#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 8838
#define LARGE_STATE_COUNT 2365
#define SYMBOL_COUNT 552
#define ALIAS_COUNT 5
#define TOKEN_COUNT 222
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 53
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 228

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_SEMI = 42,
  anon_sym___extension__ = 43,
  anon_sym_typedef = 44,
  anon_sym_virtual = 45,
  anon_sym_extern = 46,
  anon_sym___attribute__ = 47,
  anon_sym___attribute = 48,
  anon_sym_using = 49,
  anon_sym_COLON = 50,
  anon_sym_COLON_COLON = 51,
  anon_sym_LBRACK_LBRACK = 52,
  anon_sym_RBRACK_RBRACK = 53,
  anon_sym___declspec = 54,
  anon_sym___based = 55,
  anon_sym___cdecl = 56,
  anon_sym___clrcall = 57,
  anon_sym___stdcall = 58,
  anon_sym___fastcall = 59,
  anon_sym___thiscall = 60,
  anon_sym___vectorcall = 61,
  sym_ms_restrict_modifier = 62,
  sym_ms_unsigned_ptr_modifier = 63,
  sym_ms_signed_ptr_modifier = 64,
  anon_sym__unaligned = 65,
  anon_sym___unaligned = 66,
  anon_sym_LBRACE = 67,
  anon_sym_RBRACE = 68,
  anon_sym_signed = 69,
  anon_sym_unsigned = 70,
  anon_sym_long = 71,
  anon_sym_short = 72,
  anon_sym_LBRACK = 73,
  anon_sym_static = 74,
  anon_sym_RBRACK = 75,
  anon_sym_EQ = 76,
  anon_sym_register = 77,
  anon_sym_inline = 78,
  anon_sym___inline = 79,
  anon_sym___inline__ = 80,
  anon_sym___forceinline = 81,
  anon_sym_thread_local = 82,
  anon_sym___thread = 83,
  anon_sym_const = 84,
  anon_sym_constexpr = 85,
  anon_sym_volatile = 86,
  anon_sym_restrict = 87,
  anon_sym___restrict__ = 88,
  anon_sym__Atomic = 89,
  anon_sym__Noreturn = 90,
  anon_sym_noreturn = 91,
  anon_sym__Nonnull = 92,
  anon_sym_mutable = 93,
  anon_sym_constinit = 94,
  anon_sym_consteval = 95,
  anon_sym_alignas = 96,
  anon_sym__Alignas = 97,
  sym_primitive_type = 98,
  anon_sym_enum = 99,
  anon_sym_class = 100,
  anon_sym_struct = 101,
  anon_sym_union = 102,
  anon_sym_if = 103,
  anon_sym_else = 104,
  anon_sym_switch = 105,
  anon_sym_case = 106,
  anon_sym_default = 107,
  anon_sym_while = 108,
  anon_sym_do = 109,
  anon_sym_for = 110,
  anon_sym_return = 111,
  anon_sym_break = 112,
  anon_sym_continue = 113,
  anon_sym_goto = 114,
  anon_sym___try = 115,
  anon_sym___except = 116,
  anon_sym___finally = 117,
  anon_sym___leave = 118,
  anon_sym_QMARK = 119,
  anon_sym_STAR_EQ = 120,
  anon_sym_SLASH_EQ = 121,
  anon_sym_PERCENT_EQ = 122,
  anon_sym_PLUS_EQ = 123,
  anon_sym_DASH_EQ = 124,
  anon_sym_LT_LT_EQ = 125,
  anon_sym_GT_GT_EQ = 126,
  anon_sym_AMP_EQ = 127,
  anon_sym_CARET_EQ = 128,
  anon_sym_PIPE_EQ = 129,
  anon_sym_and_eq = 130,
  anon_sym_or_eq = 131,
  anon_sym_xor_eq = 132,
  anon_sym_not = 133,
  anon_sym_compl = 134,
  anon_sym_LT_EQ_GT = 135,
  anon_sym_or = 136,
  anon_sym_and = 137,
  anon_sym_bitor = 138,
  anon_sym_xor = 139,
  anon_sym_bitand = 140,
  anon_sym_not_eq = 141,
  anon_sym_DASH_DASH = 142,
  anon_sym_PLUS_PLUS = 143,
  anon_sym_sizeof = 144,
  anon_sym___alignof__ = 145,
  anon_sym___alignof = 146,
  anon_sym__alignof = 147,
  anon_sym_alignof = 148,
  anon_sym__Alignof = 149,
  anon_sym_offsetof = 150,
  anon_sym__Generic = 151,
  anon_sym_asm = 152,
  anon_sym___asm__ = 153,
  anon_sym___asm = 154,
  anon_sym___volatile__ = 155,
  anon_sym_DOT = 156,
  anon_sym_DOT_STAR = 157,
  anon_sym_DASH_GT = 158,
  sym_number_literal = 159,
  anon_sym_L_SQUOTE = 160,
  anon_sym_u_SQUOTE = 161,
  anon_sym_U_SQUOTE = 162,
  anon_sym_u8_SQUOTE = 163,
  anon_sym_SQUOTE = 164,
  aux_sym_char_literal_token1 = 165,
  anon_sym_L_DQUOTE = 166,
  anon_sym_u_DQUOTE = 167,
  anon_sym_U_DQUOTE = 168,
  anon_sym_u8_DQUOTE = 169,
  anon_sym_DQUOTE = 170,
  aux_sym_string_literal_token1 = 171,
  sym_escape_sequence = 172,
  sym_system_lib_string = 173,
  sym_true = 174,
  sym_false = 175,
  anon_sym_NULL = 176,
  anon_sym_nullptr = 177,
  sym_comment = 178,
  sym_auto = 179,
  anon_sym_decltype = 180,
  anon_sym_final = 181,
  anon_sym_override = 182,
  anon_sym_explicit = 183,
  anon_sym_typename = 184,
  anon_sym_export = 185,
  anon_sym_module = 186,
  anon_sym_import = 187,
  anon_sym_private = 188,
  anon_sym_template = 189,
  anon_sym_GT2 = 190,
  anon_sym_operator = 191,
  anon_sym_try = 192,
  anon_sym_delete = 193,
  aux_sym_pure_virtual_clause_token1 = 194,
  anon_sym_friend = 195,
  anon_sym_public = 196,
  anon_sym_protected = 197,
  anon_sym_noexcept = 198,
  anon_sym_throw = 199,
  anon_sym_namespace = 200,
  anon_sym_static_assert = 201,
  anon_sym_concept = 202,
  anon_sym_co_return = 203,
  anon_sym_co_yield = 204,
  anon_sym_catch = 205,
  anon_sym_R_DQUOTE = 206,
  anon_sym_LR_DQUOTE = 207,
  anon_sym_uR_DQUOTE = 208,
  anon_sym_UR_DQUOTE = 209,
  anon_sym_u8R_DQUOTE = 210,
  anon_sym_co_await = 211,
  anon_sym_new = 212,
  anon_sym_requires = 213,
  anon_sym_DASH_GT_STAR = 214,
  anon_sym_LPAREN_RPAREN = 215,
  anon_sym_LBRACK_RBRACK = 216,
  anon_sym_DQUOTE_DQUOTE = 217,
  sym_this = 218,
  sym_literal_suffix = 219,
  sym_raw_string_delimiter = 220,
  sym_raw_string_content = 221,
  sym_translation_unit = 222,
  sym__top_level_item = 223,
  sym__block_item = 224,
  sym_preproc_include = 225,
  sym_preproc_def = 226,
  sym_preproc_function_def = 227,
  sym_preproc_params = 228,
  sym_preproc_call = 229,
  sym_preproc_if = 230,
  sym_preproc_ifdef = 231,
  sym_preproc_else = 232,
  sym_preproc_elif = 233,
  sym_preproc_elifdef = 234,
  sym_preproc_if_in_field_declaration_list = 235,
  sym_preproc_ifdef_in_field_declaration_list = 236,
  sym_preproc_else_in_field_declaration_list = 237,
  sym_preproc_elif_in_field_declaration_list = 238,
  sym_preproc_elifdef_in_field_declaration_list = 239,
  sym_preproc_if_in_enumerator_list = 240,
  sym_preproc_ifdef_in_enumerator_list = 241,
  sym_preproc_else_in_enumerator_list = 242,
  sym_preproc_elif_in_enumerator_list = 243,
  sym_preproc_elifdef_in_enumerator_list = 244,
  sym_preproc_if_in_enumerator_list_no_comma = 245,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 246,
  sym_preproc_else_in_enumerator_list_no_comma = 247,
  sym_preproc_elif_in_enumerator_list_no_comma = 248,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 249,
  sym__preproc_expression = 250,
  sym_preproc_parenthesized_expression = 251,
  sym_preproc_defined = 252,
  sym_preproc_unary_expression = 253,
  sym_preproc_call_expression = 254,
  sym_preproc_argument_list = 255,
  sym_preproc_binary_expression = 256,
  sym_function_definition = 257,
  sym_declaration = 258,
  sym_type_definition = 259,
  sym__type_definition_type = 260,
  sym__type_definition_declarators = 261,
  sym__declaration_modifiers = 262,
  sym__declaration_specifiers = 263,
  sym_linkage_specification = 264,
  sym_attribute_specifier = 265,
  sym_attribute = 266,
  sym_attribute_declaration = 267,
  sym_ms_declspec_modifier = 268,
  sym_ms_based_modifier = 269,
  sym_ms_call_modifier = 270,
  sym_ms_unaligned_ptr_modifier = 271,
  sym_ms_pointer_modifier = 272,
  sym_declaration_list = 273,
  sym__declarator = 274,
  sym__field_declarator = 275,
  sym__type_declarator = 276,
  sym__abstract_declarator = 277,
  sym_parenthesized_declarator = 278,
  sym_parenthesized_field_declarator = 279,
  sym_parenthesized_type_declarator = 280,
  sym_abstract_parenthesized_declarator = 281,
  sym_attributed_declarator = 282,
  sym_attributed_field_declarator = 283,
  sym_attributed_type_declarator = 284,
  sym_pointer_declarator = 285,
  sym_pointer_field_declarator = 286,
  sym_pointer_type_declarator = 287,
  sym_abstract_pointer_declarator = 288,
  sym_function_declarator = 289,
  sym_function_field_declarator = 290,
  sym_function_type_declarator = 291,
  sym_abstract_function_declarator = 292,
  sym_array_declarator = 293,
  sym_array_field_declarator = 294,
  sym_array_type_declarator = 295,
  sym_abstract_array_declarator = 296,
  sym_init_declarator = 297,
  sym_compound_statement = 298,
  sym_storage_class_specifier = 299,
  sym_type_qualifier = 300,
  sym_alignas_qualifier = 301,
  sym_type_specifier = 302,
  sym_sized_type_specifier = 303,
  sym_enum_specifier = 304,
  sym_enumerator_list = 305,
  sym_struct_specifier = 306,
  sym_union_specifier = 307,
  sym_field_declaration_list = 308,
  sym__field_declaration_list_item = 309,
  sym_field_declaration = 310,
  sym_bitfield_clause = 311,
  sym_enumerator = 312,
  sym_parameter_list = 313,
  sym_parameter_declaration = 314,
  sym_attributed_statement = 315,
  sym_statement = 316,
  sym__top_level_statement = 317,
  sym_labeled_statement = 318,
  sym__top_level_expression_statement = 319,
  sym_expression_statement = 320,
  sym_if_statement = 321,
  sym_else_clause = 322,
  sym_switch_statement = 323,
  sym_case_statement = 324,
  sym_while_statement = 325,
  sym_do_statement = 326,
  sym_for_statement = 327,
  sym__for_statement_body = 328,
  sym_return_statement = 329,
  sym_break_statement = 330,
  sym_continue_statement = 331,
  sym_goto_statement = 332,
  sym_seh_try_statement = 333,
  sym_seh_except_clause = 334,
  sym_seh_finally_clause = 335,
  sym_seh_leave_statement = 336,
  sym_expression = 337,
  sym__string = 338,
  sym_comma_expression = 339,
  sym_conditional_expression = 340,
  sym_assignment_expression = 341,
  sym_pointer_expression = 342,
  sym_unary_expression = 343,
  sym_binary_expression = 344,
  sym_update_expression = 345,
  sym_cast_expression = 346,
  sym_type_descriptor = 347,
  sym_sizeof_expression = 348,
  sym_alignof_expression = 349,
  sym_offsetof_expression = 350,
  sym_generic_expression = 351,
  sym_subscript_expression = 352,
  sym_call_expression = 353,
  sym_gnu_asm_expression = 354,
  sym_gnu_asm_qualifier = 355,
  sym_gnu_asm_output_operand_list = 356,
  sym_gnu_asm_output_operand = 357,
  sym_gnu_asm_input_operand_list = 358,
  sym_gnu_asm_input_operand = 359,
  sym_gnu_asm_clobber_list = 360,
  sym_gnu_asm_goto_list = 361,
  sym_extension_expression = 362,
  sym_argument_list = 363,
  sym_field_expression = 364,
  sym_compound_literal_expression = 365,
  sym_parenthesized_expression = 366,
  sym_initializer_list = 367,
  sym_initializer_pair = 368,
  sym_subscript_designator = 369,
  sym_subscript_range_designator = 370,
  sym_field_designator = 371,
  sym_char_literal = 372,
  sym_concatenated_string = 373,
  sym_string_literal = 374,
  sym_null = 375,
  sym__empty_declaration = 376,
  sym_placeholder_type_specifier = 377,
  sym_decltype_auto = 378,
  sym_decltype = 379,
  sym__class_declaration = 380,
  sym__class_declaration_item = 381,
  sym_class_specifier = 382,
  sym__class_name = 383,
  sym_virtual_specifier = 384,
  sym_explicit_function_specifier = 385,
  sym_base_class_clause = 386,
  sym__enum_base_clause = 387,
  sym_dependent_type = 388,
  sym_module_name = 389,
  sym_module_partition = 390,
  sym_module_declaration = 391,
  sym_export_declaration = 392,
  sym_import_declaration = 393,
  sym_global_module_fragment_declaration = 394,
  sym_private_module_fragment_declaration = 395,
  sym_template_declaration = 396,
  sym_template_instantiation = 397,
  sym_template_parameter_list = 398,
  sym_type_parameter_declaration = 399,
  sym_variadic_type_parameter_declaration = 400,
  sym_optional_type_parameter_declaration = 401,
  sym_template_template_parameter_declaration = 402,
  sym_optional_parameter_declaration = 403,
  sym_variadic_parameter_declaration = 404,
  sym_variadic_declarator = 405,
  sym_variadic_reference_declarator = 406,
  sym_operator_cast = 407,
  sym_field_initializer_list = 408,
  sym_field_initializer = 409,
  sym_inline_method_definition = 410,
  sym__constructor_specifiers = 411,
  sym_operator_cast_definition = 412,
  sym_operator_cast_declaration = 413,
  sym_constructor_try_statement = 414,
  sym_constructor_or_destructor_definition = 415,
  sym_constructor_or_destructor_declaration = 416,
  sym_default_method_clause = 417,
  sym_delete_method_clause = 418,
  sym_pure_virtual_clause = 419,
  sym_friend_declaration = 420,
  sym_access_specifier = 421,
  sym_reference_declarator = 422,
  sym_reference_field_declarator = 423,
  sym_reference_type_declarator = 424,
  sym_abstract_reference_declarator = 425,
  sym_structured_binding_declarator = 426,
  sym_ref_qualifier = 427,
  sym__function_declarator_seq = 428,
  sym__function_attributes_start = 429,
  sym__function_exception_specification = 430,
  sym__function_attributes_end = 431,
  sym__function_postfix = 432,
  sym_trailing_return_type = 433,
  sym_noexcept = 434,
  sym_throw_specifier = 435,
  sym_template_type = 436,
  sym_template_method = 437,
  sym_template_function = 438,
  sym_template_argument_list = 439,
  sym_namespace_definition = 440,
  sym_namespace_alias_definition = 441,
  sym__namespace_specifier = 442,
  sym_nested_namespace_specifier = 443,
  sym_using_declaration = 444,
  sym_alias_declaration = 445,
  sym_static_assert_declaration = 446,
  sym_concept_definition = 447,
  sym_for_range_loop = 448,
  sym__for_range_loop_body = 449,
  sym_init_statement = 450,
  sym_condition_clause = 451,
  sym_condition_declaration = 452,
  sym_co_return_statement = 453,
  sym_co_yield_statement = 454,
  sym_throw_statement = 455,
  sym_try_statement = 456,
  sym_catch_clause = 457,
  sym_raw_string_literal = 458,
  sym_subscript_argument_list = 459,
  sym_co_await_expression = 460,
  sym_new_expression = 461,
  sym_new_declarator = 462,
  sym_delete_expression = 463,
  sym_type_requirement = 464,
  sym_compound_requirement = 465,
  sym__requirement = 466,
  sym_requirement_seq = 467,
  sym_constraint_conjunction = 468,
  sym_constraint_disjunction = 469,
  sym__requirement_clause_constraint = 470,
  sym_requires_clause = 471,
  sym_requires_parameter_list = 472,
  sym_requires_expression = 473,
  sym_lambda_specifier = 474,
  sym_lambda_declarator = 475,
  sym_lambda_expression = 476,
  sym_lambda_capture_specifier = 477,
  sym_lambda_default_capture = 478,
  sym__lambda_capture_identifier = 479,
  sym_lambda_capture_initializer = 480,
  sym__lambda_capture = 481,
  sym__fold_operator = 482,
  sym__binary_fold_operator = 483,
  sym__unary_left_fold = 484,
  sym__unary_right_fold = 485,
  sym__binary_fold = 486,
  sym_fold_expression = 487,
  sym_parameter_pack_expansion = 488,
  sym_type_parameter_pack_expansion = 489,
  sym_identifier_parameter_pack_expansion = 490,
  sym_destructor_name = 491,
  sym_dependent_identifier = 492,
  sym_dependent_field_identifier = 493,
  sym_dependent_type_identifier = 494,
  sym__scope_resolution = 495,
  sym_qualified_field_identifier = 496,
  sym_qualified_identifier = 497,
  sym_qualified_type_identifier = 498,
  sym_qualified_operator_cast_identifier = 499,
  sym__assignment_expression_lhs = 500,
  sym_operator_name = 501,
  sym_user_defined_literal = 502,
  aux_sym_translation_unit_repeat1 = 503,
  aux_sym_preproc_params_repeat1 = 504,
  aux_sym_preproc_if_repeat1 = 505,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 506,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 507,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 508,
  aux_sym_preproc_argument_list_repeat1 = 509,
  aux_sym_declaration_repeat1 = 510,
  aux_sym_type_definition_repeat1 = 511,
  aux_sym__type_definition_type_repeat1 = 512,
  aux_sym__type_definition_declarators_repeat1 = 513,
  aux_sym__declaration_specifiers_repeat1 = 514,
  aux_sym_attribute_declaration_repeat1 = 515,
  aux_sym_attributed_declarator_repeat1 = 516,
  aux_sym_pointer_declarator_repeat1 = 517,
  aux_sym_array_declarator_repeat1 = 518,
  aux_sym_sized_type_specifier_repeat1 = 519,
  aux_sym_enumerator_list_repeat1 = 520,
  aux_sym_field_declaration_repeat1 = 521,
  aux_sym_parameter_list_repeat1 = 522,
  aux_sym_case_statement_repeat1 = 523,
  aux_sym_generic_expression_repeat1 = 524,
  aux_sym_gnu_asm_expression_repeat1 = 525,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 526,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 527,
  aux_sym_gnu_asm_clobber_list_repeat1 = 528,
  aux_sym_gnu_asm_goto_list_repeat1 = 529,
  aux_sym_argument_list_repeat1 = 530,
  aux_sym_initializer_list_repeat1 = 531,
  aux_sym_initializer_pair_repeat1 = 532,
  aux_sym_char_literal_repeat1 = 533,
  aux_sym_concatenated_string_repeat1 = 534,
  aux_sym_string_literal_repeat1 = 535,
  aux_sym__class_declaration_repeat1 = 536,
  aux_sym_base_class_clause_repeat1 = 537,
  aux_sym_module_name_repeat1 = 538,
  aux_sym_template_parameter_list_repeat1 = 539,
  aux_sym_field_initializer_list_repeat1 = 540,
  aux_sym_operator_cast_definition_repeat1 = 541,
  aux_sym_constructor_try_statement_repeat1 = 542,
  aux_sym_structured_binding_declarator_repeat1 = 543,
  aux_sym__function_postfix_repeat1 = 544,
  aux_sym_throw_specifier_repeat1 = 545,
  aux_sym_template_argument_list_repeat1 = 546,
  aux_sym_subscript_argument_list_repeat1 = 547,
  aux_sym_requirement_seq_repeat1 = 548,
  aux_sym_requires_parameter_list_repeat1 = 549,
  aux_sym_lambda_declarator_repeat1 = 550,
  aux_sym_lambda_capture_specifier_repeat1 = 551,
  alias_sym_field_identifier = 552,
  alias_sym_namespace_identifier = 553,
  alias_sym_simple_requirement = 554,
  alias_sym_statement_identifier = 555,
  alias_sym_type_identifier = 556,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_virtual] = "virtual",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym___attribute] = "__attribute",
  [anon_sym_using] = "using",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_static] = "static",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym__Nonnull] = "_Nonnull",
  [anon_sym_mutable] = "mutable",
  [anon_sym_constinit] = "constinit",
  [anon_sym_consteval] = "consteval",
  [anon_sym_alignas] = "alignas",
  [anon_sym__Alignas] = "_Alignas",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_class] = "class",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_and_eq] = "and_eq",
  [anon_sym_or_eq] = "or_eq",
  [anon_sym_xor_eq] = "xor_eq",
  [anon_sym_not] = "not",
  [anon_sym_compl] = "compl",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_bitor] = "bitor",
  [anon_sym_xor] = "xor",
  [anon_sym_bitand] = "bitand",
  [anon_sym_not_eq] = "not_eq",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym___asm] = "__asm",
  [anon_sym___volatile__] = "__volatile__",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_STAR] = ".*",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [sym_auto] = "auto",
  [anon_sym_decltype] = "decltype",
  [anon_sym_final] = "final",
  [anon_sym_override] = "override",
  [anon_sym_explicit] = "explicit",
  [anon_sym_typename] = "typename",
  [anon_sym_export] = "export",
  [anon_sym_module] = "module",
  [anon_sym_import] = "import",
  [anon_sym_private] = "private",
  [anon_sym_template] = "template",
  [anon_sym_GT2] = ">",
  [anon_sym_operator] = "operator",
  [anon_sym_try] = "try",
  [anon_sym_delete] = "delete",
  [aux_sym_pure_virtual_clause_token1] = "pure_virtual_clause_token1",
  [anon_sym_friend] = "friend",
  [anon_sym_public] = "public",
  [anon_sym_protected] = "protected",
  [anon_sym_noexcept] = "noexcept",
  [anon_sym_throw] = "throw",
  [anon_sym_namespace] = "namespace",
  [anon_sym_static_assert] = "static_assert",
  [anon_sym_concept] = "concept",
  [anon_sym_co_return] = "co_return",
  [anon_sym_co_yield] = "co_yield",
  [anon_sym_catch] = "catch",
  [anon_sym_R_DQUOTE] = "R\"",
  [anon_sym_LR_DQUOTE] = "LR\"",
  [anon_sym_uR_DQUOTE] = "uR\"",
  [anon_sym_UR_DQUOTE] = "UR\"",
  [anon_sym_u8R_DQUOTE] = "u8R\"",
  [anon_sym_co_await] = "co_await",
  [anon_sym_new] = "new",
  [anon_sym_requires] = "requires",
  [anon_sym_DASH_GT_STAR] = "->*",
  [anon_sym_LPAREN_RPAREN] = "()",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_DQUOTE_DQUOTE] = "\"\"",
  [sym_this] = "this",
  [sym_literal_suffix] = "literal_suffix",
  [sym_raw_string_delimiter] = "raw_string_delimiter",
  [sym_raw_string_content] = "raw_string_content",
  [sym_translation_unit] = "translation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym__block_item] = "_block_item",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym_alignas_qualifier] = "alignas_qualifier",
  [sym_type_specifier] = "type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_statement] = "statement",
  [sym__top_level_statement] = "_top_level_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym_expression] = "expression",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_extension_expression] = "extension_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_placeholder_type_specifier] = "placeholder_type_specifier",
  [sym_decltype_auto] = "decltype",
  [sym_decltype] = "decltype",
  [sym__class_declaration] = "_class_declaration",
  [sym__class_declaration_item] = "_class_declaration_item",
  [sym_class_specifier] = "class_specifier",
  [sym__class_name] = "_class_name",
  [sym_virtual_specifier] = "virtual_specifier",
  [sym_explicit_function_specifier] = "explicit_function_specifier",
  [sym_base_class_clause] = "base_class_clause",
  [sym__enum_base_clause] = "_enum_base_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_module_name] = "module_name",
  [sym_module_partition] = "module_partition",
  [sym_module_declaration] = "module_declaration",
  [sym_export_declaration] = "export_declaration",
  [sym_import_declaration] = "import_declaration",
  [sym_global_module_fragment_declaration] = "global_module_fragment_declaration",
  [sym_private_module_fragment_declaration] = "private_module_fragment_declaration",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_variadic_type_parameter_declaration] = "variadic_type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_template_template_parameter_declaration] = "template_template_parameter_declaration",
  [sym_optional_parameter_declaration] = "optional_parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_variadic_declarator] = "variadic_declarator",
  [sym_variadic_reference_declarator] = "reference_declarator",
  [sym_operator_cast] = "operator_cast",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "function_definition",
  [sym__constructor_specifiers] = "_constructor_specifiers",
  [sym_operator_cast_definition] = "function_definition",
  [sym_operator_cast_declaration] = "declaration",
  [sym_constructor_try_statement] = "try_statement",
  [sym_constructor_or_destructor_definition] = "function_definition",
  [sym_constructor_or_destructor_declaration] = "declaration",
  [sym_default_method_clause] = "default_method_clause",
  [sym_delete_method_clause] = "delete_method_clause",
  [sym_pure_virtual_clause] = "pure_virtual_clause",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_declarator",
  [sym_reference_type_declarator] = "reference_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_ref_qualifier] = "ref_qualifier",
  [sym__function_declarator_seq] = "_function_declarator_seq",
  [sym__function_attributes_start] = "_function_attributes_start",
  [sym__function_exception_specification] = "_function_exception_specification",
  [sym__function_attributes_end] = "_function_attributes_end",
  [sym__function_postfix] = "_function_postfix",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_noexcept] = "noexcept",
  [sym_throw_specifier] = "throw_specifier",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_alias_definition] = "namespace_alias_definition",
  [sym__namespace_specifier] = "_namespace_specifier",
  [sym_nested_namespace_specifier] = "nested_namespace_specifier",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_static_assert_declaration] = "static_assert_declaration",
  [sym_concept_definition] = "concept_definition",
  [sym_for_range_loop] = "for_range_loop",
  [sym__for_range_loop_body] = "_for_range_loop_body",
  [sym_init_statement] = "init_statement",
  [sym_condition_clause] = "condition_clause",
  [sym_condition_declaration] = "declaration",
  [sym_co_return_statement] = "co_return_statement",
  [sym_co_yield_statement] = "co_yield_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_subscript_argument_list] = "subscript_argument_list",
  [sym_co_await_expression] = "co_await_expression",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_type_requirement] = "type_requirement",
  [sym_compound_requirement] = "compound_requirement",
  [sym__requirement] = "_requirement",
  [sym_requirement_seq] = "requirement_seq",
  [sym_constraint_conjunction] = "constraint_conjunction",
  [sym_constraint_disjunction] = "constraint_disjunction",
  [sym__requirement_clause_constraint] = "_requirement_clause_constraint",
  [sym_requires_clause] = "requires_clause",
  [sym_requires_parameter_list] = "parameter_list",
  [sym_requires_expression] = "requires_expression",
  [sym_lambda_specifier] = "lambda_specifier",
  [sym_lambda_declarator] = "lambda_declarator",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym__lambda_capture_identifier] = "_lambda_capture_identifier",
  [sym_lambda_capture_initializer] = "lambda_capture_initializer",
  [sym__lambda_capture] = "_lambda_capture",
  [sym__fold_operator] = "_fold_operator",
  [sym__binary_fold_operator] = "_binary_fold_operator",
  [sym__unary_left_fold] = "_unary_left_fold",
  [sym__unary_right_fold] = "_unary_right_fold",
  [sym__binary_fold] = "_binary_fold",
  [sym_fold_expression] = "fold_expression",
  [sym_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_type_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_identifier_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_destructor_name] = "destructor_name",
  [sym_dependent_identifier] = "dependent_name",
  [sym_dependent_field_identifier] = "dependent_name",
  [sym_dependent_type_identifier] = "dependent_name",
  [sym__scope_resolution] = "_scope_resolution",
  [sym_qualified_field_identifier] = "qualified_identifier",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_qualified_type_identifier] = "qualified_identifier",
  [sym_qualified_operator_cast_identifier] = "qualified_identifier",
  [sym__assignment_expression_lhs] = "assignment_expression",
  [sym_operator_name] = "operator_name",
  [sym_user_defined_literal] = "user_defined_literal",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_array_declarator_repeat1] = "array_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym__class_declaration_repeat1] = "_class_declaration_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_module_name_repeat1] = "module_name_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_operator_cast_definition_repeat1] = "operator_cast_definition_repeat1",
  [aux_sym_constructor_try_statement_repeat1] = "constructor_try_statement_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym__function_postfix_repeat1] = "_function_postfix_repeat1",
  [aux_sym_throw_specifier_repeat1] = "throw_specifier_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [aux_sym_subscript_argument_list_repeat1] = "subscript_argument_list_repeat1",
  [aux_sym_requirement_seq_repeat1] = "requirement_seq_repeat1",
  [aux_sym_requires_parameter_list_repeat1] = "requires_parameter_list_repeat1",
  [aux_sym_lambda_declarator_repeat1] = "lambda_declarator_repeat1",
  [aux_sym_lambda_capture_specifier_repeat1] = "lambda_capture_specifier_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_simple_requirement] = "simple_requirement",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym___attribute] = anon_sym___attribute,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym__Nonnull] = anon_sym__Nonnull,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_constinit] = anon_sym_constinit,
  [anon_sym_consteval] = anon_sym_consteval,
  [anon_sym_alignas] = anon_sym_alignas,
  [anon_sym__Alignas] = anon_sym__Alignas,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_and_eq] = anon_sym_and_eq,
  [anon_sym_or_eq] = anon_sym_or_eq,
  [anon_sym_xor_eq] = anon_sym_xor_eq,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_compl] = anon_sym_compl,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_bitor] = anon_sym_bitor,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_bitand] = anon_sym_bitand,
  [anon_sym_not_eq] = anon_sym_not_eq,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym___asm] = anon_sym___asm,
  [anon_sym___volatile__] = anon_sym___volatile__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_STAR] = anon_sym_DOT_STAR,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [sym_auto] = sym_auto,
  [anon_sym_decltype] = anon_sym_decltype,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_typename] = anon_sym_typename,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_template] = anon_sym_template,
  [anon_sym_GT2] = anon_sym_GT,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_delete] = anon_sym_delete,
  [aux_sym_pure_virtual_clause_token1] = aux_sym_pure_virtual_clause_token1,
  [anon_sym_friend] = anon_sym_friend,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_noexcept] = anon_sym_noexcept,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_static_assert] = anon_sym_static_assert,
  [anon_sym_concept] = anon_sym_concept,
  [anon_sym_co_return] = anon_sym_co_return,
  [anon_sym_co_yield] = anon_sym_co_yield,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_R_DQUOTE] = anon_sym_R_DQUOTE,
  [anon_sym_LR_DQUOTE] = anon_sym_LR_DQUOTE,
  [anon_sym_uR_DQUOTE] = anon_sym_uR_DQUOTE,
  [anon_sym_UR_DQUOTE] = anon_sym_UR_DQUOTE,
  [anon_sym_u8R_DQUOTE] = anon_sym_u8R_DQUOTE,
  [anon_sym_co_await] = anon_sym_co_await,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_DASH_GT_STAR] = anon_sym_DASH_GT_STAR,
  [anon_sym_LPAREN_RPAREN] = anon_sym_LPAREN_RPAREN,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE,
  [sym_this] = sym_this,
  [sym_literal_suffix] = sym_literal_suffix,
  [sym_raw_string_delimiter] = sym_raw_string_delimiter,
  [sym_raw_string_content] = sym_raw_string_content,
  [sym_translation_unit] = sym_translation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym__block_item] = sym__block_item,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_type_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym_alignas_qualifier] = sym_alignas_qualifier,
  [sym_type_specifier] = sym_type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_statement] = sym_statement,
  [sym__top_level_statement] = sym__top_level_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym_expression] = sym_expression,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_extension_expression] = sym_extension_expression,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_placeholder_type_specifier] = sym_placeholder_type_specifier,
  [sym_decltype_auto] = sym_decltype,
  [sym_decltype] = sym_decltype,
  [sym__class_declaration] = sym__class_declaration,
  [sym__class_declaration_item] = sym__class_declaration_item,
  [sym_class_specifier] = sym_class_specifier,
  [sym__class_name] = sym__class_name,
  [sym_virtual_specifier] = sym_virtual_specifier,
  [sym_explicit_function_specifier] = sym_explicit_function_specifier,
  [sym_base_class_clause] = sym_base_class_clause,
  [sym__enum_base_clause] = sym__enum_base_clause,
  [sym_dependent_type] = sym_dependent_type,
  [sym_module_name] = sym_module_name,
  [sym_module_partition] = sym_module_partition,
  [sym_module_declaration] = sym_module_declaration,
  [sym_export_declaration] = sym_export_declaration,
  [sym_import_declaration] = sym_import_declaration,
  [sym_global_module_fragment_declaration] = sym_global_module_fragment_declaration,
  [sym_private_module_fragment_declaration] = sym_private_module_fragment_declaration,
  [sym_template_declaration] = sym_template_declaration,
  [sym_template_instantiation] = sym_template_instantiation,
  [sym_template_parameter_list] = sym_template_parameter_list,
  [sym_type_parameter_declaration] = sym_type_parameter_declaration,
  [sym_variadic_type_parameter_declaration] = sym_variadic_type_parameter_declaration,
  [sym_optional_type_parameter_declaration] = sym_optional_type_parameter_declaration,
  [sym_template_template_parameter_declaration] = sym_template_template_parameter_declaration,
  [sym_optional_parameter_declaration] = sym_optional_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_variadic_declarator] = sym_variadic_declarator,
  [sym_variadic_reference_declarator] = sym_reference_declarator,
  [sym_operator_cast] = sym_operator_cast,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_field_initializer] = sym_field_initializer,
  [sym_inline_method_definition] = sym_function_definition,
  [sym__constructor_specifiers] = sym__constructor_specifiers,
  [sym_operator_cast_definition] = sym_function_definition,
  [sym_operator_cast_declaration] = sym_declaration,
  [sym_constructor_try_statement] = sym_try_statement,
  [sym_constructor_or_destructor_definition] = sym_function_definition,
  [sym_constructor_or_destructor_declaration] = sym_declaration,
  [sym_default_method_clause] = sym_default_method_clause,
  [sym_delete_method_clause] = sym_delete_method_clause,
  [sym_pure_virtual_clause] = sym_pure_virtual_clause,
  [sym_friend_declaration] = sym_friend_declaration,
  [sym_access_specifier] = sym_access_specifier,
  [sym_reference_declarator] = sym_reference_declarator,
  [sym_reference_field_declarator] = sym_reference_declarator,
  [sym_reference_type_declarator] = sym_reference_declarator,
  [sym_abstract_reference_declarator] = sym_abstract_reference_declarator,
  [sym_structured_binding_declarator] = sym_structured_binding_declarator,
  [sym_ref_qualifier] = sym_ref_qualifier,
  [sym__function_declarator_seq] = sym__function_declarator_seq,
  [sym__function_attributes_start] = sym__function_attributes_start,
  [sym__function_exception_specification] = sym__function_exception_specification,
  [sym__function_attributes_end] = sym__function_attributes_end,
  [sym__function_postfix] = sym__function_postfix,
  [sym_trailing_return_type] = sym_trailing_return_type,
  [sym_noexcept] = sym_noexcept,
  [sym_throw_specifier] = sym_throw_specifier,
  [sym_template_type] = sym_template_type,
  [sym_template_method] = sym_template_method,
  [sym_template_function] = sym_template_function,
  [sym_template_argument_list] = sym_template_argument_list,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_alias_definition] = sym_namespace_alias_definition,
  [sym__namespace_specifier] = sym__namespace_specifier,
  [sym_nested_namespace_specifier] = sym_nested_namespace_specifier,
  [sym_using_declaration] = sym_using_declaration,
  [sym_alias_declaration] = sym_alias_declaration,
  [sym_static_assert_declaration] = sym_static_assert_declaration,
  [sym_concept_definition] = sym_concept_definition,
  [sym_for_range_loop] = sym_for_range_loop,
  [sym__for_range_loop_body] = sym__for_range_loop_body,
  [sym_init_statement] = sym_init_statement,
  [sym_condition_clause] = sym_condition_clause,
  [sym_condition_declaration] = sym_declaration,
  [sym_co_return_statement] = sym_co_return_statement,
  [sym_co_yield_statement] = sym_co_yield_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_subscript_argument_list] = sym_subscript_argument_list,
  [sym_co_await_expression] = sym_co_await_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_new_declarator] = sym_new_declarator,
  [sym_delete_expression] = sym_delete_expression,
  [sym_type_requirement] = sym_type_requirement,
  [sym_compound_requirement] = sym_compound_requirement,
  [sym__requirement] = sym__requirement,
  [sym_requirement_seq] = sym_requirement_seq,
  [sym_constraint_conjunction] = sym_constraint_conjunction,
  [sym_constraint_disjunction] = sym_constraint_disjunction,
  [sym__requirement_clause_constraint] = sym__requirement_clause_constraint,
  [sym_requires_clause] = sym_requires_clause,
  [sym_requires_parameter_list] = sym_parameter_list,
  [sym_requires_expression] = sym_requires_expression,
  [sym_lambda_specifier] = sym_lambda_specifier,
  [sym_lambda_declarator] = sym_lambda_declarator,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_lambda_capture_specifier] = sym_lambda_capture_specifier,
  [sym_lambda_default_capture] = sym_lambda_default_capture,
  [sym__lambda_capture_identifier] = sym__lambda_capture_identifier,
  [sym_lambda_capture_initializer] = sym_lambda_capture_initializer,
  [sym__lambda_capture] = sym__lambda_capture,
  [sym__fold_operator] = sym__fold_operator,
  [sym__binary_fold_operator] = sym__binary_fold_operator,
  [sym__unary_left_fold] = sym__unary_left_fold,
  [sym__unary_right_fold] = sym__unary_right_fold,
  [sym__binary_fold] = sym__binary_fold,
  [sym_fold_expression] = sym_fold_expression,
  [sym_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_type_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_identifier_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_destructor_name] = sym_destructor_name,
  [sym_dependent_identifier] = sym_dependent_identifier,
  [sym_dependent_field_identifier] = sym_dependent_identifier,
  [sym_dependent_type_identifier] = sym_dependent_identifier,
  [sym__scope_resolution] = sym__scope_resolution,
  [sym_qualified_field_identifier] = sym_qualified_identifier,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_qualified_type_identifier] = sym_qualified_identifier,
  [sym_qualified_operator_cast_identifier] = sym_qualified_identifier,
  [sym__assignment_expression_lhs] = sym_assignment_expression,
  [sym_operator_name] = sym_operator_name,
  [sym_user_defined_literal] = sym_user_defined_literal,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_array_declarator_repeat1] = aux_sym_array_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym__class_declaration_repeat1] = aux_sym__class_declaration_repeat1,
  [aux_sym_base_class_clause_repeat1] = aux_sym_base_class_clause_repeat1,
  [aux_sym_module_name_repeat1] = aux_sym_module_name_repeat1,
  [aux_sym_template_parameter_list_repeat1] = aux_sym_template_parameter_list_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_operator_cast_definition_repeat1] = aux_sym_operator_cast_definition_repeat1,
  [aux_sym_constructor_try_statement_repeat1] = aux_sym_constructor_try_statement_repeat1,
  [aux_sym_structured_binding_declarator_repeat1] = aux_sym_structured_binding_declarator_repeat1,
  [aux_sym__function_postfix_repeat1] = aux_sym__function_postfix_repeat1,
  [aux_sym_throw_specifier_repeat1] = aux_sym_throw_specifier_repeat1,
  [aux_sym_template_argument_list_repeat1] = aux_sym_template_argument_list_repeat1,
  [aux_sym_subscript_argument_list_repeat1] = aux_sym_subscript_argument_list_repeat1,
  [aux_sym_requirement_seq_repeat1] = aux_sym_requirement_seq_repeat1,
  [aux_sym_requires_parameter_list_repeat1] = aux_sym_requires_parameter_list_repeat1,
  [aux_sym_lambda_declarator_repeat1] = aux_sym_lambda_declarator_repeat1,
  [aux_sym_lambda_capture_specifier_repeat1] = aux_sym_lambda_capture_specifier_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_namespace_identifier] = alias_sym_namespace_identifier,
  [alias_sym_simple_requirement] = alias_sym_simple_requirement,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Nonnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constinit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_consteval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignas] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_compl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___volatile__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_decltype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pure_virtual_clause_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noexcept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_concept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym__block_item] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_alignas_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_placeholder_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype_auto] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype] = {
    .visible = true,
    .named = true,
  },
  [sym__class_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__class_declaration_item] = {
    .visible = false,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__class_name] = {
    .visible = false,
    .named = true,
  },
  [sym_virtual_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_function_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_base_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_module_name] = {
    .visible = true,
    .named = true,
  },
  [sym_module_partition] = {
    .visible = true,
    .named = true,
  },
  [sym_module_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_export_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_global_module_fragment_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_private_module_fragment_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_template_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_operator_cast_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_default_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_pure_virtual_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declarator_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_start] = {
    .visible = false,
    .named = true,
  },
  [sym__function_exception_specification] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_end] = {
    .visible = false,
    .named = true,
  },
  [sym__function_postfix] = {
    .visible = false,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_alias_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__namespace_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_nested_namespace_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_assert_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_concept_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym__for_range_loop_body] = {
    .visible = false,
    .named = true,
  },
  [sym_init_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_co_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_co_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_co_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement] = {
    .visible = false,
    .named = true,
  },
  [sym_requirement_seq] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement_clause_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_requires_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_capture_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_lambda_capture_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_capture] = {
    .visible = false,
    .named = true,
  },
  [sym__fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_left_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_right_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold] = {
    .visible = false,
    .named = true,
  },
  [sym_fold_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_operator_cast_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment_expression_lhs] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_user_defined_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operator_cast_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_postfix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_throw_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requirement_seq_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_capture_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_simple_requirement] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_base = 5,
  field_body = 6,
  field_captures = 7,
  field_clobbers = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_declarator = 12,
  field_default_type = 13,
  field_default_value = 14,
  field_delimiter = 15,
  field_designator = 16,
  field_directive = 17,
  field_end = 18,
  field_field = 19,
  field_filter = 20,
  field_function = 21,
  field_goto_labels = 22,
  field_header = 23,
  field_indices = 24,
  field_initializer = 25,
  field_input_operands = 26,
  field_label = 27,
  field_left = 28,
  field_length = 29,
  field_member = 30,
  field_message = 31,
  field_name = 32,
  field_namespace = 33,
  field_operand = 34,
  field_operator = 35,
  field_output_operands = 36,
  field_parameters = 37,
  field_partition = 38,
  field_path = 39,
  field_pattern = 40,
  field_placement = 41,
  field_prefix = 42,
  field_register = 43,
  field_requirements = 44,
  field_right = 45,
  field_scope = 46,
  field_size = 47,
  field_start = 48,
  field_symbol = 49,
  field_template_parameters = 50,
  field_type = 51,
  field_update = 52,
  field_value = 53,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_base] = "base",
  [field_body] = "body",
  [field_captures] = "captures",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_default_type] = "default_type",
  [field_default_value] = "default_value",
  [field_delimiter] = "delimiter",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_header] = "header",
  [field_indices] = "indices",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_member] = "member",
  [field_message] = "message",
  [field_name] = "name",
  [field_namespace] = "namespace",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_partition] = "partition",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_placement] = "placement",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_requirements] = "requirements",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_template_parameters] = "template_parameters",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 8, .length = 2},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 18, .length = 1},
  [16] = {.index = 19, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 0, .length = 1},
  [20] = {.index = 21, .length = 1},
  [21] = {.index = 22, .length = 1},
  [22] = {.index = 23, .length = 1},
  [23] = {.index = 24, .length = 1},
  [24] = {.index = 25, .length = 2},
  [25] = {.index = 27, .length = 2},
  [26] = {.index = 29, .length = 1},
  [27] = {.index = 30, .length = 1},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 2},
  [30] = {.index = 34, .length = 2},
  [31] = {.index = 18, .length = 1},
  [32] = {.index = 36, .length = 2},
  [33] = {.index = 38, .length = 2},
  [34] = {.index = 38, .length = 2},
  [35] = {.index = 21, .length = 1},
  [36] = {.index = 40, .length = 1},
  [37] = {.index = 41, .length = 2},
  [38] = {.index = 43, .length = 2},
  [39] = {.index = 45, .length = 1},
  [40] = {.index = 46, .length = 3},
  [41] = {.index = 49, .length = 1},
  [44] = {.index = 50, .length = 2},
  [45] = {.index = 52, .length = 1},
  [46] = {.index = 53, .length = 1},
  [47] = {.index = 54, .length = 1},
  [48] = {.index = 55, .length = 2},
  [49] = {.index = 57, .length = 2},
  [50] = {.index = 59, .length = 2},
  [51] = {.index = 61, .length = 2},
  [52] = {.index = 63, .length = 2},
  [53] = {.index = 65, .length = 1},
  [54] = {.index = 66, .length = 1},
  [55] = {.index = 67, .length = 3},
  [56] = {.index = 70, .length = 1},
  [57] = {.index = 71, .length = 1},
  [58] = {.index = 72, .length = 1},
  [59] = {.index = 73, .length = 1},
  [60] = {.index = 74, .length = 2},
  [62] = {.index = 55, .length = 2},
  [63] = {.index = 76, .length = 2},
  [64] = {.index = 78, .length = 2},
  [65] = {.index = 80, .length = 2},
  [67] = {.index = 82, .length = 2},
  [68] = {.index = 84, .length = 2},
  [69] = {.index = 86, .length = 3},
  [70] = {.index = 89, .length = 2},
  [71] = {.index = 91, .length = 2},
  [72] = {.index = 93, .length = 3},
  [73] = {.index = 93, .length = 3},
  [74] = {.index = 96, .length = 3},
  [75] = {.index = 99, .length = 3},
  [76] = {.index = 102, .length = 3},
  [77] = {.index = 52, .length = 1},
  [78] = {.index = 105, .length = 2},
  [79] = {.index = 107, .length = 2},
  [80] = {.index = 109, .length = 2},
  [81] = {.index = 111, .length = 1},
  [82] = {.index = 112, .length = 2},
  [83] = {.index = 114, .length = 2},
  [84] = {.index = 116, .length = 2},
  [85] = {.index = 118, .length = 3},
  [86] = {.index = 121, .length = 2},
  [87] = {.index = 123, .length = 1},
  [88] = {.index = 124, .length = 2},
  [89] = {.index = 126, .length = 2},
  [90] = {.index = 128, .length = 2},
  [91] = {.index = 130, .length = 2},
  [92] = {.index = 132, .length = 2},
  [93] = {.index = 134, .length = 2},
  [94] = {.index = 136, .length = 2},
  [95] = {.index = 138, .length = 2},
  [96] = {.index = 140, .length = 1},
  [97] = {.index = 138, .length = 2},
  [99] = {.index = 141, .length = 2},
  [100] = {.index = 143, .length = 1},
  [101] = {.index = 143, .length = 1},
  [102] = {.index = 144, .length = 3},
  [104] = {.index = 147, .length = 2},
  [105] = {.index = 149, .length = 2},
  [106] = {.index = 151, .length = 2},
  [107] = {.index = 153, .length = 3},
  [108] = {.index = 156, .length = 1},
  [109] = {.index = 157, .length = 1},
  [110] = {.index = 158, .length = 1},
  [111] = {.index = 159, .length = 1},
  [112] = {.index = 160, .length = 2},
  [114] = {.index = 162, .length = 3},
  [115] = {.index = 165, .length = 3},
  [116] = {.index = 168, .length = 3},
  [117] = {.index = 171, .length = 3},
  [118] = {.index = 174, .length = 2},
  [119] = {.index = 176, .length = 3},
  [120] = {.index = 179, .length = 3},
  [121] = {.index = 182, .length = 2},
  [122] = {.index = 184, .length = 3},
  [123] = {.index = 187, .length = 2},
  [124] = {.index = 19, .length = 2},
  [125] = {.index = 38, .length = 2},
  [126] = {.index = 189, .length = 2},
  [127] = {.index = 191, .length = 2},
  [128] = {.index = 193, .length = 4},
  [129] = {.index = 197, .length = 4},
  [130] = {.index = 201, .length = 2},
  [131] = {.index = 203, .length = 3},
  [132] = {.index = 206, .length = 2},
  [133] = {.index = 208, .length = 2},
  [134] = {.index = 210, .length = 1},
  [135] = {.index = 211, .length = 1},
  [136] = {.index = 212, .length = 2},
  [137] = {.index = 214, .length = 2},
  [138] = {.index = 216, .length = 2},
  [139] = {.index = 218, .length = 3},
  [140] = {.index = 221, .length = 3},
  [141] = {.index = 224, .length = 3},
  [142] = {.index = 227, .length = 2},
  [143] = {.index = 229, .length = 2},
  [144] = {.index = 231, .length = 2},
  [145] = {.index = 231, .length = 2},
  [146] = {.index = 233, .length = 2},
  [147] = {.index = 233, .length = 2},
  [148] = {.index = 235, .length = 2},
  [149] = {.index = 237, .length = 3},
  [150] = {.index = 240, .length = 2},
  [151] = {.index = 242, .length = 2},
  [152] = {.index = 244, .length = 3},
  [153] = {.index = 247, .length = 2},
  [154] = {.index = 249, .length = 3},
  [155] = {.index = 252, .length = 2},
  [156] = {.index = 254, .length = 1},
  [157] = {.index = 255, .length = 2},
  [158] = {.index = 257, .length = 2},
  [159] = {.index = 259, .length = 4},
  [160] = {.index = 263, .length = 5},
  [161] = {.index = 268, .length = 1},
  [162] = {.index = 269, .length = 1},
  [163] = {.index = 270, .length = 2},
  [164] = {.index = 272, .length = 1},
  [165] = {.index = 273, .length = 2},
  [167] = {.index = 275, .length = 1},
  [168] = {.index = 276, .length = 2},
  [169] = {.index = 278, .length = 2},
  [170] = {.index = 11, .length = 1},
  [171] = {.index = 11, .length = 1},
  [172] = {.index = 280, .length = 1},
  [173] = {.index = 281, .length = 1},
  [174] = {.index = 282, .length = 4},
  [175] = {.index = 286, .length = 2},
  [176] = {.index = 288, .length = 4},
  [177] = {.index = 292, .length = 1},
  [178] = {.index = 293, .length = 3},
  [179] = {.index = 296, .length = 2},
  [180] = {.index = 298, .length = 3},
  [181] = {.index = 301, .length = 5},
  [182] = {.index = 306, .length = 2},
  [183] = {.index = 308, .length = 2},
  [184] = {.index = 310, .length = 1},
  [185] = {.index = 311, .length = 2},
  [186] = {.index = 313, .length = 4},
  [187] = {.index = 317, .length = 2},
  [188] = {.index = 319, .length = 2},
  [189] = {.index = 321, .length = 3},
  [190] = {.index = 324, .length = 4},
  [191] = {.index = 328, .length = 4},
  [192] = {.index = 332, .length = 3},
  [193] = {.index = 335, .length = 2},
  [194] = {.index = 337, .length = 3},
  [195] = {.index = 340, .length = 3},
  [196] = {.index = 343, .length = 2},
  [197] = {.index = 345, .length = 2},
  [198] = {.index = 347, .length = 2},
  [199] = {.index = 349, .length = 2},
  [200] = {.index = 351, .length = 3},
  [201] = {.index = 354, .length = 2},
  [202] = {.index = 356, .length = 2},
  [203] = {.index = 358, .length = 3},
  [204] = {.index = 361, .length = 3},
  [205] = {.index = 364, .length = 2},
  [206] = {.index = 366, .length = 2},
  [207] = {.index = 368, .length = 4},
  [208] = {.index = 372, .length = 5},
  [209] = {.index = 377, .length = 3},
  [210] = {.index = 380, .length = 4},
  [211] = {.index = 384, .length = 2},
  [212] = {.index = 386, .length = 1},
  [213] = {.index = 387, .length = 4},
  [214] = {.index = 391, .length = 3},
  [215] = {.index = 394, .length = 2},
  [216] = {.index = 396, .length = 1},
  [217] = {.index = 397, .length = 5},
  [218] = {.index = 402, .length = 2},
  [219] = {.index = 404, .length = 2},
  [220] = {.index = 65, .length = 1},
  [221] = {.index = 406, .length = 5},
  [222] = {.index = 411, .length = 4},
  [223] = {.index = 415, .length = 2},
  [224] = {.index = 417, .length = 2},
  [225] = {.index = 419, .length = 5},
  [226] = {.index = 424, .length = 2},
  [227] = {.index = 426, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_declarator, 1},
  [5] =
    {field_name, 0},
  [6] =
    {field_arguments, 1},
    {field_function, 0},
  [8] =
    {field_type, 0},
    {field_value, 1},
  [10] =
    {field_body, 1},
  [11] =
    {field_name, 1},
  [12] =
    {field_body, 0},
  [13] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [15] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [17] =
    {field_value, 1},
  [18] =
    {field_scope, 0},
  [19] =
    {field_arguments, 1},
    {field_name, 0},
  [21] =
    {field_type, 1},
  [22] =
    {field_requirements, 1},
  [23] =
    {field_constraint, 1},
  [24] =
    {field_parameters, 0},
  [25] =
    {field_declarator, 0},
    {field_parameters, 1, .inherited = true},
  [27] =
    {field_body, 1},
    {field_declarator, 0},
  [29] =
    {field_declarator, 0},
  [30] =
    {field_constraint, 0},
  [31] =
    {field_pattern, 0},
  [32] =
    {field_argument, 0},
    {field_operator, 1},
  [34] =
    {field_argument, 0},
    {field_indices, 1},
  [36] =
    {field_body, 1},
    {field_captures, 0},
  [38] =
    {field_name, 1},
    {field_scope, 0, .inherited = true},
  [40] =
    {field_path, 1},
  [41] =
    {field_argument, 1},
    {field_directive, 0},
  [43] =
    {field_declarator, 1},
    {field_type, 0},
  [45] =
    {field_parameters, 0, .inherited = true},
  [46] =
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [49] =
    {field_declarator, 2},
  [50] =
    {field_body, 2},
    {field_value, 1},
  [52] =
    {field_type, 2},
  [53] =
    {field_body, 2},
  [54] =
    {field_name, 2},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_base, 2, .inherited = true},
    {field_name, 1},
  [59] =
    {field_body, 1},
    {field_name, 0},
  [61] =
    {field_condition, 1},
    {field_consequence, 2},
  [63] =
    {field_body, 2},
    {field_condition, 1},
  [65] =
    {field_label, 1},
  [66] =
    {field_label, 0},
  [67] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [70] =
    {field_header, 1},
  [71] =
    {field_partition, 1},
  [72] =
    {field_type, 0, .inherited = true},
  [73] =
    {field_parameters, 1},
  [74] =
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [76] =
    {field_arguments, 2},
    {field_type, 1},
  [78] =
    {field_declarator, 2},
    {field_type, 1},
  [80] =
    {field_placement, 1},
    {field_type, 2},
  [82] =
    {field_parameters, 1},
    {field_requirements, 2},
  [84] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [86] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [89] =
    {field_declarator, 0},
    {field_value, 1},
  [91] =
    {field_body, 2},
    {field_declarator, 0},
  [93] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [96] =
    {field_body, 2},
    {field_captures, 0},
    {field_template_parameters, 1},
  [99] =
    {field_body, 2},
    {field_captures, 0},
    {field_declarator, 1},
  [102] =
    {field_name, 1},
    {field_name, 2},
    {field_scope, 0, .inherited = true},
  [105] =
    {field_body, 2},
    {field_declarator, 1},
  [107] =
    {field_name, 1},
    {field_value, 2},
  [109] =
    {field_name, 1},
    {field_parameters, 2},
  [111] =
    {field_condition, 1},
  [112] =
    {field_alternative, 2},
    {field_name, 1},
  [114] =
    {field_declarator, 2},
    {field_type, 0},
  [116] =
    {field_left, 0},
    {field_right, 2},
  [118] =
    {field_left, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 2},
  [121] =
    {field_type, 1},
    {field_value, 3},
  [123] =
    {field_declarator, 3},
  [124] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [126] =
    {field_declarator, 0},
    {field_parameters, 1},
  [128] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [130] =
    {field_arguments, 3},
    {field_type, 2},
  [132] =
    {field_declarator, 3},
    {field_type, 2},
  [134] =
    {field_placement, 2},
    {field_type, 3},
  [136] =
    {field_name, 2},
    {field_prefix, 0},
  [138] =
    {field_body, 3},
    {field_name, 2},
  [140] =
    {field_body, 3},
  [141] =
    {field_base, 3, .inherited = true},
    {field_name, 2},
  [143] =
    {field_base, 1},
  [144] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
  [147] =
    {field_body, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [149] =
    {field_body, 2},
    {field_name, 0},
  [151] =
    {field_condition, 2},
    {field_consequence, 3},
  [153] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [156] =
    {field_initializer, 0},
  [157] =
    {field_assembly_code, 2},
  [158] =
    {field_header, 2},
  [159] =
    {field_partition, 2},
  [160] =
    {field_name, 1},
    {field_partition, 2},
  [162] =
    {field_arguments, 3},
    {field_declarator, 2},
    {field_type, 1},
  [165] =
    {field_arguments, 3},
    {field_placement, 1},
    {field_type, 2},
  [168] =
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [171] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [174] =
    {field_declarator, 0},
    {field_value, 2},
  [176] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [179] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [182] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [184] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [187] =
    {field_declarator, 0},
    {field_size, 2},
  [189] =
    {field_alternative, 3},
    {field_condition, 0},
  [191] =
    {field_declarator, 0},
    {field_default_value, 2},
  [193] =
    {field_body, 3},
    {field_captures, 0},
    {field_constraint, 2},
    {field_template_parameters, 1},
  [197] =
    {field_body, 3},
    {field_captures, 0},
    {field_declarator, 2},
    {field_template_parameters, 1},
  [201] =
    {field_body, 3},
    {field_declarator, 1},
  [203] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [206] =
    {field_alternative, 3},
    {field_condition, 1},
  [208] =
    {field_alternative, 3},
    {field_name, 1},
  [210] =
    {field_size, 1},
  [211] =
    {field_operator, 0},
  [212] =
    {field_declarator, 3},
    {field_type, 1},
  [214] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [216] =
    {field_name, 1},
    {field_type, 3},
  [218] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_type, 2},
  [221] =
    {field_arguments, 4},
    {field_placement, 2},
    {field_type, 3},
  [224] =
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [227] =
    {field_name, 3},
    {field_namespace, 1},
  [229] =
    {field_left, 1},
    {field_right, 3},
  [231] =
    {field_body, 4},
    {field_name, 3},
  [233] =
    {field_designator, 0},
    {field_value, 2},
  [235] =
    {field_name, 0},
    {field_value, 2},
  [237] =
    {field_base, 3, .inherited = true},
    {field_body, 4},
    {field_name, 2},
  [240] =
    {field_body, 3},
    {field_name, 0},
  [242] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
  [244] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 2},
  [247] =
    {field_initializer, 1},
    {field_value, 2},
  [249] =
    {field_alternative, 4},
    {field_condition, 2},
    {field_consequence, 3},
  [252] =
    {field_body, 1},
    {field_condition, 3},
  [254] =
    {field_update, 2},
  [255] =
    {field_initializer, 0},
    {field_update, 2},
  [257] =
    {field_condition, 1},
    {field_initializer, 0},
  [259] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [263] =
    {field_body, 4},
    {field_declarator, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [268] =
    {field_value, 3},
  [269] =
    {field_operand, 1},
  [270] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [272] =
    {field_assembly_code, 3},
  [273] =
    {field_name, 2},
    {field_partition, 3},
  [275] =
    {field_default_type, 2},
  [276] =
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [278] =
    {field_body, 2},
    {field_parameters, 1},
  [280] =
    {field_condition, 2},
  [281] =
    {field_length, 1},
  [282] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [286] =
    {field_declarator, 1},
    {field_declarator, 2},
  [288] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [292] =
    {field_declarator, 4},
  [293] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [296] =
    {field_declarator, 0},
    {field_size, 3},
  [298] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [301] =
    {field_body, 4},
    {field_captures, 0},
    {field_constraint, 2},
    {field_declarator, 3},
    {field_template_parameters, 1},
  [306] =
    {field_declarator, 1},
    {field_default_value, 3},
  [308] =
    {field_alternative, 4},
    {field_condition, 1},
  [310] =
    {field_size, 2},
  [311] =
    {field_name, 1},
    {field_type, 4},
  [313] =
    {field_arguments, 5},
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [317] =
    {field_body, 2},
    {field_filter, 1},
  [319] =
    {field_left, 2},
    {field_right, 4},
  [321] =
    {field_declarator, 1},
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [324] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_default_value, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [328] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
    {field_default_value, 0, .inherited = true},
    {field_default_value, 1, .inherited = true},
  [332] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 3},
  [335] =
    {field_condition, 1},
    {field_update, 3},
  [337] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [340] =
    {field_declarator, 1},
    {field_right, 3},
    {field_type, 0, .inherited = true},
  [343] =
    {field_initializer, 0},
    {field_update, 3},
  [345] =
    {field_condition, 2},
    {field_initializer, 0},
  [347] =
    {field_member, 4},
    {field_type, 2},
  [349] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [351] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [354] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [356] =
    {field_default_type, 3},
    {field_name, 1},
  [358] =
    {field_declarator, 1},
    {field_default_value, 3},
    {field_type, 0, .inherited = true},
  [361] =
    {field_name, 5},
    {field_namespace, 1},
    {field_prefix, 3},
  [364] =
    {field_end, 3},
    {field_start, 1},
  [366] =
    {field_declarator, 1},
    {field_default_value, 2},
  [368] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [372] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 2},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [377] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [380] =
    {field_declarator, 2},
    {field_initializer, 0},
    {field_right, 4},
    {field_type, 1, .inherited = true},
  [384] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [386] =
    {field_register, 1},
  [387] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [391] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [394] =
    {field_condition, 2},
    {field_message, 4},
  [396] =
    {field_delimiter, 1},
  [397] =
    {field_declarator, 1},
    {field_declarator, 4, .inherited = true},
    {field_default_value, 3},
    {field_default_value, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [402] =
    {field_constraint, 0},
    {field_value, 2},
  [404] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [406] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [411] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [415] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [417] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [419] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [424] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [426] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_namespace_identifier,
  },
  [16] = {
    [0] = alias_sym_type_identifier,
  },
  [18] = {
    [0] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = alias_sym_namespace_identifier,
  },
  [34] = {
    [1] = alias_sym_type_identifier,
  },
  [35] = {
    [1] = alias_sym_type_identifier,
  },
  [42] = {
    [0] = sym_primitive_type,
  },
  [43] = {
    [0] = sym_pointer_declarator,
  },
  [53] = {
    [1] = alias_sym_statement_identifier,
  },
  [54] = {
    [0] = alias_sym_statement_identifier,
  },
  [61] = {
    [1] = alias_sym_namespace_identifier,
  },
  [62] = {
    [1] = alias_sym_namespace_identifier,
  },
  [66] = {
    [0] = alias_sym_simple_requirement,
  },
  [72] = {
    [2] = alias_sym_field_identifier,
  },
  [77] = {
    [2] = alias_sym_type_identifier,
  },
  [95] = {
    [2] = alias_sym_namespace_identifier,
  },
  [98] = {
    [1] = alias_sym_field_identifier,
  },
  [101] = {
    [1] = alias_sym_type_identifier,
  },
  [103] = {
    [0] = alias_sym_field_identifier,
  },
  [113] = {
    [1] = alias_sym_type_identifier,
  },
  [124] = {
    [0] = alias_sym_field_identifier,
  },
  [125] = {
    [1] = alias_sym_field_identifier,
  },
  [138] = {
    [1] = alias_sym_type_identifier,
  },
  [144] = {
    [3] = alias_sym_namespace_identifier,
  },
  [146] = {
    [0] = alias_sym_field_identifier,
  },
  [166] = {
    [2] = alias_sym_type_identifier,
  },
  [170] = {
    [1] = alias_sym_namespace_identifier,
    [3] = alias_sym_namespace_identifier,
  },
  [171] = {
    [1] = alias_sym_namespace_identifier,
  },
  [185] = {
    [1] = alias_sym_type_identifier,
  },
  [198] = {
    [4] = alias_sym_field_identifier,
  },
  [202] = {
    [1] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_pointer_type_declarator, 2,
    sym_pointer_type_declarator,
    sym_pointer_declarator,
  sym_expression_statement, 2,
    sym_expression_statement,
    alias_sym_simple_requirement,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 2,
  [10] = 2,
  [11] = 2,
  [12] = 2,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 14,
  [17] = 17,
  [18] = 17,
  [19] = 15,
  [20] = 17,
  [21] = 14,
  [22] = 13,
  [23] = 13,
  [24] = 15,
  [25] = 14,
  [26] = 17,
  [27] = 27,
  [28] = 13,
  [29] = 15,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 33,
  [39] = 36,
  [40] = 40,
  [41] = 41,
  [42] = 33,
  [43] = 43,
  [44] = 36,
  [45] = 40,
  [46] = 41,
  [47] = 47,
  [48] = 43,
  [49] = 43,
  [50] = 36,
  [51] = 51,
  [52] = 40,
  [53] = 41,
  [54] = 43,
  [55] = 55,
  [56] = 36,
  [57] = 40,
  [58] = 41,
  [59] = 36,
  [60] = 40,
  [61] = 36,
  [62] = 40,
  [63] = 63,
  [64] = 36,
  [65] = 40,
  [66] = 36,
  [67] = 40,
  [68] = 40,
  [69] = 36,
  [70] = 40,
  [71] = 36,
  [72] = 40,
  [73] = 36,
  [74] = 40,
  [75] = 36,
  [76] = 40,
  [77] = 36,
  [78] = 40,
  [79] = 36,
  [80] = 40,
  [81] = 36,
  [82] = 40,
  [83] = 40,
  [84] = 36,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 87,
  [91] = 89,
  [92] = 86,
  [93] = 88,
  [94] = 85,
  [95] = 88,
  [96] = 89,
  [97] = 85,
  [98] = 89,
  [99] = 86,
  [100] = 87,
  [101] = 86,
  [102] = 88,
  [103] = 85,
  [104] = 87,
  [105] = 105,
  [106] = 87,
  [107] = 85,
  [108] = 89,
  [109] = 109,
  [110] = 109,
  [111] = 109,
  [112] = 109,
  [113] = 109,
  [114] = 88,
  [115] = 86,
  [116] = 109,
  [117] = 117,
  [118] = 117,
  [119] = 117,
  [120] = 117,
  [121] = 117,
  [122] = 117,
  [123] = 123,
  [124] = 124,
  [125] = 124,
  [126] = 124,
  [127] = 127,
  [128] = 127,
  [129] = 127,
  [130] = 127,
  [131] = 127,
  [132] = 127,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 137,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 139,
  [143] = 143,
  [144] = 143,
  [145] = 140,
  [146] = 141,
  [147] = 140,
  [148] = 139,
  [149] = 143,
  [150] = 141,
  [151] = 140,
  [152] = 139,
  [153] = 143,
  [154] = 143,
  [155] = 143,
  [156] = 143,
  [157] = 139,
  [158] = 137,
  [159] = 139,
  [160] = 139,
  [161] = 139,
  [162] = 143,
  [163] = 143,
  [164] = 141,
  [165] = 139,
  [166] = 143,
  [167] = 139,
  [168] = 143,
  [169] = 139,
  [170] = 143,
  [171] = 139,
  [172] = 143,
  [173] = 139,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 174,
  [178] = 178,
  [179] = 179,
  [180] = 176,
  [181] = 178,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 175,
  [186] = 176,
  [187] = 179,
  [188] = 176,
  [189] = 174,
  [190] = 182,
  [191] = 183,
  [192] = 184,
  [193] = 141,
  [194] = 178,
  [195] = 182,
  [196] = 183,
  [197] = 184,
  [198] = 182,
  [199] = 178,
  [200] = 178,
  [201] = 184,
  [202] = 182,
  [203] = 179,
  [204] = 183,
  [205] = 174,
  [206] = 184,
  [207] = 176,
  [208] = 174,
  [209] = 137,
  [210] = 141,
  [211] = 178,
  [212] = 182,
  [213] = 183,
  [214] = 184,
  [215] = 176,
  [216] = 179,
  [217] = 175,
  [218] = 179,
  [219] = 179,
  [220] = 174,
  [221] = 175,
  [222] = 175,
  [223] = 183,
  [224] = 224,
  [225] = 225,
  [226] = 137,
  [227] = 137,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 224,
  [232] = 229,
  [233] = 225,
  [234] = 229,
  [235] = 229,
  [236] = 137,
  [237] = 237,
  [238] = 238,
  [239] = 136,
  [240] = 240,
  [241] = 135,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 240,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 237,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 238,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 242,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 259,
  [298] = 261,
  [299] = 263,
  [300] = 264,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 266,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 255,
  [343] = 247,
  [344] = 270,
  [345] = 277,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 258,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 225,
  [360] = 360,
  [361] = 361,
  [362] = 224,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 278,
  [368] = 280,
  [369] = 281,
  [370] = 228,
  [371] = 371,
  [372] = 262,
  [373] = 245,
  [374] = 339,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 375,
  [379] = 376,
  [380] = 252,
  [381] = 253,
  [382] = 269,
  [383] = 243,
  [384] = 244,
  [385] = 371,
  [386] = 371,
  [387] = 246,
  [388] = 230,
  [389] = 339,
  [390] = 248,
  [391] = 375,
  [392] = 376,
  [393] = 377,
  [394] = 377,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 371,
  [400] = 274,
  [401] = 279,
  [402] = 371,
  [403] = 254,
  [404] = 271,
  [405] = 267,
  [406] = 265,
  [407] = 371,
  [408] = 371,
  [409] = 225,
  [410] = 371,
  [411] = 371,
  [412] = 371,
  [413] = 268,
  [414] = 371,
  [415] = 273,
  [416] = 371,
  [417] = 417,
  [418] = 371,
  [419] = 419,
  [420] = 275,
  [421] = 371,
  [422] = 276,
  [423] = 256,
  [424] = 371,
  [425] = 224,
  [426] = 371,
  [427] = 371,
  [428] = 250,
  [429] = 249,
  [430] = 430,
  [431] = 272,
  [432] = 432,
  [433] = 433,
  [434] = 293,
  [435] = 229,
  [436] = 229,
  [437] = 430,
  [438] = 228,
  [439] = 230,
  [440] = 440,
  [441] = 440,
  [442] = 257,
  [443] = 443,
  [444] = 229,
  [445] = 228,
  [446] = 229,
  [447] = 230,
  [448] = 229,
  [449] = 229,
  [450] = 238,
  [451] = 451,
  [452] = 451,
  [453] = 136,
  [454] = 135,
  [455] = 136,
  [456] = 240,
  [457] = 135,
  [458] = 240,
  [459] = 459,
  [460] = 237,
  [461] = 237,
  [462] = 459,
  [463] = 459,
  [464] = 459,
  [465] = 459,
  [466] = 459,
  [467] = 459,
  [468] = 459,
  [469] = 459,
  [470] = 459,
  [471] = 459,
  [472] = 459,
  [473] = 238,
  [474] = 273,
  [475] = 331,
  [476] = 288,
  [477] = 315,
  [478] = 332,
  [479] = 333,
  [480] = 334,
  [481] = 335,
  [482] = 336,
  [483] = 483,
  [484] = 294,
  [485] = 337,
  [486] = 316,
  [487] = 312,
  [488] = 274,
  [489] = 338,
  [490] = 295,
  [491] = 250,
  [492] = 290,
  [493] = 291,
  [494] = 305,
  [495] = 340,
  [496] = 341,
  [497] = 303,
  [498] = 308,
  [499] = 499,
  [500] = 317,
  [501] = 321,
  [502] = 268,
  [503] = 309,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 284,
  [511] = 346,
  [512] = 285,
  [513] = 347,
  [514] = 348,
  [515] = 349,
  [516] = 304,
  [517] = 351,
  [518] = 352,
  [519] = 292,
  [520] = 354,
  [521] = 355,
  [522] = 356,
  [523] = 310,
  [524] = 254,
  [525] = 263,
  [526] = 357,
  [527] = 318,
  [528] = 528,
  [529] = 279,
  [530] = 249,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 255,
  [535] = 277,
  [536] = 358,
  [537] = 258,
  [538] = 267,
  [539] = 264,
  [540] = 272,
  [541] = 274,
  [542] = 247,
  [543] = 432,
  [544] = 271,
  [545] = 279,
  [546] = 546,
  [547] = 296,
  [548] = 255,
  [549] = 277,
  [550] = 258,
  [551] = 551,
  [552] = 267,
  [553] = 272,
  [554] = 247,
  [555] = 555,
  [556] = 254,
  [557] = 557,
  [558] = 271,
  [559] = 257,
  [560] = 265,
  [561] = 561,
  [562] = 325,
  [563] = 563,
  [564] = 265,
  [565] = 565,
  [566] = 330,
  [567] = 249,
  [568] = 275,
  [569] = 273,
  [570] = 276,
  [571] = 256,
  [572] = 275,
  [573] = 242,
  [574] = 276,
  [575] = 259,
  [576] = 261,
  [577] = 263,
  [578] = 256,
  [579] = 264,
  [580] = 266,
  [581] = 257,
  [582] = 313,
  [583] = 242,
  [584] = 360,
  [585] = 361,
  [586] = 259,
  [587] = 587,
  [588] = 246,
  [589] = 261,
  [590] = 590,
  [591] = 270,
  [592] = 268,
  [593] = 311,
  [594] = 257,
  [595] = 266,
  [596] = 270,
  [597] = 597,
  [598] = 598,
  [599] = 314,
  [600] = 250,
  [601] = 278,
  [602] = 283,
  [603] = 280,
  [604] = 281,
  [605] = 306,
  [606] = 322,
  [607] = 262,
  [608] = 262,
  [609] = 245,
  [610] = 252,
  [611] = 433,
  [612] = 364,
  [613] = 252,
  [614] = 245,
  [615] = 253,
  [616] = 269,
  [617] = 248,
  [618] = 326,
  [619] = 307,
  [620] = 319,
  [621] = 286,
  [622] = 287,
  [623] = 327,
  [624] = 328,
  [625] = 625,
  [626] = 243,
  [627] = 244,
  [628] = 329,
  [629] = 320,
  [630] = 246,
  [631] = 324,
  [632] = 248,
  [633] = 253,
  [634] = 365,
  [635] = 366,
  [636] = 269,
  [637] = 278,
  [638] = 638,
  [639] = 243,
  [640] = 244,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 280,
  [645] = 645,
  [646] = 301,
  [647] = 281,
  [648] = 302,
  [649] = 363,
  [650] = 285,
  [651] = 307,
  [652] = 308,
  [653] = 309,
  [654] = 301,
  [655] = 310,
  [656] = 311,
  [657] = 303,
  [658] = 304,
  [659] = 305,
  [660] = 283,
  [661] = 312,
  [662] = 306,
  [663] = 307,
  [664] = 314,
  [665] = 315,
  [666] = 316,
  [667] = 313,
  [668] = 314,
  [669] = 318,
  [670] = 319,
  [671] = 320,
  [672] = 315,
  [673] = 316,
  [674] = 317,
  [675] = 321,
  [676] = 324,
  [677] = 325,
  [678] = 326,
  [679] = 327,
  [680] = 328,
  [681] = 335,
  [682] = 336,
  [683] = 337,
  [684] = 318,
  [685] = 340,
  [686] = 341,
  [687] = 319,
  [688] = 320,
  [689] = 346,
  [690] = 347,
  [691] = 349,
  [692] = 351,
  [693] = 352,
  [694] = 356,
  [695] = 430,
  [696] = 284,
  [697] = 321,
  [698] = 287,
  [699] = 288,
  [700] = 291,
  [701] = 293,
  [702] = 295,
  [703] = 322,
  [704] = 302,
  [705] = 324,
  [706] = 325,
  [707] = 308,
  [708] = 309,
  [709] = 310,
  [710] = 311,
  [711] = 283,
  [712] = 312,
  [713] = 313,
  [714] = 317,
  [715] = 326,
  [716] = 322,
  [717] = 327,
  [718] = 328,
  [719] = 329,
  [720] = 330,
  [721] = 331,
  [722] = 329,
  [723] = 332,
  [724] = 333,
  [725] = 334,
  [726] = 348,
  [727] = 330,
  [728] = 331,
  [729] = 354,
  [730] = 306,
  [731] = 358,
  [732] = 332,
  [733] = 333,
  [734] = 334,
  [735] = 360,
  [736] = 361,
  [737] = 335,
  [738] = 433,
  [739] = 364,
  [740] = 365,
  [741] = 366,
  [742] = 336,
  [743] = 337,
  [744] = 338,
  [745] = 338,
  [746] = 357,
  [747] = 340,
  [748] = 341,
  [749] = 346,
  [750] = 347,
  [751] = 348,
  [752] = 349,
  [753] = 351,
  [754] = 352,
  [755] = 354,
  [756] = 355,
  [757] = 356,
  [758] = 357,
  [759] = 358,
  [760] = 430,
  [761] = 432,
  [762] = 360,
  [763] = 361,
  [764] = 363,
  [765] = 284,
  [766] = 285,
  [767] = 286,
  [768] = 287,
  [769] = 288,
  [770] = 305,
  [771] = 290,
  [772] = 291,
  [773] = 292,
  [774] = 293,
  [775] = 433,
  [776] = 364,
  [777] = 294,
  [778] = 295,
  [779] = 296,
  [780] = 365,
  [781] = 366,
  [782] = 432,
  [783] = 301,
  [784] = 302,
  [785] = 296,
  [786] = 363,
  [787] = 286,
  [788] = 303,
  [789] = 290,
  [790] = 292,
  [791] = 294,
  [792] = 304,
  [793] = 355,
  [794] = 137,
  [795] = 795,
  [796] = 796,
  [797] = 796,
  [798] = 795,
  [799] = 799,
  [800] = 800,
  [801] = 796,
  [802] = 795,
  [803] = 796,
  [804] = 587,
  [805] = 795,
  [806] = 796,
  [807] = 795,
  [808] = 796,
  [809] = 795,
  [810] = 795,
  [811] = 795,
  [812] = 587,
  [813] = 796,
  [814] = 795,
  [815] = 796,
  [816] = 796,
  [817] = 795,
  [818] = 796,
  [819] = 137,
  [820] = 137,
  [821] = 137,
  [822] = 137,
  [823] = 137,
  [824] = 824,
  [825] = 825,
  [826] = 825,
  [827] = 451,
  [828] = 828,
  [829] = 829,
  [830] = 451,
  [831] = 451,
  [832] = 832,
  [833] = 832,
  [834] = 832,
  [835] = 832,
  [836] = 832,
  [837] = 832,
  [838] = 832,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 843,
  [848] = 839,
  [849] = 843,
  [850] = 843,
  [851] = 843,
  [852] = 845,
  [853] = 839,
  [854] = 843,
  [855] = 841,
  [856] = 846,
  [857] = 839,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 843,
  [864] = 841,
  [865] = 861,
  [866] = 844,
  [867] = 841,
  [868] = 224,
  [869] = 869,
  [870] = 451,
  [871] = 451,
  [872] = 225,
  [873] = 873,
  [874] = 873,
  [875] = 873,
  [876] = 873,
  [877] = 451,
  [878] = 135,
  [879] = 879,
  [880] = 829,
  [881] = 828,
  [882] = 238,
  [883] = 237,
  [884] = 240,
  [885] = 136,
  [886] = 266,
  [887] = 269,
  [888] = 258,
  [889] = 267,
  [890] = 261,
  [891] = 244,
  [892] = 272,
  [893] = 275,
  [894] = 273,
  [895] = 278,
  [896] = 280,
  [897] = 250,
  [898] = 276,
  [899] = 246,
  [900] = 860,
  [901] = 901,
  [902] = 265,
  [903] = 252,
  [904] = 279,
  [905] = 277,
  [906] = 255,
  [907] = 247,
  [908] = 243,
  [909] = 901,
  [910] = 274,
  [911] = 268,
  [912] = 253,
  [913] = 256,
  [914] = 262,
  [915] = 248,
  [916] = 270,
  [917] = 259,
  [918] = 281,
  [919] = 264,
  [920] = 263,
  [921] = 254,
  [922] = 245,
  [923] = 249,
  [924] = 271,
  [925] = 242,
  [926] = 926,
  [927] = 927,
  [928] = 928,
  [929] = 928,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 927,
  [934] = 934,
  [935] = 935,
  [936] = 928,
  [937] = 932,
  [938] = 934,
  [939] = 939,
  [940] = 930,
  [941] = 932,
  [942] = 935,
  [943] = 930,
  [944] = 934,
  [945] = 928,
  [946] = 932,
  [947] = 935,
  [948] = 930,
  [949] = 934,
  [950] = 930,
  [951] = 935,
  [952] = 928,
  [953] = 932,
  [954] = 934,
  [955] = 930,
  [956] = 935,
  [957] = 927,
  [958] = 934,
  [959] = 930,
  [960] = 935,
  [961] = 935,
  [962] = 934,
  [963] = 928,
  [964] = 930,
  [965] = 928,
  [966] = 935,
  [967] = 934,
  [968] = 932,
  [969] = 930,
  [970] = 928,
  [971] = 935,
  [972] = 928,
  [973] = 934,
  [974] = 928,
  [975] = 927,
  [976] = 931,
  [977] = 927,
  [978] = 927,
  [979] = 934,
  [980] = 928,
  [981] = 981,
  [982] = 934,
  [983] = 934,
  [984] = 934,
  [985] = 928,
  [986] = 928,
  [987] = 987,
  [988] = 987,
  [989] = 989,
  [990] = 987,
  [991] = 989,
  [992] = 931,
  [993] = 989,
  [994] = 987,
  [995] = 987,
  [996] = 987,
  [997] = 989,
  [998] = 989,
  [999] = 989,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1006,
  [1008] = 1008,
  [1009] = 1004,
  [1010] = 1005,
  [1011] = 1004,
  [1012] = 1005,
  [1013] = 1004,
  [1014] = 1004,
  [1015] = 1004,
  [1016] = 1004,
  [1017] = 1017,
  [1018] = 1004,
  [1019] = 1008,
  [1020] = 1008,
  [1021] = 1008,
  [1022] = 1006,
  [1023] = 1008,
  [1024] = 1006,
  [1025] = 1006,
  [1026] = 1004,
  [1027] = 1008,
  [1028] = 1008,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1031,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1031,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1046,
  [1048] = 1048,
  [1049] = 1046,
  [1050] = 1050,
  [1051] = 1046,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1053,
  [1057] = 1054,
  [1058] = 1046,
  [1059] = 1053,
  [1060] = 1054,
  [1061] = 1053,
  [1062] = 1046,
  [1063] = 1053,
  [1064] = 1053,
  [1065] = 1053,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1053,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1046,
  [1073] = 1046,
  [1074] = 1053,
  [1075] = 1053,
  [1076] = 1054,
  [1077] = 1077,
  [1078] = 1046,
  [1079] = 1079,
  [1080] = 1054,
  [1081] = 1081,
  [1082] = 1053,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 1046,
  [1086] = 1054,
  [1087] = 1046,
  [1088] = 1046,
  [1089] = 1046,
  [1090] = 1054,
  [1091] = 1053,
  [1092] = 1053,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 1102,
  [1103] = 1103,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1109,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1112,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 1098,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1106,
  [1127] = 1104,
  [1128] = 1101,
  [1129] = 1108,
  [1130] = 1130,
  [1131] = 1099,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1130,
  [1135] = 1122,
  [1136] = 1136,
  [1137] = 1122,
  [1138] = 1138,
  [1139] = 1114,
  [1140] = 1107,
  [1141] = 1110,
  [1142] = 1142,
  [1143] = 1122,
  [1144] = 1136,
  [1145] = 1145,
  [1146] = 1122,
  [1147] = 1147,
  [1148] = 1105,
  [1149] = 1122,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1122,
  [1153] = 1145,
  [1154] = 1138,
  [1155] = 1122,
  [1156] = 1123,
  [1157] = 1151,
  [1158] = 1122,
  [1159] = 1125,
  [1160] = 1122,
  [1161] = 1142,
  [1162] = 1116,
  [1163] = 1138,
  [1164] = 1096,
  [1165] = 1138,
  [1166] = 1118,
  [1167] = 1136,
  [1168] = 1145,
  [1169] = 1169,
  [1170] = 1138,
  [1171] = 1145,
  [1172] = 1102,
  [1173] = 1130,
  [1174] = 1123,
  [1175] = 1142,
  [1176] = 1138,
  [1177] = 1113,
  [1178] = 1123,
  [1179] = 1100,
  [1180] = 1138,
  [1181] = 1095,
  [1182] = 1138,
  [1183] = 1145,
  [1184] = 1138,
  [1185] = 1138,
  [1186] = 1115,
  [1187] = 1123,
  [1188] = 1119,
  [1189] = 1138,
  [1190] = 1138,
  [1191] = 1191,
  [1192] = 1132,
  [1193] = 1124,
  [1194] = 1150,
  [1195] = 1097,
  [1196] = 1133,
  [1197] = 1103,
  [1198] = 1130,
  [1199] = 1136,
  [1200] = 1138,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1202,
  [1211] = 1205,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1207,
  [1222] = 1222,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1208,
  [1226] = 1209,
  [1227] = 1205,
  [1228] = 1214,
  [1229] = 1217,
  [1230] = 1208,
  [1231] = 1209,
  [1232] = 1207,
  [1233] = 1208,
  [1234] = 1234,
  [1235] = 1205,
  [1236] = 1209,
  [1237] = 1205,
  [1238] = 1214,
  [1239] = 1239,
  [1240] = 1217,
  [1241] = 1241,
  [1242] = 1234,
  [1243] = 1207,
  [1244] = 1205,
  [1245] = 1217,
  [1246] = 1246,
  [1247] = 1215,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1201,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1208,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1209,
  [1260] = 1260,
  [1261] = 1214,
  [1262] = 1241,
  [1263] = 1234,
  [1264] = 1205,
  [1265] = 1246,
  [1266] = 1249,
  [1267] = 1250,
  [1268] = 1251,
  [1269] = 1201,
  [1270] = 1254,
  [1271] = 1255,
  [1272] = 1257,
  [1273] = 1258,
  [1274] = 1260,
  [1275] = 1214,
  [1276] = 1276,
  [1277] = 1253,
  [1278] = 1278,
  [1279] = 1217,
  [1280] = 1208,
  [1281] = 1207,
  [1282] = 1246,
  [1283] = 1249,
  [1284] = 1250,
  [1285] = 1285,
  [1286] = 1251,
  [1287] = 1201,
  [1288] = 1254,
  [1289] = 1255,
  [1290] = 1207,
  [1291] = 1257,
  [1292] = 1258,
  [1293] = 1217,
  [1294] = 1260,
  [1295] = 1214,
  [1296] = 1296,
  [1297] = 1234,
  [1298] = 1246,
  [1299] = 1249,
  [1300] = 1250,
  [1301] = 1251,
  [1302] = 1201,
  [1303] = 1254,
  [1304] = 1255,
  [1305] = 1257,
  [1306] = 1258,
  [1307] = 1260,
  [1308] = 1308,
  [1309] = 1208,
  [1310] = 1209,
  [1311] = 1205,
  [1312] = 1214,
  [1313] = 1217,
  [1314] = 1207,
  [1315] = 1215,
  [1316] = 1248,
  [1317] = 1253,
  [1318] = 1318,
  [1319] = 1208,
  [1320] = 1209,
  [1321] = 1248,
  [1322] = 1241,
  [1323] = 1234,
  [1324] = 1205,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1209,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1241,
  [1331] = 1246,
  [1332] = 1249,
  [1333] = 1250,
  [1334] = 1251,
  [1335] = 1201,
  [1336] = 1254,
  [1337] = 1255,
  [1338] = 1257,
  [1339] = 1258,
  [1340] = 1260,
  [1341] = 1214,
  [1342] = 1342,
  [1343] = 1234,
  [1344] = 1207,
  [1345] = 1345,
  [1346] = 1217,
  [1347] = 1207,
  [1348] = 1234,
  [1349] = 1246,
  [1350] = 1249,
  [1351] = 1250,
  [1352] = 1251,
  [1353] = 1201,
  [1354] = 1254,
  [1355] = 1255,
  [1356] = 1257,
  [1357] = 1258,
  [1358] = 1260,
  [1359] = 1208,
  [1360] = 1209,
  [1361] = 1215,
  [1362] = 1253,
  [1363] = 1241,
  [1364] = 1364,
  [1365] = 1285,
  [1366] = 1246,
  [1367] = 1234,
  [1368] = 1246,
  [1369] = 1249,
  [1370] = 1250,
  [1371] = 1251,
  [1372] = 1201,
  [1373] = 1254,
  [1374] = 1255,
  [1375] = 1257,
  [1376] = 1258,
  [1377] = 1260,
  [1378] = 1215,
  [1379] = 1253,
  [1380] = 1208,
  [1381] = 1209,
  [1382] = 1234,
  [1383] = 1234,
  [1384] = 1246,
  [1385] = 1249,
  [1386] = 1250,
  [1387] = 1251,
  [1388] = 1201,
  [1389] = 1389,
  [1390] = 1255,
  [1391] = 1257,
  [1392] = 1258,
  [1393] = 1260,
  [1394] = 1215,
  [1395] = 1253,
  [1396] = 1205,
  [1397] = 1215,
  [1398] = 1253,
  [1399] = 1249,
  [1400] = 1250,
  [1401] = 1251,
  [1402] = 1201,
  [1403] = 1254,
  [1404] = 1246,
  [1405] = 1249,
  [1406] = 1250,
  [1407] = 1251,
  [1408] = 1215,
  [1409] = 1201,
  [1410] = 1253,
  [1411] = 1254,
  [1412] = 1255,
  [1413] = 1257,
  [1414] = 1258,
  [1415] = 1260,
  [1416] = 1214,
  [1417] = 1215,
  [1418] = 1253,
  [1419] = 1217,
  [1420] = 1215,
  [1421] = 1253,
  [1422] = 1218,
  [1423] = 1219,
  [1424] = 1255,
  [1425] = 1257,
  [1426] = 1258,
  [1427] = 1260,
  [1428] = 1318,
  [1429] = 1325,
  [1430] = 1234,
  [1431] = 1205,
  [1432] = 1214,
  [1433] = 1246,
  [1434] = 1249,
  [1435] = 1250,
  [1436] = 1251,
  [1437] = 1201,
  [1438] = 1254,
  [1439] = 1255,
  [1440] = 1257,
  [1441] = 1258,
  [1442] = 1260,
  [1443] = 1214,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1203,
  [1447] = 1217,
  [1448] = 1276,
  [1449] = 1207,
  [1450] = 1212,
  [1451] = 1318,
  [1452] = 1325,
  [1453] = 1217,
  [1454] = 1444,
  [1455] = 1445,
  [1456] = 1203,
  [1457] = 1276,
  [1458] = 1212,
  [1459] = 1318,
  [1460] = 1325,
  [1461] = 1444,
  [1462] = 1445,
  [1463] = 1203,
  [1464] = 1276,
  [1465] = 1212,
  [1466] = 1318,
  [1467] = 1325,
  [1468] = 1444,
  [1469] = 1445,
  [1470] = 1203,
  [1471] = 1276,
  [1472] = 1212,
  [1473] = 1444,
  [1474] = 1445,
  [1475] = 1203,
  [1476] = 1276,
  [1477] = 1444,
  [1478] = 1212,
  [1479] = 1444,
  [1480] = 1445,
  [1481] = 1276,
  [1482] = 1215,
  [1483] = 1253,
  [1484] = 1389,
  [1485] = 1208,
  [1486] = 1209,
  [1487] = 1326,
  [1488] = 1215,
  [1489] = 1253,
  [1490] = 1249,
  [1491] = 1326,
  [1492] = 1326,
  [1493] = 1326,
  [1494] = 1326,
  [1495] = 1326,
  [1496] = 1241,
  [1497] = 1234,
  [1498] = 1246,
  [1499] = 1249,
  [1500] = 1250,
  [1501] = 1251,
  [1502] = 1201,
  [1503] = 1254,
  [1504] = 1255,
  [1505] = 1257,
  [1506] = 1258,
  [1507] = 1260,
  [1508] = 1208,
  [1509] = 1209,
  [1510] = 1205,
  [1511] = 1214,
  [1512] = 1217,
  [1513] = 1207,
  [1514] = 1234,
  [1515] = 1205,
  [1516] = 1246,
  [1517] = 1250,
  [1518] = 1251,
  [1519] = 1254,
  [1520] = 1255,
  [1521] = 1257,
  [1522] = 1258,
  [1523] = 1260,
  [1524] = 1214,
  [1525] = 1445,
  [1526] = 1217,
  [1527] = 1207,
  [1528] = 1215,
  [1529] = 1253,
  [1530] = 1208,
  [1531] = 1209,
  [1532] = 1207,
  [1533] = 1389,
  [1534] = 1389,
  [1535] = 1389,
  [1536] = 1389,
  [1537] = 1254,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1547,
  [1549] = 1549,
  [1550] = 338,
  [1551] = 357,
  [1552] = 1552,
  [1553] = 1540,
  [1554] = 1538,
  [1555] = 1539,
  [1556] = 1544,
  [1557] = 1541,
  [1558] = 1552,
  [1559] = 1552,
  [1560] = 1545,
  [1561] = 1542,
  [1562] = 1543,
  [1563] = 1552,
  [1564] = 1541,
  [1565] = 1546,
  [1566] = 1542,
  [1567] = 1543,
  [1568] = 1538,
  [1569] = 1545,
  [1570] = 1544,
  [1571] = 1539,
  [1572] = 1540,
  [1573] = 1573,
  [1574] = 1546,
  [1575] = 1541,
  [1576] = 931,
  [1577] = 1546,
  [1578] = 1578,
  [1579] = 931,
  [1580] = 1545,
  [1581] = 1538,
  [1582] = 1542,
  [1583] = 1544,
  [1584] = 1540,
  [1585] = 1585,
  [1586] = 1546,
  [1587] = 1539,
  [1588] = 1543,
  [1589] = 931,
  [1590] = 1590,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1592,
  [1595] = 1593,
  [1596] = 1545,
  [1597] = 1538,
  [1598] = 1542,
  [1599] = 1540,
  [1600] = 1544,
  [1601] = 1543,
  [1602] = 1539,
  [1603] = 1603,
  [1604] = 1546,
  [1605] = 1593,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1611,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1614,
  [1618] = 1618,
  [1619] = 1592,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1593,
  [1625] = 1592,
  [1626] = 1578,
  [1627] = 1627,
  [1628] = 1578,
  [1629] = 1627,
  [1630] = 1627,
  [1631] = 1627,
  [1632] = 1632,
  [1633] = 1578,
  [1634] = 1585,
  [1635] = 1593,
  [1636] = 1636,
  [1637] = 1592,
  [1638] = 1632,
  [1639] = 1632,
  [1640] = 1636,
  [1641] = 1636,
  [1642] = 1632,
  [1643] = 1636,
  [1644] = 1632,
  [1645] = 1632,
  [1646] = 1636,
  [1647] = 1636,
  [1648] = 1632,
  [1649] = 1614,
  [1650] = 1636,
  [1651] = 1590,
  [1652] = 1591,
  [1653] = 1614,
  [1654] = 1578,
  [1655] = 1578,
  [1656] = 1585,
  [1657] = 1591,
  [1658] = 1590,
  [1659] = 1546,
  [1660] = 1590,
  [1661] = 1661,
  [1662] = 1591,
  [1663] = 1663,
  [1664] = 1538,
  [1665] = 1542,
  [1666] = 1543,
  [1667] = 1540,
  [1668] = 1544,
  [1669] = 1585,
  [1670] = 1670,
  [1671] = 1539,
  [1672] = 1614,
  [1673] = 1546,
  [1674] = 1585,
  [1675] = 1545,
  [1676] = 1591,
  [1677] = 228,
  [1678] = 1678,
  [1679] = 224,
  [1680] = 1539,
  [1681] = 1543,
  [1682] = 1591,
  [1683] = 1542,
  [1684] = 1684,
  [1685] = 1545,
  [1686] = 230,
  [1687] = 1538,
  [1688] = 1590,
  [1689] = 1689,
  [1690] = 225,
  [1691] = 1540,
  [1692] = 1692,
  [1693] = 1544,
  [1694] = 1694,
  [1695] = 1590,
  [1696] = 1696,
  [1697] = 1696,
  [1698] = 1698,
  [1699] = 1696,
  [1700] = 1696,
  [1701] = 1546,
  [1702] = 136,
  [1703] = 1703,
  [1704] = 135,
  [1705] = 1541,
  [1706] = 238,
  [1707] = 257,
  [1708] = 1708,
  [1709] = 257,
  [1710] = 302,
  [1711] = 1711,
  [1712] = 325,
  [1713] = 1713,
  [1714] = 326,
  [1715] = 327,
  [1716] = 348,
  [1717] = 349,
  [1718] = 246,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 1541,
  [1724] = 351,
  [1725] = 1725,
  [1726] = 266,
  [1727] = 352,
  [1728] = 1728,
  [1729] = 328,
  [1730] = 262,
  [1731] = 1731,
  [1732] = 1543,
  [1733] = 245,
  [1734] = 1720,
  [1735] = 338,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1738,
  [1739] = 248,
  [1740] = 357,
  [1741] = 263,
  [1742] = 1731,
  [1743] = 1743,
  [1744] = 1720,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 361,
  [1749] = 433,
  [1750] = 364,
  [1751] = 1751,
  [1752] = 1720,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 264,
  [1757] = 1542,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1720,
  [1761] = 354,
  [1762] = 355,
  [1763] = 1545,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 358,
  [1773] = 1773,
  [1774] = 312,
  [1775] = 366,
  [1776] = 329,
  [1777] = 330,
  [1778] = 1778,
  [1779] = 1779,
  [1780] = 1780,
  [1781] = 331,
  [1782] = 313,
  [1783] = 1720,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1539,
  [1787] = 332,
  [1788] = 317,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 278,
  [1792] = 430,
  [1793] = 1793,
  [1794] = 280,
  [1795] = 1795,
  [1796] = 284,
  [1797] = 285,
  [1798] = 286,
  [1799] = 1799,
  [1800] = 1731,
  [1801] = 287,
  [1802] = 288,
  [1803] = 281,
  [1804] = 360,
  [1805] = 333,
  [1806] = 291,
  [1807] = 293,
  [1808] = 1808,
  [1809] = 334,
  [1810] = 1810,
  [1811] = 295,
  [1812] = 1720,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 322,
  [1818] = 1818,
  [1819] = 1819,
  [1820] = 1820,
  [1821] = 306,
  [1822] = 307,
  [1823] = 308,
  [1824] = 1824,
  [1825] = 1538,
  [1826] = 1540,
  [1827] = 309,
  [1828] = 310,
  [1829] = 311,
  [1830] = 1544,
  [1831] = 1731,
  [1832] = 283,
  [1833] = 365,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 228,
  [1837] = 1837,
  [1838] = 230,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1603,
  [1845] = 225,
  [1846] = 225,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 224,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1854,
  [1855] = 230,
  [1856] = 1546,
  [1857] = 1541,
  [1858] = 1591,
  [1859] = 1859,
  [1860] = 1592,
  [1861] = 1593,
  [1862] = 228,
  [1863] = 1670,
  [1864] = 1864,
  [1865] = 1865,
  [1866] = 1866,
  [1867] = 1867,
  [1868] = 1590,
  [1869] = 1592,
  [1870] = 1870,
  [1871] = 1871,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1874,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1878,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 1593,
  [1890] = 224,
  [1891] = 135,
  [1892] = 1892,
  [1893] = 1816,
  [1894] = 829,
  [1895] = 1546,
  [1896] = 1541,
  [1897] = 828,
  [1898] = 1835,
  [1899] = 1899,
  [1900] = 1900,
  [1901] = 1901,
  [1902] = 1902,
  [1903] = 1903,
  [1904] = 1904,
  [1905] = 1905,
  [1906] = 1813,
  [1907] = 136,
  [1908] = 1814,
  [1909] = 1888,
  [1910] = 1790,
  [1911] = 1911,
  [1912] = 1912,
  [1913] = 135,
  [1914] = 257,
  [1915] = 1915,
  [1916] = 1546,
  [1917] = 257,
  [1918] = 1585,
  [1919] = 136,
  [1920] = 238,
  [1921] = 1813,
  [1922] = 257,
  [1923] = 1814,
  [1924] = 1912,
  [1925] = 1912,
  [1926] = 1578,
  [1927] = 1927,
  [1928] = 1928,
  [1929] = 1912,
  [1930] = 1930,
  [1931] = 136,
  [1932] = 1912,
  [1933] = 1912,
  [1934] = 1912,
  [1935] = 1935,
  [1936] = 1790,
  [1937] = 238,
  [1938] = 1938,
  [1939] = 257,
  [1940] = 1940,
  [1941] = 1603,
  [1942] = 1942,
  [1943] = 1943,
  [1944] = 1944,
  [1945] = 1816,
  [1946] = 1946,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 135,
  [1950] = 1950,
  [1951] = 1951,
  [1952] = 288,
  [1953] = 264,
  [1954] = 311,
  [1955] = 1746,
  [1956] = 1956,
  [1957] = 1766,
  [1958] = 278,
  [1959] = 365,
  [1960] = 1824,
  [1961] = 1719,
  [1962] = 1770,
  [1963] = 1785,
  [1964] = 364,
  [1965] = 280,
  [1966] = 281,
  [1967] = 1759,
  [1968] = 322,
  [1969] = 1764,
  [1970] = 1736,
  [1971] = 1737,
  [1972] = 1738,
  [1973] = 263,
  [1974] = 1743,
  [1975] = 1745,
  [1976] = 1746,
  [1977] = 1747,
  [1978] = 1751,
  [1979] = 1753,
  [1980] = 1754,
  [1981] = 246,
  [1982] = 1765,
  [1983] = 1759,
  [1984] = 1764,
  [1985] = 1765,
  [1986] = 1767,
  [1987] = 1768,
  [1988] = 1769,
  [1989] = 306,
  [1990] = 264,
  [1991] = 307,
  [1992] = 1684,
  [1993] = 1993,
  [1994] = 1767,
  [1995] = 1771,
  [1996] = 1778,
  [1997] = 1793,
  [1998] = 1795,
  [1999] = 1808,
  [2000] = 1810,
  [2001] = 1815,
  [2002] = 1819,
  [2003] = 1820,
  [2004] = 1711,
  [2005] = 1689,
  [2006] = 266,
  [2007] = 430,
  [2008] = 1747,
  [2009] = 325,
  [2010] = 1692,
  [2011] = 262,
  [2012] = 245,
  [2013] = 338,
  [2014] = 354,
  [2015] = 355,
  [2016] = 248,
  [2017] = 357,
  [2018] = 248,
  [2019] = 326,
  [2020] = 366,
  [2021] = 283,
  [2022] = 360,
  [2023] = 1758,
  [2024] = 361,
  [2025] = 1766,
  [2026] = 1768,
  [2027] = 1769,
  [2028] = 1771,
  [2029] = 357,
  [2030] = 327,
  [2031] = 284,
  [2032] = 285,
  [2033] = 328,
  [2034] = 1942,
  [2035] = 329,
  [2036] = 1778,
  [2037] = 330,
  [2038] = 331,
  [2039] = 287,
  [2040] = 1888,
  [2041] = 309,
  [2042] = 291,
  [2043] = 293,
  [2044] = 332,
  [2045] = 1736,
  [2046] = 278,
  [2047] = 295,
  [2048] = 1904,
  [2049] = 333,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 280,
  [2053] = 2053,
  [2054] = 281,
  [2055] = 1614,
  [2056] = 2056,
  [2057] = 334,
  [2058] = 1793,
  [2059] = 1795,
  [2060] = 1808,
  [2061] = 1993,
  [2062] = 1810,
  [2063] = 1815,
  [2064] = 2064,
  [2065] = 1956,
  [2066] = 302,
  [2067] = 364,
  [2068] = 1903,
  [2069] = 1901,
  [2070] = 1743,
  [2071] = 358,
  [2072] = 325,
  [2073] = 326,
  [2074] = 1819,
  [2075] = 348,
  [2076] = 349,
  [2077] = 1820,
  [2078] = 1711,
  [2079] = 348,
  [2080] = 308,
  [2081] = 327,
  [2082] = 328,
  [2083] = 1755,
  [2084] = 351,
  [2085] = 309,
  [2086] = 310,
  [2087] = 311,
  [2088] = 283,
  [2089] = 246,
  [2090] = 262,
  [2091] = 352,
  [2092] = 1993,
  [2093] = 312,
  [2094] = 313,
  [2095] = 245,
  [2096] = 312,
  [2097] = 2064,
  [2098] = 433,
  [2099] = 1670,
  [2100] = 266,
  [2101] = 1779,
  [2102] = 313,
  [2103] = 317,
  [2104] = 1789,
  [2105] = 354,
  [2106] = 1670,
  [2107] = 1728,
  [2108] = 355,
  [2109] = 1738,
  [2110] = 1799,
  [2111] = 430,
  [2112] = 2112,
  [2113] = 317,
  [2114] = 338,
  [2115] = 2064,
  [2116] = 2116,
  [2117] = 1899,
  [2118] = 1755,
  [2119] = 284,
  [2120] = 1779,
  [2121] = 285,
  [2122] = 1789,
  [2123] = 1799,
  [2124] = 286,
  [2125] = 1824,
  [2126] = 1719,
  [2127] = 1751,
  [2128] = 1770,
  [2129] = 287,
  [2130] = 1785,
  [2131] = 1670,
  [2132] = 288,
  [2133] = 1753,
  [2134] = 310,
  [2135] = 2135,
  [2136] = 1993,
  [2137] = 291,
  [2138] = 293,
  [2139] = 365,
  [2140] = 349,
  [2141] = 351,
  [2142] = 352,
  [2143] = 295,
  [2144] = 366,
  [2145] = 322,
  [2146] = 1754,
  [2147] = 286,
  [2148] = 358,
  [2149] = 1903,
  [2150] = 302,
  [2151] = 1737,
  [2152] = 1745,
  [2153] = 306,
  [2154] = 307,
  [2155] = 1904,
  [2156] = 308,
  [2157] = 360,
  [2158] = 1758,
  [2159] = 1614,
  [2160] = 329,
  [2161] = 330,
  [2162] = 331,
  [2163] = 361,
  [2164] = 263,
  [2165] = 332,
  [2166] = 333,
  [2167] = 334,
  [2168] = 433,
  [2169] = 2169,
  [2170] = 1592,
  [2171] = 2171,
  [2172] = 1784,
  [2173] = 2173,
  [2174] = 1713,
  [2175] = 2175,
  [2176] = 2176,
  [2177] = 2177,
  [2178] = 2171,
  [2179] = 2171,
  [2180] = 1593,
  [2181] = 2181,
  [2182] = 1689,
  [2183] = 2183,
  [2184] = 2171,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2171,
  [2189] = 1684,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 1818,
  [2196] = 1692,
  [2197] = 2197,
  [2198] = 1585,
  [2199] = 2171,
  [2200] = 2200,
  [2201] = 2201,
  [2202] = 1670,
  [2203] = 2203,
  [2204] = 1670,
  [2205] = 2050,
  [2206] = 2206,
  [2207] = 1887,
  [2208] = 1670,
  [2209] = 1722,
  [2210] = 2210,
  [2211] = 1940,
  [2212] = 1591,
  [2213] = 1721,
  [2214] = 1943,
  [2215] = 2215,
  [2216] = 2116,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 1843,
  [2222] = 2222,
  [2223] = 1849,
  [2224] = 2224,
  [2225] = 1877,
  [2226] = 1864,
  [2227] = 1865,
  [2228] = 1866,
  [2229] = 1590,
  [2230] = 2197,
  [2231] = 1870,
  [2232] = 1871,
  [2233] = 1872,
  [2234] = 1928,
  [2235] = 1885,
  [2236] = 1684,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 1670,
  [2240] = 1878,
  [2241] = 1880,
  [2242] = 2242,
  [2243] = 1881,
  [2244] = 1540,
  [2245] = 1879,
  [2246] = 1882,
  [2247] = 2247,
  [2248] = 1935,
  [2249] = 1883,
  [2250] = 1790,
  [2251] = 1834,
  [2252] = 1773,
  [2253] = 1884,
  [2254] = 1950,
  [2255] = 1839,
  [2256] = 1948,
  [2257] = 1840,
  [2258] = 1841,
  [2259] = 1544,
  [2260] = 1816,
  [2261] = 1847,
  [2262] = 1848,
  [2263] = 1850,
  [2264] = 1852,
  [2265] = 1951,
  [2266] = 2266,
  [2267] = 1853,
  [2268] = 1854,
  [2269] = 1930,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 1835,
  [2273] = 1902,
  [2274] = 1837,
  [2275] = 1938,
  [2276] = 2276,
  [2277] = 1944,
  [2278] = 1946,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2051,
  [2282] = 1725,
  [2283] = 1886,
  [2284] = 2284,
  [2285] = 1689,
  [2286] = 1670,
  [2287] = 2287,
  [2288] = 1927,
  [2289] = 1867,
  [2290] = 1842,
  [2291] = 1813,
  [2292] = 1814,
  [2293] = 1585,
  [2294] = 1873,
  [2295] = 1541,
  [2296] = 1888,
  [2297] = 1942,
  [2298] = 2298,
  [2299] = 1874,
  [2300] = 1670,
  [2301] = 1692,
  [2302] = 1875,
  [2303] = 1876,
  [2304] = 1539,
  [2305] = 1543,
  [2306] = 1542,
  [2307] = 1545,
  [2308] = 1538,
  [2309] = 1859,
  [2310] = 1930,
  [2311] = 2181,
  [2312] = 1935,
  [2313] = 2313,
  [2314] = 1946,
  [2315] = 1928,
  [2316] = 1947,
  [2317] = 1938,
  [2318] = 1943,
  [2319] = 1903,
  [2320] = 1593,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 1947,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 1943,
  [2327] = 1951,
  [2328] = 1728,
  [2329] = 2191,
  [2330] = 2206,
  [2331] = 1944,
  [2332] = 1928,
  [2333] = 1773,
  [2334] = 2190,
  [2335] = 2200,
  [2336] = 2201,
  [2337] = 1944,
  [2338] = 1546,
  [2339] = 1725,
  [2340] = 1904,
  [2341] = 1927,
  [2342] = 1721,
  [2343] = 2175,
  [2344] = 1946,
  [2345] = 1722,
  [2346] = 1927,
  [2347] = 2347,
  [2348] = 1950,
  [2349] = 1948,
  [2350] = 2183,
  [2351] = 2193,
  [2352] = 2192,
  [2353] = 1950,
  [2354] = 1948,
  [2355] = 1935,
  [2356] = 1940,
  [2357] = 1940,
  [2358] = 1942,
  [2359] = 1592,
  [2360] = 2173,
  [2361] = 1951,
  [2362] = 1930,
  [2363] = 1938,
  [2364] = 2186,
  [2365] = 2365,
  [2366] = 1721,
  [2367] = 2367,
  [2368] = 1773,
  [2369] = 1942,
  [2370] = 1684,
  [2371] = 828,
  [2372] = 1689,
  [2373] = 2373,
  [2374] = 829,
  [2375] = 2050,
  [2376] = 1692,
  [2377] = 2377,
  [2378] = 1722,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 1725,
  [2383] = 1614,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 1947,
  [2388] = 2388,
  [2389] = 1721,
  [2390] = 1773,
  [2391] = 1722,
  [2392] = 1725,
  [2393] = 1784,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2396,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 1728,
  [2400] = 1818,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 1713,
  [2407] = 2407,
  [2408] = 1608,
  [2409] = 1874,
  [2410] = 2410,
  [2411] = 1877,
  [2412] = 2412,
  [2413] = 1620,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2419,
  [2420] = 1609,
  [2421] = 1610,
  [2422] = 1607,
  [2423] = 2423,
  [2424] = 1725,
  [2425] = 2425,
  [2426] = 2426,
  [2427] = 1613,
  [2428] = 1616,
  [2429] = 135,
  [2430] = 2430,
  [2431] = 2431,
  [2432] = 1618,
  [2433] = 1622,
  [2434] = 1728,
  [2435] = 2435,
  [2436] = 2436,
  [2437] = 1773,
  [2438] = 2050,
  [2439] = 2439,
  [2440] = 1875,
  [2441] = 2441,
  [2442] = 2442,
  [2443] = 2443,
  [2444] = 1721,
  [2445] = 1773,
  [2446] = 1722,
  [2447] = 1725,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 1721,
  [2451] = 2451,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 1842,
  [2455] = 2455,
  [2456] = 2456,
  [2457] = 1623,
  [2458] = 1615,
  [2459] = 2215,
  [2460] = 1612,
  [2461] = 2461,
  [2462] = 1606,
  [2463] = 2322,
  [2464] = 2464,
  [2465] = 2465,
  [2466] = 2466,
  [2467] = 1864,
  [2468] = 1865,
  [2469] = 1866,
  [2470] = 2470,
  [2471] = 2471,
  [2472] = 2271,
  [2473] = 2050,
  [2474] = 1870,
  [2475] = 1871,
  [2476] = 1872,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 1621,
  [2480] = 2480,
  [2481] = 2481,
  [2482] = 2482,
  [2483] = 1876,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 2486,
  [2487] = 1867,
  [2488] = 1878,
  [2489] = 1880,
  [2490] = 1881,
  [2491] = 1882,
  [2492] = 1883,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 1859,
  [2502] = 1837,
  [2503] = 1728,
  [2504] = 1884,
  [2505] = 2505,
  [2506] = 2506,
  [2507] = 1839,
  [2508] = 1840,
  [2509] = 1841,
  [2510] = 1847,
  [2511] = 1848,
  [2512] = 1850,
  [2513] = 1852,
  [2514] = 2514,
  [2515] = 1853,
  [2516] = 1854,
  [2517] = 1843,
  [2518] = 1849,
  [2519] = 136,
  [2520] = 1722,
  [2521] = 2521,
  [2522] = 1873,
  [2523] = 1879,
  [2524] = 2524,
  [2525] = 2525,
  [2526] = 2526,
  [2527] = 1611,
  [2528] = 2321,
  [2529] = 1885,
  [2530] = 1886,
  [2531] = 1887,
  [2532] = 1834,
  [2533] = 2533,
  [2534] = 1813,
  [2535] = 1938,
  [2536] = 1539,
  [2537] = 2537,
  [2538] = 1543,
  [2539] = 1542,
  [2540] = 1545,
  [2541] = 1538,
  [2542] = 1540,
  [2543] = 1544,
  [2544] = 1614,
  [2545] = 1940,
  [2546] = 1943,
  [2547] = 1603,
  [2548] = 1944,
  [2549] = 2051,
  [2550] = 2550,
  [2551] = 2116,
  [2552] = 1946,
  [2553] = 1930,
  [2554] = 1948,
  [2555] = 1899,
  [2556] = 1814,
  [2557] = 1790,
  [2558] = 2558,
  [2559] = 1901,
  [2560] = 1721,
  [2561] = 1773,
  [2562] = 1722,
  [2563] = 1725,
  [2564] = 2564,
  [2565] = 2565,
  [2566] = 1942,
  [2567] = 1816,
  [2568] = 2197,
  [2569] = 1928,
  [2570] = 1927,
  [2571] = 1935,
  [2572] = 1951,
  [2573] = 1950,
  [2574] = 2574,
  [2575] = 1938,
  [2576] = 1542,
  [2577] = 2183,
  [2578] = 2206,
  [2579] = 2186,
  [2580] = 2173,
  [2581] = 2175,
  [2582] = 1818,
  [2583] = 1539,
  [2584] = 1951,
  [2585] = 1930,
  [2586] = 2197,
  [2587] = 1928,
  [2588] = 1899,
  [2589] = 1935,
  [2590] = 1545,
  [2591] = 1603,
  [2592] = 1728,
  [2593] = 2321,
  [2594] = 1948,
  [2595] = 1692,
  [2596] = 1950,
  [2597] = 1948,
  [2598] = 1713,
  [2599] = 1927,
  [2600] = 1944,
  [2601] = 1901,
  [2602] = 1585,
  [2603] = 1951,
  [2604] = 1930,
  [2605] = 2322,
  [2606] = 1938,
  [2607] = 1944,
  [2608] = 1946,
  [2609] = 1927,
  [2610] = 2050,
  [2611] = 1814,
  [2612] = 1943,
  [2613] = 1899,
  [2614] = 2200,
  [2615] = 1888,
  [2616] = 1928,
  [2617] = 1946,
  [2618] = 2201,
  [2619] = 1538,
  [2620] = 1540,
  [2621] = 1784,
  [2622] = 1940,
  [2623] = 1943,
  [2624] = 1684,
  [2625] = 1544,
  [2626] = 1813,
  [2627] = 1721,
  [2628] = 1689,
  [2629] = 1950,
  [2630] = 1816,
  [2631] = 1901,
  [2632] = 1790,
  [2633] = 2190,
  [2634] = 2191,
  [2635] = 1773,
  [2636] = 1543,
  [2637] = 2192,
  [2638] = 2193,
  [2639] = 1722,
  [2640] = 1725,
  [2641] = 1935,
  [2642] = 2181,
  [2643] = 1940,
  [2644] = 1725,
  [2645] = 1886,
  [2646] = 1887,
  [2647] = 1834,
  [2648] = 1842,
  [2649] = 1843,
  [2650] = 1849,
  [2651] = 1867,
  [2652] = 1877,
  [2653] = 1722,
  [2654] = 2564,
  [2655] = 1888,
  [2656] = 2565,
  [2657] = 1902,
  [2658] = 1813,
  [2659] = 1814,
  [2660] = 2660,
  [2661] = 1947,
  [2662] = 1790,
  [2663] = 2564,
  [2664] = 2565,
  [2665] = 1721,
  [2666] = 1773,
  [2667] = 1885,
  [2668] = 1879,
  [2669] = 1816,
  [2670] = 1603,
  [2671] = 2321,
  [2672] = 1873,
  [2673] = 1874,
  [2674] = 1592,
  [2675] = 1875,
  [2676] = 1876,
  [2677] = 1884,
  [2678] = 1593,
  [2679] = 1839,
  [2680] = 2322,
  [2681] = 1840,
  [2682] = 1841,
  [2683] = 1847,
  [2684] = 1848,
  [2685] = 1850,
  [2686] = 1852,
  [2687] = 1603,
  [2688] = 1853,
  [2689] = 1854,
  [2690] = 2660,
  [2691] = 1835,
  [2692] = 1864,
  [2693] = 1865,
  [2694] = 1835,
  [2695] = 2660,
  [2696] = 1866,
  [2697] = 2660,
  [2698] = 1870,
  [2699] = 1871,
  [2700] = 1872,
  [2701] = 1878,
  [2702] = 1880,
  [2703] = 1947,
  [2704] = 1881,
  [2705] = 1882,
  [2706] = 1883,
  [2707] = 1837,
  [2708] = 1859,
  [2709] = 1911,
  [2710] = 1930,
  [2711] = 1938,
  [2712] = 1944,
  [2713] = 1946,
  [2714] = 1927,
  [2715] = 1947,
  [2716] = 1940,
  [2717] = 1943,
  [2718] = 1892,
  [2719] = 271,
  [2720] = 2720,
  [2721] = 2721,
  [2722] = 2197,
  [2723] = 1591,
  [2724] = 2724,
  [2725] = 2725,
  [2726] = 1813,
  [2727] = 1814,
  [2728] = 1888,
  [2729] = 2724,
  [2730] = 1790,
  [2731] = 1603,
  [2732] = 1948,
  [2733] = 1951,
  [2734] = 1539,
  [2735] = 1543,
  [2736] = 2724,
  [2737] = 1542,
  [2738] = 2738,
  [2739] = 1545,
  [2740] = 1538,
  [2741] = 1540,
  [2742] = 2724,
  [2743] = 1544,
  [2744] = 1901,
  [2745] = 2724,
  [2746] = 1905,
  [2747] = 1603,
  [2748] = 2724,
  [2749] = 2051,
  [2750] = 1900,
  [2751] = 2751,
  [2752] = 2752,
  [2753] = 1816,
  [2754] = 1950,
  [2755] = 1928,
  [2756] = 1899,
  [2757] = 1935,
  [2758] = 2724,
  [2759] = 274,
  [2760] = 1888,
  [2761] = 2116,
  [2762] = 2448,
  [2763] = 1542,
  [2764] = 1545,
  [2765] = 1538,
  [2766] = 2766,
  [2767] = 1540,
  [2768] = 2506,
  [2769] = 1722,
  [2770] = 2766,
  [2771] = 2771,
  [2772] = 2772,
  [2773] = 2773,
  [2774] = 2435,
  [2775] = 2116,
  [2776] = 2419,
  [2777] = 1544,
  [2778] = 2771,
  [2779] = 2181,
  [2780] = 2766,
  [2781] = 2771,
  [2782] = 2416,
  [2783] = 1814,
  [2784] = 1892,
  [2785] = 1725,
  [2786] = 2417,
  [2787] = 1790,
  [2788] = 2051,
  [2789] = 2116,
  [2790] = 2790,
  [2791] = 2791,
  [2792] = 2766,
  [2793] = 2771,
  [2794] = 1813,
  [2795] = 2795,
  [2796] = 2796,
  [2797] = 2797,
  [2798] = 2798,
  [2799] = 2799,
  [2800] = 2766,
  [2801] = 2771,
  [2802] = 2802,
  [2803] = 2190,
  [2804] = 2183,
  [2805] = 2766,
  [2806] = 1543,
  [2807] = 2807,
  [2808] = 2808,
  [2809] = 1902,
  [2810] = 2050,
  [2811] = 2191,
  [2812] = 2812,
  [2813] = 2813,
  [2814] = 2192,
  [2815] = 2193,
  [2816] = 2206,
  [2817] = 2817,
  [2818] = 2818,
  [2819] = 2819,
  [2820] = 2186,
  [2821] = 2821,
  [2822] = 2418,
  [2823] = 2200,
  [2824] = 2201,
  [2825] = 1721,
  [2826] = 1911,
  [2827] = 2524,
  [2828] = 2173,
  [2829] = 1773,
  [2830] = 1816,
  [2831] = 2322,
  [2832] = 2321,
  [2833] = 2766,
  [2834] = 1905,
  [2835] = 2175,
  [2836] = 2414,
  [2837] = 2771,
  [2838] = 2415,
  [2839] = 2051,
  [2840] = 1900,
  [2841] = 1539,
  [2842] = 2771,
  [2843] = 2843,
  [2844] = 2183,
  [2845] = 2564,
  [2846] = 1888,
  [2847] = 2565,
  [2848] = 2206,
  [2849] = 2186,
  [2850] = 1614,
  [2851] = 1870,
  [2852] = 2200,
  [2853] = 2201,
  [2854] = 1847,
  [2855] = 2855,
  [2856] = 1878,
  [2857] = 2857,
  [2858] = 2192,
  [2859] = 1947,
  [2860] = 2860,
  [2861] = 1864,
  [2862] = 2193,
  [2863] = 2860,
  [2864] = 1546,
  [2865] = 2173,
  [2866] = 2190,
  [2867] = 2175,
  [2868] = 2197,
  [2869] = 2181,
  [2870] = 2870,
  [2871] = 1839,
  [2872] = 1885,
  [2873] = 2191,
  [2874] = 1888,
  [2875] = 2200,
  [2876] = 2190,
  [2877] = 2860,
  [2878] = 2878,
  [2879] = 2169,
  [2880] = 2191,
  [2881] = 1905,
  [2882] = 2181,
  [2883] = 2878,
  [2884] = 2821,
  [2885] = 2860,
  [2886] = 2855,
  [2887] = 2887,
  [2888] = 2888,
  [2889] = 2185,
  [2890] = 2860,
  [2891] = 1900,
  [2892] = 2203,
  [2893] = 2772,
  [2894] = 2192,
  [2895] = 2193,
  [2896] = 1878,
  [2897] = 2888,
  [2898] = 2887,
  [2899] = 2878,
  [2900] = 2888,
  [2901] = 1541,
  [2902] = 2860,
  [2903] = 2790,
  [2904] = 2887,
  [2905] = 1885,
  [2906] = 1818,
  [2907] = 2888,
  [2908] = 2808,
  [2909] = 2791,
  [2910] = 2051,
  [2911] = 2773,
  [2912] = 2912,
  [2913] = 2795,
  [2914] = 2796,
  [2915] = 2817,
  [2916] = 2176,
  [2917] = 2201,
  [2918] = 2116,
  [2919] = 2912,
  [2920] = 2920,
  [2921] = 2878,
  [2922] = 2797,
  [2923] = 2798,
  [2924] = 1713,
  [2925] = 2194,
  [2926] = 2878,
  [2927] = 1847,
  [2928] = 1784,
  [2929] = 2206,
  [2930] = 1864,
  [2931] = 2186,
  [2932] = 2920,
  [2933] = 2878,
  [2934] = 2812,
  [2935] = 2480,
  [2936] = 1899,
  [2937] = 2887,
  [2938] = 1839,
  [2939] = 2920,
  [2940] = 2887,
  [2941] = 2920,
  [2942] = 2912,
  [2943] = 2878,
  [2944] = 2920,
  [2945] = 1541,
  [2946] = 2920,
  [2947] = 1901,
  [2948] = 2888,
  [2949] = 2813,
  [2950] = 2870,
  [2951] = 2887,
  [2952] = 1546,
  [2953] = 1901,
  [2954] = 2920,
  [2955] = 1911,
  [2956] = 2860,
  [2957] = 2183,
  [2958] = 2888,
  [2959] = 1870,
  [2960] = 2888,
  [2961] = 1892,
  [2962] = 2860,
  [2963] = 2799,
  [2964] = 2802,
  [2965] = 2173,
  [2966] = 2807,
  [2967] = 2175,
  [2968] = 2818,
  [2969] = 2887,
  [2970] = 2819,
  [2971] = 1899,
  [2972] = 2186,
  [2973] = 2973,
  [2974] = 2181,
  [2975] = 1590,
  [2976] = 1859,
  [2977] = 1818,
  [2978] = 1879,
  [2979] = 2183,
  [2980] = 2321,
  [2981] = 2860,
  [2982] = 1947,
  [2983] = 1902,
  [2984] = 2206,
  [2985] = 1546,
  [2986] = 1873,
  [2987] = 1874,
  [2988] = 1728,
  [2989] = 1875,
  [2990] = 1876,
  [2991] = 2860,
  [2992] = 1865,
  [2993] = 1866,
  [2994] = 2860,
  [2995] = 1784,
  [2996] = 1871,
  [2997] = 1872,
  [2998] = 2860,
  [2999] = 2999,
  [3000] = 1880,
  [3001] = 1881,
  [3002] = 1882,
  [3003] = 1883,
  [3004] = 2860,
  [3005] = 860,
  [3006] = 2790,
  [3007] = 2860,
  [3008] = 1837,
  [3009] = 3009,
  [3010] = 2537,
  [3011] = 3011,
  [3012] = 1884,
  [3013] = 2791,
  [3014] = 2173,
  [3015] = 1902,
  [3016] = 2190,
  [3017] = 2175,
  [3018] = 2795,
  [3019] = 1886,
  [3020] = 1887,
  [3021] = 2796,
  [3022] = 1834,
  [3023] = 2797,
  [3024] = 2798,
  [3025] = 1842,
  [3026] = 2799,
  [3027] = 1843,
  [3028] = 1849,
  [3029] = 2802,
  [3030] = 2807,
  [3031] = 2197,
  [3032] = 1867,
  [3033] = 2860,
  [3034] = 2772,
  [3035] = 1877,
  [3036] = 2773,
  [3037] = 2817,
  [3038] = 2818,
  [3039] = 2819,
  [3040] = 2808,
  [3041] = 2812,
  [3042] = 3011,
  [3043] = 2813,
  [3044] = 1713,
  [3045] = 1928,
  [3046] = 1840,
  [3047] = 1935,
  [3048] = 1841,
  [3049] = 1848,
  [3050] = 1850,
  [3051] = 2821,
  [3052] = 1852,
  [3053] = 2860,
  [3054] = 1853,
  [3055] = 1854,
  [3056] = 3011,
  [3057] = 1950,
  [3058] = 1948,
  [3059] = 1942,
  [3060] = 2191,
  [3061] = 828,
  [3062] = 2322,
  [3063] = 2973,
  [3064] = 3011,
  [3065] = 2247,
  [3066] = 3066,
  [3067] = 3011,
  [3068] = 1541,
  [3069] = 3011,
  [3070] = 2176,
  [3071] = 1951,
  [3072] = 1930,
  [3073] = 1938,
  [3074] = 1944,
  [3075] = 1946,
  [3076] = 2276,
  [3077] = 2194,
  [3078] = 829,
  [3079] = 2192,
  [3080] = 1927,
  [3081] = 3009,
  [3082] = 3066,
  [3083] = 2203,
  [3084] = 1940,
  [3085] = 1943,
  [3086] = 2270,
  [3087] = 2860,
  [3088] = 2860,
  [3089] = 3009,
  [3090] = 2210,
  [3091] = 1835,
  [3092] = 3066,
  [3093] = 3009,
  [3094] = 1546,
  [3095] = 3066,
  [3096] = 3096,
  [3097] = 2193,
  [3098] = 3066,
  [3099] = 3066,
  [3100] = 2185,
  [3101] = 3066,
  [3102] = 2169,
  [3103] = 3103,
  [3104] = 2217,
  [3105] = 2973,
  [3106] = 2200,
  [3107] = 2201,
  [3108] = 2222,
  [3109] = 3109,
  [3110] = 2798,
  [3111] = 1859,
  [3112] = 2812,
  [3113] = 1902,
  [3114] = 1879,
  [3115] = 1867,
  [3116] = 2407,
  [3117] = 1873,
  [3118] = 1877,
  [3119] = 3119,
  [3120] = 3120,
  [3121] = 1874,
  [3122] = 2407,
  [3123] = 1875,
  [3124] = 1876,
  [3125] = 1839,
  [3126] = 2790,
  [3127] = 1728,
  [3128] = 1684,
  [3129] = 1546,
  [3130] = 2407,
  [3131] = 1847,
  [3132] = 2999,
  [3133] = 2395,
  [3134] = 1870,
  [3135] = 2247,
  [3136] = 2379,
  [3137] = 1689,
  [3138] = 2791,
  [3139] = 2380,
  [3140] = 2325,
  [3141] = 1840,
  [3142] = 1865,
  [3143] = 1835,
  [3144] = 1866,
  [3145] = 2773,
  [3146] = 1871,
  [3147] = 2381,
  [3148] = 1872,
  [3149] = 1841,
  [3150] = 1901,
  [3151] = 1692,
  [3152] = 2270,
  [3153] = 2407,
  [3154] = 1848,
  [3155] = 2817,
  [3156] = 2384,
  [3157] = 1850,
  [3158] = 2795,
  [3159] = 2796,
  [3160] = 2797,
  [3161] = 2210,
  [3162] = 1878,
  [3163] = 2802,
  [3164] = 2807,
  [3165] = 2818,
  [3166] = 2819,
  [3167] = 2347,
  [3168] = 2407,
  [3169] = 1884,
  [3170] = 1899,
  [3171] = 2388,
  [3172] = 1852,
  [3173] = 1885,
  [3174] = 2313,
  [3175] = 1853,
  [3176] = 1880,
  [3177] = 2860,
  [3178] = 1881,
  [3179] = 2860,
  [3180] = 1882,
  [3181] = 2870,
  [3182] = 1883,
  [3183] = 2813,
  [3184] = 2821,
  [3185] = 1837,
  [3186] = 2377,
  [3187] = 1942,
  [3188] = 1854,
  [3189] = 2843,
  [3190] = 1541,
  [3191] = 1886,
  [3192] = 1887,
  [3193] = 2050,
  [3194] = 1834,
  [3195] = 1864,
  [3196] = 1842,
  [3197] = 2398,
  [3198] = 1843,
  [3199] = 2276,
  [3200] = 1849,
  [3201] = 2772,
  [3202] = 2217,
  [3203] = 2751,
  [3204] = 2808,
  [3205] = 2395,
  [3206] = 2222,
  [3207] = 2855,
  [3208] = 2799,
  [3209] = 2818,
  [3210] = 1623,
  [3211] = 1615,
  [3212] = 2407,
  [3213] = 2855,
  [3214] = 1612,
  [3215] = 3215,
  [3216] = 2860,
  [3217] = 1616,
  [3218] = 3218,
  [3219] = 135,
  [3220] = 3215,
  [3221] = 2398,
  [3222] = 1609,
  [3223] = 2860,
  [3224] = 2812,
  [3225] = 2414,
  [3226] = 1818,
  [3227] = 2514,
  [3228] = 2415,
  [3229] = 2416,
  [3230] = 3215,
  [3231] = 2224,
  [3232] = 2417,
  [3233] = 3233,
  [3234] = 2418,
  [3235] = 2870,
  [3236] = 3215,
  [3237] = 2197,
  [3238] = 2419,
  [3239] = 3215,
  [3240] = 1611,
  [3241] = 2505,
  [3242] = 2480,
  [3243] = 3233,
  [3244] = 3215,
  [3245] = 2279,
  [3246] = 1610,
  [3247] = 1607,
  [3248] = 829,
  [3249] = 2377,
  [3250] = 2280,
  [3251] = 2772,
  [3252] = 3252,
  [3253] = 2480,
  [3254] = 2435,
  [3255] = 2367,
  [3256] = 2237,
  [3257] = 3257,
  [3258] = 1606,
  [3259] = 1608,
  [3260] = 2313,
  [3261] = 2395,
  [3262] = 2287,
  [3263] = 2325,
  [3264] = 2386,
  [3265] = 136,
  [3266] = 2397,
  [3267] = 2298,
  [3268] = 1618,
  [3269] = 2574,
  [3270] = 2860,
  [3271] = 2407,
  [3272] = 3215,
  [3273] = 2860,
  [3274] = 3274,
  [3275] = 1613,
  [3276] = 2505,
  [3277] = 1622,
  [3278] = 2238,
  [3279] = 2821,
  [3280] = 2790,
  [3281] = 3252,
  [3282] = 3282,
  [3283] = 3283,
  [3284] = 2284,
  [3285] = 2218,
  [3286] = 2219,
  [3287] = 2791,
  [3288] = 2220,
  [3289] = 2381,
  [3290] = 3215,
  [3291] = 1725,
  [3292] = 3252,
  [3293] = 2514,
  [3294] = 2404,
  [3295] = 2860,
  [3296] = 2379,
  [3297] = 2347,
  [3298] = 2407,
  [3299] = 2860,
  [3300] = 1621,
  [3301] = 2321,
  [3302] = 1620,
  [3303] = 2322,
  [3304] = 2377,
  [3305] = 2772,
  [3306] = 2379,
  [3307] = 2380,
  [3308] = 2773,
  [3309] = 2381,
  [3310] = 2790,
  [3311] = 2791,
  [3312] = 2817,
  [3313] = 2384,
  [3314] = 2795,
  [3315] = 2796,
  [3316] = 2797,
  [3317] = 2798,
  [3318] = 2799,
  [3319] = 2802,
  [3320] = 2807,
  [3321] = 2324,
  [3322] = 2819,
  [3323] = 2388,
  [3324] = 2808,
  [3325] = 2812,
  [3326] = 2813,
  [3327] = 2821,
  [3328] = 2050,
  [3329] = 1713,
  [3330] = 2380,
  [3331] = 2817,
  [3332] = 2384,
  [3333] = 2398,
  [3334] = 2795,
  [3335] = 1546,
  [3336] = 2478,
  [3337] = 2796,
  [3338] = 828,
  [3339] = 2388,
  [3340] = 1722,
  [3341] = 2797,
  [3342] = 2798,
  [3343] = 1784,
  [3344] = 2478,
  [3345] = 3215,
  [3346] = 2799,
  [3347] = 2773,
  [3348] = 2802,
  [3349] = 2807,
  [3350] = 2818,
  [3351] = 2819,
  [3352] = 2808,
  [3353] = 2813,
  [3354] = 2284,
  [3355] = 2494,
  [3356] = 2451,
  [3357] = 1608,
  [3358] = 1872,
  [3359] = 135,
  [3360] = 2870,
  [3361] = 2197,
  [3362] = 1928,
  [3363] = 1935,
  [3364] = 2373,
  [3365] = 2480,
  [3366] = 2395,
  [3367] = 2276,
  [3368] = 1950,
  [3369] = 1948,
  [3370] = 2860,
  [3371] = 3371,
  [3372] = 3372,
  [3373] = 2461,
  [3374] = 1951,
  [3375] = 1930,
  [3376] = 2470,
  [3377] = 1938,
  [3378] = 1944,
  [3379] = 1946,
  [3380] = 2471,
  [3381] = 1609,
  [3382] = 1610,
  [3383] = 1607,
  [3384] = 2396,
  [3385] = 1927,
  [3386] = 2533,
  [3387] = 2217,
  [3388] = 2397,
  [3389] = 1940,
  [3390] = 2401,
  [3391] = 2481,
  [3392] = 2218,
  [3393] = 2219,
  [3394] = 2220,
  [3395] = 1943,
  [3396] = 2482,
  [3397] = 1886,
  [3398] = 2197,
  [3399] = 2324,
  [3400] = 1882,
  [3401] = 2423,
  [3402] = 2407,
  [3403] = 1848,
  [3404] = 1850,
  [3405] = 2860,
  [3406] = 1887,
  [3407] = 828,
  [3408] = 2855,
  [3409] = 1852,
  [3410] = 2521,
  [3411] = 1854,
  [3412] = 2425,
  [3413] = 1721,
  [3414] = 2404,
  [3415] = 1834,
  [3416] = 1942,
  [3417] = 2499,
  [3418] = 2365,
  [3419] = 1842,
  [3420] = 2448,
  [3421] = 2436,
  [3422] = 829,
  [3423] = 2514,
  [3424] = 2496,
  [3425] = 2426,
  [3426] = 2500,
  [3427] = 1843,
  [3428] = 2524,
  [3429] = 2298,
  [3430] = 1613,
  [3431] = 1616,
  [3432] = 1883,
  [3433] = 2497,
  [3434] = 2466,
  [3435] = 1541,
  [3436] = 2403,
  [3437] = 2405,
  [3438] = 2439,
  [3439] = 2495,
  [3440] = 1849,
  [3441] = 2449,
  [3442] = 1618,
  [3443] = 1622,
  [3444] = 2484,
  [3445] = 1840,
  [3446] = 2485,
  [3447] = 2486,
  [3448] = 1773,
  [3449] = 2386,
  [3450] = 1866,
  [3451] = 2441,
  [3452] = 2430,
  [3453] = 1835,
  [3454] = 2402,
  [3455] = 1899,
  [3456] = 1901,
  [3457] = 2224,
  [3458] = 1865,
  [3459] = 2860,
  [3460] = 1689,
  [3461] = 1880,
  [3462] = 2237,
  [3463] = 1692,
  [3464] = 1722,
  [3465] = 2442,
  [3466] = 2477,
  [3467] = 2464,
  [3468] = 1837,
  [3469] = 2443,
  [3470] = 2465,
  [3471] = 2210,
  [3472] = 1585,
  [3473] = 3371,
  [3474] = 1725,
  [3475] = 1611,
  [3476] = 2367,
  [3477] = 3372,
  [3478] = 2271,
  [3479] = 1606,
  [3480] = 2279,
  [3481] = 2280,
  [3482] = 2287,
  [3483] = 1841,
  [3484] = 2238,
  [3485] = 2860,
  [3486] = 3371,
  [3487] = 2860,
  [3488] = 1881,
  [3489] = 2051,
  [3490] = 2116,
  [3491] = 1859,
  [3492] = 3372,
  [3493] = 2222,
  [3494] = 2407,
  [3495] = 2478,
  [3496] = 2431,
  [3497] = 1867,
  [3498] = 2498,
  [3499] = 1877,
  [3500] = 2410,
  [3501] = 1621,
  [3502] = 2505,
  [3503] = 2452,
  [3504] = 1879,
  [3505] = 2453,
  [3506] = 2480,
  [3507] = 1902,
  [3508] = 136,
  [3509] = 2506,
  [3510] = 2412,
  [3511] = 1873,
  [3512] = 1874,
  [3513] = 1875,
  [3514] = 1876,
  [3515] = 2525,
  [3516] = 2526,
  [3517] = 1684,
  [3518] = 1620,
  [3519] = 2435,
  [3520] = 2455,
  [3521] = 2456,
  [3522] = 1623,
  [3523] = 1615,
  [3524] = 2215,
  [3525] = 1884,
  [3526] = 1612,
  [3527] = 2414,
  [3528] = 2493,
  [3529] = 2415,
  [3530] = 2416,
  [3531] = 2417,
  [3532] = 2418,
  [3533] = 2419,
  [3534] = 1871,
  [3535] = 2407,
  [3536] = 1853,
  [3537] = 2426,
  [3538] = 2466,
  [3539] = 1538,
  [3540] = 2506,
  [3541] = 2500,
  [3542] = 1540,
  [3543] = 2790,
  [3544] = 2419,
  [3545] = 2525,
  [3546] = 2526,
  [3547] = 2480,
  [3548] = 1544,
  [3549] = 2817,
  [3550] = 2384,
  [3551] = 1722,
  [3552] = 1609,
  [3553] = 2795,
  [3554] = 2796,
  [3555] = 2401,
  [3556] = 2797,
  [3557] = 2403,
  [3558] = 1610,
  [3559] = 2271,
  [3560] = 2402,
  [3561] = 2439,
  [3562] = 2798,
  [3563] = 2799,
  [3564] = 1607,
  [3565] = 2470,
  [3566] = 2325,
  [3567] = 2482,
  [3568] = 2480,
  [3569] = 136,
  [3570] = 2802,
  [3571] = 2365,
  [3572] = 2791,
  [3573] = 2495,
  [3574] = 2843,
  [3575] = 2521,
  [3576] = 2321,
  [3577] = 1725,
  [3578] = 2388,
  [3579] = 2431,
  [3580] = 2448,
  [3581] = 2405,
  [3582] = 2821,
  [3583] = 2430,
  [3584] = 2807,
  [3585] = 2423,
  [3586] = 2455,
  [3587] = 2478,
  [3588] = 1546,
  [3589] = 1611,
  [3590] = 2514,
  [3591] = 2812,
  [3592] = 2322,
  [3593] = 2498,
  [3594] = 2425,
  [3595] = 2818,
  [3596] = 2484,
  [3597] = 2485,
  [3598] = 2436,
  [3599] = 2486,
  [3600] = 1813,
  [3601] = 1814,
  [3602] = 2480,
  [3603] = 2410,
  [3604] = 135,
  [3605] = 2441,
  [3606] = 2808,
  [3607] = 2325,
  [3608] = 2200,
  [3609] = 2412,
  [3610] = 2201,
  [3611] = 2449,
  [3612] = 2456,
  [3613] = 2191,
  [3614] = 2192,
  [3615] = 2193,
  [3616] = 2181,
  [3617] = 1620,
  [3618] = 2183,
  [3619] = 2206,
  [3620] = 2186,
  [3621] = 2173,
  [3622] = 2175,
  [3623] = 1790,
  [3624] = 1621,
  [3625] = 2477,
  [3626] = 2407,
  [3627] = 2481,
  [3628] = 2493,
  [3629] = 3629,
  [3630] = 2494,
  [3631] = 2443,
  [3632] = 2813,
  [3633] = 1615,
  [3634] = 2453,
  [3635] = 2373,
  [3636] = 2496,
  [3637] = 2497,
  [3638] = 3638,
  [3639] = 2819,
  [3640] = 2396,
  [3641] = 2414,
  [3642] = 2215,
  [3643] = 2499,
  [3644] = 3644,
  [3645] = 1543,
  [3646] = 2377,
  [3647] = 2772,
  [3648] = 1613,
  [3649] = 1616,
  [3650] = 2451,
  [3651] = 2461,
  [3652] = 2415,
  [3653] = 2416,
  [3654] = 1539,
  [3655] = 1543,
  [3656] = 1606,
  [3657] = 1542,
  [3658] = 1542,
  [3659] = 2505,
  [3660] = 1608,
  [3661] = 1545,
  [3662] = 2379,
  [3663] = 2380,
  [3664] = 1546,
  [3665] = 2417,
  [3666] = 1545,
  [3667] = 2452,
  [3668] = 2773,
  [3669] = 1623,
  [3670] = 2524,
  [3671] = 2381,
  [3672] = 1538,
  [3673] = 1540,
  [3674] = 1612,
  [3675] = 3675,
  [3676] = 1544,
  [3677] = 1721,
  [3678] = 2480,
  [3679] = 2471,
  [3680] = 2418,
  [3681] = 1816,
  [3682] = 1773,
  [3683] = 2533,
  [3684] = 1618,
  [3685] = 2464,
  [3686] = 2465,
  [3687] = 1622,
  [3688] = 2442,
  [3689] = 2435,
  [3690] = 1539,
  [3691] = 3691,
  [3692] = 2190,
  [3693] = 3693,
  [3694] = 3694,
  [3695] = 1546,
  [3696] = 3696,
  [3697] = 3697,
  [3698] = 2397,
  [3699] = 3699,
  [3700] = 3697,
  [3701] = 3699,
  [3702] = 3699,
  [3703] = 3703,
  [3704] = 3371,
  [3705] = 3705,
  [3706] = 3103,
  [3707] = 3372,
  [3708] = 1901,
  [3709] = 1725,
  [3710] = 3697,
  [3711] = 3705,
  [3712] = 2423,
  [3713] = 3713,
  [3714] = 2870,
  [3715] = 3696,
  [3716] = 3705,
  [3717] = 3713,
  [3718] = 3694,
  [3719] = 2397,
  [3720] = 3705,
  [3721] = 3699,
  [3722] = 3713,
  [3723] = 3723,
  [3724] = 3705,
  [3725] = 3696,
  [3726] = 3713,
  [3727] = 1578,
  [3728] = 3705,
  [3729] = 3699,
  [3730] = 3713,
  [3731] = 3696,
  [3732] = 3705,
  [3733] = 3713,
  [3734] = 3705,
  [3735] = 3713,
  [3736] = 3699,
  [3737] = 1947,
  [3738] = 3694,
  [3739] = 3703,
  [3740] = 3705,
  [3741] = 3741,
  [3742] = 2466,
  [3743] = 3743,
  [3744] = 3696,
  [3745] = 3697,
  [3746] = 3697,
  [3747] = 3713,
  [3748] = 3748,
  [3749] = 1722,
  [3750] = 2379,
  [3751] = 1888,
  [3752] = 3697,
  [3753] = 3697,
  [3754] = 3699,
  [3755] = 2380,
  [3756] = 3697,
  [3757] = 3697,
  [3758] = 2443,
  [3759] = 1942,
  [3760] = 2384,
  [3761] = 3761,
  [3762] = 3696,
  [3763] = 3697,
  [3764] = 2855,
  [3765] = 3694,
  [3766] = 2381,
  [3767] = 3694,
  [3768] = 3696,
  [3769] = 3697,
  [3770] = 1899,
  [3771] = 2482,
  [3772] = 1721,
  [3773] = 3713,
  [3774] = 3699,
  [3775] = 3696,
  [3776] = 3697,
  [3777] = 3697,
  [3778] = 3697,
  [3779] = 3741,
  [3780] = 3697,
  [3781] = 3694,
  [3782] = 2377,
  [3783] = 3697,
  [3784] = 3703,
  [3785] = 3696,
  [3786] = 3741,
  [3787] = 3787,
  [3788] = 3697,
  [3789] = 3703,
  [3790] = 3741,
  [3791] = 1773,
  [3792] = 3703,
  [3793] = 3741,
  [3794] = 3699,
  [3795] = 3703,
  [3796] = 3741,
  [3797] = 2388,
  [3798] = 3109,
  [3799] = 3799,
  [3800] = 2497,
  [3801] = 2498,
  [3802] = 2494,
  [3803] = 2499,
  [3804] = 1622,
  [3805] = 2441,
  [3806] = 2500,
  [3807] = 2843,
  [3808] = 2524,
  [3809] = 2443,
  [3810] = 2464,
  [3811] = 2465,
  [3812] = 2452,
  [3813] = 2448,
  [3814] = 2466,
  [3815] = 2453,
  [3816] = 2423,
  [3817] = 1541,
  [3818] = 2050,
  [3819] = 3799,
  [3820] = 3283,
  [3821] = 2484,
  [3822] = 1892,
  [3823] = 1911,
  [3824] = 1905,
  [3825] = 3371,
  [3826] = 1900,
  [3827] = 2452,
  [3828] = 2453,
  [3829] = 2455,
  [3830] = 2481,
  [3831] = 2456,
  [3832] = 2426,
  [3833] = 2485,
  [3834] = 2486,
  [3835] = 3799,
  [3836] = 1623,
  [3837] = 2271,
  [3838] = 2215,
  [3839] = 1612,
  [3840] = 2426,
  [3841] = 2470,
  [3842] = 3799,
  [3843] = 2455,
  [3844] = 2456,
  [3845] = 2410,
  [3846] = 136,
  [3847] = 2471,
  [3848] = 3799,
  [3849] = 135,
  [3850] = 3799,
  [3851] = 2533,
  [3852] = 1615,
  [3853] = 2477,
  [3854] = 2495,
  [3855] = 2506,
  [3856] = 3799,
  [3857] = 1721,
  [3858] = 1773,
  [3859] = 2496,
  [3860] = 2425,
  [3861] = 2497,
  [3862] = 2477,
  [3863] = 1609,
  [3864] = 2441,
  [3865] = 2442,
  [3866] = 2498,
  [3867] = 2499,
  [3868] = 1613,
  [3869] = 3799,
  [3870] = 2451,
  [3871] = 1722,
  [3872] = 3372,
  [3873] = 1616,
  [3874] = 1725,
  [3875] = 1621,
  [3876] = 3799,
  [3877] = 2321,
  [3878] = 2322,
  [3879] = 3799,
  [3880] = 2481,
  [3881] = 3799,
  [3882] = 3799,
  [3883] = 3371,
  [3884] = 3372,
  [3885] = 2482,
  [3886] = 3799,
  [3887] = 2470,
  [3888] = 2442,
  [3889] = 2461,
  [3890] = 3799,
  [3891] = 3799,
  [3892] = 2412,
  [3893] = 2471,
  [3894] = 3799,
  [3895] = 1607,
  [3896] = 2464,
  [3897] = 2484,
  [3898] = 2465,
  [3899] = 2485,
  [3900] = 2425,
  [3901] = 2486,
  [3902] = 2533,
  [3903] = 1606,
  [3904] = 3799,
  [3905] = 2051,
  [3906] = 2451,
  [3907] = 1610,
  [3908] = 2461,
  [3909] = 2116,
  [3910] = 3799,
  [3911] = 3799,
  [3912] = 2500,
  [3913] = 2493,
  [3914] = 2494,
  [3915] = 1608,
  [3916] = 1611,
  [3917] = 1618,
  [3918] = 2495,
  [3919] = 2410,
  [3920] = 2412,
  [3921] = 1620,
  [3922] = 2496,
  [3923] = 2493,
  [3924] = 3924,
  [3925] = 1728,
  [3926] = 3926,
  [3927] = 3926,
  [3928] = 3928,
  [3929] = 1773,
  [3930] = 3930,
  [3931] = 1592,
  [3932] = 3930,
  [3933] = 1722,
  [3934] = 1911,
  [3935] = 3928,
  [3936] = 3926,
  [3937] = 1593,
  [3938] = 3930,
  [3939] = 2321,
  [3940] = 3930,
  [3941] = 3928,
  [3942] = 2200,
  [3943] = 2201,
  [3944] = 3928,
  [3945] = 3928,
  [3946] = 3926,
  [3947] = 2322,
  [3948] = 3928,
  [3949] = 1892,
  [3950] = 1905,
  [3951] = 2190,
  [3952] = 2191,
  [3953] = 1725,
  [3954] = 2192,
  [3955] = 2193,
  [3956] = 2181,
  [3957] = 3372,
  [3958] = 3926,
  [3959] = 2183,
  [3960] = 2206,
  [3961] = 2186,
  [3962] = 1546,
  [3963] = 3926,
  [3964] = 3930,
  [3965] = 1721,
  [3966] = 3966,
  [3967] = 3371,
  [3968] = 1900,
  [3969] = 3930,
  [3970] = 3928,
  [3971] = 2175,
  [3972] = 3966,
  [3973] = 3926,
  [3974] = 2173,
  [3975] = 3930,
  [3976] = 2217,
  [3977] = 3977,
  [3978] = 1591,
  [3979] = 1864,
  [3980] = 2197,
  [3981] = 3371,
  [3982] = 3982,
  [3983] = 3983,
  [3984] = 3983,
  [3985] = 1870,
  [3986] = 1901,
  [3987] = 1878,
  [3988] = 3977,
  [3989] = 3372,
  [3990] = 3371,
  [3991] = 3977,
  [3992] = 1590,
  [3993] = 2210,
  [3994] = 1839,
  [3995] = 3371,
  [3996] = 3372,
  [3997] = 3372,
  [3998] = 1899,
  [3999] = 3983,
  [4000] = 3372,
  [4001] = 2197,
  [4002] = 1885,
  [4003] = 1847,
  [4004] = 2222,
  [4005] = 3371,
  [4006] = 2276,
  [4007] = 2322,
  [4008] = 4008,
  [4009] = 4009,
  [4010] = 4010,
  [4011] = 4009,
  [4012] = 4012,
  [4013] = 1818,
  [4014] = 4009,
  [4015] = 4012,
  [4016] = 4010,
  [4017] = 4012,
  [4018] = 2394,
  [4019] = 1784,
  [4020] = 4008,
  [4021] = 4010,
  [4022] = 4009,
  [4023] = 4012,
  [4024] = 1713,
  [4025] = 4025,
  [4026] = 2050,
  [4027] = 4008,
  [4028] = 3748,
  [4029] = 4012,
  [4030] = 4009,
  [4031] = 4012,
  [4032] = 3371,
  [4033] = 4010,
  [4034] = 3372,
  [4035] = 2321,
  [4036] = 4008,
  [4037] = 4009,
  [4038] = 2197,
  [4039] = 4008,
  [4040] = 3371,
  [4041] = 3372,
  [4042] = 1899,
  [4043] = 3761,
  [4044] = 4010,
  [4045] = 4008,
  [4046] = 1901,
  [4047] = 1541,
  [4048] = 2385,
  [4049] = 4009,
  [4050] = 4008,
  [4051] = 4012,
  [4052] = 4010,
  [4053] = 4010,
  [4054] = 1865,
  [4055] = 1853,
  [4056] = 1854,
  [4057] = 2322,
  [4058] = 1585,
  [4059] = 1900,
  [4060] = 2321,
  [4061] = 1834,
  [4062] = 1842,
  [4063] = 1866,
  [4064] = 1840,
  [4065] = 1905,
  [4066] = 1549,
  [4067] = 1841,
  [4068] = 262,
  [4069] = 1592,
  [4070] = 1871,
  [4071] = 1872,
  [4072] = 3982,
  [4073] = 1614,
  [4074] = 1880,
  [4075] = 1881,
  [4076] = 245,
  [4077] = 1882,
  [4078] = 1877,
  [4079] = 1883,
  [4080] = 1843,
  [4081] = 1859,
  [4082] = 1875,
  [4083] = 1837,
  [4084] = 1593,
  [4085] = 3983,
  [4086] = 1892,
  [4087] = 1879,
  [4088] = 3977,
  [4089] = 1849,
  [4090] = 1848,
  [4091] = 3371,
  [4092] = 1867,
  [4093] = 3372,
  [4094] = 1850,
  [4095] = 1852,
  [4096] = 1884,
  [4097] = 1876,
  [4098] = 1886,
  [4099] = 248,
  [4100] = 1887,
  [4101] = 357,
  [4102] = 1873,
  [4103] = 1911,
  [4104] = 1874,
  [4105] = 266,
  [4106] = 338,
  [4107] = 3371,
  [4108] = 2796,
  [4109] = 2797,
  [4110] = 2798,
  [4111] = 2799,
  [4112] = 2802,
  [4113] = 2807,
  [4114] = 2818,
  [4115] = 2819,
  [4116] = 2808,
  [4117] = 2812,
  [4118] = 4118,
  [4119] = 2813,
  [4120] = 2821,
  [4121] = 1892,
  [4122] = 4122,
  [4123] = 4123,
  [4124] = 4124,
  [4125] = 4125,
  [4126] = 1541,
  [4127] = 4127,
  [4128] = 1578,
  [4129] = 4118,
  [4130] = 3977,
  [4131] = 1578,
  [4132] = 4132,
  [4133] = 1911,
  [4134] = 4134,
  [4135] = 2222,
  [4136] = 1905,
  [4137] = 4122,
  [4138] = 2276,
  [4139] = 4123,
  [4140] = 4124,
  [4141] = 3372,
  [4142] = 4125,
  [4143] = 1900,
  [4144] = 4144,
  [4145] = 3977,
  [4146] = 2448,
  [4147] = 3983,
  [4148] = 2210,
  [4149] = 4122,
  [4150] = 3371,
  [4151] = 4123,
  [4152] = 4124,
  [4153] = 4125,
  [4154] = 4144,
  [4155] = 3372,
  [4156] = 4156,
  [4157] = 4132,
  [4158] = 2772,
  [4159] = 2773,
  [4160] = 2524,
  [4161] = 2217,
  [4162] = 3372,
  [4163] = 2506,
  [4164] = 3983,
  [4165] = 4134,
  [4166] = 2817,
  [4167] = 2790,
  [4168] = 2791,
  [4169] = 3371,
  [4170] = 2795,
  [4171] = 2404,
  [4172] = 4172,
  [4173] = 4172,
  [4174] = 2215,
  [4175] = 1935,
  [4176] = 3977,
  [4177] = 4177,
  [4178] = 2386,
  [4179] = 4172,
  [4180] = 1950,
  [4181] = 1948,
  [4182] = 3983,
  [4183] = 2271,
  [4184] = 4184,
  [4185] = 2550,
  [4186] = 2574,
  [4187] = 2367,
  [4188] = 4188,
  [4189] = 2197,
  [4190] = 3371,
  [4191] = 4191,
  [4192] = 1951,
  [4193] = 1930,
  [4194] = 1938,
  [4195] = 1944,
  [4196] = 1946,
  [4197] = 2558,
  [4198] = 1927,
  [4199] = 2870,
  [4200] = 2050,
  [4201] = 2321,
  [4202] = 2322,
  [4203] = 1928,
  [4204] = 4204,
  [4205] = 2855,
  [4206] = 1940,
  [4207] = 1943,
  [4208] = 1947,
  [4209] = 1592,
  [4210] = 1593,
  [4211] = 3372,
  [4212] = 3371,
  [4213] = 3977,
  [4214] = 2215,
  [4215] = 3983,
  [4216] = 3372,
  [4217] = 1585,
  [4218] = 1728,
  [4219] = 4122,
  [4220] = 1623,
  [4221] = 1615,
  [4222] = 1612,
  [4223] = 4123,
  [4224] = 4124,
  [4225] = 4125,
  [4226] = 1546,
  [4227] = 1606,
  [4228] = 1608,
  [4229] = 1901,
  [4230] = 1613,
  [4231] = 1899,
  [4232] = 135,
  [4233] = 1616,
  [4234] = 3983,
  [4235] = 3983,
  [4236] = 136,
  [4237] = 1620,
  [4238] = 1614,
  [4239] = 1592,
  [4240] = 1618,
  [4241] = 1622,
  [4242] = 4156,
  [4243] = 2855,
  [4244] = 1621,
  [4245] = 3977,
  [4246] = 3977,
  [4247] = 1593,
  [4248] = 1611,
  [4249] = 4249,
  [4250] = 2870,
  [4251] = 1609,
  [4252] = 1610,
  [4253] = 3983,
  [4254] = 4156,
  [4255] = 3977,
  [4256] = 1607,
  [4257] = 2271,
  [4258] = 2797,
  [4259] = 3977,
  [4260] = 2795,
  [4261] = 4122,
  [4262] = 4123,
  [4263] = 4124,
  [4264] = 4125,
  [4265] = 2802,
  [4266] = 2773,
  [4267] = 1835,
  [4268] = 2821,
  [4269] = 2807,
  [4270] = 4270,
  [4271] = 4123,
  [4272] = 2819,
  [4273] = 2817,
  [4274] = 2798,
  [4275] = 1591,
  [4276] = 3983,
  [4277] = 2819,
  [4278] = 2795,
  [4279] = 2321,
  [4280] = 2050,
  [4281] = 1591,
  [4282] = 2791,
  [4283] = 2791,
  [4284] = 2813,
  [4285] = 2796,
  [4286] = 2798,
  [4287] = 4184,
  [4288] = 2799,
  [4289] = 1590,
  [4290] = 2802,
  [4291] = 2818,
  [4292] = 3371,
  [4293] = 2799,
  [4294] = 2772,
  [4295] = 4188,
  [4296] = 2322,
  [4297] = 4124,
  [4298] = 4122,
  [4299] = 3983,
  [4300] = 4125,
  [4301] = 3977,
  [4302] = 2818,
  [4303] = 4303,
  [4304] = 3372,
  [4305] = 2797,
  [4306] = 2808,
  [4307] = 2812,
  [4308] = 2197,
  [4309] = 2808,
  [4310] = 2772,
  [4311] = 2796,
  [4312] = 4312,
  [4313] = 2821,
  [4314] = 2807,
  [4315] = 2773,
  [4316] = 1590,
  [4317] = 2813,
  [4318] = 2812,
  [4319] = 2790,
  [4320] = 2790,
  [4321] = 2817,
  [4322] = 4322,
  [4323] = 4323,
  [4324] = 2276,
  [4325] = 4323,
  [4326] = 4326,
  [4327] = 4327,
  [4328] = 4323,
  [4329] = 2217,
  [4330] = 4323,
  [4331] = 4331,
  [4332] = 4323,
  [4333] = 4122,
  [4334] = 4323,
  [4335] = 4327,
  [4336] = 4323,
  [4337] = 4249,
  [4338] = 4327,
  [4339] = 4323,
  [4340] = 4340,
  [4341] = 2222,
  [4342] = 4342,
  [4343] = 4323,
  [4344] = 4323,
  [4345] = 4340,
  [4346] = 1813,
  [4347] = 1539,
  [4348] = 4327,
  [4349] = 4323,
  [4350] = 1543,
  [4351] = 1542,
  [4352] = 1545,
  [4353] = 1538,
  [4354] = 1814,
  [4355] = 1540,
  [4356] = 1947,
  [4357] = 1544,
  [4358] = 2116,
  [4359] = 1928,
  [4360] = 4331,
  [4361] = 4340,
  [4362] = 2855,
  [4363] = 4363,
  [4364] = 4327,
  [4365] = 4340,
  [4366] = 4340,
  [4367] = 4323,
  [4368] = 4363,
  [4369] = 2210,
  [4370] = 4323,
  [4371] = 1950,
  [4372] = 4372,
  [4373] = 3983,
  [4374] = 3977,
  [4375] = 1948,
  [4376] = 1816,
  [4377] = 4331,
  [4378] = 1603,
  [4379] = 1951,
  [4380] = 2870,
  [4381] = 1930,
  [4382] = 2051,
  [4383] = 1938,
  [4384] = 1728,
  [4385] = 4327,
  [4386] = 2050,
  [4387] = 1944,
  [4388] = 1946,
  [4389] = 1927,
  [4390] = 4331,
  [4391] = 4323,
  [4392] = 1940,
  [4393] = 1614,
  [4394] = 1943,
  [4395] = 4327,
  [4396] = 4340,
  [4397] = 4331,
  [4398] = 1790,
  [4399] = 4125,
  [4400] = 4400,
  [4401] = 4331,
  [4402] = 4323,
  [4403] = 4403,
  [4404] = 4123,
  [4405] = 4323,
  [4406] = 4124,
  [4407] = 4363,
  [4408] = 4323,
  [4409] = 1935,
  [4410] = 2377,
  [4411] = 4411,
  [4412] = 2798,
  [4413] = 4413,
  [4414] = 3977,
  [4415] = 4124,
  [4416] = 4122,
  [4417] = 4417,
  [4418] = 4418,
  [4419] = 2799,
  [4420] = 2381,
  [4421] = 2790,
  [4422] = 2802,
  [4423] = 2201,
  [4424] = 4424,
  [4425] = 1888,
  [4426] = 2807,
  [4427] = 2380,
  [4428] = 3983,
  [4429] = 2813,
  [4430] = 2818,
  [4431] = 4431,
  [4432] = 4432,
  [4433] = 4433,
  [4434] = 2173,
  [4435] = 2791,
  [4436] = 4125,
  [4437] = 4417,
  [4438] = 4123,
  [4439] = 4124,
  [4440] = 4440,
  [4441] = 2819,
  [4442] = 4122,
  [4443] = 4417,
  [4444] = 1901,
  [4445] = 4125,
  [4446] = 4446,
  [4447] = 4417,
  [4448] = 4417,
  [4449] = 4123,
  [4450] = 4450,
  [4451] = 4124,
  [4452] = 4452,
  [4453] = 4440,
  [4454] = 2322,
  [4455] = 3983,
  [4456] = 2808,
  [4457] = 4457,
  [4458] = 4417,
  [4459] = 2175,
  [4460] = 4460,
  [4461] = 4461,
  [4462] = 4462,
  [4463] = 2325,
  [4464] = 4440,
  [4465] = 4125,
  [4466] = 4457,
  [4467] = 4122,
  [4468] = 1784,
  [4469] = 4469,
  [4470] = 4470,
  [4471] = 2181,
  [4472] = 4418,
  [4473] = 2821,
  [4474] = 4474,
  [4475] = 4440,
  [4476] = 4476,
  [4477] = 4461,
  [4478] = 2379,
  [4479] = 2812,
  [4480] = 1899,
  [4481] = 4440,
  [4482] = 4417,
  [4483] = 4483,
  [4484] = 4123,
  [4485] = 4485,
  [4486] = 2773,
  [4487] = 4124,
  [4488] = 1614,
  [4489] = 4489,
  [4490] = 2772,
  [4491] = 2190,
  [4492] = 2773,
  [4493] = 4457,
  [4494] = 3233,
  [4495] = 2790,
  [4496] = 2384,
  [4497] = 4417,
  [4498] = 2388,
  [4499] = 4125,
  [4500] = 4457,
  [4501] = 2183,
  [4502] = 2797,
  [4503] = 2321,
  [4504] = 1728,
  [4505] = 2791,
  [4506] = 4440,
  [4507] = 2388,
  [4508] = 4417,
  [4509] = 1546,
  [4510] = 2817,
  [4511] = 2795,
  [4512] = 2796,
  [4513] = 2197,
  [4514] = 2191,
  [4515] = 2797,
  [4516] = 2798,
  [4517] = 2790,
  [4518] = 2791,
  [4519] = 2817,
  [4520] = 2795,
  [4521] = 2796,
  [4522] = 2797,
  [4523] = 2798,
  [4524] = 2799,
  [4525] = 2802,
  [4526] = 2807,
  [4527] = 2818,
  [4528] = 2819,
  [4529] = 2808,
  [4530] = 2812,
  [4531] = 2813,
  [4532] = 2821,
  [4533] = 2772,
  [4534] = 2799,
  [4535] = 2773,
  [4536] = 2802,
  [4537] = 2192,
  [4538] = 2807,
  [4539] = 2206,
  [4540] = 4540,
  [4541] = 2193,
  [4542] = 2818,
  [4543] = 4543,
  [4544] = 4417,
  [4545] = 2377,
  [4546] = 2186,
  [4547] = 2379,
  [4548] = 2819,
  [4549] = 2380,
  [4550] = 2381,
  [4551] = 2772,
  [4552] = 4457,
  [4553] = 4553,
  [4554] = 4440,
  [4555] = 4322,
  [4556] = 4556,
  [4557] = 4557,
  [4558] = 4127,
  [4559] = 4559,
  [4560] = 3977,
  [4561] = 4461,
  [4562] = 4461,
  [4563] = 4123,
  [4564] = 4417,
  [4565] = 2808,
  [4566] = 2812,
  [4567] = 2813,
  [4568] = 4568,
  [4569] = 2821,
  [4570] = 4156,
  [4571] = 4457,
  [4572] = 4122,
  [4573] = 4417,
  [4574] = 2817,
  [4575] = 4417,
  [4576] = 2384,
  [4577] = 2200,
  [4578] = 4474,
  [4579] = 2795,
  [4580] = 2796,
  [4581] = 4476,
  [4582] = 4461,
  [4583] = 4583,
  [4584] = 1885,
  [4585] = 4585,
  [4586] = 1886,
  [4587] = 4587,
  [4588] = 1887,
  [4589] = 4585,
  [4590] = 1834,
  [4591] = 4585,
  [4592] = 4585,
  [4593] = 4593,
  [4594] = 4594,
  [4595] = 4593,
  [4596] = 4596,
  [4597] = 1842,
  [4598] = 4598,
  [4599] = 4599,
  [4600] = 4600,
  [4601] = 1899,
  [4602] = 4602,
  [4603] = 4603,
  [4604] = 4604,
  [4605] = 1843,
  [4606] = 1849,
  [4607] = 4607,
  [4608] = 4608,
  [4609] = 4585,
  [4610] = 4610,
  [4611] = 4611,
  [4612] = 1859,
  [4613] = 4613,
  [4614] = 4585,
  [4615] = 4615,
  [4616] = 4616,
  [4617] = 4610,
  [4618] = 4607,
  [4619] = 4619,
  [4620] = 4620,
  [4621] = 4587,
  [4622] = 4613,
  [4623] = 4623,
  [4624] = 4594,
  [4625] = 4615,
  [4626] = 4610,
  [4627] = 4593,
  [4628] = 1837,
  [4629] = 4594,
  [4630] = 4610,
  [4631] = 4583,
  [4632] = 4632,
  [4633] = 1884,
  [4634] = 4600,
  [4635] = 4613,
  [4636] = 4602,
  [4637] = 4603,
  [4638] = 4122,
  [4639] = 4123,
  [4640] = 4124,
  [4641] = 4125,
  [4642] = 1873,
  [4643] = 4643,
  [4644] = 4599,
  [4645] = 4645,
  [4646] = 4583,
  [4647] = 4583,
  [4648] = 4585,
  [4649] = 4607,
  [4650] = 4594,
  [4651] = 4602,
  [4652] = 4610,
  [4653] = 1874,
  [4654] = 4616,
  [4655] = 4583,
  [4656] = 4585,
  [4657] = 4657,
  [4658] = 4599,
  [4659] = 1875,
  [4660] = 1867,
  [4661] = 4661,
  [4662] = 1864,
  [4663] = 1865,
  [4664] = 4607,
  [4665] = 4665,
  [4666] = 4657,
  [4667] = 1866,
  [4668] = 4599,
  [4669] = 4620,
  [4670] = 4587,
  [4671] = 4615,
  [4672] = 4613,
  [4673] = 4616,
  [4674] = 4674,
  [4675] = 4594,
  [4676] = 4599,
  [4677] = 4677,
  [4678] = 1877,
  [4679] = 4583,
  [4680] = 4583,
  [4681] = 4620,
  [4682] = 4607,
  [4683] = 1876,
  [4684] = 4599,
  [4685] = 4603,
  [4686] = 4616,
  [4687] = 4587,
  [4688] = 4688,
  [4689] = 4689,
  [4690] = 2397,
  [4691] = 4620,
  [4692] = 4632,
  [4693] = 1839,
  [4694] = 4632,
  [4695] = 1870,
  [4696] = 4607,
  [4697] = 4585,
  [4698] = 4698,
  [4699] = 1871,
  [4700] = 4593,
  [4701] = 1872,
  [4702] = 4620,
  [4703] = 4587,
  [4704] = 4616,
  [4705] = 4613,
  [4706] = 1879,
  [4707] = 4610,
  [4708] = 4600,
  [4709] = 4709,
  [4710] = 1878,
  [4711] = 4122,
  [4712] = 4607,
  [4713] = 4602,
  [4714] = 4603,
  [4715] = 4615,
  [4716] = 1840,
  [4717] = 4717,
  [4718] = 4123,
  [4719] = 4124,
  [4720] = 1841,
  [4721] = 4620,
  [4722] = 4125,
  [4723] = 4600,
  [4724] = 4613,
  [4725] = 4709,
  [4726] = 1847,
  [4727] = 4632,
  [4728] = 4728,
  [4729] = 4594,
  [4730] = 1880,
  [4731] = 1848,
  [4732] = 1850,
  [4733] = 1852,
  [4734] = 4674,
  [4735] = 4735,
  [4736] = 1881,
  [4737] = 3983,
  [4738] = 2870,
  [4739] = 1882,
  [4740] = 4585,
  [4741] = 4616,
  [4742] = 1901,
  [4743] = 1883,
  [4744] = 4744,
  [4745] = 4593,
  [4746] = 1853,
  [4747] = 1854,
  [4748] = 4599,
  [4749] = 2855,
  [4750] = 4620,
  [4751] = 4600,
  [4752] = 4752,
  [4753] = 4602,
  [4754] = 4603,
  [4755] = 4585,
  [4756] = 4587,
  [4757] = 4610,
  [4758] = 4616,
  [4759] = 4585,
  [4760] = 4616,
  [4761] = 4594,
  [4762] = 4762,
  [4763] = 4717,
  [4764] = 4764,
  [4765] = 4765,
  [4766] = 4766,
  [4767] = 4616,
  [4768] = 3977,
  [4769] = 4661,
  [4770] = 4665,
  [4771] = 4665,
  [4772] = 4665,
  [4773] = 4665,
  [4774] = 4665,
  [4775] = 4613,
  [4776] = 2247,
  [4777] = 2455,
  [4778] = 2506,
  [4779] = 4709,
  [4780] = 4780,
  [4781] = 2464,
  [4782] = 2465,
  [4783] = 2466,
  [4784] = 4784,
  [4785] = 4780,
  [4786] = 4786,
  [4787] = 4787,
  [4788] = 2410,
  [4789] = 4709,
  [4790] = 2456,
  [4791] = 4780,
  [4792] = 2470,
  [4793] = 2471,
  [4794] = 2533,
  [4795] = 2215,
  [4796] = 4780,
  [4797] = 2477,
  [4798] = 4780,
  [4799] = 3983,
  [4800] = 4780,
  [4801] = 4780,
  [4802] = 4709,
  [4803] = 2481,
  [4804] = 4709,
  [4805] = 2482,
  [4806] = 2484,
  [4807] = 2485,
  [4808] = 2486,
  [4809] = 2493,
  [4810] = 2494,
  [4811] = 2495,
  [4812] = 2496,
  [4813] = 4813,
  [4814] = 2498,
  [4815] = 2499,
  [4816] = 2425,
  [4817] = 2412,
  [4818] = 4122,
  [4819] = 4123,
  [4820] = 2451,
  [4821] = 4124,
  [4822] = 4125,
  [4823] = 4709,
  [4824] = 4709,
  [4825] = 2271,
  [4826] = 2116,
  [4827] = 2448,
  [4828] = 2441,
  [4829] = 2461,
  [4830] = 4830,
  [4831] = 2524,
  [4832] = 2423,
  [4833] = 2442,
  [4834] = 2452,
  [4835] = 2426,
  [4836] = 2051,
  [4837] = 3977,
  [4838] = 2453,
  [4839] = 2500,
  [4840] = 2443,
  [4841] = 2497,
  [4842] = 4842,
  [4843] = 4709,
  [4844] = 2193,
  [4845] = 3983,
  [4846] = 2321,
  [4847] = 1901,
  [4848] = 4125,
  [4849] = 4849,
  [4850] = 4850,
  [4851] = 4849,
  [4852] = 1784,
  [4853] = 2050,
  [4854] = 4123,
  [4855] = 4125,
  [4856] = 2200,
  [4857] = 4709,
  [4858] = 2175,
  [4859] = 1818,
  [4860] = 3977,
  [4861] = 4842,
  [4862] = 2190,
  [4863] = 2322,
  [4864] = 4709,
  [4865] = 1593,
  [4866] = 4709,
  [4867] = 2322,
  [4868] = 2181,
  [4869] = 4122,
  [4870] = 2173,
  [4871] = 4123,
  [4872] = 4709,
  [4873] = 4873,
  [4874] = 4124,
  [4875] = 4123,
  [4876] = 2321,
  [4877] = 2201,
  [4878] = 2191,
  [4879] = 4709,
  [4880] = 2197,
  [4881] = 4124,
  [4882] = 1592,
  [4883] = 4709,
  [4884] = 2183,
  [4885] = 2192,
  [4886] = 2206,
  [4887] = 4887,
  [4888] = 2186,
  [4889] = 4125,
  [4890] = 2321,
  [4891] = 4122,
  [4892] = 4709,
  [4893] = 4709,
  [4894] = 1713,
  [4895] = 1899,
  [4896] = 4709,
  [4897] = 2322,
  [4898] = 4873,
  [4899] = 1834,
  [4900] = 1867,
  [4901] = 4125,
  [4902] = 4709,
  [4903] = 1864,
  [4904] = 1854,
  [4905] = 1843,
  [4906] = 1870,
  [4907] = 4123,
  [4908] = 1842,
  [4909] = 4124,
  [4910] = 1849,
  [4911] = 4911,
  [4912] = 1871,
  [4913] = 1872,
  [4914] = 4914,
  [4915] = 1887,
  [4916] = 1840,
  [4917] = 1878,
  [4918] = 1880,
  [4919] = 1879,
  [4920] = 1881,
  [4921] = 1835,
  [4922] = 1885,
  [4923] = 1875,
  [4924] = 1884,
  [4925] = 1882,
  [4926] = 1865,
  [4927] = 1866,
  [4928] = 1883,
  [4929] = 1873,
  [4930] = 1847,
  [4931] = 1874,
  [4932] = 1848,
  [4933] = 1876,
  [4934] = 1850,
  [4935] = 1837,
  [4936] = 1886,
  [4937] = 1841,
  [4938] = 4709,
  [4939] = 4914,
  [4940] = 1877,
  [4941] = 1852,
  [4942] = 4942,
  [4943] = 4911,
  [4944] = 4122,
  [4945] = 1853,
  [4946] = 1839,
  [4947] = 1902,
  [4948] = 1859,
  [4949] = 2321,
  [4950] = 2322,
  [4951] = 4911,
  [4952] = 4911,
  [4953] = 4914,
  [4954] = 4914,
  [4955] = 4709,
  [4956] = 4914,
  [4957] = 4709,
  [4958] = 4123,
  [4959] = 4911,
  [4960] = 4709,
  [4961] = 2051,
  [4962] = 2116,
  [4963] = 4125,
  [4964] = 4124,
  [4965] = 4911,
  [4966] = 4914,
  [4967] = 4709,
  [4968] = 4911,
  [4969] = 4914,
  [4970] = 4911,
  [4971] = 4122,
  [4972] = 4709,
  [4973] = 4709,
  [4974] = 4914,
  [4975] = 2537,
  [4976] = 4124,
  [4977] = 4709,
  [4978] = 4978,
  [4979] = 4978,
  [4980] = 2197,
  [4981] = 4981,
  [4982] = 4981,
  [4983] = 4978,
  [4984] = 1946,
  [4985] = 1938,
  [4986] = 1593,
  [4987] = 4911,
  [4988] = 4978,
  [4989] = 4914,
  [4990] = 4978,
  [4991] = 4709,
  [4992] = 4914,
  [4993] = 4911,
  [4994] = 4981,
  [4995] = 1928,
  [4996] = 4123,
  [4997] = 4122,
  [4998] = 4709,
  [4999] = 4981,
  [5000] = 4914,
  [5001] = 4978,
  [5002] = 5002,
  [5003] = 4914,
  [5004] = 4911,
  [5005] = 4911,
  [5006] = 4981,
  [5007] = 1950,
  [5008] = 4981,
  [5009] = 4125,
  [5010] = 4978,
  [5011] = 4709,
  [5012] = 4981,
  [5013] = 4914,
  [5014] = 4978,
  [5015] = 1927,
  [5016] = 1951,
  [5017] = 4911,
  [5018] = 5018,
  [5019] = 3283,
  [5020] = 4911,
  [5021] = 1944,
  [5022] = 4981,
  [5023] = 1940,
  [5024] = 1943,
  [5025] = 4978,
  [5026] = 4911,
  [5027] = 4911,
  [5028] = 4911,
  [5029] = 1935,
  [5030] = 1930,
  [5031] = 4914,
  [5032] = 1592,
  [5033] = 4981,
  [5034] = 4911,
  [5035] = 1948,
  [5036] = 4709,
  [5037] = 4914,
  [5038] = 1614,
  [5039] = 4914,
  [5040] = 4914,
  [5041] = 4914,
  [5042] = 5042,
  [5043] = 5043,
  [5044] = 2192,
  [5045] = 2193,
  [5046] = 5046,
  [5047] = 5043,
  [5048] = 2181,
  [5049] = 5049,
  [5050] = 2183,
  [5051] = 2206,
  [5052] = 2186,
  [5053] = 2173,
  [5054] = 2175,
  [5055] = 5055,
  [5056] = 5056,
  [5057] = 5057,
  [5058] = 5057,
  [5059] = 5043,
  [5060] = 5043,
  [5061] = 5042,
  [5062] = 5057,
  [5063] = 5056,
  [5064] = 5056,
  [5065] = 5065,
  [5066] = 5046,
  [5067] = 2537,
  [5068] = 4911,
  [5069] = 5049,
  [5070] = 5070,
  [5071] = 5070,
  [5072] = 5055,
  [5073] = 5049,
  [5074] = 5049,
  [5075] = 5070,
  [5076] = 5070,
  [5077] = 5055,
  [5078] = 5055,
  [5079] = 5057,
  [5080] = 5043,
  [5081] = 5056,
  [5082] = 5057,
  [5083] = 5043,
  [5084] = 5046,
  [5085] = 5057,
  [5086] = 5065,
  [5087] = 5043,
  [5088] = 5057,
  [5089] = 5056,
  [5090] = 5065,
  [5091] = 5043,
  [5092] = 5042,
  [5093] = 5057,
  [5094] = 5046,
  [5095] = 5043,
  [5096] = 5042,
  [5097] = 5065,
  [5098] = 5046,
  [5099] = 5065,
  [5100] = 4914,
  [5101] = 5056,
  [5102] = 5043,
  [5103] = 5055,
  [5104] = 5057,
  [5105] = 5070,
  [5106] = 5057,
  [5107] = 5043,
  [5108] = 5056,
  [5109] = 5057,
  [5110] = 5043,
  [5111] = 5056,
  [5112] = 5049,
  [5113] = 5070,
  [5114] = 2537,
  [5115] = 5057,
  [5116] = 5049,
  [5117] = 5070,
  [5118] = 5055,
  [5119] = 5049,
  [5120] = 5042,
  [5121] = 5046,
  [5122] = 5057,
  [5123] = 5065,
  [5124] = 5043,
  [5125] = 5043,
  [5126] = 5056,
  [5127] = 5057,
  [5128] = 5056,
  [5129] = 5043,
  [5130] = 5057,
  [5131] = 5056,
  [5132] = 5056,
  [5133] = 4911,
  [5134] = 5042,
  [5135] = 5055,
  [5136] = 5057,
  [5137] = 5057,
  [5138] = 4914,
  [5139] = 5056,
  [5140] = 5043,
  [5141] = 5056,
  [5142] = 5043,
  [5143] = 5042,
  [5144] = 5057,
  [5145] = 5056,
  [5146] = 2200,
  [5147] = 2201,
  [5148] = 5056,
  [5149] = 5046,
  [5150] = 5065,
  [5151] = 5056,
  [5152] = 5043,
  [5153] = 2190,
  [5154] = 2191,
  [5155] = 5056,
  [5156] = 5156,
  [5157] = 5156,
  [5158] = 5156,
  [5159] = 5159,
  [5160] = 5160,
  [5161] = 5156,
  [5162] = 5160,
  [5163] = 5156,
  [5164] = 5156,
  [5165] = 4911,
  [5166] = 5166,
  [5167] = 5160,
  [5168] = 5168,
  [5169] = 5159,
  [5170] = 5159,
  [5171] = 5159,
  [5172] = 5159,
  [5173] = 5156,
  [5174] = 5174,
  [5175] = 5159,
  [5176] = 5156,
  [5177] = 5159,
  [5178] = 5159,
  [5179] = 4911,
  [5180] = 5180,
  [5181] = 4914,
  [5182] = 5160,
  [5183] = 5159,
  [5184] = 5180,
  [5185] = 5160,
  [5186] = 5174,
  [5187] = 5159,
  [5188] = 5160,
  [5189] = 5156,
  [5190] = 5156,
  [5191] = 5174,
  [5192] = 4914,
  [5193] = 5193,
  [5194] = 5156,
  [5195] = 5159,
  [5196] = 5180,
  [5197] = 5174,
  [5198] = 4914,
  [5199] = 5159,
  [5200] = 4911,
  [5201] = 5156,
  [5202] = 5156,
  [5203] = 4914,
  [5204] = 4911,
  [5205] = 5156,
  [5206] = 5174,
  [5207] = 5159,
  [5208] = 5174,
  [5209] = 5180,
  [5210] = 4914,
  [5211] = 5159,
  [5212] = 5159,
  [5213] = 5159,
  [5214] = 5160,
  [5215] = 5180,
  [5216] = 5159,
  [5217] = 5217,
  [5218] = 5160,
  [5219] = 4911,
  [5220] = 5156,
  [5221] = 5174,
  [5222] = 5156,
  [5223] = 4914,
  [5224] = 5159,
  [5225] = 5156,
  [5226] = 5160,
  [5227] = 5174,
  [5228] = 5228,
  [5229] = 4911,
  [5230] = 5174,
  [5231] = 5159,
  [5232] = 5156,
  [5233] = 5159,
  [5234] = 5234,
  [5235] = 4911,
  [5236] = 4914,
  [5237] = 4911,
  [5238] = 4914,
  [5239] = 5239,
  [5240] = 5240,
  [5241] = 5241,
  [5242] = 5242,
  [5243] = 1947,
  [5244] = 5244,
  [5245] = 5245,
  [5246] = 5246,
  [5247] = 5247,
  [5248] = 5248,
  [5249] = 5242,
  [5250] = 5240,
  [5251] = 5246,
  [5252] = 5252,
  [5253] = 4911,
  [5254] = 4914,
  [5255] = 4911,
  [5256] = 4914,
  [5257] = 5242,
  [5258] = 1614,
  [5259] = 5240,
  [5260] = 5246,
  [5261] = 4914,
  [5262] = 5252,
  [5263] = 5242,
  [5264] = 5240,
  [5265] = 5246,
  [5266] = 5252,
  [5267] = 3761,
  [5268] = 3748,
  [5269] = 5242,
  [5270] = 5246,
  [5271] = 5252,
  [5272] = 5242,
  [5273] = 5246,
  [5274] = 5252,
  [5275] = 5242,
  [5276] = 5246,
  [5277] = 5245,
  [5278] = 5247,
  [5279] = 5252,
  [5280] = 5248,
  [5281] = 5281,
  [5282] = 4911,
  [5283] = 5252,
  [5284] = 5247,
  [5285] = 3103,
  [5286] = 5248,
  [5287] = 5245,
  [5288] = 5245,
  [5289] = 5247,
  [5290] = 5247,
  [5291] = 5245,
  [5292] = 5247,
  [5293] = 5245,
  [5294] = 5248,
  [5295] = 5248,
  [5296] = 5248,
  [5297] = 5245,
  [5298] = 5247,
  [5299] = 5248,
  [5300] = 5248,
  [5301] = 5247,
  [5302] = 5245,
  [5303] = 5248,
  [5304] = 5245,
  [5305] = 5247,
  [5306] = 5245,
  [5307] = 5247,
  [5308] = 5248,
  [5309] = 5245,
  [5310] = 5247,
  [5311] = 5245,
  [5312] = 5247,
  [5313] = 5248,
  [5314] = 5245,
  [5315] = 5247,
  [5316] = 5248,
  [5317] = 5245,
  [5318] = 5247,
  [5319] = 5248,
  [5320] = 5248,
  [5321] = 5245,
  [5322] = 5247,
  [5323] = 5248,
  [5324] = 5245,
  [5325] = 5247,
  [5326] = 5248,
  [5327] = 3109,
  [5328] = 5245,
  [5329] = 5247,
  [5330] = 5248,
  [5331] = 5245,
  [5332] = 5247,
  [5333] = 5248,
  [5334] = 5334,
  [5335] = 5245,
  [5336] = 5247,
  [5337] = 5334,
  [5338] = 5245,
  [5339] = 5334,
  [5340] = 5247,
  [5341] = 5334,
  [5342] = 5248,
  [5343] = 5248,
  [5344] = 5247,
  [5345] = 5345,
  [5346] = 5247,
  [5347] = 5248,
  [5348] = 5245,
  [5349] = 5247,
  [5350] = 5248,
  [5351] = 5351,
  [5352] = 5345,
  [5353] = 5351,
  [5354] = 5351,
  [5355] = 5351,
  [5356] = 5245,
  [5357] = 5345,
  [5358] = 5245,
  [5359] = 5247,
  [5360] = 5248,
  [5361] = 5245,
  [5362] = 5245,
  [5363] = 5247,
  [5364] = 5248,
  [5365] = 5351,
  [5366] = 5245,
  [5367] = 5351,
  [5368] = 5248,
  [5369] = 5247,
  [5370] = 5248,
  [5371] = 5351,
  [5372] = 5248,
  [5373] = 5247,
  [5374] = 5248,
  [5375] = 5245,
  [5376] = 5376,
  [5377] = 5247,
  [5378] = 5376,
  [5379] = 5248,
  [5380] = 5245,
  [5381] = 5381,
  [5382] = 5245,
  [5383] = 5247,
  [5384] = 5384,
  [5385] = 5248,
  [5386] = 5245,
  [5387] = 5247,
  [5388] = 5388,
  [5389] = 5376,
  [5390] = 5248,
  [5391] = 5247,
  [5392] = 5245,
  [5393] = 5393,
  [5394] = 5393,
  [5395] = 5395,
  [5396] = 5395,
  [5397] = 5393,
  [5398] = 5393,
  [5399] = 5395,
  [5400] = 5395,
  [5401] = 5395,
  [5402] = 5395,
  [5403] = 5393,
  [5404] = 5395,
  [5405] = 5393,
  [5406] = 5345,
  [5407] = 5407,
  [5408] = 5393,
  [5409] = 5395,
  [5410] = 5393,
  [5411] = 5395,
  [5412] = 5393,
  [5413] = 5393,
  [5414] = 5395,
  [5415] = 5395,
  [5416] = 5393,
  [5417] = 5417,
  [5418] = 5418,
  [5419] = 5419,
  [5420] = 5420,
  [5421] = 5417,
  [5422] = 5422,
  [5423] = 5417,
  [5424] = 5422,
  [5425] = 2215,
  [5426] = 5422,
  [5427] = 2271,
  [5428] = 5384,
  [5429] = 5422,
  [5430] = 5422,
  [5431] = 5422,
  [5432] = 5417,
  [5433] = 5422,
  [5434] = 5434,
  [5435] = 5417,
  [5436] = 5422,
  [5437] = 5434,
  [5438] = 5438,
  [5439] = 5417,
  [5440] = 5422,
  [5441] = 5417,
  [5442] = 5442,
  [5443] = 5434,
  [5444] = 5434,
  [5445] = 5422,
  [5446] = 5446,
  [5447] = 5447,
  [5448] = 5418,
  [5449] = 5434,
  [5450] = 5419,
  [5451] = 5417,
  [5452] = 5420,
  [5453] = 5447,
  [5454] = 5417,
  [5455] = 5422,
  [5456] = 5422,
  [5457] = 5422,
  [5458] = 5458,
  [5459] = 5434,
  [5460] = 5460,
  [5461] = 5417,
  [5462] = 5460,
  [5463] = 5345,
  [5464] = 5417,
  [5465] = 5422,
  [5466] = 5417,
  [5467] = 5422,
  [5468] = 5381,
  [5469] = 5434,
  [5470] = 5345,
  [5471] = 5471,
  [5472] = 5434,
  [5473] = 5417,
  [5474] = 5422,
  [5475] = 5417,
  [5476] = 5417,
  [5477] = 5417,
  [5478] = 5460,
  [5479] = 5446,
  [5480] = 5434,
  [5481] = 5422,
  [5482] = 5434,
  [5483] = 5417,
  [5484] = 5484,
  [5485] = 5485,
  [5486] = 5486,
  [5487] = 5484,
  [5488] = 5485,
  [5489] = 5489,
  [5490] = 1615,
  [5491] = 5419,
  [5492] = 1606,
  [5493] = 1608,
  [5494] = 5494,
  [5495] = 5495,
  [5496] = 5496,
  [5497] = 5486,
  [5498] = 5498,
  [5499] = 5495,
  [5500] = 5496,
  [5501] = 5495,
  [5502] = 5486,
  [5503] = 1621,
  [5504] = 5484,
  [5505] = 5485,
  [5506] = 5506,
  [5507] = 5489,
  [5508] = 5484,
  [5509] = 5495,
  [5510] = 5496,
  [5511] = 5484,
  [5512] = 5485,
  [5513] = 5489,
  [5514] = 5447,
  [5515] = 5486,
  [5516] = 5485,
  [5517] = 5506,
  [5518] = 5495,
  [5519] = 5496,
  [5520] = 2271,
  [5521] = 5484,
  [5522] = 5485,
  [5523] = 5489,
  [5524] = 5524,
  [5525] = 5498,
  [5526] = 5484,
  [5527] = 5485,
  [5528] = 5506,
  [5529] = 5495,
  [5530] = 5496,
  [5531] = 5484,
  [5532] = 5485,
  [5533] = 5489,
  [5534] = 5447,
  [5535] = 5495,
  [5536] = 5536,
  [5537] = 5496,
  [5538] = 5506,
  [5539] = 5495,
  [5540] = 5496,
  [5541] = 5484,
  [5542] = 5485,
  [5543] = 5489,
  [5544] = 5418,
  [5545] = 5506,
  [5546] = 5546,
  [5547] = 5506,
  [5548] = 5489,
  [5549] = 5489,
  [5550] = 5550,
  [5551] = 5506,
  [5552] = 5489,
  [5553] = 5553,
  [5554] = 5419,
  [5555] = 5420,
  [5556] = 5556,
  [5557] = 5484,
  [5558] = 5485,
  [5559] = 5495,
  [5560] = 5496,
  [5561] = 5506,
  [5562] = 5495,
  [5563] = 5484,
  [5564] = 5485,
  [5565] = 5496,
  [5566] = 5489,
  [5567] = 5495,
  [5568] = 5496,
  [5569] = 5496,
  [5570] = 5484,
  [5571] = 5485,
  [5572] = 5489,
  [5573] = 5495,
  [5574] = 5496,
  [5575] = 5484,
  [5576] = 5485,
  [5577] = 1623,
  [5578] = 2215,
  [5579] = 1612,
  [5580] = 5546,
  [5581] = 5546,
  [5582] = 5489,
  [5583] = 5495,
  [5584] = 5496,
  [5585] = 5486,
  [5586] = 5495,
  [5587] = 5438,
  [5588] = 5496,
  [5589] = 5484,
  [5590] = 5485,
  [5591] = 5591,
  [5592] = 5506,
  [5593] = 5524,
  [5594] = 136,
  [5595] = 135,
  [5596] = 5489,
  [5597] = 5495,
  [5598] = 5496,
  [5599] = 5489,
  [5600] = 5484,
  [5601] = 5485,
  [5602] = 5489,
  [5603] = 5446,
  [5604] = 1611,
  [5605] = 1620,
  [5606] = 5606,
  [5607] = 5495,
  [5608] = 5496,
  [5609] = 1609,
  [5610] = 1610,
  [5611] = 1607,
  [5612] = 5495,
  [5613] = 5496,
  [5614] = 5489,
  [5615] = 5446,
  [5616] = 5418,
  [5617] = 5486,
  [5618] = 1613,
  [5619] = 5619,
  [5620] = 5620,
  [5621] = 5420,
  [5622] = 1616,
  [5623] = 5484,
  [5624] = 5485,
  [5625] = 1618,
  [5626] = 1622,
  [5627] = 5506,
  [5628] = 5345,
  [5629] = 5495,
  [5630] = 5496,
  [5631] = 5506,
  [5632] = 5486,
  [5633] = 5489,
  [5634] = 5485,
  [5635] = 5484,
  [5636] = 5524,
  [5637] = 5498,
  [5638] = 5484,
  [5639] = 5485,
  [5640] = 5489,
  [5641] = 5641,
  [5642] = 5642,
  [5643] = 5643,
  [5644] = 5644,
  [5645] = 5645,
  [5646] = 5646,
  [5647] = 5641,
  [5648] = 5648,
  [5649] = 5649,
  [5650] = 5650,
  [5651] = 5651,
  [5652] = 5652,
  [5653] = 5653,
  [5654] = 5654,
  [5655] = 5655,
  [5656] = 5656,
  [5657] = 5657,
  [5658] = 5658,
  [5659] = 5654,
  [5660] = 5660,
  [5661] = 5661,
  [5662] = 5653,
  [5663] = 5655,
  [5664] = 5658,
  [5665] = 5660,
  [5666] = 5666,
  [5667] = 5667,
  [5668] = 5650,
  [5669] = 5653,
  [5670] = 5655,
  [5671] = 5658,
  [5672] = 5660,
  [5673] = 5673,
  [5674] = 2855,
  [5675] = 5651,
  [5676] = 5654,
  [5677] = 5653,
  [5678] = 5655,
  [5679] = 5658,
  [5680] = 5660,
  [5681] = 5641,
  [5682] = 5641,
  [5683] = 5345,
  [5684] = 5651,
  [5685] = 5654,
  [5686] = 5686,
  [5687] = 2247,
  [5688] = 5442,
  [5689] = 5651,
  [5690] = 5641,
  [5691] = 5651,
  [5692] = 5345,
  [5693] = 5651,
  [5694] = 5644,
  [5695] = 5641,
  [5696] = 5650,
  [5697] = 5697,
  [5698] = 5651,
  [5699] = 5699,
  [5700] = 5700,
  [5701] = 5653,
  [5702] = 5654,
  [5703] = 5655,
  [5704] = 5704,
  [5705] = 5705,
  [5706] = 5658,
  [5707] = 5707,
  [5708] = 5708,
  [5709] = 5660,
  [5710] = 5710,
  [5711] = 5711,
  [5712] = 5712,
  [5713] = 5653,
  [5714] = 5655,
  [5715] = 5658,
  [5716] = 5660,
  [5717] = 5717,
  [5718] = 5718,
  [5719] = 5719,
  [5720] = 5720,
  [5721] = 5656,
  [5722] = 5722,
  [5723] = 5650,
  [5724] = 5700,
  [5725] = 5654,
  [5726] = 5704,
  [5727] = 5707,
  [5728] = 5644,
  [5729] = 5708,
  [5730] = 5710,
  [5731] = 5731,
  [5732] = 5650,
  [5733] = 5458,
  [5734] = 5641,
  [5735] = 5644,
  [5736] = 5650,
  [5737] = 5654,
  [5738] = 5711,
  [5739] = 5717,
  [5740] = 5345,
  [5741] = 5718,
  [5742] = 5719,
  [5743] = 5720,
  [5744] = 5644,
  [5745] = 5644,
  [5746] = 5650,
  [5747] = 5471,
  [5748] = 5651,
  [5749] = 5641,
  [5750] = 5654,
  [5751] = 5751,
  [5752] = 5644,
  [5753] = 5345,
  [5754] = 5650,
  [5755] = 5755,
  [5756] = 5644,
  [5757] = 5650,
  [5758] = 5712,
  [5759] = 5651,
  [5760] = 5641,
  [5761] = 5651,
  [5762] = 5652,
  [5763] = 5654,
  [5764] = 5764,
  [5765] = 5765,
  [5766] = 5766,
  [5767] = 5767,
  [5768] = 5768,
  [5769] = 5641,
  [5770] = 5666,
  [5771] = 5771,
  [5772] = 5654,
  [5773] = 5654,
  [5774] = 5774,
  [5775] = 5654,
  [5776] = 5641,
  [5777] = 5712,
  [5778] = 5652,
  [5779] = 5712,
  [5780] = 5780,
  [5781] = 5654,
  [5782] = 5782,
  [5783] = 5783,
  [5784] = 5784,
  [5785] = 5641,
  [5786] = 5651,
  [5787] = 5651,
  [5788] = 5654,
  [5789] = 5641,
  [5790] = 5651,
  [5791] = 5644,
  [5792] = 5792,
  [5793] = 5793,
  [5794] = 5794,
  [5795] = 2247,
  [5796] = 5796,
  [5797] = 5765,
  [5798] = 5798,
  [5799] = 5799,
  [5800] = 2395,
  [5801] = 5798,
  [5802] = 5731,
  [5803] = 5803,
  [5804] = 5804,
  [5805] = 5805,
  [5806] = 5697,
  [5807] = 5796,
  [5808] = 5699,
  [5809] = 1901,
  [5810] = 5794,
  [5811] = 5705,
  [5812] = 5812,
  [5813] = 5813,
  [5814] = 5799,
  [5815] = 5815,
  [5816] = 5816,
  [5817] = 1899,
  [5818] = 5818,
  [5819] = 5819,
  [5820] = 5820,
  [5821] = 5646,
  [5822] = 5822,
  [5823] = 5766,
  [5824] = 5649,
  [5825] = 5767,
  [5826] = 5645,
  [5827] = 5827,
  [5828] = 2855,
  [5829] = 5829,
  [5830] = 5830,
  [5831] = 5831,
  [5832] = 5832,
  [5833] = 5774,
  [5834] = 5780,
  [5835] = 5835,
  [5836] = 5836,
  [5837] = 5805,
  [5838] = 5796,
  [5839] = 5839,
  [5840] = 5840,
  [5841] = 5841,
  [5842] = 5722,
  [5843] = 5843,
  [5844] = 5805,
  [5845] = 5799,
  [5846] = 5846,
  [5847] = 5796,
  [5848] = 5794,
  [5849] = 5849,
  [5850] = 5796,
  [5851] = 5345,
  [5852] = 5794,
  [5853] = 5673,
  [5854] = 5642,
  [5855] = 5855,
  [5856] = 5643,
  [5857] = 5805,
  [5858] = 5796,
  [5859] = 5859,
  [5860] = 5796,
  [5861] = 5345,
  [5862] = 5862,
  [5863] = 5794,
  [5864] = 5864,
  [5865] = 5771,
  [5866] = 5866,
  [5867] = 5867,
  [5868] = 5794,
  [5869] = 5869,
  [5870] = 5648,
  [5871] = 5793,
  [5872] = 5872,
  [5873] = 5794,
  [5874] = 5874,
  [5875] = 5875,
  [5876] = 5876,
  [5877] = 5877,
  [5878] = 5799,
  [5879] = 5879,
  [5880] = 5798,
  [5881] = 5655,
  [5882] = 5655,
  [5883] = 5658,
  [5884] = 1610,
  [5885] = 2271,
  [5886] = 5886,
  [5887] = 1607,
  [5888] = 5420,
  [5889] = 2203,
  [5890] = 5890,
  [5891] = 1623,
  [5892] = 5660,
  [5893] = 2407,
  [5894] = 1615,
  [5895] = 5420,
  [5896] = 136,
  [5897] = 2514,
  [5898] = 1612,
  [5899] = 1621,
  [5900] = 828,
  [5901] = 135,
  [5902] = 5890,
  [5903] = 2478,
  [5904] = 5418,
  [5905] = 5890,
  [5906] = 5446,
  [5907] = 2176,
  [5908] = 1606,
  [5909] = 5447,
  [5910] = 5345,
  [5911] = 1613,
  [5912] = 2185,
  [5913] = 1608,
  [5914] = 5890,
  [5915] = 5653,
  [5916] = 5890,
  [5917] = 5917,
  [5918] = 1611,
  [5919] = 1622,
  [5920] = 2194,
  [5921] = 5658,
  [5922] = 5660,
  [5923] = 5923,
  [5924] = 5924,
  [5925] = 5606,
  [5926] = 2215,
  [5927] = 5418,
  [5928] = 829,
  [5929] = 5446,
  [5930] = 1609,
  [5931] = 1618,
  [5932] = 5447,
  [5933] = 1620,
  [5934] = 2169,
  [5935] = 5419,
  [5936] = 5653,
  [5937] = 5937,
  [5938] = 5536,
  [5939] = 1616,
  [5940] = 5419,
  [5941] = 5660,
  [5942] = 5653,
  [5943] = 5655,
  [5944] = 5658,
  [5945] = 5660,
  [5946] = 5345,
  [5947] = 5947,
  [5948] = 5948,
  [5949] = 5949,
  [5950] = 5660,
  [5951] = 2505,
  [5952] = 5952,
  [5953] = 5655,
  [5954] = 1546,
  [5955] = 5653,
  [5956] = 5658,
  [5957] = 5660,
  [5958] = 5658,
  [5959] = 1689,
  [5960] = 2270,
  [5961] = 5345,
  [5962] = 5962,
  [5963] = 5655,
  [5964] = 5948,
  [5965] = 5965,
  [5966] = 5658,
  [5967] = 1684,
  [5968] = 5968,
  [5969] = 5969,
  [5970] = 1692,
  [5971] = 5345,
  [5972] = 5653,
  [5973] = 5973,
  [5974] = 5653,
  [5975] = 5975,
  [5976] = 5655,
  [5977] = 5977,
  [5978] = 2224,
  [5979] = 5979,
  [5980] = 2279,
  [5981] = 2280,
  [5982] = 2287,
  [5983] = 5653,
  [5984] = 5816,
  [5985] = 5446,
  [5986] = 5986,
  [5987] = 5986,
  [5988] = 5862,
  [5989] = 2238,
  [5990] = 5855,
  [5991] = 5991,
  [5992] = 5986,
  [5993] = 5653,
  [5994] = 5994,
  [5995] = 5995,
  [5996] = 5996,
  [5997] = 5986,
  [5998] = 5998,
  [5999] = 5841,
  [6000] = 5986,
  [6001] = 6001,
  [6002] = 5986,
  [6003] = 6003,
  [6004] = 6004,
  [6005] = 6005,
  [6006] = 6006,
  [6007] = 6007,
  [6008] = 6008,
  [6009] = 6009,
  [6010] = 6010,
  [6011] = 5655,
  [6012] = 5877,
  [6013] = 5447,
  [6014] = 5986,
  [6015] = 5818,
  [6016] = 5829,
  [6017] = 5830,
  [6018] = 5832,
  [6019] = 2215,
  [6020] = 2271,
  [6021] = 5986,
  [6022] = 5986,
  [6023] = 5655,
  [6024] = 2414,
  [6025] = 2415,
  [6026] = 2416,
  [6027] = 2417,
  [6028] = 2418,
  [6029] = 2419,
  [6030] = 5986,
  [6031] = 5658,
  [6032] = 5839,
  [6033] = 5418,
  [6034] = 5447,
  [6035] = 6035,
  [6036] = 5658,
  [6037] = 5986,
  [6038] = 5446,
  [6039] = 5345,
  [6040] = 5660,
  [6041] = 5876,
  [6042] = 5419,
  [6043] = 5660,
  [6044] = 5986,
  [6045] = 5846,
  [6046] = 5420,
  [6047] = 5812,
  [6048] = 5836,
  [6049] = 5813,
  [6050] = 2237,
  [6051] = 6001,
  [6052] = 6003,
  [6053] = 6004,
  [6054] = 6005,
  [6055] = 6006,
  [6056] = 2298,
  [6057] = 6007,
  [6058] = 6008,
  [6059] = 6009,
  [6060] = 5986,
  [6061] = 6061,
  [6062] = 6062,
  [6063] = 5418,
  [6064] = 5419,
  [6065] = 5986,
  [6066] = 6066,
  [6067] = 5420,
  [6068] = 2435,
  [6069] = 5986,
  [6070] = 5986,
  [6071] = 5819,
  [6072] = 6001,
  [6073] = 5820,
  [6074] = 5822,
  [6075] = 6075,
  [6076] = 5827,
  [6077] = 6003,
  [6078] = 6004,
  [6079] = 6005,
  [6080] = 6006,
  [6081] = 2284,
  [6082] = 2218,
  [6083] = 6007,
  [6084] = 6008,
  [6085] = 6009,
  [6086] = 5986,
  [6087] = 5792,
  [6088] = 2219,
  [6089] = 2220,
  [6090] = 5986,
  [6091] = 5986,
  [6092] = 5804,
  [6093] = 6093,
  [6094] = 5653,
  [6095] = 5655,
  [6096] = 5658,
  [6097] = 5660,
  [6098] = 6098,
  [6099] = 5655,
  [6100] = 5653,
  [6101] = 5655,
  [6102] = 5658,
  [6103] = 5660,
  [6104] = 5658,
  [6105] = 6105,
  [6106] = 6106,
  [6107] = 6107,
  [6108] = 5658,
  [6109] = 6093,
  [6110] = 5653,
  [6111] = 6111,
  [6112] = 5660,
  [6113] = 5653,
  [6114] = 5655,
  [6115] = 5658,
  [6116] = 5660,
  [6117] = 5660,
  [6118] = 5660,
  [6119] = 5660,
  [6120] = 6120,
  [6121] = 6111,
  [6122] = 5653,
  [6123] = 5655,
  [6124] = 5658,
  [6125] = 5660,
  [6126] = 6093,
  [6127] = 5655,
  [6128] = 6111,
  [6129] = 6093,
  [6130] = 5653,
  [6131] = 6111,
  [6132] = 6105,
  [6133] = 5655,
  [6134] = 6111,
  [6135] = 6135,
  [6136] = 6093,
  [6137] = 6137,
  [6138] = 6111,
  [6139] = 5653,
  [6140] = 5345,
  [6141] = 6141,
  [6142] = 6098,
  [6143] = 6105,
  [6144] = 1942,
  [6145] = 6120,
  [6146] = 6146,
  [6147] = 6147,
  [6148] = 6148,
  [6149] = 6135,
  [6150] = 5658,
  [6151] = 6093,
  [6152] = 6152,
  [6153] = 5653,
  [6154] = 6111,
  [6155] = 6155,
  [6156] = 6156,
  [6157] = 6157,
  [6158] = 6120,
  [6159] = 6120,
  [6160] = 6120,
  [6161] = 6120,
  [6162] = 6162,
  [6163] = 5658,
  [6164] = 6120,
  [6165] = 6093,
  [6166] = 6105,
  [6167] = 6141,
  [6168] = 6155,
  [6169] = 5655,
  [6170] = 6170,
  [6171] = 6147,
  [6172] = 6172,
  [6173] = 6009,
  [6174] = 6174,
  [6175] = 5655,
  [6176] = 6003,
  [6177] = 5658,
  [6178] = 5660,
  [6179] = 6172,
  [6180] = 6172,
  [6181] = 6181,
  [6182] = 5345,
  [6183] = 6172,
  [6184] = 2176,
  [6185] = 6185,
  [6186] = 6172,
  [6187] = 5446,
  [6188] = 5447,
  [6189] = 5418,
  [6190] = 5419,
  [6191] = 5420,
  [6192] = 6172,
  [6193] = 6172,
  [6194] = 6172,
  [6195] = 2169,
  [6196] = 5446,
  [6197] = 5420,
  [6198] = 5418,
  [6199] = 5653,
  [6200] = 5655,
  [6201] = 5658,
  [6202] = 5660,
  [6203] = 5653,
  [6204] = 5655,
  [6205] = 5658,
  [6206] = 5660,
  [6207] = 5447,
  [6208] = 6208,
  [6209] = 5653,
  [6210] = 2215,
  [6211] = 5655,
  [6212] = 5658,
  [6213] = 5660,
  [6214] = 6174,
  [6215] = 6172,
  [6216] = 2194,
  [6217] = 6174,
  [6218] = 6174,
  [6219] = 2194,
  [6220] = 6004,
  [6221] = 6172,
  [6222] = 6174,
  [6223] = 6005,
  [6224] = 6224,
  [6225] = 2203,
  [6226] = 6172,
  [6227] = 2185,
  [6228] = 5419,
  [6229] = 5418,
  [6230] = 2271,
  [6231] = 6224,
  [6232] = 6224,
  [6233] = 6233,
  [6234] = 2271,
  [6235] = 2215,
  [6236] = 6006,
  [6237] = 5446,
  [6238] = 2185,
  [6239] = 5419,
  [6240] = 6172,
  [6241] = 6172,
  [6242] = 6174,
  [6243] = 6172,
  [6244] = 1721,
  [6245] = 6172,
  [6246] = 2176,
  [6247] = 6224,
  [6248] = 5446,
  [6249] = 6172,
  [6250] = 1722,
  [6251] = 2203,
  [6252] = 5447,
  [6253] = 5420,
  [6254] = 5447,
  [6255] = 6172,
  [6256] = 6172,
  [6257] = 6224,
  [6258] = 6001,
  [6259] = 1725,
  [6260] = 5418,
  [6261] = 5419,
  [6262] = 6007,
  [6263] = 5420,
  [6264] = 2271,
  [6265] = 2215,
  [6266] = 6008,
  [6267] = 6172,
  [6268] = 5653,
  [6269] = 1773,
  [6270] = 6172,
  [6271] = 6224,
  [6272] = 6272,
  [6273] = 6208,
  [6274] = 6174,
  [6275] = 6224,
  [6276] = 2169,
  [6277] = 6277,
  [6278] = 6009,
  [6279] = 6279,
  [6280] = 6280,
  [6281] = 6005,
  [6282] = 6282,
  [6283] = 6283,
  [6284] = 6006,
  [6285] = 6277,
  [6286] = 6001,
  [6287] = 6005,
  [6288] = 6006,
  [6289] = 6008,
  [6290] = 6003,
  [6291] = 6004,
  [6292] = 6007,
  [6293] = 6009,
  [6294] = 6141,
  [6295] = 6280,
  [6296] = 6296,
  [6297] = 6279,
  [6298] = 6298,
  [6299] = 6299,
  [6300] = 6001,
  [6301] = 6098,
  [6302] = 6277,
  [6303] = 6303,
  [6304] = 6007,
  [6305] = 6008,
  [6306] = 6306,
  [6307] = 2270,
  [6308] = 2270,
  [6309] = 6279,
  [6310] = 6306,
  [6311] = 6282,
  [6312] = 6279,
  [6313] = 6147,
  [6314] = 5653,
  [6315] = 5655,
  [6316] = 5658,
  [6317] = 5660,
  [6318] = 6318,
  [6319] = 6135,
  [6320] = 6280,
  [6321] = 6279,
  [6322] = 6277,
  [6323] = 6279,
  [6324] = 6280,
  [6325] = 6280,
  [6326] = 6306,
  [6327] = 6327,
  [6328] = 6279,
  [6329] = 6280,
  [6330] = 5653,
  [6331] = 6306,
  [6332] = 6279,
  [6333] = 5655,
  [6334] = 5658,
  [6335] = 5660,
  [6336] = 6280,
  [6337] = 6280,
  [6338] = 6279,
  [6339] = 6339,
  [6340] = 6296,
  [6341] = 5949,
  [6342] = 6296,
  [6343] = 6280,
  [6344] = 6003,
  [6345] = 6296,
  [6346] = 6280,
  [6347] = 6004,
  [6348] = 6279,
  [6349] = 6155,
  [6350] = 6277,
  [6351] = 5660,
  [6352] = 6352,
  [6353] = 6352,
  [6354] = 6352,
  [6355] = 6352,
  [6356] = 3743,
  [6357] = 2403,
  [6358] = 5653,
  [6359] = 6352,
  [6360] = 5655,
  [6361] = 5658,
  [6362] = 5660,
  [6363] = 5660,
  [6364] = 6352,
  [6365] = 6365,
  [6366] = 6352,
  [6367] = 6006,
  [6368] = 6001,
  [6369] = 6369,
  [6370] = 5653,
  [6371] = 6352,
  [6372] = 5655,
  [6373] = 5658,
  [6374] = 6352,
  [6375] = 6352,
  [6376] = 6352,
  [6377] = 5653,
  [6378] = 6378,
  [6379] = 6352,
  [6380] = 6380,
  [6381] = 6381,
  [6382] = 6352,
  [6383] = 6352,
  [6384] = 5658,
  [6385] = 6003,
  [6386] = 6352,
  [6387] = 6352,
  [6388] = 5655,
  [6389] = 6005,
  [6390] = 6352,
  [6391] = 6007,
  [6392] = 6004,
  [6393] = 6352,
  [6394] = 6394,
  [6395] = 6008,
  [6396] = 6352,
  [6397] = 6009,
  [6398] = 6398,
  [6399] = 6399,
  [6400] = 6352,
  [6401] = 6401,
  [6402] = 6402,
  [6403] = 6403,
  [6404] = 6404,
  [6405] = 6006,
  [6406] = 6406,
  [6407] = 6001,
  [6408] = 2322,
  [6409] = 6004,
  [6410] = 6410,
  [6411] = 6411,
  [6412] = 6412,
  [6413] = 6003,
  [6414] = 6414,
  [6415] = 6410,
  [6416] = 6406,
  [6417] = 6004,
  [6418] = 6007,
  [6419] = 6410,
  [6420] = 6009,
  [6421] = 6009,
  [6422] = 6422,
  [6423] = 6098,
  [6424] = 6424,
  [6425] = 6406,
  [6426] = 6003,
  [6427] = 6427,
  [6428] = 6428,
  [6429] = 6429,
  [6430] = 6410,
  [6431] = 6431,
  [6432] = 6431,
  [6433] = 1543,
  [6434] = 1542,
  [6435] = 6435,
  [6436] = 6005,
  [6437] = 6437,
  [6438] = 1545,
  [6439] = 6431,
  [6440] = 6410,
  [6441] = 6006,
  [6442] = 6437,
  [6443] = 6443,
  [6444] = 6444,
  [6445] = 6431,
  [6446] = 1539,
  [6447] = 6155,
  [6448] = 6437,
  [6449] = 5446,
  [6450] = 6001,
  [6451] = 6135,
  [6452] = 6004,
  [6453] = 6453,
  [6454] = 6454,
  [6455] = 5447,
  [6456] = 6406,
  [6457] = 5418,
  [6458] = 5419,
  [6459] = 6437,
  [6460] = 5420,
  [6461] = 6437,
  [6462] = 6431,
  [6463] = 6410,
  [6464] = 6005,
  [6465] = 6003,
  [6466] = 6004,
  [6467] = 6007,
  [6468] = 6005,
  [6469] = 5446,
  [6470] = 6006,
  [6471] = 5447,
  [6472] = 1538,
  [6473] = 6473,
  [6474] = 6431,
  [6475] = 6431,
  [6476] = 5418,
  [6477] = 5419,
  [6478] = 6444,
  [6479] = 5420,
  [6480] = 6480,
  [6481] = 6406,
  [6482] = 6444,
  [6483] = 6444,
  [6484] = 2271,
  [6485] = 6485,
  [6486] = 6008,
  [6487] = 2215,
  [6488] = 6488,
  [6489] = 6444,
  [6490] = 1540,
  [6491] = 6491,
  [6492] = 1544,
  [6493] = 6147,
  [6494] = 6494,
  [6495] = 6437,
  [6496] = 6496,
  [6497] = 6007,
  [6498] = 6498,
  [6499] = 6410,
  [6500] = 6500,
  [6501] = 6444,
  [6502] = 6502,
  [6503] = 6009,
  [6504] = 6437,
  [6505] = 6005,
  [6506] = 6506,
  [6507] = 6001,
  [6508] = 6008,
  [6509] = 6141,
  [6510] = 6008,
  [6511] = 6511,
  [6512] = 2321,
  [6513] = 6406,
  [6514] = 6514,
  [6515] = 6406,
  [6516] = 6006,
  [6517] = 6003,
  [6518] = 6444,
  [6519] = 6007,
  [6520] = 6520,
  [6521] = 6008,
  [6522] = 6001,
  [6523] = 6523,
  [6524] = 6009,
  [6525] = 6525,
  [6526] = 6526,
  [6527] = 6527,
  [6528] = 6001,
  [6529] = 6003,
  [6530] = 6004,
  [6531] = 6005,
  [6532] = 6006,
  [6533] = 6007,
  [6534] = 6008,
  [6535] = 6009,
  [6536] = 5446,
  [6537] = 6003,
  [6538] = 6007,
  [6539] = 6009,
  [6540] = 6001,
  [6541] = 6005,
  [6542] = 6006,
  [6543] = 6008,
  [6544] = 6525,
  [6545] = 6003,
  [6546] = 6004,
  [6547] = 6007,
  [6548] = 6009,
  [6549] = 6549,
  [6550] = 6525,
  [6551] = 6551,
  [6552] = 6552,
  [6553] = 6525,
  [6554] = 6554,
  [6555] = 6525,
  [6556] = 6525,
  [6557] = 6557,
  [6558] = 6558,
  [6559] = 6525,
  [6560] = 6560,
  [6561] = 6525,
  [6562] = 5447,
  [6563] = 6563,
  [6564] = 6525,
  [6565] = 5418,
  [6566] = 6525,
  [6567] = 5419,
  [6568] = 5420,
  [6569] = 6526,
  [6570] = 6525,
  [6571] = 6525,
  [6572] = 6572,
  [6573] = 6004,
  [6574] = 6525,
  [6575] = 6004,
  [6576] = 5849,
  [6577] = 6577,
  [6578] = 6578,
  [6579] = 6578,
  [6580] = 6578,
  [6581] = 6581,
  [6582] = 6582,
  [6583] = 6582,
  [6584] = 6582,
  [6585] = 6581,
  [6586] = 6586,
  [6587] = 6578,
  [6588] = 6577,
  [6589] = 6578,
  [6590] = 6590,
  [6591] = 6582,
  [6592] = 6578,
  [6593] = 6578,
  [6594] = 6578,
  [6595] = 6581,
  [6596] = 6582,
  [6597] = 6581,
  [6598] = 6586,
  [6599] = 6578,
  [6600] = 6582,
  [6601] = 6581,
  [6602] = 6590,
  [6603] = 6577,
  [6604] = 6578,
  [6605] = 6581,
  [6606] = 6578,
  [6607] = 6147,
  [6608] = 6135,
  [6609] = 6155,
  [6610] = 6586,
  [6611] = 6141,
  [6612] = 6578,
  [6613] = 6581,
  [6614] = 6098,
  [6615] = 6578,
  [6616] = 6001,
  [6617] = 6582,
  [6618] = 6578,
  [6619] = 6003,
  [6620] = 6578,
  [6621] = 6005,
  [6622] = 6006,
  [6623] = 6007,
  [6624] = 6008,
  [6625] = 6009,
  [6626] = 6578,
  [6627] = 6578,
  [6628] = 6590,
  [6629] = 6590,
  [6630] = 6578,
  [6631] = 6586,
  [6632] = 6578,
  [6633] = 6578,
  [6634] = 6578,
  [6635] = 6577,
  [6636] = 5859,
  [6637] = 6637,
  [6638] = 6003,
  [6639] = 6639,
  [6640] = 6004,
  [6641] = 6147,
  [6642] = 6135,
  [6643] = 6643,
  [6644] = 6644,
  [6645] = 6008,
  [6646] = 6003,
  [6647] = 6647,
  [6648] = 6003,
  [6649] = 6004,
  [6650] = 6007,
  [6651] = 5859,
  [6652] = 6155,
  [6653] = 5849,
  [6654] = 6007,
  [6655] = 6007,
  [6656] = 6009,
  [6657] = 6644,
  [6658] = 6004,
  [6659] = 6659,
  [6660] = 6639,
  [6661] = 2407,
  [6662] = 6141,
  [6663] = 6663,
  [6664] = 6009,
  [6665] = 6665,
  [6666] = 6004,
  [6667] = 6667,
  [6668] = 6668,
  [6669] = 6669,
  [6670] = 6098,
  [6671] = 6639,
  [6672] = 6672,
  [6673] = 6005,
  [6674] = 6674,
  [6675] = 6675,
  [6676] = 6676,
  [6677] = 6137,
  [6678] = 6678,
  [6679] = 6639,
  [6680] = 6006,
  [6681] = 6146,
  [6682] = 6003,
  [6683] = 6683,
  [6684] = 6004,
  [6685] = 6644,
  [6686] = 6686,
  [6687] = 6007,
  [6688] = 6106,
  [6689] = 6689,
  [6690] = 6009,
  [6691] = 6691,
  [6692] = 6644,
  [6693] = 6152,
  [6694] = 6644,
  [6695] = 6695,
  [6696] = 6001,
  [6697] = 6697,
  [6698] = 6007,
  [6699] = 6691,
  [6700] = 6001,
  [6701] = 6009,
  [6702] = 6005,
  [6703] = 6006,
  [6704] = 6008,
  [6705] = 6705,
  [6706] = 6706,
  [6707] = 6707,
  [6708] = 6644,
  [6709] = 6644,
  [6710] = 6710,
  [6711] = 6691,
  [6712] = 6003,
  [6713] = 6691,
  [6714] = 6714,
  [6715] = 6107,
  [6716] = 6009,
  [6717] = 6717,
  [6718] = 6008,
  [6719] = 6719,
  [6720] = 6720,
  [6721] = 6721,
  [6722] = 6722,
  [6723] = 2203,
  [6724] = 6724,
  [6725] = 6725,
  [6726] = 6726,
  [6727] = 2194,
  [6728] = 6728,
  [6729] = 6729,
  [6730] = 6730,
  [6731] = 2169,
  [6732] = 6732,
  [6733] = 6719,
  [6734] = 6717,
  [6735] = 6721,
  [6736] = 6719,
  [6737] = 6006,
  [6738] = 6722,
  [6739] = 6726,
  [6740] = 6719,
  [6741] = 6005,
  [6742] = 6722,
  [6743] = 6717,
  [6744] = 6744,
  [6745] = 6745,
  [6746] = 6722,
  [6747] = 6726,
  [6748] = 6722,
  [6749] = 2176,
  [6750] = 6726,
  [6751] = 6722,
  [6752] = 6726,
  [6753] = 2185,
  [6754] = 6722,
  [6755] = 6004,
  [6756] = 6756,
  [6757] = 6757,
  [6758] = 6001,
  [6759] = 6759,
  [6760] = 6007,
  [6761] = 6730,
  [6762] = 6009,
  [6763] = 6003,
  [6764] = 6730,
  [6765] = 6721,
  [6766] = 6745,
  [6767] = 2407,
  [6768] = 6768,
  [6769] = 6721,
  [6770] = 6726,
  [6771] = 6730,
  [6772] = 6729,
  [6773] = 6773,
  [6774] = 6717,
  [6775] = 6726,
  [6776] = 6776,
  [6777] = 6777,
  [6778] = 6003,
  [6779] = 6004,
  [6780] = 6780,
  [6781] = 6781,
  [6782] = 2270,
  [6783] = 6783,
  [6784] = 6784,
  [6785] = 6785,
  [6786] = 6785,
  [6787] = 6787,
  [6788] = 6001,
  [6789] = 6007,
  [6790] = 6790,
  [6791] = 6777,
  [6792] = 6792,
  [6793] = 6793,
  [6794] = 6009,
  [6795] = 6795,
  [6796] = 6785,
  [6797] = 6792,
  [6798] = 6798,
  [6799] = 6793,
  [6800] = 6299,
  [6801] = 6785,
  [6802] = 6781,
  [6803] = 6803,
  [6804] = 6793,
  [6805] = 6805,
  [6806] = 6806,
  [6807] = 6006,
  [6808] = 6785,
  [6809] = 6809,
  [6810] = 6810,
  [6811] = 6298,
  [6812] = 6803,
  [6813] = 6792,
  [6814] = 6814,
  [6815] = 6777,
  [6816] = 6793,
  [6817] = 6817,
  [6818] = 6783,
  [6819] = 6819,
  [6820] = 6814,
  [6821] = 6806,
  [6822] = 6822,
  [6823] = 6814,
  [6824] = 6824,
  [6825] = 6008,
  [6826] = 6783,
  [6827] = 6785,
  [6828] = 6283,
  [6829] = 6829,
  [6830] = 6803,
  [6831] = 6831,
  [6832] = 6832,
  [6833] = 6793,
  [6834] = 6793,
  [6835] = 6785,
  [6836] = 6836,
  [6837] = 6005,
  [6838] = 6838,
  [6839] = 6793,
  [6840] = 6840,
  [6841] = 2407,
  [6842] = 6798,
  [6843] = 2407,
  [6844] = 6844,
  [6845] = 6798,
  [6846] = 6781,
  [6847] = 6806,
  [6848] = 6848,
  [6849] = 6848,
  [6850] = 6850,
  [6851] = 6851,
  [6852] = 6852,
  [6853] = 6853,
  [6854] = 6854,
  [6855] = 5849,
  [6856] = 6856,
  [6857] = 6006,
  [6858] = 6856,
  [6859] = 6859,
  [6860] = 6851,
  [6861] = 6861,
  [6862] = 6852,
  [6863] = 6004,
  [6864] = 6864,
  [6865] = 6865,
  [6866] = 6848,
  [6867] = 6867,
  [6868] = 6005,
  [6869] = 6869,
  [6870] = 6870,
  [6871] = 6854,
  [6872] = 6872,
  [6873] = 6008,
  [6874] = 2407,
  [6875] = 6851,
  [6876] = 6851,
  [6877] = 2313,
  [6878] = 2215,
  [6879] = 6009,
  [6880] = 6880,
  [6881] = 2271,
  [6882] = 6852,
  [6883] = 6848,
  [6884] = 6884,
  [6885] = 6853,
  [6886] = 6001,
  [6887] = 6854,
  [6888] = 2407,
  [6889] = 6889,
  [6890] = 6854,
  [6891] = 6891,
  [6892] = 6852,
  [6893] = 6853,
  [6894] = 6854,
  [6895] = 6848,
  [6896] = 6896,
  [6897] = 6897,
  [6898] = 6853,
  [6899] = 6856,
  [6900] = 6854,
  [6901] = 6856,
  [6902] = 6854,
  [6903] = 6003,
  [6904] = 6870,
  [6905] = 6007,
  [6906] = 6848,
  [6907] = 6848,
  [6908] = 6854,
  [6909] = 6856,
  [6910] = 6853,
  [6911] = 6853,
  [6912] = 6848,
  [6913] = 6856,
  [6914] = 6914,
  [6915] = 6915,
  [6916] = 6916,
  [6917] = 6917,
  [6918] = 6856,
  [6919] = 6853,
  [6920] = 6848,
  [6921] = 6856,
  [6922] = 6853,
  [6923] = 6923,
  [6924] = 6853,
  [6925] = 6925,
  [6926] = 6852,
  [6927] = 6856,
  [6928] = 6915,
  [6929] = 6854,
  [6930] = 6930,
  [6931] = 6931,
  [6932] = 6932,
  [6933] = 6933,
  [6934] = 6934,
  [6935] = 6935,
  [6936] = 6936,
  [6937] = 6937,
  [6938] = 6933,
  [6939] = 6933,
  [6940] = 6940,
  [6941] = 6941,
  [6942] = 6942,
  [6943] = 6943,
  [6944] = 6944,
  [6945] = 6937,
  [6946] = 6934,
  [6947] = 6943,
  [6948] = 6944,
  [6949] = 6943,
  [6950] = 6937,
  [6951] = 6951,
  [6952] = 6937,
  [6953] = 6953,
  [6954] = 6954,
  [6955] = 6954,
  [6956] = 6956,
  [6957] = 6944,
  [6958] = 6937,
  [6959] = 6953,
  [6960] = 6937,
  [6961] = 6933,
  [6962] = 6962,
  [6963] = 6944,
  [6964] = 6964,
  [6965] = 6934,
  [6966] = 6937,
  [6967] = 6937,
  [6968] = 6953,
  [6969] = 6969,
  [6970] = 6934,
  [6971] = 6971,
  [6972] = 6944,
  [6973] = 6942,
  [6974] = 6956,
  [6975] = 6975,
  [6976] = 6953,
  [6977] = 6977,
  [6978] = 6937,
  [6979] = 6933,
  [6980] = 6964,
  [6981] = 6943,
  [6982] = 6956,
  [6983] = 6944,
  [6984] = 6934,
  [6985] = 6971,
  [6986] = 6971,
  [6987] = 6937,
  [6988] = 6944,
  [6989] = 6943,
  [6990] = 6990,
  [6991] = 6954,
  [6992] = 6992,
  [6993] = 6937,
  [6994] = 6971,
  [6995] = 6934,
  [6996] = 6944,
  [6997] = 6934,
  [6998] = 6943,
  [6999] = 6964,
  [7000] = 6971,
  [7001] = 7001,
  [7002] = 6943,
  [7003] = 6930,
  [7004] = 6931,
  [7005] = 6992,
  [7006] = 6954,
  [7007] = 6943,
  [7008] = 7008,
  [7009] = 7009,
  [7010] = 6934,
  [7011] = 6930,
  [7012] = 6931,
  [7013] = 6934,
  [7014] = 6931,
  [7015] = 6937,
  [7016] = 6930,
  [7017] = 6944,
  [7018] = 6937,
  [7019] = 6992,
  [7020] = 7020,
  [7021] = 6956,
  [7022] = 6971,
  [7023] = 6971,
  [7024] = 6930,
  [7025] = 6933,
  [7026] = 6932,
  [7027] = 7001,
  [7028] = 7028,
  [7029] = 2407,
  [7030] = 6933,
  [7031] = 7031,
  [7032] = 6931,
  [7033] = 6954,
  [7034] = 7034,
  [7035] = 6932,
  [7036] = 7036,
  [7037] = 6942,
  [7038] = 6943,
  [7039] = 7039,
  [7040] = 6933,
  [7041] = 6943,
  [7042] = 7001,
  [7043] = 6964,
  [7044] = 6930,
  [7045] = 7045,
  [7046] = 7034,
  [7047] = 6942,
  [7048] = 7048,
  [7049] = 6943,
  [7050] = 7050,
  [7051] = 6944,
  [7052] = 6964,
  [7053] = 6937,
  [7054] = 7034,
  [7055] = 6942,
  [7056] = 6933,
  [7057] = 6953,
  [7058] = 7058,
  [7059] = 7059,
  [7060] = 6943,
  [7061] = 6943,
  [7062] = 7034,
  [7063] = 6942,
  [7064] = 6937,
  [7065] = 6954,
  [7066] = 6954,
  [7067] = 7036,
  [7068] = 7068,
  [7069] = 6933,
  [7070] = 6964,
  [7071] = 7034,
  [7072] = 6942,
  [7073] = 6943,
  [7074] = 6937,
  [7075] = 7034,
  [7076] = 6942,
  [7077] = 6992,
  [7078] = 7078,
  [7079] = 7034,
  [7080] = 6953,
  [7081] = 6933,
  [7082] = 6943,
  [7083] = 6933,
  [7084] = 6934,
  [7085] = 6932,
  [7086] = 6930,
  [7087] = 6944,
  [7088] = 6953,
  [7089] = 6937,
  [7090] = 6956,
  [7091] = 7091,
  [7092] = 7092,
  [7093] = 7093,
  [7094] = 6933,
  [7095] = 6930,
  [7096] = 6930,
  [7097] = 7034,
  [7098] = 5849,
  [7099] = 6956,
  [7100] = 6931,
  [7101] = 6933,
  [7102] = 6943,
  [7103] = 6992,
  [7104] = 7104,
  [7105] = 6931,
  [7106] = 6933,
  [7107] = 7107,
  [7108] = 6943,
  [7109] = 6932,
  [7110] = 6992,
  [7111] = 6930,
  [7112] = 6930,
  [7113] = 6930,
  [7114] = 7114,
  [7115] = 6964,
  [7116] = 7116,
  [7117] = 6943,
  [7118] = 7034,
  [7119] = 6933,
  [7120] = 7120,
  [7121] = 6971,
  [7122] = 7122,
  [7123] = 6932,
  [7124] = 6937,
  [7125] = 6943,
  [7126] = 6934,
  [7127] = 6934,
  [7128] = 7036,
  [7129] = 6933,
  [7130] = 6937,
  [7131] = 6942,
  [7132] = 7001,
  [7133] = 6992,
  [7134] = 6944,
  [7135] = 6971,
  [7136] = 7136,
  [7137] = 7137,
  [7138] = 7138,
  [7139] = 7139,
  [7140] = 7140,
  [7141] = 7141,
  [7142] = 7142,
  [7143] = 7143,
  [7144] = 7144,
  [7145] = 7145,
  [7146] = 7146,
  [7147] = 7147,
  [7148] = 2453,
  [7149] = 7149,
  [7150] = 7150,
  [7151] = 7151,
  [7152] = 7152,
  [7153] = 7140,
  [7154] = 7154,
  [7155] = 7151,
  [7156] = 7156,
  [7157] = 7157,
  [7158] = 7158,
  [7159] = 7159,
  [7160] = 7147,
  [7161] = 7161,
  [7162] = 7162,
  [7163] = 7163,
  [7164] = 7164,
  [7165] = 7165,
  [7166] = 7166,
  [7167] = 7167,
  [7168] = 7168,
  [7169] = 7147,
  [7170] = 7170,
  [7171] = 7151,
  [7172] = 7156,
  [7173] = 7157,
  [7174] = 7158,
  [7175] = 7175,
  [7176] = 7176,
  [7177] = 7147,
  [7178] = 7178,
  [7179] = 7151,
  [7180] = 7167,
  [7181] = 7156,
  [7182] = 7157,
  [7183] = 7158,
  [7184] = 7138,
  [7185] = 7185,
  [7186] = 7186,
  [7187] = 7187,
  [7188] = 7188,
  [7189] = 7156,
  [7190] = 7157,
  [7191] = 7158,
  [7192] = 7147,
  [7193] = 7151,
  [7194] = 7156,
  [7195] = 7157,
  [7196] = 7158,
  [7197] = 7140,
  [7198] = 7198,
  [7199] = 7199,
  [7200] = 7168,
  [7201] = 7154,
  [7202] = 7147,
  [7203] = 7151,
  [7204] = 7156,
  [7205] = 7157,
  [7206] = 7158,
  [7207] = 7141,
  [7208] = 7208,
  [7209] = 7146,
  [7210] = 7147,
  [7211] = 7151,
  [7212] = 7156,
  [7213] = 7157,
  [7214] = 7158,
  [7215] = 7215,
  [7216] = 7216,
  [7217] = 7147,
  [7218] = 7151,
  [7219] = 7156,
  [7220] = 7157,
  [7221] = 7158,
  [7222] = 7222,
  [7223] = 7175,
  [7224] = 7224,
  [7225] = 7225,
  [7226] = 7149,
  [7227] = 7147,
  [7228] = 7228,
  [7229] = 7151,
  [7230] = 7156,
  [7231] = 7157,
  [7232] = 7158,
  [7233] = 7137,
  [7234] = 7234,
  [7235] = 7224,
  [7236] = 7151,
  [7237] = 7147,
  [7238] = 7151,
  [7239] = 7156,
  [7240] = 7157,
  [7241] = 7158,
  [7242] = 7147,
  [7243] = 7243,
  [7244] = 7147,
  [7245] = 7147,
  [7246] = 7147,
  [7247] = 7154,
  [7248] = 7248,
  [7249] = 7249,
  [7250] = 7176,
  [7251] = 7151,
  [7252] = 7252,
  [7253] = 7253,
  [7254] = 7254,
  [7255] = 7225,
  [7256] = 7178,
  [7257] = 7257,
  [7258] = 7258,
  [7259] = 7259,
  [7260] = 7162,
  [7261] = 7261,
  [7262] = 7163,
  [7263] = 7164,
  [7264] = 7264,
  [7265] = 7265,
  [7266] = 7266,
  [7267] = 7166,
  [7268] = 7268,
  [7269] = 7167,
  [7270] = 7147,
  [7271] = 7271,
  [7272] = 7136,
  [7273] = 7141,
  [7274] = 7274,
  [7275] = 7275,
  [7276] = 7276,
  [7277] = 7161,
  [7278] = 7278,
  [7279] = 7279,
  [7280] = 7147,
  [7281] = 7281,
  [7282] = 7282,
  [7283] = 7283,
  [7284] = 7284,
  [7285] = 7285,
  [7286] = 7215,
  [7287] = 7216,
  [7288] = 7288,
  [7289] = 7289,
  [7290] = 7186,
  [7291] = 7187,
  [7292] = 7147,
  [7293] = 7156,
  [7294] = 7294,
  [7295] = 7162,
  [7296] = 7138,
  [7297] = 7297,
  [7298] = 7140,
  [7299] = 7146,
  [7300] = 7157,
  [7301] = 7146,
  [7302] = 7302,
  [7303] = 7158,
  [7304] = 7304,
  [7305] = 7175,
  [7306] = 7176,
  [7307] = 7178,
  [7308] = 7154,
  [7309] = 7151,
  [7310] = 7162,
  [7311] = 7163,
  [7312] = 7164,
  [7313] = 2407,
  [7314] = 7314,
  [7315] = 7315,
  [7316] = 7167,
  [7317] = 6659,
  [7318] = 7318,
  [7319] = 7186,
  [7320] = 7187,
  [7321] = 7175,
  [7322] = 7178,
  [7323] = 7323,
  [7324] = 7324,
  [7325] = 7156,
  [7326] = 7157,
  [7327] = 7186,
  [7328] = 7187,
  [7329] = 7156,
  [7330] = 7157,
  [7331] = 7158,
  [7332] = 7198,
  [7333] = 7158,
  [7334] = 7168,
  [7335] = 237,
  [7336] = 7215,
  [7337] = 7216,
  [7338] = 7224,
  [7339] = 7225,
  [7340] = 7228,
  [7341] = 7137,
  [7342] = 7198,
  [7343] = 7199,
  [7344] = 7168,
  [7345] = 7170,
  [7346] = 7288,
  [7347] = 7347,
  [7348] = 7149,
  [7349] = 7349,
  [7350] = 7350,
  [7351] = 7186,
  [7352] = 7224,
  [7353] = 7225,
  [7354] = 7215,
  [7355] = 7249,
  [7356] = 7216,
  [7357] = 7253,
  [7358] = 7254,
  [7359] = 7359,
  [7360] = 2471,
  [7361] = 2533,
  [7362] = 7136,
  [7363] = 7268,
  [7364] = 7364,
  [7365] = 7365,
  [7366] = 7187,
  [7367] = 7367,
  [7368] = 7368,
  [7369] = 7284,
  [7370] = 7224,
  [7371] = 7254,
  [7372] = 7138,
  [7373] = 7373,
  [7374] = 7225,
  [7375] = 7375,
  [7376] = 7288,
  [7377] = 7156,
  [7378] = 7378,
  [7379] = 7147,
  [7380] = 7162,
  [7381] = 7163,
  [7382] = 7382,
  [7383] = 7164,
  [7384] = 7228,
  [7385] = 7138,
  [7386] = 7140,
  [7387] = 7137,
  [7388] = 7146,
  [7389] = 7389,
  [7390] = 7157,
  [7391] = 7154,
  [7392] = 7392,
  [7393] = 7228,
  [7394] = 7151,
  [7395] = 7395,
  [7396] = 7288,
  [7397] = 7162,
  [7398] = 7163,
  [7399] = 7166,
  [7400] = 7164,
  [7401] = 7249,
  [7402] = 7253,
  [7403] = 7254,
  [7404] = 7215,
  [7405] = 7167,
  [7406] = 7253,
  [7407] = 7216,
  [7408] = 7408,
  [7409] = 7268,
  [7410] = 7175,
  [7411] = 7411,
  [7412] = 7158,
  [7413] = 7175,
  [7414] = 7178,
  [7415] = 7186,
  [7416] = 7187,
  [7417] = 7156,
  [7418] = 7157,
  [7419] = 7158,
  [7420] = 7198,
  [7421] = 7228,
  [7422] = 7168,
  [7423] = 7249,
  [7424] = 7254,
  [7425] = 7268,
  [7426] = 7426,
  [7427] = 7427,
  [7428] = 7268,
  [7429] = 7215,
  [7430] = 7216,
  [7431] = 7224,
  [7432] = 7225,
  [7433] = 7433,
  [7434] = 7434,
  [7435] = 7228,
  [7436] = 7137,
  [7437] = 7437,
  [7438] = 7137,
  [7439] = 7439,
  [7440] = 7440,
  [7441] = 7441,
  [7442] = 7249,
  [7443] = 7254,
  [7444] = 7444,
  [7445] = 7445,
  [7446] = 7446,
  [7447] = 7268,
  [7448] = 7167,
  [7449] = 7282,
  [7450] = 7176,
  [7451] = 7451,
  [7452] = 7249,
  [7453] = 7254,
  [7454] = 7454,
  [7455] = 7268,
  [7456] = 7136,
  [7457] = 7249,
  [7458] = 7284,
  [7459] = 7459,
  [7460] = 7249,
  [7461] = 7254,
  [7462] = 7254,
  [7463] = 7284,
  [7464] = 7254,
  [7465] = 7465,
  [7466] = 7254,
  [7467] = 7254,
  [7468] = 2485,
  [7469] = 7288,
  [7470] = 7470,
  [7471] = 7471,
  [7472] = 7147,
  [7473] = 7253,
  [7474] = 7474,
  [7475] = 2486,
  [7476] = 7253,
  [7477] = 7477,
  [7478] = 7478,
  [7479] = 7136,
  [7480] = 7138,
  [7481] = 7161,
  [7482] = 7140,
  [7483] = 7178,
  [7484] = 7282,
  [7485] = 7154,
  [7486] = 7151,
  [7487] = 7487,
  [7488] = 7162,
  [7489] = 7163,
  [7490] = 7164,
  [7491] = 7198,
  [7492] = 7282,
  [7493] = 7167,
  [7494] = 7494,
  [7495] = 2493,
  [7496] = 2494,
  [7497] = 7497,
  [7498] = 7166,
  [7499] = 7175,
  [7500] = 7186,
  [7501] = 7136,
  [7502] = 7187,
  [7503] = 7156,
  [7504] = 7157,
  [7505] = 7158,
  [7506] = 7198,
  [7507] = 7136,
  [7508] = 7168,
  [7509] = 7509,
  [7510] = 2496,
  [7511] = 7215,
  [7512] = 7216,
  [7513] = 7224,
  [7514] = 7514,
  [7515] = 7225,
  [7516] = 7228,
  [7517] = 7198,
  [7518] = 7284,
  [7519] = 2497,
  [7520] = 2499,
  [7521] = 7521,
  [7522] = 7163,
  [7523] = 7199,
  [7524] = 7288,
  [7525] = 7164,
  [7526] = 7136,
  [7527] = 7284,
  [7528] = 7284,
  [7529] = 7168,
  [7530] = 7284,
  [7531] = 7288,
  [7532] = 7147,
  [7533] = 7170,
  [7534] = 7199,
  [7535] = 7138,
  [7536] = 7288,
  [7537] = 7147,
  [7538] = 7538,
  [7539] = 7539,
  [7540] = 7151,
  [7541] = 7162,
  [7542] = 7163,
  [7543] = 7164,
  [7544] = 7147,
  [7545] = 7545,
  [7546] = 7546,
  [7547] = 7138,
  [7548] = 7548,
  [7549] = 7140,
  [7550] = 7141,
  [7551] = 7146,
  [7552] = 7156,
  [7553] = 7157,
  [7554] = 7158,
  [7555] = 7198,
  [7556] = 240,
  [7557] = 7154,
  [7558] = 7151,
  [7559] = 7559,
  [7560] = 7560,
  [7561] = 7561,
  [7562] = 7562,
  [7563] = 7563,
  [7564] = 7564,
  [7565] = 7565,
  [7566] = 7566,
  [7567] = 7567,
  [7568] = 7568,
  [7569] = 7569,
  [7570] = 7570,
  [7571] = 7571,
  [7572] = 7572,
  [7573] = 7573,
  [7574] = 7574,
  [7575] = 7575,
  [7576] = 7576,
  [7577] = 7577,
  [7578] = 7563,
  [7579] = 7579,
  [7580] = 7580,
  [7581] = 7581,
  [7582] = 7568,
  [7583] = 7583,
  [7584] = 7584,
  [7585] = 7585,
  [7586] = 7586,
  [7587] = 7574,
  [7588] = 7588,
  [7589] = 7576,
  [7590] = 7590,
  [7591] = 7591,
  [7592] = 7561,
  [7593] = 7593,
  [7594] = 7581,
  [7595] = 7595,
  [7596] = 7596,
  [7597] = 7573,
  [7598] = 7598,
  [7599] = 7595,
  [7600] = 7600,
  [7601] = 7574,
  [7602] = 7598,
  [7603] = 7576,
  [7604] = 7600,
  [7605] = 7605,
  [7606] = 7606,
  [7607] = 7565,
  [7608] = 7608,
  [7609] = 7565,
  [7610] = 7563,
  [7611] = 7611,
  [7612] = 7573,
  [7613] = 7563,
  [7614] = 7581,
  [7615] = 7595,
  [7616] = 7595,
  [7617] = 7577,
  [7618] = 7598,
  [7619] = 7573,
  [7620] = 7565,
  [7621] = 7573,
  [7622] = 7622,
  [7623] = 7623,
  [7624] = 7605,
  [7625] = 7606,
  [7626] = 7577,
  [7627] = 7623,
  [7628] = 7628,
  [7629] = 7561,
  [7630] = 7576,
  [7631] = 7575,
  [7632] = 7632,
  [7633] = 7583,
  [7634] = 7605,
  [7635] = 7623,
  [7636] = 7636,
  [7637] = 7561,
  [7638] = 7576,
  [7639] = 7628,
  [7640] = 7640,
  [7641] = 7606,
  [7642] = 7593,
  [7643] = 7577,
  [7644] = 7644,
  [7645] = 7567,
  [7646] = 7646,
  [7647] = 7575,
  [7648] = 7648,
  [7649] = 7608,
  [7650] = 7650,
  [7651] = 7561,
  [7652] = 7563,
  [7653] = 7653,
  [7654] = 7654,
  [7655] = 7577,
  [7656] = 7656,
  [7657] = 7561,
  [7658] = 7593,
  [7659] = 7611,
  [7660] = 7660,
  [7661] = 7661,
  [7662] = 7662,
  [7663] = 7576,
  [7664] = 7577,
  [7665] = 7567,
  [7666] = 7646,
  [7667] = 7574,
  [7668] = 7668,
  [7669] = 7566,
  [7670] = 7568,
  [7671] = 7565,
  [7672] = 7583,
  [7673] = 7572,
  [7674] = 7585,
  [7675] = 7570,
  [7676] = 7574,
  [7677] = 7579,
  [7678] = 7588,
  [7679] = 7576,
  [7680] = 7680,
  [7681] = 7588,
  [7682] = 7623,
  [7683] = 7683,
  [7684] = 7573,
  [7685] = 7646,
  [7686] = 7585,
  [7687] = 7576,
  [7688] = 7595,
  [7689] = 7628,
  [7690] = 7690,
  [7691] = 7566,
  [7692] = 7605,
  [7693] = 7606,
  [7694] = 7577,
  [7695] = 7575,
  [7696] = 7595,
  [7697] = 7576,
  [7698] = 7698,
  [7699] = 7699,
  [7700] = 7632,
  [7701] = 7653,
  [7702] = 7654,
  [7703] = 7656,
  [7704] = 7561,
  [7705] = 7611,
  [7706] = 7660,
  [7707] = 7661,
  [7708] = 7654,
  [7709] = 7563,
  [7710] = 7581,
  [7711] = 7711,
  [7712] = 7661,
  [7713] = 7579,
  [7714] = 7566,
  [7715] = 7568,
  [7716] = 7598,
  [7717] = 7572,
  [7718] = 7598,
  [7719] = 7565,
  [7720] = 7579,
  [7721] = 7573,
  [7722] = 7722,
  [7723] = 7623,
  [7724] = 7724,
  [7725] = 7577,
  [7726] = 7653,
  [7727] = 7570,
  [7728] = 7656,
  [7729] = 7567,
  [7730] = 7730,
  [7731] = 7731,
  [7732] = 7611,
  [7733] = 7660,
  [7734] = 7575,
  [7735] = 7735,
  [7736] = 7593,
  [7737] = 7566,
  [7738] = 7568,
  [7739] = 7739,
  [7740] = 7572,
  [7741] = 7579,
  [7742] = 7742,
  [7743] = 7608,
  [7744] = 7744,
  [7745] = 7632,
  [7746] = 7573,
  [7747] = 7656,
  [7748] = 7632,
  [7749] = 7611,
  [7750] = 7750,
  [7751] = 7751,
  [7752] = 7561,
  [7753] = 7572,
  [7754] = 7646,
  [7755] = 7585,
  [7756] = 7568,
  [7757] = 7572,
  [7758] = 7758,
  [7759] = 7579,
  [7760] = 7760,
  [7761] = 7761,
  [7762] = 7561,
  [7763] = 7656,
  [7764] = 7561,
  [7765] = 7611,
  [7766] = 7766,
  [7767] = 7656,
  [7768] = 7575,
  [7769] = 7605,
  [7770] = 7646,
  [7771] = 7568,
  [7772] = 7606,
  [7773] = 7572,
  [7774] = 7598,
  [7775] = 7775,
  [7776] = 7776,
  [7777] = 7567,
  [7778] = 7778,
  [7779] = 7588,
  [7780] = 7656,
  [7781] = 7611,
  [7782] = 7782,
  [7783] = 7571,
  [7784] = 7568,
  [7785] = 7785,
  [7786] = 7611,
  [7787] = 7611,
  [7788] = 7583,
  [7789] = 7561,
  [7790] = 7605,
  [7791] = 7585,
  [7792] = 7623,
  [7793] = 7646,
  [7794] = 7606,
  [7795] = 7574,
  [7796] = 7567,
  [7797] = 7588,
  [7798] = 7660,
  [7799] = 7576,
  [7800] = 7800,
  [7801] = 7628,
  [7802] = 7654,
  [7803] = 7563,
  [7804] = 7608,
  [7805] = 7574,
  [7806] = 7653,
  [7807] = 7576,
  [7808] = 7654,
  [7809] = 7595,
  [7810] = 7810,
  [7811] = 7605,
  [7812] = 7606,
  [7813] = 7583,
  [7814] = 7608,
  [7815] = 7561,
  [7816] = 7816,
  [7817] = 7656,
  [7818] = 7654,
  [7819] = 7819,
  [7820] = 7576,
  [7821] = 7591,
  [7822] = 7822,
  [7823] = 7561,
  [7824] = 7563,
  [7825] = 7581,
  [7826] = 7826,
  [7827] = 7600,
  [7828] = 7828,
  [7829] = 7561,
  [7830] = 7646,
  [7831] = 7565,
  [7832] = 7581,
  [7833] = 7573,
  [7834] = 7653,
  [7835] = 7623,
  [7836] = 7581,
  [7837] = 7567,
  [7838] = 7661,
  [7839] = 7577,
  [7840] = 7611,
  [7841] = 7577,
  [7842] = 7565,
  [7843] = 7567,
  [7844] = 7605,
  [7845] = 7606,
  [7846] = 7573,
  [7847] = 7571,
  [7848] = 7660,
  [7849] = 7849,
  [7850] = 7567,
  [7851] = 7563,
  [7852] = 7565,
  [7853] = 7595,
  [7854] = 7563,
  [7855] = 7661,
  [7856] = 7567,
  [7857] = 7571,
  [7858] = 7622,
  [7859] = 7571,
  [7860] = 7661,
  [7861] = 7561,
  [7862] = 7583,
  [7863] = 7863,
  [7864] = 7605,
  [7865] = 7606,
  [7866] = 7585,
  [7867] = 7567,
  [7868] = 7608,
  [7869] = 7622,
  [7870] = 7583,
  [7871] = 7660,
  [7872] = 7574,
  [7873] = 7576,
  [7874] = 7583,
  [7875] = 7724,
  [7876] = 7561,
  [7877] = 7576,
  [7878] = 7567,
  [7879] = 7574,
  [7880] = 7622,
  [7881] = 7605,
  [7882] = 7606,
  [7883] = 7573,
  [7884] = 7595,
  [7885] = 7588,
  [7886] = 7585,
  [7887] = 7576,
  [7888] = 7605,
  [7889] = 7606,
  [7890] = 7574,
  [7891] = 7574,
  [7892] = 7632,
  [7893] = 7563,
  [7894] = 7570,
  [7895] = 7895,
  [7896] = 7595,
  [7897] = 7588,
  [7898] = 7565,
  [7899] = 7573,
  [7900] = 7724,
  [7901] = 7623,
  [7902] = 7605,
  [7903] = 7606,
  [7904] = 7577,
  [7905] = 7724,
  [7906] = 7724,
  [7907] = 7724,
  [7908] = 7908,
  [7909] = 7576,
  [7910] = 7724,
  [7911] = 7724,
  [7912] = 7724,
  [7913] = 7724,
  [7914] = 7724,
  [7915] = 7724,
  [7916] = 7724,
  [7917] = 7724,
  [7918] = 7724,
  [7919] = 7724,
  [7920] = 7724,
  [7921] = 7583,
  [7922] = 7600,
  [7923] = 7923,
  [7924] = 7924,
  [7925] = 7925,
  [7926] = 7926,
  [7927] = 7927,
  [7928] = 7928,
  [7929] = 7929,
  [7930] = 7930,
  [7931] = 7931,
  [7932] = 5771,
  [7933] = 7933,
  [7934] = 7934,
  [7935] = 7935,
  [7936] = 7936,
  [7937] = 7937,
  [7938] = 7938,
  [7939] = 7939,
  [7940] = 7940,
  [7941] = 7941,
  [7942] = 7942,
  [7943] = 7943,
  [7944] = 7944,
  [7945] = 7938,
  [7946] = 7942,
  [7947] = 7947,
  [7948] = 7925,
  [7949] = 7949,
  [7950] = 7950,
  [7951] = 7951,
  [7952] = 7947,
  [7953] = 7949,
  [7954] = 7954,
  [7955] = 7955,
  [7956] = 7956,
  [7957] = 7941,
  [7958] = 7958,
  [7959] = 7959,
  [7960] = 7960,
  [7961] = 7961,
  [7962] = 7962,
  [7963] = 7963,
  [7964] = 7964,
  [7965] = 7965,
  [7966] = 7966,
  [7967] = 7967,
  [7968] = 7968,
  [7969] = 7969,
  [7970] = 7970,
  [7971] = 7971,
  [7972] = 7972,
  [7973] = 7942,
  [7974] = 7947,
  [7975] = 7975,
  [7976] = 7976,
  [7977] = 7977,
  [7978] = 7949,
  [7979] = 7979,
  [7980] = 7980,
  [7981] = 7964,
  [7982] = 7982,
  [7983] = 7931,
  [7984] = 7984,
  [7985] = 7985,
  [7986] = 7986,
  [7987] = 7987,
  [7988] = 7988,
  [7989] = 7929,
  [7990] = 7987,
  [7991] = 7987,
  [7992] = 7933,
  [7993] = 7993,
  [7994] = 7994,
  [7995] = 7995,
  [7996] = 7996,
  [7997] = 7997,
  [7998] = 7988,
  [7999] = 7956,
  [8000] = 7929,
  [8001] = 8001,
  [8002] = 8002,
  [8003] = 8003,
  [8004] = 8004,
  [8005] = 8005,
  [8006] = 7963,
  [8007] = 7949,
  [8008] = 8008,
  [8009] = 7994,
  [8010] = 8008,
  [8011] = 7931,
  [8012] = 8012,
  [8013] = 8013,
  [8014] = 7942,
  [8015] = 8015,
  [8016] = 8016,
  [8017] = 8017,
  [8018] = 7994,
  [8019] = 8019,
  [8020] = 8015,
  [8021] = 8021,
  [8022] = 8022,
  [8023] = 8023,
  [8024] = 8024,
  [8025] = 8025,
  [8026] = 7996,
  [8027] = 8027,
  [8028] = 8028,
  [8029] = 8029,
  [8030] = 8030,
  [8031] = 5673,
  [8032] = 8032,
  [8033] = 7931,
  [8034] = 7976,
  [8035] = 8035,
  [8036] = 8036,
  [8037] = 8037,
  [8038] = 8038,
  [8039] = 8012,
  [8040] = 7993,
  [8041] = 8037,
  [8042] = 8032,
  [8043] = 8043,
  [8044] = 8027,
  [8045] = 8045,
  [8046] = 7933,
  [8047] = 8047,
  [8048] = 7965,
  [8049] = 8049,
  [8050] = 8050,
  [8051] = 8051,
  [8052] = 7976,
  [8053] = 8053,
  [8054] = 8054,
  [8055] = 8055,
  [8056] = 8056,
  [8057] = 8023,
  [8058] = 8058,
  [8059] = 8025,
  [8060] = 7987,
  [8061] = 7924,
  [8062] = 7925,
  [8063] = 7933,
  [8064] = 7996,
  [8065] = 8065,
  [8066] = 7960,
  [8067] = 7984,
  [8068] = 8029,
  [8069] = 8069,
  [8070] = 8012,
  [8071] = 7961,
  [8072] = 8072,
  [8073] = 7944,
  [8074] = 7976,
  [8075] = 8075,
  [8076] = 7931,
  [8077] = 7964,
  [8078] = 7954,
  [8079] = 7955,
  [8080] = 8080,
  [8081] = 8080,
  [8082] = 7993,
  [8083] = 8083,
  [8084] = 8084,
  [8085] = 7963,
  [8086] = 7928,
  [8087] = 8087,
  [8088] = 8047,
  [8089] = 8089,
  [8090] = 7987,
  [8091] = 7987,
  [8092] = 7933,
  [8093] = 5731,
  [8094] = 7935,
  [8095] = 8004,
  [8096] = 7967,
  [8097] = 8008,
  [8098] = 7964,
  [8099] = 8032,
  [8100] = 8100,
  [8101] = 8015,
  [8102] = 8102,
  [8103] = 7942,
  [8104] = 8027,
  [8105] = 7947,
  [8106] = 8021,
  [8107] = 8058,
  [8108] = 8108,
  [8109] = 8109,
  [8110] = 8110,
  [8111] = 8111,
  [8112] = 7956,
  [8113] = 8113,
  [8114] = 7969,
  [8115] = 7993,
  [8116] = 8116,
  [8117] = 7971,
  [8118] = 8003,
  [8119] = 8119,
  [8120] = 8120,
  [8121] = 8043,
  [8122] = 8008,
  [8123] = 8123,
  [8124] = 7942,
  [8125] = 8080,
  [8126] = 8126,
  [8127] = 7949,
  [8128] = 7987,
  [8129] = 7987,
  [8130] = 8055,
  [8131] = 7928,
  [8132] = 7925,
  [8133] = 7933,
  [8134] = 7933,
  [8135] = 7924,
  [8136] = 7944,
  [8137] = 7964,
  [8138] = 8138,
  [8139] = 7938,
  [8140] = 8053,
  [8141] = 7975,
  [8142] = 8142,
  [8143] = 7975,
  [8144] = 8053,
  [8145] = 7933,
  [8146] = 7944,
  [8147] = 8147,
  [8148] = 8148,
  [8149] = 8149,
  [8150] = 7975,
  [8151] = 7954,
  [8152] = 7955,
  [8153] = 8012,
  [8154] = 8004,
  [8155] = 8155,
  [8156] = 8156,
  [8157] = 8157,
  [8158] = 7933,
  [8159] = 7976,
  [8160] = 8160,
  [8161] = 8021,
  [8162] = 8023,
  [8163] = 8023,
  [8164] = 8025,
  [8165] = 8165,
  [8166] = 8108,
  [8167] = 8025,
  [8168] = 7996,
  [8169] = 8169,
  [8170] = 8170,
  [8171] = 8108,
  [8172] = 7954,
  [8173] = 8173,
  [8174] = 8174,
  [8175] = 8043,
  [8176] = 8080,
  [8177] = 1722,
  [8178] = 8178,
  [8179] = 8179,
  [8180] = 8023,
  [8181] = 8181,
  [8182] = 7955,
  [8183] = 8055,
  [8184] = 7996,
  [8185] = 8080,
  [8186] = 8186,
  [8187] = 8029,
  [8188] = 7924,
  [8189] = 8189,
  [8190] = 8190,
  [8191] = 8054,
  [8192] = 8192,
  [8193] = 8055,
  [8194] = 8194,
  [8195] = 8047,
  [8196] = 8196,
  [8197] = 7965,
  [8198] = 8198,
  [8199] = 7944,
  [8200] = 7949,
  [8201] = 7987,
  [8202] = 8202,
  [8203] = 8203,
  [8204] = 7954,
  [8205] = 7955,
  [8206] = 8206,
  [8207] = 8004,
  [8208] = 8208,
  [8209] = 6859,
  [8210] = 7987,
  [8211] = 7933,
  [8212] = 7988,
  [8213] = 8213,
  [8214] = 8021,
  [8215] = 8215,
  [8216] = 8206,
  [8217] = 8217,
  [8218] = 7975,
  [8219] = 7926,
  [8220] = 8220,
  [8221] = 8221,
  [8222] = 8222,
  [8223] = 8119,
  [8224] = 7988,
  [8225] = 8049,
  [8226] = 8226,
  [8227] = 8043,
  [8228] = 7936,
  [8229] = 8229,
  [8230] = 8221,
  [8231] = 8231,
  [8232] = 8119,
  [8233] = 7934,
  [8234] = 8027,
  [8235] = 8235,
  [8236] = 8226,
  [8237] = 7924,
  [8238] = 8012,
  [8239] = 8239,
  [8240] = 7936,
  [8241] = 8087,
  [8242] = 8054,
  [8243] = 8243,
  [8244] = 8032,
  [8245] = 7931,
  [8246] = 7982,
  [8247] = 8247,
  [8248] = 8047,
  [8249] = 8029,
  [8250] = 7954,
  [8251] = 7955,
  [8252] = 7993,
  [8253] = 7944,
  [8254] = 8254,
  [8255] = 8036,
  [8256] = 8256,
  [8257] = 8257,
  [8258] = 8003,
  [8259] = 8043,
  [8260] = 8260,
  [8261] = 8261,
  [8262] = 8262,
  [8263] = 7924,
  [8264] = 8264,
  [8265] = 8008,
  [8266] = 7955,
  [8267] = 8267,
  [8268] = 7931,
  [8269] = 8016,
  [8270] = 8056,
  [8271] = 8271,
  [8272] = 8043,
  [8273] = 8058,
  [8274] = 8274,
  [8275] = 7924,
  [8276] = 8016,
  [8277] = 7955,
  [8278] = 8278,
  [8279] = 8279,
  [8280] = 8226,
  [8281] = 8235,
  [8282] = 8043,
  [8283] = 7924,
  [8284] = 7955,
  [8285] = 8053,
  [8286] = 7926,
  [8287] = 7924,
  [8288] = 7955,
  [8289] = 8004,
  [8290] = 7987,
  [8291] = 7924,
  [8292] = 7955,
  [8293] = 7924,
  [8294] = 7955,
  [8295] = 7924,
  [8296] = 7955,
  [8297] = 7924,
  [8298] = 7955,
  [8299] = 7924,
  [8300] = 7955,
  [8301] = 7924,
  [8302] = 7955,
  [8303] = 8005,
  [8304] = 8054,
  [8305] = 8003,
  [8306] = 8306,
  [8307] = 8307,
  [8308] = 8279,
  [8309] = 7977,
  [8310] = 8310,
  [8311] = 8311,
  [8312] = 8312,
  [8313] = 7972,
  [8314] = 7928,
  [8315] = 8315,
  [8316] = 7951,
  [8317] = 7988,
  [8318] = 8318,
  [8319] = 8221,
  [8320] = 7929,
  [8321] = 7933,
  [8322] = 8108,
  [8323] = 8045,
  [8324] = 7938,
  [8325] = 7964,
  [8326] = 7923,
  [8327] = 8327,
  [8328] = 7942,
  [8329] = 8329,
  [8330] = 8330,
  [8331] = 8331,
  [8332] = 7947,
  [8333] = 8123,
  [8334] = 7975,
  [8335] = 7934,
  [8336] = 8336,
  [8337] = 8036,
  [8338] = 8338,
  [8339] = 7970,
  [8340] = 8340,
  [8341] = 7982,
  [8342] = 8056,
  [8343] = 8315,
  [8344] = 7984,
  [8345] = 8345,
  [8346] = 8047,
  [8347] = 7963,
  [8348] = 8058,
  [8349] = 8349,
  [8350] = 8016,
  [8351] = 7965,
  [8352] = 8352,
  [8353] = 8353,
  [8354] = 7982,
  [8355] = 7994,
  [8356] = 8356,
  [8357] = 7988,
  [8358] = 7958,
  [8359] = 8032,
  [8360] = 8025,
  [8361] = 8361,
  [8362] = 8043,
  [8363] = 8363,
  [8364] = 7942,
  [8365] = 7984,
  [8366] = 7931,
  [8367] = 7949,
  [8368] = 8174,
  [8369] = 8369,
  [8370] = 5705,
  [8371] = 8015,
  [8372] = 8235,
  [8373] = 8373,
  [8374] = 8374,
  [8375] = 7960,
  [8376] = 7988,
  [8377] = 7976,
  [8378] = 8089,
  [8379] = 8356,
  [8380] = 8206,
  [8381] = 7994,
  [8382] = 7994,
  [8383] = 8119,
  [8384] = 7938,
  [8385] = 8036,
  [8386] = 8013,
  [8387] = 8387,
  [8388] = 8388,
  [8389] = 8389,
  [8390] = 8221,
  [8391] = 8391,
  [8392] = 8027,
  [8393] = 7961,
  [8394] = 8222,
  [8395] = 8395,
  [8396] = 8119,
  [8397] = 8174,
  [8398] = 8021,
  [8399] = 8023,
  [8400] = 7924,
  [8401] = 8025,
  [8402] = 7987,
  [8403] = 7996,
  [8404] = 8005,
  [8405] = 8206,
  [8406] = 8029,
  [8407] = 7934,
  [8408] = 8003,
  [8409] = 8215,
  [8410] = 8226,
  [8411] = 7931,
  [8412] = 7931,
  [8413] = 8221,
  [8414] = 8119,
  [8415] = 7936,
  [8416] = 7987,
  [8417] = 8306,
  [8418] = 8226,
  [8419] = 7936,
  [8420] = 7933,
  [8421] = 8243,
  [8422] = 8422,
  [8423] = 8032,
  [8424] = 8080,
  [8425] = 8425,
  [8426] = 8110,
  [8427] = 8310,
  [8428] = 7954,
  [8429] = 8311,
  [8430] = 8045,
  [8431] = 8431,
  [8432] = 8045,
  [8433] = 8433,
  [8434] = 8221,
  [8435] = 7925,
  [8436] = 8056,
  [8437] = 8437,
  [8438] = 8012,
  [8439] = 8012,
  [8440] = 7976,
  [8441] = 8441,
  [8442] = 8235,
  [8443] = 7955,
  [8444] = 8444,
  [8445] = 8445,
  [8446] = 7994,
  [8447] = 8110,
  [8448] = 8331,
  [8449] = 8215,
  [8450] = 8311,
  [8451] = 8451,
  [8452] = 7963,
  [8453] = 8453,
  [8454] = 8454,
  [8455] = 7993,
  [8456] = 8047,
  [8457] = 8235,
  [8458] = 7987,
  [8459] = 8459,
  [8460] = 8174,
  [8461] = 7963,
  [8462] = 8340,
  [8463] = 8463,
  [8464] = 8036,
  [8465] = 1725,
  [8466] = 8047,
  [8467] = 8027,
  [8468] = 8110,
  [8469] = 8222,
  [8470] = 7925,
  [8471] = 8311,
  [8472] = 8472,
  [8473] = 7993,
  [8474] = 8003,
  [8475] = 8003,
  [8476] = 8476,
  [8477] = 8329,
  [8478] = 8478,
  [8479] = 8056,
  [8480] = 8480,
  [8481] = 7987,
  [8482] = 8058,
  [8483] = 8441,
  [8484] = 7988,
  [8485] = 8012,
  [8486] = 8353,
  [8487] = 8487,
  [8488] = 8488,
  [8489] = 8489,
  [8490] = 7937,
  [8491] = 7951,
  [8492] = 8029,
  [8493] = 8493,
  [8494] = 7928,
  [8495] = 7933,
  [8496] = 7964,
  [8497] = 7942,
  [8498] = 7975,
  [8499] = 8004,
  [8500] = 8005,
  [8501] = 8087,
  [8502] = 8502,
  [8503] = 8008,
  [8504] = 8504,
  [8505] = 8505,
  [8506] = 8206,
  [8507] = 8507,
  [8508] = 8306,
  [8509] = 7977,
  [8510] = 8310,
  [8511] = 7972,
  [8512] = 8512,
  [8513] = 8315,
  [8514] = 8514,
  [8515] = 8221,
  [8516] = 8516,
  [8517] = 8108,
  [8518] = 8518,
  [8519] = 8331,
  [8520] = 8520,
  [8521] = 8123,
  [8522] = 8522,
  [8523] = 8523,
  [8524] = 8524,
  [8525] = 7970,
  [8526] = 8340,
  [8527] = 7984,
  [8528] = 8528,
  [8529] = 7924,
  [8530] = 7965,
  [8531] = 7988,
  [8532] = 7958,
  [8533] = 7937,
  [8534] = 7937,
  [8535] = 8089,
  [8536] = 8013,
  [8537] = 7951,
  [8538] = 7951,
  [8539] = 8306,
  [8540] = 7977,
  [8541] = 7972,
  [8542] = 8169,
  [8543] = 8315,
  [8544] = 7949,
  [8545] = 8545,
  [8546] = 8331,
  [8547] = 8029,
  [8548] = 8123,
  [8549] = 8032,
  [8550] = 8221,
  [8551] = 7970,
  [8552] = 8340,
  [8553] = 8119,
  [8554] = 7958,
  [8555] = 8226,
  [8556] = 7936,
  [8557] = 8089,
  [8558] = 8013,
  [8559] = 8055,
  [8560] = 8306,
  [8561] = 7977,
  [8562] = 7972,
  [8563] = 8563,
  [8564] = 8315,
  [8565] = 8015,
  [8566] = 7926,
  [8567] = 8331,
  [8568] = 8123,
  [8569] = 8243,
  [8570] = 8087,
  [8571] = 7970,
  [8572] = 8340,
  [8573] = 8573,
  [8574] = 7958,
  [8575] = 7988,
  [8576] = 8463,
  [8577] = 8089,
  [8578] = 8013,
  [8579] = 7928,
  [8580] = 8306,
  [8581] = 7977,
  [8582] = 7972,
  [8583] = 8583,
  [8584] = 8315,
  [8585] = 8585,
  [8586] = 8087,
  [8587] = 8123,
  [8588] = 8221,
  [8589] = 8478,
  [8590] = 7970,
  [8591] = 8340,
  [8592] = 8021,
  [8593] = 7958,
  [8594] = 8594,
  [8595] = 8478,
  [8596] = 8089,
  [8597] = 8013,
  [8598] = 8598,
  [8599] = 8306,
  [8600] = 7977,
  [8601] = 8601,
  [8602] = 8315,
  [8603] = 8603,
  [8604] = 8604,
  [8605] = 8119,
  [8606] = 7988,
  [8607] = 7970,
  [8608] = 8340,
  [8609] = 8609,
  [8610] = 8226,
  [8611] = 7969,
  [8612] = 8089,
  [8613] = 8613,
  [8614] = 8306,
  [8615] = 7977,
  [8616] = 8315,
  [8617] = 8037,
  [8618] = 8340,
  [8619] = 8619,
  [8620] = 8221,
  [8621] = 8089,
  [8622] = 8206,
  [8623] = 8306,
  [8624] = 7977,
  [8625] = 8315,
  [8626] = 8110,
  [8627] = 8340,
  [8628] = 7936,
  [8629] = 8089,
  [8630] = 8306,
  [8631] = 7977,
  [8632] = 8315,
  [8633] = 8340,
  [8634] = 8089,
  [8635] = 7977,
  [8636] = 8340,
  [8637] = 8089,
  [8638] = 7977,
  [8639] = 8340,
  [8640] = 8089,
  [8641] = 8340,
  [8642] = 8089,
  [8643] = 8340,
  [8644] = 8089,
  [8645] = 8340,
  [8646] = 8089,
  [8647] = 8340,
  [8648] = 8089,
  [8649] = 8340,
  [8650] = 8089,
  [8651] = 7963,
  [8652] = 8652,
  [8653] = 8310,
  [8654] = 8654,
  [8655] = 8655,
  [8656] = 7928,
  [8657] = 8657,
  [8658] = 8658,
  [8659] = 8659,
  [8660] = 8206,
  [8661] = 8661,
  [8662] = 8662,
  [8663] = 8663,
  [8664] = 8012,
  [8665] = 7984,
  [8666] = 8666,
  [8667] = 8045,
  [8668] = 7942,
  [8669] = 7929,
  [8670] = 8670,
  [8671] = 8356,
  [8672] = 8395,
  [8673] = 7933,
  [8674] = 8661,
  [8675] = 7949,
  [8676] = 7938,
  [8677] = 8235,
  [8678] = 8043,
  [8679] = 8679,
  [8680] = 7923,
  [8681] = 8681,
  [8682] = 8021,
  [8683] = 8683,
  [8684] = 8226,
  [8685] = 8685,
  [8686] = 7988,
  [8687] = 8687,
  [8688] = 8688,
  [8689] = 8689,
  [8690] = 8690,
  [8691] = 8221,
  [8692] = 7994,
  [8693] = 8004,
  [8694] = 8694,
  [8695] = 7971,
  [8696] = 8311,
  [8697] = 8221,
  [8698] = 7963,
  [8699] = 8119,
  [8700] = 8226,
  [8701] = 7965,
  [8702] = 8029,
  [8703] = 7936,
  [8704] = 7931,
  [8705] = 7931,
  [8706] = 8235,
  [8707] = 8023,
  [8708] = 8025,
  [8709] = 8181,
  [8710] = 7996,
  [8711] = 8311,
  [8712] = 7984,
  [8713] = 8116,
  [8714] = 8045,
  [8715] = 8715,
  [8716] = 7925,
  [8717] = 8717,
  [8718] = 7942,
  [8719] = 7947,
  [8720] = 8239,
  [8721] = 8029,
  [8722] = 7933,
  [8723] = 7949,
  [8724] = 8724,
  [8725] = 7938,
  [8726] = 8726,
  [8727] = 8221,
  [8728] = 7925,
  [8729] = 8729,
  [8730] = 8012,
  [8731] = 8043,
  [8732] = 8732,
  [8733] = 7967,
  [8734] = 7931,
  [8735] = 7994,
  [8736] = 7993,
  [8737] = 8310,
  [8738] = 8654,
  [8739] = 8655,
  [8740] = 7963,
  [8741] = 7942,
  [8742] = 7987,
  [8743] = 7965,
  [8744] = 8356,
  [8745] = 8395,
  [8746] = 8655,
  [8747] = 8747,
  [8748] = 7936,
  [8749] = 7959,
  [8750] = 8310,
  [8751] = 8654,
  [8752] = 8655,
  [8753] = 8441,
  [8754] = 8116,
  [8755] = 8356,
  [8756] = 8395,
  [8757] = 7923,
  [8758] = 8053,
  [8759] = 8054,
  [8760] = 8654,
  [8761] = 8655,
  [8762] = 8762,
  [8763] = 7988,
  [8764] = 8356,
  [8765] = 8395,
  [8766] = 7929,
  [8767] = 8767,
  [8768] = 8654,
  [8769] = 8655,
  [8770] = 8463,
  [8771] = 7935,
  [8772] = 8356,
  [8773] = 8395,
  [8774] = 8087,
  [8775] = 8654,
  [8776] = 8655,
  [8777] = 8661,
  [8778] = 8356,
  [8779] = 8395,
  [8780] = 7925,
  [8781] = 8356,
  [8782] = 8395,
  [8783] = 8329,
  [8784] = 8395,
  [8785] = 7987,
  [8786] = 8395,
  [8787] = 7941,
  [8788] = 8395,
  [8789] = 8053,
  [8790] = 8395,
  [8791] = 8054,
  [8792] = 8395,
  [8793] = 8055,
  [8794] = 8395,
  [8795] = 7933,
  [8796] = 8395,
  [8797] = 7963,
  [8798] = 8395,
  [8799] = 8799,
  [8800] = 8395,
  [8801] = 8148,
  [8802] = 8149,
  [8803] = 8029,
  [8804] = 8148,
  [8805] = 8149,
  [8806] = 7993,
  [8807] = 8148,
  [8808] = 8149,
  [8809] = 7994,
  [8810] = 8148,
  [8811] = 8149,
  [8812] = 8812,
  [8813] = 8148,
  [8814] = 8149,
  [8815] = 7933,
  [8816] = 8149,
  [8817] = 8149,
  [8818] = 8149,
  [8819] = 8149,
  [8820] = 8149,
  [8821] = 8149,
  [8822] = 8149,
  [8823] = 8149,
  [8824] = 8149,
  [8825] = 8149,
  [8826] = 8149,
  [8827] = 8027,
  [8828] = 8828,
  [8829] = 8654,
  [8830] = 8239,
  [8831] = 7937,
  [8832] = 8679,
  [8833] = 8679,
  [8834] = 8679,
  [8835] = 8679,
  [8836] = 8679,
  [8837] = 8837,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007},
  {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f},
  {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f},
  {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1},
  {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3},
  {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf},
  {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a},
  {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea},
  {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69},
  {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1},
  {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a},
  {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13},
  {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55},
  {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072},
  {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176},
  {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328},
  {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a},
  {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644},
  {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909},
  {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1},
  {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8},
  {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33},
  {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646},
  {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f},
  {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5},
  {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c},
  {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505},
  {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550},
  {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e},
  {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c},
  {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee},
  {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24},
  {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49},
  {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d},
  {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e},
  {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d},
  {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5},
  {0xb7, 0xb7}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec},
  {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1},
  {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd},
  {0x5bf, 0x5bf}, {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669},
  {0x66e, 0x6d3}, {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5},
  {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1},
  {0x8e3, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1},
  {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33},
  {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3},
  {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff},
  {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44},
  {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83},
  {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa},
  {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a},
  {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3},
  {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef},
  {0xcf1, 0xcf3}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63},
  {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e},
  {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4},
  {0xec6, 0xec6}, {0xec8, 0xece}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35},
  {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6},
  {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e},
  {0x1920, 0x192b}, {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b},
  {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c},
  {0x1b50, 0x1b59}, {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba},
  {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040},
  {0x2054, 0x2054}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27},
  {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe},
  {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d},
  {0xa67f, 0xa6f1}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827},
  {0xa82c, 0xa82c}, {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953},
  {0xa960, 0xa97c}, {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76},
  {0xaa7a, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7},
  {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a},
  {0xff65, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a},
  {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0},
  {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5},
  {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a},
  {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755},
  {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838},
  {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939},
  {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a},
  {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac},
  {0x10eb0, 0x10eb1}, {0x10efd, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046},
  {0x11066, 0x11075}, {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147},
  {0x11150, 0x11173}, {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237},
  {0x1123e, 0x11241}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9},
  {0x11300, 0x11303}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344},
  {0x11347, 0x11348}, {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a},
  {0x11450, 0x11459}, {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd},
  {0x11600, 0x11640}, {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739},
  {0x11740, 0x11746}, {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935},
  {0x11937, 0x11938}, {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e},
  {0x11a47, 0x11a47}, {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59},
  {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d},
  {0x11d3f, 0x11d47}, {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9},
  {0x11ee0, 0x11ef6}, {0x11f00, 0x11f10}, {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e},
  {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69},
  {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77},
  {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1},
  {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132},
  {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99},
  {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad},
  {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9},
  {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e},
  {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714},
  {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff},
  {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a},
  {0x1e000, 0x1e006}, {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c},
  {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb},
  {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f},
  {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42},
  {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59},
  {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77},
  {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9},
  {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
  {0x31350, 0x323af}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(340);
      ADVANCE_MAP(
        '!', 407,
        '"', 525,
        '#', 286,
        '%', 431,
        '&', 441,
        '\'', 516,
        '(', 344,
        ')', 347,
        '*', 427,
        '+', 421,
        ',', 346,
        '-', 410,
        '.', 491,
        '/', 429,
        '0', 498,
        ':', 461,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 469,
        '\\', 2,
        ']', 471,
        '^', 438,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 435,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(338);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(163);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(163);
      if (lookahead == '\r') SKIP(1);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(172);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(172);
      if (lookahead == '\r') SKIP(3);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(171);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(171);
      if (lookahead == '\r') SKIP(5);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(174);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(174);
      if (lookahead == '\r') SKIP(7);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(173);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(173);
      if (lookahead == '\r') SKIP(9);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(175);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(175);
      if (lookahead == '\r') SKIP(11);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(176);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(176);
      if (lookahead == '\r') SKIP(13);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(166);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(166);
      if (lookahead == '\r') SKIP(15);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(167);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(167);
      if (lookahead == '\r') SKIP(17);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(239);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(239);
      if (lookahead == '\r') SKIP(19);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(195);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(195);
      if (lookahead == '\r') SKIP(21);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(240);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(240);
      if (lookahead == '\r') SKIP(23);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(169);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(169);
      if (lookahead == '\r') SKIP(25);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(188);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(188);
      if (lookahead == '\r') SKIP(27);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(177);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(177);
      if (lookahead == '\r') SKIP(29);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(184);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(184);
      if (lookahead == '\r') SKIP(31);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(196);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(196);
      if (lookahead == '\r') SKIP(33);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(194);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(194);
      if (lookahead == '\r') SKIP(35);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(210);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(210);
      if (lookahead == '\r') SKIP(37);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(185);
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(185);
      if (lookahead == '\r') SKIP(39);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(199);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(199);
      if (lookahead == '\r') SKIP(41);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(189);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(189);
      if (lookahead == '\r') SKIP(43);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(179);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(179);
      if (lookahead == '\r') SKIP(45);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(197);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(197);
      if (lookahead == '\r') SKIP(47);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(213);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(213);
      if (lookahead == '\r') SKIP(49);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(221);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(221);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(209);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(209);
      if (lookahead == '\r') SKIP(53);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(217);
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(217);
      if (lookahead == '\r') SKIP(55);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(180);
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(180);
      if (lookahead == '\r') SKIP(57);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(226);
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(226);
      if (lookahead == '\r') SKIP(59);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(238);
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(238);
      if (lookahead == '\r') SKIP(61);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(241);
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(241);
      if (lookahead == '\r') SKIP(63);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(186);
      END_STATE();
    case 66:
      if (lookahead == '\n') SKIP(186);
      if (lookahead == '\r') SKIP(65);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 67:
      if (lookahead == '\n') SKIP(190);
      END_STATE();
    case 68:
      if (lookahead == '\n') SKIP(190);
      if (lookahead == '\r') SKIP(67);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 69:
      if (lookahead == '\n') SKIP(229);
      END_STATE();
    case 70:
      if (lookahead == '\n') SKIP(229);
      if (lookahead == '\r') SKIP(69);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 71:
      if (lookahead == '\n') SKIP(203);
      END_STATE();
    case 72:
      if (lookahead == '\n') SKIP(203);
      if (lookahead == '\r') SKIP(71);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 73:
      if (lookahead == '\n') SKIP(233);
      END_STATE();
    case 74:
      if (lookahead == '\n') SKIP(233);
      if (lookahead == '\r') SKIP(73);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 75:
      if (lookahead == '\n') SKIP(243);
      END_STATE();
    case 76:
      if (lookahead == '\n') SKIP(243);
      if (lookahead == '\r') SKIP(75);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 77:
      if (lookahead == '\n') SKIP(242);
      END_STATE();
    case 78:
      if (lookahead == '\n') SKIP(242);
      if (lookahead == '\r') SKIP(77);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 79:
      if (lookahead == '\n') SKIP(170);
      END_STATE();
    case 80:
      if (lookahead == '\n') SKIP(170);
      if (lookahead == '\r') SKIP(79);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 81:
      if (lookahead == '\n') SKIP(220);
      END_STATE();
    case 82:
      if (lookahead == '\n') SKIP(220);
      if (lookahead == '\r') SKIP(81);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 83:
      if (lookahead == '\n') SKIP(212);
      END_STATE();
    case 84:
      if (lookahead == '\n') SKIP(212);
      if (lookahead == '\r') SKIP(83);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 85:
      if (lookahead == '\n') SKIP(219);
      END_STATE();
    case 86:
      if (lookahead == '\n') SKIP(219);
      if (lookahead == '\r') SKIP(85);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 87:
      if (lookahead == '\n') SKIP(245);
      END_STATE();
    case 88:
      if (lookahead == '\n') SKIP(245);
      if (lookahead == '\r') SKIP(87);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 89:
      if (lookahead == '\n') SKIP(225);
      END_STATE();
    case 90:
      if (lookahead == '\n') SKIP(225);
      if (lookahead == '\r') SKIP(89);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 91:
      if (lookahead == '\n') SKIP(244);
      END_STATE();
    case 92:
      if (lookahead == '\n') SKIP(244);
      if (lookahead == '\r') SKIP(91);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 93:
      if (lookahead == '\n') SKIP(251);
      END_STATE();
    case 94:
      if (lookahead == '\n') SKIP(251);
      if (lookahead == '\r') SKIP(93);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 95:
      if (lookahead == '\n') SKIP(178);
      END_STATE();
    case 96:
      if (lookahead == '\n') SKIP(178);
      if (lookahead == '\r') SKIP(95);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 97:
      if (lookahead == '\n') SKIP(99);
      END_STATE();
    case 98:
      if (lookahead == '\n') SKIP(99);
      if (lookahead == '\r') SKIP(97);
      END_STATE();
    case 99:
      ADVANCE_MAP(
        '\n', 349,
        '!', 273,
        '%', 430,
        '&', 440,
        '(', 405,
        '*', 426,
        '+', 419,
        '-', 409,
        '/', 428,
        '<', 454,
        '=', 274,
        '>', 445,
      );
      if (lookahead == '\\') SKIP(98);
      if (lookahead == '^') ADVANCE(437);
      if (lookahead == '|') ADVANCE(436);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(99);
      END_STATE();
    case 100:
      if (lookahead == '\n') SKIP(246);
      END_STATE();
    case 101:
      if (lookahead == '\n') SKIP(246);
      if (lookahead == '\r') SKIP(100);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 102:
      if (lookahead == '\n') SKIP(250);
      END_STATE();
    case 103:
      if (lookahead == '\n') SKIP(250);
      if (lookahead == '\r') SKIP(102);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 104:
      if (lookahead == '\n') SKIP(234);
      END_STATE();
    case 105:
      if (lookahead == '\n') SKIP(234);
      if (lookahead == '\r') SKIP(104);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 106:
      if (lookahead == '\n') SKIP(235);
      END_STATE();
    case 107:
      if (lookahead == '\n') SKIP(235);
      if (lookahead == '\r') SKIP(106);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 108:
      if (lookahead == '\n') SKIP(236);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '/') ADVANCE(526);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(529);
      if (lookahead != 0) ADVANCE(530);
      END_STATE();
    case 109:
      if (lookahead == '\n') ADVANCE(532);
      if (lookahead == '\r') ADVANCE(531);
      if (lookahead == 'U') ADVANCE(336);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == 'x') ADVANCE(322);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(534);
      if (lookahead != 0) ADVANCE(531);
      END_STATE();
    case 110:
      if (lookahead == '\n') SKIP(247);
      if (lookahead == '\'') ADVANCE(516);
      if (lookahead == '/') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(518);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(520);
      if (lookahead != 0) ADVANCE(517);
      END_STATE();
    case 111:
      if (lookahead == '\n') ADVANCE(342);
      if (lookahead == '\r') ADVANCE(115);
      if (lookahead == '(') ADVANCE(344);
      if (lookahead == '/') ADVANCE(370);
      if (lookahead == '\\') ADVANCE(365);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(264);
      if (lookahead != 0) ADVANCE(372);
      END_STATE();
    case 112:
      if (lookahead == '\n') ADVANCE(342);
      if (lookahead == '\r') ADVANCE(115);
      if (lookahead == '/') ADVANCE(370);
      if (lookahead == '\\') ADVANCE(365);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(264);
      if (lookahead != 0) ADVANCE(372);
      END_STATE();
    case 113:
      if (lookahead == '\n') ADVANCE(342);
      if (lookahead == '\r') ADVANCE(114);
      if (lookahead == '(') ADVANCE(405);
      if (lookahead == '/') ADVANCE(255);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(252);
      END_STATE();
    case 114:
      if (lookahead == '\n') ADVANCE(342);
      if (lookahead == '(') ADVANCE(405);
      if (lookahead == '/') ADVANCE(255);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(252);
      END_STATE();
    case 115:
      if (lookahead == '\n') ADVANCE(342);
      if (lookahead == '/') ADVANCE(370);
      if (lookahead == '\\') ADVANCE(365);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(264);
      if (lookahead != 0) ADVANCE(372);
      END_STATE();
    case 116:
      if (lookahead == '\n') SKIP(252);
      END_STATE();
    case 117:
      if (lookahead == '\n') SKIP(252);
      if (lookahead == '\r') SKIP(116);
      END_STATE();
    case 118:
      if (lookahead == '\n') SKIP(164);
      END_STATE();
    case 119:
      if (lookahead == '\n') SKIP(164);
      if (lookahead == '\r') SKIP(118);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 120:
      if (lookahead == '\n') SKIP(168);
      END_STATE();
    case 121:
      if (lookahead == '\n') SKIP(168);
      if (lookahead == '\r') SKIP(120);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 122:
      if (lookahead == '\n') SKIP(204);
      END_STATE();
    case 123:
      if (lookahead == '\n') SKIP(204);
      if (lookahead == '\r') SKIP(122);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 124:
      if (lookahead == '\n') SKIP(205);
      END_STATE();
    case 125:
      if (lookahead == '\n') SKIP(205);
      if (lookahead == '\r') SKIP(124);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 126:
      if (lookahead == '\n') SKIP(200);
      END_STATE();
    case 127:
      if (lookahead == '\n') SKIP(200);
      if (lookahead == '\r') SKIP(126);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 128:
      if (lookahead == '\n') SKIP(230);
      END_STATE();
    case 129:
      if (lookahead == '\n') SKIP(230);
      if (lookahead == '\r') SKIP(128);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 130:
      if (lookahead == '\n') SKIP(211);
      END_STATE();
    case 131:
      if (lookahead == '\n') SKIP(211);
      if (lookahead == '\r') SKIP(130);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 132:
      if (lookahead == '\n') SKIP(182);
      END_STATE();
    case 133:
      if (lookahead == '\n') SKIP(182);
      if (lookahead == '\r') SKIP(132);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 134:
      if (lookahead == '\n') SKIP(227);
      END_STATE();
    case 135:
      if (lookahead == '\n') SKIP(227);
      if (lookahead == '\r') SKIP(134);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 136:
      if (lookahead == '\n') SKIP(192);
      END_STATE();
    case 137:
      if (lookahead == '\n') SKIP(192);
      if (lookahead == '\r') SKIP(136);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 138:
      if (lookahead == '\n') SKIP(218);
      END_STATE();
    case 139:
      if (lookahead == '\n') SKIP(218);
      if (lookahead == '\r') SKIP(138);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 140:
      if (lookahead == '\n') SKIP(202);
      END_STATE();
    case 141:
      if (lookahead == '\n') SKIP(202);
      if (lookahead == '\r') SKIP(140);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 142:
      if (lookahead == '\n') SKIP(223);
      END_STATE();
    case 143:
      if (lookahead == '\n') SKIP(223);
      if (lookahead == '\r') SKIP(142);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 144:
      if (lookahead == '\n') SKIP(215);
      END_STATE();
    case 145:
      if (lookahead == '\n') SKIP(215);
      if (lookahead == '\r') SKIP(144);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 146:
      if (lookahead == '\n') SKIP(165);
      END_STATE();
    case 147:
      if (lookahead == '\n') SKIP(165);
      if (lookahead == '\r') SKIP(146);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 148:
      if (lookahead == '\n') SKIP(206);
      END_STATE();
    case 149:
      if (lookahead == '\n') SKIP(206);
      if (lookahead == '\r') SKIP(148);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 150:
      if (lookahead == '\n') SKIP(228);
      END_STATE();
    case 151:
      if (lookahead == '\n') SKIP(228);
      if (lookahead == '\r') SKIP(150);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 152:
      if (lookahead == '\n') SKIP(208);
      END_STATE();
    case 153:
      if (lookahead == '\n') SKIP(208);
      if (lookahead == '\r') SKIP(152);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 154:
      if (lookahead == '\n') SKIP(224);
      END_STATE();
    case 155:
      if (lookahead == '\n') SKIP(224);
      if (lookahead == '\r') SKIP(154);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 156:
      if (lookahead == '\n') SKIP(216);
      END_STATE();
    case 157:
      if (lookahead == '\n') SKIP(216);
      if (lookahead == '\r') SKIP(156);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 158:
      if (lookahead == '\n') SKIP(198);
      END_STATE();
    case 159:
      if (lookahead == '\n') SKIP(198);
      if (lookahead == '\r') SKIP(158);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 160:
      if (lookahead == '\n') SKIP(232);
      END_STATE();
    case 161:
      if (lookahead == '\n') SKIP(232);
      if (lookahead == '\r') SKIP(160);
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 162:
      if (lookahead == '\r') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(634);
      if (lookahead != 0) ADVANCE(639);
      END_STATE();
    case 163:
      ADVANCE_MAP(
        '!', 407,
        '"', 525,
        '#', 286,
        '%', 431,
        '&', 441,
        '\'', 516,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 421,
        ',', 346,
        '-', 410,
        '.', 491,
        '/', 429,
        '0', 498,
        ':', 461,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 469,
        '\\', 2,
        ']', 471,
        '^', 438,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 435,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(163);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 164:
      ADVANCE_MAP(
        '!', 407,
        '"', 525,
        '#', 295,
        '%', 431,
        '&', 441,
        '\'', 516,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 421,
        ',', 346,
        '-', 411,
        '.', 491,
        '/', 429,
        '0', 498,
        ':', 461,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 467,
        '\\', 119,
        ']', 471,
        '^', 438,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 435,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(164);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 165:
      ADVANCE_MAP(
        '!', 407,
        '"', 525,
        '#', 295,
        '%', 430,
        '&', 440,
        '\'', 516,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 422,
        ',', 346,
        '-', 412,
        '.', 491,
        '/', 428,
        '0', 498,
        ':', 461,
        ';', 459,
        '<', 453,
        '=', 274,
        '>', 445,
        '?', 476,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 467,
        '\\', 147,
        ']', 471,
        '^', 437,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 436,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(165);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 166:
      ADVANCE_MAP(
        '!', 407,
        '"', 525,
        '%', 431,
        '&', 441,
        '\'', 516,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 421,
        ',', 346,
        '-', 410,
        '.', 491,
        '/', 429,
        '0', 498,
        ':', 271,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 467,
        '\\', 16,
        '^', 438,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 435,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(166);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 167:
      ADVANCE_MAP(
        '!', 407,
        '"', 525,
        '%', 431,
        '&', 441,
        '\'', 516,
        '(', 405,
        '*', 427,
        '+', 421,
        ',', 346,
        '-', 411,
        '.', 491,
        '/', 429,
        '0', 498,
        ':', 271,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 467,
        '\\', 18,
        '^', 438,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 435,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(167);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 168:
      ADVANCE_MAP(
        '!', 407,
        '"', 525,
        '%', 430,
        '&', 440,
        '\'', 516,
        '(', 405,
        '*', 426,
        '+', 422,
        ',', 346,
        '-', 412,
        '.', 491,
        '/', 428,
        '0', 498,
        ':', 271,
        '<', 453,
        '=', 274,
        '>', 641,
        '?', 476,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 467,
        '\\', 121,
        '^', 437,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 436,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(168);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 169:
      ADVANCE_MAP(
        '!', 407,
        '"', 237,
        '%', 431,
        '&', 441,
        '(', 253,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '/', 429,
        ':', 271,
        '<', 451,
        '=', 473,
        '>', 446,
        '[', 283,
        '\\', 26,
        '^', 438,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '|', 435,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(169);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 170:
      ADVANCE_MAP(
        '!', 407,
        '"', 237,
        '%', 431,
        '&', 441,
        '(', 253,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 446,
        '[', 284,
        '\\', 80,
        '^', 438,
        '|', 435,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(170);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 171:
      ADVANCE_MAP(
        '!', 406,
        '"', 525,
        '#', 286,
        '&', 440,
        '\'', 516,
        '(', 405,
        '*', 426,
        '+', 422,
        ',', 346,
        '-', 413,
        '.', 315,
        '/', 255,
        '0', 498,
        ':', 271,
        ';', 459,
        '<', 272,
        '>', 275,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 468,
        '\\', 6,
        ']', 285,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 434,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(171);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 172:
      ADVANCE_MAP(
        '!', 406,
        '"', 525,
        '#', 290,
        '%', 430,
        '&', 440,
        '\'', 516,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 422,
        ',', 346,
        '-', 413,
        '.', 492,
        '/', 428,
        '0', 498,
        ':', 461,
        ';', 459,
        '<', 450,
        '=', 472,
        '>', 641,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 468,
        '\\', 4,
        ']', 471,
        '^', 437,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 309,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 173:
      ADVANCE_MAP(
        '!', 406,
        '"', 525,
        '#', 294,
        '&', 439,
        '\'', 516,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 422,
        '-', 413,
        '.', 261,
        '/', 255,
        '0', 498,
        ':', 271,
        ';', 459,
        '>', 444,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 468,
        '\\', 10,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(173);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 174:
      ADVANCE_MAP(
        '!', 406,
        '"', 525,
        '#', 288,
        '&', 440,
        '\'', 516,
        '(', 405,
        '*', 426,
        '+', 422,
        ',', 346,
        '-', 413,
        '.', 315,
        '/', 255,
        '0', 498,
        ':', 271,
        ';', 459,
        '>', 277,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 468,
        '\\', 8,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(174);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 175:
      ADVANCE_MAP(
        '!', 406,
        '"', 525,
        '&', 440,
        '\'', 516,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 422,
        ',', 346,
        '-', 413,
        '.', 492,
        '/', 255,
        '0', 498,
        ':', 271,
        ';', 459,
        '=', 472,
        '>', 641,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 467,
        '\\', 12,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(175);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 176:
      ADVANCE_MAP(
        '!', 406,
        '"', 525,
        '&', 439,
        '\'', 516,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 422,
        ',', 346,
        '-', 413,
        '.', 492,
        '/', 255,
        '0', 498,
        ':', 461,
        ';', 459,
        '<', 450,
        '=', 472,
        '>', 641,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 467,
        '\\', 14,
        ']', 471,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 177:
      ADVANCE_MAP(
        '!', 406,
        '"', 525,
        '&', 439,
        '\'', 516,
        '(', 405,
        '*', 426,
        '+', 422,
        '-', 412,
        '.', 315,
        '/', 255,
        '0', 498,
        ':', 271,
        '<', 450,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 468,
        '\\', 30,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(177);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 178:
      ADVANCE_MAP(
        '!', 406,
        '\'', 516,
        '(', 405,
        ')', 347,
        '+', 424,
        '-', 417,
        '.', 315,
        '/', 255,
        '0', 498,
        'L', 560,
        'U', 561,
        '\\', 96,
        'u', 562,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(178);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 179:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 461,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        'L', 543,
        'R', 545,
        'U', 547,
        '[', 467,
        '\\', 46,
        ']', 471,
        '^', 438,
        'u', 550,
        '{', 465,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(179);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 180:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 460,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        'L', 543,
        'R', 545,
        'U', 547,
        '[', 467,
        '\\', 58,
        ']', 471,
        '^', 438,
        'u', 550,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(180);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 181:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 460,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        'L', 652,
        'R', 653,
        'U', 654,
        '[', 467,
        '\\', 58,
        ']', 471,
        '^', 438,
        'u', 655,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(180);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 182:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '#', 295,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 460,
        ';', 459,
        '<', 453,
        '=', 274,
        '>', 445,
        '?', 476,
        'L', 543,
        'R', 545,
        'U', 547,
        '[', 467,
        '\\', 133,
        ']', 471,
        '^', 437,
        'u', 550,
        '|', 436,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '#', 295,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 460,
        ';', 459,
        '<', 453,
        '=', 274,
        '>', 445,
        '?', 476,
        'L', 652,
        'R', 653,
        'U', 654,
        '[', 467,
        '\\', 133,
        ']', 471,
        '^', 437,
        'u', 655,
        '|', 436,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 184:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        ':', 271,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        'L', 543,
        'R', 545,
        'U', 547,
        '[', 468,
        '\\', 32,
        '^', 438,
        'u', 550,
        '{', 465,
        '|', 435,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 185:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        ':', 271,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        'L', 543,
        'R', 545,
        'U', 547,
        '[', 467,
        '\\', 40,
        '^', 438,
        'u', 550,
        '{', 465,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(185);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 186:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        'L', 543,
        'R', 545,
        'U', 547,
        '[', 467,
        '\\', 66,
        '^', 438,
        'u', 550,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 187:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        'L', 652,
        'R', 653,
        'U', 654,
        '[', 467,
        '\\', 66,
        '^', 438,
        'u', 655,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 461,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        'L', 543,
        'R', 545,
        'U', 547,
        '[', 468,
        '\\', 28,
        '^', 438,
        'u', 550,
        '{', 465,
        '|', 435,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(188);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 189:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '%', 431,
        '&', 441,
        '(', 405,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 271,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        'L', 543,
        'R', 545,
        'U', 547,
        '[', 467,
        '\\', 44,
        '^', 438,
        'u', 550,
        '{', 465,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(189);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 190:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '%', 431,
        '&', 441,
        '(', 405,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        'L', 543,
        'R', 545,
        'U', 547,
        '[', 467,
        '\\', 68,
        '^', 438,
        'u', 550,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '%', 431,
        '&', 441,
        '(', 405,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        'L', 652,
        'R', 653,
        'U', 654,
        '[', 467,
        '\\', 68,
        '^', 438,
        'u', 655,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 192:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '%', 430,
        '&', 440,
        '(', 405,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        '<', 453,
        '=', 274,
        '>', 641,
        '?', 476,
        'L', 543,
        'R', 545,
        'U', 547,
        '[', 467,
        '\\', 137,
        '^', 437,
        'u', 550,
        '|', 436,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 193:
      ADVANCE_MAP(
        '!', 273,
        '"', 525,
        '%', 430,
        '&', 440,
        '(', 405,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        '<', 453,
        '=', 274,
        '>', 641,
        '?', 476,
        'L', 652,
        'R', 653,
        'U', 654,
        '[', 467,
        '\\', 137,
        '^', 437,
        'u', 655,
        '|', 436,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 194:
      ADVANCE_MAP(
        '!', 273,
        '#', 306,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 461,
        ';', 459,
        '<', 453,
        '=', 473,
        '>', 445,
        '?', 476,
        '[', 468,
        '\\', 36,
        ']', 471,
        '^', 437,
        '{', 465,
        '|', 436,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 195:
      ADVANCE_MAP(
        '!', 273,
        '#', 291,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 419,
        ',', 346,
        '-', 409,
        '/', 428,
        ':', 271,
        ';', 459,
        '<', 454,
        '=', 274,
        '>', 445,
        '[', 468,
        '\\', 22,
        '^', 437,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '|', 436,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(195);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 196:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        '0', 642,
        ':', 461,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 468,
        '\\', 34,
        ']', 471,
        '^', 438,
        '{', 465,
        '|', 435,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(196);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 197:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 461,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 467,
        '\\', 48,
        ']', 471,
        '^', 438,
        '{', 465,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(197);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 198:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 460,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 468,
        '\\', 159,
        ']', 471,
        '^', 438,
        '{', 465,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(198);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 199:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 460,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 467,
        '\\', 42,
        ']', 471,
        '^', 438,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '{', 465,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(199);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 200:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 460,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 467,
        '\\', 127,
        ']', 471,
        '^', 438,
        '{', 465,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 201:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 460,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 467,
        '\\', 141,
        ']', 471,
        '^', 438,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 202:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 460,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 467,
        '\\', 141,
        ']', 471,
        '^', 438,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 203:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 460,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 470,
        '\\', 72,
        ']', 471,
        '^', 438,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(203);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 204:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 461,
        ';', 459,
        '<', 453,
        '=', 274,
        '>', 445,
        '?', 476,
        '[', 467,
        '\\', 123,
        ']', 471,
        '^', 437,
        '{', 465,
        '|', 436,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 205:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 460,
        ';', 459,
        '<', 453,
        '=', 274,
        '>', 445,
        '?', 476,
        '[', 467,
        '\\', 125,
        ']', 471,
        '^', 437,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '{', 465,
        '|', 436,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(205);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 206:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 460,
        ';', 459,
        '<', 453,
        '=', 274,
        '>', 445,
        '?', 476,
        '[', 467,
        '\\', 149,
        ']', 471,
        '^', 437,
        '{', 465,
        '|', 436,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(206);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 207:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 460,
        ';', 459,
        '<', 453,
        '=', 274,
        '>', 445,
        '?', 476,
        '[', 467,
        '\\', 153,
        ']', 471,
        '^', 437,
        '|', 436,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 208:
      ADVANCE_MAP(
        '!', 273,
        '#', 295,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 460,
        ';', 459,
        '<', 453,
        '=', 274,
        '>', 445,
        '?', 476,
        '[', 467,
        '\\', 153,
        ']', 471,
        '^', 437,
        '|', 436,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 209:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        ':', 461,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 467,
        '\\', 54,
        '^', 438,
        '{', 465,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 210:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        ':', 271,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 468,
        '\\', 38,
        '^', 438,
        '{', 465,
        '|', 435,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 211:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        ':', 460,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 467,
        '\\', 131,
        '^', 438,
        '{', 465,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 212:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 469,
        '\\', 84,
        '^', 438,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(212);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 213:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 467,
        '\\', 50,
        '^', 438,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '{', 465,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 214:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 467,
        '\\', 145,
        '^', 438,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 215:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 467,
        '\\', 145,
        '^', 438,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 216:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 414,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 470,
        '\\', 157,
        '^', 438,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(216);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 217:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 461,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        '[', 467,
        '\\', 56,
        '^', 438,
        '{', 465,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(217);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 218:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ':', 460,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        '[', 467,
        '\\', 139,
        '^', 438,
        '{', 465,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 219:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 446,
        '?', 476,
        '[', 469,
        '\\', 86,
        '^', 438,
        '|', 435,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 220:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        '[', 468,
        '\\', 82,
        '^', 438,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(220);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 221:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        '[', 467,
        '\\', 52,
        '^', 438,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '{', 465,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 222:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        '[', 467,
        '\\', 143,
        '^', 438,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 223:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        '[', 467,
        '\\', 143,
        '^', 438,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 224:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '(', 405,
        '*', 427,
        '+', 423,
        ',', 346,
        '-', 415,
        '.', 490,
        '/', 429,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        '[', 470,
        '\\', 155,
        '^', 438,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 225:
      ADVANCE_MAP(
        '!', 273,
        '%', 431,
        '&', 441,
        '*', 427,
        '+', 425,
        ',', 346,
        '-', 418,
        '.', 254,
        '/', 429,
        '<', 452,
        '=', 473,
        '>', 446,
        '\\', 90,
        '^', 438,
        '|', 435,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 226:
      ADVANCE_MAP(
        '!', 273,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 461,
        ';', 459,
        '<', 453,
        '=', 274,
        '>', 445,
        '?', 476,
        '[', 467,
        '\\', 60,
        ']', 471,
        '^', 437,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '{', 465,
        '|', 436,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 227:
      ADVANCE_MAP(
        '!', 273,
        '%', 430,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 271,
        ';', 459,
        '<', 453,
        '=', 274,
        '>', 445,
        '?', 476,
        '[', 467,
        '\\', 135,
        ']', 285,
        '^', 437,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '{', 465,
        '|', 436,
        '}', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 228:
      ADVANCE_MAP(
        '!', 273,
        '%', 430,
        '&', 440,
        '(', 405,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 461,
        '<', 453,
        '=', 274,
        '>', 641,
        '?', 476,
        '[', 467,
        '\\', 151,
        '^', 437,
        '{', 465,
        '|', 436,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 229:
      ADVANCE_MAP(
        '!', 273,
        '%', 430,
        '&', 440,
        '(', 405,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        ':', 460,
        '<', 453,
        '=', 274,
        '>', 641,
        '?', 476,
        '[', 467,
        '\\', 70,
        '^', 437,
        '{', 465,
        '|', 436,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 230:
      ADVANCE_MAP(
        '!', 273,
        '%', 430,
        '&', 440,
        '(', 405,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        '<', 453,
        '=', 274,
        '>', 641,
        '?', 476,
        '[', 467,
        '\\', 129,
        '^', 437,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '{', 465,
        '|', 436,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(230);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 231:
      ADVANCE_MAP(
        '!', 273,
        '%', 430,
        '&', 440,
        '(', 405,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        '<', 453,
        '=', 274,
        '>', 641,
        '?', 476,
        '[', 467,
        '\\', 161,
        '^', 437,
        '|', 436,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 232:
      ADVANCE_MAP(
        '!', 273,
        '%', 430,
        '&', 440,
        '(', 405,
        '*', 426,
        '+', 420,
        ',', 346,
        '-', 416,
        '.', 490,
        '/', 428,
        '<', 453,
        '=', 274,
        '>', 641,
        '?', 476,
        '[', 467,
        '\\', 161,
        '^', 437,
        '|', 436,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 233:
      ADVANCE_MAP(
        '"', 525,
        '&', 440,
        '(', 405,
        '*', 426,
        '/', 255,
        ':', 271,
        'L', 544,
        'U', 548,
        '[', 468,
        '\\', 74,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 551,
        'v', 611,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 234:
      ADVANCE_MAP(
        '"', 525,
        ')', 347,
        ',', 346,
        '/', 255,
        ':', 460,
        'L', 543,
        'R', 545,
        'U', 547,
        '\\', 105,
        'u', 550,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 235:
      ADVANCE_MAP(
        '"', 525,
        '/', 255,
        ':', 460,
        '<', 279,
        'L', 544,
        'U', 548,
        '\\', 107,
        'u', 552,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 236:
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '/') ADVANCE(255);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(236);
      END_STATE();
    case 237:
      if (lookahead == '"') ADVANCE(651);
      END_STATE();
    case 238:
      ADVANCE_MAP(
        '#', 295,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        ',', 346,
        '-', 278,
        '.', 260,
        '/', 255,
        ':', 461,
        ';', 459,
        '<', 450,
        '=', 472,
        '>', 641,
        '[', 468,
        '\\', 62,
        ']', 471,
        '{', 465,
        '|', 309,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(238);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 239:
      ADVANCE_MAP(
        '#', 287,
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 419,
        ',', 346,
        '-', 278,
        '.', 260,
        '/', 255,
        ':', 461,
        ';', 459,
        '<', 450,
        '=', 472,
        '>', 641,
        '[', 468,
        '\\', 20,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '{', 465,
        '|', 309,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 240:
      ADVANCE_MAP(
        '#', 289,
        '&', 440,
        '(', 405,
        '*', 426,
        ',', 346,
        '/', 255,
        ':', 271,
        ';', 459,
        '[', 468,
        '\\', 24,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(240);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 241:
      ADVANCE_MAP(
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        ',', 346,
        '-', 278,
        '.', 260,
        '/', 255,
        ':', 461,
        ';', 459,
        '<', 450,
        '=', 472,
        '>', 641,
        '[', 467,
        '\\', 64,
        '{', 465,
        '|', 309,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(241);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 242:
      ADVANCE_MAP(
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        ',', 346,
        '-', 278,
        '.', 260,
        '/', 255,
        ':', 460,
        ';', 459,
        '<', 450,
        '=', 472,
        '>', 641,
        '[', 468,
        '\\', 78,
        ']', 471,
        '{', 465,
        '|', 309,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 243:
      ADVANCE_MAP(
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        ',', 346,
        '-', 278,
        '/', 255,
        ':', 460,
        ';', 459,
        '<', 450,
        '=', 472,
        '>', 641,
        '[', 468,
        '\\', 76,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '{', 465,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 244:
      ADVANCE_MAP(
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        ',', 346,
        '.', 260,
        '/', 255,
        ':', 460,
        ';', 459,
        '=', 472,
        '>', 641,
        '[', 467,
        '\\', 92,
        '{', 465,
        '|', 309,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 245:
      ADVANCE_MAP(
        '&', 440,
        '(', 405,
        ')', 347,
        '*', 426,
        ',', 346,
        '/', 255,
        ';', 459,
        '=', 472,
        '>', 641,
        '[', 467,
        '\\', 88,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 606,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        'u', 599,
        'v', 611,
        '{', 465,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(245);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 246:
      ADVANCE_MAP(
        '&', 439,
        '*', 426,
        '.', 260,
        '/', 255,
        ':', 271,
        '=', 472,
        '\\', 101,
        ']', 471,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(246);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 247:
      if (lookahead == '\'') ADVANCE(516);
      if (lookahead == '/') ADVANCE(255);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247);
      END_STATE();
    case 248:
      if (lookahead == '\'') ADVANCE(320);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(310);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(248);
      END_STATE();
    case 249:
      if (lookahead == '\'') ADVANCE(316);
      if (lookahead == '.') ADVANCE(505);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(310);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(249);
      END_STATE();
    case 250:
      ADVANCE_MAP(
        '(', 405,
        ')', 347,
        ',', 346,
        '/', 255,
        ':', 460,
        ';', 459,
        '<', 450,
        '=', 472,
        '>', 641,
        '[', 469,
        '\\', 103,
        ']', 471,
        '{', 465,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(250);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 251:
      ADVANCE_MAP(
        '(', 405,
        '/', 255,
        ':', 271,
        'F', 568,
        'T', 572,
        '[', 467,
        '\\', 94,
        'f', 578,
        't', 619,
        '{', 465,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(251);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 252:
      if (lookahead == '(') ADVANCE(405);
      if (lookahead == '/') ADVANCE(255);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(252);
      END_STATE();
    case 253:
      if (lookahead == ')') ADVANCE(649);
      END_STATE();
    case 254:
      if (lookahead == '*') ADVANCE(493);
      END_STATE();
    case 255:
      if (lookahead == '*') ADVANCE(258);
      if (lookahead == '/') ADVANCE(639);
      END_STATE();
    case 256:
      if (lookahead == '*') ADVANCE(648);
      END_STATE();
    case 257:
      if (lookahead == '*') ADVANCE(257);
      if (lookahead == '/') ADVANCE(632);
      if (lookahead != 0) ADVANCE(258);
      END_STATE();
    case 258:
      if (lookahead == '*') ADVANCE(257);
      if (lookahead != 0) ADVANCE(258);
      END_STATE();
    case 259:
      if (lookahead == '*') ADVANCE(257);
      if (lookahead != 0) ADVANCE(363);
      END_STATE();
    case 260:
      if (lookahead == '.') ADVANCE(262);
      END_STATE();
    case 261:
      if (lookahead == '.') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(497);
      END_STATE();
    case 262:
      if (lookahead == '.') ADVANCE(345);
      END_STATE();
    case 263:
      if (lookahead == '.') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(503);
      END_STATE();
    case 264:
      if (lookahead == '/') ADVANCE(370);
      if (lookahead == '\\') ADVANCE(365);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(264);
      if (lookahead != 0) ADVANCE(372);
      END_STATE();
    case 265:
      if (lookahead == '1') ADVANCE(269);
      END_STATE();
    case 266:
      if (lookahead == '2') ADVANCE(496);
      END_STATE();
    case 267:
      if (lookahead == '2') ADVANCE(270);
      if (lookahead == '6') ADVANCE(496);
      END_STATE();
    case 268:
      if (lookahead == '4') ADVANCE(496);
      END_STATE();
    case 269:
      if (lookahead == '6') ADVANCE(496);
      END_STATE();
    case 270:
      if (lookahead == '8') ADVANCE(496);
      END_STATE();
    case 271:
      if (lookahead == ':') ADVANCE(462);
      END_STATE();
    case 272:
      if (lookahead == '<') ADVANCE(455);
      if (lookahead == '=') ADVANCE(448);
      END_STATE();
    case 273:
      if (lookahead == '=') ADVANCE(443);
      END_STATE();
    case 274:
      if (lookahead == '=') ADVANCE(442);
      END_STATE();
    case 275:
      if (lookahead == '=') ADVANCE(447);
      if (lookahead == '>') ADVANCE(276);
      END_STATE();
    case 276:
      if (lookahead == '=') ADVANCE(483);
      END_STATE();
    case 277:
      if (lookahead == '>') ADVANCE(457);
      END_STATE();
    case 278:
      if (lookahead == '>') ADVANCE(494);
      END_STATE();
    case 279:
      if (lookahead == '>') ADVANCE(538);
      if (lookahead == '\\') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(279);
      END_STATE();
    case 280:
      if (lookahead == '>') ADVANCE(539);
      if (lookahead == '\\') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(279);
      END_STATE();
    case 281:
      if (lookahead == 'F') ADVANCE(265);
      END_STATE();
    case 282:
      if (lookahead == 'U') ADVANCE(335);
      if (lookahead == 'u') ADVANCE(327);
      END_STATE();
    case 283:
      if (lookahead == '[') ADVANCE(463);
      if (lookahead == ']') ADVANCE(650);
      END_STATE();
    case 284:
      if (lookahead == ']') ADVANCE(650);
      END_STATE();
    case 285:
      if (lookahead == ']') ADVANCE(464);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(379);
      if (lookahead == 'e') ADVANCE(399);
      if (lookahead == 'i') ADVANCE(387);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(286);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 287:
      if (lookahead == 'd') ADVANCE(379);
      if (lookahead == 'e') ADVANCE(399);
      if (lookahead == 'i') ADVANCE(388);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(287);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(379);
      if (lookahead == 'e') ADVANCE(401);
      if (lookahead == 'i') ADVANCE(387);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(288);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 289:
      if (lookahead == 'd') ADVANCE(379);
      if (lookahead == 'e') ADVANCE(401);
      if (lookahead == 'i') ADVANCE(388);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(289);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 290:
      if (lookahead == 'd') ADVANCE(379);
      if (lookahead == 'i') ADVANCE(387);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(290);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 291:
      if (lookahead == 'd') ADVANCE(379);
      if (lookahead == 'i') ADVANCE(388);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(291);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 292:
      if (lookahead == 'd') ADVANCE(304);
      END_STATE();
    case 293:
      if (lookahead == 'd') ADVANCE(298);
      END_STATE();
    case 294:
      if (lookahead == 'e') ADVANCE(308);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(294);
      END_STATE();
    case 295:
      if (lookahead == 'e') ADVANCE(307);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(295);
      END_STATE();
    case 296:
      if (lookahead == 'e') ADVANCE(354);
      END_STATE();
    case 297:
      if (lookahead == 'e') ADVANCE(302);
      END_STATE();
    case 298:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 299:
      if (lookahead == 'f') ADVANCE(265);
      END_STATE();
    case 300:
      if (lookahead == 'f') ADVANCE(350);
      END_STATE();
    case 301:
      if (lookahead == 'f') ADVANCE(356);
      END_STATE();
    case 302:
      if (lookahead == 'f') ADVANCE(358);
      END_STATE();
    case 303:
      if (lookahead == 'f') ADVANCE(360);
      END_STATE();
    case 304:
      if (lookahead == 'i') ADVANCE(300);
      END_STATE();
    case 305:
      if (lookahead == 'i') ADVANCE(301);
      if (lookahead == 's') ADVANCE(296);
      END_STATE();
    case 306:
      if (lookahead == 'i') ADVANCE(388);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(306);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 307:
      if (lookahead == 'l') ADVANCE(305);
      if (lookahead == 'n') ADVANCE(292);
      END_STATE();
    case 308:
      if (lookahead == 'n') ADVANCE(292);
      END_STATE();
    case 309:
      if (lookahead == '|') ADVANCE(432);
      END_STATE();
    case 310:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(317);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(502);
      END_STATE();
    case 311:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(310);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(248);
      END_STATE();
    case 312:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(500);
      END_STATE();
    case 313:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(249);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(499);
      END_STATE();
    case 314:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 315:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(497);
      END_STATE();
    case 316:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(249);
      END_STATE();
    case 317:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(502);
      END_STATE();
    case 318:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(631);
      END_STATE();
    case 319:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(503);
      END_STATE();
    case 320:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(248);
      END_STATE();
    case 321:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(531);
      END_STATE();
    case 322:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(537);
      END_STATE();
    case 323:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(318);
      END_STATE();
    case 324:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(321);
      END_STATE();
    case 325:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(323);
      END_STATE();
    case 326:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(324);
      END_STATE();
    case 327:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(325);
      END_STATE();
    case 328:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(326);
      END_STATE();
    case 329:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(327);
      END_STATE();
    case 330:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(328);
      END_STATE();
    case 331:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(329);
      END_STATE();
    case 332:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(330);
      END_STATE();
    case 333:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(331);
      END_STATE();
    case 334:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(332);
      END_STATE();
    case 335:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(333);
      END_STATE();
    case 336:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(334);
      END_STATE();
    case 337:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(372);
      END_STATE();
    case 338:
      if (eof) ADVANCE(340);
      ADVANCE_MAP(
        '!', 407,
        '"', 525,
        '#', 286,
        '%', 431,
        '&', 441,
        '\'', 516,
        '(', 405,
        ')', 347,
        '*', 427,
        '+', 421,
        ',', 346,
        '-', 410,
        '.', 491,
        '/', 429,
        '0', 498,
        ':', 461,
        ';', 459,
        '<', 451,
        '=', 473,
        '>', 641,
        '?', 476,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 469,
        '\\', 2,
        ']', 471,
        '^', 438,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 435,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(338);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 339:
      if (eof) ADVANCE(340);
      ADVANCE_MAP(
        '!', 406,
        '"', 525,
        '#', 290,
        '%', 430,
        '&', 440,
        '\'', 516,
        '(', 405,
        ')', 347,
        '*', 426,
        '+', 422,
        ',', 346,
        '-', 413,
        '.', 492,
        '/', 428,
        '0', 498,
        ':', 461,
        ';', 459,
        '<', 450,
        '=', 472,
        '>', 641,
        'F', 568,
        'L', 542,
        'R', 545,
        'T', 572,
        'U', 546,
        '[', 468,
        '\\', 4,
        ']', 471,
        '^', 437,
        'b', 614,
        'c', 593,
        'd', 610,
        'f', 577,
        'i', 607,
        'm', 579,
        'n', 627,
        'p', 624,
        's', 594,
        't', 619,
        'u', 549,
        'v', 611,
        '{', 465,
        '|', 309,
        '}', 466,
        '~', 408,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(339);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(631);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(383);
      if (lookahead == 'n') ADVANCE(377);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(349);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(297);
      if (lookahead == 'n') ADVANCE(293);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(385);
      if (lookahead == 'n') ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(258);
      if (lookahead == '*') ADVANCE(362);
      if (lookahead == '/') ADVANCE(632);
      if (lookahead == '\\') ADVANCE(368);
      if (lookahead != 0) ADVANCE(363);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(258);
      if (lookahead == '*') ADVANCE(362);
      if (lookahead == '/') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(368);
      if (lookahead != 0) ADVANCE(363);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(639);
      if (lookahead == '\r') ADVANCE(633);
      if (lookahead == '/') ADVANCE(636);
      if (lookahead == '\\') ADVANCE(635);
      if (lookahead != 0) ADVANCE(637);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(264);
      if (lookahead == '\r') ADVANCE(366);
      if (lookahead == '/') ADVANCE(337);
      if (lookahead == '\\') ADVANCE(367);
      if (lookahead != 0) ADVANCE(372);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(264);
      if (lookahead == '/') ADVANCE(337);
      if (lookahead == '\\') ADVANCE(367);
      if (lookahead != 0) ADVANCE(372);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(373);
      if (lookahead == '/') ADVANCE(337);
      if (lookahead == '\\') ADVANCE(367);
      if (lookahead != 0) ADVANCE(372);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(371);
      if (lookahead == '*') ADVANCE(362);
      if (lookahead == '/') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(368);
      if (lookahead != 0) ADVANCE(363);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(638);
      if (lookahead == '/') ADVANCE(636);
      if (lookahead == '\\') ADVANCE(635);
      if (lookahead != 0) ADVANCE(637);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(363);
      if (lookahead == '/') ADVANCE(636);
      if (lookahead == '\\') ADVANCE(367);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(372);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(362);
      if (lookahead == '/') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(368);
      if (lookahead != 0) ADVANCE(363);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(337);
      if (lookahead == '\\') ADVANCE(367);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(372);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(337);
      if (lookahead == '\\') ADVANCE(367);
      if (lookahead != 0) ADVANCE(372);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(400);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(398);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(382);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(384);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(386);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(355);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(343);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(341);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(393);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(394);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(395);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(348);
      if (lookahead == 'n') ADVANCE(374);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(348);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(396);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(357);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(351);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(353);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(359);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(361);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(402);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(390);
      if (lookahead == 's') ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(391);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(397);
      if (lookahead == 'n') ADVANCE(375);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(375);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(381);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(376);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(404);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(443);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '.') ADVANCE(315);
      if (lookahead == '0') ADVANCE(498);
      if (lookahead == '=') ADVANCE(481);
      if (lookahead == '>') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '.') ADVANCE(315);
      if (lookahead == '0') ADVANCE(498);
      if (lookahead == '=') ADVANCE(481);
      if (lookahead == '>') ADVANCE(494);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '.') ADVANCE(315);
      if (lookahead == '0') ADVANCE(498);
      if (lookahead == '>') ADVANCE(494);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '.') ADVANCE(315);
      if (lookahead == '0') ADVANCE(498);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '=') ADVANCE(481);
      if (lookahead == '>') ADVANCE(495);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '=') ADVANCE(481);
      if (lookahead == '>') ADVANCE(494);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(488);
      if (lookahead == '>') ADVANCE(494);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(315);
      if (lookahead == '0') ADVANCE(498);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(481);
      if (lookahead == '>') ADVANCE(256);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(489);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(489);
      if (lookahead == '.') ADVANCE(315);
      if (lookahead == '0') ADVANCE(498);
      if (lookahead == '=') ADVANCE(480);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(489);
      if (lookahead == '.') ADVANCE(315);
      if (lookahead == '0') ADVANCE(498);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(489);
      if (lookahead == '=') ADVANCE(480);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(315);
      if (lookahead == '0') ADVANCE(498);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(480);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(477);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(258);
      if (lookahead == '/') ADVANCE(639);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(258);
      if (lookahead == '/') ADVANCE(639);
      if (lookahead == '=') ADVANCE(478);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(479);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(486);
      if (lookahead == '|') ADVANCE(432);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(432);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(485);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(433);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(433);
      if (lookahead == '=') ADVANCE(484);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(447);
      if (lookahead == '>') ADVANCE(457);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(447);
      if (lookahead == '>') ADVANCE(458);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(487);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(456);
      if (lookahead == '=') ADVANCE(449);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(456);
      if (lookahead == '=') ADVANCE(448);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(455);
      if (lookahead == '=') ADVANCE(449);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(455);
      if (lookahead == '=') ADVANCE(448);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(482);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(483);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(462);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(463);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(463);
      if (lookahead == ']') ADVANCE(650);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(650);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(442);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(567);
      if (lookahead == '3') ADVANCE(565);
      if (lookahead == '6') ADVANCE(566);
      if (lookahead == '8') ADVANCE(576);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'p') ADVANCE(625);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(493);
      if (lookahead == '.') ADVANCE(262);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(493);
      if (lookahead == '.') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(497);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(497);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_DOT_STAR);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '*') ADVANCE(648);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(sym_number_literal);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 315,
        'B', 281,
        'b', 299,
        'E', 310,
        'e', 310,
        'F', 504,
        'f', 504,
        'L', 496,
        'l', 496,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(497);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 313,
        '.', 505,
        'L', 506,
        'l', 509,
        'B', 312,
        'b', 312,
        'E', 310,
        'e', 310,
        'U', 508,
        'u', 508,
        'X', 263,
        'x', 263,
        'Z', 511,
        'z', 511,
        '8', 249,
        '9', 249,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(499);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 313,
        '.', 505,
        'L', 506,
        'l', 509,
        'E', 310,
        'e', 310,
        'U', 508,
        'u', 508,
        'Z', 511,
        'z', 511,
        '8', 249,
        '9', 249,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(499);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 312,
        'L', 506,
        'l', 509,
        'U', 508,
        'u', 508,
        'Z', 511,
        'z', 511,
        '0', 500,
        '1', 500,
      );
      END_STATE();
    case 501:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 314,
        '.', 505,
        'L', 506,
        'l', 509,
        'E', 310,
        'e', 310,
        'U', 508,
        'u', 508,
        'Z', 511,
        'z', 511,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(317);
      if (lookahead == 'B') ADVANCE(281);
      if (lookahead == 'b') ADVANCE(299);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(504);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(502);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 319,
        '.', 311,
        'L', 506,
        'l', 509,
        'P', 310,
        'p', 310,
        'U', 508,
        'u', 508,
        'Z', 511,
        'z', 511,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(503);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '1') ADVANCE(267);
      if (lookahead == '3') ADVANCE(266);
      if (lookahead == '6') ADVANCE(268);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        'B', 281,
        'b', 299,
        'E', 310,
        'e', 310,
        'F', 504,
        'f', 504,
        'L', 496,
        'l', 496,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(497);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(511);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(496);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(496);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(507);
      if (lookahead == 'l') ADVANCE(510);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(496);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(511);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(496);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(496);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(496);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(532);
      if (lookahead == '\r') ADVANCE(531);
      if (lookahead == 'U') ADVANCE(336);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == 'x') ADVANCE(322);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(534);
      if (lookahead != 0) ADVANCE(531);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(258);
      if (lookahead == '/') ADVANCE(639);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(109);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(528);
      if (lookahead == '/') ADVANCE(530);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(530);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(527);
      if (lookahead == '/') ADVANCE(530);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(528);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(527);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(528);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(526);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(529);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(530);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(530);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(109);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(531);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(533);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(531);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(535);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(536);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(538);
      if (lookahead == '\\') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(279);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(sym_true);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(sym_false);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(521);
      if (lookahead == '\'') ADVANCE(512);
      if (lookahead == 'R') ADVANCE(553);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(521);
      if (lookahead == 'R') ADVANCE(553);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(521);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(643);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(523);
      if (lookahead == '\'') ADVANCE(514);
      if (lookahead == 'R') ADVANCE(554);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(523);
      if (lookahead == 'R') ADVANCE(554);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(523);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(522);
      if (lookahead == '\'') ADVANCE(513);
      if (lookahead == '8') ADVANCE(555);
      if (lookahead == 'R') ADVANCE(558);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'i') ADVANCE(609);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(522);
      if (lookahead == '8') ADVANCE(556);
      if (lookahead == 'R') ADVANCE(558);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(522);
      if (lookahead == '8') ADVANCE(557);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'i') ADVANCE(609);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(522);
      if (lookahead == '8') ADVANCE(557);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(644);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(646);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(524);
      if (lookahead == '\'') ADVANCE(515);
      if (lookahead == 'R') ADVANCE(559);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(524);
      if (lookahead == 'R') ADVANCE(559);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(524);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(645);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(512);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(514);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(513);
      if (lookahead == '8') ADVANCE(563);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(515);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '1') ADVANCE(567);
      if (lookahead == '3') ADVANCE(565);
      if (lookahead == '6') ADVANCE(566);
      if (lookahead == '8') ADVANCE(576);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'p') ADVANCE(625);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '2') ADVANCE(576);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '4') ADVANCE(576);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '6') ADVANCE(576);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A') ADVANCE(571);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(540);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(541);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L') ADVANCE(573);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R') ADVANCE(574);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S') ADVANCE(570);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U') ADVANCE(569);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == '_') ADVANCE(582);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == '_') ADVANCE(622);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'a') ADVANCE(600);
      if (lookahead == 'l') ADVANCE(612);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'a') ADVANCE(600);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'a') ADVANCE(629);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'a') ADVANCE(616);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'a') ADVANCE(622);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'a') ADVANCE(604);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'b') ADVANCE(605);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'd') ADVANCE(475);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'd') ADVANCE(596);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'e') ADVANCE(540);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'e') ADVANCE(475);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'e') ADVANCE(541);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'e') ADVANCE(576);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'f') ADVANCE(576);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'f') ADVANCE(590);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'g') ADVANCE(608);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'h') ADVANCE(580);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'i') ADVANCE(630);
      if (lookahead == 's') ADVANCE(595);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'i') ADVANCE(630);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'i') ADVANCE(591);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'i') ADVANCE(592);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'i') ADVANCE(584);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'i') ADVANCE(609);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'l') ADVANCE(620);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'l') ADVANCE(475);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'l') ADVANCE(615);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'l') ADVANCE(602);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'l') ADVANCE(597);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'l') ADVANCE(587);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'l') ADVANCE(612);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'n') ADVANCE(621);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'n') ADVANCE(576);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'n') ADVANCE(623);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'o') ADVANCE(626);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'o') ADVANCE(598);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'o') ADVANCE(581);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'o') ADVANCE(601);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'o') ADVANCE(613);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'p') ADVANCE(625);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'r') ADVANCE(474);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'r') ADVANCE(585);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'r') ADVANCE(576);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'r') ADVANCE(628);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 's') ADVANCE(588);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 't') ADVANCE(474);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 't') ADVANCE(475);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 't') ADVANCE(564);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 't') ADVANCE(617);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 't') ADVANCE(618);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'u') ADVANCE(583);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'u') ADVANCE(603);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'u') ADVANCE(586);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'x') ADVANCE(575);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (lookahead == 'z') ADVANCE(589);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(639);
      if (lookahead == '/') ADVANCE(636);
      if (lookahead == '\\') ADVANCE(369);
      if (lookahead != 0) ADVANCE(637);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(634);
      if (lookahead != 0) ADVANCE(639);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(638);
      if (lookahead == '/') ADVANCE(636);
      if (lookahead == '\\') ADVANCE(635);
      if (lookahead != 0) ADVANCE(637);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(639);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(637);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(636);
      if (lookahead == '\\') ADVANCE(369);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(637);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(636);
      if (lookahead == '\\') ADVANCE(369);
      if (lookahead != 0) ADVANCE(637);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(639);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(162);
      if (lookahead != 0) ADVANCE(639);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(anon_sym_GT2);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(aux_sym_pure_virtual_clause_token1);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(anon_sym_R_DQUOTE);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(anon_sym_LR_DQUOTE);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(anon_sym_uR_DQUOTE);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(anon_sym_UR_DQUOTE);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(anon_sym_u8R_DQUOTE);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(anon_sym_DASH_GT_STAR);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(anon_sym_LPAREN_RPAREN);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(521);
      if (lookahead == 'R') ADVANCE(656);
      if (lookahead == '\\') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(643);
      if (lookahead == '\\') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(523);
      if (lookahead == 'R') ADVANCE(657);
      if (lookahead == '\\') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(522);
      if (lookahead == '8') ADVANCE(658);
      if (lookahead == 'R') ADVANCE(659);
      if (lookahead == '\\') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(644);
      if (lookahead == '\\') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(646);
      if (lookahead == '\\') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(524);
      if (lookahead == 'R') ADVANCE(660);
      if (lookahead == '\\') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(645);
      if (lookahead == '\\') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '\\') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(631);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'N') ADVANCE(1);
      if (lookahead == '\\') SKIP(2);
      if (lookahead == '_') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(12);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(14);
      if (lookahead == 'o') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(16);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      if (lookahead == 'v') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      if (lookahead == 'x') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'U') ADVANCE(24);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(25);
      END_STATE();
    case 3:
      if (lookahead == 'A') ADVANCE(26);
      if (lookahead == 'G') ADVANCE(27);
      if (lookahead == 'N') ADVANCE(28);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 4:
      if (lookahead == 'l') ADVANCE(32);
      if (lookahead == 'n') ADVANCE(33);
      if (lookahead == 's') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead == 'l') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 'x') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(46);
      if (lookahead == 'o') ADVANCE(47);
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 11:
      if (lookahead == 'f') ADVANCE(50);
      if (lookahead == 'm') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(52);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 13:
      if (lookahead == 'o') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(56);
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 'o') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(60);
      if (lookahead == 'p') ADVANCE(61);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'v') ADVANCE(63);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(66);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(67);
      if (lookahead == 'i') ADVANCE(68);
      if (lookahead == 't') ADVANCE(69);
      if (lookahead == 'w') ADVANCE(70);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(71);
      if (lookahead == 'h') ADVANCE(72);
      if (lookahead == 'r') ADVANCE(73);
      if (lookahead == 'y') ADVANCE(74);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(75);
      if (lookahead == 's') ADVANCE(76);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(77);
      if (lookahead == 'o') ADVANCE(78);
      END_STATE();
    case 22:
      if (lookahead == 'h') ADVANCE(79);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 24:
      if (lookahead == 'L') ADVANCE(81);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(82);
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 28:
      if (lookahead == 'o') ADVANCE(85);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        'a', 86,
        'b', 87,
        'c', 88,
        'd', 89,
        'e', 90,
        'f', 91,
        'i', 92,
        'l', 93,
        'r', 94,
        's', 95,
        't', 96,
        'u', 97,
        'v', 98,
      );
      END_STATE();
    case 30:
      if (lookahead == 'l') ADVANCE(99);
      END_STATE();
    case 31:
      if (lookahead == 'n') ADVANCE(100);
      END_STATE();
    case 32:
      if (lookahead == 'i') ADVANCE(101);
      END_STATE();
    case 33:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 34:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 36:
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 38:
      if (lookahead == 's') ADVANCE(107);
      if (lookahead == 't') ADVANCE(108);
      END_STATE();
    case 39:
      if (lookahead == 'a') ADVANCE(109);
      END_STATE();
    case 40:
      if (lookahead == '_') ADVANCE(110);
      if (lookahead == 'm') ADVANCE(111);
      if (lookahead == 'n') ADVANCE(112);
      END_STATE();
    case 41:
      if (lookahead == 'c') ADVANCE(113);
      if (lookahead == 'f') ADVANCE(114);
      if (lookahead == 'l') ADVANCE(115);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 43:
      if (lookahead == 's') ADVANCE(116);
      END_STATE();
    case 44:
      if (lookahead == 'u') ADVANCE(117);
      END_STATE();
    case 45:
      if (lookahead == 'p') ADVANCE(118);
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 46:
      if (lookahead == 'n') ADVANCE(120);
      END_STATE();
    case 47:
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(122);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 51:
      if (lookahead == 'p') ADVANCE(124);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(125);
      END_STATE();
    case 53:
      if (lookahead == 'n') ADVANCE(126);
      END_STATE();
    case 54:
      if (lookahead == 'd') ADVANCE(127);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(128);
      END_STATE();
    case 56:
      if (lookahead == 'm') ADVANCE(129);
      END_STATE();
    case 57:
      if (lookahead == 'w') ADVANCE(130);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'r') ADVANCE(132);
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 59:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 60:
      if (lookahead == 'f') ADVANCE(135);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '_') ADVANCE(137);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(139);
      if (lookahead == 'o') ADVANCE(140);
      END_STATE();
    case 65:
      if (lookahead == 'b') ADVANCE(141);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(142);
      if (lookahead == 'q') ADVANCE(143);
      if (lookahead == 's') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 67:
      if (lookahead == 'o') ADVANCE(146);
      END_STATE();
    case 68:
      if (lookahead == 'g') ADVANCE(147);
      if (lookahead == 'z') ADVANCE(148);
      END_STATE();
    case 69:
      if (lookahead == 'a') ADVANCE(149);
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(151);
      END_STATE();
    case 71:
      if (lookahead == 'm') ADVANCE(152);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(153);
      if (lookahead == 'r') ADVANCE(154);
      END_STATE();
    case 73:
      if (lookahead == 'y') ADVANCE(155);
      END_STATE();
    case 74:
      if (lookahead == 'p') ADVANCE(156);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(157);
      if (lookahead == 's') ADVANCE(158);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(159);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(160);
      END_STATE();
    case 78:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 79:
      if (lookahead == 'i') ADVANCE(162);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(163);
      END_STATE();
    case 81:
      if (lookahead == 'L') ADVANCE(164);
      END_STATE();
    case 82:
      if (lookahead == 'i') ADVANCE(165);
      END_STATE();
    case 83:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 84:
      if (lookahead == 'n') ADVANCE(167);
      END_STATE();
    case 85:
      if (lookahead == 'n') ADVANCE(168);
      if (lookahead == 'r') ADVANCE(169);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(170);
      if (lookahead == 's') ADVANCE(171);
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(173);
      END_STATE();
    case 88:
      if (lookahead == 'd') ADVANCE(174);
      if (lookahead == 'l') ADVANCE(175);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 90:
      if (lookahead == 'x') ADVANCE(177);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(178);
      if (lookahead == 'i') ADVANCE(179);
      if (lookahead == 'o') ADVANCE(180);
      END_STATE();
    case 92:
      if (lookahead == 'n') ADVANCE(181);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 95:
      if (lookahead == 'p') ADVANCE(184);
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 96:
      if (lookahead == 'h') ADVANCE(186);
      if (lookahead == 'r') ADVANCE(187);
      END_STATE();
    case 97:
      if (lookahead == 'n') ADVANCE(188);
      if (lookahead == 'p') ADVANCE(189);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(190);
      if (lookahead == 'o') ADVANCE(191);
      END_STATE();
    case 99:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 100:
      if (lookahead == 'a') ADVANCE(193);
      END_STATE();
    case 101:
      if (lookahead == 'g') ADVANCE(194);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '_') ADVANCE(195);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 104:
      if (lookahead == 'o') ADVANCE(196);
      END_STATE();
    case 105:
      if (lookahead == 'a') ADVANCE(197);
      if (lookahead == 'o') ADVANCE(198);
      END_STATE();
    case 106:
      if (lookahead == 'a') ADVANCE(199);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(200);
      END_STATE();
    case 108:
      if (lookahead == 'c') ADVANCE(201);
      END_STATE();
    case 109:
      if (lookahead == 's') ADVANCE(202);
      END_STATE();
    case 110:
      if (lookahead == 'a') ADVANCE(203);
      if (lookahead == 'r') ADVANCE(204);
      if (lookahead == 'y') ADVANCE(205);
      END_STATE();
    case 111:
      if (lookahead == 'p') ADVANCE(206);
      END_STATE();
    case 112:
      if (lookahead == 'c') ADVANCE(207);
      if (lookahead == 's') ADVANCE(208);
      if (lookahead == 't') ADVANCE(209);
      END_STATE();
    case 113:
      if (lookahead == 'l') ADVANCE(210);
      END_STATE();
    case 114:
      if (lookahead == 'a') ADVANCE(211);
      if (lookahead == 'i') ADVANCE(212);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(213);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 117:
      if (lookahead == 'm') ADVANCE(215);
      END_STATE();
    case 118:
      if (lookahead == 'l') ADVANCE(216);
      if (lookahead == 'o') ADVANCE(217);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 120:
      if (lookahead == 'a') ADVANCE(219);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 123:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 124:
      if (lookahead == 'o') ADVANCE(222);
      END_STATE();
    case 125:
      if (lookahead == 'i') ADVANCE(223);
      END_STATE();
    case 126:
      if (lookahead == 'g') ADVANCE(224);
      END_STATE();
    case 127:
      if (lookahead == 'u') ADVANCE(225);
      END_STATE();
    case 128:
      if (lookahead == 'a') ADVANCE(226);
      END_STATE();
    case 129:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 131:
      if (lookahead == 'x') ADVANCE(228);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '_') ADVANCE(230);
      END_STATE();
    case 134:
      if (lookahead == 'l') ADVANCE(231);
      END_STATE();
    case 135:
      if (lookahead == 's') ADVANCE(232);
      END_STATE();
    case 136:
      if (lookahead == 'r') ADVANCE(233);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 138:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 139:
      if (lookahead == 'v') ADVANCE(236);
      END_STATE();
    case 140:
      if (lookahead == 't') ADVANCE(237);
      END_STATE();
    case 141:
      if (lookahead == 'l') ADVANCE(238);
      END_STATE();
    case 142:
      if (lookahead == 'i') ADVANCE(239);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(240);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 145:
      if (lookahead == 'u') ADVANCE(242);
      END_STATE();
    case 146:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 147:
      if (lookahead == 'n') ADVANCE(244);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 149:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 150:
      if (lookahead == 'u') ADVANCE(247);
      END_STATE();
    case 151:
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 152:
      if (lookahead == 'p') ADVANCE(249);
      END_STATE();
    case 153:
      if (lookahead == 's') ADVANCE(250);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(251);
      if (lookahead == 'o') ADVANCE(252);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 156:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 157:
      if (lookahead == 'o') ADVANCE(254);
      END_STATE();
    case 158:
      if (lookahead == 'i') ADVANCE(255);
      END_STATE();
    case 159:
      if (lookahead == 'n') ADVANCE(256);
      END_STATE();
    case 160:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 161:
      if (lookahead == 'a') ADVANCE(258);
      END_STATE();
    case 162:
      if (lookahead == 'l') ADVANCE(259);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == '_') ADVANCE(260);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 165:
      if (lookahead == 'g') ADVANCE(261);
      END_STATE();
    case 166:
      if (lookahead == 'm') ADVANCE(262);
      END_STATE();
    case 167:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 168:
      if (lookahead == 'n') ADVANCE(264);
      END_STATE();
    case 169:
      if (lookahead == 'e') ADVANCE(265);
      END_STATE();
    case 170:
      if (lookahead == 'i') ADVANCE(266);
      END_STATE();
    case 171:
      if (lookahead == 'm') ADVANCE(267);
      END_STATE();
    case 172:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 173:
      if (lookahead == 's') ADVANCE(269);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(270);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(271);
      END_STATE();
    case 176:
      if (lookahead == 'c') ADVANCE(272);
      END_STATE();
    case 177:
      if (lookahead == 'c') ADVANCE(273);
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 178:
      if (lookahead == 's') ADVANCE(275);
      END_STATE();
    case 179:
      if (lookahead == 'n') ADVANCE(276);
      END_STATE();
    case 180:
      if (lookahead == 'r') ADVANCE(277);
      END_STATE();
    case 181:
      if (lookahead == 'l') ADVANCE(278);
      END_STATE();
    case 182:
      if (lookahead == 'a') ADVANCE(279);
      END_STATE();
    case 183:
      if (lookahead == 's') ADVANCE(280);
      END_STATE();
    case 184:
      if (lookahead == 't') ADVANCE(281);
      END_STATE();
    case 185:
      if (lookahead == 'd') ADVANCE(282);
      END_STATE();
    case 186:
      if (lookahead == 'i') ADVANCE(283);
      if (lookahead == 'r') ADVANCE(284);
      END_STATE();
    case 187:
      if (lookahead == 'y') ADVANCE(285);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(286);
      END_STATE();
    case 189:
      if (lookahead == 't') ADVANCE(287);
      END_STATE();
    case 190:
      if (lookahead == 'c') ADVANCE(288);
      END_STATE();
    case 191:
      if (lookahead == 'l') ADVANCE(289);
      END_STATE();
    case 192:
      if (lookahead == 'g') ADVANCE(290);
      END_STATE();
    case 193:
      if (lookahead == 'l') ADVANCE(291);
      END_STATE();
    case 194:
      if (lookahead == 'n') ADVANCE(292);
      END_STATE();
    case 195:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_auto);
      END_STATE();
    case 197:
      if (lookahead == 'n') ADVANCE(294);
      END_STATE();
    case 198:
      if (lookahead == 'r') ADVANCE(295);
      END_STATE();
    case 199:
      if (lookahead == 'k') ADVANCE(296);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 201:
      if (lookahead == 'h') ADVANCE(297);
      END_STATE();
    case 202:
      if (lookahead == 's') ADVANCE(298);
      END_STATE();
    case 203:
      if (lookahead == 'w') ADVANCE(299);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 205:
      if (lookahead == 'i') ADVANCE(301);
      END_STATE();
    case 206:
      if (lookahead == 'l') ADVANCE(302);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 208:
      if (lookahead == 't') ADVANCE(304);
      END_STATE();
    case 209:
      if (lookahead == 'i') ADVANCE(305);
      END_STATE();
    case 210:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 211:
      if (lookahead == 'u') ADVANCE(307);
      END_STATE();
    case 212:
      if (lookahead == 'n') ADVANCE(308);
      END_STATE();
    case 213:
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 216:
      if (lookahead == 'i') ADVANCE(310);
      END_STATE();
    case 217:
      if (lookahead == 'r') ADVANCE(311);
      END_STATE();
    case 218:
      if (lookahead == 'r') ADVANCE(312);
      END_STATE();
    case 219:
      if (lookahead == 'l') ADVANCE(313);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(314);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 222:
      if (lookahead == 'r') ADVANCE(315);
      END_STATE();
    case 223:
      if (lookahead == 'n') ADVANCE(316);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 225:
      if (lookahead == 'l') ADVANCE(317);
      END_STATE();
    case 226:
      if (lookahead == 'b') ADVANCE(318);
      END_STATE();
    case 227:
      if (lookahead == 's') ADVANCE(319);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(320);
      END_STATE();
    case 229:
      if (lookahead == 't') ADVANCE(321);
      END_STATE();
    case 230:
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 231:
      if (lookahead == 'p') ADVANCE(323);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(324);
      END_STATE();
    case 233:
      if (lookahead == 'a') ADVANCE(325);
      END_STATE();
    case 234:
      if (lookahead == 'q') ADVANCE(326);
      END_STATE();
    case 235:
      if (lookahead == 'r') ADVANCE(327);
      END_STATE();
    case 236:
      if (lookahead == 'a') ADVANCE(328);
      END_STATE();
    case 237:
      if (lookahead == 'e') ADVANCE(329);
      END_STATE();
    case 238:
      if (lookahead == 'i') ADVANCE(330);
      END_STATE();
    case 239:
      if (lookahead == 's') ADVANCE(331);
      END_STATE();
    case 240:
      if (lookahead == 'i') ADVANCE(332);
      END_STATE();
    case 241:
      if (lookahead == 'r') ADVANCE(333);
      END_STATE();
    case 242:
      if (lookahead == 'r') ADVANCE(334);
      END_STATE();
    case 243:
      if (lookahead == 't') ADVANCE(335);
      END_STATE();
    case 244:
      if (lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 245:
      if (lookahead == 'o') ADVANCE(337);
      END_STATE();
    case 246:
      if (lookahead == 'i') ADVANCE(338);
      END_STATE();
    case 247:
      if (lookahead == 'c') ADVANCE(339);
      END_STATE();
    case 248:
      if (lookahead == 'c') ADVANCE(340);
      END_STATE();
    case 249:
      if (lookahead == 'l') ADVANCE(341);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 251:
      if (lookahead == 'a') ADVANCE(342);
      END_STATE();
    case 252:
      if (lookahead == 'w') ADVANCE(343);
      END_STATE();
    case 253:
      if (lookahead == 'd') ADVANCE(344);
      if (lookahead == 'n') ADVANCE(345);
      END_STATE();
    case 254:
      if (lookahead == 'n') ADVANCE(346);
      END_STATE();
    case 255:
      if (lookahead == 'g') ADVANCE(347);
      END_STATE();
    case 256:
      if (lookahead == 'g') ADVANCE(348);
      END_STATE();
    case 257:
      if (lookahead == 'u') ADVANCE(349);
      END_STATE();
    case 258:
      if (lookahead == 't') ADVANCE(350);
      END_STATE();
    case 259:
      if (lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 260:
      if (lookahead == 'e') ADVANCE(352);
      END_STATE();
    case 261:
      if (lookahead == 'n') ADVANCE(353);
      END_STATE();
    case 262:
      if (lookahead == 'i') ADVANCE(354);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(355);
      END_STATE();
    case 264:
      if (lookahead == 'u') ADVANCE(356);
      END_STATE();
    case 265:
      if (lookahead == 't') ADVANCE(357);
      END_STATE();
    case 266:
      if (lookahead == 'g') ADVANCE(358);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym___asm);
      if (lookahead == '_') ADVANCE(359);
      END_STATE();
    case 268:
      if (lookahead == 'r') ADVANCE(360);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(361);
      END_STATE();
    case 270:
      if (lookahead == 'c') ADVANCE(362);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(363);
      END_STATE();
    case 272:
      if (lookahead == 'l') ADVANCE(364);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(365);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 275:
      if (lookahead == 't') ADVANCE(367);
      END_STATE();
    case 276:
      if (lookahead == 'a') ADVANCE(368);
      END_STATE();
    case 277:
      if (lookahead == 'c') ADVANCE(369);
      END_STATE();
    case 278:
      if (lookahead == 'i') ADVANCE(370);
      END_STATE();
    case 279:
      if (lookahead == 'v') ADVANCE(371);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(372);
      END_STATE();
    case 281:
      if (lookahead == 'r') ADVANCE(373);
      END_STATE();
    case 282:
      if (lookahead == 'c') ADVANCE(374);
      END_STATE();
    case 283:
      if (lookahead == 's') ADVANCE(375);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(376);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 286:
      if (lookahead == 'l') ADVANCE(377);
      END_STATE();
    case 287:
      if (lookahead == 'r') ADVANCE(378);
      END_STATE();
    case 288:
      if (lookahead == 't') ADVANCE(379);
      END_STATE();
    case 289:
      if (lookahead == 'a') ADVANCE(380);
      END_STATE();
    case 290:
      if (lookahead == 'n') ADVANCE(381);
      END_STATE();
    case 291:
      if (lookahead == 'i') ADVANCE(382);
      END_STATE();
    case 292:
      if (lookahead == 'a') ADVANCE(383);
      if (lookahead == 'o') ADVANCE(384);
      END_STATE();
    case 293:
      if (lookahead == 'q') ADVANCE(385);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(386);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_bitor);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 299:
      if (lookahead == 'a') ADVANCE(387);
      END_STATE();
    case 300:
      if (lookahead == 't') ADVANCE(388);
      END_STATE();
    case 301:
      if (lookahead == 'e') ADVANCE(389);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_compl);
      END_STATE();
    case 303:
      if (lookahead == 'p') ADVANCE(390);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(391);
      if (lookahead == 'i') ADVANCE(392);
      END_STATE();
    case 305:
      if (lookahead == 'n') ADVANCE(393);
      END_STATE();
    case 306:
      if (lookahead == 'y') ADVANCE(394);
      END_STATE();
    case 307:
      if (lookahead == 'l') ADVANCE(395);
      END_STATE();
    case 308:
      if (lookahead == 'e') ADVANCE(396);
      END_STATE();
    case 309:
      if (lookahead == 'e') ADVANCE(397);
      END_STATE();
    case 310:
      if (lookahead == 'c') ADVANCE(398);
      END_STATE();
    case 311:
      if (lookahead == 't') ADVANCE(399);
      END_STATE();
    case 312:
      if (lookahead == 'n') ADVANCE(400);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_final);
      END_STATE();
    case 314:
      if (lookahead == 'd') ADVANCE(401);
      END_STATE();
    case 315:
      if (lookahead == 't') ADVANCE(402);
      END_STATE();
    case 316:
      if (lookahead == 'e') ADVANCE(403);
      END_STATE();
    case 317:
      if (lookahead == 'e') ADVANCE(404);
      END_STATE();
    case 318:
      if (lookahead == 'l') ADVANCE(405);
      END_STATE();
    case 319:
      if (lookahead == 'p') ADVANCE(406);
      END_STATE();
    case 320:
      if (lookahead == 'e') ADVANCE(407);
      END_STATE();
    case 321:
      if (lookahead == 'u') ADVANCE(408);
      END_STATE();
    case 322:
      if (lookahead == 'q') ADVANCE(409);
      END_STATE();
    case 323:
      if (lookahead == 't') ADVANCE(410);
      END_STATE();
    case 324:
      if (lookahead == 't') ADVANCE(411);
      END_STATE();
    case 325:
      if (lookahead == 't') ADVANCE(412);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_or_eq);
      END_STATE();
    case 327:
      if (lookahead == 'i') ADVANCE(413);
      END_STATE();
    case 328:
      if (lookahead == 't') ADVANCE(414);
      END_STATE();
    case 329:
      if (lookahead == 'c') ADVANCE(415);
      END_STATE();
    case 330:
      if (lookahead == 'c') ADVANCE(416);
      END_STATE();
    case 331:
      if (lookahead == 't') ADVANCE(417);
      END_STATE();
    case 332:
      if (lookahead == 'r') ADVANCE(418);
      END_STATE();
    case 333:
      if (lookahead == 'i') ADVANCE(419);
      END_STATE();
    case 334:
      if (lookahead == 'n') ADVANCE(420);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 336:
      if (lookahead == 'd') ADVANCE(421);
      END_STATE();
    case 337:
      if (lookahead == 'f') ADVANCE(422);
      END_STATE();
    case 338:
      if (lookahead == 'c') ADVANCE(423);
      END_STATE();
    case 339:
      if (lookahead == 't') ADVANCE(424);
      END_STATE();
    case 340:
      if (lookahead == 'h') ADVANCE(425);
      END_STATE();
    case 341:
      if (lookahead == 'a') ADVANCE(426);
      END_STATE();
    case 342:
      if (lookahead == 'd') ADVANCE(427);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 344:
      if (lookahead == 'e') ADVANCE(428);
      END_STATE();
    case 345:
      if (lookahead == 'a') ADVANCE(429);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 347:
      if (lookahead == 'n') ADVANCE(430);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 349:
      if (lookahead == 'a') ADVANCE(431);
      END_STATE();
    case 350:
      if (lookahead == 'i') ADVANCE(432);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 352:
      if (lookahead == 'q') ADVANCE(433);
      END_STATE();
    case 353:
      if (lookahead == 'a') ADVANCE(434);
      if (lookahead == 'o') ADVANCE(435);
      END_STATE();
    case 354:
      if (lookahead == 'c') ADVANCE(436);
      END_STATE();
    case 355:
      if (lookahead == 'i') ADVANCE(437);
      END_STATE();
    case 356:
      if (lookahead == 'l') ADVANCE(438);
      END_STATE();
    case 357:
      if (lookahead == 'u') ADVANCE(439);
      END_STATE();
    case 358:
      if (lookahead == 'n') ADVANCE(440);
      END_STATE();
    case 359:
      if (lookahead == '_') ADVANCE(441);
      END_STATE();
    case 360:
      if (lookahead == 'i') ADVANCE(442);
      END_STATE();
    case 361:
      if (lookahead == 'd') ADVANCE(443);
      END_STATE();
    case 362:
      if (lookahead == 'l') ADVANCE(444);
      END_STATE();
    case 363:
      if (lookahead == 'a') ADVANCE(445);
      END_STATE();
    case 364:
      if (lookahead == 's') ADVANCE(446);
      END_STATE();
    case 365:
      if (lookahead == 'p') ADVANCE(447);
      END_STATE();
    case 366:
      if (lookahead == 'n') ADVANCE(448);
      END_STATE();
    case 367:
      if (lookahead == 'c') ADVANCE(449);
      END_STATE();
    case 368:
      if (lookahead == 'l') ADVANCE(450);
      END_STATE();
    case 369:
      if (lookahead == 'e') ADVANCE(451);
      END_STATE();
    case 370:
      if (lookahead == 'n') ADVANCE(452);
      END_STATE();
    case 371:
      if (lookahead == 'e') ADVANCE(453);
      END_STATE();
    case 372:
      if (lookahead == 'r') ADVANCE(454);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 374:
      if (lookahead == 'a') ADVANCE(455);
      END_STATE();
    case 375:
      if (lookahead == 'c') ADVANCE(456);
      END_STATE();
    case 376:
      if (lookahead == 'a') ADVANCE(457);
      END_STATE();
    case 377:
      if (lookahead == 'i') ADVANCE(458);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 379:
      if (lookahead == 'o') ADVANCE(459);
      END_STATE();
    case 380:
      if (lookahead == 't') ADVANCE(460);
      END_STATE();
    case 381:
      if (lookahead == 'o') ADVANCE(461);
      END_STATE();
    case 382:
      if (lookahead == 'g') ADVANCE(462);
      END_STATE();
    case 383:
      if (lookahead == 's') ADVANCE(463);
      END_STATE();
    case 384:
      if (lookahead == 'f') ADVANCE(464);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_and_eq);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_bitand);
      END_STATE();
    case 387:
      if (lookahead == 'i') ADVANCE(465);
      END_STATE();
    case 388:
      if (lookahead == 'u') ADVANCE(466);
      END_STATE();
    case 389:
      if (lookahead == 'l') ADVANCE(467);
      END_STATE();
    case 390:
      if (lookahead == 't') ADVANCE(468);
      END_STATE();
    case 391:
      if (lookahead == 'v') ADVANCE(469);
      if (lookahead == 'x') ADVANCE(470);
      END_STATE();
    case 392:
      if (lookahead == 'n') ADVANCE(471);
      END_STATE();
    case 393:
      if (lookahead == 'u') ADVANCE(472);
      END_STATE();
    case 394:
      if (lookahead == 'p') ADVANCE(473);
      END_STATE();
    case 395:
      if (lookahead == 't') ADVANCE(474);
      END_STATE();
    case 396:
      if (lookahead == 'd') ADVANCE(475);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 398:
      if (lookahead == 'i') ADVANCE(476);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_friend);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 405:
      if (lookahead == 'e') ADVANCE(477);
      END_STATE();
    case 406:
      if (lookahead == 'a') ADVANCE(478);
      END_STATE();
    case 407:
      if (lookahead == 'p') ADVANCE(479);
      END_STATE();
    case 408:
      if (lookahead == 'r') ADVANCE(480);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_not_eq);
      END_STATE();
    case 410:
      if (lookahead == 'r') ADVANCE(481);
      END_STATE();
    case 411:
      if (lookahead == 'o') ADVANCE(482);
      END_STATE();
    case 412:
      if (lookahead == 'o') ADVANCE(483);
      END_STATE();
    case 413:
      if (lookahead == 'd') ADVANCE(484);
      END_STATE();
    case 414:
      if (lookahead == 'e') ADVANCE(485);
      END_STATE();
    case 415:
      if (lookahead == 't') ADVANCE(486);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 417:
      if (lookahead == 'e') ADVANCE(487);
      END_STATE();
    case 418:
      if (lookahead == 'e') ADVANCE(488);
      END_STATE();
    case 419:
      if (lookahead == 'c') ADVANCE(489);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_static);
      if (lookahead == '_') ADVANCE(490);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 426:
      if (lookahead == 't') ADVANCE(491);
      END_STATE();
    case 427:
      if (lookahead == '_') ADVANCE(492);
      END_STATE();
    case 428:
      if (lookahead == 'f') ADVANCE(493);
      END_STATE();
    case 429:
      if (lookahead == 'm') ADVANCE(494);
      END_STATE();
    case 430:
      if (lookahead == 'e') ADVANCE(495);
      END_STATE();
    case 431:
      if (lookahead == 'l') ADVANCE(496);
      END_STATE();
    case 432:
      if (lookahead == 'l') ADVANCE(497);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_xor_eq);
      END_STATE();
    case 434:
      if (lookahead == 's') ADVANCE(498);
      END_STATE();
    case 435:
      if (lookahead == 'f') ADVANCE(499);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 437:
      if (lookahead == 'c') ADVANCE(500);
      END_STATE();
    case 438:
      if (lookahead == 'l') ADVANCE(501);
      END_STATE();
    case 439:
      if (lookahead == 'r') ADVANCE(502);
      END_STATE();
    case 440:
      if (lookahead == 'o') ADVANCE(503);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 442:
      if (lookahead == 'b') ADVANCE(504);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 445:
      if (lookahead == 'l') ADVANCE(505);
      END_STATE();
    case 446:
      if (lookahead == 'p') ADVANCE(506);
      END_STATE();
    case 447:
      if (lookahead == 't') ADVANCE(507);
      END_STATE();
    case 448:
      if (lookahead == 's') ADVANCE(508);
      END_STATE();
    case 449:
      if (lookahead == 'a') ADVANCE(509);
      END_STATE();
    case 450:
      if (lookahead == 'l') ADVANCE(510);
      END_STATE();
    case 451:
      if (lookahead == 'i') ADVANCE(511);
      END_STATE();
    case 452:
      if (lookahead == 'e') ADVANCE(512);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 454:
      if (lookahead == 'i') ADVANCE(513);
      END_STATE();
    case 455:
      if (lookahead == 'l') ADVANCE(514);
      END_STATE();
    case 456:
      if (lookahead == 'a') ADVANCE(515);
      END_STATE();
    case 457:
      if (lookahead == 'd') ADVANCE(516);
      END_STATE();
    case 458:
      if (lookahead == 'g') ADVANCE(517);
      END_STATE();
    case 459:
      if (lookahead == 'r') ADVANCE(518);
      END_STATE();
    case 460:
      if (lookahead == 'i') ADVANCE(519);
      END_STATE();
    case 461:
      if (lookahead == 'f') ADVANCE(520);
      END_STATE();
    case 462:
      if (lookahead == 'n') ADVANCE(521);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_alignas);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 465:
      if (lookahead == 't') ADVANCE(522);
      END_STATE();
    case 466:
      if (lookahead == 'r') ADVANCE(523);
      END_STATE();
    case 467:
      if (lookahead == 'd') ADVANCE(524);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_concept);
      END_STATE();
    case 469:
      if (lookahead == 'a') ADVANCE(525);
      END_STATE();
    case 470:
      if (lookahead == 'p') ADVANCE(526);
      END_STATE();
    case 471:
      if (lookahead == 'i') ADVANCE(527);
      END_STATE();
    case 472:
      if (lookahead == 'e') ADVANCE(528);
      END_STATE();
    case 473:
      if (lookahead == 'e') ADVANCE(529);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 476:
      if (lookahead == 't') ADVANCE(530);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 478:
      if (lookahead == 'c') ADVANCE(531);
      END_STATE();
    case 479:
      if (lookahead == 't') ADVANCE(532);
      END_STATE();
    case 480:
      if (lookahead == 'n') ADVANCE(533);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_nullptr);
      END_STATE();
    case 482:
      if (lookahead == 'f') ADVANCE(534);
      END_STATE();
    case 483:
      if (lookahead == 'r') ADVANCE(535);
      END_STATE();
    case 484:
      if (lookahead == 'e') ADVANCE(536);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 486:
      if (lookahead == 'e') ADVANCE(537);
      END_STATE();
    case 487:
      if (lookahead == 'r') ADVANCE(538);
      END_STATE();
    case 488:
      if (lookahead == 's') ADVANCE(539);
      END_STATE();
    case 489:
      if (lookahead == 't') ADVANCE(540);
      END_STATE();
    case 490:
      if (lookahead == 'a') ADVANCE(541);
      END_STATE();
    case 491:
      if (lookahead == 'e') ADVANCE(542);
      END_STATE();
    case 492:
      if (lookahead == 'l') ADVANCE(543);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 494:
      if (lookahead == 'e') ADVANCE(544);
      END_STATE();
    case 495:
      if (lookahead == 'd') ADVANCE(545);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 497:
      if (lookahead == 'e') ADVANCE(546);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym__Alignas);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym__Nonnull);
      END_STATE();
    case 502:
      if (lookahead == 'n') ADVANCE(547);
      END_STATE();
    case 503:
      if (lookahead == 'f') ADVANCE(548);
      END_STATE();
    case 504:
      if (lookahead == 'u') ADVANCE(549);
      END_STATE();
    case 505:
      if (lookahead == 'l') ADVANCE(550);
      END_STATE();
    case 506:
      if (lookahead == 'e') ADVANCE(551);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 508:
      if (lookahead == 'i') ADVANCE(552);
      END_STATE();
    case 509:
      if (lookahead == 'l') ADVANCE(553);
      END_STATE();
    case 510:
      if (lookahead == 'y') ADVANCE(554);
      END_STATE();
    case 511:
      if (lookahead == 'n') ADVANCE(555);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(556);
      END_STATE();
    case 513:
      if (lookahead == 'c') ADVANCE(557);
      END_STATE();
    case 514:
      if (lookahead == 'l') ADVANCE(558);
      END_STATE();
    case 515:
      if (lookahead == 'l') ADVANCE(559);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 517:
      if (lookahead == 'n') ADVANCE(560);
      END_STATE();
    case 518:
      if (lookahead == 'c') ADVANCE(561);
      END_STATE();
    case 519:
      if (lookahead == 'l') ADVANCE(562);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 521:
      if (lookahead == 'e') ADVANCE(563);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_co_await);
      END_STATE();
    case 523:
      if (lookahead == 'n') ADVANCE(564);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_co_yield);
      END_STATE();
    case 525:
      if (lookahead == 'l') ADVANCE(565);
      END_STATE();
    case 526:
      if (lookahead == 'r') ADVANCE(566);
      END_STATE();
    case 527:
      if (lookahead == 't') ADVANCE(567);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_decltype);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 531:
      if (lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_noexcept);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 537:
      if (lookahead == 'd') ADVANCE(569);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 541:
      if (lookahead == 's') ADVANCE(570);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_template);
      END_STATE();
    case 543:
      if (lookahead == 'o') ADVANCE(571);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_typename);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(572);
      END_STATE();
    case 549:
      if (lookahead == 't') ADVANCE(573);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 551:
      if (lookahead == 'c') ADVANCE(574);
      END_STATE();
    case 552:
      if (lookahead == 'o') ADVANCE(575);
      END_STATE();
    case 553:
      if (lookahead == 'l') ADVANCE(576);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 555:
      if (lookahead == 'l') ADVANCE(577);
      END_STATE();
    case 556:
      if (lookahead == '_') ADVANCE(578);
      END_STATE();
    case 557:
      if (lookahead == 't') ADVANCE(579);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 559:
      if (lookahead == 'l') ADVANCE(580);
      END_STATE();
    case 560:
      if (lookahead == 'e') ADVANCE(581);
      END_STATE();
    case 561:
      if (lookahead == 'a') ADVANCE(582);
      END_STATE();
    case 562:
      if (lookahead == 'e') ADVANCE(583);
      END_STATE();
    case 563:
      if (lookahead == 'd') ADVANCE(584);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_co_return);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_consteval);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_constinit);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 570:
      if (lookahead == 's') ADVANCE(585);
      END_STATE();
    case 571:
      if (lookahead == 'c') ADVANCE(586);
      END_STATE();
    case 572:
      if (lookahead == '_') ADVANCE(587);
      END_STATE();
    case 573:
      if (lookahead == 'e') ADVANCE(588);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 575:
      if (lookahead == 'n') ADVANCE(589);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 577:
      if (lookahead == 'i') ADVANCE(590);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(591);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 581:
      if (lookahead == 'd') ADVANCE(592);
      END_STATE();
    case 582:
      if (lookahead == 'l') ADVANCE(593);
      END_STATE();
    case 583:
      if (lookahead == '_') ADVANCE(594);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 585:
      if (lookahead == 'e') ADVANCE(595);
      END_STATE();
    case 586:
      if (lookahead == 'a') ADVANCE(596);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym___attribute);
      if (lookahead == '_') ADVANCE(597);
      END_STATE();
    case 589:
      if (lookahead == '_') ADVANCE(598);
      END_STATE();
    case 590:
      if (lookahead == 'n') ADVANCE(599);
      END_STATE();
    case 591:
      if (lookahead == '_') ADVANCE(600);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 593:
      if (lookahead == 'l') ADVANCE(601);
      END_STATE();
    case 594:
      if (lookahead == '_') ADVANCE(602);
      END_STATE();
    case 595:
      if (lookahead == 'r') ADVANCE(603);
      END_STATE();
    case 596:
      if (lookahead == 'l') ADVANCE(604);
      END_STATE();
    case 597:
      if (lookahead == '_') ADVANCE(605);
      END_STATE();
    case 598:
      if (lookahead == '_') ADVANCE(606);
      END_STATE();
    case 599:
      if (lookahead == 'e') ADVANCE(607);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(anon_sym___volatile__);
      END_STATE();
    case 603:
      if (lookahead == 't') ADVANCE(608);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym_static_assert);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 339},
  [2] = {.lex_state = 339},
  [3] = {.lex_state = 339},
  [4] = {.lex_state = 339},
  [5] = {.lex_state = 339},
  [6] = {.lex_state = 339},
  [7] = {.lex_state = 339},
  [8] = {.lex_state = 339},
  [9] = {.lex_state = 339},
  [10] = {.lex_state = 339},
  [11] = {.lex_state = 339},
  [12] = {.lex_state = 339},
  [13] = {.lex_state = 171},
  [14] = {.lex_state = 171},
  [15] = {.lex_state = 171},
  [16] = {.lex_state = 171},
  [17] = {.lex_state = 171},
  [18] = {.lex_state = 171},
  [19] = {.lex_state = 171},
  [20] = {.lex_state = 171},
  [21] = {.lex_state = 171},
  [22] = {.lex_state = 171},
  [23] = {.lex_state = 171},
  [24] = {.lex_state = 171},
  [25] = {.lex_state = 171},
  [26] = {.lex_state = 171},
  [27] = {.lex_state = 171},
  [28] = {.lex_state = 171},
  [29] = {.lex_state = 171},
  [30] = {.lex_state = 171},
  [31] = {.lex_state = 171},
  [32] = {.lex_state = 171},
  [33] = {.lex_state = 171},
  [34] = {.lex_state = 339},
  [35] = {.lex_state = 339},
  [36] = {.lex_state = 339},
  [37] = {.lex_state = 174},
  [38] = {.lex_state = 174},
  [39] = {.lex_state = 339},
  [40] = {.lex_state = 339},
  [41] = {.lex_state = 339},
  [42] = {.lex_state = 339},
  [43] = {.lex_state = 339},
  [44] = {.lex_state = 339},
  [45] = {.lex_state = 339},
  [46] = {.lex_state = 339},
  [47] = {.lex_state = 339},
  [48] = {.lex_state = 339},
  [49] = {.lex_state = 339},
  [50] = {.lex_state = 339},
  [51] = {.lex_state = 174},
  [52] = {.lex_state = 339},
  [53] = {.lex_state = 339},
  [54] = {.lex_state = 339},
  [55] = {.lex_state = 339},
  [56] = {.lex_state = 339},
  [57] = {.lex_state = 339},
  [58] = {.lex_state = 339},
  [59] = {.lex_state = 339},
  [60] = {.lex_state = 339},
  [61] = {.lex_state = 339},
  [62] = {.lex_state = 339},
  [63] = {.lex_state = 339},
  [64] = {.lex_state = 339},
  [65] = {.lex_state = 339},
  [66] = {.lex_state = 339},
  [67] = {.lex_state = 339},
  [68] = {.lex_state = 339},
  [69] = {.lex_state = 339},
  [70] = {.lex_state = 339},
  [71] = {.lex_state = 339},
  [72] = {.lex_state = 339},
  [73] = {.lex_state = 339},
  [74] = {.lex_state = 339},
  [75] = {.lex_state = 339},
  [76] = {.lex_state = 339},
  [77] = {.lex_state = 339},
  [78] = {.lex_state = 339},
  [79] = {.lex_state = 339},
  [80] = {.lex_state = 339},
  [81] = {.lex_state = 339},
  [82] = {.lex_state = 339},
  [83] = {.lex_state = 339},
  [84] = {.lex_state = 339},
  [85] = {.lex_state = 171},
  [86] = {.lex_state = 171},
  [87] = {.lex_state = 171},
  [88] = {.lex_state = 171},
  [89] = {.lex_state = 171},
  [90] = {.lex_state = 339},
  [91] = {.lex_state = 339},
  [92] = {.lex_state = 339},
  [93] = {.lex_state = 339},
  [94] = {.lex_state = 339},
  [95] = {.lex_state = 339},
  [96] = {.lex_state = 339},
  [97] = {.lex_state = 174},
  [98] = {.lex_state = 174},
  [99] = {.lex_state = 174},
  [100] = {.lex_state = 339},
  [101] = {.lex_state = 339},
  [102] = {.lex_state = 174},
  [103] = {.lex_state = 339},
  [104] = {.lex_state = 174},
  [105] = {.lex_state = 173},
  [106] = {.lex_state = 173},
  [107] = {.lex_state = 173},
  [108] = {.lex_state = 173},
  [109] = {.lex_state = 173},
  [110] = {.lex_state = 173},
  [111] = {.lex_state = 173},
  [112] = {.lex_state = 173},
  [113] = {.lex_state = 173},
  [114] = {.lex_state = 173},
  [115] = {.lex_state = 173},
  [116] = {.lex_state = 173},
  [117] = {.lex_state = 173},
  [118] = {.lex_state = 173},
  [119] = {.lex_state = 173},
  [120] = {.lex_state = 173},
  [121] = {.lex_state = 173},
  [122] = {.lex_state = 173},
  [123] = {.lex_state = 173},
  [124] = {.lex_state = 175},
  [125] = {.lex_state = 175},
  [126] = {.lex_state = 175},
  [127] = {.lex_state = 173},
  [128] = {.lex_state = 173},
  [129] = {.lex_state = 173},
  [130] = {.lex_state = 173},
  [131] = {.lex_state = 173},
  [132] = {.lex_state = 173},
  [133] = {.lex_state = 173},
  [134] = {.lex_state = 173},
  [135] = {.lex_state = 339},
  [136] = {.lex_state = 339},
  [137] = {.lex_state = 164},
  [138] = {.lex_state = 164},
  [139] = {.lex_state = 176},
  [140] = {.lex_state = 173},
  [141] = {.lex_state = 173},
  [142] = {.lex_state = 176},
  [143] = {.lex_state = 176},
  [144] = {.lex_state = 176},
  [145] = {.lex_state = 173},
  [146] = {.lex_state = 173},
  [147] = {.lex_state = 173},
  [148] = {.lex_state = 176},
  [149] = {.lex_state = 176},
  [150] = {.lex_state = 173},
  [151] = {.lex_state = 173},
  [152] = {.lex_state = 176},
  [153] = {.lex_state = 176},
  [154] = {.lex_state = 176},
  [155] = {.lex_state = 176},
  [156] = {.lex_state = 176},
  [157] = {.lex_state = 176},
  [158] = {.lex_state = 164},
  [159] = {.lex_state = 176},
  [160] = {.lex_state = 176},
  [161] = {.lex_state = 176},
  [162] = {.lex_state = 176},
  [163] = {.lex_state = 176},
  [164] = {.lex_state = 173},
  [165] = {.lex_state = 176},
  [166] = {.lex_state = 176},
  [167] = {.lex_state = 176},
  [168] = {.lex_state = 176},
  [169] = {.lex_state = 176},
  [170] = {.lex_state = 176},
  [171] = {.lex_state = 176},
  [172] = {.lex_state = 176},
  [173] = {.lex_state = 176},
  [174] = {.lex_state = 173},
  [175] = {.lex_state = 173},
  [176] = {.lex_state = 173},
  [177] = {.lex_state = 173},
  [178] = {.lex_state = 173},
  [179] = {.lex_state = 173},
  [180] = {.lex_state = 173},
  [181] = {.lex_state = 173},
  [182] = {.lex_state = 173},
  [183] = {.lex_state = 173},
  [184] = {.lex_state = 173},
  [185] = {.lex_state = 173},
  [186] = {.lex_state = 173},
  [187] = {.lex_state = 173},
  [188] = {.lex_state = 173},
  [189] = {.lex_state = 173},
  [190] = {.lex_state = 173},
  [191] = {.lex_state = 173},
  [192] = {.lex_state = 173},
  [193] = {.lex_state = 173},
  [194] = {.lex_state = 173},
  [195] = {.lex_state = 173},
  [196] = {.lex_state = 173},
  [197] = {.lex_state = 173},
  [198] = {.lex_state = 173},
  [199] = {.lex_state = 173},
  [200] = {.lex_state = 173},
  [201] = {.lex_state = 173},
  [202] = {.lex_state = 173},
  [203] = {.lex_state = 173},
  [204] = {.lex_state = 173},
  [205] = {.lex_state = 173},
  [206] = {.lex_state = 173},
  [207] = {.lex_state = 173},
  [208] = {.lex_state = 173},
  [209] = {.lex_state = 166},
  [210] = {.lex_state = 173},
  [211] = {.lex_state = 173},
  [212] = {.lex_state = 173},
  [213] = {.lex_state = 173},
  [214] = {.lex_state = 173},
  [215] = {.lex_state = 173},
  [216] = {.lex_state = 173},
  [217] = {.lex_state = 173},
  [218] = {.lex_state = 173},
  [219] = {.lex_state = 173},
  [220] = {.lex_state = 173},
  [221] = {.lex_state = 173},
  [222] = {.lex_state = 173},
  [223] = {.lex_state = 173},
  [224] = {.lex_state = 171},
  [225] = {.lex_state = 171},
  [226] = {.lex_state = 167},
  [227] = {.lex_state = 164},
  [228] = {.lex_state = 171},
  [229] = {.lex_state = 339},
  [230] = {.lex_state = 171},
  [231] = {.lex_state = 339},
  [232] = {.lex_state = 339},
  [233] = {.lex_state = 339},
  [234] = {.lex_state = 339},
  [235] = {.lex_state = 339},
  [236] = {.lex_state = 166},
  [237] = {.lex_state = 171},
  [238] = {.lex_state = 171},
  [239] = {.lex_state = 171},
  [240] = {.lex_state = 171},
  [241] = {.lex_state = 171},
  [242] = {.lex_state = 171},
  [243] = {.lex_state = 171},
  [244] = {.lex_state = 171},
  [245] = {.lex_state = 171},
  [246] = {.lex_state = 171},
  [247] = {.lex_state = 171},
  [248] = {.lex_state = 171},
  [249] = {.lex_state = 171},
  [250] = {.lex_state = 171},
  [251] = {.lex_state = 339},
  [252] = {.lex_state = 171},
  [253] = {.lex_state = 171},
  [254] = {.lex_state = 171},
  [255] = {.lex_state = 171},
  [256] = {.lex_state = 171},
  [257] = {.lex_state = 171},
  [258] = {.lex_state = 171},
  [259] = {.lex_state = 171},
  [260] = {.lex_state = 339},
  [261] = {.lex_state = 171},
  [262] = {.lex_state = 171},
  [263] = {.lex_state = 171},
  [264] = {.lex_state = 171},
  [265] = {.lex_state = 171},
  [266] = {.lex_state = 171},
  [267] = {.lex_state = 171},
  [268] = {.lex_state = 171},
  [269] = {.lex_state = 171},
  [270] = {.lex_state = 171},
  [271] = {.lex_state = 171},
  [272] = {.lex_state = 171},
  [273] = {.lex_state = 171},
  [274] = {.lex_state = 171},
  [275] = {.lex_state = 171},
  [276] = {.lex_state = 171},
  [277] = {.lex_state = 171},
  [278] = {.lex_state = 171},
  [279] = {.lex_state = 171},
  [280] = {.lex_state = 171},
  [281] = {.lex_state = 171},
  [282] = {.lex_state = 339},
  [283] = {.lex_state = 171},
  [284] = {.lex_state = 171},
  [285] = {.lex_state = 171},
  [286] = {.lex_state = 171},
  [287] = {.lex_state = 171},
  [288] = {.lex_state = 171},
  [289] = {.lex_state = 339},
  [290] = {.lex_state = 171},
  [291] = {.lex_state = 171},
  [292] = {.lex_state = 171},
  [293] = {.lex_state = 171},
  [294] = {.lex_state = 171},
  [295] = {.lex_state = 171},
  [296] = {.lex_state = 171},
  [297] = {.lex_state = 339},
  [298] = {.lex_state = 339},
  [299] = {.lex_state = 339},
  [300] = {.lex_state = 339},
  [301] = {.lex_state = 171},
  [302] = {.lex_state = 171},
  [303] = {.lex_state = 171},
  [304] = {.lex_state = 171},
  [305] = {.lex_state = 171},
  [306] = {.lex_state = 171},
  [307] = {.lex_state = 171},
  [308] = {.lex_state = 171},
  [309] = {.lex_state = 171},
  [310] = {.lex_state = 171},
  [311] = {.lex_state = 171},
  [312] = {.lex_state = 171},
  [313] = {.lex_state = 171},
  [314] = {.lex_state = 171},
  [315] = {.lex_state = 171},
  [316] = {.lex_state = 171},
  [317] = {.lex_state = 171},
  [318] = {.lex_state = 171},
  [319] = {.lex_state = 171},
  [320] = {.lex_state = 171},
  [321] = {.lex_state = 171},
  [322] = {.lex_state = 171},
  [323] = {.lex_state = 339},
  [324] = {.lex_state = 171},
  [325] = {.lex_state = 171},
  [326] = {.lex_state = 171},
  [327] = {.lex_state = 171},
  [328] = {.lex_state = 171},
  [329] = {.lex_state = 171},
  [330] = {.lex_state = 171},
  [331] = {.lex_state = 171},
  [332] = {.lex_state = 171},
  [333] = {.lex_state = 171},
  [334] = {.lex_state = 171},
  [335] = {.lex_state = 171},
  [336] = {.lex_state = 171},
  [337] = {.lex_state = 171},
  [338] = {.lex_state = 171},
  [339] = {.lex_state = 239},
  [340] = {.lex_state = 171},
  [341] = {.lex_state = 171},
  [342] = {.lex_state = 339},
  [343] = {.lex_state = 339},
  [344] = {.lex_state = 339},
  [345] = {.lex_state = 339},
  [346] = {.lex_state = 171},
  [347] = {.lex_state = 171},
  [348] = {.lex_state = 171},
  [349] = {.lex_state = 171},
  [350] = {.lex_state = 173},
  [351] = {.lex_state = 171},
  [352] = {.lex_state = 171},
  [353] = {.lex_state = 339},
  [354] = {.lex_state = 171},
  [355] = {.lex_state = 171},
  [356] = {.lex_state = 171},
  [357] = {.lex_state = 171},
  [358] = {.lex_state = 171},
  [359] = {.lex_state = 174},
  [360] = {.lex_state = 171},
  [361] = {.lex_state = 171},
  [362] = {.lex_state = 174},
  [363] = {.lex_state = 171},
  [364] = {.lex_state = 171},
  [365] = {.lex_state = 171},
  [366] = {.lex_state = 171},
  [367] = {.lex_state = 339},
  [368] = {.lex_state = 339},
  [369] = {.lex_state = 339},
  [370] = {.lex_state = 339},
  [371] = {.lex_state = 176},
  [372] = {.lex_state = 339},
  [373] = {.lex_state = 339},
  [374] = {.lex_state = 239},
  [375] = {.lex_state = 239},
  [376] = {.lex_state = 239},
  [377] = {.lex_state = 239},
  [378] = {.lex_state = 239},
  [379] = {.lex_state = 239},
  [380] = {.lex_state = 339},
  [381] = {.lex_state = 339},
  [382] = {.lex_state = 339},
  [383] = {.lex_state = 339},
  [384] = {.lex_state = 339},
  [385] = {.lex_state = 176},
  [386] = {.lex_state = 176},
  [387] = {.lex_state = 339},
  [388] = {.lex_state = 339},
  [389] = {.lex_state = 239},
  [390] = {.lex_state = 339},
  [391] = {.lex_state = 239},
  [392] = {.lex_state = 239},
  [393] = {.lex_state = 239},
  [394] = {.lex_state = 239},
  [395] = {.lex_state = 239},
  [396] = {.lex_state = 239},
  [397] = {.lex_state = 239},
  [398] = {.lex_state = 239},
  [399] = {.lex_state = 176},
  [400] = {.lex_state = 339},
  [401] = {.lex_state = 339},
  [402] = {.lex_state = 176},
  [403] = {.lex_state = 339},
  [404] = {.lex_state = 339},
  [405] = {.lex_state = 339},
  [406] = {.lex_state = 339},
  [407] = {.lex_state = 176},
  [408] = {.lex_state = 176},
  [409] = {.lex_state = 339},
  [410] = {.lex_state = 176},
  [411] = {.lex_state = 176},
  [412] = {.lex_state = 176},
  [413] = {.lex_state = 339},
  [414] = {.lex_state = 176},
  [415] = {.lex_state = 339},
  [416] = {.lex_state = 176},
  [417] = {.lex_state = 173},
  [418] = {.lex_state = 176},
  [419] = {.lex_state = 173},
  [420] = {.lex_state = 339},
  [421] = {.lex_state = 176},
  [422] = {.lex_state = 339},
  [423] = {.lex_state = 339},
  [424] = {.lex_state = 176},
  [425] = {.lex_state = 339},
  [426] = {.lex_state = 176},
  [427] = {.lex_state = 176},
  [428] = {.lex_state = 339},
  [429] = {.lex_state = 339},
  [430] = {.lex_state = 171},
  [431] = {.lex_state = 339},
  [432] = {.lex_state = 171},
  [433] = {.lex_state = 171},
  [434] = {.lex_state = 339},
  [435] = {.lex_state = 173},
  [436] = {.lex_state = 173},
  [437] = {.lex_state = 339},
  [438] = {.lex_state = 174},
  [439] = {.lex_state = 174},
  [440] = {.lex_state = 175},
  [441] = {.lex_state = 175},
  [442] = {.lex_state = 339},
  [443] = {.lex_state = 176},
  [444] = {.lex_state = 173},
  [445] = {.lex_state = 339},
  [446] = {.lex_state = 173},
  [447] = {.lex_state = 339},
  [448] = {.lex_state = 173},
  [449] = {.lex_state = 173},
  [450] = {.lex_state = 174},
  [451] = {.lex_state = 173},
  [452] = {.lex_state = 173},
  [453] = {.lex_state = 174},
  [454] = {.lex_state = 174},
  [455] = {.lex_state = 339},
  [456] = {.lex_state = 174},
  [457] = {.lex_state = 339},
  [458] = {.lex_state = 339},
  [459] = {.lex_state = 176},
  [460] = {.lex_state = 339},
  [461] = {.lex_state = 174},
  [462] = {.lex_state = 176},
  [463] = {.lex_state = 176},
  [464] = {.lex_state = 176},
  [465] = {.lex_state = 176},
  [466] = {.lex_state = 176},
  [467] = {.lex_state = 176},
  [468] = {.lex_state = 176},
  [469] = {.lex_state = 176},
  [470] = {.lex_state = 176},
  [471] = {.lex_state = 176},
  [472] = {.lex_state = 176},
  [473] = {.lex_state = 339},
  [474] = {.lex_state = 339},
  [475] = {.lex_state = 339},
  [476] = {.lex_state = 339},
  [477] = {.lex_state = 339},
  [478] = {.lex_state = 339},
  [479] = {.lex_state = 339},
  [480] = {.lex_state = 339},
  [481] = {.lex_state = 339},
  [482] = {.lex_state = 339},
  [483] = {.lex_state = 339},
  [484] = {.lex_state = 339},
  [485] = {.lex_state = 339},
  [486] = {.lex_state = 339},
  [487] = {.lex_state = 339},
  [488] = {.lex_state = 339},
  [489] = {.lex_state = 339},
  [490] = {.lex_state = 339},
  [491] = {.lex_state = 339},
  [492] = {.lex_state = 339},
  [493] = {.lex_state = 339},
  [494] = {.lex_state = 339},
  [495] = {.lex_state = 339},
  [496] = {.lex_state = 339},
  [497] = {.lex_state = 339},
  [498] = {.lex_state = 339},
  [499] = {.lex_state = 339},
  [500] = {.lex_state = 339},
  [501] = {.lex_state = 339},
  [502] = {.lex_state = 339},
  [503] = {.lex_state = 339},
  [504] = {.lex_state = 339},
  [505] = {.lex_state = 339},
  [506] = {.lex_state = 339},
  [507] = {.lex_state = 339},
  [508] = {.lex_state = 339},
  [509] = {.lex_state = 339},
  [510] = {.lex_state = 339},
  [511] = {.lex_state = 339},
  [512] = {.lex_state = 339},
  [513] = {.lex_state = 339},
  [514] = {.lex_state = 339},
  [515] = {.lex_state = 339},
  [516] = {.lex_state = 339},
  [517] = {.lex_state = 339},
  [518] = {.lex_state = 339},
  [519] = {.lex_state = 339},
  [520] = {.lex_state = 339},
  [521] = {.lex_state = 339},
  [522] = {.lex_state = 339},
  [523] = {.lex_state = 339},
  [524] = {.lex_state = 339},
  [525] = {.lex_state = 174},
  [526] = {.lex_state = 339},
  [527] = {.lex_state = 339},
  [528] = {.lex_state = 339},
  [529] = {.lex_state = 174},
  [530] = {.lex_state = 339},
  [531] = {.lex_state = 339},
  [532] = {.lex_state = 339},
  [533] = {.lex_state = 339},
  [534] = {.lex_state = 174},
  [535] = {.lex_state = 174},
  [536] = {.lex_state = 339},
  [537] = {.lex_state = 174},
  [538] = {.lex_state = 174},
  [539] = {.lex_state = 174},
  [540] = {.lex_state = 174},
  [541] = {.lex_state = 174},
  [542] = {.lex_state = 174},
  [543] = {.lex_state = 339},
  [544] = {.lex_state = 339},
  [545] = {.lex_state = 339},
  [546] = {.lex_state = 339},
  [547] = {.lex_state = 339},
  [548] = {.lex_state = 339},
  [549] = {.lex_state = 339},
  [550] = {.lex_state = 339},
  [551] = {.lex_state = 339},
  [552] = {.lex_state = 339},
  [553] = {.lex_state = 339},
  [554] = {.lex_state = 339},
  [555] = {.lex_state = 339},
  [556] = {.lex_state = 174},
  [557] = {.lex_state = 339},
  [558] = {.lex_state = 174},
  [559] = {.lex_state = 174},
  [560] = {.lex_state = 174},
  [561] = {.lex_state = 339},
  [562] = {.lex_state = 339},
  [563] = {.lex_state = 339},
  [564] = {.lex_state = 339},
  [565] = {.lex_state = 339},
  [566] = {.lex_state = 339},
  [567] = {.lex_state = 174},
  [568] = {.lex_state = 339},
  [569] = {.lex_state = 174},
  [570] = {.lex_state = 339},
  [571] = {.lex_state = 339},
  [572] = {.lex_state = 174},
  [573] = {.lex_state = 339},
  [574] = {.lex_state = 174},
  [575] = {.lex_state = 339},
  [576] = {.lex_state = 339},
  [577] = {.lex_state = 339},
  [578] = {.lex_state = 174},
  [579] = {.lex_state = 339},
  [580] = {.lex_state = 339},
  [581] = {.lex_state = 339},
  [582] = {.lex_state = 339},
  [583] = {.lex_state = 174},
  [584] = {.lex_state = 339},
  [585] = {.lex_state = 339},
  [586] = {.lex_state = 174},
  [587] = {.lex_state = 239},
  [588] = {.lex_state = 174},
  [589] = {.lex_state = 174},
  [590] = {.lex_state = 339},
  [591] = {.lex_state = 339},
  [592] = {.lex_state = 174},
  [593] = {.lex_state = 339},
  [594] = {.lex_state = 339},
  [595] = {.lex_state = 174},
  [596] = {.lex_state = 174},
  [597] = {.lex_state = 339},
  [598] = {.lex_state = 339},
  [599] = {.lex_state = 339},
  [600] = {.lex_state = 174},
  [601] = {.lex_state = 339},
  [602] = {.lex_state = 339},
  [603] = {.lex_state = 339},
  [604] = {.lex_state = 339},
  [605] = {.lex_state = 339},
  [606] = {.lex_state = 339},
  [607] = {.lex_state = 339},
  [608] = {.lex_state = 174},
  [609] = {.lex_state = 339},
  [610] = {.lex_state = 174},
  [611] = {.lex_state = 339},
  [612] = {.lex_state = 339},
  [613] = {.lex_state = 339},
  [614] = {.lex_state = 174},
  [615] = {.lex_state = 339},
  [616] = {.lex_state = 339},
  [617] = {.lex_state = 174},
  [618] = {.lex_state = 339},
  [619] = {.lex_state = 339},
  [620] = {.lex_state = 339},
  [621] = {.lex_state = 339},
  [622] = {.lex_state = 339},
  [623] = {.lex_state = 339},
  [624] = {.lex_state = 339},
  [625] = {.lex_state = 339},
  [626] = {.lex_state = 339},
  [627] = {.lex_state = 339},
  [628] = {.lex_state = 339},
  [629] = {.lex_state = 339},
  [630] = {.lex_state = 339},
  [631] = {.lex_state = 339},
  [632] = {.lex_state = 339},
  [633] = {.lex_state = 174},
  [634] = {.lex_state = 339},
  [635] = {.lex_state = 339},
  [636] = {.lex_state = 174},
  [637] = {.lex_state = 174},
  [638] = {.lex_state = 339},
  [639] = {.lex_state = 174},
  [640] = {.lex_state = 174},
  [641] = {.lex_state = 339},
  [642] = {.lex_state = 339},
  [643] = {.lex_state = 339},
  [644] = {.lex_state = 174},
  [645] = {.lex_state = 339},
  [646] = {.lex_state = 339},
  [647] = {.lex_state = 174},
  [648] = {.lex_state = 339},
  [649] = {.lex_state = 339},
  [650] = {.lex_state = 174},
  [651] = {.lex_state = 339},
  [652] = {.lex_state = 339},
  [653] = {.lex_state = 339},
  [654] = {.lex_state = 174},
  [655] = {.lex_state = 339},
  [656] = {.lex_state = 339},
  [657] = {.lex_state = 174},
  [658] = {.lex_state = 174},
  [659] = {.lex_state = 174},
  [660] = {.lex_state = 339},
  [661] = {.lex_state = 339},
  [662] = {.lex_state = 174},
  [663] = {.lex_state = 174},
  [664] = {.lex_state = 174},
  [665] = {.lex_state = 174},
  [666] = {.lex_state = 174},
  [667] = {.lex_state = 339},
  [668] = {.lex_state = 339},
  [669] = {.lex_state = 174},
  [670] = {.lex_state = 174},
  [671] = {.lex_state = 174},
  [672] = {.lex_state = 339},
  [673] = {.lex_state = 339},
  [674] = {.lex_state = 339},
  [675] = {.lex_state = 174},
  [676] = {.lex_state = 174},
  [677] = {.lex_state = 174},
  [678] = {.lex_state = 174},
  [679] = {.lex_state = 174},
  [680] = {.lex_state = 174},
  [681] = {.lex_state = 174},
  [682] = {.lex_state = 174},
  [683] = {.lex_state = 174},
  [684] = {.lex_state = 339},
  [685] = {.lex_state = 174},
  [686] = {.lex_state = 174},
  [687] = {.lex_state = 339},
  [688] = {.lex_state = 339},
  [689] = {.lex_state = 174},
  [690] = {.lex_state = 174},
  [691] = {.lex_state = 174},
  [692] = {.lex_state = 174},
  [693] = {.lex_state = 174},
  [694] = {.lex_state = 174},
  [695] = {.lex_state = 174},
  [696] = {.lex_state = 174},
  [697] = {.lex_state = 339},
  [698] = {.lex_state = 174},
  [699] = {.lex_state = 174},
  [700] = {.lex_state = 174},
  [701] = {.lex_state = 174},
  [702] = {.lex_state = 174},
  [703] = {.lex_state = 339},
  [704] = {.lex_state = 174},
  [705] = {.lex_state = 339},
  [706] = {.lex_state = 339},
  [707] = {.lex_state = 174},
  [708] = {.lex_state = 174},
  [709] = {.lex_state = 174},
  [710] = {.lex_state = 174},
  [711] = {.lex_state = 174},
  [712] = {.lex_state = 174},
  [713] = {.lex_state = 174},
  [714] = {.lex_state = 174},
  [715] = {.lex_state = 339},
  [716] = {.lex_state = 174},
  [717] = {.lex_state = 339},
  [718] = {.lex_state = 339},
  [719] = {.lex_state = 174},
  [720] = {.lex_state = 174},
  [721] = {.lex_state = 174},
  [722] = {.lex_state = 339},
  [723] = {.lex_state = 174},
  [724] = {.lex_state = 174},
  [725] = {.lex_state = 174},
  [726] = {.lex_state = 174},
  [727] = {.lex_state = 339},
  [728] = {.lex_state = 339},
  [729] = {.lex_state = 174},
  [730] = {.lex_state = 339},
  [731] = {.lex_state = 174},
  [732] = {.lex_state = 339},
  [733] = {.lex_state = 339},
  [734] = {.lex_state = 339},
  [735] = {.lex_state = 174},
  [736] = {.lex_state = 174},
  [737] = {.lex_state = 339},
  [738] = {.lex_state = 174},
  [739] = {.lex_state = 174},
  [740] = {.lex_state = 174},
  [741] = {.lex_state = 174},
  [742] = {.lex_state = 339},
  [743] = {.lex_state = 339},
  [744] = {.lex_state = 339},
  [745] = {.lex_state = 174},
  [746] = {.lex_state = 174},
  [747] = {.lex_state = 339},
  [748] = {.lex_state = 339},
  [749] = {.lex_state = 339},
  [750] = {.lex_state = 339},
  [751] = {.lex_state = 339},
  [752] = {.lex_state = 339},
  [753] = {.lex_state = 339},
  [754] = {.lex_state = 339},
  [755] = {.lex_state = 339},
  [756] = {.lex_state = 339},
  [757] = {.lex_state = 339},
  [758] = {.lex_state = 339},
  [759] = {.lex_state = 339},
  [760] = {.lex_state = 339},
  [761] = {.lex_state = 339},
  [762] = {.lex_state = 339},
  [763] = {.lex_state = 339},
  [764] = {.lex_state = 339},
  [765] = {.lex_state = 339},
  [766] = {.lex_state = 339},
  [767] = {.lex_state = 339},
  [768] = {.lex_state = 339},
  [769] = {.lex_state = 339},
  [770] = {.lex_state = 339},
  [771] = {.lex_state = 339},
  [772] = {.lex_state = 339},
  [773] = {.lex_state = 339},
  [774] = {.lex_state = 339},
  [775] = {.lex_state = 339},
  [776] = {.lex_state = 339},
  [777] = {.lex_state = 339},
  [778] = {.lex_state = 339},
  [779] = {.lex_state = 339},
  [780] = {.lex_state = 339},
  [781] = {.lex_state = 339},
  [782] = {.lex_state = 174},
  [783] = {.lex_state = 339},
  [784] = {.lex_state = 339},
  [785] = {.lex_state = 174},
  [786] = {.lex_state = 174},
  [787] = {.lex_state = 174},
  [788] = {.lex_state = 339},
  [789] = {.lex_state = 174},
  [790] = {.lex_state = 174},
  [791] = {.lex_state = 174},
  [792] = {.lex_state = 339},
  [793] = {.lex_state = 174},
  [794] = {.lex_state = 165},
  [795] = {.lex_state = 195},
  [796] = {.lex_state = 195},
  [797] = {.lex_state = 195},
  [798] = {.lex_state = 195},
  [799] = {.lex_state = 240},
  [800] = {.lex_state = 240},
  [801] = {.lex_state = 195},
  [802] = {.lex_state = 195},
  [803] = {.lex_state = 195},
  [804] = {.lex_state = 195},
  [805] = {.lex_state = 195},
  [806] = {.lex_state = 195},
  [807] = {.lex_state = 195},
  [808] = {.lex_state = 195},
  [809] = {.lex_state = 195},
  [810] = {.lex_state = 195},
  [811] = {.lex_state = 195},
  [812] = {.lex_state = 240},
  [813] = {.lex_state = 195},
  [814] = {.lex_state = 195},
  [815] = {.lex_state = 195},
  [816] = {.lex_state = 195},
  [817] = {.lex_state = 195},
  [818] = {.lex_state = 195},
  [819] = {.lex_state = 165},
  [820] = {.lex_state = 165},
  [821] = {.lex_state = 165},
  [822] = {.lex_state = 165},
  [823] = {.lex_state = 168},
  [824] = {.lex_state = 165},
  [825] = {.lex_state = 169},
  [826] = {.lex_state = 169},
  [827] = {.lex_state = 176},
  [828] = {.lex_state = 339},
  [829] = {.lex_state = 339},
  [830] = {.lex_state = 176},
  [831] = {.lex_state = 176},
  [832] = {.lex_state = 239},
  [833] = {.lex_state = 239},
  [834] = {.lex_state = 239},
  [835] = {.lex_state = 239},
  [836] = {.lex_state = 239},
  [837] = {.lex_state = 239},
  [838] = {.lex_state = 239},
  [839] = {.lex_state = 176},
  [840] = {.lex_state = 176},
  [841] = {.lex_state = 176},
  [842] = {.lex_state = 176},
  [843] = {.lex_state = 239},
  [844] = {.lex_state = 176},
  [845] = {.lex_state = 176},
  [846] = {.lex_state = 176},
  [847] = {.lex_state = 239},
  [848] = {.lex_state = 176},
  [849] = {.lex_state = 239},
  [850] = {.lex_state = 239},
  [851] = {.lex_state = 239},
  [852] = {.lex_state = 176},
  [853] = {.lex_state = 176},
  [854] = {.lex_state = 239},
  [855] = {.lex_state = 176},
  [856] = {.lex_state = 176},
  [857] = {.lex_state = 176},
  [858] = {.lex_state = 176},
  [859] = {.lex_state = 176},
  [860] = {.lex_state = 339},
  [861] = {.lex_state = 176},
  [862] = {.lex_state = 176},
  [863] = {.lex_state = 239},
  [864] = {.lex_state = 176},
  [865] = {.lex_state = 176},
  [866] = {.lex_state = 176},
  [867] = {.lex_state = 176},
  [868] = {.lex_state = 173},
  [869] = {.lex_state = 188},
  [870] = {.lex_state = 175},
  [871] = {.lex_state = 175},
  [872] = {.lex_state = 173},
  [873] = {.lex_state = 188},
  [874] = {.lex_state = 188},
  [875] = {.lex_state = 188},
  [876] = {.lex_state = 188},
  [877] = {.lex_state = 176},
  [878] = {.lex_state = 173},
  [879] = {.lex_state = 188},
  [880] = {.lex_state = 173},
  [881] = {.lex_state = 173},
  [882] = {.lex_state = 173},
  [883] = {.lex_state = 173},
  [884] = {.lex_state = 173},
  [885] = {.lex_state = 173},
  [886] = {.lex_state = 173},
  [887] = {.lex_state = 173},
  [888] = {.lex_state = 173},
  [889] = {.lex_state = 173},
  [890] = {.lex_state = 173},
  [891] = {.lex_state = 173},
  [892] = {.lex_state = 173},
  [893] = {.lex_state = 173},
  [894] = {.lex_state = 173},
  [895] = {.lex_state = 173},
  [896] = {.lex_state = 173},
  [897] = {.lex_state = 173},
  [898] = {.lex_state = 173},
  [899] = {.lex_state = 173},
  [900] = {.lex_state = 173},
  [901] = {.lex_state = 175},
  [902] = {.lex_state = 173},
  [903] = {.lex_state = 173},
  [904] = {.lex_state = 173},
  [905] = {.lex_state = 173},
  [906] = {.lex_state = 173},
  [907] = {.lex_state = 173},
  [908] = {.lex_state = 173},
  [909] = {.lex_state = 175},
  [910] = {.lex_state = 173},
  [911] = {.lex_state = 173},
  [912] = {.lex_state = 173},
  [913] = {.lex_state = 173},
  [914] = {.lex_state = 173},
  [915] = {.lex_state = 173},
  [916] = {.lex_state = 173},
  [917] = {.lex_state = 173},
  [918] = {.lex_state = 173},
  [919] = {.lex_state = 173},
  [920] = {.lex_state = 173},
  [921] = {.lex_state = 173},
  [922] = {.lex_state = 173},
  [923] = {.lex_state = 173},
  [924] = {.lex_state = 173},
  [925] = {.lex_state = 173},
  [926] = {.lex_state = 239},
  [927] = {.lex_state = 188},
  [928] = {.lex_state = 177},
  [929] = {.lex_state = 177},
  [930] = {.lex_state = 176},
  [931] = {.lex_state = 188},
  [932] = {.lex_state = 176},
  [933] = {.lex_state = 188},
  [934] = {.lex_state = 177},
  [935] = {.lex_state = 176},
  [936] = {.lex_state = 177},
  [937] = {.lex_state = 176},
  [938] = {.lex_state = 177},
  [939] = {.lex_state = 176},
  [940] = {.lex_state = 176},
  [941] = {.lex_state = 176},
  [942] = {.lex_state = 176},
  [943] = {.lex_state = 176},
  [944] = {.lex_state = 177},
  [945] = {.lex_state = 177},
  [946] = {.lex_state = 176},
  [947] = {.lex_state = 176},
  [948] = {.lex_state = 176},
  [949] = {.lex_state = 177},
  [950] = {.lex_state = 176},
  [951] = {.lex_state = 176},
  [952] = {.lex_state = 177},
  [953] = {.lex_state = 176},
  [954] = {.lex_state = 177},
  [955] = {.lex_state = 176},
  [956] = {.lex_state = 176},
  [957] = {.lex_state = 188},
  [958] = {.lex_state = 177},
  [959] = {.lex_state = 176},
  [960] = {.lex_state = 176},
  [961] = {.lex_state = 176},
  [962] = {.lex_state = 177},
  [963] = {.lex_state = 177},
  [964] = {.lex_state = 176},
  [965] = {.lex_state = 177},
  [966] = {.lex_state = 176},
  [967] = {.lex_state = 177},
  [968] = {.lex_state = 176},
  [969] = {.lex_state = 176},
  [970] = {.lex_state = 177},
  [971] = {.lex_state = 176},
  [972] = {.lex_state = 177},
  [973] = {.lex_state = 177},
  [974] = {.lex_state = 177},
  [975] = {.lex_state = 188},
  [976] = {.lex_state = 184},
  [977] = {.lex_state = 188},
  [978] = {.lex_state = 188},
  [979] = {.lex_state = 177},
  [980] = {.lex_state = 177},
  [981] = {.lex_state = 176},
  [982] = {.lex_state = 177},
  [983] = {.lex_state = 177},
  [984] = {.lex_state = 177},
  [985] = {.lex_state = 177},
  [986] = {.lex_state = 177},
  [987] = {.lex_state = 176},
  [988] = {.lex_state = 176},
  [989] = {.lex_state = 176},
  [990] = {.lex_state = 176},
  [991] = {.lex_state = 176},
  [992] = {.lex_state = 188},
  [993] = {.lex_state = 176},
  [994] = {.lex_state = 176},
  [995] = {.lex_state = 176},
  [996] = {.lex_state = 176},
  [997] = {.lex_state = 176},
  [998] = {.lex_state = 176},
  [999] = {.lex_state = 176},
  [1000] = {.lex_state = 176},
  [1001] = {.lex_state = 176},
  [1002] = {.lex_state = 176},
  [1003] = {.lex_state = 176},
  [1004] = {.lex_state = 176},
  [1005] = {.lex_state = 176},
  [1006] = {.lex_state = 176},
  [1007] = {.lex_state = 176},
  [1008] = {.lex_state = 176},
  [1009] = {.lex_state = 176},
  [1010] = {.lex_state = 176},
  [1011] = {.lex_state = 176},
  [1012] = {.lex_state = 176},
  [1013] = {.lex_state = 176},
  [1014] = {.lex_state = 176},
  [1015] = {.lex_state = 176},
  [1016] = {.lex_state = 176},
  [1017] = {.lex_state = 176},
  [1018] = {.lex_state = 176},
  [1019] = {.lex_state = 176},
  [1020] = {.lex_state = 176},
  [1021] = {.lex_state = 176},
  [1022] = {.lex_state = 176},
  [1023] = {.lex_state = 176},
  [1024] = {.lex_state = 176},
  [1025] = {.lex_state = 176},
  [1026] = {.lex_state = 176},
  [1027] = {.lex_state = 176},
  [1028] = {.lex_state = 176},
  [1029] = {.lex_state = 176},
  [1030] = {.lex_state = 176},
  [1031] = {.lex_state = 176},
  [1032] = {.lex_state = 176},
  [1033] = {.lex_state = 176},
  [1034] = {.lex_state = 176},
  [1035] = {.lex_state = 176},
  [1036] = {.lex_state = 176},
  [1037] = {.lex_state = 176},
  [1038] = {.lex_state = 176},
  [1039] = {.lex_state = 176},
  [1040] = {.lex_state = 176},
  [1041] = {.lex_state = 176},
  [1042] = {.lex_state = 176},
  [1043] = {.lex_state = 176},
  [1044] = {.lex_state = 176},
  [1045] = {.lex_state = 176},
  [1046] = {.lex_state = 176},
  [1047] = {.lex_state = 176},
  [1048] = {.lex_state = 176},
  [1049] = {.lex_state = 176},
  [1050] = {.lex_state = 176},
  [1051] = {.lex_state = 176},
  [1052] = {.lex_state = 176},
  [1053] = {.lex_state = 176},
  [1054] = {.lex_state = 176},
  [1055] = {.lex_state = 176},
  [1056] = {.lex_state = 176},
  [1057] = {.lex_state = 176},
  [1058] = {.lex_state = 176},
  [1059] = {.lex_state = 176},
  [1060] = {.lex_state = 176},
  [1061] = {.lex_state = 176},
  [1062] = {.lex_state = 176},
  [1063] = {.lex_state = 176},
  [1064] = {.lex_state = 176},
  [1065] = {.lex_state = 176},
  [1066] = {.lex_state = 176},
  [1067] = {.lex_state = 176},
  [1068] = {.lex_state = 176},
  [1069] = {.lex_state = 176},
  [1070] = {.lex_state = 176},
  [1071] = {.lex_state = 176},
  [1072] = {.lex_state = 176},
  [1073] = {.lex_state = 176},
  [1074] = {.lex_state = 176},
  [1075] = {.lex_state = 176},
  [1076] = {.lex_state = 176},
  [1077] = {.lex_state = 176},
  [1078] = {.lex_state = 176},
  [1079] = {.lex_state = 176},
  [1080] = {.lex_state = 176},
  [1081] = {.lex_state = 176},
  [1082] = {.lex_state = 176},
  [1083] = {.lex_state = 176},
  [1084] = {.lex_state = 176},
  [1085] = {.lex_state = 176},
  [1086] = {.lex_state = 176},
  [1087] = {.lex_state = 176},
  [1088] = {.lex_state = 176},
  [1089] = {.lex_state = 176},
  [1090] = {.lex_state = 176},
  [1091] = {.lex_state = 176},
  [1092] = {.lex_state = 176},
  [1093] = {.lex_state = 176},
  [1094] = {.lex_state = 176},
  [1095] = {.lex_state = 176},
  [1096] = {.lex_state = 176},
  [1097] = {.lex_state = 176},
  [1098] = {.lex_state = 176},
  [1099] = {.lex_state = 176},
  [1100] = {.lex_state = 176},
  [1101] = {.lex_state = 176},
  [1102] = {.lex_state = 176},
  [1103] = {.lex_state = 176},
  [1104] = {.lex_state = 176},
  [1105] = {.lex_state = 176},
  [1106] = {.lex_state = 176},
  [1107] = {.lex_state = 176},
  [1108] = {.lex_state = 176},
  [1109] = {.lex_state = 176},
  [1110] = {.lex_state = 176},
  [1111] = {.lex_state = 176},
  [1112] = {.lex_state = 176},
  [1113] = {.lex_state = 176},
  [1114] = {.lex_state = 176},
  [1115] = {.lex_state = 176},
  [1116] = {.lex_state = 176},
  [1117] = {.lex_state = 176},
  [1118] = {.lex_state = 176},
  [1119] = {.lex_state = 176},
  [1120] = {.lex_state = 176},
  [1121] = {.lex_state = 176},
  [1122] = {.lex_state = 176},
  [1123] = {.lex_state = 176},
  [1124] = {.lex_state = 176},
  [1125] = {.lex_state = 176},
  [1126] = {.lex_state = 176},
  [1127] = {.lex_state = 176},
  [1128] = {.lex_state = 176},
  [1129] = {.lex_state = 176},
  [1130] = {.lex_state = 176},
  [1131] = {.lex_state = 176},
  [1132] = {.lex_state = 176},
  [1133] = {.lex_state = 176},
  [1134] = {.lex_state = 176},
  [1135] = {.lex_state = 176},
  [1136] = {.lex_state = 176},
  [1137] = {.lex_state = 176},
  [1138] = {.lex_state = 176},
  [1139] = {.lex_state = 176},
  [1140] = {.lex_state = 176},
  [1141] = {.lex_state = 176},
  [1142] = {.lex_state = 176},
  [1143] = {.lex_state = 176},
  [1144] = {.lex_state = 176},
  [1145] = {.lex_state = 176},
  [1146] = {.lex_state = 176},
  [1147] = {.lex_state = 176},
  [1148] = {.lex_state = 176},
  [1149] = {.lex_state = 176},
  [1150] = {.lex_state = 176},
  [1151] = {.lex_state = 176},
  [1152] = {.lex_state = 176},
  [1153] = {.lex_state = 176},
  [1154] = {.lex_state = 176},
  [1155] = {.lex_state = 176},
  [1156] = {.lex_state = 176},
  [1157] = {.lex_state = 176},
  [1158] = {.lex_state = 176},
  [1159] = {.lex_state = 176},
  [1160] = {.lex_state = 176},
  [1161] = {.lex_state = 176},
  [1162] = {.lex_state = 176},
  [1163] = {.lex_state = 176},
  [1164] = {.lex_state = 176},
  [1165] = {.lex_state = 176},
  [1166] = {.lex_state = 176},
  [1167] = {.lex_state = 176},
  [1168] = {.lex_state = 176},
  [1169] = {.lex_state = 176},
  [1170] = {.lex_state = 176},
  [1171] = {.lex_state = 176},
  [1172] = {.lex_state = 176},
  [1173] = {.lex_state = 176},
  [1174] = {.lex_state = 176},
  [1175] = {.lex_state = 176},
  [1176] = {.lex_state = 176},
  [1177] = {.lex_state = 176},
  [1178] = {.lex_state = 176},
  [1179] = {.lex_state = 176},
  [1180] = {.lex_state = 176},
  [1181] = {.lex_state = 176},
  [1182] = {.lex_state = 176},
  [1183] = {.lex_state = 176},
  [1184] = {.lex_state = 176},
  [1185] = {.lex_state = 176},
  [1186] = {.lex_state = 176},
  [1187] = {.lex_state = 176},
  [1188] = {.lex_state = 176},
  [1189] = {.lex_state = 176},
  [1190] = {.lex_state = 176},
  [1191] = {.lex_state = 176},
  [1192] = {.lex_state = 176},
  [1193] = {.lex_state = 176},
  [1194] = {.lex_state = 176},
  [1195] = {.lex_state = 176},
  [1196] = {.lex_state = 176},
  [1197] = {.lex_state = 176},
  [1198] = {.lex_state = 176},
  [1199] = {.lex_state = 176},
  [1200] = {.lex_state = 176},
  [1201] = {.lex_state = 176},
  [1202] = {.lex_state = 176},
  [1203] = {.lex_state = 176},
  [1204] = {.lex_state = 176},
  [1205] = {.lex_state = 176},
  [1206] = {.lex_state = 176},
  [1207] = {.lex_state = 176},
  [1208] = {.lex_state = 176},
  [1209] = {.lex_state = 176},
  [1210] = {.lex_state = 176},
  [1211] = {.lex_state = 176},
  [1212] = {.lex_state = 176},
  [1213] = {.lex_state = 176},
  [1214] = {.lex_state = 176},
  [1215] = {.lex_state = 176},
  [1216] = {.lex_state = 176},
  [1217] = {.lex_state = 176},
  [1218] = {.lex_state = 176},
  [1219] = {.lex_state = 176},
  [1220] = {.lex_state = 176},
  [1221] = {.lex_state = 176},
  [1222] = {.lex_state = 176},
  [1223] = {.lex_state = 176},
  [1224] = {.lex_state = 176},
  [1225] = {.lex_state = 176},
  [1226] = {.lex_state = 176},
  [1227] = {.lex_state = 176},
  [1228] = {.lex_state = 176},
  [1229] = {.lex_state = 176},
  [1230] = {.lex_state = 176},
  [1231] = {.lex_state = 176},
  [1232] = {.lex_state = 176},
  [1233] = {.lex_state = 176},
  [1234] = {.lex_state = 176},
  [1235] = {.lex_state = 176},
  [1236] = {.lex_state = 176},
  [1237] = {.lex_state = 176},
  [1238] = {.lex_state = 176},
  [1239] = {.lex_state = 176},
  [1240] = {.lex_state = 176},
  [1241] = {.lex_state = 176},
  [1242] = {.lex_state = 176},
  [1243] = {.lex_state = 176},
  [1244] = {.lex_state = 176},
  [1245] = {.lex_state = 176},
  [1246] = {.lex_state = 176},
  [1247] = {.lex_state = 176},
  [1248] = {.lex_state = 176},
  [1249] = {.lex_state = 176},
  [1250] = {.lex_state = 176},
  [1251] = {.lex_state = 176},
  [1252] = {.lex_state = 176},
  [1253] = {.lex_state = 176},
  [1254] = {.lex_state = 176},
  [1255] = {.lex_state = 176},
  [1256] = {.lex_state = 176},
  [1257] = {.lex_state = 176},
  [1258] = {.lex_state = 176},
  [1259] = {.lex_state = 176},
  [1260] = {.lex_state = 176},
  [1261] = {.lex_state = 176},
  [1262] = {.lex_state = 176},
  [1263] = {.lex_state = 176},
  [1264] = {.lex_state = 176},
  [1265] = {.lex_state = 176},
  [1266] = {.lex_state = 176},
  [1267] = {.lex_state = 176},
  [1268] = {.lex_state = 176},
  [1269] = {.lex_state = 176},
  [1270] = {.lex_state = 176},
  [1271] = {.lex_state = 176},
  [1272] = {.lex_state = 176},
  [1273] = {.lex_state = 176},
  [1274] = {.lex_state = 176},
  [1275] = {.lex_state = 176},
  [1276] = {.lex_state = 176},
  [1277] = {.lex_state = 176},
  [1278] = {.lex_state = 176},
  [1279] = {.lex_state = 176},
  [1280] = {.lex_state = 176},
  [1281] = {.lex_state = 176},
  [1282] = {.lex_state = 176},
  [1283] = {.lex_state = 176},
  [1284] = {.lex_state = 176},
  [1285] = {.lex_state = 176},
  [1286] = {.lex_state = 176},
  [1287] = {.lex_state = 176},
  [1288] = {.lex_state = 176},
  [1289] = {.lex_state = 176},
  [1290] = {.lex_state = 176},
  [1291] = {.lex_state = 176},
  [1292] = {.lex_state = 176},
  [1293] = {.lex_state = 176},
  [1294] = {.lex_state = 176},
  [1295] = {.lex_state = 176},
  [1296] = {.lex_state = 176},
  [1297] = {.lex_state = 176},
  [1298] = {.lex_state = 176},
  [1299] = {.lex_state = 176},
  [1300] = {.lex_state = 176},
  [1301] = {.lex_state = 176},
  [1302] = {.lex_state = 176},
  [1303] = {.lex_state = 176},
  [1304] = {.lex_state = 176},
  [1305] = {.lex_state = 176},
  [1306] = {.lex_state = 176},
  [1307] = {.lex_state = 176},
  [1308] = {.lex_state = 176},
  [1309] = {.lex_state = 176},
  [1310] = {.lex_state = 176},
  [1311] = {.lex_state = 176},
  [1312] = {.lex_state = 176},
  [1313] = {.lex_state = 176},
  [1314] = {.lex_state = 176},
  [1315] = {.lex_state = 176},
  [1316] = {.lex_state = 176},
  [1317] = {.lex_state = 176},
  [1318] = {.lex_state = 176},
  [1319] = {.lex_state = 176},
  [1320] = {.lex_state = 176},
  [1321] = {.lex_state = 176},
  [1322] = {.lex_state = 176},
  [1323] = {.lex_state = 176},
  [1324] = {.lex_state = 176},
  [1325] = {.lex_state = 176},
  [1326] = {.lex_state = 176},
  [1327] = {.lex_state = 176},
  [1328] = {.lex_state = 176},
  [1329] = {.lex_state = 176},
  [1330] = {.lex_state = 176},
  [1331] = {.lex_state = 176},
  [1332] = {.lex_state = 176},
  [1333] = {.lex_state = 176},
  [1334] = {.lex_state = 176},
  [1335] = {.lex_state = 176},
  [1336] = {.lex_state = 176},
  [1337] = {.lex_state = 176},
  [1338] = {.lex_state = 176},
  [1339] = {.lex_state = 176},
  [1340] = {.lex_state = 176},
  [1341] = {.lex_state = 176},
  [1342] = {.lex_state = 176},
  [1343] = {.lex_state = 176},
  [1344] = {.lex_state = 176},
  [1345] = {.lex_state = 176},
  [1346] = {.lex_state = 176},
  [1347] = {.lex_state = 176},
  [1348] = {.lex_state = 176},
  [1349] = {.lex_state = 176},
  [1350] = {.lex_state = 176},
  [1351] = {.lex_state = 176},
  [1352] = {.lex_state = 176},
  [1353] = {.lex_state = 176},
  [1354] = {.lex_state = 176},
  [1355] = {.lex_state = 176},
  [1356] = {.lex_state = 176},
  [1357] = {.lex_state = 176},
  [1358] = {.lex_state = 176},
  [1359] = {.lex_state = 176},
  [1360] = {.lex_state = 176},
  [1361] = {.lex_state = 176},
  [1362] = {.lex_state = 176},
  [1363] = {.lex_state = 176},
  [1364] = {.lex_state = 176},
  [1365] = {.lex_state = 176},
  [1366] = {.lex_state = 176},
  [1367] = {.lex_state = 176},
  [1368] = {.lex_state = 176},
  [1369] = {.lex_state = 176},
  [1370] = {.lex_state = 176},
  [1371] = {.lex_state = 176},
  [1372] = {.lex_state = 176},
  [1373] = {.lex_state = 176},
  [1374] = {.lex_state = 176},
  [1375] = {.lex_state = 176},
  [1376] = {.lex_state = 176},
  [1377] = {.lex_state = 176},
  [1378] = {.lex_state = 176},
  [1379] = {.lex_state = 176},
  [1380] = {.lex_state = 176},
  [1381] = {.lex_state = 176},
  [1382] = {.lex_state = 176},
  [1383] = {.lex_state = 176},
  [1384] = {.lex_state = 176},
  [1385] = {.lex_state = 176},
  [1386] = {.lex_state = 176},
  [1387] = {.lex_state = 176},
  [1388] = {.lex_state = 176},
  [1389] = {.lex_state = 176},
  [1390] = {.lex_state = 176},
  [1391] = {.lex_state = 176},
  [1392] = {.lex_state = 176},
  [1393] = {.lex_state = 176},
  [1394] = {.lex_state = 176},
  [1395] = {.lex_state = 176},
  [1396] = {.lex_state = 176},
  [1397] = {.lex_state = 176},
  [1398] = {.lex_state = 176},
  [1399] = {.lex_state = 176},
  [1400] = {.lex_state = 176},
  [1401] = {.lex_state = 176},
  [1402] = {.lex_state = 176},
  [1403] = {.lex_state = 176},
  [1404] = {.lex_state = 176},
  [1405] = {.lex_state = 176},
  [1406] = {.lex_state = 176},
  [1407] = {.lex_state = 176},
  [1408] = {.lex_state = 176},
  [1409] = {.lex_state = 176},
  [1410] = {.lex_state = 176},
  [1411] = {.lex_state = 176},
  [1412] = {.lex_state = 176},
  [1413] = {.lex_state = 176},
  [1414] = {.lex_state = 176},
  [1415] = {.lex_state = 176},
  [1416] = {.lex_state = 176},
  [1417] = {.lex_state = 176},
  [1418] = {.lex_state = 176},
  [1419] = {.lex_state = 176},
  [1420] = {.lex_state = 176},
  [1421] = {.lex_state = 176},
  [1422] = {.lex_state = 176},
  [1423] = {.lex_state = 176},
  [1424] = {.lex_state = 176},
  [1425] = {.lex_state = 176},
  [1426] = {.lex_state = 176},
  [1427] = {.lex_state = 176},
  [1428] = {.lex_state = 176},
  [1429] = {.lex_state = 176},
  [1430] = {.lex_state = 176},
  [1431] = {.lex_state = 176},
  [1432] = {.lex_state = 176},
  [1433] = {.lex_state = 176},
  [1434] = {.lex_state = 176},
  [1435] = {.lex_state = 176},
  [1436] = {.lex_state = 176},
  [1437] = {.lex_state = 176},
  [1438] = {.lex_state = 176},
  [1439] = {.lex_state = 176},
  [1440] = {.lex_state = 176},
  [1441] = {.lex_state = 176},
  [1442] = {.lex_state = 176},
  [1443] = {.lex_state = 176},
  [1444] = {.lex_state = 176},
  [1445] = {.lex_state = 176},
  [1446] = {.lex_state = 176},
  [1447] = {.lex_state = 176},
  [1448] = {.lex_state = 176},
  [1449] = {.lex_state = 176},
  [1450] = {.lex_state = 176},
  [1451] = {.lex_state = 176},
  [1452] = {.lex_state = 176},
  [1453] = {.lex_state = 176},
  [1454] = {.lex_state = 176},
  [1455] = {.lex_state = 176},
  [1456] = {.lex_state = 176},
  [1457] = {.lex_state = 176},
  [1458] = {.lex_state = 176},
  [1459] = {.lex_state = 176},
  [1460] = {.lex_state = 176},
  [1461] = {.lex_state = 176},
  [1462] = {.lex_state = 176},
  [1463] = {.lex_state = 176},
  [1464] = {.lex_state = 176},
  [1465] = {.lex_state = 176},
  [1466] = {.lex_state = 176},
  [1467] = {.lex_state = 176},
  [1468] = {.lex_state = 176},
  [1469] = {.lex_state = 176},
  [1470] = {.lex_state = 176},
  [1471] = {.lex_state = 176},
  [1472] = {.lex_state = 176},
  [1473] = {.lex_state = 176},
  [1474] = {.lex_state = 176},
  [1475] = {.lex_state = 176},
  [1476] = {.lex_state = 176},
  [1477] = {.lex_state = 176},
  [1478] = {.lex_state = 176},
  [1479] = {.lex_state = 176},
  [1480] = {.lex_state = 176},
  [1481] = {.lex_state = 176},
  [1482] = {.lex_state = 176},
  [1483] = {.lex_state = 176},
  [1484] = {.lex_state = 176},
  [1485] = {.lex_state = 176},
  [1486] = {.lex_state = 176},
  [1487] = {.lex_state = 176},
  [1488] = {.lex_state = 176},
  [1489] = {.lex_state = 176},
  [1490] = {.lex_state = 176},
  [1491] = {.lex_state = 176},
  [1492] = {.lex_state = 176},
  [1493] = {.lex_state = 176},
  [1494] = {.lex_state = 176},
  [1495] = {.lex_state = 176},
  [1496] = {.lex_state = 176},
  [1497] = {.lex_state = 176},
  [1498] = {.lex_state = 176},
  [1499] = {.lex_state = 176},
  [1500] = {.lex_state = 176},
  [1501] = {.lex_state = 176},
  [1502] = {.lex_state = 176},
  [1503] = {.lex_state = 176},
  [1504] = {.lex_state = 176},
  [1505] = {.lex_state = 176},
  [1506] = {.lex_state = 176},
  [1507] = {.lex_state = 176},
  [1508] = {.lex_state = 176},
  [1509] = {.lex_state = 176},
  [1510] = {.lex_state = 176},
  [1511] = {.lex_state = 176},
  [1512] = {.lex_state = 176},
  [1513] = {.lex_state = 176},
  [1514] = {.lex_state = 176},
  [1515] = {.lex_state = 176},
  [1516] = {.lex_state = 176},
  [1517] = {.lex_state = 176},
  [1518] = {.lex_state = 176},
  [1519] = {.lex_state = 176},
  [1520] = {.lex_state = 176},
  [1521] = {.lex_state = 176},
  [1522] = {.lex_state = 176},
  [1523] = {.lex_state = 176},
  [1524] = {.lex_state = 176},
  [1525] = {.lex_state = 176},
  [1526] = {.lex_state = 176},
  [1527] = {.lex_state = 176},
  [1528] = {.lex_state = 176},
  [1529] = {.lex_state = 176},
  [1530] = {.lex_state = 176},
  [1531] = {.lex_state = 176},
  [1532] = {.lex_state = 176},
  [1533] = {.lex_state = 176},
  [1534] = {.lex_state = 176},
  [1535] = {.lex_state = 176},
  [1536] = {.lex_state = 176},
  [1537] = {.lex_state = 176},
  [1538] = {.lex_state = 196},
  [1539] = {.lex_state = 196},
  [1540] = {.lex_state = 196},
  [1541] = {.lex_state = 196},
  [1542] = {.lex_state = 196},
  [1543] = {.lex_state = 196},
  [1544] = {.lex_state = 196},
  [1545] = {.lex_state = 196},
  [1546] = {.lex_state = 196},
  [1547] = {.lex_state = 239},
  [1548] = {.lex_state = 239},
  [1549] = {.lex_state = 173},
  [1550] = {.lex_state = 173},
  [1551] = {.lex_state = 173},
  [1552] = {.lex_state = 239},
  [1553] = {.lex_state = 194},
  [1554] = {.lex_state = 194},
  [1555] = {.lex_state = 194},
  [1556] = {.lex_state = 194},
  [1557] = {.lex_state = 196},
  [1558] = {.lex_state = 239},
  [1559] = {.lex_state = 239},
  [1560] = {.lex_state = 194},
  [1561] = {.lex_state = 194},
  [1562] = {.lex_state = 194},
  [1563] = {.lex_state = 239},
  [1564] = {.lex_state = 210},
  [1565] = {.lex_state = 196},
  [1566] = {.lex_state = 210},
  [1567] = {.lex_state = 210},
  [1568] = {.lex_state = 210},
  [1569] = {.lex_state = 210},
  [1570] = {.lex_state = 210},
  [1571] = {.lex_state = 210},
  [1572] = {.lex_state = 210},
  [1573] = {.lex_state = 184},
  [1574] = {.lex_state = 210},
  [1575] = {.lex_state = 196},
  [1576] = {.lex_state = 185},
  [1577] = {.lex_state = 196},
  [1578] = {.lex_state = 199},
  [1579] = {.lex_state = 189},
  [1580] = {.lex_state = 210},
  [1581] = {.lex_state = 210},
  [1582] = {.lex_state = 210},
  [1583] = {.lex_state = 210},
  [1584] = {.lex_state = 210},
  [1585] = {.lex_state = 199},
  [1586] = {.lex_state = 210},
  [1587] = {.lex_state = 210},
  [1588] = {.lex_state = 210},
  [1589] = {.lex_state = 179},
  [1590] = {.lex_state = 199},
  [1591] = {.lex_state = 199},
  [1592] = {.lex_state = 199},
  [1593] = {.lex_state = 199},
  [1594] = {.lex_state = 199},
  [1595] = {.lex_state = 199},
  [1596] = {.lex_state = 197},
  [1597] = {.lex_state = 197},
  [1598] = {.lex_state = 197},
  [1599] = {.lex_state = 197},
  [1600] = {.lex_state = 197},
  [1601] = {.lex_state = 197},
  [1602] = {.lex_state = 197},
  [1603] = {.lex_state = 239},
  [1604] = {.lex_state = 194},
  [1605] = {.lex_state = 213},
  [1606] = {.lex_state = 239},
  [1607] = {.lex_state = 239},
  [1608] = {.lex_state = 239},
  [1609] = {.lex_state = 239},
  [1610] = {.lex_state = 239},
  [1611] = {.lex_state = 239},
  [1612] = {.lex_state = 239},
  [1613] = {.lex_state = 239},
  [1614] = {.lex_state = 199},
  [1615] = {.lex_state = 239},
  [1616] = {.lex_state = 239},
  [1617] = {.lex_state = 199},
  [1618] = {.lex_state = 239},
  [1619] = {.lex_state = 213},
  [1620] = {.lex_state = 239},
  [1621] = {.lex_state = 239},
  [1622] = {.lex_state = 239},
  [1623] = {.lex_state = 239},
  [1624] = {.lex_state = 221},
  [1625] = {.lex_state = 221},
  [1626] = {.lex_state = 213},
  [1627] = {.lex_state = 239},
  [1628] = {.lex_state = 221},
  [1629] = {.lex_state = 239},
  [1630] = {.lex_state = 239},
  [1631] = {.lex_state = 239},
  [1632] = {.lex_state = 239},
  [1633] = {.lex_state = 239},
  [1634] = {.lex_state = 213},
  [1635] = {.lex_state = 213},
  [1636] = {.lex_state = 239},
  [1637] = {.lex_state = 213},
  [1638] = {.lex_state = 239},
  [1639] = {.lex_state = 239},
  [1640] = {.lex_state = 239},
  [1641] = {.lex_state = 239},
  [1642] = {.lex_state = 239},
  [1643] = {.lex_state = 239},
  [1644] = {.lex_state = 239},
  [1645] = {.lex_state = 239},
  [1646] = {.lex_state = 239},
  [1647] = {.lex_state = 239},
  [1648] = {.lex_state = 239},
  [1649] = {.lex_state = 213},
  [1650] = {.lex_state = 239},
  [1651] = {.lex_state = 213},
  [1652] = {.lex_state = 213},
  [1653] = {.lex_state = 221},
  [1654] = {.lex_state = 213},
  [1655] = {.lex_state = 205},
  [1656] = {.lex_state = 221},
  [1657] = {.lex_state = 239},
  [1658] = {.lex_state = 239},
  [1659] = {.lex_state = 194},
  [1660] = {.lex_state = 221},
  [1661] = {.lex_state = 239},
  [1662] = {.lex_state = 221},
  [1663] = {.lex_state = 239},
  [1664] = {.lex_state = 209},
  [1665] = {.lex_state = 209},
  [1666] = {.lex_state = 209},
  [1667] = {.lex_state = 209},
  [1668] = {.lex_state = 209},
  [1669] = {.lex_state = 205},
  [1670] = {.lex_state = 179},
  [1671] = {.lex_state = 209},
  [1672] = {.lex_state = 213},
  [1673] = {.lex_state = 194},
  [1674] = {.lex_state = 213},
  [1675] = {.lex_state = 209},
  [1676] = {.lex_state = 213},
  [1677] = {.lex_state = 239},
  [1678] = {.lex_state = 173},
  [1679] = {.lex_state = 239},
  [1680] = {.lex_state = 217},
  [1681] = {.lex_state = 217},
  [1682] = {.lex_state = 205},
  [1683] = {.lex_state = 217},
  [1684] = {.lex_state = 181},
  [1685] = {.lex_state = 217},
  [1686] = {.lex_state = 239},
  [1687] = {.lex_state = 217},
  [1688] = {.lex_state = 213},
  [1689] = {.lex_state = 181},
  [1690] = {.lex_state = 239},
  [1691] = {.lex_state = 217},
  [1692] = {.lex_state = 181},
  [1693] = {.lex_state = 217},
  [1694] = {.lex_state = 173},
  [1695] = {.lex_state = 205},
  [1696] = {.lex_state = 239},
  [1697] = {.lex_state = 239},
  [1698] = {.lex_state = 176},
  [1699] = {.lex_state = 239},
  [1700] = {.lex_state = 239},
  [1701] = {.lex_state = 210},
  [1702] = {.lex_state = 239},
  [1703] = {.lex_state = 239},
  [1704] = {.lex_state = 239},
  [1705] = {.lex_state = 210},
  [1706] = {.lex_state = 239},
  [1707] = {.lex_state = 239},
  [1708] = {.lex_state = 239},
  [1709] = {.lex_state = 239},
  [1710] = {.lex_state = 239},
  [1711] = {.lex_state = 239},
  [1712] = {.lex_state = 239},
  [1713] = {.lex_state = 226},
  [1714] = {.lex_state = 239},
  [1715] = {.lex_state = 239},
  [1716] = {.lex_state = 239},
  [1717] = {.lex_state = 239},
  [1718] = {.lex_state = 239},
  [1719] = {.lex_state = 239},
  [1720] = {.lex_state = 194},
  [1721] = {.lex_state = 181},
  [1722] = {.lex_state = 181},
  [1723] = {.lex_state = 209},
  [1724] = {.lex_state = 239},
  [1725] = {.lex_state = 181},
  [1726] = {.lex_state = 239},
  [1727] = {.lex_state = 239},
  [1728] = {.lex_state = 200},
  [1729] = {.lex_state = 239},
  [1730] = {.lex_state = 239},
  [1731] = {.lex_state = 194},
  [1732] = {.lex_state = 226},
  [1733] = {.lex_state = 239},
  [1734] = {.lex_state = 194},
  [1735] = {.lex_state = 239},
  [1736] = {.lex_state = 239},
  [1737] = {.lex_state = 239},
  [1738] = {.lex_state = 239},
  [1739] = {.lex_state = 239},
  [1740] = {.lex_state = 239},
  [1741] = {.lex_state = 239},
  [1742] = {.lex_state = 194},
  [1743] = {.lex_state = 239},
  [1744] = {.lex_state = 194},
  [1745] = {.lex_state = 239},
  [1746] = {.lex_state = 239},
  [1747] = {.lex_state = 239},
  [1748] = {.lex_state = 239},
  [1749] = {.lex_state = 239},
  [1750] = {.lex_state = 239},
  [1751] = {.lex_state = 239},
  [1752] = {.lex_state = 194},
  [1753] = {.lex_state = 239},
  [1754] = {.lex_state = 239},
  [1755] = {.lex_state = 239},
  [1756] = {.lex_state = 239},
  [1757] = {.lex_state = 226},
  [1758] = {.lex_state = 239},
  [1759] = {.lex_state = 239},
  [1760] = {.lex_state = 194},
  [1761] = {.lex_state = 239},
  [1762] = {.lex_state = 239},
  [1763] = {.lex_state = 226},
  [1764] = {.lex_state = 239},
  [1765] = {.lex_state = 239},
  [1766] = {.lex_state = 239},
  [1767] = {.lex_state = 239},
  [1768] = {.lex_state = 239},
  [1769] = {.lex_state = 239},
  [1770] = {.lex_state = 239},
  [1771] = {.lex_state = 239},
  [1772] = {.lex_state = 239},
  [1773] = {.lex_state = 181},
  [1774] = {.lex_state = 239},
  [1775] = {.lex_state = 239},
  [1776] = {.lex_state = 239},
  [1777] = {.lex_state = 239},
  [1778] = {.lex_state = 239},
  [1779] = {.lex_state = 239},
  [1780] = {.lex_state = 239},
  [1781] = {.lex_state = 239},
  [1782] = {.lex_state = 239},
  [1783] = {.lex_state = 194},
  [1784] = {.lex_state = 205},
  [1785] = {.lex_state = 239},
  [1786] = {.lex_state = 226},
  [1787] = {.lex_state = 239},
  [1788] = {.lex_state = 239},
  [1789] = {.lex_state = 239},
  [1790] = {.lex_state = 226},
  [1791] = {.lex_state = 239},
  [1792] = {.lex_state = 239},
  [1793] = {.lex_state = 239},
  [1794] = {.lex_state = 239},
  [1795] = {.lex_state = 239},
  [1796] = {.lex_state = 239},
  [1797] = {.lex_state = 239},
  [1798] = {.lex_state = 239},
  [1799] = {.lex_state = 239},
  [1800] = {.lex_state = 194},
  [1801] = {.lex_state = 239},
  [1802] = {.lex_state = 239},
  [1803] = {.lex_state = 239},
  [1804] = {.lex_state = 239},
  [1805] = {.lex_state = 239},
  [1806] = {.lex_state = 239},
  [1807] = {.lex_state = 239},
  [1808] = {.lex_state = 239},
  [1809] = {.lex_state = 239},
  [1810] = {.lex_state = 239},
  [1811] = {.lex_state = 239},
  [1812] = {.lex_state = 194},
  [1813] = {.lex_state = 226},
  [1814] = {.lex_state = 226},
  [1815] = {.lex_state = 239},
  [1816] = {.lex_state = 226},
  [1817] = {.lex_state = 239},
  [1818] = {.lex_state = 226},
  [1819] = {.lex_state = 239},
  [1820] = {.lex_state = 239},
  [1821] = {.lex_state = 239},
  [1822] = {.lex_state = 239},
  [1823] = {.lex_state = 239},
  [1824] = {.lex_state = 239},
  [1825] = {.lex_state = 226},
  [1826] = {.lex_state = 226},
  [1827] = {.lex_state = 239},
  [1828] = {.lex_state = 239},
  [1829] = {.lex_state = 239},
  [1830] = {.lex_state = 226},
  [1831] = {.lex_state = 194},
  [1832] = {.lex_state = 239},
  [1833] = {.lex_state = 239},
  [1834] = {.lex_state = 205},
  [1835] = {.lex_state = 239},
  [1836] = {.lex_state = 240},
  [1837] = {.lex_state = 205},
  [1838] = {.lex_state = 240},
  [1839] = {.lex_state = 205},
  [1840] = {.lex_state = 205},
  [1841] = {.lex_state = 205},
  [1842] = {.lex_state = 205},
  [1843] = {.lex_state = 205},
  [1844] = {.lex_state = 204},
  [1845] = {.lex_state = 195},
  [1846] = {.lex_state = 240},
  [1847] = {.lex_state = 205},
  [1848] = {.lex_state = 205},
  [1849] = {.lex_state = 205},
  [1850] = {.lex_state = 205},
  [1851] = {.lex_state = 240},
  [1852] = {.lex_state = 205},
  [1853] = {.lex_state = 205},
  [1854] = {.lex_state = 205},
  [1855] = {.lex_state = 195},
  [1856] = {.lex_state = 209},
  [1857] = {.lex_state = 217},
  [1858] = {.lex_state = 176},
  [1859] = {.lex_state = 205},
  [1860] = {.lex_state = 205},
  [1861] = {.lex_state = 205},
  [1862] = {.lex_state = 195},
  [1863] = {.lex_state = 179},
  [1864] = {.lex_state = 205},
  [1865] = {.lex_state = 205},
  [1866] = {.lex_state = 205},
  [1867] = {.lex_state = 205},
  [1868] = {.lex_state = 176},
  [1869] = {.lex_state = 205},
  [1870] = {.lex_state = 205},
  [1871] = {.lex_state = 205},
  [1872] = {.lex_state = 205},
  [1873] = {.lex_state = 205},
  [1874] = {.lex_state = 205},
  [1875] = {.lex_state = 205},
  [1876] = {.lex_state = 205},
  [1877] = {.lex_state = 205},
  [1878] = {.lex_state = 205},
  [1879] = {.lex_state = 205},
  [1880] = {.lex_state = 205},
  [1881] = {.lex_state = 205},
  [1882] = {.lex_state = 205},
  [1883] = {.lex_state = 205},
  [1884] = {.lex_state = 205},
  [1885] = {.lex_state = 205},
  [1886] = {.lex_state = 205},
  [1887] = {.lex_state = 205},
  [1888] = {.lex_state = 205},
  [1889] = {.lex_state = 205},
  [1890] = {.lex_state = 195},
  [1891] = {.lex_state = 239},
  [1892] = {.lex_state = 200},
  [1893] = {.lex_state = 238},
  [1894] = {.lex_state = 238},
  [1895] = {.lex_state = 217},
  [1896] = {.lex_state = 197},
  [1897] = {.lex_state = 238},
  [1898] = {.lex_state = 206},
  [1899] = {.lex_state = 197},
  [1900] = {.lex_state = 200},
  [1901] = {.lex_state = 197},
  [1902] = {.lex_state = 206},
  [1903] = {.lex_state = 241},
  [1904] = {.lex_state = 241},
  [1905] = {.lex_state = 200},
  [1906] = {.lex_state = 238},
  [1907] = {.lex_state = 239},
  [1908] = {.lex_state = 238},
  [1909] = {.lex_state = 238},
  [1910] = {.lex_state = 238},
  [1911] = {.lex_state = 200},
  [1912] = {.lex_state = 239},
  [1913] = {.lex_state = 240},
  [1914] = {.lex_state = 240},
  [1915] = {.lex_state = 239},
  [1916] = {.lex_state = 197},
  [1917] = {.lex_state = 195},
  [1918] = {.lex_state = 239},
  [1919] = {.lex_state = 240},
  [1920] = {.lex_state = 240},
  [1921] = {.lex_state = 197},
  [1922] = {.lex_state = 195},
  [1923] = {.lex_state = 197},
  [1924] = {.lex_state = 239},
  [1925] = {.lex_state = 239},
  [1926] = {.lex_state = 230},
  [1927] = {.lex_state = 206},
  [1928] = {.lex_state = 206},
  [1929] = {.lex_state = 239},
  [1930] = {.lex_state = 206},
  [1931] = {.lex_state = 195},
  [1932] = {.lex_state = 239},
  [1933] = {.lex_state = 239},
  [1934] = {.lex_state = 239},
  [1935] = {.lex_state = 206},
  [1936] = {.lex_state = 197},
  [1937] = {.lex_state = 195},
  [1938] = {.lex_state = 206},
  [1939] = {.lex_state = 240},
  [1940] = {.lex_state = 206},
  [1941] = {.lex_state = 197},
  [1942] = {.lex_state = 181},
  [1943] = {.lex_state = 206},
  [1944] = {.lex_state = 206},
  [1945] = {.lex_state = 197},
  [1946] = {.lex_state = 206},
  [1947] = {.lex_state = 206},
  [1948] = {.lex_state = 206},
  [1949] = {.lex_state = 195},
  [1950] = {.lex_state = 206},
  [1951] = {.lex_state = 206},
  [1952] = {.lex_state = 195},
  [1953] = {.lex_state = 240},
  [1954] = {.lex_state = 240},
  [1955] = {.lex_state = 195},
  [1956] = {.lex_state = 184},
  [1957] = {.lex_state = 240},
  [1958] = {.lex_state = 240},
  [1959] = {.lex_state = 195},
  [1960] = {.lex_state = 195},
  [1961] = {.lex_state = 195},
  [1962] = {.lex_state = 195},
  [1963] = {.lex_state = 195},
  [1964] = {.lex_state = 195},
  [1965] = {.lex_state = 240},
  [1966] = {.lex_state = 240},
  [1967] = {.lex_state = 195},
  [1968] = {.lex_state = 240},
  [1969] = {.lex_state = 195},
  [1970] = {.lex_state = 240},
  [1971] = {.lex_state = 240},
  [1972] = {.lex_state = 240},
  [1973] = {.lex_state = 195},
  [1974] = {.lex_state = 240},
  [1975] = {.lex_state = 240},
  [1976] = {.lex_state = 240},
  [1977] = {.lex_state = 240},
  [1978] = {.lex_state = 240},
  [1979] = {.lex_state = 240},
  [1980] = {.lex_state = 240},
  [1981] = {.lex_state = 240},
  [1982] = {.lex_state = 195},
  [1983] = {.lex_state = 240},
  [1984] = {.lex_state = 240},
  [1985] = {.lex_state = 240},
  [1986] = {.lex_state = 240},
  [1987] = {.lex_state = 240},
  [1988] = {.lex_state = 240},
  [1989] = {.lex_state = 195},
  [1990] = {.lex_state = 195},
  [1991] = {.lex_state = 195},
  [1992] = {.lex_state = 181},
  [1993] = {.lex_state = 239},
  [1994] = {.lex_state = 195},
  [1995] = {.lex_state = 240},
  [1996] = {.lex_state = 240},
  [1997] = {.lex_state = 240},
  [1998] = {.lex_state = 240},
  [1999] = {.lex_state = 240},
  [2000] = {.lex_state = 240},
  [2001] = {.lex_state = 240},
  [2002] = {.lex_state = 240},
  [2003] = {.lex_state = 240},
  [2004] = {.lex_state = 240},
  [2005] = {.lex_state = 181},
  [2006] = {.lex_state = 240},
  [2007] = {.lex_state = 195},
  [2008] = {.lex_state = 195},
  [2009] = {.lex_state = 240},
  [2010] = {.lex_state = 181},
  [2011] = {.lex_state = 240},
  [2012] = {.lex_state = 240},
  [2013] = {.lex_state = 240},
  [2014] = {.lex_state = 195},
  [2015] = {.lex_state = 195},
  [2016] = {.lex_state = 240},
  [2017] = {.lex_state = 240},
  [2018] = {.lex_state = 195},
  [2019] = {.lex_state = 240},
  [2020] = {.lex_state = 195},
  [2021] = {.lex_state = 240},
  [2022] = {.lex_state = 195},
  [2023] = {.lex_state = 195},
  [2024] = {.lex_state = 195},
  [2025] = {.lex_state = 195},
  [2026] = {.lex_state = 195},
  [2027] = {.lex_state = 195},
  [2028] = {.lex_state = 195},
  [2029] = {.lex_state = 195},
  [2030] = {.lex_state = 240},
  [2031] = {.lex_state = 195},
  [2032] = {.lex_state = 195},
  [2033] = {.lex_state = 240},
  [2034] = {.lex_state = 181},
  [2035] = {.lex_state = 240},
  [2036] = {.lex_state = 195},
  [2037] = {.lex_state = 240},
  [2038] = {.lex_state = 240},
  [2039] = {.lex_state = 195},
  [2040] = {.lex_state = 200},
  [2041] = {.lex_state = 240},
  [2042] = {.lex_state = 195},
  [2043] = {.lex_state = 195},
  [2044] = {.lex_state = 240},
  [2045] = {.lex_state = 195},
  [2046] = {.lex_state = 195},
  [2047] = {.lex_state = 195},
  [2048] = {.lex_state = 241},
  [2049] = {.lex_state = 240},
  [2050] = {.lex_state = 197},
  [2051] = {.lex_state = 200},
  [2052] = {.lex_state = 195},
  [2053] = {.lex_state = 239},
  [2054] = {.lex_state = 195},
  [2055] = {.lex_state = 205},
  [2056] = {.lex_state = 239},
  [2057] = {.lex_state = 240},
  [2058] = {.lex_state = 195},
  [2059] = {.lex_state = 195},
  [2060] = {.lex_state = 195},
  [2061] = {.lex_state = 239},
  [2062] = {.lex_state = 195},
  [2063] = {.lex_state = 195},
  [2064] = {.lex_state = 188},
  [2065] = {.lex_state = 188},
  [2066] = {.lex_state = 195},
  [2067] = {.lex_state = 240},
  [2068] = {.lex_state = 241},
  [2069] = {.lex_state = 239},
  [2070] = {.lex_state = 195},
  [2071] = {.lex_state = 195},
  [2072] = {.lex_state = 195},
  [2073] = {.lex_state = 195},
  [2074] = {.lex_state = 195},
  [2075] = {.lex_state = 240},
  [2076] = {.lex_state = 240},
  [2077] = {.lex_state = 195},
  [2078] = {.lex_state = 195},
  [2079] = {.lex_state = 195},
  [2080] = {.lex_state = 195},
  [2081] = {.lex_state = 195},
  [2082] = {.lex_state = 195},
  [2083] = {.lex_state = 195},
  [2084] = {.lex_state = 240},
  [2085] = {.lex_state = 195},
  [2086] = {.lex_state = 195},
  [2087] = {.lex_state = 195},
  [2088] = {.lex_state = 195},
  [2089] = {.lex_state = 195},
  [2090] = {.lex_state = 195},
  [2091] = {.lex_state = 240},
  [2092] = {.lex_state = 239},
  [2093] = {.lex_state = 195},
  [2094] = {.lex_state = 195},
  [2095] = {.lex_state = 195},
  [2096] = {.lex_state = 240},
  [2097] = {.lex_state = 188},
  [2098] = {.lex_state = 195},
  [2099] = {.lex_state = 179},
  [2100] = {.lex_state = 195},
  [2101] = {.lex_state = 195},
  [2102] = {.lex_state = 240},
  [2103] = {.lex_state = 195},
  [2104] = {.lex_state = 195},
  [2105] = {.lex_state = 240},
  [2106] = {.lex_state = 179},
  [2107] = {.lex_state = 206},
  [2108] = {.lex_state = 240},
  [2109] = {.lex_state = 195},
  [2110] = {.lex_state = 195},
  [2111] = {.lex_state = 240},
  [2112] = {.lex_state = 179},
  [2113] = {.lex_state = 240},
  [2114] = {.lex_state = 195},
  [2115] = {.lex_state = 184},
  [2116] = {.lex_state = 200},
  [2117] = {.lex_state = 239},
  [2118] = {.lex_state = 240},
  [2119] = {.lex_state = 240},
  [2120] = {.lex_state = 240},
  [2121] = {.lex_state = 240},
  [2122] = {.lex_state = 240},
  [2123] = {.lex_state = 240},
  [2124] = {.lex_state = 240},
  [2125] = {.lex_state = 240},
  [2126] = {.lex_state = 240},
  [2127] = {.lex_state = 195},
  [2128] = {.lex_state = 240},
  [2129] = {.lex_state = 240},
  [2130] = {.lex_state = 240},
  [2131] = {.lex_state = 179},
  [2132] = {.lex_state = 240},
  [2133] = {.lex_state = 195},
  [2134] = {.lex_state = 240},
  [2135] = {.lex_state = 239},
  [2136] = {.lex_state = 239},
  [2137] = {.lex_state = 240},
  [2138] = {.lex_state = 240},
  [2139] = {.lex_state = 240},
  [2140] = {.lex_state = 195},
  [2141] = {.lex_state = 195},
  [2142] = {.lex_state = 195},
  [2143] = {.lex_state = 240},
  [2144] = {.lex_state = 240},
  [2145] = {.lex_state = 195},
  [2146] = {.lex_state = 195},
  [2147] = {.lex_state = 195},
  [2148] = {.lex_state = 240},
  [2149] = {.lex_state = 204},
  [2150] = {.lex_state = 240},
  [2151] = {.lex_state = 195},
  [2152] = {.lex_state = 195},
  [2153] = {.lex_state = 240},
  [2154] = {.lex_state = 240},
  [2155] = {.lex_state = 204},
  [2156] = {.lex_state = 240},
  [2157] = {.lex_state = 240},
  [2158] = {.lex_state = 240},
  [2159] = {.lex_state = 205},
  [2160] = {.lex_state = 195},
  [2161] = {.lex_state = 195},
  [2162] = {.lex_state = 195},
  [2163] = {.lex_state = 240},
  [2164] = {.lex_state = 240},
  [2165] = {.lex_state = 195},
  [2166] = {.lex_state = 195},
  [2167] = {.lex_state = 195},
  [2168] = {.lex_state = 240},
  [2169] = {.lex_state = 198},
  [2170] = {.lex_state = 230},
  [2171] = {.lex_state = 179},
  [2172] = {.lex_state = 200},
  [2173] = {.lex_state = 200},
  [2174] = {.lex_state = 197},
  [2175] = {.lex_state = 200},
  [2176] = {.lex_state = 198},
  [2177] = {.lex_state = 179},
  [2178] = {.lex_state = 179},
  [2179] = {.lex_state = 179},
  [2180] = {.lex_state = 230},
  [2181] = {.lex_state = 200},
  [2182] = {.lex_state = 187},
  [2183] = {.lex_state = 200},
  [2184] = {.lex_state = 179},
  [2185] = {.lex_state = 198},
  [2186] = {.lex_state = 200},
  [2187] = {.lex_state = 179},
  [2188] = {.lex_state = 179},
  [2189] = {.lex_state = 187},
  [2190] = {.lex_state = 200},
  [2191] = {.lex_state = 200},
  [2192] = {.lex_state = 200},
  [2193] = {.lex_state = 200},
  [2194] = {.lex_state = 198},
  [2195] = {.lex_state = 197},
  [2196] = {.lex_state = 187},
  [2197] = {.lex_state = 197},
  [2198] = {.lex_state = 230},
  [2199] = {.lex_state = 179},
  [2200] = {.lex_state = 200},
  [2201] = {.lex_state = 200},
  [2202] = {.lex_state = 185},
  [2203] = {.lex_state = 198},
  [2204] = {.lex_state = 185},
  [2205] = {.lex_state = 197},
  [2206] = {.lex_state = 200},
  [2207] = {.lex_state = 200},
  [2208] = {.lex_state = 189},
  [2209] = {.lex_state = 181},
  [2210] = {.lex_state = 200},
  [2211] = {.lex_state = 197},
  [2212] = {.lex_state = 230},
  [2213] = {.lex_state = 181},
  [2214] = {.lex_state = 197},
  [2215] = {.lex_state = 239},
  [2216] = {.lex_state = 206},
  [2217] = {.lex_state = 200},
  [2218] = {.lex_state = 198},
  [2219] = {.lex_state = 198},
  [2220] = {.lex_state = 198},
  [2221] = {.lex_state = 200},
  [2222] = {.lex_state = 200},
  [2223] = {.lex_state = 200},
  [2224] = {.lex_state = 198},
  [2225] = {.lex_state = 200},
  [2226] = {.lex_state = 200},
  [2227] = {.lex_state = 200},
  [2228] = {.lex_state = 200},
  [2229] = {.lex_state = 230},
  [2230] = {.lex_state = 197},
  [2231] = {.lex_state = 200},
  [2232] = {.lex_state = 200},
  [2233] = {.lex_state = 200},
  [2234] = {.lex_state = 197},
  [2235] = {.lex_state = 200},
  [2236] = {.lex_state = 191},
  [2237] = {.lex_state = 198},
  [2238] = {.lex_state = 198},
  [2239] = {.lex_state = 179},
  [2240] = {.lex_state = 200},
  [2241] = {.lex_state = 200},
  [2242] = {.lex_state = 179},
  [2243] = {.lex_state = 200},
  [2244] = {.lex_state = 239},
  [2245] = {.lex_state = 200},
  [2246] = {.lex_state = 200},
  [2247] = {.lex_state = 198},
  [2248] = {.lex_state = 197},
  [2249] = {.lex_state = 200},
  [2250] = {.lex_state = 239},
  [2251] = {.lex_state = 200},
  [2252] = {.lex_state = 181},
  [2253] = {.lex_state = 200},
  [2254] = {.lex_state = 197},
  [2255] = {.lex_state = 200},
  [2256] = {.lex_state = 197},
  [2257] = {.lex_state = 200},
  [2258] = {.lex_state = 200},
  [2259] = {.lex_state = 239},
  [2260] = {.lex_state = 239},
  [2261] = {.lex_state = 200},
  [2262] = {.lex_state = 200},
  [2263] = {.lex_state = 200},
  [2264] = {.lex_state = 200},
  [2265] = {.lex_state = 197},
  [2266] = {.lex_state = 179},
  [2267] = {.lex_state = 200},
  [2268] = {.lex_state = 200},
  [2269] = {.lex_state = 197},
  [2270] = {.lex_state = 198},
  [2271] = {.lex_state = 239},
  [2272] = {.lex_state = 200},
  [2273] = {.lex_state = 200},
  [2274] = {.lex_state = 200},
  [2275] = {.lex_state = 197},
  [2276] = {.lex_state = 200},
  [2277] = {.lex_state = 197},
  [2278] = {.lex_state = 197},
  [2279] = {.lex_state = 198},
  [2280] = {.lex_state = 198},
  [2281] = {.lex_state = 206},
  [2282] = {.lex_state = 181},
  [2283] = {.lex_state = 200},
  [2284] = {.lex_state = 198},
  [2285] = {.lex_state = 191},
  [2286] = {.lex_state = 189},
  [2287] = {.lex_state = 198},
  [2288] = {.lex_state = 197},
  [2289] = {.lex_state = 200},
  [2290] = {.lex_state = 200},
  [2291] = {.lex_state = 239},
  [2292] = {.lex_state = 239},
  [2293] = {.lex_state = 197},
  [2294] = {.lex_state = 200},
  [2295] = {.lex_state = 197},
  [2296] = {.lex_state = 239},
  [2297] = {.lex_state = 181},
  [2298] = {.lex_state = 198},
  [2299] = {.lex_state = 200},
  [2300] = {.lex_state = 179},
  [2301] = {.lex_state = 191},
  [2302] = {.lex_state = 200},
  [2303] = {.lex_state = 200},
  [2304] = {.lex_state = 239},
  [2305] = {.lex_state = 239},
  [2306] = {.lex_state = 239},
  [2307] = {.lex_state = 239},
  [2308] = {.lex_state = 239},
  [2309] = {.lex_state = 200},
  [2310] = {.lex_state = 200},
  [2311] = {.lex_state = 206},
  [2312] = {.lex_state = 200},
  [2313] = {.lex_state = 197},
  [2314] = {.lex_state = 200},
  [2315] = {.lex_state = 200},
  [2316] = {.lex_state = 200},
  [2317] = {.lex_state = 200},
  [2318] = {.lex_state = 200},
  [2319] = {.lex_state = 204},
  [2320] = {.lex_state = 239},
  [2321] = {.lex_state = 200},
  [2322] = {.lex_state = 200},
  [2323] = {.lex_state = 229},
  [2324] = {.lex_state = 197},
  [2325] = {.lex_state = 200},
  [2326] = {.lex_state = 229},
  [2327] = {.lex_state = 200},
  [2328] = {.lex_state = 229},
  [2329] = {.lex_state = 206},
  [2330] = {.lex_state = 206},
  [2331] = {.lex_state = 200},
  [2332] = {.lex_state = 229},
  [2333] = {.lex_state = 181},
  [2334] = {.lex_state = 206},
  [2335] = {.lex_state = 206},
  [2336] = {.lex_state = 206},
  [2337] = {.lex_state = 229},
  [2338] = {.lex_state = 197},
  [2339] = {.lex_state = 181},
  [2340] = {.lex_state = 204},
  [2341] = {.lex_state = 229},
  [2342] = {.lex_state = 181},
  [2343] = {.lex_state = 206},
  [2344] = {.lex_state = 229},
  [2345] = {.lex_state = 181},
  [2346] = {.lex_state = 200},
  [2347] = {.lex_state = 197},
  [2348] = {.lex_state = 229},
  [2349] = {.lex_state = 229},
  [2350] = {.lex_state = 206},
  [2351] = {.lex_state = 206},
  [2352] = {.lex_state = 206},
  [2353] = {.lex_state = 200},
  [2354] = {.lex_state = 200},
  [2355] = {.lex_state = 229},
  [2356] = {.lex_state = 200},
  [2357] = {.lex_state = 229},
  [2358] = {.lex_state = 187},
  [2359] = {.lex_state = 239},
  [2360] = {.lex_state = 206},
  [2361] = {.lex_state = 229},
  [2362] = {.lex_state = 229},
  [2363] = {.lex_state = 229},
  [2364] = {.lex_state = 206},
  [2365] = {.lex_state = 200},
  [2366] = {.lex_state = 187},
  [2367] = {.lex_state = 198},
  [2368] = {.lex_state = 187},
  [2369] = {.lex_state = 191},
  [2370] = {.lex_state = 187},
  [2371] = {.lex_state = 198},
  [2372] = {.lex_state = 187},
  [2373] = {.lex_state = 200},
  [2374] = {.lex_state = 198},
  [2375] = {.lex_state = 209},
  [2376] = {.lex_state = 187},
  [2377] = {.lex_state = 197},
  [2378] = {.lex_state = 187},
  [2379] = {.lex_state = 197},
  [2380] = {.lex_state = 197},
  [2381] = {.lex_state = 197},
  [2382] = {.lex_state = 187},
  [2383] = {.lex_state = 230},
  [2384] = {.lex_state = 197},
  [2385] = {.lex_state = 238},
  [2386] = {.lex_state = 198},
  [2387] = {.lex_state = 197},
  [2388] = {.lex_state = 197},
  [2389] = {.lex_state = 181},
  [2390] = {.lex_state = 181},
  [2391] = {.lex_state = 181},
  [2392] = {.lex_state = 181},
  [2393] = {.lex_state = 238},
  [2394] = {.lex_state = 238},
  [2395] = {.lex_state = 203},
  [2396] = {.lex_state = 200},
  [2397] = {.lex_state = 200},
  [2398] = {.lex_state = 197},
  [2399] = {.lex_state = 211},
  [2400] = {.lex_state = 238},
  [2401] = {.lex_state = 200},
  [2402] = {.lex_state = 200},
  [2403] = {.lex_state = 200},
  [2404] = {.lex_state = 198},
  [2405] = {.lex_state = 200},
  [2406] = {.lex_state = 238},
  [2407] = {.lex_state = 200},
  [2408] = {.lex_state = 200},
  [2409] = {.lex_state = 238},
  [2410] = {.lex_state = 200},
  [2411] = {.lex_state = 238},
  [2412] = {.lex_state = 200},
  [2413] = {.lex_state = 200},
  [2414] = {.lex_state = 200},
  [2415] = {.lex_state = 200},
  [2416] = {.lex_state = 200},
  [2417] = {.lex_state = 200},
  [2418] = {.lex_state = 200},
  [2419] = {.lex_state = 200},
  [2420] = {.lex_state = 200},
  [2421] = {.lex_state = 200},
  [2422] = {.lex_state = 200},
  [2423] = {.lex_state = 200},
  [2424] = {.lex_state = 187},
  [2425] = {.lex_state = 200},
  [2426] = {.lex_state = 200},
  [2427] = {.lex_state = 200},
  [2428] = {.lex_state = 200},
  [2429] = {.lex_state = 200},
  [2430] = {.lex_state = 200},
  [2431] = {.lex_state = 200},
  [2432] = {.lex_state = 200},
  [2433] = {.lex_state = 200},
  [2434] = {.lex_state = 238},
  [2435] = {.lex_state = 200},
  [2436] = {.lex_state = 200},
  [2437] = {.lex_state = 187},
  [2438] = {.lex_state = 217},
  [2439] = {.lex_state = 200},
  [2440] = {.lex_state = 238},
  [2441] = {.lex_state = 200},
  [2442] = {.lex_state = 200},
  [2443] = {.lex_state = 200},
  [2444] = {.lex_state = 191},
  [2445] = {.lex_state = 191},
  [2446] = {.lex_state = 191},
  [2447] = {.lex_state = 191},
  [2448] = {.lex_state = 200},
  [2449] = {.lex_state = 200},
  [2450] = {.lex_state = 187},
  [2451] = {.lex_state = 200},
  [2452] = {.lex_state = 200},
  [2453] = {.lex_state = 200},
  [2454] = {.lex_state = 238},
  [2455] = {.lex_state = 200},
  [2456] = {.lex_state = 200},
  [2457] = {.lex_state = 200},
  [2458] = {.lex_state = 200},
  [2459] = {.lex_state = 200},
  [2460] = {.lex_state = 200},
  [2461] = {.lex_state = 200},
  [2462] = {.lex_state = 200},
  [2463] = {.lex_state = 200},
  [2464] = {.lex_state = 200},
  [2465] = {.lex_state = 200},
  [2466] = {.lex_state = 200},
  [2467] = {.lex_state = 238},
  [2468] = {.lex_state = 238},
  [2469] = {.lex_state = 238},
  [2470] = {.lex_state = 200},
  [2471] = {.lex_state = 200},
  [2472] = {.lex_state = 200},
  [2473] = {.lex_state = 238},
  [2474] = {.lex_state = 238},
  [2475] = {.lex_state = 238},
  [2476] = {.lex_state = 238},
  [2477] = {.lex_state = 200},
  [2478] = {.lex_state = 200},
  [2479] = {.lex_state = 200},
  [2480] = {.lex_state = 200},
  [2481] = {.lex_state = 200},
  [2482] = {.lex_state = 200},
  [2483] = {.lex_state = 238},
  [2484] = {.lex_state = 200},
  [2485] = {.lex_state = 200},
  [2486] = {.lex_state = 200},
  [2487] = {.lex_state = 238},
  [2488] = {.lex_state = 238},
  [2489] = {.lex_state = 238},
  [2490] = {.lex_state = 238},
  [2491] = {.lex_state = 238},
  [2492] = {.lex_state = 238},
  [2493] = {.lex_state = 200},
  [2494] = {.lex_state = 200},
  [2495] = {.lex_state = 200},
  [2496] = {.lex_state = 200},
  [2497] = {.lex_state = 200},
  [2498] = {.lex_state = 200},
  [2499] = {.lex_state = 200},
  [2500] = {.lex_state = 200},
  [2501] = {.lex_state = 238},
  [2502] = {.lex_state = 238},
  [2503] = {.lex_state = 218},
  [2504] = {.lex_state = 238},
  [2505] = {.lex_state = 200},
  [2506] = {.lex_state = 200},
  [2507] = {.lex_state = 238},
  [2508] = {.lex_state = 238},
  [2509] = {.lex_state = 238},
  [2510] = {.lex_state = 238},
  [2511] = {.lex_state = 238},
  [2512] = {.lex_state = 238},
  [2513] = {.lex_state = 238},
  [2514] = {.lex_state = 200},
  [2515] = {.lex_state = 238},
  [2516] = {.lex_state = 238},
  [2517] = {.lex_state = 238},
  [2518] = {.lex_state = 238},
  [2519] = {.lex_state = 200},
  [2520] = {.lex_state = 187},
  [2521] = {.lex_state = 200},
  [2522] = {.lex_state = 238},
  [2523] = {.lex_state = 238},
  [2524] = {.lex_state = 200},
  [2525] = {.lex_state = 200},
  [2526] = {.lex_state = 200},
  [2527] = {.lex_state = 200},
  [2528] = {.lex_state = 200},
  [2529] = {.lex_state = 238},
  [2530] = {.lex_state = 238},
  [2531] = {.lex_state = 238},
  [2532] = {.lex_state = 238},
  [2533] = {.lex_state = 200},
  [2534] = {.lex_state = 228},
  [2535] = {.lex_state = 209},
  [2536] = {.lex_state = 228},
  [2537] = {.lex_state = 238},
  [2538] = {.lex_state = 228},
  [2539] = {.lex_state = 228},
  [2540] = {.lex_state = 228},
  [2541] = {.lex_state = 228},
  [2542] = {.lex_state = 228},
  [2543] = {.lex_state = 228},
  [2544] = {.lex_state = 239},
  [2545] = {.lex_state = 209},
  [2546] = {.lex_state = 209},
  [2547] = {.lex_state = 228},
  [2548] = {.lex_state = 209},
  [2549] = {.lex_state = 229},
  [2550] = {.lex_state = 238},
  [2551] = {.lex_state = 229},
  [2552] = {.lex_state = 209},
  [2553] = {.lex_state = 209},
  [2554] = {.lex_state = 209},
  [2555] = {.lex_state = 209},
  [2556] = {.lex_state = 228},
  [2557] = {.lex_state = 228},
  [2558] = {.lex_state = 238},
  [2559] = {.lex_state = 209},
  [2560] = {.lex_state = 191},
  [2561] = {.lex_state = 191},
  [2562] = {.lex_state = 191},
  [2563] = {.lex_state = 191},
  [2564] = {.lex_state = 241},
  [2565] = {.lex_state = 241},
  [2566] = {.lex_state = 187},
  [2567] = {.lex_state = 228},
  [2568] = {.lex_state = 209},
  [2569] = {.lex_state = 209},
  [2570] = {.lex_state = 209},
  [2571] = {.lex_state = 209},
  [2572] = {.lex_state = 209},
  [2573] = {.lex_state = 209},
  [2574] = {.lex_state = 238},
  [2575] = {.lex_state = 238},
  [2576] = {.lex_state = 238},
  [2577] = {.lex_state = 229},
  [2578] = {.lex_state = 229},
  [2579] = {.lex_state = 229},
  [2580] = {.lex_state = 229},
  [2581] = {.lex_state = 229},
  [2582] = {.lex_state = 228},
  [2583] = {.lex_state = 238},
  [2584] = {.lex_state = 238},
  [2585] = {.lex_state = 238},
  [2586] = {.lex_state = 217},
  [2587] = {.lex_state = 217},
  [2588] = {.lex_state = 217},
  [2589] = {.lex_state = 217},
  [2590] = {.lex_state = 238},
  [2591] = {.lex_state = 209},
  [2592] = {.lex_state = 211},
  [2593] = {.lex_state = 211},
  [2594] = {.lex_state = 238},
  [2595] = {.lex_state = 183},
  [2596] = {.lex_state = 217},
  [2597] = {.lex_state = 217},
  [2598] = {.lex_state = 228},
  [2599] = {.lex_state = 238},
  [2600] = {.lex_state = 238},
  [2601] = {.lex_state = 176},
  [2602] = {.lex_state = 238},
  [2603] = {.lex_state = 217},
  [2604] = {.lex_state = 217},
  [2605] = {.lex_state = 211},
  [2606] = {.lex_state = 217},
  [2607] = {.lex_state = 217},
  [2608] = {.lex_state = 217},
  [2609] = {.lex_state = 217},
  [2610] = {.lex_state = 209},
  [2611] = {.lex_state = 209},
  [2612] = {.lex_state = 217},
  [2613] = {.lex_state = 176},
  [2614] = {.lex_state = 229},
  [2615] = {.lex_state = 229},
  [2616] = {.lex_state = 238},
  [2617] = {.lex_state = 238},
  [2618] = {.lex_state = 229},
  [2619] = {.lex_state = 238},
  [2620] = {.lex_state = 238},
  [2621] = {.lex_state = 229},
  [2622] = {.lex_state = 238},
  [2623] = {.lex_state = 238},
  [2624] = {.lex_state = 183},
  [2625] = {.lex_state = 238},
  [2626] = {.lex_state = 209},
  [2627] = {.lex_state = 187},
  [2628] = {.lex_state = 183},
  [2629] = {.lex_state = 238},
  [2630] = {.lex_state = 209},
  [2631] = {.lex_state = 217},
  [2632] = {.lex_state = 209},
  [2633] = {.lex_state = 229},
  [2634] = {.lex_state = 229},
  [2635] = {.lex_state = 187},
  [2636] = {.lex_state = 238},
  [2637] = {.lex_state = 229},
  [2638] = {.lex_state = 229},
  [2639] = {.lex_state = 187},
  [2640] = {.lex_state = 187},
  [2641] = {.lex_state = 238},
  [2642] = {.lex_state = 229},
  [2643] = {.lex_state = 217},
  [2644] = {.lex_state = 187},
  [2645] = {.lex_state = 229},
  [2646] = {.lex_state = 229},
  [2647] = {.lex_state = 229},
  [2648] = {.lex_state = 229},
  [2649] = {.lex_state = 229},
  [2650] = {.lex_state = 229},
  [2651] = {.lex_state = 229},
  [2652] = {.lex_state = 229},
  [2653] = {.lex_state = 187},
  [2654] = {.lex_state = 241},
  [2655] = {.lex_state = 211},
  [2656] = {.lex_state = 241},
  [2657] = {.lex_state = 229},
  [2658] = {.lex_state = 217},
  [2659] = {.lex_state = 217},
  [2660] = {.lex_state = 233},
  [2661] = {.lex_state = 238},
  [2662] = {.lex_state = 217},
  [2663] = {.lex_state = 204},
  [2664] = {.lex_state = 204},
  [2665] = {.lex_state = 187},
  [2666] = {.lex_state = 187},
  [2667] = {.lex_state = 229},
  [2668] = {.lex_state = 229},
  [2669] = {.lex_state = 217},
  [2670] = {.lex_state = 209},
  [2671] = {.lex_state = 218},
  [2672] = {.lex_state = 229},
  [2673] = {.lex_state = 229},
  [2674] = {.lex_state = 239},
  [2675] = {.lex_state = 229},
  [2676] = {.lex_state = 229},
  [2677] = {.lex_state = 229},
  [2678] = {.lex_state = 239},
  [2679] = {.lex_state = 229},
  [2680] = {.lex_state = 218},
  [2681] = {.lex_state = 229},
  [2682] = {.lex_state = 229},
  [2683] = {.lex_state = 229},
  [2684] = {.lex_state = 229},
  [2685] = {.lex_state = 229},
  [2686] = {.lex_state = 229},
  [2687] = {.lex_state = 217},
  [2688] = {.lex_state = 229},
  [2689] = {.lex_state = 229},
  [2690] = {.lex_state = 233},
  [2691] = {.lex_state = 229},
  [2692] = {.lex_state = 229},
  [2693] = {.lex_state = 229},
  [2694] = {.lex_state = 238},
  [2695] = {.lex_state = 233},
  [2696] = {.lex_state = 229},
  [2697] = {.lex_state = 233},
  [2698] = {.lex_state = 229},
  [2699] = {.lex_state = 229},
  [2700] = {.lex_state = 229},
  [2701] = {.lex_state = 229},
  [2702] = {.lex_state = 229},
  [2703] = {.lex_state = 209},
  [2704] = {.lex_state = 229},
  [2705] = {.lex_state = 229},
  [2706] = {.lex_state = 229},
  [2707] = {.lex_state = 229},
  [2708] = {.lex_state = 229},
  [2709] = {.lex_state = 209},
  [2710] = {.lex_state = 209},
  [2711] = {.lex_state = 209},
  [2712] = {.lex_state = 209},
  [2713] = {.lex_state = 209},
  [2714] = {.lex_state = 209},
  [2715] = {.lex_state = 217},
  [2716] = {.lex_state = 209},
  [2717] = {.lex_state = 209},
  [2718] = {.lex_state = 209},
  [2719] = {.lex_state = 176},
  [2720] = {.lex_state = 176},
  [2721] = {.lex_state = 176},
  [2722] = {.lex_state = 209},
  [2723] = {.lex_state = 238},
  [2724] = {.lex_state = 194},
  [2725] = {.lex_state = 176},
  [2726] = {.lex_state = 176},
  [2727] = {.lex_state = 176},
  [2728] = {.lex_state = 218},
  [2729] = {.lex_state = 194},
  [2730] = {.lex_state = 176},
  [2731] = {.lex_state = 238},
  [2732] = {.lex_state = 209},
  [2733] = {.lex_state = 209},
  [2734] = {.lex_state = 176},
  [2735] = {.lex_state = 176},
  [2736] = {.lex_state = 194},
  [2737] = {.lex_state = 176},
  [2738] = {.lex_state = 176},
  [2739] = {.lex_state = 176},
  [2740] = {.lex_state = 176},
  [2741] = {.lex_state = 176},
  [2742] = {.lex_state = 194},
  [2743] = {.lex_state = 176},
  [2744] = {.lex_state = 209},
  [2745] = {.lex_state = 194},
  [2746] = {.lex_state = 209},
  [2747] = {.lex_state = 176},
  [2748] = {.lex_state = 194},
  [2749] = {.lex_state = 209},
  [2750] = {.lex_state = 209},
  [2751] = {.lex_state = 238},
  [2752] = {.lex_state = 176},
  [2753] = {.lex_state = 176},
  [2754] = {.lex_state = 209},
  [2755] = {.lex_state = 209},
  [2756] = {.lex_state = 209},
  [2757] = {.lex_state = 209},
  [2758] = {.lex_state = 194},
  [2759] = {.lex_state = 176},
  [2760] = {.lex_state = 176},
  [2761] = {.lex_state = 209},
  [2762] = {.lex_state = 227},
  [2763] = {.lex_state = 209},
  [2764] = {.lex_state = 209},
  [2765] = {.lex_state = 209},
  [2766] = {.lex_state = 194},
  [2767] = {.lex_state = 209},
  [2768] = {.lex_state = 227},
  [2769] = {.lex_state = 183},
  [2770] = {.lex_state = 194},
  [2771] = {.lex_state = 194},
  [2772] = {.lex_state = 197},
  [2773] = {.lex_state = 197},
  [2774] = {.lex_state = 198},
  [2775] = {.lex_state = 238},
  [2776] = {.lex_state = 198},
  [2777] = {.lex_state = 209},
  [2778] = {.lex_state = 194},
  [2779] = {.lex_state = 209},
  [2780] = {.lex_state = 194},
  [2781] = {.lex_state = 194},
  [2782] = {.lex_state = 198},
  [2783] = {.lex_state = 209},
  [2784] = {.lex_state = 217},
  [2785] = {.lex_state = 183},
  [2786] = {.lex_state = 198},
  [2787] = {.lex_state = 209},
  [2788] = {.lex_state = 238},
  [2789] = {.lex_state = 217},
  [2790] = {.lex_state = 197},
  [2791] = {.lex_state = 197},
  [2792] = {.lex_state = 194},
  [2793] = {.lex_state = 194},
  [2794] = {.lex_state = 209},
  [2795] = {.lex_state = 197},
  [2796] = {.lex_state = 197},
  [2797] = {.lex_state = 197},
  [2798] = {.lex_state = 197},
  [2799] = {.lex_state = 197},
  [2800] = {.lex_state = 194},
  [2801] = {.lex_state = 194},
  [2802] = {.lex_state = 197},
  [2803] = {.lex_state = 209},
  [2804] = {.lex_state = 209},
  [2805] = {.lex_state = 194},
  [2806] = {.lex_state = 209},
  [2807] = {.lex_state = 197},
  [2808] = {.lex_state = 197},
  [2809] = {.lex_state = 243},
  [2810] = {.lex_state = 238},
  [2811] = {.lex_state = 209},
  [2812] = {.lex_state = 197},
  [2813] = {.lex_state = 197},
  [2814] = {.lex_state = 209},
  [2815] = {.lex_state = 209},
  [2816] = {.lex_state = 209},
  [2817] = {.lex_state = 197},
  [2818] = {.lex_state = 197},
  [2819] = {.lex_state = 197},
  [2820] = {.lex_state = 209},
  [2821] = {.lex_state = 197},
  [2822] = {.lex_state = 198},
  [2823] = {.lex_state = 209},
  [2824] = {.lex_state = 209},
  [2825] = {.lex_state = 183},
  [2826] = {.lex_state = 217},
  [2827] = {.lex_state = 227},
  [2828] = {.lex_state = 209},
  [2829] = {.lex_state = 183},
  [2830] = {.lex_state = 209},
  [2831] = {.lex_state = 211},
  [2832] = {.lex_state = 211},
  [2833] = {.lex_state = 194},
  [2834] = {.lex_state = 217},
  [2835] = {.lex_state = 209},
  [2836] = {.lex_state = 198},
  [2837] = {.lex_state = 194},
  [2838] = {.lex_state = 198},
  [2839] = {.lex_state = 217},
  [2840] = {.lex_state = 217},
  [2841] = {.lex_state = 209},
  [2842] = {.lex_state = 194},
  [2843] = {.lex_state = 238},
  [2844] = {.lex_state = 217},
  [2845] = {.lex_state = 204},
  [2846] = {.lex_state = 211},
  [2847] = {.lex_state = 204},
  [2848] = {.lex_state = 217},
  [2849] = {.lex_state = 217},
  [2850] = {.lex_state = 239},
  [2851] = {.lex_state = 209},
  [2852] = {.lex_state = 217},
  [2853] = {.lex_state = 217},
  [2854] = {.lex_state = 209},
  [2855] = {.lex_state = 201},
  [2856] = {.lex_state = 209},
  [2857] = {.lex_state = 238},
  [2858] = {.lex_state = 217},
  [2859] = {.lex_state = 209},
  [2860] = {.lex_state = 242},
  [2861] = {.lex_state = 209},
  [2862] = {.lex_state = 217},
  [2863] = {.lex_state = 242},
  [2864] = {.lex_state = 196},
  [2865] = {.lex_state = 217},
  [2866] = {.lex_state = 217},
  [2867] = {.lex_state = 217},
  [2868] = {.lex_state = 238},
  [2869] = {.lex_state = 217},
  [2870] = {.lex_state = 201},
  [2871] = {.lex_state = 209},
  [2872] = {.lex_state = 209},
  [2873] = {.lex_state = 217},
  [2874] = {.lex_state = 242},
  [2875] = {.lex_state = 238},
  [2876] = {.lex_state = 238},
  [2877] = {.lex_state = 242},
  [2878] = {.lex_state = 204},
  [2879] = {.lex_state = 210},
  [2880] = {.lex_state = 238},
  [2881] = {.lex_state = 209},
  [2882] = {.lex_state = 238},
  [2883] = {.lex_state = 204},
  [2884] = {.lex_state = 197},
  [2885] = {.lex_state = 238},
  [2886] = {.lex_state = 201},
  [2887] = {.lex_state = 204},
  [2888] = {.lex_state = 204},
  [2889] = {.lex_state = 210},
  [2890] = {.lex_state = 242},
  [2891] = {.lex_state = 209},
  [2892] = {.lex_state = 210},
  [2893] = {.lex_state = 197},
  [2894] = {.lex_state = 238},
  [2895] = {.lex_state = 238},
  [2896] = {.lex_state = 217},
  [2897] = {.lex_state = 204},
  [2898] = {.lex_state = 204},
  [2899] = {.lex_state = 204},
  [2900] = {.lex_state = 204},
  [2901] = {.lex_state = 196},
  [2902] = {.lex_state = 242},
  [2903] = {.lex_state = 197},
  [2904] = {.lex_state = 204},
  [2905] = {.lex_state = 217},
  [2906] = {.lex_state = 209},
  [2907] = {.lex_state = 204},
  [2908] = {.lex_state = 197},
  [2909] = {.lex_state = 197},
  [2910] = {.lex_state = 209},
  [2911] = {.lex_state = 197},
  [2912] = {.lex_state = 209},
  [2913] = {.lex_state = 197},
  [2914] = {.lex_state = 197},
  [2915] = {.lex_state = 197},
  [2916] = {.lex_state = 210},
  [2917] = {.lex_state = 238},
  [2918] = {.lex_state = 209},
  [2919] = {.lex_state = 209},
  [2920] = {.lex_state = 204},
  [2921] = {.lex_state = 204},
  [2922] = {.lex_state = 197},
  [2923] = {.lex_state = 197},
  [2924] = {.lex_state = 209},
  [2925] = {.lex_state = 210},
  [2926] = {.lex_state = 204},
  [2927] = {.lex_state = 217},
  [2928] = {.lex_state = 209},
  [2929] = {.lex_state = 238},
  [2930] = {.lex_state = 217},
  [2931] = {.lex_state = 238},
  [2932] = {.lex_state = 204},
  [2933] = {.lex_state = 204},
  [2934] = {.lex_state = 197},
  [2935] = {.lex_state = 197},
  [2936] = {.lex_state = 238},
  [2937] = {.lex_state = 204},
  [2938] = {.lex_state = 217},
  [2939] = {.lex_state = 204},
  [2940] = {.lex_state = 204},
  [2941] = {.lex_state = 204},
  [2942] = {.lex_state = 209},
  [2943] = {.lex_state = 204},
  [2944] = {.lex_state = 204},
  [2945] = {.lex_state = 210},
  [2946] = {.lex_state = 204},
  [2947] = {.lex_state = 238},
  [2948] = {.lex_state = 204},
  [2949] = {.lex_state = 197},
  [2950] = {.lex_state = 201},
  [2951] = {.lex_state = 204},
  [2952] = {.lex_state = 228},
  [2953] = {.lex_state = 238},
  [2954] = {.lex_state = 204},
  [2955] = {.lex_state = 209},
  [2956] = {.lex_state = 242},
  [2957] = {.lex_state = 238},
  [2958] = {.lex_state = 204},
  [2959] = {.lex_state = 217},
  [2960] = {.lex_state = 204},
  [2961] = {.lex_state = 209},
  [2962] = {.lex_state = 238},
  [2963] = {.lex_state = 197},
  [2964] = {.lex_state = 197},
  [2965] = {.lex_state = 238},
  [2966] = {.lex_state = 197},
  [2967] = {.lex_state = 238},
  [2968] = {.lex_state = 197},
  [2969] = {.lex_state = 204},
  [2970] = {.lex_state = 197},
  [2971] = {.lex_state = 238},
  [2972] = {.lex_state = 209},
  [2973] = {.lex_state = 239},
  [2974] = {.lex_state = 209},
  [2975] = {.lex_state = 238},
  [2976] = {.lex_state = 209},
  [2977] = {.lex_state = 217},
  [2978] = {.lex_state = 209},
  [2979] = {.lex_state = 209},
  [2980] = {.lex_state = 194},
  [2981] = {.lex_state = 238},
  [2982] = {.lex_state = 238},
  [2983] = {.lex_state = 209},
  [2984] = {.lex_state = 209},
  [2985] = {.lex_state = 204},
  [2986] = {.lex_state = 209},
  [2987] = {.lex_state = 209},
  [2988] = {.lex_state = 242},
  [2989] = {.lex_state = 209},
  [2990] = {.lex_state = 209},
  [2991] = {.lex_state = 194},
  [2992] = {.lex_state = 209},
  [2993] = {.lex_state = 209},
  [2994] = {.lex_state = 194},
  [2995] = {.lex_state = 217},
  [2996] = {.lex_state = 209},
  [2997] = {.lex_state = 209},
  [2998] = {.lex_state = 238},
  [2999] = {.lex_state = 238},
  [3000] = {.lex_state = 209},
  [3001] = {.lex_state = 209},
  [3002] = {.lex_state = 209},
  [3003] = {.lex_state = 209},
  [3004] = {.lex_state = 194},
  [3005] = {.lex_state = 239},
  [3006] = {.lex_state = 197},
  [3007] = {.lex_state = 238},
  [3008] = {.lex_state = 209},
  [3009] = {.lex_state = 239},
  [3010] = {.lex_state = 238},
  [3011] = {.lex_state = 170},
  [3012] = {.lex_state = 209},
  [3013] = {.lex_state = 197},
  [3014] = {.lex_state = 209},
  [3015] = {.lex_state = 238},
  [3016] = {.lex_state = 209},
  [3017] = {.lex_state = 209},
  [3018] = {.lex_state = 197},
  [3019] = {.lex_state = 209},
  [3020] = {.lex_state = 209},
  [3021] = {.lex_state = 197},
  [3022] = {.lex_state = 209},
  [3023] = {.lex_state = 197},
  [3024] = {.lex_state = 197},
  [3025] = {.lex_state = 209},
  [3026] = {.lex_state = 197},
  [3027] = {.lex_state = 209},
  [3028] = {.lex_state = 209},
  [3029] = {.lex_state = 197},
  [3030] = {.lex_state = 197},
  [3031] = {.lex_state = 238},
  [3032] = {.lex_state = 209},
  [3033] = {.lex_state = 194},
  [3034] = {.lex_state = 197},
  [3035] = {.lex_state = 209},
  [3036] = {.lex_state = 197},
  [3037] = {.lex_state = 197},
  [3038] = {.lex_state = 197},
  [3039] = {.lex_state = 197},
  [3040] = {.lex_state = 197},
  [3041] = {.lex_state = 197},
  [3042] = {.lex_state = 170},
  [3043] = {.lex_state = 197},
  [3044] = {.lex_state = 217},
  [3045] = {.lex_state = 238},
  [3046] = {.lex_state = 209},
  [3047] = {.lex_state = 238},
  [3048] = {.lex_state = 209},
  [3049] = {.lex_state = 209},
  [3050] = {.lex_state = 209},
  [3051] = {.lex_state = 197},
  [3052] = {.lex_state = 209},
  [3053] = {.lex_state = 238},
  [3054] = {.lex_state = 209},
  [3055] = {.lex_state = 209},
  [3056] = {.lex_state = 170},
  [3057] = {.lex_state = 238},
  [3058] = {.lex_state = 238},
  [3059] = {.lex_state = 183},
  [3060] = {.lex_state = 209},
  [3061] = {.lex_state = 239},
  [3062] = {.lex_state = 194},
  [3063] = {.lex_state = 239},
  [3064] = {.lex_state = 170},
  [3065] = {.lex_state = 210},
  [3066] = {.lex_state = 239},
  [3067] = {.lex_state = 170},
  [3068] = {.lex_state = 209},
  [3069] = {.lex_state = 170},
  [3070] = {.lex_state = 220},
  [3071] = {.lex_state = 238},
  [3072] = {.lex_state = 238},
  [3073] = {.lex_state = 238},
  [3074] = {.lex_state = 238},
  [3075] = {.lex_state = 238},
  [3076] = {.lex_state = 209},
  [3077] = {.lex_state = 220},
  [3078] = {.lex_state = 239},
  [3079] = {.lex_state = 209},
  [3080] = {.lex_state = 238},
  [3081] = {.lex_state = 239},
  [3082] = {.lex_state = 239},
  [3083] = {.lex_state = 220},
  [3084] = {.lex_state = 238},
  [3085] = {.lex_state = 238},
  [3086] = {.lex_state = 210},
  [3087] = {.lex_state = 238},
  [3088] = {.lex_state = 238},
  [3089] = {.lex_state = 239},
  [3090] = {.lex_state = 209},
  [3091] = {.lex_state = 209},
  [3092] = {.lex_state = 239},
  [3093] = {.lex_state = 239},
  [3094] = {.lex_state = 210},
  [3095] = {.lex_state = 239},
  [3096] = {.lex_state = 176},
  [3097] = {.lex_state = 209},
  [3098] = {.lex_state = 239},
  [3099] = {.lex_state = 239},
  [3100] = {.lex_state = 220},
  [3101] = {.lex_state = 239},
  [3102] = {.lex_state = 220},
  [3103] = {.lex_state = 238},
  [3104] = {.lex_state = 209},
  [3105] = {.lex_state = 239},
  [3106] = {.lex_state = 209},
  [3107] = {.lex_state = 209},
  [3108] = {.lex_state = 209},
  [3109] = {.lex_state = 238},
  [3110] = {.lex_state = 209},
  [3111] = {.lex_state = 217},
  [3112] = {.lex_state = 209},
  [3113] = {.lex_state = 217},
  [3114] = {.lex_state = 217},
  [3115] = {.lex_state = 217},
  [3116] = {.lex_state = 197},
  [3117] = {.lex_state = 217},
  [3118] = {.lex_state = 217},
  [3119] = {.lex_state = 238},
  [3120] = {.lex_state = 239},
  [3121] = {.lex_state = 217},
  [3122] = {.lex_state = 196},
  [3123] = {.lex_state = 217},
  [3124] = {.lex_state = 217},
  [3125] = {.lex_state = 209},
  [3126] = {.lex_state = 209},
  [3127] = {.lex_state = 206},
  [3128] = {.lex_state = 183},
  [3129] = {.lex_state = 209},
  [3130] = {.lex_state = 196},
  [3131] = {.lex_state = 209},
  [3132] = {.lex_state = 239},
  [3133] = {.lex_state = 212},
  [3134] = {.lex_state = 209},
  [3135] = {.lex_state = 220},
  [3136] = {.lex_state = 209},
  [3137] = {.lex_state = 183},
  [3138] = {.lex_state = 209},
  [3139] = {.lex_state = 209},
  [3140] = {.lex_state = 209},
  [3141] = {.lex_state = 217},
  [3142] = {.lex_state = 217},
  [3143] = {.lex_state = 217},
  [3144] = {.lex_state = 217},
  [3145] = {.lex_state = 209},
  [3146] = {.lex_state = 217},
  [3147] = {.lex_state = 209},
  [3148] = {.lex_state = 217},
  [3149] = {.lex_state = 217},
  [3150] = {.lex_state = 238},
  [3151] = {.lex_state = 183},
  [3152] = {.lex_state = 220},
  [3153] = {.lex_state = 210},
  [3154] = {.lex_state = 217},
  [3155] = {.lex_state = 209},
  [3156] = {.lex_state = 209},
  [3157] = {.lex_state = 217},
  [3158] = {.lex_state = 209},
  [3159] = {.lex_state = 209},
  [3160] = {.lex_state = 209},
  [3161] = {.lex_state = 217},
  [3162] = {.lex_state = 209},
  [3163] = {.lex_state = 209},
  [3164] = {.lex_state = 209},
  [3165] = {.lex_state = 209},
  [3166] = {.lex_state = 209},
  [3167] = {.lex_state = 209},
  [3168] = {.lex_state = 210},
  [3169] = {.lex_state = 217},
  [3170] = {.lex_state = 238},
  [3171] = {.lex_state = 209},
  [3172] = {.lex_state = 217},
  [3173] = {.lex_state = 209},
  [3174] = {.lex_state = 209},
  [3175] = {.lex_state = 217},
  [3176] = {.lex_state = 217},
  [3177] = {.lex_state = 238},
  [3178] = {.lex_state = 217},
  [3179] = {.lex_state = 238},
  [3180] = {.lex_state = 217},
  [3181] = {.lex_state = 201},
  [3182] = {.lex_state = 217},
  [3183] = {.lex_state = 209},
  [3184] = {.lex_state = 209},
  [3185] = {.lex_state = 217},
  [3186] = {.lex_state = 209},
  [3187] = {.lex_state = 183},
  [3188] = {.lex_state = 217},
  [3189] = {.lex_state = 238},
  [3190] = {.lex_state = 217},
  [3191] = {.lex_state = 217},
  [3192] = {.lex_state = 217},
  [3193] = {.lex_state = 204},
  [3194] = {.lex_state = 217},
  [3195] = {.lex_state = 209},
  [3196] = {.lex_state = 217},
  [3197] = {.lex_state = 209},
  [3198] = {.lex_state = 217},
  [3199] = {.lex_state = 217},
  [3200] = {.lex_state = 217},
  [3201] = {.lex_state = 209},
  [3202] = {.lex_state = 217},
  [3203] = {.lex_state = 239},
  [3204] = {.lex_state = 209},
  [3205] = {.lex_state = 219},
  [3206] = {.lex_state = 217},
  [3207] = {.lex_state = 201},
  [3208] = {.lex_state = 209},
  [3209] = {.lex_state = 200},
  [3210] = {.lex_state = 206},
  [3211] = {.lex_state = 206},
  [3212] = {.lex_state = 209},
  [3213] = {.lex_state = 214},
  [3214] = {.lex_state = 206},
  [3215] = {.lex_state = 209},
  [3216] = {.lex_state = 238},
  [3217] = {.lex_state = 206},
  [3218] = {.lex_state = 197},
  [3219] = {.lex_state = 206},
  [3220] = {.lex_state = 209},
  [3221] = {.lex_state = 217},
  [3222] = {.lex_state = 206},
  [3223] = {.lex_state = 194},
  [3224] = {.lex_state = 217},
  [3225] = {.lex_state = 210},
  [3226] = {.lex_state = 209},
  [3227] = {.lex_state = 196},
  [3228] = {.lex_state = 210},
  [3229] = {.lex_state = 210},
  [3230] = {.lex_state = 209},
  [3231] = {.lex_state = 210},
  [3232] = {.lex_state = 210},
  [3233] = {.lex_state = 210},
  [3234] = {.lex_state = 210},
  [3235] = {.lex_state = 214},
  [3236] = {.lex_state = 209},
  [3237] = {.lex_state = 204},
  [3238] = {.lex_state = 210},
  [3239] = {.lex_state = 209},
  [3240] = {.lex_state = 206},
  [3241] = {.lex_state = 196},
  [3242] = {.lex_state = 197},
  [3243] = {.lex_state = 196},
  [3244] = {.lex_state = 209},
  [3245] = {.lex_state = 210},
  [3246] = {.lex_state = 206},
  [3247] = {.lex_state = 206},
  [3248] = {.lex_state = 210},
  [3249] = {.lex_state = 217},
  [3250] = {.lex_state = 210},
  [3251] = {.lex_state = 217},
  [3252] = {.lex_state = 196},
  [3253] = {.lex_state = 197},
  [3254] = {.lex_state = 210},
  [3255] = {.lex_state = 210},
  [3256] = {.lex_state = 210},
  [3257] = {.lex_state = 197},
  [3258] = {.lex_state = 206},
  [3259] = {.lex_state = 206},
  [3260] = {.lex_state = 217},
  [3261] = {.lex_state = 216},
  [3262] = {.lex_state = 210},
  [3263] = {.lex_state = 217},
  [3264] = {.lex_state = 210},
  [3265] = {.lex_state = 206},
  [3266] = {.lex_state = 209},
  [3267] = {.lex_state = 210},
  [3268] = {.lex_state = 206},
  [3269] = {.lex_state = 239},
  [3270] = {.lex_state = 238},
  [3271] = {.lex_state = 209},
  [3272] = {.lex_state = 209},
  [3273] = {.lex_state = 238},
  [3274] = {.lex_state = 238},
  [3275] = {.lex_state = 206},
  [3276] = {.lex_state = 210},
  [3277] = {.lex_state = 206},
  [3278] = {.lex_state = 210},
  [3279] = {.lex_state = 217},
  [3280] = {.lex_state = 217},
  [3281] = {.lex_state = 196},
  [3282] = {.lex_state = 194},
  [3283] = {.lex_state = 243},
  [3284] = {.lex_state = 210},
  [3285] = {.lex_state = 210},
  [3286] = {.lex_state = 210},
  [3287] = {.lex_state = 217},
  [3288] = {.lex_state = 210},
  [3289] = {.lex_state = 217},
  [3290] = {.lex_state = 209},
  [3291] = {.lex_state = 239},
  [3292] = {.lex_state = 210},
  [3293] = {.lex_state = 210},
  [3294] = {.lex_state = 210},
  [3295] = {.lex_state = 238},
  [3296] = {.lex_state = 217},
  [3297] = {.lex_state = 217},
  [3298] = {.lex_state = 209},
  [3299] = {.lex_state = 194},
  [3300] = {.lex_state = 206},
  [3301] = {.lex_state = 238},
  [3302] = {.lex_state = 206},
  [3303] = {.lex_state = 238},
  [3304] = {.lex_state = 200},
  [3305] = {.lex_state = 200},
  [3306] = {.lex_state = 200},
  [3307] = {.lex_state = 200},
  [3308] = {.lex_state = 200},
  [3309] = {.lex_state = 200},
  [3310] = {.lex_state = 200},
  [3311] = {.lex_state = 200},
  [3312] = {.lex_state = 200},
  [3313] = {.lex_state = 200},
  [3314] = {.lex_state = 200},
  [3315] = {.lex_state = 200},
  [3316] = {.lex_state = 200},
  [3317] = {.lex_state = 200},
  [3318] = {.lex_state = 200},
  [3319] = {.lex_state = 200},
  [3320] = {.lex_state = 200},
  [3321] = {.lex_state = 209},
  [3322] = {.lex_state = 200},
  [3323] = {.lex_state = 200},
  [3324] = {.lex_state = 200},
  [3325] = {.lex_state = 200},
  [3326] = {.lex_state = 200},
  [3327] = {.lex_state = 200},
  [3328] = {.lex_state = 204},
  [3329] = {.lex_state = 209},
  [3330] = {.lex_state = 217},
  [3331] = {.lex_state = 217},
  [3332] = {.lex_state = 217},
  [3333] = {.lex_state = 200},
  [3334] = {.lex_state = 217},
  [3335] = {.lex_state = 217},
  [3336] = {.lex_state = 210},
  [3337] = {.lex_state = 217},
  [3338] = {.lex_state = 210},
  [3339] = {.lex_state = 217},
  [3340] = {.lex_state = 239},
  [3341] = {.lex_state = 217},
  [3342] = {.lex_state = 217},
  [3343] = {.lex_state = 209},
  [3344] = {.lex_state = 196},
  [3345] = {.lex_state = 209},
  [3346] = {.lex_state = 217},
  [3347] = {.lex_state = 217},
  [3348] = {.lex_state = 217},
  [3349] = {.lex_state = 217},
  [3350] = {.lex_state = 217},
  [3351] = {.lex_state = 217},
  [3352] = {.lex_state = 217},
  [3353] = {.lex_state = 217},
  [3354] = {.lex_state = 220},
  [3355] = {.lex_state = 209},
  [3356] = {.lex_state = 209},
  [3357] = {.lex_state = 209},
  [3358] = {.lex_state = 209},
  [3359] = {.lex_state = 209},
  [3360] = {.lex_state = 222},
  [3361] = {.lex_state = 204},
  [3362] = {.lex_state = 204},
  [3363] = {.lex_state = 204},
  [3364] = {.lex_state = 209},
  [3365] = {.lex_state = 209},
  [3366] = {.lex_state = 224},
  [3367] = {.lex_state = 209},
  [3368] = {.lex_state = 204},
  [3369] = {.lex_state = 204},
  [3370] = {.lex_state = 242},
  [3371] = {.lex_state = 242},
  [3372] = {.lex_state = 242},
  [3373] = {.lex_state = 209},
  [3374] = {.lex_state = 204},
  [3375] = {.lex_state = 204},
  [3376] = {.lex_state = 209},
  [3377] = {.lex_state = 204},
  [3378] = {.lex_state = 204},
  [3379] = {.lex_state = 204},
  [3380] = {.lex_state = 209},
  [3381] = {.lex_state = 209},
  [3382] = {.lex_state = 209},
  [3383] = {.lex_state = 209},
  [3384] = {.lex_state = 209},
  [3385] = {.lex_state = 204},
  [3386] = {.lex_state = 209},
  [3387] = {.lex_state = 209},
  [3388] = {.lex_state = 217},
  [3389] = {.lex_state = 204},
  [3390] = {.lex_state = 209},
  [3391] = {.lex_state = 209},
  [3392] = {.lex_state = 220},
  [3393] = {.lex_state = 220},
  [3394] = {.lex_state = 220},
  [3395] = {.lex_state = 204},
  [3396] = {.lex_state = 209},
  [3397] = {.lex_state = 209},
  [3398] = {.lex_state = 238},
  [3399] = {.lex_state = 217},
  [3400] = {.lex_state = 209},
  [3401] = {.lex_state = 209},
  [3402] = {.lex_state = 197},
  [3403] = {.lex_state = 209},
  [3404] = {.lex_state = 209},
  [3405] = {.lex_state = 194},
  [3406] = {.lex_state = 209},
  [3407] = {.lex_state = 220},
  [3408] = {.lex_state = 222},
  [3409] = {.lex_state = 209},
  [3410] = {.lex_state = 209},
  [3411] = {.lex_state = 209},
  [3412] = {.lex_state = 209},
  [3413] = {.lex_state = 183},
  [3414] = {.lex_state = 220},
  [3415] = {.lex_state = 209},
  [3416] = {.lex_state = 183},
  [3417] = {.lex_state = 209},
  [3418] = {.lex_state = 209},
  [3419] = {.lex_state = 209},
  [3420] = {.lex_state = 209},
  [3421] = {.lex_state = 209},
  [3422] = {.lex_state = 220},
  [3423] = {.lex_state = 209},
  [3424] = {.lex_state = 209},
  [3425] = {.lex_state = 209},
  [3426] = {.lex_state = 209},
  [3427] = {.lex_state = 209},
  [3428] = {.lex_state = 209},
  [3429] = {.lex_state = 220},
  [3430] = {.lex_state = 209},
  [3431] = {.lex_state = 209},
  [3432] = {.lex_state = 209},
  [3433] = {.lex_state = 209},
  [3434] = {.lex_state = 209},
  [3435] = {.lex_state = 238},
  [3436] = {.lex_state = 209},
  [3437] = {.lex_state = 209},
  [3438] = {.lex_state = 209},
  [3439] = {.lex_state = 209},
  [3440] = {.lex_state = 209},
  [3441] = {.lex_state = 209},
  [3442] = {.lex_state = 209},
  [3443] = {.lex_state = 209},
  [3444] = {.lex_state = 209},
  [3445] = {.lex_state = 209},
  [3446] = {.lex_state = 209},
  [3447] = {.lex_state = 209},
  [3448] = {.lex_state = 183},
  [3449] = {.lex_state = 220},
  [3450] = {.lex_state = 209},
  [3451] = {.lex_state = 209},
  [3452] = {.lex_state = 209},
  [3453] = {.lex_state = 209},
  [3454] = {.lex_state = 209},
  [3455] = {.lex_state = 204},
  [3456] = {.lex_state = 204},
  [3457] = {.lex_state = 220},
  [3458] = {.lex_state = 209},
  [3459] = {.lex_state = 242},
  [3460] = {.lex_state = 193},
  [3461] = {.lex_state = 209},
  [3462] = {.lex_state = 220},
  [3463] = {.lex_state = 193},
  [3464] = {.lex_state = 183},
  [3465] = {.lex_state = 209},
  [3466] = {.lex_state = 209},
  [3467] = {.lex_state = 209},
  [3468] = {.lex_state = 209},
  [3469] = {.lex_state = 209},
  [3470] = {.lex_state = 209},
  [3471] = {.lex_state = 209},
  [3472] = {.lex_state = 204},
  [3473] = {.lex_state = 242},
  [3474] = {.lex_state = 183},
  [3475] = {.lex_state = 209},
  [3476] = {.lex_state = 220},
  [3477] = {.lex_state = 242},
  [3478] = {.lex_state = 209},
  [3479] = {.lex_state = 209},
  [3480] = {.lex_state = 220},
  [3481] = {.lex_state = 220},
  [3482] = {.lex_state = 220},
  [3483] = {.lex_state = 209},
  [3484] = {.lex_state = 220},
  [3485] = {.lex_state = 242},
  [3486] = {.lex_state = 238},
  [3487] = {.lex_state = 242},
  [3488] = {.lex_state = 209},
  [3489] = {.lex_state = 238},
  [3490] = {.lex_state = 238},
  [3491] = {.lex_state = 209},
  [3492] = {.lex_state = 238},
  [3493] = {.lex_state = 209},
  [3494] = {.lex_state = 217},
  [3495] = {.lex_state = 209},
  [3496] = {.lex_state = 209},
  [3497] = {.lex_state = 209},
  [3498] = {.lex_state = 209},
  [3499] = {.lex_state = 209},
  [3500] = {.lex_state = 209},
  [3501] = {.lex_state = 209},
  [3502] = {.lex_state = 209},
  [3503] = {.lex_state = 209},
  [3504] = {.lex_state = 209},
  [3505] = {.lex_state = 209},
  [3506] = {.lex_state = 209},
  [3507] = {.lex_state = 209},
  [3508] = {.lex_state = 209},
  [3509] = {.lex_state = 209},
  [3510] = {.lex_state = 209},
  [3511] = {.lex_state = 209},
  [3512] = {.lex_state = 209},
  [3513] = {.lex_state = 209},
  [3514] = {.lex_state = 209},
  [3515] = {.lex_state = 209},
  [3516] = {.lex_state = 209},
  [3517] = {.lex_state = 193},
  [3518] = {.lex_state = 209},
  [3519] = {.lex_state = 209},
  [3520] = {.lex_state = 209},
  [3521] = {.lex_state = 209},
  [3522] = {.lex_state = 209},
  [3523] = {.lex_state = 209},
  [3524] = {.lex_state = 209},
  [3525] = {.lex_state = 209},
  [3526] = {.lex_state = 209},
  [3527] = {.lex_state = 209},
  [3528] = {.lex_state = 209},
  [3529] = {.lex_state = 209},
  [3530] = {.lex_state = 209},
  [3531] = {.lex_state = 209},
  [3532] = {.lex_state = 209},
  [3533] = {.lex_state = 209},
  [3534] = {.lex_state = 209},
  [3535] = {.lex_state = 217},
  [3536] = {.lex_state = 209},
  [3537] = {.lex_state = 217},
  [3538] = {.lex_state = 217},
  [3539] = {.lex_state = 200},
  [3540] = {.lex_state = 217},
  [3541] = {.lex_state = 217},
  [3542] = {.lex_state = 200},
  [3543] = {.lex_state = 209},
  [3544] = {.lex_state = 217},
  [3545] = {.lex_state = 217},
  [3546] = {.lex_state = 217},
  [3547] = {.lex_state = 217},
  [3548] = {.lex_state = 200},
  [3549] = {.lex_state = 209},
  [3550] = {.lex_state = 209},
  [3551] = {.lex_state = 183},
  [3552] = {.lex_state = 217},
  [3553] = {.lex_state = 209},
  [3554] = {.lex_state = 209},
  [3555] = {.lex_state = 217},
  [3556] = {.lex_state = 209},
  [3557] = {.lex_state = 217},
  [3558] = {.lex_state = 217},
  [3559] = {.lex_state = 217},
  [3560] = {.lex_state = 217},
  [3561] = {.lex_state = 217},
  [3562] = {.lex_state = 209},
  [3563] = {.lex_state = 209},
  [3564] = {.lex_state = 217},
  [3565] = {.lex_state = 217},
  [3566] = {.lex_state = 209},
  [3567] = {.lex_state = 217},
  [3568] = {.lex_state = 200},
  [3569] = {.lex_state = 217},
  [3570] = {.lex_state = 209},
  [3571] = {.lex_state = 217},
  [3572] = {.lex_state = 209},
  [3573] = {.lex_state = 217},
  [3574] = {.lex_state = 238},
  [3575] = {.lex_state = 217},
  [3576] = {.lex_state = 206},
  [3577] = {.lex_state = 183},
  [3578] = {.lex_state = 209},
  [3579] = {.lex_state = 217},
  [3580] = {.lex_state = 217},
  [3581] = {.lex_state = 217},
  [3582] = {.lex_state = 209},
  [3583] = {.lex_state = 217},
  [3584] = {.lex_state = 209},
  [3585] = {.lex_state = 217},
  [3586] = {.lex_state = 217},
  [3587] = {.lex_state = 217},
  [3588] = {.lex_state = 204},
  [3589] = {.lex_state = 217},
  [3590] = {.lex_state = 217},
  [3591] = {.lex_state = 209},
  [3592] = {.lex_state = 206},
  [3593] = {.lex_state = 217},
  [3594] = {.lex_state = 217},
  [3595] = {.lex_state = 209},
  [3596] = {.lex_state = 217},
  [3597] = {.lex_state = 217},
  [3598] = {.lex_state = 217},
  [3599] = {.lex_state = 217},
  [3600] = {.lex_state = 204},
  [3601] = {.lex_state = 204},
  [3602] = {.lex_state = 217},
  [3603] = {.lex_state = 217},
  [3604] = {.lex_state = 217},
  [3605] = {.lex_state = 217},
  [3606] = {.lex_state = 209},
  [3607] = {.lex_state = 206},
  [3608] = {.lex_state = 238},
  [3609] = {.lex_state = 217},
  [3610] = {.lex_state = 238},
  [3611] = {.lex_state = 217},
  [3612] = {.lex_state = 217},
  [3613] = {.lex_state = 238},
  [3614] = {.lex_state = 238},
  [3615] = {.lex_state = 238},
  [3616] = {.lex_state = 238},
  [3617] = {.lex_state = 217},
  [3618] = {.lex_state = 238},
  [3619] = {.lex_state = 238},
  [3620] = {.lex_state = 238},
  [3621] = {.lex_state = 238},
  [3622] = {.lex_state = 238},
  [3623] = {.lex_state = 204},
  [3624] = {.lex_state = 217},
  [3625] = {.lex_state = 217},
  [3626] = {.lex_state = 197},
  [3627] = {.lex_state = 217},
  [3628] = {.lex_state = 217},
  [3629] = {.lex_state = 239},
  [3630] = {.lex_state = 217},
  [3631] = {.lex_state = 217},
  [3632] = {.lex_state = 209},
  [3633] = {.lex_state = 217},
  [3634] = {.lex_state = 217},
  [3635] = {.lex_state = 217},
  [3636] = {.lex_state = 217},
  [3637] = {.lex_state = 217},
  [3638] = {.lex_state = 197},
  [3639] = {.lex_state = 209},
  [3640] = {.lex_state = 217},
  [3641] = {.lex_state = 217},
  [3642] = {.lex_state = 217},
  [3643] = {.lex_state = 217},
  [3644] = {.lex_state = 197},
  [3645] = {.lex_state = 200},
  [3646] = {.lex_state = 209},
  [3647] = {.lex_state = 209},
  [3648] = {.lex_state = 217},
  [3649] = {.lex_state = 217},
  [3650] = {.lex_state = 217},
  [3651] = {.lex_state = 217},
  [3652] = {.lex_state = 217},
  [3653] = {.lex_state = 217},
  [3654] = {.lex_state = 204},
  [3655] = {.lex_state = 204},
  [3656] = {.lex_state = 217},
  [3657] = {.lex_state = 204},
  [3658] = {.lex_state = 200},
  [3659] = {.lex_state = 217},
  [3660] = {.lex_state = 217},
  [3661] = {.lex_state = 200},
  [3662] = {.lex_state = 209},
  [3663] = {.lex_state = 209},
  [3664] = {.lex_state = 209},
  [3665] = {.lex_state = 217},
  [3666] = {.lex_state = 204},
  [3667] = {.lex_state = 217},
  [3668] = {.lex_state = 209},
  [3669] = {.lex_state = 217},
  [3670] = {.lex_state = 217},
  [3671] = {.lex_state = 209},
  [3672] = {.lex_state = 204},
  [3673] = {.lex_state = 204},
  [3674] = {.lex_state = 217},
  [3675] = {.lex_state = 197},
  [3676] = {.lex_state = 204},
  [3677] = {.lex_state = 183},
  [3678] = {.lex_state = 197},
  [3679] = {.lex_state = 217},
  [3680] = {.lex_state = 217},
  [3681] = {.lex_state = 204},
  [3682] = {.lex_state = 183},
  [3683] = {.lex_state = 217},
  [3684] = {.lex_state = 217},
  [3685] = {.lex_state = 217},
  [3686] = {.lex_state = 217},
  [3687] = {.lex_state = 217},
  [3688] = {.lex_state = 217},
  [3689] = {.lex_state = 217},
  [3690] = {.lex_state = 200},
  [3691] = {.lex_state = 196},
  [3692] = {.lex_state = 238},
  [3693] = {.lex_state = 197},
  [3694] = {.lex_state = 239},
  [3695] = {.lex_state = 194},
  [3696] = {.lex_state = 239},
  [3697] = {.lex_state = 239},
  [3698] = {.lex_state = 209},
  [3699] = {.lex_state = 239},
  [3700] = {.lex_state = 239},
  [3701] = {.lex_state = 239},
  [3702] = {.lex_state = 239},
  [3703] = {.lex_state = 239},
  [3704] = {.lex_state = 238},
  [3705] = {.lex_state = 239},
  [3706] = {.lex_state = 194},
  [3707] = {.lex_state = 238},
  [3708] = {.lex_state = 204},
  [3709] = {.lex_state = 183},
  [3710] = {.lex_state = 239},
  [3711] = {.lex_state = 239},
  [3712] = {.lex_state = 206},
  [3713] = {.lex_state = 239},
  [3714] = {.lex_state = 214},
  [3715] = {.lex_state = 239},
  [3716] = {.lex_state = 239},
  [3717] = {.lex_state = 239},
  [3718] = {.lex_state = 239},
  [3719] = {.lex_state = 206},
  [3720] = {.lex_state = 239},
  [3721] = {.lex_state = 239},
  [3722] = {.lex_state = 239},
  [3723] = {.lex_state = 239},
  [3724] = {.lex_state = 239},
  [3725] = {.lex_state = 239},
  [3726] = {.lex_state = 239},
  [3727] = {.lex_state = 243},
  [3728] = {.lex_state = 239},
  [3729] = {.lex_state = 239},
  [3730] = {.lex_state = 239},
  [3731] = {.lex_state = 239},
  [3732] = {.lex_state = 239},
  [3733] = {.lex_state = 239},
  [3734] = {.lex_state = 239},
  [3735] = {.lex_state = 239},
  [3736] = {.lex_state = 239},
  [3737] = {.lex_state = 204},
  [3738] = {.lex_state = 239},
  [3739] = {.lex_state = 239},
  [3740] = {.lex_state = 239},
  [3741] = {.lex_state = 239},
  [3742] = {.lex_state = 206},
  [3743] = {.lex_state = 239},
  [3744] = {.lex_state = 239},
  [3745] = {.lex_state = 239},
  [3746] = {.lex_state = 239},
  [3747] = {.lex_state = 239},
  [3748] = {.lex_state = 243},
  [3749] = {.lex_state = 183},
  [3750] = {.lex_state = 204},
  [3751] = {.lex_state = 206},
  [3752] = {.lex_state = 239},
  [3753] = {.lex_state = 239},
  [3754] = {.lex_state = 239},
  [3755] = {.lex_state = 204},
  [3756] = {.lex_state = 239},
  [3757] = {.lex_state = 239},
  [3758] = {.lex_state = 206},
  [3759] = {.lex_state = 193},
  [3760] = {.lex_state = 204},
  [3761] = {.lex_state = 243},
  [3762] = {.lex_state = 239},
  [3763] = {.lex_state = 239},
  [3764] = {.lex_state = 214},
  [3765] = {.lex_state = 239},
  [3766] = {.lex_state = 204},
  [3767] = {.lex_state = 239},
  [3768] = {.lex_state = 239},
  [3769] = {.lex_state = 239},
  [3770] = {.lex_state = 204},
  [3771] = {.lex_state = 206},
  [3772] = {.lex_state = 183},
  [3773] = {.lex_state = 239},
  [3774] = {.lex_state = 239},
  [3775] = {.lex_state = 239},
  [3776] = {.lex_state = 239},
  [3777] = {.lex_state = 239},
  [3778] = {.lex_state = 239},
  [3779] = {.lex_state = 239},
  [3780] = {.lex_state = 239},
  [3781] = {.lex_state = 239},
  [3782] = {.lex_state = 204},
  [3783] = {.lex_state = 239},
  [3784] = {.lex_state = 239},
  [3785] = {.lex_state = 239},
  [3786] = {.lex_state = 239},
  [3787] = {.lex_state = 239},
  [3788] = {.lex_state = 239},
  [3789] = {.lex_state = 239},
  [3790] = {.lex_state = 239},
  [3791] = {.lex_state = 183},
  [3792] = {.lex_state = 239},
  [3793] = {.lex_state = 239},
  [3794] = {.lex_state = 239},
  [3795] = {.lex_state = 239},
  [3796] = {.lex_state = 239},
  [3797] = {.lex_state = 204},
  [3798] = {.lex_state = 194},
  [3799] = {.lex_state = 239},
  [3800] = {.lex_state = 209},
  [3801] = {.lex_state = 209},
  [3802] = {.lex_state = 206},
  [3803] = {.lex_state = 209},
  [3804] = {.lex_state = 209},
  [3805] = {.lex_state = 206},
  [3806] = {.lex_state = 206},
  [3807] = {.lex_state = 238},
  [3808] = {.lex_state = 209},
  [3809] = {.lex_state = 209},
  [3810] = {.lex_state = 209},
  [3811] = {.lex_state = 209},
  [3812] = {.lex_state = 209},
  [3813] = {.lex_state = 209},
  [3814] = {.lex_state = 209},
  [3815] = {.lex_state = 209},
  [3816] = {.lex_state = 209},
  [3817] = {.lex_state = 238},
  [3818] = {.lex_state = 228},
  [3819] = {.lex_state = 239},
  [3820] = {.lex_state = 241},
  [3821] = {.lex_state = 206},
  [3822] = {.lex_state = 204},
  [3823] = {.lex_state = 204},
  [3824] = {.lex_state = 204},
  [3825] = {.lex_state = 242},
  [3826] = {.lex_state = 204},
  [3827] = {.lex_state = 206},
  [3828] = {.lex_state = 206},
  [3829] = {.lex_state = 209},
  [3830] = {.lex_state = 206},
  [3831] = {.lex_state = 209},
  [3832] = {.lex_state = 209},
  [3833] = {.lex_state = 206},
  [3834] = {.lex_state = 206},
  [3835] = {.lex_state = 239},
  [3836] = {.lex_state = 209},
  [3837] = {.lex_state = 209},
  [3838] = {.lex_state = 209},
  [3839] = {.lex_state = 209},
  [3840] = {.lex_state = 206},
  [3841] = {.lex_state = 209},
  [3842] = {.lex_state = 239},
  [3843] = {.lex_state = 206},
  [3844] = {.lex_state = 206},
  [3845] = {.lex_state = 206},
  [3846] = {.lex_state = 209},
  [3847] = {.lex_state = 209},
  [3848] = {.lex_state = 239},
  [3849] = {.lex_state = 209},
  [3850] = {.lex_state = 239},
  [3851] = {.lex_state = 209},
  [3852] = {.lex_state = 209},
  [3853] = {.lex_state = 206},
  [3854] = {.lex_state = 206},
  [3855] = {.lex_state = 209},
  [3856] = {.lex_state = 239},
  [3857] = {.lex_state = 193},
  [3858] = {.lex_state = 193},
  [3859] = {.lex_state = 206},
  [3860] = {.lex_state = 209},
  [3861] = {.lex_state = 206},
  [3862] = {.lex_state = 209},
  [3863] = {.lex_state = 209},
  [3864] = {.lex_state = 209},
  [3865] = {.lex_state = 206},
  [3866] = {.lex_state = 206},
  [3867] = {.lex_state = 206},
  [3868] = {.lex_state = 209},
  [3869] = {.lex_state = 239},
  [3870] = {.lex_state = 206},
  [3871] = {.lex_state = 193},
  [3872] = {.lex_state = 242},
  [3873] = {.lex_state = 209},
  [3874] = {.lex_state = 193},
  [3875] = {.lex_state = 209},
  [3876] = {.lex_state = 239},
  [3877] = {.lex_state = 206},
  [3878] = {.lex_state = 206},
  [3879] = {.lex_state = 239},
  [3880] = {.lex_state = 209},
  [3881] = {.lex_state = 239},
  [3882] = {.lex_state = 239},
  [3883] = {.lex_state = 241},
  [3884] = {.lex_state = 241},
  [3885] = {.lex_state = 209},
  [3886] = {.lex_state = 239},
  [3887] = {.lex_state = 206},
  [3888] = {.lex_state = 209},
  [3889] = {.lex_state = 206},
  [3890] = {.lex_state = 239},
  [3891] = {.lex_state = 239},
  [3892] = {.lex_state = 206},
  [3893] = {.lex_state = 206},
  [3894] = {.lex_state = 239},
  [3895] = {.lex_state = 209},
  [3896] = {.lex_state = 206},
  [3897] = {.lex_state = 209},
  [3898] = {.lex_state = 206},
  [3899] = {.lex_state = 209},
  [3900] = {.lex_state = 206},
  [3901] = {.lex_state = 209},
  [3902] = {.lex_state = 206},
  [3903] = {.lex_state = 209},
  [3904] = {.lex_state = 239},
  [3905] = {.lex_state = 204},
  [3906] = {.lex_state = 209},
  [3907] = {.lex_state = 209},
  [3908] = {.lex_state = 209},
  [3909] = {.lex_state = 204},
  [3910] = {.lex_state = 239},
  [3911] = {.lex_state = 239},
  [3912] = {.lex_state = 209},
  [3913] = {.lex_state = 209},
  [3914] = {.lex_state = 209},
  [3915] = {.lex_state = 209},
  [3916] = {.lex_state = 209},
  [3917] = {.lex_state = 209},
  [3918] = {.lex_state = 209},
  [3919] = {.lex_state = 209},
  [3920] = {.lex_state = 209},
  [3921] = {.lex_state = 209},
  [3922] = {.lex_state = 209},
  [3923] = {.lex_state = 206},
  [3924] = {.lex_state = 239},
  [3925] = {.lex_state = 242},
  [3926] = {.lex_state = 204},
  [3927] = {.lex_state = 204},
  [3928] = {.lex_state = 204},
  [3929] = {.lex_state = 193},
  [3930] = {.lex_state = 204},
  [3931] = {.lex_state = 243},
  [3932] = {.lex_state = 204},
  [3933] = {.lex_state = 193},
  [3934] = {.lex_state = 204},
  [3935] = {.lex_state = 204},
  [3936] = {.lex_state = 204},
  [3937] = {.lex_state = 243},
  [3938] = {.lex_state = 204},
  [3939] = {.lex_state = 242},
  [3940] = {.lex_state = 204},
  [3941] = {.lex_state = 204},
  [3942] = {.lex_state = 204},
  [3943] = {.lex_state = 204},
  [3944] = {.lex_state = 204},
  [3945] = {.lex_state = 204},
  [3946] = {.lex_state = 204},
  [3947] = {.lex_state = 242},
  [3948] = {.lex_state = 204},
  [3949] = {.lex_state = 204},
  [3950] = {.lex_state = 204},
  [3951] = {.lex_state = 204},
  [3952] = {.lex_state = 204},
  [3953] = {.lex_state = 193},
  [3954] = {.lex_state = 204},
  [3955] = {.lex_state = 204},
  [3956] = {.lex_state = 204},
  [3957] = {.lex_state = 194},
  [3958] = {.lex_state = 204},
  [3959] = {.lex_state = 204},
  [3960] = {.lex_state = 204},
  [3961] = {.lex_state = 204},
  [3962] = {.lex_state = 238},
  [3963] = {.lex_state = 204},
  [3964] = {.lex_state = 204},
  [3965] = {.lex_state = 193},
  [3966] = {.lex_state = 241},
  [3967] = {.lex_state = 194},
  [3968] = {.lex_state = 204},
  [3969] = {.lex_state = 204},
  [3970] = {.lex_state = 204},
  [3971] = {.lex_state = 204},
  [3972] = {.lex_state = 241},
  [3973] = {.lex_state = 204},
  [3974] = {.lex_state = 204},
  [3975] = {.lex_state = 204},
  [3976] = {.lex_state = 206},
  [3977] = {.lex_state = 242},
  [3978] = {.lex_state = 243},
  [3979] = {.lex_state = 204},
  [3980] = {.lex_state = 228},
  [3981] = {.lex_state = 204},
  [3982] = {.lex_state = 238},
  [3983] = {.lex_state = 238},
  [3984] = {.lex_state = 242},
  [3985] = {.lex_state = 204},
  [3986] = {.lex_state = 228},
  [3987] = {.lex_state = 204},
  [3988] = {.lex_state = 242},
  [3989] = {.lex_state = 204},
  [3990] = {.lex_state = 241},
  [3991] = {.lex_state = 238},
  [3992] = {.lex_state = 243},
  [3993] = {.lex_state = 206},
  [3994] = {.lex_state = 204},
  [3995] = {.lex_state = 241},
  [3996] = {.lex_state = 204},
  [3997] = {.lex_state = 241},
  [3998] = {.lex_state = 228},
  [3999] = {.lex_state = 242},
  [4000] = {.lex_state = 241},
  [4001] = {.lex_state = 238},
  [4002] = {.lex_state = 204},
  [4003] = {.lex_state = 204},
  [4004] = {.lex_state = 206},
  [4005] = {.lex_state = 204},
  [4006] = {.lex_state = 206},
  [4007] = {.lex_state = 229},
  [4008] = {.lex_state = 239},
  [4009] = {.lex_state = 239},
  [4010] = {.lex_state = 239},
  [4011] = {.lex_state = 239},
  [4012] = {.lex_state = 239},
  [4013] = {.lex_state = 204},
  [4014] = {.lex_state = 239},
  [4015] = {.lex_state = 239},
  [4016] = {.lex_state = 239},
  [4017] = {.lex_state = 239},
  [4018] = {.lex_state = 194},
  [4019] = {.lex_state = 204},
  [4020] = {.lex_state = 239},
  [4021] = {.lex_state = 239},
  [4022] = {.lex_state = 239},
  [4023] = {.lex_state = 239},
  [4024] = {.lex_state = 204},
  [4025] = {.lex_state = 241},
  [4026] = {.lex_state = 238},
  [4027] = {.lex_state = 239},
  [4028] = {.lex_state = 241},
  [4029] = {.lex_state = 239},
  [4030] = {.lex_state = 239},
  [4031] = {.lex_state = 239},
  [4032] = {.lex_state = 238},
  [4033] = {.lex_state = 239},
  [4034] = {.lex_state = 238},
  [4035] = {.lex_state = 229},
  [4036] = {.lex_state = 239},
  [4037] = {.lex_state = 239},
  [4038] = {.lex_state = 238},
  [4039] = {.lex_state = 239},
  [4040] = {.lex_state = 241},
  [4041] = {.lex_state = 241},
  [4042] = {.lex_state = 238},
  [4043] = {.lex_state = 241},
  [4044] = {.lex_state = 239},
  [4045] = {.lex_state = 239},
  [4046] = {.lex_state = 238},
  [4047] = {.lex_state = 238},
  [4048] = {.lex_state = 194},
  [4049] = {.lex_state = 239},
  [4050] = {.lex_state = 239},
  [4051] = {.lex_state = 239},
  [4052] = {.lex_state = 239},
  [4053] = {.lex_state = 239},
  [4054] = {.lex_state = 204},
  [4055] = {.lex_state = 204},
  [4056] = {.lex_state = 204},
  [4057] = {.lex_state = 242},
  [4058] = {.lex_state = 243},
  [4059] = {.lex_state = 206},
  [4060] = {.lex_state = 242},
  [4061] = {.lex_state = 204},
  [4062] = {.lex_state = 204},
  [4063] = {.lex_state = 204},
  [4064] = {.lex_state = 204},
  [4065] = {.lex_state = 206},
  [4066] = {.lex_state = 239},
  [4067] = {.lex_state = 204},
  [4068] = {.lex_state = 239},
  [4069] = {.lex_state = 245},
  [4070] = {.lex_state = 204},
  [4071] = {.lex_state = 204},
  [4072] = {.lex_state = 242},
  [4073] = {.lex_state = 243},
  [4074] = {.lex_state = 204},
  [4075] = {.lex_state = 204},
  [4076] = {.lex_state = 239},
  [4077] = {.lex_state = 204},
  [4078] = {.lex_state = 204},
  [4079] = {.lex_state = 204},
  [4080] = {.lex_state = 204},
  [4081] = {.lex_state = 204},
  [4082] = {.lex_state = 204},
  [4083] = {.lex_state = 204},
  [4084] = {.lex_state = 245},
  [4085] = {.lex_state = 238},
  [4086] = {.lex_state = 206},
  [4087] = {.lex_state = 204},
  [4088] = {.lex_state = 238},
  [4089] = {.lex_state = 204},
  [4090] = {.lex_state = 204},
  [4091] = {.lex_state = 242},
  [4092] = {.lex_state = 204},
  [4093] = {.lex_state = 242},
  [4094] = {.lex_state = 204},
  [4095] = {.lex_state = 204},
  [4096] = {.lex_state = 204},
  [4097] = {.lex_state = 204},
  [4098] = {.lex_state = 204},
  [4099] = {.lex_state = 239},
  [4100] = {.lex_state = 204},
  [4101] = {.lex_state = 239},
  [4102] = {.lex_state = 204},
  [4103] = {.lex_state = 206},
  [4104] = {.lex_state = 204},
  [4105] = {.lex_state = 239},
  [4106] = {.lex_state = 239},
  [4107] = {.lex_state = 206},
  [4108] = {.lex_state = 204},
  [4109] = {.lex_state = 204},
  [4110] = {.lex_state = 204},
  [4111] = {.lex_state = 204},
  [4112] = {.lex_state = 204},
  [4113] = {.lex_state = 204},
  [4114] = {.lex_state = 204},
  [4115] = {.lex_state = 204},
  [4116] = {.lex_state = 204},
  [4117] = {.lex_state = 204},
  [4118] = {.lex_state = 194},
  [4119] = {.lex_state = 204},
  [4120] = {.lex_state = 204},
  [4121] = {.lex_state = 229},
  [4122] = {.lex_state = 242},
  [4123] = {.lex_state = 242},
  [4124] = {.lex_state = 242},
  [4125] = {.lex_state = 242},
  [4126] = {.lex_state = 238},
  [4127] = {.lex_state = 204},
  [4128] = {.lex_state = 245},
  [4129] = {.lex_state = 194},
  [4130] = {.lex_state = 242},
  [4131] = {.lex_state = 241},
  [4132] = {.lex_state = 194},
  [4133] = {.lex_state = 229},
  [4134] = {.lex_state = 194},
  [4135] = {.lex_state = 204},
  [4136] = {.lex_state = 229},
  [4137] = {.lex_state = 242},
  [4138] = {.lex_state = 204},
  [4139] = {.lex_state = 242},
  [4140] = {.lex_state = 242},
  [4141] = {.lex_state = 241},
  [4142] = {.lex_state = 242},
  [4143] = {.lex_state = 229},
  [4144] = {.lex_state = 194},
  [4145] = {.lex_state = 241},
  [4146] = {.lex_state = 206},
  [4147] = {.lex_state = 241},
  [4148] = {.lex_state = 204},
  [4149] = {.lex_state = 238},
  [4150] = {.lex_state = 204},
  [4151] = {.lex_state = 238},
  [4152] = {.lex_state = 238},
  [4153] = {.lex_state = 238},
  [4154] = {.lex_state = 194},
  [4155] = {.lex_state = 206},
  [4156] = {.lex_state = 241},
  [4157] = {.lex_state = 194},
  [4158] = {.lex_state = 204},
  [4159] = {.lex_state = 204},
  [4160] = {.lex_state = 206},
  [4161] = {.lex_state = 204},
  [4162] = {.lex_state = 204},
  [4163] = {.lex_state = 206},
  [4164] = {.lex_state = 242},
  [4165] = {.lex_state = 194},
  [4166] = {.lex_state = 204},
  [4167] = {.lex_state = 204},
  [4168] = {.lex_state = 204},
  [4169] = {.lex_state = 241},
  [4170] = {.lex_state = 204},
  [4171] = {.lex_state = 242},
  [4172] = {.lex_state = 204},
  [4173] = {.lex_state = 204},
  [4174] = {.lex_state = 206},
  [4175] = {.lex_state = 242},
  [4176] = {.lex_state = 194},
  [4177] = {.lex_state = 194},
  [4178] = {.lex_state = 242},
  [4179] = {.lex_state = 204},
  [4180] = {.lex_state = 242},
  [4181] = {.lex_state = 242},
  [4182] = {.lex_state = 194},
  [4183] = {.lex_state = 206},
  [4184] = {.lex_state = 238},
  [4185] = {.lex_state = 194},
  [4186] = {.lex_state = 194},
  [4187] = {.lex_state = 242},
  [4188] = {.lex_state = 238},
  [4189] = {.lex_state = 241},
  [4190] = {.lex_state = 241},
  [4191] = {.lex_state = 194},
  [4192] = {.lex_state = 242},
  [4193] = {.lex_state = 242},
  [4194] = {.lex_state = 242},
  [4195] = {.lex_state = 242},
  [4196] = {.lex_state = 242},
  [4197] = {.lex_state = 194},
  [4198] = {.lex_state = 242},
  [4199] = {.lex_state = 207},
  [4200] = {.lex_state = 241},
  [4201] = {.lex_state = 242},
  [4202] = {.lex_state = 242},
  [4203] = {.lex_state = 242},
  [4204] = {.lex_state = 194},
  [4205] = {.lex_state = 207},
  [4206] = {.lex_state = 242},
  [4207] = {.lex_state = 242},
  [4208] = {.lex_state = 242},
  [4209] = {.lex_state = 205},
  [4210] = {.lex_state = 205},
  [4211] = {.lex_state = 241},
  [4212] = {.lex_state = 204},
  [4213] = {.lex_state = 204},
  [4214] = {.lex_state = 204},
  [4215] = {.lex_state = 204},
  [4216] = {.lex_state = 204},
  [4217] = {.lex_state = 245},
  [4218] = {.lex_state = 242},
  [4219] = {.lex_state = 238},
  [4220] = {.lex_state = 229},
  [4221] = {.lex_state = 229},
  [4222] = {.lex_state = 229},
  [4223] = {.lex_state = 238},
  [4224] = {.lex_state = 238},
  [4225] = {.lex_state = 238},
  [4226] = {.lex_state = 194},
  [4227] = {.lex_state = 229},
  [4228] = {.lex_state = 229},
  [4229] = {.lex_state = 241},
  [4230] = {.lex_state = 229},
  [4231] = {.lex_state = 241},
  [4232] = {.lex_state = 229},
  [4233] = {.lex_state = 229},
  [4234] = {.lex_state = 241},
  [4235] = {.lex_state = 204},
  [4236] = {.lex_state = 229},
  [4237] = {.lex_state = 229},
  [4238] = {.lex_state = 245},
  [4239] = {.lex_state = 230},
  [4240] = {.lex_state = 229},
  [4241] = {.lex_state = 229},
  [4242] = {.lex_state = 204},
  [4243] = {.lex_state = 207},
  [4244] = {.lex_state = 229},
  [4245] = {.lex_state = 241},
  [4246] = {.lex_state = 241},
  [4247] = {.lex_state = 230},
  [4248] = {.lex_state = 229},
  [4249] = {.lex_state = 238},
  [4250] = {.lex_state = 207},
  [4251] = {.lex_state = 229},
  [4252] = {.lex_state = 229},
  [4253] = {.lex_state = 241},
  [4254] = {.lex_state = 241},
  [4255] = {.lex_state = 204},
  [4256] = {.lex_state = 229},
  [4257] = {.lex_state = 204},
  [4258] = {.lex_state = 204},
  [4259] = {.lex_state = 241},
  [4260] = {.lex_state = 204},
  [4261] = {.lex_state = 241},
  [4262] = {.lex_state = 241},
  [4263] = {.lex_state = 241},
  [4264] = {.lex_state = 241},
  [4265] = {.lex_state = 204},
  [4266] = {.lex_state = 204},
  [4267] = {.lex_state = 242},
  [4268] = {.lex_state = 204},
  [4269] = {.lex_state = 204},
  [4270] = {.lex_state = 204},
  [4271] = {.lex_state = 242},
  [4272] = {.lex_state = 204},
  [4273] = {.lex_state = 204},
  [4274] = {.lex_state = 204},
  [4275] = {.lex_state = 241},
  [4276] = {.lex_state = 241},
  [4277] = {.lex_state = 204},
  [4278] = {.lex_state = 204},
  [4279] = {.lex_state = 242},
  [4280] = {.lex_state = 241},
  [4281] = {.lex_state = 245},
  [4282] = {.lex_state = 204},
  [4283] = {.lex_state = 204},
  [4284] = {.lex_state = 204},
  [4285] = {.lex_state = 204},
  [4286] = {.lex_state = 204},
  [4287] = {.lex_state = 242},
  [4288] = {.lex_state = 204},
  [4289] = {.lex_state = 241},
  [4290] = {.lex_state = 204},
  [4291] = {.lex_state = 204},
  [4292] = {.lex_state = 206},
  [4293] = {.lex_state = 204},
  [4294] = {.lex_state = 204},
  [4295] = {.lex_state = 242},
  [4296] = {.lex_state = 242},
  [4297] = {.lex_state = 242},
  [4298] = {.lex_state = 242},
  [4299] = {.lex_state = 238},
  [4300] = {.lex_state = 242},
  [4301] = {.lex_state = 238},
  [4302] = {.lex_state = 204},
  [4303] = {.lex_state = 204},
  [4304] = {.lex_state = 206},
  [4305] = {.lex_state = 204},
  [4306] = {.lex_state = 204},
  [4307] = {.lex_state = 204},
  [4308] = {.lex_state = 241},
  [4309] = {.lex_state = 204},
  [4310] = {.lex_state = 204},
  [4311] = {.lex_state = 204},
  [4312] = {.lex_state = 204},
  [4313] = {.lex_state = 204},
  [4314] = {.lex_state = 204},
  [4315] = {.lex_state = 204},
  [4316] = {.lex_state = 245},
  [4317] = {.lex_state = 204},
  [4318] = {.lex_state = 204},
  [4319] = {.lex_state = 204},
  [4320] = {.lex_state = 204},
  [4321] = {.lex_state = 204},
  [4322] = {.lex_state = 204},
  [4323] = {.lex_state = 229},
  [4324] = {.lex_state = 229},
  [4325] = {.lex_state = 229},
  [4326] = {.lex_state = 204},
  [4327] = {.lex_state = 204},
  [4328] = {.lex_state = 229},
  [4329] = {.lex_state = 229},
  [4330] = {.lex_state = 229},
  [4331] = {.lex_state = 204},
  [4332] = {.lex_state = 229},
  [4333] = {.lex_state = 194},
  [4334] = {.lex_state = 229},
  [4335] = {.lex_state = 204},
  [4336] = {.lex_state = 229},
  [4337] = {.lex_state = 242},
  [4338] = {.lex_state = 204},
  [4339] = {.lex_state = 229},
  [4340] = {.lex_state = 204},
  [4341] = {.lex_state = 229},
  [4342] = {.lex_state = 225},
  [4343] = {.lex_state = 229},
  [4344] = {.lex_state = 229},
  [4345] = {.lex_state = 204},
  [4346] = {.lex_state = 241},
  [4347] = {.lex_state = 241},
  [4348] = {.lex_state = 204},
  [4349] = {.lex_state = 229},
  [4350] = {.lex_state = 241},
  [4351] = {.lex_state = 241},
  [4352] = {.lex_state = 241},
  [4353] = {.lex_state = 241},
  [4354] = {.lex_state = 241},
  [4355] = {.lex_state = 241},
  [4356] = {.lex_state = 241},
  [4357] = {.lex_state = 241},
  [4358] = {.lex_state = 242},
  [4359] = {.lex_state = 241},
  [4360] = {.lex_state = 204},
  [4361] = {.lex_state = 204},
  [4362] = {.lex_state = 207},
  [4363] = {.lex_state = 204},
  [4364] = {.lex_state = 204},
  [4365] = {.lex_state = 204},
  [4366] = {.lex_state = 204},
  [4367] = {.lex_state = 229},
  [4368] = {.lex_state = 204},
  [4369] = {.lex_state = 229},
  [4370] = {.lex_state = 229},
  [4371] = {.lex_state = 241},
  [4372] = {.lex_state = 204},
  [4373] = {.lex_state = 242},
  [4374] = {.lex_state = 242},
  [4375] = {.lex_state = 241},
  [4376] = {.lex_state = 241},
  [4377] = {.lex_state = 204},
  [4378] = {.lex_state = 241},
  [4379] = {.lex_state = 241},
  [4380] = {.lex_state = 207},
  [4381] = {.lex_state = 241},
  [4382] = {.lex_state = 242},
  [4383] = {.lex_state = 241},
  [4384] = {.lex_state = 244},
  [4385] = {.lex_state = 204},
  [4386] = {.lex_state = 241},
  [4387] = {.lex_state = 241},
  [4388] = {.lex_state = 241},
  [4389] = {.lex_state = 241},
  [4390] = {.lex_state = 204},
  [4391] = {.lex_state = 229},
  [4392] = {.lex_state = 241},
  [4393] = {.lex_state = 205},
  [4394] = {.lex_state = 241},
  [4395] = {.lex_state = 204},
  [4396] = {.lex_state = 204},
  [4397] = {.lex_state = 204},
  [4398] = {.lex_state = 241},
  [4399] = {.lex_state = 194},
  [4400] = {.lex_state = 204},
  [4401] = {.lex_state = 204},
  [4402] = {.lex_state = 229},
  [4403] = {.lex_state = 204},
  [4404] = {.lex_state = 194},
  [4405] = {.lex_state = 229},
  [4406] = {.lex_state = 194},
  [4407] = {.lex_state = 204},
  [4408] = {.lex_state = 229},
  [4409] = {.lex_state = 241},
  [4410] = {.lex_state = 229},
  [4411] = {.lex_state = 204},
  [4412] = {.lex_state = 229},
  [4413] = {.lex_state = 204},
  [4414] = {.lex_state = 204},
  [4415] = {.lex_state = 204},
  [4416] = {.lex_state = 241},
  [4417] = {.lex_state = 206},
  [4418] = {.lex_state = 204},
  [4419] = {.lex_state = 229},
  [4420] = {.lex_state = 229},
  [4421] = {.lex_state = 229},
  [4422] = {.lex_state = 229},
  [4423] = {.lex_state = 242},
  [4424] = {.lex_state = 204},
  [4425] = {.lex_state = 244},
  [4426] = {.lex_state = 229},
  [4427] = {.lex_state = 229},
  [4428] = {.lex_state = 206},
  [4429] = {.lex_state = 229},
  [4430] = {.lex_state = 229},
  [4431] = {.lex_state = 204},
  [4432] = {.lex_state = 204},
  [4433] = {.lex_state = 204},
  [4434] = {.lex_state = 242},
  [4435] = {.lex_state = 229},
  [4436] = {.lex_state = 204},
  [4437] = {.lex_state = 206},
  [4438] = {.lex_state = 241},
  [4439] = {.lex_state = 241},
  [4440] = {.lex_state = 204},
  [4441] = {.lex_state = 229},
  [4442] = {.lex_state = 204},
  [4443] = {.lex_state = 206},
  [4444] = {.lex_state = 241},
  [4445] = {.lex_state = 241},
  [4446] = {.lex_state = 204},
  [4447] = {.lex_state = 206},
  [4448] = {.lex_state = 206},
  [4449] = {.lex_state = 241},
  [4450] = {.lex_state = 204},
  [4451] = {.lex_state = 241},
  [4452] = {.lex_state = 204},
  [4453] = {.lex_state = 204},
  [4454] = {.lex_state = 244},
  [4455] = {.lex_state = 204},
  [4456] = {.lex_state = 229},
  [4457] = {.lex_state = 204},
  [4458] = {.lex_state = 206},
  [4459] = {.lex_state = 242},
  [4460] = {.lex_state = 204},
  [4461] = {.lex_state = 204},
  [4462] = {.lex_state = 229},
  [4463] = {.lex_state = 229},
  [4464] = {.lex_state = 204},
  [4465] = {.lex_state = 241},
  [4466] = {.lex_state = 204},
  [4467] = {.lex_state = 204},
  [4468] = {.lex_state = 242},
  [4469] = {.lex_state = 204},
  [4470] = {.lex_state = 204},
  [4471] = {.lex_state = 242},
  [4472] = {.lex_state = 229},
  [4473] = {.lex_state = 229},
  [4474] = {.lex_state = 229},
  [4475] = {.lex_state = 204},
  [4476] = {.lex_state = 229},
  [4477] = {.lex_state = 204},
  [4478] = {.lex_state = 229},
  [4479] = {.lex_state = 229},
  [4480] = {.lex_state = 241},
  [4481] = {.lex_state = 204},
  [4482] = {.lex_state = 206},
  [4483] = {.lex_state = 204},
  [4484] = {.lex_state = 204},
  [4485] = {.lex_state = 204},
  [4486] = {.lex_state = 229},
  [4487] = {.lex_state = 204},
  [4488] = {.lex_state = 230},
  [4489] = {.lex_state = 204},
  [4490] = {.lex_state = 206},
  [4491] = {.lex_state = 242},
  [4492] = {.lex_state = 206},
  [4493] = {.lex_state = 204},
  [4494] = {.lex_state = 194},
  [4495] = {.lex_state = 206},
  [4496] = {.lex_state = 206},
  [4497] = {.lex_state = 206},
  [4498] = {.lex_state = 206},
  [4499] = {.lex_state = 204},
  [4500] = {.lex_state = 204},
  [4501] = {.lex_state = 242},
  [4502] = {.lex_state = 229},
  [4503] = {.lex_state = 244},
  [4504] = {.lex_state = 205},
  [4505] = {.lex_state = 206},
  [4506] = {.lex_state = 204},
  [4507] = {.lex_state = 229},
  [4508] = {.lex_state = 206},
  [4509] = {.lex_state = 228},
  [4510] = {.lex_state = 206},
  [4511] = {.lex_state = 206},
  [4512] = {.lex_state = 206},
  [4513] = {.lex_state = 241},
  [4514] = {.lex_state = 242},
  [4515] = {.lex_state = 206},
  [4516] = {.lex_state = 206},
  [4517] = {.lex_state = 204},
  [4518] = {.lex_state = 204},
  [4519] = {.lex_state = 204},
  [4520] = {.lex_state = 204},
  [4521] = {.lex_state = 204},
  [4522] = {.lex_state = 204},
  [4523] = {.lex_state = 204},
  [4524] = {.lex_state = 204},
  [4525] = {.lex_state = 204},
  [4526] = {.lex_state = 204},
  [4527] = {.lex_state = 204},
  [4528] = {.lex_state = 204},
  [4529] = {.lex_state = 204},
  [4530] = {.lex_state = 204},
  [4531] = {.lex_state = 204},
  [4532] = {.lex_state = 204},
  [4533] = {.lex_state = 204},
  [4534] = {.lex_state = 206},
  [4535] = {.lex_state = 204},
  [4536] = {.lex_state = 206},
  [4537] = {.lex_state = 242},
  [4538] = {.lex_state = 206},
  [4539] = {.lex_state = 242},
  [4540] = {.lex_state = 204},
  [4541] = {.lex_state = 242},
  [4542] = {.lex_state = 206},
  [4543] = {.lex_state = 204},
  [4544] = {.lex_state = 206},
  [4545] = {.lex_state = 206},
  [4546] = {.lex_state = 242},
  [4547] = {.lex_state = 206},
  [4548] = {.lex_state = 206},
  [4549] = {.lex_state = 206},
  [4550] = {.lex_state = 206},
  [4551] = {.lex_state = 229},
  [4552] = {.lex_state = 204},
  [4553] = {.lex_state = 204},
  [4554] = {.lex_state = 204},
  [4555] = {.lex_state = 206},
  [4556] = {.lex_state = 204},
  [4557] = {.lex_state = 204},
  [4558] = {.lex_state = 204},
  [4559] = {.lex_state = 204},
  [4560] = {.lex_state = 206},
  [4561] = {.lex_state = 204},
  [4562] = {.lex_state = 204},
  [4563] = {.lex_state = 204},
  [4564] = {.lex_state = 206},
  [4565] = {.lex_state = 206},
  [4566] = {.lex_state = 206},
  [4567] = {.lex_state = 206},
  [4568] = {.lex_state = 204},
  [4569] = {.lex_state = 206},
  [4570] = {.lex_state = 204},
  [4571] = {.lex_state = 204},
  [4572] = {.lex_state = 241},
  [4573] = {.lex_state = 206},
  [4574] = {.lex_state = 229},
  [4575] = {.lex_state = 206},
  [4576] = {.lex_state = 229},
  [4577] = {.lex_state = 242},
  [4578] = {.lex_state = 204},
  [4579] = {.lex_state = 229},
  [4580] = {.lex_state = 229},
  [4581] = {.lex_state = 204},
  [4582] = {.lex_state = 204},
  [4583] = {.lex_state = 239},
  [4584] = {.lex_state = 242},
  [4585] = {.lex_state = 204},
  [4586] = {.lex_state = 242},
  [4587] = {.lex_state = 204},
  [4588] = {.lex_state = 242},
  [4589] = {.lex_state = 204},
  [4590] = {.lex_state = 242},
  [4591] = {.lex_state = 204},
  [4592] = {.lex_state = 204},
  [4593] = {.lex_state = 206},
  [4594] = {.lex_state = 239},
  [4595] = {.lex_state = 206},
  [4596] = {.lex_state = 204},
  [4597] = {.lex_state = 242},
  [4598] = {.lex_state = 204},
  [4599] = {.lex_state = 204},
  [4600] = {.lex_state = 204},
  [4601] = {.lex_state = 239},
  [4602] = {.lex_state = 204},
  [4603] = {.lex_state = 204},
  [4604] = {.lex_state = 204},
  [4605] = {.lex_state = 242},
  [4606] = {.lex_state = 242},
  [4607] = {.lex_state = 204},
  [4608] = {.lex_state = 204},
  [4609] = {.lex_state = 204},
  [4610] = {.lex_state = 239},
  [4611] = {.lex_state = 204},
  [4612] = {.lex_state = 242},
  [4613] = {.lex_state = 204},
  [4614] = {.lex_state = 204},
  [4615] = {.lex_state = 204},
  [4616] = {.lex_state = 204},
  [4617] = {.lex_state = 239},
  [4618] = {.lex_state = 204},
  [4619] = {.lex_state = 204},
  [4620] = {.lex_state = 204},
  [4621] = {.lex_state = 204},
  [4622] = {.lex_state = 204},
  [4623] = {.lex_state = 242},
  [4624] = {.lex_state = 239},
  [4625] = {.lex_state = 204},
  [4626] = {.lex_state = 239},
  [4627] = {.lex_state = 206},
  [4628] = {.lex_state = 242},
  [4629] = {.lex_state = 239},
  [4630] = {.lex_state = 239},
  [4631] = {.lex_state = 239},
  [4632] = {.lex_state = 204},
  [4633] = {.lex_state = 242},
  [4634] = {.lex_state = 204},
  [4635] = {.lex_state = 204},
  [4636] = {.lex_state = 204},
  [4637] = {.lex_state = 204},
  [4638] = {.lex_state = 241},
  [4639] = {.lex_state = 241},
  [4640] = {.lex_state = 241},
  [4641] = {.lex_state = 241},
  [4642] = {.lex_state = 242},
  [4643] = {.lex_state = 204},
  [4644] = {.lex_state = 204},
  [4645] = {.lex_state = 204},
  [4646] = {.lex_state = 239},
  [4647] = {.lex_state = 239},
  [4648] = {.lex_state = 204},
  [4649] = {.lex_state = 204},
  [4650] = {.lex_state = 239},
  [4651] = {.lex_state = 204},
  [4652] = {.lex_state = 239},
  [4653] = {.lex_state = 242},
  [4654] = {.lex_state = 204},
  [4655] = {.lex_state = 239},
  [4656] = {.lex_state = 204},
  [4657] = {.lex_state = 204},
  [4658] = {.lex_state = 204},
  [4659] = {.lex_state = 242},
  [4660] = {.lex_state = 242},
  [4661] = {.lex_state = 204},
  [4662] = {.lex_state = 242},
  [4663] = {.lex_state = 242},
  [4664] = {.lex_state = 204},
  [4665] = {.lex_state = 204},
  [4666] = {.lex_state = 204},
  [4667] = {.lex_state = 242},
  [4668] = {.lex_state = 204},
  [4669] = {.lex_state = 204},
  [4670] = {.lex_state = 204},
  [4671] = {.lex_state = 204},
  [4672] = {.lex_state = 204},
  [4673] = {.lex_state = 204},
  [4674] = {.lex_state = 204},
  [4675] = {.lex_state = 239},
  [4676] = {.lex_state = 204},
  [4677] = {.lex_state = 204},
  [4678] = {.lex_state = 242},
  [4679] = {.lex_state = 239},
  [4680] = {.lex_state = 239},
  [4681] = {.lex_state = 204},
  [4682] = {.lex_state = 204},
  [4683] = {.lex_state = 242},
  [4684] = {.lex_state = 204},
  [4685] = {.lex_state = 204},
  [4686] = {.lex_state = 204},
  [4687] = {.lex_state = 204},
  [4688] = {.lex_state = 204},
  [4689] = {.lex_state = 204},
  [4690] = {.lex_state = 229},
  [4691] = {.lex_state = 204},
  [4692] = {.lex_state = 204},
  [4693] = {.lex_state = 242},
  [4694] = {.lex_state = 204},
  [4695] = {.lex_state = 242},
  [4696] = {.lex_state = 204},
  [4697] = {.lex_state = 204},
  [4698] = {.lex_state = 204},
  [4699] = {.lex_state = 242},
  [4700] = {.lex_state = 206},
  [4701] = {.lex_state = 242},
  [4702] = {.lex_state = 204},
  [4703] = {.lex_state = 204},
  [4704] = {.lex_state = 204},
  [4705] = {.lex_state = 204},
  [4706] = {.lex_state = 242},
  [4707] = {.lex_state = 239},
  [4708] = {.lex_state = 204},
  [4709] = {.lex_state = 242},
  [4710] = {.lex_state = 242},
  [4711] = {.lex_state = 238},
  [4712] = {.lex_state = 204},
  [4713] = {.lex_state = 204},
  [4714] = {.lex_state = 204},
  [4715] = {.lex_state = 204},
  [4716] = {.lex_state = 242},
  [4717] = {.lex_state = 204},
  [4718] = {.lex_state = 238},
  [4719] = {.lex_state = 238},
  [4720] = {.lex_state = 242},
  [4721] = {.lex_state = 204},
  [4722] = {.lex_state = 238},
  [4723] = {.lex_state = 204},
  [4724] = {.lex_state = 204},
  [4725] = {.lex_state = 242},
  [4726] = {.lex_state = 242},
  [4727] = {.lex_state = 204},
  [4728] = {.lex_state = 204},
  [4729] = {.lex_state = 239},
  [4730] = {.lex_state = 242},
  [4731] = {.lex_state = 242},
  [4732] = {.lex_state = 242},
  [4733] = {.lex_state = 242},
  [4734] = {.lex_state = 204},
  [4735] = {.lex_state = 204},
  [4736] = {.lex_state = 242},
  [4737] = {.lex_state = 241},
  [4738] = {.lex_state = 231},
  [4739] = {.lex_state = 242},
  [4740] = {.lex_state = 204},
  [4741] = {.lex_state = 204},
  [4742] = {.lex_state = 239},
  [4743] = {.lex_state = 242},
  [4744] = {.lex_state = 204},
  [4745] = {.lex_state = 206},
  [4746] = {.lex_state = 242},
  [4747] = {.lex_state = 242},
  [4748] = {.lex_state = 204},
  [4749] = {.lex_state = 231},
  [4750] = {.lex_state = 204},
  [4751] = {.lex_state = 204},
  [4752] = {.lex_state = 204},
  [4753] = {.lex_state = 204},
  [4754] = {.lex_state = 204},
  [4755] = {.lex_state = 204},
  [4756] = {.lex_state = 204},
  [4757] = {.lex_state = 239},
  [4758] = {.lex_state = 204},
  [4759] = {.lex_state = 204},
  [4760] = {.lex_state = 204},
  [4761] = {.lex_state = 239},
  [4762] = {.lex_state = 204},
  [4763] = {.lex_state = 204},
  [4764] = {.lex_state = 204},
  [4765] = {.lex_state = 204},
  [4766] = {.lex_state = 204},
  [4767] = {.lex_state = 204},
  [4768] = {.lex_state = 241},
  [4769] = {.lex_state = 204},
  [4770] = {.lex_state = 204},
  [4771] = {.lex_state = 204},
  [4772] = {.lex_state = 204},
  [4773] = {.lex_state = 204},
  [4774] = {.lex_state = 204},
  [4775] = {.lex_state = 204},
  [4776] = {.lex_state = 238},
  [4777] = {.lex_state = 229},
  [4778] = {.lex_state = 229},
  [4779] = {.lex_state = 242},
  [4780] = {.lex_state = 204},
  [4781] = {.lex_state = 229},
  [4782] = {.lex_state = 229},
  [4783] = {.lex_state = 229},
  [4784] = {.lex_state = 204},
  [4785] = {.lex_state = 204},
  [4786] = {.lex_state = 204},
  [4787] = {.lex_state = 207},
  [4788] = {.lex_state = 229},
  [4789] = {.lex_state = 238},
  [4790] = {.lex_state = 229},
  [4791] = {.lex_state = 204},
  [4792] = {.lex_state = 229},
  [4793] = {.lex_state = 229},
  [4794] = {.lex_state = 229},
  [4795] = {.lex_state = 229},
  [4796] = {.lex_state = 204},
  [4797] = {.lex_state = 229},
  [4798] = {.lex_state = 204},
  [4799] = {.lex_state = 204},
  [4800] = {.lex_state = 204},
  [4801] = {.lex_state = 204},
  [4802] = {.lex_state = 238},
  [4803] = {.lex_state = 229},
  [4804] = {.lex_state = 242},
  [4805] = {.lex_state = 229},
  [4806] = {.lex_state = 229},
  [4807] = {.lex_state = 229},
  [4808] = {.lex_state = 229},
  [4809] = {.lex_state = 229},
  [4810] = {.lex_state = 229},
  [4811] = {.lex_state = 229},
  [4812] = {.lex_state = 229},
  [4813] = {.lex_state = 204},
  [4814] = {.lex_state = 229},
  [4815] = {.lex_state = 229},
  [4816] = {.lex_state = 229},
  [4817] = {.lex_state = 229},
  [4818] = {.lex_state = 242},
  [4819] = {.lex_state = 242},
  [4820] = {.lex_state = 229},
  [4821] = {.lex_state = 242},
  [4822] = {.lex_state = 242},
  [4823] = {.lex_state = 242},
  [4824] = {.lex_state = 242},
  [4825] = {.lex_state = 229},
  [4826] = {.lex_state = 241},
  [4827] = {.lex_state = 229},
  [4828] = {.lex_state = 229},
  [4829] = {.lex_state = 229},
  [4830] = {.lex_state = 194},
  [4831] = {.lex_state = 229},
  [4832] = {.lex_state = 229},
  [4833] = {.lex_state = 229},
  [4834] = {.lex_state = 229},
  [4835] = {.lex_state = 229},
  [4836] = {.lex_state = 241},
  [4837] = {.lex_state = 204},
  [4838] = {.lex_state = 229},
  [4839] = {.lex_state = 229},
  [4840] = {.lex_state = 229},
  [4841] = {.lex_state = 229},
  [4842] = {.lex_state = 194},
  [4843] = {.lex_state = 238},
  [4844] = {.lex_state = 241},
  [4845] = {.lex_state = 206},
  [4846] = {.lex_state = 205},
  [4847] = {.lex_state = 241},
  [4848] = {.lex_state = 241},
  [4849] = {.lex_state = 194},
  [4850] = {.lex_state = 204},
  [4851] = {.lex_state = 194},
  [4852] = {.lex_state = 241},
  [4853] = {.lex_state = 239},
  [4854] = {.lex_state = 204},
  [4855] = {.lex_state = 204},
  [4856] = {.lex_state = 241},
  [4857] = {.lex_state = 238},
  [4858] = {.lex_state = 241},
  [4859] = {.lex_state = 241},
  [4860] = {.lex_state = 206},
  [4861] = {.lex_state = 194},
  [4862] = {.lex_state = 241},
  [4863] = {.lex_state = 229},
  [4864] = {.lex_state = 238},
  [4865] = {.lex_state = 239},
  [4866] = {.lex_state = 238},
  [4867] = {.lex_state = 205},
  [4868] = {.lex_state = 241},
  [4869] = {.lex_state = 206},
  [4870] = {.lex_state = 241},
  [4871] = {.lex_state = 206},
  [4872] = {.lex_state = 238},
  [4873] = {.lex_state = 194},
  [4874] = {.lex_state = 204},
  [4875] = {.lex_state = 241},
  [4876] = {.lex_state = 229},
  [4877] = {.lex_state = 241},
  [4878] = {.lex_state = 241},
  [4879] = {.lex_state = 194},
  [4880] = {.lex_state = 238},
  [4881] = {.lex_state = 206},
  [4882] = {.lex_state = 239},
  [4883] = {.lex_state = 194},
  [4884] = {.lex_state = 241},
  [4885] = {.lex_state = 241},
  [4886] = {.lex_state = 241},
  [4887] = {.lex_state = 238},
  [4888] = {.lex_state = 241},
  [4889] = {.lex_state = 206},
  [4890] = {.lex_state = 206},
  [4891] = {.lex_state = 204},
  [4892] = {.lex_state = 194},
  [4893] = {.lex_state = 194},
  [4894] = {.lex_state = 241},
  [4895] = {.lex_state = 241},
  [4896] = {.lex_state = 238},
  [4897] = {.lex_state = 206},
  [4898] = {.lex_state = 194},
  [4899] = {.lex_state = 241},
  [4900] = {.lex_state = 241},
  [4901] = {.lex_state = 241},
  [4902] = {.lex_state = 238},
  [4903] = {.lex_state = 241},
  [4904] = {.lex_state = 241},
  [4905] = {.lex_state = 241},
  [4906] = {.lex_state = 241},
  [4907] = {.lex_state = 241},
  [4908] = {.lex_state = 241},
  [4909] = {.lex_state = 241},
  [4910] = {.lex_state = 241},
  [4911] = {.lex_state = 242},
  [4912] = {.lex_state = 241},
  [4913] = {.lex_state = 241},
  [4914] = {.lex_state = 242},
  [4915] = {.lex_state = 241},
  [4916] = {.lex_state = 241},
  [4917] = {.lex_state = 241},
  [4918] = {.lex_state = 241},
  [4919] = {.lex_state = 241},
  [4920] = {.lex_state = 241},
  [4921] = {.lex_state = 241},
  [4922] = {.lex_state = 241},
  [4923] = {.lex_state = 241},
  [4924] = {.lex_state = 241},
  [4925] = {.lex_state = 241},
  [4926] = {.lex_state = 241},
  [4927] = {.lex_state = 241},
  [4928] = {.lex_state = 241},
  [4929] = {.lex_state = 241},
  [4930] = {.lex_state = 241},
  [4931] = {.lex_state = 241},
  [4932] = {.lex_state = 241},
  [4933] = {.lex_state = 241},
  [4934] = {.lex_state = 241},
  [4935] = {.lex_state = 241},
  [4936] = {.lex_state = 241},
  [4937] = {.lex_state = 241},
  [4938] = {.lex_state = 238},
  [4939] = {.lex_state = 242},
  [4940] = {.lex_state = 241},
  [4941] = {.lex_state = 241},
  [4942] = {.lex_state = 239},
  [4943] = {.lex_state = 242},
  [4944] = {.lex_state = 241},
  [4945] = {.lex_state = 241},
  [4946] = {.lex_state = 241},
  [4947] = {.lex_state = 241},
  [4948] = {.lex_state = 241},
  [4949] = {.lex_state = 242},
  [4950] = {.lex_state = 242},
  [4951] = {.lex_state = 238},
  [4952] = {.lex_state = 242},
  [4953] = {.lex_state = 238},
  [4954] = {.lex_state = 242},
  [4955] = {.lex_state = 238},
  [4956] = {.lex_state = 242},
  [4957] = {.lex_state = 194},
  [4958] = {.lex_state = 204},
  [4959] = {.lex_state = 242},
  [4960] = {.lex_state = 238},
  [4961] = {.lex_state = 239},
  [4962] = {.lex_state = 239},
  [4963] = {.lex_state = 204},
  [4964] = {.lex_state = 204},
  [4965] = {.lex_state = 242},
  [4966] = {.lex_state = 242},
  [4967] = {.lex_state = 238},
  [4968] = {.lex_state = 238},
  [4969] = {.lex_state = 242},
  [4970] = {.lex_state = 242},
  [4971] = {.lex_state = 204},
  [4972] = {.lex_state = 238},
  [4973] = {.lex_state = 194},
  [4974] = {.lex_state = 238},
  [4975] = {.lex_state = 241},
  [4976] = {.lex_state = 206},
  [4977] = {.lex_state = 242},
  [4978] = {.lex_state = 239},
  [4979] = {.lex_state = 239},
  [4980] = {.lex_state = 239},
  [4981] = {.lex_state = 239},
  [4982] = {.lex_state = 239},
  [4983] = {.lex_state = 239},
  [4984] = {.lex_state = 239},
  [4985] = {.lex_state = 239},
  [4986] = {.lex_state = 239},
  [4987] = {.lex_state = 238},
  [4988] = {.lex_state = 239},
  [4989] = {.lex_state = 238},
  [4990] = {.lex_state = 239},
  [4991] = {.lex_state = 242},
  [4992] = {.lex_state = 196},
  [4993] = {.lex_state = 238},
  [4994] = {.lex_state = 239},
  [4995] = {.lex_state = 239},
  [4996] = {.lex_state = 206},
  [4997] = {.lex_state = 206},
  [4998] = {.lex_state = 242},
  [4999] = {.lex_state = 239},
  [5000] = {.lex_state = 238},
  [5001] = {.lex_state = 239},
  [5002] = {.lex_state = 239},
  [5003] = {.lex_state = 196},
  [5004] = {.lex_state = 196},
  [5005] = {.lex_state = 238},
  [5006] = {.lex_state = 239},
  [5007] = {.lex_state = 239},
  [5008] = {.lex_state = 239},
  [5009] = {.lex_state = 206},
  [5010] = {.lex_state = 239},
  [5011] = {.lex_state = 242},
  [5012] = {.lex_state = 239},
  [5013] = {.lex_state = 238},
  [5014] = {.lex_state = 239},
  [5015] = {.lex_state = 239},
  [5016] = {.lex_state = 239},
  [5017] = {.lex_state = 196},
  [5018] = {.lex_state = 239},
  [5019] = {.lex_state = 206},
  [5020] = {.lex_state = 196},
  [5021] = {.lex_state = 239},
  [5022] = {.lex_state = 239},
  [5023] = {.lex_state = 239},
  [5024] = {.lex_state = 239},
  [5025] = {.lex_state = 239},
  [5026] = {.lex_state = 196},
  [5027] = {.lex_state = 238},
  [5028] = {.lex_state = 238},
  [5029] = {.lex_state = 239},
  [5030] = {.lex_state = 239},
  [5031] = {.lex_state = 238},
  [5032] = {.lex_state = 239},
  [5033] = {.lex_state = 239},
  [5034] = {.lex_state = 238},
  [5035] = {.lex_state = 239},
  [5036] = {.lex_state = 194},
  [5037] = {.lex_state = 238},
  [5038] = {.lex_state = 239},
  [5039] = {.lex_state = 196},
  [5040] = {.lex_state = 238},
  [5041] = {.lex_state = 196},
  [5042] = {.lex_state = 196},
  [5043] = {.lex_state = 196},
  [5044] = {.lex_state = 239},
  [5045] = {.lex_state = 239},
  [5046] = {.lex_state = 196},
  [5047] = {.lex_state = 196},
  [5048] = {.lex_state = 239},
  [5049] = {.lex_state = 196},
  [5050] = {.lex_state = 239},
  [5051] = {.lex_state = 239},
  [5052] = {.lex_state = 239},
  [5053] = {.lex_state = 239},
  [5054] = {.lex_state = 239},
  [5055] = {.lex_state = 196},
  [5056] = {.lex_state = 196},
  [5057] = {.lex_state = 196},
  [5058] = {.lex_state = 196},
  [5059] = {.lex_state = 196},
  [5060] = {.lex_state = 196},
  [5061] = {.lex_state = 196},
  [5062] = {.lex_state = 196},
  [5063] = {.lex_state = 196},
  [5064] = {.lex_state = 196},
  [5065] = {.lex_state = 196},
  [5066] = {.lex_state = 196},
  [5067] = {.lex_state = 204},
  [5068] = {.lex_state = 238},
  [5069] = {.lex_state = 196},
  [5070] = {.lex_state = 196},
  [5071] = {.lex_state = 196},
  [5072] = {.lex_state = 196},
  [5073] = {.lex_state = 196},
  [5074] = {.lex_state = 196},
  [5075] = {.lex_state = 196},
  [5076] = {.lex_state = 196},
  [5077] = {.lex_state = 196},
  [5078] = {.lex_state = 196},
  [5079] = {.lex_state = 196},
  [5080] = {.lex_state = 196},
  [5081] = {.lex_state = 196},
  [5082] = {.lex_state = 196},
  [5083] = {.lex_state = 196},
  [5084] = {.lex_state = 196},
  [5085] = {.lex_state = 196},
  [5086] = {.lex_state = 196},
  [5087] = {.lex_state = 196},
  [5088] = {.lex_state = 196},
  [5089] = {.lex_state = 196},
  [5090] = {.lex_state = 196},
  [5091] = {.lex_state = 196},
  [5092] = {.lex_state = 196},
  [5093] = {.lex_state = 196},
  [5094] = {.lex_state = 196},
  [5095] = {.lex_state = 196},
  [5096] = {.lex_state = 196},
  [5097] = {.lex_state = 196},
  [5098] = {.lex_state = 196},
  [5099] = {.lex_state = 196},
  [5100] = {.lex_state = 238},
  [5101] = {.lex_state = 196},
  [5102] = {.lex_state = 196},
  [5103] = {.lex_state = 196},
  [5104] = {.lex_state = 196},
  [5105] = {.lex_state = 196},
  [5106] = {.lex_state = 196},
  [5107] = {.lex_state = 196},
  [5108] = {.lex_state = 196},
  [5109] = {.lex_state = 196},
  [5110] = {.lex_state = 196},
  [5111] = {.lex_state = 196},
  [5112] = {.lex_state = 196},
  [5113] = {.lex_state = 196},
  [5114] = {.lex_state = 204},
  [5115] = {.lex_state = 196},
  [5116] = {.lex_state = 196},
  [5117] = {.lex_state = 196},
  [5118] = {.lex_state = 196},
  [5119] = {.lex_state = 196},
  [5120] = {.lex_state = 196},
  [5121] = {.lex_state = 196},
  [5122] = {.lex_state = 196},
  [5123] = {.lex_state = 196},
  [5124] = {.lex_state = 196},
  [5125] = {.lex_state = 196},
  [5126] = {.lex_state = 196},
  [5127] = {.lex_state = 196},
  [5128] = {.lex_state = 196},
  [5129] = {.lex_state = 196},
  [5130] = {.lex_state = 196},
  [5131] = {.lex_state = 196},
  [5132] = {.lex_state = 196},
  [5133] = {.lex_state = 238},
  [5134] = {.lex_state = 196},
  [5135] = {.lex_state = 196},
  [5136] = {.lex_state = 196},
  [5137] = {.lex_state = 196},
  [5138] = {.lex_state = 238},
  [5139] = {.lex_state = 196},
  [5140] = {.lex_state = 196},
  [5141] = {.lex_state = 196},
  [5142] = {.lex_state = 196},
  [5143] = {.lex_state = 196},
  [5144] = {.lex_state = 196},
  [5145] = {.lex_state = 196},
  [5146] = {.lex_state = 239},
  [5147] = {.lex_state = 239},
  [5148] = {.lex_state = 196},
  [5149] = {.lex_state = 196},
  [5150] = {.lex_state = 196},
  [5151] = {.lex_state = 196},
  [5152] = {.lex_state = 196},
  [5153] = {.lex_state = 239},
  [5154] = {.lex_state = 239},
  [5155] = {.lex_state = 196},
  [5156] = {.lex_state = 196},
  [5157] = {.lex_state = 196},
  [5158] = {.lex_state = 196},
  [5159] = {.lex_state = 239},
  [5160] = {.lex_state = 239},
  [5161] = {.lex_state = 196},
  [5162] = {.lex_state = 239},
  [5163] = {.lex_state = 196},
  [5164] = {.lex_state = 196},
  [5165] = {.lex_state = 238},
  [5166] = {.lex_state = 239},
  [5167] = {.lex_state = 239},
  [5168] = {.lex_state = 204},
  [5169] = {.lex_state = 239},
  [5170] = {.lex_state = 239},
  [5171] = {.lex_state = 239},
  [5172] = {.lex_state = 239},
  [5173] = {.lex_state = 196},
  [5174] = {.lex_state = 239},
  [5175] = {.lex_state = 239},
  [5176] = {.lex_state = 196},
  [5177] = {.lex_state = 239},
  [5178] = {.lex_state = 239},
  [5179] = {.lex_state = 238},
  [5180] = {.lex_state = 204},
  [5181] = {.lex_state = 238},
  [5182] = {.lex_state = 239},
  [5183] = {.lex_state = 239},
  [5184] = {.lex_state = 204},
  [5185] = {.lex_state = 239},
  [5186] = {.lex_state = 239},
  [5187] = {.lex_state = 239},
  [5188] = {.lex_state = 239},
  [5189] = {.lex_state = 196},
  [5190] = {.lex_state = 196},
  [5191] = {.lex_state = 239},
  [5192] = {.lex_state = 238},
  [5193] = {.lex_state = 239},
  [5194] = {.lex_state = 196},
  [5195] = {.lex_state = 239},
  [5196] = {.lex_state = 204},
  [5197] = {.lex_state = 239},
  [5198] = {.lex_state = 196},
  [5199] = {.lex_state = 239},
  [5200] = {.lex_state = 196},
  [5201] = {.lex_state = 196},
  [5202] = {.lex_state = 196},
  [5203] = {.lex_state = 196},
  [5204] = {.lex_state = 238},
  [5205] = {.lex_state = 196},
  [5206] = {.lex_state = 239},
  [5207] = {.lex_state = 239},
  [5208] = {.lex_state = 239},
  [5209] = {.lex_state = 204},
  [5210] = {.lex_state = 238},
  [5211] = {.lex_state = 239},
  [5212] = {.lex_state = 239},
  [5213] = {.lex_state = 239},
  [5214] = {.lex_state = 239},
  [5215] = {.lex_state = 204},
  [5216] = {.lex_state = 239},
  [5217] = {.lex_state = 204},
  [5218] = {.lex_state = 239},
  [5219] = {.lex_state = 196},
  [5220] = {.lex_state = 196},
  [5221] = {.lex_state = 239},
  [5222] = {.lex_state = 196},
  [5223] = {.lex_state = 238},
  [5224] = {.lex_state = 239},
  [5225] = {.lex_state = 196},
  [5226] = {.lex_state = 239},
  [5227] = {.lex_state = 239},
  [5228] = {.lex_state = 204},
  [5229] = {.lex_state = 238},
  [5230] = {.lex_state = 239},
  [5231] = {.lex_state = 239},
  [5232] = {.lex_state = 196},
  [5233] = {.lex_state = 239},
  [5234] = {.lex_state = 204},
  [5235] = {.lex_state = 198},
  [5236] = {.lex_state = 198},
  [5237] = {.lex_state = 198},
  [5238] = {.lex_state = 198},
  [5239] = {.lex_state = 239},
  [5240] = {.lex_state = 204},
  [5241] = {.lex_state = 239},
  [5242] = {.lex_state = 204},
  [5243] = {.lex_state = 239},
  [5244] = {.lex_state = 204},
  [5245] = {.lex_state = 242},
  [5246] = {.lex_state = 204},
  [5247] = {.lex_state = 242},
  [5248] = {.lex_state = 242},
  [5249] = {.lex_state = 204},
  [5250] = {.lex_state = 204},
  [5251] = {.lex_state = 204},
  [5252] = {.lex_state = 204},
  [5253] = {.lex_state = 198},
  [5254] = {.lex_state = 198},
  [5255] = {.lex_state = 196},
  [5256] = {.lex_state = 196},
  [5257] = {.lex_state = 204},
  [5258] = {.lex_state = 239},
  [5259] = {.lex_state = 204},
  [5260] = {.lex_state = 204},
  [5261] = {.lex_state = 198},
  [5262] = {.lex_state = 204},
  [5263] = {.lex_state = 204},
  [5264] = {.lex_state = 204},
  [5265] = {.lex_state = 204},
  [5266] = {.lex_state = 204},
  [5267] = {.lex_state = 206},
  [5268] = {.lex_state = 206},
  [5269] = {.lex_state = 204},
  [5270] = {.lex_state = 204},
  [5271] = {.lex_state = 204},
  [5272] = {.lex_state = 204},
  [5273] = {.lex_state = 204},
  [5274] = {.lex_state = 204},
  [5275] = {.lex_state = 204},
  [5276] = {.lex_state = 204},
  [5277] = {.lex_state = 242},
  [5278] = {.lex_state = 242},
  [5279] = {.lex_state = 204},
  [5280] = {.lex_state = 242},
  [5281] = {.lex_state = 204},
  [5282] = {.lex_state = 198},
  [5283] = {.lex_state = 204},
  [5284] = {.lex_state = 238},
  [5285] = {.lex_state = 241},
  [5286] = {.lex_state = 238},
  [5287] = {.lex_state = 242},
  [5288] = {.lex_state = 238},
  [5289] = {.lex_state = 242},
  [5290] = {.lex_state = 242},
  [5291] = {.lex_state = 242},
  [5292] = {.lex_state = 242},
  [5293] = {.lex_state = 242},
  [5294] = {.lex_state = 242},
  [5295] = {.lex_state = 242},
  [5296] = {.lex_state = 242},
  [5297] = {.lex_state = 242},
  [5298] = {.lex_state = 242},
  [5299] = {.lex_state = 242},
  [5300] = {.lex_state = 238},
  [5301] = {.lex_state = 238},
  [5302] = {.lex_state = 238},
  [5303] = {.lex_state = 196},
  [5304] = {.lex_state = 238},
  [5305] = {.lex_state = 196},
  [5306] = {.lex_state = 196},
  [5307] = {.lex_state = 238},
  [5308] = {.lex_state = 238},
  [5309] = {.lex_state = 196},
  [5310] = {.lex_state = 196},
  [5311] = {.lex_state = 238},
  [5312] = {.lex_state = 238},
  [5313] = {.lex_state = 238},
  [5314] = {.lex_state = 238},
  [5315] = {.lex_state = 238},
  [5316] = {.lex_state = 238},
  [5317] = {.lex_state = 238},
  [5318] = {.lex_state = 238},
  [5319] = {.lex_state = 238},
  [5320] = {.lex_state = 196},
  [5321] = {.lex_state = 196},
  [5322] = {.lex_state = 196},
  [5323] = {.lex_state = 196},
  [5324] = {.lex_state = 196},
  [5325] = {.lex_state = 196},
  [5326] = {.lex_state = 196},
  [5327] = {.lex_state = 241},
  [5328] = {.lex_state = 238},
  [5329] = {.lex_state = 238},
  [5330] = {.lex_state = 238},
  [5331] = {.lex_state = 238},
  [5332] = {.lex_state = 238},
  [5333] = {.lex_state = 238},
  [5334] = {.lex_state = 239},
  [5335] = {.lex_state = 238},
  [5336] = {.lex_state = 238},
  [5337] = {.lex_state = 239},
  [5338] = {.lex_state = 238},
  [5339] = {.lex_state = 239},
  [5340] = {.lex_state = 238},
  [5341] = {.lex_state = 239},
  [5342] = {.lex_state = 238},
  [5343] = {.lex_state = 238},
  [5344] = {.lex_state = 196},
  [5345] = {.lex_state = 242},
  [5346] = {.lex_state = 238},
  [5347] = {.lex_state = 238},
  [5348] = {.lex_state = 238},
  [5349] = {.lex_state = 238},
  [5350] = {.lex_state = 238},
  [5351] = {.lex_state = 251},
  [5352] = {.lex_state = 238},
  [5353] = {.lex_state = 251},
  [5354] = {.lex_state = 251},
  [5355] = {.lex_state = 251},
  [5356] = {.lex_state = 196},
  [5357] = {.lex_state = 242},
  [5358] = {.lex_state = 238},
  [5359] = {.lex_state = 238},
  [5360] = {.lex_state = 238},
  [5361] = {.lex_state = 196},
  [5362] = {.lex_state = 238},
  [5363] = {.lex_state = 196},
  [5364] = {.lex_state = 196},
  [5365] = {.lex_state = 251},
  [5366] = {.lex_state = 238},
  [5367] = {.lex_state = 251},
  [5368] = {.lex_state = 196},
  [5369] = {.lex_state = 238},
  [5370] = {.lex_state = 238},
  [5371] = {.lex_state = 251},
  [5372] = {.lex_state = 198},
  [5373] = {.lex_state = 198},
  [5374] = {.lex_state = 198},
  [5375] = {.lex_state = 198},
  [5376] = {.lex_state = 242},
  [5377] = {.lex_state = 198},
  [5378] = {.lex_state = 242},
  [5379] = {.lex_state = 198},
  [5380] = {.lex_state = 198},
  [5381] = {.lex_state = 238},
  [5382] = {.lex_state = 198},
  [5383] = {.lex_state = 198},
  [5384] = {.lex_state = 238},
  [5385] = {.lex_state = 198},
  [5386] = {.lex_state = 196},
  [5387] = {.lex_state = 196},
  [5388] = {.lex_state = 194},
  [5389] = {.lex_state = 242},
  [5390] = {.lex_state = 196},
  [5391] = {.lex_state = 198},
  [5392] = {.lex_state = 198},
  [5393] = {.lex_state = 196},
  [5394] = {.lex_state = 196},
  [5395] = {.lex_state = 238},
  [5396] = {.lex_state = 238},
  [5397] = {.lex_state = 196},
  [5398] = {.lex_state = 196},
  [5399] = {.lex_state = 238},
  [5400] = {.lex_state = 238},
  [5401] = {.lex_state = 238},
  [5402] = {.lex_state = 238},
  [5403] = {.lex_state = 196},
  [5404] = {.lex_state = 238},
  [5405] = {.lex_state = 196},
  [5406] = {.lex_state = 238},
  [5407] = {.lex_state = 242},
  [5408] = {.lex_state = 196},
  [5409] = {.lex_state = 238},
  [5410] = {.lex_state = 196},
  [5411] = {.lex_state = 238},
  [5412] = {.lex_state = 196},
  [5413] = {.lex_state = 196},
  [5414] = {.lex_state = 238},
  [5415] = {.lex_state = 238},
  [5416] = {.lex_state = 196},
  [5417] = {.lex_state = 251},
  [5418] = {.lex_state = 238},
  [5419] = {.lex_state = 238},
  [5420] = {.lex_state = 238},
  [5421] = {.lex_state = 251},
  [5422] = {.lex_state = 251},
  [5423] = {.lex_state = 251},
  [5424] = {.lex_state = 251},
  [5425] = {.lex_state = 238},
  [5426] = {.lex_state = 251},
  [5427] = {.lex_state = 238},
  [5428] = {.lex_state = 242},
  [5429] = {.lex_state = 251},
  [5430] = {.lex_state = 251},
  [5431] = {.lex_state = 251},
  [5432] = {.lex_state = 251},
  [5433] = {.lex_state = 251},
  [5434] = {.lex_state = 251},
  [5435] = {.lex_state = 251},
  [5436] = {.lex_state = 251},
  [5437] = {.lex_state = 251},
  [5438] = {.lex_state = 195},
  [5439] = {.lex_state = 251},
  [5440] = {.lex_state = 251},
  [5441] = {.lex_state = 251},
  [5442] = {.lex_state = 238},
  [5443] = {.lex_state = 251},
  [5444] = {.lex_state = 251},
  [5445] = {.lex_state = 251},
  [5446] = {.lex_state = 238},
  [5447] = {.lex_state = 238},
  [5448] = {.lex_state = 238},
  [5449] = {.lex_state = 251},
  [5450] = {.lex_state = 238},
  [5451] = {.lex_state = 251},
  [5452] = {.lex_state = 238},
  [5453] = {.lex_state = 238},
  [5454] = {.lex_state = 251},
  [5455] = {.lex_state = 251},
  [5456] = {.lex_state = 251},
  [5457] = {.lex_state = 251},
  [5458] = {.lex_state = 238},
  [5459] = {.lex_state = 251},
  [5460] = {.lex_state = 194},
  [5461] = {.lex_state = 251},
  [5462] = {.lex_state = 194},
  [5463] = {.lex_state = 241},
  [5464] = {.lex_state = 251},
  [5465] = {.lex_state = 251},
  [5466] = {.lex_state = 251},
  [5467] = {.lex_state = 251},
  [5468] = {.lex_state = 242},
  [5469] = {.lex_state = 251},
  [5470] = {.lex_state = 242},
  [5471] = {.lex_state = 238},
  [5472] = {.lex_state = 251},
  [5473] = {.lex_state = 251},
  [5474] = {.lex_state = 251},
  [5475] = {.lex_state = 251},
  [5476] = {.lex_state = 251},
  [5477] = {.lex_state = 251},
  [5478] = {.lex_state = 194},
  [5479] = {.lex_state = 238},
  [5480] = {.lex_state = 251},
  [5481] = {.lex_state = 251},
  [5482] = {.lex_state = 251},
  [5483] = {.lex_state = 251},
  [5484] = {.lex_state = 196},
  [5485] = {.lex_state = 196},
  [5486] = {.lex_state = 238},
  [5487] = {.lex_state = 196},
  [5488] = {.lex_state = 196},
  [5489] = {.lex_state = 196},
  [5490] = {.lex_state = 242},
  [5491] = {.lex_state = 242},
  [5492] = {.lex_state = 242},
  [5493] = {.lex_state = 242},
  [5494] = {.lex_state = 242},
  [5495] = {.lex_state = 196},
  [5496] = {.lex_state = 196},
  [5497] = {.lex_state = 238},
  [5498] = {.lex_state = 194},
  [5499] = {.lex_state = 196},
  [5500] = {.lex_state = 196},
  [5501] = {.lex_state = 196},
  [5502] = {.lex_state = 238},
  [5503] = {.lex_state = 242},
  [5504] = {.lex_state = 196},
  [5505] = {.lex_state = 196},
  [5506] = {.lex_state = 196},
  [5507] = {.lex_state = 196},
  [5508] = {.lex_state = 196},
  [5509] = {.lex_state = 196},
  [5510] = {.lex_state = 196},
  [5511] = {.lex_state = 196},
  [5512] = {.lex_state = 196},
  [5513] = {.lex_state = 196},
  [5514] = {.lex_state = 242},
  [5515] = {.lex_state = 238},
  [5516] = {.lex_state = 196},
  [5517] = {.lex_state = 196},
  [5518] = {.lex_state = 196},
  [5519] = {.lex_state = 196},
  [5520] = {.lex_state = 242},
  [5521] = {.lex_state = 196},
  [5522] = {.lex_state = 196},
  [5523] = {.lex_state = 196},
  [5524] = {.lex_state = 178},
  [5525] = {.lex_state = 194},
  [5526] = {.lex_state = 196},
  [5527] = {.lex_state = 196},
  [5528] = {.lex_state = 196},
  [5529] = {.lex_state = 196},
  [5530] = {.lex_state = 196},
  [5531] = {.lex_state = 196},
  [5532] = {.lex_state = 196},
  [5533] = {.lex_state = 196},
  [5534] = {.lex_state = 242},
  [5535] = {.lex_state = 196},
  [5536] = {.lex_state = 242},
  [5537] = {.lex_state = 196},
  [5538] = {.lex_state = 196},
  [5539] = {.lex_state = 196},
  [5540] = {.lex_state = 196},
  [5541] = {.lex_state = 196},
  [5542] = {.lex_state = 196},
  [5543] = {.lex_state = 196},
  [5544] = {.lex_state = 242},
  [5545] = {.lex_state = 196},
  [5546] = {.lex_state = 195},
  [5547] = {.lex_state = 196},
  [5548] = {.lex_state = 196},
  [5549] = {.lex_state = 196},
  [5550] = {.lex_state = 242},
  [5551] = {.lex_state = 196},
  [5552] = {.lex_state = 196},
  [5553] = {.lex_state = 242},
  [5554] = {.lex_state = 242},
  [5555] = {.lex_state = 242},
  [5556] = {.lex_state = 242},
  [5557] = {.lex_state = 196},
  [5558] = {.lex_state = 196},
  [5559] = {.lex_state = 196},
  [5560] = {.lex_state = 196},
  [5561] = {.lex_state = 196},
  [5562] = {.lex_state = 196},
  [5563] = {.lex_state = 196},
  [5564] = {.lex_state = 196},
  [5565] = {.lex_state = 196},
  [5566] = {.lex_state = 196},
  [5567] = {.lex_state = 196},
  [5568] = {.lex_state = 196},
  [5569] = {.lex_state = 196},
  [5570] = {.lex_state = 196},
  [5571] = {.lex_state = 196},
  [5572] = {.lex_state = 196},
  [5573] = {.lex_state = 196},
  [5574] = {.lex_state = 196},
  [5575] = {.lex_state = 196},
  [5576] = {.lex_state = 196},
  [5577] = {.lex_state = 242},
  [5578] = {.lex_state = 242},
  [5579] = {.lex_state = 242},
  [5580] = {.lex_state = 195},
  [5581] = {.lex_state = 195},
  [5582] = {.lex_state = 196},
  [5583] = {.lex_state = 196},
  [5584] = {.lex_state = 196},
  [5585] = {.lex_state = 238},
  [5586] = {.lex_state = 196},
  [5587] = {.lex_state = 99},
  [5588] = {.lex_state = 196},
  [5589] = {.lex_state = 196},
  [5590] = {.lex_state = 196},
  [5591] = {.lex_state = 194},
  [5592] = {.lex_state = 196},
  [5593] = {.lex_state = 178},
  [5594] = {.lex_state = 242},
  [5595] = {.lex_state = 242},
  [5596] = {.lex_state = 196},
  [5597] = {.lex_state = 196},
  [5598] = {.lex_state = 196},
  [5599] = {.lex_state = 196},
  [5600] = {.lex_state = 196},
  [5601] = {.lex_state = 196},
  [5602] = {.lex_state = 196},
  [5603] = {.lex_state = 242},
  [5604] = {.lex_state = 242},
  [5605] = {.lex_state = 242},
  [5606] = {.lex_state = 242},
  [5607] = {.lex_state = 196},
  [5608] = {.lex_state = 196},
  [5609] = {.lex_state = 242},
  [5610] = {.lex_state = 242},
  [5611] = {.lex_state = 242},
  [5612] = {.lex_state = 196},
  [5613] = {.lex_state = 196},
  [5614] = {.lex_state = 196},
  [5615] = {.lex_state = 242},
  [5616] = {.lex_state = 242},
  [5617] = {.lex_state = 238},
  [5618] = {.lex_state = 242},
  [5619] = {.lex_state = 242},
  [5620] = {.lex_state = 242},
  [5621] = {.lex_state = 242},
  [5622] = {.lex_state = 242},
  [5623] = {.lex_state = 196},
  [5624] = {.lex_state = 196},
  [5625] = {.lex_state = 242},
  [5626] = {.lex_state = 242},
  [5627] = {.lex_state = 196},
  [5628] = {.lex_state = 194},
  [5629] = {.lex_state = 196},
  [5630] = {.lex_state = 196},
  [5631] = {.lex_state = 196},
  [5632] = {.lex_state = 238},
  [5633] = {.lex_state = 196},
  [5634] = {.lex_state = 196},
  [5635] = {.lex_state = 196},
  [5636] = {.lex_state = 178},
  [5637] = {.lex_state = 194},
  [5638] = {.lex_state = 196},
  [5639] = {.lex_state = 196},
  [5640] = {.lex_state = 196},
  [5641] = {.lex_state = 246},
  [5642] = {.lex_state = 195},
  [5643] = {.lex_state = 195},
  [5644] = {.lex_state = 239},
  [5645] = {.lex_state = 195},
  [5646] = {.lex_state = 195},
  [5647] = {.lex_state = 246},
  [5648] = {.lex_state = 195},
  [5649] = {.lex_state = 195},
  [5650] = {.lex_state = 239},
  [5651] = {.lex_state = 246},
  [5652] = {.lex_state = 178},
  [5653] = {.lex_state = 242},
  [5654] = {.lex_state = 194},
  [5655] = {.lex_state = 242},
  [5656] = {.lex_state = 178},
  [5657] = {.lex_state = 178},
  [5658] = {.lex_state = 242},
  [5659] = {.lex_state = 194},
  [5660] = {.lex_state = 242},
  [5661] = {.lex_state = 178},
  [5662] = {.lex_state = 238},
  [5663] = {.lex_state = 238},
  [5664] = {.lex_state = 238},
  [5665] = {.lex_state = 238},
  [5666] = {.lex_state = 178},
  [5667] = {.lex_state = 246},
  [5668] = {.lex_state = 239},
  [5669] = {.lex_state = 242},
  [5670] = {.lex_state = 242},
  [5671] = {.lex_state = 242},
  [5672] = {.lex_state = 242},
  [5673] = {.lex_state = 195},
  [5674] = {.lex_state = 195},
  [5675] = {.lex_state = 246},
  [5676] = {.lex_state = 194},
  [5677] = {.lex_state = 238},
  [5678] = {.lex_state = 238},
  [5679] = {.lex_state = 238},
  [5680] = {.lex_state = 238},
  [5681] = {.lex_state = 246},
  [5682] = {.lex_state = 246},
  [5683] = {.lex_state = 241},
  [5684] = {.lex_state = 246},
  [5685] = {.lex_state = 194},
  [5686] = {.lex_state = 178},
  [5687] = {.lex_state = 242},
  [5688] = {.lex_state = 242},
  [5689] = {.lex_state = 246},
  [5690] = {.lex_state = 246},
  [5691] = {.lex_state = 246},
  [5692] = {.lex_state = 204},
  [5693] = {.lex_state = 246},
  [5694] = {.lex_state = 239},
  [5695] = {.lex_state = 246},
  [5696] = {.lex_state = 239},
  [5697] = {.lex_state = 195},
  [5698] = {.lex_state = 246},
  [5699] = {.lex_state = 195},
  [5700] = {.lex_state = 178},
  [5701] = {.lex_state = 242},
  [5702] = {.lex_state = 194},
  [5703] = {.lex_state = 242},
  [5704] = {.lex_state = 178},
  [5705] = {.lex_state = 195},
  [5706] = {.lex_state = 242},
  [5707] = {.lex_state = 178},
  [5708] = {.lex_state = 178},
  [5709] = {.lex_state = 242},
  [5710] = {.lex_state = 178},
  [5711] = {.lex_state = 178},
  [5712] = {.lex_state = 178},
  [5713] = {.lex_state = 242},
  [5714] = {.lex_state = 242},
  [5715] = {.lex_state = 242},
  [5716] = {.lex_state = 242},
  [5717] = {.lex_state = 178},
  [5718] = {.lex_state = 178},
  [5719] = {.lex_state = 178},
  [5720] = {.lex_state = 178},
  [5721] = {.lex_state = 178},
  [5722] = {.lex_state = 195},
  [5723] = {.lex_state = 239},
  [5724] = {.lex_state = 178},
  [5725] = {.lex_state = 194},
  [5726] = {.lex_state = 178},
  [5727] = {.lex_state = 178},
  [5728] = {.lex_state = 239},
  [5729] = {.lex_state = 178},
  [5730] = {.lex_state = 178},
  [5731] = {.lex_state = 195},
  [5732] = {.lex_state = 239},
  [5733] = {.lex_state = 242},
  [5734] = {.lex_state = 246},
  [5735] = {.lex_state = 239},
  [5736] = {.lex_state = 239},
  [5737] = {.lex_state = 194},
  [5738] = {.lex_state = 178},
  [5739] = {.lex_state = 178},
  [5740] = {.lex_state = 204},
  [5741] = {.lex_state = 178},
  [5742] = {.lex_state = 178},
  [5743] = {.lex_state = 178},
  [5744] = {.lex_state = 239},
  [5745] = {.lex_state = 239},
  [5746] = {.lex_state = 239},
  [5747] = {.lex_state = 242},
  [5748] = {.lex_state = 246},
  [5749] = {.lex_state = 246},
  [5750] = {.lex_state = 194},
  [5751] = {.lex_state = 246},
  [5752] = {.lex_state = 239},
  [5753] = {.lex_state = 241},
  [5754] = {.lex_state = 239},
  [5755] = {.lex_state = 178},
  [5756] = {.lex_state = 239},
  [5757] = {.lex_state = 239},
  [5758] = {.lex_state = 178},
  [5759] = {.lex_state = 246},
  [5760] = {.lex_state = 246},
  [5761] = {.lex_state = 246},
  [5762] = {.lex_state = 178},
  [5763] = {.lex_state = 194},
  [5764] = {.lex_state = 195},
  [5765] = {.lex_state = 195},
  [5766] = {.lex_state = 195},
  [5767] = {.lex_state = 195},
  [5768] = {.lex_state = 178},
  [5769] = {.lex_state = 246},
  [5770] = {.lex_state = 178},
  [5771] = {.lex_state = 195},
  [5772] = {.lex_state = 194},
  [5773] = {.lex_state = 194},
  [5774] = {.lex_state = 195},
  [5775] = {.lex_state = 194},
  [5776] = {.lex_state = 246},
  [5777] = {.lex_state = 178},
  [5778] = {.lex_state = 178},
  [5779] = {.lex_state = 178},
  [5780] = {.lex_state = 195},
  [5781] = {.lex_state = 194},
  [5782] = {.lex_state = 178},
  [5783] = {.lex_state = 178},
  [5784] = {.lex_state = 178},
  [5785] = {.lex_state = 246},
  [5786] = {.lex_state = 246},
  [5787] = {.lex_state = 246},
  [5788] = {.lex_state = 194},
  [5789] = {.lex_state = 246},
  [5790] = {.lex_state = 246},
  [5791] = {.lex_state = 239},
  [5792] = {.lex_state = 242},
  [5793] = {.lex_state = 195},
  [5794] = {.lex_state = 239},
  [5795] = {.lex_state = 238},
  [5796] = {.lex_state = 194},
  [5797] = {.lex_state = 99},
  [5798] = {.lex_state = 99},
  [5799] = {.lex_state = 239},
  [5800] = {.lex_state = 250},
  [5801] = {.lex_state = 99},
  [5802] = {.lex_state = 99},
  [5803] = {.lex_state = 239},
  [5804] = {.lex_state = 242},
  [5805] = {.lex_state = 99},
  [5806] = {.lex_state = 99},
  [5807] = {.lex_state = 194},
  [5808] = {.lex_state = 99},
  [5809] = {.lex_state = 241},
  [5810] = {.lex_state = 239},
  [5811] = {.lex_state = 99},
  [5812] = {.lex_state = 242},
  [5813] = {.lex_state = 242},
  [5814] = {.lex_state = 239},
  [5815] = {.lex_state = 99},
  [5816] = {.lex_state = 242},
  [5817] = {.lex_state = 241},
  [5818] = {.lex_state = 242},
  [5819] = {.lex_state = 242},
  [5820] = {.lex_state = 242},
  [5821] = {.lex_state = 99},
  [5822] = {.lex_state = 242},
  [5823] = {.lex_state = 99},
  [5824] = {.lex_state = 99},
  [5825] = {.lex_state = 99},
  [5826] = {.lex_state = 99},
  [5827] = {.lex_state = 242},
  [5828] = {.lex_state = 99},
  [5829] = {.lex_state = 242},
  [5830] = {.lex_state = 242},
  [5831] = {.lex_state = 99},
  [5832] = {.lex_state = 242},
  [5833] = {.lex_state = 99},
  [5834] = {.lex_state = 99},
  [5835] = {.lex_state = 242},
  [5836] = {.lex_state = 242},
  [5837] = {.lex_state = 99},
  [5838] = {.lex_state = 194},
  [5839] = {.lex_state = 242},
  [5840] = {.lex_state = 99},
  [5841] = {.lex_state = 242},
  [5842] = {.lex_state = 99},
  [5843] = {.lex_state = 99},
  [5844] = {.lex_state = 99},
  [5845] = {.lex_state = 239},
  [5846] = {.lex_state = 242},
  [5847] = {.lex_state = 194},
  [5848] = {.lex_state = 239},
  [5849] = {.lex_state = 238},
  [5850] = {.lex_state = 194},
  [5851] = {.lex_state = 241},
  [5852] = {.lex_state = 239},
  [5853] = {.lex_state = 99},
  [5854] = {.lex_state = 99},
  [5855] = {.lex_state = 242},
  [5856] = {.lex_state = 99},
  [5857] = {.lex_state = 99},
  [5858] = {.lex_state = 194},
  [5859] = {.lex_state = 238},
  [5860] = {.lex_state = 194},
  [5861] = {.lex_state = 238},
  [5862] = {.lex_state = 242},
  [5863] = {.lex_state = 239},
  [5864] = {.lex_state = 196},
  [5865] = {.lex_state = 99},
  [5866] = {.lex_state = 196},
  [5867] = {.lex_state = 99},
  [5868] = {.lex_state = 239},
  [5869] = {.lex_state = 196},
  [5870] = {.lex_state = 99},
  [5871] = {.lex_state = 195},
  [5872] = {.lex_state = 99},
  [5873] = {.lex_state = 239},
  [5874] = {.lex_state = 196},
  [5875] = {.lex_state = 196},
  [5876] = {.lex_state = 242},
  [5877] = {.lex_state = 242},
  [5878] = {.lex_state = 239},
  [5879] = {.lex_state = 99},
  [5880] = {.lex_state = 99},
  [5881] = {.lex_state = 238},
  [5882] = {.lex_state = 238},
  [5883] = {.lex_state = 238},
  [5884] = {.lex_state = 241},
  [5885] = {.lex_state = 241},
  [5886] = {.lex_state = 196},
  [5887] = {.lex_state = 241},
  [5888] = {.lex_state = 241},
  [5889] = {.lex_state = 238},
  [5890] = {.lex_state = 238},
  [5891] = {.lex_state = 241},
  [5892] = {.lex_state = 238},
  [5893] = {.lex_state = 242},
  [5894] = {.lex_state = 241},
  [5895] = {.lex_state = 241},
  [5896] = {.lex_state = 241},
  [5897] = {.lex_state = 242},
  [5898] = {.lex_state = 241},
  [5899] = {.lex_state = 241},
  [5900] = {.lex_state = 242},
  [5901] = {.lex_state = 241},
  [5902] = {.lex_state = 238},
  [5903] = {.lex_state = 242},
  [5904] = {.lex_state = 241},
  [5905] = {.lex_state = 238},
  [5906] = {.lex_state = 241},
  [5907] = {.lex_state = 238},
  [5908] = {.lex_state = 241},
  [5909] = {.lex_state = 241},
  [5910] = {.lex_state = 242},
  [5911] = {.lex_state = 241},
  [5912] = {.lex_state = 238},
  [5913] = {.lex_state = 241},
  [5914] = {.lex_state = 238},
  [5915] = {.lex_state = 238},
  [5916] = {.lex_state = 238},
  [5917] = {.lex_state = 196},
  [5918] = {.lex_state = 241},
  [5919] = {.lex_state = 241},
  [5920] = {.lex_state = 238},
  [5921] = {.lex_state = 238},
  [5922] = {.lex_state = 238},
  [5923] = {.lex_state = 196},
  [5924] = {.lex_state = 196},
  [5925] = {.lex_state = 244},
  [5926] = {.lex_state = 241},
  [5927] = {.lex_state = 241},
  [5928] = {.lex_state = 242},
  [5929] = {.lex_state = 241},
  [5930] = {.lex_state = 241},
  [5931] = {.lex_state = 241},
  [5932] = {.lex_state = 241},
  [5933] = {.lex_state = 241},
  [5934] = {.lex_state = 238},
  [5935] = {.lex_state = 241},
  [5936] = {.lex_state = 238},
  [5937] = {.lex_state = 238},
  [5938] = {.lex_state = 244},
  [5939] = {.lex_state = 241},
  [5940] = {.lex_state = 241},
  [5941] = {.lex_state = 242},
  [5942] = {.lex_state = 241},
  [5943] = {.lex_state = 241},
  [5944] = {.lex_state = 241},
  [5945] = {.lex_state = 241},
  [5946] = {.lex_state = 206},
  [5947] = {.lex_state = 194},
  [5948] = {.lex_state = 194},
  [5949] = {.lex_state = 238},
  [5950] = {.lex_state = 242},
  [5951] = {.lex_state = 242},
  [5952] = {.lex_state = 196},
  [5953] = {.lex_state = 242},
  [5954] = {.lex_state = 238},
  [5955] = {.lex_state = 242},
  [5956] = {.lex_state = 241},
  [5957] = {.lex_state = 241},
  [5958] = {.lex_state = 242},
  [5959] = {.lex_state = 234},
  [5960] = {.lex_state = 238},
  [5961] = {.lex_state = 241},
  [5962] = {.lex_state = 194},
  [5963] = {.lex_state = 242},
  [5964] = {.lex_state = 194},
  [5965] = {.lex_state = 238},
  [5966] = {.lex_state = 242},
  [5967] = {.lex_state = 234},
  [5968] = {.lex_state = 246},
  [5969] = {.lex_state = 196},
  [5970] = {.lex_state = 234},
  [5971] = {.lex_state = 175},
  [5972] = {.lex_state = 242},
  [5973] = {.lex_state = 246},
  [5974] = {.lex_state = 241},
  [5975] = {.lex_state = 196},
  [5976] = {.lex_state = 241},
  [5977] = {.lex_state = 234},
  [5978] = {.lex_state = 242},
  [5979] = {.lex_state = 242},
  [5980] = {.lex_state = 242},
  [5981] = {.lex_state = 242},
  [5982] = {.lex_state = 242},
  [5983] = {.lex_state = 196},
  [5984] = {.lex_state = 244},
  [5985] = {.lex_state = 200},
  [5986] = {.lex_state = 239},
  [5987] = {.lex_state = 239},
  [5988] = {.lex_state = 244},
  [5989] = {.lex_state = 242},
  [5990] = {.lex_state = 244},
  [5991] = {.lex_state = 242},
  [5992] = {.lex_state = 239},
  [5993] = {.lex_state = 196},
  [5994] = {.lex_state = 242},
  [5995] = {.lex_state = 242},
  [5996] = {.lex_state = 196},
  [5997] = {.lex_state = 239},
  [5998] = {.lex_state = 242},
  [5999] = {.lex_state = 244},
  [6000] = {.lex_state = 239},
  [6001] = {.lex_state = 238},
  [6002] = {.lex_state = 239},
  [6003] = {.lex_state = 238},
  [6004] = {.lex_state = 238},
  [6005] = {.lex_state = 238},
  [6006] = {.lex_state = 238},
  [6007] = {.lex_state = 238},
  [6008] = {.lex_state = 238},
  [6009] = {.lex_state = 238},
  [6010] = {.lex_state = 242},
  [6011] = {.lex_state = 196},
  [6012] = {.lex_state = 244},
  [6013] = {.lex_state = 200},
  [6014] = {.lex_state = 239},
  [6015] = {.lex_state = 244},
  [6016] = {.lex_state = 244},
  [6017] = {.lex_state = 244},
  [6018] = {.lex_state = 244},
  [6019] = {.lex_state = 200},
  [6020] = {.lex_state = 200},
  [6021] = {.lex_state = 239},
  [6022] = {.lex_state = 239},
  [6023] = {.lex_state = 196},
  [6024] = {.lex_state = 242},
  [6025] = {.lex_state = 242},
  [6026] = {.lex_state = 242},
  [6027] = {.lex_state = 242},
  [6028] = {.lex_state = 242},
  [6029] = {.lex_state = 242},
  [6030] = {.lex_state = 239},
  [6031] = {.lex_state = 196},
  [6032] = {.lex_state = 244},
  [6033] = {.lex_state = 200},
  [6034] = {.lex_state = 200},
  [6035] = {.lex_state = 242},
  [6036] = {.lex_state = 196},
  [6037] = {.lex_state = 239},
  [6038] = {.lex_state = 200},
  [6039] = {.lex_state = 175},
  [6040] = {.lex_state = 196},
  [6041] = {.lex_state = 244},
  [6042] = {.lex_state = 200},
  [6043] = {.lex_state = 196},
  [6044] = {.lex_state = 239},
  [6045] = {.lex_state = 244},
  [6046] = {.lex_state = 200},
  [6047] = {.lex_state = 244},
  [6048] = {.lex_state = 244},
  [6049] = {.lex_state = 244},
  [6050] = {.lex_state = 242},
  [6051] = {.lex_state = 242},
  [6052] = {.lex_state = 242},
  [6053] = {.lex_state = 242},
  [6054] = {.lex_state = 242},
  [6055] = {.lex_state = 242},
  [6056] = {.lex_state = 242},
  [6057] = {.lex_state = 242},
  [6058] = {.lex_state = 242},
  [6059] = {.lex_state = 242},
  [6060] = {.lex_state = 239},
  [6061] = {.lex_state = 242},
  [6062] = {.lex_state = 242},
  [6063] = {.lex_state = 200},
  [6064] = {.lex_state = 200},
  [6065] = {.lex_state = 239},
  [6066] = {.lex_state = 242},
  [6067] = {.lex_state = 200},
  [6068] = {.lex_state = 242},
  [6069] = {.lex_state = 239},
  [6070] = {.lex_state = 239},
  [6071] = {.lex_state = 244},
  [6072] = {.lex_state = 242},
  [6073] = {.lex_state = 244},
  [6074] = {.lex_state = 244},
  [6075] = {.lex_state = 242},
  [6076] = {.lex_state = 244},
  [6077] = {.lex_state = 242},
  [6078] = {.lex_state = 242},
  [6079] = {.lex_state = 242},
  [6080] = {.lex_state = 242},
  [6081] = {.lex_state = 242},
  [6082] = {.lex_state = 242},
  [6083] = {.lex_state = 242},
  [6084] = {.lex_state = 242},
  [6085] = {.lex_state = 242},
  [6086] = {.lex_state = 239},
  [6087] = {.lex_state = 244},
  [6088] = {.lex_state = 242},
  [6089] = {.lex_state = 242},
  [6090] = {.lex_state = 239},
  [6091] = {.lex_state = 239},
  [6092] = {.lex_state = 244},
  [6093] = {.lex_state = 188},
  [6094] = {.lex_state = 197},
  [6095] = {.lex_state = 197},
  [6096] = {.lex_state = 197},
  [6097] = {.lex_state = 197},
  [6098] = {.lex_state = 242},
  [6099] = {.lex_state = 241},
  [6100] = {.lex_state = 197},
  [6101] = {.lex_state = 197},
  [6102] = {.lex_state = 197},
  [6103] = {.lex_state = 197},
  [6104] = {.lex_state = 241},
  [6105] = {.lex_state = 196},
  [6106] = {.lex_state = 242},
  [6107] = {.lex_state = 242},
  [6108] = {.lex_state = 241},
  [6109] = {.lex_state = 188},
  [6110] = {.lex_state = 197},
  [6111] = {.lex_state = 188},
  [6112] = {.lex_state = 241},
  [6113] = {.lex_state = 217},
  [6114] = {.lex_state = 217},
  [6115] = {.lex_state = 217},
  [6116] = {.lex_state = 217},
  [6117] = {.lex_state = 241},
  [6118] = {.lex_state = 197},
  [6119] = {.lex_state = 197},
  [6120] = {.lex_state = 188},
  [6121] = {.lex_state = 188},
  [6122] = {.lex_state = 217},
  [6123] = {.lex_state = 217},
  [6124] = {.lex_state = 217},
  [6125] = {.lex_state = 217},
  [6126] = {.lex_state = 188},
  [6127] = {.lex_state = 241},
  [6128] = {.lex_state = 188},
  [6129] = {.lex_state = 188},
  [6130] = {.lex_state = 241},
  [6131] = {.lex_state = 188},
  [6132] = {.lex_state = 196},
  [6133] = {.lex_state = 197},
  [6134] = {.lex_state = 188},
  [6135] = {.lex_state = 242},
  [6136] = {.lex_state = 188},
  [6137] = {.lex_state = 242},
  [6138] = {.lex_state = 188},
  [6139] = {.lex_state = 197},
  [6140] = {.lex_state = 204},
  [6141] = {.lex_state = 242},
  [6142] = {.lex_state = 238},
  [6143] = {.lex_state = 196},
  [6144] = {.lex_state = 181},
  [6145] = {.lex_state = 188},
  [6146] = {.lex_state = 242},
  [6147] = {.lex_state = 238},
  [6148] = {.lex_state = 196},
  [6149] = {.lex_state = 238},
  [6150] = {.lex_state = 197},
  [6151] = {.lex_state = 188},
  [6152] = {.lex_state = 242},
  [6153] = {.lex_state = 241},
  [6154] = {.lex_state = 188},
  [6155] = {.lex_state = 242},
  [6156] = {.lex_state = 196},
  [6157] = {.lex_state = 196},
  [6158] = {.lex_state = 188},
  [6159] = {.lex_state = 188},
  [6160] = {.lex_state = 188},
  [6161] = {.lex_state = 188},
  [6162] = {.lex_state = 196},
  [6163] = {.lex_state = 197},
  [6164] = {.lex_state = 188},
  [6165] = {.lex_state = 188},
  [6166] = {.lex_state = 196},
  [6167] = {.lex_state = 238},
  [6168] = {.lex_state = 238},
  [6169] = {.lex_state = 197},
  [6170] = {.lex_state = 188},
  [6171] = {.lex_state = 242},
  [6172] = {.lex_state = 196},
  [6173] = {.lex_state = 238},
  [6174] = {.lex_state = 242},
  [6175] = {.lex_state = 217},
  [6176] = {.lex_state = 238},
  [6177] = {.lex_state = 217},
  [6178] = {.lex_state = 217},
  [6179] = {.lex_state = 196},
  [6180] = {.lex_state = 196},
  [6181] = {.lex_state = 196},
  [6182] = {.lex_state = 205},
  [6183] = {.lex_state = 196},
  [6184] = {.lex_state = 242},
  [6185] = {.lex_state = 196},
  [6186] = {.lex_state = 196},
  [6187] = {.lex_state = 217},
  [6188] = {.lex_state = 217},
  [6189] = {.lex_state = 217},
  [6190] = {.lex_state = 217},
  [6191] = {.lex_state = 217},
  [6192] = {.lex_state = 196},
  [6193] = {.lex_state = 196},
  [6194] = {.lex_state = 196},
  [6195] = {.lex_state = 196},
  [6196] = {.lex_state = 217},
  [6197] = {.lex_state = 196},
  [6198] = {.lex_state = 196},
  [6199] = {.lex_state = 238},
  [6200] = {.lex_state = 238},
  [6201] = {.lex_state = 238},
  [6202] = {.lex_state = 238},
  [6203] = {.lex_state = 238},
  [6204] = {.lex_state = 238},
  [6205] = {.lex_state = 238},
  [6206] = {.lex_state = 238},
  [6207] = {.lex_state = 217},
  [6208] = {.lex_state = 238},
  [6209] = {.lex_state = 217},
  [6210] = {.lex_state = 196},
  [6211] = {.lex_state = 217},
  [6212] = {.lex_state = 217},
  [6213] = {.lex_state = 217},
  [6214] = {.lex_state = 242},
  [6215] = {.lex_state = 196},
  [6216] = {.lex_state = 242},
  [6217] = {.lex_state = 242},
  [6218] = {.lex_state = 242},
  [6219] = {.lex_state = 196},
  [6220] = {.lex_state = 238},
  [6221] = {.lex_state = 196},
  [6222] = {.lex_state = 242},
  [6223] = {.lex_state = 238},
  [6224] = {.lex_state = 242},
  [6225] = {.lex_state = 242},
  [6226] = {.lex_state = 196},
  [6227] = {.lex_state = 242},
  [6228] = {.lex_state = 196},
  [6229] = {.lex_state = 217},
  [6230] = {.lex_state = 217},
  [6231] = {.lex_state = 242},
  [6232] = {.lex_state = 242},
  [6233] = {.lex_state = 196},
  [6234] = {.lex_state = 196},
  [6235] = {.lex_state = 217},
  [6236] = {.lex_state = 238},
  [6237] = {.lex_state = 196},
  [6238] = {.lex_state = 196},
  [6239] = {.lex_state = 217},
  [6240] = {.lex_state = 196},
  [6241] = {.lex_state = 196},
  [6242] = {.lex_state = 242},
  [6243] = {.lex_state = 196},
  [6244] = {.lex_state = 234},
  [6245] = {.lex_state = 196},
  [6246] = {.lex_state = 196},
  [6247] = {.lex_state = 242},
  [6248] = {.lex_state = 196},
  [6249] = {.lex_state = 196},
  [6250] = {.lex_state = 234},
  [6251] = {.lex_state = 196},
  [6252] = {.lex_state = 196},
  [6253] = {.lex_state = 217},
  [6254] = {.lex_state = 196},
  [6255] = {.lex_state = 196},
  [6256] = {.lex_state = 196},
  [6257] = {.lex_state = 242},
  [6258] = {.lex_state = 238},
  [6259] = {.lex_state = 234},
  [6260] = {.lex_state = 196},
  [6261] = {.lex_state = 196},
  [6262] = {.lex_state = 238},
  [6263] = {.lex_state = 196},
  [6264] = {.lex_state = 196},
  [6265] = {.lex_state = 196},
  [6266] = {.lex_state = 238},
  [6267] = {.lex_state = 196},
  [6268] = {.lex_state = 217},
  [6269] = {.lex_state = 234},
  [6270] = {.lex_state = 196},
  [6271] = {.lex_state = 242},
  [6272] = {.lex_state = 196},
  [6273] = {.lex_state = 238},
  [6274] = {.lex_state = 242},
  [6275] = {.lex_state = 242},
  [6276] = {.lex_state = 242},
  [6277] = {.lex_state = 196},
  [6278] = {.lex_state = 242},
  [6279] = {.lex_state = 194},
  [6280] = {.lex_state = 194},
  [6281] = {.lex_state = 242},
  [6282] = {.lex_state = 175},
  [6283] = {.lex_state = 242},
  [6284] = {.lex_state = 242},
  [6285] = {.lex_state = 196},
  [6286] = {.lex_state = 241},
  [6287] = {.lex_state = 241},
  [6288] = {.lex_state = 241},
  [6289] = {.lex_state = 241},
  [6290] = {.lex_state = 241},
  [6291] = {.lex_state = 241},
  [6292] = {.lex_state = 241},
  [6293] = {.lex_state = 241},
  [6294] = {.lex_state = 238},
  [6295] = {.lex_state = 194},
  [6296] = {.lex_state = 242},
  [6297] = {.lex_state = 194},
  [6298] = {.lex_state = 242},
  [6299] = {.lex_state = 242},
  [6300] = {.lex_state = 242},
  [6301] = {.lex_state = 238},
  [6302] = {.lex_state = 196},
  [6303] = {.lex_state = 175},
  [6304] = {.lex_state = 242},
  [6305] = {.lex_state = 242},
  [6306] = {.lex_state = 242},
  [6307] = {.lex_state = 196},
  [6308] = {.lex_state = 242},
  [6309] = {.lex_state = 194},
  [6310] = {.lex_state = 242},
  [6311] = {.lex_state = 175},
  [6312] = {.lex_state = 194},
  [6313] = {.lex_state = 238},
  [6314] = {.lex_state = 198},
  [6315] = {.lex_state = 198},
  [6316] = {.lex_state = 198},
  [6317] = {.lex_state = 198},
  [6318] = {.lex_state = 196},
  [6319] = {.lex_state = 238},
  [6320] = {.lex_state = 194},
  [6321] = {.lex_state = 194},
  [6322] = {.lex_state = 196},
  [6323] = {.lex_state = 194},
  [6324] = {.lex_state = 194},
  [6325] = {.lex_state = 194},
  [6326] = {.lex_state = 242},
  [6327] = {.lex_state = 196},
  [6328] = {.lex_state = 194},
  [6329] = {.lex_state = 194},
  [6330] = {.lex_state = 198},
  [6331] = {.lex_state = 242},
  [6332] = {.lex_state = 194},
  [6333] = {.lex_state = 198},
  [6334] = {.lex_state = 198},
  [6335] = {.lex_state = 198},
  [6336] = {.lex_state = 194},
  [6337] = {.lex_state = 194},
  [6338] = {.lex_state = 194},
  [6339] = {.lex_state = 196},
  [6340] = {.lex_state = 242},
  [6341] = {.lex_state = 242},
  [6342] = {.lex_state = 242},
  [6343] = {.lex_state = 194},
  [6344] = {.lex_state = 242},
  [6345] = {.lex_state = 242},
  [6346] = {.lex_state = 194},
  [6347] = {.lex_state = 242},
  [6348] = {.lex_state = 194},
  [6349] = {.lex_state = 238},
  [6350] = {.lex_state = 196},
  [6351] = {.lex_state = 200},
  [6352] = {.lex_state = 196},
  [6353] = {.lex_state = 196},
  [6354] = {.lex_state = 196},
  [6355] = {.lex_state = 196},
  [6356] = {.lex_state = 204},
  [6357] = {.lex_state = 242},
  [6358] = {.lex_state = 200},
  [6359] = {.lex_state = 196},
  [6360] = {.lex_state = 200},
  [6361] = {.lex_state = 200},
  [6362] = {.lex_state = 197},
  [6363] = {.lex_state = 200},
  [6364] = {.lex_state = 196},
  [6365] = {.lex_state = 242},
  [6366] = {.lex_state = 196},
  [6367] = {.lex_state = 196},
  [6368] = {.lex_state = 196},
  [6369] = {.lex_state = 242},
  [6370] = {.lex_state = 200},
  [6371] = {.lex_state = 196},
  [6372] = {.lex_state = 200},
  [6373] = {.lex_state = 200},
  [6374] = {.lex_state = 196},
  [6375] = {.lex_state = 196},
  [6376] = {.lex_state = 196},
  [6377] = {.lex_state = 197},
  [6378] = {.lex_state = 242},
  [6379] = {.lex_state = 196},
  [6380] = {.lex_state = 242},
  [6381] = {.lex_state = 242},
  [6382] = {.lex_state = 196},
  [6383] = {.lex_state = 196},
  [6384] = {.lex_state = 197},
  [6385] = {.lex_state = 196},
  [6386] = {.lex_state = 196},
  [6387] = {.lex_state = 196},
  [6388] = {.lex_state = 197},
  [6389] = {.lex_state = 196},
  [6390] = {.lex_state = 196},
  [6391] = {.lex_state = 196},
  [6392] = {.lex_state = 196},
  [6393] = {.lex_state = 196},
  [6394] = {.lex_state = 0},
  [6395] = {.lex_state = 196},
  [6396] = {.lex_state = 196},
  [6397] = {.lex_state = 196},
  [6398] = {.lex_state = 242},
  [6399] = {.lex_state = 242},
  [6400] = {.lex_state = 196},
  [6401] = {.lex_state = 242},
  [6402] = {.lex_state = 196},
  [6403] = {.lex_state = 242},
  [6404] = {.lex_state = 196},
  [6405] = {.lex_state = 197},
  [6406] = {.lex_state = 196},
  [6407] = {.lex_state = 241},
  [6408] = {.lex_state = 229},
  [6409] = {.lex_state = 197},
  [6410] = {.lex_state = 196},
  [6411] = {.lex_state = 196},
  [6412] = {.lex_state = 196},
  [6413] = {.lex_state = 217},
  [6414] = {.lex_state = 196},
  [6415] = {.lex_state = 196},
  [6416] = {.lex_state = 196},
  [6417] = {.lex_state = 217},
  [6418] = {.lex_state = 217},
  [6419] = {.lex_state = 196},
  [6420] = {.lex_state = 241},
  [6421] = {.lex_state = 217},
  [6422] = {.lex_state = 196},
  [6423] = {.lex_state = 196},
  [6424] = {.lex_state = 196},
  [6425] = {.lex_state = 196},
  [6426] = {.lex_state = 241},
  [6427] = {.lex_state = 196},
  [6428] = {.lex_state = 196},
  [6429] = {.lex_state = 196},
  [6430] = {.lex_state = 196},
  [6431] = {.lex_state = 196},
  [6432] = {.lex_state = 196},
  [6433] = {.lex_state = 242},
  [6434] = {.lex_state = 242},
  [6435] = {.lex_state = 194},
  [6436] = {.lex_state = 241},
  [6437] = {.lex_state = 196},
  [6438] = {.lex_state = 242},
  [6439] = {.lex_state = 196},
  [6440] = {.lex_state = 196},
  [6441] = {.lex_state = 241},
  [6442] = {.lex_state = 196},
  [6443] = {.lex_state = 238},
  [6444] = {.lex_state = 196},
  [6445] = {.lex_state = 196},
  [6446] = {.lex_state = 242},
  [6447] = {.lex_state = 196},
  [6448] = {.lex_state = 196},
  [6449] = {.lex_state = 198},
  [6450] = {.lex_state = 197},
  [6451] = {.lex_state = 196},
  [6452] = {.lex_state = 241},
  [6453] = {.lex_state = 235},
  [6454] = {.lex_state = 196},
  [6455] = {.lex_state = 198},
  [6456] = {.lex_state = 196},
  [6457] = {.lex_state = 198},
  [6458] = {.lex_state = 198},
  [6459] = {.lex_state = 196},
  [6460] = {.lex_state = 198},
  [6461] = {.lex_state = 196},
  [6462] = {.lex_state = 196},
  [6463] = {.lex_state = 196},
  [6464] = {.lex_state = 217},
  [6465] = {.lex_state = 197},
  [6466] = {.lex_state = 197},
  [6467] = {.lex_state = 197},
  [6468] = {.lex_state = 197},
  [6469] = {.lex_state = 198},
  [6470] = {.lex_state = 217},
  [6471] = {.lex_state = 198},
  [6472] = {.lex_state = 242},
  [6473] = {.lex_state = 235},
  [6474] = {.lex_state = 196},
  [6475] = {.lex_state = 196},
  [6476] = {.lex_state = 198},
  [6477] = {.lex_state = 198},
  [6478] = {.lex_state = 196},
  [6479] = {.lex_state = 198},
  [6480] = {.lex_state = 196},
  [6481] = {.lex_state = 196},
  [6482] = {.lex_state = 196},
  [6483] = {.lex_state = 196},
  [6484] = {.lex_state = 198},
  [6485] = {.lex_state = 196},
  [6486] = {.lex_state = 217},
  [6487] = {.lex_state = 198},
  [6488] = {.lex_state = 196},
  [6489] = {.lex_state = 196},
  [6490] = {.lex_state = 242},
  [6491] = {.lex_state = 238},
  [6492] = {.lex_state = 242},
  [6493] = {.lex_state = 196},
  [6494] = {.lex_state = 196},
  [6495] = {.lex_state = 196},
  [6496] = {.lex_state = 196},
  [6497] = {.lex_state = 197},
  [6498] = {.lex_state = 238},
  [6499] = {.lex_state = 196},
  [6500] = {.lex_state = 238},
  [6501] = {.lex_state = 196},
  [6502] = {.lex_state = 196},
  [6503] = {.lex_state = 197},
  [6504] = {.lex_state = 196},
  [6505] = {.lex_state = 197},
  [6506] = {.lex_state = 238},
  [6507] = {.lex_state = 197},
  [6508] = {.lex_state = 197},
  [6509] = {.lex_state = 196},
  [6510] = {.lex_state = 241},
  [6511] = {.lex_state = 196},
  [6512] = {.lex_state = 229},
  [6513] = {.lex_state = 196},
  [6514] = {.lex_state = 196},
  [6515] = {.lex_state = 196},
  [6516] = {.lex_state = 197},
  [6517] = {.lex_state = 197},
  [6518] = {.lex_state = 196},
  [6519] = {.lex_state = 241},
  [6520] = {.lex_state = 196},
  [6521] = {.lex_state = 197},
  [6522] = {.lex_state = 217},
  [6523] = {.lex_state = 196},
  [6524] = {.lex_state = 197},
  [6525] = {.lex_state = 194},
  [6526] = {.lex_state = 197},
  [6527] = {.lex_state = 196},
  [6528] = {.lex_state = 238},
  [6529] = {.lex_state = 238},
  [6530] = {.lex_state = 238},
  [6531] = {.lex_state = 238},
  [6532] = {.lex_state = 238},
  [6533] = {.lex_state = 238},
  [6534] = {.lex_state = 238},
  [6535] = {.lex_state = 238},
  [6536] = {.lex_state = 197},
  [6537] = {.lex_state = 241},
  [6538] = {.lex_state = 241},
  [6539] = {.lex_state = 241},
  [6540] = {.lex_state = 217},
  [6541] = {.lex_state = 217},
  [6542] = {.lex_state = 217},
  [6543] = {.lex_state = 217},
  [6544] = {.lex_state = 194},
  [6545] = {.lex_state = 217},
  [6546] = {.lex_state = 217},
  [6547] = {.lex_state = 217},
  [6548] = {.lex_state = 217},
  [6549] = {.lex_state = 196},
  [6550] = {.lex_state = 194},
  [6551] = {.lex_state = 196},
  [6552] = {.lex_state = 339},
  [6553] = {.lex_state = 194},
  [6554] = {.lex_state = 196},
  [6555] = {.lex_state = 194},
  [6556] = {.lex_state = 194},
  [6557] = {.lex_state = 196},
  [6558] = {.lex_state = 181},
  [6559] = {.lex_state = 194},
  [6560] = {.lex_state = 196},
  [6561] = {.lex_state = 194},
  [6562] = {.lex_state = 197},
  [6563] = {.lex_state = 181},
  [6564] = {.lex_state = 194},
  [6565] = {.lex_state = 197},
  [6566] = {.lex_state = 194},
  [6567] = {.lex_state = 197},
  [6568] = {.lex_state = 197},
  [6569] = {.lex_state = 217},
  [6570] = {.lex_state = 194},
  [6571] = {.lex_state = 194},
  [6572] = {.lex_state = 196},
  [6573] = {.lex_state = 241},
  [6574] = {.lex_state = 194},
  [6575] = {.lex_state = 198},
  [6576] = {.lex_state = 339},
  [6577] = {.lex_state = 235},
  [6578] = {.lex_state = 196},
  [6579] = {.lex_state = 196},
  [6580] = {.lex_state = 196},
  [6581] = {.lex_state = 196},
  [6582] = {.lex_state = 196},
  [6583] = {.lex_state = 196},
  [6584] = {.lex_state = 196},
  [6585] = {.lex_state = 196},
  [6586] = {.lex_state = 196},
  [6587] = {.lex_state = 196},
  [6588] = {.lex_state = 235},
  [6589] = {.lex_state = 196},
  [6590] = {.lex_state = 196},
  [6591] = {.lex_state = 196},
  [6592] = {.lex_state = 196},
  [6593] = {.lex_state = 196},
  [6594] = {.lex_state = 196},
  [6595] = {.lex_state = 196},
  [6596] = {.lex_state = 196},
  [6597] = {.lex_state = 196},
  [6598] = {.lex_state = 196},
  [6599] = {.lex_state = 196},
  [6600] = {.lex_state = 196},
  [6601] = {.lex_state = 196},
  [6602] = {.lex_state = 196},
  [6603] = {.lex_state = 235},
  [6604] = {.lex_state = 196},
  [6605] = {.lex_state = 196},
  [6606] = {.lex_state = 196},
  [6607] = {.lex_state = 339},
  [6608] = {.lex_state = 339},
  [6609] = {.lex_state = 339},
  [6610] = {.lex_state = 196},
  [6611] = {.lex_state = 339},
  [6612] = {.lex_state = 196},
  [6613] = {.lex_state = 196},
  [6614] = {.lex_state = 339},
  [6615] = {.lex_state = 196},
  [6616] = {.lex_state = 198},
  [6617] = {.lex_state = 196},
  [6618] = {.lex_state = 196},
  [6619] = {.lex_state = 198},
  [6620] = {.lex_state = 196},
  [6621] = {.lex_state = 198},
  [6622] = {.lex_state = 198},
  [6623] = {.lex_state = 198},
  [6624] = {.lex_state = 198},
  [6625] = {.lex_state = 198},
  [6626] = {.lex_state = 196},
  [6627] = {.lex_state = 196},
  [6628] = {.lex_state = 196},
  [6629] = {.lex_state = 196},
  [6630] = {.lex_state = 196},
  [6631] = {.lex_state = 196},
  [6632] = {.lex_state = 196},
  [6633] = {.lex_state = 196},
  [6634] = {.lex_state = 196},
  [6635] = {.lex_state = 235},
  [6636] = {.lex_state = 339},
  [6637] = {.lex_state = 194},
  [6638] = {.lex_state = 200},
  [6639] = {.lex_state = 339},
  [6640] = {.lex_state = 200},
  [6641] = {.lex_state = 198},
  [6642] = {.lex_state = 198},
  [6643] = {.lex_state = 196},
  [6644] = {.lex_state = 339},
  [6645] = {.lex_state = 175},
  [6646] = {.lex_state = 175},
  [6647] = {.lex_state = 194},
  [6648] = {.lex_state = 197},
  [6649] = {.lex_state = 175},
  [6650] = {.lex_state = 200},
  [6651] = {.lex_state = 238},
  [6652] = {.lex_state = 198},
  [6653] = {.lex_state = 238},
  [6654] = {.lex_state = 197},
  [6655] = {.lex_state = 217},
  [6656] = {.lex_state = 200},
  [6657] = {.lex_state = 339},
  [6658] = {.lex_state = 217},
  [6659] = {.lex_state = 238},
  [6660] = {.lex_state = 339},
  [6661] = {.lex_state = 243},
  [6662] = {.lex_state = 198},
  [6663] = {.lex_state = 339},
  [6664] = {.lex_state = 197},
  [6665] = {.lex_state = 196},
  [6666] = {.lex_state = 197},
  [6667] = {.lex_state = 196},
  [6668] = {.lex_state = 196},
  [6669] = {.lex_state = 196},
  [6670] = {.lex_state = 198},
  [6671] = {.lex_state = 339},
  [6672] = {.lex_state = 339},
  [6673] = {.lex_state = 175},
  [6674] = {.lex_state = 175},
  [6675] = {.lex_state = 175},
  [6676] = {.lex_state = 196},
  [6677] = {.lex_state = 339},
  [6678] = {.lex_state = 241},
  [6679] = {.lex_state = 339},
  [6680] = {.lex_state = 175},
  [6681] = {.lex_state = 339},
  [6682] = {.lex_state = 241},
  [6683] = {.lex_state = 339},
  [6684] = {.lex_state = 241},
  [6685] = {.lex_state = 339},
  [6686] = {.lex_state = 339},
  [6687] = {.lex_state = 175},
  [6688] = {.lex_state = 339},
  [6689] = {.lex_state = 198},
  [6690] = {.lex_state = 175},
  [6691] = {.lex_state = 339},
  [6692] = {.lex_state = 339},
  [6693] = {.lex_state = 339},
  [6694] = {.lex_state = 339},
  [6695] = {.lex_state = 196},
  [6696] = {.lex_state = 200},
  [6697] = {.lex_state = 196},
  [6698] = {.lex_state = 241},
  [6699] = {.lex_state = 339},
  [6700] = {.lex_state = 175},
  [6701] = {.lex_state = 241},
  [6702] = {.lex_state = 200},
  [6703] = {.lex_state = 200},
  [6704] = {.lex_state = 200},
  [6705] = {.lex_state = 196},
  [6706] = {.lex_state = 196},
  [6707] = {.lex_state = 196},
  [6708] = {.lex_state = 339},
  [6709] = {.lex_state = 339},
  [6710] = {.lex_state = 339},
  [6711] = {.lex_state = 339},
  [6712] = {.lex_state = 217},
  [6713] = {.lex_state = 339},
  [6714] = {.lex_state = 196},
  [6715] = {.lex_state = 339},
  [6716] = {.lex_state = 217},
  [6717] = {.lex_state = 339},
  [6718] = {.lex_state = 175},
  [6719] = {.lex_state = 196},
  [6720] = {.lex_state = 217},
  [6721] = {.lex_state = 339},
  [6722] = {.lex_state = 196},
  [6723] = {.lex_state = 198},
  [6724] = {.lex_state = 339},
  [6725] = {.lex_state = 196},
  [6726] = {.lex_state = 196},
  [6727] = {.lex_state = 198},
  [6728] = {.lex_state = 175},
  [6729] = {.lex_state = 241},
  [6730] = {.lex_state = 196},
  [6731] = {.lex_state = 198},
  [6732] = {.lex_state = 196},
  [6733] = {.lex_state = 196},
  [6734] = {.lex_state = 339},
  [6735] = {.lex_state = 339},
  [6736] = {.lex_state = 196},
  [6737] = {.lex_state = 175},
  [6738] = {.lex_state = 196},
  [6739] = {.lex_state = 196},
  [6740] = {.lex_state = 196},
  [6741] = {.lex_state = 175},
  [6742] = {.lex_state = 196},
  [6743] = {.lex_state = 339},
  [6744] = {.lex_state = 339},
  [6745] = {.lex_state = 196},
  [6746] = {.lex_state = 196},
  [6747] = {.lex_state = 196},
  [6748] = {.lex_state = 196},
  [6749] = {.lex_state = 198},
  [6750] = {.lex_state = 196},
  [6751] = {.lex_state = 196},
  [6752] = {.lex_state = 196},
  [6753] = {.lex_state = 198},
  [6754] = {.lex_state = 196},
  [6755] = {.lex_state = 175},
  [6756] = {.lex_state = 175},
  [6757] = {.lex_state = 339},
  [6758] = {.lex_state = 175},
  [6759] = {.lex_state = 217},
  [6760] = {.lex_state = 175},
  [6761] = {.lex_state = 196},
  [6762] = {.lex_state = 175},
  [6763] = {.lex_state = 175},
  [6764] = {.lex_state = 196},
  [6765] = {.lex_state = 339},
  [6766] = {.lex_state = 196},
  [6767] = {.lex_state = 238},
  [6768] = {.lex_state = 217},
  [6769] = {.lex_state = 339},
  [6770] = {.lex_state = 196},
  [6771] = {.lex_state = 196},
  [6772] = {.lex_state = 241},
  [6773] = {.lex_state = 339},
  [6774] = {.lex_state = 339},
  [6775] = {.lex_state = 196},
  [6776] = {.lex_state = 194},
  [6777] = {.lex_state = 196},
  [6778] = {.lex_state = 197},
  [6779] = {.lex_state = 197},
  [6780] = {.lex_state = 194},
  [6781] = {.lex_state = 196},
  [6782] = {.lex_state = 198},
  [6783] = {.lex_state = 196},
  [6784] = {.lex_state = 239},
  [6785] = {.lex_state = 238},
  [6786] = {.lex_state = 238},
  [6787] = {.lex_state = 239},
  [6788] = {.lex_state = 197},
  [6789] = {.lex_state = 197},
  [6790] = {.lex_state = 239},
  [6791] = {.lex_state = 196},
  [6792] = {.lex_state = 196},
  [6793] = {.lex_state = 238},
  [6794] = {.lex_state = 197},
  [6795] = {.lex_state = 194},
  [6796] = {.lex_state = 238},
  [6797] = {.lex_state = 196},
  [6798] = {.lex_state = 196},
  [6799] = {.lex_state = 238},
  [6800] = {.lex_state = 339},
  [6801] = {.lex_state = 238},
  [6802] = {.lex_state = 196},
  [6803] = {.lex_state = 196},
  [6804] = {.lex_state = 238},
  [6805] = {.lex_state = 239},
  [6806] = {.lex_state = 196},
  [6807] = {.lex_state = 197},
  [6808] = {.lex_state = 238},
  [6809] = {.lex_state = 194},
  [6810] = {.lex_state = 194},
  [6811] = {.lex_state = 339},
  [6812] = {.lex_state = 196},
  [6813] = {.lex_state = 196},
  [6814] = {.lex_state = 196},
  [6815] = {.lex_state = 196},
  [6816] = {.lex_state = 238},
  [6817] = {.lex_state = 194},
  [6818] = {.lex_state = 196},
  [6819] = {.lex_state = 0},
  [6820] = {.lex_state = 196},
  [6821] = {.lex_state = 196},
  [6822] = {.lex_state = 239},
  [6823] = {.lex_state = 196},
  [6824] = {.lex_state = 194},
  [6825] = {.lex_state = 197},
  [6826] = {.lex_state = 196},
  [6827] = {.lex_state = 238},
  [6828] = {.lex_state = 339},
  [6829] = {.lex_state = 194},
  [6830] = {.lex_state = 196},
  [6831] = {.lex_state = 196},
  [6832] = {.lex_state = 194},
  [6833] = {.lex_state = 238},
  [6834] = {.lex_state = 238},
  [6835] = {.lex_state = 238},
  [6836] = {.lex_state = 0},
  [6837] = {.lex_state = 197},
  [6838] = {.lex_state = 194},
  [6839] = {.lex_state = 238},
  [6840] = {.lex_state = 194},
  [6841] = {.lex_state = 339},
  [6842] = {.lex_state = 196},
  [6843] = {.lex_state = 339},
  [6844] = {.lex_state = 239},
  [6845] = {.lex_state = 196},
  [6846] = {.lex_state = 196},
  [6847] = {.lex_state = 196},
  [6848] = {.lex_state = 196},
  [6849] = {.lex_state = 196},
  [6850] = {.lex_state = 238},
  [6851] = {.lex_state = 196},
  [6852] = {.lex_state = 196},
  [6853] = {.lex_state = 196},
  [6854] = {.lex_state = 196},
  [6855] = {.lex_state = 339},
  [6856] = {.lex_state = 196},
  [6857] = {.lex_state = 199},
  [6858] = {.lex_state = 196},
  [6859] = {.lex_state = 196},
  [6860] = {.lex_state = 196},
  [6861] = {.lex_state = 198},
  [6862] = {.lex_state = 196},
  [6863] = {.lex_state = 199},
  [6864] = {.lex_state = 196},
  [6865] = {.lex_state = 196},
  [6866] = {.lex_state = 196},
  [6867] = {.lex_state = 171},
  [6868] = {.lex_state = 199},
  [6869] = {.lex_state = 196},
  [6870] = {.lex_state = 175},
  [6871] = {.lex_state = 196},
  [6872] = {.lex_state = 198},
  [6873] = {.lex_state = 199},
  [6874] = {.lex_state = 339},
  [6875] = {.lex_state = 196},
  [6876] = {.lex_state = 196},
  [6877] = {.lex_state = 339},
  [6878] = {.lex_state = 196},
  [6879] = {.lex_state = 199},
  [6880] = {.lex_state = 196},
  [6881] = {.lex_state = 196},
  [6882] = {.lex_state = 196},
  [6883] = {.lex_state = 196},
  [6884] = {.lex_state = 196},
  [6885] = {.lex_state = 196},
  [6886] = {.lex_state = 199},
  [6887] = {.lex_state = 196},
  [6888] = {.lex_state = 339},
  [6889] = {.lex_state = 196},
  [6890] = {.lex_state = 196},
  [6891] = {.lex_state = 196},
  [6892] = {.lex_state = 196},
  [6893] = {.lex_state = 196},
  [6894] = {.lex_state = 196},
  [6895] = {.lex_state = 196},
  [6896] = {.lex_state = 198},
  [6897] = {.lex_state = 196},
  [6898] = {.lex_state = 196},
  [6899] = {.lex_state = 196},
  [6900] = {.lex_state = 196},
  [6901] = {.lex_state = 196},
  [6902] = {.lex_state = 196},
  [6903] = {.lex_state = 199},
  [6904] = {.lex_state = 175},
  [6905] = {.lex_state = 199},
  [6906] = {.lex_state = 196},
  [6907] = {.lex_state = 196},
  [6908] = {.lex_state = 196},
  [6909] = {.lex_state = 196},
  [6910] = {.lex_state = 196},
  [6911] = {.lex_state = 196},
  [6912] = {.lex_state = 196},
  [6913] = {.lex_state = 196},
  [6914] = {.lex_state = 171},
  [6915] = {.lex_state = 175},
  [6916] = {.lex_state = 198},
  [6917] = {.lex_state = 217},
  [6918] = {.lex_state = 196},
  [6919] = {.lex_state = 196},
  [6920] = {.lex_state = 196},
  [6921] = {.lex_state = 196},
  [6922] = {.lex_state = 196},
  [6923] = {.lex_state = 198},
  [6924] = {.lex_state = 196},
  [6925] = {.lex_state = 217},
  [6926] = {.lex_state = 196},
  [6927] = {.lex_state = 196},
  [6928] = {.lex_state = 175},
  [6929] = {.lex_state = 196},
  [6930] = {.lex_state = 199},
  [6931] = {.lex_state = 339},
  [6932] = {.lex_state = 196},
  [6933] = {.lex_state = 0},
  [6934] = {.lex_state = 199},
  [6935] = {.lex_state = 199},
  [6936] = {.lex_state = 199},
  [6937] = {.lex_state = 108},
  [6938] = {.lex_state = 0},
  [6939] = {.lex_state = 0},
  [6940] = {.lex_state = 238},
  [6941] = {.lex_state = 198},
  [6942] = {.lex_state = 339},
  [6943] = {.lex_state = 108},
  [6944] = {.lex_state = 110},
  [6945] = {.lex_state = 108},
  [6946] = {.lex_state = 199},
  [6947] = {.lex_state = 108},
  [6948] = {.lex_state = 110},
  [6949] = {.lex_state = 108},
  [6950] = {.lex_state = 108},
  [6951] = {.lex_state = 196},
  [6952] = {.lex_state = 108},
  [6953] = {.lex_state = 111},
  [6954] = {.lex_state = 199},
  [6955] = {.lex_state = 199},
  [6956] = {.lex_state = 339},
  [6957] = {.lex_state = 110},
  [6958] = {.lex_state = 108},
  [6959] = {.lex_state = 111},
  [6960] = {.lex_state = 108},
  [6961] = {.lex_state = 0},
  [6962] = {.lex_state = 199},
  [6963] = {.lex_state = 110},
  [6964] = {.lex_state = 238},
  [6965] = {.lex_state = 199},
  [6966] = {.lex_state = 108},
  [6967] = {.lex_state = 108},
  [6968] = {.lex_state = 111},
  [6969] = {.lex_state = 238},
  [6970] = {.lex_state = 199},
  [6971] = {.lex_state = 339},
  [6972] = {.lex_state = 110},
  [6973] = {.lex_state = 339},
  [6974] = {.lex_state = 339},
  [6975] = {.lex_state = 339},
  [6976] = {.lex_state = 111},
  [6977] = {.lex_state = 200},
  [6978] = {.lex_state = 108},
  [6979] = {.lex_state = 0},
  [6980] = {.lex_state = 238},
  [6981] = {.lex_state = 108},
  [6982] = {.lex_state = 339},
  [6983] = {.lex_state = 110},
  [6984] = {.lex_state = 199},
  [6985] = {.lex_state = 339},
  [6986] = {.lex_state = 339},
  [6987] = {.lex_state = 108},
  [6988] = {.lex_state = 110},
  [6989] = {.lex_state = 108},
  [6990] = {.lex_state = 0},
  [6991] = {.lex_state = 199},
  [6992] = {.lex_state = 339},
  [6993] = {.lex_state = 108},
  [6994] = {.lex_state = 339},
  [6995] = {.lex_state = 199},
  [6996] = {.lex_state = 110},
  [6997] = {.lex_state = 199},
  [6998] = {.lex_state = 108},
  [6999] = {.lex_state = 238},
  [7000] = {.lex_state = 339},
  [7001] = {.lex_state = 339},
  [7002] = {.lex_state = 108},
  [7003] = {.lex_state = 199},
  [7004] = {.lex_state = 339},
  [7005] = {.lex_state = 339},
  [7006] = {.lex_state = 199},
  [7007] = {.lex_state = 108},
  [7008] = {.lex_state = 196},
  [7009] = {.lex_state = 0},
  [7010] = {.lex_state = 199},
  [7011] = {.lex_state = 199},
  [7012] = {.lex_state = 339},
  [7013] = {.lex_state = 199},
  [7014] = {.lex_state = 339},
  [7015] = {.lex_state = 108},
  [7016] = {.lex_state = 199},
  [7017] = {.lex_state = 110},
  [7018] = {.lex_state = 108},
  [7019] = {.lex_state = 339},
  [7020] = {.lex_state = 110},
  [7021] = {.lex_state = 339},
  [7022] = {.lex_state = 339},
  [7023] = {.lex_state = 339},
  [7024] = {.lex_state = 199},
  [7025] = {.lex_state = 0},
  [7026] = {.lex_state = 196},
  [7027] = {.lex_state = 339},
  [7028] = {.lex_state = 199},
  [7029] = {.lex_state = 339},
  [7030] = {.lex_state = 0},
  [7031] = {.lex_state = 196},
  [7032] = {.lex_state = 339},
  [7033] = {.lex_state = 199},
  [7034] = {.lex_state = 339},
  [7035] = {.lex_state = 196},
  [7036] = {.lex_state = 196},
  [7037] = {.lex_state = 339},
  [7038] = {.lex_state = 108},
  [7039] = {.lex_state = 108},
  [7040] = {.lex_state = 0},
  [7041] = {.lex_state = 108},
  [7042] = {.lex_state = 339},
  [7043] = {.lex_state = 238},
  [7044] = {.lex_state = 199},
  [7045] = {.lex_state = 217},
  [7046] = {.lex_state = 339},
  [7047] = {.lex_state = 339},
  [7048] = {.lex_state = 171},
  [7049] = {.lex_state = 108},
  [7050] = {.lex_state = 196},
  [7051] = {.lex_state = 110},
  [7052] = {.lex_state = 238},
  [7053] = {.lex_state = 108},
  [7054] = {.lex_state = 339},
  [7055] = {.lex_state = 339},
  [7056] = {.lex_state = 0},
  [7057] = {.lex_state = 111},
  [7058] = {.lex_state = 196},
  [7059] = {.lex_state = 196},
  [7060] = {.lex_state = 108},
  [7061] = {.lex_state = 108},
  [7062] = {.lex_state = 339},
  [7063] = {.lex_state = 339},
  [7064] = {.lex_state = 108},
  [7065] = {.lex_state = 199},
  [7066] = {.lex_state = 199},
  [7067] = {.lex_state = 196},
  [7068] = {.lex_state = 0},
  [7069] = {.lex_state = 0},
  [7070] = {.lex_state = 238},
  [7071] = {.lex_state = 339},
  [7072] = {.lex_state = 339},
  [7073] = {.lex_state = 108},
  [7074] = {.lex_state = 108},
  [7075] = {.lex_state = 339},
  [7076] = {.lex_state = 339},
  [7077] = {.lex_state = 339},
  [7078] = {.lex_state = 196},
  [7079] = {.lex_state = 339},
  [7080] = {.lex_state = 111},
  [7081] = {.lex_state = 0},
  [7082] = {.lex_state = 108},
  [7083] = {.lex_state = 0},
  [7084] = {.lex_state = 199},
  [7085] = {.lex_state = 196},
  [7086] = {.lex_state = 199},
  [7087] = {.lex_state = 110},
  [7088] = {.lex_state = 111},
  [7089] = {.lex_state = 108},
  [7090] = {.lex_state = 339},
  [7091] = {.lex_state = 196},
  [7092] = {.lex_state = 199},
  [7093] = {.lex_state = 199},
  [7094] = {.lex_state = 0},
  [7095] = {.lex_state = 199},
  [7096] = {.lex_state = 199},
  [7097] = {.lex_state = 339},
  [7098] = {.lex_state = 339},
  [7099] = {.lex_state = 339},
  [7100] = {.lex_state = 339},
  [7101] = {.lex_state = 0},
  [7102] = {.lex_state = 108},
  [7103] = {.lex_state = 339},
  [7104] = {.lex_state = 171},
  [7105] = {.lex_state = 339},
  [7106] = {.lex_state = 0},
  [7107] = {.lex_state = 199},
  [7108] = {.lex_state = 108},
  [7109] = {.lex_state = 196},
  [7110] = {.lex_state = 339},
  [7111] = {.lex_state = 199},
  [7112] = {.lex_state = 199},
  [7113] = {.lex_state = 199},
  [7114] = {.lex_state = 238},
  [7115] = {.lex_state = 238},
  [7116] = {.lex_state = 199},
  [7117] = {.lex_state = 108},
  [7118] = {.lex_state = 339},
  [7119] = {.lex_state = 0},
  [7120] = {.lex_state = 199},
  [7121] = {.lex_state = 339},
  [7122] = {.lex_state = 0},
  [7123] = {.lex_state = 196},
  [7124] = {.lex_state = 108},
  [7125] = {.lex_state = 108},
  [7126] = {.lex_state = 199},
  [7127] = {.lex_state = 199},
  [7128] = {.lex_state = 196},
  [7129] = {.lex_state = 0},
  [7130] = {.lex_state = 108},
  [7131] = {.lex_state = 339},
  [7132] = {.lex_state = 339},
  [7133] = {.lex_state = 339},
  [7134] = {.lex_state = 110},
  [7135] = {.lex_state = 339},
  [7136] = {.lex_state = 171},
  [7137] = {.lex_state = 0},
  [7138] = {.lex_state = 171},
  [7139] = {.lex_state = 0},
  [7140] = {.lex_state = 0},
  [7141] = {.lex_state = 0},
  [7142] = {.lex_state = 199},
  [7143] = {.lex_state = 0},
  [7144] = {.lex_state = 0},
  [7145] = {.lex_state = 199},
  [7146] = {.lex_state = 0},
  [7147] = {.lex_state = 196},
  [7148] = {.lex_state = 196},
  [7149] = {.lex_state = 0},
  [7150] = {.lex_state = 0},
  [7151] = {.lex_state = 0},
  [7152] = {.lex_state = 0},
  [7153] = {.lex_state = 0},
  [7154] = {.lex_state = 199},
  [7155] = {.lex_state = 0},
  [7156] = {.lex_state = 0},
  [7157] = {.lex_state = 0},
  [7158] = {.lex_state = 0},
  [7159] = {.lex_state = 0},
  [7160] = {.lex_state = 196},
  [7161] = {.lex_state = 0},
  [7162] = {.lex_state = 0},
  [7163] = {.lex_state = 0},
  [7164] = {.lex_state = 0},
  [7165] = {.lex_state = 0},
  [7166] = {.lex_state = 0},
  [7167] = {.lex_state = 196},
  [7168] = {.lex_state = 196},
  [7169] = {.lex_state = 196},
  [7170] = {.lex_state = 0},
  [7171] = {.lex_state = 0},
  [7172] = {.lex_state = 0},
  [7173] = {.lex_state = 0},
  [7174] = {.lex_state = 0},
  [7175] = {.lex_state = 0},
  [7176] = {.lex_state = 0},
  [7177] = {.lex_state = 196},
  [7178] = {.lex_state = 0},
  [7179] = {.lex_state = 0},
  [7180] = {.lex_state = 196},
  [7181] = {.lex_state = 0},
  [7182] = {.lex_state = 0},
  [7183] = {.lex_state = 0},
  [7184] = {.lex_state = 171},
  [7185] = {.lex_state = 0},
  [7186] = {.lex_state = 199},
  [7187] = {.lex_state = 199},
  [7188] = {.lex_state = 196},
  [7189] = {.lex_state = 0},
  [7190] = {.lex_state = 0},
  [7191] = {.lex_state = 0},
  [7192] = {.lex_state = 196},
  [7193] = {.lex_state = 0},
  [7194] = {.lex_state = 0},
  [7195] = {.lex_state = 0},
  [7196] = {.lex_state = 0},
  [7197] = {.lex_state = 0},
  [7198] = {.lex_state = 0},
  [7199] = {.lex_state = 0},
  [7200] = {.lex_state = 196},
  [7201] = {.lex_state = 199},
  [7202] = {.lex_state = 196},
  [7203] = {.lex_state = 0},
  [7204] = {.lex_state = 0},
  [7205] = {.lex_state = 0},
  [7206] = {.lex_state = 0},
  [7207] = {.lex_state = 0},
  [7208] = {.lex_state = 196},
  [7209] = {.lex_state = 0},
  [7210] = {.lex_state = 196},
  [7211] = {.lex_state = 0},
  [7212] = {.lex_state = 0},
  [7213] = {.lex_state = 0},
  [7214] = {.lex_state = 0},
  [7215] = {.lex_state = 199},
  [7216] = {.lex_state = 199},
  [7217] = {.lex_state = 196},
  [7218] = {.lex_state = 0},
  [7219] = {.lex_state = 0},
  [7220] = {.lex_state = 0},
  [7221] = {.lex_state = 0},
  [7222] = {.lex_state = 0},
  [7223] = {.lex_state = 0},
  [7224] = {.lex_state = 199},
  [7225] = {.lex_state = 199},
  [7226] = {.lex_state = 0},
  [7227] = {.lex_state = 196},
  [7228] = {.lex_state = 199},
  [7229] = {.lex_state = 0},
  [7230] = {.lex_state = 0},
  [7231] = {.lex_state = 0},
  [7232] = {.lex_state = 0},
  [7233] = {.lex_state = 0},
  [7234] = {.lex_state = 0},
  [7235] = {.lex_state = 199},
  [7236] = {.lex_state = 0},
  [7237] = {.lex_state = 196},
  [7238] = {.lex_state = 0},
  [7239] = {.lex_state = 0},
  [7240] = {.lex_state = 0},
  [7241] = {.lex_state = 0},
  [7242] = {.lex_state = 196},
  [7243] = {.lex_state = 0},
  [7244] = {.lex_state = 196},
  [7245] = {.lex_state = 196},
  [7246] = {.lex_state = 196},
  [7247] = {.lex_state = 199},
  [7248] = {.lex_state = 199},
  [7249] = {.lex_state = 196},
  [7250] = {.lex_state = 0},
  [7251] = {.lex_state = 0},
  [7252] = {.lex_state = 199},
  [7253] = {.lex_state = 196},
  [7254] = {.lex_state = 110},
  [7255] = {.lex_state = 199},
  [7256] = {.lex_state = 0},
  [7257] = {.lex_state = 0},
  [7258] = {.lex_state = 0},
  [7259] = {.lex_state = 339},
  [7260] = {.lex_state = 0},
  [7261] = {.lex_state = 0},
  [7262] = {.lex_state = 0},
  [7263] = {.lex_state = 0},
  [7264] = {.lex_state = 0},
  [7265] = {.lex_state = 0},
  [7266] = {.lex_state = 0},
  [7267] = {.lex_state = 0},
  [7268] = {.lex_state = 196},
  [7269] = {.lex_state = 196},
  [7270] = {.lex_state = 196},
  [7271] = {.lex_state = 0},
  [7272] = {.lex_state = 171},
  [7273] = {.lex_state = 0},
  [7274] = {.lex_state = 0},
  [7275] = {.lex_state = 199},
  [7276] = {.lex_state = 199},
  [7277] = {.lex_state = 0},
  [7278] = {.lex_state = 0},
  [7279] = {.lex_state = 0},
  [7280] = {.lex_state = 196},
  [7281] = {.lex_state = 0},
  [7282] = {.lex_state = 113},
  [7283] = {.lex_state = 0},
  [7284] = {.lex_state = 196},
  [7285] = {.lex_state = 175},
  [7286] = {.lex_state = 199},
  [7287] = {.lex_state = 199},
  [7288] = {.lex_state = 0},
  [7289] = {.lex_state = 0},
  [7290] = {.lex_state = 199},
  [7291] = {.lex_state = 199},
  [7292] = {.lex_state = 196},
  [7293] = {.lex_state = 0},
  [7294] = {.lex_state = 0},
  [7295] = {.lex_state = 0},
  [7296] = {.lex_state = 171},
  [7297] = {.lex_state = 0},
  [7298] = {.lex_state = 0},
  [7299] = {.lex_state = 0},
  [7300] = {.lex_state = 0},
  [7301] = {.lex_state = 0},
  [7302] = {.lex_state = 0},
  [7303] = {.lex_state = 0},
  [7304] = {.lex_state = 0},
  [7305] = {.lex_state = 0},
  [7306] = {.lex_state = 0},
  [7307] = {.lex_state = 0},
  [7308] = {.lex_state = 199},
  [7309] = {.lex_state = 0},
  [7310] = {.lex_state = 0},
  [7311] = {.lex_state = 0},
  [7312] = {.lex_state = 0},
  [7313] = {.lex_state = 339},
  [7314] = {.lex_state = 0},
  [7315] = {.lex_state = 164},
  [7316] = {.lex_state = 196},
  [7317] = {.lex_state = 339},
  [7318] = {.lex_state = 0},
  [7319] = {.lex_state = 199},
  [7320] = {.lex_state = 199},
  [7321] = {.lex_state = 0},
  [7322] = {.lex_state = 0},
  [7323] = {.lex_state = 0},
  [7324] = {.lex_state = 0},
  [7325] = {.lex_state = 0},
  [7326] = {.lex_state = 0},
  [7327] = {.lex_state = 199},
  [7328] = {.lex_state = 199},
  [7329] = {.lex_state = 0},
  [7330] = {.lex_state = 0},
  [7331] = {.lex_state = 0},
  [7332] = {.lex_state = 0},
  [7333] = {.lex_state = 0},
  [7334] = {.lex_state = 196},
  [7335] = {.lex_state = 196},
  [7336] = {.lex_state = 199},
  [7337] = {.lex_state = 199},
  [7338] = {.lex_state = 199},
  [7339] = {.lex_state = 199},
  [7340] = {.lex_state = 199},
  [7341] = {.lex_state = 0},
  [7342] = {.lex_state = 0},
  [7343] = {.lex_state = 0},
  [7344] = {.lex_state = 196},
  [7345] = {.lex_state = 0},
  [7346] = {.lex_state = 0},
  [7347] = {.lex_state = 217},
  [7348] = {.lex_state = 0},
  [7349] = {.lex_state = 0},
  [7350] = {.lex_state = 199},
  [7351] = {.lex_state = 199},
  [7352] = {.lex_state = 199},
  [7353] = {.lex_state = 199},
  [7354] = {.lex_state = 199},
  [7355] = {.lex_state = 196},
  [7356] = {.lex_state = 199},
  [7357] = {.lex_state = 196},
  [7358] = {.lex_state = 110},
  [7359] = {.lex_state = 0},
  [7360] = {.lex_state = 196},
  [7361] = {.lex_state = 196},
  [7362] = {.lex_state = 171},
  [7363] = {.lex_state = 196},
  [7364] = {.lex_state = 0},
  [7365] = {.lex_state = 0},
  [7366] = {.lex_state = 199},
  [7367] = {.lex_state = 0},
  [7368] = {.lex_state = 0},
  [7369] = {.lex_state = 196},
  [7370] = {.lex_state = 199},
  [7371] = {.lex_state = 110},
  [7372] = {.lex_state = 171},
  [7373] = {.lex_state = 0},
  [7374] = {.lex_state = 199},
  [7375] = {.lex_state = 0},
  [7376] = {.lex_state = 0},
  [7377] = {.lex_state = 0},
  [7378] = {.lex_state = 196},
  [7379] = {.lex_state = 196},
  [7380] = {.lex_state = 0},
  [7381] = {.lex_state = 0},
  [7382] = {.lex_state = 196},
  [7383] = {.lex_state = 0},
  [7384] = {.lex_state = 199},
  [7385] = {.lex_state = 171},
  [7386] = {.lex_state = 0},
  [7387] = {.lex_state = 0},
  [7388] = {.lex_state = 0},
  [7389] = {.lex_state = 199},
  [7390] = {.lex_state = 0},
  [7391] = {.lex_state = 199},
  [7392] = {.lex_state = 0},
  [7393] = {.lex_state = 199},
  [7394] = {.lex_state = 0},
  [7395] = {.lex_state = 171},
  [7396] = {.lex_state = 0},
  [7397] = {.lex_state = 0},
  [7398] = {.lex_state = 0},
  [7399] = {.lex_state = 0},
  [7400] = {.lex_state = 0},
  [7401] = {.lex_state = 196},
  [7402] = {.lex_state = 196},
  [7403] = {.lex_state = 110},
  [7404] = {.lex_state = 199},
  [7405] = {.lex_state = 196},
  [7406] = {.lex_state = 196},
  [7407] = {.lex_state = 199},
  [7408] = {.lex_state = 0},
  [7409] = {.lex_state = 196},
  [7410] = {.lex_state = 0},
  [7411] = {.lex_state = 0},
  [7412] = {.lex_state = 0},
  [7413] = {.lex_state = 0},
  [7414] = {.lex_state = 0},
  [7415] = {.lex_state = 199},
  [7416] = {.lex_state = 199},
  [7417] = {.lex_state = 0},
  [7418] = {.lex_state = 0},
  [7419] = {.lex_state = 0},
  [7420] = {.lex_state = 0},
  [7421] = {.lex_state = 199},
  [7422] = {.lex_state = 196},
  [7423] = {.lex_state = 196},
  [7424] = {.lex_state = 110},
  [7425] = {.lex_state = 196},
  [7426] = {.lex_state = 0},
  [7427] = {.lex_state = 196},
  [7428] = {.lex_state = 196},
  [7429] = {.lex_state = 199},
  [7430] = {.lex_state = 199},
  [7431] = {.lex_state = 199},
  [7432] = {.lex_state = 199},
  [7433] = {.lex_state = 0},
  [7434] = {.lex_state = 0},
  [7435] = {.lex_state = 199},
  [7436] = {.lex_state = 0},
  [7437] = {.lex_state = 0},
  [7438] = {.lex_state = 0},
  [7439] = {.lex_state = 0},
  [7440] = {.lex_state = 0},
  [7441] = {.lex_state = 196},
  [7442] = {.lex_state = 196},
  [7443] = {.lex_state = 110},
  [7444] = {.lex_state = 0},
  [7445] = {.lex_state = 0},
  [7446] = {.lex_state = 0},
  [7447] = {.lex_state = 196},
  [7448] = {.lex_state = 196},
  [7449] = {.lex_state = 113},
  [7450] = {.lex_state = 0},
  [7451] = {.lex_state = 0},
  [7452] = {.lex_state = 196},
  [7453] = {.lex_state = 110},
  [7454] = {.lex_state = 0},
  [7455] = {.lex_state = 196},
  [7456] = {.lex_state = 171},
  [7457] = {.lex_state = 196},
  [7458] = {.lex_state = 196},
  [7459] = {.lex_state = 0},
  [7460] = {.lex_state = 196},
  [7461] = {.lex_state = 110},
  [7462] = {.lex_state = 110},
  [7463] = {.lex_state = 196},
  [7464] = {.lex_state = 110},
  [7465] = {.lex_state = 0},
  [7466] = {.lex_state = 110},
  [7467] = {.lex_state = 110},
  [7468] = {.lex_state = 196},
  [7469] = {.lex_state = 0},
  [7470] = {.lex_state = 0},
  [7471] = {.lex_state = 196},
  [7472] = {.lex_state = 196},
  [7473] = {.lex_state = 196},
  [7474] = {.lex_state = 196},
  [7475] = {.lex_state = 196},
  [7476] = {.lex_state = 196},
  [7477] = {.lex_state = 175},
  [7478] = {.lex_state = 175},
  [7479] = {.lex_state = 171},
  [7480] = {.lex_state = 171},
  [7481] = {.lex_state = 0},
  [7482] = {.lex_state = 0},
  [7483] = {.lex_state = 0},
  [7484] = {.lex_state = 113},
  [7485] = {.lex_state = 199},
  [7486] = {.lex_state = 0},
  [7487] = {.lex_state = 0},
  [7488] = {.lex_state = 0},
  [7489] = {.lex_state = 0},
  [7490] = {.lex_state = 0},
  [7491] = {.lex_state = 0},
  [7492] = {.lex_state = 113},
  [7493] = {.lex_state = 196},
  [7494] = {.lex_state = 0},
  [7495] = {.lex_state = 196},
  [7496] = {.lex_state = 196},
  [7497] = {.lex_state = 0},
  [7498] = {.lex_state = 0},
  [7499] = {.lex_state = 0},
  [7500] = {.lex_state = 199},
  [7501] = {.lex_state = 171},
  [7502] = {.lex_state = 199},
  [7503] = {.lex_state = 0},
  [7504] = {.lex_state = 0},
  [7505] = {.lex_state = 0},
  [7506] = {.lex_state = 0},
  [7507] = {.lex_state = 171},
  [7508] = {.lex_state = 196},
  [7509] = {.lex_state = 0},
  [7510] = {.lex_state = 196},
  [7511] = {.lex_state = 199},
  [7512] = {.lex_state = 199},
  [7513] = {.lex_state = 199},
  [7514] = {.lex_state = 196},
  [7515] = {.lex_state = 199},
  [7516] = {.lex_state = 199},
  [7517] = {.lex_state = 0},
  [7518] = {.lex_state = 196},
  [7519] = {.lex_state = 196},
  [7520] = {.lex_state = 196},
  [7521] = {.lex_state = 0},
  [7522] = {.lex_state = 0},
  [7523] = {.lex_state = 0},
  [7524] = {.lex_state = 0},
  [7525] = {.lex_state = 0},
  [7526] = {.lex_state = 171},
  [7527] = {.lex_state = 196},
  [7528] = {.lex_state = 196},
  [7529] = {.lex_state = 196},
  [7530] = {.lex_state = 196},
  [7531] = {.lex_state = 0},
  [7532] = {.lex_state = 196},
  [7533] = {.lex_state = 0},
  [7534] = {.lex_state = 0},
  [7535] = {.lex_state = 171},
  [7536] = {.lex_state = 0},
  [7537] = {.lex_state = 196},
  [7538] = {.lex_state = 0},
  [7539] = {.lex_state = 0},
  [7540] = {.lex_state = 0},
  [7541] = {.lex_state = 0},
  [7542] = {.lex_state = 0},
  [7543] = {.lex_state = 0},
  [7544] = {.lex_state = 196},
  [7545] = {.lex_state = 0},
  [7546] = {.lex_state = 0},
  [7547] = {.lex_state = 171},
  [7548] = {.lex_state = 0},
  [7549] = {.lex_state = 0},
  [7550] = {.lex_state = 0},
  [7551] = {.lex_state = 0},
  [7552] = {.lex_state = 0},
  [7553] = {.lex_state = 0},
  [7554] = {.lex_state = 0},
  [7555] = {.lex_state = 0},
  [7556] = {.lex_state = 196},
  [7557] = {.lex_state = 199},
  [7558] = {.lex_state = 0},
  [7559] = {.lex_state = 196},
  [7560] = {.lex_state = 0},
  [7561] = {.lex_state = 196},
  [7562] = {.lex_state = 0},
  [7563] = {.lex_state = 0},
  [7564] = {.lex_state = 171},
  [7565] = {.lex_state = 0},
  [7566] = {.lex_state = 339},
  [7567] = {.lex_state = 0},
  [7568] = {.lex_state = 339},
  [7569] = {.lex_state = 0},
  [7570] = {.lex_state = 0},
  [7571] = {.lex_state = 0},
  [7572] = {.lex_state = 0},
  [7573] = {.lex_state = 0},
  [7574] = {.lex_state = 0},
  [7575] = {.lex_state = 0},
  [7576] = {.lex_state = 339},
  [7577] = {.lex_state = 0},
  [7578] = {.lex_state = 0},
  [7579] = {.lex_state = 339},
  [7580] = {.lex_state = 0},
  [7581] = {.lex_state = 0},
  [7582] = {.lex_state = 339},
  [7583] = {.lex_state = 0},
  [7584] = {.lex_state = 0},
  [7585] = {.lex_state = 0},
  [7586] = {.lex_state = 0},
  [7587] = {.lex_state = 0},
  [7588] = {.lex_state = 112},
  [7589] = {.lex_state = 339},
  [7590] = {.lex_state = 0},
  [7591] = {.lex_state = 196},
  [7592] = {.lex_state = 196},
  [7593] = {.lex_state = 339},
  [7594] = {.lex_state = 0},
  [7595] = {.lex_state = 0},
  [7596] = {.lex_state = 0},
  [7597] = {.lex_state = 0},
  [7598] = {.lex_state = 0},
  [7599] = {.lex_state = 0},
  [7600] = {.lex_state = 0},
  [7601] = {.lex_state = 0},
  [7602] = {.lex_state = 0},
  [7603] = {.lex_state = 339},
  [7604] = {.lex_state = 0},
  [7605] = {.lex_state = 0},
  [7606] = {.lex_state = 0},
  [7607] = {.lex_state = 0},
  [7608] = {.lex_state = 0},
  [7609] = {.lex_state = 0},
  [7610] = {.lex_state = 0},
  [7611] = {.lex_state = 339},
  [7612] = {.lex_state = 0},
  [7613] = {.lex_state = 0},
  [7614] = {.lex_state = 0},
  [7615] = {.lex_state = 0},
  [7616] = {.lex_state = 0},
  [7617] = {.lex_state = 0},
  [7618] = {.lex_state = 0},
  [7619] = {.lex_state = 0},
  [7620] = {.lex_state = 0},
  [7621] = {.lex_state = 0},
  [7622] = {.lex_state = 0},
  [7623] = {.lex_state = 0},
  [7624] = {.lex_state = 0},
  [7625] = {.lex_state = 0},
  [7626] = {.lex_state = 0},
  [7627] = {.lex_state = 0},
  [7628] = {.lex_state = 0},
  [7629] = {.lex_state = 196},
  [7630] = {.lex_state = 339},
  [7631] = {.lex_state = 0},
  [7632] = {.lex_state = 339},
  [7633] = {.lex_state = 0},
  [7634] = {.lex_state = 0},
  [7635] = {.lex_state = 0},
  [7636] = {.lex_state = 112},
  [7637] = {.lex_state = 196},
  [7638] = {.lex_state = 339},
  [7639] = {.lex_state = 0},
  [7640] = {.lex_state = 0},
  [7641] = {.lex_state = 0},
  [7642] = {.lex_state = 339},
  [7643] = {.lex_state = 0},
  [7644] = {.lex_state = 339},
  [7645] = {.lex_state = 0},
  [7646] = {.lex_state = 112},
  [7647] = {.lex_state = 0},
  [7648] = {.lex_state = 0},
  [7649] = {.lex_state = 0},
  [7650] = {.lex_state = 0},
  [7651] = {.lex_state = 196},
  [7652] = {.lex_state = 0},
  [7653] = {.lex_state = 339},
  [7654] = {.lex_state = 339},
  [7655] = {.lex_state = 0},
  [7656] = {.lex_state = 0},
  [7657] = {.lex_state = 196},
  [7658] = {.lex_state = 339},
  [7659] = {.lex_state = 339},
  [7660] = {.lex_state = 0},
  [7661] = {.lex_state = 339},
  [7662] = {.lex_state = 196},
  [7663] = {.lex_state = 339},
  [7664] = {.lex_state = 0},
  [7665] = {.lex_state = 0},
  [7666] = {.lex_state = 112},
  [7667] = {.lex_state = 0},
  [7668] = {.lex_state = 196},
  [7669] = {.lex_state = 339},
  [7670] = {.lex_state = 339},
  [7671] = {.lex_state = 0},
  [7672] = {.lex_state = 0},
  [7673] = {.lex_state = 0},
  [7674] = {.lex_state = 0},
  [7675] = {.lex_state = 0},
  [7676] = {.lex_state = 0},
  [7677] = {.lex_state = 339},
  [7678] = {.lex_state = 112},
  [7679] = {.lex_state = 339},
  [7680] = {.lex_state = 0},
  [7681] = {.lex_state = 112},
  [7682] = {.lex_state = 0},
  [7683] = {.lex_state = 196},
  [7684] = {.lex_state = 0},
  [7685] = {.lex_state = 112},
  [7686] = {.lex_state = 0},
  [7687] = {.lex_state = 339},
  [7688] = {.lex_state = 0},
  [7689] = {.lex_state = 0},
  [7690] = {.lex_state = 171},
  [7691] = {.lex_state = 339},
  [7692] = {.lex_state = 0},
  [7693] = {.lex_state = 0},
  [7694] = {.lex_state = 0},
  [7695] = {.lex_state = 0},
  [7696] = {.lex_state = 0},
  [7697] = {.lex_state = 339},
  [7698] = {.lex_state = 0},
  [7699] = {.lex_state = 0},
  [7700] = {.lex_state = 339},
  [7701] = {.lex_state = 339},
  [7702] = {.lex_state = 339},
  [7703] = {.lex_state = 0},
  [7704] = {.lex_state = 196},
  [7705] = {.lex_state = 339},
  [7706] = {.lex_state = 0},
  [7707] = {.lex_state = 339},
  [7708] = {.lex_state = 339},
  [7709] = {.lex_state = 0},
  [7710] = {.lex_state = 0},
  [7711] = {.lex_state = 0},
  [7712] = {.lex_state = 339},
  [7713] = {.lex_state = 339},
  [7714] = {.lex_state = 339},
  [7715] = {.lex_state = 339},
  [7716] = {.lex_state = 0},
  [7717] = {.lex_state = 0},
  [7718] = {.lex_state = 0},
  [7719] = {.lex_state = 0},
  [7720] = {.lex_state = 339},
  [7721] = {.lex_state = 0},
  [7722] = {.lex_state = 0},
  [7723] = {.lex_state = 0},
  [7724] = {.lex_state = 339, .external_lex_state = 2},
  [7725] = {.lex_state = 0},
  [7726] = {.lex_state = 339},
  [7727] = {.lex_state = 0},
  [7728] = {.lex_state = 0},
  [7729] = {.lex_state = 0},
  [7730] = {.lex_state = 0},
  [7731] = {.lex_state = 196},
  [7732] = {.lex_state = 339},
  [7733] = {.lex_state = 0},
  [7734] = {.lex_state = 0},
  [7735] = {.lex_state = 0},
  [7736] = {.lex_state = 339},
  [7737] = {.lex_state = 339},
  [7738] = {.lex_state = 339},
  [7739] = {.lex_state = 112},
  [7740] = {.lex_state = 0},
  [7741] = {.lex_state = 339},
  [7742] = {.lex_state = 171},
  [7743] = {.lex_state = 0},
  [7744] = {.lex_state = 0},
  [7745] = {.lex_state = 339},
  [7746] = {.lex_state = 0},
  [7747] = {.lex_state = 0},
  [7748] = {.lex_state = 339},
  [7749] = {.lex_state = 339},
  [7750] = {.lex_state = 0},
  [7751] = {.lex_state = 0},
  [7752] = {.lex_state = 196},
  [7753] = {.lex_state = 0},
  [7754] = {.lex_state = 112},
  [7755] = {.lex_state = 0},
  [7756] = {.lex_state = 339},
  [7757] = {.lex_state = 0},
  [7758] = {.lex_state = 0},
  [7759] = {.lex_state = 339},
  [7760] = {.lex_state = 0},
  [7761] = {.lex_state = 0},
  [7762] = {.lex_state = 196},
  [7763] = {.lex_state = 0},
  [7764] = {.lex_state = 196},
  [7765] = {.lex_state = 339},
  [7766] = {.lex_state = 0},
  [7767] = {.lex_state = 0},
  [7768] = {.lex_state = 0},
  [7769] = {.lex_state = 0},
  [7770] = {.lex_state = 112},
  [7771] = {.lex_state = 339},
  [7772] = {.lex_state = 0},
  [7773] = {.lex_state = 0},
  [7774] = {.lex_state = 0},
  [7775] = {.lex_state = 0},
  [7776] = {.lex_state = 0},
  [7777] = {.lex_state = 0},
  [7778] = {.lex_state = 0},
  [7779] = {.lex_state = 112},
  [7780] = {.lex_state = 0},
  [7781] = {.lex_state = 339},
  [7782] = {.lex_state = 0},
  [7783] = {.lex_state = 0},
  [7784] = {.lex_state = 339},
  [7785] = {.lex_state = 0},
  [7786] = {.lex_state = 339},
  [7787] = {.lex_state = 339},
  [7788] = {.lex_state = 0},
  [7789] = {.lex_state = 196},
  [7790] = {.lex_state = 0},
  [7791] = {.lex_state = 0},
  [7792] = {.lex_state = 0},
  [7793] = {.lex_state = 112},
  [7794] = {.lex_state = 0},
  [7795] = {.lex_state = 0},
  [7796] = {.lex_state = 0},
  [7797] = {.lex_state = 112},
  [7798] = {.lex_state = 0},
  [7799] = {.lex_state = 339},
  [7800] = {.lex_state = 0},
  [7801] = {.lex_state = 0},
  [7802] = {.lex_state = 339},
  [7803] = {.lex_state = 0},
  [7804] = {.lex_state = 0},
  [7805] = {.lex_state = 0},
  [7806] = {.lex_state = 339},
  [7807] = {.lex_state = 339},
  [7808] = {.lex_state = 339},
  [7809] = {.lex_state = 0},
  [7810] = {.lex_state = 0},
  [7811] = {.lex_state = 0},
  [7812] = {.lex_state = 0},
  [7813] = {.lex_state = 0},
  [7814] = {.lex_state = 0},
  [7815] = {.lex_state = 196},
  [7816] = {.lex_state = 0},
  [7817] = {.lex_state = 0},
  [7818] = {.lex_state = 339},
  [7819] = {.lex_state = 0},
  [7820] = {.lex_state = 339},
  [7821] = {.lex_state = 196},
  [7822] = {.lex_state = 112},
  [7823] = {.lex_state = 196},
  [7824] = {.lex_state = 0},
  [7825] = {.lex_state = 0},
  [7826] = {.lex_state = 0},
  [7827] = {.lex_state = 0},
  [7828] = {.lex_state = 0},
  [7829] = {.lex_state = 196},
  [7830] = {.lex_state = 112},
  [7831] = {.lex_state = 0},
  [7832] = {.lex_state = 0},
  [7833] = {.lex_state = 0},
  [7834] = {.lex_state = 339},
  [7835] = {.lex_state = 0},
  [7836] = {.lex_state = 0},
  [7837] = {.lex_state = 0},
  [7838] = {.lex_state = 339},
  [7839] = {.lex_state = 0},
  [7840] = {.lex_state = 339},
  [7841] = {.lex_state = 0},
  [7842] = {.lex_state = 0},
  [7843] = {.lex_state = 0},
  [7844] = {.lex_state = 0},
  [7845] = {.lex_state = 0},
  [7846] = {.lex_state = 0},
  [7847] = {.lex_state = 0},
  [7848] = {.lex_state = 0},
  [7849] = {.lex_state = 171},
  [7850] = {.lex_state = 0},
  [7851] = {.lex_state = 0},
  [7852] = {.lex_state = 0},
  [7853] = {.lex_state = 0},
  [7854] = {.lex_state = 0},
  [7855] = {.lex_state = 339},
  [7856] = {.lex_state = 0},
  [7857] = {.lex_state = 0},
  [7858] = {.lex_state = 0},
  [7859] = {.lex_state = 0},
  [7860] = {.lex_state = 339},
  [7861] = {.lex_state = 196},
  [7862] = {.lex_state = 0},
  [7863] = {.lex_state = 0},
  [7864] = {.lex_state = 0},
  [7865] = {.lex_state = 0},
  [7866] = {.lex_state = 0},
  [7867] = {.lex_state = 0},
  [7868] = {.lex_state = 0},
  [7869] = {.lex_state = 0},
  [7870] = {.lex_state = 0},
  [7871] = {.lex_state = 0},
  [7872] = {.lex_state = 0},
  [7873] = {.lex_state = 339},
  [7874] = {.lex_state = 0},
  [7875] = {.lex_state = 339, .external_lex_state = 2},
  [7876] = {.lex_state = 196},
  [7877] = {.lex_state = 339},
  [7878] = {.lex_state = 0},
  [7879] = {.lex_state = 0},
  [7880] = {.lex_state = 0},
  [7881] = {.lex_state = 0},
  [7882] = {.lex_state = 0},
  [7883] = {.lex_state = 0},
  [7884] = {.lex_state = 0},
  [7885] = {.lex_state = 112},
  [7886] = {.lex_state = 0},
  [7887] = {.lex_state = 339},
  [7888] = {.lex_state = 0},
  [7889] = {.lex_state = 0},
  [7890] = {.lex_state = 0},
  [7891] = {.lex_state = 0},
  [7892] = {.lex_state = 339},
  [7893] = {.lex_state = 0},
  [7894] = {.lex_state = 0},
  [7895] = {.lex_state = 0},
  [7896] = {.lex_state = 0},
  [7897] = {.lex_state = 112},
  [7898] = {.lex_state = 0},
  [7899] = {.lex_state = 0},
  [7900] = {.lex_state = 339, .external_lex_state = 2},
  [7901] = {.lex_state = 0},
  [7902] = {.lex_state = 0},
  [7903] = {.lex_state = 0},
  [7904] = {.lex_state = 0},
  [7905] = {.lex_state = 339, .external_lex_state = 2},
  [7906] = {.lex_state = 339, .external_lex_state = 2},
  [7907] = {.lex_state = 339, .external_lex_state = 2},
  [7908] = {.lex_state = 171},
  [7909] = {.lex_state = 339},
  [7910] = {.lex_state = 339, .external_lex_state = 2},
  [7911] = {.lex_state = 339, .external_lex_state = 2},
  [7912] = {.lex_state = 339, .external_lex_state = 2},
  [7913] = {.lex_state = 339, .external_lex_state = 2},
  [7914] = {.lex_state = 339, .external_lex_state = 2},
  [7915] = {.lex_state = 339, .external_lex_state = 2},
  [7916] = {.lex_state = 339, .external_lex_state = 2},
  [7917] = {.lex_state = 339, .external_lex_state = 2},
  [7918] = {.lex_state = 339, .external_lex_state = 2},
  [7919] = {.lex_state = 339, .external_lex_state = 2},
  [7920] = {.lex_state = 339, .external_lex_state = 2},
  [7921] = {.lex_state = 0},
  [7922] = {.lex_state = 0},
  [7923] = {.lex_state = 173},
  [7924] = {.lex_state = 0},
  [7925] = {.lex_state = 0},
  [7926] = {.lex_state = 173},
  [7927] = {.lex_state = 0},
  [7928] = {.lex_state = 0},
  [7929] = {.lex_state = 0},
  [7930] = {.lex_state = 0},
  [7931] = {.lex_state = 199},
  [7932] = {.lex_state = 113},
  [7933] = {.lex_state = 0},
  [7934] = {.lex_state = 173},
  [7935] = {.lex_state = 173},
  [7936] = {.lex_state = 0},
  [7937] = {.lex_state = 0},
  [7938] = {.lex_state = 113},
  [7939] = {.lex_state = 0},
  [7940] = {.lex_state = 339},
  [7941] = {.lex_state = 0},
  [7942] = {.lex_state = 0},
  [7943] = {.lex_state = 0},
  [7944] = {.lex_state = 196},
  [7945] = {.lex_state = 113},
  [7946] = {.lex_state = 0},
  [7947] = {.lex_state = 0},
  [7948] = {.lex_state = 0},
  [7949] = {.lex_state = 0},
  [7950] = {.lex_state = 0},
  [7951] = {.lex_state = 0},
  [7952] = {.lex_state = 0},
  [7953] = {.lex_state = 0},
  [7954] = {.lex_state = 0},
  [7955] = {.lex_state = 0, .external_lex_state = 2},
  [7956] = {.lex_state = 0},
  [7957] = {.lex_state = 0},
  [7958] = {.lex_state = 0},
  [7959] = {.lex_state = 196},
  [7960] = {.lex_state = 0},
  [7961] = {.lex_state = 0},
  [7962] = {.lex_state = 196},
  [7963] = {.lex_state = 0},
  [7964] = {.lex_state = 0},
  [7965] = {.lex_state = 0},
  [7966] = {.lex_state = 0},
  [7967] = {.lex_state = 199},
  [7968] = {.lex_state = 171},
  [7969] = {.lex_state = 0},
  [7970] = {.lex_state = 339},
  [7971] = {.lex_state = 0},
  [7972] = {.lex_state = 339},
  [7973] = {.lex_state = 0},
  [7974] = {.lex_state = 0},
  [7975] = {.lex_state = 0},
  [7976] = {.lex_state = 0},
  [7977] = {.lex_state = 339},
  [7978] = {.lex_state = 0},
  [7979] = {.lex_state = 196},
  [7980] = {.lex_state = 0},
  [7981] = {.lex_state = 0},
  [7982] = {.lex_state = 0},
  [7983] = {.lex_state = 199},
  [7984] = {.lex_state = 339},
  [7985] = {.lex_state = 0},
  [7986] = {.lex_state = 0},
  [7987] = {.lex_state = 0},
  [7988] = {.lex_state = 0},
  [7989] = {.lex_state = 0},
  [7990] = {.lex_state = 0},
  [7991] = {.lex_state = 0},
  [7992] = {.lex_state = 0},
  [7993] = {.lex_state = 0},
  [7994] = {.lex_state = 0},
  [7995] = {.lex_state = 0},
  [7996] = {.lex_state = 0},
  [7997] = {.lex_state = 0},
  [7998] = {.lex_state = 0},
  [7999] = {.lex_state = 0},
  [8000] = {.lex_state = 0},
  [8001] = {.lex_state = 195},
  [8002] = {.lex_state = 239},
  [8003] = {.lex_state = 0},
  [8004] = {.lex_state = 196},
  [8005] = {.lex_state = 196},
  [8006] = {.lex_state = 0},
  [8007] = {.lex_state = 0},
  [8008] = {.lex_state = 0},
  [8009] = {.lex_state = 0},
  [8010] = {.lex_state = 0},
  [8011] = {.lex_state = 199},
  [8012] = {.lex_state = 0},
  [8013] = {.lex_state = 199},
  [8014] = {.lex_state = 0},
  [8015] = {.lex_state = 196},
  [8016] = {.lex_state = 173},
  [8017] = {.lex_state = 196},
  [8018] = {.lex_state = 0},
  [8019] = {.lex_state = 339},
  [8020] = {.lex_state = 196},
  [8021] = {.lex_state = 339},
  [8022] = {.lex_state = 339},
  [8023] = {.lex_state = 0},
  [8024] = {.lex_state = 0},
  [8025] = {.lex_state = 0},
  [8026] = {.lex_state = 0},
  [8027] = {.lex_state = 0},
  [8028] = {.lex_state = 339},
  [8029] = {.lex_state = 196},
  [8030] = {.lex_state = 0},
  [8031] = {.lex_state = 113},
  [8032] = {.lex_state = 113},
  [8033] = {.lex_state = 199},
  [8034] = {.lex_state = 0},
  [8035] = {.lex_state = 199},
  [8036] = {.lex_state = 199},
  [8037] = {.lex_state = 0},
  [8038] = {.lex_state = 0},
  [8039] = {.lex_state = 0},
  [8040] = {.lex_state = 0},
  [8041] = {.lex_state = 0},
  [8042] = {.lex_state = 113},
  [8043] = {.lex_state = 339},
  [8044] = {.lex_state = 0},
  [8045] = {.lex_state = 196},
  [8046] = {.lex_state = 0},
  [8047] = {.lex_state = 0},
  [8048] = {.lex_state = 0},
  [8049] = {.lex_state = 339},
  [8050] = {.lex_state = 0},
  [8051] = {.lex_state = 0},
  [8052] = {.lex_state = 0},
  [8053] = {.lex_state = 0},
  [8054] = {.lex_state = 0},
  [8055] = {.lex_state = 196},
  [8056] = {.lex_state = 0},
  [8057] = {.lex_state = 0},
  [8058] = {.lex_state = 0},
  [8059] = {.lex_state = 0},
  [8060] = {.lex_state = 0},
  [8061] = {.lex_state = 0},
  [8062] = {.lex_state = 0},
  [8063] = {.lex_state = 0},
  [8064] = {.lex_state = 0},
  [8065] = {.lex_state = 171},
  [8066] = {.lex_state = 0},
  [8067] = {.lex_state = 339},
  [8068] = {.lex_state = 196},
  [8069] = {.lex_state = 196},
  [8070] = {.lex_state = 0},
  [8071] = {.lex_state = 0},
  [8072] = {.lex_state = 0},
  [8073] = {.lex_state = 196},
  [8074] = {.lex_state = 0},
  [8075] = {.lex_state = 0},
  [8076] = {.lex_state = 199},
  [8077] = {.lex_state = 0},
  [8078] = {.lex_state = 0},
  [8079] = {.lex_state = 0, .external_lex_state = 2},
  [8080] = {.lex_state = 0},
  [8081] = {.lex_state = 0},
  [8082] = {.lex_state = 0},
  [8083] = {.lex_state = 196},
  [8084] = {.lex_state = 339},
  [8085] = {.lex_state = 0},
  [8086] = {.lex_state = 0},
  [8087] = {.lex_state = 196},
  [8088] = {.lex_state = 0},
  [8089] = {.lex_state = 0},
  [8090] = {.lex_state = 0},
  [8091] = {.lex_state = 0},
  [8092] = {.lex_state = 0},
  [8093] = {.lex_state = 113},
  [8094] = {.lex_state = 173},
  [8095] = {.lex_state = 196},
  [8096] = {.lex_state = 199},
  [8097] = {.lex_state = 0},
  [8098] = {.lex_state = 0},
  [8099] = {.lex_state = 113},
  [8100] = {.lex_state = 0},
  [8101] = {.lex_state = 196},
  [8102] = {.lex_state = 0},
  [8103] = {.lex_state = 0},
  [8104] = {.lex_state = 0},
  [8105] = {.lex_state = 0},
  [8106] = {.lex_state = 339},
  [8107] = {.lex_state = 0},
  [8108] = {.lex_state = 0},
  [8109] = {.lex_state = 0},
  [8110] = {.lex_state = 0},
  [8111] = {.lex_state = 196},
  [8112] = {.lex_state = 0},
  [8113] = {.lex_state = 339},
  [8114] = {.lex_state = 0},
  [8115] = {.lex_state = 0},
  [8116] = {.lex_state = 173},
  [8117] = {.lex_state = 0},
  [8118] = {.lex_state = 0},
  [8119] = {.lex_state = 0},
  [8120] = {.lex_state = 196},
  [8121] = {.lex_state = 339},
  [8122] = {.lex_state = 0},
  [8123] = {.lex_state = 339},
  [8124] = {.lex_state = 0},
  [8125] = {.lex_state = 0},
  [8126] = {.lex_state = 0},
  [8127] = {.lex_state = 0},
  [8128] = {.lex_state = 0},
  [8129] = {.lex_state = 0},
  [8130] = {.lex_state = 196},
  [8131] = {.lex_state = 0},
  [8132] = {.lex_state = 0},
  [8133] = {.lex_state = 0},
  [8134] = {.lex_state = 0},
  [8135] = {.lex_state = 0},
  [8136] = {.lex_state = 196},
  [8137] = {.lex_state = 0},
  [8138] = {.lex_state = 171},
  [8139] = {.lex_state = 113},
  [8140] = {.lex_state = 0},
  [8141] = {.lex_state = 0},
  [8142] = {.lex_state = 0},
  [8143] = {.lex_state = 0},
  [8144] = {.lex_state = 0},
  [8145] = {.lex_state = 0},
  [8146] = {.lex_state = 196},
  [8147] = {.lex_state = 0},
  [8148] = {.lex_state = 339},
  [8149] = {.lex_state = 339},
  [8150] = {.lex_state = 0},
  [8151] = {.lex_state = 0},
  [8152] = {.lex_state = 0, .external_lex_state = 2},
  [8153] = {.lex_state = 0},
  [8154] = {.lex_state = 196},
  [8155] = {.lex_state = 0},
  [8156] = {.lex_state = 0},
  [8157] = {.lex_state = 339},
  [8158] = {.lex_state = 0},
  [8159] = {.lex_state = 0},
  [8160] = {.lex_state = 173},
  [8161] = {.lex_state = 339},
  [8162] = {.lex_state = 0},
  [8163] = {.lex_state = 0},
  [8164] = {.lex_state = 0},
  [8165] = {.lex_state = 196},
  [8166] = {.lex_state = 0},
  [8167] = {.lex_state = 0},
  [8168] = {.lex_state = 0},
  [8169] = {.lex_state = 0},
  [8170] = {.lex_state = 0},
  [8171] = {.lex_state = 0},
  [8172] = {.lex_state = 0},
  [8173] = {.lex_state = 196},
  [8174] = {.lex_state = 113},
  [8175] = {.lex_state = 339},
  [8176] = {.lex_state = 0},
  [8177] = {.lex_state = 113},
  [8178] = {.lex_state = 0},
  [8179] = {.lex_state = 173},
  [8180] = {.lex_state = 0},
  [8181] = {.lex_state = 0},
  [8182] = {.lex_state = 0, .external_lex_state = 2},
  [8183] = {.lex_state = 196},
  [8184] = {.lex_state = 0},
  [8185] = {.lex_state = 0},
  [8186] = {.lex_state = 0},
  [8187] = {.lex_state = 196},
  [8188] = {.lex_state = 0},
  [8189] = {.lex_state = 0},
  [8190] = {.lex_state = 0},
  [8191] = {.lex_state = 0},
  [8192] = {.lex_state = 0},
  [8193] = {.lex_state = 196},
  [8194] = {.lex_state = 0},
  [8195] = {.lex_state = 0},
  [8196] = {.lex_state = 0},
  [8197] = {.lex_state = 0},
  [8198] = {.lex_state = 0},
  [8199] = {.lex_state = 196},
  [8200] = {.lex_state = 0},
  [8201] = {.lex_state = 0},
  [8202] = {.lex_state = 173},
  [8203] = {.lex_state = 0},
  [8204] = {.lex_state = 0},
  [8205] = {.lex_state = 0, .external_lex_state = 2},
  [8206] = {.lex_state = 113},
  [8207] = {.lex_state = 196},
  [8208] = {.lex_state = 0},
  [8209] = {.lex_state = 199},
  [8210] = {.lex_state = 0},
  [8211] = {.lex_state = 0},
  [8212] = {.lex_state = 0},
  [8213] = {.lex_state = 173},
  [8214] = {.lex_state = 339},
  [8215] = {.lex_state = 0},
  [8216] = {.lex_state = 113},
  [8217] = {.lex_state = 0},
  [8218] = {.lex_state = 0},
  [8219] = {.lex_state = 173},
  [8220] = {.lex_state = 196},
  [8221] = {.lex_state = 0},
  [8222] = {.lex_state = 173},
  [8223] = {.lex_state = 0},
  [8224] = {.lex_state = 0},
  [8225] = {.lex_state = 339},
  [8226] = {.lex_state = 0},
  [8227] = {.lex_state = 339},
  [8228] = {.lex_state = 0},
  [8229] = {.lex_state = 173},
  [8230] = {.lex_state = 0},
  [8231] = {.lex_state = 0},
  [8232] = {.lex_state = 0},
  [8233] = {.lex_state = 173},
  [8234] = {.lex_state = 0},
  [8235] = {.lex_state = 0},
  [8236] = {.lex_state = 0},
  [8237] = {.lex_state = 0},
  [8238] = {.lex_state = 0},
  [8239] = {.lex_state = 173},
  [8240] = {.lex_state = 0},
  [8241] = {.lex_state = 196},
  [8242] = {.lex_state = 0},
  [8243] = {.lex_state = 0},
  [8244] = {.lex_state = 113},
  [8245] = {.lex_state = 199},
  [8246] = {.lex_state = 0},
  [8247] = {.lex_state = 173},
  [8248] = {.lex_state = 0},
  [8249] = {.lex_state = 196},
  [8250] = {.lex_state = 0},
  [8251] = {.lex_state = 0, .external_lex_state = 2},
  [8252] = {.lex_state = 0},
  [8253] = {.lex_state = 196},
  [8254] = {.lex_state = 174},
  [8255] = {.lex_state = 199},
  [8256] = {.lex_state = 0},
  [8257] = {.lex_state = 173},
  [8258] = {.lex_state = 0},
  [8259] = {.lex_state = 339},
  [8260] = {.lex_state = 0},
  [8261] = {.lex_state = 196},
  [8262] = {.lex_state = 173},
  [8263] = {.lex_state = 0},
  [8264] = {.lex_state = 0},
  [8265] = {.lex_state = 0},
  [8266] = {.lex_state = 0, .external_lex_state = 2},
  [8267] = {.lex_state = 0},
  [8268] = {.lex_state = 199},
  [8269] = {.lex_state = 173},
  [8270] = {.lex_state = 0},
  [8271] = {.lex_state = 0},
  [8272] = {.lex_state = 339},
  [8273] = {.lex_state = 0},
  [8274] = {.lex_state = 196},
  [8275] = {.lex_state = 0},
  [8276] = {.lex_state = 173},
  [8277] = {.lex_state = 0, .external_lex_state = 2},
  [8278] = {.lex_state = 339},
  [8279] = {.lex_state = 339},
  [8280] = {.lex_state = 0},
  [8281] = {.lex_state = 0},
  [8282] = {.lex_state = 339},
  [8283] = {.lex_state = 0},
  [8284] = {.lex_state = 0, .external_lex_state = 2},
  [8285] = {.lex_state = 0},
  [8286] = {.lex_state = 173},
  [8287] = {.lex_state = 0},
  [8288] = {.lex_state = 0, .external_lex_state = 2},
  [8289] = {.lex_state = 196},
  [8290] = {.lex_state = 0},
  [8291] = {.lex_state = 0},
  [8292] = {.lex_state = 0, .external_lex_state = 2},
  [8293] = {.lex_state = 0},
  [8294] = {.lex_state = 0, .external_lex_state = 2},
  [8295] = {.lex_state = 0},
  [8296] = {.lex_state = 0, .external_lex_state = 2},
  [8297] = {.lex_state = 0},
  [8298] = {.lex_state = 0, .external_lex_state = 2},
  [8299] = {.lex_state = 0},
  [8300] = {.lex_state = 0, .external_lex_state = 2},
  [8301] = {.lex_state = 0},
  [8302] = {.lex_state = 0, .external_lex_state = 2},
  [8303] = {.lex_state = 196},
  [8304] = {.lex_state = 0},
  [8305] = {.lex_state = 0},
  [8306] = {.lex_state = 339},
  [8307] = {.lex_state = 0},
  [8308] = {.lex_state = 339},
  [8309] = {.lex_state = 339},
  [8310] = {.lex_state = 339},
  [8311] = {.lex_state = 0},
  [8312] = {.lex_state = 196},
  [8313] = {.lex_state = 339},
  [8314] = {.lex_state = 0},
  [8315] = {.lex_state = 339},
  [8316] = {.lex_state = 0},
  [8317] = {.lex_state = 0},
  [8318] = {.lex_state = 0},
  [8319] = {.lex_state = 0},
  [8320] = {.lex_state = 0},
  [8321] = {.lex_state = 0},
  [8322] = {.lex_state = 0},
  [8323] = {.lex_state = 196},
  [8324] = {.lex_state = 113},
  [8325] = {.lex_state = 0},
  [8326] = {.lex_state = 173},
  [8327] = {.lex_state = 0},
  [8328] = {.lex_state = 0},
  [8329] = {.lex_state = 0},
  [8330] = {.lex_state = 0},
  [8331] = {.lex_state = 196},
  [8332] = {.lex_state = 0},
  [8333] = {.lex_state = 339},
  [8334] = {.lex_state = 0},
  [8335] = {.lex_state = 173},
  [8336] = {.lex_state = 0},
  [8337] = {.lex_state = 199},
  [8338] = {.lex_state = 0},
  [8339] = {.lex_state = 339},
  [8340] = {.lex_state = 0, .external_lex_state = 3},
  [8341] = {.lex_state = 0},
  [8342] = {.lex_state = 0},
  [8343] = {.lex_state = 339},
  [8344] = {.lex_state = 339},
  [8345] = {.lex_state = 196},
  [8346] = {.lex_state = 0},
  [8347] = {.lex_state = 0},
  [8348] = {.lex_state = 0},
  [8349] = {.lex_state = 0},
  [8350] = {.lex_state = 173},
  [8351] = {.lex_state = 0},
  [8352] = {.lex_state = 0},
  [8353] = {.lex_state = 196},
  [8354] = {.lex_state = 0},
  [8355] = {.lex_state = 0},
  [8356] = {.lex_state = 196},
  [8357] = {.lex_state = 0},
  [8358] = {.lex_state = 0},
  [8359] = {.lex_state = 113},
  [8360] = {.lex_state = 0},
  [8361] = {.lex_state = 173},
  [8362] = {.lex_state = 339},
  [8363] = {.lex_state = 339},
  [8364] = {.lex_state = 0},
  [8365] = {.lex_state = 339},
  [8366] = {.lex_state = 199},
  [8367] = {.lex_state = 0},
  [8368] = {.lex_state = 113},
  [8369] = {.lex_state = 0},
  [8370] = {.lex_state = 113},
  [8371] = {.lex_state = 196},
  [8372] = {.lex_state = 0},
  [8373] = {.lex_state = 196},
  [8374] = {.lex_state = 171},
  [8375] = {.lex_state = 0},
  [8376] = {.lex_state = 0},
  [8377] = {.lex_state = 0},
  [8378] = {.lex_state = 0},
  [8379] = {.lex_state = 196},
  [8380] = {.lex_state = 113},
  [8381] = {.lex_state = 0},
  [8382] = {.lex_state = 0},
  [8383] = {.lex_state = 0},
  [8384] = {.lex_state = 113},
  [8385] = {.lex_state = 199},
  [8386] = {.lex_state = 199},
  [8387] = {.lex_state = 173},
  [8388] = {.lex_state = 339},
  [8389] = {.lex_state = 0},
  [8390] = {.lex_state = 0},
  [8391] = {.lex_state = 0},
  [8392] = {.lex_state = 0},
  [8393] = {.lex_state = 0},
  [8394] = {.lex_state = 173},
  [8395] = {.lex_state = 0, .external_lex_state = 3},
  [8396] = {.lex_state = 0},
  [8397] = {.lex_state = 113},
  [8398] = {.lex_state = 339},
  [8399] = {.lex_state = 0},
  [8400] = {.lex_state = 0},
  [8401] = {.lex_state = 0},
  [8402] = {.lex_state = 0},
  [8403] = {.lex_state = 0},
  [8404] = {.lex_state = 196},
  [8405] = {.lex_state = 113},
  [8406] = {.lex_state = 196},
  [8407] = {.lex_state = 173},
  [8408] = {.lex_state = 0},
  [8409] = {.lex_state = 0},
  [8410] = {.lex_state = 0},
  [8411] = {.lex_state = 199},
  [8412] = {.lex_state = 199},
  [8413] = {.lex_state = 0},
  [8414] = {.lex_state = 0},
  [8415] = {.lex_state = 0},
  [8416] = {.lex_state = 0},
  [8417] = {.lex_state = 339},
  [8418] = {.lex_state = 0},
  [8419] = {.lex_state = 0},
  [8420] = {.lex_state = 0},
  [8421] = {.lex_state = 0},
  [8422] = {.lex_state = 173},
  [8423] = {.lex_state = 113},
  [8424] = {.lex_state = 0},
  [8425] = {.lex_state = 173},
  [8426] = {.lex_state = 0},
  [8427] = {.lex_state = 339},
  [8428] = {.lex_state = 0},
  [8429] = {.lex_state = 0},
  [8430] = {.lex_state = 196},
  [8431] = {.lex_state = 0},
  [8432] = {.lex_state = 196},
  [8433] = {.lex_state = 173},
  [8434] = {.lex_state = 0},
  [8435] = {.lex_state = 0},
  [8436] = {.lex_state = 0},
  [8437] = {.lex_state = 0},
  [8438] = {.lex_state = 0},
  [8439] = {.lex_state = 0},
  [8440] = {.lex_state = 0},
  [8441] = {.lex_state = 0},
  [8442] = {.lex_state = 0},
  [8443] = {.lex_state = 0, .external_lex_state = 2},
  [8444] = {.lex_state = 0},
  [8445] = {.lex_state = 0},
  [8446] = {.lex_state = 0},
  [8447] = {.lex_state = 0},
  [8448] = {.lex_state = 196},
  [8449] = {.lex_state = 0},
  [8450] = {.lex_state = 0},
  [8451] = {.lex_state = 196},
  [8452] = {.lex_state = 0},
  [8453] = {.lex_state = 0},
  [8454] = {.lex_state = 196},
  [8455] = {.lex_state = 0},
  [8456] = {.lex_state = 0},
  [8457] = {.lex_state = 0},
  [8458] = {.lex_state = 0},
  [8459] = {.lex_state = 0},
  [8460] = {.lex_state = 113},
  [8461] = {.lex_state = 0},
  [8462] = {.lex_state = 0, .external_lex_state = 3},
  [8463] = {.lex_state = 0},
  [8464] = {.lex_state = 199},
  [8465] = {.lex_state = 113},
  [8466] = {.lex_state = 0},
  [8467] = {.lex_state = 0},
  [8468] = {.lex_state = 0},
  [8469] = {.lex_state = 173},
  [8470] = {.lex_state = 0},
  [8471] = {.lex_state = 0},
  [8472] = {.lex_state = 173},
  [8473] = {.lex_state = 0},
  [8474] = {.lex_state = 0},
  [8475] = {.lex_state = 0},
  [8476] = {.lex_state = 339},
  [8477] = {.lex_state = 0},
  [8478] = {.lex_state = 0},
  [8479] = {.lex_state = 0},
  [8480] = {.lex_state = 0},
  [8481] = {.lex_state = 0},
  [8482] = {.lex_state = 0},
  [8483] = {.lex_state = 0},
  [8484] = {.lex_state = 0},
  [8485] = {.lex_state = 0},
  [8486] = {.lex_state = 196},
  [8487] = {.lex_state = 196},
  [8488] = {.lex_state = 0},
  [8489] = {.lex_state = 196},
  [8490] = {.lex_state = 0},
  [8491] = {.lex_state = 0},
  [8492] = {.lex_state = 196},
  [8493] = {.lex_state = 0},
  [8494] = {.lex_state = 0},
  [8495] = {.lex_state = 0},
  [8496] = {.lex_state = 0},
  [8497] = {.lex_state = 0},
  [8498] = {.lex_state = 0},
  [8499] = {.lex_state = 196},
  [8500] = {.lex_state = 196},
  [8501] = {.lex_state = 196},
  [8502] = {.lex_state = 0},
  [8503] = {.lex_state = 0},
  [8504] = {.lex_state = 173},
  [8505] = {.lex_state = 0},
  [8506] = {.lex_state = 113},
  [8507] = {.lex_state = 339},
  [8508] = {.lex_state = 339},
  [8509] = {.lex_state = 339},
  [8510] = {.lex_state = 339},
  [8511] = {.lex_state = 339},
  [8512] = {.lex_state = 196},
  [8513] = {.lex_state = 339},
  [8514] = {.lex_state = 173},
  [8515] = {.lex_state = 0},
  [8516] = {.lex_state = 339},
  [8517] = {.lex_state = 0},
  [8518] = {.lex_state = 173},
  [8519] = {.lex_state = 196},
  [8520] = {.lex_state = 196},
  [8521] = {.lex_state = 339},
  [8522] = {.lex_state = 339},
  [8523] = {.lex_state = 173},
  [8524] = {.lex_state = 173},
  [8525] = {.lex_state = 339},
  [8526] = {.lex_state = 0, .external_lex_state = 3},
  [8527] = {.lex_state = 339},
  [8528] = {.lex_state = 173},
  [8529] = {.lex_state = 0},
  [8530] = {.lex_state = 0},
  [8531] = {.lex_state = 0},
  [8532] = {.lex_state = 0},
  [8533] = {.lex_state = 0},
  [8534] = {.lex_state = 0},
  [8535] = {.lex_state = 0},
  [8536] = {.lex_state = 199},
  [8537] = {.lex_state = 0},
  [8538] = {.lex_state = 0},
  [8539] = {.lex_state = 339},
  [8540] = {.lex_state = 339},
  [8541] = {.lex_state = 339},
  [8542] = {.lex_state = 0},
  [8543] = {.lex_state = 339},
  [8544] = {.lex_state = 0},
  [8545] = {.lex_state = 0},
  [8546] = {.lex_state = 196},
  [8547] = {.lex_state = 196},
  [8548] = {.lex_state = 339},
  [8549] = {.lex_state = 113},
  [8550] = {.lex_state = 0},
  [8551] = {.lex_state = 339},
  [8552] = {.lex_state = 0, .external_lex_state = 3},
  [8553] = {.lex_state = 0},
  [8554] = {.lex_state = 0},
  [8555] = {.lex_state = 0},
  [8556] = {.lex_state = 0},
  [8557] = {.lex_state = 0},
  [8558] = {.lex_state = 199},
  [8559] = {.lex_state = 196},
  [8560] = {.lex_state = 339},
  [8561] = {.lex_state = 339},
  [8562] = {.lex_state = 339},
  [8563] = {.lex_state = 0},
  [8564] = {.lex_state = 339},
  [8565] = {.lex_state = 196},
  [8566] = {.lex_state = 173},
  [8567] = {.lex_state = 196},
  [8568] = {.lex_state = 339},
  [8569] = {.lex_state = 0},
  [8570] = {.lex_state = 196},
  [8571] = {.lex_state = 339},
  [8572] = {.lex_state = 0, .external_lex_state = 3},
  [8573] = {.lex_state = 173},
  [8574] = {.lex_state = 0},
  [8575] = {.lex_state = 0},
  [8576] = {.lex_state = 0},
  [8577] = {.lex_state = 0},
  [8578] = {.lex_state = 199},
  [8579] = {.lex_state = 0},
  [8580] = {.lex_state = 339},
  [8581] = {.lex_state = 339},
  [8582] = {.lex_state = 339},
  [8583] = {.lex_state = 196},
  [8584] = {.lex_state = 339},
  [8585] = {.lex_state = 0},
  [8586] = {.lex_state = 196},
  [8587] = {.lex_state = 339},
  [8588] = {.lex_state = 0},
  [8589] = {.lex_state = 0},
  [8590] = {.lex_state = 339},
  [8591] = {.lex_state = 0, .external_lex_state = 3},
  [8592] = {.lex_state = 339},
  [8593] = {.lex_state = 0},
  [8594] = {.lex_state = 0},
  [8595] = {.lex_state = 0},
  [8596] = {.lex_state = 0},
  [8597] = {.lex_state = 199},
  [8598] = {.lex_state = 199},
  [8599] = {.lex_state = 339},
  [8600] = {.lex_state = 339},
  [8601] = {.lex_state = 0},
  [8602] = {.lex_state = 339},
  [8603] = {.lex_state = 196},
  [8604] = {.lex_state = 171},
  [8605] = {.lex_state = 0},
  [8606] = {.lex_state = 0},
  [8607] = {.lex_state = 339},
  [8608] = {.lex_state = 0, .external_lex_state = 3},
  [8609] = {.lex_state = 0},
  [8610] = {.lex_state = 0},
  [8611] = {.lex_state = 0},
  [8612] = {.lex_state = 0},
  [8613] = {.lex_state = 0},
  [8614] = {.lex_state = 339},
  [8615] = {.lex_state = 339},
  [8616] = {.lex_state = 339},
  [8617] = {.lex_state = 0},
  [8618] = {.lex_state = 0, .external_lex_state = 3},
  [8619] = {.lex_state = 0},
  [8620] = {.lex_state = 0},
  [8621] = {.lex_state = 0},
  [8622] = {.lex_state = 113},
  [8623] = {.lex_state = 339},
  [8624] = {.lex_state = 339},
  [8625] = {.lex_state = 339},
  [8626] = {.lex_state = 0},
  [8627] = {.lex_state = 0, .external_lex_state = 3},
  [8628] = {.lex_state = 0},
  [8629] = {.lex_state = 0},
  [8630] = {.lex_state = 339},
  [8631] = {.lex_state = 339},
  [8632] = {.lex_state = 339},
  [8633] = {.lex_state = 0, .external_lex_state = 3},
  [8634] = {.lex_state = 0},
  [8635] = {.lex_state = 339},
  [8636] = {.lex_state = 0, .external_lex_state = 3},
  [8637] = {.lex_state = 0},
  [8638] = {.lex_state = 339},
  [8639] = {.lex_state = 0, .external_lex_state = 3},
  [8640] = {.lex_state = 0},
  [8641] = {.lex_state = 0, .external_lex_state = 3},
  [8642] = {.lex_state = 0},
  [8643] = {.lex_state = 0, .external_lex_state = 3},
  [8644] = {.lex_state = 0},
  [8645] = {.lex_state = 0, .external_lex_state = 3},
  [8646] = {.lex_state = 0},
  [8647] = {.lex_state = 0, .external_lex_state = 3},
  [8648] = {.lex_state = 0},
  [8649] = {.lex_state = 0, .external_lex_state = 3},
  [8650] = {.lex_state = 0},
  [8651] = {.lex_state = 0},
  [8652] = {.lex_state = 196},
  [8653] = {.lex_state = 339},
  [8654] = {.lex_state = 339},
  [8655] = {.lex_state = 196},
  [8656] = {.lex_state = 0},
  [8657] = {.lex_state = 0},
  [8658] = {.lex_state = 0},
  [8659] = {.lex_state = 0},
  [8660] = {.lex_state = 113},
  [8661] = {.lex_state = 196},
  [8662] = {.lex_state = 196},
  [8663] = {.lex_state = 173},
  [8664] = {.lex_state = 0},
  [8665] = {.lex_state = 339},
  [8666] = {.lex_state = 0},
  [8667] = {.lex_state = 196},
  [8668] = {.lex_state = 0},
  [8669] = {.lex_state = 0},
  [8670] = {.lex_state = 0},
  [8671] = {.lex_state = 196},
  [8672] = {.lex_state = 0, .external_lex_state = 3},
  [8673] = {.lex_state = 0},
  [8674] = {.lex_state = 196},
  [8675] = {.lex_state = 0},
  [8676] = {.lex_state = 113},
  [8677] = {.lex_state = 0},
  [8678] = {.lex_state = 339},
  [8679] = {.lex_state = 339},
  [8680] = {.lex_state = 173},
  [8681] = {.lex_state = 0},
  [8682] = {.lex_state = 339},
  [8683] = {.lex_state = 339},
  [8684] = {.lex_state = 0},
  [8685] = {.lex_state = 0},
  [8686] = {.lex_state = 0},
  [8687] = {.lex_state = 196},
  [8688] = {.lex_state = 173},
  [8689] = {.lex_state = 196},
  [8690] = {.lex_state = 173},
  [8691] = {.lex_state = 0},
  [8692] = {.lex_state = 0},
  [8693] = {.lex_state = 196},
  [8694] = {.lex_state = 0},
  [8695] = {.lex_state = 0},
  [8696] = {.lex_state = 0},
  [8697] = {.lex_state = 0},
  [8698] = {.lex_state = 0},
  [8699] = {.lex_state = 0},
  [8700] = {.lex_state = 0},
  [8701] = {.lex_state = 0},
  [8702] = {.lex_state = 196},
  [8703] = {.lex_state = 0},
  [8704] = {.lex_state = 199},
  [8705] = {.lex_state = 199},
  [8706] = {.lex_state = 0},
  [8707] = {.lex_state = 0},
  [8708] = {.lex_state = 0},
  [8709] = {.lex_state = 0},
  [8710] = {.lex_state = 0},
  [8711] = {.lex_state = 0},
  [8712] = {.lex_state = 339},
  [8713] = {.lex_state = 173},
  [8714] = {.lex_state = 196},
  [8715] = {.lex_state = 0},
  [8716] = {.lex_state = 0},
  [8717] = {.lex_state = 0},
  [8718] = {.lex_state = 0},
  [8719] = {.lex_state = 0},
  [8720] = {.lex_state = 173},
  [8721] = {.lex_state = 196},
  [8722] = {.lex_state = 0},
  [8723] = {.lex_state = 0},
  [8724] = {.lex_state = 173},
  [8725] = {.lex_state = 113},
  [8726] = {.lex_state = 196},
  [8727] = {.lex_state = 0},
  [8728] = {.lex_state = 0},
  [8729] = {.lex_state = 0},
  [8730] = {.lex_state = 0},
  [8731] = {.lex_state = 339},
  [8732] = {.lex_state = 0},
  [8733] = {.lex_state = 199},
  [8734] = {.lex_state = 199},
  [8735] = {.lex_state = 0},
  [8736] = {.lex_state = 0},
  [8737] = {.lex_state = 339},
  [8738] = {.lex_state = 339},
  [8739] = {.lex_state = 196},
  [8740] = {.lex_state = 0},
  [8741] = {.lex_state = 0},
  [8742] = {.lex_state = 0},
  [8743] = {.lex_state = 0},
  [8744] = {.lex_state = 196},
  [8745] = {.lex_state = 0, .external_lex_state = 3},
  [8746] = {.lex_state = 196},
  [8747] = {.lex_state = 0},
  [8748] = {.lex_state = 0},
  [8749] = {.lex_state = 196},
  [8750] = {.lex_state = 339},
  [8751] = {.lex_state = 339},
  [8752] = {.lex_state = 196},
  [8753] = {.lex_state = 0},
  [8754] = {.lex_state = 173},
  [8755] = {.lex_state = 196},
  [8756] = {.lex_state = 0, .external_lex_state = 3},
  [8757] = {.lex_state = 173},
  [8758] = {.lex_state = 0},
  [8759] = {.lex_state = 0},
  [8760] = {.lex_state = 339},
  [8761] = {.lex_state = 196},
  [8762] = {.lex_state = 0},
  [8763] = {.lex_state = 0},
  [8764] = {.lex_state = 196},
  [8765] = {.lex_state = 0, .external_lex_state = 3},
  [8766] = {.lex_state = 0},
  [8767] = {.lex_state = 0},
  [8768] = {.lex_state = 339},
  [8769] = {.lex_state = 196},
  [8770] = {.lex_state = 0},
  [8771] = {.lex_state = 173},
  [8772] = {.lex_state = 196},
  [8773] = {.lex_state = 0, .external_lex_state = 3},
  [8774] = {.lex_state = 196},
  [8775] = {.lex_state = 339},
  [8776] = {.lex_state = 196},
  [8777] = {.lex_state = 196},
  [8778] = {.lex_state = 196},
  [8779] = {.lex_state = 0, .external_lex_state = 3},
  [8780] = {.lex_state = 0},
  [8781] = {.lex_state = 196},
  [8782] = {.lex_state = 0, .external_lex_state = 3},
  [8783] = {.lex_state = 0},
  [8784] = {.lex_state = 0, .external_lex_state = 3},
  [8785] = {.lex_state = 0},
  [8786] = {.lex_state = 0, .external_lex_state = 3},
  [8787] = {.lex_state = 0},
  [8788] = {.lex_state = 0, .external_lex_state = 3},
  [8789] = {.lex_state = 0},
  [8790] = {.lex_state = 0, .external_lex_state = 3},
  [8791] = {.lex_state = 0},
  [8792] = {.lex_state = 0, .external_lex_state = 3},
  [8793] = {.lex_state = 196},
  [8794] = {.lex_state = 0, .external_lex_state = 3},
  [8795] = {.lex_state = 0},
  [8796] = {.lex_state = 0, .external_lex_state = 3},
  [8797] = {.lex_state = 0},
  [8798] = {.lex_state = 0, .external_lex_state = 3},
  [8799] = {.lex_state = 196},
  [8800] = {.lex_state = 0, .external_lex_state = 3},
  [8801] = {.lex_state = 339},
  [8802] = {.lex_state = 339},
  [8803] = {.lex_state = 196},
  [8804] = {.lex_state = 339},
  [8805] = {.lex_state = 339},
  [8806] = {.lex_state = 0},
  [8807] = {.lex_state = 339},
  [8808] = {.lex_state = 339},
  [8809] = {.lex_state = 0},
  [8810] = {.lex_state = 339},
  [8811] = {.lex_state = 339},
  [8812] = {.lex_state = 0},
  [8813] = {.lex_state = 339},
  [8814] = {.lex_state = 339},
  [8815] = {.lex_state = 0},
  [8816] = {.lex_state = 339},
  [8817] = {.lex_state = 339},
  [8818] = {.lex_state = 339},
  [8819] = {.lex_state = 339},
  [8820] = {.lex_state = 339},
  [8821] = {.lex_state = 339},
  [8822] = {.lex_state = 339},
  [8823] = {.lex_state = 339},
  [8824] = {.lex_state = 339},
  [8825] = {.lex_state = 339},
  [8826] = {.lex_state = 339},
  [8827] = {.lex_state = 0},
  [8828] = {.lex_state = 0},
  [8829] = {.lex_state = 339},
  [8830] = {.lex_state = 173},
  [8831] = {.lex_state = 0},
  [8832] = {.lex_state = 339},
  [8833] = {.lex_state = 339},
  [8834] = {.lex_state = 339},
  [8835] = {.lex_state = 339},
  [8836] = {.lex_state = 339},
  [8837] = {.lex_state = 173},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym___attribute] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym__Nonnull] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_constinit] = ACTIONS(1),
    [anon_sym_consteval] = ACTIONS(1),
    [anon_sym_alignas] = ACTIONS(1),
    [anon_sym__Alignas] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_and_eq] = ACTIONS(1),
    [anon_sym_or_eq] = ACTIONS(1),
    [anon_sym_xor_eq] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_compl] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_bitor] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_bitand] = ACTIONS(1),
    [anon_sym_not_eq] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym___asm] = ACTIONS(1),
    [anon_sym___volatile__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_STAR] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1),
    [anon_sym_decltype] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_typename] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_template] = ACTIONS(1),
    [anon_sym_GT2] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(1),
    [anon_sym_friend] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_noexcept] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_static_assert] = ACTIONS(1),
    [anon_sym_concept] = ACTIONS(1),
    [anon_sym_co_return] = ACTIONS(1),
    [anon_sym_co_yield] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_R_DQUOTE] = ACTIONS(1),
    [anon_sym_LR_DQUOTE] = ACTIONS(1),
    [anon_sym_uR_DQUOTE] = ACTIONS(1),
    [anon_sym_UR_DQUOTE] = ACTIONS(1),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1),
    [anon_sym_co_await] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_raw_string_delimiter] = ACTIONS(1),
    [sym_raw_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(8391),
    [sym__top_level_item] = STATE(34),
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4748),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6326),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(34),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2748),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(546),
    [sym__top_level_statement] = STATE(34),
    [sym_labeled_statement] = STATE(34),
    [sym__top_level_expression_statement] = STATE(34),
    [sym_if_statement] = STATE(34),
    [sym_switch_statement] = STATE(34),
    [sym_case_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_do_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_goto_statement] = STATE(34),
    [sym_expression] = STATE(4786),
    [sym__string] = STATE(4787),
    [sym_conditional_expression] = STATE(4850),
    [sym_assignment_expression] = STATE(4850),
    [sym_pointer_expression] = STATE(3693),
    [sym_unary_expression] = STATE(4850),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(4850),
    [sym_cast_expression] = STATE(4850),
    [sym_sizeof_expression] = STATE(4850),
    [sym_alignof_expression] = STATE(4850),
    [sym_offsetof_expression] = STATE(4850),
    [sym_generic_expression] = STATE(4850),
    [sym_subscript_expression] = STATE(3693),
    [sym_call_expression] = STATE(3693),
    [sym_gnu_asm_expression] = STATE(4850),
    [sym_extension_expression] = STATE(4850),
    [sym_field_expression] = STATE(3693),
    [sym_compound_literal_expression] = STATE(4850),
    [sym_parenthesized_expression] = STATE(3693),
    [sym_char_literal] = STATE(4787),
    [sym_concatenated_string] = STATE(4787),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(4850),
    [sym__empty_declaration] = STATE(34),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1831),
    [sym_dependent_type] = STATE(2523),
    [sym_module_declaration] = STATE(34),
    [sym_export_declaration] = STATE(34),
    [sym_import_declaration] = STATE(34),
    [sym_global_module_fragment_declaration] = STATE(34),
    [sym_private_module_fragment_declaration] = STATE(34),
    [sym_template_declaration] = STATE(34),
    [sym_template_instantiation] = STATE(34),
    [sym_operator_cast] = STATE(6833),
    [sym__constructor_specifiers] = STATE(1831),
    [sym_operator_cast_definition] = STATE(34),
    [sym_operator_cast_declaration] = STATE(34),
    [sym_constructor_or_destructor_definition] = STATE(34),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4830),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_alias_definition] = STATE(34),
    [sym_using_declaration] = STATE(34),
    [sym_alias_declaration] = STATE(34),
    [sym_static_assert_declaration] = STATE(34),
    [sym_concept_definition] = STATE(34),
    [sym_for_range_loop] = STATE(34),
    [sym_co_return_statement] = STATE(34),
    [sym_co_yield_statement] = STATE(34),
    [sym_throw_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(4850),
    [sym_new_expression] = STATE(4850),
    [sym_delete_expression] = STATE(4850),
    [sym_requires_clause] = STATE(4850),
    [sym_requires_expression] = STATE(4850),
    [sym_lambda_expression] = STATE(4850),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(4850),
    [sym_parameter_pack_expansion] = STATE(4850),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3691),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6833),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3693),
    [aux_sym_translation_unit_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(145),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1831),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(33),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(65),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(115),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(121),
    [sym_false] = ACTIONS(121),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(137),
    [anon_sym_template] = ACTIONS(139),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_static_assert] = ACTIONS(151),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(121),
  },
  [2] = {
    [sym__block_item] = STATE(83),
    [sym_preproc_include] = STATE(83),
    [sym_preproc_def] = STATE(83),
    [sym_preproc_function_def] = STATE(83),
    [sym_preproc_call] = STATE(83),
    [sym_preproc_if] = STATE(83),
    [sym_preproc_ifdef] = STATE(83),
    [sym_function_definition] = STATE(83),
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(83),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(83),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(83),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(83),
    [sym_template_instantiation] = STATE(83),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(83),
    [sym_operator_cast_declaration] = STATE(83),
    [sym_constructor_or_destructor_definition] = STATE(83),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(83),
    [sym_namespace_alias_definition] = STATE(83),
    [sym_using_declaration] = STATE(83),
    [sym_alias_declaration] = STATE(83),
    [sym_static_assert_declaration] = STATE(83),
    [sym_concept_definition] = STATE(83),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(83),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(193),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [3] = {
    [sym__block_item] = STATE(80),
    [sym_preproc_include] = STATE(80),
    [sym_preproc_def] = STATE(80),
    [sym_preproc_function_def] = STATE(80),
    [sym_preproc_call] = STATE(80),
    [sym_preproc_if] = STATE(80),
    [sym_preproc_ifdef] = STATE(80),
    [sym_function_definition] = STATE(80),
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(80),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(80),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(80),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(80),
    [sym_template_instantiation] = STATE(80),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(80),
    [sym_operator_cast_declaration] = STATE(80),
    [sym_constructor_or_destructor_definition] = STATE(80),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(80),
    [sym_namespace_alias_definition] = STATE(80),
    [sym_using_declaration] = STATE(80),
    [sym_alias_declaration] = STATE(80),
    [sym_static_assert_declaration] = STATE(80),
    [sym_concept_definition] = STATE(80),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(80),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [4] = {
    [sym__block_item] = STATE(68),
    [sym_preproc_include] = STATE(68),
    [sym_preproc_def] = STATE(68),
    [sym_preproc_function_def] = STATE(68),
    [sym_preproc_call] = STATE(68),
    [sym_preproc_if] = STATE(68),
    [sym_preproc_ifdef] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(68),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(68),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(68),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(68),
    [sym_template_instantiation] = STATE(68),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(68),
    [sym_operator_cast_declaration] = STATE(68),
    [sym_constructor_or_destructor_definition] = STATE(68),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(68),
    [sym_namespace_alias_definition] = STATE(68),
    [sym_using_declaration] = STATE(68),
    [sym_alias_declaration] = STATE(68),
    [sym_static_assert_declaration] = STATE(68),
    [sym_concept_definition] = STATE(68),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(68),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [5] = {
    [sym__block_item] = STATE(40),
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(40),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(40),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(40),
    [sym_template_instantiation] = STATE(40),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(40),
    [sym_operator_cast_declaration] = STATE(40),
    [sym_constructor_or_destructor_definition] = STATE(40),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(40),
    [sym_namespace_alias_definition] = STATE(40),
    [sym_using_declaration] = STATE(40),
    [sym_alias_declaration] = STATE(40),
    [sym_static_assert_declaration] = STATE(40),
    [sym_concept_definition] = STATE(40),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(251),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [6] = {
    [sym__block_item] = STATE(40),
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(40),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(40),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(40),
    [sym_template_instantiation] = STATE(40),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(40),
    [sym_operator_cast_declaration] = STATE(40),
    [sym_constructor_or_destructor_definition] = STATE(40),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(40),
    [sym_namespace_alias_definition] = STATE(40),
    [sym_using_declaration] = STATE(40),
    [sym_alias_declaration] = STATE(40),
    [sym_static_assert_declaration] = STATE(40),
    [sym_concept_definition] = STATE(40),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [7] = {
    [sym__block_item] = STATE(52),
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(52),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(52),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(52),
    [sym_template_instantiation] = STATE(52),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(52),
    [sym_operator_cast_declaration] = STATE(52),
    [sym_constructor_or_destructor_definition] = STATE(52),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(52),
    [sym_namespace_alias_definition] = STATE(52),
    [sym_using_declaration] = STATE(52),
    [sym_alias_declaration] = STATE(52),
    [sym_static_assert_declaration] = STATE(52),
    [sym_concept_definition] = STATE(52),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [8] = {
    [sym__block_item] = STATE(65),
    [sym_preproc_include] = STATE(65),
    [sym_preproc_def] = STATE(65),
    [sym_preproc_function_def] = STATE(65),
    [sym_preproc_call] = STATE(65),
    [sym_preproc_if] = STATE(65),
    [sym_preproc_ifdef] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(65),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(65),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(65),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(65),
    [sym_template_instantiation] = STATE(65),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(65),
    [sym_operator_cast_declaration] = STATE(65),
    [sym_constructor_or_destructor_definition] = STATE(65),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(65),
    [sym_namespace_alias_definition] = STATE(65),
    [sym_using_declaration] = STATE(65),
    [sym_alias_declaration] = STATE(65),
    [sym_static_assert_declaration] = STATE(65),
    [sym_concept_definition] = STATE(65),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(65),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [9] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [10] = {
    [sym__block_item] = STATE(65),
    [sym_preproc_include] = STATE(65),
    [sym_preproc_def] = STATE(65),
    [sym_preproc_function_def] = STATE(65),
    [sym_preproc_call] = STATE(65),
    [sym_preproc_if] = STATE(65),
    [sym_preproc_ifdef] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(65),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(65),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(65),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(65),
    [sym_template_instantiation] = STATE(65),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(65),
    [sym_operator_cast_declaration] = STATE(65),
    [sym_constructor_or_destructor_definition] = STATE(65),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(65),
    [sym_namespace_alias_definition] = STATE(65),
    [sym_using_declaration] = STATE(65),
    [sym_alias_declaration] = STATE(65),
    [sym_static_assert_declaration] = STATE(65),
    [sym_concept_definition] = STATE(65),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(65),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [11] = {
    [sym__block_item] = STATE(80),
    [sym_preproc_include] = STATE(80),
    [sym_preproc_def] = STATE(80),
    [sym_preproc_function_def] = STATE(80),
    [sym_preproc_call] = STATE(80),
    [sym_preproc_if] = STATE(80),
    [sym_preproc_ifdef] = STATE(80),
    [sym_function_definition] = STATE(80),
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(80),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(80),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(80),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(80),
    [sym_template_instantiation] = STATE(80),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(80),
    [sym_operator_cast_declaration] = STATE(80),
    [sym_constructor_or_destructor_definition] = STATE(80),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(80),
    [sym_namespace_alias_definition] = STATE(80),
    [sym_using_declaration] = STATE(80),
    [sym_alias_declaration] = STATE(80),
    [sym_static_assert_declaration] = STATE(80),
    [sym_concept_definition] = STATE(80),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(80),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [12] = {
    [sym__block_item] = STATE(83),
    [sym_preproc_include] = STATE(83),
    [sym_preproc_def] = STATE(83),
    [sym_preproc_function_def] = STATE(83),
    [sym_preproc_call] = STATE(83),
    [sym_preproc_if] = STATE(83),
    [sym_preproc_ifdef] = STATE(83),
    [sym_function_definition] = STATE(83),
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(83),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(83),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(83),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(83),
    [sym_template_instantiation] = STATE(83),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(83),
    [sym_operator_cast_declaration] = STATE(83),
    [sym_constructor_or_destructor_definition] = STATE(83),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(83),
    [sym_namespace_alias_definition] = STATE(83),
    [sym_using_declaration] = STATE(83),
    [sym_alias_declaration] = STATE(83),
    [sym_static_assert_declaration] = STATE(83),
    [sym_concept_definition] = STATE(83),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(83),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(167),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(265),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [13] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8233),
    [sym_preproc_elif] = STATE(8233),
    [sym_preproc_elifdef] = STATE(8233),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(275),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [14] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(7926),
    [sym_preproc_elif] = STATE(7926),
    [sym_preproc_elifdef] = STATE(7926),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(22),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(22),
    [sym_template_instantiation] = STATE(22),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(22),
    [sym_operator_cast_declaration] = STATE(22),
    [sym_constructor_or_destructor_definition] = STATE(22),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(22),
    [sym_namespace_alias_definition] = STATE(22),
    [sym_using_declaration] = STATE(22),
    [sym_alias_declaration] = STATE(22),
    [sym_static_assert_declaration] = STATE(22),
    [sym_concept_definition] = STATE(22),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(343),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [15] = {
    [sym__block_item] = STATE(17),
    [sym_preproc_include] = STATE(17),
    [sym_preproc_def] = STATE(17),
    [sym_preproc_function_def] = STATE(17),
    [sym_preproc_call] = STATE(17),
    [sym_preproc_if] = STATE(17),
    [sym_preproc_ifdef] = STATE(17),
    [sym_preproc_else] = STATE(8680),
    [sym_preproc_elif] = STATE(8680),
    [sym_preproc_elifdef] = STATE(8680),
    [sym_function_definition] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_type_definition] = STATE(17),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(17),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(17),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(17),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(17),
    [sym_template_instantiation] = STATE(17),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(17),
    [sym_operator_cast_declaration] = STATE(17),
    [sym_constructor_or_destructor_definition] = STATE(17),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(17),
    [sym_namespace_alias_definition] = STATE(17),
    [sym_using_declaration] = STATE(17),
    [sym_alias_declaration] = STATE(17),
    [sym_static_assert_declaration] = STATE(17),
    [sym_concept_definition] = STATE(17),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(17),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [16] = {
    [sym__block_item] = STATE(13),
    [sym_preproc_include] = STATE(13),
    [sym_preproc_def] = STATE(13),
    [sym_preproc_function_def] = STATE(13),
    [sym_preproc_call] = STATE(13),
    [sym_preproc_if] = STATE(13),
    [sym_preproc_ifdef] = STATE(13),
    [sym_preproc_else] = STATE(8219),
    [sym_preproc_elif] = STATE(8219),
    [sym_preproc_elifdef] = STATE(8219),
    [sym_function_definition] = STATE(13),
    [sym_declaration] = STATE(13),
    [sym_type_definition] = STATE(13),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(13),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(13),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(13),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(13),
    [sym_template_instantiation] = STATE(13),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(13),
    [sym_operator_cast_declaration] = STATE(13),
    [sym_constructor_or_destructor_definition] = STATE(13),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(13),
    [sym_namespace_alias_definition] = STATE(13),
    [sym_using_declaration] = STATE(13),
    [sym_alias_declaration] = STATE(13),
    [sym_static_assert_declaration] = STATE(13),
    [sym_concept_definition] = STATE(13),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(13),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(347),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [17] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8276),
    [sym_preproc_elif] = STATE(8276),
    [sym_preproc_elifdef] = STATE(8276),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [18] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8016),
    [sym_preproc_elif] = STATE(8016),
    [sym_preproc_elifdef] = STATE(8016),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(351),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [19] = {
    [sym__block_item] = STATE(20),
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(8326),
    [sym_preproc_elif] = STATE(8326),
    [sym_preproc_elifdef] = STATE(8326),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(20),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(20),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(20),
    [sym_template_instantiation] = STATE(20),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(20),
    [sym_operator_cast_declaration] = STATE(20),
    [sym_constructor_or_destructor_definition] = STATE(20),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(20),
    [sym_namespace_alias_definition] = STATE(20),
    [sym_using_declaration] = STATE(20),
    [sym_alias_declaration] = STATE(20),
    [sym_static_assert_declaration] = STATE(20),
    [sym_concept_definition] = STATE(20),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [20] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8350),
    [sym_preproc_elif] = STATE(8350),
    [sym_preproc_elifdef] = STATE(8350),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [21] = {
    [sym__block_item] = STATE(23),
    [sym_preproc_include] = STATE(23),
    [sym_preproc_def] = STATE(23),
    [sym_preproc_function_def] = STATE(23),
    [sym_preproc_call] = STATE(23),
    [sym_preproc_if] = STATE(23),
    [sym_preproc_ifdef] = STATE(23),
    [sym_preproc_else] = STATE(8286),
    [sym_preproc_elif] = STATE(8286),
    [sym_preproc_elifdef] = STATE(8286),
    [sym_function_definition] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_type_definition] = STATE(23),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(23),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(23),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(23),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(23),
    [sym_template_instantiation] = STATE(23),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(23),
    [sym_operator_cast_declaration] = STATE(23),
    [sym_constructor_or_destructor_definition] = STATE(23),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(23),
    [sym_namespace_alias_definition] = STATE(23),
    [sym_using_declaration] = STATE(23),
    [sym_alias_declaration] = STATE(23),
    [sym_static_assert_declaration] = STATE(23),
    [sym_concept_definition] = STATE(23),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(23),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [22] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8335),
    [sym_preproc_elif] = STATE(8335),
    [sym_preproc_elifdef] = STATE(8335),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [23] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8407),
    [sym_preproc_elif] = STATE(8407),
    [sym_preproc_elifdef] = STATE(8407),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [24] = {
    [sym__block_item] = STATE(26),
    [sym_preproc_include] = STATE(26),
    [sym_preproc_def] = STATE(26),
    [sym_preproc_function_def] = STATE(26),
    [sym_preproc_call] = STATE(26),
    [sym_preproc_if] = STATE(26),
    [sym_preproc_ifdef] = STATE(26),
    [sym_preproc_else] = STATE(8757),
    [sym_preproc_elif] = STATE(8757),
    [sym_preproc_elifdef] = STATE(8757),
    [sym_function_definition] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_type_definition] = STATE(26),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(26),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(26),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(26),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(26),
    [sym_template_instantiation] = STATE(26),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(26),
    [sym_operator_cast_declaration] = STATE(26),
    [sym_constructor_or_destructor_definition] = STATE(26),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(26),
    [sym_namespace_alias_definition] = STATE(26),
    [sym_using_declaration] = STATE(26),
    [sym_alias_declaration] = STATE(26),
    [sym_static_assert_declaration] = STATE(26),
    [sym_concept_definition] = STATE(26),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(26),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [25] = {
    [sym__block_item] = STATE(28),
    [sym_preproc_include] = STATE(28),
    [sym_preproc_def] = STATE(28),
    [sym_preproc_function_def] = STATE(28),
    [sym_preproc_call] = STATE(28),
    [sym_preproc_if] = STATE(28),
    [sym_preproc_ifdef] = STATE(28),
    [sym_preproc_else] = STATE(8566),
    [sym_preproc_elif] = STATE(8566),
    [sym_preproc_elifdef] = STATE(8566),
    [sym_function_definition] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_type_definition] = STATE(28),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(28),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(28),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(28),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(28),
    [sym_template_instantiation] = STATE(28),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(28),
    [sym_operator_cast_declaration] = STATE(28),
    [sym_constructor_or_destructor_definition] = STATE(28),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(28),
    [sym_namespace_alias_definition] = STATE(28),
    [sym_using_declaration] = STATE(28),
    [sym_alias_declaration] = STATE(28),
    [sym_static_assert_declaration] = STATE(28),
    [sym_concept_definition] = STATE(28),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(28),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [26] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8269),
    [sym_preproc_elif] = STATE(8269),
    [sym_preproc_elifdef] = STATE(8269),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [27] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_preproc_else] = STATE(8361),
    [sym_preproc_elif] = STATE(8361),
    [sym_preproc_elifdef] = STATE(8361),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [28] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7934),
    [sym_preproc_elif] = STATE(7934),
    [sym_preproc_elifdef] = STATE(7934),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [29] = {
    [sym__block_item] = STATE(18),
    [sym_preproc_include] = STATE(18),
    [sym_preproc_def] = STATE(18),
    [sym_preproc_function_def] = STATE(18),
    [sym_preproc_call] = STATE(18),
    [sym_preproc_if] = STATE(18),
    [sym_preproc_ifdef] = STATE(18),
    [sym_preproc_else] = STATE(7923),
    [sym_preproc_elif] = STATE(7923),
    [sym_preproc_elifdef] = STATE(7923),
    [sym_function_definition] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_type_definition] = STATE(18),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(18),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(18),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(18),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(18),
    [sym_template_instantiation] = STATE(18),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(18),
    [sym_operator_cast_declaration] = STATE(18),
    [sym_constructor_or_destructor_definition] = STATE(18),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(18),
    [sym_namespace_alias_definition] = STATE(18),
    [sym_using_declaration] = STATE(18),
    [sym_alias_declaration] = STATE(18),
    [sym_static_assert_declaration] = STATE(18),
    [sym_concept_definition] = STATE(18),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(18),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [30] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8425),
    [sym_preproc_elif] = STATE(8425),
    [sym_preproc_elifdef] = STATE(8425),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [31] = {
    [sym__block_item] = STATE(32),
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_preproc_else] = STATE(8422),
    [sym_preproc_elif] = STATE(8422),
    [sym_preproc_elifdef] = STATE(8422),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(32),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(32),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(32),
    [sym_template_instantiation] = STATE(32),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(32),
    [sym_operator_cast_declaration] = STATE(32),
    [sym_constructor_or_destructor_definition] = STATE(32),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(32),
    [sym_namespace_alias_definition] = STATE(32),
    [sym_using_declaration] = STATE(32),
    [sym_alias_declaration] = STATE(32),
    [sym_static_assert_declaration] = STATE(32),
    [sym_concept_definition] = STATE(32),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(377),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [32] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8229),
    [sym_preproc_elif] = STATE(8229),
    [sym_preproc_elifdef] = STATE(8229),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(267),
    [aux_sym_preproc_include_token1] = ACTIONS(269),
    [aux_sym_preproc_def_token1] = ACTIONS(271),
    [aux_sym_preproc_if_token1] = ACTIONS(273),
    [aux_sym_preproc_if_token2] = ACTIONS(379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(277),
    [aux_sym_preproc_else_token1] = ACTIONS(279),
    [aux_sym_preproc_elif_token1] = ACTIONS(281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(283),
    [sym_preproc_directive] = ACTIONS(285),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(289),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(293),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(299),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(327),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(335),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [33] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6310),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(432),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1731),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1731),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(147),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1731),
    [sym_identifier] = ACTIONS(381),
    [aux_sym_preproc_include_token1] = ACTIONS(384),
    [aux_sym_preproc_def_token1] = ACTIONS(387),
    [aux_sym_preproc_if_token1] = ACTIONS(390),
    [aux_sym_preproc_if_token2] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [aux_sym_preproc_else_token1] = ACTIONS(393),
    [aux_sym_preproc_elif_token1] = ACTIONS(393),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(393),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(393),
    [sym_preproc_directive] = ACTIONS(398),
    [anon_sym_LPAREN2] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(404),
    [anon_sym_TILDE] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_PLUS] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym___extension__] = ACTIONS(425),
    [anon_sym_typedef] = ACTIONS(428),
    [anon_sym_virtual] = ACTIONS(431),
    [anon_sym_extern] = ACTIONS(434),
    [anon_sym___attribute__] = ACTIONS(437),
    [anon_sym___attribute] = ACTIONS(437),
    [anon_sym_using] = ACTIONS(440),
    [anon_sym_COLON_COLON] = ACTIONS(443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(446),
    [anon_sym___declspec] = ACTIONS(449),
    [anon_sym___based] = ACTIONS(452),
    [anon_sym___cdecl] = ACTIONS(455),
    [anon_sym___clrcall] = ACTIONS(455),
    [anon_sym___stdcall] = ACTIONS(455),
    [anon_sym___fastcall] = ACTIONS(455),
    [anon_sym___thiscall] = ACTIONS(455),
    [anon_sym___vectorcall] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(458),
    [anon_sym_signed] = ACTIONS(461),
    [anon_sym_unsigned] = ACTIONS(461),
    [anon_sym_long] = ACTIONS(461),
    [anon_sym_short] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_static] = ACTIONS(467),
    [anon_sym_register] = ACTIONS(467),
    [anon_sym_inline] = ACTIONS(470),
    [anon_sym___inline] = ACTIONS(467),
    [anon_sym___inline__] = ACTIONS(467),
    [anon_sym___forceinline] = ACTIONS(467),
    [anon_sym_thread_local] = ACTIONS(467),
    [anon_sym___thread] = ACTIONS(467),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym___restrict__] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym__Noreturn] = ACTIONS(473),
    [anon_sym_noreturn] = ACTIONS(473),
    [anon_sym__Nonnull] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_constinit] = ACTIONS(473),
    [anon_sym_consteval] = ACTIONS(473),
    [anon_sym_alignas] = ACTIONS(476),
    [anon_sym__Alignas] = ACTIONS(476),
    [sym_primitive_type] = ACTIONS(479),
    [anon_sym_enum] = ACTIONS(482),
    [anon_sym_class] = ACTIONS(485),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_union] = ACTIONS(491),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_switch] = ACTIONS(497),
    [anon_sym_case] = ACTIONS(500),
    [anon_sym_default] = ACTIONS(503),
    [anon_sym_while] = ACTIONS(506),
    [anon_sym_do] = ACTIONS(509),
    [anon_sym_for] = ACTIONS(512),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(518),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(527),
    [anon_sym___leave] = ACTIONS(530),
    [anon_sym_not] = ACTIONS(410),
    [anon_sym_compl] = ACTIONS(410),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_sizeof] = ACTIONS(536),
    [anon_sym___alignof__] = ACTIONS(539),
    [anon_sym___alignof] = ACTIONS(539),
    [anon_sym__alignof] = ACTIONS(539),
    [anon_sym_alignof] = ACTIONS(539),
    [anon_sym__Alignof] = ACTIONS(539),
    [anon_sym_offsetof] = ACTIONS(542),
    [anon_sym__Generic] = ACTIONS(545),
    [anon_sym_asm] = ACTIONS(548),
    [anon_sym___asm__] = ACTIONS(548),
    [anon_sym___asm] = ACTIONS(548),
    [sym_number_literal] = ACTIONS(551),
    [anon_sym_L_SQUOTE] = ACTIONS(554),
    [anon_sym_u_SQUOTE] = ACTIONS(554),
    [anon_sym_U_SQUOTE] = ACTIONS(554),
    [anon_sym_u8_SQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(554),
    [anon_sym_L_DQUOTE] = ACTIONS(557),
    [anon_sym_u_DQUOTE] = ACTIONS(557),
    [anon_sym_U_DQUOTE] = ACTIONS(557),
    [anon_sym_u8_DQUOTE] = ACTIONS(557),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [sym_true] = ACTIONS(560),
    [sym_false] = ACTIONS(560),
    [anon_sym_NULL] = ACTIONS(563),
    [anon_sym_nullptr] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(566),
    [anon_sym_decltype] = ACTIONS(569),
    [anon_sym_explicit] = ACTIONS(572),
    [anon_sym_typename] = ACTIONS(575),
    [anon_sym_template] = ACTIONS(578),
    [anon_sym_operator] = ACTIONS(581),
    [anon_sym_try] = ACTIONS(584),
    [anon_sym_delete] = ACTIONS(587),
    [anon_sym_throw] = ACTIONS(590),
    [anon_sym_namespace] = ACTIONS(593),
    [anon_sym_static_assert] = ACTIONS(596),
    [anon_sym_concept] = ACTIONS(599),
    [anon_sym_co_return] = ACTIONS(602),
    [anon_sym_co_yield] = ACTIONS(605),
    [anon_sym_R_DQUOTE] = ACTIONS(608),
    [anon_sym_LR_DQUOTE] = ACTIONS(608),
    [anon_sym_uR_DQUOTE] = ACTIONS(608),
    [anon_sym_UR_DQUOTE] = ACTIONS(608),
    [anon_sym_u8R_DQUOTE] = ACTIONS(608),
    [anon_sym_co_await] = ACTIONS(611),
    [anon_sym_new] = ACTIONS(614),
    [anon_sym_requires] = ACTIONS(617),
    [sym_this] = ACTIONS(560),
  },
  [34] = {
    [sym__top_level_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4748),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6326),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(35),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2748),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(546),
    [sym__top_level_statement] = STATE(35),
    [sym_labeled_statement] = STATE(35),
    [sym__top_level_expression_statement] = STATE(35),
    [sym_if_statement] = STATE(35),
    [sym_switch_statement] = STATE(35),
    [sym_case_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_do_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_return_statement] = STATE(35),
    [sym_break_statement] = STATE(35),
    [sym_continue_statement] = STATE(35),
    [sym_goto_statement] = STATE(35),
    [sym_expression] = STATE(4786),
    [sym__string] = STATE(4787),
    [sym_conditional_expression] = STATE(4850),
    [sym_assignment_expression] = STATE(4850),
    [sym_pointer_expression] = STATE(3693),
    [sym_unary_expression] = STATE(4850),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(4850),
    [sym_cast_expression] = STATE(4850),
    [sym_sizeof_expression] = STATE(4850),
    [sym_alignof_expression] = STATE(4850),
    [sym_offsetof_expression] = STATE(4850),
    [sym_generic_expression] = STATE(4850),
    [sym_subscript_expression] = STATE(3693),
    [sym_call_expression] = STATE(3693),
    [sym_gnu_asm_expression] = STATE(4850),
    [sym_extension_expression] = STATE(4850),
    [sym_field_expression] = STATE(3693),
    [sym_compound_literal_expression] = STATE(4850),
    [sym_parenthesized_expression] = STATE(3693),
    [sym_char_literal] = STATE(4787),
    [sym_concatenated_string] = STATE(4787),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(4850),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1831),
    [sym_dependent_type] = STATE(2523),
    [sym_module_declaration] = STATE(35),
    [sym_export_declaration] = STATE(35),
    [sym_import_declaration] = STATE(35),
    [sym_global_module_fragment_declaration] = STATE(35),
    [sym_private_module_fragment_declaration] = STATE(35),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(6833),
    [sym__constructor_specifiers] = STATE(1831),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4830),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(35),
    [sym_co_return_statement] = STATE(35),
    [sym_co_yield_statement] = STATE(35),
    [sym_throw_statement] = STATE(35),
    [sym_try_statement] = STATE(35),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(4850),
    [sym_new_expression] = STATE(4850),
    [sym_delete_expression] = STATE(4850),
    [sym_requires_clause] = STATE(4850),
    [sym_requires_expression] = STATE(4850),
    [sym_lambda_expression] = STATE(4850),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(4850),
    [sym_parameter_pack_expansion] = STATE(4850),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3691),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6833),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3693),
    [aux_sym_translation_unit_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(145),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1831),
    [ts_builtin_sym_end] = ACTIONS(620),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(33),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(65),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(115),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(121),
    [sym_false] = ACTIONS(121),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(137),
    [anon_sym_template] = ACTIONS(139),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_static_assert] = ACTIONS(151),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(121),
  },
  [35] = {
    [sym__top_level_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4748),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6326),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(35),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2748),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(546),
    [sym__top_level_statement] = STATE(35),
    [sym_labeled_statement] = STATE(35),
    [sym__top_level_expression_statement] = STATE(35),
    [sym_if_statement] = STATE(35),
    [sym_switch_statement] = STATE(35),
    [sym_case_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_do_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_return_statement] = STATE(35),
    [sym_break_statement] = STATE(35),
    [sym_continue_statement] = STATE(35),
    [sym_goto_statement] = STATE(35),
    [sym_expression] = STATE(4786),
    [sym__string] = STATE(4787),
    [sym_conditional_expression] = STATE(4850),
    [sym_assignment_expression] = STATE(4850),
    [sym_pointer_expression] = STATE(3693),
    [sym_unary_expression] = STATE(4850),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(4850),
    [sym_cast_expression] = STATE(4850),
    [sym_sizeof_expression] = STATE(4850),
    [sym_alignof_expression] = STATE(4850),
    [sym_offsetof_expression] = STATE(4850),
    [sym_generic_expression] = STATE(4850),
    [sym_subscript_expression] = STATE(3693),
    [sym_call_expression] = STATE(3693),
    [sym_gnu_asm_expression] = STATE(4850),
    [sym_extension_expression] = STATE(4850),
    [sym_field_expression] = STATE(3693),
    [sym_compound_literal_expression] = STATE(4850),
    [sym_parenthesized_expression] = STATE(3693),
    [sym_char_literal] = STATE(4787),
    [sym_concatenated_string] = STATE(4787),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(4850),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1831),
    [sym_dependent_type] = STATE(2523),
    [sym_module_declaration] = STATE(35),
    [sym_export_declaration] = STATE(35),
    [sym_import_declaration] = STATE(35),
    [sym_global_module_fragment_declaration] = STATE(35),
    [sym_private_module_fragment_declaration] = STATE(35),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(6833),
    [sym__constructor_specifiers] = STATE(1831),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4830),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(35),
    [sym_co_return_statement] = STATE(35),
    [sym_co_yield_statement] = STATE(35),
    [sym_throw_statement] = STATE(35),
    [sym_try_statement] = STATE(35),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(4850),
    [sym_new_expression] = STATE(4850),
    [sym_delete_expression] = STATE(4850),
    [sym_requires_clause] = STATE(4850),
    [sym_requires_expression] = STATE(4850),
    [sym_lambda_expression] = STATE(4850),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(4850),
    [sym_parameter_pack_expansion] = STATE(4850),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3691),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6833),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3693),
    [aux_sym_translation_unit_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(145),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1831),
    [ts_builtin_sym_end] = ACTIONS(622),
    [sym_identifier] = ACTIONS(624),
    [aux_sym_preproc_include_token1] = ACTIONS(627),
    [aux_sym_preproc_def_token1] = ACTIONS(630),
    [aux_sym_preproc_if_token1] = ACTIONS(633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(636),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(636),
    [sym_preproc_directive] = ACTIONS(639),
    [anon_sym_LPAREN2] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(648),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(660),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym___extension__] = ACTIONS(666),
    [anon_sym_typedef] = ACTIONS(669),
    [anon_sym_virtual] = ACTIONS(672),
    [anon_sym_extern] = ACTIONS(675),
    [anon_sym___attribute__] = ACTIONS(678),
    [anon_sym___attribute] = ACTIONS(678),
    [anon_sym_using] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(684),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(687),
    [anon_sym___declspec] = ACTIONS(690),
    [anon_sym___based] = ACTIONS(693),
    [anon_sym___cdecl] = ACTIONS(696),
    [anon_sym___clrcall] = ACTIONS(696),
    [anon_sym___stdcall] = ACTIONS(696),
    [anon_sym___fastcall] = ACTIONS(696),
    [anon_sym___thiscall] = ACTIONS(696),
    [anon_sym___vectorcall] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(699),
    [anon_sym_signed] = ACTIONS(702),
    [anon_sym_unsigned] = ACTIONS(702),
    [anon_sym_long] = ACTIONS(702),
    [anon_sym_short] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(705),
    [anon_sym_static] = ACTIONS(708),
    [anon_sym_register] = ACTIONS(708),
    [anon_sym_inline] = ACTIONS(711),
    [anon_sym___inline] = ACTIONS(708),
    [anon_sym___inline__] = ACTIONS(708),
    [anon_sym___forceinline] = ACTIONS(708),
    [anon_sym_thread_local] = ACTIONS(708),
    [anon_sym___thread] = ACTIONS(708),
    [anon_sym_const] = ACTIONS(714),
    [anon_sym_constexpr] = ACTIONS(714),
    [anon_sym_volatile] = ACTIONS(714),
    [anon_sym_restrict] = ACTIONS(714),
    [anon_sym___restrict__] = ACTIONS(714),
    [anon_sym__Atomic] = ACTIONS(714),
    [anon_sym__Noreturn] = ACTIONS(714),
    [anon_sym_noreturn] = ACTIONS(714),
    [anon_sym__Nonnull] = ACTIONS(714),
    [anon_sym_mutable] = ACTIONS(714),
    [anon_sym_constinit] = ACTIONS(714),
    [anon_sym_consteval] = ACTIONS(714),
    [anon_sym_alignas] = ACTIONS(717),
    [anon_sym__Alignas] = ACTIONS(717),
    [sym_primitive_type] = ACTIONS(720),
    [anon_sym_enum] = ACTIONS(723),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_struct] = ACTIONS(729),
    [anon_sym_union] = ACTIONS(732),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_switch] = ACTIONS(738),
    [anon_sym_case] = ACTIONS(741),
    [anon_sym_default] = ACTIONS(744),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_do] = ACTIONS(750),
    [anon_sym_for] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(756),
    [anon_sym_break] = ACTIONS(759),
    [anon_sym_continue] = ACTIONS(762),
    [anon_sym_goto] = ACTIONS(765),
    [anon_sym_not] = ACTIONS(651),
    [anon_sym_compl] = ACTIONS(651),
    [anon_sym_DASH_DASH] = ACTIONS(768),
    [anon_sym_PLUS_PLUS] = ACTIONS(768),
    [anon_sym_sizeof] = ACTIONS(771),
    [anon_sym___alignof__] = ACTIONS(774),
    [anon_sym___alignof] = ACTIONS(774),
    [anon_sym__alignof] = ACTIONS(774),
    [anon_sym_alignof] = ACTIONS(774),
    [anon_sym__Alignof] = ACTIONS(774),
    [anon_sym_offsetof] = ACTIONS(777),
    [anon_sym__Generic] = ACTIONS(780),
    [anon_sym_asm] = ACTIONS(783),
    [anon_sym___asm__] = ACTIONS(783),
    [anon_sym___asm] = ACTIONS(783),
    [sym_number_literal] = ACTIONS(786),
    [anon_sym_L_SQUOTE] = ACTIONS(789),
    [anon_sym_u_SQUOTE] = ACTIONS(789),
    [anon_sym_U_SQUOTE] = ACTIONS(789),
    [anon_sym_u8_SQUOTE] = ACTIONS(789),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [anon_sym_L_DQUOTE] = ACTIONS(792),
    [anon_sym_u_DQUOTE] = ACTIONS(792),
    [anon_sym_U_DQUOTE] = ACTIONS(792),
    [anon_sym_u8_DQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(792),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [anon_sym_NULL] = ACTIONS(798),
    [anon_sym_nullptr] = ACTIONS(798),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(801),
    [anon_sym_decltype] = ACTIONS(804),
    [anon_sym_explicit] = ACTIONS(807),
    [anon_sym_typename] = ACTIONS(810),
    [anon_sym_export] = ACTIONS(813),
    [anon_sym_module] = ACTIONS(816),
    [anon_sym_import] = ACTIONS(819),
    [anon_sym_template] = ACTIONS(822),
    [anon_sym_operator] = ACTIONS(825),
    [anon_sym_try] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_throw] = ACTIONS(834),
    [anon_sym_namespace] = ACTIONS(837),
    [anon_sym_static_assert] = ACTIONS(840),
    [anon_sym_concept] = ACTIONS(843),
    [anon_sym_co_return] = ACTIONS(846),
    [anon_sym_co_yield] = ACTIONS(849),
    [anon_sym_R_DQUOTE] = ACTIONS(852),
    [anon_sym_LR_DQUOTE] = ACTIONS(852),
    [anon_sym_uR_DQUOTE] = ACTIONS(852),
    [anon_sym_UR_DQUOTE] = ACTIONS(852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(852),
    [anon_sym_co_await] = ACTIONS(855),
    [anon_sym_new] = ACTIONS(858),
    [anon_sym_requires] = ACTIONS(861),
    [sym_this] = ACTIONS(795),
  },
  [36] = {
    [sym__block_item] = STATE(83),
    [sym_preproc_include] = STATE(83),
    [sym_preproc_def] = STATE(83),
    [sym_preproc_function_def] = STATE(83),
    [sym_preproc_call] = STATE(83),
    [sym_preproc_if] = STATE(83),
    [sym_preproc_ifdef] = STATE(83),
    [sym_function_definition] = STATE(83),
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(83),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(83),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(83),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(83),
    [sym_template_instantiation] = STATE(83),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(83),
    [sym_operator_cast_declaration] = STATE(83),
    [sym_constructor_or_destructor_definition] = STATE(83),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(83),
    [sym_namespace_alias_definition] = STATE(83),
    [sym_using_declaration] = STATE(83),
    [sym_alias_declaration] = STATE(83),
    [sym_static_assert_declaration] = STATE(83),
    [sym_concept_definition] = STATE(83),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(83),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(868),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [37] = {
    [sym__block_item] = STATE(51),
    [sym_preproc_include] = STATE(51),
    [sym_preproc_def] = STATE(51),
    [sym_preproc_function_def] = STATE(51),
    [sym_preproc_call] = STATE(51),
    [sym_preproc_if] = STATE(51),
    [sym_preproc_ifdef] = STATE(51),
    [sym_function_definition] = STATE(51),
    [sym_declaration] = STATE(51),
    [sym_type_definition] = STATE(51),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4658),
    [sym_linkage_specification] = STATE(51),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1912),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6306),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(529),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2729),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(782),
    [sym_statement] = STATE(51),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(51),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1742),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(51),
    [sym_template_instantiation] = STATE(51),
    [sym_operator_cast] = STATE(6793),
    [sym__constructor_specifiers] = STATE(1742),
    [sym_operator_cast_definition] = STATE(51),
    [sym_operator_cast_declaration] = STATE(51),
    [sym_constructor_or_destructor_definition] = STATE(51),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(51),
    [sym_namespace_alias_definition] = STATE(51),
    [sym_using_declaration] = STATE(51),
    [sym_alias_declaration] = STATE(51),
    [sym_static_assert_declaration] = STATE(51),
    [sym_concept_definition] = STATE(51),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6793),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(51),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(151),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1742),
    [sym_identifier] = ACTIONS(870),
    [aux_sym_preproc_include_token1] = ACTIONS(872),
    [aux_sym_preproc_def_token1] = ACTIONS(874),
    [aux_sym_preproc_if_token1] = ACTIONS(876),
    [aux_sym_preproc_if_token2] = ACTIONS(878),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(880),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(880),
    [sym_preproc_directive] = ACTIONS(882),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(886),
    [anon_sym_typedef] = ACTIONS(888),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(890),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(892),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(896),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(924),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(930),
    [anon_sym_static_assert] = ACTIONS(932),
    [anon_sym_concept] = ACTIONS(934),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [38] = {
    [sym__block_item] = STATE(38),
    [sym_preproc_include] = STATE(38),
    [sym_preproc_def] = STATE(38),
    [sym_preproc_function_def] = STATE(38),
    [sym_preproc_call] = STATE(38),
    [sym_preproc_if] = STATE(38),
    [sym_preproc_ifdef] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_declaration] = STATE(38),
    [sym_type_definition] = STATE(38),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4658),
    [sym_linkage_specification] = STATE(38),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1912),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6306),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(529),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2729),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(782),
    [sym_statement] = STATE(38),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(38),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1742),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(38),
    [sym_template_instantiation] = STATE(38),
    [sym_operator_cast] = STATE(6793),
    [sym__constructor_specifiers] = STATE(1742),
    [sym_operator_cast_definition] = STATE(38),
    [sym_operator_cast_declaration] = STATE(38),
    [sym_constructor_or_destructor_definition] = STATE(38),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(38),
    [sym_namespace_alias_definition] = STATE(38),
    [sym_using_declaration] = STATE(38),
    [sym_alias_declaration] = STATE(38),
    [sym_static_assert_declaration] = STATE(38),
    [sym_concept_definition] = STATE(38),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6793),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(38),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(151),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1742),
    [sym_identifier] = ACTIONS(940),
    [aux_sym_preproc_include_token1] = ACTIONS(943),
    [aux_sym_preproc_def_token1] = ACTIONS(946),
    [aux_sym_preproc_if_token1] = ACTIONS(949),
    [aux_sym_preproc_if_token2] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(952),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(952),
    [sym_preproc_directive] = ACTIONS(955),
    [anon_sym_LPAREN2] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(404),
    [anon_sym_TILDE] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_PLUS] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym___extension__] = ACTIONS(961),
    [anon_sym_typedef] = ACTIONS(964),
    [anon_sym_virtual] = ACTIONS(431),
    [anon_sym_extern] = ACTIONS(967),
    [anon_sym___attribute__] = ACTIONS(437),
    [anon_sym___attribute] = ACTIONS(437),
    [anon_sym_using] = ACTIONS(970),
    [anon_sym_COLON_COLON] = ACTIONS(443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(446),
    [anon_sym___declspec] = ACTIONS(449),
    [anon_sym___based] = ACTIONS(452),
    [anon_sym___cdecl] = ACTIONS(455),
    [anon_sym___clrcall] = ACTIONS(455),
    [anon_sym___stdcall] = ACTIONS(455),
    [anon_sym___fastcall] = ACTIONS(455),
    [anon_sym___thiscall] = ACTIONS(455),
    [anon_sym___vectorcall] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_signed] = ACTIONS(461),
    [anon_sym_unsigned] = ACTIONS(461),
    [anon_sym_long] = ACTIONS(461),
    [anon_sym_short] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_static] = ACTIONS(467),
    [anon_sym_register] = ACTIONS(467),
    [anon_sym_inline] = ACTIONS(976),
    [anon_sym___inline] = ACTIONS(467),
    [anon_sym___inline__] = ACTIONS(467),
    [anon_sym___forceinline] = ACTIONS(467),
    [anon_sym_thread_local] = ACTIONS(467),
    [anon_sym___thread] = ACTIONS(467),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym___restrict__] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym__Noreturn] = ACTIONS(473),
    [anon_sym_noreturn] = ACTIONS(473),
    [anon_sym__Nonnull] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_constinit] = ACTIONS(473),
    [anon_sym_consteval] = ACTIONS(473),
    [anon_sym_alignas] = ACTIONS(476),
    [anon_sym__Alignas] = ACTIONS(476),
    [sym_primitive_type] = ACTIONS(479),
    [anon_sym_enum] = ACTIONS(482),
    [anon_sym_class] = ACTIONS(485),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_union] = ACTIONS(491),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_switch] = ACTIONS(982),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(991),
    [anon_sym_do] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1003),
    [anon_sym_continue] = ACTIONS(1006),
    [anon_sym_goto] = ACTIONS(1009),
    [anon_sym___try] = ACTIONS(1012),
    [anon_sym___leave] = ACTIONS(1015),
    [anon_sym_not] = ACTIONS(410),
    [anon_sym_compl] = ACTIONS(410),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_sizeof] = ACTIONS(536),
    [anon_sym___alignof__] = ACTIONS(539),
    [anon_sym___alignof] = ACTIONS(539),
    [anon_sym__alignof] = ACTIONS(539),
    [anon_sym_alignof] = ACTIONS(539),
    [anon_sym__Alignof] = ACTIONS(539),
    [anon_sym_offsetof] = ACTIONS(542),
    [anon_sym__Generic] = ACTIONS(545),
    [anon_sym_asm] = ACTIONS(548),
    [anon_sym___asm__] = ACTIONS(548),
    [anon_sym___asm] = ACTIONS(548),
    [sym_number_literal] = ACTIONS(551),
    [anon_sym_L_SQUOTE] = ACTIONS(554),
    [anon_sym_u_SQUOTE] = ACTIONS(554),
    [anon_sym_U_SQUOTE] = ACTIONS(554),
    [anon_sym_u8_SQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(554),
    [anon_sym_L_DQUOTE] = ACTIONS(557),
    [anon_sym_u_DQUOTE] = ACTIONS(557),
    [anon_sym_U_DQUOTE] = ACTIONS(557),
    [anon_sym_u8_DQUOTE] = ACTIONS(557),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [sym_true] = ACTIONS(560),
    [sym_false] = ACTIONS(560),
    [anon_sym_NULL] = ACTIONS(563),
    [anon_sym_nullptr] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(566),
    [anon_sym_decltype] = ACTIONS(569),
    [anon_sym_explicit] = ACTIONS(572),
    [anon_sym_typename] = ACTIONS(575),
    [anon_sym_template] = ACTIONS(1018),
    [anon_sym_operator] = ACTIONS(581),
    [anon_sym_try] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(587),
    [anon_sym_throw] = ACTIONS(1024),
    [anon_sym_namespace] = ACTIONS(1027),
    [anon_sym_static_assert] = ACTIONS(1030),
    [anon_sym_concept] = ACTIONS(1033),
    [anon_sym_co_return] = ACTIONS(1036),
    [anon_sym_co_yield] = ACTIONS(1039),
    [anon_sym_R_DQUOTE] = ACTIONS(608),
    [anon_sym_LR_DQUOTE] = ACTIONS(608),
    [anon_sym_uR_DQUOTE] = ACTIONS(608),
    [anon_sym_UR_DQUOTE] = ACTIONS(608),
    [anon_sym_u8R_DQUOTE] = ACTIONS(608),
    [anon_sym_co_await] = ACTIONS(611),
    [anon_sym_new] = ACTIONS(614),
    [anon_sym_requires] = ACTIONS(617),
    [sym_this] = ACTIONS(560),
  },
  [39] = {
    [sym__block_item] = STATE(40),
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(40),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(40),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(40),
    [sym_template_instantiation] = STATE(40),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(40),
    [sym_operator_cast_declaration] = STATE(40),
    [sym_constructor_or_destructor_definition] = STATE(40),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(40),
    [sym_namespace_alias_definition] = STATE(40),
    [sym_using_declaration] = STATE(40),
    [sym_alias_declaration] = STATE(40),
    [sym_static_assert_declaration] = STATE(40),
    [sym_concept_definition] = STATE(40),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [40] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1044),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [41] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [42] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(1048),
    [aux_sym_preproc_include_token1] = ACTIONS(1051),
    [aux_sym_preproc_def_token1] = ACTIONS(1054),
    [aux_sym_preproc_if_token1] = ACTIONS(1057),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1060),
    [sym_preproc_directive] = ACTIONS(1063),
    [anon_sym_LPAREN2] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(404),
    [anon_sym_TILDE] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_PLUS] = ACTIONS(410),
    [anon_sym_STAR] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(1066),
    [anon_sym___extension__] = ACTIONS(1069),
    [anon_sym_typedef] = ACTIONS(1072),
    [anon_sym_virtual] = ACTIONS(431),
    [anon_sym_extern] = ACTIONS(1075),
    [anon_sym___attribute__] = ACTIONS(437),
    [anon_sym___attribute] = ACTIONS(437),
    [anon_sym_using] = ACTIONS(1078),
    [anon_sym_COLON_COLON] = ACTIONS(443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(446),
    [anon_sym___declspec] = ACTIONS(449),
    [anon_sym___based] = ACTIONS(452),
    [anon_sym___cdecl] = ACTIONS(455),
    [anon_sym___clrcall] = ACTIONS(455),
    [anon_sym___stdcall] = ACTIONS(455),
    [anon_sym___fastcall] = ACTIONS(455),
    [anon_sym___thiscall] = ACTIONS(455),
    [anon_sym___vectorcall] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1084),
    [anon_sym_signed] = ACTIONS(461),
    [anon_sym_unsigned] = ACTIONS(461),
    [anon_sym_long] = ACTIONS(461),
    [anon_sym_short] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_static] = ACTIONS(467),
    [anon_sym_register] = ACTIONS(467),
    [anon_sym_inline] = ACTIONS(1086),
    [anon_sym___inline] = ACTIONS(467),
    [anon_sym___inline__] = ACTIONS(467),
    [anon_sym___forceinline] = ACTIONS(467),
    [anon_sym_thread_local] = ACTIONS(467),
    [anon_sym___thread] = ACTIONS(467),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_constexpr] = ACTIONS(473),
    [anon_sym_volatile] = ACTIONS(473),
    [anon_sym_restrict] = ACTIONS(473),
    [anon_sym___restrict__] = ACTIONS(473),
    [anon_sym__Atomic] = ACTIONS(473),
    [anon_sym__Noreturn] = ACTIONS(473),
    [anon_sym_noreturn] = ACTIONS(473),
    [anon_sym__Nonnull] = ACTIONS(473),
    [anon_sym_mutable] = ACTIONS(473),
    [anon_sym_constinit] = ACTIONS(473),
    [anon_sym_consteval] = ACTIONS(473),
    [anon_sym_alignas] = ACTIONS(476),
    [anon_sym__Alignas] = ACTIONS(476),
    [sym_primitive_type] = ACTIONS(479),
    [anon_sym_enum] = ACTIONS(482),
    [anon_sym_class] = ACTIONS(485),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_union] = ACTIONS(491),
    [anon_sym_if] = ACTIONS(1089),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_default] = ACTIONS(1098),
    [anon_sym_while] = ACTIONS(1101),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1107),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_goto] = ACTIONS(1119),
    [anon_sym___try] = ACTIONS(1122),
    [anon_sym___leave] = ACTIONS(1125),
    [anon_sym_not] = ACTIONS(410),
    [anon_sym_compl] = ACTIONS(410),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_sizeof] = ACTIONS(536),
    [anon_sym___alignof__] = ACTIONS(539),
    [anon_sym___alignof] = ACTIONS(539),
    [anon_sym__alignof] = ACTIONS(539),
    [anon_sym_alignof] = ACTIONS(539),
    [anon_sym__Alignof] = ACTIONS(539),
    [anon_sym_offsetof] = ACTIONS(542),
    [anon_sym__Generic] = ACTIONS(545),
    [anon_sym_asm] = ACTIONS(548),
    [anon_sym___asm__] = ACTIONS(548),
    [anon_sym___asm] = ACTIONS(548),
    [sym_number_literal] = ACTIONS(551),
    [anon_sym_L_SQUOTE] = ACTIONS(554),
    [anon_sym_u_SQUOTE] = ACTIONS(554),
    [anon_sym_U_SQUOTE] = ACTIONS(554),
    [anon_sym_u8_SQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(554),
    [anon_sym_L_DQUOTE] = ACTIONS(557),
    [anon_sym_u_DQUOTE] = ACTIONS(557),
    [anon_sym_U_DQUOTE] = ACTIONS(557),
    [anon_sym_u8_DQUOTE] = ACTIONS(557),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [sym_true] = ACTIONS(560),
    [sym_false] = ACTIONS(560),
    [anon_sym_NULL] = ACTIONS(563),
    [anon_sym_nullptr] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(566),
    [anon_sym_decltype] = ACTIONS(569),
    [anon_sym_explicit] = ACTIONS(572),
    [anon_sym_typename] = ACTIONS(575),
    [anon_sym_template] = ACTIONS(1128),
    [anon_sym_operator] = ACTIONS(581),
    [anon_sym_try] = ACTIONS(1131),
    [anon_sym_delete] = ACTIONS(587),
    [anon_sym_throw] = ACTIONS(1134),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_static_assert] = ACTIONS(1140),
    [anon_sym_concept] = ACTIONS(1143),
    [anon_sym_co_return] = ACTIONS(1146),
    [anon_sym_co_yield] = ACTIONS(1149),
    [anon_sym_R_DQUOTE] = ACTIONS(608),
    [anon_sym_LR_DQUOTE] = ACTIONS(608),
    [anon_sym_uR_DQUOTE] = ACTIONS(608),
    [anon_sym_UR_DQUOTE] = ACTIONS(608),
    [anon_sym_u8R_DQUOTE] = ACTIONS(608),
    [anon_sym_co_await] = ACTIONS(611),
    [anon_sym_new] = ACTIONS(614),
    [anon_sym_requires] = ACTIONS(617),
    [sym_this] = ACTIONS(560),
  },
  [43] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1152),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [44] = {
    [sym__block_item] = STATE(45),
    [sym_preproc_include] = STATE(45),
    [sym_preproc_def] = STATE(45),
    [sym_preproc_function_def] = STATE(45),
    [sym_preproc_call] = STATE(45),
    [sym_preproc_if] = STATE(45),
    [sym_preproc_ifdef] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_declaration] = STATE(45),
    [sym_type_definition] = STATE(45),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(45),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(45),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(45),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(45),
    [sym_template_instantiation] = STATE(45),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(45),
    [sym_operator_cast_declaration] = STATE(45),
    [sym_constructor_or_destructor_definition] = STATE(45),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(45),
    [sym_namespace_alias_definition] = STATE(45),
    [sym_using_declaration] = STATE(45),
    [sym_alias_declaration] = STATE(45),
    [sym_static_assert_declaration] = STATE(45),
    [sym_concept_definition] = STATE(45),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(45),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1154),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [45] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1156),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [46] = {
    [sym__block_item] = STATE(49),
    [sym_preproc_include] = STATE(49),
    [sym_preproc_def] = STATE(49),
    [sym_preproc_function_def] = STATE(49),
    [sym_preproc_call] = STATE(49),
    [sym_preproc_if] = STATE(49),
    [sym_preproc_ifdef] = STATE(49),
    [sym_function_definition] = STATE(49),
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(49),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(49),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(49),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(49),
    [sym_template_instantiation] = STATE(49),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(49),
    [sym_operator_cast_declaration] = STATE(49),
    [sym_constructor_or_destructor_definition] = STATE(49),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(49),
    [sym_namespace_alias_definition] = STATE(49),
    [sym_using_declaration] = STATE(49),
    [sym_alias_declaration] = STATE(49),
    [sym_static_assert_declaration] = STATE(49),
    [sym_concept_definition] = STATE(49),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(49),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1158),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [47] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1160),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [48] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1162),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [49] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1164),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [50] = {
    [sym__block_item] = STATE(52),
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(52),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(52),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(52),
    [sym_template_instantiation] = STATE(52),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(52),
    [sym_operator_cast_declaration] = STATE(52),
    [sym_constructor_or_destructor_definition] = STATE(52),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(52),
    [sym_namespace_alias_definition] = STATE(52),
    [sym_using_declaration] = STATE(52),
    [sym_alias_declaration] = STATE(52),
    [sym_static_assert_declaration] = STATE(52),
    [sym_concept_definition] = STATE(52),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [51] = {
    [sym__block_item] = STATE(38),
    [sym_preproc_include] = STATE(38),
    [sym_preproc_def] = STATE(38),
    [sym_preproc_function_def] = STATE(38),
    [sym_preproc_call] = STATE(38),
    [sym_preproc_if] = STATE(38),
    [sym_preproc_ifdef] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_declaration] = STATE(38),
    [sym_type_definition] = STATE(38),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4658),
    [sym_linkage_specification] = STATE(38),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1912),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6306),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(529),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2729),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(782),
    [sym_statement] = STATE(38),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(38),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1742),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(38),
    [sym_template_instantiation] = STATE(38),
    [sym_operator_cast] = STATE(6793),
    [sym__constructor_specifiers] = STATE(1742),
    [sym_operator_cast_definition] = STATE(38),
    [sym_operator_cast_declaration] = STATE(38),
    [sym_constructor_or_destructor_definition] = STATE(38),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(38),
    [sym_namespace_alias_definition] = STATE(38),
    [sym_using_declaration] = STATE(38),
    [sym_alias_declaration] = STATE(38),
    [sym_static_assert_declaration] = STATE(38),
    [sym_concept_definition] = STATE(38),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6793),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(38),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(151),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1742),
    [sym_identifier] = ACTIONS(870),
    [aux_sym_preproc_include_token1] = ACTIONS(872),
    [aux_sym_preproc_def_token1] = ACTIONS(874),
    [aux_sym_preproc_if_token1] = ACTIONS(876),
    [aux_sym_preproc_if_token2] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(880),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(880),
    [sym_preproc_directive] = ACTIONS(882),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(886),
    [anon_sym_typedef] = ACTIONS(888),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(890),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(892),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(896),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(924),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(930),
    [anon_sym_static_assert] = ACTIONS(932),
    [anon_sym_concept] = ACTIONS(934),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [52] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [53] = {
    [sym__block_item] = STATE(54),
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(54),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1172),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [54] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1174),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [55] = {
    [sym__block_item] = STATE(47),
    [sym_preproc_include] = STATE(47),
    [sym_preproc_def] = STATE(47),
    [sym_preproc_function_def] = STATE(47),
    [sym_preproc_call] = STATE(47),
    [sym_preproc_if] = STATE(47),
    [sym_preproc_ifdef] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_declaration] = STATE(47),
    [sym_type_definition] = STATE(47),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(47),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(47),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(47),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(47),
    [sym_template_instantiation] = STATE(47),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(47),
    [sym_operator_cast_declaration] = STATE(47),
    [sym_constructor_or_destructor_definition] = STATE(47),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(47),
    [sym_namespace_alias_definition] = STATE(47),
    [sym_using_declaration] = STATE(47),
    [sym_alias_declaration] = STATE(47),
    [sym_static_assert_declaration] = STATE(47),
    [sym_concept_definition] = STATE(47),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(47),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1176),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [56] = {
    [sym__block_item] = STATE(57),
    [sym_preproc_include] = STATE(57),
    [sym_preproc_def] = STATE(57),
    [sym_preproc_function_def] = STATE(57),
    [sym_preproc_call] = STATE(57),
    [sym_preproc_if] = STATE(57),
    [sym_preproc_ifdef] = STATE(57),
    [sym_function_definition] = STATE(57),
    [sym_declaration] = STATE(57),
    [sym_type_definition] = STATE(57),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(57),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(57),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(57),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(57),
    [sym_template_instantiation] = STATE(57),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(57),
    [sym_operator_cast_declaration] = STATE(57),
    [sym_constructor_or_destructor_definition] = STATE(57),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(57),
    [sym_namespace_alias_definition] = STATE(57),
    [sym_using_declaration] = STATE(57),
    [sym_alias_declaration] = STATE(57),
    [sym_static_assert_declaration] = STATE(57),
    [sym_concept_definition] = STATE(57),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(57),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1178),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [57] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1180),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [58] = {
    [sym__block_item] = STATE(48),
    [sym_preproc_include] = STATE(48),
    [sym_preproc_def] = STATE(48),
    [sym_preproc_function_def] = STATE(48),
    [sym_preproc_call] = STATE(48),
    [sym_preproc_if] = STATE(48),
    [sym_preproc_ifdef] = STATE(48),
    [sym_function_definition] = STATE(48),
    [sym_declaration] = STATE(48),
    [sym_type_definition] = STATE(48),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(48),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(48),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(48),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(48),
    [sym_template_instantiation] = STATE(48),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(48),
    [sym_operator_cast_declaration] = STATE(48),
    [sym_constructor_or_destructor_definition] = STATE(48),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(48),
    [sym_namespace_alias_definition] = STATE(48),
    [sym_using_declaration] = STATE(48),
    [sym_alias_declaration] = STATE(48),
    [sym_static_assert_declaration] = STATE(48),
    [sym_concept_definition] = STATE(48),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(48),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1182),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [59] = {
    [sym__block_item] = STATE(60),
    [sym_preproc_include] = STATE(60),
    [sym_preproc_def] = STATE(60),
    [sym_preproc_function_def] = STATE(60),
    [sym_preproc_call] = STATE(60),
    [sym_preproc_if] = STATE(60),
    [sym_preproc_ifdef] = STATE(60),
    [sym_function_definition] = STATE(60),
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(60),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(60),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(60),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(60),
    [sym_template_instantiation] = STATE(60),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(60),
    [sym_operator_cast_declaration] = STATE(60),
    [sym_constructor_or_destructor_definition] = STATE(60),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(60),
    [sym_namespace_alias_definition] = STATE(60),
    [sym_using_declaration] = STATE(60),
    [sym_alias_declaration] = STATE(60),
    [sym_static_assert_declaration] = STATE(60),
    [sym_concept_definition] = STATE(60),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(60),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [60] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1186),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [61] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1188),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [62] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1190),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [63] = {
    [sym__block_item] = STATE(551),
    [sym_preproc_include] = STATE(551),
    [sym_preproc_def] = STATE(551),
    [sym_preproc_function_def] = STATE(551),
    [sym_preproc_call] = STATE(551),
    [sym_preproc_if] = STATE(551),
    [sym_preproc_ifdef] = STATE(551),
    [sym_function_definition] = STATE(551),
    [sym_declaration] = STATE(551),
    [sym_type_definition] = STATE(551),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4748),
    [sym_linkage_specification] = STATE(551),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6326),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(401),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2748),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(543),
    [sym_statement] = STATE(551),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(551),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1831),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(551),
    [sym_template_instantiation] = STATE(551),
    [sym_operator_cast] = STATE(6833),
    [sym__constructor_specifiers] = STATE(1831),
    [sym_operator_cast_definition] = STATE(551),
    [sym_operator_cast_declaration] = STATE(551),
    [sym_constructor_or_destructor_definition] = STATE(551),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(551),
    [sym_namespace_alias_definition] = STATE(551),
    [sym_using_declaration] = STATE(551),
    [sym_alias_declaration] = STATE(551),
    [sym_static_assert_declaration] = STATE(551),
    [sym_concept_definition] = STATE(551),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6833),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(145),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1831),
    [sym_identifier] = ACTIONS(1192),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(65),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1202),
    [anon_sym_import] = ACTIONS(1204),
    [anon_sym_template] = ACTIONS(139),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_static_assert] = ACTIONS(151),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [64] = {
    [sym__block_item] = STATE(65),
    [sym_preproc_include] = STATE(65),
    [sym_preproc_def] = STATE(65),
    [sym_preproc_function_def] = STATE(65),
    [sym_preproc_call] = STATE(65),
    [sym_preproc_if] = STATE(65),
    [sym_preproc_ifdef] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(65),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(65),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(65),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(65),
    [sym_template_instantiation] = STATE(65),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(65),
    [sym_operator_cast_declaration] = STATE(65),
    [sym_constructor_or_destructor_definition] = STATE(65),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(65),
    [sym_namespace_alias_definition] = STATE(65),
    [sym_using_declaration] = STATE(65),
    [sym_alias_declaration] = STATE(65),
    [sym_static_assert_declaration] = STATE(65),
    [sym_concept_definition] = STATE(65),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(65),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [65] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1208),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [66] = {
    [sym__block_item] = STATE(67),
    [sym_preproc_include] = STATE(67),
    [sym_preproc_def] = STATE(67),
    [sym_preproc_function_def] = STATE(67),
    [sym_preproc_call] = STATE(67),
    [sym_preproc_if] = STATE(67),
    [sym_preproc_ifdef] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(67),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(67),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(67),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(67),
    [sym_template_instantiation] = STATE(67),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(67),
    [sym_operator_cast_declaration] = STATE(67),
    [sym_constructor_or_destructor_definition] = STATE(67),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(67),
    [sym_namespace_alias_definition] = STATE(67),
    [sym_using_declaration] = STATE(67),
    [sym_alias_declaration] = STATE(67),
    [sym_static_assert_declaration] = STATE(67),
    [sym_concept_definition] = STATE(67),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(67),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [67] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1212),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [68] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [69] = {
    [sym__block_item] = STATE(70),
    [sym_preproc_include] = STATE(70),
    [sym_preproc_def] = STATE(70),
    [sym_preproc_function_def] = STATE(70),
    [sym_preproc_call] = STATE(70),
    [sym_preproc_if] = STATE(70),
    [sym_preproc_ifdef] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(70),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(70),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(70),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(70),
    [sym_template_instantiation] = STATE(70),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(70),
    [sym_operator_cast_declaration] = STATE(70),
    [sym_constructor_or_destructor_definition] = STATE(70),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(70),
    [sym_namespace_alias_definition] = STATE(70),
    [sym_using_declaration] = STATE(70),
    [sym_alias_declaration] = STATE(70),
    [sym_static_assert_declaration] = STATE(70),
    [sym_concept_definition] = STATE(70),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(70),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1216),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [70] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1218),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [71] = {
    [sym__block_item] = STATE(72),
    [sym_preproc_include] = STATE(72),
    [sym_preproc_def] = STATE(72),
    [sym_preproc_function_def] = STATE(72),
    [sym_preproc_call] = STATE(72),
    [sym_preproc_if] = STATE(72),
    [sym_preproc_ifdef] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_declaration] = STATE(72),
    [sym_type_definition] = STATE(72),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(72),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(72),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(72),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(72),
    [sym_template_instantiation] = STATE(72),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(72),
    [sym_operator_cast_declaration] = STATE(72),
    [sym_constructor_or_destructor_definition] = STATE(72),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(72),
    [sym_namespace_alias_definition] = STATE(72),
    [sym_using_declaration] = STATE(72),
    [sym_alias_declaration] = STATE(72),
    [sym_static_assert_declaration] = STATE(72),
    [sym_concept_definition] = STATE(72),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(72),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1220),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [72] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1222),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [73] = {
    [sym__block_item] = STATE(74),
    [sym_preproc_include] = STATE(74),
    [sym_preproc_def] = STATE(74),
    [sym_preproc_function_def] = STATE(74),
    [sym_preproc_call] = STATE(74),
    [sym_preproc_if] = STATE(74),
    [sym_preproc_ifdef] = STATE(74),
    [sym_function_definition] = STATE(74),
    [sym_declaration] = STATE(74),
    [sym_type_definition] = STATE(74),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(74),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(74),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(74),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(74),
    [sym_template_instantiation] = STATE(74),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(74),
    [sym_operator_cast_declaration] = STATE(74),
    [sym_constructor_or_destructor_definition] = STATE(74),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(74),
    [sym_namespace_alias_definition] = STATE(74),
    [sym_using_declaration] = STATE(74),
    [sym_alias_declaration] = STATE(74),
    [sym_static_assert_declaration] = STATE(74),
    [sym_concept_definition] = STATE(74),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(74),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1224),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [74] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1226),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [75] = {
    [sym__block_item] = STATE(76),
    [sym_preproc_include] = STATE(76),
    [sym_preproc_def] = STATE(76),
    [sym_preproc_function_def] = STATE(76),
    [sym_preproc_call] = STATE(76),
    [sym_preproc_if] = STATE(76),
    [sym_preproc_ifdef] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_declaration] = STATE(76),
    [sym_type_definition] = STATE(76),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(76),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(76),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(76),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(76),
    [sym_template_instantiation] = STATE(76),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(76),
    [sym_operator_cast_declaration] = STATE(76),
    [sym_constructor_or_destructor_definition] = STATE(76),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(76),
    [sym_namespace_alias_definition] = STATE(76),
    [sym_using_declaration] = STATE(76),
    [sym_alias_declaration] = STATE(76),
    [sym_static_assert_declaration] = STATE(76),
    [sym_concept_definition] = STATE(76),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(76),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [76] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [77] = {
    [sym__block_item] = STATE(78),
    [sym_preproc_include] = STATE(78),
    [sym_preproc_def] = STATE(78),
    [sym_preproc_function_def] = STATE(78),
    [sym_preproc_call] = STATE(78),
    [sym_preproc_if] = STATE(78),
    [sym_preproc_ifdef] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_declaration] = STATE(78),
    [sym_type_definition] = STATE(78),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(78),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(78),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(78),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(78),
    [sym_template_instantiation] = STATE(78),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(78),
    [sym_operator_cast_declaration] = STATE(78),
    [sym_constructor_or_destructor_definition] = STATE(78),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(78),
    [sym_namespace_alias_definition] = STATE(78),
    [sym_using_declaration] = STATE(78),
    [sym_alias_declaration] = STATE(78),
    [sym_static_assert_declaration] = STATE(78),
    [sym_concept_definition] = STATE(78),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(78),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [78] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1234),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [79] = {
    [sym__block_item] = STATE(80),
    [sym_preproc_include] = STATE(80),
    [sym_preproc_def] = STATE(80),
    [sym_preproc_function_def] = STATE(80),
    [sym_preproc_call] = STATE(80),
    [sym_preproc_if] = STATE(80),
    [sym_preproc_ifdef] = STATE(80),
    [sym_function_definition] = STATE(80),
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(80),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(80),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(80),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(80),
    [sym_template_instantiation] = STATE(80),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(80),
    [sym_operator_cast_declaration] = STATE(80),
    [sym_constructor_or_destructor_definition] = STATE(80),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(80),
    [sym_namespace_alias_definition] = STATE(80),
    [sym_using_declaration] = STATE(80),
    [sym_alias_declaration] = STATE(80),
    [sym_static_assert_declaration] = STATE(80),
    [sym_concept_definition] = STATE(80),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(80),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [80] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1238),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [81] = {
    [sym__block_item] = STATE(82),
    [sym_preproc_include] = STATE(82),
    [sym_preproc_def] = STATE(82),
    [sym_preproc_function_def] = STATE(82),
    [sym_preproc_call] = STATE(82),
    [sym_preproc_if] = STATE(82),
    [sym_preproc_ifdef] = STATE(82),
    [sym_function_definition] = STATE(82),
    [sym_declaration] = STATE(82),
    [sym_type_definition] = STATE(82),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(82),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(82),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(82),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(82),
    [sym_template_instantiation] = STATE(82),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(82),
    [sym_operator_cast_declaration] = STATE(82),
    [sym_constructor_or_destructor_definition] = STATE(82),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(82),
    [sym_namespace_alias_definition] = STATE(82),
    [sym_using_declaration] = STATE(82),
    [sym_alias_declaration] = STATE(82),
    [sym_static_assert_declaration] = STATE(82),
    [sym_concept_definition] = STATE(82),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(82),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [82] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1242),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [83] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [84] = {
    [sym__block_item] = STATE(68),
    [sym_preproc_include] = STATE(68),
    [sym_preproc_def] = STATE(68),
    [sym_preproc_function_def] = STATE(68),
    [sym_preproc_call] = STATE(68),
    [sym_preproc_if] = STATE(68),
    [sym_preproc_ifdef] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_linkage_specification] = STATE(68),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(860),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6331),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(761),
    [sym_statement] = STATE(68),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym__empty_declaration] = STATE(68),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_explicit_function_specifier] = STATE(1800),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(68),
    [sym_template_instantiation] = STATE(68),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1800),
    [sym_operator_cast_definition] = STATE(68),
    [sym_operator_cast_declaration] = STATE(68),
    [sym_constructor_or_destructor_definition] = STATE(68),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(4494),
    [sym_namespace_definition] = STATE(68),
    [sym_namespace_alias_definition] = STATE(68),
    [sym_using_declaration] = STATE(68),
    [sym_alias_declaration] = STATE(68),
    [sym_static_assert_declaration] = STATE(68),
    [sym_concept_definition] = STATE(68),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5460),
    [sym_qualified_identifier] = STATE(3281),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_preproc_if_repeat1] = STATE(68),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(140),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(864),
    [aux_sym_preproc_include_token1] = ACTIONS(169),
    [aux_sym_preproc_def_token1] = ACTIONS(171),
    [aux_sym_preproc_if_token1] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(177),
    [sym_preproc_directive] = ACTIONS(179),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(183),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(187),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(189),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(197),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(231),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(237),
    [anon_sym_static_assert] = ACTIONS(239),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [85] = {
    [sym_declaration] = STATE(85),
    [sym_type_definition] = STATE(85),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5180),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(85),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(85),
    [sym_labeled_statement] = STATE(85),
    [sym_expression_statement] = STATE(85),
    [sym_if_statement] = STATE(85),
    [sym_switch_statement] = STATE(85),
    [sym_while_statement] = STATE(85),
    [sym_do_statement] = STATE(85),
    [sym_for_statement] = STATE(85),
    [sym_return_statement] = STATE(85),
    [sym_break_statement] = STATE(85),
    [sym_continue_statement] = STATE(85),
    [sym_goto_statement] = STATE(85),
    [sym_seh_try_statement] = STATE(85),
    [sym_seh_leave_statement] = STATE(85),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(85),
    [sym_co_return_statement] = STATE(85),
    [sym_co_yield_statement] = STATE(85),
    [sym_throw_statement] = STATE(85),
    [sym_try_statement] = STATE(85),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(1248),
    [aux_sym_preproc_include_token1] = ACTIONS(1251),
    [aux_sym_preproc_def_token1] = ACTIONS(1251),
    [aux_sym_preproc_if_token1] = ACTIONS(1251),
    [aux_sym_preproc_if_token2] = ACTIONS(1251),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1251),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1251),
    [aux_sym_preproc_else_token1] = ACTIONS(1251),
    [aux_sym_preproc_elif_token1] = ACTIONS(1251),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1251),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1251),
    [sym_preproc_directive] = ACTIONS(1251),
    [anon_sym_LPAREN2] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1270),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1276),
    [anon_sym_virtual] = ACTIONS(1279),
    [anon_sym_extern] = ACTIONS(1282),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym___attribute] = ACTIONS(1285),
    [anon_sym_using] = ACTIONS(1251),
    [anon_sym_COLON_COLON] = ACTIONS(1288),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1294),
    [anon_sym___based] = ACTIONS(1251),
    [anon_sym___cdecl] = ACTIONS(1251),
    [anon_sym___clrcall] = ACTIONS(1251),
    [anon_sym___stdcall] = ACTIONS(1251),
    [anon_sym___fastcall] = ACTIONS(1251),
    [anon_sym___thiscall] = ACTIONS(1251),
    [anon_sym___vectorcall] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_signed] = ACTIONS(1300),
    [anon_sym_unsigned] = ACTIONS(1300),
    [anon_sym_long] = ACTIONS(1300),
    [anon_sym_short] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1282),
    [anon_sym_register] = ACTIONS(1282),
    [anon_sym_inline] = ACTIONS(1282),
    [anon_sym___inline] = ACTIONS(1282),
    [anon_sym___inline__] = ACTIONS(1282),
    [anon_sym___forceinline] = ACTIONS(1282),
    [anon_sym_thread_local] = ACTIONS(1282),
    [anon_sym___thread] = ACTIONS(1282),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_constexpr] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym___restrict__] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym__Noreturn] = ACTIONS(1306),
    [anon_sym_noreturn] = ACTIONS(1306),
    [anon_sym__Nonnull] = ACTIONS(1306),
    [anon_sym_mutable] = ACTIONS(1306),
    [anon_sym_constinit] = ACTIONS(1306),
    [anon_sym_consteval] = ACTIONS(1306),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1312),
    [anon_sym_enum] = ACTIONS(1315),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1324),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_else] = ACTIONS(1251),
    [anon_sym_switch] = ACTIONS(1330),
    [anon_sym_case] = ACTIONS(1251),
    [anon_sym_default] = ACTIONS(1251),
    [anon_sym_while] = ACTIONS(1333),
    [anon_sym_do] = ACTIONS(1336),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1348),
    [anon_sym_goto] = ACTIONS(1351),
    [anon_sym___try] = ACTIONS(1354),
    [anon_sym___leave] = ACTIONS(1357),
    [anon_sym_not] = ACTIONS(1259),
    [anon_sym_compl] = ACTIONS(1259),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_sizeof] = ACTIONS(1363),
    [anon_sym___alignof__] = ACTIONS(1366),
    [anon_sym___alignof] = ACTIONS(1366),
    [anon_sym__alignof] = ACTIONS(1366),
    [anon_sym_alignof] = ACTIONS(1366),
    [anon_sym__Alignof] = ACTIONS(1366),
    [anon_sym_offsetof] = ACTIONS(1369),
    [anon_sym__Generic] = ACTIONS(1372),
    [anon_sym_asm] = ACTIONS(1375),
    [anon_sym___asm__] = ACTIONS(1375),
    [anon_sym___asm] = ACTIONS(1375),
    [sym_number_literal] = ACTIONS(1378),
    [anon_sym_L_SQUOTE] = ACTIONS(1381),
    [anon_sym_u_SQUOTE] = ACTIONS(1381),
    [anon_sym_U_SQUOTE] = ACTIONS(1381),
    [anon_sym_u8_SQUOTE] = ACTIONS(1381),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [anon_sym_L_DQUOTE] = ACTIONS(1384),
    [anon_sym_u_DQUOTE] = ACTIONS(1384),
    [anon_sym_U_DQUOTE] = ACTIONS(1384),
    [anon_sym_u8_DQUOTE] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_true] = ACTIONS(1387),
    [sym_false] = ACTIONS(1387),
    [anon_sym_NULL] = ACTIONS(1390),
    [anon_sym_nullptr] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1393),
    [anon_sym_decltype] = ACTIONS(1396),
    [anon_sym_explicit] = ACTIONS(1251),
    [anon_sym_typename] = ACTIONS(1399),
    [anon_sym_template] = ACTIONS(1402),
    [anon_sym_operator] = ACTIONS(1251),
    [anon_sym_try] = ACTIONS(1405),
    [anon_sym_delete] = ACTIONS(1408),
    [anon_sym_throw] = ACTIONS(1411),
    [anon_sym_namespace] = ACTIONS(1251),
    [anon_sym_static_assert] = ACTIONS(1251),
    [anon_sym_concept] = ACTIONS(1251),
    [anon_sym_co_return] = ACTIONS(1414),
    [anon_sym_co_yield] = ACTIONS(1417),
    [anon_sym_R_DQUOTE] = ACTIONS(1420),
    [anon_sym_LR_DQUOTE] = ACTIONS(1420),
    [anon_sym_uR_DQUOTE] = ACTIONS(1420),
    [anon_sym_UR_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1420),
    [anon_sym_co_await] = ACTIONS(1423),
    [anon_sym_new] = ACTIONS(1426),
    [anon_sym_requires] = ACTIONS(1429),
    [sym_this] = ACTIONS(1387),
  },
  [86] = {
    [sym_declaration] = STATE(88),
    [sym_type_definition] = STATE(88),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5180),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(88),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(88),
    [sym_labeled_statement] = STATE(88),
    [sym_expression_statement] = STATE(88),
    [sym_if_statement] = STATE(88),
    [sym_switch_statement] = STATE(88),
    [sym_while_statement] = STATE(88),
    [sym_do_statement] = STATE(88),
    [sym_for_statement] = STATE(88),
    [sym_return_statement] = STATE(88),
    [sym_break_statement] = STATE(88),
    [sym_continue_statement] = STATE(88),
    [sym_goto_statement] = STATE(88),
    [sym_seh_try_statement] = STATE(88),
    [sym_seh_leave_statement] = STATE(88),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(88),
    [sym_co_return_statement] = STATE(88),
    [sym_co_yield_statement] = STATE(88),
    [sym_throw_statement] = STATE(88),
    [sym_try_statement] = STATE(88),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(88),
    [sym_identifier] = ACTIONS(1432),
    [aux_sym_preproc_include_token1] = ACTIONS(1434),
    [aux_sym_preproc_def_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token2] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1434),
    [aux_sym_preproc_else_token1] = ACTIONS(1434),
    [aux_sym_preproc_elif_token1] = ACTIONS(1434),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1434),
    [sym_preproc_directive] = ACTIONS(1434),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(1444),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1434),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1434),
    [anon_sym___cdecl] = ACTIONS(1434),
    [anon_sym___clrcall] = ACTIONS(1434),
    [anon_sym___stdcall] = ACTIONS(1434),
    [anon_sym___fastcall] = ACTIONS(1434),
    [anon_sym___thiscall] = ACTIONS(1434),
    [anon_sym___vectorcall] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1434),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1434),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_static_assert] = ACTIONS(1434),
    [anon_sym_concept] = ACTIONS(1434),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [87] = {
    [sym_declaration] = STATE(89),
    [sym_type_definition] = STATE(89),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5180),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(89),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym_seh_try_statement] = STATE(89),
    [sym_seh_leave_statement] = STATE(89),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(89),
    [sym_co_return_statement] = STATE(89),
    [sym_co_yield_statement] = STATE(89),
    [sym_throw_statement] = STATE(89),
    [sym_try_statement] = STATE(89),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(89),
    [sym_identifier] = ACTIONS(1432),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token2] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [aux_sym_preproc_else_token1] = ACTIONS(1454),
    [aux_sym_preproc_elif_token1] = ACTIONS(1454),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(1444),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1454),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_else] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1454),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1454),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(1454),
    [anon_sym_static_assert] = ACTIONS(1454),
    [anon_sym_concept] = ACTIONS(1454),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [88] = {
    [sym_declaration] = STATE(85),
    [sym_type_definition] = STATE(85),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5180),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(85),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(85),
    [sym_labeled_statement] = STATE(85),
    [sym_expression_statement] = STATE(85),
    [sym_if_statement] = STATE(85),
    [sym_switch_statement] = STATE(85),
    [sym_while_statement] = STATE(85),
    [sym_do_statement] = STATE(85),
    [sym_for_statement] = STATE(85),
    [sym_return_statement] = STATE(85),
    [sym_break_statement] = STATE(85),
    [sym_continue_statement] = STATE(85),
    [sym_goto_statement] = STATE(85),
    [sym_seh_try_statement] = STATE(85),
    [sym_seh_leave_statement] = STATE(85),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(85),
    [sym_co_return_statement] = STATE(85),
    [sym_co_yield_statement] = STATE(85),
    [sym_throw_statement] = STATE(85),
    [sym_try_statement] = STATE(85),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(1432),
    [aux_sym_preproc_include_token1] = ACTIONS(1458),
    [aux_sym_preproc_def_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token2] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1458),
    [aux_sym_preproc_else_token1] = ACTIONS(1458),
    [aux_sym_preproc_elif_token1] = ACTIONS(1458),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1458),
    [sym_preproc_directive] = ACTIONS(1458),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1460),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(1444),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1458),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1458),
    [anon_sym___cdecl] = ACTIONS(1458),
    [anon_sym___clrcall] = ACTIONS(1458),
    [anon_sym___stdcall] = ACTIONS(1458),
    [anon_sym___fastcall] = ACTIONS(1458),
    [anon_sym___thiscall] = ACTIONS(1458),
    [anon_sym___vectorcall] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_else] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1458),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1458),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(1458),
    [anon_sym_static_assert] = ACTIONS(1458),
    [anon_sym_concept] = ACTIONS(1458),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [89] = {
    [sym_declaration] = STATE(85),
    [sym_type_definition] = STATE(85),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5180),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(85),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(85),
    [sym_labeled_statement] = STATE(85),
    [sym_expression_statement] = STATE(85),
    [sym_if_statement] = STATE(85),
    [sym_switch_statement] = STATE(85),
    [sym_while_statement] = STATE(85),
    [sym_do_statement] = STATE(85),
    [sym_for_statement] = STATE(85),
    [sym_return_statement] = STATE(85),
    [sym_break_statement] = STATE(85),
    [sym_continue_statement] = STATE(85),
    [sym_goto_statement] = STATE(85),
    [sym_seh_try_statement] = STATE(85),
    [sym_seh_leave_statement] = STATE(85),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(85),
    [sym_co_return_statement] = STATE(85),
    [sym_co_yield_statement] = STATE(85),
    [sym_throw_statement] = STATE(85),
    [sym_try_statement] = STATE(85),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(1432),
    [aux_sym_preproc_include_token1] = ACTIONS(1462),
    [aux_sym_preproc_def_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token2] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1462),
    [aux_sym_preproc_else_token1] = ACTIONS(1462),
    [aux_sym_preproc_elif_token1] = ACTIONS(1462),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1462),
    [sym_preproc_directive] = ACTIONS(1462),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(1444),
    [anon_sym_typedef] = ACTIONS(291),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1462),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1462),
    [anon_sym___cdecl] = ACTIONS(1462),
    [anon_sym___clrcall] = ACTIONS(1462),
    [anon_sym___stdcall] = ACTIONS(1462),
    [anon_sym___fastcall] = ACTIONS(1462),
    [anon_sym___thiscall] = ACTIONS(1462),
    [anon_sym___vectorcall] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1462),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1462),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_static_assert] = ACTIONS(1462),
    [anon_sym_concept] = ACTIONS(1462),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [90] = {
    [sym_declaration] = STATE(91),
    [sym_type_definition] = STATE(91),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5215),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(91),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(91),
    [sym_labeled_statement] = STATE(91),
    [sym_expression_statement] = STATE(91),
    [sym_if_statement] = STATE(91),
    [sym_switch_statement] = STATE(91),
    [sym_while_statement] = STATE(91),
    [sym_do_statement] = STATE(91),
    [sym_for_statement] = STATE(91),
    [sym_return_statement] = STATE(91),
    [sym_break_statement] = STATE(91),
    [sym_continue_statement] = STATE(91),
    [sym_goto_statement] = STATE(91),
    [sym_seh_try_statement] = STATE(91),
    [sym_seh_leave_statement] = STATE(91),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(91),
    [sym_co_return_statement] = STATE(91),
    [sym_co_yield_statement] = STATE(91),
    [sym_throw_statement] = STATE(91),
    [sym_try_statement] = STATE(91),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(91),
    [ts_builtin_sym_end] = ACTIONS(1456),
    [sym_identifier] = ACTIONS(1466),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(1468),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1454),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1454),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_import] = ACTIONS(1454),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1454),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1454),
    [anon_sym_static_assert] = ACTIONS(1454),
    [anon_sym_concept] = ACTIONS(1454),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [91] = {
    [sym_declaration] = STATE(94),
    [sym_type_definition] = STATE(94),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5215),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(94),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym_seh_try_statement] = STATE(94),
    [sym_seh_leave_statement] = STATE(94),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(94),
    [sym_co_return_statement] = STATE(94),
    [sym_co_yield_statement] = STATE(94),
    [sym_throw_statement] = STATE(94),
    [sym_try_statement] = STATE(94),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(94),
    [ts_builtin_sym_end] = ACTIONS(1464),
    [sym_identifier] = ACTIONS(1466),
    [aux_sym_preproc_include_token1] = ACTIONS(1462),
    [aux_sym_preproc_def_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1462),
    [sym_preproc_directive] = ACTIONS(1462),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(1468),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1462),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1462),
    [anon_sym___cdecl] = ACTIONS(1462),
    [anon_sym___clrcall] = ACTIONS(1462),
    [anon_sym___stdcall] = ACTIONS(1462),
    [anon_sym___fastcall] = ACTIONS(1462),
    [anon_sym___thiscall] = ACTIONS(1462),
    [anon_sym___vectorcall] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1462),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_import] = ACTIONS(1462),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1462),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_static_assert] = ACTIONS(1462),
    [anon_sym_concept] = ACTIONS(1462),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [92] = {
    [sym_declaration] = STATE(93),
    [sym_type_definition] = STATE(93),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5215),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(93),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(93),
    [sym_labeled_statement] = STATE(93),
    [sym_expression_statement] = STATE(93),
    [sym_if_statement] = STATE(93),
    [sym_switch_statement] = STATE(93),
    [sym_while_statement] = STATE(93),
    [sym_do_statement] = STATE(93),
    [sym_for_statement] = STATE(93),
    [sym_return_statement] = STATE(93),
    [sym_break_statement] = STATE(93),
    [sym_continue_statement] = STATE(93),
    [sym_goto_statement] = STATE(93),
    [sym_seh_try_statement] = STATE(93),
    [sym_seh_leave_statement] = STATE(93),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(93),
    [sym_co_return_statement] = STATE(93),
    [sym_co_yield_statement] = STATE(93),
    [sym_throw_statement] = STATE(93),
    [sym_try_statement] = STATE(93),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(93),
    [ts_builtin_sym_end] = ACTIONS(1440),
    [sym_identifier] = ACTIONS(1466),
    [aux_sym_preproc_include_token1] = ACTIONS(1434),
    [aux_sym_preproc_def_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1434),
    [sym_preproc_directive] = ACTIONS(1434),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(1468),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1434),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1434),
    [anon_sym___cdecl] = ACTIONS(1434),
    [anon_sym___clrcall] = ACTIONS(1434),
    [anon_sym___stdcall] = ACTIONS(1434),
    [anon_sym___fastcall] = ACTIONS(1434),
    [anon_sym___thiscall] = ACTIONS(1434),
    [anon_sym___vectorcall] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1434),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(1434),
    [anon_sym_import] = ACTIONS(1434),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1434),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_static_assert] = ACTIONS(1434),
    [anon_sym_concept] = ACTIONS(1434),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [93] = {
    [sym_declaration] = STATE(94),
    [sym_type_definition] = STATE(94),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5215),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(94),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym_seh_try_statement] = STATE(94),
    [sym_seh_leave_statement] = STATE(94),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(94),
    [sym_co_return_statement] = STATE(94),
    [sym_co_yield_statement] = STATE(94),
    [sym_throw_statement] = STATE(94),
    [sym_try_statement] = STATE(94),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(94),
    [ts_builtin_sym_end] = ACTIONS(1460),
    [sym_identifier] = ACTIONS(1466),
    [aux_sym_preproc_include_token1] = ACTIONS(1458),
    [aux_sym_preproc_def_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1458),
    [sym_preproc_directive] = ACTIONS(1458),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1460),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(1468),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1458),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1458),
    [anon_sym___cdecl] = ACTIONS(1458),
    [anon_sym___clrcall] = ACTIONS(1458),
    [anon_sym___stdcall] = ACTIONS(1458),
    [anon_sym___fastcall] = ACTIONS(1458),
    [anon_sym___thiscall] = ACTIONS(1458),
    [anon_sym___vectorcall] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1458),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(1458),
    [anon_sym_module] = ACTIONS(1458),
    [anon_sym_import] = ACTIONS(1458),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1458),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1458),
    [anon_sym_static_assert] = ACTIONS(1458),
    [anon_sym_concept] = ACTIONS(1458),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [94] = {
    [sym_declaration] = STATE(94),
    [sym_type_definition] = STATE(94),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5215),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(94),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym_seh_try_statement] = STATE(94),
    [sym_seh_leave_statement] = STATE(94),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(94),
    [sym_co_return_statement] = STATE(94),
    [sym_co_yield_statement] = STATE(94),
    [sym_throw_statement] = STATE(94),
    [sym_try_statement] = STATE(94),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(94),
    [ts_builtin_sym_end] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1470),
    [aux_sym_preproc_include_token1] = ACTIONS(1251),
    [aux_sym_preproc_def_token1] = ACTIONS(1251),
    [aux_sym_preproc_if_token1] = ACTIONS(1251),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1251),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1251),
    [sym_preproc_directive] = ACTIONS(1251),
    [anon_sym_LPAREN2] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym___extension__] = ACTIONS(1476),
    [anon_sym_typedef] = ACTIONS(1479),
    [anon_sym_virtual] = ACTIONS(1279),
    [anon_sym_extern] = ACTIONS(1282),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym___attribute] = ACTIONS(1285),
    [anon_sym_using] = ACTIONS(1251),
    [anon_sym_COLON_COLON] = ACTIONS(1288),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1294),
    [anon_sym___based] = ACTIONS(1251),
    [anon_sym___cdecl] = ACTIONS(1251),
    [anon_sym___clrcall] = ACTIONS(1251),
    [anon_sym___stdcall] = ACTIONS(1251),
    [anon_sym___fastcall] = ACTIONS(1251),
    [anon_sym___thiscall] = ACTIONS(1251),
    [anon_sym___vectorcall] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_signed] = ACTIONS(1300),
    [anon_sym_unsigned] = ACTIONS(1300),
    [anon_sym_long] = ACTIONS(1300),
    [anon_sym_short] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1282),
    [anon_sym_register] = ACTIONS(1282),
    [anon_sym_inline] = ACTIONS(1282),
    [anon_sym___inline] = ACTIONS(1282),
    [anon_sym___inline__] = ACTIONS(1282),
    [anon_sym___forceinline] = ACTIONS(1282),
    [anon_sym_thread_local] = ACTIONS(1282),
    [anon_sym___thread] = ACTIONS(1282),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_constexpr] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym___restrict__] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym__Noreturn] = ACTIONS(1306),
    [anon_sym_noreturn] = ACTIONS(1306),
    [anon_sym__Nonnull] = ACTIONS(1306),
    [anon_sym_mutable] = ACTIONS(1306),
    [anon_sym_constinit] = ACTIONS(1306),
    [anon_sym_consteval] = ACTIONS(1306),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1312),
    [anon_sym_enum] = ACTIONS(1315),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1324),
    [anon_sym_if] = ACTIONS(1485),
    [anon_sym_else] = ACTIONS(1251),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_case] = ACTIONS(1251),
    [anon_sym_default] = ACTIONS(1251),
    [anon_sym_while] = ACTIONS(1491),
    [anon_sym_do] = ACTIONS(1494),
    [anon_sym_for] = ACTIONS(1497),
    [anon_sym_return] = ACTIONS(1500),
    [anon_sym_break] = ACTIONS(1503),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1509),
    [anon_sym___try] = ACTIONS(1512),
    [anon_sym___leave] = ACTIONS(1515),
    [anon_sym_not] = ACTIONS(1259),
    [anon_sym_compl] = ACTIONS(1259),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_sizeof] = ACTIONS(1363),
    [anon_sym___alignof__] = ACTIONS(1366),
    [anon_sym___alignof] = ACTIONS(1366),
    [anon_sym__alignof] = ACTIONS(1366),
    [anon_sym_alignof] = ACTIONS(1366),
    [anon_sym__Alignof] = ACTIONS(1366),
    [anon_sym_offsetof] = ACTIONS(1369),
    [anon_sym__Generic] = ACTIONS(1372),
    [anon_sym_asm] = ACTIONS(1375),
    [anon_sym___asm__] = ACTIONS(1375),
    [anon_sym___asm] = ACTIONS(1375),
    [sym_number_literal] = ACTIONS(1378),
    [anon_sym_L_SQUOTE] = ACTIONS(1381),
    [anon_sym_u_SQUOTE] = ACTIONS(1381),
    [anon_sym_U_SQUOTE] = ACTIONS(1381),
    [anon_sym_u8_SQUOTE] = ACTIONS(1381),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [anon_sym_L_DQUOTE] = ACTIONS(1384),
    [anon_sym_u_DQUOTE] = ACTIONS(1384),
    [anon_sym_U_DQUOTE] = ACTIONS(1384),
    [anon_sym_u8_DQUOTE] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_true] = ACTIONS(1387),
    [sym_false] = ACTIONS(1387),
    [anon_sym_NULL] = ACTIONS(1390),
    [anon_sym_nullptr] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1393),
    [anon_sym_decltype] = ACTIONS(1396),
    [anon_sym_explicit] = ACTIONS(1251),
    [anon_sym_typename] = ACTIONS(1399),
    [anon_sym_export] = ACTIONS(1251),
    [anon_sym_module] = ACTIONS(1251),
    [anon_sym_import] = ACTIONS(1251),
    [anon_sym_template] = ACTIONS(1402),
    [anon_sym_operator] = ACTIONS(1251),
    [anon_sym_try] = ACTIONS(1518),
    [anon_sym_delete] = ACTIONS(1408),
    [anon_sym_throw] = ACTIONS(1521),
    [anon_sym_namespace] = ACTIONS(1251),
    [anon_sym_static_assert] = ACTIONS(1251),
    [anon_sym_concept] = ACTIONS(1251),
    [anon_sym_co_return] = ACTIONS(1524),
    [anon_sym_co_yield] = ACTIONS(1527),
    [anon_sym_R_DQUOTE] = ACTIONS(1420),
    [anon_sym_LR_DQUOTE] = ACTIONS(1420),
    [anon_sym_uR_DQUOTE] = ACTIONS(1420),
    [anon_sym_UR_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1420),
    [anon_sym_co_await] = ACTIONS(1423),
    [anon_sym_new] = ACTIONS(1426),
    [anon_sym_requires] = ACTIONS(1429),
    [sym_this] = ACTIONS(1387),
  },
  [95] = {
    [sym_declaration] = STATE(103),
    [sym_type_definition] = STATE(103),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5184),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(103),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_seh_try_statement] = STATE(103),
    [sym_seh_leave_statement] = STATE(103),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(103),
    [sym_co_return_statement] = STATE(103),
    [sym_co_yield_statement] = STATE(103),
    [sym_throw_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(103),
    [sym_identifier] = ACTIONS(1530),
    [aux_sym_preproc_include_token1] = ACTIONS(1458),
    [aux_sym_preproc_def_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1458),
    [sym_preproc_directive] = ACTIONS(1458),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1460),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(1532),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1458),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1458),
    [anon_sym___cdecl] = ACTIONS(1458),
    [anon_sym___clrcall] = ACTIONS(1458),
    [anon_sym___stdcall] = ACTIONS(1458),
    [anon_sym___fastcall] = ACTIONS(1458),
    [anon_sym___thiscall] = ACTIONS(1458),
    [anon_sym___vectorcall] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_else] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1458),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1458),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(1458),
    [anon_sym_static_assert] = ACTIONS(1458),
    [anon_sym_concept] = ACTIONS(1458),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [96] = {
    [sym_declaration] = STATE(103),
    [sym_type_definition] = STATE(103),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5184),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(103),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_seh_try_statement] = STATE(103),
    [sym_seh_leave_statement] = STATE(103),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(103),
    [sym_co_return_statement] = STATE(103),
    [sym_co_yield_statement] = STATE(103),
    [sym_throw_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(103),
    [sym_identifier] = ACTIONS(1530),
    [aux_sym_preproc_include_token1] = ACTIONS(1462),
    [aux_sym_preproc_def_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1462),
    [sym_preproc_directive] = ACTIONS(1462),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(1532),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1462),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1462),
    [anon_sym___cdecl] = ACTIONS(1462),
    [anon_sym___clrcall] = ACTIONS(1462),
    [anon_sym___stdcall] = ACTIONS(1462),
    [anon_sym___fastcall] = ACTIONS(1462),
    [anon_sym___thiscall] = ACTIONS(1462),
    [anon_sym___vectorcall] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1462),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1462),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_static_assert] = ACTIONS(1462),
    [anon_sym_concept] = ACTIONS(1462),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [97] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5196),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1534),
    [aux_sym_preproc_include_token1] = ACTIONS(1251),
    [aux_sym_preproc_def_token1] = ACTIONS(1251),
    [aux_sym_preproc_if_token1] = ACTIONS(1251),
    [aux_sym_preproc_if_token2] = ACTIONS(1251),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1251),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1251),
    [sym_preproc_directive] = ACTIONS(1251),
    [anon_sym_LPAREN2] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym___extension__] = ACTIONS(1540),
    [anon_sym_typedef] = ACTIONS(1543),
    [anon_sym_virtual] = ACTIONS(1279),
    [anon_sym_extern] = ACTIONS(1282),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym___attribute] = ACTIONS(1285),
    [anon_sym_using] = ACTIONS(1251),
    [anon_sym_COLON_COLON] = ACTIONS(1288),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1294),
    [anon_sym___based] = ACTIONS(1251),
    [anon_sym___cdecl] = ACTIONS(1251),
    [anon_sym___clrcall] = ACTIONS(1251),
    [anon_sym___stdcall] = ACTIONS(1251),
    [anon_sym___fastcall] = ACTIONS(1251),
    [anon_sym___thiscall] = ACTIONS(1251),
    [anon_sym___vectorcall] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_signed] = ACTIONS(1300),
    [anon_sym_unsigned] = ACTIONS(1300),
    [anon_sym_long] = ACTIONS(1300),
    [anon_sym_short] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1282),
    [anon_sym_register] = ACTIONS(1282),
    [anon_sym_inline] = ACTIONS(1282),
    [anon_sym___inline] = ACTIONS(1282),
    [anon_sym___inline__] = ACTIONS(1282),
    [anon_sym___forceinline] = ACTIONS(1282),
    [anon_sym_thread_local] = ACTIONS(1282),
    [anon_sym___thread] = ACTIONS(1282),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_constexpr] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym___restrict__] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym__Noreturn] = ACTIONS(1306),
    [anon_sym_noreturn] = ACTIONS(1306),
    [anon_sym__Nonnull] = ACTIONS(1306),
    [anon_sym_mutable] = ACTIONS(1306),
    [anon_sym_constinit] = ACTIONS(1306),
    [anon_sym_consteval] = ACTIONS(1306),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1312),
    [anon_sym_enum] = ACTIONS(1315),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1324),
    [anon_sym_if] = ACTIONS(1549),
    [anon_sym_else] = ACTIONS(1251),
    [anon_sym_switch] = ACTIONS(1552),
    [anon_sym_case] = ACTIONS(1251),
    [anon_sym_default] = ACTIONS(1251),
    [anon_sym_while] = ACTIONS(1555),
    [anon_sym_do] = ACTIONS(1558),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1564),
    [anon_sym_break] = ACTIONS(1567),
    [anon_sym_continue] = ACTIONS(1570),
    [anon_sym_goto] = ACTIONS(1573),
    [anon_sym___try] = ACTIONS(1576),
    [anon_sym___leave] = ACTIONS(1579),
    [anon_sym_not] = ACTIONS(1259),
    [anon_sym_compl] = ACTIONS(1259),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_sizeof] = ACTIONS(1363),
    [anon_sym___alignof__] = ACTIONS(1366),
    [anon_sym___alignof] = ACTIONS(1366),
    [anon_sym__alignof] = ACTIONS(1366),
    [anon_sym_alignof] = ACTIONS(1366),
    [anon_sym__Alignof] = ACTIONS(1366),
    [anon_sym_offsetof] = ACTIONS(1369),
    [anon_sym__Generic] = ACTIONS(1372),
    [anon_sym_asm] = ACTIONS(1375),
    [anon_sym___asm__] = ACTIONS(1375),
    [anon_sym___asm] = ACTIONS(1375),
    [sym_number_literal] = ACTIONS(1378),
    [anon_sym_L_SQUOTE] = ACTIONS(1381),
    [anon_sym_u_SQUOTE] = ACTIONS(1381),
    [anon_sym_U_SQUOTE] = ACTIONS(1381),
    [anon_sym_u8_SQUOTE] = ACTIONS(1381),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [anon_sym_L_DQUOTE] = ACTIONS(1384),
    [anon_sym_u_DQUOTE] = ACTIONS(1384),
    [anon_sym_U_DQUOTE] = ACTIONS(1384),
    [anon_sym_u8_DQUOTE] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_true] = ACTIONS(1387),
    [sym_false] = ACTIONS(1387),
    [anon_sym_NULL] = ACTIONS(1390),
    [anon_sym_nullptr] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1393),
    [anon_sym_decltype] = ACTIONS(1396),
    [anon_sym_explicit] = ACTIONS(1251),
    [anon_sym_typename] = ACTIONS(1399),
    [anon_sym_template] = ACTIONS(1402),
    [anon_sym_operator] = ACTIONS(1251),
    [anon_sym_try] = ACTIONS(1582),
    [anon_sym_delete] = ACTIONS(1408),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_namespace] = ACTIONS(1251),
    [anon_sym_static_assert] = ACTIONS(1251),
    [anon_sym_concept] = ACTIONS(1251),
    [anon_sym_co_return] = ACTIONS(1588),
    [anon_sym_co_yield] = ACTIONS(1591),
    [anon_sym_R_DQUOTE] = ACTIONS(1420),
    [anon_sym_LR_DQUOTE] = ACTIONS(1420),
    [anon_sym_uR_DQUOTE] = ACTIONS(1420),
    [anon_sym_UR_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1420),
    [anon_sym_co_await] = ACTIONS(1423),
    [anon_sym_new] = ACTIONS(1426),
    [anon_sym_requires] = ACTIONS(1429),
    [sym_this] = ACTIONS(1387),
  },
  [98] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5196),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1594),
    [aux_sym_preproc_include_token1] = ACTIONS(1462),
    [aux_sym_preproc_def_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token2] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1462),
    [sym_preproc_directive] = ACTIONS(1462),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(1596),
    [anon_sym_typedef] = ACTIONS(888),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1462),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1462),
    [anon_sym___cdecl] = ACTIONS(1462),
    [anon_sym___clrcall] = ACTIONS(1462),
    [anon_sym___stdcall] = ACTIONS(1462),
    [anon_sym___fastcall] = ACTIONS(1462),
    [anon_sym___thiscall] = ACTIONS(1462),
    [anon_sym___vectorcall] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1462),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1462),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_static_assert] = ACTIONS(1462),
    [anon_sym_concept] = ACTIONS(1462),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [99] = {
    [sym_declaration] = STATE(102),
    [sym_type_definition] = STATE(102),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5196),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(102),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(102),
    [sym_labeled_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym_if_statement] = STATE(102),
    [sym_switch_statement] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_do_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_break_statement] = STATE(102),
    [sym_continue_statement] = STATE(102),
    [sym_goto_statement] = STATE(102),
    [sym_seh_try_statement] = STATE(102),
    [sym_seh_leave_statement] = STATE(102),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(102),
    [sym_co_return_statement] = STATE(102),
    [sym_co_yield_statement] = STATE(102),
    [sym_throw_statement] = STATE(102),
    [sym_try_statement] = STATE(102),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(102),
    [sym_identifier] = ACTIONS(1594),
    [aux_sym_preproc_include_token1] = ACTIONS(1434),
    [aux_sym_preproc_def_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token2] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1434),
    [sym_preproc_directive] = ACTIONS(1434),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(1596),
    [anon_sym_typedef] = ACTIONS(888),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1434),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1434),
    [anon_sym___cdecl] = ACTIONS(1434),
    [anon_sym___clrcall] = ACTIONS(1434),
    [anon_sym___stdcall] = ACTIONS(1434),
    [anon_sym___fastcall] = ACTIONS(1434),
    [anon_sym___thiscall] = ACTIONS(1434),
    [anon_sym___vectorcall] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1434),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1434),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_static_assert] = ACTIONS(1434),
    [anon_sym_concept] = ACTIONS(1434),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [100] = {
    [sym_declaration] = STATE(96),
    [sym_type_definition] = STATE(96),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5184),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(96),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(96),
    [sym_labeled_statement] = STATE(96),
    [sym_expression_statement] = STATE(96),
    [sym_if_statement] = STATE(96),
    [sym_switch_statement] = STATE(96),
    [sym_while_statement] = STATE(96),
    [sym_do_statement] = STATE(96),
    [sym_for_statement] = STATE(96),
    [sym_return_statement] = STATE(96),
    [sym_break_statement] = STATE(96),
    [sym_continue_statement] = STATE(96),
    [sym_goto_statement] = STATE(96),
    [sym_seh_try_statement] = STATE(96),
    [sym_seh_leave_statement] = STATE(96),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(96),
    [sym_co_return_statement] = STATE(96),
    [sym_co_yield_statement] = STATE(96),
    [sym_throw_statement] = STATE(96),
    [sym_try_statement] = STATE(96),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(96),
    [sym_identifier] = ACTIONS(1530),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(1532),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1454),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_else] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1454),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1454),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(1454),
    [anon_sym_static_assert] = ACTIONS(1454),
    [anon_sym_concept] = ACTIONS(1454),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [101] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5184),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(1530),
    [aux_sym_preproc_include_token1] = ACTIONS(1434),
    [aux_sym_preproc_def_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1434),
    [sym_preproc_directive] = ACTIONS(1434),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(1532),
    [anon_sym_typedef] = ACTIONS(185),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1434),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1434),
    [anon_sym___cdecl] = ACTIONS(1434),
    [anon_sym___clrcall] = ACTIONS(1434),
    [anon_sym___stdcall] = ACTIONS(1434),
    [anon_sym___fastcall] = ACTIONS(1434),
    [anon_sym___thiscall] = ACTIONS(1434),
    [anon_sym___vectorcall] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1434),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1434),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_static_assert] = ACTIONS(1434),
    [anon_sym_concept] = ACTIONS(1434),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [102] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5196),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1594),
    [aux_sym_preproc_include_token1] = ACTIONS(1458),
    [aux_sym_preproc_def_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token2] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1458),
    [sym_preproc_directive] = ACTIONS(1458),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1460),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(1596),
    [anon_sym_typedef] = ACTIONS(888),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1458),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1458),
    [anon_sym___cdecl] = ACTIONS(1458),
    [anon_sym___clrcall] = ACTIONS(1458),
    [anon_sym___stdcall] = ACTIONS(1458),
    [anon_sym___fastcall] = ACTIONS(1458),
    [anon_sym___thiscall] = ACTIONS(1458),
    [anon_sym___vectorcall] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1458),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1458),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(1458),
    [anon_sym_static_assert] = ACTIONS(1458),
    [anon_sym_concept] = ACTIONS(1458),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [103] = {
    [sym_declaration] = STATE(103),
    [sym_type_definition] = STATE(103),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5184),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(103),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_seh_try_statement] = STATE(103),
    [sym_seh_leave_statement] = STATE(103),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(103),
    [sym_co_return_statement] = STATE(103),
    [sym_co_yield_statement] = STATE(103),
    [sym_throw_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(103),
    [sym_identifier] = ACTIONS(1598),
    [aux_sym_preproc_include_token1] = ACTIONS(1251),
    [aux_sym_preproc_def_token1] = ACTIONS(1251),
    [aux_sym_preproc_if_token1] = ACTIONS(1251),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1251),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1251),
    [sym_preproc_directive] = ACTIONS(1251),
    [anon_sym_LPAREN2] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym___extension__] = ACTIONS(1604),
    [anon_sym_typedef] = ACTIONS(1607),
    [anon_sym_virtual] = ACTIONS(1279),
    [anon_sym_extern] = ACTIONS(1282),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym___attribute] = ACTIONS(1285),
    [anon_sym_using] = ACTIONS(1251),
    [anon_sym_COLON_COLON] = ACTIONS(1288),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1294),
    [anon_sym___based] = ACTIONS(1251),
    [anon_sym___cdecl] = ACTIONS(1251),
    [anon_sym___clrcall] = ACTIONS(1251),
    [anon_sym___stdcall] = ACTIONS(1251),
    [anon_sym___fastcall] = ACTIONS(1251),
    [anon_sym___thiscall] = ACTIONS(1251),
    [anon_sym___vectorcall] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_signed] = ACTIONS(1300),
    [anon_sym_unsigned] = ACTIONS(1300),
    [anon_sym_long] = ACTIONS(1300),
    [anon_sym_short] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1282),
    [anon_sym_register] = ACTIONS(1282),
    [anon_sym_inline] = ACTIONS(1282),
    [anon_sym___inline] = ACTIONS(1282),
    [anon_sym___inline__] = ACTIONS(1282),
    [anon_sym___forceinline] = ACTIONS(1282),
    [anon_sym_thread_local] = ACTIONS(1282),
    [anon_sym___thread] = ACTIONS(1282),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_constexpr] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym___restrict__] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym__Noreturn] = ACTIONS(1306),
    [anon_sym_noreturn] = ACTIONS(1306),
    [anon_sym__Nonnull] = ACTIONS(1306),
    [anon_sym_mutable] = ACTIONS(1306),
    [anon_sym_constinit] = ACTIONS(1306),
    [anon_sym_consteval] = ACTIONS(1306),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1312),
    [anon_sym_enum] = ACTIONS(1315),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1324),
    [anon_sym_if] = ACTIONS(1613),
    [anon_sym_else] = ACTIONS(1251),
    [anon_sym_switch] = ACTIONS(1616),
    [anon_sym_case] = ACTIONS(1251),
    [anon_sym_default] = ACTIONS(1251),
    [anon_sym_while] = ACTIONS(1619),
    [anon_sym_do] = ACTIONS(1622),
    [anon_sym_for] = ACTIONS(1625),
    [anon_sym_return] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(1631),
    [anon_sym_continue] = ACTIONS(1634),
    [anon_sym_goto] = ACTIONS(1637),
    [anon_sym___try] = ACTIONS(1640),
    [anon_sym___leave] = ACTIONS(1643),
    [anon_sym_not] = ACTIONS(1259),
    [anon_sym_compl] = ACTIONS(1259),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_sizeof] = ACTIONS(1363),
    [anon_sym___alignof__] = ACTIONS(1366),
    [anon_sym___alignof] = ACTIONS(1366),
    [anon_sym__alignof] = ACTIONS(1366),
    [anon_sym_alignof] = ACTIONS(1366),
    [anon_sym__Alignof] = ACTIONS(1366),
    [anon_sym_offsetof] = ACTIONS(1369),
    [anon_sym__Generic] = ACTIONS(1372),
    [anon_sym_asm] = ACTIONS(1375),
    [anon_sym___asm__] = ACTIONS(1375),
    [anon_sym___asm] = ACTIONS(1375),
    [sym_number_literal] = ACTIONS(1378),
    [anon_sym_L_SQUOTE] = ACTIONS(1381),
    [anon_sym_u_SQUOTE] = ACTIONS(1381),
    [anon_sym_U_SQUOTE] = ACTIONS(1381),
    [anon_sym_u8_SQUOTE] = ACTIONS(1381),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [anon_sym_L_DQUOTE] = ACTIONS(1384),
    [anon_sym_u_DQUOTE] = ACTIONS(1384),
    [anon_sym_U_DQUOTE] = ACTIONS(1384),
    [anon_sym_u8_DQUOTE] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_true] = ACTIONS(1387),
    [sym_false] = ACTIONS(1387),
    [anon_sym_NULL] = ACTIONS(1390),
    [anon_sym_nullptr] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1393),
    [anon_sym_decltype] = ACTIONS(1396),
    [anon_sym_explicit] = ACTIONS(1251),
    [anon_sym_typename] = ACTIONS(1399),
    [anon_sym_template] = ACTIONS(1402),
    [anon_sym_operator] = ACTIONS(1251),
    [anon_sym_try] = ACTIONS(1646),
    [anon_sym_delete] = ACTIONS(1408),
    [anon_sym_throw] = ACTIONS(1649),
    [anon_sym_namespace] = ACTIONS(1251),
    [anon_sym_static_assert] = ACTIONS(1251),
    [anon_sym_concept] = ACTIONS(1251),
    [anon_sym_co_return] = ACTIONS(1652),
    [anon_sym_co_yield] = ACTIONS(1655),
    [anon_sym_R_DQUOTE] = ACTIONS(1420),
    [anon_sym_LR_DQUOTE] = ACTIONS(1420),
    [anon_sym_uR_DQUOTE] = ACTIONS(1420),
    [anon_sym_UR_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1420),
    [anon_sym_co_await] = ACTIONS(1423),
    [anon_sym_new] = ACTIONS(1426),
    [anon_sym_requires] = ACTIONS(1429),
    [sym_this] = ACTIONS(1387),
  },
  [104] = {
    [sym_declaration] = STATE(98),
    [sym_type_definition] = STATE(98),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5196),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(98),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym_seh_try_statement] = STATE(98),
    [sym_seh_leave_statement] = STATE(98),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(98),
    [sym_co_return_statement] = STATE(98),
    [sym_co_yield_statement] = STATE(98),
    [sym_throw_statement] = STATE(98),
    [sym_try_statement] = STATE(98),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(98),
    [sym_identifier] = ACTIONS(1594),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token2] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(1596),
    [anon_sym_typedef] = ACTIONS(888),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1454),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1454),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1454),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(1454),
    [anon_sym_static_assert] = ACTIONS(1454),
    [anon_sym_concept] = ACTIONS(1454),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [105] = {
    [sym_declaration] = STATE(571),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5184),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(571),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4403),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7580),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1530),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(1658),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [106] = {
    [sym_declaration] = STATE(108),
    [sym_type_definition] = STATE(108),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5209),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(108),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(108),
    [sym_labeled_statement] = STATE(108),
    [sym_expression_statement] = STATE(108),
    [sym_if_statement] = STATE(108),
    [sym_switch_statement] = STATE(108),
    [sym_while_statement] = STATE(108),
    [sym_do_statement] = STATE(108),
    [sym_for_statement] = STATE(108),
    [sym_return_statement] = STATE(108),
    [sym_break_statement] = STATE(108),
    [sym_continue_statement] = STATE(108),
    [sym_goto_statement] = STATE(108),
    [sym_seh_try_statement] = STATE(108),
    [sym_seh_leave_statement] = STATE(108),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(108),
    [sym_co_return_statement] = STATE(108),
    [sym_co_yield_statement] = STATE(108),
    [sym_throw_statement] = STATE(108),
    [sym_try_statement] = STATE(108),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(108),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1664),
    [anon_sym_typedef] = ACTIONS(1666),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_else] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [107] = {
    [sym_declaration] = STATE(107),
    [sym_type_definition] = STATE(107),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5209),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(107),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(107),
    [sym_labeled_statement] = STATE(107),
    [sym_expression_statement] = STATE(107),
    [sym_if_statement] = STATE(107),
    [sym_switch_statement] = STATE(107),
    [sym_while_statement] = STATE(107),
    [sym_do_statement] = STATE(107),
    [sym_for_statement] = STATE(107),
    [sym_return_statement] = STATE(107),
    [sym_break_statement] = STATE(107),
    [sym_continue_statement] = STATE(107),
    [sym_goto_statement] = STATE(107),
    [sym_seh_try_statement] = STATE(107),
    [sym_seh_leave_statement] = STATE(107),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(107),
    [sym_co_return_statement] = STATE(107),
    [sym_co_yield_statement] = STATE(107),
    [sym_throw_statement] = STATE(107),
    [sym_try_statement] = STATE(107),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(107),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_LPAREN2] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_AMP] = ACTIONS(1262),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym___extension__] = ACTIONS(1706),
    [anon_sym_typedef] = ACTIONS(1709),
    [anon_sym_virtual] = ACTIONS(1279),
    [anon_sym_extern] = ACTIONS(1282),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym___attribute] = ACTIONS(1285),
    [anon_sym_COLON_COLON] = ACTIONS(1288),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(1712),
    [anon_sym_signed] = ACTIONS(1300),
    [anon_sym_unsigned] = ACTIONS(1300),
    [anon_sym_long] = ACTIONS(1300),
    [anon_sym_short] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1282),
    [anon_sym_register] = ACTIONS(1282),
    [anon_sym_inline] = ACTIONS(1282),
    [anon_sym___inline] = ACTIONS(1282),
    [anon_sym___inline__] = ACTIONS(1282),
    [anon_sym___forceinline] = ACTIONS(1282),
    [anon_sym_thread_local] = ACTIONS(1282),
    [anon_sym___thread] = ACTIONS(1282),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_constexpr] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym___restrict__] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym__Noreturn] = ACTIONS(1306),
    [anon_sym_noreturn] = ACTIONS(1306),
    [anon_sym__Nonnull] = ACTIONS(1306),
    [anon_sym_mutable] = ACTIONS(1306),
    [anon_sym_constinit] = ACTIONS(1306),
    [anon_sym_consteval] = ACTIONS(1306),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1312),
    [anon_sym_enum] = ACTIONS(1315),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1324),
    [anon_sym_if] = ACTIONS(1715),
    [anon_sym_else] = ACTIONS(1251),
    [anon_sym_switch] = ACTIONS(1718),
    [anon_sym_while] = ACTIONS(1721),
    [anon_sym_do] = ACTIONS(1724),
    [anon_sym_for] = ACTIONS(1727),
    [anon_sym_return] = ACTIONS(1730),
    [anon_sym_break] = ACTIONS(1733),
    [anon_sym_continue] = ACTIONS(1736),
    [anon_sym_goto] = ACTIONS(1739),
    [anon_sym___try] = ACTIONS(1742),
    [anon_sym___leave] = ACTIONS(1745),
    [anon_sym_not] = ACTIONS(1259),
    [anon_sym_compl] = ACTIONS(1259),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_sizeof] = ACTIONS(1363),
    [anon_sym___alignof__] = ACTIONS(1366),
    [anon_sym___alignof] = ACTIONS(1366),
    [anon_sym__alignof] = ACTIONS(1366),
    [anon_sym_alignof] = ACTIONS(1366),
    [anon_sym__Alignof] = ACTIONS(1366),
    [anon_sym_offsetof] = ACTIONS(1369),
    [anon_sym__Generic] = ACTIONS(1372),
    [anon_sym_asm] = ACTIONS(1375),
    [anon_sym___asm__] = ACTIONS(1375),
    [anon_sym___asm] = ACTIONS(1375),
    [sym_number_literal] = ACTIONS(1378),
    [anon_sym_L_SQUOTE] = ACTIONS(1381),
    [anon_sym_u_SQUOTE] = ACTIONS(1381),
    [anon_sym_U_SQUOTE] = ACTIONS(1381),
    [anon_sym_u8_SQUOTE] = ACTIONS(1381),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [anon_sym_L_DQUOTE] = ACTIONS(1384),
    [anon_sym_u_DQUOTE] = ACTIONS(1384),
    [anon_sym_U_DQUOTE] = ACTIONS(1384),
    [anon_sym_u8_DQUOTE] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_true] = ACTIONS(1387),
    [sym_false] = ACTIONS(1387),
    [anon_sym_NULL] = ACTIONS(1390),
    [anon_sym_nullptr] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1393),
    [anon_sym_decltype] = ACTIONS(1396),
    [anon_sym_typename] = ACTIONS(1399),
    [anon_sym_template] = ACTIONS(1402),
    [anon_sym_try] = ACTIONS(1748),
    [anon_sym_delete] = ACTIONS(1408),
    [anon_sym_throw] = ACTIONS(1751),
    [anon_sym_co_return] = ACTIONS(1754),
    [anon_sym_co_yield] = ACTIONS(1757),
    [anon_sym_R_DQUOTE] = ACTIONS(1420),
    [anon_sym_LR_DQUOTE] = ACTIONS(1420),
    [anon_sym_uR_DQUOTE] = ACTIONS(1420),
    [anon_sym_UR_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1420),
    [anon_sym_co_await] = ACTIONS(1423),
    [anon_sym_new] = ACTIONS(1426),
    [anon_sym_requires] = ACTIONS(1429),
    [sym_this] = ACTIONS(1387),
  },
  [108] = {
    [sym_declaration] = STATE(107),
    [sym_type_definition] = STATE(107),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5209),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(107),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(107),
    [sym_labeled_statement] = STATE(107),
    [sym_expression_statement] = STATE(107),
    [sym_if_statement] = STATE(107),
    [sym_switch_statement] = STATE(107),
    [sym_while_statement] = STATE(107),
    [sym_do_statement] = STATE(107),
    [sym_for_statement] = STATE(107),
    [sym_return_statement] = STATE(107),
    [sym_break_statement] = STATE(107),
    [sym_continue_statement] = STATE(107),
    [sym_goto_statement] = STATE(107),
    [sym_seh_try_statement] = STATE(107),
    [sym_seh_leave_statement] = STATE(107),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(107),
    [sym_co_return_statement] = STATE(107),
    [sym_co_yield_statement] = STATE(107),
    [sym_throw_statement] = STATE(107),
    [sym_try_statement] = STATE(107),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(107),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1664),
    [anon_sym_typedef] = ACTIONS(1666),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [109] = {
    [sym_declaration] = STATE(913),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5209),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(904),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(904),
    [sym_statement] = STATE(913),
    [sym_labeled_statement] = STATE(904),
    [sym_expression_statement] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_switch_statement] = STATE(904),
    [sym_case_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_do_statement] = STATE(904),
    [sym_for_statement] = STATE(904),
    [sym_return_statement] = STATE(904),
    [sym_break_statement] = STATE(904),
    [sym_continue_statement] = STATE(904),
    [sym_goto_statement] = STATE(904),
    [sym_seh_try_statement] = STATE(904),
    [sym_seh_leave_statement] = STATE(904),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(904),
    [sym_co_return_statement] = STATE(904),
    [sym_co_yield_statement] = STATE(904),
    [sym_throw_statement] = STATE(904),
    [sym_try_statement] = STATE(904),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1658),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [110] = {
    [sym_declaration] = STATE(423),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5215),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(423),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1764),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(1658),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [111] = {
    [sym_declaration] = STATE(256),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5180),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(279),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(279),
    [sym_statement] = STATE(256),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(1658),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [112] = {
    [sym_declaration] = STATE(578),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5196),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(529),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(529),
    [sym_statement] = STATE(578),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1594),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(1658),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [113] = {
    [sym_declaration] = STATE(571),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5184),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(545),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(571),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1530),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(1658),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [114] = {
    [sym_declaration] = STATE(107),
    [sym_type_definition] = STATE(107),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5209),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(107),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(107),
    [sym_labeled_statement] = STATE(107),
    [sym_expression_statement] = STATE(107),
    [sym_if_statement] = STATE(107),
    [sym_switch_statement] = STATE(107),
    [sym_while_statement] = STATE(107),
    [sym_do_statement] = STATE(107),
    [sym_for_statement] = STATE(107),
    [sym_return_statement] = STATE(107),
    [sym_break_statement] = STATE(107),
    [sym_continue_statement] = STATE(107),
    [sym_goto_statement] = STATE(107),
    [sym_seh_try_statement] = STATE(107),
    [sym_seh_leave_statement] = STATE(107),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(107),
    [sym_co_return_statement] = STATE(107),
    [sym_co_yield_statement] = STATE(107),
    [sym_throw_statement] = STATE(107),
    [sym_try_statement] = STATE(107),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(107),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1664),
    [anon_sym_typedef] = ACTIONS(1666),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_else] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [115] = {
    [sym_declaration] = STATE(114),
    [sym_type_definition] = STATE(114),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5209),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(114),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(114),
    [sym_labeled_statement] = STATE(114),
    [sym_expression_statement] = STATE(114),
    [sym_if_statement] = STATE(114),
    [sym_switch_statement] = STATE(114),
    [sym_while_statement] = STATE(114),
    [sym_do_statement] = STATE(114),
    [sym_for_statement] = STATE(114),
    [sym_return_statement] = STATE(114),
    [sym_break_statement] = STATE(114),
    [sym_continue_statement] = STATE(114),
    [sym_goto_statement] = STATE(114),
    [sym_seh_try_statement] = STATE(114),
    [sym_seh_leave_statement] = STATE(114),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(114),
    [sym_co_return_statement] = STATE(114),
    [sym_co_yield_statement] = STATE(114),
    [sym_throw_statement] = STATE(114),
    [sym_try_statement] = STATE(114),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_case_statement_repeat1] = STATE(114),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1664),
    [anon_sym_typedef] = ACTIONS(1666),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [116] = {
    [sym_declaration] = STATE(423),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5215),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(900),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_compound_statement] = STATE(401),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_attributed_statement] = STATE(401),
    [sym_statement] = STATE(423),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1466),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(1658),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [117] = {
    [sym_declaration] = STATE(419),
    [sym_type_definition] = STATE(4066),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5217),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_expression_statement] = STATE(4066),
    [sym__for_statement_body] = STATE(8140),
    [sym_expression] = STATE(4446),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8178),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_alias_declaration] = STATE(4066),
    [sym__for_range_loop_body] = STATE(8242),
    [sym_init_statement] = STATE(1915),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1776),
    [anon_sym___extension__] = ACTIONS(1778),
    [anon_sym_typedef] = ACTIONS(1780),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [118] = {
    [sym_declaration] = STATE(419),
    [sym_type_definition] = STATE(4066),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5217),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_expression_statement] = STATE(4066),
    [sym__for_statement_body] = STATE(8758),
    [sym_expression] = STATE(4446),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8178),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_alias_declaration] = STATE(4066),
    [sym__for_range_loop_body] = STATE(8759),
    [sym_init_statement] = STATE(1915),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1776),
    [anon_sym___extension__] = ACTIONS(1778),
    [anon_sym_typedef] = ACTIONS(1780),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [119] = {
    [sym_declaration] = STATE(419),
    [sym_type_definition] = STATE(4066),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5217),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_expression_statement] = STATE(4066),
    [sym__for_statement_body] = STATE(8789),
    [sym_expression] = STATE(4446),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8178),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_alias_declaration] = STATE(4066),
    [sym__for_range_loop_body] = STATE(8791),
    [sym_init_statement] = STATE(1915),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1776),
    [anon_sym___extension__] = ACTIONS(1778),
    [anon_sym_typedef] = ACTIONS(1780),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [120] = {
    [sym_declaration] = STATE(419),
    [sym_type_definition] = STATE(4066),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5217),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_expression_statement] = STATE(4066),
    [sym__for_statement_body] = STATE(8144),
    [sym_expression] = STATE(4446),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8178),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_alias_declaration] = STATE(4066),
    [sym__for_range_loop_body] = STATE(8191),
    [sym_init_statement] = STATE(1915),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1776),
    [anon_sym___extension__] = ACTIONS(1778),
    [anon_sym_typedef] = ACTIONS(1780),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [121] = {
    [sym_declaration] = STATE(419),
    [sym_type_definition] = STATE(4066),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5217),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_expression_statement] = STATE(4066),
    [sym__for_statement_body] = STATE(8285),
    [sym_expression] = STATE(4446),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8178),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_alias_declaration] = STATE(4066),
    [sym__for_range_loop_body] = STATE(8304),
    [sym_init_statement] = STATE(1915),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1776),
    [anon_sym___extension__] = ACTIONS(1778),
    [anon_sym_typedef] = ACTIONS(1780),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [122] = {
    [sym_declaration] = STATE(419),
    [sym_type_definition] = STATE(4066),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5217),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_expression_statement] = STATE(4066),
    [sym__for_statement_body] = STATE(8053),
    [sym_expression] = STATE(4446),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8178),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_alias_declaration] = STATE(4066),
    [sym__for_range_loop_body] = STATE(8054),
    [sym_init_statement] = STATE(1915),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1776),
    [anon_sym___extension__] = ACTIONS(1778),
    [anon_sym_typedef] = ACTIONS(1780),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [123] = {
    [sym_declaration] = STATE(1549),
    [sym_type_definition] = STATE(1549),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5168),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_expression_statement] = STATE(1549),
    [sym_expression] = STATE(4400),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7863),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_alias_declaration] = STATE(1549),
    [sym_init_statement] = STATE(134),
    [sym_condition_declaration] = STATE(8609),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(1664),
    [anon_sym_typedef] = ACTIONS(1666),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1786),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [124] = {
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(5281),
    [sym__declarator] = STATE(6672),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(8409),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2919),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8409),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8413),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3233),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8414),
    [sym__unary_right_fold] = STATE(8418),
    [sym__binary_fold] = STATE(8419),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5788),
    [sym_qualified_identifier] = STATE(3292),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8421),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1802),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(1808),
    [anon_sym___clrcall] = ACTIONS(1808),
    [anon_sym___stdcall] = ACTIONS(1808),
    [anon_sym___fastcall] = ACTIONS(1808),
    [anon_sym___thiscall] = ACTIONS(1808),
    [anon_sym___vectorcall] = ACTIONS(1808),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [125] = {
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(5281),
    [sym__declarator] = STATE(6672),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8230),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3233),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5788),
    [sym_qualified_identifier] = STATE(3292),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1802),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(1808),
    [anon_sym___clrcall] = ACTIONS(1808),
    [anon_sym___stdcall] = ACTIONS(1808),
    [anon_sym___fastcall] = ACTIONS(1808),
    [anon_sym___thiscall] = ACTIONS(1808),
    [anon_sym___vectorcall] = ACTIONS(1808),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [126] = {
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(5281),
    [sym__declarator] = STATE(6672),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8727),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3233),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5788),
    [sym_qualified_identifier] = STATE(3292),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1802),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(1808),
    [anon_sym___clrcall] = ACTIONS(1808),
    [anon_sym___stdcall] = ACTIONS(1808),
    [anon_sym___fastcall] = ACTIONS(1808),
    [anon_sym___thiscall] = ACTIONS(1808),
    [anon_sym___vectorcall] = ACTIONS(1808),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [127] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7359),
    [sym_expression] = STATE(3345),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7359),
    [sym_variadic_parameter_declaration] = STATE(7359),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8414),
    [sym__unary_right_fold] = STATE(8418),
    [sym__binary_fold] = STATE(8419),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5763),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3506),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1864),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1876),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1882),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [128] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7359),
    [sym_expression] = STATE(3272),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7359),
    [sym_variadic_parameter_declaration] = STATE(7359),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5763),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3506),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1864),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1876),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1882),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [129] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7359),
    [sym_expression] = STATE(3244),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7359),
    [sym_variadic_parameter_declaration] = STATE(7359),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5763),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3506),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1864),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1876),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1882),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [130] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7359),
    [sym_expression] = STATE(3290),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7359),
    [sym_variadic_parameter_declaration] = STATE(7359),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8396),
    [sym__unary_right_fold] = STATE(8410),
    [sym__binary_fold] = STATE(8415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5763),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3506),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1864),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1876),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1882),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [131] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7359),
    [sym_expression] = STATE(3220),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7359),
    [sym_variadic_parameter_declaration] = STATE(7359),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8699),
    [sym__unary_right_fold] = STATE(8700),
    [sym__binary_fold] = STATE(8703),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5763),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3506),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1864),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1876),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1882),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [132] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7359),
    [sym_expression] = STATE(3236),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7359),
    [sym_variadic_parameter_declaration] = STATE(7359),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8605),
    [sym__unary_right_fold] = STATE(8610),
    [sym__binary_fold] = STATE(8628),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5763),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3506),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1864),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1876),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1882),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [133] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_compound_statement] = STATE(7153),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7399),
    [sym_expression] = STATE(4348),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7153),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7399),
    [sym_variadic_parameter_declaration] = STATE(7399),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5775),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1928),
    [anon_sym_RPAREN] = ACTIONS(1930),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1658),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [134] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5244),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_expression] = STATE(4470),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8444),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3103),
    [sym_template_function] = STATE(3889),
    [sym_condition_declaration] = STATE(8444),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5725),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(3109),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1658),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(1934),
    [sym_identifier] = ACTIONS(1936),
    [aux_sym_preproc_include_token1] = ACTIONS(1936),
    [aux_sym_preproc_def_token1] = ACTIONS(1936),
    [anon_sym_COMMA] = ACTIONS(1934),
    [anon_sym_RPAREN] = ACTIONS(1934),
    [aux_sym_preproc_if_token1] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1936),
    [sym_preproc_directive] = ACTIONS(1936),
    [anon_sym_LPAREN2] = ACTIONS(1934),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_DASH] = ACTIONS(1936),
    [anon_sym_PLUS] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(1934),
    [anon_sym_PIPE_PIPE] = ACTIONS(1934),
    [anon_sym_AMP_AMP] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym___extension__] = ACTIONS(1936),
    [anon_sym_typedef] = ACTIONS(1936),
    [anon_sym_virtual] = ACTIONS(1936),
    [anon_sym_extern] = ACTIONS(1936),
    [anon_sym___attribute__] = ACTIONS(1936),
    [anon_sym___attribute] = ACTIONS(1936),
    [anon_sym_using] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1934),
    [anon_sym___declspec] = ACTIONS(1936),
    [anon_sym___based] = ACTIONS(1936),
    [anon_sym___cdecl] = ACTIONS(1936),
    [anon_sym___clrcall] = ACTIONS(1936),
    [anon_sym___stdcall] = ACTIONS(1936),
    [anon_sym___fastcall] = ACTIONS(1936),
    [anon_sym___thiscall] = ACTIONS(1936),
    [anon_sym___vectorcall] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_signed] = ACTIONS(1936),
    [anon_sym_unsigned] = ACTIONS(1936),
    [anon_sym_long] = ACTIONS(1936),
    [anon_sym_short] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_EQ] = ACTIONS(1934),
    [anon_sym_register] = ACTIONS(1936),
    [anon_sym_inline] = ACTIONS(1936),
    [anon_sym___inline] = ACTIONS(1936),
    [anon_sym___inline__] = ACTIONS(1936),
    [anon_sym___forceinline] = ACTIONS(1936),
    [anon_sym_thread_local] = ACTIONS(1936),
    [anon_sym___thread] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_constexpr] = ACTIONS(1936),
    [anon_sym_volatile] = ACTIONS(1936),
    [anon_sym_restrict] = ACTIONS(1936),
    [anon_sym___restrict__] = ACTIONS(1936),
    [anon_sym__Atomic] = ACTIONS(1936),
    [anon_sym__Noreturn] = ACTIONS(1936),
    [anon_sym_noreturn] = ACTIONS(1936),
    [anon_sym__Nonnull] = ACTIONS(1936),
    [anon_sym_mutable] = ACTIONS(1936),
    [anon_sym_constinit] = ACTIONS(1936),
    [anon_sym_consteval] = ACTIONS(1936),
    [anon_sym_alignas] = ACTIONS(1936),
    [anon_sym__Alignas] = ACTIONS(1936),
    [sym_primitive_type] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_struct] = ACTIONS(1936),
    [anon_sym_union] = ACTIONS(1936),
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(1936),
    [anon_sym_switch] = ACTIONS(1936),
    [anon_sym_case] = ACTIONS(1936),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_while] = ACTIONS(1936),
    [anon_sym_do] = ACTIONS(1936),
    [anon_sym_for] = ACTIONS(1936),
    [anon_sym_return] = ACTIONS(1936),
    [anon_sym_break] = ACTIONS(1936),
    [anon_sym_continue] = ACTIONS(1936),
    [anon_sym_goto] = ACTIONS(1936),
    [anon_sym___try] = ACTIONS(1936),
    [anon_sym___except] = ACTIONS(1936),
    [anon_sym___finally] = ACTIONS(1936),
    [anon_sym___leave] = ACTIONS(1936),
    [anon_sym_not] = ACTIONS(1936),
    [anon_sym_compl] = ACTIONS(1936),
    [anon_sym_or] = ACTIONS(1936),
    [anon_sym_and] = ACTIONS(1936),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_sizeof] = ACTIONS(1936),
    [anon_sym___alignof__] = ACTIONS(1936),
    [anon_sym___alignof] = ACTIONS(1936),
    [anon_sym__alignof] = ACTIONS(1936),
    [anon_sym_alignof] = ACTIONS(1936),
    [anon_sym__Alignof] = ACTIONS(1936),
    [anon_sym_offsetof] = ACTIONS(1936),
    [anon_sym__Generic] = ACTIONS(1936),
    [anon_sym_asm] = ACTIONS(1936),
    [anon_sym___asm__] = ACTIONS(1936),
    [anon_sym___asm] = ACTIONS(1936),
    [sym_number_literal] = ACTIONS(1934),
    [anon_sym_L_SQUOTE] = ACTIONS(1934),
    [anon_sym_u_SQUOTE] = ACTIONS(1934),
    [anon_sym_U_SQUOTE] = ACTIONS(1934),
    [anon_sym_u8_SQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [anon_sym_L_DQUOTE] = ACTIONS(1934),
    [anon_sym_u_DQUOTE] = ACTIONS(1934),
    [anon_sym_U_DQUOTE] = ACTIONS(1934),
    [anon_sym_u8_DQUOTE] = ACTIONS(1934),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [anon_sym_NULL] = ACTIONS(1936),
    [anon_sym_nullptr] = ACTIONS(1936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1936),
    [anon_sym_decltype] = ACTIONS(1936),
    [anon_sym_final] = ACTIONS(1936),
    [anon_sym_override] = ACTIONS(1936),
    [anon_sym_explicit] = ACTIONS(1936),
    [anon_sym_typename] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(1936),
    [anon_sym_module] = ACTIONS(1936),
    [anon_sym_import] = ACTIONS(1936),
    [anon_sym_template] = ACTIONS(1936),
    [anon_sym_GT2] = ACTIONS(1934),
    [anon_sym_operator] = ACTIONS(1936),
    [anon_sym_try] = ACTIONS(1936),
    [anon_sym_delete] = ACTIONS(1936),
    [anon_sym_throw] = ACTIONS(1936),
    [anon_sym_namespace] = ACTIONS(1936),
    [anon_sym_static_assert] = ACTIONS(1936),
    [anon_sym_concept] = ACTIONS(1936),
    [anon_sym_co_return] = ACTIONS(1936),
    [anon_sym_co_yield] = ACTIONS(1936),
    [anon_sym_catch] = ACTIONS(1936),
    [anon_sym_R_DQUOTE] = ACTIONS(1934),
    [anon_sym_LR_DQUOTE] = ACTIONS(1934),
    [anon_sym_uR_DQUOTE] = ACTIONS(1934),
    [anon_sym_UR_DQUOTE] = ACTIONS(1934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1934),
    [anon_sym_co_await] = ACTIONS(1936),
    [anon_sym_new] = ACTIONS(1936),
    [anon_sym_requires] = ACTIONS(1936),
    [sym_this] = ACTIONS(1936),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_include_token1] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(1938),
    [anon_sym_RPAREN] = ACTIONS(1938),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_PIPE_PIPE] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym___cdecl] = ACTIONS(1940),
    [anon_sym___clrcall] = ACTIONS(1940),
    [anon_sym___stdcall] = ACTIONS(1940),
    [anon_sym___fastcall] = ACTIONS(1940),
    [anon_sym___thiscall] = ACTIONS(1940),
    [anon_sym___vectorcall] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_EQ] = ACTIONS(1938),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_else] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1940),
    [anon_sym___try] = ACTIONS(1940),
    [anon_sym___except] = ACTIONS(1940),
    [anon_sym___finally] = ACTIONS(1940),
    [anon_sym___leave] = ACTIONS(1940),
    [anon_sym_not] = ACTIONS(1940),
    [anon_sym_compl] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1940),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_sizeof] = ACTIONS(1940),
    [anon_sym___alignof__] = ACTIONS(1940),
    [anon_sym___alignof] = ACTIONS(1940),
    [anon_sym__alignof] = ACTIONS(1940),
    [anon_sym_alignof] = ACTIONS(1940),
    [anon_sym__Alignof] = ACTIONS(1940),
    [anon_sym_offsetof] = ACTIONS(1940),
    [anon_sym__Generic] = ACTIONS(1940),
    [anon_sym_asm] = ACTIONS(1940),
    [anon_sym___asm__] = ACTIONS(1940),
    [anon_sym___asm] = ACTIONS(1940),
    [sym_number_literal] = ACTIONS(1938),
    [anon_sym_L_SQUOTE] = ACTIONS(1938),
    [anon_sym_u_SQUOTE] = ACTIONS(1938),
    [anon_sym_U_SQUOTE] = ACTIONS(1938),
    [anon_sym_u8_SQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_L_DQUOTE] = ACTIONS(1938),
    [anon_sym_u_DQUOTE] = ACTIONS(1938),
    [anon_sym_U_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8_DQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [anon_sym_NULL] = ACTIONS(1940),
    [anon_sym_nullptr] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_final] = ACTIONS(1940),
    [anon_sym_override] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_export] = ACTIONS(1940),
    [anon_sym_module] = ACTIONS(1940),
    [anon_sym_import] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_GT2] = ACTIONS(1938),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_concept] = ACTIONS(1940),
    [anon_sym_co_return] = ACTIONS(1940),
    [anon_sym_co_yield] = ACTIONS(1940),
    [anon_sym_catch] = ACTIONS(1940),
    [anon_sym_R_DQUOTE] = ACTIONS(1938),
    [anon_sym_LR_DQUOTE] = ACTIONS(1938),
    [anon_sym_uR_DQUOTE] = ACTIONS(1938),
    [anon_sym_UR_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1938),
    [anon_sym_co_await] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_requires] = ACTIONS(1940),
    [sym_this] = ACTIONS(1940),
  },
  [137] = {
    [sym_expression] = STATE(2388),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_initializer_list] = STATE(2441),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [aux_sym_preproc_if_token2] = ACTIONS(1944),
    [aux_sym_preproc_else_token1] = ACTIONS(1944),
    [aux_sym_preproc_elif_token1] = ACTIONS(1942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1944),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1946),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1942),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [anon_sym_EQ] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_STAR_EQ] = ACTIONS(1944),
    [anon_sym_SLASH_EQ] = ACTIONS(1944),
    [anon_sym_PERCENT_EQ] = ACTIONS(1944),
    [anon_sym_PLUS_EQ] = ACTIONS(1944),
    [anon_sym_DASH_EQ] = ACTIONS(1944),
    [anon_sym_LT_LT_EQ] = ACTIONS(1944),
    [anon_sym_GT_GT_EQ] = ACTIONS(1944),
    [anon_sym_AMP_EQ] = ACTIONS(1944),
    [anon_sym_CARET_EQ] = ACTIONS(1944),
    [anon_sym_PIPE_EQ] = ACTIONS(1944),
    [anon_sym_and_eq] = ACTIONS(1942),
    [anon_sym_or_eq] = ACTIONS(1942),
    [anon_sym_xor_eq] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [138] = {
    [sym_expression] = STATE(2388),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_initializer_list] = STATE(2441),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_RPAREN] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1992),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1942),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(1944),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [anon_sym_RBRACK] = ACTIONS(1944),
    [anon_sym_EQ] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_STAR_EQ] = ACTIONS(1944),
    [anon_sym_SLASH_EQ] = ACTIONS(1944),
    [anon_sym_PERCENT_EQ] = ACTIONS(1944),
    [anon_sym_PLUS_EQ] = ACTIONS(1944),
    [anon_sym_DASH_EQ] = ACTIONS(1944),
    [anon_sym_LT_LT_EQ] = ACTIONS(1944),
    [anon_sym_GT_GT_EQ] = ACTIONS(1944),
    [anon_sym_AMP_EQ] = ACTIONS(1944),
    [anon_sym_CARET_EQ] = ACTIONS(1944),
    [anon_sym_PIPE_EQ] = ACTIONS(1944),
    [anon_sym_and_eq] = ACTIONS(1942),
    [anon_sym_or_eq] = ACTIONS(1942),
    [anon_sym_xor_eq] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [139] = {
    [sym_compound_statement] = STATE(8409),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2919),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8409),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8691),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8699),
    [sym__unary_right_fold] = STATE(8700),
    [sym__binary_fold] = STATE(8703),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8421),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [140] = {
    [sym_attribute_declaration] = STATE(141),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(554),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(2022),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_using] = ACTIONS(2026),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [141] = {
    [sym_attribute_declaration] = STATE(141),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(554),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(2030),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2036),
    [anon_sym_TILDE] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_using] = ACTIONS(2051),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2059),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [sym_primitive_type] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_switch] = ACTIONS(2071),
    [anon_sym_case] = ACTIONS(2074),
    [anon_sym_default] = ACTIONS(2077),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2086),
    [anon_sym_return] = ACTIONS(2089),
    [anon_sym_break] = ACTIONS(2092),
    [anon_sym_continue] = ACTIONS(2095),
    [anon_sym_goto] = ACTIONS(2098),
    [anon_sym___try] = ACTIONS(2101),
    [anon_sym___leave] = ACTIONS(2104),
    [anon_sym_not] = ACTIONS(2039),
    [anon_sym_compl] = ACTIONS(2039),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2110),
    [anon_sym___alignof__] = ACTIONS(2113),
    [anon_sym___alignof] = ACTIONS(2113),
    [anon_sym__alignof] = ACTIONS(2113),
    [anon_sym_alignof] = ACTIONS(2113),
    [anon_sym__Alignof] = ACTIONS(2113),
    [anon_sym_offsetof] = ACTIONS(2116),
    [anon_sym__Generic] = ACTIONS(2119),
    [anon_sym_asm] = ACTIONS(2122),
    [anon_sym___asm__] = ACTIONS(2122),
    [anon_sym___asm] = ACTIONS(2122),
    [sym_number_literal] = ACTIONS(2125),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2131),
    [anon_sym_u_DQUOTE] = ACTIONS(2131),
    [anon_sym_U_DQUOTE] = ACTIONS(2131),
    [anon_sym_u8_DQUOTE] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [anon_sym_NULL] = ACTIONS(2137),
    [anon_sym_nullptr] = ACTIONS(2137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2140),
    [anon_sym_template] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2146),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_co_return] = ACTIONS(2155),
    [anon_sym_co_yield] = ACTIONS(2158),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2164),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2170),
    [sym_this] = ACTIONS(2134),
  },
  [142] = {
    [sym_compound_statement] = STATE(8409),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2919),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8409),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8413),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8414),
    [sym__unary_right_fold] = STATE(8418),
    [sym__binary_fold] = STATE(8419),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8421),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [143] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8606),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [144] = {
    [sym_compound_statement] = STATE(8409),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2919),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8409),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8763),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8414),
    [sym__unary_right_fold] = STATE(8418),
    [sym__binary_fold] = STATE(8419),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8421),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [145] = {
    [sym_attribute_declaration] = STATE(164),
    [sym_compound_statement] = STATE(401),
    [sym_attributed_statement] = STATE(401),
    [sym_statement] = STATE(343),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(164),
    [sym_identifier] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_using] = ACTIONS(2175),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [146] = {
    [sym_attribute_declaration] = STATE(146),
    [sym_compound_statement] = STATE(279),
    [sym_attributed_statement] = STATE(279),
    [sym_statement] = STATE(247),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(146),
    [sym_identifier] = ACTIONS(2177),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2036),
    [anon_sym_TILDE] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2180),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_using] = ACTIONS(2051),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [sym_primitive_type] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_case] = ACTIONS(2192),
    [anon_sym_default] = ACTIONS(2195),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2207),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_goto] = ACTIONS(2216),
    [anon_sym___try] = ACTIONS(2219),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2039),
    [anon_sym_compl] = ACTIONS(2039),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2110),
    [anon_sym___alignof__] = ACTIONS(2113),
    [anon_sym___alignof] = ACTIONS(2113),
    [anon_sym__alignof] = ACTIONS(2113),
    [anon_sym_alignof] = ACTIONS(2113),
    [anon_sym__Alignof] = ACTIONS(2113),
    [anon_sym_offsetof] = ACTIONS(2116),
    [anon_sym__Generic] = ACTIONS(2119),
    [anon_sym_asm] = ACTIONS(2122),
    [anon_sym___asm__] = ACTIONS(2122),
    [anon_sym___asm] = ACTIONS(2122),
    [sym_number_literal] = ACTIONS(2125),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2131),
    [anon_sym_u_DQUOTE] = ACTIONS(2131),
    [anon_sym_U_DQUOTE] = ACTIONS(2131),
    [anon_sym_u8_DQUOTE] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [anon_sym_NULL] = ACTIONS(2137),
    [anon_sym_nullptr] = ACTIONS(2137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2140),
    [anon_sym_template] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_co_return] = ACTIONS(2231),
    [anon_sym_co_yield] = ACTIONS(2234),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2164),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2170),
    [sym_this] = ACTIONS(2134),
  },
  [147] = {
    [sym_attribute_declaration] = STATE(146),
    [sym_compound_statement] = STATE(279),
    [sym_attributed_statement] = STATE(279),
    [sym_statement] = STATE(247),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(146),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [148] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8230),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [149] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8317),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [150] = {
    [sym_attribute_declaration] = STATE(150),
    [sym_compound_statement] = STATE(529),
    [sym_attributed_statement] = STATE(529),
    [sym_statement] = STATE(542),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(150),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2036),
    [anon_sym_TILDE] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_using] = ACTIONS(2051),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2247),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [sym_primitive_type] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2253),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2259),
    [anon_sym_while] = ACTIONS(2262),
    [anon_sym_do] = ACTIONS(2265),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2271),
    [anon_sym_break] = ACTIONS(2274),
    [anon_sym_continue] = ACTIONS(2277),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym___try] = ACTIONS(2283),
    [anon_sym___leave] = ACTIONS(2286),
    [anon_sym_not] = ACTIONS(2039),
    [anon_sym_compl] = ACTIONS(2039),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2110),
    [anon_sym___alignof__] = ACTIONS(2113),
    [anon_sym___alignof] = ACTIONS(2113),
    [anon_sym__alignof] = ACTIONS(2113),
    [anon_sym_alignof] = ACTIONS(2113),
    [anon_sym__Alignof] = ACTIONS(2113),
    [anon_sym_offsetof] = ACTIONS(2116),
    [anon_sym__Generic] = ACTIONS(2119),
    [anon_sym_asm] = ACTIONS(2122),
    [anon_sym___asm__] = ACTIONS(2122),
    [anon_sym___asm] = ACTIONS(2122),
    [sym_number_literal] = ACTIONS(2125),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2131),
    [anon_sym_u_DQUOTE] = ACTIONS(2131),
    [anon_sym_U_DQUOTE] = ACTIONS(2131),
    [anon_sym_u8_DQUOTE] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [anon_sym_NULL] = ACTIONS(2137),
    [anon_sym_nullptr] = ACTIONS(2137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2140),
    [anon_sym_template] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2289),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2295),
    [anon_sym_co_yield] = ACTIONS(2298),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2164),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2170),
    [sym_this] = ACTIONS(2134),
  },
  [151] = {
    [sym_attribute_declaration] = STATE(150),
    [sym_compound_statement] = STATE(529),
    [sym_attributed_statement] = STATE(529),
    [sym_statement] = STATE(542),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(150),
    [sym_identifier] = ACTIONS(2301),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_using] = ACTIONS(2303),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [152] = {
    [sym_compound_statement] = STATE(8215),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2942),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8215),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8390),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8396),
    [sym__unary_right_fold] = STATE(8410),
    [sym__binary_fold] = STATE(8415),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8243),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [153] = {
    [sym_compound_statement] = STATE(8215),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2942),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8215),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8575),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8396),
    [sym__unary_right_fold] = STATE(8410),
    [sym__binary_fold] = STATE(8415),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8243),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [154] = {
    [sym_compound_statement] = STATE(8409),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2919),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8409),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(7998),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8699),
    [sym__unary_right_fold] = STATE(8700),
    [sym__binary_fold] = STATE(8703),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8421),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [155] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8531),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [156] = {
    [sym_compound_statement] = STATE(8215),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2942),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8215),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(7988),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8605),
    [sym__unary_right_fold] = STATE(8610),
    [sym__binary_fold] = STATE(8628),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8243),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [157] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8221),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [158] = {
    [sym_expression] = STATE(2388),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_initializer_list] = STATE(2441),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(2307),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1942),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym___attribute] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [anon_sym_EQ] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_STAR_EQ] = ACTIONS(1944),
    [anon_sym_SLASH_EQ] = ACTIONS(1944),
    [anon_sym_PERCENT_EQ] = ACTIONS(1944),
    [anon_sym_PLUS_EQ] = ACTIONS(1944),
    [anon_sym_DASH_EQ] = ACTIONS(1944),
    [anon_sym_LT_LT_EQ] = ACTIONS(1944),
    [anon_sym_GT_GT_EQ] = ACTIONS(1944),
    [anon_sym_AMP_EQ] = ACTIONS(1944),
    [anon_sym_CARET_EQ] = ACTIONS(1944),
    [anon_sym_PIPE_EQ] = ACTIONS(1944),
    [anon_sym_and_eq] = ACTIONS(1942),
    [anon_sym_or_eq] = ACTIONS(1942),
    [anon_sym_xor_eq] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [159] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8550),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [160] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8727),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [161] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8434),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [162] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8376),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [163] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8686),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [164] = {
    [sym_attribute_declaration] = STATE(164),
    [sym_compound_statement] = STATE(401),
    [sym_attributed_statement] = STATE(401),
    [sym_statement] = STATE(343),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(164),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2036),
    [anon_sym_TILDE] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2332),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_using] = ACTIONS(2051),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [sym_primitive_type] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_switch] = ACTIONS(2341),
    [anon_sym_case] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2347),
    [anon_sym_while] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2353),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2359),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2365),
    [anon_sym_goto] = ACTIONS(2368),
    [anon_sym___try] = ACTIONS(2371),
    [anon_sym___leave] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2039),
    [anon_sym_compl] = ACTIONS(2039),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2110),
    [anon_sym___alignof__] = ACTIONS(2113),
    [anon_sym___alignof] = ACTIONS(2113),
    [anon_sym__alignof] = ACTIONS(2113),
    [anon_sym_alignof] = ACTIONS(2113),
    [anon_sym__Alignof] = ACTIONS(2113),
    [anon_sym_offsetof] = ACTIONS(2116),
    [anon_sym__Generic] = ACTIONS(2119),
    [anon_sym_asm] = ACTIONS(2122),
    [anon_sym___asm__] = ACTIONS(2122),
    [anon_sym___asm] = ACTIONS(2122),
    [sym_number_literal] = ACTIONS(2125),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2131),
    [anon_sym_u_DQUOTE] = ACTIONS(2131),
    [anon_sym_U_DQUOTE] = ACTIONS(2131),
    [anon_sym_u8_DQUOTE] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [anon_sym_NULL] = ACTIONS(2137),
    [anon_sym_nullptr] = ACTIONS(2137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2140),
    [anon_sym_template] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2377),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2380),
    [anon_sym_co_return] = ACTIONS(2383),
    [anon_sym_co_yield] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2164),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2170),
    [sym_this] = ACTIONS(2134),
  },
  [165] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8620),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [166] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8224),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [167] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8319),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [168] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8212),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [169] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8515),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [170] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8357),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [171] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8697),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [172] = {
    [sym_compound_statement] = STATE(8449),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2912),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8484),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [173] = {
    [sym_compound_statement] = STATE(8215),
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(2942),
    [sym__string] = STATE(3235),
    [sym_comma_expression] = STATE(8215),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_type_descriptor] = STATE(8588),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7814),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym__unary_left_fold] = STATE(8605),
    [sym__unary_right_fold] = STATE(8610),
    [sym__binary_fold] = STATE(8628),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5702),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym__assignment_expression_lhs] = STATE(8243),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1814),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [174] = {
    [sym_attribute_declaration] = STATE(203),
    [sym_compound_statement] = STATE(279),
    [sym_attributed_statement] = STATE(279),
    [sym_statement] = STATE(273),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [175] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(8448),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [176] = {
    [sym_attribute_declaration] = STATE(218),
    [sym_compound_statement] = STATE(529),
    [sym_attributed_statement] = STATE(529),
    [sym_statement] = STATE(456),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(2301),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [177] = {
    [sym_attribute_declaration] = STATE(218),
    [sym_compound_statement] = STATE(529),
    [sym_attributed_statement] = STATE(529),
    [sym_statement] = STATE(569),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(2301),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [178] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(460),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2022),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [179] = {
    [sym_attribute_declaration] = STATE(193),
    [sym_compound_statement] = STATE(904),
    [sym_attributed_statement] = STATE(904),
    [sym_statement] = STATE(907),
    [sym_labeled_statement] = STATE(904),
    [sym_expression_statement] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_switch_statement] = STATE(904),
    [sym_case_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_do_statement] = STATE(904),
    [sym_for_statement] = STATE(904),
    [sym_return_statement] = STATE(904),
    [sym_break_statement] = STATE(904),
    [sym_continue_statement] = STATE(904),
    [sym_goto_statement] = STATE(904),
    [sym_seh_try_statement] = STATE(904),
    [sym_seh_leave_statement] = STATE(904),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(904),
    [sym_co_return_statement] = STATE(904),
    [sym_co_yield_statement] = STATE(904),
    [sym_throw_statement] = STATE(904),
    [sym_try_statement] = STATE(904),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(193),
    [sym_identifier] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [180] = {
    [sym_attribute_declaration] = STATE(203),
    [sym_compound_statement] = STATE(279),
    [sym_attributed_statement] = STATE(279),
    [sym_statement] = STATE(240),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [181] = {
    [sym_attribute_declaration] = STATE(218),
    [sym_compound_statement] = STATE(529),
    [sym_attributed_statement] = STATE(529),
    [sym_statement] = STATE(461),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(2301),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [182] = {
    [sym_attribute_declaration] = STATE(218),
    [sym_compound_statement] = STATE(529),
    [sym_attributed_statement] = STATE(529),
    [sym_statement] = STATE(633),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(2301),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [183] = {
    [sym_attribute_declaration] = STATE(218),
    [sym_compound_statement] = STATE(529),
    [sym_attributed_statement] = STATE(529),
    [sym_statement] = STATE(639),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(2301),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [184] = {
    [sym_attribute_declaration] = STATE(218),
    [sym_compound_statement] = STATE(529),
    [sym_attributed_statement] = STATE(529),
    [sym_statement] = STATE(640),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(2301),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [185] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(8567),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [186] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(401),
    [sym_attributed_statement] = STATE(401),
    [sym_statement] = STATE(251),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [187] = {
    [sym_attribute_declaration] = STATE(164),
    [sym_compound_statement] = STATE(401),
    [sym_attributed_statement] = STATE(401),
    [sym_statement] = STATE(343),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(164),
    [sym_identifier] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [188] = {
    [sym_attribute_declaration] = STATE(179),
    [sym_compound_statement] = STATE(904),
    [sym_attributed_statement] = STATE(904),
    [sym_statement] = STATE(884),
    [sym_labeled_statement] = STATE(904),
    [sym_expression_statement] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_switch_statement] = STATE(904),
    [sym_case_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_do_statement] = STATE(904),
    [sym_for_statement] = STATE(904),
    [sym_return_statement] = STATE(904),
    [sym_break_statement] = STATE(904),
    [sym_continue_statement] = STATE(904),
    [sym_goto_statement] = STATE(904),
    [sym_seh_try_statement] = STATE(904),
    [sym_seh_leave_statement] = STATE(904),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(904),
    [sym_co_return_statement] = STATE(904),
    [sym_co_yield_statement] = STATE(904),
    [sym_throw_statement] = STATE(904),
    [sym_try_statement] = STATE(904),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [sym_identifier] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [189] = {
    [sym_attribute_declaration] = STATE(179),
    [sym_compound_statement] = STATE(904),
    [sym_attributed_statement] = STATE(904),
    [sym_statement] = STATE(894),
    [sym_labeled_statement] = STATE(904),
    [sym_expression_statement] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_switch_statement] = STATE(904),
    [sym_case_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_do_statement] = STATE(904),
    [sym_for_statement] = STATE(904),
    [sym_return_statement] = STATE(904),
    [sym_break_statement] = STATE(904),
    [sym_continue_statement] = STATE(904),
    [sym_goto_statement] = STATE(904),
    [sym_seh_try_statement] = STATE(904),
    [sym_seh_leave_statement] = STATE(904),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(904),
    [sym_co_return_statement] = STATE(904),
    [sym_co_yield_statement] = STATE(904),
    [sym_throw_statement] = STATE(904),
    [sym_try_statement] = STATE(904),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [sym_identifier] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [190] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(615),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2022),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [191] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(401),
    [sym_attributed_statement] = STATE(401),
    [sym_statement] = STATE(383),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [192] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(401),
    [sym_attributed_statement] = STATE(401),
    [sym_statement] = STATE(384),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [193] = {
    [sym_attribute_declaration] = STATE(193),
    [sym_compound_statement] = STATE(904),
    [sym_attributed_statement] = STATE(904),
    [sym_statement] = STATE(907),
    [sym_labeled_statement] = STATE(904),
    [sym_expression_statement] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_switch_statement] = STATE(904),
    [sym_case_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_do_statement] = STATE(904),
    [sym_for_statement] = STATE(904),
    [sym_return_statement] = STATE(904),
    [sym_break_statement] = STATE(904),
    [sym_continue_statement] = STATE(904),
    [sym_goto_statement] = STATE(904),
    [sym_seh_try_statement] = STATE(904),
    [sym_seh_leave_statement] = STATE(904),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(904),
    [sym_co_return_statement] = STATE(904),
    [sym_co_yield_statement] = STATE(904),
    [sym_throw_statement] = STATE(904),
    [sym_try_statement] = STATE(904),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(193),
    [sym_identifier] = ACTIONS(2393),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2036),
    [anon_sym_TILDE] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [sym_primitive_type] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(2402),
    [anon_sym_switch] = ACTIONS(2405),
    [anon_sym_case] = ACTIONS(2408),
    [anon_sym_default] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2417),
    [anon_sym_for] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2423),
    [anon_sym_break] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_goto] = ACTIONS(2432),
    [anon_sym___try] = ACTIONS(2435),
    [anon_sym___leave] = ACTIONS(2438),
    [anon_sym_not] = ACTIONS(2039),
    [anon_sym_compl] = ACTIONS(2039),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2110),
    [anon_sym___alignof__] = ACTIONS(2113),
    [anon_sym___alignof] = ACTIONS(2113),
    [anon_sym__alignof] = ACTIONS(2113),
    [anon_sym_alignof] = ACTIONS(2113),
    [anon_sym__Alignof] = ACTIONS(2113),
    [anon_sym_offsetof] = ACTIONS(2116),
    [anon_sym__Generic] = ACTIONS(2119),
    [anon_sym_asm] = ACTIONS(2122),
    [anon_sym___asm__] = ACTIONS(2122),
    [anon_sym___asm] = ACTIONS(2122),
    [sym_number_literal] = ACTIONS(2125),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2131),
    [anon_sym_u_DQUOTE] = ACTIONS(2131),
    [anon_sym_U_DQUOTE] = ACTIONS(2131),
    [anon_sym_u8_DQUOTE] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [anon_sym_NULL] = ACTIONS(2137),
    [anon_sym_nullptr] = ACTIONS(2137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2140),
    [anon_sym_template] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2441),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2444),
    [anon_sym_co_return] = ACTIONS(2447),
    [anon_sym_co_yield] = ACTIONS(2450),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2164),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2170),
    [sym_this] = ACTIONS(2134),
  },
  [194] = {
    [sym_attribute_declaration] = STATE(179),
    [sym_compound_statement] = STATE(904),
    [sym_attributed_statement] = STATE(904),
    [sym_statement] = STATE(883),
    [sym_labeled_statement] = STATE(904),
    [sym_expression_statement] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_switch_statement] = STATE(904),
    [sym_case_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_do_statement] = STATE(904),
    [sym_for_statement] = STATE(904),
    [sym_return_statement] = STATE(904),
    [sym_break_statement] = STATE(904),
    [sym_continue_statement] = STATE(904),
    [sym_goto_statement] = STATE(904),
    [sym_seh_try_statement] = STATE(904),
    [sym_seh_leave_statement] = STATE(904),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(904),
    [sym_co_return_statement] = STATE(904),
    [sym_co_yield_statement] = STATE(904),
    [sym_throw_statement] = STATE(904),
    [sym_try_statement] = STATE(904),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [sym_identifier] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [195] = {
    [sym_attribute_declaration] = STATE(179),
    [sym_compound_statement] = STATE(904),
    [sym_attributed_statement] = STATE(904),
    [sym_statement] = STATE(912),
    [sym_labeled_statement] = STATE(904),
    [sym_expression_statement] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_switch_statement] = STATE(904),
    [sym_case_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_do_statement] = STATE(904),
    [sym_for_statement] = STATE(904),
    [sym_return_statement] = STATE(904),
    [sym_break_statement] = STATE(904),
    [sym_continue_statement] = STATE(904),
    [sym_goto_statement] = STATE(904),
    [sym_seh_try_statement] = STATE(904),
    [sym_seh_leave_statement] = STATE(904),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(904),
    [sym_co_return_statement] = STATE(904),
    [sym_co_yield_statement] = STATE(904),
    [sym_throw_statement] = STATE(904),
    [sym_try_statement] = STATE(904),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [sym_identifier] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [196] = {
    [sym_attribute_declaration] = STATE(179),
    [sym_compound_statement] = STATE(904),
    [sym_attributed_statement] = STATE(904),
    [sym_statement] = STATE(908),
    [sym_labeled_statement] = STATE(904),
    [sym_expression_statement] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_switch_statement] = STATE(904),
    [sym_case_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_do_statement] = STATE(904),
    [sym_for_statement] = STATE(904),
    [sym_return_statement] = STATE(904),
    [sym_break_statement] = STATE(904),
    [sym_continue_statement] = STATE(904),
    [sym_goto_statement] = STATE(904),
    [sym_seh_try_statement] = STATE(904),
    [sym_seh_leave_statement] = STATE(904),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(904),
    [sym_co_return_statement] = STATE(904),
    [sym_co_yield_statement] = STATE(904),
    [sym_throw_statement] = STATE(904),
    [sym_try_statement] = STATE(904),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [sym_identifier] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [197] = {
    [sym_attribute_declaration] = STATE(179),
    [sym_compound_statement] = STATE(904),
    [sym_attributed_statement] = STATE(904),
    [sym_statement] = STATE(891),
    [sym_labeled_statement] = STATE(904),
    [sym_expression_statement] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_switch_statement] = STATE(904),
    [sym_case_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_do_statement] = STATE(904),
    [sym_for_statement] = STATE(904),
    [sym_return_statement] = STATE(904),
    [sym_break_statement] = STATE(904),
    [sym_continue_statement] = STATE(904),
    [sym_goto_statement] = STATE(904),
    [sym_seh_try_statement] = STATE(904),
    [sym_seh_leave_statement] = STATE(904),
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8696),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(904),
    [sym_co_return_statement] = STATE(904),
    [sym_co_yield_statement] = STATE(904),
    [sym_throw_statement] = STATE(904),
    [sym_try_statement] = STATE(904),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(179),
    [sym_identifier] = ACTIONS(2391),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1670),
    [anon_sym_switch] = ACTIONS(1672),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_goto] = ACTIONS(1686),
    [anon_sym___try] = ACTIONS(1688),
    [anon_sym___leave] = ACTIONS(1690),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1694),
    [anon_sym_co_return] = ACTIONS(1696),
    [anon_sym_co_yield] = ACTIONS(1698),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [198] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(401),
    [sym_attributed_statement] = STATE(401),
    [sym_statement] = STATE(381),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [199] = {
    [sym_attribute_declaration] = STATE(203),
    [sym_compound_statement] = STATE(279),
    [sym_attributed_statement] = STATE(279),
    [sym_statement] = STATE(237),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [200] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(401),
    [sym_attributed_statement] = STATE(401),
    [sym_statement] = STATE(260),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [201] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(627),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2022),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [202] = {
    [sym_attribute_declaration] = STATE(203),
    [sym_compound_statement] = STATE(279),
    [sym_attributed_statement] = STATE(279),
    [sym_statement] = STATE(253),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [203] = {
    [sym_attribute_declaration] = STATE(146),
    [sym_compound_statement] = STATE(279),
    [sym_attributed_statement] = STATE(279),
    [sym_statement] = STATE(247),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(146),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [204] = {
    [sym_attribute_declaration] = STATE(203),
    [sym_compound_statement] = STATE(279),
    [sym_attributed_statement] = STATE(279),
    [sym_statement] = STATE(243),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [205] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(401),
    [sym_attributed_statement] = STATE(401),
    [sym_statement] = STATE(415),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_switch_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_do_statement] = STATE(401),
    [sym_for_statement] = STATE(401),
    [sym_return_statement] = STATE(401),
    [sym_break_statement] = STATE(401),
    [sym_continue_statement] = STATE(401),
    [sym_goto_statement] = STATE(401),
    [sym_seh_try_statement] = STATE(401),
    [sym_seh_leave_statement] = STATE(401),
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8450),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(401),
    [sym_co_return_statement] = STATE(401),
    [sym_co_yield_statement] = STATE(401),
    [sym_throw_statement] = STATE(401),
    [sym_try_statement] = STATE(401),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2173),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1198),
    [anon_sym___leave] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [206] = {
    [sym_attribute_declaration] = STATE(203),
    [sym_compound_statement] = STATE(279),
    [sym_attributed_statement] = STATE(279),
    [sym_statement] = STATE(244),
    [sym_labeled_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_case_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(279),
    [sym_seh_try_statement] = STATE(279),
    [sym_seh_leave_statement] = STATE(279),
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8429),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(279),
    [sym_co_return_statement] = STATE(279),
    [sym_co_yield_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(203),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(303),
    [anon_sym_case] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(313),
    [anon_sym_return] = ACTIONS(315),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(319),
    [anon_sym_goto] = ACTIONS(321),
    [anon_sym___try] = ACTIONS(323),
    [anon_sym___leave] = ACTIONS(325),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(339),
    [anon_sym_co_yield] = ACTIONS(341),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [207] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(7556),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [208] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(415),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [209] = {
    [sym_expression] = STATE(3171),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_initializer_list] = STATE(3451),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_RPAREN] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1798),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1942),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [anon_sym_EQ] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_STAR_EQ] = ACTIONS(1944),
    [anon_sym_SLASH_EQ] = ACTIONS(1944),
    [anon_sym_PERCENT_EQ] = ACTIONS(1944),
    [anon_sym_PLUS_EQ] = ACTIONS(1944),
    [anon_sym_DASH_EQ] = ACTIONS(1944),
    [anon_sym_LT_LT_EQ] = ACTIONS(1944),
    [anon_sym_GT_GT_EQ] = ACTIONS(1944),
    [anon_sym_AMP_EQ] = ACTIONS(1944),
    [anon_sym_CARET_EQ] = ACTIONS(1944),
    [anon_sym_PIPE_EQ] = ACTIONS(1944),
    [anon_sym_and_eq] = ACTIONS(1942),
    [anon_sym_or_eq] = ACTIONS(1942),
    [anon_sym_xor_eq] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1944),
    [sym_this] = ACTIONS(1842),
  },
  [210] = {
    [sym_attribute_declaration] = STATE(210),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(343),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(210),
    [sym_identifier] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2036),
    [anon_sym_TILDE] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [sym_primitive_type] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_switch] = ACTIONS(2341),
    [anon_sym_case] = ACTIONS(2408),
    [anon_sym_default] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2467),
    [anon_sym_do] = ACTIONS(2353),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2359),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2365),
    [anon_sym_goto] = ACTIONS(2368),
    [anon_sym___try] = ACTIONS(2473),
    [anon_sym___leave] = ACTIONS(2104),
    [anon_sym_not] = ACTIONS(2039),
    [anon_sym_compl] = ACTIONS(2039),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_sizeof] = ACTIONS(2110),
    [anon_sym___alignof__] = ACTIONS(2113),
    [anon_sym___alignof] = ACTIONS(2113),
    [anon_sym__alignof] = ACTIONS(2113),
    [anon_sym_alignof] = ACTIONS(2113),
    [anon_sym__Alignof] = ACTIONS(2113),
    [anon_sym_offsetof] = ACTIONS(2116),
    [anon_sym__Generic] = ACTIONS(2119),
    [anon_sym_asm] = ACTIONS(2122),
    [anon_sym___asm__] = ACTIONS(2122),
    [anon_sym___asm] = ACTIONS(2122),
    [sym_number_literal] = ACTIONS(2125),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2131),
    [anon_sym_u_DQUOTE] = ACTIONS(2131),
    [anon_sym_U_DQUOTE] = ACTIONS(2131),
    [anon_sym_u8_DQUOTE] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [anon_sym_NULL] = ACTIONS(2137),
    [anon_sym_nullptr] = ACTIONS(2137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2140),
    [anon_sym_template] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2377),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2380),
    [anon_sym_co_return] = ACTIONS(2383),
    [anon_sym_co_yield] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2164),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2170),
    [sym_this] = ACTIONS(2134),
  },
  [211] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(7335),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [212] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(381),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [213] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(383),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [214] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(384),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [215] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(458),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2022),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [216] = {
    [sym_attribute_declaration] = STATE(210),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(343),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(210),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [217] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(8331),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [218] = {
    [sym_attribute_declaration] = STATE(150),
    [sym_compound_statement] = STATE(529),
    [sym_attributed_statement] = STATE(529),
    [sym_statement] = STATE(542),
    [sym_labeled_statement] = STATE(529),
    [sym_expression_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_switch_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_do_statement] = STATE(529),
    [sym_for_statement] = STATE(529),
    [sym_return_statement] = STATE(529),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(529),
    [sym_goto_statement] = STATE(529),
    [sym_seh_try_statement] = STATE(529),
    [sym_seh_leave_statement] = STATE(529),
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8311),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(529),
    [sym_co_return_statement] = STATE(529),
    [sym_co_yield_statement] = STATE(529),
    [sym_throw_statement] = STATE(529),
    [sym_try_statement] = STATE(529),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(150),
    [sym_identifier] = ACTIONS(2301),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym___try] = ACTIONS(920),
    [anon_sym___leave] = ACTIONS(922),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_co_return] = ACTIONS(936),
    [anon_sym_co_yield] = ACTIONS(938),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [219] = {
    [sym_attribute_declaration] = STATE(141),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(554),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(2022),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [220] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(474),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2022),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [221] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(8519),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [222] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(8546),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1762),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1772),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [223] = {
    [sym_attribute_declaration] = STATE(219),
    [sym_compound_statement] = STATE(545),
    [sym_attributed_statement] = STATE(545),
    [sym_statement] = STATE(626),
    [sym_labeled_statement] = STATE(545),
    [sym_expression_statement] = STATE(545),
    [sym_if_statement] = STATE(545),
    [sym_switch_statement] = STATE(545),
    [sym_case_statement] = STATE(545),
    [sym_while_statement] = STATE(545),
    [sym_do_statement] = STATE(545),
    [sym_for_statement] = STATE(545),
    [sym_return_statement] = STATE(545),
    [sym_break_statement] = STATE(545),
    [sym_continue_statement] = STATE(545),
    [sym_goto_statement] = STATE(545),
    [sym_seh_try_statement] = STATE(545),
    [sym_seh_leave_statement] = STATE(545),
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8711),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_for_range_loop] = STATE(545),
    [sym_co_return_statement] = STATE(545),
    [sym_co_yield_statement] = STATE(545),
    [sym_throw_statement] = STATE(545),
    [sym_try_statement] = STATE(545),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_attributed_declarator_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(2022),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(181),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(199),
    [anon_sym_switch] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(207),
    [anon_sym_do] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_return] = ACTIONS(213),
    [anon_sym_break] = ACTIONS(215),
    [anon_sym_continue] = ACTIONS(217),
    [anon_sym_goto] = ACTIONS(219),
    [anon_sym___try] = ACTIONS(221),
    [anon_sym___leave] = ACTIONS(223),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(233),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(243),
    [anon_sym_co_yield] = ACTIONS(245),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [224] = {
    [sym_catch_clause] = STATE(224),
    [aux_sym_constructor_try_statement_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(2476),
    [aux_sym_preproc_include_token1] = ACTIONS(2476),
    [aux_sym_preproc_def_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token2] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2476),
    [aux_sym_preproc_else_token1] = ACTIONS(2476),
    [aux_sym_preproc_elif_token1] = ACTIONS(2476),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2476),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2476),
    [sym_preproc_directive] = ACTIONS(2476),
    [anon_sym_LPAREN2] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym___extension__] = ACTIONS(2476),
    [anon_sym_typedef] = ACTIONS(2476),
    [anon_sym_virtual] = ACTIONS(2476),
    [anon_sym_extern] = ACTIONS(2476),
    [anon_sym___attribute__] = ACTIONS(2476),
    [anon_sym___attribute] = ACTIONS(2476),
    [anon_sym_using] = ACTIONS(2476),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2478),
    [anon_sym___declspec] = ACTIONS(2476),
    [anon_sym___based] = ACTIONS(2476),
    [anon_sym___cdecl] = ACTIONS(2476),
    [anon_sym___clrcall] = ACTIONS(2476),
    [anon_sym___stdcall] = ACTIONS(2476),
    [anon_sym___fastcall] = ACTIONS(2476),
    [anon_sym___thiscall] = ACTIONS(2476),
    [anon_sym___vectorcall] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_signed] = ACTIONS(2476),
    [anon_sym_unsigned] = ACTIONS(2476),
    [anon_sym_long] = ACTIONS(2476),
    [anon_sym_short] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_register] = ACTIONS(2476),
    [anon_sym_inline] = ACTIONS(2476),
    [anon_sym___inline] = ACTIONS(2476),
    [anon_sym___inline__] = ACTIONS(2476),
    [anon_sym___forceinline] = ACTIONS(2476),
    [anon_sym_thread_local] = ACTIONS(2476),
    [anon_sym___thread] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_constexpr] = ACTIONS(2476),
    [anon_sym_volatile] = ACTIONS(2476),
    [anon_sym_restrict] = ACTIONS(2476),
    [anon_sym___restrict__] = ACTIONS(2476),
    [anon_sym__Atomic] = ACTIONS(2476),
    [anon_sym__Noreturn] = ACTIONS(2476),
    [anon_sym_noreturn] = ACTIONS(2476),
    [anon_sym__Nonnull] = ACTIONS(2476),
    [anon_sym_mutable] = ACTIONS(2476),
    [anon_sym_constinit] = ACTIONS(2476),
    [anon_sym_consteval] = ACTIONS(2476),
    [anon_sym_alignas] = ACTIONS(2476),
    [anon_sym__Alignas] = ACTIONS(2476),
    [sym_primitive_type] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [anon_sym_class] = ACTIONS(2476),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2476),
    [anon_sym_if] = ACTIONS(2476),
    [anon_sym_else] = ACTIONS(2476),
    [anon_sym_switch] = ACTIONS(2476),
    [anon_sym_case] = ACTIONS(2476),
    [anon_sym_default] = ACTIONS(2476),
    [anon_sym_while] = ACTIONS(2476),
    [anon_sym_do] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2476),
    [anon_sym_break] = ACTIONS(2476),
    [anon_sym_continue] = ACTIONS(2476),
    [anon_sym_goto] = ACTIONS(2476),
    [anon_sym___try] = ACTIONS(2476),
    [anon_sym___leave] = ACTIONS(2476),
    [anon_sym_not] = ACTIONS(2476),
    [anon_sym_compl] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2476),
    [anon_sym___alignof__] = ACTIONS(2476),
    [anon_sym___alignof] = ACTIONS(2476),
    [anon_sym__alignof] = ACTIONS(2476),
    [anon_sym_alignof] = ACTIONS(2476),
    [anon_sym__Alignof] = ACTIONS(2476),
    [anon_sym_offsetof] = ACTIONS(2476),
    [anon_sym__Generic] = ACTIONS(2476),
    [anon_sym_asm] = ACTIONS(2476),
    [anon_sym___asm__] = ACTIONS(2476),
    [anon_sym___asm] = ACTIONS(2476),
    [sym_number_literal] = ACTIONS(2478),
    [anon_sym_L_SQUOTE] = ACTIONS(2478),
    [anon_sym_u_SQUOTE] = ACTIONS(2478),
    [anon_sym_U_SQUOTE] = ACTIONS(2478),
    [anon_sym_u8_SQUOTE] = ACTIONS(2478),
    [anon_sym_SQUOTE] = ACTIONS(2478),
    [anon_sym_L_DQUOTE] = ACTIONS(2478),
    [anon_sym_u_DQUOTE] = ACTIONS(2478),
    [anon_sym_U_DQUOTE] = ACTIONS(2478),
    [anon_sym_u8_DQUOTE] = ACTIONS(2478),
    [anon_sym_DQUOTE] = ACTIONS(2478),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2476),
    [anon_sym_nullptr] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2476),
    [anon_sym_decltype] = ACTIONS(2476),
    [anon_sym_explicit] = ACTIONS(2476),
    [anon_sym_typename] = ACTIONS(2476),
    [anon_sym_template] = ACTIONS(2476),
    [anon_sym_operator] = ACTIONS(2476),
    [anon_sym_try] = ACTIONS(2476),
    [anon_sym_delete] = ACTIONS(2476),
    [anon_sym_throw] = ACTIONS(2476),
    [anon_sym_namespace] = ACTIONS(2476),
    [anon_sym_static_assert] = ACTIONS(2476),
    [anon_sym_concept] = ACTIONS(2476),
    [anon_sym_co_return] = ACTIONS(2476),
    [anon_sym_co_yield] = ACTIONS(2476),
    [anon_sym_catch] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2478),
    [anon_sym_LR_DQUOTE] = ACTIONS(2478),
    [anon_sym_uR_DQUOTE] = ACTIONS(2478),
    [anon_sym_UR_DQUOTE] = ACTIONS(2478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2478),
    [anon_sym_co_await] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2476),
    [anon_sym_requires] = ACTIONS(2476),
    [sym_this] = ACTIONS(2476),
  },
  [225] = {
    [sym_catch_clause] = STATE(224),
    [aux_sym_constructor_try_statement_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_include_token1] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token2] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [aux_sym_preproc_else_token1] = ACTIONS(2483),
    [aux_sym_preproc_elif_token1] = ACTIONS(2483),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_virtual] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym___attribute] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym___cdecl] = ACTIONS(2483),
    [anon_sym___clrcall] = ACTIONS(2483),
    [anon_sym___stdcall] = ACTIONS(2483),
    [anon_sym___fastcall] = ACTIONS(2483),
    [anon_sym___thiscall] = ACTIONS(2483),
    [anon_sym___vectorcall] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym__Nonnull] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_case] = ACTIONS(2483),
    [anon_sym_default] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_goto] = ACTIONS(2483),
    [anon_sym___try] = ACTIONS(2483),
    [anon_sym___leave] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2483),
    [anon_sym_compl] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_sizeof] = ACTIONS(2483),
    [anon_sym___alignof__] = ACTIONS(2483),
    [anon_sym___alignof] = ACTIONS(2483),
    [anon_sym__alignof] = ACTIONS(2483),
    [anon_sym_alignof] = ACTIONS(2483),
    [anon_sym__Alignof] = ACTIONS(2483),
    [anon_sym_offsetof] = ACTIONS(2483),
    [anon_sym__Generic] = ACTIONS(2483),
    [anon_sym_asm] = ACTIONS(2483),
    [anon_sym___asm__] = ACTIONS(2483),
    [anon_sym___asm] = ACTIONS(2483),
    [sym_number_literal] = ACTIONS(2485),
    [anon_sym_L_SQUOTE] = ACTIONS(2485),
    [anon_sym_u_SQUOTE] = ACTIONS(2485),
    [anon_sym_U_SQUOTE] = ACTIONS(2485),
    [anon_sym_u8_SQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [anon_sym_L_DQUOTE] = ACTIONS(2485),
    [anon_sym_u_DQUOTE] = ACTIONS(2485),
    [anon_sym_U_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8_DQUOTE] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [anon_sym_NULL] = ACTIONS(2483),
    [anon_sym_nullptr] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_namespace] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_concept] = ACTIONS(2483),
    [anon_sym_co_return] = ACTIONS(2483),
    [anon_sym_co_yield] = ACTIONS(2483),
    [anon_sym_catch] = ACTIONS(2487),
    [anon_sym_R_DQUOTE] = ACTIONS(2485),
    [anon_sym_LR_DQUOTE] = ACTIONS(2485),
    [anon_sym_uR_DQUOTE] = ACTIONS(2485),
    [anon_sym_UR_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2485),
    [anon_sym_co_await] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_requires] = ACTIONS(2483),
    [sym_this] = ACTIONS(2483),
  },
  [226] = {
    [sym_expression] = STATE(3339),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_initializer_list] = STATE(3605),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(2491),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1942),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1942),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(2499),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [anon_sym_EQ] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_STAR_EQ] = ACTIONS(1944),
    [anon_sym_SLASH_EQ] = ACTIONS(1944),
    [anon_sym_PERCENT_EQ] = ACTIONS(1944),
    [anon_sym_PLUS_EQ] = ACTIONS(1944),
    [anon_sym_DASH_EQ] = ACTIONS(1944),
    [anon_sym_LT_LT_EQ] = ACTIONS(1944),
    [anon_sym_GT_GT_EQ] = ACTIONS(1942),
    [anon_sym_AMP_EQ] = ACTIONS(1944),
    [anon_sym_CARET_EQ] = ACTIONS(1944),
    [anon_sym_PIPE_EQ] = ACTIONS(1944),
    [anon_sym_and_eq] = ACTIONS(1942),
    [anon_sym_or_eq] = ACTIONS(1942),
    [anon_sym_xor_eq] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [227] = {
    [sym_expression] = STATE(3323),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_initializer_list] = STATE(2441),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(2533),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1942),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [anon_sym_EQ] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_STAR_EQ] = ACTIONS(1944),
    [anon_sym_SLASH_EQ] = ACTIONS(1944),
    [anon_sym_PERCENT_EQ] = ACTIONS(1944),
    [anon_sym_PLUS_EQ] = ACTIONS(1944),
    [anon_sym_DASH_EQ] = ACTIONS(1944),
    [anon_sym_LT_LT_EQ] = ACTIONS(1944),
    [anon_sym_GT_GT_EQ] = ACTIONS(1944),
    [anon_sym_AMP_EQ] = ACTIONS(1944),
    [anon_sym_CARET_EQ] = ACTIONS(1944),
    [anon_sym_PIPE_EQ] = ACTIONS(1944),
    [anon_sym_and_eq] = ACTIONS(1942),
    [anon_sym_or_eq] = ACTIONS(1942),
    [anon_sym_xor_eq] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [228] = {
    [sym_catch_clause] = STATE(224),
    [aux_sym_constructor_try_statement_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(2547),
    [aux_sym_preproc_include_token1] = ACTIONS(2547),
    [aux_sym_preproc_def_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token2] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2547),
    [aux_sym_preproc_else_token1] = ACTIONS(2547),
    [aux_sym_preproc_elif_token1] = ACTIONS(2547),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2547),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2547),
    [sym_preproc_directive] = ACTIONS(2547),
    [anon_sym_LPAREN2] = ACTIONS(2549),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_TILDE] = ACTIONS(2549),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_PLUS] = ACTIONS(2547),
    [anon_sym_STAR] = ACTIONS(2549),
    [anon_sym_AMP_AMP] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(2549),
    [anon_sym___extension__] = ACTIONS(2547),
    [anon_sym_typedef] = ACTIONS(2547),
    [anon_sym_virtual] = ACTIONS(2547),
    [anon_sym_extern] = ACTIONS(2547),
    [anon_sym___attribute__] = ACTIONS(2547),
    [anon_sym___attribute] = ACTIONS(2547),
    [anon_sym_using] = ACTIONS(2547),
    [anon_sym_COLON_COLON] = ACTIONS(2549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2549),
    [anon_sym___declspec] = ACTIONS(2547),
    [anon_sym___based] = ACTIONS(2547),
    [anon_sym___cdecl] = ACTIONS(2547),
    [anon_sym___clrcall] = ACTIONS(2547),
    [anon_sym___stdcall] = ACTIONS(2547),
    [anon_sym___fastcall] = ACTIONS(2547),
    [anon_sym___thiscall] = ACTIONS(2547),
    [anon_sym___vectorcall] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [anon_sym_signed] = ACTIONS(2547),
    [anon_sym_unsigned] = ACTIONS(2547),
    [anon_sym_long] = ACTIONS(2547),
    [anon_sym_short] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_register] = ACTIONS(2547),
    [anon_sym_inline] = ACTIONS(2547),
    [anon_sym___inline] = ACTIONS(2547),
    [anon_sym___inline__] = ACTIONS(2547),
    [anon_sym___forceinline] = ACTIONS(2547),
    [anon_sym_thread_local] = ACTIONS(2547),
    [anon_sym___thread] = ACTIONS(2547),
    [anon_sym_const] = ACTIONS(2547),
    [anon_sym_constexpr] = ACTIONS(2547),
    [anon_sym_volatile] = ACTIONS(2547),
    [anon_sym_restrict] = ACTIONS(2547),
    [anon_sym___restrict__] = ACTIONS(2547),
    [anon_sym__Atomic] = ACTIONS(2547),
    [anon_sym__Noreturn] = ACTIONS(2547),
    [anon_sym_noreturn] = ACTIONS(2547),
    [anon_sym__Nonnull] = ACTIONS(2547),
    [anon_sym_mutable] = ACTIONS(2547),
    [anon_sym_constinit] = ACTIONS(2547),
    [anon_sym_consteval] = ACTIONS(2547),
    [anon_sym_alignas] = ACTIONS(2547),
    [anon_sym__Alignas] = ACTIONS(2547),
    [sym_primitive_type] = ACTIONS(2547),
    [anon_sym_enum] = ACTIONS(2547),
    [anon_sym_class] = ACTIONS(2547),
    [anon_sym_struct] = ACTIONS(2547),
    [anon_sym_union] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(2547),
    [anon_sym_switch] = ACTIONS(2547),
    [anon_sym_case] = ACTIONS(2547),
    [anon_sym_default] = ACTIONS(2547),
    [anon_sym_while] = ACTIONS(2547),
    [anon_sym_do] = ACTIONS(2547),
    [anon_sym_for] = ACTIONS(2547),
    [anon_sym_return] = ACTIONS(2547),
    [anon_sym_break] = ACTIONS(2547),
    [anon_sym_continue] = ACTIONS(2547),
    [anon_sym_goto] = ACTIONS(2547),
    [anon_sym___try] = ACTIONS(2547),
    [anon_sym___leave] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2547),
    [anon_sym_compl] = ACTIONS(2547),
    [anon_sym_DASH_DASH] = ACTIONS(2549),
    [anon_sym_PLUS_PLUS] = ACTIONS(2549),
    [anon_sym_sizeof] = ACTIONS(2547),
    [anon_sym___alignof__] = ACTIONS(2547),
    [anon_sym___alignof] = ACTIONS(2547),
    [anon_sym__alignof] = ACTIONS(2547),
    [anon_sym_alignof] = ACTIONS(2547),
    [anon_sym__Alignof] = ACTIONS(2547),
    [anon_sym_offsetof] = ACTIONS(2547),
    [anon_sym__Generic] = ACTIONS(2547),
    [anon_sym_asm] = ACTIONS(2547),
    [anon_sym___asm__] = ACTIONS(2547),
    [anon_sym___asm] = ACTIONS(2547),
    [sym_number_literal] = ACTIONS(2549),
    [anon_sym_L_SQUOTE] = ACTIONS(2549),
    [anon_sym_u_SQUOTE] = ACTIONS(2549),
    [anon_sym_U_SQUOTE] = ACTIONS(2549),
    [anon_sym_u8_SQUOTE] = ACTIONS(2549),
    [anon_sym_SQUOTE] = ACTIONS(2549),
    [anon_sym_L_DQUOTE] = ACTIONS(2549),
    [anon_sym_u_DQUOTE] = ACTIONS(2549),
    [anon_sym_U_DQUOTE] = ACTIONS(2549),
    [anon_sym_u8_DQUOTE] = ACTIONS(2549),
    [anon_sym_DQUOTE] = ACTIONS(2549),
    [sym_true] = ACTIONS(2547),
    [sym_false] = ACTIONS(2547),
    [anon_sym_NULL] = ACTIONS(2547),
    [anon_sym_nullptr] = ACTIONS(2547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2547),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2547),
    [anon_sym_template] = ACTIONS(2547),
    [anon_sym_operator] = ACTIONS(2547),
    [anon_sym_try] = ACTIONS(2547),
    [anon_sym_delete] = ACTIONS(2547),
    [anon_sym_throw] = ACTIONS(2547),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_static_assert] = ACTIONS(2547),
    [anon_sym_concept] = ACTIONS(2547),
    [anon_sym_co_return] = ACTIONS(2547),
    [anon_sym_co_yield] = ACTIONS(2547),
    [anon_sym_catch] = ACTIONS(2487),
    [anon_sym_R_DQUOTE] = ACTIONS(2549),
    [anon_sym_LR_DQUOTE] = ACTIONS(2549),
    [anon_sym_uR_DQUOTE] = ACTIONS(2549),
    [anon_sym_UR_DQUOTE] = ACTIONS(2549),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2549),
    [anon_sym_co_await] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2547),
    [anon_sym_requires] = ACTIONS(2547),
    [sym_this] = ACTIONS(2547),
  },
  [229] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2571),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_explicit] = ACTIONS(2573),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [230] = {
    [sym_catch_clause] = STATE(224),
    [aux_sym_constructor_try_statement_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(2590),
    [aux_sym_preproc_include_token1] = ACTIONS(2590),
    [aux_sym_preproc_def_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token2] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2590),
    [aux_sym_preproc_else_token1] = ACTIONS(2590),
    [aux_sym_preproc_elif_token1] = ACTIONS(2590),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2590),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2590),
    [sym_preproc_directive] = ACTIONS(2590),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_TILDE] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym___extension__] = ACTIONS(2590),
    [anon_sym_typedef] = ACTIONS(2590),
    [anon_sym_virtual] = ACTIONS(2590),
    [anon_sym_extern] = ACTIONS(2590),
    [anon_sym___attribute__] = ACTIONS(2590),
    [anon_sym___attribute] = ACTIONS(2590),
    [anon_sym_using] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2592),
    [anon_sym___declspec] = ACTIONS(2590),
    [anon_sym___based] = ACTIONS(2590),
    [anon_sym___cdecl] = ACTIONS(2590),
    [anon_sym___clrcall] = ACTIONS(2590),
    [anon_sym___stdcall] = ACTIONS(2590),
    [anon_sym___fastcall] = ACTIONS(2590),
    [anon_sym___thiscall] = ACTIONS(2590),
    [anon_sym___vectorcall] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_signed] = ACTIONS(2590),
    [anon_sym_unsigned] = ACTIONS(2590),
    [anon_sym_long] = ACTIONS(2590),
    [anon_sym_short] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2590),
    [anon_sym_register] = ACTIONS(2590),
    [anon_sym_inline] = ACTIONS(2590),
    [anon_sym___inline] = ACTIONS(2590),
    [anon_sym___inline__] = ACTIONS(2590),
    [anon_sym___forceinline] = ACTIONS(2590),
    [anon_sym_thread_local] = ACTIONS(2590),
    [anon_sym___thread] = ACTIONS(2590),
    [anon_sym_const] = ACTIONS(2590),
    [anon_sym_constexpr] = ACTIONS(2590),
    [anon_sym_volatile] = ACTIONS(2590),
    [anon_sym_restrict] = ACTIONS(2590),
    [anon_sym___restrict__] = ACTIONS(2590),
    [anon_sym__Atomic] = ACTIONS(2590),
    [anon_sym__Noreturn] = ACTIONS(2590),
    [anon_sym_noreturn] = ACTIONS(2590),
    [anon_sym__Nonnull] = ACTIONS(2590),
    [anon_sym_mutable] = ACTIONS(2590),
    [anon_sym_constinit] = ACTIONS(2590),
    [anon_sym_consteval] = ACTIONS(2590),
    [anon_sym_alignas] = ACTIONS(2590),
    [anon_sym__Alignas] = ACTIONS(2590),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_enum] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_struct] = ACTIONS(2590),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_switch] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_default] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_continue] = ACTIONS(2590),
    [anon_sym_goto] = ACTIONS(2590),
    [anon_sym___try] = ACTIONS(2590),
    [anon_sym___leave] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_compl] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2592),
    [anon_sym_sizeof] = ACTIONS(2590),
    [anon_sym___alignof__] = ACTIONS(2590),
    [anon_sym___alignof] = ACTIONS(2590),
    [anon_sym__alignof] = ACTIONS(2590),
    [anon_sym_alignof] = ACTIONS(2590),
    [anon_sym__Alignof] = ACTIONS(2590),
    [anon_sym_offsetof] = ACTIONS(2590),
    [anon_sym__Generic] = ACTIONS(2590),
    [anon_sym_asm] = ACTIONS(2590),
    [anon_sym___asm__] = ACTIONS(2590),
    [anon_sym___asm] = ACTIONS(2590),
    [sym_number_literal] = ACTIONS(2592),
    [anon_sym_L_SQUOTE] = ACTIONS(2592),
    [anon_sym_u_SQUOTE] = ACTIONS(2592),
    [anon_sym_U_SQUOTE] = ACTIONS(2592),
    [anon_sym_u8_SQUOTE] = ACTIONS(2592),
    [anon_sym_SQUOTE] = ACTIONS(2592),
    [anon_sym_L_DQUOTE] = ACTIONS(2592),
    [anon_sym_u_DQUOTE] = ACTIONS(2592),
    [anon_sym_U_DQUOTE] = ACTIONS(2592),
    [anon_sym_u8_DQUOTE] = ACTIONS(2592),
    [anon_sym_DQUOTE] = ACTIONS(2592),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [anon_sym_NULL] = ACTIONS(2590),
    [anon_sym_nullptr] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2590),
    [anon_sym_decltype] = ACTIONS(2590),
    [anon_sym_explicit] = ACTIONS(2590),
    [anon_sym_typename] = ACTIONS(2590),
    [anon_sym_template] = ACTIONS(2590),
    [anon_sym_operator] = ACTIONS(2590),
    [anon_sym_try] = ACTIONS(2590),
    [anon_sym_delete] = ACTIONS(2590),
    [anon_sym_throw] = ACTIONS(2590),
    [anon_sym_namespace] = ACTIONS(2590),
    [anon_sym_static_assert] = ACTIONS(2590),
    [anon_sym_concept] = ACTIONS(2590),
    [anon_sym_co_return] = ACTIONS(2590),
    [anon_sym_co_yield] = ACTIONS(2590),
    [anon_sym_catch] = ACTIONS(2487),
    [anon_sym_R_DQUOTE] = ACTIONS(2592),
    [anon_sym_LR_DQUOTE] = ACTIONS(2592),
    [anon_sym_uR_DQUOTE] = ACTIONS(2592),
    [anon_sym_UR_DQUOTE] = ACTIONS(2592),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2592),
    [anon_sym_co_await] = ACTIONS(2590),
    [anon_sym_new] = ACTIONS(2590),
    [anon_sym_requires] = ACTIONS(2590),
    [sym_this] = ACTIONS(2590),
  },
  [231] = {
    [sym_catch_clause] = STATE(231),
    [aux_sym_constructor_try_statement_repeat1] = STATE(231),
    [ts_builtin_sym_end] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(2476),
    [aux_sym_preproc_include_token1] = ACTIONS(2476),
    [aux_sym_preproc_def_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token1] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2476),
    [sym_preproc_directive] = ACTIONS(2476),
    [anon_sym_LPAREN2] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym___extension__] = ACTIONS(2476),
    [anon_sym_typedef] = ACTIONS(2476),
    [anon_sym_virtual] = ACTIONS(2476),
    [anon_sym_extern] = ACTIONS(2476),
    [anon_sym___attribute__] = ACTIONS(2476),
    [anon_sym___attribute] = ACTIONS(2476),
    [anon_sym_using] = ACTIONS(2476),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2478),
    [anon_sym___declspec] = ACTIONS(2476),
    [anon_sym___based] = ACTIONS(2476),
    [anon_sym___cdecl] = ACTIONS(2476),
    [anon_sym___clrcall] = ACTIONS(2476),
    [anon_sym___stdcall] = ACTIONS(2476),
    [anon_sym___fastcall] = ACTIONS(2476),
    [anon_sym___thiscall] = ACTIONS(2476),
    [anon_sym___vectorcall] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_signed] = ACTIONS(2476),
    [anon_sym_unsigned] = ACTIONS(2476),
    [anon_sym_long] = ACTIONS(2476),
    [anon_sym_short] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_register] = ACTIONS(2476),
    [anon_sym_inline] = ACTIONS(2476),
    [anon_sym___inline] = ACTIONS(2476),
    [anon_sym___inline__] = ACTIONS(2476),
    [anon_sym___forceinline] = ACTIONS(2476),
    [anon_sym_thread_local] = ACTIONS(2476),
    [anon_sym___thread] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_constexpr] = ACTIONS(2476),
    [anon_sym_volatile] = ACTIONS(2476),
    [anon_sym_restrict] = ACTIONS(2476),
    [anon_sym___restrict__] = ACTIONS(2476),
    [anon_sym__Atomic] = ACTIONS(2476),
    [anon_sym__Noreturn] = ACTIONS(2476),
    [anon_sym_noreturn] = ACTIONS(2476),
    [anon_sym__Nonnull] = ACTIONS(2476),
    [anon_sym_mutable] = ACTIONS(2476),
    [anon_sym_constinit] = ACTIONS(2476),
    [anon_sym_consteval] = ACTIONS(2476),
    [anon_sym_alignas] = ACTIONS(2476),
    [anon_sym__Alignas] = ACTIONS(2476),
    [sym_primitive_type] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [anon_sym_class] = ACTIONS(2476),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2476),
    [anon_sym_if] = ACTIONS(2476),
    [anon_sym_else] = ACTIONS(2476),
    [anon_sym_switch] = ACTIONS(2476),
    [anon_sym_case] = ACTIONS(2476),
    [anon_sym_default] = ACTIONS(2476),
    [anon_sym_while] = ACTIONS(2476),
    [anon_sym_do] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2476),
    [anon_sym_break] = ACTIONS(2476),
    [anon_sym_continue] = ACTIONS(2476),
    [anon_sym_goto] = ACTIONS(2476),
    [anon_sym___try] = ACTIONS(2476),
    [anon_sym___leave] = ACTIONS(2476),
    [anon_sym_not] = ACTIONS(2476),
    [anon_sym_compl] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2476),
    [anon_sym___alignof__] = ACTIONS(2476),
    [anon_sym___alignof] = ACTIONS(2476),
    [anon_sym__alignof] = ACTIONS(2476),
    [anon_sym_alignof] = ACTIONS(2476),
    [anon_sym__Alignof] = ACTIONS(2476),
    [anon_sym_offsetof] = ACTIONS(2476),
    [anon_sym__Generic] = ACTIONS(2476),
    [anon_sym_asm] = ACTIONS(2476),
    [anon_sym___asm__] = ACTIONS(2476),
    [anon_sym___asm] = ACTIONS(2476),
    [sym_number_literal] = ACTIONS(2478),
    [anon_sym_L_SQUOTE] = ACTIONS(2478),
    [anon_sym_u_SQUOTE] = ACTIONS(2478),
    [anon_sym_U_SQUOTE] = ACTIONS(2478),
    [anon_sym_u8_SQUOTE] = ACTIONS(2478),
    [anon_sym_SQUOTE] = ACTIONS(2478),
    [anon_sym_L_DQUOTE] = ACTIONS(2478),
    [anon_sym_u_DQUOTE] = ACTIONS(2478),
    [anon_sym_U_DQUOTE] = ACTIONS(2478),
    [anon_sym_u8_DQUOTE] = ACTIONS(2478),
    [anon_sym_DQUOTE] = ACTIONS(2478),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2476),
    [anon_sym_nullptr] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2476),
    [anon_sym_decltype] = ACTIONS(2476),
    [anon_sym_explicit] = ACTIONS(2476),
    [anon_sym_typename] = ACTIONS(2476),
    [anon_sym_export] = ACTIONS(2476),
    [anon_sym_module] = ACTIONS(2476),
    [anon_sym_import] = ACTIONS(2476),
    [anon_sym_template] = ACTIONS(2476),
    [anon_sym_operator] = ACTIONS(2476),
    [anon_sym_try] = ACTIONS(2476),
    [anon_sym_delete] = ACTIONS(2476),
    [anon_sym_throw] = ACTIONS(2476),
    [anon_sym_namespace] = ACTIONS(2476),
    [anon_sym_static_assert] = ACTIONS(2476),
    [anon_sym_concept] = ACTIONS(2476),
    [anon_sym_co_return] = ACTIONS(2476),
    [anon_sym_co_yield] = ACTIONS(2476),
    [anon_sym_catch] = ACTIONS(2594),
    [anon_sym_R_DQUOTE] = ACTIONS(2478),
    [anon_sym_LR_DQUOTE] = ACTIONS(2478),
    [anon_sym_uR_DQUOTE] = ACTIONS(2478),
    [anon_sym_UR_DQUOTE] = ACTIONS(2478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2478),
    [anon_sym_co_await] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2476),
    [anon_sym_requires] = ACTIONS(2476),
    [sym_this] = ACTIONS(2476),
  },
  [232] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2597),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_explicit] = ACTIONS(2573),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [233] = {
    [sym_catch_clause] = STATE(231),
    [aux_sym_constructor_try_statement_repeat1] = STATE(231),
    [ts_builtin_sym_end] = ACTIONS(2485),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_include_token1] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_virtual] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym___attribute] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym___cdecl] = ACTIONS(2483),
    [anon_sym___clrcall] = ACTIONS(2483),
    [anon_sym___stdcall] = ACTIONS(2483),
    [anon_sym___fastcall] = ACTIONS(2483),
    [anon_sym___thiscall] = ACTIONS(2483),
    [anon_sym___vectorcall] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym__Nonnull] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_case] = ACTIONS(2483),
    [anon_sym_default] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_goto] = ACTIONS(2483),
    [anon_sym___try] = ACTIONS(2483),
    [anon_sym___leave] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2483),
    [anon_sym_compl] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_sizeof] = ACTIONS(2483),
    [anon_sym___alignof__] = ACTIONS(2483),
    [anon_sym___alignof] = ACTIONS(2483),
    [anon_sym__alignof] = ACTIONS(2483),
    [anon_sym_alignof] = ACTIONS(2483),
    [anon_sym__Alignof] = ACTIONS(2483),
    [anon_sym_offsetof] = ACTIONS(2483),
    [anon_sym__Generic] = ACTIONS(2483),
    [anon_sym_asm] = ACTIONS(2483),
    [anon_sym___asm__] = ACTIONS(2483),
    [anon_sym___asm] = ACTIONS(2483),
    [sym_number_literal] = ACTIONS(2485),
    [anon_sym_L_SQUOTE] = ACTIONS(2485),
    [anon_sym_u_SQUOTE] = ACTIONS(2485),
    [anon_sym_U_SQUOTE] = ACTIONS(2485),
    [anon_sym_u8_SQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [anon_sym_L_DQUOTE] = ACTIONS(2485),
    [anon_sym_u_DQUOTE] = ACTIONS(2485),
    [anon_sym_U_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8_DQUOTE] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [anon_sym_NULL] = ACTIONS(2483),
    [anon_sym_nullptr] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_export] = ACTIONS(2483),
    [anon_sym_module] = ACTIONS(2483),
    [anon_sym_import] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_namespace] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_concept] = ACTIONS(2483),
    [anon_sym_co_return] = ACTIONS(2483),
    [anon_sym_co_yield] = ACTIONS(2483),
    [anon_sym_catch] = ACTIONS(2599),
    [anon_sym_R_DQUOTE] = ACTIONS(2485),
    [anon_sym_LR_DQUOTE] = ACTIONS(2485),
    [anon_sym_uR_DQUOTE] = ACTIONS(2485),
    [anon_sym_UR_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2485),
    [anon_sym_co_await] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_requires] = ACTIONS(2483),
    [sym_this] = ACTIONS(2483),
  },
  [234] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2601),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_explicit] = ACTIONS(2573),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [235] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2603),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_explicit] = ACTIONS(2573),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [236] = {
    [sym_expression] = STATE(3578),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_initializer_list] = STATE(3864),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_RPAREN] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1872),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1942),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1942),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACE] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [anon_sym_EQ] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_STAR_EQ] = ACTIONS(1944),
    [anon_sym_SLASH_EQ] = ACTIONS(1944),
    [anon_sym_PERCENT_EQ] = ACTIONS(1944),
    [anon_sym_PLUS_EQ] = ACTIONS(1944),
    [anon_sym_DASH_EQ] = ACTIONS(1944),
    [anon_sym_LT_LT_EQ] = ACTIONS(1944),
    [anon_sym_GT_GT_EQ] = ACTIONS(1944),
    [anon_sym_AMP_EQ] = ACTIONS(1944),
    [anon_sym_CARET_EQ] = ACTIONS(1944),
    [anon_sym_PIPE_EQ] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1944),
    [sym_this] = ACTIONS(1910),
  },
  [237] = {
    [sym_else_clause] = STATE(252),
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_include_token1] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token2] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [aux_sym_preproc_else_token1] = ACTIONS(2613),
    [aux_sym_preproc_elif_token1] = ACTIONS(2613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym___cdecl] = ACTIONS(2613),
    [anon_sym___clrcall] = ACTIONS(2613),
    [anon_sym___stdcall] = ACTIONS(2613),
    [anon_sym___fastcall] = ACTIONS(2613),
    [anon_sym___thiscall] = ACTIONS(2613),
    [anon_sym___vectorcall] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(2617),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_case] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_goto] = ACTIONS(2613),
    [anon_sym___try] = ACTIONS(2613),
    [anon_sym___leave] = ACTIONS(2613),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_compl] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2615),
    [anon_sym_sizeof] = ACTIONS(2613),
    [anon_sym___alignof__] = ACTIONS(2613),
    [anon_sym___alignof] = ACTIONS(2613),
    [anon_sym__alignof] = ACTIONS(2613),
    [anon_sym_alignof] = ACTIONS(2613),
    [anon_sym__Alignof] = ACTIONS(2613),
    [anon_sym_offsetof] = ACTIONS(2613),
    [anon_sym__Generic] = ACTIONS(2613),
    [anon_sym_asm] = ACTIONS(2613),
    [anon_sym___asm__] = ACTIONS(2613),
    [anon_sym___asm] = ACTIONS(2613),
    [sym_number_literal] = ACTIONS(2615),
    [anon_sym_L_SQUOTE] = ACTIONS(2615),
    [anon_sym_u_SQUOTE] = ACTIONS(2615),
    [anon_sym_U_SQUOTE] = ACTIONS(2615),
    [anon_sym_u8_SQUOTE] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2615),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [anon_sym_NULL] = ACTIONS(2613),
    [anon_sym_nullptr] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_namespace] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
    [anon_sym_concept] = ACTIONS(2613),
    [anon_sym_co_return] = ACTIONS(2613),
    [anon_sym_co_yield] = ACTIONS(2613),
    [anon_sym_R_DQUOTE] = ACTIONS(2615),
    [anon_sym_LR_DQUOTE] = ACTIONS(2615),
    [anon_sym_uR_DQUOTE] = ACTIONS(2615),
    [anon_sym_UR_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2615),
    [anon_sym_co_await] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_requires] = ACTIONS(2613),
    [sym_this] = ACTIONS(2613),
  },
  [238] = {
    [sym_identifier] = ACTIONS(2619),
    [aux_sym_preproc_include_token1] = ACTIONS(2619),
    [aux_sym_preproc_def_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token2] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2619),
    [aux_sym_preproc_else_token1] = ACTIONS(2619),
    [aux_sym_preproc_elif_token1] = ACTIONS(2619),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2619),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2619),
    [sym_preproc_directive] = ACTIONS(2619),
    [anon_sym_LPAREN2] = ACTIONS(2621),
    [anon_sym_BANG] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(2619),
    [anon_sym_PLUS] = ACTIONS(2619),
    [anon_sym_STAR] = ACTIONS(2621),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(2619),
    [anon_sym_typedef] = ACTIONS(2619),
    [anon_sym_virtual] = ACTIONS(2619),
    [anon_sym_extern] = ACTIONS(2619),
    [anon_sym___attribute__] = ACTIONS(2619),
    [anon_sym___attribute] = ACTIONS(2619),
    [anon_sym_using] = ACTIONS(2619),
    [anon_sym_COLON_COLON] = ACTIONS(2621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2621),
    [anon_sym___declspec] = ACTIONS(2619),
    [anon_sym___based] = ACTIONS(2619),
    [anon_sym___cdecl] = ACTIONS(2619),
    [anon_sym___clrcall] = ACTIONS(2619),
    [anon_sym___stdcall] = ACTIONS(2619),
    [anon_sym___fastcall] = ACTIONS(2619),
    [anon_sym___thiscall] = ACTIONS(2619),
    [anon_sym___vectorcall] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_signed] = ACTIONS(2619),
    [anon_sym_unsigned] = ACTIONS(2619),
    [anon_sym_long] = ACTIONS(2619),
    [anon_sym_short] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_register] = ACTIONS(2619),
    [anon_sym_inline] = ACTIONS(2619),
    [anon_sym___inline] = ACTIONS(2619),
    [anon_sym___inline__] = ACTIONS(2619),
    [anon_sym___forceinline] = ACTIONS(2619),
    [anon_sym_thread_local] = ACTIONS(2619),
    [anon_sym___thread] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_constexpr] = ACTIONS(2619),
    [anon_sym_volatile] = ACTIONS(2619),
    [anon_sym_restrict] = ACTIONS(2619),
    [anon_sym___restrict__] = ACTIONS(2619),
    [anon_sym__Atomic] = ACTIONS(2619),
    [anon_sym__Noreturn] = ACTIONS(2619),
    [anon_sym_noreturn] = ACTIONS(2619),
    [anon_sym__Nonnull] = ACTIONS(2619),
    [anon_sym_mutable] = ACTIONS(2619),
    [anon_sym_constinit] = ACTIONS(2619),
    [anon_sym_consteval] = ACTIONS(2619),
    [anon_sym_alignas] = ACTIONS(2619),
    [anon_sym__Alignas] = ACTIONS(2619),
    [sym_primitive_type] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_struct] = ACTIONS(2619),
    [anon_sym_union] = ACTIONS(2619),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_else] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2619),
    [anon_sym_case] = ACTIONS(2619),
    [anon_sym_default] = ACTIONS(2619),
    [anon_sym_while] = ACTIONS(2619),
    [anon_sym_do] = ACTIONS(2619),
    [anon_sym_for] = ACTIONS(2619),
    [anon_sym_return] = ACTIONS(2619),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_continue] = ACTIONS(2619),
    [anon_sym_goto] = ACTIONS(2619),
    [anon_sym___try] = ACTIONS(2619),
    [anon_sym___leave] = ACTIONS(2619),
    [anon_sym_not] = ACTIONS(2619),
    [anon_sym_compl] = ACTIONS(2619),
    [anon_sym_DASH_DASH] = ACTIONS(2621),
    [anon_sym_PLUS_PLUS] = ACTIONS(2621),
    [anon_sym_sizeof] = ACTIONS(2619),
    [anon_sym___alignof__] = ACTIONS(2619),
    [anon_sym___alignof] = ACTIONS(2619),
    [anon_sym__alignof] = ACTIONS(2619),
    [anon_sym_alignof] = ACTIONS(2619),
    [anon_sym__Alignof] = ACTIONS(2619),
    [anon_sym_offsetof] = ACTIONS(2619),
    [anon_sym__Generic] = ACTIONS(2619),
    [anon_sym_asm] = ACTIONS(2619),
    [anon_sym___asm__] = ACTIONS(2619),
    [anon_sym___asm] = ACTIONS(2619),
    [sym_number_literal] = ACTIONS(2621),
    [anon_sym_L_SQUOTE] = ACTIONS(2621),
    [anon_sym_u_SQUOTE] = ACTIONS(2621),
    [anon_sym_U_SQUOTE] = ACTIONS(2621),
    [anon_sym_u8_SQUOTE] = ACTIONS(2621),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [anon_sym_L_DQUOTE] = ACTIONS(2621),
    [anon_sym_u_DQUOTE] = ACTIONS(2621),
    [anon_sym_U_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8_DQUOTE] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [sym_true] = ACTIONS(2619),
    [sym_false] = ACTIONS(2619),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2619),
    [anon_sym_decltype] = ACTIONS(2619),
    [anon_sym_explicit] = ACTIONS(2619),
    [anon_sym_typename] = ACTIONS(2619),
    [anon_sym_template] = ACTIONS(2619),
    [anon_sym_operator] = ACTIONS(2619),
    [anon_sym_try] = ACTIONS(2619),
    [anon_sym_delete] = ACTIONS(2619),
    [anon_sym_throw] = ACTIONS(2619),
    [anon_sym_namespace] = ACTIONS(2619),
    [anon_sym_static_assert] = ACTIONS(2619),
    [anon_sym_concept] = ACTIONS(2619),
    [anon_sym_co_return] = ACTIONS(2619),
    [anon_sym_co_yield] = ACTIONS(2619),
    [anon_sym_catch] = ACTIONS(2619),
    [anon_sym_R_DQUOTE] = ACTIONS(2621),
    [anon_sym_LR_DQUOTE] = ACTIONS(2621),
    [anon_sym_uR_DQUOTE] = ACTIONS(2621),
    [anon_sym_UR_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2621),
    [anon_sym_co_await] = ACTIONS(2619),
    [anon_sym_new] = ACTIONS(2619),
    [anon_sym_requires] = ACTIONS(2619),
    [sym_this] = ACTIONS(2619),
  },
  [239] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_include_token1] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token2] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [aux_sym_preproc_else_token1] = ACTIONS(1940),
    [aux_sym_preproc_elif_token1] = ACTIONS(1940),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym___cdecl] = ACTIONS(1940),
    [anon_sym___clrcall] = ACTIONS(1940),
    [anon_sym___stdcall] = ACTIONS(1940),
    [anon_sym___fastcall] = ACTIONS(1940),
    [anon_sym___thiscall] = ACTIONS(1940),
    [anon_sym___vectorcall] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_else] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1940),
    [anon_sym___try] = ACTIONS(1940),
    [anon_sym___leave] = ACTIONS(1940),
    [anon_sym_not] = ACTIONS(1940),
    [anon_sym_compl] = ACTIONS(1940),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_sizeof] = ACTIONS(1940),
    [anon_sym___alignof__] = ACTIONS(1940),
    [anon_sym___alignof] = ACTIONS(1940),
    [anon_sym__alignof] = ACTIONS(1940),
    [anon_sym_alignof] = ACTIONS(1940),
    [anon_sym__Alignof] = ACTIONS(1940),
    [anon_sym_offsetof] = ACTIONS(1940),
    [anon_sym__Generic] = ACTIONS(1940),
    [anon_sym_asm] = ACTIONS(1940),
    [anon_sym___asm__] = ACTIONS(1940),
    [anon_sym___asm] = ACTIONS(1940),
    [sym_number_literal] = ACTIONS(1938),
    [anon_sym_L_SQUOTE] = ACTIONS(1938),
    [anon_sym_u_SQUOTE] = ACTIONS(1938),
    [anon_sym_U_SQUOTE] = ACTIONS(1938),
    [anon_sym_u8_SQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_L_DQUOTE] = ACTIONS(1938),
    [anon_sym_u_DQUOTE] = ACTIONS(1938),
    [anon_sym_U_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8_DQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [anon_sym_NULL] = ACTIONS(1940),
    [anon_sym_nullptr] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_concept] = ACTIONS(1940),
    [anon_sym_co_return] = ACTIONS(1940),
    [anon_sym_co_yield] = ACTIONS(1940),
    [anon_sym_catch] = ACTIONS(1940),
    [anon_sym_R_DQUOTE] = ACTIONS(1938),
    [anon_sym_LR_DQUOTE] = ACTIONS(1938),
    [anon_sym_uR_DQUOTE] = ACTIONS(1938),
    [anon_sym_UR_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1938),
    [anon_sym_co_await] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_requires] = ACTIONS(1940),
    [sym_this] = ACTIONS(1940),
  },
  [240] = {
    [sym_else_clause] = STATE(270),
    [sym_identifier] = ACTIONS(2623),
    [aux_sym_preproc_include_token1] = ACTIONS(2623),
    [aux_sym_preproc_def_token1] = ACTIONS(2623),
    [aux_sym_preproc_if_token1] = ACTIONS(2623),
    [aux_sym_preproc_if_token2] = ACTIONS(2623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2623),
    [aux_sym_preproc_else_token1] = ACTIONS(2623),
    [aux_sym_preproc_elif_token1] = ACTIONS(2623),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2623),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2623),
    [sym_preproc_directive] = ACTIONS(2623),
    [anon_sym_LPAREN2] = ACTIONS(2625),
    [anon_sym_BANG] = ACTIONS(2625),
    [anon_sym_TILDE] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_AMP_AMP] = ACTIONS(2625),
    [anon_sym_AMP] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2625),
    [anon_sym___extension__] = ACTIONS(2623),
    [anon_sym_typedef] = ACTIONS(2623),
    [anon_sym_virtual] = ACTIONS(2623),
    [anon_sym_extern] = ACTIONS(2623),
    [anon_sym___attribute__] = ACTIONS(2623),
    [anon_sym___attribute] = ACTIONS(2623),
    [anon_sym_using] = ACTIONS(2623),
    [anon_sym_COLON_COLON] = ACTIONS(2625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2625),
    [anon_sym___declspec] = ACTIONS(2623),
    [anon_sym___based] = ACTIONS(2623),
    [anon_sym___cdecl] = ACTIONS(2623),
    [anon_sym___clrcall] = ACTIONS(2623),
    [anon_sym___stdcall] = ACTIONS(2623),
    [anon_sym___fastcall] = ACTIONS(2623),
    [anon_sym___thiscall] = ACTIONS(2623),
    [anon_sym___vectorcall] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2625),
    [anon_sym_signed] = ACTIONS(2623),
    [anon_sym_unsigned] = ACTIONS(2623),
    [anon_sym_long] = ACTIONS(2623),
    [anon_sym_short] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_static] = ACTIONS(2623),
    [anon_sym_register] = ACTIONS(2623),
    [anon_sym_inline] = ACTIONS(2623),
    [anon_sym___inline] = ACTIONS(2623),
    [anon_sym___inline__] = ACTIONS(2623),
    [anon_sym___forceinline] = ACTIONS(2623),
    [anon_sym_thread_local] = ACTIONS(2623),
    [anon_sym___thread] = ACTIONS(2623),
    [anon_sym_const] = ACTIONS(2623),
    [anon_sym_constexpr] = ACTIONS(2623),
    [anon_sym_volatile] = ACTIONS(2623),
    [anon_sym_restrict] = ACTIONS(2623),
    [anon_sym___restrict__] = ACTIONS(2623),
    [anon_sym__Atomic] = ACTIONS(2623),
    [anon_sym__Noreturn] = ACTIONS(2623),
    [anon_sym_noreturn] = ACTIONS(2623),
    [anon_sym__Nonnull] = ACTIONS(2623),
    [anon_sym_mutable] = ACTIONS(2623),
    [anon_sym_constinit] = ACTIONS(2623),
    [anon_sym_consteval] = ACTIONS(2623),
    [anon_sym_alignas] = ACTIONS(2623),
    [anon_sym__Alignas] = ACTIONS(2623),
    [sym_primitive_type] = ACTIONS(2623),
    [anon_sym_enum] = ACTIONS(2623),
    [anon_sym_class] = ACTIONS(2623),
    [anon_sym_struct] = ACTIONS(2623),
    [anon_sym_union] = ACTIONS(2623),
    [anon_sym_if] = ACTIONS(2623),
    [anon_sym_else] = ACTIONS(2617),
    [anon_sym_switch] = ACTIONS(2623),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2623),
    [anon_sym_while] = ACTIONS(2623),
    [anon_sym_do] = ACTIONS(2623),
    [anon_sym_for] = ACTIONS(2623),
    [anon_sym_return] = ACTIONS(2623),
    [anon_sym_break] = ACTIONS(2623),
    [anon_sym_continue] = ACTIONS(2623),
    [anon_sym_goto] = ACTIONS(2623),
    [anon_sym___try] = ACTIONS(2623),
    [anon_sym___leave] = ACTIONS(2623),
    [anon_sym_not] = ACTIONS(2623),
    [anon_sym_compl] = ACTIONS(2623),
    [anon_sym_DASH_DASH] = ACTIONS(2625),
    [anon_sym_PLUS_PLUS] = ACTIONS(2625),
    [anon_sym_sizeof] = ACTIONS(2623),
    [anon_sym___alignof__] = ACTIONS(2623),
    [anon_sym___alignof] = ACTIONS(2623),
    [anon_sym__alignof] = ACTIONS(2623),
    [anon_sym_alignof] = ACTIONS(2623),
    [anon_sym__Alignof] = ACTIONS(2623),
    [anon_sym_offsetof] = ACTIONS(2623),
    [anon_sym__Generic] = ACTIONS(2623),
    [anon_sym_asm] = ACTIONS(2623),
    [anon_sym___asm__] = ACTIONS(2623),
    [anon_sym___asm] = ACTIONS(2623),
    [sym_number_literal] = ACTIONS(2625),
    [anon_sym_L_SQUOTE] = ACTIONS(2625),
    [anon_sym_u_SQUOTE] = ACTIONS(2625),
    [anon_sym_U_SQUOTE] = ACTIONS(2625),
    [anon_sym_u8_SQUOTE] = ACTIONS(2625),
    [anon_sym_SQUOTE] = ACTIONS(2625),
    [anon_sym_L_DQUOTE] = ACTIONS(2625),
    [anon_sym_u_DQUOTE] = ACTIONS(2625),
    [anon_sym_U_DQUOTE] = ACTIONS(2625),
    [anon_sym_u8_DQUOTE] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(2625),
    [sym_true] = ACTIONS(2623),
    [sym_false] = ACTIONS(2623),
    [anon_sym_NULL] = ACTIONS(2623),
    [anon_sym_nullptr] = ACTIONS(2623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2623),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_explicit] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2623),
    [anon_sym_template] = ACTIONS(2623),
    [anon_sym_operator] = ACTIONS(2623),
    [anon_sym_try] = ACTIONS(2623),
    [anon_sym_delete] = ACTIONS(2623),
    [anon_sym_throw] = ACTIONS(2623),
    [anon_sym_namespace] = ACTIONS(2623),
    [anon_sym_static_assert] = ACTIONS(2623),
    [anon_sym_concept] = ACTIONS(2623),
    [anon_sym_co_return] = ACTIONS(2623),
    [anon_sym_co_yield] = ACTIONS(2623),
    [anon_sym_R_DQUOTE] = ACTIONS(2625),
    [anon_sym_LR_DQUOTE] = ACTIONS(2625),
    [anon_sym_uR_DQUOTE] = ACTIONS(2625),
    [anon_sym_UR_DQUOTE] = ACTIONS(2625),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2625),
    [anon_sym_co_await] = ACTIONS(2623),
    [anon_sym_new] = ACTIONS(2623),
    [anon_sym_requires] = ACTIONS(2623),
    [sym_this] = ACTIONS(2623),
  },
  [241] = {
    [sym_identifier] = ACTIONS(1936),
    [aux_sym_preproc_include_token1] = ACTIONS(1936),
    [aux_sym_preproc_def_token1] = ACTIONS(1936),
    [aux_sym_preproc_if_token1] = ACTIONS(1936),
    [aux_sym_preproc_if_token2] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1936),
    [aux_sym_preproc_else_token1] = ACTIONS(1936),
    [aux_sym_preproc_elif_token1] = ACTIONS(1936),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1936),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1936),
    [sym_preproc_directive] = ACTIONS(1936),
    [anon_sym_LPAREN2] = ACTIONS(1934),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_DASH] = ACTIONS(1936),
    [anon_sym_PLUS] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(1934),
    [anon_sym_AMP_AMP] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym___extension__] = ACTIONS(1936),
    [anon_sym_typedef] = ACTIONS(1936),
    [anon_sym_virtual] = ACTIONS(1936),
    [anon_sym_extern] = ACTIONS(1936),
    [anon_sym___attribute__] = ACTIONS(1936),
    [anon_sym___attribute] = ACTIONS(1936),
    [anon_sym_using] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1934),
    [anon_sym___declspec] = ACTIONS(1936),
    [anon_sym___based] = ACTIONS(1936),
    [anon_sym___cdecl] = ACTIONS(1936),
    [anon_sym___clrcall] = ACTIONS(1936),
    [anon_sym___stdcall] = ACTIONS(1936),
    [anon_sym___fastcall] = ACTIONS(1936),
    [anon_sym___thiscall] = ACTIONS(1936),
    [anon_sym___vectorcall] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_signed] = ACTIONS(1936),
    [anon_sym_unsigned] = ACTIONS(1936),
    [anon_sym_long] = ACTIONS(1936),
    [anon_sym_short] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_register] = ACTIONS(1936),
    [anon_sym_inline] = ACTIONS(1936),
    [anon_sym___inline] = ACTIONS(1936),
    [anon_sym___inline__] = ACTIONS(1936),
    [anon_sym___forceinline] = ACTIONS(1936),
    [anon_sym_thread_local] = ACTIONS(1936),
    [anon_sym___thread] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_constexpr] = ACTIONS(1936),
    [anon_sym_volatile] = ACTIONS(1936),
    [anon_sym_restrict] = ACTIONS(1936),
    [anon_sym___restrict__] = ACTIONS(1936),
    [anon_sym__Atomic] = ACTIONS(1936),
    [anon_sym__Noreturn] = ACTIONS(1936),
    [anon_sym_noreturn] = ACTIONS(1936),
    [anon_sym__Nonnull] = ACTIONS(1936),
    [anon_sym_mutable] = ACTIONS(1936),
    [anon_sym_constinit] = ACTIONS(1936),
    [anon_sym_consteval] = ACTIONS(1936),
    [anon_sym_alignas] = ACTIONS(1936),
    [anon_sym__Alignas] = ACTIONS(1936),
    [sym_primitive_type] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_struct] = ACTIONS(1936),
    [anon_sym_union] = ACTIONS(1936),
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(1936),
    [anon_sym_switch] = ACTIONS(1936),
    [anon_sym_case] = ACTIONS(1936),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_while] = ACTIONS(1936),
    [anon_sym_do] = ACTIONS(1936),
    [anon_sym_for] = ACTIONS(1936),
    [anon_sym_return] = ACTIONS(1936),
    [anon_sym_break] = ACTIONS(1936),
    [anon_sym_continue] = ACTIONS(1936),
    [anon_sym_goto] = ACTIONS(1936),
    [anon_sym___try] = ACTIONS(1936),
    [anon_sym___leave] = ACTIONS(1936),
    [anon_sym_not] = ACTIONS(1936),
    [anon_sym_compl] = ACTIONS(1936),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_sizeof] = ACTIONS(1936),
    [anon_sym___alignof__] = ACTIONS(1936),
    [anon_sym___alignof] = ACTIONS(1936),
    [anon_sym__alignof] = ACTIONS(1936),
    [anon_sym_alignof] = ACTIONS(1936),
    [anon_sym__Alignof] = ACTIONS(1936),
    [anon_sym_offsetof] = ACTIONS(1936),
    [anon_sym__Generic] = ACTIONS(1936),
    [anon_sym_asm] = ACTIONS(1936),
    [anon_sym___asm__] = ACTIONS(1936),
    [anon_sym___asm] = ACTIONS(1936),
    [sym_number_literal] = ACTIONS(1934),
    [anon_sym_L_SQUOTE] = ACTIONS(1934),
    [anon_sym_u_SQUOTE] = ACTIONS(1934),
    [anon_sym_U_SQUOTE] = ACTIONS(1934),
    [anon_sym_u8_SQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [anon_sym_L_DQUOTE] = ACTIONS(1934),
    [anon_sym_u_DQUOTE] = ACTIONS(1934),
    [anon_sym_U_DQUOTE] = ACTIONS(1934),
    [anon_sym_u8_DQUOTE] = ACTIONS(1934),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [anon_sym_NULL] = ACTIONS(1936),
    [anon_sym_nullptr] = ACTIONS(1936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1936),
    [anon_sym_decltype] = ACTIONS(1936),
    [anon_sym_explicit] = ACTIONS(1936),
    [anon_sym_typename] = ACTIONS(1936),
    [anon_sym_template] = ACTIONS(1936),
    [anon_sym_operator] = ACTIONS(1936),
    [anon_sym_try] = ACTIONS(1936),
    [anon_sym_delete] = ACTIONS(1936),
    [anon_sym_throw] = ACTIONS(1936),
    [anon_sym_namespace] = ACTIONS(1936),
    [anon_sym_static_assert] = ACTIONS(1936),
    [anon_sym_concept] = ACTIONS(1936),
    [anon_sym_co_return] = ACTIONS(1936),
    [anon_sym_co_yield] = ACTIONS(1936),
    [anon_sym_catch] = ACTIONS(1936),
    [anon_sym_R_DQUOTE] = ACTIONS(1934),
    [anon_sym_LR_DQUOTE] = ACTIONS(1934),
    [anon_sym_uR_DQUOTE] = ACTIONS(1934),
    [anon_sym_UR_DQUOTE] = ACTIONS(1934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1934),
    [anon_sym_co_await] = ACTIONS(1936),
    [anon_sym_new] = ACTIONS(1936),
    [anon_sym_requires] = ACTIONS(1936),
    [sym_this] = ACTIONS(1936),
  },
  [242] = {
    [sym_identifier] = ACTIONS(2627),
    [aux_sym_preproc_include_token1] = ACTIONS(2627),
    [aux_sym_preproc_def_token1] = ACTIONS(2627),
    [aux_sym_preproc_if_token1] = ACTIONS(2627),
    [aux_sym_preproc_if_token2] = ACTIONS(2627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2627),
    [aux_sym_preproc_else_token1] = ACTIONS(2627),
    [aux_sym_preproc_elif_token1] = ACTIONS(2627),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2627),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2627),
    [sym_preproc_directive] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2629),
    [anon_sym_BANG] = ACTIONS(2629),
    [anon_sym_TILDE] = ACTIONS(2629),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2629),
    [anon_sym_AMP_AMP] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_SEMI] = ACTIONS(2629),
    [anon_sym___extension__] = ACTIONS(2627),
    [anon_sym_typedef] = ACTIONS(2627),
    [anon_sym_virtual] = ACTIONS(2627),
    [anon_sym_extern] = ACTIONS(2627),
    [anon_sym___attribute__] = ACTIONS(2627),
    [anon_sym___attribute] = ACTIONS(2627),
    [anon_sym_using] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2629),
    [anon_sym___declspec] = ACTIONS(2627),
    [anon_sym___based] = ACTIONS(2627),
    [anon_sym___cdecl] = ACTIONS(2627),
    [anon_sym___clrcall] = ACTIONS(2627),
    [anon_sym___stdcall] = ACTIONS(2627),
    [anon_sym___fastcall] = ACTIONS(2627),
    [anon_sym___thiscall] = ACTIONS(2627),
    [anon_sym___vectorcall] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2629),
    [anon_sym_signed] = ACTIONS(2627),
    [anon_sym_unsigned] = ACTIONS(2627),
    [anon_sym_long] = ACTIONS(2627),
    [anon_sym_short] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_static] = ACTIONS(2627),
    [anon_sym_register] = ACTIONS(2627),
    [anon_sym_inline] = ACTIONS(2627),
    [anon_sym___inline] = ACTIONS(2627),
    [anon_sym___inline__] = ACTIONS(2627),
    [anon_sym___forceinline] = ACTIONS(2627),
    [anon_sym_thread_local] = ACTIONS(2627),
    [anon_sym___thread] = ACTIONS(2627),
    [anon_sym_const] = ACTIONS(2627),
    [anon_sym_constexpr] = ACTIONS(2627),
    [anon_sym_volatile] = ACTIONS(2627),
    [anon_sym_restrict] = ACTIONS(2627),
    [anon_sym___restrict__] = ACTIONS(2627),
    [anon_sym__Atomic] = ACTIONS(2627),
    [anon_sym__Noreturn] = ACTIONS(2627),
    [anon_sym_noreturn] = ACTIONS(2627),
    [anon_sym__Nonnull] = ACTIONS(2627),
    [anon_sym_mutable] = ACTIONS(2627),
    [anon_sym_constinit] = ACTIONS(2627),
    [anon_sym_consteval] = ACTIONS(2627),
    [anon_sym_alignas] = ACTIONS(2627),
    [anon_sym__Alignas] = ACTIONS(2627),
    [sym_primitive_type] = ACTIONS(2627),
    [anon_sym_enum] = ACTIONS(2627),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_union] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_else] = ACTIONS(2627),
    [anon_sym_switch] = ACTIONS(2627),
    [anon_sym_case] = ACTIONS(2627),
    [anon_sym_default] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_goto] = ACTIONS(2627),
    [anon_sym___try] = ACTIONS(2627),
    [anon_sym___leave] = ACTIONS(2627),
    [anon_sym_not] = ACTIONS(2627),
    [anon_sym_compl] = ACTIONS(2627),
    [anon_sym_DASH_DASH] = ACTIONS(2629),
    [anon_sym_PLUS_PLUS] = ACTIONS(2629),
    [anon_sym_sizeof] = ACTIONS(2627),
    [anon_sym___alignof__] = ACTIONS(2627),
    [anon_sym___alignof] = ACTIONS(2627),
    [anon_sym__alignof] = ACTIONS(2627),
    [anon_sym_alignof] = ACTIONS(2627),
    [anon_sym__Alignof] = ACTIONS(2627),
    [anon_sym_offsetof] = ACTIONS(2627),
    [anon_sym__Generic] = ACTIONS(2627),
    [anon_sym_asm] = ACTIONS(2627),
    [anon_sym___asm__] = ACTIONS(2627),
    [anon_sym___asm] = ACTIONS(2627),
    [sym_number_literal] = ACTIONS(2629),
    [anon_sym_L_SQUOTE] = ACTIONS(2629),
    [anon_sym_u_SQUOTE] = ACTIONS(2629),
    [anon_sym_U_SQUOTE] = ACTIONS(2629),
    [anon_sym_u8_SQUOTE] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2629),
    [anon_sym_L_DQUOTE] = ACTIONS(2629),
    [anon_sym_u_DQUOTE] = ACTIONS(2629),
    [anon_sym_U_DQUOTE] = ACTIONS(2629),
    [anon_sym_u8_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE] = ACTIONS(2629),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [anon_sym_NULL] = ACTIONS(2627),
    [anon_sym_nullptr] = ACTIONS(2627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2627),
    [anon_sym_decltype] = ACTIONS(2627),
    [anon_sym_explicit] = ACTIONS(2627),
    [anon_sym_typename] = ACTIONS(2627),
    [anon_sym_template] = ACTIONS(2627),
    [anon_sym_operator] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_delete] = ACTIONS(2627),
    [anon_sym_throw] = ACTIONS(2627),
    [anon_sym_namespace] = ACTIONS(2627),
    [anon_sym_static_assert] = ACTIONS(2627),
    [anon_sym_concept] = ACTIONS(2627),
    [anon_sym_co_return] = ACTIONS(2627),
    [anon_sym_co_yield] = ACTIONS(2627),
    [anon_sym_R_DQUOTE] = ACTIONS(2629),
    [anon_sym_LR_DQUOTE] = ACTIONS(2629),
    [anon_sym_uR_DQUOTE] = ACTIONS(2629),
    [anon_sym_UR_DQUOTE] = ACTIONS(2629),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2629),
    [anon_sym_co_await] = ACTIONS(2627),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_requires] = ACTIONS(2627),
    [sym_this] = ACTIONS(2627),
  },
  [243] = {
    [sym_identifier] = ACTIONS(2631),
    [aux_sym_preproc_include_token1] = ACTIONS(2631),
    [aux_sym_preproc_def_token1] = ACTIONS(2631),
    [aux_sym_preproc_if_token1] = ACTIONS(2631),
    [aux_sym_preproc_if_token2] = ACTIONS(2631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2631),
    [aux_sym_preproc_else_token1] = ACTIONS(2631),
    [aux_sym_preproc_elif_token1] = ACTIONS(2631),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2631),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2631),
    [sym_preproc_directive] = ACTIONS(2631),
    [anon_sym_LPAREN2] = ACTIONS(2633),
    [anon_sym_BANG] = ACTIONS(2633),
    [anon_sym_TILDE] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym___extension__] = ACTIONS(2631),
    [anon_sym_typedef] = ACTIONS(2631),
    [anon_sym_virtual] = ACTIONS(2631),
    [anon_sym_extern] = ACTIONS(2631),
    [anon_sym___attribute__] = ACTIONS(2631),
    [anon_sym___attribute] = ACTIONS(2631),
    [anon_sym_using] = ACTIONS(2631),
    [anon_sym_COLON_COLON] = ACTIONS(2633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2633),
    [anon_sym___declspec] = ACTIONS(2631),
    [anon_sym___based] = ACTIONS(2631),
    [anon_sym___cdecl] = ACTIONS(2631),
    [anon_sym___clrcall] = ACTIONS(2631),
    [anon_sym___stdcall] = ACTIONS(2631),
    [anon_sym___fastcall] = ACTIONS(2631),
    [anon_sym___thiscall] = ACTIONS(2631),
    [anon_sym___vectorcall] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_signed] = ACTIONS(2631),
    [anon_sym_unsigned] = ACTIONS(2631),
    [anon_sym_long] = ACTIONS(2631),
    [anon_sym_short] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2631),
    [anon_sym_static] = ACTIONS(2631),
    [anon_sym_register] = ACTIONS(2631),
    [anon_sym_inline] = ACTIONS(2631),
    [anon_sym___inline] = ACTIONS(2631),
    [anon_sym___inline__] = ACTIONS(2631),
    [anon_sym___forceinline] = ACTIONS(2631),
    [anon_sym_thread_local] = ACTIONS(2631),
    [anon_sym___thread] = ACTIONS(2631),
    [anon_sym_const] = ACTIONS(2631),
    [anon_sym_constexpr] = ACTIONS(2631),
    [anon_sym_volatile] = ACTIONS(2631),
    [anon_sym_restrict] = ACTIONS(2631),
    [anon_sym___restrict__] = ACTIONS(2631),
    [anon_sym__Atomic] = ACTIONS(2631),
    [anon_sym__Noreturn] = ACTIONS(2631),
    [anon_sym_noreturn] = ACTIONS(2631),
    [anon_sym__Nonnull] = ACTIONS(2631),
    [anon_sym_mutable] = ACTIONS(2631),
    [anon_sym_constinit] = ACTIONS(2631),
    [anon_sym_consteval] = ACTIONS(2631),
    [anon_sym_alignas] = ACTIONS(2631),
    [anon_sym__Alignas] = ACTIONS(2631),
    [sym_primitive_type] = ACTIONS(2631),
    [anon_sym_enum] = ACTIONS(2631),
    [anon_sym_class] = ACTIONS(2631),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_union] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_else] = ACTIONS(2631),
    [anon_sym_switch] = ACTIONS(2631),
    [anon_sym_case] = ACTIONS(2631),
    [anon_sym_default] = ACTIONS(2631),
    [anon_sym_while] = ACTIONS(2631),
    [anon_sym_do] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_goto] = ACTIONS(2631),
    [anon_sym___try] = ACTIONS(2631),
    [anon_sym___leave] = ACTIONS(2631),
    [anon_sym_not] = ACTIONS(2631),
    [anon_sym_compl] = ACTIONS(2631),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_sizeof] = ACTIONS(2631),
    [anon_sym___alignof__] = ACTIONS(2631),
    [anon_sym___alignof] = ACTIONS(2631),
    [anon_sym__alignof] = ACTIONS(2631),
    [anon_sym_alignof] = ACTIONS(2631),
    [anon_sym__Alignof] = ACTIONS(2631),
    [anon_sym_offsetof] = ACTIONS(2631),
    [anon_sym__Generic] = ACTIONS(2631),
    [anon_sym_asm] = ACTIONS(2631),
    [anon_sym___asm__] = ACTIONS(2631),
    [anon_sym___asm] = ACTIONS(2631),
    [sym_number_literal] = ACTIONS(2633),
    [anon_sym_L_SQUOTE] = ACTIONS(2633),
    [anon_sym_u_SQUOTE] = ACTIONS(2633),
    [anon_sym_U_SQUOTE] = ACTIONS(2633),
    [anon_sym_u8_SQUOTE] = ACTIONS(2633),
    [anon_sym_SQUOTE] = ACTIONS(2633),
    [anon_sym_L_DQUOTE] = ACTIONS(2633),
    [anon_sym_u_DQUOTE] = ACTIONS(2633),
    [anon_sym_U_DQUOTE] = ACTIONS(2633),
    [anon_sym_u8_DQUOTE] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(2633),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [anon_sym_NULL] = ACTIONS(2631),
    [anon_sym_nullptr] = ACTIONS(2631),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2631),
    [anon_sym_decltype] = ACTIONS(2631),
    [anon_sym_explicit] = ACTIONS(2631),
    [anon_sym_typename] = ACTIONS(2631),
    [anon_sym_template] = ACTIONS(2631),
    [anon_sym_operator] = ACTIONS(2631),
    [anon_sym_try] = ACTIONS(2631),
    [anon_sym_delete] = ACTIONS(2631),
    [anon_sym_throw] = ACTIONS(2631),
    [anon_sym_namespace] = ACTIONS(2631),
    [anon_sym_static_assert] = ACTIONS(2631),
    [anon_sym_concept] = ACTIONS(2631),
    [anon_sym_co_return] = ACTIONS(2631),
    [anon_sym_co_yield] = ACTIONS(2631),
    [anon_sym_R_DQUOTE] = ACTIONS(2633),
    [anon_sym_LR_DQUOTE] = ACTIONS(2633),
    [anon_sym_uR_DQUOTE] = ACTIONS(2633),
    [anon_sym_UR_DQUOTE] = ACTIONS(2633),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2633),
    [anon_sym_co_await] = ACTIONS(2631),
    [anon_sym_new] = ACTIONS(2631),
    [anon_sym_requires] = ACTIONS(2631),
    [sym_this] = ACTIONS(2631),
  },
  [244] = {
    [sym_identifier] = ACTIONS(2635),
    [aux_sym_preproc_include_token1] = ACTIONS(2635),
    [aux_sym_preproc_def_token1] = ACTIONS(2635),
    [aux_sym_preproc_if_token1] = ACTIONS(2635),
    [aux_sym_preproc_if_token2] = ACTIONS(2635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2635),
    [aux_sym_preproc_else_token1] = ACTIONS(2635),
    [aux_sym_preproc_elif_token1] = ACTIONS(2635),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2635),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2635),
    [sym_preproc_directive] = ACTIONS(2635),
    [anon_sym_LPAREN2] = ACTIONS(2637),
    [anon_sym_BANG] = ACTIONS(2637),
    [anon_sym_TILDE] = ACTIONS(2637),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2637),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_SEMI] = ACTIONS(2637),
    [anon_sym___extension__] = ACTIONS(2635),
    [anon_sym_typedef] = ACTIONS(2635),
    [anon_sym_virtual] = ACTIONS(2635),
    [anon_sym_extern] = ACTIONS(2635),
    [anon_sym___attribute__] = ACTIONS(2635),
    [anon_sym___attribute] = ACTIONS(2635),
    [anon_sym_using] = ACTIONS(2635),
    [anon_sym_COLON_COLON] = ACTIONS(2637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2637),
    [anon_sym___declspec] = ACTIONS(2635),
    [anon_sym___based] = ACTIONS(2635),
    [anon_sym___cdecl] = ACTIONS(2635),
    [anon_sym___clrcall] = ACTIONS(2635),
    [anon_sym___stdcall] = ACTIONS(2635),
    [anon_sym___fastcall] = ACTIONS(2635),
    [anon_sym___thiscall] = ACTIONS(2635),
    [anon_sym___vectorcall] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2637),
    [anon_sym_signed] = ACTIONS(2635),
    [anon_sym_unsigned] = ACTIONS(2635),
    [anon_sym_long] = ACTIONS(2635),
    [anon_sym_short] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(2635),
    [anon_sym_static] = ACTIONS(2635),
    [anon_sym_register] = ACTIONS(2635),
    [anon_sym_inline] = ACTIONS(2635),
    [anon_sym___inline] = ACTIONS(2635),
    [anon_sym___inline__] = ACTIONS(2635),
    [anon_sym___forceinline] = ACTIONS(2635),
    [anon_sym_thread_local] = ACTIONS(2635),
    [anon_sym___thread] = ACTIONS(2635),
    [anon_sym_const] = ACTIONS(2635),
    [anon_sym_constexpr] = ACTIONS(2635),
    [anon_sym_volatile] = ACTIONS(2635),
    [anon_sym_restrict] = ACTIONS(2635),
    [anon_sym___restrict__] = ACTIONS(2635),
    [anon_sym__Atomic] = ACTIONS(2635),
    [anon_sym__Noreturn] = ACTIONS(2635),
    [anon_sym_noreturn] = ACTIONS(2635),
    [anon_sym__Nonnull] = ACTIONS(2635),
    [anon_sym_mutable] = ACTIONS(2635),
    [anon_sym_constinit] = ACTIONS(2635),
    [anon_sym_consteval] = ACTIONS(2635),
    [anon_sym_alignas] = ACTIONS(2635),
    [anon_sym__Alignas] = ACTIONS(2635),
    [sym_primitive_type] = ACTIONS(2635),
    [anon_sym_enum] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(2635),
    [anon_sym_struct] = ACTIONS(2635),
    [anon_sym_union] = ACTIONS(2635),
    [anon_sym_if] = ACTIONS(2635),
    [anon_sym_else] = ACTIONS(2635),
    [anon_sym_switch] = ACTIONS(2635),
    [anon_sym_case] = ACTIONS(2635),
    [anon_sym_default] = ACTIONS(2635),
    [anon_sym_while] = ACTIONS(2635),
    [anon_sym_do] = ACTIONS(2635),
    [anon_sym_for] = ACTIONS(2635),
    [anon_sym_return] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_continue] = ACTIONS(2635),
    [anon_sym_goto] = ACTIONS(2635),
    [anon_sym___try] = ACTIONS(2635),
    [anon_sym___leave] = ACTIONS(2635),
    [anon_sym_not] = ACTIONS(2635),
    [anon_sym_compl] = ACTIONS(2635),
    [anon_sym_DASH_DASH] = ACTIONS(2637),
    [anon_sym_PLUS_PLUS] = ACTIONS(2637),
    [anon_sym_sizeof] = ACTIONS(2635),
    [anon_sym___alignof__] = ACTIONS(2635),
    [anon_sym___alignof] = ACTIONS(2635),
    [anon_sym__alignof] = ACTIONS(2635),
    [anon_sym_alignof] = ACTIONS(2635),
    [anon_sym__Alignof] = ACTIONS(2635),
    [anon_sym_offsetof] = ACTIONS(2635),
    [anon_sym__Generic] = ACTIONS(2635),
    [anon_sym_asm] = ACTIONS(2635),
    [anon_sym___asm__] = ACTIONS(2635),
    [anon_sym___asm] = ACTIONS(2635),
    [sym_number_literal] = ACTIONS(2637),
    [anon_sym_L_SQUOTE] = ACTIONS(2637),
    [anon_sym_u_SQUOTE] = ACTIONS(2637),
    [anon_sym_U_SQUOTE] = ACTIONS(2637),
    [anon_sym_u8_SQUOTE] = ACTIONS(2637),
    [anon_sym_SQUOTE] = ACTIONS(2637),
    [anon_sym_L_DQUOTE] = ACTIONS(2637),
    [anon_sym_u_DQUOTE] = ACTIONS(2637),
    [anon_sym_U_DQUOTE] = ACTIONS(2637),
    [anon_sym_u8_DQUOTE] = ACTIONS(2637),
    [anon_sym_DQUOTE] = ACTIONS(2637),
    [sym_true] = ACTIONS(2635),
    [sym_false] = ACTIONS(2635),
    [anon_sym_NULL] = ACTIONS(2635),
    [anon_sym_nullptr] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2635),
    [anon_sym_decltype] = ACTIONS(2635),
    [anon_sym_explicit] = ACTIONS(2635),
    [anon_sym_typename] = ACTIONS(2635),
    [anon_sym_template] = ACTIONS(2635),
    [anon_sym_operator] = ACTIONS(2635),
    [anon_sym_try] = ACTIONS(2635),
    [anon_sym_delete] = ACTIONS(2635),
    [anon_sym_throw] = ACTIONS(2635),
    [anon_sym_namespace] = ACTIONS(2635),
    [anon_sym_static_assert] = ACTIONS(2635),
    [anon_sym_concept] = ACTIONS(2635),
    [anon_sym_co_return] = ACTIONS(2635),
    [anon_sym_co_yield] = ACTIONS(2635),
    [anon_sym_R_DQUOTE] = ACTIONS(2637),
    [anon_sym_LR_DQUOTE] = ACTIONS(2637),
    [anon_sym_uR_DQUOTE] = ACTIONS(2637),
    [anon_sym_UR_DQUOTE] = ACTIONS(2637),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2637),
    [anon_sym_co_await] = ACTIONS(2635),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2635),
    [sym_this] = ACTIONS(2635),
  },
  [245] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [aux_sym_preproc_else_token1] = ACTIONS(2639),
    [aux_sym_preproc_elif_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym___attribute] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym__Nonnull] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym__Alignas] = ACTIONS(2639),
    [sym_primitive_type] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [anon_sym___asm] = ACTIONS(2639),
    [sym_number_literal] = ACTIONS(2641),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [246] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym___attribute] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym__Nonnull] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym__Alignas] = ACTIONS(2643),
    [sym_primitive_type] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [anon_sym___asm] = ACTIONS(2643),
    [sym_number_literal] = ACTIONS(2645),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [247] = {
    [sym_identifier] = ACTIONS(2647),
    [aux_sym_preproc_include_token1] = ACTIONS(2647),
    [aux_sym_preproc_def_token1] = ACTIONS(2647),
    [aux_sym_preproc_if_token1] = ACTIONS(2647),
    [aux_sym_preproc_if_token2] = ACTIONS(2647),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2647),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2647),
    [aux_sym_preproc_else_token1] = ACTIONS(2647),
    [aux_sym_preproc_elif_token1] = ACTIONS(2647),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2647),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2647),
    [sym_preproc_directive] = ACTIONS(2647),
    [anon_sym_LPAREN2] = ACTIONS(2649),
    [anon_sym_BANG] = ACTIONS(2649),
    [anon_sym_TILDE] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2649),
    [anon_sym_AMP_AMP] = ACTIONS(2649),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_SEMI] = ACTIONS(2649),
    [anon_sym___extension__] = ACTIONS(2647),
    [anon_sym_typedef] = ACTIONS(2647),
    [anon_sym_virtual] = ACTIONS(2647),
    [anon_sym_extern] = ACTIONS(2647),
    [anon_sym___attribute__] = ACTIONS(2647),
    [anon_sym___attribute] = ACTIONS(2647),
    [anon_sym_using] = ACTIONS(2647),
    [anon_sym_COLON_COLON] = ACTIONS(2649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2649),
    [anon_sym___declspec] = ACTIONS(2647),
    [anon_sym___based] = ACTIONS(2647),
    [anon_sym___cdecl] = ACTIONS(2647),
    [anon_sym___clrcall] = ACTIONS(2647),
    [anon_sym___stdcall] = ACTIONS(2647),
    [anon_sym___fastcall] = ACTIONS(2647),
    [anon_sym___thiscall] = ACTIONS(2647),
    [anon_sym___vectorcall] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2649),
    [anon_sym_signed] = ACTIONS(2647),
    [anon_sym_unsigned] = ACTIONS(2647),
    [anon_sym_long] = ACTIONS(2647),
    [anon_sym_short] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2647),
    [anon_sym_static] = ACTIONS(2647),
    [anon_sym_register] = ACTIONS(2647),
    [anon_sym_inline] = ACTIONS(2647),
    [anon_sym___inline] = ACTIONS(2647),
    [anon_sym___inline__] = ACTIONS(2647),
    [anon_sym___forceinline] = ACTIONS(2647),
    [anon_sym_thread_local] = ACTIONS(2647),
    [anon_sym___thread] = ACTIONS(2647),
    [anon_sym_const] = ACTIONS(2647),
    [anon_sym_constexpr] = ACTIONS(2647),
    [anon_sym_volatile] = ACTIONS(2647),
    [anon_sym_restrict] = ACTIONS(2647),
    [anon_sym___restrict__] = ACTIONS(2647),
    [anon_sym__Atomic] = ACTIONS(2647),
    [anon_sym__Noreturn] = ACTIONS(2647),
    [anon_sym_noreturn] = ACTIONS(2647),
    [anon_sym__Nonnull] = ACTIONS(2647),
    [anon_sym_mutable] = ACTIONS(2647),
    [anon_sym_constinit] = ACTIONS(2647),
    [anon_sym_consteval] = ACTIONS(2647),
    [anon_sym_alignas] = ACTIONS(2647),
    [anon_sym__Alignas] = ACTIONS(2647),
    [sym_primitive_type] = ACTIONS(2647),
    [anon_sym_enum] = ACTIONS(2647),
    [anon_sym_class] = ACTIONS(2647),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_union] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_else] = ACTIONS(2647),
    [anon_sym_switch] = ACTIONS(2647),
    [anon_sym_case] = ACTIONS(2647),
    [anon_sym_default] = ACTIONS(2647),
    [anon_sym_while] = ACTIONS(2647),
    [anon_sym_do] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_return] = ACTIONS(2647),
    [anon_sym_break] = ACTIONS(2647),
    [anon_sym_continue] = ACTIONS(2647),
    [anon_sym_goto] = ACTIONS(2647),
    [anon_sym___try] = ACTIONS(2647),
    [anon_sym___leave] = ACTIONS(2647),
    [anon_sym_not] = ACTIONS(2647),
    [anon_sym_compl] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2649),
    [anon_sym_PLUS_PLUS] = ACTIONS(2649),
    [anon_sym_sizeof] = ACTIONS(2647),
    [anon_sym___alignof__] = ACTIONS(2647),
    [anon_sym___alignof] = ACTIONS(2647),
    [anon_sym__alignof] = ACTIONS(2647),
    [anon_sym_alignof] = ACTIONS(2647),
    [anon_sym__Alignof] = ACTIONS(2647),
    [anon_sym_offsetof] = ACTIONS(2647),
    [anon_sym__Generic] = ACTIONS(2647),
    [anon_sym_asm] = ACTIONS(2647),
    [anon_sym___asm__] = ACTIONS(2647),
    [anon_sym___asm] = ACTIONS(2647),
    [sym_number_literal] = ACTIONS(2649),
    [anon_sym_L_SQUOTE] = ACTIONS(2649),
    [anon_sym_u_SQUOTE] = ACTIONS(2649),
    [anon_sym_U_SQUOTE] = ACTIONS(2649),
    [anon_sym_u8_SQUOTE] = ACTIONS(2649),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_L_DQUOTE] = ACTIONS(2649),
    [anon_sym_u_DQUOTE] = ACTIONS(2649),
    [anon_sym_U_DQUOTE] = ACTIONS(2649),
    [anon_sym_u8_DQUOTE] = ACTIONS(2649),
    [anon_sym_DQUOTE] = ACTIONS(2649),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [anon_sym_NULL] = ACTIONS(2647),
    [anon_sym_nullptr] = ACTIONS(2647),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2647),
    [anon_sym_decltype] = ACTIONS(2647),
    [anon_sym_explicit] = ACTIONS(2647),
    [anon_sym_typename] = ACTIONS(2647),
    [anon_sym_template] = ACTIONS(2647),
    [anon_sym_operator] = ACTIONS(2647),
    [anon_sym_try] = ACTIONS(2647),
    [anon_sym_delete] = ACTIONS(2647),
    [anon_sym_throw] = ACTIONS(2647),
    [anon_sym_namespace] = ACTIONS(2647),
    [anon_sym_static_assert] = ACTIONS(2647),
    [anon_sym_concept] = ACTIONS(2647),
    [anon_sym_co_return] = ACTIONS(2647),
    [anon_sym_co_yield] = ACTIONS(2647),
    [anon_sym_R_DQUOTE] = ACTIONS(2649),
    [anon_sym_LR_DQUOTE] = ACTIONS(2649),
    [anon_sym_uR_DQUOTE] = ACTIONS(2649),
    [anon_sym_UR_DQUOTE] = ACTIONS(2649),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2649),
    [anon_sym_co_await] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(2647),
    [anon_sym_requires] = ACTIONS(2647),
    [sym_this] = ACTIONS(2647),
  },
  [248] = {
    [sym_identifier] = ACTIONS(2651),
    [aux_sym_preproc_include_token1] = ACTIONS(2651),
    [aux_sym_preproc_def_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token2] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2651),
    [aux_sym_preproc_else_token1] = ACTIONS(2651),
    [aux_sym_preproc_elif_token1] = ACTIONS(2651),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2651),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2651),
    [sym_preproc_directive] = ACTIONS(2651),
    [anon_sym_LPAREN2] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym___extension__] = ACTIONS(2651),
    [anon_sym_typedef] = ACTIONS(2651),
    [anon_sym_virtual] = ACTIONS(2651),
    [anon_sym_extern] = ACTIONS(2651),
    [anon_sym___attribute__] = ACTIONS(2651),
    [anon_sym___attribute] = ACTIONS(2651),
    [anon_sym_using] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2653),
    [anon_sym___declspec] = ACTIONS(2651),
    [anon_sym___based] = ACTIONS(2651),
    [anon_sym___cdecl] = ACTIONS(2651),
    [anon_sym___clrcall] = ACTIONS(2651),
    [anon_sym___stdcall] = ACTIONS(2651),
    [anon_sym___fastcall] = ACTIONS(2651),
    [anon_sym___thiscall] = ACTIONS(2651),
    [anon_sym___vectorcall] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2653),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2651),
    [anon_sym_register] = ACTIONS(2651),
    [anon_sym_inline] = ACTIONS(2651),
    [anon_sym___inline] = ACTIONS(2651),
    [anon_sym___inline__] = ACTIONS(2651),
    [anon_sym___forceinline] = ACTIONS(2651),
    [anon_sym_thread_local] = ACTIONS(2651),
    [anon_sym___thread] = ACTIONS(2651),
    [anon_sym_const] = ACTIONS(2651),
    [anon_sym_constexpr] = ACTIONS(2651),
    [anon_sym_volatile] = ACTIONS(2651),
    [anon_sym_restrict] = ACTIONS(2651),
    [anon_sym___restrict__] = ACTIONS(2651),
    [anon_sym__Atomic] = ACTIONS(2651),
    [anon_sym__Noreturn] = ACTIONS(2651),
    [anon_sym_noreturn] = ACTIONS(2651),
    [anon_sym__Nonnull] = ACTIONS(2651),
    [anon_sym_mutable] = ACTIONS(2651),
    [anon_sym_constinit] = ACTIONS(2651),
    [anon_sym_consteval] = ACTIONS(2651),
    [anon_sym_alignas] = ACTIONS(2651),
    [anon_sym__Alignas] = ACTIONS(2651),
    [sym_primitive_type] = ACTIONS(2651),
    [anon_sym_enum] = ACTIONS(2651),
    [anon_sym_class] = ACTIONS(2651),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_union] = ACTIONS(2651),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_else] = ACTIONS(2651),
    [anon_sym_switch] = ACTIONS(2651),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_default] = ACTIONS(2651),
    [anon_sym_while] = ACTIONS(2651),
    [anon_sym_do] = ACTIONS(2651),
    [anon_sym_for] = ACTIONS(2651),
    [anon_sym_return] = ACTIONS(2651),
    [anon_sym_break] = ACTIONS(2651),
    [anon_sym_continue] = ACTIONS(2651),
    [anon_sym_goto] = ACTIONS(2651),
    [anon_sym___try] = ACTIONS(2651),
    [anon_sym___leave] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2651),
    [anon_sym_compl] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2653),
    [anon_sym_sizeof] = ACTIONS(2651),
    [anon_sym___alignof__] = ACTIONS(2651),
    [anon_sym___alignof] = ACTIONS(2651),
    [anon_sym__alignof] = ACTIONS(2651),
    [anon_sym_alignof] = ACTIONS(2651),
    [anon_sym__Alignof] = ACTIONS(2651),
    [anon_sym_offsetof] = ACTIONS(2651),
    [anon_sym__Generic] = ACTIONS(2651),
    [anon_sym_asm] = ACTIONS(2651),
    [anon_sym___asm__] = ACTIONS(2651),
    [anon_sym___asm] = ACTIONS(2651),
    [sym_number_literal] = ACTIONS(2653),
    [anon_sym_L_SQUOTE] = ACTIONS(2653),
    [anon_sym_u_SQUOTE] = ACTIONS(2653),
    [anon_sym_U_SQUOTE] = ACTIONS(2653),
    [anon_sym_u8_SQUOTE] = ACTIONS(2653),
    [anon_sym_SQUOTE] = ACTIONS(2653),
    [anon_sym_L_DQUOTE] = ACTIONS(2653),
    [anon_sym_u_DQUOTE] = ACTIONS(2653),
    [anon_sym_U_DQUOTE] = ACTIONS(2653),
    [anon_sym_u8_DQUOTE] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(2653),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [anon_sym_NULL] = ACTIONS(2651),
    [anon_sym_nullptr] = ACTIONS(2651),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2651),
    [anon_sym_decltype] = ACTIONS(2651),
    [anon_sym_explicit] = ACTIONS(2651),
    [anon_sym_typename] = ACTIONS(2651),
    [anon_sym_template] = ACTIONS(2651),
    [anon_sym_operator] = ACTIONS(2651),
    [anon_sym_try] = ACTIONS(2651),
    [anon_sym_delete] = ACTIONS(2651),
    [anon_sym_throw] = ACTIONS(2651),
    [anon_sym_namespace] = ACTIONS(2651),
    [anon_sym_static_assert] = ACTIONS(2651),
    [anon_sym_concept] = ACTIONS(2651),
    [anon_sym_co_return] = ACTIONS(2651),
    [anon_sym_co_yield] = ACTIONS(2651),
    [anon_sym_R_DQUOTE] = ACTIONS(2653),
    [anon_sym_LR_DQUOTE] = ACTIONS(2653),
    [anon_sym_uR_DQUOTE] = ACTIONS(2653),
    [anon_sym_UR_DQUOTE] = ACTIONS(2653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2653),
    [anon_sym_co_await] = ACTIONS(2651),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_requires] = ACTIONS(2651),
    [sym_this] = ACTIONS(2651),
  },
  [249] = {
    [sym_identifier] = ACTIONS(2655),
    [aux_sym_preproc_include_token1] = ACTIONS(2655),
    [aux_sym_preproc_def_token1] = ACTIONS(2655),
    [aux_sym_preproc_if_token1] = ACTIONS(2655),
    [aux_sym_preproc_if_token2] = ACTIONS(2655),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2655),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2655),
    [aux_sym_preproc_else_token1] = ACTIONS(2655),
    [aux_sym_preproc_elif_token1] = ACTIONS(2655),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2655),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2655),
    [sym_preproc_directive] = ACTIONS(2655),
    [anon_sym_LPAREN2] = ACTIONS(2657),
    [anon_sym_BANG] = ACTIONS(2657),
    [anon_sym_TILDE] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_AMP_AMP] = ACTIONS(2657),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym___extension__] = ACTIONS(2655),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_virtual] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym___attribute__] = ACTIONS(2655),
    [anon_sym___attribute] = ACTIONS(2655),
    [anon_sym_using] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2657),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2657),
    [anon_sym___declspec] = ACTIONS(2655),
    [anon_sym___based] = ACTIONS(2655),
    [anon_sym___cdecl] = ACTIONS(2655),
    [anon_sym___clrcall] = ACTIONS(2655),
    [anon_sym___stdcall] = ACTIONS(2655),
    [anon_sym___fastcall] = ACTIONS(2655),
    [anon_sym___thiscall] = ACTIONS(2655),
    [anon_sym___vectorcall] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_signed] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2655),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym___inline] = ACTIONS(2655),
    [anon_sym___inline__] = ACTIONS(2655),
    [anon_sym___forceinline] = ACTIONS(2655),
    [anon_sym_thread_local] = ACTIONS(2655),
    [anon_sym___thread] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym___restrict__] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym__Noreturn] = ACTIONS(2655),
    [anon_sym_noreturn] = ACTIONS(2655),
    [anon_sym__Nonnull] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_constinit] = ACTIONS(2655),
    [anon_sym_consteval] = ACTIONS(2655),
    [anon_sym_alignas] = ACTIONS(2655),
    [anon_sym__Alignas] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_class] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_else] = ACTIONS(2655),
    [anon_sym_switch] = ACTIONS(2655),
    [anon_sym_case] = ACTIONS(2655),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym___try] = ACTIONS(2655),
    [anon_sym___leave] = ACTIONS(2655),
    [anon_sym_not] = ACTIONS(2655),
    [anon_sym_compl] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(2657),
    [anon_sym_sizeof] = ACTIONS(2655),
    [anon_sym___alignof__] = ACTIONS(2655),
    [anon_sym___alignof] = ACTIONS(2655),
    [anon_sym__alignof] = ACTIONS(2655),
    [anon_sym_alignof] = ACTIONS(2655),
    [anon_sym__Alignof] = ACTIONS(2655),
    [anon_sym_offsetof] = ACTIONS(2655),
    [anon_sym__Generic] = ACTIONS(2655),
    [anon_sym_asm] = ACTIONS(2655),
    [anon_sym___asm__] = ACTIONS(2655),
    [anon_sym___asm] = ACTIONS(2655),
    [sym_number_literal] = ACTIONS(2657),
    [anon_sym_L_SQUOTE] = ACTIONS(2657),
    [anon_sym_u_SQUOTE] = ACTIONS(2657),
    [anon_sym_U_SQUOTE] = ACTIONS(2657),
    [anon_sym_u8_SQUOTE] = ACTIONS(2657),
    [anon_sym_SQUOTE] = ACTIONS(2657),
    [anon_sym_L_DQUOTE] = ACTIONS(2657),
    [anon_sym_u_DQUOTE] = ACTIONS(2657),
    [anon_sym_U_DQUOTE] = ACTIONS(2657),
    [anon_sym_u8_DQUOTE] = ACTIONS(2657),
    [anon_sym_DQUOTE] = ACTIONS(2657),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [anon_sym_NULL] = ACTIONS(2655),
    [anon_sym_nullptr] = ACTIONS(2655),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_decltype] = ACTIONS(2655),
    [anon_sym_explicit] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_template] = ACTIONS(2655),
    [anon_sym_operator] = ACTIONS(2655),
    [anon_sym_try] = ACTIONS(2655),
    [anon_sym_delete] = ACTIONS(2655),
    [anon_sym_throw] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_static_assert] = ACTIONS(2655),
    [anon_sym_concept] = ACTIONS(2655),
    [anon_sym_co_return] = ACTIONS(2655),
    [anon_sym_co_yield] = ACTIONS(2655),
    [anon_sym_R_DQUOTE] = ACTIONS(2657),
    [anon_sym_LR_DQUOTE] = ACTIONS(2657),
    [anon_sym_uR_DQUOTE] = ACTIONS(2657),
    [anon_sym_UR_DQUOTE] = ACTIONS(2657),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2657),
    [anon_sym_co_await] = ACTIONS(2655),
    [anon_sym_new] = ACTIONS(2655),
    [anon_sym_requires] = ACTIONS(2655),
    [sym_this] = ACTIONS(2655),
  },
  [250] = {
    [sym_identifier] = ACTIONS(2659),
    [aux_sym_preproc_include_token1] = ACTIONS(2659),
    [aux_sym_preproc_def_token1] = ACTIONS(2659),
    [aux_sym_preproc_if_token1] = ACTIONS(2659),
    [aux_sym_preproc_if_token2] = ACTIONS(2659),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2659),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2659),
    [aux_sym_preproc_else_token1] = ACTIONS(2659),
    [aux_sym_preproc_elif_token1] = ACTIONS(2659),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2659),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2659),
    [sym_preproc_directive] = ACTIONS(2659),
    [anon_sym_LPAREN2] = ACTIONS(2661),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym___extension__] = ACTIONS(2659),
    [anon_sym_typedef] = ACTIONS(2659),
    [anon_sym_virtual] = ACTIONS(2659),
    [anon_sym_extern] = ACTIONS(2659),
    [anon_sym___attribute__] = ACTIONS(2659),
    [anon_sym___attribute] = ACTIONS(2659),
    [anon_sym_using] = ACTIONS(2659),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2661),
    [anon_sym___declspec] = ACTIONS(2659),
    [anon_sym___based] = ACTIONS(2659),
    [anon_sym___cdecl] = ACTIONS(2659),
    [anon_sym___clrcall] = ACTIONS(2659),
    [anon_sym___stdcall] = ACTIONS(2659),
    [anon_sym___fastcall] = ACTIONS(2659),
    [anon_sym___thiscall] = ACTIONS(2659),
    [anon_sym___vectorcall] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_signed] = ACTIONS(2659),
    [anon_sym_unsigned] = ACTIONS(2659),
    [anon_sym_long] = ACTIONS(2659),
    [anon_sym_short] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2659),
    [anon_sym_register] = ACTIONS(2659),
    [anon_sym_inline] = ACTIONS(2659),
    [anon_sym___inline] = ACTIONS(2659),
    [anon_sym___inline__] = ACTIONS(2659),
    [anon_sym___forceinline] = ACTIONS(2659),
    [anon_sym_thread_local] = ACTIONS(2659),
    [anon_sym___thread] = ACTIONS(2659),
    [anon_sym_const] = ACTIONS(2659),
    [anon_sym_constexpr] = ACTIONS(2659),
    [anon_sym_volatile] = ACTIONS(2659),
    [anon_sym_restrict] = ACTIONS(2659),
    [anon_sym___restrict__] = ACTIONS(2659),
    [anon_sym__Atomic] = ACTIONS(2659),
    [anon_sym__Noreturn] = ACTIONS(2659),
    [anon_sym_noreturn] = ACTIONS(2659),
    [anon_sym__Nonnull] = ACTIONS(2659),
    [anon_sym_mutable] = ACTIONS(2659),
    [anon_sym_constinit] = ACTIONS(2659),
    [anon_sym_consteval] = ACTIONS(2659),
    [anon_sym_alignas] = ACTIONS(2659),
    [anon_sym__Alignas] = ACTIONS(2659),
    [sym_primitive_type] = ACTIONS(2659),
    [anon_sym_enum] = ACTIONS(2659),
    [anon_sym_class] = ACTIONS(2659),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_union] = ACTIONS(2659),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_else] = ACTIONS(2659),
    [anon_sym_switch] = ACTIONS(2659),
    [anon_sym_case] = ACTIONS(2659),
    [anon_sym_default] = ACTIONS(2659),
    [anon_sym_while] = ACTIONS(2659),
    [anon_sym_do] = ACTIONS(2659),
    [anon_sym_for] = ACTIONS(2659),
    [anon_sym_return] = ACTIONS(2659),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_continue] = ACTIONS(2659),
    [anon_sym_goto] = ACTIONS(2659),
    [anon_sym___try] = ACTIONS(2659),
    [anon_sym___leave] = ACTIONS(2659),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_compl] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2661),
    [anon_sym_PLUS_PLUS] = ACTIONS(2661),
    [anon_sym_sizeof] = ACTIONS(2659),
    [anon_sym___alignof__] = ACTIONS(2659),
    [anon_sym___alignof] = ACTIONS(2659),
    [anon_sym__alignof] = ACTIONS(2659),
    [anon_sym_alignof] = ACTIONS(2659),
    [anon_sym__Alignof] = ACTIONS(2659),
    [anon_sym_offsetof] = ACTIONS(2659),
    [anon_sym__Generic] = ACTIONS(2659),
    [anon_sym_asm] = ACTIONS(2659),
    [anon_sym___asm__] = ACTIONS(2659),
    [anon_sym___asm] = ACTIONS(2659),
    [sym_number_literal] = ACTIONS(2661),
    [anon_sym_L_SQUOTE] = ACTIONS(2661),
    [anon_sym_u_SQUOTE] = ACTIONS(2661),
    [anon_sym_U_SQUOTE] = ACTIONS(2661),
    [anon_sym_u8_SQUOTE] = ACTIONS(2661),
    [anon_sym_SQUOTE] = ACTIONS(2661),
    [anon_sym_L_DQUOTE] = ACTIONS(2661),
    [anon_sym_u_DQUOTE] = ACTIONS(2661),
    [anon_sym_U_DQUOTE] = ACTIONS(2661),
    [anon_sym_u8_DQUOTE] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [anon_sym_NULL] = ACTIONS(2659),
    [anon_sym_nullptr] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2659),
    [anon_sym_decltype] = ACTIONS(2659),
    [anon_sym_explicit] = ACTIONS(2659),
    [anon_sym_typename] = ACTIONS(2659),
    [anon_sym_template] = ACTIONS(2659),
    [anon_sym_operator] = ACTIONS(2659),
    [anon_sym_try] = ACTIONS(2659),
    [anon_sym_delete] = ACTIONS(2659),
    [anon_sym_throw] = ACTIONS(2659),
    [anon_sym_namespace] = ACTIONS(2659),
    [anon_sym_static_assert] = ACTIONS(2659),
    [anon_sym_concept] = ACTIONS(2659),
    [anon_sym_co_return] = ACTIONS(2659),
    [anon_sym_co_yield] = ACTIONS(2659),
    [anon_sym_R_DQUOTE] = ACTIONS(2661),
    [anon_sym_LR_DQUOTE] = ACTIONS(2661),
    [anon_sym_uR_DQUOTE] = ACTIONS(2661),
    [anon_sym_UR_DQUOTE] = ACTIONS(2661),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2661),
    [anon_sym_co_await] = ACTIONS(2659),
    [anon_sym_new] = ACTIONS(2659),
    [anon_sym_requires] = ACTIONS(2659),
    [sym_this] = ACTIONS(2659),
  },
  [251] = {
    [sym_else_clause] = STATE(344),
    [ts_builtin_sym_end] = ACTIONS(2625),
    [sym_identifier] = ACTIONS(2623),
    [aux_sym_preproc_include_token1] = ACTIONS(2623),
    [aux_sym_preproc_def_token1] = ACTIONS(2623),
    [aux_sym_preproc_if_token1] = ACTIONS(2623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2623),
    [sym_preproc_directive] = ACTIONS(2623),
    [anon_sym_LPAREN2] = ACTIONS(2625),
    [anon_sym_BANG] = ACTIONS(2625),
    [anon_sym_TILDE] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_AMP_AMP] = ACTIONS(2625),
    [anon_sym_AMP] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2625),
    [anon_sym___extension__] = ACTIONS(2623),
    [anon_sym_typedef] = ACTIONS(2623),
    [anon_sym_virtual] = ACTIONS(2623),
    [anon_sym_extern] = ACTIONS(2623),
    [anon_sym___attribute__] = ACTIONS(2623),
    [anon_sym___attribute] = ACTIONS(2623),
    [anon_sym_using] = ACTIONS(2623),
    [anon_sym_COLON_COLON] = ACTIONS(2625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2625),
    [anon_sym___declspec] = ACTIONS(2623),
    [anon_sym___based] = ACTIONS(2623),
    [anon_sym___cdecl] = ACTIONS(2623),
    [anon_sym___clrcall] = ACTIONS(2623),
    [anon_sym___stdcall] = ACTIONS(2623),
    [anon_sym___fastcall] = ACTIONS(2623),
    [anon_sym___thiscall] = ACTIONS(2623),
    [anon_sym___vectorcall] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2625),
    [anon_sym_signed] = ACTIONS(2623),
    [anon_sym_unsigned] = ACTIONS(2623),
    [anon_sym_long] = ACTIONS(2623),
    [anon_sym_short] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_static] = ACTIONS(2623),
    [anon_sym_register] = ACTIONS(2623),
    [anon_sym_inline] = ACTIONS(2623),
    [anon_sym___inline] = ACTIONS(2623),
    [anon_sym___inline__] = ACTIONS(2623),
    [anon_sym___forceinline] = ACTIONS(2623),
    [anon_sym_thread_local] = ACTIONS(2623),
    [anon_sym___thread] = ACTIONS(2623),
    [anon_sym_const] = ACTIONS(2623),
    [anon_sym_constexpr] = ACTIONS(2623),
    [anon_sym_volatile] = ACTIONS(2623),
    [anon_sym_restrict] = ACTIONS(2623),
    [anon_sym___restrict__] = ACTIONS(2623),
    [anon_sym__Atomic] = ACTIONS(2623),
    [anon_sym__Noreturn] = ACTIONS(2623),
    [anon_sym_noreturn] = ACTIONS(2623),
    [anon_sym__Nonnull] = ACTIONS(2623),
    [anon_sym_mutable] = ACTIONS(2623),
    [anon_sym_constinit] = ACTIONS(2623),
    [anon_sym_consteval] = ACTIONS(2623),
    [anon_sym_alignas] = ACTIONS(2623),
    [anon_sym__Alignas] = ACTIONS(2623),
    [sym_primitive_type] = ACTIONS(2623),
    [anon_sym_enum] = ACTIONS(2623),
    [anon_sym_class] = ACTIONS(2623),
    [anon_sym_struct] = ACTIONS(2623),
    [anon_sym_union] = ACTIONS(2623),
    [anon_sym_if] = ACTIONS(2623),
    [anon_sym_else] = ACTIONS(2663),
    [anon_sym_switch] = ACTIONS(2623),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2623),
    [anon_sym_while] = ACTIONS(2623),
    [anon_sym_do] = ACTIONS(2623),
    [anon_sym_for] = ACTIONS(2623),
    [anon_sym_return] = ACTIONS(2623),
    [anon_sym_break] = ACTIONS(2623),
    [anon_sym_continue] = ACTIONS(2623),
    [anon_sym_goto] = ACTIONS(2623),
    [anon_sym___try] = ACTIONS(2623),
    [anon_sym___leave] = ACTIONS(2623),
    [anon_sym_not] = ACTIONS(2623),
    [anon_sym_compl] = ACTIONS(2623),
    [anon_sym_DASH_DASH] = ACTIONS(2625),
    [anon_sym_PLUS_PLUS] = ACTIONS(2625),
    [anon_sym_sizeof] = ACTIONS(2623),
    [anon_sym___alignof__] = ACTIONS(2623),
    [anon_sym___alignof] = ACTIONS(2623),
    [anon_sym__alignof] = ACTIONS(2623),
    [anon_sym_alignof] = ACTIONS(2623),
    [anon_sym__Alignof] = ACTIONS(2623),
    [anon_sym_offsetof] = ACTIONS(2623),
    [anon_sym__Generic] = ACTIONS(2623),
    [anon_sym_asm] = ACTIONS(2623),
    [anon_sym___asm__] = ACTIONS(2623),
    [anon_sym___asm] = ACTIONS(2623),
    [sym_number_literal] = ACTIONS(2625),
    [anon_sym_L_SQUOTE] = ACTIONS(2625),
    [anon_sym_u_SQUOTE] = ACTIONS(2625),
    [anon_sym_U_SQUOTE] = ACTIONS(2625),
    [anon_sym_u8_SQUOTE] = ACTIONS(2625),
    [anon_sym_SQUOTE] = ACTIONS(2625),
    [anon_sym_L_DQUOTE] = ACTIONS(2625),
    [anon_sym_u_DQUOTE] = ACTIONS(2625),
    [anon_sym_U_DQUOTE] = ACTIONS(2625),
    [anon_sym_u8_DQUOTE] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(2625),
    [sym_true] = ACTIONS(2623),
    [sym_false] = ACTIONS(2623),
    [anon_sym_NULL] = ACTIONS(2623),
    [anon_sym_nullptr] = ACTIONS(2623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2623),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_explicit] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2623),
    [anon_sym_export] = ACTIONS(2623),
    [anon_sym_module] = ACTIONS(2623),
    [anon_sym_import] = ACTIONS(2623),
    [anon_sym_template] = ACTIONS(2623),
    [anon_sym_operator] = ACTIONS(2623),
    [anon_sym_try] = ACTIONS(2623),
    [anon_sym_delete] = ACTIONS(2623),
    [anon_sym_throw] = ACTIONS(2623),
    [anon_sym_namespace] = ACTIONS(2623),
    [anon_sym_static_assert] = ACTIONS(2623),
    [anon_sym_concept] = ACTIONS(2623),
    [anon_sym_co_return] = ACTIONS(2623),
    [anon_sym_co_yield] = ACTIONS(2623),
    [anon_sym_R_DQUOTE] = ACTIONS(2625),
    [anon_sym_LR_DQUOTE] = ACTIONS(2625),
    [anon_sym_uR_DQUOTE] = ACTIONS(2625),
    [anon_sym_UR_DQUOTE] = ACTIONS(2625),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2625),
    [anon_sym_co_await] = ACTIONS(2623),
    [anon_sym_new] = ACTIONS(2623),
    [anon_sym_requires] = ACTIONS(2623),
    [sym_this] = ACTIONS(2623),
  },
  [252] = {
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token2] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [aux_sym_preproc_else_token1] = ACTIONS(2665),
    [aux_sym_preproc_elif_token1] = ACTIONS(2665),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym___attribute] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym__Nonnull] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym__Alignas] = ACTIONS(2665),
    [sym_primitive_type] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [anon_sym___asm] = ACTIONS(2665),
    [sym_number_literal] = ACTIONS(2667),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [253] = {
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token2] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [aux_sym_preproc_else_token1] = ACTIONS(2669),
    [aux_sym_preproc_elif_token1] = ACTIONS(2669),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym___attribute] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym__Nonnull] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym__Alignas] = ACTIONS(2669),
    [sym_primitive_type] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [anon_sym___asm] = ACTIONS(2669),
    [sym_number_literal] = ACTIONS(2671),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [254] = {
    [sym_identifier] = ACTIONS(2673),
    [aux_sym_preproc_include_token1] = ACTIONS(2673),
    [aux_sym_preproc_def_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token2] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2673),
    [aux_sym_preproc_else_token1] = ACTIONS(2673),
    [aux_sym_preproc_elif_token1] = ACTIONS(2673),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2673),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2673),
    [sym_preproc_directive] = ACTIONS(2673),
    [anon_sym_LPAREN2] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_AMP_AMP] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym___extension__] = ACTIONS(2673),
    [anon_sym_typedef] = ACTIONS(2673),
    [anon_sym_virtual] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym___attribute__] = ACTIONS(2673),
    [anon_sym___attribute] = ACTIONS(2673),
    [anon_sym_using] = ACTIONS(2673),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2675),
    [anon_sym___declspec] = ACTIONS(2673),
    [anon_sym___based] = ACTIONS(2673),
    [anon_sym___cdecl] = ACTIONS(2673),
    [anon_sym___clrcall] = ACTIONS(2673),
    [anon_sym___stdcall] = ACTIONS(2673),
    [anon_sym___fastcall] = ACTIONS(2673),
    [anon_sym___thiscall] = ACTIONS(2673),
    [anon_sym___vectorcall] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_signed] = ACTIONS(2673),
    [anon_sym_unsigned] = ACTIONS(2673),
    [anon_sym_long] = ACTIONS(2673),
    [anon_sym_short] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_register] = ACTIONS(2673),
    [anon_sym_inline] = ACTIONS(2673),
    [anon_sym___inline] = ACTIONS(2673),
    [anon_sym___inline__] = ACTIONS(2673),
    [anon_sym___forceinline] = ACTIONS(2673),
    [anon_sym_thread_local] = ACTIONS(2673),
    [anon_sym___thread] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_constexpr] = ACTIONS(2673),
    [anon_sym_volatile] = ACTIONS(2673),
    [anon_sym_restrict] = ACTIONS(2673),
    [anon_sym___restrict__] = ACTIONS(2673),
    [anon_sym__Atomic] = ACTIONS(2673),
    [anon_sym__Noreturn] = ACTIONS(2673),
    [anon_sym_noreturn] = ACTIONS(2673),
    [anon_sym__Nonnull] = ACTIONS(2673),
    [anon_sym_mutable] = ACTIONS(2673),
    [anon_sym_constinit] = ACTIONS(2673),
    [anon_sym_consteval] = ACTIONS(2673),
    [anon_sym_alignas] = ACTIONS(2673),
    [anon_sym__Alignas] = ACTIONS(2673),
    [sym_primitive_type] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_goto] = ACTIONS(2673),
    [anon_sym___try] = ACTIONS(2673),
    [anon_sym___leave] = ACTIONS(2673),
    [anon_sym_not] = ACTIONS(2673),
    [anon_sym_compl] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_sizeof] = ACTIONS(2673),
    [anon_sym___alignof__] = ACTIONS(2673),
    [anon_sym___alignof] = ACTIONS(2673),
    [anon_sym__alignof] = ACTIONS(2673),
    [anon_sym_alignof] = ACTIONS(2673),
    [anon_sym__Alignof] = ACTIONS(2673),
    [anon_sym_offsetof] = ACTIONS(2673),
    [anon_sym__Generic] = ACTIONS(2673),
    [anon_sym_asm] = ACTIONS(2673),
    [anon_sym___asm__] = ACTIONS(2673),
    [anon_sym___asm] = ACTIONS(2673),
    [sym_number_literal] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2675),
    [anon_sym_u_SQUOTE] = ACTIONS(2675),
    [anon_sym_U_SQUOTE] = ACTIONS(2675),
    [anon_sym_u8_SQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_L_DQUOTE] = ACTIONS(2675),
    [anon_sym_u_DQUOTE] = ACTIONS(2675),
    [anon_sym_U_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8_DQUOTE] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [anon_sym_NULL] = ACTIONS(2673),
    [anon_sym_nullptr] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2673),
    [anon_sym_decltype] = ACTIONS(2673),
    [anon_sym_explicit] = ACTIONS(2673),
    [anon_sym_typename] = ACTIONS(2673),
    [anon_sym_template] = ACTIONS(2673),
    [anon_sym_operator] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_static_assert] = ACTIONS(2673),
    [anon_sym_concept] = ACTIONS(2673),
    [anon_sym_co_return] = ACTIONS(2673),
    [anon_sym_co_yield] = ACTIONS(2673),
    [anon_sym_R_DQUOTE] = ACTIONS(2675),
    [anon_sym_LR_DQUOTE] = ACTIONS(2675),
    [anon_sym_uR_DQUOTE] = ACTIONS(2675),
    [anon_sym_UR_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2675),
    [anon_sym_co_await] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_requires] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
  },
  [255] = {
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token2] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [aux_sym_preproc_else_token1] = ACTIONS(2677),
    [aux_sym_preproc_elif_token1] = ACTIONS(2677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_virtual] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym___attribute] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym__Nonnull] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [anon_sym___asm] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
  },
  [256] = {
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_include_token1] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token2] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [aux_sym_preproc_else_token1] = ACTIONS(2681),
    [aux_sym_preproc_elif_token1] = ACTIONS(2681),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym___cdecl] = ACTIONS(2681),
    [anon_sym___clrcall] = ACTIONS(2681),
    [anon_sym___stdcall] = ACTIONS(2681),
    [anon_sym___fastcall] = ACTIONS(2681),
    [anon_sym___thiscall] = ACTIONS(2681),
    [anon_sym___vectorcall] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_case] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_goto] = ACTIONS(2681),
    [anon_sym___try] = ACTIONS(2681),
    [anon_sym___leave] = ACTIONS(2681),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_compl] = ACTIONS(2681),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_sizeof] = ACTIONS(2681),
    [anon_sym___alignof__] = ACTIONS(2681),
    [anon_sym___alignof] = ACTIONS(2681),
    [anon_sym__alignof] = ACTIONS(2681),
    [anon_sym_alignof] = ACTIONS(2681),
    [anon_sym__Alignof] = ACTIONS(2681),
    [anon_sym_offsetof] = ACTIONS(2681),
    [anon_sym__Generic] = ACTIONS(2681),
    [anon_sym_asm] = ACTIONS(2681),
    [anon_sym___asm__] = ACTIONS(2681),
    [anon_sym___asm] = ACTIONS(2681),
    [sym_number_literal] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2683),
    [anon_sym_u_SQUOTE] = ACTIONS(2683),
    [anon_sym_U_SQUOTE] = ACTIONS(2683),
    [anon_sym_u8_SQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_L_DQUOTE] = ACTIONS(2683),
    [anon_sym_u_DQUOTE] = ACTIONS(2683),
    [anon_sym_U_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8_DQUOTE] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [anon_sym_NULL] = ACTIONS(2681),
    [anon_sym_nullptr] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
    [anon_sym_concept] = ACTIONS(2681),
    [anon_sym_co_return] = ACTIONS(2681),
    [anon_sym_co_yield] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2683),
    [anon_sym_LR_DQUOTE] = ACTIONS(2683),
    [anon_sym_uR_DQUOTE] = ACTIONS(2683),
    [anon_sym_UR_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2683),
    [anon_sym_co_await] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_requires] = ACTIONS(2681),
    [sym_this] = ACTIONS(2681),
  },
  [257] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_include_token1] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token2] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [aux_sym_preproc_else_token1] = ACTIONS(1940),
    [aux_sym_preproc_elif_token1] = ACTIONS(1940),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym___cdecl] = ACTIONS(1940),
    [anon_sym___clrcall] = ACTIONS(1940),
    [anon_sym___stdcall] = ACTIONS(1940),
    [anon_sym___fastcall] = ACTIONS(1940),
    [anon_sym___thiscall] = ACTIONS(1940),
    [anon_sym___vectorcall] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1940),
    [anon_sym___try] = ACTIONS(1940),
    [anon_sym___leave] = ACTIONS(1940),
    [anon_sym_not] = ACTIONS(1940),
    [anon_sym_compl] = ACTIONS(1940),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_sizeof] = ACTIONS(1940),
    [anon_sym___alignof__] = ACTIONS(1940),
    [anon_sym___alignof] = ACTIONS(1940),
    [anon_sym__alignof] = ACTIONS(1940),
    [anon_sym_alignof] = ACTIONS(1940),
    [anon_sym__Alignof] = ACTIONS(1940),
    [anon_sym_offsetof] = ACTIONS(1940),
    [anon_sym__Generic] = ACTIONS(1940),
    [anon_sym_asm] = ACTIONS(1940),
    [anon_sym___asm__] = ACTIONS(1940),
    [anon_sym___asm] = ACTIONS(1940),
    [sym_number_literal] = ACTIONS(1938),
    [anon_sym_L_SQUOTE] = ACTIONS(1938),
    [anon_sym_u_SQUOTE] = ACTIONS(1938),
    [anon_sym_U_SQUOTE] = ACTIONS(1938),
    [anon_sym_u8_SQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_L_DQUOTE] = ACTIONS(1938),
    [anon_sym_u_DQUOTE] = ACTIONS(1938),
    [anon_sym_U_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8_DQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [anon_sym_NULL] = ACTIONS(1940),
    [anon_sym_nullptr] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_concept] = ACTIONS(1940),
    [anon_sym_co_return] = ACTIONS(1940),
    [anon_sym_co_yield] = ACTIONS(1940),
    [anon_sym_R_DQUOTE] = ACTIONS(1938),
    [anon_sym_LR_DQUOTE] = ACTIONS(1938),
    [anon_sym_uR_DQUOTE] = ACTIONS(1938),
    [anon_sym_UR_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1938),
    [anon_sym_co_await] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_requires] = ACTIONS(1940),
    [sym_this] = ACTIONS(1940),
  },
  [258] = {
    [sym_identifier] = ACTIONS(2687),
    [aux_sym_preproc_include_token1] = ACTIONS(2687),
    [aux_sym_preproc_def_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token2] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2687),
    [aux_sym_preproc_else_token1] = ACTIONS(2687),
    [aux_sym_preproc_elif_token1] = ACTIONS(2687),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2687),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym___extension__] = ACTIONS(2687),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_virtual] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym___attribute] = ACTIONS(2687),
    [anon_sym_using] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2689),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2689),
    [anon_sym___declspec] = ACTIONS(2687),
    [anon_sym___based] = ACTIONS(2687),
    [anon_sym___cdecl] = ACTIONS(2687),
    [anon_sym___clrcall] = ACTIONS(2687),
    [anon_sym___stdcall] = ACTIONS(2687),
    [anon_sym___fastcall] = ACTIONS(2687),
    [anon_sym___thiscall] = ACTIONS(2687),
    [anon_sym___vectorcall] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym___inline] = ACTIONS(2687),
    [anon_sym___inline__] = ACTIONS(2687),
    [anon_sym___forceinline] = ACTIONS(2687),
    [anon_sym_thread_local] = ACTIONS(2687),
    [anon_sym___thread] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_constexpr] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym___restrict__] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym__Noreturn] = ACTIONS(2687),
    [anon_sym_noreturn] = ACTIONS(2687),
    [anon_sym__Nonnull] = ACTIONS(2687),
    [anon_sym_mutable] = ACTIONS(2687),
    [anon_sym_constinit] = ACTIONS(2687),
    [anon_sym_consteval] = ACTIONS(2687),
    [anon_sym_alignas] = ACTIONS(2687),
    [anon_sym__Alignas] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym___try] = ACTIONS(2687),
    [anon_sym___leave] = ACTIONS(2687),
    [anon_sym_not] = ACTIONS(2687),
    [anon_sym_compl] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [anon_sym___alignof__] = ACTIONS(2687),
    [anon_sym___alignof] = ACTIONS(2687),
    [anon_sym__alignof] = ACTIONS(2687),
    [anon_sym_alignof] = ACTIONS(2687),
    [anon_sym__Alignof] = ACTIONS(2687),
    [anon_sym_offsetof] = ACTIONS(2687),
    [anon_sym__Generic] = ACTIONS(2687),
    [anon_sym_asm] = ACTIONS(2687),
    [anon_sym___asm__] = ACTIONS(2687),
    [anon_sym___asm] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [anon_sym_L_SQUOTE] = ACTIONS(2689),
    [anon_sym_u_SQUOTE] = ACTIONS(2689),
    [anon_sym_U_SQUOTE] = ACTIONS(2689),
    [anon_sym_u8_SQUOTE] = ACTIONS(2689),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_L_DQUOTE] = ACTIONS(2689),
    [anon_sym_u_DQUOTE] = ACTIONS(2689),
    [anon_sym_U_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [anon_sym_NULL] = ACTIONS(2687),
    [anon_sym_nullptr] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2687),
    [anon_sym_decltype] = ACTIONS(2687),
    [anon_sym_explicit] = ACTIONS(2687),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2687),
    [anon_sym_operator] = ACTIONS(2687),
    [anon_sym_try] = ACTIONS(2687),
    [anon_sym_delete] = ACTIONS(2687),
    [anon_sym_throw] = ACTIONS(2687),
    [anon_sym_namespace] = ACTIONS(2687),
    [anon_sym_static_assert] = ACTIONS(2687),
    [anon_sym_concept] = ACTIONS(2687),
    [anon_sym_co_return] = ACTIONS(2687),
    [anon_sym_co_yield] = ACTIONS(2687),
    [anon_sym_R_DQUOTE] = ACTIONS(2689),
    [anon_sym_LR_DQUOTE] = ACTIONS(2689),
    [anon_sym_uR_DQUOTE] = ACTIONS(2689),
    [anon_sym_UR_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2689),
    [anon_sym_co_await] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2687),
    [anon_sym_requires] = ACTIONS(2687),
    [sym_this] = ACTIONS(2687),
  },
  [259] = {
    [sym_identifier] = ACTIONS(2691),
    [aux_sym_preproc_include_token1] = ACTIONS(2691),
    [aux_sym_preproc_def_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token2] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2691),
    [aux_sym_preproc_else_token1] = ACTIONS(2691),
    [aux_sym_preproc_elif_token1] = ACTIONS(2691),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2691),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2691),
    [sym_preproc_directive] = ACTIONS(2691),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym___extension__] = ACTIONS(2691),
    [anon_sym_typedef] = ACTIONS(2691),
    [anon_sym_virtual] = ACTIONS(2691),
    [anon_sym_extern] = ACTIONS(2691),
    [anon_sym___attribute__] = ACTIONS(2691),
    [anon_sym___attribute] = ACTIONS(2691),
    [anon_sym_using] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2693),
    [anon_sym___declspec] = ACTIONS(2691),
    [anon_sym___based] = ACTIONS(2691),
    [anon_sym___cdecl] = ACTIONS(2691),
    [anon_sym___clrcall] = ACTIONS(2691),
    [anon_sym___stdcall] = ACTIONS(2691),
    [anon_sym___fastcall] = ACTIONS(2691),
    [anon_sym___thiscall] = ACTIONS(2691),
    [anon_sym___vectorcall] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_signed] = ACTIONS(2691),
    [anon_sym_unsigned] = ACTIONS(2691),
    [anon_sym_long] = ACTIONS(2691),
    [anon_sym_short] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2691),
    [anon_sym_register] = ACTIONS(2691),
    [anon_sym_inline] = ACTIONS(2691),
    [anon_sym___inline] = ACTIONS(2691),
    [anon_sym___inline__] = ACTIONS(2691),
    [anon_sym___forceinline] = ACTIONS(2691),
    [anon_sym_thread_local] = ACTIONS(2691),
    [anon_sym___thread] = ACTIONS(2691),
    [anon_sym_const] = ACTIONS(2691),
    [anon_sym_constexpr] = ACTIONS(2691),
    [anon_sym_volatile] = ACTIONS(2691),
    [anon_sym_restrict] = ACTIONS(2691),
    [anon_sym___restrict__] = ACTIONS(2691),
    [anon_sym__Atomic] = ACTIONS(2691),
    [anon_sym__Noreturn] = ACTIONS(2691),
    [anon_sym_noreturn] = ACTIONS(2691),
    [anon_sym__Nonnull] = ACTIONS(2691),
    [anon_sym_mutable] = ACTIONS(2691),
    [anon_sym_constinit] = ACTIONS(2691),
    [anon_sym_consteval] = ACTIONS(2691),
    [anon_sym_alignas] = ACTIONS(2691),
    [anon_sym__Alignas] = ACTIONS(2691),
    [sym_primitive_type] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2691),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_union] = ACTIONS(2691),
    [anon_sym_if] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2691),
    [anon_sym_switch] = ACTIONS(2691),
    [anon_sym_case] = ACTIONS(2691),
    [anon_sym_default] = ACTIONS(2691),
    [anon_sym_while] = ACTIONS(2691),
    [anon_sym_do] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2691),
    [anon_sym_return] = ACTIONS(2691),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_continue] = ACTIONS(2691),
    [anon_sym_goto] = ACTIONS(2691),
    [anon_sym___try] = ACTIONS(2691),
    [anon_sym___leave] = ACTIONS(2691),
    [anon_sym_not] = ACTIONS(2691),
    [anon_sym_compl] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_sizeof] = ACTIONS(2691),
    [anon_sym___alignof__] = ACTIONS(2691),
    [anon_sym___alignof] = ACTIONS(2691),
    [anon_sym__alignof] = ACTIONS(2691),
    [anon_sym_alignof] = ACTIONS(2691),
    [anon_sym__Alignof] = ACTIONS(2691),
    [anon_sym_offsetof] = ACTIONS(2691),
    [anon_sym__Generic] = ACTIONS(2691),
    [anon_sym_asm] = ACTIONS(2691),
    [anon_sym___asm__] = ACTIONS(2691),
    [anon_sym___asm] = ACTIONS(2691),
    [sym_number_literal] = ACTIONS(2693),
    [anon_sym_L_SQUOTE] = ACTIONS(2693),
    [anon_sym_u_SQUOTE] = ACTIONS(2693),
    [anon_sym_U_SQUOTE] = ACTIONS(2693),
    [anon_sym_u8_SQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_L_DQUOTE] = ACTIONS(2693),
    [anon_sym_u_DQUOTE] = ACTIONS(2693),
    [anon_sym_U_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8_DQUOTE] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [anon_sym_NULL] = ACTIONS(2691),
    [anon_sym_nullptr] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2691),
    [anon_sym_decltype] = ACTIONS(2691),
    [anon_sym_explicit] = ACTIONS(2691),
    [anon_sym_typename] = ACTIONS(2691),
    [anon_sym_template] = ACTIONS(2691),
    [anon_sym_operator] = ACTIONS(2691),
    [anon_sym_try] = ACTIONS(2691),
    [anon_sym_delete] = ACTIONS(2691),
    [anon_sym_throw] = ACTIONS(2691),
    [anon_sym_namespace] = ACTIONS(2691),
    [anon_sym_static_assert] = ACTIONS(2691),
    [anon_sym_concept] = ACTIONS(2691),
    [anon_sym_co_return] = ACTIONS(2691),
    [anon_sym_co_yield] = ACTIONS(2691),
    [anon_sym_R_DQUOTE] = ACTIONS(2693),
    [anon_sym_LR_DQUOTE] = ACTIONS(2693),
    [anon_sym_uR_DQUOTE] = ACTIONS(2693),
    [anon_sym_UR_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2693),
    [anon_sym_co_await] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2691),
    [anon_sym_requires] = ACTIONS(2691),
    [sym_this] = ACTIONS(2691),
  },
  [260] = {
    [sym_else_clause] = STATE(380),
    [ts_builtin_sym_end] = ACTIONS(2615),
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_include_token1] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym___cdecl] = ACTIONS(2613),
    [anon_sym___clrcall] = ACTIONS(2613),
    [anon_sym___stdcall] = ACTIONS(2613),
    [anon_sym___fastcall] = ACTIONS(2613),
    [anon_sym___thiscall] = ACTIONS(2613),
    [anon_sym___vectorcall] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(2663),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_case] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_goto] = ACTIONS(2613),
    [anon_sym___try] = ACTIONS(2613),
    [anon_sym___leave] = ACTIONS(2613),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_compl] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2615),
    [anon_sym_sizeof] = ACTIONS(2613),
    [anon_sym___alignof__] = ACTIONS(2613),
    [anon_sym___alignof] = ACTIONS(2613),
    [anon_sym__alignof] = ACTIONS(2613),
    [anon_sym_alignof] = ACTIONS(2613),
    [anon_sym__Alignof] = ACTIONS(2613),
    [anon_sym_offsetof] = ACTIONS(2613),
    [anon_sym__Generic] = ACTIONS(2613),
    [anon_sym_asm] = ACTIONS(2613),
    [anon_sym___asm__] = ACTIONS(2613),
    [anon_sym___asm] = ACTIONS(2613),
    [sym_number_literal] = ACTIONS(2615),
    [anon_sym_L_SQUOTE] = ACTIONS(2615),
    [anon_sym_u_SQUOTE] = ACTIONS(2615),
    [anon_sym_U_SQUOTE] = ACTIONS(2615),
    [anon_sym_u8_SQUOTE] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2615),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [anon_sym_NULL] = ACTIONS(2613),
    [anon_sym_nullptr] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_export] = ACTIONS(2613),
    [anon_sym_module] = ACTIONS(2613),
    [anon_sym_import] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_namespace] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
    [anon_sym_concept] = ACTIONS(2613),
    [anon_sym_co_return] = ACTIONS(2613),
    [anon_sym_co_yield] = ACTIONS(2613),
    [anon_sym_R_DQUOTE] = ACTIONS(2615),
    [anon_sym_LR_DQUOTE] = ACTIONS(2615),
    [anon_sym_uR_DQUOTE] = ACTIONS(2615),
    [anon_sym_UR_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2615),
    [anon_sym_co_await] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_requires] = ACTIONS(2613),
    [sym_this] = ACTIONS(2613),
  },
  [261] = {
    [sym_identifier] = ACTIONS(2695),
    [aux_sym_preproc_include_token1] = ACTIONS(2695),
    [aux_sym_preproc_def_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token2] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2695),
    [aux_sym_preproc_else_token1] = ACTIONS(2695),
    [aux_sym_preproc_elif_token1] = ACTIONS(2695),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2695),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2695),
    [sym_preproc_directive] = ACTIONS(2695),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym___extension__] = ACTIONS(2695),
    [anon_sym_typedef] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym___attribute__] = ACTIONS(2695),
    [anon_sym___attribute] = ACTIONS(2695),
    [anon_sym_using] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2697),
    [anon_sym___declspec] = ACTIONS(2695),
    [anon_sym___based] = ACTIONS(2695),
    [anon_sym___cdecl] = ACTIONS(2695),
    [anon_sym___clrcall] = ACTIONS(2695),
    [anon_sym___stdcall] = ACTIONS(2695),
    [anon_sym___fastcall] = ACTIONS(2695),
    [anon_sym___thiscall] = ACTIONS(2695),
    [anon_sym___vectorcall] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_signed] = ACTIONS(2695),
    [anon_sym_unsigned] = ACTIONS(2695),
    [anon_sym_long] = ACTIONS(2695),
    [anon_sym_short] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym___inline] = ACTIONS(2695),
    [anon_sym___inline__] = ACTIONS(2695),
    [anon_sym___forceinline] = ACTIONS(2695),
    [anon_sym_thread_local] = ACTIONS(2695),
    [anon_sym___thread] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym___restrict__] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym__Noreturn] = ACTIONS(2695),
    [anon_sym_noreturn] = ACTIONS(2695),
    [anon_sym__Nonnull] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_constinit] = ACTIONS(2695),
    [anon_sym_consteval] = ACTIONS(2695),
    [anon_sym_alignas] = ACTIONS(2695),
    [anon_sym__Alignas] = ACTIONS(2695),
    [sym_primitive_type] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2695),
    [anon_sym_union] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_case] = ACTIONS(2695),
    [anon_sym_default] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_goto] = ACTIONS(2695),
    [anon_sym___try] = ACTIONS(2695),
    [anon_sym___leave] = ACTIONS(2695),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_compl] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_sizeof] = ACTIONS(2695),
    [anon_sym___alignof__] = ACTIONS(2695),
    [anon_sym___alignof] = ACTIONS(2695),
    [anon_sym__alignof] = ACTIONS(2695),
    [anon_sym_alignof] = ACTIONS(2695),
    [anon_sym__Alignof] = ACTIONS(2695),
    [anon_sym_offsetof] = ACTIONS(2695),
    [anon_sym__Generic] = ACTIONS(2695),
    [anon_sym_asm] = ACTIONS(2695),
    [anon_sym___asm__] = ACTIONS(2695),
    [anon_sym___asm] = ACTIONS(2695),
    [sym_number_literal] = ACTIONS(2697),
    [anon_sym_L_SQUOTE] = ACTIONS(2697),
    [anon_sym_u_SQUOTE] = ACTIONS(2697),
    [anon_sym_U_SQUOTE] = ACTIONS(2697),
    [anon_sym_u8_SQUOTE] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_L_DQUOTE] = ACTIONS(2697),
    [anon_sym_u_DQUOTE] = ACTIONS(2697),
    [anon_sym_U_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [anon_sym_NULL] = ACTIONS(2695),
    [anon_sym_nullptr] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2695),
    [anon_sym_decltype] = ACTIONS(2695),
    [anon_sym_explicit] = ACTIONS(2695),
    [anon_sym_typename] = ACTIONS(2695),
    [anon_sym_template] = ACTIONS(2695),
    [anon_sym_operator] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_static_assert] = ACTIONS(2695),
    [anon_sym_concept] = ACTIONS(2695),
    [anon_sym_co_return] = ACTIONS(2695),
    [anon_sym_co_yield] = ACTIONS(2695),
    [anon_sym_R_DQUOTE] = ACTIONS(2697),
    [anon_sym_LR_DQUOTE] = ACTIONS(2697),
    [anon_sym_uR_DQUOTE] = ACTIONS(2697),
    [anon_sym_UR_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2697),
    [anon_sym_co_await] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_requires] = ACTIONS(2695),
    [sym_this] = ACTIONS(2695),
  },
  [262] = {
    [sym_identifier] = ACTIONS(2699),
    [aux_sym_preproc_include_token1] = ACTIONS(2699),
    [aux_sym_preproc_def_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token2] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2699),
    [aux_sym_preproc_else_token1] = ACTIONS(2699),
    [aux_sym_preproc_elif_token1] = ACTIONS(2699),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2699),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2699),
    [sym_preproc_directive] = ACTIONS(2699),
    [anon_sym_LPAREN2] = ACTIONS(2701),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2699),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_AMP_AMP] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym___extension__] = ACTIONS(2699),
    [anon_sym_typedef] = ACTIONS(2699),
    [anon_sym_virtual] = ACTIONS(2699),
    [anon_sym_extern] = ACTIONS(2699),
    [anon_sym___attribute__] = ACTIONS(2699),
    [anon_sym___attribute] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2701),
    [anon_sym___declspec] = ACTIONS(2699),
    [anon_sym___based] = ACTIONS(2699),
    [anon_sym___cdecl] = ACTIONS(2699),
    [anon_sym___clrcall] = ACTIONS(2699),
    [anon_sym___stdcall] = ACTIONS(2699),
    [anon_sym___fastcall] = ACTIONS(2699),
    [anon_sym___thiscall] = ACTIONS(2699),
    [anon_sym___vectorcall] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(2701),
    [anon_sym_signed] = ACTIONS(2699),
    [anon_sym_unsigned] = ACTIONS(2699),
    [anon_sym_long] = ACTIONS(2699),
    [anon_sym_short] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_register] = ACTIONS(2699),
    [anon_sym_inline] = ACTIONS(2699),
    [anon_sym___inline] = ACTIONS(2699),
    [anon_sym___inline__] = ACTIONS(2699),
    [anon_sym___forceinline] = ACTIONS(2699),
    [anon_sym_thread_local] = ACTIONS(2699),
    [anon_sym___thread] = ACTIONS(2699),
    [anon_sym_const] = ACTIONS(2699),
    [anon_sym_constexpr] = ACTIONS(2699),
    [anon_sym_volatile] = ACTIONS(2699),
    [anon_sym_restrict] = ACTIONS(2699),
    [anon_sym___restrict__] = ACTIONS(2699),
    [anon_sym__Atomic] = ACTIONS(2699),
    [anon_sym__Noreturn] = ACTIONS(2699),
    [anon_sym_noreturn] = ACTIONS(2699),
    [anon_sym__Nonnull] = ACTIONS(2699),
    [anon_sym_mutable] = ACTIONS(2699),
    [anon_sym_constinit] = ACTIONS(2699),
    [anon_sym_consteval] = ACTIONS(2699),
    [anon_sym_alignas] = ACTIONS(2699),
    [anon_sym__Alignas] = ACTIONS(2699),
    [sym_primitive_type] = ACTIONS(2699),
    [anon_sym_enum] = ACTIONS(2699),
    [anon_sym_class] = ACTIONS(2699),
    [anon_sym_struct] = ACTIONS(2699),
    [anon_sym_union] = ACTIONS(2699),
    [anon_sym_if] = ACTIONS(2699),
    [anon_sym_else] = ACTIONS(2699),
    [anon_sym_switch] = ACTIONS(2699),
    [anon_sym_case] = ACTIONS(2699),
    [anon_sym_default] = ACTIONS(2699),
    [anon_sym_while] = ACTIONS(2699),
    [anon_sym_do] = ACTIONS(2699),
    [anon_sym_for] = ACTIONS(2699),
    [anon_sym_return] = ACTIONS(2699),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_continue] = ACTIONS(2699),
    [anon_sym_goto] = ACTIONS(2699),
    [anon_sym___try] = ACTIONS(2699),
    [anon_sym___leave] = ACTIONS(2699),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_compl] = ACTIONS(2699),
    [anon_sym_DASH_DASH] = ACTIONS(2701),
    [anon_sym_PLUS_PLUS] = ACTIONS(2701),
    [anon_sym_sizeof] = ACTIONS(2699),
    [anon_sym___alignof__] = ACTIONS(2699),
    [anon_sym___alignof] = ACTIONS(2699),
    [anon_sym__alignof] = ACTIONS(2699),
    [anon_sym_alignof] = ACTIONS(2699),
    [anon_sym__Alignof] = ACTIONS(2699),
    [anon_sym_offsetof] = ACTIONS(2699),
    [anon_sym__Generic] = ACTIONS(2699),
    [anon_sym_asm] = ACTIONS(2699),
    [anon_sym___asm__] = ACTIONS(2699),
    [anon_sym___asm] = ACTIONS(2699),
    [sym_number_literal] = ACTIONS(2701),
    [anon_sym_L_SQUOTE] = ACTIONS(2701),
    [anon_sym_u_SQUOTE] = ACTIONS(2701),
    [anon_sym_U_SQUOTE] = ACTIONS(2701),
    [anon_sym_u8_SQUOTE] = ACTIONS(2701),
    [anon_sym_SQUOTE] = ACTIONS(2701),
    [anon_sym_L_DQUOTE] = ACTIONS(2701),
    [anon_sym_u_DQUOTE] = ACTIONS(2701),
    [anon_sym_U_DQUOTE] = ACTIONS(2701),
    [anon_sym_u8_DQUOTE] = ACTIONS(2701),
    [anon_sym_DQUOTE] = ACTIONS(2701),
    [sym_true] = ACTIONS(2699),
    [sym_false] = ACTIONS(2699),
    [anon_sym_NULL] = ACTIONS(2699),
    [anon_sym_nullptr] = ACTIONS(2699),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2699),
    [anon_sym_decltype] = ACTIONS(2699),
    [anon_sym_explicit] = ACTIONS(2699),
    [anon_sym_typename] = ACTIONS(2699),
    [anon_sym_template] = ACTIONS(2699),
    [anon_sym_operator] = ACTIONS(2699),
    [anon_sym_try] = ACTIONS(2699),
    [anon_sym_delete] = ACTIONS(2699),
    [anon_sym_throw] = ACTIONS(2699),
    [anon_sym_namespace] = ACTIONS(2699),
    [anon_sym_static_assert] = ACTIONS(2699),
    [anon_sym_concept] = ACTIONS(2699),
    [anon_sym_co_return] = ACTIONS(2699),
    [anon_sym_co_yield] = ACTIONS(2699),
    [anon_sym_R_DQUOTE] = ACTIONS(2701),
    [anon_sym_LR_DQUOTE] = ACTIONS(2701),
    [anon_sym_uR_DQUOTE] = ACTIONS(2701),
    [anon_sym_UR_DQUOTE] = ACTIONS(2701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2701),
    [anon_sym_co_await] = ACTIONS(2699),
    [anon_sym_new] = ACTIONS(2699),
    [anon_sym_requires] = ACTIONS(2699),
    [sym_this] = ACTIONS(2699),
  },
  [263] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_include_token1] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token2] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [aux_sym_preproc_else_token1] = ACTIONS(2703),
    [aux_sym_preproc_elif_token1] = ACTIONS(2703),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym___cdecl] = ACTIONS(2703),
    [anon_sym___clrcall] = ACTIONS(2703),
    [anon_sym___stdcall] = ACTIONS(2703),
    [anon_sym___fastcall] = ACTIONS(2703),
    [anon_sym___thiscall] = ACTIONS(2703),
    [anon_sym___vectorcall] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [anon_sym_if] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2703),
    [anon_sym_case] = ACTIONS(2703),
    [anon_sym_default] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(2703),
    [anon_sym_do] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2703),
    [anon_sym_return] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2703),
    [anon_sym_continue] = ACTIONS(2703),
    [anon_sym_goto] = ACTIONS(2703),
    [anon_sym___try] = ACTIONS(2703),
    [anon_sym___leave] = ACTIONS(2703),
    [anon_sym_not] = ACTIONS(2703),
    [anon_sym_compl] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2703),
    [anon_sym___alignof__] = ACTIONS(2703),
    [anon_sym___alignof] = ACTIONS(2703),
    [anon_sym__alignof] = ACTIONS(2703),
    [anon_sym_alignof] = ACTIONS(2703),
    [anon_sym__Alignof] = ACTIONS(2703),
    [anon_sym_offsetof] = ACTIONS(2703),
    [anon_sym__Generic] = ACTIONS(2703),
    [anon_sym_asm] = ACTIONS(2703),
    [anon_sym___asm__] = ACTIONS(2703),
    [anon_sym___asm] = ACTIONS(2703),
    [sym_number_literal] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2705),
    [anon_sym_u_SQUOTE] = ACTIONS(2705),
    [anon_sym_U_SQUOTE] = ACTIONS(2705),
    [anon_sym_u8_SQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_L_DQUOTE] = ACTIONS(2705),
    [anon_sym_u_DQUOTE] = ACTIONS(2705),
    [anon_sym_U_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8_DQUOTE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [sym_false] = ACTIONS(2703),
    [anon_sym_NULL] = ACTIONS(2703),
    [anon_sym_nullptr] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2703),
    [anon_sym_delete] = ACTIONS(2703),
    [anon_sym_throw] = ACTIONS(2703),
    [anon_sym_namespace] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
    [anon_sym_concept] = ACTIONS(2703),
    [anon_sym_co_return] = ACTIONS(2703),
    [anon_sym_co_yield] = ACTIONS(2703),
    [anon_sym_R_DQUOTE] = ACTIONS(2705),
    [anon_sym_LR_DQUOTE] = ACTIONS(2705),
    [anon_sym_uR_DQUOTE] = ACTIONS(2705),
    [anon_sym_UR_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2705),
    [anon_sym_co_await] = ACTIONS(2703),
    [anon_sym_new] = ACTIONS(2703),
    [anon_sym_requires] = ACTIONS(2703),
    [sym_this] = ACTIONS(2703),
  },
  [264] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_include_token1] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token2] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [aux_sym_preproc_else_token1] = ACTIONS(2703),
    [aux_sym_preproc_elif_token1] = ACTIONS(2703),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym___cdecl] = ACTIONS(2703),
    [anon_sym___clrcall] = ACTIONS(2703),
    [anon_sym___stdcall] = ACTIONS(2703),
    [anon_sym___fastcall] = ACTIONS(2703),
    [anon_sym___thiscall] = ACTIONS(2703),
    [anon_sym___vectorcall] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [anon_sym_if] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2703),
    [anon_sym_case] = ACTIONS(2703),
    [anon_sym_default] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(2703),
    [anon_sym_do] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2703),
    [anon_sym_return] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2703),
    [anon_sym_continue] = ACTIONS(2703),
    [anon_sym_goto] = ACTIONS(2703),
    [anon_sym___try] = ACTIONS(2703),
    [anon_sym___leave] = ACTIONS(2703),
    [anon_sym_not] = ACTIONS(2703),
    [anon_sym_compl] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2703),
    [anon_sym___alignof__] = ACTIONS(2703),
    [anon_sym___alignof] = ACTIONS(2703),
    [anon_sym__alignof] = ACTIONS(2703),
    [anon_sym_alignof] = ACTIONS(2703),
    [anon_sym__Alignof] = ACTIONS(2703),
    [anon_sym_offsetof] = ACTIONS(2703),
    [anon_sym__Generic] = ACTIONS(2703),
    [anon_sym_asm] = ACTIONS(2703),
    [anon_sym___asm__] = ACTIONS(2703),
    [anon_sym___asm] = ACTIONS(2703),
    [sym_number_literal] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2705),
    [anon_sym_u_SQUOTE] = ACTIONS(2705),
    [anon_sym_U_SQUOTE] = ACTIONS(2705),
    [anon_sym_u8_SQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_L_DQUOTE] = ACTIONS(2705),
    [anon_sym_u_DQUOTE] = ACTIONS(2705),
    [anon_sym_U_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8_DQUOTE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [sym_false] = ACTIONS(2703),
    [anon_sym_NULL] = ACTIONS(2703),
    [anon_sym_nullptr] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2703),
    [anon_sym_delete] = ACTIONS(2703),
    [anon_sym_throw] = ACTIONS(2703),
    [anon_sym_namespace] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
    [anon_sym_concept] = ACTIONS(2703),
    [anon_sym_co_return] = ACTIONS(2703),
    [anon_sym_co_yield] = ACTIONS(2703),
    [anon_sym_R_DQUOTE] = ACTIONS(2705),
    [anon_sym_LR_DQUOTE] = ACTIONS(2705),
    [anon_sym_uR_DQUOTE] = ACTIONS(2705),
    [anon_sym_UR_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2705),
    [anon_sym_co_await] = ACTIONS(2703),
    [anon_sym_new] = ACTIONS(2703),
    [anon_sym_requires] = ACTIONS(2703),
    [sym_this] = ACTIONS(2703),
  },
  [265] = {
    [sym_identifier] = ACTIONS(2707),
    [aux_sym_preproc_include_token1] = ACTIONS(2707),
    [aux_sym_preproc_def_token1] = ACTIONS(2707),
    [aux_sym_preproc_if_token1] = ACTIONS(2707),
    [aux_sym_preproc_if_token2] = ACTIONS(2707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2707),
    [aux_sym_preproc_else_token1] = ACTIONS(2707),
    [aux_sym_preproc_elif_token1] = ACTIONS(2707),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2707),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2707),
    [sym_preproc_directive] = ACTIONS(2707),
    [anon_sym_LPAREN2] = ACTIONS(2709),
    [anon_sym_BANG] = ACTIONS(2709),
    [anon_sym_TILDE] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_PLUS] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_AMP_AMP] = ACTIONS(2709),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2709),
    [anon_sym___extension__] = ACTIONS(2707),
    [anon_sym_typedef] = ACTIONS(2707),
    [anon_sym_virtual] = ACTIONS(2707),
    [anon_sym_extern] = ACTIONS(2707),
    [anon_sym___attribute__] = ACTIONS(2707),
    [anon_sym___attribute] = ACTIONS(2707),
    [anon_sym_using] = ACTIONS(2707),
    [anon_sym_COLON_COLON] = ACTIONS(2709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2709),
    [anon_sym___declspec] = ACTIONS(2707),
    [anon_sym___based] = ACTIONS(2707),
    [anon_sym___cdecl] = ACTIONS(2707),
    [anon_sym___clrcall] = ACTIONS(2707),
    [anon_sym___stdcall] = ACTIONS(2707),
    [anon_sym___fastcall] = ACTIONS(2707),
    [anon_sym___thiscall] = ACTIONS(2707),
    [anon_sym___vectorcall] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2709),
    [anon_sym_signed] = ACTIONS(2707),
    [anon_sym_unsigned] = ACTIONS(2707),
    [anon_sym_long] = ACTIONS(2707),
    [anon_sym_short] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_static] = ACTIONS(2707),
    [anon_sym_register] = ACTIONS(2707),
    [anon_sym_inline] = ACTIONS(2707),
    [anon_sym___inline] = ACTIONS(2707),
    [anon_sym___inline__] = ACTIONS(2707),
    [anon_sym___forceinline] = ACTIONS(2707),
    [anon_sym_thread_local] = ACTIONS(2707),
    [anon_sym___thread] = ACTIONS(2707),
    [anon_sym_const] = ACTIONS(2707),
    [anon_sym_constexpr] = ACTIONS(2707),
    [anon_sym_volatile] = ACTIONS(2707),
    [anon_sym_restrict] = ACTIONS(2707),
    [anon_sym___restrict__] = ACTIONS(2707),
    [anon_sym__Atomic] = ACTIONS(2707),
    [anon_sym__Noreturn] = ACTIONS(2707),
    [anon_sym_noreturn] = ACTIONS(2707),
    [anon_sym__Nonnull] = ACTIONS(2707),
    [anon_sym_mutable] = ACTIONS(2707),
    [anon_sym_constinit] = ACTIONS(2707),
    [anon_sym_consteval] = ACTIONS(2707),
    [anon_sym_alignas] = ACTIONS(2707),
    [anon_sym__Alignas] = ACTIONS(2707),
    [sym_primitive_type] = ACTIONS(2707),
    [anon_sym_enum] = ACTIONS(2707),
    [anon_sym_class] = ACTIONS(2707),
    [anon_sym_struct] = ACTIONS(2707),
    [anon_sym_union] = ACTIONS(2707),
    [anon_sym_if] = ACTIONS(2707),
    [anon_sym_else] = ACTIONS(2707),
    [anon_sym_switch] = ACTIONS(2707),
    [anon_sym_case] = ACTIONS(2707),
    [anon_sym_default] = ACTIONS(2707),
    [anon_sym_while] = ACTIONS(2707),
    [anon_sym_do] = ACTIONS(2707),
    [anon_sym_for] = ACTIONS(2707),
    [anon_sym_return] = ACTIONS(2707),
    [anon_sym_break] = ACTIONS(2707),
    [anon_sym_continue] = ACTIONS(2707),
    [anon_sym_goto] = ACTIONS(2707),
    [anon_sym___try] = ACTIONS(2707),
    [anon_sym___leave] = ACTIONS(2707),
    [anon_sym_not] = ACTIONS(2707),
    [anon_sym_compl] = ACTIONS(2707),
    [anon_sym_DASH_DASH] = ACTIONS(2709),
    [anon_sym_PLUS_PLUS] = ACTIONS(2709),
    [anon_sym_sizeof] = ACTIONS(2707),
    [anon_sym___alignof__] = ACTIONS(2707),
    [anon_sym___alignof] = ACTIONS(2707),
    [anon_sym__alignof] = ACTIONS(2707),
    [anon_sym_alignof] = ACTIONS(2707),
    [anon_sym__Alignof] = ACTIONS(2707),
    [anon_sym_offsetof] = ACTIONS(2707),
    [anon_sym__Generic] = ACTIONS(2707),
    [anon_sym_asm] = ACTIONS(2707),
    [anon_sym___asm__] = ACTIONS(2707),
    [anon_sym___asm] = ACTIONS(2707),
    [sym_number_literal] = ACTIONS(2709),
    [anon_sym_L_SQUOTE] = ACTIONS(2709),
    [anon_sym_u_SQUOTE] = ACTIONS(2709),
    [anon_sym_U_SQUOTE] = ACTIONS(2709),
    [anon_sym_u8_SQUOTE] = ACTIONS(2709),
    [anon_sym_SQUOTE] = ACTIONS(2709),
    [anon_sym_L_DQUOTE] = ACTIONS(2709),
    [anon_sym_u_DQUOTE] = ACTIONS(2709),
    [anon_sym_U_DQUOTE] = ACTIONS(2709),
    [anon_sym_u8_DQUOTE] = ACTIONS(2709),
    [anon_sym_DQUOTE] = ACTIONS(2709),
    [sym_true] = ACTIONS(2707),
    [sym_false] = ACTIONS(2707),
    [anon_sym_NULL] = ACTIONS(2707),
    [anon_sym_nullptr] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2707),
    [anon_sym_decltype] = ACTIONS(2707),
    [anon_sym_explicit] = ACTIONS(2707),
    [anon_sym_typename] = ACTIONS(2707),
    [anon_sym_template] = ACTIONS(2707),
    [anon_sym_operator] = ACTIONS(2707),
    [anon_sym_try] = ACTIONS(2707),
    [anon_sym_delete] = ACTIONS(2707),
    [anon_sym_throw] = ACTIONS(2707),
    [anon_sym_namespace] = ACTIONS(2707),
    [anon_sym_static_assert] = ACTIONS(2707),
    [anon_sym_concept] = ACTIONS(2707),
    [anon_sym_co_return] = ACTIONS(2707),
    [anon_sym_co_yield] = ACTIONS(2707),
    [anon_sym_R_DQUOTE] = ACTIONS(2709),
    [anon_sym_LR_DQUOTE] = ACTIONS(2709),
    [anon_sym_uR_DQUOTE] = ACTIONS(2709),
    [anon_sym_UR_DQUOTE] = ACTIONS(2709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2709),
    [anon_sym_co_await] = ACTIONS(2707),
    [anon_sym_new] = ACTIONS(2707),
    [anon_sym_requires] = ACTIONS(2707),
    [sym_this] = ACTIONS(2707),
  },
  [266] = {
    [sym_identifier] = ACTIONS(2711),
    [aux_sym_preproc_include_token1] = ACTIONS(2711),
    [aux_sym_preproc_def_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token2] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2711),
    [aux_sym_preproc_else_token1] = ACTIONS(2711),
    [aux_sym_preproc_elif_token1] = ACTIONS(2711),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2711),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2711),
    [sym_preproc_directive] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym___extension__] = ACTIONS(2711),
    [anon_sym_typedef] = ACTIONS(2711),
    [anon_sym_virtual] = ACTIONS(2711),
    [anon_sym_extern] = ACTIONS(2711),
    [anon_sym___attribute__] = ACTIONS(2711),
    [anon_sym___attribute] = ACTIONS(2711),
    [anon_sym_using] = ACTIONS(2711),
    [anon_sym_COLON_COLON] = ACTIONS(2713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2713),
    [anon_sym___declspec] = ACTIONS(2711),
    [anon_sym___based] = ACTIONS(2711),
    [anon_sym___cdecl] = ACTIONS(2711),
    [anon_sym___clrcall] = ACTIONS(2711),
    [anon_sym___stdcall] = ACTIONS(2711),
    [anon_sym___fastcall] = ACTIONS(2711),
    [anon_sym___thiscall] = ACTIONS(2711),
    [anon_sym___vectorcall] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_signed] = ACTIONS(2711),
    [anon_sym_unsigned] = ACTIONS(2711),
    [anon_sym_long] = ACTIONS(2711),
    [anon_sym_short] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_static] = ACTIONS(2711),
    [anon_sym_register] = ACTIONS(2711),
    [anon_sym_inline] = ACTIONS(2711),
    [anon_sym___inline] = ACTIONS(2711),
    [anon_sym___inline__] = ACTIONS(2711),
    [anon_sym___forceinline] = ACTIONS(2711),
    [anon_sym_thread_local] = ACTIONS(2711),
    [anon_sym___thread] = ACTIONS(2711),
    [anon_sym_const] = ACTIONS(2711),
    [anon_sym_constexpr] = ACTIONS(2711),
    [anon_sym_volatile] = ACTIONS(2711),
    [anon_sym_restrict] = ACTIONS(2711),
    [anon_sym___restrict__] = ACTIONS(2711),
    [anon_sym__Atomic] = ACTIONS(2711),
    [anon_sym__Noreturn] = ACTIONS(2711),
    [anon_sym_noreturn] = ACTIONS(2711),
    [anon_sym__Nonnull] = ACTIONS(2711),
    [anon_sym_mutable] = ACTIONS(2711),
    [anon_sym_constinit] = ACTIONS(2711),
    [anon_sym_consteval] = ACTIONS(2711),
    [anon_sym_alignas] = ACTIONS(2711),
    [anon_sym__Alignas] = ACTIONS(2711),
    [sym_primitive_type] = ACTIONS(2711),
    [anon_sym_enum] = ACTIONS(2711),
    [anon_sym_class] = ACTIONS(2711),
    [anon_sym_struct] = ACTIONS(2711),
    [anon_sym_union] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(2711),
    [anon_sym_else] = ACTIONS(2711),
    [anon_sym_switch] = ACTIONS(2711),
    [anon_sym_case] = ACTIONS(2711),
    [anon_sym_default] = ACTIONS(2711),
    [anon_sym_while] = ACTIONS(2711),
    [anon_sym_do] = ACTIONS(2711),
    [anon_sym_for] = ACTIONS(2711),
    [anon_sym_return] = ACTIONS(2711),
    [anon_sym_break] = ACTIONS(2711),
    [anon_sym_continue] = ACTIONS(2711),
    [anon_sym_goto] = ACTIONS(2711),
    [anon_sym___try] = ACTIONS(2711),
    [anon_sym___leave] = ACTIONS(2711),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_compl] = ACTIONS(2711),
    [anon_sym_DASH_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_PLUS] = ACTIONS(2713),
    [anon_sym_sizeof] = ACTIONS(2711),
    [anon_sym___alignof__] = ACTIONS(2711),
    [anon_sym___alignof] = ACTIONS(2711),
    [anon_sym__alignof] = ACTIONS(2711),
    [anon_sym_alignof] = ACTIONS(2711),
    [anon_sym__Alignof] = ACTIONS(2711),
    [anon_sym_offsetof] = ACTIONS(2711),
    [anon_sym__Generic] = ACTIONS(2711),
    [anon_sym_asm] = ACTIONS(2711),
    [anon_sym___asm__] = ACTIONS(2711),
    [anon_sym___asm] = ACTIONS(2711),
    [sym_number_literal] = ACTIONS(2713),
    [anon_sym_L_SQUOTE] = ACTIONS(2713),
    [anon_sym_u_SQUOTE] = ACTIONS(2713),
    [anon_sym_U_SQUOTE] = ACTIONS(2713),
    [anon_sym_u8_SQUOTE] = ACTIONS(2713),
    [anon_sym_SQUOTE] = ACTIONS(2713),
    [anon_sym_L_DQUOTE] = ACTIONS(2713),
    [anon_sym_u_DQUOTE] = ACTIONS(2713),
    [anon_sym_U_DQUOTE] = ACTIONS(2713),
    [anon_sym_u8_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [sym_true] = ACTIONS(2711),
    [sym_false] = ACTIONS(2711),
    [anon_sym_NULL] = ACTIONS(2711),
    [anon_sym_nullptr] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2711),
    [anon_sym_decltype] = ACTIONS(2711),
    [anon_sym_explicit] = ACTIONS(2711),
    [anon_sym_typename] = ACTIONS(2711),
    [anon_sym_template] = ACTIONS(2711),
    [anon_sym_operator] = ACTIONS(2711),
    [anon_sym_try] = ACTIONS(2711),
    [anon_sym_delete] = ACTIONS(2711),
    [anon_sym_throw] = ACTIONS(2711),
    [anon_sym_namespace] = ACTIONS(2711),
    [anon_sym_static_assert] = ACTIONS(2711),
    [anon_sym_concept] = ACTIONS(2711),
    [anon_sym_co_return] = ACTIONS(2711),
    [anon_sym_co_yield] = ACTIONS(2711),
    [anon_sym_R_DQUOTE] = ACTIONS(2713),
    [anon_sym_LR_DQUOTE] = ACTIONS(2713),
    [anon_sym_uR_DQUOTE] = ACTIONS(2713),
    [anon_sym_UR_DQUOTE] = ACTIONS(2713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2713),
    [anon_sym_co_await] = ACTIONS(2711),
    [anon_sym_new] = ACTIONS(2711),
    [anon_sym_requires] = ACTIONS(2711),
    [sym_this] = ACTIONS(2711),
  },
  [267] = {
    [sym_identifier] = ACTIONS(2715),
    [aux_sym_preproc_include_token1] = ACTIONS(2715),
    [aux_sym_preproc_def_token1] = ACTIONS(2715),
    [aux_sym_preproc_if_token1] = ACTIONS(2715),
    [aux_sym_preproc_if_token2] = ACTIONS(2715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2715),
    [aux_sym_preproc_else_token1] = ACTIONS(2715),
    [aux_sym_preproc_elif_token1] = ACTIONS(2715),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2715),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2715),
    [sym_preproc_directive] = ACTIONS(2715),
    [anon_sym_LPAREN2] = ACTIONS(2717),
    [anon_sym_BANG] = ACTIONS(2717),
    [anon_sym_TILDE] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_AMP_AMP] = ACTIONS(2717),
    [anon_sym_AMP] = ACTIONS(2715),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym___extension__] = ACTIONS(2715),
    [anon_sym_typedef] = ACTIONS(2715),
    [anon_sym_virtual] = ACTIONS(2715),
    [anon_sym_extern] = ACTIONS(2715),
    [anon_sym___attribute__] = ACTIONS(2715),
    [anon_sym___attribute] = ACTIONS(2715),
    [anon_sym_using] = ACTIONS(2715),
    [anon_sym_COLON_COLON] = ACTIONS(2717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2717),
    [anon_sym___declspec] = ACTIONS(2715),
    [anon_sym___based] = ACTIONS(2715),
    [anon_sym___cdecl] = ACTIONS(2715),
    [anon_sym___clrcall] = ACTIONS(2715),
    [anon_sym___stdcall] = ACTIONS(2715),
    [anon_sym___fastcall] = ACTIONS(2715),
    [anon_sym___thiscall] = ACTIONS(2715),
    [anon_sym___vectorcall] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_signed] = ACTIONS(2715),
    [anon_sym_unsigned] = ACTIONS(2715),
    [anon_sym_long] = ACTIONS(2715),
    [anon_sym_short] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(2715),
    [anon_sym_static] = ACTIONS(2715),
    [anon_sym_register] = ACTIONS(2715),
    [anon_sym_inline] = ACTIONS(2715),
    [anon_sym___inline] = ACTIONS(2715),
    [anon_sym___inline__] = ACTIONS(2715),
    [anon_sym___forceinline] = ACTIONS(2715),
    [anon_sym_thread_local] = ACTIONS(2715),
    [anon_sym___thread] = ACTIONS(2715),
    [anon_sym_const] = ACTIONS(2715),
    [anon_sym_constexpr] = ACTIONS(2715),
    [anon_sym_volatile] = ACTIONS(2715),
    [anon_sym_restrict] = ACTIONS(2715),
    [anon_sym___restrict__] = ACTIONS(2715),
    [anon_sym__Atomic] = ACTIONS(2715),
    [anon_sym__Noreturn] = ACTIONS(2715),
    [anon_sym_noreturn] = ACTIONS(2715),
    [anon_sym__Nonnull] = ACTIONS(2715),
    [anon_sym_mutable] = ACTIONS(2715),
    [anon_sym_constinit] = ACTIONS(2715),
    [anon_sym_consteval] = ACTIONS(2715),
    [anon_sym_alignas] = ACTIONS(2715),
    [anon_sym__Alignas] = ACTIONS(2715),
    [sym_primitive_type] = ACTIONS(2715),
    [anon_sym_enum] = ACTIONS(2715),
    [anon_sym_class] = ACTIONS(2715),
    [anon_sym_struct] = ACTIONS(2715),
    [anon_sym_union] = ACTIONS(2715),
    [anon_sym_if] = ACTIONS(2715),
    [anon_sym_else] = ACTIONS(2715),
    [anon_sym_switch] = ACTIONS(2715),
    [anon_sym_case] = ACTIONS(2715),
    [anon_sym_default] = ACTIONS(2715),
    [anon_sym_while] = ACTIONS(2715),
    [anon_sym_do] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2715),
    [anon_sym_return] = ACTIONS(2715),
    [anon_sym_break] = ACTIONS(2715),
    [anon_sym_continue] = ACTIONS(2715),
    [anon_sym_goto] = ACTIONS(2715),
    [anon_sym___try] = ACTIONS(2715),
    [anon_sym___leave] = ACTIONS(2715),
    [anon_sym_not] = ACTIONS(2715),
    [anon_sym_compl] = ACTIONS(2715),
    [anon_sym_DASH_DASH] = ACTIONS(2717),
    [anon_sym_PLUS_PLUS] = ACTIONS(2717),
    [anon_sym_sizeof] = ACTIONS(2715),
    [anon_sym___alignof__] = ACTIONS(2715),
    [anon_sym___alignof] = ACTIONS(2715),
    [anon_sym__alignof] = ACTIONS(2715),
    [anon_sym_alignof] = ACTIONS(2715),
    [anon_sym__Alignof] = ACTIONS(2715),
    [anon_sym_offsetof] = ACTIONS(2715),
    [anon_sym__Generic] = ACTIONS(2715),
    [anon_sym_asm] = ACTIONS(2715),
    [anon_sym___asm__] = ACTIONS(2715),
    [anon_sym___asm] = ACTIONS(2715),
    [sym_number_literal] = ACTIONS(2717),
    [anon_sym_L_SQUOTE] = ACTIONS(2717),
    [anon_sym_u_SQUOTE] = ACTIONS(2717),
    [anon_sym_U_SQUOTE] = ACTIONS(2717),
    [anon_sym_u8_SQUOTE] = ACTIONS(2717),
    [anon_sym_SQUOTE] = ACTIONS(2717),
    [anon_sym_L_DQUOTE] = ACTIONS(2717),
    [anon_sym_u_DQUOTE] = ACTIONS(2717),
    [anon_sym_U_DQUOTE] = ACTIONS(2717),
    [anon_sym_u8_DQUOTE] = ACTIONS(2717),
    [anon_sym_DQUOTE] = ACTIONS(2717),
    [sym_true] = ACTIONS(2715),
    [sym_false] = ACTIONS(2715),
    [anon_sym_NULL] = ACTIONS(2715),
    [anon_sym_nullptr] = ACTIONS(2715),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2715),
    [anon_sym_decltype] = ACTIONS(2715),
    [anon_sym_explicit] = ACTIONS(2715),
    [anon_sym_typename] = ACTIONS(2715),
    [anon_sym_template] = ACTIONS(2715),
    [anon_sym_operator] = ACTIONS(2715),
    [anon_sym_try] = ACTIONS(2715),
    [anon_sym_delete] = ACTIONS(2715),
    [anon_sym_throw] = ACTIONS(2715),
    [anon_sym_namespace] = ACTIONS(2715),
    [anon_sym_static_assert] = ACTIONS(2715),
    [anon_sym_concept] = ACTIONS(2715),
    [anon_sym_co_return] = ACTIONS(2715),
    [anon_sym_co_yield] = ACTIONS(2715),
    [anon_sym_R_DQUOTE] = ACTIONS(2717),
    [anon_sym_LR_DQUOTE] = ACTIONS(2717),
    [anon_sym_uR_DQUOTE] = ACTIONS(2717),
    [anon_sym_UR_DQUOTE] = ACTIONS(2717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2717),
    [anon_sym_co_await] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2715),
    [anon_sym_requires] = ACTIONS(2715),
    [sym_this] = ACTIONS(2715),
  },
  [268] = {
    [sym_identifier] = ACTIONS(2719),
    [aux_sym_preproc_include_token1] = ACTIONS(2719),
    [aux_sym_preproc_def_token1] = ACTIONS(2719),
    [aux_sym_preproc_if_token1] = ACTIONS(2719),
    [aux_sym_preproc_if_token2] = ACTIONS(2719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2719),
    [aux_sym_preproc_else_token1] = ACTIONS(2719),
    [aux_sym_preproc_elif_token1] = ACTIONS(2719),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2719),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2719),
    [sym_preproc_directive] = ACTIONS(2719),
    [anon_sym_LPAREN2] = ACTIONS(2721),
    [anon_sym_BANG] = ACTIONS(2721),
    [anon_sym_TILDE] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2719),
    [anon_sym_PLUS] = ACTIONS(2719),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(2719),
    [anon_sym_typedef] = ACTIONS(2719),
    [anon_sym_virtual] = ACTIONS(2719),
    [anon_sym_extern] = ACTIONS(2719),
    [anon_sym___attribute__] = ACTIONS(2719),
    [anon_sym___attribute] = ACTIONS(2719),
    [anon_sym_using] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2721),
    [anon_sym___declspec] = ACTIONS(2719),
    [anon_sym___based] = ACTIONS(2719),
    [anon_sym___cdecl] = ACTIONS(2719),
    [anon_sym___clrcall] = ACTIONS(2719),
    [anon_sym___stdcall] = ACTIONS(2719),
    [anon_sym___fastcall] = ACTIONS(2719),
    [anon_sym___thiscall] = ACTIONS(2719),
    [anon_sym___vectorcall] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2719),
    [anon_sym_unsigned] = ACTIONS(2719),
    [anon_sym_long] = ACTIONS(2719),
    [anon_sym_short] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_static] = ACTIONS(2719),
    [anon_sym_register] = ACTIONS(2719),
    [anon_sym_inline] = ACTIONS(2719),
    [anon_sym___inline] = ACTIONS(2719),
    [anon_sym___inline__] = ACTIONS(2719),
    [anon_sym___forceinline] = ACTIONS(2719),
    [anon_sym_thread_local] = ACTIONS(2719),
    [anon_sym___thread] = ACTIONS(2719),
    [anon_sym_const] = ACTIONS(2719),
    [anon_sym_constexpr] = ACTIONS(2719),
    [anon_sym_volatile] = ACTIONS(2719),
    [anon_sym_restrict] = ACTIONS(2719),
    [anon_sym___restrict__] = ACTIONS(2719),
    [anon_sym__Atomic] = ACTIONS(2719),
    [anon_sym__Noreturn] = ACTIONS(2719),
    [anon_sym_noreturn] = ACTIONS(2719),
    [anon_sym__Nonnull] = ACTIONS(2719),
    [anon_sym_mutable] = ACTIONS(2719),
    [anon_sym_constinit] = ACTIONS(2719),
    [anon_sym_consteval] = ACTIONS(2719),
    [anon_sym_alignas] = ACTIONS(2719),
    [anon_sym__Alignas] = ACTIONS(2719),
    [sym_primitive_type] = ACTIONS(2719),
    [anon_sym_enum] = ACTIONS(2719),
    [anon_sym_class] = ACTIONS(2719),
    [anon_sym_struct] = ACTIONS(2719),
    [anon_sym_union] = ACTIONS(2719),
    [anon_sym_if] = ACTIONS(2719),
    [anon_sym_else] = ACTIONS(2719),
    [anon_sym_switch] = ACTIONS(2719),
    [anon_sym_case] = ACTIONS(2719),
    [anon_sym_default] = ACTIONS(2719),
    [anon_sym_while] = ACTIONS(2719),
    [anon_sym_do] = ACTIONS(2719),
    [anon_sym_for] = ACTIONS(2719),
    [anon_sym_return] = ACTIONS(2719),
    [anon_sym_break] = ACTIONS(2719),
    [anon_sym_continue] = ACTIONS(2719),
    [anon_sym_goto] = ACTIONS(2719),
    [anon_sym___try] = ACTIONS(2719),
    [anon_sym___leave] = ACTIONS(2719),
    [anon_sym_not] = ACTIONS(2719),
    [anon_sym_compl] = ACTIONS(2719),
    [anon_sym_DASH_DASH] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(2721),
    [anon_sym_sizeof] = ACTIONS(2719),
    [anon_sym___alignof__] = ACTIONS(2719),
    [anon_sym___alignof] = ACTIONS(2719),
    [anon_sym__alignof] = ACTIONS(2719),
    [anon_sym_alignof] = ACTIONS(2719),
    [anon_sym__Alignof] = ACTIONS(2719),
    [anon_sym_offsetof] = ACTIONS(2719),
    [anon_sym__Generic] = ACTIONS(2719),
    [anon_sym_asm] = ACTIONS(2719),
    [anon_sym___asm__] = ACTIONS(2719),
    [anon_sym___asm] = ACTIONS(2719),
    [sym_number_literal] = ACTIONS(2721),
    [anon_sym_L_SQUOTE] = ACTIONS(2721),
    [anon_sym_u_SQUOTE] = ACTIONS(2721),
    [anon_sym_U_SQUOTE] = ACTIONS(2721),
    [anon_sym_u8_SQUOTE] = ACTIONS(2721),
    [anon_sym_SQUOTE] = ACTIONS(2721),
    [anon_sym_L_DQUOTE] = ACTIONS(2721),
    [anon_sym_u_DQUOTE] = ACTIONS(2721),
    [anon_sym_U_DQUOTE] = ACTIONS(2721),
    [anon_sym_u8_DQUOTE] = ACTIONS(2721),
    [anon_sym_DQUOTE] = ACTIONS(2721),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [anon_sym_NULL] = ACTIONS(2719),
    [anon_sym_nullptr] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2719),
    [anon_sym_decltype] = ACTIONS(2719),
    [anon_sym_explicit] = ACTIONS(2719),
    [anon_sym_typename] = ACTIONS(2719),
    [anon_sym_template] = ACTIONS(2719),
    [anon_sym_operator] = ACTIONS(2719),
    [anon_sym_try] = ACTIONS(2719),
    [anon_sym_delete] = ACTIONS(2719),
    [anon_sym_throw] = ACTIONS(2719),
    [anon_sym_namespace] = ACTIONS(2719),
    [anon_sym_static_assert] = ACTIONS(2719),
    [anon_sym_concept] = ACTIONS(2719),
    [anon_sym_co_return] = ACTIONS(2719),
    [anon_sym_co_yield] = ACTIONS(2719),
    [anon_sym_R_DQUOTE] = ACTIONS(2721),
    [anon_sym_LR_DQUOTE] = ACTIONS(2721),
    [anon_sym_uR_DQUOTE] = ACTIONS(2721),
    [anon_sym_UR_DQUOTE] = ACTIONS(2721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2721),
    [anon_sym_co_await] = ACTIONS(2719),
    [anon_sym_new] = ACTIONS(2719),
    [anon_sym_requires] = ACTIONS(2719),
    [sym_this] = ACTIONS(2719),
  },
  [269] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [aux_sym_preproc_else_token1] = ACTIONS(2723),
    [aux_sym_preproc_elif_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym___attribute] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym__Nonnull] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym__Alignas] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [anon_sym___asm] = ACTIONS(2723),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [270] = {
    [sym_identifier] = ACTIONS(2727),
    [aux_sym_preproc_include_token1] = ACTIONS(2727),
    [aux_sym_preproc_def_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token2] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2727),
    [aux_sym_preproc_else_token1] = ACTIONS(2727),
    [aux_sym_preproc_elif_token1] = ACTIONS(2727),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2727),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym___extension__] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_virtual] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym___attribute__] = ACTIONS(2727),
    [anon_sym___attribute] = ACTIONS(2727),
    [anon_sym_using] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2729),
    [anon_sym___declspec] = ACTIONS(2727),
    [anon_sym___based] = ACTIONS(2727),
    [anon_sym___cdecl] = ACTIONS(2727),
    [anon_sym___clrcall] = ACTIONS(2727),
    [anon_sym___stdcall] = ACTIONS(2727),
    [anon_sym___fastcall] = ACTIONS(2727),
    [anon_sym___thiscall] = ACTIONS(2727),
    [anon_sym___vectorcall] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_signed] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym___inline] = ACTIONS(2727),
    [anon_sym___inline__] = ACTIONS(2727),
    [anon_sym___forceinline] = ACTIONS(2727),
    [anon_sym_thread_local] = ACTIONS(2727),
    [anon_sym___thread] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_constexpr] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym___restrict__] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym__Noreturn] = ACTIONS(2727),
    [anon_sym_noreturn] = ACTIONS(2727),
    [anon_sym__Nonnull] = ACTIONS(2727),
    [anon_sym_mutable] = ACTIONS(2727),
    [anon_sym_constinit] = ACTIONS(2727),
    [anon_sym_consteval] = ACTIONS(2727),
    [anon_sym_alignas] = ACTIONS(2727),
    [anon_sym__Alignas] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_else] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym___try] = ACTIONS(2727),
    [anon_sym___leave] = ACTIONS(2727),
    [anon_sym_not] = ACTIONS(2727),
    [anon_sym_compl] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [anon_sym___alignof__] = ACTIONS(2727),
    [anon_sym___alignof] = ACTIONS(2727),
    [anon_sym__alignof] = ACTIONS(2727),
    [anon_sym_alignof] = ACTIONS(2727),
    [anon_sym__Alignof] = ACTIONS(2727),
    [anon_sym_offsetof] = ACTIONS(2727),
    [anon_sym__Generic] = ACTIONS(2727),
    [anon_sym_asm] = ACTIONS(2727),
    [anon_sym___asm__] = ACTIONS(2727),
    [anon_sym___asm] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [anon_sym_L_SQUOTE] = ACTIONS(2729),
    [anon_sym_u_SQUOTE] = ACTIONS(2729),
    [anon_sym_U_SQUOTE] = ACTIONS(2729),
    [anon_sym_u8_SQUOTE] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_L_DQUOTE] = ACTIONS(2729),
    [anon_sym_u_DQUOTE] = ACTIONS(2729),
    [anon_sym_U_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [anon_sym_NULL] = ACTIONS(2727),
    [anon_sym_nullptr] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2727),
    [anon_sym_decltype] = ACTIONS(2727),
    [anon_sym_explicit] = ACTIONS(2727),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_template] = ACTIONS(2727),
    [anon_sym_operator] = ACTIONS(2727),
    [anon_sym_try] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2727),
    [anon_sym_throw] = ACTIONS(2727),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_static_assert] = ACTIONS(2727),
    [anon_sym_concept] = ACTIONS(2727),
    [anon_sym_co_return] = ACTIONS(2727),
    [anon_sym_co_yield] = ACTIONS(2727),
    [anon_sym_R_DQUOTE] = ACTIONS(2729),
    [anon_sym_LR_DQUOTE] = ACTIONS(2729),
    [anon_sym_uR_DQUOTE] = ACTIONS(2729),
    [anon_sym_UR_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2729),
    [anon_sym_co_await] = ACTIONS(2727),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_requires] = ACTIONS(2727),
    [sym_this] = ACTIONS(2727),
  },
  [271] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [aux_sym_preproc_else_token1] = ACTIONS(2731),
    [aux_sym_preproc_elif_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [anon_sym___asm] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [272] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token2] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [aux_sym_preproc_else_token1] = ACTIONS(2735),
    [aux_sym_preproc_elif_token1] = ACTIONS(2735),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [anon_sym___asm] = ACTIONS(2735),
    [sym_number_literal] = ACTIONS(2737),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [273] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token2] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [aux_sym_preproc_else_token1] = ACTIONS(2739),
    [aux_sym_preproc_elif_token1] = ACTIONS(2739),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [anon_sym___asm] = ACTIONS(2739),
    [sym_number_literal] = ACTIONS(2741),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [274] = {
    [sym_identifier] = ACTIONS(2743),
    [aux_sym_preproc_include_token1] = ACTIONS(2743),
    [aux_sym_preproc_def_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token2] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2743),
    [aux_sym_preproc_else_token1] = ACTIONS(2743),
    [aux_sym_preproc_elif_token1] = ACTIONS(2743),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2743),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2743),
    [sym_preproc_directive] = ACTIONS(2743),
    [anon_sym_LPAREN2] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym___extension__] = ACTIONS(2743),
    [anon_sym_typedef] = ACTIONS(2743),
    [anon_sym_virtual] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym___attribute__] = ACTIONS(2743),
    [anon_sym___attribute] = ACTIONS(2743),
    [anon_sym_using] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(2745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2745),
    [anon_sym___declspec] = ACTIONS(2743),
    [anon_sym___based] = ACTIONS(2743),
    [anon_sym___cdecl] = ACTIONS(2743),
    [anon_sym___clrcall] = ACTIONS(2743),
    [anon_sym___stdcall] = ACTIONS(2743),
    [anon_sym___fastcall] = ACTIONS(2743),
    [anon_sym___thiscall] = ACTIONS(2743),
    [anon_sym___vectorcall] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_signed] = ACTIONS(2743),
    [anon_sym_unsigned] = ACTIONS(2743),
    [anon_sym_long] = ACTIONS(2743),
    [anon_sym_short] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_register] = ACTIONS(2743),
    [anon_sym_inline] = ACTIONS(2743),
    [anon_sym___inline] = ACTIONS(2743),
    [anon_sym___inline__] = ACTIONS(2743),
    [anon_sym___forceinline] = ACTIONS(2743),
    [anon_sym_thread_local] = ACTIONS(2743),
    [anon_sym___thread] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_constexpr] = ACTIONS(2743),
    [anon_sym_volatile] = ACTIONS(2743),
    [anon_sym_restrict] = ACTIONS(2743),
    [anon_sym___restrict__] = ACTIONS(2743),
    [anon_sym__Atomic] = ACTIONS(2743),
    [anon_sym__Noreturn] = ACTIONS(2743),
    [anon_sym_noreturn] = ACTIONS(2743),
    [anon_sym__Nonnull] = ACTIONS(2743),
    [anon_sym_mutable] = ACTIONS(2743),
    [anon_sym_constinit] = ACTIONS(2743),
    [anon_sym_consteval] = ACTIONS(2743),
    [anon_sym_alignas] = ACTIONS(2743),
    [anon_sym__Alignas] = ACTIONS(2743),
    [sym_primitive_type] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2743),
    [anon_sym_switch] = ACTIONS(2743),
    [anon_sym_case] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_goto] = ACTIONS(2743),
    [anon_sym___try] = ACTIONS(2743),
    [anon_sym___leave] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2743),
    [anon_sym_compl] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2745),
    [anon_sym_sizeof] = ACTIONS(2743),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2743),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2743),
    [anon_sym___asm__] = ACTIONS(2743),
    [anon_sym___asm] = ACTIONS(2743),
    [sym_number_literal] = ACTIONS(2745),
    [anon_sym_L_SQUOTE] = ACTIONS(2745),
    [anon_sym_u_SQUOTE] = ACTIONS(2745),
    [anon_sym_U_SQUOTE] = ACTIONS(2745),
    [anon_sym_u8_SQUOTE] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2745),
    [anon_sym_L_DQUOTE] = ACTIONS(2745),
    [anon_sym_u_DQUOTE] = ACTIONS(2745),
    [anon_sym_U_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8_DQUOTE] = ACTIONS(2745),
    [anon_sym_DQUOTE] = ACTIONS(2745),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [anon_sym_NULL] = ACTIONS(2743),
    [anon_sym_nullptr] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2743),
    [anon_sym_decltype] = ACTIONS(2743),
    [anon_sym_explicit] = ACTIONS(2743),
    [anon_sym_typename] = ACTIONS(2743),
    [anon_sym_template] = ACTIONS(2743),
    [anon_sym_operator] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [anon_sym_delete] = ACTIONS(2743),
    [anon_sym_throw] = ACTIONS(2743),
    [anon_sym_namespace] = ACTIONS(2743),
    [anon_sym_static_assert] = ACTIONS(2743),
    [anon_sym_concept] = ACTIONS(2743),
    [anon_sym_co_return] = ACTIONS(2743),
    [anon_sym_co_yield] = ACTIONS(2743),
    [anon_sym_R_DQUOTE] = ACTIONS(2745),
    [anon_sym_LR_DQUOTE] = ACTIONS(2745),
    [anon_sym_uR_DQUOTE] = ACTIONS(2745),
    [anon_sym_UR_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2745),
    [anon_sym_co_await] = ACTIONS(2743),
    [anon_sym_new] = ACTIONS(2743),
    [anon_sym_requires] = ACTIONS(2743),
    [sym_this] = ACTIONS(2743),
  },
  [275] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [aux_sym_preproc_else_token1] = ACTIONS(2747),
    [aux_sym_preproc_elif_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [276] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token2] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [aux_sym_preproc_else_token1] = ACTIONS(2751),
    [aux_sym_preproc_elif_token1] = ACTIONS(2751),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [anon_sym___asm] = ACTIONS(2751),
    [sym_number_literal] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [277] = {
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token2] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [aux_sym_preproc_else_token1] = ACTIONS(2755),
    [aux_sym_preproc_elif_token1] = ACTIONS(2755),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym___attribute] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym__Nonnull] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym__Alignas] = ACTIONS(2755),
    [sym_primitive_type] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [anon_sym___asm] = ACTIONS(2755),
    [sym_number_literal] = ACTIONS(2757),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [278] = {
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_include_token1] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token2] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [aux_sym_preproc_else_token1] = ACTIONS(2759),
    [aux_sym_preproc_elif_token1] = ACTIONS(2759),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym___cdecl] = ACTIONS(2759),
    [anon_sym___clrcall] = ACTIONS(2759),
    [anon_sym___stdcall] = ACTIONS(2759),
    [anon_sym___fastcall] = ACTIONS(2759),
    [anon_sym___thiscall] = ACTIONS(2759),
    [anon_sym___vectorcall] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_switch] = ACTIONS(2759),
    [anon_sym_case] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_goto] = ACTIONS(2759),
    [anon_sym___try] = ACTIONS(2759),
    [anon_sym___leave] = ACTIONS(2759),
    [anon_sym_not] = ACTIONS(2759),
    [anon_sym_compl] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_sizeof] = ACTIONS(2759),
    [anon_sym___alignof__] = ACTIONS(2759),
    [anon_sym___alignof] = ACTIONS(2759),
    [anon_sym__alignof] = ACTIONS(2759),
    [anon_sym_alignof] = ACTIONS(2759),
    [anon_sym__Alignof] = ACTIONS(2759),
    [anon_sym_offsetof] = ACTIONS(2759),
    [anon_sym__Generic] = ACTIONS(2759),
    [anon_sym_asm] = ACTIONS(2759),
    [anon_sym___asm__] = ACTIONS(2759),
    [anon_sym___asm] = ACTIONS(2759),
    [sym_number_literal] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2761),
    [anon_sym_u_SQUOTE] = ACTIONS(2761),
    [anon_sym_U_SQUOTE] = ACTIONS(2761),
    [anon_sym_u8_SQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_L_DQUOTE] = ACTIONS(2761),
    [anon_sym_u_DQUOTE] = ACTIONS(2761),
    [anon_sym_U_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8_DQUOTE] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2759),
    [anon_sym_nullptr] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2759),
    [anon_sym_throw] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
    [anon_sym_concept] = ACTIONS(2759),
    [anon_sym_co_return] = ACTIONS(2759),
    [anon_sym_co_yield] = ACTIONS(2759),
    [anon_sym_R_DQUOTE] = ACTIONS(2761),
    [anon_sym_LR_DQUOTE] = ACTIONS(2761),
    [anon_sym_uR_DQUOTE] = ACTIONS(2761),
    [anon_sym_UR_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2761),
    [anon_sym_co_await] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_requires] = ACTIONS(2759),
    [sym_this] = ACTIONS(2759),
  },
  [279] = {
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_include_token1] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token2] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [aux_sym_preproc_else_token1] = ACTIONS(2763),
    [aux_sym_preproc_elif_token1] = ACTIONS(2763),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym___cdecl] = ACTIONS(2763),
    [anon_sym___clrcall] = ACTIONS(2763),
    [anon_sym___stdcall] = ACTIONS(2763),
    [anon_sym___fastcall] = ACTIONS(2763),
    [anon_sym___thiscall] = ACTIONS(2763),
    [anon_sym___vectorcall] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_else] = ACTIONS(2763),
    [anon_sym_switch] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2763),
    [anon_sym_default] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_do] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_goto] = ACTIONS(2763),
    [anon_sym___try] = ACTIONS(2763),
    [anon_sym___leave] = ACTIONS(2763),
    [anon_sym_not] = ACTIONS(2763),
    [anon_sym_compl] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_sizeof] = ACTIONS(2763),
    [anon_sym___alignof__] = ACTIONS(2763),
    [anon_sym___alignof] = ACTIONS(2763),
    [anon_sym__alignof] = ACTIONS(2763),
    [anon_sym_alignof] = ACTIONS(2763),
    [anon_sym__Alignof] = ACTIONS(2763),
    [anon_sym_offsetof] = ACTIONS(2763),
    [anon_sym__Generic] = ACTIONS(2763),
    [anon_sym_asm] = ACTIONS(2763),
    [anon_sym___asm__] = ACTIONS(2763),
    [anon_sym___asm] = ACTIONS(2763),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2765),
    [anon_sym_u_SQUOTE] = ACTIONS(2765),
    [anon_sym_U_SQUOTE] = ACTIONS(2765),
    [anon_sym_u8_SQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_L_DQUOTE] = ACTIONS(2765),
    [anon_sym_u_DQUOTE] = ACTIONS(2765),
    [anon_sym_U_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8_DQUOTE] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [anon_sym_NULL] = ACTIONS(2763),
    [anon_sym_nullptr] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_throw] = ACTIONS(2763),
    [anon_sym_namespace] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
    [anon_sym_concept] = ACTIONS(2763),
    [anon_sym_co_return] = ACTIONS(2763),
    [anon_sym_co_yield] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2763),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_requires] = ACTIONS(2763),
    [sym_this] = ACTIONS(2763),
  },
  [280] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [aux_sym_preproc_else_token1] = ACTIONS(2767),
    [aux_sym_preproc_elif_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [281] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [aux_sym_preproc_else_token1] = ACTIONS(2767),
    [aux_sym_preproc_elif_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(2621),
    [sym_identifier] = ACTIONS(2619),
    [aux_sym_preproc_include_token1] = ACTIONS(2619),
    [aux_sym_preproc_def_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token1] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2619),
    [sym_preproc_directive] = ACTIONS(2619),
    [anon_sym_LPAREN2] = ACTIONS(2621),
    [anon_sym_BANG] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(2619),
    [anon_sym_PLUS] = ACTIONS(2619),
    [anon_sym_STAR] = ACTIONS(2621),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(2619),
    [anon_sym_typedef] = ACTIONS(2619),
    [anon_sym_virtual] = ACTIONS(2619),
    [anon_sym_extern] = ACTIONS(2619),
    [anon_sym___attribute__] = ACTIONS(2619),
    [anon_sym___attribute] = ACTIONS(2619),
    [anon_sym_using] = ACTIONS(2619),
    [anon_sym_COLON_COLON] = ACTIONS(2621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2621),
    [anon_sym___declspec] = ACTIONS(2619),
    [anon_sym___based] = ACTIONS(2619),
    [anon_sym___cdecl] = ACTIONS(2619),
    [anon_sym___clrcall] = ACTIONS(2619),
    [anon_sym___stdcall] = ACTIONS(2619),
    [anon_sym___fastcall] = ACTIONS(2619),
    [anon_sym___thiscall] = ACTIONS(2619),
    [anon_sym___vectorcall] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_signed] = ACTIONS(2619),
    [anon_sym_unsigned] = ACTIONS(2619),
    [anon_sym_long] = ACTIONS(2619),
    [anon_sym_short] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_register] = ACTIONS(2619),
    [anon_sym_inline] = ACTIONS(2619),
    [anon_sym___inline] = ACTIONS(2619),
    [anon_sym___inline__] = ACTIONS(2619),
    [anon_sym___forceinline] = ACTIONS(2619),
    [anon_sym_thread_local] = ACTIONS(2619),
    [anon_sym___thread] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_constexpr] = ACTIONS(2619),
    [anon_sym_volatile] = ACTIONS(2619),
    [anon_sym_restrict] = ACTIONS(2619),
    [anon_sym___restrict__] = ACTIONS(2619),
    [anon_sym__Atomic] = ACTIONS(2619),
    [anon_sym__Noreturn] = ACTIONS(2619),
    [anon_sym_noreturn] = ACTIONS(2619),
    [anon_sym__Nonnull] = ACTIONS(2619),
    [anon_sym_mutable] = ACTIONS(2619),
    [anon_sym_constinit] = ACTIONS(2619),
    [anon_sym_consteval] = ACTIONS(2619),
    [anon_sym_alignas] = ACTIONS(2619),
    [anon_sym__Alignas] = ACTIONS(2619),
    [sym_primitive_type] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_struct] = ACTIONS(2619),
    [anon_sym_union] = ACTIONS(2619),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_else] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2619),
    [anon_sym_case] = ACTIONS(2619),
    [anon_sym_default] = ACTIONS(2619),
    [anon_sym_while] = ACTIONS(2619),
    [anon_sym_do] = ACTIONS(2619),
    [anon_sym_for] = ACTIONS(2619),
    [anon_sym_return] = ACTIONS(2619),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_continue] = ACTIONS(2619),
    [anon_sym_goto] = ACTIONS(2619),
    [anon_sym___try] = ACTIONS(2619),
    [anon_sym___leave] = ACTIONS(2619),
    [anon_sym_not] = ACTIONS(2619),
    [anon_sym_compl] = ACTIONS(2619),
    [anon_sym_DASH_DASH] = ACTIONS(2621),
    [anon_sym_PLUS_PLUS] = ACTIONS(2621),
    [anon_sym_sizeof] = ACTIONS(2619),
    [anon_sym___alignof__] = ACTIONS(2619),
    [anon_sym___alignof] = ACTIONS(2619),
    [anon_sym__alignof] = ACTIONS(2619),
    [anon_sym_alignof] = ACTIONS(2619),
    [anon_sym__Alignof] = ACTIONS(2619),
    [anon_sym_offsetof] = ACTIONS(2619),
    [anon_sym__Generic] = ACTIONS(2619),
    [anon_sym_asm] = ACTIONS(2619),
    [anon_sym___asm__] = ACTIONS(2619),
    [anon_sym___asm] = ACTIONS(2619),
    [sym_number_literal] = ACTIONS(2621),
    [anon_sym_L_SQUOTE] = ACTIONS(2621),
    [anon_sym_u_SQUOTE] = ACTIONS(2621),
    [anon_sym_U_SQUOTE] = ACTIONS(2621),
    [anon_sym_u8_SQUOTE] = ACTIONS(2621),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [anon_sym_L_DQUOTE] = ACTIONS(2621),
    [anon_sym_u_DQUOTE] = ACTIONS(2621),
    [anon_sym_U_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8_DQUOTE] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [sym_true] = ACTIONS(2619),
    [sym_false] = ACTIONS(2619),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2619),
    [anon_sym_decltype] = ACTIONS(2619),
    [anon_sym_explicit] = ACTIONS(2619),
    [anon_sym_typename] = ACTIONS(2619),
    [anon_sym_export] = ACTIONS(2619),
    [anon_sym_module] = ACTIONS(2619),
    [anon_sym_import] = ACTIONS(2619),
    [anon_sym_template] = ACTIONS(2619),
    [anon_sym_operator] = ACTIONS(2619),
    [anon_sym_try] = ACTIONS(2619),
    [anon_sym_delete] = ACTIONS(2619),
    [anon_sym_throw] = ACTIONS(2619),
    [anon_sym_namespace] = ACTIONS(2619),
    [anon_sym_static_assert] = ACTIONS(2619),
    [anon_sym_concept] = ACTIONS(2619),
    [anon_sym_co_return] = ACTIONS(2619),
    [anon_sym_co_yield] = ACTIONS(2619),
    [anon_sym_catch] = ACTIONS(2619),
    [anon_sym_R_DQUOTE] = ACTIONS(2621),
    [anon_sym_LR_DQUOTE] = ACTIONS(2621),
    [anon_sym_uR_DQUOTE] = ACTIONS(2621),
    [anon_sym_UR_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2621),
    [anon_sym_co_await] = ACTIONS(2619),
    [anon_sym_new] = ACTIONS(2619),
    [anon_sym_requires] = ACTIONS(2619),
    [sym_this] = ACTIONS(2619),
  },
  [283] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_include_token1] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token2] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [aux_sym_preproc_else_token1] = ACTIONS(2771),
    [aux_sym_preproc_elif_token1] = ACTIONS(2771),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_BANG] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym___cdecl] = ACTIONS(2771),
    [anon_sym___clrcall] = ACTIONS(2771),
    [anon_sym___stdcall] = ACTIONS(2771),
    [anon_sym___fastcall] = ACTIONS(2771),
    [anon_sym___thiscall] = ACTIONS(2771),
    [anon_sym___vectorcall] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_switch] = ACTIONS(2771),
    [anon_sym_case] = ACTIONS(2771),
    [anon_sym_default] = ACTIONS(2771),
    [anon_sym_while] = ACTIONS(2771),
    [anon_sym_do] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2771),
    [anon_sym_return] = ACTIONS(2771),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_continue] = ACTIONS(2771),
    [anon_sym_goto] = ACTIONS(2771),
    [anon_sym___try] = ACTIONS(2771),
    [anon_sym___leave] = ACTIONS(2771),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_compl] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2773),
    [anon_sym_PLUS_PLUS] = ACTIONS(2773),
    [anon_sym_sizeof] = ACTIONS(2771),
    [anon_sym___alignof__] = ACTIONS(2771),
    [anon_sym___alignof] = ACTIONS(2771),
    [anon_sym__alignof] = ACTIONS(2771),
    [anon_sym_alignof] = ACTIONS(2771),
    [anon_sym__Alignof] = ACTIONS(2771),
    [anon_sym_offsetof] = ACTIONS(2771),
    [anon_sym__Generic] = ACTIONS(2771),
    [anon_sym_asm] = ACTIONS(2771),
    [anon_sym___asm__] = ACTIONS(2771),
    [anon_sym___asm] = ACTIONS(2771),
    [sym_number_literal] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2773),
    [anon_sym_u_SQUOTE] = ACTIONS(2773),
    [anon_sym_U_SQUOTE] = ACTIONS(2773),
    [anon_sym_u8_SQUOTE] = ACTIONS(2773),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [anon_sym_L_DQUOTE] = ACTIONS(2773),
    [anon_sym_u_DQUOTE] = ACTIONS(2773),
    [anon_sym_U_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8_DQUOTE] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(2773),
    [sym_true] = ACTIONS(2771),
    [sym_false] = ACTIONS(2771),
    [anon_sym_NULL] = ACTIONS(2771),
    [anon_sym_nullptr] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_try] = ACTIONS(2771),
    [anon_sym_delete] = ACTIONS(2771),
    [anon_sym_throw] = ACTIONS(2771),
    [anon_sym_namespace] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
    [anon_sym_concept] = ACTIONS(2771),
    [anon_sym_co_return] = ACTIONS(2771),
    [anon_sym_co_yield] = ACTIONS(2771),
    [anon_sym_R_DQUOTE] = ACTIONS(2773),
    [anon_sym_LR_DQUOTE] = ACTIONS(2773),
    [anon_sym_uR_DQUOTE] = ACTIONS(2773),
    [anon_sym_UR_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2773),
    [anon_sym_co_await] = ACTIONS(2771),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2771),
  },
  [284] = {
    [sym_identifier] = ACTIONS(2775),
    [aux_sym_preproc_include_token1] = ACTIONS(2775),
    [aux_sym_preproc_def_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token2] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2775),
    [aux_sym_preproc_else_token1] = ACTIONS(2775),
    [aux_sym_preproc_elif_token1] = ACTIONS(2775),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2775),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2775),
    [sym_preproc_directive] = ACTIONS(2775),
    [anon_sym_LPAREN2] = ACTIONS(2777),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_TILDE] = ACTIONS(2777),
    [anon_sym_DASH] = ACTIONS(2775),
    [anon_sym_PLUS] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym___extension__] = ACTIONS(2775),
    [anon_sym_typedef] = ACTIONS(2775),
    [anon_sym_virtual] = ACTIONS(2775),
    [anon_sym_extern] = ACTIONS(2775),
    [anon_sym___attribute__] = ACTIONS(2775),
    [anon_sym___attribute] = ACTIONS(2775),
    [anon_sym_using] = ACTIONS(2775),
    [anon_sym_COLON_COLON] = ACTIONS(2777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2777),
    [anon_sym___declspec] = ACTIONS(2775),
    [anon_sym___based] = ACTIONS(2775),
    [anon_sym___cdecl] = ACTIONS(2775),
    [anon_sym___clrcall] = ACTIONS(2775),
    [anon_sym___stdcall] = ACTIONS(2775),
    [anon_sym___fastcall] = ACTIONS(2775),
    [anon_sym___thiscall] = ACTIONS(2775),
    [anon_sym___vectorcall] = ACTIONS(2775),
    [anon_sym_LBRACE] = ACTIONS(2777),
    [anon_sym_signed] = ACTIONS(2775),
    [anon_sym_unsigned] = ACTIONS(2775),
    [anon_sym_long] = ACTIONS(2775),
    [anon_sym_short] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_static] = ACTIONS(2775),
    [anon_sym_register] = ACTIONS(2775),
    [anon_sym_inline] = ACTIONS(2775),
    [anon_sym___inline] = ACTIONS(2775),
    [anon_sym___inline__] = ACTIONS(2775),
    [anon_sym___forceinline] = ACTIONS(2775),
    [anon_sym_thread_local] = ACTIONS(2775),
    [anon_sym___thread] = ACTIONS(2775),
    [anon_sym_const] = ACTIONS(2775),
    [anon_sym_constexpr] = ACTIONS(2775),
    [anon_sym_volatile] = ACTIONS(2775),
    [anon_sym_restrict] = ACTIONS(2775),
    [anon_sym___restrict__] = ACTIONS(2775),
    [anon_sym__Atomic] = ACTIONS(2775),
    [anon_sym__Noreturn] = ACTIONS(2775),
    [anon_sym_noreturn] = ACTIONS(2775),
    [anon_sym__Nonnull] = ACTIONS(2775),
    [anon_sym_mutable] = ACTIONS(2775),
    [anon_sym_constinit] = ACTIONS(2775),
    [anon_sym_consteval] = ACTIONS(2775),
    [anon_sym_alignas] = ACTIONS(2775),
    [anon_sym__Alignas] = ACTIONS(2775),
    [sym_primitive_type] = ACTIONS(2775),
    [anon_sym_enum] = ACTIONS(2775),
    [anon_sym_class] = ACTIONS(2775),
    [anon_sym_struct] = ACTIONS(2775),
    [anon_sym_union] = ACTIONS(2775),
    [anon_sym_if] = ACTIONS(2775),
    [anon_sym_switch] = ACTIONS(2775),
    [anon_sym_case] = ACTIONS(2775),
    [anon_sym_default] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(2775),
    [anon_sym_do] = ACTIONS(2775),
    [anon_sym_for] = ACTIONS(2775),
    [anon_sym_return] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2775),
    [anon_sym_continue] = ACTIONS(2775),
    [anon_sym_goto] = ACTIONS(2775),
    [anon_sym___try] = ACTIONS(2775),
    [anon_sym___leave] = ACTIONS(2775),
    [anon_sym_not] = ACTIONS(2775),
    [anon_sym_compl] = ACTIONS(2775),
    [anon_sym_DASH_DASH] = ACTIONS(2777),
    [anon_sym_PLUS_PLUS] = ACTIONS(2777),
    [anon_sym_sizeof] = ACTIONS(2775),
    [anon_sym___alignof__] = ACTIONS(2775),
    [anon_sym___alignof] = ACTIONS(2775),
    [anon_sym__alignof] = ACTIONS(2775),
    [anon_sym_alignof] = ACTIONS(2775),
    [anon_sym__Alignof] = ACTIONS(2775),
    [anon_sym_offsetof] = ACTIONS(2775),
    [anon_sym__Generic] = ACTIONS(2775),
    [anon_sym_asm] = ACTIONS(2775),
    [anon_sym___asm__] = ACTIONS(2775),
    [anon_sym___asm] = ACTIONS(2775),
    [sym_number_literal] = ACTIONS(2777),
    [anon_sym_L_SQUOTE] = ACTIONS(2777),
    [anon_sym_u_SQUOTE] = ACTIONS(2777),
    [anon_sym_U_SQUOTE] = ACTIONS(2777),
    [anon_sym_u8_SQUOTE] = ACTIONS(2777),
    [anon_sym_SQUOTE] = ACTIONS(2777),
    [anon_sym_L_DQUOTE] = ACTIONS(2777),
    [anon_sym_u_DQUOTE] = ACTIONS(2777),
    [anon_sym_U_DQUOTE] = ACTIONS(2777),
    [anon_sym_u8_DQUOTE] = ACTIONS(2777),
    [anon_sym_DQUOTE] = ACTIONS(2777),
    [sym_true] = ACTIONS(2775),
    [sym_false] = ACTIONS(2775),
    [anon_sym_NULL] = ACTIONS(2775),
    [anon_sym_nullptr] = ACTIONS(2775),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2775),
    [anon_sym_decltype] = ACTIONS(2775),
    [anon_sym_explicit] = ACTIONS(2775),
    [anon_sym_typename] = ACTIONS(2775),
    [anon_sym_template] = ACTIONS(2775),
    [anon_sym_operator] = ACTIONS(2775),
    [anon_sym_try] = ACTIONS(2775),
    [anon_sym_delete] = ACTIONS(2775),
    [anon_sym_throw] = ACTIONS(2775),
    [anon_sym_namespace] = ACTIONS(2775),
    [anon_sym_static_assert] = ACTIONS(2775),
    [anon_sym_concept] = ACTIONS(2775),
    [anon_sym_co_return] = ACTIONS(2775),
    [anon_sym_co_yield] = ACTIONS(2775),
    [anon_sym_R_DQUOTE] = ACTIONS(2777),
    [anon_sym_LR_DQUOTE] = ACTIONS(2777),
    [anon_sym_uR_DQUOTE] = ACTIONS(2777),
    [anon_sym_UR_DQUOTE] = ACTIONS(2777),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2777),
    [anon_sym_co_await] = ACTIONS(2775),
    [anon_sym_new] = ACTIONS(2775),
    [anon_sym_requires] = ACTIONS(2775),
    [sym_this] = ACTIONS(2775),
  },
  [285] = {
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_include_token1] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token2] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [aux_sym_preproc_else_token1] = ACTIONS(2779),
    [aux_sym_preproc_elif_token1] = ACTIONS(2779),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym___attribute] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym___cdecl] = ACTIONS(2779),
    [anon_sym___clrcall] = ACTIONS(2779),
    [anon_sym___stdcall] = ACTIONS(2779),
    [anon_sym___fastcall] = ACTIONS(2779),
    [anon_sym___thiscall] = ACTIONS(2779),
    [anon_sym___vectorcall] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym__Nonnull] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym__Alignas] = ACTIONS(2779),
    [sym_primitive_type] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_switch] = ACTIONS(2779),
    [anon_sym_case] = ACTIONS(2779),
    [anon_sym_default] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [anon_sym_do] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2779),
    [anon_sym_continue] = ACTIONS(2779),
    [anon_sym_goto] = ACTIONS(2779),
    [anon_sym___try] = ACTIONS(2779),
    [anon_sym___leave] = ACTIONS(2779),
    [anon_sym_not] = ACTIONS(2779),
    [anon_sym_compl] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2781),
    [anon_sym_sizeof] = ACTIONS(2779),
    [anon_sym___alignof__] = ACTIONS(2779),
    [anon_sym___alignof] = ACTIONS(2779),
    [anon_sym__alignof] = ACTIONS(2779),
    [anon_sym_alignof] = ACTIONS(2779),
    [anon_sym__Alignof] = ACTIONS(2779),
    [anon_sym_offsetof] = ACTIONS(2779),
    [anon_sym__Generic] = ACTIONS(2779),
    [anon_sym_asm] = ACTIONS(2779),
    [anon_sym___asm__] = ACTIONS(2779),
    [anon_sym___asm] = ACTIONS(2779),
    [sym_number_literal] = ACTIONS(2781),
    [anon_sym_L_SQUOTE] = ACTIONS(2781),
    [anon_sym_u_SQUOTE] = ACTIONS(2781),
    [anon_sym_U_SQUOTE] = ACTIONS(2781),
    [anon_sym_u8_SQUOTE] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_L_DQUOTE] = ACTIONS(2781),
    [anon_sym_u_DQUOTE] = ACTIONS(2781),
    [anon_sym_U_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8_DQUOTE] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2781),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [anon_sym_NULL] = ACTIONS(2779),
    [anon_sym_nullptr] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_delete] = ACTIONS(2779),
    [anon_sym_throw] = ACTIONS(2779),
    [anon_sym_namespace] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
    [anon_sym_concept] = ACTIONS(2779),
    [anon_sym_co_return] = ACTIONS(2779),
    [anon_sym_co_yield] = ACTIONS(2779),
    [anon_sym_R_DQUOTE] = ACTIONS(2781),
    [anon_sym_LR_DQUOTE] = ACTIONS(2781),
    [anon_sym_uR_DQUOTE] = ACTIONS(2781),
    [anon_sym_UR_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2781),
    [anon_sym_co_await] = ACTIONS(2779),
    [anon_sym_new] = ACTIONS(2779),
    [anon_sym_requires] = ACTIONS(2779),
    [sym_this] = ACTIONS(2779),
  },
  [286] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_include_token1] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token2] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [aux_sym_preproc_else_token1] = ACTIONS(2783),
    [aux_sym_preproc_elif_token1] = ACTIONS(2783),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym___attribute] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym___cdecl] = ACTIONS(2783),
    [anon_sym___clrcall] = ACTIONS(2783),
    [anon_sym___stdcall] = ACTIONS(2783),
    [anon_sym___fastcall] = ACTIONS(2783),
    [anon_sym___thiscall] = ACTIONS(2783),
    [anon_sym___vectorcall] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym__Nonnull] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym__Alignas] = ACTIONS(2783),
    [sym_primitive_type] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_switch] = ACTIONS(2783),
    [anon_sym_case] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_goto] = ACTIONS(2783),
    [anon_sym___try] = ACTIONS(2783),
    [anon_sym___leave] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_compl] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_sizeof] = ACTIONS(2783),
    [anon_sym___alignof__] = ACTIONS(2783),
    [anon_sym___alignof] = ACTIONS(2783),
    [anon_sym__alignof] = ACTIONS(2783),
    [anon_sym_alignof] = ACTIONS(2783),
    [anon_sym__Alignof] = ACTIONS(2783),
    [anon_sym_offsetof] = ACTIONS(2783),
    [anon_sym__Generic] = ACTIONS(2783),
    [anon_sym_asm] = ACTIONS(2783),
    [anon_sym___asm__] = ACTIONS(2783),
    [anon_sym___asm] = ACTIONS(2783),
    [sym_number_literal] = ACTIONS(2785),
    [anon_sym_L_SQUOTE] = ACTIONS(2785),
    [anon_sym_u_SQUOTE] = ACTIONS(2785),
    [anon_sym_U_SQUOTE] = ACTIONS(2785),
    [anon_sym_u8_SQUOTE] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_L_DQUOTE] = ACTIONS(2785),
    [anon_sym_u_DQUOTE] = ACTIONS(2785),
    [anon_sym_U_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [anon_sym_NULL] = ACTIONS(2783),
    [anon_sym_nullptr] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_throw] = ACTIONS(2783),
    [anon_sym_namespace] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
    [anon_sym_concept] = ACTIONS(2783),
    [anon_sym_co_return] = ACTIONS(2783),
    [anon_sym_co_yield] = ACTIONS(2783),
    [anon_sym_R_DQUOTE] = ACTIONS(2785),
    [anon_sym_LR_DQUOTE] = ACTIONS(2785),
    [anon_sym_uR_DQUOTE] = ACTIONS(2785),
    [anon_sym_UR_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2785),
    [anon_sym_co_await] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_requires] = ACTIONS(2783),
    [sym_this] = ACTIONS(2783),
  },
  [287] = {
    [sym_identifier] = ACTIONS(2787),
    [aux_sym_preproc_include_token1] = ACTIONS(2787),
    [aux_sym_preproc_def_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token2] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2787),
    [aux_sym_preproc_else_token1] = ACTIONS(2787),
    [aux_sym_preproc_elif_token1] = ACTIONS(2787),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2787),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2787),
    [sym_preproc_directive] = ACTIONS(2787),
    [anon_sym_LPAREN2] = ACTIONS(2789),
    [anon_sym_BANG] = ACTIONS(2789),
    [anon_sym_TILDE] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym___extension__] = ACTIONS(2787),
    [anon_sym_typedef] = ACTIONS(2787),
    [anon_sym_virtual] = ACTIONS(2787),
    [anon_sym_extern] = ACTIONS(2787),
    [anon_sym___attribute__] = ACTIONS(2787),
    [anon_sym___attribute] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2789),
    [anon_sym___declspec] = ACTIONS(2787),
    [anon_sym___based] = ACTIONS(2787),
    [anon_sym___cdecl] = ACTIONS(2787),
    [anon_sym___clrcall] = ACTIONS(2787),
    [anon_sym___stdcall] = ACTIONS(2787),
    [anon_sym___fastcall] = ACTIONS(2787),
    [anon_sym___thiscall] = ACTIONS(2787),
    [anon_sym___vectorcall] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_signed] = ACTIONS(2787),
    [anon_sym_unsigned] = ACTIONS(2787),
    [anon_sym_long] = ACTIONS(2787),
    [anon_sym_short] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_static] = ACTIONS(2787),
    [anon_sym_register] = ACTIONS(2787),
    [anon_sym_inline] = ACTIONS(2787),
    [anon_sym___inline] = ACTIONS(2787),
    [anon_sym___inline__] = ACTIONS(2787),
    [anon_sym___forceinline] = ACTIONS(2787),
    [anon_sym_thread_local] = ACTIONS(2787),
    [anon_sym___thread] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_constexpr] = ACTIONS(2787),
    [anon_sym_volatile] = ACTIONS(2787),
    [anon_sym_restrict] = ACTIONS(2787),
    [anon_sym___restrict__] = ACTIONS(2787),
    [anon_sym__Atomic] = ACTIONS(2787),
    [anon_sym__Noreturn] = ACTIONS(2787),
    [anon_sym_noreturn] = ACTIONS(2787),
    [anon_sym__Nonnull] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_constinit] = ACTIONS(2787),
    [anon_sym_consteval] = ACTIONS(2787),
    [anon_sym_alignas] = ACTIONS(2787),
    [anon_sym__Alignas] = ACTIONS(2787),
    [sym_primitive_type] = ACTIONS(2787),
    [anon_sym_enum] = ACTIONS(2787),
    [anon_sym_class] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_union] = ACTIONS(2787),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_switch] = ACTIONS(2787),
    [anon_sym_case] = ACTIONS(2787),
    [anon_sym_default] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [anon_sym_do] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_break] = ACTIONS(2787),
    [anon_sym_continue] = ACTIONS(2787),
    [anon_sym_goto] = ACTIONS(2787),
    [anon_sym___try] = ACTIONS(2787),
    [anon_sym___leave] = ACTIONS(2787),
    [anon_sym_not] = ACTIONS(2787),
    [anon_sym_compl] = ACTIONS(2787),
    [anon_sym_DASH_DASH] = ACTIONS(2789),
    [anon_sym_PLUS_PLUS] = ACTIONS(2789),
    [anon_sym_sizeof] = ACTIONS(2787),
    [anon_sym___alignof__] = ACTIONS(2787),
    [anon_sym___alignof] = ACTIONS(2787),
    [anon_sym__alignof] = ACTIONS(2787),
    [anon_sym_alignof] = ACTIONS(2787),
    [anon_sym__Alignof] = ACTIONS(2787),
    [anon_sym_offsetof] = ACTIONS(2787),
    [anon_sym__Generic] = ACTIONS(2787),
    [anon_sym_asm] = ACTIONS(2787),
    [anon_sym___asm__] = ACTIONS(2787),
    [anon_sym___asm] = ACTIONS(2787),
    [sym_number_literal] = ACTIONS(2789),
    [anon_sym_L_SQUOTE] = ACTIONS(2789),
    [anon_sym_u_SQUOTE] = ACTIONS(2789),
    [anon_sym_U_SQUOTE] = ACTIONS(2789),
    [anon_sym_u8_SQUOTE] = ACTIONS(2789),
    [anon_sym_SQUOTE] = ACTIONS(2789),
    [anon_sym_L_DQUOTE] = ACTIONS(2789),
    [anon_sym_u_DQUOTE] = ACTIONS(2789),
    [anon_sym_U_DQUOTE] = ACTIONS(2789),
    [anon_sym_u8_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE] = ACTIONS(2789),
    [sym_true] = ACTIONS(2787),
    [sym_false] = ACTIONS(2787),
    [anon_sym_NULL] = ACTIONS(2787),
    [anon_sym_nullptr] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2787),
    [anon_sym_decltype] = ACTIONS(2787),
    [anon_sym_explicit] = ACTIONS(2787),
    [anon_sym_typename] = ACTIONS(2787),
    [anon_sym_template] = ACTIONS(2787),
    [anon_sym_operator] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_delete] = ACTIONS(2787),
    [anon_sym_throw] = ACTIONS(2787),
    [anon_sym_namespace] = ACTIONS(2787),
    [anon_sym_static_assert] = ACTIONS(2787),
    [anon_sym_concept] = ACTIONS(2787),
    [anon_sym_co_return] = ACTIONS(2787),
    [anon_sym_co_yield] = ACTIONS(2787),
    [anon_sym_R_DQUOTE] = ACTIONS(2789),
    [anon_sym_LR_DQUOTE] = ACTIONS(2789),
    [anon_sym_uR_DQUOTE] = ACTIONS(2789),
    [anon_sym_UR_DQUOTE] = ACTIONS(2789),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2789),
    [anon_sym_co_await] = ACTIONS(2787),
    [anon_sym_new] = ACTIONS(2787),
    [anon_sym_requires] = ACTIONS(2787),
    [sym_this] = ACTIONS(2787),
  },
  [288] = {
    [sym_identifier] = ACTIONS(2791),
    [aux_sym_preproc_include_token1] = ACTIONS(2791),
    [aux_sym_preproc_def_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token2] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2791),
    [aux_sym_preproc_else_token1] = ACTIONS(2791),
    [aux_sym_preproc_elif_token1] = ACTIONS(2791),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2791),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2791),
    [sym_preproc_directive] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2793),
    [anon_sym_BANG] = ACTIONS(2793),
    [anon_sym_TILDE] = ACTIONS(2793),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym___extension__] = ACTIONS(2791),
    [anon_sym_typedef] = ACTIONS(2791),
    [anon_sym_virtual] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym___attribute__] = ACTIONS(2791),
    [anon_sym___attribute] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2793),
    [anon_sym___declspec] = ACTIONS(2791),
    [anon_sym___based] = ACTIONS(2791),
    [anon_sym___cdecl] = ACTIONS(2791),
    [anon_sym___clrcall] = ACTIONS(2791),
    [anon_sym___stdcall] = ACTIONS(2791),
    [anon_sym___fastcall] = ACTIONS(2791),
    [anon_sym___thiscall] = ACTIONS(2791),
    [anon_sym___vectorcall] = ACTIONS(2791),
    [anon_sym_LBRACE] = ACTIONS(2793),
    [anon_sym_signed] = ACTIONS(2791),
    [anon_sym_unsigned] = ACTIONS(2791),
    [anon_sym_long] = ACTIONS(2791),
    [anon_sym_short] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_register] = ACTIONS(2791),
    [anon_sym_inline] = ACTIONS(2791),
    [anon_sym___inline] = ACTIONS(2791),
    [anon_sym___inline__] = ACTIONS(2791),
    [anon_sym___forceinline] = ACTIONS(2791),
    [anon_sym_thread_local] = ACTIONS(2791),
    [anon_sym___thread] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_constexpr] = ACTIONS(2791),
    [anon_sym_volatile] = ACTIONS(2791),
    [anon_sym_restrict] = ACTIONS(2791),
    [anon_sym___restrict__] = ACTIONS(2791),
    [anon_sym__Atomic] = ACTIONS(2791),
    [anon_sym__Noreturn] = ACTIONS(2791),
    [anon_sym_noreturn] = ACTIONS(2791),
    [anon_sym__Nonnull] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_constinit] = ACTIONS(2791),
    [anon_sym_consteval] = ACTIONS(2791),
    [anon_sym_alignas] = ACTIONS(2791),
    [anon_sym__Alignas] = ACTIONS(2791),
    [sym_primitive_type] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_class] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_switch] = ACTIONS(2791),
    [anon_sym_case] = ACTIONS(2791),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_break] = ACTIONS(2791),
    [anon_sym_continue] = ACTIONS(2791),
    [anon_sym_goto] = ACTIONS(2791),
    [anon_sym___try] = ACTIONS(2791),
    [anon_sym___leave] = ACTIONS(2791),
    [anon_sym_not] = ACTIONS(2791),
    [anon_sym_compl] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(2793),
    [anon_sym_PLUS_PLUS] = ACTIONS(2793),
    [anon_sym_sizeof] = ACTIONS(2791),
    [anon_sym___alignof__] = ACTIONS(2791),
    [anon_sym___alignof] = ACTIONS(2791),
    [anon_sym__alignof] = ACTIONS(2791),
    [anon_sym_alignof] = ACTIONS(2791),
    [anon_sym__Alignof] = ACTIONS(2791),
    [anon_sym_offsetof] = ACTIONS(2791),
    [anon_sym__Generic] = ACTIONS(2791),
    [anon_sym_asm] = ACTIONS(2791),
    [anon_sym___asm__] = ACTIONS(2791),
    [anon_sym___asm] = ACTIONS(2791),
    [sym_number_literal] = ACTIONS(2793),
    [anon_sym_L_SQUOTE] = ACTIONS(2793),
    [anon_sym_u_SQUOTE] = ACTIONS(2793),
    [anon_sym_U_SQUOTE] = ACTIONS(2793),
    [anon_sym_u8_SQUOTE] = ACTIONS(2793),
    [anon_sym_SQUOTE] = ACTIONS(2793),
    [anon_sym_L_DQUOTE] = ACTIONS(2793),
    [anon_sym_u_DQUOTE] = ACTIONS(2793),
    [anon_sym_U_DQUOTE] = ACTIONS(2793),
    [anon_sym_u8_DQUOTE] = ACTIONS(2793),
    [anon_sym_DQUOTE] = ACTIONS(2793),
    [sym_true] = ACTIONS(2791),
    [sym_false] = ACTIONS(2791),
    [anon_sym_NULL] = ACTIONS(2791),
    [anon_sym_nullptr] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2791),
    [anon_sym_decltype] = ACTIONS(2791),
    [anon_sym_explicit] = ACTIONS(2791),
    [anon_sym_typename] = ACTIONS(2791),
    [anon_sym_template] = ACTIONS(2791),
    [anon_sym_operator] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_delete] = ACTIONS(2791),
    [anon_sym_throw] = ACTIONS(2791),
    [anon_sym_namespace] = ACTIONS(2791),
    [anon_sym_static_assert] = ACTIONS(2791),
    [anon_sym_concept] = ACTIONS(2791),
    [anon_sym_co_return] = ACTIONS(2791),
    [anon_sym_co_yield] = ACTIONS(2791),
    [anon_sym_R_DQUOTE] = ACTIONS(2793),
    [anon_sym_LR_DQUOTE] = ACTIONS(2793),
    [anon_sym_uR_DQUOTE] = ACTIONS(2793),
    [anon_sym_UR_DQUOTE] = ACTIONS(2793),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2793),
    [anon_sym_co_await] = ACTIONS(2791),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_requires] = ACTIONS(2791),
    [sym_this] = ACTIONS(2791),
  },
  [289] = {
    [ts_builtin_sym_end] = ACTIONS(2629),
    [sym_identifier] = ACTIONS(2627),
    [aux_sym_preproc_include_token1] = ACTIONS(2627),
    [aux_sym_preproc_def_token1] = ACTIONS(2627),
    [aux_sym_preproc_if_token1] = ACTIONS(2627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2627),
    [sym_preproc_directive] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2629),
    [anon_sym_BANG] = ACTIONS(2629),
    [anon_sym_TILDE] = ACTIONS(2629),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2629),
    [anon_sym_AMP_AMP] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_SEMI] = ACTIONS(2629),
    [anon_sym___extension__] = ACTIONS(2627),
    [anon_sym_typedef] = ACTIONS(2627),
    [anon_sym_virtual] = ACTIONS(2627),
    [anon_sym_extern] = ACTIONS(2627),
    [anon_sym___attribute__] = ACTIONS(2627),
    [anon_sym___attribute] = ACTIONS(2627),
    [anon_sym_using] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2629),
    [anon_sym___declspec] = ACTIONS(2627),
    [anon_sym___based] = ACTIONS(2627),
    [anon_sym___cdecl] = ACTIONS(2627),
    [anon_sym___clrcall] = ACTIONS(2627),
    [anon_sym___stdcall] = ACTIONS(2627),
    [anon_sym___fastcall] = ACTIONS(2627),
    [anon_sym___thiscall] = ACTIONS(2627),
    [anon_sym___vectorcall] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2629),
    [anon_sym_signed] = ACTIONS(2627),
    [anon_sym_unsigned] = ACTIONS(2627),
    [anon_sym_long] = ACTIONS(2627),
    [anon_sym_short] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_static] = ACTIONS(2627),
    [anon_sym_register] = ACTIONS(2627),
    [anon_sym_inline] = ACTIONS(2627),
    [anon_sym___inline] = ACTIONS(2627),
    [anon_sym___inline__] = ACTIONS(2627),
    [anon_sym___forceinline] = ACTIONS(2627),
    [anon_sym_thread_local] = ACTIONS(2627),
    [anon_sym___thread] = ACTIONS(2627),
    [anon_sym_const] = ACTIONS(2627),
    [anon_sym_constexpr] = ACTIONS(2627),
    [anon_sym_volatile] = ACTIONS(2627),
    [anon_sym_restrict] = ACTIONS(2627),
    [anon_sym___restrict__] = ACTIONS(2627),
    [anon_sym__Atomic] = ACTIONS(2627),
    [anon_sym__Noreturn] = ACTIONS(2627),
    [anon_sym_noreturn] = ACTIONS(2627),
    [anon_sym__Nonnull] = ACTIONS(2627),
    [anon_sym_mutable] = ACTIONS(2627),
    [anon_sym_constinit] = ACTIONS(2627),
    [anon_sym_consteval] = ACTIONS(2627),
    [anon_sym_alignas] = ACTIONS(2627),
    [anon_sym__Alignas] = ACTIONS(2627),
    [sym_primitive_type] = ACTIONS(2627),
    [anon_sym_enum] = ACTIONS(2627),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_union] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_else] = ACTIONS(2627),
    [anon_sym_switch] = ACTIONS(2627),
    [anon_sym_case] = ACTIONS(2627),
    [anon_sym_default] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_goto] = ACTIONS(2627),
    [anon_sym___try] = ACTIONS(2627),
    [anon_sym___leave] = ACTIONS(2627),
    [anon_sym_not] = ACTIONS(2627),
    [anon_sym_compl] = ACTIONS(2627),
    [anon_sym_DASH_DASH] = ACTIONS(2629),
    [anon_sym_PLUS_PLUS] = ACTIONS(2629),
    [anon_sym_sizeof] = ACTIONS(2627),
    [anon_sym___alignof__] = ACTIONS(2627),
    [anon_sym___alignof] = ACTIONS(2627),
    [anon_sym__alignof] = ACTIONS(2627),
    [anon_sym_alignof] = ACTIONS(2627),
    [anon_sym__Alignof] = ACTIONS(2627),
    [anon_sym_offsetof] = ACTIONS(2627),
    [anon_sym__Generic] = ACTIONS(2627),
    [anon_sym_asm] = ACTIONS(2627),
    [anon_sym___asm__] = ACTIONS(2627),
    [anon_sym___asm] = ACTIONS(2627),
    [sym_number_literal] = ACTIONS(2629),
    [anon_sym_L_SQUOTE] = ACTIONS(2629),
    [anon_sym_u_SQUOTE] = ACTIONS(2629),
    [anon_sym_U_SQUOTE] = ACTIONS(2629),
    [anon_sym_u8_SQUOTE] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2629),
    [anon_sym_L_DQUOTE] = ACTIONS(2629),
    [anon_sym_u_DQUOTE] = ACTIONS(2629),
    [anon_sym_U_DQUOTE] = ACTIONS(2629),
    [anon_sym_u8_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE] = ACTIONS(2629),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [anon_sym_NULL] = ACTIONS(2627),
    [anon_sym_nullptr] = ACTIONS(2627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2627),
    [anon_sym_decltype] = ACTIONS(2627),
    [anon_sym_explicit] = ACTIONS(2627),
    [anon_sym_typename] = ACTIONS(2627),
    [anon_sym_export] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2627),
    [anon_sym_import] = ACTIONS(2627),
    [anon_sym_template] = ACTIONS(2627),
    [anon_sym_operator] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_delete] = ACTIONS(2627),
    [anon_sym_throw] = ACTIONS(2627),
    [anon_sym_namespace] = ACTIONS(2627),
    [anon_sym_static_assert] = ACTIONS(2627),
    [anon_sym_concept] = ACTIONS(2627),
    [anon_sym_co_return] = ACTIONS(2627),
    [anon_sym_co_yield] = ACTIONS(2627),
    [anon_sym_R_DQUOTE] = ACTIONS(2629),
    [anon_sym_LR_DQUOTE] = ACTIONS(2629),
    [anon_sym_uR_DQUOTE] = ACTIONS(2629),
    [anon_sym_UR_DQUOTE] = ACTIONS(2629),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2629),
    [anon_sym_co_await] = ACTIONS(2627),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_requires] = ACTIONS(2627),
    [sym_this] = ACTIONS(2627),
  },
  [290] = {
    [sym_identifier] = ACTIONS(2795),
    [aux_sym_preproc_include_token1] = ACTIONS(2795),
    [aux_sym_preproc_def_token1] = ACTIONS(2795),
    [aux_sym_preproc_if_token1] = ACTIONS(2795),
    [aux_sym_preproc_if_token2] = ACTIONS(2795),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2795),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2795),
    [aux_sym_preproc_else_token1] = ACTIONS(2795),
    [aux_sym_preproc_elif_token1] = ACTIONS(2795),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2795),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2795),
    [sym_preproc_directive] = ACTIONS(2795),
    [anon_sym_LPAREN2] = ACTIONS(2797),
    [anon_sym_BANG] = ACTIONS(2797),
    [anon_sym_TILDE] = ACTIONS(2797),
    [anon_sym_DASH] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_AMP_AMP] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_SEMI] = ACTIONS(2797),
    [anon_sym___extension__] = ACTIONS(2795),
    [anon_sym_typedef] = ACTIONS(2795),
    [anon_sym_virtual] = ACTIONS(2795),
    [anon_sym_extern] = ACTIONS(2795),
    [anon_sym___attribute__] = ACTIONS(2795),
    [anon_sym___attribute] = ACTIONS(2795),
    [anon_sym_using] = ACTIONS(2795),
    [anon_sym_COLON_COLON] = ACTIONS(2797),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2797),
    [anon_sym___declspec] = ACTIONS(2795),
    [anon_sym___based] = ACTIONS(2795),
    [anon_sym___cdecl] = ACTIONS(2795),
    [anon_sym___clrcall] = ACTIONS(2795),
    [anon_sym___stdcall] = ACTIONS(2795),
    [anon_sym___fastcall] = ACTIONS(2795),
    [anon_sym___thiscall] = ACTIONS(2795),
    [anon_sym___vectorcall] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2797),
    [anon_sym_signed] = ACTIONS(2795),
    [anon_sym_unsigned] = ACTIONS(2795),
    [anon_sym_long] = ACTIONS(2795),
    [anon_sym_short] = ACTIONS(2795),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_static] = ACTIONS(2795),
    [anon_sym_register] = ACTIONS(2795),
    [anon_sym_inline] = ACTIONS(2795),
    [anon_sym___inline] = ACTIONS(2795),
    [anon_sym___inline__] = ACTIONS(2795),
    [anon_sym___forceinline] = ACTIONS(2795),
    [anon_sym_thread_local] = ACTIONS(2795),
    [anon_sym___thread] = ACTIONS(2795),
    [anon_sym_const] = ACTIONS(2795),
    [anon_sym_constexpr] = ACTIONS(2795),
    [anon_sym_volatile] = ACTIONS(2795),
    [anon_sym_restrict] = ACTIONS(2795),
    [anon_sym___restrict__] = ACTIONS(2795),
    [anon_sym__Atomic] = ACTIONS(2795),
    [anon_sym__Noreturn] = ACTIONS(2795),
    [anon_sym_noreturn] = ACTIONS(2795),
    [anon_sym__Nonnull] = ACTIONS(2795),
    [anon_sym_mutable] = ACTIONS(2795),
    [anon_sym_constinit] = ACTIONS(2795),
    [anon_sym_consteval] = ACTIONS(2795),
    [anon_sym_alignas] = ACTIONS(2795),
    [anon_sym__Alignas] = ACTIONS(2795),
    [sym_primitive_type] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2795),
    [anon_sym_class] = ACTIONS(2795),
    [anon_sym_struct] = ACTIONS(2795),
    [anon_sym_union] = ACTIONS(2795),
    [anon_sym_if] = ACTIONS(2795),
    [anon_sym_switch] = ACTIONS(2795),
    [anon_sym_case] = ACTIONS(2795),
    [anon_sym_default] = ACTIONS(2795),
    [anon_sym_while] = ACTIONS(2795),
    [anon_sym_do] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2795),
    [anon_sym_return] = ACTIONS(2795),
    [anon_sym_break] = ACTIONS(2795),
    [anon_sym_continue] = ACTIONS(2795),
    [anon_sym_goto] = ACTIONS(2795),
    [anon_sym___try] = ACTIONS(2795),
    [anon_sym___leave] = ACTIONS(2795),
    [anon_sym_not] = ACTIONS(2795),
    [anon_sym_compl] = ACTIONS(2795),
    [anon_sym_DASH_DASH] = ACTIONS(2797),
    [anon_sym_PLUS_PLUS] = ACTIONS(2797),
    [anon_sym_sizeof] = ACTIONS(2795),
    [anon_sym___alignof__] = ACTIONS(2795),
    [anon_sym___alignof] = ACTIONS(2795),
    [anon_sym__alignof] = ACTIONS(2795),
    [anon_sym_alignof] = ACTIONS(2795),
    [anon_sym__Alignof] = ACTIONS(2795),
    [anon_sym_offsetof] = ACTIONS(2795),
    [anon_sym__Generic] = ACTIONS(2795),
    [anon_sym_asm] = ACTIONS(2795),
    [anon_sym___asm__] = ACTIONS(2795),
    [anon_sym___asm] = ACTIONS(2795),
    [sym_number_literal] = ACTIONS(2797),
    [anon_sym_L_SQUOTE] = ACTIONS(2797),
    [anon_sym_u_SQUOTE] = ACTIONS(2797),
    [anon_sym_U_SQUOTE] = ACTIONS(2797),
    [anon_sym_u8_SQUOTE] = ACTIONS(2797),
    [anon_sym_SQUOTE] = ACTIONS(2797),
    [anon_sym_L_DQUOTE] = ACTIONS(2797),
    [anon_sym_u_DQUOTE] = ACTIONS(2797),
    [anon_sym_U_DQUOTE] = ACTIONS(2797),
    [anon_sym_u8_DQUOTE] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(2797),
    [sym_true] = ACTIONS(2795),
    [sym_false] = ACTIONS(2795),
    [anon_sym_NULL] = ACTIONS(2795),
    [anon_sym_nullptr] = ACTIONS(2795),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2795),
    [anon_sym_decltype] = ACTIONS(2795),
    [anon_sym_explicit] = ACTIONS(2795),
    [anon_sym_typename] = ACTIONS(2795),
    [anon_sym_template] = ACTIONS(2795),
    [anon_sym_operator] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2795),
    [anon_sym_delete] = ACTIONS(2795),
    [anon_sym_throw] = ACTIONS(2795),
    [anon_sym_namespace] = ACTIONS(2795),
    [anon_sym_static_assert] = ACTIONS(2795),
    [anon_sym_concept] = ACTIONS(2795),
    [anon_sym_co_return] = ACTIONS(2795),
    [anon_sym_co_yield] = ACTIONS(2795),
    [anon_sym_R_DQUOTE] = ACTIONS(2797),
    [anon_sym_LR_DQUOTE] = ACTIONS(2797),
    [anon_sym_uR_DQUOTE] = ACTIONS(2797),
    [anon_sym_UR_DQUOTE] = ACTIONS(2797),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2797),
    [anon_sym_co_await] = ACTIONS(2795),
    [anon_sym_new] = ACTIONS(2795),
    [anon_sym_requires] = ACTIONS(2795),
    [sym_this] = ACTIONS(2795),
  },
  [291] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [aux_sym_preproc_else_token1] = ACTIONS(2799),
    [aux_sym_preproc_elif_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym___try] = ACTIONS(2799),
    [anon_sym___leave] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [292] = {
    [sym_identifier] = ACTIONS(2803),
    [aux_sym_preproc_include_token1] = ACTIONS(2803),
    [aux_sym_preproc_def_token1] = ACTIONS(2803),
    [aux_sym_preproc_if_token1] = ACTIONS(2803),
    [aux_sym_preproc_if_token2] = ACTIONS(2803),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2803),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2803),
    [aux_sym_preproc_else_token1] = ACTIONS(2803),
    [aux_sym_preproc_elif_token1] = ACTIONS(2803),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2803),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2803),
    [sym_preproc_directive] = ACTIONS(2803),
    [anon_sym_LPAREN2] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(2805),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2803),
    [anon_sym_PLUS] = ACTIONS(2803),
    [anon_sym_STAR] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2805),
    [anon_sym_AMP] = ACTIONS(2803),
    [anon_sym_SEMI] = ACTIONS(2805),
    [anon_sym___extension__] = ACTIONS(2803),
    [anon_sym_typedef] = ACTIONS(2803),
    [anon_sym_virtual] = ACTIONS(2803),
    [anon_sym_extern] = ACTIONS(2803),
    [anon_sym___attribute__] = ACTIONS(2803),
    [anon_sym___attribute] = ACTIONS(2803),
    [anon_sym_using] = ACTIONS(2803),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2805),
    [anon_sym___declspec] = ACTIONS(2803),
    [anon_sym___based] = ACTIONS(2803),
    [anon_sym___cdecl] = ACTIONS(2803),
    [anon_sym___clrcall] = ACTIONS(2803),
    [anon_sym___stdcall] = ACTIONS(2803),
    [anon_sym___fastcall] = ACTIONS(2803),
    [anon_sym___thiscall] = ACTIONS(2803),
    [anon_sym___vectorcall] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(2805),
    [anon_sym_signed] = ACTIONS(2803),
    [anon_sym_unsigned] = ACTIONS(2803),
    [anon_sym_long] = ACTIONS(2803),
    [anon_sym_short] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_static] = ACTIONS(2803),
    [anon_sym_register] = ACTIONS(2803),
    [anon_sym_inline] = ACTIONS(2803),
    [anon_sym___inline] = ACTIONS(2803),
    [anon_sym___inline__] = ACTIONS(2803),
    [anon_sym___forceinline] = ACTIONS(2803),
    [anon_sym_thread_local] = ACTIONS(2803),
    [anon_sym___thread] = ACTIONS(2803),
    [anon_sym_const] = ACTIONS(2803),
    [anon_sym_constexpr] = ACTIONS(2803),
    [anon_sym_volatile] = ACTIONS(2803),
    [anon_sym_restrict] = ACTIONS(2803),
    [anon_sym___restrict__] = ACTIONS(2803),
    [anon_sym__Atomic] = ACTIONS(2803),
    [anon_sym__Noreturn] = ACTIONS(2803),
    [anon_sym_noreturn] = ACTIONS(2803),
    [anon_sym__Nonnull] = ACTIONS(2803),
    [anon_sym_mutable] = ACTIONS(2803),
    [anon_sym_constinit] = ACTIONS(2803),
    [anon_sym_consteval] = ACTIONS(2803),
    [anon_sym_alignas] = ACTIONS(2803),
    [anon_sym__Alignas] = ACTIONS(2803),
    [sym_primitive_type] = ACTIONS(2803),
    [anon_sym_enum] = ACTIONS(2803),
    [anon_sym_class] = ACTIONS(2803),
    [anon_sym_struct] = ACTIONS(2803),
    [anon_sym_union] = ACTIONS(2803),
    [anon_sym_if] = ACTIONS(2803),
    [anon_sym_switch] = ACTIONS(2803),
    [anon_sym_case] = ACTIONS(2803),
    [anon_sym_default] = ACTIONS(2803),
    [anon_sym_while] = ACTIONS(2803),
    [anon_sym_do] = ACTIONS(2803),
    [anon_sym_for] = ACTIONS(2803),
    [anon_sym_return] = ACTIONS(2803),
    [anon_sym_break] = ACTIONS(2803),
    [anon_sym_continue] = ACTIONS(2803),
    [anon_sym_goto] = ACTIONS(2803),
    [anon_sym___try] = ACTIONS(2803),
    [anon_sym___leave] = ACTIONS(2803),
    [anon_sym_not] = ACTIONS(2803),
    [anon_sym_compl] = ACTIONS(2803),
    [anon_sym_DASH_DASH] = ACTIONS(2805),
    [anon_sym_PLUS_PLUS] = ACTIONS(2805),
    [anon_sym_sizeof] = ACTIONS(2803),
    [anon_sym___alignof__] = ACTIONS(2803),
    [anon_sym___alignof] = ACTIONS(2803),
    [anon_sym__alignof] = ACTIONS(2803),
    [anon_sym_alignof] = ACTIONS(2803),
    [anon_sym__Alignof] = ACTIONS(2803),
    [anon_sym_offsetof] = ACTIONS(2803),
    [anon_sym__Generic] = ACTIONS(2803),
    [anon_sym_asm] = ACTIONS(2803),
    [anon_sym___asm__] = ACTIONS(2803),
    [anon_sym___asm] = ACTIONS(2803),
    [sym_number_literal] = ACTIONS(2805),
    [anon_sym_L_SQUOTE] = ACTIONS(2805),
    [anon_sym_u_SQUOTE] = ACTIONS(2805),
    [anon_sym_U_SQUOTE] = ACTIONS(2805),
    [anon_sym_u8_SQUOTE] = ACTIONS(2805),
    [anon_sym_SQUOTE] = ACTIONS(2805),
    [anon_sym_L_DQUOTE] = ACTIONS(2805),
    [anon_sym_u_DQUOTE] = ACTIONS(2805),
    [anon_sym_U_DQUOTE] = ACTIONS(2805),
    [anon_sym_u8_DQUOTE] = ACTIONS(2805),
    [anon_sym_DQUOTE] = ACTIONS(2805),
    [sym_true] = ACTIONS(2803),
    [sym_false] = ACTIONS(2803),
    [anon_sym_NULL] = ACTIONS(2803),
    [anon_sym_nullptr] = ACTIONS(2803),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2803),
    [anon_sym_decltype] = ACTIONS(2803),
    [anon_sym_explicit] = ACTIONS(2803),
    [anon_sym_typename] = ACTIONS(2803),
    [anon_sym_template] = ACTIONS(2803),
    [anon_sym_operator] = ACTIONS(2803),
    [anon_sym_try] = ACTIONS(2803),
    [anon_sym_delete] = ACTIONS(2803),
    [anon_sym_throw] = ACTIONS(2803),
    [anon_sym_namespace] = ACTIONS(2803),
    [anon_sym_static_assert] = ACTIONS(2803),
    [anon_sym_concept] = ACTIONS(2803),
    [anon_sym_co_return] = ACTIONS(2803),
    [anon_sym_co_yield] = ACTIONS(2803),
    [anon_sym_R_DQUOTE] = ACTIONS(2805),
    [anon_sym_LR_DQUOTE] = ACTIONS(2805),
    [anon_sym_uR_DQUOTE] = ACTIONS(2805),
    [anon_sym_UR_DQUOTE] = ACTIONS(2805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2805),
    [anon_sym_co_await] = ACTIONS(2803),
    [anon_sym_new] = ACTIONS(2803),
    [anon_sym_requires] = ACTIONS(2803),
    [sym_this] = ACTIONS(2803),
  },
  [293] = {
    [sym_identifier] = ACTIONS(2807),
    [aux_sym_preproc_include_token1] = ACTIONS(2807),
    [aux_sym_preproc_def_token1] = ACTIONS(2807),
    [aux_sym_preproc_if_token1] = ACTIONS(2807),
    [aux_sym_preproc_if_token2] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2807),
    [aux_sym_preproc_else_token1] = ACTIONS(2807),
    [aux_sym_preproc_elif_token1] = ACTIONS(2807),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2807),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2807),
    [sym_preproc_directive] = ACTIONS(2807),
    [anon_sym_LPAREN2] = ACTIONS(2809),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_TILDE] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2807),
    [anon_sym_typedef] = ACTIONS(2807),
    [anon_sym_virtual] = ACTIONS(2807),
    [anon_sym_extern] = ACTIONS(2807),
    [anon_sym___attribute__] = ACTIONS(2807),
    [anon_sym___attribute] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2809),
    [anon_sym___declspec] = ACTIONS(2807),
    [anon_sym___based] = ACTIONS(2807),
    [anon_sym___cdecl] = ACTIONS(2807),
    [anon_sym___clrcall] = ACTIONS(2807),
    [anon_sym___stdcall] = ACTIONS(2807),
    [anon_sym___fastcall] = ACTIONS(2807),
    [anon_sym___thiscall] = ACTIONS(2807),
    [anon_sym___vectorcall] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2809),
    [anon_sym_signed] = ACTIONS(2807),
    [anon_sym_unsigned] = ACTIONS(2807),
    [anon_sym_long] = ACTIONS(2807),
    [anon_sym_short] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_static] = ACTIONS(2807),
    [anon_sym_register] = ACTIONS(2807),
    [anon_sym_inline] = ACTIONS(2807),
    [anon_sym___inline] = ACTIONS(2807),
    [anon_sym___inline__] = ACTIONS(2807),
    [anon_sym___forceinline] = ACTIONS(2807),
    [anon_sym_thread_local] = ACTIONS(2807),
    [anon_sym___thread] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_constexpr] = ACTIONS(2807),
    [anon_sym_volatile] = ACTIONS(2807),
    [anon_sym_restrict] = ACTIONS(2807),
    [anon_sym___restrict__] = ACTIONS(2807),
    [anon_sym__Atomic] = ACTIONS(2807),
    [anon_sym__Noreturn] = ACTIONS(2807),
    [anon_sym_noreturn] = ACTIONS(2807),
    [anon_sym__Nonnull] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_constinit] = ACTIONS(2807),
    [anon_sym_consteval] = ACTIONS(2807),
    [anon_sym_alignas] = ACTIONS(2807),
    [anon_sym__Alignas] = ACTIONS(2807),
    [sym_primitive_type] = ACTIONS(2807),
    [anon_sym_enum] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_union] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_switch] = ACTIONS(2807),
    [anon_sym_case] = ACTIONS(2807),
    [anon_sym_default] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_for] = ACTIONS(2807),
    [anon_sym_return] = ACTIONS(2807),
    [anon_sym_break] = ACTIONS(2807),
    [anon_sym_continue] = ACTIONS(2807),
    [anon_sym_goto] = ACTIONS(2807),
    [anon_sym___try] = ACTIONS(2807),
    [anon_sym___leave] = ACTIONS(2807),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2809),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2807),
    [anon_sym___alignof] = ACTIONS(2807),
    [anon_sym__alignof] = ACTIONS(2807),
    [anon_sym_alignof] = ACTIONS(2807),
    [anon_sym__Alignof] = ACTIONS(2807),
    [anon_sym_offsetof] = ACTIONS(2807),
    [anon_sym__Generic] = ACTIONS(2807),
    [anon_sym_asm] = ACTIONS(2807),
    [anon_sym___asm__] = ACTIONS(2807),
    [anon_sym___asm] = ACTIONS(2807),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2809),
    [anon_sym_u_SQUOTE] = ACTIONS(2809),
    [anon_sym_U_SQUOTE] = ACTIONS(2809),
    [anon_sym_u8_SQUOTE] = ACTIONS(2809),
    [anon_sym_SQUOTE] = ACTIONS(2809),
    [anon_sym_L_DQUOTE] = ACTIONS(2809),
    [anon_sym_u_DQUOTE] = ACTIONS(2809),
    [anon_sym_U_DQUOTE] = ACTIONS(2809),
    [anon_sym_u8_DQUOTE] = ACTIONS(2809),
    [anon_sym_DQUOTE] = ACTIONS(2809),
    [sym_true] = ACTIONS(2807),
    [sym_false] = ACTIONS(2807),
    [anon_sym_NULL] = ACTIONS(2807),
    [anon_sym_nullptr] = ACTIONS(2807),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2807),
    [anon_sym_decltype] = ACTIONS(2807),
    [anon_sym_explicit] = ACTIONS(2807),
    [anon_sym_typename] = ACTIONS(2807),
    [anon_sym_template] = ACTIONS(2807),
    [anon_sym_operator] = ACTIONS(2807),
    [anon_sym_try] = ACTIONS(2807),
    [anon_sym_delete] = ACTIONS(2807),
    [anon_sym_throw] = ACTIONS(2807),
    [anon_sym_namespace] = ACTIONS(2807),
    [anon_sym_static_assert] = ACTIONS(2807),
    [anon_sym_concept] = ACTIONS(2807),
    [anon_sym_co_return] = ACTIONS(2807),
    [anon_sym_co_yield] = ACTIONS(2807),
    [anon_sym_R_DQUOTE] = ACTIONS(2809),
    [anon_sym_LR_DQUOTE] = ACTIONS(2809),
    [anon_sym_uR_DQUOTE] = ACTIONS(2809),
    [anon_sym_UR_DQUOTE] = ACTIONS(2809),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2809),
    [anon_sym_co_await] = ACTIONS(2807),
    [anon_sym_new] = ACTIONS(2807),
    [anon_sym_requires] = ACTIONS(2807),
    [sym_this] = ACTIONS(2807),
  },
  [294] = {
    [sym_identifier] = ACTIONS(2811),
    [aux_sym_preproc_include_token1] = ACTIONS(2811),
    [aux_sym_preproc_def_token1] = ACTIONS(2811),
    [aux_sym_preproc_if_token1] = ACTIONS(2811),
    [aux_sym_preproc_if_token2] = ACTIONS(2811),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2811),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2811),
    [aux_sym_preproc_else_token1] = ACTIONS(2811),
    [aux_sym_preproc_elif_token1] = ACTIONS(2811),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2811),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2811),
    [sym_preproc_directive] = ACTIONS(2811),
    [anon_sym_LPAREN2] = ACTIONS(2813),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_TILDE] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym_SEMI] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2811),
    [anon_sym_typedef] = ACTIONS(2811),
    [anon_sym_virtual] = ACTIONS(2811),
    [anon_sym_extern] = ACTIONS(2811),
    [anon_sym___attribute__] = ACTIONS(2811),
    [anon_sym___attribute] = ACTIONS(2811),
    [anon_sym_using] = ACTIONS(2811),
    [anon_sym_COLON_COLON] = ACTIONS(2813),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2813),
    [anon_sym___declspec] = ACTIONS(2811),
    [anon_sym___based] = ACTIONS(2811),
    [anon_sym___cdecl] = ACTIONS(2811),
    [anon_sym___clrcall] = ACTIONS(2811),
    [anon_sym___stdcall] = ACTIONS(2811),
    [anon_sym___fastcall] = ACTIONS(2811),
    [anon_sym___thiscall] = ACTIONS(2811),
    [anon_sym___vectorcall] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2813),
    [anon_sym_signed] = ACTIONS(2811),
    [anon_sym_unsigned] = ACTIONS(2811),
    [anon_sym_long] = ACTIONS(2811),
    [anon_sym_short] = ACTIONS(2811),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_static] = ACTIONS(2811),
    [anon_sym_register] = ACTIONS(2811),
    [anon_sym_inline] = ACTIONS(2811),
    [anon_sym___inline] = ACTIONS(2811),
    [anon_sym___inline__] = ACTIONS(2811),
    [anon_sym___forceinline] = ACTIONS(2811),
    [anon_sym_thread_local] = ACTIONS(2811),
    [anon_sym___thread] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_constexpr] = ACTIONS(2811),
    [anon_sym_volatile] = ACTIONS(2811),
    [anon_sym_restrict] = ACTIONS(2811),
    [anon_sym___restrict__] = ACTIONS(2811),
    [anon_sym__Atomic] = ACTIONS(2811),
    [anon_sym__Noreturn] = ACTIONS(2811),
    [anon_sym_noreturn] = ACTIONS(2811),
    [anon_sym__Nonnull] = ACTIONS(2811),
    [anon_sym_mutable] = ACTIONS(2811),
    [anon_sym_constinit] = ACTIONS(2811),
    [anon_sym_consteval] = ACTIONS(2811),
    [anon_sym_alignas] = ACTIONS(2811),
    [anon_sym__Alignas] = ACTIONS(2811),
    [sym_primitive_type] = ACTIONS(2811),
    [anon_sym_enum] = ACTIONS(2811),
    [anon_sym_class] = ACTIONS(2811),
    [anon_sym_struct] = ACTIONS(2811),
    [anon_sym_union] = ACTIONS(2811),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_switch] = ACTIONS(2811),
    [anon_sym_case] = ACTIONS(2811),
    [anon_sym_default] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [anon_sym_do] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_break] = ACTIONS(2811),
    [anon_sym_continue] = ACTIONS(2811),
    [anon_sym_goto] = ACTIONS(2811),
    [anon_sym___try] = ACTIONS(2811),
    [anon_sym___leave] = ACTIONS(2811),
    [anon_sym_not] = ACTIONS(2811),
    [anon_sym_compl] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2813),
    [anon_sym_sizeof] = ACTIONS(2811),
    [anon_sym___alignof__] = ACTIONS(2811),
    [anon_sym___alignof] = ACTIONS(2811),
    [anon_sym__alignof] = ACTIONS(2811),
    [anon_sym_alignof] = ACTIONS(2811),
    [anon_sym__Alignof] = ACTIONS(2811),
    [anon_sym_offsetof] = ACTIONS(2811),
    [anon_sym__Generic] = ACTIONS(2811),
    [anon_sym_asm] = ACTIONS(2811),
    [anon_sym___asm__] = ACTIONS(2811),
    [anon_sym___asm] = ACTIONS(2811),
    [sym_number_literal] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2813),
    [anon_sym_u_SQUOTE] = ACTIONS(2813),
    [anon_sym_U_SQUOTE] = ACTIONS(2813),
    [anon_sym_u8_SQUOTE] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2813),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2811),
    [sym_false] = ACTIONS(2811),
    [anon_sym_NULL] = ACTIONS(2811),
    [anon_sym_nullptr] = ACTIONS(2811),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2811),
    [anon_sym_decltype] = ACTIONS(2811),
    [anon_sym_explicit] = ACTIONS(2811),
    [anon_sym_typename] = ACTIONS(2811),
    [anon_sym_template] = ACTIONS(2811),
    [anon_sym_operator] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_delete] = ACTIONS(2811),
    [anon_sym_throw] = ACTIONS(2811),
    [anon_sym_namespace] = ACTIONS(2811),
    [anon_sym_static_assert] = ACTIONS(2811),
    [anon_sym_concept] = ACTIONS(2811),
    [anon_sym_co_return] = ACTIONS(2811),
    [anon_sym_co_yield] = ACTIONS(2811),
    [anon_sym_R_DQUOTE] = ACTIONS(2813),
    [anon_sym_LR_DQUOTE] = ACTIONS(2813),
    [anon_sym_uR_DQUOTE] = ACTIONS(2813),
    [anon_sym_UR_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2813),
    [anon_sym_co_await] = ACTIONS(2811),
    [anon_sym_new] = ACTIONS(2811),
    [anon_sym_requires] = ACTIONS(2811),
    [sym_this] = ACTIONS(2811),
  },
  [295] = {
    [sym_identifier] = ACTIONS(2815),
    [aux_sym_preproc_include_token1] = ACTIONS(2815),
    [aux_sym_preproc_def_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token2] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2815),
    [aux_sym_preproc_else_token1] = ACTIONS(2815),
    [aux_sym_preproc_elif_token1] = ACTIONS(2815),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2815),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2815),
    [sym_preproc_directive] = ACTIONS(2815),
    [anon_sym_LPAREN2] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_TILDE] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym___extension__] = ACTIONS(2815),
    [anon_sym_typedef] = ACTIONS(2815),
    [anon_sym_virtual] = ACTIONS(2815),
    [anon_sym_extern] = ACTIONS(2815),
    [anon_sym___attribute__] = ACTIONS(2815),
    [anon_sym___attribute] = ACTIONS(2815),
    [anon_sym_using] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2817),
    [anon_sym___declspec] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(2815),
    [anon_sym___cdecl] = ACTIONS(2815),
    [anon_sym___clrcall] = ACTIONS(2815),
    [anon_sym___stdcall] = ACTIONS(2815),
    [anon_sym___fastcall] = ACTIONS(2815),
    [anon_sym___thiscall] = ACTIONS(2815),
    [anon_sym___vectorcall] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2817),
    [anon_sym_signed] = ACTIONS(2815),
    [anon_sym_unsigned] = ACTIONS(2815),
    [anon_sym_long] = ACTIONS(2815),
    [anon_sym_short] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2815),
    [anon_sym_register] = ACTIONS(2815),
    [anon_sym_inline] = ACTIONS(2815),
    [anon_sym___inline] = ACTIONS(2815),
    [anon_sym___inline__] = ACTIONS(2815),
    [anon_sym___forceinline] = ACTIONS(2815),
    [anon_sym_thread_local] = ACTIONS(2815),
    [anon_sym___thread] = ACTIONS(2815),
    [anon_sym_const] = ACTIONS(2815),
    [anon_sym_constexpr] = ACTIONS(2815),
    [anon_sym_volatile] = ACTIONS(2815),
    [anon_sym_restrict] = ACTIONS(2815),
    [anon_sym___restrict__] = ACTIONS(2815),
    [anon_sym__Atomic] = ACTIONS(2815),
    [anon_sym__Noreturn] = ACTIONS(2815),
    [anon_sym_noreturn] = ACTIONS(2815),
    [anon_sym__Nonnull] = ACTIONS(2815),
    [anon_sym_mutable] = ACTIONS(2815),
    [anon_sym_constinit] = ACTIONS(2815),
    [anon_sym_consteval] = ACTIONS(2815),
    [anon_sym_alignas] = ACTIONS(2815),
    [anon_sym__Alignas] = ACTIONS(2815),
    [sym_primitive_type] = ACTIONS(2815),
    [anon_sym_enum] = ACTIONS(2815),
    [anon_sym_class] = ACTIONS(2815),
    [anon_sym_struct] = ACTIONS(2815),
    [anon_sym_union] = ACTIONS(2815),
    [anon_sym_if] = ACTIONS(2815),
    [anon_sym_switch] = ACTIONS(2815),
    [anon_sym_case] = ACTIONS(2815),
    [anon_sym_default] = ACTIONS(2815),
    [anon_sym_while] = ACTIONS(2815),
    [anon_sym_do] = ACTIONS(2815),
    [anon_sym_for] = ACTIONS(2815),
    [anon_sym_return] = ACTIONS(2815),
    [anon_sym_break] = ACTIONS(2815),
    [anon_sym_continue] = ACTIONS(2815),
    [anon_sym_goto] = ACTIONS(2815),
    [anon_sym___try] = ACTIONS(2815),
    [anon_sym___leave] = ACTIONS(2815),
    [anon_sym_not] = ACTIONS(2815),
    [anon_sym_compl] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2817),
    [anon_sym_sizeof] = ACTIONS(2815),
    [anon_sym___alignof__] = ACTIONS(2815),
    [anon_sym___alignof] = ACTIONS(2815),
    [anon_sym__alignof] = ACTIONS(2815),
    [anon_sym_alignof] = ACTIONS(2815),
    [anon_sym__Alignof] = ACTIONS(2815),
    [anon_sym_offsetof] = ACTIONS(2815),
    [anon_sym__Generic] = ACTIONS(2815),
    [anon_sym_asm] = ACTIONS(2815),
    [anon_sym___asm__] = ACTIONS(2815),
    [anon_sym___asm] = ACTIONS(2815),
    [sym_number_literal] = ACTIONS(2817),
    [anon_sym_L_SQUOTE] = ACTIONS(2817),
    [anon_sym_u_SQUOTE] = ACTIONS(2817),
    [anon_sym_U_SQUOTE] = ACTIONS(2817),
    [anon_sym_u8_SQUOTE] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_L_DQUOTE] = ACTIONS(2817),
    [anon_sym_u_DQUOTE] = ACTIONS(2817),
    [anon_sym_U_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8_DQUOTE] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(2817),
    [sym_true] = ACTIONS(2815),
    [sym_false] = ACTIONS(2815),
    [anon_sym_NULL] = ACTIONS(2815),
    [anon_sym_nullptr] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2815),
    [anon_sym_decltype] = ACTIONS(2815),
    [anon_sym_explicit] = ACTIONS(2815),
    [anon_sym_typename] = ACTIONS(2815),
    [anon_sym_template] = ACTIONS(2815),
    [anon_sym_operator] = ACTIONS(2815),
    [anon_sym_try] = ACTIONS(2815),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_throw] = ACTIONS(2815),
    [anon_sym_namespace] = ACTIONS(2815),
    [anon_sym_static_assert] = ACTIONS(2815),
    [anon_sym_concept] = ACTIONS(2815),
    [anon_sym_co_return] = ACTIONS(2815),
    [anon_sym_co_yield] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2815),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_requires] = ACTIONS(2815),
    [sym_this] = ACTIONS(2815),
  },
  [296] = {
    [sym_identifier] = ACTIONS(2819),
    [aux_sym_preproc_include_token1] = ACTIONS(2819),
    [aux_sym_preproc_def_token1] = ACTIONS(2819),
    [aux_sym_preproc_if_token1] = ACTIONS(2819),
    [aux_sym_preproc_if_token2] = ACTIONS(2819),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2819),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2819),
    [aux_sym_preproc_else_token1] = ACTIONS(2819),
    [aux_sym_preproc_elif_token1] = ACTIONS(2819),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2819),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2819),
    [sym_preproc_directive] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2821),
    [anon_sym_AMP_AMP] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_SEMI] = ACTIONS(2821),
    [anon_sym___extension__] = ACTIONS(2819),
    [anon_sym_typedef] = ACTIONS(2819),
    [anon_sym_virtual] = ACTIONS(2819),
    [anon_sym_extern] = ACTIONS(2819),
    [anon_sym___attribute__] = ACTIONS(2819),
    [anon_sym___attribute] = ACTIONS(2819),
    [anon_sym_using] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2821),
    [anon_sym___declspec] = ACTIONS(2819),
    [anon_sym___based] = ACTIONS(2819),
    [anon_sym___cdecl] = ACTIONS(2819),
    [anon_sym___clrcall] = ACTIONS(2819),
    [anon_sym___stdcall] = ACTIONS(2819),
    [anon_sym___fastcall] = ACTIONS(2819),
    [anon_sym___thiscall] = ACTIONS(2819),
    [anon_sym___vectorcall] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2821),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_static] = ACTIONS(2819),
    [anon_sym_register] = ACTIONS(2819),
    [anon_sym_inline] = ACTIONS(2819),
    [anon_sym___inline] = ACTIONS(2819),
    [anon_sym___inline__] = ACTIONS(2819),
    [anon_sym___forceinline] = ACTIONS(2819),
    [anon_sym_thread_local] = ACTIONS(2819),
    [anon_sym___thread] = ACTIONS(2819),
    [anon_sym_const] = ACTIONS(2819),
    [anon_sym_constexpr] = ACTIONS(2819),
    [anon_sym_volatile] = ACTIONS(2819),
    [anon_sym_restrict] = ACTIONS(2819),
    [anon_sym___restrict__] = ACTIONS(2819),
    [anon_sym__Atomic] = ACTIONS(2819),
    [anon_sym__Noreturn] = ACTIONS(2819),
    [anon_sym_noreturn] = ACTIONS(2819),
    [anon_sym__Nonnull] = ACTIONS(2819),
    [anon_sym_mutable] = ACTIONS(2819),
    [anon_sym_constinit] = ACTIONS(2819),
    [anon_sym_consteval] = ACTIONS(2819),
    [anon_sym_alignas] = ACTIONS(2819),
    [anon_sym__Alignas] = ACTIONS(2819),
    [sym_primitive_type] = ACTIONS(2819),
    [anon_sym_enum] = ACTIONS(2819),
    [anon_sym_class] = ACTIONS(2819),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_union] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_switch] = ACTIONS(2819),
    [anon_sym_case] = ACTIONS(2819),
    [anon_sym_default] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2819),
    [anon_sym_continue] = ACTIONS(2819),
    [anon_sym_goto] = ACTIONS(2819),
    [anon_sym___try] = ACTIONS(2819),
    [anon_sym___leave] = ACTIONS(2819),
    [anon_sym_not] = ACTIONS(2819),
    [anon_sym_compl] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2821),
    [anon_sym_PLUS_PLUS] = ACTIONS(2821),
    [anon_sym_sizeof] = ACTIONS(2819),
    [anon_sym___alignof__] = ACTIONS(2819),
    [anon_sym___alignof] = ACTIONS(2819),
    [anon_sym__alignof] = ACTIONS(2819),
    [anon_sym_alignof] = ACTIONS(2819),
    [anon_sym__Alignof] = ACTIONS(2819),
    [anon_sym_offsetof] = ACTIONS(2819),
    [anon_sym__Generic] = ACTIONS(2819),
    [anon_sym_asm] = ACTIONS(2819),
    [anon_sym___asm__] = ACTIONS(2819),
    [anon_sym___asm] = ACTIONS(2819),
    [sym_number_literal] = ACTIONS(2821),
    [anon_sym_L_SQUOTE] = ACTIONS(2821),
    [anon_sym_u_SQUOTE] = ACTIONS(2821),
    [anon_sym_U_SQUOTE] = ACTIONS(2821),
    [anon_sym_u8_SQUOTE] = ACTIONS(2821),
    [anon_sym_SQUOTE] = ACTIONS(2821),
    [anon_sym_L_DQUOTE] = ACTIONS(2821),
    [anon_sym_u_DQUOTE] = ACTIONS(2821),
    [anon_sym_U_DQUOTE] = ACTIONS(2821),
    [anon_sym_u8_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE] = ACTIONS(2821),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [anon_sym_NULL] = ACTIONS(2819),
    [anon_sym_nullptr] = ACTIONS(2819),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2819),
    [anon_sym_decltype] = ACTIONS(2819),
    [anon_sym_explicit] = ACTIONS(2819),
    [anon_sym_typename] = ACTIONS(2819),
    [anon_sym_template] = ACTIONS(2819),
    [anon_sym_operator] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_delete] = ACTIONS(2819),
    [anon_sym_throw] = ACTIONS(2819),
    [anon_sym_namespace] = ACTIONS(2819),
    [anon_sym_static_assert] = ACTIONS(2819),
    [anon_sym_concept] = ACTIONS(2819),
    [anon_sym_co_return] = ACTIONS(2819),
    [anon_sym_co_yield] = ACTIONS(2819),
    [anon_sym_R_DQUOTE] = ACTIONS(2821),
    [anon_sym_LR_DQUOTE] = ACTIONS(2821),
    [anon_sym_uR_DQUOTE] = ACTIONS(2821),
    [anon_sym_UR_DQUOTE] = ACTIONS(2821),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2821),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_requires] = ACTIONS(2819),
    [sym_this] = ACTIONS(2819),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(2693),
    [sym_identifier] = ACTIONS(2691),
    [aux_sym_preproc_include_token1] = ACTIONS(2691),
    [aux_sym_preproc_def_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2691),
    [sym_preproc_directive] = ACTIONS(2691),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym___extension__] = ACTIONS(2691),
    [anon_sym_typedef] = ACTIONS(2691),
    [anon_sym_virtual] = ACTIONS(2691),
    [anon_sym_extern] = ACTIONS(2691),
    [anon_sym___attribute__] = ACTIONS(2691),
    [anon_sym___attribute] = ACTIONS(2691),
    [anon_sym_using] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2693),
    [anon_sym___declspec] = ACTIONS(2691),
    [anon_sym___based] = ACTIONS(2691),
    [anon_sym___cdecl] = ACTIONS(2691),
    [anon_sym___clrcall] = ACTIONS(2691),
    [anon_sym___stdcall] = ACTIONS(2691),
    [anon_sym___fastcall] = ACTIONS(2691),
    [anon_sym___thiscall] = ACTIONS(2691),
    [anon_sym___vectorcall] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_signed] = ACTIONS(2691),
    [anon_sym_unsigned] = ACTIONS(2691),
    [anon_sym_long] = ACTIONS(2691),
    [anon_sym_short] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2691),
    [anon_sym_register] = ACTIONS(2691),
    [anon_sym_inline] = ACTIONS(2691),
    [anon_sym___inline] = ACTIONS(2691),
    [anon_sym___inline__] = ACTIONS(2691),
    [anon_sym___forceinline] = ACTIONS(2691),
    [anon_sym_thread_local] = ACTIONS(2691),
    [anon_sym___thread] = ACTIONS(2691),
    [anon_sym_const] = ACTIONS(2691),
    [anon_sym_constexpr] = ACTIONS(2691),
    [anon_sym_volatile] = ACTIONS(2691),
    [anon_sym_restrict] = ACTIONS(2691),
    [anon_sym___restrict__] = ACTIONS(2691),
    [anon_sym__Atomic] = ACTIONS(2691),
    [anon_sym__Noreturn] = ACTIONS(2691),
    [anon_sym_noreturn] = ACTIONS(2691),
    [anon_sym__Nonnull] = ACTIONS(2691),
    [anon_sym_mutable] = ACTIONS(2691),
    [anon_sym_constinit] = ACTIONS(2691),
    [anon_sym_consteval] = ACTIONS(2691),
    [anon_sym_alignas] = ACTIONS(2691),
    [anon_sym__Alignas] = ACTIONS(2691),
    [sym_primitive_type] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2691),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_union] = ACTIONS(2691),
    [anon_sym_if] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2691),
    [anon_sym_switch] = ACTIONS(2691),
    [anon_sym_case] = ACTIONS(2691),
    [anon_sym_default] = ACTIONS(2691),
    [anon_sym_while] = ACTIONS(2691),
    [anon_sym_do] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2691),
    [anon_sym_return] = ACTIONS(2691),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_continue] = ACTIONS(2691),
    [anon_sym_goto] = ACTIONS(2691),
    [anon_sym___try] = ACTIONS(2691),
    [anon_sym___leave] = ACTIONS(2691),
    [anon_sym_not] = ACTIONS(2691),
    [anon_sym_compl] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_sizeof] = ACTIONS(2691),
    [anon_sym___alignof__] = ACTIONS(2691),
    [anon_sym___alignof] = ACTIONS(2691),
    [anon_sym__alignof] = ACTIONS(2691),
    [anon_sym_alignof] = ACTIONS(2691),
    [anon_sym__Alignof] = ACTIONS(2691),
    [anon_sym_offsetof] = ACTIONS(2691),
    [anon_sym__Generic] = ACTIONS(2691),
    [anon_sym_asm] = ACTIONS(2691),
    [anon_sym___asm__] = ACTIONS(2691),
    [anon_sym___asm] = ACTIONS(2691),
    [sym_number_literal] = ACTIONS(2693),
    [anon_sym_L_SQUOTE] = ACTIONS(2693),
    [anon_sym_u_SQUOTE] = ACTIONS(2693),
    [anon_sym_U_SQUOTE] = ACTIONS(2693),
    [anon_sym_u8_SQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_L_DQUOTE] = ACTIONS(2693),
    [anon_sym_u_DQUOTE] = ACTIONS(2693),
    [anon_sym_U_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8_DQUOTE] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [anon_sym_NULL] = ACTIONS(2691),
    [anon_sym_nullptr] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2691),
    [anon_sym_decltype] = ACTIONS(2691),
    [anon_sym_explicit] = ACTIONS(2691),
    [anon_sym_typename] = ACTIONS(2691),
    [anon_sym_export] = ACTIONS(2691),
    [anon_sym_module] = ACTIONS(2691),
    [anon_sym_import] = ACTIONS(2691),
    [anon_sym_template] = ACTIONS(2691),
    [anon_sym_operator] = ACTIONS(2691),
    [anon_sym_try] = ACTIONS(2691),
    [anon_sym_delete] = ACTIONS(2691),
    [anon_sym_throw] = ACTIONS(2691),
    [anon_sym_namespace] = ACTIONS(2691),
    [anon_sym_static_assert] = ACTIONS(2691),
    [anon_sym_concept] = ACTIONS(2691),
    [anon_sym_co_return] = ACTIONS(2691),
    [anon_sym_co_yield] = ACTIONS(2691),
    [anon_sym_R_DQUOTE] = ACTIONS(2693),
    [anon_sym_LR_DQUOTE] = ACTIONS(2693),
    [anon_sym_uR_DQUOTE] = ACTIONS(2693),
    [anon_sym_UR_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2693),
    [anon_sym_co_await] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2691),
    [anon_sym_requires] = ACTIONS(2691),
    [sym_this] = ACTIONS(2691),
  },
  [298] = {
    [ts_builtin_sym_end] = ACTIONS(2697),
    [sym_identifier] = ACTIONS(2695),
    [aux_sym_preproc_include_token1] = ACTIONS(2695),
    [aux_sym_preproc_def_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2695),
    [sym_preproc_directive] = ACTIONS(2695),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym___extension__] = ACTIONS(2695),
    [anon_sym_typedef] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym___attribute__] = ACTIONS(2695),
    [anon_sym___attribute] = ACTIONS(2695),
    [anon_sym_using] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2697),
    [anon_sym___declspec] = ACTIONS(2695),
    [anon_sym___based] = ACTIONS(2695),
    [anon_sym___cdecl] = ACTIONS(2695),
    [anon_sym___clrcall] = ACTIONS(2695),
    [anon_sym___stdcall] = ACTIONS(2695),
    [anon_sym___fastcall] = ACTIONS(2695),
    [anon_sym___thiscall] = ACTIONS(2695),
    [anon_sym___vectorcall] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_signed] = ACTIONS(2695),
    [anon_sym_unsigned] = ACTIONS(2695),
    [anon_sym_long] = ACTIONS(2695),
    [anon_sym_short] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym___inline] = ACTIONS(2695),
    [anon_sym___inline__] = ACTIONS(2695),
    [anon_sym___forceinline] = ACTIONS(2695),
    [anon_sym_thread_local] = ACTIONS(2695),
    [anon_sym___thread] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym___restrict__] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym__Noreturn] = ACTIONS(2695),
    [anon_sym_noreturn] = ACTIONS(2695),
    [anon_sym__Nonnull] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_constinit] = ACTIONS(2695),
    [anon_sym_consteval] = ACTIONS(2695),
    [anon_sym_alignas] = ACTIONS(2695),
    [anon_sym__Alignas] = ACTIONS(2695),
    [sym_primitive_type] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2695),
    [anon_sym_union] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_case] = ACTIONS(2695),
    [anon_sym_default] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_goto] = ACTIONS(2695),
    [anon_sym___try] = ACTIONS(2695),
    [anon_sym___leave] = ACTIONS(2695),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_compl] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_sizeof] = ACTIONS(2695),
    [anon_sym___alignof__] = ACTIONS(2695),
    [anon_sym___alignof] = ACTIONS(2695),
    [anon_sym__alignof] = ACTIONS(2695),
    [anon_sym_alignof] = ACTIONS(2695),
    [anon_sym__Alignof] = ACTIONS(2695),
    [anon_sym_offsetof] = ACTIONS(2695),
    [anon_sym__Generic] = ACTIONS(2695),
    [anon_sym_asm] = ACTIONS(2695),
    [anon_sym___asm__] = ACTIONS(2695),
    [anon_sym___asm] = ACTIONS(2695),
    [sym_number_literal] = ACTIONS(2697),
    [anon_sym_L_SQUOTE] = ACTIONS(2697),
    [anon_sym_u_SQUOTE] = ACTIONS(2697),
    [anon_sym_U_SQUOTE] = ACTIONS(2697),
    [anon_sym_u8_SQUOTE] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_L_DQUOTE] = ACTIONS(2697),
    [anon_sym_u_DQUOTE] = ACTIONS(2697),
    [anon_sym_U_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [anon_sym_NULL] = ACTIONS(2695),
    [anon_sym_nullptr] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2695),
    [anon_sym_decltype] = ACTIONS(2695),
    [anon_sym_explicit] = ACTIONS(2695),
    [anon_sym_typename] = ACTIONS(2695),
    [anon_sym_export] = ACTIONS(2695),
    [anon_sym_module] = ACTIONS(2695),
    [anon_sym_import] = ACTIONS(2695),
    [anon_sym_template] = ACTIONS(2695),
    [anon_sym_operator] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_static_assert] = ACTIONS(2695),
    [anon_sym_concept] = ACTIONS(2695),
    [anon_sym_co_return] = ACTIONS(2695),
    [anon_sym_co_yield] = ACTIONS(2695),
    [anon_sym_R_DQUOTE] = ACTIONS(2697),
    [anon_sym_LR_DQUOTE] = ACTIONS(2697),
    [anon_sym_uR_DQUOTE] = ACTIONS(2697),
    [anon_sym_UR_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2697),
    [anon_sym_co_await] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_requires] = ACTIONS(2695),
    [sym_this] = ACTIONS(2695),
  },
  [299] = {
    [ts_builtin_sym_end] = ACTIONS(2705),
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_include_token1] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym___cdecl] = ACTIONS(2703),
    [anon_sym___clrcall] = ACTIONS(2703),
    [anon_sym___stdcall] = ACTIONS(2703),
    [anon_sym___fastcall] = ACTIONS(2703),
    [anon_sym___thiscall] = ACTIONS(2703),
    [anon_sym___vectorcall] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [anon_sym_if] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2703),
    [anon_sym_case] = ACTIONS(2703),
    [anon_sym_default] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(2703),
    [anon_sym_do] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2703),
    [anon_sym_return] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2703),
    [anon_sym_continue] = ACTIONS(2703),
    [anon_sym_goto] = ACTIONS(2703),
    [anon_sym___try] = ACTIONS(2703),
    [anon_sym___leave] = ACTIONS(2703),
    [anon_sym_not] = ACTIONS(2703),
    [anon_sym_compl] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2703),
    [anon_sym___alignof__] = ACTIONS(2703),
    [anon_sym___alignof] = ACTIONS(2703),
    [anon_sym__alignof] = ACTIONS(2703),
    [anon_sym_alignof] = ACTIONS(2703),
    [anon_sym__Alignof] = ACTIONS(2703),
    [anon_sym_offsetof] = ACTIONS(2703),
    [anon_sym__Generic] = ACTIONS(2703),
    [anon_sym_asm] = ACTIONS(2703),
    [anon_sym___asm__] = ACTIONS(2703),
    [anon_sym___asm] = ACTIONS(2703),
    [sym_number_literal] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2705),
    [anon_sym_u_SQUOTE] = ACTIONS(2705),
    [anon_sym_U_SQUOTE] = ACTIONS(2705),
    [anon_sym_u8_SQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_L_DQUOTE] = ACTIONS(2705),
    [anon_sym_u_DQUOTE] = ACTIONS(2705),
    [anon_sym_U_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8_DQUOTE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [sym_false] = ACTIONS(2703),
    [anon_sym_NULL] = ACTIONS(2703),
    [anon_sym_nullptr] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_export] = ACTIONS(2703),
    [anon_sym_module] = ACTIONS(2703),
    [anon_sym_import] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2703),
    [anon_sym_delete] = ACTIONS(2703),
    [anon_sym_throw] = ACTIONS(2703),
    [anon_sym_namespace] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
    [anon_sym_concept] = ACTIONS(2703),
    [anon_sym_co_return] = ACTIONS(2703),
    [anon_sym_co_yield] = ACTIONS(2703),
    [anon_sym_R_DQUOTE] = ACTIONS(2705),
    [anon_sym_LR_DQUOTE] = ACTIONS(2705),
    [anon_sym_uR_DQUOTE] = ACTIONS(2705),
    [anon_sym_UR_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2705),
    [anon_sym_co_await] = ACTIONS(2703),
    [anon_sym_new] = ACTIONS(2703),
    [anon_sym_requires] = ACTIONS(2703),
    [sym_this] = ACTIONS(2703),
  },
  [300] = {
    [ts_builtin_sym_end] = ACTIONS(2705),
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_include_token1] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym___cdecl] = ACTIONS(2703),
    [anon_sym___clrcall] = ACTIONS(2703),
    [anon_sym___stdcall] = ACTIONS(2703),
    [anon_sym___fastcall] = ACTIONS(2703),
    [anon_sym___thiscall] = ACTIONS(2703),
    [anon_sym___vectorcall] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [anon_sym_if] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2703),
    [anon_sym_case] = ACTIONS(2703),
    [anon_sym_default] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(2703),
    [anon_sym_do] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2703),
    [anon_sym_return] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2703),
    [anon_sym_continue] = ACTIONS(2703),
    [anon_sym_goto] = ACTIONS(2703),
    [anon_sym___try] = ACTIONS(2703),
    [anon_sym___leave] = ACTIONS(2703),
    [anon_sym_not] = ACTIONS(2703),
    [anon_sym_compl] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2703),
    [anon_sym___alignof__] = ACTIONS(2703),
    [anon_sym___alignof] = ACTIONS(2703),
    [anon_sym__alignof] = ACTIONS(2703),
    [anon_sym_alignof] = ACTIONS(2703),
    [anon_sym__Alignof] = ACTIONS(2703),
    [anon_sym_offsetof] = ACTIONS(2703),
    [anon_sym__Generic] = ACTIONS(2703),
    [anon_sym_asm] = ACTIONS(2703),
    [anon_sym___asm__] = ACTIONS(2703),
    [anon_sym___asm] = ACTIONS(2703),
    [sym_number_literal] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2705),
    [anon_sym_u_SQUOTE] = ACTIONS(2705),
    [anon_sym_U_SQUOTE] = ACTIONS(2705),
    [anon_sym_u8_SQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_L_DQUOTE] = ACTIONS(2705),
    [anon_sym_u_DQUOTE] = ACTIONS(2705),
    [anon_sym_U_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8_DQUOTE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [sym_false] = ACTIONS(2703),
    [anon_sym_NULL] = ACTIONS(2703),
    [anon_sym_nullptr] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_export] = ACTIONS(2703),
    [anon_sym_module] = ACTIONS(2703),
    [anon_sym_import] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2703),
    [anon_sym_delete] = ACTIONS(2703),
    [anon_sym_throw] = ACTIONS(2703),
    [anon_sym_namespace] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
    [anon_sym_concept] = ACTIONS(2703),
    [anon_sym_co_return] = ACTIONS(2703),
    [anon_sym_co_yield] = ACTIONS(2703),
    [anon_sym_R_DQUOTE] = ACTIONS(2705),
    [anon_sym_LR_DQUOTE] = ACTIONS(2705),
    [anon_sym_uR_DQUOTE] = ACTIONS(2705),
    [anon_sym_UR_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2705),
    [anon_sym_co_await] = ACTIONS(2703),
    [anon_sym_new] = ACTIONS(2703),
    [anon_sym_requires] = ACTIONS(2703),
    [sym_this] = ACTIONS(2703),
  },
  [301] = {
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_include_token1] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2823),
    [aux_sym_preproc_if_token1] = ACTIONS(2823),
    [aux_sym_preproc_if_token2] = ACTIONS(2823),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2823),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2823),
    [aux_sym_preproc_else_token1] = ACTIONS(2823),
    [aux_sym_preproc_elif_token1] = ACTIONS(2823),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2823),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2823),
    [sym_preproc_directive] = ACTIONS(2823),
    [anon_sym_LPAREN2] = ACTIONS(2825),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_TILDE] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_SEMI] = ACTIONS(2825),
    [anon_sym___extension__] = ACTIONS(2823),
    [anon_sym_typedef] = ACTIONS(2823),
    [anon_sym_virtual] = ACTIONS(2823),
    [anon_sym_extern] = ACTIONS(2823),
    [anon_sym___attribute__] = ACTIONS(2823),
    [anon_sym___attribute] = ACTIONS(2823),
    [anon_sym_using] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2825),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2825),
    [anon_sym___declspec] = ACTIONS(2823),
    [anon_sym___based] = ACTIONS(2823),
    [anon_sym___cdecl] = ACTIONS(2823),
    [anon_sym___clrcall] = ACTIONS(2823),
    [anon_sym___stdcall] = ACTIONS(2823),
    [anon_sym___fastcall] = ACTIONS(2823),
    [anon_sym___thiscall] = ACTIONS(2823),
    [anon_sym___vectorcall] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_signed] = ACTIONS(2823),
    [anon_sym_unsigned] = ACTIONS(2823),
    [anon_sym_long] = ACTIONS(2823),
    [anon_sym_short] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2823),
    [anon_sym_register] = ACTIONS(2823),
    [anon_sym_inline] = ACTIONS(2823),
    [anon_sym___inline] = ACTIONS(2823),
    [anon_sym___inline__] = ACTIONS(2823),
    [anon_sym___forceinline] = ACTIONS(2823),
    [anon_sym_thread_local] = ACTIONS(2823),
    [anon_sym___thread] = ACTIONS(2823),
    [anon_sym_const] = ACTIONS(2823),
    [anon_sym_constexpr] = ACTIONS(2823),
    [anon_sym_volatile] = ACTIONS(2823),
    [anon_sym_restrict] = ACTIONS(2823),
    [anon_sym___restrict__] = ACTIONS(2823),
    [anon_sym__Atomic] = ACTIONS(2823),
    [anon_sym__Noreturn] = ACTIONS(2823),
    [anon_sym_noreturn] = ACTIONS(2823),
    [anon_sym__Nonnull] = ACTIONS(2823),
    [anon_sym_mutable] = ACTIONS(2823),
    [anon_sym_constinit] = ACTIONS(2823),
    [anon_sym_consteval] = ACTIONS(2823),
    [anon_sym_alignas] = ACTIONS(2823),
    [anon_sym__Alignas] = ACTIONS(2823),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2823),
    [anon_sym_class] = ACTIONS(2823),
    [anon_sym_struct] = ACTIONS(2823),
    [anon_sym_union] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_switch] = ACTIONS(2823),
    [anon_sym_case] = ACTIONS(2823),
    [anon_sym_default] = ACTIONS(2823),
    [anon_sym_while] = ACTIONS(2823),
    [anon_sym_do] = ACTIONS(2823),
    [anon_sym_for] = ACTIONS(2823),
    [anon_sym_return] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2823),
    [anon_sym_continue] = ACTIONS(2823),
    [anon_sym_goto] = ACTIONS(2823),
    [anon_sym___try] = ACTIONS(2823),
    [anon_sym___leave] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2823),
    [anon_sym_compl] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2825),
    [anon_sym_sizeof] = ACTIONS(2823),
    [anon_sym___alignof__] = ACTIONS(2823),
    [anon_sym___alignof] = ACTIONS(2823),
    [anon_sym__alignof] = ACTIONS(2823),
    [anon_sym_alignof] = ACTIONS(2823),
    [anon_sym__Alignof] = ACTIONS(2823),
    [anon_sym_offsetof] = ACTIONS(2823),
    [anon_sym__Generic] = ACTIONS(2823),
    [anon_sym_asm] = ACTIONS(2823),
    [anon_sym___asm__] = ACTIONS(2823),
    [anon_sym___asm] = ACTIONS(2823),
    [sym_number_literal] = ACTIONS(2825),
    [anon_sym_L_SQUOTE] = ACTIONS(2825),
    [anon_sym_u_SQUOTE] = ACTIONS(2825),
    [anon_sym_U_SQUOTE] = ACTIONS(2825),
    [anon_sym_u8_SQUOTE] = ACTIONS(2825),
    [anon_sym_SQUOTE] = ACTIONS(2825),
    [anon_sym_L_DQUOTE] = ACTIONS(2825),
    [anon_sym_u_DQUOTE] = ACTIONS(2825),
    [anon_sym_U_DQUOTE] = ACTIONS(2825),
    [anon_sym_u8_DQUOTE] = ACTIONS(2825),
    [anon_sym_DQUOTE] = ACTIONS(2825),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [anon_sym_NULL] = ACTIONS(2823),
    [anon_sym_nullptr] = ACTIONS(2823),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2823),
    [anon_sym_decltype] = ACTIONS(2823),
    [anon_sym_explicit] = ACTIONS(2823),
    [anon_sym_typename] = ACTIONS(2823),
    [anon_sym_template] = ACTIONS(2823),
    [anon_sym_operator] = ACTIONS(2823),
    [anon_sym_try] = ACTIONS(2823),
    [anon_sym_delete] = ACTIONS(2823),
    [anon_sym_throw] = ACTIONS(2823),
    [anon_sym_namespace] = ACTIONS(2823),
    [anon_sym_static_assert] = ACTIONS(2823),
    [anon_sym_concept] = ACTIONS(2823),
    [anon_sym_co_return] = ACTIONS(2823),
    [anon_sym_co_yield] = ACTIONS(2823),
    [anon_sym_R_DQUOTE] = ACTIONS(2825),
    [anon_sym_LR_DQUOTE] = ACTIONS(2825),
    [anon_sym_uR_DQUOTE] = ACTIONS(2825),
    [anon_sym_UR_DQUOTE] = ACTIONS(2825),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2825),
    [anon_sym_co_await] = ACTIONS(2823),
    [anon_sym_new] = ACTIONS(2823),
    [anon_sym_requires] = ACTIONS(2823),
    [sym_this] = ACTIONS(2823),
  },
  [302] = {
    [sym_identifier] = ACTIONS(2827),
    [aux_sym_preproc_include_token1] = ACTIONS(2827),
    [aux_sym_preproc_def_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2827),
    [aux_sym_preproc_else_token1] = ACTIONS(2827),
    [aux_sym_preproc_elif_token1] = ACTIONS(2827),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2827),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2827),
    [sym_preproc_directive] = ACTIONS(2827),
    [anon_sym_LPAREN2] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym___extension__] = ACTIONS(2827),
    [anon_sym_typedef] = ACTIONS(2827),
    [anon_sym_virtual] = ACTIONS(2827),
    [anon_sym_extern] = ACTIONS(2827),
    [anon_sym___attribute__] = ACTIONS(2827),
    [anon_sym___attribute] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2829),
    [anon_sym___declspec] = ACTIONS(2827),
    [anon_sym___based] = ACTIONS(2827),
    [anon_sym___cdecl] = ACTIONS(2827),
    [anon_sym___clrcall] = ACTIONS(2827),
    [anon_sym___stdcall] = ACTIONS(2827),
    [anon_sym___fastcall] = ACTIONS(2827),
    [anon_sym___thiscall] = ACTIONS(2827),
    [anon_sym___vectorcall] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_signed] = ACTIONS(2827),
    [anon_sym_unsigned] = ACTIONS(2827),
    [anon_sym_long] = ACTIONS(2827),
    [anon_sym_short] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_static] = ACTIONS(2827),
    [anon_sym_register] = ACTIONS(2827),
    [anon_sym_inline] = ACTIONS(2827),
    [anon_sym___inline] = ACTIONS(2827),
    [anon_sym___inline__] = ACTIONS(2827),
    [anon_sym___forceinline] = ACTIONS(2827),
    [anon_sym_thread_local] = ACTIONS(2827),
    [anon_sym___thread] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_constexpr] = ACTIONS(2827),
    [anon_sym_volatile] = ACTIONS(2827),
    [anon_sym_restrict] = ACTIONS(2827),
    [anon_sym___restrict__] = ACTIONS(2827),
    [anon_sym__Atomic] = ACTIONS(2827),
    [anon_sym__Noreturn] = ACTIONS(2827),
    [anon_sym_noreturn] = ACTIONS(2827),
    [anon_sym__Nonnull] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_constinit] = ACTIONS(2827),
    [anon_sym_consteval] = ACTIONS(2827),
    [anon_sym_alignas] = ACTIONS(2827),
    [anon_sym__Alignas] = ACTIONS(2827),
    [sym_primitive_type] = ACTIONS(2827),
    [anon_sym_enum] = ACTIONS(2827),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_union] = ACTIONS(2827),
    [anon_sym_if] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_default] = ACTIONS(2827),
    [anon_sym_while] = ACTIONS(2827),
    [anon_sym_do] = ACTIONS(2827),
    [anon_sym_for] = ACTIONS(2827),
    [anon_sym_return] = ACTIONS(2827),
    [anon_sym_break] = ACTIONS(2827),
    [anon_sym_continue] = ACTIONS(2827),
    [anon_sym_goto] = ACTIONS(2827),
    [anon_sym___try] = ACTIONS(2827),
    [anon_sym___leave] = ACTIONS(2827),
    [anon_sym_not] = ACTIONS(2827),
    [anon_sym_compl] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_sizeof] = ACTIONS(2827),
    [anon_sym___alignof__] = ACTIONS(2827),
    [anon_sym___alignof] = ACTIONS(2827),
    [anon_sym__alignof] = ACTIONS(2827),
    [anon_sym_alignof] = ACTIONS(2827),
    [anon_sym__Alignof] = ACTIONS(2827),
    [anon_sym_offsetof] = ACTIONS(2827),
    [anon_sym__Generic] = ACTIONS(2827),
    [anon_sym_asm] = ACTIONS(2827),
    [anon_sym___asm__] = ACTIONS(2827),
    [anon_sym___asm] = ACTIONS(2827),
    [sym_number_literal] = ACTIONS(2829),
    [anon_sym_L_SQUOTE] = ACTIONS(2829),
    [anon_sym_u_SQUOTE] = ACTIONS(2829),
    [anon_sym_U_SQUOTE] = ACTIONS(2829),
    [anon_sym_u8_SQUOTE] = ACTIONS(2829),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_L_DQUOTE] = ACTIONS(2829),
    [anon_sym_u_DQUOTE] = ACTIONS(2829),
    [anon_sym_U_DQUOTE] = ACTIONS(2829),
    [anon_sym_u8_DQUOTE] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(2829),
    [sym_true] = ACTIONS(2827),
    [sym_false] = ACTIONS(2827),
    [anon_sym_NULL] = ACTIONS(2827),
    [anon_sym_nullptr] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2827),
    [anon_sym_decltype] = ACTIONS(2827),
    [anon_sym_explicit] = ACTIONS(2827),
    [anon_sym_typename] = ACTIONS(2827),
    [anon_sym_template] = ACTIONS(2827),
    [anon_sym_operator] = ACTIONS(2827),
    [anon_sym_try] = ACTIONS(2827),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_throw] = ACTIONS(2827),
    [anon_sym_namespace] = ACTIONS(2827),
    [anon_sym_static_assert] = ACTIONS(2827),
    [anon_sym_concept] = ACTIONS(2827),
    [anon_sym_co_return] = ACTIONS(2827),
    [anon_sym_co_yield] = ACTIONS(2827),
    [anon_sym_R_DQUOTE] = ACTIONS(2829),
    [anon_sym_LR_DQUOTE] = ACTIONS(2829),
    [anon_sym_uR_DQUOTE] = ACTIONS(2829),
    [anon_sym_UR_DQUOTE] = ACTIONS(2829),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2829),
    [anon_sym_co_await] = ACTIONS(2827),
    [anon_sym_new] = ACTIONS(2827),
    [anon_sym_requires] = ACTIONS(2827),
    [sym_this] = ACTIONS(2827),
  },
  [303] = {
    [sym_identifier] = ACTIONS(2831),
    [aux_sym_preproc_include_token1] = ACTIONS(2831),
    [aux_sym_preproc_def_token1] = ACTIONS(2831),
    [aux_sym_preproc_if_token1] = ACTIONS(2831),
    [aux_sym_preproc_if_token2] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2831),
    [aux_sym_preproc_elif_token1] = ACTIONS(2831),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2831),
    [sym_preproc_directive] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym___extension__] = ACTIONS(2831),
    [anon_sym_typedef] = ACTIONS(2831),
    [anon_sym_virtual] = ACTIONS(2831),
    [anon_sym_extern] = ACTIONS(2831),
    [anon_sym___attribute__] = ACTIONS(2831),
    [anon_sym___attribute] = ACTIONS(2831),
    [anon_sym_using] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2833),
    [anon_sym___declspec] = ACTIONS(2831),
    [anon_sym___based] = ACTIONS(2831),
    [anon_sym___cdecl] = ACTIONS(2831),
    [anon_sym___clrcall] = ACTIONS(2831),
    [anon_sym___stdcall] = ACTIONS(2831),
    [anon_sym___fastcall] = ACTIONS(2831),
    [anon_sym___thiscall] = ACTIONS(2831),
    [anon_sym___vectorcall] = ACTIONS(2831),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_signed] = ACTIONS(2831),
    [anon_sym_unsigned] = ACTIONS(2831),
    [anon_sym_long] = ACTIONS(2831),
    [anon_sym_short] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_static] = ACTIONS(2831),
    [anon_sym_register] = ACTIONS(2831),
    [anon_sym_inline] = ACTIONS(2831),
    [anon_sym___inline] = ACTIONS(2831),
    [anon_sym___inline__] = ACTIONS(2831),
    [anon_sym___forceinline] = ACTIONS(2831),
    [anon_sym_thread_local] = ACTIONS(2831),
    [anon_sym___thread] = ACTIONS(2831),
    [anon_sym_const] = ACTIONS(2831),
    [anon_sym_constexpr] = ACTIONS(2831),
    [anon_sym_volatile] = ACTIONS(2831),
    [anon_sym_restrict] = ACTIONS(2831),
    [anon_sym___restrict__] = ACTIONS(2831),
    [anon_sym__Atomic] = ACTIONS(2831),
    [anon_sym__Noreturn] = ACTIONS(2831),
    [anon_sym_noreturn] = ACTIONS(2831),
    [anon_sym__Nonnull] = ACTIONS(2831),
    [anon_sym_mutable] = ACTIONS(2831),
    [anon_sym_constinit] = ACTIONS(2831),
    [anon_sym_consteval] = ACTIONS(2831),
    [anon_sym_alignas] = ACTIONS(2831),
    [anon_sym__Alignas] = ACTIONS(2831),
    [sym_primitive_type] = ACTIONS(2831),
    [anon_sym_enum] = ACTIONS(2831),
    [anon_sym_class] = ACTIONS(2831),
    [anon_sym_struct] = ACTIONS(2831),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_switch] = ACTIONS(2831),
    [anon_sym_case] = ACTIONS(2831),
    [anon_sym_default] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_break] = ACTIONS(2831),
    [anon_sym_continue] = ACTIONS(2831),
    [anon_sym_goto] = ACTIONS(2831),
    [anon_sym___try] = ACTIONS(2831),
    [anon_sym___leave] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_compl] = ACTIONS(2831),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2831),
    [anon_sym___alignof__] = ACTIONS(2831),
    [anon_sym___alignof] = ACTIONS(2831),
    [anon_sym__alignof] = ACTIONS(2831),
    [anon_sym_alignof] = ACTIONS(2831),
    [anon_sym__Alignof] = ACTIONS(2831),
    [anon_sym_offsetof] = ACTIONS(2831),
    [anon_sym__Generic] = ACTIONS(2831),
    [anon_sym_asm] = ACTIONS(2831),
    [anon_sym___asm__] = ACTIONS(2831),
    [anon_sym___asm] = ACTIONS(2831),
    [sym_number_literal] = ACTIONS(2833),
    [anon_sym_L_SQUOTE] = ACTIONS(2833),
    [anon_sym_u_SQUOTE] = ACTIONS(2833),
    [anon_sym_U_SQUOTE] = ACTIONS(2833),
    [anon_sym_u8_SQUOTE] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_L_DQUOTE] = ACTIONS(2833),
    [anon_sym_u_DQUOTE] = ACTIONS(2833),
    [anon_sym_U_DQUOTE] = ACTIONS(2833),
    [anon_sym_u8_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [sym_true] = ACTIONS(2831),
    [sym_false] = ACTIONS(2831),
    [anon_sym_NULL] = ACTIONS(2831),
    [anon_sym_nullptr] = ACTIONS(2831),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2831),
    [anon_sym_decltype] = ACTIONS(2831),
    [anon_sym_explicit] = ACTIONS(2831),
    [anon_sym_typename] = ACTIONS(2831),
    [anon_sym_template] = ACTIONS(2831),
    [anon_sym_operator] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_delete] = ACTIONS(2831),
    [anon_sym_throw] = ACTIONS(2831),
    [anon_sym_namespace] = ACTIONS(2831),
    [anon_sym_static_assert] = ACTIONS(2831),
    [anon_sym_concept] = ACTIONS(2831),
    [anon_sym_co_return] = ACTIONS(2831),
    [anon_sym_co_yield] = ACTIONS(2831),
    [anon_sym_R_DQUOTE] = ACTIONS(2833),
    [anon_sym_LR_DQUOTE] = ACTIONS(2833),
    [anon_sym_uR_DQUOTE] = ACTIONS(2833),
    [anon_sym_UR_DQUOTE] = ACTIONS(2833),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2833),
    [anon_sym_co_await] = ACTIONS(2831),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_requires] = ACTIONS(2831),
    [sym_this] = ACTIONS(2831),
  },
  [304] = {
    [sym_identifier] = ACTIONS(2835),
    [aux_sym_preproc_include_token1] = ACTIONS(2835),
    [aux_sym_preproc_def_token1] = ACTIONS(2835),
    [aux_sym_preproc_if_token1] = ACTIONS(2835),
    [aux_sym_preproc_if_token2] = ACTIONS(2835),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2835),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2835),
    [aux_sym_preproc_else_token1] = ACTIONS(2835),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2835),
    [sym_preproc_directive] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym___extension__] = ACTIONS(2835),
    [anon_sym_typedef] = ACTIONS(2835),
    [anon_sym_virtual] = ACTIONS(2835),
    [anon_sym_extern] = ACTIONS(2835),
    [anon_sym___attribute__] = ACTIONS(2835),
    [anon_sym___attribute] = ACTIONS(2835),
    [anon_sym_using] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2837),
    [anon_sym___declspec] = ACTIONS(2835),
    [anon_sym___based] = ACTIONS(2835),
    [anon_sym___cdecl] = ACTIONS(2835),
    [anon_sym___clrcall] = ACTIONS(2835),
    [anon_sym___stdcall] = ACTIONS(2835),
    [anon_sym___fastcall] = ACTIONS(2835),
    [anon_sym___thiscall] = ACTIONS(2835),
    [anon_sym___vectorcall] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_signed] = ACTIONS(2835),
    [anon_sym_unsigned] = ACTIONS(2835),
    [anon_sym_long] = ACTIONS(2835),
    [anon_sym_short] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_static] = ACTIONS(2835),
    [anon_sym_register] = ACTIONS(2835),
    [anon_sym_inline] = ACTIONS(2835),
    [anon_sym___inline] = ACTIONS(2835),
    [anon_sym___inline__] = ACTIONS(2835),
    [anon_sym___forceinline] = ACTIONS(2835),
    [anon_sym_thread_local] = ACTIONS(2835),
    [anon_sym___thread] = ACTIONS(2835),
    [anon_sym_const] = ACTIONS(2835),
    [anon_sym_constexpr] = ACTIONS(2835),
    [anon_sym_volatile] = ACTIONS(2835),
    [anon_sym_restrict] = ACTIONS(2835),
    [anon_sym___restrict__] = ACTIONS(2835),
    [anon_sym__Atomic] = ACTIONS(2835),
    [anon_sym__Noreturn] = ACTIONS(2835),
    [anon_sym_noreturn] = ACTIONS(2835),
    [anon_sym__Nonnull] = ACTIONS(2835),
    [anon_sym_mutable] = ACTIONS(2835),
    [anon_sym_constinit] = ACTIONS(2835),
    [anon_sym_consteval] = ACTIONS(2835),
    [anon_sym_alignas] = ACTIONS(2835),
    [anon_sym__Alignas] = ACTIONS(2835),
    [sym_primitive_type] = ACTIONS(2835),
    [anon_sym_enum] = ACTIONS(2835),
    [anon_sym_class] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2835),
    [anon_sym_union] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_switch] = ACTIONS(2835),
    [anon_sym_case] = ACTIONS(2835),
    [anon_sym_default] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_break] = ACTIONS(2835),
    [anon_sym_continue] = ACTIONS(2835),
    [anon_sym_goto] = ACTIONS(2835),
    [anon_sym___try] = ACTIONS(2835),
    [anon_sym___leave] = ACTIONS(2835),
    [anon_sym_not] = ACTIONS(2835),
    [anon_sym_compl] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2835),
    [anon_sym___alignof] = ACTIONS(2835),
    [anon_sym__alignof] = ACTIONS(2835),
    [anon_sym_alignof] = ACTIONS(2835),
    [anon_sym__Alignof] = ACTIONS(2835),
    [anon_sym_offsetof] = ACTIONS(2835),
    [anon_sym__Generic] = ACTIONS(2835),
    [anon_sym_asm] = ACTIONS(2835),
    [anon_sym___asm__] = ACTIONS(2835),
    [anon_sym___asm] = ACTIONS(2835),
    [sym_number_literal] = ACTIONS(2837),
    [anon_sym_L_SQUOTE] = ACTIONS(2837),
    [anon_sym_u_SQUOTE] = ACTIONS(2837),
    [anon_sym_U_SQUOTE] = ACTIONS(2837),
    [anon_sym_u8_SQUOTE] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_L_DQUOTE] = ACTIONS(2837),
    [anon_sym_u_DQUOTE] = ACTIONS(2837),
    [anon_sym_U_DQUOTE] = ACTIONS(2837),
    [anon_sym_u8_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [sym_true] = ACTIONS(2835),
    [sym_false] = ACTIONS(2835),
    [anon_sym_NULL] = ACTIONS(2835),
    [anon_sym_nullptr] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2835),
    [anon_sym_decltype] = ACTIONS(2835),
    [anon_sym_explicit] = ACTIONS(2835),
    [anon_sym_typename] = ACTIONS(2835),
    [anon_sym_template] = ACTIONS(2835),
    [anon_sym_operator] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_delete] = ACTIONS(2835),
    [anon_sym_throw] = ACTIONS(2835),
    [anon_sym_namespace] = ACTIONS(2835),
    [anon_sym_static_assert] = ACTIONS(2835),
    [anon_sym_concept] = ACTIONS(2835),
    [anon_sym_co_return] = ACTIONS(2835),
    [anon_sym_co_yield] = ACTIONS(2835),
    [anon_sym_R_DQUOTE] = ACTIONS(2837),
    [anon_sym_LR_DQUOTE] = ACTIONS(2837),
    [anon_sym_uR_DQUOTE] = ACTIONS(2837),
    [anon_sym_UR_DQUOTE] = ACTIONS(2837),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2837),
    [anon_sym_co_await] = ACTIONS(2835),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_requires] = ACTIONS(2835),
    [sym_this] = ACTIONS(2835),
  },
  [305] = {
    [sym_identifier] = ACTIONS(2839),
    [aux_sym_preproc_include_token1] = ACTIONS(2839),
    [aux_sym_preproc_def_token1] = ACTIONS(2839),
    [aux_sym_preproc_if_token1] = ACTIONS(2839),
    [aux_sym_preproc_if_token2] = ACTIONS(2839),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2839),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2839),
    [aux_sym_preproc_else_token1] = ACTIONS(2839),
    [aux_sym_preproc_elif_token1] = ACTIONS(2839),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2839),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2839),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym___extension__] = ACTIONS(2839),
    [anon_sym_typedef] = ACTIONS(2839),
    [anon_sym_virtual] = ACTIONS(2839),
    [anon_sym_extern] = ACTIONS(2839),
    [anon_sym___attribute__] = ACTIONS(2839),
    [anon_sym___attribute] = ACTIONS(2839),
    [anon_sym_using] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2841),
    [anon_sym___declspec] = ACTIONS(2839),
    [anon_sym___based] = ACTIONS(2839),
    [anon_sym___cdecl] = ACTIONS(2839),
    [anon_sym___clrcall] = ACTIONS(2839),
    [anon_sym___stdcall] = ACTIONS(2839),
    [anon_sym___fastcall] = ACTIONS(2839),
    [anon_sym___thiscall] = ACTIONS(2839),
    [anon_sym___vectorcall] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_signed] = ACTIONS(2839),
    [anon_sym_unsigned] = ACTIONS(2839),
    [anon_sym_long] = ACTIONS(2839),
    [anon_sym_short] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_static] = ACTIONS(2839),
    [anon_sym_register] = ACTIONS(2839),
    [anon_sym_inline] = ACTIONS(2839),
    [anon_sym___inline] = ACTIONS(2839),
    [anon_sym___inline__] = ACTIONS(2839),
    [anon_sym___forceinline] = ACTIONS(2839),
    [anon_sym_thread_local] = ACTIONS(2839),
    [anon_sym___thread] = ACTIONS(2839),
    [anon_sym_const] = ACTIONS(2839),
    [anon_sym_constexpr] = ACTIONS(2839),
    [anon_sym_volatile] = ACTIONS(2839),
    [anon_sym_restrict] = ACTIONS(2839),
    [anon_sym___restrict__] = ACTIONS(2839),
    [anon_sym__Atomic] = ACTIONS(2839),
    [anon_sym__Noreturn] = ACTIONS(2839),
    [anon_sym_noreturn] = ACTIONS(2839),
    [anon_sym__Nonnull] = ACTIONS(2839),
    [anon_sym_mutable] = ACTIONS(2839),
    [anon_sym_constinit] = ACTIONS(2839),
    [anon_sym_consteval] = ACTIONS(2839),
    [anon_sym_alignas] = ACTIONS(2839),
    [anon_sym__Alignas] = ACTIONS(2839),
    [sym_primitive_type] = ACTIONS(2839),
    [anon_sym_enum] = ACTIONS(2839),
    [anon_sym_class] = ACTIONS(2839),
    [anon_sym_struct] = ACTIONS(2839),
    [anon_sym_union] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_switch] = ACTIONS(2839),
    [anon_sym_case] = ACTIONS(2839),
    [anon_sym_default] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_continue] = ACTIONS(2839),
    [anon_sym_goto] = ACTIONS(2839),
    [anon_sym___try] = ACTIONS(2839),
    [anon_sym___leave] = ACTIONS(2839),
    [anon_sym_not] = ACTIONS(2839),
    [anon_sym_compl] = ACTIONS(2839),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_sizeof] = ACTIONS(2839),
    [anon_sym___alignof__] = ACTIONS(2839),
    [anon_sym___alignof] = ACTIONS(2839),
    [anon_sym__alignof] = ACTIONS(2839),
    [anon_sym_alignof] = ACTIONS(2839),
    [anon_sym__Alignof] = ACTIONS(2839),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2839),
    [anon_sym_asm] = ACTIONS(2839),
    [anon_sym___asm__] = ACTIONS(2839),
    [anon_sym___asm] = ACTIONS(2839),
    [sym_number_literal] = ACTIONS(2841),
    [anon_sym_L_SQUOTE] = ACTIONS(2841),
    [anon_sym_u_SQUOTE] = ACTIONS(2841),
    [anon_sym_U_SQUOTE] = ACTIONS(2841),
    [anon_sym_u8_SQUOTE] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_L_DQUOTE] = ACTIONS(2841),
    [anon_sym_u_DQUOTE] = ACTIONS(2841),
    [anon_sym_U_DQUOTE] = ACTIONS(2841),
    [anon_sym_u8_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [sym_true] = ACTIONS(2839),
    [sym_false] = ACTIONS(2839),
    [anon_sym_NULL] = ACTIONS(2839),
    [anon_sym_nullptr] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2839),
    [anon_sym_decltype] = ACTIONS(2839),
    [anon_sym_explicit] = ACTIONS(2839),
    [anon_sym_typename] = ACTIONS(2839),
    [anon_sym_template] = ACTIONS(2839),
    [anon_sym_operator] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_delete] = ACTIONS(2839),
    [anon_sym_throw] = ACTIONS(2839),
    [anon_sym_namespace] = ACTIONS(2839),
    [anon_sym_static_assert] = ACTIONS(2839),
    [anon_sym_concept] = ACTIONS(2839),
    [anon_sym_co_return] = ACTIONS(2839),
    [anon_sym_co_yield] = ACTIONS(2839),
    [anon_sym_R_DQUOTE] = ACTIONS(2841),
    [anon_sym_LR_DQUOTE] = ACTIONS(2841),
    [anon_sym_uR_DQUOTE] = ACTIONS(2841),
    [anon_sym_UR_DQUOTE] = ACTIONS(2841),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2841),
    [anon_sym_co_await] = ACTIONS(2839),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_requires] = ACTIONS(2839),
    [sym_this] = ACTIONS(2839),
  },
  [306] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [aux_sym_preproc_else_token1] = ACTIONS(2843),
    [aux_sym_preproc_elif_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [307] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [aux_sym_preproc_else_token1] = ACTIONS(2843),
    [aux_sym_preproc_elif_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [308] = {
    [sym_identifier] = ACTIONS(2847),
    [aux_sym_preproc_include_token1] = ACTIONS(2847),
    [aux_sym_preproc_def_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token2] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2847),
    [aux_sym_preproc_else_token1] = ACTIONS(2847),
    [aux_sym_preproc_elif_token1] = ACTIONS(2847),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2847),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2847),
    [sym_preproc_directive] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym___extension__] = ACTIONS(2847),
    [anon_sym_typedef] = ACTIONS(2847),
    [anon_sym_virtual] = ACTIONS(2847),
    [anon_sym_extern] = ACTIONS(2847),
    [anon_sym___attribute__] = ACTIONS(2847),
    [anon_sym___attribute] = ACTIONS(2847),
    [anon_sym_using] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2849),
    [anon_sym___declspec] = ACTIONS(2847),
    [anon_sym___based] = ACTIONS(2847),
    [anon_sym___cdecl] = ACTIONS(2847),
    [anon_sym___clrcall] = ACTIONS(2847),
    [anon_sym___stdcall] = ACTIONS(2847),
    [anon_sym___fastcall] = ACTIONS(2847),
    [anon_sym___thiscall] = ACTIONS(2847),
    [anon_sym___vectorcall] = ACTIONS(2847),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_signed] = ACTIONS(2847),
    [anon_sym_unsigned] = ACTIONS(2847),
    [anon_sym_long] = ACTIONS(2847),
    [anon_sym_short] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2847),
    [anon_sym_register] = ACTIONS(2847),
    [anon_sym_inline] = ACTIONS(2847),
    [anon_sym___inline] = ACTIONS(2847),
    [anon_sym___inline__] = ACTIONS(2847),
    [anon_sym___forceinline] = ACTIONS(2847),
    [anon_sym_thread_local] = ACTIONS(2847),
    [anon_sym___thread] = ACTIONS(2847),
    [anon_sym_const] = ACTIONS(2847),
    [anon_sym_constexpr] = ACTIONS(2847),
    [anon_sym_volatile] = ACTIONS(2847),
    [anon_sym_restrict] = ACTIONS(2847),
    [anon_sym___restrict__] = ACTIONS(2847),
    [anon_sym__Atomic] = ACTIONS(2847),
    [anon_sym__Noreturn] = ACTIONS(2847),
    [anon_sym_noreturn] = ACTIONS(2847),
    [anon_sym__Nonnull] = ACTIONS(2847),
    [anon_sym_mutable] = ACTIONS(2847),
    [anon_sym_constinit] = ACTIONS(2847),
    [anon_sym_consteval] = ACTIONS(2847),
    [anon_sym_alignas] = ACTIONS(2847),
    [anon_sym__Alignas] = ACTIONS(2847),
    [sym_primitive_type] = ACTIONS(2847),
    [anon_sym_enum] = ACTIONS(2847),
    [anon_sym_class] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2847),
    [anon_sym_union] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_switch] = ACTIONS(2847),
    [anon_sym_case] = ACTIONS(2847),
    [anon_sym_default] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_break] = ACTIONS(2847),
    [anon_sym_continue] = ACTIONS(2847),
    [anon_sym_goto] = ACTIONS(2847),
    [anon_sym___try] = ACTIONS(2847),
    [anon_sym___leave] = ACTIONS(2847),
    [anon_sym_not] = ACTIONS(2847),
    [anon_sym_compl] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2849),
    [anon_sym_sizeof] = ACTIONS(2847),
    [anon_sym___alignof__] = ACTIONS(2847),
    [anon_sym___alignof] = ACTIONS(2847),
    [anon_sym__alignof] = ACTIONS(2847),
    [anon_sym_alignof] = ACTIONS(2847),
    [anon_sym__Alignof] = ACTIONS(2847),
    [anon_sym_offsetof] = ACTIONS(2847),
    [anon_sym__Generic] = ACTIONS(2847),
    [anon_sym_asm] = ACTIONS(2847),
    [anon_sym___asm__] = ACTIONS(2847),
    [anon_sym___asm] = ACTIONS(2847),
    [sym_number_literal] = ACTIONS(2849),
    [anon_sym_L_SQUOTE] = ACTIONS(2849),
    [anon_sym_u_SQUOTE] = ACTIONS(2849),
    [anon_sym_U_SQUOTE] = ACTIONS(2849),
    [anon_sym_u8_SQUOTE] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [anon_sym_NULL] = ACTIONS(2847),
    [anon_sym_nullptr] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2847),
    [anon_sym_decltype] = ACTIONS(2847),
    [anon_sym_explicit] = ACTIONS(2847),
    [anon_sym_typename] = ACTIONS(2847),
    [anon_sym_template] = ACTIONS(2847),
    [anon_sym_operator] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_delete] = ACTIONS(2847),
    [anon_sym_throw] = ACTIONS(2847),
    [anon_sym_namespace] = ACTIONS(2847),
    [anon_sym_static_assert] = ACTIONS(2847),
    [anon_sym_concept] = ACTIONS(2847),
    [anon_sym_co_return] = ACTIONS(2847),
    [anon_sym_co_yield] = ACTIONS(2847),
    [anon_sym_R_DQUOTE] = ACTIONS(2849),
    [anon_sym_LR_DQUOTE] = ACTIONS(2849),
    [anon_sym_uR_DQUOTE] = ACTIONS(2849),
    [anon_sym_UR_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2849),
    [anon_sym_co_await] = ACTIONS(2847),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_requires] = ACTIONS(2847),
    [sym_this] = ACTIONS(2847),
  },
  [309] = {
    [sym_identifier] = ACTIONS(2851),
    [aux_sym_preproc_include_token1] = ACTIONS(2851),
    [aux_sym_preproc_def_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token2] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2851),
    [aux_sym_preproc_else_token1] = ACTIONS(2851),
    [aux_sym_preproc_elif_token1] = ACTIONS(2851),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2851),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2851),
    [sym_preproc_directive] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2853),
    [anon_sym_BANG] = ACTIONS(2853),
    [anon_sym_TILDE] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_STAR] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym___extension__] = ACTIONS(2851),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_virtual] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(2851),
    [anon_sym___attribute__] = ACTIONS(2851),
    [anon_sym___attribute] = ACTIONS(2851),
    [anon_sym_using] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2853),
    [anon_sym___declspec] = ACTIONS(2851),
    [anon_sym___based] = ACTIONS(2851),
    [anon_sym___cdecl] = ACTIONS(2851),
    [anon_sym___clrcall] = ACTIONS(2851),
    [anon_sym___stdcall] = ACTIONS(2851),
    [anon_sym___fastcall] = ACTIONS(2851),
    [anon_sym___thiscall] = ACTIONS(2851),
    [anon_sym___vectorcall] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_signed] = ACTIONS(2851),
    [anon_sym_unsigned] = ACTIONS(2851),
    [anon_sym_long] = ACTIONS(2851),
    [anon_sym_short] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_static] = ACTIONS(2851),
    [anon_sym_register] = ACTIONS(2851),
    [anon_sym_inline] = ACTIONS(2851),
    [anon_sym___inline] = ACTIONS(2851),
    [anon_sym___inline__] = ACTIONS(2851),
    [anon_sym___forceinline] = ACTIONS(2851),
    [anon_sym_thread_local] = ACTIONS(2851),
    [anon_sym___thread] = ACTIONS(2851),
    [anon_sym_const] = ACTIONS(2851),
    [anon_sym_constexpr] = ACTIONS(2851),
    [anon_sym_volatile] = ACTIONS(2851),
    [anon_sym_restrict] = ACTIONS(2851),
    [anon_sym___restrict__] = ACTIONS(2851),
    [anon_sym__Atomic] = ACTIONS(2851),
    [anon_sym__Noreturn] = ACTIONS(2851),
    [anon_sym_noreturn] = ACTIONS(2851),
    [anon_sym__Nonnull] = ACTIONS(2851),
    [anon_sym_mutable] = ACTIONS(2851),
    [anon_sym_constinit] = ACTIONS(2851),
    [anon_sym_consteval] = ACTIONS(2851),
    [anon_sym_alignas] = ACTIONS(2851),
    [anon_sym__Alignas] = ACTIONS(2851),
    [sym_primitive_type] = ACTIONS(2851),
    [anon_sym_enum] = ACTIONS(2851),
    [anon_sym_class] = ACTIONS(2851),
    [anon_sym_struct] = ACTIONS(2851),
    [anon_sym_union] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_switch] = ACTIONS(2851),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_break] = ACTIONS(2851),
    [anon_sym_continue] = ACTIONS(2851),
    [anon_sym_goto] = ACTIONS(2851),
    [anon_sym___try] = ACTIONS(2851),
    [anon_sym___leave] = ACTIONS(2851),
    [anon_sym_not] = ACTIONS(2851),
    [anon_sym_compl] = ACTIONS(2851),
    [anon_sym_DASH_DASH] = ACTIONS(2853),
    [anon_sym_PLUS_PLUS] = ACTIONS(2853),
    [anon_sym_sizeof] = ACTIONS(2851),
    [anon_sym___alignof__] = ACTIONS(2851),
    [anon_sym___alignof] = ACTIONS(2851),
    [anon_sym__alignof] = ACTIONS(2851),
    [anon_sym_alignof] = ACTIONS(2851),
    [anon_sym__Alignof] = ACTIONS(2851),
    [anon_sym_offsetof] = ACTIONS(2851),
    [anon_sym__Generic] = ACTIONS(2851),
    [anon_sym_asm] = ACTIONS(2851),
    [anon_sym___asm__] = ACTIONS(2851),
    [anon_sym___asm] = ACTIONS(2851),
    [sym_number_literal] = ACTIONS(2853),
    [anon_sym_L_SQUOTE] = ACTIONS(2853),
    [anon_sym_u_SQUOTE] = ACTIONS(2853),
    [anon_sym_U_SQUOTE] = ACTIONS(2853),
    [anon_sym_u8_SQUOTE] = ACTIONS(2853),
    [anon_sym_SQUOTE] = ACTIONS(2853),
    [anon_sym_L_DQUOTE] = ACTIONS(2853),
    [anon_sym_u_DQUOTE] = ACTIONS(2853),
    [anon_sym_U_DQUOTE] = ACTIONS(2853),
    [anon_sym_u8_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE] = ACTIONS(2853),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2851),
    [anon_sym_nullptr] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2851),
    [anon_sym_decltype] = ACTIONS(2851),
    [anon_sym_explicit] = ACTIONS(2851),
    [anon_sym_typename] = ACTIONS(2851),
    [anon_sym_template] = ACTIONS(2851),
    [anon_sym_operator] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_delete] = ACTIONS(2851),
    [anon_sym_throw] = ACTIONS(2851),
    [anon_sym_namespace] = ACTIONS(2851),
    [anon_sym_static_assert] = ACTIONS(2851),
    [anon_sym_concept] = ACTIONS(2851),
    [anon_sym_co_return] = ACTIONS(2851),
    [anon_sym_co_yield] = ACTIONS(2851),
    [anon_sym_R_DQUOTE] = ACTIONS(2853),
    [anon_sym_LR_DQUOTE] = ACTIONS(2853),
    [anon_sym_uR_DQUOTE] = ACTIONS(2853),
    [anon_sym_UR_DQUOTE] = ACTIONS(2853),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2853),
    [anon_sym_co_await] = ACTIONS(2851),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_requires] = ACTIONS(2851),
    [sym_this] = ACTIONS(2851),
  },
  [310] = {
    [sym_identifier] = ACTIONS(2855),
    [aux_sym_preproc_include_token1] = ACTIONS(2855),
    [aux_sym_preproc_def_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token2] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2855),
    [aux_sym_preproc_else_token1] = ACTIONS(2855),
    [aux_sym_preproc_elif_token1] = ACTIONS(2855),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2855),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2855),
    [sym_preproc_directive] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(2857),
    [anon_sym_TILDE] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym___extension__] = ACTIONS(2855),
    [anon_sym_typedef] = ACTIONS(2855),
    [anon_sym_virtual] = ACTIONS(2855),
    [anon_sym_extern] = ACTIONS(2855),
    [anon_sym___attribute__] = ACTIONS(2855),
    [anon_sym___attribute] = ACTIONS(2855),
    [anon_sym_using] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2857),
    [anon_sym___declspec] = ACTIONS(2855),
    [anon_sym___based] = ACTIONS(2855),
    [anon_sym___cdecl] = ACTIONS(2855),
    [anon_sym___clrcall] = ACTIONS(2855),
    [anon_sym___stdcall] = ACTIONS(2855),
    [anon_sym___fastcall] = ACTIONS(2855),
    [anon_sym___thiscall] = ACTIONS(2855),
    [anon_sym___vectorcall] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_signed] = ACTIONS(2855),
    [anon_sym_unsigned] = ACTIONS(2855),
    [anon_sym_long] = ACTIONS(2855),
    [anon_sym_short] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(2855),
    [anon_sym_register] = ACTIONS(2855),
    [anon_sym_inline] = ACTIONS(2855),
    [anon_sym___inline] = ACTIONS(2855),
    [anon_sym___inline__] = ACTIONS(2855),
    [anon_sym___forceinline] = ACTIONS(2855),
    [anon_sym_thread_local] = ACTIONS(2855),
    [anon_sym___thread] = ACTIONS(2855),
    [anon_sym_const] = ACTIONS(2855),
    [anon_sym_constexpr] = ACTIONS(2855),
    [anon_sym_volatile] = ACTIONS(2855),
    [anon_sym_restrict] = ACTIONS(2855),
    [anon_sym___restrict__] = ACTIONS(2855),
    [anon_sym__Atomic] = ACTIONS(2855),
    [anon_sym__Noreturn] = ACTIONS(2855),
    [anon_sym_noreturn] = ACTIONS(2855),
    [anon_sym__Nonnull] = ACTIONS(2855),
    [anon_sym_mutable] = ACTIONS(2855),
    [anon_sym_constinit] = ACTIONS(2855),
    [anon_sym_consteval] = ACTIONS(2855),
    [anon_sym_alignas] = ACTIONS(2855),
    [anon_sym__Alignas] = ACTIONS(2855),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_enum] = ACTIONS(2855),
    [anon_sym_class] = ACTIONS(2855),
    [anon_sym_struct] = ACTIONS(2855),
    [anon_sym_union] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_case] = ACTIONS(2855),
    [anon_sym_default] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_break] = ACTIONS(2855),
    [anon_sym_continue] = ACTIONS(2855),
    [anon_sym_goto] = ACTIONS(2855),
    [anon_sym___try] = ACTIONS(2855),
    [anon_sym___leave] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2855),
    [anon_sym_compl] = ACTIONS(2855),
    [anon_sym_DASH_DASH] = ACTIONS(2857),
    [anon_sym_PLUS_PLUS] = ACTIONS(2857),
    [anon_sym_sizeof] = ACTIONS(2855),
    [anon_sym___alignof__] = ACTIONS(2855),
    [anon_sym___alignof] = ACTIONS(2855),
    [anon_sym__alignof] = ACTIONS(2855),
    [anon_sym_alignof] = ACTIONS(2855),
    [anon_sym__Alignof] = ACTIONS(2855),
    [anon_sym_offsetof] = ACTIONS(2855),
    [anon_sym__Generic] = ACTIONS(2855),
    [anon_sym_asm] = ACTIONS(2855),
    [anon_sym___asm__] = ACTIONS(2855),
    [anon_sym___asm] = ACTIONS(2855),
    [sym_number_literal] = ACTIONS(2857),
    [anon_sym_L_SQUOTE] = ACTIONS(2857),
    [anon_sym_u_SQUOTE] = ACTIONS(2857),
    [anon_sym_U_SQUOTE] = ACTIONS(2857),
    [anon_sym_u8_SQUOTE] = ACTIONS(2857),
    [anon_sym_SQUOTE] = ACTIONS(2857),
    [anon_sym_L_DQUOTE] = ACTIONS(2857),
    [anon_sym_u_DQUOTE] = ACTIONS(2857),
    [anon_sym_U_DQUOTE] = ACTIONS(2857),
    [anon_sym_u8_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [sym_true] = ACTIONS(2855),
    [sym_false] = ACTIONS(2855),
    [anon_sym_NULL] = ACTIONS(2855),
    [anon_sym_nullptr] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2855),
    [anon_sym_explicit] = ACTIONS(2855),
    [anon_sym_typename] = ACTIONS(2855),
    [anon_sym_template] = ACTIONS(2855),
    [anon_sym_operator] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_delete] = ACTIONS(2855),
    [anon_sym_throw] = ACTIONS(2855),
    [anon_sym_namespace] = ACTIONS(2855),
    [anon_sym_static_assert] = ACTIONS(2855),
    [anon_sym_concept] = ACTIONS(2855),
    [anon_sym_co_return] = ACTIONS(2855),
    [anon_sym_co_yield] = ACTIONS(2855),
    [anon_sym_R_DQUOTE] = ACTIONS(2857),
    [anon_sym_LR_DQUOTE] = ACTIONS(2857),
    [anon_sym_uR_DQUOTE] = ACTIONS(2857),
    [anon_sym_UR_DQUOTE] = ACTIONS(2857),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2857),
    [anon_sym_co_await] = ACTIONS(2855),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_requires] = ACTIONS(2855),
    [sym_this] = ACTIONS(2855),
  },
  [311] = {
    [sym_identifier] = ACTIONS(2859),
    [aux_sym_preproc_include_token1] = ACTIONS(2859),
    [aux_sym_preproc_def_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token2] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2859),
    [aux_sym_preproc_else_token1] = ACTIONS(2859),
    [aux_sym_preproc_elif_token1] = ACTIONS(2859),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2859),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2859),
    [sym_preproc_directive] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym___extension__] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2859),
    [anon_sym_virtual] = ACTIONS(2859),
    [anon_sym_extern] = ACTIONS(2859),
    [anon_sym___attribute__] = ACTIONS(2859),
    [anon_sym___attribute] = ACTIONS(2859),
    [anon_sym_using] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2861),
    [anon_sym___declspec] = ACTIONS(2859),
    [anon_sym___based] = ACTIONS(2859),
    [anon_sym___cdecl] = ACTIONS(2859),
    [anon_sym___clrcall] = ACTIONS(2859),
    [anon_sym___stdcall] = ACTIONS(2859),
    [anon_sym___fastcall] = ACTIONS(2859),
    [anon_sym___thiscall] = ACTIONS(2859),
    [anon_sym___vectorcall] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_signed] = ACTIONS(2859),
    [anon_sym_unsigned] = ACTIONS(2859),
    [anon_sym_long] = ACTIONS(2859),
    [anon_sym_short] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2859),
    [anon_sym_register] = ACTIONS(2859),
    [anon_sym_inline] = ACTIONS(2859),
    [anon_sym___inline] = ACTIONS(2859),
    [anon_sym___inline__] = ACTIONS(2859),
    [anon_sym___forceinline] = ACTIONS(2859),
    [anon_sym_thread_local] = ACTIONS(2859),
    [anon_sym___thread] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2859),
    [anon_sym_constexpr] = ACTIONS(2859),
    [anon_sym_volatile] = ACTIONS(2859),
    [anon_sym_restrict] = ACTIONS(2859),
    [anon_sym___restrict__] = ACTIONS(2859),
    [anon_sym__Atomic] = ACTIONS(2859),
    [anon_sym__Noreturn] = ACTIONS(2859),
    [anon_sym_noreturn] = ACTIONS(2859),
    [anon_sym__Nonnull] = ACTIONS(2859),
    [anon_sym_mutable] = ACTIONS(2859),
    [anon_sym_constinit] = ACTIONS(2859),
    [anon_sym_consteval] = ACTIONS(2859),
    [anon_sym_alignas] = ACTIONS(2859),
    [anon_sym__Alignas] = ACTIONS(2859),
    [sym_primitive_type] = ACTIONS(2859),
    [anon_sym_enum] = ACTIONS(2859),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2859),
    [anon_sym_union] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_switch] = ACTIONS(2859),
    [anon_sym_case] = ACTIONS(2859),
    [anon_sym_default] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_break] = ACTIONS(2859),
    [anon_sym_continue] = ACTIONS(2859),
    [anon_sym_goto] = ACTIONS(2859),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(2859),
    [anon_sym_not] = ACTIONS(2859),
    [anon_sym_compl] = ACTIONS(2859),
    [anon_sym_DASH_DASH] = ACTIONS(2861),
    [anon_sym_PLUS_PLUS] = ACTIONS(2861),
    [anon_sym_sizeof] = ACTIONS(2859),
    [anon_sym___alignof__] = ACTIONS(2859),
    [anon_sym___alignof] = ACTIONS(2859),
    [anon_sym__alignof] = ACTIONS(2859),
    [anon_sym_alignof] = ACTIONS(2859),
    [anon_sym__Alignof] = ACTIONS(2859),
    [anon_sym_offsetof] = ACTIONS(2859),
    [anon_sym__Generic] = ACTIONS(2859),
    [anon_sym_asm] = ACTIONS(2859),
    [anon_sym___asm__] = ACTIONS(2859),
    [anon_sym___asm] = ACTIONS(2859),
    [sym_number_literal] = ACTIONS(2861),
    [anon_sym_L_SQUOTE] = ACTIONS(2861),
    [anon_sym_u_SQUOTE] = ACTIONS(2861),
    [anon_sym_U_SQUOTE] = ACTIONS(2861),
    [anon_sym_u8_SQUOTE] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2861),
    [anon_sym_L_DQUOTE] = ACTIONS(2861),
    [anon_sym_u_DQUOTE] = ACTIONS(2861),
    [anon_sym_U_DQUOTE] = ACTIONS(2861),
    [anon_sym_u8_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE] = ACTIONS(2861),
    [sym_true] = ACTIONS(2859),
    [sym_false] = ACTIONS(2859),
    [anon_sym_NULL] = ACTIONS(2859),
    [anon_sym_nullptr] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2859),
    [anon_sym_decltype] = ACTIONS(2859),
    [anon_sym_explicit] = ACTIONS(2859),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(2859),
    [anon_sym_operator] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_delete] = ACTIONS(2859),
    [anon_sym_throw] = ACTIONS(2859),
    [anon_sym_namespace] = ACTIONS(2859),
    [anon_sym_static_assert] = ACTIONS(2859),
    [anon_sym_concept] = ACTIONS(2859),
    [anon_sym_co_return] = ACTIONS(2859),
    [anon_sym_co_yield] = ACTIONS(2859),
    [anon_sym_R_DQUOTE] = ACTIONS(2861),
    [anon_sym_LR_DQUOTE] = ACTIONS(2861),
    [anon_sym_uR_DQUOTE] = ACTIONS(2861),
    [anon_sym_UR_DQUOTE] = ACTIONS(2861),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2861),
    [anon_sym_co_await] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_requires] = ACTIONS(2859),
    [sym_this] = ACTIONS(2859),
  },
  [312] = {
    [sym_identifier] = ACTIONS(2863),
    [aux_sym_preproc_include_token1] = ACTIONS(2863),
    [aux_sym_preproc_def_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token2] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2863),
    [aux_sym_preproc_else_token1] = ACTIONS(2863),
    [aux_sym_preproc_elif_token1] = ACTIONS(2863),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2863),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2863),
    [sym_preproc_directive] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym___extension__] = ACTIONS(2863),
    [anon_sym_typedef] = ACTIONS(2863),
    [anon_sym_virtual] = ACTIONS(2863),
    [anon_sym_extern] = ACTIONS(2863),
    [anon_sym___attribute__] = ACTIONS(2863),
    [anon_sym___attribute] = ACTIONS(2863),
    [anon_sym_using] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2865),
    [anon_sym___declspec] = ACTIONS(2863),
    [anon_sym___based] = ACTIONS(2863),
    [anon_sym___cdecl] = ACTIONS(2863),
    [anon_sym___clrcall] = ACTIONS(2863),
    [anon_sym___stdcall] = ACTIONS(2863),
    [anon_sym___fastcall] = ACTIONS(2863),
    [anon_sym___thiscall] = ACTIONS(2863),
    [anon_sym___vectorcall] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_signed] = ACTIONS(2863),
    [anon_sym_unsigned] = ACTIONS(2863),
    [anon_sym_long] = ACTIONS(2863),
    [anon_sym_short] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_static] = ACTIONS(2863),
    [anon_sym_register] = ACTIONS(2863),
    [anon_sym_inline] = ACTIONS(2863),
    [anon_sym___inline] = ACTIONS(2863),
    [anon_sym___inline__] = ACTIONS(2863),
    [anon_sym___forceinline] = ACTIONS(2863),
    [anon_sym_thread_local] = ACTIONS(2863),
    [anon_sym___thread] = ACTIONS(2863),
    [anon_sym_const] = ACTIONS(2863),
    [anon_sym_constexpr] = ACTIONS(2863),
    [anon_sym_volatile] = ACTIONS(2863),
    [anon_sym_restrict] = ACTIONS(2863),
    [anon_sym___restrict__] = ACTIONS(2863),
    [anon_sym__Atomic] = ACTIONS(2863),
    [anon_sym__Noreturn] = ACTIONS(2863),
    [anon_sym_noreturn] = ACTIONS(2863),
    [anon_sym__Nonnull] = ACTIONS(2863),
    [anon_sym_mutable] = ACTIONS(2863),
    [anon_sym_constinit] = ACTIONS(2863),
    [anon_sym_consteval] = ACTIONS(2863),
    [anon_sym_alignas] = ACTIONS(2863),
    [anon_sym__Alignas] = ACTIONS(2863),
    [sym_primitive_type] = ACTIONS(2863),
    [anon_sym_enum] = ACTIONS(2863),
    [anon_sym_class] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2863),
    [anon_sym_union] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_switch] = ACTIONS(2863),
    [anon_sym_case] = ACTIONS(2863),
    [anon_sym_default] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_break] = ACTIONS(2863),
    [anon_sym_continue] = ACTIONS(2863),
    [anon_sym_goto] = ACTIONS(2863),
    [anon_sym___try] = ACTIONS(2863),
    [anon_sym___leave] = ACTIONS(2863),
    [anon_sym_not] = ACTIONS(2863),
    [anon_sym_compl] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_sizeof] = ACTIONS(2863),
    [anon_sym___alignof__] = ACTIONS(2863),
    [anon_sym___alignof] = ACTIONS(2863),
    [anon_sym__alignof] = ACTIONS(2863),
    [anon_sym_alignof] = ACTIONS(2863),
    [anon_sym__Alignof] = ACTIONS(2863),
    [anon_sym_offsetof] = ACTIONS(2863),
    [anon_sym__Generic] = ACTIONS(2863),
    [anon_sym_asm] = ACTIONS(2863),
    [anon_sym___asm__] = ACTIONS(2863),
    [anon_sym___asm] = ACTIONS(2863),
    [sym_number_literal] = ACTIONS(2865),
    [anon_sym_L_SQUOTE] = ACTIONS(2865),
    [anon_sym_u_SQUOTE] = ACTIONS(2865),
    [anon_sym_U_SQUOTE] = ACTIONS(2865),
    [anon_sym_u8_SQUOTE] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_L_DQUOTE] = ACTIONS(2865),
    [anon_sym_u_DQUOTE] = ACTIONS(2865),
    [anon_sym_U_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [sym_true] = ACTIONS(2863),
    [sym_false] = ACTIONS(2863),
    [anon_sym_NULL] = ACTIONS(2863),
    [anon_sym_nullptr] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2863),
    [anon_sym_decltype] = ACTIONS(2863),
    [anon_sym_explicit] = ACTIONS(2863),
    [anon_sym_typename] = ACTIONS(2863),
    [anon_sym_template] = ACTIONS(2863),
    [anon_sym_operator] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_throw] = ACTIONS(2863),
    [anon_sym_namespace] = ACTIONS(2863),
    [anon_sym_static_assert] = ACTIONS(2863),
    [anon_sym_concept] = ACTIONS(2863),
    [anon_sym_co_return] = ACTIONS(2863),
    [anon_sym_co_yield] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2863),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_requires] = ACTIONS(2863),
    [sym_this] = ACTIONS(2863),
  },
  [313] = {
    [sym_identifier] = ACTIONS(2867),
    [aux_sym_preproc_include_token1] = ACTIONS(2867),
    [aux_sym_preproc_def_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token2] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2867),
    [aux_sym_preproc_else_token1] = ACTIONS(2867),
    [aux_sym_preproc_elif_token1] = ACTIONS(2867),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2867),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2867),
    [sym_preproc_directive] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2869),
    [anon_sym_BANG] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2869),
    [anon_sym___extension__] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2867),
    [anon_sym_virtual] = ACTIONS(2867),
    [anon_sym_extern] = ACTIONS(2867),
    [anon_sym___attribute__] = ACTIONS(2867),
    [anon_sym___attribute] = ACTIONS(2867),
    [anon_sym_using] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2869),
    [anon_sym___declspec] = ACTIONS(2867),
    [anon_sym___based] = ACTIONS(2867),
    [anon_sym___cdecl] = ACTIONS(2867),
    [anon_sym___clrcall] = ACTIONS(2867),
    [anon_sym___stdcall] = ACTIONS(2867),
    [anon_sym___fastcall] = ACTIONS(2867),
    [anon_sym___thiscall] = ACTIONS(2867),
    [anon_sym___vectorcall] = ACTIONS(2867),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_signed] = ACTIONS(2867),
    [anon_sym_unsigned] = ACTIONS(2867),
    [anon_sym_long] = ACTIONS(2867),
    [anon_sym_short] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2867),
    [anon_sym_register] = ACTIONS(2867),
    [anon_sym_inline] = ACTIONS(2867),
    [anon_sym___inline] = ACTIONS(2867),
    [anon_sym___inline__] = ACTIONS(2867),
    [anon_sym___forceinline] = ACTIONS(2867),
    [anon_sym_thread_local] = ACTIONS(2867),
    [anon_sym___thread] = ACTIONS(2867),
    [anon_sym_const] = ACTIONS(2867),
    [anon_sym_constexpr] = ACTIONS(2867),
    [anon_sym_volatile] = ACTIONS(2867),
    [anon_sym_restrict] = ACTIONS(2867),
    [anon_sym___restrict__] = ACTIONS(2867),
    [anon_sym__Atomic] = ACTIONS(2867),
    [anon_sym__Noreturn] = ACTIONS(2867),
    [anon_sym_noreturn] = ACTIONS(2867),
    [anon_sym__Nonnull] = ACTIONS(2867),
    [anon_sym_mutable] = ACTIONS(2867),
    [anon_sym_constinit] = ACTIONS(2867),
    [anon_sym_consteval] = ACTIONS(2867),
    [anon_sym_alignas] = ACTIONS(2867),
    [anon_sym__Alignas] = ACTIONS(2867),
    [sym_primitive_type] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2867),
    [anon_sym_class] = ACTIONS(2867),
    [anon_sym_struct] = ACTIONS(2867),
    [anon_sym_union] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_switch] = ACTIONS(2867),
    [anon_sym_case] = ACTIONS(2867),
    [anon_sym_default] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_continue] = ACTIONS(2867),
    [anon_sym_goto] = ACTIONS(2867),
    [anon_sym___try] = ACTIONS(2867),
    [anon_sym___leave] = ACTIONS(2867),
    [anon_sym_not] = ACTIONS(2867),
    [anon_sym_compl] = ACTIONS(2867),
    [anon_sym_DASH_DASH] = ACTIONS(2869),
    [anon_sym_PLUS_PLUS] = ACTIONS(2869),
    [anon_sym_sizeof] = ACTIONS(2867),
    [anon_sym___alignof__] = ACTIONS(2867),
    [anon_sym___alignof] = ACTIONS(2867),
    [anon_sym__alignof] = ACTIONS(2867),
    [anon_sym_alignof] = ACTIONS(2867),
    [anon_sym__Alignof] = ACTIONS(2867),
    [anon_sym_offsetof] = ACTIONS(2867),
    [anon_sym__Generic] = ACTIONS(2867),
    [anon_sym_asm] = ACTIONS(2867),
    [anon_sym___asm__] = ACTIONS(2867),
    [anon_sym___asm] = ACTIONS(2867),
    [sym_number_literal] = ACTIONS(2869),
    [anon_sym_L_SQUOTE] = ACTIONS(2869),
    [anon_sym_u_SQUOTE] = ACTIONS(2869),
    [anon_sym_U_SQUOTE] = ACTIONS(2869),
    [anon_sym_u8_SQUOTE] = ACTIONS(2869),
    [anon_sym_SQUOTE] = ACTIONS(2869),
    [anon_sym_L_DQUOTE] = ACTIONS(2869),
    [anon_sym_u_DQUOTE] = ACTIONS(2869),
    [anon_sym_U_DQUOTE] = ACTIONS(2869),
    [anon_sym_u8_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [sym_true] = ACTIONS(2867),
    [sym_false] = ACTIONS(2867),
    [anon_sym_NULL] = ACTIONS(2867),
    [anon_sym_nullptr] = ACTIONS(2867),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2867),
    [anon_sym_decltype] = ACTIONS(2867),
    [anon_sym_explicit] = ACTIONS(2867),
    [anon_sym_typename] = ACTIONS(2867),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_delete] = ACTIONS(2867),
    [anon_sym_throw] = ACTIONS(2867),
    [anon_sym_namespace] = ACTIONS(2867),
    [anon_sym_static_assert] = ACTIONS(2867),
    [anon_sym_concept] = ACTIONS(2867),
    [anon_sym_co_return] = ACTIONS(2867),
    [anon_sym_co_yield] = ACTIONS(2867),
    [anon_sym_R_DQUOTE] = ACTIONS(2869),
    [anon_sym_LR_DQUOTE] = ACTIONS(2869),
    [anon_sym_uR_DQUOTE] = ACTIONS(2869),
    [anon_sym_UR_DQUOTE] = ACTIONS(2869),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2869),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_requires] = ACTIONS(2867),
    [sym_this] = ACTIONS(2867),
  },
  [314] = {
    [sym_identifier] = ACTIONS(2871),
    [aux_sym_preproc_include_token1] = ACTIONS(2871),
    [aux_sym_preproc_def_token1] = ACTIONS(2871),
    [aux_sym_preproc_if_token1] = ACTIONS(2871),
    [aux_sym_preproc_if_token2] = ACTIONS(2871),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2871),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2871),
    [aux_sym_preproc_else_token1] = ACTIONS(2871),
    [aux_sym_preproc_elif_token1] = ACTIONS(2871),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2871),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2871),
    [sym_preproc_directive] = ACTIONS(2871),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym___extension__] = ACTIONS(2871),
    [anon_sym_typedef] = ACTIONS(2871),
    [anon_sym_virtual] = ACTIONS(2871),
    [anon_sym_extern] = ACTIONS(2871),
    [anon_sym___attribute__] = ACTIONS(2871),
    [anon_sym___attribute] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2873),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2873),
    [anon_sym___declspec] = ACTIONS(2871),
    [anon_sym___based] = ACTIONS(2871),
    [anon_sym___cdecl] = ACTIONS(2871),
    [anon_sym___clrcall] = ACTIONS(2871),
    [anon_sym___stdcall] = ACTIONS(2871),
    [anon_sym___fastcall] = ACTIONS(2871),
    [anon_sym___thiscall] = ACTIONS(2871),
    [anon_sym___vectorcall] = ACTIONS(2871),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_signed] = ACTIONS(2871),
    [anon_sym_unsigned] = ACTIONS(2871),
    [anon_sym_long] = ACTIONS(2871),
    [anon_sym_short] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_static] = ACTIONS(2871),
    [anon_sym_register] = ACTIONS(2871),
    [anon_sym_inline] = ACTIONS(2871),
    [anon_sym___inline] = ACTIONS(2871),
    [anon_sym___inline__] = ACTIONS(2871),
    [anon_sym___forceinline] = ACTIONS(2871),
    [anon_sym_thread_local] = ACTIONS(2871),
    [anon_sym___thread] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_constexpr] = ACTIONS(2871),
    [anon_sym_volatile] = ACTIONS(2871),
    [anon_sym_restrict] = ACTIONS(2871),
    [anon_sym___restrict__] = ACTIONS(2871),
    [anon_sym__Atomic] = ACTIONS(2871),
    [anon_sym__Noreturn] = ACTIONS(2871),
    [anon_sym_noreturn] = ACTIONS(2871),
    [anon_sym__Nonnull] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_constinit] = ACTIONS(2871),
    [anon_sym_consteval] = ACTIONS(2871),
    [anon_sym_alignas] = ACTIONS(2871),
    [anon_sym__Alignas] = ACTIONS(2871),
    [sym_primitive_type] = ACTIONS(2871),
    [anon_sym_enum] = ACTIONS(2871),
    [anon_sym_class] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_union] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_switch] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(2871),
    [anon_sym_default] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [anon_sym_do] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_break] = ACTIONS(2871),
    [anon_sym_continue] = ACTIONS(2871),
    [anon_sym_goto] = ACTIONS(2871),
    [anon_sym___try] = ACTIONS(2871),
    [anon_sym___leave] = ACTIONS(2871),
    [anon_sym_not] = ACTIONS(2871),
    [anon_sym_compl] = ACTIONS(2871),
    [anon_sym_DASH_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2873),
    [anon_sym_sizeof] = ACTIONS(2871),
    [anon_sym___alignof__] = ACTIONS(2871),
    [anon_sym___alignof] = ACTIONS(2871),
    [anon_sym__alignof] = ACTIONS(2871),
    [anon_sym_alignof] = ACTIONS(2871),
    [anon_sym__Alignof] = ACTIONS(2871),
    [anon_sym_offsetof] = ACTIONS(2871),
    [anon_sym__Generic] = ACTIONS(2871),
    [anon_sym_asm] = ACTIONS(2871),
    [anon_sym___asm__] = ACTIONS(2871),
    [anon_sym___asm] = ACTIONS(2871),
    [sym_number_literal] = ACTIONS(2873),
    [anon_sym_L_SQUOTE] = ACTIONS(2873),
    [anon_sym_u_SQUOTE] = ACTIONS(2873),
    [anon_sym_U_SQUOTE] = ACTIONS(2873),
    [anon_sym_u8_SQUOTE] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_L_DQUOTE] = ACTIONS(2873),
    [anon_sym_u_DQUOTE] = ACTIONS(2873),
    [anon_sym_U_DQUOTE] = ACTIONS(2873),
    [anon_sym_u8_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [sym_true] = ACTIONS(2871),
    [sym_false] = ACTIONS(2871),
    [anon_sym_NULL] = ACTIONS(2871),
    [anon_sym_nullptr] = ACTIONS(2871),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2871),
    [anon_sym_decltype] = ACTIONS(2871),
    [anon_sym_explicit] = ACTIONS(2871),
    [anon_sym_typename] = ACTIONS(2871),
    [anon_sym_template] = ACTIONS(2871),
    [anon_sym_operator] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_delete] = ACTIONS(2871),
    [anon_sym_throw] = ACTIONS(2871),
    [anon_sym_namespace] = ACTIONS(2871),
    [anon_sym_static_assert] = ACTIONS(2871),
    [anon_sym_concept] = ACTIONS(2871),
    [anon_sym_co_return] = ACTIONS(2871),
    [anon_sym_co_yield] = ACTIONS(2871),
    [anon_sym_R_DQUOTE] = ACTIONS(2873),
    [anon_sym_LR_DQUOTE] = ACTIONS(2873),
    [anon_sym_uR_DQUOTE] = ACTIONS(2873),
    [anon_sym_UR_DQUOTE] = ACTIONS(2873),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2873),
    [anon_sym_co_await] = ACTIONS(2871),
    [anon_sym_new] = ACTIONS(2871),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2871),
  },
  [315] = {
    [sym_identifier] = ACTIONS(2875),
    [aux_sym_preproc_include_token1] = ACTIONS(2875),
    [aux_sym_preproc_def_token1] = ACTIONS(2875),
    [aux_sym_preproc_if_token1] = ACTIONS(2875),
    [aux_sym_preproc_if_token2] = ACTIONS(2875),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2875),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2875),
    [aux_sym_preproc_else_token1] = ACTIONS(2875),
    [aux_sym_preproc_elif_token1] = ACTIONS(2875),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2875),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2875),
    [sym_preproc_directive] = ACTIONS(2875),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2875),
    [anon_sym_typedef] = ACTIONS(2875),
    [anon_sym_virtual] = ACTIONS(2875),
    [anon_sym_extern] = ACTIONS(2875),
    [anon_sym___attribute__] = ACTIONS(2875),
    [anon_sym___attribute] = ACTIONS(2875),
    [anon_sym_using] = ACTIONS(2875),
    [anon_sym_COLON_COLON] = ACTIONS(2877),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2877),
    [anon_sym___declspec] = ACTIONS(2875),
    [anon_sym___based] = ACTIONS(2875),
    [anon_sym___cdecl] = ACTIONS(2875),
    [anon_sym___clrcall] = ACTIONS(2875),
    [anon_sym___stdcall] = ACTIONS(2875),
    [anon_sym___fastcall] = ACTIONS(2875),
    [anon_sym___thiscall] = ACTIONS(2875),
    [anon_sym___vectorcall] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_signed] = ACTIONS(2875),
    [anon_sym_unsigned] = ACTIONS(2875),
    [anon_sym_long] = ACTIONS(2875),
    [anon_sym_short] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_static] = ACTIONS(2875),
    [anon_sym_register] = ACTIONS(2875),
    [anon_sym_inline] = ACTIONS(2875),
    [anon_sym___inline] = ACTIONS(2875),
    [anon_sym___inline__] = ACTIONS(2875),
    [anon_sym___forceinline] = ACTIONS(2875),
    [anon_sym_thread_local] = ACTIONS(2875),
    [anon_sym___thread] = ACTIONS(2875),
    [anon_sym_const] = ACTIONS(2875),
    [anon_sym_constexpr] = ACTIONS(2875),
    [anon_sym_volatile] = ACTIONS(2875),
    [anon_sym_restrict] = ACTIONS(2875),
    [anon_sym___restrict__] = ACTIONS(2875),
    [anon_sym__Atomic] = ACTIONS(2875),
    [anon_sym__Noreturn] = ACTIONS(2875),
    [anon_sym_noreturn] = ACTIONS(2875),
    [anon_sym__Nonnull] = ACTIONS(2875),
    [anon_sym_mutable] = ACTIONS(2875),
    [anon_sym_constinit] = ACTIONS(2875),
    [anon_sym_consteval] = ACTIONS(2875),
    [anon_sym_alignas] = ACTIONS(2875),
    [anon_sym__Alignas] = ACTIONS(2875),
    [sym_primitive_type] = ACTIONS(2875),
    [anon_sym_enum] = ACTIONS(2875),
    [anon_sym_class] = ACTIONS(2875),
    [anon_sym_struct] = ACTIONS(2875),
    [anon_sym_union] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_switch] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_default] = ACTIONS(2875),
    [anon_sym_while] = ACTIONS(2875),
    [anon_sym_do] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2875),
    [anon_sym_return] = ACTIONS(2875),
    [anon_sym_break] = ACTIONS(2875),
    [anon_sym_continue] = ACTIONS(2875),
    [anon_sym_goto] = ACTIONS(2875),
    [anon_sym___try] = ACTIONS(2875),
    [anon_sym___leave] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2875),
    [anon_sym_compl] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_sizeof] = ACTIONS(2875),
    [anon_sym___alignof__] = ACTIONS(2875),
    [anon_sym___alignof] = ACTIONS(2875),
    [anon_sym__alignof] = ACTIONS(2875),
    [anon_sym_alignof] = ACTIONS(2875),
    [anon_sym__Alignof] = ACTIONS(2875),
    [anon_sym_offsetof] = ACTIONS(2875),
    [anon_sym__Generic] = ACTIONS(2875),
    [anon_sym_asm] = ACTIONS(2875),
    [anon_sym___asm__] = ACTIONS(2875),
    [anon_sym___asm] = ACTIONS(2875),
    [sym_number_literal] = ACTIONS(2877),
    [anon_sym_L_SQUOTE] = ACTIONS(2877),
    [anon_sym_u_SQUOTE] = ACTIONS(2877),
    [anon_sym_U_SQUOTE] = ACTIONS(2877),
    [anon_sym_u8_SQUOTE] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_L_DQUOTE] = ACTIONS(2877),
    [anon_sym_u_DQUOTE] = ACTIONS(2877),
    [anon_sym_U_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [sym_true] = ACTIONS(2875),
    [sym_false] = ACTIONS(2875),
    [anon_sym_NULL] = ACTIONS(2875),
    [anon_sym_nullptr] = ACTIONS(2875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2875),
    [anon_sym_decltype] = ACTIONS(2875),
    [anon_sym_explicit] = ACTIONS(2875),
    [anon_sym_typename] = ACTIONS(2875),
    [anon_sym_template] = ACTIONS(2875),
    [anon_sym_operator] = ACTIONS(2875),
    [anon_sym_try] = ACTIONS(2875),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_throw] = ACTIONS(2875),
    [anon_sym_namespace] = ACTIONS(2875),
    [anon_sym_static_assert] = ACTIONS(2875),
    [anon_sym_concept] = ACTIONS(2875),
    [anon_sym_co_return] = ACTIONS(2875),
    [anon_sym_co_yield] = ACTIONS(2875),
    [anon_sym_R_DQUOTE] = ACTIONS(2877),
    [anon_sym_LR_DQUOTE] = ACTIONS(2877),
    [anon_sym_uR_DQUOTE] = ACTIONS(2877),
    [anon_sym_UR_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2877),
    [anon_sym_co_await] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2875),
    [anon_sym_requires] = ACTIONS(2875),
    [sym_this] = ACTIONS(2875),
  },
  [316] = {
    [sym_identifier] = ACTIONS(2879),
    [aux_sym_preproc_include_token1] = ACTIONS(2879),
    [aux_sym_preproc_def_token1] = ACTIONS(2879),
    [aux_sym_preproc_if_token1] = ACTIONS(2879),
    [aux_sym_preproc_if_token2] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2879),
    [aux_sym_preproc_else_token1] = ACTIONS(2879),
    [aux_sym_preproc_elif_token1] = ACTIONS(2879),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2879),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2879),
    [sym_preproc_directive] = ACTIONS(2879),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2879),
    [anon_sym_typedef] = ACTIONS(2879),
    [anon_sym_virtual] = ACTIONS(2879),
    [anon_sym_extern] = ACTIONS(2879),
    [anon_sym___attribute__] = ACTIONS(2879),
    [anon_sym___attribute] = ACTIONS(2879),
    [anon_sym_using] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2879),
    [anon_sym___based] = ACTIONS(2879),
    [anon_sym___cdecl] = ACTIONS(2879),
    [anon_sym___clrcall] = ACTIONS(2879),
    [anon_sym___stdcall] = ACTIONS(2879),
    [anon_sym___fastcall] = ACTIONS(2879),
    [anon_sym___thiscall] = ACTIONS(2879),
    [anon_sym___vectorcall] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2879),
    [anon_sym_unsigned] = ACTIONS(2879),
    [anon_sym_long] = ACTIONS(2879),
    [anon_sym_short] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_static] = ACTIONS(2879),
    [anon_sym_register] = ACTIONS(2879),
    [anon_sym_inline] = ACTIONS(2879),
    [anon_sym___inline] = ACTIONS(2879),
    [anon_sym___inline__] = ACTIONS(2879),
    [anon_sym___forceinline] = ACTIONS(2879),
    [anon_sym_thread_local] = ACTIONS(2879),
    [anon_sym___thread] = ACTIONS(2879),
    [anon_sym_const] = ACTIONS(2879),
    [anon_sym_constexpr] = ACTIONS(2879),
    [anon_sym_volatile] = ACTIONS(2879),
    [anon_sym_restrict] = ACTIONS(2879),
    [anon_sym___restrict__] = ACTIONS(2879),
    [anon_sym__Atomic] = ACTIONS(2879),
    [anon_sym__Noreturn] = ACTIONS(2879),
    [anon_sym_noreturn] = ACTIONS(2879),
    [anon_sym__Nonnull] = ACTIONS(2879),
    [anon_sym_mutable] = ACTIONS(2879),
    [anon_sym_constinit] = ACTIONS(2879),
    [anon_sym_consteval] = ACTIONS(2879),
    [anon_sym_alignas] = ACTIONS(2879),
    [anon_sym__Alignas] = ACTIONS(2879),
    [sym_primitive_type] = ACTIONS(2879),
    [anon_sym_enum] = ACTIONS(2879),
    [anon_sym_class] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2879),
    [anon_sym_union] = ACTIONS(2879),
    [anon_sym_if] = ACTIONS(2879),
    [anon_sym_switch] = ACTIONS(2879),
    [anon_sym_case] = ACTIONS(2879),
    [anon_sym_default] = ACTIONS(2879),
    [anon_sym_while] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2879),
    [anon_sym_return] = ACTIONS(2879),
    [anon_sym_break] = ACTIONS(2879),
    [anon_sym_continue] = ACTIONS(2879),
    [anon_sym_goto] = ACTIONS(2879),
    [anon_sym___try] = ACTIONS(2879),
    [anon_sym___leave] = ACTIONS(2879),
    [anon_sym_not] = ACTIONS(2879),
    [anon_sym_compl] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2879),
    [anon_sym___alignof__] = ACTIONS(2879),
    [anon_sym___alignof] = ACTIONS(2879),
    [anon_sym__alignof] = ACTIONS(2879),
    [anon_sym_alignof] = ACTIONS(2879),
    [anon_sym__Alignof] = ACTIONS(2879),
    [anon_sym_offsetof] = ACTIONS(2879),
    [anon_sym__Generic] = ACTIONS(2879),
    [anon_sym_asm] = ACTIONS(2879),
    [anon_sym___asm__] = ACTIONS(2879),
    [anon_sym___asm] = ACTIONS(2879),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2879),
    [sym_false] = ACTIONS(2879),
    [anon_sym_NULL] = ACTIONS(2879),
    [anon_sym_nullptr] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2879),
    [anon_sym_decltype] = ACTIONS(2879),
    [anon_sym_explicit] = ACTIONS(2879),
    [anon_sym_typename] = ACTIONS(2879),
    [anon_sym_template] = ACTIONS(2879),
    [anon_sym_operator] = ACTIONS(2879),
    [anon_sym_try] = ACTIONS(2879),
    [anon_sym_delete] = ACTIONS(2879),
    [anon_sym_throw] = ACTIONS(2879),
    [anon_sym_namespace] = ACTIONS(2879),
    [anon_sym_static_assert] = ACTIONS(2879),
    [anon_sym_concept] = ACTIONS(2879),
    [anon_sym_co_return] = ACTIONS(2879),
    [anon_sym_co_yield] = ACTIONS(2879),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2879),
    [anon_sym_requires] = ACTIONS(2879),
    [sym_this] = ACTIONS(2879),
  },
  [317] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token2] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [aux_sym_preproc_else_token1] = ACTIONS(2883),
    [aux_sym_preproc_elif_token1] = ACTIONS(2883),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2885),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym___try] = ACTIONS(2883),
    [anon_sym___leave] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2885),
    [anon_sym_L_SQUOTE] = ACTIONS(2885),
    [anon_sym_u_SQUOTE] = ACTIONS(2885),
    [anon_sym_U_SQUOTE] = ACTIONS(2885),
    [anon_sym_u8_SQUOTE] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_L_DQUOTE] = ACTIONS(2885),
    [anon_sym_u_DQUOTE] = ACTIONS(2885),
    [anon_sym_U_DQUOTE] = ACTIONS(2885),
    [anon_sym_u8_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE] = ACTIONS(2885),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2885),
    [anon_sym_LR_DQUOTE] = ACTIONS(2885),
    [anon_sym_uR_DQUOTE] = ACTIONS(2885),
    [anon_sym_UR_DQUOTE] = ACTIONS(2885),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2885),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
  },
  [318] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_include_token1] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token2] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [aux_sym_preproc_else_token1] = ACTIONS(2887),
    [aux_sym_preproc_elif_token1] = ACTIONS(2887),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym___attribute] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym___cdecl] = ACTIONS(2887),
    [anon_sym___clrcall] = ACTIONS(2887),
    [anon_sym___stdcall] = ACTIONS(2887),
    [anon_sym___fastcall] = ACTIONS(2887),
    [anon_sym___thiscall] = ACTIONS(2887),
    [anon_sym___vectorcall] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym__Nonnull] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym__Alignas] = ACTIONS(2887),
    [sym_primitive_type] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2887),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_goto] = ACTIONS(2887),
    [anon_sym___try] = ACTIONS(2887),
    [anon_sym___leave] = ACTIONS(2887),
    [anon_sym_not] = ACTIONS(2887),
    [anon_sym_compl] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_sizeof] = ACTIONS(2887),
    [anon_sym___alignof__] = ACTIONS(2887),
    [anon_sym___alignof] = ACTIONS(2887),
    [anon_sym__alignof] = ACTIONS(2887),
    [anon_sym_alignof] = ACTIONS(2887),
    [anon_sym__Alignof] = ACTIONS(2887),
    [anon_sym_offsetof] = ACTIONS(2887),
    [anon_sym__Generic] = ACTIONS(2887),
    [anon_sym_asm] = ACTIONS(2887),
    [anon_sym___asm__] = ACTIONS(2887),
    [anon_sym___asm] = ACTIONS(2887),
    [sym_number_literal] = ACTIONS(2889),
    [anon_sym_L_SQUOTE] = ACTIONS(2889),
    [anon_sym_u_SQUOTE] = ACTIONS(2889),
    [anon_sym_U_SQUOTE] = ACTIONS(2889),
    [anon_sym_u8_SQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_L_DQUOTE] = ACTIONS(2889),
    [anon_sym_u_DQUOTE] = ACTIONS(2889),
    [anon_sym_U_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [anon_sym_NULL] = ACTIONS(2887),
    [anon_sym_nullptr] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_namespace] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_concept] = ACTIONS(2887),
    [anon_sym_co_return] = ACTIONS(2887),
    [anon_sym_co_yield] = ACTIONS(2887),
    [anon_sym_R_DQUOTE] = ACTIONS(2889),
    [anon_sym_LR_DQUOTE] = ACTIONS(2889),
    [anon_sym_uR_DQUOTE] = ACTIONS(2889),
    [anon_sym_UR_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2889),
    [anon_sym_co_await] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_requires] = ACTIONS(2887),
    [sym_this] = ACTIONS(2887),
  },
  [319] = {
    [sym_identifier] = ACTIONS(2891),
    [aux_sym_preproc_include_token1] = ACTIONS(2891),
    [aux_sym_preproc_def_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token2] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2891),
    [aux_sym_preproc_else_token1] = ACTIONS(2891),
    [aux_sym_preproc_elif_token1] = ACTIONS(2891),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2891),
    [sym_preproc_directive] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2891),
    [anon_sym_typedef] = ACTIONS(2891),
    [anon_sym_virtual] = ACTIONS(2891),
    [anon_sym_extern] = ACTIONS(2891),
    [anon_sym___attribute__] = ACTIONS(2891),
    [anon_sym___attribute] = ACTIONS(2891),
    [anon_sym_using] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2893),
    [anon_sym___declspec] = ACTIONS(2891),
    [anon_sym___based] = ACTIONS(2891),
    [anon_sym___cdecl] = ACTIONS(2891),
    [anon_sym___clrcall] = ACTIONS(2891),
    [anon_sym___stdcall] = ACTIONS(2891),
    [anon_sym___fastcall] = ACTIONS(2891),
    [anon_sym___thiscall] = ACTIONS(2891),
    [anon_sym___vectorcall] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2891),
    [anon_sym_unsigned] = ACTIONS(2891),
    [anon_sym_long] = ACTIONS(2891),
    [anon_sym_short] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_register] = ACTIONS(2891),
    [anon_sym_inline] = ACTIONS(2891),
    [anon_sym___inline] = ACTIONS(2891),
    [anon_sym___inline__] = ACTIONS(2891),
    [anon_sym___forceinline] = ACTIONS(2891),
    [anon_sym_thread_local] = ACTIONS(2891),
    [anon_sym___thread] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_constexpr] = ACTIONS(2891),
    [anon_sym_volatile] = ACTIONS(2891),
    [anon_sym_restrict] = ACTIONS(2891),
    [anon_sym___restrict__] = ACTIONS(2891),
    [anon_sym__Atomic] = ACTIONS(2891),
    [anon_sym__Noreturn] = ACTIONS(2891),
    [anon_sym_noreturn] = ACTIONS(2891),
    [anon_sym__Nonnull] = ACTIONS(2891),
    [anon_sym_mutable] = ACTIONS(2891),
    [anon_sym_constinit] = ACTIONS(2891),
    [anon_sym_consteval] = ACTIONS(2891),
    [anon_sym_alignas] = ACTIONS(2891),
    [anon_sym__Alignas] = ACTIONS(2891),
    [sym_primitive_type] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2891),
    [anon_sym_union] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_goto] = ACTIONS(2891),
    [anon_sym___try] = ACTIONS(2891),
    [anon_sym___leave] = ACTIONS(2891),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_compl] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_sizeof] = ACTIONS(2891),
    [anon_sym___alignof__] = ACTIONS(2891),
    [anon_sym___alignof] = ACTIONS(2891),
    [anon_sym__alignof] = ACTIONS(2891),
    [anon_sym_alignof] = ACTIONS(2891),
    [anon_sym__Alignof] = ACTIONS(2891),
    [anon_sym_offsetof] = ACTIONS(2891),
    [anon_sym__Generic] = ACTIONS(2891),
    [anon_sym_asm] = ACTIONS(2891),
    [anon_sym___asm__] = ACTIONS(2891),
    [anon_sym___asm] = ACTIONS(2891),
    [sym_number_literal] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2893),
    [anon_sym_u_SQUOTE] = ACTIONS(2893),
    [anon_sym_U_SQUOTE] = ACTIONS(2893),
    [anon_sym_u8_SQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_L_DQUOTE] = ACTIONS(2893),
    [anon_sym_u_DQUOTE] = ACTIONS(2893),
    [anon_sym_U_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [anon_sym_NULL] = ACTIONS(2891),
    [anon_sym_nullptr] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2891),
    [anon_sym_decltype] = ACTIONS(2891),
    [anon_sym_explicit] = ACTIONS(2891),
    [anon_sym_typename] = ACTIONS(2891),
    [anon_sym_template] = ACTIONS(2891),
    [anon_sym_operator] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_static_assert] = ACTIONS(2891),
    [anon_sym_concept] = ACTIONS(2891),
    [anon_sym_co_return] = ACTIONS(2891),
    [anon_sym_co_yield] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2893),
    [anon_sym_LR_DQUOTE] = ACTIONS(2893),
    [anon_sym_uR_DQUOTE] = ACTIONS(2893),
    [anon_sym_UR_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2893),
    [anon_sym_co_await] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_requires] = ACTIONS(2891),
    [sym_this] = ACTIONS(2891),
  },
  [320] = {
    [sym_identifier] = ACTIONS(2895),
    [aux_sym_preproc_include_token1] = ACTIONS(2895),
    [aux_sym_preproc_def_token1] = ACTIONS(2895),
    [aux_sym_preproc_if_token1] = ACTIONS(2895),
    [aux_sym_preproc_if_token2] = ACTIONS(2895),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2895),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2895),
    [aux_sym_preproc_else_token1] = ACTIONS(2895),
    [aux_sym_preproc_elif_token1] = ACTIONS(2895),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2895),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym___extension__] = ACTIONS(2895),
    [anon_sym_typedef] = ACTIONS(2895),
    [anon_sym_virtual] = ACTIONS(2895),
    [anon_sym_extern] = ACTIONS(2895),
    [anon_sym___attribute__] = ACTIONS(2895),
    [anon_sym___attribute] = ACTIONS(2895),
    [anon_sym_using] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2897),
    [anon_sym___declspec] = ACTIONS(2895),
    [anon_sym___based] = ACTIONS(2895),
    [anon_sym___cdecl] = ACTIONS(2895),
    [anon_sym___clrcall] = ACTIONS(2895),
    [anon_sym___stdcall] = ACTIONS(2895),
    [anon_sym___fastcall] = ACTIONS(2895),
    [anon_sym___thiscall] = ACTIONS(2895),
    [anon_sym___vectorcall] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_signed] = ACTIONS(2895),
    [anon_sym_unsigned] = ACTIONS(2895),
    [anon_sym_long] = ACTIONS(2895),
    [anon_sym_short] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2895),
    [anon_sym_register] = ACTIONS(2895),
    [anon_sym_inline] = ACTIONS(2895),
    [anon_sym___inline] = ACTIONS(2895),
    [anon_sym___inline__] = ACTIONS(2895),
    [anon_sym___forceinline] = ACTIONS(2895),
    [anon_sym_thread_local] = ACTIONS(2895),
    [anon_sym___thread] = ACTIONS(2895),
    [anon_sym_const] = ACTIONS(2895),
    [anon_sym_constexpr] = ACTIONS(2895),
    [anon_sym_volatile] = ACTIONS(2895),
    [anon_sym_restrict] = ACTIONS(2895),
    [anon_sym___restrict__] = ACTIONS(2895),
    [anon_sym__Atomic] = ACTIONS(2895),
    [anon_sym__Noreturn] = ACTIONS(2895),
    [anon_sym_noreturn] = ACTIONS(2895),
    [anon_sym__Nonnull] = ACTIONS(2895),
    [anon_sym_mutable] = ACTIONS(2895),
    [anon_sym_constinit] = ACTIONS(2895),
    [anon_sym_consteval] = ACTIONS(2895),
    [anon_sym_alignas] = ACTIONS(2895),
    [anon_sym__Alignas] = ACTIONS(2895),
    [sym_primitive_type] = ACTIONS(2895),
    [anon_sym_enum] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2895),
    [anon_sym_struct] = ACTIONS(2895),
    [anon_sym_union] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_switch] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2895),
    [anon_sym_default] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_break] = ACTIONS(2895),
    [anon_sym_continue] = ACTIONS(2895),
    [anon_sym_goto] = ACTIONS(2895),
    [anon_sym___try] = ACTIONS(2895),
    [anon_sym___leave] = ACTIONS(2895),
    [anon_sym_not] = ACTIONS(2895),
    [anon_sym_compl] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_sizeof] = ACTIONS(2895),
    [anon_sym___alignof__] = ACTIONS(2895),
    [anon_sym___alignof] = ACTIONS(2895),
    [anon_sym__alignof] = ACTIONS(2895),
    [anon_sym_alignof] = ACTIONS(2895),
    [anon_sym__Alignof] = ACTIONS(2895),
    [anon_sym_offsetof] = ACTIONS(2895),
    [anon_sym__Generic] = ACTIONS(2895),
    [anon_sym_asm] = ACTIONS(2895),
    [anon_sym___asm__] = ACTIONS(2895),
    [anon_sym___asm] = ACTIONS(2895),
    [sym_number_literal] = ACTIONS(2897),
    [anon_sym_L_SQUOTE] = ACTIONS(2897),
    [anon_sym_u_SQUOTE] = ACTIONS(2897),
    [anon_sym_U_SQUOTE] = ACTIONS(2897),
    [anon_sym_u8_SQUOTE] = ACTIONS(2897),
    [anon_sym_SQUOTE] = ACTIONS(2897),
    [anon_sym_L_DQUOTE] = ACTIONS(2897),
    [anon_sym_u_DQUOTE] = ACTIONS(2897),
    [anon_sym_U_DQUOTE] = ACTIONS(2897),
    [anon_sym_u8_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [sym_true] = ACTIONS(2895),
    [sym_false] = ACTIONS(2895),
    [anon_sym_NULL] = ACTIONS(2895),
    [anon_sym_nullptr] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2895),
    [anon_sym_decltype] = ACTIONS(2895),
    [anon_sym_explicit] = ACTIONS(2895),
    [anon_sym_typename] = ACTIONS(2895),
    [anon_sym_template] = ACTIONS(2895),
    [anon_sym_operator] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_delete] = ACTIONS(2895),
    [anon_sym_throw] = ACTIONS(2895),
    [anon_sym_namespace] = ACTIONS(2895),
    [anon_sym_static_assert] = ACTIONS(2895),
    [anon_sym_concept] = ACTIONS(2895),
    [anon_sym_co_return] = ACTIONS(2895),
    [anon_sym_co_yield] = ACTIONS(2895),
    [anon_sym_R_DQUOTE] = ACTIONS(2897),
    [anon_sym_LR_DQUOTE] = ACTIONS(2897),
    [anon_sym_uR_DQUOTE] = ACTIONS(2897),
    [anon_sym_UR_DQUOTE] = ACTIONS(2897),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2897),
    [anon_sym_co_await] = ACTIONS(2895),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_requires] = ACTIONS(2895),
    [sym_this] = ACTIONS(2895),
  },
  [321] = {
    [sym_identifier] = ACTIONS(2899),
    [aux_sym_preproc_include_token1] = ACTIONS(2899),
    [aux_sym_preproc_def_token1] = ACTIONS(2899),
    [aux_sym_preproc_if_token1] = ACTIONS(2899),
    [aux_sym_preproc_if_token2] = ACTIONS(2899),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2899),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2899),
    [aux_sym_preproc_else_token1] = ACTIONS(2899),
    [aux_sym_preproc_elif_token1] = ACTIONS(2899),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2899),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2899),
    [sym_preproc_directive] = ACTIONS(2899),
    [anon_sym_LPAREN2] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_PLUS] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym___extension__] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2899),
    [anon_sym_virtual] = ACTIONS(2899),
    [anon_sym_extern] = ACTIONS(2899),
    [anon_sym___attribute__] = ACTIONS(2899),
    [anon_sym___attribute] = ACTIONS(2899),
    [anon_sym_using] = ACTIONS(2899),
    [anon_sym_COLON_COLON] = ACTIONS(2901),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2901),
    [anon_sym___declspec] = ACTIONS(2899),
    [anon_sym___based] = ACTIONS(2899),
    [anon_sym___cdecl] = ACTIONS(2899),
    [anon_sym___clrcall] = ACTIONS(2899),
    [anon_sym___stdcall] = ACTIONS(2899),
    [anon_sym___fastcall] = ACTIONS(2899),
    [anon_sym___thiscall] = ACTIONS(2899),
    [anon_sym___vectorcall] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_signed] = ACTIONS(2899),
    [anon_sym_unsigned] = ACTIONS(2899),
    [anon_sym_long] = ACTIONS(2899),
    [anon_sym_short] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_static] = ACTIONS(2899),
    [anon_sym_register] = ACTIONS(2899),
    [anon_sym_inline] = ACTIONS(2899),
    [anon_sym___inline] = ACTIONS(2899),
    [anon_sym___inline__] = ACTIONS(2899),
    [anon_sym___forceinline] = ACTIONS(2899),
    [anon_sym_thread_local] = ACTIONS(2899),
    [anon_sym___thread] = ACTIONS(2899),
    [anon_sym_const] = ACTIONS(2899),
    [anon_sym_constexpr] = ACTIONS(2899),
    [anon_sym_volatile] = ACTIONS(2899),
    [anon_sym_restrict] = ACTIONS(2899),
    [anon_sym___restrict__] = ACTIONS(2899),
    [anon_sym__Atomic] = ACTIONS(2899),
    [anon_sym__Noreturn] = ACTIONS(2899),
    [anon_sym_noreturn] = ACTIONS(2899),
    [anon_sym__Nonnull] = ACTIONS(2899),
    [anon_sym_mutable] = ACTIONS(2899),
    [anon_sym_constinit] = ACTIONS(2899),
    [anon_sym_consteval] = ACTIONS(2899),
    [anon_sym_alignas] = ACTIONS(2899),
    [anon_sym__Alignas] = ACTIONS(2899),
    [sym_primitive_type] = ACTIONS(2899),
    [anon_sym_enum] = ACTIONS(2899),
    [anon_sym_class] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(2899),
    [anon_sym_union] = ACTIONS(2899),
    [anon_sym_if] = ACTIONS(2899),
    [anon_sym_switch] = ACTIONS(2899),
    [anon_sym_case] = ACTIONS(2899),
    [anon_sym_default] = ACTIONS(2899),
    [anon_sym_while] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2899),
    [anon_sym_for] = ACTIONS(2899),
    [anon_sym_return] = ACTIONS(2899),
    [anon_sym_break] = ACTIONS(2899),
    [anon_sym_continue] = ACTIONS(2899),
    [anon_sym_goto] = ACTIONS(2899),
    [anon_sym___try] = ACTIONS(2899),
    [anon_sym___leave] = ACTIONS(2899),
    [anon_sym_not] = ACTIONS(2899),
    [anon_sym_compl] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_sizeof] = ACTIONS(2899),
    [anon_sym___alignof__] = ACTIONS(2899),
    [anon_sym___alignof] = ACTIONS(2899),
    [anon_sym__alignof] = ACTIONS(2899),
    [anon_sym_alignof] = ACTIONS(2899),
    [anon_sym__Alignof] = ACTIONS(2899),
    [anon_sym_offsetof] = ACTIONS(2899),
    [anon_sym__Generic] = ACTIONS(2899),
    [anon_sym_asm] = ACTIONS(2899),
    [anon_sym___asm__] = ACTIONS(2899),
    [anon_sym___asm] = ACTIONS(2899),
    [sym_number_literal] = ACTIONS(2901),
    [anon_sym_L_SQUOTE] = ACTIONS(2901),
    [anon_sym_u_SQUOTE] = ACTIONS(2901),
    [anon_sym_U_SQUOTE] = ACTIONS(2901),
    [anon_sym_u8_SQUOTE] = ACTIONS(2901),
    [anon_sym_SQUOTE] = ACTIONS(2901),
    [anon_sym_L_DQUOTE] = ACTIONS(2901),
    [anon_sym_u_DQUOTE] = ACTIONS(2901),
    [anon_sym_U_DQUOTE] = ACTIONS(2901),
    [anon_sym_u8_DQUOTE] = ACTIONS(2901),
    [anon_sym_DQUOTE] = ACTIONS(2901),
    [sym_true] = ACTIONS(2899),
    [sym_false] = ACTIONS(2899),
    [anon_sym_NULL] = ACTIONS(2899),
    [anon_sym_nullptr] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2899),
    [anon_sym_decltype] = ACTIONS(2899),
    [anon_sym_explicit] = ACTIONS(2899),
    [anon_sym_typename] = ACTIONS(2899),
    [anon_sym_template] = ACTIONS(2899),
    [anon_sym_operator] = ACTIONS(2899),
    [anon_sym_try] = ACTIONS(2899),
    [anon_sym_delete] = ACTIONS(2899),
    [anon_sym_throw] = ACTIONS(2899),
    [anon_sym_namespace] = ACTIONS(2899),
    [anon_sym_static_assert] = ACTIONS(2899),
    [anon_sym_concept] = ACTIONS(2899),
    [anon_sym_co_return] = ACTIONS(2899),
    [anon_sym_co_yield] = ACTIONS(2899),
    [anon_sym_R_DQUOTE] = ACTIONS(2901),
    [anon_sym_LR_DQUOTE] = ACTIONS(2901),
    [anon_sym_uR_DQUOTE] = ACTIONS(2901),
    [anon_sym_UR_DQUOTE] = ACTIONS(2901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2901),
    [anon_sym_co_await] = ACTIONS(2899),
    [anon_sym_new] = ACTIONS(2899),
    [anon_sym_requires] = ACTIONS(2899),
    [sym_this] = ACTIONS(2899),
  },
  [322] = {
    [sym_identifier] = ACTIONS(2903),
    [aux_sym_preproc_include_token1] = ACTIONS(2903),
    [aux_sym_preproc_def_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token2] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2903),
    [aux_sym_preproc_else_token1] = ACTIONS(2903),
    [aux_sym_preproc_elif_token1] = ACTIONS(2903),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2903),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2903),
    [sym_preproc_directive] = ACTIONS(2903),
    [anon_sym_LPAREN2] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2903),
    [anon_sym_typedef] = ACTIONS(2903),
    [anon_sym_virtual] = ACTIONS(2903),
    [anon_sym_extern] = ACTIONS(2903),
    [anon_sym___attribute__] = ACTIONS(2903),
    [anon_sym___attribute] = ACTIONS(2903),
    [anon_sym_using] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2905),
    [anon_sym___declspec] = ACTIONS(2903),
    [anon_sym___based] = ACTIONS(2903),
    [anon_sym___cdecl] = ACTIONS(2903),
    [anon_sym___clrcall] = ACTIONS(2903),
    [anon_sym___stdcall] = ACTIONS(2903),
    [anon_sym___fastcall] = ACTIONS(2903),
    [anon_sym___thiscall] = ACTIONS(2903),
    [anon_sym___vectorcall] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_signed] = ACTIONS(2903),
    [anon_sym_unsigned] = ACTIONS(2903),
    [anon_sym_long] = ACTIONS(2903),
    [anon_sym_short] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_register] = ACTIONS(2903),
    [anon_sym_inline] = ACTIONS(2903),
    [anon_sym___inline] = ACTIONS(2903),
    [anon_sym___inline__] = ACTIONS(2903),
    [anon_sym___forceinline] = ACTIONS(2903),
    [anon_sym_thread_local] = ACTIONS(2903),
    [anon_sym___thread] = ACTIONS(2903),
    [anon_sym_const] = ACTIONS(2903),
    [anon_sym_constexpr] = ACTIONS(2903),
    [anon_sym_volatile] = ACTIONS(2903),
    [anon_sym_restrict] = ACTIONS(2903),
    [anon_sym___restrict__] = ACTIONS(2903),
    [anon_sym__Atomic] = ACTIONS(2903),
    [anon_sym__Noreturn] = ACTIONS(2903),
    [anon_sym_noreturn] = ACTIONS(2903),
    [anon_sym__Nonnull] = ACTIONS(2903),
    [anon_sym_mutable] = ACTIONS(2903),
    [anon_sym_constinit] = ACTIONS(2903),
    [anon_sym_consteval] = ACTIONS(2903),
    [anon_sym_alignas] = ACTIONS(2903),
    [anon_sym__Alignas] = ACTIONS(2903),
    [sym_primitive_type] = ACTIONS(2903),
    [anon_sym_enum] = ACTIONS(2903),
    [anon_sym_class] = ACTIONS(2903),
    [anon_sym_struct] = ACTIONS(2903),
    [anon_sym_union] = ACTIONS(2903),
    [anon_sym_if] = ACTIONS(2903),
    [anon_sym_switch] = ACTIONS(2903),
    [anon_sym_case] = ACTIONS(2903),
    [anon_sym_default] = ACTIONS(2903),
    [anon_sym_while] = ACTIONS(2903),
    [anon_sym_do] = ACTIONS(2903),
    [anon_sym_for] = ACTIONS(2903),
    [anon_sym_return] = ACTIONS(2903),
    [anon_sym_break] = ACTIONS(2903),
    [anon_sym_continue] = ACTIONS(2903),
    [anon_sym_goto] = ACTIONS(2903),
    [anon_sym___try] = ACTIONS(2903),
    [anon_sym___leave] = ACTIONS(2903),
    [anon_sym_not] = ACTIONS(2903),
    [anon_sym_compl] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_sizeof] = ACTIONS(2903),
    [anon_sym___alignof__] = ACTIONS(2903),
    [anon_sym___alignof] = ACTIONS(2903),
    [anon_sym__alignof] = ACTIONS(2903),
    [anon_sym_alignof] = ACTIONS(2903),
    [anon_sym__Alignof] = ACTIONS(2903),
    [anon_sym_offsetof] = ACTIONS(2903),
    [anon_sym__Generic] = ACTIONS(2903),
    [anon_sym_asm] = ACTIONS(2903),
    [anon_sym___asm__] = ACTIONS(2903),
    [anon_sym___asm] = ACTIONS(2903),
    [sym_number_literal] = ACTIONS(2905),
    [anon_sym_L_SQUOTE] = ACTIONS(2905),
    [anon_sym_u_SQUOTE] = ACTIONS(2905),
    [anon_sym_U_SQUOTE] = ACTIONS(2905),
    [anon_sym_u8_SQUOTE] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(2905),
    [anon_sym_L_DQUOTE] = ACTIONS(2905),
    [anon_sym_u_DQUOTE] = ACTIONS(2905),
    [anon_sym_U_DQUOTE] = ACTIONS(2905),
    [anon_sym_u8_DQUOTE] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [sym_true] = ACTIONS(2903),
    [sym_false] = ACTIONS(2903),
    [anon_sym_NULL] = ACTIONS(2903),
    [anon_sym_nullptr] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2903),
    [anon_sym_decltype] = ACTIONS(2903),
    [anon_sym_explicit] = ACTIONS(2903),
    [anon_sym_typename] = ACTIONS(2903),
    [anon_sym_template] = ACTIONS(2903),
    [anon_sym_operator] = ACTIONS(2903),
    [anon_sym_try] = ACTIONS(2903),
    [anon_sym_delete] = ACTIONS(2903),
    [anon_sym_throw] = ACTIONS(2903),
    [anon_sym_namespace] = ACTIONS(2903),
    [anon_sym_static_assert] = ACTIONS(2903),
    [anon_sym_concept] = ACTIONS(2903),
    [anon_sym_co_return] = ACTIONS(2903),
    [anon_sym_co_yield] = ACTIONS(2903),
    [anon_sym_R_DQUOTE] = ACTIONS(2905),
    [anon_sym_LR_DQUOTE] = ACTIONS(2905),
    [anon_sym_uR_DQUOTE] = ACTIONS(2905),
    [anon_sym_UR_DQUOTE] = ACTIONS(2905),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2905),
    [anon_sym_co_await] = ACTIONS(2903),
    [anon_sym_new] = ACTIONS(2903),
    [anon_sym_requires] = ACTIONS(2903),
    [sym_this] = ACTIONS(2903),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(2713),
    [sym_identifier] = ACTIONS(2711),
    [aux_sym_preproc_include_token1] = ACTIONS(2711),
    [aux_sym_preproc_def_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token1] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2711),
    [sym_preproc_directive] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym___extension__] = ACTIONS(2711),
    [anon_sym_typedef] = ACTIONS(2711),
    [anon_sym_virtual] = ACTIONS(2711),
    [anon_sym_extern] = ACTIONS(2711),
    [anon_sym___attribute__] = ACTIONS(2711),
    [anon_sym___attribute] = ACTIONS(2711),
    [anon_sym_using] = ACTIONS(2711),
    [anon_sym_COLON_COLON] = ACTIONS(2713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2713),
    [anon_sym___declspec] = ACTIONS(2711),
    [anon_sym___based] = ACTIONS(2711),
    [anon_sym___cdecl] = ACTIONS(2711),
    [anon_sym___clrcall] = ACTIONS(2711),
    [anon_sym___stdcall] = ACTIONS(2711),
    [anon_sym___fastcall] = ACTIONS(2711),
    [anon_sym___thiscall] = ACTIONS(2711),
    [anon_sym___vectorcall] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_signed] = ACTIONS(2711),
    [anon_sym_unsigned] = ACTIONS(2711),
    [anon_sym_long] = ACTIONS(2711),
    [anon_sym_short] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_static] = ACTIONS(2711),
    [anon_sym_register] = ACTIONS(2711),
    [anon_sym_inline] = ACTIONS(2711),
    [anon_sym___inline] = ACTIONS(2711),
    [anon_sym___inline__] = ACTIONS(2711),
    [anon_sym___forceinline] = ACTIONS(2711),
    [anon_sym_thread_local] = ACTIONS(2711),
    [anon_sym___thread] = ACTIONS(2711),
    [anon_sym_const] = ACTIONS(2711),
    [anon_sym_constexpr] = ACTIONS(2711),
    [anon_sym_volatile] = ACTIONS(2711),
    [anon_sym_restrict] = ACTIONS(2711),
    [anon_sym___restrict__] = ACTIONS(2711),
    [anon_sym__Atomic] = ACTIONS(2711),
    [anon_sym__Noreturn] = ACTIONS(2711),
    [anon_sym_noreturn] = ACTIONS(2711),
    [anon_sym__Nonnull] = ACTIONS(2711),
    [anon_sym_mutable] = ACTIONS(2711),
    [anon_sym_constinit] = ACTIONS(2711),
    [anon_sym_consteval] = ACTIONS(2711),
    [anon_sym_alignas] = ACTIONS(2711),
    [anon_sym__Alignas] = ACTIONS(2711),
    [sym_primitive_type] = ACTIONS(2711),
    [anon_sym_enum] = ACTIONS(2711),
    [anon_sym_class] = ACTIONS(2711),
    [anon_sym_struct] = ACTIONS(2711),
    [anon_sym_union] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(2711),
    [anon_sym_else] = ACTIONS(2711),
    [anon_sym_switch] = ACTIONS(2711),
    [anon_sym_case] = ACTIONS(2711),
    [anon_sym_default] = ACTIONS(2711),
    [anon_sym_while] = ACTIONS(2711),
    [anon_sym_do] = ACTIONS(2711),
    [anon_sym_for] = ACTIONS(2711),
    [anon_sym_return] = ACTIONS(2711),
    [anon_sym_break] = ACTIONS(2711),
    [anon_sym_continue] = ACTIONS(2711),
    [anon_sym_goto] = ACTIONS(2711),
    [anon_sym___try] = ACTIONS(2711),
    [anon_sym___leave] = ACTIONS(2711),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_compl] = ACTIONS(2711),
    [anon_sym_DASH_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_PLUS] = ACTIONS(2713),
    [anon_sym_sizeof] = ACTIONS(2711),
    [anon_sym___alignof__] = ACTIONS(2711),
    [anon_sym___alignof] = ACTIONS(2711),
    [anon_sym__alignof] = ACTIONS(2711),
    [anon_sym_alignof] = ACTIONS(2711),
    [anon_sym__Alignof] = ACTIONS(2711),
    [anon_sym_offsetof] = ACTIONS(2711),
    [anon_sym__Generic] = ACTIONS(2711),
    [anon_sym_asm] = ACTIONS(2711),
    [anon_sym___asm__] = ACTIONS(2711),
    [anon_sym___asm] = ACTIONS(2711),
    [sym_number_literal] = ACTIONS(2713),
    [anon_sym_L_SQUOTE] = ACTIONS(2713),
    [anon_sym_u_SQUOTE] = ACTIONS(2713),
    [anon_sym_U_SQUOTE] = ACTIONS(2713),
    [anon_sym_u8_SQUOTE] = ACTIONS(2713),
    [anon_sym_SQUOTE] = ACTIONS(2713),
    [anon_sym_L_DQUOTE] = ACTIONS(2713),
    [anon_sym_u_DQUOTE] = ACTIONS(2713),
    [anon_sym_U_DQUOTE] = ACTIONS(2713),
    [anon_sym_u8_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [sym_true] = ACTIONS(2711),
    [sym_false] = ACTIONS(2711),
    [anon_sym_NULL] = ACTIONS(2711),
    [anon_sym_nullptr] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2711),
    [anon_sym_decltype] = ACTIONS(2711),
    [anon_sym_explicit] = ACTIONS(2711),
    [anon_sym_typename] = ACTIONS(2711),
    [anon_sym_export] = ACTIONS(2711),
    [anon_sym_module] = ACTIONS(2711),
    [anon_sym_import] = ACTIONS(2711),
    [anon_sym_template] = ACTIONS(2711),
    [anon_sym_operator] = ACTIONS(2711),
    [anon_sym_try] = ACTIONS(2711),
    [anon_sym_delete] = ACTIONS(2711),
    [anon_sym_throw] = ACTIONS(2711),
    [anon_sym_namespace] = ACTIONS(2711),
    [anon_sym_static_assert] = ACTIONS(2711),
    [anon_sym_concept] = ACTIONS(2711),
    [anon_sym_co_return] = ACTIONS(2711),
    [anon_sym_co_yield] = ACTIONS(2711),
    [anon_sym_R_DQUOTE] = ACTIONS(2713),
    [anon_sym_LR_DQUOTE] = ACTIONS(2713),
    [anon_sym_uR_DQUOTE] = ACTIONS(2713),
    [anon_sym_UR_DQUOTE] = ACTIONS(2713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2713),
    [anon_sym_co_await] = ACTIONS(2711),
    [anon_sym_new] = ACTIONS(2711),
    [anon_sym_requires] = ACTIONS(2711),
    [sym_this] = ACTIONS(2711),
  },
  [324] = {
    [sym_identifier] = ACTIONS(2907),
    [aux_sym_preproc_include_token1] = ACTIONS(2907),
    [aux_sym_preproc_def_token1] = ACTIONS(2907),
    [aux_sym_preproc_if_token1] = ACTIONS(2907),
    [aux_sym_preproc_if_token2] = ACTIONS(2907),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2907),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2907),
    [aux_sym_preproc_else_token1] = ACTIONS(2907),
    [aux_sym_preproc_elif_token1] = ACTIONS(2907),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2907),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2907),
    [sym_preproc_directive] = ACTIONS(2907),
    [anon_sym_LPAREN2] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_PLUS] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2909),
    [anon_sym___extension__] = ACTIONS(2907),
    [anon_sym_typedef] = ACTIONS(2907),
    [anon_sym_virtual] = ACTIONS(2907),
    [anon_sym_extern] = ACTIONS(2907),
    [anon_sym___attribute__] = ACTIONS(2907),
    [anon_sym___attribute] = ACTIONS(2907),
    [anon_sym_using] = ACTIONS(2907),
    [anon_sym_COLON_COLON] = ACTIONS(2909),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2909),
    [anon_sym___declspec] = ACTIONS(2907),
    [anon_sym___based] = ACTIONS(2907),
    [anon_sym___cdecl] = ACTIONS(2907),
    [anon_sym___clrcall] = ACTIONS(2907),
    [anon_sym___stdcall] = ACTIONS(2907),
    [anon_sym___fastcall] = ACTIONS(2907),
    [anon_sym___thiscall] = ACTIONS(2907),
    [anon_sym___vectorcall] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_signed] = ACTIONS(2907),
    [anon_sym_unsigned] = ACTIONS(2907),
    [anon_sym_long] = ACTIONS(2907),
    [anon_sym_short] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_static] = ACTIONS(2907),
    [anon_sym_register] = ACTIONS(2907),
    [anon_sym_inline] = ACTIONS(2907),
    [anon_sym___inline] = ACTIONS(2907),
    [anon_sym___inline__] = ACTIONS(2907),
    [anon_sym___forceinline] = ACTIONS(2907),
    [anon_sym_thread_local] = ACTIONS(2907),
    [anon_sym___thread] = ACTIONS(2907),
    [anon_sym_const] = ACTIONS(2907),
    [anon_sym_constexpr] = ACTIONS(2907),
    [anon_sym_volatile] = ACTIONS(2907),
    [anon_sym_restrict] = ACTIONS(2907),
    [anon_sym___restrict__] = ACTIONS(2907),
    [anon_sym__Atomic] = ACTIONS(2907),
    [anon_sym__Noreturn] = ACTIONS(2907),
    [anon_sym_noreturn] = ACTIONS(2907),
    [anon_sym__Nonnull] = ACTIONS(2907),
    [anon_sym_mutable] = ACTIONS(2907),
    [anon_sym_constinit] = ACTIONS(2907),
    [anon_sym_consteval] = ACTIONS(2907),
    [anon_sym_alignas] = ACTIONS(2907),
    [anon_sym__Alignas] = ACTIONS(2907),
    [sym_primitive_type] = ACTIONS(2907),
    [anon_sym_enum] = ACTIONS(2907),
    [anon_sym_class] = ACTIONS(2907),
    [anon_sym_struct] = ACTIONS(2907),
    [anon_sym_union] = ACTIONS(2907),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2907),
    [anon_sym_default] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_for] = ACTIONS(2907),
    [anon_sym_return] = ACTIONS(2907),
    [anon_sym_break] = ACTIONS(2907),
    [anon_sym_continue] = ACTIONS(2907),
    [anon_sym_goto] = ACTIONS(2907),
    [anon_sym___try] = ACTIONS(2907),
    [anon_sym___leave] = ACTIONS(2907),
    [anon_sym_not] = ACTIONS(2907),
    [anon_sym_compl] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2909),
    [anon_sym_sizeof] = ACTIONS(2907),
    [anon_sym___alignof__] = ACTIONS(2907),
    [anon_sym___alignof] = ACTIONS(2907),
    [anon_sym__alignof] = ACTIONS(2907),
    [anon_sym_alignof] = ACTIONS(2907),
    [anon_sym__Alignof] = ACTIONS(2907),
    [anon_sym_offsetof] = ACTIONS(2907),
    [anon_sym__Generic] = ACTIONS(2907),
    [anon_sym_asm] = ACTIONS(2907),
    [anon_sym___asm__] = ACTIONS(2907),
    [anon_sym___asm] = ACTIONS(2907),
    [sym_number_literal] = ACTIONS(2909),
    [anon_sym_L_SQUOTE] = ACTIONS(2909),
    [anon_sym_u_SQUOTE] = ACTIONS(2909),
    [anon_sym_U_SQUOTE] = ACTIONS(2909),
    [anon_sym_u8_SQUOTE] = ACTIONS(2909),
    [anon_sym_SQUOTE] = ACTIONS(2909),
    [anon_sym_L_DQUOTE] = ACTIONS(2909),
    [anon_sym_u_DQUOTE] = ACTIONS(2909),
    [anon_sym_U_DQUOTE] = ACTIONS(2909),
    [anon_sym_u8_DQUOTE] = ACTIONS(2909),
    [anon_sym_DQUOTE] = ACTIONS(2909),
    [sym_true] = ACTIONS(2907),
    [sym_false] = ACTIONS(2907),
    [anon_sym_NULL] = ACTIONS(2907),
    [anon_sym_nullptr] = ACTIONS(2907),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2907),
    [anon_sym_decltype] = ACTIONS(2907),
    [anon_sym_explicit] = ACTIONS(2907),
    [anon_sym_typename] = ACTIONS(2907),
    [anon_sym_template] = ACTIONS(2907),
    [anon_sym_operator] = ACTIONS(2907),
    [anon_sym_try] = ACTIONS(2907),
    [anon_sym_delete] = ACTIONS(2907),
    [anon_sym_throw] = ACTIONS(2907),
    [anon_sym_namespace] = ACTIONS(2907),
    [anon_sym_static_assert] = ACTIONS(2907),
    [anon_sym_concept] = ACTIONS(2907),
    [anon_sym_co_return] = ACTIONS(2907),
    [anon_sym_co_yield] = ACTIONS(2907),
    [anon_sym_R_DQUOTE] = ACTIONS(2909),
    [anon_sym_LR_DQUOTE] = ACTIONS(2909),
    [anon_sym_uR_DQUOTE] = ACTIONS(2909),
    [anon_sym_UR_DQUOTE] = ACTIONS(2909),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2909),
    [anon_sym_co_await] = ACTIONS(2907),
    [anon_sym_new] = ACTIONS(2907),
    [anon_sym_requires] = ACTIONS(2907),
    [sym_this] = ACTIONS(2907),
  },
  [325] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_include_token1] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token2] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [aux_sym_preproc_else_token1] = ACTIONS(2911),
    [aux_sym_preproc_elif_token1] = ACTIONS(2911),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym___cdecl] = ACTIONS(2911),
    [anon_sym___clrcall] = ACTIONS(2911),
    [anon_sym___stdcall] = ACTIONS(2911),
    [anon_sym___fastcall] = ACTIONS(2911),
    [anon_sym___thiscall] = ACTIONS(2911),
    [anon_sym___vectorcall] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2911),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2911),
    [anon_sym_return] = ACTIONS(2911),
    [anon_sym_break] = ACTIONS(2911),
    [anon_sym_continue] = ACTIONS(2911),
    [anon_sym_goto] = ACTIONS(2911),
    [anon_sym___try] = ACTIONS(2911),
    [anon_sym___leave] = ACTIONS(2911),
    [anon_sym_not] = ACTIONS(2911),
    [anon_sym_compl] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_sizeof] = ACTIONS(2911),
    [anon_sym___alignof__] = ACTIONS(2911),
    [anon_sym___alignof] = ACTIONS(2911),
    [anon_sym__alignof] = ACTIONS(2911),
    [anon_sym_alignof] = ACTIONS(2911),
    [anon_sym__Alignof] = ACTIONS(2911),
    [anon_sym_offsetof] = ACTIONS(2911),
    [anon_sym__Generic] = ACTIONS(2911),
    [anon_sym_asm] = ACTIONS(2911),
    [anon_sym___asm__] = ACTIONS(2911),
    [anon_sym___asm] = ACTIONS(2911),
    [sym_number_literal] = ACTIONS(2913),
    [anon_sym_L_SQUOTE] = ACTIONS(2913),
    [anon_sym_u_SQUOTE] = ACTIONS(2913),
    [anon_sym_U_SQUOTE] = ACTIONS(2913),
    [anon_sym_u8_SQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_L_DQUOTE] = ACTIONS(2913),
    [anon_sym_u_DQUOTE] = ACTIONS(2913),
    [anon_sym_U_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8_DQUOTE] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [sym_true] = ACTIONS(2911),
    [sym_false] = ACTIONS(2911),
    [anon_sym_NULL] = ACTIONS(2911),
    [anon_sym_nullptr] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2911),
    [anon_sym_delete] = ACTIONS(2911),
    [anon_sym_throw] = ACTIONS(2911),
    [anon_sym_namespace] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
    [anon_sym_concept] = ACTIONS(2911),
    [anon_sym_co_return] = ACTIONS(2911),
    [anon_sym_co_yield] = ACTIONS(2911),
    [anon_sym_R_DQUOTE] = ACTIONS(2913),
    [anon_sym_LR_DQUOTE] = ACTIONS(2913),
    [anon_sym_uR_DQUOTE] = ACTIONS(2913),
    [anon_sym_UR_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2913),
    [anon_sym_co_await] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2911),
    [anon_sym_requires] = ACTIONS(2911),
    [sym_this] = ACTIONS(2911),
  },
  [326] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_include_token1] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token2] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [aux_sym_preproc_else_token1] = ACTIONS(2911),
    [aux_sym_preproc_elif_token1] = ACTIONS(2911),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym___cdecl] = ACTIONS(2911),
    [anon_sym___clrcall] = ACTIONS(2911),
    [anon_sym___stdcall] = ACTIONS(2911),
    [anon_sym___fastcall] = ACTIONS(2911),
    [anon_sym___thiscall] = ACTIONS(2911),
    [anon_sym___vectorcall] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2911),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2911),
    [anon_sym_return] = ACTIONS(2911),
    [anon_sym_break] = ACTIONS(2911),
    [anon_sym_continue] = ACTIONS(2911),
    [anon_sym_goto] = ACTIONS(2911),
    [anon_sym___try] = ACTIONS(2911),
    [anon_sym___leave] = ACTIONS(2911),
    [anon_sym_not] = ACTIONS(2911),
    [anon_sym_compl] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_sizeof] = ACTIONS(2911),
    [anon_sym___alignof__] = ACTIONS(2911),
    [anon_sym___alignof] = ACTIONS(2911),
    [anon_sym__alignof] = ACTIONS(2911),
    [anon_sym_alignof] = ACTIONS(2911),
    [anon_sym__Alignof] = ACTIONS(2911),
    [anon_sym_offsetof] = ACTIONS(2911),
    [anon_sym__Generic] = ACTIONS(2911),
    [anon_sym_asm] = ACTIONS(2911),
    [anon_sym___asm__] = ACTIONS(2911),
    [anon_sym___asm] = ACTIONS(2911),
    [sym_number_literal] = ACTIONS(2913),
    [anon_sym_L_SQUOTE] = ACTIONS(2913),
    [anon_sym_u_SQUOTE] = ACTIONS(2913),
    [anon_sym_U_SQUOTE] = ACTIONS(2913),
    [anon_sym_u8_SQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_L_DQUOTE] = ACTIONS(2913),
    [anon_sym_u_DQUOTE] = ACTIONS(2913),
    [anon_sym_U_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8_DQUOTE] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [sym_true] = ACTIONS(2911),
    [sym_false] = ACTIONS(2911),
    [anon_sym_NULL] = ACTIONS(2911),
    [anon_sym_nullptr] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2911),
    [anon_sym_delete] = ACTIONS(2911),
    [anon_sym_throw] = ACTIONS(2911),
    [anon_sym_namespace] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
    [anon_sym_concept] = ACTIONS(2911),
    [anon_sym_co_return] = ACTIONS(2911),
    [anon_sym_co_yield] = ACTIONS(2911),
    [anon_sym_R_DQUOTE] = ACTIONS(2913),
    [anon_sym_LR_DQUOTE] = ACTIONS(2913),
    [anon_sym_uR_DQUOTE] = ACTIONS(2913),
    [anon_sym_UR_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2913),
    [anon_sym_co_await] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2911),
    [anon_sym_requires] = ACTIONS(2911),
    [sym_this] = ACTIONS(2911),
  },
  [327] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_include_token1] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token2] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [aux_sym_preproc_else_token1] = ACTIONS(2915),
    [aux_sym_preproc_elif_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_goto] = ACTIONS(2915),
    [anon_sym___try] = ACTIONS(2915),
    [anon_sym___leave] = ACTIONS(2915),
    [anon_sym_not] = ACTIONS(2915),
    [anon_sym_compl] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_sizeof] = ACTIONS(2915),
    [anon_sym___alignof__] = ACTIONS(2915),
    [anon_sym___alignof] = ACTIONS(2915),
    [anon_sym__alignof] = ACTIONS(2915),
    [anon_sym_alignof] = ACTIONS(2915),
    [anon_sym__Alignof] = ACTIONS(2915),
    [anon_sym_offsetof] = ACTIONS(2915),
    [anon_sym__Generic] = ACTIONS(2915),
    [anon_sym_asm] = ACTIONS(2915),
    [anon_sym___asm__] = ACTIONS(2915),
    [anon_sym___asm] = ACTIONS(2915),
    [sym_number_literal] = ACTIONS(2917),
    [anon_sym_L_SQUOTE] = ACTIONS(2917),
    [anon_sym_u_SQUOTE] = ACTIONS(2917),
    [anon_sym_U_SQUOTE] = ACTIONS(2917),
    [anon_sym_u8_SQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_L_DQUOTE] = ACTIONS(2917),
    [anon_sym_u_DQUOTE] = ACTIONS(2917),
    [anon_sym_U_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8_DQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [anon_sym_NULL] = ACTIONS(2915),
    [anon_sym_nullptr] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
    [anon_sym_concept] = ACTIONS(2915),
    [anon_sym_co_return] = ACTIONS(2915),
    [anon_sym_co_yield] = ACTIONS(2915),
    [anon_sym_R_DQUOTE] = ACTIONS(2917),
    [anon_sym_LR_DQUOTE] = ACTIONS(2917),
    [anon_sym_uR_DQUOTE] = ACTIONS(2917),
    [anon_sym_UR_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2917),
    [anon_sym_co_await] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [sym_this] = ACTIONS(2915),
  },
  [328] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_include_token1] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token2] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [aux_sym_preproc_else_token1] = ACTIONS(2915),
    [aux_sym_preproc_elif_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_goto] = ACTIONS(2915),
    [anon_sym___try] = ACTIONS(2915),
    [anon_sym___leave] = ACTIONS(2915),
    [anon_sym_not] = ACTIONS(2915),
    [anon_sym_compl] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_sizeof] = ACTIONS(2915),
    [anon_sym___alignof__] = ACTIONS(2915),
    [anon_sym___alignof] = ACTIONS(2915),
    [anon_sym__alignof] = ACTIONS(2915),
    [anon_sym_alignof] = ACTIONS(2915),
    [anon_sym__Alignof] = ACTIONS(2915),
    [anon_sym_offsetof] = ACTIONS(2915),
    [anon_sym__Generic] = ACTIONS(2915),
    [anon_sym_asm] = ACTIONS(2915),
    [anon_sym___asm__] = ACTIONS(2915),
    [anon_sym___asm] = ACTIONS(2915),
    [sym_number_literal] = ACTIONS(2917),
    [anon_sym_L_SQUOTE] = ACTIONS(2917),
    [anon_sym_u_SQUOTE] = ACTIONS(2917),
    [anon_sym_U_SQUOTE] = ACTIONS(2917),
    [anon_sym_u8_SQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_L_DQUOTE] = ACTIONS(2917),
    [anon_sym_u_DQUOTE] = ACTIONS(2917),
    [anon_sym_U_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8_DQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [anon_sym_NULL] = ACTIONS(2915),
    [anon_sym_nullptr] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
    [anon_sym_concept] = ACTIONS(2915),
    [anon_sym_co_return] = ACTIONS(2915),
    [anon_sym_co_yield] = ACTIONS(2915),
    [anon_sym_R_DQUOTE] = ACTIONS(2917),
    [anon_sym_LR_DQUOTE] = ACTIONS(2917),
    [anon_sym_uR_DQUOTE] = ACTIONS(2917),
    [anon_sym_UR_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2917),
    [anon_sym_co_await] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [sym_this] = ACTIONS(2915),
  },
  [329] = {
    [sym_identifier] = ACTIONS(2919),
    [aux_sym_preproc_include_token1] = ACTIONS(2919),
    [aux_sym_preproc_def_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token2] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2919),
    [aux_sym_preproc_else_token1] = ACTIONS(2919),
    [aux_sym_preproc_elif_token1] = ACTIONS(2919),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2919),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2919),
    [sym_preproc_directive] = ACTIONS(2919),
    [anon_sym_LPAREN2] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym___extension__] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(2919),
    [anon_sym_virtual] = ACTIONS(2919),
    [anon_sym_extern] = ACTIONS(2919),
    [anon_sym___attribute__] = ACTIONS(2919),
    [anon_sym___attribute] = ACTIONS(2919),
    [anon_sym_using] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(2921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2921),
    [anon_sym___declspec] = ACTIONS(2919),
    [anon_sym___based] = ACTIONS(2919),
    [anon_sym___cdecl] = ACTIONS(2919),
    [anon_sym___clrcall] = ACTIONS(2919),
    [anon_sym___stdcall] = ACTIONS(2919),
    [anon_sym___fastcall] = ACTIONS(2919),
    [anon_sym___thiscall] = ACTIONS(2919),
    [anon_sym___vectorcall] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_signed] = ACTIONS(2919),
    [anon_sym_unsigned] = ACTIONS(2919),
    [anon_sym_long] = ACTIONS(2919),
    [anon_sym_short] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_register] = ACTIONS(2919),
    [anon_sym_inline] = ACTIONS(2919),
    [anon_sym___inline] = ACTIONS(2919),
    [anon_sym___inline__] = ACTIONS(2919),
    [anon_sym___forceinline] = ACTIONS(2919),
    [anon_sym_thread_local] = ACTIONS(2919),
    [anon_sym___thread] = ACTIONS(2919),
    [anon_sym_const] = ACTIONS(2919),
    [anon_sym_constexpr] = ACTIONS(2919),
    [anon_sym_volatile] = ACTIONS(2919),
    [anon_sym_restrict] = ACTIONS(2919),
    [anon_sym___restrict__] = ACTIONS(2919),
    [anon_sym__Atomic] = ACTIONS(2919),
    [anon_sym__Noreturn] = ACTIONS(2919),
    [anon_sym_noreturn] = ACTIONS(2919),
    [anon_sym__Nonnull] = ACTIONS(2919),
    [anon_sym_mutable] = ACTIONS(2919),
    [anon_sym_constinit] = ACTIONS(2919),
    [anon_sym_consteval] = ACTIONS(2919),
    [anon_sym_alignas] = ACTIONS(2919),
    [anon_sym__Alignas] = ACTIONS(2919),
    [sym_primitive_type] = ACTIONS(2919),
    [anon_sym_enum] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2919),
    [anon_sym_switch] = ACTIONS(2919),
    [anon_sym_case] = ACTIONS(2919),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_while] = ACTIONS(2919),
    [anon_sym_do] = ACTIONS(2919),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_continue] = ACTIONS(2919),
    [anon_sym_goto] = ACTIONS(2919),
    [anon_sym___try] = ACTIONS(2919),
    [anon_sym___leave] = ACTIONS(2919),
    [anon_sym_not] = ACTIONS(2919),
    [anon_sym_compl] = ACTIONS(2919),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_sizeof] = ACTIONS(2919),
    [anon_sym___alignof__] = ACTIONS(2919),
    [anon_sym___alignof] = ACTIONS(2919),
    [anon_sym__alignof] = ACTIONS(2919),
    [anon_sym_alignof] = ACTIONS(2919),
    [anon_sym__Alignof] = ACTIONS(2919),
    [anon_sym_offsetof] = ACTIONS(2919),
    [anon_sym__Generic] = ACTIONS(2919),
    [anon_sym_asm] = ACTIONS(2919),
    [anon_sym___asm__] = ACTIONS(2919),
    [anon_sym___asm] = ACTIONS(2919),
    [sym_number_literal] = ACTIONS(2921),
    [anon_sym_L_SQUOTE] = ACTIONS(2921),
    [anon_sym_u_SQUOTE] = ACTIONS(2921),
    [anon_sym_U_SQUOTE] = ACTIONS(2921),
    [anon_sym_u8_SQUOTE] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_L_DQUOTE] = ACTIONS(2921),
    [anon_sym_u_DQUOTE] = ACTIONS(2921),
    [anon_sym_U_DQUOTE] = ACTIONS(2921),
    [anon_sym_u8_DQUOTE] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [sym_true] = ACTIONS(2919),
    [sym_false] = ACTIONS(2919),
    [anon_sym_NULL] = ACTIONS(2919),
    [anon_sym_nullptr] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2919),
    [anon_sym_decltype] = ACTIONS(2919),
    [anon_sym_explicit] = ACTIONS(2919),
    [anon_sym_typename] = ACTIONS(2919),
    [anon_sym_template] = ACTIONS(2919),
    [anon_sym_operator] = ACTIONS(2919),
    [anon_sym_try] = ACTIONS(2919),
    [anon_sym_delete] = ACTIONS(2919),
    [anon_sym_throw] = ACTIONS(2919),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_static_assert] = ACTIONS(2919),
    [anon_sym_concept] = ACTIONS(2919),
    [anon_sym_co_return] = ACTIONS(2919),
    [anon_sym_co_yield] = ACTIONS(2919),
    [anon_sym_R_DQUOTE] = ACTIONS(2921),
    [anon_sym_LR_DQUOTE] = ACTIONS(2921),
    [anon_sym_uR_DQUOTE] = ACTIONS(2921),
    [anon_sym_UR_DQUOTE] = ACTIONS(2921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2921),
    [anon_sym_co_await] = ACTIONS(2919),
    [anon_sym_new] = ACTIONS(2919),
    [anon_sym_requires] = ACTIONS(2919),
    [sym_this] = ACTIONS(2919),
  },
  [330] = {
    [sym_identifier] = ACTIONS(2923),
    [aux_sym_preproc_include_token1] = ACTIONS(2923),
    [aux_sym_preproc_def_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token2] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2923),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2923),
    [sym_preproc_directive] = ACTIONS(2923),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2923),
    [anon_sym_typedef] = ACTIONS(2923),
    [anon_sym_virtual] = ACTIONS(2923),
    [anon_sym_extern] = ACTIONS(2923),
    [anon_sym___attribute__] = ACTIONS(2923),
    [anon_sym___attribute] = ACTIONS(2923),
    [anon_sym_using] = ACTIONS(2923),
    [anon_sym_COLON_COLON] = ACTIONS(2925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2925),
    [anon_sym___declspec] = ACTIONS(2923),
    [anon_sym___based] = ACTIONS(2923),
    [anon_sym___cdecl] = ACTIONS(2923),
    [anon_sym___clrcall] = ACTIONS(2923),
    [anon_sym___stdcall] = ACTIONS(2923),
    [anon_sym___fastcall] = ACTIONS(2923),
    [anon_sym___thiscall] = ACTIONS(2923),
    [anon_sym___vectorcall] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_signed] = ACTIONS(2923),
    [anon_sym_unsigned] = ACTIONS(2923),
    [anon_sym_long] = ACTIONS(2923),
    [anon_sym_short] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_register] = ACTIONS(2923),
    [anon_sym_inline] = ACTIONS(2923),
    [anon_sym___inline] = ACTIONS(2923),
    [anon_sym___inline__] = ACTIONS(2923),
    [anon_sym___forceinline] = ACTIONS(2923),
    [anon_sym_thread_local] = ACTIONS(2923),
    [anon_sym___thread] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_constexpr] = ACTIONS(2923),
    [anon_sym_volatile] = ACTIONS(2923),
    [anon_sym_restrict] = ACTIONS(2923),
    [anon_sym___restrict__] = ACTIONS(2923),
    [anon_sym__Atomic] = ACTIONS(2923),
    [anon_sym__Noreturn] = ACTIONS(2923),
    [anon_sym_noreturn] = ACTIONS(2923),
    [anon_sym__Nonnull] = ACTIONS(2923),
    [anon_sym_mutable] = ACTIONS(2923),
    [anon_sym_constinit] = ACTIONS(2923),
    [anon_sym_consteval] = ACTIONS(2923),
    [anon_sym_alignas] = ACTIONS(2923),
    [anon_sym__Alignas] = ACTIONS(2923),
    [sym_primitive_type] = ACTIONS(2923),
    [anon_sym_enum] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2923),
    [anon_sym_union] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_case] = ACTIONS(2923),
    [anon_sym_default] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_break] = ACTIONS(2923),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2923),
    [anon_sym___try] = ACTIONS(2923),
    [anon_sym___leave] = ACTIONS(2923),
    [anon_sym_not] = ACTIONS(2923),
    [anon_sym_compl] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_sizeof] = ACTIONS(2923),
    [anon_sym___alignof__] = ACTIONS(2923),
    [anon_sym___alignof] = ACTIONS(2923),
    [anon_sym__alignof] = ACTIONS(2923),
    [anon_sym_alignof] = ACTIONS(2923),
    [anon_sym__Alignof] = ACTIONS(2923),
    [anon_sym_offsetof] = ACTIONS(2923),
    [anon_sym__Generic] = ACTIONS(2923),
    [anon_sym_asm] = ACTIONS(2923),
    [anon_sym___asm__] = ACTIONS(2923),
    [anon_sym___asm] = ACTIONS(2923),
    [sym_number_literal] = ACTIONS(2925),
    [anon_sym_L_SQUOTE] = ACTIONS(2925),
    [anon_sym_u_SQUOTE] = ACTIONS(2925),
    [anon_sym_U_SQUOTE] = ACTIONS(2925),
    [anon_sym_u8_SQUOTE] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [anon_sym_L_DQUOTE] = ACTIONS(2925),
    [anon_sym_u_DQUOTE] = ACTIONS(2925),
    [anon_sym_U_DQUOTE] = ACTIONS(2925),
    [anon_sym_u8_DQUOTE] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [sym_true] = ACTIONS(2923),
    [sym_false] = ACTIONS(2923),
    [anon_sym_NULL] = ACTIONS(2923),
    [anon_sym_nullptr] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2923),
    [anon_sym_decltype] = ACTIONS(2923),
    [anon_sym_explicit] = ACTIONS(2923),
    [anon_sym_typename] = ACTIONS(2923),
    [anon_sym_template] = ACTIONS(2923),
    [anon_sym_operator] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_delete] = ACTIONS(2923),
    [anon_sym_throw] = ACTIONS(2923),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_static_assert] = ACTIONS(2923),
    [anon_sym_concept] = ACTIONS(2923),
    [anon_sym_co_return] = ACTIONS(2923),
    [anon_sym_co_yield] = ACTIONS(2923),
    [anon_sym_R_DQUOTE] = ACTIONS(2925),
    [anon_sym_LR_DQUOTE] = ACTIONS(2925),
    [anon_sym_uR_DQUOTE] = ACTIONS(2925),
    [anon_sym_UR_DQUOTE] = ACTIONS(2925),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2925),
    [anon_sym_co_await] = ACTIONS(2923),
    [anon_sym_new] = ACTIONS(2923),
    [anon_sym_requires] = ACTIONS(2923),
    [sym_this] = ACTIONS(2923),
  },
  [331] = {
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_include_token1] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token2] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [aux_sym_preproc_else_token1] = ACTIONS(2927),
    [aux_sym_preproc_elif_token1] = ACTIONS(2927),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym___attribute] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2929),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym___cdecl] = ACTIONS(2927),
    [anon_sym___clrcall] = ACTIONS(2927),
    [anon_sym___stdcall] = ACTIONS(2927),
    [anon_sym___fastcall] = ACTIONS(2927),
    [anon_sym___thiscall] = ACTIONS(2927),
    [anon_sym___vectorcall] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym__Nonnull] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym__Alignas] = ACTIONS(2927),
    [sym_primitive_type] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym___try] = ACTIONS(2927),
    [anon_sym___leave] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2927),
    [anon_sym_compl] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_sizeof] = ACTIONS(2927),
    [anon_sym___alignof__] = ACTIONS(2927),
    [anon_sym___alignof] = ACTIONS(2927),
    [anon_sym__alignof] = ACTIONS(2927),
    [anon_sym_alignof] = ACTIONS(2927),
    [anon_sym__Alignof] = ACTIONS(2927),
    [anon_sym_offsetof] = ACTIONS(2927),
    [anon_sym__Generic] = ACTIONS(2927),
    [anon_sym_asm] = ACTIONS(2927),
    [anon_sym___asm__] = ACTIONS(2927),
    [anon_sym___asm] = ACTIONS(2927),
    [sym_number_literal] = ACTIONS(2929),
    [anon_sym_L_SQUOTE] = ACTIONS(2929),
    [anon_sym_u_SQUOTE] = ACTIONS(2929),
    [anon_sym_U_SQUOTE] = ACTIONS(2929),
    [anon_sym_u8_SQUOTE] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [anon_sym_L_DQUOTE] = ACTIONS(2929),
    [anon_sym_u_DQUOTE] = ACTIONS(2929),
    [anon_sym_U_DQUOTE] = ACTIONS(2929),
    [anon_sym_u8_DQUOTE] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [anon_sym_NULL] = ACTIONS(2927),
    [anon_sym_nullptr] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
    [anon_sym_concept] = ACTIONS(2927),
    [anon_sym_co_return] = ACTIONS(2927),
    [anon_sym_co_yield] = ACTIONS(2927),
    [anon_sym_R_DQUOTE] = ACTIONS(2929),
    [anon_sym_LR_DQUOTE] = ACTIONS(2929),
    [anon_sym_uR_DQUOTE] = ACTIONS(2929),
    [anon_sym_UR_DQUOTE] = ACTIONS(2929),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2929),
    [anon_sym_co_await] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_requires] = ACTIONS(2927),
    [sym_this] = ACTIONS(2927),
  },
  [332] = {
    [sym_identifier] = ACTIONS(2931),
    [aux_sym_preproc_include_token1] = ACTIONS(2931),
    [aux_sym_preproc_def_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token2] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2931),
    [aux_sym_preproc_else_token1] = ACTIONS(2931),
    [aux_sym_preproc_elif_token1] = ACTIONS(2931),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2931),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2931),
    [sym_preproc_directive] = ACTIONS(2931),
    [anon_sym_LPAREN2] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym___extension__] = ACTIONS(2931),
    [anon_sym_typedef] = ACTIONS(2931),
    [anon_sym_virtual] = ACTIONS(2931),
    [anon_sym_extern] = ACTIONS(2931),
    [anon_sym___attribute__] = ACTIONS(2931),
    [anon_sym___attribute] = ACTIONS(2931),
    [anon_sym_using] = ACTIONS(2931),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2933),
    [anon_sym___declspec] = ACTIONS(2931),
    [anon_sym___based] = ACTIONS(2931),
    [anon_sym___cdecl] = ACTIONS(2931),
    [anon_sym___clrcall] = ACTIONS(2931),
    [anon_sym___stdcall] = ACTIONS(2931),
    [anon_sym___fastcall] = ACTIONS(2931),
    [anon_sym___thiscall] = ACTIONS(2931),
    [anon_sym___vectorcall] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_signed] = ACTIONS(2931),
    [anon_sym_unsigned] = ACTIONS(2931),
    [anon_sym_long] = ACTIONS(2931),
    [anon_sym_short] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_register] = ACTIONS(2931),
    [anon_sym_inline] = ACTIONS(2931),
    [anon_sym___inline] = ACTIONS(2931),
    [anon_sym___inline__] = ACTIONS(2931),
    [anon_sym___forceinline] = ACTIONS(2931),
    [anon_sym_thread_local] = ACTIONS(2931),
    [anon_sym___thread] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_constexpr] = ACTIONS(2931),
    [anon_sym_volatile] = ACTIONS(2931),
    [anon_sym_restrict] = ACTIONS(2931),
    [anon_sym___restrict__] = ACTIONS(2931),
    [anon_sym__Atomic] = ACTIONS(2931),
    [anon_sym__Noreturn] = ACTIONS(2931),
    [anon_sym_noreturn] = ACTIONS(2931),
    [anon_sym__Nonnull] = ACTIONS(2931),
    [anon_sym_mutable] = ACTIONS(2931),
    [anon_sym_constinit] = ACTIONS(2931),
    [anon_sym_consteval] = ACTIONS(2931),
    [anon_sym_alignas] = ACTIONS(2931),
    [anon_sym__Alignas] = ACTIONS(2931),
    [sym_primitive_type] = ACTIONS(2931),
    [anon_sym_enum] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2931),
    [anon_sym_struct] = ACTIONS(2931),
    [anon_sym_union] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_switch] = ACTIONS(2931),
    [anon_sym_case] = ACTIONS(2931),
    [anon_sym_default] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_for] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2931),
    [anon_sym_break] = ACTIONS(2931),
    [anon_sym_continue] = ACTIONS(2931),
    [anon_sym_goto] = ACTIONS(2931),
    [anon_sym___try] = ACTIONS(2931),
    [anon_sym___leave] = ACTIONS(2931),
    [anon_sym_not] = ACTIONS(2931),
    [anon_sym_compl] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2931),
    [anon_sym___alignof__] = ACTIONS(2931),
    [anon_sym___alignof] = ACTIONS(2931),
    [anon_sym__alignof] = ACTIONS(2931),
    [anon_sym_alignof] = ACTIONS(2931),
    [anon_sym__Alignof] = ACTIONS(2931),
    [anon_sym_offsetof] = ACTIONS(2931),
    [anon_sym__Generic] = ACTIONS(2931),
    [anon_sym_asm] = ACTIONS(2931),
    [anon_sym___asm__] = ACTIONS(2931),
    [anon_sym___asm] = ACTIONS(2931),
    [sym_number_literal] = ACTIONS(2933),
    [anon_sym_L_SQUOTE] = ACTIONS(2933),
    [anon_sym_u_SQUOTE] = ACTIONS(2933),
    [anon_sym_U_SQUOTE] = ACTIONS(2933),
    [anon_sym_u8_SQUOTE] = ACTIONS(2933),
    [anon_sym_SQUOTE] = ACTIONS(2933),
    [anon_sym_L_DQUOTE] = ACTIONS(2933),
    [anon_sym_u_DQUOTE] = ACTIONS(2933),
    [anon_sym_U_DQUOTE] = ACTIONS(2933),
    [anon_sym_u8_DQUOTE] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2933),
    [sym_true] = ACTIONS(2931),
    [sym_false] = ACTIONS(2931),
    [anon_sym_NULL] = ACTIONS(2931),
    [anon_sym_nullptr] = ACTIONS(2931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2931),
    [anon_sym_decltype] = ACTIONS(2931),
    [anon_sym_explicit] = ACTIONS(2931),
    [anon_sym_typename] = ACTIONS(2931),
    [anon_sym_template] = ACTIONS(2931),
    [anon_sym_operator] = ACTIONS(2931),
    [anon_sym_try] = ACTIONS(2931),
    [anon_sym_delete] = ACTIONS(2931),
    [anon_sym_throw] = ACTIONS(2931),
    [anon_sym_namespace] = ACTIONS(2931),
    [anon_sym_static_assert] = ACTIONS(2931),
    [anon_sym_concept] = ACTIONS(2931),
    [anon_sym_co_return] = ACTIONS(2931),
    [anon_sym_co_yield] = ACTIONS(2931),
    [anon_sym_R_DQUOTE] = ACTIONS(2933),
    [anon_sym_LR_DQUOTE] = ACTIONS(2933),
    [anon_sym_uR_DQUOTE] = ACTIONS(2933),
    [anon_sym_UR_DQUOTE] = ACTIONS(2933),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2933),
    [anon_sym_co_await] = ACTIONS(2931),
    [anon_sym_new] = ACTIONS(2931),
    [anon_sym_requires] = ACTIONS(2931),
    [sym_this] = ACTIONS(2931),
  },
  [333] = {
    [sym_identifier] = ACTIONS(2935),
    [aux_sym_preproc_include_token1] = ACTIONS(2935),
    [aux_sym_preproc_def_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token2] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2935),
    [aux_sym_preproc_else_token1] = ACTIONS(2935),
    [aux_sym_preproc_elif_token1] = ACTIONS(2935),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2935),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2935),
    [sym_preproc_directive] = ACTIONS(2935),
    [anon_sym_LPAREN2] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym___extension__] = ACTIONS(2935),
    [anon_sym_typedef] = ACTIONS(2935),
    [anon_sym_virtual] = ACTIONS(2935),
    [anon_sym_extern] = ACTIONS(2935),
    [anon_sym___attribute__] = ACTIONS(2935),
    [anon_sym___attribute] = ACTIONS(2935),
    [anon_sym_using] = ACTIONS(2935),
    [anon_sym_COLON_COLON] = ACTIONS(2937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2937),
    [anon_sym___declspec] = ACTIONS(2935),
    [anon_sym___based] = ACTIONS(2935),
    [anon_sym___cdecl] = ACTIONS(2935),
    [anon_sym___clrcall] = ACTIONS(2935),
    [anon_sym___stdcall] = ACTIONS(2935),
    [anon_sym___fastcall] = ACTIONS(2935),
    [anon_sym___thiscall] = ACTIONS(2935),
    [anon_sym___vectorcall] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_signed] = ACTIONS(2935),
    [anon_sym_unsigned] = ACTIONS(2935),
    [anon_sym_long] = ACTIONS(2935),
    [anon_sym_short] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_register] = ACTIONS(2935),
    [anon_sym_inline] = ACTIONS(2935),
    [anon_sym___inline] = ACTIONS(2935),
    [anon_sym___inline__] = ACTIONS(2935),
    [anon_sym___forceinline] = ACTIONS(2935),
    [anon_sym_thread_local] = ACTIONS(2935),
    [anon_sym___thread] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_constexpr] = ACTIONS(2935),
    [anon_sym_volatile] = ACTIONS(2935),
    [anon_sym_restrict] = ACTIONS(2935),
    [anon_sym___restrict__] = ACTIONS(2935),
    [anon_sym__Atomic] = ACTIONS(2935),
    [anon_sym__Noreturn] = ACTIONS(2935),
    [anon_sym_noreturn] = ACTIONS(2935),
    [anon_sym__Nonnull] = ACTIONS(2935),
    [anon_sym_mutable] = ACTIONS(2935),
    [anon_sym_constinit] = ACTIONS(2935),
    [anon_sym_consteval] = ACTIONS(2935),
    [anon_sym_alignas] = ACTIONS(2935),
    [anon_sym__Alignas] = ACTIONS(2935),
    [sym_primitive_type] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_union] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_case] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2935),
    [anon_sym_while] = ACTIONS(2935),
    [anon_sym_do] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_goto] = ACTIONS(2935),
    [anon_sym___try] = ACTIONS(2935),
    [anon_sym___leave] = ACTIONS(2935),
    [anon_sym_not] = ACTIONS(2935),
    [anon_sym_compl] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2937),
    [anon_sym_sizeof] = ACTIONS(2935),
    [anon_sym___alignof__] = ACTIONS(2935),
    [anon_sym___alignof] = ACTIONS(2935),
    [anon_sym__alignof] = ACTIONS(2935),
    [anon_sym_alignof] = ACTIONS(2935),
    [anon_sym__Alignof] = ACTIONS(2935),
    [anon_sym_offsetof] = ACTIONS(2935),
    [anon_sym__Generic] = ACTIONS(2935),
    [anon_sym_asm] = ACTIONS(2935),
    [anon_sym___asm__] = ACTIONS(2935),
    [anon_sym___asm] = ACTIONS(2935),
    [sym_number_literal] = ACTIONS(2937),
    [anon_sym_L_SQUOTE] = ACTIONS(2937),
    [anon_sym_u_SQUOTE] = ACTIONS(2937),
    [anon_sym_U_SQUOTE] = ACTIONS(2937),
    [anon_sym_u8_SQUOTE] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2937),
    [anon_sym_L_DQUOTE] = ACTIONS(2937),
    [anon_sym_u_DQUOTE] = ACTIONS(2937),
    [anon_sym_U_DQUOTE] = ACTIONS(2937),
    [anon_sym_u8_DQUOTE] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [anon_sym_NULL] = ACTIONS(2935),
    [anon_sym_nullptr] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2935),
    [anon_sym_decltype] = ACTIONS(2935),
    [anon_sym_explicit] = ACTIONS(2935),
    [anon_sym_typename] = ACTIONS(2935),
    [anon_sym_template] = ACTIONS(2935),
    [anon_sym_operator] = ACTIONS(2935),
    [anon_sym_try] = ACTIONS(2935),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_throw] = ACTIONS(2935),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_static_assert] = ACTIONS(2935),
    [anon_sym_concept] = ACTIONS(2935),
    [anon_sym_co_return] = ACTIONS(2935),
    [anon_sym_co_yield] = ACTIONS(2935),
    [anon_sym_R_DQUOTE] = ACTIONS(2937),
    [anon_sym_LR_DQUOTE] = ACTIONS(2937),
    [anon_sym_uR_DQUOTE] = ACTIONS(2937),
    [anon_sym_UR_DQUOTE] = ACTIONS(2937),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2937),
    [anon_sym_co_await] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2935),
    [anon_sym_requires] = ACTIONS(2935),
    [sym_this] = ACTIONS(2935),
  },
  [334] = {
    [sym_identifier] = ACTIONS(2939),
    [aux_sym_preproc_include_token1] = ACTIONS(2939),
    [aux_sym_preproc_def_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token2] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2939),
    [aux_sym_preproc_else_token1] = ACTIONS(2939),
    [aux_sym_preproc_elif_token1] = ACTIONS(2939),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2939),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2939),
    [sym_preproc_directive] = ACTIONS(2939),
    [anon_sym_LPAREN2] = ACTIONS(2941),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2939),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2939),
    [anon_sym_typedef] = ACTIONS(2939),
    [anon_sym_virtual] = ACTIONS(2939),
    [anon_sym_extern] = ACTIONS(2939),
    [anon_sym___attribute__] = ACTIONS(2939),
    [anon_sym___attribute] = ACTIONS(2939),
    [anon_sym_using] = ACTIONS(2939),
    [anon_sym_COLON_COLON] = ACTIONS(2941),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2941),
    [anon_sym___declspec] = ACTIONS(2939),
    [anon_sym___based] = ACTIONS(2939),
    [anon_sym___cdecl] = ACTIONS(2939),
    [anon_sym___clrcall] = ACTIONS(2939),
    [anon_sym___stdcall] = ACTIONS(2939),
    [anon_sym___fastcall] = ACTIONS(2939),
    [anon_sym___thiscall] = ACTIONS(2939),
    [anon_sym___vectorcall] = ACTIONS(2939),
    [anon_sym_LBRACE] = ACTIONS(2941),
    [anon_sym_signed] = ACTIONS(2939),
    [anon_sym_unsigned] = ACTIONS(2939),
    [anon_sym_long] = ACTIONS(2939),
    [anon_sym_short] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_static] = ACTIONS(2939),
    [anon_sym_register] = ACTIONS(2939),
    [anon_sym_inline] = ACTIONS(2939),
    [anon_sym___inline] = ACTIONS(2939),
    [anon_sym___inline__] = ACTIONS(2939),
    [anon_sym___forceinline] = ACTIONS(2939),
    [anon_sym_thread_local] = ACTIONS(2939),
    [anon_sym___thread] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_constexpr] = ACTIONS(2939),
    [anon_sym_volatile] = ACTIONS(2939),
    [anon_sym_restrict] = ACTIONS(2939),
    [anon_sym___restrict__] = ACTIONS(2939),
    [anon_sym__Atomic] = ACTIONS(2939),
    [anon_sym__Noreturn] = ACTIONS(2939),
    [anon_sym_noreturn] = ACTIONS(2939),
    [anon_sym__Nonnull] = ACTIONS(2939),
    [anon_sym_mutable] = ACTIONS(2939),
    [anon_sym_constinit] = ACTIONS(2939),
    [anon_sym_consteval] = ACTIONS(2939),
    [anon_sym_alignas] = ACTIONS(2939),
    [anon_sym__Alignas] = ACTIONS(2939),
    [sym_primitive_type] = ACTIONS(2939),
    [anon_sym_enum] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2939),
    [anon_sym_struct] = ACTIONS(2939),
    [anon_sym_union] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(2939),
    [anon_sym_switch] = ACTIONS(2939),
    [anon_sym_case] = ACTIONS(2939),
    [anon_sym_default] = ACTIONS(2939),
    [anon_sym_while] = ACTIONS(2939),
    [anon_sym_do] = ACTIONS(2939),
    [anon_sym_for] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2939),
    [anon_sym_break] = ACTIONS(2939),
    [anon_sym_continue] = ACTIONS(2939),
    [anon_sym_goto] = ACTIONS(2939),
    [anon_sym___try] = ACTIONS(2939),
    [anon_sym___leave] = ACTIONS(2939),
    [anon_sym_not] = ACTIONS(2939),
    [anon_sym_compl] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2941),
    [anon_sym_PLUS_PLUS] = ACTIONS(2941),
    [anon_sym_sizeof] = ACTIONS(2939),
    [anon_sym___alignof__] = ACTIONS(2939),
    [anon_sym___alignof] = ACTIONS(2939),
    [anon_sym__alignof] = ACTIONS(2939),
    [anon_sym_alignof] = ACTIONS(2939),
    [anon_sym__Alignof] = ACTIONS(2939),
    [anon_sym_offsetof] = ACTIONS(2939),
    [anon_sym__Generic] = ACTIONS(2939),
    [anon_sym_asm] = ACTIONS(2939),
    [anon_sym___asm__] = ACTIONS(2939),
    [anon_sym___asm] = ACTIONS(2939),
    [sym_number_literal] = ACTIONS(2941),
    [anon_sym_L_SQUOTE] = ACTIONS(2941),
    [anon_sym_u_SQUOTE] = ACTIONS(2941),
    [anon_sym_U_SQUOTE] = ACTIONS(2941),
    [anon_sym_u8_SQUOTE] = ACTIONS(2941),
    [anon_sym_SQUOTE] = ACTIONS(2941),
    [anon_sym_L_DQUOTE] = ACTIONS(2941),
    [anon_sym_u_DQUOTE] = ACTIONS(2941),
    [anon_sym_U_DQUOTE] = ACTIONS(2941),
    [anon_sym_u8_DQUOTE] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_true] = ACTIONS(2939),
    [sym_false] = ACTIONS(2939),
    [anon_sym_NULL] = ACTIONS(2939),
    [anon_sym_nullptr] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2939),
    [anon_sym_decltype] = ACTIONS(2939),
    [anon_sym_explicit] = ACTIONS(2939),
    [anon_sym_typename] = ACTIONS(2939),
    [anon_sym_template] = ACTIONS(2939),
    [anon_sym_operator] = ACTIONS(2939),
    [anon_sym_try] = ACTIONS(2939),
    [anon_sym_delete] = ACTIONS(2939),
    [anon_sym_throw] = ACTIONS(2939),
    [anon_sym_namespace] = ACTIONS(2939),
    [anon_sym_static_assert] = ACTIONS(2939),
    [anon_sym_concept] = ACTIONS(2939),
    [anon_sym_co_return] = ACTIONS(2939),
    [anon_sym_co_yield] = ACTIONS(2939),
    [anon_sym_R_DQUOTE] = ACTIONS(2941),
    [anon_sym_LR_DQUOTE] = ACTIONS(2941),
    [anon_sym_uR_DQUOTE] = ACTIONS(2941),
    [anon_sym_UR_DQUOTE] = ACTIONS(2941),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2941),
    [anon_sym_co_await] = ACTIONS(2939),
    [anon_sym_new] = ACTIONS(2939),
    [anon_sym_requires] = ACTIONS(2939),
    [sym_this] = ACTIONS(2939),
  },
  [335] = {
    [sym_identifier] = ACTIONS(2943),
    [aux_sym_preproc_include_token1] = ACTIONS(2943),
    [aux_sym_preproc_def_token1] = ACTIONS(2943),
    [aux_sym_preproc_if_token1] = ACTIONS(2943),
    [aux_sym_preproc_if_token2] = ACTIONS(2943),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2943),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2943),
    [aux_sym_preproc_else_token1] = ACTIONS(2943),
    [aux_sym_preproc_elif_token1] = ACTIONS(2943),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2943),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2943),
    [sym_preproc_directive] = ACTIONS(2943),
    [anon_sym_LPAREN2] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_TILDE] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2943),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym___extension__] = ACTIONS(2943),
    [anon_sym_typedef] = ACTIONS(2943),
    [anon_sym_virtual] = ACTIONS(2943),
    [anon_sym_extern] = ACTIONS(2943),
    [anon_sym___attribute__] = ACTIONS(2943),
    [anon_sym___attribute] = ACTIONS(2943),
    [anon_sym_using] = ACTIONS(2943),
    [anon_sym_COLON_COLON] = ACTIONS(2945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2945),
    [anon_sym___declspec] = ACTIONS(2943),
    [anon_sym___based] = ACTIONS(2943),
    [anon_sym___cdecl] = ACTIONS(2943),
    [anon_sym___clrcall] = ACTIONS(2943),
    [anon_sym___stdcall] = ACTIONS(2943),
    [anon_sym___fastcall] = ACTIONS(2943),
    [anon_sym___thiscall] = ACTIONS(2943),
    [anon_sym___vectorcall] = ACTIONS(2943),
    [anon_sym_LBRACE] = ACTIONS(2945),
    [anon_sym_signed] = ACTIONS(2943),
    [anon_sym_unsigned] = ACTIONS(2943),
    [anon_sym_long] = ACTIONS(2943),
    [anon_sym_short] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_static] = ACTIONS(2943),
    [anon_sym_register] = ACTIONS(2943),
    [anon_sym_inline] = ACTIONS(2943),
    [anon_sym___inline] = ACTIONS(2943),
    [anon_sym___inline__] = ACTIONS(2943),
    [anon_sym___forceinline] = ACTIONS(2943),
    [anon_sym_thread_local] = ACTIONS(2943),
    [anon_sym___thread] = ACTIONS(2943),
    [anon_sym_const] = ACTIONS(2943),
    [anon_sym_constexpr] = ACTIONS(2943),
    [anon_sym_volatile] = ACTIONS(2943),
    [anon_sym_restrict] = ACTIONS(2943),
    [anon_sym___restrict__] = ACTIONS(2943),
    [anon_sym__Atomic] = ACTIONS(2943),
    [anon_sym__Noreturn] = ACTIONS(2943),
    [anon_sym_noreturn] = ACTIONS(2943),
    [anon_sym__Nonnull] = ACTIONS(2943),
    [anon_sym_mutable] = ACTIONS(2943),
    [anon_sym_constinit] = ACTIONS(2943),
    [anon_sym_consteval] = ACTIONS(2943),
    [anon_sym_alignas] = ACTIONS(2943),
    [anon_sym__Alignas] = ACTIONS(2943),
    [sym_primitive_type] = ACTIONS(2943),
    [anon_sym_enum] = ACTIONS(2943),
    [anon_sym_class] = ACTIONS(2943),
    [anon_sym_struct] = ACTIONS(2943),
    [anon_sym_union] = ACTIONS(2943),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_switch] = ACTIONS(2943),
    [anon_sym_case] = ACTIONS(2943),
    [anon_sym_default] = ACTIONS(2943),
    [anon_sym_while] = ACTIONS(2943),
    [anon_sym_do] = ACTIONS(2943),
    [anon_sym_for] = ACTIONS(2943),
    [anon_sym_return] = ACTIONS(2943),
    [anon_sym_break] = ACTIONS(2943),
    [anon_sym_continue] = ACTIONS(2943),
    [anon_sym_goto] = ACTIONS(2943),
    [anon_sym___try] = ACTIONS(2943),
    [anon_sym___leave] = ACTIONS(2943),
    [anon_sym_not] = ACTIONS(2943),
    [anon_sym_compl] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_sizeof] = ACTIONS(2943),
    [anon_sym___alignof__] = ACTIONS(2943),
    [anon_sym___alignof] = ACTIONS(2943),
    [anon_sym__alignof] = ACTIONS(2943),
    [anon_sym_alignof] = ACTIONS(2943),
    [anon_sym__Alignof] = ACTIONS(2943),
    [anon_sym_offsetof] = ACTIONS(2943),
    [anon_sym__Generic] = ACTIONS(2943),
    [anon_sym_asm] = ACTIONS(2943),
    [anon_sym___asm__] = ACTIONS(2943),
    [anon_sym___asm] = ACTIONS(2943),
    [sym_number_literal] = ACTIONS(2945),
    [anon_sym_L_SQUOTE] = ACTIONS(2945),
    [anon_sym_u_SQUOTE] = ACTIONS(2945),
    [anon_sym_U_SQUOTE] = ACTIONS(2945),
    [anon_sym_u8_SQUOTE] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_L_DQUOTE] = ACTIONS(2945),
    [anon_sym_u_DQUOTE] = ACTIONS(2945),
    [anon_sym_U_DQUOTE] = ACTIONS(2945),
    [anon_sym_u8_DQUOTE] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_true] = ACTIONS(2943),
    [sym_false] = ACTIONS(2943),
    [anon_sym_NULL] = ACTIONS(2943),
    [anon_sym_nullptr] = ACTIONS(2943),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2943),
    [anon_sym_decltype] = ACTIONS(2943),
    [anon_sym_explicit] = ACTIONS(2943),
    [anon_sym_typename] = ACTIONS(2943),
    [anon_sym_template] = ACTIONS(2943),
    [anon_sym_operator] = ACTIONS(2943),
    [anon_sym_try] = ACTIONS(2943),
    [anon_sym_delete] = ACTIONS(2943),
    [anon_sym_throw] = ACTIONS(2943),
    [anon_sym_namespace] = ACTIONS(2943),
    [anon_sym_static_assert] = ACTIONS(2943),
    [anon_sym_concept] = ACTIONS(2943),
    [anon_sym_co_return] = ACTIONS(2943),
    [anon_sym_co_yield] = ACTIONS(2943),
    [anon_sym_R_DQUOTE] = ACTIONS(2945),
    [anon_sym_LR_DQUOTE] = ACTIONS(2945),
    [anon_sym_uR_DQUOTE] = ACTIONS(2945),
    [anon_sym_UR_DQUOTE] = ACTIONS(2945),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2945),
    [anon_sym_co_await] = ACTIONS(2943),
    [anon_sym_new] = ACTIONS(2943),
    [anon_sym_requires] = ACTIONS(2943),
    [sym_this] = ACTIONS(2943),
  },
  [336] = {
    [sym_identifier] = ACTIONS(2947),
    [aux_sym_preproc_include_token1] = ACTIONS(2947),
    [aux_sym_preproc_def_token1] = ACTIONS(2947),
    [aux_sym_preproc_if_token1] = ACTIONS(2947),
    [aux_sym_preproc_if_token2] = ACTIONS(2947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2947),
    [aux_sym_preproc_else_token1] = ACTIONS(2947),
    [aux_sym_preproc_elif_token1] = ACTIONS(2947),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2947),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2947),
    [sym_preproc_directive] = ACTIONS(2947),
    [anon_sym_LPAREN2] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym___extension__] = ACTIONS(2947),
    [anon_sym_typedef] = ACTIONS(2947),
    [anon_sym_virtual] = ACTIONS(2947),
    [anon_sym_extern] = ACTIONS(2947),
    [anon_sym___attribute__] = ACTIONS(2947),
    [anon_sym___attribute] = ACTIONS(2947),
    [anon_sym_using] = ACTIONS(2947),
    [anon_sym_COLON_COLON] = ACTIONS(2949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2949),
    [anon_sym___declspec] = ACTIONS(2947),
    [anon_sym___based] = ACTIONS(2947),
    [anon_sym___cdecl] = ACTIONS(2947),
    [anon_sym___clrcall] = ACTIONS(2947),
    [anon_sym___stdcall] = ACTIONS(2947),
    [anon_sym___fastcall] = ACTIONS(2947),
    [anon_sym___thiscall] = ACTIONS(2947),
    [anon_sym___vectorcall] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2949),
    [anon_sym_signed] = ACTIONS(2947),
    [anon_sym_unsigned] = ACTIONS(2947),
    [anon_sym_long] = ACTIONS(2947),
    [anon_sym_short] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_static] = ACTIONS(2947),
    [anon_sym_register] = ACTIONS(2947),
    [anon_sym_inline] = ACTIONS(2947),
    [anon_sym___inline] = ACTIONS(2947),
    [anon_sym___inline__] = ACTIONS(2947),
    [anon_sym___forceinline] = ACTIONS(2947),
    [anon_sym_thread_local] = ACTIONS(2947),
    [anon_sym___thread] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_constexpr] = ACTIONS(2947),
    [anon_sym_volatile] = ACTIONS(2947),
    [anon_sym_restrict] = ACTIONS(2947),
    [anon_sym___restrict__] = ACTIONS(2947),
    [anon_sym__Atomic] = ACTIONS(2947),
    [anon_sym__Noreturn] = ACTIONS(2947),
    [anon_sym_noreturn] = ACTIONS(2947),
    [anon_sym__Nonnull] = ACTIONS(2947),
    [anon_sym_mutable] = ACTIONS(2947),
    [anon_sym_constinit] = ACTIONS(2947),
    [anon_sym_consteval] = ACTIONS(2947),
    [anon_sym_alignas] = ACTIONS(2947),
    [anon_sym__Alignas] = ACTIONS(2947),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2947),
    [anon_sym_class] = ACTIONS(2947),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_switch] = ACTIONS(2947),
    [anon_sym_case] = ACTIONS(2947),
    [anon_sym_default] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_goto] = ACTIONS(2947),
    [anon_sym___try] = ACTIONS(2947),
    [anon_sym___leave] = ACTIONS(2947),
    [anon_sym_not] = ACTIONS(2947),
    [anon_sym_compl] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2949),
    [anon_sym_PLUS_PLUS] = ACTIONS(2949),
    [anon_sym_sizeof] = ACTIONS(2947),
    [anon_sym___alignof__] = ACTIONS(2947),
    [anon_sym___alignof] = ACTIONS(2947),
    [anon_sym__alignof] = ACTIONS(2947),
    [anon_sym_alignof] = ACTIONS(2947),
    [anon_sym__Alignof] = ACTIONS(2947),
    [anon_sym_offsetof] = ACTIONS(2947),
    [anon_sym__Generic] = ACTIONS(2947),
    [anon_sym_asm] = ACTIONS(2947),
    [anon_sym___asm__] = ACTIONS(2947),
    [anon_sym___asm] = ACTIONS(2947),
    [sym_number_literal] = ACTIONS(2949),
    [anon_sym_L_SQUOTE] = ACTIONS(2949),
    [anon_sym_u_SQUOTE] = ACTIONS(2949),
    [anon_sym_U_SQUOTE] = ACTIONS(2949),
    [anon_sym_u8_SQUOTE] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_L_DQUOTE] = ACTIONS(2949),
    [anon_sym_u_DQUOTE] = ACTIONS(2949),
    [anon_sym_U_DQUOTE] = ACTIONS(2949),
    [anon_sym_u8_DQUOTE] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [anon_sym_NULL] = ACTIONS(2947),
    [anon_sym_nullptr] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2947),
    [anon_sym_decltype] = ACTIONS(2947),
    [anon_sym_explicit] = ACTIONS(2947),
    [anon_sym_typename] = ACTIONS(2947),
    [anon_sym_template] = ACTIONS(2947),
    [anon_sym_operator] = ACTIONS(2947),
    [anon_sym_try] = ACTIONS(2947),
    [anon_sym_delete] = ACTIONS(2947),
    [anon_sym_throw] = ACTIONS(2947),
    [anon_sym_namespace] = ACTIONS(2947),
    [anon_sym_static_assert] = ACTIONS(2947),
    [anon_sym_concept] = ACTIONS(2947),
    [anon_sym_co_return] = ACTIONS(2947),
    [anon_sym_co_yield] = ACTIONS(2947),
    [anon_sym_R_DQUOTE] = ACTIONS(2949),
    [anon_sym_LR_DQUOTE] = ACTIONS(2949),
    [anon_sym_uR_DQUOTE] = ACTIONS(2949),
    [anon_sym_UR_DQUOTE] = ACTIONS(2949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2949),
    [anon_sym_co_await] = ACTIONS(2947),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_requires] = ACTIONS(2947),
    [sym_this] = ACTIONS(2947),
  },
  [337] = {
    [sym_identifier] = ACTIONS(2951),
    [aux_sym_preproc_include_token1] = ACTIONS(2951),
    [aux_sym_preproc_def_token1] = ACTIONS(2951),
    [aux_sym_preproc_if_token1] = ACTIONS(2951),
    [aux_sym_preproc_if_token2] = ACTIONS(2951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2951),
    [aux_sym_preproc_else_token1] = ACTIONS(2951),
    [aux_sym_preproc_elif_token1] = ACTIONS(2951),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2951),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2951),
    [sym_preproc_directive] = ACTIONS(2951),
    [anon_sym_LPAREN2] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_TILDE] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_AMP_AMP] = ACTIONS(2953),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2953),
    [anon_sym___extension__] = ACTIONS(2951),
    [anon_sym_typedef] = ACTIONS(2951),
    [anon_sym_virtual] = ACTIONS(2951),
    [anon_sym_extern] = ACTIONS(2951),
    [anon_sym___attribute__] = ACTIONS(2951),
    [anon_sym___attribute] = ACTIONS(2951),
    [anon_sym_using] = ACTIONS(2951),
    [anon_sym_COLON_COLON] = ACTIONS(2953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2953),
    [anon_sym___declspec] = ACTIONS(2951),
    [anon_sym___based] = ACTIONS(2951),
    [anon_sym___cdecl] = ACTIONS(2951),
    [anon_sym___clrcall] = ACTIONS(2951),
    [anon_sym___stdcall] = ACTIONS(2951),
    [anon_sym___fastcall] = ACTIONS(2951),
    [anon_sym___thiscall] = ACTIONS(2951),
    [anon_sym___vectorcall] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2953),
    [anon_sym_signed] = ACTIONS(2951),
    [anon_sym_unsigned] = ACTIONS(2951),
    [anon_sym_long] = ACTIONS(2951),
    [anon_sym_short] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_static] = ACTIONS(2951),
    [anon_sym_register] = ACTIONS(2951),
    [anon_sym_inline] = ACTIONS(2951),
    [anon_sym___inline] = ACTIONS(2951),
    [anon_sym___inline__] = ACTIONS(2951),
    [anon_sym___forceinline] = ACTIONS(2951),
    [anon_sym_thread_local] = ACTIONS(2951),
    [anon_sym___thread] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_constexpr] = ACTIONS(2951),
    [anon_sym_volatile] = ACTIONS(2951),
    [anon_sym_restrict] = ACTIONS(2951),
    [anon_sym___restrict__] = ACTIONS(2951),
    [anon_sym__Atomic] = ACTIONS(2951),
    [anon_sym__Noreturn] = ACTIONS(2951),
    [anon_sym_noreturn] = ACTIONS(2951),
    [anon_sym__Nonnull] = ACTIONS(2951),
    [anon_sym_mutable] = ACTIONS(2951),
    [anon_sym_constinit] = ACTIONS(2951),
    [anon_sym_consteval] = ACTIONS(2951),
    [anon_sym_alignas] = ACTIONS(2951),
    [anon_sym__Alignas] = ACTIONS(2951),
    [sym_primitive_type] = ACTIONS(2951),
    [anon_sym_enum] = ACTIONS(2951),
    [anon_sym_class] = ACTIONS(2951),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_union] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_switch] = ACTIONS(2951),
    [anon_sym_case] = ACTIONS(2951),
    [anon_sym_default] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2951),
    [anon_sym_do] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_goto] = ACTIONS(2951),
    [anon_sym___try] = ACTIONS(2951),
    [anon_sym___leave] = ACTIONS(2951),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_compl] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2951),
    [anon_sym___alignof__] = ACTIONS(2951),
    [anon_sym___alignof] = ACTIONS(2951),
    [anon_sym__alignof] = ACTIONS(2951),
    [anon_sym_alignof] = ACTIONS(2951),
    [anon_sym__Alignof] = ACTIONS(2951),
    [anon_sym_offsetof] = ACTIONS(2951),
    [anon_sym__Generic] = ACTIONS(2951),
    [anon_sym_asm] = ACTIONS(2951),
    [anon_sym___asm__] = ACTIONS(2951),
    [anon_sym___asm] = ACTIONS(2951),
    [sym_number_literal] = ACTIONS(2953),
    [anon_sym_L_SQUOTE] = ACTIONS(2953),
    [anon_sym_u_SQUOTE] = ACTIONS(2953),
    [anon_sym_U_SQUOTE] = ACTIONS(2953),
    [anon_sym_u8_SQUOTE] = ACTIONS(2953),
    [anon_sym_SQUOTE] = ACTIONS(2953),
    [anon_sym_L_DQUOTE] = ACTIONS(2953),
    [anon_sym_u_DQUOTE] = ACTIONS(2953),
    [anon_sym_U_DQUOTE] = ACTIONS(2953),
    [anon_sym_u8_DQUOTE] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(2953),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [anon_sym_NULL] = ACTIONS(2951),
    [anon_sym_nullptr] = ACTIONS(2951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2951),
    [anon_sym_decltype] = ACTIONS(2951),
    [anon_sym_explicit] = ACTIONS(2951),
    [anon_sym_typename] = ACTIONS(2951),
    [anon_sym_template] = ACTIONS(2951),
    [anon_sym_operator] = ACTIONS(2951),
    [anon_sym_try] = ACTIONS(2951),
    [anon_sym_delete] = ACTIONS(2951),
    [anon_sym_throw] = ACTIONS(2951),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_static_assert] = ACTIONS(2951),
    [anon_sym_concept] = ACTIONS(2951),
    [anon_sym_co_return] = ACTIONS(2951),
    [anon_sym_co_yield] = ACTIONS(2951),
    [anon_sym_R_DQUOTE] = ACTIONS(2953),
    [anon_sym_LR_DQUOTE] = ACTIONS(2953),
    [anon_sym_uR_DQUOTE] = ACTIONS(2953),
    [anon_sym_UR_DQUOTE] = ACTIONS(2953),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2953),
    [anon_sym_co_await] = ACTIONS(2951),
    [anon_sym_new] = ACTIONS(2951),
    [anon_sym_requires] = ACTIONS(2951),
    [sym_this] = ACTIONS(2951),
  },
  [338] = {
    [sym_identifier] = ACTIONS(2955),
    [aux_sym_preproc_include_token1] = ACTIONS(2955),
    [aux_sym_preproc_def_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token2] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2955),
    [aux_sym_preproc_else_token1] = ACTIONS(2955),
    [aux_sym_preproc_elif_token1] = ACTIONS(2955),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2955),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2955),
    [sym_preproc_directive] = ACTIONS(2955),
    [anon_sym_LPAREN2] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2955),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym___extension__] = ACTIONS(2955),
    [anon_sym_typedef] = ACTIONS(2955),
    [anon_sym_virtual] = ACTIONS(2955),
    [anon_sym_extern] = ACTIONS(2955),
    [anon_sym___attribute__] = ACTIONS(2955),
    [anon_sym___attribute] = ACTIONS(2955),
    [anon_sym_using] = ACTIONS(2955),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2957),
    [anon_sym___declspec] = ACTIONS(2955),
    [anon_sym___based] = ACTIONS(2955),
    [anon_sym___cdecl] = ACTIONS(2955),
    [anon_sym___clrcall] = ACTIONS(2955),
    [anon_sym___stdcall] = ACTIONS(2955),
    [anon_sym___fastcall] = ACTIONS(2955),
    [anon_sym___thiscall] = ACTIONS(2955),
    [anon_sym___vectorcall] = ACTIONS(2955),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_signed] = ACTIONS(2955),
    [anon_sym_unsigned] = ACTIONS(2955),
    [anon_sym_long] = ACTIONS(2955),
    [anon_sym_short] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_register] = ACTIONS(2955),
    [anon_sym_inline] = ACTIONS(2955),
    [anon_sym___inline] = ACTIONS(2955),
    [anon_sym___inline__] = ACTIONS(2955),
    [anon_sym___forceinline] = ACTIONS(2955),
    [anon_sym_thread_local] = ACTIONS(2955),
    [anon_sym___thread] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_constexpr] = ACTIONS(2955),
    [anon_sym_volatile] = ACTIONS(2955),
    [anon_sym_restrict] = ACTIONS(2955),
    [anon_sym___restrict__] = ACTIONS(2955),
    [anon_sym__Atomic] = ACTIONS(2955),
    [anon_sym__Noreturn] = ACTIONS(2955),
    [anon_sym_noreturn] = ACTIONS(2955),
    [anon_sym__Nonnull] = ACTIONS(2955),
    [anon_sym_mutable] = ACTIONS(2955),
    [anon_sym_constinit] = ACTIONS(2955),
    [anon_sym_consteval] = ACTIONS(2955),
    [anon_sym_alignas] = ACTIONS(2955),
    [anon_sym__Alignas] = ACTIONS(2955),
    [sym_primitive_type] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2955),
    [anon_sym_union] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2955),
    [anon_sym_switch] = ACTIONS(2955),
    [anon_sym_case] = ACTIONS(2955),
    [anon_sym_default] = ACTIONS(2955),
    [anon_sym_while] = ACTIONS(2955),
    [anon_sym_do] = ACTIONS(2955),
    [anon_sym_for] = ACTIONS(2955),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_break] = ACTIONS(2955),
    [anon_sym_continue] = ACTIONS(2955),
    [anon_sym_goto] = ACTIONS(2955),
    [anon_sym___try] = ACTIONS(2955),
    [anon_sym___leave] = ACTIONS(2955),
    [anon_sym_not] = ACTIONS(2955),
    [anon_sym_compl] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_sizeof] = ACTIONS(2955),
    [anon_sym___alignof__] = ACTIONS(2955),
    [anon_sym___alignof] = ACTIONS(2955),
    [anon_sym__alignof] = ACTIONS(2955),
    [anon_sym_alignof] = ACTIONS(2955),
    [anon_sym__Alignof] = ACTIONS(2955),
    [anon_sym_offsetof] = ACTIONS(2955),
    [anon_sym__Generic] = ACTIONS(2955),
    [anon_sym_asm] = ACTIONS(2955),
    [anon_sym___asm__] = ACTIONS(2955),
    [anon_sym___asm] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(2957),
    [anon_sym_L_SQUOTE] = ACTIONS(2957),
    [anon_sym_u_SQUOTE] = ACTIONS(2957),
    [anon_sym_U_SQUOTE] = ACTIONS(2957),
    [anon_sym_u8_SQUOTE] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2955),
    [sym_false] = ACTIONS(2955),
    [anon_sym_NULL] = ACTIONS(2955),
    [anon_sym_nullptr] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2955),
    [anon_sym_decltype] = ACTIONS(2955),
    [anon_sym_explicit] = ACTIONS(2955),
    [anon_sym_typename] = ACTIONS(2955),
    [anon_sym_template] = ACTIONS(2955),
    [anon_sym_operator] = ACTIONS(2955),
    [anon_sym_try] = ACTIONS(2955),
    [anon_sym_delete] = ACTIONS(2955),
    [anon_sym_throw] = ACTIONS(2955),
    [anon_sym_namespace] = ACTIONS(2955),
    [anon_sym_static_assert] = ACTIONS(2955),
    [anon_sym_concept] = ACTIONS(2955),
    [anon_sym_co_return] = ACTIONS(2955),
    [anon_sym_co_yield] = ACTIONS(2955),
    [anon_sym_R_DQUOTE] = ACTIONS(2957),
    [anon_sym_LR_DQUOTE] = ACTIONS(2957),
    [anon_sym_uR_DQUOTE] = ACTIONS(2957),
    [anon_sym_UR_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2957),
    [anon_sym_co_await] = ACTIONS(2955),
    [anon_sym_new] = ACTIONS(2955),
    [anon_sym_requires] = ACTIONS(2955),
    [sym_this] = ACTIONS(2955),
  },
  [339] = {
    [sym_preproc_def] = STATE(379),
    [sym_preproc_function_def] = STATE(379),
    [sym_preproc_call] = STATE(379),
    [sym_preproc_if_in_field_declaration_list] = STATE(379),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(379),
    [sym_preproc_else_in_field_declaration_list] = STATE(8222),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8222),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8222),
    [sym_type_definition] = STATE(379),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(379),
    [sym_field_declaration] = STATE(379),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(379),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(379),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(379),
    [sym_operator_cast_declaration] = STATE(379),
    [sym_constructor_or_destructor_definition] = STATE(379),
    [sym_constructor_or_destructor_declaration] = STATE(379),
    [sym_friend_declaration] = STATE(379),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(379),
    [sym_alias_declaration] = STATE(379),
    [sym_static_assert_declaration] = STATE(379),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(379),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(2965),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [340] = {
    [sym_identifier] = ACTIONS(3019),
    [aux_sym_preproc_include_token1] = ACTIONS(3019),
    [aux_sym_preproc_def_token1] = ACTIONS(3019),
    [aux_sym_preproc_if_token1] = ACTIONS(3019),
    [aux_sym_preproc_if_token2] = ACTIONS(3019),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3019),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3019),
    [aux_sym_preproc_else_token1] = ACTIONS(3019),
    [aux_sym_preproc_elif_token1] = ACTIONS(3019),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3019),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3019),
    [sym_preproc_directive] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_STAR] = ACTIONS(3021),
    [anon_sym_AMP_AMP] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_SEMI] = ACTIONS(3021),
    [anon_sym___extension__] = ACTIONS(3019),
    [anon_sym_typedef] = ACTIONS(3019),
    [anon_sym_virtual] = ACTIONS(3019),
    [anon_sym_extern] = ACTIONS(3019),
    [anon_sym___attribute__] = ACTIONS(3019),
    [anon_sym___attribute] = ACTIONS(3019),
    [anon_sym_using] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3021),
    [anon_sym___declspec] = ACTIONS(3019),
    [anon_sym___based] = ACTIONS(3019),
    [anon_sym___cdecl] = ACTIONS(3019),
    [anon_sym___clrcall] = ACTIONS(3019),
    [anon_sym___stdcall] = ACTIONS(3019),
    [anon_sym___fastcall] = ACTIONS(3019),
    [anon_sym___thiscall] = ACTIONS(3019),
    [anon_sym___vectorcall] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3021),
    [anon_sym_signed] = ACTIONS(3019),
    [anon_sym_unsigned] = ACTIONS(3019),
    [anon_sym_long] = ACTIONS(3019),
    [anon_sym_short] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_static] = ACTIONS(3019),
    [anon_sym_register] = ACTIONS(3019),
    [anon_sym_inline] = ACTIONS(3019),
    [anon_sym___inline] = ACTIONS(3019),
    [anon_sym___inline__] = ACTIONS(3019),
    [anon_sym___forceinline] = ACTIONS(3019),
    [anon_sym_thread_local] = ACTIONS(3019),
    [anon_sym___thread] = ACTIONS(3019),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_constexpr] = ACTIONS(3019),
    [anon_sym_volatile] = ACTIONS(3019),
    [anon_sym_restrict] = ACTIONS(3019),
    [anon_sym___restrict__] = ACTIONS(3019),
    [anon_sym__Atomic] = ACTIONS(3019),
    [anon_sym__Noreturn] = ACTIONS(3019),
    [anon_sym_noreturn] = ACTIONS(3019),
    [anon_sym__Nonnull] = ACTIONS(3019),
    [anon_sym_mutable] = ACTIONS(3019),
    [anon_sym_constinit] = ACTIONS(3019),
    [anon_sym_consteval] = ACTIONS(3019),
    [anon_sym_alignas] = ACTIONS(3019),
    [anon_sym__Alignas] = ACTIONS(3019),
    [sym_primitive_type] = ACTIONS(3019),
    [anon_sym_enum] = ACTIONS(3019),
    [anon_sym_class] = ACTIONS(3019),
    [anon_sym_struct] = ACTIONS(3019),
    [anon_sym_union] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_switch] = ACTIONS(3019),
    [anon_sym_case] = ACTIONS(3019),
    [anon_sym_default] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_break] = ACTIONS(3019),
    [anon_sym_continue] = ACTIONS(3019),
    [anon_sym_goto] = ACTIONS(3019),
    [anon_sym___try] = ACTIONS(3019),
    [anon_sym___leave] = ACTIONS(3019),
    [anon_sym_not] = ACTIONS(3019),
    [anon_sym_compl] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3021),
    [anon_sym_sizeof] = ACTIONS(3019),
    [anon_sym___alignof__] = ACTIONS(3019),
    [anon_sym___alignof] = ACTIONS(3019),
    [anon_sym__alignof] = ACTIONS(3019),
    [anon_sym_alignof] = ACTIONS(3019),
    [anon_sym__Alignof] = ACTIONS(3019),
    [anon_sym_offsetof] = ACTIONS(3019),
    [anon_sym__Generic] = ACTIONS(3019),
    [anon_sym_asm] = ACTIONS(3019),
    [anon_sym___asm__] = ACTIONS(3019),
    [anon_sym___asm] = ACTIONS(3019),
    [sym_number_literal] = ACTIONS(3021),
    [anon_sym_L_SQUOTE] = ACTIONS(3021),
    [anon_sym_u_SQUOTE] = ACTIONS(3021),
    [anon_sym_U_SQUOTE] = ACTIONS(3021),
    [anon_sym_u8_SQUOTE] = ACTIONS(3021),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [anon_sym_L_DQUOTE] = ACTIONS(3021),
    [anon_sym_u_DQUOTE] = ACTIONS(3021),
    [anon_sym_U_DQUOTE] = ACTIONS(3021),
    [anon_sym_u8_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE] = ACTIONS(3021),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [anon_sym_NULL] = ACTIONS(3019),
    [anon_sym_nullptr] = ACTIONS(3019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3019),
    [anon_sym_decltype] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_typename] = ACTIONS(3019),
    [anon_sym_template] = ACTIONS(3019),
    [anon_sym_operator] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_delete] = ACTIONS(3019),
    [anon_sym_throw] = ACTIONS(3019),
    [anon_sym_namespace] = ACTIONS(3019),
    [anon_sym_static_assert] = ACTIONS(3019),
    [anon_sym_concept] = ACTIONS(3019),
    [anon_sym_co_return] = ACTIONS(3019),
    [anon_sym_co_yield] = ACTIONS(3019),
    [anon_sym_R_DQUOTE] = ACTIONS(3021),
    [anon_sym_LR_DQUOTE] = ACTIONS(3021),
    [anon_sym_uR_DQUOTE] = ACTIONS(3021),
    [anon_sym_UR_DQUOTE] = ACTIONS(3021),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3021),
    [anon_sym_co_await] = ACTIONS(3019),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_requires] = ACTIONS(3019),
    [sym_this] = ACTIONS(3019),
  },
  [341] = {
    [sym_identifier] = ACTIONS(3023),
    [aux_sym_preproc_include_token1] = ACTIONS(3023),
    [aux_sym_preproc_def_token1] = ACTIONS(3023),
    [aux_sym_preproc_if_token1] = ACTIONS(3023),
    [aux_sym_preproc_if_token2] = ACTIONS(3023),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3023),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3023),
    [aux_sym_preproc_else_token1] = ACTIONS(3023),
    [aux_sym_preproc_elif_token1] = ACTIONS(3023),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3023),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3023),
    [sym_preproc_directive] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3025),
    [anon_sym_BANG] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(3025),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_STAR] = ACTIONS(3025),
    [anon_sym_AMP_AMP] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym___extension__] = ACTIONS(3023),
    [anon_sym_typedef] = ACTIONS(3023),
    [anon_sym_virtual] = ACTIONS(3023),
    [anon_sym_extern] = ACTIONS(3023),
    [anon_sym___attribute__] = ACTIONS(3023),
    [anon_sym___attribute] = ACTIONS(3023),
    [anon_sym_using] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3025),
    [anon_sym___declspec] = ACTIONS(3023),
    [anon_sym___based] = ACTIONS(3023),
    [anon_sym___cdecl] = ACTIONS(3023),
    [anon_sym___clrcall] = ACTIONS(3023),
    [anon_sym___stdcall] = ACTIONS(3023),
    [anon_sym___fastcall] = ACTIONS(3023),
    [anon_sym___thiscall] = ACTIONS(3023),
    [anon_sym___vectorcall] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3025),
    [anon_sym_signed] = ACTIONS(3023),
    [anon_sym_unsigned] = ACTIONS(3023),
    [anon_sym_long] = ACTIONS(3023),
    [anon_sym_short] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3023),
    [anon_sym_register] = ACTIONS(3023),
    [anon_sym_inline] = ACTIONS(3023),
    [anon_sym___inline] = ACTIONS(3023),
    [anon_sym___inline__] = ACTIONS(3023),
    [anon_sym___forceinline] = ACTIONS(3023),
    [anon_sym_thread_local] = ACTIONS(3023),
    [anon_sym___thread] = ACTIONS(3023),
    [anon_sym_const] = ACTIONS(3023),
    [anon_sym_constexpr] = ACTIONS(3023),
    [anon_sym_volatile] = ACTIONS(3023),
    [anon_sym_restrict] = ACTIONS(3023),
    [anon_sym___restrict__] = ACTIONS(3023),
    [anon_sym__Atomic] = ACTIONS(3023),
    [anon_sym__Noreturn] = ACTIONS(3023),
    [anon_sym_noreturn] = ACTIONS(3023),
    [anon_sym__Nonnull] = ACTIONS(3023),
    [anon_sym_mutable] = ACTIONS(3023),
    [anon_sym_constinit] = ACTIONS(3023),
    [anon_sym_consteval] = ACTIONS(3023),
    [anon_sym_alignas] = ACTIONS(3023),
    [anon_sym__Alignas] = ACTIONS(3023),
    [sym_primitive_type] = ACTIONS(3023),
    [anon_sym_enum] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3023),
    [anon_sym_struct] = ACTIONS(3023),
    [anon_sym_union] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_switch] = ACTIONS(3023),
    [anon_sym_case] = ACTIONS(3023),
    [anon_sym_default] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_break] = ACTIONS(3023),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_goto] = ACTIONS(3023),
    [anon_sym___try] = ACTIONS(3023),
    [anon_sym___leave] = ACTIONS(3023),
    [anon_sym_not] = ACTIONS(3023),
    [anon_sym_compl] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3025),
    [anon_sym_PLUS_PLUS] = ACTIONS(3025),
    [anon_sym_sizeof] = ACTIONS(3023),
    [anon_sym___alignof__] = ACTIONS(3023),
    [anon_sym___alignof] = ACTIONS(3023),
    [anon_sym__alignof] = ACTIONS(3023),
    [anon_sym_alignof] = ACTIONS(3023),
    [anon_sym__Alignof] = ACTIONS(3023),
    [anon_sym_offsetof] = ACTIONS(3023),
    [anon_sym__Generic] = ACTIONS(3023),
    [anon_sym_asm] = ACTIONS(3023),
    [anon_sym___asm__] = ACTIONS(3023),
    [anon_sym___asm] = ACTIONS(3023),
    [sym_number_literal] = ACTIONS(3025),
    [anon_sym_L_SQUOTE] = ACTIONS(3025),
    [anon_sym_u_SQUOTE] = ACTIONS(3025),
    [anon_sym_U_SQUOTE] = ACTIONS(3025),
    [anon_sym_u8_SQUOTE] = ACTIONS(3025),
    [anon_sym_SQUOTE] = ACTIONS(3025),
    [anon_sym_L_DQUOTE] = ACTIONS(3025),
    [anon_sym_u_DQUOTE] = ACTIONS(3025),
    [anon_sym_U_DQUOTE] = ACTIONS(3025),
    [anon_sym_u8_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE] = ACTIONS(3025),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [anon_sym_NULL] = ACTIONS(3023),
    [anon_sym_nullptr] = ACTIONS(3023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3023),
    [anon_sym_decltype] = ACTIONS(3023),
    [anon_sym_explicit] = ACTIONS(3023),
    [anon_sym_typename] = ACTIONS(3023),
    [anon_sym_template] = ACTIONS(3023),
    [anon_sym_operator] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_delete] = ACTIONS(3023),
    [anon_sym_throw] = ACTIONS(3023),
    [anon_sym_namespace] = ACTIONS(3023),
    [anon_sym_static_assert] = ACTIONS(3023),
    [anon_sym_concept] = ACTIONS(3023),
    [anon_sym_co_return] = ACTIONS(3023),
    [anon_sym_co_yield] = ACTIONS(3023),
    [anon_sym_R_DQUOTE] = ACTIONS(3025),
    [anon_sym_LR_DQUOTE] = ACTIONS(3025),
    [anon_sym_uR_DQUOTE] = ACTIONS(3025),
    [anon_sym_UR_DQUOTE] = ACTIONS(3025),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3025),
    [anon_sym_co_await] = ACTIONS(3023),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_requires] = ACTIONS(3023),
    [sym_this] = ACTIONS(3023),
  },
  [342] = {
    [ts_builtin_sym_end] = ACTIONS(2679),
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_virtual] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym___attribute] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym__Nonnull] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [anon_sym___asm] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_export] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(2677),
    [anon_sym_import] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2647),
    [aux_sym_preproc_include_token1] = ACTIONS(2647),
    [aux_sym_preproc_def_token1] = ACTIONS(2647),
    [aux_sym_preproc_if_token1] = ACTIONS(2647),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2647),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2647),
    [sym_preproc_directive] = ACTIONS(2647),
    [anon_sym_LPAREN2] = ACTIONS(2649),
    [anon_sym_BANG] = ACTIONS(2649),
    [anon_sym_TILDE] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2649),
    [anon_sym_AMP_AMP] = ACTIONS(2649),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_SEMI] = ACTIONS(2649),
    [anon_sym___extension__] = ACTIONS(2647),
    [anon_sym_typedef] = ACTIONS(2647),
    [anon_sym_virtual] = ACTIONS(2647),
    [anon_sym_extern] = ACTIONS(2647),
    [anon_sym___attribute__] = ACTIONS(2647),
    [anon_sym___attribute] = ACTIONS(2647),
    [anon_sym_using] = ACTIONS(2647),
    [anon_sym_COLON_COLON] = ACTIONS(2649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2649),
    [anon_sym___declspec] = ACTIONS(2647),
    [anon_sym___based] = ACTIONS(2647),
    [anon_sym___cdecl] = ACTIONS(2647),
    [anon_sym___clrcall] = ACTIONS(2647),
    [anon_sym___stdcall] = ACTIONS(2647),
    [anon_sym___fastcall] = ACTIONS(2647),
    [anon_sym___thiscall] = ACTIONS(2647),
    [anon_sym___vectorcall] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2649),
    [anon_sym_signed] = ACTIONS(2647),
    [anon_sym_unsigned] = ACTIONS(2647),
    [anon_sym_long] = ACTIONS(2647),
    [anon_sym_short] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2647),
    [anon_sym_static] = ACTIONS(2647),
    [anon_sym_register] = ACTIONS(2647),
    [anon_sym_inline] = ACTIONS(2647),
    [anon_sym___inline] = ACTIONS(2647),
    [anon_sym___inline__] = ACTIONS(2647),
    [anon_sym___forceinline] = ACTIONS(2647),
    [anon_sym_thread_local] = ACTIONS(2647),
    [anon_sym___thread] = ACTIONS(2647),
    [anon_sym_const] = ACTIONS(2647),
    [anon_sym_constexpr] = ACTIONS(2647),
    [anon_sym_volatile] = ACTIONS(2647),
    [anon_sym_restrict] = ACTIONS(2647),
    [anon_sym___restrict__] = ACTIONS(2647),
    [anon_sym__Atomic] = ACTIONS(2647),
    [anon_sym__Noreturn] = ACTIONS(2647),
    [anon_sym_noreturn] = ACTIONS(2647),
    [anon_sym__Nonnull] = ACTIONS(2647),
    [anon_sym_mutable] = ACTIONS(2647),
    [anon_sym_constinit] = ACTIONS(2647),
    [anon_sym_consteval] = ACTIONS(2647),
    [anon_sym_alignas] = ACTIONS(2647),
    [anon_sym__Alignas] = ACTIONS(2647),
    [sym_primitive_type] = ACTIONS(2647),
    [anon_sym_enum] = ACTIONS(2647),
    [anon_sym_class] = ACTIONS(2647),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_union] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_else] = ACTIONS(2647),
    [anon_sym_switch] = ACTIONS(2647),
    [anon_sym_case] = ACTIONS(2647),
    [anon_sym_default] = ACTIONS(2647),
    [anon_sym_while] = ACTIONS(2647),
    [anon_sym_do] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_return] = ACTIONS(2647),
    [anon_sym_break] = ACTIONS(2647),
    [anon_sym_continue] = ACTIONS(2647),
    [anon_sym_goto] = ACTIONS(2647),
    [anon_sym___try] = ACTIONS(2647),
    [anon_sym___leave] = ACTIONS(2647),
    [anon_sym_not] = ACTIONS(2647),
    [anon_sym_compl] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2649),
    [anon_sym_PLUS_PLUS] = ACTIONS(2649),
    [anon_sym_sizeof] = ACTIONS(2647),
    [anon_sym___alignof__] = ACTIONS(2647),
    [anon_sym___alignof] = ACTIONS(2647),
    [anon_sym__alignof] = ACTIONS(2647),
    [anon_sym_alignof] = ACTIONS(2647),
    [anon_sym__Alignof] = ACTIONS(2647),
    [anon_sym_offsetof] = ACTIONS(2647),
    [anon_sym__Generic] = ACTIONS(2647),
    [anon_sym_asm] = ACTIONS(2647),
    [anon_sym___asm__] = ACTIONS(2647),
    [anon_sym___asm] = ACTIONS(2647),
    [sym_number_literal] = ACTIONS(2649),
    [anon_sym_L_SQUOTE] = ACTIONS(2649),
    [anon_sym_u_SQUOTE] = ACTIONS(2649),
    [anon_sym_U_SQUOTE] = ACTIONS(2649),
    [anon_sym_u8_SQUOTE] = ACTIONS(2649),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_L_DQUOTE] = ACTIONS(2649),
    [anon_sym_u_DQUOTE] = ACTIONS(2649),
    [anon_sym_U_DQUOTE] = ACTIONS(2649),
    [anon_sym_u8_DQUOTE] = ACTIONS(2649),
    [anon_sym_DQUOTE] = ACTIONS(2649),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [anon_sym_NULL] = ACTIONS(2647),
    [anon_sym_nullptr] = ACTIONS(2647),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2647),
    [anon_sym_decltype] = ACTIONS(2647),
    [anon_sym_explicit] = ACTIONS(2647),
    [anon_sym_typename] = ACTIONS(2647),
    [anon_sym_export] = ACTIONS(2647),
    [anon_sym_module] = ACTIONS(2647),
    [anon_sym_import] = ACTIONS(2647),
    [anon_sym_template] = ACTIONS(2647),
    [anon_sym_operator] = ACTIONS(2647),
    [anon_sym_try] = ACTIONS(2647),
    [anon_sym_delete] = ACTIONS(2647),
    [anon_sym_throw] = ACTIONS(2647),
    [anon_sym_namespace] = ACTIONS(2647),
    [anon_sym_static_assert] = ACTIONS(2647),
    [anon_sym_concept] = ACTIONS(2647),
    [anon_sym_co_return] = ACTIONS(2647),
    [anon_sym_co_yield] = ACTIONS(2647),
    [anon_sym_R_DQUOTE] = ACTIONS(2649),
    [anon_sym_LR_DQUOTE] = ACTIONS(2649),
    [anon_sym_uR_DQUOTE] = ACTIONS(2649),
    [anon_sym_UR_DQUOTE] = ACTIONS(2649),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2649),
    [anon_sym_co_await] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(2647),
    [anon_sym_requires] = ACTIONS(2647),
    [sym_this] = ACTIONS(2647),
  },
  [344] = {
    [ts_builtin_sym_end] = ACTIONS(2729),
    [sym_identifier] = ACTIONS(2727),
    [aux_sym_preproc_include_token1] = ACTIONS(2727),
    [aux_sym_preproc_def_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym___extension__] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_virtual] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym___attribute__] = ACTIONS(2727),
    [anon_sym___attribute] = ACTIONS(2727),
    [anon_sym_using] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2729),
    [anon_sym___declspec] = ACTIONS(2727),
    [anon_sym___based] = ACTIONS(2727),
    [anon_sym___cdecl] = ACTIONS(2727),
    [anon_sym___clrcall] = ACTIONS(2727),
    [anon_sym___stdcall] = ACTIONS(2727),
    [anon_sym___fastcall] = ACTIONS(2727),
    [anon_sym___thiscall] = ACTIONS(2727),
    [anon_sym___vectorcall] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_signed] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym___inline] = ACTIONS(2727),
    [anon_sym___inline__] = ACTIONS(2727),
    [anon_sym___forceinline] = ACTIONS(2727),
    [anon_sym_thread_local] = ACTIONS(2727),
    [anon_sym___thread] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_constexpr] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym___restrict__] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym__Noreturn] = ACTIONS(2727),
    [anon_sym_noreturn] = ACTIONS(2727),
    [anon_sym__Nonnull] = ACTIONS(2727),
    [anon_sym_mutable] = ACTIONS(2727),
    [anon_sym_constinit] = ACTIONS(2727),
    [anon_sym_consteval] = ACTIONS(2727),
    [anon_sym_alignas] = ACTIONS(2727),
    [anon_sym__Alignas] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_else] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym___try] = ACTIONS(2727),
    [anon_sym___leave] = ACTIONS(2727),
    [anon_sym_not] = ACTIONS(2727),
    [anon_sym_compl] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [anon_sym___alignof__] = ACTIONS(2727),
    [anon_sym___alignof] = ACTIONS(2727),
    [anon_sym__alignof] = ACTIONS(2727),
    [anon_sym_alignof] = ACTIONS(2727),
    [anon_sym__Alignof] = ACTIONS(2727),
    [anon_sym_offsetof] = ACTIONS(2727),
    [anon_sym__Generic] = ACTIONS(2727),
    [anon_sym_asm] = ACTIONS(2727),
    [anon_sym___asm__] = ACTIONS(2727),
    [anon_sym___asm] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [anon_sym_L_SQUOTE] = ACTIONS(2729),
    [anon_sym_u_SQUOTE] = ACTIONS(2729),
    [anon_sym_U_SQUOTE] = ACTIONS(2729),
    [anon_sym_u8_SQUOTE] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_L_DQUOTE] = ACTIONS(2729),
    [anon_sym_u_DQUOTE] = ACTIONS(2729),
    [anon_sym_U_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [anon_sym_NULL] = ACTIONS(2727),
    [anon_sym_nullptr] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2727),
    [anon_sym_decltype] = ACTIONS(2727),
    [anon_sym_explicit] = ACTIONS(2727),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_export] = ACTIONS(2727),
    [anon_sym_module] = ACTIONS(2727),
    [anon_sym_import] = ACTIONS(2727),
    [anon_sym_template] = ACTIONS(2727),
    [anon_sym_operator] = ACTIONS(2727),
    [anon_sym_try] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2727),
    [anon_sym_throw] = ACTIONS(2727),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_static_assert] = ACTIONS(2727),
    [anon_sym_concept] = ACTIONS(2727),
    [anon_sym_co_return] = ACTIONS(2727),
    [anon_sym_co_yield] = ACTIONS(2727),
    [anon_sym_R_DQUOTE] = ACTIONS(2729),
    [anon_sym_LR_DQUOTE] = ACTIONS(2729),
    [anon_sym_uR_DQUOTE] = ACTIONS(2729),
    [anon_sym_UR_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2729),
    [anon_sym_co_await] = ACTIONS(2727),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_requires] = ACTIONS(2727),
    [sym_this] = ACTIONS(2727),
  },
  [345] = {
    [ts_builtin_sym_end] = ACTIONS(2757),
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym___attribute] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym__Nonnull] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym__Alignas] = ACTIONS(2755),
    [sym_primitive_type] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [anon_sym___asm] = ACTIONS(2755),
    [sym_number_literal] = ACTIONS(2757),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_export] = ACTIONS(2755),
    [anon_sym_module] = ACTIONS(2755),
    [anon_sym_import] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [346] = {
    [sym_identifier] = ACTIONS(3027),
    [aux_sym_preproc_include_token1] = ACTIONS(3027),
    [aux_sym_preproc_def_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token2] = ACTIONS(3027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3027),
    [aux_sym_preproc_else_token1] = ACTIONS(3027),
    [aux_sym_preproc_elif_token1] = ACTIONS(3027),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3027),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3027),
    [sym_preproc_directive] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3029),
    [anon_sym_BANG] = ACTIONS(3029),
    [anon_sym_TILDE] = ACTIONS(3029),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3029),
    [anon_sym_AMP_AMP] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_SEMI] = ACTIONS(3029),
    [anon_sym___extension__] = ACTIONS(3027),
    [anon_sym_typedef] = ACTIONS(3027),
    [anon_sym_virtual] = ACTIONS(3027),
    [anon_sym_extern] = ACTIONS(3027),
    [anon_sym___attribute__] = ACTIONS(3027),
    [anon_sym___attribute] = ACTIONS(3027),
    [anon_sym_using] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3029),
    [anon_sym___declspec] = ACTIONS(3027),
    [anon_sym___based] = ACTIONS(3027),
    [anon_sym___cdecl] = ACTIONS(3027),
    [anon_sym___clrcall] = ACTIONS(3027),
    [anon_sym___stdcall] = ACTIONS(3027),
    [anon_sym___fastcall] = ACTIONS(3027),
    [anon_sym___thiscall] = ACTIONS(3027),
    [anon_sym___vectorcall] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_signed] = ACTIONS(3027),
    [anon_sym_unsigned] = ACTIONS(3027),
    [anon_sym_long] = ACTIONS(3027),
    [anon_sym_short] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_static] = ACTIONS(3027),
    [anon_sym_register] = ACTIONS(3027),
    [anon_sym_inline] = ACTIONS(3027),
    [anon_sym___inline] = ACTIONS(3027),
    [anon_sym___inline__] = ACTIONS(3027),
    [anon_sym___forceinline] = ACTIONS(3027),
    [anon_sym_thread_local] = ACTIONS(3027),
    [anon_sym___thread] = ACTIONS(3027),
    [anon_sym_const] = ACTIONS(3027),
    [anon_sym_constexpr] = ACTIONS(3027),
    [anon_sym_volatile] = ACTIONS(3027),
    [anon_sym_restrict] = ACTIONS(3027),
    [anon_sym___restrict__] = ACTIONS(3027),
    [anon_sym__Atomic] = ACTIONS(3027),
    [anon_sym__Noreturn] = ACTIONS(3027),
    [anon_sym_noreturn] = ACTIONS(3027),
    [anon_sym__Nonnull] = ACTIONS(3027),
    [anon_sym_mutable] = ACTIONS(3027),
    [anon_sym_constinit] = ACTIONS(3027),
    [anon_sym_consteval] = ACTIONS(3027),
    [anon_sym_alignas] = ACTIONS(3027),
    [anon_sym__Alignas] = ACTIONS(3027),
    [sym_primitive_type] = ACTIONS(3027),
    [anon_sym_enum] = ACTIONS(3027),
    [anon_sym_class] = ACTIONS(3027),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_union] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_switch] = ACTIONS(3027),
    [anon_sym_case] = ACTIONS(3027),
    [anon_sym_default] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_goto] = ACTIONS(3027),
    [anon_sym___try] = ACTIONS(3027),
    [anon_sym___leave] = ACTIONS(3027),
    [anon_sym_not] = ACTIONS(3027),
    [anon_sym_compl] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3029),
    [anon_sym_PLUS_PLUS] = ACTIONS(3029),
    [anon_sym_sizeof] = ACTIONS(3027),
    [anon_sym___alignof__] = ACTIONS(3027),
    [anon_sym___alignof] = ACTIONS(3027),
    [anon_sym__alignof] = ACTIONS(3027),
    [anon_sym_alignof] = ACTIONS(3027),
    [anon_sym__Alignof] = ACTIONS(3027),
    [anon_sym_offsetof] = ACTIONS(3027),
    [anon_sym__Generic] = ACTIONS(3027),
    [anon_sym_asm] = ACTIONS(3027),
    [anon_sym___asm__] = ACTIONS(3027),
    [anon_sym___asm] = ACTIONS(3027),
    [sym_number_literal] = ACTIONS(3029),
    [anon_sym_L_SQUOTE] = ACTIONS(3029),
    [anon_sym_u_SQUOTE] = ACTIONS(3029),
    [anon_sym_U_SQUOTE] = ACTIONS(3029),
    [anon_sym_u8_SQUOTE] = ACTIONS(3029),
    [anon_sym_SQUOTE] = ACTIONS(3029),
    [anon_sym_L_DQUOTE] = ACTIONS(3029),
    [anon_sym_u_DQUOTE] = ACTIONS(3029),
    [anon_sym_U_DQUOTE] = ACTIONS(3029),
    [anon_sym_u8_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE] = ACTIONS(3029),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [anon_sym_NULL] = ACTIONS(3027),
    [anon_sym_nullptr] = ACTIONS(3027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3027),
    [anon_sym_decltype] = ACTIONS(3027),
    [anon_sym_explicit] = ACTIONS(3027),
    [anon_sym_typename] = ACTIONS(3027),
    [anon_sym_template] = ACTIONS(3027),
    [anon_sym_operator] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_delete] = ACTIONS(3027),
    [anon_sym_throw] = ACTIONS(3027),
    [anon_sym_namespace] = ACTIONS(3027),
    [anon_sym_static_assert] = ACTIONS(3027),
    [anon_sym_concept] = ACTIONS(3027),
    [anon_sym_co_return] = ACTIONS(3027),
    [anon_sym_co_yield] = ACTIONS(3027),
    [anon_sym_R_DQUOTE] = ACTIONS(3029),
    [anon_sym_LR_DQUOTE] = ACTIONS(3029),
    [anon_sym_uR_DQUOTE] = ACTIONS(3029),
    [anon_sym_UR_DQUOTE] = ACTIONS(3029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3029),
    [anon_sym_co_await] = ACTIONS(3027),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_requires] = ACTIONS(3027),
    [sym_this] = ACTIONS(3027),
  },
  [347] = {
    [sym_identifier] = ACTIONS(3031),
    [aux_sym_preproc_include_token1] = ACTIONS(3031),
    [aux_sym_preproc_def_token1] = ACTIONS(3031),
    [aux_sym_preproc_if_token1] = ACTIONS(3031),
    [aux_sym_preproc_if_token2] = ACTIONS(3031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3031),
    [aux_sym_preproc_else_token1] = ACTIONS(3031),
    [aux_sym_preproc_elif_token1] = ACTIONS(3031),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3031),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3031),
    [sym_preproc_directive] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3033),
    [anon_sym_BANG] = ACTIONS(3033),
    [anon_sym_TILDE] = ACTIONS(3033),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_SEMI] = ACTIONS(3033),
    [anon_sym___extension__] = ACTIONS(3031),
    [anon_sym_typedef] = ACTIONS(3031),
    [anon_sym_virtual] = ACTIONS(3031),
    [anon_sym_extern] = ACTIONS(3031),
    [anon_sym___attribute__] = ACTIONS(3031),
    [anon_sym___attribute] = ACTIONS(3031),
    [anon_sym_using] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3033),
    [anon_sym___declspec] = ACTIONS(3031),
    [anon_sym___based] = ACTIONS(3031),
    [anon_sym___cdecl] = ACTIONS(3031),
    [anon_sym___clrcall] = ACTIONS(3031),
    [anon_sym___stdcall] = ACTIONS(3031),
    [anon_sym___fastcall] = ACTIONS(3031),
    [anon_sym___thiscall] = ACTIONS(3031),
    [anon_sym___vectorcall] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3033),
    [anon_sym_signed] = ACTIONS(3031),
    [anon_sym_unsigned] = ACTIONS(3031),
    [anon_sym_long] = ACTIONS(3031),
    [anon_sym_short] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_static] = ACTIONS(3031),
    [anon_sym_register] = ACTIONS(3031),
    [anon_sym_inline] = ACTIONS(3031),
    [anon_sym___inline] = ACTIONS(3031),
    [anon_sym___inline__] = ACTIONS(3031),
    [anon_sym___forceinline] = ACTIONS(3031),
    [anon_sym_thread_local] = ACTIONS(3031),
    [anon_sym___thread] = ACTIONS(3031),
    [anon_sym_const] = ACTIONS(3031),
    [anon_sym_constexpr] = ACTIONS(3031),
    [anon_sym_volatile] = ACTIONS(3031),
    [anon_sym_restrict] = ACTIONS(3031),
    [anon_sym___restrict__] = ACTIONS(3031),
    [anon_sym__Atomic] = ACTIONS(3031),
    [anon_sym__Noreturn] = ACTIONS(3031),
    [anon_sym_noreturn] = ACTIONS(3031),
    [anon_sym__Nonnull] = ACTIONS(3031),
    [anon_sym_mutable] = ACTIONS(3031),
    [anon_sym_constinit] = ACTIONS(3031),
    [anon_sym_consteval] = ACTIONS(3031),
    [anon_sym_alignas] = ACTIONS(3031),
    [anon_sym__Alignas] = ACTIONS(3031),
    [sym_primitive_type] = ACTIONS(3031),
    [anon_sym_enum] = ACTIONS(3031),
    [anon_sym_class] = ACTIONS(3031),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_union] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_switch] = ACTIONS(3031),
    [anon_sym_case] = ACTIONS(3031),
    [anon_sym_default] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_goto] = ACTIONS(3031),
    [anon_sym___try] = ACTIONS(3031),
    [anon_sym___leave] = ACTIONS(3031),
    [anon_sym_not] = ACTIONS(3031),
    [anon_sym_compl] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3033),
    [anon_sym_PLUS_PLUS] = ACTIONS(3033),
    [anon_sym_sizeof] = ACTIONS(3031),
    [anon_sym___alignof__] = ACTIONS(3031),
    [anon_sym___alignof] = ACTIONS(3031),
    [anon_sym__alignof] = ACTIONS(3031),
    [anon_sym_alignof] = ACTIONS(3031),
    [anon_sym__Alignof] = ACTIONS(3031),
    [anon_sym_offsetof] = ACTIONS(3031),
    [anon_sym__Generic] = ACTIONS(3031),
    [anon_sym_asm] = ACTIONS(3031),
    [anon_sym___asm__] = ACTIONS(3031),
    [anon_sym___asm] = ACTIONS(3031),
    [sym_number_literal] = ACTIONS(3033),
    [anon_sym_L_SQUOTE] = ACTIONS(3033),
    [anon_sym_u_SQUOTE] = ACTIONS(3033),
    [anon_sym_U_SQUOTE] = ACTIONS(3033),
    [anon_sym_u8_SQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3033),
    [anon_sym_L_DQUOTE] = ACTIONS(3033),
    [anon_sym_u_DQUOTE] = ACTIONS(3033),
    [anon_sym_U_DQUOTE] = ACTIONS(3033),
    [anon_sym_u8_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [anon_sym_NULL] = ACTIONS(3031),
    [anon_sym_nullptr] = ACTIONS(3031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3031),
    [anon_sym_decltype] = ACTIONS(3031),
    [anon_sym_explicit] = ACTIONS(3031),
    [anon_sym_typename] = ACTIONS(3031),
    [anon_sym_template] = ACTIONS(3031),
    [anon_sym_operator] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_delete] = ACTIONS(3031),
    [anon_sym_throw] = ACTIONS(3031),
    [anon_sym_namespace] = ACTIONS(3031),
    [anon_sym_static_assert] = ACTIONS(3031),
    [anon_sym_concept] = ACTIONS(3031),
    [anon_sym_co_return] = ACTIONS(3031),
    [anon_sym_co_yield] = ACTIONS(3031),
    [anon_sym_R_DQUOTE] = ACTIONS(3033),
    [anon_sym_LR_DQUOTE] = ACTIONS(3033),
    [anon_sym_uR_DQUOTE] = ACTIONS(3033),
    [anon_sym_UR_DQUOTE] = ACTIONS(3033),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3033),
    [anon_sym_co_await] = ACTIONS(3031),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_requires] = ACTIONS(3031),
    [sym_this] = ACTIONS(3031),
  },
  [348] = {
    [sym_identifier] = ACTIONS(3035),
    [aux_sym_preproc_include_token1] = ACTIONS(3035),
    [aux_sym_preproc_def_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token2] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3035),
    [aux_sym_preproc_else_token1] = ACTIONS(3035),
    [aux_sym_preproc_elif_token1] = ACTIONS(3035),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3035),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3035),
    [sym_preproc_directive] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3037),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_AMP_AMP] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_SEMI] = ACTIONS(3037),
    [anon_sym___extension__] = ACTIONS(3035),
    [anon_sym_typedef] = ACTIONS(3035),
    [anon_sym_virtual] = ACTIONS(3035),
    [anon_sym_extern] = ACTIONS(3035),
    [anon_sym___attribute__] = ACTIONS(3035),
    [anon_sym___attribute] = ACTIONS(3035),
    [anon_sym_using] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3037),
    [anon_sym___declspec] = ACTIONS(3035),
    [anon_sym___based] = ACTIONS(3035),
    [anon_sym___cdecl] = ACTIONS(3035),
    [anon_sym___clrcall] = ACTIONS(3035),
    [anon_sym___stdcall] = ACTIONS(3035),
    [anon_sym___fastcall] = ACTIONS(3035),
    [anon_sym___thiscall] = ACTIONS(3035),
    [anon_sym___vectorcall] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3037),
    [anon_sym_signed] = ACTIONS(3035),
    [anon_sym_unsigned] = ACTIONS(3035),
    [anon_sym_long] = ACTIONS(3035),
    [anon_sym_short] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3035),
    [anon_sym_register] = ACTIONS(3035),
    [anon_sym_inline] = ACTIONS(3035),
    [anon_sym___inline] = ACTIONS(3035),
    [anon_sym___inline__] = ACTIONS(3035),
    [anon_sym___forceinline] = ACTIONS(3035),
    [anon_sym_thread_local] = ACTIONS(3035),
    [anon_sym___thread] = ACTIONS(3035),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_constexpr] = ACTIONS(3035),
    [anon_sym_volatile] = ACTIONS(3035),
    [anon_sym_restrict] = ACTIONS(3035),
    [anon_sym___restrict__] = ACTIONS(3035),
    [anon_sym__Atomic] = ACTIONS(3035),
    [anon_sym__Noreturn] = ACTIONS(3035),
    [anon_sym_noreturn] = ACTIONS(3035),
    [anon_sym__Nonnull] = ACTIONS(3035),
    [anon_sym_mutable] = ACTIONS(3035),
    [anon_sym_constinit] = ACTIONS(3035),
    [anon_sym_consteval] = ACTIONS(3035),
    [anon_sym_alignas] = ACTIONS(3035),
    [anon_sym__Alignas] = ACTIONS(3035),
    [sym_primitive_type] = ACTIONS(3035),
    [anon_sym_enum] = ACTIONS(3035),
    [anon_sym_class] = ACTIONS(3035),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_union] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_switch] = ACTIONS(3035),
    [anon_sym_case] = ACTIONS(3035),
    [anon_sym_default] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_break] = ACTIONS(3035),
    [anon_sym_continue] = ACTIONS(3035),
    [anon_sym_goto] = ACTIONS(3035),
    [anon_sym___try] = ACTIONS(3035),
    [anon_sym___leave] = ACTIONS(3035),
    [anon_sym_not] = ACTIONS(3035),
    [anon_sym_compl] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3037),
    [anon_sym_sizeof] = ACTIONS(3035),
    [anon_sym___alignof__] = ACTIONS(3035),
    [anon_sym___alignof] = ACTIONS(3035),
    [anon_sym__alignof] = ACTIONS(3035),
    [anon_sym_alignof] = ACTIONS(3035),
    [anon_sym__Alignof] = ACTIONS(3035),
    [anon_sym_offsetof] = ACTIONS(3035),
    [anon_sym__Generic] = ACTIONS(3035),
    [anon_sym_asm] = ACTIONS(3035),
    [anon_sym___asm__] = ACTIONS(3035),
    [anon_sym___asm] = ACTIONS(3035),
    [sym_number_literal] = ACTIONS(3037),
    [anon_sym_L_SQUOTE] = ACTIONS(3037),
    [anon_sym_u_SQUOTE] = ACTIONS(3037),
    [anon_sym_U_SQUOTE] = ACTIONS(3037),
    [anon_sym_u8_SQUOTE] = ACTIONS(3037),
    [anon_sym_SQUOTE] = ACTIONS(3037),
    [anon_sym_L_DQUOTE] = ACTIONS(3037),
    [anon_sym_u_DQUOTE] = ACTIONS(3037),
    [anon_sym_U_DQUOTE] = ACTIONS(3037),
    [anon_sym_u8_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE] = ACTIONS(3037),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [anon_sym_NULL] = ACTIONS(3035),
    [anon_sym_nullptr] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3035),
    [anon_sym_decltype] = ACTIONS(3035),
    [anon_sym_explicit] = ACTIONS(3035),
    [anon_sym_typename] = ACTIONS(3035),
    [anon_sym_template] = ACTIONS(3035),
    [anon_sym_operator] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_delete] = ACTIONS(3035),
    [anon_sym_throw] = ACTIONS(3035),
    [anon_sym_namespace] = ACTIONS(3035),
    [anon_sym_static_assert] = ACTIONS(3035),
    [anon_sym_concept] = ACTIONS(3035),
    [anon_sym_co_return] = ACTIONS(3035),
    [anon_sym_co_yield] = ACTIONS(3035),
    [anon_sym_R_DQUOTE] = ACTIONS(3037),
    [anon_sym_LR_DQUOTE] = ACTIONS(3037),
    [anon_sym_uR_DQUOTE] = ACTIONS(3037),
    [anon_sym_UR_DQUOTE] = ACTIONS(3037),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3037),
    [anon_sym_co_await] = ACTIONS(3035),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_requires] = ACTIONS(3035),
    [sym_this] = ACTIONS(3035),
  },
  [349] = {
    [sym_identifier] = ACTIONS(3039),
    [aux_sym_preproc_include_token1] = ACTIONS(3039),
    [aux_sym_preproc_def_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token2] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3039),
    [aux_sym_preproc_else_token1] = ACTIONS(3039),
    [aux_sym_preproc_elif_token1] = ACTIONS(3039),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3039),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3039),
    [sym_preproc_directive] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym___extension__] = ACTIONS(3039),
    [anon_sym_typedef] = ACTIONS(3039),
    [anon_sym_virtual] = ACTIONS(3039),
    [anon_sym_extern] = ACTIONS(3039),
    [anon_sym___attribute__] = ACTIONS(3039),
    [anon_sym___attribute] = ACTIONS(3039),
    [anon_sym_using] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3041),
    [anon_sym___declspec] = ACTIONS(3039),
    [anon_sym___based] = ACTIONS(3039),
    [anon_sym___cdecl] = ACTIONS(3039),
    [anon_sym___clrcall] = ACTIONS(3039),
    [anon_sym___stdcall] = ACTIONS(3039),
    [anon_sym___fastcall] = ACTIONS(3039),
    [anon_sym___thiscall] = ACTIONS(3039),
    [anon_sym___vectorcall] = ACTIONS(3039),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_signed] = ACTIONS(3039),
    [anon_sym_unsigned] = ACTIONS(3039),
    [anon_sym_long] = ACTIONS(3039),
    [anon_sym_short] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3039),
    [anon_sym_register] = ACTIONS(3039),
    [anon_sym_inline] = ACTIONS(3039),
    [anon_sym___inline] = ACTIONS(3039),
    [anon_sym___inline__] = ACTIONS(3039),
    [anon_sym___forceinline] = ACTIONS(3039),
    [anon_sym_thread_local] = ACTIONS(3039),
    [anon_sym___thread] = ACTIONS(3039),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_constexpr] = ACTIONS(3039),
    [anon_sym_volatile] = ACTIONS(3039),
    [anon_sym_restrict] = ACTIONS(3039),
    [anon_sym___restrict__] = ACTIONS(3039),
    [anon_sym__Atomic] = ACTIONS(3039),
    [anon_sym__Noreturn] = ACTIONS(3039),
    [anon_sym_noreturn] = ACTIONS(3039),
    [anon_sym__Nonnull] = ACTIONS(3039),
    [anon_sym_mutable] = ACTIONS(3039),
    [anon_sym_constinit] = ACTIONS(3039),
    [anon_sym_consteval] = ACTIONS(3039),
    [anon_sym_alignas] = ACTIONS(3039),
    [anon_sym__Alignas] = ACTIONS(3039),
    [sym_primitive_type] = ACTIONS(3039),
    [anon_sym_enum] = ACTIONS(3039),
    [anon_sym_class] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3039),
    [anon_sym_union] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_switch] = ACTIONS(3039),
    [anon_sym_case] = ACTIONS(3039),
    [anon_sym_default] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_break] = ACTIONS(3039),
    [anon_sym_continue] = ACTIONS(3039),
    [anon_sym_goto] = ACTIONS(3039),
    [anon_sym___try] = ACTIONS(3039),
    [anon_sym___leave] = ACTIONS(3039),
    [anon_sym_not] = ACTIONS(3039),
    [anon_sym_compl] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3041),
    [anon_sym_sizeof] = ACTIONS(3039),
    [anon_sym___alignof__] = ACTIONS(3039),
    [anon_sym___alignof] = ACTIONS(3039),
    [anon_sym__alignof] = ACTIONS(3039),
    [anon_sym_alignof] = ACTIONS(3039),
    [anon_sym__Alignof] = ACTIONS(3039),
    [anon_sym_offsetof] = ACTIONS(3039),
    [anon_sym__Generic] = ACTIONS(3039),
    [anon_sym_asm] = ACTIONS(3039),
    [anon_sym___asm__] = ACTIONS(3039),
    [anon_sym___asm] = ACTIONS(3039),
    [sym_number_literal] = ACTIONS(3041),
    [anon_sym_L_SQUOTE] = ACTIONS(3041),
    [anon_sym_u_SQUOTE] = ACTIONS(3041),
    [anon_sym_U_SQUOTE] = ACTIONS(3041),
    [anon_sym_u8_SQUOTE] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_L_DQUOTE] = ACTIONS(3041),
    [anon_sym_u_DQUOTE] = ACTIONS(3041),
    [anon_sym_U_DQUOTE] = ACTIONS(3041),
    [anon_sym_u8_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [sym_true] = ACTIONS(3039),
    [sym_false] = ACTIONS(3039),
    [anon_sym_NULL] = ACTIONS(3039),
    [anon_sym_nullptr] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3039),
    [anon_sym_decltype] = ACTIONS(3039),
    [anon_sym_explicit] = ACTIONS(3039),
    [anon_sym_typename] = ACTIONS(3039),
    [anon_sym_template] = ACTIONS(3039),
    [anon_sym_operator] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_delete] = ACTIONS(3039),
    [anon_sym_throw] = ACTIONS(3039),
    [anon_sym_namespace] = ACTIONS(3039),
    [anon_sym_static_assert] = ACTIONS(3039),
    [anon_sym_concept] = ACTIONS(3039),
    [anon_sym_co_return] = ACTIONS(3039),
    [anon_sym_co_yield] = ACTIONS(3039),
    [anon_sym_R_DQUOTE] = ACTIONS(3041),
    [anon_sym_LR_DQUOTE] = ACTIONS(3041),
    [anon_sym_uR_DQUOTE] = ACTIONS(3041),
    [anon_sym_UR_DQUOTE] = ACTIONS(3041),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3041),
    [anon_sym_co_await] = ACTIONS(3039),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_requires] = ACTIONS(3039),
    [sym_this] = ACTIONS(3039),
  },
  [350] = {
    [sym_expression] = STATE(4413),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7997),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(3051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(3057),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [351] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_include_token1] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token2] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [aux_sym_preproc_else_token1] = ACTIONS(3063),
    [aux_sym_preproc_elif_token1] = ACTIONS(3063),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym___cdecl] = ACTIONS(3063),
    [anon_sym___clrcall] = ACTIONS(3063),
    [anon_sym___stdcall] = ACTIONS(3063),
    [anon_sym___fastcall] = ACTIONS(3063),
    [anon_sym___thiscall] = ACTIONS(3063),
    [anon_sym___vectorcall] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym___try] = ACTIONS(3063),
    [anon_sym___leave] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(3063),
    [anon_sym_compl] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym___alignof__] = ACTIONS(3063),
    [anon_sym___alignof] = ACTIONS(3063),
    [anon_sym__alignof] = ACTIONS(3063),
    [anon_sym_alignof] = ACTIONS(3063),
    [anon_sym__Alignof] = ACTIONS(3063),
    [anon_sym_offsetof] = ACTIONS(3063),
    [anon_sym__Generic] = ACTIONS(3063),
    [anon_sym_asm] = ACTIONS(3063),
    [anon_sym___asm__] = ACTIONS(3063),
    [anon_sym___asm] = ACTIONS(3063),
    [sym_number_literal] = ACTIONS(3065),
    [anon_sym_L_SQUOTE] = ACTIONS(3065),
    [anon_sym_u_SQUOTE] = ACTIONS(3065),
    [anon_sym_U_SQUOTE] = ACTIONS(3065),
    [anon_sym_u8_SQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_L_DQUOTE] = ACTIONS(3065),
    [anon_sym_u_DQUOTE] = ACTIONS(3065),
    [anon_sym_U_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [sym_true] = ACTIONS(3063),
    [sym_false] = ACTIONS(3063),
    [anon_sym_NULL] = ACTIONS(3063),
    [anon_sym_nullptr] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
    [anon_sym_concept] = ACTIONS(3063),
    [anon_sym_co_return] = ACTIONS(3063),
    [anon_sym_co_yield] = ACTIONS(3063),
    [anon_sym_R_DQUOTE] = ACTIONS(3065),
    [anon_sym_LR_DQUOTE] = ACTIONS(3065),
    [anon_sym_uR_DQUOTE] = ACTIONS(3065),
    [anon_sym_UR_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3065),
    [anon_sym_co_await] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_requires] = ACTIONS(3063),
    [sym_this] = ACTIONS(3063),
  },
  [352] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_include_token1] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token2] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [aux_sym_preproc_else_token1] = ACTIONS(3063),
    [aux_sym_preproc_elif_token1] = ACTIONS(3063),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym___cdecl] = ACTIONS(3063),
    [anon_sym___clrcall] = ACTIONS(3063),
    [anon_sym___stdcall] = ACTIONS(3063),
    [anon_sym___fastcall] = ACTIONS(3063),
    [anon_sym___thiscall] = ACTIONS(3063),
    [anon_sym___vectorcall] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym___try] = ACTIONS(3063),
    [anon_sym___leave] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(3063),
    [anon_sym_compl] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym___alignof__] = ACTIONS(3063),
    [anon_sym___alignof] = ACTIONS(3063),
    [anon_sym__alignof] = ACTIONS(3063),
    [anon_sym_alignof] = ACTIONS(3063),
    [anon_sym__Alignof] = ACTIONS(3063),
    [anon_sym_offsetof] = ACTIONS(3063),
    [anon_sym__Generic] = ACTIONS(3063),
    [anon_sym_asm] = ACTIONS(3063),
    [anon_sym___asm__] = ACTIONS(3063),
    [anon_sym___asm] = ACTIONS(3063),
    [sym_number_literal] = ACTIONS(3065),
    [anon_sym_L_SQUOTE] = ACTIONS(3065),
    [anon_sym_u_SQUOTE] = ACTIONS(3065),
    [anon_sym_U_SQUOTE] = ACTIONS(3065),
    [anon_sym_u8_SQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_L_DQUOTE] = ACTIONS(3065),
    [anon_sym_u_DQUOTE] = ACTIONS(3065),
    [anon_sym_U_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [sym_true] = ACTIONS(3063),
    [sym_false] = ACTIONS(3063),
    [anon_sym_NULL] = ACTIONS(3063),
    [anon_sym_nullptr] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
    [anon_sym_concept] = ACTIONS(3063),
    [anon_sym_co_return] = ACTIONS(3063),
    [anon_sym_co_yield] = ACTIONS(3063),
    [anon_sym_R_DQUOTE] = ACTIONS(3065),
    [anon_sym_LR_DQUOTE] = ACTIONS(3065),
    [anon_sym_uR_DQUOTE] = ACTIONS(3065),
    [anon_sym_UR_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3065),
    [anon_sym_co_await] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_requires] = ACTIONS(3063),
    [sym_this] = ACTIONS(3063),
  },
  [353] = {
    [ts_builtin_sym_end] = ACTIONS(2689),
    [sym_identifier] = ACTIONS(2687),
    [aux_sym_preproc_include_token1] = ACTIONS(2687),
    [aux_sym_preproc_def_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym___extension__] = ACTIONS(2687),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_virtual] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym___attribute] = ACTIONS(2687),
    [anon_sym_using] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2689),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2689),
    [anon_sym___declspec] = ACTIONS(2687),
    [anon_sym___based] = ACTIONS(2687),
    [anon_sym___cdecl] = ACTIONS(2687),
    [anon_sym___clrcall] = ACTIONS(2687),
    [anon_sym___stdcall] = ACTIONS(2687),
    [anon_sym___fastcall] = ACTIONS(2687),
    [anon_sym___thiscall] = ACTIONS(2687),
    [anon_sym___vectorcall] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym___inline] = ACTIONS(2687),
    [anon_sym___inline__] = ACTIONS(2687),
    [anon_sym___forceinline] = ACTIONS(2687),
    [anon_sym_thread_local] = ACTIONS(2687),
    [anon_sym___thread] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_constexpr] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym___restrict__] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym__Noreturn] = ACTIONS(2687),
    [anon_sym_noreturn] = ACTIONS(2687),
    [anon_sym__Nonnull] = ACTIONS(2687),
    [anon_sym_mutable] = ACTIONS(2687),
    [anon_sym_constinit] = ACTIONS(2687),
    [anon_sym_consteval] = ACTIONS(2687),
    [anon_sym_alignas] = ACTIONS(2687),
    [anon_sym__Alignas] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym___try] = ACTIONS(2687),
    [anon_sym___leave] = ACTIONS(2687),
    [anon_sym_not] = ACTIONS(2687),
    [anon_sym_compl] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [anon_sym___alignof__] = ACTIONS(2687),
    [anon_sym___alignof] = ACTIONS(2687),
    [anon_sym__alignof] = ACTIONS(2687),
    [anon_sym_alignof] = ACTIONS(2687),
    [anon_sym__Alignof] = ACTIONS(2687),
    [anon_sym_offsetof] = ACTIONS(2687),
    [anon_sym__Generic] = ACTIONS(2687),
    [anon_sym_asm] = ACTIONS(2687),
    [anon_sym___asm__] = ACTIONS(2687),
    [anon_sym___asm] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [anon_sym_L_SQUOTE] = ACTIONS(2689),
    [anon_sym_u_SQUOTE] = ACTIONS(2689),
    [anon_sym_U_SQUOTE] = ACTIONS(2689),
    [anon_sym_u8_SQUOTE] = ACTIONS(2689),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_L_DQUOTE] = ACTIONS(2689),
    [anon_sym_u_DQUOTE] = ACTIONS(2689),
    [anon_sym_U_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [anon_sym_NULL] = ACTIONS(2687),
    [anon_sym_nullptr] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2687),
    [anon_sym_decltype] = ACTIONS(2687),
    [anon_sym_explicit] = ACTIONS(2687),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_export] = ACTIONS(2687),
    [anon_sym_module] = ACTIONS(2687),
    [anon_sym_import] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2687),
    [anon_sym_operator] = ACTIONS(2687),
    [anon_sym_try] = ACTIONS(2687),
    [anon_sym_delete] = ACTIONS(2687),
    [anon_sym_throw] = ACTIONS(2687),
    [anon_sym_namespace] = ACTIONS(2687),
    [anon_sym_static_assert] = ACTIONS(2687),
    [anon_sym_concept] = ACTIONS(2687),
    [anon_sym_co_return] = ACTIONS(2687),
    [anon_sym_co_yield] = ACTIONS(2687),
    [anon_sym_R_DQUOTE] = ACTIONS(2689),
    [anon_sym_LR_DQUOTE] = ACTIONS(2689),
    [anon_sym_uR_DQUOTE] = ACTIONS(2689),
    [anon_sym_UR_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2689),
    [anon_sym_co_await] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2687),
    [anon_sym_requires] = ACTIONS(2687),
    [sym_this] = ACTIONS(2687),
  },
  [354] = {
    [sym_identifier] = ACTIONS(3067),
    [aux_sym_preproc_include_token1] = ACTIONS(3067),
    [aux_sym_preproc_def_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token2] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3067),
    [aux_sym_preproc_else_token1] = ACTIONS(3067),
    [aux_sym_preproc_elif_token1] = ACTIONS(3067),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3067),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3067),
    [sym_preproc_directive] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym___extension__] = ACTIONS(3067),
    [anon_sym_typedef] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym___attribute__] = ACTIONS(3067),
    [anon_sym___attribute] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3069),
    [anon_sym___declspec] = ACTIONS(3067),
    [anon_sym___based] = ACTIONS(3067),
    [anon_sym___cdecl] = ACTIONS(3067),
    [anon_sym___clrcall] = ACTIONS(3067),
    [anon_sym___stdcall] = ACTIONS(3067),
    [anon_sym___fastcall] = ACTIONS(3067),
    [anon_sym___thiscall] = ACTIONS(3067),
    [anon_sym___vectorcall] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_signed] = ACTIONS(3067),
    [anon_sym_unsigned] = ACTIONS(3067),
    [anon_sym_long] = ACTIONS(3067),
    [anon_sym_short] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_register] = ACTIONS(3067),
    [anon_sym_inline] = ACTIONS(3067),
    [anon_sym___inline] = ACTIONS(3067),
    [anon_sym___inline__] = ACTIONS(3067),
    [anon_sym___forceinline] = ACTIONS(3067),
    [anon_sym_thread_local] = ACTIONS(3067),
    [anon_sym___thread] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_constexpr] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_restrict] = ACTIONS(3067),
    [anon_sym___restrict__] = ACTIONS(3067),
    [anon_sym__Atomic] = ACTIONS(3067),
    [anon_sym__Noreturn] = ACTIONS(3067),
    [anon_sym_noreturn] = ACTIONS(3067),
    [anon_sym__Nonnull] = ACTIONS(3067),
    [anon_sym_mutable] = ACTIONS(3067),
    [anon_sym_constinit] = ACTIONS(3067),
    [anon_sym_consteval] = ACTIONS(3067),
    [anon_sym_alignas] = ACTIONS(3067),
    [anon_sym__Alignas] = ACTIONS(3067),
    [sym_primitive_type] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_union] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_case] = ACTIONS(3067),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_break] = ACTIONS(3067),
    [anon_sym_continue] = ACTIONS(3067),
    [anon_sym_goto] = ACTIONS(3067),
    [anon_sym___try] = ACTIONS(3067),
    [anon_sym___leave] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(3067),
    [anon_sym_compl] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_sizeof] = ACTIONS(3067),
    [anon_sym___alignof__] = ACTIONS(3067),
    [anon_sym___alignof] = ACTIONS(3067),
    [anon_sym__alignof] = ACTIONS(3067),
    [anon_sym_alignof] = ACTIONS(3067),
    [anon_sym__Alignof] = ACTIONS(3067),
    [anon_sym_offsetof] = ACTIONS(3067),
    [anon_sym__Generic] = ACTIONS(3067),
    [anon_sym_asm] = ACTIONS(3067),
    [anon_sym___asm__] = ACTIONS(3067),
    [anon_sym___asm] = ACTIONS(3067),
    [sym_number_literal] = ACTIONS(3069),
    [anon_sym_L_SQUOTE] = ACTIONS(3069),
    [anon_sym_u_SQUOTE] = ACTIONS(3069),
    [anon_sym_U_SQUOTE] = ACTIONS(3069),
    [anon_sym_u8_SQUOTE] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_L_DQUOTE] = ACTIONS(3069),
    [anon_sym_u_DQUOTE] = ACTIONS(3069),
    [anon_sym_U_DQUOTE] = ACTIONS(3069),
    [anon_sym_u8_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [sym_true] = ACTIONS(3067),
    [sym_false] = ACTIONS(3067),
    [anon_sym_NULL] = ACTIONS(3067),
    [anon_sym_nullptr] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3067),
    [anon_sym_decltype] = ACTIONS(3067),
    [anon_sym_explicit] = ACTIONS(3067),
    [anon_sym_typename] = ACTIONS(3067),
    [anon_sym_template] = ACTIONS(3067),
    [anon_sym_operator] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_delete] = ACTIONS(3067),
    [anon_sym_throw] = ACTIONS(3067),
    [anon_sym_namespace] = ACTIONS(3067),
    [anon_sym_static_assert] = ACTIONS(3067),
    [anon_sym_concept] = ACTIONS(3067),
    [anon_sym_co_return] = ACTIONS(3067),
    [anon_sym_co_yield] = ACTIONS(3067),
    [anon_sym_R_DQUOTE] = ACTIONS(3069),
    [anon_sym_LR_DQUOTE] = ACTIONS(3069),
    [anon_sym_uR_DQUOTE] = ACTIONS(3069),
    [anon_sym_UR_DQUOTE] = ACTIONS(3069),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3069),
    [anon_sym_co_await] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_requires] = ACTIONS(3067),
    [sym_this] = ACTIONS(3067),
  },
  [355] = {
    [sym_identifier] = ACTIONS(3071),
    [aux_sym_preproc_include_token1] = ACTIONS(3071),
    [aux_sym_preproc_def_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token2] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3071),
    [aux_sym_preproc_else_token1] = ACTIONS(3071),
    [aux_sym_preproc_elif_token1] = ACTIONS(3071),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3071),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3071),
    [sym_preproc_directive] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym___extension__] = ACTIONS(3071),
    [anon_sym_typedef] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym___attribute__] = ACTIONS(3071),
    [anon_sym___attribute] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3073),
    [anon_sym___declspec] = ACTIONS(3071),
    [anon_sym___based] = ACTIONS(3071),
    [anon_sym___cdecl] = ACTIONS(3071),
    [anon_sym___clrcall] = ACTIONS(3071),
    [anon_sym___stdcall] = ACTIONS(3071),
    [anon_sym___fastcall] = ACTIONS(3071),
    [anon_sym___thiscall] = ACTIONS(3071),
    [anon_sym___vectorcall] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_signed] = ACTIONS(3071),
    [anon_sym_unsigned] = ACTIONS(3071),
    [anon_sym_long] = ACTIONS(3071),
    [anon_sym_short] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_register] = ACTIONS(3071),
    [anon_sym_inline] = ACTIONS(3071),
    [anon_sym___inline] = ACTIONS(3071),
    [anon_sym___inline__] = ACTIONS(3071),
    [anon_sym___forceinline] = ACTIONS(3071),
    [anon_sym_thread_local] = ACTIONS(3071),
    [anon_sym___thread] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_constexpr] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_restrict] = ACTIONS(3071),
    [anon_sym___restrict__] = ACTIONS(3071),
    [anon_sym__Atomic] = ACTIONS(3071),
    [anon_sym__Noreturn] = ACTIONS(3071),
    [anon_sym_noreturn] = ACTIONS(3071),
    [anon_sym__Nonnull] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_constinit] = ACTIONS(3071),
    [anon_sym_consteval] = ACTIONS(3071),
    [anon_sym_alignas] = ACTIONS(3071),
    [anon_sym__Alignas] = ACTIONS(3071),
    [sym_primitive_type] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_union] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_switch] = ACTIONS(3071),
    [anon_sym_case] = ACTIONS(3071),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3071),
    [anon_sym_goto] = ACTIONS(3071),
    [anon_sym___try] = ACTIONS(3071),
    [anon_sym___leave] = ACTIONS(3071),
    [anon_sym_not] = ACTIONS(3071),
    [anon_sym_compl] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_sizeof] = ACTIONS(3071),
    [anon_sym___alignof__] = ACTIONS(3071),
    [anon_sym___alignof] = ACTIONS(3071),
    [anon_sym__alignof] = ACTIONS(3071),
    [anon_sym_alignof] = ACTIONS(3071),
    [anon_sym__Alignof] = ACTIONS(3071),
    [anon_sym_offsetof] = ACTIONS(3071),
    [anon_sym__Generic] = ACTIONS(3071),
    [anon_sym_asm] = ACTIONS(3071),
    [anon_sym___asm__] = ACTIONS(3071),
    [anon_sym___asm] = ACTIONS(3071),
    [sym_number_literal] = ACTIONS(3073),
    [anon_sym_L_SQUOTE] = ACTIONS(3073),
    [anon_sym_u_SQUOTE] = ACTIONS(3073),
    [anon_sym_U_SQUOTE] = ACTIONS(3073),
    [anon_sym_u8_SQUOTE] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_L_DQUOTE] = ACTIONS(3073),
    [anon_sym_u_DQUOTE] = ACTIONS(3073),
    [anon_sym_U_DQUOTE] = ACTIONS(3073),
    [anon_sym_u8_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [sym_true] = ACTIONS(3071),
    [sym_false] = ACTIONS(3071),
    [anon_sym_NULL] = ACTIONS(3071),
    [anon_sym_nullptr] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3071),
    [anon_sym_decltype] = ACTIONS(3071),
    [anon_sym_explicit] = ACTIONS(3071),
    [anon_sym_typename] = ACTIONS(3071),
    [anon_sym_template] = ACTIONS(3071),
    [anon_sym_operator] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_delete] = ACTIONS(3071),
    [anon_sym_throw] = ACTIONS(3071),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_static_assert] = ACTIONS(3071),
    [anon_sym_concept] = ACTIONS(3071),
    [anon_sym_co_return] = ACTIONS(3071),
    [anon_sym_co_yield] = ACTIONS(3071),
    [anon_sym_R_DQUOTE] = ACTIONS(3073),
    [anon_sym_LR_DQUOTE] = ACTIONS(3073),
    [anon_sym_uR_DQUOTE] = ACTIONS(3073),
    [anon_sym_UR_DQUOTE] = ACTIONS(3073),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3073),
    [anon_sym_co_await] = ACTIONS(3071),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_requires] = ACTIONS(3071),
    [sym_this] = ACTIONS(3071),
  },
  [356] = {
    [sym_identifier] = ACTIONS(3075),
    [aux_sym_preproc_include_token1] = ACTIONS(3075),
    [aux_sym_preproc_def_token1] = ACTIONS(3075),
    [aux_sym_preproc_if_token1] = ACTIONS(3075),
    [aux_sym_preproc_if_token2] = ACTIONS(3075),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3075),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3075),
    [aux_sym_preproc_else_token1] = ACTIONS(3075),
    [aux_sym_preproc_elif_token1] = ACTIONS(3075),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3075),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3075),
    [sym_preproc_directive] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3077),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_AMP_AMP] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym___extension__] = ACTIONS(3075),
    [anon_sym_typedef] = ACTIONS(3075),
    [anon_sym_virtual] = ACTIONS(3075),
    [anon_sym_extern] = ACTIONS(3075),
    [anon_sym___attribute__] = ACTIONS(3075),
    [anon_sym___attribute] = ACTIONS(3075),
    [anon_sym_using] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3077),
    [anon_sym___declspec] = ACTIONS(3075),
    [anon_sym___based] = ACTIONS(3075),
    [anon_sym___cdecl] = ACTIONS(3075),
    [anon_sym___clrcall] = ACTIONS(3075),
    [anon_sym___stdcall] = ACTIONS(3075),
    [anon_sym___fastcall] = ACTIONS(3075),
    [anon_sym___thiscall] = ACTIONS(3075),
    [anon_sym___vectorcall] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_signed] = ACTIONS(3075),
    [anon_sym_unsigned] = ACTIONS(3075),
    [anon_sym_long] = ACTIONS(3075),
    [anon_sym_short] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_register] = ACTIONS(3075),
    [anon_sym_inline] = ACTIONS(3075),
    [anon_sym___inline] = ACTIONS(3075),
    [anon_sym___inline__] = ACTIONS(3075),
    [anon_sym___forceinline] = ACTIONS(3075),
    [anon_sym_thread_local] = ACTIONS(3075),
    [anon_sym___thread] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_constexpr] = ACTIONS(3075),
    [anon_sym_volatile] = ACTIONS(3075),
    [anon_sym_restrict] = ACTIONS(3075),
    [anon_sym___restrict__] = ACTIONS(3075),
    [anon_sym__Atomic] = ACTIONS(3075),
    [anon_sym__Noreturn] = ACTIONS(3075),
    [anon_sym_noreturn] = ACTIONS(3075),
    [anon_sym__Nonnull] = ACTIONS(3075),
    [anon_sym_mutable] = ACTIONS(3075),
    [anon_sym_constinit] = ACTIONS(3075),
    [anon_sym_consteval] = ACTIONS(3075),
    [anon_sym_alignas] = ACTIONS(3075),
    [anon_sym__Alignas] = ACTIONS(3075),
    [sym_primitive_type] = ACTIONS(3075),
    [anon_sym_enum] = ACTIONS(3075),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_struct] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_case] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_goto] = ACTIONS(3075),
    [anon_sym___try] = ACTIONS(3075),
    [anon_sym___leave] = ACTIONS(3075),
    [anon_sym_not] = ACTIONS(3075),
    [anon_sym_compl] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_sizeof] = ACTIONS(3075),
    [anon_sym___alignof__] = ACTIONS(3075),
    [anon_sym___alignof] = ACTIONS(3075),
    [anon_sym__alignof] = ACTIONS(3075),
    [anon_sym_alignof] = ACTIONS(3075),
    [anon_sym__Alignof] = ACTIONS(3075),
    [anon_sym_offsetof] = ACTIONS(3075),
    [anon_sym__Generic] = ACTIONS(3075),
    [anon_sym_asm] = ACTIONS(3075),
    [anon_sym___asm__] = ACTIONS(3075),
    [anon_sym___asm] = ACTIONS(3075),
    [sym_number_literal] = ACTIONS(3077),
    [anon_sym_L_SQUOTE] = ACTIONS(3077),
    [anon_sym_u_SQUOTE] = ACTIONS(3077),
    [anon_sym_U_SQUOTE] = ACTIONS(3077),
    [anon_sym_u8_SQUOTE] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [anon_sym_L_DQUOTE] = ACTIONS(3077),
    [anon_sym_u_DQUOTE] = ACTIONS(3077),
    [anon_sym_U_DQUOTE] = ACTIONS(3077),
    [anon_sym_u8_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [sym_true] = ACTIONS(3075),
    [sym_false] = ACTIONS(3075),
    [anon_sym_NULL] = ACTIONS(3075),
    [anon_sym_nullptr] = ACTIONS(3075),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3075),
    [anon_sym_decltype] = ACTIONS(3075),
    [anon_sym_explicit] = ACTIONS(3075),
    [anon_sym_typename] = ACTIONS(3075),
    [anon_sym_template] = ACTIONS(3075),
    [anon_sym_operator] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_delete] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_static_assert] = ACTIONS(3075),
    [anon_sym_concept] = ACTIONS(3075),
    [anon_sym_co_return] = ACTIONS(3075),
    [anon_sym_co_yield] = ACTIONS(3075),
    [anon_sym_R_DQUOTE] = ACTIONS(3077),
    [anon_sym_LR_DQUOTE] = ACTIONS(3077),
    [anon_sym_uR_DQUOTE] = ACTIONS(3077),
    [anon_sym_UR_DQUOTE] = ACTIONS(3077),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3077),
    [anon_sym_co_await] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_requires] = ACTIONS(3075),
    [sym_this] = ACTIONS(3075),
  },
  [357] = {
    [sym_identifier] = ACTIONS(3079),
    [aux_sym_preproc_include_token1] = ACTIONS(3079),
    [aux_sym_preproc_def_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token2] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3079),
    [aux_sym_preproc_else_token1] = ACTIONS(3079),
    [aux_sym_preproc_elif_token1] = ACTIONS(3079),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3079),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3079),
    [sym_preproc_directive] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_AMP_AMP] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym___extension__] = ACTIONS(3079),
    [anon_sym_typedef] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym___attribute__] = ACTIONS(3079),
    [anon_sym___attribute] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3081),
    [anon_sym___declspec] = ACTIONS(3079),
    [anon_sym___based] = ACTIONS(3079),
    [anon_sym___cdecl] = ACTIONS(3079),
    [anon_sym___clrcall] = ACTIONS(3079),
    [anon_sym___stdcall] = ACTIONS(3079),
    [anon_sym___fastcall] = ACTIONS(3079),
    [anon_sym___thiscall] = ACTIONS(3079),
    [anon_sym___vectorcall] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3081),
    [anon_sym_signed] = ACTIONS(3079),
    [anon_sym_unsigned] = ACTIONS(3079),
    [anon_sym_long] = ACTIONS(3079),
    [anon_sym_short] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_register] = ACTIONS(3079),
    [anon_sym_inline] = ACTIONS(3079),
    [anon_sym___inline] = ACTIONS(3079),
    [anon_sym___inline__] = ACTIONS(3079),
    [anon_sym___forceinline] = ACTIONS(3079),
    [anon_sym_thread_local] = ACTIONS(3079),
    [anon_sym___thread] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_constexpr] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_restrict] = ACTIONS(3079),
    [anon_sym___restrict__] = ACTIONS(3079),
    [anon_sym__Atomic] = ACTIONS(3079),
    [anon_sym__Noreturn] = ACTIONS(3079),
    [anon_sym_noreturn] = ACTIONS(3079),
    [anon_sym__Nonnull] = ACTIONS(3079),
    [anon_sym_mutable] = ACTIONS(3079),
    [anon_sym_constinit] = ACTIONS(3079),
    [anon_sym_consteval] = ACTIONS(3079),
    [anon_sym_alignas] = ACTIONS(3079),
    [anon_sym__Alignas] = ACTIONS(3079),
    [sym_primitive_type] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_union] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_switch] = ACTIONS(3079),
    [anon_sym_case] = ACTIONS(3079),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_break] = ACTIONS(3079),
    [anon_sym_continue] = ACTIONS(3079),
    [anon_sym_goto] = ACTIONS(3079),
    [anon_sym___try] = ACTIONS(3079),
    [anon_sym___leave] = ACTIONS(3079),
    [anon_sym_not] = ACTIONS(3079),
    [anon_sym_compl] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_sizeof] = ACTIONS(3079),
    [anon_sym___alignof__] = ACTIONS(3079),
    [anon_sym___alignof] = ACTIONS(3079),
    [anon_sym__alignof] = ACTIONS(3079),
    [anon_sym_alignof] = ACTIONS(3079),
    [anon_sym__Alignof] = ACTIONS(3079),
    [anon_sym_offsetof] = ACTIONS(3079),
    [anon_sym__Generic] = ACTIONS(3079),
    [anon_sym_asm] = ACTIONS(3079),
    [anon_sym___asm__] = ACTIONS(3079),
    [anon_sym___asm] = ACTIONS(3079),
    [sym_number_literal] = ACTIONS(3081),
    [anon_sym_L_SQUOTE] = ACTIONS(3081),
    [anon_sym_u_SQUOTE] = ACTIONS(3081),
    [anon_sym_U_SQUOTE] = ACTIONS(3081),
    [anon_sym_u8_SQUOTE] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [anon_sym_L_DQUOTE] = ACTIONS(3081),
    [anon_sym_u_DQUOTE] = ACTIONS(3081),
    [anon_sym_U_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [sym_true] = ACTIONS(3079),
    [sym_false] = ACTIONS(3079),
    [anon_sym_NULL] = ACTIONS(3079),
    [anon_sym_nullptr] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3079),
    [anon_sym_decltype] = ACTIONS(3079),
    [anon_sym_explicit] = ACTIONS(3079),
    [anon_sym_typename] = ACTIONS(3079),
    [anon_sym_template] = ACTIONS(3079),
    [anon_sym_operator] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_delete] = ACTIONS(3079),
    [anon_sym_throw] = ACTIONS(3079),
    [anon_sym_namespace] = ACTIONS(3079),
    [anon_sym_static_assert] = ACTIONS(3079),
    [anon_sym_concept] = ACTIONS(3079),
    [anon_sym_co_return] = ACTIONS(3079),
    [anon_sym_co_yield] = ACTIONS(3079),
    [anon_sym_R_DQUOTE] = ACTIONS(3081),
    [anon_sym_LR_DQUOTE] = ACTIONS(3081),
    [anon_sym_uR_DQUOTE] = ACTIONS(3081),
    [anon_sym_UR_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3081),
    [anon_sym_co_await] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_requires] = ACTIONS(3079),
    [sym_this] = ACTIONS(3079),
  },
  [358] = {
    [sym_identifier] = ACTIONS(3083),
    [aux_sym_preproc_include_token1] = ACTIONS(3083),
    [aux_sym_preproc_def_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token2] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3083),
    [aux_sym_preproc_else_token1] = ACTIONS(3083),
    [aux_sym_preproc_elif_token1] = ACTIONS(3083),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3083),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3083),
    [sym_preproc_directive] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3085),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym___extension__] = ACTIONS(3083),
    [anon_sym_typedef] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym___attribute__] = ACTIONS(3083),
    [anon_sym___attribute] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3085),
    [anon_sym___declspec] = ACTIONS(3083),
    [anon_sym___based] = ACTIONS(3083),
    [anon_sym___cdecl] = ACTIONS(3083),
    [anon_sym___clrcall] = ACTIONS(3083),
    [anon_sym___stdcall] = ACTIONS(3083),
    [anon_sym___fastcall] = ACTIONS(3083),
    [anon_sym___thiscall] = ACTIONS(3083),
    [anon_sym___vectorcall] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_signed] = ACTIONS(3083),
    [anon_sym_unsigned] = ACTIONS(3083),
    [anon_sym_long] = ACTIONS(3083),
    [anon_sym_short] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_register] = ACTIONS(3083),
    [anon_sym_inline] = ACTIONS(3083),
    [anon_sym___inline] = ACTIONS(3083),
    [anon_sym___inline__] = ACTIONS(3083),
    [anon_sym___forceinline] = ACTIONS(3083),
    [anon_sym_thread_local] = ACTIONS(3083),
    [anon_sym___thread] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_constexpr] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_restrict] = ACTIONS(3083),
    [anon_sym___restrict__] = ACTIONS(3083),
    [anon_sym__Atomic] = ACTIONS(3083),
    [anon_sym__Noreturn] = ACTIONS(3083),
    [anon_sym_noreturn] = ACTIONS(3083),
    [anon_sym__Nonnull] = ACTIONS(3083),
    [anon_sym_mutable] = ACTIONS(3083),
    [anon_sym_constinit] = ACTIONS(3083),
    [anon_sym_consteval] = ACTIONS(3083),
    [anon_sym_alignas] = ACTIONS(3083),
    [anon_sym__Alignas] = ACTIONS(3083),
    [sym_primitive_type] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3083),
    [anon_sym_union] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_case] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_goto] = ACTIONS(3083),
    [anon_sym___try] = ACTIONS(3083),
    [anon_sym___leave] = ACTIONS(3083),
    [anon_sym_not] = ACTIONS(3083),
    [anon_sym_compl] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_sizeof] = ACTIONS(3083),
    [anon_sym___alignof__] = ACTIONS(3083),
    [anon_sym___alignof] = ACTIONS(3083),
    [anon_sym__alignof] = ACTIONS(3083),
    [anon_sym_alignof] = ACTIONS(3083),
    [anon_sym__Alignof] = ACTIONS(3083),
    [anon_sym_offsetof] = ACTIONS(3083),
    [anon_sym__Generic] = ACTIONS(3083),
    [anon_sym_asm] = ACTIONS(3083),
    [anon_sym___asm__] = ACTIONS(3083),
    [anon_sym___asm] = ACTIONS(3083),
    [sym_number_literal] = ACTIONS(3085),
    [anon_sym_L_SQUOTE] = ACTIONS(3085),
    [anon_sym_u_SQUOTE] = ACTIONS(3085),
    [anon_sym_U_SQUOTE] = ACTIONS(3085),
    [anon_sym_u8_SQUOTE] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [anon_sym_L_DQUOTE] = ACTIONS(3085),
    [anon_sym_u_DQUOTE] = ACTIONS(3085),
    [anon_sym_U_DQUOTE] = ACTIONS(3085),
    [anon_sym_u8_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [sym_true] = ACTIONS(3083),
    [sym_false] = ACTIONS(3083),
    [anon_sym_NULL] = ACTIONS(3083),
    [anon_sym_nullptr] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3083),
    [anon_sym_decltype] = ACTIONS(3083),
    [anon_sym_explicit] = ACTIONS(3083),
    [anon_sym_typename] = ACTIONS(3083),
    [anon_sym_template] = ACTIONS(3083),
    [anon_sym_operator] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_delete] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_namespace] = ACTIONS(3083),
    [anon_sym_static_assert] = ACTIONS(3083),
    [anon_sym_concept] = ACTIONS(3083),
    [anon_sym_co_return] = ACTIONS(3083),
    [anon_sym_co_yield] = ACTIONS(3083),
    [anon_sym_R_DQUOTE] = ACTIONS(3085),
    [anon_sym_LR_DQUOTE] = ACTIONS(3085),
    [anon_sym_uR_DQUOTE] = ACTIONS(3085),
    [anon_sym_UR_DQUOTE] = ACTIONS(3085),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3085),
    [anon_sym_co_await] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_requires] = ACTIONS(3083),
    [sym_this] = ACTIONS(3083),
  },
  [359] = {
    [sym_catch_clause] = STATE(362),
    [aux_sym_constructor_try_statement_repeat1] = STATE(362),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_include_token1] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token2] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_virtual] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym___attribute] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym___cdecl] = ACTIONS(2483),
    [anon_sym___clrcall] = ACTIONS(2483),
    [anon_sym___stdcall] = ACTIONS(2483),
    [anon_sym___fastcall] = ACTIONS(2483),
    [anon_sym___thiscall] = ACTIONS(2483),
    [anon_sym___vectorcall] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym__Nonnull] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_case] = ACTIONS(2483),
    [anon_sym_default] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_goto] = ACTIONS(2483),
    [anon_sym___try] = ACTIONS(2483),
    [anon_sym___leave] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2483),
    [anon_sym_compl] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_sizeof] = ACTIONS(2483),
    [anon_sym___alignof__] = ACTIONS(2483),
    [anon_sym___alignof] = ACTIONS(2483),
    [anon_sym__alignof] = ACTIONS(2483),
    [anon_sym_alignof] = ACTIONS(2483),
    [anon_sym__Alignof] = ACTIONS(2483),
    [anon_sym_offsetof] = ACTIONS(2483),
    [anon_sym__Generic] = ACTIONS(2483),
    [anon_sym_asm] = ACTIONS(2483),
    [anon_sym___asm__] = ACTIONS(2483),
    [anon_sym___asm] = ACTIONS(2483),
    [sym_number_literal] = ACTIONS(2485),
    [anon_sym_L_SQUOTE] = ACTIONS(2485),
    [anon_sym_u_SQUOTE] = ACTIONS(2485),
    [anon_sym_U_SQUOTE] = ACTIONS(2485),
    [anon_sym_u8_SQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [anon_sym_L_DQUOTE] = ACTIONS(2485),
    [anon_sym_u_DQUOTE] = ACTIONS(2485),
    [anon_sym_U_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8_DQUOTE] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [anon_sym_NULL] = ACTIONS(2483),
    [anon_sym_nullptr] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_namespace] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_concept] = ACTIONS(2483),
    [anon_sym_co_return] = ACTIONS(2483),
    [anon_sym_co_yield] = ACTIONS(2483),
    [anon_sym_catch] = ACTIONS(3087),
    [anon_sym_R_DQUOTE] = ACTIONS(2485),
    [anon_sym_LR_DQUOTE] = ACTIONS(2485),
    [anon_sym_uR_DQUOTE] = ACTIONS(2485),
    [anon_sym_UR_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2485),
    [anon_sym_co_await] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_requires] = ACTIONS(2483),
    [sym_this] = ACTIONS(2483),
  },
  [360] = {
    [sym_identifier] = ACTIONS(3089),
    [aux_sym_preproc_include_token1] = ACTIONS(3089),
    [aux_sym_preproc_def_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token2] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3089),
    [aux_sym_preproc_else_token1] = ACTIONS(3089),
    [aux_sym_preproc_elif_token1] = ACTIONS(3089),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3089),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3089),
    [sym_preproc_directive] = ACTIONS(3089),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_STAR] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym___extension__] = ACTIONS(3089),
    [anon_sym_typedef] = ACTIONS(3089),
    [anon_sym_virtual] = ACTIONS(3089),
    [anon_sym_extern] = ACTIONS(3089),
    [anon_sym___attribute__] = ACTIONS(3089),
    [anon_sym___attribute] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_COLON_COLON] = ACTIONS(3091),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3091),
    [anon_sym___declspec] = ACTIONS(3089),
    [anon_sym___based] = ACTIONS(3089),
    [anon_sym___cdecl] = ACTIONS(3089),
    [anon_sym___clrcall] = ACTIONS(3089),
    [anon_sym___stdcall] = ACTIONS(3089),
    [anon_sym___fastcall] = ACTIONS(3089),
    [anon_sym___thiscall] = ACTIONS(3089),
    [anon_sym___vectorcall] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_signed] = ACTIONS(3089),
    [anon_sym_unsigned] = ACTIONS(3089),
    [anon_sym_long] = ACTIONS(3089),
    [anon_sym_short] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3089),
    [anon_sym_register] = ACTIONS(3089),
    [anon_sym_inline] = ACTIONS(3089),
    [anon_sym___inline] = ACTIONS(3089),
    [anon_sym___inline__] = ACTIONS(3089),
    [anon_sym___forceinline] = ACTIONS(3089),
    [anon_sym_thread_local] = ACTIONS(3089),
    [anon_sym___thread] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_constexpr] = ACTIONS(3089),
    [anon_sym_volatile] = ACTIONS(3089),
    [anon_sym_restrict] = ACTIONS(3089),
    [anon_sym___restrict__] = ACTIONS(3089),
    [anon_sym__Atomic] = ACTIONS(3089),
    [anon_sym__Noreturn] = ACTIONS(3089),
    [anon_sym_noreturn] = ACTIONS(3089),
    [anon_sym__Nonnull] = ACTIONS(3089),
    [anon_sym_mutable] = ACTIONS(3089),
    [anon_sym_constinit] = ACTIONS(3089),
    [anon_sym_consteval] = ACTIONS(3089),
    [anon_sym_alignas] = ACTIONS(3089),
    [anon_sym__Alignas] = ACTIONS(3089),
    [sym_primitive_type] = ACTIONS(3089),
    [anon_sym_enum] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_union] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_switch] = ACTIONS(3089),
    [anon_sym_case] = ACTIONS(3089),
    [anon_sym_default] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [anon_sym_do] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_break] = ACTIONS(3089),
    [anon_sym_continue] = ACTIONS(3089),
    [anon_sym_goto] = ACTIONS(3089),
    [anon_sym___try] = ACTIONS(3089),
    [anon_sym___leave] = ACTIONS(3089),
    [anon_sym_not] = ACTIONS(3089),
    [anon_sym_compl] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_sizeof] = ACTIONS(3089),
    [anon_sym___alignof__] = ACTIONS(3089),
    [anon_sym___alignof] = ACTIONS(3089),
    [anon_sym__alignof] = ACTIONS(3089),
    [anon_sym_alignof] = ACTIONS(3089),
    [anon_sym__Alignof] = ACTIONS(3089),
    [anon_sym_offsetof] = ACTIONS(3089),
    [anon_sym__Generic] = ACTIONS(3089),
    [anon_sym_asm] = ACTIONS(3089),
    [anon_sym___asm__] = ACTIONS(3089),
    [anon_sym___asm] = ACTIONS(3089),
    [sym_number_literal] = ACTIONS(3091),
    [anon_sym_L_SQUOTE] = ACTIONS(3091),
    [anon_sym_u_SQUOTE] = ACTIONS(3091),
    [anon_sym_U_SQUOTE] = ACTIONS(3091),
    [anon_sym_u8_SQUOTE] = ACTIONS(3091),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [anon_sym_L_DQUOTE] = ACTIONS(3091),
    [anon_sym_u_DQUOTE] = ACTIONS(3091),
    [anon_sym_U_DQUOTE] = ACTIONS(3091),
    [anon_sym_u8_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [sym_true] = ACTIONS(3089),
    [sym_false] = ACTIONS(3089),
    [anon_sym_NULL] = ACTIONS(3089),
    [anon_sym_nullptr] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3089),
    [anon_sym_decltype] = ACTIONS(3089),
    [anon_sym_explicit] = ACTIONS(3089),
    [anon_sym_typename] = ACTIONS(3089),
    [anon_sym_template] = ACTIONS(3089),
    [anon_sym_operator] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_delete] = ACTIONS(3089),
    [anon_sym_throw] = ACTIONS(3089),
    [anon_sym_namespace] = ACTIONS(3089),
    [anon_sym_static_assert] = ACTIONS(3089),
    [anon_sym_concept] = ACTIONS(3089),
    [anon_sym_co_return] = ACTIONS(3089),
    [anon_sym_co_yield] = ACTIONS(3089),
    [anon_sym_R_DQUOTE] = ACTIONS(3091),
    [anon_sym_LR_DQUOTE] = ACTIONS(3091),
    [anon_sym_uR_DQUOTE] = ACTIONS(3091),
    [anon_sym_UR_DQUOTE] = ACTIONS(3091),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3091),
    [anon_sym_co_await] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3089),
    [anon_sym_requires] = ACTIONS(3089),
    [sym_this] = ACTIONS(3089),
  },
  [361] = {
    [sym_identifier] = ACTIONS(3093),
    [aux_sym_preproc_include_token1] = ACTIONS(3093),
    [aux_sym_preproc_def_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token2] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3093),
    [aux_sym_preproc_else_token1] = ACTIONS(3093),
    [aux_sym_preproc_elif_token1] = ACTIONS(3093),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3093),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3093),
    [sym_preproc_directive] = ACTIONS(3093),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym___extension__] = ACTIONS(3093),
    [anon_sym_typedef] = ACTIONS(3093),
    [anon_sym_virtual] = ACTIONS(3093),
    [anon_sym_extern] = ACTIONS(3093),
    [anon_sym___attribute__] = ACTIONS(3093),
    [anon_sym___attribute] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_COLON_COLON] = ACTIONS(3095),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3095),
    [anon_sym___declspec] = ACTIONS(3093),
    [anon_sym___based] = ACTIONS(3093),
    [anon_sym___cdecl] = ACTIONS(3093),
    [anon_sym___clrcall] = ACTIONS(3093),
    [anon_sym___stdcall] = ACTIONS(3093),
    [anon_sym___fastcall] = ACTIONS(3093),
    [anon_sym___thiscall] = ACTIONS(3093),
    [anon_sym___vectorcall] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_signed] = ACTIONS(3093),
    [anon_sym_unsigned] = ACTIONS(3093),
    [anon_sym_long] = ACTIONS(3093),
    [anon_sym_short] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3093),
    [anon_sym_register] = ACTIONS(3093),
    [anon_sym_inline] = ACTIONS(3093),
    [anon_sym___inline] = ACTIONS(3093),
    [anon_sym___inline__] = ACTIONS(3093),
    [anon_sym___forceinline] = ACTIONS(3093),
    [anon_sym_thread_local] = ACTIONS(3093),
    [anon_sym___thread] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_constexpr] = ACTIONS(3093),
    [anon_sym_volatile] = ACTIONS(3093),
    [anon_sym_restrict] = ACTIONS(3093),
    [anon_sym___restrict__] = ACTIONS(3093),
    [anon_sym__Atomic] = ACTIONS(3093),
    [anon_sym__Noreturn] = ACTIONS(3093),
    [anon_sym_noreturn] = ACTIONS(3093),
    [anon_sym__Nonnull] = ACTIONS(3093),
    [anon_sym_mutable] = ACTIONS(3093),
    [anon_sym_constinit] = ACTIONS(3093),
    [anon_sym_consteval] = ACTIONS(3093),
    [anon_sym_alignas] = ACTIONS(3093),
    [anon_sym__Alignas] = ACTIONS(3093),
    [sym_primitive_type] = ACTIONS(3093),
    [anon_sym_enum] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_union] = ACTIONS(3093),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_switch] = ACTIONS(3093),
    [anon_sym_case] = ACTIONS(3093),
    [anon_sym_default] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [anon_sym_do] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_break] = ACTIONS(3093),
    [anon_sym_continue] = ACTIONS(3093),
    [anon_sym_goto] = ACTIONS(3093),
    [anon_sym___try] = ACTIONS(3093),
    [anon_sym___leave] = ACTIONS(3093),
    [anon_sym_not] = ACTIONS(3093),
    [anon_sym_compl] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3095),
    [anon_sym_sizeof] = ACTIONS(3093),
    [anon_sym___alignof__] = ACTIONS(3093),
    [anon_sym___alignof] = ACTIONS(3093),
    [anon_sym__alignof] = ACTIONS(3093),
    [anon_sym_alignof] = ACTIONS(3093),
    [anon_sym__Alignof] = ACTIONS(3093),
    [anon_sym_offsetof] = ACTIONS(3093),
    [anon_sym__Generic] = ACTIONS(3093),
    [anon_sym_asm] = ACTIONS(3093),
    [anon_sym___asm__] = ACTIONS(3093),
    [anon_sym___asm] = ACTIONS(3093),
    [sym_number_literal] = ACTIONS(3095),
    [anon_sym_L_SQUOTE] = ACTIONS(3095),
    [anon_sym_u_SQUOTE] = ACTIONS(3095),
    [anon_sym_U_SQUOTE] = ACTIONS(3095),
    [anon_sym_u8_SQUOTE] = ACTIONS(3095),
    [anon_sym_SQUOTE] = ACTIONS(3095),
    [anon_sym_L_DQUOTE] = ACTIONS(3095),
    [anon_sym_u_DQUOTE] = ACTIONS(3095),
    [anon_sym_U_DQUOTE] = ACTIONS(3095),
    [anon_sym_u8_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [sym_true] = ACTIONS(3093),
    [sym_false] = ACTIONS(3093),
    [anon_sym_NULL] = ACTIONS(3093),
    [anon_sym_nullptr] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3093),
    [anon_sym_decltype] = ACTIONS(3093),
    [anon_sym_explicit] = ACTIONS(3093),
    [anon_sym_typename] = ACTIONS(3093),
    [anon_sym_template] = ACTIONS(3093),
    [anon_sym_operator] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_delete] = ACTIONS(3093),
    [anon_sym_throw] = ACTIONS(3093),
    [anon_sym_namespace] = ACTIONS(3093),
    [anon_sym_static_assert] = ACTIONS(3093),
    [anon_sym_concept] = ACTIONS(3093),
    [anon_sym_co_return] = ACTIONS(3093),
    [anon_sym_co_yield] = ACTIONS(3093),
    [anon_sym_R_DQUOTE] = ACTIONS(3095),
    [anon_sym_LR_DQUOTE] = ACTIONS(3095),
    [anon_sym_uR_DQUOTE] = ACTIONS(3095),
    [anon_sym_UR_DQUOTE] = ACTIONS(3095),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3095),
    [anon_sym_co_await] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3093),
    [anon_sym_requires] = ACTIONS(3093),
    [sym_this] = ACTIONS(3093),
  },
  [362] = {
    [sym_catch_clause] = STATE(362),
    [aux_sym_constructor_try_statement_repeat1] = STATE(362),
    [sym_identifier] = ACTIONS(2476),
    [aux_sym_preproc_include_token1] = ACTIONS(2476),
    [aux_sym_preproc_def_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token2] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2476),
    [sym_preproc_directive] = ACTIONS(2476),
    [anon_sym_LPAREN2] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym___extension__] = ACTIONS(2476),
    [anon_sym_typedef] = ACTIONS(2476),
    [anon_sym_virtual] = ACTIONS(2476),
    [anon_sym_extern] = ACTIONS(2476),
    [anon_sym___attribute__] = ACTIONS(2476),
    [anon_sym___attribute] = ACTIONS(2476),
    [anon_sym_using] = ACTIONS(2476),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2478),
    [anon_sym___declspec] = ACTIONS(2476),
    [anon_sym___based] = ACTIONS(2476),
    [anon_sym___cdecl] = ACTIONS(2476),
    [anon_sym___clrcall] = ACTIONS(2476),
    [anon_sym___stdcall] = ACTIONS(2476),
    [anon_sym___fastcall] = ACTIONS(2476),
    [anon_sym___thiscall] = ACTIONS(2476),
    [anon_sym___vectorcall] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_signed] = ACTIONS(2476),
    [anon_sym_unsigned] = ACTIONS(2476),
    [anon_sym_long] = ACTIONS(2476),
    [anon_sym_short] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_register] = ACTIONS(2476),
    [anon_sym_inline] = ACTIONS(2476),
    [anon_sym___inline] = ACTIONS(2476),
    [anon_sym___inline__] = ACTIONS(2476),
    [anon_sym___forceinline] = ACTIONS(2476),
    [anon_sym_thread_local] = ACTIONS(2476),
    [anon_sym___thread] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_constexpr] = ACTIONS(2476),
    [anon_sym_volatile] = ACTIONS(2476),
    [anon_sym_restrict] = ACTIONS(2476),
    [anon_sym___restrict__] = ACTIONS(2476),
    [anon_sym__Atomic] = ACTIONS(2476),
    [anon_sym__Noreturn] = ACTIONS(2476),
    [anon_sym_noreturn] = ACTIONS(2476),
    [anon_sym__Nonnull] = ACTIONS(2476),
    [anon_sym_mutable] = ACTIONS(2476),
    [anon_sym_constinit] = ACTIONS(2476),
    [anon_sym_consteval] = ACTIONS(2476),
    [anon_sym_alignas] = ACTIONS(2476),
    [anon_sym__Alignas] = ACTIONS(2476),
    [sym_primitive_type] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [anon_sym_class] = ACTIONS(2476),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2476),
    [anon_sym_if] = ACTIONS(2476),
    [anon_sym_else] = ACTIONS(2476),
    [anon_sym_switch] = ACTIONS(2476),
    [anon_sym_case] = ACTIONS(2476),
    [anon_sym_default] = ACTIONS(2476),
    [anon_sym_while] = ACTIONS(2476),
    [anon_sym_do] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2476),
    [anon_sym_break] = ACTIONS(2476),
    [anon_sym_continue] = ACTIONS(2476),
    [anon_sym_goto] = ACTIONS(2476),
    [anon_sym___try] = ACTIONS(2476),
    [anon_sym___leave] = ACTIONS(2476),
    [anon_sym_not] = ACTIONS(2476),
    [anon_sym_compl] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2476),
    [anon_sym___alignof__] = ACTIONS(2476),
    [anon_sym___alignof] = ACTIONS(2476),
    [anon_sym__alignof] = ACTIONS(2476),
    [anon_sym_alignof] = ACTIONS(2476),
    [anon_sym__Alignof] = ACTIONS(2476),
    [anon_sym_offsetof] = ACTIONS(2476),
    [anon_sym__Generic] = ACTIONS(2476),
    [anon_sym_asm] = ACTIONS(2476),
    [anon_sym___asm__] = ACTIONS(2476),
    [anon_sym___asm] = ACTIONS(2476),
    [sym_number_literal] = ACTIONS(2478),
    [anon_sym_L_SQUOTE] = ACTIONS(2478),
    [anon_sym_u_SQUOTE] = ACTIONS(2478),
    [anon_sym_U_SQUOTE] = ACTIONS(2478),
    [anon_sym_u8_SQUOTE] = ACTIONS(2478),
    [anon_sym_SQUOTE] = ACTIONS(2478),
    [anon_sym_L_DQUOTE] = ACTIONS(2478),
    [anon_sym_u_DQUOTE] = ACTIONS(2478),
    [anon_sym_U_DQUOTE] = ACTIONS(2478),
    [anon_sym_u8_DQUOTE] = ACTIONS(2478),
    [anon_sym_DQUOTE] = ACTIONS(2478),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2476),
    [anon_sym_nullptr] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2476),
    [anon_sym_decltype] = ACTIONS(2476),
    [anon_sym_explicit] = ACTIONS(2476),
    [anon_sym_typename] = ACTIONS(2476),
    [anon_sym_template] = ACTIONS(2476),
    [anon_sym_operator] = ACTIONS(2476),
    [anon_sym_try] = ACTIONS(2476),
    [anon_sym_delete] = ACTIONS(2476),
    [anon_sym_throw] = ACTIONS(2476),
    [anon_sym_namespace] = ACTIONS(2476),
    [anon_sym_static_assert] = ACTIONS(2476),
    [anon_sym_concept] = ACTIONS(2476),
    [anon_sym_co_return] = ACTIONS(2476),
    [anon_sym_co_yield] = ACTIONS(2476),
    [anon_sym_catch] = ACTIONS(3097),
    [anon_sym_R_DQUOTE] = ACTIONS(2478),
    [anon_sym_LR_DQUOTE] = ACTIONS(2478),
    [anon_sym_uR_DQUOTE] = ACTIONS(2478),
    [anon_sym_UR_DQUOTE] = ACTIONS(2478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2478),
    [anon_sym_co_await] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2476),
    [anon_sym_requires] = ACTIONS(2476),
    [sym_this] = ACTIONS(2476),
  },
  [363] = {
    [sym_identifier] = ACTIONS(3100),
    [aux_sym_preproc_include_token1] = ACTIONS(3100),
    [aux_sym_preproc_def_token1] = ACTIONS(3100),
    [aux_sym_preproc_if_token1] = ACTIONS(3100),
    [aux_sym_preproc_if_token2] = ACTIONS(3100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3100),
    [aux_sym_preproc_else_token1] = ACTIONS(3100),
    [aux_sym_preproc_elif_token1] = ACTIONS(3100),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3100),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3100),
    [sym_preproc_directive] = ACTIONS(3100),
    [anon_sym_LPAREN2] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_AMP_AMP] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym___extension__] = ACTIONS(3100),
    [anon_sym_typedef] = ACTIONS(3100),
    [anon_sym_virtual] = ACTIONS(3100),
    [anon_sym_extern] = ACTIONS(3100),
    [anon_sym___attribute__] = ACTIONS(3100),
    [anon_sym___attribute] = ACTIONS(3100),
    [anon_sym_using] = ACTIONS(3100),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3102),
    [anon_sym___declspec] = ACTIONS(3100),
    [anon_sym___based] = ACTIONS(3100),
    [anon_sym___cdecl] = ACTIONS(3100),
    [anon_sym___clrcall] = ACTIONS(3100),
    [anon_sym___stdcall] = ACTIONS(3100),
    [anon_sym___fastcall] = ACTIONS(3100),
    [anon_sym___thiscall] = ACTIONS(3100),
    [anon_sym___vectorcall] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_signed] = ACTIONS(3100),
    [anon_sym_unsigned] = ACTIONS(3100),
    [anon_sym_long] = ACTIONS(3100),
    [anon_sym_short] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3100),
    [anon_sym_inline] = ACTIONS(3100),
    [anon_sym___inline] = ACTIONS(3100),
    [anon_sym___inline__] = ACTIONS(3100),
    [anon_sym___forceinline] = ACTIONS(3100),
    [anon_sym_thread_local] = ACTIONS(3100),
    [anon_sym___thread] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_constexpr] = ACTIONS(3100),
    [anon_sym_volatile] = ACTIONS(3100),
    [anon_sym_restrict] = ACTIONS(3100),
    [anon_sym___restrict__] = ACTIONS(3100),
    [anon_sym__Atomic] = ACTIONS(3100),
    [anon_sym__Noreturn] = ACTIONS(3100),
    [anon_sym_noreturn] = ACTIONS(3100),
    [anon_sym__Nonnull] = ACTIONS(3100),
    [anon_sym_mutable] = ACTIONS(3100),
    [anon_sym_constinit] = ACTIONS(3100),
    [anon_sym_consteval] = ACTIONS(3100),
    [anon_sym_alignas] = ACTIONS(3100),
    [anon_sym__Alignas] = ACTIONS(3100),
    [sym_primitive_type] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_struct] = ACTIONS(3100),
    [anon_sym_union] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_goto] = ACTIONS(3100),
    [anon_sym___try] = ACTIONS(3100),
    [anon_sym___leave] = ACTIONS(3100),
    [anon_sym_not] = ACTIONS(3100),
    [anon_sym_compl] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_sizeof] = ACTIONS(3100),
    [anon_sym___alignof__] = ACTIONS(3100),
    [anon_sym___alignof] = ACTIONS(3100),
    [anon_sym__alignof] = ACTIONS(3100),
    [anon_sym_alignof] = ACTIONS(3100),
    [anon_sym__Alignof] = ACTIONS(3100),
    [anon_sym_offsetof] = ACTIONS(3100),
    [anon_sym__Generic] = ACTIONS(3100),
    [anon_sym_asm] = ACTIONS(3100),
    [anon_sym___asm__] = ACTIONS(3100),
    [anon_sym___asm] = ACTIONS(3100),
    [sym_number_literal] = ACTIONS(3102),
    [anon_sym_L_SQUOTE] = ACTIONS(3102),
    [anon_sym_u_SQUOTE] = ACTIONS(3102),
    [anon_sym_U_SQUOTE] = ACTIONS(3102),
    [anon_sym_u8_SQUOTE] = ACTIONS(3102),
    [anon_sym_SQUOTE] = ACTIONS(3102),
    [anon_sym_L_DQUOTE] = ACTIONS(3102),
    [anon_sym_u_DQUOTE] = ACTIONS(3102),
    [anon_sym_U_DQUOTE] = ACTIONS(3102),
    [anon_sym_u8_DQUOTE] = ACTIONS(3102),
    [anon_sym_DQUOTE] = ACTIONS(3102),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [anon_sym_NULL] = ACTIONS(3100),
    [anon_sym_nullptr] = ACTIONS(3100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3100),
    [anon_sym_decltype] = ACTIONS(3100),
    [anon_sym_explicit] = ACTIONS(3100),
    [anon_sym_typename] = ACTIONS(3100),
    [anon_sym_template] = ACTIONS(3100),
    [anon_sym_operator] = ACTIONS(3100),
    [anon_sym_try] = ACTIONS(3100),
    [anon_sym_delete] = ACTIONS(3100),
    [anon_sym_throw] = ACTIONS(3100),
    [anon_sym_namespace] = ACTIONS(3100),
    [anon_sym_static_assert] = ACTIONS(3100),
    [anon_sym_concept] = ACTIONS(3100),
    [anon_sym_co_return] = ACTIONS(3100),
    [anon_sym_co_yield] = ACTIONS(3100),
    [anon_sym_R_DQUOTE] = ACTIONS(3102),
    [anon_sym_LR_DQUOTE] = ACTIONS(3102),
    [anon_sym_uR_DQUOTE] = ACTIONS(3102),
    [anon_sym_UR_DQUOTE] = ACTIONS(3102),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3102),
    [anon_sym_co_await] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_requires] = ACTIONS(3100),
    [sym_this] = ACTIONS(3100),
  },
  [364] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_include_token1] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token2] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [aux_sym_preproc_else_token1] = ACTIONS(3104),
    [aux_sym_preproc_elif_token1] = ACTIONS(3104),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym___cdecl] = ACTIONS(3104),
    [anon_sym___clrcall] = ACTIONS(3104),
    [anon_sym___stdcall] = ACTIONS(3104),
    [anon_sym___fastcall] = ACTIONS(3104),
    [anon_sym___thiscall] = ACTIONS(3104),
    [anon_sym___vectorcall] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym___try] = ACTIONS(3104),
    [anon_sym___leave] = ACTIONS(3104),
    [anon_sym_not] = ACTIONS(3104),
    [anon_sym_compl] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3106),
    [anon_sym_PLUS_PLUS] = ACTIONS(3106),
    [anon_sym_sizeof] = ACTIONS(3104),
    [anon_sym___alignof__] = ACTIONS(3104),
    [anon_sym___alignof] = ACTIONS(3104),
    [anon_sym__alignof] = ACTIONS(3104),
    [anon_sym_alignof] = ACTIONS(3104),
    [anon_sym__Alignof] = ACTIONS(3104),
    [anon_sym_offsetof] = ACTIONS(3104),
    [anon_sym__Generic] = ACTIONS(3104),
    [anon_sym_asm] = ACTIONS(3104),
    [anon_sym___asm__] = ACTIONS(3104),
    [anon_sym___asm] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3106),
    [anon_sym_L_SQUOTE] = ACTIONS(3106),
    [anon_sym_u_SQUOTE] = ACTIONS(3106),
    [anon_sym_U_SQUOTE] = ACTIONS(3106),
    [anon_sym_u8_SQUOTE] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3106),
    [anon_sym_L_DQUOTE] = ACTIONS(3106),
    [anon_sym_u_DQUOTE] = ACTIONS(3106),
    [anon_sym_U_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8_DQUOTE] = ACTIONS(3106),
    [anon_sym_DQUOTE] = ACTIONS(3106),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [anon_sym_NULL] = ACTIONS(3104),
    [anon_sym_nullptr] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_try] = ACTIONS(3104),
    [anon_sym_delete] = ACTIONS(3104),
    [anon_sym_throw] = ACTIONS(3104),
    [anon_sym_namespace] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
    [anon_sym_concept] = ACTIONS(3104),
    [anon_sym_co_return] = ACTIONS(3104),
    [anon_sym_co_yield] = ACTIONS(3104),
    [anon_sym_R_DQUOTE] = ACTIONS(3106),
    [anon_sym_LR_DQUOTE] = ACTIONS(3106),
    [anon_sym_uR_DQUOTE] = ACTIONS(3106),
    [anon_sym_UR_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3106),
    [anon_sym_co_await] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_requires] = ACTIONS(3104),
    [sym_this] = ACTIONS(3104),
  },
  [365] = {
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_include_token1] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token2] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [aux_sym_preproc_else_token1] = ACTIONS(3108),
    [aux_sym_preproc_elif_token1] = ACTIONS(3108),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_BANG] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym___attribute] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym___cdecl] = ACTIONS(3108),
    [anon_sym___clrcall] = ACTIONS(3108),
    [anon_sym___stdcall] = ACTIONS(3108),
    [anon_sym___fastcall] = ACTIONS(3108),
    [anon_sym___thiscall] = ACTIONS(3108),
    [anon_sym___vectorcall] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym__Nonnull] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym__Alignas] = ACTIONS(3108),
    [sym_primitive_type] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [anon_sym_if] = ACTIONS(3108),
    [anon_sym_switch] = ACTIONS(3108),
    [anon_sym_case] = ACTIONS(3108),
    [anon_sym_default] = ACTIONS(3108),
    [anon_sym_while] = ACTIONS(3108),
    [anon_sym_do] = ACTIONS(3108),
    [anon_sym_for] = ACTIONS(3108),
    [anon_sym_return] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3108),
    [anon_sym_continue] = ACTIONS(3108),
    [anon_sym_goto] = ACTIONS(3108),
    [anon_sym___try] = ACTIONS(3108),
    [anon_sym___leave] = ACTIONS(3108),
    [anon_sym_not] = ACTIONS(3108),
    [anon_sym_compl] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_sizeof] = ACTIONS(3108),
    [anon_sym___alignof__] = ACTIONS(3108),
    [anon_sym___alignof] = ACTIONS(3108),
    [anon_sym__alignof] = ACTIONS(3108),
    [anon_sym_alignof] = ACTIONS(3108),
    [anon_sym__Alignof] = ACTIONS(3108),
    [anon_sym_offsetof] = ACTIONS(3108),
    [anon_sym__Generic] = ACTIONS(3108),
    [anon_sym_asm] = ACTIONS(3108),
    [anon_sym___asm__] = ACTIONS(3108),
    [anon_sym___asm] = ACTIONS(3108),
    [sym_number_literal] = ACTIONS(3110),
    [anon_sym_L_SQUOTE] = ACTIONS(3110),
    [anon_sym_u_SQUOTE] = ACTIONS(3110),
    [anon_sym_U_SQUOTE] = ACTIONS(3110),
    [anon_sym_u8_SQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [anon_sym_L_DQUOTE] = ACTIONS(3110),
    [anon_sym_u_DQUOTE] = ACTIONS(3110),
    [anon_sym_U_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8_DQUOTE] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [anon_sym_NULL] = ACTIONS(3108),
    [anon_sym_nullptr] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_try] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(3108),
    [anon_sym_throw] = ACTIONS(3108),
    [anon_sym_namespace] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
    [anon_sym_concept] = ACTIONS(3108),
    [anon_sym_co_return] = ACTIONS(3108),
    [anon_sym_co_yield] = ACTIONS(3108),
    [anon_sym_R_DQUOTE] = ACTIONS(3110),
    [anon_sym_LR_DQUOTE] = ACTIONS(3110),
    [anon_sym_uR_DQUOTE] = ACTIONS(3110),
    [anon_sym_UR_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3110),
    [anon_sym_co_await] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_requires] = ACTIONS(3108),
    [sym_this] = ACTIONS(3108),
  },
  [366] = {
    [sym_identifier] = ACTIONS(3112),
    [aux_sym_preproc_include_token1] = ACTIONS(3112),
    [aux_sym_preproc_def_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token2] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3112),
    [aux_sym_preproc_else_token1] = ACTIONS(3112),
    [aux_sym_preproc_elif_token1] = ACTIONS(3112),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3112),
    [sym_preproc_directive] = ACTIONS(3112),
    [anon_sym_LPAREN2] = ACTIONS(3114),
    [anon_sym_BANG] = ACTIONS(3114),
    [anon_sym_TILDE] = ACTIONS(3114),
    [anon_sym_DASH] = ACTIONS(3112),
    [anon_sym_PLUS] = ACTIONS(3112),
    [anon_sym_STAR] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3112),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym___extension__] = ACTIONS(3112),
    [anon_sym_typedef] = ACTIONS(3112),
    [anon_sym_virtual] = ACTIONS(3112),
    [anon_sym_extern] = ACTIONS(3112),
    [anon_sym___attribute__] = ACTIONS(3112),
    [anon_sym___attribute] = ACTIONS(3112),
    [anon_sym_using] = ACTIONS(3112),
    [anon_sym_COLON_COLON] = ACTIONS(3114),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3114),
    [anon_sym___declspec] = ACTIONS(3112),
    [anon_sym___based] = ACTIONS(3112),
    [anon_sym___cdecl] = ACTIONS(3112),
    [anon_sym___clrcall] = ACTIONS(3112),
    [anon_sym___stdcall] = ACTIONS(3112),
    [anon_sym___fastcall] = ACTIONS(3112),
    [anon_sym___thiscall] = ACTIONS(3112),
    [anon_sym___vectorcall] = ACTIONS(3112),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_signed] = ACTIONS(3112),
    [anon_sym_unsigned] = ACTIONS(3112),
    [anon_sym_long] = ACTIONS(3112),
    [anon_sym_short] = ACTIONS(3112),
    [anon_sym_LBRACK] = ACTIONS(3112),
    [anon_sym_static] = ACTIONS(3112),
    [anon_sym_register] = ACTIONS(3112),
    [anon_sym_inline] = ACTIONS(3112),
    [anon_sym___inline] = ACTIONS(3112),
    [anon_sym___inline__] = ACTIONS(3112),
    [anon_sym___forceinline] = ACTIONS(3112),
    [anon_sym_thread_local] = ACTIONS(3112),
    [anon_sym___thread] = ACTIONS(3112),
    [anon_sym_const] = ACTIONS(3112),
    [anon_sym_constexpr] = ACTIONS(3112),
    [anon_sym_volatile] = ACTIONS(3112),
    [anon_sym_restrict] = ACTIONS(3112),
    [anon_sym___restrict__] = ACTIONS(3112),
    [anon_sym__Atomic] = ACTIONS(3112),
    [anon_sym__Noreturn] = ACTIONS(3112),
    [anon_sym_noreturn] = ACTIONS(3112),
    [anon_sym__Nonnull] = ACTIONS(3112),
    [anon_sym_mutable] = ACTIONS(3112),
    [anon_sym_constinit] = ACTIONS(3112),
    [anon_sym_consteval] = ACTIONS(3112),
    [anon_sym_alignas] = ACTIONS(3112),
    [anon_sym__Alignas] = ACTIONS(3112),
    [sym_primitive_type] = ACTIONS(3112),
    [anon_sym_enum] = ACTIONS(3112),
    [anon_sym_class] = ACTIONS(3112),
    [anon_sym_struct] = ACTIONS(3112),
    [anon_sym_union] = ACTIONS(3112),
    [anon_sym_if] = ACTIONS(3112),
    [anon_sym_switch] = ACTIONS(3112),
    [anon_sym_case] = ACTIONS(3112),
    [anon_sym_default] = ACTIONS(3112),
    [anon_sym_while] = ACTIONS(3112),
    [anon_sym_do] = ACTIONS(3112),
    [anon_sym_for] = ACTIONS(3112),
    [anon_sym_return] = ACTIONS(3112),
    [anon_sym_break] = ACTIONS(3112),
    [anon_sym_continue] = ACTIONS(3112),
    [anon_sym_goto] = ACTIONS(3112),
    [anon_sym___try] = ACTIONS(3112),
    [anon_sym___leave] = ACTIONS(3112),
    [anon_sym_not] = ACTIONS(3112),
    [anon_sym_compl] = ACTIONS(3112),
    [anon_sym_DASH_DASH] = ACTIONS(3114),
    [anon_sym_PLUS_PLUS] = ACTIONS(3114),
    [anon_sym_sizeof] = ACTIONS(3112),
    [anon_sym___alignof__] = ACTIONS(3112),
    [anon_sym___alignof] = ACTIONS(3112),
    [anon_sym__alignof] = ACTIONS(3112),
    [anon_sym_alignof] = ACTIONS(3112),
    [anon_sym__Alignof] = ACTIONS(3112),
    [anon_sym_offsetof] = ACTIONS(3112),
    [anon_sym__Generic] = ACTIONS(3112),
    [anon_sym_asm] = ACTIONS(3112),
    [anon_sym___asm__] = ACTIONS(3112),
    [anon_sym___asm] = ACTIONS(3112),
    [sym_number_literal] = ACTIONS(3114),
    [anon_sym_L_SQUOTE] = ACTIONS(3114),
    [anon_sym_u_SQUOTE] = ACTIONS(3114),
    [anon_sym_U_SQUOTE] = ACTIONS(3114),
    [anon_sym_u8_SQUOTE] = ACTIONS(3114),
    [anon_sym_SQUOTE] = ACTIONS(3114),
    [anon_sym_L_DQUOTE] = ACTIONS(3114),
    [anon_sym_u_DQUOTE] = ACTIONS(3114),
    [anon_sym_U_DQUOTE] = ACTIONS(3114),
    [anon_sym_u8_DQUOTE] = ACTIONS(3114),
    [anon_sym_DQUOTE] = ACTIONS(3114),
    [sym_true] = ACTIONS(3112),
    [sym_false] = ACTIONS(3112),
    [anon_sym_NULL] = ACTIONS(3112),
    [anon_sym_nullptr] = ACTIONS(3112),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3112),
    [anon_sym_decltype] = ACTIONS(3112),
    [anon_sym_explicit] = ACTIONS(3112),
    [anon_sym_typename] = ACTIONS(3112),
    [anon_sym_template] = ACTIONS(3112),
    [anon_sym_operator] = ACTIONS(3112),
    [anon_sym_try] = ACTIONS(3112),
    [anon_sym_delete] = ACTIONS(3112),
    [anon_sym_throw] = ACTIONS(3112),
    [anon_sym_namespace] = ACTIONS(3112),
    [anon_sym_static_assert] = ACTIONS(3112),
    [anon_sym_concept] = ACTIONS(3112),
    [anon_sym_co_return] = ACTIONS(3112),
    [anon_sym_co_yield] = ACTIONS(3112),
    [anon_sym_R_DQUOTE] = ACTIONS(3114),
    [anon_sym_LR_DQUOTE] = ACTIONS(3114),
    [anon_sym_uR_DQUOTE] = ACTIONS(3114),
    [anon_sym_UR_DQUOTE] = ACTIONS(3114),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3114),
    [anon_sym_co_await] = ACTIONS(3112),
    [anon_sym_new] = ACTIONS(3112),
    [anon_sym_requires] = ACTIONS(3112),
    [sym_this] = ACTIONS(3112),
  },
  [367] = {
    [ts_builtin_sym_end] = ACTIONS(2761),
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_include_token1] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym___cdecl] = ACTIONS(2759),
    [anon_sym___clrcall] = ACTIONS(2759),
    [anon_sym___stdcall] = ACTIONS(2759),
    [anon_sym___fastcall] = ACTIONS(2759),
    [anon_sym___thiscall] = ACTIONS(2759),
    [anon_sym___vectorcall] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_switch] = ACTIONS(2759),
    [anon_sym_case] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_goto] = ACTIONS(2759),
    [anon_sym___try] = ACTIONS(2759),
    [anon_sym___leave] = ACTIONS(2759),
    [anon_sym_not] = ACTIONS(2759),
    [anon_sym_compl] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_sizeof] = ACTIONS(2759),
    [anon_sym___alignof__] = ACTIONS(2759),
    [anon_sym___alignof] = ACTIONS(2759),
    [anon_sym__alignof] = ACTIONS(2759),
    [anon_sym_alignof] = ACTIONS(2759),
    [anon_sym__Alignof] = ACTIONS(2759),
    [anon_sym_offsetof] = ACTIONS(2759),
    [anon_sym__Generic] = ACTIONS(2759),
    [anon_sym_asm] = ACTIONS(2759),
    [anon_sym___asm__] = ACTIONS(2759),
    [anon_sym___asm] = ACTIONS(2759),
    [sym_number_literal] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2761),
    [anon_sym_u_SQUOTE] = ACTIONS(2761),
    [anon_sym_U_SQUOTE] = ACTIONS(2761),
    [anon_sym_u8_SQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_L_DQUOTE] = ACTIONS(2761),
    [anon_sym_u_DQUOTE] = ACTIONS(2761),
    [anon_sym_U_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8_DQUOTE] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2759),
    [anon_sym_nullptr] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_export] = ACTIONS(2759),
    [anon_sym_module] = ACTIONS(2759),
    [anon_sym_import] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2759),
    [anon_sym_throw] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
    [anon_sym_concept] = ACTIONS(2759),
    [anon_sym_co_return] = ACTIONS(2759),
    [anon_sym_co_yield] = ACTIONS(2759),
    [anon_sym_R_DQUOTE] = ACTIONS(2761),
    [anon_sym_LR_DQUOTE] = ACTIONS(2761),
    [anon_sym_uR_DQUOTE] = ACTIONS(2761),
    [anon_sym_UR_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2761),
    [anon_sym_co_await] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_requires] = ACTIONS(2759),
    [sym_this] = ACTIONS(2759),
  },
  [368] = {
    [ts_builtin_sym_end] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_export] = ACTIONS(2767),
    [anon_sym_module] = ACTIONS(2767),
    [anon_sym_import] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_export] = ACTIONS(2767),
    [anon_sym_module] = ACTIONS(2767),
    [anon_sym_import] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [370] = {
    [sym_catch_clause] = STATE(231),
    [aux_sym_constructor_try_statement_repeat1] = STATE(231),
    [ts_builtin_sym_end] = ACTIONS(2549),
    [sym_identifier] = ACTIONS(2547),
    [aux_sym_preproc_include_token1] = ACTIONS(2547),
    [aux_sym_preproc_def_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token1] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2547),
    [sym_preproc_directive] = ACTIONS(2547),
    [anon_sym_LPAREN2] = ACTIONS(2549),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_TILDE] = ACTIONS(2549),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_PLUS] = ACTIONS(2547),
    [anon_sym_STAR] = ACTIONS(2549),
    [anon_sym_AMP_AMP] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(2549),
    [anon_sym___extension__] = ACTIONS(2547),
    [anon_sym_typedef] = ACTIONS(2547),
    [anon_sym_virtual] = ACTIONS(2547),
    [anon_sym_extern] = ACTIONS(2547),
    [anon_sym___attribute__] = ACTIONS(2547),
    [anon_sym___attribute] = ACTIONS(2547),
    [anon_sym_using] = ACTIONS(2547),
    [anon_sym_COLON_COLON] = ACTIONS(2549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2549),
    [anon_sym___declspec] = ACTIONS(2547),
    [anon_sym___based] = ACTIONS(2547),
    [anon_sym___cdecl] = ACTIONS(2547),
    [anon_sym___clrcall] = ACTIONS(2547),
    [anon_sym___stdcall] = ACTIONS(2547),
    [anon_sym___fastcall] = ACTIONS(2547),
    [anon_sym___thiscall] = ACTIONS(2547),
    [anon_sym___vectorcall] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [anon_sym_signed] = ACTIONS(2547),
    [anon_sym_unsigned] = ACTIONS(2547),
    [anon_sym_long] = ACTIONS(2547),
    [anon_sym_short] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_register] = ACTIONS(2547),
    [anon_sym_inline] = ACTIONS(2547),
    [anon_sym___inline] = ACTIONS(2547),
    [anon_sym___inline__] = ACTIONS(2547),
    [anon_sym___forceinline] = ACTIONS(2547),
    [anon_sym_thread_local] = ACTIONS(2547),
    [anon_sym___thread] = ACTIONS(2547),
    [anon_sym_const] = ACTIONS(2547),
    [anon_sym_constexpr] = ACTIONS(2547),
    [anon_sym_volatile] = ACTIONS(2547),
    [anon_sym_restrict] = ACTIONS(2547),
    [anon_sym___restrict__] = ACTIONS(2547),
    [anon_sym__Atomic] = ACTIONS(2547),
    [anon_sym__Noreturn] = ACTIONS(2547),
    [anon_sym_noreturn] = ACTIONS(2547),
    [anon_sym__Nonnull] = ACTIONS(2547),
    [anon_sym_mutable] = ACTIONS(2547),
    [anon_sym_constinit] = ACTIONS(2547),
    [anon_sym_consteval] = ACTIONS(2547),
    [anon_sym_alignas] = ACTIONS(2547),
    [anon_sym__Alignas] = ACTIONS(2547),
    [sym_primitive_type] = ACTIONS(2547),
    [anon_sym_enum] = ACTIONS(2547),
    [anon_sym_class] = ACTIONS(2547),
    [anon_sym_struct] = ACTIONS(2547),
    [anon_sym_union] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(2547),
    [anon_sym_switch] = ACTIONS(2547),
    [anon_sym_case] = ACTIONS(2547),
    [anon_sym_default] = ACTIONS(2547),
    [anon_sym_while] = ACTIONS(2547),
    [anon_sym_do] = ACTIONS(2547),
    [anon_sym_for] = ACTIONS(2547),
    [anon_sym_return] = ACTIONS(2547),
    [anon_sym_break] = ACTIONS(2547),
    [anon_sym_continue] = ACTIONS(2547),
    [anon_sym_goto] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2547),
    [anon_sym_compl] = ACTIONS(2547),
    [anon_sym_DASH_DASH] = ACTIONS(2549),
    [anon_sym_PLUS_PLUS] = ACTIONS(2549),
    [anon_sym_sizeof] = ACTIONS(2547),
    [anon_sym___alignof__] = ACTIONS(2547),
    [anon_sym___alignof] = ACTIONS(2547),
    [anon_sym__alignof] = ACTIONS(2547),
    [anon_sym_alignof] = ACTIONS(2547),
    [anon_sym__Alignof] = ACTIONS(2547),
    [anon_sym_offsetof] = ACTIONS(2547),
    [anon_sym__Generic] = ACTIONS(2547),
    [anon_sym_asm] = ACTIONS(2547),
    [anon_sym___asm__] = ACTIONS(2547),
    [anon_sym___asm] = ACTIONS(2547),
    [sym_number_literal] = ACTIONS(2549),
    [anon_sym_L_SQUOTE] = ACTIONS(2549),
    [anon_sym_u_SQUOTE] = ACTIONS(2549),
    [anon_sym_U_SQUOTE] = ACTIONS(2549),
    [anon_sym_u8_SQUOTE] = ACTIONS(2549),
    [anon_sym_SQUOTE] = ACTIONS(2549),
    [anon_sym_L_DQUOTE] = ACTIONS(2549),
    [anon_sym_u_DQUOTE] = ACTIONS(2549),
    [anon_sym_U_DQUOTE] = ACTIONS(2549),
    [anon_sym_u8_DQUOTE] = ACTIONS(2549),
    [anon_sym_DQUOTE] = ACTIONS(2549),
    [sym_true] = ACTIONS(2547),
    [sym_false] = ACTIONS(2547),
    [anon_sym_NULL] = ACTIONS(2547),
    [anon_sym_nullptr] = ACTIONS(2547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2547),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2547),
    [anon_sym_export] = ACTIONS(2547),
    [anon_sym_module] = ACTIONS(2547),
    [anon_sym_import] = ACTIONS(2547),
    [anon_sym_template] = ACTIONS(2547),
    [anon_sym_operator] = ACTIONS(2547),
    [anon_sym_try] = ACTIONS(2547),
    [anon_sym_delete] = ACTIONS(2547),
    [anon_sym_throw] = ACTIONS(2547),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_static_assert] = ACTIONS(2547),
    [anon_sym_concept] = ACTIONS(2547),
    [anon_sym_co_return] = ACTIONS(2547),
    [anon_sym_co_yield] = ACTIONS(2547),
    [anon_sym_catch] = ACTIONS(2599),
    [anon_sym_R_DQUOTE] = ACTIONS(2549),
    [anon_sym_LR_DQUOTE] = ACTIONS(2549),
    [anon_sym_uR_DQUOTE] = ACTIONS(2549),
    [anon_sym_UR_DQUOTE] = ACTIONS(2549),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2549),
    [anon_sym_co_await] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2547),
    [anon_sym_requires] = ACTIONS(2547),
    [sym_this] = ACTIONS(2547),
  },
  [371] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4408),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7129),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7558),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [372] = {
    [ts_builtin_sym_end] = ACTIONS(2701),
    [sym_identifier] = ACTIONS(2699),
    [aux_sym_preproc_include_token1] = ACTIONS(2699),
    [aux_sym_preproc_def_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token1] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2699),
    [sym_preproc_directive] = ACTIONS(2699),
    [anon_sym_LPAREN2] = ACTIONS(2701),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2699),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_AMP_AMP] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym___extension__] = ACTIONS(2699),
    [anon_sym_typedef] = ACTIONS(2699),
    [anon_sym_virtual] = ACTIONS(2699),
    [anon_sym_extern] = ACTIONS(2699),
    [anon_sym___attribute__] = ACTIONS(2699),
    [anon_sym___attribute] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2701),
    [anon_sym___declspec] = ACTIONS(2699),
    [anon_sym___based] = ACTIONS(2699),
    [anon_sym___cdecl] = ACTIONS(2699),
    [anon_sym___clrcall] = ACTIONS(2699),
    [anon_sym___stdcall] = ACTIONS(2699),
    [anon_sym___fastcall] = ACTIONS(2699),
    [anon_sym___thiscall] = ACTIONS(2699),
    [anon_sym___vectorcall] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(2701),
    [anon_sym_signed] = ACTIONS(2699),
    [anon_sym_unsigned] = ACTIONS(2699),
    [anon_sym_long] = ACTIONS(2699),
    [anon_sym_short] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_register] = ACTIONS(2699),
    [anon_sym_inline] = ACTIONS(2699),
    [anon_sym___inline] = ACTIONS(2699),
    [anon_sym___inline__] = ACTIONS(2699),
    [anon_sym___forceinline] = ACTIONS(2699),
    [anon_sym_thread_local] = ACTIONS(2699),
    [anon_sym___thread] = ACTIONS(2699),
    [anon_sym_const] = ACTIONS(2699),
    [anon_sym_constexpr] = ACTIONS(2699),
    [anon_sym_volatile] = ACTIONS(2699),
    [anon_sym_restrict] = ACTIONS(2699),
    [anon_sym___restrict__] = ACTIONS(2699),
    [anon_sym__Atomic] = ACTIONS(2699),
    [anon_sym__Noreturn] = ACTIONS(2699),
    [anon_sym_noreturn] = ACTIONS(2699),
    [anon_sym__Nonnull] = ACTIONS(2699),
    [anon_sym_mutable] = ACTIONS(2699),
    [anon_sym_constinit] = ACTIONS(2699),
    [anon_sym_consteval] = ACTIONS(2699),
    [anon_sym_alignas] = ACTIONS(2699),
    [anon_sym__Alignas] = ACTIONS(2699),
    [sym_primitive_type] = ACTIONS(2699),
    [anon_sym_enum] = ACTIONS(2699),
    [anon_sym_class] = ACTIONS(2699),
    [anon_sym_struct] = ACTIONS(2699),
    [anon_sym_union] = ACTIONS(2699),
    [anon_sym_if] = ACTIONS(2699),
    [anon_sym_else] = ACTIONS(2699),
    [anon_sym_switch] = ACTIONS(2699),
    [anon_sym_case] = ACTIONS(2699),
    [anon_sym_default] = ACTIONS(2699),
    [anon_sym_while] = ACTIONS(2699),
    [anon_sym_do] = ACTIONS(2699),
    [anon_sym_for] = ACTIONS(2699),
    [anon_sym_return] = ACTIONS(2699),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_continue] = ACTIONS(2699),
    [anon_sym_goto] = ACTIONS(2699),
    [anon_sym___try] = ACTIONS(2699),
    [anon_sym___leave] = ACTIONS(2699),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_compl] = ACTIONS(2699),
    [anon_sym_DASH_DASH] = ACTIONS(2701),
    [anon_sym_PLUS_PLUS] = ACTIONS(2701),
    [anon_sym_sizeof] = ACTIONS(2699),
    [anon_sym___alignof__] = ACTIONS(2699),
    [anon_sym___alignof] = ACTIONS(2699),
    [anon_sym__alignof] = ACTIONS(2699),
    [anon_sym_alignof] = ACTIONS(2699),
    [anon_sym__Alignof] = ACTIONS(2699),
    [anon_sym_offsetof] = ACTIONS(2699),
    [anon_sym__Generic] = ACTIONS(2699),
    [anon_sym_asm] = ACTIONS(2699),
    [anon_sym___asm__] = ACTIONS(2699),
    [anon_sym___asm] = ACTIONS(2699),
    [sym_number_literal] = ACTIONS(2701),
    [anon_sym_L_SQUOTE] = ACTIONS(2701),
    [anon_sym_u_SQUOTE] = ACTIONS(2701),
    [anon_sym_U_SQUOTE] = ACTIONS(2701),
    [anon_sym_u8_SQUOTE] = ACTIONS(2701),
    [anon_sym_SQUOTE] = ACTIONS(2701),
    [anon_sym_L_DQUOTE] = ACTIONS(2701),
    [anon_sym_u_DQUOTE] = ACTIONS(2701),
    [anon_sym_U_DQUOTE] = ACTIONS(2701),
    [anon_sym_u8_DQUOTE] = ACTIONS(2701),
    [anon_sym_DQUOTE] = ACTIONS(2701),
    [sym_true] = ACTIONS(2699),
    [sym_false] = ACTIONS(2699),
    [anon_sym_NULL] = ACTIONS(2699),
    [anon_sym_nullptr] = ACTIONS(2699),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2699),
    [anon_sym_decltype] = ACTIONS(2699),
    [anon_sym_explicit] = ACTIONS(2699),
    [anon_sym_typename] = ACTIONS(2699),
    [anon_sym_export] = ACTIONS(2699),
    [anon_sym_module] = ACTIONS(2699),
    [anon_sym_import] = ACTIONS(2699),
    [anon_sym_template] = ACTIONS(2699),
    [anon_sym_operator] = ACTIONS(2699),
    [anon_sym_try] = ACTIONS(2699),
    [anon_sym_delete] = ACTIONS(2699),
    [anon_sym_throw] = ACTIONS(2699),
    [anon_sym_namespace] = ACTIONS(2699),
    [anon_sym_static_assert] = ACTIONS(2699),
    [anon_sym_concept] = ACTIONS(2699),
    [anon_sym_co_return] = ACTIONS(2699),
    [anon_sym_co_yield] = ACTIONS(2699),
    [anon_sym_R_DQUOTE] = ACTIONS(2701),
    [anon_sym_LR_DQUOTE] = ACTIONS(2701),
    [anon_sym_uR_DQUOTE] = ACTIONS(2701),
    [anon_sym_UR_DQUOTE] = ACTIONS(2701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2701),
    [anon_sym_co_await] = ACTIONS(2699),
    [anon_sym_new] = ACTIONS(2699),
    [anon_sym_requires] = ACTIONS(2699),
    [sym_this] = ACTIONS(2699),
  },
  [373] = {
    [ts_builtin_sym_end] = ACTIONS(2641),
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym___attribute] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym__Nonnull] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym__Alignas] = ACTIONS(2639),
    [sym_primitive_type] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [anon_sym___asm] = ACTIONS(2639),
    [sym_number_literal] = ACTIONS(2641),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_export] = ACTIONS(2639),
    [anon_sym_module] = ACTIONS(2639),
    [anon_sym_import] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [374] = {
    [sym_preproc_def] = STATE(376),
    [sym_preproc_function_def] = STATE(376),
    [sym_preproc_call] = STATE(376),
    [sym_preproc_if_in_field_declaration_list] = STATE(376),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(376),
    [sym_preproc_else_in_field_declaration_list] = STATE(8394),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8394),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8394),
    [sym_type_definition] = STATE(376),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(376),
    [sym_field_declaration] = STATE(376),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(376),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(376),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(376),
    [sym_operator_cast_declaration] = STATE(376),
    [sym_constructor_or_destructor_definition] = STATE(376),
    [sym_constructor_or_destructor_declaration] = STATE(376),
    [sym_friend_declaration] = STATE(376),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(376),
    [sym_alias_declaration] = STATE(376),
    [sym_static_assert_declaration] = STATE(376),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(376),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [375] = {
    [sym_preproc_def] = STATE(377),
    [sym_preproc_function_def] = STATE(377),
    [sym_preproc_call] = STATE(377),
    [sym_preproc_if_in_field_declaration_list] = STATE(377),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(377),
    [sym_preproc_else_in_field_declaration_list] = STATE(8116),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8116),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8116),
    [sym_type_definition] = STATE(377),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(377),
    [sym_field_declaration] = STATE(377),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(377),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(377),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(377),
    [sym_operator_cast_declaration] = STATE(377),
    [sym_constructor_or_destructor_definition] = STATE(377),
    [sym_constructor_or_destructor_declaration] = STATE(377),
    [sym_friend_declaration] = STATE(377),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(377),
    [sym_alias_declaration] = STATE(377),
    [sym_static_assert_declaration] = STATE(377),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(377),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [376] = {
    [sym_preproc_def] = STATE(587),
    [sym_preproc_function_def] = STATE(587),
    [sym_preproc_call] = STATE(587),
    [sym_preproc_if_in_field_declaration_list] = STATE(587),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(587),
    [sym_preproc_else_in_field_declaration_list] = STATE(8239),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8239),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8239),
    [sym_type_definition] = STATE(587),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(587),
    [sym_field_declaration] = STATE(587),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(587),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(587),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(587),
    [sym_operator_cast_declaration] = STATE(587),
    [sym_constructor_or_destructor_definition] = STATE(587),
    [sym_constructor_or_destructor_declaration] = STATE(587),
    [sym_friend_declaration] = STATE(587),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(587),
    [sym_alias_declaration] = STATE(587),
    [sym_static_assert_declaration] = STATE(587),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(587),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [377] = {
    [sym_preproc_def] = STATE(587),
    [sym_preproc_function_def] = STATE(587),
    [sym_preproc_call] = STATE(587),
    [sym_preproc_if_in_field_declaration_list] = STATE(587),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(587),
    [sym_preproc_else_in_field_declaration_list] = STATE(8771),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8771),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8771),
    [sym_type_definition] = STATE(587),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(587),
    [sym_field_declaration] = STATE(587),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(587),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(587),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(587),
    [sym_operator_cast_declaration] = STATE(587),
    [sym_constructor_or_destructor_definition] = STATE(587),
    [sym_constructor_or_destructor_declaration] = STATE(587),
    [sym_friend_declaration] = STATE(587),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(587),
    [sym_alias_declaration] = STATE(587),
    [sym_static_assert_declaration] = STATE(587),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(587),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [378] = {
    [sym_preproc_def] = STATE(394),
    [sym_preproc_function_def] = STATE(394),
    [sym_preproc_call] = STATE(394),
    [sym_preproc_if_in_field_declaration_list] = STATE(394),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(394),
    [sym_preproc_else_in_field_declaration_list] = STATE(8754),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8754),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8754),
    [sym_type_definition] = STATE(394),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(394),
    [sym_field_declaration] = STATE(394),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(394),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(394),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(394),
    [sym_operator_cast_declaration] = STATE(394),
    [sym_constructor_or_destructor_definition] = STATE(394),
    [sym_constructor_or_destructor_declaration] = STATE(394),
    [sym_friend_declaration] = STATE(394),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(394),
    [sym_alias_declaration] = STATE(394),
    [sym_static_assert_declaration] = STATE(394),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(394),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3196),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [379] = {
    [sym_preproc_def] = STATE(587),
    [sym_preproc_function_def] = STATE(587),
    [sym_preproc_call] = STATE(587),
    [sym_preproc_if_in_field_declaration_list] = STATE(587),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(587),
    [sym_preproc_else_in_field_declaration_list] = STATE(8830),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8830),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8830),
    [sym_type_definition] = STATE(587),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(587),
    [sym_field_declaration] = STATE(587),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(587),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(587),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(587),
    [sym_operator_cast_declaration] = STATE(587),
    [sym_constructor_or_destructor_definition] = STATE(587),
    [sym_constructor_or_destructor_declaration] = STATE(587),
    [sym_friend_declaration] = STATE(587),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(587),
    [sym_alias_declaration] = STATE(587),
    [sym_static_assert_declaration] = STATE(587),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(587),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3200),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [380] = {
    [ts_builtin_sym_end] = ACTIONS(2667),
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym___attribute] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym__Nonnull] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym__Alignas] = ACTIONS(2665),
    [sym_primitive_type] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [anon_sym___asm] = ACTIONS(2665),
    [sym_number_literal] = ACTIONS(2667),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_export] = ACTIONS(2665),
    [anon_sym_module] = ACTIONS(2665),
    [anon_sym_import] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [381] = {
    [ts_builtin_sym_end] = ACTIONS(2671),
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym___attribute] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym__Nonnull] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym__Alignas] = ACTIONS(2669),
    [sym_primitive_type] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [anon_sym___asm] = ACTIONS(2669),
    [sym_number_literal] = ACTIONS(2671),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_export] = ACTIONS(2669),
    [anon_sym_module] = ACTIONS(2669),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [382] = {
    [ts_builtin_sym_end] = ACTIONS(2725),
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym___attribute] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym__Nonnull] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym__Alignas] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [anon_sym___asm] = ACTIONS(2723),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_export] = ACTIONS(2723),
    [anon_sym_module] = ACTIONS(2723),
    [anon_sym_import] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [383] = {
    [ts_builtin_sym_end] = ACTIONS(2633),
    [sym_identifier] = ACTIONS(2631),
    [aux_sym_preproc_include_token1] = ACTIONS(2631),
    [aux_sym_preproc_def_token1] = ACTIONS(2631),
    [aux_sym_preproc_if_token1] = ACTIONS(2631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2631),
    [sym_preproc_directive] = ACTIONS(2631),
    [anon_sym_LPAREN2] = ACTIONS(2633),
    [anon_sym_BANG] = ACTIONS(2633),
    [anon_sym_TILDE] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym___extension__] = ACTIONS(2631),
    [anon_sym_typedef] = ACTIONS(2631),
    [anon_sym_virtual] = ACTIONS(2631),
    [anon_sym_extern] = ACTIONS(2631),
    [anon_sym___attribute__] = ACTIONS(2631),
    [anon_sym___attribute] = ACTIONS(2631),
    [anon_sym_using] = ACTIONS(2631),
    [anon_sym_COLON_COLON] = ACTIONS(2633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2633),
    [anon_sym___declspec] = ACTIONS(2631),
    [anon_sym___based] = ACTIONS(2631),
    [anon_sym___cdecl] = ACTIONS(2631),
    [anon_sym___clrcall] = ACTIONS(2631),
    [anon_sym___stdcall] = ACTIONS(2631),
    [anon_sym___fastcall] = ACTIONS(2631),
    [anon_sym___thiscall] = ACTIONS(2631),
    [anon_sym___vectorcall] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_signed] = ACTIONS(2631),
    [anon_sym_unsigned] = ACTIONS(2631),
    [anon_sym_long] = ACTIONS(2631),
    [anon_sym_short] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2631),
    [anon_sym_static] = ACTIONS(2631),
    [anon_sym_register] = ACTIONS(2631),
    [anon_sym_inline] = ACTIONS(2631),
    [anon_sym___inline] = ACTIONS(2631),
    [anon_sym___inline__] = ACTIONS(2631),
    [anon_sym___forceinline] = ACTIONS(2631),
    [anon_sym_thread_local] = ACTIONS(2631),
    [anon_sym___thread] = ACTIONS(2631),
    [anon_sym_const] = ACTIONS(2631),
    [anon_sym_constexpr] = ACTIONS(2631),
    [anon_sym_volatile] = ACTIONS(2631),
    [anon_sym_restrict] = ACTIONS(2631),
    [anon_sym___restrict__] = ACTIONS(2631),
    [anon_sym__Atomic] = ACTIONS(2631),
    [anon_sym__Noreturn] = ACTIONS(2631),
    [anon_sym_noreturn] = ACTIONS(2631),
    [anon_sym__Nonnull] = ACTIONS(2631),
    [anon_sym_mutable] = ACTIONS(2631),
    [anon_sym_constinit] = ACTIONS(2631),
    [anon_sym_consteval] = ACTIONS(2631),
    [anon_sym_alignas] = ACTIONS(2631),
    [anon_sym__Alignas] = ACTIONS(2631),
    [sym_primitive_type] = ACTIONS(2631),
    [anon_sym_enum] = ACTIONS(2631),
    [anon_sym_class] = ACTIONS(2631),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_union] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_else] = ACTIONS(2631),
    [anon_sym_switch] = ACTIONS(2631),
    [anon_sym_case] = ACTIONS(2631),
    [anon_sym_default] = ACTIONS(2631),
    [anon_sym_while] = ACTIONS(2631),
    [anon_sym_do] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_goto] = ACTIONS(2631),
    [anon_sym___try] = ACTIONS(2631),
    [anon_sym___leave] = ACTIONS(2631),
    [anon_sym_not] = ACTIONS(2631),
    [anon_sym_compl] = ACTIONS(2631),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_sizeof] = ACTIONS(2631),
    [anon_sym___alignof__] = ACTIONS(2631),
    [anon_sym___alignof] = ACTIONS(2631),
    [anon_sym__alignof] = ACTIONS(2631),
    [anon_sym_alignof] = ACTIONS(2631),
    [anon_sym__Alignof] = ACTIONS(2631),
    [anon_sym_offsetof] = ACTIONS(2631),
    [anon_sym__Generic] = ACTIONS(2631),
    [anon_sym_asm] = ACTIONS(2631),
    [anon_sym___asm__] = ACTIONS(2631),
    [anon_sym___asm] = ACTIONS(2631),
    [sym_number_literal] = ACTIONS(2633),
    [anon_sym_L_SQUOTE] = ACTIONS(2633),
    [anon_sym_u_SQUOTE] = ACTIONS(2633),
    [anon_sym_U_SQUOTE] = ACTIONS(2633),
    [anon_sym_u8_SQUOTE] = ACTIONS(2633),
    [anon_sym_SQUOTE] = ACTIONS(2633),
    [anon_sym_L_DQUOTE] = ACTIONS(2633),
    [anon_sym_u_DQUOTE] = ACTIONS(2633),
    [anon_sym_U_DQUOTE] = ACTIONS(2633),
    [anon_sym_u8_DQUOTE] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(2633),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [anon_sym_NULL] = ACTIONS(2631),
    [anon_sym_nullptr] = ACTIONS(2631),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2631),
    [anon_sym_decltype] = ACTIONS(2631),
    [anon_sym_explicit] = ACTIONS(2631),
    [anon_sym_typename] = ACTIONS(2631),
    [anon_sym_export] = ACTIONS(2631),
    [anon_sym_module] = ACTIONS(2631),
    [anon_sym_import] = ACTIONS(2631),
    [anon_sym_template] = ACTIONS(2631),
    [anon_sym_operator] = ACTIONS(2631),
    [anon_sym_try] = ACTIONS(2631),
    [anon_sym_delete] = ACTIONS(2631),
    [anon_sym_throw] = ACTIONS(2631),
    [anon_sym_namespace] = ACTIONS(2631),
    [anon_sym_static_assert] = ACTIONS(2631),
    [anon_sym_concept] = ACTIONS(2631),
    [anon_sym_co_return] = ACTIONS(2631),
    [anon_sym_co_yield] = ACTIONS(2631),
    [anon_sym_R_DQUOTE] = ACTIONS(2633),
    [anon_sym_LR_DQUOTE] = ACTIONS(2633),
    [anon_sym_uR_DQUOTE] = ACTIONS(2633),
    [anon_sym_UR_DQUOTE] = ACTIONS(2633),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2633),
    [anon_sym_co_await] = ACTIONS(2631),
    [anon_sym_new] = ACTIONS(2631),
    [anon_sym_requires] = ACTIONS(2631),
    [sym_this] = ACTIONS(2631),
  },
  [384] = {
    [ts_builtin_sym_end] = ACTIONS(2637),
    [sym_identifier] = ACTIONS(2635),
    [aux_sym_preproc_include_token1] = ACTIONS(2635),
    [aux_sym_preproc_def_token1] = ACTIONS(2635),
    [aux_sym_preproc_if_token1] = ACTIONS(2635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2635),
    [sym_preproc_directive] = ACTIONS(2635),
    [anon_sym_LPAREN2] = ACTIONS(2637),
    [anon_sym_BANG] = ACTIONS(2637),
    [anon_sym_TILDE] = ACTIONS(2637),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2637),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_SEMI] = ACTIONS(2637),
    [anon_sym___extension__] = ACTIONS(2635),
    [anon_sym_typedef] = ACTIONS(2635),
    [anon_sym_virtual] = ACTIONS(2635),
    [anon_sym_extern] = ACTIONS(2635),
    [anon_sym___attribute__] = ACTIONS(2635),
    [anon_sym___attribute] = ACTIONS(2635),
    [anon_sym_using] = ACTIONS(2635),
    [anon_sym_COLON_COLON] = ACTIONS(2637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2637),
    [anon_sym___declspec] = ACTIONS(2635),
    [anon_sym___based] = ACTIONS(2635),
    [anon_sym___cdecl] = ACTIONS(2635),
    [anon_sym___clrcall] = ACTIONS(2635),
    [anon_sym___stdcall] = ACTIONS(2635),
    [anon_sym___fastcall] = ACTIONS(2635),
    [anon_sym___thiscall] = ACTIONS(2635),
    [anon_sym___vectorcall] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2637),
    [anon_sym_signed] = ACTIONS(2635),
    [anon_sym_unsigned] = ACTIONS(2635),
    [anon_sym_long] = ACTIONS(2635),
    [anon_sym_short] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(2635),
    [anon_sym_static] = ACTIONS(2635),
    [anon_sym_register] = ACTIONS(2635),
    [anon_sym_inline] = ACTIONS(2635),
    [anon_sym___inline] = ACTIONS(2635),
    [anon_sym___inline__] = ACTIONS(2635),
    [anon_sym___forceinline] = ACTIONS(2635),
    [anon_sym_thread_local] = ACTIONS(2635),
    [anon_sym___thread] = ACTIONS(2635),
    [anon_sym_const] = ACTIONS(2635),
    [anon_sym_constexpr] = ACTIONS(2635),
    [anon_sym_volatile] = ACTIONS(2635),
    [anon_sym_restrict] = ACTIONS(2635),
    [anon_sym___restrict__] = ACTIONS(2635),
    [anon_sym__Atomic] = ACTIONS(2635),
    [anon_sym__Noreturn] = ACTIONS(2635),
    [anon_sym_noreturn] = ACTIONS(2635),
    [anon_sym__Nonnull] = ACTIONS(2635),
    [anon_sym_mutable] = ACTIONS(2635),
    [anon_sym_constinit] = ACTIONS(2635),
    [anon_sym_consteval] = ACTIONS(2635),
    [anon_sym_alignas] = ACTIONS(2635),
    [anon_sym__Alignas] = ACTIONS(2635),
    [sym_primitive_type] = ACTIONS(2635),
    [anon_sym_enum] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(2635),
    [anon_sym_struct] = ACTIONS(2635),
    [anon_sym_union] = ACTIONS(2635),
    [anon_sym_if] = ACTIONS(2635),
    [anon_sym_else] = ACTIONS(2635),
    [anon_sym_switch] = ACTIONS(2635),
    [anon_sym_case] = ACTIONS(2635),
    [anon_sym_default] = ACTIONS(2635),
    [anon_sym_while] = ACTIONS(2635),
    [anon_sym_do] = ACTIONS(2635),
    [anon_sym_for] = ACTIONS(2635),
    [anon_sym_return] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_continue] = ACTIONS(2635),
    [anon_sym_goto] = ACTIONS(2635),
    [anon_sym___try] = ACTIONS(2635),
    [anon_sym___leave] = ACTIONS(2635),
    [anon_sym_not] = ACTIONS(2635),
    [anon_sym_compl] = ACTIONS(2635),
    [anon_sym_DASH_DASH] = ACTIONS(2637),
    [anon_sym_PLUS_PLUS] = ACTIONS(2637),
    [anon_sym_sizeof] = ACTIONS(2635),
    [anon_sym___alignof__] = ACTIONS(2635),
    [anon_sym___alignof] = ACTIONS(2635),
    [anon_sym__alignof] = ACTIONS(2635),
    [anon_sym_alignof] = ACTIONS(2635),
    [anon_sym__Alignof] = ACTIONS(2635),
    [anon_sym_offsetof] = ACTIONS(2635),
    [anon_sym__Generic] = ACTIONS(2635),
    [anon_sym_asm] = ACTIONS(2635),
    [anon_sym___asm__] = ACTIONS(2635),
    [anon_sym___asm] = ACTIONS(2635),
    [sym_number_literal] = ACTIONS(2637),
    [anon_sym_L_SQUOTE] = ACTIONS(2637),
    [anon_sym_u_SQUOTE] = ACTIONS(2637),
    [anon_sym_U_SQUOTE] = ACTIONS(2637),
    [anon_sym_u8_SQUOTE] = ACTIONS(2637),
    [anon_sym_SQUOTE] = ACTIONS(2637),
    [anon_sym_L_DQUOTE] = ACTIONS(2637),
    [anon_sym_u_DQUOTE] = ACTIONS(2637),
    [anon_sym_U_DQUOTE] = ACTIONS(2637),
    [anon_sym_u8_DQUOTE] = ACTIONS(2637),
    [anon_sym_DQUOTE] = ACTIONS(2637),
    [sym_true] = ACTIONS(2635),
    [sym_false] = ACTIONS(2635),
    [anon_sym_NULL] = ACTIONS(2635),
    [anon_sym_nullptr] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2635),
    [anon_sym_decltype] = ACTIONS(2635),
    [anon_sym_explicit] = ACTIONS(2635),
    [anon_sym_typename] = ACTIONS(2635),
    [anon_sym_export] = ACTIONS(2635),
    [anon_sym_module] = ACTIONS(2635),
    [anon_sym_import] = ACTIONS(2635),
    [anon_sym_template] = ACTIONS(2635),
    [anon_sym_operator] = ACTIONS(2635),
    [anon_sym_try] = ACTIONS(2635),
    [anon_sym_delete] = ACTIONS(2635),
    [anon_sym_throw] = ACTIONS(2635),
    [anon_sym_namespace] = ACTIONS(2635),
    [anon_sym_static_assert] = ACTIONS(2635),
    [anon_sym_concept] = ACTIONS(2635),
    [anon_sym_co_return] = ACTIONS(2635),
    [anon_sym_co_yield] = ACTIONS(2635),
    [anon_sym_R_DQUOTE] = ACTIONS(2637),
    [anon_sym_LR_DQUOTE] = ACTIONS(2637),
    [anon_sym_uR_DQUOTE] = ACTIONS(2637),
    [anon_sym_UR_DQUOTE] = ACTIONS(2637),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2637),
    [anon_sym_co_await] = ACTIONS(2635),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2635),
    [sym_this] = ACTIONS(2635),
  },
  [385] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4349),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(6933),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7236),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3202),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [386] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4402),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7081),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7251),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3204),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [387] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym___attribute] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym__Nonnull] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym__Alignas] = ACTIONS(2643),
    [sym_primitive_type] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [anon_sym___asm] = ACTIONS(2643),
    [sym_number_literal] = ACTIONS(2645),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_export] = ACTIONS(2643),
    [anon_sym_module] = ACTIONS(2643),
    [anon_sym_import] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [388] = {
    [sym_catch_clause] = STATE(231),
    [aux_sym_constructor_try_statement_repeat1] = STATE(231),
    [ts_builtin_sym_end] = ACTIONS(2592),
    [sym_identifier] = ACTIONS(2590),
    [aux_sym_preproc_include_token1] = ACTIONS(2590),
    [aux_sym_preproc_def_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token1] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2590),
    [sym_preproc_directive] = ACTIONS(2590),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_TILDE] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym___extension__] = ACTIONS(2590),
    [anon_sym_typedef] = ACTIONS(2590),
    [anon_sym_virtual] = ACTIONS(2590),
    [anon_sym_extern] = ACTIONS(2590),
    [anon_sym___attribute__] = ACTIONS(2590),
    [anon_sym___attribute] = ACTIONS(2590),
    [anon_sym_using] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2592),
    [anon_sym___declspec] = ACTIONS(2590),
    [anon_sym___based] = ACTIONS(2590),
    [anon_sym___cdecl] = ACTIONS(2590),
    [anon_sym___clrcall] = ACTIONS(2590),
    [anon_sym___stdcall] = ACTIONS(2590),
    [anon_sym___fastcall] = ACTIONS(2590),
    [anon_sym___thiscall] = ACTIONS(2590),
    [anon_sym___vectorcall] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_signed] = ACTIONS(2590),
    [anon_sym_unsigned] = ACTIONS(2590),
    [anon_sym_long] = ACTIONS(2590),
    [anon_sym_short] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2590),
    [anon_sym_register] = ACTIONS(2590),
    [anon_sym_inline] = ACTIONS(2590),
    [anon_sym___inline] = ACTIONS(2590),
    [anon_sym___inline__] = ACTIONS(2590),
    [anon_sym___forceinline] = ACTIONS(2590),
    [anon_sym_thread_local] = ACTIONS(2590),
    [anon_sym___thread] = ACTIONS(2590),
    [anon_sym_const] = ACTIONS(2590),
    [anon_sym_constexpr] = ACTIONS(2590),
    [anon_sym_volatile] = ACTIONS(2590),
    [anon_sym_restrict] = ACTIONS(2590),
    [anon_sym___restrict__] = ACTIONS(2590),
    [anon_sym__Atomic] = ACTIONS(2590),
    [anon_sym__Noreturn] = ACTIONS(2590),
    [anon_sym_noreturn] = ACTIONS(2590),
    [anon_sym__Nonnull] = ACTIONS(2590),
    [anon_sym_mutable] = ACTIONS(2590),
    [anon_sym_constinit] = ACTIONS(2590),
    [anon_sym_consteval] = ACTIONS(2590),
    [anon_sym_alignas] = ACTIONS(2590),
    [anon_sym__Alignas] = ACTIONS(2590),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_enum] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_struct] = ACTIONS(2590),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_switch] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_default] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_continue] = ACTIONS(2590),
    [anon_sym_goto] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_compl] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2592),
    [anon_sym_sizeof] = ACTIONS(2590),
    [anon_sym___alignof__] = ACTIONS(2590),
    [anon_sym___alignof] = ACTIONS(2590),
    [anon_sym__alignof] = ACTIONS(2590),
    [anon_sym_alignof] = ACTIONS(2590),
    [anon_sym__Alignof] = ACTIONS(2590),
    [anon_sym_offsetof] = ACTIONS(2590),
    [anon_sym__Generic] = ACTIONS(2590),
    [anon_sym_asm] = ACTIONS(2590),
    [anon_sym___asm__] = ACTIONS(2590),
    [anon_sym___asm] = ACTIONS(2590),
    [sym_number_literal] = ACTIONS(2592),
    [anon_sym_L_SQUOTE] = ACTIONS(2592),
    [anon_sym_u_SQUOTE] = ACTIONS(2592),
    [anon_sym_U_SQUOTE] = ACTIONS(2592),
    [anon_sym_u8_SQUOTE] = ACTIONS(2592),
    [anon_sym_SQUOTE] = ACTIONS(2592),
    [anon_sym_L_DQUOTE] = ACTIONS(2592),
    [anon_sym_u_DQUOTE] = ACTIONS(2592),
    [anon_sym_U_DQUOTE] = ACTIONS(2592),
    [anon_sym_u8_DQUOTE] = ACTIONS(2592),
    [anon_sym_DQUOTE] = ACTIONS(2592),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [anon_sym_NULL] = ACTIONS(2590),
    [anon_sym_nullptr] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2590),
    [anon_sym_decltype] = ACTIONS(2590),
    [anon_sym_explicit] = ACTIONS(2590),
    [anon_sym_typename] = ACTIONS(2590),
    [anon_sym_export] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_import] = ACTIONS(2590),
    [anon_sym_template] = ACTIONS(2590),
    [anon_sym_operator] = ACTIONS(2590),
    [anon_sym_try] = ACTIONS(2590),
    [anon_sym_delete] = ACTIONS(2590),
    [anon_sym_throw] = ACTIONS(2590),
    [anon_sym_namespace] = ACTIONS(2590),
    [anon_sym_static_assert] = ACTIONS(2590),
    [anon_sym_concept] = ACTIONS(2590),
    [anon_sym_co_return] = ACTIONS(2590),
    [anon_sym_co_yield] = ACTIONS(2590),
    [anon_sym_catch] = ACTIONS(2599),
    [anon_sym_R_DQUOTE] = ACTIONS(2592),
    [anon_sym_LR_DQUOTE] = ACTIONS(2592),
    [anon_sym_uR_DQUOTE] = ACTIONS(2592),
    [anon_sym_UR_DQUOTE] = ACTIONS(2592),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2592),
    [anon_sym_co_await] = ACTIONS(2590),
    [anon_sym_new] = ACTIONS(2590),
    [anon_sym_requires] = ACTIONS(2590),
    [sym_this] = ACTIONS(2590),
  },
  [389] = {
    [sym_preproc_def] = STATE(392),
    [sym_preproc_function_def] = STATE(392),
    [sym_preproc_call] = STATE(392),
    [sym_preproc_if_in_field_declaration_list] = STATE(392),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(392),
    [sym_preproc_else_in_field_declaration_list] = STATE(8469),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8469),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8469),
    [sym_type_definition] = STATE(392),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(392),
    [sym_field_declaration] = STATE(392),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(392),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(392),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(392),
    [sym_operator_cast_declaration] = STATE(392),
    [sym_constructor_or_destructor_definition] = STATE(392),
    [sym_constructor_or_destructor_declaration] = STATE(392),
    [sym_friend_declaration] = STATE(392),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(392),
    [sym_alias_declaration] = STATE(392),
    [sym_static_assert_declaration] = STATE(392),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(392),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3208),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [390] = {
    [ts_builtin_sym_end] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2651),
    [aux_sym_preproc_include_token1] = ACTIONS(2651),
    [aux_sym_preproc_def_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token1] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2651),
    [sym_preproc_directive] = ACTIONS(2651),
    [anon_sym_LPAREN2] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym___extension__] = ACTIONS(2651),
    [anon_sym_typedef] = ACTIONS(2651),
    [anon_sym_virtual] = ACTIONS(2651),
    [anon_sym_extern] = ACTIONS(2651),
    [anon_sym___attribute__] = ACTIONS(2651),
    [anon_sym___attribute] = ACTIONS(2651),
    [anon_sym_using] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2653),
    [anon_sym___declspec] = ACTIONS(2651),
    [anon_sym___based] = ACTIONS(2651),
    [anon_sym___cdecl] = ACTIONS(2651),
    [anon_sym___clrcall] = ACTIONS(2651),
    [anon_sym___stdcall] = ACTIONS(2651),
    [anon_sym___fastcall] = ACTIONS(2651),
    [anon_sym___thiscall] = ACTIONS(2651),
    [anon_sym___vectorcall] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2653),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2651),
    [anon_sym_register] = ACTIONS(2651),
    [anon_sym_inline] = ACTIONS(2651),
    [anon_sym___inline] = ACTIONS(2651),
    [anon_sym___inline__] = ACTIONS(2651),
    [anon_sym___forceinline] = ACTIONS(2651),
    [anon_sym_thread_local] = ACTIONS(2651),
    [anon_sym___thread] = ACTIONS(2651),
    [anon_sym_const] = ACTIONS(2651),
    [anon_sym_constexpr] = ACTIONS(2651),
    [anon_sym_volatile] = ACTIONS(2651),
    [anon_sym_restrict] = ACTIONS(2651),
    [anon_sym___restrict__] = ACTIONS(2651),
    [anon_sym__Atomic] = ACTIONS(2651),
    [anon_sym__Noreturn] = ACTIONS(2651),
    [anon_sym_noreturn] = ACTIONS(2651),
    [anon_sym__Nonnull] = ACTIONS(2651),
    [anon_sym_mutable] = ACTIONS(2651),
    [anon_sym_constinit] = ACTIONS(2651),
    [anon_sym_consteval] = ACTIONS(2651),
    [anon_sym_alignas] = ACTIONS(2651),
    [anon_sym__Alignas] = ACTIONS(2651),
    [sym_primitive_type] = ACTIONS(2651),
    [anon_sym_enum] = ACTIONS(2651),
    [anon_sym_class] = ACTIONS(2651),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_union] = ACTIONS(2651),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_else] = ACTIONS(2651),
    [anon_sym_switch] = ACTIONS(2651),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_default] = ACTIONS(2651),
    [anon_sym_while] = ACTIONS(2651),
    [anon_sym_do] = ACTIONS(2651),
    [anon_sym_for] = ACTIONS(2651),
    [anon_sym_return] = ACTIONS(2651),
    [anon_sym_break] = ACTIONS(2651),
    [anon_sym_continue] = ACTIONS(2651),
    [anon_sym_goto] = ACTIONS(2651),
    [anon_sym___try] = ACTIONS(2651),
    [anon_sym___leave] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2651),
    [anon_sym_compl] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2653),
    [anon_sym_sizeof] = ACTIONS(2651),
    [anon_sym___alignof__] = ACTIONS(2651),
    [anon_sym___alignof] = ACTIONS(2651),
    [anon_sym__alignof] = ACTIONS(2651),
    [anon_sym_alignof] = ACTIONS(2651),
    [anon_sym__Alignof] = ACTIONS(2651),
    [anon_sym_offsetof] = ACTIONS(2651),
    [anon_sym__Generic] = ACTIONS(2651),
    [anon_sym_asm] = ACTIONS(2651),
    [anon_sym___asm__] = ACTIONS(2651),
    [anon_sym___asm] = ACTIONS(2651),
    [sym_number_literal] = ACTIONS(2653),
    [anon_sym_L_SQUOTE] = ACTIONS(2653),
    [anon_sym_u_SQUOTE] = ACTIONS(2653),
    [anon_sym_U_SQUOTE] = ACTIONS(2653),
    [anon_sym_u8_SQUOTE] = ACTIONS(2653),
    [anon_sym_SQUOTE] = ACTIONS(2653),
    [anon_sym_L_DQUOTE] = ACTIONS(2653),
    [anon_sym_u_DQUOTE] = ACTIONS(2653),
    [anon_sym_U_DQUOTE] = ACTIONS(2653),
    [anon_sym_u8_DQUOTE] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(2653),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [anon_sym_NULL] = ACTIONS(2651),
    [anon_sym_nullptr] = ACTIONS(2651),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2651),
    [anon_sym_decltype] = ACTIONS(2651),
    [anon_sym_explicit] = ACTIONS(2651),
    [anon_sym_typename] = ACTIONS(2651),
    [anon_sym_export] = ACTIONS(2651),
    [anon_sym_module] = ACTIONS(2651),
    [anon_sym_import] = ACTIONS(2651),
    [anon_sym_template] = ACTIONS(2651),
    [anon_sym_operator] = ACTIONS(2651),
    [anon_sym_try] = ACTIONS(2651),
    [anon_sym_delete] = ACTIONS(2651),
    [anon_sym_throw] = ACTIONS(2651),
    [anon_sym_namespace] = ACTIONS(2651),
    [anon_sym_static_assert] = ACTIONS(2651),
    [anon_sym_concept] = ACTIONS(2651),
    [anon_sym_co_return] = ACTIONS(2651),
    [anon_sym_co_yield] = ACTIONS(2651),
    [anon_sym_R_DQUOTE] = ACTIONS(2653),
    [anon_sym_LR_DQUOTE] = ACTIONS(2653),
    [anon_sym_uR_DQUOTE] = ACTIONS(2653),
    [anon_sym_UR_DQUOTE] = ACTIONS(2653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2653),
    [anon_sym_co_await] = ACTIONS(2651),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_requires] = ACTIONS(2651),
    [sym_this] = ACTIONS(2651),
  },
  [391] = {
    [sym_preproc_def] = STATE(393),
    [sym_preproc_function_def] = STATE(393),
    [sym_preproc_call] = STATE(393),
    [sym_preproc_if_in_field_declaration_list] = STATE(393),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(393),
    [sym_preproc_else_in_field_declaration_list] = STATE(8713),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8713),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8713),
    [sym_type_definition] = STATE(393),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(393),
    [sym_field_declaration] = STATE(393),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(393),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(393),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(393),
    [sym_operator_cast_declaration] = STATE(393),
    [sym_constructor_or_destructor_definition] = STATE(393),
    [sym_constructor_or_destructor_declaration] = STATE(393),
    [sym_friend_declaration] = STATE(393),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(393),
    [sym_alias_declaration] = STATE(393),
    [sym_static_assert_declaration] = STATE(393),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(393),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [392] = {
    [sym_preproc_def] = STATE(587),
    [sym_preproc_function_def] = STATE(587),
    [sym_preproc_call] = STATE(587),
    [sym_preproc_if_in_field_declaration_list] = STATE(587),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(587),
    [sym_preproc_else_in_field_declaration_list] = STATE(8720),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8720),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8720),
    [sym_type_definition] = STATE(587),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(587),
    [sym_field_declaration] = STATE(587),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(587),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(587),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(587),
    [sym_operator_cast_declaration] = STATE(587),
    [sym_constructor_or_destructor_definition] = STATE(587),
    [sym_constructor_or_destructor_declaration] = STATE(587),
    [sym_friend_declaration] = STATE(587),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(587),
    [sym_alias_declaration] = STATE(587),
    [sym_static_assert_declaration] = STATE(587),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(587),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [393] = {
    [sym_preproc_def] = STATE(587),
    [sym_preproc_function_def] = STATE(587),
    [sym_preproc_call] = STATE(587),
    [sym_preproc_if_in_field_declaration_list] = STATE(587),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(587),
    [sym_preproc_else_in_field_declaration_list] = STATE(7935),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7935),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7935),
    [sym_type_definition] = STATE(587),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(587),
    [sym_field_declaration] = STATE(587),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(587),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(587),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(587),
    [sym_operator_cast_declaration] = STATE(587),
    [sym_constructor_or_destructor_definition] = STATE(587),
    [sym_constructor_or_destructor_declaration] = STATE(587),
    [sym_friend_declaration] = STATE(587),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(587),
    [sym_alias_declaration] = STATE(587),
    [sym_static_assert_declaration] = STATE(587),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(587),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3216),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [394] = {
    [sym_preproc_def] = STATE(587),
    [sym_preproc_function_def] = STATE(587),
    [sym_preproc_call] = STATE(587),
    [sym_preproc_if_in_field_declaration_list] = STATE(587),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(587),
    [sym_preproc_else_in_field_declaration_list] = STATE(8094),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8094),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8094),
    [sym_type_definition] = STATE(587),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(587),
    [sym_field_declaration] = STATE(587),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(587),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(587),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(587),
    [sym_operator_cast_declaration] = STATE(587),
    [sym_constructor_or_destructor_definition] = STATE(587),
    [sym_constructor_or_destructor_declaration] = STATE(587),
    [sym_friend_declaration] = STATE(587),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(587),
    [sym_alias_declaration] = STATE(587),
    [sym_static_assert_declaration] = STATE(587),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(587),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [395] = {
    [sym_preproc_def] = STATE(397),
    [sym_preproc_function_def] = STATE(397),
    [sym_preproc_call] = STATE(397),
    [sym_preproc_if_in_field_declaration_list] = STATE(397),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(397),
    [sym_preproc_else_in_field_declaration_list] = STATE(8262),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8262),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8262),
    [sym_type_definition] = STATE(397),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(397),
    [sym_field_declaration] = STATE(397),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(397),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(397),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(397),
    [sym_operator_cast_declaration] = STATE(397),
    [sym_constructor_or_destructor_definition] = STATE(397),
    [sym_constructor_or_destructor_declaration] = STATE(397),
    [sym_friend_declaration] = STATE(397),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(397),
    [sym_alias_declaration] = STATE(397),
    [sym_static_assert_declaration] = STATE(397),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(397),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3220),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3222),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [396] = {
    [sym_preproc_def] = STATE(398),
    [sym_preproc_function_def] = STATE(398),
    [sym_preproc_call] = STATE(398),
    [sym_preproc_if_in_field_declaration_list] = STATE(398),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(398),
    [sym_preproc_else_in_field_declaration_list] = STATE(8518),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8518),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8518),
    [sym_type_definition] = STATE(398),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(398),
    [sym_field_declaration] = STATE(398),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(398),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(398),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(398),
    [sym_operator_cast_declaration] = STATE(398),
    [sym_constructor_or_destructor_definition] = STATE(398),
    [sym_constructor_or_destructor_declaration] = STATE(398),
    [sym_friend_declaration] = STATE(398),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(398),
    [sym_alias_declaration] = STATE(398),
    [sym_static_assert_declaration] = STATE(398),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(398),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3224),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [397] = {
    [sym_preproc_def] = STATE(587),
    [sym_preproc_function_def] = STATE(587),
    [sym_preproc_call] = STATE(587),
    [sym_preproc_if_in_field_declaration_list] = STATE(587),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(587),
    [sym_preproc_else_in_field_declaration_list] = STATE(8528),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8528),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8528),
    [sym_type_definition] = STATE(587),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(587),
    [sym_field_declaration] = STATE(587),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(587),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(587),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(587),
    [sym_operator_cast_declaration] = STATE(587),
    [sym_constructor_or_destructor_definition] = STATE(587),
    [sym_constructor_or_destructor_declaration] = STATE(587),
    [sym_friend_declaration] = STATE(587),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(587),
    [sym_alias_declaration] = STATE(587),
    [sym_static_assert_declaration] = STATE(587),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(587),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [398] = {
    [sym_preproc_def] = STATE(587),
    [sym_preproc_function_def] = STATE(587),
    [sym_preproc_call] = STATE(587),
    [sym_preproc_if_in_field_declaration_list] = STATE(587),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(587),
    [sym_preproc_else_in_field_declaration_list] = STATE(8514),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8514),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8514),
    [sym_type_definition] = STATE(587),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(587),
    [sym_field_declaration] = STATE(587),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(587),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(587),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(587),
    [sym_operator_cast_declaration] = STATE(587),
    [sym_constructor_or_destructor_definition] = STATE(587),
    [sym_constructor_or_destructor_declaration] = STATE(587),
    [sym_friend_declaration] = STATE(587),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(587),
    [sym_alias_declaration] = STATE(587),
    [sym_static_assert_declaration] = STATE(587),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(587),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(2961),
    [aux_sym_preproc_if_token1] = ACTIONS(2963),
    [aux_sym_preproc_if_token2] = ACTIONS(3230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2969),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2973),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym___extension__] = ACTIONS(2987),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3017),
  },
  [399] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4328),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7069),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7155),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3232),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [400] = {
    [ts_builtin_sym_end] = ACTIONS(2745),
    [sym_identifier] = ACTIONS(2743),
    [aux_sym_preproc_include_token1] = ACTIONS(2743),
    [aux_sym_preproc_def_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2743),
    [sym_preproc_directive] = ACTIONS(2743),
    [anon_sym_LPAREN2] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym___extension__] = ACTIONS(2743),
    [anon_sym_typedef] = ACTIONS(2743),
    [anon_sym_virtual] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym___attribute__] = ACTIONS(2743),
    [anon_sym___attribute] = ACTIONS(2743),
    [anon_sym_using] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(2745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2745),
    [anon_sym___declspec] = ACTIONS(2743),
    [anon_sym___based] = ACTIONS(2743),
    [anon_sym___cdecl] = ACTIONS(2743),
    [anon_sym___clrcall] = ACTIONS(2743),
    [anon_sym___stdcall] = ACTIONS(2743),
    [anon_sym___fastcall] = ACTIONS(2743),
    [anon_sym___thiscall] = ACTIONS(2743),
    [anon_sym___vectorcall] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_signed] = ACTIONS(2743),
    [anon_sym_unsigned] = ACTIONS(2743),
    [anon_sym_long] = ACTIONS(2743),
    [anon_sym_short] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_register] = ACTIONS(2743),
    [anon_sym_inline] = ACTIONS(2743),
    [anon_sym___inline] = ACTIONS(2743),
    [anon_sym___inline__] = ACTIONS(2743),
    [anon_sym___forceinline] = ACTIONS(2743),
    [anon_sym_thread_local] = ACTIONS(2743),
    [anon_sym___thread] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_constexpr] = ACTIONS(2743),
    [anon_sym_volatile] = ACTIONS(2743),
    [anon_sym_restrict] = ACTIONS(2743),
    [anon_sym___restrict__] = ACTIONS(2743),
    [anon_sym__Atomic] = ACTIONS(2743),
    [anon_sym__Noreturn] = ACTIONS(2743),
    [anon_sym_noreturn] = ACTIONS(2743),
    [anon_sym__Nonnull] = ACTIONS(2743),
    [anon_sym_mutable] = ACTIONS(2743),
    [anon_sym_constinit] = ACTIONS(2743),
    [anon_sym_consteval] = ACTIONS(2743),
    [anon_sym_alignas] = ACTIONS(2743),
    [anon_sym__Alignas] = ACTIONS(2743),
    [sym_primitive_type] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2743),
    [anon_sym_switch] = ACTIONS(2743),
    [anon_sym_case] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_goto] = ACTIONS(2743),
    [anon_sym___try] = ACTIONS(2743),
    [anon_sym___leave] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2743),
    [anon_sym_compl] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2745),
    [anon_sym_sizeof] = ACTIONS(2743),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2743),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2743),
    [anon_sym___asm__] = ACTIONS(2743),
    [anon_sym___asm] = ACTIONS(2743),
    [sym_number_literal] = ACTIONS(2745),
    [anon_sym_L_SQUOTE] = ACTIONS(2745),
    [anon_sym_u_SQUOTE] = ACTIONS(2745),
    [anon_sym_U_SQUOTE] = ACTIONS(2745),
    [anon_sym_u8_SQUOTE] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2745),
    [anon_sym_L_DQUOTE] = ACTIONS(2745),
    [anon_sym_u_DQUOTE] = ACTIONS(2745),
    [anon_sym_U_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8_DQUOTE] = ACTIONS(2745),
    [anon_sym_DQUOTE] = ACTIONS(2745),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [anon_sym_NULL] = ACTIONS(2743),
    [anon_sym_nullptr] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2743),
    [anon_sym_decltype] = ACTIONS(2743),
    [anon_sym_explicit] = ACTIONS(2743),
    [anon_sym_typename] = ACTIONS(2743),
    [anon_sym_export] = ACTIONS(2743),
    [anon_sym_module] = ACTIONS(2743),
    [anon_sym_import] = ACTIONS(2743),
    [anon_sym_template] = ACTIONS(2743),
    [anon_sym_operator] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [anon_sym_delete] = ACTIONS(2743),
    [anon_sym_throw] = ACTIONS(2743),
    [anon_sym_namespace] = ACTIONS(2743),
    [anon_sym_static_assert] = ACTIONS(2743),
    [anon_sym_concept] = ACTIONS(2743),
    [anon_sym_co_return] = ACTIONS(2743),
    [anon_sym_co_yield] = ACTIONS(2743),
    [anon_sym_R_DQUOTE] = ACTIONS(2745),
    [anon_sym_LR_DQUOTE] = ACTIONS(2745),
    [anon_sym_uR_DQUOTE] = ACTIONS(2745),
    [anon_sym_UR_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2745),
    [anon_sym_co_await] = ACTIONS(2743),
    [anon_sym_new] = ACTIONS(2743),
    [anon_sym_requires] = ACTIONS(2743),
    [sym_this] = ACTIONS(2743),
  },
  [401] = {
    [ts_builtin_sym_end] = ACTIONS(2765),
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_include_token1] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym___cdecl] = ACTIONS(2763),
    [anon_sym___clrcall] = ACTIONS(2763),
    [anon_sym___stdcall] = ACTIONS(2763),
    [anon_sym___fastcall] = ACTIONS(2763),
    [anon_sym___thiscall] = ACTIONS(2763),
    [anon_sym___vectorcall] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_else] = ACTIONS(2763),
    [anon_sym_switch] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2763),
    [anon_sym_default] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_do] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_goto] = ACTIONS(2763),
    [anon_sym___try] = ACTIONS(2763),
    [anon_sym___leave] = ACTIONS(2763),
    [anon_sym_not] = ACTIONS(2763),
    [anon_sym_compl] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_sizeof] = ACTIONS(2763),
    [anon_sym___alignof__] = ACTIONS(2763),
    [anon_sym___alignof] = ACTIONS(2763),
    [anon_sym__alignof] = ACTIONS(2763),
    [anon_sym_alignof] = ACTIONS(2763),
    [anon_sym__Alignof] = ACTIONS(2763),
    [anon_sym_offsetof] = ACTIONS(2763),
    [anon_sym__Generic] = ACTIONS(2763),
    [anon_sym_asm] = ACTIONS(2763),
    [anon_sym___asm__] = ACTIONS(2763),
    [anon_sym___asm] = ACTIONS(2763),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2765),
    [anon_sym_u_SQUOTE] = ACTIONS(2765),
    [anon_sym_U_SQUOTE] = ACTIONS(2765),
    [anon_sym_u8_SQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_L_DQUOTE] = ACTIONS(2765),
    [anon_sym_u_DQUOTE] = ACTIONS(2765),
    [anon_sym_U_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8_DQUOTE] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [anon_sym_NULL] = ACTIONS(2763),
    [anon_sym_nullptr] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_export] = ACTIONS(2763),
    [anon_sym_module] = ACTIONS(2763),
    [anon_sym_import] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_throw] = ACTIONS(2763),
    [anon_sym_namespace] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
    [anon_sym_concept] = ACTIONS(2763),
    [anon_sym_co_return] = ACTIONS(2763),
    [anon_sym_co_yield] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2763),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_requires] = ACTIONS(2763),
    [sym_this] = ACTIONS(2763),
  },
  [402] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4344),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7056),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7309),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3234),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [403] = {
    [ts_builtin_sym_end] = ACTIONS(2675),
    [sym_identifier] = ACTIONS(2673),
    [aux_sym_preproc_include_token1] = ACTIONS(2673),
    [aux_sym_preproc_def_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2673),
    [sym_preproc_directive] = ACTIONS(2673),
    [anon_sym_LPAREN2] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_AMP_AMP] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym___extension__] = ACTIONS(2673),
    [anon_sym_typedef] = ACTIONS(2673),
    [anon_sym_virtual] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym___attribute__] = ACTIONS(2673),
    [anon_sym___attribute] = ACTIONS(2673),
    [anon_sym_using] = ACTIONS(2673),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2675),
    [anon_sym___declspec] = ACTIONS(2673),
    [anon_sym___based] = ACTIONS(2673),
    [anon_sym___cdecl] = ACTIONS(2673),
    [anon_sym___clrcall] = ACTIONS(2673),
    [anon_sym___stdcall] = ACTIONS(2673),
    [anon_sym___fastcall] = ACTIONS(2673),
    [anon_sym___thiscall] = ACTIONS(2673),
    [anon_sym___vectorcall] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_signed] = ACTIONS(2673),
    [anon_sym_unsigned] = ACTIONS(2673),
    [anon_sym_long] = ACTIONS(2673),
    [anon_sym_short] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_register] = ACTIONS(2673),
    [anon_sym_inline] = ACTIONS(2673),
    [anon_sym___inline] = ACTIONS(2673),
    [anon_sym___inline__] = ACTIONS(2673),
    [anon_sym___forceinline] = ACTIONS(2673),
    [anon_sym_thread_local] = ACTIONS(2673),
    [anon_sym___thread] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_constexpr] = ACTIONS(2673),
    [anon_sym_volatile] = ACTIONS(2673),
    [anon_sym_restrict] = ACTIONS(2673),
    [anon_sym___restrict__] = ACTIONS(2673),
    [anon_sym__Atomic] = ACTIONS(2673),
    [anon_sym__Noreturn] = ACTIONS(2673),
    [anon_sym_noreturn] = ACTIONS(2673),
    [anon_sym__Nonnull] = ACTIONS(2673),
    [anon_sym_mutable] = ACTIONS(2673),
    [anon_sym_constinit] = ACTIONS(2673),
    [anon_sym_consteval] = ACTIONS(2673),
    [anon_sym_alignas] = ACTIONS(2673),
    [anon_sym__Alignas] = ACTIONS(2673),
    [sym_primitive_type] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_goto] = ACTIONS(2673),
    [anon_sym___try] = ACTIONS(2673),
    [anon_sym___leave] = ACTIONS(2673),
    [anon_sym_not] = ACTIONS(2673),
    [anon_sym_compl] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_sizeof] = ACTIONS(2673),
    [anon_sym___alignof__] = ACTIONS(2673),
    [anon_sym___alignof] = ACTIONS(2673),
    [anon_sym__alignof] = ACTIONS(2673),
    [anon_sym_alignof] = ACTIONS(2673),
    [anon_sym__Alignof] = ACTIONS(2673),
    [anon_sym_offsetof] = ACTIONS(2673),
    [anon_sym__Generic] = ACTIONS(2673),
    [anon_sym_asm] = ACTIONS(2673),
    [anon_sym___asm__] = ACTIONS(2673),
    [anon_sym___asm] = ACTIONS(2673),
    [sym_number_literal] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2675),
    [anon_sym_u_SQUOTE] = ACTIONS(2675),
    [anon_sym_U_SQUOTE] = ACTIONS(2675),
    [anon_sym_u8_SQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_L_DQUOTE] = ACTIONS(2675),
    [anon_sym_u_DQUOTE] = ACTIONS(2675),
    [anon_sym_U_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8_DQUOTE] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [anon_sym_NULL] = ACTIONS(2673),
    [anon_sym_nullptr] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2673),
    [anon_sym_decltype] = ACTIONS(2673),
    [anon_sym_explicit] = ACTIONS(2673),
    [anon_sym_typename] = ACTIONS(2673),
    [anon_sym_export] = ACTIONS(2673),
    [anon_sym_module] = ACTIONS(2673),
    [anon_sym_import] = ACTIONS(2673),
    [anon_sym_template] = ACTIONS(2673),
    [anon_sym_operator] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_static_assert] = ACTIONS(2673),
    [anon_sym_concept] = ACTIONS(2673),
    [anon_sym_co_return] = ACTIONS(2673),
    [anon_sym_co_yield] = ACTIONS(2673),
    [anon_sym_R_DQUOTE] = ACTIONS(2675),
    [anon_sym_LR_DQUOTE] = ACTIONS(2675),
    [anon_sym_uR_DQUOTE] = ACTIONS(2675),
    [anon_sym_UR_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2675),
    [anon_sym_co_await] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_requires] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
  },
  [404] = {
    [ts_builtin_sym_end] = ACTIONS(2733),
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [anon_sym___asm] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_export] = ACTIONS(2731),
    [anon_sym_module] = ACTIONS(2731),
    [anon_sym_import] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [405] = {
    [ts_builtin_sym_end] = ACTIONS(2717),
    [sym_identifier] = ACTIONS(2715),
    [aux_sym_preproc_include_token1] = ACTIONS(2715),
    [aux_sym_preproc_def_token1] = ACTIONS(2715),
    [aux_sym_preproc_if_token1] = ACTIONS(2715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2715),
    [sym_preproc_directive] = ACTIONS(2715),
    [anon_sym_LPAREN2] = ACTIONS(2717),
    [anon_sym_BANG] = ACTIONS(2717),
    [anon_sym_TILDE] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_AMP_AMP] = ACTIONS(2717),
    [anon_sym_AMP] = ACTIONS(2715),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym___extension__] = ACTIONS(2715),
    [anon_sym_typedef] = ACTIONS(2715),
    [anon_sym_virtual] = ACTIONS(2715),
    [anon_sym_extern] = ACTIONS(2715),
    [anon_sym___attribute__] = ACTIONS(2715),
    [anon_sym___attribute] = ACTIONS(2715),
    [anon_sym_using] = ACTIONS(2715),
    [anon_sym_COLON_COLON] = ACTIONS(2717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2717),
    [anon_sym___declspec] = ACTIONS(2715),
    [anon_sym___based] = ACTIONS(2715),
    [anon_sym___cdecl] = ACTIONS(2715),
    [anon_sym___clrcall] = ACTIONS(2715),
    [anon_sym___stdcall] = ACTIONS(2715),
    [anon_sym___fastcall] = ACTIONS(2715),
    [anon_sym___thiscall] = ACTIONS(2715),
    [anon_sym___vectorcall] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_signed] = ACTIONS(2715),
    [anon_sym_unsigned] = ACTIONS(2715),
    [anon_sym_long] = ACTIONS(2715),
    [anon_sym_short] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(2715),
    [anon_sym_static] = ACTIONS(2715),
    [anon_sym_register] = ACTIONS(2715),
    [anon_sym_inline] = ACTIONS(2715),
    [anon_sym___inline] = ACTIONS(2715),
    [anon_sym___inline__] = ACTIONS(2715),
    [anon_sym___forceinline] = ACTIONS(2715),
    [anon_sym_thread_local] = ACTIONS(2715),
    [anon_sym___thread] = ACTIONS(2715),
    [anon_sym_const] = ACTIONS(2715),
    [anon_sym_constexpr] = ACTIONS(2715),
    [anon_sym_volatile] = ACTIONS(2715),
    [anon_sym_restrict] = ACTIONS(2715),
    [anon_sym___restrict__] = ACTIONS(2715),
    [anon_sym__Atomic] = ACTIONS(2715),
    [anon_sym__Noreturn] = ACTIONS(2715),
    [anon_sym_noreturn] = ACTIONS(2715),
    [anon_sym__Nonnull] = ACTIONS(2715),
    [anon_sym_mutable] = ACTIONS(2715),
    [anon_sym_constinit] = ACTIONS(2715),
    [anon_sym_consteval] = ACTIONS(2715),
    [anon_sym_alignas] = ACTIONS(2715),
    [anon_sym__Alignas] = ACTIONS(2715),
    [sym_primitive_type] = ACTIONS(2715),
    [anon_sym_enum] = ACTIONS(2715),
    [anon_sym_class] = ACTIONS(2715),
    [anon_sym_struct] = ACTIONS(2715),
    [anon_sym_union] = ACTIONS(2715),
    [anon_sym_if] = ACTIONS(2715),
    [anon_sym_else] = ACTIONS(2715),
    [anon_sym_switch] = ACTIONS(2715),
    [anon_sym_case] = ACTIONS(2715),
    [anon_sym_default] = ACTIONS(2715),
    [anon_sym_while] = ACTIONS(2715),
    [anon_sym_do] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2715),
    [anon_sym_return] = ACTIONS(2715),
    [anon_sym_break] = ACTIONS(2715),
    [anon_sym_continue] = ACTIONS(2715),
    [anon_sym_goto] = ACTIONS(2715),
    [anon_sym___try] = ACTIONS(2715),
    [anon_sym___leave] = ACTIONS(2715),
    [anon_sym_not] = ACTIONS(2715),
    [anon_sym_compl] = ACTIONS(2715),
    [anon_sym_DASH_DASH] = ACTIONS(2717),
    [anon_sym_PLUS_PLUS] = ACTIONS(2717),
    [anon_sym_sizeof] = ACTIONS(2715),
    [anon_sym___alignof__] = ACTIONS(2715),
    [anon_sym___alignof] = ACTIONS(2715),
    [anon_sym__alignof] = ACTIONS(2715),
    [anon_sym_alignof] = ACTIONS(2715),
    [anon_sym__Alignof] = ACTIONS(2715),
    [anon_sym_offsetof] = ACTIONS(2715),
    [anon_sym__Generic] = ACTIONS(2715),
    [anon_sym_asm] = ACTIONS(2715),
    [anon_sym___asm__] = ACTIONS(2715),
    [anon_sym___asm] = ACTIONS(2715),
    [sym_number_literal] = ACTIONS(2717),
    [anon_sym_L_SQUOTE] = ACTIONS(2717),
    [anon_sym_u_SQUOTE] = ACTIONS(2717),
    [anon_sym_U_SQUOTE] = ACTIONS(2717),
    [anon_sym_u8_SQUOTE] = ACTIONS(2717),
    [anon_sym_SQUOTE] = ACTIONS(2717),
    [anon_sym_L_DQUOTE] = ACTIONS(2717),
    [anon_sym_u_DQUOTE] = ACTIONS(2717),
    [anon_sym_U_DQUOTE] = ACTIONS(2717),
    [anon_sym_u8_DQUOTE] = ACTIONS(2717),
    [anon_sym_DQUOTE] = ACTIONS(2717),
    [sym_true] = ACTIONS(2715),
    [sym_false] = ACTIONS(2715),
    [anon_sym_NULL] = ACTIONS(2715),
    [anon_sym_nullptr] = ACTIONS(2715),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2715),
    [anon_sym_decltype] = ACTIONS(2715),
    [anon_sym_explicit] = ACTIONS(2715),
    [anon_sym_typename] = ACTIONS(2715),
    [anon_sym_export] = ACTIONS(2715),
    [anon_sym_module] = ACTIONS(2715),
    [anon_sym_import] = ACTIONS(2715),
    [anon_sym_template] = ACTIONS(2715),
    [anon_sym_operator] = ACTIONS(2715),
    [anon_sym_try] = ACTIONS(2715),
    [anon_sym_delete] = ACTIONS(2715),
    [anon_sym_throw] = ACTIONS(2715),
    [anon_sym_namespace] = ACTIONS(2715),
    [anon_sym_static_assert] = ACTIONS(2715),
    [anon_sym_concept] = ACTIONS(2715),
    [anon_sym_co_return] = ACTIONS(2715),
    [anon_sym_co_yield] = ACTIONS(2715),
    [anon_sym_R_DQUOTE] = ACTIONS(2717),
    [anon_sym_LR_DQUOTE] = ACTIONS(2717),
    [anon_sym_uR_DQUOTE] = ACTIONS(2717),
    [anon_sym_UR_DQUOTE] = ACTIONS(2717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2717),
    [anon_sym_co_await] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2715),
    [anon_sym_requires] = ACTIONS(2715),
    [sym_this] = ACTIONS(2715),
  },
  [406] = {
    [ts_builtin_sym_end] = ACTIONS(2709),
    [sym_identifier] = ACTIONS(2707),
    [aux_sym_preproc_include_token1] = ACTIONS(2707),
    [aux_sym_preproc_def_token1] = ACTIONS(2707),
    [aux_sym_preproc_if_token1] = ACTIONS(2707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2707),
    [sym_preproc_directive] = ACTIONS(2707),
    [anon_sym_LPAREN2] = ACTIONS(2709),
    [anon_sym_BANG] = ACTIONS(2709),
    [anon_sym_TILDE] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_PLUS] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_AMP_AMP] = ACTIONS(2709),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2709),
    [anon_sym___extension__] = ACTIONS(2707),
    [anon_sym_typedef] = ACTIONS(2707),
    [anon_sym_virtual] = ACTIONS(2707),
    [anon_sym_extern] = ACTIONS(2707),
    [anon_sym___attribute__] = ACTIONS(2707),
    [anon_sym___attribute] = ACTIONS(2707),
    [anon_sym_using] = ACTIONS(2707),
    [anon_sym_COLON_COLON] = ACTIONS(2709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2709),
    [anon_sym___declspec] = ACTIONS(2707),
    [anon_sym___based] = ACTIONS(2707),
    [anon_sym___cdecl] = ACTIONS(2707),
    [anon_sym___clrcall] = ACTIONS(2707),
    [anon_sym___stdcall] = ACTIONS(2707),
    [anon_sym___fastcall] = ACTIONS(2707),
    [anon_sym___thiscall] = ACTIONS(2707),
    [anon_sym___vectorcall] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2709),
    [anon_sym_signed] = ACTIONS(2707),
    [anon_sym_unsigned] = ACTIONS(2707),
    [anon_sym_long] = ACTIONS(2707),
    [anon_sym_short] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_static] = ACTIONS(2707),
    [anon_sym_register] = ACTIONS(2707),
    [anon_sym_inline] = ACTIONS(2707),
    [anon_sym___inline] = ACTIONS(2707),
    [anon_sym___inline__] = ACTIONS(2707),
    [anon_sym___forceinline] = ACTIONS(2707),
    [anon_sym_thread_local] = ACTIONS(2707),
    [anon_sym___thread] = ACTIONS(2707),
    [anon_sym_const] = ACTIONS(2707),
    [anon_sym_constexpr] = ACTIONS(2707),
    [anon_sym_volatile] = ACTIONS(2707),
    [anon_sym_restrict] = ACTIONS(2707),
    [anon_sym___restrict__] = ACTIONS(2707),
    [anon_sym__Atomic] = ACTIONS(2707),
    [anon_sym__Noreturn] = ACTIONS(2707),
    [anon_sym_noreturn] = ACTIONS(2707),
    [anon_sym__Nonnull] = ACTIONS(2707),
    [anon_sym_mutable] = ACTIONS(2707),
    [anon_sym_constinit] = ACTIONS(2707),
    [anon_sym_consteval] = ACTIONS(2707),
    [anon_sym_alignas] = ACTIONS(2707),
    [anon_sym__Alignas] = ACTIONS(2707),
    [sym_primitive_type] = ACTIONS(2707),
    [anon_sym_enum] = ACTIONS(2707),
    [anon_sym_class] = ACTIONS(2707),
    [anon_sym_struct] = ACTIONS(2707),
    [anon_sym_union] = ACTIONS(2707),
    [anon_sym_if] = ACTIONS(2707),
    [anon_sym_else] = ACTIONS(2707),
    [anon_sym_switch] = ACTIONS(2707),
    [anon_sym_case] = ACTIONS(2707),
    [anon_sym_default] = ACTIONS(2707),
    [anon_sym_while] = ACTIONS(2707),
    [anon_sym_do] = ACTIONS(2707),
    [anon_sym_for] = ACTIONS(2707),
    [anon_sym_return] = ACTIONS(2707),
    [anon_sym_break] = ACTIONS(2707),
    [anon_sym_continue] = ACTIONS(2707),
    [anon_sym_goto] = ACTIONS(2707),
    [anon_sym___try] = ACTIONS(2707),
    [anon_sym___leave] = ACTIONS(2707),
    [anon_sym_not] = ACTIONS(2707),
    [anon_sym_compl] = ACTIONS(2707),
    [anon_sym_DASH_DASH] = ACTIONS(2709),
    [anon_sym_PLUS_PLUS] = ACTIONS(2709),
    [anon_sym_sizeof] = ACTIONS(2707),
    [anon_sym___alignof__] = ACTIONS(2707),
    [anon_sym___alignof] = ACTIONS(2707),
    [anon_sym__alignof] = ACTIONS(2707),
    [anon_sym_alignof] = ACTIONS(2707),
    [anon_sym__Alignof] = ACTIONS(2707),
    [anon_sym_offsetof] = ACTIONS(2707),
    [anon_sym__Generic] = ACTIONS(2707),
    [anon_sym_asm] = ACTIONS(2707),
    [anon_sym___asm__] = ACTIONS(2707),
    [anon_sym___asm] = ACTIONS(2707),
    [sym_number_literal] = ACTIONS(2709),
    [anon_sym_L_SQUOTE] = ACTIONS(2709),
    [anon_sym_u_SQUOTE] = ACTIONS(2709),
    [anon_sym_U_SQUOTE] = ACTIONS(2709),
    [anon_sym_u8_SQUOTE] = ACTIONS(2709),
    [anon_sym_SQUOTE] = ACTIONS(2709),
    [anon_sym_L_DQUOTE] = ACTIONS(2709),
    [anon_sym_u_DQUOTE] = ACTIONS(2709),
    [anon_sym_U_DQUOTE] = ACTIONS(2709),
    [anon_sym_u8_DQUOTE] = ACTIONS(2709),
    [anon_sym_DQUOTE] = ACTIONS(2709),
    [sym_true] = ACTIONS(2707),
    [sym_false] = ACTIONS(2707),
    [anon_sym_NULL] = ACTIONS(2707),
    [anon_sym_nullptr] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2707),
    [anon_sym_decltype] = ACTIONS(2707),
    [anon_sym_explicit] = ACTIONS(2707),
    [anon_sym_typename] = ACTIONS(2707),
    [anon_sym_export] = ACTIONS(2707),
    [anon_sym_module] = ACTIONS(2707),
    [anon_sym_import] = ACTIONS(2707),
    [anon_sym_template] = ACTIONS(2707),
    [anon_sym_operator] = ACTIONS(2707),
    [anon_sym_try] = ACTIONS(2707),
    [anon_sym_delete] = ACTIONS(2707),
    [anon_sym_throw] = ACTIONS(2707),
    [anon_sym_namespace] = ACTIONS(2707),
    [anon_sym_static_assert] = ACTIONS(2707),
    [anon_sym_concept] = ACTIONS(2707),
    [anon_sym_co_return] = ACTIONS(2707),
    [anon_sym_co_yield] = ACTIONS(2707),
    [anon_sym_R_DQUOTE] = ACTIONS(2709),
    [anon_sym_LR_DQUOTE] = ACTIONS(2709),
    [anon_sym_uR_DQUOTE] = ACTIONS(2709),
    [anon_sym_UR_DQUOTE] = ACTIONS(2709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2709),
    [anon_sym_co_await] = ACTIONS(2707),
    [anon_sym_new] = ACTIONS(2707),
    [anon_sym_requires] = ACTIONS(2707),
    [sym_this] = ACTIONS(2707),
  },
  [407] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4370),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(6961),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7394),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3236),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [408] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4343),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7101),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7486),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3238),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [409] = {
    [sym_catch_clause] = STATE(425),
    [aux_sym_constructor_try_statement_repeat1] = STATE(425),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_include_token1] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_virtual] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym___attribute] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym___cdecl] = ACTIONS(2483),
    [anon_sym___clrcall] = ACTIONS(2483),
    [anon_sym___stdcall] = ACTIONS(2483),
    [anon_sym___fastcall] = ACTIONS(2483),
    [anon_sym___thiscall] = ACTIONS(2483),
    [anon_sym___vectorcall] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym__Nonnull] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_case] = ACTIONS(2483),
    [anon_sym_default] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_goto] = ACTIONS(2483),
    [anon_sym___try] = ACTIONS(2483),
    [anon_sym___leave] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2483),
    [anon_sym_compl] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_sizeof] = ACTIONS(2483),
    [anon_sym___alignof__] = ACTIONS(2483),
    [anon_sym___alignof] = ACTIONS(2483),
    [anon_sym__alignof] = ACTIONS(2483),
    [anon_sym_alignof] = ACTIONS(2483),
    [anon_sym__Alignof] = ACTIONS(2483),
    [anon_sym_offsetof] = ACTIONS(2483),
    [anon_sym__Generic] = ACTIONS(2483),
    [anon_sym_asm] = ACTIONS(2483),
    [anon_sym___asm__] = ACTIONS(2483),
    [anon_sym___asm] = ACTIONS(2483),
    [sym_number_literal] = ACTIONS(2485),
    [anon_sym_L_SQUOTE] = ACTIONS(2485),
    [anon_sym_u_SQUOTE] = ACTIONS(2485),
    [anon_sym_U_SQUOTE] = ACTIONS(2485),
    [anon_sym_u8_SQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [anon_sym_L_DQUOTE] = ACTIONS(2485),
    [anon_sym_u_DQUOTE] = ACTIONS(2485),
    [anon_sym_U_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8_DQUOTE] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [anon_sym_NULL] = ACTIONS(2483),
    [anon_sym_nullptr] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_namespace] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_concept] = ACTIONS(2483),
    [anon_sym_co_return] = ACTIONS(2483),
    [anon_sym_co_yield] = ACTIONS(2483),
    [anon_sym_catch] = ACTIONS(3240),
    [anon_sym_R_DQUOTE] = ACTIONS(2485),
    [anon_sym_LR_DQUOTE] = ACTIONS(2485),
    [anon_sym_uR_DQUOTE] = ACTIONS(2485),
    [anon_sym_UR_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2485),
    [anon_sym_co_await] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_requires] = ACTIONS(2483),
    [sym_this] = ACTIONS(2483),
  },
  [410] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4367),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7119),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7540),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3242),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [411] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4391),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7025),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7151),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3244),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [412] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4405),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7106),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7171),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3246),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(2721),
    [sym_identifier] = ACTIONS(2719),
    [aux_sym_preproc_include_token1] = ACTIONS(2719),
    [aux_sym_preproc_def_token1] = ACTIONS(2719),
    [aux_sym_preproc_if_token1] = ACTIONS(2719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2719),
    [sym_preproc_directive] = ACTIONS(2719),
    [anon_sym_LPAREN2] = ACTIONS(2721),
    [anon_sym_BANG] = ACTIONS(2721),
    [anon_sym_TILDE] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2719),
    [anon_sym_PLUS] = ACTIONS(2719),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(2719),
    [anon_sym_typedef] = ACTIONS(2719),
    [anon_sym_virtual] = ACTIONS(2719),
    [anon_sym_extern] = ACTIONS(2719),
    [anon_sym___attribute__] = ACTIONS(2719),
    [anon_sym___attribute] = ACTIONS(2719),
    [anon_sym_using] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2721),
    [anon_sym___declspec] = ACTIONS(2719),
    [anon_sym___based] = ACTIONS(2719),
    [anon_sym___cdecl] = ACTIONS(2719),
    [anon_sym___clrcall] = ACTIONS(2719),
    [anon_sym___stdcall] = ACTIONS(2719),
    [anon_sym___fastcall] = ACTIONS(2719),
    [anon_sym___thiscall] = ACTIONS(2719),
    [anon_sym___vectorcall] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2719),
    [anon_sym_unsigned] = ACTIONS(2719),
    [anon_sym_long] = ACTIONS(2719),
    [anon_sym_short] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_static] = ACTIONS(2719),
    [anon_sym_register] = ACTIONS(2719),
    [anon_sym_inline] = ACTIONS(2719),
    [anon_sym___inline] = ACTIONS(2719),
    [anon_sym___inline__] = ACTIONS(2719),
    [anon_sym___forceinline] = ACTIONS(2719),
    [anon_sym_thread_local] = ACTIONS(2719),
    [anon_sym___thread] = ACTIONS(2719),
    [anon_sym_const] = ACTIONS(2719),
    [anon_sym_constexpr] = ACTIONS(2719),
    [anon_sym_volatile] = ACTIONS(2719),
    [anon_sym_restrict] = ACTIONS(2719),
    [anon_sym___restrict__] = ACTIONS(2719),
    [anon_sym__Atomic] = ACTIONS(2719),
    [anon_sym__Noreturn] = ACTIONS(2719),
    [anon_sym_noreturn] = ACTIONS(2719),
    [anon_sym__Nonnull] = ACTIONS(2719),
    [anon_sym_mutable] = ACTIONS(2719),
    [anon_sym_constinit] = ACTIONS(2719),
    [anon_sym_consteval] = ACTIONS(2719),
    [anon_sym_alignas] = ACTIONS(2719),
    [anon_sym__Alignas] = ACTIONS(2719),
    [sym_primitive_type] = ACTIONS(2719),
    [anon_sym_enum] = ACTIONS(2719),
    [anon_sym_class] = ACTIONS(2719),
    [anon_sym_struct] = ACTIONS(2719),
    [anon_sym_union] = ACTIONS(2719),
    [anon_sym_if] = ACTIONS(2719),
    [anon_sym_else] = ACTIONS(2719),
    [anon_sym_switch] = ACTIONS(2719),
    [anon_sym_case] = ACTIONS(2719),
    [anon_sym_default] = ACTIONS(2719),
    [anon_sym_while] = ACTIONS(2719),
    [anon_sym_do] = ACTIONS(2719),
    [anon_sym_for] = ACTIONS(2719),
    [anon_sym_return] = ACTIONS(2719),
    [anon_sym_break] = ACTIONS(2719),
    [anon_sym_continue] = ACTIONS(2719),
    [anon_sym_goto] = ACTIONS(2719),
    [anon_sym___try] = ACTIONS(2719),
    [anon_sym___leave] = ACTIONS(2719),
    [anon_sym_not] = ACTIONS(2719),
    [anon_sym_compl] = ACTIONS(2719),
    [anon_sym_DASH_DASH] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(2721),
    [anon_sym_sizeof] = ACTIONS(2719),
    [anon_sym___alignof__] = ACTIONS(2719),
    [anon_sym___alignof] = ACTIONS(2719),
    [anon_sym__alignof] = ACTIONS(2719),
    [anon_sym_alignof] = ACTIONS(2719),
    [anon_sym__Alignof] = ACTIONS(2719),
    [anon_sym_offsetof] = ACTIONS(2719),
    [anon_sym__Generic] = ACTIONS(2719),
    [anon_sym_asm] = ACTIONS(2719),
    [anon_sym___asm__] = ACTIONS(2719),
    [anon_sym___asm] = ACTIONS(2719),
    [sym_number_literal] = ACTIONS(2721),
    [anon_sym_L_SQUOTE] = ACTIONS(2721),
    [anon_sym_u_SQUOTE] = ACTIONS(2721),
    [anon_sym_U_SQUOTE] = ACTIONS(2721),
    [anon_sym_u8_SQUOTE] = ACTIONS(2721),
    [anon_sym_SQUOTE] = ACTIONS(2721),
    [anon_sym_L_DQUOTE] = ACTIONS(2721),
    [anon_sym_u_DQUOTE] = ACTIONS(2721),
    [anon_sym_U_DQUOTE] = ACTIONS(2721),
    [anon_sym_u8_DQUOTE] = ACTIONS(2721),
    [anon_sym_DQUOTE] = ACTIONS(2721),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [anon_sym_NULL] = ACTIONS(2719),
    [anon_sym_nullptr] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2719),
    [anon_sym_decltype] = ACTIONS(2719),
    [anon_sym_explicit] = ACTIONS(2719),
    [anon_sym_typename] = ACTIONS(2719),
    [anon_sym_export] = ACTIONS(2719),
    [anon_sym_module] = ACTIONS(2719),
    [anon_sym_import] = ACTIONS(2719),
    [anon_sym_template] = ACTIONS(2719),
    [anon_sym_operator] = ACTIONS(2719),
    [anon_sym_try] = ACTIONS(2719),
    [anon_sym_delete] = ACTIONS(2719),
    [anon_sym_throw] = ACTIONS(2719),
    [anon_sym_namespace] = ACTIONS(2719),
    [anon_sym_static_assert] = ACTIONS(2719),
    [anon_sym_concept] = ACTIONS(2719),
    [anon_sym_co_return] = ACTIONS(2719),
    [anon_sym_co_yield] = ACTIONS(2719),
    [anon_sym_R_DQUOTE] = ACTIONS(2721),
    [anon_sym_LR_DQUOTE] = ACTIONS(2721),
    [anon_sym_uR_DQUOTE] = ACTIONS(2721),
    [anon_sym_UR_DQUOTE] = ACTIONS(2721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2721),
    [anon_sym_co_await] = ACTIONS(2719),
    [anon_sym_new] = ACTIONS(2719),
    [anon_sym_requires] = ACTIONS(2719),
    [sym_this] = ACTIONS(2719),
  },
  [414] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4323),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7040),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7179),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3248),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [415] = {
    [ts_builtin_sym_end] = ACTIONS(2741),
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [anon_sym___asm] = ACTIONS(2739),
    [sym_number_literal] = ACTIONS(2741),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_export] = ACTIONS(2739),
    [anon_sym_module] = ACTIONS(2739),
    [anon_sym_import] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [416] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4325),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(6938),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7193),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [417] = {
    [sym_expression] = STATE(4553),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8659),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3252),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym___extension__] = ACTIONS(3257),
    [anon_sym_virtual] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym___attribute__] = ACTIONS(2743),
    [anon_sym___attribute] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(3260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2745),
    [anon_sym___declspec] = ACTIONS(2743),
    [anon_sym_signed] = ACTIONS(2743),
    [anon_sym_unsigned] = ACTIONS(2743),
    [anon_sym_long] = ACTIONS(2743),
    [anon_sym_short] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_register] = ACTIONS(2743),
    [anon_sym_inline] = ACTIONS(2743),
    [anon_sym___inline] = ACTIONS(2743),
    [anon_sym___inline__] = ACTIONS(2743),
    [anon_sym___forceinline] = ACTIONS(2743),
    [anon_sym_thread_local] = ACTIONS(2743),
    [anon_sym___thread] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_constexpr] = ACTIONS(2743),
    [anon_sym_volatile] = ACTIONS(2743),
    [anon_sym_restrict] = ACTIONS(2743),
    [anon_sym___restrict__] = ACTIONS(2743),
    [anon_sym__Atomic] = ACTIONS(2743),
    [anon_sym__Noreturn] = ACTIONS(2743),
    [anon_sym_noreturn] = ACTIONS(2743),
    [anon_sym__Nonnull] = ACTIONS(2743),
    [anon_sym_mutable] = ACTIONS(2743),
    [anon_sym_constinit] = ACTIONS(2743),
    [anon_sym_consteval] = ACTIONS(2743),
    [anon_sym_alignas] = ACTIONS(2743),
    [anon_sym__Alignas] = ACTIONS(2743),
    [sym_primitive_type] = ACTIONS(3263),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2743),
    [anon_sym_decltype] = ACTIONS(3266),
    [anon_sym_typename] = ACTIONS(2743),
    [anon_sym_template] = ACTIONS(3269),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [418] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4330),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7083),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7203),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3272),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [419] = {
    [sym_expression] = STATE(4559),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8670),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym___extension__] = ACTIONS(3279),
    [anon_sym_virtual] = ACTIONS(3282),
    [anon_sym_extern] = ACTIONS(3282),
    [anon_sym___attribute__] = ACTIONS(3282),
    [anon_sym___attribute] = ACTIONS(3282),
    [anon_sym_COLON_COLON] = ACTIONS(3284),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3287),
    [anon_sym___declspec] = ACTIONS(3282),
    [anon_sym_signed] = ACTIONS(3282),
    [anon_sym_unsigned] = ACTIONS(3282),
    [anon_sym_long] = ACTIONS(3282),
    [anon_sym_short] = ACTIONS(3282),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(3282),
    [anon_sym_register] = ACTIONS(3282),
    [anon_sym_inline] = ACTIONS(3282),
    [anon_sym___inline] = ACTIONS(3282),
    [anon_sym___inline__] = ACTIONS(3282),
    [anon_sym___forceinline] = ACTIONS(3282),
    [anon_sym_thread_local] = ACTIONS(3282),
    [anon_sym___thread] = ACTIONS(3282),
    [anon_sym_const] = ACTIONS(3282),
    [anon_sym_constexpr] = ACTIONS(3282),
    [anon_sym_volatile] = ACTIONS(3282),
    [anon_sym_restrict] = ACTIONS(3282),
    [anon_sym___restrict__] = ACTIONS(3282),
    [anon_sym__Atomic] = ACTIONS(3282),
    [anon_sym__Noreturn] = ACTIONS(3282),
    [anon_sym_noreturn] = ACTIONS(3282),
    [anon_sym__Nonnull] = ACTIONS(3282),
    [anon_sym_mutable] = ACTIONS(3282),
    [anon_sym_constinit] = ACTIONS(3282),
    [anon_sym_consteval] = ACTIONS(3282),
    [anon_sym_alignas] = ACTIONS(3282),
    [anon_sym__Alignas] = ACTIONS(3282),
    [sym_primitive_type] = ACTIONS(3289),
    [anon_sym_enum] = ACTIONS(3282),
    [anon_sym_class] = ACTIONS(3282),
    [anon_sym_struct] = ACTIONS(3282),
    [anon_sym_union] = ACTIONS(3282),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3282),
    [anon_sym_decltype] = ACTIONS(3292),
    [anon_sym_typename] = ACTIONS(3282),
    [anon_sym_template] = ACTIONS(3295),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(2749),
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_export] = ACTIONS(2747),
    [anon_sym_module] = ACTIONS(2747),
    [anon_sym_import] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [421] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4332),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(6979),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7211),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(2753),
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [anon_sym___asm] = ACTIONS(2751),
    [sym_number_literal] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_export] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(2751),
    [anon_sym_import] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(2683),
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_include_token1] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym___cdecl] = ACTIONS(2681),
    [anon_sym___clrcall] = ACTIONS(2681),
    [anon_sym___stdcall] = ACTIONS(2681),
    [anon_sym___fastcall] = ACTIONS(2681),
    [anon_sym___thiscall] = ACTIONS(2681),
    [anon_sym___vectorcall] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_case] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_goto] = ACTIONS(2681),
    [anon_sym___try] = ACTIONS(2681),
    [anon_sym___leave] = ACTIONS(2681),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_compl] = ACTIONS(2681),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_sizeof] = ACTIONS(2681),
    [anon_sym___alignof__] = ACTIONS(2681),
    [anon_sym___alignof] = ACTIONS(2681),
    [anon_sym__alignof] = ACTIONS(2681),
    [anon_sym_alignof] = ACTIONS(2681),
    [anon_sym__Alignof] = ACTIONS(2681),
    [anon_sym_offsetof] = ACTIONS(2681),
    [anon_sym__Generic] = ACTIONS(2681),
    [anon_sym_asm] = ACTIONS(2681),
    [anon_sym___asm__] = ACTIONS(2681),
    [anon_sym___asm] = ACTIONS(2681),
    [sym_number_literal] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2683),
    [anon_sym_u_SQUOTE] = ACTIONS(2683),
    [anon_sym_U_SQUOTE] = ACTIONS(2683),
    [anon_sym_u8_SQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_L_DQUOTE] = ACTIONS(2683),
    [anon_sym_u_DQUOTE] = ACTIONS(2683),
    [anon_sym_U_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8_DQUOTE] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [anon_sym_NULL] = ACTIONS(2681),
    [anon_sym_nullptr] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_export] = ACTIONS(2681),
    [anon_sym_module] = ACTIONS(2681),
    [anon_sym_import] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
    [anon_sym_concept] = ACTIONS(2681),
    [anon_sym_co_return] = ACTIONS(2681),
    [anon_sym_co_yield] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2683),
    [anon_sym_LR_DQUOTE] = ACTIONS(2683),
    [anon_sym_uR_DQUOTE] = ACTIONS(2683),
    [anon_sym_UR_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2683),
    [anon_sym_co_await] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_requires] = ACTIONS(2681),
    [sym_this] = ACTIONS(2681),
  },
  [424] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4334),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7030),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7218),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3300),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [425] = {
    [sym_catch_clause] = STATE(425),
    [aux_sym_constructor_try_statement_repeat1] = STATE(425),
    [sym_identifier] = ACTIONS(2476),
    [aux_sym_preproc_include_token1] = ACTIONS(2476),
    [aux_sym_preproc_def_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token1] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2476),
    [sym_preproc_directive] = ACTIONS(2476),
    [anon_sym_LPAREN2] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym___extension__] = ACTIONS(2476),
    [anon_sym_typedef] = ACTIONS(2476),
    [anon_sym_virtual] = ACTIONS(2476),
    [anon_sym_extern] = ACTIONS(2476),
    [anon_sym___attribute__] = ACTIONS(2476),
    [anon_sym___attribute] = ACTIONS(2476),
    [anon_sym_using] = ACTIONS(2476),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2478),
    [anon_sym___declspec] = ACTIONS(2476),
    [anon_sym___based] = ACTIONS(2476),
    [anon_sym___cdecl] = ACTIONS(2476),
    [anon_sym___clrcall] = ACTIONS(2476),
    [anon_sym___stdcall] = ACTIONS(2476),
    [anon_sym___fastcall] = ACTIONS(2476),
    [anon_sym___thiscall] = ACTIONS(2476),
    [anon_sym___vectorcall] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_signed] = ACTIONS(2476),
    [anon_sym_unsigned] = ACTIONS(2476),
    [anon_sym_long] = ACTIONS(2476),
    [anon_sym_short] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_register] = ACTIONS(2476),
    [anon_sym_inline] = ACTIONS(2476),
    [anon_sym___inline] = ACTIONS(2476),
    [anon_sym___inline__] = ACTIONS(2476),
    [anon_sym___forceinline] = ACTIONS(2476),
    [anon_sym_thread_local] = ACTIONS(2476),
    [anon_sym___thread] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_constexpr] = ACTIONS(2476),
    [anon_sym_volatile] = ACTIONS(2476),
    [anon_sym_restrict] = ACTIONS(2476),
    [anon_sym___restrict__] = ACTIONS(2476),
    [anon_sym__Atomic] = ACTIONS(2476),
    [anon_sym__Noreturn] = ACTIONS(2476),
    [anon_sym_noreturn] = ACTIONS(2476),
    [anon_sym__Nonnull] = ACTIONS(2476),
    [anon_sym_mutable] = ACTIONS(2476),
    [anon_sym_constinit] = ACTIONS(2476),
    [anon_sym_consteval] = ACTIONS(2476),
    [anon_sym_alignas] = ACTIONS(2476),
    [anon_sym__Alignas] = ACTIONS(2476),
    [sym_primitive_type] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [anon_sym_class] = ACTIONS(2476),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2476),
    [anon_sym_if] = ACTIONS(2476),
    [anon_sym_else] = ACTIONS(2476),
    [anon_sym_switch] = ACTIONS(2476),
    [anon_sym_case] = ACTIONS(2476),
    [anon_sym_default] = ACTIONS(2476),
    [anon_sym_while] = ACTIONS(2476),
    [anon_sym_do] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2476),
    [anon_sym_break] = ACTIONS(2476),
    [anon_sym_continue] = ACTIONS(2476),
    [anon_sym_goto] = ACTIONS(2476),
    [anon_sym___try] = ACTIONS(2476),
    [anon_sym___leave] = ACTIONS(2476),
    [anon_sym_not] = ACTIONS(2476),
    [anon_sym_compl] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2476),
    [anon_sym___alignof__] = ACTIONS(2476),
    [anon_sym___alignof] = ACTIONS(2476),
    [anon_sym__alignof] = ACTIONS(2476),
    [anon_sym_alignof] = ACTIONS(2476),
    [anon_sym__Alignof] = ACTIONS(2476),
    [anon_sym_offsetof] = ACTIONS(2476),
    [anon_sym__Generic] = ACTIONS(2476),
    [anon_sym_asm] = ACTIONS(2476),
    [anon_sym___asm__] = ACTIONS(2476),
    [anon_sym___asm] = ACTIONS(2476),
    [sym_number_literal] = ACTIONS(2478),
    [anon_sym_L_SQUOTE] = ACTIONS(2478),
    [anon_sym_u_SQUOTE] = ACTIONS(2478),
    [anon_sym_U_SQUOTE] = ACTIONS(2478),
    [anon_sym_u8_SQUOTE] = ACTIONS(2478),
    [anon_sym_SQUOTE] = ACTIONS(2478),
    [anon_sym_L_DQUOTE] = ACTIONS(2478),
    [anon_sym_u_DQUOTE] = ACTIONS(2478),
    [anon_sym_U_DQUOTE] = ACTIONS(2478),
    [anon_sym_u8_DQUOTE] = ACTIONS(2478),
    [anon_sym_DQUOTE] = ACTIONS(2478),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2476),
    [anon_sym_nullptr] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2476),
    [anon_sym_decltype] = ACTIONS(2476),
    [anon_sym_explicit] = ACTIONS(2476),
    [anon_sym_typename] = ACTIONS(2476),
    [anon_sym_template] = ACTIONS(2476),
    [anon_sym_operator] = ACTIONS(2476),
    [anon_sym_try] = ACTIONS(2476),
    [anon_sym_delete] = ACTIONS(2476),
    [anon_sym_throw] = ACTIONS(2476),
    [anon_sym_namespace] = ACTIONS(2476),
    [anon_sym_static_assert] = ACTIONS(2476),
    [anon_sym_concept] = ACTIONS(2476),
    [anon_sym_co_return] = ACTIONS(2476),
    [anon_sym_co_yield] = ACTIONS(2476),
    [anon_sym_catch] = ACTIONS(3302),
    [anon_sym_R_DQUOTE] = ACTIONS(2478),
    [anon_sym_LR_DQUOTE] = ACTIONS(2478),
    [anon_sym_uR_DQUOTE] = ACTIONS(2478),
    [anon_sym_UR_DQUOTE] = ACTIONS(2478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2478),
    [anon_sym_co_await] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2476),
    [anon_sym_requires] = ACTIONS(2476),
    [sym_this] = ACTIONS(2476),
  },
  [426] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4336),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7094),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7229),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3305),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [427] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4339),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(6939),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7238),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(3307),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2659),
    [aux_sym_preproc_include_token1] = ACTIONS(2659),
    [aux_sym_preproc_def_token1] = ACTIONS(2659),
    [aux_sym_preproc_if_token1] = ACTIONS(2659),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2659),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2659),
    [sym_preproc_directive] = ACTIONS(2659),
    [anon_sym_LPAREN2] = ACTIONS(2661),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym___extension__] = ACTIONS(2659),
    [anon_sym_typedef] = ACTIONS(2659),
    [anon_sym_virtual] = ACTIONS(2659),
    [anon_sym_extern] = ACTIONS(2659),
    [anon_sym___attribute__] = ACTIONS(2659),
    [anon_sym___attribute] = ACTIONS(2659),
    [anon_sym_using] = ACTIONS(2659),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2661),
    [anon_sym___declspec] = ACTIONS(2659),
    [anon_sym___based] = ACTIONS(2659),
    [anon_sym___cdecl] = ACTIONS(2659),
    [anon_sym___clrcall] = ACTIONS(2659),
    [anon_sym___stdcall] = ACTIONS(2659),
    [anon_sym___fastcall] = ACTIONS(2659),
    [anon_sym___thiscall] = ACTIONS(2659),
    [anon_sym___vectorcall] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_signed] = ACTIONS(2659),
    [anon_sym_unsigned] = ACTIONS(2659),
    [anon_sym_long] = ACTIONS(2659),
    [anon_sym_short] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2659),
    [anon_sym_register] = ACTIONS(2659),
    [anon_sym_inline] = ACTIONS(2659),
    [anon_sym___inline] = ACTIONS(2659),
    [anon_sym___inline__] = ACTIONS(2659),
    [anon_sym___forceinline] = ACTIONS(2659),
    [anon_sym_thread_local] = ACTIONS(2659),
    [anon_sym___thread] = ACTIONS(2659),
    [anon_sym_const] = ACTIONS(2659),
    [anon_sym_constexpr] = ACTIONS(2659),
    [anon_sym_volatile] = ACTIONS(2659),
    [anon_sym_restrict] = ACTIONS(2659),
    [anon_sym___restrict__] = ACTIONS(2659),
    [anon_sym__Atomic] = ACTIONS(2659),
    [anon_sym__Noreturn] = ACTIONS(2659),
    [anon_sym_noreturn] = ACTIONS(2659),
    [anon_sym__Nonnull] = ACTIONS(2659),
    [anon_sym_mutable] = ACTIONS(2659),
    [anon_sym_constinit] = ACTIONS(2659),
    [anon_sym_consteval] = ACTIONS(2659),
    [anon_sym_alignas] = ACTIONS(2659),
    [anon_sym__Alignas] = ACTIONS(2659),
    [sym_primitive_type] = ACTIONS(2659),
    [anon_sym_enum] = ACTIONS(2659),
    [anon_sym_class] = ACTIONS(2659),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_union] = ACTIONS(2659),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_else] = ACTIONS(2659),
    [anon_sym_switch] = ACTIONS(2659),
    [anon_sym_case] = ACTIONS(2659),
    [anon_sym_default] = ACTIONS(2659),
    [anon_sym_while] = ACTIONS(2659),
    [anon_sym_do] = ACTIONS(2659),
    [anon_sym_for] = ACTIONS(2659),
    [anon_sym_return] = ACTIONS(2659),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_continue] = ACTIONS(2659),
    [anon_sym_goto] = ACTIONS(2659),
    [anon_sym___try] = ACTIONS(2659),
    [anon_sym___leave] = ACTIONS(2659),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_compl] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2661),
    [anon_sym_PLUS_PLUS] = ACTIONS(2661),
    [anon_sym_sizeof] = ACTIONS(2659),
    [anon_sym___alignof__] = ACTIONS(2659),
    [anon_sym___alignof] = ACTIONS(2659),
    [anon_sym__alignof] = ACTIONS(2659),
    [anon_sym_alignof] = ACTIONS(2659),
    [anon_sym__Alignof] = ACTIONS(2659),
    [anon_sym_offsetof] = ACTIONS(2659),
    [anon_sym__Generic] = ACTIONS(2659),
    [anon_sym_asm] = ACTIONS(2659),
    [anon_sym___asm__] = ACTIONS(2659),
    [anon_sym___asm] = ACTIONS(2659),
    [sym_number_literal] = ACTIONS(2661),
    [anon_sym_L_SQUOTE] = ACTIONS(2661),
    [anon_sym_u_SQUOTE] = ACTIONS(2661),
    [anon_sym_U_SQUOTE] = ACTIONS(2661),
    [anon_sym_u8_SQUOTE] = ACTIONS(2661),
    [anon_sym_SQUOTE] = ACTIONS(2661),
    [anon_sym_L_DQUOTE] = ACTIONS(2661),
    [anon_sym_u_DQUOTE] = ACTIONS(2661),
    [anon_sym_U_DQUOTE] = ACTIONS(2661),
    [anon_sym_u8_DQUOTE] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [anon_sym_NULL] = ACTIONS(2659),
    [anon_sym_nullptr] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2659),
    [anon_sym_decltype] = ACTIONS(2659),
    [anon_sym_explicit] = ACTIONS(2659),
    [anon_sym_typename] = ACTIONS(2659),
    [anon_sym_export] = ACTIONS(2659),
    [anon_sym_module] = ACTIONS(2659),
    [anon_sym_import] = ACTIONS(2659),
    [anon_sym_template] = ACTIONS(2659),
    [anon_sym_operator] = ACTIONS(2659),
    [anon_sym_try] = ACTIONS(2659),
    [anon_sym_delete] = ACTIONS(2659),
    [anon_sym_throw] = ACTIONS(2659),
    [anon_sym_namespace] = ACTIONS(2659),
    [anon_sym_static_assert] = ACTIONS(2659),
    [anon_sym_concept] = ACTIONS(2659),
    [anon_sym_co_return] = ACTIONS(2659),
    [anon_sym_co_yield] = ACTIONS(2659),
    [anon_sym_R_DQUOTE] = ACTIONS(2661),
    [anon_sym_LR_DQUOTE] = ACTIONS(2661),
    [anon_sym_uR_DQUOTE] = ACTIONS(2661),
    [anon_sym_UR_DQUOTE] = ACTIONS(2661),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2661),
    [anon_sym_co_await] = ACTIONS(2659),
    [anon_sym_new] = ACTIONS(2659),
    [anon_sym_requires] = ACTIONS(2659),
    [sym_this] = ACTIONS(2659),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2655),
    [aux_sym_preproc_include_token1] = ACTIONS(2655),
    [aux_sym_preproc_def_token1] = ACTIONS(2655),
    [aux_sym_preproc_if_token1] = ACTIONS(2655),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2655),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2655),
    [sym_preproc_directive] = ACTIONS(2655),
    [anon_sym_LPAREN2] = ACTIONS(2657),
    [anon_sym_BANG] = ACTIONS(2657),
    [anon_sym_TILDE] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_AMP_AMP] = ACTIONS(2657),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym___extension__] = ACTIONS(2655),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_virtual] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym___attribute__] = ACTIONS(2655),
    [anon_sym___attribute] = ACTIONS(2655),
    [anon_sym_using] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2657),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2657),
    [anon_sym___declspec] = ACTIONS(2655),
    [anon_sym___based] = ACTIONS(2655),
    [anon_sym___cdecl] = ACTIONS(2655),
    [anon_sym___clrcall] = ACTIONS(2655),
    [anon_sym___stdcall] = ACTIONS(2655),
    [anon_sym___fastcall] = ACTIONS(2655),
    [anon_sym___thiscall] = ACTIONS(2655),
    [anon_sym___vectorcall] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_signed] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2655),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym___inline] = ACTIONS(2655),
    [anon_sym___inline__] = ACTIONS(2655),
    [anon_sym___forceinline] = ACTIONS(2655),
    [anon_sym_thread_local] = ACTIONS(2655),
    [anon_sym___thread] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym___restrict__] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym__Noreturn] = ACTIONS(2655),
    [anon_sym_noreturn] = ACTIONS(2655),
    [anon_sym__Nonnull] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_constinit] = ACTIONS(2655),
    [anon_sym_consteval] = ACTIONS(2655),
    [anon_sym_alignas] = ACTIONS(2655),
    [anon_sym__Alignas] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_class] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_else] = ACTIONS(2655),
    [anon_sym_switch] = ACTIONS(2655),
    [anon_sym_case] = ACTIONS(2655),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym___try] = ACTIONS(2655),
    [anon_sym___leave] = ACTIONS(2655),
    [anon_sym_not] = ACTIONS(2655),
    [anon_sym_compl] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(2657),
    [anon_sym_sizeof] = ACTIONS(2655),
    [anon_sym___alignof__] = ACTIONS(2655),
    [anon_sym___alignof] = ACTIONS(2655),
    [anon_sym__alignof] = ACTIONS(2655),
    [anon_sym_alignof] = ACTIONS(2655),
    [anon_sym__Alignof] = ACTIONS(2655),
    [anon_sym_offsetof] = ACTIONS(2655),
    [anon_sym__Generic] = ACTIONS(2655),
    [anon_sym_asm] = ACTIONS(2655),
    [anon_sym___asm__] = ACTIONS(2655),
    [anon_sym___asm] = ACTIONS(2655),
    [sym_number_literal] = ACTIONS(2657),
    [anon_sym_L_SQUOTE] = ACTIONS(2657),
    [anon_sym_u_SQUOTE] = ACTIONS(2657),
    [anon_sym_U_SQUOTE] = ACTIONS(2657),
    [anon_sym_u8_SQUOTE] = ACTIONS(2657),
    [anon_sym_SQUOTE] = ACTIONS(2657),
    [anon_sym_L_DQUOTE] = ACTIONS(2657),
    [anon_sym_u_DQUOTE] = ACTIONS(2657),
    [anon_sym_U_DQUOTE] = ACTIONS(2657),
    [anon_sym_u8_DQUOTE] = ACTIONS(2657),
    [anon_sym_DQUOTE] = ACTIONS(2657),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [anon_sym_NULL] = ACTIONS(2655),
    [anon_sym_nullptr] = ACTIONS(2655),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_decltype] = ACTIONS(2655),
    [anon_sym_explicit] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_export] = ACTIONS(2655),
    [anon_sym_module] = ACTIONS(2655),
    [anon_sym_import] = ACTIONS(2655),
    [anon_sym_template] = ACTIONS(2655),
    [anon_sym_operator] = ACTIONS(2655),
    [anon_sym_try] = ACTIONS(2655),
    [anon_sym_delete] = ACTIONS(2655),
    [anon_sym_throw] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_static_assert] = ACTIONS(2655),
    [anon_sym_concept] = ACTIONS(2655),
    [anon_sym_co_return] = ACTIONS(2655),
    [anon_sym_co_yield] = ACTIONS(2655),
    [anon_sym_R_DQUOTE] = ACTIONS(2657),
    [anon_sym_LR_DQUOTE] = ACTIONS(2657),
    [anon_sym_uR_DQUOTE] = ACTIONS(2657),
    [anon_sym_UR_DQUOTE] = ACTIONS(2657),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2657),
    [anon_sym_co_await] = ACTIONS(2655),
    [anon_sym_new] = ACTIONS(2655),
    [anon_sym_requires] = ACTIONS(2655),
    [sym_this] = ACTIONS(2655),
  },
  [430] = {
    [sym_identifier] = ACTIONS(3309),
    [aux_sym_preproc_include_token1] = ACTIONS(3309),
    [aux_sym_preproc_def_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token2] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3309),
    [aux_sym_preproc_else_token1] = ACTIONS(3309),
    [aux_sym_preproc_elif_token1] = ACTIONS(3309),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3309),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3309),
    [sym_preproc_directive] = ACTIONS(3309),
    [anon_sym_LPAREN2] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_AMP_AMP] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym___extension__] = ACTIONS(3309),
    [anon_sym_typedef] = ACTIONS(3309),
    [anon_sym_virtual] = ACTIONS(3309),
    [anon_sym_extern] = ACTIONS(3309),
    [anon_sym___attribute__] = ACTIONS(3309),
    [anon_sym___attribute] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_COLON_COLON] = ACTIONS(3311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3311),
    [anon_sym___declspec] = ACTIONS(3309),
    [anon_sym___based] = ACTIONS(3309),
    [anon_sym___cdecl] = ACTIONS(3309),
    [anon_sym___clrcall] = ACTIONS(3309),
    [anon_sym___stdcall] = ACTIONS(3309),
    [anon_sym___fastcall] = ACTIONS(3309),
    [anon_sym___thiscall] = ACTIONS(3309),
    [anon_sym___vectorcall] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_signed] = ACTIONS(3309),
    [anon_sym_unsigned] = ACTIONS(3309),
    [anon_sym_long] = ACTIONS(3309),
    [anon_sym_short] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_register] = ACTIONS(3309),
    [anon_sym_inline] = ACTIONS(3309),
    [anon_sym___inline] = ACTIONS(3309),
    [anon_sym___inline__] = ACTIONS(3309),
    [anon_sym___forceinline] = ACTIONS(3309),
    [anon_sym_thread_local] = ACTIONS(3309),
    [anon_sym___thread] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_constexpr] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(3309),
    [anon_sym_restrict] = ACTIONS(3309),
    [anon_sym___restrict__] = ACTIONS(3309),
    [anon_sym__Atomic] = ACTIONS(3309),
    [anon_sym__Noreturn] = ACTIONS(3309),
    [anon_sym_noreturn] = ACTIONS(3309),
    [anon_sym__Nonnull] = ACTIONS(3309),
    [anon_sym_mutable] = ACTIONS(3309),
    [anon_sym_constinit] = ACTIONS(3309),
    [anon_sym_consteval] = ACTIONS(3309),
    [anon_sym_alignas] = ACTIONS(3309),
    [anon_sym__Alignas] = ACTIONS(3309),
    [sym_primitive_type] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_struct] = ACTIONS(3309),
    [anon_sym_union] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_case] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_goto] = ACTIONS(3309),
    [anon_sym___try] = ACTIONS(3309),
    [anon_sym___leave] = ACTIONS(3309),
    [anon_sym_not] = ACTIONS(3309),
    [anon_sym_compl] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_sizeof] = ACTIONS(3309),
    [anon_sym___alignof__] = ACTIONS(3309),
    [anon_sym___alignof] = ACTIONS(3309),
    [anon_sym__alignof] = ACTIONS(3309),
    [anon_sym_alignof] = ACTIONS(3309),
    [anon_sym__Alignof] = ACTIONS(3309),
    [anon_sym_offsetof] = ACTIONS(3309),
    [anon_sym__Generic] = ACTIONS(3309),
    [anon_sym_asm] = ACTIONS(3309),
    [anon_sym___asm__] = ACTIONS(3309),
    [anon_sym___asm] = ACTIONS(3309),
    [sym_number_literal] = ACTIONS(3311),
    [anon_sym_L_SQUOTE] = ACTIONS(3311),
    [anon_sym_u_SQUOTE] = ACTIONS(3311),
    [anon_sym_U_SQUOTE] = ACTIONS(3311),
    [anon_sym_u8_SQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_L_DQUOTE] = ACTIONS(3311),
    [anon_sym_u_DQUOTE] = ACTIONS(3311),
    [anon_sym_U_DQUOTE] = ACTIONS(3311),
    [anon_sym_u8_DQUOTE] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3309),
    [anon_sym_nullptr] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3309),
    [anon_sym_decltype] = ACTIONS(3309),
    [anon_sym_explicit] = ACTIONS(3309),
    [anon_sym_typename] = ACTIONS(3309),
    [anon_sym_template] = ACTIONS(3309),
    [anon_sym_operator] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_static_assert] = ACTIONS(3309),
    [anon_sym_concept] = ACTIONS(3309),
    [anon_sym_co_return] = ACTIONS(3309),
    [anon_sym_co_yield] = ACTIONS(3309),
    [anon_sym_R_DQUOTE] = ACTIONS(3311),
    [anon_sym_LR_DQUOTE] = ACTIONS(3311),
    [anon_sym_uR_DQUOTE] = ACTIONS(3311),
    [anon_sym_UR_DQUOTE] = ACTIONS(3311),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3311),
    [anon_sym_co_await] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_requires] = ACTIONS(3309),
    [sym_this] = ACTIONS(3309),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(2737),
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [anon_sym___asm] = ACTIONS(2735),
    [sym_number_literal] = ACTIONS(2737),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_export] = ACTIONS(2735),
    [anon_sym_module] = ACTIONS(2735),
    [anon_sym_import] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [432] = {
    [sym_identifier] = ACTIONS(3313),
    [aux_sym_preproc_include_token1] = ACTIONS(3313),
    [aux_sym_preproc_def_token1] = ACTIONS(3313),
    [aux_sym_preproc_if_token1] = ACTIONS(3313),
    [aux_sym_preproc_if_token2] = ACTIONS(3313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3313),
    [aux_sym_preproc_else_token1] = ACTIONS(3313),
    [aux_sym_preproc_elif_token1] = ACTIONS(3313),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3313),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3313),
    [sym_preproc_directive] = ACTIONS(3313),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_PLUS] = ACTIONS(3313),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3313),
    [anon_sym_typedef] = ACTIONS(3313),
    [anon_sym_virtual] = ACTIONS(3313),
    [anon_sym_extern] = ACTIONS(3313),
    [anon_sym___attribute__] = ACTIONS(3313),
    [anon_sym___attribute] = ACTIONS(3313),
    [anon_sym_using] = ACTIONS(3313),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3313),
    [anon_sym___based] = ACTIONS(3313),
    [anon_sym___cdecl] = ACTIONS(3313),
    [anon_sym___clrcall] = ACTIONS(3313),
    [anon_sym___stdcall] = ACTIONS(3313),
    [anon_sym___fastcall] = ACTIONS(3313),
    [anon_sym___thiscall] = ACTIONS(3313),
    [anon_sym___vectorcall] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3313),
    [anon_sym_unsigned] = ACTIONS(3313),
    [anon_sym_long] = ACTIONS(3313),
    [anon_sym_short] = ACTIONS(3313),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_static] = ACTIONS(3313),
    [anon_sym_register] = ACTIONS(3313),
    [anon_sym_inline] = ACTIONS(3313),
    [anon_sym___inline] = ACTIONS(3313),
    [anon_sym___inline__] = ACTIONS(3313),
    [anon_sym___forceinline] = ACTIONS(3313),
    [anon_sym_thread_local] = ACTIONS(3313),
    [anon_sym___thread] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3313),
    [anon_sym_constexpr] = ACTIONS(3313),
    [anon_sym_volatile] = ACTIONS(3313),
    [anon_sym_restrict] = ACTIONS(3313),
    [anon_sym___restrict__] = ACTIONS(3313),
    [anon_sym__Atomic] = ACTIONS(3313),
    [anon_sym__Noreturn] = ACTIONS(3313),
    [anon_sym_noreturn] = ACTIONS(3313),
    [anon_sym__Nonnull] = ACTIONS(3313),
    [anon_sym_mutable] = ACTIONS(3313),
    [anon_sym_constinit] = ACTIONS(3313),
    [anon_sym_consteval] = ACTIONS(3313),
    [anon_sym_alignas] = ACTIONS(3313),
    [anon_sym__Alignas] = ACTIONS(3313),
    [sym_primitive_type] = ACTIONS(3313),
    [anon_sym_enum] = ACTIONS(3313),
    [anon_sym_class] = ACTIONS(3313),
    [anon_sym_struct] = ACTIONS(3313),
    [anon_sym_union] = ACTIONS(3313),
    [anon_sym_if] = ACTIONS(3313),
    [anon_sym_switch] = ACTIONS(3313),
    [anon_sym_case] = ACTIONS(3313),
    [anon_sym_default] = ACTIONS(3313),
    [anon_sym_while] = ACTIONS(3313),
    [anon_sym_do] = ACTIONS(3313),
    [anon_sym_for] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3313),
    [anon_sym_break] = ACTIONS(3313),
    [anon_sym_continue] = ACTIONS(3313),
    [anon_sym_goto] = ACTIONS(3313),
    [anon_sym___try] = ACTIONS(3313),
    [anon_sym___leave] = ACTIONS(3313),
    [anon_sym_not] = ACTIONS(3313),
    [anon_sym_compl] = ACTIONS(3313),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3313),
    [anon_sym___alignof__] = ACTIONS(3313),
    [anon_sym___alignof] = ACTIONS(3313),
    [anon_sym__alignof] = ACTIONS(3313),
    [anon_sym_alignof] = ACTIONS(3313),
    [anon_sym__Alignof] = ACTIONS(3313),
    [anon_sym_offsetof] = ACTIONS(3313),
    [anon_sym__Generic] = ACTIONS(3313),
    [anon_sym_asm] = ACTIONS(3313),
    [anon_sym___asm__] = ACTIONS(3313),
    [anon_sym___asm] = ACTIONS(3313),
    [sym_number_literal] = ACTIONS(3316),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3313),
    [sym_false] = ACTIONS(3313),
    [anon_sym_NULL] = ACTIONS(3313),
    [anon_sym_nullptr] = ACTIONS(3313),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3313),
    [anon_sym_decltype] = ACTIONS(3313),
    [anon_sym_explicit] = ACTIONS(3313),
    [anon_sym_typename] = ACTIONS(3313),
    [anon_sym_template] = ACTIONS(3313),
    [anon_sym_operator] = ACTIONS(3313),
    [anon_sym_try] = ACTIONS(3313),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_throw] = ACTIONS(3313),
    [anon_sym_namespace] = ACTIONS(3313),
    [anon_sym_static_assert] = ACTIONS(3313),
    [anon_sym_concept] = ACTIONS(3313),
    [anon_sym_co_return] = ACTIONS(3313),
    [anon_sym_co_yield] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3313),
    [anon_sym_new] = ACTIONS(3313),
    [anon_sym_requires] = ACTIONS(3313),
    [sym_this] = ACTIONS(3313),
  },
  [433] = {
    [sym_identifier] = ACTIONS(3319),
    [aux_sym_preproc_include_token1] = ACTIONS(3319),
    [aux_sym_preproc_def_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token2] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3319),
    [aux_sym_preproc_else_token1] = ACTIONS(3319),
    [aux_sym_preproc_elif_token1] = ACTIONS(3319),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3319),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3319),
    [sym_preproc_directive] = ACTIONS(3319),
    [anon_sym_LPAREN2] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym___extension__] = ACTIONS(3319),
    [anon_sym_typedef] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym___attribute__] = ACTIONS(3319),
    [anon_sym___attribute] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_COLON_COLON] = ACTIONS(3321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3321),
    [anon_sym___declspec] = ACTIONS(3319),
    [anon_sym___based] = ACTIONS(3319),
    [anon_sym___cdecl] = ACTIONS(3319),
    [anon_sym___clrcall] = ACTIONS(3319),
    [anon_sym___stdcall] = ACTIONS(3319),
    [anon_sym___fastcall] = ACTIONS(3319),
    [anon_sym___thiscall] = ACTIONS(3319),
    [anon_sym___vectorcall] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_signed] = ACTIONS(3319),
    [anon_sym_unsigned] = ACTIONS(3319),
    [anon_sym_long] = ACTIONS(3319),
    [anon_sym_short] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_register] = ACTIONS(3319),
    [anon_sym_inline] = ACTIONS(3319),
    [anon_sym___inline] = ACTIONS(3319),
    [anon_sym___inline__] = ACTIONS(3319),
    [anon_sym___forceinline] = ACTIONS(3319),
    [anon_sym_thread_local] = ACTIONS(3319),
    [anon_sym___thread] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_constexpr] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_restrict] = ACTIONS(3319),
    [anon_sym___restrict__] = ACTIONS(3319),
    [anon_sym__Atomic] = ACTIONS(3319),
    [anon_sym__Noreturn] = ACTIONS(3319),
    [anon_sym_noreturn] = ACTIONS(3319),
    [anon_sym__Nonnull] = ACTIONS(3319),
    [anon_sym_mutable] = ACTIONS(3319),
    [anon_sym_constinit] = ACTIONS(3319),
    [anon_sym_consteval] = ACTIONS(3319),
    [anon_sym_alignas] = ACTIONS(3319),
    [anon_sym__Alignas] = ACTIONS(3319),
    [sym_primitive_type] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_union] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_case] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_goto] = ACTIONS(3319),
    [anon_sym___try] = ACTIONS(3319),
    [anon_sym___leave] = ACTIONS(3319),
    [anon_sym_not] = ACTIONS(3319),
    [anon_sym_compl] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_sizeof] = ACTIONS(3319),
    [anon_sym___alignof__] = ACTIONS(3319),
    [anon_sym___alignof] = ACTIONS(3319),
    [anon_sym__alignof] = ACTIONS(3319),
    [anon_sym_alignof] = ACTIONS(3319),
    [anon_sym__Alignof] = ACTIONS(3319),
    [anon_sym_offsetof] = ACTIONS(3319),
    [anon_sym__Generic] = ACTIONS(3319),
    [anon_sym_asm] = ACTIONS(3319),
    [anon_sym___asm__] = ACTIONS(3319),
    [anon_sym___asm] = ACTIONS(3319),
    [sym_number_literal] = ACTIONS(3321),
    [anon_sym_L_SQUOTE] = ACTIONS(3321),
    [anon_sym_u_SQUOTE] = ACTIONS(3321),
    [anon_sym_U_SQUOTE] = ACTIONS(3321),
    [anon_sym_u8_SQUOTE] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [anon_sym_L_DQUOTE] = ACTIONS(3321),
    [anon_sym_u_DQUOTE] = ACTIONS(3321),
    [anon_sym_U_DQUOTE] = ACTIONS(3321),
    [anon_sym_u8_DQUOTE] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [sym_true] = ACTIONS(3319),
    [sym_false] = ACTIONS(3319),
    [anon_sym_NULL] = ACTIONS(3319),
    [anon_sym_nullptr] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3319),
    [anon_sym_decltype] = ACTIONS(3319),
    [anon_sym_explicit] = ACTIONS(3319),
    [anon_sym_typename] = ACTIONS(3319),
    [anon_sym_template] = ACTIONS(3319),
    [anon_sym_operator] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_delete] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_static_assert] = ACTIONS(3319),
    [anon_sym_concept] = ACTIONS(3319),
    [anon_sym_co_return] = ACTIONS(3319),
    [anon_sym_co_yield] = ACTIONS(3319),
    [anon_sym_R_DQUOTE] = ACTIONS(3321),
    [anon_sym_LR_DQUOTE] = ACTIONS(3321),
    [anon_sym_uR_DQUOTE] = ACTIONS(3321),
    [anon_sym_UR_DQUOTE] = ACTIONS(3321),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3321),
    [anon_sym_co_await] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3319),
    [sym_this] = ACTIONS(3319),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(2809),
    [sym_identifier] = ACTIONS(2807),
    [aux_sym_preproc_include_token1] = ACTIONS(2807),
    [aux_sym_preproc_def_token1] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2807),
    [sym_preproc_directive] = ACTIONS(2807),
    [anon_sym_LPAREN2] = ACTIONS(2809),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_TILDE] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2807),
    [anon_sym_typedef] = ACTIONS(2807),
    [anon_sym_virtual] = ACTIONS(2807),
    [anon_sym_extern] = ACTIONS(2807),
    [anon_sym___attribute__] = ACTIONS(2807),
    [anon_sym___attribute] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2809),
    [anon_sym___declspec] = ACTIONS(2807),
    [anon_sym___based] = ACTIONS(2807),
    [anon_sym___cdecl] = ACTIONS(2807),
    [anon_sym___clrcall] = ACTIONS(2807),
    [anon_sym___stdcall] = ACTIONS(2807),
    [anon_sym___fastcall] = ACTIONS(2807),
    [anon_sym___thiscall] = ACTIONS(2807),
    [anon_sym___vectorcall] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2809),
    [anon_sym_RBRACE] = ACTIONS(2809),
    [anon_sym_signed] = ACTIONS(2807),
    [anon_sym_unsigned] = ACTIONS(2807),
    [anon_sym_long] = ACTIONS(2807),
    [anon_sym_short] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_static] = ACTIONS(2807),
    [anon_sym_register] = ACTIONS(2807),
    [anon_sym_inline] = ACTIONS(2807),
    [anon_sym___inline] = ACTIONS(2807),
    [anon_sym___inline__] = ACTIONS(2807),
    [anon_sym___forceinline] = ACTIONS(2807),
    [anon_sym_thread_local] = ACTIONS(2807),
    [anon_sym___thread] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_constexpr] = ACTIONS(2807),
    [anon_sym_volatile] = ACTIONS(2807),
    [anon_sym_restrict] = ACTIONS(2807),
    [anon_sym___restrict__] = ACTIONS(2807),
    [anon_sym__Atomic] = ACTIONS(2807),
    [anon_sym__Noreturn] = ACTIONS(2807),
    [anon_sym_noreturn] = ACTIONS(2807),
    [anon_sym__Nonnull] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_constinit] = ACTIONS(2807),
    [anon_sym_consteval] = ACTIONS(2807),
    [anon_sym_alignas] = ACTIONS(2807),
    [anon_sym__Alignas] = ACTIONS(2807),
    [sym_primitive_type] = ACTIONS(2807),
    [anon_sym_enum] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_union] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_switch] = ACTIONS(2807),
    [anon_sym_case] = ACTIONS(2807),
    [anon_sym_default] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_for] = ACTIONS(2807),
    [anon_sym_return] = ACTIONS(2807),
    [anon_sym_break] = ACTIONS(2807),
    [anon_sym_continue] = ACTIONS(2807),
    [anon_sym_goto] = ACTIONS(2807),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2809),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2807),
    [anon_sym___alignof] = ACTIONS(2807),
    [anon_sym__alignof] = ACTIONS(2807),
    [anon_sym_alignof] = ACTIONS(2807),
    [anon_sym__Alignof] = ACTIONS(2807),
    [anon_sym_offsetof] = ACTIONS(2807),
    [anon_sym__Generic] = ACTIONS(2807),
    [anon_sym_asm] = ACTIONS(2807),
    [anon_sym___asm__] = ACTIONS(2807),
    [anon_sym___asm] = ACTIONS(2807),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2809),
    [anon_sym_u_SQUOTE] = ACTIONS(2809),
    [anon_sym_U_SQUOTE] = ACTIONS(2809),
    [anon_sym_u8_SQUOTE] = ACTIONS(2809),
    [anon_sym_SQUOTE] = ACTIONS(2809),
    [anon_sym_L_DQUOTE] = ACTIONS(2809),
    [anon_sym_u_DQUOTE] = ACTIONS(2809),
    [anon_sym_U_DQUOTE] = ACTIONS(2809),
    [anon_sym_u8_DQUOTE] = ACTIONS(2809),
    [anon_sym_DQUOTE] = ACTIONS(2809),
    [sym_true] = ACTIONS(2807),
    [sym_false] = ACTIONS(2807),
    [anon_sym_NULL] = ACTIONS(2807),
    [anon_sym_nullptr] = ACTIONS(2807),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2807),
    [anon_sym_decltype] = ACTIONS(2807),
    [anon_sym_explicit] = ACTIONS(2807),
    [anon_sym_typename] = ACTIONS(2807),
    [anon_sym_export] = ACTIONS(2807),
    [anon_sym_module] = ACTIONS(2807),
    [anon_sym_import] = ACTIONS(2807),
    [anon_sym_template] = ACTIONS(2807),
    [anon_sym_operator] = ACTIONS(2807),
    [anon_sym_try] = ACTIONS(2807),
    [anon_sym_delete] = ACTIONS(2807),
    [anon_sym_throw] = ACTIONS(2807),
    [anon_sym_namespace] = ACTIONS(2807),
    [anon_sym_static_assert] = ACTIONS(2807),
    [anon_sym_concept] = ACTIONS(2807),
    [anon_sym_co_return] = ACTIONS(2807),
    [anon_sym_co_yield] = ACTIONS(2807),
    [anon_sym_R_DQUOTE] = ACTIONS(2809),
    [anon_sym_LR_DQUOTE] = ACTIONS(2809),
    [anon_sym_uR_DQUOTE] = ACTIONS(2809),
    [anon_sym_UR_DQUOTE] = ACTIONS(2809),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2809),
    [anon_sym_co_await] = ACTIONS(2807),
    [anon_sym_new] = ACTIONS(2807),
    [anon_sym_requires] = ACTIONS(2807),
    [sym_this] = ACTIONS(2807),
  },
  [435] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2601),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [436] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2603),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(3311),
    [sym_identifier] = ACTIONS(3309),
    [aux_sym_preproc_include_token1] = ACTIONS(3309),
    [aux_sym_preproc_def_token1] = ACTIONS(3309),
    [anon_sym_COMMA] = ACTIONS(3311),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3309),
    [sym_preproc_directive] = ACTIONS(3309),
    [anon_sym_LPAREN2] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_AMP_AMP] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym___extension__] = ACTIONS(3309),
    [anon_sym_typedef] = ACTIONS(3309),
    [anon_sym_virtual] = ACTIONS(3309),
    [anon_sym_extern] = ACTIONS(3309),
    [anon_sym___attribute__] = ACTIONS(3309),
    [anon_sym___attribute] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_COLON_COLON] = ACTIONS(3311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3311),
    [anon_sym___declspec] = ACTIONS(3309),
    [anon_sym___based] = ACTIONS(3309),
    [anon_sym___cdecl] = ACTIONS(3309),
    [anon_sym___clrcall] = ACTIONS(3309),
    [anon_sym___stdcall] = ACTIONS(3309),
    [anon_sym___fastcall] = ACTIONS(3309),
    [anon_sym___thiscall] = ACTIONS(3309),
    [anon_sym___vectorcall] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_RBRACE] = ACTIONS(3311),
    [anon_sym_signed] = ACTIONS(3309),
    [anon_sym_unsigned] = ACTIONS(3309),
    [anon_sym_long] = ACTIONS(3309),
    [anon_sym_short] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_register] = ACTIONS(3309),
    [anon_sym_inline] = ACTIONS(3309),
    [anon_sym___inline] = ACTIONS(3309),
    [anon_sym___inline__] = ACTIONS(3309),
    [anon_sym___forceinline] = ACTIONS(3309),
    [anon_sym_thread_local] = ACTIONS(3309),
    [anon_sym___thread] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_constexpr] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(3309),
    [anon_sym_restrict] = ACTIONS(3309),
    [anon_sym___restrict__] = ACTIONS(3309),
    [anon_sym__Atomic] = ACTIONS(3309),
    [anon_sym__Noreturn] = ACTIONS(3309),
    [anon_sym_noreturn] = ACTIONS(3309),
    [anon_sym__Nonnull] = ACTIONS(3309),
    [anon_sym_mutable] = ACTIONS(3309),
    [anon_sym_constinit] = ACTIONS(3309),
    [anon_sym_consteval] = ACTIONS(3309),
    [anon_sym_alignas] = ACTIONS(3309),
    [anon_sym__Alignas] = ACTIONS(3309),
    [sym_primitive_type] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_struct] = ACTIONS(3309),
    [anon_sym_union] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_case] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_goto] = ACTIONS(3309),
    [anon_sym_not] = ACTIONS(3309),
    [anon_sym_compl] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_sizeof] = ACTIONS(3309),
    [anon_sym___alignof__] = ACTIONS(3309),
    [anon_sym___alignof] = ACTIONS(3309),
    [anon_sym__alignof] = ACTIONS(3309),
    [anon_sym_alignof] = ACTIONS(3309),
    [anon_sym__Alignof] = ACTIONS(3309),
    [anon_sym_offsetof] = ACTIONS(3309),
    [anon_sym__Generic] = ACTIONS(3309),
    [anon_sym_asm] = ACTIONS(3309),
    [anon_sym___asm__] = ACTIONS(3309),
    [anon_sym___asm] = ACTIONS(3309),
    [sym_number_literal] = ACTIONS(3311),
    [anon_sym_L_SQUOTE] = ACTIONS(3311),
    [anon_sym_u_SQUOTE] = ACTIONS(3311),
    [anon_sym_U_SQUOTE] = ACTIONS(3311),
    [anon_sym_u8_SQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_L_DQUOTE] = ACTIONS(3311),
    [anon_sym_u_DQUOTE] = ACTIONS(3311),
    [anon_sym_U_DQUOTE] = ACTIONS(3311),
    [anon_sym_u8_DQUOTE] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3309),
    [anon_sym_nullptr] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3309),
    [anon_sym_decltype] = ACTIONS(3309),
    [anon_sym_explicit] = ACTIONS(3309),
    [anon_sym_typename] = ACTIONS(3309),
    [anon_sym_export] = ACTIONS(3309),
    [anon_sym_module] = ACTIONS(3309),
    [anon_sym_import] = ACTIONS(3309),
    [anon_sym_template] = ACTIONS(3309),
    [anon_sym_operator] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_static_assert] = ACTIONS(3309),
    [anon_sym_concept] = ACTIONS(3309),
    [anon_sym_co_return] = ACTIONS(3309),
    [anon_sym_co_yield] = ACTIONS(3309),
    [anon_sym_R_DQUOTE] = ACTIONS(3311),
    [anon_sym_LR_DQUOTE] = ACTIONS(3311),
    [anon_sym_uR_DQUOTE] = ACTIONS(3311),
    [anon_sym_UR_DQUOTE] = ACTIONS(3311),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3311),
    [anon_sym_co_await] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_requires] = ACTIONS(3309),
    [sym_this] = ACTIONS(3309),
  },
  [438] = {
    [sym_catch_clause] = STATE(362),
    [aux_sym_constructor_try_statement_repeat1] = STATE(362),
    [sym_identifier] = ACTIONS(2547),
    [aux_sym_preproc_include_token1] = ACTIONS(2547),
    [aux_sym_preproc_def_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token2] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2547),
    [sym_preproc_directive] = ACTIONS(2547),
    [anon_sym_LPAREN2] = ACTIONS(2549),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_TILDE] = ACTIONS(2549),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_PLUS] = ACTIONS(2547),
    [anon_sym_STAR] = ACTIONS(2549),
    [anon_sym_AMP_AMP] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(2549),
    [anon_sym___extension__] = ACTIONS(2547),
    [anon_sym_typedef] = ACTIONS(2547),
    [anon_sym_virtual] = ACTIONS(2547),
    [anon_sym_extern] = ACTIONS(2547),
    [anon_sym___attribute__] = ACTIONS(2547),
    [anon_sym___attribute] = ACTIONS(2547),
    [anon_sym_using] = ACTIONS(2547),
    [anon_sym_COLON_COLON] = ACTIONS(2549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2549),
    [anon_sym___declspec] = ACTIONS(2547),
    [anon_sym___based] = ACTIONS(2547),
    [anon_sym___cdecl] = ACTIONS(2547),
    [anon_sym___clrcall] = ACTIONS(2547),
    [anon_sym___stdcall] = ACTIONS(2547),
    [anon_sym___fastcall] = ACTIONS(2547),
    [anon_sym___thiscall] = ACTIONS(2547),
    [anon_sym___vectorcall] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [anon_sym_signed] = ACTIONS(2547),
    [anon_sym_unsigned] = ACTIONS(2547),
    [anon_sym_long] = ACTIONS(2547),
    [anon_sym_short] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_register] = ACTIONS(2547),
    [anon_sym_inline] = ACTIONS(2547),
    [anon_sym___inline] = ACTIONS(2547),
    [anon_sym___inline__] = ACTIONS(2547),
    [anon_sym___forceinline] = ACTIONS(2547),
    [anon_sym_thread_local] = ACTIONS(2547),
    [anon_sym___thread] = ACTIONS(2547),
    [anon_sym_const] = ACTIONS(2547),
    [anon_sym_constexpr] = ACTIONS(2547),
    [anon_sym_volatile] = ACTIONS(2547),
    [anon_sym_restrict] = ACTIONS(2547),
    [anon_sym___restrict__] = ACTIONS(2547),
    [anon_sym__Atomic] = ACTIONS(2547),
    [anon_sym__Noreturn] = ACTIONS(2547),
    [anon_sym_noreturn] = ACTIONS(2547),
    [anon_sym__Nonnull] = ACTIONS(2547),
    [anon_sym_mutable] = ACTIONS(2547),
    [anon_sym_constinit] = ACTIONS(2547),
    [anon_sym_consteval] = ACTIONS(2547),
    [anon_sym_alignas] = ACTIONS(2547),
    [anon_sym__Alignas] = ACTIONS(2547),
    [sym_primitive_type] = ACTIONS(2547),
    [anon_sym_enum] = ACTIONS(2547),
    [anon_sym_class] = ACTIONS(2547),
    [anon_sym_struct] = ACTIONS(2547),
    [anon_sym_union] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(2547),
    [anon_sym_switch] = ACTIONS(2547),
    [anon_sym_case] = ACTIONS(2547),
    [anon_sym_default] = ACTIONS(2547),
    [anon_sym_while] = ACTIONS(2547),
    [anon_sym_do] = ACTIONS(2547),
    [anon_sym_for] = ACTIONS(2547),
    [anon_sym_return] = ACTIONS(2547),
    [anon_sym_break] = ACTIONS(2547),
    [anon_sym_continue] = ACTIONS(2547),
    [anon_sym_goto] = ACTIONS(2547),
    [anon_sym___try] = ACTIONS(2547),
    [anon_sym___leave] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2547),
    [anon_sym_compl] = ACTIONS(2547),
    [anon_sym_DASH_DASH] = ACTIONS(2549),
    [anon_sym_PLUS_PLUS] = ACTIONS(2549),
    [anon_sym_sizeof] = ACTIONS(2547),
    [anon_sym___alignof__] = ACTIONS(2547),
    [anon_sym___alignof] = ACTIONS(2547),
    [anon_sym__alignof] = ACTIONS(2547),
    [anon_sym_alignof] = ACTIONS(2547),
    [anon_sym__Alignof] = ACTIONS(2547),
    [anon_sym_offsetof] = ACTIONS(2547),
    [anon_sym__Generic] = ACTIONS(2547),
    [anon_sym_asm] = ACTIONS(2547),
    [anon_sym___asm__] = ACTIONS(2547),
    [anon_sym___asm] = ACTIONS(2547),
    [sym_number_literal] = ACTIONS(2549),
    [anon_sym_L_SQUOTE] = ACTIONS(2549),
    [anon_sym_u_SQUOTE] = ACTIONS(2549),
    [anon_sym_U_SQUOTE] = ACTIONS(2549),
    [anon_sym_u8_SQUOTE] = ACTIONS(2549),
    [anon_sym_SQUOTE] = ACTIONS(2549),
    [anon_sym_L_DQUOTE] = ACTIONS(2549),
    [anon_sym_u_DQUOTE] = ACTIONS(2549),
    [anon_sym_U_DQUOTE] = ACTIONS(2549),
    [anon_sym_u8_DQUOTE] = ACTIONS(2549),
    [anon_sym_DQUOTE] = ACTIONS(2549),
    [sym_true] = ACTIONS(2547),
    [sym_false] = ACTIONS(2547),
    [anon_sym_NULL] = ACTIONS(2547),
    [anon_sym_nullptr] = ACTIONS(2547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2547),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2547),
    [anon_sym_template] = ACTIONS(2547),
    [anon_sym_operator] = ACTIONS(2547),
    [anon_sym_try] = ACTIONS(2547),
    [anon_sym_delete] = ACTIONS(2547),
    [anon_sym_throw] = ACTIONS(2547),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_static_assert] = ACTIONS(2547),
    [anon_sym_concept] = ACTIONS(2547),
    [anon_sym_co_return] = ACTIONS(2547),
    [anon_sym_co_yield] = ACTIONS(2547),
    [anon_sym_catch] = ACTIONS(3087),
    [anon_sym_R_DQUOTE] = ACTIONS(2549),
    [anon_sym_LR_DQUOTE] = ACTIONS(2549),
    [anon_sym_uR_DQUOTE] = ACTIONS(2549),
    [anon_sym_UR_DQUOTE] = ACTIONS(2549),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2549),
    [anon_sym_co_await] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2547),
    [anon_sym_requires] = ACTIONS(2547),
    [sym_this] = ACTIONS(2547),
  },
  [439] = {
    [sym_catch_clause] = STATE(362),
    [aux_sym_constructor_try_statement_repeat1] = STATE(362),
    [sym_identifier] = ACTIONS(2590),
    [aux_sym_preproc_include_token1] = ACTIONS(2590),
    [aux_sym_preproc_def_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token2] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2590),
    [sym_preproc_directive] = ACTIONS(2590),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_TILDE] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym___extension__] = ACTIONS(2590),
    [anon_sym_typedef] = ACTIONS(2590),
    [anon_sym_virtual] = ACTIONS(2590),
    [anon_sym_extern] = ACTIONS(2590),
    [anon_sym___attribute__] = ACTIONS(2590),
    [anon_sym___attribute] = ACTIONS(2590),
    [anon_sym_using] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2592),
    [anon_sym___declspec] = ACTIONS(2590),
    [anon_sym___based] = ACTIONS(2590),
    [anon_sym___cdecl] = ACTIONS(2590),
    [anon_sym___clrcall] = ACTIONS(2590),
    [anon_sym___stdcall] = ACTIONS(2590),
    [anon_sym___fastcall] = ACTIONS(2590),
    [anon_sym___thiscall] = ACTIONS(2590),
    [anon_sym___vectorcall] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_signed] = ACTIONS(2590),
    [anon_sym_unsigned] = ACTIONS(2590),
    [anon_sym_long] = ACTIONS(2590),
    [anon_sym_short] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2590),
    [anon_sym_register] = ACTIONS(2590),
    [anon_sym_inline] = ACTIONS(2590),
    [anon_sym___inline] = ACTIONS(2590),
    [anon_sym___inline__] = ACTIONS(2590),
    [anon_sym___forceinline] = ACTIONS(2590),
    [anon_sym_thread_local] = ACTIONS(2590),
    [anon_sym___thread] = ACTIONS(2590),
    [anon_sym_const] = ACTIONS(2590),
    [anon_sym_constexpr] = ACTIONS(2590),
    [anon_sym_volatile] = ACTIONS(2590),
    [anon_sym_restrict] = ACTIONS(2590),
    [anon_sym___restrict__] = ACTIONS(2590),
    [anon_sym__Atomic] = ACTIONS(2590),
    [anon_sym__Noreturn] = ACTIONS(2590),
    [anon_sym_noreturn] = ACTIONS(2590),
    [anon_sym__Nonnull] = ACTIONS(2590),
    [anon_sym_mutable] = ACTIONS(2590),
    [anon_sym_constinit] = ACTIONS(2590),
    [anon_sym_consteval] = ACTIONS(2590),
    [anon_sym_alignas] = ACTIONS(2590),
    [anon_sym__Alignas] = ACTIONS(2590),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_enum] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_struct] = ACTIONS(2590),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_switch] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_default] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_continue] = ACTIONS(2590),
    [anon_sym_goto] = ACTIONS(2590),
    [anon_sym___try] = ACTIONS(2590),
    [anon_sym___leave] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_compl] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2592),
    [anon_sym_sizeof] = ACTIONS(2590),
    [anon_sym___alignof__] = ACTIONS(2590),
    [anon_sym___alignof] = ACTIONS(2590),
    [anon_sym__alignof] = ACTIONS(2590),
    [anon_sym_alignof] = ACTIONS(2590),
    [anon_sym__Alignof] = ACTIONS(2590),
    [anon_sym_offsetof] = ACTIONS(2590),
    [anon_sym__Generic] = ACTIONS(2590),
    [anon_sym_asm] = ACTIONS(2590),
    [anon_sym___asm__] = ACTIONS(2590),
    [anon_sym___asm] = ACTIONS(2590),
    [sym_number_literal] = ACTIONS(2592),
    [anon_sym_L_SQUOTE] = ACTIONS(2592),
    [anon_sym_u_SQUOTE] = ACTIONS(2592),
    [anon_sym_U_SQUOTE] = ACTIONS(2592),
    [anon_sym_u8_SQUOTE] = ACTIONS(2592),
    [anon_sym_SQUOTE] = ACTIONS(2592),
    [anon_sym_L_DQUOTE] = ACTIONS(2592),
    [anon_sym_u_DQUOTE] = ACTIONS(2592),
    [anon_sym_U_DQUOTE] = ACTIONS(2592),
    [anon_sym_u8_DQUOTE] = ACTIONS(2592),
    [anon_sym_DQUOTE] = ACTIONS(2592),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [anon_sym_NULL] = ACTIONS(2590),
    [anon_sym_nullptr] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2590),
    [anon_sym_decltype] = ACTIONS(2590),
    [anon_sym_explicit] = ACTIONS(2590),
    [anon_sym_typename] = ACTIONS(2590),
    [anon_sym_template] = ACTIONS(2590),
    [anon_sym_operator] = ACTIONS(2590),
    [anon_sym_try] = ACTIONS(2590),
    [anon_sym_delete] = ACTIONS(2590),
    [anon_sym_throw] = ACTIONS(2590),
    [anon_sym_namespace] = ACTIONS(2590),
    [anon_sym_static_assert] = ACTIONS(2590),
    [anon_sym_concept] = ACTIONS(2590),
    [anon_sym_co_return] = ACTIONS(2590),
    [anon_sym_co_yield] = ACTIONS(2590),
    [anon_sym_catch] = ACTIONS(3087),
    [anon_sym_R_DQUOTE] = ACTIONS(2592),
    [anon_sym_LR_DQUOTE] = ACTIONS(2592),
    [anon_sym_uR_DQUOTE] = ACTIONS(2592),
    [anon_sym_UR_DQUOTE] = ACTIONS(2592),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2592),
    [anon_sym_co_await] = ACTIONS(2590),
    [anon_sym_new] = ACTIONS(2590),
    [anon_sym_requires] = ACTIONS(2590),
    [sym_this] = ACTIONS(2590),
  },
  [440] = {
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_unaligned_ptr_modifier] = STATE(4043),
    [sym_ms_pointer_modifier] = STATE(2954),
    [sym__declarator] = STATE(6493),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_type_qualifier] = STATE(3928),
    [sym_alignas_qualifier] = STATE(4289),
    [sym_expression] = STATE(3197),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3233),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5659),
    [sym_qualified_identifier] = STATE(3292),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3365),
    [aux_sym__type_definition_type_repeat1] = STATE(3928),
    [aux_sym_pointer_declarator_repeat1] = STATE(2954),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_LPAREN2] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1802),
    [anon_sym___extension__] = ACTIONS(3325),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(3327),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3327),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3327),
    [anon_sym__unaligned] = ACTIONS(3329),
    [anon_sym___unaligned] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_constexpr] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_restrict] = ACTIONS(3331),
    [anon_sym___restrict__] = ACTIONS(3331),
    [anon_sym__Atomic] = ACTIONS(3331),
    [anon_sym__Noreturn] = ACTIONS(3331),
    [anon_sym_noreturn] = ACTIONS(3331),
    [anon_sym__Nonnull] = ACTIONS(3331),
    [anon_sym_mutable] = ACTIONS(3331),
    [anon_sym_constinit] = ACTIONS(3331),
    [anon_sym_consteval] = ACTIONS(3331),
    [anon_sym_alignas] = ACTIONS(3333),
    [anon_sym__Alignas] = ACTIONS(3333),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [441] = {
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_unaligned_ptr_modifier] = STATE(4043),
    [sym_ms_pointer_modifier] = STATE(2954),
    [sym__declarator] = STATE(6493),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_type_qualifier] = STATE(3928),
    [sym_alignas_qualifier] = STATE(4289),
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3243),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5654),
    [sym_qualified_identifier] = STATE(3252),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(2480),
    [aux_sym__type_definition_type_repeat1] = STATE(3928),
    [aux_sym_pointer_declarator_repeat1] = STATE(2954),
    [sym_identifier] = ACTIONS(3335),
    [anon_sym_LPAREN2] = ACTIONS(3337),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(3341),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(3327),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3327),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3327),
    [anon_sym__unaligned] = ACTIONS(3329),
    [anon_sym___unaligned] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_constexpr] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_restrict] = ACTIONS(3331),
    [anon_sym___restrict__] = ACTIONS(3331),
    [anon_sym__Atomic] = ACTIONS(3331),
    [anon_sym__Noreturn] = ACTIONS(3331),
    [anon_sym_noreturn] = ACTIONS(3331),
    [anon_sym__Nonnull] = ACTIONS(3331),
    [anon_sym_mutable] = ACTIONS(3331),
    [anon_sym_constinit] = ACTIONS(3331),
    [anon_sym_consteval] = ACTIONS(3331),
    [anon_sym_alignas] = ACTIONS(3333),
    [anon_sym__Alignas] = ACTIONS(3333),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_include_token1] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [anon_sym_RPAREN] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym___cdecl] = ACTIONS(1940),
    [anon_sym___clrcall] = ACTIONS(1940),
    [anon_sym___stdcall] = ACTIONS(1940),
    [anon_sym___fastcall] = ACTIONS(1940),
    [anon_sym___thiscall] = ACTIONS(1940),
    [anon_sym___vectorcall] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1940),
    [anon_sym_not] = ACTIONS(1940),
    [anon_sym_compl] = ACTIONS(1940),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_sizeof] = ACTIONS(1940),
    [anon_sym___alignof__] = ACTIONS(1940),
    [anon_sym___alignof] = ACTIONS(1940),
    [anon_sym__alignof] = ACTIONS(1940),
    [anon_sym_alignof] = ACTIONS(1940),
    [anon_sym__Alignof] = ACTIONS(1940),
    [anon_sym_offsetof] = ACTIONS(1940),
    [anon_sym__Generic] = ACTIONS(1940),
    [anon_sym_asm] = ACTIONS(1940),
    [anon_sym___asm__] = ACTIONS(1940),
    [anon_sym___asm] = ACTIONS(1940),
    [sym_number_literal] = ACTIONS(1938),
    [anon_sym_L_SQUOTE] = ACTIONS(1938),
    [anon_sym_u_SQUOTE] = ACTIONS(1938),
    [anon_sym_U_SQUOTE] = ACTIONS(1938),
    [anon_sym_u8_SQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_L_DQUOTE] = ACTIONS(1938),
    [anon_sym_u_DQUOTE] = ACTIONS(1938),
    [anon_sym_U_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8_DQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [anon_sym_NULL] = ACTIONS(1940),
    [anon_sym_nullptr] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_export] = ACTIONS(1940),
    [anon_sym_module] = ACTIONS(1940),
    [anon_sym_import] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_concept] = ACTIONS(1940),
    [anon_sym_co_return] = ACTIONS(1940),
    [anon_sym_co_yield] = ACTIONS(1940),
    [anon_sym_R_DQUOTE] = ACTIONS(1938),
    [anon_sym_LR_DQUOTE] = ACTIONS(1938),
    [anon_sym_uR_DQUOTE] = ACTIONS(1938),
    [anon_sym_UR_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1938),
    [anon_sym_co_await] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_requires] = ACTIONS(1940),
    [sym_this] = ACTIONS(1940),
  },
  [443] = {
    [sym_type_qualifier] = STATE(3910),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4737),
    [sym_sized_type_specifier] = STATE(2668),
    [sym_enum_specifier] = STATE(2668),
    [sym_struct_specifier] = STATE(2668),
    [sym_union_specifier] = STATE(2668),
    [sym_expression] = STATE(4462),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_type_descriptor] = STATE(7408),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_placeholder_type_specifier] = STATE(2668),
    [sym_decltype_auto] = STATE(2708),
    [sym_decltype] = STATE(2598),
    [sym_class_specifier] = STATE(2668),
    [sym__class_name] = STATE(7804),
    [sym_dependent_type] = STATE(2668),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_type_parameter_pack_expansion] = STATE(7711),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5750),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3602),
    [aux_sym__type_definition_type_repeat1] = STATE(3910),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4239),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3130),
    [anon_sym_unsigned] = ACTIONS(3130),
    [anon_sym_long] = ACTIONS(3130),
    [anon_sym_short] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3140),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3168),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [444] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(3345),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [445] = {
    [sym_catch_clause] = STATE(425),
    [aux_sym_constructor_try_statement_repeat1] = STATE(425),
    [sym_identifier] = ACTIONS(2547),
    [aux_sym_preproc_include_token1] = ACTIONS(2547),
    [aux_sym_preproc_def_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token1] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2547),
    [sym_preproc_directive] = ACTIONS(2547),
    [anon_sym_LPAREN2] = ACTIONS(2549),
    [anon_sym_BANG] = ACTIONS(2549),
    [anon_sym_TILDE] = ACTIONS(2549),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_PLUS] = ACTIONS(2547),
    [anon_sym_STAR] = ACTIONS(2549),
    [anon_sym_AMP_AMP] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(2549),
    [anon_sym___extension__] = ACTIONS(2547),
    [anon_sym_typedef] = ACTIONS(2547),
    [anon_sym_virtual] = ACTIONS(2547),
    [anon_sym_extern] = ACTIONS(2547),
    [anon_sym___attribute__] = ACTIONS(2547),
    [anon_sym___attribute] = ACTIONS(2547),
    [anon_sym_using] = ACTIONS(2547),
    [anon_sym_COLON_COLON] = ACTIONS(2549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2549),
    [anon_sym___declspec] = ACTIONS(2547),
    [anon_sym___based] = ACTIONS(2547),
    [anon_sym___cdecl] = ACTIONS(2547),
    [anon_sym___clrcall] = ACTIONS(2547),
    [anon_sym___stdcall] = ACTIONS(2547),
    [anon_sym___fastcall] = ACTIONS(2547),
    [anon_sym___thiscall] = ACTIONS(2547),
    [anon_sym___vectorcall] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [anon_sym_RBRACE] = ACTIONS(2549),
    [anon_sym_signed] = ACTIONS(2547),
    [anon_sym_unsigned] = ACTIONS(2547),
    [anon_sym_long] = ACTIONS(2547),
    [anon_sym_short] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_register] = ACTIONS(2547),
    [anon_sym_inline] = ACTIONS(2547),
    [anon_sym___inline] = ACTIONS(2547),
    [anon_sym___inline__] = ACTIONS(2547),
    [anon_sym___forceinline] = ACTIONS(2547),
    [anon_sym_thread_local] = ACTIONS(2547),
    [anon_sym___thread] = ACTIONS(2547),
    [anon_sym_const] = ACTIONS(2547),
    [anon_sym_constexpr] = ACTIONS(2547),
    [anon_sym_volatile] = ACTIONS(2547),
    [anon_sym_restrict] = ACTIONS(2547),
    [anon_sym___restrict__] = ACTIONS(2547),
    [anon_sym__Atomic] = ACTIONS(2547),
    [anon_sym__Noreturn] = ACTIONS(2547),
    [anon_sym_noreturn] = ACTIONS(2547),
    [anon_sym__Nonnull] = ACTIONS(2547),
    [anon_sym_mutable] = ACTIONS(2547),
    [anon_sym_constinit] = ACTIONS(2547),
    [anon_sym_consteval] = ACTIONS(2547),
    [anon_sym_alignas] = ACTIONS(2547),
    [anon_sym__Alignas] = ACTIONS(2547),
    [sym_primitive_type] = ACTIONS(2547),
    [anon_sym_enum] = ACTIONS(2547),
    [anon_sym_class] = ACTIONS(2547),
    [anon_sym_struct] = ACTIONS(2547),
    [anon_sym_union] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(2547),
    [anon_sym_switch] = ACTIONS(2547),
    [anon_sym_case] = ACTIONS(2547),
    [anon_sym_default] = ACTIONS(2547),
    [anon_sym_while] = ACTIONS(2547),
    [anon_sym_do] = ACTIONS(2547),
    [anon_sym_for] = ACTIONS(2547),
    [anon_sym_return] = ACTIONS(2547),
    [anon_sym_break] = ACTIONS(2547),
    [anon_sym_continue] = ACTIONS(2547),
    [anon_sym_goto] = ACTIONS(2547),
    [anon_sym___try] = ACTIONS(2547),
    [anon_sym___leave] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2547),
    [anon_sym_compl] = ACTIONS(2547),
    [anon_sym_DASH_DASH] = ACTIONS(2549),
    [anon_sym_PLUS_PLUS] = ACTIONS(2549),
    [anon_sym_sizeof] = ACTIONS(2547),
    [anon_sym___alignof__] = ACTIONS(2547),
    [anon_sym___alignof] = ACTIONS(2547),
    [anon_sym__alignof] = ACTIONS(2547),
    [anon_sym_alignof] = ACTIONS(2547),
    [anon_sym__Alignof] = ACTIONS(2547),
    [anon_sym_offsetof] = ACTIONS(2547),
    [anon_sym__Generic] = ACTIONS(2547),
    [anon_sym_asm] = ACTIONS(2547),
    [anon_sym___asm__] = ACTIONS(2547),
    [anon_sym___asm] = ACTIONS(2547),
    [sym_number_literal] = ACTIONS(2549),
    [anon_sym_L_SQUOTE] = ACTIONS(2549),
    [anon_sym_u_SQUOTE] = ACTIONS(2549),
    [anon_sym_U_SQUOTE] = ACTIONS(2549),
    [anon_sym_u8_SQUOTE] = ACTIONS(2549),
    [anon_sym_SQUOTE] = ACTIONS(2549),
    [anon_sym_L_DQUOTE] = ACTIONS(2549),
    [anon_sym_u_DQUOTE] = ACTIONS(2549),
    [anon_sym_U_DQUOTE] = ACTIONS(2549),
    [anon_sym_u8_DQUOTE] = ACTIONS(2549),
    [anon_sym_DQUOTE] = ACTIONS(2549),
    [sym_true] = ACTIONS(2547),
    [sym_false] = ACTIONS(2547),
    [anon_sym_NULL] = ACTIONS(2547),
    [anon_sym_nullptr] = ACTIONS(2547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2547),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2547),
    [anon_sym_template] = ACTIONS(2547),
    [anon_sym_operator] = ACTIONS(2547),
    [anon_sym_try] = ACTIONS(2547),
    [anon_sym_delete] = ACTIONS(2547),
    [anon_sym_throw] = ACTIONS(2547),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_static_assert] = ACTIONS(2547),
    [anon_sym_concept] = ACTIONS(2547),
    [anon_sym_co_return] = ACTIONS(2547),
    [anon_sym_co_yield] = ACTIONS(2547),
    [anon_sym_catch] = ACTIONS(3240),
    [anon_sym_R_DQUOTE] = ACTIONS(2549),
    [anon_sym_LR_DQUOTE] = ACTIONS(2549),
    [anon_sym_uR_DQUOTE] = ACTIONS(2549),
    [anon_sym_UR_DQUOTE] = ACTIONS(2549),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2549),
    [anon_sym_co_await] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2547),
    [anon_sym_requires] = ACTIONS(2547),
    [sym_this] = ACTIONS(2547),
  },
  [446] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2597),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [447] = {
    [sym_catch_clause] = STATE(425),
    [aux_sym_constructor_try_statement_repeat1] = STATE(425),
    [sym_identifier] = ACTIONS(2590),
    [aux_sym_preproc_include_token1] = ACTIONS(2590),
    [aux_sym_preproc_def_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token1] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2590),
    [sym_preproc_directive] = ACTIONS(2590),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_TILDE] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym___extension__] = ACTIONS(2590),
    [anon_sym_typedef] = ACTIONS(2590),
    [anon_sym_virtual] = ACTIONS(2590),
    [anon_sym_extern] = ACTIONS(2590),
    [anon_sym___attribute__] = ACTIONS(2590),
    [anon_sym___attribute] = ACTIONS(2590),
    [anon_sym_using] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2592),
    [anon_sym___declspec] = ACTIONS(2590),
    [anon_sym___based] = ACTIONS(2590),
    [anon_sym___cdecl] = ACTIONS(2590),
    [anon_sym___clrcall] = ACTIONS(2590),
    [anon_sym___stdcall] = ACTIONS(2590),
    [anon_sym___fastcall] = ACTIONS(2590),
    [anon_sym___thiscall] = ACTIONS(2590),
    [anon_sym___vectorcall] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_RBRACE] = ACTIONS(2592),
    [anon_sym_signed] = ACTIONS(2590),
    [anon_sym_unsigned] = ACTIONS(2590),
    [anon_sym_long] = ACTIONS(2590),
    [anon_sym_short] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2590),
    [anon_sym_register] = ACTIONS(2590),
    [anon_sym_inline] = ACTIONS(2590),
    [anon_sym___inline] = ACTIONS(2590),
    [anon_sym___inline__] = ACTIONS(2590),
    [anon_sym___forceinline] = ACTIONS(2590),
    [anon_sym_thread_local] = ACTIONS(2590),
    [anon_sym___thread] = ACTIONS(2590),
    [anon_sym_const] = ACTIONS(2590),
    [anon_sym_constexpr] = ACTIONS(2590),
    [anon_sym_volatile] = ACTIONS(2590),
    [anon_sym_restrict] = ACTIONS(2590),
    [anon_sym___restrict__] = ACTIONS(2590),
    [anon_sym__Atomic] = ACTIONS(2590),
    [anon_sym__Noreturn] = ACTIONS(2590),
    [anon_sym_noreturn] = ACTIONS(2590),
    [anon_sym__Nonnull] = ACTIONS(2590),
    [anon_sym_mutable] = ACTIONS(2590),
    [anon_sym_constinit] = ACTIONS(2590),
    [anon_sym_consteval] = ACTIONS(2590),
    [anon_sym_alignas] = ACTIONS(2590),
    [anon_sym__Alignas] = ACTIONS(2590),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_enum] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_struct] = ACTIONS(2590),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_switch] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_default] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_continue] = ACTIONS(2590),
    [anon_sym_goto] = ACTIONS(2590),
    [anon_sym___try] = ACTIONS(2590),
    [anon_sym___leave] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_compl] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2592),
    [anon_sym_sizeof] = ACTIONS(2590),
    [anon_sym___alignof__] = ACTIONS(2590),
    [anon_sym___alignof] = ACTIONS(2590),
    [anon_sym__alignof] = ACTIONS(2590),
    [anon_sym_alignof] = ACTIONS(2590),
    [anon_sym__Alignof] = ACTIONS(2590),
    [anon_sym_offsetof] = ACTIONS(2590),
    [anon_sym__Generic] = ACTIONS(2590),
    [anon_sym_asm] = ACTIONS(2590),
    [anon_sym___asm__] = ACTIONS(2590),
    [anon_sym___asm] = ACTIONS(2590),
    [sym_number_literal] = ACTIONS(2592),
    [anon_sym_L_SQUOTE] = ACTIONS(2592),
    [anon_sym_u_SQUOTE] = ACTIONS(2592),
    [anon_sym_U_SQUOTE] = ACTIONS(2592),
    [anon_sym_u8_SQUOTE] = ACTIONS(2592),
    [anon_sym_SQUOTE] = ACTIONS(2592),
    [anon_sym_L_DQUOTE] = ACTIONS(2592),
    [anon_sym_u_DQUOTE] = ACTIONS(2592),
    [anon_sym_U_DQUOTE] = ACTIONS(2592),
    [anon_sym_u8_DQUOTE] = ACTIONS(2592),
    [anon_sym_DQUOTE] = ACTIONS(2592),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [anon_sym_NULL] = ACTIONS(2590),
    [anon_sym_nullptr] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2590),
    [anon_sym_decltype] = ACTIONS(2590),
    [anon_sym_explicit] = ACTIONS(2590),
    [anon_sym_typename] = ACTIONS(2590),
    [anon_sym_template] = ACTIONS(2590),
    [anon_sym_operator] = ACTIONS(2590),
    [anon_sym_try] = ACTIONS(2590),
    [anon_sym_delete] = ACTIONS(2590),
    [anon_sym_throw] = ACTIONS(2590),
    [anon_sym_namespace] = ACTIONS(2590),
    [anon_sym_static_assert] = ACTIONS(2590),
    [anon_sym_concept] = ACTIONS(2590),
    [anon_sym_co_return] = ACTIONS(2590),
    [anon_sym_co_yield] = ACTIONS(2590),
    [anon_sym_catch] = ACTIONS(3240),
    [anon_sym_R_DQUOTE] = ACTIONS(2592),
    [anon_sym_LR_DQUOTE] = ACTIONS(2592),
    [anon_sym_uR_DQUOTE] = ACTIONS(2592),
    [anon_sym_UR_DQUOTE] = ACTIONS(2592),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2592),
    [anon_sym_co_await] = ACTIONS(2590),
    [anon_sym_new] = ACTIONS(2590),
    [anon_sym_requires] = ACTIONS(2590),
    [sym_this] = ACTIONS(2590),
  },
  [448] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(3347),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [449] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2571),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [450] = {
    [sym_identifier] = ACTIONS(2619),
    [aux_sym_preproc_include_token1] = ACTIONS(2619),
    [aux_sym_preproc_def_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token2] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2619),
    [sym_preproc_directive] = ACTIONS(2619),
    [anon_sym_LPAREN2] = ACTIONS(2621),
    [anon_sym_BANG] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(2619),
    [anon_sym_PLUS] = ACTIONS(2619),
    [anon_sym_STAR] = ACTIONS(2621),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(2619),
    [anon_sym_typedef] = ACTIONS(2619),
    [anon_sym_virtual] = ACTIONS(2619),
    [anon_sym_extern] = ACTIONS(2619),
    [anon_sym___attribute__] = ACTIONS(2619),
    [anon_sym___attribute] = ACTIONS(2619),
    [anon_sym_using] = ACTIONS(2619),
    [anon_sym_COLON_COLON] = ACTIONS(2621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2621),
    [anon_sym___declspec] = ACTIONS(2619),
    [anon_sym___based] = ACTIONS(2619),
    [anon_sym___cdecl] = ACTIONS(2619),
    [anon_sym___clrcall] = ACTIONS(2619),
    [anon_sym___stdcall] = ACTIONS(2619),
    [anon_sym___fastcall] = ACTIONS(2619),
    [anon_sym___thiscall] = ACTIONS(2619),
    [anon_sym___vectorcall] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_signed] = ACTIONS(2619),
    [anon_sym_unsigned] = ACTIONS(2619),
    [anon_sym_long] = ACTIONS(2619),
    [anon_sym_short] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_register] = ACTIONS(2619),
    [anon_sym_inline] = ACTIONS(2619),
    [anon_sym___inline] = ACTIONS(2619),
    [anon_sym___inline__] = ACTIONS(2619),
    [anon_sym___forceinline] = ACTIONS(2619),
    [anon_sym_thread_local] = ACTIONS(2619),
    [anon_sym___thread] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_constexpr] = ACTIONS(2619),
    [anon_sym_volatile] = ACTIONS(2619),
    [anon_sym_restrict] = ACTIONS(2619),
    [anon_sym___restrict__] = ACTIONS(2619),
    [anon_sym__Atomic] = ACTIONS(2619),
    [anon_sym__Noreturn] = ACTIONS(2619),
    [anon_sym_noreturn] = ACTIONS(2619),
    [anon_sym__Nonnull] = ACTIONS(2619),
    [anon_sym_mutable] = ACTIONS(2619),
    [anon_sym_constinit] = ACTIONS(2619),
    [anon_sym_consteval] = ACTIONS(2619),
    [anon_sym_alignas] = ACTIONS(2619),
    [anon_sym__Alignas] = ACTIONS(2619),
    [sym_primitive_type] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_struct] = ACTIONS(2619),
    [anon_sym_union] = ACTIONS(2619),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_else] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2619),
    [anon_sym_case] = ACTIONS(2619),
    [anon_sym_default] = ACTIONS(2619),
    [anon_sym_while] = ACTIONS(2619),
    [anon_sym_do] = ACTIONS(2619),
    [anon_sym_for] = ACTIONS(2619),
    [anon_sym_return] = ACTIONS(2619),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_continue] = ACTIONS(2619),
    [anon_sym_goto] = ACTIONS(2619),
    [anon_sym___try] = ACTIONS(2619),
    [anon_sym___leave] = ACTIONS(2619),
    [anon_sym_not] = ACTIONS(2619),
    [anon_sym_compl] = ACTIONS(2619),
    [anon_sym_DASH_DASH] = ACTIONS(2621),
    [anon_sym_PLUS_PLUS] = ACTIONS(2621),
    [anon_sym_sizeof] = ACTIONS(2619),
    [anon_sym___alignof__] = ACTIONS(2619),
    [anon_sym___alignof] = ACTIONS(2619),
    [anon_sym__alignof] = ACTIONS(2619),
    [anon_sym_alignof] = ACTIONS(2619),
    [anon_sym__Alignof] = ACTIONS(2619),
    [anon_sym_offsetof] = ACTIONS(2619),
    [anon_sym__Generic] = ACTIONS(2619),
    [anon_sym_asm] = ACTIONS(2619),
    [anon_sym___asm__] = ACTIONS(2619),
    [anon_sym___asm] = ACTIONS(2619),
    [sym_number_literal] = ACTIONS(2621),
    [anon_sym_L_SQUOTE] = ACTIONS(2621),
    [anon_sym_u_SQUOTE] = ACTIONS(2621),
    [anon_sym_U_SQUOTE] = ACTIONS(2621),
    [anon_sym_u8_SQUOTE] = ACTIONS(2621),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [anon_sym_L_DQUOTE] = ACTIONS(2621),
    [anon_sym_u_DQUOTE] = ACTIONS(2621),
    [anon_sym_U_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8_DQUOTE] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [sym_true] = ACTIONS(2619),
    [sym_false] = ACTIONS(2619),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2619),
    [anon_sym_decltype] = ACTIONS(2619),
    [anon_sym_explicit] = ACTIONS(2619),
    [anon_sym_typename] = ACTIONS(2619),
    [anon_sym_template] = ACTIONS(2619),
    [anon_sym_operator] = ACTIONS(2619),
    [anon_sym_try] = ACTIONS(2619),
    [anon_sym_delete] = ACTIONS(2619),
    [anon_sym_throw] = ACTIONS(2619),
    [anon_sym_namespace] = ACTIONS(2619),
    [anon_sym_static_assert] = ACTIONS(2619),
    [anon_sym_concept] = ACTIONS(2619),
    [anon_sym_co_return] = ACTIONS(2619),
    [anon_sym_co_yield] = ACTIONS(2619),
    [anon_sym_catch] = ACTIONS(2619),
    [anon_sym_R_DQUOTE] = ACTIONS(2621),
    [anon_sym_LR_DQUOTE] = ACTIONS(2621),
    [anon_sym_uR_DQUOTE] = ACTIONS(2621),
    [anon_sym_UR_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2621),
    [anon_sym_co_await] = ACTIONS(2619),
    [anon_sym_new] = ACTIONS(2619),
    [anon_sym_requires] = ACTIONS(2619),
    [sym_this] = ACTIONS(2619),
  },
  [451] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [452] = {
    [sym_expression] = STATE(3647),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(3352),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(3355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(3358),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [453] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_include_token1] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token2] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym___cdecl] = ACTIONS(1940),
    [anon_sym___clrcall] = ACTIONS(1940),
    [anon_sym___stdcall] = ACTIONS(1940),
    [anon_sym___fastcall] = ACTIONS(1940),
    [anon_sym___thiscall] = ACTIONS(1940),
    [anon_sym___vectorcall] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_else] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1940),
    [anon_sym___try] = ACTIONS(1940),
    [anon_sym___leave] = ACTIONS(1940),
    [anon_sym_not] = ACTIONS(1940),
    [anon_sym_compl] = ACTIONS(1940),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_sizeof] = ACTIONS(1940),
    [anon_sym___alignof__] = ACTIONS(1940),
    [anon_sym___alignof] = ACTIONS(1940),
    [anon_sym__alignof] = ACTIONS(1940),
    [anon_sym_alignof] = ACTIONS(1940),
    [anon_sym__Alignof] = ACTIONS(1940),
    [anon_sym_offsetof] = ACTIONS(1940),
    [anon_sym__Generic] = ACTIONS(1940),
    [anon_sym_asm] = ACTIONS(1940),
    [anon_sym___asm__] = ACTIONS(1940),
    [anon_sym___asm] = ACTIONS(1940),
    [sym_number_literal] = ACTIONS(1938),
    [anon_sym_L_SQUOTE] = ACTIONS(1938),
    [anon_sym_u_SQUOTE] = ACTIONS(1938),
    [anon_sym_U_SQUOTE] = ACTIONS(1938),
    [anon_sym_u8_SQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_L_DQUOTE] = ACTIONS(1938),
    [anon_sym_u_DQUOTE] = ACTIONS(1938),
    [anon_sym_U_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8_DQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [anon_sym_NULL] = ACTIONS(1940),
    [anon_sym_nullptr] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_concept] = ACTIONS(1940),
    [anon_sym_co_return] = ACTIONS(1940),
    [anon_sym_co_yield] = ACTIONS(1940),
    [anon_sym_catch] = ACTIONS(1940),
    [anon_sym_R_DQUOTE] = ACTIONS(1938),
    [anon_sym_LR_DQUOTE] = ACTIONS(1938),
    [anon_sym_uR_DQUOTE] = ACTIONS(1938),
    [anon_sym_UR_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1938),
    [anon_sym_co_await] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_requires] = ACTIONS(1940),
    [sym_this] = ACTIONS(1940),
  },
  [454] = {
    [sym_identifier] = ACTIONS(1936),
    [aux_sym_preproc_include_token1] = ACTIONS(1936),
    [aux_sym_preproc_def_token1] = ACTIONS(1936),
    [aux_sym_preproc_if_token1] = ACTIONS(1936),
    [aux_sym_preproc_if_token2] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1936),
    [sym_preproc_directive] = ACTIONS(1936),
    [anon_sym_LPAREN2] = ACTIONS(1934),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_DASH] = ACTIONS(1936),
    [anon_sym_PLUS] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(1934),
    [anon_sym_AMP_AMP] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym___extension__] = ACTIONS(1936),
    [anon_sym_typedef] = ACTIONS(1936),
    [anon_sym_virtual] = ACTIONS(1936),
    [anon_sym_extern] = ACTIONS(1936),
    [anon_sym___attribute__] = ACTIONS(1936),
    [anon_sym___attribute] = ACTIONS(1936),
    [anon_sym_using] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1934),
    [anon_sym___declspec] = ACTIONS(1936),
    [anon_sym___based] = ACTIONS(1936),
    [anon_sym___cdecl] = ACTIONS(1936),
    [anon_sym___clrcall] = ACTIONS(1936),
    [anon_sym___stdcall] = ACTIONS(1936),
    [anon_sym___fastcall] = ACTIONS(1936),
    [anon_sym___thiscall] = ACTIONS(1936),
    [anon_sym___vectorcall] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_signed] = ACTIONS(1936),
    [anon_sym_unsigned] = ACTIONS(1936),
    [anon_sym_long] = ACTIONS(1936),
    [anon_sym_short] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_register] = ACTIONS(1936),
    [anon_sym_inline] = ACTIONS(1936),
    [anon_sym___inline] = ACTIONS(1936),
    [anon_sym___inline__] = ACTIONS(1936),
    [anon_sym___forceinline] = ACTIONS(1936),
    [anon_sym_thread_local] = ACTIONS(1936),
    [anon_sym___thread] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_constexpr] = ACTIONS(1936),
    [anon_sym_volatile] = ACTIONS(1936),
    [anon_sym_restrict] = ACTIONS(1936),
    [anon_sym___restrict__] = ACTIONS(1936),
    [anon_sym__Atomic] = ACTIONS(1936),
    [anon_sym__Noreturn] = ACTIONS(1936),
    [anon_sym_noreturn] = ACTIONS(1936),
    [anon_sym__Nonnull] = ACTIONS(1936),
    [anon_sym_mutable] = ACTIONS(1936),
    [anon_sym_constinit] = ACTIONS(1936),
    [anon_sym_consteval] = ACTIONS(1936),
    [anon_sym_alignas] = ACTIONS(1936),
    [anon_sym__Alignas] = ACTIONS(1936),
    [sym_primitive_type] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_struct] = ACTIONS(1936),
    [anon_sym_union] = ACTIONS(1936),
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(1936),
    [anon_sym_switch] = ACTIONS(1936),
    [anon_sym_case] = ACTIONS(1936),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_while] = ACTIONS(1936),
    [anon_sym_do] = ACTIONS(1936),
    [anon_sym_for] = ACTIONS(1936),
    [anon_sym_return] = ACTIONS(1936),
    [anon_sym_break] = ACTIONS(1936),
    [anon_sym_continue] = ACTIONS(1936),
    [anon_sym_goto] = ACTIONS(1936),
    [anon_sym___try] = ACTIONS(1936),
    [anon_sym___leave] = ACTIONS(1936),
    [anon_sym_not] = ACTIONS(1936),
    [anon_sym_compl] = ACTIONS(1936),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_sizeof] = ACTIONS(1936),
    [anon_sym___alignof__] = ACTIONS(1936),
    [anon_sym___alignof] = ACTIONS(1936),
    [anon_sym__alignof] = ACTIONS(1936),
    [anon_sym_alignof] = ACTIONS(1936),
    [anon_sym__Alignof] = ACTIONS(1936),
    [anon_sym_offsetof] = ACTIONS(1936),
    [anon_sym__Generic] = ACTIONS(1936),
    [anon_sym_asm] = ACTIONS(1936),
    [anon_sym___asm__] = ACTIONS(1936),
    [anon_sym___asm] = ACTIONS(1936),
    [sym_number_literal] = ACTIONS(1934),
    [anon_sym_L_SQUOTE] = ACTIONS(1934),
    [anon_sym_u_SQUOTE] = ACTIONS(1934),
    [anon_sym_U_SQUOTE] = ACTIONS(1934),
    [anon_sym_u8_SQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [anon_sym_L_DQUOTE] = ACTIONS(1934),
    [anon_sym_u_DQUOTE] = ACTIONS(1934),
    [anon_sym_U_DQUOTE] = ACTIONS(1934),
    [anon_sym_u8_DQUOTE] = ACTIONS(1934),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [anon_sym_NULL] = ACTIONS(1936),
    [anon_sym_nullptr] = ACTIONS(1936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1936),
    [anon_sym_decltype] = ACTIONS(1936),
    [anon_sym_explicit] = ACTIONS(1936),
    [anon_sym_typename] = ACTIONS(1936),
    [anon_sym_template] = ACTIONS(1936),
    [anon_sym_operator] = ACTIONS(1936),
    [anon_sym_try] = ACTIONS(1936),
    [anon_sym_delete] = ACTIONS(1936),
    [anon_sym_throw] = ACTIONS(1936),
    [anon_sym_namespace] = ACTIONS(1936),
    [anon_sym_static_assert] = ACTIONS(1936),
    [anon_sym_concept] = ACTIONS(1936),
    [anon_sym_co_return] = ACTIONS(1936),
    [anon_sym_co_yield] = ACTIONS(1936),
    [anon_sym_catch] = ACTIONS(1936),
    [anon_sym_R_DQUOTE] = ACTIONS(1934),
    [anon_sym_LR_DQUOTE] = ACTIONS(1934),
    [anon_sym_uR_DQUOTE] = ACTIONS(1934),
    [anon_sym_UR_DQUOTE] = ACTIONS(1934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1934),
    [anon_sym_co_await] = ACTIONS(1936),
    [anon_sym_new] = ACTIONS(1936),
    [anon_sym_requires] = ACTIONS(1936),
    [sym_this] = ACTIONS(1936),
  },
  [455] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_include_token1] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym___cdecl] = ACTIONS(1940),
    [anon_sym___clrcall] = ACTIONS(1940),
    [anon_sym___stdcall] = ACTIONS(1940),
    [anon_sym___fastcall] = ACTIONS(1940),
    [anon_sym___thiscall] = ACTIONS(1940),
    [anon_sym___vectorcall] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_RBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_else] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1940),
    [anon_sym___try] = ACTIONS(1940),
    [anon_sym___leave] = ACTIONS(1940),
    [anon_sym_not] = ACTIONS(1940),
    [anon_sym_compl] = ACTIONS(1940),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_sizeof] = ACTIONS(1940),
    [anon_sym___alignof__] = ACTIONS(1940),
    [anon_sym___alignof] = ACTIONS(1940),
    [anon_sym__alignof] = ACTIONS(1940),
    [anon_sym_alignof] = ACTIONS(1940),
    [anon_sym__Alignof] = ACTIONS(1940),
    [anon_sym_offsetof] = ACTIONS(1940),
    [anon_sym__Generic] = ACTIONS(1940),
    [anon_sym_asm] = ACTIONS(1940),
    [anon_sym___asm__] = ACTIONS(1940),
    [anon_sym___asm] = ACTIONS(1940),
    [sym_number_literal] = ACTIONS(1938),
    [anon_sym_L_SQUOTE] = ACTIONS(1938),
    [anon_sym_u_SQUOTE] = ACTIONS(1938),
    [anon_sym_U_SQUOTE] = ACTIONS(1938),
    [anon_sym_u8_SQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_L_DQUOTE] = ACTIONS(1938),
    [anon_sym_u_DQUOTE] = ACTIONS(1938),
    [anon_sym_U_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8_DQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [anon_sym_NULL] = ACTIONS(1940),
    [anon_sym_nullptr] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_concept] = ACTIONS(1940),
    [anon_sym_co_return] = ACTIONS(1940),
    [anon_sym_co_yield] = ACTIONS(1940),
    [anon_sym_catch] = ACTIONS(1940),
    [anon_sym_R_DQUOTE] = ACTIONS(1938),
    [anon_sym_LR_DQUOTE] = ACTIONS(1938),
    [anon_sym_uR_DQUOTE] = ACTIONS(1938),
    [anon_sym_UR_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1938),
    [anon_sym_co_await] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_requires] = ACTIONS(1940),
    [sym_this] = ACTIONS(1940),
  },
  [456] = {
    [sym_else_clause] = STATE(596),
    [sym_identifier] = ACTIONS(2623),
    [aux_sym_preproc_include_token1] = ACTIONS(2623),
    [aux_sym_preproc_def_token1] = ACTIONS(2623),
    [aux_sym_preproc_if_token1] = ACTIONS(2623),
    [aux_sym_preproc_if_token2] = ACTIONS(2623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2623),
    [sym_preproc_directive] = ACTIONS(2623),
    [anon_sym_LPAREN2] = ACTIONS(2625),
    [anon_sym_BANG] = ACTIONS(2625),
    [anon_sym_TILDE] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_AMP_AMP] = ACTIONS(2625),
    [anon_sym_AMP] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2625),
    [anon_sym___extension__] = ACTIONS(2623),
    [anon_sym_typedef] = ACTIONS(2623),
    [anon_sym_virtual] = ACTIONS(2623),
    [anon_sym_extern] = ACTIONS(2623),
    [anon_sym___attribute__] = ACTIONS(2623),
    [anon_sym___attribute] = ACTIONS(2623),
    [anon_sym_using] = ACTIONS(2623),
    [anon_sym_COLON_COLON] = ACTIONS(2625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2625),
    [anon_sym___declspec] = ACTIONS(2623),
    [anon_sym___based] = ACTIONS(2623),
    [anon_sym___cdecl] = ACTIONS(2623),
    [anon_sym___clrcall] = ACTIONS(2623),
    [anon_sym___stdcall] = ACTIONS(2623),
    [anon_sym___fastcall] = ACTIONS(2623),
    [anon_sym___thiscall] = ACTIONS(2623),
    [anon_sym___vectorcall] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2625),
    [anon_sym_signed] = ACTIONS(2623),
    [anon_sym_unsigned] = ACTIONS(2623),
    [anon_sym_long] = ACTIONS(2623),
    [anon_sym_short] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_static] = ACTIONS(2623),
    [anon_sym_register] = ACTIONS(2623),
    [anon_sym_inline] = ACTIONS(2623),
    [anon_sym___inline] = ACTIONS(2623),
    [anon_sym___inline__] = ACTIONS(2623),
    [anon_sym___forceinline] = ACTIONS(2623),
    [anon_sym_thread_local] = ACTIONS(2623),
    [anon_sym___thread] = ACTIONS(2623),
    [anon_sym_const] = ACTIONS(2623),
    [anon_sym_constexpr] = ACTIONS(2623),
    [anon_sym_volatile] = ACTIONS(2623),
    [anon_sym_restrict] = ACTIONS(2623),
    [anon_sym___restrict__] = ACTIONS(2623),
    [anon_sym__Atomic] = ACTIONS(2623),
    [anon_sym__Noreturn] = ACTIONS(2623),
    [anon_sym_noreturn] = ACTIONS(2623),
    [anon_sym__Nonnull] = ACTIONS(2623),
    [anon_sym_mutable] = ACTIONS(2623),
    [anon_sym_constinit] = ACTIONS(2623),
    [anon_sym_consteval] = ACTIONS(2623),
    [anon_sym_alignas] = ACTIONS(2623),
    [anon_sym__Alignas] = ACTIONS(2623),
    [sym_primitive_type] = ACTIONS(2623),
    [anon_sym_enum] = ACTIONS(2623),
    [anon_sym_class] = ACTIONS(2623),
    [anon_sym_struct] = ACTIONS(2623),
    [anon_sym_union] = ACTIONS(2623),
    [anon_sym_if] = ACTIONS(2623),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(2623),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2623),
    [anon_sym_while] = ACTIONS(2623),
    [anon_sym_do] = ACTIONS(2623),
    [anon_sym_for] = ACTIONS(2623),
    [anon_sym_return] = ACTIONS(2623),
    [anon_sym_break] = ACTIONS(2623),
    [anon_sym_continue] = ACTIONS(2623),
    [anon_sym_goto] = ACTIONS(2623),
    [anon_sym___try] = ACTIONS(2623),
    [anon_sym___leave] = ACTIONS(2623),
    [anon_sym_not] = ACTIONS(2623),
    [anon_sym_compl] = ACTIONS(2623),
    [anon_sym_DASH_DASH] = ACTIONS(2625),
    [anon_sym_PLUS_PLUS] = ACTIONS(2625),
    [anon_sym_sizeof] = ACTIONS(2623),
    [anon_sym___alignof__] = ACTIONS(2623),
    [anon_sym___alignof] = ACTIONS(2623),
    [anon_sym__alignof] = ACTIONS(2623),
    [anon_sym_alignof] = ACTIONS(2623),
    [anon_sym__Alignof] = ACTIONS(2623),
    [anon_sym_offsetof] = ACTIONS(2623),
    [anon_sym__Generic] = ACTIONS(2623),
    [anon_sym_asm] = ACTIONS(2623),
    [anon_sym___asm__] = ACTIONS(2623),
    [anon_sym___asm] = ACTIONS(2623),
    [sym_number_literal] = ACTIONS(2625),
    [anon_sym_L_SQUOTE] = ACTIONS(2625),
    [anon_sym_u_SQUOTE] = ACTIONS(2625),
    [anon_sym_U_SQUOTE] = ACTIONS(2625),
    [anon_sym_u8_SQUOTE] = ACTIONS(2625),
    [anon_sym_SQUOTE] = ACTIONS(2625),
    [anon_sym_L_DQUOTE] = ACTIONS(2625),
    [anon_sym_u_DQUOTE] = ACTIONS(2625),
    [anon_sym_U_DQUOTE] = ACTIONS(2625),
    [anon_sym_u8_DQUOTE] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(2625),
    [sym_true] = ACTIONS(2623),
    [sym_false] = ACTIONS(2623),
    [anon_sym_NULL] = ACTIONS(2623),
    [anon_sym_nullptr] = ACTIONS(2623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2623),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_explicit] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2623),
    [anon_sym_template] = ACTIONS(2623),
    [anon_sym_operator] = ACTIONS(2623),
    [anon_sym_try] = ACTIONS(2623),
    [anon_sym_delete] = ACTIONS(2623),
    [anon_sym_throw] = ACTIONS(2623),
    [anon_sym_namespace] = ACTIONS(2623),
    [anon_sym_static_assert] = ACTIONS(2623),
    [anon_sym_concept] = ACTIONS(2623),
    [anon_sym_co_return] = ACTIONS(2623),
    [anon_sym_co_yield] = ACTIONS(2623),
    [anon_sym_R_DQUOTE] = ACTIONS(2625),
    [anon_sym_LR_DQUOTE] = ACTIONS(2625),
    [anon_sym_uR_DQUOTE] = ACTIONS(2625),
    [anon_sym_UR_DQUOTE] = ACTIONS(2625),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2625),
    [anon_sym_co_await] = ACTIONS(2623),
    [anon_sym_new] = ACTIONS(2623),
    [anon_sym_requires] = ACTIONS(2623),
    [sym_this] = ACTIONS(2623),
  },
  [457] = {
    [sym_identifier] = ACTIONS(1936),
    [aux_sym_preproc_include_token1] = ACTIONS(1936),
    [aux_sym_preproc_def_token1] = ACTIONS(1936),
    [aux_sym_preproc_if_token1] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1936),
    [sym_preproc_directive] = ACTIONS(1936),
    [anon_sym_LPAREN2] = ACTIONS(1934),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_DASH] = ACTIONS(1936),
    [anon_sym_PLUS] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(1934),
    [anon_sym_AMP_AMP] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym___extension__] = ACTIONS(1936),
    [anon_sym_typedef] = ACTIONS(1936),
    [anon_sym_virtual] = ACTIONS(1936),
    [anon_sym_extern] = ACTIONS(1936),
    [anon_sym___attribute__] = ACTIONS(1936),
    [anon_sym___attribute] = ACTIONS(1936),
    [anon_sym_using] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1934),
    [anon_sym___declspec] = ACTIONS(1936),
    [anon_sym___based] = ACTIONS(1936),
    [anon_sym___cdecl] = ACTIONS(1936),
    [anon_sym___clrcall] = ACTIONS(1936),
    [anon_sym___stdcall] = ACTIONS(1936),
    [anon_sym___fastcall] = ACTIONS(1936),
    [anon_sym___thiscall] = ACTIONS(1936),
    [anon_sym___vectorcall] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_RBRACE] = ACTIONS(1934),
    [anon_sym_signed] = ACTIONS(1936),
    [anon_sym_unsigned] = ACTIONS(1936),
    [anon_sym_long] = ACTIONS(1936),
    [anon_sym_short] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_register] = ACTIONS(1936),
    [anon_sym_inline] = ACTIONS(1936),
    [anon_sym___inline] = ACTIONS(1936),
    [anon_sym___inline__] = ACTIONS(1936),
    [anon_sym___forceinline] = ACTIONS(1936),
    [anon_sym_thread_local] = ACTIONS(1936),
    [anon_sym___thread] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_constexpr] = ACTIONS(1936),
    [anon_sym_volatile] = ACTIONS(1936),
    [anon_sym_restrict] = ACTIONS(1936),
    [anon_sym___restrict__] = ACTIONS(1936),
    [anon_sym__Atomic] = ACTIONS(1936),
    [anon_sym__Noreturn] = ACTIONS(1936),
    [anon_sym_noreturn] = ACTIONS(1936),
    [anon_sym__Nonnull] = ACTIONS(1936),
    [anon_sym_mutable] = ACTIONS(1936),
    [anon_sym_constinit] = ACTIONS(1936),
    [anon_sym_consteval] = ACTIONS(1936),
    [anon_sym_alignas] = ACTIONS(1936),
    [anon_sym__Alignas] = ACTIONS(1936),
    [sym_primitive_type] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_struct] = ACTIONS(1936),
    [anon_sym_union] = ACTIONS(1936),
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(1936),
    [anon_sym_switch] = ACTIONS(1936),
    [anon_sym_case] = ACTIONS(1936),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_while] = ACTIONS(1936),
    [anon_sym_do] = ACTIONS(1936),
    [anon_sym_for] = ACTIONS(1936),
    [anon_sym_return] = ACTIONS(1936),
    [anon_sym_break] = ACTIONS(1936),
    [anon_sym_continue] = ACTIONS(1936),
    [anon_sym_goto] = ACTIONS(1936),
    [anon_sym___try] = ACTIONS(1936),
    [anon_sym___leave] = ACTIONS(1936),
    [anon_sym_not] = ACTIONS(1936),
    [anon_sym_compl] = ACTIONS(1936),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_sizeof] = ACTIONS(1936),
    [anon_sym___alignof__] = ACTIONS(1936),
    [anon_sym___alignof] = ACTIONS(1936),
    [anon_sym__alignof] = ACTIONS(1936),
    [anon_sym_alignof] = ACTIONS(1936),
    [anon_sym__Alignof] = ACTIONS(1936),
    [anon_sym_offsetof] = ACTIONS(1936),
    [anon_sym__Generic] = ACTIONS(1936),
    [anon_sym_asm] = ACTIONS(1936),
    [anon_sym___asm__] = ACTIONS(1936),
    [anon_sym___asm] = ACTIONS(1936),
    [sym_number_literal] = ACTIONS(1934),
    [anon_sym_L_SQUOTE] = ACTIONS(1934),
    [anon_sym_u_SQUOTE] = ACTIONS(1934),
    [anon_sym_U_SQUOTE] = ACTIONS(1934),
    [anon_sym_u8_SQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [anon_sym_L_DQUOTE] = ACTIONS(1934),
    [anon_sym_u_DQUOTE] = ACTIONS(1934),
    [anon_sym_U_DQUOTE] = ACTIONS(1934),
    [anon_sym_u8_DQUOTE] = ACTIONS(1934),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [anon_sym_NULL] = ACTIONS(1936),
    [anon_sym_nullptr] = ACTIONS(1936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1936),
    [anon_sym_decltype] = ACTIONS(1936),
    [anon_sym_explicit] = ACTIONS(1936),
    [anon_sym_typename] = ACTIONS(1936),
    [anon_sym_template] = ACTIONS(1936),
    [anon_sym_operator] = ACTIONS(1936),
    [anon_sym_try] = ACTIONS(1936),
    [anon_sym_delete] = ACTIONS(1936),
    [anon_sym_throw] = ACTIONS(1936),
    [anon_sym_namespace] = ACTIONS(1936),
    [anon_sym_static_assert] = ACTIONS(1936),
    [anon_sym_concept] = ACTIONS(1936),
    [anon_sym_co_return] = ACTIONS(1936),
    [anon_sym_co_yield] = ACTIONS(1936),
    [anon_sym_catch] = ACTIONS(1936),
    [anon_sym_R_DQUOTE] = ACTIONS(1934),
    [anon_sym_LR_DQUOTE] = ACTIONS(1934),
    [anon_sym_uR_DQUOTE] = ACTIONS(1934),
    [anon_sym_UR_DQUOTE] = ACTIONS(1934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1934),
    [anon_sym_co_await] = ACTIONS(1936),
    [anon_sym_new] = ACTIONS(1936),
    [anon_sym_requires] = ACTIONS(1936),
    [sym_this] = ACTIONS(1936),
  },
  [458] = {
    [sym_else_clause] = STATE(591),
    [sym_identifier] = ACTIONS(2623),
    [aux_sym_preproc_include_token1] = ACTIONS(2623),
    [aux_sym_preproc_def_token1] = ACTIONS(2623),
    [aux_sym_preproc_if_token1] = ACTIONS(2623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2623),
    [sym_preproc_directive] = ACTIONS(2623),
    [anon_sym_LPAREN2] = ACTIONS(2625),
    [anon_sym_BANG] = ACTIONS(2625),
    [anon_sym_TILDE] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_AMP_AMP] = ACTIONS(2625),
    [anon_sym_AMP] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2625),
    [anon_sym___extension__] = ACTIONS(2623),
    [anon_sym_typedef] = ACTIONS(2623),
    [anon_sym_virtual] = ACTIONS(2623),
    [anon_sym_extern] = ACTIONS(2623),
    [anon_sym___attribute__] = ACTIONS(2623),
    [anon_sym___attribute] = ACTIONS(2623),
    [anon_sym_using] = ACTIONS(2623),
    [anon_sym_COLON_COLON] = ACTIONS(2625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2625),
    [anon_sym___declspec] = ACTIONS(2623),
    [anon_sym___based] = ACTIONS(2623),
    [anon_sym___cdecl] = ACTIONS(2623),
    [anon_sym___clrcall] = ACTIONS(2623),
    [anon_sym___stdcall] = ACTIONS(2623),
    [anon_sym___fastcall] = ACTIONS(2623),
    [anon_sym___thiscall] = ACTIONS(2623),
    [anon_sym___vectorcall] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2625),
    [anon_sym_RBRACE] = ACTIONS(2625),
    [anon_sym_signed] = ACTIONS(2623),
    [anon_sym_unsigned] = ACTIONS(2623),
    [anon_sym_long] = ACTIONS(2623),
    [anon_sym_short] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_static] = ACTIONS(2623),
    [anon_sym_register] = ACTIONS(2623),
    [anon_sym_inline] = ACTIONS(2623),
    [anon_sym___inline] = ACTIONS(2623),
    [anon_sym___inline__] = ACTIONS(2623),
    [anon_sym___forceinline] = ACTIONS(2623),
    [anon_sym_thread_local] = ACTIONS(2623),
    [anon_sym___thread] = ACTIONS(2623),
    [anon_sym_const] = ACTIONS(2623),
    [anon_sym_constexpr] = ACTIONS(2623),
    [anon_sym_volatile] = ACTIONS(2623),
    [anon_sym_restrict] = ACTIONS(2623),
    [anon_sym___restrict__] = ACTIONS(2623),
    [anon_sym__Atomic] = ACTIONS(2623),
    [anon_sym__Noreturn] = ACTIONS(2623),
    [anon_sym_noreturn] = ACTIONS(2623),
    [anon_sym__Nonnull] = ACTIONS(2623),
    [anon_sym_mutable] = ACTIONS(2623),
    [anon_sym_constinit] = ACTIONS(2623),
    [anon_sym_consteval] = ACTIONS(2623),
    [anon_sym_alignas] = ACTIONS(2623),
    [anon_sym__Alignas] = ACTIONS(2623),
    [sym_primitive_type] = ACTIONS(2623),
    [anon_sym_enum] = ACTIONS(2623),
    [anon_sym_class] = ACTIONS(2623),
    [anon_sym_struct] = ACTIONS(2623),
    [anon_sym_union] = ACTIONS(2623),
    [anon_sym_if] = ACTIONS(2623),
    [anon_sym_else] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(2623),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2623),
    [anon_sym_while] = ACTIONS(2623),
    [anon_sym_do] = ACTIONS(2623),
    [anon_sym_for] = ACTIONS(2623),
    [anon_sym_return] = ACTIONS(2623),
    [anon_sym_break] = ACTIONS(2623),
    [anon_sym_continue] = ACTIONS(2623),
    [anon_sym_goto] = ACTIONS(2623),
    [anon_sym___try] = ACTIONS(2623),
    [anon_sym___leave] = ACTIONS(2623),
    [anon_sym_not] = ACTIONS(2623),
    [anon_sym_compl] = ACTIONS(2623),
    [anon_sym_DASH_DASH] = ACTIONS(2625),
    [anon_sym_PLUS_PLUS] = ACTIONS(2625),
    [anon_sym_sizeof] = ACTIONS(2623),
    [anon_sym___alignof__] = ACTIONS(2623),
    [anon_sym___alignof] = ACTIONS(2623),
    [anon_sym__alignof] = ACTIONS(2623),
    [anon_sym_alignof] = ACTIONS(2623),
    [anon_sym__Alignof] = ACTIONS(2623),
    [anon_sym_offsetof] = ACTIONS(2623),
    [anon_sym__Generic] = ACTIONS(2623),
    [anon_sym_asm] = ACTIONS(2623),
    [anon_sym___asm__] = ACTIONS(2623),
    [anon_sym___asm] = ACTIONS(2623),
    [sym_number_literal] = ACTIONS(2625),
    [anon_sym_L_SQUOTE] = ACTIONS(2625),
    [anon_sym_u_SQUOTE] = ACTIONS(2625),
    [anon_sym_U_SQUOTE] = ACTIONS(2625),
    [anon_sym_u8_SQUOTE] = ACTIONS(2625),
    [anon_sym_SQUOTE] = ACTIONS(2625),
    [anon_sym_L_DQUOTE] = ACTIONS(2625),
    [anon_sym_u_DQUOTE] = ACTIONS(2625),
    [anon_sym_U_DQUOTE] = ACTIONS(2625),
    [anon_sym_u8_DQUOTE] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(2625),
    [sym_true] = ACTIONS(2623),
    [sym_false] = ACTIONS(2623),
    [anon_sym_NULL] = ACTIONS(2623),
    [anon_sym_nullptr] = ACTIONS(2623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2623),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_explicit] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2623),
    [anon_sym_template] = ACTIONS(2623),
    [anon_sym_operator] = ACTIONS(2623),
    [anon_sym_try] = ACTIONS(2623),
    [anon_sym_delete] = ACTIONS(2623),
    [anon_sym_throw] = ACTIONS(2623),
    [anon_sym_namespace] = ACTIONS(2623),
    [anon_sym_static_assert] = ACTIONS(2623),
    [anon_sym_concept] = ACTIONS(2623),
    [anon_sym_co_return] = ACTIONS(2623),
    [anon_sym_co_yield] = ACTIONS(2623),
    [anon_sym_R_DQUOTE] = ACTIONS(2625),
    [anon_sym_LR_DQUOTE] = ACTIONS(2625),
    [anon_sym_uR_DQUOTE] = ACTIONS(2625),
    [anon_sym_UR_DQUOTE] = ACTIONS(2625),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2625),
    [anon_sym_co_await] = ACTIONS(2623),
    [anon_sym_new] = ACTIONS(2623),
    [anon_sym_requires] = ACTIONS(2623),
    [sym_this] = ACTIONS(2623),
  },
  [459] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4591),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(8741),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [460] = {
    [sym_else_clause] = STATE(613),
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_include_token1] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym___cdecl] = ACTIONS(2613),
    [anon_sym___clrcall] = ACTIONS(2613),
    [anon_sym___stdcall] = ACTIONS(2613),
    [anon_sym___fastcall] = ACTIONS(2613),
    [anon_sym___thiscall] = ACTIONS(2613),
    [anon_sym___vectorcall] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_RBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_case] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_goto] = ACTIONS(2613),
    [anon_sym___try] = ACTIONS(2613),
    [anon_sym___leave] = ACTIONS(2613),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_compl] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2615),
    [anon_sym_sizeof] = ACTIONS(2613),
    [anon_sym___alignof__] = ACTIONS(2613),
    [anon_sym___alignof] = ACTIONS(2613),
    [anon_sym__alignof] = ACTIONS(2613),
    [anon_sym_alignof] = ACTIONS(2613),
    [anon_sym__Alignof] = ACTIONS(2613),
    [anon_sym_offsetof] = ACTIONS(2613),
    [anon_sym__Generic] = ACTIONS(2613),
    [anon_sym_asm] = ACTIONS(2613),
    [anon_sym___asm__] = ACTIONS(2613),
    [anon_sym___asm] = ACTIONS(2613),
    [sym_number_literal] = ACTIONS(2615),
    [anon_sym_L_SQUOTE] = ACTIONS(2615),
    [anon_sym_u_SQUOTE] = ACTIONS(2615),
    [anon_sym_U_SQUOTE] = ACTIONS(2615),
    [anon_sym_u8_SQUOTE] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2615),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [anon_sym_NULL] = ACTIONS(2613),
    [anon_sym_nullptr] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_namespace] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
    [anon_sym_concept] = ACTIONS(2613),
    [anon_sym_co_return] = ACTIONS(2613),
    [anon_sym_co_yield] = ACTIONS(2613),
    [anon_sym_R_DQUOTE] = ACTIONS(2615),
    [anon_sym_LR_DQUOTE] = ACTIONS(2615),
    [anon_sym_uR_DQUOTE] = ACTIONS(2615),
    [anon_sym_UR_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2615),
    [anon_sym_co_await] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_requires] = ACTIONS(2613),
    [sym_this] = ACTIONS(2613),
  },
  [461] = {
    [sym_else_clause] = STATE(610),
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_include_token1] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token2] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym___cdecl] = ACTIONS(2613),
    [anon_sym___clrcall] = ACTIONS(2613),
    [anon_sym___stdcall] = ACTIONS(2613),
    [anon_sym___fastcall] = ACTIONS(2613),
    [anon_sym___thiscall] = ACTIONS(2613),
    [anon_sym___vectorcall] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_case] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_goto] = ACTIONS(2613),
    [anon_sym___try] = ACTIONS(2613),
    [anon_sym___leave] = ACTIONS(2613),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_compl] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2615),
    [anon_sym_sizeof] = ACTIONS(2613),
    [anon_sym___alignof__] = ACTIONS(2613),
    [anon_sym___alignof] = ACTIONS(2613),
    [anon_sym__alignof] = ACTIONS(2613),
    [anon_sym_alignof] = ACTIONS(2613),
    [anon_sym__Alignof] = ACTIONS(2613),
    [anon_sym_offsetof] = ACTIONS(2613),
    [anon_sym__Generic] = ACTIONS(2613),
    [anon_sym_asm] = ACTIONS(2613),
    [anon_sym___asm__] = ACTIONS(2613),
    [anon_sym___asm] = ACTIONS(2613),
    [sym_number_literal] = ACTIONS(2615),
    [anon_sym_L_SQUOTE] = ACTIONS(2615),
    [anon_sym_u_SQUOTE] = ACTIONS(2615),
    [anon_sym_U_SQUOTE] = ACTIONS(2615),
    [anon_sym_u8_SQUOTE] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2615),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [anon_sym_NULL] = ACTIONS(2613),
    [anon_sym_nullptr] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_namespace] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
    [anon_sym_concept] = ACTIONS(2613),
    [anon_sym_co_return] = ACTIONS(2613),
    [anon_sym_co_yield] = ACTIONS(2613),
    [anon_sym_R_DQUOTE] = ACTIONS(2615),
    [anon_sym_LR_DQUOTE] = ACTIONS(2615),
    [anon_sym_uR_DQUOTE] = ACTIONS(2615),
    [anon_sym_UR_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2615),
    [anon_sym_co_await] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_requires] = ACTIONS(2613),
    [sym_this] = ACTIONS(2613),
  },
  [462] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4609),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(8718),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [463] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4759),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(7942),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [464] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4656),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(8124),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [465] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(7946),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [466] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4648),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(7973),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [467] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4697),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(8364),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [468] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4740),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(8668),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [469] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4755),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(8103),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [470] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4585),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(8497),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [471] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4589),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(8014),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [472] = {
    [sym_type_qualifier] = STATE(3904),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4455),
    [sym_sized_type_specifier] = STATE(1879),
    [sym_enum_specifier] = STATE(1879),
    [sym_struct_specifier] = STATE(1879),
    [sym_union_specifier] = STATE(1879),
    [sym_expression] = STATE(4592),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_type_descriptor] = STATE(8328),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_placeholder_type_specifier] = STATE(1879),
    [sym_decltype_auto] = STATE(1859),
    [sym_decltype] = STATE(1713),
    [sym_class_specifier] = STATE(1879),
    [sym__class_name] = STATE(7608),
    [sym_dependent_type] = STATE(1879),
    [sym_template_type] = STATE(5285),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5676),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(5327),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym__type_definition_type_repeat1] = STATE(3904),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4209),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1822),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1846),
    [anon_sym_decltype] = ACTIONS(1848),
    [anon_sym_typename] = ACTIONS(1850),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [473] = {
    [sym_identifier] = ACTIONS(2619),
    [aux_sym_preproc_include_token1] = ACTIONS(2619),
    [aux_sym_preproc_def_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token1] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2619),
    [sym_preproc_directive] = ACTIONS(2619),
    [anon_sym_LPAREN2] = ACTIONS(2621),
    [anon_sym_BANG] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(2619),
    [anon_sym_PLUS] = ACTIONS(2619),
    [anon_sym_STAR] = ACTIONS(2621),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(2619),
    [anon_sym_typedef] = ACTIONS(2619),
    [anon_sym_virtual] = ACTIONS(2619),
    [anon_sym_extern] = ACTIONS(2619),
    [anon_sym___attribute__] = ACTIONS(2619),
    [anon_sym___attribute] = ACTIONS(2619),
    [anon_sym_using] = ACTIONS(2619),
    [anon_sym_COLON_COLON] = ACTIONS(2621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2621),
    [anon_sym___declspec] = ACTIONS(2619),
    [anon_sym___based] = ACTIONS(2619),
    [anon_sym___cdecl] = ACTIONS(2619),
    [anon_sym___clrcall] = ACTIONS(2619),
    [anon_sym___stdcall] = ACTIONS(2619),
    [anon_sym___fastcall] = ACTIONS(2619),
    [anon_sym___thiscall] = ACTIONS(2619),
    [anon_sym___vectorcall] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_RBRACE] = ACTIONS(2621),
    [anon_sym_signed] = ACTIONS(2619),
    [anon_sym_unsigned] = ACTIONS(2619),
    [anon_sym_long] = ACTIONS(2619),
    [anon_sym_short] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_register] = ACTIONS(2619),
    [anon_sym_inline] = ACTIONS(2619),
    [anon_sym___inline] = ACTIONS(2619),
    [anon_sym___inline__] = ACTIONS(2619),
    [anon_sym___forceinline] = ACTIONS(2619),
    [anon_sym_thread_local] = ACTIONS(2619),
    [anon_sym___thread] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_constexpr] = ACTIONS(2619),
    [anon_sym_volatile] = ACTIONS(2619),
    [anon_sym_restrict] = ACTIONS(2619),
    [anon_sym___restrict__] = ACTIONS(2619),
    [anon_sym__Atomic] = ACTIONS(2619),
    [anon_sym__Noreturn] = ACTIONS(2619),
    [anon_sym_noreturn] = ACTIONS(2619),
    [anon_sym__Nonnull] = ACTIONS(2619),
    [anon_sym_mutable] = ACTIONS(2619),
    [anon_sym_constinit] = ACTIONS(2619),
    [anon_sym_consteval] = ACTIONS(2619),
    [anon_sym_alignas] = ACTIONS(2619),
    [anon_sym__Alignas] = ACTIONS(2619),
    [sym_primitive_type] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_struct] = ACTIONS(2619),
    [anon_sym_union] = ACTIONS(2619),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_else] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2619),
    [anon_sym_case] = ACTIONS(2619),
    [anon_sym_default] = ACTIONS(2619),
    [anon_sym_while] = ACTIONS(2619),
    [anon_sym_do] = ACTIONS(2619),
    [anon_sym_for] = ACTIONS(2619),
    [anon_sym_return] = ACTIONS(2619),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_continue] = ACTIONS(2619),
    [anon_sym_goto] = ACTIONS(2619),
    [anon_sym___try] = ACTIONS(2619),
    [anon_sym___leave] = ACTIONS(2619),
    [anon_sym_not] = ACTIONS(2619),
    [anon_sym_compl] = ACTIONS(2619),
    [anon_sym_DASH_DASH] = ACTIONS(2621),
    [anon_sym_PLUS_PLUS] = ACTIONS(2621),
    [anon_sym_sizeof] = ACTIONS(2619),
    [anon_sym___alignof__] = ACTIONS(2619),
    [anon_sym___alignof] = ACTIONS(2619),
    [anon_sym__alignof] = ACTIONS(2619),
    [anon_sym_alignof] = ACTIONS(2619),
    [anon_sym__Alignof] = ACTIONS(2619),
    [anon_sym_offsetof] = ACTIONS(2619),
    [anon_sym__Generic] = ACTIONS(2619),
    [anon_sym_asm] = ACTIONS(2619),
    [anon_sym___asm__] = ACTIONS(2619),
    [anon_sym___asm] = ACTIONS(2619),
    [sym_number_literal] = ACTIONS(2621),
    [anon_sym_L_SQUOTE] = ACTIONS(2621),
    [anon_sym_u_SQUOTE] = ACTIONS(2621),
    [anon_sym_U_SQUOTE] = ACTIONS(2621),
    [anon_sym_u8_SQUOTE] = ACTIONS(2621),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [anon_sym_L_DQUOTE] = ACTIONS(2621),
    [anon_sym_u_DQUOTE] = ACTIONS(2621),
    [anon_sym_U_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8_DQUOTE] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [sym_true] = ACTIONS(2619),
    [sym_false] = ACTIONS(2619),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2619),
    [anon_sym_decltype] = ACTIONS(2619),
    [anon_sym_explicit] = ACTIONS(2619),
    [anon_sym_typename] = ACTIONS(2619),
    [anon_sym_template] = ACTIONS(2619),
    [anon_sym_operator] = ACTIONS(2619),
    [anon_sym_try] = ACTIONS(2619),
    [anon_sym_delete] = ACTIONS(2619),
    [anon_sym_throw] = ACTIONS(2619),
    [anon_sym_namespace] = ACTIONS(2619),
    [anon_sym_static_assert] = ACTIONS(2619),
    [anon_sym_concept] = ACTIONS(2619),
    [anon_sym_co_return] = ACTIONS(2619),
    [anon_sym_co_yield] = ACTIONS(2619),
    [anon_sym_catch] = ACTIONS(2619),
    [anon_sym_R_DQUOTE] = ACTIONS(2621),
    [anon_sym_LR_DQUOTE] = ACTIONS(2621),
    [anon_sym_uR_DQUOTE] = ACTIONS(2621),
    [anon_sym_UR_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2621),
    [anon_sym_co_await] = ACTIONS(2619),
    [anon_sym_new] = ACTIONS(2619),
    [anon_sym_requires] = ACTIONS(2619),
    [sym_this] = ACTIONS(2619),
  },
  [474] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_RBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [anon_sym___asm] = ACTIONS(2739),
    [sym_number_literal] = ACTIONS(2741),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(2929),
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_include_token1] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym___attribute] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2929),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym___cdecl] = ACTIONS(2927),
    [anon_sym___clrcall] = ACTIONS(2927),
    [anon_sym___stdcall] = ACTIONS(2927),
    [anon_sym___fastcall] = ACTIONS(2927),
    [anon_sym___thiscall] = ACTIONS(2927),
    [anon_sym___vectorcall] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym__Nonnull] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym__Alignas] = ACTIONS(2927),
    [sym_primitive_type] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2927),
    [anon_sym_compl] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_sizeof] = ACTIONS(2927),
    [anon_sym___alignof__] = ACTIONS(2927),
    [anon_sym___alignof] = ACTIONS(2927),
    [anon_sym__alignof] = ACTIONS(2927),
    [anon_sym_alignof] = ACTIONS(2927),
    [anon_sym__Alignof] = ACTIONS(2927),
    [anon_sym_offsetof] = ACTIONS(2927),
    [anon_sym__Generic] = ACTIONS(2927),
    [anon_sym_asm] = ACTIONS(2927),
    [anon_sym___asm__] = ACTIONS(2927),
    [anon_sym___asm] = ACTIONS(2927),
    [sym_number_literal] = ACTIONS(2929),
    [anon_sym_L_SQUOTE] = ACTIONS(2929),
    [anon_sym_u_SQUOTE] = ACTIONS(2929),
    [anon_sym_U_SQUOTE] = ACTIONS(2929),
    [anon_sym_u8_SQUOTE] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [anon_sym_L_DQUOTE] = ACTIONS(2929),
    [anon_sym_u_DQUOTE] = ACTIONS(2929),
    [anon_sym_U_DQUOTE] = ACTIONS(2929),
    [anon_sym_u8_DQUOTE] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [anon_sym_NULL] = ACTIONS(2927),
    [anon_sym_nullptr] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_export] = ACTIONS(2927),
    [anon_sym_module] = ACTIONS(2927),
    [anon_sym_import] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
    [anon_sym_concept] = ACTIONS(2927),
    [anon_sym_co_return] = ACTIONS(2927),
    [anon_sym_co_yield] = ACTIONS(2927),
    [anon_sym_R_DQUOTE] = ACTIONS(2929),
    [anon_sym_LR_DQUOTE] = ACTIONS(2929),
    [anon_sym_uR_DQUOTE] = ACTIONS(2929),
    [anon_sym_UR_DQUOTE] = ACTIONS(2929),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2929),
    [anon_sym_co_await] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_requires] = ACTIONS(2927),
    [sym_this] = ACTIONS(2927),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2791),
    [aux_sym_preproc_include_token1] = ACTIONS(2791),
    [aux_sym_preproc_def_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token1] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2791),
    [sym_preproc_directive] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2793),
    [anon_sym_BANG] = ACTIONS(2793),
    [anon_sym_TILDE] = ACTIONS(2793),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym___extension__] = ACTIONS(2791),
    [anon_sym_typedef] = ACTIONS(2791),
    [anon_sym_virtual] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym___attribute__] = ACTIONS(2791),
    [anon_sym___attribute] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2793),
    [anon_sym___declspec] = ACTIONS(2791),
    [anon_sym___based] = ACTIONS(2791),
    [anon_sym___cdecl] = ACTIONS(2791),
    [anon_sym___clrcall] = ACTIONS(2791),
    [anon_sym___stdcall] = ACTIONS(2791),
    [anon_sym___fastcall] = ACTIONS(2791),
    [anon_sym___thiscall] = ACTIONS(2791),
    [anon_sym___vectorcall] = ACTIONS(2791),
    [anon_sym_LBRACE] = ACTIONS(2793),
    [anon_sym_signed] = ACTIONS(2791),
    [anon_sym_unsigned] = ACTIONS(2791),
    [anon_sym_long] = ACTIONS(2791),
    [anon_sym_short] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_register] = ACTIONS(2791),
    [anon_sym_inline] = ACTIONS(2791),
    [anon_sym___inline] = ACTIONS(2791),
    [anon_sym___inline__] = ACTIONS(2791),
    [anon_sym___forceinline] = ACTIONS(2791),
    [anon_sym_thread_local] = ACTIONS(2791),
    [anon_sym___thread] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_constexpr] = ACTIONS(2791),
    [anon_sym_volatile] = ACTIONS(2791),
    [anon_sym_restrict] = ACTIONS(2791),
    [anon_sym___restrict__] = ACTIONS(2791),
    [anon_sym__Atomic] = ACTIONS(2791),
    [anon_sym__Noreturn] = ACTIONS(2791),
    [anon_sym_noreturn] = ACTIONS(2791),
    [anon_sym__Nonnull] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_constinit] = ACTIONS(2791),
    [anon_sym_consteval] = ACTIONS(2791),
    [anon_sym_alignas] = ACTIONS(2791),
    [anon_sym__Alignas] = ACTIONS(2791),
    [sym_primitive_type] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_class] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_switch] = ACTIONS(2791),
    [anon_sym_case] = ACTIONS(2791),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_break] = ACTIONS(2791),
    [anon_sym_continue] = ACTIONS(2791),
    [anon_sym_goto] = ACTIONS(2791),
    [anon_sym_not] = ACTIONS(2791),
    [anon_sym_compl] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(2793),
    [anon_sym_PLUS_PLUS] = ACTIONS(2793),
    [anon_sym_sizeof] = ACTIONS(2791),
    [anon_sym___alignof__] = ACTIONS(2791),
    [anon_sym___alignof] = ACTIONS(2791),
    [anon_sym__alignof] = ACTIONS(2791),
    [anon_sym_alignof] = ACTIONS(2791),
    [anon_sym__Alignof] = ACTIONS(2791),
    [anon_sym_offsetof] = ACTIONS(2791),
    [anon_sym__Generic] = ACTIONS(2791),
    [anon_sym_asm] = ACTIONS(2791),
    [anon_sym___asm__] = ACTIONS(2791),
    [anon_sym___asm] = ACTIONS(2791),
    [sym_number_literal] = ACTIONS(2793),
    [anon_sym_L_SQUOTE] = ACTIONS(2793),
    [anon_sym_u_SQUOTE] = ACTIONS(2793),
    [anon_sym_U_SQUOTE] = ACTIONS(2793),
    [anon_sym_u8_SQUOTE] = ACTIONS(2793),
    [anon_sym_SQUOTE] = ACTIONS(2793),
    [anon_sym_L_DQUOTE] = ACTIONS(2793),
    [anon_sym_u_DQUOTE] = ACTIONS(2793),
    [anon_sym_U_DQUOTE] = ACTIONS(2793),
    [anon_sym_u8_DQUOTE] = ACTIONS(2793),
    [anon_sym_DQUOTE] = ACTIONS(2793),
    [sym_true] = ACTIONS(2791),
    [sym_false] = ACTIONS(2791),
    [anon_sym_NULL] = ACTIONS(2791),
    [anon_sym_nullptr] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2791),
    [anon_sym_decltype] = ACTIONS(2791),
    [anon_sym_explicit] = ACTIONS(2791),
    [anon_sym_typename] = ACTIONS(2791),
    [anon_sym_export] = ACTIONS(2791),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_import] = ACTIONS(2791),
    [anon_sym_template] = ACTIONS(2791),
    [anon_sym_operator] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_delete] = ACTIONS(2791),
    [anon_sym_throw] = ACTIONS(2791),
    [anon_sym_namespace] = ACTIONS(2791),
    [anon_sym_static_assert] = ACTIONS(2791),
    [anon_sym_concept] = ACTIONS(2791),
    [anon_sym_co_return] = ACTIONS(2791),
    [anon_sym_co_yield] = ACTIONS(2791),
    [anon_sym_R_DQUOTE] = ACTIONS(2793),
    [anon_sym_LR_DQUOTE] = ACTIONS(2793),
    [anon_sym_uR_DQUOTE] = ACTIONS(2793),
    [anon_sym_UR_DQUOTE] = ACTIONS(2793),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2793),
    [anon_sym_co_await] = ACTIONS(2791),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_requires] = ACTIONS(2791),
    [sym_this] = ACTIONS(2791),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(2877),
    [sym_identifier] = ACTIONS(2875),
    [aux_sym_preproc_include_token1] = ACTIONS(2875),
    [aux_sym_preproc_def_token1] = ACTIONS(2875),
    [aux_sym_preproc_if_token1] = ACTIONS(2875),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2875),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2875),
    [sym_preproc_directive] = ACTIONS(2875),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2875),
    [anon_sym_typedef] = ACTIONS(2875),
    [anon_sym_virtual] = ACTIONS(2875),
    [anon_sym_extern] = ACTIONS(2875),
    [anon_sym___attribute__] = ACTIONS(2875),
    [anon_sym___attribute] = ACTIONS(2875),
    [anon_sym_using] = ACTIONS(2875),
    [anon_sym_COLON_COLON] = ACTIONS(2877),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2877),
    [anon_sym___declspec] = ACTIONS(2875),
    [anon_sym___based] = ACTIONS(2875),
    [anon_sym___cdecl] = ACTIONS(2875),
    [anon_sym___clrcall] = ACTIONS(2875),
    [anon_sym___stdcall] = ACTIONS(2875),
    [anon_sym___fastcall] = ACTIONS(2875),
    [anon_sym___thiscall] = ACTIONS(2875),
    [anon_sym___vectorcall] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_signed] = ACTIONS(2875),
    [anon_sym_unsigned] = ACTIONS(2875),
    [anon_sym_long] = ACTIONS(2875),
    [anon_sym_short] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_static] = ACTIONS(2875),
    [anon_sym_register] = ACTIONS(2875),
    [anon_sym_inline] = ACTIONS(2875),
    [anon_sym___inline] = ACTIONS(2875),
    [anon_sym___inline__] = ACTIONS(2875),
    [anon_sym___forceinline] = ACTIONS(2875),
    [anon_sym_thread_local] = ACTIONS(2875),
    [anon_sym___thread] = ACTIONS(2875),
    [anon_sym_const] = ACTIONS(2875),
    [anon_sym_constexpr] = ACTIONS(2875),
    [anon_sym_volatile] = ACTIONS(2875),
    [anon_sym_restrict] = ACTIONS(2875),
    [anon_sym___restrict__] = ACTIONS(2875),
    [anon_sym__Atomic] = ACTIONS(2875),
    [anon_sym__Noreturn] = ACTIONS(2875),
    [anon_sym_noreturn] = ACTIONS(2875),
    [anon_sym__Nonnull] = ACTIONS(2875),
    [anon_sym_mutable] = ACTIONS(2875),
    [anon_sym_constinit] = ACTIONS(2875),
    [anon_sym_consteval] = ACTIONS(2875),
    [anon_sym_alignas] = ACTIONS(2875),
    [anon_sym__Alignas] = ACTIONS(2875),
    [sym_primitive_type] = ACTIONS(2875),
    [anon_sym_enum] = ACTIONS(2875),
    [anon_sym_class] = ACTIONS(2875),
    [anon_sym_struct] = ACTIONS(2875),
    [anon_sym_union] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_switch] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_default] = ACTIONS(2875),
    [anon_sym_while] = ACTIONS(2875),
    [anon_sym_do] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2875),
    [anon_sym_return] = ACTIONS(2875),
    [anon_sym_break] = ACTIONS(2875),
    [anon_sym_continue] = ACTIONS(2875),
    [anon_sym_goto] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2875),
    [anon_sym_compl] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_sizeof] = ACTIONS(2875),
    [anon_sym___alignof__] = ACTIONS(2875),
    [anon_sym___alignof] = ACTIONS(2875),
    [anon_sym__alignof] = ACTIONS(2875),
    [anon_sym_alignof] = ACTIONS(2875),
    [anon_sym__Alignof] = ACTIONS(2875),
    [anon_sym_offsetof] = ACTIONS(2875),
    [anon_sym__Generic] = ACTIONS(2875),
    [anon_sym_asm] = ACTIONS(2875),
    [anon_sym___asm__] = ACTIONS(2875),
    [anon_sym___asm] = ACTIONS(2875),
    [sym_number_literal] = ACTIONS(2877),
    [anon_sym_L_SQUOTE] = ACTIONS(2877),
    [anon_sym_u_SQUOTE] = ACTIONS(2877),
    [anon_sym_U_SQUOTE] = ACTIONS(2877),
    [anon_sym_u8_SQUOTE] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_L_DQUOTE] = ACTIONS(2877),
    [anon_sym_u_DQUOTE] = ACTIONS(2877),
    [anon_sym_U_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [sym_true] = ACTIONS(2875),
    [sym_false] = ACTIONS(2875),
    [anon_sym_NULL] = ACTIONS(2875),
    [anon_sym_nullptr] = ACTIONS(2875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2875),
    [anon_sym_decltype] = ACTIONS(2875),
    [anon_sym_explicit] = ACTIONS(2875),
    [anon_sym_typename] = ACTIONS(2875),
    [anon_sym_export] = ACTIONS(2875),
    [anon_sym_module] = ACTIONS(2875),
    [anon_sym_import] = ACTIONS(2875),
    [anon_sym_template] = ACTIONS(2875),
    [anon_sym_operator] = ACTIONS(2875),
    [anon_sym_try] = ACTIONS(2875),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_throw] = ACTIONS(2875),
    [anon_sym_namespace] = ACTIONS(2875),
    [anon_sym_static_assert] = ACTIONS(2875),
    [anon_sym_concept] = ACTIONS(2875),
    [anon_sym_co_return] = ACTIONS(2875),
    [anon_sym_co_yield] = ACTIONS(2875),
    [anon_sym_R_DQUOTE] = ACTIONS(2877),
    [anon_sym_LR_DQUOTE] = ACTIONS(2877),
    [anon_sym_uR_DQUOTE] = ACTIONS(2877),
    [anon_sym_UR_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2877),
    [anon_sym_co_await] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2875),
    [anon_sym_requires] = ACTIONS(2875),
    [sym_this] = ACTIONS(2875),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(2933),
    [sym_identifier] = ACTIONS(2931),
    [aux_sym_preproc_include_token1] = ACTIONS(2931),
    [aux_sym_preproc_def_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token1] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2931),
    [sym_preproc_directive] = ACTIONS(2931),
    [anon_sym_LPAREN2] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym___extension__] = ACTIONS(2931),
    [anon_sym_typedef] = ACTIONS(2931),
    [anon_sym_virtual] = ACTIONS(2931),
    [anon_sym_extern] = ACTIONS(2931),
    [anon_sym___attribute__] = ACTIONS(2931),
    [anon_sym___attribute] = ACTIONS(2931),
    [anon_sym_using] = ACTIONS(2931),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2933),
    [anon_sym___declspec] = ACTIONS(2931),
    [anon_sym___based] = ACTIONS(2931),
    [anon_sym___cdecl] = ACTIONS(2931),
    [anon_sym___clrcall] = ACTIONS(2931),
    [anon_sym___stdcall] = ACTIONS(2931),
    [anon_sym___fastcall] = ACTIONS(2931),
    [anon_sym___thiscall] = ACTIONS(2931),
    [anon_sym___vectorcall] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_signed] = ACTIONS(2931),
    [anon_sym_unsigned] = ACTIONS(2931),
    [anon_sym_long] = ACTIONS(2931),
    [anon_sym_short] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_register] = ACTIONS(2931),
    [anon_sym_inline] = ACTIONS(2931),
    [anon_sym___inline] = ACTIONS(2931),
    [anon_sym___inline__] = ACTIONS(2931),
    [anon_sym___forceinline] = ACTIONS(2931),
    [anon_sym_thread_local] = ACTIONS(2931),
    [anon_sym___thread] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_constexpr] = ACTIONS(2931),
    [anon_sym_volatile] = ACTIONS(2931),
    [anon_sym_restrict] = ACTIONS(2931),
    [anon_sym___restrict__] = ACTIONS(2931),
    [anon_sym__Atomic] = ACTIONS(2931),
    [anon_sym__Noreturn] = ACTIONS(2931),
    [anon_sym_noreturn] = ACTIONS(2931),
    [anon_sym__Nonnull] = ACTIONS(2931),
    [anon_sym_mutable] = ACTIONS(2931),
    [anon_sym_constinit] = ACTIONS(2931),
    [anon_sym_consteval] = ACTIONS(2931),
    [anon_sym_alignas] = ACTIONS(2931),
    [anon_sym__Alignas] = ACTIONS(2931),
    [sym_primitive_type] = ACTIONS(2931),
    [anon_sym_enum] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2931),
    [anon_sym_struct] = ACTIONS(2931),
    [anon_sym_union] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_switch] = ACTIONS(2931),
    [anon_sym_case] = ACTIONS(2931),
    [anon_sym_default] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_for] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2931),
    [anon_sym_break] = ACTIONS(2931),
    [anon_sym_continue] = ACTIONS(2931),
    [anon_sym_goto] = ACTIONS(2931),
    [anon_sym_not] = ACTIONS(2931),
    [anon_sym_compl] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2931),
    [anon_sym___alignof__] = ACTIONS(2931),
    [anon_sym___alignof] = ACTIONS(2931),
    [anon_sym__alignof] = ACTIONS(2931),
    [anon_sym_alignof] = ACTIONS(2931),
    [anon_sym__Alignof] = ACTIONS(2931),
    [anon_sym_offsetof] = ACTIONS(2931),
    [anon_sym__Generic] = ACTIONS(2931),
    [anon_sym_asm] = ACTIONS(2931),
    [anon_sym___asm__] = ACTIONS(2931),
    [anon_sym___asm] = ACTIONS(2931),
    [sym_number_literal] = ACTIONS(2933),
    [anon_sym_L_SQUOTE] = ACTIONS(2933),
    [anon_sym_u_SQUOTE] = ACTIONS(2933),
    [anon_sym_U_SQUOTE] = ACTIONS(2933),
    [anon_sym_u8_SQUOTE] = ACTIONS(2933),
    [anon_sym_SQUOTE] = ACTIONS(2933),
    [anon_sym_L_DQUOTE] = ACTIONS(2933),
    [anon_sym_u_DQUOTE] = ACTIONS(2933),
    [anon_sym_U_DQUOTE] = ACTIONS(2933),
    [anon_sym_u8_DQUOTE] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2933),
    [sym_true] = ACTIONS(2931),
    [sym_false] = ACTIONS(2931),
    [anon_sym_NULL] = ACTIONS(2931),
    [anon_sym_nullptr] = ACTIONS(2931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2931),
    [anon_sym_decltype] = ACTIONS(2931),
    [anon_sym_explicit] = ACTIONS(2931),
    [anon_sym_typename] = ACTIONS(2931),
    [anon_sym_export] = ACTIONS(2931),
    [anon_sym_module] = ACTIONS(2931),
    [anon_sym_import] = ACTIONS(2931),
    [anon_sym_template] = ACTIONS(2931),
    [anon_sym_operator] = ACTIONS(2931),
    [anon_sym_try] = ACTIONS(2931),
    [anon_sym_delete] = ACTIONS(2931),
    [anon_sym_throw] = ACTIONS(2931),
    [anon_sym_namespace] = ACTIONS(2931),
    [anon_sym_static_assert] = ACTIONS(2931),
    [anon_sym_concept] = ACTIONS(2931),
    [anon_sym_co_return] = ACTIONS(2931),
    [anon_sym_co_yield] = ACTIONS(2931),
    [anon_sym_R_DQUOTE] = ACTIONS(2933),
    [anon_sym_LR_DQUOTE] = ACTIONS(2933),
    [anon_sym_uR_DQUOTE] = ACTIONS(2933),
    [anon_sym_UR_DQUOTE] = ACTIONS(2933),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2933),
    [anon_sym_co_await] = ACTIONS(2931),
    [anon_sym_new] = ACTIONS(2931),
    [anon_sym_requires] = ACTIONS(2931),
    [sym_this] = ACTIONS(2931),
  },
  [479] = {
    [ts_builtin_sym_end] = ACTIONS(2937),
    [sym_identifier] = ACTIONS(2935),
    [aux_sym_preproc_include_token1] = ACTIONS(2935),
    [aux_sym_preproc_def_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token1] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2935),
    [sym_preproc_directive] = ACTIONS(2935),
    [anon_sym_LPAREN2] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym___extension__] = ACTIONS(2935),
    [anon_sym_typedef] = ACTIONS(2935),
    [anon_sym_virtual] = ACTIONS(2935),
    [anon_sym_extern] = ACTIONS(2935),
    [anon_sym___attribute__] = ACTIONS(2935),
    [anon_sym___attribute] = ACTIONS(2935),
    [anon_sym_using] = ACTIONS(2935),
    [anon_sym_COLON_COLON] = ACTIONS(2937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2937),
    [anon_sym___declspec] = ACTIONS(2935),
    [anon_sym___based] = ACTIONS(2935),
    [anon_sym___cdecl] = ACTIONS(2935),
    [anon_sym___clrcall] = ACTIONS(2935),
    [anon_sym___stdcall] = ACTIONS(2935),
    [anon_sym___fastcall] = ACTIONS(2935),
    [anon_sym___thiscall] = ACTIONS(2935),
    [anon_sym___vectorcall] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_signed] = ACTIONS(2935),
    [anon_sym_unsigned] = ACTIONS(2935),
    [anon_sym_long] = ACTIONS(2935),
    [anon_sym_short] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_register] = ACTIONS(2935),
    [anon_sym_inline] = ACTIONS(2935),
    [anon_sym___inline] = ACTIONS(2935),
    [anon_sym___inline__] = ACTIONS(2935),
    [anon_sym___forceinline] = ACTIONS(2935),
    [anon_sym_thread_local] = ACTIONS(2935),
    [anon_sym___thread] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_constexpr] = ACTIONS(2935),
    [anon_sym_volatile] = ACTIONS(2935),
    [anon_sym_restrict] = ACTIONS(2935),
    [anon_sym___restrict__] = ACTIONS(2935),
    [anon_sym__Atomic] = ACTIONS(2935),
    [anon_sym__Noreturn] = ACTIONS(2935),
    [anon_sym_noreturn] = ACTIONS(2935),
    [anon_sym__Nonnull] = ACTIONS(2935),
    [anon_sym_mutable] = ACTIONS(2935),
    [anon_sym_constinit] = ACTIONS(2935),
    [anon_sym_consteval] = ACTIONS(2935),
    [anon_sym_alignas] = ACTIONS(2935),
    [anon_sym__Alignas] = ACTIONS(2935),
    [sym_primitive_type] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_union] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_case] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2935),
    [anon_sym_while] = ACTIONS(2935),
    [anon_sym_do] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_goto] = ACTIONS(2935),
    [anon_sym_not] = ACTIONS(2935),
    [anon_sym_compl] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2937),
    [anon_sym_sizeof] = ACTIONS(2935),
    [anon_sym___alignof__] = ACTIONS(2935),
    [anon_sym___alignof] = ACTIONS(2935),
    [anon_sym__alignof] = ACTIONS(2935),
    [anon_sym_alignof] = ACTIONS(2935),
    [anon_sym__Alignof] = ACTIONS(2935),
    [anon_sym_offsetof] = ACTIONS(2935),
    [anon_sym__Generic] = ACTIONS(2935),
    [anon_sym_asm] = ACTIONS(2935),
    [anon_sym___asm__] = ACTIONS(2935),
    [anon_sym___asm] = ACTIONS(2935),
    [sym_number_literal] = ACTIONS(2937),
    [anon_sym_L_SQUOTE] = ACTIONS(2937),
    [anon_sym_u_SQUOTE] = ACTIONS(2937),
    [anon_sym_U_SQUOTE] = ACTIONS(2937),
    [anon_sym_u8_SQUOTE] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2937),
    [anon_sym_L_DQUOTE] = ACTIONS(2937),
    [anon_sym_u_DQUOTE] = ACTIONS(2937),
    [anon_sym_U_DQUOTE] = ACTIONS(2937),
    [anon_sym_u8_DQUOTE] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [anon_sym_NULL] = ACTIONS(2935),
    [anon_sym_nullptr] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2935),
    [anon_sym_decltype] = ACTIONS(2935),
    [anon_sym_explicit] = ACTIONS(2935),
    [anon_sym_typename] = ACTIONS(2935),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_import] = ACTIONS(2935),
    [anon_sym_template] = ACTIONS(2935),
    [anon_sym_operator] = ACTIONS(2935),
    [anon_sym_try] = ACTIONS(2935),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_throw] = ACTIONS(2935),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_static_assert] = ACTIONS(2935),
    [anon_sym_concept] = ACTIONS(2935),
    [anon_sym_co_return] = ACTIONS(2935),
    [anon_sym_co_yield] = ACTIONS(2935),
    [anon_sym_R_DQUOTE] = ACTIONS(2937),
    [anon_sym_LR_DQUOTE] = ACTIONS(2937),
    [anon_sym_uR_DQUOTE] = ACTIONS(2937),
    [anon_sym_UR_DQUOTE] = ACTIONS(2937),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2937),
    [anon_sym_co_await] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2935),
    [anon_sym_requires] = ACTIONS(2935),
    [sym_this] = ACTIONS(2935),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(2941),
    [sym_identifier] = ACTIONS(2939),
    [aux_sym_preproc_include_token1] = ACTIONS(2939),
    [aux_sym_preproc_def_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2939),
    [sym_preproc_directive] = ACTIONS(2939),
    [anon_sym_LPAREN2] = ACTIONS(2941),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2939),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2939),
    [anon_sym_typedef] = ACTIONS(2939),
    [anon_sym_virtual] = ACTIONS(2939),
    [anon_sym_extern] = ACTIONS(2939),
    [anon_sym___attribute__] = ACTIONS(2939),
    [anon_sym___attribute] = ACTIONS(2939),
    [anon_sym_using] = ACTIONS(2939),
    [anon_sym_COLON_COLON] = ACTIONS(2941),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2941),
    [anon_sym___declspec] = ACTIONS(2939),
    [anon_sym___based] = ACTIONS(2939),
    [anon_sym___cdecl] = ACTIONS(2939),
    [anon_sym___clrcall] = ACTIONS(2939),
    [anon_sym___stdcall] = ACTIONS(2939),
    [anon_sym___fastcall] = ACTIONS(2939),
    [anon_sym___thiscall] = ACTIONS(2939),
    [anon_sym___vectorcall] = ACTIONS(2939),
    [anon_sym_LBRACE] = ACTIONS(2941),
    [anon_sym_signed] = ACTIONS(2939),
    [anon_sym_unsigned] = ACTIONS(2939),
    [anon_sym_long] = ACTIONS(2939),
    [anon_sym_short] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_static] = ACTIONS(2939),
    [anon_sym_register] = ACTIONS(2939),
    [anon_sym_inline] = ACTIONS(2939),
    [anon_sym___inline] = ACTIONS(2939),
    [anon_sym___inline__] = ACTIONS(2939),
    [anon_sym___forceinline] = ACTIONS(2939),
    [anon_sym_thread_local] = ACTIONS(2939),
    [anon_sym___thread] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_constexpr] = ACTIONS(2939),
    [anon_sym_volatile] = ACTIONS(2939),
    [anon_sym_restrict] = ACTIONS(2939),
    [anon_sym___restrict__] = ACTIONS(2939),
    [anon_sym__Atomic] = ACTIONS(2939),
    [anon_sym__Noreturn] = ACTIONS(2939),
    [anon_sym_noreturn] = ACTIONS(2939),
    [anon_sym__Nonnull] = ACTIONS(2939),
    [anon_sym_mutable] = ACTIONS(2939),
    [anon_sym_constinit] = ACTIONS(2939),
    [anon_sym_consteval] = ACTIONS(2939),
    [anon_sym_alignas] = ACTIONS(2939),
    [anon_sym__Alignas] = ACTIONS(2939),
    [sym_primitive_type] = ACTIONS(2939),
    [anon_sym_enum] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2939),
    [anon_sym_struct] = ACTIONS(2939),
    [anon_sym_union] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(2939),
    [anon_sym_switch] = ACTIONS(2939),
    [anon_sym_case] = ACTIONS(2939),
    [anon_sym_default] = ACTIONS(2939),
    [anon_sym_while] = ACTIONS(2939),
    [anon_sym_do] = ACTIONS(2939),
    [anon_sym_for] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2939),
    [anon_sym_break] = ACTIONS(2939),
    [anon_sym_continue] = ACTIONS(2939),
    [anon_sym_goto] = ACTIONS(2939),
    [anon_sym_not] = ACTIONS(2939),
    [anon_sym_compl] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2941),
    [anon_sym_PLUS_PLUS] = ACTIONS(2941),
    [anon_sym_sizeof] = ACTIONS(2939),
    [anon_sym___alignof__] = ACTIONS(2939),
    [anon_sym___alignof] = ACTIONS(2939),
    [anon_sym__alignof] = ACTIONS(2939),
    [anon_sym_alignof] = ACTIONS(2939),
    [anon_sym__Alignof] = ACTIONS(2939),
    [anon_sym_offsetof] = ACTIONS(2939),
    [anon_sym__Generic] = ACTIONS(2939),
    [anon_sym_asm] = ACTIONS(2939),
    [anon_sym___asm__] = ACTIONS(2939),
    [anon_sym___asm] = ACTIONS(2939),
    [sym_number_literal] = ACTIONS(2941),
    [anon_sym_L_SQUOTE] = ACTIONS(2941),
    [anon_sym_u_SQUOTE] = ACTIONS(2941),
    [anon_sym_U_SQUOTE] = ACTIONS(2941),
    [anon_sym_u8_SQUOTE] = ACTIONS(2941),
    [anon_sym_SQUOTE] = ACTIONS(2941),
    [anon_sym_L_DQUOTE] = ACTIONS(2941),
    [anon_sym_u_DQUOTE] = ACTIONS(2941),
    [anon_sym_U_DQUOTE] = ACTIONS(2941),
    [anon_sym_u8_DQUOTE] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_true] = ACTIONS(2939),
    [sym_false] = ACTIONS(2939),
    [anon_sym_NULL] = ACTIONS(2939),
    [anon_sym_nullptr] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2939),
    [anon_sym_decltype] = ACTIONS(2939),
    [anon_sym_explicit] = ACTIONS(2939),
    [anon_sym_typename] = ACTIONS(2939),
    [anon_sym_export] = ACTIONS(2939),
    [anon_sym_module] = ACTIONS(2939),
    [anon_sym_import] = ACTIONS(2939),
    [anon_sym_template] = ACTIONS(2939),
    [anon_sym_operator] = ACTIONS(2939),
    [anon_sym_try] = ACTIONS(2939),
    [anon_sym_delete] = ACTIONS(2939),
    [anon_sym_throw] = ACTIONS(2939),
    [anon_sym_namespace] = ACTIONS(2939),
    [anon_sym_static_assert] = ACTIONS(2939),
    [anon_sym_concept] = ACTIONS(2939),
    [anon_sym_co_return] = ACTIONS(2939),
    [anon_sym_co_yield] = ACTIONS(2939),
    [anon_sym_R_DQUOTE] = ACTIONS(2941),
    [anon_sym_LR_DQUOTE] = ACTIONS(2941),
    [anon_sym_uR_DQUOTE] = ACTIONS(2941),
    [anon_sym_UR_DQUOTE] = ACTIONS(2941),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2941),
    [anon_sym_co_await] = ACTIONS(2939),
    [anon_sym_new] = ACTIONS(2939),
    [anon_sym_requires] = ACTIONS(2939),
    [sym_this] = ACTIONS(2939),
  },
  [481] = {
    [ts_builtin_sym_end] = ACTIONS(2945),
    [sym_identifier] = ACTIONS(2943),
    [aux_sym_preproc_include_token1] = ACTIONS(2943),
    [aux_sym_preproc_def_token1] = ACTIONS(2943),
    [aux_sym_preproc_if_token1] = ACTIONS(2943),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2943),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2943),
    [sym_preproc_directive] = ACTIONS(2943),
    [anon_sym_LPAREN2] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_TILDE] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2943),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym___extension__] = ACTIONS(2943),
    [anon_sym_typedef] = ACTIONS(2943),
    [anon_sym_virtual] = ACTIONS(2943),
    [anon_sym_extern] = ACTIONS(2943),
    [anon_sym___attribute__] = ACTIONS(2943),
    [anon_sym___attribute] = ACTIONS(2943),
    [anon_sym_using] = ACTIONS(2943),
    [anon_sym_COLON_COLON] = ACTIONS(2945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2945),
    [anon_sym___declspec] = ACTIONS(2943),
    [anon_sym___based] = ACTIONS(2943),
    [anon_sym___cdecl] = ACTIONS(2943),
    [anon_sym___clrcall] = ACTIONS(2943),
    [anon_sym___stdcall] = ACTIONS(2943),
    [anon_sym___fastcall] = ACTIONS(2943),
    [anon_sym___thiscall] = ACTIONS(2943),
    [anon_sym___vectorcall] = ACTIONS(2943),
    [anon_sym_LBRACE] = ACTIONS(2945),
    [anon_sym_signed] = ACTIONS(2943),
    [anon_sym_unsigned] = ACTIONS(2943),
    [anon_sym_long] = ACTIONS(2943),
    [anon_sym_short] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_static] = ACTIONS(2943),
    [anon_sym_register] = ACTIONS(2943),
    [anon_sym_inline] = ACTIONS(2943),
    [anon_sym___inline] = ACTIONS(2943),
    [anon_sym___inline__] = ACTIONS(2943),
    [anon_sym___forceinline] = ACTIONS(2943),
    [anon_sym_thread_local] = ACTIONS(2943),
    [anon_sym___thread] = ACTIONS(2943),
    [anon_sym_const] = ACTIONS(2943),
    [anon_sym_constexpr] = ACTIONS(2943),
    [anon_sym_volatile] = ACTIONS(2943),
    [anon_sym_restrict] = ACTIONS(2943),
    [anon_sym___restrict__] = ACTIONS(2943),
    [anon_sym__Atomic] = ACTIONS(2943),
    [anon_sym__Noreturn] = ACTIONS(2943),
    [anon_sym_noreturn] = ACTIONS(2943),
    [anon_sym__Nonnull] = ACTIONS(2943),
    [anon_sym_mutable] = ACTIONS(2943),
    [anon_sym_constinit] = ACTIONS(2943),
    [anon_sym_consteval] = ACTIONS(2943),
    [anon_sym_alignas] = ACTIONS(2943),
    [anon_sym__Alignas] = ACTIONS(2943),
    [sym_primitive_type] = ACTIONS(2943),
    [anon_sym_enum] = ACTIONS(2943),
    [anon_sym_class] = ACTIONS(2943),
    [anon_sym_struct] = ACTIONS(2943),
    [anon_sym_union] = ACTIONS(2943),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_switch] = ACTIONS(2943),
    [anon_sym_case] = ACTIONS(2943),
    [anon_sym_default] = ACTIONS(2943),
    [anon_sym_while] = ACTIONS(2943),
    [anon_sym_do] = ACTIONS(2943),
    [anon_sym_for] = ACTIONS(2943),
    [anon_sym_return] = ACTIONS(2943),
    [anon_sym_break] = ACTIONS(2943),
    [anon_sym_continue] = ACTIONS(2943),
    [anon_sym_goto] = ACTIONS(2943),
    [anon_sym_not] = ACTIONS(2943),
    [anon_sym_compl] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_sizeof] = ACTIONS(2943),
    [anon_sym___alignof__] = ACTIONS(2943),
    [anon_sym___alignof] = ACTIONS(2943),
    [anon_sym__alignof] = ACTIONS(2943),
    [anon_sym_alignof] = ACTIONS(2943),
    [anon_sym__Alignof] = ACTIONS(2943),
    [anon_sym_offsetof] = ACTIONS(2943),
    [anon_sym__Generic] = ACTIONS(2943),
    [anon_sym_asm] = ACTIONS(2943),
    [anon_sym___asm__] = ACTIONS(2943),
    [anon_sym___asm] = ACTIONS(2943),
    [sym_number_literal] = ACTIONS(2945),
    [anon_sym_L_SQUOTE] = ACTIONS(2945),
    [anon_sym_u_SQUOTE] = ACTIONS(2945),
    [anon_sym_U_SQUOTE] = ACTIONS(2945),
    [anon_sym_u8_SQUOTE] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_L_DQUOTE] = ACTIONS(2945),
    [anon_sym_u_DQUOTE] = ACTIONS(2945),
    [anon_sym_U_DQUOTE] = ACTIONS(2945),
    [anon_sym_u8_DQUOTE] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_true] = ACTIONS(2943),
    [sym_false] = ACTIONS(2943),
    [anon_sym_NULL] = ACTIONS(2943),
    [anon_sym_nullptr] = ACTIONS(2943),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2943),
    [anon_sym_decltype] = ACTIONS(2943),
    [anon_sym_explicit] = ACTIONS(2943),
    [anon_sym_typename] = ACTIONS(2943),
    [anon_sym_export] = ACTIONS(2943),
    [anon_sym_module] = ACTIONS(2943),
    [anon_sym_import] = ACTIONS(2943),
    [anon_sym_template] = ACTIONS(2943),
    [anon_sym_operator] = ACTIONS(2943),
    [anon_sym_try] = ACTIONS(2943),
    [anon_sym_delete] = ACTIONS(2943),
    [anon_sym_throw] = ACTIONS(2943),
    [anon_sym_namespace] = ACTIONS(2943),
    [anon_sym_static_assert] = ACTIONS(2943),
    [anon_sym_concept] = ACTIONS(2943),
    [anon_sym_co_return] = ACTIONS(2943),
    [anon_sym_co_yield] = ACTIONS(2943),
    [anon_sym_R_DQUOTE] = ACTIONS(2945),
    [anon_sym_LR_DQUOTE] = ACTIONS(2945),
    [anon_sym_uR_DQUOTE] = ACTIONS(2945),
    [anon_sym_UR_DQUOTE] = ACTIONS(2945),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2945),
    [anon_sym_co_await] = ACTIONS(2943),
    [anon_sym_new] = ACTIONS(2943),
    [anon_sym_requires] = ACTIONS(2943),
    [sym_this] = ACTIONS(2943),
  },
  [482] = {
    [ts_builtin_sym_end] = ACTIONS(2949),
    [sym_identifier] = ACTIONS(2947),
    [aux_sym_preproc_include_token1] = ACTIONS(2947),
    [aux_sym_preproc_def_token1] = ACTIONS(2947),
    [aux_sym_preproc_if_token1] = ACTIONS(2947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2947),
    [sym_preproc_directive] = ACTIONS(2947),
    [anon_sym_LPAREN2] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym___extension__] = ACTIONS(2947),
    [anon_sym_typedef] = ACTIONS(2947),
    [anon_sym_virtual] = ACTIONS(2947),
    [anon_sym_extern] = ACTIONS(2947),
    [anon_sym___attribute__] = ACTIONS(2947),
    [anon_sym___attribute] = ACTIONS(2947),
    [anon_sym_using] = ACTIONS(2947),
    [anon_sym_COLON_COLON] = ACTIONS(2949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2949),
    [anon_sym___declspec] = ACTIONS(2947),
    [anon_sym___based] = ACTIONS(2947),
    [anon_sym___cdecl] = ACTIONS(2947),
    [anon_sym___clrcall] = ACTIONS(2947),
    [anon_sym___stdcall] = ACTIONS(2947),
    [anon_sym___fastcall] = ACTIONS(2947),
    [anon_sym___thiscall] = ACTIONS(2947),
    [anon_sym___vectorcall] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2949),
    [anon_sym_signed] = ACTIONS(2947),
    [anon_sym_unsigned] = ACTIONS(2947),
    [anon_sym_long] = ACTIONS(2947),
    [anon_sym_short] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_static] = ACTIONS(2947),
    [anon_sym_register] = ACTIONS(2947),
    [anon_sym_inline] = ACTIONS(2947),
    [anon_sym___inline] = ACTIONS(2947),
    [anon_sym___inline__] = ACTIONS(2947),
    [anon_sym___forceinline] = ACTIONS(2947),
    [anon_sym_thread_local] = ACTIONS(2947),
    [anon_sym___thread] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_constexpr] = ACTIONS(2947),
    [anon_sym_volatile] = ACTIONS(2947),
    [anon_sym_restrict] = ACTIONS(2947),
    [anon_sym___restrict__] = ACTIONS(2947),
    [anon_sym__Atomic] = ACTIONS(2947),
    [anon_sym__Noreturn] = ACTIONS(2947),
    [anon_sym_noreturn] = ACTIONS(2947),
    [anon_sym__Nonnull] = ACTIONS(2947),
    [anon_sym_mutable] = ACTIONS(2947),
    [anon_sym_constinit] = ACTIONS(2947),
    [anon_sym_consteval] = ACTIONS(2947),
    [anon_sym_alignas] = ACTIONS(2947),
    [anon_sym__Alignas] = ACTIONS(2947),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2947),
    [anon_sym_class] = ACTIONS(2947),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_switch] = ACTIONS(2947),
    [anon_sym_case] = ACTIONS(2947),
    [anon_sym_default] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_goto] = ACTIONS(2947),
    [anon_sym_not] = ACTIONS(2947),
    [anon_sym_compl] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2949),
    [anon_sym_PLUS_PLUS] = ACTIONS(2949),
    [anon_sym_sizeof] = ACTIONS(2947),
    [anon_sym___alignof__] = ACTIONS(2947),
    [anon_sym___alignof] = ACTIONS(2947),
    [anon_sym__alignof] = ACTIONS(2947),
    [anon_sym_alignof] = ACTIONS(2947),
    [anon_sym__Alignof] = ACTIONS(2947),
    [anon_sym_offsetof] = ACTIONS(2947),
    [anon_sym__Generic] = ACTIONS(2947),
    [anon_sym_asm] = ACTIONS(2947),
    [anon_sym___asm__] = ACTIONS(2947),
    [anon_sym___asm] = ACTIONS(2947),
    [sym_number_literal] = ACTIONS(2949),
    [anon_sym_L_SQUOTE] = ACTIONS(2949),
    [anon_sym_u_SQUOTE] = ACTIONS(2949),
    [anon_sym_U_SQUOTE] = ACTIONS(2949),
    [anon_sym_u8_SQUOTE] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_L_DQUOTE] = ACTIONS(2949),
    [anon_sym_u_DQUOTE] = ACTIONS(2949),
    [anon_sym_U_DQUOTE] = ACTIONS(2949),
    [anon_sym_u8_DQUOTE] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [anon_sym_NULL] = ACTIONS(2947),
    [anon_sym_nullptr] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2947),
    [anon_sym_decltype] = ACTIONS(2947),
    [anon_sym_explicit] = ACTIONS(2947),
    [anon_sym_typename] = ACTIONS(2947),
    [anon_sym_export] = ACTIONS(2947),
    [anon_sym_module] = ACTIONS(2947),
    [anon_sym_import] = ACTIONS(2947),
    [anon_sym_template] = ACTIONS(2947),
    [anon_sym_operator] = ACTIONS(2947),
    [anon_sym_try] = ACTIONS(2947),
    [anon_sym_delete] = ACTIONS(2947),
    [anon_sym_throw] = ACTIONS(2947),
    [anon_sym_namespace] = ACTIONS(2947),
    [anon_sym_static_assert] = ACTIONS(2947),
    [anon_sym_concept] = ACTIONS(2947),
    [anon_sym_co_return] = ACTIONS(2947),
    [anon_sym_co_yield] = ACTIONS(2947),
    [anon_sym_R_DQUOTE] = ACTIONS(2949),
    [anon_sym_LR_DQUOTE] = ACTIONS(2949),
    [anon_sym_uR_DQUOTE] = ACTIONS(2949),
    [anon_sym_UR_DQUOTE] = ACTIONS(2949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2949),
    [anon_sym_co_await] = ACTIONS(2947),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_requires] = ACTIONS(2947),
    [sym_this] = ACTIONS(2947),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(3371),
    [sym_identifier] = ACTIONS(3373),
    [aux_sym_preproc_include_token1] = ACTIONS(3373),
    [aux_sym_preproc_def_token1] = ACTIONS(3373),
    [aux_sym_preproc_if_token1] = ACTIONS(3373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3373),
    [sym_preproc_directive] = ACTIONS(3373),
    [anon_sym_LPAREN2] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3371),
    [anon_sym_TILDE] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_STAR] = ACTIONS(3371),
    [anon_sym_AMP_AMP] = ACTIONS(3371),
    [anon_sym_AMP] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(3371),
    [anon_sym___extension__] = ACTIONS(3373),
    [anon_sym_typedef] = ACTIONS(3373),
    [anon_sym_virtual] = ACTIONS(3373),
    [anon_sym_extern] = ACTIONS(3373),
    [anon_sym___attribute__] = ACTIONS(3373),
    [anon_sym___attribute] = ACTIONS(3373),
    [anon_sym_using] = ACTIONS(3373),
    [anon_sym_COLON_COLON] = ACTIONS(3371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3371),
    [anon_sym___declspec] = ACTIONS(3373),
    [anon_sym___based] = ACTIONS(3373),
    [anon_sym___cdecl] = ACTIONS(3373),
    [anon_sym___clrcall] = ACTIONS(3373),
    [anon_sym___stdcall] = ACTIONS(3373),
    [anon_sym___fastcall] = ACTIONS(3373),
    [anon_sym___thiscall] = ACTIONS(3373),
    [anon_sym___vectorcall] = ACTIONS(3373),
    [anon_sym_LBRACE] = ACTIONS(3371),
    [anon_sym_signed] = ACTIONS(3373),
    [anon_sym_unsigned] = ACTIONS(3373),
    [anon_sym_long] = ACTIONS(3373),
    [anon_sym_short] = ACTIONS(3373),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_static] = ACTIONS(3373),
    [anon_sym_register] = ACTIONS(3373),
    [anon_sym_inline] = ACTIONS(3373),
    [anon_sym___inline] = ACTIONS(3373),
    [anon_sym___inline__] = ACTIONS(3373),
    [anon_sym___forceinline] = ACTIONS(3373),
    [anon_sym_thread_local] = ACTIONS(3373),
    [anon_sym___thread] = ACTIONS(3373),
    [anon_sym_const] = ACTIONS(3373),
    [anon_sym_constexpr] = ACTIONS(3373),
    [anon_sym_volatile] = ACTIONS(3373),
    [anon_sym_restrict] = ACTIONS(3373),
    [anon_sym___restrict__] = ACTIONS(3373),
    [anon_sym__Atomic] = ACTIONS(3373),
    [anon_sym__Noreturn] = ACTIONS(3373),
    [anon_sym_noreturn] = ACTIONS(3373),
    [anon_sym__Nonnull] = ACTIONS(3373),
    [anon_sym_mutable] = ACTIONS(3373),
    [anon_sym_constinit] = ACTIONS(3373),
    [anon_sym_consteval] = ACTIONS(3373),
    [anon_sym_alignas] = ACTIONS(3373),
    [anon_sym__Alignas] = ACTIONS(3373),
    [sym_primitive_type] = ACTIONS(3373),
    [anon_sym_enum] = ACTIONS(3373),
    [anon_sym_class] = ACTIONS(3373),
    [anon_sym_struct] = ACTIONS(3373),
    [anon_sym_union] = ACTIONS(3373),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(3373),
    [anon_sym_case] = ACTIONS(3373),
    [anon_sym_default] = ACTIONS(3373),
    [anon_sym_while] = ACTIONS(3373),
    [anon_sym_do] = ACTIONS(3373),
    [anon_sym_for] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3373),
    [anon_sym_break] = ACTIONS(3373),
    [anon_sym_continue] = ACTIONS(3373),
    [anon_sym_goto] = ACTIONS(3373),
    [anon_sym_not] = ACTIONS(3373),
    [anon_sym_compl] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3371),
    [anon_sym_PLUS_PLUS] = ACTIONS(3371),
    [anon_sym_sizeof] = ACTIONS(3373),
    [anon_sym___alignof__] = ACTIONS(3373),
    [anon_sym___alignof] = ACTIONS(3373),
    [anon_sym__alignof] = ACTIONS(3373),
    [anon_sym_alignof] = ACTIONS(3373),
    [anon_sym__Alignof] = ACTIONS(3373),
    [anon_sym_offsetof] = ACTIONS(3373),
    [anon_sym__Generic] = ACTIONS(3373),
    [anon_sym_asm] = ACTIONS(3373),
    [anon_sym___asm__] = ACTIONS(3373),
    [anon_sym___asm] = ACTIONS(3373),
    [sym_number_literal] = ACTIONS(3371),
    [anon_sym_L_SQUOTE] = ACTIONS(3371),
    [anon_sym_u_SQUOTE] = ACTIONS(3371),
    [anon_sym_U_SQUOTE] = ACTIONS(3371),
    [anon_sym_u8_SQUOTE] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(3371),
    [anon_sym_L_DQUOTE] = ACTIONS(3371),
    [anon_sym_u_DQUOTE] = ACTIONS(3371),
    [anon_sym_U_DQUOTE] = ACTIONS(3371),
    [anon_sym_u8_DQUOTE] = ACTIONS(3371),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [sym_true] = ACTIONS(3373),
    [sym_false] = ACTIONS(3373),
    [anon_sym_NULL] = ACTIONS(3373),
    [anon_sym_nullptr] = ACTIONS(3373),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3373),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_explicit] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3373),
    [anon_sym_export] = ACTIONS(3373),
    [anon_sym_module] = ACTIONS(3373),
    [anon_sym_import] = ACTIONS(3373),
    [anon_sym_template] = ACTIONS(3373),
    [anon_sym_operator] = ACTIONS(3373),
    [anon_sym_try] = ACTIONS(3373),
    [anon_sym_delete] = ACTIONS(3373),
    [anon_sym_throw] = ACTIONS(3373),
    [anon_sym_namespace] = ACTIONS(3373),
    [anon_sym_static_assert] = ACTIONS(3373),
    [anon_sym_concept] = ACTIONS(3373),
    [anon_sym_co_return] = ACTIONS(3373),
    [anon_sym_co_yield] = ACTIONS(3373),
    [anon_sym_R_DQUOTE] = ACTIONS(3371),
    [anon_sym_LR_DQUOTE] = ACTIONS(3371),
    [anon_sym_uR_DQUOTE] = ACTIONS(3371),
    [anon_sym_UR_DQUOTE] = ACTIONS(3371),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3371),
    [anon_sym_co_await] = ACTIONS(3373),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_requires] = ACTIONS(3373),
    [sym_this] = ACTIONS(3373),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(2813),
    [sym_identifier] = ACTIONS(2811),
    [aux_sym_preproc_include_token1] = ACTIONS(2811),
    [aux_sym_preproc_def_token1] = ACTIONS(2811),
    [aux_sym_preproc_if_token1] = ACTIONS(2811),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2811),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2811),
    [sym_preproc_directive] = ACTIONS(2811),
    [anon_sym_LPAREN2] = ACTIONS(2813),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_TILDE] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym_SEMI] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2811),
    [anon_sym_typedef] = ACTIONS(2811),
    [anon_sym_virtual] = ACTIONS(2811),
    [anon_sym_extern] = ACTIONS(2811),
    [anon_sym___attribute__] = ACTIONS(2811),
    [anon_sym___attribute] = ACTIONS(2811),
    [anon_sym_using] = ACTIONS(2811),
    [anon_sym_COLON_COLON] = ACTIONS(2813),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2813),
    [anon_sym___declspec] = ACTIONS(2811),
    [anon_sym___based] = ACTIONS(2811),
    [anon_sym___cdecl] = ACTIONS(2811),
    [anon_sym___clrcall] = ACTIONS(2811),
    [anon_sym___stdcall] = ACTIONS(2811),
    [anon_sym___fastcall] = ACTIONS(2811),
    [anon_sym___thiscall] = ACTIONS(2811),
    [anon_sym___vectorcall] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2813),
    [anon_sym_signed] = ACTIONS(2811),
    [anon_sym_unsigned] = ACTIONS(2811),
    [anon_sym_long] = ACTIONS(2811),
    [anon_sym_short] = ACTIONS(2811),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_static] = ACTIONS(2811),
    [anon_sym_register] = ACTIONS(2811),
    [anon_sym_inline] = ACTIONS(2811),
    [anon_sym___inline] = ACTIONS(2811),
    [anon_sym___inline__] = ACTIONS(2811),
    [anon_sym___forceinline] = ACTIONS(2811),
    [anon_sym_thread_local] = ACTIONS(2811),
    [anon_sym___thread] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_constexpr] = ACTIONS(2811),
    [anon_sym_volatile] = ACTIONS(2811),
    [anon_sym_restrict] = ACTIONS(2811),
    [anon_sym___restrict__] = ACTIONS(2811),
    [anon_sym__Atomic] = ACTIONS(2811),
    [anon_sym__Noreturn] = ACTIONS(2811),
    [anon_sym_noreturn] = ACTIONS(2811),
    [anon_sym__Nonnull] = ACTIONS(2811),
    [anon_sym_mutable] = ACTIONS(2811),
    [anon_sym_constinit] = ACTIONS(2811),
    [anon_sym_consteval] = ACTIONS(2811),
    [anon_sym_alignas] = ACTIONS(2811),
    [anon_sym__Alignas] = ACTIONS(2811),
    [sym_primitive_type] = ACTIONS(2811),
    [anon_sym_enum] = ACTIONS(2811),
    [anon_sym_class] = ACTIONS(2811),
    [anon_sym_struct] = ACTIONS(2811),
    [anon_sym_union] = ACTIONS(2811),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_switch] = ACTIONS(2811),
    [anon_sym_case] = ACTIONS(2811),
    [anon_sym_default] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [anon_sym_do] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_break] = ACTIONS(2811),
    [anon_sym_continue] = ACTIONS(2811),
    [anon_sym_goto] = ACTIONS(2811),
    [anon_sym_not] = ACTIONS(2811),
    [anon_sym_compl] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2813),
    [anon_sym_sizeof] = ACTIONS(2811),
    [anon_sym___alignof__] = ACTIONS(2811),
    [anon_sym___alignof] = ACTIONS(2811),
    [anon_sym__alignof] = ACTIONS(2811),
    [anon_sym_alignof] = ACTIONS(2811),
    [anon_sym__Alignof] = ACTIONS(2811),
    [anon_sym_offsetof] = ACTIONS(2811),
    [anon_sym__Generic] = ACTIONS(2811),
    [anon_sym_asm] = ACTIONS(2811),
    [anon_sym___asm__] = ACTIONS(2811),
    [anon_sym___asm] = ACTIONS(2811),
    [sym_number_literal] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2813),
    [anon_sym_u_SQUOTE] = ACTIONS(2813),
    [anon_sym_U_SQUOTE] = ACTIONS(2813),
    [anon_sym_u8_SQUOTE] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2813),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2811),
    [sym_false] = ACTIONS(2811),
    [anon_sym_NULL] = ACTIONS(2811),
    [anon_sym_nullptr] = ACTIONS(2811),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2811),
    [anon_sym_decltype] = ACTIONS(2811),
    [anon_sym_explicit] = ACTIONS(2811),
    [anon_sym_typename] = ACTIONS(2811),
    [anon_sym_export] = ACTIONS(2811),
    [anon_sym_module] = ACTIONS(2811),
    [anon_sym_import] = ACTIONS(2811),
    [anon_sym_template] = ACTIONS(2811),
    [anon_sym_operator] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_delete] = ACTIONS(2811),
    [anon_sym_throw] = ACTIONS(2811),
    [anon_sym_namespace] = ACTIONS(2811),
    [anon_sym_static_assert] = ACTIONS(2811),
    [anon_sym_concept] = ACTIONS(2811),
    [anon_sym_co_return] = ACTIONS(2811),
    [anon_sym_co_yield] = ACTIONS(2811),
    [anon_sym_R_DQUOTE] = ACTIONS(2813),
    [anon_sym_LR_DQUOTE] = ACTIONS(2813),
    [anon_sym_uR_DQUOTE] = ACTIONS(2813),
    [anon_sym_UR_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2813),
    [anon_sym_co_await] = ACTIONS(2811),
    [anon_sym_new] = ACTIONS(2811),
    [anon_sym_requires] = ACTIONS(2811),
    [sym_this] = ACTIONS(2811),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(2953),
    [sym_identifier] = ACTIONS(2951),
    [aux_sym_preproc_include_token1] = ACTIONS(2951),
    [aux_sym_preproc_def_token1] = ACTIONS(2951),
    [aux_sym_preproc_if_token1] = ACTIONS(2951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2951),
    [sym_preproc_directive] = ACTIONS(2951),
    [anon_sym_LPAREN2] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_TILDE] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_AMP_AMP] = ACTIONS(2953),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2953),
    [anon_sym___extension__] = ACTIONS(2951),
    [anon_sym_typedef] = ACTIONS(2951),
    [anon_sym_virtual] = ACTIONS(2951),
    [anon_sym_extern] = ACTIONS(2951),
    [anon_sym___attribute__] = ACTIONS(2951),
    [anon_sym___attribute] = ACTIONS(2951),
    [anon_sym_using] = ACTIONS(2951),
    [anon_sym_COLON_COLON] = ACTIONS(2953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2953),
    [anon_sym___declspec] = ACTIONS(2951),
    [anon_sym___based] = ACTIONS(2951),
    [anon_sym___cdecl] = ACTIONS(2951),
    [anon_sym___clrcall] = ACTIONS(2951),
    [anon_sym___stdcall] = ACTIONS(2951),
    [anon_sym___fastcall] = ACTIONS(2951),
    [anon_sym___thiscall] = ACTIONS(2951),
    [anon_sym___vectorcall] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2953),
    [anon_sym_signed] = ACTIONS(2951),
    [anon_sym_unsigned] = ACTIONS(2951),
    [anon_sym_long] = ACTIONS(2951),
    [anon_sym_short] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_static] = ACTIONS(2951),
    [anon_sym_register] = ACTIONS(2951),
    [anon_sym_inline] = ACTIONS(2951),
    [anon_sym___inline] = ACTIONS(2951),
    [anon_sym___inline__] = ACTIONS(2951),
    [anon_sym___forceinline] = ACTIONS(2951),
    [anon_sym_thread_local] = ACTIONS(2951),
    [anon_sym___thread] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_constexpr] = ACTIONS(2951),
    [anon_sym_volatile] = ACTIONS(2951),
    [anon_sym_restrict] = ACTIONS(2951),
    [anon_sym___restrict__] = ACTIONS(2951),
    [anon_sym__Atomic] = ACTIONS(2951),
    [anon_sym__Noreturn] = ACTIONS(2951),
    [anon_sym_noreturn] = ACTIONS(2951),
    [anon_sym__Nonnull] = ACTIONS(2951),
    [anon_sym_mutable] = ACTIONS(2951),
    [anon_sym_constinit] = ACTIONS(2951),
    [anon_sym_consteval] = ACTIONS(2951),
    [anon_sym_alignas] = ACTIONS(2951),
    [anon_sym__Alignas] = ACTIONS(2951),
    [sym_primitive_type] = ACTIONS(2951),
    [anon_sym_enum] = ACTIONS(2951),
    [anon_sym_class] = ACTIONS(2951),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_union] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_switch] = ACTIONS(2951),
    [anon_sym_case] = ACTIONS(2951),
    [anon_sym_default] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2951),
    [anon_sym_do] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_goto] = ACTIONS(2951),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_compl] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2951),
    [anon_sym___alignof__] = ACTIONS(2951),
    [anon_sym___alignof] = ACTIONS(2951),
    [anon_sym__alignof] = ACTIONS(2951),
    [anon_sym_alignof] = ACTIONS(2951),
    [anon_sym__Alignof] = ACTIONS(2951),
    [anon_sym_offsetof] = ACTIONS(2951),
    [anon_sym__Generic] = ACTIONS(2951),
    [anon_sym_asm] = ACTIONS(2951),
    [anon_sym___asm__] = ACTIONS(2951),
    [anon_sym___asm] = ACTIONS(2951),
    [sym_number_literal] = ACTIONS(2953),
    [anon_sym_L_SQUOTE] = ACTIONS(2953),
    [anon_sym_u_SQUOTE] = ACTIONS(2953),
    [anon_sym_U_SQUOTE] = ACTIONS(2953),
    [anon_sym_u8_SQUOTE] = ACTIONS(2953),
    [anon_sym_SQUOTE] = ACTIONS(2953),
    [anon_sym_L_DQUOTE] = ACTIONS(2953),
    [anon_sym_u_DQUOTE] = ACTIONS(2953),
    [anon_sym_U_DQUOTE] = ACTIONS(2953),
    [anon_sym_u8_DQUOTE] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(2953),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [anon_sym_NULL] = ACTIONS(2951),
    [anon_sym_nullptr] = ACTIONS(2951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2951),
    [anon_sym_decltype] = ACTIONS(2951),
    [anon_sym_explicit] = ACTIONS(2951),
    [anon_sym_typename] = ACTIONS(2951),
    [anon_sym_export] = ACTIONS(2951),
    [anon_sym_module] = ACTIONS(2951),
    [anon_sym_import] = ACTIONS(2951),
    [anon_sym_template] = ACTIONS(2951),
    [anon_sym_operator] = ACTIONS(2951),
    [anon_sym_try] = ACTIONS(2951),
    [anon_sym_delete] = ACTIONS(2951),
    [anon_sym_throw] = ACTIONS(2951),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_static_assert] = ACTIONS(2951),
    [anon_sym_concept] = ACTIONS(2951),
    [anon_sym_co_return] = ACTIONS(2951),
    [anon_sym_co_yield] = ACTIONS(2951),
    [anon_sym_R_DQUOTE] = ACTIONS(2953),
    [anon_sym_LR_DQUOTE] = ACTIONS(2953),
    [anon_sym_uR_DQUOTE] = ACTIONS(2953),
    [anon_sym_UR_DQUOTE] = ACTIONS(2953),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2953),
    [anon_sym_co_await] = ACTIONS(2951),
    [anon_sym_new] = ACTIONS(2951),
    [anon_sym_requires] = ACTIONS(2951),
    [sym_this] = ACTIONS(2951),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2879),
    [aux_sym_preproc_include_token1] = ACTIONS(2879),
    [aux_sym_preproc_def_token1] = ACTIONS(2879),
    [aux_sym_preproc_if_token1] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2879),
    [sym_preproc_directive] = ACTIONS(2879),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2879),
    [anon_sym_typedef] = ACTIONS(2879),
    [anon_sym_virtual] = ACTIONS(2879),
    [anon_sym_extern] = ACTIONS(2879),
    [anon_sym___attribute__] = ACTIONS(2879),
    [anon_sym___attribute] = ACTIONS(2879),
    [anon_sym_using] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2879),
    [anon_sym___based] = ACTIONS(2879),
    [anon_sym___cdecl] = ACTIONS(2879),
    [anon_sym___clrcall] = ACTIONS(2879),
    [anon_sym___stdcall] = ACTIONS(2879),
    [anon_sym___fastcall] = ACTIONS(2879),
    [anon_sym___thiscall] = ACTIONS(2879),
    [anon_sym___vectorcall] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2879),
    [anon_sym_unsigned] = ACTIONS(2879),
    [anon_sym_long] = ACTIONS(2879),
    [anon_sym_short] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_static] = ACTIONS(2879),
    [anon_sym_register] = ACTIONS(2879),
    [anon_sym_inline] = ACTIONS(2879),
    [anon_sym___inline] = ACTIONS(2879),
    [anon_sym___inline__] = ACTIONS(2879),
    [anon_sym___forceinline] = ACTIONS(2879),
    [anon_sym_thread_local] = ACTIONS(2879),
    [anon_sym___thread] = ACTIONS(2879),
    [anon_sym_const] = ACTIONS(2879),
    [anon_sym_constexpr] = ACTIONS(2879),
    [anon_sym_volatile] = ACTIONS(2879),
    [anon_sym_restrict] = ACTIONS(2879),
    [anon_sym___restrict__] = ACTIONS(2879),
    [anon_sym__Atomic] = ACTIONS(2879),
    [anon_sym__Noreturn] = ACTIONS(2879),
    [anon_sym_noreturn] = ACTIONS(2879),
    [anon_sym__Nonnull] = ACTIONS(2879),
    [anon_sym_mutable] = ACTIONS(2879),
    [anon_sym_constinit] = ACTIONS(2879),
    [anon_sym_consteval] = ACTIONS(2879),
    [anon_sym_alignas] = ACTIONS(2879),
    [anon_sym__Alignas] = ACTIONS(2879),
    [sym_primitive_type] = ACTIONS(2879),
    [anon_sym_enum] = ACTIONS(2879),
    [anon_sym_class] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2879),
    [anon_sym_union] = ACTIONS(2879),
    [anon_sym_if] = ACTIONS(2879),
    [anon_sym_switch] = ACTIONS(2879),
    [anon_sym_case] = ACTIONS(2879),
    [anon_sym_default] = ACTIONS(2879),
    [anon_sym_while] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2879),
    [anon_sym_return] = ACTIONS(2879),
    [anon_sym_break] = ACTIONS(2879),
    [anon_sym_continue] = ACTIONS(2879),
    [anon_sym_goto] = ACTIONS(2879),
    [anon_sym_not] = ACTIONS(2879),
    [anon_sym_compl] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2879),
    [anon_sym___alignof__] = ACTIONS(2879),
    [anon_sym___alignof] = ACTIONS(2879),
    [anon_sym__alignof] = ACTIONS(2879),
    [anon_sym_alignof] = ACTIONS(2879),
    [anon_sym__Alignof] = ACTIONS(2879),
    [anon_sym_offsetof] = ACTIONS(2879),
    [anon_sym__Generic] = ACTIONS(2879),
    [anon_sym_asm] = ACTIONS(2879),
    [anon_sym___asm__] = ACTIONS(2879),
    [anon_sym___asm] = ACTIONS(2879),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2879),
    [sym_false] = ACTIONS(2879),
    [anon_sym_NULL] = ACTIONS(2879),
    [anon_sym_nullptr] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2879),
    [anon_sym_decltype] = ACTIONS(2879),
    [anon_sym_explicit] = ACTIONS(2879),
    [anon_sym_typename] = ACTIONS(2879),
    [anon_sym_export] = ACTIONS(2879),
    [anon_sym_module] = ACTIONS(2879),
    [anon_sym_import] = ACTIONS(2879),
    [anon_sym_template] = ACTIONS(2879),
    [anon_sym_operator] = ACTIONS(2879),
    [anon_sym_try] = ACTIONS(2879),
    [anon_sym_delete] = ACTIONS(2879),
    [anon_sym_throw] = ACTIONS(2879),
    [anon_sym_namespace] = ACTIONS(2879),
    [anon_sym_static_assert] = ACTIONS(2879),
    [anon_sym_concept] = ACTIONS(2879),
    [anon_sym_co_return] = ACTIONS(2879),
    [anon_sym_co_yield] = ACTIONS(2879),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2879),
    [anon_sym_requires] = ACTIONS(2879),
    [sym_this] = ACTIONS(2879),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(2865),
    [sym_identifier] = ACTIONS(2863),
    [aux_sym_preproc_include_token1] = ACTIONS(2863),
    [aux_sym_preproc_def_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token1] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2863),
    [sym_preproc_directive] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym___extension__] = ACTIONS(2863),
    [anon_sym_typedef] = ACTIONS(2863),
    [anon_sym_virtual] = ACTIONS(2863),
    [anon_sym_extern] = ACTIONS(2863),
    [anon_sym___attribute__] = ACTIONS(2863),
    [anon_sym___attribute] = ACTIONS(2863),
    [anon_sym_using] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2865),
    [anon_sym___declspec] = ACTIONS(2863),
    [anon_sym___based] = ACTIONS(2863),
    [anon_sym___cdecl] = ACTIONS(2863),
    [anon_sym___clrcall] = ACTIONS(2863),
    [anon_sym___stdcall] = ACTIONS(2863),
    [anon_sym___fastcall] = ACTIONS(2863),
    [anon_sym___thiscall] = ACTIONS(2863),
    [anon_sym___vectorcall] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_signed] = ACTIONS(2863),
    [anon_sym_unsigned] = ACTIONS(2863),
    [anon_sym_long] = ACTIONS(2863),
    [anon_sym_short] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_static] = ACTIONS(2863),
    [anon_sym_register] = ACTIONS(2863),
    [anon_sym_inline] = ACTIONS(2863),
    [anon_sym___inline] = ACTIONS(2863),
    [anon_sym___inline__] = ACTIONS(2863),
    [anon_sym___forceinline] = ACTIONS(2863),
    [anon_sym_thread_local] = ACTIONS(2863),
    [anon_sym___thread] = ACTIONS(2863),
    [anon_sym_const] = ACTIONS(2863),
    [anon_sym_constexpr] = ACTIONS(2863),
    [anon_sym_volatile] = ACTIONS(2863),
    [anon_sym_restrict] = ACTIONS(2863),
    [anon_sym___restrict__] = ACTIONS(2863),
    [anon_sym__Atomic] = ACTIONS(2863),
    [anon_sym__Noreturn] = ACTIONS(2863),
    [anon_sym_noreturn] = ACTIONS(2863),
    [anon_sym__Nonnull] = ACTIONS(2863),
    [anon_sym_mutable] = ACTIONS(2863),
    [anon_sym_constinit] = ACTIONS(2863),
    [anon_sym_consteval] = ACTIONS(2863),
    [anon_sym_alignas] = ACTIONS(2863),
    [anon_sym__Alignas] = ACTIONS(2863),
    [sym_primitive_type] = ACTIONS(2863),
    [anon_sym_enum] = ACTIONS(2863),
    [anon_sym_class] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2863),
    [anon_sym_union] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_switch] = ACTIONS(2863),
    [anon_sym_case] = ACTIONS(2863),
    [anon_sym_default] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_break] = ACTIONS(2863),
    [anon_sym_continue] = ACTIONS(2863),
    [anon_sym_goto] = ACTIONS(2863),
    [anon_sym_not] = ACTIONS(2863),
    [anon_sym_compl] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_sizeof] = ACTIONS(2863),
    [anon_sym___alignof__] = ACTIONS(2863),
    [anon_sym___alignof] = ACTIONS(2863),
    [anon_sym__alignof] = ACTIONS(2863),
    [anon_sym_alignof] = ACTIONS(2863),
    [anon_sym__Alignof] = ACTIONS(2863),
    [anon_sym_offsetof] = ACTIONS(2863),
    [anon_sym__Generic] = ACTIONS(2863),
    [anon_sym_asm] = ACTIONS(2863),
    [anon_sym___asm__] = ACTIONS(2863),
    [anon_sym___asm] = ACTIONS(2863),
    [sym_number_literal] = ACTIONS(2865),
    [anon_sym_L_SQUOTE] = ACTIONS(2865),
    [anon_sym_u_SQUOTE] = ACTIONS(2865),
    [anon_sym_U_SQUOTE] = ACTIONS(2865),
    [anon_sym_u8_SQUOTE] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_L_DQUOTE] = ACTIONS(2865),
    [anon_sym_u_DQUOTE] = ACTIONS(2865),
    [anon_sym_U_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [sym_true] = ACTIONS(2863),
    [sym_false] = ACTIONS(2863),
    [anon_sym_NULL] = ACTIONS(2863),
    [anon_sym_nullptr] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2863),
    [anon_sym_decltype] = ACTIONS(2863),
    [anon_sym_explicit] = ACTIONS(2863),
    [anon_sym_typename] = ACTIONS(2863),
    [anon_sym_export] = ACTIONS(2863),
    [anon_sym_module] = ACTIONS(2863),
    [anon_sym_import] = ACTIONS(2863),
    [anon_sym_template] = ACTIONS(2863),
    [anon_sym_operator] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_throw] = ACTIONS(2863),
    [anon_sym_namespace] = ACTIONS(2863),
    [anon_sym_static_assert] = ACTIONS(2863),
    [anon_sym_concept] = ACTIONS(2863),
    [anon_sym_co_return] = ACTIONS(2863),
    [anon_sym_co_yield] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2863),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_requires] = ACTIONS(2863),
    [sym_this] = ACTIONS(2863),
  },
  [488] = {
    [sym_identifier] = ACTIONS(2743),
    [aux_sym_preproc_include_token1] = ACTIONS(2743),
    [aux_sym_preproc_def_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2743),
    [sym_preproc_directive] = ACTIONS(2743),
    [anon_sym_LPAREN2] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym___extension__] = ACTIONS(2743),
    [anon_sym_typedef] = ACTIONS(2743),
    [anon_sym_virtual] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym___attribute__] = ACTIONS(2743),
    [anon_sym___attribute] = ACTIONS(2743),
    [anon_sym_using] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(2745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2745),
    [anon_sym___declspec] = ACTIONS(2743),
    [anon_sym___based] = ACTIONS(2743),
    [anon_sym___cdecl] = ACTIONS(2743),
    [anon_sym___clrcall] = ACTIONS(2743),
    [anon_sym___stdcall] = ACTIONS(2743),
    [anon_sym___fastcall] = ACTIONS(2743),
    [anon_sym___thiscall] = ACTIONS(2743),
    [anon_sym___vectorcall] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_RBRACE] = ACTIONS(2745),
    [anon_sym_signed] = ACTIONS(2743),
    [anon_sym_unsigned] = ACTIONS(2743),
    [anon_sym_long] = ACTIONS(2743),
    [anon_sym_short] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_register] = ACTIONS(2743),
    [anon_sym_inline] = ACTIONS(2743),
    [anon_sym___inline] = ACTIONS(2743),
    [anon_sym___inline__] = ACTIONS(2743),
    [anon_sym___forceinline] = ACTIONS(2743),
    [anon_sym_thread_local] = ACTIONS(2743),
    [anon_sym___thread] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_constexpr] = ACTIONS(2743),
    [anon_sym_volatile] = ACTIONS(2743),
    [anon_sym_restrict] = ACTIONS(2743),
    [anon_sym___restrict__] = ACTIONS(2743),
    [anon_sym__Atomic] = ACTIONS(2743),
    [anon_sym__Noreturn] = ACTIONS(2743),
    [anon_sym_noreturn] = ACTIONS(2743),
    [anon_sym__Nonnull] = ACTIONS(2743),
    [anon_sym_mutable] = ACTIONS(2743),
    [anon_sym_constinit] = ACTIONS(2743),
    [anon_sym_consteval] = ACTIONS(2743),
    [anon_sym_alignas] = ACTIONS(2743),
    [anon_sym__Alignas] = ACTIONS(2743),
    [sym_primitive_type] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2743),
    [anon_sym_switch] = ACTIONS(2743),
    [anon_sym_case] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_goto] = ACTIONS(2743),
    [anon_sym___try] = ACTIONS(2743),
    [anon_sym___leave] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2743),
    [anon_sym_compl] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2745),
    [anon_sym_sizeof] = ACTIONS(2743),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2743),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2743),
    [anon_sym___asm__] = ACTIONS(2743),
    [anon_sym___asm] = ACTIONS(2743),
    [sym_number_literal] = ACTIONS(2745),
    [anon_sym_L_SQUOTE] = ACTIONS(2745),
    [anon_sym_u_SQUOTE] = ACTIONS(2745),
    [anon_sym_U_SQUOTE] = ACTIONS(2745),
    [anon_sym_u8_SQUOTE] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2745),
    [anon_sym_L_DQUOTE] = ACTIONS(2745),
    [anon_sym_u_DQUOTE] = ACTIONS(2745),
    [anon_sym_U_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8_DQUOTE] = ACTIONS(2745),
    [anon_sym_DQUOTE] = ACTIONS(2745),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [anon_sym_NULL] = ACTIONS(2743),
    [anon_sym_nullptr] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2743),
    [anon_sym_decltype] = ACTIONS(2743),
    [anon_sym_explicit] = ACTIONS(2743),
    [anon_sym_typename] = ACTIONS(2743),
    [anon_sym_template] = ACTIONS(2743),
    [anon_sym_operator] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [anon_sym_delete] = ACTIONS(2743),
    [anon_sym_throw] = ACTIONS(2743),
    [anon_sym_namespace] = ACTIONS(2743),
    [anon_sym_static_assert] = ACTIONS(2743),
    [anon_sym_concept] = ACTIONS(2743),
    [anon_sym_co_return] = ACTIONS(2743),
    [anon_sym_co_yield] = ACTIONS(2743),
    [anon_sym_R_DQUOTE] = ACTIONS(2745),
    [anon_sym_LR_DQUOTE] = ACTIONS(2745),
    [anon_sym_uR_DQUOTE] = ACTIONS(2745),
    [anon_sym_UR_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2745),
    [anon_sym_co_await] = ACTIONS(2743),
    [anon_sym_new] = ACTIONS(2743),
    [anon_sym_requires] = ACTIONS(2743),
    [sym_this] = ACTIONS(2743),
  },
  [489] = {
    [ts_builtin_sym_end] = ACTIONS(2957),
    [sym_identifier] = ACTIONS(2955),
    [aux_sym_preproc_include_token1] = ACTIONS(2955),
    [aux_sym_preproc_def_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token1] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2955),
    [sym_preproc_directive] = ACTIONS(2955),
    [anon_sym_LPAREN2] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2955),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym___extension__] = ACTIONS(2955),
    [anon_sym_typedef] = ACTIONS(2955),
    [anon_sym_virtual] = ACTIONS(2955),
    [anon_sym_extern] = ACTIONS(2955),
    [anon_sym___attribute__] = ACTIONS(2955),
    [anon_sym___attribute] = ACTIONS(2955),
    [anon_sym_using] = ACTIONS(2955),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2957),
    [anon_sym___declspec] = ACTIONS(2955),
    [anon_sym___based] = ACTIONS(2955),
    [anon_sym___cdecl] = ACTIONS(2955),
    [anon_sym___clrcall] = ACTIONS(2955),
    [anon_sym___stdcall] = ACTIONS(2955),
    [anon_sym___fastcall] = ACTIONS(2955),
    [anon_sym___thiscall] = ACTIONS(2955),
    [anon_sym___vectorcall] = ACTIONS(2955),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_signed] = ACTIONS(2955),
    [anon_sym_unsigned] = ACTIONS(2955),
    [anon_sym_long] = ACTIONS(2955),
    [anon_sym_short] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_register] = ACTIONS(2955),
    [anon_sym_inline] = ACTIONS(2955),
    [anon_sym___inline] = ACTIONS(2955),
    [anon_sym___inline__] = ACTIONS(2955),
    [anon_sym___forceinline] = ACTIONS(2955),
    [anon_sym_thread_local] = ACTIONS(2955),
    [anon_sym___thread] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_constexpr] = ACTIONS(2955),
    [anon_sym_volatile] = ACTIONS(2955),
    [anon_sym_restrict] = ACTIONS(2955),
    [anon_sym___restrict__] = ACTIONS(2955),
    [anon_sym__Atomic] = ACTIONS(2955),
    [anon_sym__Noreturn] = ACTIONS(2955),
    [anon_sym_noreturn] = ACTIONS(2955),
    [anon_sym__Nonnull] = ACTIONS(2955),
    [anon_sym_mutable] = ACTIONS(2955),
    [anon_sym_constinit] = ACTIONS(2955),
    [anon_sym_consteval] = ACTIONS(2955),
    [anon_sym_alignas] = ACTIONS(2955),
    [anon_sym__Alignas] = ACTIONS(2955),
    [sym_primitive_type] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2955),
    [anon_sym_union] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2955),
    [anon_sym_switch] = ACTIONS(2955),
    [anon_sym_case] = ACTIONS(2955),
    [anon_sym_default] = ACTIONS(2955),
    [anon_sym_while] = ACTIONS(2955),
    [anon_sym_do] = ACTIONS(2955),
    [anon_sym_for] = ACTIONS(2955),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_break] = ACTIONS(2955),
    [anon_sym_continue] = ACTIONS(2955),
    [anon_sym_goto] = ACTIONS(2955),
    [anon_sym_not] = ACTIONS(2955),
    [anon_sym_compl] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_sizeof] = ACTIONS(2955),
    [anon_sym___alignof__] = ACTIONS(2955),
    [anon_sym___alignof] = ACTIONS(2955),
    [anon_sym__alignof] = ACTIONS(2955),
    [anon_sym_alignof] = ACTIONS(2955),
    [anon_sym__Alignof] = ACTIONS(2955),
    [anon_sym_offsetof] = ACTIONS(2955),
    [anon_sym__Generic] = ACTIONS(2955),
    [anon_sym_asm] = ACTIONS(2955),
    [anon_sym___asm__] = ACTIONS(2955),
    [anon_sym___asm] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(2957),
    [anon_sym_L_SQUOTE] = ACTIONS(2957),
    [anon_sym_u_SQUOTE] = ACTIONS(2957),
    [anon_sym_U_SQUOTE] = ACTIONS(2957),
    [anon_sym_u8_SQUOTE] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2955),
    [sym_false] = ACTIONS(2955),
    [anon_sym_NULL] = ACTIONS(2955),
    [anon_sym_nullptr] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2955),
    [anon_sym_decltype] = ACTIONS(2955),
    [anon_sym_explicit] = ACTIONS(2955),
    [anon_sym_typename] = ACTIONS(2955),
    [anon_sym_export] = ACTIONS(2955),
    [anon_sym_module] = ACTIONS(2955),
    [anon_sym_import] = ACTIONS(2955),
    [anon_sym_template] = ACTIONS(2955),
    [anon_sym_operator] = ACTIONS(2955),
    [anon_sym_try] = ACTIONS(2955),
    [anon_sym_delete] = ACTIONS(2955),
    [anon_sym_throw] = ACTIONS(2955),
    [anon_sym_namespace] = ACTIONS(2955),
    [anon_sym_static_assert] = ACTIONS(2955),
    [anon_sym_concept] = ACTIONS(2955),
    [anon_sym_co_return] = ACTIONS(2955),
    [anon_sym_co_yield] = ACTIONS(2955),
    [anon_sym_R_DQUOTE] = ACTIONS(2957),
    [anon_sym_LR_DQUOTE] = ACTIONS(2957),
    [anon_sym_uR_DQUOTE] = ACTIONS(2957),
    [anon_sym_UR_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2957),
    [anon_sym_co_await] = ACTIONS(2955),
    [anon_sym_new] = ACTIONS(2955),
    [anon_sym_requires] = ACTIONS(2955),
    [sym_this] = ACTIONS(2955),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(2817),
    [sym_identifier] = ACTIONS(2815),
    [aux_sym_preproc_include_token1] = ACTIONS(2815),
    [aux_sym_preproc_def_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token1] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2815),
    [sym_preproc_directive] = ACTIONS(2815),
    [anon_sym_LPAREN2] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_TILDE] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym___extension__] = ACTIONS(2815),
    [anon_sym_typedef] = ACTIONS(2815),
    [anon_sym_virtual] = ACTIONS(2815),
    [anon_sym_extern] = ACTIONS(2815),
    [anon_sym___attribute__] = ACTIONS(2815),
    [anon_sym___attribute] = ACTIONS(2815),
    [anon_sym_using] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2817),
    [anon_sym___declspec] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(2815),
    [anon_sym___cdecl] = ACTIONS(2815),
    [anon_sym___clrcall] = ACTIONS(2815),
    [anon_sym___stdcall] = ACTIONS(2815),
    [anon_sym___fastcall] = ACTIONS(2815),
    [anon_sym___thiscall] = ACTIONS(2815),
    [anon_sym___vectorcall] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2817),
    [anon_sym_signed] = ACTIONS(2815),
    [anon_sym_unsigned] = ACTIONS(2815),
    [anon_sym_long] = ACTIONS(2815),
    [anon_sym_short] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2815),
    [anon_sym_register] = ACTIONS(2815),
    [anon_sym_inline] = ACTIONS(2815),
    [anon_sym___inline] = ACTIONS(2815),
    [anon_sym___inline__] = ACTIONS(2815),
    [anon_sym___forceinline] = ACTIONS(2815),
    [anon_sym_thread_local] = ACTIONS(2815),
    [anon_sym___thread] = ACTIONS(2815),
    [anon_sym_const] = ACTIONS(2815),
    [anon_sym_constexpr] = ACTIONS(2815),
    [anon_sym_volatile] = ACTIONS(2815),
    [anon_sym_restrict] = ACTIONS(2815),
    [anon_sym___restrict__] = ACTIONS(2815),
    [anon_sym__Atomic] = ACTIONS(2815),
    [anon_sym__Noreturn] = ACTIONS(2815),
    [anon_sym_noreturn] = ACTIONS(2815),
    [anon_sym__Nonnull] = ACTIONS(2815),
    [anon_sym_mutable] = ACTIONS(2815),
    [anon_sym_constinit] = ACTIONS(2815),
    [anon_sym_consteval] = ACTIONS(2815),
    [anon_sym_alignas] = ACTIONS(2815),
    [anon_sym__Alignas] = ACTIONS(2815),
    [sym_primitive_type] = ACTIONS(2815),
    [anon_sym_enum] = ACTIONS(2815),
    [anon_sym_class] = ACTIONS(2815),
    [anon_sym_struct] = ACTIONS(2815),
    [anon_sym_union] = ACTIONS(2815),
    [anon_sym_if] = ACTIONS(2815),
    [anon_sym_switch] = ACTIONS(2815),
    [anon_sym_case] = ACTIONS(2815),
    [anon_sym_default] = ACTIONS(2815),
    [anon_sym_while] = ACTIONS(2815),
    [anon_sym_do] = ACTIONS(2815),
    [anon_sym_for] = ACTIONS(2815),
    [anon_sym_return] = ACTIONS(2815),
    [anon_sym_break] = ACTIONS(2815),
    [anon_sym_continue] = ACTIONS(2815),
    [anon_sym_goto] = ACTIONS(2815),
    [anon_sym_not] = ACTIONS(2815),
    [anon_sym_compl] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2817),
    [anon_sym_sizeof] = ACTIONS(2815),
    [anon_sym___alignof__] = ACTIONS(2815),
    [anon_sym___alignof] = ACTIONS(2815),
    [anon_sym__alignof] = ACTIONS(2815),
    [anon_sym_alignof] = ACTIONS(2815),
    [anon_sym__Alignof] = ACTIONS(2815),
    [anon_sym_offsetof] = ACTIONS(2815),
    [anon_sym__Generic] = ACTIONS(2815),
    [anon_sym_asm] = ACTIONS(2815),
    [anon_sym___asm__] = ACTIONS(2815),
    [anon_sym___asm] = ACTIONS(2815),
    [sym_number_literal] = ACTIONS(2817),
    [anon_sym_L_SQUOTE] = ACTIONS(2817),
    [anon_sym_u_SQUOTE] = ACTIONS(2817),
    [anon_sym_U_SQUOTE] = ACTIONS(2817),
    [anon_sym_u8_SQUOTE] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_L_DQUOTE] = ACTIONS(2817),
    [anon_sym_u_DQUOTE] = ACTIONS(2817),
    [anon_sym_U_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8_DQUOTE] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(2817),
    [sym_true] = ACTIONS(2815),
    [sym_false] = ACTIONS(2815),
    [anon_sym_NULL] = ACTIONS(2815),
    [anon_sym_nullptr] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2815),
    [anon_sym_decltype] = ACTIONS(2815),
    [anon_sym_explicit] = ACTIONS(2815),
    [anon_sym_typename] = ACTIONS(2815),
    [anon_sym_export] = ACTIONS(2815),
    [anon_sym_module] = ACTIONS(2815),
    [anon_sym_import] = ACTIONS(2815),
    [anon_sym_template] = ACTIONS(2815),
    [anon_sym_operator] = ACTIONS(2815),
    [anon_sym_try] = ACTIONS(2815),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_throw] = ACTIONS(2815),
    [anon_sym_namespace] = ACTIONS(2815),
    [anon_sym_static_assert] = ACTIONS(2815),
    [anon_sym_concept] = ACTIONS(2815),
    [anon_sym_co_return] = ACTIONS(2815),
    [anon_sym_co_yield] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2815),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_requires] = ACTIONS(2815),
    [sym_this] = ACTIONS(2815),
  },
  [491] = {
    [sym_identifier] = ACTIONS(2659),
    [aux_sym_preproc_include_token1] = ACTIONS(2659),
    [aux_sym_preproc_def_token1] = ACTIONS(2659),
    [aux_sym_preproc_if_token1] = ACTIONS(2659),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2659),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2659),
    [sym_preproc_directive] = ACTIONS(2659),
    [anon_sym_LPAREN2] = ACTIONS(2661),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym___extension__] = ACTIONS(2659),
    [anon_sym_typedef] = ACTIONS(2659),
    [anon_sym_virtual] = ACTIONS(2659),
    [anon_sym_extern] = ACTIONS(2659),
    [anon_sym___attribute__] = ACTIONS(2659),
    [anon_sym___attribute] = ACTIONS(2659),
    [anon_sym_using] = ACTIONS(2659),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2661),
    [anon_sym___declspec] = ACTIONS(2659),
    [anon_sym___based] = ACTIONS(2659),
    [anon_sym___cdecl] = ACTIONS(2659),
    [anon_sym___clrcall] = ACTIONS(2659),
    [anon_sym___stdcall] = ACTIONS(2659),
    [anon_sym___fastcall] = ACTIONS(2659),
    [anon_sym___thiscall] = ACTIONS(2659),
    [anon_sym___vectorcall] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_RBRACE] = ACTIONS(2661),
    [anon_sym_signed] = ACTIONS(2659),
    [anon_sym_unsigned] = ACTIONS(2659),
    [anon_sym_long] = ACTIONS(2659),
    [anon_sym_short] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2659),
    [anon_sym_register] = ACTIONS(2659),
    [anon_sym_inline] = ACTIONS(2659),
    [anon_sym___inline] = ACTIONS(2659),
    [anon_sym___inline__] = ACTIONS(2659),
    [anon_sym___forceinline] = ACTIONS(2659),
    [anon_sym_thread_local] = ACTIONS(2659),
    [anon_sym___thread] = ACTIONS(2659),
    [anon_sym_const] = ACTIONS(2659),
    [anon_sym_constexpr] = ACTIONS(2659),
    [anon_sym_volatile] = ACTIONS(2659),
    [anon_sym_restrict] = ACTIONS(2659),
    [anon_sym___restrict__] = ACTIONS(2659),
    [anon_sym__Atomic] = ACTIONS(2659),
    [anon_sym__Noreturn] = ACTIONS(2659),
    [anon_sym_noreturn] = ACTIONS(2659),
    [anon_sym__Nonnull] = ACTIONS(2659),
    [anon_sym_mutable] = ACTIONS(2659),
    [anon_sym_constinit] = ACTIONS(2659),
    [anon_sym_consteval] = ACTIONS(2659),
    [anon_sym_alignas] = ACTIONS(2659),
    [anon_sym__Alignas] = ACTIONS(2659),
    [sym_primitive_type] = ACTIONS(2659),
    [anon_sym_enum] = ACTIONS(2659),
    [anon_sym_class] = ACTIONS(2659),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_union] = ACTIONS(2659),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_else] = ACTIONS(2659),
    [anon_sym_switch] = ACTIONS(2659),
    [anon_sym_case] = ACTIONS(2659),
    [anon_sym_default] = ACTIONS(2659),
    [anon_sym_while] = ACTIONS(2659),
    [anon_sym_do] = ACTIONS(2659),
    [anon_sym_for] = ACTIONS(2659),
    [anon_sym_return] = ACTIONS(2659),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_continue] = ACTIONS(2659),
    [anon_sym_goto] = ACTIONS(2659),
    [anon_sym___try] = ACTIONS(2659),
    [anon_sym___leave] = ACTIONS(2659),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_compl] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2661),
    [anon_sym_PLUS_PLUS] = ACTIONS(2661),
    [anon_sym_sizeof] = ACTIONS(2659),
    [anon_sym___alignof__] = ACTIONS(2659),
    [anon_sym___alignof] = ACTIONS(2659),
    [anon_sym__alignof] = ACTIONS(2659),
    [anon_sym_alignof] = ACTIONS(2659),
    [anon_sym__Alignof] = ACTIONS(2659),
    [anon_sym_offsetof] = ACTIONS(2659),
    [anon_sym__Generic] = ACTIONS(2659),
    [anon_sym_asm] = ACTIONS(2659),
    [anon_sym___asm__] = ACTIONS(2659),
    [anon_sym___asm] = ACTIONS(2659),
    [sym_number_literal] = ACTIONS(2661),
    [anon_sym_L_SQUOTE] = ACTIONS(2661),
    [anon_sym_u_SQUOTE] = ACTIONS(2661),
    [anon_sym_U_SQUOTE] = ACTIONS(2661),
    [anon_sym_u8_SQUOTE] = ACTIONS(2661),
    [anon_sym_SQUOTE] = ACTIONS(2661),
    [anon_sym_L_DQUOTE] = ACTIONS(2661),
    [anon_sym_u_DQUOTE] = ACTIONS(2661),
    [anon_sym_U_DQUOTE] = ACTIONS(2661),
    [anon_sym_u8_DQUOTE] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [anon_sym_NULL] = ACTIONS(2659),
    [anon_sym_nullptr] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2659),
    [anon_sym_decltype] = ACTIONS(2659),
    [anon_sym_explicit] = ACTIONS(2659),
    [anon_sym_typename] = ACTIONS(2659),
    [anon_sym_template] = ACTIONS(2659),
    [anon_sym_operator] = ACTIONS(2659),
    [anon_sym_try] = ACTIONS(2659),
    [anon_sym_delete] = ACTIONS(2659),
    [anon_sym_throw] = ACTIONS(2659),
    [anon_sym_namespace] = ACTIONS(2659),
    [anon_sym_static_assert] = ACTIONS(2659),
    [anon_sym_concept] = ACTIONS(2659),
    [anon_sym_co_return] = ACTIONS(2659),
    [anon_sym_co_yield] = ACTIONS(2659),
    [anon_sym_R_DQUOTE] = ACTIONS(2661),
    [anon_sym_LR_DQUOTE] = ACTIONS(2661),
    [anon_sym_uR_DQUOTE] = ACTIONS(2661),
    [anon_sym_UR_DQUOTE] = ACTIONS(2661),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2661),
    [anon_sym_co_await] = ACTIONS(2659),
    [anon_sym_new] = ACTIONS(2659),
    [anon_sym_requires] = ACTIONS(2659),
    [sym_this] = ACTIONS(2659),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(2797),
    [sym_identifier] = ACTIONS(2795),
    [aux_sym_preproc_include_token1] = ACTIONS(2795),
    [aux_sym_preproc_def_token1] = ACTIONS(2795),
    [aux_sym_preproc_if_token1] = ACTIONS(2795),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2795),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2795),
    [sym_preproc_directive] = ACTIONS(2795),
    [anon_sym_LPAREN2] = ACTIONS(2797),
    [anon_sym_BANG] = ACTIONS(2797),
    [anon_sym_TILDE] = ACTIONS(2797),
    [anon_sym_DASH] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_AMP_AMP] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_SEMI] = ACTIONS(2797),
    [anon_sym___extension__] = ACTIONS(2795),
    [anon_sym_typedef] = ACTIONS(2795),
    [anon_sym_virtual] = ACTIONS(2795),
    [anon_sym_extern] = ACTIONS(2795),
    [anon_sym___attribute__] = ACTIONS(2795),
    [anon_sym___attribute] = ACTIONS(2795),
    [anon_sym_using] = ACTIONS(2795),
    [anon_sym_COLON_COLON] = ACTIONS(2797),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2797),
    [anon_sym___declspec] = ACTIONS(2795),
    [anon_sym___based] = ACTIONS(2795),
    [anon_sym___cdecl] = ACTIONS(2795),
    [anon_sym___clrcall] = ACTIONS(2795),
    [anon_sym___stdcall] = ACTIONS(2795),
    [anon_sym___fastcall] = ACTIONS(2795),
    [anon_sym___thiscall] = ACTIONS(2795),
    [anon_sym___vectorcall] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2797),
    [anon_sym_signed] = ACTIONS(2795),
    [anon_sym_unsigned] = ACTIONS(2795),
    [anon_sym_long] = ACTIONS(2795),
    [anon_sym_short] = ACTIONS(2795),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_static] = ACTIONS(2795),
    [anon_sym_register] = ACTIONS(2795),
    [anon_sym_inline] = ACTIONS(2795),
    [anon_sym___inline] = ACTIONS(2795),
    [anon_sym___inline__] = ACTIONS(2795),
    [anon_sym___forceinline] = ACTIONS(2795),
    [anon_sym_thread_local] = ACTIONS(2795),
    [anon_sym___thread] = ACTIONS(2795),
    [anon_sym_const] = ACTIONS(2795),
    [anon_sym_constexpr] = ACTIONS(2795),
    [anon_sym_volatile] = ACTIONS(2795),
    [anon_sym_restrict] = ACTIONS(2795),
    [anon_sym___restrict__] = ACTIONS(2795),
    [anon_sym__Atomic] = ACTIONS(2795),
    [anon_sym__Noreturn] = ACTIONS(2795),
    [anon_sym_noreturn] = ACTIONS(2795),
    [anon_sym__Nonnull] = ACTIONS(2795),
    [anon_sym_mutable] = ACTIONS(2795),
    [anon_sym_constinit] = ACTIONS(2795),
    [anon_sym_consteval] = ACTIONS(2795),
    [anon_sym_alignas] = ACTIONS(2795),
    [anon_sym__Alignas] = ACTIONS(2795),
    [sym_primitive_type] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2795),
    [anon_sym_class] = ACTIONS(2795),
    [anon_sym_struct] = ACTIONS(2795),
    [anon_sym_union] = ACTIONS(2795),
    [anon_sym_if] = ACTIONS(2795),
    [anon_sym_switch] = ACTIONS(2795),
    [anon_sym_case] = ACTIONS(2795),
    [anon_sym_default] = ACTIONS(2795),
    [anon_sym_while] = ACTIONS(2795),
    [anon_sym_do] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2795),
    [anon_sym_return] = ACTIONS(2795),
    [anon_sym_break] = ACTIONS(2795),
    [anon_sym_continue] = ACTIONS(2795),
    [anon_sym_goto] = ACTIONS(2795),
    [anon_sym_not] = ACTIONS(2795),
    [anon_sym_compl] = ACTIONS(2795),
    [anon_sym_DASH_DASH] = ACTIONS(2797),
    [anon_sym_PLUS_PLUS] = ACTIONS(2797),
    [anon_sym_sizeof] = ACTIONS(2795),
    [anon_sym___alignof__] = ACTIONS(2795),
    [anon_sym___alignof] = ACTIONS(2795),
    [anon_sym__alignof] = ACTIONS(2795),
    [anon_sym_alignof] = ACTIONS(2795),
    [anon_sym__Alignof] = ACTIONS(2795),
    [anon_sym_offsetof] = ACTIONS(2795),
    [anon_sym__Generic] = ACTIONS(2795),
    [anon_sym_asm] = ACTIONS(2795),
    [anon_sym___asm__] = ACTIONS(2795),
    [anon_sym___asm] = ACTIONS(2795),
    [sym_number_literal] = ACTIONS(2797),
    [anon_sym_L_SQUOTE] = ACTIONS(2797),
    [anon_sym_u_SQUOTE] = ACTIONS(2797),
    [anon_sym_U_SQUOTE] = ACTIONS(2797),
    [anon_sym_u8_SQUOTE] = ACTIONS(2797),
    [anon_sym_SQUOTE] = ACTIONS(2797),
    [anon_sym_L_DQUOTE] = ACTIONS(2797),
    [anon_sym_u_DQUOTE] = ACTIONS(2797),
    [anon_sym_U_DQUOTE] = ACTIONS(2797),
    [anon_sym_u8_DQUOTE] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(2797),
    [sym_true] = ACTIONS(2795),
    [sym_false] = ACTIONS(2795),
    [anon_sym_NULL] = ACTIONS(2795),
    [anon_sym_nullptr] = ACTIONS(2795),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2795),
    [anon_sym_decltype] = ACTIONS(2795),
    [anon_sym_explicit] = ACTIONS(2795),
    [anon_sym_typename] = ACTIONS(2795),
    [anon_sym_export] = ACTIONS(2795),
    [anon_sym_module] = ACTIONS(2795),
    [anon_sym_import] = ACTIONS(2795),
    [anon_sym_template] = ACTIONS(2795),
    [anon_sym_operator] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2795),
    [anon_sym_delete] = ACTIONS(2795),
    [anon_sym_throw] = ACTIONS(2795),
    [anon_sym_namespace] = ACTIONS(2795),
    [anon_sym_static_assert] = ACTIONS(2795),
    [anon_sym_concept] = ACTIONS(2795),
    [anon_sym_co_return] = ACTIONS(2795),
    [anon_sym_co_yield] = ACTIONS(2795),
    [anon_sym_R_DQUOTE] = ACTIONS(2797),
    [anon_sym_LR_DQUOTE] = ACTIONS(2797),
    [anon_sym_uR_DQUOTE] = ACTIONS(2797),
    [anon_sym_UR_DQUOTE] = ACTIONS(2797),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2797),
    [anon_sym_co_await] = ACTIONS(2795),
    [anon_sym_new] = ACTIONS(2795),
    [anon_sym_requires] = ACTIONS(2795),
    [sym_this] = ACTIONS(2795),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(2801),
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_export] = ACTIONS(2799),
    [anon_sym_module] = ACTIONS(2799),
    [anon_sym_import] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [494] = {
    [ts_builtin_sym_end] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2839),
    [aux_sym_preproc_include_token1] = ACTIONS(2839),
    [aux_sym_preproc_def_token1] = ACTIONS(2839),
    [aux_sym_preproc_if_token1] = ACTIONS(2839),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2839),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2839),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym___extension__] = ACTIONS(2839),
    [anon_sym_typedef] = ACTIONS(2839),
    [anon_sym_virtual] = ACTIONS(2839),
    [anon_sym_extern] = ACTIONS(2839),
    [anon_sym___attribute__] = ACTIONS(2839),
    [anon_sym___attribute] = ACTIONS(2839),
    [anon_sym_using] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2841),
    [anon_sym___declspec] = ACTIONS(2839),
    [anon_sym___based] = ACTIONS(2839),
    [anon_sym___cdecl] = ACTIONS(2839),
    [anon_sym___clrcall] = ACTIONS(2839),
    [anon_sym___stdcall] = ACTIONS(2839),
    [anon_sym___fastcall] = ACTIONS(2839),
    [anon_sym___thiscall] = ACTIONS(2839),
    [anon_sym___vectorcall] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_signed] = ACTIONS(2839),
    [anon_sym_unsigned] = ACTIONS(2839),
    [anon_sym_long] = ACTIONS(2839),
    [anon_sym_short] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_static] = ACTIONS(2839),
    [anon_sym_register] = ACTIONS(2839),
    [anon_sym_inline] = ACTIONS(2839),
    [anon_sym___inline] = ACTIONS(2839),
    [anon_sym___inline__] = ACTIONS(2839),
    [anon_sym___forceinline] = ACTIONS(2839),
    [anon_sym_thread_local] = ACTIONS(2839),
    [anon_sym___thread] = ACTIONS(2839),
    [anon_sym_const] = ACTIONS(2839),
    [anon_sym_constexpr] = ACTIONS(2839),
    [anon_sym_volatile] = ACTIONS(2839),
    [anon_sym_restrict] = ACTIONS(2839),
    [anon_sym___restrict__] = ACTIONS(2839),
    [anon_sym__Atomic] = ACTIONS(2839),
    [anon_sym__Noreturn] = ACTIONS(2839),
    [anon_sym_noreturn] = ACTIONS(2839),
    [anon_sym__Nonnull] = ACTIONS(2839),
    [anon_sym_mutable] = ACTIONS(2839),
    [anon_sym_constinit] = ACTIONS(2839),
    [anon_sym_consteval] = ACTIONS(2839),
    [anon_sym_alignas] = ACTIONS(2839),
    [anon_sym__Alignas] = ACTIONS(2839),
    [sym_primitive_type] = ACTIONS(2839),
    [anon_sym_enum] = ACTIONS(2839),
    [anon_sym_class] = ACTIONS(2839),
    [anon_sym_struct] = ACTIONS(2839),
    [anon_sym_union] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_switch] = ACTIONS(2839),
    [anon_sym_case] = ACTIONS(2839),
    [anon_sym_default] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_continue] = ACTIONS(2839),
    [anon_sym_goto] = ACTIONS(2839),
    [anon_sym_not] = ACTIONS(2839),
    [anon_sym_compl] = ACTIONS(2839),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_sizeof] = ACTIONS(2839),
    [anon_sym___alignof__] = ACTIONS(2839),
    [anon_sym___alignof] = ACTIONS(2839),
    [anon_sym__alignof] = ACTIONS(2839),
    [anon_sym_alignof] = ACTIONS(2839),
    [anon_sym__Alignof] = ACTIONS(2839),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2839),
    [anon_sym_asm] = ACTIONS(2839),
    [anon_sym___asm__] = ACTIONS(2839),
    [anon_sym___asm] = ACTIONS(2839),
    [sym_number_literal] = ACTIONS(2841),
    [anon_sym_L_SQUOTE] = ACTIONS(2841),
    [anon_sym_u_SQUOTE] = ACTIONS(2841),
    [anon_sym_U_SQUOTE] = ACTIONS(2841),
    [anon_sym_u8_SQUOTE] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_L_DQUOTE] = ACTIONS(2841),
    [anon_sym_u_DQUOTE] = ACTIONS(2841),
    [anon_sym_U_DQUOTE] = ACTIONS(2841),
    [anon_sym_u8_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [sym_true] = ACTIONS(2839),
    [sym_false] = ACTIONS(2839),
    [anon_sym_NULL] = ACTIONS(2839),
    [anon_sym_nullptr] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2839),
    [anon_sym_decltype] = ACTIONS(2839),
    [anon_sym_explicit] = ACTIONS(2839),
    [anon_sym_typename] = ACTIONS(2839),
    [anon_sym_export] = ACTIONS(2839),
    [anon_sym_module] = ACTIONS(2839),
    [anon_sym_import] = ACTIONS(2839),
    [anon_sym_template] = ACTIONS(2839),
    [anon_sym_operator] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_delete] = ACTIONS(2839),
    [anon_sym_throw] = ACTIONS(2839),
    [anon_sym_namespace] = ACTIONS(2839),
    [anon_sym_static_assert] = ACTIONS(2839),
    [anon_sym_concept] = ACTIONS(2839),
    [anon_sym_co_return] = ACTIONS(2839),
    [anon_sym_co_yield] = ACTIONS(2839),
    [anon_sym_R_DQUOTE] = ACTIONS(2841),
    [anon_sym_LR_DQUOTE] = ACTIONS(2841),
    [anon_sym_uR_DQUOTE] = ACTIONS(2841),
    [anon_sym_UR_DQUOTE] = ACTIONS(2841),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2841),
    [anon_sym_co_await] = ACTIONS(2839),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_requires] = ACTIONS(2839),
    [sym_this] = ACTIONS(2839),
  },
  [495] = {
    [ts_builtin_sym_end] = ACTIONS(3021),
    [sym_identifier] = ACTIONS(3019),
    [aux_sym_preproc_include_token1] = ACTIONS(3019),
    [aux_sym_preproc_def_token1] = ACTIONS(3019),
    [aux_sym_preproc_if_token1] = ACTIONS(3019),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3019),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3019),
    [sym_preproc_directive] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_STAR] = ACTIONS(3021),
    [anon_sym_AMP_AMP] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_SEMI] = ACTIONS(3021),
    [anon_sym___extension__] = ACTIONS(3019),
    [anon_sym_typedef] = ACTIONS(3019),
    [anon_sym_virtual] = ACTIONS(3019),
    [anon_sym_extern] = ACTIONS(3019),
    [anon_sym___attribute__] = ACTIONS(3019),
    [anon_sym___attribute] = ACTIONS(3019),
    [anon_sym_using] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3021),
    [anon_sym___declspec] = ACTIONS(3019),
    [anon_sym___based] = ACTIONS(3019),
    [anon_sym___cdecl] = ACTIONS(3019),
    [anon_sym___clrcall] = ACTIONS(3019),
    [anon_sym___stdcall] = ACTIONS(3019),
    [anon_sym___fastcall] = ACTIONS(3019),
    [anon_sym___thiscall] = ACTIONS(3019),
    [anon_sym___vectorcall] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3021),
    [anon_sym_signed] = ACTIONS(3019),
    [anon_sym_unsigned] = ACTIONS(3019),
    [anon_sym_long] = ACTIONS(3019),
    [anon_sym_short] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_static] = ACTIONS(3019),
    [anon_sym_register] = ACTIONS(3019),
    [anon_sym_inline] = ACTIONS(3019),
    [anon_sym___inline] = ACTIONS(3019),
    [anon_sym___inline__] = ACTIONS(3019),
    [anon_sym___forceinline] = ACTIONS(3019),
    [anon_sym_thread_local] = ACTIONS(3019),
    [anon_sym___thread] = ACTIONS(3019),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_constexpr] = ACTIONS(3019),
    [anon_sym_volatile] = ACTIONS(3019),
    [anon_sym_restrict] = ACTIONS(3019),
    [anon_sym___restrict__] = ACTIONS(3019),
    [anon_sym__Atomic] = ACTIONS(3019),
    [anon_sym__Noreturn] = ACTIONS(3019),
    [anon_sym_noreturn] = ACTIONS(3019),
    [anon_sym__Nonnull] = ACTIONS(3019),
    [anon_sym_mutable] = ACTIONS(3019),
    [anon_sym_constinit] = ACTIONS(3019),
    [anon_sym_consteval] = ACTIONS(3019),
    [anon_sym_alignas] = ACTIONS(3019),
    [anon_sym__Alignas] = ACTIONS(3019),
    [sym_primitive_type] = ACTIONS(3019),
    [anon_sym_enum] = ACTIONS(3019),
    [anon_sym_class] = ACTIONS(3019),
    [anon_sym_struct] = ACTIONS(3019),
    [anon_sym_union] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_switch] = ACTIONS(3019),
    [anon_sym_case] = ACTIONS(3019),
    [anon_sym_default] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_break] = ACTIONS(3019),
    [anon_sym_continue] = ACTIONS(3019),
    [anon_sym_goto] = ACTIONS(3019),
    [anon_sym_not] = ACTIONS(3019),
    [anon_sym_compl] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3021),
    [anon_sym_sizeof] = ACTIONS(3019),
    [anon_sym___alignof__] = ACTIONS(3019),
    [anon_sym___alignof] = ACTIONS(3019),
    [anon_sym__alignof] = ACTIONS(3019),
    [anon_sym_alignof] = ACTIONS(3019),
    [anon_sym__Alignof] = ACTIONS(3019),
    [anon_sym_offsetof] = ACTIONS(3019),
    [anon_sym__Generic] = ACTIONS(3019),
    [anon_sym_asm] = ACTIONS(3019),
    [anon_sym___asm__] = ACTIONS(3019),
    [anon_sym___asm] = ACTIONS(3019),
    [sym_number_literal] = ACTIONS(3021),
    [anon_sym_L_SQUOTE] = ACTIONS(3021),
    [anon_sym_u_SQUOTE] = ACTIONS(3021),
    [anon_sym_U_SQUOTE] = ACTIONS(3021),
    [anon_sym_u8_SQUOTE] = ACTIONS(3021),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [anon_sym_L_DQUOTE] = ACTIONS(3021),
    [anon_sym_u_DQUOTE] = ACTIONS(3021),
    [anon_sym_U_DQUOTE] = ACTIONS(3021),
    [anon_sym_u8_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE] = ACTIONS(3021),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [anon_sym_NULL] = ACTIONS(3019),
    [anon_sym_nullptr] = ACTIONS(3019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3019),
    [anon_sym_decltype] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_typename] = ACTIONS(3019),
    [anon_sym_export] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3019),
    [anon_sym_import] = ACTIONS(3019),
    [anon_sym_template] = ACTIONS(3019),
    [anon_sym_operator] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_delete] = ACTIONS(3019),
    [anon_sym_throw] = ACTIONS(3019),
    [anon_sym_namespace] = ACTIONS(3019),
    [anon_sym_static_assert] = ACTIONS(3019),
    [anon_sym_concept] = ACTIONS(3019),
    [anon_sym_co_return] = ACTIONS(3019),
    [anon_sym_co_yield] = ACTIONS(3019),
    [anon_sym_R_DQUOTE] = ACTIONS(3021),
    [anon_sym_LR_DQUOTE] = ACTIONS(3021),
    [anon_sym_uR_DQUOTE] = ACTIONS(3021),
    [anon_sym_UR_DQUOTE] = ACTIONS(3021),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3021),
    [anon_sym_co_await] = ACTIONS(3019),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_requires] = ACTIONS(3019),
    [sym_this] = ACTIONS(3019),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(3025),
    [sym_identifier] = ACTIONS(3023),
    [aux_sym_preproc_include_token1] = ACTIONS(3023),
    [aux_sym_preproc_def_token1] = ACTIONS(3023),
    [aux_sym_preproc_if_token1] = ACTIONS(3023),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3023),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3023),
    [sym_preproc_directive] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3025),
    [anon_sym_BANG] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(3025),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_STAR] = ACTIONS(3025),
    [anon_sym_AMP_AMP] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym___extension__] = ACTIONS(3023),
    [anon_sym_typedef] = ACTIONS(3023),
    [anon_sym_virtual] = ACTIONS(3023),
    [anon_sym_extern] = ACTIONS(3023),
    [anon_sym___attribute__] = ACTIONS(3023),
    [anon_sym___attribute] = ACTIONS(3023),
    [anon_sym_using] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3025),
    [anon_sym___declspec] = ACTIONS(3023),
    [anon_sym___based] = ACTIONS(3023),
    [anon_sym___cdecl] = ACTIONS(3023),
    [anon_sym___clrcall] = ACTIONS(3023),
    [anon_sym___stdcall] = ACTIONS(3023),
    [anon_sym___fastcall] = ACTIONS(3023),
    [anon_sym___thiscall] = ACTIONS(3023),
    [anon_sym___vectorcall] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3025),
    [anon_sym_signed] = ACTIONS(3023),
    [anon_sym_unsigned] = ACTIONS(3023),
    [anon_sym_long] = ACTIONS(3023),
    [anon_sym_short] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3023),
    [anon_sym_register] = ACTIONS(3023),
    [anon_sym_inline] = ACTIONS(3023),
    [anon_sym___inline] = ACTIONS(3023),
    [anon_sym___inline__] = ACTIONS(3023),
    [anon_sym___forceinline] = ACTIONS(3023),
    [anon_sym_thread_local] = ACTIONS(3023),
    [anon_sym___thread] = ACTIONS(3023),
    [anon_sym_const] = ACTIONS(3023),
    [anon_sym_constexpr] = ACTIONS(3023),
    [anon_sym_volatile] = ACTIONS(3023),
    [anon_sym_restrict] = ACTIONS(3023),
    [anon_sym___restrict__] = ACTIONS(3023),
    [anon_sym__Atomic] = ACTIONS(3023),
    [anon_sym__Noreturn] = ACTIONS(3023),
    [anon_sym_noreturn] = ACTIONS(3023),
    [anon_sym__Nonnull] = ACTIONS(3023),
    [anon_sym_mutable] = ACTIONS(3023),
    [anon_sym_constinit] = ACTIONS(3023),
    [anon_sym_consteval] = ACTIONS(3023),
    [anon_sym_alignas] = ACTIONS(3023),
    [anon_sym__Alignas] = ACTIONS(3023),
    [sym_primitive_type] = ACTIONS(3023),
    [anon_sym_enum] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3023),
    [anon_sym_struct] = ACTIONS(3023),
    [anon_sym_union] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_switch] = ACTIONS(3023),
    [anon_sym_case] = ACTIONS(3023),
    [anon_sym_default] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_break] = ACTIONS(3023),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_goto] = ACTIONS(3023),
    [anon_sym_not] = ACTIONS(3023),
    [anon_sym_compl] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3025),
    [anon_sym_PLUS_PLUS] = ACTIONS(3025),
    [anon_sym_sizeof] = ACTIONS(3023),
    [anon_sym___alignof__] = ACTIONS(3023),
    [anon_sym___alignof] = ACTIONS(3023),
    [anon_sym__alignof] = ACTIONS(3023),
    [anon_sym_alignof] = ACTIONS(3023),
    [anon_sym__Alignof] = ACTIONS(3023),
    [anon_sym_offsetof] = ACTIONS(3023),
    [anon_sym__Generic] = ACTIONS(3023),
    [anon_sym_asm] = ACTIONS(3023),
    [anon_sym___asm__] = ACTIONS(3023),
    [anon_sym___asm] = ACTIONS(3023),
    [sym_number_literal] = ACTIONS(3025),
    [anon_sym_L_SQUOTE] = ACTIONS(3025),
    [anon_sym_u_SQUOTE] = ACTIONS(3025),
    [anon_sym_U_SQUOTE] = ACTIONS(3025),
    [anon_sym_u8_SQUOTE] = ACTIONS(3025),
    [anon_sym_SQUOTE] = ACTIONS(3025),
    [anon_sym_L_DQUOTE] = ACTIONS(3025),
    [anon_sym_u_DQUOTE] = ACTIONS(3025),
    [anon_sym_U_DQUOTE] = ACTIONS(3025),
    [anon_sym_u8_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE] = ACTIONS(3025),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [anon_sym_NULL] = ACTIONS(3023),
    [anon_sym_nullptr] = ACTIONS(3023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3023),
    [anon_sym_decltype] = ACTIONS(3023),
    [anon_sym_explicit] = ACTIONS(3023),
    [anon_sym_typename] = ACTIONS(3023),
    [anon_sym_export] = ACTIONS(3023),
    [anon_sym_module] = ACTIONS(3023),
    [anon_sym_import] = ACTIONS(3023),
    [anon_sym_template] = ACTIONS(3023),
    [anon_sym_operator] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_delete] = ACTIONS(3023),
    [anon_sym_throw] = ACTIONS(3023),
    [anon_sym_namespace] = ACTIONS(3023),
    [anon_sym_static_assert] = ACTIONS(3023),
    [anon_sym_concept] = ACTIONS(3023),
    [anon_sym_co_return] = ACTIONS(3023),
    [anon_sym_co_yield] = ACTIONS(3023),
    [anon_sym_R_DQUOTE] = ACTIONS(3025),
    [anon_sym_LR_DQUOTE] = ACTIONS(3025),
    [anon_sym_uR_DQUOTE] = ACTIONS(3025),
    [anon_sym_UR_DQUOTE] = ACTIONS(3025),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3025),
    [anon_sym_co_await] = ACTIONS(3023),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_requires] = ACTIONS(3023),
    [sym_this] = ACTIONS(3023),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(2833),
    [sym_identifier] = ACTIONS(2831),
    [aux_sym_preproc_include_token1] = ACTIONS(2831),
    [aux_sym_preproc_def_token1] = ACTIONS(2831),
    [aux_sym_preproc_if_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [sym_preproc_directive] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym___extension__] = ACTIONS(2831),
    [anon_sym_typedef] = ACTIONS(2831),
    [anon_sym_virtual] = ACTIONS(2831),
    [anon_sym_extern] = ACTIONS(2831),
    [anon_sym___attribute__] = ACTIONS(2831),
    [anon_sym___attribute] = ACTIONS(2831),
    [anon_sym_using] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2833),
    [anon_sym___declspec] = ACTIONS(2831),
    [anon_sym___based] = ACTIONS(2831),
    [anon_sym___cdecl] = ACTIONS(2831),
    [anon_sym___clrcall] = ACTIONS(2831),
    [anon_sym___stdcall] = ACTIONS(2831),
    [anon_sym___fastcall] = ACTIONS(2831),
    [anon_sym___thiscall] = ACTIONS(2831),
    [anon_sym___vectorcall] = ACTIONS(2831),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_signed] = ACTIONS(2831),
    [anon_sym_unsigned] = ACTIONS(2831),
    [anon_sym_long] = ACTIONS(2831),
    [anon_sym_short] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_static] = ACTIONS(2831),
    [anon_sym_register] = ACTIONS(2831),
    [anon_sym_inline] = ACTIONS(2831),
    [anon_sym___inline] = ACTIONS(2831),
    [anon_sym___inline__] = ACTIONS(2831),
    [anon_sym___forceinline] = ACTIONS(2831),
    [anon_sym_thread_local] = ACTIONS(2831),
    [anon_sym___thread] = ACTIONS(2831),
    [anon_sym_const] = ACTIONS(2831),
    [anon_sym_constexpr] = ACTIONS(2831),
    [anon_sym_volatile] = ACTIONS(2831),
    [anon_sym_restrict] = ACTIONS(2831),
    [anon_sym___restrict__] = ACTIONS(2831),
    [anon_sym__Atomic] = ACTIONS(2831),
    [anon_sym__Noreturn] = ACTIONS(2831),
    [anon_sym_noreturn] = ACTIONS(2831),
    [anon_sym__Nonnull] = ACTIONS(2831),
    [anon_sym_mutable] = ACTIONS(2831),
    [anon_sym_constinit] = ACTIONS(2831),
    [anon_sym_consteval] = ACTIONS(2831),
    [anon_sym_alignas] = ACTIONS(2831),
    [anon_sym__Alignas] = ACTIONS(2831),
    [sym_primitive_type] = ACTIONS(2831),
    [anon_sym_enum] = ACTIONS(2831),
    [anon_sym_class] = ACTIONS(2831),
    [anon_sym_struct] = ACTIONS(2831),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_switch] = ACTIONS(2831),
    [anon_sym_case] = ACTIONS(2831),
    [anon_sym_default] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_break] = ACTIONS(2831),
    [anon_sym_continue] = ACTIONS(2831),
    [anon_sym_goto] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_compl] = ACTIONS(2831),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2831),
    [anon_sym___alignof__] = ACTIONS(2831),
    [anon_sym___alignof] = ACTIONS(2831),
    [anon_sym__alignof] = ACTIONS(2831),
    [anon_sym_alignof] = ACTIONS(2831),
    [anon_sym__Alignof] = ACTIONS(2831),
    [anon_sym_offsetof] = ACTIONS(2831),
    [anon_sym__Generic] = ACTIONS(2831),
    [anon_sym_asm] = ACTIONS(2831),
    [anon_sym___asm__] = ACTIONS(2831),
    [anon_sym___asm] = ACTIONS(2831),
    [sym_number_literal] = ACTIONS(2833),
    [anon_sym_L_SQUOTE] = ACTIONS(2833),
    [anon_sym_u_SQUOTE] = ACTIONS(2833),
    [anon_sym_U_SQUOTE] = ACTIONS(2833),
    [anon_sym_u8_SQUOTE] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_L_DQUOTE] = ACTIONS(2833),
    [anon_sym_u_DQUOTE] = ACTIONS(2833),
    [anon_sym_U_DQUOTE] = ACTIONS(2833),
    [anon_sym_u8_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [sym_true] = ACTIONS(2831),
    [sym_false] = ACTIONS(2831),
    [anon_sym_NULL] = ACTIONS(2831),
    [anon_sym_nullptr] = ACTIONS(2831),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2831),
    [anon_sym_decltype] = ACTIONS(2831),
    [anon_sym_explicit] = ACTIONS(2831),
    [anon_sym_typename] = ACTIONS(2831),
    [anon_sym_export] = ACTIONS(2831),
    [anon_sym_module] = ACTIONS(2831),
    [anon_sym_import] = ACTIONS(2831),
    [anon_sym_template] = ACTIONS(2831),
    [anon_sym_operator] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_delete] = ACTIONS(2831),
    [anon_sym_throw] = ACTIONS(2831),
    [anon_sym_namespace] = ACTIONS(2831),
    [anon_sym_static_assert] = ACTIONS(2831),
    [anon_sym_concept] = ACTIONS(2831),
    [anon_sym_co_return] = ACTIONS(2831),
    [anon_sym_co_yield] = ACTIONS(2831),
    [anon_sym_R_DQUOTE] = ACTIONS(2833),
    [anon_sym_LR_DQUOTE] = ACTIONS(2833),
    [anon_sym_uR_DQUOTE] = ACTIONS(2833),
    [anon_sym_UR_DQUOTE] = ACTIONS(2833),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2833),
    [anon_sym_co_await] = ACTIONS(2831),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_requires] = ACTIONS(2831),
    [sym_this] = ACTIONS(2831),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(2849),
    [sym_identifier] = ACTIONS(2847),
    [aux_sym_preproc_include_token1] = ACTIONS(2847),
    [aux_sym_preproc_def_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token1] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2847),
    [sym_preproc_directive] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym___extension__] = ACTIONS(2847),
    [anon_sym_typedef] = ACTIONS(2847),
    [anon_sym_virtual] = ACTIONS(2847),
    [anon_sym_extern] = ACTIONS(2847),
    [anon_sym___attribute__] = ACTIONS(2847),
    [anon_sym___attribute] = ACTIONS(2847),
    [anon_sym_using] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2849),
    [anon_sym___declspec] = ACTIONS(2847),
    [anon_sym___based] = ACTIONS(2847),
    [anon_sym___cdecl] = ACTIONS(2847),
    [anon_sym___clrcall] = ACTIONS(2847),
    [anon_sym___stdcall] = ACTIONS(2847),
    [anon_sym___fastcall] = ACTIONS(2847),
    [anon_sym___thiscall] = ACTIONS(2847),
    [anon_sym___vectorcall] = ACTIONS(2847),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_signed] = ACTIONS(2847),
    [anon_sym_unsigned] = ACTIONS(2847),
    [anon_sym_long] = ACTIONS(2847),
    [anon_sym_short] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2847),
    [anon_sym_register] = ACTIONS(2847),
    [anon_sym_inline] = ACTIONS(2847),
    [anon_sym___inline] = ACTIONS(2847),
    [anon_sym___inline__] = ACTIONS(2847),
    [anon_sym___forceinline] = ACTIONS(2847),
    [anon_sym_thread_local] = ACTIONS(2847),
    [anon_sym___thread] = ACTIONS(2847),
    [anon_sym_const] = ACTIONS(2847),
    [anon_sym_constexpr] = ACTIONS(2847),
    [anon_sym_volatile] = ACTIONS(2847),
    [anon_sym_restrict] = ACTIONS(2847),
    [anon_sym___restrict__] = ACTIONS(2847),
    [anon_sym__Atomic] = ACTIONS(2847),
    [anon_sym__Noreturn] = ACTIONS(2847),
    [anon_sym_noreturn] = ACTIONS(2847),
    [anon_sym__Nonnull] = ACTIONS(2847),
    [anon_sym_mutable] = ACTIONS(2847),
    [anon_sym_constinit] = ACTIONS(2847),
    [anon_sym_consteval] = ACTIONS(2847),
    [anon_sym_alignas] = ACTIONS(2847),
    [anon_sym__Alignas] = ACTIONS(2847),
    [sym_primitive_type] = ACTIONS(2847),
    [anon_sym_enum] = ACTIONS(2847),
    [anon_sym_class] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2847),
    [anon_sym_union] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_switch] = ACTIONS(2847),
    [anon_sym_case] = ACTIONS(2847),
    [anon_sym_default] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_break] = ACTIONS(2847),
    [anon_sym_continue] = ACTIONS(2847),
    [anon_sym_goto] = ACTIONS(2847),
    [anon_sym_not] = ACTIONS(2847),
    [anon_sym_compl] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2849),
    [anon_sym_sizeof] = ACTIONS(2847),
    [anon_sym___alignof__] = ACTIONS(2847),
    [anon_sym___alignof] = ACTIONS(2847),
    [anon_sym__alignof] = ACTIONS(2847),
    [anon_sym_alignof] = ACTIONS(2847),
    [anon_sym__Alignof] = ACTIONS(2847),
    [anon_sym_offsetof] = ACTIONS(2847),
    [anon_sym__Generic] = ACTIONS(2847),
    [anon_sym_asm] = ACTIONS(2847),
    [anon_sym___asm__] = ACTIONS(2847),
    [anon_sym___asm] = ACTIONS(2847),
    [sym_number_literal] = ACTIONS(2849),
    [anon_sym_L_SQUOTE] = ACTIONS(2849),
    [anon_sym_u_SQUOTE] = ACTIONS(2849),
    [anon_sym_U_SQUOTE] = ACTIONS(2849),
    [anon_sym_u8_SQUOTE] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [anon_sym_NULL] = ACTIONS(2847),
    [anon_sym_nullptr] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2847),
    [anon_sym_decltype] = ACTIONS(2847),
    [anon_sym_explicit] = ACTIONS(2847),
    [anon_sym_typename] = ACTIONS(2847),
    [anon_sym_export] = ACTIONS(2847),
    [anon_sym_module] = ACTIONS(2847),
    [anon_sym_import] = ACTIONS(2847),
    [anon_sym_template] = ACTIONS(2847),
    [anon_sym_operator] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_delete] = ACTIONS(2847),
    [anon_sym_throw] = ACTIONS(2847),
    [anon_sym_namespace] = ACTIONS(2847),
    [anon_sym_static_assert] = ACTIONS(2847),
    [anon_sym_concept] = ACTIONS(2847),
    [anon_sym_co_return] = ACTIONS(2847),
    [anon_sym_co_yield] = ACTIONS(2847),
    [anon_sym_R_DQUOTE] = ACTIONS(2849),
    [anon_sym_LR_DQUOTE] = ACTIONS(2849),
    [anon_sym_uR_DQUOTE] = ACTIONS(2849),
    [anon_sym_UR_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2849),
    [anon_sym_co_await] = ACTIONS(2847),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_requires] = ACTIONS(2847),
    [sym_this] = ACTIONS(2847),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(3375),
    [sym_identifier] = ACTIONS(3377),
    [aux_sym_preproc_include_token1] = ACTIONS(3377),
    [aux_sym_preproc_def_token1] = ACTIONS(3377),
    [aux_sym_preproc_if_token1] = ACTIONS(3377),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3377),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3377),
    [sym_preproc_directive] = ACTIONS(3377),
    [anon_sym_LPAREN2] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3375),
    [anon_sym_TILDE] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_STAR] = ACTIONS(3375),
    [anon_sym_AMP_AMP] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym___extension__] = ACTIONS(3377),
    [anon_sym_typedef] = ACTIONS(3377),
    [anon_sym_virtual] = ACTIONS(3377),
    [anon_sym_extern] = ACTIONS(3377),
    [anon_sym___attribute__] = ACTIONS(3377),
    [anon_sym___attribute] = ACTIONS(3377),
    [anon_sym_using] = ACTIONS(3377),
    [anon_sym_COLON_COLON] = ACTIONS(3375),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3375),
    [anon_sym___declspec] = ACTIONS(3377),
    [anon_sym___based] = ACTIONS(3377),
    [anon_sym___cdecl] = ACTIONS(3377),
    [anon_sym___clrcall] = ACTIONS(3377),
    [anon_sym___stdcall] = ACTIONS(3377),
    [anon_sym___fastcall] = ACTIONS(3377),
    [anon_sym___thiscall] = ACTIONS(3377),
    [anon_sym___vectorcall] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3375),
    [anon_sym_signed] = ACTIONS(3377),
    [anon_sym_unsigned] = ACTIONS(3377),
    [anon_sym_long] = ACTIONS(3377),
    [anon_sym_short] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_static] = ACTIONS(3377),
    [anon_sym_register] = ACTIONS(3377),
    [anon_sym_inline] = ACTIONS(3377),
    [anon_sym___inline] = ACTIONS(3377),
    [anon_sym___inline__] = ACTIONS(3377),
    [anon_sym___forceinline] = ACTIONS(3377),
    [anon_sym_thread_local] = ACTIONS(3377),
    [anon_sym___thread] = ACTIONS(3377),
    [anon_sym_const] = ACTIONS(3377),
    [anon_sym_constexpr] = ACTIONS(3377),
    [anon_sym_volatile] = ACTIONS(3377),
    [anon_sym_restrict] = ACTIONS(3377),
    [anon_sym___restrict__] = ACTIONS(3377),
    [anon_sym__Atomic] = ACTIONS(3377),
    [anon_sym__Noreturn] = ACTIONS(3377),
    [anon_sym_noreturn] = ACTIONS(3377),
    [anon_sym__Nonnull] = ACTIONS(3377),
    [anon_sym_mutable] = ACTIONS(3377),
    [anon_sym_constinit] = ACTIONS(3377),
    [anon_sym_consteval] = ACTIONS(3377),
    [anon_sym_alignas] = ACTIONS(3377),
    [anon_sym__Alignas] = ACTIONS(3377),
    [sym_primitive_type] = ACTIONS(3377),
    [anon_sym_enum] = ACTIONS(3377),
    [anon_sym_class] = ACTIONS(3377),
    [anon_sym_struct] = ACTIONS(3377),
    [anon_sym_union] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3377),
    [anon_sym_switch] = ACTIONS(3377),
    [anon_sym_case] = ACTIONS(3377),
    [anon_sym_default] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(3377),
    [anon_sym_for] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3377),
    [anon_sym_break] = ACTIONS(3377),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_goto] = ACTIONS(3377),
    [anon_sym_not] = ACTIONS(3377),
    [anon_sym_compl] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_sizeof] = ACTIONS(3377),
    [anon_sym___alignof__] = ACTIONS(3377),
    [anon_sym___alignof] = ACTIONS(3377),
    [anon_sym__alignof] = ACTIONS(3377),
    [anon_sym_alignof] = ACTIONS(3377),
    [anon_sym__Alignof] = ACTIONS(3377),
    [anon_sym_offsetof] = ACTIONS(3377),
    [anon_sym__Generic] = ACTIONS(3377),
    [anon_sym_asm] = ACTIONS(3377),
    [anon_sym___asm__] = ACTIONS(3377),
    [anon_sym___asm] = ACTIONS(3377),
    [sym_number_literal] = ACTIONS(3375),
    [anon_sym_L_SQUOTE] = ACTIONS(3375),
    [anon_sym_u_SQUOTE] = ACTIONS(3375),
    [anon_sym_U_SQUOTE] = ACTIONS(3375),
    [anon_sym_u8_SQUOTE] = ACTIONS(3375),
    [anon_sym_SQUOTE] = ACTIONS(3375),
    [anon_sym_L_DQUOTE] = ACTIONS(3375),
    [anon_sym_u_DQUOTE] = ACTIONS(3375),
    [anon_sym_U_DQUOTE] = ACTIONS(3375),
    [anon_sym_u8_DQUOTE] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [sym_true] = ACTIONS(3377),
    [sym_false] = ACTIONS(3377),
    [anon_sym_NULL] = ACTIONS(3377),
    [anon_sym_nullptr] = ACTIONS(3377),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3377),
    [anon_sym_decltype] = ACTIONS(3377),
    [anon_sym_explicit] = ACTIONS(3377),
    [anon_sym_typename] = ACTIONS(3377),
    [anon_sym_export] = ACTIONS(3377),
    [anon_sym_module] = ACTIONS(3377),
    [anon_sym_import] = ACTIONS(3377),
    [anon_sym_template] = ACTIONS(3377),
    [anon_sym_operator] = ACTIONS(3377),
    [anon_sym_try] = ACTIONS(3377),
    [anon_sym_delete] = ACTIONS(3377),
    [anon_sym_throw] = ACTIONS(3377),
    [anon_sym_namespace] = ACTIONS(3377),
    [anon_sym_static_assert] = ACTIONS(3377),
    [anon_sym_concept] = ACTIONS(3377),
    [anon_sym_co_return] = ACTIONS(3377),
    [anon_sym_co_yield] = ACTIONS(3377),
    [anon_sym_R_DQUOTE] = ACTIONS(3375),
    [anon_sym_LR_DQUOTE] = ACTIONS(3375),
    [anon_sym_uR_DQUOTE] = ACTIONS(3375),
    [anon_sym_UR_DQUOTE] = ACTIONS(3375),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3375),
    [anon_sym_co_await] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3377),
    [anon_sym_requires] = ACTIONS(3377),
    [sym_this] = ACTIONS(3377),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(2885),
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2885),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2885),
    [anon_sym_L_SQUOTE] = ACTIONS(2885),
    [anon_sym_u_SQUOTE] = ACTIONS(2885),
    [anon_sym_U_SQUOTE] = ACTIONS(2885),
    [anon_sym_u8_SQUOTE] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_L_DQUOTE] = ACTIONS(2885),
    [anon_sym_u_DQUOTE] = ACTIONS(2885),
    [anon_sym_U_DQUOTE] = ACTIONS(2885),
    [anon_sym_u8_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE] = ACTIONS(2885),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_export] = ACTIONS(2883),
    [anon_sym_module] = ACTIONS(2883),
    [anon_sym_import] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2885),
    [anon_sym_LR_DQUOTE] = ACTIONS(2885),
    [anon_sym_uR_DQUOTE] = ACTIONS(2885),
    [anon_sym_UR_DQUOTE] = ACTIONS(2885),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2885),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(2901),
    [sym_identifier] = ACTIONS(2899),
    [aux_sym_preproc_include_token1] = ACTIONS(2899),
    [aux_sym_preproc_def_token1] = ACTIONS(2899),
    [aux_sym_preproc_if_token1] = ACTIONS(2899),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2899),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2899),
    [sym_preproc_directive] = ACTIONS(2899),
    [anon_sym_LPAREN2] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_PLUS] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym___extension__] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2899),
    [anon_sym_virtual] = ACTIONS(2899),
    [anon_sym_extern] = ACTIONS(2899),
    [anon_sym___attribute__] = ACTIONS(2899),
    [anon_sym___attribute] = ACTIONS(2899),
    [anon_sym_using] = ACTIONS(2899),
    [anon_sym_COLON_COLON] = ACTIONS(2901),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2901),
    [anon_sym___declspec] = ACTIONS(2899),
    [anon_sym___based] = ACTIONS(2899),
    [anon_sym___cdecl] = ACTIONS(2899),
    [anon_sym___clrcall] = ACTIONS(2899),
    [anon_sym___stdcall] = ACTIONS(2899),
    [anon_sym___fastcall] = ACTIONS(2899),
    [anon_sym___thiscall] = ACTIONS(2899),
    [anon_sym___vectorcall] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_signed] = ACTIONS(2899),
    [anon_sym_unsigned] = ACTIONS(2899),
    [anon_sym_long] = ACTIONS(2899),
    [anon_sym_short] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_static] = ACTIONS(2899),
    [anon_sym_register] = ACTIONS(2899),
    [anon_sym_inline] = ACTIONS(2899),
    [anon_sym___inline] = ACTIONS(2899),
    [anon_sym___inline__] = ACTIONS(2899),
    [anon_sym___forceinline] = ACTIONS(2899),
    [anon_sym_thread_local] = ACTIONS(2899),
    [anon_sym___thread] = ACTIONS(2899),
    [anon_sym_const] = ACTIONS(2899),
    [anon_sym_constexpr] = ACTIONS(2899),
    [anon_sym_volatile] = ACTIONS(2899),
    [anon_sym_restrict] = ACTIONS(2899),
    [anon_sym___restrict__] = ACTIONS(2899),
    [anon_sym__Atomic] = ACTIONS(2899),
    [anon_sym__Noreturn] = ACTIONS(2899),
    [anon_sym_noreturn] = ACTIONS(2899),
    [anon_sym__Nonnull] = ACTIONS(2899),
    [anon_sym_mutable] = ACTIONS(2899),
    [anon_sym_constinit] = ACTIONS(2899),
    [anon_sym_consteval] = ACTIONS(2899),
    [anon_sym_alignas] = ACTIONS(2899),
    [anon_sym__Alignas] = ACTIONS(2899),
    [sym_primitive_type] = ACTIONS(2899),
    [anon_sym_enum] = ACTIONS(2899),
    [anon_sym_class] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(2899),
    [anon_sym_union] = ACTIONS(2899),
    [anon_sym_if] = ACTIONS(2899),
    [anon_sym_switch] = ACTIONS(2899),
    [anon_sym_case] = ACTIONS(2899),
    [anon_sym_default] = ACTIONS(2899),
    [anon_sym_while] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2899),
    [anon_sym_for] = ACTIONS(2899),
    [anon_sym_return] = ACTIONS(2899),
    [anon_sym_break] = ACTIONS(2899),
    [anon_sym_continue] = ACTIONS(2899),
    [anon_sym_goto] = ACTIONS(2899),
    [anon_sym_not] = ACTIONS(2899),
    [anon_sym_compl] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_sizeof] = ACTIONS(2899),
    [anon_sym___alignof__] = ACTIONS(2899),
    [anon_sym___alignof] = ACTIONS(2899),
    [anon_sym__alignof] = ACTIONS(2899),
    [anon_sym_alignof] = ACTIONS(2899),
    [anon_sym__Alignof] = ACTIONS(2899),
    [anon_sym_offsetof] = ACTIONS(2899),
    [anon_sym__Generic] = ACTIONS(2899),
    [anon_sym_asm] = ACTIONS(2899),
    [anon_sym___asm__] = ACTIONS(2899),
    [anon_sym___asm] = ACTIONS(2899),
    [sym_number_literal] = ACTIONS(2901),
    [anon_sym_L_SQUOTE] = ACTIONS(2901),
    [anon_sym_u_SQUOTE] = ACTIONS(2901),
    [anon_sym_U_SQUOTE] = ACTIONS(2901),
    [anon_sym_u8_SQUOTE] = ACTIONS(2901),
    [anon_sym_SQUOTE] = ACTIONS(2901),
    [anon_sym_L_DQUOTE] = ACTIONS(2901),
    [anon_sym_u_DQUOTE] = ACTIONS(2901),
    [anon_sym_U_DQUOTE] = ACTIONS(2901),
    [anon_sym_u8_DQUOTE] = ACTIONS(2901),
    [anon_sym_DQUOTE] = ACTIONS(2901),
    [sym_true] = ACTIONS(2899),
    [sym_false] = ACTIONS(2899),
    [anon_sym_NULL] = ACTIONS(2899),
    [anon_sym_nullptr] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2899),
    [anon_sym_decltype] = ACTIONS(2899),
    [anon_sym_explicit] = ACTIONS(2899),
    [anon_sym_typename] = ACTIONS(2899),
    [anon_sym_export] = ACTIONS(2899),
    [anon_sym_module] = ACTIONS(2899),
    [anon_sym_import] = ACTIONS(2899),
    [anon_sym_template] = ACTIONS(2899),
    [anon_sym_operator] = ACTIONS(2899),
    [anon_sym_try] = ACTIONS(2899),
    [anon_sym_delete] = ACTIONS(2899),
    [anon_sym_throw] = ACTIONS(2899),
    [anon_sym_namespace] = ACTIONS(2899),
    [anon_sym_static_assert] = ACTIONS(2899),
    [anon_sym_concept] = ACTIONS(2899),
    [anon_sym_co_return] = ACTIONS(2899),
    [anon_sym_co_yield] = ACTIONS(2899),
    [anon_sym_R_DQUOTE] = ACTIONS(2901),
    [anon_sym_LR_DQUOTE] = ACTIONS(2901),
    [anon_sym_uR_DQUOTE] = ACTIONS(2901),
    [anon_sym_UR_DQUOTE] = ACTIONS(2901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2901),
    [anon_sym_co_await] = ACTIONS(2899),
    [anon_sym_new] = ACTIONS(2899),
    [anon_sym_requires] = ACTIONS(2899),
    [sym_this] = ACTIONS(2899),
  },
  [502] = {
    [sym_identifier] = ACTIONS(2719),
    [aux_sym_preproc_include_token1] = ACTIONS(2719),
    [aux_sym_preproc_def_token1] = ACTIONS(2719),
    [aux_sym_preproc_if_token1] = ACTIONS(2719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2719),
    [sym_preproc_directive] = ACTIONS(2719),
    [anon_sym_LPAREN2] = ACTIONS(2721),
    [anon_sym_BANG] = ACTIONS(2721),
    [anon_sym_TILDE] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2719),
    [anon_sym_PLUS] = ACTIONS(2719),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(2719),
    [anon_sym_typedef] = ACTIONS(2719),
    [anon_sym_virtual] = ACTIONS(2719),
    [anon_sym_extern] = ACTIONS(2719),
    [anon_sym___attribute__] = ACTIONS(2719),
    [anon_sym___attribute] = ACTIONS(2719),
    [anon_sym_using] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2721),
    [anon_sym___declspec] = ACTIONS(2719),
    [anon_sym___based] = ACTIONS(2719),
    [anon_sym___cdecl] = ACTIONS(2719),
    [anon_sym___clrcall] = ACTIONS(2719),
    [anon_sym___stdcall] = ACTIONS(2719),
    [anon_sym___fastcall] = ACTIONS(2719),
    [anon_sym___thiscall] = ACTIONS(2719),
    [anon_sym___vectorcall] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2721),
    [anon_sym_RBRACE] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2719),
    [anon_sym_unsigned] = ACTIONS(2719),
    [anon_sym_long] = ACTIONS(2719),
    [anon_sym_short] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_static] = ACTIONS(2719),
    [anon_sym_register] = ACTIONS(2719),
    [anon_sym_inline] = ACTIONS(2719),
    [anon_sym___inline] = ACTIONS(2719),
    [anon_sym___inline__] = ACTIONS(2719),
    [anon_sym___forceinline] = ACTIONS(2719),
    [anon_sym_thread_local] = ACTIONS(2719),
    [anon_sym___thread] = ACTIONS(2719),
    [anon_sym_const] = ACTIONS(2719),
    [anon_sym_constexpr] = ACTIONS(2719),
    [anon_sym_volatile] = ACTIONS(2719),
    [anon_sym_restrict] = ACTIONS(2719),
    [anon_sym___restrict__] = ACTIONS(2719),
    [anon_sym__Atomic] = ACTIONS(2719),
    [anon_sym__Noreturn] = ACTIONS(2719),
    [anon_sym_noreturn] = ACTIONS(2719),
    [anon_sym__Nonnull] = ACTIONS(2719),
    [anon_sym_mutable] = ACTIONS(2719),
    [anon_sym_constinit] = ACTIONS(2719),
    [anon_sym_consteval] = ACTIONS(2719),
    [anon_sym_alignas] = ACTIONS(2719),
    [anon_sym__Alignas] = ACTIONS(2719),
    [sym_primitive_type] = ACTIONS(2719),
    [anon_sym_enum] = ACTIONS(2719),
    [anon_sym_class] = ACTIONS(2719),
    [anon_sym_struct] = ACTIONS(2719),
    [anon_sym_union] = ACTIONS(2719),
    [anon_sym_if] = ACTIONS(2719),
    [anon_sym_else] = ACTIONS(2719),
    [anon_sym_switch] = ACTIONS(2719),
    [anon_sym_case] = ACTIONS(2719),
    [anon_sym_default] = ACTIONS(2719),
    [anon_sym_while] = ACTIONS(2719),
    [anon_sym_do] = ACTIONS(2719),
    [anon_sym_for] = ACTIONS(2719),
    [anon_sym_return] = ACTIONS(2719),
    [anon_sym_break] = ACTIONS(2719),
    [anon_sym_continue] = ACTIONS(2719),
    [anon_sym_goto] = ACTIONS(2719),
    [anon_sym___try] = ACTIONS(2719),
    [anon_sym___leave] = ACTIONS(2719),
    [anon_sym_not] = ACTIONS(2719),
    [anon_sym_compl] = ACTIONS(2719),
    [anon_sym_DASH_DASH] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(2721),
    [anon_sym_sizeof] = ACTIONS(2719),
    [anon_sym___alignof__] = ACTIONS(2719),
    [anon_sym___alignof] = ACTIONS(2719),
    [anon_sym__alignof] = ACTIONS(2719),
    [anon_sym_alignof] = ACTIONS(2719),
    [anon_sym__Alignof] = ACTIONS(2719),
    [anon_sym_offsetof] = ACTIONS(2719),
    [anon_sym__Generic] = ACTIONS(2719),
    [anon_sym_asm] = ACTIONS(2719),
    [anon_sym___asm__] = ACTIONS(2719),
    [anon_sym___asm] = ACTIONS(2719),
    [sym_number_literal] = ACTIONS(2721),
    [anon_sym_L_SQUOTE] = ACTIONS(2721),
    [anon_sym_u_SQUOTE] = ACTIONS(2721),
    [anon_sym_U_SQUOTE] = ACTIONS(2721),
    [anon_sym_u8_SQUOTE] = ACTIONS(2721),
    [anon_sym_SQUOTE] = ACTIONS(2721),
    [anon_sym_L_DQUOTE] = ACTIONS(2721),
    [anon_sym_u_DQUOTE] = ACTIONS(2721),
    [anon_sym_U_DQUOTE] = ACTIONS(2721),
    [anon_sym_u8_DQUOTE] = ACTIONS(2721),
    [anon_sym_DQUOTE] = ACTIONS(2721),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [anon_sym_NULL] = ACTIONS(2719),
    [anon_sym_nullptr] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2719),
    [anon_sym_decltype] = ACTIONS(2719),
    [anon_sym_explicit] = ACTIONS(2719),
    [anon_sym_typename] = ACTIONS(2719),
    [anon_sym_template] = ACTIONS(2719),
    [anon_sym_operator] = ACTIONS(2719),
    [anon_sym_try] = ACTIONS(2719),
    [anon_sym_delete] = ACTIONS(2719),
    [anon_sym_throw] = ACTIONS(2719),
    [anon_sym_namespace] = ACTIONS(2719),
    [anon_sym_static_assert] = ACTIONS(2719),
    [anon_sym_concept] = ACTIONS(2719),
    [anon_sym_co_return] = ACTIONS(2719),
    [anon_sym_co_yield] = ACTIONS(2719),
    [anon_sym_R_DQUOTE] = ACTIONS(2721),
    [anon_sym_LR_DQUOTE] = ACTIONS(2721),
    [anon_sym_uR_DQUOTE] = ACTIONS(2721),
    [anon_sym_UR_DQUOTE] = ACTIONS(2721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2721),
    [anon_sym_co_await] = ACTIONS(2719),
    [anon_sym_new] = ACTIONS(2719),
    [anon_sym_requires] = ACTIONS(2719),
    [sym_this] = ACTIONS(2719),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(2853),
    [sym_identifier] = ACTIONS(2851),
    [aux_sym_preproc_include_token1] = ACTIONS(2851),
    [aux_sym_preproc_def_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token1] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2851),
    [sym_preproc_directive] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2853),
    [anon_sym_BANG] = ACTIONS(2853),
    [anon_sym_TILDE] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_STAR] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym___extension__] = ACTIONS(2851),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_virtual] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(2851),
    [anon_sym___attribute__] = ACTIONS(2851),
    [anon_sym___attribute] = ACTIONS(2851),
    [anon_sym_using] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2853),
    [anon_sym___declspec] = ACTIONS(2851),
    [anon_sym___based] = ACTIONS(2851),
    [anon_sym___cdecl] = ACTIONS(2851),
    [anon_sym___clrcall] = ACTIONS(2851),
    [anon_sym___stdcall] = ACTIONS(2851),
    [anon_sym___fastcall] = ACTIONS(2851),
    [anon_sym___thiscall] = ACTIONS(2851),
    [anon_sym___vectorcall] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_signed] = ACTIONS(2851),
    [anon_sym_unsigned] = ACTIONS(2851),
    [anon_sym_long] = ACTIONS(2851),
    [anon_sym_short] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_static] = ACTIONS(2851),
    [anon_sym_register] = ACTIONS(2851),
    [anon_sym_inline] = ACTIONS(2851),
    [anon_sym___inline] = ACTIONS(2851),
    [anon_sym___inline__] = ACTIONS(2851),
    [anon_sym___forceinline] = ACTIONS(2851),
    [anon_sym_thread_local] = ACTIONS(2851),
    [anon_sym___thread] = ACTIONS(2851),
    [anon_sym_const] = ACTIONS(2851),
    [anon_sym_constexpr] = ACTIONS(2851),
    [anon_sym_volatile] = ACTIONS(2851),
    [anon_sym_restrict] = ACTIONS(2851),
    [anon_sym___restrict__] = ACTIONS(2851),
    [anon_sym__Atomic] = ACTIONS(2851),
    [anon_sym__Noreturn] = ACTIONS(2851),
    [anon_sym_noreturn] = ACTIONS(2851),
    [anon_sym__Nonnull] = ACTIONS(2851),
    [anon_sym_mutable] = ACTIONS(2851),
    [anon_sym_constinit] = ACTIONS(2851),
    [anon_sym_consteval] = ACTIONS(2851),
    [anon_sym_alignas] = ACTIONS(2851),
    [anon_sym__Alignas] = ACTIONS(2851),
    [sym_primitive_type] = ACTIONS(2851),
    [anon_sym_enum] = ACTIONS(2851),
    [anon_sym_class] = ACTIONS(2851),
    [anon_sym_struct] = ACTIONS(2851),
    [anon_sym_union] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_switch] = ACTIONS(2851),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_break] = ACTIONS(2851),
    [anon_sym_continue] = ACTIONS(2851),
    [anon_sym_goto] = ACTIONS(2851),
    [anon_sym_not] = ACTIONS(2851),
    [anon_sym_compl] = ACTIONS(2851),
    [anon_sym_DASH_DASH] = ACTIONS(2853),
    [anon_sym_PLUS_PLUS] = ACTIONS(2853),
    [anon_sym_sizeof] = ACTIONS(2851),
    [anon_sym___alignof__] = ACTIONS(2851),
    [anon_sym___alignof] = ACTIONS(2851),
    [anon_sym__alignof] = ACTIONS(2851),
    [anon_sym_alignof] = ACTIONS(2851),
    [anon_sym__Alignof] = ACTIONS(2851),
    [anon_sym_offsetof] = ACTIONS(2851),
    [anon_sym__Generic] = ACTIONS(2851),
    [anon_sym_asm] = ACTIONS(2851),
    [anon_sym___asm__] = ACTIONS(2851),
    [anon_sym___asm] = ACTIONS(2851),
    [sym_number_literal] = ACTIONS(2853),
    [anon_sym_L_SQUOTE] = ACTIONS(2853),
    [anon_sym_u_SQUOTE] = ACTIONS(2853),
    [anon_sym_U_SQUOTE] = ACTIONS(2853),
    [anon_sym_u8_SQUOTE] = ACTIONS(2853),
    [anon_sym_SQUOTE] = ACTIONS(2853),
    [anon_sym_L_DQUOTE] = ACTIONS(2853),
    [anon_sym_u_DQUOTE] = ACTIONS(2853),
    [anon_sym_U_DQUOTE] = ACTIONS(2853),
    [anon_sym_u8_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE] = ACTIONS(2853),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2851),
    [anon_sym_nullptr] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2851),
    [anon_sym_decltype] = ACTIONS(2851),
    [anon_sym_explicit] = ACTIONS(2851),
    [anon_sym_typename] = ACTIONS(2851),
    [anon_sym_export] = ACTIONS(2851),
    [anon_sym_module] = ACTIONS(2851),
    [anon_sym_import] = ACTIONS(2851),
    [anon_sym_template] = ACTIONS(2851),
    [anon_sym_operator] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_delete] = ACTIONS(2851),
    [anon_sym_throw] = ACTIONS(2851),
    [anon_sym_namespace] = ACTIONS(2851),
    [anon_sym_static_assert] = ACTIONS(2851),
    [anon_sym_concept] = ACTIONS(2851),
    [anon_sym_co_return] = ACTIONS(2851),
    [anon_sym_co_yield] = ACTIONS(2851),
    [anon_sym_R_DQUOTE] = ACTIONS(2853),
    [anon_sym_LR_DQUOTE] = ACTIONS(2853),
    [anon_sym_uR_DQUOTE] = ACTIONS(2853),
    [anon_sym_UR_DQUOTE] = ACTIONS(2853),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2853),
    [anon_sym_co_await] = ACTIONS(2851),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_requires] = ACTIONS(2851),
    [sym_this] = ACTIONS(2851),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(3379),
    [sym_identifier] = ACTIONS(3381),
    [aux_sym_preproc_include_token1] = ACTIONS(3381),
    [aux_sym_preproc_def_token1] = ACTIONS(3381),
    [aux_sym_preproc_if_token1] = ACTIONS(3381),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3381),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3381),
    [sym_preproc_directive] = ACTIONS(3381),
    [anon_sym_LPAREN2] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3381),
    [anon_sym_PLUS] = ACTIONS(3381),
    [anon_sym_STAR] = ACTIONS(3379),
    [anon_sym_AMP_AMP] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym___extension__] = ACTIONS(3381),
    [anon_sym_typedef] = ACTIONS(3381),
    [anon_sym_virtual] = ACTIONS(3381),
    [anon_sym_extern] = ACTIONS(3381),
    [anon_sym___attribute__] = ACTIONS(3381),
    [anon_sym___attribute] = ACTIONS(3381),
    [anon_sym_using] = ACTIONS(3381),
    [anon_sym_COLON_COLON] = ACTIONS(3379),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3379),
    [anon_sym___declspec] = ACTIONS(3381),
    [anon_sym___based] = ACTIONS(3381),
    [anon_sym___cdecl] = ACTIONS(3381),
    [anon_sym___clrcall] = ACTIONS(3381),
    [anon_sym___stdcall] = ACTIONS(3381),
    [anon_sym___fastcall] = ACTIONS(3381),
    [anon_sym___thiscall] = ACTIONS(3381),
    [anon_sym___vectorcall] = ACTIONS(3381),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_signed] = ACTIONS(3381),
    [anon_sym_unsigned] = ACTIONS(3381),
    [anon_sym_long] = ACTIONS(3381),
    [anon_sym_short] = ACTIONS(3381),
    [anon_sym_LBRACK] = ACTIONS(3381),
    [anon_sym_static] = ACTIONS(3381),
    [anon_sym_register] = ACTIONS(3381),
    [anon_sym_inline] = ACTIONS(3381),
    [anon_sym___inline] = ACTIONS(3381),
    [anon_sym___inline__] = ACTIONS(3381),
    [anon_sym___forceinline] = ACTIONS(3381),
    [anon_sym_thread_local] = ACTIONS(3381),
    [anon_sym___thread] = ACTIONS(3381),
    [anon_sym_const] = ACTIONS(3381),
    [anon_sym_constexpr] = ACTIONS(3381),
    [anon_sym_volatile] = ACTIONS(3381),
    [anon_sym_restrict] = ACTIONS(3381),
    [anon_sym___restrict__] = ACTIONS(3381),
    [anon_sym__Atomic] = ACTIONS(3381),
    [anon_sym__Noreturn] = ACTIONS(3381),
    [anon_sym_noreturn] = ACTIONS(3381),
    [anon_sym__Nonnull] = ACTIONS(3381),
    [anon_sym_mutable] = ACTIONS(3381),
    [anon_sym_constinit] = ACTIONS(3381),
    [anon_sym_consteval] = ACTIONS(3381),
    [anon_sym_alignas] = ACTIONS(3381),
    [anon_sym__Alignas] = ACTIONS(3381),
    [sym_primitive_type] = ACTIONS(3381),
    [anon_sym_enum] = ACTIONS(3381),
    [anon_sym_class] = ACTIONS(3381),
    [anon_sym_struct] = ACTIONS(3381),
    [anon_sym_union] = ACTIONS(3381),
    [anon_sym_if] = ACTIONS(3381),
    [anon_sym_switch] = ACTIONS(3381),
    [anon_sym_case] = ACTIONS(3381),
    [anon_sym_default] = ACTIONS(3381),
    [anon_sym_while] = ACTIONS(3381),
    [anon_sym_do] = ACTIONS(3381),
    [anon_sym_for] = ACTIONS(3381),
    [anon_sym_return] = ACTIONS(3381),
    [anon_sym_break] = ACTIONS(3381),
    [anon_sym_continue] = ACTIONS(3381),
    [anon_sym_goto] = ACTIONS(3381),
    [anon_sym_not] = ACTIONS(3381),
    [anon_sym_compl] = ACTIONS(3381),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_sizeof] = ACTIONS(3381),
    [anon_sym___alignof__] = ACTIONS(3381),
    [anon_sym___alignof] = ACTIONS(3381),
    [anon_sym__alignof] = ACTIONS(3381),
    [anon_sym_alignof] = ACTIONS(3381),
    [anon_sym__Alignof] = ACTIONS(3381),
    [anon_sym_offsetof] = ACTIONS(3381),
    [anon_sym__Generic] = ACTIONS(3381),
    [anon_sym_asm] = ACTIONS(3381),
    [anon_sym___asm__] = ACTIONS(3381),
    [anon_sym___asm] = ACTIONS(3381),
    [sym_number_literal] = ACTIONS(3379),
    [anon_sym_L_SQUOTE] = ACTIONS(3379),
    [anon_sym_u_SQUOTE] = ACTIONS(3379),
    [anon_sym_U_SQUOTE] = ACTIONS(3379),
    [anon_sym_u8_SQUOTE] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3379),
    [anon_sym_L_DQUOTE] = ACTIONS(3379),
    [anon_sym_u_DQUOTE] = ACTIONS(3379),
    [anon_sym_U_DQUOTE] = ACTIONS(3379),
    [anon_sym_u8_DQUOTE] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [sym_true] = ACTIONS(3381),
    [sym_false] = ACTIONS(3381),
    [anon_sym_NULL] = ACTIONS(3381),
    [anon_sym_nullptr] = ACTIONS(3381),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3381),
    [anon_sym_decltype] = ACTIONS(3381),
    [anon_sym_explicit] = ACTIONS(3381),
    [anon_sym_typename] = ACTIONS(3381),
    [anon_sym_export] = ACTIONS(3381),
    [anon_sym_module] = ACTIONS(3381),
    [anon_sym_import] = ACTIONS(3381),
    [anon_sym_template] = ACTIONS(3381),
    [anon_sym_operator] = ACTIONS(3381),
    [anon_sym_try] = ACTIONS(3381),
    [anon_sym_delete] = ACTIONS(3381),
    [anon_sym_throw] = ACTIONS(3381),
    [anon_sym_namespace] = ACTIONS(3381),
    [anon_sym_static_assert] = ACTIONS(3381),
    [anon_sym_concept] = ACTIONS(3381),
    [anon_sym_co_return] = ACTIONS(3381),
    [anon_sym_co_yield] = ACTIONS(3381),
    [anon_sym_R_DQUOTE] = ACTIONS(3379),
    [anon_sym_LR_DQUOTE] = ACTIONS(3379),
    [anon_sym_uR_DQUOTE] = ACTIONS(3379),
    [anon_sym_UR_DQUOTE] = ACTIONS(3379),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3379),
    [anon_sym_co_await] = ACTIONS(3381),
    [anon_sym_new] = ACTIONS(3381),
    [anon_sym_requires] = ACTIONS(3381),
    [sym_this] = ACTIONS(3381),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(3383),
    [sym_identifier] = ACTIONS(3385),
    [aux_sym_preproc_include_token1] = ACTIONS(3385),
    [aux_sym_preproc_def_token1] = ACTIONS(3385),
    [aux_sym_preproc_if_token1] = ACTIONS(3385),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3385),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3385),
    [sym_preproc_directive] = ACTIONS(3385),
    [anon_sym_LPAREN2] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_TILDE] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_STAR] = ACTIONS(3383),
    [anon_sym_AMP_AMP] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym___extension__] = ACTIONS(3385),
    [anon_sym_typedef] = ACTIONS(3385),
    [anon_sym_virtual] = ACTIONS(3385),
    [anon_sym_extern] = ACTIONS(3385),
    [anon_sym___attribute__] = ACTIONS(3385),
    [anon_sym___attribute] = ACTIONS(3385),
    [anon_sym_using] = ACTIONS(3385),
    [anon_sym_COLON_COLON] = ACTIONS(3383),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3383),
    [anon_sym___declspec] = ACTIONS(3385),
    [anon_sym___based] = ACTIONS(3385),
    [anon_sym___cdecl] = ACTIONS(3385),
    [anon_sym___clrcall] = ACTIONS(3385),
    [anon_sym___stdcall] = ACTIONS(3385),
    [anon_sym___fastcall] = ACTIONS(3385),
    [anon_sym___thiscall] = ACTIONS(3385),
    [anon_sym___vectorcall] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3383),
    [anon_sym_signed] = ACTIONS(3385),
    [anon_sym_unsigned] = ACTIONS(3385),
    [anon_sym_long] = ACTIONS(3385),
    [anon_sym_short] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_static] = ACTIONS(3385),
    [anon_sym_register] = ACTIONS(3385),
    [anon_sym_inline] = ACTIONS(3385),
    [anon_sym___inline] = ACTIONS(3385),
    [anon_sym___inline__] = ACTIONS(3385),
    [anon_sym___forceinline] = ACTIONS(3385),
    [anon_sym_thread_local] = ACTIONS(3385),
    [anon_sym___thread] = ACTIONS(3385),
    [anon_sym_const] = ACTIONS(3385),
    [anon_sym_constexpr] = ACTIONS(3385),
    [anon_sym_volatile] = ACTIONS(3385),
    [anon_sym_restrict] = ACTIONS(3385),
    [anon_sym___restrict__] = ACTIONS(3385),
    [anon_sym__Atomic] = ACTIONS(3385),
    [anon_sym__Noreturn] = ACTIONS(3385),
    [anon_sym_noreturn] = ACTIONS(3385),
    [anon_sym__Nonnull] = ACTIONS(3385),
    [anon_sym_mutable] = ACTIONS(3385),
    [anon_sym_constinit] = ACTIONS(3385),
    [anon_sym_consteval] = ACTIONS(3385),
    [anon_sym_alignas] = ACTIONS(3385),
    [anon_sym__Alignas] = ACTIONS(3385),
    [sym_primitive_type] = ACTIONS(3385),
    [anon_sym_enum] = ACTIONS(3385),
    [anon_sym_class] = ACTIONS(3385),
    [anon_sym_struct] = ACTIONS(3385),
    [anon_sym_union] = ACTIONS(3385),
    [anon_sym_if] = ACTIONS(3385),
    [anon_sym_switch] = ACTIONS(3385),
    [anon_sym_case] = ACTIONS(3385),
    [anon_sym_default] = ACTIONS(3385),
    [anon_sym_while] = ACTIONS(3385),
    [anon_sym_do] = ACTIONS(3385),
    [anon_sym_for] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3385),
    [anon_sym_break] = ACTIONS(3385),
    [anon_sym_continue] = ACTIONS(3385),
    [anon_sym_goto] = ACTIONS(3385),
    [anon_sym_not] = ACTIONS(3385),
    [anon_sym_compl] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_sizeof] = ACTIONS(3385),
    [anon_sym___alignof__] = ACTIONS(3385),
    [anon_sym___alignof] = ACTIONS(3385),
    [anon_sym__alignof] = ACTIONS(3385),
    [anon_sym_alignof] = ACTIONS(3385),
    [anon_sym__Alignof] = ACTIONS(3385),
    [anon_sym_offsetof] = ACTIONS(3385),
    [anon_sym__Generic] = ACTIONS(3385),
    [anon_sym_asm] = ACTIONS(3385),
    [anon_sym___asm__] = ACTIONS(3385),
    [anon_sym___asm] = ACTIONS(3385),
    [sym_number_literal] = ACTIONS(3383),
    [anon_sym_L_SQUOTE] = ACTIONS(3383),
    [anon_sym_u_SQUOTE] = ACTIONS(3383),
    [anon_sym_U_SQUOTE] = ACTIONS(3383),
    [anon_sym_u8_SQUOTE] = ACTIONS(3383),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_L_DQUOTE] = ACTIONS(3383),
    [anon_sym_u_DQUOTE] = ACTIONS(3383),
    [anon_sym_U_DQUOTE] = ACTIONS(3383),
    [anon_sym_u8_DQUOTE] = ACTIONS(3383),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [sym_true] = ACTIONS(3385),
    [sym_false] = ACTIONS(3385),
    [anon_sym_NULL] = ACTIONS(3385),
    [anon_sym_nullptr] = ACTIONS(3385),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3385),
    [anon_sym_decltype] = ACTIONS(3385),
    [anon_sym_explicit] = ACTIONS(3385),
    [anon_sym_typename] = ACTIONS(3385),
    [anon_sym_export] = ACTIONS(3385),
    [anon_sym_module] = ACTIONS(3385),
    [anon_sym_import] = ACTIONS(3385),
    [anon_sym_template] = ACTIONS(3385),
    [anon_sym_operator] = ACTIONS(3385),
    [anon_sym_try] = ACTIONS(3385),
    [anon_sym_delete] = ACTIONS(3385),
    [anon_sym_throw] = ACTIONS(3385),
    [anon_sym_namespace] = ACTIONS(3385),
    [anon_sym_static_assert] = ACTIONS(3385),
    [anon_sym_concept] = ACTIONS(3385),
    [anon_sym_co_return] = ACTIONS(3385),
    [anon_sym_co_yield] = ACTIONS(3385),
    [anon_sym_R_DQUOTE] = ACTIONS(3383),
    [anon_sym_LR_DQUOTE] = ACTIONS(3383),
    [anon_sym_uR_DQUOTE] = ACTIONS(3383),
    [anon_sym_UR_DQUOTE] = ACTIONS(3383),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3383),
    [anon_sym_co_await] = ACTIONS(3385),
    [anon_sym_new] = ACTIONS(3385),
    [anon_sym_requires] = ACTIONS(3385),
    [sym_this] = ACTIONS(3385),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(3387),
    [sym_identifier] = ACTIONS(3389),
    [aux_sym_preproc_include_token1] = ACTIONS(3389),
    [aux_sym_preproc_def_token1] = ACTIONS(3389),
    [aux_sym_preproc_if_token1] = ACTIONS(3389),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3389),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3389),
    [sym_preproc_directive] = ACTIONS(3389),
    [anon_sym_LPAREN2] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3387),
    [anon_sym_AMP_AMP] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3389),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym___extension__] = ACTIONS(3389),
    [anon_sym_typedef] = ACTIONS(3389),
    [anon_sym_virtual] = ACTIONS(3389),
    [anon_sym_extern] = ACTIONS(3389),
    [anon_sym___attribute__] = ACTIONS(3389),
    [anon_sym___attribute] = ACTIONS(3389),
    [anon_sym_using] = ACTIONS(3389),
    [anon_sym_COLON_COLON] = ACTIONS(3387),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3387),
    [anon_sym___declspec] = ACTIONS(3389),
    [anon_sym___based] = ACTIONS(3389),
    [anon_sym___cdecl] = ACTIONS(3389),
    [anon_sym___clrcall] = ACTIONS(3389),
    [anon_sym___stdcall] = ACTIONS(3389),
    [anon_sym___fastcall] = ACTIONS(3389),
    [anon_sym___thiscall] = ACTIONS(3389),
    [anon_sym___vectorcall] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_signed] = ACTIONS(3389),
    [anon_sym_unsigned] = ACTIONS(3389),
    [anon_sym_long] = ACTIONS(3389),
    [anon_sym_short] = ACTIONS(3389),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_static] = ACTIONS(3389),
    [anon_sym_register] = ACTIONS(3389),
    [anon_sym_inline] = ACTIONS(3389),
    [anon_sym___inline] = ACTIONS(3389),
    [anon_sym___inline__] = ACTIONS(3389),
    [anon_sym___forceinline] = ACTIONS(3389),
    [anon_sym_thread_local] = ACTIONS(3389),
    [anon_sym___thread] = ACTIONS(3389),
    [anon_sym_const] = ACTIONS(3389),
    [anon_sym_constexpr] = ACTIONS(3389),
    [anon_sym_volatile] = ACTIONS(3389),
    [anon_sym_restrict] = ACTIONS(3389),
    [anon_sym___restrict__] = ACTIONS(3389),
    [anon_sym__Atomic] = ACTIONS(3389),
    [anon_sym__Noreturn] = ACTIONS(3389),
    [anon_sym_noreturn] = ACTIONS(3389),
    [anon_sym__Nonnull] = ACTIONS(3389),
    [anon_sym_mutable] = ACTIONS(3389),
    [anon_sym_constinit] = ACTIONS(3389),
    [anon_sym_consteval] = ACTIONS(3389),
    [anon_sym_alignas] = ACTIONS(3389),
    [anon_sym__Alignas] = ACTIONS(3389),
    [sym_primitive_type] = ACTIONS(3389),
    [anon_sym_enum] = ACTIONS(3389),
    [anon_sym_class] = ACTIONS(3389),
    [anon_sym_struct] = ACTIONS(3389),
    [anon_sym_union] = ACTIONS(3389),
    [anon_sym_if] = ACTIONS(3389),
    [anon_sym_switch] = ACTIONS(3389),
    [anon_sym_case] = ACTIONS(3389),
    [anon_sym_default] = ACTIONS(3389),
    [anon_sym_while] = ACTIONS(3389),
    [anon_sym_do] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3389),
    [anon_sym_return] = ACTIONS(3389),
    [anon_sym_break] = ACTIONS(3389),
    [anon_sym_continue] = ACTIONS(3389),
    [anon_sym_goto] = ACTIONS(3389),
    [anon_sym_not] = ACTIONS(3389),
    [anon_sym_compl] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_sizeof] = ACTIONS(3389),
    [anon_sym___alignof__] = ACTIONS(3389),
    [anon_sym___alignof] = ACTIONS(3389),
    [anon_sym__alignof] = ACTIONS(3389),
    [anon_sym_alignof] = ACTIONS(3389),
    [anon_sym__Alignof] = ACTIONS(3389),
    [anon_sym_offsetof] = ACTIONS(3389),
    [anon_sym__Generic] = ACTIONS(3389),
    [anon_sym_asm] = ACTIONS(3389),
    [anon_sym___asm__] = ACTIONS(3389),
    [anon_sym___asm] = ACTIONS(3389),
    [sym_number_literal] = ACTIONS(3387),
    [anon_sym_L_SQUOTE] = ACTIONS(3387),
    [anon_sym_u_SQUOTE] = ACTIONS(3387),
    [anon_sym_U_SQUOTE] = ACTIONS(3387),
    [anon_sym_u8_SQUOTE] = ACTIONS(3387),
    [anon_sym_SQUOTE] = ACTIONS(3387),
    [anon_sym_L_DQUOTE] = ACTIONS(3387),
    [anon_sym_u_DQUOTE] = ACTIONS(3387),
    [anon_sym_U_DQUOTE] = ACTIONS(3387),
    [anon_sym_u8_DQUOTE] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [sym_true] = ACTIONS(3389),
    [sym_false] = ACTIONS(3389),
    [anon_sym_NULL] = ACTIONS(3389),
    [anon_sym_nullptr] = ACTIONS(3389),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3389),
    [anon_sym_decltype] = ACTIONS(3389),
    [anon_sym_explicit] = ACTIONS(3389),
    [anon_sym_typename] = ACTIONS(3389),
    [anon_sym_export] = ACTIONS(3389),
    [anon_sym_module] = ACTIONS(3389),
    [anon_sym_import] = ACTIONS(3389),
    [anon_sym_template] = ACTIONS(3389),
    [anon_sym_operator] = ACTIONS(3389),
    [anon_sym_try] = ACTIONS(3389),
    [anon_sym_delete] = ACTIONS(3389),
    [anon_sym_throw] = ACTIONS(3389),
    [anon_sym_namespace] = ACTIONS(3389),
    [anon_sym_static_assert] = ACTIONS(3389),
    [anon_sym_concept] = ACTIONS(3389),
    [anon_sym_co_return] = ACTIONS(3389),
    [anon_sym_co_yield] = ACTIONS(3389),
    [anon_sym_R_DQUOTE] = ACTIONS(3387),
    [anon_sym_LR_DQUOTE] = ACTIONS(3387),
    [anon_sym_uR_DQUOTE] = ACTIONS(3387),
    [anon_sym_UR_DQUOTE] = ACTIONS(3387),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3387),
    [anon_sym_co_await] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3389),
    [anon_sym_requires] = ACTIONS(3389),
    [sym_this] = ACTIONS(3389),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(3391),
    [sym_identifier] = ACTIONS(3393),
    [aux_sym_preproc_include_token1] = ACTIONS(3393),
    [aux_sym_preproc_def_token1] = ACTIONS(3393),
    [aux_sym_preproc_if_token1] = ACTIONS(3393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3393),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3393),
    [sym_preproc_directive] = ACTIONS(3393),
    [anon_sym_LPAREN2] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_TILDE] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3391),
    [anon_sym_AMP_AMP] = ACTIONS(3391),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym___extension__] = ACTIONS(3393),
    [anon_sym_typedef] = ACTIONS(3393),
    [anon_sym_virtual] = ACTIONS(3393),
    [anon_sym_extern] = ACTIONS(3393),
    [anon_sym___attribute__] = ACTIONS(3393),
    [anon_sym___attribute] = ACTIONS(3393),
    [anon_sym_using] = ACTIONS(3393),
    [anon_sym_COLON_COLON] = ACTIONS(3391),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3391),
    [anon_sym___declspec] = ACTIONS(3393),
    [anon_sym___based] = ACTIONS(3393),
    [anon_sym___cdecl] = ACTIONS(3393),
    [anon_sym___clrcall] = ACTIONS(3393),
    [anon_sym___stdcall] = ACTIONS(3393),
    [anon_sym___fastcall] = ACTIONS(3393),
    [anon_sym___thiscall] = ACTIONS(3393),
    [anon_sym___vectorcall] = ACTIONS(3393),
    [anon_sym_LBRACE] = ACTIONS(3391),
    [anon_sym_signed] = ACTIONS(3393),
    [anon_sym_unsigned] = ACTIONS(3393),
    [anon_sym_long] = ACTIONS(3393),
    [anon_sym_short] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_static] = ACTIONS(3393),
    [anon_sym_register] = ACTIONS(3393),
    [anon_sym_inline] = ACTIONS(3393),
    [anon_sym___inline] = ACTIONS(3393),
    [anon_sym___inline__] = ACTIONS(3393),
    [anon_sym___forceinline] = ACTIONS(3393),
    [anon_sym_thread_local] = ACTIONS(3393),
    [anon_sym___thread] = ACTIONS(3393),
    [anon_sym_const] = ACTIONS(3393),
    [anon_sym_constexpr] = ACTIONS(3393),
    [anon_sym_volatile] = ACTIONS(3393),
    [anon_sym_restrict] = ACTIONS(3393),
    [anon_sym___restrict__] = ACTIONS(3393),
    [anon_sym__Atomic] = ACTIONS(3393),
    [anon_sym__Noreturn] = ACTIONS(3393),
    [anon_sym_noreturn] = ACTIONS(3393),
    [anon_sym__Nonnull] = ACTIONS(3393),
    [anon_sym_mutable] = ACTIONS(3393),
    [anon_sym_constinit] = ACTIONS(3393),
    [anon_sym_consteval] = ACTIONS(3393),
    [anon_sym_alignas] = ACTIONS(3393),
    [anon_sym__Alignas] = ACTIONS(3393),
    [sym_primitive_type] = ACTIONS(3393),
    [anon_sym_enum] = ACTIONS(3393),
    [anon_sym_class] = ACTIONS(3393),
    [anon_sym_struct] = ACTIONS(3393),
    [anon_sym_union] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_switch] = ACTIONS(3393),
    [anon_sym_case] = ACTIONS(3393),
    [anon_sym_default] = ACTIONS(3393),
    [anon_sym_while] = ACTIONS(3393),
    [anon_sym_do] = ACTIONS(3393),
    [anon_sym_for] = ACTIONS(3393),
    [anon_sym_return] = ACTIONS(3393),
    [anon_sym_break] = ACTIONS(3393),
    [anon_sym_continue] = ACTIONS(3393),
    [anon_sym_goto] = ACTIONS(3393),
    [anon_sym_not] = ACTIONS(3393),
    [anon_sym_compl] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3391),
    [anon_sym_sizeof] = ACTIONS(3393),
    [anon_sym___alignof__] = ACTIONS(3393),
    [anon_sym___alignof] = ACTIONS(3393),
    [anon_sym__alignof] = ACTIONS(3393),
    [anon_sym_alignof] = ACTIONS(3393),
    [anon_sym__Alignof] = ACTIONS(3393),
    [anon_sym_offsetof] = ACTIONS(3393),
    [anon_sym__Generic] = ACTIONS(3393),
    [anon_sym_asm] = ACTIONS(3393),
    [anon_sym___asm__] = ACTIONS(3393),
    [anon_sym___asm] = ACTIONS(3393),
    [sym_number_literal] = ACTIONS(3391),
    [anon_sym_L_SQUOTE] = ACTIONS(3391),
    [anon_sym_u_SQUOTE] = ACTIONS(3391),
    [anon_sym_U_SQUOTE] = ACTIONS(3391),
    [anon_sym_u8_SQUOTE] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3391),
    [anon_sym_L_DQUOTE] = ACTIONS(3391),
    [anon_sym_u_DQUOTE] = ACTIONS(3391),
    [anon_sym_U_DQUOTE] = ACTIONS(3391),
    [anon_sym_u8_DQUOTE] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [sym_true] = ACTIONS(3393),
    [sym_false] = ACTIONS(3393),
    [anon_sym_NULL] = ACTIONS(3393),
    [anon_sym_nullptr] = ACTIONS(3393),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3393),
    [anon_sym_decltype] = ACTIONS(3393),
    [anon_sym_explicit] = ACTIONS(3393),
    [anon_sym_typename] = ACTIONS(3393),
    [anon_sym_export] = ACTIONS(3393),
    [anon_sym_module] = ACTIONS(3393),
    [anon_sym_import] = ACTIONS(3393),
    [anon_sym_template] = ACTIONS(3393),
    [anon_sym_operator] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3393),
    [anon_sym_delete] = ACTIONS(3393),
    [anon_sym_throw] = ACTIONS(3393),
    [anon_sym_namespace] = ACTIONS(3393),
    [anon_sym_static_assert] = ACTIONS(3393),
    [anon_sym_concept] = ACTIONS(3393),
    [anon_sym_co_return] = ACTIONS(3393),
    [anon_sym_co_yield] = ACTIONS(3393),
    [anon_sym_R_DQUOTE] = ACTIONS(3391),
    [anon_sym_LR_DQUOTE] = ACTIONS(3391),
    [anon_sym_uR_DQUOTE] = ACTIONS(3391),
    [anon_sym_UR_DQUOTE] = ACTIONS(3391),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3391),
    [anon_sym_co_await] = ACTIONS(3393),
    [anon_sym_new] = ACTIONS(3393),
    [anon_sym_requires] = ACTIONS(3393),
    [sym_this] = ACTIONS(3393),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(3395),
    [sym_identifier] = ACTIONS(3397),
    [aux_sym_preproc_include_token1] = ACTIONS(3397),
    [aux_sym_preproc_def_token1] = ACTIONS(3397),
    [aux_sym_preproc_if_token1] = ACTIONS(3397),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3397),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3397),
    [sym_preproc_directive] = ACTIONS(3397),
    [anon_sym_LPAREN2] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_AMP_AMP] = ACTIONS(3395),
    [anon_sym_AMP] = ACTIONS(3397),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym___extension__] = ACTIONS(3397),
    [anon_sym_typedef] = ACTIONS(3397),
    [anon_sym_virtual] = ACTIONS(3397),
    [anon_sym_extern] = ACTIONS(3397),
    [anon_sym___attribute__] = ACTIONS(3397),
    [anon_sym___attribute] = ACTIONS(3397),
    [anon_sym_using] = ACTIONS(3397),
    [anon_sym_COLON_COLON] = ACTIONS(3395),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3395),
    [anon_sym___declspec] = ACTIONS(3397),
    [anon_sym___based] = ACTIONS(3397),
    [anon_sym___cdecl] = ACTIONS(3397),
    [anon_sym___clrcall] = ACTIONS(3397),
    [anon_sym___stdcall] = ACTIONS(3397),
    [anon_sym___fastcall] = ACTIONS(3397),
    [anon_sym___thiscall] = ACTIONS(3397),
    [anon_sym___vectorcall] = ACTIONS(3397),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_signed] = ACTIONS(3397),
    [anon_sym_unsigned] = ACTIONS(3397),
    [anon_sym_long] = ACTIONS(3397),
    [anon_sym_short] = ACTIONS(3397),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3397),
    [anon_sym_register] = ACTIONS(3397),
    [anon_sym_inline] = ACTIONS(3397),
    [anon_sym___inline] = ACTIONS(3397),
    [anon_sym___inline__] = ACTIONS(3397),
    [anon_sym___forceinline] = ACTIONS(3397),
    [anon_sym_thread_local] = ACTIONS(3397),
    [anon_sym___thread] = ACTIONS(3397),
    [anon_sym_const] = ACTIONS(3397),
    [anon_sym_constexpr] = ACTIONS(3397),
    [anon_sym_volatile] = ACTIONS(3397),
    [anon_sym_restrict] = ACTIONS(3397),
    [anon_sym___restrict__] = ACTIONS(3397),
    [anon_sym__Atomic] = ACTIONS(3397),
    [anon_sym__Noreturn] = ACTIONS(3397),
    [anon_sym_noreturn] = ACTIONS(3397),
    [anon_sym__Nonnull] = ACTIONS(3397),
    [anon_sym_mutable] = ACTIONS(3397),
    [anon_sym_constinit] = ACTIONS(3397),
    [anon_sym_consteval] = ACTIONS(3397),
    [anon_sym_alignas] = ACTIONS(3397),
    [anon_sym__Alignas] = ACTIONS(3397),
    [sym_primitive_type] = ACTIONS(3397),
    [anon_sym_enum] = ACTIONS(3397),
    [anon_sym_class] = ACTIONS(3397),
    [anon_sym_struct] = ACTIONS(3397),
    [anon_sym_union] = ACTIONS(3397),
    [anon_sym_if] = ACTIONS(3397),
    [anon_sym_switch] = ACTIONS(3397),
    [anon_sym_case] = ACTIONS(3397),
    [anon_sym_default] = ACTIONS(3397),
    [anon_sym_while] = ACTIONS(3397),
    [anon_sym_do] = ACTIONS(3397),
    [anon_sym_for] = ACTIONS(3397),
    [anon_sym_return] = ACTIONS(3397),
    [anon_sym_break] = ACTIONS(3397),
    [anon_sym_continue] = ACTIONS(3397),
    [anon_sym_goto] = ACTIONS(3397),
    [anon_sym_not] = ACTIONS(3397),
    [anon_sym_compl] = ACTIONS(3397),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_sizeof] = ACTIONS(3397),
    [anon_sym___alignof__] = ACTIONS(3397),
    [anon_sym___alignof] = ACTIONS(3397),
    [anon_sym__alignof] = ACTIONS(3397),
    [anon_sym_alignof] = ACTIONS(3397),
    [anon_sym__Alignof] = ACTIONS(3397),
    [anon_sym_offsetof] = ACTIONS(3397),
    [anon_sym__Generic] = ACTIONS(3397),
    [anon_sym_asm] = ACTIONS(3397),
    [anon_sym___asm__] = ACTIONS(3397),
    [anon_sym___asm] = ACTIONS(3397),
    [sym_number_literal] = ACTIONS(3395),
    [anon_sym_L_SQUOTE] = ACTIONS(3395),
    [anon_sym_u_SQUOTE] = ACTIONS(3395),
    [anon_sym_U_SQUOTE] = ACTIONS(3395),
    [anon_sym_u8_SQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_L_DQUOTE] = ACTIONS(3395),
    [anon_sym_u_DQUOTE] = ACTIONS(3395),
    [anon_sym_U_DQUOTE] = ACTIONS(3395),
    [anon_sym_u8_DQUOTE] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_true] = ACTIONS(3397),
    [sym_false] = ACTIONS(3397),
    [anon_sym_NULL] = ACTIONS(3397),
    [anon_sym_nullptr] = ACTIONS(3397),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3397),
    [anon_sym_decltype] = ACTIONS(3397),
    [anon_sym_explicit] = ACTIONS(3397),
    [anon_sym_typename] = ACTIONS(3397),
    [anon_sym_export] = ACTIONS(3397),
    [anon_sym_module] = ACTIONS(3397),
    [anon_sym_import] = ACTIONS(3397),
    [anon_sym_template] = ACTIONS(3397),
    [anon_sym_operator] = ACTIONS(3397),
    [anon_sym_try] = ACTIONS(3397),
    [anon_sym_delete] = ACTIONS(3397),
    [anon_sym_throw] = ACTIONS(3397),
    [anon_sym_namespace] = ACTIONS(3397),
    [anon_sym_static_assert] = ACTIONS(3397),
    [anon_sym_concept] = ACTIONS(3397),
    [anon_sym_co_return] = ACTIONS(3397),
    [anon_sym_co_yield] = ACTIONS(3397),
    [anon_sym_R_DQUOTE] = ACTIONS(3395),
    [anon_sym_LR_DQUOTE] = ACTIONS(3395),
    [anon_sym_uR_DQUOTE] = ACTIONS(3395),
    [anon_sym_UR_DQUOTE] = ACTIONS(3395),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3395),
    [anon_sym_co_await] = ACTIONS(3397),
    [anon_sym_new] = ACTIONS(3397),
    [anon_sym_requires] = ACTIONS(3397),
    [sym_this] = ACTIONS(3397),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(3399),
    [sym_identifier] = ACTIONS(3401),
    [aux_sym_preproc_include_token1] = ACTIONS(3401),
    [aux_sym_preproc_def_token1] = ACTIONS(3401),
    [aux_sym_preproc_if_token1] = ACTIONS(3401),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3401),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3401),
    [sym_preproc_directive] = ACTIONS(3401),
    [anon_sym_LPAREN2] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3399),
    [anon_sym_TILDE] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3399),
    [anon_sym_AMP_AMP] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3399),
    [anon_sym___extension__] = ACTIONS(3401),
    [anon_sym_typedef] = ACTIONS(3401),
    [anon_sym_virtual] = ACTIONS(3401),
    [anon_sym_extern] = ACTIONS(3401),
    [anon_sym___attribute__] = ACTIONS(3401),
    [anon_sym___attribute] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_COLON_COLON] = ACTIONS(3399),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3399),
    [anon_sym___declspec] = ACTIONS(3401),
    [anon_sym___based] = ACTIONS(3401),
    [anon_sym___cdecl] = ACTIONS(3401),
    [anon_sym___clrcall] = ACTIONS(3401),
    [anon_sym___stdcall] = ACTIONS(3401),
    [anon_sym___fastcall] = ACTIONS(3401),
    [anon_sym___thiscall] = ACTIONS(3401),
    [anon_sym___vectorcall] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3399),
    [anon_sym_signed] = ACTIONS(3401),
    [anon_sym_unsigned] = ACTIONS(3401),
    [anon_sym_long] = ACTIONS(3401),
    [anon_sym_short] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_register] = ACTIONS(3401),
    [anon_sym_inline] = ACTIONS(3401),
    [anon_sym___inline] = ACTIONS(3401),
    [anon_sym___inline__] = ACTIONS(3401),
    [anon_sym___forceinline] = ACTIONS(3401),
    [anon_sym_thread_local] = ACTIONS(3401),
    [anon_sym___thread] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_constexpr] = ACTIONS(3401),
    [anon_sym_volatile] = ACTIONS(3401),
    [anon_sym_restrict] = ACTIONS(3401),
    [anon_sym___restrict__] = ACTIONS(3401),
    [anon_sym__Atomic] = ACTIONS(3401),
    [anon_sym__Noreturn] = ACTIONS(3401),
    [anon_sym_noreturn] = ACTIONS(3401),
    [anon_sym__Nonnull] = ACTIONS(3401),
    [anon_sym_mutable] = ACTIONS(3401),
    [anon_sym_constinit] = ACTIONS(3401),
    [anon_sym_consteval] = ACTIONS(3401),
    [anon_sym_alignas] = ACTIONS(3401),
    [anon_sym__Alignas] = ACTIONS(3401),
    [sym_primitive_type] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_struct] = ACTIONS(3401),
    [anon_sym_union] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_case] = ACTIONS(3401),
    [anon_sym_default] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_goto] = ACTIONS(3401),
    [anon_sym_not] = ACTIONS(3401),
    [anon_sym_compl] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3399),
    [anon_sym_PLUS_PLUS] = ACTIONS(3399),
    [anon_sym_sizeof] = ACTIONS(3401),
    [anon_sym___alignof__] = ACTIONS(3401),
    [anon_sym___alignof] = ACTIONS(3401),
    [anon_sym__alignof] = ACTIONS(3401),
    [anon_sym_alignof] = ACTIONS(3401),
    [anon_sym__Alignof] = ACTIONS(3401),
    [anon_sym_offsetof] = ACTIONS(3401),
    [anon_sym__Generic] = ACTIONS(3401),
    [anon_sym_asm] = ACTIONS(3401),
    [anon_sym___asm__] = ACTIONS(3401),
    [anon_sym___asm] = ACTIONS(3401),
    [sym_number_literal] = ACTIONS(3399),
    [anon_sym_L_SQUOTE] = ACTIONS(3399),
    [anon_sym_u_SQUOTE] = ACTIONS(3399),
    [anon_sym_U_SQUOTE] = ACTIONS(3399),
    [anon_sym_u8_SQUOTE] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3399),
    [anon_sym_L_DQUOTE] = ACTIONS(3399),
    [anon_sym_u_DQUOTE] = ACTIONS(3399),
    [anon_sym_U_DQUOTE] = ACTIONS(3399),
    [anon_sym_u8_DQUOTE] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(3399),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [anon_sym_NULL] = ACTIONS(3401),
    [anon_sym_nullptr] = ACTIONS(3401),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3401),
    [anon_sym_decltype] = ACTIONS(3401),
    [anon_sym_explicit] = ACTIONS(3401),
    [anon_sym_typename] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(3401),
    [anon_sym_module] = ACTIONS(3401),
    [anon_sym_import] = ACTIONS(3401),
    [anon_sym_template] = ACTIONS(3401),
    [anon_sym_operator] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_delete] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_static_assert] = ACTIONS(3401),
    [anon_sym_concept] = ACTIONS(3401),
    [anon_sym_co_return] = ACTIONS(3401),
    [anon_sym_co_yield] = ACTIONS(3401),
    [anon_sym_R_DQUOTE] = ACTIONS(3399),
    [anon_sym_LR_DQUOTE] = ACTIONS(3399),
    [anon_sym_uR_DQUOTE] = ACTIONS(3399),
    [anon_sym_UR_DQUOTE] = ACTIONS(3399),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3399),
    [anon_sym_co_await] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_requires] = ACTIONS(3401),
    [sym_this] = ACTIONS(3401),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(2777),
    [sym_identifier] = ACTIONS(2775),
    [aux_sym_preproc_include_token1] = ACTIONS(2775),
    [aux_sym_preproc_def_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token1] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2775),
    [sym_preproc_directive] = ACTIONS(2775),
    [anon_sym_LPAREN2] = ACTIONS(2777),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_TILDE] = ACTIONS(2777),
    [anon_sym_DASH] = ACTIONS(2775),
    [anon_sym_PLUS] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym___extension__] = ACTIONS(2775),
    [anon_sym_typedef] = ACTIONS(2775),
    [anon_sym_virtual] = ACTIONS(2775),
    [anon_sym_extern] = ACTIONS(2775),
    [anon_sym___attribute__] = ACTIONS(2775),
    [anon_sym___attribute] = ACTIONS(2775),
    [anon_sym_using] = ACTIONS(2775),
    [anon_sym_COLON_COLON] = ACTIONS(2777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2777),
    [anon_sym___declspec] = ACTIONS(2775),
    [anon_sym___based] = ACTIONS(2775),
    [anon_sym___cdecl] = ACTIONS(2775),
    [anon_sym___clrcall] = ACTIONS(2775),
    [anon_sym___stdcall] = ACTIONS(2775),
    [anon_sym___fastcall] = ACTIONS(2775),
    [anon_sym___thiscall] = ACTIONS(2775),
    [anon_sym___vectorcall] = ACTIONS(2775),
    [anon_sym_LBRACE] = ACTIONS(2777),
    [anon_sym_signed] = ACTIONS(2775),
    [anon_sym_unsigned] = ACTIONS(2775),
    [anon_sym_long] = ACTIONS(2775),
    [anon_sym_short] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_static] = ACTIONS(2775),
    [anon_sym_register] = ACTIONS(2775),
    [anon_sym_inline] = ACTIONS(2775),
    [anon_sym___inline] = ACTIONS(2775),
    [anon_sym___inline__] = ACTIONS(2775),
    [anon_sym___forceinline] = ACTIONS(2775),
    [anon_sym_thread_local] = ACTIONS(2775),
    [anon_sym___thread] = ACTIONS(2775),
    [anon_sym_const] = ACTIONS(2775),
    [anon_sym_constexpr] = ACTIONS(2775),
    [anon_sym_volatile] = ACTIONS(2775),
    [anon_sym_restrict] = ACTIONS(2775),
    [anon_sym___restrict__] = ACTIONS(2775),
    [anon_sym__Atomic] = ACTIONS(2775),
    [anon_sym__Noreturn] = ACTIONS(2775),
    [anon_sym_noreturn] = ACTIONS(2775),
    [anon_sym__Nonnull] = ACTIONS(2775),
    [anon_sym_mutable] = ACTIONS(2775),
    [anon_sym_constinit] = ACTIONS(2775),
    [anon_sym_consteval] = ACTIONS(2775),
    [anon_sym_alignas] = ACTIONS(2775),
    [anon_sym__Alignas] = ACTIONS(2775),
    [sym_primitive_type] = ACTIONS(2775),
    [anon_sym_enum] = ACTIONS(2775),
    [anon_sym_class] = ACTIONS(2775),
    [anon_sym_struct] = ACTIONS(2775),
    [anon_sym_union] = ACTIONS(2775),
    [anon_sym_if] = ACTIONS(2775),
    [anon_sym_switch] = ACTIONS(2775),
    [anon_sym_case] = ACTIONS(2775),
    [anon_sym_default] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(2775),
    [anon_sym_do] = ACTIONS(2775),
    [anon_sym_for] = ACTIONS(2775),
    [anon_sym_return] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2775),
    [anon_sym_continue] = ACTIONS(2775),
    [anon_sym_goto] = ACTIONS(2775),
    [anon_sym_not] = ACTIONS(2775),
    [anon_sym_compl] = ACTIONS(2775),
    [anon_sym_DASH_DASH] = ACTIONS(2777),
    [anon_sym_PLUS_PLUS] = ACTIONS(2777),
    [anon_sym_sizeof] = ACTIONS(2775),
    [anon_sym___alignof__] = ACTIONS(2775),
    [anon_sym___alignof] = ACTIONS(2775),
    [anon_sym__alignof] = ACTIONS(2775),
    [anon_sym_alignof] = ACTIONS(2775),
    [anon_sym__Alignof] = ACTIONS(2775),
    [anon_sym_offsetof] = ACTIONS(2775),
    [anon_sym__Generic] = ACTIONS(2775),
    [anon_sym_asm] = ACTIONS(2775),
    [anon_sym___asm__] = ACTIONS(2775),
    [anon_sym___asm] = ACTIONS(2775),
    [sym_number_literal] = ACTIONS(2777),
    [anon_sym_L_SQUOTE] = ACTIONS(2777),
    [anon_sym_u_SQUOTE] = ACTIONS(2777),
    [anon_sym_U_SQUOTE] = ACTIONS(2777),
    [anon_sym_u8_SQUOTE] = ACTIONS(2777),
    [anon_sym_SQUOTE] = ACTIONS(2777),
    [anon_sym_L_DQUOTE] = ACTIONS(2777),
    [anon_sym_u_DQUOTE] = ACTIONS(2777),
    [anon_sym_U_DQUOTE] = ACTIONS(2777),
    [anon_sym_u8_DQUOTE] = ACTIONS(2777),
    [anon_sym_DQUOTE] = ACTIONS(2777),
    [sym_true] = ACTIONS(2775),
    [sym_false] = ACTIONS(2775),
    [anon_sym_NULL] = ACTIONS(2775),
    [anon_sym_nullptr] = ACTIONS(2775),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2775),
    [anon_sym_decltype] = ACTIONS(2775),
    [anon_sym_explicit] = ACTIONS(2775),
    [anon_sym_typename] = ACTIONS(2775),
    [anon_sym_export] = ACTIONS(2775),
    [anon_sym_module] = ACTIONS(2775),
    [anon_sym_import] = ACTIONS(2775),
    [anon_sym_template] = ACTIONS(2775),
    [anon_sym_operator] = ACTIONS(2775),
    [anon_sym_try] = ACTIONS(2775),
    [anon_sym_delete] = ACTIONS(2775),
    [anon_sym_throw] = ACTIONS(2775),
    [anon_sym_namespace] = ACTIONS(2775),
    [anon_sym_static_assert] = ACTIONS(2775),
    [anon_sym_concept] = ACTIONS(2775),
    [anon_sym_co_return] = ACTIONS(2775),
    [anon_sym_co_yield] = ACTIONS(2775),
    [anon_sym_R_DQUOTE] = ACTIONS(2777),
    [anon_sym_LR_DQUOTE] = ACTIONS(2777),
    [anon_sym_uR_DQUOTE] = ACTIONS(2777),
    [anon_sym_UR_DQUOTE] = ACTIONS(2777),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2777),
    [anon_sym_co_await] = ACTIONS(2775),
    [anon_sym_new] = ACTIONS(2775),
    [anon_sym_requires] = ACTIONS(2775),
    [sym_this] = ACTIONS(2775),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(3029),
    [sym_identifier] = ACTIONS(3027),
    [aux_sym_preproc_include_token1] = ACTIONS(3027),
    [aux_sym_preproc_def_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3027),
    [sym_preproc_directive] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3029),
    [anon_sym_BANG] = ACTIONS(3029),
    [anon_sym_TILDE] = ACTIONS(3029),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3029),
    [anon_sym_AMP_AMP] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_SEMI] = ACTIONS(3029),
    [anon_sym___extension__] = ACTIONS(3027),
    [anon_sym_typedef] = ACTIONS(3027),
    [anon_sym_virtual] = ACTIONS(3027),
    [anon_sym_extern] = ACTIONS(3027),
    [anon_sym___attribute__] = ACTIONS(3027),
    [anon_sym___attribute] = ACTIONS(3027),
    [anon_sym_using] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3029),
    [anon_sym___declspec] = ACTIONS(3027),
    [anon_sym___based] = ACTIONS(3027),
    [anon_sym___cdecl] = ACTIONS(3027),
    [anon_sym___clrcall] = ACTIONS(3027),
    [anon_sym___stdcall] = ACTIONS(3027),
    [anon_sym___fastcall] = ACTIONS(3027),
    [anon_sym___thiscall] = ACTIONS(3027),
    [anon_sym___vectorcall] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_signed] = ACTIONS(3027),
    [anon_sym_unsigned] = ACTIONS(3027),
    [anon_sym_long] = ACTIONS(3027),
    [anon_sym_short] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_static] = ACTIONS(3027),
    [anon_sym_register] = ACTIONS(3027),
    [anon_sym_inline] = ACTIONS(3027),
    [anon_sym___inline] = ACTIONS(3027),
    [anon_sym___inline__] = ACTIONS(3027),
    [anon_sym___forceinline] = ACTIONS(3027),
    [anon_sym_thread_local] = ACTIONS(3027),
    [anon_sym___thread] = ACTIONS(3027),
    [anon_sym_const] = ACTIONS(3027),
    [anon_sym_constexpr] = ACTIONS(3027),
    [anon_sym_volatile] = ACTIONS(3027),
    [anon_sym_restrict] = ACTIONS(3027),
    [anon_sym___restrict__] = ACTIONS(3027),
    [anon_sym__Atomic] = ACTIONS(3027),
    [anon_sym__Noreturn] = ACTIONS(3027),
    [anon_sym_noreturn] = ACTIONS(3027),
    [anon_sym__Nonnull] = ACTIONS(3027),
    [anon_sym_mutable] = ACTIONS(3027),
    [anon_sym_constinit] = ACTIONS(3027),
    [anon_sym_consteval] = ACTIONS(3027),
    [anon_sym_alignas] = ACTIONS(3027),
    [anon_sym__Alignas] = ACTIONS(3027),
    [sym_primitive_type] = ACTIONS(3027),
    [anon_sym_enum] = ACTIONS(3027),
    [anon_sym_class] = ACTIONS(3027),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_union] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_switch] = ACTIONS(3027),
    [anon_sym_case] = ACTIONS(3027),
    [anon_sym_default] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_goto] = ACTIONS(3027),
    [anon_sym_not] = ACTIONS(3027),
    [anon_sym_compl] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3029),
    [anon_sym_PLUS_PLUS] = ACTIONS(3029),
    [anon_sym_sizeof] = ACTIONS(3027),
    [anon_sym___alignof__] = ACTIONS(3027),
    [anon_sym___alignof] = ACTIONS(3027),
    [anon_sym__alignof] = ACTIONS(3027),
    [anon_sym_alignof] = ACTIONS(3027),
    [anon_sym__Alignof] = ACTIONS(3027),
    [anon_sym_offsetof] = ACTIONS(3027),
    [anon_sym__Generic] = ACTIONS(3027),
    [anon_sym_asm] = ACTIONS(3027),
    [anon_sym___asm__] = ACTIONS(3027),
    [anon_sym___asm] = ACTIONS(3027),
    [sym_number_literal] = ACTIONS(3029),
    [anon_sym_L_SQUOTE] = ACTIONS(3029),
    [anon_sym_u_SQUOTE] = ACTIONS(3029),
    [anon_sym_U_SQUOTE] = ACTIONS(3029),
    [anon_sym_u8_SQUOTE] = ACTIONS(3029),
    [anon_sym_SQUOTE] = ACTIONS(3029),
    [anon_sym_L_DQUOTE] = ACTIONS(3029),
    [anon_sym_u_DQUOTE] = ACTIONS(3029),
    [anon_sym_U_DQUOTE] = ACTIONS(3029),
    [anon_sym_u8_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE] = ACTIONS(3029),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [anon_sym_NULL] = ACTIONS(3027),
    [anon_sym_nullptr] = ACTIONS(3027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3027),
    [anon_sym_decltype] = ACTIONS(3027),
    [anon_sym_explicit] = ACTIONS(3027),
    [anon_sym_typename] = ACTIONS(3027),
    [anon_sym_export] = ACTIONS(3027),
    [anon_sym_module] = ACTIONS(3027),
    [anon_sym_import] = ACTIONS(3027),
    [anon_sym_template] = ACTIONS(3027),
    [anon_sym_operator] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_delete] = ACTIONS(3027),
    [anon_sym_throw] = ACTIONS(3027),
    [anon_sym_namespace] = ACTIONS(3027),
    [anon_sym_static_assert] = ACTIONS(3027),
    [anon_sym_concept] = ACTIONS(3027),
    [anon_sym_co_return] = ACTIONS(3027),
    [anon_sym_co_yield] = ACTIONS(3027),
    [anon_sym_R_DQUOTE] = ACTIONS(3029),
    [anon_sym_LR_DQUOTE] = ACTIONS(3029),
    [anon_sym_uR_DQUOTE] = ACTIONS(3029),
    [anon_sym_UR_DQUOTE] = ACTIONS(3029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3029),
    [anon_sym_co_await] = ACTIONS(3027),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_requires] = ACTIONS(3027),
    [sym_this] = ACTIONS(3027),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(2781),
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_include_token1] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym___attribute] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym___cdecl] = ACTIONS(2779),
    [anon_sym___clrcall] = ACTIONS(2779),
    [anon_sym___stdcall] = ACTIONS(2779),
    [anon_sym___fastcall] = ACTIONS(2779),
    [anon_sym___thiscall] = ACTIONS(2779),
    [anon_sym___vectorcall] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym__Nonnull] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym__Alignas] = ACTIONS(2779),
    [sym_primitive_type] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_switch] = ACTIONS(2779),
    [anon_sym_case] = ACTIONS(2779),
    [anon_sym_default] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [anon_sym_do] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2779),
    [anon_sym_continue] = ACTIONS(2779),
    [anon_sym_goto] = ACTIONS(2779),
    [anon_sym_not] = ACTIONS(2779),
    [anon_sym_compl] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2781),
    [anon_sym_sizeof] = ACTIONS(2779),
    [anon_sym___alignof__] = ACTIONS(2779),
    [anon_sym___alignof] = ACTIONS(2779),
    [anon_sym__alignof] = ACTIONS(2779),
    [anon_sym_alignof] = ACTIONS(2779),
    [anon_sym__Alignof] = ACTIONS(2779),
    [anon_sym_offsetof] = ACTIONS(2779),
    [anon_sym__Generic] = ACTIONS(2779),
    [anon_sym_asm] = ACTIONS(2779),
    [anon_sym___asm__] = ACTIONS(2779),
    [anon_sym___asm] = ACTIONS(2779),
    [sym_number_literal] = ACTIONS(2781),
    [anon_sym_L_SQUOTE] = ACTIONS(2781),
    [anon_sym_u_SQUOTE] = ACTIONS(2781),
    [anon_sym_U_SQUOTE] = ACTIONS(2781),
    [anon_sym_u8_SQUOTE] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_L_DQUOTE] = ACTIONS(2781),
    [anon_sym_u_DQUOTE] = ACTIONS(2781),
    [anon_sym_U_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8_DQUOTE] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2781),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [anon_sym_NULL] = ACTIONS(2779),
    [anon_sym_nullptr] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_export] = ACTIONS(2779),
    [anon_sym_module] = ACTIONS(2779),
    [anon_sym_import] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_delete] = ACTIONS(2779),
    [anon_sym_throw] = ACTIONS(2779),
    [anon_sym_namespace] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
    [anon_sym_concept] = ACTIONS(2779),
    [anon_sym_co_return] = ACTIONS(2779),
    [anon_sym_co_yield] = ACTIONS(2779),
    [anon_sym_R_DQUOTE] = ACTIONS(2781),
    [anon_sym_LR_DQUOTE] = ACTIONS(2781),
    [anon_sym_uR_DQUOTE] = ACTIONS(2781),
    [anon_sym_UR_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2781),
    [anon_sym_co_await] = ACTIONS(2779),
    [anon_sym_new] = ACTIONS(2779),
    [anon_sym_requires] = ACTIONS(2779),
    [sym_this] = ACTIONS(2779),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(3033),
    [sym_identifier] = ACTIONS(3031),
    [aux_sym_preproc_include_token1] = ACTIONS(3031),
    [aux_sym_preproc_def_token1] = ACTIONS(3031),
    [aux_sym_preproc_if_token1] = ACTIONS(3031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3031),
    [sym_preproc_directive] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3033),
    [anon_sym_BANG] = ACTIONS(3033),
    [anon_sym_TILDE] = ACTIONS(3033),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_SEMI] = ACTIONS(3033),
    [anon_sym___extension__] = ACTIONS(3031),
    [anon_sym_typedef] = ACTIONS(3031),
    [anon_sym_virtual] = ACTIONS(3031),
    [anon_sym_extern] = ACTIONS(3031),
    [anon_sym___attribute__] = ACTIONS(3031),
    [anon_sym___attribute] = ACTIONS(3031),
    [anon_sym_using] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3033),
    [anon_sym___declspec] = ACTIONS(3031),
    [anon_sym___based] = ACTIONS(3031),
    [anon_sym___cdecl] = ACTIONS(3031),
    [anon_sym___clrcall] = ACTIONS(3031),
    [anon_sym___stdcall] = ACTIONS(3031),
    [anon_sym___fastcall] = ACTIONS(3031),
    [anon_sym___thiscall] = ACTIONS(3031),
    [anon_sym___vectorcall] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3033),
    [anon_sym_signed] = ACTIONS(3031),
    [anon_sym_unsigned] = ACTIONS(3031),
    [anon_sym_long] = ACTIONS(3031),
    [anon_sym_short] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_static] = ACTIONS(3031),
    [anon_sym_register] = ACTIONS(3031),
    [anon_sym_inline] = ACTIONS(3031),
    [anon_sym___inline] = ACTIONS(3031),
    [anon_sym___inline__] = ACTIONS(3031),
    [anon_sym___forceinline] = ACTIONS(3031),
    [anon_sym_thread_local] = ACTIONS(3031),
    [anon_sym___thread] = ACTIONS(3031),
    [anon_sym_const] = ACTIONS(3031),
    [anon_sym_constexpr] = ACTIONS(3031),
    [anon_sym_volatile] = ACTIONS(3031),
    [anon_sym_restrict] = ACTIONS(3031),
    [anon_sym___restrict__] = ACTIONS(3031),
    [anon_sym__Atomic] = ACTIONS(3031),
    [anon_sym__Noreturn] = ACTIONS(3031),
    [anon_sym_noreturn] = ACTIONS(3031),
    [anon_sym__Nonnull] = ACTIONS(3031),
    [anon_sym_mutable] = ACTIONS(3031),
    [anon_sym_constinit] = ACTIONS(3031),
    [anon_sym_consteval] = ACTIONS(3031),
    [anon_sym_alignas] = ACTIONS(3031),
    [anon_sym__Alignas] = ACTIONS(3031),
    [sym_primitive_type] = ACTIONS(3031),
    [anon_sym_enum] = ACTIONS(3031),
    [anon_sym_class] = ACTIONS(3031),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_union] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_switch] = ACTIONS(3031),
    [anon_sym_case] = ACTIONS(3031),
    [anon_sym_default] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_goto] = ACTIONS(3031),
    [anon_sym_not] = ACTIONS(3031),
    [anon_sym_compl] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3033),
    [anon_sym_PLUS_PLUS] = ACTIONS(3033),
    [anon_sym_sizeof] = ACTIONS(3031),
    [anon_sym___alignof__] = ACTIONS(3031),
    [anon_sym___alignof] = ACTIONS(3031),
    [anon_sym__alignof] = ACTIONS(3031),
    [anon_sym_alignof] = ACTIONS(3031),
    [anon_sym__Alignof] = ACTIONS(3031),
    [anon_sym_offsetof] = ACTIONS(3031),
    [anon_sym__Generic] = ACTIONS(3031),
    [anon_sym_asm] = ACTIONS(3031),
    [anon_sym___asm__] = ACTIONS(3031),
    [anon_sym___asm] = ACTIONS(3031),
    [sym_number_literal] = ACTIONS(3033),
    [anon_sym_L_SQUOTE] = ACTIONS(3033),
    [anon_sym_u_SQUOTE] = ACTIONS(3033),
    [anon_sym_U_SQUOTE] = ACTIONS(3033),
    [anon_sym_u8_SQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3033),
    [anon_sym_L_DQUOTE] = ACTIONS(3033),
    [anon_sym_u_DQUOTE] = ACTIONS(3033),
    [anon_sym_U_DQUOTE] = ACTIONS(3033),
    [anon_sym_u8_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [anon_sym_NULL] = ACTIONS(3031),
    [anon_sym_nullptr] = ACTIONS(3031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3031),
    [anon_sym_decltype] = ACTIONS(3031),
    [anon_sym_explicit] = ACTIONS(3031),
    [anon_sym_typename] = ACTIONS(3031),
    [anon_sym_export] = ACTIONS(3031),
    [anon_sym_module] = ACTIONS(3031),
    [anon_sym_import] = ACTIONS(3031),
    [anon_sym_template] = ACTIONS(3031),
    [anon_sym_operator] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_delete] = ACTIONS(3031),
    [anon_sym_throw] = ACTIONS(3031),
    [anon_sym_namespace] = ACTIONS(3031),
    [anon_sym_static_assert] = ACTIONS(3031),
    [anon_sym_concept] = ACTIONS(3031),
    [anon_sym_co_return] = ACTIONS(3031),
    [anon_sym_co_yield] = ACTIONS(3031),
    [anon_sym_R_DQUOTE] = ACTIONS(3033),
    [anon_sym_LR_DQUOTE] = ACTIONS(3033),
    [anon_sym_uR_DQUOTE] = ACTIONS(3033),
    [anon_sym_UR_DQUOTE] = ACTIONS(3033),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3033),
    [anon_sym_co_await] = ACTIONS(3031),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_requires] = ACTIONS(3031),
    [sym_this] = ACTIONS(3031),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(3037),
    [sym_identifier] = ACTIONS(3035),
    [aux_sym_preproc_include_token1] = ACTIONS(3035),
    [aux_sym_preproc_def_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token1] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3035),
    [sym_preproc_directive] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3037),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_AMP_AMP] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_SEMI] = ACTIONS(3037),
    [anon_sym___extension__] = ACTIONS(3035),
    [anon_sym_typedef] = ACTIONS(3035),
    [anon_sym_virtual] = ACTIONS(3035),
    [anon_sym_extern] = ACTIONS(3035),
    [anon_sym___attribute__] = ACTIONS(3035),
    [anon_sym___attribute] = ACTIONS(3035),
    [anon_sym_using] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3037),
    [anon_sym___declspec] = ACTIONS(3035),
    [anon_sym___based] = ACTIONS(3035),
    [anon_sym___cdecl] = ACTIONS(3035),
    [anon_sym___clrcall] = ACTIONS(3035),
    [anon_sym___stdcall] = ACTIONS(3035),
    [anon_sym___fastcall] = ACTIONS(3035),
    [anon_sym___thiscall] = ACTIONS(3035),
    [anon_sym___vectorcall] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3037),
    [anon_sym_signed] = ACTIONS(3035),
    [anon_sym_unsigned] = ACTIONS(3035),
    [anon_sym_long] = ACTIONS(3035),
    [anon_sym_short] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3035),
    [anon_sym_register] = ACTIONS(3035),
    [anon_sym_inline] = ACTIONS(3035),
    [anon_sym___inline] = ACTIONS(3035),
    [anon_sym___inline__] = ACTIONS(3035),
    [anon_sym___forceinline] = ACTIONS(3035),
    [anon_sym_thread_local] = ACTIONS(3035),
    [anon_sym___thread] = ACTIONS(3035),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_constexpr] = ACTIONS(3035),
    [anon_sym_volatile] = ACTIONS(3035),
    [anon_sym_restrict] = ACTIONS(3035),
    [anon_sym___restrict__] = ACTIONS(3035),
    [anon_sym__Atomic] = ACTIONS(3035),
    [anon_sym__Noreturn] = ACTIONS(3035),
    [anon_sym_noreturn] = ACTIONS(3035),
    [anon_sym__Nonnull] = ACTIONS(3035),
    [anon_sym_mutable] = ACTIONS(3035),
    [anon_sym_constinit] = ACTIONS(3035),
    [anon_sym_consteval] = ACTIONS(3035),
    [anon_sym_alignas] = ACTIONS(3035),
    [anon_sym__Alignas] = ACTIONS(3035),
    [sym_primitive_type] = ACTIONS(3035),
    [anon_sym_enum] = ACTIONS(3035),
    [anon_sym_class] = ACTIONS(3035),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_union] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_switch] = ACTIONS(3035),
    [anon_sym_case] = ACTIONS(3035),
    [anon_sym_default] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_break] = ACTIONS(3035),
    [anon_sym_continue] = ACTIONS(3035),
    [anon_sym_goto] = ACTIONS(3035),
    [anon_sym_not] = ACTIONS(3035),
    [anon_sym_compl] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3037),
    [anon_sym_sizeof] = ACTIONS(3035),
    [anon_sym___alignof__] = ACTIONS(3035),
    [anon_sym___alignof] = ACTIONS(3035),
    [anon_sym__alignof] = ACTIONS(3035),
    [anon_sym_alignof] = ACTIONS(3035),
    [anon_sym__Alignof] = ACTIONS(3035),
    [anon_sym_offsetof] = ACTIONS(3035),
    [anon_sym__Generic] = ACTIONS(3035),
    [anon_sym_asm] = ACTIONS(3035),
    [anon_sym___asm__] = ACTIONS(3035),
    [anon_sym___asm] = ACTIONS(3035),
    [sym_number_literal] = ACTIONS(3037),
    [anon_sym_L_SQUOTE] = ACTIONS(3037),
    [anon_sym_u_SQUOTE] = ACTIONS(3037),
    [anon_sym_U_SQUOTE] = ACTIONS(3037),
    [anon_sym_u8_SQUOTE] = ACTIONS(3037),
    [anon_sym_SQUOTE] = ACTIONS(3037),
    [anon_sym_L_DQUOTE] = ACTIONS(3037),
    [anon_sym_u_DQUOTE] = ACTIONS(3037),
    [anon_sym_U_DQUOTE] = ACTIONS(3037),
    [anon_sym_u8_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE] = ACTIONS(3037),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [anon_sym_NULL] = ACTIONS(3035),
    [anon_sym_nullptr] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3035),
    [anon_sym_decltype] = ACTIONS(3035),
    [anon_sym_explicit] = ACTIONS(3035),
    [anon_sym_typename] = ACTIONS(3035),
    [anon_sym_export] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(3035),
    [anon_sym_import] = ACTIONS(3035),
    [anon_sym_template] = ACTIONS(3035),
    [anon_sym_operator] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_delete] = ACTIONS(3035),
    [anon_sym_throw] = ACTIONS(3035),
    [anon_sym_namespace] = ACTIONS(3035),
    [anon_sym_static_assert] = ACTIONS(3035),
    [anon_sym_concept] = ACTIONS(3035),
    [anon_sym_co_return] = ACTIONS(3035),
    [anon_sym_co_yield] = ACTIONS(3035),
    [anon_sym_R_DQUOTE] = ACTIONS(3037),
    [anon_sym_LR_DQUOTE] = ACTIONS(3037),
    [anon_sym_uR_DQUOTE] = ACTIONS(3037),
    [anon_sym_UR_DQUOTE] = ACTIONS(3037),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3037),
    [anon_sym_co_await] = ACTIONS(3035),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_requires] = ACTIONS(3035),
    [sym_this] = ACTIONS(3035),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(3041),
    [sym_identifier] = ACTIONS(3039),
    [aux_sym_preproc_include_token1] = ACTIONS(3039),
    [aux_sym_preproc_def_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token1] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3039),
    [sym_preproc_directive] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym___extension__] = ACTIONS(3039),
    [anon_sym_typedef] = ACTIONS(3039),
    [anon_sym_virtual] = ACTIONS(3039),
    [anon_sym_extern] = ACTIONS(3039),
    [anon_sym___attribute__] = ACTIONS(3039),
    [anon_sym___attribute] = ACTIONS(3039),
    [anon_sym_using] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3041),
    [anon_sym___declspec] = ACTIONS(3039),
    [anon_sym___based] = ACTIONS(3039),
    [anon_sym___cdecl] = ACTIONS(3039),
    [anon_sym___clrcall] = ACTIONS(3039),
    [anon_sym___stdcall] = ACTIONS(3039),
    [anon_sym___fastcall] = ACTIONS(3039),
    [anon_sym___thiscall] = ACTIONS(3039),
    [anon_sym___vectorcall] = ACTIONS(3039),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_signed] = ACTIONS(3039),
    [anon_sym_unsigned] = ACTIONS(3039),
    [anon_sym_long] = ACTIONS(3039),
    [anon_sym_short] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3039),
    [anon_sym_register] = ACTIONS(3039),
    [anon_sym_inline] = ACTIONS(3039),
    [anon_sym___inline] = ACTIONS(3039),
    [anon_sym___inline__] = ACTIONS(3039),
    [anon_sym___forceinline] = ACTIONS(3039),
    [anon_sym_thread_local] = ACTIONS(3039),
    [anon_sym___thread] = ACTIONS(3039),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_constexpr] = ACTIONS(3039),
    [anon_sym_volatile] = ACTIONS(3039),
    [anon_sym_restrict] = ACTIONS(3039),
    [anon_sym___restrict__] = ACTIONS(3039),
    [anon_sym__Atomic] = ACTIONS(3039),
    [anon_sym__Noreturn] = ACTIONS(3039),
    [anon_sym_noreturn] = ACTIONS(3039),
    [anon_sym__Nonnull] = ACTIONS(3039),
    [anon_sym_mutable] = ACTIONS(3039),
    [anon_sym_constinit] = ACTIONS(3039),
    [anon_sym_consteval] = ACTIONS(3039),
    [anon_sym_alignas] = ACTIONS(3039),
    [anon_sym__Alignas] = ACTIONS(3039),
    [sym_primitive_type] = ACTIONS(3039),
    [anon_sym_enum] = ACTIONS(3039),
    [anon_sym_class] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3039),
    [anon_sym_union] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_switch] = ACTIONS(3039),
    [anon_sym_case] = ACTIONS(3039),
    [anon_sym_default] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_break] = ACTIONS(3039),
    [anon_sym_continue] = ACTIONS(3039),
    [anon_sym_goto] = ACTIONS(3039),
    [anon_sym_not] = ACTIONS(3039),
    [anon_sym_compl] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3041),
    [anon_sym_sizeof] = ACTIONS(3039),
    [anon_sym___alignof__] = ACTIONS(3039),
    [anon_sym___alignof] = ACTIONS(3039),
    [anon_sym__alignof] = ACTIONS(3039),
    [anon_sym_alignof] = ACTIONS(3039),
    [anon_sym__Alignof] = ACTIONS(3039),
    [anon_sym_offsetof] = ACTIONS(3039),
    [anon_sym__Generic] = ACTIONS(3039),
    [anon_sym_asm] = ACTIONS(3039),
    [anon_sym___asm__] = ACTIONS(3039),
    [anon_sym___asm] = ACTIONS(3039),
    [sym_number_literal] = ACTIONS(3041),
    [anon_sym_L_SQUOTE] = ACTIONS(3041),
    [anon_sym_u_SQUOTE] = ACTIONS(3041),
    [anon_sym_U_SQUOTE] = ACTIONS(3041),
    [anon_sym_u8_SQUOTE] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_L_DQUOTE] = ACTIONS(3041),
    [anon_sym_u_DQUOTE] = ACTIONS(3041),
    [anon_sym_U_DQUOTE] = ACTIONS(3041),
    [anon_sym_u8_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [sym_true] = ACTIONS(3039),
    [sym_false] = ACTIONS(3039),
    [anon_sym_NULL] = ACTIONS(3039),
    [anon_sym_nullptr] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3039),
    [anon_sym_decltype] = ACTIONS(3039),
    [anon_sym_explicit] = ACTIONS(3039),
    [anon_sym_typename] = ACTIONS(3039),
    [anon_sym_export] = ACTIONS(3039),
    [anon_sym_module] = ACTIONS(3039),
    [anon_sym_import] = ACTIONS(3039),
    [anon_sym_template] = ACTIONS(3039),
    [anon_sym_operator] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_delete] = ACTIONS(3039),
    [anon_sym_throw] = ACTIONS(3039),
    [anon_sym_namespace] = ACTIONS(3039),
    [anon_sym_static_assert] = ACTIONS(3039),
    [anon_sym_concept] = ACTIONS(3039),
    [anon_sym_co_return] = ACTIONS(3039),
    [anon_sym_co_yield] = ACTIONS(3039),
    [anon_sym_R_DQUOTE] = ACTIONS(3041),
    [anon_sym_LR_DQUOTE] = ACTIONS(3041),
    [anon_sym_uR_DQUOTE] = ACTIONS(3041),
    [anon_sym_UR_DQUOTE] = ACTIONS(3041),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3041),
    [anon_sym_co_await] = ACTIONS(3039),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_requires] = ACTIONS(3039),
    [sym_this] = ACTIONS(3039),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2835),
    [aux_sym_preproc_include_token1] = ACTIONS(2835),
    [aux_sym_preproc_def_token1] = ACTIONS(2835),
    [aux_sym_preproc_if_token1] = ACTIONS(2835),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2835),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2835),
    [sym_preproc_directive] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym___extension__] = ACTIONS(2835),
    [anon_sym_typedef] = ACTIONS(2835),
    [anon_sym_virtual] = ACTIONS(2835),
    [anon_sym_extern] = ACTIONS(2835),
    [anon_sym___attribute__] = ACTIONS(2835),
    [anon_sym___attribute] = ACTIONS(2835),
    [anon_sym_using] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2837),
    [anon_sym___declspec] = ACTIONS(2835),
    [anon_sym___based] = ACTIONS(2835),
    [anon_sym___cdecl] = ACTIONS(2835),
    [anon_sym___clrcall] = ACTIONS(2835),
    [anon_sym___stdcall] = ACTIONS(2835),
    [anon_sym___fastcall] = ACTIONS(2835),
    [anon_sym___thiscall] = ACTIONS(2835),
    [anon_sym___vectorcall] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_signed] = ACTIONS(2835),
    [anon_sym_unsigned] = ACTIONS(2835),
    [anon_sym_long] = ACTIONS(2835),
    [anon_sym_short] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_static] = ACTIONS(2835),
    [anon_sym_register] = ACTIONS(2835),
    [anon_sym_inline] = ACTIONS(2835),
    [anon_sym___inline] = ACTIONS(2835),
    [anon_sym___inline__] = ACTIONS(2835),
    [anon_sym___forceinline] = ACTIONS(2835),
    [anon_sym_thread_local] = ACTIONS(2835),
    [anon_sym___thread] = ACTIONS(2835),
    [anon_sym_const] = ACTIONS(2835),
    [anon_sym_constexpr] = ACTIONS(2835),
    [anon_sym_volatile] = ACTIONS(2835),
    [anon_sym_restrict] = ACTIONS(2835),
    [anon_sym___restrict__] = ACTIONS(2835),
    [anon_sym__Atomic] = ACTIONS(2835),
    [anon_sym__Noreturn] = ACTIONS(2835),
    [anon_sym_noreturn] = ACTIONS(2835),
    [anon_sym__Nonnull] = ACTIONS(2835),
    [anon_sym_mutable] = ACTIONS(2835),
    [anon_sym_constinit] = ACTIONS(2835),
    [anon_sym_consteval] = ACTIONS(2835),
    [anon_sym_alignas] = ACTIONS(2835),
    [anon_sym__Alignas] = ACTIONS(2835),
    [sym_primitive_type] = ACTIONS(2835),
    [anon_sym_enum] = ACTIONS(2835),
    [anon_sym_class] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2835),
    [anon_sym_union] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_switch] = ACTIONS(2835),
    [anon_sym_case] = ACTIONS(2835),
    [anon_sym_default] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_break] = ACTIONS(2835),
    [anon_sym_continue] = ACTIONS(2835),
    [anon_sym_goto] = ACTIONS(2835),
    [anon_sym_not] = ACTIONS(2835),
    [anon_sym_compl] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2835),
    [anon_sym___alignof] = ACTIONS(2835),
    [anon_sym__alignof] = ACTIONS(2835),
    [anon_sym_alignof] = ACTIONS(2835),
    [anon_sym__Alignof] = ACTIONS(2835),
    [anon_sym_offsetof] = ACTIONS(2835),
    [anon_sym__Generic] = ACTIONS(2835),
    [anon_sym_asm] = ACTIONS(2835),
    [anon_sym___asm__] = ACTIONS(2835),
    [anon_sym___asm] = ACTIONS(2835),
    [sym_number_literal] = ACTIONS(2837),
    [anon_sym_L_SQUOTE] = ACTIONS(2837),
    [anon_sym_u_SQUOTE] = ACTIONS(2837),
    [anon_sym_U_SQUOTE] = ACTIONS(2837),
    [anon_sym_u8_SQUOTE] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_L_DQUOTE] = ACTIONS(2837),
    [anon_sym_u_DQUOTE] = ACTIONS(2837),
    [anon_sym_U_DQUOTE] = ACTIONS(2837),
    [anon_sym_u8_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [sym_true] = ACTIONS(2835),
    [sym_false] = ACTIONS(2835),
    [anon_sym_NULL] = ACTIONS(2835),
    [anon_sym_nullptr] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2835),
    [anon_sym_decltype] = ACTIONS(2835),
    [anon_sym_explicit] = ACTIONS(2835),
    [anon_sym_typename] = ACTIONS(2835),
    [anon_sym_export] = ACTIONS(2835),
    [anon_sym_module] = ACTIONS(2835),
    [anon_sym_import] = ACTIONS(2835),
    [anon_sym_template] = ACTIONS(2835),
    [anon_sym_operator] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_delete] = ACTIONS(2835),
    [anon_sym_throw] = ACTIONS(2835),
    [anon_sym_namespace] = ACTIONS(2835),
    [anon_sym_static_assert] = ACTIONS(2835),
    [anon_sym_concept] = ACTIONS(2835),
    [anon_sym_co_return] = ACTIONS(2835),
    [anon_sym_co_yield] = ACTIONS(2835),
    [anon_sym_R_DQUOTE] = ACTIONS(2837),
    [anon_sym_LR_DQUOTE] = ACTIONS(2837),
    [anon_sym_uR_DQUOTE] = ACTIONS(2837),
    [anon_sym_UR_DQUOTE] = ACTIONS(2837),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2837),
    [anon_sym_co_await] = ACTIONS(2835),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_requires] = ACTIONS(2835),
    [sym_this] = ACTIONS(2835),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_include_token1] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym___cdecl] = ACTIONS(3063),
    [anon_sym___clrcall] = ACTIONS(3063),
    [anon_sym___stdcall] = ACTIONS(3063),
    [anon_sym___fastcall] = ACTIONS(3063),
    [anon_sym___thiscall] = ACTIONS(3063),
    [anon_sym___vectorcall] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(3063),
    [anon_sym_compl] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym___alignof__] = ACTIONS(3063),
    [anon_sym___alignof] = ACTIONS(3063),
    [anon_sym__alignof] = ACTIONS(3063),
    [anon_sym_alignof] = ACTIONS(3063),
    [anon_sym__Alignof] = ACTIONS(3063),
    [anon_sym_offsetof] = ACTIONS(3063),
    [anon_sym__Generic] = ACTIONS(3063),
    [anon_sym_asm] = ACTIONS(3063),
    [anon_sym___asm__] = ACTIONS(3063),
    [anon_sym___asm] = ACTIONS(3063),
    [sym_number_literal] = ACTIONS(3065),
    [anon_sym_L_SQUOTE] = ACTIONS(3065),
    [anon_sym_u_SQUOTE] = ACTIONS(3065),
    [anon_sym_U_SQUOTE] = ACTIONS(3065),
    [anon_sym_u8_SQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_L_DQUOTE] = ACTIONS(3065),
    [anon_sym_u_DQUOTE] = ACTIONS(3065),
    [anon_sym_U_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [sym_true] = ACTIONS(3063),
    [sym_false] = ACTIONS(3063),
    [anon_sym_NULL] = ACTIONS(3063),
    [anon_sym_nullptr] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_export] = ACTIONS(3063),
    [anon_sym_module] = ACTIONS(3063),
    [anon_sym_import] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
    [anon_sym_concept] = ACTIONS(3063),
    [anon_sym_co_return] = ACTIONS(3063),
    [anon_sym_co_yield] = ACTIONS(3063),
    [anon_sym_R_DQUOTE] = ACTIONS(3065),
    [anon_sym_LR_DQUOTE] = ACTIONS(3065),
    [anon_sym_uR_DQUOTE] = ACTIONS(3065),
    [anon_sym_UR_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3065),
    [anon_sym_co_await] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_requires] = ACTIONS(3063),
    [sym_this] = ACTIONS(3063),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_include_token1] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym___cdecl] = ACTIONS(3063),
    [anon_sym___clrcall] = ACTIONS(3063),
    [anon_sym___stdcall] = ACTIONS(3063),
    [anon_sym___fastcall] = ACTIONS(3063),
    [anon_sym___thiscall] = ACTIONS(3063),
    [anon_sym___vectorcall] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(3063),
    [anon_sym_compl] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym___alignof__] = ACTIONS(3063),
    [anon_sym___alignof] = ACTIONS(3063),
    [anon_sym__alignof] = ACTIONS(3063),
    [anon_sym_alignof] = ACTIONS(3063),
    [anon_sym__Alignof] = ACTIONS(3063),
    [anon_sym_offsetof] = ACTIONS(3063),
    [anon_sym__Generic] = ACTIONS(3063),
    [anon_sym_asm] = ACTIONS(3063),
    [anon_sym___asm__] = ACTIONS(3063),
    [anon_sym___asm] = ACTIONS(3063),
    [sym_number_literal] = ACTIONS(3065),
    [anon_sym_L_SQUOTE] = ACTIONS(3065),
    [anon_sym_u_SQUOTE] = ACTIONS(3065),
    [anon_sym_U_SQUOTE] = ACTIONS(3065),
    [anon_sym_u8_SQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_L_DQUOTE] = ACTIONS(3065),
    [anon_sym_u_DQUOTE] = ACTIONS(3065),
    [anon_sym_U_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [sym_true] = ACTIONS(3063),
    [sym_false] = ACTIONS(3063),
    [anon_sym_NULL] = ACTIONS(3063),
    [anon_sym_nullptr] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_export] = ACTIONS(3063),
    [anon_sym_module] = ACTIONS(3063),
    [anon_sym_import] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
    [anon_sym_concept] = ACTIONS(3063),
    [anon_sym_co_return] = ACTIONS(3063),
    [anon_sym_co_yield] = ACTIONS(3063),
    [anon_sym_R_DQUOTE] = ACTIONS(3065),
    [anon_sym_LR_DQUOTE] = ACTIONS(3065),
    [anon_sym_uR_DQUOTE] = ACTIONS(3065),
    [anon_sym_UR_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3065),
    [anon_sym_co_await] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_requires] = ACTIONS(3063),
    [sym_this] = ACTIONS(3063),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(2805),
    [sym_identifier] = ACTIONS(2803),
    [aux_sym_preproc_include_token1] = ACTIONS(2803),
    [aux_sym_preproc_def_token1] = ACTIONS(2803),
    [aux_sym_preproc_if_token1] = ACTIONS(2803),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2803),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2803),
    [sym_preproc_directive] = ACTIONS(2803),
    [anon_sym_LPAREN2] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(2805),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2803),
    [anon_sym_PLUS] = ACTIONS(2803),
    [anon_sym_STAR] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2805),
    [anon_sym_AMP] = ACTIONS(2803),
    [anon_sym_SEMI] = ACTIONS(2805),
    [anon_sym___extension__] = ACTIONS(2803),
    [anon_sym_typedef] = ACTIONS(2803),
    [anon_sym_virtual] = ACTIONS(2803),
    [anon_sym_extern] = ACTIONS(2803),
    [anon_sym___attribute__] = ACTIONS(2803),
    [anon_sym___attribute] = ACTIONS(2803),
    [anon_sym_using] = ACTIONS(2803),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2805),
    [anon_sym___declspec] = ACTIONS(2803),
    [anon_sym___based] = ACTIONS(2803),
    [anon_sym___cdecl] = ACTIONS(2803),
    [anon_sym___clrcall] = ACTIONS(2803),
    [anon_sym___stdcall] = ACTIONS(2803),
    [anon_sym___fastcall] = ACTIONS(2803),
    [anon_sym___thiscall] = ACTIONS(2803),
    [anon_sym___vectorcall] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(2805),
    [anon_sym_signed] = ACTIONS(2803),
    [anon_sym_unsigned] = ACTIONS(2803),
    [anon_sym_long] = ACTIONS(2803),
    [anon_sym_short] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_static] = ACTIONS(2803),
    [anon_sym_register] = ACTIONS(2803),
    [anon_sym_inline] = ACTIONS(2803),
    [anon_sym___inline] = ACTIONS(2803),
    [anon_sym___inline__] = ACTIONS(2803),
    [anon_sym___forceinline] = ACTIONS(2803),
    [anon_sym_thread_local] = ACTIONS(2803),
    [anon_sym___thread] = ACTIONS(2803),
    [anon_sym_const] = ACTIONS(2803),
    [anon_sym_constexpr] = ACTIONS(2803),
    [anon_sym_volatile] = ACTIONS(2803),
    [anon_sym_restrict] = ACTIONS(2803),
    [anon_sym___restrict__] = ACTIONS(2803),
    [anon_sym__Atomic] = ACTIONS(2803),
    [anon_sym__Noreturn] = ACTIONS(2803),
    [anon_sym_noreturn] = ACTIONS(2803),
    [anon_sym__Nonnull] = ACTIONS(2803),
    [anon_sym_mutable] = ACTIONS(2803),
    [anon_sym_constinit] = ACTIONS(2803),
    [anon_sym_consteval] = ACTIONS(2803),
    [anon_sym_alignas] = ACTIONS(2803),
    [anon_sym__Alignas] = ACTIONS(2803),
    [sym_primitive_type] = ACTIONS(2803),
    [anon_sym_enum] = ACTIONS(2803),
    [anon_sym_class] = ACTIONS(2803),
    [anon_sym_struct] = ACTIONS(2803),
    [anon_sym_union] = ACTIONS(2803),
    [anon_sym_if] = ACTIONS(2803),
    [anon_sym_switch] = ACTIONS(2803),
    [anon_sym_case] = ACTIONS(2803),
    [anon_sym_default] = ACTIONS(2803),
    [anon_sym_while] = ACTIONS(2803),
    [anon_sym_do] = ACTIONS(2803),
    [anon_sym_for] = ACTIONS(2803),
    [anon_sym_return] = ACTIONS(2803),
    [anon_sym_break] = ACTIONS(2803),
    [anon_sym_continue] = ACTIONS(2803),
    [anon_sym_goto] = ACTIONS(2803),
    [anon_sym_not] = ACTIONS(2803),
    [anon_sym_compl] = ACTIONS(2803),
    [anon_sym_DASH_DASH] = ACTIONS(2805),
    [anon_sym_PLUS_PLUS] = ACTIONS(2805),
    [anon_sym_sizeof] = ACTIONS(2803),
    [anon_sym___alignof__] = ACTIONS(2803),
    [anon_sym___alignof] = ACTIONS(2803),
    [anon_sym__alignof] = ACTIONS(2803),
    [anon_sym_alignof] = ACTIONS(2803),
    [anon_sym__Alignof] = ACTIONS(2803),
    [anon_sym_offsetof] = ACTIONS(2803),
    [anon_sym__Generic] = ACTIONS(2803),
    [anon_sym_asm] = ACTIONS(2803),
    [anon_sym___asm__] = ACTIONS(2803),
    [anon_sym___asm] = ACTIONS(2803),
    [sym_number_literal] = ACTIONS(2805),
    [anon_sym_L_SQUOTE] = ACTIONS(2805),
    [anon_sym_u_SQUOTE] = ACTIONS(2805),
    [anon_sym_U_SQUOTE] = ACTIONS(2805),
    [anon_sym_u8_SQUOTE] = ACTIONS(2805),
    [anon_sym_SQUOTE] = ACTIONS(2805),
    [anon_sym_L_DQUOTE] = ACTIONS(2805),
    [anon_sym_u_DQUOTE] = ACTIONS(2805),
    [anon_sym_U_DQUOTE] = ACTIONS(2805),
    [anon_sym_u8_DQUOTE] = ACTIONS(2805),
    [anon_sym_DQUOTE] = ACTIONS(2805),
    [sym_true] = ACTIONS(2803),
    [sym_false] = ACTIONS(2803),
    [anon_sym_NULL] = ACTIONS(2803),
    [anon_sym_nullptr] = ACTIONS(2803),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2803),
    [anon_sym_decltype] = ACTIONS(2803),
    [anon_sym_explicit] = ACTIONS(2803),
    [anon_sym_typename] = ACTIONS(2803),
    [anon_sym_export] = ACTIONS(2803),
    [anon_sym_module] = ACTIONS(2803),
    [anon_sym_import] = ACTIONS(2803),
    [anon_sym_template] = ACTIONS(2803),
    [anon_sym_operator] = ACTIONS(2803),
    [anon_sym_try] = ACTIONS(2803),
    [anon_sym_delete] = ACTIONS(2803),
    [anon_sym_throw] = ACTIONS(2803),
    [anon_sym_namespace] = ACTIONS(2803),
    [anon_sym_static_assert] = ACTIONS(2803),
    [anon_sym_concept] = ACTIONS(2803),
    [anon_sym_co_return] = ACTIONS(2803),
    [anon_sym_co_yield] = ACTIONS(2803),
    [anon_sym_R_DQUOTE] = ACTIONS(2805),
    [anon_sym_LR_DQUOTE] = ACTIONS(2805),
    [anon_sym_uR_DQUOTE] = ACTIONS(2805),
    [anon_sym_UR_DQUOTE] = ACTIONS(2805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2805),
    [anon_sym_co_await] = ACTIONS(2803),
    [anon_sym_new] = ACTIONS(2803),
    [anon_sym_requires] = ACTIONS(2803),
    [sym_this] = ACTIONS(2803),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(3069),
    [sym_identifier] = ACTIONS(3067),
    [aux_sym_preproc_include_token1] = ACTIONS(3067),
    [aux_sym_preproc_def_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3067),
    [sym_preproc_directive] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym___extension__] = ACTIONS(3067),
    [anon_sym_typedef] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym___attribute__] = ACTIONS(3067),
    [anon_sym___attribute] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3069),
    [anon_sym___declspec] = ACTIONS(3067),
    [anon_sym___based] = ACTIONS(3067),
    [anon_sym___cdecl] = ACTIONS(3067),
    [anon_sym___clrcall] = ACTIONS(3067),
    [anon_sym___stdcall] = ACTIONS(3067),
    [anon_sym___fastcall] = ACTIONS(3067),
    [anon_sym___thiscall] = ACTIONS(3067),
    [anon_sym___vectorcall] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_signed] = ACTIONS(3067),
    [anon_sym_unsigned] = ACTIONS(3067),
    [anon_sym_long] = ACTIONS(3067),
    [anon_sym_short] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_register] = ACTIONS(3067),
    [anon_sym_inline] = ACTIONS(3067),
    [anon_sym___inline] = ACTIONS(3067),
    [anon_sym___inline__] = ACTIONS(3067),
    [anon_sym___forceinline] = ACTIONS(3067),
    [anon_sym_thread_local] = ACTIONS(3067),
    [anon_sym___thread] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_constexpr] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_restrict] = ACTIONS(3067),
    [anon_sym___restrict__] = ACTIONS(3067),
    [anon_sym__Atomic] = ACTIONS(3067),
    [anon_sym__Noreturn] = ACTIONS(3067),
    [anon_sym_noreturn] = ACTIONS(3067),
    [anon_sym__Nonnull] = ACTIONS(3067),
    [anon_sym_mutable] = ACTIONS(3067),
    [anon_sym_constinit] = ACTIONS(3067),
    [anon_sym_consteval] = ACTIONS(3067),
    [anon_sym_alignas] = ACTIONS(3067),
    [anon_sym__Alignas] = ACTIONS(3067),
    [sym_primitive_type] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_union] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_case] = ACTIONS(3067),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_break] = ACTIONS(3067),
    [anon_sym_continue] = ACTIONS(3067),
    [anon_sym_goto] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(3067),
    [anon_sym_compl] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_sizeof] = ACTIONS(3067),
    [anon_sym___alignof__] = ACTIONS(3067),
    [anon_sym___alignof] = ACTIONS(3067),
    [anon_sym__alignof] = ACTIONS(3067),
    [anon_sym_alignof] = ACTIONS(3067),
    [anon_sym__Alignof] = ACTIONS(3067),
    [anon_sym_offsetof] = ACTIONS(3067),
    [anon_sym__Generic] = ACTIONS(3067),
    [anon_sym_asm] = ACTIONS(3067),
    [anon_sym___asm__] = ACTIONS(3067),
    [anon_sym___asm] = ACTIONS(3067),
    [sym_number_literal] = ACTIONS(3069),
    [anon_sym_L_SQUOTE] = ACTIONS(3069),
    [anon_sym_u_SQUOTE] = ACTIONS(3069),
    [anon_sym_U_SQUOTE] = ACTIONS(3069),
    [anon_sym_u8_SQUOTE] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_L_DQUOTE] = ACTIONS(3069),
    [anon_sym_u_DQUOTE] = ACTIONS(3069),
    [anon_sym_U_DQUOTE] = ACTIONS(3069),
    [anon_sym_u8_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [sym_true] = ACTIONS(3067),
    [sym_false] = ACTIONS(3067),
    [anon_sym_NULL] = ACTIONS(3067),
    [anon_sym_nullptr] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3067),
    [anon_sym_decltype] = ACTIONS(3067),
    [anon_sym_explicit] = ACTIONS(3067),
    [anon_sym_typename] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3067),
    [anon_sym_module] = ACTIONS(3067),
    [anon_sym_import] = ACTIONS(3067),
    [anon_sym_template] = ACTIONS(3067),
    [anon_sym_operator] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_delete] = ACTIONS(3067),
    [anon_sym_throw] = ACTIONS(3067),
    [anon_sym_namespace] = ACTIONS(3067),
    [anon_sym_static_assert] = ACTIONS(3067),
    [anon_sym_concept] = ACTIONS(3067),
    [anon_sym_co_return] = ACTIONS(3067),
    [anon_sym_co_yield] = ACTIONS(3067),
    [anon_sym_R_DQUOTE] = ACTIONS(3069),
    [anon_sym_LR_DQUOTE] = ACTIONS(3069),
    [anon_sym_uR_DQUOTE] = ACTIONS(3069),
    [anon_sym_UR_DQUOTE] = ACTIONS(3069),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3069),
    [anon_sym_co_await] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_requires] = ACTIONS(3067),
    [sym_this] = ACTIONS(3067),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(3073),
    [sym_identifier] = ACTIONS(3071),
    [aux_sym_preproc_include_token1] = ACTIONS(3071),
    [aux_sym_preproc_def_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3071),
    [sym_preproc_directive] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym___extension__] = ACTIONS(3071),
    [anon_sym_typedef] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym___attribute__] = ACTIONS(3071),
    [anon_sym___attribute] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3073),
    [anon_sym___declspec] = ACTIONS(3071),
    [anon_sym___based] = ACTIONS(3071),
    [anon_sym___cdecl] = ACTIONS(3071),
    [anon_sym___clrcall] = ACTIONS(3071),
    [anon_sym___stdcall] = ACTIONS(3071),
    [anon_sym___fastcall] = ACTIONS(3071),
    [anon_sym___thiscall] = ACTIONS(3071),
    [anon_sym___vectorcall] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_signed] = ACTIONS(3071),
    [anon_sym_unsigned] = ACTIONS(3071),
    [anon_sym_long] = ACTIONS(3071),
    [anon_sym_short] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_register] = ACTIONS(3071),
    [anon_sym_inline] = ACTIONS(3071),
    [anon_sym___inline] = ACTIONS(3071),
    [anon_sym___inline__] = ACTIONS(3071),
    [anon_sym___forceinline] = ACTIONS(3071),
    [anon_sym_thread_local] = ACTIONS(3071),
    [anon_sym___thread] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_constexpr] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_restrict] = ACTIONS(3071),
    [anon_sym___restrict__] = ACTIONS(3071),
    [anon_sym__Atomic] = ACTIONS(3071),
    [anon_sym__Noreturn] = ACTIONS(3071),
    [anon_sym_noreturn] = ACTIONS(3071),
    [anon_sym__Nonnull] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_constinit] = ACTIONS(3071),
    [anon_sym_consteval] = ACTIONS(3071),
    [anon_sym_alignas] = ACTIONS(3071),
    [anon_sym__Alignas] = ACTIONS(3071),
    [sym_primitive_type] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_union] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_switch] = ACTIONS(3071),
    [anon_sym_case] = ACTIONS(3071),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3071),
    [anon_sym_goto] = ACTIONS(3071),
    [anon_sym_not] = ACTIONS(3071),
    [anon_sym_compl] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_sizeof] = ACTIONS(3071),
    [anon_sym___alignof__] = ACTIONS(3071),
    [anon_sym___alignof] = ACTIONS(3071),
    [anon_sym__alignof] = ACTIONS(3071),
    [anon_sym_alignof] = ACTIONS(3071),
    [anon_sym__Alignof] = ACTIONS(3071),
    [anon_sym_offsetof] = ACTIONS(3071),
    [anon_sym__Generic] = ACTIONS(3071),
    [anon_sym_asm] = ACTIONS(3071),
    [anon_sym___asm__] = ACTIONS(3071),
    [anon_sym___asm] = ACTIONS(3071),
    [sym_number_literal] = ACTIONS(3073),
    [anon_sym_L_SQUOTE] = ACTIONS(3073),
    [anon_sym_u_SQUOTE] = ACTIONS(3073),
    [anon_sym_U_SQUOTE] = ACTIONS(3073),
    [anon_sym_u8_SQUOTE] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_L_DQUOTE] = ACTIONS(3073),
    [anon_sym_u_DQUOTE] = ACTIONS(3073),
    [anon_sym_U_DQUOTE] = ACTIONS(3073),
    [anon_sym_u8_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [sym_true] = ACTIONS(3071),
    [sym_false] = ACTIONS(3071),
    [anon_sym_NULL] = ACTIONS(3071),
    [anon_sym_nullptr] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3071),
    [anon_sym_decltype] = ACTIONS(3071),
    [anon_sym_explicit] = ACTIONS(3071),
    [anon_sym_typename] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_template] = ACTIONS(3071),
    [anon_sym_operator] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_delete] = ACTIONS(3071),
    [anon_sym_throw] = ACTIONS(3071),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_static_assert] = ACTIONS(3071),
    [anon_sym_concept] = ACTIONS(3071),
    [anon_sym_co_return] = ACTIONS(3071),
    [anon_sym_co_yield] = ACTIONS(3071),
    [anon_sym_R_DQUOTE] = ACTIONS(3073),
    [anon_sym_LR_DQUOTE] = ACTIONS(3073),
    [anon_sym_uR_DQUOTE] = ACTIONS(3073),
    [anon_sym_UR_DQUOTE] = ACTIONS(3073),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3073),
    [anon_sym_co_await] = ACTIONS(3071),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_requires] = ACTIONS(3071),
    [sym_this] = ACTIONS(3071),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(3077),
    [sym_identifier] = ACTIONS(3075),
    [aux_sym_preproc_include_token1] = ACTIONS(3075),
    [aux_sym_preproc_def_token1] = ACTIONS(3075),
    [aux_sym_preproc_if_token1] = ACTIONS(3075),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3075),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3075),
    [sym_preproc_directive] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3077),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_AMP_AMP] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym___extension__] = ACTIONS(3075),
    [anon_sym_typedef] = ACTIONS(3075),
    [anon_sym_virtual] = ACTIONS(3075),
    [anon_sym_extern] = ACTIONS(3075),
    [anon_sym___attribute__] = ACTIONS(3075),
    [anon_sym___attribute] = ACTIONS(3075),
    [anon_sym_using] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3077),
    [anon_sym___declspec] = ACTIONS(3075),
    [anon_sym___based] = ACTIONS(3075),
    [anon_sym___cdecl] = ACTIONS(3075),
    [anon_sym___clrcall] = ACTIONS(3075),
    [anon_sym___stdcall] = ACTIONS(3075),
    [anon_sym___fastcall] = ACTIONS(3075),
    [anon_sym___thiscall] = ACTIONS(3075),
    [anon_sym___vectorcall] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_signed] = ACTIONS(3075),
    [anon_sym_unsigned] = ACTIONS(3075),
    [anon_sym_long] = ACTIONS(3075),
    [anon_sym_short] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_register] = ACTIONS(3075),
    [anon_sym_inline] = ACTIONS(3075),
    [anon_sym___inline] = ACTIONS(3075),
    [anon_sym___inline__] = ACTIONS(3075),
    [anon_sym___forceinline] = ACTIONS(3075),
    [anon_sym_thread_local] = ACTIONS(3075),
    [anon_sym___thread] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_constexpr] = ACTIONS(3075),
    [anon_sym_volatile] = ACTIONS(3075),
    [anon_sym_restrict] = ACTIONS(3075),
    [anon_sym___restrict__] = ACTIONS(3075),
    [anon_sym__Atomic] = ACTIONS(3075),
    [anon_sym__Noreturn] = ACTIONS(3075),
    [anon_sym_noreturn] = ACTIONS(3075),
    [anon_sym__Nonnull] = ACTIONS(3075),
    [anon_sym_mutable] = ACTIONS(3075),
    [anon_sym_constinit] = ACTIONS(3075),
    [anon_sym_consteval] = ACTIONS(3075),
    [anon_sym_alignas] = ACTIONS(3075),
    [anon_sym__Alignas] = ACTIONS(3075),
    [sym_primitive_type] = ACTIONS(3075),
    [anon_sym_enum] = ACTIONS(3075),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_struct] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_case] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_goto] = ACTIONS(3075),
    [anon_sym_not] = ACTIONS(3075),
    [anon_sym_compl] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_sizeof] = ACTIONS(3075),
    [anon_sym___alignof__] = ACTIONS(3075),
    [anon_sym___alignof] = ACTIONS(3075),
    [anon_sym__alignof] = ACTIONS(3075),
    [anon_sym_alignof] = ACTIONS(3075),
    [anon_sym__Alignof] = ACTIONS(3075),
    [anon_sym_offsetof] = ACTIONS(3075),
    [anon_sym__Generic] = ACTIONS(3075),
    [anon_sym_asm] = ACTIONS(3075),
    [anon_sym___asm__] = ACTIONS(3075),
    [anon_sym___asm] = ACTIONS(3075),
    [sym_number_literal] = ACTIONS(3077),
    [anon_sym_L_SQUOTE] = ACTIONS(3077),
    [anon_sym_u_SQUOTE] = ACTIONS(3077),
    [anon_sym_U_SQUOTE] = ACTIONS(3077),
    [anon_sym_u8_SQUOTE] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [anon_sym_L_DQUOTE] = ACTIONS(3077),
    [anon_sym_u_DQUOTE] = ACTIONS(3077),
    [anon_sym_U_DQUOTE] = ACTIONS(3077),
    [anon_sym_u8_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [sym_true] = ACTIONS(3075),
    [sym_false] = ACTIONS(3075),
    [anon_sym_NULL] = ACTIONS(3075),
    [anon_sym_nullptr] = ACTIONS(3075),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3075),
    [anon_sym_decltype] = ACTIONS(3075),
    [anon_sym_explicit] = ACTIONS(3075),
    [anon_sym_typename] = ACTIONS(3075),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_import] = ACTIONS(3075),
    [anon_sym_template] = ACTIONS(3075),
    [anon_sym_operator] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_delete] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_static_assert] = ACTIONS(3075),
    [anon_sym_concept] = ACTIONS(3075),
    [anon_sym_co_return] = ACTIONS(3075),
    [anon_sym_co_yield] = ACTIONS(3075),
    [anon_sym_R_DQUOTE] = ACTIONS(3077),
    [anon_sym_LR_DQUOTE] = ACTIONS(3077),
    [anon_sym_uR_DQUOTE] = ACTIONS(3077),
    [anon_sym_UR_DQUOTE] = ACTIONS(3077),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3077),
    [anon_sym_co_await] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_requires] = ACTIONS(3075),
    [sym_this] = ACTIONS(3075),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(2857),
    [sym_identifier] = ACTIONS(2855),
    [aux_sym_preproc_include_token1] = ACTIONS(2855),
    [aux_sym_preproc_def_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token1] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2855),
    [sym_preproc_directive] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(2857),
    [anon_sym_TILDE] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym___extension__] = ACTIONS(2855),
    [anon_sym_typedef] = ACTIONS(2855),
    [anon_sym_virtual] = ACTIONS(2855),
    [anon_sym_extern] = ACTIONS(2855),
    [anon_sym___attribute__] = ACTIONS(2855),
    [anon_sym___attribute] = ACTIONS(2855),
    [anon_sym_using] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2857),
    [anon_sym___declspec] = ACTIONS(2855),
    [anon_sym___based] = ACTIONS(2855),
    [anon_sym___cdecl] = ACTIONS(2855),
    [anon_sym___clrcall] = ACTIONS(2855),
    [anon_sym___stdcall] = ACTIONS(2855),
    [anon_sym___fastcall] = ACTIONS(2855),
    [anon_sym___thiscall] = ACTIONS(2855),
    [anon_sym___vectorcall] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_signed] = ACTIONS(2855),
    [anon_sym_unsigned] = ACTIONS(2855),
    [anon_sym_long] = ACTIONS(2855),
    [anon_sym_short] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(2855),
    [anon_sym_register] = ACTIONS(2855),
    [anon_sym_inline] = ACTIONS(2855),
    [anon_sym___inline] = ACTIONS(2855),
    [anon_sym___inline__] = ACTIONS(2855),
    [anon_sym___forceinline] = ACTIONS(2855),
    [anon_sym_thread_local] = ACTIONS(2855),
    [anon_sym___thread] = ACTIONS(2855),
    [anon_sym_const] = ACTIONS(2855),
    [anon_sym_constexpr] = ACTIONS(2855),
    [anon_sym_volatile] = ACTIONS(2855),
    [anon_sym_restrict] = ACTIONS(2855),
    [anon_sym___restrict__] = ACTIONS(2855),
    [anon_sym__Atomic] = ACTIONS(2855),
    [anon_sym__Noreturn] = ACTIONS(2855),
    [anon_sym_noreturn] = ACTIONS(2855),
    [anon_sym__Nonnull] = ACTIONS(2855),
    [anon_sym_mutable] = ACTIONS(2855),
    [anon_sym_constinit] = ACTIONS(2855),
    [anon_sym_consteval] = ACTIONS(2855),
    [anon_sym_alignas] = ACTIONS(2855),
    [anon_sym__Alignas] = ACTIONS(2855),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_enum] = ACTIONS(2855),
    [anon_sym_class] = ACTIONS(2855),
    [anon_sym_struct] = ACTIONS(2855),
    [anon_sym_union] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_case] = ACTIONS(2855),
    [anon_sym_default] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_break] = ACTIONS(2855),
    [anon_sym_continue] = ACTIONS(2855),
    [anon_sym_goto] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2855),
    [anon_sym_compl] = ACTIONS(2855),
    [anon_sym_DASH_DASH] = ACTIONS(2857),
    [anon_sym_PLUS_PLUS] = ACTIONS(2857),
    [anon_sym_sizeof] = ACTIONS(2855),
    [anon_sym___alignof__] = ACTIONS(2855),
    [anon_sym___alignof] = ACTIONS(2855),
    [anon_sym__alignof] = ACTIONS(2855),
    [anon_sym_alignof] = ACTIONS(2855),
    [anon_sym__Alignof] = ACTIONS(2855),
    [anon_sym_offsetof] = ACTIONS(2855),
    [anon_sym__Generic] = ACTIONS(2855),
    [anon_sym_asm] = ACTIONS(2855),
    [anon_sym___asm__] = ACTIONS(2855),
    [anon_sym___asm] = ACTIONS(2855),
    [sym_number_literal] = ACTIONS(2857),
    [anon_sym_L_SQUOTE] = ACTIONS(2857),
    [anon_sym_u_SQUOTE] = ACTIONS(2857),
    [anon_sym_U_SQUOTE] = ACTIONS(2857),
    [anon_sym_u8_SQUOTE] = ACTIONS(2857),
    [anon_sym_SQUOTE] = ACTIONS(2857),
    [anon_sym_L_DQUOTE] = ACTIONS(2857),
    [anon_sym_u_DQUOTE] = ACTIONS(2857),
    [anon_sym_U_DQUOTE] = ACTIONS(2857),
    [anon_sym_u8_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [sym_true] = ACTIONS(2855),
    [sym_false] = ACTIONS(2855),
    [anon_sym_NULL] = ACTIONS(2855),
    [anon_sym_nullptr] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2855),
    [anon_sym_explicit] = ACTIONS(2855),
    [anon_sym_typename] = ACTIONS(2855),
    [anon_sym_export] = ACTIONS(2855),
    [anon_sym_module] = ACTIONS(2855),
    [anon_sym_import] = ACTIONS(2855),
    [anon_sym_template] = ACTIONS(2855),
    [anon_sym_operator] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_delete] = ACTIONS(2855),
    [anon_sym_throw] = ACTIONS(2855),
    [anon_sym_namespace] = ACTIONS(2855),
    [anon_sym_static_assert] = ACTIONS(2855),
    [anon_sym_concept] = ACTIONS(2855),
    [anon_sym_co_return] = ACTIONS(2855),
    [anon_sym_co_yield] = ACTIONS(2855),
    [anon_sym_R_DQUOTE] = ACTIONS(2857),
    [anon_sym_LR_DQUOTE] = ACTIONS(2857),
    [anon_sym_uR_DQUOTE] = ACTIONS(2857),
    [anon_sym_UR_DQUOTE] = ACTIONS(2857),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2857),
    [anon_sym_co_await] = ACTIONS(2855),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_requires] = ACTIONS(2855),
    [sym_this] = ACTIONS(2855),
  },
  [524] = {
    [sym_identifier] = ACTIONS(2673),
    [aux_sym_preproc_include_token1] = ACTIONS(2673),
    [aux_sym_preproc_def_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2673),
    [sym_preproc_directive] = ACTIONS(2673),
    [anon_sym_LPAREN2] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_AMP_AMP] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym___extension__] = ACTIONS(2673),
    [anon_sym_typedef] = ACTIONS(2673),
    [anon_sym_virtual] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym___attribute__] = ACTIONS(2673),
    [anon_sym___attribute] = ACTIONS(2673),
    [anon_sym_using] = ACTIONS(2673),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2675),
    [anon_sym___declspec] = ACTIONS(2673),
    [anon_sym___based] = ACTIONS(2673),
    [anon_sym___cdecl] = ACTIONS(2673),
    [anon_sym___clrcall] = ACTIONS(2673),
    [anon_sym___stdcall] = ACTIONS(2673),
    [anon_sym___fastcall] = ACTIONS(2673),
    [anon_sym___thiscall] = ACTIONS(2673),
    [anon_sym___vectorcall] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_RBRACE] = ACTIONS(2675),
    [anon_sym_signed] = ACTIONS(2673),
    [anon_sym_unsigned] = ACTIONS(2673),
    [anon_sym_long] = ACTIONS(2673),
    [anon_sym_short] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_register] = ACTIONS(2673),
    [anon_sym_inline] = ACTIONS(2673),
    [anon_sym___inline] = ACTIONS(2673),
    [anon_sym___inline__] = ACTIONS(2673),
    [anon_sym___forceinline] = ACTIONS(2673),
    [anon_sym_thread_local] = ACTIONS(2673),
    [anon_sym___thread] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_constexpr] = ACTIONS(2673),
    [anon_sym_volatile] = ACTIONS(2673),
    [anon_sym_restrict] = ACTIONS(2673),
    [anon_sym___restrict__] = ACTIONS(2673),
    [anon_sym__Atomic] = ACTIONS(2673),
    [anon_sym__Noreturn] = ACTIONS(2673),
    [anon_sym_noreturn] = ACTIONS(2673),
    [anon_sym__Nonnull] = ACTIONS(2673),
    [anon_sym_mutable] = ACTIONS(2673),
    [anon_sym_constinit] = ACTIONS(2673),
    [anon_sym_consteval] = ACTIONS(2673),
    [anon_sym_alignas] = ACTIONS(2673),
    [anon_sym__Alignas] = ACTIONS(2673),
    [sym_primitive_type] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_goto] = ACTIONS(2673),
    [anon_sym___try] = ACTIONS(2673),
    [anon_sym___leave] = ACTIONS(2673),
    [anon_sym_not] = ACTIONS(2673),
    [anon_sym_compl] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_sizeof] = ACTIONS(2673),
    [anon_sym___alignof__] = ACTIONS(2673),
    [anon_sym___alignof] = ACTIONS(2673),
    [anon_sym__alignof] = ACTIONS(2673),
    [anon_sym_alignof] = ACTIONS(2673),
    [anon_sym__Alignof] = ACTIONS(2673),
    [anon_sym_offsetof] = ACTIONS(2673),
    [anon_sym__Generic] = ACTIONS(2673),
    [anon_sym_asm] = ACTIONS(2673),
    [anon_sym___asm__] = ACTIONS(2673),
    [anon_sym___asm] = ACTIONS(2673),
    [sym_number_literal] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2675),
    [anon_sym_u_SQUOTE] = ACTIONS(2675),
    [anon_sym_U_SQUOTE] = ACTIONS(2675),
    [anon_sym_u8_SQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_L_DQUOTE] = ACTIONS(2675),
    [anon_sym_u_DQUOTE] = ACTIONS(2675),
    [anon_sym_U_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8_DQUOTE] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [anon_sym_NULL] = ACTIONS(2673),
    [anon_sym_nullptr] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2673),
    [anon_sym_decltype] = ACTIONS(2673),
    [anon_sym_explicit] = ACTIONS(2673),
    [anon_sym_typename] = ACTIONS(2673),
    [anon_sym_template] = ACTIONS(2673),
    [anon_sym_operator] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_static_assert] = ACTIONS(2673),
    [anon_sym_concept] = ACTIONS(2673),
    [anon_sym_co_return] = ACTIONS(2673),
    [anon_sym_co_yield] = ACTIONS(2673),
    [anon_sym_R_DQUOTE] = ACTIONS(2675),
    [anon_sym_LR_DQUOTE] = ACTIONS(2675),
    [anon_sym_uR_DQUOTE] = ACTIONS(2675),
    [anon_sym_UR_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2675),
    [anon_sym_co_await] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_requires] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
  },
  [525] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_include_token1] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token2] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym___cdecl] = ACTIONS(2703),
    [anon_sym___clrcall] = ACTIONS(2703),
    [anon_sym___stdcall] = ACTIONS(2703),
    [anon_sym___fastcall] = ACTIONS(2703),
    [anon_sym___thiscall] = ACTIONS(2703),
    [anon_sym___vectorcall] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [anon_sym_if] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2703),
    [anon_sym_case] = ACTIONS(2703),
    [anon_sym_default] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(2703),
    [anon_sym_do] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2703),
    [anon_sym_return] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2703),
    [anon_sym_continue] = ACTIONS(2703),
    [anon_sym_goto] = ACTIONS(2703),
    [anon_sym___try] = ACTIONS(2703),
    [anon_sym___leave] = ACTIONS(2703),
    [anon_sym_not] = ACTIONS(2703),
    [anon_sym_compl] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2703),
    [anon_sym___alignof__] = ACTIONS(2703),
    [anon_sym___alignof] = ACTIONS(2703),
    [anon_sym__alignof] = ACTIONS(2703),
    [anon_sym_alignof] = ACTIONS(2703),
    [anon_sym__Alignof] = ACTIONS(2703),
    [anon_sym_offsetof] = ACTIONS(2703),
    [anon_sym__Generic] = ACTIONS(2703),
    [anon_sym_asm] = ACTIONS(2703),
    [anon_sym___asm__] = ACTIONS(2703),
    [anon_sym___asm] = ACTIONS(2703),
    [sym_number_literal] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2705),
    [anon_sym_u_SQUOTE] = ACTIONS(2705),
    [anon_sym_U_SQUOTE] = ACTIONS(2705),
    [anon_sym_u8_SQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_L_DQUOTE] = ACTIONS(2705),
    [anon_sym_u_DQUOTE] = ACTIONS(2705),
    [anon_sym_U_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8_DQUOTE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [sym_false] = ACTIONS(2703),
    [anon_sym_NULL] = ACTIONS(2703),
    [anon_sym_nullptr] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2703),
    [anon_sym_delete] = ACTIONS(2703),
    [anon_sym_throw] = ACTIONS(2703),
    [anon_sym_namespace] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
    [anon_sym_concept] = ACTIONS(2703),
    [anon_sym_co_return] = ACTIONS(2703),
    [anon_sym_co_yield] = ACTIONS(2703),
    [anon_sym_R_DQUOTE] = ACTIONS(2705),
    [anon_sym_LR_DQUOTE] = ACTIONS(2705),
    [anon_sym_uR_DQUOTE] = ACTIONS(2705),
    [anon_sym_UR_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2705),
    [anon_sym_co_await] = ACTIONS(2703),
    [anon_sym_new] = ACTIONS(2703),
    [anon_sym_requires] = ACTIONS(2703),
    [sym_this] = ACTIONS(2703),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(3081),
    [sym_identifier] = ACTIONS(3079),
    [aux_sym_preproc_include_token1] = ACTIONS(3079),
    [aux_sym_preproc_def_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3079),
    [sym_preproc_directive] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_AMP_AMP] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym___extension__] = ACTIONS(3079),
    [anon_sym_typedef] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym___attribute__] = ACTIONS(3079),
    [anon_sym___attribute] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3081),
    [anon_sym___declspec] = ACTIONS(3079),
    [anon_sym___based] = ACTIONS(3079),
    [anon_sym___cdecl] = ACTIONS(3079),
    [anon_sym___clrcall] = ACTIONS(3079),
    [anon_sym___stdcall] = ACTIONS(3079),
    [anon_sym___fastcall] = ACTIONS(3079),
    [anon_sym___thiscall] = ACTIONS(3079),
    [anon_sym___vectorcall] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3081),
    [anon_sym_signed] = ACTIONS(3079),
    [anon_sym_unsigned] = ACTIONS(3079),
    [anon_sym_long] = ACTIONS(3079),
    [anon_sym_short] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_register] = ACTIONS(3079),
    [anon_sym_inline] = ACTIONS(3079),
    [anon_sym___inline] = ACTIONS(3079),
    [anon_sym___inline__] = ACTIONS(3079),
    [anon_sym___forceinline] = ACTIONS(3079),
    [anon_sym_thread_local] = ACTIONS(3079),
    [anon_sym___thread] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_constexpr] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_restrict] = ACTIONS(3079),
    [anon_sym___restrict__] = ACTIONS(3079),
    [anon_sym__Atomic] = ACTIONS(3079),
    [anon_sym__Noreturn] = ACTIONS(3079),
    [anon_sym_noreturn] = ACTIONS(3079),
    [anon_sym__Nonnull] = ACTIONS(3079),
    [anon_sym_mutable] = ACTIONS(3079),
    [anon_sym_constinit] = ACTIONS(3079),
    [anon_sym_consteval] = ACTIONS(3079),
    [anon_sym_alignas] = ACTIONS(3079),
    [anon_sym__Alignas] = ACTIONS(3079),
    [sym_primitive_type] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_union] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_switch] = ACTIONS(3079),
    [anon_sym_case] = ACTIONS(3079),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_break] = ACTIONS(3079),
    [anon_sym_continue] = ACTIONS(3079),
    [anon_sym_goto] = ACTIONS(3079),
    [anon_sym_not] = ACTIONS(3079),
    [anon_sym_compl] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_sizeof] = ACTIONS(3079),
    [anon_sym___alignof__] = ACTIONS(3079),
    [anon_sym___alignof] = ACTIONS(3079),
    [anon_sym__alignof] = ACTIONS(3079),
    [anon_sym_alignof] = ACTIONS(3079),
    [anon_sym__Alignof] = ACTIONS(3079),
    [anon_sym_offsetof] = ACTIONS(3079),
    [anon_sym__Generic] = ACTIONS(3079),
    [anon_sym_asm] = ACTIONS(3079),
    [anon_sym___asm__] = ACTIONS(3079),
    [anon_sym___asm] = ACTIONS(3079),
    [sym_number_literal] = ACTIONS(3081),
    [anon_sym_L_SQUOTE] = ACTIONS(3081),
    [anon_sym_u_SQUOTE] = ACTIONS(3081),
    [anon_sym_U_SQUOTE] = ACTIONS(3081),
    [anon_sym_u8_SQUOTE] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [anon_sym_L_DQUOTE] = ACTIONS(3081),
    [anon_sym_u_DQUOTE] = ACTIONS(3081),
    [anon_sym_U_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [sym_true] = ACTIONS(3079),
    [sym_false] = ACTIONS(3079),
    [anon_sym_NULL] = ACTIONS(3079),
    [anon_sym_nullptr] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3079),
    [anon_sym_decltype] = ACTIONS(3079),
    [anon_sym_explicit] = ACTIONS(3079),
    [anon_sym_typename] = ACTIONS(3079),
    [anon_sym_export] = ACTIONS(3079),
    [anon_sym_module] = ACTIONS(3079),
    [anon_sym_import] = ACTIONS(3079),
    [anon_sym_template] = ACTIONS(3079),
    [anon_sym_operator] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_delete] = ACTIONS(3079),
    [anon_sym_throw] = ACTIONS(3079),
    [anon_sym_namespace] = ACTIONS(3079),
    [anon_sym_static_assert] = ACTIONS(3079),
    [anon_sym_concept] = ACTIONS(3079),
    [anon_sym_co_return] = ACTIONS(3079),
    [anon_sym_co_yield] = ACTIONS(3079),
    [anon_sym_R_DQUOTE] = ACTIONS(3081),
    [anon_sym_LR_DQUOTE] = ACTIONS(3081),
    [anon_sym_uR_DQUOTE] = ACTIONS(3081),
    [anon_sym_UR_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3081),
    [anon_sym_co_await] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_requires] = ACTIONS(3079),
    [sym_this] = ACTIONS(3079),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(2889),
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_include_token1] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym___attribute] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym___cdecl] = ACTIONS(2887),
    [anon_sym___clrcall] = ACTIONS(2887),
    [anon_sym___stdcall] = ACTIONS(2887),
    [anon_sym___fastcall] = ACTIONS(2887),
    [anon_sym___thiscall] = ACTIONS(2887),
    [anon_sym___vectorcall] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym__Nonnull] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym__Alignas] = ACTIONS(2887),
    [sym_primitive_type] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2887),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_goto] = ACTIONS(2887),
    [anon_sym_not] = ACTIONS(2887),
    [anon_sym_compl] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_sizeof] = ACTIONS(2887),
    [anon_sym___alignof__] = ACTIONS(2887),
    [anon_sym___alignof] = ACTIONS(2887),
    [anon_sym__alignof] = ACTIONS(2887),
    [anon_sym_alignof] = ACTIONS(2887),
    [anon_sym__Alignof] = ACTIONS(2887),
    [anon_sym_offsetof] = ACTIONS(2887),
    [anon_sym__Generic] = ACTIONS(2887),
    [anon_sym_asm] = ACTIONS(2887),
    [anon_sym___asm__] = ACTIONS(2887),
    [anon_sym___asm] = ACTIONS(2887),
    [sym_number_literal] = ACTIONS(2889),
    [anon_sym_L_SQUOTE] = ACTIONS(2889),
    [anon_sym_u_SQUOTE] = ACTIONS(2889),
    [anon_sym_U_SQUOTE] = ACTIONS(2889),
    [anon_sym_u8_SQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_L_DQUOTE] = ACTIONS(2889),
    [anon_sym_u_DQUOTE] = ACTIONS(2889),
    [anon_sym_U_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [anon_sym_NULL] = ACTIONS(2887),
    [anon_sym_nullptr] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_export] = ACTIONS(2887),
    [anon_sym_module] = ACTIONS(2887),
    [anon_sym_import] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_namespace] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_concept] = ACTIONS(2887),
    [anon_sym_co_return] = ACTIONS(2887),
    [anon_sym_co_yield] = ACTIONS(2887),
    [anon_sym_R_DQUOTE] = ACTIONS(2889),
    [anon_sym_LR_DQUOTE] = ACTIONS(2889),
    [anon_sym_uR_DQUOTE] = ACTIONS(2889),
    [anon_sym_UR_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2889),
    [anon_sym_co_await] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_requires] = ACTIONS(2887),
    [sym_this] = ACTIONS(2887),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(3403),
    [sym_identifier] = ACTIONS(3405),
    [aux_sym_preproc_include_token1] = ACTIONS(3405),
    [aux_sym_preproc_def_token1] = ACTIONS(3405),
    [aux_sym_preproc_if_token1] = ACTIONS(3405),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3405),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3405),
    [sym_preproc_directive] = ACTIONS(3405),
    [anon_sym_LPAREN2] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_PLUS] = ACTIONS(3405),
    [anon_sym_STAR] = ACTIONS(3403),
    [anon_sym_AMP_AMP] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3403),
    [anon_sym___extension__] = ACTIONS(3405),
    [anon_sym_typedef] = ACTIONS(3405),
    [anon_sym_virtual] = ACTIONS(3405),
    [anon_sym_extern] = ACTIONS(3405),
    [anon_sym___attribute__] = ACTIONS(3405),
    [anon_sym___attribute] = ACTIONS(3405),
    [anon_sym_using] = ACTIONS(3405),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3403),
    [anon_sym___declspec] = ACTIONS(3405),
    [anon_sym___based] = ACTIONS(3405),
    [anon_sym___cdecl] = ACTIONS(3405),
    [anon_sym___clrcall] = ACTIONS(3405),
    [anon_sym___stdcall] = ACTIONS(3405),
    [anon_sym___fastcall] = ACTIONS(3405),
    [anon_sym___thiscall] = ACTIONS(3405),
    [anon_sym___vectorcall] = ACTIONS(3405),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_signed] = ACTIONS(3405),
    [anon_sym_unsigned] = ACTIONS(3405),
    [anon_sym_long] = ACTIONS(3405),
    [anon_sym_short] = ACTIONS(3405),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_static] = ACTIONS(3405),
    [anon_sym_register] = ACTIONS(3405),
    [anon_sym_inline] = ACTIONS(3405),
    [anon_sym___inline] = ACTIONS(3405),
    [anon_sym___inline__] = ACTIONS(3405),
    [anon_sym___forceinline] = ACTIONS(3405),
    [anon_sym_thread_local] = ACTIONS(3405),
    [anon_sym___thread] = ACTIONS(3405),
    [anon_sym_const] = ACTIONS(3405),
    [anon_sym_constexpr] = ACTIONS(3405),
    [anon_sym_volatile] = ACTIONS(3405),
    [anon_sym_restrict] = ACTIONS(3405),
    [anon_sym___restrict__] = ACTIONS(3405),
    [anon_sym__Atomic] = ACTIONS(3405),
    [anon_sym__Noreturn] = ACTIONS(3405),
    [anon_sym_noreturn] = ACTIONS(3405),
    [anon_sym__Nonnull] = ACTIONS(3405),
    [anon_sym_mutable] = ACTIONS(3405),
    [anon_sym_constinit] = ACTIONS(3405),
    [anon_sym_consteval] = ACTIONS(3405),
    [anon_sym_alignas] = ACTIONS(3405),
    [anon_sym__Alignas] = ACTIONS(3405),
    [sym_primitive_type] = ACTIONS(3405),
    [anon_sym_enum] = ACTIONS(3405),
    [anon_sym_class] = ACTIONS(3405),
    [anon_sym_struct] = ACTIONS(3405),
    [anon_sym_union] = ACTIONS(3405),
    [anon_sym_if] = ACTIONS(3405),
    [anon_sym_switch] = ACTIONS(3405),
    [anon_sym_case] = ACTIONS(3405),
    [anon_sym_default] = ACTIONS(3405),
    [anon_sym_while] = ACTIONS(3405),
    [anon_sym_do] = ACTIONS(3405),
    [anon_sym_for] = ACTIONS(3405),
    [anon_sym_return] = ACTIONS(3405),
    [anon_sym_break] = ACTIONS(3405),
    [anon_sym_continue] = ACTIONS(3405),
    [anon_sym_goto] = ACTIONS(3405),
    [anon_sym_not] = ACTIONS(3405),
    [anon_sym_compl] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(3403),
    [anon_sym_sizeof] = ACTIONS(3405),
    [anon_sym___alignof__] = ACTIONS(3405),
    [anon_sym___alignof] = ACTIONS(3405),
    [anon_sym__alignof] = ACTIONS(3405),
    [anon_sym_alignof] = ACTIONS(3405),
    [anon_sym__Alignof] = ACTIONS(3405),
    [anon_sym_offsetof] = ACTIONS(3405),
    [anon_sym__Generic] = ACTIONS(3405),
    [anon_sym_asm] = ACTIONS(3405),
    [anon_sym___asm__] = ACTIONS(3405),
    [anon_sym___asm] = ACTIONS(3405),
    [sym_number_literal] = ACTIONS(3403),
    [anon_sym_L_SQUOTE] = ACTIONS(3403),
    [anon_sym_u_SQUOTE] = ACTIONS(3403),
    [anon_sym_U_SQUOTE] = ACTIONS(3403),
    [anon_sym_u8_SQUOTE] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3403),
    [anon_sym_L_DQUOTE] = ACTIONS(3403),
    [anon_sym_u_DQUOTE] = ACTIONS(3403),
    [anon_sym_U_DQUOTE] = ACTIONS(3403),
    [anon_sym_u8_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE] = ACTIONS(3403),
    [sym_true] = ACTIONS(3405),
    [sym_false] = ACTIONS(3405),
    [anon_sym_NULL] = ACTIONS(3405),
    [anon_sym_nullptr] = ACTIONS(3405),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3405),
    [anon_sym_decltype] = ACTIONS(3405),
    [anon_sym_explicit] = ACTIONS(3405),
    [anon_sym_typename] = ACTIONS(3405),
    [anon_sym_export] = ACTIONS(3405),
    [anon_sym_module] = ACTIONS(3405),
    [anon_sym_import] = ACTIONS(3405),
    [anon_sym_template] = ACTIONS(3405),
    [anon_sym_operator] = ACTIONS(3405),
    [anon_sym_try] = ACTIONS(3405),
    [anon_sym_delete] = ACTIONS(3405),
    [anon_sym_throw] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3405),
    [anon_sym_static_assert] = ACTIONS(3405),
    [anon_sym_concept] = ACTIONS(3405),
    [anon_sym_co_return] = ACTIONS(3405),
    [anon_sym_co_yield] = ACTIONS(3405),
    [anon_sym_R_DQUOTE] = ACTIONS(3403),
    [anon_sym_LR_DQUOTE] = ACTIONS(3403),
    [anon_sym_uR_DQUOTE] = ACTIONS(3403),
    [anon_sym_UR_DQUOTE] = ACTIONS(3403),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3403),
    [anon_sym_co_await] = ACTIONS(3405),
    [anon_sym_new] = ACTIONS(3405),
    [anon_sym_requires] = ACTIONS(3405),
    [sym_this] = ACTIONS(3405),
  },
  [529] = {
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_include_token1] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token2] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym___cdecl] = ACTIONS(2763),
    [anon_sym___clrcall] = ACTIONS(2763),
    [anon_sym___stdcall] = ACTIONS(2763),
    [anon_sym___fastcall] = ACTIONS(2763),
    [anon_sym___thiscall] = ACTIONS(2763),
    [anon_sym___vectorcall] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_else] = ACTIONS(2763),
    [anon_sym_switch] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2763),
    [anon_sym_default] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_do] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_goto] = ACTIONS(2763),
    [anon_sym___try] = ACTIONS(2763),
    [anon_sym___leave] = ACTIONS(2763),
    [anon_sym_not] = ACTIONS(2763),
    [anon_sym_compl] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_sizeof] = ACTIONS(2763),
    [anon_sym___alignof__] = ACTIONS(2763),
    [anon_sym___alignof] = ACTIONS(2763),
    [anon_sym__alignof] = ACTIONS(2763),
    [anon_sym_alignof] = ACTIONS(2763),
    [anon_sym__Alignof] = ACTIONS(2763),
    [anon_sym_offsetof] = ACTIONS(2763),
    [anon_sym__Generic] = ACTIONS(2763),
    [anon_sym_asm] = ACTIONS(2763),
    [anon_sym___asm__] = ACTIONS(2763),
    [anon_sym___asm] = ACTIONS(2763),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2765),
    [anon_sym_u_SQUOTE] = ACTIONS(2765),
    [anon_sym_U_SQUOTE] = ACTIONS(2765),
    [anon_sym_u8_SQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_L_DQUOTE] = ACTIONS(2765),
    [anon_sym_u_DQUOTE] = ACTIONS(2765),
    [anon_sym_U_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8_DQUOTE] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [anon_sym_NULL] = ACTIONS(2763),
    [anon_sym_nullptr] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_throw] = ACTIONS(2763),
    [anon_sym_namespace] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
    [anon_sym_concept] = ACTIONS(2763),
    [anon_sym_co_return] = ACTIONS(2763),
    [anon_sym_co_yield] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2763),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_requires] = ACTIONS(2763),
    [sym_this] = ACTIONS(2763),
  },
  [530] = {
    [sym_identifier] = ACTIONS(2655),
    [aux_sym_preproc_include_token1] = ACTIONS(2655),
    [aux_sym_preproc_def_token1] = ACTIONS(2655),
    [aux_sym_preproc_if_token1] = ACTIONS(2655),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2655),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2655),
    [sym_preproc_directive] = ACTIONS(2655),
    [anon_sym_LPAREN2] = ACTIONS(2657),
    [anon_sym_BANG] = ACTIONS(2657),
    [anon_sym_TILDE] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_AMP_AMP] = ACTIONS(2657),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym___extension__] = ACTIONS(2655),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_virtual] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym___attribute__] = ACTIONS(2655),
    [anon_sym___attribute] = ACTIONS(2655),
    [anon_sym_using] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2657),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2657),
    [anon_sym___declspec] = ACTIONS(2655),
    [anon_sym___based] = ACTIONS(2655),
    [anon_sym___cdecl] = ACTIONS(2655),
    [anon_sym___clrcall] = ACTIONS(2655),
    [anon_sym___stdcall] = ACTIONS(2655),
    [anon_sym___fastcall] = ACTIONS(2655),
    [anon_sym___thiscall] = ACTIONS(2655),
    [anon_sym___vectorcall] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_RBRACE] = ACTIONS(2657),
    [anon_sym_signed] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2655),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym___inline] = ACTIONS(2655),
    [anon_sym___inline__] = ACTIONS(2655),
    [anon_sym___forceinline] = ACTIONS(2655),
    [anon_sym_thread_local] = ACTIONS(2655),
    [anon_sym___thread] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym___restrict__] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym__Noreturn] = ACTIONS(2655),
    [anon_sym_noreturn] = ACTIONS(2655),
    [anon_sym__Nonnull] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_constinit] = ACTIONS(2655),
    [anon_sym_consteval] = ACTIONS(2655),
    [anon_sym_alignas] = ACTIONS(2655),
    [anon_sym__Alignas] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_class] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_else] = ACTIONS(2655),
    [anon_sym_switch] = ACTIONS(2655),
    [anon_sym_case] = ACTIONS(2655),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym___try] = ACTIONS(2655),
    [anon_sym___leave] = ACTIONS(2655),
    [anon_sym_not] = ACTIONS(2655),
    [anon_sym_compl] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(2657),
    [anon_sym_sizeof] = ACTIONS(2655),
    [anon_sym___alignof__] = ACTIONS(2655),
    [anon_sym___alignof] = ACTIONS(2655),
    [anon_sym__alignof] = ACTIONS(2655),
    [anon_sym_alignof] = ACTIONS(2655),
    [anon_sym__Alignof] = ACTIONS(2655),
    [anon_sym_offsetof] = ACTIONS(2655),
    [anon_sym__Generic] = ACTIONS(2655),
    [anon_sym_asm] = ACTIONS(2655),
    [anon_sym___asm__] = ACTIONS(2655),
    [anon_sym___asm] = ACTIONS(2655),
    [sym_number_literal] = ACTIONS(2657),
    [anon_sym_L_SQUOTE] = ACTIONS(2657),
    [anon_sym_u_SQUOTE] = ACTIONS(2657),
    [anon_sym_U_SQUOTE] = ACTIONS(2657),
    [anon_sym_u8_SQUOTE] = ACTIONS(2657),
    [anon_sym_SQUOTE] = ACTIONS(2657),
    [anon_sym_L_DQUOTE] = ACTIONS(2657),
    [anon_sym_u_DQUOTE] = ACTIONS(2657),
    [anon_sym_U_DQUOTE] = ACTIONS(2657),
    [anon_sym_u8_DQUOTE] = ACTIONS(2657),
    [anon_sym_DQUOTE] = ACTIONS(2657),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [anon_sym_NULL] = ACTIONS(2655),
    [anon_sym_nullptr] = ACTIONS(2655),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_decltype] = ACTIONS(2655),
    [anon_sym_explicit] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_template] = ACTIONS(2655),
    [anon_sym_operator] = ACTIONS(2655),
    [anon_sym_try] = ACTIONS(2655),
    [anon_sym_delete] = ACTIONS(2655),
    [anon_sym_throw] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_static_assert] = ACTIONS(2655),
    [anon_sym_concept] = ACTIONS(2655),
    [anon_sym_co_return] = ACTIONS(2655),
    [anon_sym_co_yield] = ACTIONS(2655),
    [anon_sym_R_DQUOTE] = ACTIONS(2657),
    [anon_sym_LR_DQUOTE] = ACTIONS(2657),
    [anon_sym_uR_DQUOTE] = ACTIONS(2657),
    [anon_sym_UR_DQUOTE] = ACTIONS(2657),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2657),
    [anon_sym_co_await] = ACTIONS(2655),
    [anon_sym_new] = ACTIONS(2655),
    [anon_sym_requires] = ACTIONS(2655),
    [sym_this] = ACTIONS(2655),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(3407),
    [sym_identifier] = ACTIONS(3409),
    [aux_sym_preproc_include_token1] = ACTIONS(3409),
    [aux_sym_preproc_def_token1] = ACTIONS(3409),
    [aux_sym_preproc_if_token1] = ACTIONS(3409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3409),
    [sym_preproc_directive] = ACTIONS(3409),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_BANG] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3409),
    [anon_sym_PLUS] = ACTIONS(3409),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(3407),
    [anon_sym___extension__] = ACTIONS(3409),
    [anon_sym_typedef] = ACTIONS(3409),
    [anon_sym_virtual] = ACTIONS(3409),
    [anon_sym_extern] = ACTIONS(3409),
    [anon_sym___attribute__] = ACTIONS(3409),
    [anon_sym___attribute] = ACTIONS(3409),
    [anon_sym_using] = ACTIONS(3409),
    [anon_sym_COLON_COLON] = ACTIONS(3407),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3407),
    [anon_sym___declspec] = ACTIONS(3409),
    [anon_sym___based] = ACTIONS(3409),
    [anon_sym___cdecl] = ACTIONS(3409),
    [anon_sym___clrcall] = ACTIONS(3409),
    [anon_sym___stdcall] = ACTIONS(3409),
    [anon_sym___fastcall] = ACTIONS(3409),
    [anon_sym___thiscall] = ACTIONS(3409),
    [anon_sym___vectorcall] = ACTIONS(3409),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_signed] = ACTIONS(3409),
    [anon_sym_unsigned] = ACTIONS(3409),
    [anon_sym_long] = ACTIONS(3409),
    [anon_sym_short] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(3409),
    [anon_sym_static] = ACTIONS(3409),
    [anon_sym_register] = ACTIONS(3409),
    [anon_sym_inline] = ACTIONS(3409),
    [anon_sym___inline] = ACTIONS(3409),
    [anon_sym___inline__] = ACTIONS(3409),
    [anon_sym___forceinline] = ACTIONS(3409),
    [anon_sym_thread_local] = ACTIONS(3409),
    [anon_sym___thread] = ACTIONS(3409),
    [anon_sym_const] = ACTIONS(3409),
    [anon_sym_constexpr] = ACTIONS(3409),
    [anon_sym_volatile] = ACTIONS(3409),
    [anon_sym_restrict] = ACTIONS(3409),
    [anon_sym___restrict__] = ACTIONS(3409),
    [anon_sym__Atomic] = ACTIONS(3409),
    [anon_sym__Noreturn] = ACTIONS(3409),
    [anon_sym_noreturn] = ACTIONS(3409),
    [anon_sym__Nonnull] = ACTIONS(3409),
    [anon_sym_mutable] = ACTIONS(3409),
    [anon_sym_constinit] = ACTIONS(3409),
    [anon_sym_consteval] = ACTIONS(3409),
    [anon_sym_alignas] = ACTIONS(3409),
    [anon_sym__Alignas] = ACTIONS(3409),
    [sym_primitive_type] = ACTIONS(3409),
    [anon_sym_enum] = ACTIONS(3409),
    [anon_sym_class] = ACTIONS(3409),
    [anon_sym_struct] = ACTIONS(3409),
    [anon_sym_union] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(3409),
    [anon_sym_switch] = ACTIONS(3409),
    [anon_sym_case] = ACTIONS(3409),
    [anon_sym_default] = ACTIONS(3409),
    [anon_sym_while] = ACTIONS(3409),
    [anon_sym_do] = ACTIONS(3409),
    [anon_sym_for] = ACTIONS(3409),
    [anon_sym_return] = ACTIONS(3409),
    [anon_sym_break] = ACTIONS(3409),
    [anon_sym_continue] = ACTIONS(3409),
    [anon_sym_goto] = ACTIONS(3409),
    [anon_sym_not] = ACTIONS(3409),
    [anon_sym_compl] = ACTIONS(3409),
    [anon_sym_DASH_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_PLUS] = ACTIONS(3407),
    [anon_sym_sizeof] = ACTIONS(3409),
    [anon_sym___alignof__] = ACTIONS(3409),
    [anon_sym___alignof] = ACTIONS(3409),
    [anon_sym__alignof] = ACTIONS(3409),
    [anon_sym_alignof] = ACTIONS(3409),
    [anon_sym__Alignof] = ACTIONS(3409),
    [anon_sym_offsetof] = ACTIONS(3409),
    [anon_sym__Generic] = ACTIONS(3409),
    [anon_sym_asm] = ACTIONS(3409),
    [anon_sym___asm__] = ACTIONS(3409),
    [anon_sym___asm] = ACTIONS(3409),
    [sym_number_literal] = ACTIONS(3407),
    [anon_sym_L_SQUOTE] = ACTIONS(3407),
    [anon_sym_u_SQUOTE] = ACTIONS(3407),
    [anon_sym_U_SQUOTE] = ACTIONS(3407),
    [anon_sym_u8_SQUOTE] = ACTIONS(3407),
    [anon_sym_SQUOTE] = ACTIONS(3407),
    [anon_sym_L_DQUOTE] = ACTIONS(3407),
    [anon_sym_u_DQUOTE] = ACTIONS(3407),
    [anon_sym_U_DQUOTE] = ACTIONS(3407),
    [anon_sym_u8_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [sym_true] = ACTIONS(3409),
    [sym_false] = ACTIONS(3409),
    [anon_sym_NULL] = ACTIONS(3409),
    [anon_sym_nullptr] = ACTIONS(3409),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3409),
    [anon_sym_decltype] = ACTIONS(3409),
    [anon_sym_explicit] = ACTIONS(3409),
    [anon_sym_typename] = ACTIONS(3409),
    [anon_sym_export] = ACTIONS(3409),
    [anon_sym_module] = ACTIONS(3409),
    [anon_sym_import] = ACTIONS(3409),
    [anon_sym_template] = ACTIONS(3409),
    [anon_sym_operator] = ACTIONS(3409),
    [anon_sym_try] = ACTIONS(3409),
    [anon_sym_delete] = ACTIONS(3409),
    [anon_sym_throw] = ACTIONS(3409),
    [anon_sym_namespace] = ACTIONS(3409),
    [anon_sym_static_assert] = ACTIONS(3409),
    [anon_sym_concept] = ACTIONS(3409),
    [anon_sym_co_return] = ACTIONS(3409),
    [anon_sym_co_yield] = ACTIONS(3409),
    [anon_sym_R_DQUOTE] = ACTIONS(3407),
    [anon_sym_LR_DQUOTE] = ACTIONS(3407),
    [anon_sym_uR_DQUOTE] = ACTIONS(3407),
    [anon_sym_UR_DQUOTE] = ACTIONS(3407),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3407),
    [anon_sym_co_await] = ACTIONS(3409),
    [anon_sym_new] = ACTIONS(3409),
    [anon_sym_requires] = ACTIONS(3409),
    [sym_this] = ACTIONS(3409),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(3411),
    [sym_identifier] = ACTIONS(3413),
    [aux_sym_preproc_include_token1] = ACTIONS(3413),
    [aux_sym_preproc_def_token1] = ACTIONS(3413),
    [aux_sym_preproc_if_token1] = ACTIONS(3413),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3413),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3413),
    [sym_preproc_directive] = ACTIONS(3413),
    [anon_sym_LPAREN2] = ACTIONS(3411),
    [anon_sym_BANG] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3411),
    [anon_sym_DASH] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_AMP_AMP] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3413),
    [anon_sym_SEMI] = ACTIONS(3411),
    [anon_sym___extension__] = ACTIONS(3413),
    [anon_sym_typedef] = ACTIONS(3413),
    [anon_sym_virtual] = ACTIONS(3413),
    [anon_sym_extern] = ACTIONS(3413),
    [anon_sym___attribute__] = ACTIONS(3413),
    [anon_sym___attribute] = ACTIONS(3413),
    [anon_sym_using] = ACTIONS(3413),
    [anon_sym_COLON_COLON] = ACTIONS(3411),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3411),
    [anon_sym___declspec] = ACTIONS(3413),
    [anon_sym___based] = ACTIONS(3413),
    [anon_sym___cdecl] = ACTIONS(3413),
    [anon_sym___clrcall] = ACTIONS(3413),
    [anon_sym___stdcall] = ACTIONS(3413),
    [anon_sym___fastcall] = ACTIONS(3413),
    [anon_sym___thiscall] = ACTIONS(3413),
    [anon_sym___vectorcall] = ACTIONS(3413),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [anon_sym_signed] = ACTIONS(3413),
    [anon_sym_unsigned] = ACTIONS(3413),
    [anon_sym_long] = ACTIONS(3413),
    [anon_sym_short] = ACTIONS(3413),
    [anon_sym_LBRACK] = ACTIONS(3413),
    [anon_sym_static] = ACTIONS(3413),
    [anon_sym_register] = ACTIONS(3413),
    [anon_sym_inline] = ACTIONS(3413),
    [anon_sym___inline] = ACTIONS(3413),
    [anon_sym___inline__] = ACTIONS(3413),
    [anon_sym___forceinline] = ACTIONS(3413),
    [anon_sym_thread_local] = ACTIONS(3413),
    [anon_sym___thread] = ACTIONS(3413),
    [anon_sym_const] = ACTIONS(3413),
    [anon_sym_constexpr] = ACTIONS(3413),
    [anon_sym_volatile] = ACTIONS(3413),
    [anon_sym_restrict] = ACTIONS(3413),
    [anon_sym___restrict__] = ACTIONS(3413),
    [anon_sym__Atomic] = ACTIONS(3413),
    [anon_sym__Noreturn] = ACTIONS(3413),
    [anon_sym_noreturn] = ACTIONS(3413),
    [anon_sym__Nonnull] = ACTIONS(3413),
    [anon_sym_mutable] = ACTIONS(3413),
    [anon_sym_constinit] = ACTIONS(3413),
    [anon_sym_consteval] = ACTIONS(3413),
    [anon_sym_alignas] = ACTIONS(3413),
    [anon_sym__Alignas] = ACTIONS(3413),
    [sym_primitive_type] = ACTIONS(3413),
    [anon_sym_enum] = ACTIONS(3413),
    [anon_sym_class] = ACTIONS(3413),
    [anon_sym_struct] = ACTIONS(3413),
    [anon_sym_union] = ACTIONS(3413),
    [anon_sym_if] = ACTIONS(3413),
    [anon_sym_switch] = ACTIONS(3413),
    [anon_sym_case] = ACTIONS(3413),
    [anon_sym_default] = ACTIONS(3413),
    [anon_sym_while] = ACTIONS(3413),
    [anon_sym_do] = ACTIONS(3413),
    [anon_sym_for] = ACTIONS(3413),
    [anon_sym_return] = ACTIONS(3413),
    [anon_sym_break] = ACTIONS(3413),
    [anon_sym_continue] = ACTIONS(3413),
    [anon_sym_goto] = ACTIONS(3413),
    [anon_sym_not] = ACTIONS(3413),
    [anon_sym_compl] = ACTIONS(3413),
    [anon_sym_DASH_DASH] = ACTIONS(3411),
    [anon_sym_PLUS_PLUS] = ACTIONS(3411),
    [anon_sym_sizeof] = ACTIONS(3413),
    [anon_sym___alignof__] = ACTIONS(3413),
    [anon_sym___alignof] = ACTIONS(3413),
    [anon_sym__alignof] = ACTIONS(3413),
    [anon_sym_alignof] = ACTIONS(3413),
    [anon_sym__Alignof] = ACTIONS(3413),
    [anon_sym_offsetof] = ACTIONS(3413),
    [anon_sym__Generic] = ACTIONS(3413),
    [anon_sym_asm] = ACTIONS(3413),
    [anon_sym___asm__] = ACTIONS(3413),
    [anon_sym___asm] = ACTIONS(3413),
    [sym_number_literal] = ACTIONS(3411),
    [anon_sym_L_SQUOTE] = ACTIONS(3411),
    [anon_sym_u_SQUOTE] = ACTIONS(3411),
    [anon_sym_U_SQUOTE] = ACTIONS(3411),
    [anon_sym_u8_SQUOTE] = ACTIONS(3411),
    [anon_sym_SQUOTE] = ACTIONS(3411),
    [anon_sym_L_DQUOTE] = ACTIONS(3411),
    [anon_sym_u_DQUOTE] = ACTIONS(3411),
    [anon_sym_U_DQUOTE] = ACTIONS(3411),
    [anon_sym_u8_DQUOTE] = ACTIONS(3411),
    [anon_sym_DQUOTE] = ACTIONS(3411),
    [sym_true] = ACTIONS(3413),
    [sym_false] = ACTIONS(3413),
    [anon_sym_NULL] = ACTIONS(3413),
    [anon_sym_nullptr] = ACTIONS(3413),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3413),
    [anon_sym_decltype] = ACTIONS(3413),
    [anon_sym_explicit] = ACTIONS(3413),
    [anon_sym_typename] = ACTIONS(3413),
    [anon_sym_export] = ACTIONS(3413),
    [anon_sym_module] = ACTIONS(3413),
    [anon_sym_import] = ACTIONS(3413),
    [anon_sym_template] = ACTIONS(3413),
    [anon_sym_operator] = ACTIONS(3413),
    [anon_sym_try] = ACTIONS(3413),
    [anon_sym_delete] = ACTIONS(3413),
    [anon_sym_throw] = ACTIONS(3413),
    [anon_sym_namespace] = ACTIONS(3413),
    [anon_sym_static_assert] = ACTIONS(3413),
    [anon_sym_concept] = ACTIONS(3413),
    [anon_sym_co_return] = ACTIONS(3413),
    [anon_sym_co_yield] = ACTIONS(3413),
    [anon_sym_R_DQUOTE] = ACTIONS(3411),
    [anon_sym_LR_DQUOTE] = ACTIONS(3411),
    [anon_sym_uR_DQUOTE] = ACTIONS(3411),
    [anon_sym_UR_DQUOTE] = ACTIONS(3411),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3411),
    [anon_sym_co_await] = ACTIONS(3413),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_requires] = ACTIONS(3413),
    [sym_this] = ACTIONS(3413),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(3415),
    [sym_identifier] = ACTIONS(3417),
    [aux_sym_preproc_include_token1] = ACTIONS(3417),
    [aux_sym_preproc_def_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3417),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3417),
    [sym_preproc_directive] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3415),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3417),
    [anon_sym_typedef] = ACTIONS(3417),
    [anon_sym_virtual] = ACTIONS(3417),
    [anon_sym_extern] = ACTIONS(3417),
    [anon_sym___attribute__] = ACTIONS(3417),
    [anon_sym___attribute] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3415),
    [anon_sym___declspec] = ACTIONS(3417),
    [anon_sym___based] = ACTIONS(3417),
    [anon_sym___cdecl] = ACTIONS(3417),
    [anon_sym___clrcall] = ACTIONS(3417),
    [anon_sym___stdcall] = ACTIONS(3417),
    [anon_sym___fastcall] = ACTIONS(3417),
    [anon_sym___thiscall] = ACTIONS(3417),
    [anon_sym___vectorcall] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_signed] = ACTIONS(3417),
    [anon_sym_unsigned] = ACTIONS(3417),
    [anon_sym_long] = ACTIONS(3417),
    [anon_sym_short] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_register] = ACTIONS(3417),
    [anon_sym_inline] = ACTIONS(3417),
    [anon_sym___inline] = ACTIONS(3417),
    [anon_sym___inline__] = ACTIONS(3417),
    [anon_sym___forceinline] = ACTIONS(3417),
    [anon_sym_thread_local] = ACTIONS(3417),
    [anon_sym___thread] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_constexpr] = ACTIONS(3417),
    [anon_sym_volatile] = ACTIONS(3417),
    [anon_sym_restrict] = ACTIONS(3417),
    [anon_sym___restrict__] = ACTIONS(3417),
    [anon_sym__Atomic] = ACTIONS(3417),
    [anon_sym__Noreturn] = ACTIONS(3417),
    [anon_sym_noreturn] = ACTIONS(3417),
    [anon_sym__Nonnull] = ACTIONS(3417),
    [anon_sym_mutable] = ACTIONS(3417),
    [anon_sym_constinit] = ACTIONS(3417),
    [anon_sym_consteval] = ACTIONS(3417),
    [anon_sym_alignas] = ACTIONS(3417),
    [anon_sym__Alignas] = ACTIONS(3417),
    [sym_primitive_type] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_struct] = ACTIONS(3417),
    [anon_sym_union] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_case] = ACTIONS(3417),
    [anon_sym_default] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_goto] = ACTIONS(3417),
    [anon_sym_not] = ACTIONS(3417),
    [anon_sym_compl] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_sizeof] = ACTIONS(3417),
    [anon_sym___alignof__] = ACTIONS(3417),
    [anon_sym___alignof] = ACTIONS(3417),
    [anon_sym__alignof] = ACTIONS(3417),
    [anon_sym_alignof] = ACTIONS(3417),
    [anon_sym__Alignof] = ACTIONS(3417),
    [anon_sym_offsetof] = ACTIONS(3417),
    [anon_sym__Generic] = ACTIONS(3417),
    [anon_sym_asm] = ACTIONS(3417),
    [anon_sym___asm__] = ACTIONS(3417),
    [anon_sym___asm] = ACTIONS(3417),
    [sym_number_literal] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3415),
    [anon_sym_u_SQUOTE] = ACTIONS(3415),
    [anon_sym_U_SQUOTE] = ACTIONS(3415),
    [anon_sym_u8_SQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [anon_sym_L_DQUOTE] = ACTIONS(3415),
    [anon_sym_u_DQUOTE] = ACTIONS(3415),
    [anon_sym_U_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8_DQUOTE] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [anon_sym_NULL] = ACTIONS(3417),
    [anon_sym_nullptr] = ACTIONS(3417),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3417),
    [anon_sym_decltype] = ACTIONS(3417),
    [anon_sym_explicit] = ACTIONS(3417),
    [anon_sym_typename] = ACTIONS(3417),
    [anon_sym_export] = ACTIONS(3417),
    [anon_sym_module] = ACTIONS(3417),
    [anon_sym_import] = ACTIONS(3417),
    [anon_sym_template] = ACTIONS(3417),
    [anon_sym_operator] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_delete] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_static_assert] = ACTIONS(3417),
    [anon_sym_concept] = ACTIONS(3417),
    [anon_sym_co_return] = ACTIONS(3417),
    [anon_sym_co_yield] = ACTIONS(3417),
    [anon_sym_R_DQUOTE] = ACTIONS(3415),
    [anon_sym_LR_DQUOTE] = ACTIONS(3415),
    [anon_sym_uR_DQUOTE] = ACTIONS(3415),
    [anon_sym_UR_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3415),
    [anon_sym_co_await] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_requires] = ACTIONS(3417),
    [sym_this] = ACTIONS(3417),
  },
  [534] = {
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token2] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_virtual] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym___attribute] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym__Nonnull] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [anon_sym___asm] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
  },
  [535] = {
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token2] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym___attribute] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym__Nonnull] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym__Alignas] = ACTIONS(2755),
    [sym_primitive_type] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [anon_sym___asm] = ACTIONS(2755),
    [sym_number_literal] = ACTIONS(2757),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(3085),
    [sym_identifier] = ACTIONS(3083),
    [aux_sym_preproc_include_token1] = ACTIONS(3083),
    [aux_sym_preproc_def_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3083),
    [sym_preproc_directive] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3085),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym___extension__] = ACTIONS(3083),
    [anon_sym_typedef] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym___attribute__] = ACTIONS(3083),
    [anon_sym___attribute] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3085),
    [anon_sym___declspec] = ACTIONS(3083),
    [anon_sym___based] = ACTIONS(3083),
    [anon_sym___cdecl] = ACTIONS(3083),
    [anon_sym___clrcall] = ACTIONS(3083),
    [anon_sym___stdcall] = ACTIONS(3083),
    [anon_sym___fastcall] = ACTIONS(3083),
    [anon_sym___thiscall] = ACTIONS(3083),
    [anon_sym___vectorcall] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_signed] = ACTIONS(3083),
    [anon_sym_unsigned] = ACTIONS(3083),
    [anon_sym_long] = ACTIONS(3083),
    [anon_sym_short] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_register] = ACTIONS(3083),
    [anon_sym_inline] = ACTIONS(3083),
    [anon_sym___inline] = ACTIONS(3083),
    [anon_sym___inline__] = ACTIONS(3083),
    [anon_sym___forceinline] = ACTIONS(3083),
    [anon_sym_thread_local] = ACTIONS(3083),
    [anon_sym___thread] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_constexpr] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_restrict] = ACTIONS(3083),
    [anon_sym___restrict__] = ACTIONS(3083),
    [anon_sym__Atomic] = ACTIONS(3083),
    [anon_sym__Noreturn] = ACTIONS(3083),
    [anon_sym_noreturn] = ACTIONS(3083),
    [anon_sym__Nonnull] = ACTIONS(3083),
    [anon_sym_mutable] = ACTIONS(3083),
    [anon_sym_constinit] = ACTIONS(3083),
    [anon_sym_consteval] = ACTIONS(3083),
    [anon_sym_alignas] = ACTIONS(3083),
    [anon_sym__Alignas] = ACTIONS(3083),
    [sym_primitive_type] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3083),
    [anon_sym_union] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_case] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_goto] = ACTIONS(3083),
    [anon_sym_not] = ACTIONS(3083),
    [anon_sym_compl] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_sizeof] = ACTIONS(3083),
    [anon_sym___alignof__] = ACTIONS(3083),
    [anon_sym___alignof] = ACTIONS(3083),
    [anon_sym__alignof] = ACTIONS(3083),
    [anon_sym_alignof] = ACTIONS(3083),
    [anon_sym__Alignof] = ACTIONS(3083),
    [anon_sym_offsetof] = ACTIONS(3083),
    [anon_sym__Generic] = ACTIONS(3083),
    [anon_sym_asm] = ACTIONS(3083),
    [anon_sym___asm__] = ACTIONS(3083),
    [anon_sym___asm] = ACTIONS(3083),
    [sym_number_literal] = ACTIONS(3085),
    [anon_sym_L_SQUOTE] = ACTIONS(3085),
    [anon_sym_u_SQUOTE] = ACTIONS(3085),
    [anon_sym_U_SQUOTE] = ACTIONS(3085),
    [anon_sym_u8_SQUOTE] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [anon_sym_L_DQUOTE] = ACTIONS(3085),
    [anon_sym_u_DQUOTE] = ACTIONS(3085),
    [anon_sym_U_DQUOTE] = ACTIONS(3085),
    [anon_sym_u8_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [sym_true] = ACTIONS(3083),
    [sym_false] = ACTIONS(3083),
    [anon_sym_NULL] = ACTIONS(3083),
    [anon_sym_nullptr] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3083),
    [anon_sym_decltype] = ACTIONS(3083),
    [anon_sym_explicit] = ACTIONS(3083),
    [anon_sym_typename] = ACTIONS(3083),
    [anon_sym_export] = ACTIONS(3083),
    [anon_sym_module] = ACTIONS(3083),
    [anon_sym_import] = ACTIONS(3083),
    [anon_sym_template] = ACTIONS(3083),
    [anon_sym_operator] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_delete] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_namespace] = ACTIONS(3083),
    [anon_sym_static_assert] = ACTIONS(3083),
    [anon_sym_concept] = ACTIONS(3083),
    [anon_sym_co_return] = ACTIONS(3083),
    [anon_sym_co_yield] = ACTIONS(3083),
    [anon_sym_R_DQUOTE] = ACTIONS(3085),
    [anon_sym_LR_DQUOTE] = ACTIONS(3085),
    [anon_sym_uR_DQUOTE] = ACTIONS(3085),
    [anon_sym_UR_DQUOTE] = ACTIONS(3085),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3085),
    [anon_sym_co_await] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_requires] = ACTIONS(3083),
    [sym_this] = ACTIONS(3083),
  },
  [537] = {
    [sym_identifier] = ACTIONS(2687),
    [aux_sym_preproc_include_token1] = ACTIONS(2687),
    [aux_sym_preproc_def_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token2] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym___extension__] = ACTIONS(2687),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_virtual] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym___attribute] = ACTIONS(2687),
    [anon_sym_using] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2689),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2689),
    [anon_sym___declspec] = ACTIONS(2687),
    [anon_sym___based] = ACTIONS(2687),
    [anon_sym___cdecl] = ACTIONS(2687),
    [anon_sym___clrcall] = ACTIONS(2687),
    [anon_sym___stdcall] = ACTIONS(2687),
    [anon_sym___fastcall] = ACTIONS(2687),
    [anon_sym___thiscall] = ACTIONS(2687),
    [anon_sym___vectorcall] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym___inline] = ACTIONS(2687),
    [anon_sym___inline__] = ACTIONS(2687),
    [anon_sym___forceinline] = ACTIONS(2687),
    [anon_sym_thread_local] = ACTIONS(2687),
    [anon_sym___thread] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_constexpr] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym___restrict__] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym__Noreturn] = ACTIONS(2687),
    [anon_sym_noreturn] = ACTIONS(2687),
    [anon_sym__Nonnull] = ACTIONS(2687),
    [anon_sym_mutable] = ACTIONS(2687),
    [anon_sym_constinit] = ACTIONS(2687),
    [anon_sym_consteval] = ACTIONS(2687),
    [anon_sym_alignas] = ACTIONS(2687),
    [anon_sym__Alignas] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym___try] = ACTIONS(2687),
    [anon_sym___leave] = ACTIONS(2687),
    [anon_sym_not] = ACTIONS(2687),
    [anon_sym_compl] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [anon_sym___alignof__] = ACTIONS(2687),
    [anon_sym___alignof] = ACTIONS(2687),
    [anon_sym__alignof] = ACTIONS(2687),
    [anon_sym_alignof] = ACTIONS(2687),
    [anon_sym__Alignof] = ACTIONS(2687),
    [anon_sym_offsetof] = ACTIONS(2687),
    [anon_sym__Generic] = ACTIONS(2687),
    [anon_sym_asm] = ACTIONS(2687),
    [anon_sym___asm__] = ACTIONS(2687),
    [anon_sym___asm] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [anon_sym_L_SQUOTE] = ACTIONS(2689),
    [anon_sym_u_SQUOTE] = ACTIONS(2689),
    [anon_sym_U_SQUOTE] = ACTIONS(2689),
    [anon_sym_u8_SQUOTE] = ACTIONS(2689),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_L_DQUOTE] = ACTIONS(2689),
    [anon_sym_u_DQUOTE] = ACTIONS(2689),
    [anon_sym_U_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [anon_sym_NULL] = ACTIONS(2687),
    [anon_sym_nullptr] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2687),
    [anon_sym_decltype] = ACTIONS(2687),
    [anon_sym_explicit] = ACTIONS(2687),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2687),
    [anon_sym_operator] = ACTIONS(2687),
    [anon_sym_try] = ACTIONS(2687),
    [anon_sym_delete] = ACTIONS(2687),
    [anon_sym_throw] = ACTIONS(2687),
    [anon_sym_namespace] = ACTIONS(2687),
    [anon_sym_static_assert] = ACTIONS(2687),
    [anon_sym_concept] = ACTIONS(2687),
    [anon_sym_co_return] = ACTIONS(2687),
    [anon_sym_co_yield] = ACTIONS(2687),
    [anon_sym_R_DQUOTE] = ACTIONS(2689),
    [anon_sym_LR_DQUOTE] = ACTIONS(2689),
    [anon_sym_uR_DQUOTE] = ACTIONS(2689),
    [anon_sym_UR_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2689),
    [anon_sym_co_await] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2687),
    [anon_sym_requires] = ACTIONS(2687),
    [sym_this] = ACTIONS(2687),
  },
  [538] = {
    [sym_identifier] = ACTIONS(2715),
    [aux_sym_preproc_include_token1] = ACTIONS(2715),
    [aux_sym_preproc_def_token1] = ACTIONS(2715),
    [aux_sym_preproc_if_token1] = ACTIONS(2715),
    [aux_sym_preproc_if_token2] = ACTIONS(2715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2715),
    [sym_preproc_directive] = ACTIONS(2715),
    [anon_sym_LPAREN2] = ACTIONS(2717),
    [anon_sym_BANG] = ACTIONS(2717),
    [anon_sym_TILDE] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_AMP_AMP] = ACTIONS(2717),
    [anon_sym_AMP] = ACTIONS(2715),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym___extension__] = ACTIONS(2715),
    [anon_sym_typedef] = ACTIONS(2715),
    [anon_sym_virtual] = ACTIONS(2715),
    [anon_sym_extern] = ACTIONS(2715),
    [anon_sym___attribute__] = ACTIONS(2715),
    [anon_sym___attribute] = ACTIONS(2715),
    [anon_sym_using] = ACTIONS(2715),
    [anon_sym_COLON_COLON] = ACTIONS(2717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2717),
    [anon_sym___declspec] = ACTIONS(2715),
    [anon_sym___based] = ACTIONS(2715),
    [anon_sym___cdecl] = ACTIONS(2715),
    [anon_sym___clrcall] = ACTIONS(2715),
    [anon_sym___stdcall] = ACTIONS(2715),
    [anon_sym___fastcall] = ACTIONS(2715),
    [anon_sym___thiscall] = ACTIONS(2715),
    [anon_sym___vectorcall] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_signed] = ACTIONS(2715),
    [anon_sym_unsigned] = ACTIONS(2715),
    [anon_sym_long] = ACTIONS(2715),
    [anon_sym_short] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(2715),
    [anon_sym_static] = ACTIONS(2715),
    [anon_sym_register] = ACTIONS(2715),
    [anon_sym_inline] = ACTIONS(2715),
    [anon_sym___inline] = ACTIONS(2715),
    [anon_sym___inline__] = ACTIONS(2715),
    [anon_sym___forceinline] = ACTIONS(2715),
    [anon_sym_thread_local] = ACTIONS(2715),
    [anon_sym___thread] = ACTIONS(2715),
    [anon_sym_const] = ACTIONS(2715),
    [anon_sym_constexpr] = ACTIONS(2715),
    [anon_sym_volatile] = ACTIONS(2715),
    [anon_sym_restrict] = ACTIONS(2715),
    [anon_sym___restrict__] = ACTIONS(2715),
    [anon_sym__Atomic] = ACTIONS(2715),
    [anon_sym__Noreturn] = ACTIONS(2715),
    [anon_sym_noreturn] = ACTIONS(2715),
    [anon_sym__Nonnull] = ACTIONS(2715),
    [anon_sym_mutable] = ACTIONS(2715),
    [anon_sym_constinit] = ACTIONS(2715),
    [anon_sym_consteval] = ACTIONS(2715),
    [anon_sym_alignas] = ACTIONS(2715),
    [anon_sym__Alignas] = ACTIONS(2715),
    [sym_primitive_type] = ACTIONS(2715),
    [anon_sym_enum] = ACTIONS(2715),
    [anon_sym_class] = ACTIONS(2715),
    [anon_sym_struct] = ACTIONS(2715),
    [anon_sym_union] = ACTIONS(2715),
    [anon_sym_if] = ACTIONS(2715),
    [anon_sym_else] = ACTIONS(2715),
    [anon_sym_switch] = ACTIONS(2715),
    [anon_sym_case] = ACTIONS(2715),
    [anon_sym_default] = ACTIONS(2715),
    [anon_sym_while] = ACTIONS(2715),
    [anon_sym_do] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2715),
    [anon_sym_return] = ACTIONS(2715),
    [anon_sym_break] = ACTIONS(2715),
    [anon_sym_continue] = ACTIONS(2715),
    [anon_sym_goto] = ACTIONS(2715),
    [anon_sym___try] = ACTIONS(2715),
    [anon_sym___leave] = ACTIONS(2715),
    [anon_sym_not] = ACTIONS(2715),
    [anon_sym_compl] = ACTIONS(2715),
    [anon_sym_DASH_DASH] = ACTIONS(2717),
    [anon_sym_PLUS_PLUS] = ACTIONS(2717),
    [anon_sym_sizeof] = ACTIONS(2715),
    [anon_sym___alignof__] = ACTIONS(2715),
    [anon_sym___alignof] = ACTIONS(2715),
    [anon_sym__alignof] = ACTIONS(2715),
    [anon_sym_alignof] = ACTIONS(2715),
    [anon_sym__Alignof] = ACTIONS(2715),
    [anon_sym_offsetof] = ACTIONS(2715),
    [anon_sym__Generic] = ACTIONS(2715),
    [anon_sym_asm] = ACTIONS(2715),
    [anon_sym___asm__] = ACTIONS(2715),
    [anon_sym___asm] = ACTIONS(2715),
    [sym_number_literal] = ACTIONS(2717),
    [anon_sym_L_SQUOTE] = ACTIONS(2717),
    [anon_sym_u_SQUOTE] = ACTIONS(2717),
    [anon_sym_U_SQUOTE] = ACTIONS(2717),
    [anon_sym_u8_SQUOTE] = ACTIONS(2717),
    [anon_sym_SQUOTE] = ACTIONS(2717),
    [anon_sym_L_DQUOTE] = ACTIONS(2717),
    [anon_sym_u_DQUOTE] = ACTIONS(2717),
    [anon_sym_U_DQUOTE] = ACTIONS(2717),
    [anon_sym_u8_DQUOTE] = ACTIONS(2717),
    [anon_sym_DQUOTE] = ACTIONS(2717),
    [sym_true] = ACTIONS(2715),
    [sym_false] = ACTIONS(2715),
    [anon_sym_NULL] = ACTIONS(2715),
    [anon_sym_nullptr] = ACTIONS(2715),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2715),
    [anon_sym_decltype] = ACTIONS(2715),
    [anon_sym_explicit] = ACTIONS(2715),
    [anon_sym_typename] = ACTIONS(2715),
    [anon_sym_template] = ACTIONS(2715),
    [anon_sym_operator] = ACTIONS(2715),
    [anon_sym_try] = ACTIONS(2715),
    [anon_sym_delete] = ACTIONS(2715),
    [anon_sym_throw] = ACTIONS(2715),
    [anon_sym_namespace] = ACTIONS(2715),
    [anon_sym_static_assert] = ACTIONS(2715),
    [anon_sym_concept] = ACTIONS(2715),
    [anon_sym_co_return] = ACTIONS(2715),
    [anon_sym_co_yield] = ACTIONS(2715),
    [anon_sym_R_DQUOTE] = ACTIONS(2717),
    [anon_sym_LR_DQUOTE] = ACTIONS(2717),
    [anon_sym_uR_DQUOTE] = ACTIONS(2717),
    [anon_sym_UR_DQUOTE] = ACTIONS(2717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2717),
    [anon_sym_co_await] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2715),
    [anon_sym_requires] = ACTIONS(2715),
    [sym_this] = ACTIONS(2715),
  },
  [539] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_include_token1] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token2] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym___cdecl] = ACTIONS(2703),
    [anon_sym___clrcall] = ACTIONS(2703),
    [anon_sym___stdcall] = ACTIONS(2703),
    [anon_sym___fastcall] = ACTIONS(2703),
    [anon_sym___thiscall] = ACTIONS(2703),
    [anon_sym___vectorcall] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [anon_sym_if] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2703),
    [anon_sym_case] = ACTIONS(2703),
    [anon_sym_default] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(2703),
    [anon_sym_do] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2703),
    [anon_sym_return] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2703),
    [anon_sym_continue] = ACTIONS(2703),
    [anon_sym_goto] = ACTIONS(2703),
    [anon_sym___try] = ACTIONS(2703),
    [anon_sym___leave] = ACTIONS(2703),
    [anon_sym_not] = ACTIONS(2703),
    [anon_sym_compl] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2703),
    [anon_sym___alignof__] = ACTIONS(2703),
    [anon_sym___alignof] = ACTIONS(2703),
    [anon_sym__alignof] = ACTIONS(2703),
    [anon_sym_alignof] = ACTIONS(2703),
    [anon_sym__Alignof] = ACTIONS(2703),
    [anon_sym_offsetof] = ACTIONS(2703),
    [anon_sym__Generic] = ACTIONS(2703),
    [anon_sym_asm] = ACTIONS(2703),
    [anon_sym___asm__] = ACTIONS(2703),
    [anon_sym___asm] = ACTIONS(2703),
    [sym_number_literal] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2705),
    [anon_sym_u_SQUOTE] = ACTIONS(2705),
    [anon_sym_U_SQUOTE] = ACTIONS(2705),
    [anon_sym_u8_SQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_L_DQUOTE] = ACTIONS(2705),
    [anon_sym_u_DQUOTE] = ACTIONS(2705),
    [anon_sym_U_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8_DQUOTE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [sym_false] = ACTIONS(2703),
    [anon_sym_NULL] = ACTIONS(2703),
    [anon_sym_nullptr] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2703),
    [anon_sym_delete] = ACTIONS(2703),
    [anon_sym_throw] = ACTIONS(2703),
    [anon_sym_namespace] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
    [anon_sym_concept] = ACTIONS(2703),
    [anon_sym_co_return] = ACTIONS(2703),
    [anon_sym_co_yield] = ACTIONS(2703),
    [anon_sym_R_DQUOTE] = ACTIONS(2705),
    [anon_sym_LR_DQUOTE] = ACTIONS(2705),
    [anon_sym_uR_DQUOTE] = ACTIONS(2705),
    [anon_sym_UR_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2705),
    [anon_sym_co_await] = ACTIONS(2703),
    [anon_sym_new] = ACTIONS(2703),
    [anon_sym_requires] = ACTIONS(2703),
    [sym_this] = ACTIONS(2703),
  },
  [540] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token2] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [anon_sym___asm] = ACTIONS(2735),
    [sym_number_literal] = ACTIONS(2737),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [541] = {
    [sym_identifier] = ACTIONS(2743),
    [aux_sym_preproc_include_token1] = ACTIONS(2743),
    [aux_sym_preproc_def_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token2] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2743),
    [sym_preproc_directive] = ACTIONS(2743),
    [anon_sym_LPAREN2] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym___extension__] = ACTIONS(2743),
    [anon_sym_typedef] = ACTIONS(2743),
    [anon_sym_virtual] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym___attribute__] = ACTIONS(2743),
    [anon_sym___attribute] = ACTIONS(2743),
    [anon_sym_using] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(2745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2745),
    [anon_sym___declspec] = ACTIONS(2743),
    [anon_sym___based] = ACTIONS(2743),
    [anon_sym___cdecl] = ACTIONS(2743),
    [anon_sym___clrcall] = ACTIONS(2743),
    [anon_sym___stdcall] = ACTIONS(2743),
    [anon_sym___fastcall] = ACTIONS(2743),
    [anon_sym___thiscall] = ACTIONS(2743),
    [anon_sym___vectorcall] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_signed] = ACTIONS(2743),
    [anon_sym_unsigned] = ACTIONS(2743),
    [anon_sym_long] = ACTIONS(2743),
    [anon_sym_short] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_register] = ACTIONS(2743),
    [anon_sym_inline] = ACTIONS(2743),
    [anon_sym___inline] = ACTIONS(2743),
    [anon_sym___inline__] = ACTIONS(2743),
    [anon_sym___forceinline] = ACTIONS(2743),
    [anon_sym_thread_local] = ACTIONS(2743),
    [anon_sym___thread] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_constexpr] = ACTIONS(2743),
    [anon_sym_volatile] = ACTIONS(2743),
    [anon_sym_restrict] = ACTIONS(2743),
    [anon_sym___restrict__] = ACTIONS(2743),
    [anon_sym__Atomic] = ACTIONS(2743),
    [anon_sym__Noreturn] = ACTIONS(2743),
    [anon_sym_noreturn] = ACTIONS(2743),
    [anon_sym__Nonnull] = ACTIONS(2743),
    [anon_sym_mutable] = ACTIONS(2743),
    [anon_sym_constinit] = ACTIONS(2743),
    [anon_sym_consteval] = ACTIONS(2743),
    [anon_sym_alignas] = ACTIONS(2743),
    [anon_sym__Alignas] = ACTIONS(2743),
    [sym_primitive_type] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2743),
    [anon_sym_switch] = ACTIONS(2743),
    [anon_sym_case] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_goto] = ACTIONS(2743),
    [anon_sym___try] = ACTIONS(2743),
    [anon_sym___leave] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2743),
    [anon_sym_compl] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2745),
    [anon_sym_sizeof] = ACTIONS(2743),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2743),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2743),
    [anon_sym___asm__] = ACTIONS(2743),
    [anon_sym___asm] = ACTIONS(2743),
    [sym_number_literal] = ACTIONS(2745),
    [anon_sym_L_SQUOTE] = ACTIONS(2745),
    [anon_sym_u_SQUOTE] = ACTIONS(2745),
    [anon_sym_U_SQUOTE] = ACTIONS(2745),
    [anon_sym_u8_SQUOTE] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2745),
    [anon_sym_L_DQUOTE] = ACTIONS(2745),
    [anon_sym_u_DQUOTE] = ACTIONS(2745),
    [anon_sym_U_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8_DQUOTE] = ACTIONS(2745),
    [anon_sym_DQUOTE] = ACTIONS(2745),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [anon_sym_NULL] = ACTIONS(2743),
    [anon_sym_nullptr] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2743),
    [anon_sym_decltype] = ACTIONS(2743),
    [anon_sym_explicit] = ACTIONS(2743),
    [anon_sym_typename] = ACTIONS(2743),
    [anon_sym_template] = ACTIONS(2743),
    [anon_sym_operator] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [anon_sym_delete] = ACTIONS(2743),
    [anon_sym_throw] = ACTIONS(2743),
    [anon_sym_namespace] = ACTIONS(2743),
    [anon_sym_static_assert] = ACTIONS(2743),
    [anon_sym_concept] = ACTIONS(2743),
    [anon_sym_co_return] = ACTIONS(2743),
    [anon_sym_co_yield] = ACTIONS(2743),
    [anon_sym_R_DQUOTE] = ACTIONS(2745),
    [anon_sym_LR_DQUOTE] = ACTIONS(2745),
    [anon_sym_uR_DQUOTE] = ACTIONS(2745),
    [anon_sym_UR_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2745),
    [anon_sym_co_await] = ACTIONS(2743),
    [anon_sym_new] = ACTIONS(2743),
    [anon_sym_requires] = ACTIONS(2743),
    [sym_this] = ACTIONS(2743),
  },
  [542] = {
    [sym_identifier] = ACTIONS(2647),
    [aux_sym_preproc_include_token1] = ACTIONS(2647),
    [aux_sym_preproc_def_token1] = ACTIONS(2647),
    [aux_sym_preproc_if_token1] = ACTIONS(2647),
    [aux_sym_preproc_if_token2] = ACTIONS(2647),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2647),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2647),
    [sym_preproc_directive] = ACTIONS(2647),
    [anon_sym_LPAREN2] = ACTIONS(2649),
    [anon_sym_BANG] = ACTIONS(2649),
    [anon_sym_TILDE] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2649),
    [anon_sym_AMP_AMP] = ACTIONS(2649),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_SEMI] = ACTIONS(2649),
    [anon_sym___extension__] = ACTIONS(2647),
    [anon_sym_typedef] = ACTIONS(2647),
    [anon_sym_virtual] = ACTIONS(2647),
    [anon_sym_extern] = ACTIONS(2647),
    [anon_sym___attribute__] = ACTIONS(2647),
    [anon_sym___attribute] = ACTIONS(2647),
    [anon_sym_using] = ACTIONS(2647),
    [anon_sym_COLON_COLON] = ACTIONS(2649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2649),
    [anon_sym___declspec] = ACTIONS(2647),
    [anon_sym___based] = ACTIONS(2647),
    [anon_sym___cdecl] = ACTIONS(2647),
    [anon_sym___clrcall] = ACTIONS(2647),
    [anon_sym___stdcall] = ACTIONS(2647),
    [anon_sym___fastcall] = ACTIONS(2647),
    [anon_sym___thiscall] = ACTIONS(2647),
    [anon_sym___vectorcall] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2649),
    [anon_sym_signed] = ACTIONS(2647),
    [anon_sym_unsigned] = ACTIONS(2647),
    [anon_sym_long] = ACTIONS(2647),
    [anon_sym_short] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2647),
    [anon_sym_static] = ACTIONS(2647),
    [anon_sym_register] = ACTIONS(2647),
    [anon_sym_inline] = ACTIONS(2647),
    [anon_sym___inline] = ACTIONS(2647),
    [anon_sym___inline__] = ACTIONS(2647),
    [anon_sym___forceinline] = ACTIONS(2647),
    [anon_sym_thread_local] = ACTIONS(2647),
    [anon_sym___thread] = ACTIONS(2647),
    [anon_sym_const] = ACTIONS(2647),
    [anon_sym_constexpr] = ACTIONS(2647),
    [anon_sym_volatile] = ACTIONS(2647),
    [anon_sym_restrict] = ACTIONS(2647),
    [anon_sym___restrict__] = ACTIONS(2647),
    [anon_sym__Atomic] = ACTIONS(2647),
    [anon_sym__Noreturn] = ACTIONS(2647),
    [anon_sym_noreturn] = ACTIONS(2647),
    [anon_sym__Nonnull] = ACTIONS(2647),
    [anon_sym_mutable] = ACTIONS(2647),
    [anon_sym_constinit] = ACTIONS(2647),
    [anon_sym_consteval] = ACTIONS(2647),
    [anon_sym_alignas] = ACTIONS(2647),
    [anon_sym__Alignas] = ACTIONS(2647),
    [sym_primitive_type] = ACTIONS(2647),
    [anon_sym_enum] = ACTIONS(2647),
    [anon_sym_class] = ACTIONS(2647),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_union] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_else] = ACTIONS(2647),
    [anon_sym_switch] = ACTIONS(2647),
    [anon_sym_case] = ACTIONS(2647),
    [anon_sym_default] = ACTIONS(2647),
    [anon_sym_while] = ACTIONS(2647),
    [anon_sym_do] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_return] = ACTIONS(2647),
    [anon_sym_break] = ACTIONS(2647),
    [anon_sym_continue] = ACTIONS(2647),
    [anon_sym_goto] = ACTIONS(2647),
    [anon_sym___try] = ACTIONS(2647),
    [anon_sym___leave] = ACTIONS(2647),
    [anon_sym_not] = ACTIONS(2647),
    [anon_sym_compl] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2649),
    [anon_sym_PLUS_PLUS] = ACTIONS(2649),
    [anon_sym_sizeof] = ACTIONS(2647),
    [anon_sym___alignof__] = ACTIONS(2647),
    [anon_sym___alignof] = ACTIONS(2647),
    [anon_sym__alignof] = ACTIONS(2647),
    [anon_sym_alignof] = ACTIONS(2647),
    [anon_sym__Alignof] = ACTIONS(2647),
    [anon_sym_offsetof] = ACTIONS(2647),
    [anon_sym__Generic] = ACTIONS(2647),
    [anon_sym_asm] = ACTIONS(2647),
    [anon_sym___asm__] = ACTIONS(2647),
    [anon_sym___asm] = ACTIONS(2647),
    [sym_number_literal] = ACTIONS(2649),
    [anon_sym_L_SQUOTE] = ACTIONS(2649),
    [anon_sym_u_SQUOTE] = ACTIONS(2649),
    [anon_sym_U_SQUOTE] = ACTIONS(2649),
    [anon_sym_u8_SQUOTE] = ACTIONS(2649),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_L_DQUOTE] = ACTIONS(2649),
    [anon_sym_u_DQUOTE] = ACTIONS(2649),
    [anon_sym_U_DQUOTE] = ACTIONS(2649),
    [anon_sym_u8_DQUOTE] = ACTIONS(2649),
    [anon_sym_DQUOTE] = ACTIONS(2649),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [anon_sym_NULL] = ACTIONS(2647),
    [anon_sym_nullptr] = ACTIONS(2647),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2647),
    [anon_sym_decltype] = ACTIONS(2647),
    [anon_sym_explicit] = ACTIONS(2647),
    [anon_sym_typename] = ACTIONS(2647),
    [anon_sym_template] = ACTIONS(2647),
    [anon_sym_operator] = ACTIONS(2647),
    [anon_sym_try] = ACTIONS(2647),
    [anon_sym_delete] = ACTIONS(2647),
    [anon_sym_throw] = ACTIONS(2647),
    [anon_sym_namespace] = ACTIONS(2647),
    [anon_sym_static_assert] = ACTIONS(2647),
    [anon_sym_concept] = ACTIONS(2647),
    [anon_sym_co_return] = ACTIONS(2647),
    [anon_sym_co_yield] = ACTIONS(2647),
    [anon_sym_R_DQUOTE] = ACTIONS(2649),
    [anon_sym_LR_DQUOTE] = ACTIONS(2649),
    [anon_sym_uR_DQUOTE] = ACTIONS(2649),
    [anon_sym_UR_DQUOTE] = ACTIONS(2649),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2649),
    [anon_sym_co_await] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(2647),
    [anon_sym_requires] = ACTIONS(2647),
    [sym_this] = ACTIONS(2647),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(3313),
    [aux_sym_preproc_include_token1] = ACTIONS(3313),
    [aux_sym_preproc_def_token1] = ACTIONS(3313),
    [aux_sym_preproc_if_token1] = ACTIONS(3313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3313),
    [sym_preproc_directive] = ACTIONS(3313),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_PLUS] = ACTIONS(3313),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3313),
    [anon_sym_typedef] = ACTIONS(3313),
    [anon_sym_virtual] = ACTIONS(3313),
    [anon_sym_extern] = ACTIONS(3313),
    [anon_sym___attribute__] = ACTIONS(3313),
    [anon_sym___attribute] = ACTIONS(3313),
    [anon_sym_using] = ACTIONS(3313),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3313),
    [anon_sym___based] = ACTIONS(3313),
    [anon_sym___cdecl] = ACTIONS(3313),
    [anon_sym___clrcall] = ACTIONS(3313),
    [anon_sym___stdcall] = ACTIONS(3313),
    [anon_sym___fastcall] = ACTIONS(3313),
    [anon_sym___thiscall] = ACTIONS(3313),
    [anon_sym___vectorcall] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3313),
    [anon_sym_unsigned] = ACTIONS(3313),
    [anon_sym_long] = ACTIONS(3313),
    [anon_sym_short] = ACTIONS(3313),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_static] = ACTIONS(3313),
    [anon_sym_register] = ACTIONS(3313),
    [anon_sym_inline] = ACTIONS(3313),
    [anon_sym___inline] = ACTIONS(3313),
    [anon_sym___inline__] = ACTIONS(3313),
    [anon_sym___forceinline] = ACTIONS(3313),
    [anon_sym_thread_local] = ACTIONS(3313),
    [anon_sym___thread] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3313),
    [anon_sym_constexpr] = ACTIONS(3313),
    [anon_sym_volatile] = ACTIONS(3313),
    [anon_sym_restrict] = ACTIONS(3313),
    [anon_sym___restrict__] = ACTIONS(3313),
    [anon_sym__Atomic] = ACTIONS(3313),
    [anon_sym__Noreturn] = ACTIONS(3313),
    [anon_sym_noreturn] = ACTIONS(3313),
    [anon_sym__Nonnull] = ACTIONS(3313),
    [anon_sym_mutable] = ACTIONS(3313),
    [anon_sym_constinit] = ACTIONS(3313),
    [anon_sym_consteval] = ACTIONS(3313),
    [anon_sym_alignas] = ACTIONS(3313),
    [anon_sym__Alignas] = ACTIONS(3313),
    [sym_primitive_type] = ACTIONS(3313),
    [anon_sym_enum] = ACTIONS(3313),
    [anon_sym_class] = ACTIONS(3313),
    [anon_sym_struct] = ACTIONS(3313),
    [anon_sym_union] = ACTIONS(3313),
    [anon_sym_if] = ACTIONS(3313),
    [anon_sym_switch] = ACTIONS(3313),
    [anon_sym_case] = ACTIONS(3313),
    [anon_sym_default] = ACTIONS(3313),
    [anon_sym_while] = ACTIONS(3313),
    [anon_sym_do] = ACTIONS(3313),
    [anon_sym_for] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3313),
    [anon_sym_break] = ACTIONS(3313),
    [anon_sym_continue] = ACTIONS(3313),
    [anon_sym_goto] = ACTIONS(3313),
    [anon_sym_not] = ACTIONS(3313),
    [anon_sym_compl] = ACTIONS(3313),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3313),
    [anon_sym___alignof__] = ACTIONS(3313),
    [anon_sym___alignof] = ACTIONS(3313),
    [anon_sym__alignof] = ACTIONS(3313),
    [anon_sym_alignof] = ACTIONS(3313),
    [anon_sym__Alignof] = ACTIONS(3313),
    [anon_sym_offsetof] = ACTIONS(3313),
    [anon_sym__Generic] = ACTIONS(3313),
    [anon_sym_asm] = ACTIONS(3313),
    [anon_sym___asm__] = ACTIONS(3313),
    [anon_sym___asm] = ACTIONS(3313),
    [sym_number_literal] = ACTIONS(3316),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3313),
    [sym_false] = ACTIONS(3313),
    [anon_sym_NULL] = ACTIONS(3313),
    [anon_sym_nullptr] = ACTIONS(3313),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3313),
    [anon_sym_decltype] = ACTIONS(3313),
    [anon_sym_explicit] = ACTIONS(3313),
    [anon_sym_typename] = ACTIONS(3313),
    [anon_sym_export] = ACTIONS(3313),
    [anon_sym_module] = ACTIONS(3313),
    [anon_sym_import] = ACTIONS(3313),
    [anon_sym_template] = ACTIONS(3313),
    [anon_sym_operator] = ACTIONS(3313),
    [anon_sym_try] = ACTIONS(3313),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_throw] = ACTIONS(3313),
    [anon_sym_namespace] = ACTIONS(3313),
    [anon_sym_static_assert] = ACTIONS(3313),
    [anon_sym_concept] = ACTIONS(3313),
    [anon_sym_co_return] = ACTIONS(3313),
    [anon_sym_co_yield] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3313),
    [anon_sym_new] = ACTIONS(3313),
    [anon_sym_requires] = ACTIONS(3313),
    [sym_this] = ACTIONS(3313),
  },
  [544] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_RBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [anon_sym___asm] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [545] = {
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_include_token1] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym___cdecl] = ACTIONS(2763),
    [anon_sym___clrcall] = ACTIONS(2763),
    [anon_sym___stdcall] = ACTIONS(2763),
    [anon_sym___fastcall] = ACTIONS(2763),
    [anon_sym___thiscall] = ACTIONS(2763),
    [anon_sym___vectorcall] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_else] = ACTIONS(2763),
    [anon_sym_switch] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2763),
    [anon_sym_default] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_do] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_goto] = ACTIONS(2763),
    [anon_sym___try] = ACTIONS(2763),
    [anon_sym___leave] = ACTIONS(2763),
    [anon_sym_not] = ACTIONS(2763),
    [anon_sym_compl] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_sizeof] = ACTIONS(2763),
    [anon_sym___alignof__] = ACTIONS(2763),
    [anon_sym___alignof] = ACTIONS(2763),
    [anon_sym__alignof] = ACTIONS(2763),
    [anon_sym_alignof] = ACTIONS(2763),
    [anon_sym__Alignof] = ACTIONS(2763),
    [anon_sym_offsetof] = ACTIONS(2763),
    [anon_sym__Generic] = ACTIONS(2763),
    [anon_sym_asm] = ACTIONS(2763),
    [anon_sym___asm__] = ACTIONS(2763),
    [anon_sym___asm] = ACTIONS(2763),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2765),
    [anon_sym_u_SQUOTE] = ACTIONS(2765),
    [anon_sym_U_SQUOTE] = ACTIONS(2765),
    [anon_sym_u8_SQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_L_DQUOTE] = ACTIONS(2765),
    [anon_sym_u_DQUOTE] = ACTIONS(2765),
    [anon_sym_U_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8_DQUOTE] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [anon_sym_NULL] = ACTIONS(2763),
    [anon_sym_nullptr] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_throw] = ACTIONS(2763),
    [anon_sym_namespace] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
    [anon_sym_concept] = ACTIONS(2763),
    [anon_sym_co_return] = ACTIONS(2763),
    [anon_sym_co_yield] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2763),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_requires] = ACTIONS(2763),
    [sym_this] = ACTIONS(2763),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(3419),
    [sym_identifier] = ACTIONS(3422),
    [aux_sym_preproc_include_token1] = ACTIONS(3422),
    [aux_sym_preproc_def_token1] = ACTIONS(3422),
    [aux_sym_preproc_if_token1] = ACTIONS(3422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3422),
    [sym_preproc_directive] = ACTIONS(3422),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3422),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_STAR] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3422),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3422),
    [anon_sym_typedef] = ACTIONS(3422),
    [anon_sym_virtual] = ACTIONS(3422),
    [anon_sym_extern] = ACTIONS(3422),
    [anon_sym___attribute__] = ACTIONS(3422),
    [anon_sym___attribute] = ACTIONS(3422),
    [anon_sym_using] = ACTIONS(3422),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3419),
    [anon_sym___declspec] = ACTIONS(3422),
    [anon_sym___based] = ACTIONS(3422),
    [anon_sym___cdecl] = ACTIONS(3422),
    [anon_sym___clrcall] = ACTIONS(3422),
    [anon_sym___stdcall] = ACTIONS(3422),
    [anon_sym___fastcall] = ACTIONS(3422),
    [anon_sym___thiscall] = ACTIONS(3422),
    [anon_sym___vectorcall] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_signed] = ACTIONS(3422),
    [anon_sym_unsigned] = ACTIONS(3422),
    [anon_sym_long] = ACTIONS(3422),
    [anon_sym_short] = ACTIONS(3422),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_static] = ACTIONS(3422),
    [anon_sym_register] = ACTIONS(3422),
    [anon_sym_inline] = ACTIONS(3422),
    [anon_sym___inline] = ACTIONS(3422),
    [anon_sym___inline__] = ACTIONS(3422),
    [anon_sym___forceinline] = ACTIONS(3422),
    [anon_sym_thread_local] = ACTIONS(3422),
    [anon_sym___thread] = ACTIONS(3422),
    [anon_sym_const] = ACTIONS(3422),
    [anon_sym_constexpr] = ACTIONS(3422),
    [anon_sym_volatile] = ACTIONS(3422),
    [anon_sym_restrict] = ACTIONS(3422),
    [anon_sym___restrict__] = ACTIONS(3422),
    [anon_sym__Atomic] = ACTIONS(3422),
    [anon_sym__Noreturn] = ACTIONS(3422),
    [anon_sym_noreturn] = ACTIONS(3422),
    [anon_sym__Nonnull] = ACTIONS(3422),
    [anon_sym_mutable] = ACTIONS(3422),
    [anon_sym_constinit] = ACTIONS(3422),
    [anon_sym_consteval] = ACTIONS(3422),
    [anon_sym_alignas] = ACTIONS(3422),
    [anon_sym__Alignas] = ACTIONS(3422),
    [sym_primitive_type] = ACTIONS(3422),
    [anon_sym_enum] = ACTIONS(3422),
    [anon_sym_class] = ACTIONS(3422),
    [anon_sym_struct] = ACTIONS(3422),
    [anon_sym_union] = ACTIONS(3422),
    [anon_sym_if] = ACTIONS(3422),
    [anon_sym_switch] = ACTIONS(3422),
    [anon_sym_case] = ACTIONS(3422),
    [anon_sym_default] = ACTIONS(3422),
    [anon_sym_while] = ACTIONS(3422),
    [anon_sym_do] = ACTIONS(3422),
    [anon_sym_for] = ACTIONS(3422),
    [anon_sym_return] = ACTIONS(3422),
    [anon_sym_break] = ACTIONS(3422),
    [anon_sym_continue] = ACTIONS(3422),
    [anon_sym_goto] = ACTIONS(3422),
    [anon_sym_not] = ACTIONS(3422),
    [anon_sym_compl] = ACTIONS(3422),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_sizeof] = ACTIONS(3422),
    [anon_sym___alignof__] = ACTIONS(3422),
    [anon_sym___alignof] = ACTIONS(3422),
    [anon_sym__alignof] = ACTIONS(3422),
    [anon_sym_alignof] = ACTIONS(3422),
    [anon_sym__Alignof] = ACTIONS(3422),
    [anon_sym_offsetof] = ACTIONS(3422),
    [anon_sym__Generic] = ACTIONS(3422),
    [anon_sym_asm] = ACTIONS(3422),
    [anon_sym___asm__] = ACTIONS(3422),
    [anon_sym___asm] = ACTIONS(3422),
    [sym_number_literal] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3419),
    [anon_sym_u_SQUOTE] = ACTIONS(3419),
    [anon_sym_U_SQUOTE] = ACTIONS(3419),
    [anon_sym_u8_SQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_L_DQUOTE] = ACTIONS(3419),
    [anon_sym_u_DQUOTE] = ACTIONS(3419),
    [anon_sym_U_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [sym_true] = ACTIONS(3422),
    [sym_false] = ACTIONS(3422),
    [anon_sym_NULL] = ACTIONS(3422),
    [anon_sym_nullptr] = ACTIONS(3422),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3422),
    [anon_sym_decltype] = ACTIONS(3422),
    [anon_sym_explicit] = ACTIONS(3422),
    [anon_sym_typename] = ACTIONS(3422),
    [anon_sym_export] = ACTIONS(3422),
    [anon_sym_module] = ACTIONS(3422),
    [anon_sym_import] = ACTIONS(3422),
    [anon_sym_template] = ACTIONS(3422),
    [anon_sym_operator] = ACTIONS(3422),
    [anon_sym_try] = ACTIONS(3422),
    [anon_sym_delete] = ACTIONS(3422),
    [anon_sym_throw] = ACTIONS(3422),
    [anon_sym_namespace] = ACTIONS(3422),
    [anon_sym_static_assert] = ACTIONS(3422),
    [anon_sym_concept] = ACTIONS(3422),
    [anon_sym_co_return] = ACTIONS(3422),
    [anon_sym_co_yield] = ACTIONS(3422),
    [anon_sym_R_DQUOTE] = ACTIONS(3419),
    [anon_sym_LR_DQUOTE] = ACTIONS(3419),
    [anon_sym_uR_DQUOTE] = ACTIONS(3419),
    [anon_sym_UR_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3419),
    [anon_sym_co_await] = ACTIONS(3422),
    [anon_sym_new] = ACTIONS(3422),
    [anon_sym_requires] = ACTIONS(3422),
    [sym_this] = ACTIONS(3422),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(2821),
    [sym_identifier] = ACTIONS(2819),
    [aux_sym_preproc_include_token1] = ACTIONS(2819),
    [aux_sym_preproc_def_token1] = ACTIONS(2819),
    [aux_sym_preproc_if_token1] = ACTIONS(2819),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2819),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2819),
    [sym_preproc_directive] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2821),
    [anon_sym_AMP_AMP] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_SEMI] = ACTIONS(2821),
    [anon_sym___extension__] = ACTIONS(2819),
    [anon_sym_typedef] = ACTIONS(2819),
    [anon_sym_virtual] = ACTIONS(2819),
    [anon_sym_extern] = ACTIONS(2819),
    [anon_sym___attribute__] = ACTIONS(2819),
    [anon_sym___attribute] = ACTIONS(2819),
    [anon_sym_using] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2821),
    [anon_sym___declspec] = ACTIONS(2819),
    [anon_sym___based] = ACTIONS(2819),
    [anon_sym___cdecl] = ACTIONS(2819),
    [anon_sym___clrcall] = ACTIONS(2819),
    [anon_sym___stdcall] = ACTIONS(2819),
    [anon_sym___fastcall] = ACTIONS(2819),
    [anon_sym___thiscall] = ACTIONS(2819),
    [anon_sym___vectorcall] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2821),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_static] = ACTIONS(2819),
    [anon_sym_register] = ACTIONS(2819),
    [anon_sym_inline] = ACTIONS(2819),
    [anon_sym___inline] = ACTIONS(2819),
    [anon_sym___inline__] = ACTIONS(2819),
    [anon_sym___forceinline] = ACTIONS(2819),
    [anon_sym_thread_local] = ACTIONS(2819),
    [anon_sym___thread] = ACTIONS(2819),
    [anon_sym_const] = ACTIONS(2819),
    [anon_sym_constexpr] = ACTIONS(2819),
    [anon_sym_volatile] = ACTIONS(2819),
    [anon_sym_restrict] = ACTIONS(2819),
    [anon_sym___restrict__] = ACTIONS(2819),
    [anon_sym__Atomic] = ACTIONS(2819),
    [anon_sym__Noreturn] = ACTIONS(2819),
    [anon_sym_noreturn] = ACTIONS(2819),
    [anon_sym__Nonnull] = ACTIONS(2819),
    [anon_sym_mutable] = ACTIONS(2819),
    [anon_sym_constinit] = ACTIONS(2819),
    [anon_sym_consteval] = ACTIONS(2819),
    [anon_sym_alignas] = ACTIONS(2819),
    [anon_sym__Alignas] = ACTIONS(2819),
    [sym_primitive_type] = ACTIONS(2819),
    [anon_sym_enum] = ACTIONS(2819),
    [anon_sym_class] = ACTIONS(2819),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_union] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_switch] = ACTIONS(2819),
    [anon_sym_case] = ACTIONS(2819),
    [anon_sym_default] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2819),
    [anon_sym_continue] = ACTIONS(2819),
    [anon_sym_goto] = ACTIONS(2819),
    [anon_sym_not] = ACTIONS(2819),
    [anon_sym_compl] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2821),
    [anon_sym_PLUS_PLUS] = ACTIONS(2821),
    [anon_sym_sizeof] = ACTIONS(2819),
    [anon_sym___alignof__] = ACTIONS(2819),
    [anon_sym___alignof] = ACTIONS(2819),
    [anon_sym__alignof] = ACTIONS(2819),
    [anon_sym_alignof] = ACTIONS(2819),
    [anon_sym__Alignof] = ACTIONS(2819),
    [anon_sym_offsetof] = ACTIONS(2819),
    [anon_sym__Generic] = ACTIONS(2819),
    [anon_sym_asm] = ACTIONS(2819),
    [anon_sym___asm__] = ACTIONS(2819),
    [anon_sym___asm] = ACTIONS(2819),
    [sym_number_literal] = ACTIONS(2821),
    [anon_sym_L_SQUOTE] = ACTIONS(2821),
    [anon_sym_u_SQUOTE] = ACTIONS(2821),
    [anon_sym_U_SQUOTE] = ACTIONS(2821),
    [anon_sym_u8_SQUOTE] = ACTIONS(2821),
    [anon_sym_SQUOTE] = ACTIONS(2821),
    [anon_sym_L_DQUOTE] = ACTIONS(2821),
    [anon_sym_u_DQUOTE] = ACTIONS(2821),
    [anon_sym_U_DQUOTE] = ACTIONS(2821),
    [anon_sym_u8_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE] = ACTIONS(2821),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [anon_sym_NULL] = ACTIONS(2819),
    [anon_sym_nullptr] = ACTIONS(2819),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2819),
    [anon_sym_decltype] = ACTIONS(2819),
    [anon_sym_explicit] = ACTIONS(2819),
    [anon_sym_typename] = ACTIONS(2819),
    [anon_sym_export] = ACTIONS(2819),
    [anon_sym_module] = ACTIONS(2819),
    [anon_sym_import] = ACTIONS(2819),
    [anon_sym_template] = ACTIONS(2819),
    [anon_sym_operator] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_delete] = ACTIONS(2819),
    [anon_sym_throw] = ACTIONS(2819),
    [anon_sym_namespace] = ACTIONS(2819),
    [anon_sym_static_assert] = ACTIONS(2819),
    [anon_sym_concept] = ACTIONS(2819),
    [anon_sym_co_return] = ACTIONS(2819),
    [anon_sym_co_yield] = ACTIONS(2819),
    [anon_sym_R_DQUOTE] = ACTIONS(2821),
    [anon_sym_LR_DQUOTE] = ACTIONS(2821),
    [anon_sym_uR_DQUOTE] = ACTIONS(2821),
    [anon_sym_UR_DQUOTE] = ACTIONS(2821),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2821),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_requires] = ACTIONS(2819),
    [sym_this] = ACTIONS(2819),
  },
  [548] = {
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_virtual] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym___attribute] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym__Nonnull] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [anon_sym___asm] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
  },
  [549] = {
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym___attribute] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_RBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym__Nonnull] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym__Alignas] = ACTIONS(2755),
    [sym_primitive_type] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [anon_sym___asm] = ACTIONS(2755),
    [sym_number_literal] = ACTIONS(2757),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [550] = {
    [sym_identifier] = ACTIONS(2687),
    [aux_sym_preproc_include_token1] = ACTIONS(2687),
    [aux_sym_preproc_def_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym___extension__] = ACTIONS(2687),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_virtual] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym___attribute] = ACTIONS(2687),
    [anon_sym_using] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2689),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2689),
    [anon_sym___declspec] = ACTIONS(2687),
    [anon_sym___based] = ACTIONS(2687),
    [anon_sym___cdecl] = ACTIONS(2687),
    [anon_sym___clrcall] = ACTIONS(2687),
    [anon_sym___stdcall] = ACTIONS(2687),
    [anon_sym___fastcall] = ACTIONS(2687),
    [anon_sym___thiscall] = ACTIONS(2687),
    [anon_sym___vectorcall] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym___inline] = ACTIONS(2687),
    [anon_sym___inline__] = ACTIONS(2687),
    [anon_sym___forceinline] = ACTIONS(2687),
    [anon_sym_thread_local] = ACTIONS(2687),
    [anon_sym___thread] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_constexpr] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym___restrict__] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym__Noreturn] = ACTIONS(2687),
    [anon_sym_noreturn] = ACTIONS(2687),
    [anon_sym__Nonnull] = ACTIONS(2687),
    [anon_sym_mutable] = ACTIONS(2687),
    [anon_sym_constinit] = ACTIONS(2687),
    [anon_sym_consteval] = ACTIONS(2687),
    [anon_sym_alignas] = ACTIONS(2687),
    [anon_sym__Alignas] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym___try] = ACTIONS(2687),
    [anon_sym___leave] = ACTIONS(2687),
    [anon_sym_not] = ACTIONS(2687),
    [anon_sym_compl] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [anon_sym___alignof__] = ACTIONS(2687),
    [anon_sym___alignof] = ACTIONS(2687),
    [anon_sym__alignof] = ACTIONS(2687),
    [anon_sym_alignof] = ACTIONS(2687),
    [anon_sym__Alignof] = ACTIONS(2687),
    [anon_sym_offsetof] = ACTIONS(2687),
    [anon_sym__Generic] = ACTIONS(2687),
    [anon_sym_asm] = ACTIONS(2687),
    [anon_sym___asm__] = ACTIONS(2687),
    [anon_sym___asm] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [anon_sym_L_SQUOTE] = ACTIONS(2689),
    [anon_sym_u_SQUOTE] = ACTIONS(2689),
    [anon_sym_U_SQUOTE] = ACTIONS(2689),
    [anon_sym_u8_SQUOTE] = ACTIONS(2689),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_L_DQUOTE] = ACTIONS(2689),
    [anon_sym_u_DQUOTE] = ACTIONS(2689),
    [anon_sym_U_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [anon_sym_NULL] = ACTIONS(2687),
    [anon_sym_nullptr] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2687),
    [anon_sym_decltype] = ACTIONS(2687),
    [anon_sym_explicit] = ACTIONS(2687),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2687),
    [anon_sym_operator] = ACTIONS(2687),
    [anon_sym_try] = ACTIONS(2687),
    [anon_sym_delete] = ACTIONS(2687),
    [anon_sym_throw] = ACTIONS(2687),
    [anon_sym_namespace] = ACTIONS(2687),
    [anon_sym_static_assert] = ACTIONS(2687),
    [anon_sym_concept] = ACTIONS(2687),
    [anon_sym_co_return] = ACTIONS(2687),
    [anon_sym_co_yield] = ACTIONS(2687),
    [anon_sym_R_DQUOTE] = ACTIONS(2689),
    [anon_sym_LR_DQUOTE] = ACTIONS(2689),
    [anon_sym_uR_DQUOTE] = ACTIONS(2689),
    [anon_sym_UR_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2689),
    [anon_sym_co_await] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2687),
    [anon_sym_requires] = ACTIONS(2687),
    [sym_this] = ACTIONS(2687),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(3427),
    [aux_sym_preproc_include_token1] = ACTIONS(3427),
    [aux_sym_preproc_def_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3427),
    [sym_preproc_directive] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym___extension__] = ACTIONS(3427),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym___attribute__] = ACTIONS(3427),
    [anon_sym___attribute] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3425),
    [anon_sym___declspec] = ACTIONS(3427),
    [anon_sym___based] = ACTIONS(3427),
    [anon_sym___cdecl] = ACTIONS(3427),
    [anon_sym___clrcall] = ACTIONS(3427),
    [anon_sym___stdcall] = ACTIONS(3427),
    [anon_sym___fastcall] = ACTIONS(3427),
    [anon_sym___thiscall] = ACTIONS(3427),
    [anon_sym___vectorcall] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_signed] = ACTIONS(3427),
    [anon_sym_unsigned] = ACTIONS(3427),
    [anon_sym_long] = ACTIONS(3427),
    [anon_sym_short] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_register] = ACTIONS(3427),
    [anon_sym_inline] = ACTIONS(3427),
    [anon_sym___inline] = ACTIONS(3427),
    [anon_sym___inline__] = ACTIONS(3427),
    [anon_sym___forceinline] = ACTIONS(3427),
    [anon_sym_thread_local] = ACTIONS(3427),
    [anon_sym___thread] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_constexpr] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_restrict] = ACTIONS(3427),
    [anon_sym___restrict__] = ACTIONS(3427),
    [anon_sym__Atomic] = ACTIONS(3427),
    [anon_sym__Noreturn] = ACTIONS(3427),
    [anon_sym_noreturn] = ACTIONS(3427),
    [anon_sym__Nonnull] = ACTIONS(3427),
    [anon_sym_mutable] = ACTIONS(3427),
    [anon_sym_constinit] = ACTIONS(3427),
    [anon_sym_consteval] = ACTIONS(3427),
    [anon_sym_alignas] = ACTIONS(3427),
    [anon_sym__Alignas] = ACTIONS(3427),
    [sym_primitive_type] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_union] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_case] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_goto] = ACTIONS(3427),
    [anon_sym_not] = ACTIONS(3427),
    [anon_sym_compl] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_sizeof] = ACTIONS(3427),
    [anon_sym___alignof__] = ACTIONS(3427),
    [anon_sym___alignof] = ACTIONS(3427),
    [anon_sym__alignof] = ACTIONS(3427),
    [anon_sym_alignof] = ACTIONS(3427),
    [anon_sym__Alignof] = ACTIONS(3427),
    [anon_sym_offsetof] = ACTIONS(3427),
    [anon_sym__Generic] = ACTIONS(3427),
    [anon_sym_asm] = ACTIONS(3427),
    [anon_sym___asm__] = ACTIONS(3427),
    [anon_sym___asm] = ACTIONS(3427),
    [sym_number_literal] = ACTIONS(3425),
    [anon_sym_L_SQUOTE] = ACTIONS(3425),
    [anon_sym_u_SQUOTE] = ACTIONS(3425),
    [anon_sym_U_SQUOTE] = ACTIONS(3425),
    [anon_sym_u8_SQUOTE] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_L_DQUOTE] = ACTIONS(3425),
    [anon_sym_u_DQUOTE] = ACTIONS(3425),
    [anon_sym_U_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_true] = ACTIONS(3427),
    [sym_false] = ACTIONS(3427),
    [anon_sym_NULL] = ACTIONS(3427),
    [anon_sym_nullptr] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3427),
    [anon_sym_decltype] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_typename] = ACTIONS(3427),
    [anon_sym_export] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_import] = ACTIONS(3427),
    [anon_sym_template] = ACTIONS(3427),
    [anon_sym_operator] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_delete] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_static_assert] = ACTIONS(3427),
    [anon_sym_concept] = ACTIONS(3427),
    [anon_sym_co_return] = ACTIONS(3427),
    [anon_sym_co_yield] = ACTIONS(3427),
    [anon_sym_R_DQUOTE] = ACTIONS(3425),
    [anon_sym_LR_DQUOTE] = ACTIONS(3425),
    [anon_sym_uR_DQUOTE] = ACTIONS(3425),
    [anon_sym_UR_DQUOTE] = ACTIONS(3425),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3425),
    [anon_sym_co_await] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_requires] = ACTIONS(3427),
    [sym_this] = ACTIONS(3427),
  },
  [552] = {
    [sym_identifier] = ACTIONS(2715),
    [aux_sym_preproc_include_token1] = ACTIONS(2715),
    [aux_sym_preproc_def_token1] = ACTIONS(2715),
    [aux_sym_preproc_if_token1] = ACTIONS(2715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2715),
    [sym_preproc_directive] = ACTIONS(2715),
    [anon_sym_LPAREN2] = ACTIONS(2717),
    [anon_sym_BANG] = ACTIONS(2717),
    [anon_sym_TILDE] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_AMP_AMP] = ACTIONS(2717),
    [anon_sym_AMP] = ACTIONS(2715),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym___extension__] = ACTIONS(2715),
    [anon_sym_typedef] = ACTIONS(2715),
    [anon_sym_virtual] = ACTIONS(2715),
    [anon_sym_extern] = ACTIONS(2715),
    [anon_sym___attribute__] = ACTIONS(2715),
    [anon_sym___attribute] = ACTIONS(2715),
    [anon_sym_using] = ACTIONS(2715),
    [anon_sym_COLON_COLON] = ACTIONS(2717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2717),
    [anon_sym___declspec] = ACTIONS(2715),
    [anon_sym___based] = ACTIONS(2715),
    [anon_sym___cdecl] = ACTIONS(2715),
    [anon_sym___clrcall] = ACTIONS(2715),
    [anon_sym___stdcall] = ACTIONS(2715),
    [anon_sym___fastcall] = ACTIONS(2715),
    [anon_sym___thiscall] = ACTIONS(2715),
    [anon_sym___vectorcall] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_signed] = ACTIONS(2715),
    [anon_sym_unsigned] = ACTIONS(2715),
    [anon_sym_long] = ACTIONS(2715),
    [anon_sym_short] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(2715),
    [anon_sym_static] = ACTIONS(2715),
    [anon_sym_register] = ACTIONS(2715),
    [anon_sym_inline] = ACTIONS(2715),
    [anon_sym___inline] = ACTIONS(2715),
    [anon_sym___inline__] = ACTIONS(2715),
    [anon_sym___forceinline] = ACTIONS(2715),
    [anon_sym_thread_local] = ACTIONS(2715),
    [anon_sym___thread] = ACTIONS(2715),
    [anon_sym_const] = ACTIONS(2715),
    [anon_sym_constexpr] = ACTIONS(2715),
    [anon_sym_volatile] = ACTIONS(2715),
    [anon_sym_restrict] = ACTIONS(2715),
    [anon_sym___restrict__] = ACTIONS(2715),
    [anon_sym__Atomic] = ACTIONS(2715),
    [anon_sym__Noreturn] = ACTIONS(2715),
    [anon_sym_noreturn] = ACTIONS(2715),
    [anon_sym__Nonnull] = ACTIONS(2715),
    [anon_sym_mutable] = ACTIONS(2715),
    [anon_sym_constinit] = ACTIONS(2715),
    [anon_sym_consteval] = ACTIONS(2715),
    [anon_sym_alignas] = ACTIONS(2715),
    [anon_sym__Alignas] = ACTIONS(2715),
    [sym_primitive_type] = ACTIONS(2715),
    [anon_sym_enum] = ACTIONS(2715),
    [anon_sym_class] = ACTIONS(2715),
    [anon_sym_struct] = ACTIONS(2715),
    [anon_sym_union] = ACTIONS(2715),
    [anon_sym_if] = ACTIONS(2715),
    [anon_sym_else] = ACTIONS(2715),
    [anon_sym_switch] = ACTIONS(2715),
    [anon_sym_case] = ACTIONS(2715),
    [anon_sym_default] = ACTIONS(2715),
    [anon_sym_while] = ACTIONS(2715),
    [anon_sym_do] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2715),
    [anon_sym_return] = ACTIONS(2715),
    [anon_sym_break] = ACTIONS(2715),
    [anon_sym_continue] = ACTIONS(2715),
    [anon_sym_goto] = ACTIONS(2715),
    [anon_sym___try] = ACTIONS(2715),
    [anon_sym___leave] = ACTIONS(2715),
    [anon_sym_not] = ACTIONS(2715),
    [anon_sym_compl] = ACTIONS(2715),
    [anon_sym_DASH_DASH] = ACTIONS(2717),
    [anon_sym_PLUS_PLUS] = ACTIONS(2717),
    [anon_sym_sizeof] = ACTIONS(2715),
    [anon_sym___alignof__] = ACTIONS(2715),
    [anon_sym___alignof] = ACTIONS(2715),
    [anon_sym__alignof] = ACTIONS(2715),
    [anon_sym_alignof] = ACTIONS(2715),
    [anon_sym__Alignof] = ACTIONS(2715),
    [anon_sym_offsetof] = ACTIONS(2715),
    [anon_sym__Generic] = ACTIONS(2715),
    [anon_sym_asm] = ACTIONS(2715),
    [anon_sym___asm__] = ACTIONS(2715),
    [anon_sym___asm] = ACTIONS(2715),
    [sym_number_literal] = ACTIONS(2717),
    [anon_sym_L_SQUOTE] = ACTIONS(2717),
    [anon_sym_u_SQUOTE] = ACTIONS(2717),
    [anon_sym_U_SQUOTE] = ACTIONS(2717),
    [anon_sym_u8_SQUOTE] = ACTIONS(2717),
    [anon_sym_SQUOTE] = ACTIONS(2717),
    [anon_sym_L_DQUOTE] = ACTIONS(2717),
    [anon_sym_u_DQUOTE] = ACTIONS(2717),
    [anon_sym_U_DQUOTE] = ACTIONS(2717),
    [anon_sym_u8_DQUOTE] = ACTIONS(2717),
    [anon_sym_DQUOTE] = ACTIONS(2717),
    [sym_true] = ACTIONS(2715),
    [sym_false] = ACTIONS(2715),
    [anon_sym_NULL] = ACTIONS(2715),
    [anon_sym_nullptr] = ACTIONS(2715),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2715),
    [anon_sym_decltype] = ACTIONS(2715),
    [anon_sym_explicit] = ACTIONS(2715),
    [anon_sym_typename] = ACTIONS(2715),
    [anon_sym_template] = ACTIONS(2715),
    [anon_sym_operator] = ACTIONS(2715),
    [anon_sym_try] = ACTIONS(2715),
    [anon_sym_delete] = ACTIONS(2715),
    [anon_sym_throw] = ACTIONS(2715),
    [anon_sym_namespace] = ACTIONS(2715),
    [anon_sym_static_assert] = ACTIONS(2715),
    [anon_sym_concept] = ACTIONS(2715),
    [anon_sym_co_return] = ACTIONS(2715),
    [anon_sym_co_yield] = ACTIONS(2715),
    [anon_sym_R_DQUOTE] = ACTIONS(2717),
    [anon_sym_LR_DQUOTE] = ACTIONS(2717),
    [anon_sym_uR_DQUOTE] = ACTIONS(2717),
    [anon_sym_UR_DQUOTE] = ACTIONS(2717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2717),
    [anon_sym_co_await] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2715),
    [anon_sym_requires] = ACTIONS(2715),
    [sym_this] = ACTIONS(2715),
  },
  [553] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [anon_sym___asm] = ACTIONS(2735),
    [sym_number_literal] = ACTIONS(2737),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [554] = {
    [sym_identifier] = ACTIONS(2647),
    [aux_sym_preproc_include_token1] = ACTIONS(2647),
    [aux_sym_preproc_def_token1] = ACTIONS(2647),
    [aux_sym_preproc_if_token1] = ACTIONS(2647),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2647),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2647),
    [sym_preproc_directive] = ACTIONS(2647),
    [anon_sym_LPAREN2] = ACTIONS(2649),
    [anon_sym_BANG] = ACTIONS(2649),
    [anon_sym_TILDE] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2649),
    [anon_sym_AMP_AMP] = ACTIONS(2649),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_SEMI] = ACTIONS(2649),
    [anon_sym___extension__] = ACTIONS(2647),
    [anon_sym_typedef] = ACTIONS(2647),
    [anon_sym_virtual] = ACTIONS(2647),
    [anon_sym_extern] = ACTIONS(2647),
    [anon_sym___attribute__] = ACTIONS(2647),
    [anon_sym___attribute] = ACTIONS(2647),
    [anon_sym_using] = ACTIONS(2647),
    [anon_sym_COLON_COLON] = ACTIONS(2649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2649),
    [anon_sym___declspec] = ACTIONS(2647),
    [anon_sym___based] = ACTIONS(2647),
    [anon_sym___cdecl] = ACTIONS(2647),
    [anon_sym___clrcall] = ACTIONS(2647),
    [anon_sym___stdcall] = ACTIONS(2647),
    [anon_sym___fastcall] = ACTIONS(2647),
    [anon_sym___thiscall] = ACTIONS(2647),
    [anon_sym___vectorcall] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2649),
    [anon_sym_RBRACE] = ACTIONS(2649),
    [anon_sym_signed] = ACTIONS(2647),
    [anon_sym_unsigned] = ACTIONS(2647),
    [anon_sym_long] = ACTIONS(2647),
    [anon_sym_short] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2647),
    [anon_sym_static] = ACTIONS(2647),
    [anon_sym_register] = ACTIONS(2647),
    [anon_sym_inline] = ACTIONS(2647),
    [anon_sym___inline] = ACTIONS(2647),
    [anon_sym___inline__] = ACTIONS(2647),
    [anon_sym___forceinline] = ACTIONS(2647),
    [anon_sym_thread_local] = ACTIONS(2647),
    [anon_sym___thread] = ACTIONS(2647),
    [anon_sym_const] = ACTIONS(2647),
    [anon_sym_constexpr] = ACTIONS(2647),
    [anon_sym_volatile] = ACTIONS(2647),
    [anon_sym_restrict] = ACTIONS(2647),
    [anon_sym___restrict__] = ACTIONS(2647),
    [anon_sym__Atomic] = ACTIONS(2647),
    [anon_sym__Noreturn] = ACTIONS(2647),
    [anon_sym_noreturn] = ACTIONS(2647),
    [anon_sym__Nonnull] = ACTIONS(2647),
    [anon_sym_mutable] = ACTIONS(2647),
    [anon_sym_constinit] = ACTIONS(2647),
    [anon_sym_consteval] = ACTIONS(2647),
    [anon_sym_alignas] = ACTIONS(2647),
    [anon_sym__Alignas] = ACTIONS(2647),
    [sym_primitive_type] = ACTIONS(2647),
    [anon_sym_enum] = ACTIONS(2647),
    [anon_sym_class] = ACTIONS(2647),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_union] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_else] = ACTIONS(2647),
    [anon_sym_switch] = ACTIONS(2647),
    [anon_sym_case] = ACTIONS(2647),
    [anon_sym_default] = ACTIONS(2647),
    [anon_sym_while] = ACTIONS(2647),
    [anon_sym_do] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_return] = ACTIONS(2647),
    [anon_sym_break] = ACTIONS(2647),
    [anon_sym_continue] = ACTIONS(2647),
    [anon_sym_goto] = ACTIONS(2647),
    [anon_sym___try] = ACTIONS(2647),
    [anon_sym___leave] = ACTIONS(2647),
    [anon_sym_not] = ACTIONS(2647),
    [anon_sym_compl] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2649),
    [anon_sym_PLUS_PLUS] = ACTIONS(2649),
    [anon_sym_sizeof] = ACTIONS(2647),
    [anon_sym___alignof__] = ACTIONS(2647),
    [anon_sym___alignof] = ACTIONS(2647),
    [anon_sym__alignof] = ACTIONS(2647),
    [anon_sym_alignof] = ACTIONS(2647),
    [anon_sym__Alignof] = ACTIONS(2647),
    [anon_sym_offsetof] = ACTIONS(2647),
    [anon_sym__Generic] = ACTIONS(2647),
    [anon_sym_asm] = ACTIONS(2647),
    [anon_sym___asm__] = ACTIONS(2647),
    [anon_sym___asm] = ACTIONS(2647),
    [sym_number_literal] = ACTIONS(2649),
    [anon_sym_L_SQUOTE] = ACTIONS(2649),
    [anon_sym_u_SQUOTE] = ACTIONS(2649),
    [anon_sym_U_SQUOTE] = ACTIONS(2649),
    [anon_sym_u8_SQUOTE] = ACTIONS(2649),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_L_DQUOTE] = ACTIONS(2649),
    [anon_sym_u_DQUOTE] = ACTIONS(2649),
    [anon_sym_U_DQUOTE] = ACTIONS(2649),
    [anon_sym_u8_DQUOTE] = ACTIONS(2649),
    [anon_sym_DQUOTE] = ACTIONS(2649),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [anon_sym_NULL] = ACTIONS(2647),
    [anon_sym_nullptr] = ACTIONS(2647),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2647),
    [anon_sym_decltype] = ACTIONS(2647),
    [anon_sym_explicit] = ACTIONS(2647),
    [anon_sym_typename] = ACTIONS(2647),
    [anon_sym_template] = ACTIONS(2647),
    [anon_sym_operator] = ACTIONS(2647),
    [anon_sym_try] = ACTIONS(2647),
    [anon_sym_delete] = ACTIONS(2647),
    [anon_sym_throw] = ACTIONS(2647),
    [anon_sym_namespace] = ACTIONS(2647),
    [anon_sym_static_assert] = ACTIONS(2647),
    [anon_sym_concept] = ACTIONS(2647),
    [anon_sym_co_return] = ACTIONS(2647),
    [anon_sym_co_yield] = ACTIONS(2647),
    [anon_sym_R_DQUOTE] = ACTIONS(2649),
    [anon_sym_LR_DQUOTE] = ACTIONS(2649),
    [anon_sym_uR_DQUOTE] = ACTIONS(2649),
    [anon_sym_UR_DQUOTE] = ACTIONS(2649),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2649),
    [anon_sym_co_await] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(2647),
    [anon_sym_requires] = ACTIONS(2647),
    [sym_this] = ACTIONS(2647),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(3429),
    [sym_identifier] = ACTIONS(3431),
    [aux_sym_preproc_include_token1] = ACTIONS(3431),
    [aux_sym_preproc_def_token1] = ACTIONS(3431),
    [aux_sym_preproc_if_token1] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3431),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3431),
    [sym_preproc_directive] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym___extension__] = ACTIONS(3431),
    [anon_sym_typedef] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym___attribute__] = ACTIONS(3431),
    [anon_sym___attribute] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3429),
    [anon_sym___declspec] = ACTIONS(3431),
    [anon_sym___based] = ACTIONS(3431),
    [anon_sym___cdecl] = ACTIONS(3431),
    [anon_sym___clrcall] = ACTIONS(3431),
    [anon_sym___stdcall] = ACTIONS(3431),
    [anon_sym___fastcall] = ACTIONS(3431),
    [anon_sym___thiscall] = ACTIONS(3431),
    [anon_sym___vectorcall] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_signed] = ACTIONS(3431),
    [anon_sym_unsigned] = ACTIONS(3431),
    [anon_sym_long] = ACTIONS(3431),
    [anon_sym_short] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_register] = ACTIONS(3431),
    [anon_sym_inline] = ACTIONS(3431),
    [anon_sym___inline] = ACTIONS(3431),
    [anon_sym___inline__] = ACTIONS(3431),
    [anon_sym___forceinline] = ACTIONS(3431),
    [anon_sym_thread_local] = ACTIONS(3431),
    [anon_sym___thread] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_constexpr] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_restrict] = ACTIONS(3431),
    [anon_sym___restrict__] = ACTIONS(3431),
    [anon_sym__Atomic] = ACTIONS(3431),
    [anon_sym__Noreturn] = ACTIONS(3431),
    [anon_sym_noreturn] = ACTIONS(3431),
    [anon_sym__Nonnull] = ACTIONS(3431),
    [anon_sym_mutable] = ACTIONS(3431),
    [anon_sym_constinit] = ACTIONS(3431),
    [anon_sym_consteval] = ACTIONS(3431),
    [anon_sym_alignas] = ACTIONS(3431),
    [anon_sym__Alignas] = ACTIONS(3431),
    [sym_primitive_type] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_union] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_case] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_goto] = ACTIONS(3431),
    [anon_sym_not] = ACTIONS(3431),
    [anon_sym_compl] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_sizeof] = ACTIONS(3431),
    [anon_sym___alignof__] = ACTIONS(3431),
    [anon_sym___alignof] = ACTIONS(3431),
    [anon_sym__alignof] = ACTIONS(3431),
    [anon_sym_alignof] = ACTIONS(3431),
    [anon_sym__Alignof] = ACTIONS(3431),
    [anon_sym_offsetof] = ACTIONS(3431),
    [anon_sym__Generic] = ACTIONS(3431),
    [anon_sym_asm] = ACTIONS(3431),
    [anon_sym___asm__] = ACTIONS(3431),
    [anon_sym___asm] = ACTIONS(3431),
    [sym_number_literal] = ACTIONS(3429),
    [anon_sym_L_SQUOTE] = ACTIONS(3429),
    [anon_sym_u_SQUOTE] = ACTIONS(3429),
    [anon_sym_U_SQUOTE] = ACTIONS(3429),
    [anon_sym_u8_SQUOTE] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_L_DQUOTE] = ACTIONS(3429),
    [anon_sym_u_DQUOTE] = ACTIONS(3429),
    [anon_sym_U_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [anon_sym_NULL] = ACTIONS(3431),
    [anon_sym_nullptr] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3431),
    [anon_sym_decltype] = ACTIONS(3431),
    [anon_sym_explicit] = ACTIONS(3431),
    [anon_sym_typename] = ACTIONS(3431),
    [anon_sym_export] = ACTIONS(3431),
    [anon_sym_module] = ACTIONS(3431),
    [anon_sym_import] = ACTIONS(3431),
    [anon_sym_template] = ACTIONS(3431),
    [anon_sym_operator] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_delete] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_static_assert] = ACTIONS(3431),
    [anon_sym_concept] = ACTIONS(3431),
    [anon_sym_co_return] = ACTIONS(3431),
    [anon_sym_co_yield] = ACTIONS(3431),
    [anon_sym_R_DQUOTE] = ACTIONS(3429),
    [anon_sym_LR_DQUOTE] = ACTIONS(3429),
    [anon_sym_uR_DQUOTE] = ACTIONS(3429),
    [anon_sym_UR_DQUOTE] = ACTIONS(3429),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3429),
    [anon_sym_co_await] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_requires] = ACTIONS(3431),
    [sym_this] = ACTIONS(3431),
  },
  [556] = {
    [sym_identifier] = ACTIONS(2673),
    [aux_sym_preproc_include_token1] = ACTIONS(2673),
    [aux_sym_preproc_def_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token2] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2673),
    [sym_preproc_directive] = ACTIONS(2673),
    [anon_sym_LPAREN2] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_AMP_AMP] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym___extension__] = ACTIONS(2673),
    [anon_sym_typedef] = ACTIONS(2673),
    [anon_sym_virtual] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym___attribute__] = ACTIONS(2673),
    [anon_sym___attribute] = ACTIONS(2673),
    [anon_sym_using] = ACTIONS(2673),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2675),
    [anon_sym___declspec] = ACTIONS(2673),
    [anon_sym___based] = ACTIONS(2673),
    [anon_sym___cdecl] = ACTIONS(2673),
    [anon_sym___clrcall] = ACTIONS(2673),
    [anon_sym___stdcall] = ACTIONS(2673),
    [anon_sym___fastcall] = ACTIONS(2673),
    [anon_sym___thiscall] = ACTIONS(2673),
    [anon_sym___vectorcall] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_signed] = ACTIONS(2673),
    [anon_sym_unsigned] = ACTIONS(2673),
    [anon_sym_long] = ACTIONS(2673),
    [anon_sym_short] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_register] = ACTIONS(2673),
    [anon_sym_inline] = ACTIONS(2673),
    [anon_sym___inline] = ACTIONS(2673),
    [anon_sym___inline__] = ACTIONS(2673),
    [anon_sym___forceinline] = ACTIONS(2673),
    [anon_sym_thread_local] = ACTIONS(2673),
    [anon_sym___thread] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_constexpr] = ACTIONS(2673),
    [anon_sym_volatile] = ACTIONS(2673),
    [anon_sym_restrict] = ACTIONS(2673),
    [anon_sym___restrict__] = ACTIONS(2673),
    [anon_sym__Atomic] = ACTIONS(2673),
    [anon_sym__Noreturn] = ACTIONS(2673),
    [anon_sym_noreturn] = ACTIONS(2673),
    [anon_sym__Nonnull] = ACTIONS(2673),
    [anon_sym_mutable] = ACTIONS(2673),
    [anon_sym_constinit] = ACTIONS(2673),
    [anon_sym_consteval] = ACTIONS(2673),
    [anon_sym_alignas] = ACTIONS(2673),
    [anon_sym__Alignas] = ACTIONS(2673),
    [sym_primitive_type] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_goto] = ACTIONS(2673),
    [anon_sym___try] = ACTIONS(2673),
    [anon_sym___leave] = ACTIONS(2673),
    [anon_sym_not] = ACTIONS(2673),
    [anon_sym_compl] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_sizeof] = ACTIONS(2673),
    [anon_sym___alignof__] = ACTIONS(2673),
    [anon_sym___alignof] = ACTIONS(2673),
    [anon_sym__alignof] = ACTIONS(2673),
    [anon_sym_alignof] = ACTIONS(2673),
    [anon_sym__Alignof] = ACTIONS(2673),
    [anon_sym_offsetof] = ACTIONS(2673),
    [anon_sym__Generic] = ACTIONS(2673),
    [anon_sym_asm] = ACTIONS(2673),
    [anon_sym___asm__] = ACTIONS(2673),
    [anon_sym___asm] = ACTIONS(2673),
    [sym_number_literal] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2675),
    [anon_sym_u_SQUOTE] = ACTIONS(2675),
    [anon_sym_U_SQUOTE] = ACTIONS(2675),
    [anon_sym_u8_SQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_L_DQUOTE] = ACTIONS(2675),
    [anon_sym_u_DQUOTE] = ACTIONS(2675),
    [anon_sym_U_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8_DQUOTE] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [anon_sym_NULL] = ACTIONS(2673),
    [anon_sym_nullptr] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2673),
    [anon_sym_decltype] = ACTIONS(2673),
    [anon_sym_explicit] = ACTIONS(2673),
    [anon_sym_typename] = ACTIONS(2673),
    [anon_sym_template] = ACTIONS(2673),
    [anon_sym_operator] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_static_assert] = ACTIONS(2673),
    [anon_sym_concept] = ACTIONS(2673),
    [anon_sym_co_return] = ACTIONS(2673),
    [anon_sym_co_yield] = ACTIONS(2673),
    [anon_sym_R_DQUOTE] = ACTIONS(2675),
    [anon_sym_LR_DQUOTE] = ACTIONS(2675),
    [anon_sym_uR_DQUOTE] = ACTIONS(2675),
    [anon_sym_UR_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2675),
    [anon_sym_co_await] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_requires] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(3433),
    [sym_identifier] = ACTIONS(3435),
    [aux_sym_preproc_include_token1] = ACTIONS(3435),
    [aux_sym_preproc_def_token1] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3435),
    [sym_preproc_directive] = ACTIONS(3435),
    [anon_sym_LPAREN2] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_AMP_AMP] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym___extension__] = ACTIONS(3435),
    [anon_sym_typedef] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym___attribute__] = ACTIONS(3435),
    [anon_sym___attribute] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_COLON_COLON] = ACTIONS(3433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3433),
    [anon_sym___declspec] = ACTIONS(3435),
    [anon_sym___based] = ACTIONS(3435),
    [anon_sym___cdecl] = ACTIONS(3435),
    [anon_sym___clrcall] = ACTIONS(3435),
    [anon_sym___stdcall] = ACTIONS(3435),
    [anon_sym___fastcall] = ACTIONS(3435),
    [anon_sym___thiscall] = ACTIONS(3435),
    [anon_sym___vectorcall] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_signed] = ACTIONS(3435),
    [anon_sym_unsigned] = ACTIONS(3435),
    [anon_sym_long] = ACTIONS(3435),
    [anon_sym_short] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_register] = ACTIONS(3435),
    [anon_sym_inline] = ACTIONS(3435),
    [anon_sym___inline] = ACTIONS(3435),
    [anon_sym___inline__] = ACTIONS(3435),
    [anon_sym___forceinline] = ACTIONS(3435),
    [anon_sym_thread_local] = ACTIONS(3435),
    [anon_sym___thread] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_constexpr] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_restrict] = ACTIONS(3435),
    [anon_sym___restrict__] = ACTIONS(3435),
    [anon_sym__Atomic] = ACTIONS(3435),
    [anon_sym__Noreturn] = ACTIONS(3435),
    [anon_sym_noreturn] = ACTIONS(3435),
    [anon_sym__Nonnull] = ACTIONS(3435),
    [anon_sym_mutable] = ACTIONS(3435),
    [anon_sym_constinit] = ACTIONS(3435),
    [anon_sym_consteval] = ACTIONS(3435),
    [anon_sym_alignas] = ACTIONS(3435),
    [anon_sym__Alignas] = ACTIONS(3435),
    [sym_primitive_type] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_union] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_goto] = ACTIONS(3435),
    [anon_sym_not] = ACTIONS(3435),
    [anon_sym_compl] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_sizeof] = ACTIONS(3435),
    [anon_sym___alignof__] = ACTIONS(3435),
    [anon_sym___alignof] = ACTIONS(3435),
    [anon_sym__alignof] = ACTIONS(3435),
    [anon_sym_alignof] = ACTIONS(3435),
    [anon_sym__Alignof] = ACTIONS(3435),
    [anon_sym_offsetof] = ACTIONS(3435),
    [anon_sym__Generic] = ACTIONS(3435),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [anon_sym___asm] = ACTIONS(3435),
    [sym_number_literal] = ACTIONS(3433),
    [anon_sym_L_SQUOTE] = ACTIONS(3433),
    [anon_sym_u_SQUOTE] = ACTIONS(3433),
    [anon_sym_U_SQUOTE] = ACTIONS(3433),
    [anon_sym_u8_SQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_L_DQUOTE] = ACTIONS(3433),
    [anon_sym_u_DQUOTE] = ACTIONS(3433),
    [anon_sym_U_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8_DQUOTE] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [anon_sym_NULL] = ACTIONS(3435),
    [anon_sym_nullptr] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3435),
    [anon_sym_decltype] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_typename] = ACTIONS(3435),
    [anon_sym_export] = ACTIONS(3435),
    [anon_sym_module] = ACTIONS(3435),
    [anon_sym_import] = ACTIONS(3435),
    [anon_sym_template] = ACTIONS(3435),
    [anon_sym_operator] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_static_assert] = ACTIONS(3435),
    [anon_sym_concept] = ACTIONS(3435),
    [anon_sym_co_return] = ACTIONS(3435),
    [anon_sym_co_yield] = ACTIONS(3435),
    [anon_sym_R_DQUOTE] = ACTIONS(3433),
    [anon_sym_LR_DQUOTE] = ACTIONS(3433),
    [anon_sym_uR_DQUOTE] = ACTIONS(3433),
    [anon_sym_UR_DQUOTE] = ACTIONS(3433),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3433),
    [anon_sym_co_await] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_requires] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
  },
  [558] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [anon_sym___asm] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [559] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_include_token1] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token2] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym___cdecl] = ACTIONS(1940),
    [anon_sym___clrcall] = ACTIONS(1940),
    [anon_sym___stdcall] = ACTIONS(1940),
    [anon_sym___fastcall] = ACTIONS(1940),
    [anon_sym___thiscall] = ACTIONS(1940),
    [anon_sym___vectorcall] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1940),
    [anon_sym___try] = ACTIONS(1940),
    [anon_sym___leave] = ACTIONS(1940),
    [anon_sym_not] = ACTIONS(1940),
    [anon_sym_compl] = ACTIONS(1940),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_sizeof] = ACTIONS(1940),
    [anon_sym___alignof__] = ACTIONS(1940),
    [anon_sym___alignof] = ACTIONS(1940),
    [anon_sym__alignof] = ACTIONS(1940),
    [anon_sym_alignof] = ACTIONS(1940),
    [anon_sym__Alignof] = ACTIONS(1940),
    [anon_sym_offsetof] = ACTIONS(1940),
    [anon_sym__Generic] = ACTIONS(1940),
    [anon_sym_asm] = ACTIONS(1940),
    [anon_sym___asm__] = ACTIONS(1940),
    [anon_sym___asm] = ACTIONS(1940),
    [sym_number_literal] = ACTIONS(1938),
    [anon_sym_L_SQUOTE] = ACTIONS(1938),
    [anon_sym_u_SQUOTE] = ACTIONS(1938),
    [anon_sym_U_SQUOTE] = ACTIONS(1938),
    [anon_sym_u8_SQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_L_DQUOTE] = ACTIONS(1938),
    [anon_sym_u_DQUOTE] = ACTIONS(1938),
    [anon_sym_U_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8_DQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [anon_sym_NULL] = ACTIONS(1940),
    [anon_sym_nullptr] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_concept] = ACTIONS(1940),
    [anon_sym_co_return] = ACTIONS(1940),
    [anon_sym_co_yield] = ACTIONS(1940),
    [anon_sym_R_DQUOTE] = ACTIONS(1938),
    [anon_sym_LR_DQUOTE] = ACTIONS(1938),
    [anon_sym_uR_DQUOTE] = ACTIONS(1938),
    [anon_sym_UR_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1938),
    [anon_sym_co_await] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_requires] = ACTIONS(1940),
    [sym_this] = ACTIONS(1940),
  },
  [560] = {
    [sym_identifier] = ACTIONS(2707),
    [aux_sym_preproc_include_token1] = ACTIONS(2707),
    [aux_sym_preproc_def_token1] = ACTIONS(2707),
    [aux_sym_preproc_if_token1] = ACTIONS(2707),
    [aux_sym_preproc_if_token2] = ACTIONS(2707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2707),
    [sym_preproc_directive] = ACTIONS(2707),
    [anon_sym_LPAREN2] = ACTIONS(2709),
    [anon_sym_BANG] = ACTIONS(2709),
    [anon_sym_TILDE] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_PLUS] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_AMP_AMP] = ACTIONS(2709),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2709),
    [anon_sym___extension__] = ACTIONS(2707),
    [anon_sym_typedef] = ACTIONS(2707),
    [anon_sym_virtual] = ACTIONS(2707),
    [anon_sym_extern] = ACTIONS(2707),
    [anon_sym___attribute__] = ACTIONS(2707),
    [anon_sym___attribute] = ACTIONS(2707),
    [anon_sym_using] = ACTIONS(2707),
    [anon_sym_COLON_COLON] = ACTIONS(2709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2709),
    [anon_sym___declspec] = ACTIONS(2707),
    [anon_sym___based] = ACTIONS(2707),
    [anon_sym___cdecl] = ACTIONS(2707),
    [anon_sym___clrcall] = ACTIONS(2707),
    [anon_sym___stdcall] = ACTIONS(2707),
    [anon_sym___fastcall] = ACTIONS(2707),
    [anon_sym___thiscall] = ACTIONS(2707),
    [anon_sym___vectorcall] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2709),
    [anon_sym_signed] = ACTIONS(2707),
    [anon_sym_unsigned] = ACTIONS(2707),
    [anon_sym_long] = ACTIONS(2707),
    [anon_sym_short] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_static] = ACTIONS(2707),
    [anon_sym_register] = ACTIONS(2707),
    [anon_sym_inline] = ACTIONS(2707),
    [anon_sym___inline] = ACTIONS(2707),
    [anon_sym___inline__] = ACTIONS(2707),
    [anon_sym___forceinline] = ACTIONS(2707),
    [anon_sym_thread_local] = ACTIONS(2707),
    [anon_sym___thread] = ACTIONS(2707),
    [anon_sym_const] = ACTIONS(2707),
    [anon_sym_constexpr] = ACTIONS(2707),
    [anon_sym_volatile] = ACTIONS(2707),
    [anon_sym_restrict] = ACTIONS(2707),
    [anon_sym___restrict__] = ACTIONS(2707),
    [anon_sym__Atomic] = ACTIONS(2707),
    [anon_sym__Noreturn] = ACTIONS(2707),
    [anon_sym_noreturn] = ACTIONS(2707),
    [anon_sym__Nonnull] = ACTIONS(2707),
    [anon_sym_mutable] = ACTIONS(2707),
    [anon_sym_constinit] = ACTIONS(2707),
    [anon_sym_consteval] = ACTIONS(2707),
    [anon_sym_alignas] = ACTIONS(2707),
    [anon_sym__Alignas] = ACTIONS(2707),
    [sym_primitive_type] = ACTIONS(2707),
    [anon_sym_enum] = ACTIONS(2707),
    [anon_sym_class] = ACTIONS(2707),
    [anon_sym_struct] = ACTIONS(2707),
    [anon_sym_union] = ACTIONS(2707),
    [anon_sym_if] = ACTIONS(2707),
    [anon_sym_else] = ACTIONS(2707),
    [anon_sym_switch] = ACTIONS(2707),
    [anon_sym_case] = ACTIONS(2707),
    [anon_sym_default] = ACTIONS(2707),
    [anon_sym_while] = ACTIONS(2707),
    [anon_sym_do] = ACTIONS(2707),
    [anon_sym_for] = ACTIONS(2707),
    [anon_sym_return] = ACTIONS(2707),
    [anon_sym_break] = ACTIONS(2707),
    [anon_sym_continue] = ACTIONS(2707),
    [anon_sym_goto] = ACTIONS(2707),
    [anon_sym___try] = ACTIONS(2707),
    [anon_sym___leave] = ACTIONS(2707),
    [anon_sym_not] = ACTIONS(2707),
    [anon_sym_compl] = ACTIONS(2707),
    [anon_sym_DASH_DASH] = ACTIONS(2709),
    [anon_sym_PLUS_PLUS] = ACTIONS(2709),
    [anon_sym_sizeof] = ACTIONS(2707),
    [anon_sym___alignof__] = ACTIONS(2707),
    [anon_sym___alignof] = ACTIONS(2707),
    [anon_sym__alignof] = ACTIONS(2707),
    [anon_sym_alignof] = ACTIONS(2707),
    [anon_sym__Alignof] = ACTIONS(2707),
    [anon_sym_offsetof] = ACTIONS(2707),
    [anon_sym__Generic] = ACTIONS(2707),
    [anon_sym_asm] = ACTIONS(2707),
    [anon_sym___asm__] = ACTIONS(2707),
    [anon_sym___asm] = ACTIONS(2707),
    [sym_number_literal] = ACTIONS(2709),
    [anon_sym_L_SQUOTE] = ACTIONS(2709),
    [anon_sym_u_SQUOTE] = ACTIONS(2709),
    [anon_sym_U_SQUOTE] = ACTIONS(2709),
    [anon_sym_u8_SQUOTE] = ACTIONS(2709),
    [anon_sym_SQUOTE] = ACTIONS(2709),
    [anon_sym_L_DQUOTE] = ACTIONS(2709),
    [anon_sym_u_DQUOTE] = ACTIONS(2709),
    [anon_sym_U_DQUOTE] = ACTIONS(2709),
    [anon_sym_u8_DQUOTE] = ACTIONS(2709),
    [anon_sym_DQUOTE] = ACTIONS(2709),
    [sym_true] = ACTIONS(2707),
    [sym_false] = ACTIONS(2707),
    [anon_sym_NULL] = ACTIONS(2707),
    [anon_sym_nullptr] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2707),
    [anon_sym_decltype] = ACTIONS(2707),
    [anon_sym_explicit] = ACTIONS(2707),
    [anon_sym_typename] = ACTIONS(2707),
    [anon_sym_template] = ACTIONS(2707),
    [anon_sym_operator] = ACTIONS(2707),
    [anon_sym_try] = ACTIONS(2707),
    [anon_sym_delete] = ACTIONS(2707),
    [anon_sym_throw] = ACTIONS(2707),
    [anon_sym_namespace] = ACTIONS(2707),
    [anon_sym_static_assert] = ACTIONS(2707),
    [anon_sym_concept] = ACTIONS(2707),
    [anon_sym_co_return] = ACTIONS(2707),
    [anon_sym_co_yield] = ACTIONS(2707),
    [anon_sym_R_DQUOTE] = ACTIONS(2709),
    [anon_sym_LR_DQUOTE] = ACTIONS(2709),
    [anon_sym_uR_DQUOTE] = ACTIONS(2709),
    [anon_sym_UR_DQUOTE] = ACTIONS(2709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2709),
    [anon_sym_co_await] = ACTIONS(2707),
    [anon_sym_new] = ACTIONS(2707),
    [anon_sym_requires] = ACTIONS(2707),
    [sym_this] = ACTIONS(2707),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(3437),
    [sym_identifier] = ACTIONS(3439),
    [aux_sym_preproc_include_token1] = ACTIONS(3439),
    [aux_sym_preproc_def_token1] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3439),
    [sym_preproc_directive] = ACTIONS(3439),
    [anon_sym_LPAREN2] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym___extension__] = ACTIONS(3439),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym___attribute__] = ACTIONS(3439),
    [anon_sym___attribute] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(3437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3437),
    [anon_sym___declspec] = ACTIONS(3439),
    [anon_sym___based] = ACTIONS(3439),
    [anon_sym___cdecl] = ACTIONS(3439),
    [anon_sym___clrcall] = ACTIONS(3439),
    [anon_sym___stdcall] = ACTIONS(3439),
    [anon_sym___fastcall] = ACTIONS(3439),
    [anon_sym___thiscall] = ACTIONS(3439),
    [anon_sym___vectorcall] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_signed] = ACTIONS(3439),
    [anon_sym_unsigned] = ACTIONS(3439),
    [anon_sym_long] = ACTIONS(3439),
    [anon_sym_short] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_register] = ACTIONS(3439),
    [anon_sym_inline] = ACTIONS(3439),
    [anon_sym___inline] = ACTIONS(3439),
    [anon_sym___inline__] = ACTIONS(3439),
    [anon_sym___forceinline] = ACTIONS(3439),
    [anon_sym_thread_local] = ACTIONS(3439),
    [anon_sym___thread] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_constexpr] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_restrict] = ACTIONS(3439),
    [anon_sym___restrict__] = ACTIONS(3439),
    [anon_sym__Atomic] = ACTIONS(3439),
    [anon_sym__Noreturn] = ACTIONS(3439),
    [anon_sym_noreturn] = ACTIONS(3439),
    [anon_sym__Nonnull] = ACTIONS(3439),
    [anon_sym_mutable] = ACTIONS(3439),
    [anon_sym_constinit] = ACTIONS(3439),
    [anon_sym_consteval] = ACTIONS(3439),
    [anon_sym_alignas] = ACTIONS(3439),
    [anon_sym__Alignas] = ACTIONS(3439),
    [sym_primitive_type] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_union] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym_not] = ACTIONS(3439),
    [anon_sym_compl] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym___alignof__] = ACTIONS(3439),
    [anon_sym___alignof] = ACTIONS(3439),
    [anon_sym__alignof] = ACTIONS(3439),
    [anon_sym_alignof] = ACTIONS(3439),
    [anon_sym__Alignof] = ACTIONS(3439),
    [anon_sym_offsetof] = ACTIONS(3439),
    [anon_sym__Generic] = ACTIONS(3439),
    [anon_sym_asm] = ACTIONS(3439),
    [anon_sym___asm__] = ACTIONS(3439),
    [anon_sym___asm] = ACTIONS(3439),
    [sym_number_literal] = ACTIONS(3437),
    [anon_sym_L_SQUOTE] = ACTIONS(3437),
    [anon_sym_u_SQUOTE] = ACTIONS(3437),
    [anon_sym_U_SQUOTE] = ACTIONS(3437),
    [anon_sym_u8_SQUOTE] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [anon_sym_L_DQUOTE] = ACTIONS(3437),
    [anon_sym_u_DQUOTE] = ACTIONS(3437),
    [anon_sym_U_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8_DQUOTE] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [anon_sym_NULL] = ACTIONS(3439),
    [anon_sym_nullptr] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3439),
    [anon_sym_decltype] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_typename] = ACTIONS(3439),
    [anon_sym_export] = ACTIONS(3439),
    [anon_sym_module] = ACTIONS(3439),
    [anon_sym_import] = ACTIONS(3439),
    [anon_sym_template] = ACTIONS(3439),
    [anon_sym_operator] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_static_assert] = ACTIONS(3439),
    [anon_sym_concept] = ACTIONS(3439),
    [anon_sym_co_return] = ACTIONS(3439),
    [anon_sym_co_yield] = ACTIONS(3439),
    [anon_sym_R_DQUOTE] = ACTIONS(3437),
    [anon_sym_LR_DQUOTE] = ACTIONS(3437),
    [anon_sym_uR_DQUOTE] = ACTIONS(3437),
    [anon_sym_UR_DQUOTE] = ACTIONS(3437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3437),
    [anon_sym_co_await] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_requires] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(2913),
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_include_token1] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym___cdecl] = ACTIONS(2911),
    [anon_sym___clrcall] = ACTIONS(2911),
    [anon_sym___stdcall] = ACTIONS(2911),
    [anon_sym___fastcall] = ACTIONS(2911),
    [anon_sym___thiscall] = ACTIONS(2911),
    [anon_sym___vectorcall] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2911),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2911),
    [anon_sym_return] = ACTIONS(2911),
    [anon_sym_break] = ACTIONS(2911),
    [anon_sym_continue] = ACTIONS(2911),
    [anon_sym_goto] = ACTIONS(2911),
    [anon_sym_not] = ACTIONS(2911),
    [anon_sym_compl] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_sizeof] = ACTIONS(2911),
    [anon_sym___alignof__] = ACTIONS(2911),
    [anon_sym___alignof] = ACTIONS(2911),
    [anon_sym__alignof] = ACTIONS(2911),
    [anon_sym_alignof] = ACTIONS(2911),
    [anon_sym__Alignof] = ACTIONS(2911),
    [anon_sym_offsetof] = ACTIONS(2911),
    [anon_sym__Generic] = ACTIONS(2911),
    [anon_sym_asm] = ACTIONS(2911),
    [anon_sym___asm__] = ACTIONS(2911),
    [anon_sym___asm] = ACTIONS(2911),
    [sym_number_literal] = ACTIONS(2913),
    [anon_sym_L_SQUOTE] = ACTIONS(2913),
    [anon_sym_u_SQUOTE] = ACTIONS(2913),
    [anon_sym_U_SQUOTE] = ACTIONS(2913),
    [anon_sym_u8_SQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_L_DQUOTE] = ACTIONS(2913),
    [anon_sym_u_DQUOTE] = ACTIONS(2913),
    [anon_sym_U_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8_DQUOTE] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [sym_true] = ACTIONS(2911),
    [sym_false] = ACTIONS(2911),
    [anon_sym_NULL] = ACTIONS(2911),
    [anon_sym_nullptr] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_export] = ACTIONS(2911),
    [anon_sym_module] = ACTIONS(2911),
    [anon_sym_import] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2911),
    [anon_sym_delete] = ACTIONS(2911),
    [anon_sym_throw] = ACTIONS(2911),
    [anon_sym_namespace] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
    [anon_sym_concept] = ACTIONS(2911),
    [anon_sym_co_return] = ACTIONS(2911),
    [anon_sym_co_yield] = ACTIONS(2911),
    [anon_sym_R_DQUOTE] = ACTIONS(2913),
    [anon_sym_LR_DQUOTE] = ACTIONS(2913),
    [anon_sym_uR_DQUOTE] = ACTIONS(2913),
    [anon_sym_UR_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2913),
    [anon_sym_co_await] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2911),
    [anon_sym_requires] = ACTIONS(2911),
    [sym_this] = ACTIONS(2911),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(3441),
    [sym_identifier] = ACTIONS(3443),
    [aux_sym_preproc_include_token1] = ACTIONS(3443),
    [aux_sym_preproc_def_token1] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3443),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3443),
    [sym_preproc_directive] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym___extension__] = ACTIONS(3443),
    [anon_sym_typedef] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym___attribute__] = ACTIONS(3443),
    [anon_sym___attribute] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3441),
    [anon_sym___declspec] = ACTIONS(3443),
    [anon_sym___based] = ACTIONS(3443),
    [anon_sym___cdecl] = ACTIONS(3443),
    [anon_sym___clrcall] = ACTIONS(3443),
    [anon_sym___stdcall] = ACTIONS(3443),
    [anon_sym___fastcall] = ACTIONS(3443),
    [anon_sym___thiscall] = ACTIONS(3443),
    [anon_sym___vectorcall] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_signed] = ACTIONS(3443),
    [anon_sym_unsigned] = ACTIONS(3443),
    [anon_sym_long] = ACTIONS(3443),
    [anon_sym_short] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_register] = ACTIONS(3443),
    [anon_sym_inline] = ACTIONS(3443),
    [anon_sym___inline] = ACTIONS(3443),
    [anon_sym___inline__] = ACTIONS(3443),
    [anon_sym___forceinline] = ACTIONS(3443),
    [anon_sym_thread_local] = ACTIONS(3443),
    [anon_sym___thread] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_constexpr] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_restrict] = ACTIONS(3443),
    [anon_sym___restrict__] = ACTIONS(3443),
    [anon_sym__Atomic] = ACTIONS(3443),
    [anon_sym__Noreturn] = ACTIONS(3443),
    [anon_sym_noreturn] = ACTIONS(3443),
    [anon_sym__Nonnull] = ACTIONS(3443),
    [anon_sym_mutable] = ACTIONS(3443),
    [anon_sym_constinit] = ACTIONS(3443),
    [anon_sym_consteval] = ACTIONS(3443),
    [anon_sym_alignas] = ACTIONS(3443),
    [anon_sym__Alignas] = ACTIONS(3443),
    [sym_primitive_type] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_union] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym_not] = ACTIONS(3443),
    [anon_sym_compl] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym___alignof__] = ACTIONS(3443),
    [anon_sym___alignof] = ACTIONS(3443),
    [anon_sym__alignof] = ACTIONS(3443),
    [anon_sym_alignof] = ACTIONS(3443),
    [anon_sym__Alignof] = ACTIONS(3443),
    [anon_sym_offsetof] = ACTIONS(3443),
    [anon_sym__Generic] = ACTIONS(3443),
    [anon_sym_asm] = ACTIONS(3443),
    [anon_sym___asm__] = ACTIONS(3443),
    [anon_sym___asm] = ACTIONS(3443),
    [sym_number_literal] = ACTIONS(3441),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3441),
    [anon_sym_u_DQUOTE] = ACTIONS(3441),
    [anon_sym_U_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [anon_sym_NULL] = ACTIONS(3443),
    [anon_sym_nullptr] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3443),
    [anon_sym_decltype] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_typename] = ACTIONS(3443),
    [anon_sym_export] = ACTIONS(3443),
    [anon_sym_module] = ACTIONS(3443),
    [anon_sym_import] = ACTIONS(3443),
    [anon_sym_template] = ACTIONS(3443),
    [anon_sym_operator] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_static_assert] = ACTIONS(3443),
    [anon_sym_concept] = ACTIONS(3443),
    [anon_sym_co_return] = ACTIONS(3443),
    [anon_sym_co_yield] = ACTIONS(3443),
    [anon_sym_R_DQUOTE] = ACTIONS(3441),
    [anon_sym_LR_DQUOTE] = ACTIONS(3441),
    [anon_sym_uR_DQUOTE] = ACTIONS(3441),
    [anon_sym_UR_DQUOTE] = ACTIONS(3441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3441),
    [anon_sym_co_await] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_requires] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
  },
  [564] = {
    [sym_identifier] = ACTIONS(2707),
    [aux_sym_preproc_include_token1] = ACTIONS(2707),
    [aux_sym_preproc_def_token1] = ACTIONS(2707),
    [aux_sym_preproc_if_token1] = ACTIONS(2707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2707),
    [sym_preproc_directive] = ACTIONS(2707),
    [anon_sym_LPAREN2] = ACTIONS(2709),
    [anon_sym_BANG] = ACTIONS(2709),
    [anon_sym_TILDE] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_PLUS] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_AMP_AMP] = ACTIONS(2709),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2709),
    [anon_sym___extension__] = ACTIONS(2707),
    [anon_sym_typedef] = ACTIONS(2707),
    [anon_sym_virtual] = ACTIONS(2707),
    [anon_sym_extern] = ACTIONS(2707),
    [anon_sym___attribute__] = ACTIONS(2707),
    [anon_sym___attribute] = ACTIONS(2707),
    [anon_sym_using] = ACTIONS(2707),
    [anon_sym_COLON_COLON] = ACTIONS(2709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2709),
    [anon_sym___declspec] = ACTIONS(2707),
    [anon_sym___based] = ACTIONS(2707),
    [anon_sym___cdecl] = ACTIONS(2707),
    [anon_sym___clrcall] = ACTIONS(2707),
    [anon_sym___stdcall] = ACTIONS(2707),
    [anon_sym___fastcall] = ACTIONS(2707),
    [anon_sym___thiscall] = ACTIONS(2707),
    [anon_sym___vectorcall] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2709),
    [anon_sym_RBRACE] = ACTIONS(2709),
    [anon_sym_signed] = ACTIONS(2707),
    [anon_sym_unsigned] = ACTIONS(2707),
    [anon_sym_long] = ACTIONS(2707),
    [anon_sym_short] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_static] = ACTIONS(2707),
    [anon_sym_register] = ACTIONS(2707),
    [anon_sym_inline] = ACTIONS(2707),
    [anon_sym___inline] = ACTIONS(2707),
    [anon_sym___inline__] = ACTIONS(2707),
    [anon_sym___forceinline] = ACTIONS(2707),
    [anon_sym_thread_local] = ACTIONS(2707),
    [anon_sym___thread] = ACTIONS(2707),
    [anon_sym_const] = ACTIONS(2707),
    [anon_sym_constexpr] = ACTIONS(2707),
    [anon_sym_volatile] = ACTIONS(2707),
    [anon_sym_restrict] = ACTIONS(2707),
    [anon_sym___restrict__] = ACTIONS(2707),
    [anon_sym__Atomic] = ACTIONS(2707),
    [anon_sym__Noreturn] = ACTIONS(2707),
    [anon_sym_noreturn] = ACTIONS(2707),
    [anon_sym__Nonnull] = ACTIONS(2707),
    [anon_sym_mutable] = ACTIONS(2707),
    [anon_sym_constinit] = ACTIONS(2707),
    [anon_sym_consteval] = ACTIONS(2707),
    [anon_sym_alignas] = ACTIONS(2707),
    [anon_sym__Alignas] = ACTIONS(2707),
    [sym_primitive_type] = ACTIONS(2707),
    [anon_sym_enum] = ACTIONS(2707),
    [anon_sym_class] = ACTIONS(2707),
    [anon_sym_struct] = ACTIONS(2707),
    [anon_sym_union] = ACTIONS(2707),
    [anon_sym_if] = ACTIONS(2707),
    [anon_sym_else] = ACTIONS(2707),
    [anon_sym_switch] = ACTIONS(2707),
    [anon_sym_case] = ACTIONS(2707),
    [anon_sym_default] = ACTIONS(2707),
    [anon_sym_while] = ACTIONS(2707),
    [anon_sym_do] = ACTIONS(2707),
    [anon_sym_for] = ACTIONS(2707),
    [anon_sym_return] = ACTIONS(2707),
    [anon_sym_break] = ACTIONS(2707),
    [anon_sym_continue] = ACTIONS(2707),
    [anon_sym_goto] = ACTIONS(2707),
    [anon_sym___try] = ACTIONS(2707),
    [anon_sym___leave] = ACTIONS(2707),
    [anon_sym_not] = ACTIONS(2707),
    [anon_sym_compl] = ACTIONS(2707),
    [anon_sym_DASH_DASH] = ACTIONS(2709),
    [anon_sym_PLUS_PLUS] = ACTIONS(2709),
    [anon_sym_sizeof] = ACTIONS(2707),
    [anon_sym___alignof__] = ACTIONS(2707),
    [anon_sym___alignof] = ACTIONS(2707),
    [anon_sym__alignof] = ACTIONS(2707),
    [anon_sym_alignof] = ACTIONS(2707),
    [anon_sym__Alignof] = ACTIONS(2707),
    [anon_sym_offsetof] = ACTIONS(2707),
    [anon_sym__Generic] = ACTIONS(2707),
    [anon_sym_asm] = ACTIONS(2707),
    [anon_sym___asm__] = ACTIONS(2707),
    [anon_sym___asm] = ACTIONS(2707),
    [sym_number_literal] = ACTIONS(2709),
    [anon_sym_L_SQUOTE] = ACTIONS(2709),
    [anon_sym_u_SQUOTE] = ACTIONS(2709),
    [anon_sym_U_SQUOTE] = ACTIONS(2709),
    [anon_sym_u8_SQUOTE] = ACTIONS(2709),
    [anon_sym_SQUOTE] = ACTIONS(2709),
    [anon_sym_L_DQUOTE] = ACTIONS(2709),
    [anon_sym_u_DQUOTE] = ACTIONS(2709),
    [anon_sym_U_DQUOTE] = ACTIONS(2709),
    [anon_sym_u8_DQUOTE] = ACTIONS(2709),
    [anon_sym_DQUOTE] = ACTIONS(2709),
    [sym_true] = ACTIONS(2707),
    [sym_false] = ACTIONS(2707),
    [anon_sym_NULL] = ACTIONS(2707),
    [anon_sym_nullptr] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2707),
    [anon_sym_decltype] = ACTIONS(2707),
    [anon_sym_explicit] = ACTIONS(2707),
    [anon_sym_typename] = ACTIONS(2707),
    [anon_sym_template] = ACTIONS(2707),
    [anon_sym_operator] = ACTIONS(2707),
    [anon_sym_try] = ACTIONS(2707),
    [anon_sym_delete] = ACTIONS(2707),
    [anon_sym_throw] = ACTIONS(2707),
    [anon_sym_namespace] = ACTIONS(2707),
    [anon_sym_static_assert] = ACTIONS(2707),
    [anon_sym_concept] = ACTIONS(2707),
    [anon_sym_co_return] = ACTIONS(2707),
    [anon_sym_co_yield] = ACTIONS(2707),
    [anon_sym_R_DQUOTE] = ACTIONS(2709),
    [anon_sym_LR_DQUOTE] = ACTIONS(2709),
    [anon_sym_uR_DQUOTE] = ACTIONS(2709),
    [anon_sym_UR_DQUOTE] = ACTIONS(2709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2709),
    [anon_sym_co_await] = ACTIONS(2707),
    [anon_sym_new] = ACTIONS(2707),
    [anon_sym_requires] = ACTIONS(2707),
    [sym_this] = ACTIONS(2707),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(3445),
    [sym_identifier] = ACTIONS(3447),
    [aux_sym_preproc_include_token1] = ACTIONS(3447),
    [aux_sym_preproc_def_token1] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3447),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3447),
    [sym_preproc_directive] = ACTIONS(3447),
    [anon_sym_LPAREN2] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym___extension__] = ACTIONS(3447),
    [anon_sym_typedef] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym___attribute__] = ACTIONS(3447),
    [anon_sym___attribute] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_COLON_COLON] = ACTIONS(3445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3445),
    [anon_sym___declspec] = ACTIONS(3447),
    [anon_sym___based] = ACTIONS(3447),
    [anon_sym___cdecl] = ACTIONS(3447),
    [anon_sym___clrcall] = ACTIONS(3447),
    [anon_sym___stdcall] = ACTIONS(3447),
    [anon_sym___fastcall] = ACTIONS(3447),
    [anon_sym___thiscall] = ACTIONS(3447),
    [anon_sym___vectorcall] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_signed] = ACTIONS(3447),
    [anon_sym_unsigned] = ACTIONS(3447),
    [anon_sym_long] = ACTIONS(3447),
    [anon_sym_short] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_register] = ACTIONS(3447),
    [anon_sym_inline] = ACTIONS(3447),
    [anon_sym___inline] = ACTIONS(3447),
    [anon_sym___inline__] = ACTIONS(3447),
    [anon_sym___forceinline] = ACTIONS(3447),
    [anon_sym_thread_local] = ACTIONS(3447),
    [anon_sym___thread] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_constexpr] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_restrict] = ACTIONS(3447),
    [anon_sym___restrict__] = ACTIONS(3447),
    [anon_sym__Atomic] = ACTIONS(3447),
    [anon_sym__Noreturn] = ACTIONS(3447),
    [anon_sym_noreturn] = ACTIONS(3447),
    [anon_sym__Nonnull] = ACTIONS(3447),
    [anon_sym_mutable] = ACTIONS(3447),
    [anon_sym_constinit] = ACTIONS(3447),
    [anon_sym_consteval] = ACTIONS(3447),
    [anon_sym_alignas] = ACTIONS(3447),
    [anon_sym__Alignas] = ACTIONS(3447),
    [sym_primitive_type] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_union] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_case] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_goto] = ACTIONS(3447),
    [anon_sym_not] = ACTIONS(3447),
    [anon_sym_compl] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_sizeof] = ACTIONS(3447),
    [anon_sym___alignof__] = ACTIONS(3447),
    [anon_sym___alignof] = ACTIONS(3447),
    [anon_sym__alignof] = ACTIONS(3447),
    [anon_sym_alignof] = ACTIONS(3447),
    [anon_sym__Alignof] = ACTIONS(3447),
    [anon_sym_offsetof] = ACTIONS(3447),
    [anon_sym__Generic] = ACTIONS(3447),
    [anon_sym_asm] = ACTIONS(3447),
    [anon_sym___asm__] = ACTIONS(3447),
    [anon_sym___asm] = ACTIONS(3447),
    [sym_number_literal] = ACTIONS(3445),
    [anon_sym_L_SQUOTE] = ACTIONS(3445),
    [anon_sym_u_SQUOTE] = ACTIONS(3445),
    [anon_sym_U_SQUOTE] = ACTIONS(3445),
    [anon_sym_u8_SQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_L_DQUOTE] = ACTIONS(3445),
    [anon_sym_u_DQUOTE] = ACTIONS(3445),
    [anon_sym_U_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8_DQUOTE] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3447),
    [anon_sym_nullptr] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3447),
    [anon_sym_decltype] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_typename] = ACTIONS(3447),
    [anon_sym_export] = ACTIONS(3447),
    [anon_sym_module] = ACTIONS(3447),
    [anon_sym_import] = ACTIONS(3447),
    [anon_sym_template] = ACTIONS(3447),
    [anon_sym_operator] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_static_assert] = ACTIONS(3447),
    [anon_sym_concept] = ACTIONS(3447),
    [anon_sym_co_return] = ACTIONS(3447),
    [anon_sym_co_yield] = ACTIONS(3447),
    [anon_sym_R_DQUOTE] = ACTIONS(3445),
    [anon_sym_LR_DQUOTE] = ACTIONS(3445),
    [anon_sym_uR_DQUOTE] = ACTIONS(3445),
    [anon_sym_UR_DQUOTE] = ACTIONS(3445),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3445),
    [anon_sym_co_await] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_requires] = ACTIONS(3447),
    [sym_this] = ACTIONS(3447),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(2925),
    [sym_identifier] = ACTIONS(2923),
    [aux_sym_preproc_include_token1] = ACTIONS(2923),
    [aux_sym_preproc_def_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2923),
    [sym_preproc_directive] = ACTIONS(2923),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2923),
    [anon_sym_typedef] = ACTIONS(2923),
    [anon_sym_virtual] = ACTIONS(2923),
    [anon_sym_extern] = ACTIONS(2923),
    [anon_sym___attribute__] = ACTIONS(2923),
    [anon_sym___attribute] = ACTIONS(2923),
    [anon_sym_using] = ACTIONS(2923),
    [anon_sym_COLON_COLON] = ACTIONS(2925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2925),
    [anon_sym___declspec] = ACTIONS(2923),
    [anon_sym___based] = ACTIONS(2923),
    [anon_sym___cdecl] = ACTIONS(2923),
    [anon_sym___clrcall] = ACTIONS(2923),
    [anon_sym___stdcall] = ACTIONS(2923),
    [anon_sym___fastcall] = ACTIONS(2923),
    [anon_sym___thiscall] = ACTIONS(2923),
    [anon_sym___vectorcall] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_signed] = ACTIONS(2923),
    [anon_sym_unsigned] = ACTIONS(2923),
    [anon_sym_long] = ACTIONS(2923),
    [anon_sym_short] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_register] = ACTIONS(2923),
    [anon_sym_inline] = ACTIONS(2923),
    [anon_sym___inline] = ACTIONS(2923),
    [anon_sym___inline__] = ACTIONS(2923),
    [anon_sym___forceinline] = ACTIONS(2923),
    [anon_sym_thread_local] = ACTIONS(2923),
    [anon_sym___thread] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_constexpr] = ACTIONS(2923),
    [anon_sym_volatile] = ACTIONS(2923),
    [anon_sym_restrict] = ACTIONS(2923),
    [anon_sym___restrict__] = ACTIONS(2923),
    [anon_sym__Atomic] = ACTIONS(2923),
    [anon_sym__Noreturn] = ACTIONS(2923),
    [anon_sym_noreturn] = ACTIONS(2923),
    [anon_sym__Nonnull] = ACTIONS(2923),
    [anon_sym_mutable] = ACTIONS(2923),
    [anon_sym_constinit] = ACTIONS(2923),
    [anon_sym_consteval] = ACTIONS(2923),
    [anon_sym_alignas] = ACTIONS(2923),
    [anon_sym__Alignas] = ACTIONS(2923),
    [sym_primitive_type] = ACTIONS(2923),
    [anon_sym_enum] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2923),
    [anon_sym_union] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_case] = ACTIONS(2923),
    [anon_sym_default] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_break] = ACTIONS(2923),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2923),
    [anon_sym_not] = ACTIONS(2923),
    [anon_sym_compl] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_sizeof] = ACTIONS(2923),
    [anon_sym___alignof__] = ACTIONS(2923),
    [anon_sym___alignof] = ACTIONS(2923),
    [anon_sym__alignof] = ACTIONS(2923),
    [anon_sym_alignof] = ACTIONS(2923),
    [anon_sym__Alignof] = ACTIONS(2923),
    [anon_sym_offsetof] = ACTIONS(2923),
    [anon_sym__Generic] = ACTIONS(2923),
    [anon_sym_asm] = ACTIONS(2923),
    [anon_sym___asm__] = ACTIONS(2923),
    [anon_sym___asm] = ACTIONS(2923),
    [sym_number_literal] = ACTIONS(2925),
    [anon_sym_L_SQUOTE] = ACTIONS(2925),
    [anon_sym_u_SQUOTE] = ACTIONS(2925),
    [anon_sym_U_SQUOTE] = ACTIONS(2925),
    [anon_sym_u8_SQUOTE] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [anon_sym_L_DQUOTE] = ACTIONS(2925),
    [anon_sym_u_DQUOTE] = ACTIONS(2925),
    [anon_sym_U_DQUOTE] = ACTIONS(2925),
    [anon_sym_u8_DQUOTE] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [sym_true] = ACTIONS(2923),
    [sym_false] = ACTIONS(2923),
    [anon_sym_NULL] = ACTIONS(2923),
    [anon_sym_nullptr] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2923),
    [anon_sym_decltype] = ACTIONS(2923),
    [anon_sym_explicit] = ACTIONS(2923),
    [anon_sym_typename] = ACTIONS(2923),
    [anon_sym_export] = ACTIONS(2923),
    [anon_sym_module] = ACTIONS(2923),
    [anon_sym_import] = ACTIONS(2923),
    [anon_sym_template] = ACTIONS(2923),
    [anon_sym_operator] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_delete] = ACTIONS(2923),
    [anon_sym_throw] = ACTIONS(2923),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_static_assert] = ACTIONS(2923),
    [anon_sym_concept] = ACTIONS(2923),
    [anon_sym_co_return] = ACTIONS(2923),
    [anon_sym_co_yield] = ACTIONS(2923),
    [anon_sym_R_DQUOTE] = ACTIONS(2925),
    [anon_sym_LR_DQUOTE] = ACTIONS(2925),
    [anon_sym_uR_DQUOTE] = ACTIONS(2925),
    [anon_sym_UR_DQUOTE] = ACTIONS(2925),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2925),
    [anon_sym_co_await] = ACTIONS(2923),
    [anon_sym_new] = ACTIONS(2923),
    [anon_sym_requires] = ACTIONS(2923),
    [sym_this] = ACTIONS(2923),
  },
  [567] = {
    [sym_identifier] = ACTIONS(2655),
    [aux_sym_preproc_include_token1] = ACTIONS(2655),
    [aux_sym_preproc_def_token1] = ACTIONS(2655),
    [aux_sym_preproc_if_token1] = ACTIONS(2655),
    [aux_sym_preproc_if_token2] = ACTIONS(2655),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2655),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2655),
    [sym_preproc_directive] = ACTIONS(2655),
    [anon_sym_LPAREN2] = ACTIONS(2657),
    [anon_sym_BANG] = ACTIONS(2657),
    [anon_sym_TILDE] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_AMP_AMP] = ACTIONS(2657),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym___extension__] = ACTIONS(2655),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_virtual] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym___attribute__] = ACTIONS(2655),
    [anon_sym___attribute] = ACTIONS(2655),
    [anon_sym_using] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2657),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2657),
    [anon_sym___declspec] = ACTIONS(2655),
    [anon_sym___based] = ACTIONS(2655),
    [anon_sym___cdecl] = ACTIONS(2655),
    [anon_sym___clrcall] = ACTIONS(2655),
    [anon_sym___stdcall] = ACTIONS(2655),
    [anon_sym___fastcall] = ACTIONS(2655),
    [anon_sym___thiscall] = ACTIONS(2655),
    [anon_sym___vectorcall] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_signed] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2655),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym___inline] = ACTIONS(2655),
    [anon_sym___inline__] = ACTIONS(2655),
    [anon_sym___forceinline] = ACTIONS(2655),
    [anon_sym_thread_local] = ACTIONS(2655),
    [anon_sym___thread] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym___restrict__] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym__Noreturn] = ACTIONS(2655),
    [anon_sym_noreturn] = ACTIONS(2655),
    [anon_sym__Nonnull] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_constinit] = ACTIONS(2655),
    [anon_sym_consteval] = ACTIONS(2655),
    [anon_sym_alignas] = ACTIONS(2655),
    [anon_sym__Alignas] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_class] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_else] = ACTIONS(2655),
    [anon_sym_switch] = ACTIONS(2655),
    [anon_sym_case] = ACTIONS(2655),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym___try] = ACTIONS(2655),
    [anon_sym___leave] = ACTIONS(2655),
    [anon_sym_not] = ACTIONS(2655),
    [anon_sym_compl] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(2657),
    [anon_sym_sizeof] = ACTIONS(2655),
    [anon_sym___alignof__] = ACTIONS(2655),
    [anon_sym___alignof] = ACTIONS(2655),
    [anon_sym__alignof] = ACTIONS(2655),
    [anon_sym_alignof] = ACTIONS(2655),
    [anon_sym__Alignof] = ACTIONS(2655),
    [anon_sym_offsetof] = ACTIONS(2655),
    [anon_sym__Generic] = ACTIONS(2655),
    [anon_sym_asm] = ACTIONS(2655),
    [anon_sym___asm__] = ACTIONS(2655),
    [anon_sym___asm] = ACTIONS(2655),
    [sym_number_literal] = ACTIONS(2657),
    [anon_sym_L_SQUOTE] = ACTIONS(2657),
    [anon_sym_u_SQUOTE] = ACTIONS(2657),
    [anon_sym_U_SQUOTE] = ACTIONS(2657),
    [anon_sym_u8_SQUOTE] = ACTIONS(2657),
    [anon_sym_SQUOTE] = ACTIONS(2657),
    [anon_sym_L_DQUOTE] = ACTIONS(2657),
    [anon_sym_u_DQUOTE] = ACTIONS(2657),
    [anon_sym_U_DQUOTE] = ACTIONS(2657),
    [anon_sym_u8_DQUOTE] = ACTIONS(2657),
    [anon_sym_DQUOTE] = ACTIONS(2657),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [anon_sym_NULL] = ACTIONS(2655),
    [anon_sym_nullptr] = ACTIONS(2655),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_decltype] = ACTIONS(2655),
    [anon_sym_explicit] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_template] = ACTIONS(2655),
    [anon_sym_operator] = ACTIONS(2655),
    [anon_sym_try] = ACTIONS(2655),
    [anon_sym_delete] = ACTIONS(2655),
    [anon_sym_throw] = ACTIONS(2655),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_static_assert] = ACTIONS(2655),
    [anon_sym_concept] = ACTIONS(2655),
    [anon_sym_co_return] = ACTIONS(2655),
    [anon_sym_co_yield] = ACTIONS(2655),
    [anon_sym_R_DQUOTE] = ACTIONS(2657),
    [anon_sym_LR_DQUOTE] = ACTIONS(2657),
    [anon_sym_uR_DQUOTE] = ACTIONS(2657),
    [anon_sym_UR_DQUOTE] = ACTIONS(2657),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2657),
    [anon_sym_co_await] = ACTIONS(2655),
    [anon_sym_new] = ACTIONS(2655),
    [anon_sym_requires] = ACTIONS(2655),
    [sym_this] = ACTIONS(2655),
  },
  [568] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_RBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [569] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token2] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [anon_sym___asm] = ACTIONS(2739),
    [sym_number_literal] = ACTIONS(2741),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [570] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [anon_sym___asm] = ACTIONS(2751),
    [sym_number_literal] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [571] = {
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_include_token1] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym___cdecl] = ACTIONS(2681),
    [anon_sym___clrcall] = ACTIONS(2681),
    [anon_sym___stdcall] = ACTIONS(2681),
    [anon_sym___fastcall] = ACTIONS(2681),
    [anon_sym___thiscall] = ACTIONS(2681),
    [anon_sym___vectorcall] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_case] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_goto] = ACTIONS(2681),
    [anon_sym___try] = ACTIONS(2681),
    [anon_sym___leave] = ACTIONS(2681),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_compl] = ACTIONS(2681),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_sizeof] = ACTIONS(2681),
    [anon_sym___alignof__] = ACTIONS(2681),
    [anon_sym___alignof] = ACTIONS(2681),
    [anon_sym__alignof] = ACTIONS(2681),
    [anon_sym_alignof] = ACTIONS(2681),
    [anon_sym__Alignof] = ACTIONS(2681),
    [anon_sym_offsetof] = ACTIONS(2681),
    [anon_sym__Generic] = ACTIONS(2681),
    [anon_sym_asm] = ACTIONS(2681),
    [anon_sym___asm__] = ACTIONS(2681),
    [anon_sym___asm] = ACTIONS(2681),
    [sym_number_literal] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2683),
    [anon_sym_u_SQUOTE] = ACTIONS(2683),
    [anon_sym_U_SQUOTE] = ACTIONS(2683),
    [anon_sym_u8_SQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_L_DQUOTE] = ACTIONS(2683),
    [anon_sym_u_DQUOTE] = ACTIONS(2683),
    [anon_sym_U_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8_DQUOTE] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [anon_sym_NULL] = ACTIONS(2681),
    [anon_sym_nullptr] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
    [anon_sym_concept] = ACTIONS(2681),
    [anon_sym_co_return] = ACTIONS(2681),
    [anon_sym_co_yield] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2683),
    [anon_sym_LR_DQUOTE] = ACTIONS(2683),
    [anon_sym_uR_DQUOTE] = ACTIONS(2683),
    [anon_sym_UR_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2683),
    [anon_sym_co_await] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_requires] = ACTIONS(2681),
    [sym_this] = ACTIONS(2681),
  },
  [572] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [573] = {
    [sym_identifier] = ACTIONS(2627),
    [aux_sym_preproc_include_token1] = ACTIONS(2627),
    [aux_sym_preproc_def_token1] = ACTIONS(2627),
    [aux_sym_preproc_if_token1] = ACTIONS(2627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2627),
    [sym_preproc_directive] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2629),
    [anon_sym_BANG] = ACTIONS(2629),
    [anon_sym_TILDE] = ACTIONS(2629),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2629),
    [anon_sym_AMP_AMP] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_SEMI] = ACTIONS(2629),
    [anon_sym___extension__] = ACTIONS(2627),
    [anon_sym_typedef] = ACTIONS(2627),
    [anon_sym_virtual] = ACTIONS(2627),
    [anon_sym_extern] = ACTIONS(2627),
    [anon_sym___attribute__] = ACTIONS(2627),
    [anon_sym___attribute] = ACTIONS(2627),
    [anon_sym_using] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2629),
    [anon_sym___declspec] = ACTIONS(2627),
    [anon_sym___based] = ACTIONS(2627),
    [anon_sym___cdecl] = ACTIONS(2627),
    [anon_sym___clrcall] = ACTIONS(2627),
    [anon_sym___stdcall] = ACTIONS(2627),
    [anon_sym___fastcall] = ACTIONS(2627),
    [anon_sym___thiscall] = ACTIONS(2627),
    [anon_sym___vectorcall] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2629),
    [anon_sym_RBRACE] = ACTIONS(2629),
    [anon_sym_signed] = ACTIONS(2627),
    [anon_sym_unsigned] = ACTIONS(2627),
    [anon_sym_long] = ACTIONS(2627),
    [anon_sym_short] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_static] = ACTIONS(2627),
    [anon_sym_register] = ACTIONS(2627),
    [anon_sym_inline] = ACTIONS(2627),
    [anon_sym___inline] = ACTIONS(2627),
    [anon_sym___inline__] = ACTIONS(2627),
    [anon_sym___forceinline] = ACTIONS(2627),
    [anon_sym_thread_local] = ACTIONS(2627),
    [anon_sym___thread] = ACTIONS(2627),
    [anon_sym_const] = ACTIONS(2627),
    [anon_sym_constexpr] = ACTIONS(2627),
    [anon_sym_volatile] = ACTIONS(2627),
    [anon_sym_restrict] = ACTIONS(2627),
    [anon_sym___restrict__] = ACTIONS(2627),
    [anon_sym__Atomic] = ACTIONS(2627),
    [anon_sym__Noreturn] = ACTIONS(2627),
    [anon_sym_noreturn] = ACTIONS(2627),
    [anon_sym__Nonnull] = ACTIONS(2627),
    [anon_sym_mutable] = ACTIONS(2627),
    [anon_sym_constinit] = ACTIONS(2627),
    [anon_sym_consteval] = ACTIONS(2627),
    [anon_sym_alignas] = ACTIONS(2627),
    [anon_sym__Alignas] = ACTIONS(2627),
    [sym_primitive_type] = ACTIONS(2627),
    [anon_sym_enum] = ACTIONS(2627),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_union] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_else] = ACTIONS(2627),
    [anon_sym_switch] = ACTIONS(2627),
    [anon_sym_case] = ACTIONS(2627),
    [anon_sym_default] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_goto] = ACTIONS(2627),
    [anon_sym___try] = ACTIONS(2627),
    [anon_sym___leave] = ACTIONS(2627),
    [anon_sym_not] = ACTIONS(2627),
    [anon_sym_compl] = ACTIONS(2627),
    [anon_sym_DASH_DASH] = ACTIONS(2629),
    [anon_sym_PLUS_PLUS] = ACTIONS(2629),
    [anon_sym_sizeof] = ACTIONS(2627),
    [anon_sym___alignof__] = ACTIONS(2627),
    [anon_sym___alignof] = ACTIONS(2627),
    [anon_sym__alignof] = ACTIONS(2627),
    [anon_sym_alignof] = ACTIONS(2627),
    [anon_sym__Alignof] = ACTIONS(2627),
    [anon_sym_offsetof] = ACTIONS(2627),
    [anon_sym__Generic] = ACTIONS(2627),
    [anon_sym_asm] = ACTIONS(2627),
    [anon_sym___asm__] = ACTIONS(2627),
    [anon_sym___asm] = ACTIONS(2627),
    [sym_number_literal] = ACTIONS(2629),
    [anon_sym_L_SQUOTE] = ACTIONS(2629),
    [anon_sym_u_SQUOTE] = ACTIONS(2629),
    [anon_sym_U_SQUOTE] = ACTIONS(2629),
    [anon_sym_u8_SQUOTE] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2629),
    [anon_sym_L_DQUOTE] = ACTIONS(2629),
    [anon_sym_u_DQUOTE] = ACTIONS(2629),
    [anon_sym_U_DQUOTE] = ACTIONS(2629),
    [anon_sym_u8_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE] = ACTIONS(2629),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [anon_sym_NULL] = ACTIONS(2627),
    [anon_sym_nullptr] = ACTIONS(2627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2627),
    [anon_sym_decltype] = ACTIONS(2627),
    [anon_sym_explicit] = ACTIONS(2627),
    [anon_sym_typename] = ACTIONS(2627),
    [anon_sym_template] = ACTIONS(2627),
    [anon_sym_operator] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_delete] = ACTIONS(2627),
    [anon_sym_throw] = ACTIONS(2627),
    [anon_sym_namespace] = ACTIONS(2627),
    [anon_sym_static_assert] = ACTIONS(2627),
    [anon_sym_concept] = ACTIONS(2627),
    [anon_sym_co_return] = ACTIONS(2627),
    [anon_sym_co_yield] = ACTIONS(2627),
    [anon_sym_R_DQUOTE] = ACTIONS(2629),
    [anon_sym_LR_DQUOTE] = ACTIONS(2629),
    [anon_sym_uR_DQUOTE] = ACTIONS(2629),
    [anon_sym_UR_DQUOTE] = ACTIONS(2629),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2629),
    [anon_sym_co_await] = ACTIONS(2627),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_requires] = ACTIONS(2627),
    [sym_this] = ACTIONS(2627),
  },
  [574] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token2] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [anon_sym___asm] = ACTIONS(2751),
    [sym_number_literal] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [575] = {
    [sym_identifier] = ACTIONS(2691),
    [aux_sym_preproc_include_token1] = ACTIONS(2691),
    [aux_sym_preproc_def_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2691),
    [sym_preproc_directive] = ACTIONS(2691),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym___extension__] = ACTIONS(2691),
    [anon_sym_typedef] = ACTIONS(2691),
    [anon_sym_virtual] = ACTIONS(2691),
    [anon_sym_extern] = ACTIONS(2691),
    [anon_sym___attribute__] = ACTIONS(2691),
    [anon_sym___attribute] = ACTIONS(2691),
    [anon_sym_using] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2693),
    [anon_sym___declspec] = ACTIONS(2691),
    [anon_sym___based] = ACTIONS(2691),
    [anon_sym___cdecl] = ACTIONS(2691),
    [anon_sym___clrcall] = ACTIONS(2691),
    [anon_sym___stdcall] = ACTIONS(2691),
    [anon_sym___fastcall] = ACTIONS(2691),
    [anon_sym___thiscall] = ACTIONS(2691),
    [anon_sym___vectorcall] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_RBRACE] = ACTIONS(2693),
    [anon_sym_signed] = ACTIONS(2691),
    [anon_sym_unsigned] = ACTIONS(2691),
    [anon_sym_long] = ACTIONS(2691),
    [anon_sym_short] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2691),
    [anon_sym_register] = ACTIONS(2691),
    [anon_sym_inline] = ACTIONS(2691),
    [anon_sym___inline] = ACTIONS(2691),
    [anon_sym___inline__] = ACTIONS(2691),
    [anon_sym___forceinline] = ACTIONS(2691),
    [anon_sym_thread_local] = ACTIONS(2691),
    [anon_sym___thread] = ACTIONS(2691),
    [anon_sym_const] = ACTIONS(2691),
    [anon_sym_constexpr] = ACTIONS(2691),
    [anon_sym_volatile] = ACTIONS(2691),
    [anon_sym_restrict] = ACTIONS(2691),
    [anon_sym___restrict__] = ACTIONS(2691),
    [anon_sym__Atomic] = ACTIONS(2691),
    [anon_sym__Noreturn] = ACTIONS(2691),
    [anon_sym_noreturn] = ACTIONS(2691),
    [anon_sym__Nonnull] = ACTIONS(2691),
    [anon_sym_mutable] = ACTIONS(2691),
    [anon_sym_constinit] = ACTIONS(2691),
    [anon_sym_consteval] = ACTIONS(2691),
    [anon_sym_alignas] = ACTIONS(2691),
    [anon_sym__Alignas] = ACTIONS(2691),
    [sym_primitive_type] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2691),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_union] = ACTIONS(2691),
    [anon_sym_if] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2691),
    [anon_sym_switch] = ACTIONS(2691),
    [anon_sym_case] = ACTIONS(2691),
    [anon_sym_default] = ACTIONS(2691),
    [anon_sym_while] = ACTIONS(2691),
    [anon_sym_do] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2691),
    [anon_sym_return] = ACTIONS(2691),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_continue] = ACTIONS(2691),
    [anon_sym_goto] = ACTIONS(2691),
    [anon_sym___try] = ACTIONS(2691),
    [anon_sym___leave] = ACTIONS(2691),
    [anon_sym_not] = ACTIONS(2691),
    [anon_sym_compl] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_sizeof] = ACTIONS(2691),
    [anon_sym___alignof__] = ACTIONS(2691),
    [anon_sym___alignof] = ACTIONS(2691),
    [anon_sym__alignof] = ACTIONS(2691),
    [anon_sym_alignof] = ACTIONS(2691),
    [anon_sym__Alignof] = ACTIONS(2691),
    [anon_sym_offsetof] = ACTIONS(2691),
    [anon_sym__Generic] = ACTIONS(2691),
    [anon_sym_asm] = ACTIONS(2691),
    [anon_sym___asm__] = ACTIONS(2691),
    [anon_sym___asm] = ACTIONS(2691),
    [sym_number_literal] = ACTIONS(2693),
    [anon_sym_L_SQUOTE] = ACTIONS(2693),
    [anon_sym_u_SQUOTE] = ACTIONS(2693),
    [anon_sym_U_SQUOTE] = ACTIONS(2693),
    [anon_sym_u8_SQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_L_DQUOTE] = ACTIONS(2693),
    [anon_sym_u_DQUOTE] = ACTIONS(2693),
    [anon_sym_U_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8_DQUOTE] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [anon_sym_NULL] = ACTIONS(2691),
    [anon_sym_nullptr] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2691),
    [anon_sym_decltype] = ACTIONS(2691),
    [anon_sym_explicit] = ACTIONS(2691),
    [anon_sym_typename] = ACTIONS(2691),
    [anon_sym_template] = ACTIONS(2691),
    [anon_sym_operator] = ACTIONS(2691),
    [anon_sym_try] = ACTIONS(2691),
    [anon_sym_delete] = ACTIONS(2691),
    [anon_sym_throw] = ACTIONS(2691),
    [anon_sym_namespace] = ACTIONS(2691),
    [anon_sym_static_assert] = ACTIONS(2691),
    [anon_sym_concept] = ACTIONS(2691),
    [anon_sym_co_return] = ACTIONS(2691),
    [anon_sym_co_yield] = ACTIONS(2691),
    [anon_sym_R_DQUOTE] = ACTIONS(2693),
    [anon_sym_LR_DQUOTE] = ACTIONS(2693),
    [anon_sym_uR_DQUOTE] = ACTIONS(2693),
    [anon_sym_UR_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2693),
    [anon_sym_co_await] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2691),
    [anon_sym_requires] = ACTIONS(2691),
    [sym_this] = ACTIONS(2691),
  },
  [576] = {
    [sym_identifier] = ACTIONS(2695),
    [aux_sym_preproc_include_token1] = ACTIONS(2695),
    [aux_sym_preproc_def_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2695),
    [sym_preproc_directive] = ACTIONS(2695),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym___extension__] = ACTIONS(2695),
    [anon_sym_typedef] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym___attribute__] = ACTIONS(2695),
    [anon_sym___attribute] = ACTIONS(2695),
    [anon_sym_using] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2697),
    [anon_sym___declspec] = ACTIONS(2695),
    [anon_sym___based] = ACTIONS(2695),
    [anon_sym___cdecl] = ACTIONS(2695),
    [anon_sym___clrcall] = ACTIONS(2695),
    [anon_sym___stdcall] = ACTIONS(2695),
    [anon_sym___fastcall] = ACTIONS(2695),
    [anon_sym___thiscall] = ACTIONS(2695),
    [anon_sym___vectorcall] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_RBRACE] = ACTIONS(2697),
    [anon_sym_signed] = ACTIONS(2695),
    [anon_sym_unsigned] = ACTIONS(2695),
    [anon_sym_long] = ACTIONS(2695),
    [anon_sym_short] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym___inline] = ACTIONS(2695),
    [anon_sym___inline__] = ACTIONS(2695),
    [anon_sym___forceinline] = ACTIONS(2695),
    [anon_sym_thread_local] = ACTIONS(2695),
    [anon_sym___thread] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym___restrict__] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym__Noreturn] = ACTIONS(2695),
    [anon_sym_noreturn] = ACTIONS(2695),
    [anon_sym__Nonnull] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_constinit] = ACTIONS(2695),
    [anon_sym_consteval] = ACTIONS(2695),
    [anon_sym_alignas] = ACTIONS(2695),
    [anon_sym__Alignas] = ACTIONS(2695),
    [sym_primitive_type] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2695),
    [anon_sym_union] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_case] = ACTIONS(2695),
    [anon_sym_default] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_goto] = ACTIONS(2695),
    [anon_sym___try] = ACTIONS(2695),
    [anon_sym___leave] = ACTIONS(2695),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_compl] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_sizeof] = ACTIONS(2695),
    [anon_sym___alignof__] = ACTIONS(2695),
    [anon_sym___alignof] = ACTIONS(2695),
    [anon_sym__alignof] = ACTIONS(2695),
    [anon_sym_alignof] = ACTIONS(2695),
    [anon_sym__Alignof] = ACTIONS(2695),
    [anon_sym_offsetof] = ACTIONS(2695),
    [anon_sym__Generic] = ACTIONS(2695),
    [anon_sym_asm] = ACTIONS(2695),
    [anon_sym___asm__] = ACTIONS(2695),
    [anon_sym___asm] = ACTIONS(2695),
    [sym_number_literal] = ACTIONS(2697),
    [anon_sym_L_SQUOTE] = ACTIONS(2697),
    [anon_sym_u_SQUOTE] = ACTIONS(2697),
    [anon_sym_U_SQUOTE] = ACTIONS(2697),
    [anon_sym_u8_SQUOTE] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_L_DQUOTE] = ACTIONS(2697),
    [anon_sym_u_DQUOTE] = ACTIONS(2697),
    [anon_sym_U_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [anon_sym_NULL] = ACTIONS(2695),
    [anon_sym_nullptr] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2695),
    [anon_sym_decltype] = ACTIONS(2695),
    [anon_sym_explicit] = ACTIONS(2695),
    [anon_sym_typename] = ACTIONS(2695),
    [anon_sym_template] = ACTIONS(2695),
    [anon_sym_operator] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_static_assert] = ACTIONS(2695),
    [anon_sym_concept] = ACTIONS(2695),
    [anon_sym_co_return] = ACTIONS(2695),
    [anon_sym_co_yield] = ACTIONS(2695),
    [anon_sym_R_DQUOTE] = ACTIONS(2697),
    [anon_sym_LR_DQUOTE] = ACTIONS(2697),
    [anon_sym_uR_DQUOTE] = ACTIONS(2697),
    [anon_sym_UR_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2697),
    [anon_sym_co_await] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_requires] = ACTIONS(2695),
    [sym_this] = ACTIONS(2695),
  },
  [577] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_include_token1] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym___cdecl] = ACTIONS(2703),
    [anon_sym___clrcall] = ACTIONS(2703),
    [anon_sym___stdcall] = ACTIONS(2703),
    [anon_sym___fastcall] = ACTIONS(2703),
    [anon_sym___thiscall] = ACTIONS(2703),
    [anon_sym___vectorcall] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_RBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [anon_sym_if] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2703),
    [anon_sym_case] = ACTIONS(2703),
    [anon_sym_default] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(2703),
    [anon_sym_do] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2703),
    [anon_sym_return] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2703),
    [anon_sym_continue] = ACTIONS(2703),
    [anon_sym_goto] = ACTIONS(2703),
    [anon_sym___try] = ACTIONS(2703),
    [anon_sym___leave] = ACTIONS(2703),
    [anon_sym_not] = ACTIONS(2703),
    [anon_sym_compl] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2703),
    [anon_sym___alignof__] = ACTIONS(2703),
    [anon_sym___alignof] = ACTIONS(2703),
    [anon_sym__alignof] = ACTIONS(2703),
    [anon_sym_alignof] = ACTIONS(2703),
    [anon_sym__Alignof] = ACTIONS(2703),
    [anon_sym_offsetof] = ACTIONS(2703),
    [anon_sym__Generic] = ACTIONS(2703),
    [anon_sym_asm] = ACTIONS(2703),
    [anon_sym___asm__] = ACTIONS(2703),
    [anon_sym___asm] = ACTIONS(2703),
    [sym_number_literal] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2705),
    [anon_sym_u_SQUOTE] = ACTIONS(2705),
    [anon_sym_U_SQUOTE] = ACTIONS(2705),
    [anon_sym_u8_SQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_L_DQUOTE] = ACTIONS(2705),
    [anon_sym_u_DQUOTE] = ACTIONS(2705),
    [anon_sym_U_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8_DQUOTE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [sym_false] = ACTIONS(2703),
    [anon_sym_NULL] = ACTIONS(2703),
    [anon_sym_nullptr] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2703),
    [anon_sym_delete] = ACTIONS(2703),
    [anon_sym_throw] = ACTIONS(2703),
    [anon_sym_namespace] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
    [anon_sym_concept] = ACTIONS(2703),
    [anon_sym_co_return] = ACTIONS(2703),
    [anon_sym_co_yield] = ACTIONS(2703),
    [anon_sym_R_DQUOTE] = ACTIONS(2705),
    [anon_sym_LR_DQUOTE] = ACTIONS(2705),
    [anon_sym_uR_DQUOTE] = ACTIONS(2705),
    [anon_sym_UR_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2705),
    [anon_sym_co_await] = ACTIONS(2703),
    [anon_sym_new] = ACTIONS(2703),
    [anon_sym_requires] = ACTIONS(2703),
    [sym_this] = ACTIONS(2703),
  },
  [578] = {
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_include_token1] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token2] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym___cdecl] = ACTIONS(2681),
    [anon_sym___clrcall] = ACTIONS(2681),
    [anon_sym___stdcall] = ACTIONS(2681),
    [anon_sym___fastcall] = ACTIONS(2681),
    [anon_sym___thiscall] = ACTIONS(2681),
    [anon_sym___vectorcall] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_case] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_goto] = ACTIONS(2681),
    [anon_sym___try] = ACTIONS(2681),
    [anon_sym___leave] = ACTIONS(2681),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_compl] = ACTIONS(2681),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_sizeof] = ACTIONS(2681),
    [anon_sym___alignof__] = ACTIONS(2681),
    [anon_sym___alignof] = ACTIONS(2681),
    [anon_sym__alignof] = ACTIONS(2681),
    [anon_sym_alignof] = ACTIONS(2681),
    [anon_sym__Alignof] = ACTIONS(2681),
    [anon_sym_offsetof] = ACTIONS(2681),
    [anon_sym__Generic] = ACTIONS(2681),
    [anon_sym_asm] = ACTIONS(2681),
    [anon_sym___asm__] = ACTIONS(2681),
    [anon_sym___asm] = ACTIONS(2681),
    [sym_number_literal] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2683),
    [anon_sym_u_SQUOTE] = ACTIONS(2683),
    [anon_sym_U_SQUOTE] = ACTIONS(2683),
    [anon_sym_u8_SQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_L_DQUOTE] = ACTIONS(2683),
    [anon_sym_u_DQUOTE] = ACTIONS(2683),
    [anon_sym_U_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8_DQUOTE] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [anon_sym_NULL] = ACTIONS(2681),
    [anon_sym_nullptr] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
    [anon_sym_concept] = ACTIONS(2681),
    [anon_sym_co_return] = ACTIONS(2681),
    [anon_sym_co_yield] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2683),
    [anon_sym_LR_DQUOTE] = ACTIONS(2683),
    [anon_sym_uR_DQUOTE] = ACTIONS(2683),
    [anon_sym_UR_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2683),
    [anon_sym_co_await] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_requires] = ACTIONS(2681),
    [sym_this] = ACTIONS(2681),
  },
  [579] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_include_token1] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym___cdecl] = ACTIONS(2703),
    [anon_sym___clrcall] = ACTIONS(2703),
    [anon_sym___stdcall] = ACTIONS(2703),
    [anon_sym___fastcall] = ACTIONS(2703),
    [anon_sym___thiscall] = ACTIONS(2703),
    [anon_sym___vectorcall] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_RBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [anon_sym_if] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2703),
    [anon_sym_case] = ACTIONS(2703),
    [anon_sym_default] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(2703),
    [anon_sym_do] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2703),
    [anon_sym_return] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2703),
    [anon_sym_continue] = ACTIONS(2703),
    [anon_sym_goto] = ACTIONS(2703),
    [anon_sym___try] = ACTIONS(2703),
    [anon_sym___leave] = ACTIONS(2703),
    [anon_sym_not] = ACTIONS(2703),
    [anon_sym_compl] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2703),
    [anon_sym___alignof__] = ACTIONS(2703),
    [anon_sym___alignof] = ACTIONS(2703),
    [anon_sym__alignof] = ACTIONS(2703),
    [anon_sym_alignof] = ACTIONS(2703),
    [anon_sym__Alignof] = ACTIONS(2703),
    [anon_sym_offsetof] = ACTIONS(2703),
    [anon_sym__Generic] = ACTIONS(2703),
    [anon_sym_asm] = ACTIONS(2703),
    [anon_sym___asm__] = ACTIONS(2703),
    [anon_sym___asm] = ACTIONS(2703),
    [sym_number_literal] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2705),
    [anon_sym_u_SQUOTE] = ACTIONS(2705),
    [anon_sym_U_SQUOTE] = ACTIONS(2705),
    [anon_sym_u8_SQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_L_DQUOTE] = ACTIONS(2705),
    [anon_sym_u_DQUOTE] = ACTIONS(2705),
    [anon_sym_U_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8_DQUOTE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [sym_false] = ACTIONS(2703),
    [anon_sym_NULL] = ACTIONS(2703),
    [anon_sym_nullptr] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2703),
    [anon_sym_delete] = ACTIONS(2703),
    [anon_sym_throw] = ACTIONS(2703),
    [anon_sym_namespace] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
    [anon_sym_concept] = ACTIONS(2703),
    [anon_sym_co_return] = ACTIONS(2703),
    [anon_sym_co_yield] = ACTIONS(2703),
    [anon_sym_R_DQUOTE] = ACTIONS(2705),
    [anon_sym_LR_DQUOTE] = ACTIONS(2705),
    [anon_sym_uR_DQUOTE] = ACTIONS(2705),
    [anon_sym_UR_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2705),
    [anon_sym_co_await] = ACTIONS(2703),
    [anon_sym_new] = ACTIONS(2703),
    [anon_sym_requires] = ACTIONS(2703),
    [sym_this] = ACTIONS(2703),
  },
  [580] = {
    [sym_identifier] = ACTIONS(2711),
    [aux_sym_preproc_include_token1] = ACTIONS(2711),
    [aux_sym_preproc_def_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token1] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2711),
    [sym_preproc_directive] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym___extension__] = ACTIONS(2711),
    [anon_sym_typedef] = ACTIONS(2711),
    [anon_sym_virtual] = ACTIONS(2711),
    [anon_sym_extern] = ACTIONS(2711),
    [anon_sym___attribute__] = ACTIONS(2711),
    [anon_sym___attribute] = ACTIONS(2711),
    [anon_sym_using] = ACTIONS(2711),
    [anon_sym_COLON_COLON] = ACTIONS(2713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2713),
    [anon_sym___declspec] = ACTIONS(2711),
    [anon_sym___based] = ACTIONS(2711),
    [anon_sym___cdecl] = ACTIONS(2711),
    [anon_sym___clrcall] = ACTIONS(2711),
    [anon_sym___stdcall] = ACTIONS(2711),
    [anon_sym___fastcall] = ACTIONS(2711),
    [anon_sym___thiscall] = ACTIONS(2711),
    [anon_sym___vectorcall] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_RBRACE] = ACTIONS(2713),
    [anon_sym_signed] = ACTIONS(2711),
    [anon_sym_unsigned] = ACTIONS(2711),
    [anon_sym_long] = ACTIONS(2711),
    [anon_sym_short] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_static] = ACTIONS(2711),
    [anon_sym_register] = ACTIONS(2711),
    [anon_sym_inline] = ACTIONS(2711),
    [anon_sym___inline] = ACTIONS(2711),
    [anon_sym___inline__] = ACTIONS(2711),
    [anon_sym___forceinline] = ACTIONS(2711),
    [anon_sym_thread_local] = ACTIONS(2711),
    [anon_sym___thread] = ACTIONS(2711),
    [anon_sym_const] = ACTIONS(2711),
    [anon_sym_constexpr] = ACTIONS(2711),
    [anon_sym_volatile] = ACTIONS(2711),
    [anon_sym_restrict] = ACTIONS(2711),
    [anon_sym___restrict__] = ACTIONS(2711),
    [anon_sym__Atomic] = ACTIONS(2711),
    [anon_sym__Noreturn] = ACTIONS(2711),
    [anon_sym_noreturn] = ACTIONS(2711),
    [anon_sym__Nonnull] = ACTIONS(2711),
    [anon_sym_mutable] = ACTIONS(2711),
    [anon_sym_constinit] = ACTIONS(2711),
    [anon_sym_consteval] = ACTIONS(2711),
    [anon_sym_alignas] = ACTIONS(2711),
    [anon_sym__Alignas] = ACTIONS(2711),
    [sym_primitive_type] = ACTIONS(2711),
    [anon_sym_enum] = ACTIONS(2711),
    [anon_sym_class] = ACTIONS(2711),
    [anon_sym_struct] = ACTIONS(2711),
    [anon_sym_union] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(2711),
    [anon_sym_else] = ACTIONS(2711),
    [anon_sym_switch] = ACTIONS(2711),
    [anon_sym_case] = ACTIONS(2711),
    [anon_sym_default] = ACTIONS(2711),
    [anon_sym_while] = ACTIONS(2711),
    [anon_sym_do] = ACTIONS(2711),
    [anon_sym_for] = ACTIONS(2711),
    [anon_sym_return] = ACTIONS(2711),
    [anon_sym_break] = ACTIONS(2711),
    [anon_sym_continue] = ACTIONS(2711),
    [anon_sym_goto] = ACTIONS(2711),
    [anon_sym___try] = ACTIONS(2711),
    [anon_sym___leave] = ACTIONS(2711),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_compl] = ACTIONS(2711),
    [anon_sym_DASH_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_PLUS] = ACTIONS(2713),
    [anon_sym_sizeof] = ACTIONS(2711),
    [anon_sym___alignof__] = ACTIONS(2711),
    [anon_sym___alignof] = ACTIONS(2711),
    [anon_sym__alignof] = ACTIONS(2711),
    [anon_sym_alignof] = ACTIONS(2711),
    [anon_sym__Alignof] = ACTIONS(2711),
    [anon_sym_offsetof] = ACTIONS(2711),
    [anon_sym__Generic] = ACTIONS(2711),
    [anon_sym_asm] = ACTIONS(2711),
    [anon_sym___asm__] = ACTIONS(2711),
    [anon_sym___asm] = ACTIONS(2711),
    [sym_number_literal] = ACTIONS(2713),
    [anon_sym_L_SQUOTE] = ACTIONS(2713),
    [anon_sym_u_SQUOTE] = ACTIONS(2713),
    [anon_sym_U_SQUOTE] = ACTIONS(2713),
    [anon_sym_u8_SQUOTE] = ACTIONS(2713),
    [anon_sym_SQUOTE] = ACTIONS(2713),
    [anon_sym_L_DQUOTE] = ACTIONS(2713),
    [anon_sym_u_DQUOTE] = ACTIONS(2713),
    [anon_sym_U_DQUOTE] = ACTIONS(2713),
    [anon_sym_u8_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [sym_true] = ACTIONS(2711),
    [sym_false] = ACTIONS(2711),
    [anon_sym_NULL] = ACTIONS(2711),
    [anon_sym_nullptr] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2711),
    [anon_sym_decltype] = ACTIONS(2711),
    [anon_sym_explicit] = ACTIONS(2711),
    [anon_sym_typename] = ACTIONS(2711),
    [anon_sym_template] = ACTIONS(2711),
    [anon_sym_operator] = ACTIONS(2711),
    [anon_sym_try] = ACTIONS(2711),
    [anon_sym_delete] = ACTIONS(2711),
    [anon_sym_throw] = ACTIONS(2711),
    [anon_sym_namespace] = ACTIONS(2711),
    [anon_sym_static_assert] = ACTIONS(2711),
    [anon_sym_concept] = ACTIONS(2711),
    [anon_sym_co_return] = ACTIONS(2711),
    [anon_sym_co_yield] = ACTIONS(2711),
    [anon_sym_R_DQUOTE] = ACTIONS(2713),
    [anon_sym_LR_DQUOTE] = ACTIONS(2713),
    [anon_sym_uR_DQUOTE] = ACTIONS(2713),
    [anon_sym_UR_DQUOTE] = ACTIONS(2713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2713),
    [anon_sym_co_await] = ACTIONS(2711),
    [anon_sym_new] = ACTIONS(2711),
    [anon_sym_requires] = ACTIONS(2711),
    [sym_this] = ACTIONS(2711),
  },
  [581] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_include_token1] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym___cdecl] = ACTIONS(1940),
    [anon_sym___clrcall] = ACTIONS(1940),
    [anon_sym___stdcall] = ACTIONS(1940),
    [anon_sym___fastcall] = ACTIONS(1940),
    [anon_sym___thiscall] = ACTIONS(1940),
    [anon_sym___vectorcall] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_RBRACE] = ACTIONS(2685),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1940),
    [anon_sym___try] = ACTIONS(1940),
    [anon_sym___leave] = ACTIONS(1940),
    [anon_sym_not] = ACTIONS(1940),
    [anon_sym_compl] = ACTIONS(1940),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_sizeof] = ACTIONS(1940),
    [anon_sym___alignof__] = ACTIONS(1940),
    [anon_sym___alignof] = ACTIONS(1940),
    [anon_sym__alignof] = ACTIONS(1940),
    [anon_sym_alignof] = ACTIONS(1940),
    [anon_sym__Alignof] = ACTIONS(1940),
    [anon_sym_offsetof] = ACTIONS(1940),
    [anon_sym__Generic] = ACTIONS(1940),
    [anon_sym_asm] = ACTIONS(1940),
    [anon_sym___asm__] = ACTIONS(1940),
    [anon_sym___asm] = ACTIONS(1940),
    [sym_number_literal] = ACTIONS(1938),
    [anon_sym_L_SQUOTE] = ACTIONS(1938),
    [anon_sym_u_SQUOTE] = ACTIONS(1938),
    [anon_sym_U_SQUOTE] = ACTIONS(1938),
    [anon_sym_u8_SQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_L_DQUOTE] = ACTIONS(1938),
    [anon_sym_u_DQUOTE] = ACTIONS(1938),
    [anon_sym_U_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8_DQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [anon_sym_NULL] = ACTIONS(1940),
    [anon_sym_nullptr] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_concept] = ACTIONS(1940),
    [anon_sym_co_return] = ACTIONS(1940),
    [anon_sym_co_yield] = ACTIONS(1940),
    [anon_sym_R_DQUOTE] = ACTIONS(1938),
    [anon_sym_LR_DQUOTE] = ACTIONS(1938),
    [anon_sym_uR_DQUOTE] = ACTIONS(1938),
    [anon_sym_UR_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1938),
    [anon_sym_co_await] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_requires] = ACTIONS(1940),
    [sym_this] = ACTIONS(1940),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(2869),
    [sym_identifier] = ACTIONS(2867),
    [aux_sym_preproc_include_token1] = ACTIONS(2867),
    [aux_sym_preproc_def_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token1] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2867),
    [sym_preproc_directive] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2869),
    [anon_sym_BANG] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2869),
    [anon_sym___extension__] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2867),
    [anon_sym_virtual] = ACTIONS(2867),
    [anon_sym_extern] = ACTIONS(2867),
    [anon_sym___attribute__] = ACTIONS(2867),
    [anon_sym___attribute] = ACTIONS(2867),
    [anon_sym_using] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2869),
    [anon_sym___declspec] = ACTIONS(2867),
    [anon_sym___based] = ACTIONS(2867),
    [anon_sym___cdecl] = ACTIONS(2867),
    [anon_sym___clrcall] = ACTIONS(2867),
    [anon_sym___stdcall] = ACTIONS(2867),
    [anon_sym___fastcall] = ACTIONS(2867),
    [anon_sym___thiscall] = ACTIONS(2867),
    [anon_sym___vectorcall] = ACTIONS(2867),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_signed] = ACTIONS(2867),
    [anon_sym_unsigned] = ACTIONS(2867),
    [anon_sym_long] = ACTIONS(2867),
    [anon_sym_short] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2867),
    [anon_sym_register] = ACTIONS(2867),
    [anon_sym_inline] = ACTIONS(2867),
    [anon_sym___inline] = ACTIONS(2867),
    [anon_sym___inline__] = ACTIONS(2867),
    [anon_sym___forceinline] = ACTIONS(2867),
    [anon_sym_thread_local] = ACTIONS(2867),
    [anon_sym___thread] = ACTIONS(2867),
    [anon_sym_const] = ACTIONS(2867),
    [anon_sym_constexpr] = ACTIONS(2867),
    [anon_sym_volatile] = ACTIONS(2867),
    [anon_sym_restrict] = ACTIONS(2867),
    [anon_sym___restrict__] = ACTIONS(2867),
    [anon_sym__Atomic] = ACTIONS(2867),
    [anon_sym__Noreturn] = ACTIONS(2867),
    [anon_sym_noreturn] = ACTIONS(2867),
    [anon_sym__Nonnull] = ACTIONS(2867),
    [anon_sym_mutable] = ACTIONS(2867),
    [anon_sym_constinit] = ACTIONS(2867),
    [anon_sym_consteval] = ACTIONS(2867),
    [anon_sym_alignas] = ACTIONS(2867),
    [anon_sym__Alignas] = ACTIONS(2867),
    [sym_primitive_type] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2867),
    [anon_sym_class] = ACTIONS(2867),
    [anon_sym_struct] = ACTIONS(2867),
    [anon_sym_union] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_switch] = ACTIONS(2867),
    [anon_sym_case] = ACTIONS(2867),
    [anon_sym_default] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_continue] = ACTIONS(2867),
    [anon_sym_goto] = ACTIONS(2867),
    [anon_sym_not] = ACTIONS(2867),
    [anon_sym_compl] = ACTIONS(2867),
    [anon_sym_DASH_DASH] = ACTIONS(2869),
    [anon_sym_PLUS_PLUS] = ACTIONS(2869),
    [anon_sym_sizeof] = ACTIONS(2867),
    [anon_sym___alignof__] = ACTIONS(2867),
    [anon_sym___alignof] = ACTIONS(2867),
    [anon_sym__alignof] = ACTIONS(2867),
    [anon_sym_alignof] = ACTIONS(2867),
    [anon_sym__Alignof] = ACTIONS(2867),
    [anon_sym_offsetof] = ACTIONS(2867),
    [anon_sym__Generic] = ACTIONS(2867),
    [anon_sym_asm] = ACTIONS(2867),
    [anon_sym___asm__] = ACTIONS(2867),
    [anon_sym___asm] = ACTIONS(2867),
    [sym_number_literal] = ACTIONS(2869),
    [anon_sym_L_SQUOTE] = ACTIONS(2869),
    [anon_sym_u_SQUOTE] = ACTIONS(2869),
    [anon_sym_U_SQUOTE] = ACTIONS(2869),
    [anon_sym_u8_SQUOTE] = ACTIONS(2869),
    [anon_sym_SQUOTE] = ACTIONS(2869),
    [anon_sym_L_DQUOTE] = ACTIONS(2869),
    [anon_sym_u_DQUOTE] = ACTIONS(2869),
    [anon_sym_U_DQUOTE] = ACTIONS(2869),
    [anon_sym_u8_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [sym_true] = ACTIONS(2867),
    [sym_false] = ACTIONS(2867),
    [anon_sym_NULL] = ACTIONS(2867),
    [anon_sym_nullptr] = ACTIONS(2867),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2867),
    [anon_sym_decltype] = ACTIONS(2867),
    [anon_sym_explicit] = ACTIONS(2867),
    [anon_sym_typename] = ACTIONS(2867),
    [anon_sym_export] = ACTIONS(2867),
    [anon_sym_module] = ACTIONS(2867),
    [anon_sym_import] = ACTIONS(2867),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_delete] = ACTIONS(2867),
    [anon_sym_throw] = ACTIONS(2867),
    [anon_sym_namespace] = ACTIONS(2867),
    [anon_sym_static_assert] = ACTIONS(2867),
    [anon_sym_concept] = ACTIONS(2867),
    [anon_sym_co_return] = ACTIONS(2867),
    [anon_sym_co_yield] = ACTIONS(2867),
    [anon_sym_R_DQUOTE] = ACTIONS(2869),
    [anon_sym_LR_DQUOTE] = ACTIONS(2869),
    [anon_sym_uR_DQUOTE] = ACTIONS(2869),
    [anon_sym_UR_DQUOTE] = ACTIONS(2869),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2869),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_requires] = ACTIONS(2867),
    [sym_this] = ACTIONS(2867),
  },
  [583] = {
    [sym_identifier] = ACTIONS(2627),
    [aux_sym_preproc_include_token1] = ACTIONS(2627),
    [aux_sym_preproc_def_token1] = ACTIONS(2627),
    [aux_sym_preproc_if_token1] = ACTIONS(2627),
    [aux_sym_preproc_if_token2] = ACTIONS(2627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2627),
    [sym_preproc_directive] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2629),
    [anon_sym_BANG] = ACTIONS(2629),
    [anon_sym_TILDE] = ACTIONS(2629),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2629),
    [anon_sym_AMP_AMP] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_SEMI] = ACTIONS(2629),
    [anon_sym___extension__] = ACTIONS(2627),
    [anon_sym_typedef] = ACTIONS(2627),
    [anon_sym_virtual] = ACTIONS(2627),
    [anon_sym_extern] = ACTIONS(2627),
    [anon_sym___attribute__] = ACTIONS(2627),
    [anon_sym___attribute] = ACTIONS(2627),
    [anon_sym_using] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2629),
    [anon_sym___declspec] = ACTIONS(2627),
    [anon_sym___based] = ACTIONS(2627),
    [anon_sym___cdecl] = ACTIONS(2627),
    [anon_sym___clrcall] = ACTIONS(2627),
    [anon_sym___stdcall] = ACTIONS(2627),
    [anon_sym___fastcall] = ACTIONS(2627),
    [anon_sym___thiscall] = ACTIONS(2627),
    [anon_sym___vectorcall] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2629),
    [anon_sym_signed] = ACTIONS(2627),
    [anon_sym_unsigned] = ACTIONS(2627),
    [anon_sym_long] = ACTIONS(2627),
    [anon_sym_short] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_static] = ACTIONS(2627),
    [anon_sym_register] = ACTIONS(2627),
    [anon_sym_inline] = ACTIONS(2627),
    [anon_sym___inline] = ACTIONS(2627),
    [anon_sym___inline__] = ACTIONS(2627),
    [anon_sym___forceinline] = ACTIONS(2627),
    [anon_sym_thread_local] = ACTIONS(2627),
    [anon_sym___thread] = ACTIONS(2627),
    [anon_sym_const] = ACTIONS(2627),
    [anon_sym_constexpr] = ACTIONS(2627),
    [anon_sym_volatile] = ACTIONS(2627),
    [anon_sym_restrict] = ACTIONS(2627),
    [anon_sym___restrict__] = ACTIONS(2627),
    [anon_sym__Atomic] = ACTIONS(2627),
    [anon_sym__Noreturn] = ACTIONS(2627),
    [anon_sym_noreturn] = ACTIONS(2627),
    [anon_sym__Nonnull] = ACTIONS(2627),
    [anon_sym_mutable] = ACTIONS(2627),
    [anon_sym_constinit] = ACTIONS(2627),
    [anon_sym_consteval] = ACTIONS(2627),
    [anon_sym_alignas] = ACTIONS(2627),
    [anon_sym__Alignas] = ACTIONS(2627),
    [sym_primitive_type] = ACTIONS(2627),
    [anon_sym_enum] = ACTIONS(2627),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_union] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_else] = ACTIONS(2627),
    [anon_sym_switch] = ACTIONS(2627),
    [anon_sym_case] = ACTIONS(2627),
    [anon_sym_default] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_goto] = ACTIONS(2627),
    [anon_sym___try] = ACTIONS(2627),
    [anon_sym___leave] = ACTIONS(2627),
    [anon_sym_not] = ACTIONS(2627),
    [anon_sym_compl] = ACTIONS(2627),
    [anon_sym_DASH_DASH] = ACTIONS(2629),
    [anon_sym_PLUS_PLUS] = ACTIONS(2629),
    [anon_sym_sizeof] = ACTIONS(2627),
    [anon_sym___alignof__] = ACTIONS(2627),
    [anon_sym___alignof] = ACTIONS(2627),
    [anon_sym__alignof] = ACTIONS(2627),
    [anon_sym_alignof] = ACTIONS(2627),
    [anon_sym__Alignof] = ACTIONS(2627),
    [anon_sym_offsetof] = ACTIONS(2627),
    [anon_sym__Generic] = ACTIONS(2627),
    [anon_sym_asm] = ACTIONS(2627),
    [anon_sym___asm__] = ACTIONS(2627),
    [anon_sym___asm] = ACTIONS(2627),
    [sym_number_literal] = ACTIONS(2629),
    [anon_sym_L_SQUOTE] = ACTIONS(2629),
    [anon_sym_u_SQUOTE] = ACTIONS(2629),
    [anon_sym_U_SQUOTE] = ACTIONS(2629),
    [anon_sym_u8_SQUOTE] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2629),
    [anon_sym_L_DQUOTE] = ACTIONS(2629),
    [anon_sym_u_DQUOTE] = ACTIONS(2629),
    [anon_sym_U_DQUOTE] = ACTIONS(2629),
    [anon_sym_u8_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE] = ACTIONS(2629),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [anon_sym_NULL] = ACTIONS(2627),
    [anon_sym_nullptr] = ACTIONS(2627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2627),
    [anon_sym_decltype] = ACTIONS(2627),
    [anon_sym_explicit] = ACTIONS(2627),
    [anon_sym_typename] = ACTIONS(2627),
    [anon_sym_template] = ACTIONS(2627),
    [anon_sym_operator] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_delete] = ACTIONS(2627),
    [anon_sym_throw] = ACTIONS(2627),
    [anon_sym_namespace] = ACTIONS(2627),
    [anon_sym_static_assert] = ACTIONS(2627),
    [anon_sym_concept] = ACTIONS(2627),
    [anon_sym_co_return] = ACTIONS(2627),
    [anon_sym_co_yield] = ACTIONS(2627),
    [anon_sym_R_DQUOTE] = ACTIONS(2629),
    [anon_sym_LR_DQUOTE] = ACTIONS(2629),
    [anon_sym_uR_DQUOTE] = ACTIONS(2629),
    [anon_sym_UR_DQUOTE] = ACTIONS(2629),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2629),
    [anon_sym_co_await] = ACTIONS(2627),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_requires] = ACTIONS(2627),
    [sym_this] = ACTIONS(2627),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(3091),
    [sym_identifier] = ACTIONS(3089),
    [aux_sym_preproc_include_token1] = ACTIONS(3089),
    [aux_sym_preproc_def_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token1] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3089),
    [sym_preproc_directive] = ACTIONS(3089),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_STAR] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym___extension__] = ACTIONS(3089),
    [anon_sym_typedef] = ACTIONS(3089),
    [anon_sym_virtual] = ACTIONS(3089),
    [anon_sym_extern] = ACTIONS(3089),
    [anon_sym___attribute__] = ACTIONS(3089),
    [anon_sym___attribute] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_COLON_COLON] = ACTIONS(3091),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3091),
    [anon_sym___declspec] = ACTIONS(3089),
    [anon_sym___based] = ACTIONS(3089),
    [anon_sym___cdecl] = ACTIONS(3089),
    [anon_sym___clrcall] = ACTIONS(3089),
    [anon_sym___stdcall] = ACTIONS(3089),
    [anon_sym___fastcall] = ACTIONS(3089),
    [anon_sym___thiscall] = ACTIONS(3089),
    [anon_sym___vectorcall] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_signed] = ACTIONS(3089),
    [anon_sym_unsigned] = ACTIONS(3089),
    [anon_sym_long] = ACTIONS(3089),
    [anon_sym_short] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3089),
    [anon_sym_register] = ACTIONS(3089),
    [anon_sym_inline] = ACTIONS(3089),
    [anon_sym___inline] = ACTIONS(3089),
    [anon_sym___inline__] = ACTIONS(3089),
    [anon_sym___forceinline] = ACTIONS(3089),
    [anon_sym_thread_local] = ACTIONS(3089),
    [anon_sym___thread] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_constexpr] = ACTIONS(3089),
    [anon_sym_volatile] = ACTIONS(3089),
    [anon_sym_restrict] = ACTIONS(3089),
    [anon_sym___restrict__] = ACTIONS(3089),
    [anon_sym__Atomic] = ACTIONS(3089),
    [anon_sym__Noreturn] = ACTIONS(3089),
    [anon_sym_noreturn] = ACTIONS(3089),
    [anon_sym__Nonnull] = ACTIONS(3089),
    [anon_sym_mutable] = ACTIONS(3089),
    [anon_sym_constinit] = ACTIONS(3089),
    [anon_sym_consteval] = ACTIONS(3089),
    [anon_sym_alignas] = ACTIONS(3089),
    [anon_sym__Alignas] = ACTIONS(3089),
    [sym_primitive_type] = ACTIONS(3089),
    [anon_sym_enum] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_union] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_switch] = ACTIONS(3089),
    [anon_sym_case] = ACTIONS(3089),
    [anon_sym_default] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [anon_sym_do] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_break] = ACTIONS(3089),
    [anon_sym_continue] = ACTIONS(3089),
    [anon_sym_goto] = ACTIONS(3089),
    [anon_sym_not] = ACTIONS(3089),
    [anon_sym_compl] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_sizeof] = ACTIONS(3089),
    [anon_sym___alignof__] = ACTIONS(3089),
    [anon_sym___alignof] = ACTIONS(3089),
    [anon_sym__alignof] = ACTIONS(3089),
    [anon_sym_alignof] = ACTIONS(3089),
    [anon_sym__Alignof] = ACTIONS(3089),
    [anon_sym_offsetof] = ACTIONS(3089),
    [anon_sym__Generic] = ACTIONS(3089),
    [anon_sym_asm] = ACTIONS(3089),
    [anon_sym___asm__] = ACTIONS(3089),
    [anon_sym___asm] = ACTIONS(3089),
    [sym_number_literal] = ACTIONS(3091),
    [anon_sym_L_SQUOTE] = ACTIONS(3091),
    [anon_sym_u_SQUOTE] = ACTIONS(3091),
    [anon_sym_U_SQUOTE] = ACTIONS(3091),
    [anon_sym_u8_SQUOTE] = ACTIONS(3091),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [anon_sym_L_DQUOTE] = ACTIONS(3091),
    [anon_sym_u_DQUOTE] = ACTIONS(3091),
    [anon_sym_U_DQUOTE] = ACTIONS(3091),
    [anon_sym_u8_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [sym_true] = ACTIONS(3089),
    [sym_false] = ACTIONS(3089),
    [anon_sym_NULL] = ACTIONS(3089),
    [anon_sym_nullptr] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3089),
    [anon_sym_decltype] = ACTIONS(3089),
    [anon_sym_explicit] = ACTIONS(3089),
    [anon_sym_typename] = ACTIONS(3089),
    [anon_sym_export] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(3089),
    [anon_sym_import] = ACTIONS(3089),
    [anon_sym_template] = ACTIONS(3089),
    [anon_sym_operator] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_delete] = ACTIONS(3089),
    [anon_sym_throw] = ACTIONS(3089),
    [anon_sym_namespace] = ACTIONS(3089),
    [anon_sym_static_assert] = ACTIONS(3089),
    [anon_sym_concept] = ACTIONS(3089),
    [anon_sym_co_return] = ACTIONS(3089),
    [anon_sym_co_yield] = ACTIONS(3089),
    [anon_sym_R_DQUOTE] = ACTIONS(3091),
    [anon_sym_LR_DQUOTE] = ACTIONS(3091),
    [anon_sym_uR_DQUOTE] = ACTIONS(3091),
    [anon_sym_UR_DQUOTE] = ACTIONS(3091),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3091),
    [anon_sym_co_await] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3089),
    [anon_sym_requires] = ACTIONS(3089),
    [sym_this] = ACTIONS(3089),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(3095),
    [sym_identifier] = ACTIONS(3093),
    [aux_sym_preproc_include_token1] = ACTIONS(3093),
    [aux_sym_preproc_def_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token1] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3093),
    [sym_preproc_directive] = ACTIONS(3093),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym___extension__] = ACTIONS(3093),
    [anon_sym_typedef] = ACTIONS(3093),
    [anon_sym_virtual] = ACTIONS(3093),
    [anon_sym_extern] = ACTIONS(3093),
    [anon_sym___attribute__] = ACTIONS(3093),
    [anon_sym___attribute] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_COLON_COLON] = ACTIONS(3095),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3095),
    [anon_sym___declspec] = ACTIONS(3093),
    [anon_sym___based] = ACTIONS(3093),
    [anon_sym___cdecl] = ACTIONS(3093),
    [anon_sym___clrcall] = ACTIONS(3093),
    [anon_sym___stdcall] = ACTIONS(3093),
    [anon_sym___fastcall] = ACTIONS(3093),
    [anon_sym___thiscall] = ACTIONS(3093),
    [anon_sym___vectorcall] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_signed] = ACTIONS(3093),
    [anon_sym_unsigned] = ACTIONS(3093),
    [anon_sym_long] = ACTIONS(3093),
    [anon_sym_short] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3093),
    [anon_sym_register] = ACTIONS(3093),
    [anon_sym_inline] = ACTIONS(3093),
    [anon_sym___inline] = ACTIONS(3093),
    [anon_sym___inline__] = ACTIONS(3093),
    [anon_sym___forceinline] = ACTIONS(3093),
    [anon_sym_thread_local] = ACTIONS(3093),
    [anon_sym___thread] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_constexpr] = ACTIONS(3093),
    [anon_sym_volatile] = ACTIONS(3093),
    [anon_sym_restrict] = ACTIONS(3093),
    [anon_sym___restrict__] = ACTIONS(3093),
    [anon_sym__Atomic] = ACTIONS(3093),
    [anon_sym__Noreturn] = ACTIONS(3093),
    [anon_sym_noreturn] = ACTIONS(3093),
    [anon_sym__Nonnull] = ACTIONS(3093),
    [anon_sym_mutable] = ACTIONS(3093),
    [anon_sym_constinit] = ACTIONS(3093),
    [anon_sym_consteval] = ACTIONS(3093),
    [anon_sym_alignas] = ACTIONS(3093),
    [anon_sym__Alignas] = ACTIONS(3093),
    [sym_primitive_type] = ACTIONS(3093),
    [anon_sym_enum] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_union] = ACTIONS(3093),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_switch] = ACTIONS(3093),
    [anon_sym_case] = ACTIONS(3093),
    [anon_sym_default] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [anon_sym_do] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_break] = ACTIONS(3093),
    [anon_sym_continue] = ACTIONS(3093),
    [anon_sym_goto] = ACTIONS(3093),
    [anon_sym_not] = ACTIONS(3093),
    [anon_sym_compl] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3095),
    [anon_sym_sizeof] = ACTIONS(3093),
    [anon_sym___alignof__] = ACTIONS(3093),
    [anon_sym___alignof] = ACTIONS(3093),
    [anon_sym__alignof] = ACTIONS(3093),
    [anon_sym_alignof] = ACTIONS(3093),
    [anon_sym__Alignof] = ACTIONS(3093),
    [anon_sym_offsetof] = ACTIONS(3093),
    [anon_sym__Generic] = ACTIONS(3093),
    [anon_sym_asm] = ACTIONS(3093),
    [anon_sym___asm__] = ACTIONS(3093),
    [anon_sym___asm] = ACTIONS(3093),
    [sym_number_literal] = ACTIONS(3095),
    [anon_sym_L_SQUOTE] = ACTIONS(3095),
    [anon_sym_u_SQUOTE] = ACTIONS(3095),
    [anon_sym_U_SQUOTE] = ACTIONS(3095),
    [anon_sym_u8_SQUOTE] = ACTIONS(3095),
    [anon_sym_SQUOTE] = ACTIONS(3095),
    [anon_sym_L_DQUOTE] = ACTIONS(3095),
    [anon_sym_u_DQUOTE] = ACTIONS(3095),
    [anon_sym_U_DQUOTE] = ACTIONS(3095),
    [anon_sym_u8_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [sym_true] = ACTIONS(3093),
    [sym_false] = ACTIONS(3093),
    [anon_sym_NULL] = ACTIONS(3093),
    [anon_sym_nullptr] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3093),
    [anon_sym_decltype] = ACTIONS(3093),
    [anon_sym_explicit] = ACTIONS(3093),
    [anon_sym_typename] = ACTIONS(3093),
    [anon_sym_export] = ACTIONS(3093),
    [anon_sym_module] = ACTIONS(3093),
    [anon_sym_import] = ACTIONS(3093),
    [anon_sym_template] = ACTIONS(3093),
    [anon_sym_operator] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_delete] = ACTIONS(3093),
    [anon_sym_throw] = ACTIONS(3093),
    [anon_sym_namespace] = ACTIONS(3093),
    [anon_sym_static_assert] = ACTIONS(3093),
    [anon_sym_concept] = ACTIONS(3093),
    [anon_sym_co_return] = ACTIONS(3093),
    [anon_sym_co_yield] = ACTIONS(3093),
    [anon_sym_R_DQUOTE] = ACTIONS(3095),
    [anon_sym_LR_DQUOTE] = ACTIONS(3095),
    [anon_sym_uR_DQUOTE] = ACTIONS(3095),
    [anon_sym_UR_DQUOTE] = ACTIONS(3095),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3095),
    [anon_sym_co_await] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3093),
    [anon_sym_requires] = ACTIONS(3093),
    [sym_this] = ACTIONS(3093),
  },
  [586] = {
    [sym_identifier] = ACTIONS(2691),
    [aux_sym_preproc_include_token1] = ACTIONS(2691),
    [aux_sym_preproc_def_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token2] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2691),
    [sym_preproc_directive] = ACTIONS(2691),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym___extension__] = ACTIONS(2691),
    [anon_sym_typedef] = ACTIONS(2691),
    [anon_sym_virtual] = ACTIONS(2691),
    [anon_sym_extern] = ACTIONS(2691),
    [anon_sym___attribute__] = ACTIONS(2691),
    [anon_sym___attribute] = ACTIONS(2691),
    [anon_sym_using] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2693),
    [anon_sym___declspec] = ACTIONS(2691),
    [anon_sym___based] = ACTIONS(2691),
    [anon_sym___cdecl] = ACTIONS(2691),
    [anon_sym___clrcall] = ACTIONS(2691),
    [anon_sym___stdcall] = ACTIONS(2691),
    [anon_sym___fastcall] = ACTIONS(2691),
    [anon_sym___thiscall] = ACTIONS(2691),
    [anon_sym___vectorcall] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_signed] = ACTIONS(2691),
    [anon_sym_unsigned] = ACTIONS(2691),
    [anon_sym_long] = ACTIONS(2691),
    [anon_sym_short] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2691),
    [anon_sym_register] = ACTIONS(2691),
    [anon_sym_inline] = ACTIONS(2691),
    [anon_sym___inline] = ACTIONS(2691),
    [anon_sym___inline__] = ACTIONS(2691),
    [anon_sym___forceinline] = ACTIONS(2691),
    [anon_sym_thread_local] = ACTIONS(2691),
    [anon_sym___thread] = ACTIONS(2691),
    [anon_sym_const] = ACTIONS(2691),
    [anon_sym_constexpr] = ACTIONS(2691),
    [anon_sym_volatile] = ACTIONS(2691),
    [anon_sym_restrict] = ACTIONS(2691),
    [anon_sym___restrict__] = ACTIONS(2691),
    [anon_sym__Atomic] = ACTIONS(2691),
    [anon_sym__Noreturn] = ACTIONS(2691),
    [anon_sym_noreturn] = ACTIONS(2691),
    [anon_sym__Nonnull] = ACTIONS(2691),
    [anon_sym_mutable] = ACTIONS(2691),
    [anon_sym_constinit] = ACTIONS(2691),
    [anon_sym_consteval] = ACTIONS(2691),
    [anon_sym_alignas] = ACTIONS(2691),
    [anon_sym__Alignas] = ACTIONS(2691),
    [sym_primitive_type] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2691),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_union] = ACTIONS(2691),
    [anon_sym_if] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2691),
    [anon_sym_switch] = ACTIONS(2691),
    [anon_sym_case] = ACTIONS(2691),
    [anon_sym_default] = ACTIONS(2691),
    [anon_sym_while] = ACTIONS(2691),
    [anon_sym_do] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2691),
    [anon_sym_return] = ACTIONS(2691),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_continue] = ACTIONS(2691),
    [anon_sym_goto] = ACTIONS(2691),
    [anon_sym___try] = ACTIONS(2691),
    [anon_sym___leave] = ACTIONS(2691),
    [anon_sym_not] = ACTIONS(2691),
    [anon_sym_compl] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_sizeof] = ACTIONS(2691),
    [anon_sym___alignof__] = ACTIONS(2691),
    [anon_sym___alignof] = ACTIONS(2691),
    [anon_sym__alignof] = ACTIONS(2691),
    [anon_sym_alignof] = ACTIONS(2691),
    [anon_sym__Alignof] = ACTIONS(2691),
    [anon_sym_offsetof] = ACTIONS(2691),
    [anon_sym__Generic] = ACTIONS(2691),
    [anon_sym_asm] = ACTIONS(2691),
    [anon_sym___asm__] = ACTIONS(2691),
    [anon_sym___asm] = ACTIONS(2691),
    [sym_number_literal] = ACTIONS(2693),
    [anon_sym_L_SQUOTE] = ACTIONS(2693),
    [anon_sym_u_SQUOTE] = ACTIONS(2693),
    [anon_sym_U_SQUOTE] = ACTIONS(2693),
    [anon_sym_u8_SQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_L_DQUOTE] = ACTIONS(2693),
    [anon_sym_u_DQUOTE] = ACTIONS(2693),
    [anon_sym_U_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8_DQUOTE] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [anon_sym_NULL] = ACTIONS(2691),
    [anon_sym_nullptr] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2691),
    [anon_sym_decltype] = ACTIONS(2691),
    [anon_sym_explicit] = ACTIONS(2691),
    [anon_sym_typename] = ACTIONS(2691),
    [anon_sym_template] = ACTIONS(2691),
    [anon_sym_operator] = ACTIONS(2691),
    [anon_sym_try] = ACTIONS(2691),
    [anon_sym_delete] = ACTIONS(2691),
    [anon_sym_throw] = ACTIONS(2691),
    [anon_sym_namespace] = ACTIONS(2691),
    [anon_sym_static_assert] = ACTIONS(2691),
    [anon_sym_concept] = ACTIONS(2691),
    [anon_sym_co_return] = ACTIONS(2691),
    [anon_sym_co_yield] = ACTIONS(2691),
    [anon_sym_R_DQUOTE] = ACTIONS(2693),
    [anon_sym_LR_DQUOTE] = ACTIONS(2693),
    [anon_sym_uR_DQUOTE] = ACTIONS(2693),
    [anon_sym_UR_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2693),
    [anon_sym_co_await] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2691),
    [anon_sym_requires] = ACTIONS(2691),
    [sym_this] = ACTIONS(2691),
  },
  [587] = {
    [sym_preproc_def] = STATE(587),
    [sym_preproc_function_def] = STATE(587),
    [sym_preproc_call] = STATE(587),
    [sym_preproc_if_in_field_declaration_list] = STATE(587),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(587),
    [sym_type_definition] = STATE(587),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5637),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(587),
    [sym_field_declaration] = STATE(587),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(587),
    [sym_operator_cast] = STATE(6834),
    [sym_inline_method_definition] = STATE(587),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(587),
    [sym_operator_cast_declaration] = STATE(587),
    [sym_constructor_or_destructor_definition] = STATE(587),
    [sym_constructor_or_destructor_declaration] = STATE(587),
    [sym_friend_declaration] = STATE(587),
    [sym_access_specifier] = STATE(8733),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(587),
    [sym_alias_declaration] = STATE(587),
    [sym_static_assert_declaration] = STATE(587),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(587),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7128),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(3449),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token2] = ACTIONS(3458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3460),
    [aux_sym_preproc_else_token1] = ACTIONS(3458),
    [aux_sym_preproc_elif_token1] = ACTIONS(3458),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3458),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3458),
    [sym_preproc_directive] = ACTIONS(3463),
    [anon_sym_LPAREN2] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3475),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3481),
    [anon_sym___extension__] = ACTIONS(3484),
    [anon_sym_typedef] = ACTIONS(3487),
    [anon_sym_virtual] = ACTIONS(3490),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym___attribute__] = ACTIONS(3496),
    [anon_sym___attribute] = ACTIONS(3496),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3508),
    [anon_sym___based] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3514),
    [anon_sym_unsigned] = ACTIONS(3514),
    [anon_sym_long] = ACTIONS(3514),
    [anon_sym_short] = ACTIONS(3514),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_register] = ACTIONS(3493),
    [anon_sym_inline] = ACTIONS(3493),
    [anon_sym___inline] = ACTIONS(3493),
    [anon_sym___inline__] = ACTIONS(3493),
    [anon_sym___forceinline] = ACTIONS(3493),
    [anon_sym_thread_local] = ACTIONS(3493),
    [anon_sym___thread] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3520),
    [anon_sym_constexpr] = ACTIONS(3523),
    [anon_sym_volatile] = ACTIONS(3520),
    [anon_sym_restrict] = ACTIONS(3520),
    [anon_sym___restrict__] = ACTIONS(3520),
    [anon_sym__Atomic] = ACTIONS(3520),
    [anon_sym__Noreturn] = ACTIONS(3520),
    [anon_sym_noreturn] = ACTIONS(3520),
    [anon_sym__Nonnull] = ACTIONS(3520),
    [anon_sym_mutable] = ACTIONS(3520),
    [anon_sym_constinit] = ACTIONS(3520),
    [anon_sym_consteval] = ACTIONS(3520),
    [anon_sym_alignas] = ACTIONS(3526),
    [anon_sym__Alignas] = ACTIONS(3526),
    [sym_primitive_type] = ACTIONS(3529),
    [anon_sym_enum] = ACTIONS(3532),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3538),
    [anon_sym_union] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3544),
    [anon_sym_decltype] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3550),
    [anon_sym_typename] = ACTIONS(3553),
    [anon_sym_private] = ACTIONS(3556),
    [anon_sym_template] = ACTIONS(3559),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3565),
    [anon_sym_public] = ACTIONS(3556),
    [anon_sym_protected] = ACTIONS(3556),
    [anon_sym_static_assert] = ACTIONS(3568),
  },
  [588] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym___attribute] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym__Nonnull] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym__Alignas] = ACTIONS(2643),
    [sym_primitive_type] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [anon_sym___asm] = ACTIONS(2643),
    [sym_number_literal] = ACTIONS(2645),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [589] = {
    [sym_identifier] = ACTIONS(2695),
    [aux_sym_preproc_include_token1] = ACTIONS(2695),
    [aux_sym_preproc_def_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token2] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2695),
    [sym_preproc_directive] = ACTIONS(2695),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym___extension__] = ACTIONS(2695),
    [anon_sym_typedef] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym___attribute__] = ACTIONS(2695),
    [anon_sym___attribute] = ACTIONS(2695),
    [anon_sym_using] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2697),
    [anon_sym___declspec] = ACTIONS(2695),
    [anon_sym___based] = ACTIONS(2695),
    [anon_sym___cdecl] = ACTIONS(2695),
    [anon_sym___clrcall] = ACTIONS(2695),
    [anon_sym___stdcall] = ACTIONS(2695),
    [anon_sym___fastcall] = ACTIONS(2695),
    [anon_sym___thiscall] = ACTIONS(2695),
    [anon_sym___vectorcall] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_signed] = ACTIONS(2695),
    [anon_sym_unsigned] = ACTIONS(2695),
    [anon_sym_long] = ACTIONS(2695),
    [anon_sym_short] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym___inline] = ACTIONS(2695),
    [anon_sym___inline__] = ACTIONS(2695),
    [anon_sym___forceinline] = ACTIONS(2695),
    [anon_sym_thread_local] = ACTIONS(2695),
    [anon_sym___thread] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym___restrict__] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym__Noreturn] = ACTIONS(2695),
    [anon_sym_noreturn] = ACTIONS(2695),
    [anon_sym__Nonnull] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_constinit] = ACTIONS(2695),
    [anon_sym_consteval] = ACTIONS(2695),
    [anon_sym_alignas] = ACTIONS(2695),
    [anon_sym__Alignas] = ACTIONS(2695),
    [sym_primitive_type] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2695),
    [anon_sym_union] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_case] = ACTIONS(2695),
    [anon_sym_default] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_goto] = ACTIONS(2695),
    [anon_sym___try] = ACTIONS(2695),
    [anon_sym___leave] = ACTIONS(2695),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_compl] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_sizeof] = ACTIONS(2695),
    [anon_sym___alignof__] = ACTIONS(2695),
    [anon_sym___alignof] = ACTIONS(2695),
    [anon_sym__alignof] = ACTIONS(2695),
    [anon_sym_alignof] = ACTIONS(2695),
    [anon_sym__Alignof] = ACTIONS(2695),
    [anon_sym_offsetof] = ACTIONS(2695),
    [anon_sym__Generic] = ACTIONS(2695),
    [anon_sym_asm] = ACTIONS(2695),
    [anon_sym___asm__] = ACTIONS(2695),
    [anon_sym___asm] = ACTIONS(2695),
    [sym_number_literal] = ACTIONS(2697),
    [anon_sym_L_SQUOTE] = ACTIONS(2697),
    [anon_sym_u_SQUOTE] = ACTIONS(2697),
    [anon_sym_U_SQUOTE] = ACTIONS(2697),
    [anon_sym_u8_SQUOTE] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_L_DQUOTE] = ACTIONS(2697),
    [anon_sym_u_DQUOTE] = ACTIONS(2697),
    [anon_sym_U_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [anon_sym_NULL] = ACTIONS(2695),
    [anon_sym_nullptr] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2695),
    [anon_sym_decltype] = ACTIONS(2695),
    [anon_sym_explicit] = ACTIONS(2695),
    [anon_sym_typename] = ACTIONS(2695),
    [anon_sym_template] = ACTIONS(2695),
    [anon_sym_operator] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_static_assert] = ACTIONS(2695),
    [anon_sym_concept] = ACTIONS(2695),
    [anon_sym_co_return] = ACTIONS(2695),
    [anon_sym_co_yield] = ACTIONS(2695),
    [anon_sym_R_DQUOTE] = ACTIONS(2697),
    [anon_sym_LR_DQUOTE] = ACTIONS(2697),
    [anon_sym_uR_DQUOTE] = ACTIONS(2697),
    [anon_sym_UR_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2697),
    [anon_sym_co_await] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_requires] = ACTIONS(2695),
    [sym_this] = ACTIONS(2695),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(3571),
    [sym_identifier] = ACTIONS(3573),
    [aux_sym_preproc_include_token1] = ACTIONS(3573),
    [aux_sym_preproc_def_token1] = ACTIONS(3573),
    [aux_sym_preproc_if_token1] = ACTIONS(3573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3573),
    [sym_preproc_directive] = ACTIONS(3573),
    [anon_sym_LPAREN2] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3571),
    [anon_sym_TILDE] = ACTIONS(3571),
    [anon_sym_DASH] = ACTIONS(3573),
    [anon_sym_PLUS] = ACTIONS(3573),
    [anon_sym_STAR] = ACTIONS(3571),
    [anon_sym_AMP_AMP] = ACTIONS(3571),
    [anon_sym_AMP] = ACTIONS(3573),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym___extension__] = ACTIONS(3573),
    [anon_sym_typedef] = ACTIONS(3573),
    [anon_sym_virtual] = ACTIONS(3573),
    [anon_sym_extern] = ACTIONS(3573),
    [anon_sym___attribute__] = ACTIONS(3573),
    [anon_sym___attribute] = ACTIONS(3573),
    [anon_sym_using] = ACTIONS(3573),
    [anon_sym_COLON_COLON] = ACTIONS(3571),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3571),
    [anon_sym___declspec] = ACTIONS(3573),
    [anon_sym___based] = ACTIONS(3573),
    [anon_sym___cdecl] = ACTIONS(3573),
    [anon_sym___clrcall] = ACTIONS(3573),
    [anon_sym___stdcall] = ACTIONS(3573),
    [anon_sym___fastcall] = ACTIONS(3573),
    [anon_sym___thiscall] = ACTIONS(3573),
    [anon_sym___vectorcall] = ACTIONS(3573),
    [anon_sym_LBRACE] = ACTIONS(3571),
    [anon_sym_signed] = ACTIONS(3573),
    [anon_sym_unsigned] = ACTIONS(3573),
    [anon_sym_long] = ACTIONS(3573),
    [anon_sym_short] = ACTIONS(3573),
    [anon_sym_LBRACK] = ACTIONS(3573),
    [anon_sym_static] = ACTIONS(3573),
    [anon_sym_register] = ACTIONS(3573),
    [anon_sym_inline] = ACTIONS(3573),
    [anon_sym___inline] = ACTIONS(3573),
    [anon_sym___inline__] = ACTIONS(3573),
    [anon_sym___forceinline] = ACTIONS(3573),
    [anon_sym_thread_local] = ACTIONS(3573),
    [anon_sym___thread] = ACTIONS(3573),
    [anon_sym_const] = ACTIONS(3573),
    [anon_sym_constexpr] = ACTIONS(3573),
    [anon_sym_volatile] = ACTIONS(3573),
    [anon_sym_restrict] = ACTIONS(3573),
    [anon_sym___restrict__] = ACTIONS(3573),
    [anon_sym__Atomic] = ACTIONS(3573),
    [anon_sym__Noreturn] = ACTIONS(3573),
    [anon_sym_noreturn] = ACTIONS(3573),
    [anon_sym__Nonnull] = ACTIONS(3573),
    [anon_sym_mutable] = ACTIONS(3573),
    [anon_sym_constinit] = ACTIONS(3573),
    [anon_sym_consteval] = ACTIONS(3573),
    [anon_sym_alignas] = ACTIONS(3573),
    [anon_sym__Alignas] = ACTIONS(3573),
    [sym_primitive_type] = ACTIONS(3573),
    [anon_sym_enum] = ACTIONS(3573),
    [anon_sym_class] = ACTIONS(3573),
    [anon_sym_struct] = ACTIONS(3573),
    [anon_sym_union] = ACTIONS(3573),
    [anon_sym_if] = ACTIONS(3573),
    [anon_sym_switch] = ACTIONS(3573),
    [anon_sym_case] = ACTIONS(3573),
    [anon_sym_default] = ACTIONS(3573),
    [anon_sym_while] = ACTIONS(3573),
    [anon_sym_do] = ACTIONS(3573),
    [anon_sym_for] = ACTIONS(3573),
    [anon_sym_return] = ACTIONS(3573),
    [anon_sym_break] = ACTIONS(3573),
    [anon_sym_continue] = ACTIONS(3573),
    [anon_sym_goto] = ACTIONS(3573),
    [anon_sym_not] = ACTIONS(3573),
    [anon_sym_compl] = ACTIONS(3573),
    [anon_sym_DASH_DASH] = ACTIONS(3571),
    [anon_sym_PLUS_PLUS] = ACTIONS(3571),
    [anon_sym_sizeof] = ACTIONS(3573),
    [anon_sym___alignof__] = ACTIONS(3573),
    [anon_sym___alignof] = ACTIONS(3573),
    [anon_sym__alignof] = ACTIONS(3573),
    [anon_sym_alignof] = ACTIONS(3573),
    [anon_sym__Alignof] = ACTIONS(3573),
    [anon_sym_offsetof] = ACTIONS(3573),
    [anon_sym__Generic] = ACTIONS(3573),
    [anon_sym_asm] = ACTIONS(3573),
    [anon_sym___asm__] = ACTIONS(3573),
    [anon_sym___asm] = ACTIONS(3573),
    [sym_number_literal] = ACTIONS(3571),
    [anon_sym_L_SQUOTE] = ACTIONS(3571),
    [anon_sym_u_SQUOTE] = ACTIONS(3571),
    [anon_sym_U_SQUOTE] = ACTIONS(3571),
    [anon_sym_u8_SQUOTE] = ACTIONS(3571),
    [anon_sym_SQUOTE] = ACTIONS(3571),
    [anon_sym_L_DQUOTE] = ACTIONS(3571),
    [anon_sym_u_DQUOTE] = ACTIONS(3571),
    [anon_sym_U_DQUOTE] = ACTIONS(3571),
    [anon_sym_u8_DQUOTE] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(3571),
    [sym_true] = ACTIONS(3573),
    [sym_false] = ACTIONS(3573),
    [anon_sym_NULL] = ACTIONS(3573),
    [anon_sym_nullptr] = ACTIONS(3573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3573),
    [anon_sym_decltype] = ACTIONS(3573),
    [anon_sym_explicit] = ACTIONS(3573),
    [anon_sym_typename] = ACTIONS(3573),
    [anon_sym_export] = ACTIONS(3573),
    [anon_sym_module] = ACTIONS(3573),
    [anon_sym_import] = ACTIONS(3573),
    [anon_sym_template] = ACTIONS(3573),
    [anon_sym_operator] = ACTIONS(3573),
    [anon_sym_try] = ACTIONS(3573),
    [anon_sym_delete] = ACTIONS(3573),
    [anon_sym_throw] = ACTIONS(3573),
    [anon_sym_namespace] = ACTIONS(3573),
    [anon_sym_static_assert] = ACTIONS(3573),
    [anon_sym_concept] = ACTIONS(3573),
    [anon_sym_co_return] = ACTIONS(3573),
    [anon_sym_co_yield] = ACTIONS(3573),
    [anon_sym_R_DQUOTE] = ACTIONS(3571),
    [anon_sym_LR_DQUOTE] = ACTIONS(3571),
    [anon_sym_uR_DQUOTE] = ACTIONS(3571),
    [anon_sym_UR_DQUOTE] = ACTIONS(3571),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3571),
    [anon_sym_co_await] = ACTIONS(3573),
    [anon_sym_new] = ACTIONS(3573),
    [anon_sym_requires] = ACTIONS(3573),
    [sym_this] = ACTIONS(3573),
  },
  [591] = {
    [sym_identifier] = ACTIONS(2727),
    [aux_sym_preproc_include_token1] = ACTIONS(2727),
    [aux_sym_preproc_def_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym___extension__] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_virtual] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym___attribute__] = ACTIONS(2727),
    [anon_sym___attribute] = ACTIONS(2727),
    [anon_sym_using] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2729),
    [anon_sym___declspec] = ACTIONS(2727),
    [anon_sym___based] = ACTIONS(2727),
    [anon_sym___cdecl] = ACTIONS(2727),
    [anon_sym___clrcall] = ACTIONS(2727),
    [anon_sym___stdcall] = ACTIONS(2727),
    [anon_sym___fastcall] = ACTIONS(2727),
    [anon_sym___thiscall] = ACTIONS(2727),
    [anon_sym___vectorcall] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_signed] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym___inline] = ACTIONS(2727),
    [anon_sym___inline__] = ACTIONS(2727),
    [anon_sym___forceinline] = ACTIONS(2727),
    [anon_sym_thread_local] = ACTIONS(2727),
    [anon_sym___thread] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_constexpr] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym___restrict__] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym__Noreturn] = ACTIONS(2727),
    [anon_sym_noreturn] = ACTIONS(2727),
    [anon_sym__Nonnull] = ACTIONS(2727),
    [anon_sym_mutable] = ACTIONS(2727),
    [anon_sym_constinit] = ACTIONS(2727),
    [anon_sym_consteval] = ACTIONS(2727),
    [anon_sym_alignas] = ACTIONS(2727),
    [anon_sym__Alignas] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_else] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym___try] = ACTIONS(2727),
    [anon_sym___leave] = ACTIONS(2727),
    [anon_sym_not] = ACTIONS(2727),
    [anon_sym_compl] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [anon_sym___alignof__] = ACTIONS(2727),
    [anon_sym___alignof] = ACTIONS(2727),
    [anon_sym__alignof] = ACTIONS(2727),
    [anon_sym_alignof] = ACTIONS(2727),
    [anon_sym__Alignof] = ACTIONS(2727),
    [anon_sym_offsetof] = ACTIONS(2727),
    [anon_sym__Generic] = ACTIONS(2727),
    [anon_sym_asm] = ACTIONS(2727),
    [anon_sym___asm__] = ACTIONS(2727),
    [anon_sym___asm] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [anon_sym_L_SQUOTE] = ACTIONS(2729),
    [anon_sym_u_SQUOTE] = ACTIONS(2729),
    [anon_sym_U_SQUOTE] = ACTIONS(2729),
    [anon_sym_u8_SQUOTE] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_L_DQUOTE] = ACTIONS(2729),
    [anon_sym_u_DQUOTE] = ACTIONS(2729),
    [anon_sym_U_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [anon_sym_NULL] = ACTIONS(2727),
    [anon_sym_nullptr] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2727),
    [anon_sym_decltype] = ACTIONS(2727),
    [anon_sym_explicit] = ACTIONS(2727),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_template] = ACTIONS(2727),
    [anon_sym_operator] = ACTIONS(2727),
    [anon_sym_try] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2727),
    [anon_sym_throw] = ACTIONS(2727),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_static_assert] = ACTIONS(2727),
    [anon_sym_concept] = ACTIONS(2727),
    [anon_sym_co_return] = ACTIONS(2727),
    [anon_sym_co_yield] = ACTIONS(2727),
    [anon_sym_R_DQUOTE] = ACTIONS(2729),
    [anon_sym_LR_DQUOTE] = ACTIONS(2729),
    [anon_sym_uR_DQUOTE] = ACTIONS(2729),
    [anon_sym_UR_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2729),
    [anon_sym_co_await] = ACTIONS(2727),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_requires] = ACTIONS(2727),
    [sym_this] = ACTIONS(2727),
  },
  [592] = {
    [sym_identifier] = ACTIONS(2719),
    [aux_sym_preproc_include_token1] = ACTIONS(2719),
    [aux_sym_preproc_def_token1] = ACTIONS(2719),
    [aux_sym_preproc_if_token1] = ACTIONS(2719),
    [aux_sym_preproc_if_token2] = ACTIONS(2719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2719),
    [sym_preproc_directive] = ACTIONS(2719),
    [anon_sym_LPAREN2] = ACTIONS(2721),
    [anon_sym_BANG] = ACTIONS(2721),
    [anon_sym_TILDE] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2719),
    [anon_sym_PLUS] = ACTIONS(2719),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(2719),
    [anon_sym_typedef] = ACTIONS(2719),
    [anon_sym_virtual] = ACTIONS(2719),
    [anon_sym_extern] = ACTIONS(2719),
    [anon_sym___attribute__] = ACTIONS(2719),
    [anon_sym___attribute] = ACTIONS(2719),
    [anon_sym_using] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2721),
    [anon_sym___declspec] = ACTIONS(2719),
    [anon_sym___based] = ACTIONS(2719),
    [anon_sym___cdecl] = ACTIONS(2719),
    [anon_sym___clrcall] = ACTIONS(2719),
    [anon_sym___stdcall] = ACTIONS(2719),
    [anon_sym___fastcall] = ACTIONS(2719),
    [anon_sym___thiscall] = ACTIONS(2719),
    [anon_sym___vectorcall] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2719),
    [anon_sym_unsigned] = ACTIONS(2719),
    [anon_sym_long] = ACTIONS(2719),
    [anon_sym_short] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_static] = ACTIONS(2719),
    [anon_sym_register] = ACTIONS(2719),
    [anon_sym_inline] = ACTIONS(2719),
    [anon_sym___inline] = ACTIONS(2719),
    [anon_sym___inline__] = ACTIONS(2719),
    [anon_sym___forceinline] = ACTIONS(2719),
    [anon_sym_thread_local] = ACTIONS(2719),
    [anon_sym___thread] = ACTIONS(2719),
    [anon_sym_const] = ACTIONS(2719),
    [anon_sym_constexpr] = ACTIONS(2719),
    [anon_sym_volatile] = ACTIONS(2719),
    [anon_sym_restrict] = ACTIONS(2719),
    [anon_sym___restrict__] = ACTIONS(2719),
    [anon_sym__Atomic] = ACTIONS(2719),
    [anon_sym__Noreturn] = ACTIONS(2719),
    [anon_sym_noreturn] = ACTIONS(2719),
    [anon_sym__Nonnull] = ACTIONS(2719),
    [anon_sym_mutable] = ACTIONS(2719),
    [anon_sym_constinit] = ACTIONS(2719),
    [anon_sym_consteval] = ACTIONS(2719),
    [anon_sym_alignas] = ACTIONS(2719),
    [anon_sym__Alignas] = ACTIONS(2719),
    [sym_primitive_type] = ACTIONS(2719),
    [anon_sym_enum] = ACTIONS(2719),
    [anon_sym_class] = ACTIONS(2719),
    [anon_sym_struct] = ACTIONS(2719),
    [anon_sym_union] = ACTIONS(2719),
    [anon_sym_if] = ACTIONS(2719),
    [anon_sym_else] = ACTIONS(2719),
    [anon_sym_switch] = ACTIONS(2719),
    [anon_sym_case] = ACTIONS(2719),
    [anon_sym_default] = ACTIONS(2719),
    [anon_sym_while] = ACTIONS(2719),
    [anon_sym_do] = ACTIONS(2719),
    [anon_sym_for] = ACTIONS(2719),
    [anon_sym_return] = ACTIONS(2719),
    [anon_sym_break] = ACTIONS(2719),
    [anon_sym_continue] = ACTIONS(2719),
    [anon_sym_goto] = ACTIONS(2719),
    [anon_sym___try] = ACTIONS(2719),
    [anon_sym___leave] = ACTIONS(2719),
    [anon_sym_not] = ACTIONS(2719),
    [anon_sym_compl] = ACTIONS(2719),
    [anon_sym_DASH_DASH] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(2721),
    [anon_sym_sizeof] = ACTIONS(2719),
    [anon_sym___alignof__] = ACTIONS(2719),
    [anon_sym___alignof] = ACTIONS(2719),
    [anon_sym__alignof] = ACTIONS(2719),
    [anon_sym_alignof] = ACTIONS(2719),
    [anon_sym__Alignof] = ACTIONS(2719),
    [anon_sym_offsetof] = ACTIONS(2719),
    [anon_sym__Generic] = ACTIONS(2719),
    [anon_sym_asm] = ACTIONS(2719),
    [anon_sym___asm__] = ACTIONS(2719),
    [anon_sym___asm] = ACTIONS(2719),
    [sym_number_literal] = ACTIONS(2721),
    [anon_sym_L_SQUOTE] = ACTIONS(2721),
    [anon_sym_u_SQUOTE] = ACTIONS(2721),
    [anon_sym_U_SQUOTE] = ACTIONS(2721),
    [anon_sym_u8_SQUOTE] = ACTIONS(2721),
    [anon_sym_SQUOTE] = ACTIONS(2721),
    [anon_sym_L_DQUOTE] = ACTIONS(2721),
    [anon_sym_u_DQUOTE] = ACTIONS(2721),
    [anon_sym_U_DQUOTE] = ACTIONS(2721),
    [anon_sym_u8_DQUOTE] = ACTIONS(2721),
    [anon_sym_DQUOTE] = ACTIONS(2721),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [anon_sym_NULL] = ACTIONS(2719),
    [anon_sym_nullptr] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2719),
    [anon_sym_decltype] = ACTIONS(2719),
    [anon_sym_explicit] = ACTIONS(2719),
    [anon_sym_typename] = ACTIONS(2719),
    [anon_sym_template] = ACTIONS(2719),
    [anon_sym_operator] = ACTIONS(2719),
    [anon_sym_try] = ACTIONS(2719),
    [anon_sym_delete] = ACTIONS(2719),
    [anon_sym_throw] = ACTIONS(2719),
    [anon_sym_namespace] = ACTIONS(2719),
    [anon_sym_static_assert] = ACTIONS(2719),
    [anon_sym_concept] = ACTIONS(2719),
    [anon_sym_co_return] = ACTIONS(2719),
    [anon_sym_co_yield] = ACTIONS(2719),
    [anon_sym_R_DQUOTE] = ACTIONS(2721),
    [anon_sym_LR_DQUOTE] = ACTIONS(2721),
    [anon_sym_uR_DQUOTE] = ACTIONS(2721),
    [anon_sym_UR_DQUOTE] = ACTIONS(2721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2721),
    [anon_sym_co_await] = ACTIONS(2719),
    [anon_sym_new] = ACTIONS(2719),
    [anon_sym_requires] = ACTIONS(2719),
    [sym_this] = ACTIONS(2719),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(2861),
    [sym_identifier] = ACTIONS(2859),
    [aux_sym_preproc_include_token1] = ACTIONS(2859),
    [aux_sym_preproc_def_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token1] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2859),
    [sym_preproc_directive] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym___extension__] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2859),
    [anon_sym_virtual] = ACTIONS(2859),
    [anon_sym_extern] = ACTIONS(2859),
    [anon_sym___attribute__] = ACTIONS(2859),
    [anon_sym___attribute] = ACTIONS(2859),
    [anon_sym_using] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2861),
    [anon_sym___declspec] = ACTIONS(2859),
    [anon_sym___based] = ACTIONS(2859),
    [anon_sym___cdecl] = ACTIONS(2859),
    [anon_sym___clrcall] = ACTIONS(2859),
    [anon_sym___stdcall] = ACTIONS(2859),
    [anon_sym___fastcall] = ACTIONS(2859),
    [anon_sym___thiscall] = ACTIONS(2859),
    [anon_sym___vectorcall] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_signed] = ACTIONS(2859),
    [anon_sym_unsigned] = ACTIONS(2859),
    [anon_sym_long] = ACTIONS(2859),
    [anon_sym_short] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2859),
    [anon_sym_register] = ACTIONS(2859),
    [anon_sym_inline] = ACTIONS(2859),
    [anon_sym___inline] = ACTIONS(2859),
    [anon_sym___inline__] = ACTIONS(2859),
    [anon_sym___forceinline] = ACTIONS(2859),
    [anon_sym_thread_local] = ACTIONS(2859),
    [anon_sym___thread] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2859),
    [anon_sym_constexpr] = ACTIONS(2859),
    [anon_sym_volatile] = ACTIONS(2859),
    [anon_sym_restrict] = ACTIONS(2859),
    [anon_sym___restrict__] = ACTIONS(2859),
    [anon_sym__Atomic] = ACTIONS(2859),
    [anon_sym__Noreturn] = ACTIONS(2859),
    [anon_sym_noreturn] = ACTIONS(2859),
    [anon_sym__Nonnull] = ACTIONS(2859),
    [anon_sym_mutable] = ACTIONS(2859),
    [anon_sym_constinit] = ACTIONS(2859),
    [anon_sym_consteval] = ACTIONS(2859),
    [anon_sym_alignas] = ACTIONS(2859),
    [anon_sym__Alignas] = ACTIONS(2859),
    [sym_primitive_type] = ACTIONS(2859),
    [anon_sym_enum] = ACTIONS(2859),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2859),
    [anon_sym_union] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_switch] = ACTIONS(2859),
    [anon_sym_case] = ACTIONS(2859),
    [anon_sym_default] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_break] = ACTIONS(2859),
    [anon_sym_continue] = ACTIONS(2859),
    [anon_sym_goto] = ACTIONS(2859),
    [anon_sym_not] = ACTIONS(2859),
    [anon_sym_compl] = ACTIONS(2859),
    [anon_sym_DASH_DASH] = ACTIONS(2861),
    [anon_sym_PLUS_PLUS] = ACTIONS(2861),
    [anon_sym_sizeof] = ACTIONS(2859),
    [anon_sym___alignof__] = ACTIONS(2859),
    [anon_sym___alignof] = ACTIONS(2859),
    [anon_sym__alignof] = ACTIONS(2859),
    [anon_sym_alignof] = ACTIONS(2859),
    [anon_sym__Alignof] = ACTIONS(2859),
    [anon_sym_offsetof] = ACTIONS(2859),
    [anon_sym__Generic] = ACTIONS(2859),
    [anon_sym_asm] = ACTIONS(2859),
    [anon_sym___asm__] = ACTIONS(2859),
    [anon_sym___asm] = ACTIONS(2859),
    [sym_number_literal] = ACTIONS(2861),
    [anon_sym_L_SQUOTE] = ACTIONS(2861),
    [anon_sym_u_SQUOTE] = ACTIONS(2861),
    [anon_sym_U_SQUOTE] = ACTIONS(2861),
    [anon_sym_u8_SQUOTE] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2861),
    [anon_sym_L_DQUOTE] = ACTIONS(2861),
    [anon_sym_u_DQUOTE] = ACTIONS(2861),
    [anon_sym_U_DQUOTE] = ACTIONS(2861),
    [anon_sym_u8_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE] = ACTIONS(2861),
    [sym_true] = ACTIONS(2859),
    [sym_false] = ACTIONS(2859),
    [anon_sym_NULL] = ACTIONS(2859),
    [anon_sym_nullptr] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2859),
    [anon_sym_decltype] = ACTIONS(2859),
    [anon_sym_explicit] = ACTIONS(2859),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_export] = ACTIONS(2859),
    [anon_sym_module] = ACTIONS(2859),
    [anon_sym_import] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(2859),
    [anon_sym_operator] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_delete] = ACTIONS(2859),
    [anon_sym_throw] = ACTIONS(2859),
    [anon_sym_namespace] = ACTIONS(2859),
    [anon_sym_static_assert] = ACTIONS(2859),
    [anon_sym_concept] = ACTIONS(2859),
    [anon_sym_co_return] = ACTIONS(2859),
    [anon_sym_co_yield] = ACTIONS(2859),
    [anon_sym_R_DQUOTE] = ACTIONS(2861),
    [anon_sym_LR_DQUOTE] = ACTIONS(2861),
    [anon_sym_uR_DQUOTE] = ACTIONS(2861),
    [anon_sym_UR_DQUOTE] = ACTIONS(2861),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2861),
    [anon_sym_co_await] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_requires] = ACTIONS(2859),
    [sym_this] = ACTIONS(2859),
  },
  [594] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_include_token1] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym___cdecl] = ACTIONS(1940),
    [anon_sym___clrcall] = ACTIONS(1940),
    [anon_sym___stdcall] = ACTIONS(1940),
    [anon_sym___fastcall] = ACTIONS(1940),
    [anon_sym___thiscall] = ACTIONS(1940),
    [anon_sym___vectorcall] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_RBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1940),
    [anon_sym___try] = ACTIONS(1940),
    [anon_sym___leave] = ACTIONS(1940),
    [anon_sym_not] = ACTIONS(1940),
    [anon_sym_compl] = ACTIONS(1940),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_sizeof] = ACTIONS(1940),
    [anon_sym___alignof__] = ACTIONS(1940),
    [anon_sym___alignof] = ACTIONS(1940),
    [anon_sym__alignof] = ACTIONS(1940),
    [anon_sym_alignof] = ACTIONS(1940),
    [anon_sym__Alignof] = ACTIONS(1940),
    [anon_sym_offsetof] = ACTIONS(1940),
    [anon_sym__Generic] = ACTIONS(1940),
    [anon_sym_asm] = ACTIONS(1940),
    [anon_sym___asm__] = ACTIONS(1940),
    [anon_sym___asm] = ACTIONS(1940),
    [sym_number_literal] = ACTIONS(1938),
    [anon_sym_L_SQUOTE] = ACTIONS(1938),
    [anon_sym_u_SQUOTE] = ACTIONS(1938),
    [anon_sym_U_SQUOTE] = ACTIONS(1938),
    [anon_sym_u8_SQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_L_DQUOTE] = ACTIONS(1938),
    [anon_sym_u_DQUOTE] = ACTIONS(1938),
    [anon_sym_U_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8_DQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [anon_sym_NULL] = ACTIONS(1940),
    [anon_sym_nullptr] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_concept] = ACTIONS(1940),
    [anon_sym_co_return] = ACTIONS(1940),
    [anon_sym_co_yield] = ACTIONS(1940),
    [anon_sym_R_DQUOTE] = ACTIONS(1938),
    [anon_sym_LR_DQUOTE] = ACTIONS(1938),
    [anon_sym_uR_DQUOTE] = ACTIONS(1938),
    [anon_sym_UR_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1938),
    [anon_sym_co_await] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_requires] = ACTIONS(1940),
    [sym_this] = ACTIONS(1940),
  },
  [595] = {
    [sym_identifier] = ACTIONS(2711),
    [aux_sym_preproc_include_token1] = ACTIONS(2711),
    [aux_sym_preproc_def_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token2] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2711),
    [sym_preproc_directive] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym___extension__] = ACTIONS(2711),
    [anon_sym_typedef] = ACTIONS(2711),
    [anon_sym_virtual] = ACTIONS(2711),
    [anon_sym_extern] = ACTIONS(2711),
    [anon_sym___attribute__] = ACTIONS(2711),
    [anon_sym___attribute] = ACTIONS(2711),
    [anon_sym_using] = ACTIONS(2711),
    [anon_sym_COLON_COLON] = ACTIONS(2713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2713),
    [anon_sym___declspec] = ACTIONS(2711),
    [anon_sym___based] = ACTIONS(2711),
    [anon_sym___cdecl] = ACTIONS(2711),
    [anon_sym___clrcall] = ACTIONS(2711),
    [anon_sym___stdcall] = ACTIONS(2711),
    [anon_sym___fastcall] = ACTIONS(2711),
    [anon_sym___thiscall] = ACTIONS(2711),
    [anon_sym___vectorcall] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_signed] = ACTIONS(2711),
    [anon_sym_unsigned] = ACTIONS(2711),
    [anon_sym_long] = ACTIONS(2711),
    [anon_sym_short] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_static] = ACTIONS(2711),
    [anon_sym_register] = ACTIONS(2711),
    [anon_sym_inline] = ACTIONS(2711),
    [anon_sym___inline] = ACTIONS(2711),
    [anon_sym___inline__] = ACTIONS(2711),
    [anon_sym___forceinline] = ACTIONS(2711),
    [anon_sym_thread_local] = ACTIONS(2711),
    [anon_sym___thread] = ACTIONS(2711),
    [anon_sym_const] = ACTIONS(2711),
    [anon_sym_constexpr] = ACTIONS(2711),
    [anon_sym_volatile] = ACTIONS(2711),
    [anon_sym_restrict] = ACTIONS(2711),
    [anon_sym___restrict__] = ACTIONS(2711),
    [anon_sym__Atomic] = ACTIONS(2711),
    [anon_sym__Noreturn] = ACTIONS(2711),
    [anon_sym_noreturn] = ACTIONS(2711),
    [anon_sym__Nonnull] = ACTIONS(2711),
    [anon_sym_mutable] = ACTIONS(2711),
    [anon_sym_constinit] = ACTIONS(2711),
    [anon_sym_consteval] = ACTIONS(2711),
    [anon_sym_alignas] = ACTIONS(2711),
    [anon_sym__Alignas] = ACTIONS(2711),
    [sym_primitive_type] = ACTIONS(2711),
    [anon_sym_enum] = ACTIONS(2711),
    [anon_sym_class] = ACTIONS(2711),
    [anon_sym_struct] = ACTIONS(2711),
    [anon_sym_union] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(2711),
    [anon_sym_else] = ACTIONS(2711),
    [anon_sym_switch] = ACTIONS(2711),
    [anon_sym_case] = ACTIONS(2711),
    [anon_sym_default] = ACTIONS(2711),
    [anon_sym_while] = ACTIONS(2711),
    [anon_sym_do] = ACTIONS(2711),
    [anon_sym_for] = ACTIONS(2711),
    [anon_sym_return] = ACTIONS(2711),
    [anon_sym_break] = ACTIONS(2711),
    [anon_sym_continue] = ACTIONS(2711),
    [anon_sym_goto] = ACTIONS(2711),
    [anon_sym___try] = ACTIONS(2711),
    [anon_sym___leave] = ACTIONS(2711),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_compl] = ACTIONS(2711),
    [anon_sym_DASH_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_PLUS] = ACTIONS(2713),
    [anon_sym_sizeof] = ACTIONS(2711),
    [anon_sym___alignof__] = ACTIONS(2711),
    [anon_sym___alignof] = ACTIONS(2711),
    [anon_sym__alignof] = ACTIONS(2711),
    [anon_sym_alignof] = ACTIONS(2711),
    [anon_sym__Alignof] = ACTIONS(2711),
    [anon_sym_offsetof] = ACTIONS(2711),
    [anon_sym__Generic] = ACTIONS(2711),
    [anon_sym_asm] = ACTIONS(2711),
    [anon_sym___asm__] = ACTIONS(2711),
    [anon_sym___asm] = ACTIONS(2711),
    [sym_number_literal] = ACTIONS(2713),
    [anon_sym_L_SQUOTE] = ACTIONS(2713),
    [anon_sym_u_SQUOTE] = ACTIONS(2713),
    [anon_sym_U_SQUOTE] = ACTIONS(2713),
    [anon_sym_u8_SQUOTE] = ACTIONS(2713),
    [anon_sym_SQUOTE] = ACTIONS(2713),
    [anon_sym_L_DQUOTE] = ACTIONS(2713),
    [anon_sym_u_DQUOTE] = ACTIONS(2713),
    [anon_sym_U_DQUOTE] = ACTIONS(2713),
    [anon_sym_u8_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [sym_true] = ACTIONS(2711),
    [sym_false] = ACTIONS(2711),
    [anon_sym_NULL] = ACTIONS(2711),
    [anon_sym_nullptr] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2711),
    [anon_sym_decltype] = ACTIONS(2711),
    [anon_sym_explicit] = ACTIONS(2711),
    [anon_sym_typename] = ACTIONS(2711),
    [anon_sym_template] = ACTIONS(2711),
    [anon_sym_operator] = ACTIONS(2711),
    [anon_sym_try] = ACTIONS(2711),
    [anon_sym_delete] = ACTIONS(2711),
    [anon_sym_throw] = ACTIONS(2711),
    [anon_sym_namespace] = ACTIONS(2711),
    [anon_sym_static_assert] = ACTIONS(2711),
    [anon_sym_concept] = ACTIONS(2711),
    [anon_sym_co_return] = ACTIONS(2711),
    [anon_sym_co_yield] = ACTIONS(2711),
    [anon_sym_R_DQUOTE] = ACTIONS(2713),
    [anon_sym_LR_DQUOTE] = ACTIONS(2713),
    [anon_sym_uR_DQUOTE] = ACTIONS(2713),
    [anon_sym_UR_DQUOTE] = ACTIONS(2713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2713),
    [anon_sym_co_await] = ACTIONS(2711),
    [anon_sym_new] = ACTIONS(2711),
    [anon_sym_requires] = ACTIONS(2711),
    [sym_this] = ACTIONS(2711),
  },
  [596] = {
    [sym_identifier] = ACTIONS(2727),
    [aux_sym_preproc_include_token1] = ACTIONS(2727),
    [aux_sym_preproc_def_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token2] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym___extension__] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_virtual] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym___attribute__] = ACTIONS(2727),
    [anon_sym___attribute] = ACTIONS(2727),
    [anon_sym_using] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2729),
    [anon_sym___declspec] = ACTIONS(2727),
    [anon_sym___based] = ACTIONS(2727),
    [anon_sym___cdecl] = ACTIONS(2727),
    [anon_sym___clrcall] = ACTIONS(2727),
    [anon_sym___stdcall] = ACTIONS(2727),
    [anon_sym___fastcall] = ACTIONS(2727),
    [anon_sym___thiscall] = ACTIONS(2727),
    [anon_sym___vectorcall] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_signed] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym___inline] = ACTIONS(2727),
    [anon_sym___inline__] = ACTIONS(2727),
    [anon_sym___forceinline] = ACTIONS(2727),
    [anon_sym_thread_local] = ACTIONS(2727),
    [anon_sym___thread] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_constexpr] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym___restrict__] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym__Noreturn] = ACTIONS(2727),
    [anon_sym_noreturn] = ACTIONS(2727),
    [anon_sym__Nonnull] = ACTIONS(2727),
    [anon_sym_mutable] = ACTIONS(2727),
    [anon_sym_constinit] = ACTIONS(2727),
    [anon_sym_consteval] = ACTIONS(2727),
    [anon_sym_alignas] = ACTIONS(2727),
    [anon_sym__Alignas] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_else] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym___try] = ACTIONS(2727),
    [anon_sym___leave] = ACTIONS(2727),
    [anon_sym_not] = ACTIONS(2727),
    [anon_sym_compl] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [anon_sym___alignof__] = ACTIONS(2727),
    [anon_sym___alignof] = ACTIONS(2727),
    [anon_sym__alignof] = ACTIONS(2727),
    [anon_sym_alignof] = ACTIONS(2727),
    [anon_sym__Alignof] = ACTIONS(2727),
    [anon_sym_offsetof] = ACTIONS(2727),
    [anon_sym__Generic] = ACTIONS(2727),
    [anon_sym_asm] = ACTIONS(2727),
    [anon_sym___asm__] = ACTIONS(2727),
    [anon_sym___asm] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [anon_sym_L_SQUOTE] = ACTIONS(2729),
    [anon_sym_u_SQUOTE] = ACTIONS(2729),
    [anon_sym_U_SQUOTE] = ACTIONS(2729),
    [anon_sym_u8_SQUOTE] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_L_DQUOTE] = ACTIONS(2729),
    [anon_sym_u_DQUOTE] = ACTIONS(2729),
    [anon_sym_U_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [anon_sym_NULL] = ACTIONS(2727),
    [anon_sym_nullptr] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2727),
    [anon_sym_decltype] = ACTIONS(2727),
    [anon_sym_explicit] = ACTIONS(2727),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_template] = ACTIONS(2727),
    [anon_sym_operator] = ACTIONS(2727),
    [anon_sym_try] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2727),
    [anon_sym_throw] = ACTIONS(2727),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_static_assert] = ACTIONS(2727),
    [anon_sym_concept] = ACTIONS(2727),
    [anon_sym_co_return] = ACTIONS(2727),
    [anon_sym_co_yield] = ACTIONS(2727),
    [anon_sym_R_DQUOTE] = ACTIONS(2729),
    [anon_sym_LR_DQUOTE] = ACTIONS(2729),
    [anon_sym_uR_DQUOTE] = ACTIONS(2729),
    [anon_sym_UR_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2729),
    [anon_sym_co_await] = ACTIONS(2727),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_requires] = ACTIONS(2727),
    [sym_this] = ACTIONS(2727),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(3575),
    [sym_identifier] = ACTIONS(3577),
    [aux_sym_preproc_include_token1] = ACTIONS(3577),
    [aux_sym_preproc_def_token1] = ACTIONS(3577),
    [aux_sym_preproc_if_token1] = ACTIONS(3577),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3577),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3577),
    [sym_preproc_directive] = ACTIONS(3577),
    [anon_sym_LPAREN2] = ACTIONS(3575),
    [anon_sym_BANG] = ACTIONS(3575),
    [anon_sym_TILDE] = ACTIONS(3575),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_PLUS] = ACTIONS(3577),
    [anon_sym_STAR] = ACTIONS(3575),
    [anon_sym_AMP_AMP] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym___extension__] = ACTIONS(3577),
    [anon_sym_typedef] = ACTIONS(3577),
    [anon_sym_virtual] = ACTIONS(3577),
    [anon_sym_extern] = ACTIONS(3577),
    [anon_sym___attribute__] = ACTIONS(3577),
    [anon_sym___attribute] = ACTIONS(3577),
    [anon_sym_using] = ACTIONS(3577),
    [anon_sym_COLON_COLON] = ACTIONS(3575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3575),
    [anon_sym___declspec] = ACTIONS(3577),
    [anon_sym___based] = ACTIONS(3577),
    [anon_sym___cdecl] = ACTIONS(3577),
    [anon_sym___clrcall] = ACTIONS(3577),
    [anon_sym___stdcall] = ACTIONS(3577),
    [anon_sym___fastcall] = ACTIONS(3577),
    [anon_sym___thiscall] = ACTIONS(3577),
    [anon_sym___vectorcall] = ACTIONS(3577),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_signed] = ACTIONS(3577),
    [anon_sym_unsigned] = ACTIONS(3577),
    [anon_sym_long] = ACTIONS(3577),
    [anon_sym_short] = ACTIONS(3577),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_static] = ACTIONS(3577),
    [anon_sym_register] = ACTIONS(3577),
    [anon_sym_inline] = ACTIONS(3577),
    [anon_sym___inline] = ACTIONS(3577),
    [anon_sym___inline__] = ACTIONS(3577),
    [anon_sym___forceinline] = ACTIONS(3577),
    [anon_sym_thread_local] = ACTIONS(3577),
    [anon_sym___thread] = ACTIONS(3577),
    [anon_sym_const] = ACTIONS(3577),
    [anon_sym_constexpr] = ACTIONS(3577),
    [anon_sym_volatile] = ACTIONS(3577),
    [anon_sym_restrict] = ACTIONS(3577),
    [anon_sym___restrict__] = ACTIONS(3577),
    [anon_sym__Atomic] = ACTIONS(3577),
    [anon_sym__Noreturn] = ACTIONS(3577),
    [anon_sym_noreturn] = ACTIONS(3577),
    [anon_sym__Nonnull] = ACTIONS(3577),
    [anon_sym_mutable] = ACTIONS(3577),
    [anon_sym_constinit] = ACTIONS(3577),
    [anon_sym_consteval] = ACTIONS(3577),
    [anon_sym_alignas] = ACTIONS(3577),
    [anon_sym__Alignas] = ACTIONS(3577),
    [sym_primitive_type] = ACTIONS(3577),
    [anon_sym_enum] = ACTIONS(3577),
    [anon_sym_class] = ACTIONS(3577),
    [anon_sym_struct] = ACTIONS(3577),
    [anon_sym_union] = ACTIONS(3577),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_switch] = ACTIONS(3577),
    [anon_sym_case] = ACTIONS(3577),
    [anon_sym_default] = ACTIONS(3577),
    [anon_sym_while] = ACTIONS(3577),
    [anon_sym_do] = ACTIONS(3577),
    [anon_sym_for] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3577),
    [anon_sym_break] = ACTIONS(3577),
    [anon_sym_continue] = ACTIONS(3577),
    [anon_sym_goto] = ACTIONS(3577),
    [anon_sym_not] = ACTIONS(3577),
    [anon_sym_compl] = ACTIONS(3577),
    [anon_sym_DASH_DASH] = ACTIONS(3575),
    [anon_sym_PLUS_PLUS] = ACTIONS(3575),
    [anon_sym_sizeof] = ACTIONS(3577),
    [anon_sym___alignof__] = ACTIONS(3577),
    [anon_sym___alignof] = ACTIONS(3577),
    [anon_sym__alignof] = ACTIONS(3577),
    [anon_sym_alignof] = ACTIONS(3577),
    [anon_sym__Alignof] = ACTIONS(3577),
    [anon_sym_offsetof] = ACTIONS(3577),
    [anon_sym__Generic] = ACTIONS(3577),
    [anon_sym_asm] = ACTIONS(3577),
    [anon_sym___asm__] = ACTIONS(3577),
    [anon_sym___asm] = ACTIONS(3577),
    [sym_number_literal] = ACTIONS(3575),
    [anon_sym_L_SQUOTE] = ACTIONS(3575),
    [anon_sym_u_SQUOTE] = ACTIONS(3575),
    [anon_sym_U_SQUOTE] = ACTIONS(3575),
    [anon_sym_u8_SQUOTE] = ACTIONS(3575),
    [anon_sym_SQUOTE] = ACTIONS(3575),
    [anon_sym_L_DQUOTE] = ACTIONS(3575),
    [anon_sym_u_DQUOTE] = ACTIONS(3575),
    [anon_sym_U_DQUOTE] = ACTIONS(3575),
    [anon_sym_u8_DQUOTE] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(3575),
    [sym_true] = ACTIONS(3577),
    [sym_false] = ACTIONS(3577),
    [anon_sym_NULL] = ACTIONS(3577),
    [anon_sym_nullptr] = ACTIONS(3577),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3577),
    [anon_sym_decltype] = ACTIONS(3577),
    [anon_sym_explicit] = ACTIONS(3577),
    [anon_sym_typename] = ACTIONS(3577),
    [anon_sym_export] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(3577),
    [anon_sym_import] = ACTIONS(3577),
    [anon_sym_template] = ACTIONS(3577),
    [anon_sym_operator] = ACTIONS(3577),
    [anon_sym_try] = ACTIONS(3577),
    [anon_sym_delete] = ACTIONS(3577),
    [anon_sym_throw] = ACTIONS(3577),
    [anon_sym_namespace] = ACTIONS(3577),
    [anon_sym_static_assert] = ACTIONS(3577),
    [anon_sym_concept] = ACTIONS(3577),
    [anon_sym_co_return] = ACTIONS(3577),
    [anon_sym_co_yield] = ACTIONS(3577),
    [anon_sym_R_DQUOTE] = ACTIONS(3575),
    [anon_sym_LR_DQUOTE] = ACTIONS(3575),
    [anon_sym_uR_DQUOTE] = ACTIONS(3575),
    [anon_sym_UR_DQUOTE] = ACTIONS(3575),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3575),
    [anon_sym_co_await] = ACTIONS(3577),
    [anon_sym_new] = ACTIONS(3577),
    [anon_sym_requires] = ACTIONS(3577),
    [sym_this] = ACTIONS(3577),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(3579),
    [sym_identifier] = ACTIONS(3581),
    [aux_sym_preproc_include_token1] = ACTIONS(3581),
    [aux_sym_preproc_def_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3581),
    [sym_preproc_directive] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_BANG] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_AMP_AMP] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym___extension__] = ACTIONS(3581),
    [anon_sym_typedef] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym___attribute__] = ACTIONS(3581),
    [anon_sym___attribute] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3579),
    [anon_sym___declspec] = ACTIONS(3581),
    [anon_sym___based] = ACTIONS(3581),
    [anon_sym___cdecl] = ACTIONS(3581),
    [anon_sym___clrcall] = ACTIONS(3581),
    [anon_sym___stdcall] = ACTIONS(3581),
    [anon_sym___fastcall] = ACTIONS(3581),
    [anon_sym___thiscall] = ACTIONS(3581),
    [anon_sym___vectorcall] = ACTIONS(3581),
    [anon_sym_LBRACE] = ACTIONS(3579),
    [anon_sym_signed] = ACTIONS(3581),
    [anon_sym_unsigned] = ACTIONS(3581),
    [anon_sym_long] = ACTIONS(3581),
    [anon_sym_short] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_register] = ACTIONS(3581),
    [anon_sym_inline] = ACTIONS(3581),
    [anon_sym___inline] = ACTIONS(3581),
    [anon_sym___inline__] = ACTIONS(3581),
    [anon_sym___forceinline] = ACTIONS(3581),
    [anon_sym_thread_local] = ACTIONS(3581),
    [anon_sym___thread] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_constexpr] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_restrict] = ACTIONS(3581),
    [anon_sym___restrict__] = ACTIONS(3581),
    [anon_sym__Atomic] = ACTIONS(3581),
    [anon_sym__Noreturn] = ACTIONS(3581),
    [anon_sym_noreturn] = ACTIONS(3581),
    [anon_sym__Nonnull] = ACTIONS(3581),
    [anon_sym_mutable] = ACTIONS(3581),
    [anon_sym_constinit] = ACTIONS(3581),
    [anon_sym_consteval] = ACTIONS(3581),
    [anon_sym_alignas] = ACTIONS(3581),
    [anon_sym__Alignas] = ACTIONS(3581),
    [sym_primitive_type] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_union] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_switch] = ACTIONS(3581),
    [anon_sym_case] = ACTIONS(3581),
    [anon_sym_default] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_break] = ACTIONS(3581),
    [anon_sym_continue] = ACTIONS(3581),
    [anon_sym_goto] = ACTIONS(3581),
    [anon_sym_not] = ACTIONS(3581),
    [anon_sym_compl] = ACTIONS(3581),
    [anon_sym_DASH_DASH] = ACTIONS(3579),
    [anon_sym_PLUS_PLUS] = ACTIONS(3579),
    [anon_sym_sizeof] = ACTIONS(3581),
    [anon_sym___alignof__] = ACTIONS(3581),
    [anon_sym___alignof] = ACTIONS(3581),
    [anon_sym__alignof] = ACTIONS(3581),
    [anon_sym_alignof] = ACTIONS(3581),
    [anon_sym__Alignof] = ACTIONS(3581),
    [anon_sym_offsetof] = ACTIONS(3581),
    [anon_sym__Generic] = ACTIONS(3581),
    [anon_sym_asm] = ACTIONS(3581),
    [anon_sym___asm__] = ACTIONS(3581),
    [anon_sym___asm] = ACTIONS(3581),
    [sym_number_literal] = ACTIONS(3579),
    [anon_sym_L_SQUOTE] = ACTIONS(3579),
    [anon_sym_u_SQUOTE] = ACTIONS(3579),
    [anon_sym_U_SQUOTE] = ACTIONS(3579),
    [anon_sym_u8_SQUOTE] = ACTIONS(3579),
    [anon_sym_SQUOTE] = ACTIONS(3579),
    [anon_sym_L_DQUOTE] = ACTIONS(3579),
    [anon_sym_u_DQUOTE] = ACTIONS(3579),
    [anon_sym_U_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE] = ACTIONS(3579),
    [sym_true] = ACTIONS(3581),
    [sym_false] = ACTIONS(3581),
    [anon_sym_NULL] = ACTIONS(3581),
    [anon_sym_nullptr] = ACTIONS(3581),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3581),
    [anon_sym_decltype] = ACTIONS(3581),
    [anon_sym_explicit] = ACTIONS(3581),
    [anon_sym_typename] = ACTIONS(3581),
    [anon_sym_export] = ACTIONS(3581),
    [anon_sym_module] = ACTIONS(3581),
    [anon_sym_import] = ACTIONS(3581),
    [anon_sym_template] = ACTIONS(3581),
    [anon_sym_operator] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_delete] = ACTIONS(3581),
    [anon_sym_throw] = ACTIONS(3581),
    [anon_sym_namespace] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3581),
    [anon_sym_concept] = ACTIONS(3581),
    [anon_sym_co_return] = ACTIONS(3581),
    [anon_sym_co_yield] = ACTIONS(3581),
    [anon_sym_R_DQUOTE] = ACTIONS(3579),
    [anon_sym_LR_DQUOTE] = ACTIONS(3579),
    [anon_sym_uR_DQUOTE] = ACTIONS(3579),
    [anon_sym_UR_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3579),
    [anon_sym_co_await] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_requires] = ACTIONS(3581),
    [sym_this] = ACTIONS(3581),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(2873),
    [sym_identifier] = ACTIONS(2871),
    [aux_sym_preproc_include_token1] = ACTIONS(2871),
    [aux_sym_preproc_def_token1] = ACTIONS(2871),
    [aux_sym_preproc_if_token1] = ACTIONS(2871),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2871),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2871),
    [sym_preproc_directive] = ACTIONS(2871),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym___extension__] = ACTIONS(2871),
    [anon_sym_typedef] = ACTIONS(2871),
    [anon_sym_virtual] = ACTIONS(2871),
    [anon_sym_extern] = ACTIONS(2871),
    [anon_sym___attribute__] = ACTIONS(2871),
    [anon_sym___attribute] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2873),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2873),
    [anon_sym___declspec] = ACTIONS(2871),
    [anon_sym___based] = ACTIONS(2871),
    [anon_sym___cdecl] = ACTIONS(2871),
    [anon_sym___clrcall] = ACTIONS(2871),
    [anon_sym___stdcall] = ACTIONS(2871),
    [anon_sym___fastcall] = ACTIONS(2871),
    [anon_sym___thiscall] = ACTIONS(2871),
    [anon_sym___vectorcall] = ACTIONS(2871),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_signed] = ACTIONS(2871),
    [anon_sym_unsigned] = ACTIONS(2871),
    [anon_sym_long] = ACTIONS(2871),
    [anon_sym_short] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_static] = ACTIONS(2871),
    [anon_sym_register] = ACTIONS(2871),
    [anon_sym_inline] = ACTIONS(2871),
    [anon_sym___inline] = ACTIONS(2871),
    [anon_sym___inline__] = ACTIONS(2871),
    [anon_sym___forceinline] = ACTIONS(2871),
    [anon_sym_thread_local] = ACTIONS(2871),
    [anon_sym___thread] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_constexpr] = ACTIONS(2871),
    [anon_sym_volatile] = ACTIONS(2871),
    [anon_sym_restrict] = ACTIONS(2871),
    [anon_sym___restrict__] = ACTIONS(2871),
    [anon_sym__Atomic] = ACTIONS(2871),
    [anon_sym__Noreturn] = ACTIONS(2871),
    [anon_sym_noreturn] = ACTIONS(2871),
    [anon_sym__Nonnull] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_constinit] = ACTIONS(2871),
    [anon_sym_consteval] = ACTIONS(2871),
    [anon_sym_alignas] = ACTIONS(2871),
    [anon_sym__Alignas] = ACTIONS(2871),
    [sym_primitive_type] = ACTIONS(2871),
    [anon_sym_enum] = ACTIONS(2871),
    [anon_sym_class] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_union] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_switch] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(2871),
    [anon_sym_default] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [anon_sym_do] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_break] = ACTIONS(2871),
    [anon_sym_continue] = ACTIONS(2871),
    [anon_sym_goto] = ACTIONS(2871),
    [anon_sym_not] = ACTIONS(2871),
    [anon_sym_compl] = ACTIONS(2871),
    [anon_sym_DASH_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2873),
    [anon_sym_sizeof] = ACTIONS(2871),
    [anon_sym___alignof__] = ACTIONS(2871),
    [anon_sym___alignof] = ACTIONS(2871),
    [anon_sym__alignof] = ACTIONS(2871),
    [anon_sym_alignof] = ACTIONS(2871),
    [anon_sym__Alignof] = ACTIONS(2871),
    [anon_sym_offsetof] = ACTIONS(2871),
    [anon_sym__Generic] = ACTIONS(2871),
    [anon_sym_asm] = ACTIONS(2871),
    [anon_sym___asm__] = ACTIONS(2871),
    [anon_sym___asm] = ACTIONS(2871),
    [sym_number_literal] = ACTIONS(2873),
    [anon_sym_L_SQUOTE] = ACTIONS(2873),
    [anon_sym_u_SQUOTE] = ACTIONS(2873),
    [anon_sym_U_SQUOTE] = ACTIONS(2873),
    [anon_sym_u8_SQUOTE] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_L_DQUOTE] = ACTIONS(2873),
    [anon_sym_u_DQUOTE] = ACTIONS(2873),
    [anon_sym_U_DQUOTE] = ACTIONS(2873),
    [anon_sym_u8_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [sym_true] = ACTIONS(2871),
    [sym_false] = ACTIONS(2871),
    [anon_sym_NULL] = ACTIONS(2871),
    [anon_sym_nullptr] = ACTIONS(2871),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2871),
    [anon_sym_decltype] = ACTIONS(2871),
    [anon_sym_explicit] = ACTIONS(2871),
    [anon_sym_typename] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_template] = ACTIONS(2871),
    [anon_sym_operator] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_delete] = ACTIONS(2871),
    [anon_sym_throw] = ACTIONS(2871),
    [anon_sym_namespace] = ACTIONS(2871),
    [anon_sym_static_assert] = ACTIONS(2871),
    [anon_sym_concept] = ACTIONS(2871),
    [anon_sym_co_return] = ACTIONS(2871),
    [anon_sym_co_yield] = ACTIONS(2871),
    [anon_sym_R_DQUOTE] = ACTIONS(2873),
    [anon_sym_LR_DQUOTE] = ACTIONS(2873),
    [anon_sym_uR_DQUOTE] = ACTIONS(2873),
    [anon_sym_UR_DQUOTE] = ACTIONS(2873),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2873),
    [anon_sym_co_await] = ACTIONS(2871),
    [anon_sym_new] = ACTIONS(2871),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2871),
  },
  [600] = {
    [sym_identifier] = ACTIONS(2659),
    [aux_sym_preproc_include_token1] = ACTIONS(2659),
    [aux_sym_preproc_def_token1] = ACTIONS(2659),
    [aux_sym_preproc_if_token1] = ACTIONS(2659),
    [aux_sym_preproc_if_token2] = ACTIONS(2659),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2659),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2659),
    [sym_preproc_directive] = ACTIONS(2659),
    [anon_sym_LPAREN2] = ACTIONS(2661),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2661),
    [anon_sym_AMP_AMP] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym___extension__] = ACTIONS(2659),
    [anon_sym_typedef] = ACTIONS(2659),
    [anon_sym_virtual] = ACTIONS(2659),
    [anon_sym_extern] = ACTIONS(2659),
    [anon_sym___attribute__] = ACTIONS(2659),
    [anon_sym___attribute] = ACTIONS(2659),
    [anon_sym_using] = ACTIONS(2659),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2661),
    [anon_sym___declspec] = ACTIONS(2659),
    [anon_sym___based] = ACTIONS(2659),
    [anon_sym___cdecl] = ACTIONS(2659),
    [anon_sym___clrcall] = ACTIONS(2659),
    [anon_sym___stdcall] = ACTIONS(2659),
    [anon_sym___fastcall] = ACTIONS(2659),
    [anon_sym___thiscall] = ACTIONS(2659),
    [anon_sym___vectorcall] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_signed] = ACTIONS(2659),
    [anon_sym_unsigned] = ACTIONS(2659),
    [anon_sym_long] = ACTIONS(2659),
    [anon_sym_short] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2659),
    [anon_sym_register] = ACTIONS(2659),
    [anon_sym_inline] = ACTIONS(2659),
    [anon_sym___inline] = ACTIONS(2659),
    [anon_sym___inline__] = ACTIONS(2659),
    [anon_sym___forceinline] = ACTIONS(2659),
    [anon_sym_thread_local] = ACTIONS(2659),
    [anon_sym___thread] = ACTIONS(2659),
    [anon_sym_const] = ACTIONS(2659),
    [anon_sym_constexpr] = ACTIONS(2659),
    [anon_sym_volatile] = ACTIONS(2659),
    [anon_sym_restrict] = ACTIONS(2659),
    [anon_sym___restrict__] = ACTIONS(2659),
    [anon_sym__Atomic] = ACTIONS(2659),
    [anon_sym__Noreturn] = ACTIONS(2659),
    [anon_sym_noreturn] = ACTIONS(2659),
    [anon_sym__Nonnull] = ACTIONS(2659),
    [anon_sym_mutable] = ACTIONS(2659),
    [anon_sym_constinit] = ACTIONS(2659),
    [anon_sym_consteval] = ACTIONS(2659),
    [anon_sym_alignas] = ACTIONS(2659),
    [anon_sym__Alignas] = ACTIONS(2659),
    [sym_primitive_type] = ACTIONS(2659),
    [anon_sym_enum] = ACTIONS(2659),
    [anon_sym_class] = ACTIONS(2659),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_union] = ACTIONS(2659),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_else] = ACTIONS(2659),
    [anon_sym_switch] = ACTIONS(2659),
    [anon_sym_case] = ACTIONS(2659),
    [anon_sym_default] = ACTIONS(2659),
    [anon_sym_while] = ACTIONS(2659),
    [anon_sym_do] = ACTIONS(2659),
    [anon_sym_for] = ACTIONS(2659),
    [anon_sym_return] = ACTIONS(2659),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_continue] = ACTIONS(2659),
    [anon_sym_goto] = ACTIONS(2659),
    [anon_sym___try] = ACTIONS(2659),
    [anon_sym___leave] = ACTIONS(2659),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_compl] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2661),
    [anon_sym_PLUS_PLUS] = ACTIONS(2661),
    [anon_sym_sizeof] = ACTIONS(2659),
    [anon_sym___alignof__] = ACTIONS(2659),
    [anon_sym___alignof] = ACTIONS(2659),
    [anon_sym__alignof] = ACTIONS(2659),
    [anon_sym_alignof] = ACTIONS(2659),
    [anon_sym__Alignof] = ACTIONS(2659),
    [anon_sym_offsetof] = ACTIONS(2659),
    [anon_sym__Generic] = ACTIONS(2659),
    [anon_sym_asm] = ACTIONS(2659),
    [anon_sym___asm__] = ACTIONS(2659),
    [anon_sym___asm] = ACTIONS(2659),
    [sym_number_literal] = ACTIONS(2661),
    [anon_sym_L_SQUOTE] = ACTIONS(2661),
    [anon_sym_u_SQUOTE] = ACTIONS(2661),
    [anon_sym_U_SQUOTE] = ACTIONS(2661),
    [anon_sym_u8_SQUOTE] = ACTIONS(2661),
    [anon_sym_SQUOTE] = ACTIONS(2661),
    [anon_sym_L_DQUOTE] = ACTIONS(2661),
    [anon_sym_u_DQUOTE] = ACTIONS(2661),
    [anon_sym_U_DQUOTE] = ACTIONS(2661),
    [anon_sym_u8_DQUOTE] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [anon_sym_NULL] = ACTIONS(2659),
    [anon_sym_nullptr] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2659),
    [anon_sym_decltype] = ACTIONS(2659),
    [anon_sym_explicit] = ACTIONS(2659),
    [anon_sym_typename] = ACTIONS(2659),
    [anon_sym_template] = ACTIONS(2659),
    [anon_sym_operator] = ACTIONS(2659),
    [anon_sym_try] = ACTIONS(2659),
    [anon_sym_delete] = ACTIONS(2659),
    [anon_sym_throw] = ACTIONS(2659),
    [anon_sym_namespace] = ACTIONS(2659),
    [anon_sym_static_assert] = ACTIONS(2659),
    [anon_sym_concept] = ACTIONS(2659),
    [anon_sym_co_return] = ACTIONS(2659),
    [anon_sym_co_yield] = ACTIONS(2659),
    [anon_sym_R_DQUOTE] = ACTIONS(2661),
    [anon_sym_LR_DQUOTE] = ACTIONS(2661),
    [anon_sym_uR_DQUOTE] = ACTIONS(2661),
    [anon_sym_UR_DQUOTE] = ACTIONS(2661),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2661),
    [anon_sym_co_await] = ACTIONS(2659),
    [anon_sym_new] = ACTIONS(2659),
    [anon_sym_requires] = ACTIONS(2659),
    [sym_this] = ACTIONS(2659),
  },
  [601] = {
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_include_token1] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym___cdecl] = ACTIONS(2759),
    [anon_sym___clrcall] = ACTIONS(2759),
    [anon_sym___stdcall] = ACTIONS(2759),
    [anon_sym___fastcall] = ACTIONS(2759),
    [anon_sym___thiscall] = ACTIONS(2759),
    [anon_sym___vectorcall] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_RBRACE] = ACTIONS(2761),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_switch] = ACTIONS(2759),
    [anon_sym_case] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_goto] = ACTIONS(2759),
    [anon_sym___try] = ACTIONS(2759),
    [anon_sym___leave] = ACTIONS(2759),
    [anon_sym_not] = ACTIONS(2759),
    [anon_sym_compl] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_sizeof] = ACTIONS(2759),
    [anon_sym___alignof__] = ACTIONS(2759),
    [anon_sym___alignof] = ACTIONS(2759),
    [anon_sym__alignof] = ACTIONS(2759),
    [anon_sym_alignof] = ACTIONS(2759),
    [anon_sym__Alignof] = ACTIONS(2759),
    [anon_sym_offsetof] = ACTIONS(2759),
    [anon_sym__Generic] = ACTIONS(2759),
    [anon_sym_asm] = ACTIONS(2759),
    [anon_sym___asm__] = ACTIONS(2759),
    [anon_sym___asm] = ACTIONS(2759),
    [sym_number_literal] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2761),
    [anon_sym_u_SQUOTE] = ACTIONS(2761),
    [anon_sym_U_SQUOTE] = ACTIONS(2761),
    [anon_sym_u8_SQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_L_DQUOTE] = ACTIONS(2761),
    [anon_sym_u_DQUOTE] = ACTIONS(2761),
    [anon_sym_U_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8_DQUOTE] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2759),
    [anon_sym_nullptr] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2759),
    [anon_sym_throw] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
    [anon_sym_concept] = ACTIONS(2759),
    [anon_sym_co_return] = ACTIONS(2759),
    [anon_sym_co_yield] = ACTIONS(2759),
    [anon_sym_R_DQUOTE] = ACTIONS(2761),
    [anon_sym_LR_DQUOTE] = ACTIONS(2761),
    [anon_sym_uR_DQUOTE] = ACTIONS(2761),
    [anon_sym_UR_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2761),
    [anon_sym_co_await] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_requires] = ACTIONS(2759),
    [sym_this] = ACTIONS(2759),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(2773),
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_include_token1] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_BANG] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym___cdecl] = ACTIONS(2771),
    [anon_sym___clrcall] = ACTIONS(2771),
    [anon_sym___stdcall] = ACTIONS(2771),
    [anon_sym___fastcall] = ACTIONS(2771),
    [anon_sym___thiscall] = ACTIONS(2771),
    [anon_sym___vectorcall] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_switch] = ACTIONS(2771),
    [anon_sym_case] = ACTIONS(2771),
    [anon_sym_default] = ACTIONS(2771),
    [anon_sym_while] = ACTIONS(2771),
    [anon_sym_do] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2771),
    [anon_sym_return] = ACTIONS(2771),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_continue] = ACTIONS(2771),
    [anon_sym_goto] = ACTIONS(2771),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_compl] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2773),
    [anon_sym_PLUS_PLUS] = ACTIONS(2773),
    [anon_sym_sizeof] = ACTIONS(2771),
    [anon_sym___alignof__] = ACTIONS(2771),
    [anon_sym___alignof] = ACTIONS(2771),
    [anon_sym__alignof] = ACTIONS(2771),
    [anon_sym_alignof] = ACTIONS(2771),
    [anon_sym__Alignof] = ACTIONS(2771),
    [anon_sym_offsetof] = ACTIONS(2771),
    [anon_sym__Generic] = ACTIONS(2771),
    [anon_sym_asm] = ACTIONS(2771),
    [anon_sym___asm__] = ACTIONS(2771),
    [anon_sym___asm] = ACTIONS(2771),
    [sym_number_literal] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2773),
    [anon_sym_u_SQUOTE] = ACTIONS(2773),
    [anon_sym_U_SQUOTE] = ACTIONS(2773),
    [anon_sym_u8_SQUOTE] = ACTIONS(2773),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [anon_sym_L_DQUOTE] = ACTIONS(2773),
    [anon_sym_u_DQUOTE] = ACTIONS(2773),
    [anon_sym_U_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8_DQUOTE] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(2773),
    [sym_true] = ACTIONS(2771),
    [sym_false] = ACTIONS(2771),
    [anon_sym_NULL] = ACTIONS(2771),
    [anon_sym_nullptr] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_export] = ACTIONS(2771),
    [anon_sym_module] = ACTIONS(2771),
    [anon_sym_import] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_try] = ACTIONS(2771),
    [anon_sym_delete] = ACTIONS(2771),
    [anon_sym_throw] = ACTIONS(2771),
    [anon_sym_namespace] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
    [anon_sym_concept] = ACTIONS(2771),
    [anon_sym_co_return] = ACTIONS(2771),
    [anon_sym_co_yield] = ACTIONS(2771),
    [anon_sym_R_DQUOTE] = ACTIONS(2773),
    [anon_sym_LR_DQUOTE] = ACTIONS(2773),
    [anon_sym_uR_DQUOTE] = ACTIONS(2773),
    [anon_sym_UR_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2773),
    [anon_sym_co_await] = ACTIONS(2771),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2771),
  },
  [603] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [604] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_export] = ACTIONS(2843),
    [anon_sym_module] = ACTIONS(2843),
    [anon_sym_import] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(2905),
    [sym_identifier] = ACTIONS(2903),
    [aux_sym_preproc_include_token1] = ACTIONS(2903),
    [aux_sym_preproc_def_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token1] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2903),
    [sym_preproc_directive] = ACTIONS(2903),
    [anon_sym_LPAREN2] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2903),
    [anon_sym_typedef] = ACTIONS(2903),
    [anon_sym_virtual] = ACTIONS(2903),
    [anon_sym_extern] = ACTIONS(2903),
    [anon_sym___attribute__] = ACTIONS(2903),
    [anon_sym___attribute] = ACTIONS(2903),
    [anon_sym_using] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2905),
    [anon_sym___declspec] = ACTIONS(2903),
    [anon_sym___based] = ACTIONS(2903),
    [anon_sym___cdecl] = ACTIONS(2903),
    [anon_sym___clrcall] = ACTIONS(2903),
    [anon_sym___stdcall] = ACTIONS(2903),
    [anon_sym___fastcall] = ACTIONS(2903),
    [anon_sym___thiscall] = ACTIONS(2903),
    [anon_sym___vectorcall] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_signed] = ACTIONS(2903),
    [anon_sym_unsigned] = ACTIONS(2903),
    [anon_sym_long] = ACTIONS(2903),
    [anon_sym_short] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_register] = ACTIONS(2903),
    [anon_sym_inline] = ACTIONS(2903),
    [anon_sym___inline] = ACTIONS(2903),
    [anon_sym___inline__] = ACTIONS(2903),
    [anon_sym___forceinline] = ACTIONS(2903),
    [anon_sym_thread_local] = ACTIONS(2903),
    [anon_sym___thread] = ACTIONS(2903),
    [anon_sym_const] = ACTIONS(2903),
    [anon_sym_constexpr] = ACTIONS(2903),
    [anon_sym_volatile] = ACTIONS(2903),
    [anon_sym_restrict] = ACTIONS(2903),
    [anon_sym___restrict__] = ACTIONS(2903),
    [anon_sym__Atomic] = ACTIONS(2903),
    [anon_sym__Noreturn] = ACTIONS(2903),
    [anon_sym_noreturn] = ACTIONS(2903),
    [anon_sym__Nonnull] = ACTIONS(2903),
    [anon_sym_mutable] = ACTIONS(2903),
    [anon_sym_constinit] = ACTIONS(2903),
    [anon_sym_consteval] = ACTIONS(2903),
    [anon_sym_alignas] = ACTIONS(2903),
    [anon_sym__Alignas] = ACTIONS(2903),
    [sym_primitive_type] = ACTIONS(2903),
    [anon_sym_enum] = ACTIONS(2903),
    [anon_sym_class] = ACTIONS(2903),
    [anon_sym_struct] = ACTIONS(2903),
    [anon_sym_union] = ACTIONS(2903),
    [anon_sym_if] = ACTIONS(2903),
    [anon_sym_switch] = ACTIONS(2903),
    [anon_sym_case] = ACTIONS(2903),
    [anon_sym_default] = ACTIONS(2903),
    [anon_sym_while] = ACTIONS(2903),
    [anon_sym_do] = ACTIONS(2903),
    [anon_sym_for] = ACTIONS(2903),
    [anon_sym_return] = ACTIONS(2903),
    [anon_sym_break] = ACTIONS(2903),
    [anon_sym_continue] = ACTIONS(2903),
    [anon_sym_goto] = ACTIONS(2903),
    [anon_sym_not] = ACTIONS(2903),
    [anon_sym_compl] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_sizeof] = ACTIONS(2903),
    [anon_sym___alignof__] = ACTIONS(2903),
    [anon_sym___alignof] = ACTIONS(2903),
    [anon_sym__alignof] = ACTIONS(2903),
    [anon_sym_alignof] = ACTIONS(2903),
    [anon_sym__Alignof] = ACTIONS(2903),
    [anon_sym_offsetof] = ACTIONS(2903),
    [anon_sym__Generic] = ACTIONS(2903),
    [anon_sym_asm] = ACTIONS(2903),
    [anon_sym___asm__] = ACTIONS(2903),
    [anon_sym___asm] = ACTIONS(2903),
    [sym_number_literal] = ACTIONS(2905),
    [anon_sym_L_SQUOTE] = ACTIONS(2905),
    [anon_sym_u_SQUOTE] = ACTIONS(2905),
    [anon_sym_U_SQUOTE] = ACTIONS(2905),
    [anon_sym_u8_SQUOTE] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(2905),
    [anon_sym_L_DQUOTE] = ACTIONS(2905),
    [anon_sym_u_DQUOTE] = ACTIONS(2905),
    [anon_sym_U_DQUOTE] = ACTIONS(2905),
    [anon_sym_u8_DQUOTE] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [sym_true] = ACTIONS(2903),
    [sym_false] = ACTIONS(2903),
    [anon_sym_NULL] = ACTIONS(2903),
    [anon_sym_nullptr] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2903),
    [anon_sym_decltype] = ACTIONS(2903),
    [anon_sym_explicit] = ACTIONS(2903),
    [anon_sym_typename] = ACTIONS(2903),
    [anon_sym_export] = ACTIONS(2903),
    [anon_sym_module] = ACTIONS(2903),
    [anon_sym_import] = ACTIONS(2903),
    [anon_sym_template] = ACTIONS(2903),
    [anon_sym_operator] = ACTIONS(2903),
    [anon_sym_try] = ACTIONS(2903),
    [anon_sym_delete] = ACTIONS(2903),
    [anon_sym_throw] = ACTIONS(2903),
    [anon_sym_namespace] = ACTIONS(2903),
    [anon_sym_static_assert] = ACTIONS(2903),
    [anon_sym_concept] = ACTIONS(2903),
    [anon_sym_co_return] = ACTIONS(2903),
    [anon_sym_co_yield] = ACTIONS(2903),
    [anon_sym_R_DQUOTE] = ACTIONS(2905),
    [anon_sym_LR_DQUOTE] = ACTIONS(2905),
    [anon_sym_uR_DQUOTE] = ACTIONS(2905),
    [anon_sym_UR_DQUOTE] = ACTIONS(2905),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2905),
    [anon_sym_co_await] = ACTIONS(2903),
    [anon_sym_new] = ACTIONS(2903),
    [anon_sym_requires] = ACTIONS(2903),
    [sym_this] = ACTIONS(2903),
  },
  [607] = {
    [sym_identifier] = ACTIONS(2699),
    [aux_sym_preproc_include_token1] = ACTIONS(2699),
    [aux_sym_preproc_def_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token1] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2699),
    [sym_preproc_directive] = ACTIONS(2699),
    [anon_sym_LPAREN2] = ACTIONS(2701),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2699),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_AMP_AMP] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym___extension__] = ACTIONS(2699),
    [anon_sym_typedef] = ACTIONS(2699),
    [anon_sym_virtual] = ACTIONS(2699),
    [anon_sym_extern] = ACTIONS(2699),
    [anon_sym___attribute__] = ACTIONS(2699),
    [anon_sym___attribute] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2701),
    [anon_sym___declspec] = ACTIONS(2699),
    [anon_sym___based] = ACTIONS(2699),
    [anon_sym___cdecl] = ACTIONS(2699),
    [anon_sym___clrcall] = ACTIONS(2699),
    [anon_sym___stdcall] = ACTIONS(2699),
    [anon_sym___fastcall] = ACTIONS(2699),
    [anon_sym___thiscall] = ACTIONS(2699),
    [anon_sym___vectorcall] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(2701),
    [anon_sym_RBRACE] = ACTIONS(2701),
    [anon_sym_signed] = ACTIONS(2699),
    [anon_sym_unsigned] = ACTIONS(2699),
    [anon_sym_long] = ACTIONS(2699),
    [anon_sym_short] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_register] = ACTIONS(2699),
    [anon_sym_inline] = ACTIONS(2699),
    [anon_sym___inline] = ACTIONS(2699),
    [anon_sym___inline__] = ACTIONS(2699),
    [anon_sym___forceinline] = ACTIONS(2699),
    [anon_sym_thread_local] = ACTIONS(2699),
    [anon_sym___thread] = ACTIONS(2699),
    [anon_sym_const] = ACTIONS(2699),
    [anon_sym_constexpr] = ACTIONS(2699),
    [anon_sym_volatile] = ACTIONS(2699),
    [anon_sym_restrict] = ACTIONS(2699),
    [anon_sym___restrict__] = ACTIONS(2699),
    [anon_sym__Atomic] = ACTIONS(2699),
    [anon_sym__Noreturn] = ACTIONS(2699),
    [anon_sym_noreturn] = ACTIONS(2699),
    [anon_sym__Nonnull] = ACTIONS(2699),
    [anon_sym_mutable] = ACTIONS(2699),
    [anon_sym_constinit] = ACTIONS(2699),
    [anon_sym_consteval] = ACTIONS(2699),
    [anon_sym_alignas] = ACTIONS(2699),
    [anon_sym__Alignas] = ACTIONS(2699),
    [sym_primitive_type] = ACTIONS(2699),
    [anon_sym_enum] = ACTIONS(2699),
    [anon_sym_class] = ACTIONS(2699),
    [anon_sym_struct] = ACTIONS(2699),
    [anon_sym_union] = ACTIONS(2699),
    [anon_sym_if] = ACTIONS(2699),
    [anon_sym_else] = ACTIONS(2699),
    [anon_sym_switch] = ACTIONS(2699),
    [anon_sym_case] = ACTIONS(2699),
    [anon_sym_default] = ACTIONS(2699),
    [anon_sym_while] = ACTIONS(2699),
    [anon_sym_do] = ACTIONS(2699),
    [anon_sym_for] = ACTIONS(2699),
    [anon_sym_return] = ACTIONS(2699),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_continue] = ACTIONS(2699),
    [anon_sym_goto] = ACTIONS(2699),
    [anon_sym___try] = ACTIONS(2699),
    [anon_sym___leave] = ACTIONS(2699),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_compl] = ACTIONS(2699),
    [anon_sym_DASH_DASH] = ACTIONS(2701),
    [anon_sym_PLUS_PLUS] = ACTIONS(2701),
    [anon_sym_sizeof] = ACTIONS(2699),
    [anon_sym___alignof__] = ACTIONS(2699),
    [anon_sym___alignof] = ACTIONS(2699),
    [anon_sym__alignof] = ACTIONS(2699),
    [anon_sym_alignof] = ACTIONS(2699),
    [anon_sym__Alignof] = ACTIONS(2699),
    [anon_sym_offsetof] = ACTIONS(2699),
    [anon_sym__Generic] = ACTIONS(2699),
    [anon_sym_asm] = ACTIONS(2699),
    [anon_sym___asm__] = ACTIONS(2699),
    [anon_sym___asm] = ACTIONS(2699),
    [sym_number_literal] = ACTIONS(2701),
    [anon_sym_L_SQUOTE] = ACTIONS(2701),
    [anon_sym_u_SQUOTE] = ACTIONS(2701),
    [anon_sym_U_SQUOTE] = ACTIONS(2701),
    [anon_sym_u8_SQUOTE] = ACTIONS(2701),
    [anon_sym_SQUOTE] = ACTIONS(2701),
    [anon_sym_L_DQUOTE] = ACTIONS(2701),
    [anon_sym_u_DQUOTE] = ACTIONS(2701),
    [anon_sym_U_DQUOTE] = ACTIONS(2701),
    [anon_sym_u8_DQUOTE] = ACTIONS(2701),
    [anon_sym_DQUOTE] = ACTIONS(2701),
    [sym_true] = ACTIONS(2699),
    [sym_false] = ACTIONS(2699),
    [anon_sym_NULL] = ACTIONS(2699),
    [anon_sym_nullptr] = ACTIONS(2699),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2699),
    [anon_sym_decltype] = ACTIONS(2699),
    [anon_sym_explicit] = ACTIONS(2699),
    [anon_sym_typename] = ACTIONS(2699),
    [anon_sym_template] = ACTIONS(2699),
    [anon_sym_operator] = ACTIONS(2699),
    [anon_sym_try] = ACTIONS(2699),
    [anon_sym_delete] = ACTIONS(2699),
    [anon_sym_throw] = ACTIONS(2699),
    [anon_sym_namespace] = ACTIONS(2699),
    [anon_sym_static_assert] = ACTIONS(2699),
    [anon_sym_concept] = ACTIONS(2699),
    [anon_sym_co_return] = ACTIONS(2699),
    [anon_sym_co_yield] = ACTIONS(2699),
    [anon_sym_R_DQUOTE] = ACTIONS(2701),
    [anon_sym_LR_DQUOTE] = ACTIONS(2701),
    [anon_sym_uR_DQUOTE] = ACTIONS(2701),
    [anon_sym_UR_DQUOTE] = ACTIONS(2701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2701),
    [anon_sym_co_await] = ACTIONS(2699),
    [anon_sym_new] = ACTIONS(2699),
    [anon_sym_requires] = ACTIONS(2699),
    [sym_this] = ACTIONS(2699),
  },
  [608] = {
    [sym_identifier] = ACTIONS(2699),
    [aux_sym_preproc_include_token1] = ACTIONS(2699),
    [aux_sym_preproc_def_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token2] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2699),
    [sym_preproc_directive] = ACTIONS(2699),
    [anon_sym_LPAREN2] = ACTIONS(2701),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2699),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_AMP_AMP] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym___extension__] = ACTIONS(2699),
    [anon_sym_typedef] = ACTIONS(2699),
    [anon_sym_virtual] = ACTIONS(2699),
    [anon_sym_extern] = ACTIONS(2699),
    [anon_sym___attribute__] = ACTIONS(2699),
    [anon_sym___attribute] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2701),
    [anon_sym___declspec] = ACTIONS(2699),
    [anon_sym___based] = ACTIONS(2699),
    [anon_sym___cdecl] = ACTIONS(2699),
    [anon_sym___clrcall] = ACTIONS(2699),
    [anon_sym___stdcall] = ACTIONS(2699),
    [anon_sym___fastcall] = ACTIONS(2699),
    [anon_sym___thiscall] = ACTIONS(2699),
    [anon_sym___vectorcall] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(2701),
    [anon_sym_signed] = ACTIONS(2699),
    [anon_sym_unsigned] = ACTIONS(2699),
    [anon_sym_long] = ACTIONS(2699),
    [anon_sym_short] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_register] = ACTIONS(2699),
    [anon_sym_inline] = ACTIONS(2699),
    [anon_sym___inline] = ACTIONS(2699),
    [anon_sym___inline__] = ACTIONS(2699),
    [anon_sym___forceinline] = ACTIONS(2699),
    [anon_sym_thread_local] = ACTIONS(2699),
    [anon_sym___thread] = ACTIONS(2699),
    [anon_sym_const] = ACTIONS(2699),
    [anon_sym_constexpr] = ACTIONS(2699),
    [anon_sym_volatile] = ACTIONS(2699),
    [anon_sym_restrict] = ACTIONS(2699),
    [anon_sym___restrict__] = ACTIONS(2699),
    [anon_sym__Atomic] = ACTIONS(2699),
    [anon_sym__Noreturn] = ACTIONS(2699),
    [anon_sym_noreturn] = ACTIONS(2699),
    [anon_sym__Nonnull] = ACTIONS(2699),
    [anon_sym_mutable] = ACTIONS(2699),
    [anon_sym_constinit] = ACTIONS(2699),
    [anon_sym_consteval] = ACTIONS(2699),
    [anon_sym_alignas] = ACTIONS(2699),
    [anon_sym__Alignas] = ACTIONS(2699),
    [sym_primitive_type] = ACTIONS(2699),
    [anon_sym_enum] = ACTIONS(2699),
    [anon_sym_class] = ACTIONS(2699),
    [anon_sym_struct] = ACTIONS(2699),
    [anon_sym_union] = ACTIONS(2699),
    [anon_sym_if] = ACTIONS(2699),
    [anon_sym_else] = ACTIONS(2699),
    [anon_sym_switch] = ACTIONS(2699),
    [anon_sym_case] = ACTIONS(2699),
    [anon_sym_default] = ACTIONS(2699),
    [anon_sym_while] = ACTIONS(2699),
    [anon_sym_do] = ACTIONS(2699),
    [anon_sym_for] = ACTIONS(2699),
    [anon_sym_return] = ACTIONS(2699),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_continue] = ACTIONS(2699),
    [anon_sym_goto] = ACTIONS(2699),
    [anon_sym___try] = ACTIONS(2699),
    [anon_sym___leave] = ACTIONS(2699),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_compl] = ACTIONS(2699),
    [anon_sym_DASH_DASH] = ACTIONS(2701),
    [anon_sym_PLUS_PLUS] = ACTIONS(2701),
    [anon_sym_sizeof] = ACTIONS(2699),
    [anon_sym___alignof__] = ACTIONS(2699),
    [anon_sym___alignof] = ACTIONS(2699),
    [anon_sym__alignof] = ACTIONS(2699),
    [anon_sym_alignof] = ACTIONS(2699),
    [anon_sym__Alignof] = ACTIONS(2699),
    [anon_sym_offsetof] = ACTIONS(2699),
    [anon_sym__Generic] = ACTIONS(2699),
    [anon_sym_asm] = ACTIONS(2699),
    [anon_sym___asm__] = ACTIONS(2699),
    [anon_sym___asm] = ACTIONS(2699),
    [sym_number_literal] = ACTIONS(2701),
    [anon_sym_L_SQUOTE] = ACTIONS(2701),
    [anon_sym_u_SQUOTE] = ACTIONS(2701),
    [anon_sym_U_SQUOTE] = ACTIONS(2701),
    [anon_sym_u8_SQUOTE] = ACTIONS(2701),
    [anon_sym_SQUOTE] = ACTIONS(2701),
    [anon_sym_L_DQUOTE] = ACTIONS(2701),
    [anon_sym_u_DQUOTE] = ACTIONS(2701),
    [anon_sym_U_DQUOTE] = ACTIONS(2701),
    [anon_sym_u8_DQUOTE] = ACTIONS(2701),
    [anon_sym_DQUOTE] = ACTIONS(2701),
    [sym_true] = ACTIONS(2699),
    [sym_false] = ACTIONS(2699),
    [anon_sym_NULL] = ACTIONS(2699),
    [anon_sym_nullptr] = ACTIONS(2699),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2699),
    [anon_sym_decltype] = ACTIONS(2699),
    [anon_sym_explicit] = ACTIONS(2699),
    [anon_sym_typename] = ACTIONS(2699),
    [anon_sym_template] = ACTIONS(2699),
    [anon_sym_operator] = ACTIONS(2699),
    [anon_sym_try] = ACTIONS(2699),
    [anon_sym_delete] = ACTIONS(2699),
    [anon_sym_throw] = ACTIONS(2699),
    [anon_sym_namespace] = ACTIONS(2699),
    [anon_sym_static_assert] = ACTIONS(2699),
    [anon_sym_concept] = ACTIONS(2699),
    [anon_sym_co_return] = ACTIONS(2699),
    [anon_sym_co_yield] = ACTIONS(2699),
    [anon_sym_R_DQUOTE] = ACTIONS(2701),
    [anon_sym_LR_DQUOTE] = ACTIONS(2701),
    [anon_sym_uR_DQUOTE] = ACTIONS(2701),
    [anon_sym_UR_DQUOTE] = ACTIONS(2701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2701),
    [anon_sym_co_await] = ACTIONS(2699),
    [anon_sym_new] = ACTIONS(2699),
    [anon_sym_requires] = ACTIONS(2699),
    [sym_this] = ACTIONS(2699),
  },
  [609] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym___attribute] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym__Nonnull] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym__Alignas] = ACTIONS(2639),
    [sym_primitive_type] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [anon_sym___asm] = ACTIONS(2639),
    [sym_number_literal] = ACTIONS(2641),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [610] = {
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token2] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym___attribute] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym__Nonnull] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym__Alignas] = ACTIONS(2665),
    [sym_primitive_type] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [anon_sym___asm] = ACTIONS(2665),
    [sym_number_literal] = ACTIONS(2667),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(3321),
    [sym_identifier] = ACTIONS(3319),
    [aux_sym_preproc_include_token1] = ACTIONS(3319),
    [aux_sym_preproc_def_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token1] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3319),
    [sym_preproc_directive] = ACTIONS(3319),
    [anon_sym_LPAREN2] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym___extension__] = ACTIONS(3319),
    [anon_sym_typedef] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym___attribute__] = ACTIONS(3319),
    [anon_sym___attribute] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_COLON_COLON] = ACTIONS(3321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3321),
    [anon_sym___declspec] = ACTIONS(3319),
    [anon_sym___based] = ACTIONS(3319),
    [anon_sym___cdecl] = ACTIONS(3319),
    [anon_sym___clrcall] = ACTIONS(3319),
    [anon_sym___stdcall] = ACTIONS(3319),
    [anon_sym___fastcall] = ACTIONS(3319),
    [anon_sym___thiscall] = ACTIONS(3319),
    [anon_sym___vectorcall] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_signed] = ACTIONS(3319),
    [anon_sym_unsigned] = ACTIONS(3319),
    [anon_sym_long] = ACTIONS(3319),
    [anon_sym_short] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_register] = ACTIONS(3319),
    [anon_sym_inline] = ACTIONS(3319),
    [anon_sym___inline] = ACTIONS(3319),
    [anon_sym___inline__] = ACTIONS(3319),
    [anon_sym___forceinline] = ACTIONS(3319),
    [anon_sym_thread_local] = ACTIONS(3319),
    [anon_sym___thread] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_constexpr] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_restrict] = ACTIONS(3319),
    [anon_sym___restrict__] = ACTIONS(3319),
    [anon_sym__Atomic] = ACTIONS(3319),
    [anon_sym__Noreturn] = ACTIONS(3319),
    [anon_sym_noreturn] = ACTIONS(3319),
    [anon_sym__Nonnull] = ACTIONS(3319),
    [anon_sym_mutable] = ACTIONS(3319),
    [anon_sym_constinit] = ACTIONS(3319),
    [anon_sym_consteval] = ACTIONS(3319),
    [anon_sym_alignas] = ACTIONS(3319),
    [anon_sym__Alignas] = ACTIONS(3319),
    [sym_primitive_type] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_union] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_case] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_goto] = ACTIONS(3319),
    [anon_sym_not] = ACTIONS(3319),
    [anon_sym_compl] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_sizeof] = ACTIONS(3319),
    [anon_sym___alignof__] = ACTIONS(3319),
    [anon_sym___alignof] = ACTIONS(3319),
    [anon_sym__alignof] = ACTIONS(3319),
    [anon_sym_alignof] = ACTIONS(3319),
    [anon_sym__Alignof] = ACTIONS(3319),
    [anon_sym_offsetof] = ACTIONS(3319),
    [anon_sym__Generic] = ACTIONS(3319),
    [anon_sym_asm] = ACTIONS(3319),
    [anon_sym___asm__] = ACTIONS(3319),
    [anon_sym___asm] = ACTIONS(3319),
    [sym_number_literal] = ACTIONS(3321),
    [anon_sym_L_SQUOTE] = ACTIONS(3321),
    [anon_sym_u_SQUOTE] = ACTIONS(3321),
    [anon_sym_U_SQUOTE] = ACTIONS(3321),
    [anon_sym_u8_SQUOTE] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [anon_sym_L_DQUOTE] = ACTIONS(3321),
    [anon_sym_u_DQUOTE] = ACTIONS(3321),
    [anon_sym_U_DQUOTE] = ACTIONS(3321),
    [anon_sym_u8_DQUOTE] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [sym_true] = ACTIONS(3319),
    [sym_false] = ACTIONS(3319),
    [anon_sym_NULL] = ACTIONS(3319),
    [anon_sym_nullptr] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3319),
    [anon_sym_decltype] = ACTIONS(3319),
    [anon_sym_explicit] = ACTIONS(3319),
    [anon_sym_typename] = ACTIONS(3319),
    [anon_sym_export] = ACTIONS(3319),
    [anon_sym_module] = ACTIONS(3319),
    [anon_sym_import] = ACTIONS(3319),
    [anon_sym_template] = ACTIONS(3319),
    [anon_sym_operator] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_delete] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_static_assert] = ACTIONS(3319),
    [anon_sym_concept] = ACTIONS(3319),
    [anon_sym_co_return] = ACTIONS(3319),
    [anon_sym_co_yield] = ACTIONS(3319),
    [anon_sym_R_DQUOTE] = ACTIONS(3321),
    [anon_sym_LR_DQUOTE] = ACTIONS(3321),
    [anon_sym_uR_DQUOTE] = ACTIONS(3321),
    [anon_sym_UR_DQUOTE] = ACTIONS(3321),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3321),
    [anon_sym_co_await] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3319),
    [sym_this] = ACTIONS(3319),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(3106),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_include_token1] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym___cdecl] = ACTIONS(3104),
    [anon_sym___clrcall] = ACTIONS(3104),
    [anon_sym___stdcall] = ACTIONS(3104),
    [anon_sym___fastcall] = ACTIONS(3104),
    [anon_sym___thiscall] = ACTIONS(3104),
    [anon_sym___vectorcall] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym_not] = ACTIONS(3104),
    [anon_sym_compl] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3106),
    [anon_sym_PLUS_PLUS] = ACTIONS(3106),
    [anon_sym_sizeof] = ACTIONS(3104),
    [anon_sym___alignof__] = ACTIONS(3104),
    [anon_sym___alignof] = ACTIONS(3104),
    [anon_sym__alignof] = ACTIONS(3104),
    [anon_sym_alignof] = ACTIONS(3104),
    [anon_sym__Alignof] = ACTIONS(3104),
    [anon_sym_offsetof] = ACTIONS(3104),
    [anon_sym__Generic] = ACTIONS(3104),
    [anon_sym_asm] = ACTIONS(3104),
    [anon_sym___asm__] = ACTIONS(3104),
    [anon_sym___asm] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3106),
    [anon_sym_L_SQUOTE] = ACTIONS(3106),
    [anon_sym_u_SQUOTE] = ACTIONS(3106),
    [anon_sym_U_SQUOTE] = ACTIONS(3106),
    [anon_sym_u8_SQUOTE] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3106),
    [anon_sym_L_DQUOTE] = ACTIONS(3106),
    [anon_sym_u_DQUOTE] = ACTIONS(3106),
    [anon_sym_U_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8_DQUOTE] = ACTIONS(3106),
    [anon_sym_DQUOTE] = ACTIONS(3106),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [anon_sym_NULL] = ACTIONS(3104),
    [anon_sym_nullptr] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_export] = ACTIONS(3104),
    [anon_sym_module] = ACTIONS(3104),
    [anon_sym_import] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_try] = ACTIONS(3104),
    [anon_sym_delete] = ACTIONS(3104),
    [anon_sym_throw] = ACTIONS(3104),
    [anon_sym_namespace] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
    [anon_sym_concept] = ACTIONS(3104),
    [anon_sym_co_return] = ACTIONS(3104),
    [anon_sym_co_yield] = ACTIONS(3104),
    [anon_sym_R_DQUOTE] = ACTIONS(3106),
    [anon_sym_LR_DQUOTE] = ACTIONS(3106),
    [anon_sym_uR_DQUOTE] = ACTIONS(3106),
    [anon_sym_UR_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3106),
    [anon_sym_co_await] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_requires] = ACTIONS(3104),
    [sym_this] = ACTIONS(3104),
  },
  [613] = {
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym___attribute] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym__Nonnull] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym__Alignas] = ACTIONS(2665),
    [sym_primitive_type] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [anon_sym___asm] = ACTIONS(2665),
    [sym_number_literal] = ACTIONS(2667),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [614] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym___attribute] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym__Nonnull] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym__Alignas] = ACTIONS(2639),
    [sym_primitive_type] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [anon_sym___asm] = ACTIONS(2639),
    [sym_number_literal] = ACTIONS(2641),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [615] = {
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym___attribute] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_RBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym__Nonnull] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym__Alignas] = ACTIONS(2669),
    [sym_primitive_type] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [anon_sym___asm] = ACTIONS(2669),
    [sym_number_literal] = ACTIONS(2671),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [616] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym___attribute] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym__Nonnull] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym__Alignas] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [anon_sym___asm] = ACTIONS(2723),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [617] = {
    [sym_identifier] = ACTIONS(2651),
    [aux_sym_preproc_include_token1] = ACTIONS(2651),
    [aux_sym_preproc_def_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token2] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2651),
    [sym_preproc_directive] = ACTIONS(2651),
    [anon_sym_LPAREN2] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym___extension__] = ACTIONS(2651),
    [anon_sym_typedef] = ACTIONS(2651),
    [anon_sym_virtual] = ACTIONS(2651),
    [anon_sym_extern] = ACTIONS(2651),
    [anon_sym___attribute__] = ACTIONS(2651),
    [anon_sym___attribute] = ACTIONS(2651),
    [anon_sym_using] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2653),
    [anon_sym___declspec] = ACTIONS(2651),
    [anon_sym___based] = ACTIONS(2651),
    [anon_sym___cdecl] = ACTIONS(2651),
    [anon_sym___clrcall] = ACTIONS(2651),
    [anon_sym___stdcall] = ACTIONS(2651),
    [anon_sym___fastcall] = ACTIONS(2651),
    [anon_sym___thiscall] = ACTIONS(2651),
    [anon_sym___vectorcall] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2653),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2651),
    [anon_sym_register] = ACTIONS(2651),
    [anon_sym_inline] = ACTIONS(2651),
    [anon_sym___inline] = ACTIONS(2651),
    [anon_sym___inline__] = ACTIONS(2651),
    [anon_sym___forceinline] = ACTIONS(2651),
    [anon_sym_thread_local] = ACTIONS(2651),
    [anon_sym___thread] = ACTIONS(2651),
    [anon_sym_const] = ACTIONS(2651),
    [anon_sym_constexpr] = ACTIONS(2651),
    [anon_sym_volatile] = ACTIONS(2651),
    [anon_sym_restrict] = ACTIONS(2651),
    [anon_sym___restrict__] = ACTIONS(2651),
    [anon_sym__Atomic] = ACTIONS(2651),
    [anon_sym__Noreturn] = ACTIONS(2651),
    [anon_sym_noreturn] = ACTIONS(2651),
    [anon_sym__Nonnull] = ACTIONS(2651),
    [anon_sym_mutable] = ACTIONS(2651),
    [anon_sym_constinit] = ACTIONS(2651),
    [anon_sym_consteval] = ACTIONS(2651),
    [anon_sym_alignas] = ACTIONS(2651),
    [anon_sym__Alignas] = ACTIONS(2651),
    [sym_primitive_type] = ACTIONS(2651),
    [anon_sym_enum] = ACTIONS(2651),
    [anon_sym_class] = ACTIONS(2651),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_union] = ACTIONS(2651),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_else] = ACTIONS(2651),
    [anon_sym_switch] = ACTIONS(2651),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_default] = ACTIONS(2651),
    [anon_sym_while] = ACTIONS(2651),
    [anon_sym_do] = ACTIONS(2651),
    [anon_sym_for] = ACTIONS(2651),
    [anon_sym_return] = ACTIONS(2651),
    [anon_sym_break] = ACTIONS(2651),
    [anon_sym_continue] = ACTIONS(2651),
    [anon_sym_goto] = ACTIONS(2651),
    [anon_sym___try] = ACTIONS(2651),
    [anon_sym___leave] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2651),
    [anon_sym_compl] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2653),
    [anon_sym_sizeof] = ACTIONS(2651),
    [anon_sym___alignof__] = ACTIONS(2651),
    [anon_sym___alignof] = ACTIONS(2651),
    [anon_sym__alignof] = ACTIONS(2651),
    [anon_sym_alignof] = ACTIONS(2651),
    [anon_sym__Alignof] = ACTIONS(2651),
    [anon_sym_offsetof] = ACTIONS(2651),
    [anon_sym__Generic] = ACTIONS(2651),
    [anon_sym_asm] = ACTIONS(2651),
    [anon_sym___asm__] = ACTIONS(2651),
    [anon_sym___asm] = ACTIONS(2651),
    [sym_number_literal] = ACTIONS(2653),
    [anon_sym_L_SQUOTE] = ACTIONS(2653),
    [anon_sym_u_SQUOTE] = ACTIONS(2653),
    [anon_sym_U_SQUOTE] = ACTIONS(2653),
    [anon_sym_u8_SQUOTE] = ACTIONS(2653),
    [anon_sym_SQUOTE] = ACTIONS(2653),
    [anon_sym_L_DQUOTE] = ACTIONS(2653),
    [anon_sym_u_DQUOTE] = ACTIONS(2653),
    [anon_sym_U_DQUOTE] = ACTIONS(2653),
    [anon_sym_u8_DQUOTE] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(2653),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [anon_sym_NULL] = ACTIONS(2651),
    [anon_sym_nullptr] = ACTIONS(2651),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2651),
    [anon_sym_decltype] = ACTIONS(2651),
    [anon_sym_explicit] = ACTIONS(2651),
    [anon_sym_typename] = ACTIONS(2651),
    [anon_sym_template] = ACTIONS(2651),
    [anon_sym_operator] = ACTIONS(2651),
    [anon_sym_try] = ACTIONS(2651),
    [anon_sym_delete] = ACTIONS(2651),
    [anon_sym_throw] = ACTIONS(2651),
    [anon_sym_namespace] = ACTIONS(2651),
    [anon_sym_static_assert] = ACTIONS(2651),
    [anon_sym_concept] = ACTIONS(2651),
    [anon_sym_co_return] = ACTIONS(2651),
    [anon_sym_co_yield] = ACTIONS(2651),
    [anon_sym_R_DQUOTE] = ACTIONS(2653),
    [anon_sym_LR_DQUOTE] = ACTIONS(2653),
    [anon_sym_uR_DQUOTE] = ACTIONS(2653),
    [anon_sym_UR_DQUOTE] = ACTIONS(2653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2653),
    [anon_sym_co_await] = ACTIONS(2651),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_requires] = ACTIONS(2651),
    [sym_this] = ACTIONS(2651),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(2913),
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_include_token1] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym___cdecl] = ACTIONS(2911),
    [anon_sym___clrcall] = ACTIONS(2911),
    [anon_sym___stdcall] = ACTIONS(2911),
    [anon_sym___fastcall] = ACTIONS(2911),
    [anon_sym___thiscall] = ACTIONS(2911),
    [anon_sym___vectorcall] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2911),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2911),
    [anon_sym_return] = ACTIONS(2911),
    [anon_sym_break] = ACTIONS(2911),
    [anon_sym_continue] = ACTIONS(2911),
    [anon_sym_goto] = ACTIONS(2911),
    [anon_sym_not] = ACTIONS(2911),
    [anon_sym_compl] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_sizeof] = ACTIONS(2911),
    [anon_sym___alignof__] = ACTIONS(2911),
    [anon_sym___alignof] = ACTIONS(2911),
    [anon_sym__alignof] = ACTIONS(2911),
    [anon_sym_alignof] = ACTIONS(2911),
    [anon_sym__Alignof] = ACTIONS(2911),
    [anon_sym_offsetof] = ACTIONS(2911),
    [anon_sym__Generic] = ACTIONS(2911),
    [anon_sym_asm] = ACTIONS(2911),
    [anon_sym___asm__] = ACTIONS(2911),
    [anon_sym___asm] = ACTIONS(2911),
    [sym_number_literal] = ACTIONS(2913),
    [anon_sym_L_SQUOTE] = ACTIONS(2913),
    [anon_sym_u_SQUOTE] = ACTIONS(2913),
    [anon_sym_U_SQUOTE] = ACTIONS(2913),
    [anon_sym_u8_SQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_L_DQUOTE] = ACTIONS(2913),
    [anon_sym_u_DQUOTE] = ACTIONS(2913),
    [anon_sym_U_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8_DQUOTE] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [sym_true] = ACTIONS(2911),
    [sym_false] = ACTIONS(2911),
    [anon_sym_NULL] = ACTIONS(2911),
    [anon_sym_nullptr] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_export] = ACTIONS(2911),
    [anon_sym_module] = ACTIONS(2911),
    [anon_sym_import] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2911),
    [anon_sym_delete] = ACTIONS(2911),
    [anon_sym_throw] = ACTIONS(2911),
    [anon_sym_namespace] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
    [anon_sym_concept] = ACTIONS(2911),
    [anon_sym_co_return] = ACTIONS(2911),
    [anon_sym_co_yield] = ACTIONS(2911),
    [anon_sym_R_DQUOTE] = ACTIONS(2913),
    [anon_sym_LR_DQUOTE] = ACTIONS(2913),
    [anon_sym_uR_DQUOTE] = ACTIONS(2913),
    [anon_sym_UR_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2913),
    [anon_sym_co_await] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2911),
    [anon_sym_requires] = ACTIONS(2911),
    [sym_this] = ACTIONS(2911),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_export] = ACTIONS(2843),
    [anon_sym_module] = ACTIONS(2843),
    [anon_sym_import] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(2893),
    [sym_identifier] = ACTIONS(2891),
    [aux_sym_preproc_include_token1] = ACTIONS(2891),
    [aux_sym_preproc_def_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2891),
    [sym_preproc_directive] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2891),
    [anon_sym_typedef] = ACTIONS(2891),
    [anon_sym_virtual] = ACTIONS(2891),
    [anon_sym_extern] = ACTIONS(2891),
    [anon_sym___attribute__] = ACTIONS(2891),
    [anon_sym___attribute] = ACTIONS(2891),
    [anon_sym_using] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2893),
    [anon_sym___declspec] = ACTIONS(2891),
    [anon_sym___based] = ACTIONS(2891),
    [anon_sym___cdecl] = ACTIONS(2891),
    [anon_sym___clrcall] = ACTIONS(2891),
    [anon_sym___stdcall] = ACTIONS(2891),
    [anon_sym___fastcall] = ACTIONS(2891),
    [anon_sym___thiscall] = ACTIONS(2891),
    [anon_sym___vectorcall] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2891),
    [anon_sym_unsigned] = ACTIONS(2891),
    [anon_sym_long] = ACTIONS(2891),
    [anon_sym_short] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_register] = ACTIONS(2891),
    [anon_sym_inline] = ACTIONS(2891),
    [anon_sym___inline] = ACTIONS(2891),
    [anon_sym___inline__] = ACTIONS(2891),
    [anon_sym___forceinline] = ACTIONS(2891),
    [anon_sym_thread_local] = ACTIONS(2891),
    [anon_sym___thread] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_constexpr] = ACTIONS(2891),
    [anon_sym_volatile] = ACTIONS(2891),
    [anon_sym_restrict] = ACTIONS(2891),
    [anon_sym___restrict__] = ACTIONS(2891),
    [anon_sym__Atomic] = ACTIONS(2891),
    [anon_sym__Noreturn] = ACTIONS(2891),
    [anon_sym_noreturn] = ACTIONS(2891),
    [anon_sym__Nonnull] = ACTIONS(2891),
    [anon_sym_mutable] = ACTIONS(2891),
    [anon_sym_constinit] = ACTIONS(2891),
    [anon_sym_consteval] = ACTIONS(2891),
    [anon_sym_alignas] = ACTIONS(2891),
    [anon_sym__Alignas] = ACTIONS(2891),
    [sym_primitive_type] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2891),
    [anon_sym_union] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_goto] = ACTIONS(2891),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_compl] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_sizeof] = ACTIONS(2891),
    [anon_sym___alignof__] = ACTIONS(2891),
    [anon_sym___alignof] = ACTIONS(2891),
    [anon_sym__alignof] = ACTIONS(2891),
    [anon_sym_alignof] = ACTIONS(2891),
    [anon_sym__Alignof] = ACTIONS(2891),
    [anon_sym_offsetof] = ACTIONS(2891),
    [anon_sym__Generic] = ACTIONS(2891),
    [anon_sym_asm] = ACTIONS(2891),
    [anon_sym___asm__] = ACTIONS(2891),
    [anon_sym___asm] = ACTIONS(2891),
    [sym_number_literal] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2893),
    [anon_sym_u_SQUOTE] = ACTIONS(2893),
    [anon_sym_U_SQUOTE] = ACTIONS(2893),
    [anon_sym_u8_SQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_L_DQUOTE] = ACTIONS(2893),
    [anon_sym_u_DQUOTE] = ACTIONS(2893),
    [anon_sym_U_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [anon_sym_NULL] = ACTIONS(2891),
    [anon_sym_nullptr] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2891),
    [anon_sym_decltype] = ACTIONS(2891),
    [anon_sym_explicit] = ACTIONS(2891),
    [anon_sym_typename] = ACTIONS(2891),
    [anon_sym_export] = ACTIONS(2891),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_import] = ACTIONS(2891),
    [anon_sym_template] = ACTIONS(2891),
    [anon_sym_operator] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_static_assert] = ACTIONS(2891),
    [anon_sym_concept] = ACTIONS(2891),
    [anon_sym_co_return] = ACTIONS(2891),
    [anon_sym_co_yield] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2893),
    [anon_sym_LR_DQUOTE] = ACTIONS(2893),
    [anon_sym_uR_DQUOTE] = ACTIONS(2893),
    [anon_sym_UR_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2893),
    [anon_sym_co_await] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_requires] = ACTIONS(2891),
    [sym_this] = ACTIONS(2891),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(2785),
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_include_token1] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym___attribute] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym___cdecl] = ACTIONS(2783),
    [anon_sym___clrcall] = ACTIONS(2783),
    [anon_sym___stdcall] = ACTIONS(2783),
    [anon_sym___fastcall] = ACTIONS(2783),
    [anon_sym___thiscall] = ACTIONS(2783),
    [anon_sym___vectorcall] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym__Nonnull] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym__Alignas] = ACTIONS(2783),
    [sym_primitive_type] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_switch] = ACTIONS(2783),
    [anon_sym_case] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_goto] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_compl] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_sizeof] = ACTIONS(2783),
    [anon_sym___alignof__] = ACTIONS(2783),
    [anon_sym___alignof] = ACTIONS(2783),
    [anon_sym__alignof] = ACTIONS(2783),
    [anon_sym_alignof] = ACTIONS(2783),
    [anon_sym__Alignof] = ACTIONS(2783),
    [anon_sym_offsetof] = ACTIONS(2783),
    [anon_sym__Generic] = ACTIONS(2783),
    [anon_sym_asm] = ACTIONS(2783),
    [anon_sym___asm__] = ACTIONS(2783),
    [anon_sym___asm] = ACTIONS(2783),
    [sym_number_literal] = ACTIONS(2785),
    [anon_sym_L_SQUOTE] = ACTIONS(2785),
    [anon_sym_u_SQUOTE] = ACTIONS(2785),
    [anon_sym_U_SQUOTE] = ACTIONS(2785),
    [anon_sym_u8_SQUOTE] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_L_DQUOTE] = ACTIONS(2785),
    [anon_sym_u_DQUOTE] = ACTIONS(2785),
    [anon_sym_U_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [anon_sym_NULL] = ACTIONS(2783),
    [anon_sym_nullptr] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_export] = ACTIONS(2783),
    [anon_sym_module] = ACTIONS(2783),
    [anon_sym_import] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_throw] = ACTIONS(2783),
    [anon_sym_namespace] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
    [anon_sym_concept] = ACTIONS(2783),
    [anon_sym_co_return] = ACTIONS(2783),
    [anon_sym_co_yield] = ACTIONS(2783),
    [anon_sym_R_DQUOTE] = ACTIONS(2785),
    [anon_sym_LR_DQUOTE] = ACTIONS(2785),
    [anon_sym_uR_DQUOTE] = ACTIONS(2785),
    [anon_sym_UR_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2785),
    [anon_sym_co_await] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_requires] = ACTIONS(2783),
    [sym_this] = ACTIONS(2783),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2787),
    [aux_sym_preproc_include_token1] = ACTIONS(2787),
    [aux_sym_preproc_def_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token1] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2787),
    [sym_preproc_directive] = ACTIONS(2787),
    [anon_sym_LPAREN2] = ACTIONS(2789),
    [anon_sym_BANG] = ACTIONS(2789),
    [anon_sym_TILDE] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym___extension__] = ACTIONS(2787),
    [anon_sym_typedef] = ACTIONS(2787),
    [anon_sym_virtual] = ACTIONS(2787),
    [anon_sym_extern] = ACTIONS(2787),
    [anon_sym___attribute__] = ACTIONS(2787),
    [anon_sym___attribute] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2789),
    [anon_sym___declspec] = ACTIONS(2787),
    [anon_sym___based] = ACTIONS(2787),
    [anon_sym___cdecl] = ACTIONS(2787),
    [anon_sym___clrcall] = ACTIONS(2787),
    [anon_sym___stdcall] = ACTIONS(2787),
    [anon_sym___fastcall] = ACTIONS(2787),
    [anon_sym___thiscall] = ACTIONS(2787),
    [anon_sym___vectorcall] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_signed] = ACTIONS(2787),
    [anon_sym_unsigned] = ACTIONS(2787),
    [anon_sym_long] = ACTIONS(2787),
    [anon_sym_short] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_static] = ACTIONS(2787),
    [anon_sym_register] = ACTIONS(2787),
    [anon_sym_inline] = ACTIONS(2787),
    [anon_sym___inline] = ACTIONS(2787),
    [anon_sym___inline__] = ACTIONS(2787),
    [anon_sym___forceinline] = ACTIONS(2787),
    [anon_sym_thread_local] = ACTIONS(2787),
    [anon_sym___thread] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_constexpr] = ACTIONS(2787),
    [anon_sym_volatile] = ACTIONS(2787),
    [anon_sym_restrict] = ACTIONS(2787),
    [anon_sym___restrict__] = ACTIONS(2787),
    [anon_sym__Atomic] = ACTIONS(2787),
    [anon_sym__Noreturn] = ACTIONS(2787),
    [anon_sym_noreturn] = ACTIONS(2787),
    [anon_sym__Nonnull] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_constinit] = ACTIONS(2787),
    [anon_sym_consteval] = ACTIONS(2787),
    [anon_sym_alignas] = ACTIONS(2787),
    [anon_sym__Alignas] = ACTIONS(2787),
    [sym_primitive_type] = ACTIONS(2787),
    [anon_sym_enum] = ACTIONS(2787),
    [anon_sym_class] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_union] = ACTIONS(2787),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_switch] = ACTIONS(2787),
    [anon_sym_case] = ACTIONS(2787),
    [anon_sym_default] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [anon_sym_do] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_break] = ACTIONS(2787),
    [anon_sym_continue] = ACTIONS(2787),
    [anon_sym_goto] = ACTIONS(2787),
    [anon_sym_not] = ACTIONS(2787),
    [anon_sym_compl] = ACTIONS(2787),
    [anon_sym_DASH_DASH] = ACTIONS(2789),
    [anon_sym_PLUS_PLUS] = ACTIONS(2789),
    [anon_sym_sizeof] = ACTIONS(2787),
    [anon_sym___alignof__] = ACTIONS(2787),
    [anon_sym___alignof] = ACTIONS(2787),
    [anon_sym__alignof] = ACTIONS(2787),
    [anon_sym_alignof] = ACTIONS(2787),
    [anon_sym__Alignof] = ACTIONS(2787),
    [anon_sym_offsetof] = ACTIONS(2787),
    [anon_sym__Generic] = ACTIONS(2787),
    [anon_sym_asm] = ACTIONS(2787),
    [anon_sym___asm__] = ACTIONS(2787),
    [anon_sym___asm] = ACTIONS(2787),
    [sym_number_literal] = ACTIONS(2789),
    [anon_sym_L_SQUOTE] = ACTIONS(2789),
    [anon_sym_u_SQUOTE] = ACTIONS(2789),
    [anon_sym_U_SQUOTE] = ACTIONS(2789),
    [anon_sym_u8_SQUOTE] = ACTIONS(2789),
    [anon_sym_SQUOTE] = ACTIONS(2789),
    [anon_sym_L_DQUOTE] = ACTIONS(2789),
    [anon_sym_u_DQUOTE] = ACTIONS(2789),
    [anon_sym_U_DQUOTE] = ACTIONS(2789),
    [anon_sym_u8_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE] = ACTIONS(2789),
    [sym_true] = ACTIONS(2787),
    [sym_false] = ACTIONS(2787),
    [anon_sym_NULL] = ACTIONS(2787),
    [anon_sym_nullptr] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2787),
    [anon_sym_decltype] = ACTIONS(2787),
    [anon_sym_explicit] = ACTIONS(2787),
    [anon_sym_typename] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2787),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_import] = ACTIONS(2787),
    [anon_sym_template] = ACTIONS(2787),
    [anon_sym_operator] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_delete] = ACTIONS(2787),
    [anon_sym_throw] = ACTIONS(2787),
    [anon_sym_namespace] = ACTIONS(2787),
    [anon_sym_static_assert] = ACTIONS(2787),
    [anon_sym_concept] = ACTIONS(2787),
    [anon_sym_co_return] = ACTIONS(2787),
    [anon_sym_co_yield] = ACTIONS(2787),
    [anon_sym_R_DQUOTE] = ACTIONS(2789),
    [anon_sym_LR_DQUOTE] = ACTIONS(2789),
    [anon_sym_uR_DQUOTE] = ACTIONS(2789),
    [anon_sym_UR_DQUOTE] = ACTIONS(2789),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2789),
    [anon_sym_co_await] = ACTIONS(2787),
    [anon_sym_new] = ACTIONS(2787),
    [anon_sym_requires] = ACTIONS(2787),
    [sym_this] = ACTIONS(2787),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(2917),
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_include_token1] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_goto] = ACTIONS(2915),
    [anon_sym_not] = ACTIONS(2915),
    [anon_sym_compl] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_sizeof] = ACTIONS(2915),
    [anon_sym___alignof__] = ACTIONS(2915),
    [anon_sym___alignof] = ACTIONS(2915),
    [anon_sym__alignof] = ACTIONS(2915),
    [anon_sym_alignof] = ACTIONS(2915),
    [anon_sym__Alignof] = ACTIONS(2915),
    [anon_sym_offsetof] = ACTIONS(2915),
    [anon_sym__Generic] = ACTIONS(2915),
    [anon_sym_asm] = ACTIONS(2915),
    [anon_sym___asm__] = ACTIONS(2915),
    [anon_sym___asm] = ACTIONS(2915),
    [sym_number_literal] = ACTIONS(2917),
    [anon_sym_L_SQUOTE] = ACTIONS(2917),
    [anon_sym_u_SQUOTE] = ACTIONS(2917),
    [anon_sym_U_SQUOTE] = ACTIONS(2917),
    [anon_sym_u8_SQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_L_DQUOTE] = ACTIONS(2917),
    [anon_sym_u_DQUOTE] = ACTIONS(2917),
    [anon_sym_U_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8_DQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [anon_sym_NULL] = ACTIONS(2915),
    [anon_sym_nullptr] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_export] = ACTIONS(2915),
    [anon_sym_module] = ACTIONS(2915),
    [anon_sym_import] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
    [anon_sym_concept] = ACTIONS(2915),
    [anon_sym_co_return] = ACTIONS(2915),
    [anon_sym_co_yield] = ACTIONS(2915),
    [anon_sym_R_DQUOTE] = ACTIONS(2917),
    [anon_sym_LR_DQUOTE] = ACTIONS(2917),
    [anon_sym_uR_DQUOTE] = ACTIONS(2917),
    [anon_sym_UR_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2917),
    [anon_sym_co_await] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [sym_this] = ACTIONS(2915),
  },
  [624] = {
    [ts_builtin_sym_end] = ACTIONS(2917),
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_include_token1] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_goto] = ACTIONS(2915),
    [anon_sym_not] = ACTIONS(2915),
    [anon_sym_compl] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_sizeof] = ACTIONS(2915),
    [anon_sym___alignof__] = ACTIONS(2915),
    [anon_sym___alignof] = ACTIONS(2915),
    [anon_sym__alignof] = ACTIONS(2915),
    [anon_sym_alignof] = ACTIONS(2915),
    [anon_sym__Alignof] = ACTIONS(2915),
    [anon_sym_offsetof] = ACTIONS(2915),
    [anon_sym__Generic] = ACTIONS(2915),
    [anon_sym_asm] = ACTIONS(2915),
    [anon_sym___asm__] = ACTIONS(2915),
    [anon_sym___asm] = ACTIONS(2915),
    [sym_number_literal] = ACTIONS(2917),
    [anon_sym_L_SQUOTE] = ACTIONS(2917),
    [anon_sym_u_SQUOTE] = ACTIONS(2917),
    [anon_sym_U_SQUOTE] = ACTIONS(2917),
    [anon_sym_u8_SQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_L_DQUOTE] = ACTIONS(2917),
    [anon_sym_u_DQUOTE] = ACTIONS(2917),
    [anon_sym_U_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8_DQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [anon_sym_NULL] = ACTIONS(2915),
    [anon_sym_nullptr] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_export] = ACTIONS(2915),
    [anon_sym_module] = ACTIONS(2915),
    [anon_sym_import] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
    [anon_sym_concept] = ACTIONS(2915),
    [anon_sym_co_return] = ACTIONS(2915),
    [anon_sym_co_yield] = ACTIONS(2915),
    [anon_sym_R_DQUOTE] = ACTIONS(2917),
    [anon_sym_LR_DQUOTE] = ACTIONS(2917),
    [anon_sym_uR_DQUOTE] = ACTIONS(2917),
    [anon_sym_UR_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2917),
    [anon_sym_co_await] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [sym_this] = ACTIONS(2915),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(3583),
    [sym_identifier] = ACTIONS(3585),
    [aux_sym_preproc_include_token1] = ACTIONS(3585),
    [aux_sym_preproc_def_token1] = ACTIONS(3585),
    [aux_sym_preproc_if_token1] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3585),
    [sym_preproc_directive] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3583),
    [anon_sym_BANG] = ACTIONS(3583),
    [anon_sym_TILDE] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3583),
    [anon_sym_AMP_AMP] = ACTIONS(3583),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3583),
    [anon_sym___extension__] = ACTIONS(3585),
    [anon_sym_typedef] = ACTIONS(3585),
    [anon_sym_virtual] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym___attribute__] = ACTIONS(3585),
    [anon_sym___attribute] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3583),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3583),
    [anon_sym___declspec] = ACTIONS(3585),
    [anon_sym___based] = ACTIONS(3585),
    [anon_sym___cdecl] = ACTIONS(3585),
    [anon_sym___clrcall] = ACTIONS(3585),
    [anon_sym___stdcall] = ACTIONS(3585),
    [anon_sym___fastcall] = ACTIONS(3585),
    [anon_sym___thiscall] = ACTIONS(3585),
    [anon_sym___vectorcall] = ACTIONS(3585),
    [anon_sym_LBRACE] = ACTIONS(3583),
    [anon_sym_signed] = ACTIONS(3585),
    [anon_sym_unsigned] = ACTIONS(3585),
    [anon_sym_long] = ACTIONS(3585),
    [anon_sym_short] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_register] = ACTIONS(3585),
    [anon_sym_inline] = ACTIONS(3585),
    [anon_sym___inline] = ACTIONS(3585),
    [anon_sym___inline__] = ACTIONS(3585),
    [anon_sym___forceinline] = ACTIONS(3585),
    [anon_sym_thread_local] = ACTIONS(3585),
    [anon_sym___thread] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_constexpr] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym_restrict] = ACTIONS(3585),
    [anon_sym___restrict__] = ACTIONS(3585),
    [anon_sym__Atomic] = ACTIONS(3585),
    [anon_sym__Noreturn] = ACTIONS(3585),
    [anon_sym_noreturn] = ACTIONS(3585),
    [anon_sym__Nonnull] = ACTIONS(3585),
    [anon_sym_mutable] = ACTIONS(3585),
    [anon_sym_constinit] = ACTIONS(3585),
    [anon_sym_consteval] = ACTIONS(3585),
    [anon_sym_alignas] = ACTIONS(3585),
    [anon_sym__Alignas] = ACTIONS(3585),
    [sym_primitive_type] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_class] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_union] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_switch] = ACTIONS(3585),
    [anon_sym_case] = ACTIONS(3585),
    [anon_sym_default] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_break] = ACTIONS(3585),
    [anon_sym_continue] = ACTIONS(3585),
    [anon_sym_goto] = ACTIONS(3585),
    [anon_sym_not] = ACTIONS(3585),
    [anon_sym_compl] = ACTIONS(3585),
    [anon_sym_DASH_DASH] = ACTIONS(3583),
    [anon_sym_PLUS_PLUS] = ACTIONS(3583),
    [anon_sym_sizeof] = ACTIONS(3585),
    [anon_sym___alignof__] = ACTIONS(3585),
    [anon_sym___alignof] = ACTIONS(3585),
    [anon_sym__alignof] = ACTIONS(3585),
    [anon_sym_alignof] = ACTIONS(3585),
    [anon_sym__Alignof] = ACTIONS(3585),
    [anon_sym_offsetof] = ACTIONS(3585),
    [anon_sym__Generic] = ACTIONS(3585),
    [anon_sym_asm] = ACTIONS(3585),
    [anon_sym___asm__] = ACTIONS(3585),
    [anon_sym___asm] = ACTIONS(3585),
    [sym_number_literal] = ACTIONS(3583),
    [anon_sym_L_SQUOTE] = ACTIONS(3583),
    [anon_sym_u_SQUOTE] = ACTIONS(3583),
    [anon_sym_U_SQUOTE] = ACTIONS(3583),
    [anon_sym_u8_SQUOTE] = ACTIONS(3583),
    [anon_sym_SQUOTE] = ACTIONS(3583),
    [anon_sym_L_DQUOTE] = ACTIONS(3583),
    [anon_sym_u_DQUOTE] = ACTIONS(3583),
    [anon_sym_U_DQUOTE] = ACTIONS(3583),
    [anon_sym_u8_DQUOTE] = ACTIONS(3583),
    [anon_sym_DQUOTE] = ACTIONS(3583),
    [sym_true] = ACTIONS(3585),
    [sym_false] = ACTIONS(3585),
    [anon_sym_NULL] = ACTIONS(3585),
    [anon_sym_nullptr] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3585),
    [anon_sym_decltype] = ACTIONS(3585),
    [anon_sym_explicit] = ACTIONS(3585),
    [anon_sym_typename] = ACTIONS(3585),
    [anon_sym_export] = ACTIONS(3585),
    [anon_sym_module] = ACTIONS(3585),
    [anon_sym_import] = ACTIONS(3585),
    [anon_sym_template] = ACTIONS(3585),
    [anon_sym_operator] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_delete] = ACTIONS(3585),
    [anon_sym_throw] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_static_assert] = ACTIONS(3585),
    [anon_sym_concept] = ACTIONS(3585),
    [anon_sym_co_return] = ACTIONS(3585),
    [anon_sym_co_yield] = ACTIONS(3585),
    [anon_sym_R_DQUOTE] = ACTIONS(3583),
    [anon_sym_LR_DQUOTE] = ACTIONS(3583),
    [anon_sym_uR_DQUOTE] = ACTIONS(3583),
    [anon_sym_UR_DQUOTE] = ACTIONS(3583),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3583),
    [anon_sym_co_await] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_requires] = ACTIONS(3585),
    [sym_this] = ACTIONS(3585),
  },
  [626] = {
    [sym_identifier] = ACTIONS(2631),
    [aux_sym_preproc_include_token1] = ACTIONS(2631),
    [aux_sym_preproc_def_token1] = ACTIONS(2631),
    [aux_sym_preproc_if_token1] = ACTIONS(2631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2631),
    [sym_preproc_directive] = ACTIONS(2631),
    [anon_sym_LPAREN2] = ACTIONS(2633),
    [anon_sym_BANG] = ACTIONS(2633),
    [anon_sym_TILDE] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym___extension__] = ACTIONS(2631),
    [anon_sym_typedef] = ACTIONS(2631),
    [anon_sym_virtual] = ACTIONS(2631),
    [anon_sym_extern] = ACTIONS(2631),
    [anon_sym___attribute__] = ACTIONS(2631),
    [anon_sym___attribute] = ACTIONS(2631),
    [anon_sym_using] = ACTIONS(2631),
    [anon_sym_COLON_COLON] = ACTIONS(2633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2633),
    [anon_sym___declspec] = ACTIONS(2631),
    [anon_sym___based] = ACTIONS(2631),
    [anon_sym___cdecl] = ACTIONS(2631),
    [anon_sym___clrcall] = ACTIONS(2631),
    [anon_sym___stdcall] = ACTIONS(2631),
    [anon_sym___fastcall] = ACTIONS(2631),
    [anon_sym___thiscall] = ACTIONS(2631),
    [anon_sym___vectorcall] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_RBRACE] = ACTIONS(2633),
    [anon_sym_signed] = ACTIONS(2631),
    [anon_sym_unsigned] = ACTIONS(2631),
    [anon_sym_long] = ACTIONS(2631),
    [anon_sym_short] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2631),
    [anon_sym_static] = ACTIONS(2631),
    [anon_sym_register] = ACTIONS(2631),
    [anon_sym_inline] = ACTIONS(2631),
    [anon_sym___inline] = ACTIONS(2631),
    [anon_sym___inline__] = ACTIONS(2631),
    [anon_sym___forceinline] = ACTIONS(2631),
    [anon_sym_thread_local] = ACTIONS(2631),
    [anon_sym___thread] = ACTIONS(2631),
    [anon_sym_const] = ACTIONS(2631),
    [anon_sym_constexpr] = ACTIONS(2631),
    [anon_sym_volatile] = ACTIONS(2631),
    [anon_sym_restrict] = ACTIONS(2631),
    [anon_sym___restrict__] = ACTIONS(2631),
    [anon_sym__Atomic] = ACTIONS(2631),
    [anon_sym__Noreturn] = ACTIONS(2631),
    [anon_sym_noreturn] = ACTIONS(2631),
    [anon_sym__Nonnull] = ACTIONS(2631),
    [anon_sym_mutable] = ACTIONS(2631),
    [anon_sym_constinit] = ACTIONS(2631),
    [anon_sym_consteval] = ACTIONS(2631),
    [anon_sym_alignas] = ACTIONS(2631),
    [anon_sym__Alignas] = ACTIONS(2631),
    [sym_primitive_type] = ACTIONS(2631),
    [anon_sym_enum] = ACTIONS(2631),
    [anon_sym_class] = ACTIONS(2631),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_union] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_else] = ACTIONS(2631),
    [anon_sym_switch] = ACTIONS(2631),
    [anon_sym_case] = ACTIONS(2631),
    [anon_sym_default] = ACTIONS(2631),
    [anon_sym_while] = ACTIONS(2631),
    [anon_sym_do] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_goto] = ACTIONS(2631),
    [anon_sym___try] = ACTIONS(2631),
    [anon_sym___leave] = ACTIONS(2631),
    [anon_sym_not] = ACTIONS(2631),
    [anon_sym_compl] = ACTIONS(2631),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_sizeof] = ACTIONS(2631),
    [anon_sym___alignof__] = ACTIONS(2631),
    [anon_sym___alignof] = ACTIONS(2631),
    [anon_sym__alignof] = ACTIONS(2631),
    [anon_sym_alignof] = ACTIONS(2631),
    [anon_sym__Alignof] = ACTIONS(2631),
    [anon_sym_offsetof] = ACTIONS(2631),
    [anon_sym__Generic] = ACTIONS(2631),
    [anon_sym_asm] = ACTIONS(2631),
    [anon_sym___asm__] = ACTIONS(2631),
    [anon_sym___asm] = ACTIONS(2631),
    [sym_number_literal] = ACTIONS(2633),
    [anon_sym_L_SQUOTE] = ACTIONS(2633),
    [anon_sym_u_SQUOTE] = ACTIONS(2633),
    [anon_sym_U_SQUOTE] = ACTIONS(2633),
    [anon_sym_u8_SQUOTE] = ACTIONS(2633),
    [anon_sym_SQUOTE] = ACTIONS(2633),
    [anon_sym_L_DQUOTE] = ACTIONS(2633),
    [anon_sym_u_DQUOTE] = ACTIONS(2633),
    [anon_sym_U_DQUOTE] = ACTIONS(2633),
    [anon_sym_u8_DQUOTE] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(2633),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [anon_sym_NULL] = ACTIONS(2631),
    [anon_sym_nullptr] = ACTIONS(2631),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2631),
    [anon_sym_decltype] = ACTIONS(2631),
    [anon_sym_explicit] = ACTIONS(2631),
    [anon_sym_typename] = ACTIONS(2631),
    [anon_sym_template] = ACTIONS(2631),
    [anon_sym_operator] = ACTIONS(2631),
    [anon_sym_try] = ACTIONS(2631),
    [anon_sym_delete] = ACTIONS(2631),
    [anon_sym_throw] = ACTIONS(2631),
    [anon_sym_namespace] = ACTIONS(2631),
    [anon_sym_static_assert] = ACTIONS(2631),
    [anon_sym_concept] = ACTIONS(2631),
    [anon_sym_co_return] = ACTIONS(2631),
    [anon_sym_co_yield] = ACTIONS(2631),
    [anon_sym_R_DQUOTE] = ACTIONS(2633),
    [anon_sym_LR_DQUOTE] = ACTIONS(2633),
    [anon_sym_uR_DQUOTE] = ACTIONS(2633),
    [anon_sym_UR_DQUOTE] = ACTIONS(2633),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2633),
    [anon_sym_co_await] = ACTIONS(2631),
    [anon_sym_new] = ACTIONS(2631),
    [anon_sym_requires] = ACTIONS(2631),
    [sym_this] = ACTIONS(2631),
  },
  [627] = {
    [sym_identifier] = ACTIONS(2635),
    [aux_sym_preproc_include_token1] = ACTIONS(2635),
    [aux_sym_preproc_def_token1] = ACTIONS(2635),
    [aux_sym_preproc_if_token1] = ACTIONS(2635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2635),
    [sym_preproc_directive] = ACTIONS(2635),
    [anon_sym_LPAREN2] = ACTIONS(2637),
    [anon_sym_BANG] = ACTIONS(2637),
    [anon_sym_TILDE] = ACTIONS(2637),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2637),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_SEMI] = ACTIONS(2637),
    [anon_sym___extension__] = ACTIONS(2635),
    [anon_sym_typedef] = ACTIONS(2635),
    [anon_sym_virtual] = ACTIONS(2635),
    [anon_sym_extern] = ACTIONS(2635),
    [anon_sym___attribute__] = ACTIONS(2635),
    [anon_sym___attribute] = ACTIONS(2635),
    [anon_sym_using] = ACTIONS(2635),
    [anon_sym_COLON_COLON] = ACTIONS(2637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2637),
    [anon_sym___declspec] = ACTIONS(2635),
    [anon_sym___based] = ACTIONS(2635),
    [anon_sym___cdecl] = ACTIONS(2635),
    [anon_sym___clrcall] = ACTIONS(2635),
    [anon_sym___stdcall] = ACTIONS(2635),
    [anon_sym___fastcall] = ACTIONS(2635),
    [anon_sym___thiscall] = ACTIONS(2635),
    [anon_sym___vectorcall] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2637),
    [anon_sym_RBRACE] = ACTIONS(2637),
    [anon_sym_signed] = ACTIONS(2635),
    [anon_sym_unsigned] = ACTIONS(2635),
    [anon_sym_long] = ACTIONS(2635),
    [anon_sym_short] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(2635),
    [anon_sym_static] = ACTIONS(2635),
    [anon_sym_register] = ACTIONS(2635),
    [anon_sym_inline] = ACTIONS(2635),
    [anon_sym___inline] = ACTIONS(2635),
    [anon_sym___inline__] = ACTIONS(2635),
    [anon_sym___forceinline] = ACTIONS(2635),
    [anon_sym_thread_local] = ACTIONS(2635),
    [anon_sym___thread] = ACTIONS(2635),
    [anon_sym_const] = ACTIONS(2635),
    [anon_sym_constexpr] = ACTIONS(2635),
    [anon_sym_volatile] = ACTIONS(2635),
    [anon_sym_restrict] = ACTIONS(2635),
    [anon_sym___restrict__] = ACTIONS(2635),
    [anon_sym__Atomic] = ACTIONS(2635),
    [anon_sym__Noreturn] = ACTIONS(2635),
    [anon_sym_noreturn] = ACTIONS(2635),
    [anon_sym__Nonnull] = ACTIONS(2635),
    [anon_sym_mutable] = ACTIONS(2635),
    [anon_sym_constinit] = ACTIONS(2635),
    [anon_sym_consteval] = ACTIONS(2635),
    [anon_sym_alignas] = ACTIONS(2635),
    [anon_sym__Alignas] = ACTIONS(2635),
    [sym_primitive_type] = ACTIONS(2635),
    [anon_sym_enum] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(2635),
    [anon_sym_struct] = ACTIONS(2635),
    [anon_sym_union] = ACTIONS(2635),
    [anon_sym_if] = ACTIONS(2635),
    [anon_sym_else] = ACTIONS(2635),
    [anon_sym_switch] = ACTIONS(2635),
    [anon_sym_case] = ACTIONS(2635),
    [anon_sym_default] = ACTIONS(2635),
    [anon_sym_while] = ACTIONS(2635),
    [anon_sym_do] = ACTIONS(2635),
    [anon_sym_for] = ACTIONS(2635),
    [anon_sym_return] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_continue] = ACTIONS(2635),
    [anon_sym_goto] = ACTIONS(2635),
    [anon_sym___try] = ACTIONS(2635),
    [anon_sym___leave] = ACTIONS(2635),
    [anon_sym_not] = ACTIONS(2635),
    [anon_sym_compl] = ACTIONS(2635),
    [anon_sym_DASH_DASH] = ACTIONS(2637),
    [anon_sym_PLUS_PLUS] = ACTIONS(2637),
    [anon_sym_sizeof] = ACTIONS(2635),
    [anon_sym___alignof__] = ACTIONS(2635),
    [anon_sym___alignof] = ACTIONS(2635),
    [anon_sym__alignof] = ACTIONS(2635),
    [anon_sym_alignof] = ACTIONS(2635),
    [anon_sym__Alignof] = ACTIONS(2635),
    [anon_sym_offsetof] = ACTIONS(2635),
    [anon_sym__Generic] = ACTIONS(2635),
    [anon_sym_asm] = ACTIONS(2635),
    [anon_sym___asm__] = ACTIONS(2635),
    [anon_sym___asm] = ACTIONS(2635),
    [sym_number_literal] = ACTIONS(2637),
    [anon_sym_L_SQUOTE] = ACTIONS(2637),
    [anon_sym_u_SQUOTE] = ACTIONS(2637),
    [anon_sym_U_SQUOTE] = ACTIONS(2637),
    [anon_sym_u8_SQUOTE] = ACTIONS(2637),
    [anon_sym_SQUOTE] = ACTIONS(2637),
    [anon_sym_L_DQUOTE] = ACTIONS(2637),
    [anon_sym_u_DQUOTE] = ACTIONS(2637),
    [anon_sym_U_DQUOTE] = ACTIONS(2637),
    [anon_sym_u8_DQUOTE] = ACTIONS(2637),
    [anon_sym_DQUOTE] = ACTIONS(2637),
    [sym_true] = ACTIONS(2635),
    [sym_false] = ACTIONS(2635),
    [anon_sym_NULL] = ACTIONS(2635),
    [anon_sym_nullptr] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2635),
    [anon_sym_decltype] = ACTIONS(2635),
    [anon_sym_explicit] = ACTIONS(2635),
    [anon_sym_typename] = ACTIONS(2635),
    [anon_sym_template] = ACTIONS(2635),
    [anon_sym_operator] = ACTIONS(2635),
    [anon_sym_try] = ACTIONS(2635),
    [anon_sym_delete] = ACTIONS(2635),
    [anon_sym_throw] = ACTIONS(2635),
    [anon_sym_namespace] = ACTIONS(2635),
    [anon_sym_static_assert] = ACTIONS(2635),
    [anon_sym_concept] = ACTIONS(2635),
    [anon_sym_co_return] = ACTIONS(2635),
    [anon_sym_co_yield] = ACTIONS(2635),
    [anon_sym_R_DQUOTE] = ACTIONS(2637),
    [anon_sym_LR_DQUOTE] = ACTIONS(2637),
    [anon_sym_uR_DQUOTE] = ACTIONS(2637),
    [anon_sym_UR_DQUOTE] = ACTIONS(2637),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2637),
    [anon_sym_co_await] = ACTIONS(2635),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2635),
    [sym_this] = ACTIONS(2635),
  },
  [628] = {
    [ts_builtin_sym_end] = ACTIONS(2921),
    [sym_identifier] = ACTIONS(2919),
    [aux_sym_preproc_include_token1] = ACTIONS(2919),
    [aux_sym_preproc_def_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token1] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2919),
    [sym_preproc_directive] = ACTIONS(2919),
    [anon_sym_LPAREN2] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym___extension__] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(2919),
    [anon_sym_virtual] = ACTIONS(2919),
    [anon_sym_extern] = ACTIONS(2919),
    [anon_sym___attribute__] = ACTIONS(2919),
    [anon_sym___attribute] = ACTIONS(2919),
    [anon_sym_using] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(2921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2921),
    [anon_sym___declspec] = ACTIONS(2919),
    [anon_sym___based] = ACTIONS(2919),
    [anon_sym___cdecl] = ACTIONS(2919),
    [anon_sym___clrcall] = ACTIONS(2919),
    [anon_sym___stdcall] = ACTIONS(2919),
    [anon_sym___fastcall] = ACTIONS(2919),
    [anon_sym___thiscall] = ACTIONS(2919),
    [anon_sym___vectorcall] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_signed] = ACTIONS(2919),
    [anon_sym_unsigned] = ACTIONS(2919),
    [anon_sym_long] = ACTIONS(2919),
    [anon_sym_short] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_register] = ACTIONS(2919),
    [anon_sym_inline] = ACTIONS(2919),
    [anon_sym___inline] = ACTIONS(2919),
    [anon_sym___inline__] = ACTIONS(2919),
    [anon_sym___forceinline] = ACTIONS(2919),
    [anon_sym_thread_local] = ACTIONS(2919),
    [anon_sym___thread] = ACTIONS(2919),
    [anon_sym_const] = ACTIONS(2919),
    [anon_sym_constexpr] = ACTIONS(2919),
    [anon_sym_volatile] = ACTIONS(2919),
    [anon_sym_restrict] = ACTIONS(2919),
    [anon_sym___restrict__] = ACTIONS(2919),
    [anon_sym__Atomic] = ACTIONS(2919),
    [anon_sym__Noreturn] = ACTIONS(2919),
    [anon_sym_noreturn] = ACTIONS(2919),
    [anon_sym__Nonnull] = ACTIONS(2919),
    [anon_sym_mutable] = ACTIONS(2919),
    [anon_sym_constinit] = ACTIONS(2919),
    [anon_sym_consteval] = ACTIONS(2919),
    [anon_sym_alignas] = ACTIONS(2919),
    [anon_sym__Alignas] = ACTIONS(2919),
    [sym_primitive_type] = ACTIONS(2919),
    [anon_sym_enum] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2919),
    [anon_sym_switch] = ACTIONS(2919),
    [anon_sym_case] = ACTIONS(2919),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_while] = ACTIONS(2919),
    [anon_sym_do] = ACTIONS(2919),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_continue] = ACTIONS(2919),
    [anon_sym_goto] = ACTIONS(2919),
    [anon_sym_not] = ACTIONS(2919),
    [anon_sym_compl] = ACTIONS(2919),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_sizeof] = ACTIONS(2919),
    [anon_sym___alignof__] = ACTIONS(2919),
    [anon_sym___alignof] = ACTIONS(2919),
    [anon_sym__alignof] = ACTIONS(2919),
    [anon_sym_alignof] = ACTIONS(2919),
    [anon_sym__Alignof] = ACTIONS(2919),
    [anon_sym_offsetof] = ACTIONS(2919),
    [anon_sym__Generic] = ACTIONS(2919),
    [anon_sym_asm] = ACTIONS(2919),
    [anon_sym___asm__] = ACTIONS(2919),
    [anon_sym___asm] = ACTIONS(2919),
    [sym_number_literal] = ACTIONS(2921),
    [anon_sym_L_SQUOTE] = ACTIONS(2921),
    [anon_sym_u_SQUOTE] = ACTIONS(2921),
    [anon_sym_U_SQUOTE] = ACTIONS(2921),
    [anon_sym_u8_SQUOTE] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_L_DQUOTE] = ACTIONS(2921),
    [anon_sym_u_DQUOTE] = ACTIONS(2921),
    [anon_sym_U_DQUOTE] = ACTIONS(2921),
    [anon_sym_u8_DQUOTE] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [sym_true] = ACTIONS(2919),
    [sym_false] = ACTIONS(2919),
    [anon_sym_NULL] = ACTIONS(2919),
    [anon_sym_nullptr] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2919),
    [anon_sym_decltype] = ACTIONS(2919),
    [anon_sym_explicit] = ACTIONS(2919),
    [anon_sym_typename] = ACTIONS(2919),
    [anon_sym_export] = ACTIONS(2919),
    [anon_sym_module] = ACTIONS(2919),
    [anon_sym_import] = ACTIONS(2919),
    [anon_sym_template] = ACTIONS(2919),
    [anon_sym_operator] = ACTIONS(2919),
    [anon_sym_try] = ACTIONS(2919),
    [anon_sym_delete] = ACTIONS(2919),
    [anon_sym_throw] = ACTIONS(2919),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_static_assert] = ACTIONS(2919),
    [anon_sym_concept] = ACTIONS(2919),
    [anon_sym_co_return] = ACTIONS(2919),
    [anon_sym_co_yield] = ACTIONS(2919),
    [anon_sym_R_DQUOTE] = ACTIONS(2921),
    [anon_sym_LR_DQUOTE] = ACTIONS(2921),
    [anon_sym_uR_DQUOTE] = ACTIONS(2921),
    [anon_sym_UR_DQUOTE] = ACTIONS(2921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2921),
    [anon_sym_co_await] = ACTIONS(2919),
    [anon_sym_new] = ACTIONS(2919),
    [anon_sym_requires] = ACTIONS(2919),
    [sym_this] = ACTIONS(2919),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(2897),
    [sym_identifier] = ACTIONS(2895),
    [aux_sym_preproc_include_token1] = ACTIONS(2895),
    [aux_sym_preproc_def_token1] = ACTIONS(2895),
    [aux_sym_preproc_if_token1] = ACTIONS(2895),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2895),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym___extension__] = ACTIONS(2895),
    [anon_sym_typedef] = ACTIONS(2895),
    [anon_sym_virtual] = ACTIONS(2895),
    [anon_sym_extern] = ACTIONS(2895),
    [anon_sym___attribute__] = ACTIONS(2895),
    [anon_sym___attribute] = ACTIONS(2895),
    [anon_sym_using] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2897),
    [anon_sym___declspec] = ACTIONS(2895),
    [anon_sym___based] = ACTIONS(2895),
    [anon_sym___cdecl] = ACTIONS(2895),
    [anon_sym___clrcall] = ACTIONS(2895),
    [anon_sym___stdcall] = ACTIONS(2895),
    [anon_sym___fastcall] = ACTIONS(2895),
    [anon_sym___thiscall] = ACTIONS(2895),
    [anon_sym___vectorcall] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_signed] = ACTIONS(2895),
    [anon_sym_unsigned] = ACTIONS(2895),
    [anon_sym_long] = ACTIONS(2895),
    [anon_sym_short] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2895),
    [anon_sym_register] = ACTIONS(2895),
    [anon_sym_inline] = ACTIONS(2895),
    [anon_sym___inline] = ACTIONS(2895),
    [anon_sym___inline__] = ACTIONS(2895),
    [anon_sym___forceinline] = ACTIONS(2895),
    [anon_sym_thread_local] = ACTIONS(2895),
    [anon_sym___thread] = ACTIONS(2895),
    [anon_sym_const] = ACTIONS(2895),
    [anon_sym_constexpr] = ACTIONS(2895),
    [anon_sym_volatile] = ACTIONS(2895),
    [anon_sym_restrict] = ACTIONS(2895),
    [anon_sym___restrict__] = ACTIONS(2895),
    [anon_sym__Atomic] = ACTIONS(2895),
    [anon_sym__Noreturn] = ACTIONS(2895),
    [anon_sym_noreturn] = ACTIONS(2895),
    [anon_sym__Nonnull] = ACTIONS(2895),
    [anon_sym_mutable] = ACTIONS(2895),
    [anon_sym_constinit] = ACTIONS(2895),
    [anon_sym_consteval] = ACTIONS(2895),
    [anon_sym_alignas] = ACTIONS(2895),
    [anon_sym__Alignas] = ACTIONS(2895),
    [sym_primitive_type] = ACTIONS(2895),
    [anon_sym_enum] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2895),
    [anon_sym_struct] = ACTIONS(2895),
    [anon_sym_union] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_switch] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2895),
    [anon_sym_default] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_break] = ACTIONS(2895),
    [anon_sym_continue] = ACTIONS(2895),
    [anon_sym_goto] = ACTIONS(2895),
    [anon_sym_not] = ACTIONS(2895),
    [anon_sym_compl] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_sizeof] = ACTIONS(2895),
    [anon_sym___alignof__] = ACTIONS(2895),
    [anon_sym___alignof] = ACTIONS(2895),
    [anon_sym__alignof] = ACTIONS(2895),
    [anon_sym_alignof] = ACTIONS(2895),
    [anon_sym__Alignof] = ACTIONS(2895),
    [anon_sym_offsetof] = ACTIONS(2895),
    [anon_sym__Generic] = ACTIONS(2895),
    [anon_sym_asm] = ACTIONS(2895),
    [anon_sym___asm__] = ACTIONS(2895),
    [anon_sym___asm] = ACTIONS(2895),
    [sym_number_literal] = ACTIONS(2897),
    [anon_sym_L_SQUOTE] = ACTIONS(2897),
    [anon_sym_u_SQUOTE] = ACTIONS(2897),
    [anon_sym_U_SQUOTE] = ACTIONS(2897),
    [anon_sym_u8_SQUOTE] = ACTIONS(2897),
    [anon_sym_SQUOTE] = ACTIONS(2897),
    [anon_sym_L_DQUOTE] = ACTIONS(2897),
    [anon_sym_u_DQUOTE] = ACTIONS(2897),
    [anon_sym_U_DQUOTE] = ACTIONS(2897),
    [anon_sym_u8_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [sym_true] = ACTIONS(2895),
    [sym_false] = ACTIONS(2895),
    [anon_sym_NULL] = ACTIONS(2895),
    [anon_sym_nullptr] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2895),
    [anon_sym_decltype] = ACTIONS(2895),
    [anon_sym_explicit] = ACTIONS(2895),
    [anon_sym_typename] = ACTIONS(2895),
    [anon_sym_export] = ACTIONS(2895),
    [anon_sym_module] = ACTIONS(2895),
    [anon_sym_import] = ACTIONS(2895),
    [anon_sym_template] = ACTIONS(2895),
    [anon_sym_operator] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_delete] = ACTIONS(2895),
    [anon_sym_throw] = ACTIONS(2895),
    [anon_sym_namespace] = ACTIONS(2895),
    [anon_sym_static_assert] = ACTIONS(2895),
    [anon_sym_concept] = ACTIONS(2895),
    [anon_sym_co_return] = ACTIONS(2895),
    [anon_sym_co_yield] = ACTIONS(2895),
    [anon_sym_R_DQUOTE] = ACTIONS(2897),
    [anon_sym_LR_DQUOTE] = ACTIONS(2897),
    [anon_sym_uR_DQUOTE] = ACTIONS(2897),
    [anon_sym_UR_DQUOTE] = ACTIONS(2897),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2897),
    [anon_sym_co_await] = ACTIONS(2895),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_requires] = ACTIONS(2895),
    [sym_this] = ACTIONS(2895),
  },
  [630] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym___attribute] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym__Nonnull] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym__Alignas] = ACTIONS(2643),
    [sym_primitive_type] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [anon_sym___asm] = ACTIONS(2643),
    [sym_number_literal] = ACTIONS(2645),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [631] = {
    [ts_builtin_sym_end] = ACTIONS(2909),
    [sym_identifier] = ACTIONS(2907),
    [aux_sym_preproc_include_token1] = ACTIONS(2907),
    [aux_sym_preproc_def_token1] = ACTIONS(2907),
    [aux_sym_preproc_if_token1] = ACTIONS(2907),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2907),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2907),
    [sym_preproc_directive] = ACTIONS(2907),
    [anon_sym_LPAREN2] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_PLUS] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2909),
    [anon_sym___extension__] = ACTIONS(2907),
    [anon_sym_typedef] = ACTIONS(2907),
    [anon_sym_virtual] = ACTIONS(2907),
    [anon_sym_extern] = ACTIONS(2907),
    [anon_sym___attribute__] = ACTIONS(2907),
    [anon_sym___attribute] = ACTIONS(2907),
    [anon_sym_using] = ACTIONS(2907),
    [anon_sym_COLON_COLON] = ACTIONS(2909),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2909),
    [anon_sym___declspec] = ACTIONS(2907),
    [anon_sym___based] = ACTIONS(2907),
    [anon_sym___cdecl] = ACTIONS(2907),
    [anon_sym___clrcall] = ACTIONS(2907),
    [anon_sym___stdcall] = ACTIONS(2907),
    [anon_sym___fastcall] = ACTIONS(2907),
    [anon_sym___thiscall] = ACTIONS(2907),
    [anon_sym___vectorcall] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_signed] = ACTIONS(2907),
    [anon_sym_unsigned] = ACTIONS(2907),
    [anon_sym_long] = ACTIONS(2907),
    [anon_sym_short] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_static] = ACTIONS(2907),
    [anon_sym_register] = ACTIONS(2907),
    [anon_sym_inline] = ACTIONS(2907),
    [anon_sym___inline] = ACTIONS(2907),
    [anon_sym___inline__] = ACTIONS(2907),
    [anon_sym___forceinline] = ACTIONS(2907),
    [anon_sym_thread_local] = ACTIONS(2907),
    [anon_sym___thread] = ACTIONS(2907),
    [anon_sym_const] = ACTIONS(2907),
    [anon_sym_constexpr] = ACTIONS(2907),
    [anon_sym_volatile] = ACTIONS(2907),
    [anon_sym_restrict] = ACTIONS(2907),
    [anon_sym___restrict__] = ACTIONS(2907),
    [anon_sym__Atomic] = ACTIONS(2907),
    [anon_sym__Noreturn] = ACTIONS(2907),
    [anon_sym_noreturn] = ACTIONS(2907),
    [anon_sym__Nonnull] = ACTIONS(2907),
    [anon_sym_mutable] = ACTIONS(2907),
    [anon_sym_constinit] = ACTIONS(2907),
    [anon_sym_consteval] = ACTIONS(2907),
    [anon_sym_alignas] = ACTIONS(2907),
    [anon_sym__Alignas] = ACTIONS(2907),
    [sym_primitive_type] = ACTIONS(2907),
    [anon_sym_enum] = ACTIONS(2907),
    [anon_sym_class] = ACTIONS(2907),
    [anon_sym_struct] = ACTIONS(2907),
    [anon_sym_union] = ACTIONS(2907),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2907),
    [anon_sym_default] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_for] = ACTIONS(2907),
    [anon_sym_return] = ACTIONS(2907),
    [anon_sym_break] = ACTIONS(2907),
    [anon_sym_continue] = ACTIONS(2907),
    [anon_sym_goto] = ACTIONS(2907),
    [anon_sym_not] = ACTIONS(2907),
    [anon_sym_compl] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2909),
    [anon_sym_sizeof] = ACTIONS(2907),
    [anon_sym___alignof__] = ACTIONS(2907),
    [anon_sym___alignof] = ACTIONS(2907),
    [anon_sym__alignof] = ACTIONS(2907),
    [anon_sym_alignof] = ACTIONS(2907),
    [anon_sym__Alignof] = ACTIONS(2907),
    [anon_sym_offsetof] = ACTIONS(2907),
    [anon_sym__Generic] = ACTIONS(2907),
    [anon_sym_asm] = ACTIONS(2907),
    [anon_sym___asm__] = ACTIONS(2907),
    [anon_sym___asm] = ACTIONS(2907),
    [sym_number_literal] = ACTIONS(2909),
    [anon_sym_L_SQUOTE] = ACTIONS(2909),
    [anon_sym_u_SQUOTE] = ACTIONS(2909),
    [anon_sym_U_SQUOTE] = ACTIONS(2909),
    [anon_sym_u8_SQUOTE] = ACTIONS(2909),
    [anon_sym_SQUOTE] = ACTIONS(2909),
    [anon_sym_L_DQUOTE] = ACTIONS(2909),
    [anon_sym_u_DQUOTE] = ACTIONS(2909),
    [anon_sym_U_DQUOTE] = ACTIONS(2909),
    [anon_sym_u8_DQUOTE] = ACTIONS(2909),
    [anon_sym_DQUOTE] = ACTIONS(2909),
    [sym_true] = ACTIONS(2907),
    [sym_false] = ACTIONS(2907),
    [anon_sym_NULL] = ACTIONS(2907),
    [anon_sym_nullptr] = ACTIONS(2907),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2907),
    [anon_sym_decltype] = ACTIONS(2907),
    [anon_sym_explicit] = ACTIONS(2907),
    [anon_sym_typename] = ACTIONS(2907),
    [anon_sym_export] = ACTIONS(2907),
    [anon_sym_module] = ACTIONS(2907),
    [anon_sym_import] = ACTIONS(2907),
    [anon_sym_template] = ACTIONS(2907),
    [anon_sym_operator] = ACTIONS(2907),
    [anon_sym_try] = ACTIONS(2907),
    [anon_sym_delete] = ACTIONS(2907),
    [anon_sym_throw] = ACTIONS(2907),
    [anon_sym_namespace] = ACTIONS(2907),
    [anon_sym_static_assert] = ACTIONS(2907),
    [anon_sym_concept] = ACTIONS(2907),
    [anon_sym_co_return] = ACTIONS(2907),
    [anon_sym_co_yield] = ACTIONS(2907),
    [anon_sym_R_DQUOTE] = ACTIONS(2909),
    [anon_sym_LR_DQUOTE] = ACTIONS(2909),
    [anon_sym_uR_DQUOTE] = ACTIONS(2909),
    [anon_sym_UR_DQUOTE] = ACTIONS(2909),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2909),
    [anon_sym_co_await] = ACTIONS(2907),
    [anon_sym_new] = ACTIONS(2907),
    [anon_sym_requires] = ACTIONS(2907),
    [sym_this] = ACTIONS(2907),
  },
  [632] = {
    [sym_identifier] = ACTIONS(2651),
    [aux_sym_preproc_include_token1] = ACTIONS(2651),
    [aux_sym_preproc_def_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token1] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2651),
    [sym_preproc_directive] = ACTIONS(2651),
    [anon_sym_LPAREN2] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym___extension__] = ACTIONS(2651),
    [anon_sym_typedef] = ACTIONS(2651),
    [anon_sym_virtual] = ACTIONS(2651),
    [anon_sym_extern] = ACTIONS(2651),
    [anon_sym___attribute__] = ACTIONS(2651),
    [anon_sym___attribute] = ACTIONS(2651),
    [anon_sym_using] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2653),
    [anon_sym___declspec] = ACTIONS(2651),
    [anon_sym___based] = ACTIONS(2651),
    [anon_sym___cdecl] = ACTIONS(2651),
    [anon_sym___clrcall] = ACTIONS(2651),
    [anon_sym___stdcall] = ACTIONS(2651),
    [anon_sym___fastcall] = ACTIONS(2651),
    [anon_sym___thiscall] = ACTIONS(2651),
    [anon_sym___vectorcall] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2653),
    [anon_sym_RBRACE] = ACTIONS(2653),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2651),
    [anon_sym_register] = ACTIONS(2651),
    [anon_sym_inline] = ACTIONS(2651),
    [anon_sym___inline] = ACTIONS(2651),
    [anon_sym___inline__] = ACTIONS(2651),
    [anon_sym___forceinline] = ACTIONS(2651),
    [anon_sym_thread_local] = ACTIONS(2651),
    [anon_sym___thread] = ACTIONS(2651),
    [anon_sym_const] = ACTIONS(2651),
    [anon_sym_constexpr] = ACTIONS(2651),
    [anon_sym_volatile] = ACTIONS(2651),
    [anon_sym_restrict] = ACTIONS(2651),
    [anon_sym___restrict__] = ACTIONS(2651),
    [anon_sym__Atomic] = ACTIONS(2651),
    [anon_sym__Noreturn] = ACTIONS(2651),
    [anon_sym_noreturn] = ACTIONS(2651),
    [anon_sym__Nonnull] = ACTIONS(2651),
    [anon_sym_mutable] = ACTIONS(2651),
    [anon_sym_constinit] = ACTIONS(2651),
    [anon_sym_consteval] = ACTIONS(2651),
    [anon_sym_alignas] = ACTIONS(2651),
    [anon_sym__Alignas] = ACTIONS(2651),
    [sym_primitive_type] = ACTIONS(2651),
    [anon_sym_enum] = ACTIONS(2651),
    [anon_sym_class] = ACTIONS(2651),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_union] = ACTIONS(2651),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_else] = ACTIONS(2651),
    [anon_sym_switch] = ACTIONS(2651),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_default] = ACTIONS(2651),
    [anon_sym_while] = ACTIONS(2651),
    [anon_sym_do] = ACTIONS(2651),
    [anon_sym_for] = ACTIONS(2651),
    [anon_sym_return] = ACTIONS(2651),
    [anon_sym_break] = ACTIONS(2651),
    [anon_sym_continue] = ACTIONS(2651),
    [anon_sym_goto] = ACTIONS(2651),
    [anon_sym___try] = ACTIONS(2651),
    [anon_sym___leave] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2651),
    [anon_sym_compl] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2653),
    [anon_sym_sizeof] = ACTIONS(2651),
    [anon_sym___alignof__] = ACTIONS(2651),
    [anon_sym___alignof] = ACTIONS(2651),
    [anon_sym__alignof] = ACTIONS(2651),
    [anon_sym_alignof] = ACTIONS(2651),
    [anon_sym__Alignof] = ACTIONS(2651),
    [anon_sym_offsetof] = ACTIONS(2651),
    [anon_sym__Generic] = ACTIONS(2651),
    [anon_sym_asm] = ACTIONS(2651),
    [anon_sym___asm__] = ACTIONS(2651),
    [anon_sym___asm] = ACTIONS(2651),
    [sym_number_literal] = ACTIONS(2653),
    [anon_sym_L_SQUOTE] = ACTIONS(2653),
    [anon_sym_u_SQUOTE] = ACTIONS(2653),
    [anon_sym_U_SQUOTE] = ACTIONS(2653),
    [anon_sym_u8_SQUOTE] = ACTIONS(2653),
    [anon_sym_SQUOTE] = ACTIONS(2653),
    [anon_sym_L_DQUOTE] = ACTIONS(2653),
    [anon_sym_u_DQUOTE] = ACTIONS(2653),
    [anon_sym_U_DQUOTE] = ACTIONS(2653),
    [anon_sym_u8_DQUOTE] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(2653),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [anon_sym_NULL] = ACTIONS(2651),
    [anon_sym_nullptr] = ACTIONS(2651),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2651),
    [anon_sym_decltype] = ACTIONS(2651),
    [anon_sym_explicit] = ACTIONS(2651),
    [anon_sym_typename] = ACTIONS(2651),
    [anon_sym_template] = ACTIONS(2651),
    [anon_sym_operator] = ACTIONS(2651),
    [anon_sym_try] = ACTIONS(2651),
    [anon_sym_delete] = ACTIONS(2651),
    [anon_sym_throw] = ACTIONS(2651),
    [anon_sym_namespace] = ACTIONS(2651),
    [anon_sym_static_assert] = ACTIONS(2651),
    [anon_sym_concept] = ACTIONS(2651),
    [anon_sym_co_return] = ACTIONS(2651),
    [anon_sym_co_yield] = ACTIONS(2651),
    [anon_sym_R_DQUOTE] = ACTIONS(2653),
    [anon_sym_LR_DQUOTE] = ACTIONS(2653),
    [anon_sym_uR_DQUOTE] = ACTIONS(2653),
    [anon_sym_UR_DQUOTE] = ACTIONS(2653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2653),
    [anon_sym_co_await] = ACTIONS(2651),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_requires] = ACTIONS(2651),
    [sym_this] = ACTIONS(2651),
  },
  [633] = {
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token2] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym___attribute] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym__Nonnull] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym__Alignas] = ACTIONS(2669),
    [sym_primitive_type] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [anon_sym___asm] = ACTIONS(2669),
    [sym_number_literal] = ACTIONS(2671),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(3110),
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_include_token1] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_BANG] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym___attribute] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym___cdecl] = ACTIONS(3108),
    [anon_sym___clrcall] = ACTIONS(3108),
    [anon_sym___stdcall] = ACTIONS(3108),
    [anon_sym___fastcall] = ACTIONS(3108),
    [anon_sym___thiscall] = ACTIONS(3108),
    [anon_sym___vectorcall] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym__Nonnull] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym__Alignas] = ACTIONS(3108),
    [sym_primitive_type] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [anon_sym_if] = ACTIONS(3108),
    [anon_sym_switch] = ACTIONS(3108),
    [anon_sym_case] = ACTIONS(3108),
    [anon_sym_default] = ACTIONS(3108),
    [anon_sym_while] = ACTIONS(3108),
    [anon_sym_do] = ACTIONS(3108),
    [anon_sym_for] = ACTIONS(3108),
    [anon_sym_return] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3108),
    [anon_sym_continue] = ACTIONS(3108),
    [anon_sym_goto] = ACTIONS(3108),
    [anon_sym_not] = ACTIONS(3108),
    [anon_sym_compl] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_sizeof] = ACTIONS(3108),
    [anon_sym___alignof__] = ACTIONS(3108),
    [anon_sym___alignof] = ACTIONS(3108),
    [anon_sym__alignof] = ACTIONS(3108),
    [anon_sym_alignof] = ACTIONS(3108),
    [anon_sym__Alignof] = ACTIONS(3108),
    [anon_sym_offsetof] = ACTIONS(3108),
    [anon_sym__Generic] = ACTIONS(3108),
    [anon_sym_asm] = ACTIONS(3108),
    [anon_sym___asm__] = ACTIONS(3108),
    [anon_sym___asm] = ACTIONS(3108),
    [sym_number_literal] = ACTIONS(3110),
    [anon_sym_L_SQUOTE] = ACTIONS(3110),
    [anon_sym_u_SQUOTE] = ACTIONS(3110),
    [anon_sym_U_SQUOTE] = ACTIONS(3110),
    [anon_sym_u8_SQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [anon_sym_L_DQUOTE] = ACTIONS(3110),
    [anon_sym_u_DQUOTE] = ACTIONS(3110),
    [anon_sym_U_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8_DQUOTE] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [anon_sym_NULL] = ACTIONS(3108),
    [anon_sym_nullptr] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_export] = ACTIONS(3108),
    [anon_sym_module] = ACTIONS(3108),
    [anon_sym_import] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_try] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(3108),
    [anon_sym_throw] = ACTIONS(3108),
    [anon_sym_namespace] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
    [anon_sym_concept] = ACTIONS(3108),
    [anon_sym_co_return] = ACTIONS(3108),
    [anon_sym_co_yield] = ACTIONS(3108),
    [anon_sym_R_DQUOTE] = ACTIONS(3110),
    [anon_sym_LR_DQUOTE] = ACTIONS(3110),
    [anon_sym_uR_DQUOTE] = ACTIONS(3110),
    [anon_sym_UR_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3110),
    [anon_sym_co_await] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_requires] = ACTIONS(3108),
    [sym_this] = ACTIONS(3108),
  },
  [635] = {
    [ts_builtin_sym_end] = ACTIONS(3114),
    [sym_identifier] = ACTIONS(3112),
    [aux_sym_preproc_include_token1] = ACTIONS(3112),
    [aux_sym_preproc_def_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3112),
    [sym_preproc_directive] = ACTIONS(3112),
    [anon_sym_LPAREN2] = ACTIONS(3114),
    [anon_sym_BANG] = ACTIONS(3114),
    [anon_sym_TILDE] = ACTIONS(3114),
    [anon_sym_DASH] = ACTIONS(3112),
    [anon_sym_PLUS] = ACTIONS(3112),
    [anon_sym_STAR] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3112),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym___extension__] = ACTIONS(3112),
    [anon_sym_typedef] = ACTIONS(3112),
    [anon_sym_virtual] = ACTIONS(3112),
    [anon_sym_extern] = ACTIONS(3112),
    [anon_sym___attribute__] = ACTIONS(3112),
    [anon_sym___attribute] = ACTIONS(3112),
    [anon_sym_using] = ACTIONS(3112),
    [anon_sym_COLON_COLON] = ACTIONS(3114),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3114),
    [anon_sym___declspec] = ACTIONS(3112),
    [anon_sym___based] = ACTIONS(3112),
    [anon_sym___cdecl] = ACTIONS(3112),
    [anon_sym___clrcall] = ACTIONS(3112),
    [anon_sym___stdcall] = ACTIONS(3112),
    [anon_sym___fastcall] = ACTIONS(3112),
    [anon_sym___thiscall] = ACTIONS(3112),
    [anon_sym___vectorcall] = ACTIONS(3112),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_signed] = ACTIONS(3112),
    [anon_sym_unsigned] = ACTIONS(3112),
    [anon_sym_long] = ACTIONS(3112),
    [anon_sym_short] = ACTIONS(3112),
    [anon_sym_LBRACK] = ACTIONS(3112),
    [anon_sym_static] = ACTIONS(3112),
    [anon_sym_register] = ACTIONS(3112),
    [anon_sym_inline] = ACTIONS(3112),
    [anon_sym___inline] = ACTIONS(3112),
    [anon_sym___inline__] = ACTIONS(3112),
    [anon_sym___forceinline] = ACTIONS(3112),
    [anon_sym_thread_local] = ACTIONS(3112),
    [anon_sym___thread] = ACTIONS(3112),
    [anon_sym_const] = ACTIONS(3112),
    [anon_sym_constexpr] = ACTIONS(3112),
    [anon_sym_volatile] = ACTIONS(3112),
    [anon_sym_restrict] = ACTIONS(3112),
    [anon_sym___restrict__] = ACTIONS(3112),
    [anon_sym__Atomic] = ACTIONS(3112),
    [anon_sym__Noreturn] = ACTIONS(3112),
    [anon_sym_noreturn] = ACTIONS(3112),
    [anon_sym__Nonnull] = ACTIONS(3112),
    [anon_sym_mutable] = ACTIONS(3112),
    [anon_sym_constinit] = ACTIONS(3112),
    [anon_sym_consteval] = ACTIONS(3112),
    [anon_sym_alignas] = ACTIONS(3112),
    [anon_sym__Alignas] = ACTIONS(3112),
    [sym_primitive_type] = ACTIONS(3112),
    [anon_sym_enum] = ACTIONS(3112),
    [anon_sym_class] = ACTIONS(3112),
    [anon_sym_struct] = ACTIONS(3112),
    [anon_sym_union] = ACTIONS(3112),
    [anon_sym_if] = ACTIONS(3112),
    [anon_sym_switch] = ACTIONS(3112),
    [anon_sym_case] = ACTIONS(3112),
    [anon_sym_default] = ACTIONS(3112),
    [anon_sym_while] = ACTIONS(3112),
    [anon_sym_do] = ACTIONS(3112),
    [anon_sym_for] = ACTIONS(3112),
    [anon_sym_return] = ACTIONS(3112),
    [anon_sym_break] = ACTIONS(3112),
    [anon_sym_continue] = ACTIONS(3112),
    [anon_sym_goto] = ACTIONS(3112),
    [anon_sym_not] = ACTIONS(3112),
    [anon_sym_compl] = ACTIONS(3112),
    [anon_sym_DASH_DASH] = ACTIONS(3114),
    [anon_sym_PLUS_PLUS] = ACTIONS(3114),
    [anon_sym_sizeof] = ACTIONS(3112),
    [anon_sym___alignof__] = ACTIONS(3112),
    [anon_sym___alignof] = ACTIONS(3112),
    [anon_sym__alignof] = ACTIONS(3112),
    [anon_sym_alignof] = ACTIONS(3112),
    [anon_sym__Alignof] = ACTIONS(3112),
    [anon_sym_offsetof] = ACTIONS(3112),
    [anon_sym__Generic] = ACTIONS(3112),
    [anon_sym_asm] = ACTIONS(3112),
    [anon_sym___asm__] = ACTIONS(3112),
    [anon_sym___asm] = ACTIONS(3112),
    [sym_number_literal] = ACTIONS(3114),
    [anon_sym_L_SQUOTE] = ACTIONS(3114),
    [anon_sym_u_SQUOTE] = ACTIONS(3114),
    [anon_sym_U_SQUOTE] = ACTIONS(3114),
    [anon_sym_u8_SQUOTE] = ACTIONS(3114),
    [anon_sym_SQUOTE] = ACTIONS(3114),
    [anon_sym_L_DQUOTE] = ACTIONS(3114),
    [anon_sym_u_DQUOTE] = ACTIONS(3114),
    [anon_sym_U_DQUOTE] = ACTIONS(3114),
    [anon_sym_u8_DQUOTE] = ACTIONS(3114),
    [anon_sym_DQUOTE] = ACTIONS(3114),
    [sym_true] = ACTIONS(3112),
    [sym_false] = ACTIONS(3112),
    [anon_sym_NULL] = ACTIONS(3112),
    [anon_sym_nullptr] = ACTIONS(3112),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3112),
    [anon_sym_decltype] = ACTIONS(3112),
    [anon_sym_explicit] = ACTIONS(3112),
    [anon_sym_typename] = ACTIONS(3112),
    [anon_sym_export] = ACTIONS(3112),
    [anon_sym_module] = ACTIONS(3112),
    [anon_sym_import] = ACTIONS(3112),
    [anon_sym_template] = ACTIONS(3112),
    [anon_sym_operator] = ACTIONS(3112),
    [anon_sym_try] = ACTIONS(3112),
    [anon_sym_delete] = ACTIONS(3112),
    [anon_sym_throw] = ACTIONS(3112),
    [anon_sym_namespace] = ACTIONS(3112),
    [anon_sym_static_assert] = ACTIONS(3112),
    [anon_sym_concept] = ACTIONS(3112),
    [anon_sym_co_return] = ACTIONS(3112),
    [anon_sym_co_yield] = ACTIONS(3112),
    [anon_sym_R_DQUOTE] = ACTIONS(3114),
    [anon_sym_LR_DQUOTE] = ACTIONS(3114),
    [anon_sym_uR_DQUOTE] = ACTIONS(3114),
    [anon_sym_UR_DQUOTE] = ACTIONS(3114),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3114),
    [anon_sym_co_await] = ACTIONS(3112),
    [anon_sym_new] = ACTIONS(3112),
    [anon_sym_requires] = ACTIONS(3112),
    [sym_this] = ACTIONS(3112),
  },
  [636] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym___attribute] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym__Nonnull] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym__Alignas] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [anon_sym___asm] = ACTIONS(2723),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [637] = {
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_include_token1] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token2] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym___cdecl] = ACTIONS(2759),
    [anon_sym___clrcall] = ACTIONS(2759),
    [anon_sym___stdcall] = ACTIONS(2759),
    [anon_sym___fastcall] = ACTIONS(2759),
    [anon_sym___thiscall] = ACTIONS(2759),
    [anon_sym___vectorcall] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_switch] = ACTIONS(2759),
    [anon_sym_case] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_goto] = ACTIONS(2759),
    [anon_sym___try] = ACTIONS(2759),
    [anon_sym___leave] = ACTIONS(2759),
    [anon_sym_not] = ACTIONS(2759),
    [anon_sym_compl] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_sizeof] = ACTIONS(2759),
    [anon_sym___alignof__] = ACTIONS(2759),
    [anon_sym___alignof] = ACTIONS(2759),
    [anon_sym__alignof] = ACTIONS(2759),
    [anon_sym_alignof] = ACTIONS(2759),
    [anon_sym__Alignof] = ACTIONS(2759),
    [anon_sym_offsetof] = ACTIONS(2759),
    [anon_sym__Generic] = ACTIONS(2759),
    [anon_sym_asm] = ACTIONS(2759),
    [anon_sym___asm__] = ACTIONS(2759),
    [anon_sym___asm] = ACTIONS(2759),
    [sym_number_literal] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2761),
    [anon_sym_u_SQUOTE] = ACTIONS(2761),
    [anon_sym_U_SQUOTE] = ACTIONS(2761),
    [anon_sym_u8_SQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_L_DQUOTE] = ACTIONS(2761),
    [anon_sym_u_DQUOTE] = ACTIONS(2761),
    [anon_sym_U_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8_DQUOTE] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2759),
    [anon_sym_nullptr] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2759),
    [anon_sym_throw] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
    [anon_sym_concept] = ACTIONS(2759),
    [anon_sym_co_return] = ACTIONS(2759),
    [anon_sym_co_yield] = ACTIONS(2759),
    [anon_sym_R_DQUOTE] = ACTIONS(2761),
    [anon_sym_LR_DQUOTE] = ACTIONS(2761),
    [anon_sym_uR_DQUOTE] = ACTIONS(2761),
    [anon_sym_UR_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2761),
    [anon_sym_co_await] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_requires] = ACTIONS(2759),
    [sym_this] = ACTIONS(2759),
  },
  [638] = {
    [ts_builtin_sym_end] = ACTIONS(3587),
    [sym_identifier] = ACTIONS(3589),
    [aux_sym_preproc_include_token1] = ACTIONS(3589),
    [aux_sym_preproc_def_token1] = ACTIONS(3589),
    [aux_sym_preproc_if_token1] = ACTIONS(3589),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3589),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3589),
    [sym_preproc_directive] = ACTIONS(3589),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_BANG] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3589),
    [anon_sym_PLUS] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(3587),
    [anon_sym___extension__] = ACTIONS(3589),
    [anon_sym_typedef] = ACTIONS(3589),
    [anon_sym_virtual] = ACTIONS(3589),
    [anon_sym_extern] = ACTIONS(3589),
    [anon_sym___attribute__] = ACTIONS(3589),
    [anon_sym___attribute] = ACTIONS(3589),
    [anon_sym_using] = ACTIONS(3589),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3587),
    [anon_sym___declspec] = ACTIONS(3589),
    [anon_sym___based] = ACTIONS(3589),
    [anon_sym___cdecl] = ACTIONS(3589),
    [anon_sym___clrcall] = ACTIONS(3589),
    [anon_sym___stdcall] = ACTIONS(3589),
    [anon_sym___fastcall] = ACTIONS(3589),
    [anon_sym___thiscall] = ACTIONS(3589),
    [anon_sym___vectorcall] = ACTIONS(3589),
    [anon_sym_LBRACE] = ACTIONS(3587),
    [anon_sym_signed] = ACTIONS(3589),
    [anon_sym_unsigned] = ACTIONS(3589),
    [anon_sym_long] = ACTIONS(3589),
    [anon_sym_short] = ACTIONS(3589),
    [anon_sym_LBRACK] = ACTIONS(3589),
    [anon_sym_static] = ACTIONS(3589),
    [anon_sym_register] = ACTIONS(3589),
    [anon_sym_inline] = ACTIONS(3589),
    [anon_sym___inline] = ACTIONS(3589),
    [anon_sym___inline__] = ACTIONS(3589),
    [anon_sym___forceinline] = ACTIONS(3589),
    [anon_sym_thread_local] = ACTIONS(3589),
    [anon_sym___thread] = ACTIONS(3589),
    [anon_sym_const] = ACTIONS(3589),
    [anon_sym_constexpr] = ACTIONS(3589),
    [anon_sym_volatile] = ACTIONS(3589),
    [anon_sym_restrict] = ACTIONS(3589),
    [anon_sym___restrict__] = ACTIONS(3589),
    [anon_sym__Atomic] = ACTIONS(3589),
    [anon_sym__Noreturn] = ACTIONS(3589),
    [anon_sym_noreturn] = ACTIONS(3589),
    [anon_sym__Nonnull] = ACTIONS(3589),
    [anon_sym_mutable] = ACTIONS(3589),
    [anon_sym_constinit] = ACTIONS(3589),
    [anon_sym_consteval] = ACTIONS(3589),
    [anon_sym_alignas] = ACTIONS(3589),
    [anon_sym__Alignas] = ACTIONS(3589),
    [sym_primitive_type] = ACTIONS(3589),
    [anon_sym_enum] = ACTIONS(3589),
    [anon_sym_class] = ACTIONS(3589),
    [anon_sym_struct] = ACTIONS(3589),
    [anon_sym_union] = ACTIONS(3589),
    [anon_sym_if] = ACTIONS(3589),
    [anon_sym_switch] = ACTIONS(3589),
    [anon_sym_case] = ACTIONS(3589),
    [anon_sym_default] = ACTIONS(3589),
    [anon_sym_while] = ACTIONS(3589),
    [anon_sym_do] = ACTIONS(3589),
    [anon_sym_for] = ACTIONS(3589),
    [anon_sym_return] = ACTIONS(3589),
    [anon_sym_break] = ACTIONS(3589),
    [anon_sym_continue] = ACTIONS(3589),
    [anon_sym_goto] = ACTIONS(3589),
    [anon_sym_not] = ACTIONS(3589),
    [anon_sym_compl] = ACTIONS(3589),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_sizeof] = ACTIONS(3589),
    [anon_sym___alignof__] = ACTIONS(3589),
    [anon_sym___alignof] = ACTIONS(3589),
    [anon_sym__alignof] = ACTIONS(3589),
    [anon_sym_alignof] = ACTIONS(3589),
    [anon_sym__Alignof] = ACTIONS(3589),
    [anon_sym_offsetof] = ACTIONS(3589),
    [anon_sym__Generic] = ACTIONS(3589),
    [anon_sym_asm] = ACTIONS(3589),
    [anon_sym___asm__] = ACTIONS(3589),
    [anon_sym___asm] = ACTIONS(3589),
    [sym_number_literal] = ACTIONS(3587),
    [anon_sym_L_SQUOTE] = ACTIONS(3587),
    [anon_sym_u_SQUOTE] = ACTIONS(3587),
    [anon_sym_U_SQUOTE] = ACTIONS(3587),
    [anon_sym_u8_SQUOTE] = ACTIONS(3587),
    [anon_sym_SQUOTE] = ACTIONS(3587),
    [anon_sym_L_DQUOTE] = ACTIONS(3587),
    [anon_sym_u_DQUOTE] = ACTIONS(3587),
    [anon_sym_U_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym_true] = ACTIONS(3589),
    [sym_false] = ACTIONS(3589),
    [anon_sym_NULL] = ACTIONS(3589),
    [anon_sym_nullptr] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3589),
    [anon_sym_decltype] = ACTIONS(3589),
    [anon_sym_explicit] = ACTIONS(3589),
    [anon_sym_typename] = ACTIONS(3589),
    [anon_sym_export] = ACTIONS(3589),
    [anon_sym_module] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3589),
    [anon_sym_template] = ACTIONS(3589),
    [anon_sym_operator] = ACTIONS(3589),
    [anon_sym_try] = ACTIONS(3589),
    [anon_sym_delete] = ACTIONS(3589),
    [anon_sym_throw] = ACTIONS(3589),
    [anon_sym_namespace] = ACTIONS(3589),
    [anon_sym_static_assert] = ACTIONS(3589),
    [anon_sym_concept] = ACTIONS(3589),
    [anon_sym_co_return] = ACTIONS(3589),
    [anon_sym_co_yield] = ACTIONS(3589),
    [anon_sym_R_DQUOTE] = ACTIONS(3587),
    [anon_sym_LR_DQUOTE] = ACTIONS(3587),
    [anon_sym_uR_DQUOTE] = ACTIONS(3587),
    [anon_sym_UR_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3587),
    [anon_sym_co_await] = ACTIONS(3589),
    [anon_sym_new] = ACTIONS(3589),
    [anon_sym_requires] = ACTIONS(3589),
    [sym_this] = ACTIONS(3589),
  },
  [639] = {
    [sym_identifier] = ACTIONS(2631),
    [aux_sym_preproc_include_token1] = ACTIONS(2631),
    [aux_sym_preproc_def_token1] = ACTIONS(2631),
    [aux_sym_preproc_if_token1] = ACTIONS(2631),
    [aux_sym_preproc_if_token2] = ACTIONS(2631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2631),
    [sym_preproc_directive] = ACTIONS(2631),
    [anon_sym_LPAREN2] = ACTIONS(2633),
    [anon_sym_BANG] = ACTIONS(2633),
    [anon_sym_TILDE] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym___extension__] = ACTIONS(2631),
    [anon_sym_typedef] = ACTIONS(2631),
    [anon_sym_virtual] = ACTIONS(2631),
    [anon_sym_extern] = ACTIONS(2631),
    [anon_sym___attribute__] = ACTIONS(2631),
    [anon_sym___attribute] = ACTIONS(2631),
    [anon_sym_using] = ACTIONS(2631),
    [anon_sym_COLON_COLON] = ACTIONS(2633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2633),
    [anon_sym___declspec] = ACTIONS(2631),
    [anon_sym___based] = ACTIONS(2631),
    [anon_sym___cdecl] = ACTIONS(2631),
    [anon_sym___clrcall] = ACTIONS(2631),
    [anon_sym___stdcall] = ACTIONS(2631),
    [anon_sym___fastcall] = ACTIONS(2631),
    [anon_sym___thiscall] = ACTIONS(2631),
    [anon_sym___vectorcall] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_signed] = ACTIONS(2631),
    [anon_sym_unsigned] = ACTIONS(2631),
    [anon_sym_long] = ACTIONS(2631),
    [anon_sym_short] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2631),
    [anon_sym_static] = ACTIONS(2631),
    [anon_sym_register] = ACTIONS(2631),
    [anon_sym_inline] = ACTIONS(2631),
    [anon_sym___inline] = ACTIONS(2631),
    [anon_sym___inline__] = ACTIONS(2631),
    [anon_sym___forceinline] = ACTIONS(2631),
    [anon_sym_thread_local] = ACTIONS(2631),
    [anon_sym___thread] = ACTIONS(2631),
    [anon_sym_const] = ACTIONS(2631),
    [anon_sym_constexpr] = ACTIONS(2631),
    [anon_sym_volatile] = ACTIONS(2631),
    [anon_sym_restrict] = ACTIONS(2631),
    [anon_sym___restrict__] = ACTIONS(2631),
    [anon_sym__Atomic] = ACTIONS(2631),
    [anon_sym__Noreturn] = ACTIONS(2631),
    [anon_sym_noreturn] = ACTIONS(2631),
    [anon_sym__Nonnull] = ACTIONS(2631),
    [anon_sym_mutable] = ACTIONS(2631),
    [anon_sym_constinit] = ACTIONS(2631),
    [anon_sym_consteval] = ACTIONS(2631),
    [anon_sym_alignas] = ACTIONS(2631),
    [anon_sym__Alignas] = ACTIONS(2631),
    [sym_primitive_type] = ACTIONS(2631),
    [anon_sym_enum] = ACTIONS(2631),
    [anon_sym_class] = ACTIONS(2631),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_union] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_else] = ACTIONS(2631),
    [anon_sym_switch] = ACTIONS(2631),
    [anon_sym_case] = ACTIONS(2631),
    [anon_sym_default] = ACTIONS(2631),
    [anon_sym_while] = ACTIONS(2631),
    [anon_sym_do] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_goto] = ACTIONS(2631),
    [anon_sym___try] = ACTIONS(2631),
    [anon_sym___leave] = ACTIONS(2631),
    [anon_sym_not] = ACTIONS(2631),
    [anon_sym_compl] = ACTIONS(2631),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_sizeof] = ACTIONS(2631),
    [anon_sym___alignof__] = ACTIONS(2631),
    [anon_sym___alignof] = ACTIONS(2631),
    [anon_sym__alignof] = ACTIONS(2631),
    [anon_sym_alignof] = ACTIONS(2631),
    [anon_sym__Alignof] = ACTIONS(2631),
    [anon_sym_offsetof] = ACTIONS(2631),
    [anon_sym__Generic] = ACTIONS(2631),
    [anon_sym_asm] = ACTIONS(2631),
    [anon_sym___asm__] = ACTIONS(2631),
    [anon_sym___asm] = ACTIONS(2631),
    [sym_number_literal] = ACTIONS(2633),
    [anon_sym_L_SQUOTE] = ACTIONS(2633),
    [anon_sym_u_SQUOTE] = ACTIONS(2633),
    [anon_sym_U_SQUOTE] = ACTIONS(2633),
    [anon_sym_u8_SQUOTE] = ACTIONS(2633),
    [anon_sym_SQUOTE] = ACTIONS(2633),
    [anon_sym_L_DQUOTE] = ACTIONS(2633),
    [anon_sym_u_DQUOTE] = ACTIONS(2633),
    [anon_sym_U_DQUOTE] = ACTIONS(2633),
    [anon_sym_u8_DQUOTE] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(2633),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [anon_sym_NULL] = ACTIONS(2631),
    [anon_sym_nullptr] = ACTIONS(2631),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2631),
    [anon_sym_decltype] = ACTIONS(2631),
    [anon_sym_explicit] = ACTIONS(2631),
    [anon_sym_typename] = ACTIONS(2631),
    [anon_sym_template] = ACTIONS(2631),
    [anon_sym_operator] = ACTIONS(2631),
    [anon_sym_try] = ACTIONS(2631),
    [anon_sym_delete] = ACTIONS(2631),
    [anon_sym_throw] = ACTIONS(2631),
    [anon_sym_namespace] = ACTIONS(2631),
    [anon_sym_static_assert] = ACTIONS(2631),
    [anon_sym_concept] = ACTIONS(2631),
    [anon_sym_co_return] = ACTIONS(2631),
    [anon_sym_co_yield] = ACTIONS(2631),
    [anon_sym_R_DQUOTE] = ACTIONS(2633),
    [anon_sym_LR_DQUOTE] = ACTIONS(2633),
    [anon_sym_uR_DQUOTE] = ACTIONS(2633),
    [anon_sym_UR_DQUOTE] = ACTIONS(2633),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2633),
    [anon_sym_co_await] = ACTIONS(2631),
    [anon_sym_new] = ACTIONS(2631),
    [anon_sym_requires] = ACTIONS(2631),
    [sym_this] = ACTIONS(2631),
  },
  [640] = {
    [sym_identifier] = ACTIONS(2635),
    [aux_sym_preproc_include_token1] = ACTIONS(2635),
    [aux_sym_preproc_def_token1] = ACTIONS(2635),
    [aux_sym_preproc_if_token1] = ACTIONS(2635),
    [aux_sym_preproc_if_token2] = ACTIONS(2635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2635),
    [sym_preproc_directive] = ACTIONS(2635),
    [anon_sym_LPAREN2] = ACTIONS(2637),
    [anon_sym_BANG] = ACTIONS(2637),
    [anon_sym_TILDE] = ACTIONS(2637),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2637),
    [anon_sym_AMP_AMP] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_SEMI] = ACTIONS(2637),
    [anon_sym___extension__] = ACTIONS(2635),
    [anon_sym_typedef] = ACTIONS(2635),
    [anon_sym_virtual] = ACTIONS(2635),
    [anon_sym_extern] = ACTIONS(2635),
    [anon_sym___attribute__] = ACTIONS(2635),
    [anon_sym___attribute] = ACTIONS(2635),
    [anon_sym_using] = ACTIONS(2635),
    [anon_sym_COLON_COLON] = ACTIONS(2637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2637),
    [anon_sym___declspec] = ACTIONS(2635),
    [anon_sym___based] = ACTIONS(2635),
    [anon_sym___cdecl] = ACTIONS(2635),
    [anon_sym___clrcall] = ACTIONS(2635),
    [anon_sym___stdcall] = ACTIONS(2635),
    [anon_sym___fastcall] = ACTIONS(2635),
    [anon_sym___thiscall] = ACTIONS(2635),
    [anon_sym___vectorcall] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2637),
    [anon_sym_signed] = ACTIONS(2635),
    [anon_sym_unsigned] = ACTIONS(2635),
    [anon_sym_long] = ACTIONS(2635),
    [anon_sym_short] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(2635),
    [anon_sym_static] = ACTIONS(2635),
    [anon_sym_register] = ACTIONS(2635),
    [anon_sym_inline] = ACTIONS(2635),
    [anon_sym___inline] = ACTIONS(2635),
    [anon_sym___inline__] = ACTIONS(2635),
    [anon_sym___forceinline] = ACTIONS(2635),
    [anon_sym_thread_local] = ACTIONS(2635),
    [anon_sym___thread] = ACTIONS(2635),
    [anon_sym_const] = ACTIONS(2635),
    [anon_sym_constexpr] = ACTIONS(2635),
    [anon_sym_volatile] = ACTIONS(2635),
    [anon_sym_restrict] = ACTIONS(2635),
    [anon_sym___restrict__] = ACTIONS(2635),
    [anon_sym__Atomic] = ACTIONS(2635),
    [anon_sym__Noreturn] = ACTIONS(2635),
    [anon_sym_noreturn] = ACTIONS(2635),
    [anon_sym__Nonnull] = ACTIONS(2635),
    [anon_sym_mutable] = ACTIONS(2635),
    [anon_sym_constinit] = ACTIONS(2635),
    [anon_sym_consteval] = ACTIONS(2635),
    [anon_sym_alignas] = ACTIONS(2635),
    [anon_sym__Alignas] = ACTIONS(2635),
    [sym_primitive_type] = ACTIONS(2635),
    [anon_sym_enum] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(2635),
    [anon_sym_struct] = ACTIONS(2635),
    [anon_sym_union] = ACTIONS(2635),
    [anon_sym_if] = ACTIONS(2635),
    [anon_sym_else] = ACTIONS(2635),
    [anon_sym_switch] = ACTIONS(2635),
    [anon_sym_case] = ACTIONS(2635),
    [anon_sym_default] = ACTIONS(2635),
    [anon_sym_while] = ACTIONS(2635),
    [anon_sym_do] = ACTIONS(2635),
    [anon_sym_for] = ACTIONS(2635),
    [anon_sym_return] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_continue] = ACTIONS(2635),
    [anon_sym_goto] = ACTIONS(2635),
    [anon_sym___try] = ACTIONS(2635),
    [anon_sym___leave] = ACTIONS(2635),
    [anon_sym_not] = ACTIONS(2635),
    [anon_sym_compl] = ACTIONS(2635),
    [anon_sym_DASH_DASH] = ACTIONS(2637),
    [anon_sym_PLUS_PLUS] = ACTIONS(2637),
    [anon_sym_sizeof] = ACTIONS(2635),
    [anon_sym___alignof__] = ACTIONS(2635),
    [anon_sym___alignof] = ACTIONS(2635),
    [anon_sym__alignof] = ACTIONS(2635),
    [anon_sym_alignof] = ACTIONS(2635),
    [anon_sym__Alignof] = ACTIONS(2635),
    [anon_sym_offsetof] = ACTIONS(2635),
    [anon_sym__Generic] = ACTIONS(2635),
    [anon_sym_asm] = ACTIONS(2635),
    [anon_sym___asm__] = ACTIONS(2635),
    [anon_sym___asm] = ACTIONS(2635),
    [sym_number_literal] = ACTIONS(2637),
    [anon_sym_L_SQUOTE] = ACTIONS(2637),
    [anon_sym_u_SQUOTE] = ACTIONS(2637),
    [anon_sym_U_SQUOTE] = ACTIONS(2637),
    [anon_sym_u8_SQUOTE] = ACTIONS(2637),
    [anon_sym_SQUOTE] = ACTIONS(2637),
    [anon_sym_L_DQUOTE] = ACTIONS(2637),
    [anon_sym_u_DQUOTE] = ACTIONS(2637),
    [anon_sym_U_DQUOTE] = ACTIONS(2637),
    [anon_sym_u8_DQUOTE] = ACTIONS(2637),
    [anon_sym_DQUOTE] = ACTIONS(2637),
    [sym_true] = ACTIONS(2635),
    [sym_false] = ACTIONS(2635),
    [anon_sym_NULL] = ACTIONS(2635),
    [anon_sym_nullptr] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2635),
    [anon_sym_decltype] = ACTIONS(2635),
    [anon_sym_explicit] = ACTIONS(2635),
    [anon_sym_typename] = ACTIONS(2635),
    [anon_sym_template] = ACTIONS(2635),
    [anon_sym_operator] = ACTIONS(2635),
    [anon_sym_try] = ACTIONS(2635),
    [anon_sym_delete] = ACTIONS(2635),
    [anon_sym_throw] = ACTIONS(2635),
    [anon_sym_namespace] = ACTIONS(2635),
    [anon_sym_static_assert] = ACTIONS(2635),
    [anon_sym_concept] = ACTIONS(2635),
    [anon_sym_co_return] = ACTIONS(2635),
    [anon_sym_co_yield] = ACTIONS(2635),
    [anon_sym_R_DQUOTE] = ACTIONS(2637),
    [anon_sym_LR_DQUOTE] = ACTIONS(2637),
    [anon_sym_uR_DQUOTE] = ACTIONS(2637),
    [anon_sym_UR_DQUOTE] = ACTIONS(2637),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2637),
    [anon_sym_co_await] = ACTIONS(2635),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2635),
    [sym_this] = ACTIONS(2635),
  },
  [641] = {
    [ts_builtin_sym_end] = ACTIONS(3591),
    [sym_identifier] = ACTIONS(3593),
    [aux_sym_preproc_include_token1] = ACTIONS(3593),
    [aux_sym_preproc_def_token1] = ACTIONS(3593),
    [aux_sym_preproc_if_token1] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3593),
    [sym_preproc_directive] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(3591),
    [anon_sym_BANG] = ACTIONS(3591),
    [anon_sym_TILDE] = ACTIONS(3591),
    [anon_sym_DASH] = ACTIONS(3593),
    [anon_sym_PLUS] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3591),
    [anon_sym_AMP_AMP] = ACTIONS(3591),
    [anon_sym_AMP] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(3591),
    [anon_sym___extension__] = ACTIONS(3593),
    [anon_sym_typedef] = ACTIONS(3593),
    [anon_sym_virtual] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym___attribute__] = ACTIONS(3593),
    [anon_sym___attribute] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_COLON_COLON] = ACTIONS(3591),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3591),
    [anon_sym___declspec] = ACTIONS(3593),
    [anon_sym___based] = ACTIONS(3593),
    [anon_sym___cdecl] = ACTIONS(3593),
    [anon_sym___clrcall] = ACTIONS(3593),
    [anon_sym___stdcall] = ACTIONS(3593),
    [anon_sym___fastcall] = ACTIONS(3593),
    [anon_sym___thiscall] = ACTIONS(3593),
    [anon_sym___vectorcall] = ACTIONS(3593),
    [anon_sym_LBRACE] = ACTIONS(3591),
    [anon_sym_signed] = ACTIONS(3593),
    [anon_sym_unsigned] = ACTIONS(3593),
    [anon_sym_long] = ACTIONS(3593),
    [anon_sym_short] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(3593),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_register] = ACTIONS(3593),
    [anon_sym_inline] = ACTIONS(3593),
    [anon_sym___inline] = ACTIONS(3593),
    [anon_sym___inline__] = ACTIONS(3593),
    [anon_sym___forceinline] = ACTIONS(3593),
    [anon_sym_thread_local] = ACTIONS(3593),
    [anon_sym___thread] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_constexpr] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym_restrict] = ACTIONS(3593),
    [anon_sym___restrict__] = ACTIONS(3593),
    [anon_sym__Atomic] = ACTIONS(3593),
    [anon_sym__Noreturn] = ACTIONS(3593),
    [anon_sym_noreturn] = ACTIONS(3593),
    [anon_sym__Nonnull] = ACTIONS(3593),
    [anon_sym_mutable] = ACTIONS(3593),
    [anon_sym_constinit] = ACTIONS(3593),
    [anon_sym_consteval] = ACTIONS(3593),
    [anon_sym_alignas] = ACTIONS(3593),
    [anon_sym__Alignas] = ACTIONS(3593),
    [sym_primitive_type] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_class] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_union] = ACTIONS(3593),
    [anon_sym_if] = ACTIONS(3593),
    [anon_sym_switch] = ACTIONS(3593),
    [anon_sym_case] = ACTIONS(3593),
    [anon_sym_default] = ACTIONS(3593),
    [anon_sym_while] = ACTIONS(3593),
    [anon_sym_do] = ACTIONS(3593),
    [anon_sym_for] = ACTIONS(3593),
    [anon_sym_return] = ACTIONS(3593),
    [anon_sym_break] = ACTIONS(3593),
    [anon_sym_continue] = ACTIONS(3593),
    [anon_sym_goto] = ACTIONS(3593),
    [anon_sym_not] = ACTIONS(3593),
    [anon_sym_compl] = ACTIONS(3593),
    [anon_sym_DASH_DASH] = ACTIONS(3591),
    [anon_sym_PLUS_PLUS] = ACTIONS(3591),
    [anon_sym_sizeof] = ACTIONS(3593),
    [anon_sym___alignof__] = ACTIONS(3593),
    [anon_sym___alignof] = ACTIONS(3593),
    [anon_sym__alignof] = ACTIONS(3593),
    [anon_sym_alignof] = ACTIONS(3593),
    [anon_sym__Alignof] = ACTIONS(3593),
    [anon_sym_offsetof] = ACTIONS(3593),
    [anon_sym__Generic] = ACTIONS(3593),
    [anon_sym_asm] = ACTIONS(3593),
    [anon_sym___asm__] = ACTIONS(3593),
    [anon_sym___asm] = ACTIONS(3593),
    [sym_number_literal] = ACTIONS(3591),
    [anon_sym_L_SQUOTE] = ACTIONS(3591),
    [anon_sym_u_SQUOTE] = ACTIONS(3591),
    [anon_sym_U_SQUOTE] = ACTIONS(3591),
    [anon_sym_u8_SQUOTE] = ACTIONS(3591),
    [anon_sym_SQUOTE] = ACTIONS(3591),
    [anon_sym_L_DQUOTE] = ACTIONS(3591),
    [anon_sym_u_DQUOTE] = ACTIONS(3591),
    [anon_sym_U_DQUOTE] = ACTIONS(3591),
    [anon_sym_u8_DQUOTE] = ACTIONS(3591),
    [anon_sym_DQUOTE] = ACTIONS(3591),
    [sym_true] = ACTIONS(3593),
    [sym_false] = ACTIONS(3593),
    [anon_sym_NULL] = ACTIONS(3593),
    [anon_sym_nullptr] = ACTIONS(3593),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3593),
    [anon_sym_decltype] = ACTIONS(3593),
    [anon_sym_explicit] = ACTIONS(3593),
    [anon_sym_typename] = ACTIONS(3593),
    [anon_sym_export] = ACTIONS(3593),
    [anon_sym_module] = ACTIONS(3593),
    [anon_sym_import] = ACTIONS(3593),
    [anon_sym_template] = ACTIONS(3593),
    [anon_sym_operator] = ACTIONS(3593),
    [anon_sym_try] = ACTIONS(3593),
    [anon_sym_delete] = ACTIONS(3593),
    [anon_sym_throw] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_static_assert] = ACTIONS(3593),
    [anon_sym_concept] = ACTIONS(3593),
    [anon_sym_co_return] = ACTIONS(3593),
    [anon_sym_co_yield] = ACTIONS(3593),
    [anon_sym_R_DQUOTE] = ACTIONS(3591),
    [anon_sym_LR_DQUOTE] = ACTIONS(3591),
    [anon_sym_uR_DQUOTE] = ACTIONS(3591),
    [anon_sym_UR_DQUOTE] = ACTIONS(3591),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3591),
    [anon_sym_co_await] = ACTIONS(3593),
    [anon_sym_new] = ACTIONS(3593),
    [anon_sym_requires] = ACTIONS(3593),
    [sym_this] = ACTIONS(3593),
  },
  [642] = {
    [ts_builtin_sym_end] = ACTIONS(3595),
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_include_token1] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3595),
    [anon_sym_BANG] = ACTIONS(3595),
    [anon_sym_TILDE] = ACTIONS(3595),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3595),
    [anon_sym_AMP_AMP] = ACTIONS(3595),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3595),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_virtual] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym___attribute] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3595),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym___cdecl] = ACTIONS(3597),
    [anon_sym___clrcall] = ACTIONS(3597),
    [anon_sym___stdcall] = ACTIONS(3597),
    [anon_sym___fastcall] = ACTIONS(3597),
    [anon_sym___thiscall] = ACTIONS(3597),
    [anon_sym___vectorcall] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3595),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym__Nonnull] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_case] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym_not] = ACTIONS(3597),
    [anon_sym_compl] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3595),
    [anon_sym_PLUS_PLUS] = ACTIONS(3595),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym___alignof__] = ACTIONS(3597),
    [anon_sym___alignof] = ACTIONS(3597),
    [anon_sym__alignof] = ACTIONS(3597),
    [anon_sym_alignof] = ACTIONS(3597),
    [anon_sym__Alignof] = ACTIONS(3597),
    [anon_sym_offsetof] = ACTIONS(3597),
    [anon_sym__Generic] = ACTIONS(3597),
    [anon_sym_asm] = ACTIONS(3597),
    [anon_sym___asm__] = ACTIONS(3597),
    [anon_sym___asm] = ACTIONS(3597),
    [sym_number_literal] = ACTIONS(3595),
    [anon_sym_L_SQUOTE] = ACTIONS(3595),
    [anon_sym_u_SQUOTE] = ACTIONS(3595),
    [anon_sym_U_SQUOTE] = ACTIONS(3595),
    [anon_sym_u8_SQUOTE] = ACTIONS(3595),
    [anon_sym_SQUOTE] = ACTIONS(3595),
    [anon_sym_L_DQUOTE] = ACTIONS(3595),
    [anon_sym_u_DQUOTE] = ACTIONS(3595),
    [anon_sym_U_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8_DQUOTE] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(3595),
    [sym_true] = ACTIONS(3597),
    [sym_false] = ACTIONS(3597),
    [anon_sym_NULL] = ACTIONS(3597),
    [anon_sym_nullptr] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_export] = ACTIONS(3597),
    [anon_sym_module] = ACTIONS(3597),
    [anon_sym_import] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_delete] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_concept] = ACTIONS(3597),
    [anon_sym_co_return] = ACTIONS(3597),
    [anon_sym_co_yield] = ACTIONS(3597),
    [anon_sym_R_DQUOTE] = ACTIONS(3595),
    [anon_sym_LR_DQUOTE] = ACTIONS(3595),
    [anon_sym_uR_DQUOTE] = ACTIONS(3595),
    [anon_sym_UR_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3595),
    [anon_sym_co_await] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_requires] = ACTIONS(3597),
    [sym_this] = ACTIONS(3597),
  },
  [643] = {
    [ts_builtin_sym_end] = ACTIONS(3599),
    [sym_identifier] = ACTIONS(3601),
    [aux_sym_preproc_include_token1] = ACTIONS(3601),
    [aux_sym_preproc_def_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3601),
    [sym_preproc_directive] = ACTIONS(3601),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3601),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym___extension__] = ACTIONS(3601),
    [anon_sym_typedef] = ACTIONS(3601),
    [anon_sym_virtual] = ACTIONS(3601),
    [anon_sym_extern] = ACTIONS(3601),
    [anon_sym___attribute__] = ACTIONS(3601),
    [anon_sym___attribute] = ACTIONS(3601),
    [anon_sym_using] = ACTIONS(3601),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3601),
    [anon_sym___based] = ACTIONS(3601),
    [anon_sym___cdecl] = ACTIONS(3601),
    [anon_sym___clrcall] = ACTIONS(3601),
    [anon_sym___stdcall] = ACTIONS(3601),
    [anon_sym___fastcall] = ACTIONS(3601),
    [anon_sym___thiscall] = ACTIONS(3601),
    [anon_sym___vectorcall] = ACTIONS(3601),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3601),
    [anon_sym_unsigned] = ACTIONS(3601),
    [anon_sym_long] = ACTIONS(3601),
    [anon_sym_short] = ACTIONS(3601),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3601),
    [anon_sym_register] = ACTIONS(3601),
    [anon_sym_inline] = ACTIONS(3601),
    [anon_sym___inline] = ACTIONS(3601),
    [anon_sym___inline__] = ACTIONS(3601),
    [anon_sym___forceinline] = ACTIONS(3601),
    [anon_sym_thread_local] = ACTIONS(3601),
    [anon_sym___thread] = ACTIONS(3601),
    [anon_sym_const] = ACTIONS(3601),
    [anon_sym_constexpr] = ACTIONS(3601),
    [anon_sym_volatile] = ACTIONS(3601),
    [anon_sym_restrict] = ACTIONS(3601),
    [anon_sym___restrict__] = ACTIONS(3601),
    [anon_sym__Atomic] = ACTIONS(3601),
    [anon_sym__Noreturn] = ACTIONS(3601),
    [anon_sym_noreturn] = ACTIONS(3601),
    [anon_sym__Nonnull] = ACTIONS(3601),
    [anon_sym_mutable] = ACTIONS(3601),
    [anon_sym_constinit] = ACTIONS(3601),
    [anon_sym_consteval] = ACTIONS(3601),
    [anon_sym_alignas] = ACTIONS(3601),
    [anon_sym__Alignas] = ACTIONS(3601),
    [sym_primitive_type] = ACTIONS(3601),
    [anon_sym_enum] = ACTIONS(3601),
    [anon_sym_class] = ACTIONS(3601),
    [anon_sym_struct] = ACTIONS(3601),
    [anon_sym_union] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3601),
    [anon_sym_switch] = ACTIONS(3601),
    [anon_sym_case] = ACTIONS(3601),
    [anon_sym_default] = ACTIONS(3601),
    [anon_sym_while] = ACTIONS(3601),
    [anon_sym_do] = ACTIONS(3601),
    [anon_sym_for] = ACTIONS(3601),
    [anon_sym_return] = ACTIONS(3601),
    [anon_sym_break] = ACTIONS(3601),
    [anon_sym_continue] = ACTIONS(3601),
    [anon_sym_goto] = ACTIONS(3601),
    [anon_sym_not] = ACTIONS(3601),
    [anon_sym_compl] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3601),
    [anon_sym___alignof__] = ACTIONS(3601),
    [anon_sym___alignof] = ACTIONS(3601),
    [anon_sym__alignof] = ACTIONS(3601),
    [anon_sym_alignof] = ACTIONS(3601),
    [anon_sym__Alignof] = ACTIONS(3601),
    [anon_sym_offsetof] = ACTIONS(3601),
    [anon_sym__Generic] = ACTIONS(3601),
    [anon_sym_asm] = ACTIONS(3601),
    [anon_sym___asm__] = ACTIONS(3601),
    [anon_sym___asm] = ACTIONS(3601),
    [sym_number_literal] = ACTIONS(3599),
    [anon_sym_L_SQUOTE] = ACTIONS(3599),
    [anon_sym_u_SQUOTE] = ACTIONS(3599),
    [anon_sym_U_SQUOTE] = ACTIONS(3599),
    [anon_sym_u8_SQUOTE] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [anon_sym_L_DQUOTE] = ACTIONS(3599),
    [anon_sym_u_DQUOTE] = ACTIONS(3599),
    [anon_sym_U_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8_DQUOTE] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3599),
    [sym_true] = ACTIONS(3601),
    [sym_false] = ACTIONS(3601),
    [anon_sym_NULL] = ACTIONS(3601),
    [anon_sym_nullptr] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3601),
    [anon_sym_decltype] = ACTIONS(3601),
    [anon_sym_explicit] = ACTIONS(3601),
    [anon_sym_typename] = ACTIONS(3601),
    [anon_sym_export] = ACTIONS(3601),
    [anon_sym_module] = ACTIONS(3601),
    [anon_sym_import] = ACTIONS(3601),
    [anon_sym_template] = ACTIONS(3601),
    [anon_sym_operator] = ACTIONS(3601),
    [anon_sym_try] = ACTIONS(3601),
    [anon_sym_delete] = ACTIONS(3601),
    [anon_sym_throw] = ACTIONS(3601),
    [anon_sym_namespace] = ACTIONS(3601),
    [anon_sym_static_assert] = ACTIONS(3601),
    [anon_sym_concept] = ACTIONS(3601),
    [anon_sym_co_return] = ACTIONS(3601),
    [anon_sym_co_yield] = ACTIONS(3601),
    [anon_sym_R_DQUOTE] = ACTIONS(3599),
    [anon_sym_LR_DQUOTE] = ACTIONS(3599),
    [anon_sym_uR_DQUOTE] = ACTIONS(3599),
    [anon_sym_UR_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3599),
    [anon_sym_co_await] = ACTIONS(3601),
    [anon_sym_new] = ACTIONS(3601),
    [anon_sym_requires] = ACTIONS(3601),
    [sym_this] = ACTIONS(3601),
  },
  [644] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [645] = {
    [ts_builtin_sym_end] = ACTIONS(3603),
    [sym_identifier] = ACTIONS(3605),
    [aux_sym_preproc_include_token1] = ACTIONS(3605),
    [aux_sym_preproc_def_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_LPAREN2] = ACTIONS(3603),
    [anon_sym_BANG] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3603),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_STAR] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym___extension__] = ACTIONS(3605),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_virtual] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym___attribute__] = ACTIONS(3605),
    [anon_sym___attribute] = ACTIONS(3605),
    [anon_sym_using] = ACTIONS(3605),
    [anon_sym_COLON_COLON] = ACTIONS(3603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3603),
    [anon_sym___declspec] = ACTIONS(3605),
    [anon_sym___based] = ACTIONS(3605),
    [anon_sym___cdecl] = ACTIONS(3605),
    [anon_sym___clrcall] = ACTIONS(3605),
    [anon_sym___stdcall] = ACTIONS(3605),
    [anon_sym___fastcall] = ACTIONS(3605),
    [anon_sym___thiscall] = ACTIONS(3605),
    [anon_sym___vectorcall] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3603),
    [anon_sym_signed] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym___inline] = ACTIONS(3605),
    [anon_sym___inline__] = ACTIONS(3605),
    [anon_sym___forceinline] = ACTIONS(3605),
    [anon_sym_thread_local] = ACTIONS(3605),
    [anon_sym___thread] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_constexpr] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym___restrict__] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym__Noreturn] = ACTIONS(3605),
    [anon_sym_noreturn] = ACTIONS(3605),
    [anon_sym__Nonnull] = ACTIONS(3605),
    [anon_sym_mutable] = ACTIONS(3605),
    [anon_sym_constinit] = ACTIONS(3605),
    [anon_sym_consteval] = ACTIONS(3605),
    [anon_sym_alignas] = ACTIONS(3605),
    [anon_sym__Alignas] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_class] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym_not] = ACTIONS(3605),
    [anon_sym_compl] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3603),
    [anon_sym_PLUS_PLUS] = ACTIONS(3603),
    [anon_sym_sizeof] = ACTIONS(3605),
    [anon_sym___alignof__] = ACTIONS(3605),
    [anon_sym___alignof] = ACTIONS(3605),
    [anon_sym__alignof] = ACTIONS(3605),
    [anon_sym_alignof] = ACTIONS(3605),
    [anon_sym__Alignof] = ACTIONS(3605),
    [anon_sym_offsetof] = ACTIONS(3605),
    [anon_sym__Generic] = ACTIONS(3605),
    [anon_sym_asm] = ACTIONS(3605),
    [anon_sym___asm__] = ACTIONS(3605),
    [anon_sym___asm] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3603),
    [anon_sym_L_SQUOTE] = ACTIONS(3603),
    [anon_sym_u_SQUOTE] = ACTIONS(3603),
    [anon_sym_U_SQUOTE] = ACTIONS(3603),
    [anon_sym_u8_SQUOTE] = ACTIONS(3603),
    [anon_sym_SQUOTE] = ACTIONS(3603),
    [anon_sym_L_DQUOTE] = ACTIONS(3603),
    [anon_sym_u_DQUOTE] = ACTIONS(3603),
    [anon_sym_U_DQUOTE] = ACTIONS(3603),
    [anon_sym_u8_DQUOTE] = ACTIONS(3603),
    [anon_sym_DQUOTE] = ACTIONS(3603),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [anon_sym_NULL] = ACTIONS(3605),
    [anon_sym_nullptr] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3605),
    [anon_sym_decltype] = ACTIONS(3605),
    [anon_sym_explicit] = ACTIONS(3605),
    [anon_sym_typename] = ACTIONS(3605),
    [anon_sym_export] = ACTIONS(3605),
    [anon_sym_module] = ACTIONS(3605),
    [anon_sym_import] = ACTIONS(3605),
    [anon_sym_template] = ACTIONS(3605),
    [anon_sym_operator] = ACTIONS(3605),
    [anon_sym_try] = ACTIONS(3605),
    [anon_sym_delete] = ACTIONS(3605),
    [anon_sym_throw] = ACTIONS(3605),
    [anon_sym_namespace] = ACTIONS(3605),
    [anon_sym_static_assert] = ACTIONS(3605),
    [anon_sym_concept] = ACTIONS(3605),
    [anon_sym_co_return] = ACTIONS(3605),
    [anon_sym_co_yield] = ACTIONS(3605),
    [anon_sym_R_DQUOTE] = ACTIONS(3603),
    [anon_sym_LR_DQUOTE] = ACTIONS(3603),
    [anon_sym_uR_DQUOTE] = ACTIONS(3603),
    [anon_sym_UR_DQUOTE] = ACTIONS(3603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3603),
    [anon_sym_co_await] = ACTIONS(3605),
    [anon_sym_new] = ACTIONS(3605),
    [anon_sym_requires] = ACTIONS(3605),
    [sym_this] = ACTIONS(3605),
  },
  [646] = {
    [ts_builtin_sym_end] = ACTIONS(2825),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_include_token1] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2823),
    [aux_sym_preproc_if_token1] = ACTIONS(2823),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2823),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2823),
    [sym_preproc_directive] = ACTIONS(2823),
    [anon_sym_LPAREN2] = ACTIONS(2825),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_TILDE] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_SEMI] = ACTIONS(2825),
    [anon_sym___extension__] = ACTIONS(2823),
    [anon_sym_typedef] = ACTIONS(2823),
    [anon_sym_virtual] = ACTIONS(2823),
    [anon_sym_extern] = ACTIONS(2823),
    [anon_sym___attribute__] = ACTIONS(2823),
    [anon_sym___attribute] = ACTIONS(2823),
    [anon_sym_using] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2825),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2825),
    [anon_sym___declspec] = ACTIONS(2823),
    [anon_sym___based] = ACTIONS(2823),
    [anon_sym___cdecl] = ACTIONS(2823),
    [anon_sym___clrcall] = ACTIONS(2823),
    [anon_sym___stdcall] = ACTIONS(2823),
    [anon_sym___fastcall] = ACTIONS(2823),
    [anon_sym___thiscall] = ACTIONS(2823),
    [anon_sym___vectorcall] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_signed] = ACTIONS(2823),
    [anon_sym_unsigned] = ACTIONS(2823),
    [anon_sym_long] = ACTIONS(2823),
    [anon_sym_short] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2823),
    [anon_sym_register] = ACTIONS(2823),
    [anon_sym_inline] = ACTIONS(2823),
    [anon_sym___inline] = ACTIONS(2823),
    [anon_sym___inline__] = ACTIONS(2823),
    [anon_sym___forceinline] = ACTIONS(2823),
    [anon_sym_thread_local] = ACTIONS(2823),
    [anon_sym___thread] = ACTIONS(2823),
    [anon_sym_const] = ACTIONS(2823),
    [anon_sym_constexpr] = ACTIONS(2823),
    [anon_sym_volatile] = ACTIONS(2823),
    [anon_sym_restrict] = ACTIONS(2823),
    [anon_sym___restrict__] = ACTIONS(2823),
    [anon_sym__Atomic] = ACTIONS(2823),
    [anon_sym__Noreturn] = ACTIONS(2823),
    [anon_sym_noreturn] = ACTIONS(2823),
    [anon_sym__Nonnull] = ACTIONS(2823),
    [anon_sym_mutable] = ACTIONS(2823),
    [anon_sym_constinit] = ACTIONS(2823),
    [anon_sym_consteval] = ACTIONS(2823),
    [anon_sym_alignas] = ACTIONS(2823),
    [anon_sym__Alignas] = ACTIONS(2823),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2823),
    [anon_sym_class] = ACTIONS(2823),
    [anon_sym_struct] = ACTIONS(2823),
    [anon_sym_union] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_switch] = ACTIONS(2823),
    [anon_sym_case] = ACTIONS(2823),
    [anon_sym_default] = ACTIONS(2823),
    [anon_sym_while] = ACTIONS(2823),
    [anon_sym_do] = ACTIONS(2823),
    [anon_sym_for] = ACTIONS(2823),
    [anon_sym_return] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2823),
    [anon_sym_continue] = ACTIONS(2823),
    [anon_sym_goto] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2823),
    [anon_sym_compl] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2825),
    [anon_sym_sizeof] = ACTIONS(2823),
    [anon_sym___alignof__] = ACTIONS(2823),
    [anon_sym___alignof] = ACTIONS(2823),
    [anon_sym__alignof] = ACTIONS(2823),
    [anon_sym_alignof] = ACTIONS(2823),
    [anon_sym__Alignof] = ACTIONS(2823),
    [anon_sym_offsetof] = ACTIONS(2823),
    [anon_sym__Generic] = ACTIONS(2823),
    [anon_sym_asm] = ACTIONS(2823),
    [anon_sym___asm__] = ACTIONS(2823),
    [anon_sym___asm] = ACTIONS(2823),
    [sym_number_literal] = ACTIONS(2825),
    [anon_sym_L_SQUOTE] = ACTIONS(2825),
    [anon_sym_u_SQUOTE] = ACTIONS(2825),
    [anon_sym_U_SQUOTE] = ACTIONS(2825),
    [anon_sym_u8_SQUOTE] = ACTIONS(2825),
    [anon_sym_SQUOTE] = ACTIONS(2825),
    [anon_sym_L_DQUOTE] = ACTIONS(2825),
    [anon_sym_u_DQUOTE] = ACTIONS(2825),
    [anon_sym_U_DQUOTE] = ACTIONS(2825),
    [anon_sym_u8_DQUOTE] = ACTIONS(2825),
    [anon_sym_DQUOTE] = ACTIONS(2825),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [anon_sym_NULL] = ACTIONS(2823),
    [anon_sym_nullptr] = ACTIONS(2823),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2823),
    [anon_sym_decltype] = ACTIONS(2823),
    [anon_sym_explicit] = ACTIONS(2823),
    [anon_sym_typename] = ACTIONS(2823),
    [anon_sym_export] = ACTIONS(2823),
    [anon_sym_module] = ACTIONS(2823),
    [anon_sym_import] = ACTIONS(2823),
    [anon_sym_template] = ACTIONS(2823),
    [anon_sym_operator] = ACTIONS(2823),
    [anon_sym_try] = ACTIONS(2823),
    [anon_sym_delete] = ACTIONS(2823),
    [anon_sym_throw] = ACTIONS(2823),
    [anon_sym_namespace] = ACTIONS(2823),
    [anon_sym_static_assert] = ACTIONS(2823),
    [anon_sym_concept] = ACTIONS(2823),
    [anon_sym_co_return] = ACTIONS(2823),
    [anon_sym_co_yield] = ACTIONS(2823),
    [anon_sym_R_DQUOTE] = ACTIONS(2825),
    [anon_sym_LR_DQUOTE] = ACTIONS(2825),
    [anon_sym_uR_DQUOTE] = ACTIONS(2825),
    [anon_sym_UR_DQUOTE] = ACTIONS(2825),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2825),
    [anon_sym_co_await] = ACTIONS(2823),
    [anon_sym_new] = ACTIONS(2823),
    [anon_sym_requires] = ACTIONS(2823),
    [sym_this] = ACTIONS(2823),
  },
  [647] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [648] = {
    [ts_builtin_sym_end] = ACTIONS(2829),
    [sym_identifier] = ACTIONS(2827),
    [aux_sym_preproc_include_token1] = ACTIONS(2827),
    [aux_sym_preproc_def_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2827),
    [sym_preproc_directive] = ACTIONS(2827),
    [anon_sym_LPAREN2] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym___extension__] = ACTIONS(2827),
    [anon_sym_typedef] = ACTIONS(2827),
    [anon_sym_virtual] = ACTIONS(2827),
    [anon_sym_extern] = ACTIONS(2827),
    [anon_sym___attribute__] = ACTIONS(2827),
    [anon_sym___attribute] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2829),
    [anon_sym___declspec] = ACTIONS(2827),
    [anon_sym___based] = ACTIONS(2827),
    [anon_sym___cdecl] = ACTIONS(2827),
    [anon_sym___clrcall] = ACTIONS(2827),
    [anon_sym___stdcall] = ACTIONS(2827),
    [anon_sym___fastcall] = ACTIONS(2827),
    [anon_sym___thiscall] = ACTIONS(2827),
    [anon_sym___vectorcall] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_signed] = ACTIONS(2827),
    [anon_sym_unsigned] = ACTIONS(2827),
    [anon_sym_long] = ACTIONS(2827),
    [anon_sym_short] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_static] = ACTIONS(2827),
    [anon_sym_register] = ACTIONS(2827),
    [anon_sym_inline] = ACTIONS(2827),
    [anon_sym___inline] = ACTIONS(2827),
    [anon_sym___inline__] = ACTIONS(2827),
    [anon_sym___forceinline] = ACTIONS(2827),
    [anon_sym_thread_local] = ACTIONS(2827),
    [anon_sym___thread] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_constexpr] = ACTIONS(2827),
    [anon_sym_volatile] = ACTIONS(2827),
    [anon_sym_restrict] = ACTIONS(2827),
    [anon_sym___restrict__] = ACTIONS(2827),
    [anon_sym__Atomic] = ACTIONS(2827),
    [anon_sym__Noreturn] = ACTIONS(2827),
    [anon_sym_noreturn] = ACTIONS(2827),
    [anon_sym__Nonnull] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_constinit] = ACTIONS(2827),
    [anon_sym_consteval] = ACTIONS(2827),
    [anon_sym_alignas] = ACTIONS(2827),
    [anon_sym__Alignas] = ACTIONS(2827),
    [sym_primitive_type] = ACTIONS(2827),
    [anon_sym_enum] = ACTIONS(2827),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_union] = ACTIONS(2827),
    [anon_sym_if] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_default] = ACTIONS(2827),
    [anon_sym_while] = ACTIONS(2827),
    [anon_sym_do] = ACTIONS(2827),
    [anon_sym_for] = ACTIONS(2827),
    [anon_sym_return] = ACTIONS(2827),
    [anon_sym_break] = ACTIONS(2827),
    [anon_sym_continue] = ACTIONS(2827),
    [anon_sym_goto] = ACTIONS(2827),
    [anon_sym_not] = ACTIONS(2827),
    [anon_sym_compl] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_sizeof] = ACTIONS(2827),
    [anon_sym___alignof__] = ACTIONS(2827),
    [anon_sym___alignof] = ACTIONS(2827),
    [anon_sym__alignof] = ACTIONS(2827),
    [anon_sym_alignof] = ACTIONS(2827),
    [anon_sym__Alignof] = ACTIONS(2827),
    [anon_sym_offsetof] = ACTIONS(2827),
    [anon_sym__Generic] = ACTIONS(2827),
    [anon_sym_asm] = ACTIONS(2827),
    [anon_sym___asm__] = ACTIONS(2827),
    [anon_sym___asm] = ACTIONS(2827),
    [sym_number_literal] = ACTIONS(2829),
    [anon_sym_L_SQUOTE] = ACTIONS(2829),
    [anon_sym_u_SQUOTE] = ACTIONS(2829),
    [anon_sym_U_SQUOTE] = ACTIONS(2829),
    [anon_sym_u8_SQUOTE] = ACTIONS(2829),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_L_DQUOTE] = ACTIONS(2829),
    [anon_sym_u_DQUOTE] = ACTIONS(2829),
    [anon_sym_U_DQUOTE] = ACTIONS(2829),
    [anon_sym_u8_DQUOTE] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(2829),
    [sym_true] = ACTIONS(2827),
    [sym_false] = ACTIONS(2827),
    [anon_sym_NULL] = ACTIONS(2827),
    [anon_sym_nullptr] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2827),
    [anon_sym_decltype] = ACTIONS(2827),
    [anon_sym_explicit] = ACTIONS(2827),
    [anon_sym_typename] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2827),
    [anon_sym_module] = ACTIONS(2827),
    [anon_sym_import] = ACTIONS(2827),
    [anon_sym_template] = ACTIONS(2827),
    [anon_sym_operator] = ACTIONS(2827),
    [anon_sym_try] = ACTIONS(2827),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_throw] = ACTIONS(2827),
    [anon_sym_namespace] = ACTIONS(2827),
    [anon_sym_static_assert] = ACTIONS(2827),
    [anon_sym_concept] = ACTIONS(2827),
    [anon_sym_co_return] = ACTIONS(2827),
    [anon_sym_co_yield] = ACTIONS(2827),
    [anon_sym_R_DQUOTE] = ACTIONS(2829),
    [anon_sym_LR_DQUOTE] = ACTIONS(2829),
    [anon_sym_uR_DQUOTE] = ACTIONS(2829),
    [anon_sym_UR_DQUOTE] = ACTIONS(2829),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2829),
    [anon_sym_co_await] = ACTIONS(2827),
    [anon_sym_new] = ACTIONS(2827),
    [anon_sym_requires] = ACTIONS(2827),
    [sym_this] = ACTIONS(2827),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(3102),
    [sym_identifier] = ACTIONS(3100),
    [aux_sym_preproc_include_token1] = ACTIONS(3100),
    [aux_sym_preproc_def_token1] = ACTIONS(3100),
    [aux_sym_preproc_if_token1] = ACTIONS(3100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3100),
    [sym_preproc_directive] = ACTIONS(3100),
    [anon_sym_LPAREN2] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_AMP_AMP] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym___extension__] = ACTIONS(3100),
    [anon_sym_typedef] = ACTIONS(3100),
    [anon_sym_virtual] = ACTIONS(3100),
    [anon_sym_extern] = ACTIONS(3100),
    [anon_sym___attribute__] = ACTIONS(3100),
    [anon_sym___attribute] = ACTIONS(3100),
    [anon_sym_using] = ACTIONS(3100),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3102),
    [anon_sym___declspec] = ACTIONS(3100),
    [anon_sym___based] = ACTIONS(3100),
    [anon_sym___cdecl] = ACTIONS(3100),
    [anon_sym___clrcall] = ACTIONS(3100),
    [anon_sym___stdcall] = ACTIONS(3100),
    [anon_sym___fastcall] = ACTIONS(3100),
    [anon_sym___thiscall] = ACTIONS(3100),
    [anon_sym___vectorcall] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_signed] = ACTIONS(3100),
    [anon_sym_unsigned] = ACTIONS(3100),
    [anon_sym_long] = ACTIONS(3100),
    [anon_sym_short] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3100),
    [anon_sym_inline] = ACTIONS(3100),
    [anon_sym___inline] = ACTIONS(3100),
    [anon_sym___inline__] = ACTIONS(3100),
    [anon_sym___forceinline] = ACTIONS(3100),
    [anon_sym_thread_local] = ACTIONS(3100),
    [anon_sym___thread] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_constexpr] = ACTIONS(3100),
    [anon_sym_volatile] = ACTIONS(3100),
    [anon_sym_restrict] = ACTIONS(3100),
    [anon_sym___restrict__] = ACTIONS(3100),
    [anon_sym__Atomic] = ACTIONS(3100),
    [anon_sym__Noreturn] = ACTIONS(3100),
    [anon_sym_noreturn] = ACTIONS(3100),
    [anon_sym__Nonnull] = ACTIONS(3100),
    [anon_sym_mutable] = ACTIONS(3100),
    [anon_sym_constinit] = ACTIONS(3100),
    [anon_sym_consteval] = ACTIONS(3100),
    [anon_sym_alignas] = ACTIONS(3100),
    [anon_sym__Alignas] = ACTIONS(3100),
    [sym_primitive_type] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_struct] = ACTIONS(3100),
    [anon_sym_union] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_goto] = ACTIONS(3100),
    [anon_sym_not] = ACTIONS(3100),
    [anon_sym_compl] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_sizeof] = ACTIONS(3100),
    [anon_sym___alignof__] = ACTIONS(3100),
    [anon_sym___alignof] = ACTIONS(3100),
    [anon_sym__alignof] = ACTIONS(3100),
    [anon_sym_alignof] = ACTIONS(3100),
    [anon_sym__Alignof] = ACTIONS(3100),
    [anon_sym_offsetof] = ACTIONS(3100),
    [anon_sym__Generic] = ACTIONS(3100),
    [anon_sym_asm] = ACTIONS(3100),
    [anon_sym___asm__] = ACTIONS(3100),
    [anon_sym___asm] = ACTIONS(3100),
    [sym_number_literal] = ACTIONS(3102),
    [anon_sym_L_SQUOTE] = ACTIONS(3102),
    [anon_sym_u_SQUOTE] = ACTIONS(3102),
    [anon_sym_U_SQUOTE] = ACTIONS(3102),
    [anon_sym_u8_SQUOTE] = ACTIONS(3102),
    [anon_sym_SQUOTE] = ACTIONS(3102),
    [anon_sym_L_DQUOTE] = ACTIONS(3102),
    [anon_sym_u_DQUOTE] = ACTIONS(3102),
    [anon_sym_U_DQUOTE] = ACTIONS(3102),
    [anon_sym_u8_DQUOTE] = ACTIONS(3102),
    [anon_sym_DQUOTE] = ACTIONS(3102),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [anon_sym_NULL] = ACTIONS(3100),
    [anon_sym_nullptr] = ACTIONS(3100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3100),
    [anon_sym_decltype] = ACTIONS(3100),
    [anon_sym_explicit] = ACTIONS(3100),
    [anon_sym_typename] = ACTIONS(3100),
    [anon_sym_export] = ACTIONS(3100),
    [anon_sym_module] = ACTIONS(3100),
    [anon_sym_import] = ACTIONS(3100),
    [anon_sym_template] = ACTIONS(3100),
    [anon_sym_operator] = ACTIONS(3100),
    [anon_sym_try] = ACTIONS(3100),
    [anon_sym_delete] = ACTIONS(3100),
    [anon_sym_throw] = ACTIONS(3100),
    [anon_sym_namespace] = ACTIONS(3100),
    [anon_sym_static_assert] = ACTIONS(3100),
    [anon_sym_concept] = ACTIONS(3100),
    [anon_sym_co_return] = ACTIONS(3100),
    [anon_sym_co_yield] = ACTIONS(3100),
    [anon_sym_R_DQUOTE] = ACTIONS(3102),
    [anon_sym_LR_DQUOTE] = ACTIONS(3102),
    [anon_sym_uR_DQUOTE] = ACTIONS(3102),
    [anon_sym_UR_DQUOTE] = ACTIONS(3102),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3102),
    [anon_sym_co_await] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_requires] = ACTIONS(3100),
    [sym_this] = ACTIONS(3100),
  },
  [650] = {
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_include_token1] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token2] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym___attribute] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym___cdecl] = ACTIONS(2779),
    [anon_sym___clrcall] = ACTIONS(2779),
    [anon_sym___stdcall] = ACTIONS(2779),
    [anon_sym___fastcall] = ACTIONS(2779),
    [anon_sym___thiscall] = ACTIONS(2779),
    [anon_sym___vectorcall] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym__Nonnull] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym__Alignas] = ACTIONS(2779),
    [sym_primitive_type] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_switch] = ACTIONS(2779),
    [anon_sym_case] = ACTIONS(2779),
    [anon_sym_default] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [anon_sym_do] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2779),
    [anon_sym_continue] = ACTIONS(2779),
    [anon_sym_goto] = ACTIONS(2779),
    [anon_sym___try] = ACTIONS(2779),
    [anon_sym___leave] = ACTIONS(2779),
    [anon_sym_not] = ACTIONS(2779),
    [anon_sym_compl] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2781),
    [anon_sym_sizeof] = ACTIONS(2779),
    [anon_sym___alignof__] = ACTIONS(2779),
    [anon_sym___alignof] = ACTIONS(2779),
    [anon_sym__alignof] = ACTIONS(2779),
    [anon_sym_alignof] = ACTIONS(2779),
    [anon_sym__Alignof] = ACTIONS(2779),
    [anon_sym_offsetof] = ACTIONS(2779),
    [anon_sym__Generic] = ACTIONS(2779),
    [anon_sym_asm] = ACTIONS(2779),
    [anon_sym___asm__] = ACTIONS(2779),
    [anon_sym___asm] = ACTIONS(2779),
    [sym_number_literal] = ACTIONS(2781),
    [anon_sym_L_SQUOTE] = ACTIONS(2781),
    [anon_sym_u_SQUOTE] = ACTIONS(2781),
    [anon_sym_U_SQUOTE] = ACTIONS(2781),
    [anon_sym_u8_SQUOTE] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_L_DQUOTE] = ACTIONS(2781),
    [anon_sym_u_DQUOTE] = ACTIONS(2781),
    [anon_sym_U_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8_DQUOTE] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2781),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [anon_sym_NULL] = ACTIONS(2779),
    [anon_sym_nullptr] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_delete] = ACTIONS(2779),
    [anon_sym_throw] = ACTIONS(2779),
    [anon_sym_namespace] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
    [anon_sym_concept] = ACTIONS(2779),
    [anon_sym_co_return] = ACTIONS(2779),
    [anon_sym_co_yield] = ACTIONS(2779),
    [anon_sym_R_DQUOTE] = ACTIONS(2781),
    [anon_sym_LR_DQUOTE] = ACTIONS(2781),
    [anon_sym_uR_DQUOTE] = ACTIONS(2781),
    [anon_sym_UR_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2781),
    [anon_sym_co_await] = ACTIONS(2779),
    [anon_sym_new] = ACTIONS(2779),
    [anon_sym_requires] = ACTIONS(2779),
    [sym_this] = ACTIONS(2779),
  },
  [651] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [652] = {
    [sym_identifier] = ACTIONS(2847),
    [aux_sym_preproc_include_token1] = ACTIONS(2847),
    [aux_sym_preproc_def_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token1] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2847),
    [sym_preproc_directive] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym___extension__] = ACTIONS(2847),
    [anon_sym_typedef] = ACTIONS(2847),
    [anon_sym_virtual] = ACTIONS(2847),
    [anon_sym_extern] = ACTIONS(2847),
    [anon_sym___attribute__] = ACTIONS(2847),
    [anon_sym___attribute] = ACTIONS(2847),
    [anon_sym_using] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2849),
    [anon_sym___declspec] = ACTIONS(2847),
    [anon_sym___based] = ACTIONS(2847),
    [anon_sym___cdecl] = ACTIONS(2847),
    [anon_sym___clrcall] = ACTIONS(2847),
    [anon_sym___stdcall] = ACTIONS(2847),
    [anon_sym___fastcall] = ACTIONS(2847),
    [anon_sym___thiscall] = ACTIONS(2847),
    [anon_sym___vectorcall] = ACTIONS(2847),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_RBRACE] = ACTIONS(2849),
    [anon_sym_signed] = ACTIONS(2847),
    [anon_sym_unsigned] = ACTIONS(2847),
    [anon_sym_long] = ACTIONS(2847),
    [anon_sym_short] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2847),
    [anon_sym_register] = ACTIONS(2847),
    [anon_sym_inline] = ACTIONS(2847),
    [anon_sym___inline] = ACTIONS(2847),
    [anon_sym___inline__] = ACTIONS(2847),
    [anon_sym___forceinline] = ACTIONS(2847),
    [anon_sym_thread_local] = ACTIONS(2847),
    [anon_sym___thread] = ACTIONS(2847),
    [anon_sym_const] = ACTIONS(2847),
    [anon_sym_constexpr] = ACTIONS(2847),
    [anon_sym_volatile] = ACTIONS(2847),
    [anon_sym_restrict] = ACTIONS(2847),
    [anon_sym___restrict__] = ACTIONS(2847),
    [anon_sym__Atomic] = ACTIONS(2847),
    [anon_sym__Noreturn] = ACTIONS(2847),
    [anon_sym_noreturn] = ACTIONS(2847),
    [anon_sym__Nonnull] = ACTIONS(2847),
    [anon_sym_mutable] = ACTIONS(2847),
    [anon_sym_constinit] = ACTIONS(2847),
    [anon_sym_consteval] = ACTIONS(2847),
    [anon_sym_alignas] = ACTIONS(2847),
    [anon_sym__Alignas] = ACTIONS(2847),
    [sym_primitive_type] = ACTIONS(2847),
    [anon_sym_enum] = ACTIONS(2847),
    [anon_sym_class] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2847),
    [anon_sym_union] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_switch] = ACTIONS(2847),
    [anon_sym_case] = ACTIONS(2847),
    [anon_sym_default] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_break] = ACTIONS(2847),
    [anon_sym_continue] = ACTIONS(2847),
    [anon_sym_goto] = ACTIONS(2847),
    [anon_sym___try] = ACTIONS(2847),
    [anon_sym___leave] = ACTIONS(2847),
    [anon_sym_not] = ACTIONS(2847),
    [anon_sym_compl] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2849),
    [anon_sym_sizeof] = ACTIONS(2847),
    [anon_sym___alignof__] = ACTIONS(2847),
    [anon_sym___alignof] = ACTIONS(2847),
    [anon_sym__alignof] = ACTIONS(2847),
    [anon_sym_alignof] = ACTIONS(2847),
    [anon_sym__Alignof] = ACTIONS(2847),
    [anon_sym_offsetof] = ACTIONS(2847),
    [anon_sym__Generic] = ACTIONS(2847),
    [anon_sym_asm] = ACTIONS(2847),
    [anon_sym___asm__] = ACTIONS(2847),
    [anon_sym___asm] = ACTIONS(2847),
    [sym_number_literal] = ACTIONS(2849),
    [anon_sym_L_SQUOTE] = ACTIONS(2849),
    [anon_sym_u_SQUOTE] = ACTIONS(2849),
    [anon_sym_U_SQUOTE] = ACTIONS(2849),
    [anon_sym_u8_SQUOTE] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [anon_sym_NULL] = ACTIONS(2847),
    [anon_sym_nullptr] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2847),
    [anon_sym_decltype] = ACTIONS(2847),
    [anon_sym_explicit] = ACTIONS(2847),
    [anon_sym_typename] = ACTIONS(2847),
    [anon_sym_template] = ACTIONS(2847),
    [anon_sym_operator] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_delete] = ACTIONS(2847),
    [anon_sym_throw] = ACTIONS(2847),
    [anon_sym_namespace] = ACTIONS(2847),
    [anon_sym_static_assert] = ACTIONS(2847),
    [anon_sym_concept] = ACTIONS(2847),
    [anon_sym_co_return] = ACTIONS(2847),
    [anon_sym_co_yield] = ACTIONS(2847),
    [anon_sym_R_DQUOTE] = ACTIONS(2849),
    [anon_sym_LR_DQUOTE] = ACTIONS(2849),
    [anon_sym_uR_DQUOTE] = ACTIONS(2849),
    [anon_sym_UR_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2849),
    [anon_sym_co_await] = ACTIONS(2847),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_requires] = ACTIONS(2847),
    [sym_this] = ACTIONS(2847),
  },
  [653] = {
    [sym_identifier] = ACTIONS(2851),
    [aux_sym_preproc_include_token1] = ACTIONS(2851),
    [aux_sym_preproc_def_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token1] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2851),
    [sym_preproc_directive] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2853),
    [anon_sym_BANG] = ACTIONS(2853),
    [anon_sym_TILDE] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_STAR] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym___extension__] = ACTIONS(2851),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_virtual] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(2851),
    [anon_sym___attribute__] = ACTIONS(2851),
    [anon_sym___attribute] = ACTIONS(2851),
    [anon_sym_using] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2853),
    [anon_sym___declspec] = ACTIONS(2851),
    [anon_sym___based] = ACTIONS(2851),
    [anon_sym___cdecl] = ACTIONS(2851),
    [anon_sym___clrcall] = ACTIONS(2851),
    [anon_sym___stdcall] = ACTIONS(2851),
    [anon_sym___fastcall] = ACTIONS(2851),
    [anon_sym___thiscall] = ACTIONS(2851),
    [anon_sym___vectorcall] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_signed] = ACTIONS(2851),
    [anon_sym_unsigned] = ACTIONS(2851),
    [anon_sym_long] = ACTIONS(2851),
    [anon_sym_short] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_static] = ACTIONS(2851),
    [anon_sym_register] = ACTIONS(2851),
    [anon_sym_inline] = ACTIONS(2851),
    [anon_sym___inline] = ACTIONS(2851),
    [anon_sym___inline__] = ACTIONS(2851),
    [anon_sym___forceinline] = ACTIONS(2851),
    [anon_sym_thread_local] = ACTIONS(2851),
    [anon_sym___thread] = ACTIONS(2851),
    [anon_sym_const] = ACTIONS(2851),
    [anon_sym_constexpr] = ACTIONS(2851),
    [anon_sym_volatile] = ACTIONS(2851),
    [anon_sym_restrict] = ACTIONS(2851),
    [anon_sym___restrict__] = ACTIONS(2851),
    [anon_sym__Atomic] = ACTIONS(2851),
    [anon_sym__Noreturn] = ACTIONS(2851),
    [anon_sym_noreturn] = ACTIONS(2851),
    [anon_sym__Nonnull] = ACTIONS(2851),
    [anon_sym_mutable] = ACTIONS(2851),
    [anon_sym_constinit] = ACTIONS(2851),
    [anon_sym_consteval] = ACTIONS(2851),
    [anon_sym_alignas] = ACTIONS(2851),
    [anon_sym__Alignas] = ACTIONS(2851),
    [sym_primitive_type] = ACTIONS(2851),
    [anon_sym_enum] = ACTIONS(2851),
    [anon_sym_class] = ACTIONS(2851),
    [anon_sym_struct] = ACTIONS(2851),
    [anon_sym_union] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_switch] = ACTIONS(2851),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_break] = ACTIONS(2851),
    [anon_sym_continue] = ACTIONS(2851),
    [anon_sym_goto] = ACTIONS(2851),
    [anon_sym___try] = ACTIONS(2851),
    [anon_sym___leave] = ACTIONS(2851),
    [anon_sym_not] = ACTIONS(2851),
    [anon_sym_compl] = ACTIONS(2851),
    [anon_sym_DASH_DASH] = ACTIONS(2853),
    [anon_sym_PLUS_PLUS] = ACTIONS(2853),
    [anon_sym_sizeof] = ACTIONS(2851),
    [anon_sym___alignof__] = ACTIONS(2851),
    [anon_sym___alignof] = ACTIONS(2851),
    [anon_sym__alignof] = ACTIONS(2851),
    [anon_sym_alignof] = ACTIONS(2851),
    [anon_sym__Alignof] = ACTIONS(2851),
    [anon_sym_offsetof] = ACTIONS(2851),
    [anon_sym__Generic] = ACTIONS(2851),
    [anon_sym_asm] = ACTIONS(2851),
    [anon_sym___asm__] = ACTIONS(2851),
    [anon_sym___asm] = ACTIONS(2851),
    [sym_number_literal] = ACTIONS(2853),
    [anon_sym_L_SQUOTE] = ACTIONS(2853),
    [anon_sym_u_SQUOTE] = ACTIONS(2853),
    [anon_sym_U_SQUOTE] = ACTIONS(2853),
    [anon_sym_u8_SQUOTE] = ACTIONS(2853),
    [anon_sym_SQUOTE] = ACTIONS(2853),
    [anon_sym_L_DQUOTE] = ACTIONS(2853),
    [anon_sym_u_DQUOTE] = ACTIONS(2853),
    [anon_sym_U_DQUOTE] = ACTIONS(2853),
    [anon_sym_u8_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE] = ACTIONS(2853),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2851),
    [anon_sym_nullptr] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2851),
    [anon_sym_decltype] = ACTIONS(2851),
    [anon_sym_explicit] = ACTIONS(2851),
    [anon_sym_typename] = ACTIONS(2851),
    [anon_sym_template] = ACTIONS(2851),
    [anon_sym_operator] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_delete] = ACTIONS(2851),
    [anon_sym_throw] = ACTIONS(2851),
    [anon_sym_namespace] = ACTIONS(2851),
    [anon_sym_static_assert] = ACTIONS(2851),
    [anon_sym_concept] = ACTIONS(2851),
    [anon_sym_co_return] = ACTIONS(2851),
    [anon_sym_co_yield] = ACTIONS(2851),
    [anon_sym_R_DQUOTE] = ACTIONS(2853),
    [anon_sym_LR_DQUOTE] = ACTIONS(2853),
    [anon_sym_uR_DQUOTE] = ACTIONS(2853),
    [anon_sym_UR_DQUOTE] = ACTIONS(2853),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2853),
    [anon_sym_co_await] = ACTIONS(2851),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_requires] = ACTIONS(2851),
    [sym_this] = ACTIONS(2851),
  },
  [654] = {
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_include_token1] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2823),
    [aux_sym_preproc_if_token1] = ACTIONS(2823),
    [aux_sym_preproc_if_token2] = ACTIONS(2823),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2823),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2823),
    [sym_preproc_directive] = ACTIONS(2823),
    [anon_sym_LPAREN2] = ACTIONS(2825),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_TILDE] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_SEMI] = ACTIONS(2825),
    [anon_sym___extension__] = ACTIONS(2823),
    [anon_sym_typedef] = ACTIONS(2823),
    [anon_sym_virtual] = ACTIONS(2823),
    [anon_sym_extern] = ACTIONS(2823),
    [anon_sym___attribute__] = ACTIONS(2823),
    [anon_sym___attribute] = ACTIONS(2823),
    [anon_sym_using] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2825),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2825),
    [anon_sym___declspec] = ACTIONS(2823),
    [anon_sym___based] = ACTIONS(2823),
    [anon_sym___cdecl] = ACTIONS(2823),
    [anon_sym___clrcall] = ACTIONS(2823),
    [anon_sym___stdcall] = ACTIONS(2823),
    [anon_sym___fastcall] = ACTIONS(2823),
    [anon_sym___thiscall] = ACTIONS(2823),
    [anon_sym___vectorcall] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_signed] = ACTIONS(2823),
    [anon_sym_unsigned] = ACTIONS(2823),
    [anon_sym_long] = ACTIONS(2823),
    [anon_sym_short] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2823),
    [anon_sym_register] = ACTIONS(2823),
    [anon_sym_inline] = ACTIONS(2823),
    [anon_sym___inline] = ACTIONS(2823),
    [anon_sym___inline__] = ACTIONS(2823),
    [anon_sym___forceinline] = ACTIONS(2823),
    [anon_sym_thread_local] = ACTIONS(2823),
    [anon_sym___thread] = ACTIONS(2823),
    [anon_sym_const] = ACTIONS(2823),
    [anon_sym_constexpr] = ACTIONS(2823),
    [anon_sym_volatile] = ACTIONS(2823),
    [anon_sym_restrict] = ACTIONS(2823),
    [anon_sym___restrict__] = ACTIONS(2823),
    [anon_sym__Atomic] = ACTIONS(2823),
    [anon_sym__Noreturn] = ACTIONS(2823),
    [anon_sym_noreturn] = ACTIONS(2823),
    [anon_sym__Nonnull] = ACTIONS(2823),
    [anon_sym_mutable] = ACTIONS(2823),
    [anon_sym_constinit] = ACTIONS(2823),
    [anon_sym_consteval] = ACTIONS(2823),
    [anon_sym_alignas] = ACTIONS(2823),
    [anon_sym__Alignas] = ACTIONS(2823),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2823),
    [anon_sym_class] = ACTIONS(2823),
    [anon_sym_struct] = ACTIONS(2823),
    [anon_sym_union] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_switch] = ACTIONS(2823),
    [anon_sym_case] = ACTIONS(2823),
    [anon_sym_default] = ACTIONS(2823),
    [anon_sym_while] = ACTIONS(2823),
    [anon_sym_do] = ACTIONS(2823),
    [anon_sym_for] = ACTIONS(2823),
    [anon_sym_return] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2823),
    [anon_sym_continue] = ACTIONS(2823),
    [anon_sym_goto] = ACTIONS(2823),
    [anon_sym___try] = ACTIONS(2823),
    [anon_sym___leave] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2823),
    [anon_sym_compl] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2825),
    [anon_sym_sizeof] = ACTIONS(2823),
    [anon_sym___alignof__] = ACTIONS(2823),
    [anon_sym___alignof] = ACTIONS(2823),
    [anon_sym__alignof] = ACTIONS(2823),
    [anon_sym_alignof] = ACTIONS(2823),
    [anon_sym__Alignof] = ACTIONS(2823),
    [anon_sym_offsetof] = ACTIONS(2823),
    [anon_sym__Generic] = ACTIONS(2823),
    [anon_sym_asm] = ACTIONS(2823),
    [anon_sym___asm__] = ACTIONS(2823),
    [anon_sym___asm] = ACTIONS(2823),
    [sym_number_literal] = ACTIONS(2825),
    [anon_sym_L_SQUOTE] = ACTIONS(2825),
    [anon_sym_u_SQUOTE] = ACTIONS(2825),
    [anon_sym_U_SQUOTE] = ACTIONS(2825),
    [anon_sym_u8_SQUOTE] = ACTIONS(2825),
    [anon_sym_SQUOTE] = ACTIONS(2825),
    [anon_sym_L_DQUOTE] = ACTIONS(2825),
    [anon_sym_u_DQUOTE] = ACTIONS(2825),
    [anon_sym_U_DQUOTE] = ACTIONS(2825),
    [anon_sym_u8_DQUOTE] = ACTIONS(2825),
    [anon_sym_DQUOTE] = ACTIONS(2825),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [anon_sym_NULL] = ACTIONS(2823),
    [anon_sym_nullptr] = ACTIONS(2823),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2823),
    [anon_sym_decltype] = ACTIONS(2823),
    [anon_sym_explicit] = ACTIONS(2823),
    [anon_sym_typename] = ACTIONS(2823),
    [anon_sym_template] = ACTIONS(2823),
    [anon_sym_operator] = ACTIONS(2823),
    [anon_sym_try] = ACTIONS(2823),
    [anon_sym_delete] = ACTIONS(2823),
    [anon_sym_throw] = ACTIONS(2823),
    [anon_sym_namespace] = ACTIONS(2823),
    [anon_sym_static_assert] = ACTIONS(2823),
    [anon_sym_concept] = ACTIONS(2823),
    [anon_sym_co_return] = ACTIONS(2823),
    [anon_sym_co_yield] = ACTIONS(2823),
    [anon_sym_R_DQUOTE] = ACTIONS(2825),
    [anon_sym_LR_DQUOTE] = ACTIONS(2825),
    [anon_sym_uR_DQUOTE] = ACTIONS(2825),
    [anon_sym_UR_DQUOTE] = ACTIONS(2825),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2825),
    [anon_sym_co_await] = ACTIONS(2823),
    [anon_sym_new] = ACTIONS(2823),
    [anon_sym_requires] = ACTIONS(2823),
    [sym_this] = ACTIONS(2823),
  },
  [655] = {
    [sym_identifier] = ACTIONS(2855),
    [aux_sym_preproc_include_token1] = ACTIONS(2855),
    [aux_sym_preproc_def_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token1] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2855),
    [sym_preproc_directive] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(2857),
    [anon_sym_TILDE] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym___extension__] = ACTIONS(2855),
    [anon_sym_typedef] = ACTIONS(2855),
    [anon_sym_virtual] = ACTIONS(2855),
    [anon_sym_extern] = ACTIONS(2855),
    [anon_sym___attribute__] = ACTIONS(2855),
    [anon_sym___attribute] = ACTIONS(2855),
    [anon_sym_using] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2857),
    [anon_sym___declspec] = ACTIONS(2855),
    [anon_sym___based] = ACTIONS(2855),
    [anon_sym___cdecl] = ACTIONS(2855),
    [anon_sym___clrcall] = ACTIONS(2855),
    [anon_sym___stdcall] = ACTIONS(2855),
    [anon_sym___fastcall] = ACTIONS(2855),
    [anon_sym___thiscall] = ACTIONS(2855),
    [anon_sym___vectorcall] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_signed] = ACTIONS(2855),
    [anon_sym_unsigned] = ACTIONS(2855),
    [anon_sym_long] = ACTIONS(2855),
    [anon_sym_short] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(2855),
    [anon_sym_register] = ACTIONS(2855),
    [anon_sym_inline] = ACTIONS(2855),
    [anon_sym___inline] = ACTIONS(2855),
    [anon_sym___inline__] = ACTIONS(2855),
    [anon_sym___forceinline] = ACTIONS(2855),
    [anon_sym_thread_local] = ACTIONS(2855),
    [anon_sym___thread] = ACTIONS(2855),
    [anon_sym_const] = ACTIONS(2855),
    [anon_sym_constexpr] = ACTIONS(2855),
    [anon_sym_volatile] = ACTIONS(2855),
    [anon_sym_restrict] = ACTIONS(2855),
    [anon_sym___restrict__] = ACTIONS(2855),
    [anon_sym__Atomic] = ACTIONS(2855),
    [anon_sym__Noreturn] = ACTIONS(2855),
    [anon_sym_noreturn] = ACTIONS(2855),
    [anon_sym__Nonnull] = ACTIONS(2855),
    [anon_sym_mutable] = ACTIONS(2855),
    [anon_sym_constinit] = ACTIONS(2855),
    [anon_sym_consteval] = ACTIONS(2855),
    [anon_sym_alignas] = ACTIONS(2855),
    [anon_sym__Alignas] = ACTIONS(2855),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_enum] = ACTIONS(2855),
    [anon_sym_class] = ACTIONS(2855),
    [anon_sym_struct] = ACTIONS(2855),
    [anon_sym_union] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_case] = ACTIONS(2855),
    [anon_sym_default] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_break] = ACTIONS(2855),
    [anon_sym_continue] = ACTIONS(2855),
    [anon_sym_goto] = ACTIONS(2855),
    [anon_sym___try] = ACTIONS(2855),
    [anon_sym___leave] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2855),
    [anon_sym_compl] = ACTIONS(2855),
    [anon_sym_DASH_DASH] = ACTIONS(2857),
    [anon_sym_PLUS_PLUS] = ACTIONS(2857),
    [anon_sym_sizeof] = ACTIONS(2855),
    [anon_sym___alignof__] = ACTIONS(2855),
    [anon_sym___alignof] = ACTIONS(2855),
    [anon_sym__alignof] = ACTIONS(2855),
    [anon_sym_alignof] = ACTIONS(2855),
    [anon_sym__Alignof] = ACTIONS(2855),
    [anon_sym_offsetof] = ACTIONS(2855),
    [anon_sym__Generic] = ACTIONS(2855),
    [anon_sym_asm] = ACTIONS(2855),
    [anon_sym___asm__] = ACTIONS(2855),
    [anon_sym___asm] = ACTIONS(2855),
    [sym_number_literal] = ACTIONS(2857),
    [anon_sym_L_SQUOTE] = ACTIONS(2857),
    [anon_sym_u_SQUOTE] = ACTIONS(2857),
    [anon_sym_U_SQUOTE] = ACTIONS(2857),
    [anon_sym_u8_SQUOTE] = ACTIONS(2857),
    [anon_sym_SQUOTE] = ACTIONS(2857),
    [anon_sym_L_DQUOTE] = ACTIONS(2857),
    [anon_sym_u_DQUOTE] = ACTIONS(2857),
    [anon_sym_U_DQUOTE] = ACTIONS(2857),
    [anon_sym_u8_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [sym_true] = ACTIONS(2855),
    [sym_false] = ACTIONS(2855),
    [anon_sym_NULL] = ACTIONS(2855),
    [anon_sym_nullptr] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2855),
    [anon_sym_explicit] = ACTIONS(2855),
    [anon_sym_typename] = ACTIONS(2855),
    [anon_sym_template] = ACTIONS(2855),
    [anon_sym_operator] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_delete] = ACTIONS(2855),
    [anon_sym_throw] = ACTIONS(2855),
    [anon_sym_namespace] = ACTIONS(2855),
    [anon_sym_static_assert] = ACTIONS(2855),
    [anon_sym_concept] = ACTIONS(2855),
    [anon_sym_co_return] = ACTIONS(2855),
    [anon_sym_co_yield] = ACTIONS(2855),
    [anon_sym_R_DQUOTE] = ACTIONS(2857),
    [anon_sym_LR_DQUOTE] = ACTIONS(2857),
    [anon_sym_uR_DQUOTE] = ACTIONS(2857),
    [anon_sym_UR_DQUOTE] = ACTIONS(2857),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2857),
    [anon_sym_co_await] = ACTIONS(2855),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_requires] = ACTIONS(2855),
    [sym_this] = ACTIONS(2855),
  },
  [656] = {
    [sym_identifier] = ACTIONS(2859),
    [aux_sym_preproc_include_token1] = ACTIONS(2859),
    [aux_sym_preproc_def_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token1] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2859),
    [sym_preproc_directive] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym___extension__] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2859),
    [anon_sym_virtual] = ACTIONS(2859),
    [anon_sym_extern] = ACTIONS(2859),
    [anon_sym___attribute__] = ACTIONS(2859),
    [anon_sym___attribute] = ACTIONS(2859),
    [anon_sym_using] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2861),
    [anon_sym___declspec] = ACTIONS(2859),
    [anon_sym___based] = ACTIONS(2859),
    [anon_sym___cdecl] = ACTIONS(2859),
    [anon_sym___clrcall] = ACTIONS(2859),
    [anon_sym___stdcall] = ACTIONS(2859),
    [anon_sym___fastcall] = ACTIONS(2859),
    [anon_sym___thiscall] = ACTIONS(2859),
    [anon_sym___vectorcall] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_RBRACE] = ACTIONS(2861),
    [anon_sym_signed] = ACTIONS(2859),
    [anon_sym_unsigned] = ACTIONS(2859),
    [anon_sym_long] = ACTIONS(2859),
    [anon_sym_short] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2859),
    [anon_sym_register] = ACTIONS(2859),
    [anon_sym_inline] = ACTIONS(2859),
    [anon_sym___inline] = ACTIONS(2859),
    [anon_sym___inline__] = ACTIONS(2859),
    [anon_sym___forceinline] = ACTIONS(2859),
    [anon_sym_thread_local] = ACTIONS(2859),
    [anon_sym___thread] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2859),
    [anon_sym_constexpr] = ACTIONS(2859),
    [anon_sym_volatile] = ACTIONS(2859),
    [anon_sym_restrict] = ACTIONS(2859),
    [anon_sym___restrict__] = ACTIONS(2859),
    [anon_sym__Atomic] = ACTIONS(2859),
    [anon_sym__Noreturn] = ACTIONS(2859),
    [anon_sym_noreturn] = ACTIONS(2859),
    [anon_sym__Nonnull] = ACTIONS(2859),
    [anon_sym_mutable] = ACTIONS(2859),
    [anon_sym_constinit] = ACTIONS(2859),
    [anon_sym_consteval] = ACTIONS(2859),
    [anon_sym_alignas] = ACTIONS(2859),
    [anon_sym__Alignas] = ACTIONS(2859),
    [sym_primitive_type] = ACTIONS(2859),
    [anon_sym_enum] = ACTIONS(2859),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2859),
    [anon_sym_union] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_switch] = ACTIONS(2859),
    [anon_sym_case] = ACTIONS(2859),
    [anon_sym_default] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_break] = ACTIONS(2859),
    [anon_sym_continue] = ACTIONS(2859),
    [anon_sym_goto] = ACTIONS(2859),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(2859),
    [anon_sym_not] = ACTIONS(2859),
    [anon_sym_compl] = ACTIONS(2859),
    [anon_sym_DASH_DASH] = ACTIONS(2861),
    [anon_sym_PLUS_PLUS] = ACTIONS(2861),
    [anon_sym_sizeof] = ACTIONS(2859),
    [anon_sym___alignof__] = ACTIONS(2859),
    [anon_sym___alignof] = ACTIONS(2859),
    [anon_sym__alignof] = ACTIONS(2859),
    [anon_sym_alignof] = ACTIONS(2859),
    [anon_sym__Alignof] = ACTIONS(2859),
    [anon_sym_offsetof] = ACTIONS(2859),
    [anon_sym__Generic] = ACTIONS(2859),
    [anon_sym_asm] = ACTIONS(2859),
    [anon_sym___asm__] = ACTIONS(2859),
    [anon_sym___asm] = ACTIONS(2859),
    [sym_number_literal] = ACTIONS(2861),
    [anon_sym_L_SQUOTE] = ACTIONS(2861),
    [anon_sym_u_SQUOTE] = ACTIONS(2861),
    [anon_sym_U_SQUOTE] = ACTIONS(2861),
    [anon_sym_u8_SQUOTE] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2861),
    [anon_sym_L_DQUOTE] = ACTIONS(2861),
    [anon_sym_u_DQUOTE] = ACTIONS(2861),
    [anon_sym_U_DQUOTE] = ACTIONS(2861),
    [anon_sym_u8_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE] = ACTIONS(2861),
    [sym_true] = ACTIONS(2859),
    [sym_false] = ACTIONS(2859),
    [anon_sym_NULL] = ACTIONS(2859),
    [anon_sym_nullptr] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2859),
    [anon_sym_decltype] = ACTIONS(2859),
    [anon_sym_explicit] = ACTIONS(2859),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(2859),
    [anon_sym_operator] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_delete] = ACTIONS(2859),
    [anon_sym_throw] = ACTIONS(2859),
    [anon_sym_namespace] = ACTIONS(2859),
    [anon_sym_static_assert] = ACTIONS(2859),
    [anon_sym_concept] = ACTIONS(2859),
    [anon_sym_co_return] = ACTIONS(2859),
    [anon_sym_co_yield] = ACTIONS(2859),
    [anon_sym_R_DQUOTE] = ACTIONS(2861),
    [anon_sym_LR_DQUOTE] = ACTIONS(2861),
    [anon_sym_uR_DQUOTE] = ACTIONS(2861),
    [anon_sym_UR_DQUOTE] = ACTIONS(2861),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2861),
    [anon_sym_co_await] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_requires] = ACTIONS(2859),
    [sym_this] = ACTIONS(2859),
  },
  [657] = {
    [sym_identifier] = ACTIONS(2831),
    [aux_sym_preproc_include_token1] = ACTIONS(2831),
    [aux_sym_preproc_def_token1] = ACTIONS(2831),
    [aux_sym_preproc_if_token1] = ACTIONS(2831),
    [aux_sym_preproc_if_token2] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [sym_preproc_directive] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym___extension__] = ACTIONS(2831),
    [anon_sym_typedef] = ACTIONS(2831),
    [anon_sym_virtual] = ACTIONS(2831),
    [anon_sym_extern] = ACTIONS(2831),
    [anon_sym___attribute__] = ACTIONS(2831),
    [anon_sym___attribute] = ACTIONS(2831),
    [anon_sym_using] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2833),
    [anon_sym___declspec] = ACTIONS(2831),
    [anon_sym___based] = ACTIONS(2831),
    [anon_sym___cdecl] = ACTIONS(2831),
    [anon_sym___clrcall] = ACTIONS(2831),
    [anon_sym___stdcall] = ACTIONS(2831),
    [anon_sym___fastcall] = ACTIONS(2831),
    [anon_sym___thiscall] = ACTIONS(2831),
    [anon_sym___vectorcall] = ACTIONS(2831),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_signed] = ACTIONS(2831),
    [anon_sym_unsigned] = ACTIONS(2831),
    [anon_sym_long] = ACTIONS(2831),
    [anon_sym_short] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_static] = ACTIONS(2831),
    [anon_sym_register] = ACTIONS(2831),
    [anon_sym_inline] = ACTIONS(2831),
    [anon_sym___inline] = ACTIONS(2831),
    [anon_sym___inline__] = ACTIONS(2831),
    [anon_sym___forceinline] = ACTIONS(2831),
    [anon_sym_thread_local] = ACTIONS(2831),
    [anon_sym___thread] = ACTIONS(2831),
    [anon_sym_const] = ACTIONS(2831),
    [anon_sym_constexpr] = ACTIONS(2831),
    [anon_sym_volatile] = ACTIONS(2831),
    [anon_sym_restrict] = ACTIONS(2831),
    [anon_sym___restrict__] = ACTIONS(2831),
    [anon_sym__Atomic] = ACTIONS(2831),
    [anon_sym__Noreturn] = ACTIONS(2831),
    [anon_sym_noreturn] = ACTIONS(2831),
    [anon_sym__Nonnull] = ACTIONS(2831),
    [anon_sym_mutable] = ACTIONS(2831),
    [anon_sym_constinit] = ACTIONS(2831),
    [anon_sym_consteval] = ACTIONS(2831),
    [anon_sym_alignas] = ACTIONS(2831),
    [anon_sym__Alignas] = ACTIONS(2831),
    [sym_primitive_type] = ACTIONS(2831),
    [anon_sym_enum] = ACTIONS(2831),
    [anon_sym_class] = ACTIONS(2831),
    [anon_sym_struct] = ACTIONS(2831),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_switch] = ACTIONS(2831),
    [anon_sym_case] = ACTIONS(2831),
    [anon_sym_default] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_break] = ACTIONS(2831),
    [anon_sym_continue] = ACTIONS(2831),
    [anon_sym_goto] = ACTIONS(2831),
    [anon_sym___try] = ACTIONS(2831),
    [anon_sym___leave] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_compl] = ACTIONS(2831),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2831),
    [anon_sym___alignof__] = ACTIONS(2831),
    [anon_sym___alignof] = ACTIONS(2831),
    [anon_sym__alignof] = ACTIONS(2831),
    [anon_sym_alignof] = ACTIONS(2831),
    [anon_sym__Alignof] = ACTIONS(2831),
    [anon_sym_offsetof] = ACTIONS(2831),
    [anon_sym__Generic] = ACTIONS(2831),
    [anon_sym_asm] = ACTIONS(2831),
    [anon_sym___asm__] = ACTIONS(2831),
    [anon_sym___asm] = ACTIONS(2831),
    [sym_number_literal] = ACTIONS(2833),
    [anon_sym_L_SQUOTE] = ACTIONS(2833),
    [anon_sym_u_SQUOTE] = ACTIONS(2833),
    [anon_sym_U_SQUOTE] = ACTIONS(2833),
    [anon_sym_u8_SQUOTE] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_L_DQUOTE] = ACTIONS(2833),
    [anon_sym_u_DQUOTE] = ACTIONS(2833),
    [anon_sym_U_DQUOTE] = ACTIONS(2833),
    [anon_sym_u8_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [sym_true] = ACTIONS(2831),
    [sym_false] = ACTIONS(2831),
    [anon_sym_NULL] = ACTIONS(2831),
    [anon_sym_nullptr] = ACTIONS(2831),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2831),
    [anon_sym_decltype] = ACTIONS(2831),
    [anon_sym_explicit] = ACTIONS(2831),
    [anon_sym_typename] = ACTIONS(2831),
    [anon_sym_template] = ACTIONS(2831),
    [anon_sym_operator] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_delete] = ACTIONS(2831),
    [anon_sym_throw] = ACTIONS(2831),
    [anon_sym_namespace] = ACTIONS(2831),
    [anon_sym_static_assert] = ACTIONS(2831),
    [anon_sym_concept] = ACTIONS(2831),
    [anon_sym_co_return] = ACTIONS(2831),
    [anon_sym_co_yield] = ACTIONS(2831),
    [anon_sym_R_DQUOTE] = ACTIONS(2833),
    [anon_sym_LR_DQUOTE] = ACTIONS(2833),
    [anon_sym_uR_DQUOTE] = ACTIONS(2833),
    [anon_sym_UR_DQUOTE] = ACTIONS(2833),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2833),
    [anon_sym_co_await] = ACTIONS(2831),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_requires] = ACTIONS(2831),
    [sym_this] = ACTIONS(2831),
  },
  [658] = {
    [sym_identifier] = ACTIONS(2835),
    [aux_sym_preproc_include_token1] = ACTIONS(2835),
    [aux_sym_preproc_def_token1] = ACTIONS(2835),
    [aux_sym_preproc_if_token1] = ACTIONS(2835),
    [aux_sym_preproc_if_token2] = ACTIONS(2835),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2835),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2835),
    [sym_preproc_directive] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym___extension__] = ACTIONS(2835),
    [anon_sym_typedef] = ACTIONS(2835),
    [anon_sym_virtual] = ACTIONS(2835),
    [anon_sym_extern] = ACTIONS(2835),
    [anon_sym___attribute__] = ACTIONS(2835),
    [anon_sym___attribute] = ACTIONS(2835),
    [anon_sym_using] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2837),
    [anon_sym___declspec] = ACTIONS(2835),
    [anon_sym___based] = ACTIONS(2835),
    [anon_sym___cdecl] = ACTIONS(2835),
    [anon_sym___clrcall] = ACTIONS(2835),
    [anon_sym___stdcall] = ACTIONS(2835),
    [anon_sym___fastcall] = ACTIONS(2835),
    [anon_sym___thiscall] = ACTIONS(2835),
    [anon_sym___vectorcall] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_signed] = ACTIONS(2835),
    [anon_sym_unsigned] = ACTIONS(2835),
    [anon_sym_long] = ACTIONS(2835),
    [anon_sym_short] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_static] = ACTIONS(2835),
    [anon_sym_register] = ACTIONS(2835),
    [anon_sym_inline] = ACTIONS(2835),
    [anon_sym___inline] = ACTIONS(2835),
    [anon_sym___inline__] = ACTIONS(2835),
    [anon_sym___forceinline] = ACTIONS(2835),
    [anon_sym_thread_local] = ACTIONS(2835),
    [anon_sym___thread] = ACTIONS(2835),
    [anon_sym_const] = ACTIONS(2835),
    [anon_sym_constexpr] = ACTIONS(2835),
    [anon_sym_volatile] = ACTIONS(2835),
    [anon_sym_restrict] = ACTIONS(2835),
    [anon_sym___restrict__] = ACTIONS(2835),
    [anon_sym__Atomic] = ACTIONS(2835),
    [anon_sym__Noreturn] = ACTIONS(2835),
    [anon_sym_noreturn] = ACTIONS(2835),
    [anon_sym__Nonnull] = ACTIONS(2835),
    [anon_sym_mutable] = ACTIONS(2835),
    [anon_sym_constinit] = ACTIONS(2835),
    [anon_sym_consteval] = ACTIONS(2835),
    [anon_sym_alignas] = ACTIONS(2835),
    [anon_sym__Alignas] = ACTIONS(2835),
    [sym_primitive_type] = ACTIONS(2835),
    [anon_sym_enum] = ACTIONS(2835),
    [anon_sym_class] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2835),
    [anon_sym_union] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_switch] = ACTIONS(2835),
    [anon_sym_case] = ACTIONS(2835),
    [anon_sym_default] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_break] = ACTIONS(2835),
    [anon_sym_continue] = ACTIONS(2835),
    [anon_sym_goto] = ACTIONS(2835),
    [anon_sym___try] = ACTIONS(2835),
    [anon_sym___leave] = ACTIONS(2835),
    [anon_sym_not] = ACTIONS(2835),
    [anon_sym_compl] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2835),
    [anon_sym___alignof] = ACTIONS(2835),
    [anon_sym__alignof] = ACTIONS(2835),
    [anon_sym_alignof] = ACTIONS(2835),
    [anon_sym__Alignof] = ACTIONS(2835),
    [anon_sym_offsetof] = ACTIONS(2835),
    [anon_sym__Generic] = ACTIONS(2835),
    [anon_sym_asm] = ACTIONS(2835),
    [anon_sym___asm__] = ACTIONS(2835),
    [anon_sym___asm] = ACTIONS(2835),
    [sym_number_literal] = ACTIONS(2837),
    [anon_sym_L_SQUOTE] = ACTIONS(2837),
    [anon_sym_u_SQUOTE] = ACTIONS(2837),
    [anon_sym_U_SQUOTE] = ACTIONS(2837),
    [anon_sym_u8_SQUOTE] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_L_DQUOTE] = ACTIONS(2837),
    [anon_sym_u_DQUOTE] = ACTIONS(2837),
    [anon_sym_U_DQUOTE] = ACTIONS(2837),
    [anon_sym_u8_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [sym_true] = ACTIONS(2835),
    [sym_false] = ACTIONS(2835),
    [anon_sym_NULL] = ACTIONS(2835),
    [anon_sym_nullptr] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2835),
    [anon_sym_decltype] = ACTIONS(2835),
    [anon_sym_explicit] = ACTIONS(2835),
    [anon_sym_typename] = ACTIONS(2835),
    [anon_sym_template] = ACTIONS(2835),
    [anon_sym_operator] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_delete] = ACTIONS(2835),
    [anon_sym_throw] = ACTIONS(2835),
    [anon_sym_namespace] = ACTIONS(2835),
    [anon_sym_static_assert] = ACTIONS(2835),
    [anon_sym_concept] = ACTIONS(2835),
    [anon_sym_co_return] = ACTIONS(2835),
    [anon_sym_co_yield] = ACTIONS(2835),
    [anon_sym_R_DQUOTE] = ACTIONS(2837),
    [anon_sym_LR_DQUOTE] = ACTIONS(2837),
    [anon_sym_uR_DQUOTE] = ACTIONS(2837),
    [anon_sym_UR_DQUOTE] = ACTIONS(2837),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2837),
    [anon_sym_co_await] = ACTIONS(2835),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_requires] = ACTIONS(2835),
    [sym_this] = ACTIONS(2835),
  },
  [659] = {
    [sym_identifier] = ACTIONS(2839),
    [aux_sym_preproc_include_token1] = ACTIONS(2839),
    [aux_sym_preproc_def_token1] = ACTIONS(2839),
    [aux_sym_preproc_if_token1] = ACTIONS(2839),
    [aux_sym_preproc_if_token2] = ACTIONS(2839),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2839),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2839),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym___extension__] = ACTIONS(2839),
    [anon_sym_typedef] = ACTIONS(2839),
    [anon_sym_virtual] = ACTIONS(2839),
    [anon_sym_extern] = ACTIONS(2839),
    [anon_sym___attribute__] = ACTIONS(2839),
    [anon_sym___attribute] = ACTIONS(2839),
    [anon_sym_using] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2841),
    [anon_sym___declspec] = ACTIONS(2839),
    [anon_sym___based] = ACTIONS(2839),
    [anon_sym___cdecl] = ACTIONS(2839),
    [anon_sym___clrcall] = ACTIONS(2839),
    [anon_sym___stdcall] = ACTIONS(2839),
    [anon_sym___fastcall] = ACTIONS(2839),
    [anon_sym___thiscall] = ACTIONS(2839),
    [anon_sym___vectorcall] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_signed] = ACTIONS(2839),
    [anon_sym_unsigned] = ACTIONS(2839),
    [anon_sym_long] = ACTIONS(2839),
    [anon_sym_short] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_static] = ACTIONS(2839),
    [anon_sym_register] = ACTIONS(2839),
    [anon_sym_inline] = ACTIONS(2839),
    [anon_sym___inline] = ACTIONS(2839),
    [anon_sym___inline__] = ACTIONS(2839),
    [anon_sym___forceinline] = ACTIONS(2839),
    [anon_sym_thread_local] = ACTIONS(2839),
    [anon_sym___thread] = ACTIONS(2839),
    [anon_sym_const] = ACTIONS(2839),
    [anon_sym_constexpr] = ACTIONS(2839),
    [anon_sym_volatile] = ACTIONS(2839),
    [anon_sym_restrict] = ACTIONS(2839),
    [anon_sym___restrict__] = ACTIONS(2839),
    [anon_sym__Atomic] = ACTIONS(2839),
    [anon_sym__Noreturn] = ACTIONS(2839),
    [anon_sym_noreturn] = ACTIONS(2839),
    [anon_sym__Nonnull] = ACTIONS(2839),
    [anon_sym_mutable] = ACTIONS(2839),
    [anon_sym_constinit] = ACTIONS(2839),
    [anon_sym_consteval] = ACTIONS(2839),
    [anon_sym_alignas] = ACTIONS(2839),
    [anon_sym__Alignas] = ACTIONS(2839),
    [sym_primitive_type] = ACTIONS(2839),
    [anon_sym_enum] = ACTIONS(2839),
    [anon_sym_class] = ACTIONS(2839),
    [anon_sym_struct] = ACTIONS(2839),
    [anon_sym_union] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_switch] = ACTIONS(2839),
    [anon_sym_case] = ACTIONS(2839),
    [anon_sym_default] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_continue] = ACTIONS(2839),
    [anon_sym_goto] = ACTIONS(2839),
    [anon_sym___try] = ACTIONS(2839),
    [anon_sym___leave] = ACTIONS(2839),
    [anon_sym_not] = ACTIONS(2839),
    [anon_sym_compl] = ACTIONS(2839),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_sizeof] = ACTIONS(2839),
    [anon_sym___alignof__] = ACTIONS(2839),
    [anon_sym___alignof] = ACTIONS(2839),
    [anon_sym__alignof] = ACTIONS(2839),
    [anon_sym_alignof] = ACTIONS(2839),
    [anon_sym__Alignof] = ACTIONS(2839),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2839),
    [anon_sym_asm] = ACTIONS(2839),
    [anon_sym___asm__] = ACTIONS(2839),
    [anon_sym___asm] = ACTIONS(2839),
    [sym_number_literal] = ACTIONS(2841),
    [anon_sym_L_SQUOTE] = ACTIONS(2841),
    [anon_sym_u_SQUOTE] = ACTIONS(2841),
    [anon_sym_U_SQUOTE] = ACTIONS(2841),
    [anon_sym_u8_SQUOTE] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_L_DQUOTE] = ACTIONS(2841),
    [anon_sym_u_DQUOTE] = ACTIONS(2841),
    [anon_sym_U_DQUOTE] = ACTIONS(2841),
    [anon_sym_u8_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [sym_true] = ACTIONS(2839),
    [sym_false] = ACTIONS(2839),
    [anon_sym_NULL] = ACTIONS(2839),
    [anon_sym_nullptr] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2839),
    [anon_sym_decltype] = ACTIONS(2839),
    [anon_sym_explicit] = ACTIONS(2839),
    [anon_sym_typename] = ACTIONS(2839),
    [anon_sym_template] = ACTIONS(2839),
    [anon_sym_operator] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_delete] = ACTIONS(2839),
    [anon_sym_throw] = ACTIONS(2839),
    [anon_sym_namespace] = ACTIONS(2839),
    [anon_sym_static_assert] = ACTIONS(2839),
    [anon_sym_concept] = ACTIONS(2839),
    [anon_sym_co_return] = ACTIONS(2839),
    [anon_sym_co_yield] = ACTIONS(2839),
    [anon_sym_R_DQUOTE] = ACTIONS(2841),
    [anon_sym_LR_DQUOTE] = ACTIONS(2841),
    [anon_sym_uR_DQUOTE] = ACTIONS(2841),
    [anon_sym_UR_DQUOTE] = ACTIONS(2841),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2841),
    [anon_sym_co_await] = ACTIONS(2839),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_requires] = ACTIONS(2839),
    [sym_this] = ACTIONS(2839),
  },
  [660] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_include_token1] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_BANG] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym___cdecl] = ACTIONS(2771),
    [anon_sym___clrcall] = ACTIONS(2771),
    [anon_sym___stdcall] = ACTIONS(2771),
    [anon_sym___fastcall] = ACTIONS(2771),
    [anon_sym___thiscall] = ACTIONS(2771),
    [anon_sym___vectorcall] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_switch] = ACTIONS(2771),
    [anon_sym_case] = ACTIONS(2771),
    [anon_sym_default] = ACTIONS(2771),
    [anon_sym_while] = ACTIONS(2771),
    [anon_sym_do] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2771),
    [anon_sym_return] = ACTIONS(2771),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_continue] = ACTIONS(2771),
    [anon_sym_goto] = ACTIONS(2771),
    [anon_sym___try] = ACTIONS(2771),
    [anon_sym___leave] = ACTIONS(2771),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_compl] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2773),
    [anon_sym_PLUS_PLUS] = ACTIONS(2773),
    [anon_sym_sizeof] = ACTIONS(2771),
    [anon_sym___alignof__] = ACTIONS(2771),
    [anon_sym___alignof] = ACTIONS(2771),
    [anon_sym__alignof] = ACTIONS(2771),
    [anon_sym_alignof] = ACTIONS(2771),
    [anon_sym__Alignof] = ACTIONS(2771),
    [anon_sym_offsetof] = ACTIONS(2771),
    [anon_sym__Generic] = ACTIONS(2771),
    [anon_sym_asm] = ACTIONS(2771),
    [anon_sym___asm__] = ACTIONS(2771),
    [anon_sym___asm] = ACTIONS(2771),
    [sym_number_literal] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2773),
    [anon_sym_u_SQUOTE] = ACTIONS(2773),
    [anon_sym_U_SQUOTE] = ACTIONS(2773),
    [anon_sym_u8_SQUOTE] = ACTIONS(2773),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [anon_sym_L_DQUOTE] = ACTIONS(2773),
    [anon_sym_u_DQUOTE] = ACTIONS(2773),
    [anon_sym_U_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8_DQUOTE] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(2773),
    [sym_true] = ACTIONS(2771),
    [sym_false] = ACTIONS(2771),
    [anon_sym_NULL] = ACTIONS(2771),
    [anon_sym_nullptr] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_try] = ACTIONS(2771),
    [anon_sym_delete] = ACTIONS(2771),
    [anon_sym_throw] = ACTIONS(2771),
    [anon_sym_namespace] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
    [anon_sym_concept] = ACTIONS(2771),
    [anon_sym_co_return] = ACTIONS(2771),
    [anon_sym_co_yield] = ACTIONS(2771),
    [anon_sym_R_DQUOTE] = ACTIONS(2773),
    [anon_sym_LR_DQUOTE] = ACTIONS(2773),
    [anon_sym_uR_DQUOTE] = ACTIONS(2773),
    [anon_sym_UR_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2773),
    [anon_sym_co_await] = ACTIONS(2771),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2771),
  },
  [661] = {
    [sym_identifier] = ACTIONS(2863),
    [aux_sym_preproc_include_token1] = ACTIONS(2863),
    [aux_sym_preproc_def_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token1] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2863),
    [sym_preproc_directive] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym___extension__] = ACTIONS(2863),
    [anon_sym_typedef] = ACTIONS(2863),
    [anon_sym_virtual] = ACTIONS(2863),
    [anon_sym_extern] = ACTIONS(2863),
    [anon_sym___attribute__] = ACTIONS(2863),
    [anon_sym___attribute] = ACTIONS(2863),
    [anon_sym_using] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2865),
    [anon_sym___declspec] = ACTIONS(2863),
    [anon_sym___based] = ACTIONS(2863),
    [anon_sym___cdecl] = ACTIONS(2863),
    [anon_sym___clrcall] = ACTIONS(2863),
    [anon_sym___stdcall] = ACTIONS(2863),
    [anon_sym___fastcall] = ACTIONS(2863),
    [anon_sym___thiscall] = ACTIONS(2863),
    [anon_sym___vectorcall] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_signed] = ACTIONS(2863),
    [anon_sym_unsigned] = ACTIONS(2863),
    [anon_sym_long] = ACTIONS(2863),
    [anon_sym_short] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_static] = ACTIONS(2863),
    [anon_sym_register] = ACTIONS(2863),
    [anon_sym_inline] = ACTIONS(2863),
    [anon_sym___inline] = ACTIONS(2863),
    [anon_sym___inline__] = ACTIONS(2863),
    [anon_sym___forceinline] = ACTIONS(2863),
    [anon_sym_thread_local] = ACTIONS(2863),
    [anon_sym___thread] = ACTIONS(2863),
    [anon_sym_const] = ACTIONS(2863),
    [anon_sym_constexpr] = ACTIONS(2863),
    [anon_sym_volatile] = ACTIONS(2863),
    [anon_sym_restrict] = ACTIONS(2863),
    [anon_sym___restrict__] = ACTIONS(2863),
    [anon_sym__Atomic] = ACTIONS(2863),
    [anon_sym__Noreturn] = ACTIONS(2863),
    [anon_sym_noreturn] = ACTIONS(2863),
    [anon_sym__Nonnull] = ACTIONS(2863),
    [anon_sym_mutable] = ACTIONS(2863),
    [anon_sym_constinit] = ACTIONS(2863),
    [anon_sym_consteval] = ACTIONS(2863),
    [anon_sym_alignas] = ACTIONS(2863),
    [anon_sym__Alignas] = ACTIONS(2863),
    [sym_primitive_type] = ACTIONS(2863),
    [anon_sym_enum] = ACTIONS(2863),
    [anon_sym_class] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2863),
    [anon_sym_union] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_switch] = ACTIONS(2863),
    [anon_sym_case] = ACTIONS(2863),
    [anon_sym_default] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_break] = ACTIONS(2863),
    [anon_sym_continue] = ACTIONS(2863),
    [anon_sym_goto] = ACTIONS(2863),
    [anon_sym___try] = ACTIONS(2863),
    [anon_sym___leave] = ACTIONS(2863),
    [anon_sym_not] = ACTIONS(2863),
    [anon_sym_compl] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_sizeof] = ACTIONS(2863),
    [anon_sym___alignof__] = ACTIONS(2863),
    [anon_sym___alignof] = ACTIONS(2863),
    [anon_sym__alignof] = ACTIONS(2863),
    [anon_sym_alignof] = ACTIONS(2863),
    [anon_sym__Alignof] = ACTIONS(2863),
    [anon_sym_offsetof] = ACTIONS(2863),
    [anon_sym__Generic] = ACTIONS(2863),
    [anon_sym_asm] = ACTIONS(2863),
    [anon_sym___asm__] = ACTIONS(2863),
    [anon_sym___asm] = ACTIONS(2863),
    [sym_number_literal] = ACTIONS(2865),
    [anon_sym_L_SQUOTE] = ACTIONS(2865),
    [anon_sym_u_SQUOTE] = ACTIONS(2865),
    [anon_sym_U_SQUOTE] = ACTIONS(2865),
    [anon_sym_u8_SQUOTE] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_L_DQUOTE] = ACTIONS(2865),
    [anon_sym_u_DQUOTE] = ACTIONS(2865),
    [anon_sym_U_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [sym_true] = ACTIONS(2863),
    [sym_false] = ACTIONS(2863),
    [anon_sym_NULL] = ACTIONS(2863),
    [anon_sym_nullptr] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2863),
    [anon_sym_decltype] = ACTIONS(2863),
    [anon_sym_explicit] = ACTIONS(2863),
    [anon_sym_typename] = ACTIONS(2863),
    [anon_sym_template] = ACTIONS(2863),
    [anon_sym_operator] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_throw] = ACTIONS(2863),
    [anon_sym_namespace] = ACTIONS(2863),
    [anon_sym_static_assert] = ACTIONS(2863),
    [anon_sym_concept] = ACTIONS(2863),
    [anon_sym_co_return] = ACTIONS(2863),
    [anon_sym_co_yield] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2863),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_requires] = ACTIONS(2863),
    [sym_this] = ACTIONS(2863),
  },
  [662] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [663] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [664] = {
    [sym_identifier] = ACTIONS(2871),
    [aux_sym_preproc_include_token1] = ACTIONS(2871),
    [aux_sym_preproc_def_token1] = ACTIONS(2871),
    [aux_sym_preproc_if_token1] = ACTIONS(2871),
    [aux_sym_preproc_if_token2] = ACTIONS(2871),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2871),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2871),
    [sym_preproc_directive] = ACTIONS(2871),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym___extension__] = ACTIONS(2871),
    [anon_sym_typedef] = ACTIONS(2871),
    [anon_sym_virtual] = ACTIONS(2871),
    [anon_sym_extern] = ACTIONS(2871),
    [anon_sym___attribute__] = ACTIONS(2871),
    [anon_sym___attribute] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2873),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2873),
    [anon_sym___declspec] = ACTIONS(2871),
    [anon_sym___based] = ACTIONS(2871),
    [anon_sym___cdecl] = ACTIONS(2871),
    [anon_sym___clrcall] = ACTIONS(2871),
    [anon_sym___stdcall] = ACTIONS(2871),
    [anon_sym___fastcall] = ACTIONS(2871),
    [anon_sym___thiscall] = ACTIONS(2871),
    [anon_sym___vectorcall] = ACTIONS(2871),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_signed] = ACTIONS(2871),
    [anon_sym_unsigned] = ACTIONS(2871),
    [anon_sym_long] = ACTIONS(2871),
    [anon_sym_short] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_static] = ACTIONS(2871),
    [anon_sym_register] = ACTIONS(2871),
    [anon_sym_inline] = ACTIONS(2871),
    [anon_sym___inline] = ACTIONS(2871),
    [anon_sym___inline__] = ACTIONS(2871),
    [anon_sym___forceinline] = ACTIONS(2871),
    [anon_sym_thread_local] = ACTIONS(2871),
    [anon_sym___thread] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_constexpr] = ACTIONS(2871),
    [anon_sym_volatile] = ACTIONS(2871),
    [anon_sym_restrict] = ACTIONS(2871),
    [anon_sym___restrict__] = ACTIONS(2871),
    [anon_sym__Atomic] = ACTIONS(2871),
    [anon_sym__Noreturn] = ACTIONS(2871),
    [anon_sym_noreturn] = ACTIONS(2871),
    [anon_sym__Nonnull] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_constinit] = ACTIONS(2871),
    [anon_sym_consteval] = ACTIONS(2871),
    [anon_sym_alignas] = ACTIONS(2871),
    [anon_sym__Alignas] = ACTIONS(2871),
    [sym_primitive_type] = ACTIONS(2871),
    [anon_sym_enum] = ACTIONS(2871),
    [anon_sym_class] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_union] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_switch] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(2871),
    [anon_sym_default] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [anon_sym_do] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_break] = ACTIONS(2871),
    [anon_sym_continue] = ACTIONS(2871),
    [anon_sym_goto] = ACTIONS(2871),
    [anon_sym___try] = ACTIONS(2871),
    [anon_sym___leave] = ACTIONS(2871),
    [anon_sym_not] = ACTIONS(2871),
    [anon_sym_compl] = ACTIONS(2871),
    [anon_sym_DASH_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2873),
    [anon_sym_sizeof] = ACTIONS(2871),
    [anon_sym___alignof__] = ACTIONS(2871),
    [anon_sym___alignof] = ACTIONS(2871),
    [anon_sym__alignof] = ACTIONS(2871),
    [anon_sym_alignof] = ACTIONS(2871),
    [anon_sym__Alignof] = ACTIONS(2871),
    [anon_sym_offsetof] = ACTIONS(2871),
    [anon_sym__Generic] = ACTIONS(2871),
    [anon_sym_asm] = ACTIONS(2871),
    [anon_sym___asm__] = ACTIONS(2871),
    [anon_sym___asm] = ACTIONS(2871),
    [sym_number_literal] = ACTIONS(2873),
    [anon_sym_L_SQUOTE] = ACTIONS(2873),
    [anon_sym_u_SQUOTE] = ACTIONS(2873),
    [anon_sym_U_SQUOTE] = ACTIONS(2873),
    [anon_sym_u8_SQUOTE] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_L_DQUOTE] = ACTIONS(2873),
    [anon_sym_u_DQUOTE] = ACTIONS(2873),
    [anon_sym_U_DQUOTE] = ACTIONS(2873),
    [anon_sym_u8_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [sym_true] = ACTIONS(2871),
    [sym_false] = ACTIONS(2871),
    [anon_sym_NULL] = ACTIONS(2871),
    [anon_sym_nullptr] = ACTIONS(2871),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2871),
    [anon_sym_decltype] = ACTIONS(2871),
    [anon_sym_explicit] = ACTIONS(2871),
    [anon_sym_typename] = ACTIONS(2871),
    [anon_sym_template] = ACTIONS(2871),
    [anon_sym_operator] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_delete] = ACTIONS(2871),
    [anon_sym_throw] = ACTIONS(2871),
    [anon_sym_namespace] = ACTIONS(2871),
    [anon_sym_static_assert] = ACTIONS(2871),
    [anon_sym_concept] = ACTIONS(2871),
    [anon_sym_co_return] = ACTIONS(2871),
    [anon_sym_co_yield] = ACTIONS(2871),
    [anon_sym_R_DQUOTE] = ACTIONS(2873),
    [anon_sym_LR_DQUOTE] = ACTIONS(2873),
    [anon_sym_uR_DQUOTE] = ACTIONS(2873),
    [anon_sym_UR_DQUOTE] = ACTIONS(2873),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2873),
    [anon_sym_co_await] = ACTIONS(2871),
    [anon_sym_new] = ACTIONS(2871),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2871),
  },
  [665] = {
    [sym_identifier] = ACTIONS(2875),
    [aux_sym_preproc_include_token1] = ACTIONS(2875),
    [aux_sym_preproc_def_token1] = ACTIONS(2875),
    [aux_sym_preproc_if_token1] = ACTIONS(2875),
    [aux_sym_preproc_if_token2] = ACTIONS(2875),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2875),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2875),
    [sym_preproc_directive] = ACTIONS(2875),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2875),
    [anon_sym_typedef] = ACTIONS(2875),
    [anon_sym_virtual] = ACTIONS(2875),
    [anon_sym_extern] = ACTIONS(2875),
    [anon_sym___attribute__] = ACTIONS(2875),
    [anon_sym___attribute] = ACTIONS(2875),
    [anon_sym_using] = ACTIONS(2875),
    [anon_sym_COLON_COLON] = ACTIONS(2877),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2877),
    [anon_sym___declspec] = ACTIONS(2875),
    [anon_sym___based] = ACTIONS(2875),
    [anon_sym___cdecl] = ACTIONS(2875),
    [anon_sym___clrcall] = ACTIONS(2875),
    [anon_sym___stdcall] = ACTIONS(2875),
    [anon_sym___fastcall] = ACTIONS(2875),
    [anon_sym___thiscall] = ACTIONS(2875),
    [anon_sym___vectorcall] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_signed] = ACTIONS(2875),
    [anon_sym_unsigned] = ACTIONS(2875),
    [anon_sym_long] = ACTIONS(2875),
    [anon_sym_short] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_static] = ACTIONS(2875),
    [anon_sym_register] = ACTIONS(2875),
    [anon_sym_inline] = ACTIONS(2875),
    [anon_sym___inline] = ACTIONS(2875),
    [anon_sym___inline__] = ACTIONS(2875),
    [anon_sym___forceinline] = ACTIONS(2875),
    [anon_sym_thread_local] = ACTIONS(2875),
    [anon_sym___thread] = ACTIONS(2875),
    [anon_sym_const] = ACTIONS(2875),
    [anon_sym_constexpr] = ACTIONS(2875),
    [anon_sym_volatile] = ACTIONS(2875),
    [anon_sym_restrict] = ACTIONS(2875),
    [anon_sym___restrict__] = ACTIONS(2875),
    [anon_sym__Atomic] = ACTIONS(2875),
    [anon_sym__Noreturn] = ACTIONS(2875),
    [anon_sym_noreturn] = ACTIONS(2875),
    [anon_sym__Nonnull] = ACTIONS(2875),
    [anon_sym_mutable] = ACTIONS(2875),
    [anon_sym_constinit] = ACTIONS(2875),
    [anon_sym_consteval] = ACTIONS(2875),
    [anon_sym_alignas] = ACTIONS(2875),
    [anon_sym__Alignas] = ACTIONS(2875),
    [sym_primitive_type] = ACTIONS(2875),
    [anon_sym_enum] = ACTIONS(2875),
    [anon_sym_class] = ACTIONS(2875),
    [anon_sym_struct] = ACTIONS(2875),
    [anon_sym_union] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_switch] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_default] = ACTIONS(2875),
    [anon_sym_while] = ACTIONS(2875),
    [anon_sym_do] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2875),
    [anon_sym_return] = ACTIONS(2875),
    [anon_sym_break] = ACTIONS(2875),
    [anon_sym_continue] = ACTIONS(2875),
    [anon_sym_goto] = ACTIONS(2875),
    [anon_sym___try] = ACTIONS(2875),
    [anon_sym___leave] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2875),
    [anon_sym_compl] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_sizeof] = ACTIONS(2875),
    [anon_sym___alignof__] = ACTIONS(2875),
    [anon_sym___alignof] = ACTIONS(2875),
    [anon_sym__alignof] = ACTIONS(2875),
    [anon_sym_alignof] = ACTIONS(2875),
    [anon_sym__Alignof] = ACTIONS(2875),
    [anon_sym_offsetof] = ACTIONS(2875),
    [anon_sym__Generic] = ACTIONS(2875),
    [anon_sym_asm] = ACTIONS(2875),
    [anon_sym___asm__] = ACTIONS(2875),
    [anon_sym___asm] = ACTIONS(2875),
    [sym_number_literal] = ACTIONS(2877),
    [anon_sym_L_SQUOTE] = ACTIONS(2877),
    [anon_sym_u_SQUOTE] = ACTIONS(2877),
    [anon_sym_U_SQUOTE] = ACTIONS(2877),
    [anon_sym_u8_SQUOTE] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_L_DQUOTE] = ACTIONS(2877),
    [anon_sym_u_DQUOTE] = ACTIONS(2877),
    [anon_sym_U_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [sym_true] = ACTIONS(2875),
    [sym_false] = ACTIONS(2875),
    [anon_sym_NULL] = ACTIONS(2875),
    [anon_sym_nullptr] = ACTIONS(2875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2875),
    [anon_sym_decltype] = ACTIONS(2875),
    [anon_sym_explicit] = ACTIONS(2875),
    [anon_sym_typename] = ACTIONS(2875),
    [anon_sym_template] = ACTIONS(2875),
    [anon_sym_operator] = ACTIONS(2875),
    [anon_sym_try] = ACTIONS(2875),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_throw] = ACTIONS(2875),
    [anon_sym_namespace] = ACTIONS(2875),
    [anon_sym_static_assert] = ACTIONS(2875),
    [anon_sym_concept] = ACTIONS(2875),
    [anon_sym_co_return] = ACTIONS(2875),
    [anon_sym_co_yield] = ACTIONS(2875),
    [anon_sym_R_DQUOTE] = ACTIONS(2877),
    [anon_sym_LR_DQUOTE] = ACTIONS(2877),
    [anon_sym_uR_DQUOTE] = ACTIONS(2877),
    [anon_sym_UR_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2877),
    [anon_sym_co_await] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2875),
    [anon_sym_requires] = ACTIONS(2875),
    [sym_this] = ACTIONS(2875),
  },
  [666] = {
    [sym_identifier] = ACTIONS(2879),
    [aux_sym_preproc_include_token1] = ACTIONS(2879),
    [aux_sym_preproc_def_token1] = ACTIONS(2879),
    [aux_sym_preproc_if_token1] = ACTIONS(2879),
    [aux_sym_preproc_if_token2] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2879),
    [sym_preproc_directive] = ACTIONS(2879),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2879),
    [anon_sym_typedef] = ACTIONS(2879),
    [anon_sym_virtual] = ACTIONS(2879),
    [anon_sym_extern] = ACTIONS(2879),
    [anon_sym___attribute__] = ACTIONS(2879),
    [anon_sym___attribute] = ACTIONS(2879),
    [anon_sym_using] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2879),
    [anon_sym___based] = ACTIONS(2879),
    [anon_sym___cdecl] = ACTIONS(2879),
    [anon_sym___clrcall] = ACTIONS(2879),
    [anon_sym___stdcall] = ACTIONS(2879),
    [anon_sym___fastcall] = ACTIONS(2879),
    [anon_sym___thiscall] = ACTIONS(2879),
    [anon_sym___vectorcall] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2879),
    [anon_sym_unsigned] = ACTIONS(2879),
    [anon_sym_long] = ACTIONS(2879),
    [anon_sym_short] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_static] = ACTIONS(2879),
    [anon_sym_register] = ACTIONS(2879),
    [anon_sym_inline] = ACTIONS(2879),
    [anon_sym___inline] = ACTIONS(2879),
    [anon_sym___inline__] = ACTIONS(2879),
    [anon_sym___forceinline] = ACTIONS(2879),
    [anon_sym_thread_local] = ACTIONS(2879),
    [anon_sym___thread] = ACTIONS(2879),
    [anon_sym_const] = ACTIONS(2879),
    [anon_sym_constexpr] = ACTIONS(2879),
    [anon_sym_volatile] = ACTIONS(2879),
    [anon_sym_restrict] = ACTIONS(2879),
    [anon_sym___restrict__] = ACTIONS(2879),
    [anon_sym__Atomic] = ACTIONS(2879),
    [anon_sym__Noreturn] = ACTIONS(2879),
    [anon_sym_noreturn] = ACTIONS(2879),
    [anon_sym__Nonnull] = ACTIONS(2879),
    [anon_sym_mutable] = ACTIONS(2879),
    [anon_sym_constinit] = ACTIONS(2879),
    [anon_sym_consteval] = ACTIONS(2879),
    [anon_sym_alignas] = ACTIONS(2879),
    [anon_sym__Alignas] = ACTIONS(2879),
    [sym_primitive_type] = ACTIONS(2879),
    [anon_sym_enum] = ACTIONS(2879),
    [anon_sym_class] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2879),
    [anon_sym_union] = ACTIONS(2879),
    [anon_sym_if] = ACTIONS(2879),
    [anon_sym_switch] = ACTIONS(2879),
    [anon_sym_case] = ACTIONS(2879),
    [anon_sym_default] = ACTIONS(2879),
    [anon_sym_while] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2879),
    [anon_sym_return] = ACTIONS(2879),
    [anon_sym_break] = ACTIONS(2879),
    [anon_sym_continue] = ACTIONS(2879),
    [anon_sym_goto] = ACTIONS(2879),
    [anon_sym___try] = ACTIONS(2879),
    [anon_sym___leave] = ACTIONS(2879),
    [anon_sym_not] = ACTIONS(2879),
    [anon_sym_compl] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2879),
    [anon_sym___alignof__] = ACTIONS(2879),
    [anon_sym___alignof] = ACTIONS(2879),
    [anon_sym__alignof] = ACTIONS(2879),
    [anon_sym_alignof] = ACTIONS(2879),
    [anon_sym__Alignof] = ACTIONS(2879),
    [anon_sym_offsetof] = ACTIONS(2879),
    [anon_sym__Generic] = ACTIONS(2879),
    [anon_sym_asm] = ACTIONS(2879),
    [anon_sym___asm__] = ACTIONS(2879),
    [anon_sym___asm] = ACTIONS(2879),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2879),
    [sym_false] = ACTIONS(2879),
    [anon_sym_NULL] = ACTIONS(2879),
    [anon_sym_nullptr] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2879),
    [anon_sym_decltype] = ACTIONS(2879),
    [anon_sym_explicit] = ACTIONS(2879),
    [anon_sym_typename] = ACTIONS(2879),
    [anon_sym_template] = ACTIONS(2879),
    [anon_sym_operator] = ACTIONS(2879),
    [anon_sym_try] = ACTIONS(2879),
    [anon_sym_delete] = ACTIONS(2879),
    [anon_sym_throw] = ACTIONS(2879),
    [anon_sym_namespace] = ACTIONS(2879),
    [anon_sym_static_assert] = ACTIONS(2879),
    [anon_sym_concept] = ACTIONS(2879),
    [anon_sym_co_return] = ACTIONS(2879),
    [anon_sym_co_yield] = ACTIONS(2879),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2879),
    [anon_sym_requires] = ACTIONS(2879),
    [sym_this] = ACTIONS(2879),
  },
  [667] = {
    [sym_identifier] = ACTIONS(2867),
    [aux_sym_preproc_include_token1] = ACTIONS(2867),
    [aux_sym_preproc_def_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token1] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2867),
    [sym_preproc_directive] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2869),
    [anon_sym_BANG] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2869),
    [anon_sym___extension__] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2867),
    [anon_sym_virtual] = ACTIONS(2867),
    [anon_sym_extern] = ACTIONS(2867),
    [anon_sym___attribute__] = ACTIONS(2867),
    [anon_sym___attribute] = ACTIONS(2867),
    [anon_sym_using] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2869),
    [anon_sym___declspec] = ACTIONS(2867),
    [anon_sym___based] = ACTIONS(2867),
    [anon_sym___cdecl] = ACTIONS(2867),
    [anon_sym___clrcall] = ACTIONS(2867),
    [anon_sym___stdcall] = ACTIONS(2867),
    [anon_sym___fastcall] = ACTIONS(2867),
    [anon_sym___thiscall] = ACTIONS(2867),
    [anon_sym___vectorcall] = ACTIONS(2867),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [anon_sym_signed] = ACTIONS(2867),
    [anon_sym_unsigned] = ACTIONS(2867),
    [anon_sym_long] = ACTIONS(2867),
    [anon_sym_short] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2867),
    [anon_sym_register] = ACTIONS(2867),
    [anon_sym_inline] = ACTIONS(2867),
    [anon_sym___inline] = ACTIONS(2867),
    [anon_sym___inline__] = ACTIONS(2867),
    [anon_sym___forceinline] = ACTIONS(2867),
    [anon_sym_thread_local] = ACTIONS(2867),
    [anon_sym___thread] = ACTIONS(2867),
    [anon_sym_const] = ACTIONS(2867),
    [anon_sym_constexpr] = ACTIONS(2867),
    [anon_sym_volatile] = ACTIONS(2867),
    [anon_sym_restrict] = ACTIONS(2867),
    [anon_sym___restrict__] = ACTIONS(2867),
    [anon_sym__Atomic] = ACTIONS(2867),
    [anon_sym__Noreturn] = ACTIONS(2867),
    [anon_sym_noreturn] = ACTIONS(2867),
    [anon_sym__Nonnull] = ACTIONS(2867),
    [anon_sym_mutable] = ACTIONS(2867),
    [anon_sym_constinit] = ACTIONS(2867),
    [anon_sym_consteval] = ACTIONS(2867),
    [anon_sym_alignas] = ACTIONS(2867),
    [anon_sym__Alignas] = ACTIONS(2867),
    [sym_primitive_type] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2867),
    [anon_sym_class] = ACTIONS(2867),
    [anon_sym_struct] = ACTIONS(2867),
    [anon_sym_union] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_switch] = ACTIONS(2867),
    [anon_sym_case] = ACTIONS(2867),
    [anon_sym_default] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_continue] = ACTIONS(2867),
    [anon_sym_goto] = ACTIONS(2867),
    [anon_sym___try] = ACTIONS(2867),
    [anon_sym___leave] = ACTIONS(2867),
    [anon_sym_not] = ACTIONS(2867),
    [anon_sym_compl] = ACTIONS(2867),
    [anon_sym_DASH_DASH] = ACTIONS(2869),
    [anon_sym_PLUS_PLUS] = ACTIONS(2869),
    [anon_sym_sizeof] = ACTIONS(2867),
    [anon_sym___alignof__] = ACTIONS(2867),
    [anon_sym___alignof] = ACTIONS(2867),
    [anon_sym__alignof] = ACTIONS(2867),
    [anon_sym_alignof] = ACTIONS(2867),
    [anon_sym__Alignof] = ACTIONS(2867),
    [anon_sym_offsetof] = ACTIONS(2867),
    [anon_sym__Generic] = ACTIONS(2867),
    [anon_sym_asm] = ACTIONS(2867),
    [anon_sym___asm__] = ACTIONS(2867),
    [anon_sym___asm] = ACTIONS(2867),
    [sym_number_literal] = ACTIONS(2869),
    [anon_sym_L_SQUOTE] = ACTIONS(2869),
    [anon_sym_u_SQUOTE] = ACTIONS(2869),
    [anon_sym_U_SQUOTE] = ACTIONS(2869),
    [anon_sym_u8_SQUOTE] = ACTIONS(2869),
    [anon_sym_SQUOTE] = ACTIONS(2869),
    [anon_sym_L_DQUOTE] = ACTIONS(2869),
    [anon_sym_u_DQUOTE] = ACTIONS(2869),
    [anon_sym_U_DQUOTE] = ACTIONS(2869),
    [anon_sym_u8_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [sym_true] = ACTIONS(2867),
    [sym_false] = ACTIONS(2867),
    [anon_sym_NULL] = ACTIONS(2867),
    [anon_sym_nullptr] = ACTIONS(2867),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2867),
    [anon_sym_decltype] = ACTIONS(2867),
    [anon_sym_explicit] = ACTIONS(2867),
    [anon_sym_typename] = ACTIONS(2867),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_delete] = ACTIONS(2867),
    [anon_sym_throw] = ACTIONS(2867),
    [anon_sym_namespace] = ACTIONS(2867),
    [anon_sym_static_assert] = ACTIONS(2867),
    [anon_sym_concept] = ACTIONS(2867),
    [anon_sym_co_return] = ACTIONS(2867),
    [anon_sym_co_yield] = ACTIONS(2867),
    [anon_sym_R_DQUOTE] = ACTIONS(2869),
    [anon_sym_LR_DQUOTE] = ACTIONS(2869),
    [anon_sym_uR_DQUOTE] = ACTIONS(2869),
    [anon_sym_UR_DQUOTE] = ACTIONS(2869),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2869),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_requires] = ACTIONS(2867),
    [sym_this] = ACTIONS(2867),
  },
  [668] = {
    [sym_identifier] = ACTIONS(2871),
    [aux_sym_preproc_include_token1] = ACTIONS(2871),
    [aux_sym_preproc_def_token1] = ACTIONS(2871),
    [aux_sym_preproc_if_token1] = ACTIONS(2871),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2871),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2871),
    [sym_preproc_directive] = ACTIONS(2871),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym___extension__] = ACTIONS(2871),
    [anon_sym_typedef] = ACTIONS(2871),
    [anon_sym_virtual] = ACTIONS(2871),
    [anon_sym_extern] = ACTIONS(2871),
    [anon_sym___attribute__] = ACTIONS(2871),
    [anon_sym___attribute] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2873),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2873),
    [anon_sym___declspec] = ACTIONS(2871),
    [anon_sym___based] = ACTIONS(2871),
    [anon_sym___cdecl] = ACTIONS(2871),
    [anon_sym___clrcall] = ACTIONS(2871),
    [anon_sym___stdcall] = ACTIONS(2871),
    [anon_sym___fastcall] = ACTIONS(2871),
    [anon_sym___thiscall] = ACTIONS(2871),
    [anon_sym___vectorcall] = ACTIONS(2871),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_signed] = ACTIONS(2871),
    [anon_sym_unsigned] = ACTIONS(2871),
    [anon_sym_long] = ACTIONS(2871),
    [anon_sym_short] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_static] = ACTIONS(2871),
    [anon_sym_register] = ACTIONS(2871),
    [anon_sym_inline] = ACTIONS(2871),
    [anon_sym___inline] = ACTIONS(2871),
    [anon_sym___inline__] = ACTIONS(2871),
    [anon_sym___forceinline] = ACTIONS(2871),
    [anon_sym_thread_local] = ACTIONS(2871),
    [anon_sym___thread] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_constexpr] = ACTIONS(2871),
    [anon_sym_volatile] = ACTIONS(2871),
    [anon_sym_restrict] = ACTIONS(2871),
    [anon_sym___restrict__] = ACTIONS(2871),
    [anon_sym__Atomic] = ACTIONS(2871),
    [anon_sym__Noreturn] = ACTIONS(2871),
    [anon_sym_noreturn] = ACTIONS(2871),
    [anon_sym__Nonnull] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_constinit] = ACTIONS(2871),
    [anon_sym_consteval] = ACTIONS(2871),
    [anon_sym_alignas] = ACTIONS(2871),
    [anon_sym__Alignas] = ACTIONS(2871),
    [sym_primitive_type] = ACTIONS(2871),
    [anon_sym_enum] = ACTIONS(2871),
    [anon_sym_class] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_union] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_switch] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(2871),
    [anon_sym_default] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [anon_sym_do] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_break] = ACTIONS(2871),
    [anon_sym_continue] = ACTIONS(2871),
    [anon_sym_goto] = ACTIONS(2871),
    [anon_sym___try] = ACTIONS(2871),
    [anon_sym___leave] = ACTIONS(2871),
    [anon_sym_not] = ACTIONS(2871),
    [anon_sym_compl] = ACTIONS(2871),
    [anon_sym_DASH_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2873),
    [anon_sym_sizeof] = ACTIONS(2871),
    [anon_sym___alignof__] = ACTIONS(2871),
    [anon_sym___alignof] = ACTIONS(2871),
    [anon_sym__alignof] = ACTIONS(2871),
    [anon_sym_alignof] = ACTIONS(2871),
    [anon_sym__Alignof] = ACTIONS(2871),
    [anon_sym_offsetof] = ACTIONS(2871),
    [anon_sym__Generic] = ACTIONS(2871),
    [anon_sym_asm] = ACTIONS(2871),
    [anon_sym___asm__] = ACTIONS(2871),
    [anon_sym___asm] = ACTIONS(2871),
    [sym_number_literal] = ACTIONS(2873),
    [anon_sym_L_SQUOTE] = ACTIONS(2873),
    [anon_sym_u_SQUOTE] = ACTIONS(2873),
    [anon_sym_U_SQUOTE] = ACTIONS(2873),
    [anon_sym_u8_SQUOTE] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_L_DQUOTE] = ACTIONS(2873),
    [anon_sym_u_DQUOTE] = ACTIONS(2873),
    [anon_sym_U_DQUOTE] = ACTIONS(2873),
    [anon_sym_u8_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [sym_true] = ACTIONS(2871),
    [sym_false] = ACTIONS(2871),
    [anon_sym_NULL] = ACTIONS(2871),
    [anon_sym_nullptr] = ACTIONS(2871),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2871),
    [anon_sym_decltype] = ACTIONS(2871),
    [anon_sym_explicit] = ACTIONS(2871),
    [anon_sym_typename] = ACTIONS(2871),
    [anon_sym_template] = ACTIONS(2871),
    [anon_sym_operator] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_delete] = ACTIONS(2871),
    [anon_sym_throw] = ACTIONS(2871),
    [anon_sym_namespace] = ACTIONS(2871),
    [anon_sym_static_assert] = ACTIONS(2871),
    [anon_sym_concept] = ACTIONS(2871),
    [anon_sym_co_return] = ACTIONS(2871),
    [anon_sym_co_yield] = ACTIONS(2871),
    [anon_sym_R_DQUOTE] = ACTIONS(2873),
    [anon_sym_LR_DQUOTE] = ACTIONS(2873),
    [anon_sym_uR_DQUOTE] = ACTIONS(2873),
    [anon_sym_UR_DQUOTE] = ACTIONS(2873),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2873),
    [anon_sym_co_await] = ACTIONS(2871),
    [anon_sym_new] = ACTIONS(2871),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2871),
  },
  [669] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_include_token1] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token2] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym___attribute] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym___cdecl] = ACTIONS(2887),
    [anon_sym___clrcall] = ACTIONS(2887),
    [anon_sym___stdcall] = ACTIONS(2887),
    [anon_sym___fastcall] = ACTIONS(2887),
    [anon_sym___thiscall] = ACTIONS(2887),
    [anon_sym___vectorcall] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym__Nonnull] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym__Alignas] = ACTIONS(2887),
    [sym_primitive_type] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2887),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_goto] = ACTIONS(2887),
    [anon_sym___try] = ACTIONS(2887),
    [anon_sym___leave] = ACTIONS(2887),
    [anon_sym_not] = ACTIONS(2887),
    [anon_sym_compl] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_sizeof] = ACTIONS(2887),
    [anon_sym___alignof__] = ACTIONS(2887),
    [anon_sym___alignof] = ACTIONS(2887),
    [anon_sym__alignof] = ACTIONS(2887),
    [anon_sym_alignof] = ACTIONS(2887),
    [anon_sym__Alignof] = ACTIONS(2887),
    [anon_sym_offsetof] = ACTIONS(2887),
    [anon_sym__Generic] = ACTIONS(2887),
    [anon_sym_asm] = ACTIONS(2887),
    [anon_sym___asm__] = ACTIONS(2887),
    [anon_sym___asm] = ACTIONS(2887),
    [sym_number_literal] = ACTIONS(2889),
    [anon_sym_L_SQUOTE] = ACTIONS(2889),
    [anon_sym_u_SQUOTE] = ACTIONS(2889),
    [anon_sym_U_SQUOTE] = ACTIONS(2889),
    [anon_sym_u8_SQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_L_DQUOTE] = ACTIONS(2889),
    [anon_sym_u_DQUOTE] = ACTIONS(2889),
    [anon_sym_U_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [anon_sym_NULL] = ACTIONS(2887),
    [anon_sym_nullptr] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_namespace] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_concept] = ACTIONS(2887),
    [anon_sym_co_return] = ACTIONS(2887),
    [anon_sym_co_yield] = ACTIONS(2887),
    [anon_sym_R_DQUOTE] = ACTIONS(2889),
    [anon_sym_LR_DQUOTE] = ACTIONS(2889),
    [anon_sym_uR_DQUOTE] = ACTIONS(2889),
    [anon_sym_UR_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2889),
    [anon_sym_co_await] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_requires] = ACTIONS(2887),
    [sym_this] = ACTIONS(2887),
  },
  [670] = {
    [sym_identifier] = ACTIONS(2891),
    [aux_sym_preproc_include_token1] = ACTIONS(2891),
    [aux_sym_preproc_def_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token2] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2891),
    [sym_preproc_directive] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2891),
    [anon_sym_typedef] = ACTIONS(2891),
    [anon_sym_virtual] = ACTIONS(2891),
    [anon_sym_extern] = ACTIONS(2891),
    [anon_sym___attribute__] = ACTIONS(2891),
    [anon_sym___attribute] = ACTIONS(2891),
    [anon_sym_using] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2893),
    [anon_sym___declspec] = ACTIONS(2891),
    [anon_sym___based] = ACTIONS(2891),
    [anon_sym___cdecl] = ACTIONS(2891),
    [anon_sym___clrcall] = ACTIONS(2891),
    [anon_sym___stdcall] = ACTIONS(2891),
    [anon_sym___fastcall] = ACTIONS(2891),
    [anon_sym___thiscall] = ACTIONS(2891),
    [anon_sym___vectorcall] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2891),
    [anon_sym_unsigned] = ACTIONS(2891),
    [anon_sym_long] = ACTIONS(2891),
    [anon_sym_short] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_register] = ACTIONS(2891),
    [anon_sym_inline] = ACTIONS(2891),
    [anon_sym___inline] = ACTIONS(2891),
    [anon_sym___inline__] = ACTIONS(2891),
    [anon_sym___forceinline] = ACTIONS(2891),
    [anon_sym_thread_local] = ACTIONS(2891),
    [anon_sym___thread] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_constexpr] = ACTIONS(2891),
    [anon_sym_volatile] = ACTIONS(2891),
    [anon_sym_restrict] = ACTIONS(2891),
    [anon_sym___restrict__] = ACTIONS(2891),
    [anon_sym__Atomic] = ACTIONS(2891),
    [anon_sym__Noreturn] = ACTIONS(2891),
    [anon_sym_noreturn] = ACTIONS(2891),
    [anon_sym__Nonnull] = ACTIONS(2891),
    [anon_sym_mutable] = ACTIONS(2891),
    [anon_sym_constinit] = ACTIONS(2891),
    [anon_sym_consteval] = ACTIONS(2891),
    [anon_sym_alignas] = ACTIONS(2891),
    [anon_sym__Alignas] = ACTIONS(2891),
    [sym_primitive_type] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2891),
    [anon_sym_union] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_goto] = ACTIONS(2891),
    [anon_sym___try] = ACTIONS(2891),
    [anon_sym___leave] = ACTIONS(2891),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_compl] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_sizeof] = ACTIONS(2891),
    [anon_sym___alignof__] = ACTIONS(2891),
    [anon_sym___alignof] = ACTIONS(2891),
    [anon_sym__alignof] = ACTIONS(2891),
    [anon_sym_alignof] = ACTIONS(2891),
    [anon_sym__Alignof] = ACTIONS(2891),
    [anon_sym_offsetof] = ACTIONS(2891),
    [anon_sym__Generic] = ACTIONS(2891),
    [anon_sym_asm] = ACTIONS(2891),
    [anon_sym___asm__] = ACTIONS(2891),
    [anon_sym___asm] = ACTIONS(2891),
    [sym_number_literal] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2893),
    [anon_sym_u_SQUOTE] = ACTIONS(2893),
    [anon_sym_U_SQUOTE] = ACTIONS(2893),
    [anon_sym_u8_SQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_L_DQUOTE] = ACTIONS(2893),
    [anon_sym_u_DQUOTE] = ACTIONS(2893),
    [anon_sym_U_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [anon_sym_NULL] = ACTIONS(2891),
    [anon_sym_nullptr] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2891),
    [anon_sym_decltype] = ACTIONS(2891),
    [anon_sym_explicit] = ACTIONS(2891),
    [anon_sym_typename] = ACTIONS(2891),
    [anon_sym_template] = ACTIONS(2891),
    [anon_sym_operator] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_static_assert] = ACTIONS(2891),
    [anon_sym_concept] = ACTIONS(2891),
    [anon_sym_co_return] = ACTIONS(2891),
    [anon_sym_co_yield] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2893),
    [anon_sym_LR_DQUOTE] = ACTIONS(2893),
    [anon_sym_uR_DQUOTE] = ACTIONS(2893),
    [anon_sym_UR_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2893),
    [anon_sym_co_await] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_requires] = ACTIONS(2891),
    [sym_this] = ACTIONS(2891),
  },
  [671] = {
    [sym_identifier] = ACTIONS(2895),
    [aux_sym_preproc_include_token1] = ACTIONS(2895),
    [aux_sym_preproc_def_token1] = ACTIONS(2895),
    [aux_sym_preproc_if_token1] = ACTIONS(2895),
    [aux_sym_preproc_if_token2] = ACTIONS(2895),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2895),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym___extension__] = ACTIONS(2895),
    [anon_sym_typedef] = ACTIONS(2895),
    [anon_sym_virtual] = ACTIONS(2895),
    [anon_sym_extern] = ACTIONS(2895),
    [anon_sym___attribute__] = ACTIONS(2895),
    [anon_sym___attribute] = ACTIONS(2895),
    [anon_sym_using] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2897),
    [anon_sym___declspec] = ACTIONS(2895),
    [anon_sym___based] = ACTIONS(2895),
    [anon_sym___cdecl] = ACTIONS(2895),
    [anon_sym___clrcall] = ACTIONS(2895),
    [anon_sym___stdcall] = ACTIONS(2895),
    [anon_sym___fastcall] = ACTIONS(2895),
    [anon_sym___thiscall] = ACTIONS(2895),
    [anon_sym___vectorcall] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_signed] = ACTIONS(2895),
    [anon_sym_unsigned] = ACTIONS(2895),
    [anon_sym_long] = ACTIONS(2895),
    [anon_sym_short] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2895),
    [anon_sym_register] = ACTIONS(2895),
    [anon_sym_inline] = ACTIONS(2895),
    [anon_sym___inline] = ACTIONS(2895),
    [anon_sym___inline__] = ACTIONS(2895),
    [anon_sym___forceinline] = ACTIONS(2895),
    [anon_sym_thread_local] = ACTIONS(2895),
    [anon_sym___thread] = ACTIONS(2895),
    [anon_sym_const] = ACTIONS(2895),
    [anon_sym_constexpr] = ACTIONS(2895),
    [anon_sym_volatile] = ACTIONS(2895),
    [anon_sym_restrict] = ACTIONS(2895),
    [anon_sym___restrict__] = ACTIONS(2895),
    [anon_sym__Atomic] = ACTIONS(2895),
    [anon_sym__Noreturn] = ACTIONS(2895),
    [anon_sym_noreturn] = ACTIONS(2895),
    [anon_sym__Nonnull] = ACTIONS(2895),
    [anon_sym_mutable] = ACTIONS(2895),
    [anon_sym_constinit] = ACTIONS(2895),
    [anon_sym_consteval] = ACTIONS(2895),
    [anon_sym_alignas] = ACTIONS(2895),
    [anon_sym__Alignas] = ACTIONS(2895),
    [sym_primitive_type] = ACTIONS(2895),
    [anon_sym_enum] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2895),
    [anon_sym_struct] = ACTIONS(2895),
    [anon_sym_union] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_switch] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2895),
    [anon_sym_default] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_break] = ACTIONS(2895),
    [anon_sym_continue] = ACTIONS(2895),
    [anon_sym_goto] = ACTIONS(2895),
    [anon_sym___try] = ACTIONS(2895),
    [anon_sym___leave] = ACTIONS(2895),
    [anon_sym_not] = ACTIONS(2895),
    [anon_sym_compl] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_sizeof] = ACTIONS(2895),
    [anon_sym___alignof__] = ACTIONS(2895),
    [anon_sym___alignof] = ACTIONS(2895),
    [anon_sym__alignof] = ACTIONS(2895),
    [anon_sym_alignof] = ACTIONS(2895),
    [anon_sym__Alignof] = ACTIONS(2895),
    [anon_sym_offsetof] = ACTIONS(2895),
    [anon_sym__Generic] = ACTIONS(2895),
    [anon_sym_asm] = ACTIONS(2895),
    [anon_sym___asm__] = ACTIONS(2895),
    [anon_sym___asm] = ACTIONS(2895),
    [sym_number_literal] = ACTIONS(2897),
    [anon_sym_L_SQUOTE] = ACTIONS(2897),
    [anon_sym_u_SQUOTE] = ACTIONS(2897),
    [anon_sym_U_SQUOTE] = ACTIONS(2897),
    [anon_sym_u8_SQUOTE] = ACTIONS(2897),
    [anon_sym_SQUOTE] = ACTIONS(2897),
    [anon_sym_L_DQUOTE] = ACTIONS(2897),
    [anon_sym_u_DQUOTE] = ACTIONS(2897),
    [anon_sym_U_DQUOTE] = ACTIONS(2897),
    [anon_sym_u8_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [sym_true] = ACTIONS(2895),
    [sym_false] = ACTIONS(2895),
    [anon_sym_NULL] = ACTIONS(2895),
    [anon_sym_nullptr] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2895),
    [anon_sym_decltype] = ACTIONS(2895),
    [anon_sym_explicit] = ACTIONS(2895),
    [anon_sym_typename] = ACTIONS(2895),
    [anon_sym_template] = ACTIONS(2895),
    [anon_sym_operator] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_delete] = ACTIONS(2895),
    [anon_sym_throw] = ACTIONS(2895),
    [anon_sym_namespace] = ACTIONS(2895),
    [anon_sym_static_assert] = ACTIONS(2895),
    [anon_sym_concept] = ACTIONS(2895),
    [anon_sym_co_return] = ACTIONS(2895),
    [anon_sym_co_yield] = ACTIONS(2895),
    [anon_sym_R_DQUOTE] = ACTIONS(2897),
    [anon_sym_LR_DQUOTE] = ACTIONS(2897),
    [anon_sym_uR_DQUOTE] = ACTIONS(2897),
    [anon_sym_UR_DQUOTE] = ACTIONS(2897),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2897),
    [anon_sym_co_await] = ACTIONS(2895),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_requires] = ACTIONS(2895),
    [sym_this] = ACTIONS(2895),
  },
  [672] = {
    [sym_identifier] = ACTIONS(2875),
    [aux_sym_preproc_include_token1] = ACTIONS(2875),
    [aux_sym_preproc_def_token1] = ACTIONS(2875),
    [aux_sym_preproc_if_token1] = ACTIONS(2875),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2875),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2875),
    [sym_preproc_directive] = ACTIONS(2875),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2875),
    [anon_sym_typedef] = ACTIONS(2875),
    [anon_sym_virtual] = ACTIONS(2875),
    [anon_sym_extern] = ACTIONS(2875),
    [anon_sym___attribute__] = ACTIONS(2875),
    [anon_sym___attribute] = ACTIONS(2875),
    [anon_sym_using] = ACTIONS(2875),
    [anon_sym_COLON_COLON] = ACTIONS(2877),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2877),
    [anon_sym___declspec] = ACTIONS(2875),
    [anon_sym___based] = ACTIONS(2875),
    [anon_sym___cdecl] = ACTIONS(2875),
    [anon_sym___clrcall] = ACTIONS(2875),
    [anon_sym___stdcall] = ACTIONS(2875),
    [anon_sym___fastcall] = ACTIONS(2875),
    [anon_sym___thiscall] = ACTIONS(2875),
    [anon_sym___vectorcall] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2877),
    [anon_sym_signed] = ACTIONS(2875),
    [anon_sym_unsigned] = ACTIONS(2875),
    [anon_sym_long] = ACTIONS(2875),
    [anon_sym_short] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_static] = ACTIONS(2875),
    [anon_sym_register] = ACTIONS(2875),
    [anon_sym_inline] = ACTIONS(2875),
    [anon_sym___inline] = ACTIONS(2875),
    [anon_sym___inline__] = ACTIONS(2875),
    [anon_sym___forceinline] = ACTIONS(2875),
    [anon_sym_thread_local] = ACTIONS(2875),
    [anon_sym___thread] = ACTIONS(2875),
    [anon_sym_const] = ACTIONS(2875),
    [anon_sym_constexpr] = ACTIONS(2875),
    [anon_sym_volatile] = ACTIONS(2875),
    [anon_sym_restrict] = ACTIONS(2875),
    [anon_sym___restrict__] = ACTIONS(2875),
    [anon_sym__Atomic] = ACTIONS(2875),
    [anon_sym__Noreturn] = ACTIONS(2875),
    [anon_sym_noreturn] = ACTIONS(2875),
    [anon_sym__Nonnull] = ACTIONS(2875),
    [anon_sym_mutable] = ACTIONS(2875),
    [anon_sym_constinit] = ACTIONS(2875),
    [anon_sym_consteval] = ACTIONS(2875),
    [anon_sym_alignas] = ACTIONS(2875),
    [anon_sym__Alignas] = ACTIONS(2875),
    [sym_primitive_type] = ACTIONS(2875),
    [anon_sym_enum] = ACTIONS(2875),
    [anon_sym_class] = ACTIONS(2875),
    [anon_sym_struct] = ACTIONS(2875),
    [anon_sym_union] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_switch] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_default] = ACTIONS(2875),
    [anon_sym_while] = ACTIONS(2875),
    [anon_sym_do] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2875),
    [anon_sym_return] = ACTIONS(2875),
    [anon_sym_break] = ACTIONS(2875),
    [anon_sym_continue] = ACTIONS(2875),
    [anon_sym_goto] = ACTIONS(2875),
    [anon_sym___try] = ACTIONS(2875),
    [anon_sym___leave] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2875),
    [anon_sym_compl] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_sizeof] = ACTIONS(2875),
    [anon_sym___alignof__] = ACTIONS(2875),
    [anon_sym___alignof] = ACTIONS(2875),
    [anon_sym__alignof] = ACTIONS(2875),
    [anon_sym_alignof] = ACTIONS(2875),
    [anon_sym__Alignof] = ACTIONS(2875),
    [anon_sym_offsetof] = ACTIONS(2875),
    [anon_sym__Generic] = ACTIONS(2875),
    [anon_sym_asm] = ACTIONS(2875),
    [anon_sym___asm__] = ACTIONS(2875),
    [anon_sym___asm] = ACTIONS(2875),
    [sym_number_literal] = ACTIONS(2877),
    [anon_sym_L_SQUOTE] = ACTIONS(2877),
    [anon_sym_u_SQUOTE] = ACTIONS(2877),
    [anon_sym_U_SQUOTE] = ACTIONS(2877),
    [anon_sym_u8_SQUOTE] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_L_DQUOTE] = ACTIONS(2877),
    [anon_sym_u_DQUOTE] = ACTIONS(2877),
    [anon_sym_U_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [sym_true] = ACTIONS(2875),
    [sym_false] = ACTIONS(2875),
    [anon_sym_NULL] = ACTIONS(2875),
    [anon_sym_nullptr] = ACTIONS(2875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2875),
    [anon_sym_decltype] = ACTIONS(2875),
    [anon_sym_explicit] = ACTIONS(2875),
    [anon_sym_typename] = ACTIONS(2875),
    [anon_sym_template] = ACTIONS(2875),
    [anon_sym_operator] = ACTIONS(2875),
    [anon_sym_try] = ACTIONS(2875),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_throw] = ACTIONS(2875),
    [anon_sym_namespace] = ACTIONS(2875),
    [anon_sym_static_assert] = ACTIONS(2875),
    [anon_sym_concept] = ACTIONS(2875),
    [anon_sym_co_return] = ACTIONS(2875),
    [anon_sym_co_yield] = ACTIONS(2875),
    [anon_sym_R_DQUOTE] = ACTIONS(2877),
    [anon_sym_LR_DQUOTE] = ACTIONS(2877),
    [anon_sym_uR_DQUOTE] = ACTIONS(2877),
    [anon_sym_UR_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2877),
    [anon_sym_co_await] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2875),
    [anon_sym_requires] = ACTIONS(2875),
    [sym_this] = ACTIONS(2875),
  },
  [673] = {
    [sym_identifier] = ACTIONS(2879),
    [aux_sym_preproc_include_token1] = ACTIONS(2879),
    [aux_sym_preproc_def_token1] = ACTIONS(2879),
    [aux_sym_preproc_if_token1] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2879),
    [sym_preproc_directive] = ACTIONS(2879),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2879),
    [anon_sym_typedef] = ACTIONS(2879),
    [anon_sym_virtual] = ACTIONS(2879),
    [anon_sym_extern] = ACTIONS(2879),
    [anon_sym___attribute__] = ACTIONS(2879),
    [anon_sym___attribute] = ACTIONS(2879),
    [anon_sym_using] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2879),
    [anon_sym___based] = ACTIONS(2879),
    [anon_sym___cdecl] = ACTIONS(2879),
    [anon_sym___clrcall] = ACTIONS(2879),
    [anon_sym___stdcall] = ACTIONS(2879),
    [anon_sym___fastcall] = ACTIONS(2879),
    [anon_sym___thiscall] = ACTIONS(2879),
    [anon_sym___vectorcall] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2879),
    [anon_sym_unsigned] = ACTIONS(2879),
    [anon_sym_long] = ACTIONS(2879),
    [anon_sym_short] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_static] = ACTIONS(2879),
    [anon_sym_register] = ACTIONS(2879),
    [anon_sym_inline] = ACTIONS(2879),
    [anon_sym___inline] = ACTIONS(2879),
    [anon_sym___inline__] = ACTIONS(2879),
    [anon_sym___forceinline] = ACTIONS(2879),
    [anon_sym_thread_local] = ACTIONS(2879),
    [anon_sym___thread] = ACTIONS(2879),
    [anon_sym_const] = ACTIONS(2879),
    [anon_sym_constexpr] = ACTIONS(2879),
    [anon_sym_volatile] = ACTIONS(2879),
    [anon_sym_restrict] = ACTIONS(2879),
    [anon_sym___restrict__] = ACTIONS(2879),
    [anon_sym__Atomic] = ACTIONS(2879),
    [anon_sym__Noreturn] = ACTIONS(2879),
    [anon_sym_noreturn] = ACTIONS(2879),
    [anon_sym__Nonnull] = ACTIONS(2879),
    [anon_sym_mutable] = ACTIONS(2879),
    [anon_sym_constinit] = ACTIONS(2879),
    [anon_sym_consteval] = ACTIONS(2879),
    [anon_sym_alignas] = ACTIONS(2879),
    [anon_sym__Alignas] = ACTIONS(2879),
    [sym_primitive_type] = ACTIONS(2879),
    [anon_sym_enum] = ACTIONS(2879),
    [anon_sym_class] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2879),
    [anon_sym_union] = ACTIONS(2879),
    [anon_sym_if] = ACTIONS(2879),
    [anon_sym_switch] = ACTIONS(2879),
    [anon_sym_case] = ACTIONS(2879),
    [anon_sym_default] = ACTIONS(2879),
    [anon_sym_while] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2879),
    [anon_sym_return] = ACTIONS(2879),
    [anon_sym_break] = ACTIONS(2879),
    [anon_sym_continue] = ACTIONS(2879),
    [anon_sym_goto] = ACTIONS(2879),
    [anon_sym___try] = ACTIONS(2879),
    [anon_sym___leave] = ACTIONS(2879),
    [anon_sym_not] = ACTIONS(2879),
    [anon_sym_compl] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2879),
    [anon_sym___alignof__] = ACTIONS(2879),
    [anon_sym___alignof] = ACTIONS(2879),
    [anon_sym__alignof] = ACTIONS(2879),
    [anon_sym_alignof] = ACTIONS(2879),
    [anon_sym__Alignof] = ACTIONS(2879),
    [anon_sym_offsetof] = ACTIONS(2879),
    [anon_sym__Generic] = ACTIONS(2879),
    [anon_sym_asm] = ACTIONS(2879),
    [anon_sym___asm__] = ACTIONS(2879),
    [anon_sym___asm] = ACTIONS(2879),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2879),
    [sym_false] = ACTIONS(2879),
    [anon_sym_NULL] = ACTIONS(2879),
    [anon_sym_nullptr] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2879),
    [anon_sym_decltype] = ACTIONS(2879),
    [anon_sym_explicit] = ACTIONS(2879),
    [anon_sym_typename] = ACTIONS(2879),
    [anon_sym_template] = ACTIONS(2879),
    [anon_sym_operator] = ACTIONS(2879),
    [anon_sym_try] = ACTIONS(2879),
    [anon_sym_delete] = ACTIONS(2879),
    [anon_sym_throw] = ACTIONS(2879),
    [anon_sym_namespace] = ACTIONS(2879),
    [anon_sym_static_assert] = ACTIONS(2879),
    [anon_sym_concept] = ACTIONS(2879),
    [anon_sym_co_return] = ACTIONS(2879),
    [anon_sym_co_yield] = ACTIONS(2879),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2879),
    [anon_sym_requires] = ACTIONS(2879),
    [sym_this] = ACTIONS(2879),
  },
  [674] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2885),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym___try] = ACTIONS(2883),
    [anon_sym___leave] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2885),
    [anon_sym_L_SQUOTE] = ACTIONS(2885),
    [anon_sym_u_SQUOTE] = ACTIONS(2885),
    [anon_sym_U_SQUOTE] = ACTIONS(2885),
    [anon_sym_u8_SQUOTE] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_L_DQUOTE] = ACTIONS(2885),
    [anon_sym_u_DQUOTE] = ACTIONS(2885),
    [anon_sym_U_DQUOTE] = ACTIONS(2885),
    [anon_sym_u8_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE] = ACTIONS(2885),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2885),
    [anon_sym_LR_DQUOTE] = ACTIONS(2885),
    [anon_sym_uR_DQUOTE] = ACTIONS(2885),
    [anon_sym_UR_DQUOTE] = ACTIONS(2885),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2885),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
  },
  [675] = {
    [sym_identifier] = ACTIONS(2899),
    [aux_sym_preproc_include_token1] = ACTIONS(2899),
    [aux_sym_preproc_def_token1] = ACTIONS(2899),
    [aux_sym_preproc_if_token1] = ACTIONS(2899),
    [aux_sym_preproc_if_token2] = ACTIONS(2899),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2899),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2899),
    [sym_preproc_directive] = ACTIONS(2899),
    [anon_sym_LPAREN2] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_PLUS] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym___extension__] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2899),
    [anon_sym_virtual] = ACTIONS(2899),
    [anon_sym_extern] = ACTIONS(2899),
    [anon_sym___attribute__] = ACTIONS(2899),
    [anon_sym___attribute] = ACTIONS(2899),
    [anon_sym_using] = ACTIONS(2899),
    [anon_sym_COLON_COLON] = ACTIONS(2901),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2901),
    [anon_sym___declspec] = ACTIONS(2899),
    [anon_sym___based] = ACTIONS(2899),
    [anon_sym___cdecl] = ACTIONS(2899),
    [anon_sym___clrcall] = ACTIONS(2899),
    [anon_sym___stdcall] = ACTIONS(2899),
    [anon_sym___fastcall] = ACTIONS(2899),
    [anon_sym___thiscall] = ACTIONS(2899),
    [anon_sym___vectorcall] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_signed] = ACTIONS(2899),
    [anon_sym_unsigned] = ACTIONS(2899),
    [anon_sym_long] = ACTIONS(2899),
    [anon_sym_short] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_static] = ACTIONS(2899),
    [anon_sym_register] = ACTIONS(2899),
    [anon_sym_inline] = ACTIONS(2899),
    [anon_sym___inline] = ACTIONS(2899),
    [anon_sym___inline__] = ACTIONS(2899),
    [anon_sym___forceinline] = ACTIONS(2899),
    [anon_sym_thread_local] = ACTIONS(2899),
    [anon_sym___thread] = ACTIONS(2899),
    [anon_sym_const] = ACTIONS(2899),
    [anon_sym_constexpr] = ACTIONS(2899),
    [anon_sym_volatile] = ACTIONS(2899),
    [anon_sym_restrict] = ACTIONS(2899),
    [anon_sym___restrict__] = ACTIONS(2899),
    [anon_sym__Atomic] = ACTIONS(2899),
    [anon_sym__Noreturn] = ACTIONS(2899),
    [anon_sym_noreturn] = ACTIONS(2899),
    [anon_sym__Nonnull] = ACTIONS(2899),
    [anon_sym_mutable] = ACTIONS(2899),
    [anon_sym_constinit] = ACTIONS(2899),
    [anon_sym_consteval] = ACTIONS(2899),
    [anon_sym_alignas] = ACTIONS(2899),
    [anon_sym__Alignas] = ACTIONS(2899),
    [sym_primitive_type] = ACTIONS(2899),
    [anon_sym_enum] = ACTIONS(2899),
    [anon_sym_class] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(2899),
    [anon_sym_union] = ACTIONS(2899),
    [anon_sym_if] = ACTIONS(2899),
    [anon_sym_switch] = ACTIONS(2899),
    [anon_sym_case] = ACTIONS(2899),
    [anon_sym_default] = ACTIONS(2899),
    [anon_sym_while] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2899),
    [anon_sym_for] = ACTIONS(2899),
    [anon_sym_return] = ACTIONS(2899),
    [anon_sym_break] = ACTIONS(2899),
    [anon_sym_continue] = ACTIONS(2899),
    [anon_sym_goto] = ACTIONS(2899),
    [anon_sym___try] = ACTIONS(2899),
    [anon_sym___leave] = ACTIONS(2899),
    [anon_sym_not] = ACTIONS(2899),
    [anon_sym_compl] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_sizeof] = ACTIONS(2899),
    [anon_sym___alignof__] = ACTIONS(2899),
    [anon_sym___alignof] = ACTIONS(2899),
    [anon_sym__alignof] = ACTIONS(2899),
    [anon_sym_alignof] = ACTIONS(2899),
    [anon_sym__Alignof] = ACTIONS(2899),
    [anon_sym_offsetof] = ACTIONS(2899),
    [anon_sym__Generic] = ACTIONS(2899),
    [anon_sym_asm] = ACTIONS(2899),
    [anon_sym___asm__] = ACTIONS(2899),
    [anon_sym___asm] = ACTIONS(2899),
    [sym_number_literal] = ACTIONS(2901),
    [anon_sym_L_SQUOTE] = ACTIONS(2901),
    [anon_sym_u_SQUOTE] = ACTIONS(2901),
    [anon_sym_U_SQUOTE] = ACTIONS(2901),
    [anon_sym_u8_SQUOTE] = ACTIONS(2901),
    [anon_sym_SQUOTE] = ACTIONS(2901),
    [anon_sym_L_DQUOTE] = ACTIONS(2901),
    [anon_sym_u_DQUOTE] = ACTIONS(2901),
    [anon_sym_U_DQUOTE] = ACTIONS(2901),
    [anon_sym_u8_DQUOTE] = ACTIONS(2901),
    [anon_sym_DQUOTE] = ACTIONS(2901),
    [sym_true] = ACTIONS(2899),
    [sym_false] = ACTIONS(2899),
    [anon_sym_NULL] = ACTIONS(2899),
    [anon_sym_nullptr] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2899),
    [anon_sym_decltype] = ACTIONS(2899),
    [anon_sym_explicit] = ACTIONS(2899),
    [anon_sym_typename] = ACTIONS(2899),
    [anon_sym_template] = ACTIONS(2899),
    [anon_sym_operator] = ACTIONS(2899),
    [anon_sym_try] = ACTIONS(2899),
    [anon_sym_delete] = ACTIONS(2899),
    [anon_sym_throw] = ACTIONS(2899),
    [anon_sym_namespace] = ACTIONS(2899),
    [anon_sym_static_assert] = ACTIONS(2899),
    [anon_sym_concept] = ACTIONS(2899),
    [anon_sym_co_return] = ACTIONS(2899),
    [anon_sym_co_yield] = ACTIONS(2899),
    [anon_sym_R_DQUOTE] = ACTIONS(2901),
    [anon_sym_LR_DQUOTE] = ACTIONS(2901),
    [anon_sym_uR_DQUOTE] = ACTIONS(2901),
    [anon_sym_UR_DQUOTE] = ACTIONS(2901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2901),
    [anon_sym_co_await] = ACTIONS(2899),
    [anon_sym_new] = ACTIONS(2899),
    [anon_sym_requires] = ACTIONS(2899),
    [sym_this] = ACTIONS(2899),
  },
  [676] = {
    [sym_identifier] = ACTIONS(2907),
    [aux_sym_preproc_include_token1] = ACTIONS(2907),
    [aux_sym_preproc_def_token1] = ACTIONS(2907),
    [aux_sym_preproc_if_token1] = ACTIONS(2907),
    [aux_sym_preproc_if_token2] = ACTIONS(2907),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2907),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2907),
    [sym_preproc_directive] = ACTIONS(2907),
    [anon_sym_LPAREN2] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_PLUS] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2909),
    [anon_sym___extension__] = ACTIONS(2907),
    [anon_sym_typedef] = ACTIONS(2907),
    [anon_sym_virtual] = ACTIONS(2907),
    [anon_sym_extern] = ACTIONS(2907),
    [anon_sym___attribute__] = ACTIONS(2907),
    [anon_sym___attribute] = ACTIONS(2907),
    [anon_sym_using] = ACTIONS(2907),
    [anon_sym_COLON_COLON] = ACTIONS(2909),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2909),
    [anon_sym___declspec] = ACTIONS(2907),
    [anon_sym___based] = ACTIONS(2907),
    [anon_sym___cdecl] = ACTIONS(2907),
    [anon_sym___clrcall] = ACTIONS(2907),
    [anon_sym___stdcall] = ACTIONS(2907),
    [anon_sym___fastcall] = ACTIONS(2907),
    [anon_sym___thiscall] = ACTIONS(2907),
    [anon_sym___vectorcall] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_signed] = ACTIONS(2907),
    [anon_sym_unsigned] = ACTIONS(2907),
    [anon_sym_long] = ACTIONS(2907),
    [anon_sym_short] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_static] = ACTIONS(2907),
    [anon_sym_register] = ACTIONS(2907),
    [anon_sym_inline] = ACTIONS(2907),
    [anon_sym___inline] = ACTIONS(2907),
    [anon_sym___inline__] = ACTIONS(2907),
    [anon_sym___forceinline] = ACTIONS(2907),
    [anon_sym_thread_local] = ACTIONS(2907),
    [anon_sym___thread] = ACTIONS(2907),
    [anon_sym_const] = ACTIONS(2907),
    [anon_sym_constexpr] = ACTIONS(2907),
    [anon_sym_volatile] = ACTIONS(2907),
    [anon_sym_restrict] = ACTIONS(2907),
    [anon_sym___restrict__] = ACTIONS(2907),
    [anon_sym__Atomic] = ACTIONS(2907),
    [anon_sym__Noreturn] = ACTIONS(2907),
    [anon_sym_noreturn] = ACTIONS(2907),
    [anon_sym__Nonnull] = ACTIONS(2907),
    [anon_sym_mutable] = ACTIONS(2907),
    [anon_sym_constinit] = ACTIONS(2907),
    [anon_sym_consteval] = ACTIONS(2907),
    [anon_sym_alignas] = ACTIONS(2907),
    [anon_sym__Alignas] = ACTIONS(2907),
    [sym_primitive_type] = ACTIONS(2907),
    [anon_sym_enum] = ACTIONS(2907),
    [anon_sym_class] = ACTIONS(2907),
    [anon_sym_struct] = ACTIONS(2907),
    [anon_sym_union] = ACTIONS(2907),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2907),
    [anon_sym_default] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_for] = ACTIONS(2907),
    [anon_sym_return] = ACTIONS(2907),
    [anon_sym_break] = ACTIONS(2907),
    [anon_sym_continue] = ACTIONS(2907),
    [anon_sym_goto] = ACTIONS(2907),
    [anon_sym___try] = ACTIONS(2907),
    [anon_sym___leave] = ACTIONS(2907),
    [anon_sym_not] = ACTIONS(2907),
    [anon_sym_compl] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2909),
    [anon_sym_sizeof] = ACTIONS(2907),
    [anon_sym___alignof__] = ACTIONS(2907),
    [anon_sym___alignof] = ACTIONS(2907),
    [anon_sym__alignof] = ACTIONS(2907),
    [anon_sym_alignof] = ACTIONS(2907),
    [anon_sym__Alignof] = ACTIONS(2907),
    [anon_sym_offsetof] = ACTIONS(2907),
    [anon_sym__Generic] = ACTIONS(2907),
    [anon_sym_asm] = ACTIONS(2907),
    [anon_sym___asm__] = ACTIONS(2907),
    [anon_sym___asm] = ACTIONS(2907),
    [sym_number_literal] = ACTIONS(2909),
    [anon_sym_L_SQUOTE] = ACTIONS(2909),
    [anon_sym_u_SQUOTE] = ACTIONS(2909),
    [anon_sym_U_SQUOTE] = ACTIONS(2909),
    [anon_sym_u8_SQUOTE] = ACTIONS(2909),
    [anon_sym_SQUOTE] = ACTIONS(2909),
    [anon_sym_L_DQUOTE] = ACTIONS(2909),
    [anon_sym_u_DQUOTE] = ACTIONS(2909),
    [anon_sym_U_DQUOTE] = ACTIONS(2909),
    [anon_sym_u8_DQUOTE] = ACTIONS(2909),
    [anon_sym_DQUOTE] = ACTIONS(2909),
    [sym_true] = ACTIONS(2907),
    [sym_false] = ACTIONS(2907),
    [anon_sym_NULL] = ACTIONS(2907),
    [anon_sym_nullptr] = ACTIONS(2907),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2907),
    [anon_sym_decltype] = ACTIONS(2907),
    [anon_sym_explicit] = ACTIONS(2907),
    [anon_sym_typename] = ACTIONS(2907),
    [anon_sym_template] = ACTIONS(2907),
    [anon_sym_operator] = ACTIONS(2907),
    [anon_sym_try] = ACTIONS(2907),
    [anon_sym_delete] = ACTIONS(2907),
    [anon_sym_throw] = ACTIONS(2907),
    [anon_sym_namespace] = ACTIONS(2907),
    [anon_sym_static_assert] = ACTIONS(2907),
    [anon_sym_concept] = ACTIONS(2907),
    [anon_sym_co_return] = ACTIONS(2907),
    [anon_sym_co_yield] = ACTIONS(2907),
    [anon_sym_R_DQUOTE] = ACTIONS(2909),
    [anon_sym_LR_DQUOTE] = ACTIONS(2909),
    [anon_sym_uR_DQUOTE] = ACTIONS(2909),
    [anon_sym_UR_DQUOTE] = ACTIONS(2909),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2909),
    [anon_sym_co_await] = ACTIONS(2907),
    [anon_sym_new] = ACTIONS(2907),
    [anon_sym_requires] = ACTIONS(2907),
    [sym_this] = ACTIONS(2907),
  },
  [677] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_include_token1] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token2] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym___cdecl] = ACTIONS(2911),
    [anon_sym___clrcall] = ACTIONS(2911),
    [anon_sym___stdcall] = ACTIONS(2911),
    [anon_sym___fastcall] = ACTIONS(2911),
    [anon_sym___thiscall] = ACTIONS(2911),
    [anon_sym___vectorcall] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2911),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2911),
    [anon_sym_return] = ACTIONS(2911),
    [anon_sym_break] = ACTIONS(2911),
    [anon_sym_continue] = ACTIONS(2911),
    [anon_sym_goto] = ACTIONS(2911),
    [anon_sym___try] = ACTIONS(2911),
    [anon_sym___leave] = ACTIONS(2911),
    [anon_sym_not] = ACTIONS(2911),
    [anon_sym_compl] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_sizeof] = ACTIONS(2911),
    [anon_sym___alignof__] = ACTIONS(2911),
    [anon_sym___alignof] = ACTIONS(2911),
    [anon_sym__alignof] = ACTIONS(2911),
    [anon_sym_alignof] = ACTIONS(2911),
    [anon_sym__Alignof] = ACTIONS(2911),
    [anon_sym_offsetof] = ACTIONS(2911),
    [anon_sym__Generic] = ACTIONS(2911),
    [anon_sym_asm] = ACTIONS(2911),
    [anon_sym___asm__] = ACTIONS(2911),
    [anon_sym___asm] = ACTIONS(2911),
    [sym_number_literal] = ACTIONS(2913),
    [anon_sym_L_SQUOTE] = ACTIONS(2913),
    [anon_sym_u_SQUOTE] = ACTIONS(2913),
    [anon_sym_U_SQUOTE] = ACTIONS(2913),
    [anon_sym_u8_SQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_L_DQUOTE] = ACTIONS(2913),
    [anon_sym_u_DQUOTE] = ACTIONS(2913),
    [anon_sym_U_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8_DQUOTE] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [sym_true] = ACTIONS(2911),
    [sym_false] = ACTIONS(2911),
    [anon_sym_NULL] = ACTIONS(2911),
    [anon_sym_nullptr] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2911),
    [anon_sym_delete] = ACTIONS(2911),
    [anon_sym_throw] = ACTIONS(2911),
    [anon_sym_namespace] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
    [anon_sym_concept] = ACTIONS(2911),
    [anon_sym_co_return] = ACTIONS(2911),
    [anon_sym_co_yield] = ACTIONS(2911),
    [anon_sym_R_DQUOTE] = ACTIONS(2913),
    [anon_sym_LR_DQUOTE] = ACTIONS(2913),
    [anon_sym_uR_DQUOTE] = ACTIONS(2913),
    [anon_sym_UR_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2913),
    [anon_sym_co_await] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2911),
    [anon_sym_requires] = ACTIONS(2911),
    [sym_this] = ACTIONS(2911),
  },
  [678] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_include_token1] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token2] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym___cdecl] = ACTIONS(2911),
    [anon_sym___clrcall] = ACTIONS(2911),
    [anon_sym___stdcall] = ACTIONS(2911),
    [anon_sym___fastcall] = ACTIONS(2911),
    [anon_sym___thiscall] = ACTIONS(2911),
    [anon_sym___vectorcall] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2911),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2911),
    [anon_sym_return] = ACTIONS(2911),
    [anon_sym_break] = ACTIONS(2911),
    [anon_sym_continue] = ACTIONS(2911),
    [anon_sym_goto] = ACTIONS(2911),
    [anon_sym___try] = ACTIONS(2911),
    [anon_sym___leave] = ACTIONS(2911),
    [anon_sym_not] = ACTIONS(2911),
    [anon_sym_compl] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_sizeof] = ACTIONS(2911),
    [anon_sym___alignof__] = ACTIONS(2911),
    [anon_sym___alignof] = ACTIONS(2911),
    [anon_sym__alignof] = ACTIONS(2911),
    [anon_sym_alignof] = ACTIONS(2911),
    [anon_sym__Alignof] = ACTIONS(2911),
    [anon_sym_offsetof] = ACTIONS(2911),
    [anon_sym__Generic] = ACTIONS(2911),
    [anon_sym_asm] = ACTIONS(2911),
    [anon_sym___asm__] = ACTIONS(2911),
    [anon_sym___asm] = ACTIONS(2911),
    [sym_number_literal] = ACTIONS(2913),
    [anon_sym_L_SQUOTE] = ACTIONS(2913),
    [anon_sym_u_SQUOTE] = ACTIONS(2913),
    [anon_sym_U_SQUOTE] = ACTIONS(2913),
    [anon_sym_u8_SQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_L_DQUOTE] = ACTIONS(2913),
    [anon_sym_u_DQUOTE] = ACTIONS(2913),
    [anon_sym_U_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8_DQUOTE] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [sym_true] = ACTIONS(2911),
    [sym_false] = ACTIONS(2911),
    [anon_sym_NULL] = ACTIONS(2911),
    [anon_sym_nullptr] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2911),
    [anon_sym_delete] = ACTIONS(2911),
    [anon_sym_throw] = ACTIONS(2911),
    [anon_sym_namespace] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
    [anon_sym_concept] = ACTIONS(2911),
    [anon_sym_co_return] = ACTIONS(2911),
    [anon_sym_co_yield] = ACTIONS(2911),
    [anon_sym_R_DQUOTE] = ACTIONS(2913),
    [anon_sym_LR_DQUOTE] = ACTIONS(2913),
    [anon_sym_uR_DQUOTE] = ACTIONS(2913),
    [anon_sym_UR_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2913),
    [anon_sym_co_await] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2911),
    [anon_sym_requires] = ACTIONS(2911),
    [sym_this] = ACTIONS(2911),
  },
  [679] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_include_token1] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token2] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_goto] = ACTIONS(2915),
    [anon_sym___try] = ACTIONS(2915),
    [anon_sym___leave] = ACTIONS(2915),
    [anon_sym_not] = ACTIONS(2915),
    [anon_sym_compl] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_sizeof] = ACTIONS(2915),
    [anon_sym___alignof__] = ACTIONS(2915),
    [anon_sym___alignof] = ACTIONS(2915),
    [anon_sym__alignof] = ACTIONS(2915),
    [anon_sym_alignof] = ACTIONS(2915),
    [anon_sym__Alignof] = ACTIONS(2915),
    [anon_sym_offsetof] = ACTIONS(2915),
    [anon_sym__Generic] = ACTIONS(2915),
    [anon_sym_asm] = ACTIONS(2915),
    [anon_sym___asm__] = ACTIONS(2915),
    [anon_sym___asm] = ACTIONS(2915),
    [sym_number_literal] = ACTIONS(2917),
    [anon_sym_L_SQUOTE] = ACTIONS(2917),
    [anon_sym_u_SQUOTE] = ACTIONS(2917),
    [anon_sym_U_SQUOTE] = ACTIONS(2917),
    [anon_sym_u8_SQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_L_DQUOTE] = ACTIONS(2917),
    [anon_sym_u_DQUOTE] = ACTIONS(2917),
    [anon_sym_U_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8_DQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [anon_sym_NULL] = ACTIONS(2915),
    [anon_sym_nullptr] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
    [anon_sym_concept] = ACTIONS(2915),
    [anon_sym_co_return] = ACTIONS(2915),
    [anon_sym_co_yield] = ACTIONS(2915),
    [anon_sym_R_DQUOTE] = ACTIONS(2917),
    [anon_sym_LR_DQUOTE] = ACTIONS(2917),
    [anon_sym_uR_DQUOTE] = ACTIONS(2917),
    [anon_sym_UR_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2917),
    [anon_sym_co_await] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [sym_this] = ACTIONS(2915),
  },
  [680] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_include_token1] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token2] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_goto] = ACTIONS(2915),
    [anon_sym___try] = ACTIONS(2915),
    [anon_sym___leave] = ACTIONS(2915),
    [anon_sym_not] = ACTIONS(2915),
    [anon_sym_compl] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_sizeof] = ACTIONS(2915),
    [anon_sym___alignof__] = ACTIONS(2915),
    [anon_sym___alignof] = ACTIONS(2915),
    [anon_sym__alignof] = ACTIONS(2915),
    [anon_sym_alignof] = ACTIONS(2915),
    [anon_sym__Alignof] = ACTIONS(2915),
    [anon_sym_offsetof] = ACTIONS(2915),
    [anon_sym__Generic] = ACTIONS(2915),
    [anon_sym_asm] = ACTIONS(2915),
    [anon_sym___asm__] = ACTIONS(2915),
    [anon_sym___asm] = ACTIONS(2915),
    [sym_number_literal] = ACTIONS(2917),
    [anon_sym_L_SQUOTE] = ACTIONS(2917),
    [anon_sym_u_SQUOTE] = ACTIONS(2917),
    [anon_sym_U_SQUOTE] = ACTIONS(2917),
    [anon_sym_u8_SQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_L_DQUOTE] = ACTIONS(2917),
    [anon_sym_u_DQUOTE] = ACTIONS(2917),
    [anon_sym_U_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8_DQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [anon_sym_NULL] = ACTIONS(2915),
    [anon_sym_nullptr] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
    [anon_sym_concept] = ACTIONS(2915),
    [anon_sym_co_return] = ACTIONS(2915),
    [anon_sym_co_yield] = ACTIONS(2915),
    [anon_sym_R_DQUOTE] = ACTIONS(2917),
    [anon_sym_LR_DQUOTE] = ACTIONS(2917),
    [anon_sym_uR_DQUOTE] = ACTIONS(2917),
    [anon_sym_UR_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2917),
    [anon_sym_co_await] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [sym_this] = ACTIONS(2915),
  },
  [681] = {
    [sym_identifier] = ACTIONS(2943),
    [aux_sym_preproc_include_token1] = ACTIONS(2943),
    [aux_sym_preproc_def_token1] = ACTIONS(2943),
    [aux_sym_preproc_if_token1] = ACTIONS(2943),
    [aux_sym_preproc_if_token2] = ACTIONS(2943),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2943),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2943),
    [sym_preproc_directive] = ACTIONS(2943),
    [anon_sym_LPAREN2] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_TILDE] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2943),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym___extension__] = ACTIONS(2943),
    [anon_sym_typedef] = ACTIONS(2943),
    [anon_sym_virtual] = ACTIONS(2943),
    [anon_sym_extern] = ACTIONS(2943),
    [anon_sym___attribute__] = ACTIONS(2943),
    [anon_sym___attribute] = ACTIONS(2943),
    [anon_sym_using] = ACTIONS(2943),
    [anon_sym_COLON_COLON] = ACTIONS(2945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2945),
    [anon_sym___declspec] = ACTIONS(2943),
    [anon_sym___based] = ACTIONS(2943),
    [anon_sym___cdecl] = ACTIONS(2943),
    [anon_sym___clrcall] = ACTIONS(2943),
    [anon_sym___stdcall] = ACTIONS(2943),
    [anon_sym___fastcall] = ACTIONS(2943),
    [anon_sym___thiscall] = ACTIONS(2943),
    [anon_sym___vectorcall] = ACTIONS(2943),
    [anon_sym_LBRACE] = ACTIONS(2945),
    [anon_sym_signed] = ACTIONS(2943),
    [anon_sym_unsigned] = ACTIONS(2943),
    [anon_sym_long] = ACTIONS(2943),
    [anon_sym_short] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_static] = ACTIONS(2943),
    [anon_sym_register] = ACTIONS(2943),
    [anon_sym_inline] = ACTIONS(2943),
    [anon_sym___inline] = ACTIONS(2943),
    [anon_sym___inline__] = ACTIONS(2943),
    [anon_sym___forceinline] = ACTIONS(2943),
    [anon_sym_thread_local] = ACTIONS(2943),
    [anon_sym___thread] = ACTIONS(2943),
    [anon_sym_const] = ACTIONS(2943),
    [anon_sym_constexpr] = ACTIONS(2943),
    [anon_sym_volatile] = ACTIONS(2943),
    [anon_sym_restrict] = ACTIONS(2943),
    [anon_sym___restrict__] = ACTIONS(2943),
    [anon_sym__Atomic] = ACTIONS(2943),
    [anon_sym__Noreturn] = ACTIONS(2943),
    [anon_sym_noreturn] = ACTIONS(2943),
    [anon_sym__Nonnull] = ACTIONS(2943),
    [anon_sym_mutable] = ACTIONS(2943),
    [anon_sym_constinit] = ACTIONS(2943),
    [anon_sym_consteval] = ACTIONS(2943),
    [anon_sym_alignas] = ACTIONS(2943),
    [anon_sym__Alignas] = ACTIONS(2943),
    [sym_primitive_type] = ACTIONS(2943),
    [anon_sym_enum] = ACTIONS(2943),
    [anon_sym_class] = ACTIONS(2943),
    [anon_sym_struct] = ACTIONS(2943),
    [anon_sym_union] = ACTIONS(2943),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_switch] = ACTIONS(2943),
    [anon_sym_case] = ACTIONS(2943),
    [anon_sym_default] = ACTIONS(2943),
    [anon_sym_while] = ACTIONS(2943),
    [anon_sym_do] = ACTIONS(2943),
    [anon_sym_for] = ACTIONS(2943),
    [anon_sym_return] = ACTIONS(2943),
    [anon_sym_break] = ACTIONS(2943),
    [anon_sym_continue] = ACTIONS(2943),
    [anon_sym_goto] = ACTIONS(2943),
    [anon_sym___try] = ACTIONS(2943),
    [anon_sym___leave] = ACTIONS(2943),
    [anon_sym_not] = ACTIONS(2943),
    [anon_sym_compl] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_sizeof] = ACTIONS(2943),
    [anon_sym___alignof__] = ACTIONS(2943),
    [anon_sym___alignof] = ACTIONS(2943),
    [anon_sym__alignof] = ACTIONS(2943),
    [anon_sym_alignof] = ACTIONS(2943),
    [anon_sym__Alignof] = ACTIONS(2943),
    [anon_sym_offsetof] = ACTIONS(2943),
    [anon_sym__Generic] = ACTIONS(2943),
    [anon_sym_asm] = ACTIONS(2943),
    [anon_sym___asm__] = ACTIONS(2943),
    [anon_sym___asm] = ACTIONS(2943),
    [sym_number_literal] = ACTIONS(2945),
    [anon_sym_L_SQUOTE] = ACTIONS(2945),
    [anon_sym_u_SQUOTE] = ACTIONS(2945),
    [anon_sym_U_SQUOTE] = ACTIONS(2945),
    [anon_sym_u8_SQUOTE] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_L_DQUOTE] = ACTIONS(2945),
    [anon_sym_u_DQUOTE] = ACTIONS(2945),
    [anon_sym_U_DQUOTE] = ACTIONS(2945),
    [anon_sym_u8_DQUOTE] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_true] = ACTIONS(2943),
    [sym_false] = ACTIONS(2943),
    [anon_sym_NULL] = ACTIONS(2943),
    [anon_sym_nullptr] = ACTIONS(2943),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2943),
    [anon_sym_decltype] = ACTIONS(2943),
    [anon_sym_explicit] = ACTIONS(2943),
    [anon_sym_typename] = ACTIONS(2943),
    [anon_sym_template] = ACTIONS(2943),
    [anon_sym_operator] = ACTIONS(2943),
    [anon_sym_try] = ACTIONS(2943),
    [anon_sym_delete] = ACTIONS(2943),
    [anon_sym_throw] = ACTIONS(2943),
    [anon_sym_namespace] = ACTIONS(2943),
    [anon_sym_static_assert] = ACTIONS(2943),
    [anon_sym_concept] = ACTIONS(2943),
    [anon_sym_co_return] = ACTIONS(2943),
    [anon_sym_co_yield] = ACTIONS(2943),
    [anon_sym_R_DQUOTE] = ACTIONS(2945),
    [anon_sym_LR_DQUOTE] = ACTIONS(2945),
    [anon_sym_uR_DQUOTE] = ACTIONS(2945),
    [anon_sym_UR_DQUOTE] = ACTIONS(2945),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2945),
    [anon_sym_co_await] = ACTIONS(2943),
    [anon_sym_new] = ACTIONS(2943),
    [anon_sym_requires] = ACTIONS(2943),
    [sym_this] = ACTIONS(2943),
  },
  [682] = {
    [sym_identifier] = ACTIONS(2947),
    [aux_sym_preproc_include_token1] = ACTIONS(2947),
    [aux_sym_preproc_def_token1] = ACTIONS(2947),
    [aux_sym_preproc_if_token1] = ACTIONS(2947),
    [aux_sym_preproc_if_token2] = ACTIONS(2947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2947),
    [sym_preproc_directive] = ACTIONS(2947),
    [anon_sym_LPAREN2] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym___extension__] = ACTIONS(2947),
    [anon_sym_typedef] = ACTIONS(2947),
    [anon_sym_virtual] = ACTIONS(2947),
    [anon_sym_extern] = ACTIONS(2947),
    [anon_sym___attribute__] = ACTIONS(2947),
    [anon_sym___attribute] = ACTIONS(2947),
    [anon_sym_using] = ACTIONS(2947),
    [anon_sym_COLON_COLON] = ACTIONS(2949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2949),
    [anon_sym___declspec] = ACTIONS(2947),
    [anon_sym___based] = ACTIONS(2947),
    [anon_sym___cdecl] = ACTIONS(2947),
    [anon_sym___clrcall] = ACTIONS(2947),
    [anon_sym___stdcall] = ACTIONS(2947),
    [anon_sym___fastcall] = ACTIONS(2947),
    [anon_sym___thiscall] = ACTIONS(2947),
    [anon_sym___vectorcall] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2949),
    [anon_sym_signed] = ACTIONS(2947),
    [anon_sym_unsigned] = ACTIONS(2947),
    [anon_sym_long] = ACTIONS(2947),
    [anon_sym_short] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_static] = ACTIONS(2947),
    [anon_sym_register] = ACTIONS(2947),
    [anon_sym_inline] = ACTIONS(2947),
    [anon_sym___inline] = ACTIONS(2947),
    [anon_sym___inline__] = ACTIONS(2947),
    [anon_sym___forceinline] = ACTIONS(2947),
    [anon_sym_thread_local] = ACTIONS(2947),
    [anon_sym___thread] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_constexpr] = ACTIONS(2947),
    [anon_sym_volatile] = ACTIONS(2947),
    [anon_sym_restrict] = ACTIONS(2947),
    [anon_sym___restrict__] = ACTIONS(2947),
    [anon_sym__Atomic] = ACTIONS(2947),
    [anon_sym__Noreturn] = ACTIONS(2947),
    [anon_sym_noreturn] = ACTIONS(2947),
    [anon_sym__Nonnull] = ACTIONS(2947),
    [anon_sym_mutable] = ACTIONS(2947),
    [anon_sym_constinit] = ACTIONS(2947),
    [anon_sym_consteval] = ACTIONS(2947),
    [anon_sym_alignas] = ACTIONS(2947),
    [anon_sym__Alignas] = ACTIONS(2947),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2947),
    [anon_sym_class] = ACTIONS(2947),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_switch] = ACTIONS(2947),
    [anon_sym_case] = ACTIONS(2947),
    [anon_sym_default] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_goto] = ACTIONS(2947),
    [anon_sym___try] = ACTIONS(2947),
    [anon_sym___leave] = ACTIONS(2947),
    [anon_sym_not] = ACTIONS(2947),
    [anon_sym_compl] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2949),
    [anon_sym_PLUS_PLUS] = ACTIONS(2949),
    [anon_sym_sizeof] = ACTIONS(2947),
    [anon_sym___alignof__] = ACTIONS(2947),
    [anon_sym___alignof] = ACTIONS(2947),
    [anon_sym__alignof] = ACTIONS(2947),
    [anon_sym_alignof] = ACTIONS(2947),
    [anon_sym__Alignof] = ACTIONS(2947),
    [anon_sym_offsetof] = ACTIONS(2947),
    [anon_sym__Generic] = ACTIONS(2947),
    [anon_sym_asm] = ACTIONS(2947),
    [anon_sym___asm__] = ACTIONS(2947),
    [anon_sym___asm] = ACTIONS(2947),
    [sym_number_literal] = ACTIONS(2949),
    [anon_sym_L_SQUOTE] = ACTIONS(2949),
    [anon_sym_u_SQUOTE] = ACTIONS(2949),
    [anon_sym_U_SQUOTE] = ACTIONS(2949),
    [anon_sym_u8_SQUOTE] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_L_DQUOTE] = ACTIONS(2949),
    [anon_sym_u_DQUOTE] = ACTIONS(2949),
    [anon_sym_U_DQUOTE] = ACTIONS(2949),
    [anon_sym_u8_DQUOTE] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [anon_sym_NULL] = ACTIONS(2947),
    [anon_sym_nullptr] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2947),
    [anon_sym_decltype] = ACTIONS(2947),
    [anon_sym_explicit] = ACTIONS(2947),
    [anon_sym_typename] = ACTIONS(2947),
    [anon_sym_template] = ACTIONS(2947),
    [anon_sym_operator] = ACTIONS(2947),
    [anon_sym_try] = ACTIONS(2947),
    [anon_sym_delete] = ACTIONS(2947),
    [anon_sym_throw] = ACTIONS(2947),
    [anon_sym_namespace] = ACTIONS(2947),
    [anon_sym_static_assert] = ACTIONS(2947),
    [anon_sym_concept] = ACTIONS(2947),
    [anon_sym_co_return] = ACTIONS(2947),
    [anon_sym_co_yield] = ACTIONS(2947),
    [anon_sym_R_DQUOTE] = ACTIONS(2949),
    [anon_sym_LR_DQUOTE] = ACTIONS(2949),
    [anon_sym_uR_DQUOTE] = ACTIONS(2949),
    [anon_sym_UR_DQUOTE] = ACTIONS(2949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2949),
    [anon_sym_co_await] = ACTIONS(2947),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_requires] = ACTIONS(2947),
    [sym_this] = ACTIONS(2947),
  },
  [683] = {
    [sym_identifier] = ACTIONS(2951),
    [aux_sym_preproc_include_token1] = ACTIONS(2951),
    [aux_sym_preproc_def_token1] = ACTIONS(2951),
    [aux_sym_preproc_if_token1] = ACTIONS(2951),
    [aux_sym_preproc_if_token2] = ACTIONS(2951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2951),
    [sym_preproc_directive] = ACTIONS(2951),
    [anon_sym_LPAREN2] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_TILDE] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_AMP_AMP] = ACTIONS(2953),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2953),
    [anon_sym___extension__] = ACTIONS(2951),
    [anon_sym_typedef] = ACTIONS(2951),
    [anon_sym_virtual] = ACTIONS(2951),
    [anon_sym_extern] = ACTIONS(2951),
    [anon_sym___attribute__] = ACTIONS(2951),
    [anon_sym___attribute] = ACTIONS(2951),
    [anon_sym_using] = ACTIONS(2951),
    [anon_sym_COLON_COLON] = ACTIONS(2953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2953),
    [anon_sym___declspec] = ACTIONS(2951),
    [anon_sym___based] = ACTIONS(2951),
    [anon_sym___cdecl] = ACTIONS(2951),
    [anon_sym___clrcall] = ACTIONS(2951),
    [anon_sym___stdcall] = ACTIONS(2951),
    [anon_sym___fastcall] = ACTIONS(2951),
    [anon_sym___thiscall] = ACTIONS(2951),
    [anon_sym___vectorcall] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2953),
    [anon_sym_signed] = ACTIONS(2951),
    [anon_sym_unsigned] = ACTIONS(2951),
    [anon_sym_long] = ACTIONS(2951),
    [anon_sym_short] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_static] = ACTIONS(2951),
    [anon_sym_register] = ACTIONS(2951),
    [anon_sym_inline] = ACTIONS(2951),
    [anon_sym___inline] = ACTIONS(2951),
    [anon_sym___inline__] = ACTIONS(2951),
    [anon_sym___forceinline] = ACTIONS(2951),
    [anon_sym_thread_local] = ACTIONS(2951),
    [anon_sym___thread] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_constexpr] = ACTIONS(2951),
    [anon_sym_volatile] = ACTIONS(2951),
    [anon_sym_restrict] = ACTIONS(2951),
    [anon_sym___restrict__] = ACTIONS(2951),
    [anon_sym__Atomic] = ACTIONS(2951),
    [anon_sym__Noreturn] = ACTIONS(2951),
    [anon_sym_noreturn] = ACTIONS(2951),
    [anon_sym__Nonnull] = ACTIONS(2951),
    [anon_sym_mutable] = ACTIONS(2951),
    [anon_sym_constinit] = ACTIONS(2951),
    [anon_sym_consteval] = ACTIONS(2951),
    [anon_sym_alignas] = ACTIONS(2951),
    [anon_sym__Alignas] = ACTIONS(2951),
    [sym_primitive_type] = ACTIONS(2951),
    [anon_sym_enum] = ACTIONS(2951),
    [anon_sym_class] = ACTIONS(2951),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_union] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_switch] = ACTIONS(2951),
    [anon_sym_case] = ACTIONS(2951),
    [anon_sym_default] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2951),
    [anon_sym_do] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_goto] = ACTIONS(2951),
    [anon_sym___try] = ACTIONS(2951),
    [anon_sym___leave] = ACTIONS(2951),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_compl] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2951),
    [anon_sym___alignof__] = ACTIONS(2951),
    [anon_sym___alignof] = ACTIONS(2951),
    [anon_sym__alignof] = ACTIONS(2951),
    [anon_sym_alignof] = ACTIONS(2951),
    [anon_sym__Alignof] = ACTIONS(2951),
    [anon_sym_offsetof] = ACTIONS(2951),
    [anon_sym__Generic] = ACTIONS(2951),
    [anon_sym_asm] = ACTIONS(2951),
    [anon_sym___asm__] = ACTIONS(2951),
    [anon_sym___asm] = ACTIONS(2951),
    [sym_number_literal] = ACTIONS(2953),
    [anon_sym_L_SQUOTE] = ACTIONS(2953),
    [anon_sym_u_SQUOTE] = ACTIONS(2953),
    [anon_sym_U_SQUOTE] = ACTIONS(2953),
    [anon_sym_u8_SQUOTE] = ACTIONS(2953),
    [anon_sym_SQUOTE] = ACTIONS(2953),
    [anon_sym_L_DQUOTE] = ACTIONS(2953),
    [anon_sym_u_DQUOTE] = ACTIONS(2953),
    [anon_sym_U_DQUOTE] = ACTIONS(2953),
    [anon_sym_u8_DQUOTE] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(2953),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [anon_sym_NULL] = ACTIONS(2951),
    [anon_sym_nullptr] = ACTIONS(2951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2951),
    [anon_sym_decltype] = ACTIONS(2951),
    [anon_sym_explicit] = ACTIONS(2951),
    [anon_sym_typename] = ACTIONS(2951),
    [anon_sym_template] = ACTIONS(2951),
    [anon_sym_operator] = ACTIONS(2951),
    [anon_sym_try] = ACTIONS(2951),
    [anon_sym_delete] = ACTIONS(2951),
    [anon_sym_throw] = ACTIONS(2951),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_static_assert] = ACTIONS(2951),
    [anon_sym_concept] = ACTIONS(2951),
    [anon_sym_co_return] = ACTIONS(2951),
    [anon_sym_co_yield] = ACTIONS(2951),
    [anon_sym_R_DQUOTE] = ACTIONS(2953),
    [anon_sym_LR_DQUOTE] = ACTIONS(2953),
    [anon_sym_uR_DQUOTE] = ACTIONS(2953),
    [anon_sym_UR_DQUOTE] = ACTIONS(2953),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2953),
    [anon_sym_co_await] = ACTIONS(2951),
    [anon_sym_new] = ACTIONS(2951),
    [anon_sym_requires] = ACTIONS(2951),
    [sym_this] = ACTIONS(2951),
  },
  [684] = {
    [sym_identifier] = ACTIONS(2887),
    [aux_sym_preproc_include_token1] = ACTIONS(2887),
    [aux_sym_preproc_def_token1] = ACTIONS(2887),
    [aux_sym_preproc_if_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2887),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2887),
    [sym_preproc_directive] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2887),
    [anon_sym_typedef] = ACTIONS(2887),
    [anon_sym_virtual] = ACTIONS(2887),
    [anon_sym_extern] = ACTIONS(2887),
    [anon_sym___attribute__] = ACTIONS(2887),
    [anon_sym___attribute] = ACTIONS(2887),
    [anon_sym_using] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2889),
    [anon_sym___declspec] = ACTIONS(2887),
    [anon_sym___based] = ACTIONS(2887),
    [anon_sym___cdecl] = ACTIONS(2887),
    [anon_sym___clrcall] = ACTIONS(2887),
    [anon_sym___stdcall] = ACTIONS(2887),
    [anon_sym___fastcall] = ACTIONS(2887),
    [anon_sym___thiscall] = ACTIONS(2887),
    [anon_sym___vectorcall] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_signed] = ACTIONS(2887),
    [anon_sym_unsigned] = ACTIONS(2887),
    [anon_sym_long] = ACTIONS(2887),
    [anon_sym_short] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_register] = ACTIONS(2887),
    [anon_sym_inline] = ACTIONS(2887),
    [anon_sym___inline] = ACTIONS(2887),
    [anon_sym___inline__] = ACTIONS(2887),
    [anon_sym___forceinline] = ACTIONS(2887),
    [anon_sym_thread_local] = ACTIONS(2887),
    [anon_sym___thread] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_constexpr] = ACTIONS(2887),
    [anon_sym_volatile] = ACTIONS(2887),
    [anon_sym_restrict] = ACTIONS(2887),
    [anon_sym___restrict__] = ACTIONS(2887),
    [anon_sym__Atomic] = ACTIONS(2887),
    [anon_sym__Noreturn] = ACTIONS(2887),
    [anon_sym_noreturn] = ACTIONS(2887),
    [anon_sym__Nonnull] = ACTIONS(2887),
    [anon_sym_mutable] = ACTIONS(2887),
    [anon_sym_constinit] = ACTIONS(2887),
    [anon_sym_consteval] = ACTIONS(2887),
    [anon_sym_alignas] = ACTIONS(2887),
    [anon_sym__Alignas] = ACTIONS(2887),
    [sym_primitive_type] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_struct] = ACTIONS(2887),
    [anon_sym_union] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2887),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_goto] = ACTIONS(2887),
    [anon_sym___try] = ACTIONS(2887),
    [anon_sym___leave] = ACTIONS(2887),
    [anon_sym_not] = ACTIONS(2887),
    [anon_sym_compl] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_sizeof] = ACTIONS(2887),
    [anon_sym___alignof__] = ACTIONS(2887),
    [anon_sym___alignof] = ACTIONS(2887),
    [anon_sym__alignof] = ACTIONS(2887),
    [anon_sym_alignof] = ACTIONS(2887),
    [anon_sym__Alignof] = ACTIONS(2887),
    [anon_sym_offsetof] = ACTIONS(2887),
    [anon_sym__Generic] = ACTIONS(2887),
    [anon_sym_asm] = ACTIONS(2887),
    [anon_sym___asm__] = ACTIONS(2887),
    [anon_sym___asm] = ACTIONS(2887),
    [sym_number_literal] = ACTIONS(2889),
    [anon_sym_L_SQUOTE] = ACTIONS(2889),
    [anon_sym_u_SQUOTE] = ACTIONS(2889),
    [anon_sym_U_SQUOTE] = ACTIONS(2889),
    [anon_sym_u8_SQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_L_DQUOTE] = ACTIONS(2889),
    [anon_sym_u_DQUOTE] = ACTIONS(2889),
    [anon_sym_U_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [anon_sym_NULL] = ACTIONS(2887),
    [anon_sym_nullptr] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2887),
    [anon_sym_decltype] = ACTIONS(2887),
    [anon_sym_explicit] = ACTIONS(2887),
    [anon_sym_typename] = ACTIONS(2887),
    [anon_sym_template] = ACTIONS(2887),
    [anon_sym_operator] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_namespace] = ACTIONS(2887),
    [anon_sym_static_assert] = ACTIONS(2887),
    [anon_sym_concept] = ACTIONS(2887),
    [anon_sym_co_return] = ACTIONS(2887),
    [anon_sym_co_yield] = ACTIONS(2887),
    [anon_sym_R_DQUOTE] = ACTIONS(2889),
    [anon_sym_LR_DQUOTE] = ACTIONS(2889),
    [anon_sym_uR_DQUOTE] = ACTIONS(2889),
    [anon_sym_UR_DQUOTE] = ACTIONS(2889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2889),
    [anon_sym_co_await] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_requires] = ACTIONS(2887),
    [sym_this] = ACTIONS(2887),
  },
  [685] = {
    [sym_identifier] = ACTIONS(3019),
    [aux_sym_preproc_include_token1] = ACTIONS(3019),
    [aux_sym_preproc_def_token1] = ACTIONS(3019),
    [aux_sym_preproc_if_token1] = ACTIONS(3019),
    [aux_sym_preproc_if_token2] = ACTIONS(3019),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3019),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3019),
    [sym_preproc_directive] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_STAR] = ACTIONS(3021),
    [anon_sym_AMP_AMP] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_SEMI] = ACTIONS(3021),
    [anon_sym___extension__] = ACTIONS(3019),
    [anon_sym_typedef] = ACTIONS(3019),
    [anon_sym_virtual] = ACTIONS(3019),
    [anon_sym_extern] = ACTIONS(3019),
    [anon_sym___attribute__] = ACTIONS(3019),
    [anon_sym___attribute] = ACTIONS(3019),
    [anon_sym_using] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3021),
    [anon_sym___declspec] = ACTIONS(3019),
    [anon_sym___based] = ACTIONS(3019),
    [anon_sym___cdecl] = ACTIONS(3019),
    [anon_sym___clrcall] = ACTIONS(3019),
    [anon_sym___stdcall] = ACTIONS(3019),
    [anon_sym___fastcall] = ACTIONS(3019),
    [anon_sym___thiscall] = ACTIONS(3019),
    [anon_sym___vectorcall] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3021),
    [anon_sym_signed] = ACTIONS(3019),
    [anon_sym_unsigned] = ACTIONS(3019),
    [anon_sym_long] = ACTIONS(3019),
    [anon_sym_short] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_static] = ACTIONS(3019),
    [anon_sym_register] = ACTIONS(3019),
    [anon_sym_inline] = ACTIONS(3019),
    [anon_sym___inline] = ACTIONS(3019),
    [anon_sym___inline__] = ACTIONS(3019),
    [anon_sym___forceinline] = ACTIONS(3019),
    [anon_sym_thread_local] = ACTIONS(3019),
    [anon_sym___thread] = ACTIONS(3019),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_constexpr] = ACTIONS(3019),
    [anon_sym_volatile] = ACTIONS(3019),
    [anon_sym_restrict] = ACTIONS(3019),
    [anon_sym___restrict__] = ACTIONS(3019),
    [anon_sym__Atomic] = ACTIONS(3019),
    [anon_sym__Noreturn] = ACTIONS(3019),
    [anon_sym_noreturn] = ACTIONS(3019),
    [anon_sym__Nonnull] = ACTIONS(3019),
    [anon_sym_mutable] = ACTIONS(3019),
    [anon_sym_constinit] = ACTIONS(3019),
    [anon_sym_consteval] = ACTIONS(3019),
    [anon_sym_alignas] = ACTIONS(3019),
    [anon_sym__Alignas] = ACTIONS(3019),
    [sym_primitive_type] = ACTIONS(3019),
    [anon_sym_enum] = ACTIONS(3019),
    [anon_sym_class] = ACTIONS(3019),
    [anon_sym_struct] = ACTIONS(3019),
    [anon_sym_union] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_switch] = ACTIONS(3019),
    [anon_sym_case] = ACTIONS(3019),
    [anon_sym_default] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_break] = ACTIONS(3019),
    [anon_sym_continue] = ACTIONS(3019),
    [anon_sym_goto] = ACTIONS(3019),
    [anon_sym___try] = ACTIONS(3019),
    [anon_sym___leave] = ACTIONS(3019),
    [anon_sym_not] = ACTIONS(3019),
    [anon_sym_compl] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3021),
    [anon_sym_sizeof] = ACTIONS(3019),
    [anon_sym___alignof__] = ACTIONS(3019),
    [anon_sym___alignof] = ACTIONS(3019),
    [anon_sym__alignof] = ACTIONS(3019),
    [anon_sym_alignof] = ACTIONS(3019),
    [anon_sym__Alignof] = ACTIONS(3019),
    [anon_sym_offsetof] = ACTIONS(3019),
    [anon_sym__Generic] = ACTIONS(3019),
    [anon_sym_asm] = ACTIONS(3019),
    [anon_sym___asm__] = ACTIONS(3019),
    [anon_sym___asm] = ACTIONS(3019),
    [sym_number_literal] = ACTIONS(3021),
    [anon_sym_L_SQUOTE] = ACTIONS(3021),
    [anon_sym_u_SQUOTE] = ACTIONS(3021),
    [anon_sym_U_SQUOTE] = ACTIONS(3021),
    [anon_sym_u8_SQUOTE] = ACTIONS(3021),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [anon_sym_L_DQUOTE] = ACTIONS(3021),
    [anon_sym_u_DQUOTE] = ACTIONS(3021),
    [anon_sym_U_DQUOTE] = ACTIONS(3021),
    [anon_sym_u8_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE] = ACTIONS(3021),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [anon_sym_NULL] = ACTIONS(3019),
    [anon_sym_nullptr] = ACTIONS(3019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3019),
    [anon_sym_decltype] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_typename] = ACTIONS(3019),
    [anon_sym_template] = ACTIONS(3019),
    [anon_sym_operator] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_delete] = ACTIONS(3019),
    [anon_sym_throw] = ACTIONS(3019),
    [anon_sym_namespace] = ACTIONS(3019),
    [anon_sym_static_assert] = ACTIONS(3019),
    [anon_sym_concept] = ACTIONS(3019),
    [anon_sym_co_return] = ACTIONS(3019),
    [anon_sym_co_yield] = ACTIONS(3019),
    [anon_sym_R_DQUOTE] = ACTIONS(3021),
    [anon_sym_LR_DQUOTE] = ACTIONS(3021),
    [anon_sym_uR_DQUOTE] = ACTIONS(3021),
    [anon_sym_UR_DQUOTE] = ACTIONS(3021),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3021),
    [anon_sym_co_await] = ACTIONS(3019),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_requires] = ACTIONS(3019),
    [sym_this] = ACTIONS(3019),
  },
  [686] = {
    [sym_identifier] = ACTIONS(3023),
    [aux_sym_preproc_include_token1] = ACTIONS(3023),
    [aux_sym_preproc_def_token1] = ACTIONS(3023),
    [aux_sym_preproc_if_token1] = ACTIONS(3023),
    [aux_sym_preproc_if_token2] = ACTIONS(3023),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3023),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3023),
    [sym_preproc_directive] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3025),
    [anon_sym_BANG] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(3025),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_STAR] = ACTIONS(3025),
    [anon_sym_AMP_AMP] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym___extension__] = ACTIONS(3023),
    [anon_sym_typedef] = ACTIONS(3023),
    [anon_sym_virtual] = ACTIONS(3023),
    [anon_sym_extern] = ACTIONS(3023),
    [anon_sym___attribute__] = ACTIONS(3023),
    [anon_sym___attribute] = ACTIONS(3023),
    [anon_sym_using] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3025),
    [anon_sym___declspec] = ACTIONS(3023),
    [anon_sym___based] = ACTIONS(3023),
    [anon_sym___cdecl] = ACTIONS(3023),
    [anon_sym___clrcall] = ACTIONS(3023),
    [anon_sym___stdcall] = ACTIONS(3023),
    [anon_sym___fastcall] = ACTIONS(3023),
    [anon_sym___thiscall] = ACTIONS(3023),
    [anon_sym___vectorcall] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3025),
    [anon_sym_signed] = ACTIONS(3023),
    [anon_sym_unsigned] = ACTIONS(3023),
    [anon_sym_long] = ACTIONS(3023),
    [anon_sym_short] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3023),
    [anon_sym_register] = ACTIONS(3023),
    [anon_sym_inline] = ACTIONS(3023),
    [anon_sym___inline] = ACTIONS(3023),
    [anon_sym___inline__] = ACTIONS(3023),
    [anon_sym___forceinline] = ACTIONS(3023),
    [anon_sym_thread_local] = ACTIONS(3023),
    [anon_sym___thread] = ACTIONS(3023),
    [anon_sym_const] = ACTIONS(3023),
    [anon_sym_constexpr] = ACTIONS(3023),
    [anon_sym_volatile] = ACTIONS(3023),
    [anon_sym_restrict] = ACTIONS(3023),
    [anon_sym___restrict__] = ACTIONS(3023),
    [anon_sym__Atomic] = ACTIONS(3023),
    [anon_sym__Noreturn] = ACTIONS(3023),
    [anon_sym_noreturn] = ACTIONS(3023),
    [anon_sym__Nonnull] = ACTIONS(3023),
    [anon_sym_mutable] = ACTIONS(3023),
    [anon_sym_constinit] = ACTIONS(3023),
    [anon_sym_consteval] = ACTIONS(3023),
    [anon_sym_alignas] = ACTIONS(3023),
    [anon_sym__Alignas] = ACTIONS(3023),
    [sym_primitive_type] = ACTIONS(3023),
    [anon_sym_enum] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3023),
    [anon_sym_struct] = ACTIONS(3023),
    [anon_sym_union] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_switch] = ACTIONS(3023),
    [anon_sym_case] = ACTIONS(3023),
    [anon_sym_default] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_break] = ACTIONS(3023),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_goto] = ACTIONS(3023),
    [anon_sym___try] = ACTIONS(3023),
    [anon_sym___leave] = ACTIONS(3023),
    [anon_sym_not] = ACTIONS(3023),
    [anon_sym_compl] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3025),
    [anon_sym_PLUS_PLUS] = ACTIONS(3025),
    [anon_sym_sizeof] = ACTIONS(3023),
    [anon_sym___alignof__] = ACTIONS(3023),
    [anon_sym___alignof] = ACTIONS(3023),
    [anon_sym__alignof] = ACTIONS(3023),
    [anon_sym_alignof] = ACTIONS(3023),
    [anon_sym__Alignof] = ACTIONS(3023),
    [anon_sym_offsetof] = ACTIONS(3023),
    [anon_sym__Generic] = ACTIONS(3023),
    [anon_sym_asm] = ACTIONS(3023),
    [anon_sym___asm__] = ACTIONS(3023),
    [anon_sym___asm] = ACTIONS(3023),
    [sym_number_literal] = ACTIONS(3025),
    [anon_sym_L_SQUOTE] = ACTIONS(3025),
    [anon_sym_u_SQUOTE] = ACTIONS(3025),
    [anon_sym_U_SQUOTE] = ACTIONS(3025),
    [anon_sym_u8_SQUOTE] = ACTIONS(3025),
    [anon_sym_SQUOTE] = ACTIONS(3025),
    [anon_sym_L_DQUOTE] = ACTIONS(3025),
    [anon_sym_u_DQUOTE] = ACTIONS(3025),
    [anon_sym_U_DQUOTE] = ACTIONS(3025),
    [anon_sym_u8_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE] = ACTIONS(3025),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [anon_sym_NULL] = ACTIONS(3023),
    [anon_sym_nullptr] = ACTIONS(3023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3023),
    [anon_sym_decltype] = ACTIONS(3023),
    [anon_sym_explicit] = ACTIONS(3023),
    [anon_sym_typename] = ACTIONS(3023),
    [anon_sym_template] = ACTIONS(3023),
    [anon_sym_operator] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_delete] = ACTIONS(3023),
    [anon_sym_throw] = ACTIONS(3023),
    [anon_sym_namespace] = ACTIONS(3023),
    [anon_sym_static_assert] = ACTIONS(3023),
    [anon_sym_concept] = ACTIONS(3023),
    [anon_sym_co_return] = ACTIONS(3023),
    [anon_sym_co_yield] = ACTIONS(3023),
    [anon_sym_R_DQUOTE] = ACTIONS(3025),
    [anon_sym_LR_DQUOTE] = ACTIONS(3025),
    [anon_sym_uR_DQUOTE] = ACTIONS(3025),
    [anon_sym_UR_DQUOTE] = ACTIONS(3025),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3025),
    [anon_sym_co_await] = ACTIONS(3023),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_requires] = ACTIONS(3023),
    [sym_this] = ACTIONS(3023),
  },
  [687] = {
    [sym_identifier] = ACTIONS(2891),
    [aux_sym_preproc_include_token1] = ACTIONS(2891),
    [aux_sym_preproc_def_token1] = ACTIONS(2891),
    [aux_sym_preproc_if_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2891),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2891),
    [sym_preproc_directive] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2891),
    [anon_sym_typedef] = ACTIONS(2891),
    [anon_sym_virtual] = ACTIONS(2891),
    [anon_sym_extern] = ACTIONS(2891),
    [anon_sym___attribute__] = ACTIONS(2891),
    [anon_sym___attribute] = ACTIONS(2891),
    [anon_sym_using] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2893),
    [anon_sym___declspec] = ACTIONS(2891),
    [anon_sym___based] = ACTIONS(2891),
    [anon_sym___cdecl] = ACTIONS(2891),
    [anon_sym___clrcall] = ACTIONS(2891),
    [anon_sym___stdcall] = ACTIONS(2891),
    [anon_sym___fastcall] = ACTIONS(2891),
    [anon_sym___thiscall] = ACTIONS(2891),
    [anon_sym___vectorcall] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2891),
    [anon_sym_unsigned] = ACTIONS(2891),
    [anon_sym_long] = ACTIONS(2891),
    [anon_sym_short] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_register] = ACTIONS(2891),
    [anon_sym_inline] = ACTIONS(2891),
    [anon_sym___inline] = ACTIONS(2891),
    [anon_sym___inline__] = ACTIONS(2891),
    [anon_sym___forceinline] = ACTIONS(2891),
    [anon_sym_thread_local] = ACTIONS(2891),
    [anon_sym___thread] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_constexpr] = ACTIONS(2891),
    [anon_sym_volatile] = ACTIONS(2891),
    [anon_sym_restrict] = ACTIONS(2891),
    [anon_sym___restrict__] = ACTIONS(2891),
    [anon_sym__Atomic] = ACTIONS(2891),
    [anon_sym__Noreturn] = ACTIONS(2891),
    [anon_sym_noreturn] = ACTIONS(2891),
    [anon_sym__Nonnull] = ACTIONS(2891),
    [anon_sym_mutable] = ACTIONS(2891),
    [anon_sym_constinit] = ACTIONS(2891),
    [anon_sym_consteval] = ACTIONS(2891),
    [anon_sym_alignas] = ACTIONS(2891),
    [anon_sym__Alignas] = ACTIONS(2891),
    [sym_primitive_type] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2891),
    [anon_sym_union] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_goto] = ACTIONS(2891),
    [anon_sym___try] = ACTIONS(2891),
    [anon_sym___leave] = ACTIONS(2891),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_compl] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_sizeof] = ACTIONS(2891),
    [anon_sym___alignof__] = ACTIONS(2891),
    [anon_sym___alignof] = ACTIONS(2891),
    [anon_sym__alignof] = ACTIONS(2891),
    [anon_sym_alignof] = ACTIONS(2891),
    [anon_sym__Alignof] = ACTIONS(2891),
    [anon_sym_offsetof] = ACTIONS(2891),
    [anon_sym__Generic] = ACTIONS(2891),
    [anon_sym_asm] = ACTIONS(2891),
    [anon_sym___asm__] = ACTIONS(2891),
    [anon_sym___asm] = ACTIONS(2891),
    [sym_number_literal] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2893),
    [anon_sym_u_SQUOTE] = ACTIONS(2893),
    [anon_sym_U_SQUOTE] = ACTIONS(2893),
    [anon_sym_u8_SQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_L_DQUOTE] = ACTIONS(2893),
    [anon_sym_u_DQUOTE] = ACTIONS(2893),
    [anon_sym_U_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [anon_sym_NULL] = ACTIONS(2891),
    [anon_sym_nullptr] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2891),
    [anon_sym_decltype] = ACTIONS(2891),
    [anon_sym_explicit] = ACTIONS(2891),
    [anon_sym_typename] = ACTIONS(2891),
    [anon_sym_template] = ACTIONS(2891),
    [anon_sym_operator] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_static_assert] = ACTIONS(2891),
    [anon_sym_concept] = ACTIONS(2891),
    [anon_sym_co_return] = ACTIONS(2891),
    [anon_sym_co_yield] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2893),
    [anon_sym_LR_DQUOTE] = ACTIONS(2893),
    [anon_sym_uR_DQUOTE] = ACTIONS(2893),
    [anon_sym_UR_DQUOTE] = ACTIONS(2893),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2893),
    [anon_sym_co_await] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_requires] = ACTIONS(2891),
    [sym_this] = ACTIONS(2891),
  },
  [688] = {
    [sym_identifier] = ACTIONS(2895),
    [aux_sym_preproc_include_token1] = ACTIONS(2895),
    [aux_sym_preproc_def_token1] = ACTIONS(2895),
    [aux_sym_preproc_if_token1] = ACTIONS(2895),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2895),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2895),
    [sym_preproc_directive] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym___extension__] = ACTIONS(2895),
    [anon_sym_typedef] = ACTIONS(2895),
    [anon_sym_virtual] = ACTIONS(2895),
    [anon_sym_extern] = ACTIONS(2895),
    [anon_sym___attribute__] = ACTIONS(2895),
    [anon_sym___attribute] = ACTIONS(2895),
    [anon_sym_using] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2897),
    [anon_sym___declspec] = ACTIONS(2895),
    [anon_sym___based] = ACTIONS(2895),
    [anon_sym___cdecl] = ACTIONS(2895),
    [anon_sym___clrcall] = ACTIONS(2895),
    [anon_sym___stdcall] = ACTIONS(2895),
    [anon_sym___fastcall] = ACTIONS(2895),
    [anon_sym___thiscall] = ACTIONS(2895),
    [anon_sym___vectorcall] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_signed] = ACTIONS(2895),
    [anon_sym_unsigned] = ACTIONS(2895),
    [anon_sym_long] = ACTIONS(2895),
    [anon_sym_short] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2895),
    [anon_sym_register] = ACTIONS(2895),
    [anon_sym_inline] = ACTIONS(2895),
    [anon_sym___inline] = ACTIONS(2895),
    [anon_sym___inline__] = ACTIONS(2895),
    [anon_sym___forceinline] = ACTIONS(2895),
    [anon_sym_thread_local] = ACTIONS(2895),
    [anon_sym___thread] = ACTIONS(2895),
    [anon_sym_const] = ACTIONS(2895),
    [anon_sym_constexpr] = ACTIONS(2895),
    [anon_sym_volatile] = ACTIONS(2895),
    [anon_sym_restrict] = ACTIONS(2895),
    [anon_sym___restrict__] = ACTIONS(2895),
    [anon_sym__Atomic] = ACTIONS(2895),
    [anon_sym__Noreturn] = ACTIONS(2895),
    [anon_sym_noreturn] = ACTIONS(2895),
    [anon_sym__Nonnull] = ACTIONS(2895),
    [anon_sym_mutable] = ACTIONS(2895),
    [anon_sym_constinit] = ACTIONS(2895),
    [anon_sym_consteval] = ACTIONS(2895),
    [anon_sym_alignas] = ACTIONS(2895),
    [anon_sym__Alignas] = ACTIONS(2895),
    [sym_primitive_type] = ACTIONS(2895),
    [anon_sym_enum] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2895),
    [anon_sym_struct] = ACTIONS(2895),
    [anon_sym_union] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_switch] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2895),
    [anon_sym_default] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_break] = ACTIONS(2895),
    [anon_sym_continue] = ACTIONS(2895),
    [anon_sym_goto] = ACTIONS(2895),
    [anon_sym___try] = ACTIONS(2895),
    [anon_sym___leave] = ACTIONS(2895),
    [anon_sym_not] = ACTIONS(2895),
    [anon_sym_compl] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_sizeof] = ACTIONS(2895),
    [anon_sym___alignof__] = ACTIONS(2895),
    [anon_sym___alignof] = ACTIONS(2895),
    [anon_sym__alignof] = ACTIONS(2895),
    [anon_sym_alignof] = ACTIONS(2895),
    [anon_sym__Alignof] = ACTIONS(2895),
    [anon_sym_offsetof] = ACTIONS(2895),
    [anon_sym__Generic] = ACTIONS(2895),
    [anon_sym_asm] = ACTIONS(2895),
    [anon_sym___asm__] = ACTIONS(2895),
    [anon_sym___asm] = ACTIONS(2895),
    [sym_number_literal] = ACTIONS(2897),
    [anon_sym_L_SQUOTE] = ACTIONS(2897),
    [anon_sym_u_SQUOTE] = ACTIONS(2897),
    [anon_sym_U_SQUOTE] = ACTIONS(2897),
    [anon_sym_u8_SQUOTE] = ACTIONS(2897),
    [anon_sym_SQUOTE] = ACTIONS(2897),
    [anon_sym_L_DQUOTE] = ACTIONS(2897),
    [anon_sym_u_DQUOTE] = ACTIONS(2897),
    [anon_sym_U_DQUOTE] = ACTIONS(2897),
    [anon_sym_u8_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [sym_true] = ACTIONS(2895),
    [sym_false] = ACTIONS(2895),
    [anon_sym_NULL] = ACTIONS(2895),
    [anon_sym_nullptr] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2895),
    [anon_sym_decltype] = ACTIONS(2895),
    [anon_sym_explicit] = ACTIONS(2895),
    [anon_sym_typename] = ACTIONS(2895),
    [anon_sym_template] = ACTIONS(2895),
    [anon_sym_operator] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_delete] = ACTIONS(2895),
    [anon_sym_throw] = ACTIONS(2895),
    [anon_sym_namespace] = ACTIONS(2895),
    [anon_sym_static_assert] = ACTIONS(2895),
    [anon_sym_concept] = ACTIONS(2895),
    [anon_sym_co_return] = ACTIONS(2895),
    [anon_sym_co_yield] = ACTIONS(2895),
    [anon_sym_R_DQUOTE] = ACTIONS(2897),
    [anon_sym_LR_DQUOTE] = ACTIONS(2897),
    [anon_sym_uR_DQUOTE] = ACTIONS(2897),
    [anon_sym_UR_DQUOTE] = ACTIONS(2897),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2897),
    [anon_sym_co_await] = ACTIONS(2895),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_requires] = ACTIONS(2895),
    [sym_this] = ACTIONS(2895),
  },
  [689] = {
    [sym_identifier] = ACTIONS(3027),
    [aux_sym_preproc_include_token1] = ACTIONS(3027),
    [aux_sym_preproc_def_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token2] = ACTIONS(3027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3027),
    [sym_preproc_directive] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3029),
    [anon_sym_BANG] = ACTIONS(3029),
    [anon_sym_TILDE] = ACTIONS(3029),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3029),
    [anon_sym_AMP_AMP] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_SEMI] = ACTIONS(3029),
    [anon_sym___extension__] = ACTIONS(3027),
    [anon_sym_typedef] = ACTIONS(3027),
    [anon_sym_virtual] = ACTIONS(3027),
    [anon_sym_extern] = ACTIONS(3027),
    [anon_sym___attribute__] = ACTIONS(3027),
    [anon_sym___attribute] = ACTIONS(3027),
    [anon_sym_using] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3029),
    [anon_sym___declspec] = ACTIONS(3027),
    [anon_sym___based] = ACTIONS(3027),
    [anon_sym___cdecl] = ACTIONS(3027),
    [anon_sym___clrcall] = ACTIONS(3027),
    [anon_sym___stdcall] = ACTIONS(3027),
    [anon_sym___fastcall] = ACTIONS(3027),
    [anon_sym___thiscall] = ACTIONS(3027),
    [anon_sym___vectorcall] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_signed] = ACTIONS(3027),
    [anon_sym_unsigned] = ACTIONS(3027),
    [anon_sym_long] = ACTIONS(3027),
    [anon_sym_short] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_static] = ACTIONS(3027),
    [anon_sym_register] = ACTIONS(3027),
    [anon_sym_inline] = ACTIONS(3027),
    [anon_sym___inline] = ACTIONS(3027),
    [anon_sym___inline__] = ACTIONS(3027),
    [anon_sym___forceinline] = ACTIONS(3027),
    [anon_sym_thread_local] = ACTIONS(3027),
    [anon_sym___thread] = ACTIONS(3027),
    [anon_sym_const] = ACTIONS(3027),
    [anon_sym_constexpr] = ACTIONS(3027),
    [anon_sym_volatile] = ACTIONS(3027),
    [anon_sym_restrict] = ACTIONS(3027),
    [anon_sym___restrict__] = ACTIONS(3027),
    [anon_sym__Atomic] = ACTIONS(3027),
    [anon_sym__Noreturn] = ACTIONS(3027),
    [anon_sym_noreturn] = ACTIONS(3027),
    [anon_sym__Nonnull] = ACTIONS(3027),
    [anon_sym_mutable] = ACTIONS(3027),
    [anon_sym_constinit] = ACTIONS(3027),
    [anon_sym_consteval] = ACTIONS(3027),
    [anon_sym_alignas] = ACTIONS(3027),
    [anon_sym__Alignas] = ACTIONS(3027),
    [sym_primitive_type] = ACTIONS(3027),
    [anon_sym_enum] = ACTIONS(3027),
    [anon_sym_class] = ACTIONS(3027),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_union] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_switch] = ACTIONS(3027),
    [anon_sym_case] = ACTIONS(3027),
    [anon_sym_default] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_goto] = ACTIONS(3027),
    [anon_sym___try] = ACTIONS(3027),
    [anon_sym___leave] = ACTIONS(3027),
    [anon_sym_not] = ACTIONS(3027),
    [anon_sym_compl] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3029),
    [anon_sym_PLUS_PLUS] = ACTIONS(3029),
    [anon_sym_sizeof] = ACTIONS(3027),
    [anon_sym___alignof__] = ACTIONS(3027),
    [anon_sym___alignof] = ACTIONS(3027),
    [anon_sym__alignof] = ACTIONS(3027),
    [anon_sym_alignof] = ACTIONS(3027),
    [anon_sym__Alignof] = ACTIONS(3027),
    [anon_sym_offsetof] = ACTIONS(3027),
    [anon_sym__Generic] = ACTIONS(3027),
    [anon_sym_asm] = ACTIONS(3027),
    [anon_sym___asm__] = ACTIONS(3027),
    [anon_sym___asm] = ACTIONS(3027),
    [sym_number_literal] = ACTIONS(3029),
    [anon_sym_L_SQUOTE] = ACTIONS(3029),
    [anon_sym_u_SQUOTE] = ACTIONS(3029),
    [anon_sym_U_SQUOTE] = ACTIONS(3029),
    [anon_sym_u8_SQUOTE] = ACTIONS(3029),
    [anon_sym_SQUOTE] = ACTIONS(3029),
    [anon_sym_L_DQUOTE] = ACTIONS(3029),
    [anon_sym_u_DQUOTE] = ACTIONS(3029),
    [anon_sym_U_DQUOTE] = ACTIONS(3029),
    [anon_sym_u8_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE] = ACTIONS(3029),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [anon_sym_NULL] = ACTIONS(3027),
    [anon_sym_nullptr] = ACTIONS(3027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3027),
    [anon_sym_decltype] = ACTIONS(3027),
    [anon_sym_explicit] = ACTIONS(3027),
    [anon_sym_typename] = ACTIONS(3027),
    [anon_sym_template] = ACTIONS(3027),
    [anon_sym_operator] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_delete] = ACTIONS(3027),
    [anon_sym_throw] = ACTIONS(3027),
    [anon_sym_namespace] = ACTIONS(3027),
    [anon_sym_static_assert] = ACTIONS(3027),
    [anon_sym_concept] = ACTIONS(3027),
    [anon_sym_co_return] = ACTIONS(3027),
    [anon_sym_co_yield] = ACTIONS(3027),
    [anon_sym_R_DQUOTE] = ACTIONS(3029),
    [anon_sym_LR_DQUOTE] = ACTIONS(3029),
    [anon_sym_uR_DQUOTE] = ACTIONS(3029),
    [anon_sym_UR_DQUOTE] = ACTIONS(3029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3029),
    [anon_sym_co_await] = ACTIONS(3027),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_requires] = ACTIONS(3027),
    [sym_this] = ACTIONS(3027),
  },
  [690] = {
    [sym_identifier] = ACTIONS(3031),
    [aux_sym_preproc_include_token1] = ACTIONS(3031),
    [aux_sym_preproc_def_token1] = ACTIONS(3031),
    [aux_sym_preproc_if_token1] = ACTIONS(3031),
    [aux_sym_preproc_if_token2] = ACTIONS(3031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3031),
    [sym_preproc_directive] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3033),
    [anon_sym_BANG] = ACTIONS(3033),
    [anon_sym_TILDE] = ACTIONS(3033),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_SEMI] = ACTIONS(3033),
    [anon_sym___extension__] = ACTIONS(3031),
    [anon_sym_typedef] = ACTIONS(3031),
    [anon_sym_virtual] = ACTIONS(3031),
    [anon_sym_extern] = ACTIONS(3031),
    [anon_sym___attribute__] = ACTIONS(3031),
    [anon_sym___attribute] = ACTIONS(3031),
    [anon_sym_using] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3033),
    [anon_sym___declspec] = ACTIONS(3031),
    [anon_sym___based] = ACTIONS(3031),
    [anon_sym___cdecl] = ACTIONS(3031),
    [anon_sym___clrcall] = ACTIONS(3031),
    [anon_sym___stdcall] = ACTIONS(3031),
    [anon_sym___fastcall] = ACTIONS(3031),
    [anon_sym___thiscall] = ACTIONS(3031),
    [anon_sym___vectorcall] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3033),
    [anon_sym_signed] = ACTIONS(3031),
    [anon_sym_unsigned] = ACTIONS(3031),
    [anon_sym_long] = ACTIONS(3031),
    [anon_sym_short] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_static] = ACTIONS(3031),
    [anon_sym_register] = ACTIONS(3031),
    [anon_sym_inline] = ACTIONS(3031),
    [anon_sym___inline] = ACTIONS(3031),
    [anon_sym___inline__] = ACTIONS(3031),
    [anon_sym___forceinline] = ACTIONS(3031),
    [anon_sym_thread_local] = ACTIONS(3031),
    [anon_sym___thread] = ACTIONS(3031),
    [anon_sym_const] = ACTIONS(3031),
    [anon_sym_constexpr] = ACTIONS(3031),
    [anon_sym_volatile] = ACTIONS(3031),
    [anon_sym_restrict] = ACTIONS(3031),
    [anon_sym___restrict__] = ACTIONS(3031),
    [anon_sym__Atomic] = ACTIONS(3031),
    [anon_sym__Noreturn] = ACTIONS(3031),
    [anon_sym_noreturn] = ACTIONS(3031),
    [anon_sym__Nonnull] = ACTIONS(3031),
    [anon_sym_mutable] = ACTIONS(3031),
    [anon_sym_constinit] = ACTIONS(3031),
    [anon_sym_consteval] = ACTIONS(3031),
    [anon_sym_alignas] = ACTIONS(3031),
    [anon_sym__Alignas] = ACTIONS(3031),
    [sym_primitive_type] = ACTIONS(3031),
    [anon_sym_enum] = ACTIONS(3031),
    [anon_sym_class] = ACTIONS(3031),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_union] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_switch] = ACTIONS(3031),
    [anon_sym_case] = ACTIONS(3031),
    [anon_sym_default] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_goto] = ACTIONS(3031),
    [anon_sym___try] = ACTIONS(3031),
    [anon_sym___leave] = ACTIONS(3031),
    [anon_sym_not] = ACTIONS(3031),
    [anon_sym_compl] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3033),
    [anon_sym_PLUS_PLUS] = ACTIONS(3033),
    [anon_sym_sizeof] = ACTIONS(3031),
    [anon_sym___alignof__] = ACTIONS(3031),
    [anon_sym___alignof] = ACTIONS(3031),
    [anon_sym__alignof] = ACTIONS(3031),
    [anon_sym_alignof] = ACTIONS(3031),
    [anon_sym__Alignof] = ACTIONS(3031),
    [anon_sym_offsetof] = ACTIONS(3031),
    [anon_sym__Generic] = ACTIONS(3031),
    [anon_sym_asm] = ACTIONS(3031),
    [anon_sym___asm__] = ACTIONS(3031),
    [anon_sym___asm] = ACTIONS(3031),
    [sym_number_literal] = ACTIONS(3033),
    [anon_sym_L_SQUOTE] = ACTIONS(3033),
    [anon_sym_u_SQUOTE] = ACTIONS(3033),
    [anon_sym_U_SQUOTE] = ACTIONS(3033),
    [anon_sym_u8_SQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3033),
    [anon_sym_L_DQUOTE] = ACTIONS(3033),
    [anon_sym_u_DQUOTE] = ACTIONS(3033),
    [anon_sym_U_DQUOTE] = ACTIONS(3033),
    [anon_sym_u8_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [anon_sym_NULL] = ACTIONS(3031),
    [anon_sym_nullptr] = ACTIONS(3031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3031),
    [anon_sym_decltype] = ACTIONS(3031),
    [anon_sym_explicit] = ACTIONS(3031),
    [anon_sym_typename] = ACTIONS(3031),
    [anon_sym_template] = ACTIONS(3031),
    [anon_sym_operator] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_delete] = ACTIONS(3031),
    [anon_sym_throw] = ACTIONS(3031),
    [anon_sym_namespace] = ACTIONS(3031),
    [anon_sym_static_assert] = ACTIONS(3031),
    [anon_sym_concept] = ACTIONS(3031),
    [anon_sym_co_return] = ACTIONS(3031),
    [anon_sym_co_yield] = ACTIONS(3031),
    [anon_sym_R_DQUOTE] = ACTIONS(3033),
    [anon_sym_LR_DQUOTE] = ACTIONS(3033),
    [anon_sym_uR_DQUOTE] = ACTIONS(3033),
    [anon_sym_UR_DQUOTE] = ACTIONS(3033),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3033),
    [anon_sym_co_await] = ACTIONS(3031),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_requires] = ACTIONS(3031),
    [sym_this] = ACTIONS(3031),
  },
  [691] = {
    [sym_identifier] = ACTIONS(3039),
    [aux_sym_preproc_include_token1] = ACTIONS(3039),
    [aux_sym_preproc_def_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token2] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3039),
    [sym_preproc_directive] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym___extension__] = ACTIONS(3039),
    [anon_sym_typedef] = ACTIONS(3039),
    [anon_sym_virtual] = ACTIONS(3039),
    [anon_sym_extern] = ACTIONS(3039),
    [anon_sym___attribute__] = ACTIONS(3039),
    [anon_sym___attribute] = ACTIONS(3039),
    [anon_sym_using] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3041),
    [anon_sym___declspec] = ACTIONS(3039),
    [anon_sym___based] = ACTIONS(3039),
    [anon_sym___cdecl] = ACTIONS(3039),
    [anon_sym___clrcall] = ACTIONS(3039),
    [anon_sym___stdcall] = ACTIONS(3039),
    [anon_sym___fastcall] = ACTIONS(3039),
    [anon_sym___thiscall] = ACTIONS(3039),
    [anon_sym___vectorcall] = ACTIONS(3039),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_signed] = ACTIONS(3039),
    [anon_sym_unsigned] = ACTIONS(3039),
    [anon_sym_long] = ACTIONS(3039),
    [anon_sym_short] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3039),
    [anon_sym_register] = ACTIONS(3039),
    [anon_sym_inline] = ACTIONS(3039),
    [anon_sym___inline] = ACTIONS(3039),
    [anon_sym___inline__] = ACTIONS(3039),
    [anon_sym___forceinline] = ACTIONS(3039),
    [anon_sym_thread_local] = ACTIONS(3039),
    [anon_sym___thread] = ACTIONS(3039),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_constexpr] = ACTIONS(3039),
    [anon_sym_volatile] = ACTIONS(3039),
    [anon_sym_restrict] = ACTIONS(3039),
    [anon_sym___restrict__] = ACTIONS(3039),
    [anon_sym__Atomic] = ACTIONS(3039),
    [anon_sym__Noreturn] = ACTIONS(3039),
    [anon_sym_noreturn] = ACTIONS(3039),
    [anon_sym__Nonnull] = ACTIONS(3039),
    [anon_sym_mutable] = ACTIONS(3039),
    [anon_sym_constinit] = ACTIONS(3039),
    [anon_sym_consteval] = ACTIONS(3039),
    [anon_sym_alignas] = ACTIONS(3039),
    [anon_sym__Alignas] = ACTIONS(3039),
    [sym_primitive_type] = ACTIONS(3039),
    [anon_sym_enum] = ACTIONS(3039),
    [anon_sym_class] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3039),
    [anon_sym_union] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_switch] = ACTIONS(3039),
    [anon_sym_case] = ACTIONS(3039),
    [anon_sym_default] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_break] = ACTIONS(3039),
    [anon_sym_continue] = ACTIONS(3039),
    [anon_sym_goto] = ACTIONS(3039),
    [anon_sym___try] = ACTIONS(3039),
    [anon_sym___leave] = ACTIONS(3039),
    [anon_sym_not] = ACTIONS(3039),
    [anon_sym_compl] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3041),
    [anon_sym_sizeof] = ACTIONS(3039),
    [anon_sym___alignof__] = ACTIONS(3039),
    [anon_sym___alignof] = ACTIONS(3039),
    [anon_sym__alignof] = ACTIONS(3039),
    [anon_sym_alignof] = ACTIONS(3039),
    [anon_sym__Alignof] = ACTIONS(3039),
    [anon_sym_offsetof] = ACTIONS(3039),
    [anon_sym__Generic] = ACTIONS(3039),
    [anon_sym_asm] = ACTIONS(3039),
    [anon_sym___asm__] = ACTIONS(3039),
    [anon_sym___asm] = ACTIONS(3039),
    [sym_number_literal] = ACTIONS(3041),
    [anon_sym_L_SQUOTE] = ACTIONS(3041),
    [anon_sym_u_SQUOTE] = ACTIONS(3041),
    [anon_sym_U_SQUOTE] = ACTIONS(3041),
    [anon_sym_u8_SQUOTE] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_L_DQUOTE] = ACTIONS(3041),
    [anon_sym_u_DQUOTE] = ACTIONS(3041),
    [anon_sym_U_DQUOTE] = ACTIONS(3041),
    [anon_sym_u8_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [sym_true] = ACTIONS(3039),
    [sym_false] = ACTIONS(3039),
    [anon_sym_NULL] = ACTIONS(3039),
    [anon_sym_nullptr] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3039),
    [anon_sym_decltype] = ACTIONS(3039),
    [anon_sym_explicit] = ACTIONS(3039),
    [anon_sym_typename] = ACTIONS(3039),
    [anon_sym_template] = ACTIONS(3039),
    [anon_sym_operator] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_delete] = ACTIONS(3039),
    [anon_sym_throw] = ACTIONS(3039),
    [anon_sym_namespace] = ACTIONS(3039),
    [anon_sym_static_assert] = ACTIONS(3039),
    [anon_sym_concept] = ACTIONS(3039),
    [anon_sym_co_return] = ACTIONS(3039),
    [anon_sym_co_yield] = ACTIONS(3039),
    [anon_sym_R_DQUOTE] = ACTIONS(3041),
    [anon_sym_LR_DQUOTE] = ACTIONS(3041),
    [anon_sym_uR_DQUOTE] = ACTIONS(3041),
    [anon_sym_UR_DQUOTE] = ACTIONS(3041),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3041),
    [anon_sym_co_await] = ACTIONS(3039),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_requires] = ACTIONS(3039),
    [sym_this] = ACTIONS(3039),
  },
  [692] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_include_token1] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token2] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym___cdecl] = ACTIONS(3063),
    [anon_sym___clrcall] = ACTIONS(3063),
    [anon_sym___stdcall] = ACTIONS(3063),
    [anon_sym___fastcall] = ACTIONS(3063),
    [anon_sym___thiscall] = ACTIONS(3063),
    [anon_sym___vectorcall] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym___try] = ACTIONS(3063),
    [anon_sym___leave] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(3063),
    [anon_sym_compl] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym___alignof__] = ACTIONS(3063),
    [anon_sym___alignof] = ACTIONS(3063),
    [anon_sym__alignof] = ACTIONS(3063),
    [anon_sym_alignof] = ACTIONS(3063),
    [anon_sym__Alignof] = ACTIONS(3063),
    [anon_sym_offsetof] = ACTIONS(3063),
    [anon_sym__Generic] = ACTIONS(3063),
    [anon_sym_asm] = ACTIONS(3063),
    [anon_sym___asm__] = ACTIONS(3063),
    [anon_sym___asm] = ACTIONS(3063),
    [sym_number_literal] = ACTIONS(3065),
    [anon_sym_L_SQUOTE] = ACTIONS(3065),
    [anon_sym_u_SQUOTE] = ACTIONS(3065),
    [anon_sym_U_SQUOTE] = ACTIONS(3065),
    [anon_sym_u8_SQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_L_DQUOTE] = ACTIONS(3065),
    [anon_sym_u_DQUOTE] = ACTIONS(3065),
    [anon_sym_U_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [sym_true] = ACTIONS(3063),
    [sym_false] = ACTIONS(3063),
    [anon_sym_NULL] = ACTIONS(3063),
    [anon_sym_nullptr] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
    [anon_sym_concept] = ACTIONS(3063),
    [anon_sym_co_return] = ACTIONS(3063),
    [anon_sym_co_yield] = ACTIONS(3063),
    [anon_sym_R_DQUOTE] = ACTIONS(3065),
    [anon_sym_LR_DQUOTE] = ACTIONS(3065),
    [anon_sym_uR_DQUOTE] = ACTIONS(3065),
    [anon_sym_UR_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3065),
    [anon_sym_co_await] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_requires] = ACTIONS(3063),
    [sym_this] = ACTIONS(3063),
  },
  [693] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_include_token1] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token2] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym___cdecl] = ACTIONS(3063),
    [anon_sym___clrcall] = ACTIONS(3063),
    [anon_sym___stdcall] = ACTIONS(3063),
    [anon_sym___fastcall] = ACTIONS(3063),
    [anon_sym___thiscall] = ACTIONS(3063),
    [anon_sym___vectorcall] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym___try] = ACTIONS(3063),
    [anon_sym___leave] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(3063),
    [anon_sym_compl] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym___alignof__] = ACTIONS(3063),
    [anon_sym___alignof] = ACTIONS(3063),
    [anon_sym__alignof] = ACTIONS(3063),
    [anon_sym_alignof] = ACTIONS(3063),
    [anon_sym__Alignof] = ACTIONS(3063),
    [anon_sym_offsetof] = ACTIONS(3063),
    [anon_sym__Generic] = ACTIONS(3063),
    [anon_sym_asm] = ACTIONS(3063),
    [anon_sym___asm__] = ACTIONS(3063),
    [anon_sym___asm] = ACTIONS(3063),
    [sym_number_literal] = ACTIONS(3065),
    [anon_sym_L_SQUOTE] = ACTIONS(3065),
    [anon_sym_u_SQUOTE] = ACTIONS(3065),
    [anon_sym_U_SQUOTE] = ACTIONS(3065),
    [anon_sym_u8_SQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_L_DQUOTE] = ACTIONS(3065),
    [anon_sym_u_DQUOTE] = ACTIONS(3065),
    [anon_sym_U_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [sym_true] = ACTIONS(3063),
    [sym_false] = ACTIONS(3063),
    [anon_sym_NULL] = ACTIONS(3063),
    [anon_sym_nullptr] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
    [anon_sym_concept] = ACTIONS(3063),
    [anon_sym_co_return] = ACTIONS(3063),
    [anon_sym_co_yield] = ACTIONS(3063),
    [anon_sym_R_DQUOTE] = ACTIONS(3065),
    [anon_sym_LR_DQUOTE] = ACTIONS(3065),
    [anon_sym_uR_DQUOTE] = ACTIONS(3065),
    [anon_sym_UR_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3065),
    [anon_sym_co_await] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_requires] = ACTIONS(3063),
    [sym_this] = ACTIONS(3063),
  },
  [694] = {
    [sym_identifier] = ACTIONS(3075),
    [aux_sym_preproc_include_token1] = ACTIONS(3075),
    [aux_sym_preproc_def_token1] = ACTIONS(3075),
    [aux_sym_preproc_if_token1] = ACTIONS(3075),
    [aux_sym_preproc_if_token2] = ACTIONS(3075),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3075),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3075),
    [sym_preproc_directive] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3077),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_AMP_AMP] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym___extension__] = ACTIONS(3075),
    [anon_sym_typedef] = ACTIONS(3075),
    [anon_sym_virtual] = ACTIONS(3075),
    [anon_sym_extern] = ACTIONS(3075),
    [anon_sym___attribute__] = ACTIONS(3075),
    [anon_sym___attribute] = ACTIONS(3075),
    [anon_sym_using] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3077),
    [anon_sym___declspec] = ACTIONS(3075),
    [anon_sym___based] = ACTIONS(3075),
    [anon_sym___cdecl] = ACTIONS(3075),
    [anon_sym___clrcall] = ACTIONS(3075),
    [anon_sym___stdcall] = ACTIONS(3075),
    [anon_sym___fastcall] = ACTIONS(3075),
    [anon_sym___thiscall] = ACTIONS(3075),
    [anon_sym___vectorcall] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_signed] = ACTIONS(3075),
    [anon_sym_unsigned] = ACTIONS(3075),
    [anon_sym_long] = ACTIONS(3075),
    [anon_sym_short] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_register] = ACTIONS(3075),
    [anon_sym_inline] = ACTIONS(3075),
    [anon_sym___inline] = ACTIONS(3075),
    [anon_sym___inline__] = ACTIONS(3075),
    [anon_sym___forceinline] = ACTIONS(3075),
    [anon_sym_thread_local] = ACTIONS(3075),
    [anon_sym___thread] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_constexpr] = ACTIONS(3075),
    [anon_sym_volatile] = ACTIONS(3075),
    [anon_sym_restrict] = ACTIONS(3075),
    [anon_sym___restrict__] = ACTIONS(3075),
    [anon_sym__Atomic] = ACTIONS(3075),
    [anon_sym__Noreturn] = ACTIONS(3075),
    [anon_sym_noreturn] = ACTIONS(3075),
    [anon_sym__Nonnull] = ACTIONS(3075),
    [anon_sym_mutable] = ACTIONS(3075),
    [anon_sym_constinit] = ACTIONS(3075),
    [anon_sym_consteval] = ACTIONS(3075),
    [anon_sym_alignas] = ACTIONS(3075),
    [anon_sym__Alignas] = ACTIONS(3075),
    [sym_primitive_type] = ACTIONS(3075),
    [anon_sym_enum] = ACTIONS(3075),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_struct] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_case] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_goto] = ACTIONS(3075),
    [anon_sym___try] = ACTIONS(3075),
    [anon_sym___leave] = ACTIONS(3075),
    [anon_sym_not] = ACTIONS(3075),
    [anon_sym_compl] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_sizeof] = ACTIONS(3075),
    [anon_sym___alignof__] = ACTIONS(3075),
    [anon_sym___alignof] = ACTIONS(3075),
    [anon_sym__alignof] = ACTIONS(3075),
    [anon_sym_alignof] = ACTIONS(3075),
    [anon_sym__Alignof] = ACTIONS(3075),
    [anon_sym_offsetof] = ACTIONS(3075),
    [anon_sym__Generic] = ACTIONS(3075),
    [anon_sym_asm] = ACTIONS(3075),
    [anon_sym___asm__] = ACTIONS(3075),
    [anon_sym___asm] = ACTIONS(3075),
    [sym_number_literal] = ACTIONS(3077),
    [anon_sym_L_SQUOTE] = ACTIONS(3077),
    [anon_sym_u_SQUOTE] = ACTIONS(3077),
    [anon_sym_U_SQUOTE] = ACTIONS(3077),
    [anon_sym_u8_SQUOTE] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [anon_sym_L_DQUOTE] = ACTIONS(3077),
    [anon_sym_u_DQUOTE] = ACTIONS(3077),
    [anon_sym_U_DQUOTE] = ACTIONS(3077),
    [anon_sym_u8_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [sym_true] = ACTIONS(3075),
    [sym_false] = ACTIONS(3075),
    [anon_sym_NULL] = ACTIONS(3075),
    [anon_sym_nullptr] = ACTIONS(3075),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3075),
    [anon_sym_decltype] = ACTIONS(3075),
    [anon_sym_explicit] = ACTIONS(3075),
    [anon_sym_typename] = ACTIONS(3075),
    [anon_sym_template] = ACTIONS(3075),
    [anon_sym_operator] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_delete] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_static_assert] = ACTIONS(3075),
    [anon_sym_concept] = ACTIONS(3075),
    [anon_sym_co_return] = ACTIONS(3075),
    [anon_sym_co_yield] = ACTIONS(3075),
    [anon_sym_R_DQUOTE] = ACTIONS(3077),
    [anon_sym_LR_DQUOTE] = ACTIONS(3077),
    [anon_sym_uR_DQUOTE] = ACTIONS(3077),
    [anon_sym_UR_DQUOTE] = ACTIONS(3077),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3077),
    [anon_sym_co_await] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_requires] = ACTIONS(3075),
    [sym_this] = ACTIONS(3075),
  },
  [695] = {
    [sym_identifier] = ACTIONS(3309),
    [aux_sym_preproc_include_token1] = ACTIONS(3309),
    [aux_sym_preproc_def_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token2] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3309),
    [sym_preproc_directive] = ACTIONS(3309),
    [anon_sym_LPAREN2] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_AMP_AMP] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym___extension__] = ACTIONS(3309),
    [anon_sym_typedef] = ACTIONS(3309),
    [anon_sym_virtual] = ACTIONS(3309),
    [anon_sym_extern] = ACTIONS(3309),
    [anon_sym___attribute__] = ACTIONS(3309),
    [anon_sym___attribute] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_COLON_COLON] = ACTIONS(3311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3311),
    [anon_sym___declspec] = ACTIONS(3309),
    [anon_sym___based] = ACTIONS(3309),
    [anon_sym___cdecl] = ACTIONS(3309),
    [anon_sym___clrcall] = ACTIONS(3309),
    [anon_sym___stdcall] = ACTIONS(3309),
    [anon_sym___fastcall] = ACTIONS(3309),
    [anon_sym___thiscall] = ACTIONS(3309),
    [anon_sym___vectorcall] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_signed] = ACTIONS(3309),
    [anon_sym_unsigned] = ACTIONS(3309),
    [anon_sym_long] = ACTIONS(3309),
    [anon_sym_short] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_register] = ACTIONS(3309),
    [anon_sym_inline] = ACTIONS(3309),
    [anon_sym___inline] = ACTIONS(3309),
    [anon_sym___inline__] = ACTIONS(3309),
    [anon_sym___forceinline] = ACTIONS(3309),
    [anon_sym_thread_local] = ACTIONS(3309),
    [anon_sym___thread] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_constexpr] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(3309),
    [anon_sym_restrict] = ACTIONS(3309),
    [anon_sym___restrict__] = ACTIONS(3309),
    [anon_sym__Atomic] = ACTIONS(3309),
    [anon_sym__Noreturn] = ACTIONS(3309),
    [anon_sym_noreturn] = ACTIONS(3309),
    [anon_sym__Nonnull] = ACTIONS(3309),
    [anon_sym_mutable] = ACTIONS(3309),
    [anon_sym_constinit] = ACTIONS(3309),
    [anon_sym_consteval] = ACTIONS(3309),
    [anon_sym_alignas] = ACTIONS(3309),
    [anon_sym__Alignas] = ACTIONS(3309),
    [sym_primitive_type] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_struct] = ACTIONS(3309),
    [anon_sym_union] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_case] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_goto] = ACTIONS(3309),
    [anon_sym___try] = ACTIONS(3309),
    [anon_sym___leave] = ACTIONS(3309),
    [anon_sym_not] = ACTIONS(3309),
    [anon_sym_compl] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_sizeof] = ACTIONS(3309),
    [anon_sym___alignof__] = ACTIONS(3309),
    [anon_sym___alignof] = ACTIONS(3309),
    [anon_sym__alignof] = ACTIONS(3309),
    [anon_sym_alignof] = ACTIONS(3309),
    [anon_sym__Alignof] = ACTIONS(3309),
    [anon_sym_offsetof] = ACTIONS(3309),
    [anon_sym__Generic] = ACTIONS(3309),
    [anon_sym_asm] = ACTIONS(3309),
    [anon_sym___asm__] = ACTIONS(3309),
    [anon_sym___asm] = ACTIONS(3309),
    [sym_number_literal] = ACTIONS(3311),
    [anon_sym_L_SQUOTE] = ACTIONS(3311),
    [anon_sym_u_SQUOTE] = ACTIONS(3311),
    [anon_sym_U_SQUOTE] = ACTIONS(3311),
    [anon_sym_u8_SQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_L_DQUOTE] = ACTIONS(3311),
    [anon_sym_u_DQUOTE] = ACTIONS(3311),
    [anon_sym_U_DQUOTE] = ACTIONS(3311),
    [anon_sym_u8_DQUOTE] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3309),
    [anon_sym_nullptr] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3309),
    [anon_sym_decltype] = ACTIONS(3309),
    [anon_sym_explicit] = ACTIONS(3309),
    [anon_sym_typename] = ACTIONS(3309),
    [anon_sym_template] = ACTIONS(3309),
    [anon_sym_operator] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_static_assert] = ACTIONS(3309),
    [anon_sym_concept] = ACTIONS(3309),
    [anon_sym_co_return] = ACTIONS(3309),
    [anon_sym_co_yield] = ACTIONS(3309),
    [anon_sym_R_DQUOTE] = ACTIONS(3311),
    [anon_sym_LR_DQUOTE] = ACTIONS(3311),
    [anon_sym_uR_DQUOTE] = ACTIONS(3311),
    [anon_sym_UR_DQUOTE] = ACTIONS(3311),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3311),
    [anon_sym_co_await] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_requires] = ACTIONS(3309),
    [sym_this] = ACTIONS(3309),
  },
  [696] = {
    [sym_identifier] = ACTIONS(2775),
    [aux_sym_preproc_include_token1] = ACTIONS(2775),
    [aux_sym_preproc_def_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token2] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2775),
    [sym_preproc_directive] = ACTIONS(2775),
    [anon_sym_LPAREN2] = ACTIONS(2777),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_TILDE] = ACTIONS(2777),
    [anon_sym_DASH] = ACTIONS(2775),
    [anon_sym_PLUS] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym___extension__] = ACTIONS(2775),
    [anon_sym_typedef] = ACTIONS(2775),
    [anon_sym_virtual] = ACTIONS(2775),
    [anon_sym_extern] = ACTIONS(2775),
    [anon_sym___attribute__] = ACTIONS(2775),
    [anon_sym___attribute] = ACTIONS(2775),
    [anon_sym_using] = ACTIONS(2775),
    [anon_sym_COLON_COLON] = ACTIONS(2777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2777),
    [anon_sym___declspec] = ACTIONS(2775),
    [anon_sym___based] = ACTIONS(2775),
    [anon_sym___cdecl] = ACTIONS(2775),
    [anon_sym___clrcall] = ACTIONS(2775),
    [anon_sym___stdcall] = ACTIONS(2775),
    [anon_sym___fastcall] = ACTIONS(2775),
    [anon_sym___thiscall] = ACTIONS(2775),
    [anon_sym___vectorcall] = ACTIONS(2775),
    [anon_sym_LBRACE] = ACTIONS(2777),
    [anon_sym_signed] = ACTIONS(2775),
    [anon_sym_unsigned] = ACTIONS(2775),
    [anon_sym_long] = ACTIONS(2775),
    [anon_sym_short] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_static] = ACTIONS(2775),
    [anon_sym_register] = ACTIONS(2775),
    [anon_sym_inline] = ACTIONS(2775),
    [anon_sym___inline] = ACTIONS(2775),
    [anon_sym___inline__] = ACTIONS(2775),
    [anon_sym___forceinline] = ACTIONS(2775),
    [anon_sym_thread_local] = ACTIONS(2775),
    [anon_sym___thread] = ACTIONS(2775),
    [anon_sym_const] = ACTIONS(2775),
    [anon_sym_constexpr] = ACTIONS(2775),
    [anon_sym_volatile] = ACTIONS(2775),
    [anon_sym_restrict] = ACTIONS(2775),
    [anon_sym___restrict__] = ACTIONS(2775),
    [anon_sym__Atomic] = ACTIONS(2775),
    [anon_sym__Noreturn] = ACTIONS(2775),
    [anon_sym_noreturn] = ACTIONS(2775),
    [anon_sym__Nonnull] = ACTIONS(2775),
    [anon_sym_mutable] = ACTIONS(2775),
    [anon_sym_constinit] = ACTIONS(2775),
    [anon_sym_consteval] = ACTIONS(2775),
    [anon_sym_alignas] = ACTIONS(2775),
    [anon_sym__Alignas] = ACTIONS(2775),
    [sym_primitive_type] = ACTIONS(2775),
    [anon_sym_enum] = ACTIONS(2775),
    [anon_sym_class] = ACTIONS(2775),
    [anon_sym_struct] = ACTIONS(2775),
    [anon_sym_union] = ACTIONS(2775),
    [anon_sym_if] = ACTIONS(2775),
    [anon_sym_switch] = ACTIONS(2775),
    [anon_sym_case] = ACTIONS(2775),
    [anon_sym_default] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(2775),
    [anon_sym_do] = ACTIONS(2775),
    [anon_sym_for] = ACTIONS(2775),
    [anon_sym_return] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2775),
    [anon_sym_continue] = ACTIONS(2775),
    [anon_sym_goto] = ACTIONS(2775),
    [anon_sym___try] = ACTIONS(2775),
    [anon_sym___leave] = ACTIONS(2775),
    [anon_sym_not] = ACTIONS(2775),
    [anon_sym_compl] = ACTIONS(2775),
    [anon_sym_DASH_DASH] = ACTIONS(2777),
    [anon_sym_PLUS_PLUS] = ACTIONS(2777),
    [anon_sym_sizeof] = ACTIONS(2775),
    [anon_sym___alignof__] = ACTIONS(2775),
    [anon_sym___alignof] = ACTIONS(2775),
    [anon_sym__alignof] = ACTIONS(2775),
    [anon_sym_alignof] = ACTIONS(2775),
    [anon_sym__Alignof] = ACTIONS(2775),
    [anon_sym_offsetof] = ACTIONS(2775),
    [anon_sym__Generic] = ACTIONS(2775),
    [anon_sym_asm] = ACTIONS(2775),
    [anon_sym___asm__] = ACTIONS(2775),
    [anon_sym___asm] = ACTIONS(2775),
    [sym_number_literal] = ACTIONS(2777),
    [anon_sym_L_SQUOTE] = ACTIONS(2777),
    [anon_sym_u_SQUOTE] = ACTIONS(2777),
    [anon_sym_U_SQUOTE] = ACTIONS(2777),
    [anon_sym_u8_SQUOTE] = ACTIONS(2777),
    [anon_sym_SQUOTE] = ACTIONS(2777),
    [anon_sym_L_DQUOTE] = ACTIONS(2777),
    [anon_sym_u_DQUOTE] = ACTIONS(2777),
    [anon_sym_U_DQUOTE] = ACTIONS(2777),
    [anon_sym_u8_DQUOTE] = ACTIONS(2777),
    [anon_sym_DQUOTE] = ACTIONS(2777),
    [sym_true] = ACTIONS(2775),
    [sym_false] = ACTIONS(2775),
    [anon_sym_NULL] = ACTIONS(2775),
    [anon_sym_nullptr] = ACTIONS(2775),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2775),
    [anon_sym_decltype] = ACTIONS(2775),
    [anon_sym_explicit] = ACTIONS(2775),
    [anon_sym_typename] = ACTIONS(2775),
    [anon_sym_template] = ACTIONS(2775),
    [anon_sym_operator] = ACTIONS(2775),
    [anon_sym_try] = ACTIONS(2775),
    [anon_sym_delete] = ACTIONS(2775),
    [anon_sym_throw] = ACTIONS(2775),
    [anon_sym_namespace] = ACTIONS(2775),
    [anon_sym_static_assert] = ACTIONS(2775),
    [anon_sym_concept] = ACTIONS(2775),
    [anon_sym_co_return] = ACTIONS(2775),
    [anon_sym_co_yield] = ACTIONS(2775),
    [anon_sym_R_DQUOTE] = ACTIONS(2777),
    [anon_sym_LR_DQUOTE] = ACTIONS(2777),
    [anon_sym_uR_DQUOTE] = ACTIONS(2777),
    [anon_sym_UR_DQUOTE] = ACTIONS(2777),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2777),
    [anon_sym_co_await] = ACTIONS(2775),
    [anon_sym_new] = ACTIONS(2775),
    [anon_sym_requires] = ACTIONS(2775),
    [sym_this] = ACTIONS(2775),
  },
  [697] = {
    [sym_identifier] = ACTIONS(2899),
    [aux_sym_preproc_include_token1] = ACTIONS(2899),
    [aux_sym_preproc_def_token1] = ACTIONS(2899),
    [aux_sym_preproc_if_token1] = ACTIONS(2899),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2899),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2899),
    [sym_preproc_directive] = ACTIONS(2899),
    [anon_sym_LPAREN2] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_PLUS] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym___extension__] = ACTIONS(2899),
    [anon_sym_typedef] = ACTIONS(2899),
    [anon_sym_virtual] = ACTIONS(2899),
    [anon_sym_extern] = ACTIONS(2899),
    [anon_sym___attribute__] = ACTIONS(2899),
    [anon_sym___attribute] = ACTIONS(2899),
    [anon_sym_using] = ACTIONS(2899),
    [anon_sym_COLON_COLON] = ACTIONS(2901),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2901),
    [anon_sym___declspec] = ACTIONS(2899),
    [anon_sym___based] = ACTIONS(2899),
    [anon_sym___cdecl] = ACTIONS(2899),
    [anon_sym___clrcall] = ACTIONS(2899),
    [anon_sym___stdcall] = ACTIONS(2899),
    [anon_sym___fastcall] = ACTIONS(2899),
    [anon_sym___thiscall] = ACTIONS(2899),
    [anon_sym___vectorcall] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2901),
    [anon_sym_signed] = ACTIONS(2899),
    [anon_sym_unsigned] = ACTIONS(2899),
    [anon_sym_long] = ACTIONS(2899),
    [anon_sym_short] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_static] = ACTIONS(2899),
    [anon_sym_register] = ACTIONS(2899),
    [anon_sym_inline] = ACTIONS(2899),
    [anon_sym___inline] = ACTIONS(2899),
    [anon_sym___inline__] = ACTIONS(2899),
    [anon_sym___forceinline] = ACTIONS(2899),
    [anon_sym_thread_local] = ACTIONS(2899),
    [anon_sym___thread] = ACTIONS(2899),
    [anon_sym_const] = ACTIONS(2899),
    [anon_sym_constexpr] = ACTIONS(2899),
    [anon_sym_volatile] = ACTIONS(2899),
    [anon_sym_restrict] = ACTIONS(2899),
    [anon_sym___restrict__] = ACTIONS(2899),
    [anon_sym__Atomic] = ACTIONS(2899),
    [anon_sym__Noreturn] = ACTIONS(2899),
    [anon_sym_noreturn] = ACTIONS(2899),
    [anon_sym__Nonnull] = ACTIONS(2899),
    [anon_sym_mutable] = ACTIONS(2899),
    [anon_sym_constinit] = ACTIONS(2899),
    [anon_sym_consteval] = ACTIONS(2899),
    [anon_sym_alignas] = ACTIONS(2899),
    [anon_sym__Alignas] = ACTIONS(2899),
    [sym_primitive_type] = ACTIONS(2899),
    [anon_sym_enum] = ACTIONS(2899),
    [anon_sym_class] = ACTIONS(2899),
    [anon_sym_struct] = ACTIONS(2899),
    [anon_sym_union] = ACTIONS(2899),
    [anon_sym_if] = ACTIONS(2899),
    [anon_sym_switch] = ACTIONS(2899),
    [anon_sym_case] = ACTIONS(2899),
    [anon_sym_default] = ACTIONS(2899),
    [anon_sym_while] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2899),
    [anon_sym_for] = ACTIONS(2899),
    [anon_sym_return] = ACTIONS(2899),
    [anon_sym_break] = ACTIONS(2899),
    [anon_sym_continue] = ACTIONS(2899),
    [anon_sym_goto] = ACTIONS(2899),
    [anon_sym___try] = ACTIONS(2899),
    [anon_sym___leave] = ACTIONS(2899),
    [anon_sym_not] = ACTIONS(2899),
    [anon_sym_compl] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_sizeof] = ACTIONS(2899),
    [anon_sym___alignof__] = ACTIONS(2899),
    [anon_sym___alignof] = ACTIONS(2899),
    [anon_sym__alignof] = ACTIONS(2899),
    [anon_sym_alignof] = ACTIONS(2899),
    [anon_sym__Alignof] = ACTIONS(2899),
    [anon_sym_offsetof] = ACTIONS(2899),
    [anon_sym__Generic] = ACTIONS(2899),
    [anon_sym_asm] = ACTIONS(2899),
    [anon_sym___asm__] = ACTIONS(2899),
    [anon_sym___asm] = ACTIONS(2899),
    [sym_number_literal] = ACTIONS(2901),
    [anon_sym_L_SQUOTE] = ACTIONS(2901),
    [anon_sym_u_SQUOTE] = ACTIONS(2901),
    [anon_sym_U_SQUOTE] = ACTIONS(2901),
    [anon_sym_u8_SQUOTE] = ACTIONS(2901),
    [anon_sym_SQUOTE] = ACTIONS(2901),
    [anon_sym_L_DQUOTE] = ACTIONS(2901),
    [anon_sym_u_DQUOTE] = ACTIONS(2901),
    [anon_sym_U_DQUOTE] = ACTIONS(2901),
    [anon_sym_u8_DQUOTE] = ACTIONS(2901),
    [anon_sym_DQUOTE] = ACTIONS(2901),
    [sym_true] = ACTIONS(2899),
    [sym_false] = ACTIONS(2899),
    [anon_sym_NULL] = ACTIONS(2899),
    [anon_sym_nullptr] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2899),
    [anon_sym_decltype] = ACTIONS(2899),
    [anon_sym_explicit] = ACTIONS(2899),
    [anon_sym_typename] = ACTIONS(2899),
    [anon_sym_template] = ACTIONS(2899),
    [anon_sym_operator] = ACTIONS(2899),
    [anon_sym_try] = ACTIONS(2899),
    [anon_sym_delete] = ACTIONS(2899),
    [anon_sym_throw] = ACTIONS(2899),
    [anon_sym_namespace] = ACTIONS(2899),
    [anon_sym_static_assert] = ACTIONS(2899),
    [anon_sym_concept] = ACTIONS(2899),
    [anon_sym_co_return] = ACTIONS(2899),
    [anon_sym_co_yield] = ACTIONS(2899),
    [anon_sym_R_DQUOTE] = ACTIONS(2901),
    [anon_sym_LR_DQUOTE] = ACTIONS(2901),
    [anon_sym_uR_DQUOTE] = ACTIONS(2901),
    [anon_sym_UR_DQUOTE] = ACTIONS(2901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2901),
    [anon_sym_co_await] = ACTIONS(2899),
    [anon_sym_new] = ACTIONS(2899),
    [anon_sym_requires] = ACTIONS(2899),
    [sym_this] = ACTIONS(2899),
  },
  [698] = {
    [sym_identifier] = ACTIONS(2787),
    [aux_sym_preproc_include_token1] = ACTIONS(2787),
    [aux_sym_preproc_def_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token2] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2787),
    [sym_preproc_directive] = ACTIONS(2787),
    [anon_sym_LPAREN2] = ACTIONS(2789),
    [anon_sym_BANG] = ACTIONS(2789),
    [anon_sym_TILDE] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym___extension__] = ACTIONS(2787),
    [anon_sym_typedef] = ACTIONS(2787),
    [anon_sym_virtual] = ACTIONS(2787),
    [anon_sym_extern] = ACTIONS(2787),
    [anon_sym___attribute__] = ACTIONS(2787),
    [anon_sym___attribute] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2789),
    [anon_sym___declspec] = ACTIONS(2787),
    [anon_sym___based] = ACTIONS(2787),
    [anon_sym___cdecl] = ACTIONS(2787),
    [anon_sym___clrcall] = ACTIONS(2787),
    [anon_sym___stdcall] = ACTIONS(2787),
    [anon_sym___fastcall] = ACTIONS(2787),
    [anon_sym___thiscall] = ACTIONS(2787),
    [anon_sym___vectorcall] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_signed] = ACTIONS(2787),
    [anon_sym_unsigned] = ACTIONS(2787),
    [anon_sym_long] = ACTIONS(2787),
    [anon_sym_short] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_static] = ACTIONS(2787),
    [anon_sym_register] = ACTIONS(2787),
    [anon_sym_inline] = ACTIONS(2787),
    [anon_sym___inline] = ACTIONS(2787),
    [anon_sym___inline__] = ACTIONS(2787),
    [anon_sym___forceinline] = ACTIONS(2787),
    [anon_sym_thread_local] = ACTIONS(2787),
    [anon_sym___thread] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_constexpr] = ACTIONS(2787),
    [anon_sym_volatile] = ACTIONS(2787),
    [anon_sym_restrict] = ACTIONS(2787),
    [anon_sym___restrict__] = ACTIONS(2787),
    [anon_sym__Atomic] = ACTIONS(2787),
    [anon_sym__Noreturn] = ACTIONS(2787),
    [anon_sym_noreturn] = ACTIONS(2787),
    [anon_sym__Nonnull] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_constinit] = ACTIONS(2787),
    [anon_sym_consteval] = ACTIONS(2787),
    [anon_sym_alignas] = ACTIONS(2787),
    [anon_sym__Alignas] = ACTIONS(2787),
    [sym_primitive_type] = ACTIONS(2787),
    [anon_sym_enum] = ACTIONS(2787),
    [anon_sym_class] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_union] = ACTIONS(2787),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_switch] = ACTIONS(2787),
    [anon_sym_case] = ACTIONS(2787),
    [anon_sym_default] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [anon_sym_do] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_break] = ACTIONS(2787),
    [anon_sym_continue] = ACTIONS(2787),
    [anon_sym_goto] = ACTIONS(2787),
    [anon_sym___try] = ACTIONS(2787),
    [anon_sym___leave] = ACTIONS(2787),
    [anon_sym_not] = ACTIONS(2787),
    [anon_sym_compl] = ACTIONS(2787),
    [anon_sym_DASH_DASH] = ACTIONS(2789),
    [anon_sym_PLUS_PLUS] = ACTIONS(2789),
    [anon_sym_sizeof] = ACTIONS(2787),
    [anon_sym___alignof__] = ACTIONS(2787),
    [anon_sym___alignof] = ACTIONS(2787),
    [anon_sym__alignof] = ACTIONS(2787),
    [anon_sym_alignof] = ACTIONS(2787),
    [anon_sym__Alignof] = ACTIONS(2787),
    [anon_sym_offsetof] = ACTIONS(2787),
    [anon_sym__Generic] = ACTIONS(2787),
    [anon_sym_asm] = ACTIONS(2787),
    [anon_sym___asm__] = ACTIONS(2787),
    [anon_sym___asm] = ACTIONS(2787),
    [sym_number_literal] = ACTIONS(2789),
    [anon_sym_L_SQUOTE] = ACTIONS(2789),
    [anon_sym_u_SQUOTE] = ACTIONS(2789),
    [anon_sym_U_SQUOTE] = ACTIONS(2789),
    [anon_sym_u8_SQUOTE] = ACTIONS(2789),
    [anon_sym_SQUOTE] = ACTIONS(2789),
    [anon_sym_L_DQUOTE] = ACTIONS(2789),
    [anon_sym_u_DQUOTE] = ACTIONS(2789),
    [anon_sym_U_DQUOTE] = ACTIONS(2789),
    [anon_sym_u8_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE] = ACTIONS(2789),
    [sym_true] = ACTIONS(2787),
    [sym_false] = ACTIONS(2787),
    [anon_sym_NULL] = ACTIONS(2787),
    [anon_sym_nullptr] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2787),
    [anon_sym_decltype] = ACTIONS(2787),
    [anon_sym_explicit] = ACTIONS(2787),
    [anon_sym_typename] = ACTIONS(2787),
    [anon_sym_template] = ACTIONS(2787),
    [anon_sym_operator] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_delete] = ACTIONS(2787),
    [anon_sym_throw] = ACTIONS(2787),
    [anon_sym_namespace] = ACTIONS(2787),
    [anon_sym_static_assert] = ACTIONS(2787),
    [anon_sym_concept] = ACTIONS(2787),
    [anon_sym_co_return] = ACTIONS(2787),
    [anon_sym_co_yield] = ACTIONS(2787),
    [anon_sym_R_DQUOTE] = ACTIONS(2789),
    [anon_sym_LR_DQUOTE] = ACTIONS(2789),
    [anon_sym_uR_DQUOTE] = ACTIONS(2789),
    [anon_sym_UR_DQUOTE] = ACTIONS(2789),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2789),
    [anon_sym_co_await] = ACTIONS(2787),
    [anon_sym_new] = ACTIONS(2787),
    [anon_sym_requires] = ACTIONS(2787),
    [sym_this] = ACTIONS(2787),
  },
  [699] = {
    [sym_identifier] = ACTIONS(2791),
    [aux_sym_preproc_include_token1] = ACTIONS(2791),
    [aux_sym_preproc_def_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token2] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2791),
    [sym_preproc_directive] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2793),
    [anon_sym_BANG] = ACTIONS(2793),
    [anon_sym_TILDE] = ACTIONS(2793),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym___extension__] = ACTIONS(2791),
    [anon_sym_typedef] = ACTIONS(2791),
    [anon_sym_virtual] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym___attribute__] = ACTIONS(2791),
    [anon_sym___attribute] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2793),
    [anon_sym___declspec] = ACTIONS(2791),
    [anon_sym___based] = ACTIONS(2791),
    [anon_sym___cdecl] = ACTIONS(2791),
    [anon_sym___clrcall] = ACTIONS(2791),
    [anon_sym___stdcall] = ACTIONS(2791),
    [anon_sym___fastcall] = ACTIONS(2791),
    [anon_sym___thiscall] = ACTIONS(2791),
    [anon_sym___vectorcall] = ACTIONS(2791),
    [anon_sym_LBRACE] = ACTIONS(2793),
    [anon_sym_signed] = ACTIONS(2791),
    [anon_sym_unsigned] = ACTIONS(2791),
    [anon_sym_long] = ACTIONS(2791),
    [anon_sym_short] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_register] = ACTIONS(2791),
    [anon_sym_inline] = ACTIONS(2791),
    [anon_sym___inline] = ACTIONS(2791),
    [anon_sym___inline__] = ACTIONS(2791),
    [anon_sym___forceinline] = ACTIONS(2791),
    [anon_sym_thread_local] = ACTIONS(2791),
    [anon_sym___thread] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_constexpr] = ACTIONS(2791),
    [anon_sym_volatile] = ACTIONS(2791),
    [anon_sym_restrict] = ACTIONS(2791),
    [anon_sym___restrict__] = ACTIONS(2791),
    [anon_sym__Atomic] = ACTIONS(2791),
    [anon_sym__Noreturn] = ACTIONS(2791),
    [anon_sym_noreturn] = ACTIONS(2791),
    [anon_sym__Nonnull] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_constinit] = ACTIONS(2791),
    [anon_sym_consteval] = ACTIONS(2791),
    [anon_sym_alignas] = ACTIONS(2791),
    [anon_sym__Alignas] = ACTIONS(2791),
    [sym_primitive_type] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_class] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_switch] = ACTIONS(2791),
    [anon_sym_case] = ACTIONS(2791),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_break] = ACTIONS(2791),
    [anon_sym_continue] = ACTIONS(2791),
    [anon_sym_goto] = ACTIONS(2791),
    [anon_sym___try] = ACTIONS(2791),
    [anon_sym___leave] = ACTIONS(2791),
    [anon_sym_not] = ACTIONS(2791),
    [anon_sym_compl] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(2793),
    [anon_sym_PLUS_PLUS] = ACTIONS(2793),
    [anon_sym_sizeof] = ACTIONS(2791),
    [anon_sym___alignof__] = ACTIONS(2791),
    [anon_sym___alignof] = ACTIONS(2791),
    [anon_sym__alignof] = ACTIONS(2791),
    [anon_sym_alignof] = ACTIONS(2791),
    [anon_sym__Alignof] = ACTIONS(2791),
    [anon_sym_offsetof] = ACTIONS(2791),
    [anon_sym__Generic] = ACTIONS(2791),
    [anon_sym_asm] = ACTIONS(2791),
    [anon_sym___asm__] = ACTIONS(2791),
    [anon_sym___asm] = ACTIONS(2791),
    [sym_number_literal] = ACTIONS(2793),
    [anon_sym_L_SQUOTE] = ACTIONS(2793),
    [anon_sym_u_SQUOTE] = ACTIONS(2793),
    [anon_sym_U_SQUOTE] = ACTIONS(2793),
    [anon_sym_u8_SQUOTE] = ACTIONS(2793),
    [anon_sym_SQUOTE] = ACTIONS(2793),
    [anon_sym_L_DQUOTE] = ACTIONS(2793),
    [anon_sym_u_DQUOTE] = ACTIONS(2793),
    [anon_sym_U_DQUOTE] = ACTIONS(2793),
    [anon_sym_u8_DQUOTE] = ACTIONS(2793),
    [anon_sym_DQUOTE] = ACTIONS(2793),
    [sym_true] = ACTIONS(2791),
    [sym_false] = ACTIONS(2791),
    [anon_sym_NULL] = ACTIONS(2791),
    [anon_sym_nullptr] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2791),
    [anon_sym_decltype] = ACTIONS(2791),
    [anon_sym_explicit] = ACTIONS(2791),
    [anon_sym_typename] = ACTIONS(2791),
    [anon_sym_template] = ACTIONS(2791),
    [anon_sym_operator] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_delete] = ACTIONS(2791),
    [anon_sym_throw] = ACTIONS(2791),
    [anon_sym_namespace] = ACTIONS(2791),
    [anon_sym_static_assert] = ACTIONS(2791),
    [anon_sym_concept] = ACTIONS(2791),
    [anon_sym_co_return] = ACTIONS(2791),
    [anon_sym_co_yield] = ACTIONS(2791),
    [anon_sym_R_DQUOTE] = ACTIONS(2793),
    [anon_sym_LR_DQUOTE] = ACTIONS(2793),
    [anon_sym_uR_DQUOTE] = ACTIONS(2793),
    [anon_sym_UR_DQUOTE] = ACTIONS(2793),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2793),
    [anon_sym_co_await] = ACTIONS(2791),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_requires] = ACTIONS(2791),
    [sym_this] = ACTIONS(2791),
  },
  [700] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym___try] = ACTIONS(2799),
    [anon_sym___leave] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [701] = {
    [sym_identifier] = ACTIONS(2807),
    [aux_sym_preproc_include_token1] = ACTIONS(2807),
    [aux_sym_preproc_def_token1] = ACTIONS(2807),
    [aux_sym_preproc_if_token1] = ACTIONS(2807),
    [aux_sym_preproc_if_token2] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2807),
    [sym_preproc_directive] = ACTIONS(2807),
    [anon_sym_LPAREN2] = ACTIONS(2809),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_TILDE] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2807),
    [anon_sym_typedef] = ACTIONS(2807),
    [anon_sym_virtual] = ACTIONS(2807),
    [anon_sym_extern] = ACTIONS(2807),
    [anon_sym___attribute__] = ACTIONS(2807),
    [anon_sym___attribute] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2809),
    [anon_sym___declspec] = ACTIONS(2807),
    [anon_sym___based] = ACTIONS(2807),
    [anon_sym___cdecl] = ACTIONS(2807),
    [anon_sym___clrcall] = ACTIONS(2807),
    [anon_sym___stdcall] = ACTIONS(2807),
    [anon_sym___fastcall] = ACTIONS(2807),
    [anon_sym___thiscall] = ACTIONS(2807),
    [anon_sym___vectorcall] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2809),
    [anon_sym_signed] = ACTIONS(2807),
    [anon_sym_unsigned] = ACTIONS(2807),
    [anon_sym_long] = ACTIONS(2807),
    [anon_sym_short] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_static] = ACTIONS(2807),
    [anon_sym_register] = ACTIONS(2807),
    [anon_sym_inline] = ACTIONS(2807),
    [anon_sym___inline] = ACTIONS(2807),
    [anon_sym___inline__] = ACTIONS(2807),
    [anon_sym___forceinline] = ACTIONS(2807),
    [anon_sym_thread_local] = ACTIONS(2807),
    [anon_sym___thread] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_constexpr] = ACTIONS(2807),
    [anon_sym_volatile] = ACTIONS(2807),
    [anon_sym_restrict] = ACTIONS(2807),
    [anon_sym___restrict__] = ACTIONS(2807),
    [anon_sym__Atomic] = ACTIONS(2807),
    [anon_sym__Noreturn] = ACTIONS(2807),
    [anon_sym_noreturn] = ACTIONS(2807),
    [anon_sym__Nonnull] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_constinit] = ACTIONS(2807),
    [anon_sym_consteval] = ACTIONS(2807),
    [anon_sym_alignas] = ACTIONS(2807),
    [anon_sym__Alignas] = ACTIONS(2807),
    [sym_primitive_type] = ACTIONS(2807),
    [anon_sym_enum] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_union] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_switch] = ACTIONS(2807),
    [anon_sym_case] = ACTIONS(2807),
    [anon_sym_default] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_for] = ACTIONS(2807),
    [anon_sym_return] = ACTIONS(2807),
    [anon_sym_break] = ACTIONS(2807),
    [anon_sym_continue] = ACTIONS(2807),
    [anon_sym_goto] = ACTIONS(2807),
    [anon_sym___try] = ACTIONS(2807),
    [anon_sym___leave] = ACTIONS(2807),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2809),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2807),
    [anon_sym___alignof] = ACTIONS(2807),
    [anon_sym__alignof] = ACTIONS(2807),
    [anon_sym_alignof] = ACTIONS(2807),
    [anon_sym__Alignof] = ACTIONS(2807),
    [anon_sym_offsetof] = ACTIONS(2807),
    [anon_sym__Generic] = ACTIONS(2807),
    [anon_sym_asm] = ACTIONS(2807),
    [anon_sym___asm__] = ACTIONS(2807),
    [anon_sym___asm] = ACTIONS(2807),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2809),
    [anon_sym_u_SQUOTE] = ACTIONS(2809),
    [anon_sym_U_SQUOTE] = ACTIONS(2809),
    [anon_sym_u8_SQUOTE] = ACTIONS(2809),
    [anon_sym_SQUOTE] = ACTIONS(2809),
    [anon_sym_L_DQUOTE] = ACTIONS(2809),
    [anon_sym_u_DQUOTE] = ACTIONS(2809),
    [anon_sym_U_DQUOTE] = ACTIONS(2809),
    [anon_sym_u8_DQUOTE] = ACTIONS(2809),
    [anon_sym_DQUOTE] = ACTIONS(2809),
    [sym_true] = ACTIONS(2807),
    [sym_false] = ACTIONS(2807),
    [anon_sym_NULL] = ACTIONS(2807),
    [anon_sym_nullptr] = ACTIONS(2807),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2807),
    [anon_sym_decltype] = ACTIONS(2807),
    [anon_sym_explicit] = ACTIONS(2807),
    [anon_sym_typename] = ACTIONS(2807),
    [anon_sym_template] = ACTIONS(2807),
    [anon_sym_operator] = ACTIONS(2807),
    [anon_sym_try] = ACTIONS(2807),
    [anon_sym_delete] = ACTIONS(2807),
    [anon_sym_throw] = ACTIONS(2807),
    [anon_sym_namespace] = ACTIONS(2807),
    [anon_sym_static_assert] = ACTIONS(2807),
    [anon_sym_concept] = ACTIONS(2807),
    [anon_sym_co_return] = ACTIONS(2807),
    [anon_sym_co_yield] = ACTIONS(2807),
    [anon_sym_R_DQUOTE] = ACTIONS(2809),
    [anon_sym_LR_DQUOTE] = ACTIONS(2809),
    [anon_sym_uR_DQUOTE] = ACTIONS(2809),
    [anon_sym_UR_DQUOTE] = ACTIONS(2809),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2809),
    [anon_sym_co_await] = ACTIONS(2807),
    [anon_sym_new] = ACTIONS(2807),
    [anon_sym_requires] = ACTIONS(2807),
    [sym_this] = ACTIONS(2807),
  },
  [702] = {
    [sym_identifier] = ACTIONS(2815),
    [aux_sym_preproc_include_token1] = ACTIONS(2815),
    [aux_sym_preproc_def_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token2] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2815),
    [sym_preproc_directive] = ACTIONS(2815),
    [anon_sym_LPAREN2] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_TILDE] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym___extension__] = ACTIONS(2815),
    [anon_sym_typedef] = ACTIONS(2815),
    [anon_sym_virtual] = ACTIONS(2815),
    [anon_sym_extern] = ACTIONS(2815),
    [anon_sym___attribute__] = ACTIONS(2815),
    [anon_sym___attribute] = ACTIONS(2815),
    [anon_sym_using] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2817),
    [anon_sym___declspec] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(2815),
    [anon_sym___cdecl] = ACTIONS(2815),
    [anon_sym___clrcall] = ACTIONS(2815),
    [anon_sym___stdcall] = ACTIONS(2815),
    [anon_sym___fastcall] = ACTIONS(2815),
    [anon_sym___thiscall] = ACTIONS(2815),
    [anon_sym___vectorcall] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2817),
    [anon_sym_signed] = ACTIONS(2815),
    [anon_sym_unsigned] = ACTIONS(2815),
    [anon_sym_long] = ACTIONS(2815),
    [anon_sym_short] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2815),
    [anon_sym_register] = ACTIONS(2815),
    [anon_sym_inline] = ACTIONS(2815),
    [anon_sym___inline] = ACTIONS(2815),
    [anon_sym___inline__] = ACTIONS(2815),
    [anon_sym___forceinline] = ACTIONS(2815),
    [anon_sym_thread_local] = ACTIONS(2815),
    [anon_sym___thread] = ACTIONS(2815),
    [anon_sym_const] = ACTIONS(2815),
    [anon_sym_constexpr] = ACTIONS(2815),
    [anon_sym_volatile] = ACTIONS(2815),
    [anon_sym_restrict] = ACTIONS(2815),
    [anon_sym___restrict__] = ACTIONS(2815),
    [anon_sym__Atomic] = ACTIONS(2815),
    [anon_sym__Noreturn] = ACTIONS(2815),
    [anon_sym_noreturn] = ACTIONS(2815),
    [anon_sym__Nonnull] = ACTIONS(2815),
    [anon_sym_mutable] = ACTIONS(2815),
    [anon_sym_constinit] = ACTIONS(2815),
    [anon_sym_consteval] = ACTIONS(2815),
    [anon_sym_alignas] = ACTIONS(2815),
    [anon_sym__Alignas] = ACTIONS(2815),
    [sym_primitive_type] = ACTIONS(2815),
    [anon_sym_enum] = ACTIONS(2815),
    [anon_sym_class] = ACTIONS(2815),
    [anon_sym_struct] = ACTIONS(2815),
    [anon_sym_union] = ACTIONS(2815),
    [anon_sym_if] = ACTIONS(2815),
    [anon_sym_switch] = ACTIONS(2815),
    [anon_sym_case] = ACTIONS(2815),
    [anon_sym_default] = ACTIONS(2815),
    [anon_sym_while] = ACTIONS(2815),
    [anon_sym_do] = ACTIONS(2815),
    [anon_sym_for] = ACTIONS(2815),
    [anon_sym_return] = ACTIONS(2815),
    [anon_sym_break] = ACTIONS(2815),
    [anon_sym_continue] = ACTIONS(2815),
    [anon_sym_goto] = ACTIONS(2815),
    [anon_sym___try] = ACTIONS(2815),
    [anon_sym___leave] = ACTIONS(2815),
    [anon_sym_not] = ACTIONS(2815),
    [anon_sym_compl] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2817),
    [anon_sym_sizeof] = ACTIONS(2815),
    [anon_sym___alignof__] = ACTIONS(2815),
    [anon_sym___alignof] = ACTIONS(2815),
    [anon_sym__alignof] = ACTIONS(2815),
    [anon_sym_alignof] = ACTIONS(2815),
    [anon_sym__Alignof] = ACTIONS(2815),
    [anon_sym_offsetof] = ACTIONS(2815),
    [anon_sym__Generic] = ACTIONS(2815),
    [anon_sym_asm] = ACTIONS(2815),
    [anon_sym___asm__] = ACTIONS(2815),
    [anon_sym___asm] = ACTIONS(2815),
    [sym_number_literal] = ACTIONS(2817),
    [anon_sym_L_SQUOTE] = ACTIONS(2817),
    [anon_sym_u_SQUOTE] = ACTIONS(2817),
    [anon_sym_U_SQUOTE] = ACTIONS(2817),
    [anon_sym_u8_SQUOTE] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_L_DQUOTE] = ACTIONS(2817),
    [anon_sym_u_DQUOTE] = ACTIONS(2817),
    [anon_sym_U_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8_DQUOTE] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(2817),
    [sym_true] = ACTIONS(2815),
    [sym_false] = ACTIONS(2815),
    [anon_sym_NULL] = ACTIONS(2815),
    [anon_sym_nullptr] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2815),
    [anon_sym_decltype] = ACTIONS(2815),
    [anon_sym_explicit] = ACTIONS(2815),
    [anon_sym_typename] = ACTIONS(2815),
    [anon_sym_template] = ACTIONS(2815),
    [anon_sym_operator] = ACTIONS(2815),
    [anon_sym_try] = ACTIONS(2815),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_throw] = ACTIONS(2815),
    [anon_sym_namespace] = ACTIONS(2815),
    [anon_sym_static_assert] = ACTIONS(2815),
    [anon_sym_concept] = ACTIONS(2815),
    [anon_sym_co_return] = ACTIONS(2815),
    [anon_sym_co_yield] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2815),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_requires] = ACTIONS(2815),
    [sym_this] = ACTIONS(2815),
  },
  [703] = {
    [sym_identifier] = ACTIONS(2903),
    [aux_sym_preproc_include_token1] = ACTIONS(2903),
    [aux_sym_preproc_def_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token1] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2903),
    [sym_preproc_directive] = ACTIONS(2903),
    [anon_sym_LPAREN2] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2903),
    [anon_sym_typedef] = ACTIONS(2903),
    [anon_sym_virtual] = ACTIONS(2903),
    [anon_sym_extern] = ACTIONS(2903),
    [anon_sym___attribute__] = ACTIONS(2903),
    [anon_sym___attribute] = ACTIONS(2903),
    [anon_sym_using] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2905),
    [anon_sym___declspec] = ACTIONS(2903),
    [anon_sym___based] = ACTIONS(2903),
    [anon_sym___cdecl] = ACTIONS(2903),
    [anon_sym___clrcall] = ACTIONS(2903),
    [anon_sym___stdcall] = ACTIONS(2903),
    [anon_sym___fastcall] = ACTIONS(2903),
    [anon_sym___thiscall] = ACTIONS(2903),
    [anon_sym___vectorcall] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_signed] = ACTIONS(2903),
    [anon_sym_unsigned] = ACTIONS(2903),
    [anon_sym_long] = ACTIONS(2903),
    [anon_sym_short] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_register] = ACTIONS(2903),
    [anon_sym_inline] = ACTIONS(2903),
    [anon_sym___inline] = ACTIONS(2903),
    [anon_sym___inline__] = ACTIONS(2903),
    [anon_sym___forceinline] = ACTIONS(2903),
    [anon_sym_thread_local] = ACTIONS(2903),
    [anon_sym___thread] = ACTIONS(2903),
    [anon_sym_const] = ACTIONS(2903),
    [anon_sym_constexpr] = ACTIONS(2903),
    [anon_sym_volatile] = ACTIONS(2903),
    [anon_sym_restrict] = ACTIONS(2903),
    [anon_sym___restrict__] = ACTIONS(2903),
    [anon_sym__Atomic] = ACTIONS(2903),
    [anon_sym__Noreturn] = ACTIONS(2903),
    [anon_sym_noreturn] = ACTIONS(2903),
    [anon_sym__Nonnull] = ACTIONS(2903),
    [anon_sym_mutable] = ACTIONS(2903),
    [anon_sym_constinit] = ACTIONS(2903),
    [anon_sym_consteval] = ACTIONS(2903),
    [anon_sym_alignas] = ACTIONS(2903),
    [anon_sym__Alignas] = ACTIONS(2903),
    [sym_primitive_type] = ACTIONS(2903),
    [anon_sym_enum] = ACTIONS(2903),
    [anon_sym_class] = ACTIONS(2903),
    [anon_sym_struct] = ACTIONS(2903),
    [anon_sym_union] = ACTIONS(2903),
    [anon_sym_if] = ACTIONS(2903),
    [anon_sym_switch] = ACTIONS(2903),
    [anon_sym_case] = ACTIONS(2903),
    [anon_sym_default] = ACTIONS(2903),
    [anon_sym_while] = ACTIONS(2903),
    [anon_sym_do] = ACTIONS(2903),
    [anon_sym_for] = ACTIONS(2903),
    [anon_sym_return] = ACTIONS(2903),
    [anon_sym_break] = ACTIONS(2903),
    [anon_sym_continue] = ACTIONS(2903),
    [anon_sym_goto] = ACTIONS(2903),
    [anon_sym___try] = ACTIONS(2903),
    [anon_sym___leave] = ACTIONS(2903),
    [anon_sym_not] = ACTIONS(2903),
    [anon_sym_compl] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_sizeof] = ACTIONS(2903),
    [anon_sym___alignof__] = ACTIONS(2903),
    [anon_sym___alignof] = ACTIONS(2903),
    [anon_sym__alignof] = ACTIONS(2903),
    [anon_sym_alignof] = ACTIONS(2903),
    [anon_sym__Alignof] = ACTIONS(2903),
    [anon_sym_offsetof] = ACTIONS(2903),
    [anon_sym__Generic] = ACTIONS(2903),
    [anon_sym_asm] = ACTIONS(2903),
    [anon_sym___asm__] = ACTIONS(2903),
    [anon_sym___asm] = ACTIONS(2903),
    [sym_number_literal] = ACTIONS(2905),
    [anon_sym_L_SQUOTE] = ACTIONS(2905),
    [anon_sym_u_SQUOTE] = ACTIONS(2905),
    [anon_sym_U_SQUOTE] = ACTIONS(2905),
    [anon_sym_u8_SQUOTE] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(2905),
    [anon_sym_L_DQUOTE] = ACTIONS(2905),
    [anon_sym_u_DQUOTE] = ACTIONS(2905),
    [anon_sym_U_DQUOTE] = ACTIONS(2905),
    [anon_sym_u8_DQUOTE] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [sym_true] = ACTIONS(2903),
    [sym_false] = ACTIONS(2903),
    [anon_sym_NULL] = ACTIONS(2903),
    [anon_sym_nullptr] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2903),
    [anon_sym_decltype] = ACTIONS(2903),
    [anon_sym_explicit] = ACTIONS(2903),
    [anon_sym_typename] = ACTIONS(2903),
    [anon_sym_template] = ACTIONS(2903),
    [anon_sym_operator] = ACTIONS(2903),
    [anon_sym_try] = ACTIONS(2903),
    [anon_sym_delete] = ACTIONS(2903),
    [anon_sym_throw] = ACTIONS(2903),
    [anon_sym_namespace] = ACTIONS(2903),
    [anon_sym_static_assert] = ACTIONS(2903),
    [anon_sym_concept] = ACTIONS(2903),
    [anon_sym_co_return] = ACTIONS(2903),
    [anon_sym_co_yield] = ACTIONS(2903),
    [anon_sym_R_DQUOTE] = ACTIONS(2905),
    [anon_sym_LR_DQUOTE] = ACTIONS(2905),
    [anon_sym_uR_DQUOTE] = ACTIONS(2905),
    [anon_sym_UR_DQUOTE] = ACTIONS(2905),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2905),
    [anon_sym_co_await] = ACTIONS(2903),
    [anon_sym_new] = ACTIONS(2903),
    [anon_sym_requires] = ACTIONS(2903),
    [sym_this] = ACTIONS(2903),
  },
  [704] = {
    [sym_identifier] = ACTIONS(2827),
    [aux_sym_preproc_include_token1] = ACTIONS(2827),
    [aux_sym_preproc_def_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2827),
    [sym_preproc_directive] = ACTIONS(2827),
    [anon_sym_LPAREN2] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym___extension__] = ACTIONS(2827),
    [anon_sym_typedef] = ACTIONS(2827),
    [anon_sym_virtual] = ACTIONS(2827),
    [anon_sym_extern] = ACTIONS(2827),
    [anon_sym___attribute__] = ACTIONS(2827),
    [anon_sym___attribute] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2829),
    [anon_sym___declspec] = ACTIONS(2827),
    [anon_sym___based] = ACTIONS(2827),
    [anon_sym___cdecl] = ACTIONS(2827),
    [anon_sym___clrcall] = ACTIONS(2827),
    [anon_sym___stdcall] = ACTIONS(2827),
    [anon_sym___fastcall] = ACTIONS(2827),
    [anon_sym___thiscall] = ACTIONS(2827),
    [anon_sym___vectorcall] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_signed] = ACTIONS(2827),
    [anon_sym_unsigned] = ACTIONS(2827),
    [anon_sym_long] = ACTIONS(2827),
    [anon_sym_short] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_static] = ACTIONS(2827),
    [anon_sym_register] = ACTIONS(2827),
    [anon_sym_inline] = ACTIONS(2827),
    [anon_sym___inline] = ACTIONS(2827),
    [anon_sym___inline__] = ACTIONS(2827),
    [anon_sym___forceinline] = ACTIONS(2827),
    [anon_sym_thread_local] = ACTIONS(2827),
    [anon_sym___thread] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_constexpr] = ACTIONS(2827),
    [anon_sym_volatile] = ACTIONS(2827),
    [anon_sym_restrict] = ACTIONS(2827),
    [anon_sym___restrict__] = ACTIONS(2827),
    [anon_sym__Atomic] = ACTIONS(2827),
    [anon_sym__Noreturn] = ACTIONS(2827),
    [anon_sym_noreturn] = ACTIONS(2827),
    [anon_sym__Nonnull] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_constinit] = ACTIONS(2827),
    [anon_sym_consteval] = ACTIONS(2827),
    [anon_sym_alignas] = ACTIONS(2827),
    [anon_sym__Alignas] = ACTIONS(2827),
    [sym_primitive_type] = ACTIONS(2827),
    [anon_sym_enum] = ACTIONS(2827),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_union] = ACTIONS(2827),
    [anon_sym_if] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_default] = ACTIONS(2827),
    [anon_sym_while] = ACTIONS(2827),
    [anon_sym_do] = ACTIONS(2827),
    [anon_sym_for] = ACTIONS(2827),
    [anon_sym_return] = ACTIONS(2827),
    [anon_sym_break] = ACTIONS(2827),
    [anon_sym_continue] = ACTIONS(2827),
    [anon_sym_goto] = ACTIONS(2827),
    [anon_sym___try] = ACTIONS(2827),
    [anon_sym___leave] = ACTIONS(2827),
    [anon_sym_not] = ACTIONS(2827),
    [anon_sym_compl] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_sizeof] = ACTIONS(2827),
    [anon_sym___alignof__] = ACTIONS(2827),
    [anon_sym___alignof] = ACTIONS(2827),
    [anon_sym__alignof] = ACTIONS(2827),
    [anon_sym_alignof] = ACTIONS(2827),
    [anon_sym__Alignof] = ACTIONS(2827),
    [anon_sym_offsetof] = ACTIONS(2827),
    [anon_sym__Generic] = ACTIONS(2827),
    [anon_sym_asm] = ACTIONS(2827),
    [anon_sym___asm__] = ACTIONS(2827),
    [anon_sym___asm] = ACTIONS(2827),
    [sym_number_literal] = ACTIONS(2829),
    [anon_sym_L_SQUOTE] = ACTIONS(2829),
    [anon_sym_u_SQUOTE] = ACTIONS(2829),
    [anon_sym_U_SQUOTE] = ACTIONS(2829),
    [anon_sym_u8_SQUOTE] = ACTIONS(2829),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_L_DQUOTE] = ACTIONS(2829),
    [anon_sym_u_DQUOTE] = ACTIONS(2829),
    [anon_sym_U_DQUOTE] = ACTIONS(2829),
    [anon_sym_u8_DQUOTE] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(2829),
    [sym_true] = ACTIONS(2827),
    [sym_false] = ACTIONS(2827),
    [anon_sym_NULL] = ACTIONS(2827),
    [anon_sym_nullptr] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2827),
    [anon_sym_decltype] = ACTIONS(2827),
    [anon_sym_explicit] = ACTIONS(2827),
    [anon_sym_typename] = ACTIONS(2827),
    [anon_sym_template] = ACTIONS(2827),
    [anon_sym_operator] = ACTIONS(2827),
    [anon_sym_try] = ACTIONS(2827),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_throw] = ACTIONS(2827),
    [anon_sym_namespace] = ACTIONS(2827),
    [anon_sym_static_assert] = ACTIONS(2827),
    [anon_sym_concept] = ACTIONS(2827),
    [anon_sym_co_return] = ACTIONS(2827),
    [anon_sym_co_yield] = ACTIONS(2827),
    [anon_sym_R_DQUOTE] = ACTIONS(2829),
    [anon_sym_LR_DQUOTE] = ACTIONS(2829),
    [anon_sym_uR_DQUOTE] = ACTIONS(2829),
    [anon_sym_UR_DQUOTE] = ACTIONS(2829),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2829),
    [anon_sym_co_await] = ACTIONS(2827),
    [anon_sym_new] = ACTIONS(2827),
    [anon_sym_requires] = ACTIONS(2827),
    [sym_this] = ACTIONS(2827),
  },
  [705] = {
    [sym_identifier] = ACTIONS(2907),
    [aux_sym_preproc_include_token1] = ACTIONS(2907),
    [aux_sym_preproc_def_token1] = ACTIONS(2907),
    [aux_sym_preproc_if_token1] = ACTIONS(2907),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2907),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2907),
    [sym_preproc_directive] = ACTIONS(2907),
    [anon_sym_LPAREN2] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_PLUS] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2909),
    [anon_sym___extension__] = ACTIONS(2907),
    [anon_sym_typedef] = ACTIONS(2907),
    [anon_sym_virtual] = ACTIONS(2907),
    [anon_sym_extern] = ACTIONS(2907),
    [anon_sym___attribute__] = ACTIONS(2907),
    [anon_sym___attribute] = ACTIONS(2907),
    [anon_sym_using] = ACTIONS(2907),
    [anon_sym_COLON_COLON] = ACTIONS(2909),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2909),
    [anon_sym___declspec] = ACTIONS(2907),
    [anon_sym___based] = ACTIONS(2907),
    [anon_sym___cdecl] = ACTIONS(2907),
    [anon_sym___clrcall] = ACTIONS(2907),
    [anon_sym___stdcall] = ACTIONS(2907),
    [anon_sym___fastcall] = ACTIONS(2907),
    [anon_sym___thiscall] = ACTIONS(2907),
    [anon_sym___vectorcall] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_RBRACE] = ACTIONS(2909),
    [anon_sym_signed] = ACTIONS(2907),
    [anon_sym_unsigned] = ACTIONS(2907),
    [anon_sym_long] = ACTIONS(2907),
    [anon_sym_short] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_static] = ACTIONS(2907),
    [anon_sym_register] = ACTIONS(2907),
    [anon_sym_inline] = ACTIONS(2907),
    [anon_sym___inline] = ACTIONS(2907),
    [anon_sym___inline__] = ACTIONS(2907),
    [anon_sym___forceinline] = ACTIONS(2907),
    [anon_sym_thread_local] = ACTIONS(2907),
    [anon_sym___thread] = ACTIONS(2907),
    [anon_sym_const] = ACTIONS(2907),
    [anon_sym_constexpr] = ACTIONS(2907),
    [anon_sym_volatile] = ACTIONS(2907),
    [anon_sym_restrict] = ACTIONS(2907),
    [anon_sym___restrict__] = ACTIONS(2907),
    [anon_sym__Atomic] = ACTIONS(2907),
    [anon_sym__Noreturn] = ACTIONS(2907),
    [anon_sym_noreturn] = ACTIONS(2907),
    [anon_sym__Nonnull] = ACTIONS(2907),
    [anon_sym_mutable] = ACTIONS(2907),
    [anon_sym_constinit] = ACTIONS(2907),
    [anon_sym_consteval] = ACTIONS(2907),
    [anon_sym_alignas] = ACTIONS(2907),
    [anon_sym__Alignas] = ACTIONS(2907),
    [sym_primitive_type] = ACTIONS(2907),
    [anon_sym_enum] = ACTIONS(2907),
    [anon_sym_class] = ACTIONS(2907),
    [anon_sym_struct] = ACTIONS(2907),
    [anon_sym_union] = ACTIONS(2907),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2907),
    [anon_sym_default] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_for] = ACTIONS(2907),
    [anon_sym_return] = ACTIONS(2907),
    [anon_sym_break] = ACTIONS(2907),
    [anon_sym_continue] = ACTIONS(2907),
    [anon_sym_goto] = ACTIONS(2907),
    [anon_sym___try] = ACTIONS(2907),
    [anon_sym___leave] = ACTIONS(2907),
    [anon_sym_not] = ACTIONS(2907),
    [anon_sym_compl] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2909),
    [anon_sym_sizeof] = ACTIONS(2907),
    [anon_sym___alignof__] = ACTIONS(2907),
    [anon_sym___alignof] = ACTIONS(2907),
    [anon_sym__alignof] = ACTIONS(2907),
    [anon_sym_alignof] = ACTIONS(2907),
    [anon_sym__Alignof] = ACTIONS(2907),
    [anon_sym_offsetof] = ACTIONS(2907),
    [anon_sym__Generic] = ACTIONS(2907),
    [anon_sym_asm] = ACTIONS(2907),
    [anon_sym___asm__] = ACTIONS(2907),
    [anon_sym___asm] = ACTIONS(2907),
    [sym_number_literal] = ACTIONS(2909),
    [anon_sym_L_SQUOTE] = ACTIONS(2909),
    [anon_sym_u_SQUOTE] = ACTIONS(2909),
    [anon_sym_U_SQUOTE] = ACTIONS(2909),
    [anon_sym_u8_SQUOTE] = ACTIONS(2909),
    [anon_sym_SQUOTE] = ACTIONS(2909),
    [anon_sym_L_DQUOTE] = ACTIONS(2909),
    [anon_sym_u_DQUOTE] = ACTIONS(2909),
    [anon_sym_U_DQUOTE] = ACTIONS(2909),
    [anon_sym_u8_DQUOTE] = ACTIONS(2909),
    [anon_sym_DQUOTE] = ACTIONS(2909),
    [sym_true] = ACTIONS(2907),
    [sym_false] = ACTIONS(2907),
    [anon_sym_NULL] = ACTIONS(2907),
    [anon_sym_nullptr] = ACTIONS(2907),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2907),
    [anon_sym_decltype] = ACTIONS(2907),
    [anon_sym_explicit] = ACTIONS(2907),
    [anon_sym_typename] = ACTIONS(2907),
    [anon_sym_template] = ACTIONS(2907),
    [anon_sym_operator] = ACTIONS(2907),
    [anon_sym_try] = ACTIONS(2907),
    [anon_sym_delete] = ACTIONS(2907),
    [anon_sym_throw] = ACTIONS(2907),
    [anon_sym_namespace] = ACTIONS(2907),
    [anon_sym_static_assert] = ACTIONS(2907),
    [anon_sym_concept] = ACTIONS(2907),
    [anon_sym_co_return] = ACTIONS(2907),
    [anon_sym_co_yield] = ACTIONS(2907),
    [anon_sym_R_DQUOTE] = ACTIONS(2909),
    [anon_sym_LR_DQUOTE] = ACTIONS(2909),
    [anon_sym_uR_DQUOTE] = ACTIONS(2909),
    [anon_sym_UR_DQUOTE] = ACTIONS(2909),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2909),
    [anon_sym_co_await] = ACTIONS(2907),
    [anon_sym_new] = ACTIONS(2907),
    [anon_sym_requires] = ACTIONS(2907),
    [sym_this] = ACTIONS(2907),
  },
  [706] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_include_token1] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym___cdecl] = ACTIONS(2911),
    [anon_sym___clrcall] = ACTIONS(2911),
    [anon_sym___stdcall] = ACTIONS(2911),
    [anon_sym___fastcall] = ACTIONS(2911),
    [anon_sym___thiscall] = ACTIONS(2911),
    [anon_sym___vectorcall] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2911),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2911),
    [anon_sym_return] = ACTIONS(2911),
    [anon_sym_break] = ACTIONS(2911),
    [anon_sym_continue] = ACTIONS(2911),
    [anon_sym_goto] = ACTIONS(2911),
    [anon_sym___try] = ACTIONS(2911),
    [anon_sym___leave] = ACTIONS(2911),
    [anon_sym_not] = ACTIONS(2911),
    [anon_sym_compl] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_sizeof] = ACTIONS(2911),
    [anon_sym___alignof__] = ACTIONS(2911),
    [anon_sym___alignof] = ACTIONS(2911),
    [anon_sym__alignof] = ACTIONS(2911),
    [anon_sym_alignof] = ACTIONS(2911),
    [anon_sym__Alignof] = ACTIONS(2911),
    [anon_sym_offsetof] = ACTIONS(2911),
    [anon_sym__Generic] = ACTIONS(2911),
    [anon_sym_asm] = ACTIONS(2911),
    [anon_sym___asm__] = ACTIONS(2911),
    [anon_sym___asm] = ACTIONS(2911),
    [sym_number_literal] = ACTIONS(2913),
    [anon_sym_L_SQUOTE] = ACTIONS(2913),
    [anon_sym_u_SQUOTE] = ACTIONS(2913),
    [anon_sym_U_SQUOTE] = ACTIONS(2913),
    [anon_sym_u8_SQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_L_DQUOTE] = ACTIONS(2913),
    [anon_sym_u_DQUOTE] = ACTIONS(2913),
    [anon_sym_U_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8_DQUOTE] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [sym_true] = ACTIONS(2911),
    [sym_false] = ACTIONS(2911),
    [anon_sym_NULL] = ACTIONS(2911),
    [anon_sym_nullptr] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2911),
    [anon_sym_delete] = ACTIONS(2911),
    [anon_sym_throw] = ACTIONS(2911),
    [anon_sym_namespace] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
    [anon_sym_concept] = ACTIONS(2911),
    [anon_sym_co_return] = ACTIONS(2911),
    [anon_sym_co_yield] = ACTIONS(2911),
    [anon_sym_R_DQUOTE] = ACTIONS(2913),
    [anon_sym_LR_DQUOTE] = ACTIONS(2913),
    [anon_sym_uR_DQUOTE] = ACTIONS(2913),
    [anon_sym_UR_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2913),
    [anon_sym_co_await] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2911),
    [anon_sym_requires] = ACTIONS(2911),
    [sym_this] = ACTIONS(2911),
  },
  [707] = {
    [sym_identifier] = ACTIONS(2847),
    [aux_sym_preproc_include_token1] = ACTIONS(2847),
    [aux_sym_preproc_def_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token2] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2847),
    [sym_preproc_directive] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym___extension__] = ACTIONS(2847),
    [anon_sym_typedef] = ACTIONS(2847),
    [anon_sym_virtual] = ACTIONS(2847),
    [anon_sym_extern] = ACTIONS(2847),
    [anon_sym___attribute__] = ACTIONS(2847),
    [anon_sym___attribute] = ACTIONS(2847),
    [anon_sym_using] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2849),
    [anon_sym___declspec] = ACTIONS(2847),
    [anon_sym___based] = ACTIONS(2847),
    [anon_sym___cdecl] = ACTIONS(2847),
    [anon_sym___clrcall] = ACTIONS(2847),
    [anon_sym___stdcall] = ACTIONS(2847),
    [anon_sym___fastcall] = ACTIONS(2847),
    [anon_sym___thiscall] = ACTIONS(2847),
    [anon_sym___vectorcall] = ACTIONS(2847),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_signed] = ACTIONS(2847),
    [anon_sym_unsigned] = ACTIONS(2847),
    [anon_sym_long] = ACTIONS(2847),
    [anon_sym_short] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2847),
    [anon_sym_register] = ACTIONS(2847),
    [anon_sym_inline] = ACTIONS(2847),
    [anon_sym___inline] = ACTIONS(2847),
    [anon_sym___inline__] = ACTIONS(2847),
    [anon_sym___forceinline] = ACTIONS(2847),
    [anon_sym_thread_local] = ACTIONS(2847),
    [anon_sym___thread] = ACTIONS(2847),
    [anon_sym_const] = ACTIONS(2847),
    [anon_sym_constexpr] = ACTIONS(2847),
    [anon_sym_volatile] = ACTIONS(2847),
    [anon_sym_restrict] = ACTIONS(2847),
    [anon_sym___restrict__] = ACTIONS(2847),
    [anon_sym__Atomic] = ACTIONS(2847),
    [anon_sym__Noreturn] = ACTIONS(2847),
    [anon_sym_noreturn] = ACTIONS(2847),
    [anon_sym__Nonnull] = ACTIONS(2847),
    [anon_sym_mutable] = ACTIONS(2847),
    [anon_sym_constinit] = ACTIONS(2847),
    [anon_sym_consteval] = ACTIONS(2847),
    [anon_sym_alignas] = ACTIONS(2847),
    [anon_sym__Alignas] = ACTIONS(2847),
    [sym_primitive_type] = ACTIONS(2847),
    [anon_sym_enum] = ACTIONS(2847),
    [anon_sym_class] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2847),
    [anon_sym_union] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_switch] = ACTIONS(2847),
    [anon_sym_case] = ACTIONS(2847),
    [anon_sym_default] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_break] = ACTIONS(2847),
    [anon_sym_continue] = ACTIONS(2847),
    [anon_sym_goto] = ACTIONS(2847),
    [anon_sym___try] = ACTIONS(2847),
    [anon_sym___leave] = ACTIONS(2847),
    [anon_sym_not] = ACTIONS(2847),
    [anon_sym_compl] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2849),
    [anon_sym_sizeof] = ACTIONS(2847),
    [anon_sym___alignof__] = ACTIONS(2847),
    [anon_sym___alignof] = ACTIONS(2847),
    [anon_sym__alignof] = ACTIONS(2847),
    [anon_sym_alignof] = ACTIONS(2847),
    [anon_sym__Alignof] = ACTIONS(2847),
    [anon_sym_offsetof] = ACTIONS(2847),
    [anon_sym__Generic] = ACTIONS(2847),
    [anon_sym_asm] = ACTIONS(2847),
    [anon_sym___asm__] = ACTIONS(2847),
    [anon_sym___asm] = ACTIONS(2847),
    [sym_number_literal] = ACTIONS(2849),
    [anon_sym_L_SQUOTE] = ACTIONS(2849),
    [anon_sym_u_SQUOTE] = ACTIONS(2849),
    [anon_sym_U_SQUOTE] = ACTIONS(2849),
    [anon_sym_u8_SQUOTE] = ACTIONS(2849),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2847),
    [sym_false] = ACTIONS(2847),
    [anon_sym_NULL] = ACTIONS(2847),
    [anon_sym_nullptr] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2847),
    [anon_sym_decltype] = ACTIONS(2847),
    [anon_sym_explicit] = ACTIONS(2847),
    [anon_sym_typename] = ACTIONS(2847),
    [anon_sym_template] = ACTIONS(2847),
    [anon_sym_operator] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_delete] = ACTIONS(2847),
    [anon_sym_throw] = ACTIONS(2847),
    [anon_sym_namespace] = ACTIONS(2847),
    [anon_sym_static_assert] = ACTIONS(2847),
    [anon_sym_concept] = ACTIONS(2847),
    [anon_sym_co_return] = ACTIONS(2847),
    [anon_sym_co_yield] = ACTIONS(2847),
    [anon_sym_R_DQUOTE] = ACTIONS(2849),
    [anon_sym_LR_DQUOTE] = ACTIONS(2849),
    [anon_sym_uR_DQUOTE] = ACTIONS(2849),
    [anon_sym_UR_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2849),
    [anon_sym_co_await] = ACTIONS(2847),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_requires] = ACTIONS(2847),
    [sym_this] = ACTIONS(2847),
  },
  [708] = {
    [sym_identifier] = ACTIONS(2851),
    [aux_sym_preproc_include_token1] = ACTIONS(2851),
    [aux_sym_preproc_def_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token2] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2851),
    [sym_preproc_directive] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2853),
    [anon_sym_BANG] = ACTIONS(2853),
    [anon_sym_TILDE] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_STAR] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym___extension__] = ACTIONS(2851),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_virtual] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(2851),
    [anon_sym___attribute__] = ACTIONS(2851),
    [anon_sym___attribute] = ACTIONS(2851),
    [anon_sym_using] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2853),
    [anon_sym___declspec] = ACTIONS(2851),
    [anon_sym___based] = ACTIONS(2851),
    [anon_sym___cdecl] = ACTIONS(2851),
    [anon_sym___clrcall] = ACTIONS(2851),
    [anon_sym___stdcall] = ACTIONS(2851),
    [anon_sym___fastcall] = ACTIONS(2851),
    [anon_sym___thiscall] = ACTIONS(2851),
    [anon_sym___vectorcall] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_signed] = ACTIONS(2851),
    [anon_sym_unsigned] = ACTIONS(2851),
    [anon_sym_long] = ACTIONS(2851),
    [anon_sym_short] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_static] = ACTIONS(2851),
    [anon_sym_register] = ACTIONS(2851),
    [anon_sym_inline] = ACTIONS(2851),
    [anon_sym___inline] = ACTIONS(2851),
    [anon_sym___inline__] = ACTIONS(2851),
    [anon_sym___forceinline] = ACTIONS(2851),
    [anon_sym_thread_local] = ACTIONS(2851),
    [anon_sym___thread] = ACTIONS(2851),
    [anon_sym_const] = ACTIONS(2851),
    [anon_sym_constexpr] = ACTIONS(2851),
    [anon_sym_volatile] = ACTIONS(2851),
    [anon_sym_restrict] = ACTIONS(2851),
    [anon_sym___restrict__] = ACTIONS(2851),
    [anon_sym__Atomic] = ACTIONS(2851),
    [anon_sym__Noreturn] = ACTIONS(2851),
    [anon_sym_noreturn] = ACTIONS(2851),
    [anon_sym__Nonnull] = ACTIONS(2851),
    [anon_sym_mutable] = ACTIONS(2851),
    [anon_sym_constinit] = ACTIONS(2851),
    [anon_sym_consteval] = ACTIONS(2851),
    [anon_sym_alignas] = ACTIONS(2851),
    [anon_sym__Alignas] = ACTIONS(2851),
    [sym_primitive_type] = ACTIONS(2851),
    [anon_sym_enum] = ACTIONS(2851),
    [anon_sym_class] = ACTIONS(2851),
    [anon_sym_struct] = ACTIONS(2851),
    [anon_sym_union] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_switch] = ACTIONS(2851),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_break] = ACTIONS(2851),
    [anon_sym_continue] = ACTIONS(2851),
    [anon_sym_goto] = ACTIONS(2851),
    [anon_sym___try] = ACTIONS(2851),
    [anon_sym___leave] = ACTIONS(2851),
    [anon_sym_not] = ACTIONS(2851),
    [anon_sym_compl] = ACTIONS(2851),
    [anon_sym_DASH_DASH] = ACTIONS(2853),
    [anon_sym_PLUS_PLUS] = ACTIONS(2853),
    [anon_sym_sizeof] = ACTIONS(2851),
    [anon_sym___alignof__] = ACTIONS(2851),
    [anon_sym___alignof] = ACTIONS(2851),
    [anon_sym__alignof] = ACTIONS(2851),
    [anon_sym_alignof] = ACTIONS(2851),
    [anon_sym__Alignof] = ACTIONS(2851),
    [anon_sym_offsetof] = ACTIONS(2851),
    [anon_sym__Generic] = ACTIONS(2851),
    [anon_sym_asm] = ACTIONS(2851),
    [anon_sym___asm__] = ACTIONS(2851),
    [anon_sym___asm] = ACTIONS(2851),
    [sym_number_literal] = ACTIONS(2853),
    [anon_sym_L_SQUOTE] = ACTIONS(2853),
    [anon_sym_u_SQUOTE] = ACTIONS(2853),
    [anon_sym_U_SQUOTE] = ACTIONS(2853),
    [anon_sym_u8_SQUOTE] = ACTIONS(2853),
    [anon_sym_SQUOTE] = ACTIONS(2853),
    [anon_sym_L_DQUOTE] = ACTIONS(2853),
    [anon_sym_u_DQUOTE] = ACTIONS(2853),
    [anon_sym_U_DQUOTE] = ACTIONS(2853),
    [anon_sym_u8_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE] = ACTIONS(2853),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2851),
    [anon_sym_nullptr] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2851),
    [anon_sym_decltype] = ACTIONS(2851),
    [anon_sym_explicit] = ACTIONS(2851),
    [anon_sym_typename] = ACTIONS(2851),
    [anon_sym_template] = ACTIONS(2851),
    [anon_sym_operator] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_delete] = ACTIONS(2851),
    [anon_sym_throw] = ACTIONS(2851),
    [anon_sym_namespace] = ACTIONS(2851),
    [anon_sym_static_assert] = ACTIONS(2851),
    [anon_sym_concept] = ACTIONS(2851),
    [anon_sym_co_return] = ACTIONS(2851),
    [anon_sym_co_yield] = ACTIONS(2851),
    [anon_sym_R_DQUOTE] = ACTIONS(2853),
    [anon_sym_LR_DQUOTE] = ACTIONS(2853),
    [anon_sym_uR_DQUOTE] = ACTIONS(2853),
    [anon_sym_UR_DQUOTE] = ACTIONS(2853),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2853),
    [anon_sym_co_await] = ACTIONS(2851),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_requires] = ACTIONS(2851),
    [sym_this] = ACTIONS(2851),
  },
  [709] = {
    [sym_identifier] = ACTIONS(2855),
    [aux_sym_preproc_include_token1] = ACTIONS(2855),
    [aux_sym_preproc_def_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token2] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2855),
    [sym_preproc_directive] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(2857),
    [anon_sym_TILDE] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym___extension__] = ACTIONS(2855),
    [anon_sym_typedef] = ACTIONS(2855),
    [anon_sym_virtual] = ACTIONS(2855),
    [anon_sym_extern] = ACTIONS(2855),
    [anon_sym___attribute__] = ACTIONS(2855),
    [anon_sym___attribute] = ACTIONS(2855),
    [anon_sym_using] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2857),
    [anon_sym___declspec] = ACTIONS(2855),
    [anon_sym___based] = ACTIONS(2855),
    [anon_sym___cdecl] = ACTIONS(2855),
    [anon_sym___clrcall] = ACTIONS(2855),
    [anon_sym___stdcall] = ACTIONS(2855),
    [anon_sym___fastcall] = ACTIONS(2855),
    [anon_sym___thiscall] = ACTIONS(2855),
    [anon_sym___vectorcall] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_signed] = ACTIONS(2855),
    [anon_sym_unsigned] = ACTIONS(2855),
    [anon_sym_long] = ACTIONS(2855),
    [anon_sym_short] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(2855),
    [anon_sym_register] = ACTIONS(2855),
    [anon_sym_inline] = ACTIONS(2855),
    [anon_sym___inline] = ACTIONS(2855),
    [anon_sym___inline__] = ACTIONS(2855),
    [anon_sym___forceinline] = ACTIONS(2855),
    [anon_sym_thread_local] = ACTIONS(2855),
    [anon_sym___thread] = ACTIONS(2855),
    [anon_sym_const] = ACTIONS(2855),
    [anon_sym_constexpr] = ACTIONS(2855),
    [anon_sym_volatile] = ACTIONS(2855),
    [anon_sym_restrict] = ACTIONS(2855),
    [anon_sym___restrict__] = ACTIONS(2855),
    [anon_sym__Atomic] = ACTIONS(2855),
    [anon_sym__Noreturn] = ACTIONS(2855),
    [anon_sym_noreturn] = ACTIONS(2855),
    [anon_sym__Nonnull] = ACTIONS(2855),
    [anon_sym_mutable] = ACTIONS(2855),
    [anon_sym_constinit] = ACTIONS(2855),
    [anon_sym_consteval] = ACTIONS(2855),
    [anon_sym_alignas] = ACTIONS(2855),
    [anon_sym__Alignas] = ACTIONS(2855),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_enum] = ACTIONS(2855),
    [anon_sym_class] = ACTIONS(2855),
    [anon_sym_struct] = ACTIONS(2855),
    [anon_sym_union] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_case] = ACTIONS(2855),
    [anon_sym_default] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_break] = ACTIONS(2855),
    [anon_sym_continue] = ACTIONS(2855),
    [anon_sym_goto] = ACTIONS(2855),
    [anon_sym___try] = ACTIONS(2855),
    [anon_sym___leave] = ACTIONS(2855),
    [anon_sym_not] = ACTIONS(2855),
    [anon_sym_compl] = ACTIONS(2855),
    [anon_sym_DASH_DASH] = ACTIONS(2857),
    [anon_sym_PLUS_PLUS] = ACTIONS(2857),
    [anon_sym_sizeof] = ACTIONS(2855),
    [anon_sym___alignof__] = ACTIONS(2855),
    [anon_sym___alignof] = ACTIONS(2855),
    [anon_sym__alignof] = ACTIONS(2855),
    [anon_sym_alignof] = ACTIONS(2855),
    [anon_sym__Alignof] = ACTIONS(2855),
    [anon_sym_offsetof] = ACTIONS(2855),
    [anon_sym__Generic] = ACTIONS(2855),
    [anon_sym_asm] = ACTIONS(2855),
    [anon_sym___asm__] = ACTIONS(2855),
    [anon_sym___asm] = ACTIONS(2855),
    [sym_number_literal] = ACTIONS(2857),
    [anon_sym_L_SQUOTE] = ACTIONS(2857),
    [anon_sym_u_SQUOTE] = ACTIONS(2857),
    [anon_sym_U_SQUOTE] = ACTIONS(2857),
    [anon_sym_u8_SQUOTE] = ACTIONS(2857),
    [anon_sym_SQUOTE] = ACTIONS(2857),
    [anon_sym_L_DQUOTE] = ACTIONS(2857),
    [anon_sym_u_DQUOTE] = ACTIONS(2857),
    [anon_sym_U_DQUOTE] = ACTIONS(2857),
    [anon_sym_u8_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [sym_true] = ACTIONS(2855),
    [sym_false] = ACTIONS(2855),
    [anon_sym_NULL] = ACTIONS(2855),
    [anon_sym_nullptr] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2855),
    [anon_sym_explicit] = ACTIONS(2855),
    [anon_sym_typename] = ACTIONS(2855),
    [anon_sym_template] = ACTIONS(2855),
    [anon_sym_operator] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_delete] = ACTIONS(2855),
    [anon_sym_throw] = ACTIONS(2855),
    [anon_sym_namespace] = ACTIONS(2855),
    [anon_sym_static_assert] = ACTIONS(2855),
    [anon_sym_concept] = ACTIONS(2855),
    [anon_sym_co_return] = ACTIONS(2855),
    [anon_sym_co_yield] = ACTIONS(2855),
    [anon_sym_R_DQUOTE] = ACTIONS(2857),
    [anon_sym_LR_DQUOTE] = ACTIONS(2857),
    [anon_sym_uR_DQUOTE] = ACTIONS(2857),
    [anon_sym_UR_DQUOTE] = ACTIONS(2857),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2857),
    [anon_sym_co_await] = ACTIONS(2855),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_requires] = ACTIONS(2855),
    [sym_this] = ACTIONS(2855),
  },
  [710] = {
    [sym_identifier] = ACTIONS(2859),
    [aux_sym_preproc_include_token1] = ACTIONS(2859),
    [aux_sym_preproc_def_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token2] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2859),
    [sym_preproc_directive] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym___extension__] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2859),
    [anon_sym_virtual] = ACTIONS(2859),
    [anon_sym_extern] = ACTIONS(2859),
    [anon_sym___attribute__] = ACTIONS(2859),
    [anon_sym___attribute] = ACTIONS(2859),
    [anon_sym_using] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2861),
    [anon_sym___declspec] = ACTIONS(2859),
    [anon_sym___based] = ACTIONS(2859),
    [anon_sym___cdecl] = ACTIONS(2859),
    [anon_sym___clrcall] = ACTIONS(2859),
    [anon_sym___stdcall] = ACTIONS(2859),
    [anon_sym___fastcall] = ACTIONS(2859),
    [anon_sym___thiscall] = ACTIONS(2859),
    [anon_sym___vectorcall] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_signed] = ACTIONS(2859),
    [anon_sym_unsigned] = ACTIONS(2859),
    [anon_sym_long] = ACTIONS(2859),
    [anon_sym_short] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2859),
    [anon_sym_register] = ACTIONS(2859),
    [anon_sym_inline] = ACTIONS(2859),
    [anon_sym___inline] = ACTIONS(2859),
    [anon_sym___inline__] = ACTIONS(2859),
    [anon_sym___forceinline] = ACTIONS(2859),
    [anon_sym_thread_local] = ACTIONS(2859),
    [anon_sym___thread] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2859),
    [anon_sym_constexpr] = ACTIONS(2859),
    [anon_sym_volatile] = ACTIONS(2859),
    [anon_sym_restrict] = ACTIONS(2859),
    [anon_sym___restrict__] = ACTIONS(2859),
    [anon_sym__Atomic] = ACTIONS(2859),
    [anon_sym__Noreturn] = ACTIONS(2859),
    [anon_sym_noreturn] = ACTIONS(2859),
    [anon_sym__Nonnull] = ACTIONS(2859),
    [anon_sym_mutable] = ACTIONS(2859),
    [anon_sym_constinit] = ACTIONS(2859),
    [anon_sym_consteval] = ACTIONS(2859),
    [anon_sym_alignas] = ACTIONS(2859),
    [anon_sym__Alignas] = ACTIONS(2859),
    [sym_primitive_type] = ACTIONS(2859),
    [anon_sym_enum] = ACTIONS(2859),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2859),
    [anon_sym_union] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_switch] = ACTIONS(2859),
    [anon_sym_case] = ACTIONS(2859),
    [anon_sym_default] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_break] = ACTIONS(2859),
    [anon_sym_continue] = ACTIONS(2859),
    [anon_sym_goto] = ACTIONS(2859),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(2859),
    [anon_sym_not] = ACTIONS(2859),
    [anon_sym_compl] = ACTIONS(2859),
    [anon_sym_DASH_DASH] = ACTIONS(2861),
    [anon_sym_PLUS_PLUS] = ACTIONS(2861),
    [anon_sym_sizeof] = ACTIONS(2859),
    [anon_sym___alignof__] = ACTIONS(2859),
    [anon_sym___alignof] = ACTIONS(2859),
    [anon_sym__alignof] = ACTIONS(2859),
    [anon_sym_alignof] = ACTIONS(2859),
    [anon_sym__Alignof] = ACTIONS(2859),
    [anon_sym_offsetof] = ACTIONS(2859),
    [anon_sym__Generic] = ACTIONS(2859),
    [anon_sym_asm] = ACTIONS(2859),
    [anon_sym___asm__] = ACTIONS(2859),
    [anon_sym___asm] = ACTIONS(2859),
    [sym_number_literal] = ACTIONS(2861),
    [anon_sym_L_SQUOTE] = ACTIONS(2861),
    [anon_sym_u_SQUOTE] = ACTIONS(2861),
    [anon_sym_U_SQUOTE] = ACTIONS(2861),
    [anon_sym_u8_SQUOTE] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2861),
    [anon_sym_L_DQUOTE] = ACTIONS(2861),
    [anon_sym_u_DQUOTE] = ACTIONS(2861),
    [anon_sym_U_DQUOTE] = ACTIONS(2861),
    [anon_sym_u8_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE] = ACTIONS(2861),
    [sym_true] = ACTIONS(2859),
    [sym_false] = ACTIONS(2859),
    [anon_sym_NULL] = ACTIONS(2859),
    [anon_sym_nullptr] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2859),
    [anon_sym_decltype] = ACTIONS(2859),
    [anon_sym_explicit] = ACTIONS(2859),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(2859),
    [anon_sym_operator] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_delete] = ACTIONS(2859),
    [anon_sym_throw] = ACTIONS(2859),
    [anon_sym_namespace] = ACTIONS(2859),
    [anon_sym_static_assert] = ACTIONS(2859),
    [anon_sym_concept] = ACTIONS(2859),
    [anon_sym_co_return] = ACTIONS(2859),
    [anon_sym_co_yield] = ACTIONS(2859),
    [anon_sym_R_DQUOTE] = ACTIONS(2861),
    [anon_sym_LR_DQUOTE] = ACTIONS(2861),
    [anon_sym_uR_DQUOTE] = ACTIONS(2861),
    [anon_sym_UR_DQUOTE] = ACTIONS(2861),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2861),
    [anon_sym_co_await] = ACTIONS(2859),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_requires] = ACTIONS(2859),
    [sym_this] = ACTIONS(2859),
  },
  [711] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_include_token1] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token2] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_BANG] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym___cdecl] = ACTIONS(2771),
    [anon_sym___clrcall] = ACTIONS(2771),
    [anon_sym___stdcall] = ACTIONS(2771),
    [anon_sym___fastcall] = ACTIONS(2771),
    [anon_sym___thiscall] = ACTIONS(2771),
    [anon_sym___vectorcall] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_switch] = ACTIONS(2771),
    [anon_sym_case] = ACTIONS(2771),
    [anon_sym_default] = ACTIONS(2771),
    [anon_sym_while] = ACTIONS(2771),
    [anon_sym_do] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2771),
    [anon_sym_return] = ACTIONS(2771),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_continue] = ACTIONS(2771),
    [anon_sym_goto] = ACTIONS(2771),
    [anon_sym___try] = ACTIONS(2771),
    [anon_sym___leave] = ACTIONS(2771),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_compl] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2773),
    [anon_sym_PLUS_PLUS] = ACTIONS(2773),
    [anon_sym_sizeof] = ACTIONS(2771),
    [anon_sym___alignof__] = ACTIONS(2771),
    [anon_sym___alignof] = ACTIONS(2771),
    [anon_sym__alignof] = ACTIONS(2771),
    [anon_sym_alignof] = ACTIONS(2771),
    [anon_sym__Alignof] = ACTIONS(2771),
    [anon_sym_offsetof] = ACTIONS(2771),
    [anon_sym__Generic] = ACTIONS(2771),
    [anon_sym_asm] = ACTIONS(2771),
    [anon_sym___asm__] = ACTIONS(2771),
    [anon_sym___asm] = ACTIONS(2771),
    [sym_number_literal] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2773),
    [anon_sym_u_SQUOTE] = ACTIONS(2773),
    [anon_sym_U_SQUOTE] = ACTIONS(2773),
    [anon_sym_u8_SQUOTE] = ACTIONS(2773),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [anon_sym_L_DQUOTE] = ACTIONS(2773),
    [anon_sym_u_DQUOTE] = ACTIONS(2773),
    [anon_sym_U_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8_DQUOTE] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(2773),
    [sym_true] = ACTIONS(2771),
    [sym_false] = ACTIONS(2771),
    [anon_sym_NULL] = ACTIONS(2771),
    [anon_sym_nullptr] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_try] = ACTIONS(2771),
    [anon_sym_delete] = ACTIONS(2771),
    [anon_sym_throw] = ACTIONS(2771),
    [anon_sym_namespace] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
    [anon_sym_concept] = ACTIONS(2771),
    [anon_sym_co_return] = ACTIONS(2771),
    [anon_sym_co_yield] = ACTIONS(2771),
    [anon_sym_R_DQUOTE] = ACTIONS(2773),
    [anon_sym_LR_DQUOTE] = ACTIONS(2773),
    [anon_sym_uR_DQUOTE] = ACTIONS(2773),
    [anon_sym_UR_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2773),
    [anon_sym_co_await] = ACTIONS(2771),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2771),
  },
  [712] = {
    [sym_identifier] = ACTIONS(2863),
    [aux_sym_preproc_include_token1] = ACTIONS(2863),
    [aux_sym_preproc_def_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token2] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2863),
    [sym_preproc_directive] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym___extension__] = ACTIONS(2863),
    [anon_sym_typedef] = ACTIONS(2863),
    [anon_sym_virtual] = ACTIONS(2863),
    [anon_sym_extern] = ACTIONS(2863),
    [anon_sym___attribute__] = ACTIONS(2863),
    [anon_sym___attribute] = ACTIONS(2863),
    [anon_sym_using] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2865),
    [anon_sym___declspec] = ACTIONS(2863),
    [anon_sym___based] = ACTIONS(2863),
    [anon_sym___cdecl] = ACTIONS(2863),
    [anon_sym___clrcall] = ACTIONS(2863),
    [anon_sym___stdcall] = ACTIONS(2863),
    [anon_sym___fastcall] = ACTIONS(2863),
    [anon_sym___thiscall] = ACTIONS(2863),
    [anon_sym___vectorcall] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_signed] = ACTIONS(2863),
    [anon_sym_unsigned] = ACTIONS(2863),
    [anon_sym_long] = ACTIONS(2863),
    [anon_sym_short] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_static] = ACTIONS(2863),
    [anon_sym_register] = ACTIONS(2863),
    [anon_sym_inline] = ACTIONS(2863),
    [anon_sym___inline] = ACTIONS(2863),
    [anon_sym___inline__] = ACTIONS(2863),
    [anon_sym___forceinline] = ACTIONS(2863),
    [anon_sym_thread_local] = ACTIONS(2863),
    [anon_sym___thread] = ACTIONS(2863),
    [anon_sym_const] = ACTIONS(2863),
    [anon_sym_constexpr] = ACTIONS(2863),
    [anon_sym_volatile] = ACTIONS(2863),
    [anon_sym_restrict] = ACTIONS(2863),
    [anon_sym___restrict__] = ACTIONS(2863),
    [anon_sym__Atomic] = ACTIONS(2863),
    [anon_sym__Noreturn] = ACTIONS(2863),
    [anon_sym_noreturn] = ACTIONS(2863),
    [anon_sym__Nonnull] = ACTIONS(2863),
    [anon_sym_mutable] = ACTIONS(2863),
    [anon_sym_constinit] = ACTIONS(2863),
    [anon_sym_consteval] = ACTIONS(2863),
    [anon_sym_alignas] = ACTIONS(2863),
    [anon_sym__Alignas] = ACTIONS(2863),
    [sym_primitive_type] = ACTIONS(2863),
    [anon_sym_enum] = ACTIONS(2863),
    [anon_sym_class] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2863),
    [anon_sym_union] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_switch] = ACTIONS(2863),
    [anon_sym_case] = ACTIONS(2863),
    [anon_sym_default] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_break] = ACTIONS(2863),
    [anon_sym_continue] = ACTIONS(2863),
    [anon_sym_goto] = ACTIONS(2863),
    [anon_sym___try] = ACTIONS(2863),
    [anon_sym___leave] = ACTIONS(2863),
    [anon_sym_not] = ACTIONS(2863),
    [anon_sym_compl] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_sizeof] = ACTIONS(2863),
    [anon_sym___alignof__] = ACTIONS(2863),
    [anon_sym___alignof] = ACTIONS(2863),
    [anon_sym__alignof] = ACTIONS(2863),
    [anon_sym_alignof] = ACTIONS(2863),
    [anon_sym__Alignof] = ACTIONS(2863),
    [anon_sym_offsetof] = ACTIONS(2863),
    [anon_sym__Generic] = ACTIONS(2863),
    [anon_sym_asm] = ACTIONS(2863),
    [anon_sym___asm__] = ACTIONS(2863),
    [anon_sym___asm] = ACTIONS(2863),
    [sym_number_literal] = ACTIONS(2865),
    [anon_sym_L_SQUOTE] = ACTIONS(2865),
    [anon_sym_u_SQUOTE] = ACTIONS(2865),
    [anon_sym_U_SQUOTE] = ACTIONS(2865),
    [anon_sym_u8_SQUOTE] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_L_DQUOTE] = ACTIONS(2865),
    [anon_sym_u_DQUOTE] = ACTIONS(2865),
    [anon_sym_U_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [sym_true] = ACTIONS(2863),
    [sym_false] = ACTIONS(2863),
    [anon_sym_NULL] = ACTIONS(2863),
    [anon_sym_nullptr] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2863),
    [anon_sym_decltype] = ACTIONS(2863),
    [anon_sym_explicit] = ACTIONS(2863),
    [anon_sym_typename] = ACTIONS(2863),
    [anon_sym_template] = ACTIONS(2863),
    [anon_sym_operator] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_throw] = ACTIONS(2863),
    [anon_sym_namespace] = ACTIONS(2863),
    [anon_sym_static_assert] = ACTIONS(2863),
    [anon_sym_concept] = ACTIONS(2863),
    [anon_sym_co_return] = ACTIONS(2863),
    [anon_sym_co_yield] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2863),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_requires] = ACTIONS(2863),
    [sym_this] = ACTIONS(2863),
  },
  [713] = {
    [sym_identifier] = ACTIONS(2867),
    [aux_sym_preproc_include_token1] = ACTIONS(2867),
    [aux_sym_preproc_def_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token2] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2867),
    [sym_preproc_directive] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2869),
    [anon_sym_BANG] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2869),
    [anon_sym___extension__] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2867),
    [anon_sym_virtual] = ACTIONS(2867),
    [anon_sym_extern] = ACTIONS(2867),
    [anon_sym___attribute__] = ACTIONS(2867),
    [anon_sym___attribute] = ACTIONS(2867),
    [anon_sym_using] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2869),
    [anon_sym___declspec] = ACTIONS(2867),
    [anon_sym___based] = ACTIONS(2867),
    [anon_sym___cdecl] = ACTIONS(2867),
    [anon_sym___clrcall] = ACTIONS(2867),
    [anon_sym___stdcall] = ACTIONS(2867),
    [anon_sym___fastcall] = ACTIONS(2867),
    [anon_sym___thiscall] = ACTIONS(2867),
    [anon_sym___vectorcall] = ACTIONS(2867),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_signed] = ACTIONS(2867),
    [anon_sym_unsigned] = ACTIONS(2867),
    [anon_sym_long] = ACTIONS(2867),
    [anon_sym_short] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2867),
    [anon_sym_register] = ACTIONS(2867),
    [anon_sym_inline] = ACTIONS(2867),
    [anon_sym___inline] = ACTIONS(2867),
    [anon_sym___inline__] = ACTIONS(2867),
    [anon_sym___forceinline] = ACTIONS(2867),
    [anon_sym_thread_local] = ACTIONS(2867),
    [anon_sym___thread] = ACTIONS(2867),
    [anon_sym_const] = ACTIONS(2867),
    [anon_sym_constexpr] = ACTIONS(2867),
    [anon_sym_volatile] = ACTIONS(2867),
    [anon_sym_restrict] = ACTIONS(2867),
    [anon_sym___restrict__] = ACTIONS(2867),
    [anon_sym__Atomic] = ACTIONS(2867),
    [anon_sym__Noreturn] = ACTIONS(2867),
    [anon_sym_noreturn] = ACTIONS(2867),
    [anon_sym__Nonnull] = ACTIONS(2867),
    [anon_sym_mutable] = ACTIONS(2867),
    [anon_sym_constinit] = ACTIONS(2867),
    [anon_sym_consteval] = ACTIONS(2867),
    [anon_sym_alignas] = ACTIONS(2867),
    [anon_sym__Alignas] = ACTIONS(2867),
    [sym_primitive_type] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2867),
    [anon_sym_class] = ACTIONS(2867),
    [anon_sym_struct] = ACTIONS(2867),
    [anon_sym_union] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_switch] = ACTIONS(2867),
    [anon_sym_case] = ACTIONS(2867),
    [anon_sym_default] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_continue] = ACTIONS(2867),
    [anon_sym_goto] = ACTIONS(2867),
    [anon_sym___try] = ACTIONS(2867),
    [anon_sym___leave] = ACTIONS(2867),
    [anon_sym_not] = ACTIONS(2867),
    [anon_sym_compl] = ACTIONS(2867),
    [anon_sym_DASH_DASH] = ACTIONS(2869),
    [anon_sym_PLUS_PLUS] = ACTIONS(2869),
    [anon_sym_sizeof] = ACTIONS(2867),
    [anon_sym___alignof__] = ACTIONS(2867),
    [anon_sym___alignof] = ACTIONS(2867),
    [anon_sym__alignof] = ACTIONS(2867),
    [anon_sym_alignof] = ACTIONS(2867),
    [anon_sym__Alignof] = ACTIONS(2867),
    [anon_sym_offsetof] = ACTIONS(2867),
    [anon_sym__Generic] = ACTIONS(2867),
    [anon_sym_asm] = ACTIONS(2867),
    [anon_sym___asm__] = ACTIONS(2867),
    [anon_sym___asm] = ACTIONS(2867),
    [sym_number_literal] = ACTIONS(2869),
    [anon_sym_L_SQUOTE] = ACTIONS(2869),
    [anon_sym_u_SQUOTE] = ACTIONS(2869),
    [anon_sym_U_SQUOTE] = ACTIONS(2869),
    [anon_sym_u8_SQUOTE] = ACTIONS(2869),
    [anon_sym_SQUOTE] = ACTIONS(2869),
    [anon_sym_L_DQUOTE] = ACTIONS(2869),
    [anon_sym_u_DQUOTE] = ACTIONS(2869),
    [anon_sym_U_DQUOTE] = ACTIONS(2869),
    [anon_sym_u8_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [sym_true] = ACTIONS(2867),
    [sym_false] = ACTIONS(2867),
    [anon_sym_NULL] = ACTIONS(2867),
    [anon_sym_nullptr] = ACTIONS(2867),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2867),
    [anon_sym_decltype] = ACTIONS(2867),
    [anon_sym_explicit] = ACTIONS(2867),
    [anon_sym_typename] = ACTIONS(2867),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_delete] = ACTIONS(2867),
    [anon_sym_throw] = ACTIONS(2867),
    [anon_sym_namespace] = ACTIONS(2867),
    [anon_sym_static_assert] = ACTIONS(2867),
    [anon_sym_concept] = ACTIONS(2867),
    [anon_sym_co_return] = ACTIONS(2867),
    [anon_sym_co_yield] = ACTIONS(2867),
    [anon_sym_R_DQUOTE] = ACTIONS(2869),
    [anon_sym_LR_DQUOTE] = ACTIONS(2869),
    [anon_sym_uR_DQUOTE] = ACTIONS(2869),
    [anon_sym_UR_DQUOTE] = ACTIONS(2869),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2869),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_requires] = ACTIONS(2867),
    [sym_this] = ACTIONS(2867),
  },
  [714] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token2] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2885),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym___try] = ACTIONS(2883),
    [anon_sym___leave] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2885),
    [anon_sym_L_SQUOTE] = ACTIONS(2885),
    [anon_sym_u_SQUOTE] = ACTIONS(2885),
    [anon_sym_U_SQUOTE] = ACTIONS(2885),
    [anon_sym_u8_SQUOTE] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_L_DQUOTE] = ACTIONS(2885),
    [anon_sym_u_DQUOTE] = ACTIONS(2885),
    [anon_sym_U_DQUOTE] = ACTIONS(2885),
    [anon_sym_u8_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE] = ACTIONS(2885),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2885),
    [anon_sym_LR_DQUOTE] = ACTIONS(2885),
    [anon_sym_uR_DQUOTE] = ACTIONS(2885),
    [anon_sym_UR_DQUOTE] = ACTIONS(2885),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2885),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
  },
  [715] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_include_token1] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym___cdecl] = ACTIONS(2911),
    [anon_sym___clrcall] = ACTIONS(2911),
    [anon_sym___stdcall] = ACTIONS(2911),
    [anon_sym___fastcall] = ACTIONS(2911),
    [anon_sym___thiscall] = ACTIONS(2911),
    [anon_sym___vectorcall] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2911),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2911),
    [anon_sym_return] = ACTIONS(2911),
    [anon_sym_break] = ACTIONS(2911),
    [anon_sym_continue] = ACTIONS(2911),
    [anon_sym_goto] = ACTIONS(2911),
    [anon_sym___try] = ACTIONS(2911),
    [anon_sym___leave] = ACTIONS(2911),
    [anon_sym_not] = ACTIONS(2911),
    [anon_sym_compl] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_sizeof] = ACTIONS(2911),
    [anon_sym___alignof__] = ACTIONS(2911),
    [anon_sym___alignof] = ACTIONS(2911),
    [anon_sym__alignof] = ACTIONS(2911),
    [anon_sym_alignof] = ACTIONS(2911),
    [anon_sym__Alignof] = ACTIONS(2911),
    [anon_sym_offsetof] = ACTIONS(2911),
    [anon_sym__Generic] = ACTIONS(2911),
    [anon_sym_asm] = ACTIONS(2911),
    [anon_sym___asm__] = ACTIONS(2911),
    [anon_sym___asm] = ACTIONS(2911),
    [sym_number_literal] = ACTIONS(2913),
    [anon_sym_L_SQUOTE] = ACTIONS(2913),
    [anon_sym_u_SQUOTE] = ACTIONS(2913),
    [anon_sym_U_SQUOTE] = ACTIONS(2913),
    [anon_sym_u8_SQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_L_DQUOTE] = ACTIONS(2913),
    [anon_sym_u_DQUOTE] = ACTIONS(2913),
    [anon_sym_U_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8_DQUOTE] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [sym_true] = ACTIONS(2911),
    [sym_false] = ACTIONS(2911),
    [anon_sym_NULL] = ACTIONS(2911),
    [anon_sym_nullptr] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2911),
    [anon_sym_delete] = ACTIONS(2911),
    [anon_sym_throw] = ACTIONS(2911),
    [anon_sym_namespace] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
    [anon_sym_concept] = ACTIONS(2911),
    [anon_sym_co_return] = ACTIONS(2911),
    [anon_sym_co_yield] = ACTIONS(2911),
    [anon_sym_R_DQUOTE] = ACTIONS(2913),
    [anon_sym_LR_DQUOTE] = ACTIONS(2913),
    [anon_sym_uR_DQUOTE] = ACTIONS(2913),
    [anon_sym_UR_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2913),
    [anon_sym_co_await] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2911),
    [anon_sym_requires] = ACTIONS(2911),
    [sym_this] = ACTIONS(2911),
  },
  [716] = {
    [sym_identifier] = ACTIONS(2903),
    [aux_sym_preproc_include_token1] = ACTIONS(2903),
    [aux_sym_preproc_def_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token2] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2903),
    [sym_preproc_directive] = ACTIONS(2903),
    [anon_sym_LPAREN2] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2903),
    [anon_sym_typedef] = ACTIONS(2903),
    [anon_sym_virtual] = ACTIONS(2903),
    [anon_sym_extern] = ACTIONS(2903),
    [anon_sym___attribute__] = ACTIONS(2903),
    [anon_sym___attribute] = ACTIONS(2903),
    [anon_sym_using] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2905),
    [anon_sym___declspec] = ACTIONS(2903),
    [anon_sym___based] = ACTIONS(2903),
    [anon_sym___cdecl] = ACTIONS(2903),
    [anon_sym___clrcall] = ACTIONS(2903),
    [anon_sym___stdcall] = ACTIONS(2903),
    [anon_sym___fastcall] = ACTIONS(2903),
    [anon_sym___thiscall] = ACTIONS(2903),
    [anon_sym___vectorcall] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_signed] = ACTIONS(2903),
    [anon_sym_unsigned] = ACTIONS(2903),
    [anon_sym_long] = ACTIONS(2903),
    [anon_sym_short] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_register] = ACTIONS(2903),
    [anon_sym_inline] = ACTIONS(2903),
    [anon_sym___inline] = ACTIONS(2903),
    [anon_sym___inline__] = ACTIONS(2903),
    [anon_sym___forceinline] = ACTIONS(2903),
    [anon_sym_thread_local] = ACTIONS(2903),
    [anon_sym___thread] = ACTIONS(2903),
    [anon_sym_const] = ACTIONS(2903),
    [anon_sym_constexpr] = ACTIONS(2903),
    [anon_sym_volatile] = ACTIONS(2903),
    [anon_sym_restrict] = ACTIONS(2903),
    [anon_sym___restrict__] = ACTIONS(2903),
    [anon_sym__Atomic] = ACTIONS(2903),
    [anon_sym__Noreturn] = ACTIONS(2903),
    [anon_sym_noreturn] = ACTIONS(2903),
    [anon_sym__Nonnull] = ACTIONS(2903),
    [anon_sym_mutable] = ACTIONS(2903),
    [anon_sym_constinit] = ACTIONS(2903),
    [anon_sym_consteval] = ACTIONS(2903),
    [anon_sym_alignas] = ACTIONS(2903),
    [anon_sym__Alignas] = ACTIONS(2903),
    [sym_primitive_type] = ACTIONS(2903),
    [anon_sym_enum] = ACTIONS(2903),
    [anon_sym_class] = ACTIONS(2903),
    [anon_sym_struct] = ACTIONS(2903),
    [anon_sym_union] = ACTIONS(2903),
    [anon_sym_if] = ACTIONS(2903),
    [anon_sym_switch] = ACTIONS(2903),
    [anon_sym_case] = ACTIONS(2903),
    [anon_sym_default] = ACTIONS(2903),
    [anon_sym_while] = ACTIONS(2903),
    [anon_sym_do] = ACTIONS(2903),
    [anon_sym_for] = ACTIONS(2903),
    [anon_sym_return] = ACTIONS(2903),
    [anon_sym_break] = ACTIONS(2903),
    [anon_sym_continue] = ACTIONS(2903),
    [anon_sym_goto] = ACTIONS(2903),
    [anon_sym___try] = ACTIONS(2903),
    [anon_sym___leave] = ACTIONS(2903),
    [anon_sym_not] = ACTIONS(2903),
    [anon_sym_compl] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_sizeof] = ACTIONS(2903),
    [anon_sym___alignof__] = ACTIONS(2903),
    [anon_sym___alignof] = ACTIONS(2903),
    [anon_sym__alignof] = ACTIONS(2903),
    [anon_sym_alignof] = ACTIONS(2903),
    [anon_sym__Alignof] = ACTIONS(2903),
    [anon_sym_offsetof] = ACTIONS(2903),
    [anon_sym__Generic] = ACTIONS(2903),
    [anon_sym_asm] = ACTIONS(2903),
    [anon_sym___asm__] = ACTIONS(2903),
    [anon_sym___asm] = ACTIONS(2903),
    [sym_number_literal] = ACTIONS(2905),
    [anon_sym_L_SQUOTE] = ACTIONS(2905),
    [anon_sym_u_SQUOTE] = ACTIONS(2905),
    [anon_sym_U_SQUOTE] = ACTIONS(2905),
    [anon_sym_u8_SQUOTE] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(2905),
    [anon_sym_L_DQUOTE] = ACTIONS(2905),
    [anon_sym_u_DQUOTE] = ACTIONS(2905),
    [anon_sym_U_DQUOTE] = ACTIONS(2905),
    [anon_sym_u8_DQUOTE] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [sym_true] = ACTIONS(2903),
    [sym_false] = ACTIONS(2903),
    [anon_sym_NULL] = ACTIONS(2903),
    [anon_sym_nullptr] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2903),
    [anon_sym_decltype] = ACTIONS(2903),
    [anon_sym_explicit] = ACTIONS(2903),
    [anon_sym_typename] = ACTIONS(2903),
    [anon_sym_template] = ACTIONS(2903),
    [anon_sym_operator] = ACTIONS(2903),
    [anon_sym_try] = ACTIONS(2903),
    [anon_sym_delete] = ACTIONS(2903),
    [anon_sym_throw] = ACTIONS(2903),
    [anon_sym_namespace] = ACTIONS(2903),
    [anon_sym_static_assert] = ACTIONS(2903),
    [anon_sym_concept] = ACTIONS(2903),
    [anon_sym_co_return] = ACTIONS(2903),
    [anon_sym_co_yield] = ACTIONS(2903),
    [anon_sym_R_DQUOTE] = ACTIONS(2905),
    [anon_sym_LR_DQUOTE] = ACTIONS(2905),
    [anon_sym_uR_DQUOTE] = ACTIONS(2905),
    [anon_sym_UR_DQUOTE] = ACTIONS(2905),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2905),
    [anon_sym_co_await] = ACTIONS(2903),
    [anon_sym_new] = ACTIONS(2903),
    [anon_sym_requires] = ACTIONS(2903),
    [sym_this] = ACTIONS(2903),
  },
  [717] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_include_token1] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_goto] = ACTIONS(2915),
    [anon_sym___try] = ACTIONS(2915),
    [anon_sym___leave] = ACTIONS(2915),
    [anon_sym_not] = ACTIONS(2915),
    [anon_sym_compl] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_sizeof] = ACTIONS(2915),
    [anon_sym___alignof__] = ACTIONS(2915),
    [anon_sym___alignof] = ACTIONS(2915),
    [anon_sym__alignof] = ACTIONS(2915),
    [anon_sym_alignof] = ACTIONS(2915),
    [anon_sym__Alignof] = ACTIONS(2915),
    [anon_sym_offsetof] = ACTIONS(2915),
    [anon_sym__Generic] = ACTIONS(2915),
    [anon_sym_asm] = ACTIONS(2915),
    [anon_sym___asm__] = ACTIONS(2915),
    [anon_sym___asm] = ACTIONS(2915),
    [sym_number_literal] = ACTIONS(2917),
    [anon_sym_L_SQUOTE] = ACTIONS(2917),
    [anon_sym_u_SQUOTE] = ACTIONS(2917),
    [anon_sym_U_SQUOTE] = ACTIONS(2917),
    [anon_sym_u8_SQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_L_DQUOTE] = ACTIONS(2917),
    [anon_sym_u_DQUOTE] = ACTIONS(2917),
    [anon_sym_U_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8_DQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [anon_sym_NULL] = ACTIONS(2915),
    [anon_sym_nullptr] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
    [anon_sym_concept] = ACTIONS(2915),
    [anon_sym_co_return] = ACTIONS(2915),
    [anon_sym_co_yield] = ACTIONS(2915),
    [anon_sym_R_DQUOTE] = ACTIONS(2917),
    [anon_sym_LR_DQUOTE] = ACTIONS(2917),
    [anon_sym_uR_DQUOTE] = ACTIONS(2917),
    [anon_sym_UR_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2917),
    [anon_sym_co_await] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [sym_this] = ACTIONS(2915),
  },
  [718] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_include_token1] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_goto] = ACTIONS(2915),
    [anon_sym___try] = ACTIONS(2915),
    [anon_sym___leave] = ACTIONS(2915),
    [anon_sym_not] = ACTIONS(2915),
    [anon_sym_compl] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_sizeof] = ACTIONS(2915),
    [anon_sym___alignof__] = ACTIONS(2915),
    [anon_sym___alignof] = ACTIONS(2915),
    [anon_sym__alignof] = ACTIONS(2915),
    [anon_sym_alignof] = ACTIONS(2915),
    [anon_sym__Alignof] = ACTIONS(2915),
    [anon_sym_offsetof] = ACTIONS(2915),
    [anon_sym__Generic] = ACTIONS(2915),
    [anon_sym_asm] = ACTIONS(2915),
    [anon_sym___asm__] = ACTIONS(2915),
    [anon_sym___asm] = ACTIONS(2915),
    [sym_number_literal] = ACTIONS(2917),
    [anon_sym_L_SQUOTE] = ACTIONS(2917),
    [anon_sym_u_SQUOTE] = ACTIONS(2917),
    [anon_sym_U_SQUOTE] = ACTIONS(2917),
    [anon_sym_u8_SQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [anon_sym_L_DQUOTE] = ACTIONS(2917),
    [anon_sym_u_DQUOTE] = ACTIONS(2917),
    [anon_sym_U_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8_DQUOTE] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [anon_sym_NULL] = ACTIONS(2915),
    [anon_sym_nullptr] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
    [anon_sym_concept] = ACTIONS(2915),
    [anon_sym_co_return] = ACTIONS(2915),
    [anon_sym_co_yield] = ACTIONS(2915),
    [anon_sym_R_DQUOTE] = ACTIONS(2917),
    [anon_sym_LR_DQUOTE] = ACTIONS(2917),
    [anon_sym_uR_DQUOTE] = ACTIONS(2917),
    [anon_sym_UR_DQUOTE] = ACTIONS(2917),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2917),
    [anon_sym_co_await] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [sym_this] = ACTIONS(2915),
  },
  [719] = {
    [sym_identifier] = ACTIONS(2919),
    [aux_sym_preproc_include_token1] = ACTIONS(2919),
    [aux_sym_preproc_def_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token2] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2919),
    [sym_preproc_directive] = ACTIONS(2919),
    [anon_sym_LPAREN2] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym___extension__] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(2919),
    [anon_sym_virtual] = ACTIONS(2919),
    [anon_sym_extern] = ACTIONS(2919),
    [anon_sym___attribute__] = ACTIONS(2919),
    [anon_sym___attribute] = ACTIONS(2919),
    [anon_sym_using] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(2921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2921),
    [anon_sym___declspec] = ACTIONS(2919),
    [anon_sym___based] = ACTIONS(2919),
    [anon_sym___cdecl] = ACTIONS(2919),
    [anon_sym___clrcall] = ACTIONS(2919),
    [anon_sym___stdcall] = ACTIONS(2919),
    [anon_sym___fastcall] = ACTIONS(2919),
    [anon_sym___thiscall] = ACTIONS(2919),
    [anon_sym___vectorcall] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_signed] = ACTIONS(2919),
    [anon_sym_unsigned] = ACTIONS(2919),
    [anon_sym_long] = ACTIONS(2919),
    [anon_sym_short] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_register] = ACTIONS(2919),
    [anon_sym_inline] = ACTIONS(2919),
    [anon_sym___inline] = ACTIONS(2919),
    [anon_sym___inline__] = ACTIONS(2919),
    [anon_sym___forceinline] = ACTIONS(2919),
    [anon_sym_thread_local] = ACTIONS(2919),
    [anon_sym___thread] = ACTIONS(2919),
    [anon_sym_const] = ACTIONS(2919),
    [anon_sym_constexpr] = ACTIONS(2919),
    [anon_sym_volatile] = ACTIONS(2919),
    [anon_sym_restrict] = ACTIONS(2919),
    [anon_sym___restrict__] = ACTIONS(2919),
    [anon_sym__Atomic] = ACTIONS(2919),
    [anon_sym__Noreturn] = ACTIONS(2919),
    [anon_sym_noreturn] = ACTIONS(2919),
    [anon_sym__Nonnull] = ACTIONS(2919),
    [anon_sym_mutable] = ACTIONS(2919),
    [anon_sym_constinit] = ACTIONS(2919),
    [anon_sym_consteval] = ACTIONS(2919),
    [anon_sym_alignas] = ACTIONS(2919),
    [anon_sym__Alignas] = ACTIONS(2919),
    [sym_primitive_type] = ACTIONS(2919),
    [anon_sym_enum] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2919),
    [anon_sym_switch] = ACTIONS(2919),
    [anon_sym_case] = ACTIONS(2919),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_while] = ACTIONS(2919),
    [anon_sym_do] = ACTIONS(2919),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_continue] = ACTIONS(2919),
    [anon_sym_goto] = ACTIONS(2919),
    [anon_sym___try] = ACTIONS(2919),
    [anon_sym___leave] = ACTIONS(2919),
    [anon_sym_not] = ACTIONS(2919),
    [anon_sym_compl] = ACTIONS(2919),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_sizeof] = ACTIONS(2919),
    [anon_sym___alignof__] = ACTIONS(2919),
    [anon_sym___alignof] = ACTIONS(2919),
    [anon_sym__alignof] = ACTIONS(2919),
    [anon_sym_alignof] = ACTIONS(2919),
    [anon_sym__Alignof] = ACTIONS(2919),
    [anon_sym_offsetof] = ACTIONS(2919),
    [anon_sym__Generic] = ACTIONS(2919),
    [anon_sym_asm] = ACTIONS(2919),
    [anon_sym___asm__] = ACTIONS(2919),
    [anon_sym___asm] = ACTIONS(2919),
    [sym_number_literal] = ACTIONS(2921),
    [anon_sym_L_SQUOTE] = ACTIONS(2921),
    [anon_sym_u_SQUOTE] = ACTIONS(2921),
    [anon_sym_U_SQUOTE] = ACTIONS(2921),
    [anon_sym_u8_SQUOTE] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_L_DQUOTE] = ACTIONS(2921),
    [anon_sym_u_DQUOTE] = ACTIONS(2921),
    [anon_sym_U_DQUOTE] = ACTIONS(2921),
    [anon_sym_u8_DQUOTE] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [sym_true] = ACTIONS(2919),
    [sym_false] = ACTIONS(2919),
    [anon_sym_NULL] = ACTIONS(2919),
    [anon_sym_nullptr] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2919),
    [anon_sym_decltype] = ACTIONS(2919),
    [anon_sym_explicit] = ACTIONS(2919),
    [anon_sym_typename] = ACTIONS(2919),
    [anon_sym_template] = ACTIONS(2919),
    [anon_sym_operator] = ACTIONS(2919),
    [anon_sym_try] = ACTIONS(2919),
    [anon_sym_delete] = ACTIONS(2919),
    [anon_sym_throw] = ACTIONS(2919),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_static_assert] = ACTIONS(2919),
    [anon_sym_concept] = ACTIONS(2919),
    [anon_sym_co_return] = ACTIONS(2919),
    [anon_sym_co_yield] = ACTIONS(2919),
    [anon_sym_R_DQUOTE] = ACTIONS(2921),
    [anon_sym_LR_DQUOTE] = ACTIONS(2921),
    [anon_sym_uR_DQUOTE] = ACTIONS(2921),
    [anon_sym_UR_DQUOTE] = ACTIONS(2921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2921),
    [anon_sym_co_await] = ACTIONS(2919),
    [anon_sym_new] = ACTIONS(2919),
    [anon_sym_requires] = ACTIONS(2919),
    [sym_this] = ACTIONS(2919),
  },
  [720] = {
    [sym_identifier] = ACTIONS(2923),
    [aux_sym_preproc_include_token1] = ACTIONS(2923),
    [aux_sym_preproc_def_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token2] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2923),
    [sym_preproc_directive] = ACTIONS(2923),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2923),
    [anon_sym_typedef] = ACTIONS(2923),
    [anon_sym_virtual] = ACTIONS(2923),
    [anon_sym_extern] = ACTIONS(2923),
    [anon_sym___attribute__] = ACTIONS(2923),
    [anon_sym___attribute] = ACTIONS(2923),
    [anon_sym_using] = ACTIONS(2923),
    [anon_sym_COLON_COLON] = ACTIONS(2925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2925),
    [anon_sym___declspec] = ACTIONS(2923),
    [anon_sym___based] = ACTIONS(2923),
    [anon_sym___cdecl] = ACTIONS(2923),
    [anon_sym___clrcall] = ACTIONS(2923),
    [anon_sym___stdcall] = ACTIONS(2923),
    [anon_sym___fastcall] = ACTIONS(2923),
    [anon_sym___thiscall] = ACTIONS(2923),
    [anon_sym___vectorcall] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_signed] = ACTIONS(2923),
    [anon_sym_unsigned] = ACTIONS(2923),
    [anon_sym_long] = ACTIONS(2923),
    [anon_sym_short] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_register] = ACTIONS(2923),
    [anon_sym_inline] = ACTIONS(2923),
    [anon_sym___inline] = ACTIONS(2923),
    [anon_sym___inline__] = ACTIONS(2923),
    [anon_sym___forceinline] = ACTIONS(2923),
    [anon_sym_thread_local] = ACTIONS(2923),
    [anon_sym___thread] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_constexpr] = ACTIONS(2923),
    [anon_sym_volatile] = ACTIONS(2923),
    [anon_sym_restrict] = ACTIONS(2923),
    [anon_sym___restrict__] = ACTIONS(2923),
    [anon_sym__Atomic] = ACTIONS(2923),
    [anon_sym__Noreturn] = ACTIONS(2923),
    [anon_sym_noreturn] = ACTIONS(2923),
    [anon_sym__Nonnull] = ACTIONS(2923),
    [anon_sym_mutable] = ACTIONS(2923),
    [anon_sym_constinit] = ACTIONS(2923),
    [anon_sym_consteval] = ACTIONS(2923),
    [anon_sym_alignas] = ACTIONS(2923),
    [anon_sym__Alignas] = ACTIONS(2923),
    [sym_primitive_type] = ACTIONS(2923),
    [anon_sym_enum] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2923),
    [anon_sym_union] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_case] = ACTIONS(2923),
    [anon_sym_default] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_break] = ACTIONS(2923),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2923),
    [anon_sym___try] = ACTIONS(2923),
    [anon_sym___leave] = ACTIONS(2923),
    [anon_sym_not] = ACTIONS(2923),
    [anon_sym_compl] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_sizeof] = ACTIONS(2923),
    [anon_sym___alignof__] = ACTIONS(2923),
    [anon_sym___alignof] = ACTIONS(2923),
    [anon_sym__alignof] = ACTIONS(2923),
    [anon_sym_alignof] = ACTIONS(2923),
    [anon_sym__Alignof] = ACTIONS(2923),
    [anon_sym_offsetof] = ACTIONS(2923),
    [anon_sym__Generic] = ACTIONS(2923),
    [anon_sym_asm] = ACTIONS(2923),
    [anon_sym___asm__] = ACTIONS(2923),
    [anon_sym___asm] = ACTIONS(2923),
    [sym_number_literal] = ACTIONS(2925),
    [anon_sym_L_SQUOTE] = ACTIONS(2925),
    [anon_sym_u_SQUOTE] = ACTIONS(2925),
    [anon_sym_U_SQUOTE] = ACTIONS(2925),
    [anon_sym_u8_SQUOTE] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [anon_sym_L_DQUOTE] = ACTIONS(2925),
    [anon_sym_u_DQUOTE] = ACTIONS(2925),
    [anon_sym_U_DQUOTE] = ACTIONS(2925),
    [anon_sym_u8_DQUOTE] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [sym_true] = ACTIONS(2923),
    [sym_false] = ACTIONS(2923),
    [anon_sym_NULL] = ACTIONS(2923),
    [anon_sym_nullptr] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2923),
    [anon_sym_decltype] = ACTIONS(2923),
    [anon_sym_explicit] = ACTIONS(2923),
    [anon_sym_typename] = ACTIONS(2923),
    [anon_sym_template] = ACTIONS(2923),
    [anon_sym_operator] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_delete] = ACTIONS(2923),
    [anon_sym_throw] = ACTIONS(2923),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_static_assert] = ACTIONS(2923),
    [anon_sym_concept] = ACTIONS(2923),
    [anon_sym_co_return] = ACTIONS(2923),
    [anon_sym_co_yield] = ACTIONS(2923),
    [anon_sym_R_DQUOTE] = ACTIONS(2925),
    [anon_sym_LR_DQUOTE] = ACTIONS(2925),
    [anon_sym_uR_DQUOTE] = ACTIONS(2925),
    [anon_sym_UR_DQUOTE] = ACTIONS(2925),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2925),
    [anon_sym_co_await] = ACTIONS(2923),
    [anon_sym_new] = ACTIONS(2923),
    [anon_sym_requires] = ACTIONS(2923),
    [sym_this] = ACTIONS(2923),
  },
  [721] = {
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_include_token1] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token2] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym___attribute] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2929),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym___cdecl] = ACTIONS(2927),
    [anon_sym___clrcall] = ACTIONS(2927),
    [anon_sym___stdcall] = ACTIONS(2927),
    [anon_sym___fastcall] = ACTIONS(2927),
    [anon_sym___thiscall] = ACTIONS(2927),
    [anon_sym___vectorcall] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym__Nonnull] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym__Alignas] = ACTIONS(2927),
    [sym_primitive_type] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym___try] = ACTIONS(2927),
    [anon_sym___leave] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2927),
    [anon_sym_compl] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_sizeof] = ACTIONS(2927),
    [anon_sym___alignof__] = ACTIONS(2927),
    [anon_sym___alignof] = ACTIONS(2927),
    [anon_sym__alignof] = ACTIONS(2927),
    [anon_sym_alignof] = ACTIONS(2927),
    [anon_sym__Alignof] = ACTIONS(2927),
    [anon_sym_offsetof] = ACTIONS(2927),
    [anon_sym__Generic] = ACTIONS(2927),
    [anon_sym_asm] = ACTIONS(2927),
    [anon_sym___asm__] = ACTIONS(2927),
    [anon_sym___asm] = ACTIONS(2927),
    [sym_number_literal] = ACTIONS(2929),
    [anon_sym_L_SQUOTE] = ACTIONS(2929),
    [anon_sym_u_SQUOTE] = ACTIONS(2929),
    [anon_sym_U_SQUOTE] = ACTIONS(2929),
    [anon_sym_u8_SQUOTE] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [anon_sym_L_DQUOTE] = ACTIONS(2929),
    [anon_sym_u_DQUOTE] = ACTIONS(2929),
    [anon_sym_U_DQUOTE] = ACTIONS(2929),
    [anon_sym_u8_DQUOTE] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [anon_sym_NULL] = ACTIONS(2927),
    [anon_sym_nullptr] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
    [anon_sym_concept] = ACTIONS(2927),
    [anon_sym_co_return] = ACTIONS(2927),
    [anon_sym_co_yield] = ACTIONS(2927),
    [anon_sym_R_DQUOTE] = ACTIONS(2929),
    [anon_sym_LR_DQUOTE] = ACTIONS(2929),
    [anon_sym_uR_DQUOTE] = ACTIONS(2929),
    [anon_sym_UR_DQUOTE] = ACTIONS(2929),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2929),
    [anon_sym_co_await] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_requires] = ACTIONS(2927),
    [sym_this] = ACTIONS(2927),
  },
  [722] = {
    [sym_identifier] = ACTIONS(2919),
    [aux_sym_preproc_include_token1] = ACTIONS(2919),
    [aux_sym_preproc_def_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token1] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2919),
    [sym_preproc_directive] = ACTIONS(2919),
    [anon_sym_LPAREN2] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym___extension__] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(2919),
    [anon_sym_virtual] = ACTIONS(2919),
    [anon_sym_extern] = ACTIONS(2919),
    [anon_sym___attribute__] = ACTIONS(2919),
    [anon_sym___attribute] = ACTIONS(2919),
    [anon_sym_using] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(2921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2921),
    [anon_sym___declspec] = ACTIONS(2919),
    [anon_sym___based] = ACTIONS(2919),
    [anon_sym___cdecl] = ACTIONS(2919),
    [anon_sym___clrcall] = ACTIONS(2919),
    [anon_sym___stdcall] = ACTIONS(2919),
    [anon_sym___fastcall] = ACTIONS(2919),
    [anon_sym___thiscall] = ACTIONS(2919),
    [anon_sym___vectorcall] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_signed] = ACTIONS(2919),
    [anon_sym_unsigned] = ACTIONS(2919),
    [anon_sym_long] = ACTIONS(2919),
    [anon_sym_short] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_register] = ACTIONS(2919),
    [anon_sym_inline] = ACTIONS(2919),
    [anon_sym___inline] = ACTIONS(2919),
    [anon_sym___inline__] = ACTIONS(2919),
    [anon_sym___forceinline] = ACTIONS(2919),
    [anon_sym_thread_local] = ACTIONS(2919),
    [anon_sym___thread] = ACTIONS(2919),
    [anon_sym_const] = ACTIONS(2919),
    [anon_sym_constexpr] = ACTIONS(2919),
    [anon_sym_volatile] = ACTIONS(2919),
    [anon_sym_restrict] = ACTIONS(2919),
    [anon_sym___restrict__] = ACTIONS(2919),
    [anon_sym__Atomic] = ACTIONS(2919),
    [anon_sym__Noreturn] = ACTIONS(2919),
    [anon_sym_noreturn] = ACTIONS(2919),
    [anon_sym__Nonnull] = ACTIONS(2919),
    [anon_sym_mutable] = ACTIONS(2919),
    [anon_sym_constinit] = ACTIONS(2919),
    [anon_sym_consteval] = ACTIONS(2919),
    [anon_sym_alignas] = ACTIONS(2919),
    [anon_sym__Alignas] = ACTIONS(2919),
    [sym_primitive_type] = ACTIONS(2919),
    [anon_sym_enum] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2919),
    [anon_sym_switch] = ACTIONS(2919),
    [anon_sym_case] = ACTIONS(2919),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_while] = ACTIONS(2919),
    [anon_sym_do] = ACTIONS(2919),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_continue] = ACTIONS(2919),
    [anon_sym_goto] = ACTIONS(2919),
    [anon_sym___try] = ACTIONS(2919),
    [anon_sym___leave] = ACTIONS(2919),
    [anon_sym_not] = ACTIONS(2919),
    [anon_sym_compl] = ACTIONS(2919),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_sizeof] = ACTIONS(2919),
    [anon_sym___alignof__] = ACTIONS(2919),
    [anon_sym___alignof] = ACTIONS(2919),
    [anon_sym__alignof] = ACTIONS(2919),
    [anon_sym_alignof] = ACTIONS(2919),
    [anon_sym__Alignof] = ACTIONS(2919),
    [anon_sym_offsetof] = ACTIONS(2919),
    [anon_sym__Generic] = ACTIONS(2919),
    [anon_sym_asm] = ACTIONS(2919),
    [anon_sym___asm__] = ACTIONS(2919),
    [anon_sym___asm] = ACTIONS(2919),
    [sym_number_literal] = ACTIONS(2921),
    [anon_sym_L_SQUOTE] = ACTIONS(2921),
    [anon_sym_u_SQUOTE] = ACTIONS(2921),
    [anon_sym_U_SQUOTE] = ACTIONS(2921),
    [anon_sym_u8_SQUOTE] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_L_DQUOTE] = ACTIONS(2921),
    [anon_sym_u_DQUOTE] = ACTIONS(2921),
    [anon_sym_U_DQUOTE] = ACTIONS(2921),
    [anon_sym_u8_DQUOTE] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [sym_true] = ACTIONS(2919),
    [sym_false] = ACTIONS(2919),
    [anon_sym_NULL] = ACTIONS(2919),
    [anon_sym_nullptr] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2919),
    [anon_sym_decltype] = ACTIONS(2919),
    [anon_sym_explicit] = ACTIONS(2919),
    [anon_sym_typename] = ACTIONS(2919),
    [anon_sym_template] = ACTIONS(2919),
    [anon_sym_operator] = ACTIONS(2919),
    [anon_sym_try] = ACTIONS(2919),
    [anon_sym_delete] = ACTIONS(2919),
    [anon_sym_throw] = ACTIONS(2919),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_static_assert] = ACTIONS(2919),
    [anon_sym_concept] = ACTIONS(2919),
    [anon_sym_co_return] = ACTIONS(2919),
    [anon_sym_co_yield] = ACTIONS(2919),
    [anon_sym_R_DQUOTE] = ACTIONS(2921),
    [anon_sym_LR_DQUOTE] = ACTIONS(2921),
    [anon_sym_uR_DQUOTE] = ACTIONS(2921),
    [anon_sym_UR_DQUOTE] = ACTIONS(2921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2921),
    [anon_sym_co_await] = ACTIONS(2919),
    [anon_sym_new] = ACTIONS(2919),
    [anon_sym_requires] = ACTIONS(2919),
    [sym_this] = ACTIONS(2919),
  },
  [723] = {
    [sym_identifier] = ACTIONS(2931),
    [aux_sym_preproc_include_token1] = ACTIONS(2931),
    [aux_sym_preproc_def_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token2] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2931),
    [sym_preproc_directive] = ACTIONS(2931),
    [anon_sym_LPAREN2] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym___extension__] = ACTIONS(2931),
    [anon_sym_typedef] = ACTIONS(2931),
    [anon_sym_virtual] = ACTIONS(2931),
    [anon_sym_extern] = ACTIONS(2931),
    [anon_sym___attribute__] = ACTIONS(2931),
    [anon_sym___attribute] = ACTIONS(2931),
    [anon_sym_using] = ACTIONS(2931),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2933),
    [anon_sym___declspec] = ACTIONS(2931),
    [anon_sym___based] = ACTIONS(2931),
    [anon_sym___cdecl] = ACTIONS(2931),
    [anon_sym___clrcall] = ACTIONS(2931),
    [anon_sym___stdcall] = ACTIONS(2931),
    [anon_sym___fastcall] = ACTIONS(2931),
    [anon_sym___thiscall] = ACTIONS(2931),
    [anon_sym___vectorcall] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_signed] = ACTIONS(2931),
    [anon_sym_unsigned] = ACTIONS(2931),
    [anon_sym_long] = ACTIONS(2931),
    [anon_sym_short] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_register] = ACTIONS(2931),
    [anon_sym_inline] = ACTIONS(2931),
    [anon_sym___inline] = ACTIONS(2931),
    [anon_sym___inline__] = ACTIONS(2931),
    [anon_sym___forceinline] = ACTIONS(2931),
    [anon_sym_thread_local] = ACTIONS(2931),
    [anon_sym___thread] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_constexpr] = ACTIONS(2931),
    [anon_sym_volatile] = ACTIONS(2931),
    [anon_sym_restrict] = ACTIONS(2931),
    [anon_sym___restrict__] = ACTIONS(2931),
    [anon_sym__Atomic] = ACTIONS(2931),
    [anon_sym__Noreturn] = ACTIONS(2931),
    [anon_sym_noreturn] = ACTIONS(2931),
    [anon_sym__Nonnull] = ACTIONS(2931),
    [anon_sym_mutable] = ACTIONS(2931),
    [anon_sym_constinit] = ACTIONS(2931),
    [anon_sym_consteval] = ACTIONS(2931),
    [anon_sym_alignas] = ACTIONS(2931),
    [anon_sym__Alignas] = ACTIONS(2931),
    [sym_primitive_type] = ACTIONS(2931),
    [anon_sym_enum] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2931),
    [anon_sym_struct] = ACTIONS(2931),
    [anon_sym_union] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_switch] = ACTIONS(2931),
    [anon_sym_case] = ACTIONS(2931),
    [anon_sym_default] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_for] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2931),
    [anon_sym_break] = ACTIONS(2931),
    [anon_sym_continue] = ACTIONS(2931),
    [anon_sym_goto] = ACTIONS(2931),
    [anon_sym___try] = ACTIONS(2931),
    [anon_sym___leave] = ACTIONS(2931),
    [anon_sym_not] = ACTIONS(2931),
    [anon_sym_compl] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2931),
    [anon_sym___alignof__] = ACTIONS(2931),
    [anon_sym___alignof] = ACTIONS(2931),
    [anon_sym__alignof] = ACTIONS(2931),
    [anon_sym_alignof] = ACTIONS(2931),
    [anon_sym__Alignof] = ACTIONS(2931),
    [anon_sym_offsetof] = ACTIONS(2931),
    [anon_sym__Generic] = ACTIONS(2931),
    [anon_sym_asm] = ACTIONS(2931),
    [anon_sym___asm__] = ACTIONS(2931),
    [anon_sym___asm] = ACTIONS(2931),
    [sym_number_literal] = ACTIONS(2933),
    [anon_sym_L_SQUOTE] = ACTIONS(2933),
    [anon_sym_u_SQUOTE] = ACTIONS(2933),
    [anon_sym_U_SQUOTE] = ACTIONS(2933),
    [anon_sym_u8_SQUOTE] = ACTIONS(2933),
    [anon_sym_SQUOTE] = ACTIONS(2933),
    [anon_sym_L_DQUOTE] = ACTIONS(2933),
    [anon_sym_u_DQUOTE] = ACTIONS(2933),
    [anon_sym_U_DQUOTE] = ACTIONS(2933),
    [anon_sym_u8_DQUOTE] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2933),
    [sym_true] = ACTIONS(2931),
    [sym_false] = ACTIONS(2931),
    [anon_sym_NULL] = ACTIONS(2931),
    [anon_sym_nullptr] = ACTIONS(2931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2931),
    [anon_sym_decltype] = ACTIONS(2931),
    [anon_sym_explicit] = ACTIONS(2931),
    [anon_sym_typename] = ACTIONS(2931),
    [anon_sym_template] = ACTIONS(2931),
    [anon_sym_operator] = ACTIONS(2931),
    [anon_sym_try] = ACTIONS(2931),
    [anon_sym_delete] = ACTIONS(2931),
    [anon_sym_throw] = ACTIONS(2931),
    [anon_sym_namespace] = ACTIONS(2931),
    [anon_sym_static_assert] = ACTIONS(2931),
    [anon_sym_concept] = ACTIONS(2931),
    [anon_sym_co_return] = ACTIONS(2931),
    [anon_sym_co_yield] = ACTIONS(2931),
    [anon_sym_R_DQUOTE] = ACTIONS(2933),
    [anon_sym_LR_DQUOTE] = ACTIONS(2933),
    [anon_sym_uR_DQUOTE] = ACTIONS(2933),
    [anon_sym_UR_DQUOTE] = ACTIONS(2933),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2933),
    [anon_sym_co_await] = ACTIONS(2931),
    [anon_sym_new] = ACTIONS(2931),
    [anon_sym_requires] = ACTIONS(2931),
    [sym_this] = ACTIONS(2931),
  },
  [724] = {
    [sym_identifier] = ACTIONS(2935),
    [aux_sym_preproc_include_token1] = ACTIONS(2935),
    [aux_sym_preproc_def_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token2] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2935),
    [sym_preproc_directive] = ACTIONS(2935),
    [anon_sym_LPAREN2] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym___extension__] = ACTIONS(2935),
    [anon_sym_typedef] = ACTIONS(2935),
    [anon_sym_virtual] = ACTIONS(2935),
    [anon_sym_extern] = ACTIONS(2935),
    [anon_sym___attribute__] = ACTIONS(2935),
    [anon_sym___attribute] = ACTIONS(2935),
    [anon_sym_using] = ACTIONS(2935),
    [anon_sym_COLON_COLON] = ACTIONS(2937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2937),
    [anon_sym___declspec] = ACTIONS(2935),
    [anon_sym___based] = ACTIONS(2935),
    [anon_sym___cdecl] = ACTIONS(2935),
    [anon_sym___clrcall] = ACTIONS(2935),
    [anon_sym___stdcall] = ACTIONS(2935),
    [anon_sym___fastcall] = ACTIONS(2935),
    [anon_sym___thiscall] = ACTIONS(2935),
    [anon_sym___vectorcall] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_signed] = ACTIONS(2935),
    [anon_sym_unsigned] = ACTIONS(2935),
    [anon_sym_long] = ACTIONS(2935),
    [anon_sym_short] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_register] = ACTIONS(2935),
    [anon_sym_inline] = ACTIONS(2935),
    [anon_sym___inline] = ACTIONS(2935),
    [anon_sym___inline__] = ACTIONS(2935),
    [anon_sym___forceinline] = ACTIONS(2935),
    [anon_sym_thread_local] = ACTIONS(2935),
    [anon_sym___thread] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_constexpr] = ACTIONS(2935),
    [anon_sym_volatile] = ACTIONS(2935),
    [anon_sym_restrict] = ACTIONS(2935),
    [anon_sym___restrict__] = ACTIONS(2935),
    [anon_sym__Atomic] = ACTIONS(2935),
    [anon_sym__Noreturn] = ACTIONS(2935),
    [anon_sym_noreturn] = ACTIONS(2935),
    [anon_sym__Nonnull] = ACTIONS(2935),
    [anon_sym_mutable] = ACTIONS(2935),
    [anon_sym_constinit] = ACTIONS(2935),
    [anon_sym_consteval] = ACTIONS(2935),
    [anon_sym_alignas] = ACTIONS(2935),
    [anon_sym__Alignas] = ACTIONS(2935),
    [sym_primitive_type] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_union] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_case] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2935),
    [anon_sym_while] = ACTIONS(2935),
    [anon_sym_do] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_goto] = ACTIONS(2935),
    [anon_sym___try] = ACTIONS(2935),
    [anon_sym___leave] = ACTIONS(2935),
    [anon_sym_not] = ACTIONS(2935),
    [anon_sym_compl] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2937),
    [anon_sym_sizeof] = ACTIONS(2935),
    [anon_sym___alignof__] = ACTIONS(2935),
    [anon_sym___alignof] = ACTIONS(2935),
    [anon_sym__alignof] = ACTIONS(2935),
    [anon_sym_alignof] = ACTIONS(2935),
    [anon_sym__Alignof] = ACTIONS(2935),
    [anon_sym_offsetof] = ACTIONS(2935),
    [anon_sym__Generic] = ACTIONS(2935),
    [anon_sym_asm] = ACTIONS(2935),
    [anon_sym___asm__] = ACTIONS(2935),
    [anon_sym___asm] = ACTIONS(2935),
    [sym_number_literal] = ACTIONS(2937),
    [anon_sym_L_SQUOTE] = ACTIONS(2937),
    [anon_sym_u_SQUOTE] = ACTIONS(2937),
    [anon_sym_U_SQUOTE] = ACTIONS(2937),
    [anon_sym_u8_SQUOTE] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2937),
    [anon_sym_L_DQUOTE] = ACTIONS(2937),
    [anon_sym_u_DQUOTE] = ACTIONS(2937),
    [anon_sym_U_DQUOTE] = ACTIONS(2937),
    [anon_sym_u8_DQUOTE] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [anon_sym_NULL] = ACTIONS(2935),
    [anon_sym_nullptr] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2935),
    [anon_sym_decltype] = ACTIONS(2935),
    [anon_sym_explicit] = ACTIONS(2935),
    [anon_sym_typename] = ACTIONS(2935),
    [anon_sym_template] = ACTIONS(2935),
    [anon_sym_operator] = ACTIONS(2935),
    [anon_sym_try] = ACTIONS(2935),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_throw] = ACTIONS(2935),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_static_assert] = ACTIONS(2935),
    [anon_sym_concept] = ACTIONS(2935),
    [anon_sym_co_return] = ACTIONS(2935),
    [anon_sym_co_yield] = ACTIONS(2935),
    [anon_sym_R_DQUOTE] = ACTIONS(2937),
    [anon_sym_LR_DQUOTE] = ACTIONS(2937),
    [anon_sym_uR_DQUOTE] = ACTIONS(2937),
    [anon_sym_UR_DQUOTE] = ACTIONS(2937),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2937),
    [anon_sym_co_await] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2935),
    [anon_sym_requires] = ACTIONS(2935),
    [sym_this] = ACTIONS(2935),
  },
  [725] = {
    [sym_identifier] = ACTIONS(2939),
    [aux_sym_preproc_include_token1] = ACTIONS(2939),
    [aux_sym_preproc_def_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token2] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2939),
    [sym_preproc_directive] = ACTIONS(2939),
    [anon_sym_LPAREN2] = ACTIONS(2941),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2939),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2939),
    [anon_sym_typedef] = ACTIONS(2939),
    [anon_sym_virtual] = ACTIONS(2939),
    [anon_sym_extern] = ACTIONS(2939),
    [anon_sym___attribute__] = ACTIONS(2939),
    [anon_sym___attribute] = ACTIONS(2939),
    [anon_sym_using] = ACTIONS(2939),
    [anon_sym_COLON_COLON] = ACTIONS(2941),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2941),
    [anon_sym___declspec] = ACTIONS(2939),
    [anon_sym___based] = ACTIONS(2939),
    [anon_sym___cdecl] = ACTIONS(2939),
    [anon_sym___clrcall] = ACTIONS(2939),
    [anon_sym___stdcall] = ACTIONS(2939),
    [anon_sym___fastcall] = ACTIONS(2939),
    [anon_sym___thiscall] = ACTIONS(2939),
    [anon_sym___vectorcall] = ACTIONS(2939),
    [anon_sym_LBRACE] = ACTIONS(2941),
    [anon_sym_signed] = ACTIONS(2939),
    [anon_sym_unsigned] = ACTIONS(2939),
    [anon_sym_long] = ACTIONS(2939),
    [anon_sym_short] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_static] = ACTIONS(2939),
    [anon_sym_register] = ACTIONS(2939),
    [anon_sym_inline] = ACTIONS(2939),
    [anon_sym___inline] = ACTIONS(2939),
    [anon_sym___inline__] = ACTIONS(2939),
    [anon_sym___forceinline] = ACTIONS(2939),
    [anon_sym_thread_local] = ACTIONS(2939),
    [anon_sym___thread] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_constexpr] = ACTIONS(2939),
    [anon_sym_volatile] = ACTIONS(2939),
    [anon_sym_restrict] = ACTIONS(2939),
    [anon_sym___restrict__] = ACTIONS(2939),
    [anon_sym__Atomic] = ACTIONS(2939),
    [anon_sym__Noreturn] = ACTIONS(2939),
    [anon_sym_noreturn] = ACTIONS(2939),
    [anon_sym__Nonnull] = ACTIONS(2939),
    [anon_sym_mutable] = ACTIONS(2939),
    [anon_sym_constinit] = ACTIONS(2939),
    [anon_sym_consteval] = ACTIONS(2939),
    [anon_sym_alignas] = ACTIONS(2939),
    [anon_sym__Alignas] = ACTIONS(2939),
    [sym_primitive_type] = ACTIONS(2939),
    [anon_sym_enum] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2939),
    [anon_sym_struct] = ACTIONS(2939),
    [anon_sym_union] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(2939),
    [anon_sym_switch] = ACTIONS(2939),
    [anon_sym_case] = ACTIONS(2939),
    [anon_sym_default] = ACTIONS(2939),
    [anon_sym_while] = ACTIONS(2939),
    [anon_sym_do] = ACTIONS(2939),
    [anon_sym_for] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2939),
    [anon_sym_break] = ACTIONS(2939),
    [anon_sym_continue] = ACTIONS(2939),
    [anon_sym_goto] = ACTIONS(2939),
    [anon_sym___try] = ACTIONS(2939),
    [anon_sym___leave] = ACTIONS(2939),
    [anon_sym_not] = ACTIONS(2939),
    [anon_sym_compl] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2941),
    [anon_sym_PLUS_PLUS] = ACTIONS(2941),
    [anon_sym_sizeof] = ACTIONS(2939),
    [anon_sym___alignof__] = ACTIONS(2939),
    [anon_sym___alignof] = ACTIONS(2939),
    [anon_sym__alignof] = ACTIONS(2939),
    [anon_sym_alignof] = ACTIONS(2939),
    [anon_sym__Alignof] = ACTIONS(2939),
    [anon_sym_offsetof] = ACTIONS(2939),
    [anon_sym__Generic] = ACTIONS(2939),
    [anon_sym_asm] = ACTIONS(2939),
    [anon_sym___asm__] = ACTIONS(2939),
    [anon_sym___asm] = ACTIONS(2939),
    [sym_number_literal] = ACTIONS(2941),
    [anon_sym_L_SQUOTE] = ACTIONS(2941),
    [anon_sym_u_SQUOTE] = ACTIONS(2941),
    [anon_sym_U_SQUOTE] = ACTIONS(2941),
    [anon_sym_u8_SQUOTE] = ACTIONS(2941),
    [anon_sym_SQUOTE] = ACTIONS(2941),
    [anon_sym_L_DQUOTE] = ACTIONS(2941),
    [anon_sym_u_DQUOTE] = ACTIONS(2941),
    [anon_sym_U_DQUOTE] = ACTIONS(2941),
    [anon_sym_u8_DQUOTE] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_true] = ACTIONS(2939),
    [sym_false] = ACTIONS(2939),
    [anon_sym_NULL] = ACTIONS(2939),
    [anon_sym_nullptr] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2939),
    [anon_sym_decltype] = ACTIONS(2939),
    [anon_sym_explicit] = ACTIONS(2939),
    [anon_sym_typename] = ACTIONS(2939),
    [anon_sym_template] = ACTIONS(2939),
    [anon_sym_operator] = ACTIONS(2939),
    [anon_sym_try] = ACTIONS(2939),
    [anon_sym_delete] = ACTIONS(2939),
    [anon_sym_throw] = ACTIONS(2939),
    [anon_sym_namespace] = ACTIONS(2939),
    [anon_sym_static_assert] = ACTIONS(2939),
    [anon_sym_concept] = ACTIONS(2939),
    [anon_sym_co_return] = ACTIONS(2939),
    [anon_sym_co_yield] = ACTIONS(2939),
    [anon_sym_R_DQUOTE] = ACTIONS(2941),
    [anon_sym_LR_DQUOTE] = ACTIONS(2941),
    [anon_sym_uR_DQUOTE] = ACTIONS(2941),
    [anon_sym_UR_DQUOTE] = ACTIONS(2941),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2941),
    [anon_sym_co_await] = ACTIONS(2939),
    [anon_sym_new] = ACTIONS(2939),
    [anon_sym_requires] = ACTIONS(2939),
    [sym_this] = ACTIONS(2939),
  },
  [726] = {
    [sym_identifier] = ACTIONS(3035),
    [aux_sym_preproc_include_token1] = ACTIONS(3035),
    [aux_sym_preproc_def_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token2] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3035),
    [sym_preproc_directive] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3037),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_AMP_AMP] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_SEMI] = ACTIONS(3037),
    [anon_sym___extension__] = ACTIONS(3035),
    [anon_sym_typedef] = ACTIONS(3035),
    [anon_sym_virtual] = ACTIONS(3035),
    [anon_sym_extern] = ACTIONS(3035),
    [anon_sym___attribute__] = ACTIONS(3035),
    [anon_sym___attribute] = ACTIONS(3035),
    [anon_sym_using] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3037),
    [anon_sym___declspec] = ACTIONS(3035),
    [anon_sym___based] = ACTIONS(3035),
    [anon_sym___cdecl] = ACTIONS(3035),
    [anon_sym___clrcall] = ACTIONS(3035),
    [anon_sym___stdcall] = ACTIONS(3035),
    [anon_sym___fastcall] = ACTIONS(3035),
    [anon_sym___thiscall] = ACTIONS(3035),
    [anon_sym___vectorcall] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3037),
    [anon_sym_signed] = ACTIONS(3035),
    [anon_sym_unsigned] = ACTIONS(3035),
    [anon_sym_long] = ACTIONS(3035),
    [anon_sym_short] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3035),
    [anon_sym_register] = ACTIONS(3035),
    [anon_sym_inline] = ACTIONS(3035),
    [anon_sym___inline] = ACTIONS(3035),
    [anon_sym___inline__] = ACTIONS(3035),
    [anon_sym___forceinline] = ACTIONS(3035),
    [anon_sym_thread_local] = ACTIONS(3035),
    [anon_sym___thread] = ACTIONS(3035),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_constexpr] = ACTIONS(3035),
    [anon_sym_volatile] = ACTIONS(3035),
    [anon_sym_restrict] = ACTIONS(3035),
    [anon_sym___restrict__] = ACTIONS(3035),
    [anon_sym__Atomic] = ACTIONS(3035),
    [anon_sym__Noreturn] = ACTIONS(3035),
    [anon_sym_noreturn] = ACTIONS(3035),
    [anon_sym__Nonnull] = ACTIONS(3035),
    [anon_sym_mutable] = ACTIONS(3035),
    [anon_sym_constinit] = ACTIONS(3035),
    [anon_sym_consteval] = ACTIONS(3035),
    [anon_sym_alignas] = ACTIONS(3035),
    [anon_sym__Alignas] = ACTIONS(3035),
    [sym_primitive_type] = ACTIONS(3035),
    [anon_sym_enum] = ACTIONS(3035),
    [anon_sym_class] = ACTIONS(3035),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_union] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_switch] = ACTIONS(3035),
    [anon_sym_case] = ACTIONS(3035),
    [anon_sym_default] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_break] = ACTIONS(3035),
    [anon_sym_continue] = ACTIONS(3035),
    [anon_sym_goto] = ACTIONS(3035),
    [anon_sym___try] = ACTIONS(3035),
    [anon_sym___leave] = ACTIONS(3035),
    [anon_sym_not] = ACTIONS(3035),
    [anon_sym_compl] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3037),
    [anon_sym_sizeof] = ACTIONS(3035),
    [anon_sym___alignof__] = ACTIONS(3035),
    [anon_sym___alignof] = ACTIONS(3035),
    [anon_sym__alignof] = ACTIONS(3035),
    [anon_sym_alignof] = ACTIONS(3035),
    [anon_sym__Alignof] = ACTIONS(3035),
    [anon_sym_offsetof] = ACTIONS(3035),
    [anon_sym__Generic] = ACTIONS(3035),
    [anon_sym_asm] = ACTIONS(3035),
    [anon_sym___asm__] = ACTIONS(3035),
    [anon_sym___asm] = ACTIONS(3035),
    [sym_number_literal] = ACTIONS(3037),
    [anon_sym_L_SQUOTE] = ACTIONS(3037),
    [anon_sym_u_SQUOTE] = ACTIONS(3037),
    [anon_sym_U_SQUOTE] = ACTIONS(3037),
    [anon_sym_u8_SQUOTE] = ACTIONS(3037),
    [anon_sym_SQUOTE] = ACTIONS(3037),
    [anon_sym_L_DQUOTE] = ACTIONS(3037),
    [anon_sym_u_DQUOTE] = ACTIONS(3037),
    [anon_sym_U_DQUOTE] = ACTIONS(3037),
    [anon_sym_u8_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE] = ACTIONS(3037),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [anon_sym_NULL] = ACTIONS(3035),
    [anon_sym_nullptr] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3035),
    [anon_sym_decltype] = ACTIONS(3035),
    [anon_sym_explicit] = ACTIONS(3035),
    [anon_sym_typename] = ACTIONS(3035),
    [anon_sym_template] = ACTIONS(3035),
    [anon_sym_operator] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_delete] = ACTIONS(3035),
    [anon_sym_throw] = ACTIONS(3035),
    [anon_sym_namespace] = ACTIONS(3035),
    [anon_sym_static_assert] = ACTIONS(3035),
    [anon_sym_concept] = ACTIONS(3035),
    [anon_sym_co_return] = ACTIONS(3035),
    [anon_sym_co_yield] = ACTIONS(3035),
    [anon_sym_R_DQUOTE] = ACTIONS(3037),
    [anon_sym_LR_DQUOTE] = ACTIONS(3037),
    [anon_sym_uR_DQUOTE] = ACTIONS(3037),
    [anon_sym_UR_DQUOTE] = ACTIONS(3037),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3037),
    [anon_sym_co_await] = ACTIONS(3035),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_requires] = ACTIONS(3035),
    [sym_this] = ACTIONS(3035),
  },
  [727] = {
    [sym_identifier] = ACTIONS(2923),
    [aux_sym_preproc_include_token1] = ACTIONS(2923),
    [aux_sym_preproc_def_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2923),
    [sym_preproc_directive] = ACTIONS(2923),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2923),
    [anon_sym_typedef] = ACTIONS(2923),
    [anon_sym_virtual] = ACTIONS(2923),
    [anon_sym_extern] = ACTIONS(2923),
    [anon_sym___attribute__] = ACTIONS(2923),
    [anon_sym___attribute] = ACTIONS(2923),
    [anon_sym_using] = ACTIONS(2923),
    [anon_sym_COLON_COLON] = ACTIONS(2925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2925),
    [anon_sym___declspec] = ACTIONS(2923),
    [anon_sym___based] = ACTIONS(2923),
    [anon_sym___cdecl] = ACTIONS(2923),
    [anon_sym___clrcall] = ACTIONS(2923),
    [anon_sym___stdcall] = ACTIONS(2923),
    [anon_sym___fastcall] = ACTIONS(2923),
    [anon_sym___thiscall] = ACTIONS(2923),
    [anon_sym___vectorcall] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_signed] = ACTIONS(2923),
    [anon_sym_unsigned] = ACTIONS(2923),
    [anon_sym_long] = ACTIONS(2923),
    [anon_sym_short] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_register] = ACTIONS(2923),
    [anon_sym_inline] = ACTIONS(2923),
    [anon_sym___inline] = ACTIONS(2923),
    [anon_sym___inline__] = ACTIONS(2923),
    [anon_sym___forceinline] = ACTIONS(2923),
    [anon_sym_thread_local] = ACTIONS(2923),
    [anon_sym___thread] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_constexpr] = ACTIONS(2923),
    [anon_sym_volatile] = ACTIONS(2923),
    [anon_sym_restrict] = ACTIONS(2923),
    [anon_sym___restrict__] = ACTIONS(2923),
    [anon_sym__Atomic] = ACTIONS(2923),
    [anon_sym__Noreturn] = ACTIONS(2923),
    [anon_sym_noreturn] = ACTIONS(2923),
    [anon_sym__Nonnull] = ACTIONS(2923),
    [anon_sym_mutable] = ACTIONS(2923),
    [anon_sym_constinit] = ACTIONS(2923),
    [anon_sym_consteval] = ACTIONS(2923),
    [anon_sym_alignas] = ACTIONS(2923),
    [anon_sym__Alignas] = ACTIONS(2923),
    [sym_primitive_type] = ACTIONS(2923),
    [anon_sym_enum] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2923),
    [anon_sym_union] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_case] = ACTIONS(2923),
    [anon_sym_default] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_break] = ACTIONS(2923),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_goto] = ACTIONS(2923),
    [anon_sym___try] = ACTIONS(2923),
    [anon_sym___leave] = ACTIONS(2923),
    [anon_sym_not] = ACTIONS(2923),
    [anon_sym_compl] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_sizeof] = ACTIONS(2923),
    [anon_sym___alignof__] = ACTIONS(2923),
    [anon_sym___alignof] = ACTIONS(2923),
    [anon_sym__alignof] = ACTIONS(2923),
    [anon_sym_alignof] = ACTIONS(2923),
    [anon_sym__Alignof] = ACTIONS(2923),
    [anon_sym_offsetof] = ACTIONS(2923),
    [anon_sym__Generic] = ACTIONS(2923),
    [anon_sym_asm] = ACTIONS(2923),
    [anon_sym___asm__] = ACTIONS(2923),
    [anon_sym___asm] = ACTIONS(2923),
    [sym_number_literal] = ACTIONS(2925),
    [anon_sym_L_SQUOTE] = ACTIONS(2925),
    [anon_sym_u_SQUOTE] = ACTIONS(2925),
    [anon_sym_U_SQUOTE] = ACTIONS(2925),
    [anon_sym_u8_SQUOTE] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [anon_sym_L_DQUOTE] = ACTIONS(2925),
    [anon_sym_u_DQUOTE] = ACTIONS(2925),
    [anon_sym_U_DQUOTE] = ACTIONS(2925),
    [anon_sym_u8_DQUOTE] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [sym_true] = ACTIONS(2923),
    [sym_false] = ACTIONS(2923),
    [anon_sym_NULL] = ACTIONS(2923),
    [anon_sym_nullptr] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2923),
    [anon_sym_decltype] = ACTIONS(2923),
    [anon_sym_explicit] = ACTIONS(2923),
    [anon_sym_typename] = ACTIONS(2923),
    [anon_sym_template] = ACTIONS(2923),
    [anon_sym_operator] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_delete] = ACTIONS(2923),
    [anon_sym_throw] = ACTIONS(2923),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_static_assert] = ACTIONS(2923),
    [anon_sym_concept] = ACTIONS(2923),
    [anon_sym_co_return] = ACTIONS(2923),
    [anon_sym_co_yield] = ACTIONS(2923),
    [anon_sym_R_DQUOTE] = ACTIONS(2925),
    [anon_sym_LR_DQUOTE] = ACTIONS(2925),
    [anon_sym_uR_DQUOTE] = ACTIONS(2925),
    [anon_sym_UR_DQUOTE] = ACTIONS(2925),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2925),
    [anon_sym_co_await] = ACTIONS(2923),
    [anon_sym_new] = ACTIONS(2923),
    [anon_sym_requires] = ACTIONS(2923),
    [sym_this] = ACTIONS(2923),
  },
  [728] = {
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_include_token1] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym___attribute] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2929),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym___cdecl] = ACTIONS(2927),
    [anon_sym___clrcall] = ACTIONS(2927),
    [anon_sym___stdcall] = ACTIONS(2927),
    [anon_sym___fastcall] = ACTIONS(2927),
    [anon_sym___thiscall] = ACTIONS(2927),
    [anon_sym___vectorcall] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym__Nonnull] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym__Alignas] = ACTIONS(2927),
    [sym_primitive_type] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_goto] = ACTIONS(2927),
    [anon_sym___try] = ACTIONS(2927),
    [anon_sym___leave] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2927),
    [anon_sym_compl] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_sizeof] = ACTIONS(2927),
    [anon_sym___alignof__] = ACTIONS(2927),
    [anon_sym___alignof] = ACTIONS(2927),
    [anon_sym__alignof] = ACTIONS(2927),
    [anon_sym_alignof] = ACTIONS(2927),
    [anon_sym__Alignof] = ACTIONS(2927),
    [anon_sym_offsetof] = ACTIONS(2927),
    [anon_sym__Generic] = ACTIONS(2927),
    [anon_sym_asm] = ACTIONS(2927),
    [anon_sym___asm__] = ACTIONS(2927),
    [anon_sym___asm] = ACTIONS(2927),
    [sym_number_literal] = ACTIONS(2929),
    [anon_sym_L_SQUOTE] = ACTIONS(2929),
    [anon_sym_u_SQUOTE] = ACTIONS(2929),
    [anon_sym_U_SQUOTE] = ACTIONS(2929),
    [anon_sym_u8_SQUOTE] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [anon_sym_L_DQUOTE] = ACTIONS(2929),
    [anon_sym_u_DQUOTE] = ACTIONS(2929),
    [anon_sym_U_DQUOTE] = ACTIONS(2929),
    [anon_sym_u8_DQUOTE] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [anon_sym_NULL] = ACTIONS(2927),
    [anon_sym_nullptr] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
    [anon_sym_concept] = ACTIONS(2927),
    [anon_sym_co_return] = ACTIONS(2927),
    [anon_sym_co_yield] = ACTIONS(2927),
    [anon_sym_R_DQUOTE] = ACTIONS(2929),
    [anon_sym_LR_DQUOTE] = ACTIONS(2929),
    [anon_sym_uR_DQUOTE] = ACTIONS(2929),
    [anon_sym_UR_DQUOTE] = ACTIONS(2929),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2929),
    [anon_sym_co_await] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_requires] = ACTIONS(2927),
    [sym_this] = ACTIONS(2927),
  },
  [729] = {
    [sym_identifier] = ACTIONS(3067),
    [aux_sym_preproc_include_token1] = ACTIONS(3067),
    [aux_sym_preproc_def_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token2] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3067),
    [sym_preproc_directive] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym___extension__] = ACTIONS(3067),
    [anon_sym_typedef] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym___attribute__] = ACTIONS(3067),
    [anon_sym___attribute] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3069),
    [anon_sym___declspec] = ACTIONS(3067),
    [anon_sym___based] = ACTIONS(3067),
    [anon_sym___cdecl] = ACTIONS(3067),
    [anon_sym___clrcall] = ACTIONS(3067),
    [anon_sym___stdcall] = ACTIONS(3067),
    [anon_sym___fastcall] = ACTIONS(3067),
    [anon_sym___thiscall] = ACTIONS(3067),
    [anon_sym___vectorcall] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_signed] = ACTIONS(3067),
    [anon_sym_unsigned] = ACTIONS(3067),
    [anon_sym_long] = ACTIONS(3067),
    [anon_sym_short] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_register] = ACTIONS(3067),
    [anon_sym_inline] = ACTIONS(3067),
    [anon_sym___inline] = ACTIONS(3067),
    [anon_sym___inline__] = ACTIONS(3067),
    [anon_sym___forceinline] = ACTIONS(3067),
    [anon_sym_thread_local] = ACTIONS(3067),
    [anon_sym___thread] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_constexpr] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_restrict] = ACTIONS(3067),
    [anon_sym___restrict__] = ACTIONS(3067),
    [anon_sym__Atomic] = ACTIONS(3067),
    [anon_sym__Noreturn] = ACTIONS(3067),
    [anon_sym_noreturn] = ACTIONS(3067),
    [anon_sym__Nonnull] = ACTIONS(3067),
    [anon_sym_mutable] = ACTIONS(3067),
    [anon_sym_constinit] = ACTIONS(3067),
    [anon_sym_consteval] = ACTIONS(3067),
    [anon_sym_alignas] = ACTIONS(3067),
    [anon_sym__Alignas] = ACTIONS(3067),
    [sym_primitive_type] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_union] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_case] = ACTIONS(3067),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_break] = ACTIONS(3067),
    [anon_sym_continue] = ACTIONS(3067),
    [anon_sym_goto] = ACTIONS(3067),
    [anon_sym___try] = ACTIONS(3067),
    [anon_sym___leave] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(3067),
    [anon_sym_compl] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_sizeof] = ACTIONS(3067),
    [anon_sym___alignof__] = ACTIONS(3067),
    [anon_sym___alignof] = ACTIONS(3067),
    [anon_sym__alignof] = ACTIONS(3067),
    [anon_sym_alignof] = ACTIONS(3067),
    [anon_sym__Alignof] = ACTIONS(3067),
    [anon_sym_offsetof] = ACTIONS(3067),
    [anon_sym__Generic] = ACTIONS(3067),
    [anon_sym_asm] = ACTIONS(3067),
    [anon_sym___asm__] = ACTIONS(3067),
    [anon_sym___asm] = ACTIONS(3067),
    [sym_number_literal] = ACTIONS(3069),
    [anon_sym_L_SQUOTE] = ACTIONS(3069),
    [anon_sym_u_SQUOTE] = ACTIONS(3069),
    [anon_sym_U_SQUOTE] = ACTIONS(3069),
    [anon_sym_u8_SQUOTE] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_L_DQUOTE] = ACTIONS(3069),
    [anon_sym_u_DQUOTE] = ACTIONS(3069),
    [anon_sym_U_DQUOTE] = ACTIONS(3069),
    [anon_sym_u8_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [sym_true] = ACTIONS(3067),
    [sym_false] = ACTIONS(3067),
    [anon_sym_NULL] = ACTIONS(3067),
    [anon_sym_nullptr] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3067),
    [anon_sym_decltype] = ACTIONS(3067),
    [anon_sym_explicit] = ACTIONS(3067),
    [anon_sym_typename] = ACTIONS(3067),
    [anon_sym_template] = ACTIONS(3067),
    [anon_sym_operator] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_delete] = ACTIONS(3067),
    [anon_sym_throw] = ACTIONS(3067),
    [anon_sym_namespace] = ACTIONS(3067),
    [anon_sym_static_assert] = ACTIONS(3067),
    [anon_sym_concept] = ACTIONS(3067),
    [anon_sym_co_return] = ACTIONS(3067),
    [anon_sym_co_yield] = ACTIONS(3067),
    [anon_sym_R_DQUOTE] = ACTIONS(3069),
    [anon_sym_LR_DQUOTE] = ACTIONS(3069),
    [anon_sym_uR_DQUOTE] = ACTIONS(3069),
    [anon_sym_UR_DQUOTE] = ACTIONS(3069),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3069),
    [anon_sym_co_await] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_requires] = ACTIONS(3067),
    [sym_this] = ACTIONS(3067),
  },
  [730] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_include_token1] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym___cdecl] = ACTIONS(2843),
    [anon_sym___clrcall] = ACTIONS(2843),
    [anon_sym___stdcall] = ACTIONS(2843),
    [anon_sym___fastcall] = ACTIONS(2843),
    [anon_sym___thiscall] = ACTIONS(2843),
    [anon_sym___vectorcall] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2845),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2843),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_break] = ACTIONS(2843),
    [anon_sym_continue] = ACTIONS(2843),
    [anon_sym_goto] = ACTIONS(2843),
    [anon_sym___try] = ACTIONS(2843),
    [anon_sym___leave] = ACTIONS(2843),
    [anon_sym_not] = ACTIONS(2843),
    [anon_sym_compl] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_sizeof] = ACTIONS(2843),
    [anon_sym___alignof__] = ACTIONS(2843),
    [anon_sym___alignof] = ACTIONS(2843),
    [anon_sym__alignof] = ACTIONS(2843),
    [anon_sym_alignof] = ACTIONS(2843),
    [anon_sym__Alignof] = ACTIONS(2843),
    [anon_sym_offsetof] = ACTIONS(2843),
    [anon_sym__Generic] = ACTIONS(2843),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2845),
    [anon_sym_u_SQUOTE] = ACTIONS(2845),
    [anon_sym_U_SQUOTE] = ACTIONS(2845),
    [anon_sym_u8_SQUOTE] = ACTIONS(2845),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_L_DQUOTE] = ACTIONS(2845),
    [anon_sym_u_DQUOTE] = ACTIONS(2845),
    [anon_sym_U_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2845),
    [sym_true] = ACTIONS(2843),
    [sym_false] = ACTIONS(2843),
    [anon_sym_NULL] = ACTIONS(2843),
    [anon_sym_nullptr] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_delete] = ACTIONS(2843),
    [anon_sym_throw] = ACTIONS(2843),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
    [anon_sym_concept] = ACTIONS(2843),
    [anon_sym_co_return] = ACTIONS(2843),
    [anon_sym_co_yield] = ACTIONS(2843),
    [anon_sym_R_DQUOTE] = ACTIONS(2845),
    [anon_sym_LR_DQUOTE] = ACTIONS(2845),
    [anon_sym_uR_DQUOTE] = ACTIONS(2845),
    [anon_sym_UR_DQUOTE] = ACTIONS(2845),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2845),
    [anon_sym_co_await] = ACTIONS(2843),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_requires] = ACTIONS(2843),
    [sym_this] = ACTIONS(2843),
  },
  [731] = {
    [sym_identifier] = ACTIONS(3083),
    [aux_sym_preproc_include_token1] = ACTIONS(3083),
    [aux_sym_preproc_def_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token2] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3083),
    [sym_preproc_directive] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3085),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym___extension__] = ACTIONS(3083),
    [anon_sym_typedef] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym___attribute__] = ACTIONS(3083),
    [anon_sym___attribute] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3085),
    [anon_sym___declspec] = ACTIONS(3083),
    [anon_sym___based] = ACTIONS(3083),
    [anon_sym___cdecl] = ACTIONS(3083),
    [anon_sym___clrcall] = ACTIONS(3083),
    [anon_sym___stdcall] = ACTIONS(3083),
    [anon_sym___fastcall] = ACTIONS(3083),
    [anon_sym___thiscall] = ACTIONS(3083),
    [anon_sym___vectorcall] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_signed] = ACTIONS(3083),
    [anon_sym_unsigned] = ACTIONS(3083),
    [anon_sym_long] = ACTIONS(3083),
    [anon_sym_short] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_register] = ACTIONS(3083),
    [anon_sym_inline] = ACTIONS(3083),
    [anon_sym___inline] = ACTIONS(3083),
    [anon_sym___inline__] = ACTIONS(3083),
    [anon_sym___forceinline] = ACTIONS(3083),
    [anon_sym_thread_local] = ACTIONS(3083),
    [anon_sym___thread] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_constexpr] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_restrict] = ACTIONS(3083),
    [anon_sym___restrict__] = ACTIONS(3083),
    [anon_sym__Atomic] = ACTIONS(3083),
    [anon_sym__Noreturn] = ACTIONS(3083),
    [anon_sym_noreturn] = ACTIONS(3083),
    [anon_sym__Nonnull] = ACTIONS(3083),
    [anon_sym_mutable] = ACTIONS(3083),
    [anon_sym_constinit] = ACTIONS(3083),
    [anon_sym_consteval] = ACTIONS(3083),
    [anon_sym_alignas] = ACTIONS(3083),
    [anon_sym__Alignas] = ACTIONS(3083),
    [sym_primitive_type] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3083),
    [anon_sym_union] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_case] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_goto] = ACTIONS(3083),
    [anon_sym___try] = ACTIONS(3083),
    [anon_sym___leave] = ACTIONS(3083),
    [anon_sym_not] = ACTIONS(3083),
    [anon_sym_compl] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_sizeof] = ACTIONS(3083),
    [anon_sym___alignof__] = ACTIONS(3083),
    [anon_sym___alignof] = ACTIONS(3083),
    [anon_sym__alignof] = ACTIONS(3083),
    [anon_sym_alignof] = ACTIONS(3083),
    [anon_sym__Alignof] = ACTIONS(3083),
    [anon_sym_offsetof] = ACTIONS(3083),
    [anon_sym__Generic] = ACTIONS(3083),
    [anon_sym_asm] = ACTIONS(3083),
    [anon_sym___asm__] = ACTIONS(3083),
    [anon_sym___asm] = ACTIONS(3083),
    [sym_number_literal] = ACTIONS(3085),
    [anon_sym_L_SQUOTE] = ACTIONS(3085),
    [anon_sym_u_SQUOTE] = ACTIONS(3085),
    [anon_sym_U_SQUOTE] = ACTIONS(3085),
    [anon_sym_u8_SQUOTE] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [anon_sym_L_DQUOTE] = ACTIONS(3085),
    [anon_sym_u_DQUOTE] = ACTIONS(3085),
    [anon_sym_U_DQUOTE] = ACTIONS(3085),
    [anon_sym_u8_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [sym_true] = ACTIONS(3083),
    [sym_false] = ACTIONS(3083),
    [anon_sym_NULL] = ACTIONS(3083),
    [anon_sym_nullptr] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3083),
    [anon_sym_decltype] = ACTIONS(3083),
    [anon_sym_explicit] = ACTIONS(3083),
    [anon_sym_typename] = ACTIONS(3083),
    [anon_sym_template] = ACTIONS(3083),
    [anon_sym_operator] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_delete] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_namespace] = ACTIONS(3083),
    [anon_sym_static_assert] = ACTIONS(3083),
    [anon_sym_concept] = ACTIONS(3083),
    [anon_sym_co_return] = ACTIONS(3083),
    [anon_sym_co_yield] = ACTIONS(3083),
    [anon_sym_R_DQUOTE] = ACTIONS(3085),
    [anon_sym_LR_DQUOTE] = ACTIONS(3085),
    [anon_sym_uR_DQUOTE] = ACTIONS(3085),
    [anon_sym_UR_DQUOTE] = ACTIONS(3085),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3085),
    [anon_sym_co_await] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_requires] = ACTIONS(3083),
    [sym_this] = ACTIONS(3083),
  },
  [732] = {
    [sym_identifier] = ACTIONS(2931),
    [aux_sym_preproc_include_token1] = ACTIONS(2931),
    [aux_sym_preproc_def_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token1] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2931),
    [sym_preproc_directive] = ACTIONS(2931),
    [anon_sym_LPAREN2] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym___extension__] = ACTIONS(2931),
    [anon_sym_typedef] = ACTIONS(2931),
    [anon_sym_virtual] = ACTIONS(2931),
    [anon_sym_extern] = ACTIONS(2931),
    [anon_sym___attribute__] = ACTIONS(2931),
    [anon_sym___attribute] = ACTIONS(2931),
    [anon_sym_using] = ACTIONS(2931),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2933),
    [anon_sym___declspec] = ACTIONS(2931),
    [anon_sym___based] = ACTIONS(2931),
    [anon_sym___cdecl] = ACTIONS(2931),
    [anon_sym___clrcall] = ACTIONS(2931),
    [anon_sym___stdcall] = ACTIONS(2931),
    [anon_sym___fastcall] = ACTIONS(2931),
    [anon_sym___thiscall] = ACTIONS(2931),
    [anon_sym___vectorcall] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(2933),
    [anon_sym_signed] = ACTIONS(2931),
    [anon_sym_unsigned] = ACTIONS(2931),
    [anon_sym_long] = ACTIONS(2931),
    [anon_sym_short] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_register] = ACTIONS(2931),
    [anon_sym_inline] = ACTIONS(2931),
    [anon_sym___inline] = ACTIONS(2931),
    [anon_sym___inline__] = ACTIONS(2931),
    [anon_sym___forceinline] = ACTIONS(2931),
    [anon_sym_thread_local] = ACTIONS(2931),
    [anon_sym___thread] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_constexpr] = ACTIONS(2931),
    [anon_sym_volatile] = ACTIONS(2931),
    [anon_sym_restrict] = ACTIONS(2931),
    [anon_sym___restrict__] = ACTIONS(2931),
    [anon_sym__Atomic] = ACTIONS(2931),
    [anon_sym__Noreturn] = ACTIONS(2931),
    [anon_sym_noreturn] = ACTIONS(2931),
    [anon_sym__Nonnull] = ACTIONS(2931),
    [anon_sym_mutable] = ACTIONS(2931),
    [anon_sym_constinit] = ACTIONS(2931),
    [anon_sym_consteval] = ACTIONS(2931),
    [anon_sym_alignas] = ACTIONS(2931),
    [anon_sym__Alignas] = ACTIONS(2931),
    [sym_primitive_type] = ACTIONS(2931),
    [anon_sym_enum] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2931),
    [anon_sym_struct] = ACTIONS(2931),
    [anon_sym_union] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_switch] = ACTIONS(2931),
    [anon_sym_case] = ACTIONS(2931),
    [anon_sym_default] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_for] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2931),
    [anon_sym_break] = ACTIONS(2931),
    [anon_sym_continue] = ACTIONS(2931),
    [anon_sym_goto] = ACTIONS(2931),
    [anon_sym___try] = ACTIONS(2931),
    [anon_sym___leave] = ACTIONS(2931),
    [anon_sym_not] = ACTIONS(2931),
    [anon_sym_compl] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2931),
    [anon_sym___alignof__] = ACTIONS(2931),
    [anon_sym___alignof] = ACTIONS(2931),
    [anon_sym__alignof] = ACTIONS(2931),
    [anon_sym_alignof] = ACTIONS(2931),
    [anon_sym__Alignof] = ACTIONS(2931),
    [anon_sym_offsetof] = ACTIONS(2931),
    [anon_sym__Generic] = ACTIONS(2931),
    [anon_sym_asm] = ACTIONS(2931),
    [anon_sym___asm__] = ACTIONS(2931),
    [anon_sym___asm] = ACTIONS(2931),
    [sym_number_literal] = ACTIONS(2933),
    [anon_sym_L_SQUOTE] = ACTIONS(2933),
    [anon_sym_u_SQUOTE] = ACTIONS(2933),
    [anon_sym_U_SQUOTE] = ACTIONS(2933),
    [anon_sym_u8_SQUOTE] = ACTIONS(2933),
    [anon_sym_SQUOTE] = ACTIONS(2933),
    [anon_sym_L_DQUOTE] = ACTIONS(2933),
    [anon_sym_u_DQUOTE] = ACTIONS(2933),
    [anon_sym_U_DQUOTE] = ACTIONS(2933),
    [anon_sym_u8_DQUOTE] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2933),
    [sym_true] = ACTIONS(2931),
    [sym_false] = ACTIONS(2931),
    [anon_sym_NULL] = ACTIONS(2931),
    [anon_sym_nullptr] = ACTIONS(2931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2931),
    [anon_sym_decltype] = ACTIONS(2931),
    [anon_sym_explicit] = ACTIONS(2931),
    [anon_sym_typename] = ACTIONS(2931),
    [anon_sym_template] = ACTIONS(2931),
    [anon_sym_operator] = ACTIONS(2931),
    [anon_sym_try] = ACTIONS(2931),
    [anon_sym_delete] = ACTIONS(2931),
    [anon_sym_throw] = ACTIONS(2931),
    [anon_sym_namespace] = ACTIONS(2931),
    [anon_sym_static_assert] = ACTIONS(2931),
    [anon_sym_concept] = ACTIONS(2931),
    [anon_sym_co_return] = ACTIONS(2931),
    [anon_sym_co_yield] = ACTIONS(2931),
    [anon_sym_R_DQUOTE] = ACTIONS(2933),
    [anon_sym_LR_DQUOTE] = ACTIONS(2933),
    [anon_sym_uR_DQUOTE] = ACTIONS(2933),
    [anon_sym_UR_DQUOTE] = ACTIONS(2933),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2933),
    [anon_sym_co_await] = ACTIONS(2931),
    [anon_sym_new] = ACTIONS(2931),
    [anon_sym_requires] = ACTIONS(2931),
    [sym_this] = ACTIONS(2931),
  },
  [733] = {
    [sym_identifier] = ACTIONS(2935),
    [aux_sym_preproc_include_token1] = ACTIONS(2935),
    [aux_sym_preproc_def_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token1] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2935),
    [sym_preproc_directive] = ACTIONS(2935),
    [anon_sym_LPAREN2] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym___extension__] = ACTIONS(2935),
    [anon_sym_typedef] = ACTIONS(2935),
    [anon_sym_virtual] = ACTIONS(2935),
    [anon_sym_extern] = ACTIONS(2935),
    [anon_sym___attribute__] = ACTIONS(2935),
    [anon_sym___attribute] = ACTIONS(2935),
    [anon_sym_using] = ACTIONS(2935),
    [anon_sym_COLON_COLON] = ACTIONS(2937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2937),
    [anon_sym___declspec] = ACTIONS(2935),
    [anon_sym___based] = ACTIONS(2935),
    [anon_sym___cdecl] = ACTIONS(2935),
    [anon_sym___clrcall] = ACTIONS(2935),
    [anon_sym___stdcall] = ACTIONS(2935),
    [anon_sym___fastcall] = ACTIONS(2935),
    [anon_sym___thiscall] = ACTIONS(2935),
    [anon_sym___vectorcall] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_RBRACE] = ACTIONS(2937),
    [anon_sym_signed] = ACTIONS(2935),
    [anon_sym_unsigned] = ACTIONS(2935),
    [anon_sym_long] = ACTIONS(2935),
    [anon_sym_short] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_register] = ACTIONS(2935),
    [anon_sym_inline] = ACTIONS(2935),
    [anon_sym___inline] = ACTIONS(2935),
    [anon_sym___inline__] = ACTIONS(2935),
    [anon_sym___forceinline] = ACTIONS(2935),
    [anon_sym_thread_local] = ACTIONS(2935),
    [anon_sym___thread] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_constexpr] = ACTIONS(2935),
    [anon_sym_volatile] = ACTIONS(2935),
    [anon_sym_restrict] = ACTIONS(2935),
    [anon_sym___restrict__] = ACTIONS(2935),
    [anon_sym__Atomic] = ACTIONS(2935),
    [anon_sym__Noreturn] = ACTIONS(2935),
    [anon_sym_noreturn] = ACTIONS(2935),
    [anon_sym__Nonnull] = ACTIONS(2935),
    [anon_sym_mutable] = ACTIONS(2935),
    [anon_sym_constinit] = ACTIONS(2935),
    [anon_sym_consteval] = ACTIONS(2935),
    [anon_sym_alignas] = ACTIONS(2935),
    [anon_sym__Alignas] = ACTIONS(2935),
    [sym_primitive_type] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_union] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_case] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2935),
    [anon_sym_while] = ACTIONS(2935),
    [anon_sym_do] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_goto] = ACTIONS(2935),
    [anon_sym___try] = ACTIONS(2935),
    [anon_sym___leave] = ACTIONS(2935),
    [anon_sym_not] = ACTIONS(2935),
    [anon_sym_compl] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2937),
    [anon_sym_sizeof] = ACTIONS(2935),
    [anon_sym___alignof__] = ACTIONS(2935),
    [anon_sym___alignof] = ACTIONS(2935),
    [anon_sym__alignof] = ACTIONS(2935),
    [anon_sym_alignof] = ACTIONS(2935),
    [anon_sym__Alignof] = ACTIONS(2935),
    [anon_sym_offsetof] = ACTIONS(2935),
    [anon_sym__Generic] = ACTIONS(2935),
    [anon_sym_asm] = ACTIONS(2935),
    [anon_sym___asm__] = ACTIONS(2935),
    [anon_sym___asm] = ACTIONS(2935),
    [sym_number_literal] = ACTIONS(2937),
    [anon_sym_L_SQUOTE] = ACTIONS(2937),
    [anon_sym_u_SQUOTE] = ACTIONS(2937),
    [anon_sym_U_SQUOTE] = ACTIONS(2937),
    [anon_sym_u8_SQUOTE] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2937),
    [anon_sym_L_DQUOTE] = ACTIONS(2937),
    [anon_sym_u_DQUOTE] = ACTIONS(2937),
    [anon_sym_U_DQUOTE] = ACTIONS(2937),
    [anon_sym_u8_DQUOTE] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [anon_sym_NULL] = ACTIONS(2935),
    [anon_sym_nullptr] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2935),
    [anon_sym_decltype] = ACTIONS(2935),
    [anon_sym_explicit] = ACTIONS(2935),
    [anon_sym_typename] = ACTIONS(2935),
    [anon_sym_template] = ACTIONS(2935),
    [anon_sym_operator] = ACTIONS(2935),
    [anon_sym_try] = ACTIONS(2935),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_throw] = ACTIONS(2935),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_static_assert] = ACTIONS(2935),
    [anon_sym_concept] = ACTIONS(2935),
    [anon_sym_co_return] = ACTIONS(2935),
    [anon_sym_co_yield] = ACTIONS(2935),
    [anon_sym_R_DQUOTE] = ACTIONS(2937),
    [anon_sym_LR_DQUOTE] = ACTIONS(2937),
    [anon_sym_uR_DQUOTE] = ACTIONS(2937),
    [anon_sym_UR_DQUOTE] = ACTIONS(2937),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2937),
    [anon_sym_co_await] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2935),
    [anon_sym_requires] = ACTIONS(2935),
    [sym_this] = ACTIONS(2935),
  },
  [734] = {
    [sym_identifier] = ACTIONS(2939),
    [aux_sym_preproc_include_token1] = ACTIONS(2939),
    [aux_sym_preproc_def_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2939),
    [sym_preproc_directive] = ACTIONS(2939),
    [anon_sym_LPAREN2] = ACTIONS(2941),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2939),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2939),
    [anon_sym_typedef] = ACTIONS(2939),
    [anon_sym_virtual] = ACTIONS(2939),
    [anon_sym_extern] = ACTIONS(2939),
    [anon_sym___attribute__] = ACTIONS(2939),
    [anon_sym___attribute] = ACTIONS(2939),
    [anon_sym_using] = ACTIONS(2939),
    [anon_sym_COLON_COLON] = ACTIONS(2941),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2941),
    [anon_sym___declspec] = ACTIONS(2939),
    [anon_sym___based] = ACTIONS(2939),
    [anon_sym___cdecl] = ACTIONS(2939),
    [anon_sym___clrcall] = ACTIONS(2939),
    [anon_sym___stdcall] = ACTIONS(2939),
    [anon_sym___fastcall] = ACTIONS(2939),
    [anon_sym___thiscall] = ACTIONS(2939),
    [anon_sym___vectorcall] = ACTIONS(2939),
    [anon_sym_LBRACE] = ACTIONS(2941),
    [anon_sym_RBRACE] = ACTIONS(2941),
    [anon_sym_signed] = ACTIONS(2939),
    [anon_sym_unsigned] = ACTIONS(2939),
    [anon_sym_long] = ACTIONS(2939),
    [anon_sym_short] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_static] = ACTIONS(2939),
    [anon_sym_register] = ACTIONS(2939),
    [anon_sym_inline] = ACTIONS(2939),
    [anon_sym___inline] = ACTIONS(2939),
    [anon_sym___inline__] = ACTIONS(2939),
    [anon_sym___forceinline] = ACTIONS(2939),
    [anon_sym_thread_local] = ACTIONS(2939),
    [anon_sym___thread] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_constexpr] = ACTIONS(2939),
    [anon_sym_volatile] = ACTIONS(2939),
    [anon_sym_restrict] = ACTIONS(2939),
    [anon_sym___restrict__] = ACTIONS(2939),
    [anon_sym__Atomic] = ACTIONS(2939),
    [anon_sym__Noreturn] = ACTIONS(2939),
    [anon_sym_noreturn] = ACTIONS(2939),
    [anon_sym__Nonnull] = ACTIONS(2939),
    [anon_sym_mutable] = ACTIONS(2939),
    [anon_sym_constinit] = ACTIONS(2939),
    [anon_sym_consteval] = ACTIONS(2939),
    [anon_sym_alignas] = ACTIONS(2939),
    [anon_sym__Alignas] = ACTIONS(2939),
    [sym_primitive_type] = ACTIONS(2939),
    [anon_sym_enum] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2939),
    [anon_sym_struct] = ACTIONS(2939),
    [anon_sym_union] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(2939),
    [anon_sym_switch] = ACTIONS(2939),
    [anon_sym_case] = ACTIONS(2939),
    [anon_sym_default] = ACTIONS(2939),
    [anon_sym_while] = ACTIONS(2939),
    [anon_sym_do] = ACTIONS(2939),
    [anon_sym_for] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2939),
    [anon_sym_break] = ACTIONS(2939),
    [anon_sym_continue] = ACTIONS(2939),
    [anon_sym_goto] = ACTIONS(2939),
    [anon_sym___try] = ACTIONS(2939),
    [anon_sym___leave] = ACTIONS(2939),
    [anon_sym_not] = ACTIONS(2939),
    [anon_sym_compl] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2941),
    [anon_sym_PLUS_PLUS] = ACTIONS(2941),
    [anon_sym_sizeof] = ACTIONS(2939),
    [anon_sym___alignof__] = ACTIONS(2939),
    [anon_sym___alignof] = ACTIONS(2939),
    [anon_sym__alignof] = ACTIONS(2939),
    [anon_sym_alignof] = ACTIONS(2939),
    [anon_sym__Alignof] = ACTIONS(2939),
    [anon_sym_offsetof] = ACTIONS(2939),
    [anon_sym__Generic] = ACTIONS(2939),
    [anon_sym_asm] = ACTIONS(2939),
    [anon_sym___asm__] = ACTIONS(2939),
    [anon_sym___asm] = ACTIONS(2939),
    [sym_number_literal] = ACTIONS(2941),
    [anon_sym_L_SQUOTE] = ACTIONS(2941),
    [anon_sym_u_SQUOTE] = ACTIONS(2941),
    [anon_sym_U_SQUOTE] = ACTIONS(2941),
    [anon_sym_u8_SQUOTE] = ACTIONS(2941),
    [anon_sym_SQUOTE] = ACTIONS(2941),
    [anon_sym_L_DQUOTE] = ACTIONS(2941),
    [anon_sym_u_DQUOTE] = ACTIONS(2941),
    [anon_sym_U_DQUOTE] = ACTIONS(2941),
    [anon_sym_u8_DQUOTE] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_true] = ACTIONS(2939),
    [sym_false] = ACTIONS(2939),
    [anon_sym_NULL] = ACTIONS(2939),
    [anon_sym_nullptr] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2939),
    [anon_sym_decltype] = ACTIONS(2939),
    [anon_sym_explicit] = ACTIONS(2939),
    [anon_sym_typename] = ACTIONS(2939),
    [anon_sym_template] = ACTIONS(2939),
    [anon_sym_operator] = ACTIONS(2939),
    [anon_sym_try] = ACTIONS(2939),
    [anon_sym_delete] = ACTIONS(2939),
    [anon_sym_throw] = ACTIONS(2939),
    [anon_sym_namespace] = ACTIONS(2939),
    [anon_sym_static_assert] = ACTIONS(2939),
    [anon_sym_concept] = ACTIONS(2939),
    [anon_sym_co_return] = ACTIONS(2939),
    [anon_sym_co_yield] = ACTIONS(2939),
    [anon_sym_R_DQUOTE] = ACTIONS(2941),
    [anon_sym_LR_DQUOTE] = ACTIONS(2941),
    [anon_sym_uR_DQUOTE] = ACTIONS(2941),
    [anon_sym_UR_DQUOTE] = ACTIONS(2941),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2941),
    [anon_sym_co_await] = ACTIONS(2939),
    [anon_sym_new] = ACTIONS(2939),
    [anon_sym_requires] = ACTIONS(2939),
    [sym_this] = ACTIONS(2939),
  },
  [735] = {
    [sym_identifier] = ACTIONS(3089),
    [aux_sym_preproc_include_token1] = ACTIONS(3089),
    [aux_sym_preproc_def_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token2] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3089),
    [sym_preproc_directive] = ACTIONS(3089),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_STAR] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym___extension__] = ACTIONS(3089),
    [anon_sym_typedef] = ACTIONS(3089),
    [anon_sym_virtual] = ACTIONS(3089),
    [anon_sym_extern] = ACTIONS(3089),
    [anon_sym___attribute__] = ACTIONS(3089),
    [anon_sym___attribute] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_COLON_COLON] = ACTIONS(3091),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3091),
    [anon_sym___declspec] = ACTIONS(3089),
    [anon_sym___based] = ACTIONS(3089),
    [anon_sym___cdecl] = ACTIONS(3089),
    [anon_sym___clrcall] = ACTIONS(3089),
    [anon_sym___stdcall] = ACTIONS(3089),
    [anon_sym___fastcall] = ACTIONS(3089),
    [anon_sym___thiscall] = ACTIONS(3089),
    [anon_sym___vectorcall] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_signed] = ACTIONS(3089),
    [anon_sym_unsigned] = ACTIONS(3089),
    [anon_sym_long] = ACTIONS(3089),
    [anon_sym_short] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3089),
    [anon_sym_register] = ACTIONS(3089),
    [anon_sym_inline] = ACTIONS(3089),
    [anon_sym___inline] = ACTIONS(3089),
    [anon_sym___inline__] = ACTIONS(3089),
    [anon_sym___forceinline] = ACTIONS(3089),
    [anon_sym_thread_local] = ACTIONS(3089),
    [anon_sym___thread] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_constexpr] = ACTIONS(3089),
    [anon_sym_volatile] = ACTIONS(3089),
    [anon_sym_restrict] = ACTIONS(3089),
    [anon_sym___restrict__] = ACTIONS(3089),
    [anon_sym__Atomic] = ACTIONS(3089),
    [anon_sym__Noreturn] = ACTIONS(3089),
    [anon_sym_noreturn] = ACTIONS(3089),
    [anon_sym__Nonnull] = ACTIONS(3089),
    [anon_sym_mutable] = ACTIONS(3089),
    [anon_sym_constinit] = ACTIONS(3089),
    [anon_sym_consteval] = ACTIONS(3089),
    [anon_sym_alignas] = ACTIONS(3089),
    [anon_sym__Alignas] = ACTIONS(3089),
    [sym_primitive_type] = ACTIONS(3089),
    [anon_sym_enum] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_union] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_switch] = ACTIONS(3089),
    [anon_sym_case] = ACTIONS(3089),
    [anon_sym_default] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [anon_sym_do] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_break] = ACTIONS(3089),
    [anon_sym_continue] = ACTIONS(3089),
    [anon_sym_goto] = ACTIONS(3089),
    [anon_sym___try] = ACTIONS(3089),
    [anon_sym___leave] = ACTIONS(3089),
    [anon_sym_not] = ACTIONS(3089),
    [anon_sym_compl] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_sizeof] = ACTIONS(3089),
    [anon_sym___alignof__] = ACTIONS(3089),
    [anon_sym___alignof] = ACTIONS(3089),
    [anon_sym__alignof] = ACTIONS(3089),
    [anon_sym_alignof] = ACTIONS(3089),
    [anon_sym__Alignof] = ACTIONS(3089),
    [anon_sym_offsetof] = ACTIONS(3089),
    [anon_sym__Generic] = ACTIONS(3089),
    [anon_sym_asm] = ACTIONS(3089),
    [anon_sym___asm__] = ACTIONS(3089),
    [anon_sym___asm] = ACTIONS(3089),
    [sym_number_literal] = ACTIONS(3091),
    [anon_sym_L_SQUOTE] = ACTIONS(3091),
    [anon_sym_u_SQUOTE] = ACTIONS(3091),
    [anon_sym_U_SQUOTE] = ACTIONS(3091),
    [anon_sym_u8_SQUOTE] = ACTIONS(3091),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [anon_sym_L_DQUOTE] = ACTIONS(3091),
    [anon_sym_u_DQUOTE] = ACTIONS(3091),
    [anon_sym_U_DQUOTE] = ACTIONS(3091),
    [anon_sym_u8_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [sym_true] = ACTIONS(3089),
    [sym_false] = ACTIONS(3089),
    [anon_sym_NULL] = ACTIONS(3089),
    [anon_sym_nullptr] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3089),
    [anon_sym_decltype] = ACTIONS(3089),
    [anon_sym_explicit] = ACTIONS(3089),
    [anon_sym_typename] = ACTIONS(3089),
    [anon_sym_template] = ACTIONS(3089),
    [anon_sym_operator] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_delete] = ACTIONS(3089),
    [anon_sym_throw] = ACTIONS(3089),
    [anon_sym_namespace] = ACTIONS(3089),
    [anon_sym_static_assert] = ACTIONS(3089),
    [anon_sym_concept] = ACTIONS(3089),
    [anon_sym_co_return] = ACTIONS(3089),
    [anon_sym_co_yield] = ACTIONS(3089),
    [anon_sym_R_DQUOTE] = ACTIONS(3091),
    [anon_sym_LR_DQUOTE] = ACTIONS(3091),
    [anon_sym_uR_DQUOTE] = ACTIONS(3091),
    [anon_sym_UR_DQUOTE] = ACTIONS(3091),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3091),
    [anon_sym_co_await] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3089),
    [anon_sym_requires] = ACTIONS(3089),
    [sym_this] = ACTIONS(3089),
  },
  [736] = {
    [sym_identifier] = ACTIONS(3093),
    [aux_sym_preproc_include_token1] = ACTIONS(3093),
    [aux_sym_preproc_def_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token2] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3093),
    [sym_preproc_directive] = ACTIONS(3093),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym___extension__] = ACTIONS(3093),
    [anon_sym_typedef] = ACTIONS(3093),
    [anon_sym_virtual] = ACTIONS(3093),
    [anon_sym_extern] = ACTIONS(3093),
    [anon_sym___attribute__] = ACTIONS(3093),
    [anon_sym___attribute] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_COLON_COLON] = ACTIONS(3095),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3095),
    [anon_sym___declspec] = ACTIONS(3093),
    [anon_sym___based] = ACTIONS(3093),
    [anon_sym___cdecl] = ACTIONS(3093),
    [anon_sym___clrcall] = ACTIONS(3093),
    [anon_sym___stdcall] = ACTIONS(3093),
    [anon_sym___fastcall] = ACTIONS(3093),
    [anon_sym___thiscall] = ACTIONS(3093),
    [anon_sym___vectorcall] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_signed] = ACTIONS(3093),
    [anon_sym_unsigned] = ACTIONS(3093),
    [anon_sym_long] = ACTIONS(3093),
    [anon_sym_short] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3093),
    [anon_sym_register] = ACTIONS(3093),
    [anon_sym_inline] = ACTIONS(3093),
    [anon_sym___inline] = ACTIONS(3093),
    [anon_sym___inline__] = ACTIONS(3093),
    [anon_sym___forceinline] = ACTIONS(3093),
    [anon_sym_thread_local] = ACTIONS(3093),
    [anon_sym___thread] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_constexpr] = ACTIONS(3093),
    [anon_sym_volatile] = ACTIONS(3093),
    [anon_sym_restrict] = ACTIONS(3093),
    [anon_sym___restrict__] = ACTIONS(3093),
    [anon_sym__Atomic] = ACTIONS(3093),
    [anon_sym__Noreturn] = ACTIONS(3093),
    [anon_sym_noreturn] = ACTIONS(3093),
    [anon_sym__Nonnull] = ACTIONS(3093),
    [anon_sym_mutable] = ACTIONS(3093),
    [anon_sym_constinit] = ACTIONS(3093),
    [anon_sym_consteval] = ACTIONS(3093),
    [anon_sym_alignas] = ACTIONS(3093),
    [anon_sym__Alignas] = ACTIONS(3093),
    [sym_primitive_type] = ACTIONS(3093),
    [anon_sym_enum] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_union] = ACTIONS(3093),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_switch] = ACTIONS(3093),
    [anon_sym_case] = ACTIONS(3093),
    [anon_sym_default] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [anon_sym_do] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_break] = ACTIONS(3093),
    [anon_sym_continue] = ACTIONS(3093),
    [anon_sym_goto] = ACTIONS(3093),
    [anon_sym___try] = ACTIONS(3093),
    [anon_sym___leave] = ACTIONS(3093),
    [anon_sym_not] = ACTIONS(3093),
    [anon_sym_compl] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3095),
    [anon_sym_sizeof] = ACTIONS(3093),
    [anon_sym___alignof__] = ACTIONS(3093),
    [anon_sym___alignof] = ACTIONS(3093),
    [anon_sym__alignof] = ACTIONS(3093),
    [anon_sym_alignof] = ACTIONS(3093),
    [anon_sym__Alignof] = ACTIONS(3093),
    [anon_sym_offsetof] = ACTIONS(3093),
    [anon_sym__Generic] = ACTIONS(3093),
    [anon_sym_asm] = ACTIONS(3093),
    [anon_sym___asm__] = ACTIONS(3093),
    [anon_sym___asm] = ACTIONS(3093),
    [sym_number_literal] = ACTIONS(3095),
    [anon_sym_L_SQUOTE] = ACTIONS(3095),
    [anon_sym_u_SQUOTE] = ACTIONS(3095),
    [anon_sym_U_SQUOTE] = ACTIONS(3095),
    [anon_sym_u8_SQUOTE] = ACTIONS(3095),
    [anon_sym_SQUOTE] = ACTIONS(3095),
    [anon_sym_L_DQUOTE] = ACTIONS(3095),
    [anon_sym_u_DQUOTE] = ACTIONS(3095),
    [anon_sym_U_DQUOTE] = ACTIONS(3095),
    [anon_sym_u8_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [sym_true] = ACTIONS(3093),
    [sym_false] = ACTIONS(3093),
    [anon_sym_NULL] = ACTIONS(3093),
    [anon_sym_nullptr] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3093),
    [anon_sym_decltype] = ACTIONS(3093),
    [anon_sym_explicit] = ACTIONS(3093),
    [anon_sym_typename] = ACTIONS(3093),
    [anon_sym_template] = ACTIONS(3093),
    [anon_sym_operator] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_delete] = ACTIONS(3093),
    [anon_sym_throw] = ACTIONS(3093),
    [anon_sym_namespace] = ACTIONS(3093),
    [anon_sym_static_assert] = ACTIONS(3093),
    [anon_sym_concept] = ACTIONS(3093),
    [anon_sym_co_return] = ACTIONS(3093),
    [anon_sym_co_yield] = ACTIONS(3093),
    [anon_sym_R_DQUOTE] = ACTIONS(3095),
    [anon_sym_LR_DQUOTE] = ACTIONS(3095),
    [anon_sym_uR_DQUOTE] = ACTIONS(3095),
    [anon_sym_UR_DQUOTE] = ACTIONS(3095),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3095),
    [anon_sym_co_await] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3093),
    [anon_sym_requires] = ACTIONS(3093),
    [sym_this] = ACTIONS(3093),
  },
  [737] = {
    [sym_identifier] = ACTIONS(2943),
    [aux_sym_preproc_include_token1] = ACTIONS(2943),
    [aux_sym_preproc_def_token1] = ACTIONS(2943),
    [aux_sym_preproc_if_token1] = ACTIONS(2943),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2943),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2943),
    [sym_preproc_directive] = ACTIONS(2943),
    [anon_sym_LPAREN2] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_TILDE] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2943),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym___extension__] = ACTIONS(2943),
    [anon_sym_typedef] = ACTIONS(2943),
    [anon_sym_virtual] = ACTIONS(2943),
    [anon_sym_extern] = ACTIONS(2943),
    [anon_sym___attribute__] = ACTIONS(2943),
    [anon_sym___attribute] = ACTIONS(2943),
    [anon_sym_using] = ACTIONS(2943),
    [anon_sym_COLON_COLON] = ACTIONS(2945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2945),
    [anon_sym___declspec] = ACTIONS(2943),
    [anon_sym___based] = ACTIONS(2943),
    [anon_sym___cdecl] = ACTIONS(2943),
    [anon_sym___clrcall] = ACTIONS(2943),
    [anon_sym___stdcall] = ACTIONS(2943),
    [anon_sym___fastcall] = ACTIONS(2943),
    [anon_sym___thiscall] = ACTIONS(2943),
    [anon_sym___vectorcall] = ACTIONS(2943),
    [anon_sym_LBRACE] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_signed] = ACTIONS(2943),
    [anon_sym_unsigned] = ACTIONS(2943),
    [anon_sym_long] = ACTIONS(2943),
    [anon_sym_short] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_static] = ACTIONS(2943),
    [anon_sym_register] = ACTIONS(2943),
    [anon_sym_inline] = ACTIONS(2943),
    [anon_sym___inline] = ACTIONS(2943),
    [anon_sym___inline__] = ACTIONS(2943),
    [anon_sym___forceinline] = ACTIONS(2943),
    [anon_sym_thread_local] = ACTIONS(2943),
    [anon_sym___thread] = ACTIONS(2943),
    [anon_sym_const] = ACTIONS(2943),
    [anon_sym_constexpr] = ACTIONS(2943),
    [anon_sym_volatile] = ACTIONS(2943),
    [anon_sym_restrict] = ACTIONS(2943),
    [anon_sym___restrict__] = ACTIONS(2943),
    [anon_sym__Atomic] = ACTIONS(2943),
    [anon_sym__Noreturn] = ACTIONS(2943),
    [anon_sym_noreturn] = ACTIONS(2943),
    [anon_sym__Nonnull] = ACTIONS(2943),
    [anon_sym_mutable] = ACTIONS(2943),
    [anon_sym_constinit] = ACTIONS(2943),
    [anon_sym_consteval] = ACTIONS(2943),
    [anon_sym_alignas] = ACTIONS(2943),
    [anon_sym__Alignas] = ACTIONS(2943),
    [sym_primitive_type] = ACTIONS(2943),
    [anon_sym_enum] = ACTIONS(2943),
    [anon_sym_class] = ACTIONS(2943),
    [anon_sym_struct] = ACTIONS(2943),
    [anon_sym_union] = ACTIONS(2943),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_switch] = ACTIONS(2943),
    [anon_sym_case] = ACTIONS(2943),
    [anon_sym_default] = ACTIONS(2943),
    [anon_sym_while] = ACTIONS(2943),
    [anon_sym_do] = ACTIONS(2943),
    [anon_sym_for] = ACTIONS(2943),
    [anon_sym_return] = ACTIONS(2943),
    [anon_sym_break] = ACTIONS(2943),
    [anon_sym_continue] = ACTIONS(2943),
    [anon_sym_goto] = ACTIONS(2943),
    [anon_sym___try] = ACTIONS(2943),
    [anon_sym___leave] = ACTIONS(2943),
    [anon_sym_not] = ACTIONS(2943),
    [anon_sym_compl] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_sizeof] = ACTIONS(2943),
    [anon_sym___alignof__] = ACTIONS(2943),
    [anon_sym___alignof] = ACTIONS(2943),
    [anon_sym__alignof] = ACTIONS(2943),
    [anon_sym_alignof] = ACTIONS(2943),
    [anon_sym__Alignof] = ACTIONS(2943),
    [anon_sym_offsetof] = ACTIONS(2943),
    [anon_sym__Generic] = ACTIONS(2943),
    [anon_sym_asm] = ACTIONS(2943),
    [anon_sym___asm__] = ACTIONS(2943),
    [anon_sym___asm] = ACTIONS(2943),
    [sym_number_literal] = ACTIONS(2945),
    [anon_sym_L_SQUOTE] = ACTIONS(2945),
    [anon_sym_u_SQUOTE] = ACTIONS(2945),
    [anon_sym_U_SQUOTE] = ACTIONS(2945),
    [anon_sym_u8_SQUOTE] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_L_DQUOTE] = ACTIONS(2945),
    [anon_sym_u_DQUOTE] = ACTIONS(2945),
    [anon_sym_U_DQUOTE] = ACTIONS(2945),
    [anon_sym_u8_DQUOTE] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_true] = ACTIONS(2943),
    [sym_false] = ACTIONS(2943),
    [anon_sym_NULL] = ACTIONS(2943),
    [anon_sym_nullptr] = ACTIONS(2943),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2943),
    [anon_sym_decltype] = ACTIONS(2943),
    [anon_sym_explicit] = ACTIONS(2943),
    [anon_sym_typename] = ACTIONS(2943),
    [anon_sym_template] = ACTIONS(2943),
    [anon_sym_operator] = ACTIONS(2943),
    [anon_sym_try] = ACTIONS(2943),
    [anon_sym_delete] = ACTIONS(2943),
    [anon_sym_throw] = ACTIONS(2943),
    [anon_sym_namespace] = ACTIONS(2943),
    [anon_sym_static_assert] = ACTIONS(2943),
    [anon_sym_concept] = ACTIONS(2943),
    [anon_sym_co_return] = ACTIONS(2943),
    [anon_sym_co_yield] = ACTIONS(2943),
    [anon_sym_R_DQUOTE] = ACTIONS(2945),
    [anon_sym_LR_DQUOTE] = ACTIONS(2945),
    [anon_sym_uR_DQUOTE] = ACTIONS(2945),
    [anon_sym_UR_DQUOTE] = ACTIONS(2945),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2945),
    [anon_sym_co_await] = ACTIONS(2943),
    [anon_sym_new] = ACTIONS(2943),
    [anon_sym_requires] = ACTIONS(2943),
    [sym_this] = ACTIONS(2943),
  },
  [738] = {
    [sym_identifier] = ACTIONS(3319),
    [aux_sym_preproc_include_token1] = ACTIONS(3319),
    [aux_sym_preproc_def_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token2] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3319),
    [sym_preproc_directive] = ACTIONS(3319),
    [anon_sym_LPAREN2] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym___extension__] = ACTIONS(3319),
    [anon_sym_typedef] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym___attribute__] = ACTIONS(3319),
    [anon_sym___attribute] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_COLON_COLON] = ACTIONS(3321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3321),
    [anon_sym___declspec] = ACTIONS(3319),
    [anon_sym___based] = ACTIONS(3319),
    [anon_sym___cdecl] = ACTIONS(3319),
    [anon_sym___clrcall] = ACTIONS(3319),
    [anon_sym___stdcall] = ACTIONS(3319),
    [anon_sym___fastcall] = ACTIONS(3319),
    [anon_sym___thiscall] = ACTIONS(3319),
    [anon_sym___vectorcall] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_signed] = ACTIONS(3319),
    [anon_sym_unsigned] = ACTIONS(3319),
    [anon_sym_long] = ACTIONS(3319),
    [anon_sym_short] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_register] = ACTIONS(3319),
    [anon_sym_inline] = ACTIONS(3319),
    [anon_sym___inline] = ACTIONS(3319),
    [anon_sym___inline__] = ACTIONS(3319),
    [anon_sym___forceinline] = ACTIONS(3319),
    [anon_sym_thread_local] = ACTIONS(3319),
    [anon_sym___thread] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_constexpr] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_restrict] = ACTIONS(3319),
    [anon_sym___restrict__] = ACTIONS(3319),
    [anon_sym__Atomic] = ACTIONS(3319),
    [anon_sym__Noreturn] = ACTIONS(3319),
    [anon_sym_noreturn] = ACTIONS(3319),
    [anon_sym__Nonnull] = ACTIONS(3319),
    [anon_sym_mutable] = ACTIONS(3319),
    [anon_sym_constinit] = ACTIONS(3319),
    [anon_sym_consteval] = ACTIONS(3319),
    [anon_sym_alignas] = ACTIONS(3319),
    [anon_sym__Alignas] = ACTIONS(3319),
    [sym_primitive_type] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_union] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_case] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_goto] = ACTIONS(3319),
    [anon_sym___try] = ACTIONS(3319),
    [anon_sym___leave] = ACTIONS(3319),
    [anon_sym_not] = ACTIONS(3319),
    [anon_sym_compl] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_sizeof] = ACTIONS(3319),
    [anon_sym___alignof__] = ACTIONS(3319),
    [anon_sym___alignof] = ACTIONS(3319),
    [anon_sym__alignof] = ACTIONS(3319),
    [anon_sym_alignof] = ACTIONS(3319),
    [anon_sym__Alignof] = ACTIONS(3319),
    [anon_sym_offsetof] = ACTIONS(3319),
    [anon_sym__Generic] = ACTIONS(3319),
    [anon_sym_asm] = ACTIONS(3319),
    [anon_sym___asm__] = ACTIONS(3319),
    [anon_sym___asm] = ACTIONS(3319),
    [sym_number_literal] = ACTIONS(3321),
    [anon_sym_L_SQUOTE] = ACTIONS(3321),
    [anon_sym_u_SQUOTE] = ACTIONS(3321),
    [anon_sym_U_SQUOTE] = ACTIONS(3321),
    [anon_sym_u8_SQUOTE] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [anon_sym_L_DQUOTE] = ACTIONS(3321),
    [anon_sym_u_DQUOTE] = ACTIONS(3321),
    [anon_sym_U_DQUOTE] = ACTIONS(3321),
    [anon_sym_u8_DQUOTE] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [sym_true] = ACTIONS(3319),
    [sym_false] = ACTIONS(3319),
    [anon_sym_NULL] = ACTIONS(3319),
    [anon_sym_nullptr] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3319),
    [anon_sym_decltype] = ACTIONS(3319),
    [anon_sym_explicit] = ACTIONS(3319),
    [anon_sym_typename] = ACTIONS(3319),
    [anon_sym_template] = ACTIONS(3319),
    [anon_sym_operator] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_delete] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_static_assert] = ACTIONS(3319),
    [anon_sym_concept] = ACTIONS(3319),
    [anon_sym_co_return] = ACTIONS(3319),
    [anon_sym_co_yield] = ACTIONS(3319),
    [anon_sym_R_DQUOTE] = ACTIONS(3321),
    [anon_sym_LR_DQUOTE] = ACTIONS(3321),
    [anon_sym_uR_DQUOTE] = ACTIONS(3321),
    [anon_sym_UR_DQUOTE] = ACTIONS(3321),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3321),
    [anon_sym_co_await] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3319),
    [sym_this] = ACTIONS(3319),
  },
  [739] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_include_token1] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token2] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym___cdecl] = ACTIONS(3104),
    [anon_sym___clrcall] = ACTIONS(3104),
    [anon_sym___stdcall] = ACTIONS(3104),
    [anon_sym___fastcall] = ACTIONS(3104),
    [anon_sym___thiscall] = ACTIONS(3104),
    [anon_sym___vectorcall] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym___try] = ACTIONS(3104),
    [anon_sym___leave] = ACTIONS(3104),
    [anon_sym_not] = ACTIONS(3104),
    [anon_sym_compl] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3106),
    [anon_sym_PLUS_PLUS] = ACTIONS(3106),
    [anon_sym_sizeof] = ACTIONS(3104),
    [anon_sym___alignof__] = ACTIONS(3104),
    [anon_sym___alignof] = ACTIONS(3104),
    [anon_sym__alignof] = ACTIONS(3104),
    [anon_sym_alignof] = ACTIONS(3104),
    [anon_sym__Alignof] = ACTIONS(3104),
    [anon_sym_offsetof] = ACTIONS(3104),
    [anon_sym__Generic] = ACTIONS(3104),
    [anon_sym_asm] = ACTIONS(3104),
    [anon_sym___asm__] = ACTIONS(3104),
    [anon_sym___asm] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3106),
    [anon_sym_L_SQUOTE] = ACTIONS(3106),
    [anon_sym_u_SQUOTE] = ACTIONS(3106),
    [anon_sym_U_SQUOTE] = ACTIONS(3106),
    [anon_sym_u8_SQUOTE] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3106),
    [anon_sym_L_DQUOTE] = ACTIONS(3106),
    [anon_sym_u_DQUOTE] = ACTIONS(3106),
    [anon_sym_U_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8_DQUOTE] = ACTIONS(3106),
    [anon_sym_DQUOTE] = ACTIONS(3106),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [anon_sym_NULL] = ACTIONS(3104),
    [anon_sym_nullptr] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_try] = ACTIONS(3104),
    [anon_sym_delete] = ACTIONS(3104),
    [anon_sym_throw] = ACTIONS(3104),
    [anon_sym_namespace] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
    [anon_sym_concept] = ACTIONS(3104),
    [anon_sym_co_return] = ACTIONS(3104),
    [anon_sym_co_yield] = ACTIONS(3104),
    [anon_sym_R_DQUOTE] = ACTIONS(3106),
    [anon_sym_LR_DQUOTE] = ACTIONS(3106),
    [anon_sym_uR_DQUOTE] = ACTIONS(3106),
    [anon_sym_UR_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3106),
    [anon_sym_co_await] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_requires] = ACTIONS(3104),
    [sym_this] = ACTIONS(3104),
  },
  [740] = {
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_include_token1] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token2] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_BANG] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym___attribute] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym___cdecl] = ACTIONS(3108),
    [anon_sym___clrcall] = ACTIONS(3108),
    [anon_sym___stdcall] = ACTIONS(3108),
    [anon_sym___fastcall] = ACTIONS(3108),
    [anon_sym___thiscall] = ACTIONS(3108),
    [anon_sym___vectorcall] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym__Nonnull] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym__Alignas] = ACTIONS(3108),
    [sym_primitive_type] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [anon_sym_if] = ACTIONS(3108),
    [anon_sym_switch] = ACTIONS(3108),
    [anon_sym_case] = ACTIONS(3108),
    [anon_sym_default] = ACTIONS(3108),
    [anon_sym_while] = ACTIONS(3108),
    [anon_sym_do] = ACTIONS(3108),
    [anon_sym_for] = ACTIONS(3108),
    [anon_sym_return] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3108),
    [anon_sym_continue] = ACTIONS(3108),
    [anon_sym_goto] = ACTIONS(3108),
    [anon_sym___try] = ACTIONS(3108),
    [anon_sym___leave] = ACTIONS(3108),
    [anon_sym_not] = ACTIONS(3108),
    [anon_sym_compl] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_sizeof] = ACTIONS(3108),
    [anon_sym___alignof__] = ACTIONS(3108),
    [anon_sym___alignof] = ACTIONS(3108),
    [anon_sym__alignof] = ACTIONS(3108),
    [anon_sym_alignof] = ACTIONS(3108),
    [anon_sym__Alignof] = ACTIONS(3108),
    [anon_sym_offsetof] = ACTIONS(3108),
    [anon_sym__Generic] = ACTIONS(3108),
    [anon_sym_asm] = ACTIONS(3108),
    [anon_sym___asm__] = ACTIONS(3108),
    [anon_sym___asm] = ACTIONS(3108),
    [sym_number_literal] = ACTIONS(3110),
    [anon_sym_L_SQUOTE] = ACTIONS(3110),
    [anon_sym_u_SQUOTE] = ACTIONS(3110),
    [anon_sym_U_SQUOTE] = ACTIONS(3110),
    [anon_sym_u8_SQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [anon_sym_L_DQUOTE] = ACTIONS(3110),
    [anon_sym_u_DQUOTE] = ACTIONS(3110),
    [anon_sym_U_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8_DQUOTE] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [anon_sym_NULL] = ACTIONS(3108),
    [anon_sym_nullptr] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_try] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(3108),
    [anon_sym_throw] = ACTIONS(3108),
    [anon_sym_namespace] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
    [anon_sym_concept] = ACTIONS(3108),
    [anon_sym_co_return] = ACTIONS(3108),
    [anon_sym_co_yield] = ACTIONS(3108),
    [anon_sym_R_DQUOTE] = ACTIONS(3110),
    [anon_sym_LR_DQUOTE] = ACTIONS(3110),
    [anon_sym_uR_DQUOTE] = ACTIONS(3110),
    [anon_sym_UR_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3110),
    [anon_sym_co_await] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_requires] = ACTIONS(3108),
    [sym_this] = ACTIONS(3108),
  },
  [741] = {
    [sym_identifier] = ACTIONS(3112),
    [aux_sym_preproc_include_token1] = ACTIONS(3112),
    [aux_sym_preproc_def_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token2] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3112),
    [sym_preproc_directive] = ACTIONS(3112),
    [anon_sym_LPAREN2] = ACTIONS(3114),
    [anon_sym_BANG] = ACTIONS(3114),
    [anon_sym_TILDE] = ACTIONS(3114),
    [anon_sym_DASH] = ACTIONS(3112),
    [anon_sym_PLUS] = ACTIONS(3112),
    [anon_sym_STAR] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3112),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym___extension__] = ACTIONS(3112),
    [anon_sym_typedef] = ACTIONS(3112),
    [anon_sym_virtual] = ACTIONS(3112),
    [anon_sym_extern] = ACTIONS(3112),
    [anon_sym___attribute__] = ACTIONS(3112),
    [anon_sym___attribute] = ACTIONS(3112),
    [anon_sym_using] = ACTIONS(3112),
    [anon_sym_COLON_COLON] = ACTIONS(3114),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3114),
    [anon_sym___declspec] = ACTIONS(3112),
    [anon_sym___based] = ACTIONS(3112),
    [anon_sym___cdecl] = ACTIONS(3112),
    [anon_sym___clrcall] = ACTIONS(3112),
    [anon_sym___stdcall] = ACTIONS(3112),
    [anon_sym___fastcall] = ACTIONS(3112),
    [anon_sym___thiscall] = ACTIONS(3112),
    [anon_sym___vectorcall] = ACTIONS(3112),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_signed] = ACTIONS(3112),
    [anon_sym_unsigned] = ACTIONS(3112),
    [anon_sym_long] = ACTIONS(3112),
    [anon_sym_short] = ACTIONS(3112),
    [anon_sym_LBRACK] = ACTIONS(3112),
    [anon_sym_static] = ACTIONS(3112),
    [anon_sym_register] = ACTIONS(3112),
    [anon_sym_inline] = ACTIONS(3112),
    [anon_sym___inline] = ACTIONS(3112),
    [anon_sym___inline__] = ACTIONS(3112),
    [anon_sym___forceinline] = ACTIONS(3112),
    [anon_sym_thread_local] = ACTIONS(3112),
    [anon_sym___thread] = ACTIONS(3112),
    [anon_sym_const] = ACTIONS(3112),
    [anon_sym_constexpr] = ACTIONS(3112),
    [anon_sym_volatile] = ACTIONS(3112),
    [anon_sym_restrict] = ACTIONS(3112),
    [anon_sym___restrict__] = ACTIONS(3112),
    [anon_sym__Atomic] = ACTIONS(3112),
    [anon_sym__Noreturn] = ACTIONS(3112),
    [anon_sym_noreturn] = ACTIONS(3112),
    [anon_sym__Nonnull] = ACTIONS(3112),
    [anon_sym_mutable] = ACTIONS(3112),
    [anon_sym_constinit] = ACTIONS(3112),
    [anon_sym_consteval] = ACTIONS(3112),
    [anon_sym_alignas] = ACTIONS(3112),
    [anon_sym__Alignas] = ACTIONS(3112),
    [sym_primitive_type] = ACTIONS(3112),
    [anon_sym_enum] = ACTIONS(3112),
    [anon_sym_class] = ACTIONS(3112),
    [anon_sym_struct] = ACTIONS(3112),
    [anon_sym_union] = ACTIONS(3112),
    [anon_sym_if] = ACTIONS(3112),
    [anon_sym_switch] = ACTIONS(3112),
    [anon_sym_case] = ACTIONS(3112),
    [anon_sym_default] = ACTIONS(3112),
    [anon_sym_while] = ACTIONS(3112),
    [anon_sym_do] = ACTIONS(3112),
    [anon_sym_for] = ACTIONS(3112),
    [anon_sym_return] = ACTIONS(3112),
    [anon_sym_break] = ACTIONS(3112),
    [anon_sym_continue] = ACTIONS(3112),
    [anon_sym_goto] = ACTIONS(3112),
    [anon_sym___try] = ACTIONS(3112),
    [anon_sym___leave] = ACTIONS(3112),
    [anon_sym_not] = ACTIONS(3112),
    [anon_sym_compl] = ACTIONS(3112),
    [anon_sym_DASH_DASH] = ACTIONS(3114),
    [anon_sym_PLUS_PLUS] = ACTIONS(3114),
    [anon_sym_sizeof] = ACTIONS(3112),
    [anon_sym___alignof__] = ACTIONS(3112),
    [anon_sym___alignof] = ACTIONS(3112),
    [anon_sym__alignof] = ACTIONS(3112),
    [anon_sym_alignof] = ACTIONS(3112),
    [anon_sym__Alignof] = ACTIONS(3112),
    [anon_sym_offsetof] = ACTIONS(3112),
    [anon_sym__Generic] = ACTIONS(3112),
    [anon_sym_asm] = ACTIONS(3112),
    [anon_sym___asm__] = ACTIONS(3112),
    [anon_sym___asm] = ACTIONS(3112),
    [sym_number_literal] = ACTIONS(3114),
    [anon_sym_L_SQUOTE] = ACTIONS(3114),
    [anon_sym_u_SQUOTE] = ACTIONS(3114),
    [anon_sym_U_SQUOTE] = ACTIONS(3114),
    [anon_sym_u8_SQUOTE] = ACTIONS(3114),
    [anon_sym_SQUOTE] = ACTIONS(3114),
    [anon_sym_L_DQUOTE] = ACTIONS(3114),
    [anon_sym_u_DQUOTE] = ACTIONS(3114),
    [anon_sym_U_DQUOTE] = ACTIONS(3114),
    [anon_sym_u8_DQUOTE] = ACTIONS(3114),
    [anon_sym_DQUOTE] = ACTIONS(3114),
    [sym_true] = ACTIONS(3112),
    [sym_false] = ACTIONS(3112),
    [anon_sym_NULL] = ACTIONS(3112),
    [anon_sym_nullptr] = ACTIONS(3112),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3112),
    [anon_sym_decltype] = ACTIONS(3112),
    [anon_sym_explicit] = ACTIONS(3112),
    [anon_sym_typename] = ACTIONS(3112),
    [anon_sym_template] = ACTIONS(3112),
    [anon_sym_operator] = ACTIONS(3112),
    [anon_sym_try] = ACTIONS(3112),
    [anon_sym_delete] = ACTIONS(3112),
    [anon_sym_throw] = ACTIONS(3112),
    [anon_sym_namespace] = ACTIONS(3112),
    [anon_sym_static_assert] = ACTIONS(3112),
    [anon_sym_concept] = ACTIONS(3112),
    [anon_sym_co_return] = ACTIONS(3112),
    [anon_sym_co_yield] = ACTIONS(3112),
    [anon_sym_R_DQUOTE] = ACTIONS(3114),
    [anon_sym_LR_DQUOTE] = ACTIONS(3114),
    [anon_sym_uR_DQUOTE] = ACTIONS(3114),
    [anon_sym_UR_DQUOTE] = ACTIONS(3114),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3114),
    [anon_sym_co_await] = ACTIONS(3112),
    [anon_sym_new] = ACTIONS(3112),
    [anon_sym_requires] = ACTIONS(3112),
    [sym_this] = ACTIONS(3112),
  },
  [742] = {
    [sym_identifier] = ACTIONS(2947),
    [aux_sym_preproc_include_token1] = ACTIONS(2947),
    [aux_sym_preproc_def_token1] = ACTIONS(2947),
    [aux_sym_preproc_if_token1] = ACTIONS(2947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2947),
    [sym_preproc_directive] = ACTIONS(2947),
    [anon_sym_LPAREN2] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym___extension__] = ACTIONS(2947),
    [anon_sym_typedef] = ACTIONS(2947),
    [anon_sym_virtual] = ACTIONS(2947),
    [anon_sym_extern] = ACTIONS(2947),
    [anon_sym___attribute__] = ACTIONS(2947),
    [anon_sym___attribute] = ACTIONS(2947),
    [anon_sym_using] = ACTIONS(2947),
    [anon_sym_COLON_COLON] = ACTIONS(2949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2949),
    [anon_sym___declspec] = ACTIONS(2947),
    [anon_sym___based] = ACTIONS(2947),
    [anon_sym___cdecl] = ACTIONS(2947),
    [anon_sym___clrcall] = ACTIONS(2947),
    [anon_sym___stdcall] = ACTIONS(2947),
    [anon_sym___fastcall] = ACTIONS(2947),
    [anon_sym___thiscall] = ACTIONS(2947),
    [anon_sym___vectorcall] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2949),
    [anon_sym_signed] = ACTIONS(2947),
    [anon_sym_unsigned] = ACTIONS(2947),
    [anon_sym_long] = ACTIONS(2947),
    [anon_sym_short] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_static] = ACTIONS(2947),
    [anon_sym_register] = ACTIONS(2947),
    [anon_sym_inline] = ACTIONS(2947),
    [anon_sym___inline] = ACTIONS(2947),
    [anon_sym___inline__] = ACTIONS(2947),
    [anon_sym___forceinline] = ACTIONS(2947),
    [anon_sym_thread_local] = ACTIONS(2947),
    [anon_sym___thread] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_constexpr] = ACTIONS(2947),
    [anon_sym_volatile] = ACTIONS(2947),
    [anon_sym_restrict] = ACTIONS(2947),
    [anon_sym___restrict__] = ACTIONS(2947),
    [anon_sym__Atomic] = ACTIONS(2947),
    [anon_sym__Noreturn] = ACTIONS(2947),
    [anon_sym_noreturn] = ACTIONS(2947),
    [anon_sym__Nonnull] = ACTIONS(2947),
    [anon_sym_mutable] = ACTIONS(2947),
    [anon_sym_constinit] = ACTIONS(2947),
    [anon_sym_consteval] = ACTIONS(2947),
    [anon_sym_alignas] = ACTIONS(2947),
    [anon_sym__Alignas] = ACTIONS(2947),
    [sym_primitive_type] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2947),
    [anon_sym_class] = ACTIONS(2947),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_switch] = ACTIONS(2947),
    [anon_sym_case] = ACTIONS(2947),
    [anon_sym_default] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_goto] = ACTIONS(2947),
    [anon_sym___try] = ACTIONS(2947),
    [anon_sym___leave] = ACTIONS(2947),
    [anon_sym_not] = ACTIONS(2947),
    [anon_sym_compl] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2949),
    [anon_sym_PLUS_PLUS] = ACTIONS(2949),
    [anon_sym_sizeof] = ACTIONS(2947),
    [anon_sym___alignof__] = ACTIONS(2947),
    [anon_sym___alignof] = ACTIONS(2947),
    [anon_sym__alignof] = ACTIONS(2947),
    [anon_sym_alignof] = ACTIONS(2947),
    [anon_sym__Alignof] = ACTIONS(2947),
    [anon_sym_offsetof] = ACTIONS(2947),
    [anon_sym__Generic] = ACTIONS(2947),
    [anon_sym_asm] = ACTIONS(2947),
    [anon_sym___asm__] = ACTIONS(2947),
    [anon_sym___asm] = ACTIONS(2947),
    [sym_number_literal] = ACTIONS(2949),
    [anon_sym_L_SQUOTE] = ACTIONS(2949),
    [anon_sym_u_SQUOTE] = ACTIONS(2949),
    [anon_sym_U_SQUOTE] = ACTIONS(2949),
    [anon_sym_u8_SQUOTE] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_L_DQUOTE] = ACTIONS(2949),
    [anon_sym_u_DQUOTE] = ACTIONS(2949),
    [anon_sym_U_DQUOTE] = ACTIONS(2949),
    [anon_sym_u8_DQUOTE] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [anon_sym_NULL] = ACTIONS(2947),
    [anon_sym_nullptr] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2947),
    [anon_sym_decltype] = ACTIONS(2947),
    [anon_sym_explicit] = ACTIONS(2947),
    [anon_sym_typename] = ACTIONS(2947),
    [anon_sym_template] = ACTIONS(2947),
    [anon_sym_operator] = ACTIONS(2947),
    [anon_sym_try] = ACTIONS(2947),
    [anon_sym_delete] = ACTIONS(2947),
    [anon_sym_throw] = ACTIONS(2947),
    [anon_sym_namespace] = ACTIONS(2947),
    [anon_sym_static_assert] = ACTIONS(2947),
    [anon_sym_concept] = ACTIONS(2947),
    [anon_sym_co_return] = ACTIONS(2947),
    [anon_sym_co_yield] = ACTIONS(2947),
    [anon_sym_R_DQUOTE] = ACTIONS(2949),
    [anon_sym_LR_DQUOTE] = ACTIONS(2949),
    [anon_sym_uR_DQUOTE] = ACTIONS(2949),
    [anon_sym_UR_DQUOTE] = ACTIONS(2949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2949),
    [anon_sym_co_await] = ACTIONS(2947),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_requires] = ACTIONS(2947),
    [sym_this] = ACTIONS(2947),
  },
  [743] = {
    [sym_identifier] = ACTIONS(2951),
    [aux_sym_preproc_include_token1] = ACTIONS(2951),
    [aux_sym_preproc_def_token1] = ACTIONS(2951),
    [aux_sym_preproc_if_token1] = ACTIONS(2951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2951),
    [sym_preproc_directive] = ACTIONS(2951),
    [anon_sym_LPAREN2] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_TILDE] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_AMP_AMP] = ACTIONS(2953),
    [anon_sym_AMP] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2953),
    [anon_sym___extension__] = ACTIONS(2951),
    [anon_sym_typedef] = ACTIONS(2951),
    [anon_sym_virtual] = ACTIONS(2951),
    [anon_sym_extern] = ACTIONS(2951),
    [anon_sym___attribute__] = ACTIONS(2951),
    [anon_sym___attribute] = ACTIONS(2951),
    [anon_sym_using] = ACTIONS(2951),
    [anon_sym_COLON_COLON] = ACTIONS(2953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2953),
    [anon_sym___declspec] = ACTIONS(2951),
    [anon_sym___based] = ACTIONS(2951),
    [anon_sym___cdecl] = ACTIONS(2951),
    [anon_sym___clrcall] = ACTIONS(2951),
    [anon_sym___stdcall] = ACTIONS(2951),
    [anon_sym___fastcall] = ACTIONS(2951),
    [anon_sym___thiscall] = ACTIONS(2951),
    [anon_sym___vectorcall] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2953),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [anon_sym_signed] = ACTIONS(2951),
    [anon_sym_unsigned] = ACTIONS(2951),
    [anon_sym_long] = ACTIONS(2951),
    [anon_sym_short] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_static] = ACTIONS(2951),
    [anon_sym_register] = ACTIONS(2951),
    [anon_sym_inline] = ACTIONS(2951),
    [anon_sym___inline] = ACTIONS(2951),
    [anon_sym___inline__] = ACTIONS(2951),
    [anon_sym___forceinline] = ACTIONS(2951),
    [anon_sym_thread_local] = ACTIONS(2951),
    [anon_sym___thread] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_constexpr] = ACTIONS(2951),
    [anon_sym_volatile] = ACTIONS(2951),
    [anon_sym_restrict] = ACTIONS(2951),
    [anon_sym___restrict__] = ACTIONS(2951),
    [anon_sym__Atomic] = ACTIONS(2951),
    [anon_sym__Noreturn] = ACTIONS(2951),
    [anon_sym_noreturn] = ACTIONS(2951),
    [anon_sym__Nonnull] = ACTIONS(2951),
    [anon_sym_mutable] = ACTIONS(2951),
    [anon_sym_constinit] = ACTIONS(2951),
    [anon_sym_consteval] = ACTIONS(2951),
    [anon_sym_alignas] = ACTIONS(2951),
    [anon_sym__Alignas] = ACTIONS(2951),
    [sym_primitive_type] = ACTIONS(2951),
    [anon_sym_enum] = ACTIONS(2951),
    [anon_sym_class] = ACTIONS(2951),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_union] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_switch] = ACTIONS(2951),
    [anon_sym_case] = ACTIONS(2951),
    [anon_sym_default] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2951),
    [anon_sym_do] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_goto] = ACTIONS(2951),
    [anon_sym___try] = ACTIONS(2951),
    [anon_sym___leave] = ACTIONS(2951),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_compl] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_sizeof] = ACTIONS(2951),
    [anon_sym___alignof__] = ACTIONS(2951),
    [anon_sym___alignof] = ACTIONS(2951),
    [anon_sym__alignof] = ACTIONS(2951),
    [anon_sym_alignof] = ACTIONS(2951),
    [anon_sym__Alignof] = ACTIONS(2951),
    [anon_sym_offsetof] = ACTIONS(2951),
    [anon_sym__Generic] = ACTIONS(2951),
    [anon_sym_asm] = ACTIONS(2951),
    [anon_sym___asm__] = ACTIONS(2951),
    [anon_sym___asm] = ACTIONS(2951),
    [sym_number_literal] = ACTIONS(2953),
    [anon_sym_L_SQUOTE] = ACTIONS(2953),
    [anon_sym_u_SQUOTE] = ACTIONS(2953),
    [anon_sym_U_SQUOTE] = ACTIONS(2953),
    [anon_sym_u8_SQUOTE] = ACTIONS(2953),
    [anon_sym_SQUOTE] = ACTIONS(2953),
    [anon_sym_L_DQUOTE] = ACTIONS(2953),
    [anon_sym_u_DQUOTE] = ACTIONS(2953),
    [anon_sym_U_DQUOTE] = ACTIONS(2953),
    [anon_sym_u8_DQUOTE] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(2953),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [anon_sym_NULL] = ACTIONS(2951),
    [anon_sym_nullptr] = ACTIONS(2951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2951),
    [anon_sym_decltype] = ACTIONS(2951),
    [anon_sym_explicit] = ACTIONS(2951),
    [anon_sym_typename] = ACTIONS(2951),
    [anon_sym_template] = ACTIONS(2951),
    [anon_sym_operator] = ACTIONS(2951),
    [anon_sym_try] = ACTIONS(2951),
    [anon_sym_delete] = ACTIONS(2951),
    [anon_sym_throw] = ACTIONS(2951),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_static_assert] = ACTIONS(2951),
    [anon_sym_concept] = ACTIONS(2951),
    [anon_sym_co_return] = ACTIONS(2951),
    [anon_sym_co_yield] = ACTIONS(2951),
    [anon_sym_R_DQUOTE] = ACTIONS(2953),
    [anon_sym_LR_DQUOTE] = ACTIONS(2953),
    [anon_sym_uR_DQUOTE] = ACTIONS(2953),
    [anon_sym_UR_DQUOTE] = ACTIONS(2953),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2953),
    [anon_sym_co_await] = ACTIONS(2951),
    [anon_sym_new] = ACTIONS(2951),
    [anon_sym_requires] = ACTIONS(2951),
    [sym_this] = ACTIONS(2951),
  },
  [744] = {
    [sym_identifier] = ACTIONS(2955),
    [aux_sym_preproc_include_token1] = ACTIONS(2955),
    [aux_sym_preproc_def_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token1] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2955),
    [sym_preproc_directive] = ACTIONS(2955),
    [anon_sym_LPAREN2] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2955),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym___extension__] = ACTIONS(2955),
    [anon_sym_typedef] = ACTIONS(2955),
    [anon_sym_virtual] = ACTIONS(2955),
    [anon_sym_extern] = ACTIONS(2955),
    [anon_sym___attribute__] = ACTIONS(2955),
    [anon_sym___attribute] = ACTIONS(2955),
    [anon_sym_using] = ACTIONS(2955),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2957),
    [anon_sym___declspec] = ACTIONS(2955),
    [anon_sym___based] = ACTIONS(2955),
    [anon_sym___cdecl] = ACTIONS(2955),
    [anon_sym___clrcall] = ACTIONS(2955),
    [anon_sym___stdcall] = ACTIONS(2955),
    [anon_sym___fastcall] = ACTIONS(2955),
    [anon_sym___thiscall] = ACTIONS(2955),
    [anon_sym___vectorcall] = ACTIONS(2955),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_RBRACE] = ACTIONS(2957),
    [anon_sym_signed] = ACTIONS(2955),
    [anon_sym_unsigned] = ACTIONS(2955),
    [anon_sym_long] = ACTIONS(2955),
    [anon_sym_short] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_register] = ACTIONS(2955),
    [anon_sym_inline] = ACTIONS(2955),
    [anon_sym___inline] = ACTIONS(2955),
    [anon_sym___inline__] = ACTIONS(2955),
    [anon_sym___forceinline] = ACTIONS(2955),
    [anon_sym_thread_local] = ACTIONS(2955),
    [anon_sym___thread] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_constexpr] = ACTIONS(2955),
    [anon_sym_volatile] = ACTIONS(2955),
    [anon_sym_restrict] = ACTIONS(2955),
    [anon_sym___restrict__] = ACTIONS(2955),
    [anon_sym__Atomic] = ACTIONS(2955),
    [anon_sym__Noreturn] = ACTIONS(2955),
    [anon_sym_noreturn] = ACTIONS(2955),
    [anon_sym__Nonnull] = ACTIONS(2955),
    [anon_sym_mutable] = ACTIONS(2955),
    [anon_sym_constinit] = ACTIONS(2955),
    [anon_sym_consteval] = ACTIONS(2955),
    [anon_sym_alignas] = ACTIONS(2955),
    [anon_sym__Alignas] = ACTIONS(2955),
    [sym_primitive_type] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2955),
    [anon_sym_union] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2955),
    [anon_sym_switch] = ACTIONS(2955),
    [anon_sym_case] = ACTIONS(2955),
    [anon_sym_default] = ACTIONS(2955),
    [anon_sym_while] = ACTIONS(2955),
    [anon_sym_do] = ACTIONS(2955),
    [anon_sym_for] = ACTIONS(2955),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_break] = ACTIONS(2955),
    [anon_sym_continue] = ACTIONS(2955),
    [anon_sym_goto] = ACTIONS(2955),
    [anon_sym___try] = ACTIONS(2955),
    [anon_sym___leave] = ACTIONS(2955),
    [anon_sym_not] = ACTIONS(2955),
    [anon_sym_compl] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_sizeof] = ACTIONS(2955),
    [anon_sym___alignof__] = ACTIONS(2955),
    [anon_sym___alignof] = ACTIONS(2955),
    [anon_sym__alignof] = ACTIONS(2955),
    [anon_sym_alignof] = ACTIONS(2955),
    [anon_sym__Alignof] = ACTIONS(2955),
    [anon_sym_offsetof] = ACTIONS(2955),
    [anon_sym__Generic] = ACTIONS(2955),
    [anon_sym_asm] = ACTIONS(2955),
    [anon_sym___asm__] = ACTIONS(2955),
    [anon_sym___asm] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(2957),
    [anon_sym_L_SQUOTE] = ACTIONS(2957),
    [anon_sym_u_SQUOTE] = ACTIONS(2957),
    [anon_sym_U_SQUOTE] = ACTIONS(2957),
    [anon_sym_u8_SQUOTE] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2955),
    [sym_false] = ACTIONS(2955),
    [anon_sym_NULL] = ACTIONS(2955),
    [anon_sym_nullptr] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2955),
    [anon_sym_decltype] = ACTIONS(2955),
    [anon_sym_explicit] = ACTIONS(2955),
    [anon_sym_typename] = ACTIONS(2955),
    [anon_sym_template] = ACTIONS(2955),
    [anon_sym_operator] = ACTIONS(2955),
    [anon_sym_try] = ACTIONS(2955),
    [anon_sym_delete] = ACTIONS(2955),
    [anon_sym_throw] = ACTIONS(2955),
    [anon_sym_namespace] = ACTIONS(2955),
    [anon_sym_static_assert] = ACTIONS(2955),
    [anon_sym_concept] = ACTIONS(2955),
    [anon_sym_co_return] = ACTIONS(2955),
    [anon_sym_co_yield] = ACTIONS(2955),
    [anon_sym_R_DQUOTE] = ACTIONS(2957),
    [anon_sym_LR_DQUOTE] = ACTIONS(2957),
    [anon_sym_uR_DQUOTE] = ACTIONS(2957),
    [anon_sym_UR_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2957),
    [anon_sym_co_await] = ACTIONS(2955),
    [anon_sym_new] = ACTIONS(2955),
    [anon_sym_requires] = ACTIONS(2955),
    [sym_this] = ACTIONS(2955),
  },
  [745] = {
    [sym_identifier] = ACTIONS(2955),
    [aux_sym_preproc_include_token1] = ACTIONS(2955),
    [aux_sym_preproc_def_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token2] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2955),
    [sym_preproc_directive] = ACTIONS(2955),
    [anon_sym_LPAREN2] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2955),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym___extension__] = ACTIONS(2955),
    [anon_sym_typedef] = ACTIONS(2955),
    [anon_sym_virtual] = ACTIONS(2955),
    [anon_sym_extern] = ACTIONS(2955),
    [anon_sym___attribute__] = ACTIONS(2955),
    [anon_sym___attribute] = ACTIONS(2955),
    [anon_sym_using] = ACTIONS(2955),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2957),
    [anon_sym___declspec] = ACTIONS(2955),
    [anon_sym___based] = ACTIONS(2955),
    [anon_sym___cdecl] = ACTIONS(2955),
    [anon_sym___clrcall] = ACTIONS(2955),
    [anon_sym___stdcall] = ACTIONS(2955),
    [anon_sym___fastcall] = ACTIONS(2955),
    [anon_sym___thiscall] = ACTIONS(2955),
    [anon_sym___vectorcall] = ACTIONS(2955),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_signed] = ACTIONS(2955),
    [anon_sym_unsigned] = ACTIONS(2955),
    [anon_sym_long] = ACTIONS(2955),
    [anon_sym_short] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_register] = ACTIONS(2955),
    [anon_sym_inline] = ACTIONS(2955),
    [anon_sym___inline] = ACTIONS(2955),
    [anon_sym___inline__] = ACTIONS(2955),
    [anon_sym___forceinline] = ACTIONS(2955),
    [anon_sym_thread_local] = ACTIONS(2955),
    [anon_sym___thread] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_constexpr] = ACTIONS(2955),
    [anon_sym_volatile] = ACTIONS(2955),
    [anon_sym_restrict] = ACTIONS(2955),
    [anon_sym___restrict__] = ACTIONS(2955),
    [anon_sym__Atomic] = ACTIONS(2955),
    [anon_sym__Noreturn] = ACTIONS(2955),
    [anon_sym_noreturn] = ACTIONS(2955),
    [anon_sym__Nonnull] = ACTIONS(2955),
    [anon_sym_mutable] = ACTIONS(2955),
    [anon_sym_constinit] = ACTIONS(2955),
    [anon_sym_consteval] = ACTIONS(2955),
    [anon_sym_alignas] = ACTIONS(2955),
    [anon_sym__Alignas] = ACTIONS(2955),
    [sym_primitive_type] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2955),
    [anon_sym_union] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2955),
    [anon_sym_switch] = ACTIONS(2955),
    [anon_sym_case] = ACTIONS(2955),
    [anon_sym_default] = ACTIONS(2955),
    [anon_sym_while] = ACTIONS(2955),
    [anon_sym_do] = ACTIONS(2955),
    [anon_sym_for] = ACTIONS(2955),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_break] = ACTIONS(2955),
    [anon_sym_continue] = ACTIONS(2955),
    [anon_sym_goto] = ACTIONS(2955),
    [anon_sym___try] = ACTIONS(2955),
    [anon_sym___leave] = ACTIONS(2955),
    [anon_sym_not] = ACTIONS(2955),
    [anon_sym_compl] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_sizeof] = ACTIONS(2955),
    [anon_sym___alignof__] = ACTIONS(2955),
    [anon_sym___alignof] = ACTIONS(2955),
    [anon_sym__alignof] = ACTIONS(2955),
    [anon_sym_alignof] = ACTIONS(2955),
    [anon_sym__Alignof] = ACTIONS(2955),
    [anon_sym_offsetof] = ACTIONS(2955),
    [anon_sym__Generic] = ACTIONS(2955),
    [anon_sym_asm] = ACTIONS(2955),
    [anon_sym___asm__] = ACTIONS(2955),
    [anon_sym___asm] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(2957),
    [anon_sym_L_SQUOTE] = ACTIONS(2957),
    [anon_sym_u_SQUOTE] = ACTIONS(2957),
    [anon_sym_U_SQUOTE] = ACTIONS(2957),
    [anon_sym_u8_SQUOTE] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2955),
    [sym_false] = ACTIONS(2955),
    [anon_sym_NULL] = ACTIONS(2955),
    [anon_sym_nullptr] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2955),
    [anon_sym_decltype] = ACTIONS(2955),
    [anon_sym_explicit] = ACTIONS(2955),
    [anon_sym_typename] = ACTIONS(2955),
    [anon_sym_template] = ACTIONS(2955),
    [anon_sym_operator] = ACTIONS(2955),
    [anon_sym_try] = ACTIONS(2955),
    [anon_sym_delete] = ACTIONS(2955),
    [anon_sym_throw] = ACTIONS(2955),
    [anon_sym_namespace] = ACTIONS(2955),
    [anon_sym_static_assert] = ACTIONS(2955),
    [anon_sym_concept] = ACTIONS(2955),
    [anon_sym_co_return] = ACTIONS(2955),
    [anon_sym_co_yield] = ACTIONS(2955),
    [anon_sym_R_DQUOTE] = ACTIONS(2957),
    [anon_sym_LR_DQUOTE] = ACTIONS(2957),
    [anon_sym_uR_DQUOTE] = ACTIONS(2957),
    [anon_sym_UR_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2957),
    [anon_sym_co_await] = ACTIONS(2955),
    [anon_sym_new] = ACTIONS(2955),
    [anon_sym_requires] = ACTIONS(2955),
    [sym_this] = ACTIONS(2955),
  },
  [746] = {
    [sym_identifier] = ACTIONS(3079),
    [aux_sym_preproc_include_token1] = ACTIONS(3079),
    [aux_sym_preproc_def_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token2] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3079),
    [sym_preproc_directive] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_AMP_AMP] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym___extension__] = ACTIONS(3079),
    [anon_sym_typedef] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym___attribute__] = ACTIONS(3079),
    [anon_sym___attribute] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3081),
    [anon_sym___declspec] = ACTIONS(3079),
    [anon_sym___based] = ACTIONS(3079),
    [anon_sym___cdecl] = ACTIONS(3079),
    [anon_sym___clrcall] = ACTIONS(3079),
    [anon_sym___stdcall] = ACTIONS(3079),
    [anon_sym___fastcall] = ACTIONS(3079),
    [anon_sym___thiscall] = ACTIONS(3079),
    [anon_sym___vectorcall] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3081),
    [anon_sym_signed] = ACTIONS(3079),
    [anon_sym_unsigned] = ACTIONS(3079),
    [anon_sym_long] = ACTIONS(3079),
    [anon_sym_short] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_register] = ACTIONS(3079),
    [anon_sym_inline] = ACTIONS(3079),
    [anon_sym___inline] = ACTIONS(3079),
    [anon_sym___inline__] = ACTIONS(3079),
    [anon_sym___forceinline] = ACTIONS(3079),
    [anon_sym_thread_local] = ACTIONS(3079),
    [anon_sym___thread] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_constexpr] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_restrict] = ACTIONS(3079),
    [anon_sym___restrict__] = ACTIONS(3079),
    [anon_sym__Atomic] = ACTIONS(3079),
    [anon_sym__Noreturn] = ACTIONS(3079),
    [anon_sym_noreturn] = ACTIONS(3079),
    [anon_sym__Nonnull] = ACTIONS(3079),
    [anon_sym_mutable] = ACTIONS(3079),
    [anon_sym_constinit] = ACTIONS(3079),
    [anon_sym_consteval] = ACTIONS(3079),
    [anon_sym_alignas] = ACTIONS(3079),
    [anon_sym__Alignas] = ACTIONS(3079),
    [sym_primitive_type] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_union] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_switch] = ACTIONS(3079),
    [anon_sym_case] = ACTIONS(3079),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_break] = ACTIONS(3079),
    [anon_sym_continue] = ACTIONS(3079),
    [anon_sym_goto] = ACTIONS(3079),
    [anon_sym___try] = ACTIONS(3079),
    [anon_sym___leave] = ACTIONS(3079),
    [anon_sym_not] = ACTIONS(3079),
    [anon_sym_compl] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_sizeof] = ACTIONS(3079),
    [anon_sym___alignof__] = ACTIONS(3079),
    [anon_sym___alignof] = ACTIONS(3079),
    [anon_sym__alignof] = ACTIONS(3079),
    [anon_sym_alignof] = ACTIONS(3079),
    [anon_sym__Alignof] = ACTIONS(3079),
    [anon_sym_offsetof] = ACTIONS(3079),
    [anon_sym__Generic] = ACTIONS(3079),
    [anon_sym_asm] = ACTIONS(3079),
    [anon_sym___asm__] = ACTIONS(3079),
    [anon_sym___asm] = ACTIONS(3079),
    [sym_number_literal] = ACTIONS(3081),
    [anon_sym_L_SQUOTE] = ACTIONS(3081),
    [anon_sym_u_SQUOTE] = ACTIONS(3081),
    [anon_sym_U_SQUOTE] = ACTIONS(3081),
    [anon_sym_u8_SQUOTE] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [anon_sym_L_DQUOTE] = ACTIONS(3081),
    [anon_sym_u_DQUOTE] = ACTIONS(3081),
    [anon_sym_U_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [sym_true] = ACTIONS(3079),
    [sym_false] = ACTIONS(3079),
    [anon_sym_NULL] = ACTIONS(3079),
    [anon_sym_nullptr] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3079),
    [anon_sym_decltype] = ACTIONS(3079),
    [anon_sym_explicit] = ACTIONS(3079),
    [anon_sym_typename] = ACTIONS(3079),
    [anon_sym_template] = ACTIONS(3079),
    [anon_sym_operator] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_delete] = ACTIONS(3079),
    [anon_sym_throw] = ACTIONS(3079),
    [anon_sym_namespace] = ACTIONS(3079),
    [anon_sym_static_assert] = ACTIONS(3079),
    [anon_sym_concept] = ACTIONS(3079),
    [anon_sym_co_return] = ACTIONS(3079),
    [anon_sym_co_yield] = ACTIONS(3079),
    [anon_sym_R_DQUOTE] = ACTIONS(3081),
    [anon_sym_LR_DQUOTE] = ACTIONS(3081),
    [anon_sym_uR_DQUOTE] = ACTIONS(3081),
    [anon_sym_UR_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3081),
    [anon_sym_co_await] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_requires] = ACTIONS(3079),
    [sym_this] = ACTIONS(3079),
  },
  [747] = {
    [sym_identifier] = ACTIONS(3019),
    [aux_sym_preproc_include_token1] = ACTIONS(3019),
    [aux_sym_preproc_def_token1] = ACTIONS(3019),
    [aux_sym_preproc_if_token1] = ACTIONS(3019),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3019),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3019),
    [sym_preproc_directive] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_STAR] = ACTIONS(3021),
    [anon_sym_AMP_AMP] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_SEMI] = ACTIONS(3021),
    [anon_sym___extension__] = ACTIONS(3019),
    [anon_sym_typedef] = ACTIONS(3019),
    [anon_sym_virtual] = ACTIONS(3019),
    [anon_sym_extern] = ACTIONS(3019),
    [anon_sym___attribute__] = ACTIONS(3019),
    [anon_sym___attribute] = ACTIONS(3019),
    [anon_sym_using] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3021),
    [anon_sym___declspec] = ACTIONS(3019),
    [anon_sym___based] = ACTIONS(3019),
    [anon_sym___cdecl] = ACTIONS(3019),
    [anon_sym___clrcall] = ACTIONS(3019),
    [anon_sym___stdcall] = ACTIONS(3019),
    [anon_sym___fastcall] = ACTIONS(3019),
    [anon_sym___thiscall] = ACTIONS(3019),
    [anon_sym___vectorcall] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(3021),
    [anon_sym_RBRACE] = ACTIONS(3021),
    [anon_sym_signed] = ACTIONS(3019),
    [anon_sym_unsigned] = ACTIONS(3019),
    [anon_sym_long] = ACTIONS(3019),
    [anon_sym_short] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_static] = ACTIONS(3019),
    [anon_sym_register] = ACTIONS(3019),
    [anon_sym_inline] = ACTIONS(3019),
    [anon_sym___inline] = ACTIONS(3019),
    [anon_sym___inline__] = ACTIONS(3019),
    [anon_sym___forceinline] = ACTIONS(3019),
    [anon_sym_thread_local] = ACTIONS(3019),
    [anon_sym___thread] = ACTIONS(3019),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_constexpr] = ACTIONS(3019),
    [anon_sym_volatile] = ACTIONS(3019),
    [anon_sym_restrict] = ACTIONS(3019),
    [anon_sym___restrict__] = ACTIONS(3019),
    [anon_sym__Atomic] = ACTIONS(3019),
    [anon_sym__Noreturn] = ACTIONS(3019),
    [anon_sym_noreturn] = ACTIONS(3019),
    [anon_sym__Nonnull] = ACTIONS(3019),
    [anon_sym_mutable] = ACTIONS(3019),
    [anon_sym_constinit] = ACTIONS(3019),
    [anon_sym_consteval] = ACTIONS(3019),
    [anon_sym_alignas] = ACTIONS(3019),
    [anon_sym__Alignas] = ACTIONS(3019),
    [sym_primitive_type] = ACTIONS(3019),
    [anon_sym_enum] = ACTIONS(3019),
    [anon_sym_class] = ACTIONS(3019),
    [anon_sym_struct] = ACTIONS(3019),
    [anon_sym_union] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_switch] = ACTIONS(3019),
    [anon_sym_case] = ACTIONS(3019),
    [anon_sym_default] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_break] = ACTIONS(3019),
    [anon_sym_continue] = ACTIONS(3019),
    [anon_sym_goto] = ACTIONS(3019),
    [anon_sym___try] = ACTIONS(3019),
    [anon_sym___leave] = ACTIONS(3019),
    [anon_sym_not] = ACTIONS(3019),
    [anon_sym_compl] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3021),
    [anon_sym_sizeof] = ACTIONS(3019),
    [anon_sym___alignof__] = ACTIONS(3019),
    [anon_sym___alignof] = ACTIONS(3019),
    [anon_sym__alignof] = ACTIONS(3019),
    [anon_sym_alignof] = ACTIONS(3019),
    [anon_sym__Alignof] = ACTIONS(3019),
    [anon_sym_offsetof] = ACTIONS(3019),
    [anon_sym__Generic] = ACTIONS(3019),
    [anon_sym_asm] = ACTIONS(3019),
    [anon_sym___asm__] = ACTIONS(3019),
    [anon_sym___asm] = ACTIONS(3019),
    [sym_number_literal] = ACTIONS(3021),
    [anon_sym_L_SQUOTE] = ACTIONS(3021),
    [anon_sym_u_SQUOTE] = ACTIONS(3021),
    [anon_sym_U_SQUOTE] = ACTIONS(3021),
    [anon_sym_u8_SQUOTE] = ACTIONS(3021),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [anon_sym_L_DQUOTE] = ACTIONS(3021),
    [anon_sym_u_DQUOTE] = ACTIONS(3021),
    [anon_sym_U_DQUOTE] = ACTIONS(3021),
    [anon_sym_u8_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE] = ACTIONS(3021),
    [sym_true] = ACTIONS(3019),
    [sym_false] = ACTIONS(3019),
    [anon_sym_NULL] = ACTIONS(3019),
    [anon_sym_nullptr] = ACTIONS(3019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3019),
    [anon_sym_decltype] = ACTIONS(3019),
    [anon_sym_explicit] = ACTIONS(3019),
    [anon_sym_typename] = ACTIONS(3019),
    [anon_sym_template] = ACTIONS(3019),
    [anon_sym_operator] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_delete] = ACTIONS(3019),
    [anon_sym_throw] = ACTIONS(3019),
    [anon_sym_namespace] = ACTIONS(3019),
    [anon_sym_static_assert] = ACTIONS(3019),
    [anon_sym_concept] = ACTIONS(3019),
    [anon_sym_co_return] = ACTIONS(3019),
    [anon_sym_co_yield] = ACTIONS(3019),
    [anon_sym_R_DQUOTE] = ACTIONS(3021),
    [anon_sym_LR_DQUOTE] = ACTIONS(3021),
    [anon_sym_uR_DQUOTE] = ACTIONS(3021),
    [anon_sym_UR_DQUOTE] = ACTIONS(3021),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3021),
    [anon_sym_co_await] = ACTIONS(3019),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_requires] = ACTIONS(3019),
    [sym_this] = ACTIONS(3019),
  },
  [748] = {
    [sym_identifier] = ACTIONS(3023),
    [aux_sym_preproc_include_token1] = ACTIONS(3023),
    [aux_sym_preproc_def_token1] = ACTIONS(3023),
    [aux_sym_preproc_if_token1] = ACTIONS(3023),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3023),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3023),
    [sym_preproc_directive] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3025),
    [anon_sym_BANG] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(3025),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_STAR] = ACTIONS(3025),
    [anon_sym_AMP_AMP] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym___extension__] = ACTIONS(3023),
    [anon_sym_typedef] = ACTIONS(3023),
    [anon_sym_virtual] = ACTIONS(3023),
    [anon_sym_extern] = ACTIONS(3023),
    [anon_sym___attribute__] = ACTIONS(3023),
    [anon_sym___attribute] = ACTIONS(3023),
    [anon_sym_using] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3025),
    [anon_sym___declspec] = ACTIONS(3023),
    [anon_sym___based] = ACTIONS(3023),
    [anon_sym___cdecl] = ACTIONS(3023),
    [anon_sym___clrcall] = ACTIONS(3023),
    [anon_sym___stdcall] = ACTIONS(3023),
    [anon_sym___fastcall] = ACTIONS(3023),
    [anon_sym___thiscall] = ACTIONS(3023),
    [anon_sym___vectorcall] = ACTIONS(3023),
    [anon_sym_LBRACE] = ACTIONS(3025),
    [anon_sym_RBRACE] = ACTIONS(3025),
    [anon_sym_signed] = ACTIONS(3023),
    [anon_sym_unsigned] = ACTIONS(3023),
    [anon_sym_long] = ACTIONS(3023),
    [anon_sym_short] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3023),
    [anon_sym_register] = ACTIONS(3023),
    [anon_sym_inline] = ACTIONS(3023),
    [anon_sym___inline] = ACTIONS(3023),
    [anon_sym___inline__] = ACTIONS(3023),
    [anon_sym___forceinline] = ACTIONS(3023),
    [anon_sym_thread_local] = ACTIONS(3023),
    [anon_sym___thread] = ACTIONS(3023),
    [anon_sym_const] = ACTIONS(3023),
    [anon_sym_constexpr] = ACTIONS(3023),
    [anon_sym_volatile] = ACTIONS(3023),
    [anon_sym_restrict] = ACTIONS(3023),
    [anon_sym___restrict__] = ACTIONS(3023),
    [anon_sym__Atomic] = ACTIONS(3023),
    [anon_sym__Noreturn] = ACTIONS(3023),
    [anon_sym_noreturn] = ACTIONS(3023),
    [anon_sym__Nonnull] = ACTIONS(3023),
    [anon_sym_mutable] = ACTIONS(3023),
    [anon_sym_constinit] = ACTIONS(3023),
    [anon_sym_consteval] = ACTIONS(3023),
    [anon_sym_alignas] = ACTIONS(3023),
    [anon_sym__Alignas] = ACTIONS(3023),
    [sym_primitive_type] = ACTIONS(3023),
    [anon_sym_enum] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3023),
    [anon_sym_struct] = ACTIONS(3023),
    [anon_sym_union] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_switch] = ACTIONS(3023),
    [anon_sym_case] = ACTIONS(3023),
    [anon_sym_default] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_break] = ACTIONS(3023),
    [anon_sym_continue] = ACTIONS(3023),
    [anon_sym_goto] = ACTIONS(3023),
    [anon_sym___try] = ACTIONS(3023),
    [anon_sym___leave] = ACTIONS(3023),
    [anon_sym_not] = ACTIONS(3023),
    [anon_sym_compl] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3025),
    [anon_sym_PLUS_PLUS] = ACTIONS(3025),
    [anon_sym_sizeof] = ACTIONS(3023),
    [anon_sym___alignof__] = ACTIONS(3023),
    [anon_sym___alignof] = ACTIONS(3023),
    [anon_sym__alignof] = ACTIONS(3023),
    [anon_sym_alignof] = ACTIONS(3023),
    [anon_sym__Alignof] = ACTIONS(3023),
    [anon_sym_offsetof] = ACTIONS(3023),
    [anon_sym__Generic] = ACTIONS(3023),
    [anon_sym_asm] = ACTIONS(3023),
    [anon_sym___asm__] = ACTIONS(3023),
    [anon_sym___asm] = ACTIONS(3023),
    [sym_number_literal] = ACTIONS(3025),
    [anon_sym_L_SQUOTE] = ACTIONS(3025),
    [anon_sym_u_SQUOTE] = ACTIONS(3025),
    [anon_sym_U_SQUOTE] = ACTIONS(3025),
    [anon_sym_u8_SQUOTE] = ACTIONS(3025),
    [anon_sym_SQUOTE] = ACTIONS(3025),
    [anon_sym_L_DQUOTE] = ACTIONS(3025),
    [anon_sym_u_DQUOTE] = ACTIONS(3025),
    [anon_sym_U_DQUOTE] = ACTIONS(3025),
    [anon_sym_u8_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE] = ACTIONS(3025),
    [sym_true] = ACTIONS(3023),
    [sym_false] = ACTIONS(3023),
    [anon_sym_NULL] = ACTIONS(3023),
    [anon_sym_nullptr] = ACTIONS(3023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3023),
    [anon_sym_decltype] = ACTIONS(3023),
    [anon_sym_explicit] = ACTIONS(3023),
    [anon_sym_typename] = ACTIONS(3023),
    [anon_sym_template] = ACTIONS(3023),
    [anon_sym_operator] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_delete] = ACTIONS(3023),
    [anon_sym_throw] = ACTIONS(3023),
    [anon_sym_namespace] = ACTIONS(3023),
    [anon_sym_static_assert] = ACTIONS(3023),
    [anon_sym_concept] = ACTIONS(3023),
    [anon_sym_co_return] = ACTIONS(3023),
    [anon_sym_co_yield] = ACTIONS(3023),
    [anon_sym_R_DQUOTE] = ACTIONS(3025),
    [anon_sym_LR_DQUOTE] = ACTIONS(3025),
    [anon_sym_uR_DQUOTE] = ACTIONS(3025),
    [anon_sym_UR_DQUOTE] = ACTIONS(3025),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3025),
    [anon_sym_co_await] = ACTIONS(3023),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_requires] = ACTIONS(3023),
    [sym_this] = ACTIONS(3023),
  },
  [749] = {
    [sym_identifier] = ACTIONS(3027),
    [aux_sym_preproc_include_token1] = ACTIONS(3027),
    [aux_sym_preproc_def_token1] = ACTIONS(3027),
    [aux_sym_preproc_if_token1] = ACTIONS(3027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3027),
    [sym_preproc_directive] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3029),
    [anon_sym_BANG] = ACTIONS(3029),
    [anon_sym_TILDE] = ACTIONS(3029),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_STAR] = ACTIONS(3029),
    [anon_sym_AMP_AMP] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_SEMI] = ACTIONS(3029),
    [anon_sym___extension__] = ACTIONS(3027),
    [anon_sym_typedef] = ACTIONS(3027),
    [anon_sym_virtual] = ACTIONS(3027),
    [anon_sym_extern] = ACTIONS(3027),
    [anon_sym___attribute__] = ACTIONS(3027),
    [anon_sym___attribute] = ACTIONS(3027),
    [anon_sym_using] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3029),
    [anon_sym___declspec] = ACTIONS(3027),
    [anon_sym___based] = ACTIONS(3027),
    [anon_sym___cdecl] = ACTIONS(3027),
    [anon_sym___clrcall] = ACTIONS(3027),
    [anon_sym___stdcall] = ACTIONS(3027),
    [anon_sym___fastcall] = ACTIONS(3027),
    [anon_sym___thiscall] = ACTIONS(3027),
    [anon_sym___vectorcall] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_RBRACE] = ACTIONS(3029),
    [anon_sym_signed] = ACTIONS(3027),
    [anon_sym_unsigned] = ACTIONS(3027),
    [anon_sym_long] = ACTIONS(3027),
    [anon_sym_short] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_static] = ACTIONS(3027),
    [anon_sym_register] = ACTIONS(3027),
    [anon_sym_inline] = ACTIONS(3027),
    [anon_sym___inline] = ACTIONS(3027),
    [anon_sym___inline__] = ACTIONS(3027),
    [anon_sym___forceinline] = ACTIONS(3027),
    [anon_sym_thread_local] = ACTIONS(3027),
    [anon_sym___thread] = ACTIONS(3027),
    [anon_sym_const] = ACTIONS(3027),
    [anon_sym_constexpr] = ACTIONS(3027),
    [anon_sym_volatile] = ACTIONS(3027),
    [anon_sym_restrict] = ACTIONS(3027),
    [anon_sym___restrict__] = ACTIONS(3027),
    [anon_sym__Atomic] = ACTIONS(3027),
    [anon_sym__Noreturn] = ACTIONS(3027),
    [anon_sym_noreturn] = ACTIONS(3027),
    [anon_sym__Nonnull] = ACTIONS(3027),
    [anon_sym_mutable] = ACTIONS(3027),
    [anon_sym_constinit] = ACTIONS(3027),
    [anon_sym_consteval] = ACTIONS(3027),
    [anon_sym_alignas] = ACTIONS(3027),
    [anon_sym__Alignas] = ACTIONS(3027),
    [sym_primitive_type] = ACTIONS(3027),
    [anon_sym_enum] = ACTIONS(3027),
    [anon_sym_class] = ACTIONS(3027),
    [anon_sym_struct] = ACTIONS(3027),
    [anon_sym_union] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_switch] = ACTIONS(3027),
    [anon_sym_case] = ACTIONS(3027),
    [anon_sym_default] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_break] = ACTIONS(3027),
    [anon_sym_continue] = ACTIONS(3027),
    [anon_sym_goto] = ACTIONS(3027),
    [anon_sym___try] = ACTIONS(3027),
    [anon_sym___leave] = ACTIONS(3027),
    [anon_sym_not] = ACTIONS(3027),
    [anon_sym_compl] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3029),
    [anon_sym_PLUS_PLUS] = ACTIONS(3029),
    [anon_sym_sizeof] = ACTIONS(3027),
    [anon_sym___alignof__] = ACTIONS(3027),
    [anon_sym___alignof] = ACTIONS(3027),
    [anon_sym__alignof] = ACTIONS(3027),
    [anon_sym_alignof] = ACTIONS(3027),
    [anon_sym__Alignof] = ACTIONS(3027),
    [anon_sym_offsetof] = ACTIONS(3027),
    [anon_sym__Generic] = ACTIONS(3027),
    [anon_sym_asm] = ACTIONS(3027),
    [anon_sym___asm__] = ACTIONS(3027),
    [anon_sym___asm] = ACTIONS(3027),
    [sym_number_literal] = ACTIONS(3029),
    [anon_sym_L_SQUOTE] = ACTIONS(3029),
    [anon_sym_u_SQUOTE] = ACTIONS(3029),
    [anon_sym_U_SQUOTE] = ACTIONS(3029),
    [anon_sym_u8_SQUOTE] = ACTIONS(3029),
    [anon_sym_SQUOTE] = ACTIONS(3029),
    [anon_sym_L_DQUOTE] = ACTIONS(3029),
    [anon_sym_u_DQUOTE] = ACTIONS(3029),
    [anon_sym_U_DQUOTE] = ACTIONS(3029),
    [anon_sym_u8_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE] = ACTIONS(3029),
    [sym_true] = ACTIONS(3027),
    [sym_false] = ACTIONS(3027),
    [anon_sym_NULL] = ACTIONS(3027),
    [anon_sym_nullptr] = ACTIONS(3027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3027),
    [anon_sym_decltype] = ACTIONS(3027),
    [anon_sym_explicit] = ACTIONS(3027),
    [anon_sym_typename] = ACTIONS(3027),
    [anon_sym_template] = ACTIONS(3027),
    [anon_sym_operator] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_delete] = ACTIONS(3027),
    [anon_sym_throw] = ACTIONS(3027),
    [anon_sym_namespace] = ACTIONS(3027),
    [anon_sym_static_assert] = ACTIONS(3027),
    [anon_sym_concept] = ACTIONS(3027),
    [anon_sym_co_return] = ACTIONS(3027),
    [anon_sym_co_yield] = ACTIONS(3027),
    [anon_sym_R_DQUOTE] = ACTIONS(3029),
    [anon_sym_LR_DQUOTE] = ACTIONS(3029),
    [anon_sym_uR_DQUOTE] = ACTIONS(3029),
    [anon_sym_UR_DQUOTE] = ACTIONS(3029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3029),
    [anon_sym_co_await] = ACTIONS(3027),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_requires] = ACTIONS(3027),
    [sym_this] = ACTIONS(3027),
  },
  [750] = {
    [sym_identifier] = ACTIONS(3031),
    [aux_sym_preproc_include_token1] = ACTIONS(3031),
    [aux_sym_preproc_def_token1] = ACTIONS(3031),
    [aux_sym_preproc_if_token1] = ACTIONS(3031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3031),
    [sym_preproc_directive] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3033),
    [anon_sym_BANG] = ACTIONS(3033),
    [anon_sym_TILDE] = ACTIONS(3033),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_STAR] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_SEMI] = ACTIONS(3033),
    [anon_sym___extension__] = ACTIONS(3031),
    [anon_sym_typedef] = ACTIONS(3031),
    [anon_sym_virtual] = ACTIONS(3031),
    [anon_sym_extern] = ACTIONS(3031),
    [anon_sym___attribute__] = ACTIONS(3031),
    [anon_sym___attribute] = ACTIONS(3031),
    [anon_sym_using] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3033),
    [anon_sym___declspec] = ACTIONS(3031),
    [anon_sym___based] = ACTIONS(3031),
    [anon_sym___cdecl] = ACTIONS(3031),
    [anon_sym___clrcall] = ACTIONS(3031),
    [anon_sym___stdcall] = ACTIONS(3031),
    [anon_sym___fastcall] = ACTIONS(3031),
    [anon_sym___thiscall] = ACTIONS(3031),
    [anon_sym___vectorcall] = ACTIONS(3031),
    [anon_sym_LBRACE] = ACTIONS(3033),
    [anon_sym_RBRACE] = ACTIONS(3033),
    [anon_sym_signed] = ACTIONS(3031),
    [anon_sym_unsigned] = ACTIONS(3031),
    [anon_sym_long] = ACTIONS(3031),
    [anon_sym_short] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_static] = ACTIONS(3031),
    [anon_sym_register] = ACTIONS(3031),
    [anon_sym_inline] = ACTIONS(3031),
    [anon_sym___inline] = ACTIONS(3031),
    [anon_sym___inline__] = ACTIONS(3031),
    [anon_sym___forceinline] = ACTIONS(3031),
    [anon_sym_thread_local] = ACTIONS(3031),
    [anon_sym___thread] = ACTIONS(3031),
    [anon_sym_const] = ACTIONS(3031),
    [anon_sym_constexpr] = ACTIONS(3031),
    [anon_sym_volatile] = ACTIONS(3031),
    [anon_sym_restrict] = ACTIONS(3031),
    [anon_sym___restrict__] = ACTIONS(3031),
    [anon_sym__Atomic] = ACTIONS(3031),
    [anon_sym__Noreturn] = ACTIONS(3031),
    [anon_sym_noreturn] = ACTIONS(3031),
    [anon_sym__Nonnull] = ACTIONS(3031),
    [anon_sym_mutable] = ACTIONS(3031),
    [anon_sym_constinit] = ACTIONS(3031),
    [anon_sym_consteval] = ACTIONS(3031),
    [anon_sym_alignas] = ACTIONS(3031),
    [anon_sym__Alignas] = ACTIONS(3031),
    [sym_primitive_type] = ACTIONS(3031),
    [anon_sym_enum] = ACTIONS(3031),
    [anon_sym_class] = ACTIONS(3031),
    [anon_sym_struct] = ACTIONS(3031),
    [anon_sym_union] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_switch] = ACTIONS(3031),
    [anon_sym_case] = ACTIONS(3031),
    [anon_sym_default] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3031),
    [anon_sym_goto] = ACTIONS(3031),
    [anon_sym___try] = ACTIONS(3031),
    [anon_sym___leave] = ACTIONS(3031),
    [anon_sym_not] = ACTIONS(3031),
    [anon_sym_compl] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3033),
    [anon_sym_PLUS_PLUS] = ACTIONS(3033),
    [anon_sym_sizeof] = ACTIONS(3031),
    [anon_sym___alignof__] = ACTIONS(3031),
    [anon_sym___alignof] = ACTIONS(3031),
    [anon_sym__alignof] = ACTIONS(3031),
    [anon_sym_alignof] = ACTIONS(3031),
    [anon_sym__Alignof] = ACTIONS(3031),
    [anon_sym_offsetof] = ACTIONS(3031),
    [anon_sym__Generic] = ACTIONS(3031),
    [anon_sym_asm] = ACTIONS(3031),
    [anon_sym___asm__] = ACTIONS(3031),
    [anon_sym___asm] = ACTIONS(3031),
    [sym_number_literal] = ACTIONS(3033),
    [anon_sym_L_SQUOTE] = ACTIONS(3033),
    [anon_sym_u_SQUOTE] = ACTIONS(3033),
    [anon_sym_U_SQUOTE] = ACTIONS(3033),
    [anon_sym_u8_SQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3033),
    [anon_sym_L_DQUOTE] = ACTIONS(3033),
    [anon_sym_u_DQUOTE] = ACTIONS(3033),
    [anon_sym_U_DQUOTE] = ACTIONS(3033),
    [anon_sym_u8_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [sym_true] = ACTIONS(3031),
    [sym_false] = ACTIONS(3031),
    [anon_sym_NULL] = ACTIONS(3031),
    [anon_sym_nullptr] = ACTIONS(3031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3031),
    [anon_sym_decltype] = ACTIONS(3031),
    [anon_sym_explicit] = ACTIONS(3031),
    [anon_sym_typename] = ACTIONS(3031),
    [anon_sym_template] = ACTIONS(3031),
    [anon_sym_operator] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_delete] = ACTIONS(3031),
    [anon_sym_throw] = ACTIONS(3031),
    [anon_sym_namespace] = ACTIONS(3031),
    [anon_sym_static_assert] = ACTIONS(3031),
    [anon_sym_concept] = ACTIONS(3031),
    [anon_sym_co_return] = ACTIONS(3031),
    [anon_sym_co_yield] = ACTIONS(3031),
    [anon_sym_R_DQUOTE] = ACTIONS(3033),
    [anon_sym_LR_DQUOTE] = ACTIONS(3033),
    [anon_sym_uR_DQUOTE] = ACTIONS(3033),
    [anon_sym_UR_DQUOTE] = ACTIONS(3033),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3033),
    [anon_sym_co_await] = ACTIONS(3031),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_requires] = ACTIONS(3031),
    [sym_this] = ACTIONS(3031),
  },
  [751] = {
    [sym_identifier] = ACTIONS(3035),
    [aux_sym_preproc_include_token1] = ACTIONS(3035),
    [aux_sym_preproc_def_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token1] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3035),
    [sym_preproc_directive] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3037),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_AMP_AMP] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_SEMI] = ACTIONS(3037),
    [anon_sym___extension__] = ACTIONS(3035),
    [anon_sym_typedef] = ACTIONS(3035),
    [anon_sym_virtual] = ACTIONS(3035),
    [anon_sym_extern] = ACTIONS(3035),
    [anon_sym___attribute__] = ACTIONS(3035),
    [anon_sym___attribute] = ACTIONS(3035),
    [anon_sym_using] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3037),
    [anon_sym___declspec] = ACTIONS(3035),
    [anon_sym___based] = ACTIONS(3035),
    [anon_sym___cdecl] = ACTIONS(3035),
    [anon_sym___clrcall] = ACTIONS(3035),
    [anon_sym___stdcall] = ACTIONS(3035),
    [anon_sym___fastcall] = ACTIONS(3035),
    [anon_sym___thiscall] = ACTIONS(3035),
    [anon_sym___vectorcall] = ACTIONS(3035),
    [anon_sym_LBRACE] = ACTIONS(3037),
    [anon_sym_RBRACE] = ACTIONS(3037),
    [anon_sym_signed] = ACTIONS(3035),
    [anon_sym_unsigned] = ACTIONS(3035),
    [anon_sym_long] = ACTIONS(3035),
    [anon_sym_short] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3035),
    [anon_sym_register] = ACTIONS(3035),
    [anon_sym_inline] = ACTIONS(3035),
    [anon_sym___inline] = ACTIONS(3035),
    [anon_sym___inline__] = ACTIONS(3035),
    [anon_sym___forceinline] = ACTIONS(3035),
    [anon_sym_thread_local] = ACTIONS(3035),
    [anon_sym___thread] = ACTIONS(3035),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_constexpr] = ACTIONS(3035),
    [anon_sym_volatile] = ACTIONS(3035),
    [anon_sym_restrict] = ACTIONS(3035),
    [anon_sym___restrict__] = ACTIONS(3035),
    [anon_sym__Atomic] = ACTIONS(3035),
    [anon_sym__Noreturn] = ACTIONS(3035),
    [anon_sym_noreturn] = ACTIONS(3035),
    [anon_sym__Nonnull] = ACTIONS(3035),
    [anon_sym_mutable] = ACTIONS(3035),
    [anon_sym_constinit] = ACTIONS(3035),
    [anon_sym_consteval] = ACTIONS(3035),
    [anon_sym_alignas] = ACTIONS(3035),
    [anon_sym__Alignas] = ACTIONS(3035),
    [sym_primitive_type] = ACTIONS(3035),
    [anon_sym_enum] = ACTIONS(3035),
    [anon_sym_class] = ACTIONS(3035),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_union] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_switch] = ACTIONS(3035),
    [anon_sym_case] = ACTIONS(3035),
    [anon_sym_default] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_break] = ACTIONS(3035),
    [anon_sym_continue] = ACTIONS(3035),
    [anon_sym_goto] = ACTIONS(3035),
    [anon_sym___try] = ACTIONS(3035),
    [anon_sym___leave] = ACTIONS(3035),
    [anon_sym_not] = ACTIONS(3035),
    [anon_sym_compl] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3037),
    [anon_sym_sizeof] = ACTIONS(3035),
    [anon_sym___alignof__] = ACTIONS(3035),
    [anon_sym___alignof] = ACTIONS(3035),
    [anon_sym__alignof] = ACTIONS(3035),
    [anon_sym_alignof] = ACTIONS(3035),
    [anon_sym__Alignof] = ACTIONS(3035),
    [anon_sym_offsetof] = ACTIONS(3035),
    [anon_sym__Generic] = ACTIONS(3035),
    [anon_sym_asm] = ACTIONS(3035),
    [anon_sym___asm__] = ACTIONS(3035),
    [anon_sym___asm] = ACTIONS(3035),
    [sym_number_literal] = ACTIONS(3037),
    [anon_sym_L_SQUOTE] = ACTIONS(3037),
    [anon_sym_u_SQUOTE] = ACTIONS(3037),
    [anon_sym_U_SQUOTE] = ACTIONS(3037),
    [anon_sym_u8_SQUOTE] = ACTIONS(3037),
    [anon_sym_SQUOTE] = ACTIONS(3037),
    [anon_sym_L_DQUOTE] = ACTIONS(3037),
    [anon_sym_u_DQUOTE] = ACTIONS(3037),
    [anon_sym_U_DQUOTE] = ACTIONS(3037),
    [anon_sym_u8_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE] = ACTIONS(3037),
    [sym_true] = ACTIONS(3035),
    [sym_false] = ACTIONS(3035),
    [anon_sym_NULL] = ACTIONS(3035),
    [anon_sym_nullptr] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3035),
    [anon_sym_decltype] = ACTIONS(3035),
    [anon_sym_explicit] = ACTIONS(3035),
    [anon_sym_typename] = ACTIONS(3035),
    [anon_sym_template] = ACTIONS(3035),
    [anon_sym_operator] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_delete] = ACTIONS(3035),
    [anon_sym_throw] = ACTIONS(3035),
    [anon_sym_namespace] = ACTIONS(3035),
    [anon_sym_static_assert] = ACTIONS(3035),
    [anon_sym_concept] = ACTIONS(3035),
    [anon_sym_co_return] = ACTIONS(3035),
    [anon_sym_co_yield] = ACTIONS(3035),
    [anon_sym_R_DQUOTE] = ACTIONS(3037),
    [anon_sym_LR_DQUOTE] = ACTIONS(3037),
    [anon_sym_uR_DQUOTE] = ACTIONS(3037),
    [anon_sym_UR_DQUOTE] = ACTIONS(3037),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3037),
    [anon_sym_co_await] = ACTIONS(3035),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_requires] = ACTIONS(3035),
    [sym_this] = ACTIONS(3035),
  },
  [752] = {
    [sym_identifier] = ACTIONS(3039),
    [aux_sym_preproc_include_token1] = ACTIONS(3039),
    [aux_sym_preproc_def_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token1] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3039),
    [sym_preproc_directive] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym___extension__] = ACTIONS(3039),
    [anon_sym_typedef] = ACTIONS(3039),
    [anon_sym_virtual] = ACTIONS(3039),
    [anon_sym_extern] = ACTIONS(3039),
    [anon_sym___attribute__] = ACTIONS(3039),
    [anon_sym___attribute] = ACTIONS(3039),
    [anon_sym_using] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3041),
    [anon_sym___declspec] = ACTIONS(3039),
    [anon_sym___based] = ACTIONS(3039),
    [anon_sym___cdecl] = ACTIONS(3039),
    [anon_sym___clrcall] = ACTIONS(3039),
    [anon_sym___stdcall] = ACTIONS(3039),
    [anon_sym___fastcall] = ACTIONS(3039),
    [anon_sym___thiscall] = ACTIONS(3039),
    [anon_sym___vectorcall] = ACTIONS(3039),
    [anon_sym_LBRACE] = ACTIONS(3041),
    [anon_sym_RBRACE] = ACTIONS(3041),
    [anon_sym_signed] = ACTIONS(3039),
    [anon_sym_unsigned] = ACTIONS(3039),
    [anon_sym_long] = ACTIONS(3039),
    [anon_sym_short] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3039),
    [anon_sym_register] = ACTIONS(3039),
    [anon_sym_inline] = ACTIONS(3039),
    [anon_sym___inline] = ACTIONS(3039),
    [anon_sym___inline__] = ACTIONS(3039),
    [anon_sym___forceinline] = ACTIONS(3039),
    [anon_sym_thread_local] = ACTIONS(3039),
    [anon_sym___thread] = ACTIONS(3039),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_constexpr] = ACTIONS(3039),
    [anon_sym_volatile] = ACTIONS(3039),
    [anon_sym_restrict] = ACTIONS(3039),
    [anon_sym___restrict__] = ACTIONS(3039),
    [anon_sym__Atomic] = ACTIONS(3039),
    [anon_sym__Noreturn] = ACTIONS(3039),
    [anon_sym_noreturn] = ACTIONS(3039),
    [anon_sym__Nonnull] = ACTIONS(3039),
    [anon_sym_mutable] = ACTIONS(3039),
    [anon_sym_constinit] = ACTIONS(3039),
    [anon_sym_consteval] = ACTIONS(3039),
    [anon_sym_alignas] = ACTIONS(3039),
    [anon_sym__Alignas] = ACTIONS(3039),
    [sym_primitive_type] = ACTIONS(3039),
    [anon_sym_enum] = ACTIONS(3039),
    [anon_sym_class] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3039),
    [anon_sym_union] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_switch] = ACTIONS(3039),
    [anon_sym_case] = ACTIONS(3039),
    [anon_sym_default] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_break] = ACTIONS(3039),
    [anon_sym_continue] = ACTIONS(3039),
    [anon_sym_goto] = ACTIONS(3039),
    [anon_sym___try] = ACTIONS(3039),
    [anon_sym___leave] = ACTIONS(3039),
    [anon_sym_not] = ACTIONS(3039),
    [anon_sym_compl] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3041),
    [anon_sym_sizeof] = ACTIONS(3039),
    [anon_sym___alignof__] = ACTIONS(3039),
    [anon_sym___alignof] = ACTIONS(3039),
    [anon_sym__alignof] = ACTIONS(3039),
    [anon_sym_alignof] = ACTIONS(3039),
    [anon_sym__Alignof] = ACTIONS(3039),
    [anon_sym_offsetof] = ACTIONS(3039),
    [anon_sym__Generic] = ACTIONS(3039),
    [anon_sym_asm] = ACTIONS(3039),
    [anon_sym___asm__] = ACTIONS(3039),
    [anon_sym___asm] = ACTIONS(3039),
    [sym_number_literal] = ACTIONS(3041),
    [anon_sym_L_SQUOTE] = ACTIONS(3041),
    [anon_sym_u_SQUOTE] = ACTIONS(3041),
    [anon_sym_U_SQUOTE] = ACTIONS(3041),
    [anon_sym_u8_SQUOTE] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_L_DQUOTE] = ACTIONS(3041),
    [anon_sym_u_DQUOTE] = ACTIONS(3041),
    [anon_sym_U_DQUOTE] = ACTIONS(3041),
    [anon_sym_u8_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE] = ACTIONS(3041),
    [sym_true] = ACTIONS(3039),
    [sym_false] = ACTIONS(3039),
    [anon_sym_NULL] = ACTIONS(3039),
    [anon_sym_nullptr] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3039),
    [anon_sym_decltype] = ACTIONS(3039),
    [anon_sym_explicit] = ACTIONS(3039),
    [anon_sym_typename] = ACTIONS(3039),
    [anon_sym_template] = ACTIONS(3039),
    [anon_sym_operator] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_delete] = ACTIONS(3039),
    [anon_sym_throw] = ACTIONS(3039),
    [anon_sym_namespace] = ACTIONS(3039),
    [anon_sym_static_assert] = ACTIONS(3039),
    [anon_sym_concept] = ACTIONS(3039),
    [anon_sym_co_return] = ACTIONS(3039),
    [anon_sym_co_yield] = ACTIONS(3039),
    [anon_sym_R_DQUOTE] = ACTIONS(3041),
    [anon_sym_LR_DQUOTE] = ACTIONS(3041),
    [anon_sym_uR_DQUOTE] = ACTIONS(3041),
    [anon_sym_UR_DQUOTE] = ACTIONS(3041),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3041),
    [anon_sym_co_await] = ACTIONS(3039),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_requires] = ACTIONS(3039),
    [sym_this] = ACTIONS(3039),
  },
  [753] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_include_token1] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym___cdecl] = ACTIONS(3063),
    [anon_sym___clrcall] = ACTIONS(3063),
    [anon_sym___stdcall] = ACTIONS(3063),
    [anon_sym___fastcall] = ACTIONS(3063),
    [anon_sym___thiscall] = ACTIONS(3063),
    [anon_sym___vectorcall] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym___try] = ACTIONS(3063),
    [anon_sym___leave] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(3063),
    [anon_sym_compl] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym___alignof__] = ACTIONS(3063),
    [anon_sym___alignof] = ACTIONS(3063),
    [anon_sym__alignof] = ACTIONS(3063),
    [anon_sym_alignof] = ACTIONS(3063),
    [anon_sym__Alignof] = ACTIONS(3063),
    [anon_sym_offsetof] = ACTIONS(3063),
    [anon_sym__Generic] = ACTIONS(3063),
    [anon_sym_asm] = ACTIONS(3063),
    [anon_sym___asm__] = ACTIONS(3063),
    [anon_sym___asm] = ACTIONS(3063),
    [sym_number_literal] = ACTIONS(3065),
    [anon_sym_L_SQUOTE] = ACTIONS(3065),
    [anon_sym_u_SQUOTE] = ACTIONS(3065),
    [anon_sym_U_SQUOTE] = ACTIONS(3065),
    [anon_sym_u8_SQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_L_DQUOTE] = ACTIONS(3065),
    [anon_sym_u_DQUOTE] = ACTIONS(3065),
    [anon_sym_U_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [sym_true] = ACTIONS(3063),
    [sym_false] = ACTIONS(3063),
    [anon_sym_NULL] = ACTIONS(3063),
    [anon_sym_nullptr] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
    [anon_sym_concept] = ACTIONS(3063),
    [anon_sym_co_return] = ACTIONS(3063),
    [anon_sym_co_yield] = ACTIONS(3063),
    [anon_sym_R_DQUOTE] = ACTIONS(3065),
    [anon_sym_LR_DQUOTE] = ACTIONS(3065),
    [anon_sym_uR_DQUOTE] = ACTIONS(3065),
    [anon_sym_UR_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3065),
    [anon_sym_co_await] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_requires] = ACTIONS(3063),
    [sym_this] = ACTIONS(3063),
  },
  [754] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_include_token1] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym___cdecl] = ACTIONS(3063),
    [anon_sym___clrcall] = ACTIONS(3063),
    [anon_sym___stdcall] = ACTIONS(3063),
    [anon_sym___fastcall] = ACTIONS(3063),
    [anon_sym___thiscall] = ACTIONS(3063),
    [anon_sym___vectorcall] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym___try] = ACTIONS(3063),
    [anon_sym___leave] = ACTIONS(3063),
    [anon_sym_not] = ACTIONS(3063),
    [anon_sym_compl] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym___alignof__] = ACTIONS(3063),
    [anon_sym___alignof] = ACTIONS(3063),
    [anon_sym__alignof] = ACTIONS(3063),
    [anon_sym_alignof] = ACTIONS(3063),
    [anon_sym__Alignof] = ACTIONS(3063),
    [anon_sym_offsetof] = ACTIONS(3063),
    [anon_sym__Generic] = ACTIONS(3063),
    [anon_sym_asm] = ACTIONS(3063),
    [anon_sym___asm__] = ACTIONS(3063),
    [anon_sym___asm] = ACTIONS(3063),
    [sym_number_literal] = ACTIONS(3065),
    [anon_sym_L_SQUOTE] = ACTIONS(3065),
    [anon_sym_u_SQUOTE] = ACTIONS(3065),
    [anon_sym_U_SQUOTE] = ACTIONS(3065),
    [anon_sym_u8_SQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_L_DQUOTE] = ACTIONS(3065),
    [anon_sym_u_DQUOTE] = ACTIONS(3065),
    [anon_sym_U_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [sym_true] = ACTIONS(3063),
    [sym_false] = ACTIONS(3063),
    [anon_sym_NULL] = ACTIONS(3063),
    [anon_sym_nullptr] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
    [anon_sym_concept] = ACTIONS(3063),
    [anon_sym_co_return] = ACTIONS(3063),
    [anon_sym_co_yield] = ACTIONS(3063),
    [anon_sym_R_DQUOTE] = ACTIONS(3065),
    [anon_sym_LR_DQUOTE] = ACTIONS(3065),
    [anon_sym_uR_DQUOTE] = ACTIONS(3065),
    [anon_sym_UR_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3065),
    [anon_sym_co_await] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_requires] = ACTIONS(3063),
    [sym_this] = ACTIONS(3063),
  },
  [755] = {
    [sym_identifier] = ACTIONS(3067),
    [aux_sym_preproc_include_token1] = ACTIONS(3067),
    [aux_sym_preproc_def_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3067),
    [sym_preproc_directive] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym___extension__] = ACTIONS(3067),
    [anon_sym_typedef] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym___attribute__] = ACTIONS(3067),
    [anon_sym___attribute] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3069),
    [anon_sym___declspec] = ACTIONS(3067),
    [anon_sym___based] = ACTIONS(3067),
    [anon_sym___cdecl] = ACTIONS(3067),
    [anon_sym___clrcall] = ACTIONS(3067),
    [anon_sym___stdcall] = ACTIONS(3067),
    [anon_sym___fastcall] = ACTIONS(3067),
    [anon_sym___thiscall] = ACTIONS(3067),
    [anon_sym___vectorcall] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_signed] = ACTIONS(3067),
    [anon_sym_unsigned] = ACTIONS(3067),
    [anon_sym_long] = ACTIONS(3067),
    [anon_sym_short] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_register] = ACTIONS(3067),
    [anon_sym_inline] = ACTIONS(3067),
    [anon_sym___inline] = ACTIONS(3067),
    [anon_sym___inline__] = ACTIONS(3067),
    [anon_sym___forceinline] = ACTIONS(3067),
    [anon_sym_thread_local] = ACTIONS(3067),
    [anon_sym___thread] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_constexpr] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_restrict] = ACTIONS(3067),
    [anon_sym___restrict__] = ACTIONS(3067),
    [anon_sym__Atomic] = ACTIONS(3067),
    [anon_sym__Noreturn] = ACTIONS(3067),
    [anon_sym_noreturn] = ACTIONS(3067),
    [anon_sym__Nonnull] = ACTIONS(3067),
    [anon_sym_mutable] = ACTIONS(3067),
    [anon_sym_constinit] = ACTIONS(3067),
    [anon_sym_consteval] = ACTIONS(3067),
    [anon_sym_alignas] = ACTIONS(3067),
    [anon_sym__Alignas] = ACTIONS(3067),
    [sym_primitive_type] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_union] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_case] = ACTIONS(3067),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_break] = ACTIONS(3067),
    [anon_sym_continue] = ACTIONS(3067),
    [anon_sym_goto] = ACTIONS(3067),
    [anon_sym___try] = ACTIONS(3067),
    [anon_sym___leave] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(3067),
    [anon_sym_compl] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_sizeof] = ACTIONS(3067),
    [anon_sym___alignof__] = ACTIONS(3067),
    [anon_sym___alignof] = ACTIONS(3067),
    [anon_sym__alignof] = ACTIONS(3067),
    [anon_sym_alignof] = ACTIONS(3067),
    [anon_sym__Alignof] = ACTIONS(3067),
    [anon_sym_offsetof] = ACTIONS(3067),
    [anon_sym__Generic] = ACTIONS(3067),
    [anon_sym_asm] = ACTIONS(3067),
    [anon_sym___asm__] = ACTIONS(3067),
    [anon_sym___asm] = ACTIONS(3067),
    [sym_number_literal] = ACTIONS(3069),
    [anon_sym_L_SQUOTE] = ACTIONS(3069),
    [anon_sym_u_SQUOTE] = ACTIONS(3069),
    [anon_sym_U_SQUOTE] = ACTIONS(3069),
    [anon_sym_u8_SQUOTE] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_L_DQUOTE] = ACTIONS(3069),
    [anon_sym_u_DQUOTE] = ACTIONS(3069),
    [anon_sym_U_DQUOTE] = ACTIONS(3069),
    [anon_sym_u8_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [sym_true] = ACTIONS(3067),
    [sym_false] = ACTIONS(3067),
    [anon_sym_NULL] = ACTIONS(3067),
    [anon_sym_nullptr] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3067),
    [anon_sym_decltype] = ACTIONS(3067),
    [anon_sym_explicit] = ACTIONS(3067),
    [anon_sym_typename] = ACTIONS(3067),
    [anon_sym_template] = ACTIONS(3067),
    [anon_sym_operator] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_delete] = ACTIONS(3067),
    [anon_sym_throw] = ACTIONS(3067),
    [anon_sym_namespace] = ACTIONS(3067),
    [anon_sym_static_assert] = ACTIONS(3067),
    [anon_sym_concept] = ACTIONS(3067),
    [anon_sym_co_return] = ACTIONS(3067),
    [anon_sym_co_yield] = ACTIONS(3067),
    [anon_sym_R_DQUOTE] = ACTIONS(3069),
    [anon_sym_LR_DQUOTE] = ACTIONS(3069),
    [anon_sym_uR_DQUOTE] = ACTIONS(3069),
    [anon_sym_UR_DQUOTE] = ACTIONS(3069),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3069),
    [anon_sym_co_await] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_requires] = ACTIONS(3067),
    [sym_this] = ACTIONS(3067),
  },
  [756] = {
    [sym_identifier] = ACTIONS(3071),
    [aux_sym_preproc_include_token1] = ACTIONS(3071),
    [aux_sym_preproc_def_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3071),
    [sym_preproc_directive] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym___extension__] = ACTIONS(3071),
    [anon_sym_typedef] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym___attribute__] = ACTIONS(3071),
    [anon_sym___attribute] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3073),
    [anon_sym___declspec] = ACTIONS(3071),
    [anon_sym___based] = ACTIONS(3071),
    [anon_sym___cdecl] = ACTIONS(3071),
    [anon_sym___clrcall] = ACTIONS(3071),
    [anon_sym___stdcall] = ACTIONS(3071),
    [anon_sym___fastcall] = ACTIONS(3071),
    [anon_sym___thiscall] = ACTIONS(3071),
    [anon_sym___vectorcall] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_signed] = ACTIONS(3071),
    [anon_sym_unsigned] = ACTIONS(3071),
    [anon_sym_long] = ACTIONS(3071),
    [anon_sym_short] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_register] = ACTIONS(3071),
    [anon_sym_inline] = ACTIONS(3071),
    [anon_sym___inline] = ACTIONS(3071),
    [anon_sym___inline__] = ACTIONS(3071),
    [anon_sym___forceinline] = ACTIONS(3071),
    [anon_sym_thread_local] = ACTIONS(3071),
    [anon_sym___thread] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_constexpr] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_restrict] = ACTIONS(3071),
    [anon_sym___restrict__] = ACTIONS(3071),
    [anon_sym__Atomic] = ACTIONS(3071),
    [anon_sym__Noreturn] = ACTIONS(3071),
    [anon_sym_noreturn] = ACTIONS(3071),
    [anon_sym__Nonnull] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_constinit] = ACTIONS(3071),
    [anon_sym_consteval] = ACTIONS(3071),
    [anon_sym_alignas] = ACTIONS(3071),
    [anon_sym__Alignas] = ACTIONS(3071),
    [sym_primitive_type] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_union] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_switch] = ACTIONS(3071),
    [anon_sym_case] = ACTIONS(3071),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3071),
    [anon_sym_goto] = ACTIONS(3071),
    [anon_sym___try] = ACTIONS(3071),
    [anon_sym___leave] = ACTIONS(3071),
    [anon_sym_not] = ACTIONS(3071),
    [anon_sym_compl] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_sizeof] = ACTIONS(3071),
    [anon_sym___alignof__] = ACTIONS(3071),
    [anon_sym___alignof] = ACTIONS(3071),
    [anon_sym__alignof] = ACTIONS(3071),
    [anon_sym_alignof] = ACTIONS(3071),
    [anon_sym__Alignof] = ACTIONS(3071),
    [anon_sym_offsetof] = ACTIONS(3071),
    [anon_sym__Generic] = ACTIONS(3071),
    [anon_sym_asm] = ACTIONS(3071),
    [anon_sym___asm__] = ACTIONS(3071),
    [anon_sym___asm] = ACTIONS(3071),
    [sym_number_literal] = ACTIONS(3073),
    [anon_sym_L_SQUOTE] = ACTIONS(3073),
    [anon_sym_u_SQUOTE] = ACTIONS(3073),
    [anon_sym_U_SQUOTE] = ACTIONS(3073),
    [anon_sym_u8_SQUOTE] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_L_DQUOTE] = ACTIONS(3073),
    [anon_sym_u_DQUOTE] = ACTIONS(3073),
    [anon_sym_U_DQUOTE] = ACTIONS(3073),
    [anon_sym_u8_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [sym_true] = ACTIONS(3071),
    [sym_false] = ACTIONS(3071),
    [anon_sym_NULL] = ACTIONS(3071),
    [anon_sym_nullptr] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3071),
    [anon_sym_decltype] = ACTIONS(3071),
    [anon_sym_explicit] = ACTIONS(3071),
    [anon_sym_typename] = ACTIONS(3071),
    [anon_sym_template] = ACTIONS(3071),
    [anon_sym_operator] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_delete] = ACTIONS(3071),
    [anon_sym_throw] = ACTIONS(3071),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_static_assert] = ACTIONS(3071),
    [anon_sym_concept] = ACTIONS(3071),
    [anon_sym_co_return] = ACTIONS(3071),
    [anon_sym_co_yield] = ACTIONS(3071),
    [anon_sym_R_DQUOTE] = ACTIONS(3073),
    [anon_sym_LR_DQUOTE] = ACTIONS(3073),
    [anon_sym_uR_DQUOTE] = ACTIONS(3073),
    [anon_sym_UR_DQUOTE] = ACTIONS(3073),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3073),
    [anon_sym_co_await] = ACTIONS(3071),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_requires] = ACTIONS(3071),
    [sym_this] = ACTIONS(3071),
  },
  [757] = {
    [sym_identifier] = ACTIONS(3075),
    [aux_sym_preproc_include_token1] = ACTIONS(3075),
    [aux_sym_preproc_def_token1] = ACTIONS(3075),
    [aux_sym_preproc_if_token1] = ACTIONS(3075),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3075),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3075),
    [sym_preproc_directive] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3077),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_AMP_AMP] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym___extension__] = ACTIONS(3075),
    [anon_sym_typedef] = ACTIONS(3075),
    [anon_sym_virtual] = ACTIONS(3075),
    [anon_sym_extern] = ACTIONS(3075),
    [anon_sym___attribute__] = ACTIONS(3075),
    [anon_sym___attribute] = ACTIONS(3075),
    [anon_sym_using] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3077),
    [anon_sym___declspec] = ACTIONS(3075),
    [anon_sym___based] = ACTIONS(3075),
    [anon_sym___cdecl] = ACTIONS(3075),
    [anon_sym___clrcall] = ACTIONS(3075),
    [anon_sym___stdcall] = ACTIONS(3075),
    [anon_sym___fastcall] = ACTIONS(3075),
    [anon_sym___thiscall] = ACTIONS(3075),
    [anon_sym___vectorcall] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_signed] = ACTIONS(3075),
    [anon_sym_unsigned] = ACTIONS(3075),
    [anon_sym_long] = ACTIONS(3075),
    [anon_sym_short] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_register] = ACTIONS(3075),
    [anon_sym_inline] = ACTIONS(3075),
    [anon_sym___inline] = ACTIONS(3075),
    [anon_sym___inline__] = ACTIONS(3075),
    [anon_sym___forceinline] = ACTIONS(3075),
    [anon_sym_thread_local] = ACTIONS(3075),
    [anon_sym___thread] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_constexpr] = ACTIONS(3075),
    [anon_sym_volatile] = ACTIONS(3075),
    [anon_sym_restrict] = ACTIONS(3075),
    [anon_sym___restrict__] = ACTIONS(3075),
    [anon_sym__Atomic] = ACTIONS(3075),
    [anon_sym__Noreturn] = ACTIONS(3075),
    [anon_sym_noreturn] = ACTIONS(3075),
    [anon_sym__Nonnull] = ACTIONS(3075),
    [anon_sym_mutable] = ACTIONS(3075),
    [anon_sym_constinit] = ACTIONS(3075),
    [anon_sym_consteval] = ACTIONS(3075),
    [anon_sym_alignas] = ACTIONS(3075),
    [anon_sym__Alignas] = ACTIONS(3075),
    [sym_primitive_type] = ACTIONS(3075),
    [anon_sym_enum] = ACTIONS(3075),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_struct] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_case] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_goto] = ACTIONS(3075),
    [anon_sym___try] = ACTIONS(3075),
    [anon_sym___leave] = ACTIONS(3075),
    [anon_sym_not] = ACTIONS(3075),
    [anon_sym_compl] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_sizeof] = ACTIONS(3075),
    [anon_sym___alignof__] = ACTIONS(3075),
    [anon_sym___alignof] = ACTIONS(3075),
    [anon_sym__alignof] = ACTIONS(3075),
    [anon_sym_alignof] = ACTIONS(3075),
    [anon_sym__Alignof] = ACTIONS(3075),
    [anon_sym_offsetof] = ACTIONS(3075),
    [anon_sym__Generic] = ACTIONS(3075),
    [anon_sym_asm] = ACTIONS(3075),
    [anon_sym___asm__] = ACTIONS(3075),
    [anon_sym___asm] = ACTIONS(3075),
    [sym_number_literal] = ACTIONS(3077),
    [anon_sym_L_SQUOTE] = ACTIONS(3077),
    [anon_sym_u_SQUOTE] = ACTIONS(3077),
    [anon_sym_U_SQUOTE] = ACTIONS(3077),
    [anon_sym_u8_SQUOTE] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [anon_sym_L_DQUOTE] = ACTIONS(3077),
    [anon_sym_u_DQUOTE] = ACTIONS(3077),
    [anon_sym_U_DQUOTE] = ACTIONS(3077),
    [anon_sym_u8_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [sym_true] = ACTIONS(3075),
    [sym_false] = ACTIONS(3075),
    [anon_sym_NULL] = ACTIONS(3075),
    [anon_sym_nullptr] = ACTIONS(3075),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3075),
    [anon_sym_decltype] = ACTIONS(3075),
    [anon_sym_explicit] = ACTIONS(3075),
    [anon_sym_typename] = ACTIONS(3075),
    [anon_sym_template] = ACTIONS(3075),
    [anon_sym_operator] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_delete] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_static_assert] = ACTIONS(3075),
    [anon_sym_concept] = ACTIONS(3075),
    [anon_sym_co_return] = ACTIONS(3075),
    [anon_sym_co_yield] = ACTIONS(3075),
    [anon_sym_R_DQUOTE] = ACTIONS(3077),
    [anon_sym_LR_DQUOTE] = ACTIONS(3077),
    [anon_sym_uR_DQUOTE] = ACTIONS(3077),
    [anon_sym_UR_DQUOTE] = ACTIONS(3077),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3077),
    [anon_sym_co_await] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_requires] = ACTIONS(3075),
    [sym_this] = ACTIONS(3075),
  },
  [758] = {
    [sym_identifier] = ACTIONS(3079),
    [aux_sym_preproc_include_token1] = ACTIONS(3079),
    [aux_sym_preproc_def_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3079),
    [sym_preproc_directive] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_AMP_AMP] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym___extension__] = ACTIONS(3079),
    [anon_sym_typedef] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym___attribute__] = ACTIONS(3079),
    [anon_sym___attribute] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3081),
    [anon_sym___declspec] = ACTIONS(3079),
    [anon_sym___based] = ACTIONS(3079),
    [anon_sym___cdecl] = ACTIONS(3079),
    [anon_sym___clrcall] = ACTIONS(3079),
    [anon_sym___stdcall] = ACTIONS(3079),
    [anon_sym___fastcall] = ACTIONS(3079),
    [anon_sym___thiscall] = ACTIONS(3079),
    [anon_sym___vectorcall] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3081),
    [anon_sym_RBRACE] = ACTIONS(3081),
    [anon_sym_signed] = ACTIONS(3079),
    [anon_sym_unsigned] = ACTIONS(3079),
    [anon_sym_long] = ACTIONS(3079),
    [anon_sym_short] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_register] = ACTIONS(3079),
    [anon_sym_inline] = ACTIONS(3079),
    [anon_sym___inline] = ACTIONS(3079),
    [anon_sym___inline__] = ACTIONS(3079),
    [anon_sym___forceinline] = ACTIONS(3079),
    [anon_sym_thread_local] = ACTIONS(3079),
    [anon_sym___thread] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_constexpr] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_restrict] = ACTIONS(3079),
    [anon_sym___restrict__] = ACTIONS(3079),
    [anon_sym__Atomic] = ACTIONS(3079),
    [anon_sym__Noreturn] = ACTIONS(3079),
    [anon_sym_noreturn] = ACTIONS(3079),
    [anon_sym__Nonnull] = ACTIONS(3079),
    [anon_sym_mutable] = ACTIONS(3079),
    [anon_sym_constinit] = ACTIONS(3079),
    [anon_sym_consteval] = ACTIONS(3079),
    [anon_sym_alignas] = ACTIONS(3079),
    [anon_sym__Alignas] = ACTIONS(3079),
    [sym_primitive_type] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_union] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_switch] = ACTIONS(3079),
    [anon_sym_case] = ACTIONS(3079),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_break] = ACTIONS(3079),
    [anon_sym_continue] = ACTIONS(3079),
    [anon_sym_goto] = ACTIONS(3079),
    [anon_sym___try] = ACTIONS(3079),
    [anon_sym___leave] = ACTIONS(3079),
    [anon_sym_not] = ACTIONS(3079),
    [anon_sym_compl] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_sizeof] = ACTIONS(3079),
    [anon_sym___alignof__] = ACTIONS(3079),
    [anon_sym___alignof] = ACTIONS(3079),
    [anon_sym__alignof] = ACTIONS(3079),
    [anon_sym_alignof] = ACTIONS(3079),
    [anon_sym__Alignof] = ACTIONS(3079),
    [anon_sym_offsetof] = ACTIONS(3079),
    [anon_sym__Generic] = ACTIONS(3079),
    [anon_sym_asm] = ACTIONS(3079),
    [anon_sym___asm__] = ACTIONS(3079),
    [anon_sym___asm] = ACTIONS(3079),
    [sym_number_literal] = ACTIONS(3081),
    [anon_sym_L_SQUOTE] = ACTIONS(3081),
    [anon_sym_u_SQUOTE] = ACTIONS(3081),
    [anon_sym_U_SQUOTE] = ACTIONS(3081),
    [anon_sym_u8_SQUOTE] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [anon_sym_L_DQUOTE] = ACTIONS(3081),
    [anon_sym_u_DQUOTE] = ACTIONS(3081),
    [anon_sym_U_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [sym_true] = ACTIONS(3079),
    [sym_false] = ACTIONS(3079),
    [anon_sym_NULL] = ACTIONS(3079),
    [anon_sym_nullptr] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3079),
    [anon_sym_decltype] = ACTIONS(3079),
    [anon_sym_explicit] = ACTIONS(3079),
    [anon_sym_typename] = ACTIONS(3079),
    [anon_sym_template] = ACTIONS(3079),
    [anon_sym_operator] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_delete] = ACTIONS(3079),
    [anon_sym_throw] = ACTIONS(3079),
    [anon_sym_namespace] = ACTIONS(3079),
    [anon_sym_static_assert] = ACTIONS(3079),
    [anon_sym_concept] = ACTIONS(3079),
    [anon_sym_co_return] = ACTIONS(3079),
    [anon_sym_co_yield] = ACTIONS(3079),
    [anon_sym_R_DQUOTE] = ACTIONS(3081),
    [anon_sym_LR_DQUOTE] = ACTIONS(3081),
    [anon_sym_uR_DQUOTE] = ACTIONS(3081),
    [anon_sym_UR_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3081),
    [anon_sym_co_await] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_requires] = ACTIONS(3079),
    [sym_this] = ACTIONS(3079),
  },
  [759] = {
    [sym_identifier] = ACTIONS(3083),
    [aux_sym_preproc_include_token1] = ACTIONS(3083),
    [aux_sym_preproc_def_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3083),
    [sym_preproc_directive] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3085),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym___extension__] = ACTIONS(3083),
    [anon_sym_typedef] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym___attribute__] = ACTIONS(3083),
    [anon_sym___attribute] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3085),
    [anon_sym___declspec] = ACTIONS(3083),
    [anon_sym___based] = ACTIONS(3083),
    [anon_sym___cdecl] = ACTIONS(3083),
    [anon_sym___clrcall] = ACTIONS(3083),
    [anon_sym___stdcall] = ACTIONS(3083),
    [anon_sym___fastcall] = ACTIONS(3083),
    [anon_sym___thiscall] = ACTIONS(3083),
    [anon_sym___vectorcall] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_signed] = ACTIONS(3083),
    [anon_sym_unsigned] = ACTIONS(3083),
    [anon_sym_long] = ACTIONS(3083),
    [anon_sym_short] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_register] = ACTIONS(3083),
    [anon_sym_inline] = ACTIONS(3083),
    [anon_sym___inline] = ACTIONS(3083),
    [anon_sym___inline__] = ACTIONS(3083),
    [anon_sym___forceinline] = ACTIONS(3083),
    [anon_sym_thread_local] = ACTIONS(3083),
    [anon_sym___thread] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_constexpr] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_restrict] = ACTIONS(3083),
    [anon_sym___restrict__] = ACTIONS(3083),
    [anon_sym__Atomic] = ACTIONS(3083),
    [anon_sym__Noreturn] = ACTIONS(3083),
    [anon_sym_noreturn] = ACTIONS(3083),
    [anon_sym__Nonnull] = ACTIONS(3083),
    [anon_sym_mutable] = ACTIONS(3083),
    [anon_sym_constinit] = ACTIONS(3083),
    [anon_sym_consteval] = ACTIONS(3083),
    [anon_sym_alignas] = ACTIONS(3083),
    [anon_sym__Alignas] = ACTIONS(3083),
    [sym_primitive_type] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3083),
    [anon_sym_union] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_case] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_goto] = ACTIONS(3083),
    [anon_sym___try] = ACTIONS(3083),
    [anon_sym___leave] = ACTIONS(3083),
    [anon_sym_not] = ACTIONS(3083),
    [anon_sym_compl] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_sizeof] = ACTIONS(3083),
    [anon_sym___alignof__] = ACTIONS(3083),
    [anon_sym___alignof] = ACTIONS(3083),
    [anon_sym__alignof] = ACTIONS(3083),
    [anon_sym_alignof] = ACTIONS(3083),
    [anon_sym__Alignof] = ACTIONS(3083),
    [anon_sym_offsetof] = ACTIONS(3083),
    [anon_sym__Generic] = ACTIONS(3083),
    [anon_sym_asm] = ACTIONS(3083),
    [anon_sym___asm__] = ACTIONS(3083),
    [anon_sym___asm] = ACTIONS(3083),
    [sym_number_literal] = ACTIONS(3085),
    [anon_sym_L_SQUOTE] = ACTIONS(3085),
    [anon_sym_u_SQUOTE] = ACTIONS(3085),
    [anon_sym_U_SQUOTE] = ACTIONS(3085),
    [anon_sym_u8_SQUOTE] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [anon_sym_L_DQUOTE] = ACTIONS(3085),
    [anon_sym_u_DQUOTE] = ACTIONS(3085),
    [anon_sym_U_DQUOTE] = ACTIONS(3085),
    [anon_sym_u8_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [sym_true] = ACTIONS(3083),
    [sym_false] = ACTIONS(3083),
    [anon_sym_NULL] = ACTIONS(3083),
    [anon_sym_nullptr] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3083),
    [anon_sym_decltype] = ACTIONS(3083),
    [anon_sym_explicit] = ACTIONS(3083),
    [anon_sym_typename] = ACTIONS(3083),
    [anon_sym_template] = ACTIONS(3083),
    [anon_sym_operator] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_delete] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_namespace] = ACTIONS(3083),
    [anon_sym_static_assert] = ACTIONS(3083),
    [anon_sym_concept] = ACTIONS(3083),
    [anon_sym_co_return] = ACTIONS(3083),
    [anon_sym_co_yield] = ACTIONS(3083),
    [anon_sym_R_DQUOTE] = ACTIONS(3085),
    [anon_sym_LR_DQUOTE] = ACTIONS(3085),
    [anon_sym_uR_DQUOTE] = ACTIONS(3085),
    [anon_sym_UR_DQUOTE] = ACTIONS(3085),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3085),
    [anon_sym_co_await] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_requires] = ACTIONS(3083),
    [sym_this] = ACTIONS(3083),
  },
  [760] = {
    [sym_identifier] = ACTIONS(3309),
    [aux_sym_preproc_include_token1] = ACTIONS(3309),
    [aux_sym_preproc_def_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3309),
    [sym_preproc_directive] = ACTIONS(3309),
    [anon_sym_LPAREN2] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_AMP_AMP] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym___extension__] = ACTIONS(3309),
    [anon_sym_typedef] = ACTIONS(3309),
    [anon_sym_virtual] = ACTIONS(3309),
    [anon_sym_extern] = ACTIONS(3309),
    [anon_sym___attribute__] = ACTIONS(3309),
    [anon_sym___attribute] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_COLON_COLON] = ACTIONS(3311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3311),
    [anon_sym___declspec] = ACTIONS(3309),
    [anon_sym___based] = ACTIONS(3309),
    [anon_sym___cdecl] = ACTIONS(3309),
    [anon_sym___clrcall] = ACTIONS(3309),
    [anon_sym___stdcall] = ACTIONS(3309),
    [anon_sym___fastcall] = ACTIONS(3309),
    [anon_sym___thiscall] = ACTIONS(3309),
    [anon_sym___vectorcall] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_RBRACE] = ACTIONS(3311),
    [anon_sym_signed] = ACTIONS(3309),
    [anon_sym_unsigned] = ACTIONS(3309),
    [anon_sym_long] = ACTIONS(3309),
    [anon_sym_short] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_register] = ACTIONS(3309),
    [anon_sym_inline] = ACTIONS(3309),
    [anon_sym___inline] = ACTIONS(3309),
    [anon_sym___inline__] = ACTIONS(3309),
    [anon_sym___forceinline] = ACTIONS(3309),
    [anon_sym_thread_local] = ACTIONS(3309),
    [anon_sym___thread] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_constexpr] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(3309),
    [anon_sym_restrict] = ACTIONS(3309),
    [anon_sym___restrict__] = ACTIONS(3309),
    [anon_sym__Atomic] = ACTIONS(3309),
    [anon_sym__Noreturn] = ACTIONS(3309),
    [anon_sym_noreturn] = ACTIONS(3309),
    [anon_sym__Nonnull] = ACTIONS(3309),
    [anon_sym_mutable] = ACTIONS(3309),
    [anon_sym_constinit] = ACTIONS(3309),
    [anon_sym_consteval] = ACTIONS(3309),
    [anon_sym_alignas] = ACTIONS(3309),
    [anon_sym__Alignas] = ACTIONS(3309),
    [sym_primitive_type] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_struct] = ACTIONS(3309),
    [anon_sym_union] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_case] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_goto] = ACTIONS(3309),
    [anon_sym___try] = ACTIONS(3309),
    [anon_sym___leave] = ACTIONS(3309),
    [anon_sym_not] = ACTIONS(3309),
    [anon_sym_compl] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_sizeof] = ACTIONS(3309),
    [anon_sym___alignof__] = ACTIONS(3309),
    [anon_sym___alignof] = ACTIONS(3309),
    [anon_sym__alignof] = ACTIONS(3309),
    [anon_sym_alignof] = ACTIONS(3309),
    [anon_sym__Alignof] = ACTIONS(3309),
    [anon_sym_offsetof] = ACTIONS(3309),
    [anon_sym__Generic] = ACTIONS(3309),
    [anon_sym_asm] = ACTIONS(3309),
    [anon_sym___asm__] = ACTIONS(3309),
    [anon_sym___asm] = ACTIONS(3309),
    [sym_number_literal] = ACTIONS(3311),
    [anon_sym_L_SQUOTE] = ACTIONS(3311),
    [anon_sym_u_SQUOTE] = ACTIONS(3311),
    [anon_sym_U_SQUOTE] = ACTIONS(3311),
    [anon_sym_u8_SQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_L_DQUOTE] = ACTIONS(3311),
    [anon_sym_u_DQUOTE] = ACTIONS(3311),
    [anon_sym_U_DQUOTE] = ACTIONS(3311),
    [anon_sym_u8_DQUOTE] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3309),
    [anon_sym_nullptr] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3309),
    [anon_sym_decltype] = ACTIONS(3309),
    [anon_sym_explicit] = ACTIONS(3309),
    [anon_sym_typename] = ACTIONS(3309),
    [anon_sym_template] = ACTIONS(3309),
    [anon_sym_operator] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_static_assert] = ACTIONS(3309),
    [anon_sym_concept] = ACTIONS(3309),
    [anon_sym_co_return] = ACTIONS(3309),
    [anon_sym_co_yield] = ACTIONS(3309),
    [anon_sym_R_DQUOTE] = ACTIONS(3311),
    [anon_sym_LR_DQUOTE] = ACTIONS(3311),
    [anon_sym_uR_DQUOTE] = ACTIONS(3311),
    [anon_sym_UR_DQUOTE] = ACTIONS(3311),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3311),
    [anon_sym_co_await] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_requires] = ACTIONS(3309),
    [sym_this] = ACTIONS(3309),
  },
  [761] = {
    [sym_identifier] = ACTIONS(3313),
    [aux_sym_preproc_include_token1] = ACTIONS(3313),
    [aux_sym_preproc_def_token1] = ACTIONS(3313),
    [aux_sym_preproc_if_token1] = ACTIONS(3313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3313),
    [sym_preproc_directive] = ACTIONS(3313),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_PLUS] = ACTIONS(3313),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3313),
    [anon_sym_typedef] = ACTIONS(3313),
    [anon_sym_virtual] = ACTIONS(3313),
    [anon_sym_extern] = ACTIONS(3313),
    [anon_sym___attribute__] = ACTIONS(3313),
    [anon_sym___attribute] = ACTIONS(3313),
    [anon_sym_using] = ACTIONS(3313),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3313),
    [anon_sym___based] = ACTIONS(3313),
    [anon_sym___cdecl] = ACTIONS(3313),
    [anon_sym___clrcall] = ACTIONS(3313),
    [anon_sym___stdcall] = ACTIONS(3313),
    [anon_sym___fastcall] = ACTIONS(3313),
    [anon_sym___thiscall] = ACTIONS(3313),
    [anon_sym___vectorcall] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3313),
    [anon_sym_unsigned] = ACTIONS(3313),
    [anon_sym_long] = ACTIONS(3313),
    [anon_sym_short] = ACTIONS(3313),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_static] = ACTIONS(3313),
    [anon_sym_register] = ACTIONS(3313),
    [anon_sym_inline] = ACTIONS(3313),
    [anon_sym___inline] = ACTIONS(3313),
    [anon_sym___inline__] = ACTIONS(3313),
    [anon_sym___forceinline] = ACTIONS(3313),
    [anon_sym_thread_local] = ACTIONS(3313),
    [anon_sym___thread] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3313),
    [anon_sym_constexpr] = ACTIONS(3313),
    [anon_sym_volatile] = ACTIONS(3313),
    [anon_sym_restrict] = ACTIONS(3313),
    [anon_sym___restrict__] = ACTIONS(3313),
    [anon_sym__Atomic] = ACTIONS(3313),
    [anon_sym__Noreturn] = ACTIONS(3313),
    [anon_sym_noreturn] = ACTIONS(3313),
    [anon_sym__Nonnull] = ACTIONS(3313),
    [anon_sym_mutable] = ACTIONS(3313),
    [anon_sym_constinit] = ACTIONS(3313),
    [anon_sym_consteval] = ACTIONS(3313),
    [anon_sym_alignas] = ACTIONS(3313),
    [anon_sym__Alignas] = ACTIONS(3313),
    [sym_primitive_type] = ACTIONS(3313),
    [anon_sym_enum] = ACTIONS(3313),
    [anon_sym_class] = ACTIONS(3313),
    [anon_sym_struct] = ACTIONS(3313),
    [anon_sym_union] = ACTIONS(3313),
    [anon_sym_if] = ACTIONS(3313),
    [anon_sym_switch] = ACTIONS(3313),
    [anon_sym_case] = ACTIONS(3313),
    [anon_sym_default] = ACTIONS(3313),
    [anon_sym_while] = ACTIONS(3313),
    [anon_sym_do] = ACTIONS(3313),
    [anon_sym_for] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3313),
    [anon_sym_break] = ACTIONS(3313),
    [anon_sym_continue] = ACTIONS(3313),
    [anon_sym_goto] = ACTIONS(3313),
    [anon_sym___try] = ACTIONS(3313),
    [anon_sym___leave] = ACTIONS(3313),
    [anon_sym_not] = ACTIONS(3313),
    [anon_sym_compl] = ACTIONS(3313),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3313),
    [anon_sym___alignof__] = ACTIONS(3313),
    [anon_sym___alignof] = ACTIONS(3313),
    [anon_sym__alignof] = ACTIONS(3313),
    [anon_sym_alignof] = ACTIONS(3313),
    [anon_sym__Alignof] = ACTIONS(3313),
    [anon_sym_offsetof] = ACTIONS(3313),
    [anon_sym__Generic] = ACTIONS(3313),
    [anon_sym_asm] = ACTIONS(3313),
    [anon_sym___asm__] = ACTIONS(3313),
    [anon_sym___asm] = ACTIONS(3313),
    [sym_number_literal] = ACTIONS(3316),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3313),
    [sym_false] = ACTIONS(3313),
    [anon_sym_NULL] = ACTIONS(3313),
    [anon_sym_nullptr] = ACTIONS(3313),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3313),
    [anon_sym_decltype] = ACTIONS(3313),
    [anon_sym_explicit] = ACTIONS(3313),
    [anon_sym_typename] = ACTIONS(3313),
    [anon_sym_template] = ACTIONS(3313),
    [anon_sym_operator] = ACTIONS(3313),
    [anon_sym_try] = ACTIONS(3313),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_throw] = ACTIONS(3313),
    [anon_sym_namespace] = ACTIONS(3313),
    [anon_sym_static_assert] = ACTIONS(3313),
    [anon_sym_concept] = ACTIONS(3313),
    [anon_sym_co_return] = ACTIONS(3313),
    [anon_sym_co_yield] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3313),
    [anon_sym_new] = ACTIONS(3313),
    [anon_sym_requires] = ACTIONS(3313),
    [sym_this] = ACTIONS(3313),
  },
  [762] = {
    [sym_identifier] = ACTIONS(3089),
    [aux_sym_preproc_include_token1] = ACTIONS(3089),
    [aux_sym_preproc_def_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token1] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3089),
    [sym_preproc_directive] = ACTIONS(3089),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_STAR] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym___extension__] = ACTIONS(3089),
    [anon_sym_typedef] = ACTIONS(3089),
    [anon_sym_virtual] = ACTIONS(3089),
    [anon_sym_extern] = ACTIONS(3089),
    [anon_sym___attribute__] = ACTIONS(3089),
    [anon_sym___attribute] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_COLON_COLON] = ACTIONS(3091),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3091),
    [anon_sym___declspec] = ACTIONS(3089),
    [anon_sym___based] = ACTIONS(3089),
    [anon_sym___cdecl] = ACTIONS(3089),
    [anon_sym___clrcall] = ACTIONS(3089),
    [anon_sym___stdcall] = ACTIONS(3089),
    [anon_sym___fastcall] = ACTIONS(3089),
    [anon_sym___thiscall] = ACTIONS(3089),
    [anon_sym___vectorcall] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_RBRACE] = ACTIONS(3091),
    [anon_sym_signed] = ACTIONS(3089),
    [anon_sym_unsigned] = ACTIONS(3089),
    [anon_sym_long] = ACTIONS(3089),
    [anon_sym_short] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3089),
    [anon_sym_register] = ACTIONS(3089),
    [anon_sym_inline] = ACTIONS(3089),
    [anon_sym___inline] = ACTIONS(3089),
    [anon_sym___inline__] = ACTIONS(3089),
    [anon_sym___forceinline] = ACTIONS(3089),
    [anon_sym_thread_local] = ACTIONS(3089),
    [anon_sym___thread] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_constexpr] = ACTIONS(3089),
    [anon_sym_volatile] = ACTIONS(3089),
    [anon_sym_restrict] = ACTIONS(3089),
    [anon_sym___restrict__] = ACTIONS(3089),
    [anon_sym__Atomic] = ACTIONS(3089),
    [anon_sym__Noreturn] = ACTIONS(3089),
    [anon_sym_noreturn] = ACTIONS(3089),
    [anon_sym__Nonnull] = ACTIONS(3089),
    [anon_sym_mutable] = ACTIONS(3089),
    [anon_sym_constinit] = ACTIONS(3089),
    [anon_sym_consteval] = ACTIONS(3089),
    [anon_sym_alignas] = ACTIONS(3089),
    [anon_sym__Alignas] = ACTIONS(3089),
    [sym_primitive_type] = ACTIONS(3089),
    [anon_sym_enum] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_union] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_switch] = ACTIONS(3089),
    [anon_sym_case] = ACTIONS(3089),
    [anon_sym_default] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [anon_sym_do] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_break] = ACTIONS(3089),
    [anon_sym_continue] = ACTIONS(3089),
    [anon_sym_goto] = ACTIONS(3089),
    [anon_sym___try] = ACTIONS(3089),
    [anon_sym___leave] = ACTIONS(3089),
    [anon_sym_not] = ACTIONS(3089),
    [anon_sym_compl] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_sizeof] = ACTIONS(3089),
    [anon_sym___alignof__] = ACTIONS(3089),
    [anon_sym___alignof] = ACTIONS(3089),
    [anon_sym__alignof] = ACTIONS(3089),
    [anon_sym_alignof] = ACTIONS(3089),
    [anon_sym__Alignof] = ACTIONS(3089),
    [anon_sym_offsetof] = ACTIONS(3089),
    [anon_sym__Generic] = ACTIONS(3089),
    [anon_sym_asm] = ACTIONS(3089),
    [anon_sym___asm__] = ACTIONS(3089),
    [anon_sym___asm] = ACTIONS(3089),
    [sym_number_literal] = ACTIONS(3091),
    [anon_sym_L_SQUOTE] = ACTIONS(3091),
    [anon_sym_u_SQUOTE] = ACTIONS(3091),
    [anon_sym_U_SQUOTE] = ACTIONS(3091),
    [anon_sym_u8_SQUOTE] = ACTIONS(3091),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [anon_sym_L_DQUOTE] = ACTIONS(3091),
    [anon_sym_u_DQUOTE] = ACTIONS(3091),
    [anon_sym_U_DQUOTE] = ACTIONS(3091),
    [anon_sym_u8_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [sym_true] = ACTIONS(3089),
    [sym_false] = ACTIONS(3089),
    [anon_sym_NULL] = ACTIONS(3089),
    [anon_sym_nullptr] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3089),
    [anon_sym_decltype] = ACTIONS(3089),
    [anon_sym_explicit] = ACTIONS(3089),
    [anon_sym_typename] = ACTIONS(3089),
    [anon_sym_template] = ACTIONS(3089),
    [anon_sym_operator] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_delete] = ACTIONS(3089),
    [anon_sym_throw] = ACTIONS(3089),
    [anon_sym_namespace] = ACTIONS(3089),
    [anon_sym_static_assert] = ACTIONS(3089),
    [anon_sym_concept] = ACTIONS(3089),
    [anon_sym_co_return] = ACTIONS(3089),
    [anon_sym_co_yield] = ACTIONS(3089),
    [anon_sym_R_DQUOTE] = ACTIONS(3091),
    [anon_sym_LR_DQUOTE] = ACTIONS(3091),
    [anon_sym_uR_DQUOTE] = ACTIONS(3091),
    [anon_sym_UR_DQUOTE] = ACTIONS(3091),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3091),
    [anon_sym_co_await] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3089),
    [anon_sym_requires] = ACTIONS(3089),
    [sym_this] = ACTIONS(3089),
  },
  [763] = {
    [sym_identifier] = ACTIONS(3093),
    [aux_sym_preproc_include_token1] = ACTIONS(3093),
    [aux_sym_preproc_def_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token1] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3093),
    [sym_preproc_directive] = ACTIONS(3093),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym___extension__] = ACTIONS(3093),
    [anon_sym_typedef] = ACTIONS(3093),
    [anon_sym_virtual] = ACTIONS(3093),
    [anon_sym_extern] = ACTIONS(3093),
    [anon_sym___attribute__] = ACTIONS(3093),
    [anon_sym___attribute] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_COLON_COLON] = ACTIONS(3095),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3095),
    [anon_sym___declspec] = ACTIONS(3093),
    [anon_sym___based] = ACTIONS(3093),
    [anon_sym___cdecl] = ACTIONS(3093),
    [anon_sym___clrcall] = ACTIONS(3093),
    [anon_sym___stdcall] = ACTIONS(3093),
    [anon_sym___fastcall] = ACTIONS(3093),
    [anon_sym___thiscall] = ACTIONS(3093),
    [anon_sym___vectorcall] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_signed] = ACTIONS(3093),
    [anon_sym_unsigned] = ACTIONS(3093),
    [anon_sym_long] = ACTIONS(3093),
    [anon_sym_short] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3093),
    [anon_sym_register] = ACTIONS(3093),
    [anon_sym_inline] = ACTIONS(3093),
    [anon_sym___inline] = ACTIONS(3093),
    [anon_sym___inline__] = ACTIONS(3093),
    [anon_sym___forceinline] = ACTIONS(3093),
    [anon_sym_thread_local] = ACTIONS(3093),
    [anon_sym___thread] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_constexpr] = ACTIONS(3093),
    [anon_sym_volatile] = ACTIONS(3093),
    [anon_sym_restrict] = ACTIONS(3093),
    [anon_sym___restrict__] = ACTIONS(3093),
    [anon_sym__Atomic] = ACTIONS(3093),
    [anon_sym__Noreturn] = ACTIONS(3093),
    [anon_sym_noreturn] = ACTIONS(3093),
    [anon_sym__Nonnull] = ACTIONS(3093),
    [anon_sym_mutable] = ACTIONS(3093),
    [anon_sym_constinit] = ACTIONS(3093),
    [anon_sym_consteval] = ACTIONS(3093),
    [anon_sym_alignas] = ACTIONS(3093),
    [anon_sym__Alignas] = ACTIONS(3093),
    [sym_primitive_type] = ACTIONS(3093),
    [anon_sym_enum] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_union] = ACTIONS(3093),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_switch] = ACTIONS(3093),
    [anon_sym_case] = ACTIONS(3093),
    [anon_sym_default] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [anon_sym_do] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_break] = ACTIONS(3093),
    [anon_sym_continue] = ACTIONS(3093),
    [anon_sym_goto] = ACTIONS(3093),
    [anon_sym___try] = ACTIONS(3093),
    [anon_sym___leave] = ACTIONS(3093),
    [anon_sym_not] = ACTIONS(3093),
    [anon_sym_compl] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3095),
    [anon_sym_sizeof] = ACTIONS(3093),
    [anon_sym___alignof__] = ACTIONS(3093),
    [anon_sym___alignof] = ACTIONS(3093),
    [anon_sym__alignof] = ACTIONS(3093),
    [anon_sym_alignof] = ACTIONS(3093),
    [anon_sym__Alignof] = ACTIONS(3093),
    [anon_sym_offsetof] = ACTIONS(3093),
    [anon_sym__Generic] = ACTIONS(3093),
    [anon_sym_asm] = ACTIONS(3093),
    [anon_sym___asm__] = ACTIONS(3093),
    [anon_sym___asm] = ACTIONS(3093),
    [sym_number_literal] = ACTIONS(3095),
    [anon_sym_L_SQUOTE] = ACTIONS(3095),
    [anon_sym_u_SQUOTE] = ACTIONS(3095),
    [anon_sym_U_SQUOTE] = ACTIONS(3095),
    [anon_sym_u8_SQUOTE] = ACTIONS(3095),
    [anon_sym_SQUOTE] = ACTIONS(3095),
    [anon_sym_L_DQUOTE] = ACTIONS(3095),
    [anon_sym_u_DQUOTE] = ACTIONS(3095),
    [anon_sym_U_DQUOTE] = ACTIONS(3095),
    [anon_sym_u8_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [sym_true] = ACTIONS(3093),
    [sym_false] = ACTIONS(3093),
    [anon_sym_NULL] = ACTIONS(3093),
    [anon_sym_nullptr] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3093),
    [anon_sym_decltype] = ACTIONS(3093),
    [anon_sym_explicit] = ACTIONS(3093),
    [anon_sym_typename] = ACTIONS(3093),
    [anon_sym_template] = ACTIONS(3093),
    [anon_sym_operator] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_delete] = ACTIONS(3093),
    [anon_sym_throw] = ACTIONS(3093),
    [anon_sym_namespace] = ACTIONS(3093),
    [anon_sym_static_assert] = ACTIONS(3093),
    [anon_sym_concept] = ACTIONS(3093),
    [anon_sym_co_return] = ACTIONS(3093),
    [anon_sym_co_yield] = ACTIONS(3093),
    [anon_sym_R_DQUOTE] = ACTIONS(3095),
    [anon_sym_LR_DQUOTE] = ACTIONS(3095),
    [anon_sym_uR_DQUOTE] = ACTIONS(3095),
    [anon_sym_UR_DQUOTE] = ACTIONS(3095),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3095),
    [anon_sym_co_await] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3093),
    [anon_sym_requires] = ACTIONS(3093),
    [sym_this] = ACTIONS(3093),
  },
  [764] = {
    [sym_identifier] = ACTIONS(3100),
    [aux_sym_preproc_include_token1] = ACTIONS(3100),
    [aux_sym_preproc_def_token1] = ACTIONS(3100),
    [aux_sym_preproc_if_token1] = ACTIONS(3100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3100),
    [sym_preproc_directive] = ACTIONS(3100),
    [anon_sym_LPAREN2] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_AMP_AMP] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym___extension__] = ACTIONS(3100),
    [anon_sym_typedef] = ACTIONS(3100),
    [anon_sym_virtual] = ACTIONS(3100),
    [anon_sym_extern] = ACTIONS(3100),
    [anon_sym___attribute__] = ACTIONS(3100),
    [anon_sym___attribute] = ACTIONS(3100),
    [anon_sym_using] = ACTIONS(3100),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3102),
    [anon_sym___declspec] = ACTIONS(3100),
    [anon_sym___based] = ACTIONS(3100),
    [anon_sym___cdecl] = ACTIONS(3100),
    [anon_sym___clrcall] = ACTIONS(3100),
    [anon_sym___stdcall] = ACTIONS(3100),
    [anon_sym___fastcall] = ACTIONS(3100),
    [anon_sym___thiscall] = ACTIONS(3100),
    [anon_sym___vectorcall] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_signed] = ACTIONS(3100),
    [anon_sym_unsigned] = ACTIONS(3100),
    [anon_sym_long] = ACTIONS(3100),
    [anon_sym_short] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3100),
    [anon_sym_inline] = ACTIONS(3100),
    [anon_sym___inline] = ACTIONS(3100),
    [anon_sym___inline__] = ACTIONS(3100),
    [anon_sym___forceinline] = ACTIONS(3100),
    [anon_sym_thread_local] = ACTIONS(3100),
    [anon_sym___thread] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_constexpr] = ACTIONS(3100),
    [anon_sym_volatile] = ACTIONS(3100),
    [anon_sym_restrict] = ACTIONS(3100),
    [anon_sym___restrict__] = ACTIONS(3100),
    [anon_sym__Atomic] = ACTIONS(3100),
    [anon_sym__Noreturn] = ACTIONS(3100),
    [anon_sym_noreturn] = ACTIONS(3100),
    [anon_sym__Nonnull] = ACTIONS(3100),
    [anon_sym_mutable] = ACTIONS(3100),
    [anon_sym_constinit] = ACTIONS(3100),
    [anon_sym_consteval] = ACTIONS(3100),
    [anon_sym_alignas] = ACTIONS(3100),
    [anon_sym__Alignas] = ACTIONS(3100),
    [sym_primitive_type] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_struct] = ACTIONS(3100),
    [anon_sym_union] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_goto] = ACTIONS(3100),
    [anon_sym___try] = ACTIONS(3100),
    [anon_sym___leave] = ACTIONS(3100),
    [anon_sym_not] = ACTIONS(3100),
    [anon_sym_compl] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_sizeof] = ACTIONS(3100),
    [anon_sym___alignof__] = ACTIONS(3100),
    [anon_sym___alignof] = ACTIONS(3100),
    [anon_sym__alignof] = ACTIONS(3100),
    [anon_sym_alignof] = ACTIONS(3100),
    [anon_sym__Alignof] = ACTIONS(3100),
    [anon_sym_offsetof] = ACTIONS(3100),
    [anon_sym__Generic] = ACTIONS(3100),
    [anon_sym_asm] = ACTIONS(3100),
    [anon_sym___asm__] = ACTIONS(3100),
    [anon_sym___asm] = ACTIONS(3100),
    [sym_number_literal] = ACTIONS(3102),
    [anon_sym_L_SQUOTE] = ACTIONS(3102),
    [anon_sym_u_SQUOTE] = ACTIONS(3102),
    [anon_sym_U_SQUOTE] = ACTIONS(3102),
    [anon_sym_u8_SQUOTE] = ACTIONS(3102),
    [anon_sym_SQUOTE] = ACTIONS(3102),
    [anon_sym_L_DQUOTE] = ACTIONS(3102),
    [anon_sym_u_DQUOTE] = ACTIONS(3102),
    [anon_sym_U_DQUOTE] = ACTIONS(3102),
    [anon_sym_u8_DQUOTE] = ACTIONS(3102),
    [anon_sym_DQUOTE] = ACTIONS(3102),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [anon_sym_NULL] = ACTIONS(3100),
    [anon_sym_nullptr] = ACTIONS(3100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3100),
    [anon_sym_decltype] = ACTIONS(3100),
    [anon_sym_explicit] = ACTIONS(3100),
    [anon_sym_typename] = ACTIONS(3100),
    [anon_sym_template] = ACTIONS(3100),
    [anon_sym_operator] = ACTIONS(3100),
    [anon_sym_try] = ACTIONS(3100),
    [anon_sym_delete] = ACTIONS(3100),
    [anon_sym_throw] = ACTIONS(3100),
    [anon_sym_namespace] = ACTIONS(3100),
    [anon_sym_static_assert] = ACTIONS(3100),
    [anon_sym_concept] = ACTIONS(3100),
    [anon_sym_co_return] = ACTIONS(3100),
    [anon_sym_co_yield] = ACTIONS(3100),
    [anon_sym_R_DQUOTE] = ACTIONS(3102),
    [anon_sym_LR_DQUOTE] = ACTIONS(3102),
    [anon_sym_uR_DQUOTE] = ACTIONS(3102),
    [anon_sym_UR_DQUOTE] = ACTIONS(3102),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3102),
    [anon_sym_co_await] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_requires] = ACTIONS(3100),
    [sym_this] = ACTIONS(3100),
  },
  [765] = {
    [sym_identifier] = ACTIONS(2775),
    [aux_sym_preproc_include_token1] = ACTIONS(2775),
    [aux_sym_preproc_def_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token1] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2775),
    [sym_preproc_directive] = ACTIONS(2775),
    [anon_sym_LPAREN2] = ACTIONS(2777),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_TILDE] = ACTIONS(2777),
    [anon_sym_DASH] = ACTIONS(2775),
    [anon_sym_PLUS] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym___extension__] = ACTIONS(2775),
    [anon_sym_typedef] = ACTIONS(2775),
    [anon_sym_virtual] = ACTIONS(2775),
    [anon_sym_extern] = ACTIONS(2775),
    [anon_sym___attribute__] = ACTIONS(2775),
    [anon_sym___attribute] = ACTIONS(2775),
    [anon_sym_using] = ACTIONS(2775),
    [anon_sym_COLON_COLON] = ACTIONS(2777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2777),
    [anon_sym___declspec] = ACTIONS(2775),
    [anon_sym___based] = ACTIONS(2775),
    [anon_sym___cdecl] = ACTIONS(2775),
    [anon_sym___clrcall] = ACTIONS(2775),
    [anon_sym___stdcall] = ACTIONS(2775),
    [anon_sym___fastcall] = ACTIONS(2775),
    [anon_sym___thiscall] = ACTIONS(2775),
    [anon_sym___vectorcall] = ACTIONS(2775),
    [anon_sym_LBRACE] = ACTIONS(2777),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_signed] = ACTIONS(2775),
    [anon_sym_unsigned] = ACTIONS(2775),
    [anon_sym_long] = ACTIONS(2775),
    [anon_sym_short] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_static] = ACTIONS(2775),
    [anon_sym_register] = ACTIONS(2775),
    [anon_sym_inline] = ACTIONS(2775),
    [anon_sym___inline] = ACTIONS(2775),
    [anon_sym___inline__] = ACTIONS(2775),
    [anon_sym___forceinline] = ACTIONS(2775),
    [anon_sym_thread_local] = ACTIONS(2775),
    [anon_sym___thread] = ACTIONS(2775),
    [anon_sym_const] = ACTIONS(2775),
    [anon_sym_constexpr] = ACTIONS(2775),
    [anon_sym_volatile] = ACTIONS(2775),
    [anon_sym_restrict] = ACTIONS(2775),
    [anon_sym___restrict__] = ACTIONS(2775),
    [anon_sym__Atomic] = ACTIONS(2775),
    [anon_sym__Noreturn] = ACTIONS(2775),
    [anon_sym_noreturn] = ACTIONS(2775),
    [anon_sym__Nonnull] = ACTIONS(2775),
    [anon_sym_mutable] = ACTIONS(2775),
    [anon_sym_constinit] = ACTIONS(2775),
    [anon_sym_consteval] = ACTIONS(2775),
    [anon_sym_alignas] = ACTIONS(2775),
    [anon_sym__Alignas] = ACTIONS(2775),
    [sym_primitive_type] = ACTIONS(2775),
    [anon_sym_enum] = ACTIONS(2775),
    [anon_sym_class] = ACTIONS(2775),
    [anon_sym_struct] = ACTIONS(2775),
    [anon_sym_union] = ACTIONS(2775),
    [anon_sym_if] = ACTIONS(2775),
    [anon_sym_switch] = ACTIONS(2775),
    [anon_sym_case] = ACTIONS(2775),
    [anon_sym_default] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(2775),
    [anon_sym_do] = ACTIONS(2775),
    [anon_sym_for] = ACTIONS(2775),
    [anon_sym_return] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2775),
    [anon_sym_continue] = ACTIONS(2775),
    [anon_sym_goto] = ACTIONS(2775),
    [anon_sym___try] = ACTIONS(2775),
    [anon_sym___leave] = ACTIONS(2775),
    [anon_sym_not] = ACTIONS(2775),
    [anon_sym_compl] = ACTIONS(2775),
    [anon_sym_DASH_DASH] = ACTIONS(2777),
    [anon_sym_PLUS_PLUS] = ACTIONS(2777),
    [anon_sym_sizeof] = ACTIONS(2775),
    [anon_sym___alignof__] = ACTIONS(2775),
    [anon_sym___alignof] = ACTIONS(2775),
    [anon_sym__alignof] = ACTIONS(2775),
    [anon_sym_alignof] = ACTIONS(2775),
    [anon_sym__Alignof] = ACTIONS(2775),
    [anon_sym_offsetof] = ACTIONS(2775),
    [anon_sym__Generic] = ACTIONS(2775),
    [anon_sym_asm] = ACTIONS(2775),
    [anon_sym___asm__] = ACTIONS(2775),
    [anon_sym___asm] = ACTIONS(2775),
    [sym_number_literal] = ACTIONS(2777),
    [anon_sym_L_SQUOTE] = ACTIONS(2777),
    [anon_sym_u_SQUOTE] = ACTIONS(2777),
    [anon_sym_U_SQUOTE] = ACTIONS(2777),
    [anon_sym_u8_SQUOTE] = ACTIONS(2777),
    [anon_sym_SQUOTE] = ACTIONS(2777),
    [anon_sym_L_DQUOTE] = ACTIONS(2777),
    [anon_sym_u_DQUOTE] = ACTIONS(2777),
    [anon_sym_U_DQUOTE] = ACTIONS(2777),
    [anon_sym_u8_DQUOTE] = ACTIONS(2777),
    [anon_sym_DQUOTE] = ACTIONS(2777),
    [sym_true] = ACTIONS(2775),
    [sym_false] = ACTIONS(2775),
    [anon_sym_NULL] = ACTIONS(2775),
    [anon_sym_nullptr] = ACTIONS(2775),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2775),
    [anon_sym_decltype] = ACTIONS(2775),
    [anon_sym_explicit] = ACTIONS(2775),
    [anon_sym_typename] = ACTIONS(2775),
    [anon_sym_template] = ACTIONS(2775),
    [anon_sym_operator] = ACTIONS(2775),
    [anon_sym_try] = ACTIONS(2775),
    [anon_sym_delete] = ACTIONS(2775),
    [anon_sym_throw] = ACTIONS(2775),
    [anon_sym_namespace] = ACTIONS(2775),
    [anon_sym_static_assert] = ACTIONS(2775),
    [anon_sym_concept] = ACTIONS(2775),
    [anon_sym_co_return] = ACTIONS(2775),
    [anon_sym_co_yield] = ACTIONS(2775),
    [anon_sym_R_DQUOTE] = ACTIONS(2777),
    [anon_sym_LR_DQUOTE] = ACTIONS(2777),
    [anon_sym_uR_DQUOTE] = ACTIONS(2777),
    [anon_sym_UR_DQUOTE] = ACTIONS(2777),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2777),
    [anon_sym_co_await] = ACTIONS(2775),
    [anon_sym_new] = ACTIONS(2775),
    [anon_sym_requires] = ACTIONS(2775),
    [sym_this] = ACTIONS(2775),
  },
  [766] = {
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_include_token1] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym___attribute] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym___cdecl] = ACTIONS(2779),
    [anon_sym___clrcall] = ACTIONS(2779),
    [anon_sym___stdcall] = ACTIONS(2779),
    [anon_sym___fastcall] = ACTIONS(2779),
    [anon_sym___thiscall] = ACTIONS(2779),
    [anon_sym___vectorcall] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym__Nonnull] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym__Alignas] = ACTIONS(2779),
    [sym_primitive_type] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_switch] = ACTIONS(2779),
    [anon_sym_case] = ACTIONS(2779),
    [anon_sym_default] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [anon_sym_do] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2779),
    [anon_sym_continue] = ACTIONS(2779),
    [anon_sym_goto] = ACTIONS(2779),
    [anon_sym___try] = ACTIONS(2779),
    [anon_sym___leave] = ACTIONS(2779),
    [anon_sym_not] = ACTIONS(2779),
    [anon_sym_compl] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2781),
    [anon_sym_sizeof] = ACTIONS(2779),
    [anon_sym___alignof__] = ACTIONS(2779),
    [anon_sym___alignof] = ACTIONS(2779),
    [anon_sym__alignof] = ACTIONS(2779),
    [anon_sym_alignof] = ACTIONS(2779),
    [anon_sym__Alignof] = ACTIONS(2779),
    [anon_sym_offsetof] = ACTIONS(2779),
    [anon_sym__Generic] = ACTIONS(2779),
    [anon_sym_asm] = ACTIONS(2779),
    [anon_sym___asm__] = ACTIONS(2779),
    [anon_sym___asm] = ACTIONS(2779),
    [sym_number_literal] = ACTIONS(2781),
    [anon_sym_L_SQUOTE] = ACTIONS(2781),
    [anon_sym_u_SQUOTE] = ACTIONS(2781),
    [anon_sym_U_SQUOTE] = ACTIONS(2781),
    [anon_sym_u8_SQUOTE] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_L_DQUOTE] = ACTIONS(2781),
    [anon_sym_u_DQUOTE] = ACTIONS(2781),
    [anon_sym_U_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8_DQUOTE] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2781),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [anon_sym_NULL] = ACTIONS(2779),
    [anon_sym_nullptr] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_delete] = ACTIONS(2779),
    [anon_sym_throw] = ACTIONS(2779),
    [anon_sym_namespace] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
    [anon_sym_concept] = ACTIONS(2779),
    [anon_sym_co_return] = ACTIONS(2779),
    [anon_sym_co_yield] = ACTIONS(2779),
    [anon_sym_R_DQUOTE] = ACTIONS(2781),
    [anon_sym_LR_DQUOTE] = ACTIONS(2781),
    [anon_sym_uR_DQUOTE] = ACTIONS(2781),
    [anon_sym_UR_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2781),
    [anon_sym_co_await] = ACTIONS(2779),
    [anon_sym_new] = ACTIONS(2779),
    [anon_sym_requires] = ACTIONS(2779),
    [sym_this] = ACTIONS(2779),
  },
  [767] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_include_token1] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym___attribute] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym___cdecl] = ACTIONS(2783),
    [anon_sym___clrcall] = ACTIONS(2783),
    [anon_sym___stdcall] = ACTIONS(2783),
    [anon_sym___fastcall] = ACTIONS(2783),
    [anon_sym___thiscall] = ACTIONS(2783),
    [anon_sym___vectorcall] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym__Nonnull] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym__Alignas] = ACTIONS(2783),
    [sym_primitive_type] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_switch] = ACTIONS(2783),
    [anon_sym_case] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_goto] = ACTIONS(2783),
    [anon_sym___try] = ACTIONS(2783),
    [anon_sym___leave] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_compl] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_sizeof] = ACTIONS(2783),
    [anon_sym___alignof__] = ACTIONS(2783),
    [anon_sym___alignof] = ACTIONS(2783),
    [anon_sym__alignof] = ACTIONS(2783),
    [anon_sym_alignof] = ACTIONS(2783),
    [anon_sym__Alignof] = ACTIONS(2783),
    [anon_sym_offsetof] = ACTIONS(2783),
    [anon_sym__Generic] = ACTIONS(2783),
    [anon_sym_asm] = ACTIONS(2783),
    [anon_sym___asm__] = ACTIONS(2783),
    [anon_sym___asm] = ACTIONS(2783),
    [sym_number_literal] = ACTIONS(2785),
    [anon_sym_L_SQUOTE] = ACTIONS(2785),
    [anon_sym_u_SQUOTE] = ACTIONS(2785),
    [anon_sym_U_SQUOTE] = ACTIONS(2785),
    [anon_sym_u8_SQUOTE] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_L_DQUOTE] = ACTIONS(2785),
    [anon_sym_u_DQUOTE] = ACTIONS(2785),
    [anon_sym_U_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [anon_sym_NULL] = ACTIONS(2783),
    [anon_sym_nullptr] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_throw] = ACTIONS(2783),
    [anon_sym_namespace] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
    [anon_sym_concept] = ACTIONS(2783),
    [anon_sym_co_return] = ACTIONS(2783),
    [anon_sym_co_yield] = ACTIONS(2783),
    [anon_sym_R_DQUOTE] = ACTIONS(2785),
    [anon_sym_LR_DQUOTE] = ACTIONS(2785),
    [anon_sym_uR_DQUOTE] = ACTIONS(2785),
    [anon_sym_UR_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2785),
    [anon_sym_co_await] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_requires] = ACTIONS(2783),
    [sym_this] = ACTIONS(2783),
  },
  [768] = {
    [sym_identifier] = ACTIONS(2787),
    [aux_sym_preproc_include_token1] = ACTIONS(2787),
    [aux_sym_preproc_def_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token1] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2787),
    [sym_preproc_directive] = ACTIONS(2787),
    [anon_sym_LPAREN2] = ACTIONS(2789),
    [anon_sym_BANG] = ACTIONS(2789),
    [anon_sym_TILDE] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym___extension__] = ACTIONS(2787),
    [anon_sym_typedef] = ACTIONS(2787),
    [anon_sym_virtual] = ACTIONS(2787),
    [anon_sym_extern] = ACTIONS(2787),
    [anon_sym___attribute__] = ACTIONS(2787),
    [anon_sym___attribute] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2789),
    [anon_sym___declspec] = ACTIONS(2787),
    [anon_sym___based] = ACTIONS(2787),
    [anon_sym___cdecl] = ACTIONS(2787),
    [anon_sym___clrcall] = ACTIONS(2787),
    [anon_sym___stdcall] = ACTIONS(2787),
    [anon_sym___fastcall] = ACTIONS(2787),
    [anon_sym___thiscall] = ACTIONS(2787),
    [anon_sym___vectorcall] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_signed] = ACTIONS(2787),
    [anon_sym_unsigned] = ACTIONS(2787),
    [anon_sym_long] = ACTIONS(2787),
    [anon_sym_short] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_static] = ACTIONS(2787),
    [anon_sym_register] = ACTIONS(2787),
    [anon_sym_inline] = ACTIONS(2787),
    [anon_sym___inline] = ACTIONS(2787),
    [anon_sym___inline__] = ACTIONS(2787),
    [anon_sym___forceinline] = ACTIONS(2787),
    [anon_sym_thread_local] = ACTIONS(2787),
    [anon_sym___thread] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_constexpr] = ACTIONS(2787),
    [anon_sym_volatile] = ACTIONS(2787),
    [anon_sym_restrict] = ACTIONS(2787),
    [anon_sym___restrict__] = ACTIONS(2787),
    [anon_sym__Atomic] = ACTIONS(2787),
    [anon_sym__Noreturn] = ACTIONS(2787),
    [anon_sym_noreturn] = ACTIONS(2787),
    [anon_sym__Nonnull] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_constinit] = ACTIONS(2787),
    [anon_sym_consteval] = ACTIONS(2787),
    [anon_sym_alignas] = ACTIONS(2787),
    [anon_sym__Alignas] = ACTIONS(2787),
    [sym_primitive_type] = ACTIONS(2787),
    [anon_sym_enum] = ACTIONS(2787),
    [anon_sym_class] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_union] = ACTIONS(2787),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_switch] = ACTIONS(2787),
    [anon_sym_case] = ACTIONS(2787),
    [anon_sym_default] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [anon_sym_do] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_break] = ACTIONS(2787),
    [anon_sym_continue] = ACTIONS(2787),
    [anon_sym_goto] = ACTIONS(2787),
    [anon_sym___try] = ACTIONS(2787),
    [anon_sym___leave] = ACTIONS(2787),
    [anon_sym_not] = ACTIONS(2787),
    [anon_sym_compl] = ACTIONS(2787),
    [anon_sym_DASH_DASH] = ACTIONS(2789),
    [anon_sym_PLUS_PLUS] = ACTIONS(2789),
    [anon_sym_sizeof] = ACTIONS(2787),
    [anon_sym___alignof__] = ACTIONS(2787),
    [anon_sym___alignof] = ACTIONS(2787),
    [anon_sym__alignof] = ACTIONS(2787),
    [anon_sym_alignof] = ACTIONS(2787),
    [anon_sym__Alignof] = ACTIONS(2787),
    [anon_sym_offsetof] = ACTIONS(2787),
    [anon_sym__Generic] = ACTIONS(2787),
    [anon_sym_asm] = ACTIONS(2787),
    [anon_sym___asm__] = ACTIONS(2787),
    [anon_sym___asm] = ACTIONS(2787),
    [sym_number_literal] = ACTIONS(2789),
    [anon_sym_L_SQUOTE] = ACTIONS(2789),
    [anon_sym_u_SQUOTE] = ACTIONS(2789),
    [anon_sym_U_SQUOTE] = ACTIONS(2789),
    [anon_sym_u8_SQUOTE] = ACTIONS(2789),
    [anon_sym_SQUOTE] = ACTIONS(2789),
    [anon_sym_L_DQUOTE] = ACTIONS(2789),
    [anon_sym_u_DQUOTE] = ACTIONS(2789),
    [anon_sym_U_DQUOTE] = ACTIONS(2789),
    [anon_sym_u8_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE] = ACTIONS(2789),
    [sym_true] = ACTIONS(2787),
    [sym_false] = ACTIONS(2787),
    [anon_sym_NULL] = ACTIONS(2787),
    [anon_sym_nullptr] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2787),
    [anon_sym_decltype] = ACTIONS(2787),
    [anon_sym_explicit] = ACTIONS(2787),
    [anon_sym_typename] = ACTIONS(2787),
    [anon_sym_template] = ACTIONS(2787),
    [anon_sym_operator] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_delete] = ACTIONS(2787),
    [anon_sym_throw] = ACTIONS(2787),
    [anon_sym_namespace] = ACTIONS(2787),
    [anon_sym_static_assert] = ACTIONS(2787),
    [anon_sym_concept] = ACTIONS(2787),
    [anon_sym_co_return] = ACTIONS(2787),
    [anon_sym_co_yield] = ACTIONS(2787),
    [anon_sym_R_DQUOTE] = ACTIONS(2789),
    [anon_sym_LR_DQUOTE] = ACTIONS(2789),
    [anon_sym_uR_DQUOTE] = ACTIONS(2789),
    [anon_sym_UR_DQUOTE] = ACTIONS(2789),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2789),
    [anon_sym_co_await] = ACTIONS(2787),
    [anon_sym_new] = ACTIONS(2787),
    [anon_sym_requires] = ACTIONS(2787),
    [sym_this] = ACTIONS(2787),
  },
  [769] = {
    [sym_identifier] = ACTIONS(2791),
    [aux_sym_preproc_include_token1] = ACTIONS(2791),
    [aux_sym_preproc_def_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token1] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2791),
    [sym_preproc_directive] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2793),
    [anon_sym_BANG] = ACTIONS(2793),
    [anon_sym_TILDE] = ACTIONS(2793),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym___extension__] = ACTIONS(2791),
    [anon_sym_typedef] = ACTIONS(2791),
    [anon_sym_virtual] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym___attribute__] = ACTIONS(2791),
    [anon_sym___attribute] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2793),
    [anon_sym___declspec] = ACTIONS(2791),
    [anon_sym___based] = ACTIONS(2791),
    [anon_sym___cdecl] = ACTIONS(2791),
    [anon_sym___clrcall] = ACTIONS(2791),
    [anon_sym___stdcall] = ACTIONS(2791),
    [anon_sym___fastcall] = ACTIONS(2791),
    [anon_sym___thiscall] = ACTIONS(2791),
    [anon_sym___vectorcall] = ACTIONS(2791),
    [anon_sym_LBRACE] = ACTIONS(2793),
    [anon_sym_RBRACE] = ACTIONS(2793),
    [anon_sym_signed] = ACTIONS(2791),
    [anon_sym_unsigned] = ACTIONS(2791),
    [anon_sym_long] = ACTIONS(2791),
    [anon_sym_short] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_register] = ACTIONS(2791),
    [anon_sym_inline] = ACTIONS(2791),
    [anon_sym___inline] = ACTIONS(2791),
    [anon_sym___inline__] = ACTIONS(2791),
    [anon_sym___forceinline] = ACTIONS(2791),
    [anon_sym_thread_local] = ACTIONS(2791),
    [anon_sym___thread] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_constexpr] = ACTIONS(2791),
    [anon_sym_volatile] = ACTIONS(2791),
    [anon_sym_restrict] = ACTIONS(2791),
    [anon_sym___restrict__] = ACTIONS(2791),
    [anon_sym__Atomic] = ACTIONS(2791),
    [anon_sym__Noreturn] = ACTIONS(2791),
    [anon_sym_noreturn] = ACTIONS(2791),
    [anon_sym__Nonnull] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_constinit] = ACTIONS(2791),
    [anon_sym_consteval] = ACTIONS(2791),
    [anon_sym_alignas] = ACTIONS(2791),
    [anon_sym__Alignas] = ACTIONS(2791),
    [sym_primitive_type] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_class] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_switch] = ACTIONS(2791),
    [anon_sym_case] = ACTIONS(2791),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_break] = ACTIONS(2791),
    [anon_sym_continue] = ACTIONS(2791),
    [anon_sym_goto] = ACTIONS(2791),
    [anon_sym___try] = ACTIONS(2791),
    [anon_sym___leave] = ACTIONS(2791),
    [anon_sym_not] = ACTIONS(2791),
    [anon_sym_compl] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(2793),
    [anon_sym_PLUS_PLUS] = ACTIONS(2793),
    [anon_sym_sizeof] = ACTIONS(2791),
    [anon_sym___alignof__] = ACTIONS(2791),
    [anon_sym___alignof] = ACTIONS(2791),
    [anon_sym__alignof] = ACTIONS(2791),
    [anon_sym_alignof] = ACTIONS(2791),
    [anon_sym__Alignof] = ACTIONS(2791),
    [anon_sym_offsetof] = ACTIONS(2791),
    [anon_sym__Generic] = ACTIONS(2791),
    [anon_sym_asm] = ACTIONS(2791),
    [anon_sym___asm__] = ACTIONS(2791),
    [anon_sym___asm] = ACTIONS(2791),
    [sym_number_literal] = ACTIONS(2793),
    [anon_sym_L_SQUOTE] = ACTIONS(2793),
    [anon_sym_u_SQUOTE] = ACTIONS(2793),
    [anon_sym_U_SQUOTE] = ACTIONS(2793),
    [anon_sym_u8_SQUOTE] = ACTIONS(2793),
    [anon_sym_SQUOTE] = ACTIONS(2793),
    [anon_sym_L_DQUOTE] = ACTIONS(2793),
    [anon_sym_u_DQUOTE] = ACTIONS(2793),
    [anon_sym_U_DQUOTE] = ACTIONS(2793),
    [anon_sym_u8_DQUOTE] = ACTIONS(2793),
    [anon_sym_DQUOTE] = ACTIONS(2793),
    [sym_true] = ACTIONS(2791),
    [sym_false] = ACTIONS(2791),
    [anon_sym_NULL] = ACTIONS(2791),
    [anon_sym_nullptr] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2791),
    [anon_sym_decltype] = ACTIONS(2791),
    [anon_sym_explicit] = ACTIONS(2791),
    [anon_sym_typename] = ACTIONS(2791),
    [anon_sym_template] = ACTIONS(2791),
    [anon_sym_operator] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_delete] = ACTIONS(2791),
    [anon_sym_throw] = ACTIONS(2791),
    [anon_sym_namespace] = ACTIONS(2791),
    [anon_sym_static_assert] = ACTIONS(2791),
    [anon_sym_concept] = ACTIONS(2791),
    [anon_sym_co_return] = ACTIONS(2791),
    [anon_sym_co_yield] = ACTIONS(2791),
    [anon_sym_R_DQUOTE] = ACTIONS(2793),
    [anon_sym_LR_DQUOTE] = ACTIONS(2793),
    [anon_sym_uR_DQUOTE] = ACTIONS(2793),
    [anon_sym_UR_DQUOTE] = ACTIONS(2793),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2793),
    [anon_sym_co_await] = ACTIONS(2791),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_requires] = ACTIONS(2791),
    [sym_this] = ACTIONS(2791),
  },
  [770] = {
    [sym_identifier] = ACTIONS(2839),
    [aux_sym_preproc_include_token1] = ACTIONS(2839),
    [aux_sym_preproc_def_token1] = ACTIONS(2839),
    [aux_sym_preproc_if_token1] = ACTIONS(2839),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2839),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2839),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_AMP_AMP] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_SEMI] = ACTIONS(2841),
    [anon_sym___extension__] = ACTIONS(2839),
    [anon_sym_typedef] = ACTIONS(2839),
    [anon_sym_virtual] = ACTIONS(2839),
    [anon_sym_extern] = ACTIONS(2839),
    [anon_sym___attribute__] = ACTIONS(2839),
    [anon_sym___attribute] = ACTIONS(2839),
    [anon_sym_using] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2841),
    [anon_sym___declspec] = ACTIONS(2839),
    [anon_sym___based] = ACTIONS(2839),
    [anon_sym___cdecl] = ACTIONS(2839),
    [anon_sym___clrcall] = ACTIONS(2839),
    [anon_sym___stdcall] = ACTIONS(2839),
    [anon_sym___fastcall] = ACTIONS(2839),
    [anon_sym___thiscall] = ACTIONS(2839),
    [anon_sym___vectorcall] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2841),
    [anon_sym_RBRACE] = ACTIONS(2841),
    [anon_sym_signed] = ACTIONS(2839),
    [anon_sym_unsigned] = ACTIONS(2839),
    [anon_sym_long] = ACTIONS(2839),
    [anon_sym_short] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_static] = ACTIONS(2839),
    [anon_sym_register] = ACTIONS(2839),
    [anon_sym_inline] = ACTIONS(2839),
    [anon_sym___inline] = ACTIONS(2839),
    [anon_sym___inline__] = ACTIONS(2839),
    [anon_sym___forceinline] = ACTIONS(2839),
    [anon_sym_thread_local] = ACTIONS(2839),
    [anon_sym___thread] = ACTIONS(2839),
    [anon_sym_const] = ACTIONS(2839),
    [anon_sym_constexpr] = ACTIONS(2839),
    [anon_sym_volatile] = ACTIONS(2839),
    [anon_sym_restrict] = ACTIONS(2839),
    [anon_sym___restrict__] = ACTIONS(2839),
    [anon_sym__Atomic] = ACTIONS(2839),
    [anon_sym__Noreturn] = ACTIONS(2839),
    [anon_sym_noreturn] = ACTIONS(2839),
    [anon_sym__Nonnull] = ACTIONS(2839),
    [anon_sym_mutable] = ACTIONS(2839),
    [anon_sym_constinit] = ACTIONS(2839),
    [anon_sym_consteval] = ACTIONS(2839),
    [anon_sym_alignas] = ACTIONS(2839),
    [anon_sym__Alignas] = ACTIONS(2839),
    [sym_primitive_type] = ACTIONS(2839),
    [anon_sym_enum] = ACTIONS(2839),
    [anon_sym_class] = ACTIONS(2839),
    [anon_sym_struct] = ACTIONS(2839),
    [anon_sym_union] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_switch] = ACTIONS(2839),
    [anon_sym_case] = ACTIONS(2839),
    [anon_sym_default] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_continue] = ACTIONS(2839),
    [anon_sym_goto] = ACTIONS(2839),
    [anon_sym___try] = ACTIONS(2839),
    [anon_sym___leave] = ACTIONS(2839),
    [anon_sym_not] = ACTIONS(2839),
    [anon_sym_compl] = ACTIONS(2839),
    [anon_sym_DASH_DASH] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2841),
    [anon_sym_sizeof] = ACTIONS(2839),
    [anon_sym___alignof__] = ACTIONS(2839),
    [anon_sym___alignof] = ACTIONS(2839),
    [anon_sym__alignof] = ACTIONS(2839),
    [anon_sym_alignof] = ACTIONS(2839),
    [anon_sym__Alignof] = ACTIONS(2839),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2839),
    [anon_sym_asm] = ACTIONS(2839),
    [anon_sym___asm__] = ACTIONS(2839),
    [anon_sym___asm] = ACTIONS(2839),
    [sym_number_literal] = ACTIONS(2841),
    [anon_sym_L_SQUOTE] = ACTIONS(2841),
    [anon_sym_u_SQUOTE] = ACTIONS(2841),
    [anon_sym_U_SQUOTE] = ACTIONS(2841),
    [anon_sym_u8_SQUOTE] = ACTIONS(2841),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_L_DQUOTE] = ACTIONS(2841),
    [anon_sym_u_DQUOTE] = ACTIONS(2841),
    [anon_sym_U_DQUOTE] = ACTIONS(2841),
    [anon_sym_u8_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE] = ACTIONS(2841),
    [sym_true] = ACTIONS(2839),
    [sym_false] = ACTIONS(2839),
    [anon_sym_NULL] = ACTIONS(2839),
    [anon_sym_nullptr] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2839),
    [anon_sym_decltype] = ACTIONS(2839),
    [anon_sym_explicit] = ACTIONS(2839),
    [anon_sym_typename] = ACTIONS(2839),
    [anon_sym_template] = ACTIONS(2839),
    [anon_sym_operator] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_delete] = ACTIONS(2839),
    [anon_sym_throw] = ACTIONS(2839),
    [anon_sym_namespace] = ACTIONS(2839),
    [anon_sym_static_assert] = ACTIONS(2839),
    [anon_sym_concept] = ACTIONS(2839),
    [anon_sym_co_return] = ACTIONS(2839),
    [anon_sym_co_yield] = ACTIONS(2839),
    [anon_sym_R_DQUOTE] = ACTIONS(2841),
    [anon_sym_LR_DQUOTE] = ACTIONS(2841),
    [anon_sym_uR_DQUOTE] = ACTIONS(2841),
    [anon_sym_UR_DQUOTE] = ACTIONS(2841),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2841),
    [anon_sym_co_await] = ACTIONS(2839),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_requires] = ACTIONS(2839),
    [sym_this] = ACTIONS(2839),
  },
  [771] = {
    [sym_identifier] = ACTIONS(2795),
    [aux_sym_preproc_include_token1] = ACTIONS(2795),
    [aux_sym_preproc_def_token1] = ACTIONS(2795),
    [aux_sym_preproc_if_token1] = ACTIONS(2795),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2795),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2795),
    [sym_preproc_directive] = ACTIONS(2795),
    [anon_sym_LPAREN2] = ACTIONS(2797),
    [anon_sym_BANG] = ACTIONS(2797),
    [anon_sym_TILDE] = ACTIONS(2797),
    [anon_sym_DASH] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_AMP_AMP] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_SEMI] = ACTIONS(2797),
    [anon_sym___extension__] = ACTIONS(2795),
    [anon_sym_typedef] = ACTIONS(2795),
    [anon_sym_virtual] = ACTIONS(2795),
    [anon_sym_extern] = ACTIONS(2795),
    [anon_sym___attribute__] = ACTIONS(2795),
    [anon_sym___attribute] = ACTIONS(2795),
    [anon_sym_using] = ACTIONS(2795),
    [anon_sym_COLON_COLON] = ACTIONS(2797),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2797),
    [anon_sym___declspec] = ACTIONS(2795),
    [anon_sym___based] = ACTIONS(2795),
    [anon_sym___cdecl] = ACTIONS(2795),
    [anon_sym___clrcall] = ACTIONS(2795),
    [anon_sym___stdcall] = ACTIONS(2795),
    [anon_sym___fastcall] = ACTIONS(2795),
    [anon_sym___thiscall] = ACTIONS(2795),
    [anon_sym___vectorcall] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2797),
    [anon_sym_RBRACE] = ACTIONS(2797),
    [anon_sym_signed] = ACTIONS(2795),
    [anon_sym_unsigned] = ACTIONS(2795),
    [anon_sym_long] = ACTIONS(2795),
    [anon_sym_short] = ACTIONS(2795),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_static] = ACTIONS(2795),
    [anon_sym_register] = ACTIONS(2795),
    [anon_sym_inline] = ACTIONS(2795),
    [anon_sym___inline] = ACTIONS(2795),
    [anon_sym___inline__] = ACTIONS(2795),
    [anon_sym___forceinline] = ACTIONS(2795),
    [anon_sym_thread_local] = ACTIONS(2795),
    [anon_sym___thread] = ACTIONS(2795),
    [anon_sym_const] = ACTIONS(2795),
    [anon_sym_constexpr] = ACTIONS(2795),
    [anon_sym_volatile] = ACTIONS(2795),
    [anon_sym_restrict] = ACTIONS(2795),
    [anon_sym___restrict__] = ACTIONS(2795),
    [anon_sym__Atomic] = ACTIONS(2795),
    [anon_sym__Noreturn] = ACTIONS(2795),
    [anon_sym_noreturn] = ACTIONS(2795),
    [anon_sym__Nonnull] = ACTIONS(2795),
    [anon_sym_mutable] = ACTIONS(2795),
    [anon_sym_constinit] = ACTIONS(2795),
    [anon_sym_consteval] = ACTIONS(2795),
    [anon_sym_alignas] = ACTIONS(2795),
    [anon_sym__Alignas] = ACTIONS(2795),
    [sym_primitive_type] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2795),
    [anon_sym_class] = ACTIONS(2795),
    [anon_sym_struct] = ACTIONS(2795),
    [anon_sym_union] = ACTIONS(2795),
    [anon_sym_if] = ACTIONS(2795),
    [anon_sym_switch] = ACTIONS(2795),
    [anon_sym_case] = ACTIONS(2795),
    [anon_sym_default] = ACTIONS(2795),
    [anon_sym_while] = ACTIONS(2795),
    [anon_sym_do] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2795),
    [anon_sym_return] = ACTIONS(2795),
    [anon_sym_break] = ACTIONS(2795),
    [anon_sym_continue] = ACTIONS(2795),
    [anon_sym_goto] = ACTIONS(2795),
    [anon_sym___try] = ACTIONS(2795),
    [anon_sym___leave] = ACTIONS(2795),
    [anon_sym_not] = ACTIONS(2795),
    [anon_sym_compl] = ACTIONS(2795),
    [anon_sym_DASH_DASH] = ACTIONS(2797),
    [anon_sym_PLUS_PLUS] = ACTIONS(2797),
    [anon_sym_sizeof] = ACTIONS(2795),
    [anon_sym___alignof__] = ACTIONS(2795),
    [anon_sym___alignof] = ACTIONS(2795),
    [anon_sym__alignof] = ACTIONS(2795),
    [anon_sym_alignof] = ACTIONS(2795),
    [anon_sym__Alignof] = ACTIONS(2795),
    [anon_sym_offsetof] = ACTIONS(2795),
    [anon_sym__Generic] = ACTIONS(2795),
    [anon_sym_asm] = ACTIONS(2795),
    [anon_sym___asm__] = ACTIONS(2795),
    [anon_sym___asm] = ACTIONS(2795),
    [sym_number_literal] = ACTIONS(2797),
    [anon_sym_L_SQUOTE] = ACTIONS(2797),
    [anon_sym_u_SQUOTE] = ACTIONS(2797),
    [anon_sym_U_SQUOTE] = ACTIONS(2797),
    [anon_sym_u8_SQUOTE] = ACTIONS(2797),
    [anon_sym_SQUOTE] = ACTIONS(2797),
    [anon_sym_L_DQUOTE] = ACTIONS(2797),
    [anon_sym_u_DQUOTE] = ACTIONS(2797),
    [anon_sym_U_DQUOTE] = ACTIONS(2797),
    [anon_sym_u8_DQUOTE] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(2797),
    [sym_true] = ACTIONS(2795),
    [sym_false] = ACTIONS(2795),
    [anon_sym_NULL] = ACTIONS(2795),
    [anon_sym_nullptr] = ACTIONS(2795),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2795),
    [anon_sym_decltype] = ACTIONS(2795),
    [anon_sym_explicit] = ACTIONS(2795),
    [anon_sym_typename] = ACTIONS(2795),
    [anon_sym_template] = ACTIONS(2795),
    [anon_sym_operator] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2795),
    [anon_sym_delete] = ACTIONS(2795),
    [anon_sym_throw] = ACTIONS(2795),
    [anon_sym_namespace] = ACTIONS(2795),
    [anon_sym_static_assert] = ACTIONS(2795),
    [anon_sym_concept] = ACTIONS(2795),
    [anon_sym_co_return] = ACTIONS(2795),
    [anon_sym_co_yield] = ACTIONS(2795),
    [anon_sym_R_DQUOTE] = ACTIONS(2797),
    [anon_sym_LR_DQUOTE] = ACTIONS(2797),
    [anon_sym_uR_DQUOTE] = ACTIONS(2797),
    [anon_sym_UR_DQUOTE] = ACTIONS(2797),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2797),
    [anon_sym_co_await] = ACTIONS(2795),
    [anon_sym_new] = ACTIONS(2795),
    [anon_sym_requires] = ACTIONS(2795),
    [sym_this] = ACTIONS(2795),
  },
  [772] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym___try] = ACTIONS(2799),
    [anon_sym___leave] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [773] = {
    [sym_identifier] = ACTIONS(2803),
    [aux_sym_preproc_include_token1] = ACTIONS(2803),
    [aux_sym_preproc_def_token1] = ACTIONS(2803),
    [aux_sym_preproc_if_token1] = ACTIONS(2803),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2803),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2803),
    [sym_preproc_directive] = ACTIONS(2803),
    [anon_sym_LPAREN2] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(2805),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2803),
    [anon_sym_PLUS] = ACTIONS(2803),
    [anon_sym_STAR] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2805),
    [anon_sym_AMP] = ACTIONS(2803),
    [anon_sym_SEMI] = ACTIONS(2805),
    [anon_sym___extension__] = ACTIONS(2803),
    [anon_sym_typedef] = ACTIONS(2803),
    [anon_sym_virtual] = ACTIONS(2803),
    [anon_sym_extern] = ACTIONS(2803),
    [anon_sym___attribute__] = ACTIONS(2803),
    [anon_sym___attribute] = ACTIONS(2803),
    [anon_sym_using] = ACTIONS(2803),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2805),
    [anon_sym___declspec] = ACTIONS(2803),
    [anon_sym___based] = ACTIONS(2803),
    [anon_sym___cdecl] = ACTIONS(2803),
    [anon_sym___clrcall] = ACTIONS(2803),
    [anon_sym___stdcall] = ACTIONS(2803),
    [anon_sym___fastcall] = ACTIONS(2803),
    [anon_sym___thiscall] = ACTIONS(2803),
    [anon_sym___vectorcall] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(2805),
    [anon_sym_signed] = ACTIONS(2803),
    [anon_sym_unsigned] = ACTIONS(2803),
    [anon_sym_long] = ACTIONS(2803),
    [anon_sym_short] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_static] = ACTIONS(2803),
    [anon_sym_register] = ACTIONS(2803),
    [anon_sym_inline] = ACTIONS(2803),
    [anon_sym___inline] = ACTIONS(2803),
    [anon_sym___inline__] = ACTIONS(2803),
    [anon_sym___forceinline] = ACTIONS(2803),
    [anon_sym_thread_local] = ACTIONS(2803),
    [anon_sym___thread] = ACTIONS(2803),
    [anon_sym_const] = ACTIONS(2803),
    [anon_sym_constexpr] = ACTIONS(2803),
    [anon_sym_volatile] = ACTIONS(2803),
    [anon_sym_restrict] = ACTIONS(2803),
    [anon_sym___restrict__] = ACTIONS(2803),
    [anon_sym__Atomic] = ACTIONS(2803),
    [anon_sym__Noreturn] = ACTIONS(2803),
    [anon_sym_noreturn] = ACTIONS(2803),
    [anon_sym__Nonnull] = ACTIONS(2803),
    [anon_sym_mutable] = ACTIONS(2803),
    [anon_sym_constinit] = ACTIONS(2803),
    [anon_sym_consteval] = ACTIONS(2803),
    [anon_sym_alignas] = ACTIONS(2803),
    [anon_sym__Alignas] = ACTIONS(2803),
    [sym_primitive_type] = ACTIONS(2803),
    [anon_sym_enum] = ACTIONS(2803),
    [anon_sym_class] = ACTIONS(2803),
    [anon_sym_struct] = ACTIONS(2803),
    [anon_sym_union] = ACTIONS(2803),
    [anon_sym_if] = ACTIONS(2803),
    [anon_sym_switch] = ACTIONS(2803),
    [anon_sym_case] = ACTIONS(2803),
    [anon_sym_default] = ACTIONS(2803),
    [anon_sym_while] = ACTIONS(2803),
    [anon_sym_do] = ACTIONS(2803),
    [anon_sym_for] = ACTIONS(2803),
    [anon_sym_return] = ACTIONS(2803),
    [anon_sym_break] = ACTIONS(2803),
    [anon_sym_continue] = ACTIONS(2803),
    [anon_sym_goto] = ACTIONS(2803),
    [anon_sym___try] = ACTIONS(2803),
    [anon_sym___leave] = ACTIONS(2803),
    [anon_sym_not] = ACTIONS(2803),
    [anon_sym_compl] = ACTIONS(2803),
    [anon_sym_DASH_DASH] = ACTIONS(2805),
    [anon_sym_PLUS_PLUS] = ACTIONS(2805),
    [anon_sym_sizeof] = ACTIONS(2803),
    [anon_sym___alignof__] = ACTIONS(2803),
    [anon_sym___alignof] = ACTIONS(2803),
    [anon_sym__alignof] = ACTIONS(2803),
    [anon_sym_alignof] = ACTIONS(2803),
    [anon_sym__Alignof] = ACTIONS(2803),
    [anon_sym_offsetof] = ACTIONS(2803),
    [anon_sym__Generic] = ACTIONS(2803),
    [anon_sym_asm] = ACTIONS(2803),
    [anon_sym___asm__] = ACTIONS(2803),
    [anon_sym___asm] = ACTIONS(2803),
    [sym_number_literal] = ACTIONS(2805),
    [anon_sym_L_SQUOTE] = ACTIONS(2805),
    [anon_sym_u_SQUOTE] = ACTIONS(2805),
    [anon_sym_U_SQUOTE] = ACTIONS(2805),
    [anon_sym_u8_SQUOTE] = ACTIONS(2805),
    [anon_sym_SQUOTE] = ACTIONS(2805),
    [anon_sym_L_DQUOTE] = ACTIONS(2805),
    [anon_sym_u_DQUOTE] = ACTIONS(2805),
    [anon_sym_U_DQUOTE] = ACTIONS(2805),
    [anon_sym_u8_DQUOTE] = ACTIONS(2805),
    [anon_sym_DQUOTE] = ACTIONS(2805),
    [sym_true] = ACTIONS(2803),
    [sym_false] = ACTIONS(2803),
    [anon_sym_NULL] = ACTIONS(2803),
    [anon_sym_nullptr] = ACTIONS(2803),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2803),
    [anon_sym_decltype] = ACTIONS(2803),
    [anon_sym_explicit] = ACTIONS(2803),
    [anon_sym_typename] = ACTIONS(2803),
    [anon_sym_template] = ACTIONS(2803),
    [anon_sym_operator] = ACTIONS(2803),
    [anon_sym_try] = ACTIONS(2803),
    [anon_sym_delete] = ACTIONS(2803),
    [anon_sym_throw] = ACTIONS(2803),
    [anon_sym_namespace] = ACTIONS(2803),
    [anon_sym_static_assert] = ACTIONS(2803),
    [anon_sym_concept] = ACTIONS(2803),
    [anon_sym_co_return] = ACTIONS(2803),
    [anon_sym_co_yield] = ACTIONS(2803),
    [anon_sym_R_DQUOTE] = ACTIONS(2805),
    [anon_sym_LR_DQUOTE] = ACTIONS(2805),
    [anon_sym_uR_DQUOTE] = ACTIONS(2805),
    [anon_sym_UR_DQUOTE] = ACTIONS(2805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2805),
    [anon_sym_co_await] = ACTIONS(2803),
    [anon_sym_new] = ACTIONS(2803),
    [anon_sym_requires] = ACTIONS(2803),
    [sym_this] = ACTIONS(2803),
  },
  [774] = {
    [sym_identifier] = ACTIONS(2807),
    [aux_sym_preproc_include_token1] = ACTIONS(2807),
    [aux_sym_preproc_def_token1] = ACTIONS(2807),
    [aux_sym_preproc_if_token1] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2807),
    [sym_preproc_directive] = ACTIONS(2807),
    [anon_sym_LPAREN2] = ACTIONS(2809),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_TILDE] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2807),
    [anon_sym_typedef] = ACTIONS(2807),
    [anon_sym_virtual] = ACTIONS(2807),
    [anon_sym_extern] = ACTIONS(2807),
    [anon_sym___attribute__] = ACTIONS(2807),
    [anon_sym___attribute] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2809),
    [anon_sym___declspec] = ACTIONS(2807),
    [anon_sym___based] = ACTIONS(2807),
    [anon_sym___cdecl] = ACTIONS(2807),
    [anon_sym___clrcall] = ACTIONS(2807),
    [anon_sym___stdcall] = ACTIONS(2807),
    [anon_sym___fastcall] = ACTIONS(2807),
    [anon_sym___thiscall] = ACTIONS(2807),
    [anon_sym___vectorcall] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2809),
    [anon_sym_RBRACE] = ACTIONS(2809),
    [anon_sym_signed] = ACTIONS(2807),
    [anon_sym_unsigned] = ACTIONS(2807),
    [anon_sym_long] = ACTIONS(2807),
    [anon_sym_short] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_static] = ACTIONS(2807),
    [anon_sym_register] = ACTIONS(2807),
    [anon_sym_inline] = ACTIONS(2807),
    [anon_sym___inline] = ACTIONS(2807),
    [anon_sym___inline__] = ACTIONS(2807),
    [anon_sym___forceinline] = ACTIONS(2807),
    [anon_sym_thread_local] = ACTIONS(2807),
    [anon_sym___thread] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_constexpr] = ACTIONS(2807),
    [anon_sym_volatile] = ACTIONS(2807),
    [anon_sym_restrict] = ACTIONS(2807),
    [anon_sym___restrict__] = ACTIONS(2807),
    [anon_sym__Atomic] = ACTIONS(2807),
    [anon_sym__Noreturn] = ACTIONS(2807),
    [anon_sym_noreturn] = ACTIONS(2807),
    [anon_sym__Nonnull] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_constinit] = ACTIONS(2807),
    [anon_sym_consteval] = ACTIONS(2807),
    [anon_sym_alignas] = ACTIONS(2807),
    [anon_sym__Alignas] = ACTIONS(2807),
    [sym_primitive_type] = ACTIONS(2807),
    [anon_sym_enum] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_union] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_switch] = ACTIONS(2807),
    [anon_sym_case] = ACTIONS(2807),
    [anon_sym_default] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_for] = ACTIONS(2807),
    [anon_sym_return] = ACTIONS(2807),
    [anon_sym_break] = ACTIONS(2807),
    [anon_sym_continue] = ACTIONS(2807),
    [anon_sym_goto] = ACTIONS(2807),
    [anon_sym___try] = ACTIONS(2807),
    [anon_sym___leave] = ACTIONS(2807),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2809),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2807),
    [anon_sym___alignof] = ACTIONS(2807),
    [anon_sym__alignof] = ACTIONS(2807),
    [anon_sym_alignof] = ACTIONS(2807),
    [anon_sym__Alignof] = ACTIONS(2807),
    [anon_sym_offsetof] = ACTIONS(2807),
    [anon_sym__Generic] = ACTIONS(2807),
    [anon_sym_asm] = ACTIONS(2807),
    [anon_sym___asm__] = ACTIONS(2807),
    [anon_sym___asm] = ACTIONS(2807),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2809),
    [anon_sym_u_SQUOTE] = ACTIONS(2809),
    [anon_sym_U_SQUOTE] = ACTIONS(2809),
    [anon_sym_u8_SQUOTE] = ACTIONS(2809),
    [anon_sym_SQUOTE] = ACTIONS(2809),
    [anon_sym_L_DQUOTE] = ACTIONS(2809),
    [anon_sym_u_DQUOTE] = ACTIONS(2809),
    [anon_sym_U_DQUOTE] = ACTIONS(2809),
    [anon_sym_u8_DQUOTE] = ACTIONS(2809),
    [anon_sym_DQUOTE] = ACTIONS(2809),
    [sym_true] = ACTIONS(2807),
    [sym_false] = ACTIONS(2807),
    [anon_sym_NULL] = ACTIONS(2807),
    [anon_sym_nullptr] = ACTIONS(2807),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2807),
    [anon_sym_decltype] = ACTIONS(2807),
    [anon_sym_explicit] = ACTIONS(2807),
    [anon_sym_typename] = ACTIONS(2807),
    [anon_sym_template] = ACTIONS(2807),
    [anon_sym_operator] = ACTIONS(2807),
    [anon_sym_try] = ACTIONS(2807),
    [anon_sym_delete] = ACTIONS(2807),
    [anon_sym_throw] = ACTIONS(2807),
    [anon_sym_namespace] = ACTIONS(2807),
    [anon_sym_static_assert] = ACTIONS(2807),
    [anon_sym_concept] = ACTIONS(2807),
    [anon_sym_co_return] = ACTIONS(2807),
    [anon_sym_co_yield] = ACTIONS(2807),
    [anon_sym_R_DQUOTE] = ACTIONS(2809),
    [anon_sym_LR_DQUOTE] = ACTIONS(2809),
    [anon_sym_uR_DQUOTE] = ACTIONS(2809),
    [anon_sym_UR_DQUOTE] = ACTIONS(2809),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2809),
    [anon_sym_co_await] = ACTIONS(2807),
    [anon_sym_new] = ACTIONS(2807),
    [anon_sym_requires] = ACTIONS(2807),
    [sym_this] = ACTIONS(2807),
  },
  [775] = {
    [sym_identifier] = ACTIONS(3319),
    [aux_sym_preproc_include_token1] = ACTIONS(3319),
    [aux_sym_preproc_def_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token1] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3319),
    [sym_preproc_directive] = ACTIONS(3319),
    [anon_sym_LPAREN2] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym___extension__] = ACTIONS(3319),
    [anon_sym_typedef] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym___attribute__] = ACTIONS(3319),
    [anon_sym___attribute] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_COLON_COLON] = ACTIONS(3321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3321),
    [anon_sym___declspec] = ACTIONS(3319),
    [anon_sym___based] = ACTIONS(3319),
    [anon_sym___cdecl] = ACTIONS(3319),
    [anon_sym___clrcall] = ACTIONS(3319),
    [anon_sym___stdcall] = ACTIONS(3319),
    [anon_sym___fastcall] = ACTIONS(3319),
    [anon_sym___thiscall] = ACTIONS(3319),
    [anon_sym___vectorcall] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_signed] = ACTIONS(3319),
    [anon_sym_unsigned] = ACTIONS(3319),
    [anon_sym_long] = ACTIONS(3319),
    [anon_sym_short] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_register] = ACTIONS(3319),
    [anon_sym_inline] = ACTIONS(3319),
    [anon_sym___inline] = ACTIONS(3319),
    [anon_sym___inline__] = ACTIONS(3319),
    [anon_sym___forceinline] = ACTIONS(3319),
    [anon_sym_thread_local] = ACTIONS(3319),
    [anon_sym___thread] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_constexpr] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_restrict] = ACTIONS(3319),
    [anon_sym___restrict__] = ACTIONS(3319),
    [anon_sym__Atomic] = ACTIONS(3319),
    [anon_sym__Noreturn] = ACTIONS(3319),
    [anon_sym_noreturn] = ACTIONS(3319),
    [anon_sym__Nonnull] = ACTIONS(3319),
    [anon_sym_mutable] = ACTIONS(3319),
    [anon_sym_constinit] = ACTIONS(3319),
    [anon_sym_consteval] = ACTIONS(3319),
    [anon_sym_alignas] = ACTIONS(3319),
    [anon_sym__Alignas] = ACTIONS(3319),
    [sym_primitive_type] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_union] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_case] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_goto] = ACTIONS(3319),
    [anon_sym___try] = ACTIONS(3319),
    [anon_sym___leave] = ACTIONS(3319),
    [anon_sym_not] = ACTIONS(3319),
    [anon_sym_compl] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_sizeof] = ACTIONS(3319),
    [anon_sym___alignof__] = ACTIONS(3319),
    [anon_sym___alignof] = ACTIONS(3319),
    [anon_sym__alignof] = ACTIONS(3319),
    [anon_sym_alignof] = ACTIONS(3319),
    [anon_sym__Alignof] = ACTIONS(3319),
    [anon_sym_offsetof] = ACTIONS(3319),
    [anon_sym__Generic] = ACTIONS(3319),
    [anon_sym_asm] = ACTIONS(3319),
    [anon_sym___asm__] = ACTIONS(3319),
    [anon_sym___asm] = ACTIONS(3319),
    [sym_number_literal] = ACTIONS(3321),
    [anon_sym_L_SQUOTE] = ACTIONS(3321),
    [anon_sym_u_SQUOTE] = ACTIONS(3321),
    [anon_sym_U_SQUOTE] = ACTIONS(3321),
    [anon_sym_u8_SQUOTE] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [anon_sym_L_DQUOTE] = ACTIONS(3321),
    [anon_sym_u_DQUOTE] = ACTIONS(3321),
    [anon_sym_U_DQUOTE] = ACTIONS(3321),
    [anon_sym_u8_DQUOTE] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [sym_true] = ACTIONS(3319),
    [sym_false] = ACTIONS(3319),
    [anon_sym_NULL] = ACTIONS(3319),
    [anon_sym_nullptr] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3319),
    [anon_sym_decltype] = ACTIONS(3319),
    [anon_sym_explicit] = ACTIONS(3319),
    [anon_sym_typename] = ACTIONS(3319),
    [anon_sym_template] = ACTIONS(3319),
    [anon_sym_operator] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_delete] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_static_assert] = ACTIONS(3319),
    [anon_sym_concept] = ACTIONS(3319),
    [anon_sym_co_return] = ACTIONS(3319),
    [anon_sym_co_yield] = ACTIONS(3319),
    [anon_sym_R_DQUOTE] = ACTIONS(3321),
    [anon_sym_LR_DQUOTE] = ACTIONS(3321),
    [anon_sym_uR_DQUOTE] = ACTIONS(3321),
    [anon_sym_UR_DQUOTE] = ACTIONS(3321),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3321),
    [anon_sym_co_await] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3319),
    [sym_this] = ACTIONS(3319),
  },
  [776] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_include_token1] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym___cdecl] = ACTIONS(3104),
    [anon_sym___clrcall] = ACTIONS(3104),
    [anon_sym___stdcall] = ACTIONS(3104),
    [anon_sym___fastcall] = ACTIONS(3104),
    [anon_sym___thiscall] = ACTIONS(3104),
    [anon_sym___vectorcall] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_RBRACE] = ACTIONS(3106),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym___try] = ACTIONS(3104),
    [anon_sym___leave] = ACTIONS(3104),
    [anon_sym_not] = ACTIONS(3104),
    [anon_sym_compl] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3106),
    [anon_sym_PLUS_PLUS] = ACTIONS(3106),
    [anon_sym_sizeof] = ACTIONS(3104),
    [anon_sym___alignof__] = ACTIONS(3104),
    [anon_sym___alignof] = ACTIONS(3104),
    [anon_sym__alignof] = ACTIONS(3104),
    [anon_sym_alignof] = ACTIONS(3104),
    [anon_sym__Alignof] = ACTIONS(3104),
    [anon_sym_offsetof] = ACTIONS(3104),
    [anon_sym__Generic] = ACTIONS(3104),
    [anon_sym_asm] = ACTIONS(3104),
    [anon_sym___asm__] = ACTIONS(3104),
    [anon_sym___asm] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3106),
    [anon_sym_L_SQUOTE] = ACTIONS(3106),
    [anon_sym_u_SQUOTE] = ACTIONS(3106),
    [anon_sym_U_SQUOTE] = ACTIONS(3106),
    [anon_sym_u8_SQUOTE] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3106),
    [anon_sym_L_DQUOTE] = ACTIONS(3106),
    [anon_sym_u_DQUOTE] = ACTIONS(3106),
    [anon_sym_U_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8_DQUOTE] = ACTIONS(3106),
    [anon_sym_DQUOTE] = ACTIONS(3106),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [anon_sym_NULL] = ACTIONS(3104),
    [anon_sym_nullptr] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_try] = ACTIONS(3104),
    [anon_sym_delete] = ACTIONS(3104),
    [anon_sym_throw] = ACTIONS(3104),
    [anon_sym_namespace] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
    [anon_sym_concept] = ACTIONS(3104),
    [anon_sym_co_return] = ACTIONS(3104),
    [anon_sym_co_yield] = ACTIONS(3104),
    [anon_sym_R_DQUOTE] = ACTIONS(3106),
    [anon_sym_LR_DQUOTE] = ACTIONS(3106),
    [anon_sym_uR_DQUOTE] = ACTIONS(3106),
    [anon_sym_UR_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3106),
    [anon_sym_co_await] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_requires] = ACTIONS(3104),
    [sym_this] = ACTIONS(3104),
  },
  [777] = {
    [sym_identifier] = ACTIONS(2811),
    [aux_sym_preproc_include_token1] = ACTIONS(2811),
    [aux_sym_preproc_def_token1] = ACTIONS(2811),
    [aux_sym_preproc_if_token1] = ACTIONS(2811),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2811),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2811),
    [sym_preproc_directive] = ACTIONS(2811),
    [anon_sym_LPAREN2] = ACTIONS(2813),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_TILDE] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym_SEMI] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2811),
    [anon_sym_typedef] = ACTIONS(2811),
    [anon_sym_virtual] = ACTIONS(2811),
    [anon_sym_extern] = ACTIONS(2811),
    [anon_sym___attribute__] = ACTIONS(2811),
    [anon_sym___attribute] = ACTIONS(2811),
    [anon_sym_using] = ACTIONS(2811),
    [anon_sym_COLON_COLON] = ACTIONS(2813),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2813),
    [anon_sym___declspec] = ACTIONS(2811),
    [anon_sym___based] = ACTIONS(2811),
    [anon_sym___cdecl] = ACTIONS(2811),
    [anon_sym___clrcall] = ACTIONS(2811),
    [anon_sym___stdcall] = ACTIONS(2811),
    [anon_sym___fastcall] = ACTIONS(2811),
    [anon_sym___thiscall] = ACTIONS(2811),
    [anon_sym___vectorcall] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2813),
    [anon_sym_RBRACE] = ACTIONS(2813),
    [anon_sym_signed] = ACTIONS(2811),
    [anon_sym_unsigned] = ACTIONS(2811),
    [anon_sym_long] = ACTIONS(2811),
    [anon_sym_short] = ACTIONS(2811),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_static] = ACTIONS(2811),
    [anon_sym_register] = ACTIONS(2811),
    [anon_sym_inline] = ACTIONS(2811),
    [anon_sym___inline] = ACTIONS(2811),
    [anon_sym___inline__] = ACTIONS(2811),
    [anon_sym___forceinline] = ACTIONS(2811),
    [anon_sym_thread_local] = ACTIONS(2811),
    [anon_sym___thread] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_constexpr] = ACTIONS(2811),
    [anon_sym_volatile] = ACTIONS(2811),
    [anon_sym_restrict] = ACTIONS(2811),
    [anon_sym___restrict__] = ACTIONS(2811),
    [anon_sym__Atomic] = ACTIONS(2811),
    [anon_sym__Noreturn] = ACTIONS(2811),
    [anon_sym_noreturn] = ACTIONS(2811),
    [anon_sym__Nonnull] = ACTIONS(2811),
    [anon_sym_mutable] = ACTIONS(2811),
    [anon_sym_constinit] = ACTIONS(2811),
    [anon_sym_consteval] = ACTIONS(2811),
    [anon_sym_alignas] = ACTIONS(2811),
    [anon_sym__Alignas] = ACTIONS(2811),
    [sym_primitive_type] = ACTIONS(2811),
    [anon_sym_enum] = ACTIONS(2811),
    [anon_sym_class] = ACTIONS(2811),
    [anon_sym_struct] = ACTIONS(2811),
    [anon_sym_union] = ACTIONS(2811),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_switch] = ACTIONS(2811),
    [anon_sym_case] = ACTIONS(2811),
    [anon_sym_default] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [anon_sym_do] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_break] = ACTIONS(2811),
    [anon_sym_continue] = ACTIONS(2811),
    [anon_sym_goto] = ACTIONS(2811),
    [anon_sym___try] = ACTIONS(2811),
    [anon_sym___leave] = ACTIONS(2811),
    [anon_sym_not] = ACTIONS(2811),
    [anon_sym_compl] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2813),
    [anon_sym_sizeof] = ACTIONS(2811),
    [anon_sym___alignof__] = ACTIONS(2811),
    [anon_sym___alignof] = ACTIONS(2811),
    [anon_sym__alignof] = ACTIONS(2811),
    [anon_sym_alignof] = ACTIONS(2811),
    [anon_sym__Alignof] = ACTIONS(2811),
    [anon_sym_offsetof] = ACTIONS(2811),
    [anon_sym__Generic] = ACTIONS(2811),
    [anon_sym_asm] = ACTIONS(2811),
    [anon_sym___asm__] = ACTIONS(2811),
    [anon_sym___asm] = ACTIONS(2811),
    [sym_number_literal] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2813),
    [anon_sym_u_SQUOTE] = ACTIONS(2813),
    [anon_sym_U_SQUOTE] = ACTIONS(2813),
    [anon_sym_u8_SQUOTE] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2813),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2811),
    [sym_false] = ACTIONS(2811),
    [anon_sym_NULL] = ACTIONS(2811),
    [anon_sym_nullptr] = ACTIONS(2811),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2811),
    [anon_sym_decltype] = ACTIONS(2811),
    [anon_sym_explicit] = ACTIONS(2811),
    [anon_sym_typename] = ACTIONS(2811),
    [anon_sym_template] = ACTIONS(2811),
    [anon_sym_operator] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_delete] = ACTIONS(2811),
    [anon_sym_throw] = ACTIONS(2811),
    [anon_sym_namespace] = ACTIONS(2811),
    [anon_sym_static_assert] = ACTIONS(2811),
    [anon_sym_concept] = ACTIONS(2811),
    [anon_sym_co_return] = ACTIONS(2811),
    [anon_sym_co_yield] = ACTIONS(2811),
    [anon_sym_R_DQUOTE] = ACTIONS(2813),
    [anon_sym_LR_DQUOTE] = ACTIONS(2813),
    [anon_sym_uR_DQUOTE] = ACTIONS(2813),
    [anon_sym_UR_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2813),
    [anon_sym_co_await] = ACTIONS(2811),
    [anon_sym_new] = ACTIONS(2811),
    [anon_sym_requires] = ACTIONS(2811),
    [sym_this] = ACTIONS(2811),
  },
  [778] = {
    [sym_identifier] = ACTIONS(2815),
    [aux_sym_preproc_include_token1] = ACTIONS(2815),
    [aux_sym_preproc_def_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token1] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2815),
    [sym_preproc_directive] = ACTIONS(2815),
    [anon_sym_LPAREN2] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_TILDE] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym___extension__] = ACTIONS(2815),
    [anon_sym_typedef] = ACTIONS(2815),
    [anon_sym_virtual] = ACTIONS(2815),
    [anon_sym_extern] = ACTIONS(2815),
    [anon_sym___attribute__] = ACTIONS(2815),
    [anon_sym___attribute] = ACTIONS(2815),
    [anon_sym_using] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2817),
    [anon_sym___declspec] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(2815),
    [anon_sym___cdecl] = ACTIONS(2815),
    [anon_sym___clrcall] = ACTIONS(2815),
    [anon_sym___stdcall] = ACTIONS(2815),
    [anon_sym___fastcall] = ACTIONS(2815),
    [anon_sym___thiscall] = ACTIONS(2815),
    [anon_sym___vectorcall] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2817),
    [anon_sym_RBRACE] = ACTIONS(2817),
    [anon_sym_signed] = ACTIONS(2815),
    [anon_sym_unsigned] = ACTIONS(2815),
    [anon_sym_long] = ACTIONS(2815),
    [anon_sym_short] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2815),
    [anon_sym_register] = ACTIONS(2815),
    [anon_sym_inline] = ACTIONS(2815),
    [anon_sym___inline] = ACTIONS(2815),
    [anon_sym___inline__] = ACTIONS(2815),
    [anon_sym___forceinline] = ACTIONS(2815),
    [anon_sym_thread_local] = ACTIONS(2815),
    [anon_sym___thread] = ACTIONS(2815),
    [anon_sym_const] = ACTIONS(2815),
    [anon_sym_constexpr] = ACTIONS(2815),
    [anon_sym_volatile] = ACTIONS(2815),
    [anon_sym_restrict] = ACTIONS(2815),
    [anon_sym___restrict__] = ACTIONS(2815),
    [anon_sym__Atomic] = ACTIONS(2815),
    [anon_sym__Noreturn] = ACTIONS(2815),
    [anon_sym_noreturn] = ACTIONS(2815),
    [anon_sym__Nonnull] = ACTIONS(2815),
    [anon_sym_mutable] = ACTIONS(2815),
    [anon_sym_constinit] = ACTIONS(2815),
    [anon_sym_consteval] = ACTIONS(2815),
    [anon_sym_alignas] = ACTIONS(2815),
    [anon_sym__Alignas] = ACTIONS(2815),
    [sym_primitive_type] = ACTIONS(2815),
    [anon_sym_enum] = ACTIONS(2815),
    [anon_sym_class] = ACTIONS(2815),
    [anon_sym_struct] = ACTIONS(2815),
    [anon_sym_union] = ACTIONS(2815),
    [anon_sym_if] = ACTIONS(2815),
    [anon_sym_switch] = ACTIONS(2815),
    [anon_sym_case] = ACTIONS(2815),
    [anon_sym_default] = ACTIONS(2815),
    [anon_sym_while] = ACTIONS(2815),
    [anon_sym_do] = ACTIONS(2815),
    [anon_sym_for] = ACTIONS(2815),
    [anon_sym_return] = ACTIONS(2815),
    [anon_sym_break] = ACTIONS(2815),
    [anon_sym_continue] = ACTIONS(2815),
    [anon_sym_goto] = ACTIONS(2815),
    [anon_sym___try] = ACTIONS(2815),
    [anon_sym___leave] = ACTIONS(2815),
    [anon_sym_not] = ACTIONS(2815),
    [anon_sym_compl] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2817),
    [anon_sym_sizeof] = ACTIONS(2815),
    [anon_sym___alignof__] = ACTIONS(2815),
    [anon_sym___alignof] = ACTIONS(2815),
    [anon_sym__alignof] = ACTIONS(2815),
    [anon_sym_alignof] = ACTIONS(2815),
    [anon_sym__Alignof] = ACTIONS(2815),
    [anon_sym_offsetof] = ACTIONS(2815),
    [anon_sym__Generic] = ACTIONS(2815),
    [anon_sym_asm] = ACTIONS(2815),
    [anon_sym___asm__] = ACTIONS(2815),
    [anon_sym___asm] = ACTIONS(2815),
    [sym_number_literal] = ACTIONS(2817),
    [anon_sym_L_SQUOTE] = ACTIONS(2817),
    [anon_sym_u_SQUOTE] = ACTIONS(2817),
    [anon_sym_U_SQUOTE] = ACTIONS(2817),
    [anon_sym_u8_SQUOTE] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_L_DQUOTE] = ACTIONS(2817),
    [anon_sym_u_DQUOTE] = ACTIONS(2817),
    [anon_sym_U_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8_DQUOTE] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(2817),
    [sym_true] = ACTIONS(2815),
    [sym_false] = ACTIONS(2815),
    [anon_sym_NULL] = ACTIONS(2815),
    [anon_sym_nullptr] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2815),
    [anon_sym_decltype] = ACTIONS(2815),
    [anon_sym_explicit] = ACTIONS(2815),
    [anon_sym_typename] = ACTIONS(2815),
    [anon_sym_template] = ACTIONS(2815),
    [anon_sym_operator] = ACTIONS(2815),
    [anon_sym_try] = ACTIONS(2815),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_throw] = ACTIONS(2815),
    [anon_sym_namespace] = ACTIONS(2815),
    [anon_sym_static_assert] = ACTIONS(2815),
    [anon_sym_concept] = ACTIONS(2815),
    [anon_sym_co_return] = ACTIONS(2815),
    [anon_sym_co_yield] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2815),
    [anon_sym_new] = ACTIONS(2815),
    [anon_sym_requires] = ACTIONS(2815),
    [sym_this] = ACTIONS(2815),
  },
  [779] = {
    [sym_identifier] = ACTIONS(2819),
    [aux_sym_preproc_include_token1] = ACTIONS(2819),
    [aux_sym_preproc_def_token1] = ACTIONS(2819),
    [aux_sym_preproc_if_token1] = ACTIONS(2819),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2819),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2819),
    [sym_preproc_directive] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2821),
    [anon_sym_AMP_AMP] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_SEMI] = ACTIONS(2821),
    [anon_sym___extension__] = ACTIONS(2819),
    [anon_sym_typedef] = ACTIONS(2819),
    [anon_sym_virtual] = ACTIONS(2819),
    [anon_sym_extern] = ACTIONS(2819),
    [anon_sym___attribute__] = ACTIONS(2819),
    [anon_sym___attribute] = ACTIONS(2819),
    [anon_sym_using] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2821),
    [anon_sym___declspec] = ACTIONS(2819),
    [anon_sym___based] = ACTIONS(2819),
    [anon_sym___cdecl] = ACTIONS(2819),
    [anon_sym___clrcall] = ACTIONS(2819),
    [anon_sym___stdcall] = ACTIONS(2819),
    [anon_sym___fastcall] = ACTIONS(2819),
    [anon_sym___thiscall] = ACTIONS(2819),
    [anon_sym___vectorcall] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2821),
    [anon_sym_RBRACE] = ACTIONS(2821),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_static] = ACTIONS(2819),
    [anon_sym_register] = ACTIONS(2819),
    [anon_sym_inline] = ACTIONS(2819),
    [anon_sym___inline] = ACTIONS(2819),
    [anon_sym___inline__] = ACTIONS(2819),
    [anon_sym___forceinline] = ACTIONS(2819),
    [anon_sym_thread_local] = ACTIONS(2819),
    [anon_sym___thread] = ACTIONS(2819),
    [anon_sym_const] = ACTIONS(2819),
    [anon_sym_constexpr] = ACTIONS(2819),
    [anon_sym_volatile] = ACTIONS(2819),
    [anon_sym_restrict] = ACTIONS(2819),
    [anon_sym___restrict__] = ACTIONS(2819),
    [anon_sym__Atomic] = ACTIONS(2819),
    [anon_sym__Noreturn] = ACTIONS(2819),
    [anon_sym_noreturn] = ACTIONS(2819),
    [anon_sym__Nonnull] = ACTIONS(2819),
    [anon_sym_mutable] = ACTIONS(2819),
    [anon_sym_constinit] = ACTIONS(2819),
    [anon_sym_consteval] = ACTIONS(2819),
    [anon_sym_alignas] = ACTIONS(2819),
    [anon_sym__Alignas] = ACTIONS(2819),
    [sym_primitive_type] = ACTIONS(2819),
    [anon_sym_enum] = ACTIONS(2819),
    [anon_sym_class] = ACTIONS(2819),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_union] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_switch] = ACTIONS(2819),
    [anon_sym_case] = ACTIONS(2819),
    [anon_sym_default] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2819),
    [anon_sym_continue] = ACTIONS(2819),
    [anon_sym_goto] = ACTIONS(2819),
    [anon_sym___try] = ACTIONS(2819),
    [anon_sym___leave] = ACTIONS(2819),
    [anon_sym_not] = ACTIONS(2819),
    [anon_sym_compl] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2821),
    [anon_sym_PLUS_PLUS] = ACTIONS(2821),
    [anon_sym_sizeof] = ACTIONS(2819),
    [anon_sym___alignof__] = ACTIONS(2819),
    [anon_sym___alignof] = ACTIONS(2819),
    [anon_sym__alignof] = ACTIONS(2819),
    [anon_sym_alignof] = ACTIONS(2819),
    [anon_sym__Alignof] = ACTIONS(2819),
    [anon_sym_offsetof] = ACTIONS(2819),
    [anon_sym__Generic] = ACTIONS(2819),
    [anon_sym_asm] = ACTIONS(2819),
    [anon_sym___asm__] = ACTIONS(2819),
    [anon_sym___asm] = ACTIONS(2819),
    [sym_number_literal] = ACTIONS(2821),
    [anon_sym_L_SQUOTE] = ACTIONS(2821),
    [anon_sym_u_SQUOTE] = ACTIONS(2821),
    [anon_sym_U_SQUOTE] = ACTIONS(2821),
    [anon_sym_u8_SQUOTE] = ACTIONS(2821),
    [anon_sym_SQUOTE] = ACTIONS(2821),
    [anon_sym_L_DQUOTE] = ACTIONS(2821),
    [anon_sym_u_DQUOTE] = ACTIONS(2821),
    [anon_sym_U_DQUOTE] = ACTIONS(2821),
    [anon_sym_u8_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE] = ACTIONS(2821),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [anon_sym_NULL] = ACTIONS(2819),
    [anon_sym_nullptr] = ACTIONS(2819),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2819),
    [anon_sym_decltype] = ACTIONS(2819),
    [anon_sym_explicit] = ACTIONS(2819),
    [anon_sym_typename] = ACTIONS(2819),
    [anon_sym_template] = ACTIONS(2819),
    [anon_sym_operator] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_delete] = ACTIONS(2819),
    [anon_sym_throw] = ACTIONS(2819),
    [anon_sym_namespace] = ACTIONS(2819),
    [anon_sym_static_assert] = ACTIONS(2819),
    [anon_sym_concept] = ACTIONS(2819),
    [anon_sym_co_return] = ACTIONS(2819),
    [anon_sym_co_yield] = ACTIONS(2819),
    [anon_sym_R_DQUOTE] = ACTIONS(2821),
    [anon_sym_LR_DQUOTE] = ACTIONS(2821),
    [anon_sym_uR_DQUOTE] = ACTIONS(2821),
    [anon_sym_UR_DQUOTE] = ACTIONS(2821),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2821),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_requires] = ACTIONS(2819),
    [sym_this] = ACTIONS(2819),
  },
  [780] = {
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_include_token1] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_BANG] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [anon_sym_PLUS] = ACTIONS(3108),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym___attribute] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym___cdecl] = ACTIONS(3108),
    [anon_sym___clrcall] = ACTIONS(3108),
    [anon_sym___stdcall] = ACTIONS(3108),
    [anon_sym___fastcall] = ACTIONS(3108),
    [anon_sym___thiscall] = ACTIONS(3108),
    [anon_sym___vectorcall] = ACTIONS(3108),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_RBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym__Nonnull] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym__Alignas] = ACTIONS(3108),
    [sym_primitive_type] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [anon_sym_if] = ACTIONS(3108),
    [anon_sym_switch] = ACTIONS(3108),
    [anon_sym_case] = ACTIONS(3108),
    [anon_sym_default] = ACTIONS(3108),
    [anon_sym_while] = ACTIONS(3108),
    [anon_sym_do] = ACTIONS(3108),
    [anon_sym_for] = ACTIONS(3108),
    [anon_sym_return] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3108),
    [anon_sym_continue] = ACTIONS(3108),
    [anon_sym_goto] = ACTIONS(3108),
    [anon_sym___try] = ACTIONS(3108),
    [anon_sym___leave] = ACTIONS(3108),
    [anon_sym_not] = ACTIONS(3108),
    [anon_sym_compl] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3110),
    [anon_sym_PLUS_PLUS] = ACTIONS(3110),
    [anon_sym_sizeof] = ACTIONS(3108),
    [anon_sym___alignof__] = ACTIONS(3108),
    [anon_sym___alignof] = ACTIONS(3108),
    [anon_sym__alignof] = ACTIONS(3108),
    [anon_sym_alignof] = ACTIONS(3108),
    [anon_sym__Alignof] = ACTIONS(3108),
    [anon_sym_offsetof] = ACTIONS(3108),
    [anon_sym__Generic] = ACTIONS(3108),
    [anon_sym_asm] = ACTIONS(3108),
    [anon_sym___asm__] = ACTIONS(3108),
    [anon_sym___asm] = ACTIONS(3108),
    [sym_number_literal] = ACTIONS(3110),
    [anon_sym_L_SQUOTE] = ACTIONS(3110),
    [anon_sym_u_SQUOTE] = ACTIONS(3110),
    [anon_sym_U_SQUOTE] = ACTIONS(3110),
    [anon_sym_u8_SQUOTE] = ACTIONS(3110),
    [anon_sym_SQUOTE] = ACTIONS(3110),
    [anon_sym_L_DQUOTE] = ACTIONS(3110),
    [anon_sym_u_DQUOTE] = ACTIONS(3110),
    [anon_sym_U_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8_DQUOTE] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(3110),
    [sym_true] = ACTIONS(3108),
    [sym_false] = ACTIONS(3108),
    [anon_sym_NULL] = ACTIONS(3108),
    [anon_sym_nullptr] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_try] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(3108),
    [anon_sym_throw] = ACTIONS(3108),
    [anon_sym_namespace] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
    [anon_sym_concept] = ACTIONS(3108),
    [anon_sym_co_return] = ACTIONS(3108),
    [anon_sym_co_yield] = ACTIONS(3108),
    [anon_sym_R_DQUOTE] = ACTIONS(3110),
    [anon_sym_LR_DQUOTE] = ACTIONS(3110),
    [anon_sym_uR_DQUOTE] = ACTIONS(3110),
    [anon_sym_UR_DQUOTE] = ACTIONS(3110),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3110),
    [anon_sym_co_await] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3108),
    [anon_sym_requires] = ACTIONS(3108),
    [sym_this] = ACTIONS(3108),
  },
  [781] = {
    [sym_identifier] = ACTIONS(3112),
    [aux_sym_preproc_include_token1] = ACTIONS(3112),
    [aux_sym_preproc_def_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3112),
    [sym_preproc_directive] = ACTIONS(3112),
    [anon_sym_LPAREN2] = ACTIONS(3114),
    [anon_sym_BANG] = ACTIONS(3114),
    [anon_sym_TILDE] = ACTIONS(3114),
    [anon_sym_DASH] = ACTIONS(3112),
    [anon_sym_PLUS] = ACTIONS(3112),
    [anon_sym_STAR] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3112),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym___extension__] = ACTIONS(3112),
    [anon_sym_typedef] = ACTIONS(3112),
    [anon_sym_virtual] = ACTIONS(3112),
    [anon_sym_extern] = ACTIONS(3112),
    [anon_sym___attribute__] = ACTIONS(3112),
    [anon_sym___attribute] = ACTIONS(3112),
    [anon_sym_using] = ACTIONS(3112),
    [anon_sym_COLON_COLON] = ACTIONS(3114),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3114),
    [anon_sym___declspec] = ACTIONS(3112),
    [anon_sym___based] = ACTIONS(3112),
    [anon_sym___cdecl] = ACTIONS(3112),
    [anon_sym___clrcall] = ACTIONS(3112),
    [anon_sym___stdcall] = ACTIONS(3112),
    [anon_sym___fastcall] = ACTIONS(3112),
    [anon_sym___thiscall] = ACTIONS(3112),
    [anon_sym___vectorcall] = ACTIONS(3112),
    [anon_sym_LBRACE] = ACTIONS(3114),
    [anon_sym_RBRACE] = ACTIONS(3114),
    [anon_sym_signed] = ACTIONS(3112),
    [anon_sym_unsigned] = ACTIONS(3112),
    [anon_sym_long] = ACTIONS(3112),
    [anon_sym_short] = ACTIONS(3112),
    [anon_sym_LBRACK] = ACTIONS(3112),
    [anon_sym_static] = ACTIONS(3112),
    [anon_sym_register] = ACTIONS(3112),
    [anon_sym_inline] = ACTIONS(3112),
    [anon_sym___inline] = ACTIONS(3112),
    [anon_sym___inline__] = ACTIONS(3112),
    [anon_sym___forceinline] = ACTIONS(3112),
    [anon_sym_thread_local] = ACTIONS(3112),
    [anon_sym___thread] = ACTIONS(3112),
    [anon_sym_const] = ACTIONS(3112),
    [anon_sym_constexpr] = ACTIONS(3112),
    [anon_sym_volatile] = ACTIONS(3112),
    [anon_sym_restrict] = ACTIONS(3112),
    [anon_sym___restrict__] = ACTIONS(3112),
    [anon_sym__Atomic] = ACTIONS(3112),
    [anon_sym__Noreturn] = ACTIONS(3112),
    [anon_sym_noreturn] = ACTIONS(3112),
    [anon_sym__Nonnull] = ACTIONS(3112),
    [anon_sym_mutable] = ACTIONS(3112),
    [anon_sym_constinit] = ACTIONS(3112),
    [anon_sym_consteval] = ACTIONS(3112),
    [anon_sym_alignas] = ACTIONS(3112),
    [anon_sym__Alignas] = ACTIONS(3112),
    [sym_primitive_type] = ACTIONS(3112),
    [anon_sym_enum] = ACTIONS(3112),
    [anon_sym_class] = ACTIONS(3112),
    [anon_sym_struct] = ACTIONS(3112),
    [anon_sym_union] = ACTIONS(3112),
    [anon_sym_if] = ACTIONS(3112),
    [anon_sym_switch] = ACTIONS(3112),
    [anon_sym_case] = ACTIONS(3112),
    [anon_sym_default] = ACTIONS(3112),
    [anon_sym_while] = ACTIONS(3112),
    [anon_sym_do] = ACTIONS(3112),
    [anon_sym_for] = ACTIONS(3112),
    [anon_sym_return] = ACTIONS(3112),
    [anon_sym_break] = ACTIONS(3112),
    [anon_sym_continue] = ACTIONS(3112),
    [anon_sym_goto] = ACTIONS(3112),
    [anon_sym___try] = ACTIONS(3112),
    [anon_sym___leave] = ACTIONS(3112),
    [anon_sym_not] = ACTIONS(3112),
    [anon_sym_compl] = ACTIONS(3112),
    [anon_sym_DASH_DASH] = ACTIONS(3114),
    [anon_sym_PLUS_PLUS] = ACTIONS(3114),
    [anon_sym_sizeof] = ACTIONS(3112),
    [anon_sym___alignof__] = ACTIONS(3112),
    [anon_sym___alignof] = ACTIONS(3112),
    [anon_sym__alignof] = ACTIONS(3112),
    [anon_sym_alignof] = ACTIONS(3112),
    [anon_sym__Alignof] = ACTIONS(3112),
    [anon_sym_offsetof] = ACTIONS(3112),
    [anon_sym__Generic] = ACTIONS(3112),
    [anon_sym_asm] = ACTIONS(3112),
    [anon_sym___asm__] = ACTIONS(3112),
    [anon_sym___asm] = ACTIONS(3112),
    [sym_number_literal] = ACTIONS(3114),
    [anon_sym_L_SQUOTE] = ACTIONS(3114),
    [anon_sym_u_SQUOTE] = ACTIONS(3114),
    [anon_sym_U_SQUOTE] = ACTIONS(3114),
    [anon_sym_u8_SQUOTE] = ACTIONS(3114),
    [anon_sym_SQUOTE] = ACTIONS(3114),
    [anon_sym_L_DQUOTE] = ACTIONS(3114),
    [anon_sym_u_DQUOTE] = ACTIONS(3114),
    [anon_sym_U_DQUOTE] = ACTIONS(3114),
    [anon_sym_u8_DQUOTE] = ACTIONS(3114),
    [anon_sym_DQUOTE] = ACTIONS(3114),
    [sym_true] = ACTIONS(3112),
    [sym_false] = ACTIONS(3112),
    [anon_sym_NULL] = ACTIONS(3112),
    [anon_sym_nullptr] = ACTIONS(3112),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3112),
    [anon_sym_decltype] = ACTIONS(3112),
    [anon_sym_explicit] = ACTIONS(3112),
    [anon_sym_typename] = ACTIONS(3112),
    [anon_sym_template] = ACTIONS(3112),
    [anon_sym_operator] = ACTIONS(3112),
    [anon_sym_try] = ACTIONS(3112),
    [anon_sym_delete] = ACTIONS(3112),
    [anon_sym_throw] = ACTIONS(3112),
    [anon_sym_namespace] = ACTIONS(3112),
    [anon_sym_static_assert] = ACTIONS(3112),
    [anon_sym_concept] = ACTIONS(3112),
    [anon_sym_co_return] = ACTIONS(3112),
    [anon_sym_co_yield] = ACTIONS(3112),
    [anon_sym_R_DQUOTE] = ACTIONS(3114),
    [anon_sym_LR_DQUOTE] = ACTIONS(3114),
    [anon_sym_uR_DQUOTE] = ACTIONS(3114),
    [anon_sym_UR_DQUOTE] = ACTIONS(3114),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3114),
    [anon_sym_co_await] = ACTIONS(3112),
    [anon_sym_new] = ACTIONS(3112),
    [anon_sym_requires] = ACTIONS(3112),
    [sym_this] = ACTIONS(3112),
  },
  [782] = {
    [sym_identifier] = ACTIONS(3313),
    [aux_sym_preproc_include_token1] = ACTIONS(3313),
    [aux_sym_preproc_def_token1] = ACTIONS(3313),
    [aux_sym_preproc_if_token1] = ACTIONS(3313),
    [aux_sym_preproc_if_token2] = ACTIONS(3313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3313),
    [sym_preproc_directive] = ACTIONS(3313),
    [anon_sym_LPAREN2] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_PLUS] = ACTIONS(3313),
    [anon_sym_STAR] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym___extension__] = ACTIONS(3313),
    [anon_sym_typedef] = ACTIONS(3313),
    [anon_sym_virtual] = ACTIONS(3313),
    [anon_sym_extern] = ACTIONS(3313),
    [anon_sym___attribute__] = ACTIONS(3313),
    [anon_sym___attribute] = ACTIONS(3313),
    [anon_sym_using] = ACTIONS(3313),
    [anon_sym_COLON_COLON] = ACTIONS(3316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3316),
    [anon_sym___declspec] = ACTIONS(3313),
    [anon_sym___based] = ACTIONS(3313),
    [anon_sym___cdecl] = ACTIONS(3313),
    [anon_sym___clrcall] = ACTIONS(3313),
    [anon_sym___stdcall] = ACTIONS(3313),
    [anon_sym___fastcall] = ACTIONS(3313),
    [anon_sym___thiscall] = ACTIONS(3313),
    [anon_sym___vectorcall] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_signed] = ACTIONS(3313),
    [anon_sym_unsigned] = ACTIONS(3313),
    [anon_sym_long] = ACTIONS(3313),
    [anon_sym_short] = ACTIONS(3313),
    [anon_sym_LBRACK] = ACTIONS(3313),
    [anon_sym_static] = ACTIONS(3313),
    [anon_sym_register] = ACTIONS(3313),
    [anon_sym_inline] = ACTIONS(3313),
    [anon_sym___inline] = ACTIONS(3313),
    [anon_sym___inline__] = ACTIONS(3313),
    [anon_sym___forceinline] = ACTIONS(3313),
    [anon_sym_thread_local] = ACTIONS(3313),
    [anon_sym___thread] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3313),
    [anon_sym_constexpr] = ACTIONS(3313),
    [anon_sym_volatile] = ACTIONS(3313),
    [anon_sym_restrict] = ACTIONS(3313),
    [anon_sym___restrict__] = ACTIONS(3313),
    [anon_sym__Atomic] = ACTIONS(3313),
    [anon_sym__Noreturn] = ACTIONS(3313),
    [anon_sym_noreturn] = ACTIONS(3313),
    [anon_sym__Nonnull] = ACTIONS(3313),
    [anon_sym_mutable] = ACTIONS(3313),
    [anon_sym_constinit] = ACTIONS(3313),
    [anon_sym_consteval] = ACTIONS(3313),
    [anon_sym_alignas] = ACTIONS(3313),
    [anon_sym__Alignas] = ACTIONS(3313),
    [sym_primitive_type] = ACTIONS(3313),
    [anon_sym_enum] = ACTIONS(3313),
    [anon_sym_class] = ACTIONS(3313),
    [anon_sym_struct] = ACTIONS(3313),
    [anon_sym_union] = ACTIONS(3313),
    [anon_sym_if] = ACTIONS(3313),
    [anon_sym_switch] = ACTIONS(3313),
    [anon_sym_case] = ACTIONS(3313),
    [anon_sym_default] = ACTIONS(3313),
    [anon_sym_while] = ACTIONS(3313),
    [anon_sym_do] = ACTIONS(3313),
    [anon_sym_for] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3313),
    [anon_sym_break] = ACTIONS(3313),
    [anon_sym_continue] = ACTIONS(3313),
    [anon_sym_goto] = ACTIONS(3313),
    [anon_sym___try] = ACTIONS(3313),
    [anon_sym___leave] = ACTIONS(3313),
    [anon_sym_not] = ACTIONS(3313),
    [anon_sym_compl] = ACTIONS(3313),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_sizeof] = ACTIONS(3313),
    [anon_sym___alignof__] = ACTIONS(3313),
    [anon_sym___alignof] = ACTIONS(3313),
    [anon_sym__alignof] = ACTIONS(3313),
    [anon_sym_alignof] = ACTIONS(3313),
    [anon_sym__Alignof] = ACTIONS(3313),
    [anon_sym_offsetof] = ACTIONS(3313),
    [anon_sym__Generic] = ACTIONS(3313),
    [anon_sym_asm] = ACTIONS(3313),
    [anon_sym___asm__] = ACTIONS(3313),
    [anon_sym___asm] = ACTIONS(3313),
    [sym_number_literal] = ACTIONS(3316),
    [anon_sym_L_SQUOTE] = ACTIONS(3316),
    [anon_sym_u_SQUOTE] = ACTIONS(3316),
    [anon_sym_U_SQUOTE] = ACTIONS(3316),
    [anon_sym_u8_SQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_L_DQUOTE] = ACTIONS(3316),
    [anon_sym_u_DQUOTE] = ACTIONS(3316),
    [anon_sym_U_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8_DQUOTE] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [sym_true] = ACTIONS(3313),
    [sym_false] = ACTIONS(3313),
    [anon_sym_NULL] = ACTIONS(3313),
    [anon_sym_nullptr] = ACTIONS(3313),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3313),
    [anon_sym_decltype] = ACTIONS(3313),
    [anon_sym_explicit] = ACTIONS(3313),
    [anon_sym_typename] = ACTIONS(3313),
    [anon_sym_template] = ACTIONS(3313),
    [anon_sym_operator] = ACTIONS(3313),
    [anon_sym_try] = ACTIONS(3313),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_throw] = ACTIONS(3313),
    [anon_sym_namespace] = ACTIONS(3313),
    [anon_sym_static_assert] = ACTIONS(3313),
    [anon_sym_concept] = ACTIONS(3313),
    [anon_sym_co_return] = ACTIONS(3313),
    [anon_sym_co_yield] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3316),
    [anon_sym_LR_DQUOTE] = ACTIONS(3316),
    [anon_sym_uR_DQUOTE] = ACTIONS(3316),
    [anon_sym_UR_DQUOTE] = ACTIONS(3316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3316),
    [anon_sym_co_await] = ACTIONS(3313),
    [anon_sym_new] = ACTIONS(3313),
    [anon_sym_requires] = ACTIONS(3313),
    [sym_this] = ACTIONS(3313),
  },
  [783] = {
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_include_token1] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2823),
    [aux_sym_preproc_if_token1] = ACTIONS(2823),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2823),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2823),
    [sym_preproc_directive] = ACTIONS(2823),
    [anon_sym_LPAREN2] = ACTIONS(2825),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_TILDE] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_SEMI] = ACTIONS(2825),
    [anon_sym___extension__] = ACTIONS(2823),
    [anon_sym_typedef] = ACTIONS(2823),
    [anon_sym_virtual] = ACTIONS(2823),
    [anon_sym_extern] = ACTIONS(2823),
    [anon_sym___attribute__] = ACTIONS(2823),
    [anon_sym___attribute] = ACTIONS(2823),
    [anon_sym_using] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2825),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2825),
    [anon_sym___declspec] = ACTIONS(2823),
    [anon_sym___based] = ACTIONS(2823),
    [anon_sym___cdecl] = ACTIONS(2823),
    [anon_sym___clrcall] = ACTIONS(2823),
    [anon_sym___stdcall] = ACTIONS(2823),
    [anon_sym___fastcall] = ACTIONS(2823),
    [anon_sym___thiscall] = ACTIONS(2823),
    [anon_sym___vectorcall] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(2825),
    [anon_sym_signed] = ACTIONS(2823),
    [anon_sym_unsigned] = ACTIONS(2823),
    [anon_sym_long] = ACTIONS(2823),
    [anon_sym_short] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2823),
    [anon_sym_register] = ACTIONS(2823),
    [anon_sym_inline] = ACTIONS(2823),
    [anon_sym___inline] = ACTIONS(2823),
    [anon_sym___inline__] = ACTIONS(2823),
    [anon_sym___forceinline] = ACTIONS(2823),
    [anon_sym_thread_local] = ACTIONS(2823),
    [anon_sym___thread] = ACTIONS(2823),
    [anon_sym_const] = ACTIONS(2823),
    [anon_sym_constexpr] = ACTIONS(2823),
    [anon_sym_volatile] = ACTIONS(2823),
    [anon_sym_restrict] = ACTIONS(2823),
    [anon_sym___restrict__] = ACTIONS(2823),
    [anon_sym__Atomic] = ACTIONS(2823),
    [anon_sym__Noreturn] = ACTIONS(2823),
    [anon_sym_noreturn] = ACTIONS(2823),
    [anon_sym__Nonnull] = ACTIONS(2823),
    [anon_sym_mutable] = ACTIONS(2823),
    [anon_sym_constinit] = ACTIONS(2823),
    [anon_sym_consteval] = ACTIONS(2823),
    [anon_sym_alignas] = ACTIONS(2823),
    [anon_sym__Alignas] = ACTIONS(2823),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2823),
    [anon_sym_class] = ACTIONS(2823),
    [anon_sym_struct] = ACTIONS(2823),
    [anon_sym_union] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(2823),
    [anon_sym_switch] = ACTIONS(2823),
    [anon_sym_case] = ACTIONS(2823),
    [anon_sym_default] = ACTIONS(2823),
    [anon_sym_while] = ACTIONS(2823),
    [anon_sym_do] = ACTIONS(2823),
    [anon_sym_for] = ACTIONS(2823),
    [anon_sym_return] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2823),
    [anon_sym_continue] = ACTIONS(2823),
    [anon_sym_goto] = ACTIONS(2823),
    [anon_sym___try] = ACTIONS(2823),
    [anon_sym___leave] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2823),
    [anon_sym_compl] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2825),
    [anon_sym_sizeof] = ACTIONS(2823),
    [anon_sym___alignof__] = ACTIONS(2823),
    [anon_sym___alignof] = ACTIONS(2823),
    [anon_sym__alignof] = ACTIONS(2823),
    [anon_sym_alignof] = ACTIONS(2823),
    [anon_sym__Alignof] = ACTIONS(2823),
    [anon_sym_offsetof] = ACTIONS(2823),
    [anon_sym__Generic] = ACTIONS(2823),
    [anon_sym_asm] = ACTIONS(2823),
    [anon_sym___asm__] = ACTIONS(2823),
    [anon_sym___asm] = ACTIONS(2823),
    [sym_number_literal] = ACTIONS(2825),
    [anon_sym_L_SQUOTE] = ACTIONS(2825),
    [anon_sym_u_SQUOTE] = ACTIONS(2825),
    [anon_sym_U_SQUOTE] = ACTIONS(2825),
    [anon_sym_u8_SQUOTE] = ACTIONS(2825),
    [anon_sym_SQUOTE] = ACTIONS(2825),
    [anon_sym_L_DQUOTE] = ACTIONS(2825),
    [anon_sym_u_DQUOTE] = ACTIONS(2825),
    [anon_sym_U_DQUOTE] = ACTIONS(2825),
    [anon_sym_u8_DQUOTE] = ACTIONS(2825),
    [anon_sym_DQUOTE] = ACTIONS(2825),
    [sym_true] = ACTIONS(2823),
    [sym_false] = ACTIONS(2823),
    [anon_sym_NULL] = ACTIONS(2823),
    [anon_sym_nullptr] = ACTIONS(2823),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2823),
    [anon_sym_decltype] = ACTIONS(2823),
    [anon_sym_explicit] = ACTIONS(2823),
    [anon_sym_typename] = ACTIONS(2823),
    [anon_sym_template] = ACTIONS(2823),
    [anon_sym_operator] = ACTIONS(2823),
    [anon_sym_try] = ACTIONS(2823),
    [anon_sym_delete] = ACTIONS(2823),
    [anon_sym_throw] = ACTIONS(2823),
    [anon_sym_namespace] = ACTIONS(2823),
    [anon_sym_static_assert] = ACTIONS(2823),
    [anon_sym_concept] = ACTIONS(2823),
    [anon_sym_co_return] = ACTIONS(2823),
    [anon_sym_co_yield] = ACTIONS(2823),
    [anon_sym_R_DQUOTE] = ACTIONS(2825),
    [anon_sym_LR_DQUOTE] = ACTIONS(2825),
    [anon_sym_uR_DQUOTE] = ACTIONS(2825),
    [anon_sym_UR_DQUOTE] = ACTIONS(2825),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2825),
    [anon_sym_co_await] = ACTIONS(2823),
    [anon_sym_new] = ACTIONS(2823),
    [anon_sym_requires] = ACTIONS(2823),
    [sym_this] = ACTIONS(2823),
  },
  [784] = {
    [sym_identifier] = ACTIONS(2827),
    [aux_sym_preproc_include_token1] = ACTIONS(2827),
    [aux_sym_preproc_def_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2827),
    [sym_preproc_directive] = ACTIONS(2827),
    [anon_sym_LPAREN2] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym___extension__] = ACTIONS(2827),
    [anon_sym_typedef] = ACTIONS(2827),
    [anon_sym_virtual] = ACTIONS(2827),
    [anon_sym_extern] = ACTIONS(2827),
    [anon_sym___attribute__] = ACTIONS(2827),
    [anon_sym___attribute] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2829),
    [anon_sym___declspec] = ACTIONS(2827),
    [anon_sym___based] = ACTIONS(2827),
    [anon_sym___cdecl] = ACTIONS(2827),
    [anon_sym___clrcall] = ACTIONS(2827),
    [anon_sym___stdcall] = ACTIONS(2827),
    [anon_sym___fastcall] = ACTIONS(2827),
    [anon_sym___thiscall] = ACTIONS(2827),
    [anon_sym___vectorcall] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_signed] = ACTIONS(2827),
    [anon_sym_unsigned] = ACTIONS(2827),
    [anon_sym_long] = ACTIONS(2827),
    [anon_sym_short] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_static] = ACTIONS(2827),
    [anon_sym_register] = ACTIONS(2827),
    [anon_sym_inline] = ACTIONS(2827),
    [anon_sym___inline] = ACTIONS(2827),
    [anon_sym___inline__] = ACTIONS(2827),
    [anon_sym___forceinline] = ACTIONS(2827),
    [anon_sym_thread_local] = ACTIONS(2827),
    [anon_sym___thread] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_constexpr] = ACTIONS(2827),
    [anon_sym_volatile] = ACTIONS(2827),
    [anon_sym_restrict] = ACTIONS(2827),
    [anon_sym___restrict__] = ACTIONS(2827),
    [anon_sym__Atomic] = ACTIONS(2827),
    [anon_sym__Noreturn] = ACTIONS(2827),
    [anon_sym_noreturn] = ACTIONS(2827),
    [anon_sym__Nonnull] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_constinit] = ACTIONS(2827),
    [anon_sym_consteval] = ACTIONS(2827),
    [anon_sym_alignas] = ACTIONS(2827),
    [anon_sym__Alignas] = ACTIONS(2827),
    [sym_primitive_type] = ACTIONS(2827),
    [anon_sym_enum] = ACTIONS(2827),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_union] = ACTIONS(2827),
    [anon_sym_if] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_case] = ACTIONS(2827),
    [anon_sym_default] = ACTIONS(2827),
    [anon_sym_while] = ACTIONS(2827),
    [anon_sym_do] = ACTIONS(2827),
    [anon_sym_for] = ACTIONS(2827),
    [anon_sym_return] = ACTIONS(2827),
    [anon_sym_break] = ACTIONS(2827),
    [anon_sym_continue] = ACTIONS(2827),
    [anon_sym_goto] = ACTIONS(2827),
    [anon_sym___try] = ACTIONS(2827),
    [anon_sym___leave] = ACTIONS(2827),
    [anon_sym_not] = ACTIONS(2827),
    [anon_sym_compl] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_sizeof] = ACTIONS(2827),
    [anon_sym___alignof__] = ACTIONS(2827),
    [anon_sym___alignof] = ACTIONS(2827),
    [anon_sym__alignof] = ACTIONS(2827),
    [anon_sym_alignof] = ACTIONS(2827),
    [anon_sym__Alignof] = ACTIONS(2827),
    [anon_sym_offsetof] = ACTIONS(2827),
    [anon_sym__Generic] = ACTIONS(2827),
    [anon_sym_asm] = ACTIONS(2827),
    [anon_sym___asm__] = ACTIONS(2827),
    [anon_sym___asm] = ACTIONS(2827),
    [sym_number_literal] = ACTIONS(2829),
    [anon_sym_L_SQUOTE] = ACTIONS(2829),
    [anon_sym_u_SQUOTE] = ACTIONS(2829),
    [anon_sym_U_SQUOTE] = ACTIONS(2829),
    [anon_sym_u8_SQUOTE] = ACTIONS(2829),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_L_DQUOTE] = ACTIONS(2829),
    [anon_sym_u_DQUOTE] = ACTIONS(2829),
    [anon_sym_U_DQUOTE] = ACTIONS(2829),
    [anon_sym_u8_DQUOTE] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(2829),
    [sym_true] = ACTIONS(2827),
    [sym_false] = ACTIONS(2827),
    [anon_sym_NULL] = ACTIONS(2827),
    [anon_sym_nullptr] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2827),
    [anon_sym_decltype] = ACTIONS(2827),
    [anon_sym_explicit] = ACTIONS(2827),
    [anon_sym_typename] = ACTIONS(2827),
    [anon_sym_template] = ACTIONS(2827),
    [anon_sym_operator] = ACTIONS(2827),
    [anon_sym_try] = ACTIONS(2827),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_throw] = ACTIONS(2827),
    [anon_sym_namespace] = ACTIONS(2827),
    [anon_sym_static_assert] = ACTIONS(2827),
    [anon_sym_concept] = ACTIONS(2827),
    [anon_sym_co_return] = ACTIONS(2827),
    [anon_sym_co_yield] = ACTIONS(2827),
    [anon_sym_R_DQUOTE] = ACTIONS(2829),
    [anon_sym_LR_DQUOTE] = ACTIONS(2829),
    [anon_sym_uR_DQUOTE] = ACTIONS(2829),
    [anon_sym_UR_DQUOTE] = ACTIONS(2829),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2829),
    [anon_sym_co_await] = ACTIONS(2827),
    [anon_sym_new] = ACTIONS(2827),
    [anon_sym_requires] = ACTIONS(2827),
    [sym_this] = ACTIONS(2827),
  },
  [785] = {
    [sym_identifier] = ACTIONS(2819),
    [aux_sym_preproc_include_token1] = ACTIONS(2819),
    [aux_sym_preproc_def_token1] = ACTIONS(2819),
    [aux_sym_preproc_if_token1] = ACTIONS(2819),
    [aux_sym_preproc_if_token2] = ACTIONS(2819),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2819),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2819),
    [sym_preproc_directive] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2821),
    [anon_sym_AMP_AMP] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_SEMI] = ACTIONS(2821),
    [anon_sym___extension__] = ACTIONS(2819),
    [anon_sym_typedef] = ACTIONS(2819),
    [anon_sym_virtual] = ACTIONS(2819),
    [anon_sym_extern] = ACTIONS(2819),
    [anon_sym___attribute__] = ACTIONS(2819),
    [anon_sym___attribute] = ACTIONS(2819),
    [anon_sym_using] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2821),
    [anon_sym___declspec] = ACTIONS(2819),
    [anon_sym___based] = ACTIONS(2819),
    [anon_sym___cdecl] = ACTIONS(2819),
    [anon_sym___clrcall] = ACTIONS(2819),
    [anon_sym___stdcall] = ACTIONS(2819),
    [anon_sym___fastcall] = ACTIONS(2819),
    [anon_sym___thiscall] = ACTIONS(2819),
    [anon_sym___vectorcall] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2821),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_static] = ACTIONS(2819),
    [anon_sym_register] = ACTIONS(2819),
    [anon_sym_inline] = ACTIONS(2819),
    [anon_sym___inline] = ACTIONS(2819),
    [anon_sym___inline__] = ACTIONS(2819),
    [anon_sym___forceinline] = ACTIONS(2819),
    [anon_sym_thread_local] = ACTIONS(2819),
    [anon_sym___thread] = ACTIONS(2819),
    [anon_sym_const] = ACTIONS(2819),
    [anon_sym_constexpr] = ACTIONS(2819),
    [anon_sym_volatile] = ACTIONS(2819),
    [anon_sym_restrict] = ACTIONS(2819),
    [anon_sym___restrict__] = ACTIONS(2819),
    [anon_sym__Atomic] = ACTIONS(2819),
    [anon_sym__Noreturn] = ACTIONS(2819),
    [anon_sym_noreturn] = ACTIONS(2819),
    [anon_sym__Nonnull] = ACTIONS(2819),
    [anon_sym_mutable] = ACTIONS(2819),
    [anon_sym_constinit] = ACTIONS(2819),
    [anon_sym_consteval] = ACTIONS(2819),
    [anon_sym_alignas] = ACTIONS(2819),
    [anon_sym__Alignas] = ACTIONS(2819),
    [sym_primitive_type] = ACTIONS(2819),
    [anon_sym_enum] = ACTIONS(2819),
    [anon_sym_class] = ACTIONS(2819),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_union] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_switch] = ACTIONS(2819),
    [anon_sym_case] = ACTIONS(2819),
    [anon_sym_default] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_break] = ACTIONS(2819),
    [anon_sym_continue] = ACTIONS(2819),
    [anon_sym_goto] = ACTIONS(2819),
    [anon_sym___try] = ACTIONS(2819),
    [anon_sym___leave] = ACTIONS(2819),
    [anon_sym_not] = ACTIONS(2819),
    [anon_sym_compl] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2821),
    [anon_sym_PLUS_PLUS] = ACTIONS(2821),
    [anon_sym_sizeof] = ACTIONS(2819),
    [anon_sym___alignof__] = ACTIONS(2819),
    [anon_sym___alignof] = ACTIONS(2819),
    [anon_sym__alignof] = ACTIONS(2819),
    [anon_sym_alignof] = ACTIONS(2819),
    [anon_sym__Alignof] = ACTIONS(2819),
    [anon_sym_offsetof] = ACTIONS(2819),
    [anon_sym__Generic] = ACTIONS(2819),
    [anon_sym_asm] = ACTIONS(2819),
    [anon_sym___asm__] = ACTIONS(2819),
    [anon_sym___asm] = ACTIONS(2819),
    [sym_number_literal] = ACTIONS(2821),
    [anon_sym_L_SQUOTE] = ACTIONS(2821),
    [anon_sym_u_SQUOTE] = ACTIONS(2821),
    [anon_sym_U_SQUOTE] = ACTIONS(2821),
    [anon_sym_u8_SQUOTE] = ACTIONS(2821),
    [anon_sym_SQUOTE] = ACTIONS(2821),
    [anon_sym_L_DQUOTE] = ACTIONS(2821),
    [anon_sym_u_DQUOTE] = ACTIONS(2821),
    [anon_sym_U_DQUOTE] = ACTIONS(2821),
    [anon_sym_u8_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE] = ACTIONS(2821),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [anon_sym_NULL] = ACTIONS(2819),
    [anon_sym_nullptr] = ACTIONS(2819),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2819),
    [anon_sym_decltype] = ACTIONS(2819),
    [anon_sym_explicit] = ACTIONS(2819),
    [anon_sym_typename] = ACTIONS(2819),
    [anon_sym_template] = ACTIONS(2819),
    [anon_sym_operator] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_delete] = ACTIONS(2819),
    [anon_sym_throw] = ACTIONS(2819),
    [anon_sym_namespace] = ACTIONS(2819),
    [anon_sym_static_assert] = ACTIONS(2819),
    [anon_sym_concept] = ACTIONS(2819),
    [anon_sym_co_return] = ACTIONS(2819),
    [anon_sym_co_yield] = ACTIONS(2819),
    [anon_sym_R_DQUOTE] = ACTIONS(2821),
    [anon_sym_LR_DQUOTE] = ACTIONS(2821),
    [anon_sym_uR_DQUOTE] = ACTIONS(2821),
    [anon_sym_UR_DQUOTE] = ACTIONS(2821),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2821),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_requires] = ACTIONS(2819),
    [sym_this] = ACTIONS(2819),
  },
  [786] = {
    [sym_identifier] = ACTIONS(3100),
    [aux_sym_preproc_include_token1] = ACTIONS(3100),
    [aux_sym_preproc_def_token1] = ACTIONS(3100),
    [aux_sym_preproc_if_token1] = ACTIONS(3100),
    [aux_sym_preproc_if_token2] = ACTIONS(3100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3100),
    [sym_preproc_directive] = ACTIONS(3100),
    [anon_sym_LPAREN2] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_AMP_AMP] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym___extension__] = ACTIONS(3100),
    [anon_sym_typedef] = ACTIONS(3100),
    [anon_sym_virtual] = ACTIONS(3100),
    [anon_sym_extern] = ACTIONS(3100),
    [anon_sym___attribute__] = ACTIONS(3100),
    [anon_sym___attribute] = ACTIONS(3100),
    [anon_sym_using] = ACTIONS(3100),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3102),
    [anon_sym___declspec] = ACTIONS(3100),
    [anon_sym___based] = ACTIONS(3100),
    [anon_sym___cdecl] = ACTIONS(3100),
    [anon_sym___clrcall] = ACTIONS(3100),
    [anon_sym___stdcall] = ACTIONS(3100),
    [anon_sym___fastcall] = ACTIONS(3100),
    [anon_sym___thiscall] = ACTIONS(3100),
    [anon_sym___vectorcall] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_signed] = ACTIONS(3100),
    [anon_sym_unsigned] = ACTIONS(3100),
    [anon_sym_long] = ACTIONS(3100),
    [anon_sym_short] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_register] = ACTIONS(3100),
    [anon_sym_inline] = ACTIONS(3100),
    [anon_sym___inline] = ACTIONS(3100),
    [anon_sym___inline__] = ACTIONS(3100),
    [anon_sym___forceinline] = ACTIONS(3100),
    [anon_sym_thread_local] = ACTIONS(3100),
    [anon_sym___thread] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_constexpr] = ACTIONS(3100),
    [anon_sym_volatile] = ACTIONS(3100),
    [anon_sym_restrict] = ACTIONS(3100),
    [anon_sym___restrict__] = ACTIONS(3100),
    [anon_sym__Atomic] = ACTIONS(3100),
    [anon_sym__Noreturn] = ACTIONS(3100),
    [anon_sym_noreturn] = ACTIONS(3100),
    [anon_sym__Nonnull] = ACTIONS(3100),
    [anon_sym_mutable] = ACTIONS(3100),
    [anon_sym_constinit] = ACTIONS(3100),
    [anon_sym_consteval] = ACTIONS(3100),
    [anon_sym_alignas] = ACTIONS(3100),
    [anon_sym__Alignas] = ACTIONS(3100),
    [sym_primitive_type] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_struct] = ACTIONS(3100),
    [anon_sym_union] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_goto] = ACTIONS(3100),
    [anon_sym___try] = ACTIONS(3100),
    [anon_sym___leave] = ACTIONS(3100),
    [anon_sym_not] = ACTIONS(3100),
    [anon_sym_compl] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_sizeof] = ACTIONS(3100),
    [anon_sym___alignof__] = ACTIONS(3100),
    [anon_sym___alignof] = ACTIONS(3100),
    [anon_sym__alignof] = ACTIONS(3100),
    [anon_sym_alignof] = ACTIONS(3100),
    [anon_sym__Alignof] = ACTIONS(3100),
    [anon_sym_offsetof] = ACTIONS(3100),
    [anon_sym__Generic] = ACTIONS(3100),
    [anon_sym_asm] = ACTIONS(3100),
    [anon_sym___asm__] = ACTIONS(3100),
    [anon_sym___asm] = ACTIONS(3100),
    [sym_number_literal] = ACTIONS(3102),
    [anon_sym_L_SQUOTE] = ACTIONS(3102),
    [anon_sym_u_SQUOTE] = ACTIONS(3102),
    [anon_sym_U_SQUOTE] = ACTIONS(3102),
    [anon_sym_u8_SQUOTE] = ACTIONS(3102),
    [anon_sym_SQUOTE] = ACTIONS(3102),
    [anon_sym_L_DQUOTE] = ACTIONS(3102),
    [anon_sym_u_DQUOTE] = ACTIONS(3102),
    [anon_sym_U_DQUOTE] = ACTIONS(3102),
    [anon_sym_u8_DQUOTE] = ACTIONS(3102),
    [anon_sym_DQUOTE] = ACTIONS(3102),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [anon_sym_NULL] = ACTIONS(3100),
    [anon_sym_nullptr] = ACTIONS(3100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3100),
    [anon_sym_decltype] = ACTIONS(3100),
    [anon_sym_explicit] = ACTIONS(3100),
    [anon_sym_typename] = ACTIONS(3100),
    [anon_sym_template] = ACTIONS(3100),
    [anon_sym_operator] = ACTIONS(3100),
    [anon_sym_try] = ACTIONS(3100),
    [anon_sym_delete] = ACTIONS(3100),
    [anon_sym_throw] = ACTIONS(3100),
    [anon_sym_namespace] = ACTIONS(3100),
    [anon_sym_static_assert] = ACTIONS(3100),
    [anon_sym_concept] = ACTIONS(3100),
    [anon_sym_co_return] = ACTIONS(3100),
    [anon_sym_co_yield] = ACTIONS(3100),
    [anon_sym_R_DQUOTE] = ACTIONS(3102),
    [anon_sym_LR_DQUOTE] = ACTIONS(3102),
    [anon_sym_uR_DQUOTE] = ACTIONS(3102),
    [anon_sym_UR_DQUOTE] = ACTIONS(3102),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3102),
    [anon_sym_co_await] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_requires] = ACTIONS(3100),
    [sym_this] = ACTIONS(3100),
  },
  [787] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_include_token1] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token2] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym___attribute] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym___cdecl] = ACTIONS(2783),
    [anon_sym___clrcall] = ACTIONS(2783),
    [anon_sym___stdcall] = ACTIONS(2783),
    [anon_sym___fastcall] = ACTIONS(2783),
    [anon_sym___thiscall] = ACTIONS(2783),
    [anon_sym___vectorcall] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym__Nonnull] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym__Alignas] = ACTIONS(2783),
    [sym_primitive_type] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_switch] = ACTIONS(2783),
    [anon_sym_case] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_goto] = ACTIONS(2783),
    [anon_sym___try] = ACTIONS(2783),
    [anon_sym___leave] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_compl] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_sizeof] = ACTIONS(2783),
    [anon_sym___alignof__] = ACTIONS(2783),
    [anon_sym___alignof] = ACTIONS(2783),
    [anon_sym__alignof] = ACTIONS(2783),
    [anon_sym_alignof] = ACTIONS(2783),
    [anon_sym__Alignof] = ACTIONS(2783),
    [anon_sym_offsetof] = ACTIONS(2783),
    [anon_sym__Generic] = ACTIONS(2783),
    [anon_sym_asm] = ACTIONS(2783),
    [anon_sym___asm__] = ACTIONS(2783),
    [anon_sym___asm] = ACTIONS(2783),
    [sym_number_literal] = ACTIONS(2785),
    [anon_sym_L_SQUOTE] = ACTIONS(2785),
    [anon_sym_u_SQUOTE] = ACTIONS(2785),
    [anon_sym_U_SQUOTE] = ACTIONS(2785),
    [anon_sym_u8_SQUOTE] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_L_DQUOTE] = ACTIONS(2785),
    [anon_sym_u_DQUOTE] = ACTIONS(2785),
    [anon_sym_U_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [anon_sym_NULL] = ACTIONS(2783),
    [anon_sym_nullptr] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_throw] = ACTIONS(2783),
    [anon_sym_namespace] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
    [anon_sym_concept] = ACTIONS(2783),
    [anon_sym_co_return] = ACTIONS(2783),
    [anon_sym_co_yield] = ACTIONS(2783),
    [anon_sym_R_DQUOTE] = ACTIONS(2785),
    [anon_sym_LR_DQUOTE] = ACTIONS(2785),
    [anon_sym_uR_DQUOTE] = ACTIONS(2785),
    [anon_sym_UR_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2785),
    [anon_sym_co_await] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_requires] = ACTIONS(2783),
    [sym_this] = ACTIONS(2783),
  },
  [788] = {
    [sym_identifier] = ACTIONS(2831),
    [aux_sym_preproc_include_token1] = ACTIONS(2831),
    [aux_sym_preproc_def_token1] = ACTIONS(2831),
    [aux_sym_preproc_if_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [sym_preproc_directive] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym___extension__] = ACTIONS(2831),
    [anon_sym_typedef] = ACTIONS(2831),
    [anon_sym_virtual] = ACTIONS(2831),
    [anon_sym_extern] = ACTIONS(2831),
    [anon_sym___attribute__] = ACTIONS(2831),
    [anon_sym___attribute] = ACTIONS(2831),
    [anon_sym_using] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2833),
    [anon_sym___declspec] = ACTIONS(2831),
    [anon_sym___based] = ACTIONS(2831),
    [anon_sym___cdecl] = ACTIONS(2831),
    [anon_sym___clrcall] = ACTIONS(2831),
    [anon_sym___stdcall] = ACTIONS(2831),
    [anon_sym___fastcall] = ACTIONS(2831),
    [anon_sym___thiscall] = ACTIONS(2831),
    [anon_sym___vectorcall] = ACTIONS(2831),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_RBRACE] = ACTIONS(2833),
    [anon_sym_signed] = ACTIONS(2831),
    [anon_sym_unsigned] = ACTIONS(2831),
    [anon_sym_long] = ACTIONS(2831),
    [anon_sym_short] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_static] = ACTIONS(2831),
    [anon_sym_register] = ACTIONS(2831),
    [anon_sym_inline] = ACTIONS(2831),
    [anon_sym___inline] = ACTIONS(2831),
    [anon_sym___inline__] = ACTIONS(2831),
    [anon_sym___forceinline] = ACTIONS(2831),
    [anon_sym_thread_local] = ACTIONS(2831),
    [anon_sym___thread] = ACTIONS(2831),
    [anon_sym_const] = ACTIONS(2831),
    [anon_sym_constexpr] = ACTIONS(2831),
    [anon_sym_volatile] = ACTIONS(2831),
    [anon_sym_restrict] = ACTIONS(2831),
    [anon_sym___restrict__] = ACTIONS(2831),
    [anon_sym__Atomic] = ACTIONS(2831),
    [anon_sym__Noreturn] = ACTIONS(2831),
    [anon_sym_noreturn] = ACTIONS(2831),
    [anon_sym__Nonnull] = ACTIONS(2831),
    [anon_sym_mutable] = ACTIONS(2831),
    [anon_sym_constinit] = ACTIONS(2831),
    [anon_sym_consteval] = ACTIONS(2831),
    [anon_sym_alignas] = ACTIONS(2831),
    [anon_sym__Alignas] = ACTIONS(2831),
    [sym_primitive_type] = ACTIONS(2831),
    [anon_sym_enum] = ACTIONS(2831),
    [anon_sym_class] = ACTIONS(2831),
    [anon_sym_struct] = ACTIONS(2831),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_switch] = ACTIONS(2831),
    [anon_sym_case] = ACTIONS(2831),
    [anon_sym_default] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_break] = ACTIONS(2831),
    [anon_sym_continue] = ACTIONS(2831),
    [anon_sym_goto] = ACTIONS(2831),
    [anon_sym___try] = ACTIONS(2831),
    [anon_sym___leave] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_compl] = ACTIONS(2831),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2831),
    [anon_sym___alignof__] = ACTIONS(2831),
    [anon_sym___alignof] = ACTIONS(2831),
    [anon_sym__alignof] = ACTIONS(2831),
    [anon_sym_alignof] = ACTIONS(2831),
    [anon_sym__Alignof] = ACTIONS(2831),
    [anon_sym_offsetof] = ACTIONS(2831),
    [anon_sym__Generic] = ACTIONS(2831),
    [anon_sym_asm] = ACTIONS(2831),
    [anon_sym___asm__] = ACTIONS(2831),
    [anon_sym___asm] = ACTIONS(2831),
    [sym_number_literal] = ACTIONS(2833),
    [anon_sym_L_SQUOTE] = ACTIONS(2833),
    [anon_sym_u_SQUOTE] = ACTIONS(2833),
    [anon_sym_U_SQUOTE] = ACTIONS(2833),
    [anon_sym_u8_SQUOTE] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_L_DQUOTE] = ACTIONS(2833),
    [anon_sym_u_DQUOTE] = ACTIONS(2833),
    [anon_sym_U_DQUOTE] = ACTIONS(2833),
    [anon_sym_u8_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(2833),
    [sym_true] = ACTIONS(2831),
    [sym_false] = ACTIONS(2831),
    [anon_sym_NULL] = ACTIONS(2831),
    [anon_sym_nullptr] = ACTIONS(2831),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2831),
    [anon_sym_decltype] = ACTIONS(2831),
    [anon_sym_explicit] = ACTIONS(2831),
    [anon_sym_typename] = ACTIONS(2831),
    [anon_sym_template] = ACTIONS(2831),
    [anon_sym_operator] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_delete] = ACTIONS(2831),
    [anon_sym_throw] = ACTIONS(2831),
    [anon_sym_namespace] = ACTIONS(2831),
    [anon_sym_static_assert] = ACTIONS(2831),
    [anon_sym_concept] = ACTIONS(2831),
    [anon_sym_co_return] = ACTIONS(2831),
    [anon_sym_co_yield] = ACTIONS(2831),
    [anon_sym_R_DQUOTE] = ACTIONS(2833),
    [anon_sym_LR_DQUOTE] = ACTIONS(2833),
    [anon_sym_uR_DQUOTE] = ACTIONS(2833),
    [anon_sym_UR_DQUOTE] = ACTIONS(2833),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2833),
    [anon_sym_co_await] = ACTIONS(2831),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_requires] = ACTIONS(2831),
    [sym_this] = ACTIONS(2831),
  },
  [789] = {
    [sym_identifier] = ACTIONS(2795),
    [aux_sym_preproc_include_token1] = ACTIONS(2795),
    [aux_sym_preproc_def_token1] = ACTIONS(2795),
    [aux_sym_preproc_if_token1] = ACTIONS(2795),
    [aux_sym_preproc_if_token2] = ACTIONS(2795),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2795),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2795),
    [sym_preproc_directive] = ACTIONS(2795),
    [anon_sym_LPAREN2] = ACTIONS(2797),
    [anon_sym_BANG] = ACTIONS(2797),
    [anon_sym_TILDE] = ACTIONS(2797),
    [anon_sym_DASH] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_AMP_AMP] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_SEMI] = ACTIONS(2797),
    [anon_sym___extension__] = ACTIONS(2795),
    [anon_sym_typedef] = ACTIONS(2795),
    [anon_sym_virtual] = ACTIONS(2795),
    [anon_sym_extern] = ACTIONS(2795),
    [anon_sym___attribute__] = ACTIONS(2795),
    [anon_sym___attribute] = ACTIONS(2795),
    [anon_sym_using] = ACTIONS(2795),
    [anon_sym_COLON_COLON] = ACTIONS(2797),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2797),
    [anon_sym___declspec] = ACTIONS(2795),
    [anon_sym___based] = ACTIONS(2795),
    [anon_sym___cdecl] = ACTIONS(2795),
    [anon_sym___clrcall] = ACTIONS(2795),
    [anon_sym___stdcall] = ACTIONS(2795),
    [anon_sym___fastcall] = ACTIONS(2795),
    [anon_sym___thiscall] = ACTIONS(2795),
    [anon_sym___vectorcall] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2797),
    [anon_sym_signed] = ACTIONS(2795),
    [anon_sym_unsigned] = ACTIONS(2795),
    [anon_sym_long] = ACTIONS(2795),
    [anon_sym_short] = ACTIONS(2795),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_static] = ACTIONS(2795),
    [anon_sym_register] = ACTIONS(2795),
    [anon_sym_inline] = ACTIONS(2795),
    [anon_sym___inline] = ACTIONS(2795),
    [anon_sym___inline__] = ACTIONS(2795),
    [anon_sym___forceinline] = ACTIONS(2795),
    [anon_sym_thread_local] = ACTIONS(2795),
    [anon_sym___thread] = ACTIONS(2795),
    [anon_sym_const] = ACTIONS(2795),
    [anon_sym_constexpr] = ACTIONS(2795),
    [anon_sym_volatile] = ACTIONS(2795),
    [anon_sym_restrict] = ACTIONS(2795),
    [anon_sym___restrict__] = ACTIONS(2795),
    [anon_sym__Atomic] = ACTIONS(2795),
    [anon_sym__Noreturn] = ACTIONS(2795),
    [anon_sym_noreturn] = ACTIONS(2795),
    [anon_sym__Nonnull] = ACTIONS(2795),
    [anon_sym_mutable] = ACTIONS(2795),
    [anon_sym_constinit] = ACTIONS(2795),
    [anon_sym_consteval] = ACTIONS(2795),
    [anon_sym_alignas] = ACTIONS(2795),
    [anon_sym__Alignas] = ACTIONS(2795),
    [sym_primitive_type] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2795),
    [anon_sym_class] = ACTIONS(2795),
    [anon_sym_struct] = ACTIONS(2795),
    [anon_sym_union] = ACTIONS(2795),
    [anon_sym_if] = ACTIONS(2795),
    [anon_sym_switch] = ACTIONS(2795),
    [anon_sym_case] = ACTIONS(2795),
    [anon_sym_default] = ACTIONS(2795),
    [anon_sym_while] = ACTIONS(2795),
    [anon_sym_do] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2795),
    [anon_sym_return] = ACTIONS(2795),
    [anon_sym_break] = ACTIONS(2795),
    [anon_sym_continue] = ACTIONS(2795),
    [anon_sym_goto] = ACTIONS(2795),
    [anon_sym___try] = ACTIONS(2795),
    [anon_sym___leave] = ACTIONS(2795),
    [anon_sym_not] = ACTIONS(2795),
    [anon_sym_compl] = ACTIONS(2795),
    [anon_sym_DASH_DASH] = ACTIONS(2797),
    [anon_sym_PLUS_PLUS] = ACTIONS(2797),
    [anon_sym_sizeof] = ACTIONS(2795),
    [anon_sym___alignof__] = ACTIONS(2795),
    [anon_sym___alignof] = ACTIONS(2795),
    [anon_sym__alignof] = ACTIONS(2795),
    [anon_sym_alignof] = ACTIONS(2795),
    [anon_sym__Alignof] = ACTIONS(2795),
    [anon_sym_offsetof] = ACTIONS(2795),
    [anon_sym__Generic] = ACTIONS(2795),
    [anon_sym_asm] = ACTIONS(2795),
    [anon_sym___asm__] = ACTIONS(2795),
    [anon_sym___asm] = ACTIONS(2795),
    [sym_number_literal] = ACTIONS(2797),
    [anon_sym_L_SQUOTE] = ACTIONS(2797),
    [anon_sym_u_SQUOTE] = ACTIONS(2797),
    [anon_sym_U_SQUOTE] = ACTIONS(2797),
    [anon_sym_u8_SQUOTE] = ACTIONS(2797),
    [anon_sym_SQUOTE] = ACTIONS(2797),
    [anon_sym_L_DQUOTE] = ACTIONS(2797),
    [anon_sym_u_DQUOTE] = ACTIONS(2797),
    [anon_sym_U_DQUOTE] = ACTIONS(2797),
    [anon_sym_u8_DQUOTE] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(2797),
    [sym_true] = ACTIONS(2795),
    [sym_false] = ACTIONS(2795),
    [anon_sym_NULL] = ACTIONS(2795),
    [anon_sym_nullptr] = ACTIONS(2795),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2795),
    [anon_sym_decltype] = ACTIONS(2795),
    [anon_sym_explicit] = ACTIONS(2795),
    [anon_sym_typename] = ACTIONS(2795),
    [anon_sym_template] = ACTIONS(2795),
    [anon_sym_operator] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2795),
    [anon_sym_delete] = ACTIONS(2795),
    [anon_sym_throw] = ACTIONS(2795),
    [anon_sym_namespace] = ACTIONS(2795),
    [anon_sym_static_assert] = ACTIONS(2795),
    [anon_sym_concept] = ACTIONS(2795),
    [anon_sym_co_return] = ACTIONS(2795),
    [anon_sym_co_yield] = ACTIONS(2795),
    [anon_sym_R_DQUOTE] = ACTIONS(2797),
    [anon_sym_LR_DQUOTE] = ACTIONS(2797),
    [anon_sym_uR_DQUOTE] = ACTIONS(2797),
    [anon_sym_UR_DQUOTE] = ACTIONS(2797),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2797),
    [anon_sym_co_await] = ACTIONS(2795),
    [anon_sym_new] = ACTIONS(2795),
    [anon_sym_requires] = ACTIONS(2795),
    [sym_this] = ACTIONS(2795),
  },
  [790] = {
    [sym_identifier] = ACTIONS(2803),
    [aux_sym_preproc_include_token1] = ACTIONS(2803),
    [aux_sym_preproc_def_token1] = ACTIONS(2803),
    [aux_sym_preproc_if_token1] = ACTIONS(2803),
    [aux_sym_preproc_if_token2] = ACTIONS(2803),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2803),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2803),
    [sym_preproc_directive] = ACTIONS(2803),
    [anon_sym_LPAREN2] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(2805),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2803),
    [anon_sym_PLUS] = ACTIONS(2803),
    [anon_sym_STAR] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2805),
    [anon_sym_AMP] = ACTIONS(2803),
    [anon_sym_SEMI] = ACTIONS(2805),
    [anon_sym___extension__] = ACTIONS(2803),
    [anon_sym_typedef] = ACTIONS(2803),
    [anon_sym_virtual] = ACTIONS(2803),
    [anon_sym_extern] = ACTIONS(2803),
    [anon_sym___attribute__] = ACTIONS(2803),
    [anon_sym___attribute] = ACTIONS(2803),
    [anon_sym_using] = ACTIONS(2803),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2805),
    [anon_sym___declspec] = ACTIONS(2803),
    [anon_sym___based] = ACTIONS(2803),
    [anon_sym___cdecl] = ACTIONS(2803),
    [anon_sym___clrcall] = ACTIONS(2803),
    [anon_sym___stdcall] = ACTIONS(2803),
    [anon_sym___fastcall] = ACTIONS(2803),
    [anon_sym___thiscall] = ACTIONS(2803),
    [anon_sym___vectorcall] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(2805),
    [anon_sym_signed] = ACTIONS(2803),
    [anon_sym_unsigned] = ACTIONS(2803),
    [anon_sym_long] = ACTIONS(2803),
    [anon_sym_short] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_static] = ACTIONS(2803),
    [anon_sym_register] = ACTIONS(2803),
    [anon_sym_inline] = ACTIONS(2803),
    [anon_sym___inline] = ACTIONS(2803),
    [anon_sym___inline__] = ACTIONS(2803),
    [anon_sym___forceinline] = ACTIONS(2803),
    [anon_sym_thread_local] = ACTIONS(2803),
    [anon_sym___thread] = ACTIONS(2803),
    [anon_sym_const] = ACTIONS(2803),
    [anon_sym_constexpr] = ACTIONS(2803),
    [anon_sym_volatile] = ACTIONS(2803),
    [anon_sym_restrict] = ACTIONS(2803),
    [anon_sym___restrict__] = ACTIONS(2803),
    [anon_sym__Atomic] = ACTIONS(2803),
    [anon_sym__Noreturn] = ACTIONS(2803),
    [anon_sym_noreturn] = ACTIONS(2803),
    [anon_sym__Nonnull] = ACTIONS(2803),
    [anon_sym_mutable] = ACTIONS(2803),
    [anon_sym_constinit] = ACTIONS(2803),
    [anon_sym_consteval] = ACTIONS(2803),
    [anon_sym_alignas] = ACTIONS(2803),
    [anon_sym__Alignas] = ACTIONS(2803),
    [sym_primitive_type] = ACTIONS(2803),
    [anon_sym_enum] = ACTIONS(2803),
    [anon_sym_class] = ACTIONS(2803),
    [anon_sym_struct] = ACTIONS(2803),
    [anon_sym_union] = ACTIONS(2803),
    [anon_sym_if] = ACTIONS(2803),
    [anon_sym_switch] = ACTIONS(2803),
    [anon_sym_case] = ACTIONS(2803),
    [anon_sym_default] = ACTIONS(2803),
    [anon_sym_while] = ACTIONS(2803),
    [anon_sym_do] = ACTIONS(2803),
    [anon_sym_for] = ACTIONS(2803),
    [anon_sym_return] = ACTIONS(2803),
    [anon_sym_break] = ACTIONS(2803),
    [anon_sym_continue] = ACTIONS(2803),
    [anon_sym_goto] = ACTIONS(2803),
    [anon_sym___try] = ACTIONS(2803),
    [anon_sym___leave] = ACTIONS(2803),
    [anon_sym_not] = ACTIONS(2803),
    [anon_sym_compl] = ACTIONS(2803),
    [anon_sym_DASH_DASH] = ACTIONS(2805),
    [anon_sym_PLUS_PLUS] = ACTIONS(2805),
    [anon_sym_sizeof] = ACTIONS(2803),
    [anon_sym___alignof__] = ACTIONS(2803),
    [anon_sym___alignof] = ACTIONS(2803),
    [anon_sym__alignof] = ACTIONS(2803),
    [anon_sym_alignof] = ACTIONS(2803),
    [anon_sym__Alignof] = ACTIONS(2803),
    [anon_sym_offsetof] = ACTIONS(2803),
    [anon_sym__Generic] = ACTIONS(2803),
    [anon_sym_asm] = ACTIONS(2803),
    [anon_sym___asm__] = ACTIONS(2803),
    [anon_sym___asm] = ACTIONS(2803),
    [sym_number_literal] = ACTIONS(2805),
    [anon_sym_L_SQUOTE] = ACTIONS(2805),
    [anon_sym_u_SQUOTE] = ACTIONS(2805),
    [anon_sym_U_SQUOTE] = ACTIONS(2805),
    [anon_sym_u8_SQUOTE] = ACTIONS(2805),
    [anon_sym_SQUOTE] = ACTIONS(2805),
    [anon_sym_L_DQUOTE] = ACTIONS(2805),
    [anon_sym_u_DQUOTE] = ACTIONS(2805),
    [anon_sym_U_DQUOTE] = ACTIONS(2805),
    [anon_sym_u8_DQUOTE] = ACTIONS(2805),
    [anon_sym_DQUOTE] = ACTIONS(2805),
    [sym_true] = ACTIONS(2803),
    [sym_false] = ACTIONS(2803),
    [anon_sym_NULL] = ACTIONS(2803),
    [anon_sym_nullptr] = ACTIONS(2803),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2803),
    [anon_sym_decltype] = ACTIONS(2803),
    [anon_sym_explicit] = ACTIONS(2803),
    [anon_sym_typename] = ACTIONS(2803),
    [anon_sym_template] = ACTIONS(2803),
    [anon_sym_operator] = ACTIONS(2803),
    [anon_sym_try] = ACTIONS(2803),
    [anon_sym_delete] = ACTIONS(2803),
    [anon_sym_throw] = ACTIONS(2803),
    [anon_sym_namespace] = ACTIONS(2803),
    [anon_sym_static_assert] = ACTIONS(2803),
    [anon_sym_concept] = ACTIONS(2803),
    [anon_sym_co_return] = ACTIONS(2803),
    [anon_sym_co_yield] = ACTIONS(2803),
    [anon_sym_R_DQUOTE] = ACTIONS(2805),
    [anon_sym_LR_DQUOTE] = ACTIONS(2805),
    [anon_sym_uR_DQUOTE] = ACTIONS(2805),
    [anon_sym_UR_DQUOTE] = ACTIONS(2805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2805),
    [anon_sym_co_await] = ACTIONS(2803),
    [anon_sym_new] = ACTIONS(2803),
    [anon_sym_requires] = ACTIONS(2803),
    [sym_this] = ACTIONS(2803),
  },
  [791] = {
    [sym_identifier] = ACTIONS(2811),
    [aux_sym_preproc_include_token1] = ACTIONS(2811),
    [aux_sym_preproc_def_token1] = ACTIONS(2811),
    [aux_sym_preproc_if_token1] = ACTIONS(2811),
    [aux_sym_preproc_if_token2] = ACTIONS(2811),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2811),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2811),
    [sym_preproc_directive] = ACTIONS(2811),
    [anon_sym_LPAREN2] = ACTIONS(2813),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_TILDE] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym_SEMI] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2811),
    [anon_sym_typedef] = ACTIONS(2811),
    [anon_sym_virtual] = ACTIONS(2811),
    [anon_sym_extern] = ACTIONS(2811),
    [anon_sym___attribute__] = ACTIONS(2811),
    [anon_sym___attribute] = ACTIONS(2811),
    [anon_sym_using] = ACTIONS(2811),
    [anon_sym_COLON_COLON] = ACTIONS(2813),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2813),
    [anon_sym___declspec] = ACTIONS(2811),
    [anon_sym___based] = ACTIONS(2811),
    [anon_sym___cdecl] = ACTIONS(2811),
    [anon_sym___clrcall] = ACTIONS(2811),
    [anon_sym___stdcall] = ACTIONS(2811),
    [anon_sym___fastcall] = ACTIONS(2811),
    [anon_sym___thiscall] = ACTIONS(2811),
    [anon_sym___vectorcall] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2813),
    [anon_sym_signed] = ACTIONS(2811),
    [anon_sym_unsigned] = ACTIONS(2811),
    [anon_sym_long] = ACTIONS(2811),
    [anon_sym_short] = ACTIONS(2811),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_static] = ACTIONS(2811),
    [anon_sym_register] = ACTIONS(2811),
    [anon_sym_inline] = ACTIONS(2811),
    [anon_sym___inline] = ACTIONS(2811),
    [anon_sym___inline__] = ACTIONS(2811),
    [anon_sym___forceinline] = ACTIONS(2811),
    [anon_sym_thread_local] = ACTIONS(2811),
    [anon_sym___thread] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_constexpr] = ACTIONS(2811),
    [anon_sym_volatile] = ACTIONS(2811),
    [anon_sym_restrict] = ACTIONS(2811),
    [anon_sym___restrict__] = ACTIONS(2811),
    [anon_sym__Atomic] = ACTIONS(2811),
    [anon_sym__Noreturn] = ACTIONS(2811),
    [anon_sym_noreturn] = ACTIONS(2811),
    [anon_sym__Nonnull] = ACTIONS(2811),
    [anon_sym_mutable] = ACTIONS(2811),
    [anon_sym_constinit] = ACTIONS(2811),
    [anon_sym_consteval] = ACTIONS(2811),
    [anon_sym_alignas] = ACTIONS(2811),
    [anon_sym__Alignas] = ACTIONS(2811),
    [sym_primitive_type] = ACTIONS(2811),
    [anon_sym_enum] = ACTIONS(2811),
    [anon_sym_class] = ACTIONS(2811),
    [anon_sym_struct] = ACTIONS(2811),
    [anon_sym_union] = ACTIONS(2811),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_switch] = ACTIONS(2811),
    [anon_sym_case] = ACTIONS(2811),
    [anon_sym_default] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [anon_sym_do] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_break] = ACTIONS(2811),
    [anon_sym_continue] = ACTIONS(2811),
    [anon_sym_goto] = ACTIONS(2811),
    [anon_sym___try] = ACTIONS(2811),
    [anon_sym___leave] = ACTIONS(2811),
    [anon_sym_not] = ACTIONS(2811),
    [anon_sym_compl] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2813),
    [anon_sym_sizeof] = ACTIONS(2811),
    [anon_sym___alignof__] = ACTIONS(2811),
    [anon_sym___alignof] = ACTIONS(2811),
    [anon_sym__alignof] = ACTIONS(2811),
    [anon_sym_alignof] = ACTIONS(2811),
    [anon_sym__Alignof] = ACTIONS(2811),
    [anon_sym_offsetof] = ACTIONS(2811),
    [anon_sym__Generic] = ACTIONS(2811),
    [anon_sym_asm] = ACTIONS(2811),
    [anon_sym___asm__] = ACTIONS(2811),
    [anon_sym___asm] = ACTIONS(2811),
    [sym_number_literal] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2813),
    [anon_sym_u_SQUOTE] = ACTIONS(2813),
    [anon_sym_U_SQUOTE] = ACTIONS(2813),
    [anon_sym_u8_SQUOTE] = ACTIONS(2813),
    [anon_sym_SQUOTE] = ACTIONS(2813),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2811),
    [sym_false] = ACTIONS(2811),
    [anon_sym_NULL] = ACTIONS(2811),
    [anon_sym_nullptr] = ACTIONS(2811),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2811),
    [anon_sym_decltype] = ACTIONS(2811),
    [anon_sym_explicit] = ACTIONS(2811),
    [anon_sym_typename] = ACTIONS(2811),
    [anon_sym_template] = ACTIONS(2811),
    [anon_sym_operator] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_delete] = ACTIONS(2811),
    [anon_sym_throw] = ACTIONS(2811),
    [anon_sym_namespace] = ACTIONS(2811),
    [anon_sym_static_assert] = ACTIONS(2811),
    [anon_sym_concept] = ACTIONS(2811),
    [anon_sym_co_return] = ACTIONS(2811),
    [anon_sym_co_yield] = ACTIONS(2811),
    [anon_sym_R_DQUOTE] = ACTIONS(2813),
    [anon_sym_LR_DQUOTE] = ACTIONS(2813),
    [anon_sym_uR_DQUOTE] = ACTIONS(2813),
    [anon_sym_UR_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2813),
    [anon_sym_co_await] = ACTIONS(2811),
    [anon_sym_new] = ACTIONS(2811),
    [anon_sym_requires] = ACTIONS(2811),
    [sym_this] = ACTIONS(2811),
  },
  [792] = {
    [sym_identifier] = ACTIONS(2835),
    [aux_sym_preproc_include_token1] = ACTIONS(2835),
    [aux_sym_preproc_def_token1] = ACTIONS(2835),
    [aux_sym_preproc_if_token1] = ACTIONS(2835),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2835),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2835),
    [sym_preproc_directive] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_STAR] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym___extension__] = ACTIONS(2835),
    [anon_sym_typedef] = ACTIONS(2835),
    [anon_sym_virtual] = ACTIONS(2835),
    [anon_sym_extern] = ACTIONS(2835),
    [anon_sym___attribute__] = ACTIONS(2835),
    [anon_sym___attribute] = ACTIONS(2835),
    [anon_sym_using] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2837),
    [anon_sym___declspec] = ACTIONS(2835),
    [anon_sym___based] = ACTIONS(2835),
    [anon_sym___cdecl] = ACTIONS(2835),
    [anon_sym___clrcall] = ACTIONS(2835),
    [anon_sym___stdcall] = ACTIONS(2835),
    [anon_sym___fastcall] = ACTIONS(2835),
    [anon_sym___thiscall] = ACTIONS(2835),
    [anon_sym___vectorcall] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2837),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_signed] = ACTIONS(2835),
    [anon_sym_unsigned] = ACTIONS(2835),
    [anon_sym_long] = ACTIONS(2835),
    [anon_sym_short] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_static] = ACTIONS(2835),
    [anon_sym_register] = ACTIONS(2835),
    [anon_sym_inline] = ACTIONS(2835),
    [anon_sym___inline] = ACTIONS(2835),
    [anon_sym___inline__] = ACTIONS(2835),
    [anon_sym___forceinline] = ACTIONS(2835),
    [anon_sym_thread_local] = ACTIONS(2835),
    [anon_sym___thread] = ACTIONS(2835),
    [anon_sym_const] = ACTIONS(2835),
    [anon_sym_constexpr] = ACTIONS(2835),
    [anon_sym_volatile] = ACTIONS(2835),
    [anon_sym_restrict] = ACTIONS(2835),
    [anon_sym___restrict__] = ACTIONS(2835),
    [anon_sym__Atomic] = ACTIONS(2835),
    [anon_sym__Noreturn] = ACTIONS(2835),
    [anon_sym_noreturn] = ACTIONS(2835),
    [anon_sym__Nonnull] = ACTIONS(2835),
    [anon_sym_mutable] = ACTIONS(2835),
    [anon_sym_constinit] = ACTIONS(2835),
    [anon_sym_consteval] = ACTIONS(2835),
    [anon_sym_alignas] = ACTIONS(2835),
    [anon_sym__Alignas] = ACTIONS(2835),
    [sym_primitive_type] = ACTIONS(2835),
    [anon_sym_enum] = ACTIONS(2835),
    [anon_sym_class] = ACTIONS(2835),
    [anon_sym_struct] = ACTIONS(2835),
    [anon_sym_union] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_switch] = ACTIONS(2835),
    [anon_sym_case] = ACTIONS(2835),
    [anon_sym_default] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_break] = ACTIONS(2835),
    [anon_sym_continue] = ACTIONS(2835),
    [anon_sym_goto] = ACTIONS(2835),
    [anon_sym___try] = ACTIONS(2835),
    [anon_sym___leave] = ACTIONS(2835),
    [anon_sym_not] = ACTIONS(2835),
    [anon_sym_compl] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2835),
    [anon_sym___alignof] = ACTIONS(2835),
    [anon_sym__alignof] = ACTIONS(2835),
    [anon_sym_alignof] = ACTIONS(2835),
    [anon_sym__Alignof] = ACTIONS(2835),
    [anon_sym_offsetof] = ACTIONS(2835),
    [anon_sym__Generic] = ACTIONS(2835),
    [anon_sym_asm] = ACTIONS(2835),
    [anon_sym___asm__] = ACTIONS(2835),
    [anon_sym___asm] = ACTIONS(2835),
    [sym_number_literal] = ACTIONS(2837),
    [anon_sym_L_SQUOTE] = ACTIONS(2837),
    [anon_sym_u_SQUOTE] = ACTIONS(2837),
    [anon_sym_U_SQUOTE] = ACTIONS(2837),
    [anon_sym_u8_SQUOTE] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_L_DQUOTE] = ACTIONS(2837),
    [anon_sym_u_DQUOTE] = ACTIONS(2837),
    [anon_sym_U_DQUOTE] = ACTIONS(2837),
    [anon_sym_u8_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE] = ACTIONS(2837),
    [sym_true] = ACTIONS(2835),
    [sym_false] = ACTIONS(2835),
    [anon_sym_NULL] = ACTIONS(2835),
    [anon_sym_nullptr] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2835),
    [anon_sym_decltype] = ACTIONS(2835),
    [anon_sym_explicit] = ACTIONS(2835),
    [anon_sym_typename] = ACTIONS(2835),
    [anon_sym_template] = ACTIONS(2835),
    [anon_sym_operator] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_delete] = ACTIONS(2835),
    [anon_sym_throw] = ACTIONS(2835),
    [anon_sym_namespace] = ACTIONS(2835),
    [anon_sym_static_assert] = ACTIONS(2835),
    [anon_sym_concept] = ACTIONS(2835),
    [anon_sym_co_return] = ACTIONS(2835),
    [anon_sym_co_yield] = ACTIONS(2835),
    [anon_sym_R_DQUOTE] = ACTIONS(2837),
    [anon_sym_LR_DQUOTE] = ACTIONS(2837),
    [anon_sym_uR_DQUOTE] = ACTIONS(2837),
    [anon_sym_UR_DQUOTE] = ACTIONS(2837),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2837),
    [anon_sym_co_await] = ACTIONS(2835),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_requires] = ACTIONS(2835),
    [sym_this] = ACTIONS(2835),
  },
  [793] = {
    [sym_identifier] = ACTIONS(3071),
    [aux_sym_preproc_include_token1] = ACTIONS(3071),
    [aux_sym_preproc_def_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token2] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3071),
    [sym_preproc_directive] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym___extension__] = ACTIONS(3071),
    [anon_sym_typedef] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym___attribute__] = ACTIONS(3071),
    [anon_sym___attribute] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3073),
    [anon_sym___declspec] = ACTIONS(3071),
    [anon_sym___based] = ACTIONS(3071),
    [anon_sym___cdecl] = ACTIONS(3071),
    [anon_sym___clrcall] = ACTIONS(3071),
    [anon_sym___stdcall] = ACTIONS(3071),
    [anon_sym___fastcall] = ACTIONS(3071),
    [anon_sym___thiscall] = ACTIONS(3071),
    [anon_sym___vectorcall] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_signed] = ACTIONS(3071),
    [anon_sym_unsigned] = ACTIONS(3071),
    [anon_sym_long] = ACTIONS(3071),
    [anon_sym_short] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_register] = ACTIONS(3071),
    [anon_sym_inline] = ACTIONS(3071),
    [anon_sym___inline] = ACTIONS(3071),
    [anon_sym___inline__] = ACTIONS(3071),
    [anon_sym___forceinline] = ACTIONS(3071),
    [anon_sym_thread_local] = ACTIONS(3071),
    [anon_sym___thread] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_constexpr] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_restrict] = ACTIONS(3071),
    [anon_sym___restrict__] = ACTIONS(3071),
    [anon_sym__Atomic] = ACTIONS(3071),
    [anon_sym__Noreturn] = ACTIONS(3071),
    [anon_sym_noreturn] = ACTIONS(3071),
    [anon_sym__Nonnull] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_constinit] = ACTIONS(3071),
    [anon_sym_consteval] = ACTIONS(3071),
    [anon_sym_alignas] = ACTIONS(3071),
    [anon_sym__Alignas] = ACTIONS(3071),
    [sym_primitive_type] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_union] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_switch] = ACTIONS(3071),
    [anon_sym_case] = ACTIONS(3071),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3071),
    [anon_sym_goto] = ACTIONS(3071),
    [anon_sym___try] = ACTIONS(3071),
    [anon_sym___leave] = ACTIONS(3071),
    [anon_sym_not] = ACTIONS(3071),
    [anon_sym_compl] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_sizeof] = ACTIONS(3071),
    [anon_sym___alignof__] = ACTIONS(3071),
    [anon_sym___alignof] = ACTIONS(3071),
    [anon_sym__alignof] = ACTIONS(3071),
    [anon_sym_alignof] = ACTIONS(3071),
    [anon_sym__Alignof] = ACTIONS(3071),
    [anon_sym_offsetof] = ACTIONS(3071),
    [anon_sym__Generic] = ACTIONS(3071),
    [anon_sym_asm] = ACTIONS(3071),
    [anon_sym___asm__] = ACTIONS(3071),
    [anon_sym___asm] = ACTIONS(3071),
    [sym_number_literal] = ACTIONS(3073),
    [anon_sym_L_SQUOTE] = ACTIONS(3073),
    [anon_sym_u_SQUOTE] = ACTIONS(3073),
    [anon_sym_U_SQUOTE] = ACTIONS(3073),
    [anon_sym_u8_SQUOTE] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_L_DQUOTE] = ACTIONS(3073),
    [anon_sym_u_DQUOTE] = ACTIONS(3073),
    [anon_sym_U_DQUOTE] = ACTIONS(3073),
    [anon_sym_u8_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [sym_true] = ACTIONS(3071),
    [sym_false] = ACTIONS(3071),
    [anon_sym_NULL] = ACTIONS(3071),
    [anon_sym_nullptr] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3071),
    [anon_sym_decltype] = ACTIONS(3071),
    [anon_sym_explicit] = ACTIONS(3071),
    [anon_sym_typename] = ACTIONS(3071),
    [anon_sym_template] = ACTIONS(3071),
    [anon_sym_operator] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_delete] = ACTIONS(3071),
    [anon_sym_throw] = ACTIONS(3071),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_static_assert] = ACTIONS(3071),
    [anon_sym_concept] = ACTIONS(3071),
    [anon_sym_co_return] = ACTIONS(3071),
    [anon_sym_co_yield] = ACTIONS(3071),
    [anon_sym_R_DQUOTE] = ACTIONS(3073),
    [anon_sym_LR_DQUOTE] = ACTIONS(3073),
    [anon_sym_uR_DQUOTE] = ACTIONS(3073),
    [anon_sym_UR_DQUOTE] = ACTIONS(3073),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3073),
    [anon_sym_co_await] = ACTIONS(3071),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_requires] = ACTIONS(3071),
    [sym_this] = ACTIONS(3071),
  },
  [794] = {
    [sym_expression] = STATE(3797),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_initializer_list] = STATE(3805),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(1942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [aux_sym_preproc_if_token2] = ACTIONS(1944),
    [aux_sym_preproc_else_token1] = ACTIONS(1944),
    [aux_sym_preproc_elif_token1] = ACTIONS(1942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1944),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [795] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [796] = {
    [sym_preproc_def] = STATE(810),
    [sym_preproc_function_def] = STATE(810),
    [sym_preproc_call] = STATE(810),
    [sym_preproc_if_in_field_declaration_list] = STATE(810),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(810),
    [sym_type_definition] = STATE(810),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(810),
    [sym_field_declaration] = STATE(810),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(810),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(810),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(810),
    [sym_operator_cast_declaration] = STATE(810),
    [sym_constructor_or_destructor_definition] = STATE(810),
    [sym_constructor_or_destructor_declaration] = STATE(810),
    [sym_friend_declaration] = STATE(810),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(810),
    [sym_alias_declaration] = STATE(810),
    [sym_static_assert_declaration] = STATE(810),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(810),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3661),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [797] = {
    [sym_preproc_def] = STATE(798),
    [sym_preproc_function_def] = STATE(798),
    [sym_preproc_call] = STATE(798),
    [sym_preproc_if_in_field_declaration_list] = STATE(798),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(798),
    [sym_type_definition] = STATE(798),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(798),
    [sym_field_declaration] = STATE(798),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(798),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(798),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(798),
    [sym_operator_cast_declaration] = STATE(798),
    [sym_constructor_or_destructor_definition] = STATE(798),
    [sym_constructor_or_destructor_declaration] = STATE(798),
    [sym_friend_declaration] = STATE(798),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(798),
    [sym_alias_declaration] = STATE(798),
    [sym_static_assert_declaration] = STATE(798),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [798] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3669),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [799] = {
    [sym_preproc_def] = STATE(800),
    [sym_preproc_function_def] = STATE(800),
    [sym_preproc_call] = STATE(800),
    [sym_preproc_if_in_field_declaration_list] = STATE(800),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(800),
    [sym_type_definition] = STATE(800),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5525),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6217),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(800),
    [sym_field_declaration] = STATE(800),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1760),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(800),
    [sym_operator_cast] = STATE(6816),
    [sym_inline_method_definition] = STATE(800),
    [sym__constructor_specifiers] = STATE(1760),
    [sym_operator_cast_definition] = STATE(800),
    [sym_operator_cast_declaration] = STATE(800),
    [sym_constructor_or_destructor_definition] = STATE(800),
    [sym_constructor_or_destructor_declaration] = STATE(800),
    [sym_friend_declaration] = STATE(800),
    [sym_access_specifier] = STATE(8096),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(800),
    [sym_alias_declaration] = STATE(800),
    [sym_static_assert_declaration] = STATE(800),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6816),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(800),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7036),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1760),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3671),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token2] = ACTIONS(3675),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym___extension__] = ACTIONS(3683),
    [anon_sym_typedef] = ACTIONS(3685),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3687),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3689),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3693),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3695),
  },
  [800] = {
    [sym_preproc_def] = STATE(812),
    [sym_preproc_function_def] = STATE(812),
    [sym_preproc_call] = STATE(812),
    [sym_preproc_if_in_field_declaration_list] = STATE(812),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(812),
    [sym_type_definition] = STATE(812),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5525),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6217),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(812),
    [sym_field_declaration] = STATE(812),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1760),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(812),
    [sym_operator_cast] = STATE(6816),
    [sym_inline_method_definition] = STATE(812),
    [sym__constructor_specifiers] = STATE(1760),
    [sym_operator_cast_definition] = STATE(812),
    [sym_operator_cast_declaration] = STATE(812),
    [sym_constructor_or_destructor_definition] = STATE(812),
    [sym_constructor_or_destructor_declaration] = STATE(812),
    [sym_friend_declaration] = STATE(812),
    [sym_access_specifier] = STATE(8096),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(812),
    [sym_alias_declaration] = STATE(812),
    [sym_static_assert_declaration] = STATE(812),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6816),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(812),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7036),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1760),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3671),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token2] = ACTIONS(3697),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3679),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3699),
    [anon_sym___extension__] = ACTIONS(3683),
    [anon_sym_typedef] = ACTIONS(3685),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3687),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3689),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3693),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3695),
  },
  [801] = {
    [sym_preproc_def] = STATE(802),
    [sym_preproc_function_def] = STATE(802),
    [sym_preproc_call] = STATE(802),
    [sym_preproc_if_in_field_declaration_list] = STATE(802),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(802),
    [sym_type_definition] = STATE(802),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(802),
    [sym_field_declaration] = STATE(802),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(802),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(802),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(802),
    [sym_operator_cast_declaration] = STATE(802),
    [sym_constructor_or_destructor_definition] = STATE(802),
    [sym_constructor_or_destructor_declaration] = STATE(802),
    [sym_friend_declaration] = STATE(802),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(802),
    [sym_alias_declaration] = STATE(802),
    [sym_static_assert_declaration] = STATE(802),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(802),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3703),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [802] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [803] = {
    [sym_preproc_def] = STATE(805),
    [sym_preproc_function_def] = STATE(805),
    [sym_preproc_call] = STATE(805),
    [sym_preproc_if_in_field_declaration_list] = STATE(805),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(805),
    [sym_type_definition] = STATE(805),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(805),
    [sym_field_declaration] = STATE(805),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(805),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(805),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(805),
    [sym_operator_cast_declaration] = STATE(805),
    [sym_constructor_or_destructor_definition] = STATE(805),
    [sym_constructor_or_destructor_declaration] = STATE(805),
    [sym_friend_declaration] = STATE(805),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(805),
    [sym_alias_declaration] = STATE(805),
    [sym_static_assert_declaration] = STATE(805),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(805),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [804] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(3449),
    [aux_sym_preproc_def_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3714),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3717),
    [sym_preproc_directive] = ACTIONS(3720),
    [anon_sym_LPAREN2] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3475),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3723),
    [anon_sym___extension__] = ACTIONS(3726),
    [anon_sym_typedef] = ACTIONS(3729),
    [anon_sym_virtual] = ACTIONS(3490),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym___attribute__] = ACTIONS(3496),
    [anon_sym___attribute] = ACTIONS(3496),
    [anon_sym_using] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3508),
    [anon_sym___based] = ACTIONS(3511),
    [anon_sym_RBRACE] = ACTIONS(3735),
    [anon_sym_signed] = ACTIONS(3514),
    [anon_sym_unsigned] = ACTIONS(3514),
    [anon_sym_long] = ACTIONS(3514),
    [anon_sym_short] = ACTIONS(3514),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_register] = ACTIONS(3493),
    [anon_sym_inline] = ACTIONS(3493),
    [anon_sym___inline] = ACTIONS(3493),
    [anon_sym___inline__] = ACTIONS(3493),
    [anon_sym___forceinline] = ACTIONS(3493),
    [anon_sym_thread_local] = ACTIONS(3493),
    [anon_sym___thread] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3520),
    [anon_sym_constexpr] = ACTIONS(3737),
    [anon_sym_volatile] = ACTIONS(3520),
    [anon_sym_restrict] = ACTIONS(3520),
    [anon_sym___restrict__] = ACTIONS(3520),
    [anon_sym__Atomic] = ACTIONS(3520),
    [anon_sym__Noreturn] = ACTIONS(3520),
    [anon_sym_noreturn] = ACTIONS(3520),
    [anon_sym__Nonnull] = ACTIONS(3520),
    [anon_sym_mutable] = ACTIONS(3520),
    [anon_sym_constinit] = ACTIONS(3520),
    [anon_sym_consteval] = ACTIONS(3520),
    [anon_sym_alignas] = ACTIONS(3526),
    [anon_sym__Alignas] = ACTIONS(3526),
    [sym_primitive_type] = ACTIONS(3529),
    [anon_sym_enum] = ACTIONS(3532),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3538),
    [anon_sym_union] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3544),
    [anon_sym_decltype] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3550),
    [anon_sym_typename] = ACTIONS(3553),
    [anon_sym_private] = ACTIONS(3556),
    [anon_sym_template] = ACTIONS(3740),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3743),
    [anon_sym_public] = ACTIONS(3556),
    [anon_sym_protected] = ACTIONS(3556),
    [anon_sym_static_assert] = ACTIONS(3746),
  },
  [805] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [806] = {
    [sym_preproc_def] = STATE(807),
    [sym_preproc_function_def] = STATE(807),
    [sym_preproc_call] = STATE(807),
    [sym_preproc_if_in_field_declaration_list] = STATE(807),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(807),
    [sym_type_definition] = STATE(807),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(807),
    [sym_field_declaration] = STATE(807),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(807),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(807),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(807),
    [sym_operator_cast_declaration] = STATE(807),
    [sym_constructor_or_destructor_definition] = STATE(807),
    [sym_constructor_or_destructor_declaration] = STATE(807),
    [sym_friend_declaration] = STATE(807),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(807),
    [sym_alias_declaration] = STATE(807),
    [sym_static_assert_declaration] = STATE(807),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(807),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3751),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3753),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [807] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [808] = {
    [sym_preproc_def] = STATE(811),
    [sym_preproc_function_def] = STATE(811),
    [sym_preproc_call] = STATE(811),
    [sym_preproc_if_in_field_declaration_list] = STATE(811),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(811),
    [sym_type_definition] = STATE(811),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(811),
    [sym_field_declaration] = STATE(811),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(811),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(811),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(811),
    [sym_operator_cast_declaration] = STATE(811),
    [sym_constructor_or_destructor_definition] = STATE(811),
    [sym_constructor_or_destructor_declaration] = STATE(811),
    [sym_friend_declaration] = STATE(811),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(811),
    [sym_alias_declaration] = STATE(811),
    [sym_static_assert_declaration] = STATE(811),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(811),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3757),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [809] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [810] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3763),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [811] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [812] = {
    [sym_preproc_def] = STATE(812),
    [sym_preproc_function_def] = STATE(812),
    [sym_preproc_call] = STATE(812),
    [sym_preproc_if_in_field_declaration_list] = STATE(812),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(812),
    [sym_type_definition] = STATE(812),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5525),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6217),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(812),
    [sym_field_declaration] = STATE(812),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1760),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(812),
    [sym_operator_cast] = STATE(6816),
    [sym_inline_method_definition] = STATE(812),
    [sym__constructor_specifiers] = STATE(1760),
    [sym_operator_cast_definition] = STATE(812),
    [sym_operator_cast_declaration] = STATE(812),
    [sym_constructor_or_destructor_definition] = STATE(812),
    [sym_constructor_or_destructor_declaration] = STATE(812),
    [sym_friend_declaration] = STATE(812),
    [sym_access_specifier] = STATE(8096),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(812),
    [sym_alias_declaration] = STATE(812),
    [sym_static_assert_declaration] = STATE(812),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6816),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(812),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7036),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1760),
    [sym_identifier] = ACTIONS(3449),
    [aux_sym_preproc_def_token1] = ACTIONS(3767),
    [aux_sym_preproc_if_token1] = ACTIONS(3770),
    [aux_sym_preproc_if_token2] = ACTIONS(3458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3773),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3773),
    [sym_preproc_directive] = ACTIONS(3776),
    [anon_sym_LPAREN2] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3475),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3779),
    [anon_sym___extension__] = ACTIONS(3782),
    [anon_sym_typedef] = ACTIONS(3785),
    [anon_sym_virtual] = ACTIONS(3490),
    [anon_sym_extern] = ACTIONS(3493),
    [anon_sym___attribute__] = ACTIONS(3496),
    [anon_sym___attribute] = ACTIONS(3496),
    [anon_sym_using] = ACTIONS(3788),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3505),
    [anon_sym___declspec] = ACTIONS(3508),
    [anon_sym___based] = ACTIONS(3511),
    [anon_sym_signed] = ACTIONS(3514),
    [anon_sym_unsigned] = ACTIONS(3514),
    [anon_sym_long] = ACTIONS(3514),
    [anon_sym_short] = ACTIONS(3514),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_register] = ACTIONS(3493),
    [anon_sym_inline] = ACTIONS(3493),
    [anon_sym___inline] = ACTIONS(3493),
    [anon_sym___inline__] = ACTIONS(3493),
    [anon_sym___forceinline] = ACTIONS(3493),
    [anon_sym_thread_local] = ACTIONS(3493),
    [anon_sym___thread] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3520),
    [anon_sym_constexpr] = ACTIONS(3791),
    [anon_sym_volatile] = ACTIONS(3520),
    [anon_sym_restrict] = ACTIONS(3520),
    [anon_sym___restrict__] = ACTIONS(3520),
    [anon_sym__Atomic] = ACTIONS(3520),
    [anon_sym__Noreturn] = ACTIONS(3520),
    [anon_sym_noreturn] = ACTIONS(3520),
    [anon_sym__Nonnull] = ACTIONS(3520),
    [anon_sym_mutable] = ACTIONS(3520),
    [anon_sym_constinit] = ACTIONS(3520),
    [anon_sym_consteval] = ACTIONS(3520),
    [anon_sym_alignas] = ACTIONS(3526),
    [anon_sym__Alignas] = ACTIONS(3526),
    [sym_primitive_type] = ACTIONS(3529),
    [anon_sym_enum] = ACTIONS(3532),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3538),
    [anon_sym_union] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3544),
    [anon_sym_decltype] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3550),
    [anon_sym_typename] = ACTIONS(3553),
    [anon_sym_private] = ACTIONS(3556),
    [anon_sym_template] = ACTIONS(3794),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3797),
    [anon_sym_public] = ACTIONS(3556),
    [anon_sym_protected] = ACTIONS(3556),
    [anon_sym_static_assert] = ACTIONS(3800),
  },
  [813] = {
    [sym_preproc_def] = STATE(814),
    [sym_preproc_function_def] = STATE(814),
    [sym_preproc_call] = STATE(814),
    [sym_preproc_if_in_field_declaration_list] = STATE(814),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(814),
    [sym_type_definition] = STATE(814),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(814),
    [sym_field_declaration] = STATE(814),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(814),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(814),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(814),
    [sym_operator_cast_declaration] = STATE(814),
    [sym_constructor_or_destructor_definition] = STATE(814),
    [sym_constructor_or_destructor_declaration] = STATE(814),
    [sym_friend_declaration] = STATE(814),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(814),
    [sym_alias_declaration] = STATE(814),
    [sym_static_assert_declaration] = STATE(814),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(814),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3803),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [814] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3807),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [815] = {
    [sym_preproc_def] = STATE(809),
    [sym_preproc_function_def] = STATE(809),
    [sym_preproc_call] = STATE(809),
    [sym_preproc_if_in_field_declaration_list] = STATE(809),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(809),
    [sym_type_definition] = STATE(809),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(809),
    [sym_field_declaration] = STATE(809),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(809),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(809),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(809),
    [sym_operator_cast_declaration] = STATE(809),
    [sym_constructor_or_destructor_definition] = STATE(809),
    [sym_constructor_or_destructor_declaration] = STATE(809),
    [sym_friend_declaration] = STATE(809),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(809),
    [sym_alias_declaration] = STATE(809),
    [sym_static_assert_declaration] = STATE(809),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(809),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3809),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [816] = {
    [sym_preproc_def] = STATE(795),
    [sym_preproc_function_def] = STATE(795),
    [sym_preproc_call] = STATE(795),
    [sym_preproc_if_in_field_declaration_list] = STATE(795),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(795),
    [sym_type_definition] = STATE(795),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(795),
    [sym_field_declaration] = STATE(795),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(795),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(795),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(795),
    [sym_operator_cast_declaration] = STATE(795),
    [sym_constructor_or_destructor_definition] = STATE(795),
    [sym_constructor_or_destructor_declaration] = STATE(795),
    [sym_friend_declaration] = STATE(795),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(795),
    [sym_alias_declaration] = STATE(795),
    [sym_static_assert_declaration] = STATE(795),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(795),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3813),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3815),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [817] = {
    [sym_preproc_def] = STATE(804),
    [sym_preproc_function_def] = STATE(804),
    [sym_preproc_call] = STATE(804),
    [sym_preproc_if_in_field_declaration_list] = STATE(804),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(804),
    [sym_type_definition] = STATE(804),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(804),
    [sym_field_declaration] = STATE(804),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(804),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(804),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(804),
    [sym_operator_cast_declaration] = STATE(804),
    [sym_constructor_or_destructor_definition] = STATE(804),
    [sym_constructor_or_destructor_declaration] = STATE(804),
    [sym_friend_declaration] = STATE(804),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(804),
    [sym_alias_declaration] = STATE(804),
    [sym_static_assert_declaration] = STATE(804),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(804),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3817),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [818] = {
    [sym_preproc_def] = STATE(817),
    [sym_preproc_function_def] = STATE(817),
    [sym_preproc_call] = STATE(817),
    [sym_preproc_if_in_field_declaration_list] = STATE(817),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(817),
    [sym_type_definition] = STATE(817),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(5498),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3005),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__field_declaration_list_item] = STATE(817),
    [sym_field_declaration] = STATE(817),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(817),
    [sym_operator_cast] = STATE(6839),
    [sym_inline_method_definition] = STATE(817),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(817),
    [sym_operator_cast_declaration] = STATE(817),
    [sym_constructor_or_destructor_definition] = STATE(817),
    [sym_constructor_or_destructor_declaration] = STATE(817),
    [sym_friend_declaration] = STATE(817),
    [sym_access_specifier] = STATE(7967),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_using_declaration] = STATE(817),
    [sym_alias_declaration] = STATE(817),
    [sym_static_assert_declaration] = STATE(817),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5478),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(817),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1993),
    [aux_sym_attributed_declarator_repeat1] = STATE(7067),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(2959),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3639),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(3819),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3821),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_static_assert] = ACTIONS(3659),
  },
  [819] = {
    [sym_expression] = STATE(3797),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_initializer_list] = STATE(3805),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym___attribute] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [820] = {
    [sym_expression] = STATE(3797),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(3805),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_RPAREN] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(1944),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [821] = {
    [sym_expression] = STATE(3797),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_initializer_list] = STATE(3805),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(3851),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [anon_sym_RBRACK] = ACTIONS(1944),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [822] = {
    [sym_expression] = STATE(4498),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_initializer_list] = STATE(3805),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(3869),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [823] = {
    [sym_expression] = STATE(4507),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_initializer_list] = STATE(4828),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(3122),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1944),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_GT_EQ] = ACTIONS(1942),
    [anon_sym_LT_EQ] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_LT_LT] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_LBRACK] = ACTIONS(1944),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(1944),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_LT_EQ_GT] = ACTIONS(1944),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_bitor] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_bitand] = ACTIONS(1942),
    [anon_sym_not_eq] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [anon_sym_DOT] = ACTIONS(1942),
    [anon_sym_DOT_STAR] = ACTIONS(1944),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [824] = {
    [sym_expression] = STATE(4728),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3891),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3851),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_SLASH] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3891),
    [anon_sym_PIPE_PIPE] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3891),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_CARET] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_EQ_EQ] = ACTIONS(3891),
    [anon_sym_BANG_EQ] = ACTIONS(3891),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_GT_EQ] = ACTIONS(3891),
    [anon_sym_LT_EQ] = ACTIONS(3895),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_LT_LT] = ACTIONS(3891),
    [anon_sym_GT_GT] = ACTIONS(3891),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(3891),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_QMARK] = ACTIONS(3891),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_LT_EQ_GT] = ACTIONS(3891),
    [anon_sym_or] = ACTIONS(3895),
    [anon_sym_and] = ACTIONS(3895),
    [anon_sym_bitor] = ACTIONS(3895),
    [anon_sym_xor] = ACTIONS(3895),
    [anon_sym_bitand] = ACTIONS(3895),
    [anon_sym_not_eq] = ACTIONS(3895),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(3895),
    [anon_sym_DOT_STAR] = ACTIONS(3891),
    [anon_sym_DASH_GT] = ACTIONS(3891),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [825] = {
    [sym__declaration_modifiers] = STATE(2092),
    [sym__declaration_specifiers] = STATE(6303),
    [sym_attribute_specifier] = STATE(2092),
    [sym_attribute_declaration] = STATE(2092),
    [sym_ms_declspec_modifier] = STATE(2092),
    [sym_storage_class_specifier] = STATE(2092),
    [sym_type_qualifier] = STATE(2092),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4018),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6599),
    [sym_qualified_type_identifier] = STATE(2809),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2092),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2674),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_BANG] = ACTIONS(3903),
    [anon_sym_TILDE] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_STAR] = ACTIONS(3903),
    [anon_sym_SLASH] = ACTIONS(3903),
    [anon_sym_PERCENT] = ACTIONS(3903),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3903),
    [anon_sym_CARET] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3903),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_GT] = ACTIONS(3903),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(3903),
    [anon_sym_LT_LT] = ACTIONS(3903),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(3905),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(3909),
    [anon_sym_unsigned] = ACTIONS(3909),
    [anon_sym_long] = ACTIONS(3909),
    [anon_sym_short] = ACTIONS(3909),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_EQ] = ACTIONS(3903),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3911),
    [anon_sym_enum] = ACTIONS(3913),
    [anon_sym_class] = ACTIONS(3915),
    [anon_sym_struct] = ACTIONS(3917),
    [anon_sym_union] = ACTIONS(3919),
    [anon_sym_STAR_EQ] = ACTIONS(3901),
    [anon_sym_SLASH_EQ] = ACTIONS(3901),
    [anon_sym_PERCENT_EQ] = ACTIONS(3901),
    [anon_sym_PLUS_EQ] = ACTIONS(3901),
    [anon_sym_DASH_EQ] = ACTIONS(3901),
    [anon_sym_LT_LT_EQ] = ACTIONS(3901),
    [anon_sym_GT_GT_EQ] = ACTIONS(3901),
    [anon_sym_AMP_EQ] = ACTIONS(3901),
    [anon_sym_CARET_EQ] = ACTIONS(3901),
    [anon_sym_PIPE_EQ] = ACTIONS(3901),
    [anon_sym_and_eq] = ACTIONS(3903),
    [anon_sym_or_eq] = ACTIONS(3903),
    [anon_sym_xor_eq] = ACTIONS(3903),
    [anon_sym_not] = ACTIONS(3903),
    [anon_sym_compl] = ACTIONS(3903),
    [anon_sym_LT_EQ_GT] = ACTIONS(3901),
    [anon_sym_or] = ACTIONS(3903),
    [anon_sym_and] = ACTIONS(3903),
    [anon_sym_bitor] = ACTIONS(3903),
    [anon_sym_xor] = ACTIONS(3903),
    [anon_sym_bitand] = ACTIONS(3903),
    [anon_sym_not_eq] = ACTIONS(3903),
    [anon_sym_DASH_DASH] = ACTIONS(3901),
    [anon_sym_PLUS_PLUS] = ACTIONS(3901),
    [anon_sym_DASH_GT] = ACTIONS(3903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3921),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3923),
    [anon_sym_co_await] = ACTIONS(3903),
    [anon_sym_new] = ACTIONS(3923),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3901),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3901),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3901),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3925),
  },
  [826] = {
    [sym__declaration_modifiers] = STATE(2092),
    [sym__declaration_specifiers] = STATE(6303),
    [sym_attribute_specifier] = STATE(2092),
    [sym_attribute_declaration] = STATE(2092),
    [sym_ms_declspec_modifier] = STATE(2092),
    [sym_storage_class_specifier] = STATE(2092),
    [sym_type_qualifier] = STATE(2092),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4018),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6599),
    [sym_qualified_type_identifier] = STATE(2809),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2092),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2674),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3927),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_SLASH] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3929),
    [anon_sym_CARET] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3929),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(3905),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(3909),
    [anon_sym_unsigned] = ACTIONS(3909),
    [anon_sym_long] = ACTIONS(3909),
    [anon_sym_short] = ACTIONS(3909),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3911),
    [anon_sym_enum] = ACTIONS(3913),
    [anon_sym_class] = ACTIONS(3915),
    [anon_sym_struct] = ACTIONS(3917),
    [anon_sym_union] = ACTIONS(3919),
    [anon_sym_STAR_EQ] = ACTIONS(3927),
    [anon_sym_SLASH_EQ] = ACTIONS(3927),
    [anon_sym_PERCENT_EQ] = ACTIONS(3927),
    [anon_sym_PLUS_EQ] = ACTIONS(3927),
    [anon_sym_DASH_EQ] = ACTIONS(3927),
    [anon_sym_LT_LT_EQ] = ACTIONS(3927),
    [anon_sym_GT_GT_EQ] = ACTIONS(3927),
    [anon_sym_AMP_EQ] = ACTIONS(3927),
    [anon_sym_CARET_EQ] = ACTIONS(3927),
    [anon_sym_PIPE_EQ] = ACTIONS(3927),
    [anon_sym_and_eq] = ACTIONS(3929),
    [anon_sym_or_eq] = ACTIONS(3929),
    [anon_sym_xor_eq] = ACTIONS(3929),
    [anon_sym_not] = ACTIONS(3929),
    [anon_sym_compl] = ACTIONS(3929),
    [anon_sym_LT_EQ_GT] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3929),
    [anon_sym_and] = ACTIONS(3929),
    [anon_sym_bitor] = ACTIONS(3929),
    [anon_sym_xor] = ACTIONS(3929),
    [anon_sym_bitand] = ACTIONS(3929),
    [anon_sym_not_eq] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH_GT] = ACTIONS(3929),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3921),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3931),
    [anon_sym_co_await] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3927),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3927),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3927),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3933),
  },
  [827] = {
    [sym_expression] = STATE(4551),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3938),
    [anon_sym_COLON_COLON] = ACTIONS(3941),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(3944),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [828] = {
    [sym_identifier] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3949),
    [anon_sym_BANG] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym___extension__] = ACTIONS(3947),
    [anon_sym_virtual] = ACTIONS(3947),
    [anon_sym_extern] = ACTIONS(3947),
    [anon_sym___attribute__] = ACTIONS(3947),
    [anon_sym___attribute] = ACTIONS(3947),
    [anon_sym_using] = ACTIONS(3947),
    [anon_sym_COLON_COLON] = ACTIONS(3949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3949),
    [anon_sym___declspec] = ACTIONS(3947),
    [anon_sym___based] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_signed] = ACTIONS(3947),
    [anon_sym_unsigned] = ACTIONS(3947),
    [anon_sym_long] = ACTIONS(3947),
    [anon_sym_short] = ACTIONS(3947),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_static] = ACTIONS(3947),
    [anon_sym_RBRACK] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3949),
    [anon_sym_register] = ACTIONS(3947),
    [anon_sym_inline] = ACTIONS(3947),
    [anon_sym___inline] = ACTIONS(3947),
    [anon_sym___inline__] = ACTIONS(3947),
    [anon_sym___forceinline] = ACTIONS(3947),
    [anon_sym_thread_local] = ACTIONS(3947),
    [anon_sym___thread] = ACTIONS(3947),
    [anon_sym_const] = ACTIONS(3947),
    [anon_sym_constexpr] = ACTIONS(3947),
    [anon_sym_volatile] = ACTIONS(3947),
    [anon_sym_restrict] = ACTIONS(3947),
    [anon_sym___restrict__] = ACTIONS(3947),
    [anon_sym__Atomic] = ACTIONS(3947),
    [anon_sym__Noreturn] = ACTIONS(3947),
    [anon_sym_noreturn] = ACTIONS(3947),
    [anon_sym__Nonnull] = ACTIONS(3947),
    [anon_sym_mutable] = ACTIONS(3947),
    [anon_sym_constinit] = ACTIONS(3947),
    [anon_sym_consteval] = ACTIONS(3947),
    [anon_sym_alignas] = ACTIONS(3947),
    [anon_sym__Alignas] = ACTIONS(3947),
    [sym_primitive_type] = ACTIONS(3947),
    [anon_sym_enum] = ACTIONS(3947),
    [anon_sym_class] = ACTIONS(3947),
    [anon_sym_struct] = ACTIONS(3947),
    [anon_sym_union] = ACTIONS(3947),
    [anon_sym_if] = ACTIONS(3947),
    [anon_sym_switch] = ACTIONS(3947),
    [anon_sym_case] = ACTIONS(3947),
    [anon_sym_default] = ACTIONS(3947),
    [anon_sym_while] = ACTIONS(3947),
    [anon_sym_do] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3947),
    [anon_sym_return] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3947),
    [anon_sym_continue] = ACTIONS(3947),
    [anon_sym_goto] = ACTIONS(3947),
    [anon_sym___try] = ACTIONS(3947),
    [anon_sym___leave] = ACTIONS(3947),
    [anon_sym_not] = ACTIONS(3947),
    [anon_sym_compl] = ACTIONS(3947),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_sizeof] = ACTIONS(3947),
    [anon_sym___alignof__] = ACTIONS(3947),
    [anon_sym___alignof] = ACTIONS(3947),
    [anon_sym__alignof] = ACTIONS(3947),
    [anon_sym_alignof] = ACTIONS(3947),
    [anon_sym__Alignof] = ACTIONS(3947),
    [anon_sym_offsetof] = ACTIONS(3947),
    [anon_sym__Generic] = ACTIONS(3947),
    [anon_sym_asm] = ACTIONS(3947),
    [anon_sym___asm__] = ACTIONS(3947),
    [anon_sym___asm] = ACTIONS(3947),
    [sym_number_literal] = ACTIONS(3949),
    [anon_sym_L_SQUOTE] = ACTIONS(3949),
    [anon_sym_u_SQUOTE] = ACTIONS(3949),
    [anon_sym_U_SQUOTE] = ACTIONS(3949),
    [anon_sym_u8_SQUOTE] = ACTIONS(3949),
    [anon_sym_SQUOTE] = ACTIONS(3949),
    [anon_sym_L_DQUOTE] = ACTIONS(3949),
    [anon_sym_u_DQUOTE] = ACTIONS(3949),
    [anon_sym_U_DQUOTE] = ACTIONS(3949),
    [anon_sym_u8_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [sym_true] = ACTIONS(3947),
    [sym_false] = ACTIONS(3947),
    [anon_sym_NULL] = ACTIONS(3947),
    [anon_sym_nullptr] = ACTIONS(3947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3947),
    [anon_sym_decltype] = ACTIONS(3947),
    [anon_sym_explicit] = ACTIONS(3947),
    [anon_sym_typename] = ACTIONS(3947),
    [anon_sym_template] = ACTIONS(3947),
    [anon_sym_GT2] = ACTIONS(3949),
    [anon_sym_operator] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(3947),
    [anon_sym_delete] = ACTIONS(3947),
    [anon_sym_throw] = ACTIONS(3947),
    [anon_sym_co_return] = ACTIONS(3947),
    [anon_sym_co_yield] = ACTIONS(3947),
    [anon_sym_R_DQUOTE] = ACTIONS(3949),
    [anon_sym_LR_DQUOTE] = ACTIONS(3949),
    [anon_sym_uR_DQUOTE] = ACTIONS(3949),
    [anon_sym_UR_DQUOTE] = ACTIONS(3949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3949),
    [anon_sym_co_await] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3947),
    [anon_sym_requires] = ACTIONS(3947),
    [sym_this] = ACTIONS(3947),
  },
  [829] = {
    [sym_identifier] = ACTIONS(3951),
    [anon_sym_COMMA] = ACTIONS(3953),
    [anon_sym_RPAREN] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3953),
    [anon_sym_BANG] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3951),
    [anon_sym_PLUS] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym_SEMI] = ACTIONS(3953),
    [anon_sym___extension__] = ACTIONS(3951),
    [anon_sym_virtual] = ACTIONS(3951),
    [anon_sym_extern] = ACTIONS(3951),
    [anon_sym___attribute__] = ACTIONS(3951),
    [anon_sym___attribute] = ACTIONS(3951),
    [anon_sym_using] = ACTIONS(3951),
    [anon_sym_COLON_COLON] = ACTIONS(3953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3953),
    [anon_sym___declspec] = ACTIONS(3951),
    [anon_sym___based] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_signed] = ACTIONS(3951),
    [anon_sym_unsigned] = ACTIONS(3951),
    [anon_sym_long] = ACTIONS(3951),
    [anon_sym_short] = ACTIONS(3951),
    [anon_sym_LBRACK] = ACTIONS(3951),
    [anon_sym_static] = ACTIONS(3951),
    [anon_sym_RBRACK] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3951),
    [anon_sym_inline] = ACTIONS(3951),
    [anon_sym___inline] = ACTIONS(3951),
    [anon_sym___inline__] = ACTIONS(3951),
    [anon_sym___forceinline] = ACTIONS(3951),
    [anon_sym_thread_local] = ACTIONS(3951),
    [anon_sym___thread] = ACTIONS(3951),
    [anon_sym_const] = ACTIONS(3951),
    [anon_sym_constexpr] = ACTIONS(3951),
    [anon_sym_volatile] = ACTIONS(3951),
    [anon_sym_restrict] = ACTIONS(3951),
    [anon_sym___restrict__] = ACTIONS(3951),
    [anon_sym__Atomic] = ACTIONS(3951),
    [anon_sym__Noreturn] = ACTIONS(3951),
    [anon_sym_noreturn] = ACTIONS(3951),
    [anon_sym__Nonnull] = ACTIONS(3951),
    [anon_sym_mutable] = ACTIONS(3951),
    [anon_sym_constinit] = ACTIONS(3951),
    [anon_sym_consteval] = ACTIONS(3951),
    [anon_sym_alignas] = ACTIONS(3951),
    [anon_sym__Alignas] = ACTIONS(3951),
    [sym_primitive_type] = ACTIONS(3951),
    [anon_sym_enum] = ACTIONS(3951),
    [anon_sym_class] = ACTIONS(3951),
    [anon_sym_struct] = ACTIONS(3951),
    [anon_sym_union] = ACTIONS(3951),
    [anon_sym_if] = ACTIONS(3951),
    [anon_sym_switch] = ACTIONS(3951),
    [anon_sym_case] = ACTIONS(3951),
    [anon_sym_default] = ACTIONS(3951),
    [anon_sym_while] = ACTIONS(3951),
    [anon_sym_do] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3951),
    [anon_sym_return] = ACTIONS(3951),
    [anon_sym_break] = ACTIONS(3951),
    [anon_sym_continue] = ACTIONS(3951),
    [anon_sym_goto] = ACTIONS(3951),
    [anon_sym___try] = ACTIONS(3951),
    [anon_sym___leave] = ACTIONS(3951),
    [anon_sym_not] = ACTIONS(3951),
    [anon_sym_compl] = ACTIONS(3951),
    [anon_sym_DASH_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_PLUS] = ACTIONS(3953),
    [anon_sym_sizeof] = ACTIONS(3951),
    [anon_sym___alignof__] = ACTIONS(3951),
    [anon_sym___alignof] = ACTIONS(3951),
    [anon_sym__alignof] = ACTIONS(3951),
    [anon_sym_alignof] = ACTIONS(3951),
    [anon_sym__Alignof] = ACTIONS(3951),
    [anon_sym_offsetof] = ACTIONS(3951),
    [anon_sym__Generic] = ACTIONS(3951),
    [anon_sym_asm] = ACTIONS(3951),
    [anon_sym___asm__] = ACTIONS(3951),
    [anon_sym___asm] = ACTIONS(3951),
    [sym_number_literal] = ACTIONS(3953),
    [anon_sym_L_SQUOTE] = ACTIONS(3953),
    [anon_sym_u_SQUOTE] = ACTIONS(3953),
    [anon_sym_U_SQUOTE] = ACTIONS(3953),
    [anon_sym_u8_SQUOTE] = ACTIONS(3953),
    [anon_sym_SQUOTE] = ACTIONS(3953),
    [anon_sym_L_DQUOTE] = ACTIONS(3953),
    [anon_sym_u_DQUOTE] = ACTIONS(3953),
    [anon_sym_U_DQUOTE] = ACTIONS(3953),
    [anon_sym_u8_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [sym_true] = ACTIONS(3951),
    [sym_false] = ACTIONS(3951),
    [anon_sym_NULL] = ACTIONS(3951),
    [anon_sym_nullptr] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3951),
    [anon_sym_decltype] = ACTIONS(3951),
    [anon_sym_explicit] = ACTIONS(3951),
    [anon_sym_typename] = ACTIONS(3951),
    [anon_sym_template] = ACTIONS(3951),
    [anon_sym_GT2] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3951),
    [anon_sym_try] = ACTIONS(3951),
    [anon_sym_delete] = ACTIONS(3951),
    [anon_sym_throw] = ACTIONS(3951),
    [anon_sym_co_return] = ACTIONS(3951),
    [anon_sym_co_yield] = ACTIONS(3951),
    [anon_sym_R_DQUOTE] = ACTIONS(3953),
    [anon_sym_LR_DQUOTE] = ACTIONS(3953),
    [anon_sym_uR_DQUOTE] = ACTIONS(3953),
    [anon_sym_UR_DQUOTE] = ACTIONS(3953),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3953),
    [anon_sym_co_await] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3951),
    [anon_sym_requires] = ACTIONS(3951),
    [sym_this] = ACTIONS(3951),
  },
  [830] = {
    [sym_expression] = STATE(3201),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(3955),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3961),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(3964),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [831] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [832] = {
    [sym_function_definition] = STATE(2150),
    [sym_declaration] = STATE(2150),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4684),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1934),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6217),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2745),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(2150),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1760),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(2150),
    [sym_operator_cast] = STATE(6816),
    [sym__constructor_specifiers] = STATE(1760),
    [sym_operator_cast_definition] = STATE(2150),
    [sym_operator_cast_declaration] = STATE(2150),
    [sym_constructor_or_destructor_definition] = STATE(2150),
    [sym_constructor_or_destructor_declaration] = STATE(2150),
    [sym_friend_declaration] = STATE(2150),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(2150),
    [sym_concept_definition] = STATE(2150),
    [sym_requires_clause] = STATE(854),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6816),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1760),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3689),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3693),
    [anon_sym_concept] = ACTIONS(3973),
    [anon_sym_requires] = ACTIONS(3975),
  },
  [833] = {
    [sym_function_definition] = STATE(2066),
    [sym_declaration] = STATE(2066),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4668),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1932),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2736),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(2066),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(2066),
    [sym_operator_cast] = STATE(6839),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(2066),
    [sym_operator_cast_declaration] = STATE(2066),
    [sym_constructor_or_destructor_definition] = STATE(2066),
    [sym_constructor_or_destructor_declaration] = STATE(2066),
    [sym_friend_declaration] = STATE(2066),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(2066),
    [sym_concept_definition] = STATE(2066),
    [sym_requires_clause] = STATE(863),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_concept] = ACTIONS(3979),
    [anon_sym_requires] = ACTIONS(3975),
  },
  [834] = {
    [sym_function_definition] = STATE(1710),
    [sym_declaration] = STATE(1710),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4676),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1933),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2742),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(1710),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(1710),
    [sym_operator_cast] = STATE(6834),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(1710),
    [sym_operator_cast_declaration] = STATE(1710),
    [sym_constructor_or_destructor_definition] = STATE(1710),
    [sym_constructor_or_destructor_declaration] = STATE(1710),
    [sym_friend_declaration] = STATE(1710),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(1710),
    [sym_concept_definition] = STATE(1710),
    [sym_requires_clause] = STATE(849),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3981),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_concept] = ACTIONS(3983),
    [anon_sym_requires] = ACTIONS(3975),
  },
  [835] = {
    [sym_function_definition] = STATE(302),
    [sym_declaration] = STATE(302),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6222),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(302),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1734),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(302),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1734),
    [sym_operator_cast_definition] = STATE(302),
    [sym_operator_cast_declaration] = STATE(302),
    [sym_constructor_or_destructor_definition] = STATE(302),
    [sym_constructor_or_destructor_declaration] = STATE(302),
    [sym_friend_declaration] = STATE(302),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(302),
    [sym_concept_definition] = STATE(302),
    [sym_requires_clause] = STATE(851),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3985),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3987),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3989),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3991),
    [anon_sym_concept] = ACTIONS(337),
    [anon_sym_requires] = ACTIONS(3975),
  },
  [836] = {
    [sym_function_definition] = STATE(704),
    [sym_declaration] = STATE(704),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4658),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1912),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6174),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2729),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(704),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1752),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(704),
    [sym_operator_cast] = STATE(6793),
    [sym__constructor_specifiers] = STATE(1752),
    [sym_operator_cast_definition] = STATE(704),
    [sym_operator_cast_declaration] = STATE(704),
    [sym_constructor_or_destructor_definition] = STATE(704),
    [sym_constructor_or_destructor_declaration] = STATE(704),
    [sym_friend_declaration] = STATE(704),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(704),
    [sym_concept_definition] = STATE(704),
    [sym_requires_clause] = STATE(843),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6793),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1752),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3993),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3995),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3997),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3999),
    [anon_sym_concept] = ACTIONS(934),
    [anon_sym_requires] = ACTIONS(3975),
  },
  [837] = {
    [sym_function_definition] = STATE(784),
    [sym_declaration] = STATE(784),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6242),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(784),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1720),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(784),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1720),
    [sym_operator_cast_definition] = STATE(784),
    [sym_operator_cast_declaration] = STATE(784),
    [sym_constructor_or_destructor_definition] = STATE(784),
    [sym_constructor_or_destructor_declaration] = STATE(784),
    [sym_friend_declaration] = STATE(784),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(784),
    [sym_concept_definition] = STATE(784),
    [sym_requires_clause] = STATE(850),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1720),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4001),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4003),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(4005),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4007),
    [anon_sym_concept] = ACTIONS(241),
    [anon_sym_requires] = ACTIONS(3975),
  },
  [838] = {
    [sym_function_definition] = STATE(648),
    [sym_declaration] = STATE(648),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4748),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6274),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2748),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(648),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1783),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(648),
    [sym_operator_cast] = STATE(6833),
    [sym__constructor_specifiers] = STATE(1783),
    [sym_operator_cast_definition] = STATE(648),
    [sym_operator_cast_declaration] = STATE(648),
    [sym_constructor_or_destructor_definition] = STATE(648),
    [sym_constructor_or_destructor_declaration] = STATE(648),
    [sym_friend_declaration] = STATE(648),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(648),
    [sym_concept_definition] = STATE(648),
    [sym_requires_clause] = STATE(847),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6833),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4009),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4011),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(4013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4015),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_requires] = ACTIONS(3975),
  },
  [839] = {
    [sym_type_qualifier] = STATE(841),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4715),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(841),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4017),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4021),
    [anon_sym_RBRACK] = ACTIONS(4023),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [840] = {
    [sym_type_qualifier] = STATE(859),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4619),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(859),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4031),
    [anon_sym_RBRACK] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [841] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4727),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4037),
    [anon_sym_RBRACK] = ACTIONS(4039),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [842] = {
    [sym_type_qualifier] = STATE(858),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4698),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(858),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4041),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4043),
    [anon_sym_RBRACK] = ACTIONS(4045),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [843] = {
    [sym_function_definition] = STATE(716),
    [sym_declaration] = STATE(716),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4658),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1912),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6174),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2729),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(716),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1752),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(716),
    [sym_operator_cast] = STATE(6793),
    [sym__constructor_specifiers] = STATE(1752),
    [sym_operator_cast_definition] = STATE(716),
    [sym_operator_cast_declaration] = STATE(716),
    [sym_constructor_or_destructor_definition] = STATE(716),
    [sym_constructor_or_destructor_declaration] = STATE(716),
    [sym_friend_declaration] = STATE(716),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(716),
    [sym_concept_definition] = STATE(716),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6793),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1752),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3993),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3995),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3997),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3999),
    [anon_sym_concept] = ACTIONS(934),
  },
  [844] = {
    [sym_type_qualifier] = STATE(852),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4763),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(852),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4047),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(4051),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [845] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4657),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4037),
    [anon_sym_RBRACK] = ACTIONS(4055),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [846] = {
    [sym_type_qualifier] = STATE(865),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4661),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(865),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4057),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4059),
    [anon_sym_RBRACK] = ACTIONS(4061),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [847] = {
    [sym_function_definition] = STATE(606),
    [sym_declaration] = STATE(606),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4748),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6274),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2748),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(606),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1783),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(606),
    [sym_operator_cast] = STATE(6833),
    [sym__constructor_specifiers] = STATE(1783),
    [sym_operator_cast_definition] = STATE(606),
    [sym_operator_cast_declaration] = STATE(606),
    [sym_constructor_or_destructor_definition] = STATE(606),
    [sym_constructor_or_destructor_declaration] = STATE(606),
    [sym_friend_declaration] = STATE(606),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(606),
    [sym_concept_definition] = STATE(606),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6833),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4009),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4011),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(4013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4015),
    [anon_sym_concept] = ACTIONS(153),
  },
  [848] = {
    [sym_type_qualifier] = STATE(867),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4671),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(867),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4065),
    [anon_sym_RBRACK] = ACTIONS(4067),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [849] = {
    [sym_function_definition] = STATE(1817),
    [sym_declaration] = STATE(1817),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4676),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1933),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6218),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2742),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(1817),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1744),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(1817),
    [sym_operator_cast] = STATE(6834),
    [sym__constructor_specifiers] = STATE(1744),
    [sym_operator_cast_definition] = STATE(1817),
    [sym_operator_cast_declaration] = STATE(1817),
    [sym_constructor_or_destructor_definition] = STATE(1817),
    [sym_constructor_or_destructor_declaration] = STATE(1817),
    [sym_friend_declaration] = STATE(1817),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(1817),
    [sym_concept_definition] = STATE(1817),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6834),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1744),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3981),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2997),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3015),
    [anon_sym_concept] = ACTIONS(3983),
  },
  [850] = {
    [sym_function_definition] = STATE(703),
    [sym_declaration] = STATE(703),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1924),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6242),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2758),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(703),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1720),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(703),
    [sym_operator_cast] = STATE(6799),
    [sym__constructor_specifiers] = STATE(1720),
    [sym_operator_cast_definition] = STATE(703),
    [sym_operator_cast_declaration] = STATE(703),
    [sym_constructor_or_destructor_definition] = STATE(703),
    [sym_constructor_or_destructor_declaration] = STATE(703),
    [sym_friend_declaration] = STATE(703),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(703),
    [sym_concept_definition] = STATE(703),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6799),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1720),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4001),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4003),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(4005),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4007),
    [anon_sym_concept] = ACTIONS(241),
  },
  [851] = {
    [sym_function_definition] = STATE(322),
    [sym_declaration] = STATE(322),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1929),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6222),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2724),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(322),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1734),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(322),
    [sym_operator_cast] = STATE(6804),
    [sym__constructor_specifiers] = STATE(1734),
    [sym_operator_cast_definition] = STATE(322),
    [sym_operator_cast_declaration] = STATE(322),
    [sym_constructor_or_destructor_definition] = STATE(322),
    [sym_constructor_or_destructor_declaration] = STATE(322),
    [sym_friend_declaration] = STATE(322),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(322),
    [sym_concept_definition] = STATE(322),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6804),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3985),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3987),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3989),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3991),
    [anon_sym_concept] = ACTIONS(337),
  },
  [852] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4666),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4069),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4037),
    [anon_sym_RBRACK] = ACTIONS(4071),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [853] = {
    [sym_type_qualifier] = STATE(855),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4625),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(855),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4073),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4075),
    [anon_sym_RBRACK] = ACTIONS(4077),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [854] = {
    [sym_function_definition] = STATE(1968),
    [sym_declaration] = STATE(1968),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4684),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1934),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6217),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2745),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(1968),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1760),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(1968),
    [sym_operator_cast] = STATE(6816),
    [sym__constructor_specifiers] = STATE(1760),
    [sym_operator_cast_definition] = STATE(1968),
    [sym_operator_cast_declaration] = STATE(1968),
    [sym_constructor_or_destructor_definition] = STATE(1968),
    [sym_constructor_or_destructor_declaration] = STATE(1968),
    [sym_friend_declaration] = STATE(1968),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(1968),
    [sym_concept_definition] = STATE(1968),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6816),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1760),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3969),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3689),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3693),
    [anon_sym_concept] = ACTIONS(3973),
  },
  [855] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4694),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4079),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4037),
    [anon_sym_RBRACK] = ACTIONS(4081),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [856] = {
    [sym_type_qualifier] = STATE(861),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4769),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(861),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4085),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [857] = {
    [sym_type_qualifier] = STATE(864),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(864),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_RBRACK] = ACTIONS(4093),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [858] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4677),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4037),
    [anon_sym_RBRACK] = ACTIONS(4097),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [859] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4689),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4099),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4037),
    [anon_sym_RBRACK] = ACTIONS(4101),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [860] = {
    [sym_identifier] = ACTIONS(4103),
    [anon_sym_LPAREN2] = ACTIONS(4106),
    [anon_sym_BANG] = ACTIONS(4109),
    [anon_sym_TILDE] = ACTIONS(4106),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_STAR] = ACTIONS(4106),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym___extension__] = ACTIONS(4103),
    [anon_sym_virtual] = ACTIONS(4115),
    [anon_sym_extern] = ACTIONS(4115),
    [anon_sym___attribute__] = ACTIONS(4115),
    [anon_sym___attribute] = ACTIONS(4115),
    [anon_sym_using] = ACTIONS(4111),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4106),
    [anon_sym___declspec] = ACTIONS(4115),
    [anon_sym___based] = ACTIONS(4115),
    [anon_sym_LBRACE] = ACTIONS(4109),
    [anon_sym_signed] = ACTIONS(4115),
    [anon_sym_unsigned] = ACTIONS(4115),
    [anon_sym_long] = ACTIONS(4115),
    [anon_sym_short] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(4103),
    [anon_sym_static] = ACTIONS(4115),
    [anon_sym_register] = ACTIONS(4115),
    [anon_sym_inline] = ACTIONS(4115),
    [anon_sym___inline] = ACTIONS(4115),
    [anon_sym___inline__] = ACTIONS(4115),
    [anon_sym___forceinline] = ACTIONS(4115),
    [anon_sym_thread_local] = ACTIONS(4115),
    [anon_sym___thread] = ACTIONS(4115),
    [anon_sym_const] = ACTIONS(4115),
    [anon_sym_constexpr] = ACTIONS(4115),
    [anon_sym_volatile] = ACTIONS(4115),
    [anon_sym_restrict] = ACTIONS(4115),
    [anon_sym___restrict__] = ACTIONS(4115),
    [anon_sym__Atomic] = ACTIONS(4115),
    [anon_sym__Noreturn] = ACTIONS(4115),
    [anon_sym_noreturn] = ACTIONS(4115),
    [anon_sym__Nonnull] = ACTIONS(4115),
    [anon_sym_mutable] = ACTIONS(4115),
    [anon_sym_constinit] = ACTIONS(4115),
    [anon_sym_consteval] = ACTIONS(4115),
    [anon_sym_alignas] = ACTIONS(4115),
    [anon_sym__Alignas] = ACTIONS(4115),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4115),
    [anon_sym_class] = ACTIONS(4115),
    [anon_sym_struct] = ACTIONS(4115),
    [anon_sym_union] = ACTIONS(4115),
    [anon_sym_if] = ACTIONS(4111),
    [anon_sym_switch] = ACTIONS(4111),
    [anon_sym_case] = ACTIONS(4111),
    [anon_sym_default] = ACTIONS(4111),
    [anon_sym_while] = ACTIONS(4111),
    [anon_sym_do] = ACTIONS(4111),
    [anon_sym_for] = ACTIONS(4111),
    [anon_sym_return] = ACTIONS(4111),
    [anon_sym_break] = ACTIONS(4111),
    [anon_sym_continue] = ACTIONS(4111),
    [anon_sym_goto] = ACTIONS(4111),
    [anon_sym___try] = ACTIONS(4111),
    [anon_sym___leave] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4111),
    [anon_sym_compl] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4109),
    [anon_sym_PLUS_PLUS] = ACTIONS(4109),
    [anon_sym_sizeof] = ACTIONS(4111),
    [anon_sym___alignof__] = ACTIONS(4111),
    [anon_sym___alignof] = ACTIONS(4111),
    [anon_sym__alignof] = ACTIONS(4111),
    [anon_sym_alignof] = ACTIONS(4111),
    [anon_sym__Alignof] = ACTIONS(4111),
    [anon_sym_offsetof] = ACTIONS(4111),
    [anon_sym__Generic] = ACTIONS(4111),
    [anon_sym_asm] = ACTIONS(4111),
    [anon_sym___asm__] = ACTIONS(4111),
    [anon_sym___asm] = ACTIONS(4111),
    [sym_number_literal] = ACTIONS(4109),
    [anon_sym_L_SQUOTE] = ACTIONS(4109),
    [anon_sym_u_SQUOTE] = ACTIONS(4109),
    [anon_sym_U_SQUOTE] = ACTIONS(4109),
    [anon_sym_u8_SQUOTE] = ACTIONS(4109),
    [anon_sym_SQUOTE] = ACTIONS(4109),
    [anon_sym_L_DQUOTE] = ACTIONS(4109),
    [anon_sym_u_DQUOTE] = ACTIONS(4109),
    [anon_sym_U_DQUOTE] = ACTIONS(4109),
    [anon_sym_u8_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_true] = ACTIONS(4111),
    [sym_false] = ACTIONS(4111),
    [anon_sym_NULL] = ACTIONS(4111),
    [anon_sym_nullptr] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4115),
    [anon_sym_decltype] = ACTIONS(4103),
    [anon_sym_explicit] = ACTIONS(4115),
    [anon_sym_typename] = ACTIONS(4115),
    [anon_sym_template] = ACTIONS(4103),
    [anon_sym_operator] = ACTIONS(4115),
    [anon_sym_try] = ACTIONS(4111),
    [anon_sym_delete] = ACTIONS(4111),
    [anon_sym_throw] = ACTIONS(4111),
    [anon_sym_co_return] = ACTIONS(4111),
    [anon_sym_co_yield] = ACTIONS(4111),
    [anon_sym_R_DQUOTE] = ACTIONS(4109),
    [anon_sym_LR_DQUOTE] = ACTIONS(4109),
    [anon_sym_uR_DQUOTE] = ACTIONS(4109),
    [anon_sym_UR_DQUOTE] = ACTIONS(4109),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4109),
    [anon_sym_co_await] = ACTIONS(4111),
    [anon_sym_new] = ACTIONS(4111),
    [anon_sym_requires] = ACTIONS(4111),
    [sym_this] = ACTIONS(4111),
  },
  [861] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4674),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4037),
    [anon_sym_RBRACK] = ACTIONS(4119),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [862] = {
    [sym_type_qualifier] = STATE(845),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(845),
    [sym_identifier] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4123),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4125),
    [anon_sym_RBRACK] = ACTIONS(4127),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [863] = {
    [sym_function_definition] = STATE(2145),
    [sym_declaration] = STATE(2145),
    [sym__declaration_modifiers] = STATE(3120),
    [sym__declaration_specifiers] = STATE(4668),
    [sym_attribute_specifier] = STATE(3120),
    [sym_attribute_declaration] = STATE(3120),
    [sym_ms_declspec_modifier] = STATE(3120),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(1932),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6214),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3120),
    [sym_type_qualifier] = STATE(3120),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2736),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym__empty_declaration] = STATE(2145),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_explicit_function_specifier] = STATE(1812),
    [sym_dependent_type] = STATE(2523),
    [sym_template_declaration] = STATE(2145),
    [sym_operator_cast] = STATE(6839),
    [sym__constructor_specifiers] = STATE(1812),
    [sym_operator_cast_definition] = STATE(2145),
    [sym_operator_cast_declaration] = STATE(2145),
    [sym_constructor_or_destructor_definition] = STATE(2145),
    [sym_constructor_or_destructor_declaration] = STATE(2145),
    [sym_friend_declaration] = STATE(2145),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_alias_declaration] = STATE(2145),
    [sym_concept_definition] = STATE(2145),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5462),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_qualified_operator_cast_identifier] = STATE(6839),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1812),
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3971),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3653),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3657),
    [anon_sym_concept] = ACTIONS(3979),
  },
  [864] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4692),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4129),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4037),
    [anon_sym_RBRACK] = ACTIONS(4131),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [865] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4734),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4133),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4037),
    [anon_sym_RBRACK] = ACTIONS(4135),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [866] = {
    [sym_type_qualifier] = STATE(845),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(845),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4123),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4125),
    [anon_sym_RBRACK] = ACTIONS(4127),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [867] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [sym_expression] = STATE(4632),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4137),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(4037),
    [anon_sym_RBRACK] = ACTIONS(4139),
    [anon_sym_const] = ACTIONS(4025),
    [anon_sym_constexpr] = ACTIONS(4025),
    [anon_sym_volatile] = ACTIONS(4025),
    [anon_sym_restrict] = ACTIONS(4025),
    [anon_sym___restrict__] = ACTIONS(4025),
    [anon_sym__Atomic] = ACTIONS(4025),
    [anon_sym__Noreturn] = ACTIONS(4025),
    [anon_sym_noreturn] = ACTIONS(4025),
    [anon_sym__Nonnull] = ACTIONS(4025),
    [anon_sym_mutable] = ACTIONS(4025),
    [anon_sym_constinit] = ACTIONS(4025),
    [anon_sym_consteval] = ACTIONS(4025),
    [anon_sym_alignas] = ACTIONS(4027),
    [anon_sym__Alignas] = ACTIONS(4027),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [868] = {
    [sym_catch_clause] = STATE(868),
    [aux_sym_constructor_try_statement_repeat1] = STATE(868),
    [sym_identifier] = ACTIONS(2476),
    [anon_sym_LPAREN2] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym___extension__] = ACTIONS(2476),
    [anon_sym_typedef] = ACTIONS(2476),
    [anon_sym_virtual] = ACTIONS(2476),
    [anon_sym_extern] = ACTIONS(2476),
    [anon_sym___attribute__] = ACTIONS(2476),
    [anon_sym___attribute] = ACTIONS(2476),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2478),
    [anon_sym___declspec] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_signed] = ACTIONS(2476),
    [anon_sym_unsigned] = ACTIONS(2476),
    [anon_sym_long] = ACTIONS(2476),
    [anon_sym_short] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_register] = ACTIONS(2476),
    [anon_sym_inline] = ACTIONS(2476),
    [anon_sym___inline] = ACTIONS(2476),
    [anon_sym___inline__] = ACTIONS(2476),
    [anon_sym___forceinline] = ACTIONS(2476),
    [anon_sym_thread_local] = ACTIONS(2476),
    [anon_sym___thread] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_constexpr] = ACTIONS(2476),
    [anon_sym_volatile] = ACTIONS(2476),
    [anon_sym_restrict] = ACTIONS(2476),
    [anon_sym___restrict__] = ACTIONS(2476),
    [anon_sym__Atomic] = ACTIONS(2476),
    [anon_sym__Noreturn] = ACTIONS(2476),
    [anon_sym_noreturn] = ACTIONS(2476),
    [anon_sym__Nonnull] = ACTIONS(2476),
    [anon_sym_mutable] = ACTIONS(2476),
    [anon_sym_constinit] = ACTIONS(2476),
    [anon_sym_consteval] = ACTIONS(2476),
    [anon_sym_alignas] = ACTIONS(2476),
    [anon_sym__Alignas] = ACTIONS(2476),
    [sym_primitive_type] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [anon_sym_class] = ACTIONS(2476),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2476),
    [anon_sym_if] = ACTIONS(2476),
    [anon_sym_else] = ACTIONS(2476),
    [anon_sym_switch] = ACTIONS(2476),
    [anon_sym_while] = ACTIONS(2476),
    [anon_sym_do] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2476),
    [anon_sym_break] = ACTIONS(2476),
    [anon_sym_continue] = ACTIONS(2476),
    [anon_sym_goto] = ACTIONS(2476),
    [anon_sym___try] = ACTIONS(2476),
    [anon_sym___leave] = ACTIONS(2476),
    [anon_sym_not] = ACTIONS(2476),
    [anon_sym_compl] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2476),
    [anon_sym___alignof__] = ACTIONS(2476),
    [anon_sym___alignof] = ACTIONS(2476),
    [anon_sym__alignof] = ACTIONS(2476),
    [anon_sym_alignof] = ACTIONS(2476),
    [anon_sym__Alignof] = ACTIONS(2476),
    [anon_sym_offsetof] = ACTIONS(2476),
    [anon_sym__Generic] = ACTIONS(2476),
    [anon_sym_asm] = ACTIONS(2476),
    [anon_sym___asm__] = ACTIONS(2476),
    [anon_sym___asm] = ACTIONS(2476),
    [sym_number_literal] = ACTIONS(2478),
    [anon_sym_L_SQUOTE] = ACTIONS(2478),
    [anon_sym_u_SQUOTE] = ACTIONS(2478),
    [anon_sym_U_SQUOTE] = ACTIONS(2478),
    [anon_sym_u8_SQUOTE] = ACTIONS(2478),
    [anon_sym_SQUOTE] = ACTIONS(2478),
    [anon_sym_L_DQUOTE] = ACTIONS(2478),
    [anon_sym_u_DQUOTE] = ACTIONS(2478),
    [anon_sym_U_DQUOTE] = ACTIONS(2478),
    [anon_sym_u8_DQUOTE] = ACTIONS(2478),
    [anon_sym_DQUOTE] = ACTIONS(2478),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2476),
    [anon_sym_nullptr] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2476),
    [anon_sym_decltype] = ACTIONS(2476),
    [anon_sym_typename] = ACTIONS(2476),
    [anon_sym_template] = ACTIONS(2476),
    [anon_sym_try] = ACTIONS(2476),
    [anon_sym_delete] = ACTIONS(2476),
    [anon_sym_throw] = ACTIONS(2476),
    [anon_sym_co_return] = ACTIONS(2476),
    [anon_sym_co_yield] = ACTIONS(2476),
    [anon_sym_catch] = ACTIONS(4141),
    [anon_sym_R_DQUOTE] = ACTIONS(2478),
    [anon_sym_LR_DQUOTE] = ACTIONS(2478),
    [anon_sym_uR_DQUOTE] = ACTIONS(2478),
    [anon_sym_UR_DQUOTE] = ACTIONS(2478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2478),
    [anon_sym_co_await] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2476),
    [anon_sym_requires] = ACTIONS(2476),
    [sym_this] = ACTIONS(2476),
  },
  [869] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1604),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4165),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4169),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym___cdecl] = ACTIONS(4144),
    [anon_sym___clrcall] = ACTIONS(4144),
    [anon_sym___stdcall] = ACTIONS(4144),
    [anon_sym___fastcall] = ACTIONS(4144),
    [anon_sym___thiscall] = ACTIONS(4144),
    [anon_sym___vectorcall] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4176),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [870] = {
    [sym_expression] = STATE(2893),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(4184),
    [anon_sym_LPAREN2] = ACTIONS(4187),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4196),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(4199),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [871] = {
    [sym_expression] = STATE(3201),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(3955),
    [anon_sym_LPAREN2] = ACTIONS(4202),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(4205),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(4211),
    [anon_sym___extension__] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3961),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(4199),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [872] = {
    [sym_catch_clause] = STATE(868),
    [aux_sym_constructor_try_statement_repeat1] = STATE(868),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_virtual] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym___attribute] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym__Nonnull] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_goto] = ACTIONS(2483),
    [anon_sym___try] = ACTIONS(2483),
    [anon_sym___leave] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2483),
    [anon_sym_compl] = ACTIONS(2483),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_sizeof] = ACTIONS(2483),
    [anon_sym___alignof__] = ACTIONS(2483),
    [anon_sym___alignof] = ACTIONS(2483),
    [anon_sym__alignof] = ACTIONS(2483),
    [anon_sym_alignof] = ACTIONS(2483),
    [anon_sym__Alignof] = ACTIONS(2483),
    [anon_sym_offsetof] = ACTIONS(2483),
    [anon_sym__Generic] = ACTIONS(2483),
    [anon_sym_asm] = ACTIONS(2483),
    [anon_sym___asm__] = ACTIONS(2483),
    [anon_sym___asm] = ACTIONS(2483),
    [sym_number_literal] = ACTIONS(2485),
    [anon_sym_L_SQUOTE] = ACTIONS(2485),
    [anon_sym_u_SQUOTE] = ACTIONS(2485),
    [anon_sym_U_SQUOTE] = ACTIONS(2485),
    [anon_sym_u8_SQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [anon_sym_L_DQUOTE] = ACTIONS(2485),
    [anon_sym_u_DQUOTE] = ACTIONS(2485),
    [anon_sym_U_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8_DQUOTE] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [anon_sym_NULL] = ACTIONS(2483),
    [anon_sym_nullptr] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_co_return] = ACTIONS(2483),
    [anon_sym_co_yield] = ACTIONS(2483),
    [anon_sym_catch] = ACTIONS(4214),
    [anon_sym_R_DQUOTE] = ACTIONS(2485),
    [anon_sym_LR_DQUOTE] = ACTIONS(2485),
    [anon_sym_uR_DQUOTE] = ACTIONS(2485),
    [anon_sym_UR_DQUOTE] = ACTIONS(2485),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2485),
    [anon_sym_co_await] = ACTIONS(2483),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_requires] = ACTIONS(2483),
    [sym_this] = ACTIONS(2483),
  },
  [873] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1604),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4169),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym___cdecl] = ACTIONS(4144),
    [anon_sym___clrcall] = ACTIONS(4144),
    [anon_sym___stdcall] = ACTIONS(4144),
    [anon_sym___fastcall] = ACTIONS(4144),
    [anon_sym___thiscall] = ACTIONS(4144),
    [anon_sym___vectorcall] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4176),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [874] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1604),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4218),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4169),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym___cdecl] = ACTIONS(4144),
    [anon_sym___clrcall] = ACTIONS(4144),
    [anon_sym___stdcall] = ACTIONS(4144),
    [anon_sym___fastcall] = ACTIONS(4144),
    [anon_sym___thiscall] = ACTIONS(4144),
    [anon_sym___vectorcall] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4176),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [875] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1604),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4169),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym___cdecl] = ACTIONS(4144),
    [anon_sym___clrcall] = ACTIONS(4144),
    [anon_sym___stdcall] = ACTIONS(4144),
    [anon_sym___fastcall] = ACTIONS(4144),
    [anon_sym___thiscall] = ACTIONS(4144),
    [anon_sym___vectorcall] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4176),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [876] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1604),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4222),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4169),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym___cdecl] = ACTIONS(4144),
    [anon_sym___clrcall] = ACTIONS(4144),
    [anon_sym___stdcall] = ACTIONS(4144),
    [anon_sym___fastcall] = ACTIONS(4144),
    [anon_sym___thiscall] = ACTIONS(4144),
    [anon_sym___vectorcall] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4176),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [877] = {
    [sym_expression] = STATE(4533),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_DASH] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4233),
    [anon_sym_STAR] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2560),
    [anon_sym___extension__] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4239),
    [anon_sym_LBRACK] = ACTIONS(4199),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_RBRACK] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2581),
    [anon_sym_not] = ACTIONS(4233),
    [anon_sym_compl] = ACTIONS(4233),
    [anon_sym_DASH_DASH] = ACTIONS(4242),
    [anon_sym_PLUS_PLUS] = ACTIONS(4242),
    [anon_sym_sizeof] = ACTIONS(4245),
    [anon_sym___alignof__] = ACTIONS(4248),
    [anon_sym___alignof] = ACTIONS(4248),
    [anon_sym__alignof] = ACTIONS(4248),
    [anon_sym_alignof] = ACTIONS(4248),
    [anon_sym__Alignof] = ACTIONS(4248),
    [anon_sym_offsetof] = ACTIONS(4251),
    [anon_sym__Generic] = ACTIONS(4254),
    [anon_sym_asm] = ACTIONS(4257),
    [anon_sym___asm__] = ACTIONS(4257),
    [anon_sym___asm] = ACTIONS(4257),
    [sym_number_literal] = ACTIONS(4260),
    [anon_sym_L_SQUOTE] = ACTIONS(4263),
    [anon_sym_u_SQUOTE] = ACTIONS(4263),
    [anon_sym_U_SQUOTE] = ACTIONS(4263),
    [anon_sym_u8_SQUOTE] = ACTIONS(4263),
    [anon_sym_SQUOTE] = ACTIONS(4263),
    [anon_sym_L_DQUOTE] = ACTIONS(4266),
    [anon_sym_u_DQUOTE] = ACTIONS(4266),
    [anon_sym_U_DQUOTE] = ACTIONS(4266),
    [anon_sym_u8_DQUOTE] = ACTIONS(4266),
    [anon_sym_DQUOTE] = ACTIONS(4266),
    [sym_true] = ACTIONS(4269),
    [sym_false] = ACTIONS(4269),
    [anon_sym_NULL] = ACTIONS(4272),
    [anon_sym_nullptr] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_template] = ACTIONS(2587),
    [anon_sym_delete] = ACTIONS(4275),
    [anon_sym_R_DQUOTE] = ACTIONS(4278),
    [anon_sym_LR_DQUOTE] = ACTIONS(4278),
    [anon_sym_uR_DQUOTE] = ACTIONS(4278),
    [anon_sym_UR_DQUOTE] = ACTIONS(4278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4278),
    [anon_sym_co_await] = ACTIONS(4281),
    [anon_sym_new] = ACTIONS(4284),
    [anon_sym_requires] = ACTIONS(4287),
    [sym_this] = ACTIONS(4269),
  },
  [878] = {
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_LPAREN2] = ACTIONS(1934),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_DASH] = ACTIONS(1936),
    [anon_sym_PLUS] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1934),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym___extension__] = ACTIONS(1936),
    [anon_sym_typedef] = ACTIONS(1936),
    [anon_sym_virtual] = ACTIONS(1936),
    [anon_sym_extern] = ACTIONS(1936),
    [anon_sym___attribute__] = ACTIONS(1936),
    [anon_sym___attribute] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1934),
    [anon_sym___declspec] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_signed] = ACTIONS(1936),
    [anon_sym_unsigned] = ACTIONS(1936),
    [anon_sym_long] = ACTIONS(1936),
    [anon_sym_short] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_register] = ACTIONS(1936),
    [anon_sym_inline] = ACTIONS(1936),
    [anon_sym___inline] = ACTIONS(1936),
    [anon_sym___inline__] = ACTIONS(1936),
    [anon_sym___forceinline] = ACTIONS(1936),
    [anon_sym_thread_local] = ACTIONS(1936),
    [anon_sym___thread] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_constexpr] = ACTIONS(1936),
    [anon_sym_volatile] = ACTIONS(1936),
    [anon_sym_restrict] = ACTIONS(1936),
    [anon_sym___restrict__] = ACTIONS(1936),
    [anon_sym__Atomic] = ACTIONS(1936),
    [anon_sym__Noreturn] = ACTIONS(1936),
    [anon_sym_noreturn] = ACTIONS(1936),
    [anon_sym__Nonnull] = ACTIONS(1936),
    [anon_sym_mutable] = ACTIONS(1936),
    [anon_sym_constinit] = ACTIONS(1936),
    [anon_sym_consteval] = ACTIONS(1936),
    [anon_sym_alignas] = ACTIONS(1936),
    [anon_sym__Alignas] = ACTIONS(1936),
    [sym_primitive_type] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_struct] = ACTIONS(1936),
    [anon_sym_union] = ACTIONS(1936),
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(1936),
    [anon_sym_switch] = ACTIONS(1936),
    [anon_sym_while] = ACTIONS(1936),
    [anon_sym_do] = ACTIONS(1936),
    [anon_sym_for] = ACTIONS(1936),
    [anon_sym_return] = ACTIONS(1936),
    [anon_sym_break] = ACTIONS(1936),
    [anon_sym_continue] = ACTIONS(1936),
    [anon_sym_goto] = ACTIONS(1936),
    [anon_sym___try] = ACTIONS(1936),
    [anon_sym___leave] = ACTIONS(1936),
    [anon_sym_not] = ACTIONS(1936),
    [anon_sym_compl] = ACTIONS(1936),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_sizeof] = ACTIONS(1936),
    [anon_sym___alignof__] = ACTIONS(1936),
    [anon_sym___alignof] = ACTIONS(1936),
    [anon_sym__alignof] = ACTIONS(1936),
    [anon_sym_alignof] = ACTIONS(1936),
    [anon_sym__Alignof] = ACTIONS(1936),
    [anon_sym_offsetof] = ACTIONS(1936),
    [anon_sym__Generic] = ACTIONS(1936),
    [anon_sym_asm] = ACTIONS(1936),
    [anon_sym___asm__] = ACTIONS(1936),
    [anon_sym___asm] = ACTIONS(1936),
    [sym_number_literal] = ACTIONS(1934),
    [anon_sym_L_SQUOTE] = ACTIONS(1934),
    [anon_sym_u_SQUOTE] = ACTIONS(1934),
    [anon_sym_U_SQUOTE] = ACTIONS(1934),
    [anon_sym_u8_SQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [anon_sym_L_DQUOTE] = ACTIONS(1934),
    [anon_sym_u_DQUOTE] = ACTIONS(1934),
    [anon_sym_U_DQUOTE] = ACTIONS(1934),
    [anon_sym_u8_DQUOTE] = ACTIONS(1934),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [anon_sym_NULL] = ACTIONS(1936),
    [anon_sym_nullptr] = ACTIONS(1936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1936),
    [anon_sym_decltype] = ACTIONS(1936),
    [anon_sym_typename] = ACTIONS(1936),
    [anon_sym_template] = ACTIONS(1936),
    [anon_sym_try] = ACTIONS(1936),
    [anon_sym_delete] = ACTIONS(1936),
    [anon_sym_throw] = ACTIONS(1936),
    [anon_sym_co_return] = ACTIONS(1936),
    [anon_sym_co_yield] = ACTIONS(1936),
    [anon_sym_catch] = ACTIONS(1936),
    [anon_sym_R_DQUOTE] = ACTIONS(1934),
    [anon_sym_LR_DQUOTE] = ACTIONS(1934),
    [anon_sym_uR_DQUOTE] = ACTIONS(1934),
    [anon_sym_UR_DQUOTE] = ACTIONS(1934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1934),
    [anon_sym_co_await] = ACTIONS(1936),
    [anon_sym_new] = ACTIONS(1936),
    [anon_sym_requires] = ACTIONS(1936),
    [sym_this] = ACTIONS(1936),
  },
  [879] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1604),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4290),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4218),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4169),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym___cdecl] = ACTIONS(4144),
    [anon_sym___clrcall] = ACTIONS(4144),
    [anon_sym___stdcall] = ACTIONS(4144),
    [anon_sym___fastcall] = ACTIONS(4144),
    [anon_sym___thiscall] = ACTIONS(4144),
    [anon_sym___vectorcall] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4176),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [880] = {
    [sym_identifier] = ACTIONS(3951),
    [anon_sym_LPAREN2] = ACTIONS(3953),
    [anon_sym_BANG] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3951),
    [anon_sym_PLUS] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3953),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3953),
    [anon_sym___extension__] = ACTIONS(3951),
    [anon_sym_virtual] = ACTIONS(3951),
    [anon_sym_extern] = ACTIONS(3951),
    [anon_sym___attribute__] = ACTIONS(3951),
    [anon_sym___attribute] = ACTIONS(3951),
    [anon_sym_using] = ACTIONS(3951),
    [anon_sym_COLON_COLON] = ACTIONS(3953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3953),
    [anon_sym___declspec] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_signed] = ACTIONS(3951),
    [anon_sym_unsigned] = ACTIONS(3951),
    [anon_sym_long] = ACTIONS(3951),
    [anon_sym_short] = ACTIONS(3951),
    [anon_sym_LBRACK] = ACTIONS(3951),
    [anon_sym_static] = ACTIONS(3951),
    [anon_sym_register] = ACTIONS(3951),
    [anon_sym_inline] = ACTIONS(3951),
    [anon_sym___inline] = ACTIONS(3951),
    [anon_sym___inline__] = ACTIONS(3951),
    [anon_sym___forceinline] = ACTIONS(3951),
    [anon_sym_thread_local] = ACTIONS(3951),
    [anon_sym___thread] = ACTIONS(3951),
    [anon_sym_const] = ACTIONS(3951),
    [anon_sym_constexpr] = ACTIONS(3951),
    [anon_sym_volatile] = ACTIONS(3951),
    [anon_sym_restrict] = ACTIONS(3951),
    [anon_sym___restrict__] = ACTIONS(3951),
    [anon_sym__Atomic] = ACTIONS(3951),
    [anon_sym__Noreturn] = ACTIONS(3951),
    [anon_sym_noreturn] = ACTIONS(3951),
    [anon_sym__Nonnull] = ACTIONS(3951),
    [anon_sym_mutable] = ACTIONS(3951),
    [anon_sym_constinit] = ACTIONS(3951),
    [anon_sym_consteval] = ACTIONS(3951),
    [anon_sym_alignas] = ACTIONS(3951),
    [anon_sym__Alignas] = ACTIONS(3951),
    [sym_primitive_type] = ACTIONS(3951),
    [anon_sym_enum] = ACTIONS(3951),
    [anon_sym_class] = ACTIONS(3951),
    [anon_sym_struct] = ACTIONS(3951),
    [anon_sym_union] = ACTIONS(3951),
    [anon_sym_if] = ACTIONS(3951),
    [anon_sym_switch] = ACTIONS(3951),
    [anon_sym_case] = ACTIONS(3951),
    [anon_sym_default] = ACTIONS(3951),
    [anon_sym_while] = ACTIONS(3951),
    [anon_sym_do] = ACTIONS(3951),
    [anon_sym_for] = ACTIONS(3951),
    [anon_sym_return] = ACTIONS(3951),
    [anon_sym_break] = ACTIONS(3951),
    [anon_sym_continue] = ACTIONS(3951),
    [anon_sym_goto] = ACTIONS(3951),
    [anon_sym___try] = ACTIONS(3951),
    [anon_sym___leave] = ACTIONS(3951),
    [anon_sym_not] = ACTIONS(3951),
    [anon_sym_compl] = ACTIONS(3951),
    [anon_sym_DASH_DASH] = ACTIONS(3953),
    [anon_sym_PLUS_PLUS] = ACTIONS(3953),
    [anon_sym_sizeof] = ACTIONS(3951),
    [anon_sym___alignof__] = ACTIONS(3951),
    [anon_sym___alignof] = ACTIONS(3951),
    [anon_sym__alignof] = ACTIONS(3951),
    [anon_sym_alignof] = ACTIONS(3951),
    [anon_sym__Alignof] = ACTIONS(3951),
    [anon_sym_offsetof] = ACTIONS(3951),
    [anon_sym__Generic] = ACTIONS(3951),
    [anon_sym_asm] = ACTIONS(3951),
    [anon_sym___asm__] = ACTIONS(3951),
    [anon_sym___asm] = ACTIONS(3951),
    [sym_number_literal] = ACTIONS(3953),
    [anon_sym_L_SQUOTE] = ACTIONS(3953),
    [anon_sym_u_SQUOTE] = ACTIONS(3953),
    [anon_sym_U_SQUOTE] = ACTIONS(3953),
    [anon_sym_u8_SQUOTE] = ACTIONS(3953),
    [anon_sym_SQUOTE] = ACTIONS(3953),
    [anon_sym_L_DQUOTE] = ACTIONS(3953),
    [anon_sym_u_DQUOTE] = ACTIONS(3953),
    [anon_sym_U_DQUOTE] = ACTIONS(3953),
    [anon_sym_u8_DQUOTE] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3953),
    [sym_true] = ACTIONS(3951),
    [sym_false] = ACTIONS(3951),
    [anon_sym_NULL] = ACTIONS(3951),
    [anon_sym_nullptr] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3951),
    [anon_sym_decltype] = ACTIONS(3951),
    [anon_sym_typename] = ACTIONS(3951),
    [anon_sym_template] = ACTIONS(3951),
    [anon_sym_try] = ACTIONS(3951),
    [anon_sym_delete] = ACTIONS(3951),
    [anon_sym_throw] = ACTIONS(3951),
    [anon_sym_co_return] = ACTIONS(3951),
    [anon_sym_co_yield] = ACTIONS(3951),
    [anon_sym_R_DQUOTE] = ACTIONS(3953),
    [anon_sym_LR_DQUOTE] = ACTIONS(3953),
    [anon_sym_uR_DQUOTE] = ACTIONS(3953),
    [anon_sym_UR_DQUOTE] = ACTIONS(3953),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3953),
    [anon_sym_co_await] = ACTIONS(3951),
    [anon_sym_new] = ACTIONS(3951),
    [anon_sym_requires] = ACTIONS(3951),
    [sym_this] = ACTIONS(3951),
  },
  [881] = {
    [sym_identifier] = ACTIONS(3947),
    [anon_sym_LPAREN2] = ACTIONS(3949),
    [anon_sym_BANG] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym___extension__] = ACTIONS(3947),
    [anon_sym_virtual] = ACTIONS(3947),
    [anon_sym_extern] = ACTIONS(3947),
    [anon_sym___attribute__] = ACTIONS(3947),
    [anon_sym___attribute] = ACTIONS(3947),
    [anon_sym_using] = ACTIONS(3947),
    [anon_sym_COLON_COLON] = ACTIONS(3949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3949),
    [anon_sym___declspec] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_signed] = ACTIONS(3947),
    [anon_sym_unsigned] = ACTIONS(3947),
    [anon_sym_long] = ACTIONS(3947),
    [anon_sym_short] = ACTIONS(3947),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_static] = ACTIONS(3947),
    [anon_sym_register] = ACTIONS(3947),
    [anon_sym_inline] = ACTIONS(3947),
    [anon_sym___inline] = ACTIONS(3947),
    [anon_sym___inline__] = ACTIONS(3947),
    [anon_sym___forceinline] = ACTIONS(3947),
    [anon_sym_thread_local] = ACTIONS(3947),
    [anon_sym___thread] = ACTIONS(3947),
    [anon_sym_const] = ACTIONS(3947),
    [anon_sym_constexpr] = ACTIONS(3947),
    [anon_sym_volatile] = ACTIONS(3947),
    [anon_sym_restrict] = ACTIONS(3947),
    [anon_sym___restrict__] = ACTIONS(3947),
    [anon_sym__Atomic] = ACTIONS(3947),
    [anon_sym__Noreturn] = ACTIONS(3947),
    [anon_sym_noreturn] = ACTIONS(3947),
    [anon_sym__Nonnull] = ACTIONS(3947),
    [anon_sym_mutable] = ACTIONS(3947),
    [anon_sym_constinit] = ACTIONS(3947),
    [anon_sym_consteval] = ACTIONS(3947),
    [anon_sym_alignas] = ACTIONS(3947),
    [anon_sym__Alignas] = ACTIONS(3947),
    [sym_primitive_type] = ACTIONS(3947),
    [anon_sym_enum] = ACTIONS(3947),
    [anon_sym_class] = ACTIONS(3947),
    [anon_sym_struct] = ACTIONS(3947),
    [anon_sym_union] = ACTIONS(3947),
    [anon_sym_if] = ACTIONS(3947),
    [anon_sym_switch] = ACTIONS(3947),
    [anon_sym_case] = ACTIONS(3947),
    [anon_sym_default] = ACTIONS(3947),
    [anon_sym_while] = ACTIONS(3947),
    [anon_sym_do] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3947),
    [anon_sym_return] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3947),
    [anon_sym_continue] = ACTIONS(3947),
    [anon_sym_goto] = ACTIONS(3947),
    [anon_sym___try] = ACTIONS(3947),
    [anon_sym___leave] = ACTIONS(3947),
    [anon_sym_not] = ACTIONS(3947),
    [anon_sym_compl] = ACTIONS(3947),
    [anon_sym_DASH_DASH] = ACTIONS(3949),
    [anon_sym_PLUS_PLUS] = ACTIONS(3949),
    [anon_sym_sizeof] = ACTIONS(3947),
    [anon_sym___alignof__] = ACTIONS(3947),
    [anon_sym___alignof] = ACTIONS(3947),
    [anon_sym__alignof] = ACTIONS(3947),
    [anon_sym_alignof] = ACTIONS(3947),
    [anon_sym__Alignof] = ACTIONS(3947),
    [anon_sym_offsetof] = ACTIONS(3947),
    [anon_sym__Generic] = ACTIONS(3947),
    [anon_sym_asm] = ACTIONS(3947),
    [anon_sym___asm__] = ACTIONS(3947),
    [anon_sym___asm] = ACTIONS(3947),
    [sym_number_literal] = ACTIONS(3949),
    [anon_sym_L_SQUOTE] = ACTIONS(3949),
    [anon_sym_u_SQUOTE] = ACTIONS(3949),
    [anon_sym_U_SQUOTE] = ACTIONS(3949),
    [anon_sym_u8_SQUOTE] = ACTIONS(3949),
    [anon_sym_SQUOTE] = ACTIONS(3949),
    [anon_sym_L_DQUOTE] = ACTIONS(3949),
    [anon_sym_u_DQUOTE] = ACTIONS(3949),
    [anon_sym_U_DQUOTE] = ACTIONS(3949),
    [anon_sym_u8_DQUOTE] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3949),
    [sym_true] = ACTIONS(3947),
    [sym_false] = ACTIONS(3947),
    [anon_sym_NULL] = ACTIONS(3947),
    [anon_sym_nullptr] = ACTIONS(3947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3947),
    [anon_sym_decltype] = ACTIONS(3947),
    [anon_sym_typename] = ACTIONS(3947),
    [anon_sym_template] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(3947),
    [anon_sym_delete] = ACTIONS(3947),
    [anon_sym_throw] = ACTIONS(3947),
    [anon_sym_co_return] = ACTIONS(3947),
    [anon_sym_co_yield] = ACTIONS(3947),
    [anon_sym_R_DQUOTE] = ACTIONS(3949),
    [anon_sym_LR_DQUOTE] = ACTIONS(3949),
    [anon_sym_uR_DQUOTE] = ACTIONS(3949),
    [anon_sym_UR_DQUOTE] = ACTIONS(3949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3949),
    [anon_sym_co_await] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(3947),
    [anon_sym_requires] = ACTIONS(3947),
    [sym_this] = ACTIONS(3947),
  },
  [882] = {
    [sym_identifier] = ACTIONS(2619),
    [anon_sym_LPAREN2] = ACTIONS(2621),
    [anon_sym_BANG] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(2619),
    [anon_sym_PLUS] = ACTIONS(2619),
    [anon_sym_STAR] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(2619),
    [anon_sym_typedef] = ACTIONS(2619),
    [anon_sym_virtual] = ACTIONS(2619),
    [anon_sym_extern] = ACTIONS(2619),
    [anon_sym___attribute__] = ACTIONS(2619),
    [anon_sym___attribute] = ACTIONS(2619),
    [anon_sym_COLON_COLON] = ACTIONS(2621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2621),
    [anon_sym___declspec] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_signed] = ACTIONS(2619),
    [anon_sym_unsigned] = ACTIONS(2619),
    [anon_sym_long] = ACTIONS(2619),
    [anon_sym_short] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_register] = ACTIONS(2619),
    [anon_sym_inline] = ACTIONS(2619),
    [anon_sym___inline] = ACTIONS(2619),
    [anon_sym___inline__] = ACTIONS(2619),
    [anon_sym___forceinline] = ACTIONS(2619),
    [anon_sym_thread_local] = ACTIONS(2619),
    [anon_sym___thread] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_constexpr] = ACTIONS(2619),
    [anon_sym_volatile] = ACTIONS(2619),
    [anon_sym_restrict] = ACTIONS(2619),
    [anon_sym___restrict__] = ACTIONS(2619),
    [anon_sym__Atomic] = ACTIONS(2619),
    [anon_sym__Noreturn] = ACTIONS(2619),
    [anon_sym_noreturn] = ACTIONS(2619),
    [anon_sym__Nonnull] = ACTIONS(2619),
    [anon_sym_mutable] = ACTIONS(2619),
    [anon_sym_constinit] = ACTIONS(2619),
    [anon_sym_consteval] = ACTIONS(2619),
    [anon_sym_alignas] = ACTIONS(2619),
    [anon_sym__Alignas] = ACTIONS(2619),
    [sym_primitive_type] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_struct] = ACTIONS(2619),
    [anon_sym_union] = ACTIONS(2619),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_else] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2619),
    [anon_sym_while] = ACTIONS(2619),
    [anon_sym_do] = ACTIONS(2619),
    [anon_sym_for] = ACTIONS(2619),
    [anon_sym_return] = ACTIONS(2619),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_continue] = ACTIONS(2619),
    [anon_sym_goto] = ACTIONS(2619),
    [anon_sym___try] = ACTIONS(2619),
    [anon_sym___leave] = ACTIONS(2619),
    [anon_sym_not] = ACTIONS(2619),
    [anon_sym_compl] = ACTIONS(2619),
    [anon_sym_DASH_DASH] = ACTIONS(2621),
    [anon_sym_PLUS_PLUS] = ACTIONS(2621),
    [anon_sym_sizeof] = ACTIONS(2619),
    [anon_sym___alignof__] = ACTIONS(2619),
    [anon_sym___alignof] = ACTIONS(2619),
    [anon_sym__alignof] = ACTIONS(2619),
    [anon_sym_alignof] = ACTIONS(2619),
    [anon_sym__Alignof] = ACTIONS(2619),
    [anon_sym_offsetof] = ACTIONS(2619),
    [anon_sym__Generic] = ACTIONS(2619),
    [anon_sym_asm] = ACTIONS(2619),
    [anon_sym___asm__] = ACTIONS(2619),
    [anon_sym___asm] = ACTIONS(2619),
    [sym_number_literal] = ACTIONS(2621),
    [anon_sym_L_SQUOTE] = ACTIONS(2621),
    [anon_sym_u_SQUOTE] = ACTIONS(2621),
    [anon_sym_U_SQUOTE] = ACTIONS(2621),
    [anon_sym_u8_SQUOTE] = ACTIONS(2621),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [anon_sym_L_DQUOTE] = ACTIONS(2621),
    [anon_sym_u_DQUOTE] = ACTIONS(2621),
    [anon_sym_U_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8_DQUOTE] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [sym_true] = ACTIONS(2619),
    [sym_false] = ACTIONS(2619),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2619),
    [anon_sym_decltype] = ACTIONS(2619),
    [anon_sym_typename] = ACTIONS(2619),
    [anon_sym_template] = ACTIONS(2619),
    [anon_sym_try] = ACTIONS(2619),
    [anon_sym_delete] = ACTIONS(2619),
    [anon_sym_throw] = ACTIONS(2619),
    [anon_sym_co_return] = ACTIONS(2619),
    [anon_sym_co_yield] = ACTIONS(2619),
    [anon_sym_catch] = ACTIONS(2619),
    [anon_sym_R_DQUOTE] = ACTIONS(2621),
    [anon_sym_LR_DQUOTE] = ACTIONS(2621),
    [anon_sym_uR_DQUOTE] = ACTIONS(2621),
    [anon_sym_UR_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2621),
    [anon_sym_co_await] = ACTIONS(2619),
    [anon_sym_new] = ACTIONS(2619),
    [anon_sym_requires] = ACTIONS(2619),
    [sym_this] = ACTIONS(2619),
  },
  [883] = {
    [sym_else_clause] = STATE(903),
    [sym_identifier] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(4292),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_goto] = ACTIONS(2613),
    [anon_sym___try] = ACTIONS(2613),
    [anon_sym___leave] = ACTIONS(2613),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_compl] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2615),
    [anon_sym_sizeof] = ACTIONS(2613),
    [anon_sym___alignof__] = ACTIONS(2613),
    [anon_sym___alignof] = ACTIONS(2613),
    [anon_sym__alignof] = ACTIONS(2613),
    [anon_sym_alignof] = ACTIONS(2613),
    [anon_sym__Alignof] = ACTIONS(2613),
    [anon_sym_offsetof] = ACTIONS(2613),
    [anon_sym__Generic] = ACTIONS(2613),
    [anon_sym_asm] = ACTIONS(2613),
    [anon_sym___asm__] = ACTIONS(2613),
    [anon_sym___asm] = ACTIONS(2613),
    [sym_number_literal] = ACTIONS(2615),
    [anon_sym_L_SQUOTE] = ACTIONS(2615),
    [anon_sym_u_SQUOTE] = ACTIONS(2615),
    [anon_sym_U_SQUOTE] = ACTIONS(2615),
    [anon_sym_u8_SQUOTE] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2615),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [anon_sym_NULL] = ACTIONS(2613),
    [anon_sym_nullptr] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_co_return] = ACTIONS(2613),
    [anon_sym_co_yield] = ACTIONS(2613),
    [anon_sym_R_DQUOTE] = ACTIONS(2615),
    [anon_sym_LR_DQUOTE] = ACTIONS(2615),
    [anon_sym_uR_DQUOTE] = ACTIONS(2615),
    [anon_sym_UR_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2615),
    [anon_sym_co_await] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_requires] = ACTIONS(2613),
    [sym_this] = ACTIONS(2613),
  },
  [884] = {
    [sym_else_clause] = STATE(916),
    [sym_identifier] = ACTIONS(2623),
    [anon_sym_LPAREN2] = ACTIONS(2625),
    [anon_sym_BANG] = ACTIONS(2625),
    [anon_sym_TILDE] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_AMP] = ACTIONS(2625),
    [anon_sym_SEMI] = ACTIONS(2625),
    [anon_sym___extension__] = ACTIONS(2623),
    [anon_sym_typedef] = ACTIONS(2623),
    [anon_sym_virtual] = ACTIONS(2623),
    [anon_sym_extern] = ACTIONS(2623),
    [anon_sym___attribute__] = ACTIONS(2623),
    [anon_sym___attribute] = ACTIONS(2623),
    [anon_sym_COLON_COLON] = ACTIONS(2625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2625),
    [anon_sym___declspec] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2625),
    [anon_sym_signed] = ACTIONS(2623),
    [anon_sym_unsigned] = ACTIONS(2623),
    [anon_sym_long] = ACTIONS(2623),
    [anon_sym_short] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_static] = ACTIONS(2623),
    [anon_sym_register] = ACTIONS(2623),
    [anon_sym_inline] = ACTIONS(2623),
    [anon_sym___inline] = ACTIONS(2623),
    [anon_sym___inline__] = ACTIONS(2623),
    [anon_sym___forceinline] = ACTIONS(2623),
    [anon_sym_thread_local] = ACTIONS(2623),
    [anon_sym___thread] = ACTIONS(2623),
    [anon_sym_const] = ACTIONS(2623),
    [anon_sym_constexpr] = ACTIONS(2623),
    [anon_sym_volatile] = ACTIONS(2623),
    [anon_sym_restrict] = ACTIONS(2623),
    [anon_sym___restrict__] = ACTIONS(2623),
    [anon_sym__Atomic] = ACTIONS(2623),
    [anon_sym__Noreturn] = ACTIONS(2623),
    [anon_sym_noreturn] = ACTIONS(2623),
    [anon_sym__Nonnull] = ACTIONS(2623),
    [anon_sym_mutable] = ACTIONS(2623),
    [anon_sym_constinit] = ACTIONS(2623),
    [anon_sym_consteval] = ACTIONS(2623),
    [anon_sym_alignas] = ACTIONS(2623),
    [anon_sym__Alignas] = ACTIONS(2623),
    [sym_primitive_type] = ACTIONS(2623),
    [anon_sym_enum] = ACTIONS(2623),
    [anon_sym_class] = ACTIONS(2623),
    [anon_sym_struct] = ACTIONS(2623),
    [anon_sym_union] = ACTIONS(2623),
    [anon_sym_if] = ACTIONS(2623),
    [anon_sym_else] = ACTIONS(4292),
    [anon_sym_switch] = ACTIONS(2623),
    [anon_sym_while] = ACTIONS(2623),
    [anon_sym_do] = ACTIONS(2623),
    [anon_sym_for] = ACTIONS(2623),
    [anon_sym_return] = ACTIONS(2623),
    [anon_sym_break] = ACTIONS(2623),
    [anon_sym_continue] = ACTIONS(2623),
    [anon_sym_goto] = ACTIONS(2623),
    [anon_sym___try] = ACTIONS(2623),
    [anon_sym___leave] = ACTIONS(2623),
    [anon_sym_not] = ACTIONS(2623),
    [anon_sym_compl] = ACTIONS(2623),
    [anon_sym_DASH_DASH] = ACTIONS(2625),
    [anon_sym_PLUS_PLUS] = ACTIONS(2625),
    [anon_sym_sizeof] = ACTIONS(2623),
    [anon_sym___alignof__] = ACTIONS(2623),
    [anon_sym___alignof] = ACTIONS(2623),
    [anon_sym__alignof] = ACTIONS(2623),
    [anon_sym_alignof] = ACTIONS(2623),
    [anon_sym__Alignof] = ACTIONS(2623),
    [anon_sym_offsetof] = ACTIONS(2623),
    [anon_sym__Generic] = ACTIONS(2623),
    [anon_sym_asm] = ACTIONS(2623),
    [anon_sym___asm__] = ACTIONS(2623),
    [anon_sym___asm] = ACTIONS(2623),
    [sym_number_literal] = ACTIONS(2625),
    [anon_sym_L_SQUOTE] = ACTIONS(2625),
    [anon_sym_u_SQUOTE] = ACTIONS(2625),
    [anon_sym_U_SQUOTE] = ACTIONS(2625),
    [anon_sym_u8_SQUOTE] = ACTIONS(2625),
    [anon_sym_SQUOTE] = ACTIONS(2625),
    [anon_sym_L_DQUOTE] = ACTIONS(2625),
    [anon_sym_u_DQUOTE] = ACTIONS(2625),
    [anon_sym_U_DQUOTE] = ACTIONS(2625),
    [anon_sym_u8_DQUOTE] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(2625),
    [sym_true] = ACTIONS(2623),
    [sym_false] = ACTIONS(2623),
    [anon_sym_NULL] = ACTIONS(2623),
    [anon_sym_nullptr] = ACTIONS(2623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2623),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2623),
    [anon_sym_template] = ACTIONS(2623),
    [anon_sym_try] = ACTIONS(2623),
    [anon_sym_delete] = ACTIONS(2623),
    [anon_sym_throw] = ACTIONS(2623),
    [anon_sym_co_return] = ACTIONS(2623),
    [anon_sym_co_yield] = ACTIONS(2623),
    [anon_sym_R_DQUOTE] = ACTIONS(2625),
    [anon_sym_LR_DQUOTE] = ACTIONS(2625),
    [anon_sym_uR_DQUOTE] = ACTIONS(2625),
    [anon_sym_UR_DQUOTE] = ACTIONS(2625),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2625),
    [anon_sym_co_await] = ACTIONS(2623),
    [anon_sym_new] = ACTIONS(2623),
    [anon_sym_requires] = ACTIONS(2623),
    [sym_this] = ACTIONS(2623),
  },
  [885] = {
    [sym_identifier] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1938),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_else] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1940),
    [anon_sym___try] = ACTIONS(1940),
    [anon_sym___leave] = ACTIONS(1940),
    [anon_sym_not] = ACTIONS(1940),
    [anon_sym_compl] = ACTIONS(1940),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_sizeof] = ACTIONS(1940),
    [anon_sym___alignof__] = ACTIONS(1940),
    [anon_sym___alignof] = ACTIONS(1940),
    [anon_sym__alignof] = ACTIONS(1940),
    [anon_sym_alignof] = ACTIONS(1940),
    [anon_sym__Alignof] = ACTIONS(1940),
    [anon_sym_offsetof] = ACTIONS(1940),
    [anon_sym__Generic] = ACTIONS(1940),
    [anon_sym_asm] = ACTIONS(1940),
    [anon_sym___asm__] = ACTIONS(1940),
    [anon_sym___asm] = ACTIONS(1940),
    [sym_number_literal] = ACTIONS(1938),
    [anon_sym_L_SQUOTE] = ACTIONS(1938),
    [anon_sym_u_SQUOTE] = ACTIONS(1938),
    [anon_sym_U_SQUOTE] = ACTIONS(1938),
    [anon_sym_u8_SQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [anon_sym_L_DQUOTE] = ACTIONS(1938),
    [anon_sym_u_DQUOTE] = ACTIONS(1938),
    [anon_sym_U_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8_DQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [anon_sym_NULL] = ACTIONS(1940),
    [anon_sym_nullptr] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_co_return] = ACTIONS(1940),
    [anon_sym_co_yield] = ACTIONS(1940),
    [anon_sym_catch] = ACTIONS(1940),
    [anon_sym_R_DQUOTE] = ACTIONS(1938),
    [anon_sym_LR_DQUOTE] = ACTIONS(1938),
    [anon_sym_uR_DQUOTE] = ACTIONS(1938),
    [anon_sym_UR_DQUOTE] = ACTIONS(1938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1938),
    [anon_sym_co_await] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_requires] = ACTIONS(1940),
    [sym_this] = ACTIONS(1940),
  },
  [886] = {
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym___extension__] = ACTIONS(2711),
    [anon_sym_typedef] = ACTIONS(2711),
    [anon_sym_virtual] = ACTIONS(2711),
    [anon_sym_extern] = ACTIONS(2711),
    [anon_sym___attribute__] = ACTIONS(2711),
    [anon_sym___attribute] = ACTIONS(2711),
    [anon_sym_COLON_COLON] = ACTIONS(2713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2713),
    [anon_sym___declspec] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_signed] = ACTIONS(2711),
    [anon_sym_unsigned] = ACTIONS(2711),
    [anon_sym_long] = ACTIONS(2711),
    [anon_sym_short] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_static] = ACTIONS(2711),
    [anon_sym_register] = ACTIONS(2711),
    [anon_sym_inline] = ACTIONS(2711),
    [anon_sym___inline] = ACTIONS(2711),
    [anon_sym___inline__] = ACTIONS(2711),
    [anon_sym___forceinline] = ACTIONS(2711),
    [anon_sym_thread_local] = ACTIONS(2711),
    [anon_sym___thread] = ACTIONS(2711),
    [anon_sym_const] = ACTIONS(2711),
    [anon_sym_constexpr] = ACTIONS(2711),
    [anon_sym_volatile] = ACTIONS(2711),
    [anon_sym_restrict] = ACTIONS(2711),
    [anon_sym___restrict__] = ACTIONS(2711),
    [anon_sym__Atomic] = ACTIONS(2711),
    [anon_sym__Noreturn] = ACTIONS(2711),
    [anon_sym_noreturn] = ACTIONS(2711),
    [anon_sym__Nonnull] = ACTIONS(2711),
    [anon_sym_mutable] = ACTIONS(2711),
    [anon_sym_constinit] = ACTIONS(2711),
    [anon_sym_consteval] = ACTIONS(2711),
    [anon_sym_alignas] = ACTIONS(2711),
    [anon_sym__Alignas] = ACTIONS(2711),
    [sym_primitive_type] = ACTIONS(2711),
    [anon_sym_enum] = ACTIONS(2711),
    [anon_sym_class] = ACTIONS(2711),
    [anon_sym_struct] = ACTIONS(2711),
    [anon_sym_union] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(2711),
    [anon_sym_else] = ACTIONS(2711),
    [anon_sym_switch] = ACTIONS(2711),
    [anon_sym_while] = ACTIONS(2711),
    [anon_sym_do] = ACTIONS(2711),
    [anon_sym_for] = ACTIONS(2711),
    [anon_sym_return] = ACTIONS(2711),
    [anon_sym_break] = ACTIONS(2711),
    [anon_sym_continue] = ACTIONS(2711),
    [anon_sym_goto] = ACTIONS(2711),
    [anon_sym___try] = ACTIONS(2711),
    [anon_sym___leave] = ACTIONS(2711),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_compl] = ACTIONS(2711),
    [anon_sym_DASH_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_PLUS] = ACTIONS(2713),
    [anon_sym_sizeof] = ACTIONS(2711),
    [anon_sym___alignof__] = ACTIONS(2711),
    [anon_sym___alignof] = ACTIONS(2711),
    [anon_sym__alignof] = ACTIONS(2711),
    [anon_sym_alignof] = ACTIONS(2711),
    [anon_sym__Alignof] = ACTIONS(2711),
    [anon_sym_offsetof] = ACTIONS(2711),
    [anon_sym__Generic] = ACTIONS(2711),
    [anon_sym_asm] = ACTIONS(2711),
    [anon_sym___asm__] = ACTIONS(2711),
    [anon_sym___asm] = ACTIONS(2711),
    [sym_number_literal] = ACTIONS(2713),
    [anon_sym_L_SQUOTE] = ACTIONS(2713),
    [anon_sym_u_SQUOTE] = ACTIONS(2713),
    [anon_sym_U_SQUOTE] = ACTIONS(2713),
    [anon_sym_u8_SQUOTE] = ACTIONS(2713),
    [anon_sym_SQUOTE] = ACTIONS(2713),
    [anon_sym_L_DQUOTE] = ACTIONS(2713),
    [anon_sym_u_DQUOTE] = ACTIONS(2713),
    [anon_sym_U_DQUOTE] = ACTIONS(2713),
    [anon_sym_u8_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [sym_true] = ACTIONS(2711),
    [sym_false] = ACTIONS(2711),
    [anon_sym_NULL] = ACTIONS(2711),
    [anon_sym_nullptr] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2711),
    [anon_sym_decltype] = ACTIONS(2711),
    [anon_sym_typename] = ACTIONS(2711),
    [anon_sym_template] = ACTIONS(2711),
    [anon_sym_try] = ACTIONS(2711),
    [anon_sym_delete] = ACTIONS(2711),
    [anon_sym_throw] = ACTIONS(2711),
    [anon_sym_co_return] = ACTIONS(2711),
    [anon_sym_co_yield] = ACTIONS(2711),
    [anon_sym_R_DQUOTE] = ACTIONS(2713),
    [anon_sym_LR_DQUOTE] = ACTIONS(2713),
    [anon_sym_uR_DQUOTE] = ACTIONS(2713),
    [anon_sym_UR_DQUOTE] = ACTIONS(2713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2713),
    [anon_sym_co_await] = ACTIONS(2711),
    [anon_sym_new] = ACTIONS(2711),
    [anon_sym_requires] = ACTIONS(2711),
    [sym_this] = ACTIONS(2711),
  },
  [887] = {
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym___attribute] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym__Nonnull] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym__Alignas] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [anon_sym___asm] = ACTIONS(2723),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [888] = {
    [sym_identifier] = ACTIONS(2687),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym___extension__] = ACTIONS(2687),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_virtual] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym___attribute] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2689),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2689),
    [anon_sym___declspec] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym___inline] = ACTIONS(2687),
    [anon_sym___inline__] = ACTIONS(2687),
    [anon_sym___forceinline] = ACTIONS(2687),
    [anon_sym_thread_local] = ACTIONS(2687),
    [anon_sym___thread] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_constexpr] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym___restrict__] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym__Noreturn] = ACTIONS(2687),
    [anon_sym_noreturn] = ACTIONS(2687),
    [anon_sym__Nonnull] = ACTIONS(2687),
    [anon_sym_mutable] = ACTIONS(2687),
    [anon_sym_constinit] = ACTIONS(2687),
    [anon_sym_consteval] = ACTIONS(2687),
    [anon_sym_alignas] = ACTIONS(2687),
    [anon_sym__Alignas] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym___try] = ACTIONS(2687),
    [anon_sym___leave] = ACTIONS(2687),
    [anon_sym_not] = ACTIONS(2687),
    [anon_sym_compl] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [anon_sym___alignof__] = ACTIONS(2687),
    [anon_sym___alignof] = ACTIONS(2687),
    [anon_sym__alignof] = ACTIONS(2687),
    [anon_sym_alignof] = ACTIONS(2687),
    [anon_sym__Alignof] = ACTIONS(2687),
    [anon_sym_offsetof] = ACTIONS(2687),
    [anon_sym__Generic] = ACTIONS(2687),
    [anon_sym_asm] = ACTIONS(2687),
    [anon_sym___asm__] = ACTIONS(2687),
    [anon_sym___asm] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [anon_sym_L_SQUOTE] = ACTIONS(2689),
    [anon_sym_u_SQUOTE] = ACTIONS(2689),
    [anon_sym_U_SQUOTE] = ACTIONS(2689),
    [anon_sym_u8_SQUOTE] = ACTIONS(2689),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_L_DQUOTE] = ACTIONS(2689),
    [anon_sym_u_DQUOTE] = ACTIONS(2689),
    [anon_sym_U_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [anon_sym_NULL] = ACTIONS(2687),
    [anon_sym_nullptr] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2687),
    [anon_sym_decltype] = ACTIONS(2687),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2687),
    [anon_sym_try] = ACTIONS(2687),
    [anon_sym_delete] = ACTIONS(2687),
    [anon_sym_throw] = ACTIONS(2687),
    [anon_sym_co_return] = ACTIONS(2687),
    [anon_sym_co_yield] = ACTIONS(2687),
    [anon_sym_R_DQUOTE] = ACTIONS(2689),
    [anon_sym_LR_DQUOTE] = ACTIONS(2689),
    [anon_sym_uR_DQUOTE] = ACTIONS(2689),
    [anon_sym_UR_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2689),
    [anon_sym_co_await] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2687),
    [anon_sym_requires] = ACTIONS(2687),
    [sym_this] = ACTIONS(2687),
  },
  [889] = {
    [sym_identifier] = ACTIONS(2715),
    [anon_sym_LPAREN2] = ACTIONS(2717),
    [anon_sym_BANG] = ACTIONS(2717),
    [anon_sym_TILDE] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_PLUS] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_AMP] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym___extension__] = ACTIONS(2715),
    [anon_sym_typedef] = ACTIONS(2715),
    [anon_sym_virtual] = ACTIONS(2715),
    [anon_sym_extern] = ACTIONS(2715),
    [anon_sym___attribute__] = ACTIONS(2715),
    [anon_sym___attribute] = ACTIONS(2715),
    [anon_sym_COLON_COLON] = ACTIONS(2717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2717),
    [anon_sym___declspec] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2717),
    [anon_sym_signed] = ACTIONS(2715),
    [anon_sym_unsigned] = ACTIONS(2715),
    [anon_sym_long] = ACTIONS(2715),
    [anon_sym_short] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(2715),
    [anon_sym_static] = ACTIONS(2715),
    [anon_sym_register] = ACTIONS(2715),
    [anon_sym_inline] = ACTIONS(2715),
    [anon_sym___inline] = ACTIONS(2715),
    [anon_sym___inline__] = ACTIONS(2715),
    [anon_sym___forceinline] = ACTIONS(2715),
    [anon_sym_thread_local] = ACTIONS(2715),
    [anon_sym___thread] = ACTIONS(2715),
    [anon_sym_const] = ACTIONS(2715),
    [anon_sym_constexpr] = ACTIONS(2715),
    [anon_sym_volatile] = ACTIONS(2715),
    [anon_sym_restrict] = ACTIONS(2715),
    [anon_sym___restrict__] = ACTIONS(2715),
    [anon_sym__Atomic] = ACTIONS(2715),
    [anon_sym__Noreturn] = ACTIONS(2715),
    [anon_sym_noreturn] = ACTIONS(2715),
    [anon_sym__Nonnull] = ACTIONS(2715),
    [anon_sym_mutable] = ACTIONS(2715),
    [anon_sym_constinit] = ACTIONS(2715),
    [anon_sym_consteval] = ACTIONS(2715),
    [anon_sym_alignas] = ACTIONS(2715),
    [anon_sym__Alignas] = ACTIONS(2715),
    [sym_primitive_type] = ACTIONS(2715),
    [anon_sym_enum] = ACTIONS(2715),
    [anon_sym_class] = ACTIONS(2715),
    [anon_sym_struct] = ACTIONS(2715),
    [anon_sym_union] = ACTIONS(2715),
    [anon_sym_if] = ACTIONS(2715),
    [anon_sym_else] = ACTIONS(2715),
    [anon_sym_switch] = ACTIONS(2715),
    [anon_sym_while] = ACTIONS(2715),
    [anon_sym_do] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2715),
    [anon_sym_return] = ACTIONS(2715),
    [anon_sym_break] = ACTIONS(2715),
    [anon_sym_continue] = ACTIONS(2715),
    [anon_sym_goto] = ACTIONS(2715),
    [anon_sym___try] = ACTIONS(2715),
    [anon_sym___leave] = ACTIONS(2715),
    [anon_sym_not] = ACTIONS(2715),
    [anon_sym_compl] = ACTIONS(2715),
    [anon_sym_DASH_DASH] = ACTIONS(2717),
    [anon_sym_PLUS_PLUS] = ACTIONS(2717),
    [anon_sym_sizeof] = ACTIONS(2715),
    [anon_sym___alignof__] = ACTIONS(2715),
    [anon_sym___alignof] = ACTIONS(2715),
    [anon_sym__alignof] = ACTIONS(2715),
    [anon_sym_alignof] = ACTIONS(2715),
    [anon_sym__Alignof] = ACTIONS(2715),
    [anon_sym_offsetof] = ACTIONS(2715),
    [anon_sym__Generic] = ACTIONS(2715),
    [anon_sym_asm] = ACTIONS(2715),
    [anon_sym___asm__] = ACTIONS(2715),
    [anon_sym___asm] = ACTIONS(2715),
    [sym_number_literal] = ACTIONS(2717),
    [anon_sym_L_SQUOTE] = ACTIONS(2717),
    [anon_sym_u_SQUOTE] = ACTIONS(2717),
    [anon_sym_U_SQUOTE] = ACTIONS(2717),
    [anon_sym_u8_SQUOTE] = ACTIONS(2717),
    [anon_sym_SQUOTE] = ACTIONS(2717),
    [anon_sym_L_DQUOTE] = ACTIONS(2717),
    [anon_sym_u_DQUOTE] = ACTIONS(2717),
    [anon_sym_U_DQUOTE] = ACTIONS(2717),
    [anon_sym_u8_DQUOTE] = ACTIONS(2717),
    [anon_sym_DQUOTE] = ACTIONS(2717),
    [sym_true] = ACTIONS(2715),
    [sym_false] = ACTIONS(2715),
    [anon_sym_NULL] = ACTIONS(2715),
    [anon_sym_nullptr] = ACTIONS(2715),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2715),
    [anon_sym_decltype] = ACTIONS(2715),
    [anon_sym_typename] = ACTIONS(2715),
    [anon_sym_template] = ACTIONS(2715),
    [anon_sym_try] = ACTIONS(2715),
    [anon_sym_delete] = ACTIONS(2715),
    [anon_sym_throw] = ACTIONS(2715),
    [anon_sym_co_return] = ACTIONS(2715),
    [anon_sym_co_yield] = ACTIONS(2715),
    [anon_sym_R_DQUOTE] = ACTIONS(2717),
    [anon_sym_LR_DQUOTE] = ACTIONS(2717),
    [anon_sym_uR_DQUOTE] = ACTIONS(2717),
    [anon_sym_UR_DQUOTE] = ACTIONS(2717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2717),
    [anon_sym_co_await] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2715),
    [anon_sym_requires] = ACTIONS(2715),
    [sym_this] = ACTIONS(2715),
  },
  [890] = {
    [sym_identifier] = ACTIONS(2695),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym___extension__] = ACTIONS(2695),
    [anon_sym_typedef] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym___attribute__] = ACTIONS(2695),
    [anon_sym___attribute] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2697),
    [anon_sym___declspec] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_signed] = ACTIONS(2695),
    [anon_sym_unsigned] = ACTIONS(2695),
    [anon_sym_long] = ACTIONS(2695),
    [anon_sym_short] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym___inline] = ACTIONS(2695),
    [anon_sym___inline__] = ACTIONS(2695),
    [anon_sym___forceinline] = ACTIONS(2695),
    [anon_sym_thread_local] = ACTIONS(2695),
    [anon_sym___thread] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym___restrict__] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym__Noreturn] = ACTIONS(2695),
    [anon_sym_noreturn] = ACTIONS(2695),
    [anon_sym__Nonnull] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_constinit] = ACTIONS(2695),
    [anon_sym_consteval] = ACTIONS(2695),
    [anon_sym_alignas] = ACTIONS(2695),
    [anon_sym__Alignas] = ACTIONS(2695),
    [sym_primitive_type] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2695),
    [anon_sym_union] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_goto] = ACTIONS(2695),
    [anon_sym___try] = ACTIONS(2695),
    [anon_sym___leave] = ACTIONS(2695),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_compl] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_sizeof] = ACTIONS(2695),
    [anon_sym___alignof__] = ACTIONS(2695),
    [anon_sym___alignof] = ACTIONS(2695),
    [anon_sym__alignof] = ACTIONS(2695),
    [anon_sym_alignof] = ACTIONS(2695),
    [anon_sym__Alignof] = ACTIONS(2695),
    [anon_sym_offsetof] = ACTIONS(2695),
    [anon_sym__Generic] = ACTIONS(2695),
    [anon_sym_asm] = ACTIONS(2695),
    [anon_sym___asm__] = ACTIONS(2695),
    [anon_sym___asm] = ACTIONS(2695),
    [sym_number_literal] = ACTIONS(2697),
    [anon_sym_L_SQUOTE] = ACTIONS(2697),
    [anon_sym_u_SQUOTE] = ACTIONS(2697),
    [anon_sym_U_SQUOTE] = ACTIONS(2697),
    [anon_sym_u8_SQUOTE] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_L_DQUOTE] = ACTIONS(2697),
    [anon_sym_u_DQUOTE] = ACTIONS(2697),
    [anon_sym_U_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [anon_sym_NULL] = ACTIONS(2695),
    [anon_sym_nullptr] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2695),
    [anon_sym_decltype] = ACTIONS(2695),
    [anon_sym_typename] = ACTIONS(2695),
    [anon_sym_template] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_co_return] = ACTIONS(2695),
    [anon_sym_co_yield] = ACTIONS(2695),
    [anon_sym_R_DQUOTE] = ACTIONS(2697),
    [anon_sym_LR_DQUOTE] = ACTIONS(2697),
    [anon_sym_uR_DQUOTE] = ACTIONS(2697),
    [anon_sym_UR_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2697),
    [anon_sym_co_await] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_requires] = ACTIONS(2695),
    [sym_this] = ACTIONS(2695),
  },
  [891] = {
    [sym_identifier] = ACTIONS(2635),
    [anon_sym_LPAREN2] = ACTIONS(2637),
    [anon_sym_BANG] = ACTIONS(2637),
    [anon_sym_TILDE] = ACTIONS(2637),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2637),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2637),
    [anon_sym___extension__] = ACTIONS(2635),
    [anon_sym_typedef] = ACTIONS(2635),
    [anon_sym_virtual] = ACTIONS(2635),
    [anon_sym_extern] = ACTIONS(2635),
    [anon_sym___attribute__] = ACTIONS(2635),
    [anon_sym___attribute] = ACTIONS(2635),
    [anon_sym_COLON_COLON] = ACTIONS(2637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2637),
    [anon_sym___declspec] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2637),
    [anon_sym_signed] = ACTIONS(2635),
    [anon_sym_unsigned] = ACTIONS(2635),
    [anon_sym_long] = ACTIONS(2635),
    [anon_sym_short] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(2635),
    [anon_sym_static] = ACTIONS(2635),
    [anon_sym_register] = ACTIONS(2635),
    [anon_sym_inline] = ACTIONS(2635),
    [anon_sym___inline] = ACTIONS(2635),
    [anon_sym___inline__] = ACTIONS(2635),
    [anon_sym___forceinline] = ACTIONS(2635),
    [anon_sym_thread_local] = ACTIONS(2635),
    [anon_sym___thread] = ACTIONS(2635),
    [anon_sym_const] = ACTIONS(2635),
    [anon_sym_constexpr] = ACTIONS(2635),
    [anon_sym_volatile] = ACTIONS(2635),
    [anon_sym_restrict] = ACTIONS(2635),
    [anon_sym___restrict__] = ACTIONS(2635),
    [anon_sym__Atomic] = ACTIONS(2635),
    [anon_sym__Noreturn] = ACTIONS(2635),
    [anon_sym_noreturn] = ACTIONS(2635),
    [anon_sym__Nonnull] = ACTIONS(2635),
    [anon_sym_mutable] = ACTIONS(2635),
    [anon_sym_constinit] = ACTIONS(2635),
    [anon_sym_consteval] = ACTIONS(2635),
    [anon_sym_alignas] = ACTIONS(2635),
    [anon_sym__Alignas] = ACTIONS(2635),
    [sym_primitive_type] = ACTIONS(2635),
    [anon_sym_enum] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(2635),
    [anon_sym_struct] = ACTIONS(2635),
    [anon_sym_union] = ACTIONS(2635),
    [anon_sym_if] = ACTIONS(2635),
    [anon_sym_else] = ACTIONS(2635),
    [anon_sym_switch] = ACTIONS(2635),
    [anon_sym_while] = ACTIONS(2635),
    [anon_sym_do] = ACTIONS(2635),
    [anon_sym_for] = ACTIONS(2635),
    [anon_sym_return] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_continue] = ACTIONS(2635),
    [anon_sym_goto] = ACTIONS(2635),
    [anon_sym___try] = ACTIONS(2635),
    [anon_sym___leave] = ACTIONS(2635),
    [anon_sym_not] = ACTIONS(2635),
    [anon_sym_compl] = ACTIONS(2635),
    [anon_sym_DASH_DASH] = ACTIONS(2637),
    [anon_sym_PLUS_PLUS] = ACTIONS(2637),
    [anon_sym_sizeof] = ACTIONS(2635),
    [anon_sym___alignof__] = ACTIONS(2635),
    [anon_sym___alignof] = ACTIONS(2635),
    [anon_sym__alignof] = ACTIONS(2635),
    [anon_sym_alignof] = ACTIONS(2635),
    [anon_sym__Alignof] = ACTIONS(2635),
    [anon_sym_offsetof] = ACTIONS(2635),
    [anon_sym__Generic] = ACTIONS(2635),
    [anon_sym_asm] = ACTIONS(2635),
    [anon_sym___asm__] = ACTIONS(2635),
    [anon_sym___asm] = ACTIONS(2635),
    [sym_number_literal] = ACTIONS(2637),
    [anon_sym_L_SQUOTE] = ACTIONS(2637),
    [anon_sym_u_SQUOTE] = ACTIONS(2637),
    [anon_sym_U_SQUOTE] = ACTIONS(2637),
    [anon_sym_u8_SQUOTE] = ACTIONS(2637),
    [anon_sym_SQUOTE] = ACTIONS(2637),
    [anon_sym_L_DQUOTE] = ACTIONS(2637),
    [anon_sym_u_DQUOTE] = ACTIONS(2637),
    [anon_sym_U_DQUOTE] = ACTIONS(2637),
    [anon_sym_u8_DQUOTE] = ACTIONS(2637),
    [anon_sym_DQUOTE] = ACTIONS(2637),
    [sym_true] = ACTIONS(2635),
    [sym_false] = ACTIONS(2635),
    [anon_sym_NULL] = ACTIONS(2635),
    [anon_sym_nullptr] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2635),
    [anon_sym_decltype] = ACTIONS(2635),
    [anon_sym_typename] = ACTIONS(2635),
    [anon_sym_template] = ACTIONS(2635),
    [anon_sym_try] = ACTIONS(2635),
    [anon_sym_delete] = ACTIONS(2635),
    [anon_sym_throw] = ACTIONS(2635),
    [anon_sym_co_return] = ACTIONS(2635),
    [anon_sym_co_yield] = ACTIONS(2635),
    [anon_sym_R_DQUOTE] = ACTIONS(2637),
    [anon_sym_LR_DQUOTE] = ACTIONS(2637),
    [anon_sym_uR_DQUOTE] = ACTIONS(2637),
    [anon_sym_UR_DQUOTE] = ACTIONS(2637),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2637),
    [anon_sym_co_await] = ACTIONS(2635),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2635),
    [sym_this] = ACTIONS(2635),
  },
  [892] = {
    [sym_identifier] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [anon_sym___asm] = ACTIONS(2735),
    [sym_number_literal] = ACTIONS(2737),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [893] = {
    [sym_identifier] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [894] = {
    [sym_identifier] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [anon_sym___asm] = ACTIONS(2739),
    [sym_number_literal] = ACTIONS(2741),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [895] = {
    [sym_identifier] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_switch] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_goto] = ACTIONS(2759),
    [anon_sym___try] = ACTIONS(2759),
    [anon_sym___leave] = ACTIONS(2759),
    [anon_sym_not] = ACTIONS(2759),
    [anon_sym_compl] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_sizeof] = ACTIONS(2759),
    [anon_sym___alignof__] = ACTIONS(2759),
    [anon_sym___alignof] = ACTIONS(2759),
    [anon_sym__alignof] = ACTIONS(2759),
    [anon_sym_alignof] = ACTIONS(2759),
    [anon_sym__Alignof] = ACTIONS(2759),
    [anon_sym_offsetof] = ACTIONS(2759),
    [anon_sym__Generic] = ACTIONS(2759),
    [anon_sym_asm] = ACTIONS(2759),
    [anon_sym___asm__] = ACTIONS(2759),
    [anon_sym___asm] = ACTIONS(2759),
    [sym_number_literal] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2761),
    [anon_sym_u_SQUOTE] = ACTIONS(2761),
    [anon_sym_U_SQUOTE] = ACTIONS(2761),
    [anon_sym_u8_SQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_L_DQUOTE] = ACTIONS(2761),
    [anon_sym_u_DQUOTE] = ACTIONS(2761),
    [anon_sym_U_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8_DQUOTE] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2759),
    [anon_sym_nullptr] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2759),
    [anon_sym_throw] = ACTIONS(2759),
    [anon_sym_co_return] = ACTIONS(2759),
    [anon_sym_co_yield] = ACTIONS(2759),
    [anon_sym_R_DQUOTE] = ACTIONS(2761),
    [anon_sym_LR_DQUOTE] = ACTIONS(2761),
    [anon_sym_uR_DQUOTE] = ACTIONS(2761),
    [anon_sym_UR_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2761),
    [anon_sym_co_await] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_requires] = ACTIONS(2759),
    [sym_this] = ACTIONS(2759),
  },
  [896] = {
    [sym_identifier] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [897] = {
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_LPAREN2] = ACTIONS(2661),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2661),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym___extension__] = ACTIONS(2659),
    [anon_sym_typedef] = ACTIONS(2659),
    [anon_sym_virtual] = ACTIONS(2659),
    [anon_sym_extern] = ACTIONS(2659),
    [anon_sym___attribute__] = ACTIONS(2659),
    [anon_sym___attribute] = ACTIONS(2659),
    [anon_sym_COLON_COLON] = ACTIONS(2661),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2661),
    [anon_sym___declspec] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2661),
    [anon_sym_signed] = ACTIONS(2659),
    [anon_sym_unsigned] = ACTIONS(2659),
    [anon_sym_long] = ACTIONS(2659),
    [anon_sym_short] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2659),
    [anon_sym_register] = ACTIONS(2659),
    [anon_sym_inline] = ACTIONS(2659),
    [anon_sym___inline] = ACTIONS(2659),
    [anon_sym___inline__] = ACTIONS(2659),
    [anon_sym___forceinline] = ACTIONS(2659),
    [anon_sym_thread_local] = ACTIONS(2659),
    [anon_sym___thread] = ACTIONS(2659),
    [anon_sym_const] = ACTIONS(2659),
    [anon_sym_constexpr] = ACTIONS(2659),
    [anon_sym_volatile] = ACTIONS(2659),
    [anon_sym_restrict] = ACTIONS(2659),
    [anon_sym___restrict__] = ACTIONS(2659),
    [anon_sym__Atomic] = ACTIONS(2659),
    [anon_sym__Noreturn] = ACTIONS(2659),
    [anon_sym_noreturn] = ACTIONS(2659),
    [anon_sym__Nonnull] = ACTIONS(2659),
    [anon_sym_mutable] = ACTIONS(2659),
    [anon_sym_constinit] = ACTIONS(2659),
    [anon_sym_consteval] = ACTIONS(2659),
    [anon_sym_alignas] = ACTIONS(2659),
    [anon_sym__Alignas] = ACTIONS(2659),
    [sym_primitive_type] = ACTIONS(2659),
    [anon_sym_enum] = ACTIONS(2659),
    [anon_sym_class] = ACTIONS(2659),
    [anon_sym_struct] = ACTIONS(2659),
    [anon_sym_union] = ACTIONS(2659),
    [anon_sym_if] = ACTIONS(2659),
    [anon_sym_else] = ACTIONS(2659),
    [anon_sym_switch] = ACTIONS(2659),
    [anon_sym_while] = ACTIONS(2659),
    [anon_sym_do] = ACTIONS(2659),
    [anon_sym_for] = ACTIONS(2659),
    [anon_sym_return] = ACTIONS(2659),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_continue] = ACTIONS(2659),
    [anon_sym_goto] = ACTIONS(2659),
    [anon_sym___try] = ACTIONS(2659),
    [anon_sym___leave] = ACTIONS(2659),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_compl] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2661),
    [anon_sym_PLUS_PLUS] = ACTIONS(2661),
    [anon_sym_sizeof] = ACTIONS(2659),
    [anon_sym___alignof__] = ACTIONS(2659),
    [anon_sym___alignof] = ACTIONS(2659),
    [anon_sym__alignof] = ACTIONS(2659),
    [anon_sym_alignof] = ACTIONS(2659),
    [anon_sym__Alignof] = ACTIONS(2659),
    [anon_sym_offsetof] = ACTIONS(2659),
    [anon_sym__Generic] = ACTIONS(2659),
    [anon_sym_asm] = ACTIONS(2659),
    [anon_sym___asm__] = ACTIONS(2659),
    [anon_sym___asm] = ACTIONS(2659),
    [sym_number_literal] = ACTIONS(2661),
    [anon_sym_L_SQUOTE] = ACTIONS(2661),
    [anon_sym_u_SQUOTE] = ACTIONS(2661),
    [anon_sym_U_SQUOTE] = ACTIONS(2661),
    [anon_sym_u8_SQUOTE] = ACTIONS(2661),
    [anon_sym_SQUOTE] = ACTIONS(2661),
    [anon_sym_L_DQUOTE] = ACTIONS(2661),
    [anon_sym_u_DQUOTE] = ACTIONS(2661),
    [anon_sym_U_DQUOTE] = ACTIONS(2661),
    [anon_sym_u8_DQUOTE] = ACTIONS(2661),
    [anon_sym_DQUOTE] = ACTIONS(2661),
    [sym_true] = ACTIONS(2659),
    [sym_false] = ACTIONS(2659),
    [anon_sym_NULL] = ACTIONS(2659),
    [anon_sym_nullptr] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2659),
    [anon_sym_decltype] = ACTIONS(2659),
    [anon_sym_typename] = ACTIONS(2659),
    [anon_sym_template] = ACTIONS(2659),
    [anon_sym_try] = ACTIONS(2659),
    [anon_sym_delete] = ACTIONS(2659),
    [anon_sym_throw] = ACTIONS(2659),
    [anon_sym_co_return] = ACTIONS(2659),
    [anon_sym_co_yield] = ACTIONS(2659),
    [anon_sym_R_DQUOTE] = ACTIONS(2661),
    [anon_sym_LR_DQUOTE] = ACTIONS(2661),
    [anon_sym_uR_DQUOTE] = ACTIONS(2661),
    [anon_sym_UR_DQUOTE] = ACTIONS(2661),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2661),
    [anon_sym_co_await] = ACTIONS(2659),
    [anon_sym_new] = ACTIONS(2659),
    [anon_sym_requires] = ACTIONS(2659),
    [sym_this] = ACTIONS(2659),
  },
  [898] = {
    [sym_identifier] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2753),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [anon_sym___asm] = ACTIONS(2751),
    [sym_number_literal] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [899] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym___attribute] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym__Nonnull] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym__Alignas] = ACTIONS(2643),
    [sym_primitive_type] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [anon_sym___asm] = ACTIONS(2643),
    [sym_number_literal] = ACTIONS(2645),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [900] = {
    [sym_identifier] = ACTIONS(4103),
    [anon_sym_LPAREN2] = ACTIONS(4109),
    [anon_sym_BANG] = ACTIONS(4109),
    [anon_sym_TILDE] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_STAR] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym___extension__] = ACTIONS(4103),
    [anon_sym_virtual] = ACTIONS(4115),
    [anon_sym_extern] = ACTIONS(4115),
    [anon_sym___attribute__] = ACTIONS(4115),
    [anon_sym___attribute] = ACTIONS(4115),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4106),
    [anon_sym___declspec] = ACTIONS(4115),
    [anon_sym_LBRACE] = ACTIONS(4109),
    [anon_sym_signed] = ACTIONS(4115),
    [anon_sym_unsigned] = ACTIONS(4115),
    [anon_sym_long] = ACTIONS(4115),
    [anon_sym_short] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(4111),
    [anon_sym_static] = ACTIONS(4115),
    [anon_sym_register] = ACTIONS(4115),
    [anon_sym_inline] = ACTIONS(4115),
    [anon_sym___inline] = ACTIONS(4115),
    [anon_sym___inline__] = ACTIONS(4115),
    [anon_sym___forceinline] = ACTIONS(4115),
    [anon_sym_thread_local] = ACTIONS(4115),
    [anon_sym___thread] = ACTIONS(4115),
    [anon_sym_const] = ACTIONS(4115),
    [anon_sym_constexpr] = ACTIONS(4115),
    [anon_sym_volatile] = ACTIONS(4115),
    [anon_sym_restrict] = ACTIONS(4115),
    [anon_sym___restrict__] = ACTIONS(4115),
    [anon_sym__Atomic] = ACTIONS(4115),
    [anon_sym__Noreturn] = ACTIONS(4115),
    [anon_sym_noreturn] = ACTIONS(4115),
    [anon_sym__Nonnull] = ACTIONS(4115),
    [anon_sym_mutable] = ACTIONS(4115),
    [anon_sym_constinit] = ACTIONS(4115),
    [anon_sym_consteval] = ACTIONS(4115),
    [anon_sym_alignas] = ACTIONS(4115),
    [anon_sym__Alignas] = ACTIONS(4115),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4115),
    [anon_sym_class] = ACTIONS(4115),
    [anon_sym_struct] = ACTIONS(4115),
    [anon_sym_union] = ACTIONS(4115),
    [anon_sym_if] = ACTIONS(4111),
    [anon_sym_switch] = ACTIONS(4111),
    [anon_sym_case] = ACTIONS(4111),
    [anon_sym_default] = ACTIONS(4111),
    [anon_sym_while] = ACTIONS(4111),
    [anon_sym_do] = ACTIONS(4111),
    [anon_sym_for] = ACTIONS(4111),
    [anon_sym_return] = ACTIONS(4111),
    [anon_sym_break] = ACTIONS(4111),
    [anon_sym_continue] = ACTIONS(4111),
    [anon_sym_goto] = ACTIONS(4111),
    [anon_sym___try] = ACTIONS(4111),
    [anon_sym___leave] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4111),
    [anon_sym_compl] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4109),
    [anon_sym_PLUS_PLUS] = ACTIONS(4109),
    [anon_sym_sizeof] = ACTIONS(4111),
    [anon_sym___alignof__] = ACTIONS(4111),
    [anon_sym___alignof] = ACTIONS(4111),
    [anon_sym__alignof] = ACTIONS(4111),
    [anon_sym_alignof] = ACTIONS(4111),
    [anon_sym__Alignof] = ACTIONS(4111),
    [anon_sym_offsetof] = ACTIONS(4111),
    [anon_sym__Generic] = ACTIONS(4111),
    [anon_sym_asm] = ACTIONS(4111),
    [anon_sym___asm__] = ACTIONS(4111),
    [anon_sym___asm] = ACTIONS(4111),
    [sym_number_literal] = ACTIONS(4109),
    [anon_sym_L_SQUOTE] = ACTIONS(4109),
    [anon_sym_u_SQUOTE] = ACTIONS(4109),
    [anon_sym_U_SQUOTE] = ACTIONS(4109),
    [anon_sym_u8_SQUOTE] = ACTIONS(4109),
    [anon_sym_SQUOTE] = ACTIONS(4109),
    [anon_sym_L_DQUOTE] = ACTIONS(4109),
    [anon_sym_u_DQUOTE] = ACTIONS(4109),
    [anon_sym_U_DQUOTE] = ACTIONS(4109),
    [anon_sym_u8_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_true] = ACTIONS(4111),
    [sym_false] = ACTIONS(4111),
    [anon_sym_NULL] = ACTIONS(4111),
    [anon_sym_nullptr] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4115),
    [anon_sym_decltype] = ACTIONS(4103),
    [anon_sym_typename] = ACTIONS(4115),
    [anon_sym_template] = ACTIONS(4103),
    [anon_sym_try] = ACTIONS(4111),
    [anon_sym_delete] = ACTIONS(4111),
    [anon_sym_throw] = ACTIONS(4111),
    [anon_sym_co_return] = ACTIONS(4111),
    [anon_sym_co_yield] = ACTIONS(4111),
    [anon_sym_R_DQUOTE] = ACTIONS(4109),
    [anon_sym_LR_DQUOTE] = ACTIONS(4109),
    [anon_sym_uR_DQUOTE] = ACTIONS(4109),
    [anon_sym_UR_DQUOTE] = ACTIONS(4109),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4109),
    [anon_sym_co_await] = ACTIONS(4111),
    [anon_sym_new] = ACTIONS(4111),
    [anon_sym_requires] = ACTIONS(4111),
    [sym_this] = ACTIONS(4111),
  },
  [901] = {
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6451),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3243),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5654),
    [sym_qualified_identifier] = STATE(3252),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(3335),
    [anon_sym_LPAREN2] = ACTIONS(3337),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1812),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [902] = {
    [sym_identifier] = ACTIONS(2707),
    [anon_sym_LPAREN2] = ACTIONS(2709),
    [anon_sym_BANG] = ACTIONS(2709),
    [anon_sym_TILDE] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_PLUS] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2709),
    [anon_sym___extension__] = ACTIONS(2707),
    [anon_sym_typedef] = ACTIONS(2707),
    [anon_sym_virtual] = ACTIONS(2707),
    [anon_sym_extern] = ACTIONS(2707),
    [anon_sym___attribute__] = ACTIONS(2707),
    [anon_sym___attribute] = ACTIONS(2707),
    [anon_sym_COLON_COLON] = ACTIONS(2709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2709),
    [anon_sym___declspec] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2709),
    [anon_sym_signed] = ACTIONS(2707),
    [anon_sym_unsigned] = ACTIONS(2707),
    [anon_sym_long] = ACTIONS(2707),
    [anon_sym_short] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_static] = ACTIONS(2707),
    [anon_sym_register] = ACTIONS(2707),
    [anon_sym_inline] = ACTIONS(2707),
    [anon_sym___inline] = ACTIONS(2707),
    [anon_sym___inline__] = ACTIONS(2707),
    [anon_sym___forceinline] = ACTIONS(2707),
    [anon_sym_thread_local] = ACTIONS(2707),
    [anon_sym___thread] = ACTIONS(2707),
    [anon_sym_const] = ACTIONS(2707),
    [anon_sym_constexpr] = ACTIONS(2707),
    [anon_sym_volatile] = ACTIONS(2707),
    [anon_sym_restrict] = ACTIONS(2707),
    [anon_sym___restrict__] = ACTIONS(2707),
    [anon_sym__Atomic] = ACTIONS(2707),
    [anon_sym__Noreturn] = ACTIONS(2707),
    [anon_sym_noreturn] = ACTIONS(2707),
    [anon_sym__Nonnull] = ACTIONS(2707),
    [anon_sym_mutable] = ACTIONS(2707),
    [anon_sym_constinit] = ACTIONS(2707),
    [anon_sym_consteval] = ACTIONS(2707),
    [anon_sym_alignas] = ACTIONS(2707),
    [anon_sym__Alignas] = ACTIONS(2707),
    [sym_primitive_type] = ACTIONS(2707),
    [anon_sym_enum] = ACTIONS(2707),
    [anon_sym_class] = ACTIONS(2707),
    [anon_sym_struct] = ACTIONS(2707),
    [anon_sym_union] = ACTIONS(2707),
    [anon_sym_if] = ACTIONS(2707),
    [anon_sym_else] = ACTIONS(2707),
    [anon_sym_switch] = ACTIONS(2707),
    [anon_sym_while] = ACTIONS(2707),
    [anon_sym_do] = ACTIONS(2707),
    [anon_sym_for] = ACTIONS(2707),
    [anon_sym_return] = ACTIONS(2707),
    [anon_sym_break] = ACTIONS(2707),
    [anon_sym_continue] = ACTIONS(2707),
    [anon_sym_goto] = ACTIONS(2707),
    [anon_sym___try] = ACTIONS(2707),
    [anon_sym___leave] = ACTIONS(2707),
    [anon_sym_not] = ACTIONS(2707),
    [anon_sym_compl] = ACTIONS(2707),
    [anon_sym_DASH_DASH] = ACTIONS(2709),
    [anon_sym_PLUS_PLUS] = ACTIONS(2709),
    [anon_sym_sizeof] = ACTIONS(2707),
    [anon_sym___alignof__] = ACTIONS(2707),
    [anon_sym___alignof] = ACTIONS(2707),
    [anon_sym__alignof] = ACTIONS(2707),
    [anon_sym_alignof] = ACTIONS(2707),
    [anon_sym__Alignof] = ACTIONS(2707),
    [anon_sym_offsetof] = ACTIONS(2707),
    [anon_sym__Generic] = ACTIONS(2707),
    [anon_sym_asm] = ACTIONS(2707),
    [anon_sym___asm__] = ACTIONS(2707),
    [anon_sym___asm] = ACTIONS(2707),
    [sym_number_literal] = ACTIONS(2709),
    [anon_sym_L_SQUOTE] = ACTIONS(2709),
    [anon_sym_u_SQUOTE] = ACTIONS(2709),
    [anon_sym_U_SQUOTE] = ACTIONS(2709),
    [anon_sym_u8_SQUOTE] = ACTIONS(2709),
    [anon_sym_SQUOTE] = ACTIONS(2709),
    [anon_sym_L_DQUOTE] = ACTIONS(2709),
    [anon_sym_u_DQUOTE] = ACTIONS(2709),
    [anon_sym_U_DQUOTE] = ACTIONS(2709),
    [anon_sym_u8_DQUOTE] = ACTIONS(2709),
    [anon_sym_DQUOTE] = ACTIONS(2709),
    [sym_true] = ACTIONS(2707),
    [sym_false] = ACTIONS(2707),
    [anon_sym_NULL] = ACTIONS(2707),
    [anon_sym_nullptr] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2707),
    [anon_sym_decltype] = ACTIONS(2707),
    [anon_sym_typename] = ACTIONS(2707),
    [anon_sym_template] = ACTIONS(2707),
    [anon_sym_try] = ACTIONS(2707),
    [anon_sym_delete] = ACTIONS(2707),
    [anon_sym_throw] = ACTIONS(2707),
    [anon_sym_co_return] = ACTIONS(2707),
    [anon_sym_co_yield] = ACTIONS(2707),
    [anon_sym_R_DQUOTE] = ACTIONS(2709),
    [anon_sym_LR_DQUOTE] = ACTIONS(2709),
    [anon_sym_uR_DQUOTE] = ACTIONS(2709),
    [anon_sym_UR_DQUOTE] = ACTIONS(2709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2709),
    [anon_sym_co_await] = ACTIONS(2707),
    [anon_sym_new] = ACTIONS(2707),
    [anon_sym_requires] = ACTIONS(2707),
    [sym_this] = ACTIONS(2707),
  },
  [903] = {
    [sym_identifier] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym___attribute] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym__Nonnull] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym__Alignas] = ACTIONS(2665),
    [sym_primitive_type] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [anon_sym___asm] = ACTIONS(2665),
    [sym_number_literal] = ACTIONS(2667),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [904] = {
    [sym_identifier] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2765),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_else] = ACTIONS(2763),
    [anon_sym_switch] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_do] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_goto] = ACTIONS(2763),
    [anon_sym___try] = ACTIONS(2763),
    [anon_sym___leave] = ACTIONS(2763),
    [anon_sym_not] = ACTIONS(2763),
    [anon_sym_compl] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_sizeof] = ACTIONS(2763),
    [anon_sym___alignof__] = ACTIONS(2763),
    [anon_sym___alignof] = ACTIONS(2763),
    [anon_sym__alignof] = ACTIONS(2763),
    [anon_sym_alignof] = ACTIONS(2763),
    [anon_sym__Alignof] = ACTIONS(2763),
    [anon_sym_offsetof] = ACTIONS(2763),
    [anon_sym__Generic] = ACTIONS(2763),
    [anon_sym_asm] = ACTIONS(2763),
    [anon_sym___asm__] = ACTIONS(2763),
    [anon_sym___asm] = ACTIONS(2763),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2765),
    [anon_sym_u_SQUOTE] = ACTIONS(2765),
    [anon_sym_U_SQUOTE] = ACTIONS(2765),
    [anon_sym_u8_SQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_L_DQUOTE] = ACTIONS(2765),
    [anon_sym_u_DQUOTE] = ACTIONS(2765),
    [anon_sym_U_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8_DQUOTE] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [anon_sym_NULL] = ACTIONS(2763),
    [anon_sym_nullptr] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_throw] = ACTIONS(2763),
    [anon_sym_co_return] = ACTIONS(2763),
    [anon_sym_co_yield] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2763),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_requires] = ACTIONS(2763),
    [sym_this] = ACTIONS(2763),
  },
  [905] = {
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym___attribute] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym__Nonnull] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym__Alignas] = ACTIONS(2755),
    [sym_primitive_type] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [anon_sym___asm] = ACTIONS(2755),
    [sym_number_literal] = ACTIONS(2757),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [906] = {
    [sym_identifier] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_virtual] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym___attribute] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym__Nonnull] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [anon_sym___asm] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
  },
  [907] = {
    [sym_identifier] = ACTIONS(2647),
    [anon_sym_LPAREN2] = ACTIONS(2649),
    [anon_sym_BANG] = ACTIONS(2649),
    [anon_sym_TILDE] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2649),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2649),
    [anon_sym___extension__] = ACTIONS(2647),
    [anon_sym_typedef] = ACTIONS(2647),
    [anon_sym_virtual] = ACTIONS(2647),
    [anon_sym_extern] = ACTIONS(2647),
    [anon_sym___attribute__] = ACTIONS(2647),
    [anon_sym___attribute] = ACTIONS(2647),
    [anon_sym_COLON_COLON] = ACTIONS(2649),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2649),
    [anon_sym___declspec] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2649),
    [anon_sym_signed] = ACTIONS(2647),
    [anon_sym_unsigned] = ACTIONS(2647),
    [anon_sym_long] = ACTIONS(2647),
    [anon_sym_short] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2647),
    [anon_sym_static] = ACTIONS(2647),
    [anon_sym_register] = ACTIONS(2647),
    [anon_sym_inline] = ACTIONS(2647),
    [anon_sym___inline] = ACTIONS(2647),
    [anon_sym___inline__] = ACTIONS(2647),
    [anon_sym___forceinline] = ACTIONS(2647),
    [anon_sym_thread_local] = ACTIONS(2647),
    [anon_sym___thread] = ACTIONS(2647),
    [anon_sym_const] = ACTIONS(2647),
    [anon_sym_constexpr] = ACTIONS(2647),
    [anon_sym_volatile] = ACTIONS(2647),
    [anon_sym_restrict] = ACTIONS(2647),
    [anon_sym___restrict__] = ACTIONS(2647),
    [anon_sym__Atomic] = ACTIONS(2647),
    [anon_sym__Noreturn] = ACTIONS(2647),
    [anon_sym_noreturn] = ACTIONS(2647),
    [anon_sym__Nonnull] = ACTIONS(2647),
    [anon_sym_mutable] = ACTIONS(2647),
    [anon_sym_constinit] = ACTIONS(2647),
    [anon_sym_consteval] = ACTIONS(2647),
    [anon_sym_alignas] = ACTIONS(2647),
    [anon_sym__Alignas] = ACTIONS(2647),
    [sym_primitive_type] = ACTIONS(2647),
    [anon_sym_enum] = ACTIONS(2647),
    [anon_sym_class] = ACTIONS(2647),
    [anon_sym_struct] = ACTIONS(2647),
    [anon_sym_union] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2647),
    [anon_sym_else] = ACTIONS(2647),
    [anon_sym_switch] = ACTIONS(2647),
    [anon_sym_while] = ACTIONS(2647),
    [anon_sym_do] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_return] = ACTIONS(2647),
    [anon_sym_break] = ACTIONS(2647),
    [anon_sym_continue] = ACTIONS(2647),
    [anon_sym_goto] = ACTIONS(2647),
    [anon_sym___try] = ACTIONS(2647),
    [anon_sym___leave] = ACTIONS(2647),
    [anon_sym_not] = ACTIONS(2647),
    [anon_sym_compl] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2649),
    [anon_sym_PLUS_PLUS] = ACTIONS(2649),
    [anon_sym_sizeof] = ACTIONS(2647),
    [anon_sym___alignof__] = ACTIONS(2647),
    [anon_sym___alignof] = ACTIONS(2647),
    [anon_sym__alignof] = ACTIONS(2647),
    [anon_sym_alignof] = ACTIONS(2647),
    [anon_sym__Alignof] = ACTIONS(2647),
    [anon_sym_offsetof] = ACTIONS(2647),
    [anon_sym__Generic] = ACTIONS(2647),
    [anon_sym_asm] = ACTIONS(2647),
    [anon_sym___asm__] = ACTIONS(2647),
    [anon_sym___asm] = ACTIONS(2647),
    [sym_number_literal] = ACTIONS(2649),
    [anon_sym_L_SQUOTE] = ACTIONS(2649),
    [anon_sym_u_SQUOTE] = ACTIONS(2649),
    [anon_sym_U_SQUOTE] = ACTIONS(2649),
    [anon_sym_u8_SQUOTE] = ACTIONS(2649),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_L_DQUOTE] = ACTIONS(2649),
    [anon_sym_u_DQUOTE] = ACTIONS(2649),
    [anon_sym_U_DQUOTE] = ACTIONS(2649),
    [anon_sym_u8_DQUOTE] = ACTIONS(2649),
    [anon_sym_DQUOTE] = ACTIONS(2649),
    [sym_true] = ACTIONS(2647),
    [sym_false] = ACTIONS(2647),
    [anon_sym_NULL] = ACTIONS(2647),
    [anon_sym_nullptr] = ACTIONS(2647),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2647),
    [anon_sym_decltype] = ACTIONS(2647),
    [anon_sym_typename] = ACTIONS(2647),
    [anon_sym_template] = ACTIONS(2647),
    [anon_sym_try] = ACTIONS(2647),
    [anon_sym_delete] = ACTIONS(2647),
    [anon_sym_throw] = ACTIONS(2647),
    [anon_sym_co_return] = ACTIONS(2647),
    [anon_sym_co_yield] = ACTIONS(2647),
    [anon_sym_R_DQUOTE] = ACTIONS(2649),
    [anon_sym_LR_DQUOTE] = ACTIONS(2649),
    [anon_sym_uR_DQUOTE] = ACTIONS(2649),
    [anon_sym_UR_DQUOTE] = ACTIONS(2649),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2649),
    [anon_sym_co_await] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(2647),
    [anon_sym_requires] = ACTIONS(2647),
    [sym_this] = ACTIONS(2647),
  },
  [908] = {
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_LPAREN2] = ACTIONS(2633),
    [anon_sym_BANG] = ACTIONS(2633),
    [anon_sym_TILDE] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym___extension__] = ACTIONS(2631),
    [anon_sym_typedef] = ACTIONS(2631),
    [anon_sym_virtual] = ACTIONS(2631),
    [anon_sym_extern] = ACTIONS(2631),
    [anon_sym___attribute__] = ACTIONS(2631),
    [anon_sym___attribute] = ACTIONS(2631),
    [anon_sym_COLON_COLON] = ACTIONS(2633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2633),
    [anon_sym___declspec] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_signed] = ACTIONS(2631),
    [anon_sym_unsigned] = ACTIONS(2631),
    [anon_sym_long] = ACTIONS(2631),
    [anon_sym_short] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2631),
    [anon_sym_static] = ACTIONS(2631),
    [anon_sym_register] = ACTIONS(2631),
    [anon_sym_inline] = ACTIONS(2631),
    [anon_sym___inline] = ACTIONS(2631),
    [anon_sym___inline__] = ACTIONS(2631),
    [anon_sym___forceinline] = ACTIONS(2631),
    [anon_sym_thread_local] = ACTIONS(2631),
    [anon_sym___thread] = ACTIONS(2631),
    [anon_sym_const] = ACTIONS(2631),
    [anon_sym_constexpr] = ACTIONS(2631),
    [anon_sym_volatile] = ACTIONS(2631),
    [anon_sym_restrict] = ACTIONS(2631),
    [anon_sym___restrict__] = ACTIONS(2631),
    [anon_sym__Atomic] = ACTIONS(2631),
    [anon_sym__Noreturn] = ACTIONS(2631),
    [anon_sym_noreturn] = ACTIONS(2631),
    [anon_sym__Nonnull] = ACTIONS(2631),
    [anon_sym_mutable] = ACTIONS(2631),
    [anon_sym_constinit] = ACTIONS(2631),
    [anon_sym_consteval] = ACTIONS(2631),
    [anon_sym_alignas] = ACTIONS(2631),
    [anon_sym__Alignas] = ACTIONS(2631),
    [sym_primitive_type] = ACTIONS(2631),
    [anon_sym_enum] = ACTIONS(2631),
    [anon_sym_class] = ACTIONS(2631),
    [anon_sym_struct] = ACTIONS(2631),
    [anon_sym_union] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_else] = ACTIONS(2631),
    [anon_sym_switch] = ACTIONS(2631),
    [anon_sym_while] = ACTIONS(2631),
    [anon_sym_do] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_goto] = ACTIONS(2631),
    [anon_sym___try] = ACTIONS(2631),
    [anon_sym___leave] = ACTIONS(2631),
    [anon_sym_not] = ACTIONS(2631),
    [anon_sym_compl] = ACTIONS(2631),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_sizeof] = ACTIONS(2631),
    [anon_sym___alignof__] = ACTIONS(2631),
    [anon_sym___alignof] = ACTIONS(2631),
    [anon_sym__alignof] = ACTIONS(2631),
    [anon_sym_alignof] = ACTIONS(2631),
    [anon_sym__Alignof] = ACTIONS(2631),
    [anon_sym_offsetof] = ACTIONS(2631),
    [anon_sym__Generic] = ACTIONS(2631),
    [anon_sym_asm] = ACTIONS(2631),
    [anon_sym___asm__] = ACTIONS(2631),
    [anon_sym___asm] = ACTIONS(2631),
    [sym_number_literal] = ACTIONS(2633),
    [anon_sym_L_SQUOTE] = ACTIONS(2633),
    [anon_sym_u_SQUOTE] = ACTIONS(2633),
    [anon_sym_U_SQUOTE] = ACTIONS(2633),
    [anon_sym_u8_SQUOTE] = ACTIONS(2633),
    [anon_sym_SQUOTE] = ACTIONS(2633),
    [anon_sym_L_DQUOTE] = ACTIONS(2633),
    [anon_sym_u_DQUOTE] = ACTIONS(2633),
    [anon_sym_U_DQUOTE] = ACTIONS(2633),
    [anon_sym_u8_DQUOTE] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(2633),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [anon_sym_NULL] = ACTIONS(2631),
    [anon_sym_nullptr] = ACTIONS(2631),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2631),
    [anon_sym_decltype] = ACTIONS(2631),
    [anon_sym_typename] = ACTIONS(2631),
    [anon_sym_template] = ACTIONS(2631),
    [anon_sym_try] = ACTIONS(2631),
    [anon_sym_delete] = ACTIONS(2631),
    [anon_sym_throw] = ACTIONS(2631),
    [anon_sym_co_return] = ACTIONS(2631),
    [anon_sym_co_yield] = ACTIONS(2631),
    [anon_sym_R_DQUOTE] = ACTIONS(2633),
    [anon_sym_LR_DQUOTE] = ACTIONS(2633),
    [anon_sym_uR_DQUOTE] = ACTIONS(2633),
    [anon_sym_UR_DQUOTE] = ACTIONS(2633),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2633),
    [anon_sym_co_await] = ACTIONS(2631),
    [anon_sym_new] = ACTIONS(2631),
    [anon_sym_requires] = ACTIONS(2631),
    [sym_this] = ACTIONS(2631),
  },
  [909] = {
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6451),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_expression] = STATE(3197),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3233),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5659),
    [sym_qualified_identifier] = STATE(3292),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_operator_name] = STATE(5998),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_LPAREN2] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1802),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1812),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [910] = {
    [sym_identifier] = ACTIONS(2743),
    [anon_sym_LPAREN2] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym___extension__] = ACTIONS(2743),
    [anon_sym_typedef] = ACTIONS(2743),
    [anon_sym_virtual] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym___attribute__] = ACTIONS(2743),
    [anon_sym___attribute] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(2745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2745),
    [anon_sym___declspec] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_signed] = ACTIONS(2743),
    [anon_sym_unsigned] = ACTIONS(2743),
    [anon_sym_long] = ACTIONS(2743),
    [anon_sym_short] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_register] = ACTIONS(2743),
    [anon_sym_inline] = ACTIONS(2743),
    [anon_sym___inline] = ACTIONS(2743),
    [anon_sym___inline__] = ACTIONS(2743),
    [anon_sym___forceinline] = ACTIONS(2743),
    [anon_sym_thread_local] = ACTIONS(2743),
    [anon_sym___thread] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_constexpr] = ACTIONS(2743),
    [anon_sym_volatile] = ACTIONS(2743),
    [anon_sym_restrict] = ACTIONS(2743),
    [anon_sym___restrict__] = ACTIONS(2743),
    [anon_sym__Atomic] = ACTIONS(2743),
    [anon_sym__Noreturn] = ACTIONS(2743),
    [anon_sym_noreturn] = ACTIONS(2743),
    [anon_sym__Nonnull] = ACTIONS(2743),
    [anon_sym_mutable] = ACTIONS(2743),
    [anon_sym_constinit] = ACTIONS(2743),
    [anon_sym_consteval] = ACTIONS(2743),
    [anon_sym_alignas] = ACTIONS(2743),
    [anon_sym__Alignas] = ACTIONS(2743),
    [sym_primitive_type] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2743),
    [anon_sym_switch] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_goto] = ACTIONS(2743),
    [anon_sym___try] = ACTIONS(2743),
    [anon_sym___leave] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2743),
    [anon_sym_compl] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2745),
    [anon_sym_sizeof] = ACTIONS(2743),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2743),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2743),
    [anon_sym___asm__] = ACTIONS(2743),
    [anon_sym___asm] = ACTIONS(2743),
    [sym_number_literal] = ACTIONS(2745),
    [anon_sym_L_SQUOTE] = ACTIONS(2745),
    [anon_sym_u_SQUOTE] = ACTIONS(2745),
    [anon_sym_U_SQUOTE] = ACTIONS(2745),
    [anon_sym_u8_SQUOTE] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2745),
    [anon_sym_L_DQUOTE] = ACTIONS(2745),
    [anon_sym_u_DQUOTE] = ACTIONS(2745),
    [anon_sym_U_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8_DQUOTE] = ACTIONS(2745),
    [anon_sym_DQUOTE] = ACTIONS(2745),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [anon_sym_NULL] = ACTIONS(2743),
    [anon_sym_nullptr] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2743),
    [anon_sym_decltype] = ACTIONS(2743),
    [anon_sym_typename] = ACTIONS(2743),
    [anon_sym_template] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [anon_sym_delete] = ACTIONS(2743),
    [anon_sym_throw] = ACTIONS(2743),
    [anon_sym_co_return] = ACTIONS(2743),
    [anon_sym_co_yield] = ACTIONS(2743),
    [anon_sym_R_DQUOTE] = ACTIONS(2745),
    [anon_sym_LR_DQUOTE] = ACTIONS(2745),
    [anon_sym_uR_DQUOTE] = ACTIONS(2745),
    [anon_sym_UR_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2745),
    [anon_sym_co_await] = ACTIONS(2743),
    [anon_sym_new] = ACTIONS(2743),
    [anon_sym_requires] = ACTIONS(2743),
    [sym_this] = ACTIONS(2743),
  },
  [911] = {
    [sym_identifier] = ACTIONS(2719),
    [anon_sym_LPAREN2] = ACTIONS(2721),
    [anon_sym_BANG] = ACTIONS(2721),
    [anon_sym_TILDE] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2719),
    [anon_sym_PLUS] = ACTIONS(2719),
    [anon_sym_STAR] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(2719),
    [anon_sym_typedef] = ACTIONS(2719),
    [anon_sym_virtual] = ACTIONS(2719),
    [anon_sym_extern] = ACTIONS(2719),
    [anon_sym___attribute__] = ACTIONS(2719),
    [anon_sym___attribute] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2721),
    [anon_sym___declspec] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2719),
    [anon_sym_unsigned] = ACTIONS(2719),
    [anon_sym_long] = ACTIONS(2719),
    [anon_sym_short] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_static] = ACTIONS(2719),
    [anon_sym_register] = ACTIONS(2719),
    [anon_sym_inline] = ACTIONS(2719),
    [anon_sym___inline] = ACTIONS(2719),
    [anon_sym___inline__] = ACTIONS(2719),
    [anon_sym___forceinline] = ACTIONS(2719),
    [anon_sym_thread_local] = ACTIONS(2719),
    [anon_sym___thread] = ACTIONS(2719),
    [anon_sym_const] = ACTIONS(2719),
    [anon_sym_constexpr] = ACTIONS(2719),
    [anon_sym_volatile] = ACTIONS(2719),
    [anon_sym_restrict] = ACTIONS(2719),
    [anon_sym___restrict__] = ACTIONS(2719),
    [anon_sym__Atomic] = ACTIONS(2719),
    [anon_sym__Noreturn] = ACTIONS(2719),
    [anon_sym_noreturn] = ACTIONS(2719),
    [anon_sym__Nonnull] = ACTIONS(2719),
    [anon_sym_mutable] = ACTIONS(2719),
    [anon_sym_constinit] = ACTIONS(2719),
    [anon_sym_consteval] = ACTIONS(2719),
    [anon_sym_alignas] = ACTIONS(2719),
    [anon_sym__Alignas] = ACTIONS(2719),
    [sym_primitive_type] = ACTIONS(2719),
    [anon_sym_enum] = ACTIONS(2719),
    [anon_sym_class] = ACTIONS(2719),
    [anon_sym_struct] = ACTIONS(2719),
    [anon_sym_union] = ACTIONS(2719),
    [anon_sym_if] = ACTIONS(2719),
    [anon_sym_else] = ACTIONS(2719),
    [anon_sym_switch] = ACTIONS(2719),
    [anon_sym_while] = ACTIONS(2719),
    [anon_sym_do] = ACTIONS(2719),
    [anon_sym_for] = ACTIONS(2719),
    [anon_sym_return] = ACTIONS(2719),
    [anon_sym_break] = ACTIONS(2719),
    [anon_sym_continue] = ACTIONS(2719),
    [anon_sym_goto] = ACTIONS(2719),
    [anon_sym___try] = ACTIONS(2719),
    [anon_sym___leave] = ACTIONS(2719),
    [anon_sym_not] = ACTIONS(2719),
    [anon_sym_compl] = ACTIONS(2719),
    [anon_sym_DASH_DASH] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(2721),
    [anon_sym_sizeof] = ACTIONS(2719),
    [anon_sym___alignof__] = ACTIONS(2719),
    [anon_sym___alignof] = ACTIONS(2719),
    [anon_sym__alignof] = ACTIONS(2719),
    [anon_sym_alignof] = ACTIONS(2719),
    [anon_sym__Alignof] = ACTIONS(2719),
    [anon_sym_offsetof] = ACTIONS(2719),
    [anon_sym__Generic] = ACTIONS(2719),
    [anon_sym_asm] = ACTIONS(2719),
    [anon_sym___asm__] = ACTIONS(2719),
    [anon_sym___asm] = ACTIONS(2719),
    [sym_number_literal] = ACTIONS(2721),
    [anon_sym_L_SQUOTE] = ACTIONS(2721),
    [anon_sym_u_SQUOTE] = ACTIONS(2721),
    [anon_sym_U_SQUOTE] = ACTIONS(2721),
    [anon_sym_u8_SQUOTE] = ACTIONS(2721),
    [anon_sym_SQUOTE] = ACTIONS(2721),
    [anon_sym_L_DQUOTE] = ACTIONS(2721),
    [anon_sym_u_DQUOTE] = ACTIONS(2721),
    [anon_sym_U_DQUOTE] = ACTIONS(2721),
    [anon_sym_u8_DQUOTE] = ACTIONS(2721),
    [anon_sym_DQUOTE] = ACTIONS(2721),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [anon_sym_NULL] = ACTIONS(2719),
    [anon_sym_nullptr] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2719),
    [anon_sym_decltype] = ACTIONS(2719),
    [anon_sym_typename] = ACTIONS(2719),
    [anon_sym_template] = ACTIONS(2719),
    [anon_sym_try] = ACTIONS(2719),
    [anon_sym_delete] = ACTIONS(2719),
    [anon_sym_throw] = ACTIONS(2719),
    [anon_sym_co_return] = ACTIONS(2719),
    [anon_sym_co_yield] = ACTIONS(2719),
    [anon_sym_R_DQUOTE] = ACTIONS(2721),
    [anon_sym_LR_DQUOTE] = ACTIONS(2721),
    [anon_sym_uR_DQUOTE] = ACTIONS(2721),
    [anon_sym_UR_DQUOTE] = ACTIONS(2721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2721),
    [anon_sym_co_await] = ACTIONS(2719),
    [anon_sym_new] = ACTIONS(2719),
    [anon_sym_requires] = ACTIONS(2719),
    [sym_this] = ACTIONS(2719),
  },
  [912] = {
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2671),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym___attribute] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym__Nonnull] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym__Alignas] = ACTIONS(2669),
    [sym_primitive_type] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [anon_sym___asm] = ACTIONS(2669),
    [sym_number_literal] = ACTIONS(2671),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [913] = {
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_goto] = ACTIONS(2681),
    [anon_sym___try] = ACTIONS(2681),
    [anon_sym___leave] = ACTIONS(2681),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_compl] = ACTIONS(2681),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_sizeof] = ACTIONS(2681),
    [anon_sym___alignof__] = ACTIONS(2681),
    [anon_sym___alignof] = ACTIONS(2681),
    [anon_sym__alignof] = ACTIONS(2681),
    [anon_sym_alignof] = ACTIONS(2681),
    [anon_sym__Alignof] = ACTIONS(2681),
    [anon_sym_offsetof] = ACTIONS(2681),
    [anon_sym__Generic] = ACTIONS(2681),
    [anon_sym_asm] = ACTIONS(2681),
    [anon_sym___asm__] = ACTIONS(2681),
    [anon_sym___asm] = ACTIONS(2681),
    [sym_number_literal] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2683),
    [anon_sym_u_SQUOTE] = ACTIONS(2683),
    [anon_sym_U_SQUOTE] = ACTIONS(2683),
    [anon_sym_u8_SQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_L_DQUOTE] = ACTIONS(2683),
    [anon_sym_u_DQUOTE] = ACTIONS(2683),
    [anon_sym_U_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8_DQUOTE] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [anon_sym_NULL] = ACTIONS(2681),
    [anon_sym_nullptr] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_co_return] = ACTIONS(2681),
    [anon_sym_co_yield] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2683),
    [anon_sym_LR_DQUOTE] = ACTIONS(2683),
    [anon_sym_uR_DQUOTE] = ACTIONS(2683),
    [anon_sym_UR_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2683),
    [anon_sym_co_await] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_requires] = ACTIONS(2681),
    [sym_this] = ACTIONS(2681),
  },
  [914] = {
    [sym_identifier] = ACTIONS(2699),
    [anon_sym_LPAREN2] = ACTIONS(2701),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2699),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym___extension__] = ACTIONS(2699),
    [anon_sym_typedef] = ACTIONS(2699),
    [anon_sym_virtual] = ACTIONS(2699),
    [anon_sym_extern] = ACTIONS(2699),
    [anon_sym___attribute__] = ACTIONS(2699),
    [anon_sym___attribute] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2701),
    [anon_sym___declspec] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(2701),
    [anon_sym_signed] = ACTIONS(2699),
    [anon_sym_unsigned] = ACTIONS(2699),
    [anon_sym_long] = ACTIONS(2699),
    [anon_sym_short] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_register] = ACTIONS(2699),
    [anon_sym_inline] = ACTIONS(2699),
    [anon_sym___inline] = ACTIONS(2699),
    [anon_sym___inline__] = ACTIONS(2699),
    [anon_sym___forceinline] = ACTIONS(2699),
    [anon_sym_thread_local] = ACTIONS(2699),
    [anon_sym___thread] = ACTIONS(2699),
    [anon_sym_const] = ACTIONS(2699),
    [anon_sym_constexpr] = ACTIONS(2699),
    [anon_sym_volatile] = ACTIONS(2699),
    [anon_sym_restrict] = ACTIONS(2699),
    [anon_sym___restrict__] = ACTIONS(2699),
    [anon_sym__Atomic] = ACTIONS(2699),
    [anon_sym__Noreturn] = ACTIONS(2699),
    [anon_sym_noreturn] = ACTIONS(2699),
    [anon_sym__Nonnull] = ACTIONS(2699),
    [anon_sym_mutable] = ACTIONS(2699),
    [anon_sym_constinit] = ACTIONS(2699),
    [anon_sym_consteval] = ACTIONS(2699),
    [anon_sym_alignas] = ACTIONS(2699),
    [anon_sym__Alignas] = ACTIONS(2699),
    [sym_primitive_type] = ACTIONS(2699),
    [anon_sym_enum] = ACTIONS(2699),
    [anon_sym_class] = ACTIONS(2699),
    [anon_sym_struct] = ACTIONS(2699),
    [anon_sym_union] = ACTIONS(2699),
    [anon_sym_if] = ACTIONS(2699),
    [anon_sym_else] = ACTIONS(2699),
    [anon_sym_switch] = ACTIONS(2699),
    [anon_sym_while] = ACTIONS(2699),
    [anon_sym_do] = ACTIONS(2699),
    [anon_sym_for] = ACTIONS(2699),
    [anon_sym_return] = ACTIONS(2699),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_continue] = ACTIONS(2699),
    [anon_sym_goto] = ACTIONS(2699),
    [anon_sym___try] = ACTIONS(2699),
    [anon_sym___leave] = ACTIONS(2699),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_compl] = ACTIONS(2699),
    [anon_sym_DASH_DASH] = ACTIONS(2701),
    [anon_sym_PLUS_PLUS] = ACTIONS(2701),
    [anon_sym_sizeof] = ACTIONS(2699),
    [anon_sym___alignof__] = ACTIONS(2699),
    [anon_sym___alignof] = ACTIONS(2699),
    [anon_sym__alignof] = ACTIONS(2699),
    [anon_sym_alignof] = ACTIONS(2699),
    [anon_sym__Alignof] = ACTIONS(2699),
    [anon_sym_offsetof] = ACTIONS(2699),
    [anon_sym__Generic] = ACTIONS(2699),
    [anon_sym_asm] = ACTIONS(2699),
    [anon_sym___asm__] = ACTIONS(2699),
    [anon_sym___asm] = ACTIONS(2699),
    [sym_number_literal] = ACTIONS(2701),
    [anon_sym_L_SQUOTE] = ACTIONS(2701),
    [anon_sym_u_SQUOTE] = ACTIONS(2701),
    [anon_sym_U_SQUOTE] = ACTIONS(2701),
    [anon_sym_u8_SQUOTE] = ACTIONS(2701),
    [anon_sym_SQUOTE] = ACTIONS(2701),
    [anon_sym_L_DQUOTE] = ACTIONS(2701),
    [anon_sym_u_DQUOTE] = ACTIONS(2701),
    [anon_sym_U_DQUOTE] = ACTIONS(2701),
    [anon_sym_u8_DQUOTE] = ACTIONS(2701),
    [anon_sym_DQUOTE] = ACTIONS(2701),
    [sym_true] = ACTIONS(2699),
    [sym_false] = ACTIONS(2699),
    [anon_sym_NULL] = ACTIONS(2699),
    [anon_sym_nullptr] = ACTIONS(2699),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2699),
    [anon_sym_decltype] = ACTIONS(2699),
    [anon_sym_typename] = ACTIONS(2699),
    [anon_sym_template] = ACTIONS(2699),
    [anon_sym_try] = ACTIONS(2699),
    [anon_sym_delete] = ACTIONS(2699),
    [anon_sym_throw] = ACTIONS(2699),
    [anon_sym_co_return] = ACTIONS(2699),
    [anon_sym_co_yield] = ACTIONS(2699),
    [anon_sym_R_DQUOTE] = ACTIONS(2701),
    [anon_sym_LR_DQUOTE] = ACTIONS(2701),
    [anon_sym_uR_DQUOTE] = ACTIONS(2701),
    [anon_sym_UR_DQUOTE] = ACTIONS(2701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2701),
    [anon_sym_co_await] = ACTIONS(2699),
    [anon_sym_new] = ACTIONS(2699),
    [anon_sym_requires] = ACTIONS(2699),
    [sym_this] = ACTIONS(2699),
  },
  [915] = {
    [sym_identifier] = ACTIONS(2651),
    [anon_sym_LPAREN2] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_PLUS] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym___extension__] = ACTIONS(2651),
    [anon_sym_typedef] = ACTIONS(2651),
    [anon_sym_virtual] = ACTIONS(2651),
    [anon_sym_extern] = ACTIONS(2651),
    [anon_sym___attribute__] = ACTIONS(2651),
    [anon_sym___attribute] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2653),
    [anon_sym___declspec] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2653),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2651),
    [anon_sym_register] = ACTIONS(2651),
    [anon_sym_inline] = ACTIONS(2651),
    [anon_sym___inline] = ACTIONS(2651),
    [anon_sym___inline__] = ACTIONS(2651),
    [anon_sym___forceinline] = ACTIONS(2651),
    [anon_sym_thread_local] = ACTIONS(2651),
    [anon_sym___thread] = ACTIONS(2651),
    [anon_sym_const] = ACTIONS(2651),
    [anon_sym_constexpr] = ACTIONS(2651),
    [anon_sym_volatile] = ACTIONS(2651),
    [anon_sym_restrict] = ACTIONS(2651),
    [anon_sym___restrict__] = ACTIONS(2651),
    [anon_sym__Atomic] = ACTIONS(2651),
    [anon_sym__Noreturn] = ACTIONS(2651),
    [anon_sym_noreturn] = ACTIONS(2651),
    [anon_sym__Nonnull] = ACTIONS(2651),
    [anon_sym_mutable] = ACTIONS(2651),
    [anon_sym_constinit] = ACTIONS(2651),
    [anon_sym_consteval] = ACTIONS(2651),
    [anon_sym_alignas] = ACTIONS(2651),
    [anon_sym__Alignas] = ACTIONS(2651),
    [sym_primitive_type] = ACTIONS(2651),
    [anon_sym_enum] = ACTIONS(2651),
    [anon_sym_class] = ACTIONS(2651),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_union] = ACTIONS(2651),
    [anon_sym_if] = ACTIONS(2651),
    [anon_sym_else] = ACTIONS(2651),
    [anon_sym_switch] = ACTIONS(2651),
    [anon_sym_while] = ACTIONS(2651),
    [anon_sym_do] = ACTIONS(2651),
    [anon_sym_for] = ACTIONS(2651),
    [anon_sym_return] = ACTIONS(2651),
    [anon_sym_break] = ACTIONS(2651),
    [anon_sym_continue] = ACTIONS(2651),
    [anon_sym_goto] = ACTIONS(2651),
    [anon_sym___try] = ACTIONS(2651),
    [anon_sym___leave] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2651),
    [anon_sym_compl] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2653),
    [anon_sym_sizeof] = ACTIONS(2651),
    [anon_sym___alignof__] = ACTIONS(2651),
    [anon_sym___alignof] = ACTIONS(2651),
    [anon_sym__alignof] = ACTIONS(2651),
    [anon_sym_alignof] = ACTIONS(2651),
    [anon_sym__Alignof] = ACTIONS(2651),
    [anon_sym_offsetof] = ACTIONS(2651),
    [anon_sym__Generic] = ACTIONS(2651),
    [anon_sym_asm] = ACTIONS(2651),
    [anon_sym___asm__] = ACTIONS(2651),
    [anon_sym___asm] = ACTIONS(2651),
    [sym_number_literal] = ACTIONS(2653),
    [anon_sym_L_SQUOTE] = ACTIONS(2653),
    [anon_sym_u_SQUOTE] = ACTIONS(2653),
    [anon_sym_U_SQUOTE] = ACTIONS(2653),
    [anon_sym_u8_SQUOTE] = ACTIONS(2653),
    [anon_sym_SQUOTE] = ACTIONS(2653),
    [anon_sym_L_DQUOTE] = ACTIONS(2653),
    [anon_sym_u_DQUOTE] = ACTIONS(2653),
    [anon_sym_U_DQUOTE] = ACTIONS(2653),
    [anon_sym_u8_DQUOTE] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(2653),
    [sym_true] = ACTIONS(2651),
    [sym_false] = ACTIONS(2651),
    [anon_sym_NULL] = ACTIONS(2651),
    [anon_sym_nullptr] = ACTIONS(2651),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2651),
    [anon_sym_decltype] = ACTIONS(2651),
    [anon_sym_typename] = ACTIONS(2651),
    [anon_sym_template] = ACTIONS(2651),
    [anon_sym_try] = ACTIONS(2651),
    [anon_sym_delete] = ACTIONS(2651),
    [anon_sym_throw] = ACTIONS(2651),
    [anon_sym_co_return] = ACTIONS(2651),
    [anon_sym_co_yield] = ACTIONS(2651),
    [anon_sym_R_DQUOTE] = ACTIONS(2653),
    [anon_sym_LR_DQUOTE] = ACTIONS(2653),
    [anon_sym_uR_DQUOTE] = ACTIONS(2653),
    [anon_sym_UR_DQUOTE] = ACTIONS(2653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2653),
    [anon_sym_co_await] = ACTIONS(2651),
    [anon_sym_new] = ACTIONS(2651),
    [anon_sym_requires] = ACTIONS(2651),
    [sym_this] = ACTIONS(2651),
  },
  [916] = {
    [sym_identifier] = ACTIONS(2727),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym___extension__] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_virtual] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym___attribute__] = ACTIONS(2727),
    [anon_sym___attribute] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2729),
    [anon_sym___declspec] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_signed] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym___inline] = ACTIONS(2727),
    [anon_sym___inline__] = ACTIONS(2727),
    [anon_sym___forceinline] = ACTIONS(2727),
    [anon_sym_thread_local] = ACTIONS(2727),
    [anon_sym___thread] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_constexpr] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym___restrict__] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym__Noreturn] = ACTIONS(2727),
    [anon_sym_noreturn] = ACTIONS(2727),
    [anon_sym__Nonnull] = ACTIONS(2727),
    [anon_sym_mutable] = ACTIONS(2727),
    [anon_sym_constinit] = ACTIONS(2727),
    [anon_sym_consteval] = ACTIONS(2727),
    [anon_sym_alignas] = ACTIONS(2727),
    [anon_sym__Alignas] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_else] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym___try] = ACTIONS(2727),
    [anon_sym___leave] = ACTIONS(2727),
    [anon_sym_not] = ACTIONS(2727),
    [anon_sym_compl] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [anon_sym___alignof__] = ACTIONS(2727),
    [anon_sym___alignof] = ACTIONS(2727),
    [anon_sym__alignof] = ACTIONS(2727),
    [anon_sym_alignof] = ACTIONS(2727),
    [anon_sym__Alignof] = ACTIONS(2727),
    [anon_sym_offsetof] = ACTIONS(2727),
    [anon_sym__Generic] = ACTIONS(2727),
    [anon_sym_asm] = ACTIONS(2727),
    [anon_sym___asm__] = ACTIONS(2727),
    [anon_sym___asm] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [anon_sym_L_SQUOTE] = ACTIONS(2729),
    [anon_sym_u_SQUOTE] = ACTIONS(2729),
    [anon_sym_U_SQUOTE] = ACTIONS(2729),
    [anon_sym_u8_SQUOTE] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_L_DQUOTE] = ACTIONS(2729),
    [anon_sym_u_DQUOTE] = ACTIONS(2729),
    [anon_sym_U_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [anon_sym_NULL] = ACTIONS(2727),
    [anon_sym_nullptr] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2727),
    [anon_sym_decltype] = ACTIONS(2727),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_template] = ACTIONS(2727),
    [anon_sym_try] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2727),
    [anon_sym_throw] = ACTIONS(2727),
    [anon_sym_co_return] = ACTIONS(2727),
    [anon_sym_co_yield] = ACTIONS(2727),
    [anon_sym_R_DQUOTE] = ACTIONS(2729),
    [anon_sym_LR_DQUOTE] = ACTIONS(2729),
    [anon_sym_uR_DQUOTE] = ACTIONS(2729),
    [anon_sym_UR_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2729),
    [anon_sym_co_await] = ACTIONS(2727),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_requires] = ACTIONS(2727),
    [sym_this] = ACTIONS(2727),
  },
  [917] = {
    [sym_identifier] = ACTIONS(2691),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym___extension__] = ACTIONS(2691),
    [anon_sym_typedef] = ACTIONS(2691),
    [anon_sym_virtual] = ACTIONS(2691),
    [anon_sym_extern] = ACTIONS(2691),
    [anon_sym___attribute__] = ACTIONS(2691),
    [anon_sym___attribute] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2693),
    [anon_sym___declspec] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_signed] = ACTIONS(2691),
    [anon_sym_unsigned] = ACTIONS(2691),
    [anon_sym_long] = ACTIONS(2691),
    [anon_sym_short] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2691),
    [anon_sym_register] = ACTIONS(2691),
    [anon_sym_inline] = ACTIONS(2691),
    [anon_sym___inline] = ACTIONS(2691),
    [anon_sym___inline__] = ACTIONS(2691),
    [anon_sym___forceinline] = ACTIONS(2691),
    [anon_sym_thread_local] = ACTIONS(2691),
    [anon_sym___thread] = ACTIONS(2691),
    [anon_sym_const] = ACTIONS(2691),
    [anon_sym_constexpr] = ACTIONS(2691),
    [anon_sym_volatile] = ACTIONS(2691),
    [anon_sym_restrict] = ACTIONS(2691),
    [anon_sym___restrict__] = ACTIONS(2691),
    [anon_sym__Atomic] = ACTIONS(2691),
    [anon_sym__Noreturn] = ACTIONS(2691),
    [anon_sym_noreturn] = ACTIONS(2691),
    [anon_sym__Nonnull] = ACTIONS(2691),
    [anon_sym_mutable] = ACTIONS(2691),
    [anon_sym_constinit] = ACTIONS(2691),
    [anon_sym_consteval] = ACTIONS(2691),
    [anon_sym_alignas] = ACTIONS(2691),
    [anon_sym__Alignas] = ACTIONS(2691),
    [sym_primitive_type] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2691),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_union] = ACTIONS(2691),
    [anon_sym_if] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2691),
    [anon_sym_switch] = ACTIONS(2691),
    [anon_sym_while] = ACTIONS(2691),
    [anon_sym_do] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2691),
    [anon_sym_return] = ACTIONS(2691),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_continue] = ACTIONS(2691),
    [anon_sym_goto] = ACTIONS(2691),
    [anon_sym___try] = ACTIONS(2691),
    [anon_sym___leave] = ACTIONS(2691),
    [anon_sym_not] = ACTIONS(2691),
    [anon_sym_compl] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_sizeof] = ACTIONS(2691),
    [anon_sym___alignof__] = ACTIONS(2691),
    [anon_sym___alignof] = ACTIONS(2691),
    [anon_sym__alignof] = ACTIONS(2691),
    [anon_sym_alignof] = ACTIONS(2691),
    [anon_sym__Alignof] = ACTIONS(2691),
    [anon_sym_offsetof] = ACTIONS(2691),
    [anon_sym__Generic] = ACTIONS(2691),
    [anon_sym_asm] = ACTIONS(2691),
    [anon_sym___asm__] = ACTIONS(2691),
    [anon_sym___asm] = ACTIONS(2691),
    [sym_number_literal] = ACTIONS(2693),
    [anon_sym_L_SQUOTE] = ACTIONS(2693),
    [anon_sym_u_SQUOTE] = ACTIONS(2693),
    [anon_sym_U_SQUOTE] = ACTIONS(2693),
    [anon_sym_u8_SQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_L_DQUOTE] = ACTIONS(2693),
    [anon_sym_u_DQUOTE] = ACTIONS(2693),
    [anon_sym_U_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8_DQUOTE] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [anon_sym_NULL] = ACTIONS(2691),
    [anon_sym_nullptr] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2691),
    [anon_sym_decltype] = ACTIONS(2691),
    [anon_sym_typename] = ACTIONS(2691),
    [anon_sym_template] = ACTIONS(2691),
    [anon_sym_try] = ACTIONS(2691),
    [anon_sym_delete] = ACTIONS(2691),
    [anon_sym_throw] = ACTIONS(2691),
    [anon_sym_co_return] = ACTIONS(2691),
    [anon_sym_co_yield] = ACTIONS(2691),
    [anon_sym_R_DQUOTE] = ACTIONS(2693),
    [anon_sym_LR_DQUOTE] = ACTIONS(2693),
    [anon_sym_uR_DQUOTE] = ACTIONS(2693),
    [anon_sym_UR_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2693),
    [anon_sym_co_await] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2691),
    [anon_sym_requires] = ACTIONS(2691),
    [sym_this] = ACTIONS(2691),
  },
  [918] = {
    [sym_identifier] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [919] = {
    [sym_identifier] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [anon_sym_if] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(2703),
    [anon_sym_do] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2703),
    [anon_sym_return] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2703),
    [anon_sym_continue] = ACTIONS(2703),
    [anon_sym_goto] = ACTIONS(2703),
    [anon_sym___try] = ACTIONS(2703),
    [anon_sym___leave] = ACTIONS(2703),
    [anon_sym_not] = ACTIONS(2703),
    [anon_sym_compl] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2703),
    [anon_sym___alignof__] = ACTIONS(2703),
    [anon_sym___alignof] = ACTIONS(2703),
    [anon_sym__alignof] = ACTIONS(2703),
    [anon_sym_alignof] = ACTIONS(2703),
    [anon_sym__Alignof] = ACTIONS(2703),
    [anon_sym_offsetof] = ACTIONS(2703),
    [anon_sym__Generic] = ACTIONS(2703),
    [anon_sym_asm] = ACTIONS(2703),
    [anon_sym___asm__] = ACTIONS(2703),
    [anon_sym___asm] = ACTIONS(2703),
    [sym_number_literal] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2705),
    [anon_sym_u_SQUOTE] = ACTIONS(2705),
    [anon_sym_U_SQUOTE] = ACTIONS(2705),
    [anon_sym_u8_SQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_L_DQUOTE] = ACTIONS(2705),
    [anon_sym_u_DQUOTE] = ACTIONS(2705),
    [anon_sym_U_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8_DQUOTE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [sym_false] = ACTIONS(2703),
    [anon_sym_NULL] = ACTIONS(2703),
    [anon_sym_nullptr] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2703),
    [anon_sym_delete] = ACTIONS(2703),
    [anon_sym_throw] = ACTIONS(2703),
    [anon_sym_co_return] = ACTIONS(2703),
    [anon_sym_co_yield] = ACTIONS(2703),
    [anon_sym_R_DQUOTE] = ACTIONS(2705),
    [anon_sym_LR_DQUOTE] = ACTIONS(2705),
    [anon_sym_uR_DQUOTE] = ACTIONS(2705),
    [anon_sym_UR_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2705),
    [anon_sym_co_await] = ACTIONS(2703),
    [anon_sym_new] = ACTIONS(2703),
    [anon_sym_requires] = ACTIONS(2703),
    [sym_this] = ACTIONS(2703),
  },
  [920] = {
    [sym_identifier] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [anon_sym_if] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(2703),
    [anon_sym_do] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2703),
    [anon_sym_return] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2703),
    [anon_sym_continue] = ACTIONS(2703),
    [anon_sym_goto] = ACTIONS(2703),
    [anon_sym___try] = ACTIONS(2703),
    [anon_sym___leave] = ACTIONS(2703),
    [anon_sym_not] = ACTIONS(2703),
    [anon_sym_compl] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2703),
    [anon_sym___alignof__] = ACTIONS(2703),
    [anon_sym___alignof] = ACTIONS(2703),
    [anon_sym__alignof] = ACTIONS(2703),
    [anon_sym_alignof] = ACTIONS(2703),
    [anon_sym__Alignof] = ACTIONS(2703),
    [anon_sym_offsetof] = ACTIONS(2703),
    [anon_sym__Generic] = ACTIONS(2703),
    [anon_sym_asm] = ACTIONS(2703),
    [anon_sym___asm__] = ACTIONS(2703),
    [anon_sym___asm] = ACTIONS(2703),
    [sym_number_literal] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2705),
    [anon_sym_u_SQUOTE] = ACTIONS(2705),
    [anon_sym_U_SQUOTE] = ACTIONS(2705),
    [anon_sym_u8_SQUOTE] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_L_DQUOTE] = ACTIONS(2705),
    [anon_sym_u_DQUOTE] = ACTIONS(2705),
    [anon_sym_U_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8_DQUOTE] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2705),
    [sym_true] = ACTIONS(2703),
    [sym_false] = ACTIONS(2703),
    [anon_sym_NULL] = ACTIONS(2703),
    [anon_sym_nullptr] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2703),
    [anon_sym_delete] = ACTIONS(2703),
    [anon_sym_throw] = ACTIONS(2703),
    [anon_sym_co_return] = ACTIONS(2703),
    [anon_sym_co_yield] = ACTIONS(2703),
    [anon_sym_R_DQUOTE] = ACTIONS(2705),
    [anon_sym_LR_DQUOTE] = ACTIONS(2705),
    [anon_sym_uR_DQUOTE] = ACTIONS(2705),
    [anon_sym_UR_DQUOTE] = ACTIONS(2705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2705),
    [anon_sym_co_await] = ACTIONS(2703),
    [anon_sym_new] = ACTIONS(2703),
    [anon_sym_requires] = ACTIONS(2703),
    [sym_this] = ACTIONS(2703),
  },
  [921] = {
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_LPAREN2] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2675),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym___extension__] = ACTIONS(2673),
    [anon_sym_typedef] = ACTIONS(2673),
    [anon_sym_virtual] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym___attribute__] = ACTIONS(2673),
    [anon_sym___attribute] = ACTIONS(2673),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2675),
    [anon_sym___declspec] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_signed] = ACTIONS(2673),
    [anon_sym_unsigned] = ACTIONS(2673),
    [anon_sym_long] = ACTIONS(2673),
    [anon_sym_short] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_register] = ACTIONS(2673),
    [anon_sym_inline] = ACTIONS(2673),
    [anon_sym___inline] = ACTIONS(2673),
    [anon_sym___inline__] = ACTIONS(2673),
    [anon_sym___forceinline] = ACTIONS(2673),
    [anon_sym_thread_local] = ACTIONS(2673),
    [anon_sym___thread] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_constexpr] = ACTIONS(2673),
    [anon_sym_volatile] = ACTIONS(2673),
    [anon_sym_restrict] = ACTIONS(2673),
    [anon_sym___restrict__] = ACTIONS(2673),
    [anon_sym__Atomic] = ACTIONS(2673),
    [anon_sym__Noreturn] = ACTIONS(2673),
    [anon_sym_noreturn] = ACTIONS(2673),
    [anon_sym__Nonnull] = ACTIONS(2673),
    [anon_sym_mutable] = ACTIONS(2673),
    [anon_sym_constinit] = ACTIONS(2673),
    [anon_sym_consteval] = ACTIONS(2673),
    [anon_sym_alignas] = ACTIONS(2673),
    [anon_sym__Alignas] = ACTIONS(2673),
    [sym_primitive_type] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_goto] = ACTIONS(2673),
    [anon_sym___try] = ACTIONS(2673),
    [anon_sym___leave] = ACTIONS(2673),
    [anon_sym_not] = ACTIONS(2673),
    [anon_sym_compl] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_sizeof] = ACTIONS(2673),
    [anon_sym___alignof__] = ACTIONS(2673),
    [anon_sym___alignof] = ACTIONS(2673),
    [anon_sym__alignof] = ACTIONS(2673),
    [anon_sym_alignof] = ACTIONS(2673),
    [anon_sym__Alignof] = ACTIONS(2673),
    [anon_sym_offsetof] = ACTIONS(2673),
    [anon_sym__Generic] = ACTIONS(2673),
    [anon_sym_asm] = ACTIONS(2673),
    [anon_sym___asm__] = ACTIONS(2673),
    [anon_sym___asm] = ACTIONS(2673),
    [sym_number_literal] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2675),
    [anon_sym_u_SQUOTE] = ACTIONS(2675),
    [anon_sym_U_SQUOTE] = ACTIONS(2675),
    [anon_sym_u8_SQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_L_DQUOTE] = ACTIONS(2675),
    [anon_sym_u_DQUOTE] = ACTIONS(2675),
    [anon_sym_U_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8_DQUOTE] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [anon_sym_NULL] = ACTIONS(2673),
    [anon_sym_nullptr] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2673),
    [anon_sym_decltype] = ACTIONS(2673),
    [anon_sym_typename] = ACTIONS(2673),
    [anon_sym_template] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_co_return] = ACTIONS(2673),
    [anon_sym_co_yield] = ACTIONS(2673),
    [anon_sym_R_DQUOTE] = ACTIONS(2675),
    [anon_sym_LR_DQUOTE] = ACTIONS(2675),
    [anon_sym_uR_DQUOTE] = ACTIONS(2675),
    [anon_sym_UR_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2675),
    [anon_sym_co_await] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_requires] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
  },
  [922] = {
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2641),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym___attribute] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym__Nonnull] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym__Alignas] = ACTIONS(2639),
    [sym_primitive_type] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [anon_sym___asm] = ACTIONS(2639),
    [sym_number_literal] = ACTIONS(2641),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [923] = {
    [sym_identifier] = ACTIONS(2655),
    [anon_sym_LPAREN2] = ACTIONS(2657),
    [anon_sym_BANG] = ACTIONS(2657),
    [anon_sym_TILDE] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_AMP] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym___extension__] = ACTIONS(2655),
    [anon_sym_typedef] = ACTIONS(2655),
    [anon_sym_virtual] = ACTIONS(2655),
    [anon_sym_extern] = ACTIONS(2655),
    [anon_sym___attribute__] = ACTIONS(2655),
    [anon_sym___attribute] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2657),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2657),
    [anon_sym___declspec] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_signed] = ACTIONS(2655),
    [anon_sym_unsigned] = ACTIONS(2655),
    [anon_sym_long] = ACTIONS(2655),
    [anon_sym_short] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2655),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_register] = ACTIONS(2655),
    [anon_sym_inline] = ACTIONS(2655),
    [anon_sym___inline] = ACTIONS(2655),
    [anon_sym___inline__] = ACTIONS(2655),
    [anon_sym___forceinline] = ACTIONS(2655),
    [anon_sym_thread_local] = ACTIONS(2655),
    [anon_sym___thread] = ACTIONS(2655),
    [anon_sym_const] = ACTIONS(2655),
    [anon_sym_constexpr] = ACTIONS(2655),
    [anon_sym_volatile] = ACTIONS(2655),
    [anon_sym_restrict] = ACTIONS(2655),
    [anon_sym___restrict__] = ACTIONS(2655),
    [anon_sym__Atomic] = ACTIONS(2655),
    [anon_sym__Noreturn] = ACTIONS(2655),
    [anon_sym_noreturn] = ACTIONS(2655),
    [anon_sym__Nonnull] = ACTIONS(2655),
    [anon_sym_mutable] = ACTIONS(2655),
    [anon_sym_constinit] = ACTIONS(2655),
    [anon_sym_consteval] = ACTIONS(2655),
    [anon_sym_alignas] = ACTIONS(2655),
    [anon_sym__Alignas] = ACTIONS(2655),
    [sym_primitive_type] = ACTIONS(2655),
    [anon_sym_enum] = ACTIONS(2655),
    [anon_sym_class] = ACTIONS(2655),
    [anon_sym_struct] = ACTIONS(2655),
    [anon_sym_union] = ACTIONS(2655),
    [anon_sym_if] = ACTIONS(2655),
    [anon_sym_else] = ACTIONS(2655),
    [anon_sym_switch] = ACTIONS(2655),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(2655),
    [anon_sym_for] = ACTIONS(2655),
    [anon_sym_return] = ACTIONS(2655),
    [anon_sym_break] = ACTIONS(2655),
    [anon_sym_continue] = ACTIONS(2655),
    [anon_sym_goto] = ACTIONS(2655),
    [anon_sym___try] = ACTIONS(2655),
    [anon_sym___leave] = ACTIONS(2655),
    [anon_sym_not] = ACTIONS(2655),
    [anon_sym_compl] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(2657),
    [anon_sym_sizeof] = ACTIONS(2655),
    [anon_sym___alignof__] = ACTIONS(2655),
    [anon_sym___alignof] = ACTIONS(2655),
    [anon_sym__alignof] = ACTIONS(2655),
    [anon_sym_alignof] = ACTIONS(2655),
    [anon_sym__Alignof] = ACTIONS(2655),
    [anon_sym_offsetof] = ACTIONS(2655),
    [anon_sym__Generic] = ACTIONS(2655),
    [anon_sym_asm] = ACTIONS(2655),
    [anon_sym___asm__] = ACTIONS(2655),
    [anon_sym___asm] = ACTIONS(2655),
    [sym_number_literal] = ACTIONS(2657),
    [anon_sym_L_SQUOTE] = ACTIONS(2657),
    [anon_sym_u_SQUOTE] = ACTIONS(2657),
    [anon_sym_U_SQUOTE] = ACTIONS(2657),
    [anon_sym_u8_SQUOTE] = ACTIONS(2657),
    [anon_sym_SQUOTE] = ACTIONS(2657),
    [anon_sym_L_DQUOTE] = ACTIONS(2657),
    [anon_sym_u_DQUOTE] = ACTIONS(2657),
    [anon_sym_U_DQUOTE] = ACTIONS(2657),
    [anon_sym_u8_DQUOTE] = ACTIONS(2657),
    [anon_sym_DQUOTE] = ACTIONS(2657),
    [sym_true] = ACTIONS(2655),
    [sym_false] = ACTIONS(2655),
    [anon_sym_NULL] = ACTIONS(2655),
    [anon_sym_nullptr] = ACTIONS(2655),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2655),
    [anon_sym_decltype] = ACTIONS(2655),
    [anon_sym_typename] = ACTIONS(2655),
    [anon_sym_template] = ACTIONS(2655),
    [anon_sym_try] = ACTIONS(2655),
    [anon_sym_delete] = ACTIONS(2655),
    [anon_sym_throw] = ACTIONS(2655),
    [anon_sym_co_return] = ACTIONS(2655),
    [anon_sym_co_yield] = ACTIONS(2655),
    [anon_sym_R_DQUOTE] = ACTIONS(2657),
    [anon_sym_LR_DQUOTE] = ACTIONS(2657),
    [anon_sym_uR_DQUOTE] = ACTIONS(2657),
    [anon_sym_UR_DQUOTE] = ACTIONS(2657),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2657),
    [anon_sym_co_await] = ACTIONS(2655),
    [anon_sym_new] = ACTIONS(2655),
    [anon_sym_requires] = ACTIONS(2655),
    [sym_this] = ACTIONS(2655),
  },
  [924] = {
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [anon_sym___asm] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [925] = {
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2629),
    [anon_sym_BANG] = ACTIONS(2629),
    [anon_sym_TILDE] = ACTIONS(2629),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2629),
    [anon_sym_SEMI] = ACTIONS(2629),
    [anon_sym___extension__] = ACTIONS(2627),
    [anon_sym_typedef] = ACTIONS(2627),
    [anon_sym_virtual] = ACTIONS(2627),
    [anon_sym_extern] = ACTIONS(2627),
    [anon_sym___attribute__] = ACTIONS(2627),
    [anon_sym___attribute] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2629),
    [anon_sym___declspec] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2629),
    [anon_sym_signed] = ACTIONS(2627),
    [anon_sym_unsigned] = ACTIONS(2627),
    [anon_sym_long] = ACTIONS(2627),
    [anon_sym_short] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_static] = ACTIONS(2627),
    [anon_sym_register] = ACTIONS(2627),
    [anon_sym_inline] = ACTIONS(2627),
    [anon_sym___inline] = ACTIONS(2627),
    [anon_sym___inline__] = ACTIONS(2627),
    [anon_sym___forceinline] = ACTIONS(2627),
    [anon_sym_thread_local] = ACTIONS(2627),
    [anon_sym___thread] = ACTIONS(2627),
    [anon_sym_const] = ACTIONS(2627),
    [anon_sym_constexpr] = ACTIONS(2627),
    [anon_sym_volatile] = ACTIONS(2627),
    [anon_sym_restrict] = ACTIONS(2627),
    [anon_sym___restrict__] = ACTIONS(2627),
    [anon_sym__Atomic] = ACTIONS(2627),
    [anon_sym__Noreturn] = ACTIONS(2627),
    [anon_sym_noreturn] = ACTIONS(2627),
    [anon_sym__Nonnull] = ACTIONS(2627),
    [anon_sym_mutable] = ACTIONS(2627),
    [anon_sym_constinit] = ACTIONS(2627),
    [anon_sym_consteval] = ACTIONS(2627),
    [anon_sym_alignas] = ACTIONS(2627),
    [anon_sym__Alignas] = ACTIONS(2627),
    [sym_primitive_type] = ACTIONS(2627),
    [anon_sym_enum] = ACTIONS(2627),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_struct] = ACTIONS(2627),
    [anon_sym_union] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_else] = ACTIONS(2627),
    [anon_sym_switch] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_goto] = ACTIONS(2627),
    [anon_sym___try] = ACTIONS(2627),
    [anon_sym___leave] = ACTIONS(2627),
    [anon_sym_not] = ACTIONS(2627),
    [anon_sym_compl] = ACTIONS(2627),
    [anon_sym_DASH_DASH] = ACTIONS(2629),
    [anon_sym_PLUS_PLUS] = ACTIONS(2629),
    [anon_sym_sizeof] = ACTIONS(2627),
    [anon_sym___alignof__] = ACTIONS(2627),
    [anon_sym___alignof] = ACTIONS(2627),
    [anon_sym__alignof] = ACTIONS(2627),
    [anon_sym_alignof] = ACTIONS(2627),
    [anon_sym__Alignof] = ACTIONS(2627),
    [anon_sym_offsetof] = ACTIONS(2627),
    [anon_sym__Generic] = ACTIONS(2627),
    [anon_sym_asm] = ACTIONS(2627),
    [anon_sym___asm__] = ACTIONS(2627),
    [anon_sym___asm] = ACTIONS(2627),
    [sym_number_literal] = ACTIONS(2629),
    [anon_sym_L_SQUOTE] = ACTIONS(2629),
    [anon_sym_u_SQUOTE] = ACTIONS(2629),
    [anon_sym_U_SQUOTE] = ACTIONS(2629),
    [anon_sym_u8_SQUOTE] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2629),
    [anon_sym_L_DQUOTE] = ACTIONS(2629),
    [anon_sym_u_DQUOTE] = ACTIONS(2629),
    [anon_sym_U_DQUOTE] = ACTIONS(2629),
    [anon_sym_u8_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE] = ACTIONS(2629),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [anon_sym_NULL] = ACTIONS(2627),
    [anon_sym_nullptr] = ACTIONS(2627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2627),
    [anon_sym_decltype] = ACTIONS(2627),
    [anon_sym_typename] = ACTIONS(2627),
    [anon_sym_template] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_delete] = ACTIONS(2627),
    [anon_sym_throw] = ACTIONS(2627),
    [anon_sym_co_return] = ACTIONS(2627),
    [anon_sym_co_yield] = ACTIONS(2627),
    [anon_sym_R_DQUOTE] = ACTIONS(2629),
    [anon_sym_LR_DQUOTE] = ACTIONS(2629),
    [anon_sym_uR_DQUOTE] = ACTIONS(2629),
    [anon_sym_UR_DQUOTE] = ACTIONS(2629),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2629),
    [anon_sym_co_await] = ACTIONS(2627),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_requires] = ACTIONS(2627),
    [sym_this] = ACTIONS(2627),
  },
  [926] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_call_modifier] = STATE(4611),
    [sym__declarator] = STATE(6672),
    [sym__abstract_declarator] = STATE(6904),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_function_declarator] = STATE(5998),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_array_declarator] = STATE(5998),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_list] = STATE(3004),
    [sym_parameter_declaration] = STATE(7399),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7399),
    [sym_variadic_parameter_declaration] = STATE(7399),
    [sym_reference_declarator] = STATE(5998),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(2406),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5781),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(4294),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1928),
    [anon_sym_RPAREN] = ACTIONS(4296),
    [anon_sym_LPAREN2] = ACTIONS(4298),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_AMP] = ACTIONS(4304),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(1808),
    [anon_sym___clrcall] = ACTIONS(1808),
    [anon_sym___stdcall] = ACTIONS(1808),
    [anon_sym___fastcall] = ACTIONS(1808),
    [anon_sym___thiscall] = ACTIONS(1808),
    [anon_sym___vectorcall] = ACTIONS(1808),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [927] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1659),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4152),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [928] = {
    [sym_expression] = STATE(3326),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [929] = {
    [sym_expression] = STATE(3632),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [930] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(935),
    [sym_compound_requirement] = STATE(935),
    [sym__requirement] = STATE(935),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(935),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4322),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [931] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1659),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4152),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [932] = {
    [sym_expression] = STATE(4396),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7209),
    [sym_initializer_pair] = STATE(7209),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_COMMA] = ACTIONS(4328),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4330),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [933] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1659),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4152),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [934] = {
    [sym_expression] = STATE(4116),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [935] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(981),
    [sym_compound_requirement] = STATE(981),
    [sym__requirement] = STATE(981),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [936] = {
    [sym_expression] = STATE(4119),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [937] = {
    [sym_expression] = STATE(4366),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7146),
    [sym_initializer_pair] = STATE(7146),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_COMMA] = ACTIONS(4342),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [938] = {
    [sym_expression] = STATE(2908),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [939] = {
    [sym_expression] = STATE(4372),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7389),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [940] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(942),
    [sym_compound_requirement] = STATE(942),
    [sym__requirement] = STATE(942),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(942),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [941] = {
    [sym_expression] = STATE(4345),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7551),
    [sym_initializer_pair] = STATE(7551),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_COMMA] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [942] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(981),
    [sym_compound_requirement] = STATE(981),
    [sym__requirement] = STATE(981),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [943] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(947),
    [sym_compound_requirement] = STATE(947),
    [sym__requirement] = STATE(947),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(947),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [944] = {
    [sym_expression] = STATE(3352),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [945] = {
    [sym_expression] = STATE(3353),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [946] = {
    [sym_expression] = STATE(4340),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7301),
    [sym_initializer_pair] = STATE(7301),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_COMMA] = ACTIONS(4360),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [947] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(981),
    [sym_compound_requirement] = STATE(981),
    [sym__requirement] = STATE(981),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [948] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(951),
    [sym_compound_requirement] = STATE(951),
    [sym__requirement] = STATE(951),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(951),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4366),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [949] = {
    [sym_expression] = STATE(4306),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [950] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(960),
    [sym_compound_requirement] = STATE(960),
    [sym__requirement] = STATE(960),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(960),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [951] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(981),
    [sym_compound_requirement] = STATE(981),
    [sym__requirement] = STATE(981),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4370),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [952] = {
    [sym_expression] = STATE(2949),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [953] = {
    [sym_expression] = STATE(4365),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7388),
    [sym_initializer_pair] = STATE(7388),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_COMMA] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4374),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [954] = {
    [sym_expression] = STATE(3606),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [955] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(956),
    [sym_compound_requirement] = STATE(956),
    [sym__requirement] = STATE(956),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(956),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4376),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [956] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(981),
    [sym_compound_requirement] = STATE(981),
    [sym__requirement] = STATE(981),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4378),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [957] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1659),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4380),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4152),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [958] = {
    [sym_expression] = STATE(4309),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [959] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(961),
    [sym_compound_requirement] = STATE(961),
    [sym__requirement] = STATE(961),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(961),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4386),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [960] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(981),
    [sym_compound_requirement] = STATE(981),
    [sym__requirement] = STATE(981),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4388),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [961] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(981),
    [sym_compound_requirement] = STATE(981),
    [sym__requirement] = STATE(981),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [962] = {
    [sym_expression] = STATE(4456),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [963] = {
    [sym_expression] = STATE(3183),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [964] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(966),
    [sym_compound_requirement] = STATE(966),
    [sym__requirement] = STATE(966),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(966),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4392),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [965] = {
    [sym_expression] = STATE(4317),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [966] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(981),
    [sym_compound_requirement] = STATE(981),
    [sym__requirement] = STATE(981),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [967] = {
    [sym_expression] = STATE(3040),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [968] = {
    [sym_expression] = STATE(4361),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7299),
    [sym_initializer_pair] = STATE(7299),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_COMMA] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [969] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(971),
    [sym_compound_requirement] = STATE(971),
    [sym__requirement] = STATE(971),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(971),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4400),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [970] = {
    [sym_expression] = STATE(4429),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [971] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(981),
    [sym_compound_requirement] = STATE(981),
    [sym__requirement] = STATE(981),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_typename] = ACTIONS(4324),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [972] = {
    [sym_expression] = STATE(3043),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [973] = {
    [sym_expression] = STATE(4565),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [974] = {
    [sym_expression] = STATE(4567),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [975] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1659),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4222),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4152),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [976] = {
    [sym_string_literal] = STATE(2370),
    [sym_template_argument_list] = STATE(1586),
    [sym_raw_string_literal] = STATE(2370),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4159),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4152),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4409),
    [anon_sym_or_eq] = ACTIONS(4409),
    [anon_sym_xor_eq] = ACTIONS(4409),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4154),
    [anon_sym_L_DQUOTE] = ACTIONS(4411),
    [anon_sym_u_DQUOTE] = ACTIONS(4411),
    [anon_sym_U_DQUOTE] = ACTIONS(4411),
    [anon_sym_u8_DQUOTE] = ACTIONS(4411),
    [anon_sym_DQUOTE] = ACTIONS(4411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(4413),
    [anon_sym_LR_DQUOTE] = ACTIONS(4413),
    [anon_sym_uR_DQUOTE] = ACTIONS(4413),
    [anon_sym_UR_DQUOTE] = ACTIONS(4413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4413),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4146),
  },
  [977] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1659),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4218),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4152),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [978] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1659),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4152),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [979] = {
    [sym_expression] = STATE(2808),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [980] = {
    [sym_expression] = STATE(2813),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [981] = {
    [sym_expression_statement] = STATE(2752),
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8471),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_type_requirement] = STATE(981),
    [sym_compound_requirement] = STATE(981),
    [sym__requirement] = STATE(981),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_requirement_seq_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(4419),
    [anon_sym_LPAREN2] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4425),
    [anon_sym_TILDE] = ACTIONS(4425),
    [anon_sym_DASH] = ACTIONS(4428),
    [anon_sym_PLUS] = ACTIONS(4428),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_AMP] = ACTIONS(4431),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(4443),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4448),
    [sym_primitive_type] = ACTIONS(4451),
    [anon_sym_not] = ACTIONS(4428),
    [anon_sym_compl] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4454),
    [anon_sym_PLUS_PLUS] = ACTIONS(4454),
    [anon_sym_sizeof] = ACTIONS(4457),
    [anon_sym___alignof__] = ACTIONS(4460),
    [anon_sym___alignof] = ACTIONS(4460),
    [anon_sym__alignof] = ACTIONS(4460),
    [anon_sym_alignof] = ACTIONS(4460),
    [anon_sym__Alignof] = ACTIONS(4460),
    [anon_sym_offsetof] = ACTIONS(4463),
    [anon_sym__Generic] = ACTIONS(4466),
    [anon_sym_asm] = ACTIONS(4469),
    [anon_sym___asm__] = ACTIONS(4469),
    [anon_sym___asm] = ACTIONS(4469),
    [sym_number_literal] = ACTIONS(4472),
    [anon_sym_L_SQUOTE] = ACTIONS(4475),
    [anon_sym_u_SQUOTE] = ACTIONS(4475),
    [anon_sym_U_SQUOTE] = ACTIONS(4475),
    [anon_sym_u8_SQUOTE] = ACTIONS(4475),
    [anon_sym_SQUOTE] = ACTIONS(4475),
    [anon_sym_L_DQUOTE] = ACTIONS(4478),
    [anon_sym_u_DQUOTE] = ACTIONS(4478),
    [anon_sym_U_DQUOTE] = ACTIONS(4478),
    [anon_sym_u8_DQUOTE] = ACTIONS(4478),
    [anon_sym_DQUOTE] = ACTIONS(4478),
    [sym_true] = ACTIONS(4481),
    [sym_false] = ACTIONS(4481),
    [anon_sym_NULL] = ACTIONS(4484),
    [anon_sym_nullptr] = ACTIONS(4484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4487),
    [anon_sym_typename] = ACTIONS(4490),
    [anon_sym_template] = ACTIONS(4493),
    [anon_sym_delete] = ACTIONS(4496),
    [anon_sym_R_DQUOTE] = ACTIONS(4499),
    [anon_sym_LR_DQUOTE] = ACTIONS(4499),
    [anon_sym_uR_DQUOTE] = ACTIONS(4499),
    [anon_sym_UR_DQUOTE] = ACTIONS(4499),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4499),
    [anon_sym_co_await] = ACTIONS(4502),
    [anon_sym_new] = ACTIONS(4505),
    [anon_sym_requires] = ACTIONS(4508),
    [sym_this] = ACTIONS(4481),
  },
  [982] = {
    [sym_expression] = STATE(3204),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [983] = {
    [sym_expression] = STATE(3324),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [984] = {
    [sym_expression] = STATE(4529),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [985] = {
    [sym_expression] = STATE(4531),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [986] = {
    [sym_expression] = STATE(4284),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(4310),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4310),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(4314),
    [anon_sym_constexpr] = ACTIONS(4314),
    [anon_sym_mutable] = ACTIONS(4314),
    [anon_sym_consteval] = ACTIONS(4314),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4310),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_noexcept] = ACTIONS(4314),
    [anon_sym_throw] = ACTIONS(4314),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [987] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [988] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4511),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [989] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [990] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4515),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [991] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4517),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [992] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(1673),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4159),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(4162),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym___extension__] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4144),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4152),
    [anon_sym___declspec] = ACTIONS(4144),
    [anon_sym___based] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(4174),
    [anon_sym_unsigned] = ACTIONS(4174),
    [anon_sym_long] = ACTIONS(4174),
    [anon_sym_short] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4144),
    [anon_sym_register] = ACTIONS(4144),
    [anon_sym_inline] = ACTIONS(4144),
    [anon_sym___inline] = ACTIONS(4144),
    [anon_sym___inline__] = ACTIONS(4144),
    [anon_sym___forceinline] = ACTIONS(4144),
    [anon_sym_thread_local] = ACTIONS(4144),
    [anon_sym___thread] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_restrict] = ACTIONS(4144),
    [anon_sym___restrict__] = ACTIONS(4144),
    [anon_sym__Atomic] = ACTIONS(4144),
    [anon_sym__Noreturn] = ACTIONS(4144),
    [anon_sym_noreturn] = ACTIONS(4144),
    [anon_sym__Nonnull] = ACTIONS(4144),
    [anon_sym_mutable] = ACTIONS(4144),
    [anon_sym_constinit] = ACTIONS(4144),
    [anon_sym_consteval] = ACTIONS(4144),
    [anon_sym_alignas] = ACTIONS(4144),
    [anon_sym__Alignas] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
    [anon_sym_template] = ACTIONS(4144),
    [anon_sym_operator] = ACTIONS(4144),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [993] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4519),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [994] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4521),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [995] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4523),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [996] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4525),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [997] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4527),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [998] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4529),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [999] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(4531),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1000] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7584),
    [sym_initializer_pair] = STATE(7584),
    [sym_subscript_designator] = STATE(6728),
    [sym_subscript_range_designator] = STATE(6728),
    [sym_field_designator] = STATE(6728),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [aux_sym_initializer_pair_repeat1] = STATE(6728),
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(225),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1001] = {
    [sym_expression] = STATE(4766),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_lambda_default_capture] = STATE(7699),
    [sym__lambda_capture_identifier] = STATE(7222),
    [sym_lambda_capture_initializer] = STATE(7222),
    [sym__lambda_capture] = STATE(7222),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_identifier_parameter_pack_expansion] = STATE(7222),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3675),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4535),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_AMP] = ACTIONS(4539),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(4543),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(4545),
  },
  [1002] = {
    [sym_expression] = STATE(4766),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_lambda_default_capture] = STATE(7699),
    [sym__lambda_capture_identifier] = STATE(7222),
    [sym_lambda_capture_initializer] = STATE(7222),
    [sym__lambda_capture] = STATE(7222),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_identifier_parameter_pack_expansion] = STATE(7222),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3675),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(4547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4535),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(4537),
    [anon_sym_AMP] = ACTIONS(4539),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(4543),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(4545),
  },
  [1003] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_identifier_parameter_pack_expansion] = STATE(7778),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3644),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(4549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4551),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4553),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1004] = {
    [sym_expression] = STATE(3230),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8553),
    [sym__unary_right_fold] = STATE(8555),
    [sym__binary_fold] = STATE(8556),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1005] = {
    [sym_expression] = STATE(4173),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_initializer_list] = STATE(6830),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(4559),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(4561),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(4563),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1006] = {
    [sym_expression] = STATE(4477),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8534),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8534),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4565),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1007] = {
    [sym_expression] = STATE(4461),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8831),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8831),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4567),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1008] = {
    [sym_compound_statement] = STATE(7140),
    [sym_expression] = STATE(4385),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7140),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4569),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1009] = {
    [sym_expression] = STATE(3345),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8414),
    [sym__unary_right_fold] = STATE(8418),
    [sym__binary_fold] = STATE(8419),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1010] = {
    [sym_expression] = STATE(4172),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_initializer_list] = STATE(6803),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(4571),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(4573),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(4575),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1011] = {
    [sym_expression] = STATE(3244),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8232),
    [sym__unary_right_fold] = STATE(8236),
    [sym__binary_fold] = STATE(8240),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1012] = {
    [sym_expression] = STATE(4179),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_initializer_list] = STATE(6812),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(4577),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(4579),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(4581),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1013] = {
    [sym_expression] = STATE(3239),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8383),
    [sym__unary_right_fold] = STATE(8684),
    [sym__binary_fold] = STATE(8748),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1014] = {
    [sym_expression] = STATE(3290),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8396),
    [sym__unary_right_fold] = STATE(8410),
    [sym__binary_fold] = STATE(8415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1015] = {
    [sym_expression] = STATE(3220),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8699),
    [sym__unary_right_fold] = STATE(8700),
    [sym__binary_fold] = STATE(8703),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1016] = {
    [sym_expression] = STATE(3236),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8605),
    [sym__unary_right_fold] = STATE(8610),
    [sym__binary_fold] = STATE(8628),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1017] = {
    [sym_compound_statement] = STATE(8449),
    [sym_expression] = STATE(3257),
    [sym__string] = STATE(2950),
    [sym_comma_expression] = STATE(8449),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym__assignment_expression_lhs] = STATE(8569),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1018] = {
    [sym_expression] = STATE(3215),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8223),
    [sym__unary_right_fold] = STATE(8226),
    [sym__binary_fold] = STATE(8228),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1019] = {
    [sym_compound_statement] = STATE(7549),
    [sym_expression] = STATE(4327),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7549),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4583),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1020] = {
    [sym_compound_statement] = STATE(7153),
    [sym_expression] = STATE(4348),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7153),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4585),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1021] = {
    [sym_compound_statement] = STATE(7482),
    [sym_expression] = STATE(4338),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7482),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1022] = {
    [sym_expression] = STATE(4582),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8533),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8533),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4589),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1023] = {
    [sym_compound_statement] = STATE(7386),
    [sym_expression] = STATE(4364),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7386),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4591),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1024] = {
    [sym_expression] = STATE(4561),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8490),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8490),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4593),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1025] = {
    [sym_expression] = STATE(4562),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7937),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7937),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4595),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1026] = {
    [sym_expression] = STATE(3272),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym__unary_left_fold] = STATE(8119),
    [sym__unary_right_fold] = STATE(8280),
    [sym__binary_fold] = STATE(7936),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1027] = {
    [sym_compound_statement] = STATE(7298),
    [sym_expression] = STATE(4335),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7298),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4597),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1028] = {
    [sym_compound_statement] = STATE(7197),
    [sym_expression] = STATE(4395),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7197),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4599),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1029] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4601),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1030] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1031] = {
    [sym_expression] = STATE(4407),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_initializer_list] = STATE(7161),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4607),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1032] = {
    [sym_expression] = STATE(4363),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_initializer_list] = STATE(7481),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4609),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1033] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4611),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1034] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4614),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1035] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4617),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1036] = {
    [sym_expression] = STATE(4368),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_initializer_list] = STATE(7277),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4620),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1037] = {
    [sym_compound_statement] = STATE(7569),
    [sym_expression] = STATE(4483),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7569),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1038] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1039] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4625),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1040] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4628),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1041] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4631),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1042] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4634),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1043] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4637),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1044] = {
    [sym_expression] = STATE(4326),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7816),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1045] = {
    [sym_expression] = STATE(4568),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8431),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1046] = {
    [sym_expression] = STATE(4575),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8705),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4644),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1047] = {
    [sym_expression] = STATE(4508),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8268),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4646),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1048] = {
    [sym_expression] = STATE(4762),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8437),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1049] = {
    [sym_expression] = STATE(4458),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8245),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4648),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1050] = {
    [sym_expression] = STATE(4557),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7586),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1051] = {
    [sym_expression] = STATE(4437),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8033),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4650),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1052] = {
    [sym_expression] = STATE(4469),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7816),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1053] = {
    [sym_expression] = STATE(3339),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_initializer_list] = STATE(3605),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(2499),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1054] = {
    [sym_expression] = STATE(4283),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(3900),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1055] = {
    [sym_expression] = STATE(4312),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_initializer_list] = STATE(6951),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1056] = {
    [sym_expression] = STATE(3171),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_initializer_list] = STATE(3451),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1057] = {
    [sym_expression] = STATE(4505),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_initializer_list] = STATE(3900),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1058] = {
    [sym_expression] = STATE(4544),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8011),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4654),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1059] = {
    [sym_expression] = STATE(4498),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_initializer_list] = STATE(3805),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1060] = {
    [sym_expression] = STATE(3572),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_initializer_list] = STATE(3860),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACE] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1061] = {
    [sym_expression] = STATE(3578),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_initializer_list] = STATE(3864),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACE] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1062] = {
    [sym_expression] = STATE(4443),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7931),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4656),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1063] = {
    [sym_expression] = STATE(3797),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_initializer_list] = STATE(3805),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1064] = {
    [sym_expression] = STATE(3797),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_initializer_list] = STATE(3805),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1065] = {
    [sym_expression] = STATE(3797),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(3805),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1066] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(7580),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1067] = {
    [sym_expression] = STATE(4489),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_initializer_list] = STATE(7785),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1068] = {
    [sym_expression] = STATE(2388),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_initializer_list] = STATE(2441),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1069] = {
    [sym_expression] = STATE(4431),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4660),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1070] = {
    [sym_expression] = STATE(4433),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8038),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4662),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1071] = {
    [sym_expression] = STATE(4645),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8336),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1072] = {
    [sym_expression] = STATE(4417),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8411),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4664),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1073] = {
    [sym_expression] = STATE(4497),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8366),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4666),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1074] = {
    [sym_expression] = STATE(2388),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_initializer_list] = STATE(2441),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1075] = {
    [sym_expression] = STATE(3797),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_initializer_list] = STATE(3805),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1076] = {
    [sym_expression] = STATE(4282),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_initializer_list] = STATE(3900),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1077] = {
    [sym_expression] = STATE(4452),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8459),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4670),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1078] = {
    [sym_expression] = STATE(4447),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7983),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4672),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1079] = {
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7943),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4674),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1080] = {
    [sym_expression] = STATE(4435),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_initializer_list] = STATE(4816),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1081] = {
    [sym_expression] = STATE(4450),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_initializer_list] = STATE(3900),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1082] = {
    [sym_expression] = STATE(3323),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_initializer_list] = STATE(2441),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1083] = {
    [sym_expression] = STATE(4424),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7950),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4678),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1084] = {
    [sym_expression] = STATE(4322),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7389),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4680),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1085] = {
    [sym_expression] = STATE(4564),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8704),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4683),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1086] = {
    [sym_expression] = STATE(4518),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_initializer_list] = STATE(3900),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1087] = {
    [sym_expression] = STATE(4448),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8076),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4685),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1088] = {
    [sym_expression] = STATE(4573),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8734),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4687),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1089] = {
    [sym_expression] = STATE(4482),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(4689),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1090] = {
    [sym_expression] = STATE(4168),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_initializer_list] = STATE(3900),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1091] = {
    [sym_expression] = STATE(4507),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_initializer_list] = STATE(4828),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1092] = {
    [sym_expression] = STATE(2388),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_initializer_list] = STATE(2441),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1093] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_initializer_list] = STATE(8155),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1094] = {
    [sym_expression] = STATE(4608),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_RPAREN] = ACTIONS(4693),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1095] = {
    [sym_expression] = STATE(3549),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4695),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1096] = {
    [sym_expression] = STATE(3550),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4698),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1097] = {
    [sym_expression] = STATE(3550),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4701),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1098] = {
    [sym_expression] = STATE(3550),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4704),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1099] = {
    [sym_expression] = STATE(3553),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4707),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1100] = {
    [sym_expression] = STATE(3554),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4710),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1101] = {
    [sym_expression] = STATE(3556),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4713),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1102] = {
    [sym_expression] = STATE(3562),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4716),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1103] = {
    [sym_expression] = STATE(3563),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4719),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1104] = {
    [sym_expression] = STATE(3570),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4722),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1105] = {
    [sym_expression] = STATE(3570),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4725),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1106] = {
    [sym_expression] = STATE(3584),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4728),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1107] = {
    [sym_expression] = STATE(3584),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4731),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1108] = {
    [sym_expression] = STATE(3584),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4734),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1109] = {
    [sym_expression] = STATE(3584),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4737),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1110] = {
    [sym_expression] = STATE(3595),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4740),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1111] = {
    [sym_expression] = STATE(3164),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4737),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1112] = {
    [sym_expression] = STATE(3110),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4743),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1113] = {
    [sym_expression] = STATE(3595),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4746),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1114] = {
    [sym_expression] = STATE(3553),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4749),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1115] = {
    [sym_expression] = STATE(3554),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4752),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1116] = {
    [sym_expression] = STATE(3556),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4755),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1117] = {
    [sym_expression] = STATE(3562),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4743),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1118] = {
    [sym_expression] = STATE(3563),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4758),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1119] = {
    [sym_expression] = STATE(3570),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4761),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1120] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4764),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1121] = {
    [sym_expression] = STATE(3156),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4704),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1122] = {
    [sym_expression] = STATE(4758),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4766),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1123] = {
    [sym_expression] = STATE(4651),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1124] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4770),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1125] = {
    [sym_expression] = STATE(4555),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7389),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1126] = {
    [sym_expression] = STATE(3164),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4728),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1127] = {
    [sym_expression] = STATE(3163),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4722),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1128] = {
    [sym_expression] = STATE(3160),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4713),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1129] = {
    [sym_expression] = STATE(3164),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4734),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1130] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4772),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1131] = {
    [sym_expression] = STATE(3158),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4707),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1132] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4774),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1133] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4776),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1134] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4778),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1135] = {
    [sym_expression] = STATE(4686),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4780),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1136] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4782),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1137] = {
    [sym_expression] = STATE(4767),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4784),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1138] = {
    [sym_expression] = STATE(3755),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4786),
    [anon_sym_LPAREN2] = ACTIONS(4788),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1139] = {
    [sym_expression] = STATE(3158),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4749),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1140] = {
    [sym_expression] = STATE(3164),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4731),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1141] = {
    [sym_expression] = STATE(3165),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4740),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1142] = {
    [sym_expression] = STATE(4266),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym_SEMI] = ACTIONS(4790),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(4792),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1143] = {
    [sym_expression] = STATE(4673),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4794),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1144] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4796),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1145] = {
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4798),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1146] = {
    [sym_expression] = STATE(4616),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4800),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1147] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4802),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1148] = {
    [sym_expression] = STATE(3163),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4725),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1149] = {
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4804),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1150] = {
    [sym_expression] = STATE(3549),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4806),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1151] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4809),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1152] = {
    [sym_expression] = STATE(4686),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4811),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1153] = {
    [sym_expression] = STATE(4600),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4813),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1154] = {
    [sym_expression] = STATE(3755),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4786),
    [anon_sym_LPAREN2] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1155] = {
    [sym_expression] = STATE(4704),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4817),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1156] = {
    [sym_expression] = STATE(4602),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4819),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1157] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4821),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1158] = {
    [sym_expression] = STATE(4741),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4823),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1159] = {
    [sym_expression] = STATE(4322),
    [sym__string] = STATE(4250),
    [sym_comma_expression] = STATE(7389),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1160] = {
    [sym_expression] = STATE(4760),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4825),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1161] = {
    [sym_expression] = STATE(4266),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym_SEMI] = ACTIONS(4827),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(4792),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1162] = {
    [sym_expression] = STATE(3160),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4755),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1163] = {
    [sym_expression] = STATE(4549),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4786),
    [anon_sym_LPAREN2] = ACTIONS(4829),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1164] = {
    [sym_expression] = STATE(3156),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4698),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1165] = {
    [sym_expression] = STATE(3330),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4831),
    [anon_sym_LPAREN2] = ACTIONS(4833),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1166] = {
    [sym_expression] = STATE(3208),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4758),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1167] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4835),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1168] = {
    [sym_expression] = STATE(4723),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4837),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1169] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4839),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1170] = {
    [sym_expression] = STATE(3307),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(4843),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1171] = {
    [sym_expression] = STATE(4634),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4845),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1172] = {
    [sym_expression] = STATE(3110),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4716),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1173] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4847),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1174] = {
    [sym_expression] = STATE(4753),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4849),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1175] = {
    [sym_expression] = STATE(4266),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym_SEMI] = ACTIONS(4851),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(4792),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1176] = {
    [sym_expression] = STATE(2380),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(4853),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1177] = {
    [sym_expression] = STATE(3165),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4746),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1178] = {
    [sym_expression] = STATE(4636),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4855),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1179] = {
    [sym_expression] = STATE(3159),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4710),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1180] = {
    [sym_expression] = STATE(3755),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4786),
    [anon_sym_LPAREN2] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1181] = {
    [sym_expression] = STATE(3155),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4695),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1182] = {
    [sym_expression] = STATE(2380),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1183] = {
    [sym_expression] = STATE(4708),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4861),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1184] = {
    [sym_expression] = STATE(3139),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4863),
    [anon_sym_LPAREN2] = ACTIONS(4865),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1185] = {
    [sym_expression] = STATE(4427),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4867),
    [anon_sym_LPAREN2] = ACTIONS(4869),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1186] = {
    [sym_expression] = STATE(3159),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4752),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1187] = {
    [sym_expression] = STATE(4713),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(4871),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1188] = {
    [sym_expression] = STATE(3163),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4761),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1189] = {
    [sym_expression] = STATE(2380),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(4873),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1190] = {
    [sym_expression] = STATE(3755),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4786),
    [anon_sym_LPAREN2] = ACTIONS(4875),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1191] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4877),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1192] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4879),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1193] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4881),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1194] = {
    [sym_expression] = STATE(3155),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4806),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1195] = {
    [sym_expression] = STATE(3156),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4701),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1196] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4883),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1197] = {
    [sym_expression] = STATE(3208),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4719),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1198] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4885),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1199] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(4887),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1200] = {
    [sym_expression] = STATE(3663),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4889),
    [anon_sym_LPAREN2] = ACTIONS(4891),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1201] = {
    [sym_expression] = STATE(4522),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1202] = {
    [sym_expression] = STATE(4418),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1203] = {
    [sym_expression] = STATE(4587),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1204] = {
    [sym_expression] = STATE(4596),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1205] = {
    [sym_expression] = STATE(4319),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4893),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1206] = {
    [sym_expression] = STATE(4752),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1207] = {
    [sym_expression] = STATE(3184),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1208] = {
    [sym_expression] = STATE(3668),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(4895),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1209] = {
    [sym_expression] = STATE(3671),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1210] = {
    [sym_expression] = STATE(4472),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1211] = {
    [sym_expression] = STATE(3543),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(4897),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1212] = {
    [sym_expression] = STATE(4397),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1213] = {
    [sym_expression] = STATE(4764),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1214] = {
    [sym_expression] = STATE(3639),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1215] = {
    [sym_expression] = STATE(3782),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1216] = {
    [sym_expression] = STATE(4765),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1217] = {
    [sym_expression] = STATE(3591),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1218] = {
    [sym_expression] = STATE(4578),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1219] = {
    [sym_expression] = STATE(4581),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1220] = {
    [sym_expression] = STATE(4744),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1221] = {
    [sym_expression] = STATE(3582),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1222] = {
    [sym_expression] = STATE(4598),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1223] = {
    [sym_expression] = STATE(4460),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1224] = {
    [sym_expression] = STATE(4604),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1225] = {
    [sym_expression] = STATE(3347),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(4899),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1226] = {
    [sym_expression] = STATE(3289),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1227] = {
    [sym_expression] = STATE(3280),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(4901),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1228] = {
    [sym_expression] = STATE(3351),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1229] = {
    [sym_expression] = STATE(3224),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1230] = {
    [sym_expression] = STATE(2911),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(4903),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1231] = {
    [sym_expression] = STATE(2381),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1232] = {
    [sym_expression] = STATE(3279),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1233] = {
    [sym_expression] = STATE(3145),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(4905),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1234] = {
    [sym_expression] = STATE(3201),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1235] = {
    [sym_expression] = STATE(2903),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(4907),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1236] = {
    [sym_expression] = STATE(3147),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1237] = {
    [sym_expression] = STATE(3006),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1238] = {
    [sym_expression] = STATE(3039),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1239] = {
    [sym_expression] = STATE(4686),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1240] = {
    [sym_expression] = STATE(3041),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1241] = {
    [sym_expression] = STATE(3197),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1242] = {
    [sym_expression] = STATE(2893),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1243] = {
    [sym_expression] = STATE(3051),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1244] = {
    [sym_expression] = STATE(3126),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(4911),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1245] = {
    [sym_expression] = STATE(4307),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1246] = {
    [sym_expression] = STATE(3155),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1247] = {
    [sym_expression] = STATE(3186),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1248] = {
    [sym_expression] = STATE(3186),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(4913),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1249] = {
    [sym_expression] = STATE(3156),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1250] = {
    [sym_expression] = STATE(3158),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1251] = {
    [sym_expression] = STATE(3159),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1252] = {
    [sym_expression] = STATE(3160),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1253] = {
    [sym_expression] = STATE(3136),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1254] = {
    [sym_expression] = STATE(3110),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1255] = {
    [sym_expression] = STATE(3208),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1256] = {
    [sym_expression] = STATE(4266),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(4792),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1257] = {
    [sym_expression] = STATE(3163),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1258] = {
    [sym_expression] = STATE(3164),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1259] = {
    [sym_expression] = STATE(3766),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1260] = {
    [sym_expression] = STATE(3165),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1261] = {
    [sym_expression] = STATE(2970),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1262] = {
    [sym_expression] = STATE(3221),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1263] = {
    [sym_expression] = STATE(4310),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1264] = {
    [sym_expression] = STATE(4320),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1265] = {
    [sym_expression] = STATE(4321),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1266] = {
    [sym_expression] = STATE(3760),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1267] = {
    [sym_expression] = STATE(4278),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1268] = {
    [sym_expression] = STATE(4311),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1269] = {
    [sym_expression] = STATE(4305),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1270] = {
    [sym_expression] = STATE(4286),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1271] = {
    [sym_expression] = STATE(4293),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1272] = {
    [sym_expression] = STATE(4265),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1273] = {
    [sym_expression] = STATE(4314),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1274] = {
    [sym_expression] = STATE(4291),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1275] = {
    [sym_expression] = STATE(4277),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1276] = {
    [sym_expression] = STATE(4635),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1277] = {
    [sym_expression] = STATE(3750),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1278] = {
    [sym_expression] = STATE(4688),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1279] = {
    [sym_expression] = STATE(4318),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1280] = {
    [sym_expression] = STATE(4315),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4917),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1281] = {
    [sym_expression] = STATE(4313),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1282] = {
    [sym_expression] = STATE(2915),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1283] = {
    [sym_expression] = STATE(2384),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1284] = {
    [sym_expression] = STATE(2913),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1285] = {
    [sym_expression] = STATE(4127),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1286] = {
    [sym_expression] = STATE(2914),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1287] = {
    [sym_expression] = STATE(2922),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1288] = {
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1289] = {
    [sym_expression] = STATE(2963),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1290] = {
    [sym_expression] = STATE(4268),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1291] = {
    [sym_expression] = STATE(2964),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1292] = {
    [sym_expression] = STATE(2966),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1293] = {
    [sym_expression] = STATE(2934),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1294] = {
    [sym_expression] = STATE(2968),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1295] = {
    [sym_expression] = STATE(3166),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1296] = {
    [sym_expression] = STATE(4643),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1297] = {
    [sym_expression] = STATE(4551),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1298] = {
    [sym_expression] = STATE(4574),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1299] = {
    [sym_expression] = STATE(4576),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1300] = {
    [sym_expression] = STATE(4579),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1301] = {
    [sym_expression] = STATE(4580),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1302] = {
    [sym_expression] = STATE(4502),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1303] = {
    [sym_expression] = STATE(4412),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1304] = {
    [sym_expression] = STATE(4419),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1305] = {
    [sym_expression] = STATE(4422),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1306] = {
    [sym_expression] = STATE(4426),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1307] = {
    [sym_expression] = STATE(4430),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1308] = {
    [sym_expression] = STATE(4540),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1309] = {
    [sym_expression] = STATE(3036),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(4919),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1310] = {
    [sym_expression] = STATE(2381),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1311] = {
    [sym_expression] = STATE(2790),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(4921),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1312] = {
    [sym_expression] = STATE(2819),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1313] = {
    [sym_expression] = STATE(2812),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1314] = {
    [sym_expression] = STATE(2821),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1315] = {
    [sym_expression] = STATE(2377),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1316] = {
    [sym_expression] = STATE(2377),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(4923),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1317] = {
    [sym_expression] = STATE(2379),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1318] = {
    [sym_expression] = STATE(4593),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1319] = {
    [sym_expression] = STATE(4159),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(4925),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1320] = {
    [sym_expression] = STATE(3766),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1321] = {
    [sym_expression] = STATE(3782),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1322] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1323] = {
    [sym_expression] = STATE(4158),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1324] = {
    [sym_expression] = STATE(4167),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(4929),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1325] = {
    [sym_expression] = STATE(4685),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1326] = {
    [sym_expression] = STATE(4554),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1327] = {
    [sym_expression] = STATE(3766),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1328] = {
    [sym_expression] = STATE(4432),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1329] = {
    [sym_expression] = STATE(4485),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1330] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1331] = {
    [sym_expression] = STATE(4166),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1332] = {
    [sym_expression] = STATE(3760),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1333] = {
    [sym_expression] = STATE(4170),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1334] = {
    [sym_expression] = STATE(4108),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1335] = {
    [sym_expression] = STATE(4109),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1336] = {
    [sym_expression] = STATE(4110),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1337] = {
    [sym_expression] = STATE(4111),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1338] = {
    [sym_expression] = STATE(4112),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1339] = {
    [sym_expression] = STATE(4113),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1340] = {
    [sym_expression] = STATE(4114),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1341] = {
    [sym_expression] = STATE(4115),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1342] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(4931),
  },
  [1343] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1344] = {
    [sym_expression] = STATE(2884),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1345] = {
    [sym_expression] = STATE(4270),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1346] = {
    [sym_expression] = STATE(4117),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1347] = {
    [sym_expression] = STATE(4120),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1348] = {
    [sym_expression] = STATE(3251),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1349] = {
    [sym_expression] = STATE(3331),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1350] = {
    [sym_expression] = STATE(3332),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1351] = {
    [sym_expression] = STATE(3334),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1352] = {
    [sym_expression] = STATE(3337),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1353] = {
    [sym_expression] = STATE(3341),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1354] = {
    [sym_expression] = STATE(3342),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1355] = {
    [sym_expression] = STATE(3346),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1356] = {
    [sym_expression] = STATE(3348),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1357] = {
    [sym_expression] = STATE(3349),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1358] = {
    [sym_expression] = STATE(3350),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1359] = {
    [sym_expression] = STATE(2773),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(4933),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1360] = {
    [sym_expression] = STATE(2381),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1361] = {
    [sym_expression] = STATE(4410),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1362] = {
    [sym_expression] = STATE(4478),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1363] = {
    [sym_expression] = STATE(2398),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1364] = {
    [sym_expression] = STATE(4766),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1365] = {
    [sym_expression] = STATE(4558),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1366] = {
    [sym_expression] = STATE(4273),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1367] = {
    [sym_expression] = STATE(3034),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1368] = {
    [sym_expression] = STATE(3037),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1369] = {
    [sym_expression] = STATE(2384),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1370] = {
    [sym_expression] = STATE(3018),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1371] = {
    [sym_expression] = STATE(3021),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1372] = {
    [sym_expression] = STATE(3023),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1373] = {
    [sym_expression] = STATE(3024),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1374] = {
    [sym_expression] = STATE(3026),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1375] = {
    [sym_expression] = STATE(3029),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1376] = {
    [sym_expression] = STATE(3030),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1377] = {
    [sym_expression] = STATE(3038),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1378] = {
    [sym_expression] = STATE(3646),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1379] = {
    [sym_expression] = STATE(3662),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1380] = {
    [sym_expression] = STATE(4486),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(4935),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1381] = {
    [sym_expression] = STATE(4420),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1382] = {
    [sym_expression] = STATE(3647),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1383] = {
    [sym_expression] = STATE(2772),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1384] = {
    [sym_expression] = STATE(2817),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1385] = {
    [sym_expression] = STATE(2384),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1386] = {
    [sym_expression] = STATE(2795),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1387] = {
    [sym_expression] = STATE(2796),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1388] = {
    [sym_expression] = STATE(2797),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1389] = {
    [sym_expression] = STATE(4774),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1390] = {
    [sym_expression] = STATE(2799),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1391] = {
    [sym_expression] = STATE(2802),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1392] = {
    [sym_expression] = STATE(2807),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1393] = {
    [sym_expression] = STATE(2818),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1394] = {
    [sym_expression] = STATE(3249),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1395] = {
    [sym_expression] = STATE(3296),
    [sym__string] = STATE(3360),
    [sym_conditional_expression] = STATE(3651),
    [sym_assignment_expression] = STATE(3651),
    [sym_pointer_expression] = STATE(3547),
    [sym_unary_expression] = STATE(3651),
    [sym_binary_expression] = STATE(3651),
    [sym_update_expression] = STATE(3651),
    [sym_cast_expression] = STATE(3651),
    [sym_sizeof_expression] = STATE(3651),
    [sym_alignof_expression] = STATE(3651),
    [sym_offsetof_expression] = STATE(3651),
    [sym_generic_expression] = STATE(3651),
    [sym_subscript_expression] = STATE(3547),
    [sym_call_expression] = STATE(3547),
    [sym_gnu_asm_expression] = STATE(3651),
    [sym_extension_expression] = STATE(3651),
    [sym_field_expression] = STATE(3547),
    [sym_compound_literal_expression] = STATE(3651),
    [sym_parenthesized_expression] = STATE(3547),
    [sym_char_literal] = STATE(3360),
    [sym_concatenated_string] = STATE(3360),
    [sym_string_literal] = STATE(2369),
    [sym_null] = STATE(3651),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7649),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3651),
    [sym_raw_string_literal] = STATE(2369),
    [sym_co_await_expression] = STATE(3651),
    [sym_new_expression] = STATE(3651),
    [sym_delete_expression] = STATE(3651),
    [sym_requires_clause] = STATE(3651),
    [sym_requires_expression] = STATE(3651),
    [sym_lambda_expression] = STATE(3651),
    [sym_lambda_capture_specifier] = STATE(5395),
    [sym_fold_expression] = STATE(3651),
    [sym_parameter_pack_expansion] = STATE(3651),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3547),
    [sym_qualified_type_identifier] = STATE(7649),
    [sym_user_defined_literal] = STATE(3547),
    [sym_identifier] = ACTIONS(2489),
    [anon_sym_LPAREN2] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(2495),
    [anon_sym_COLON_COLON] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2501),
    [anon_sym_not] = ACTIONS(2491),
    [anon_sym_compl] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4358),
    [anon_sym_sizeof] = ACTIONS(2503),
    [anon_sym___alignof__] = ACTIONS(2505),
    [anon_sym___alignof] = ACTIONS(2505),
    [anon_sym__alignof] = ACTIONS(2505),
    [anon_sym_alignof] = ACTIONS(2505),
    [anon_sym__Alignof] = ACTIONS(2505),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2509),
    [anon_sym_asm] = ACTIONS(2511),
    [anon_sym___asm__] = ACTIONS(2511),
    [anon_sym___asm] = ACTIONS(2511),
    [sym_number_literal] = ACTIONS(2513),
    [anon_sym_L_SQUOTE] = ACTIONS(2515),
    [anon_sym_u_SQUOTE] = ACTIONS(2515),
    [anon_sym_U_SQUOTE] = ACTIONS(2515),
    [anon_sym_u8_SQUOTE] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2515),
    [anon_sym_L_DQUOTE] = ACTIONS(2517),
    [anon_sym_u_DQUOTE] = ACTIONS(2517),
    [anon_sym_U_DQUOTE] = ACTIONS(2517),
    [anon_sym_u8_DQUOTE] = ACTIONS(2517),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [sym_true] = ACTIONS(2519),
    [sym_false] = ACTIONS(2519),
    [anon_sym_NULL] = ACTIONS(2521),
    [anon_sym_nullptr] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2529),
    [anon_sym_requires] = ACTIONS(2531),
    [sym_this] = ACTIONS(2519),
  },
  [1396] = {
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(4937),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1397] = {
    [sym_expression] = STATE(3782),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1398] = {
    [sym_expression] = STATE(3750),
    [sym__string] = STATE(4380),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3253),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3253),
    [sym_call_expression] = STATE(3253),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3253),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3253),
    [sym_char_literal] = STATE(4380),
    [sym_concatenated_string] = STATE(4380),
    [sym_string_literal] = STATE(3416),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3416),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3253),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3253),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(3829),
    [anon_sym_COLON_COLON] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3825),
    [anon_sym_compl] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4384),
    [anon_sym_sizeof] = ACTIONS(3833),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3835),
    [anon_sym_L_SQUOTE] = ACTIONS(3837),
    [anon_sym_u_SQUOTE] = ACTIONS(3837),
    [anon_sym_U_SQUOTE] = ACTIONS(3837),
    [anon_sym_u8_SQUOTE] = ACTIONS(3837),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [anon_sym_L_DQUOTE] = ACTIONS(3839),
    [anon_sym_u_DQUOTE] = ACTIONS(3839),
    [anon_sym_U_DQUOTE] = ACTIONS(3839),
    [anon_sym_u8_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3839),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_R_DQUOTE] = ACTIONS(3843),
    [anon_sym_LR_DQUOTE] = ACTIONS(3843),
    [anon_sym_uR_DQUOTE] = ACTIONS(3843),
    [anon_sym_UR_DQUOTE] = ACTIONS(3843),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3843),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1399] = {
    [sym_expression] = STATE(3760),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1400] = {
    [sym_expression] = STATE(4260),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1401] = {
    [sym_expression] = STATE(4285),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1402] = {
    [sym_expression] = STATE(4258),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1403] = {
    [sym_expression] = STATE(4274),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1404] = {
    [sym_expression] = STATE(3549),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1405] = {
    [sym_expression] = STATE(3550),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1406] = {
    [sym_expression] = STATE(3553),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1407] = {
    [sym_expression] = STATE(3554),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1408] = {
    [sym_expression] = STATE(3782),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1409] = {
    [sym_expression] = STATE(3556),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1410] = {
    [sym_expression] = STATE(3750),
    [sym__string] = STATE(4199),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(2935),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(2935),
    [sym_call_expression] = STATE(2935),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(2935),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(2935),
    [sym_char_literal] = STATE(4199),
    [sym_concatenated_string] = STATE(4199),
    [sym_string_literal] = STATE(3059),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3059),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2935),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(2935),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_LPAREN2] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4338),
    [anon_sym_sizeof] = ACTIONS(3617),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(3619),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
    [anon_sym_co_await] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3633),
    [sym_this] = ACTIONS(229),
  },
  [1411] = {
    [sym_expression] = STATE(3562),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1412] = {
    [sym_expression] = STATE(3563),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1413] = {
    [sym_expression] = STATE(3570),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1414] = {
    [sym_expression] = STATE(3584),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1415] = {
    [sym_expression] = STATE(3595),
    [sym__string] = STATE(3714),
    [sym_conditional_expression] = STATE(3908),
    [sym_assignment_expression] = STATE(3908),
    [sym_pointer_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3908),
    [sym_binary_expression] = STATE(3908),
    [sym_update_expression] = STATE(3908),
    [sym_cast_expression] = STATE(3908),
    [sym_sizeof_expression] = STATE(3908),
    [sym_alignof_expression] = STATE(3908),
    [sym_offsetof_expression] = STATE(3908),
    [sym_generic_expression] = STATE(3908),
    [sym_subscript_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_gnu_asm_expression] = STATE(3908),
    [sym_extension_expression] = STATE(3908),
    [sym_field_expression] = STATE(3506),
    [sym_compound_literal_expression] = STATE(3908),
    [sym_parenthesized_expression] = STATE(3506),
    [sym_char_literal] = STATE(3714),
    [sym_concatenated_string] = STATE(3714),
    [sym_string_literal] = STATE(2566),
    [sym_null] = STATE(3908),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3908),
    [sym_raw_string_literal] = STATE(2566),
    [sym_co_await_expression] = STATE(3908),
    [sym_new_expression] = STATE(3908),
    [sym_delete_expression] = STATE(3908),
    [sym_requires_clause] = STATE(3908),
    [sym_requires_expression] = STATE(3908),
    [sym_lambda_expression] = STATE(3908),
    [sym_lambda_capture_specifier] = STATE(5415),
    [sym_fold_expression] = STATE(3908),
    [sym_parameter_pack_expansion] = STATE(3908),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3506),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3506),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(1872),
    [anon_sym_compl] = ACTIONS(1872),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1896),
    [anon_sym___alignof] = ACTIONS(1896),
    [anon_sym__alignof] = ACTIONS(1896),
    [anon_sym_alignof] = ACTIONS(1896),
    [anon_sym__Alignof] = ACTIONS(1896),
    [anon_sym_offsetof] = ACTIONS(1898),
    [anon_sym__Generic] = ACTIONS(1900),
    [anon_sym_asm] = ACTIONS(1902),
    [anon_sym___asm__] = ACTIONS(1902),
    [anon_sym___asm] = ACTIONS(1902),
    [sym_number_literal] = ACTIONS(1904),
    [anon_sym_L_SQUOTE] = ACTIONS(1906),
    [anon_sym_u_SQUOTE] = ACTIONS(1906),
    [anon_sym_U_SQUOTE] = ACTIONS(1906),
    [anon_sym_u8_SQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_L_DQUOTE] = ACTIONS(1908),
    [anon_sym_u_DQUOTE] = ACTIONS(1908),
    [anon_sym_U_DQUOTE] = ACTIONS(1908),
    [anon_sym_u8_DQUOTE] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1908),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [anon_sym_NULL] = ACTIONS(1912),
    [anon_sym_nullptr] = ACTIONS(1912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1910),
  },
  [1416] = {
    [sym_expression] = STATE(4441),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1417] = {
    [sym_expression] = STATE(2377),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1418] = {
    [sym_expression] = STATE(2379),
    [sym__string] = STATE(3181),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(3181),
    [sym_concatenated_string] = STATE(3181),
    [sym_string_literal] = STATE(2297),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2297),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2311),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2307),
    [anon_sym_compl] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4396),
    [anon_sym_sizeof] = ACTIONS(2315),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2317),
    [anon_sym_L_SQUOTE] = ACTIONS(2319),
    [anon_sym_u_SQUOTE] = ACTIONS(2319),
    [anon_sym_U_SQUOTE] = ACTIONS(2319),
    [anon_sym_u8_SQUOTE] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_L_DQUOTE] = ACTIONS(2321),
    [anon_sym_u_DQUOTE] = ACTIONS(2321),
    [anon_sym_U_DQUOTE] = ACTIONS(2321),
    [anon_sym_u8_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_R_DQUOTE] = ACTIONS(2325),
    [anon_sym_LR_DQUOTE] = ACTIONS(2325),
    [anon_sym_uR_DQUOTE] = ACTIONS(2325),
    [anon_sym_UR_DQUOTE] = ACTIONS(2325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2325),
    [anon_sym_co_await] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1419] = {
    [sym_expression] = STATE(3112),
    [sym__string] = STATE(3235),
    [sym_conditional_expression] = STATE(3373),
    [sym_assignment_expression] = STATE(3373),
    [sym_pointer_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3373),
    [sym_binary_expression] = STATE(3373),
    [sym_update_expression] = STATE(3373),
    [sym_cast_expression] = STATE(3373),
    [sym_sizeof_expression] = STATE(3373),
    [sym_alignof_expression] = STATE(3373),
    [sym_offsetof_expression] = STATE(3373),
    [sym_generic_expression] = STATE(3373),
    [sym_subscript_expression] = STATE(3365),
    [sym_call_expression] = STATE(3365),
    [sym_gnu_asm_expression] = STATE(3373),
    [sym_extension_expression] = STATE(3373),
    [sym_field_expression] = STATE(3365),
    [sym_compound_literal_expression] = STATE(3373),
    [sym_parenthesized_expression] = STATE(3365),
    [sym_char_literal] = STATE(3235),
    [sym_concatenated_string] = STATE(3235),
    [sym_string_literal] = STATE(2358),
    [sym_null] = STATE(3373),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7814),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3373),
    [sym_raw_string_literal] = STATE(2358),
    [sym_co_await_expression] = STATE(3373),
    [sym_new_expression] = STATE(3373),
    [sym_delete_expression] = STATE(3373),
    [sym_requires_clause] = STATE(3373),
    [sym_requires_expression] = STATE(3373),
    [sym_lambda_expression] = STATE(3373),
    [sym_lambda_capture_specifier] = STATE(5414),
    [sym_fold_expression] = STATE(3373),
    [sym_parameter_pack_expansion] = STATE(3373),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5737),
    [sym_qualified_identifier] = STATE(3365),
    [sym_qualified_type_identifier] = STATE(7814),
    [sym_user_defined_literal] = STATE(3365),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [anon_sym___extension__] = ACTIONS(2455),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2459),
    [anon_sym_not] = ACTIONS(1798),
    [anon_sym_compl] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym___asm] = ACTIONS(1834),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_R_DQUOTE] = ACTIONS(1856),
    [anon_sym_LR_DQUOTE] = ACTIONS(1856),
    [anon_sym_uR_DQUOTE] = ACTIONS(1856),
    [anon_sym_UR_DQUOTE] = ACTIONS(1856),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1856),
    [anon_sym_co_await] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_requires] = ACTIONS(1862),
    [sym_this] = ACTIONS(1842),
  },
  [1420] = {
    [sym_expression] = STATE(2377),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1421] = {
    [sym_expression] = STATE(2379),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1422] = {
    [sym_expression] = STATE(4474),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1423] = {
    [sym_expression] = STATE(4476),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1424] = {
    [sym_expression] = STATE(4288),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1425] = {
    [sym_expression] = STATE(4290),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1426] = {
    [sym_expression] = STATE(4269),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1427] = {
    [sym_expression] = STATE(4302),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1428] = {
    [sym_expression] = STATE(4745),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1429] = {
    [sym_expression] = STATE(4754),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1430] = {
    [sym_expression] = STATE(4490),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1431] = {
    [sym_expression] = STATE(4495),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(4939),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1432] = {
    [sym_expression] = STATE(4272),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1433] = {
    [sym_expression] = STATE(4510),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1434] = {
    [sym_expression] = STATE(4496),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1435] = {
    [sym_expression] = STATE(4511),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1436] = {
    [sym_expression] = STATE(4512),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1437] = {
    [sym_expression] = STATE(4515),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1438] = {
    [sym_expression] = STATE(4516),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1439] = {
    [sym_expression] = STATE(4534),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1440] = {
    [sym_expression] = STATE(4536),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1441] = {
    [sym_expression] = STATE(4538),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1442] = {
    [sym_expression] = STATE(4542),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1443] = {
    [sym_expression] = STATE(4548),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1444] = {
    [sym_expression] = STATE(4696),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1445] = {
    [sym_expression] = STATE(4750),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1446] = {
    [sym_expression] = STATE(4756),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1447] = {
    [sym_expression] = STATE(4566),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1448] = {
    [sym_expression] = STATE(4775),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1449] = {
    [sym_expression] = STATE(4569),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1450] = {
    [sym_expression] = STATE(4390),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1451] = {
    [sym_expression] = STATE(4700),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1452] = {
    [sym_expression] = STATE(4714),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1453] = {
    [sym_expression] = STATE(4479),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1454] = {
    [sym_expression] = STATE(4649),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1455] = {
    [sym_expression] = STATE(4681),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1456] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1457] = {
    [sym_expression] = STATE(4613),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1458] = {
    [sym_expression] = STATE(4331),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1459] = {
    [sym_expression] = STATE(4627),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1460] = {
    [sym_expression] = STATE(4637),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1461] = {
    [sym_expression] = STATE(4682),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1462] = {
    [sym_expression] = STATE(4702),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1463] = {
    [sym_expression] = STATE(4703),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1464] = {
    [sym_expression] = STATE(4705),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1465] = {
    [sym_expression] = STATE(4360),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1466] = {
    [sym_expression] = STATE(4595),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1467] = {
    [sym_expression] = STATE(4603),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1468] = {
    [sym_expression] = STATE(4618),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1469] = {
    [sym_expression] = STATE(4620),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1470] = {
    [sym_expression] = STATE(4621),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1471] = {
    [sym_expression] = STATE(4622),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1472] = {
    [sym_expression] = STATE(4377),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1473] = {
    [sym_expression] = STATE(4664),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1474] = {
    [sym_expression] = STATE(4669),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1475] = {
    [sym_expression] = STATE(4670),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1476] = {
    [sym_expression] = STATE(4672),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1477] = {
    [sym_expression] = STATE(4607),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1478] = {
    [sym_expression] = STATE(4401),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1479] = {
    [sym_expression] = STATE(4712),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1480] = {
    [sym_expression] = STATE(4721),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1481] = {
    [sym_expression] = STATE(4724),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1482] = {
    [sym_expression] = STATE(4545),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1483] = {
    [sym_expression] = STATE(4547),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1484] = {
    [sym_expression] = STATE(4665),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1485] = {
    [sym_expression] = STATE(4492),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1486] = {
    [sym_expression] = STATE(4550),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3568),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3568),
    [sym_call_expression] = STATE(3568),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3568),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3568),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3568),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3568),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4404),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1487] = {
    [sym_expression] = STATE(4506),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1488] = {
    [sym_expression] = STATE(3304),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1489] = {
    [sym_expression] = STATE(3306),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1490] = {
    [sym_expression] = STATE(3760),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1491] = {
    [sym_expression] = STATE(4440),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1492] = {
    [sym_expression] = STATE(4453),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1493] = {
    [sym_expression] = STATE(4464),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1494] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1495] = {
    [sym_expression] = STATE(4481),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1496] = {
    [sym_expression] = STATE(3333),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1497] = {
    [sym_expression] = STATE(3305),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1498] = {
    [sym_expression] = STATE(3312),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1499] = {
    [sym_expression] = STATE(3313),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1500] = {
    [sym_expression] = STATE(3314),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1501] = {
    [sym_expression] = STATE(3315),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1502] = {
    [sym_expression] = STATE(3316),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1503] = {
    [sym_expression] = STATE(3317),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1504] = {
    [sym_expression] = STATE(3318),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1505] = {
    [sym_expression] = STATE(3319),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1506] = {
    [sym_expression] = STATE(3320),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1507] = {
    [sym_expression] = STATE(3209),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1508] = {
    [sym_expression] = STATE(3308),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(4943),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1509] = {
    [sym_expression] = STATE(3309),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1510] = {
    [sym_expression] = STATE(3310),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(4945),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1511] = {
    [sym_expression] = STATE(3322),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1512] = {
    [sym_expression] = STATE(3325),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1513] = {
    [sym_expression] = STATE(3327),
    [sym__string] = STATE(2950),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2950),
    [sym_concatenated_string] = STATE(2950),
    [sym_string_literal] = STATE(2034),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(2034),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_AMP] = ACTIONS(4312),
    [anon_sym___extension__] = ACTIONS(2537),
    [anon_sym_COLON_COLON] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(2533),
    [anon_sym_compl] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4316),
    [anon_sym_sizeof] = ACTIONS(2541),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2004),
    [anon_sym_u_SQUOTE] = ACTIONS(2004),
    [anon_sym_U_SQUOTE] = ACTIONS(2004),
    [anon_sym_u8_SQUOTE] = ACTIONS(2004),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2545),
    [anon_sym_new] = ACTIONS(2014),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1514] = {
    [sym_expression] = STATE(4533),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1515] = {
    [sym_expression] = STATE(4517),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(4947),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1516] = {
    [sym_expression] = STATE(4519),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1517] = {
    [sym_expression] = STATE(4520),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1518] = {
    [sym_expression] = STATE(4521),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1519] = {
    [sym_expression] = STATE(4523),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1520] = {
    [sym_expression] = STATE(4524),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1521] = {
    [sym_expression] = STATE(4525),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1522] = {
    [sym_expression] = STATE(4526),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1523] = {
    [sym_expression] = STATE(4527),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1524] = {
    [sym_expression] = STATE(4528),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1525] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1526] = {
    [sym_expression] = STATE(4530),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1527] = {
    [sym_expression] = STATE(4532),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1528] = {
    [sym_expression] = STATE(3782),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1529] = {
    [sym_expression] = STATE(3750),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1530] = {
    [sym_expression] = STATE(4535),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(4949),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1531] = {
    [sym_expression] = STATE(3766),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3678),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3678),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3678),
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(3855),
    [anon_sym_COLON_COLON] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_compl] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1532] = {
    [sym_expression] = STATE(4473),
    [sym__string] = STATE(4738),
    [sym_conditional_expression] = STATE(4829),
    [sym_assignment_expression] = STATE(4829),
    [sym_pointer_expression] = STATE(3602),
    [sym_unary_expression] = STATE(4829),
    [sym_binary_expression] = STATE(4829),
    [sym_update_expression] = STATE(4829),
    [sym_cast_expression] = STATE(4829),
    [sym_sizeof_expression] = STATE(4829),
    [sym_alignof_expression] = STATE(4829),
    [sym_offsetof_expression] = STATE(4829),
    [sym_generic_expression] = STATE(4829),
    [sym_subscript_expression] = STATE(3602),
    [sym_call_expression] = STATE(3602),
    [sym_gnu_asm_expression] = STATE(4829),
    [sym_extension_expression] = STATE(4829),
    [sym_field_expression] = STATE(3602),
    [sym_compound_literal_expression] = STATE(4829),
    [sym_parenthesized_expression] = STATE(3602),
    [sym_char_literal] = STATE(4738),
    [sym_concatenated_string] = STATE(4738),
    [sym_string_literal] = STATE(3759),
    [sym_null] = STATE(4829),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7804),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(4829),
    [sym_raw_string_literal] = STATE(3759),
    [sym_co_await_expression] = STATE(4829),
    [sym_new_expression] = STATE(4829),
    [sym_delete_expression] = STATE(4829),
    [sym_requires_clause] = STATE(4829),
    [sym_requires_expression] = STATE(4829),
    [sym_lambda_expression] = STATE(4829),
    [sym_lambda_capture_specifier] = STATE(5401),
    [sym_fold_expression] = STATE(4829),
    [sym_parameter_pack_expansion] = STATE(4829),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5773),
    [sym_qualified_identifier] = STATE(3602),
    [sym_qualified_type_identifier] = STATE(7804),
    [sym_user_defined_literal] = STATE(3602),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_LPAREN2] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [anon_sym___asm] = ACTIONS(3152),
    [sym_number_literal] = ACTIONS(3154),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_R_DQUOTE] = ACTIONS(3174),
    [anon_sym_LR_DQUOTE] = ACTIONS(3174),
    [anon_sym_uR_DQUOTE] = ACTIONS(3174),
    [anon_sym_UR_DQUOTE] = ACTIONS(3174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3174),
    [anon_sym_co_await] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3180),
    [sym_this] = ACTIONS(3160),
  },
  [1533] = {
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1534] = {
    [sym_expression] = STATE(4771),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1535] = {
    [sym_expression] = STATE(4772),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1536] = {
    [sym_expression] = STATE(4773),
    [sym__string] = STATE(4250),
    [sym_conditional_expression] = STATE(3889),
    [sym_assignment_expression] = STATE(3889),
    [sym_pointer_expression] = STATE(3242),
    [sym_unary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_cast_expression] = STATE(3889),
    [sym_sizeof_expression] = STATE(3889),
    [sym_alignof_expression] = STATE(3889),
    [sym_offsetof_expression] = STATE(3889),
    [sym_generic_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(3242),
    [sym_call_expression] = STATE(3242),
    [sym_gnu_asm_expression] = STATE(3889),
    [sym_extension_expression] = STATE(3889),
    [sym_field_expression] = STATE(3242),
    [sym_compound_literal_expression] = STATE(3889),
    [sym_parenthesized_expression] = STATE(3242),
    [sym_char_literal] = STATE(4250),
    [sym_concatenated_string] = STATE(4250),
    [sym_string_literal] = STATE(3187),
    [sym_null] = STATE(3889),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7608),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(3889),
    [sym_raw_string_literal] = STATE(3187),
    [sym_co_await_expression] = STATE(3889),
    [sym_new_expression] = STATE(3889),
    [sym_delete_expression] = STATE(3889),
    [sym_requires_clause] = STATE(3889),
    [sym_requires_expression] = STATE(3889),
    [sym_lambda_expression] = STATE(3889),
    [sym_lambda_capture_specifier] = STATE(5399),
    [sym_fold_expression] = STATE(3889),
    [sym_parameter_pack_expansion] = STATE(3889),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(3242),
    [sym_qualified_type_identifier] = STATE(7608),
    [sym_user_defined_literal] = STATE(3242),
    [sym_identifier] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(227),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(229),
    [sym_false] = ACTIONS(229),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(229),
  },
  [1537] = {
    [sym_expression] = STATE(2798),
    [sym__string] = STATE(2870),
    [sym_conditional_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_pointer_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_update_expression] = STATE(2461),
    [sym_cast_expression] = STATE(2461),
    [sym_sizeof_expression] = STATE(2461),
    [sym_alignof_expression] = STATE(2461),
    [sym_offsetof_expression] = STATE(2461),
    [sym_generic_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_gnu_asm_expression] = STATE(2461),
    [sym_extension_expression] = STATE(2461),
    [sym_field_expression] = STATE(2480),
    [sym_compound_literal_expression] = STATE(2461),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_char_literal] = STATE(2870),
    [sym_concatenated_string] = STATE(2870),
    [sym_string_literal] = STATE(1942),
    [sym_null] = STATE(2461),
    [sym_decltype] = STATE(8601),
    [sym__class_name] = STATE(7743),
    [sym_template_type] = STATE(1893),
    [sym_template_function] = STATE(2461),
    [sym_raw_string_literal] = STATE(1942),
    [sym_co_await_expression] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_delete_expression] = STATE(2461),
    [sym_requires_clause] = STATE(2461),
    [sym_requires_expression] = STATE(2461),
    [sym_lambda_expression] = STATE(2461),
    [sym_lambda_capture_specifier] = STATE(5402),
    [sym_fold_expression] = STATE(2461),
    [sym_parameter_pack_expansion] = STATE(2461),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5772),
    [sym_qualified_identifier] = STATE(2480),
    [sym_qualified_type_identifier] = STATE(7743),
    [sym_user_defined_literal] = STATE(2480),
    [sym_identifier] = ACTIONS(1990),
    [anon_sym_LPAREN2] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(1956),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1960),
    [anon_sym___alignof] = ACTIONS(1960),
    [anon_sym__alignof] = ACTIONS(1960),
    [anon_sym_alignof] = ACTIONS(1960),
    [anon_sym__Alignof] = ACTIONS(1960),
    [anon_sym_offsetof] = ACTIONS(1962),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1966),
    [anon_sym___asm__] = ACTIONS(1966),
    [anon_sym___asm] = ACTIONS(1966),
    [sym_number_literal] = ACTIONS(1968),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1986),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1974),
  },
  [1538] = {
    [sym_identifier] = ACTIONS(4951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4953),
    [anon_sym_COMMA] = ACTIONS(4953),
    [anon_sym_RPAREN] = ACTIONS(4953),
    [anon_sym_LPAREN2] = ACTIONS(4953),
    [anon_sym_TILDE] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4951),
    [anon_sym_SLASH] = ACTIONS(4951),
    [anon_sym_PERCENT] = ACTIONS(4951),
    [anon_sym_PIPE_PIPE] = ACTIONS(4953),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_PIPE] = ACTIONS(4951),
    [anon_sym_CARET] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_EQ_EQ] = ACTIONS(4953),
    [anon_sym_BANG_EQ] = ACTIONS(4953),
    [anon_sym_GT] = ACTIONS(4951),
    [anon_sym_GT_EQ] = ACTIONS(4953),
    [anon_sym_LT_EQ] = ACTIONS(4951),
    [anon_sym_LT] = ACTIONS(4951),
    [anon_sym_LT_LT] = ACTIONS(4951),
    [anon_sym_GT_GT] = ACTIONS(4951),
    [anon_sym_SEMI] = ACTIONS(4953),
    [anon_sym___extension__] = ACTIONS(4951),
    [anon_sym_virtual] = ACTIONS(4951),
    [anon_sym_extern] = ACTIONS(4951),
    [anon_sym___attribute__] = ACTIONS(4951),
    [anon_sym___attribute] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4953),
    [anon_sym___declspec] = ACTIONS(4951),
    [anon_sym___based] = ACTIONS(4951),
    [anon_sym___cdecl] = ACTIONS(4951),
    [anon_sym___clrcall] = ACTIONS(4951),
    [anon_sym___stdcall] = ACTIONS(4951),
    [anon_sym___fastcall] = ACTIONS(4951),
    [anon_sym___thiscall] = ACTIONS(4951),
    [anon_sym___vectorcall] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4953),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym_LBRACK] = ACTIONS(4951),
    [anon_sym_static] = ACTIONS(4951),
    [anon_sym_EQ] = ACTIONS(4951),
    [anon_sym_register] = ACTIONS(4951),
    [anon_sym_inline] = ACTIONS(4951),
    [anon_sym___inline] = ACTIONS(4951),
    [anon_sym___inline__] = ACTIONS(4951),
    [anon_sym___forceinline] = ACTIONS(4951),
    [anon_sym_thread_local] = ACTIONS(4951),
    [anon_sym___thread] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym_restrict] = ACTIONS(4951),
    [anon_sym___restrict__] = ACTIONS(4951),
    [anon_sym__Atomic] = ACTIONS(4951),
    [anon_sym__Noreturn] = ACTIONS(4951),
    [anon_sym_noreturn] = ACTIONS(4951),
    [anon_sym__Nonnull] = ACTIONS(4951),
    [anon_sym_mutable] = ACTIONS(4951),
    [anon_sym_constinit] = ACTIONS(4951),
    [anon_sym_consteval] = ACTIONS(4951),
    [anon_sym_alignas] = ACTIONS(4951),
    [anon_sym__Alignas] = ACTIONS(4951),
    [anon_sym_QMARK] = ACTIONS(4953),
    [anon_sym_STAR_EQ] = ACTIONS(4953),
    [anon_sym_SLASH_EQ] = ACTIONS(4953),
    [anon_sym_PERCENT_EQ] = ACTIONS(4953),
    [anon_sym_PLUS_EQ] = ACTIONS(4953),
    [anon_sym_DASH_EQ] = ACTIONS(4953),
    [anon_sym_LT_LT_EQ] = ACTIONS(4953),
    [anon_sym_GT_GT_EQ] = ACTIONS(4953),
    [anon_sym_AMP_EQ] = ACTIONS(4953),
    [anon_sym_CARET_EQ] = ACTIONS(4953),
    [anon_sym_PIPE_EQ] = ACTIONS(4953),
    [anon_sym_and_eq] = ACTIONS(4951),
    [anon_sym_or_eq] = ACTIONS(4951),
    [anon_sym_xor_eq] = ACTIONS(4951),
    [anon_sym_LT_EQ_GT] = ACTIONS(4953),
    [anon_sym_or] = ACTIONS(4951),
    [anon_sym_and] = ACTIONS(4951),
    [anon_sym_bitor] = ACTIONS(4951),
    [anon_sym_xor] = ACTIONS(4951),
    [anon_sym_bitand] = ACTIONS(4951),
    [anon_sym_not_eq] = ACTIONS(4951),
    [anon_sym_DASH_DASH] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4953),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_DOT_STAR] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4951),
    [anon_sym_decltype] = ACTIONS(4951),
    [anon_sym_template] = ACTIONS(4951),
    [anon_sym_operator] = ACTIONS(4951),
  },
  [1539] = {
    [sym_identifier] = ACTIONS(4955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4957),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4957),
    [anon_sym_LPAREN2] = ACTIONS(4957),
    [anon_sym_TILDE] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_SLASH] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4957),
    [anon_sym_AMP_AMP] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4955),
    [anon_sym_CARET] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4957),
    [anon_sym_BANG_EQ] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_GT_EQ] = ACTIONS(4957),
    [anon_sym_LT_EQ] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4955),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym___extension__] = ACTIONS(4955),
    [anon_sym_virtual] = ACTIONS(4955),
    [anon_sym_extern] = ACTIONS(4955),
    [anon_sym___attribute__] = ACTIONS(4955),
    [anon_sym___attribute] = ACTIONS(4955),
    [anon_sym_COLON_COLON] = ACTIONS(4957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4957),
    [anon_sym___declspec] = ACTIONS(4955),
    [anon_sym___based] = ACTIONS(4955),
    [anon_sym___cdecl] = ACTIONS(4955),
    [anon_sym___clrcall] = ACTIONS(4955),
    [anon_sym___stdcall] = ACTIONS(4955),
    [anon_sym___fastcall] = ACTIONS(4955),
    [anon_sym___thiscall] = ACTIONS(4955),
    [anon_sym___vectorcall] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(4957),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4955),
    [anon_sym_static] = ACTIONS(4955),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_register] = ACTIONS(4955),
    [anon_sym_inline] = ACTIONS(4955),
    [anon_sym___inline] = ACTIONS(4955),
    [anon_sym___inline__] = ACTIONS(4955),
    [anon_sym___forceinline] = ACTIONS(4955),
    [anon_sym_thread_local] = ACTIONS(4955),
    [anon_sym___thread] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_constexpr] = ACTIONS(4955),
    [anon_sym_volatile] = ACTIONS(4955),
    [anon_sym_restrict] = ACTIONS(4955),
    [anon_sym___restrict__] = ACTIONS(4955),
    [anon_sym__Atomic] = ACTIONS(4955),
    [anon_sym__Noreturn] = ACTIONS(4955),
    [anon_sym_noreturn] = ACTIONS(4955),
    [anon_sym__Nonnull] = ACTIONS(4955),
    [anon_sym_mutable] = ACTIONS(4955),
    [anon_sym_constinit] = ACTIONS(4955),
    [anon_sym_consteval] = ACTIONS(4955),
    [anon_sym_alignas] = ACTIONS(4955),
    [anon_sym__Alignas] = ACTIONS(4955),
    [anon_sym_QMARK] = ACTIONS(4957),
    [anon_sym_STAR_EQ] = ACTIONS(4957),
    [anon_sym_SLASH_EQ] = ACTIONS(4957),
    [anon_sym_PERCENT_EQ] = ACTIONS(4957),
    [anon_sym_PLUS_EQ] = ACTIONS(4957),
    [anon_sym_DASH_EQ] = ACTIONS(4957),
    [anon_sym_LT_LT_EQ] = ACTIONS(4957),
    [anon_sym_GT_GT_EQ] = ACTIONS(4957),
    [anon_sym_AMP_EQ] = ACTIONS(4957),
    [anon_sym_CARET_EQ] = ACTIONS(4957),
    [anon_sym_PIPE_EQ] = ACTIONS(4957),
    [anon_sym_and_eq] = ACTIONS(4955),
    [anon_sym_or_eq] = ACTIONS(4955),
    [anon_sym_xor_eq] = ACTIONS(4955),
    [anon_sym_LT_EQ_GT] = ACTIONS(4957),
    [anon_sym_or] = ACTIONS(4955),
    [anon_sym_and] = ACTIONS(4955),
    [anon_sym_bitor] = ACTIONS(4955),
    [anon_sym_xor] = ACTIONS(4955),
    [anon_sym_bitand] = ACTIONS(4955),
    [anon_sym_not_eq] = ACTIONS(4955),
    [anon_sym_DASH_DASH] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4957),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_DOT_STAR] = ACTIONS(4957),
    [anon_sym_DASH_GT] = ACTIONS(4957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4955),
    [anon_sym_decltype] = ACTIONS(4955),
    [anon_sym_template] = ACTIONS(4955),
    [anon_sym_operator] = ACTIONS(4955),
  },
  [1540] = {
    [sym_identifier] = ACTIONS(4959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_TILDE] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_SLASH] = ACTIONS(4959),
    [anon_sym_PERCENT] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4959),
    [anon_sym_CARET] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4959),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym___extension__] = ACTIONS(4959),
    [anon_sym_virtual] = ACTIONS(4959),
    [anon_sym_extern] = ACTIONS(4959),
    [anon_sym___attribute__] = ACTIONS(4959),
    [anon_sym___attribute] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(4961),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4961),
    [anon_sym___declspec] = ACTIONS(4959),
    [anon_sym___based] = ACTIONS(4959),
    [anon_sym___cdecl] = ACTIONS(4959),
    [anon_sym___clrcall] = ACTIONS(4959),
    [anon_sym___stdcall] = ACTIONS(4959),
    [anon_sym___fastcall] = ACTIONS(4959),
    [anon_sym___thiscall] = ACTIONS(4959),
    [anon_sym___vectorcall] = ACTIONS(4959),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_RBRACE] = ACTIONS(4961),
    [anon_sym_LBRACK] = ACTIONS(4959),
    [anon_sym_static] = ACTIONS(4959),
    [anon_sym_EQ] = ACTIONS(4959),
    [anon_sym_register] = ACTIONS(4959),
    [anon_sym_inline] = ACTIONS(4959),
    [anon_sym___inline] = ACTIONS(4959),
    [anon_sym___inline__] = ACTIONS(4959),
    [anon_sym___forceinline] = ACTIONS(4959),
    [anon_sym_thread_local] = ACTIONS(4959),
    [anon_sym___thread] = ACTIONS(4959),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_constexpr] = ACTIONS(4959),
    [anon_sym_volatile] = ACTIONS(4959),
    [anon_sym_restrict] = ACTIONS(4959),
    [anon_sym___restrict__] = ACTIONS(4959),
    [anon_sym__Atomic] = ACTIONS(4959),
    [anon_sym__Noreturn] = ACTIONS(4959),
    [anon_sym_noreturn] = ACTIONS(4959),
    [anon_sym__Nonnull] = ACTIONS(4959),
    [anon_sym_mutable] = ACTIONS(4959),
    [anon_sym_constinit] = ACTIONS(4959),
    [anon_sym_consteval] = ACTIONS(4959),
    [anon_sym_alignas] = ACTIONS(4959),
    [anon_sym__Alignas] = ACTIONS(4959),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4961),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_and_eq] = ACTIONS(4959),
    [anon_sym_or_eq] = ACTIONS(4959),
    [anon_sym_xor_eq] = ACTIONS(4959),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4959),
    [anon_sym_and] = ACTIONS(4959),
    [anon_sym_bitor] = ACTIONS(4959),
    [anon_sym_xor] = ACTIONS(4959),
    [anon_sym_bitand] = ACTIONS(4959),
    [anon_sym_not_eq] = ACTIONS(4959),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4959),
    [anon_sym_decltype] = ACTIONS(4959),
    [anon_sym_template] = ACTIONS(4959),
    [anon_sym_operator] = ACTIONS(4959),
  },
  [1541] = {
    [sym_template_argument_list] = STATE(1546),
    [sym_identifier] = ACTIONS(4963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_LPAREN2] = ACTIONS(4967),
    [anon_sym_TILDE] = ACTIONS(4970),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_SLASH] = ACTIONS(4972),
    [anon_sym_PERCENT] = ACTIONS(4972),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4972),
    [anon_sym_CARET] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4974),
    [anon_sym_EQ_EQ] = ACTIONS(4965),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_GT] = ACTIONS(4972),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(4977),
    [anon_sym_LT_LT] = ACTIONS(4972),
    [anon_sym_GT_GT] = ACTIONS(4972),
    [anon_sym_SEMI] = ACTIONS(4967),
    [anon_sym___extension__] = ACTIONS(4963),
    [anon_sym_virtual] = ACTIONS(4963),
    [anon_sym_extern] = ACTIONS(4963),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4967),
    [anon_sym___declspec] = ACTIONS(4963),
    [anon_sym___based] = ACTIONS(4963),
    [anon_sym___cdecl] = ACTIONS(4963),
    [anon_sym___clrcall] = ACTIONS(4963),
    [anon_sym___stdcall] = ACTIONS(4963),
    [anon_sym___fastcall] = ACTIONS(4963),
    [anon_sym___thiscall] = ACTIONS(4963),
    [anon_sym___vectorcall] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4974),
    [anon_sym_static] = ACTIONS(4963),
    [anon_sym_EQ] = ACTIONS(4972),
    [anon_sym_register] = ACTIONS(4963),
    [anon_sym_inline] = ACTIONS(4963),
    [anon_sym___inline] = ACTIONS(4963),
    [anon_sym___inline__] = ACTIONS(4963),
    [anon_sym___forceinline] = ACTIONS(4963),
    [anon_sym_thread_local] = ACTIONS(4963),
    [anon_sym___thread] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_constexpr] = ACTIONS(4963),
    [anon_sym_volatile] = ACTIONS(4963),
    [anon_sym_restrict] = ACTIONS(4963),
    [anon_sym___restrict__] = ACTIONS(4963),
    [anon_sym__Atomic] = ACTIONS(4963),
    [anon_sym__Noreturn] = ACTIONS(4963),
    [anon_sym_noreturn] = ACTIONS(4963),
    [anon_sym__Nonnull] = ACTIONS(4963),
    [anon_sym_mutable] = ACTIONS(4963),
    [anon_sym_constinit] = ACTIONS(4963),
    [anon_sym_consteval] = ACTIONS(4963),
    [anon_sym_alignas] = ACTIONS(4963),
    [anon_sym__Alignas] = ACTIONS(4963),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_and_eq] = ACTIONS(4972),
    [anon_sym_or_eq] = ACTIONS(4972),
    [anon_sym_xor_eq] = ACTIONS(4972),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4972),
    [anon_sym_and] = ACTIONS(4972),
    [anon_sym_bitor] = ACTIONS(4972),
    [anon_sym_xor] = ACTIONS(4972),
    [anon_sym_bitand] = ACTIONS(4972),
    [anon_sym_not_eq] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(4965),
    [anon_sym_PLUS_PLUS] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4972),
    [anon_sym_DOT_STAR] = ACTIONS(4965),
    [anon_sym_DASH_GT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_template] = ACTIONS(4963),
    [anon_sym_operator] = ACTIONS(4963),
  },
  [1542] = {
    [sym_identifier] = ACTIONS(4980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_RPAREN] = ACTIONS(4982),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(4982),
    [anon_sym_DASH] = ACTIONS(4980),
    [anon_sym_PLUS] = ACTIONS(4980),
    [anon_sym_STAR] = ACTIONS(4980),
    [anon_sym_SLASH] = ACTIONS(4980),
    [anon_sym_PERCENT] = ACTIONS(4980),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4980),
    [anon_sym_CARET] = ACTIONS(4980),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4982),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_LT_LT] = ACTIONS(4980),
    [anon_sym_GT_GT] = ACTIONS(4980),
    [anon_sym_SEMI] = ACTIONS(4982),
    [anon_sym___extension__] = ACTIONS(4980),
    [anon_sym_virtual] = ACTIONS(4980),
    [anon_sym_extern] = ACTIONS(4980),
    [anon_sym___attribute__] = ACTIONS(4980),
    [anon_sym___attribute] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4982),
    [anon_sym___declspec] = ACTIONS(4980),
    [anon_sym___based] = ACTIONS(4980),
    [anon_sym___cdecl] = ACTIONS(4980),
    [anon_sym___clrcall] = ACTIONS(4980),
    [anon_sym___stdcall] = ACTIONS(4980),
    [anon_sym___fastcall] = ACTIONS(4980),
    [anon_sym___thiscall] = ACTIONS(4980),
    [anon_sym___vectorcall] = ACTIONS(4980),
    [anon_sym_LBRACE] = ACTIONS(4982),
    [anon_sym_RBRACE] = ACTIONS(4982),
    [anon_sym_LBRACK] = ACTIONS(4980),
    [anon_sym_static] = ACTIONS(4980),
    [anon_sym_EQ] = ACTIONS(4980),
    [anon_sym_register] = ACTIONS(4980),
    [anon_sym_inline] = ACTIONS(4980),
    [anon_sym___inline] = ACTIONS(4980),
    [anon_sym___inline__] = ACTIONS(4980),
    [anon_sym___forceinline] = ACTIONS(4980),
    [anon_sym_thread_local] = ACTIONS(4980),
    [anon_sym___thread] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4980),
    [anon_sym_volatile] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4980),
    [anon_sym___restrict__] = ACTIONS(4980),
    [anon_sym__Atomic] = ACTIONS(4980),
    [anon_sym__Noreturn] = ACTIONS(4980),
    [anon_sym_noreturn] = ACTIONS(4980),
    [anon_sym__Nonnull] = ACTIONS(4980),
    [anon_sym_mutable] = ACTIONS(4980),
    [anon_sym_constinit] = ACTIONS(4980),
    [anon_sym_consteval] = ACTIONS(4980),
    [anon_sym_alignas] = ACTIONS(4980),
    [anon_sym__Alignas] = ACTIONS(4980),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_STAR_EQ] = ACTIONS(4982),
    [anon_sym_SLASH_EQ] = ACTIONS(4982),
    [anon_sym_PERCENT_EQ] = ACTIONS(4982),
    [anon_sym_PLUS_EQ] = ACTIONS(4982),
    [anon_sym_DASH_EQ] = ACTIONS(4982),
    [anon_sym_LT_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT_GT_EQ] = ACTIONS(4982),
    [anon_sym_AMP_EQ] = ACTIONS(4982),
    [anon_sym_CARET_EQ] = ACTIONS(4982),
    [anon_sym_PIPE_EQ] = ACTIONS(4982),
    [anon_sym_and_eq] = ACTIONS(4980),
    [anon_sym_or_eq] = ACTIONS(4980),
    [anon_sym_xor_eq] = ACTIONS(4980),
    [anon_sym_LT_EQ_GT] = ACTIONS(4982),
    [anon_sym_or] = ACTIONS(4980),
    [anon_sym_and] = ACTIONS(4980),
    [anon_sym_bitor] = ACTIONS(4980),
    [anon_sym_xor] = ACTIONS(4980),
    [anon_sym_bitand] = ACTIONS(4980),
    [anon_sym_not_eq] = ACTIONS(4980),
    [anon_sym_DASH_DASH] = ACTIONS(4982),
    [anon_sym_PLUS_PLUS] = ACTIONS(4982),
    [anon_sym_DOT] = ACTIONS(4980),
    [anon_sym_DOT_STAR] = ACTIONS(4982),
    [anon_sym_DASH_GT] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4980),
    [anon_sym_decltype] = ACTIONS(4980),
    [anon_sym_template] = ACTIONS(4980),
    [anon_sym_operator] = ACTIONS(4980),
  },
  [1543] = {
    [sym_identifier] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_RPAREN] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4986),
    [anon_sym_BANG_EQ] = ACTIONS(4986),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4986),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym_SEMI] = ACTIONS(4986),
    [anon_sym___extension__] = ACTIONS(4984),
    [anon_sym_virtual] = ACTIONS(4984),
    [anon_sym_extern] = ACTIONS(4984),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4986),
    [anon_sym___declspec] = ACTIONS(4984),
    [anon_sym___based] = ACTIONS(4984),
    [anon_sym___cdecl] = ACTIONS(4984),
    [anon_sym___clrcall] = ACTIONS(4984),
    [anon_sym___stdcall] = ACTIONS(4984),
    [anon_sym___fastcall] = ACTIONS(4984),
    [anon_sym___thiscall] = ACTIONS(4984),
    [anon_sym___vectorcall] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4986),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_LBRACK] = ACTIONS(4984),
    [anon_sym_static] = ACTIONS(4984),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_register] = ACTIONS(4984),
    [anon_sym_inline] = ACTIONS(4984),
    [anon_sym___inline] = ACTIONS(4984),
    [anon_sym___inline__] = ACTIONS(4984),
    [anon_sym___forceinline] = ACTIONS(4984),
    [anon_sym_thread_local] = ACTIONS(4984),
    [anon_sym___thread] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym___restrict__] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym__Noreturn] = ACTIONS(4984),
    [anon_sym_noreturn] = ACTIONS(4984),
    [anon_sym__Nonnull] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_constinit] = ACTIONS(4984),
    [anon_sym_consteval] = ACTIONS(4984),
    [anon_sym_alignas] = ACTIONS(4984),
    [anon_sym__Alignas] = ACTIONS(4984),
    [anon_sym_QMARK] = ACTIONS(4986),
    [anon_sym_STAR_EQ] = ACTIONS(4986),
    [anon_sym_SLASH_EQ] = ACTIONS(4986),
    [anon_sym_PERCENT_EQ] = ACTIONS(4986),
    [anon_sym_PLUS_EQ] = ACTIONS(4986),
    [anon_sym_DASH_EQ] = ACTIONS(4986),
    [anon_sym_LT_LT_EQ] = ACTIONS(4986),
    [anon_sym_GT_GT_EQ] = ACTIONS(4986),
    [anon_sym_AMP_EQ] = ACTIONS(4986),
    [anon_sym_CARET_EQ] = ACTIONS(4986),
    [anon_sym_PIPE_EQ] = ACTIONS(4986),
    [anon_sym_and_eq] = ACTIONS(4984),
    [anon_sym_or_eq] = ACTIONS(4984),
    [anon_sym_xor_eq] = ACTIONS(4984),
    [anon_sym_LT_EQ_GT] = ACTIONS(4986),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(4986),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4986),
    [anon_sym_DASH_GT] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_template] = ACTIONS(4984),
    [anon_sym_operator] = ACTIONS(4984),
  },
  [1544] = {
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4990),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_RPAREN] = ACTIONS(4990),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(4988),
    [anon_sym_SLASH] = ACTIONS(4988),
    [anon_sym_PERCENT] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym_EQ_EQ] = ACTIONS(4990),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4988),
    [anon_sym_GT_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4988),
    [anon_sym_GT_GT] = ACTIONS(4988),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym___attribute] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym___cdecl] = ACTIONS(4988),
    [anon_sym___clrcall] = ACTIONS(4988),
    [anon_sym___stdcall] = ACTIONS(4988),
    [anon_sym___fastcall] = ACTIONS(4988),
    [anon_sym___thiscall] = ACTIONS(4988),
    [anon_sym___vectorcall] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_RBRACE] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_EQ] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym__Nonnull] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym__Alignas] = ACTIONS(4988),
    [anon_sym_QMARK] = ACTIONS(4990),
    [anon_sym_STAR_EQ] = ACTIONS(4990),
    [anon_sym_SLASH_EQ] = ACTIONS(4990),
    [anon_sym_PERCENT_EQ] = ACTIONS(4990),
    [anon_sym_PLUS_EQ] = ACTIONS(4990),
    [anon_sym_DASH_EQ] = ACTIONS(4990),
    [anon_sym_LT_LT_EQ] = ACTIONS(4990),
    [anon_sym_GT_GT_EQ] = ACTIONS(4990),
    [anon_sym_AMP_EQ] = ACTIONS(4990),
    [anon_sym_CARET_EQ] = ACTIONS(4990),
    [anon_sym_PIPE_EQ] = ACTIONS(4990),
    [anon_sym_and_eq] = ACTIONS(4988),
    [anon_sym_or_eq] = ACTIONS(4988),
    [anon_sym_xor_eq] = ACTIONS(4988),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_and] = ACTIONS(4988),
    [anon_sym_bitor] = ACTIONS(4988),
    [anon_sym_xor] = ACTIONS(4988),
    [anon_sym_bitand] = ACTIONS(4988),
    [anon_sym_not_eq] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(4990),
    [anon_sym_PLUS_PLUS] = ACTIONS(4990),
    [anon_sym_DOT] = ACTIONS(4988),
    [anon_sym_DOT_STAR] = ACTIONS(4990),
    [anon_sym_DASH_GT] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
  },
  [1545] = {
    [sym_identifier] = ACTIONS(4992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4994),
    [anon_sym_COMMA] = ACTIONS(4994),
    [anon_sym_RPAREN] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_TILDE] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4992),
    [anon_sym_PLUS] = ACTIONS(4992),
    [anon_sym_STAR] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4992),
    [anon_sym_PIPE_PIPE] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(4992),
    [anon_sym_CARET] = ACTIONS(4992),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4994),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_GT_EQ] = ACTIONS(4994),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_SEMI] = ACTIONS(4994),
    [anon_sym___extension__] = ACTIONS(4992),
    [anon_sym_virtual] = ACTIONS(4992),
    [anon_sym_extern] = ACTIONS(4992),
    [anon_sym___attribute__] = ACTIONS(4992),
    [anon_sym___attribute] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4994),
    [anon_sym___declspec] = ACTIONS(4992),
    [anon_sym___based] = ACTIONS(4992),
    [anon_sym___cdecl] = ACTIONS(4992),
    [anon_sym___clrcall] = ACTIONS(4992),
    [anon_sym___stdcall] = ACTIONS(4992),
    [anon_sym___fastcall] = ACTIONS(4992),
    [anon_sym___thiscall] = ACTIONS(4992),
    [anon_sym___vectorcall] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4994),
    [anon_sym_RBRACE] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(4992),
    [anon_sym_static] = ACTIONS(4992),
    [anon_sym_EQ] = ACTIONS(4992),
    [anon_sym_register] = ACTIONS(4992),
    [anon_sym_inline] = ACTIONS(4992),
    [anon_sym___inline] = ACTIONS(4992),
    [anon_sym___inline__] = ACTIONS(4992),
    [anon_sym___forceinline] = ACTIONS(4992),
    [anon_sym_thread_local] = ACTIONS(4992),
    [anon_sym___thread] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym___restrict__] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym__Noreturn] = ACTIONS(4992),
    [anon_sym_noreturn] = ACTIONS(4992),
    [anon_sym__Nonnull] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_constinit] = ACTIONS(4992),
    [anon_sym_consteval] = ACTIONS(4992),
    [anon_sym_alignas] = ACTIONS(4992),
    [anon_sym__Alignas] = ACTIONS(4992),
    [anon_sym_QMARK] = ACTIONS(4994),
    [anon_sym_STAR_EQ] = ACTIONS(4994),
    [anon_sym_SLASH_EQ] = ACTIONS(4994),
    [anon_sym_PERCENT_EQ] = ACTIONS(4994),
    [anon_sym_PLUS_EQ] = ACTIONS(4994),
    [anon_sym_DASH_EQ] = ACTIONS(4994),
    [anon_sym_LT_LT_EQ] = ACTIONS(4994),
    [anon_sym_GT_GT_EQ] = ACTIONS(4994),
    [anon_sym_AMP_EQ] = ACTIONS(4994),
    [anon_sym_CARET_EQ] = ACTIONS(4994),
    [anon_sym_PIPE_EQ] = ACTIONS(4994),
    [anon_sym_and_eq] = ACTIONS(4992),
    [anon_sym_or_eq] = ACTIONS(4992),
    [anon_sym_xor_eq] = ACTIONS(4992),
    [anon_sym_LT_EQ_GT] = ACTIONS(4994),
    [anon_sym_or] = ACTIONS(4992),
    [anon_sym_and] = ACTIONS(4992),
    [anon_sym_bitor] = ACTIONS(4992),
    [anon_sym_xor] = ACTIONS(4992),
    [anon_sym_bitand] = ACTIONS(4992),
    [anon_sym_not_eq] = ACTIONS(4992),
    [anon_sym_DASH_DASH] = ACTIONS(4994),
    [anon_sym_PLUS_PLUS] = ACTIONS(4994),
    [anon_sym_DOT] = ACTIONS(4992),
    [anon_sym_DOT_STAR] = ACTIONS(4994),
    [anon_sym_DASH_GT] = ACTIONS(4994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_decltype] = ACTIONS(4992),
    [anon_sym_template] = ACTIONS(4992),
    [anon_sym_operator] = ACTIONS(4992),
  },
  [1546] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5005),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5005),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym_SEMI] = ACTIONS(5000),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5000),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym___cdecl] = ACTIONS(4996),
    [anon_sym___clrcall] = ACTIONS(4996),
    [anon_sym___stdcall] = ACTIONS(4996),
    [anon_sym___fastcall] = ACTIONS(4996),
    [anon_sym___thiscall] = ACTIONS(4996),
    [anon_sym___vectorcall] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_EQ] = ACTIONS(5005),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym__Nonnull] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym__Alignas] = ACTIONS(4996),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_STAR_EQ] = ACTIONS(4998),
    [anon_sym_SLASH_EQ] = ACTIONS(4998),
    [anon_sym_PERCENT_EQ] = ACTIONS(4998),
    [anon_sym_PLUS_EQ] = ACTIONS(4998),
    [anon_sym_DASH_EQ] = ACTIONS(4998),
    [anon_sym_LT_LT_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT_EQ] = ACTIONS(4998),
    [anon_sym_AMP_EQ] = ACTIONS(4998),
    [anon_sym_CARET_EQ] = ACTIONS(4998),
    [anon_sym_PIPE_EQ] = ACTIONS(4998),
    [anon_sym_and_eq] = ACTIONS(5005),
    [anon_sym_or_eq] = ACTIONS(5005),
    [anon_sym_xor_eq] = ACTIONS(5005),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(5005),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(5005),
    [anon_sym_not_eq] = ACTIONS(5005),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
  },
  [1547] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_ms_call_modifier] = STATE(6311),
    [sym__abstract_declarator] = STATE(6870),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_list] = STATE(3004),
    [sym_parameter_declaration] = STATE(7399),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7399),
    [sym_variadic_parameter_declaration] = STATE(7399),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1928),
    [anon_sym_RPAREN] = ACTIONS(4296),
    [anon_sym_LPAREN2] = ACTIONS(5012),
    [anon_sym_STAR] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(5016),
    [anon_sym_AMP] = ACTIONS(5018),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(1808),
    [anon_sym___clrcall] = ACTIONS(1808),
    [anon_sym___stdcall] = ACTIONS(1808),
    [anon_sym___fastcall] = ACTIONS(1808),
    [anon_sym___thiscall] = ACTIONS(1808),
    [anon_sym___vectorcall] = ACTIONS(1808),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(5022),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1548] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_ms_call_modifier] = STATE(6282),
    [sym__abstract_declarator] = STATE(6904),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_list] = STATE(3004),
    [sym_parameter_declaration] = STATE(7399),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7399),
    [sym_variadic_parameter_declaration] = STATE(7399),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1928),
    [anon_sym_RPAREN] = ACTIONS(4296),
    [anon_sym_LPAREN2] = ACTIONS(5012),
    [anon_sym_STAR] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(5016),
    [anon_sym_AMP] = ACTIONS(5018),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(1808),
    [anon_sym___clrcall] = ACTIONS(1808),
    [anon_sym___stdcall] = ACTIONS(1808),
    [anon_sym___fastcall] = ACTIONS(1808),
    [anon_sym___thiscall] = ACTIONS(1808),
    [anon_sym___vectorcall] = ACTIONS(1808),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(5022),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1549] = {
    [sym_identifier] = ACTIONS(3282),
    [anon_sym_LPAREN2] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3282),
    [anon_sym_PLUS] = ACTIONS(3282),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3287),
    [anon_sym___extension__] = ACTIONS(3282),
    [anon_sym_virtual] = ACTIONS(3282),
    [anon_sym_extern] = ACTIONS(3282),
    [anon_sym___attribute__] = ACTIONS(3282),
    [anon_sym___attribute] = ACTIONS(3282),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3287),
    [anon_sym___declspec] = ACTIONS(3282),
    [anon_sym_signed] = ACTIONS(3282),
    [anon_sym_unsigned] = ACTIONS(3282),
    [anon_sym_long] = ACTIONS(3282),
    [anon_sym_short] = ACTIONS(3282),
    [anon_sym_LBRACK] = ACTIONS(3282),
    [anon_sym_static] = ACTIONS(3282),
    [anon_sym_register] = ACTIONS(3282),
    [anon_sym_inline] = ACTIONS(3282),
    [anon_sym___inline] = ACTIONS(3282),
    [anon_sym___inline__] = ACTIONS(3282),
    [anon_sym___forceinline] = ACTIONS(3282),
    [anon_sym_thread_local] = ACTIONS(3282),
    [anon_sym___thread] = ACTIONS(3282),
    [anon_sym_const] = ACTIONS(3282),
    [anon_sym_constexpr] = ACTIONS(3282),
    [anon_sym_volatile] = ACTIONS(3282),
    [anon_sym_restrict] = ACTIONS(3282),
    [anon_sym___restrict__] = ACTIONS(3282),
    [anon_sym__Atomic] = ACTIONS(3282),
    [anon_sym__Noreturn] = ACTIONS(3282),
    [anon_sym_noreturn] = ACTIONS(3282),
    [anon_sym__Nonnull] = ACTIONS(3282),
    [anon_sym_mutable] = ACTIONS(3282),
    [anon_sym_constinit] = ACTIONS(3282),
    [anon_sym_consteval] = ACTIONS(3282),
    [anon_sym_alignas] = ACTIONS(3282),
    [anon_sym__Alignas] = ACTIONS(3282),
    [sym_primitive_type] = ACTIONS(3282),
    [anon_sym_enum] = ACTIONS(3282),
    [anon_sym_class] = ACTIONS(3282),
    [anon_sym_struct] = ACTIONS(3282),
    [anon_sym_union] = ACTIONS(3282),
    [anon_sym_not] = ACTIONS(3282),
    [anon_sym_compl] = ACTIONS(3282),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_sizeof] = ACTIONS(3282),
    [anon_sym___alignof__] = ACTIONS(3282),
    [anon_sym___alignof] = ACTIONS(3282),
    [anon_sym__alignof] = ACTIONS(3282),
    [anon_sym_alignof] = ACTIONS(3282),
    [anon_sym__Alignof] = ACTIONS(3282),
    [anon_sym_offsetof] = ACTIONS(3282),
    [anon_sym__Generic] = ACTIONS(3282),
    [anon_sym_asm] = ACTIONS(3282),
    [anon_sym___asm__] = ACTIONS(3282),
    [anon_sym___asm] = ACTIONS(3282),
    [sym_number_literal] = ACTIONS(3287),
    [anon_sym_L_SQUOTE] = ACTIONS(3287),
    [anon_sym_u_SQUOTE] = ACTIONS(3287),
    [anon_sym_U_SQUOTE] = ACTIONS(3287),
    [anon_sym_u8_SQUOTE] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3287),
    [anon_sym_L_DQUOTE] = ACTIONS(3287),
    [anon_sym_u_DQUOTE] = ACTIONS(3287),
    [anon_sym_U_DQUOTE] = ACTIONS(3287),
    [anon_sym_u8_DQUOTE] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [sym_true] = ACTIONS(3282),
    [sym_false] = ACTIONS(3282),
    [anon_sym_NULL] = ACTIONS(3282),
    [anon_sym_nullptr] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3282),
    [anon_sym_decltype] = ACTIONS(3282),
    [anon_sym_typename] = ACTIONS(3282),
    [anon_sym_template] = ACTIONS(3282),
    [anon_sym_delete] = ACTIONS(3282),
    [anon_sym_R_DQUOTE] = ACTIONS(3287),
    [anon_sym_LR_DQUOTE] = ACTIONS(3287),
    [anon_sym_uR_DQUOTE] = ACTIONS(3287),
    [anon_sym_UR_DQUOTE] = ACTIONS(3287),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3287),
    [anon_sym_co_await] = ACTIONS(3282),
    [anon_sym_new] = ACTIONS(3282),
    [anon_sym_requires] = ACTIONS(3282),
    [sym_this] = ACTIONS(3282),
  },
  [1550] = {
    [sym_identifier] = ACTIONS(2955),
    [anon_sym_LPAREN2] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2955),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym___extension__] = ACTIONS(2955),
    [anon_sym_virtual] = ACTIONS(2955),
    [anon_sym_extern] = ACTIONS(2955),
    [anon_sym___attribute__] = ACTIONS(2955),
    [anon_sym___attribute] = ACTIONS(2955),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2957),
    [anon_sym___declspec] = ACTIONS(2955),
    [anon_sym_signed] = ACTIONS(2955),
    [anon_sym_unsigned] = ACTIONS(2955),
    [anon_sym_long] = ACTIONS(2955),
    [anon_sym_short] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_register] = ACTIONS(2955),
    [anon_sym_inline] = ACTIONS(2955),
    [anon_sym___inline] = ACTIONS(2955),
    [anon_sym___inline__] = ACTIONS(2955),
    [anon_sym___forceinline] = ACTIONS(2955),
    [anon_sym_thread_local] = ACTIONS(2955),
    [anon_sym___thread] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_constexpr] = ACTIONS(2955),
    [anon_sym_volatile] = ACTIONS(2955),
    [anon_sym_restrict] = ACTIONS(2955),
    [anon_sym___restrict__] = ACTIONS(2955),
    [anon_sym__Atomic] = ACTIONS(2955),
    [anon_sym__Noreturn] = ACTIONS(2955),
    [anon_sym_noreturn] = ACTIONS(2955),
    [anon_sym__Nonnull] = ACTIONS(2955),
    [anon_sym_mutable] = ACTIONS(2955),
    [anon_sym_constinit] = ACTIONS(2955),
    [anon_sym_consteval] = ACTIONS(2955),
    [anon_sym_alignas] = ACTIONS(2955),
    [anon_sym__Alignas] = ACTIONS(2955),
    [sym_primitive_type] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2955),
    [anon_sym_union] = ACTIONS(2955),
    [anon_sym_not] = ACTIONS(2955),
    [anon_sym_compl] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_sizeof] = ACTIONS(2955),
    [anon_sym___alignof__] = ACTIONS(2955),
    [anon_sym___alignof] = ACTIONS(2955),
    [anon_sym__alignof] = ACTIONS(2955),
    [anon_sym_alignof] = ACTIONS(2955),
    [anon_sym__Alignof] = ACTIONS(2955),
    [anon_sym_offsetof] = ACTIONS(2955),
    [anon_sym__Generic] = ACTIONS(2955),
    [anon_sym_asm] = ACTIONS(2955),
    [anon_sym___asm__] = ACTIONS(2955),
    [anon_sym___asm] = ACTIONS(2955),
    [sym_number_literal] = ACTIONS(2957),
    [anon_sym_L_SQUOTE] = ACTIONS(2957),
    [anon_sym_u_SQUOTE] = ACTIONS(2957),
    [anon_sym_U_SQUOTE] = ACTIONS(2957),
    [anon_sym_u8_SQUOTE] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2955),
    [sym_false] = ACTIONS(2955),
    [anon_sym_NULL] = ACTIONS(2955),
    [anon_sym_nullptr] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2955),
    [anon_sym_decltype] = ACTIONS(2955),
    [anon_sym_typename] = ACTIONS(2955),
    [anon_sym_template] = ACTIONS(2955),
    [anon_sym_delete] = ACTIONS(2955),
    [anon_sym_R_DQUOTE] = ACTIONS(2957),
    [anon_sym_LR_DQUOTE] = ACTIONS(2957),
    [anon_sym_uR_DQUOTE] = ACTIONS(2957),
    [anon_sym_UR_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2957),
    [anon_sym_co_await] = ACTIONS(2955),
    [anon_sym_new] = ACTIONS(2955),
    [anon_sym_requires] = ACTIONS(2955),
    [sym_this] = ACTIONS(2955),
  },
  [1551] = {
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3081),
    [anon_sym___extension__] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym___attribute__] = ACTIONS(3079),
    [anon_sym___attribute] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3081),
    [anon_sym___declspec] = ACTIONS(3079),
    [anon_sym_signed] = ACTIONS(3079),
    [anon_sym_unsigned] = ACTIONS(3079),
    [anon_sym_long] = ACTIONS(3079),
    [anon_sym_short] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_register] = ACTIONS(3079),
    [anon_sym_inline] = ACTIONS(3079),
    [anon_sym___inline] = ACTIONS(3079),
    [anon_sym___inline__] = ACTIONS(3079),
    [anon_sym___forceinline] = ACTIONS(3079),
    [anon_sym_thread_local] = ACTIONS(3079),
    [anon_sym___thread] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_constexpr] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_restrict] = ACTIONS(3079),
    [anon_sym___restrict__] = ACTIONS(3079),
    [anon_sym__Atomic] = ACTIONS(3079),
    [anon_sym__Noreturn] = ACTIONS(3079),
    [anon_sym_noreturn] = ACTIONS(3079),
    [anon_sym__Nonnull] = ACTIONS(3079),
    [anon_sym_mutable] = ACTIONS(3079),
    [anon_sym_constinit] = ACTIONS(3079),
    [anon_sym_consteval] = ACTIONS(3079),
    [anon_sym_alignas] = ACTIONS(3079),
    [anon_sym__Alignas] = ACTIONS(3079),
    [sym_primitive_type] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_union] = ACTIONS(3079),
    [anon_sym_not] = ACTIONS(3079),
    [anon_sym_compl] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_sizeof] = ACTIONS(3079),
    [anon_sym___alignof__] = ACTIONS(3079),
    [anon_sym___alignof] = ACTIONS(3079),
    [anon_sym__alignof] = ACTIONS(3079),
    [anon_sym_alignof] = ACTIONS(3079),
    [anon_sym__Alignof] = ACTIONS(3079),
    [anon_sym_offsetof] = ACTIONS(3079),
    [anon_sym__Generic] = ACTIONS(3079),
    [anon_sym_asm] = ACTIONS(3079),
    [anon_sym___asm__] = ACTIONS(3079),
    [anon_sym___asm] = ACTIONS(3079),
    [sym_number_literal] = ACTIONS(3081),
    [anon_sym_L_SQUOTE] = ACTIONS(3081),
    [anon_sym_u_SQUOTE] = ACTIONS(3081),
    [anon_sym_U_SQUOTE] = ACTIONS(3081),
    [anon_sym_u8_SQUOTE] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [anon_sym_L_DQUOTE] = ACTIONS(3081),
    [anon_sym_u_DQUOTE] = ACTIONS(3081),
    [anon_sym_U_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [sym_true] = ACTIONS(3079),
    [sym_false] = ACTIONS(3079),
    [anon_sym_NULL] = ACTIONS(3079),
    [anon_sym_nullptr] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3079),
    [anon_sym_decltype] = ACTIONS(3079),
    [anon_sym_typename] = ACTIONS(3079),
    [anon_sym_template] = ACTIONS(3079),
    [anon_sym_delete] = ACTIONS(3079),
    [anon_sym_R_DQUOTE] = ACTIONS(3081),
    [anon_sym_LR_DQUOTE] = ACTIONS(3081),
    [anon_sym_uR_DQUOTE] = ACTIONS(3081),
    [anon_sym_UR_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3081),
    [anon_sym_co_await] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_requires] = ACTIONS(3079),
    [sym_this] = ACTIONS(3079),
  },
  [1552] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5240),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6713),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_parameter_list] = STATE(838),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(4191),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5685),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(5026),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [1553] = {
    [sym_identifier] = ACTIONS(4959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_TILDE] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4961),
    [anon_sym_SLASH] = ACTIONS(4959),
    [anon_sym_PERCENT] = ACTIONS(4961),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4959),
    [anon_sym_CARET] = ACTIONS(4961),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym___extension__] = ACTIONS(4959),
    [anon_sym_virtual] = ACTIONS(4959),
    [anon_sym_extern] = ACTIONS(4959),
    [anon_sym___attribute__] = ACTIONS(4959),
    [anon_sym___attribute] = ACTIONS(4959),
    [anon_sym_COLON] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(4961),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4961),
    [anon_sym___declspec] = ACTIONS(4959),
    [anon_sym___based] = ACTIONS(4959),
    [anon_sym___cdecl] = ACTIONS(4959),
    [anon_sym___clrcall] = ACTIONS(4959),
    [anon_sym___stdcall] = ACTIONS(4959),
    [anon_sym___fastcall] = ACTIONS(4959),
    [anon_sym___thiscall] = ACTIONS(4959),
    [anon_sym___vectorcall] = ACTIONS(4959),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_RBRACE] = ACTIONS(4961),
    [anon_sym_LBRACK] = ACTIONS(4959),
    [anon_sym_static] = ACTIONS(4959),
    [anon_sym_RBRACK] = ACTIONS(4961),
    [anon_sym_EQ] = ACTIONS(4959),
    [anon_sym_register] = ACTIONS(4959),
    [anon_sym_inline] = ACTIONS(4959),
    [anon_sym___inline] = ACTIONS(4959),
    [anon_sym___inline__] = ACTIONS(4959),
    [anon_sym___forceinline] = ACTIONS(4959),
    [anon_sym_thread_local] = ACTIONS(4959),
    [anon_sym___thread] = ACTIONS(4959),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_constexpr] = ACTIONS(4959),
    [anon_sym_volatile] = ACTIONS(4959),
    [anon_sym_restrict] = ACTIONS(4959),
    [anon_sym___restrict__] = ACTIONS(4959),
    [anon_sym__Atomic] = ACTIONS(4959),
    [anon_sym__Noreturn] = ACTIONS(4959),
    [anon_sym_noreturn] = ACTIONS(4959),
    [anon_sym__Nonnull] = ACTIONS(4959),
    [anon_sym_mutable] = ACTIONS(4959),
    [anon_sym_constinit] = ACTIONS(4959),
    [anon_sym_consteval] = ACTIONS(4959),
    [anon_sym_alignas] = ACTIONS(4959),
    [anon_sym__Alignas] = ACTIONS(4959),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4959),
    [anon_sym_and] = ACTIONS(4959),
    [anon_sym_bitor] = ACTIONS(4959),
    [anon_sym_xor] = ACTIONS(4959),
    [anon_sym_bitand] = ACTIONS(4959),
    [anon_sym_not_eq] = ACTIONS(4959),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4959),
    [anon_sym_decltype] = ACTIONS(4959),
    [anon_sym_final] = ACTIONS(4959),
    [anon_sym_override] = ACTIONS(4959),
    [anon_sym_template] = ACTIONS(4959),
    [anon_sym_operator] = ACTIONS(4959),
    [anon_sym_try] = ACTIONS(4959),
    [anon_sym_noexcept] = ACTIONS(4959),
    [anon_sym_throw] = ACTIONS(4959),
    [anon_sym_requires] = ACTIONS(4959),
  },
  [1554] = {
    [sym_identifier] = ACTIONS(4951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4953),
    [anon_sym_COMMA] = ACTIONS(4953),
    [anon_sym_RPAREN] = ACTIONS(4953),
    [anon_sym_LPAREN2] = ACTIONS(4953),
    [anon_sym_TILDE] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4953),
    [anon_sym_SLASH] = ACTIONS(4951),
    [anon_sym_PERCENT] = ACTIONS(4953),
    [anon_sym_PIPE_PIPE] = ACTIONS(4953),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_PIPE] = ACTIONS(4951),
    [anon_sym_CARET] = ACTIONS(4953),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_EQ_EQ] = ACTIONS(4953),
    [anon_sym_BANG_EQ] = ACTIONS(4953),
    [anon_sym_GT] = ACTIONS(4951),
    [anon_sym_GT_EQ] = ACTIONS(4953),
    [anon_sym_LT_EQ] = ACTIONS(4951),
    [anon_sym_LT] = ACTIONS(4951),
    [anon_sym_LT_LT] = ACTIONS(4953),
    [anon_sym_GT_GT] = ACTIONS(4953),
    [anon_sym_SEMI] = ACTIONS(4953),
    [anon_sym___extension__] = ACTIONS(4951),
    [anon_sym_virtual] = ACTIONS(4951),
    [anon_sym_extern] = ACTIONS(4951),
    [anon_sym___attribute__] = ACTIONS(4951),
    [anon_sym___attribute] = ACTIONS(4951),
    [anon_sym_COLON] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4953),
    [anon_sym___declspec] = ACTIONS(4951),
    [anon_sym___based] = ACTIONS(4951),
    [anon_sym___cdecl] = ACTIONS(4951),
    [anon_sym___clrcall] = ACTIONS(4951),
    [anon_sym___stdcall] = ACTIONS(4951),
    [anon_sym___fastcall] = ACTIONS(4951),
    [anon_sym___thiscall] = ACTIONS(4951),
    [anon_sym___vectorcall] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4953),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym_LBRACK] = ACTIONS(4951),
    [anon_sym_static] = ACTIONS(4951),
    [anon_sym_RBRACK] = ACTIONS(4953),
    [anon_sym_EQ] = ACTIONS(4951),
    [anon_sym_register] = ACTIONS(4951),
    [anon_sym_inline] = ACTIONS(4951),
    [anon_sym___inline] = ACTIONS(4951),
    [anon_sym___inline__] = ACTIONS(4951),
    [anon_sym___forceinline] = ACTIONS(4951),
    [anon_sym_thread_local] = ACTIONS(4951),
    [anon_sym___thread] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym_restrict] = ACTIONS(4951),
    [anon_sym___restrict__] = ACTIONS(4951),
    [anon_sym__Atomic] = ACTIONS(4951),
    [anon_sym__Noreturn] = ACTIONS(4951),
    [anon_sym_noreturn] = ACTIONS(4951),
    [anon_sym__Nonnull] = ACTIONS(4951),
    [anon_sym_mutable] = ACTIONS(4951),
    [anon_sym_constinit] = ACTIONS(4951),
    [anon_sym_consteval] = ACTIONS(4951),
    [anon_sym_alignas] = ACTIONS(4951),
    [anon_sym__Alignas] = ACTIONS(4951),
    [anon_sym_QMARK] = ACTIONS(4953),
    [anon_sym_LT_EQ_GT] = ACTIONS(4953),
    [anon_sym_or] = ACTIONS(4951),
    [anon_sym_and] = ACTIONS(4951),
    [anon_sym_bitor] = ACTIONS(4951),
    [anon_sym_xor] = ACTIONS(4951),
    [anon_sym_bitand] = ACTIONS(4951),
    [anon_sym_not_eq] = ACTIONS(4951),
    [anon_sym_DASH_DASH] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4953),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_DOT_STAR] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4951),
    [anon_sym_decltype] = ACTIONS(4951),
    [anon_sym_final] = ACTIONS(4951),
    [anon_sym_override] = ACTIONS(4951),
    [anon_sym_template] = ACTIONS(4951),
    [anon_sym_operator] = ACTIONS(4951),
    [anon_sym_try] = ACTIONS(4951),
    [anon_sym_noexcept] = ACTIONS(4951),
    [anon_sym_throw] = ACTIONS(4951),
    [anon_sym_requires] = ACTIONS(4951),
  },
  [1555] = {
    [sym_identifier] = ACTIONS(4955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4957),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4957),
    [anon_sym_LPAREN2] = ACTIONS(4957),
    [anon_sym_TILDE] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_SLASH] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4957),
    [anon_sym_PIPE_PIPE] = ACTIONS(4957),
    [anon_sym_AMP_AMP] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4955),
    [anon_sym_CARET] = ACTIONS(4957),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4957),
    [anon_sym_BANG_EQ] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_GT_EQ] = ACTIONS(4957),
    [anon_sym_LT_EQ] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4957),
    [anon_sym_GT_GT] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym___extension__] = ACTIONS(4955),
    [anon_sym_virtual] = ACTIONS(4955),
    [anon_sym_extern] = ACTIONS(4955),
    [anon_sym___attribute__] = ACTIONS(4955),
    [anon_sym___attribute] = ACTIONS(4955),
    [anon_sym_COLON] = ACTIONS(4955),
    [anon_sym_COLON_COLON] = ACTIONS(4957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4957),
    [anon_sym___declspec] = ACTIONS(4955),
    [anon_sym___based] = ACTIONS(4955),
    [anon_sym___cdecl] = ACTIONS(4955),
    [anon_sym___clrcall] = ACTIONS(4955),
    [anon_sym___stdcall] = ACTIONS(4955),
    [anon_sym___fastcall] = ACTIONS(4955),
    [anon_sym___thiscall] = ACTIONS(4955),
    [anon_sym___vectorcall] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(4957),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4955),
    [anon_sym_static] = ACTIONS(4955),
    [anon_sym_RBRACK] = ACTIONS(4957),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_register] = ACTIONS(4955),
    [anon_sym_inline] = ACTIONS(4955),
    [anon_sym___inline] = ACTIONS(4955),
    [anon_sym___inline__] = ACTIONS(4955),
    [anon_sym___forceinline] = ACTIONS(4955),
    [anon_sym_thread_local] = ACTIONS(4955),
    [anon_sym___thread] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_constexpr] = ACTIONS(4955),
    [anon_sym_volatile] = ACTIONS(4955),
    [anon_sym_restrict] = ACTIONS(4955),
    [anon_sym___restrict__] = ACTIONS(4955),
    [anon_sym__Atomic] = ACTIONS(4955),
    [anon_sym__Noreturn] = ACTIONS(4955),
    [anon_sym_noreturn] = ACTIONS(4955),
    [anon_sym__Nonnull] = ACTIONS(4955),
    [anon_sym_mutable] = ACTIONS(4955),
    [anon_sym_constinit] = ACTIONS(4955),
    [anon_sym_consteval] = ACTIONS(4955),
    [anon_sym_alignas] = ACTIONS(4955),
    [anon_sym__Alignas] = ACTIONS(4955),
    [anon_sym_QMARK] = ACTIONS(4957),
    [anon_sym_LT_EQ_GT] = ACTIONS(4957),
    [anon_sym_or] = ACTIONS(4955),
    [anon_sym_and] = ACTIONS(4955),
    [anon_sym_bitor] = ACTIONS(4955),
    [anon_sym_xor] = ACTIONS(4955),
    [anon_sym_bitand] = ACTIONS(4955),
    [anon_sym_not_eq] = ACTIONS(4955),
    [anon_sym_DASH_DASH] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4957),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_DOT_STAR] = ACTIONS(4957),
    [anon_sym_DASH_GT] = ACTIONS(4957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4955),
    [anon_sym_decltype] = ACTIONS(4955),
    [anon_sym_final] = ACTIONS(4955),
    [anon_sym_override] = ACTIONS(4955),
    [anon_sym_template] = ACTIONS(4955),
    [anon_sym_operator] = ACTIONS(4955),
    [anon_sym_try] = ACTIONS(4955),
    [anon_sym_noexcept] = ACTIONS(4955),
    [anon_sym_throw] = ACTIONS(4955),
    [anon_sym_requires] = ACTIONS(4955),
  },
  [1556] = {
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4990),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_RPAREN] = ACTIONS(4990),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_SLASH] = ACTIONS(4988),
    [anon_sym_PERCENT] = ACTIONS(4990),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym_EQ_EQ] = ACTIONS(4990),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4988),
    [anon_sym_GT_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4990),
    [anon_sym_GT_GT] = ACTIONS(4990),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym___attribute] = ACTIONS(4988),
    [anon_sym_COLON] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym___cdecl] = ACTIONS(4988),
    [anon_sym___clrcall] = ACTIONS(4988),
    [anon_sym___stdcall] = ACTIONS(4988),
    [anon_sym___fastcall] = ACTIONS(4988),
    [anon_sym___thiscall] = ACTIONS(4988),
    [anon_sym___vectorcall] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_RBRACE] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_RBRACK] = ACTIONS(4990),
    [anon_sym_EQ] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym__Nonnull] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym__Alignas] = ACTIONS(4988),
    [anon_sym_QMARK] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_and] = ACTIONS(4988),
    [anon_sym_bitor] = ACTIONS(4988),
    [anon_sym_xor] = ACTIONS(4988),
    [anon_sym_bitand] = ACTIONS(4988),
    [anon_sym_not_eq] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(4990),
    [anon_sym_PLUS_PLUS] = ACTIONS(4990),
    [anon_sym_DOT] = ACTIONS(4988),
    [anon_sym_DOT_STAR] = ACTIONS(4990),
    [anon_sym_DASH_GT] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_final] = ACTIONS(4988),
    [anon_sym_override] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
    [anon_sym_try] = ACTIONS(4988),
    [anon_sym_noexcept] = ACTIONS(4988),
    [anon_sym_throw] = ACTIONS(4988),
    [anon_sym_requires] = ACTIONS(4988),
  },
  [1557] = {
    [sym_template_argument_list] = STATE(1565),
    [sym_identifier] = ACTIONS(4963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_LPAREN2] = ACTIONS(4967),
    [anon_sym_TILDE] = ACTIONS(4970),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_SLASH] = ACTIONS(4972),
    [anon_sym_PERCENT] = ACTIONS(4972),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4972),
    [anon_sym_CARET] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4974),
    [anon_sym_EQ_EQ] = ACTIONS(4965),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_GT] = ACTIONS(4972),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(4977),
    [anon_sym_LT_LT] = ACTIONS(4972),
    [anon_sym_GT_GT] = ACTIONS(4972),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym___extension__] = ACTIONS(4963),
    [anon_sym_virtual] = ACTIONS(4963),
    [anon_sym_extern] = ACTIONS(4963),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4970),
    [anon_sym___declspec] = ACTIONS(4963),
    [anon_sym___based] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4974),
    [anon_sym_static] = ACTIONS(4963),
    [anon_sym_EQ] = ACTIONS(4972),
    [anon_sym_register] = ACTIONS(4963),
    [anon_sym_inline] = ACTIONS(4963),
    [anon_sym___inline] = ACTIONS(4963),
    [anon_sym___inline__] = ACTIONS(4963),
    [anon_sym___forceinline] = ACTIONS(4963),
    [anon_sym_thread_local] = ACTIONS(4963),
    [anon_sym___thread] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_constexpr] = ACTIONS(4963),
    [anon_sym_volatile] = ACTIONS(4963),
    [anon_sym_restrict] = ACTIONS(4963),
    [anon_sym___restrict__] = ACTIONS(4963),
    [anon_sym__Atomic] = ACTIONS(4963),
    [anon_sym__Noreturn] = ACTIONS(4963),
    [anon_sym_noreturn] = ACTIONS(4963),
    [anon_sym__Nonnull] = ACTIONS(4963),
    [anon_sym_mutable] = ACTIONS(4963),
    [anon_sym_constinit] = ACTIONS(4963),
    [anon_sym_consteval] = ACTIONS(4963),
    [anon_sym_alignas] = ACTIONS(4963),
    [anon_sym__Alignas] = ACTIONS(4963),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_and_eq] = ACTIONS(4972),
    [anon_sym_or_eq] = ACTIONS(4972),
    [anon_sym_xor_eq] = ACTIONS(4972),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4972),
    [anon_sym_and] = ACTIONS(4972),
    [anon_sym_bitor] = ACTIONS(4972),
    [anon_sym_xor] = ACTIONS(4972),
    [anon_sym_bitand] = ACTIONS(4972),
    [anon_sym_not_eq] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(4965),
    [anon_sym_PLUS_PLUS] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4972),
    [anon_sym_DOT_STAR] = ACTIONS(4965),
    [anon_sym_DASH_GT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_template] = ACTIONS(4963),
    [anon_sym_operator] = ACTIONS(4963),
  },
  [1558] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5250),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6699),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_parameter_list] = STATE(837),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(4191),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5685),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(5026),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [1559] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5259),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6691),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_parameter_list] = STATE(835),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(4191),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5685),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(5026),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [1560] = {
    [sym_identifier] = ACTIONS(4992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4994),
    [anon_sym_COMMA] = ACTIONS(4994),
    [anon_sym_RPAREN] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_TILDE] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4992),
    [anon_sym_PLUS] = ACTIONS(4992),
    [anon_sym_STAR] = ACTIONS(4994),
    [anon_sym_SLASH] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_PIPE_PIPE] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(4992),
    [anon_sym_CARET] = ACTIONS(4994),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4994),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_GT_EQ] = ACTIONS(4994),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_LT_LT] = ACTIONS(4994),
    [anon_sym_GT_GT] = ACTIONS(4994),
    [anon_sym_SEMI] = ACTIONS(4994),
    [anon_sym___extension__] = ACTIONS(4992),
    [anon_sym_virtual] = ACTIONS(4992),
    [anon_sym_extern] = ACTIONS(4992),
    [anon_sym___attribute__] = ACTIONS(4992),
    [anon_sym___attribute] = ACTIONS(4992),
    [anon_sym_COLON] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4994),
    [anon_sym___declspec] = ACTIONS(4992),
    [anon_sym___based] = ACTIONS(4992),
    [anon_sym___cdecl] = ACTIONS(4992),
    [anon_sym___clrcall] = ACTIONS(4992),
    [anon_sym___stdcall] = ACTIONS(4992),
    [anon_sym___fastcall] = ACTIONS(4992),
    [anon_sym___thiscall] = ACTIONS(4992),
    [anon_sym___vectorcall] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4994),
    [anon_sym_RBRACE] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(4992),
    [anon_sym_static] = ACTIONS(4992),
    [anon_sym_RBRACK] = ACTIONS(4994),
    [anon_sym_EQ] = ACTIONS(4992),
    [anon_sym_register] = ACTIONS(4992),
    [anon_sym_inline] = ACTIONS(4992),
    [anon_sym___inline] = ACTIONS(4992),
    [anon_sym___inline__] = ACTIONS(4992),
    [anon_sym___forceinline] = ACTIONS(4992),
    [anon_sym_thread_local] = ACTIONS(4992),
    [anon_sym___thread] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym___restrict__] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym__Noreturn] = ACTIONS(4992),
    [anon_sym_noreturn] = ACTIONS(4992),
    [anon_sym__Nonnull] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_constinit] = ACTIONS(4992),
    [anon_sym_consteval] = ACTIONS(4992),
    [anon_sym_alignas] = ACTIONS(4992),
    [anon_sym__Alignas] = ACTIONS(4992),
    [anon_sym_QMARK] = ACTIONS(4994),
    [anon_sym_LT_EQ_GT] = ACTIONS(4994),
    [anon_sym_or] = ACTIONS(4992),
    [anon_sym_and] = ACTIONS(4992),
    [anon_sym_bitor] = ACTIONS(4992),
    [anon_sym_xor] = ACTIONS(4992),
    [anon_sym_bitand] = ACTIONS(4992),
    [anon_sym_not_eq] = ACTIONS(4992),
    [anon_sym_DASH_DASH] = ACTIONS(4994),
    [anon_sym_PLUS_PLUS] = ACTIONS(4994),
    [anon_sym_DOT] = ACTIONS(4992),
    [anon_sym_DOT_STAR] = ACTIONS(4994),
    [anon_sym_DASH_GT] = ACTIONS(4994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_decltype] = ACTIONS(4992),
    [anon_sym_final] = ACTIONS(4992),
    [anon_sym_override] = ACTIONS(4992),
    [anon_sym_template] = ACTIONS(4992),
    [anon_sym_operator] = ACTIONS(4992),
    [anon_sym_try] = ACTIONS(4992),
    [anon_sym_noexcept] = ACTIONS(4992),
    [anon_sym_throw] = ACTIONS(4992),
    [anon_sym_requires] = ACTIONS(4992),
  },
  [1561] = {
    [sym_identifier] = ACTIONS(4980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_RPAREN] = ACTIONS(4982),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(4982),
    [anon_sym_DASH] = ACTIONS(4980),
    [anon_sym_PLUS] = ACTIONS(4980),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_SLASH] = ACTIONS(4980),
    [anon_sym_PERCENT] = ACTIONS(4982),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4980),
    [anon_sym_CARET] = ACTIONS(4982),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4982),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_LT_LT] = ACTIONS(4982),
    [anon_sym_GT_GT] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(4982),
    [anon_sym___extension__] = ACTIONS(4980),
    [anon_sym_virtual] = ACTIONS(4980),
    [anon_sym_extern] = ACTIONS(4980),
    [anon_sym___attribute__] = ACTIONS(4980),
    [anon_sym___attribute] = ACTIONS(4980),
    [anon_sym_COLON] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4982),
    [anon_sym___declspec] = ACTIONS(4980),
    [anon_sym___based] = ACTIONS(4980),
    [anon_sym___cdecl] = ACTIONS(4980),
    [anon_sym___clrcall] = ACTIONS(4980),
    [anon_sym___stdcall] = ACTIONS(4980),
    [anon_sym___fastcall] = ACTIONS(4980),
    [anon_sym___thiscall] = ACTIONS(4980),
    [anon_sym___vectorcall] = ACTIONS(4980),
    [anon_sym_LBRACE] = ACTIONS(4982),
    [anon_sym_RBRACE] = ACTIONS(4982),
    [anon_sym_LBRACK] = ACTIONS(4980),
    [anon_sym_static] = ACTIONS(4980),
    [anon_sym_RBRACK] = ACTIONS(4982),
    [anon_sym_EQ] = ACTIONS(4980),
    [anon_sym_register] = ACTIONS(4980),
    [anon_sym_inline] = ACTIONS(4980),
    [anon_sym___inline] = ACTIONS(4980),
    [anon_sym___inline__] = ACTIONS(4980),
    [anon_sym___forceinline] = ACTIONS(4980),
    [anon_sym_thread_local] = ACTIONS(4980),
    [anon_sym___thread] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4980),
    [anon_sym_volatile] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4980),
    [anon_sym___restrict__] = ACTIONS(4980),
    [anon_sym__Atomic] = ACTIONS(4980),
    [anon_sym__Noreturn] = ACTIONS(4980),
    [anon_sym_noreturn] = ACTIONS(4980),
    [anon_sym__Nonnull] = ACTIONS(4980),
    [anon_sym_mutable] = ACTIONS(4980),
    [anon_sym_constinit] = ACTIONS(4980),
    [anon_sym_consteval] = ACTIONS(4980),
    [anon_sym_alignas] = ACTIONS(4980),
    [anon_sym__Alignas] = ACTIONS(4980),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_LT_EQ_GT] = ACTIONS(4982),
    [anon_sym_or] = ACTIONS(4980),
    [anon_sym_and] = ACTIONS(4980),
    [anon_sym_bitor] = ACTIONS(4980),
    [anon_sym_xor] = ACTIONS(4980),
    [anon_sym_bitand] = ACTIONS(4980),
    [anon_sym_not_eq] = ACTIONS(4980),
    [anon_sym_DASH_DASH] = ACTIONS(4982),
    [anon_sym_PLUS_PLUS] = ACTIONS(4982),
    [anon_sym_DOT] = ACTIONS(4980),
    [anon_sym_DOT_STAR] = ACTIONS(4982),
    [anon_sym_DASH_GT] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4980),
    [anon_sym_decltype] = ACTIONS(4980),
    [anon_sym_final] = ACTIONS(4980),
    [anon_sym_override] = ACTIONS(4980),
    [anon_sym_template] = ACTIONS(4980),
    [anon_sym_operator] = ACTIONS(4980),
    [anon_sym_try] = ACTIONS(4980),
    [anon_sym_noexcept] = ACTIONS(4980),
    [anon_sym_throw] = ACTIONS(4980),
    [anon_sym_requires] = ACTIONS(4980),
  },
  [1562] = {
    [sym_identifier] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_RPAREN] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4986),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4986),
    [anon_sym_PIPE_PIPE] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4986),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4986),
    [anon_sym_BANG_EQ] = ACTIONS(4986),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4986),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4986),
    [anon_sym_GT_GT] = ACTIONS(4986),
    [anon_sym_SEMI] = ACTIONS(4986),
    [anon_sym___extension__] = ACTIONS(4984),
    [anon_sym_virtual] = ACTIONS(4984),
    [anon_sym_extern] = ACTIONS(4984),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_COLON] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4986),
    [anon_sym___declspec] = ACTIONS(4984),
    [anon_sym___based] = ACTIONS(4984),
    [anon_sym___cdecl] = ACTIONS(4984),
    [anon_sym___clrcall] = ACTIONS(4984),
    [anon_sym___stdcall] = ACTIONS(4984),
    [anon_sym___fastcall] = ACTIONS(4984),
    [anon_sym___thiscall] = ACTIONS(4984),
    [anon_sym___vectorcall] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4986),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_LBRACK] = ACTIONS(4984),
    [anon_sym_static] = ACTIONS(4984),
    [anon_sym_RBRACK] = ACTIONS(4986),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_register] = ACTIONS(4984),
    [anon_sym_inline] = ACTIONS(4984),
    [anon_sym___inline] = ACTIONS(4984),
    [anon_sym___inline__] = ACTIONS(4984),
    [anon_sym___forceinline] = ACTIONS(4984),
    [anon_sym_thread_local] = ACTIONS(4984),
    [anon_sym___thread] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym___restrict__] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym__Noreturn] = ACTIONS(4984),
    [anon_sym_noreturn] = ACTIONS(4984),
    [anon_sym__Nonnull] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_constinit] = ACTIONS(4984),
    [anon_sym_consteval] = ACTIONS(4984),
    [anon_sym_alignas] = ACTIONS(4984),
    [anon_sym__Alignas] = ACTIONS(4984),
    [anon_sym_QMARK] = ACTIONS(4986),
    [anon_sym_LT_EQ_GT] = ACTIONS(4986),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(4986),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4986),
    [anon_sym_DASH_GT] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_final] = ACTIONS(4984),
    [anon_sym_override] = ACTIONS(4984),
    [anon_sym_template] = ACTIONS(4984),
    [anon_sym_operator] = ACTIONS(4984),
    [anon_sym_try] = ACTIONS(4984),
    [anon_sym_noexcept] = ACTIONS(4984),
    [anon_sym_throw] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(4984),
  },
  [1563] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5264),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6711),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(5998),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_parameter_list] = STATE(836),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(4191),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5685),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_type_identifier] = STATE(3015),
    [sym_operator_name] = STATE(5998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(5026),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [1564] = {
    [sym_template_argument_list] = STATE(1574),
    [sym_identifier] = ACTIONS(4963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_LPAREN2] = ACTIONS(4967),
    [anon_sym_TILDE] = ACTIONS(4970),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_SLASH] = ACTIONS(4972),
    [anon_sym_PERCENT] = ACTIONS(4972),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4972),
    [anon_sym_CARET] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4974),
    [anon_sym_EQ_EQ] = ACTIONS(4965),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_GT] = ACTIONS(4972),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(5030),
    [anon_sym_LT_LT] = ACTIONS(4972),
    [anon_sym_GT_GT] = ACTIONS(4972),
    [anon_sym___extension__] = ACTIONS(4963),
    [anon_sym_virtual] = ACTIONS(4963),
    [anon_sym_extern] = ACTIONS(4963),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4970),
    [anon_sym___declspec] = ACTIONS(4963),
    [anon_sym___based] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4974),
    [anon_sym_static] = ACTIONS(4963),
    [anon_sym_EQ] = ACTIONS(4974),
    [anon_sym_register] = ACTIONS(4963),
    [anon_sym_inline] = ACTIONS(4963),
    [anon_sym___inline] = ACTIONS(4963),
    [anon_sym___inline__] = ACTIONS(4963),
    [anon_sym___forceinline] = ACTIONS(4963),
    [anon_sym_thread_local] = ACTIONS(4963),
    [anon_sym___thread] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_constexpr] = ACTIONS(4963),
    [anon_sym_volatile] = ACTIONS(4963),
    [anon_sym_restrict] = ACTIONS(4963),
    [anon_sym___restrict__] = ACTIONS(4963),
    [anon_sym__Atomic] = ACTIONS(4963),
    [anon_sym__Noreturn] = ACTIONS(4963),
    [anon_sym_noreturn] = ACTIONS(4963),
    [anon_sym__Nonnull] = ACTIONS(4963),
    [anon_sym_mutable] = ACTIONS(4963),
    [anon_sym_constinit] = ACTIONS(4963),
    [anon_sym_consteval] = ACTIONS(4963),
    [anon_sym_alignas] = ACTIONS(4963),
    [anon_sym__Alignas] = ACTIONS(4963),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_and_eq] = ACTIONS(4972),
    [anon_sym_or_eq] = ACTIONS(4972),
    [anon_sym_xor_eq] = ACTIONS(4972),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4972),
    [anon_sym_and] = ACTIONS(4972),
    [anon_sym_bitor] = ACTIONS(4972),
    [anon_sym_xor] = ACTIONS(4972),
    [anon_sym_bitand] = ACTIONS(4972),
    [anon_sym_not_eq] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(4965),
    [anon_sym_PLUS_PLUS] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4972),
    [anon_sym_DOT_STAR] = ACTIONS(4965),
    [anon_sym_DASH_GT] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_template] = ACTIONS(4963),
    [anon_sym_operator] = ACTIONS(4963),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4965),
  },
  [1565] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5005),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5005),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5003),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_EQ] = ACTIONS(5005),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym__Nonnull] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym__Alignas] = ACTIONS(4996),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_STAR_EQ] = ACTIONS(4998),
    [anon_sym_SLASH_EQ] = ACTIONS(4998),
    [anon_sym_PERCENT_EQ] = ACTIONS(4998),
    [anon_sym_PLUS_EQ] = ACTIONS(4998),
    [anon_sym_DASH_EQ] = ACTIONS(4998),
    [anon_sym_LT_LT_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT_EQ] = ACTIONS(4998),
    [anon_sym_AMP_EQ] = ACTIONS(4998),
    [anon_sym_CARET_EQ] = ACTIONS(4998),
    [anon_sym_PIPE_EQ] = ACTIONS(4998),
    [anon_sym_and_eq] = ACTIONS(5005),
    [anon_sym_or_eq] = ACTIONS(5005),
    [anon_sym_xor_eq] = ACTIONS(5005),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(5005),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(5005),
    [anon_sym_not_eq] = ACTIONS(5005),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
  },
  [1566] = {
    [sym_identifier] = ACTIONS(4980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_RPAREN] = ACTIONS(4982),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(4982),
    [anon_sym_DASH] = ACTIONS(4980),
    [anon_sym_PLUS] = ACTIONS(4980),
    [anon_sym_STAR] = ACTIONS(4980),
    [anon_sym_SLASH] = ACTIONS(4980),
    [anon_sym_PERCENT] = ACTIONS(4980),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4980),
    [anon_sym_CARET] = ACTIONS(4980),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4982),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_LT_LT] = ACTIONS(4980),
    [anon_sym_GT_GT] = ACTIONS(4980),
    [anon_sym___extension__] = ACTIONS(4980),
    [anon_sym_virtual] = ACTIONS(4980),
    [anon_sym_extern] = ACTIONS(4980),
    [anon_sym___attribute__] = ACTIONS(4980),
    [anon_sym___attribute] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4982),
    [anon_sym___declspec] = ACTIONS(4980),
    [anon_sym___based] = ACTIONS(4980),
    [anon_sym_LBRACE] = ACTIONS(4982),
    [anon_sym_LBRACK] = ACTIONS(4980),
    [anon_sym_static] = ACTIONS(4980),
    [anon_sym_EQ] = ACTIONS(4980),
    [anon_sym_register] = ACTIONS(4980),
    [anon_sym_inline] = ACTIONS(4980),
    [anon_sym___inline] = ACTIONS(4980),
    [anon_sym___inline__] = ACTIONS(4980),
    [anon_sym___forceinline] = ACTIONS(4980),
    [anon_sym_thread_local] = ACTIONS(4980),
    [anon_sym___thread] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4980),
    [anon_sym_volatile] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4980),
    [anon_sym___restrict__] = ACTIONS(4980),
    [anon_sym__Atomic] = ACTIONS(4980),
    [anon_sym__Noreturn] = ACTIONS(4980),
    [anon_sym_noreturn] = ACTIONS(4980),
    [anon_sym__Nonnull] = ACTIONS(4980),
    [anon_sym_mutable] = ACTIONS(4980),
    [anon_sym_constinit] = ACTIONS(4980),
    [anon_sym_consteval] = ACTIONS(4980),
    [anon_sym_alignas] = ACTIONS(4980),
    [anon_sym__Alignas] = ACTIONS(4980),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_STAR_EQ] = ACTIONS(4982),
    [anon_sym_SLASH_EQ] = ACTIONS(4982),
    [anon_sym_PERCENT_EQ] = ACTIONS(4982),
    [anon_sym_PLUS_EQ] = ACTIONS(4982),
    [anon_sym_DASH_EQ] = ACTIONS(4982),
    [anon_sym_LT_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT_GT_EQ] = ACTIONS(4982),
    [anon_sym_AMP_EQ] = ACTIONS(4982),
    [anon_sym_CARET_EQ] = ACTIONS(4982),
    [anon_sym_PIPE_EQ] = ACTIONS(4982),
    [anon_sym_and_eq] = ACTIONS(4980),
    [anon_sym_or_eq] = ACTIONS(4980),
    [anon_sym_xor_eq] = ACTIONS(4980),
    [anon_sym_LT_EQ_GT] = ACTIONS(4982),
    [anon_sym_or] = ACTIONS(4980),
    [anon_sym_and] = ACTIONS(4980),
    [anon_sym_bitor] = ACTIONS(4980),
    [anon_sym_xor] = ACTIONS(4980),
    [anon_sym_bitand] = ACTIONS(4980),
    [anon_sym_not_eq] = ACTIONS(4980),
    [anon_sym_DASH_DASH] = ACTIONS(4982),
    [anon_sym_PLUS_PLUS] = ACTIONS(4982),
    [anon_sym_DOT] = ACTIONS(4980),
    [anon_sym_DOT_STAR] = ACTIONS(4982),
    [anon_sym_DASH_GT] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4980),
    [anon_sym_decltype] = ACTIONS(4980),
    [anon_sym_template] = ACTIONS(4980),
    [anon_sym_operator] = ACTIONS(4980),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4982),
  },
  [1567] = {
    [sym_identifier] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_RPAREN] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4986),
    [anon_sym_BANG_EQ] = ACTIONS(4986),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4986),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4984),
    [anon_sym_virtual] = ACTIONS(4984),
    [anon_sym_extern] = ACTIONS(4984),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4986),
    [anon_sym___declspec] = ACTIONS(4984),
    [anon_sym___based] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4986),
    [anon_sym_LBRACK] = ACTIONS(4984),
    [anon_sym_static] = ACTIONS(4984),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_register] = ACTIONS(4984),
    [anon_sym_inline] = ACTIONS(4984),
    [anon_sym___inline] = ACTIONS(4984),
    [anon_sym___inline__] = ACTIONS(4984),
    [anon_sym___forceinline] = ACTIONS(4984),
    [anon_sym_thread_local] = ACTIONS(4984),
    [anon_sym___thread] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym___restrict__] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym__Noreturn] = ACTIONS(4984),
    [anon_sym_noreturn] = ACTIONS(4984),
    [anon_sym__Nonnull] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_constinit] = ACTIONS(4984),
    [anon_sym_consteval] = ACTIONS(4984),
    [anon_sym_alignas] = ACTIONS(4984),
    [anon_sym__Alignas] = ACTIONS(4984),
    [anon_sym_QMARK] = ACTIONS(4986),
    [anon_sym_STAR_EQ] = ACTIONS(4986),
    [anon_sym_SLASH_EQ] = ACTIONS(4986),
    [anon_sym_PERCENT_EQ] = ACTIONS(4986),
    [anon_sym_PLUS_EQ] = ACTIONS(4986),
    [anon_sym_DASH_EQ] = ACTIONS(4986),
    [anon_sym_LT_LT_EQ] = ACTIONS(4986),
    [anon_sym_GT_GT_EQ] = ACTIONS(4986),
    [anon_sym_AMP_EQ] = ACTIONS(4986),
    [anon_sym_CARET_EQ] = ACTIONS(4986),
    [anon_sym_PIPE_EQ] = ACTIONS(4986),
    [anon_sym_and_eq] = ACTIONS(4984),
    [anon_sym_or_eq] = ACTIONS(4984),
    [anon_sym_xor_eq] = ACTIONS(4984),
    [anon_sym_LT_EQ_GT] = ACTIONS(4986),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(4986),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4986),
    [anon_sym_DASH_GT] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_template] = ACTIONS(4984),
    [anon_sym_operator] = ACTIONS(4984),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4986),
  },
  [1568] = {
    [sym_identifier] = ACTIONS(4951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4953),
    [anon_sym_COMMA] = ACTIONS(4953),
    [anon_sym_RPAREN] = ACTIONS(4953),
    [anon_sym_LPAREN2] = ACTIONS(4953),
    [anon_sym_TILDE] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4951),
    [anon_sym_SLASH] = ACTIONS(4951),
    [anon_sym_PERCENT] = ACTIONS(4951),
    [anon_sym_PIPE_PIPE] = ACTIONS(4953),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_PIPE] = ACTIONS(4951),
    [anon_sym_CARET] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_EQ_EQ] = ACTIONS(4953),
    [anon_sym_BANG_EQ] = ACTIONS(4953),
    [anon_sym_GT] = ACTIONS(4951),
    [anon_sym_GT_EQ] = ACTIONS(4953),
    [anon_sym_LT_EQ] = ACTIONS(4951),
    [anon_sym_LT] = ACTIONS(4951),
    [anon_sym_LT_LT] = ACTIONS(4951),
    [anon_sym_GT_GT] = ACTIONS(4951),
    [anon_sym___extension__] = ACTIONS(4951),
    [anon_sym_virtual] = ACTIONS(4951),
    [anon_sym_extern] = ACTIONS(4951),
    [anon_sym___attribute__] = ACTIONS(4951),
    [anon_sym___attribute] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4953),
    [anon_sym___declspec] = ACTIONS(4951),
    [anon_sym___based] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4953),
    [anon_sym_LBRACK] = ACTIONS(4951),
    [anon_sym_static] = ACTIONS(4951),
    [anon_sym_EQ] = ACTIONS(4951),
    [anon_sym_register] = ACTIONS(4951),
    [anon_sym_inline] = ACTIONS(4951),
    [anon_sym___inline] = ACTIONS(4951),
    [anon_sym___inline__] = ACTIONS(4951),
    [anon_sym___forceinline] = ACTIONS(4951),
    [anon_sym_thread_local] = ACTIONS(4951),
    [anon_sym___thread] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym_restrict] = ACTIONS(4951),
    [anon_sym___restrict__] = ACTIONS(4951),
    [anon_sym__Atomic] = ACTIONS(4951),
    [anon_sym__Noreturn] = ACTIONS(4951),
    [anon_sym_noreturn] = ACTIONS(4951),
    [anon_sym__Nonnull] = ACTIONS(4951),
    [anon_sym_mutable] = ACTIONS(4951),
    [anon_sym_constinit] = ACTIONS(4951),
    [anon_sym_consteval] = ACTIONS(4951),
    [anon_sym_alignas] = ACTIONS(4951),
    [anon_sym__Alignas] = ACTIONS(4951),
    [anon_sym_QMARK] = ACTIONS(4953),
    [anon_sym_STAR_EQ] = ACTIONS(4953),
    [anon_sym_SLASH_EQ] = ACTIONS(4953),
    [anon_sym_PERCENT_EQ] = ACTIONS(4953),
    [anon_sym_PLUS_EQ] = ACTIONS(4953),
    [anon_sym_DASH_EQ] = ACTIONS(4953),
    [anon_sym_LT_LT_EQ] = ACTIONS(4953),
    [anon_sym_GT_GT_EQ] = ACTIONS(4953),
    [anon_sym_AMP_EQ] = ACTIONS(4953),
    [anon_sym_CARET_EQ] = ACTIONS(4953),
    [anon_sym_PIPE_EQ] = ACTIONS(4953),
    [anon_sym_and_eq] = ACTIONS(4951),
    [anon_sym_or_eq] = ACTIONS(4951),
    [anon_sym_xor_eq] = ACTIONS(4951),
    [anon_sym_LT_EQ_GT] = ACTIONS(4953),
    [anon_sym_or] = ACTIONS(4951),
    [anon_sym_and] = ACTIONS(4951),
    [anon_sym_bitor] = ACTIONS(4951),
    [anon_sym_xor] = ACTIONS(4951),
    [anon_sym_bitand] = ACTIONS(4951),
    [anon_sym_not_eq] = ACTIONS(4951),
    [anon_sym_DASH_DASH] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4953),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_DOT_STAR] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(4951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4951),
    [anon_sym_decltype] = ACTIONS(4951),
    [anon_sym_template] = ACTIONS(4951),
    [anon_sym_operator] = ACTIONS(4951),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4953),
  },
  [1569] = {
    [sym_identifier] = ACTIONS(4992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4994),
    [anon_sym_COMMA] = ACTIONS(4994),
    [anon_sym_RPAREN] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_TILDE] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4992),
    [anon_sym_PLUS] = ACTIONS(4992),
    [anon_sym_STAR] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4992),
    [anon_sym_PIPE_PIPE] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(4992),
    [anon_sym_CARET] = ACTIONS(4992),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4994),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_GT_EQ] = ACTIONS(4994),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym___extension__] = ACTIONS(4992),
    [anon_sym_virtual] = ACTIONS(4992),
    [anon_sym_extern] = ACTIONS(4992),
    [anon_sym___attribute__] = ACTIONS(4992),
    [anon_sym___attribute] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4994),
    [anon_sym___declspec] = ACTIONS(4992),
    [anon_sym___based] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(4992),
    [anon_sym_static] = ACTIONS(4992),
    [anon_sym_EQ] = ACTIONS(4992),
    [anon_sym_register] = ACTIONS(4992),
    [anon_sym_inline] = ACTIONS(4992),
    [anon_sym___inline] = ACTIONS(4992),
    [anon_sym___inline__] = ACTIONS(4992),
    [anon_sym___forceinline] = ACTIONS(4992),
    [anon_sym_thread_local] = ACTIONS(4992),
    [anon_sym___thread] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym___restrict__] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym__Noreturn] = ACTIONS(4992),
    [anon_sym_noreturn] = ACTIONS(4992),
    [anon_sym__Nonnull] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_constinit] = ACTIONS(4992),
    [anon_sym_consteval] = ACTIONS(4992),
    [anon_sym_alignas] = ACTIONS(4992),
    [anon_sym__Alignas] = ACTIONS(4992),
    [anon_sym_QMARK] = ACTIONS(4994),
    [anon_sym_STAR_EQ] = ACTIONS(4994),
    [anon_sym_SLASH_EQ] = ACTIONS(4994),
    [anon_sym_PERCENT_EQ] = ACTIONS(4994),
    [anon_sym_PLUS_EQ] = ACTIONS(4994),
    [anon_sym_DASH_EQ] = ACTIONS(4994),
    [anon_sym_LT_LT_EQ] = ACTIONS(4994),
    [anon_sym_GT_GT_EQ] = ACTIONS(4994),
    [anon_sym_AMP_EQ] = ACTIONS(4994),
    [anon_sym_CARET_EQ] = ACTIONS(4994),
    [anon_sym_PIPE_EQ] = ACTIONS(4994),
    [anon_sym_and_eq] = ACTIONS(4992),
    [anon_sym_or_eq] = ACTIONS(4992),
    [anon_sym_xor_eq] = ACTIONS(4992),
    [anon_sym_LT_EQ_GT] = ACTIONS(4994),
    [anon_sym_or] = ACTIONS(4992),
    [anon_sym_and] = ACTIONS(4992),
    [anon_sym_bitor] = ACTIONS(4992),
    [anon_sym_xor] = ACTIONS(4992),
    [anon_sym_bitand] = ACTIONS(4992),
    [anon_sym_not_eq] = ACTIONS(4992),
    [anon_sym_DASH_DASH] = ACTIONS(4994),
    [anon_sym_PLUS_PLUS] = ACTIONS(4994),
    [anon_sym_DOT] = ACTIONS(4992),
    [anon_sym_DOT_STAR] = ACTIONS(4994),
    [anon_sym_DASH_GT] = ACTIONS(4992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_decltype] = ACTIONS(4992),
    [anon_sym_template] = ACTIONS(4992),
    [anon_sym_operator] = ACTIONS(4992),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4994),
  },
  [1570] = {
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4990),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_RPAREN] = ACTIONS(4990),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(4988),
    [anon_sym_SLASH] = ACTIONS(4988),
    [anon_sym_PERCENT] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym_EQ_EQ] = ACTIONS(4990),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4988),
    [anon_sym_GT_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4988),
    [anon_sym_GT_GT] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym___attribute] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_EQ] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym__Nonnull] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym__Alignas] = ACTIONS(4988),
    [anon_sym_QMARK] = ACTIONS(4990),
    [anon_sym_STAR_EQ] = ACTIONS(4990),
    [anon_sym_SLASH_EQ] = ACTIONS(4990),
    [anon_sym_PERCENT_EQ] = ACTIONS(4990),
    [anon_sym_PLUS_EQ] = ACTIONS(4990),
    [anon_sym_DASH_EQ] = ACTIONS(4990),
    [anon_sym_LT_LT_EQ] = ACTIONS(4990),
    [anon_sym_GT_GT_EQ] = ACTIONS(4990),
    [anon_sym_AMP_EQ] = ACTIONS(4990),
    [anon_sym_CARET_EQ] = ACTIONS(4990),
    [anon_sym_PIPE_EQ] = ACTIONS(4990),
    [anon_sym_and_eq] = ACTIONS(4988),
    [anon_sym_or_eq] = ACTIONS(4988),
    [anon_sym_xor_eq] = ACTIONS(4988),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_and] = ACTIONS(4988),
    [anon_sym_bitor] = ACTIONS(4988),
    [anon_sym_xor] = ACTIONS(4988),
    [anon_sym_bitand] = ACTIONS(4988),
    [anon_sym_not_eq] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(4990),
    [anon_sym_PLUS_PLUS] = ACTIONS(4990),
    [anon_sym_DOT] = ACTIONS(4988),
    [anon_sym_DOT_STAR] = ACTIONS(4990),
    [anon_sym_DASH_GT] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4990),
  },
  [1571] = {
    [sym_identifier] = ACTIONS(4955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4957),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4957),
    [anon_sym_LPAREN2] = ACTIONS(4957),
    [anon_sym_TILDE] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_SLASH] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4957),
    [anon_sym_AMP_AMP] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4955),
    [anon_sym_CARET] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4957),
    [anon_sym_BANG_EQ] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_GT_EQ] = ACTIONS(4957),
    [anon_sym_LT_EQ] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4955),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym___extension__] = ACTIONS(4955),
    [anon_sym_virtual] = ACTIONS(4955),
    [anon_sym_extern] = ACTIONS(4955),
    [anon_sym___attribute__] = ACTIONS(4955),
    [anon_sym___attribute] = ACTIONS(4955),
    [anon_sym_COLON_COLON] = ACTIONS(4957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4957),
    [anon_sym___declspec] = ACTIONS(4955),
    [anon_sym___based] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4955),
    [anon_sym_static] = ACTIONS(4955),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_register] = ACTIONS(4955),
    [anon_sym_inline] = ACTIONS(4955),
    [anon_sym___inline] = ACTIONS(4955),
    [anon_sym___inline__] = ACTIONS(4955),
    [anon_sym___forceinline] = ACTIONS(4955),
    [anon_sym_thread_local] = ACTIONS(4955),
    [anon_sym___thread] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_constexpr] = ACTIONS(4955),
    [anon_sym_volatile] = ACTIONS(4955),
    [anon_sym_restrict] = ACTIONS(4955),
    [anon_sym___restrict__] = ACTIONS(4955),
    [anon_sym__Atomic] = ACTIONS(4955),
    [anon_sym__Noreturn] = ACTIONS(4955),
    [anon_sym_noreturn] = ACTIONS(4955),
    [anon_sym__Nonnull] = ACTIONS(4955),
    [anon_sym_mutable] = ACTIONS(4955),
    [anon_sym_constinit] = ACTIONS(4955),
    [anon_sym_consteval] = ACTIONS(4955),
    [anon_sym_alignas] = ACTIONS(4955),
    [anon_sym__Alignas] = ACTIONS(4955),
    [anon_sym_QMARK] = ACTIONS(4957),
    [anon_sym_STAR_EQ] = ACTIONS(4957),
    [anon_sym_SLASH_EQ] = ACTIONS(4957),
    [anon_sym_PERCENT_EQ] = ACTIONS(4957),
    [anon_sym_PLUS_EQ] = ACTIONS(4957),
    [anon_sym_DASH_EQ] = ACTIONS(4957),
    [anon_sym_LT_LT_EQ] = ACTIONS(4957),
    [anon_sym_GT_GT_EQ] = ACTIONS(4957),
    [anon_sym_AMP_EQ] = ACTIONS(4957),
    [anon_sym_CARET_EQ] = ACTIONS(4957),
    [anon_sym_PIPE_EQ] = ACTIONS(4957),
    [anon_sym_and_eq] = ACTIONS(4955),
    [anon_sym_or_eq] = ACTIONS(4955),
    [anon_sym_xor_eq] = ACTIONS(4955),
    [anon_sym_LT_EQ_GT] = ACTIONS(4957),
    [anon_sym_or] = ACTIONS(4955),
    [anon_sym_and] = ACTIONS(4955),
    [anon_sym_bitor] = ACTIONS(4955),
    [anon_sym_xor] = ACTIONS(4955),
    [anon_sym_bitand] = ACTIONS(4955),
    [anon_sym_not_eq] = ACTIONS(4955),
    [anon_sym_DASH_DASH] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4957),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_DOT_STAR] = ACTIONS(4957),
    [anon_sym_DASH_GT] = ACTIONS(4955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4955),
    [anon_sym_decltype] = ACTIONS(4955),
    [anon_sym_template] = ACTIONS(4955),
    [anon_sym_operator] = ACTIONS(4955),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4957),
  },
  [1572] = {
    [sym_identifier] = ACTIONS(4959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_TILDE] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_SLASH] = ACTIONS(4959),
    [anon_sym_PERCENT] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4959),
    [anon_sym_CARET] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4959),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym___extension__] = ACTIONS(4959),
    [anon_sym_virtual] = ACTIONS(4959),
    [anon_sym_extern] = ACTIONS(4959),
    [anon_sym___attribute__] = ACTIONS(4959),
    [anon_sym___attribute] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(4961),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4961),
    [anon_sym___declspec] = ACTIONS(4959),
    [anon_sym___based] = ACTIONS(4959),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_LBRACK] = ACTIONS(4959),
    [anon_sym_static] = ACTIONS(4959),
    [anon_sym_EQ] = ACTIONS(4959),
    [anon_sym_register] = ACTIONS(4959),
    [anon_sym_inline] = ACTIONS(4959),
    [anon_sym___inline] = ACTIONS(4959),
    [anon_sym___inline__] = ACTIONS(4959),
    [anon_sym___forceinline] = ACTIONS(4959),
    [anon_sym_thread_local] = ACTIONS(4959),
    [anon_sym___thread] = ACTIONS(4959),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_constexpr] = ACTIONS(4959),
    [anon_sym_volatile] = ACTIONS(4959),
    [anon_sym_restrict] = ACTIONS(4959),
    [anon_sym___restrict__] = ACTIONS(4959),
    [anon_sym__Atomic] = ACTIONS(4959),
    [anon_sym__Noreturn] = ACTIONS(4959),
    [anon_sym_noreturn] = ACTIONS(4959),
    [anon_sym__Nonnull] = ACTIONS(4959),
    [anon_sym_mutable] = ACTIONS(4959),
    [anon_sym_constinit] = ACTIONS(4959),
    [anon_sym_consteval] = ACTIONS(4959),
    [anon_sym_alignas] = ACTIONS(4959),
    [anon_sym__Alignas] = ACTIONS(4959),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4961),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_and_eq] = ACTIONS(4959),
    [anon_sym_or_eq] = ACTIONS(4959),
    [anon_sym_xor_eq] = ACTIONS(4959),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4959),
    [anon_sym_and] = ACTIONS(4959),
    [anon_sym_bitor] = ACTIONS(4959),
    [anon_sym_xor] = ACTIONS(4959),
    [anon_sym_bitand] = ACTIONS(4959),
    [anon_sym_not_eq] = ACTIONS(4959),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4959),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4959),
    [anon_sym_decltype] = ACTIONS(4959),
    [anon_sym_template] = ACTIONS(4959),
    [anon_sym_operator] = ACTIONS(4959),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4961),
  },
  [1573] = {
    [sym_string_literal] = STATE(2189),
    [sym_template_argument_list] = STATE(1701),
    [sym_raw_string_literal] = STATE(2189),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym___extension__] = ACTIONS(4152),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5036),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(5038),
    [anon_sym_unsigned] = ACTIONS(5038),
    [anon_sym_long] = ACTIONS(5038),
    [anon_sym_short] = ACTIONS(5038),
    [anon_sym_LBRACK] = ACTIONS(4176),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4152),
    [anon_sym_volatile] = ACTIONS(4152),
    [anon_sym_restrict] = ACTIONS(4152),
    [anon_sym___restrict__] = ACTIONS(4152),
    [anon_sym__Atomic] = ACTIONS(4152),
    [anon_sym__Noreturn] = ACTIONS(4152),
    [anon_sym_noreturn] = ACTIONS(4152),
    [anon_sym__Nonnull] = ACTIONS(4152),
    [anon_sym_mutable] = ACTIONS(4152),
    [anon_sym_constinit] = ACTIONS(4152),
    [anon_sym_consteval] = ACTIONS(4152),
    [anon_sym_alignas] = ACTIONS(4152),
    [anon_sym__Alignas] = ACTIONS(4152),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4146),
    [anon_sym_or_eq] = ACTIONS(4146),
    [anon_sym_xor_eq] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4154),
    [anon_sym_L_DQUOTE] = ACTIONS(5040),
    [anon_sym_u_DQUOTE] = ACTIONS(5040),
    [anon_sym_U_DQUOTE] = ACTIONS(5040),
    [anon_sym_u8_DQUOTE] = ACTIONS(5040),
    [anon_sym_DQUOTE] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4152),
    [anon_sym_decltype] = ACTIONS(4152),
    [anon_sym_R_DQUOTE] = ACTIONS(5042),
    [anon_sym_LR_DQUOTE] = ACTIONS(5042),
    [anon_sym_uR_DQUOTE] = ACTIONS(5042),
    [anon_sym_UR_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5042),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4146),
  },
  [1574] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5000),
    [anon_sym_COMMA] = ACTIONS(5000),
    [anon_sym_RPAREN] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5005),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5005),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5003),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_EQ] = ACTIONS(5007),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym__Nonnull] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym__Alignas] = ACTIONS(4996),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_STAR_EQ] = ACTIONS(4998),
    [anon_sym_SLASH_EQ] = ACTIONS(4998),
    [anon_sym_PERCENT_EQ] = ACTIONS(4998),
    [anon_sym_PLUS_EQ] = ACTIONS(4998),
    [anon_sym_DASH_EQ] = ACTIONS(4998),
    [anon_sym_LT_LT_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT_EQ] = ACTIONS(4998),
    [anon_sym_AMP_EQ] = ACTIONS(4998),
    [anon_sym_CARET_EQ] = ACTIONS(4998),
    [anon_sym_PIPE_EQ] = ACTIONS(4998),
    [anon_sym_and_eq] = ACTIONS(5005),
    [anon_sym_or_eq] = ACTIONS(5005),
    [anon_sym_xor_eq] = ACTIONS(5005),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(5005),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(5005),
    [anon_sym_not_eq] = ACTIONS(5005),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(5005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4998),
  },
  [1575] = {
    [sym_template_argument_list] = STATE(1577),
    [sym_identifier] = ACTIONS(4963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_LPAREN2] = ACTIONS(4967),
    [anon_sym_TILDE] = ACTIONS(4970),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_SLASH] = ACTIONS(4972),
    [anon_sym_PERCENT] = ACTIONS(4972),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4972),
    [anon_sym_CARET] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4974),
    [anon_sym_EQ_EQ] = ACTIONS(4965),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_GT] = ACTIONS(4972),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(4977),
    [anon_sym_LT_LT] = ACTIONS(4972),
    [anon_sym_GT_GT] = ACTIONS(4972),
    [anon_sym___extension__] = ACTIONS(4963),
    [anon_sym_virtual] = ACTIONS(4963),
    [anon_sym_extern] = ACTIONS(4963),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4970),
    [anon_sym___declspec] = ACTIONS(4963),
    [anon_sym___based] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4974),
    [anon_sym_static] = ACTIONS(4963),
    [anon_sym_EQ] = ACTIONS(4974),
    [anon_sym_register] = ACTIONS(4963),
    [anon_sym_inline] = ACTIONS(4963),
    [anon_sym___inline] = ACTIONS(4963),
    [anon_sym___inline__] = ACTIONS(4963),
    [anon_sym___forceinline] = ACTIONS(4963),
    [anon_sym_thread_local] = ACTIONS(4963),
    [anon_sym___thread] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_constexpr] = ACTIONS(4963),
    [anon_sym_volatile] = ACTIONS(4963),
    [anon_sym_restrict] = ACTIONS(4963),
    [anon_sym___restrict__] = ACTIONS(4963),
    [anon_sym__Atomic] = ACTIONS(4963),
    [anon_sym__Noreturn] = ACTIONS(4963),
    [anon_sym_noreturn] = ACTIONS(4963),
    [anon_sym__Nonnull] = ACTIONS(4963),
    [anon_sym_mutable] = ACTIONS(4963),
    [anon_sym_constinit] = ACTIONS(4963),
    [anon_sym_consteval] = ACTIONS(4963),
    [anon_sym_alignas] = ACTIONS(4963),
    [anon_sym__Alignas] = ACTIONS(4963),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_and_eq] = ACTIONS(4972),
    [anon_sym_or_eq] = ACTIONS(4972),
    [anon_sym_xor_eq] = ACTIONS(4972),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4972),
    [anon_sym_and] = ACTIONS(4972),
    [anon_sym_bitor] = ACTIONS(4972),
    [anon_sym_xor] = ACTIONS(4972),
    [anon_sym_bitand] = ACTIONS(4972),
    [anon_sym_not_eq] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(4965),
    [anon_sym_PLUS_PLUS] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4972),
    [anon_sym_DOT_STAR] = ACTIONS(4965),
    [anon_sym_DASH_GT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_template] = ACTIONS(4963),
    [anon_sym_operator] = ACTIONS(4963),
  },
  [1576] = {
    [sym_string_literal] = STATE(2189),
    [sym_template_argument_list] = STATE(1856),
    [sym_raw_string_literal] = STATE(2189),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5044),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym___extension__] = ACTIONS(4152),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(5038),
    [anon_sym_unsigned] = ACTIONS(5038),
    [anon_sym_long] = ACTIONS(5038),
    [anon_sym_short] = ACTIONS(5038),
    [anon_sym_LBRACK] = ACTIONS(4159),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4152),
    [anon_sym_volatile] = ACTIONS(4152),
    [anon_sym_restrict] = ACTIONS(4152),
    [anon_sym___restrict__] = ACTIONS(4152),
    [anon_sym__Atomic] = ACTIONS(4152),
    [anon_sym__Noreturn] = ACTIONS(4152),
    [anon_sym_noreturn] = ACTIONS(4152),
    [anon_sym__Nonnull] = ACTIONS(4152),
    [anon_sym_mutable] = ACTIONS(4152),
    [anon_sym_constinit] = ACTIONS(4152),
    [anon_sym_consteval] = ACTIONS(4152),
    [anon_sym_alignas] = ACTIONS(4152),
    [anon_sym__Alignas] = ACTIONS(4152),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4146),
    [anon_sym_or_eq] = ACTIONS(4146),
    [anon_sym_xor_eq] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4154),
    [anon_sym_L_DQUOTE] = ACTIONS(5040),
    [anon_sym_u_DQUOTE] = ACTIONS(5040),
    [anon_sym_U_DQUOTE] = ACTIONS(5040),
    [anon_sym_u8_DQUOTE] = ACTIONS(5040),
    [anon_sym_DQUOTE] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4152),
    [anon_sym_decltype] = ACTIONS(4152),
    [anon_sym_R_DQUOTE] = ACTIONS(5042),
    [anon_sym_LR_DQUOTE] = ACTIONS(5042),
    [anon_sym_uR_DQUOTE] = ACTIONS(5042),
    [anon_sym_UR_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5042),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4146),
  },
  [1577] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5000),
    [anon_sym_COMMA] = ACTIONS(5000),
    [anon_sym_RPAREN] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5005),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5005),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5003),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_EQ] = ACTIONS(5007),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym__Nonnull] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym__Alignas] = ACTIONS(4996),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_STAR_EQ] = ACTIONS(4998),
    [anon_sym_SLASH_EQ] = ACTIONS(4998),
    [anon_sym_PERCENT_EQ] = ACTIONS(4998),
    [anon_sym_PLUS_EQ] = ACTIONS(4998),
    [anon_sym_DASH_EQ] = ACTIONS(4998),
    [anon_sym_LT_LT_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT_EQ] = ACTIONS(4998),
    [anon_sym_AMP_EQ] = ACTIONS(4998),
    [anon_sym_CARET_EQ] = ACTIONS(4998),
    [anon_sym_PIPE_EQ] = ACTIONS(4998),
    [anon_sym_and_eq] = ACTIONS(5005),
    [anon_sym_or_eq] = ACTIONS(5005),
    [anon_sym_xor_eq] = ACTIONS(5005),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(5005),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(5005),
    [anon_sym_not_eq] = ACTIONS(5005),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
  },
  [1578] = {
    [sym_type_qualifier] = STATE(1578),
    [sym_alignas_qualifier] = STATE(1590),
    [aux_sym__type_definition_type_repeat1] = STATE(1578),
    [sym_identifier] = ACTIONS(5047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5049),
    [anon_sym_COMMA] = ACTIONS(5049),
    [anon_sym_RPAREN] = ACTIONS(5049),
    [aux_sym_preproc_if_token2] = ACTIONS(5049),
    [aux_sym_preproc_else_token1] = ACTIONS(5049),
    [aux_sym_preproc_elif_token1] = ACTIONS(5047),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5049),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5049),
    [anon_sym_LPAREN2] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5047),
    [anon_sym_STAR] = ACTIONS(5047),
    [anon_sym_SLASH] = ACTIONS(5047),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_PIPE] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5047),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5049),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(5047),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym_SEMI] = ACTIONS(5049),
    [anon_sym___extension__] = ACTIONS(5051),
    [anon_sym___attribute__] = ACTIONS(5047),
    [anon_sym___attribute] = ACTIONS(5047),
    [anon_sym_COLON] = ACTIONS(5049),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_RBRACE] = ACTIONS(5049),
    [anon_sym_signed] = ACTIONS(5047),
    [anon_sym_unsigned] = ACTIONS(5047),
    [anon_sym_long] = ACTIONS(5047),
    [anon_sym_short] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [anon_sym_RBRACK] = ACTIONS(5049),
    [anon_sym_EQ] = ACTIONS(5047),
    [anon_sym_const] = ACTIONS(5051),
    [anon_sym_constexpr] = ACTIONS(5051),
    [anon_sym_volatile] = ACTIONS(5051),
    [anon_sym_restrict] = ACTIONS(5051),
    [anon_sym___restrict__] = ACTIONS(5051),
    [anon_sym__Atomic] = ACTIONS(5051),
    [anon_sym__Noreturn] = ACTIONS(5051),
    [anon_sym_noreturn] = ACTIONS(5051),
    [anon_sym__Nonnull] = ACTIONS(5051),
    [anon_sym_mutable] = ACTIONS(5051),
    [anon_sym_constinit] = ACTIONS(5051),
    [anon_sym_consteval] = ACTIONS(5051),
    [anon_sym_alignas] = ACTIONS(5054),
    [anon_sym__Alignas] = ACTIONS(5054),
    [sym_primitive_type] = ACTIONS(5047),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_STAR_EQ] = ACTIONS(5049),
    [anon_sym_SLASH_EQ] = ACTIONS(5049),
    [anon_sym_PERCENT_EQ] = ACTIONS(5049),
    [anon_sym_PLUS_EQ] = ACTIONS(5049),
    [anon_sym_DASH_EQ] = ACTIONS(5049),
    [anon_sym_LT_LT_EQ] = ACTIONS(5049),
    [anon_sym_GT_GT_EQ] = ACTIONS(5049),
    [anon_sym_AMP_EQ] = ACTIONS(5049),
    [anon_sym_CARET_EQ] = ACTIONS(5049),
    [anon_sym_PIPE_EQ] = ACTIONS(5049),
    [anon_sym_and_eq] = ACTIONS(5047),
    [anon_sym_or_eq] = ACTIONS(5047),
    [anon_sym_xor_eq] = ACTIONS(5047),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_or] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_bitor] = ACTIONS(5047),
    [anon_sym_xor] = ACTIONS(5047),
    [anon_sym_bitand] = ACTIONS(5047),
    [anon_sym_not_eq] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5049),
    [anon_sym_DOT] = ACTIONS(5047),
    [anon_sym_DOT_STAR] = ACTIONS(5049),
    [anon_sym_DASH_GT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5047),
    [anon_sym_decltype] = ACTIONS(5047),
  },
  [1579] = {
    [sym_string_literal] = STATE(3517),
    [sym_template_argument_list] = STATE(2952),
    [sym_raw_string_literal] = STATE(3517),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4159),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4154),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5057),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym___extension__] = ACTIONS(4152),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(5060),
    [anon_sym_unsigned] = ACTIONS(5060),
    [anon_sym_long] = ACTIONS(5060),
    [anon_sym_short] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(4159),
    [anon_sym_EQ] = ACTIONS(5062),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4152),
    [anon_sym_volatile] = ACTIONS(4152),
    [anon_sym_restrict] = ACTIONS(4152),
    [anon_sym___restrict__] = ACTIONS(4152),
    [anon_sym__Atomic] = ACTIONS(4152),
    [anon_sym__Noreturn] = ACTIONS(4152),
    [anon_sym_noreturn] = ACTIONS(4152),
    [anon_sym__Nonnull] = ACTIONS(4152),
    [anon_sym_mutable] = ACTIONS(4152),
    [anon_sym_constinit] = ACTIONS(4152),
    [anon_sym_consteval] = ACTIONS(4152),
    [anon_sym_alignas] = ACTIONS(4152),
    [anon_sym__Alignas] = ACTIONS(4152),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(5064),
    [anon_sym_SLASH_EQ] = ACTIONS(5064),
    [anon_sym_PERCENT_EQ] = ACTIONS(5064),
    [anon_sym_PLUS_EQ] = ACTIONS(5064),
    [anon_sym_DASH_EQ] = ACTIONS(5064),
    [anon_sym_LT_LT_EQ] = ACTIONS(5064),
    [anon_sym_GT_GT_EQ] = ACTIONS(5062),
    [anon_sym_AMP_EQ] = ACTIONS(5064),
    [anon_sym_CARET_EQ] = ACTIONS(5064),
    [anon_sym_PIPE_EQ] = ACTIONS(5064),
    [anon_sym_and_eq] = ACTIONS(5064),
    [anon_sym_or_eq] = ACTIONS(5064),
    [anon_sym_xor_eq] = ACTIONS(5064),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(5066),
    [anon_sym_u_DQUOTE] = ACTIONS(5066),
    [anon_sym_U_DQUOTE] = ACTIONS(5066),
    [anon_sym_u8_DQUOTE] = ACTIONS(5066),
    [anon_sym_DQUOTE] = ACTIONS(5066),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4152),
    [anon_sym_decltype] = ACTIONS(4152),
    [anon_sym_GT2] = ACTIONS(4159),
    [anon_sym_R_DQUOTE] = ACTIONS(5068),
    [anon_sym_LR_DQUOTE] = ACTIONS(5068),
    [anon_sym_uR_DQUOTE] = ACTIONS(5068),
    [anon_sym_UR_DQUOTE] = ACTIONS(5068),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5068),
  },
  [1580] = {
    [sym_identifier] = ACTIONS(4992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4994),
    [anon_sym_COMMA] = ACTIONS(4994),
    [anon_sym_RPAREN] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_TILDE] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4992),
    [anon_sym_PLUS] = ACTIONS(4992),
    [anon_sym_STAR] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4992),
    [anon_sym_PIPE_PIPE] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(4992),
    [anon_sym_CARET] = ACTIONS(4992),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4994),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_GT_EQ] = ACTIONS(4994),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym___extension__] = ACTIONS(4992),
    [anon_sym_virtual] = ACTIONS(4992),
    [anon_sym_extern] = ACTIONS(4992),
    [anon_sym___attribute__] = ACTIONS(4992),
    [anon_sym___attribute] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4994),
    [anon_sym___declspec] = ACTIONS(4992),
    [anon_sym___based] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(4992),
    [anon_sym_static] = ACTIONS(4992),
    [anon_sym_EQ] = ACTIONS(4992),
    [anon_sym_register] = ACTIONS(4992),
    [anon_sym_inline] = ACTIONS(4992),
    [anon_sym___inline] = ACTIONS(4992),
    [anon_sym___inline__] = ACTIONS(4992),
    [anon_sym___forceinline] = ACTIONS(4992),
    [anon_sym_thread_local] = ACTIONS(4992),
    [anon_sym___thread] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym___restrict__] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym__Noreturn] = ACTIONS(4992),
    [anon_sym_noreturn] = ACTIONS(4992),
    [anon_sym__Nonnull] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_constinit] = ACTIONS(4992),
    [anon_sym_consteval] = ACTIONS(4992),
    [anon_sym_alignas] = ACTIONS(4992),
    [anon_sym__Alignas] = ACTIONS(4992),
    [anon_sym_QMARK] = ACTIONS(4994),
    [anon_sym_STAR_EQ] = ACTIONS(4994),
    [anon_sym_SLASH_EQ] = ACTIONS(4994),
    [anon_sym_PERCENT_EQ] = ACTIONS(4994),
    [anon_sym_PLUS_EQ] = ACTIONS(4994),
    [anon_sym_DASH_EQ] = ACTIONS(4994),
    [anon_sym_LT_LT_EQ] = ACTIONS(4994),
    [anon_sym_GT_GT_EQ] = ACTIONS(4994),
    [anon_sym_AMP_EQ] = ACTIONS(4994),
    [anon_sym_CARET_EQ] = ACTIONS(4994),
    [anon_sym_PIPE_EQ] = ACTIONS(4994),
    [anon_sym_LT_EQ_GT] = ACTIONS(4994),
    [anon_sym_or] = ACTIONS(4992),
    [anon_sym_and] = ACTIONS(4992),
    [anon_sym_bitor] = ACTIONS(4992),
    [anon_sym_xor] = ACTIONS(4992),
    [anon_sym_bitand] = ACTIONS(4992),
    [anon_sym_not_eq] = ACTIONS(4992),
    [anon_sym_DASH_DASH] = ACTIONS(4994),
    [anon_sym_PLUS_PLUS] = ACTIONS(4994),
    [anon_sym_DOT] = ACTIONS(4992),
    [anon_sym_DOT_STAR] = ACTIONS(4994),
    [anon_sym_DASH_GT] = ACTIONS(4992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_decltype] = ACTIONS(4992),
    [anon_sym_template] = ACTIONS(4992),
    [anon_sym_operator] = ACTIONS(4992),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4994),
  },
  [1581] = {
    [sym_identifier] = ACTIONS(4951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4953),
    [anon_sym_COMMA] = ACTIONS(4953),
    [anon_sym_RPAREN] = ACTIONS(4953),
    [anon_sym_LPAREN2] = ACTIONS(4953),
    [anon_sym_TILDE] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4951),
    [anon_sym_SLASH] = ACTIONS(4951),
    [anon_sym_PERCENT] = ACTIONS(4951),
    [anon_sym_PIPE_PIPE] = ACTIONS(4953),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_PIPE] = ACTIONS(4951),
    [anon_sym_CARET] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_EQ_EQ] = ACTIONS(4953),
    [anon_sym_BANG_EQ] = ACTIONS(4953),
    [anon_sym_GT] = ACTIONS(4951),
    [anon_sym_GT_EQ] = ACTIONS(4953),
    [anon_sym_LT_EQ] = ACTIONS(4951),
    [anon_sym_LT] = ACTIONS(4951),
    [anon_sym_LT_LT] = ACTIONS(4951),
    [anon_sym_GT_GT] = ACTIONS(4951),
    [anon_sym___extension__] = ACTIONS(4951),
    [anon_sym_virtual] = ACTIONS(4951),
    [anon_sym_extern] = ACTIONS(4951),
    [anon_sym___attribute__] = ACTIONS(4951),
    [anon_sym___attribute] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4953),
    [anon_sym___declspec] = ACTIONS(4951),
    [anon_sym___based] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4953),
    [anon_sym_LBRACK] = ACTIONS(4951),
    [anon_sym_static] = ACTIONS(4951),
    [anon_sym_EQ] = ACTIONS(4951),
    [anon_sym_register] = ACTIONS(4951),
    [anon_sym_inline] = ACTIONS(4951),
    [anon_sym___inline] = ACTIONS(4951),
    [anon_sym___inline__] = ACTIONS(4951),
    [anon_sym___forceinline] = ACTIONS(4951),
    [anon_sym_thread_local] = ACTIONS(4951),
    [anon_sym___thread] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym_restrict] = ACTIONS(4951),
    [anon_sym___restrict__] = ACTIONS(4951),
    [anon_sym__Atomic] = ACTIONS(4951),
    [anon_sym__Noreturn] = ACTIONS(4951),
    [anon_sym_noreturn] = ACTIONS(4951),
    [anon_sym__Nonnull] = ACTIONS(4951),
    [anon_sym_mutable] = ACTIONS(4951),
    [anon_sym_constinit] = ACTIONS(4951),
    [anon_sym_consteval] = ACTIONS(4951),
    [anon_sym_alignas] = ACTIONS(4951),
    [anon_sym__Alignas] = ACTIONS(4951),
    [anon_sym_QMARK] = ACTIONS(4953),
    [anon_sym_STAR_EQ] = ACTIONS(4953),
    [anon_sym_SLASH_EQ] = ACTIONS(4953),
    [anon_sym_PERCENT_EQ] = ACTIONS(4953),
    [anon_sym_PLUS_EQ] = ACTIONS(4953),
    [anon_sym_DASH_EQ] = ACTIONS(4953),
    [anon_sym_LT_LT_EQ] = ACTIONS(4953),
    [anon_sym_GT_GT_EQ] = ACTIONS(4953),
    [anon_sym_AMP_EQ] = ACTIONS(4953),
    [anon_sym_CARET_EQ] = ACTIONS(4953),
    [anon_sym_PIPE_EQ] = ACTIONS(4953),
    [anon_sym_LT_EQ_GT] = ACTIONS(4953),
    [anon_sym_or] = ACTIONS(4951),
    [anon_sym_and] = ACTIONS(4951),
    [anon_sym_bitor] = ACTIONS(4951),
    [anon_sym_xor] = ACTIONS(4951),
    [anon_sym_bitand] = ACTIONS(4951),
    [anon_sym_not_eq] = ACTIONS(4951),
    [anon_sym_DASH_DASH] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4953),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_DOT_STAR] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(4951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4951),
    [anon_sym_decltype] = ACTIONS(4951),
    [anon_sym_template] = ACTIONS(4951),
    [anon_sym_operator] = ACTIONS(4951),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4953),
  },
  [1582] = {
    [sym_identifier] = ACTIONS(4980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_RPAREN] = ACTIONS(4982),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(4982),
    [anon_sym_DASH] = ACTIONS(4980),
    [anon_sym_PLUS] = ACTIONS(4980),
    [anon_sym_STAR] = ACTIONS(4980),
    [anon_sym_SLASH] = ACTIONS(4980),
    [anon_sym_PERCENT] = ACTIONS(4980),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4980),
    [anon_sym_CARET] = ACTIONS(4980),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4982),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_LT_LT] = ACTIONS(4980),
    [anon_sym_GT_GT] = ACTIONS(4980),
    [anon_sym___extension__] = ACTIONS(4980),
    [anon_sym_virtual] = ACTIONS(4980),
    [anon_sym_extern] = ACTIONS(4980),
    [anon_sym___attribute__] = ACTIONS(4980),
    [anon_sym___attribute] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4982),
    [anon_sym___declspec] = ACTIONS(4980),
    [anon_sym___based] = ACTIONS(4980),
    [anon_sym_LBRACE] = ACTIONS(4982),
    [anon_sym_LBRACK] = ACTIONS(4980),
    [anon_sym_static] = ACTIONS(4980),
    [anon_sym_EQ] = ACTIONS(4980),
    [anon_sym_register] = ACTIONS(4980),
    [anon_sym_inline] = ACTIONS(4980),
    [anon_sym___inline] = ACTIONS(4980),
    [anon_sym___inline__] = ACTIONS(4980),
    [anon_sym___forceinline] = ACTIONS(4980),
    [anon_sym_thread_local] = ACTIONS(4980),
    [anon_sym___thread] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4980),
    [anon_sym_volatile] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4980),
    [anon_sym___restrict__] = ACTIONS(4980),
    [anon_sym__Atomic] = ACTIONS(4980),
    [anon_sym__Noreturn] = ACTIONS(4980),
    [anon_sym_noreturn] = ACTIONS(4980),
    [anon_sym__Nonnull] = ACTIONS(4980),
    [anon_sym_mutable] = ACTIONS(4980),
    [anon_sym_constinit] = ACTIONS(4980),
    [anon_sym_consteval] = ACTIONS(4980),
    [anon_sym_alignas] = ACTIONS(4980),
    [anon_sym__Alignas] = ACTIONS(4980),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_STAR_EQ] = ACTIONS(4982),
    [anon_sym_SLASH_EQ] = ACTIONS(4982),
    [anon_sym_PERCENT_EQ] = ACTIONS(4982),
    [anon_sym_PLUS_EQ] = ACTIONS(4982),
    [anon_sym_DASH_EQ] = ACTIONS(4982),
    [anon_sym_LT_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT_GT_EQ] = ACTIONS(4982),
    [anon_sym_AMP_EQ] = ACTIONS(4982),
    [anon_sym_CARET_EQ] = ACTIONS(4982),
    [anon_sym_PIPE_EQ] = ACTIONS(4982),
    [anon_sym_LT_EQ_GT] = ACTIONS(4982),
    [anon_sym_or] = ACTIONS(4980),
    [anon_sym_and] = ACTIONS(4980),
    [anon_sym_bitor] = ACTIONS(4980),
    [anon_sym_xor] = ACTIONS(4980),
    [anon_sym_bitand] = ACTIONS(4980),
    [anon_sym_not_eq] = ACTIONS(4980),
    [anon_sym_DASH_DASH] = ACTIONS(4982),
    [anon_sym_PLUS_PLUS] = ACTIONS(4982),
    [anon_sym_DOT] = ACTIONS(4980),
    [anon_sym_DOT_STAR] = ACTIONS(4982),
    [anon_sym_DASH_GT] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4980),
    [anon_sym_decltype] = ACTIONS(4980),
    [anon_sym_template] = ACTIONS(4980),
    [anon_sym_operator] = ACTIONS(4980),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4982),
  },
  [1583] = {
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4990),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_RPAREN] = ACTIONS(4990),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(4988),
    [anon_sym_SLASH] = ACTIONS(4988),
    [anon_sym_PERCENT] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym_EQ_EQ] = ACTIONS(4990),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4988),
    [anon_sym_GT_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4988),
    [anon_sym_GT_GT] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym___attribute] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_EQ] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym__Nonnull] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym__Alignas] = ACTIONS(4988),
    [anon_sym_QMARK] = ACTIONS(4990),
    [anon_sym_STAR_EQ] = ACTIONS(4990),
    [anon_sym_SLASH_EQ] = ACTIONS(4990),
    [anon_sym_PERCENT_EQ] = ACTIONS(4990),
    [anon_sym_PLUS_EQ] = ACTIONS(4990),
    [anon_sym_DASH_EQ] = ACTIONS(4990),
    [anon_sym_LT_LT_EQ] = ACTIONS(4990),
    [anon_sym_GT_GT_EQ] = ACTIONS(4990),
    [anon_sym_AMP_EQ] = ACTIONS(4990),
    [anon_sym_CARET_EQ] = ACTIONS(4990),
    [anon_sym_PIPE_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_and] = ACTIONS(4988),
    [anon_sym_bitor] = ACTIONS(4988),
    [anon_sym_xor] = ACTIONS(4988),
    [anon_sym_bitand] = ACTIONS(4988),
    [anon_sym_not_eq] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(4990),
    [anon_sym_PLUS_PLUS] = ACTIONS(4990),
    [anon_sym_DOT] = ACTIONS(4988),
    [anon_sym_DOT_STAR] = ACTIONS(4990),
    [anon_sym_DASH_GT] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4990),
  },
  [1584] = {
    [sym_identifier] = ACTIONS(4959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_TILDE] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_SLASH] = ACTIONS(4959),
    [anon_sym_PERCENT] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4959),
    [anon_sym_CARET] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4959),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym___extension__] = ACTIONS(4959),
    [anon_sym_virtual] = ACTIONS(4959),
    [anon_sym_extern] = ACTIONS(4959),
    [anon_sym___attribute__] = ACTIONS(4959),
    [anon_sym___attribute] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(4961),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4961),
    [anon_sym___declspec] = ACTIONS(4959),
    [anon_sym___based] = ACTIONS(4959),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_LBRACK] = ACTIONS(4959),
    [anon_sym_static] = ACTIONS(4959),
    [anon_sym_EQ] = ACTIONS(4959),
    [anon_sym_register] = ACTIONS(4959),
    [anon_sym_inline] = ACTIONS(4959),
    [anon_sym___inline] = ACTIONS(4959),
    [anon_sym___inline__] = ACTIONS(4959),
    [anon_sym___forceinline] = ACTIONS(4959),
    [anon_sym_thread_local] = ACTIONS(4959),
    [anon_sym___thread] = ACTIONS(4959),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_constexpr] = ACTIONS(4959),
    [anon_sym_volatile] = ACTIONS(4959),
    [anon_sym_restrict] = ACTIONS(4959),
    [anon_sym___restrict__] = ACTIONS(4959),
    [anon_sym__Atomic] = ACTIONS(4959),
    [anon_sym__Noreturn] = ACTIONS(4959),
    [anon_sym_noreturn] = ACTIONS(4959),
    [anon_sym__Nonnull] = ACTIONS(4959),
    [anon_sym_mutable] = ACTIONS(4959),
    [anon_sym_constinit] = ACTIONS(4959),
    [anon_sym_consteval] = ACTIONS(4959),
    [anon_sym_alignas] = ACTIONS(4959),
    [anon_sym__Alignas] = ACTIONS(4959),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4961),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4959),
    [anon_sym_and] = ACTIONS(4959),
    [anon_sym_bitor] = ACTIONS(4959),
    [anon_sym_xor] = ACTIONS(4959),
    [anon_sym_bitand] = ACTIONS(4959),
    [anon_sym_not_eq] = ACTIONS(4959),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4959),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4959),
    [anon_sym_decltype] = ACTIONS(4959),
    [anon_sym_template] = ACTIONS(4959),
    [anon_sym_operator] = ACTIONS(4959),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4961),
  },
  [1585] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1585),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5072),
    [anon_sym_COMMA] = ACTIONS(5072),
    [anon_sym_RPAREN] = ACTIONS(5072),
    [aux_sym_preproc_if_token2] = ACTIONS(5072),
    [aux_sym_preproc_else_token1] = ACTIONS(5072),
    [aux_sym_preproc_elif_token1] = ACTIONS(5070),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_PLUS] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5070),
    [anon_sym_SLASH] = ACTIONS(5070),
    [anon_sym_PERCENT] = ACTIONS(5070),
    [anon_sym_PIPE_PIPE] = ACTIONS(5072),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5070),
    [anon_sym_CARET] = ACTIONS(5070),
    [anon_sym_AMP] = ACTIONS(5070),
    [anon_sym_EQ_EQ] = ACTIONS(5072),
    [anon_sym_BANG_EQ] = ACTIONS(5072),
    [anon_sym_GT] = ACTIONS(5070),
    [anon_sym_GT_EQ] = ACTIONS(5072),
    [anon_sym_LT_EQ] = ACTIONS(5070),
    [anon_sym_LT] = ACTIONS(5070),
    [anon_sym_LT_LT] = ACTIONS(5070),
    [anon_sym_GT_GT] = ACTIONS(5070),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5070),
    [anon_sym___attribute] = ACTIONS(5070),
    [anon_sym_COLON] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_RBRACE] = ACTIONS(5072),
    [anon_sym_signed] = ACTIONS(5074),
    [anon_sym_unsigned] = ACTIONS(5074),
    [anon_sym_long] = ACTIONS(5074),
    [anon_sym_short] = ACTIONS(5074),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_RBRACK] = ACTIONS(5072),
    [anon_sym_EQ] = ACTIONS(5070),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5072),
    [anon_sym_STAR_EQ] = ACTIONS(5072),
    [anon_sym_SLASH_EQ] = ACTIONS(5072),
    [anon_sym_PERCENT_EQ] = ACTIONS(5072),
    [anon_sym_PLUS_EQ] = ACTIONS(5072),
    [anon_sym_DASH_EQ] = ACTIONS(5072),
    [anon_sym_LT_LT_EQ] = ACTIONS(5072),
    [anon_sym_GT_GT_EQ] = ACTIONS(5072),
    [anon_sym_AMP_EQ] = ACTIONS(5072),
    [anon_sym_CARET_EQ] = ACTIONS(5072),
    [anon_sym_PIPE_EQ] = ACTIONS(5072),
    [anon_sym_and_eq] = ACTIONS(5070),
    [anon_sym_or_eq] = ACTIONS(5070),
    [anon_sym_xor_eq] = ACTIONS(5070),
    [anon_sym_LT_EQ_GT] = ACTIONS(5072),
    [anon_sym_or] = ACTIONS(5070),
    [anon_sym_and] = ACTIONS(5070),
    [anon_sym_bitor] = ACTIONS(5070),
    [anon_sym_xor] = ACTIONS(5070),
    [anon_sym_bitand] = ACTIONS(5070),
    [anon_sym_not_eq] = ACTIONS(5070),
    [anon_sym_DASH_DASH] = ACTIONS(5072),
    [anon_sym_PLUS_PLUS] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5070),
    [anon_sym_DOT_STAR] = ACTIONS(5072),
    [anon_sym_DASH_GT] = ACTIONS(5072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5070),
    [anon_sym_decltype] = ACTIONS(5070),
  },
  [1586] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5000),
    [anon_sym_COMMA] = ACTIONS(5000),
    [anon_sym_RPAREN] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5005),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5005),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5003),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_EQ] = ACTIONS(5007),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym__Nonnull] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym__Alignas] = ACTIONS(4996),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_STAR_EQ] = ACTIONS(4998),
    [anon_sym_SLASH_EQ] = ACTIONS(4998),
    [anon_sym_PERCENT_EQ] = ACTIONS(4998),
    [anon_sym_PLUS_EQ] = ACTIONS(4998),
    [anon_sym_DASH_EQ] = ACTIONS(4998),
    [anon_sym_LT_LT_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT_EQ] = ACTIONS(4998),
    [anon_sym_AMP_EQ] = ACTIONS(4998),
    [anon_sym_CARET_EQ] = ACTIONS(4998),
    [anon_sym_PIPE_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(5005),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(5005),
    [anon_sym_not_eq] = ACTIONS(5005),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(5005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4998),
  },
  [1587] = {
    [sym_identifier] = ACTIONS(4955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4957),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4957),
    [anon_sym_LPAREN2] = ACTIONS(4957),
    [anon_sym_TILDE] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_SLASH] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4957),
    [anon_sym_AMP_AMP] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4955),
    [anon_sym_CARET] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4957),
    [anon_sym_BANG_EQ] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_GT_EQ] = ACTIONS(4957),
    [anon_sym_LT_EQ] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4955),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym___extension__] = ACTIONS(4955),
    [anon_sym_virtual] = ACTIONS(4955),
    [anon_sym_extern] = ACTIONS(4955),
    [anon_sym___attribute__] = ACTIONS(4955),
    [anon_sym___attribute] = ACTIONS(4955),
    [anon_sym_COLON_COLON] = ACTIONS(4957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4957),
    [anon_sym___declspec] = ACTIONS(4955),
    [anon_sym___based] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4955),
    [anon_sym_static] = ACTIONS(4955),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_register] = ACTIONS(4955),
    [anon_sym_inline] = ACTIONS(4955),
    [anon_sym___inline] = ACTIONS(4955),
    [anon_sym___inline__] = ACTIONS(4955),
    [anon_sym___forceinline] = ACTIONS(4955),
    [anon_sym_thread_local] = ACTIONS(4955),
    [anon_sym___thread] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_constexpr] = ACTIONS(4955),
    [anon_sym_volatile] = ACTIONS(4955),
    [anon_sym_restrict] = ACTIONS(4955),
    [anon_sym___restrict__] = ACTIONS(4955),
    [anon_sym__Atomic] = ACTIONS(4955),
    [anon_sym__Noreturn] = ACTIONS(4955),
    [anon_sym_noreturn] = ACTIONS(4955),
    [anon_sym__Nonnull] = ACTIONS(4955),
    [anon_sym_mutable] = ACTIONS(4955),
    [anon_sym_constinit] = ACTIONS(4955),
    [anon_sym_consteval] = ACTIONS(4955),
    [anon_sym_alignas] = ACTIONS(4955),
    [anon_sym__Alignas] = ACTIONS(4955),
    [anon_sym_QMARK] = ACTIONS(4957),
    [anon_sym_STAR_EQ] = ACTIONS(4957),
    [anon_sym_SLASH_EQ] = ACTIONS(4957),
    [anon_sym_PERCENT_EQ] = ACTIONS(4957),
    [anon_sym_PLUS_EQ] = ACTIONS(4957),
    [anon_sym_DASH_EQ] = ACTIONS(4957),
    [anon_sym_LT_LT_EQ] = ACTIONS(4957),
    [anon_sym_GT_GT_EQ] = ACTIONS(4957),
    [anon_sym_AMP_EQ] = ACTIONS(4957),
    [anon_sym_CARET_EQ] = ACTIONS(4957),
    [anon_sym_PIPE_EQ] = ACTIONS(4957),
    [anon_sym_LT_EQ_GT] = ACTIONS(4957),
    [anon_sym_or] = ACTIONS(4955),
    [anon_sym_and] = ACTIONS(4955),
    [anon_sym_bitor] = ACTIONS(4955),
    [anon_sym_xor] = ACTIONS(4955),
    [anon_sym_bitand] = ACTIONS(4955),
    [anon_sym_not_eq] = ACTIONS(4955),
    [anon_sym_DASH_DASH] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4957),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_DOT_STAR] = ACTIONS(4957),
    [anon_sym_DASH_GT] = ACTIONS(4955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4955),
    [anon_sym_decltype] = ACTIONS(4955),
    [anon_sym_template] = ACTIONS(4955),
    [anon_sym_operator] = ACTIONS(4955),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4957),
  },
  [1588] = {
    [sym_identifier] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_RPAREN] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4986),
    [anon_sym_BANG_EQ] = ACTIONS(4986),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4986),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4984),
    [anon_sym_virtual] = ACTIONS(4984),
    [anon_sym_extern] = ACTIONS(4984),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4986),
    [anon_sym___declspec] = ACTIONS(4984),
    [anon_sym___based] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4986),
    [anon_sym_LBRACK] = ACTIONS(4984),
    [anon_sym_static] = ACTIONS(4984),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_register] = ACTIONS(4984),
    [anon_sym_inline] = ACTIONS(4984),
    [anon_sym___inline] = ACTIONS(4984),
    [anon_sym___inline__] = ACTIONS(4984),
    [anon_sym___forceinline] = ACTIONS(4984),
    [anon_sym_thread_local] = ACTIONS(4984),
    [anon_sym___thread] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym___restrict__] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym__Noreturn] = ACTIONS(4984),
    [anon_sym_noreturn] = ACTIONS(4984),
    [anon_sym__Nonnull] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_constinit] = ACTIONS(4984),
    [anon_sym_consteval] = ACTIONS(4984),
    [anon_sym_alignas] = ACTIONS(4984),
    [anon_sym__Alignas] = ACTIONS(4984),
    [anon_sym_QMARK] = ACTIONS(4986),
    [anon_sym_STAR_EQ] = ACTIONS(4986),
    [anon_sym_SLASH_EQ] = ACTIONS(4986),
    [anon_sym_PERCENT_EQ] = ACTIONS(4986),
    [anon_sym_PLUS_EQ] = ACTIONS(4986),
    [anon_sym_DASH_EQ] = ACTIONS(4986),
    [anon_sym_LT_LT_EQ] = ACTIONS(4986),
    [anon_sym_GT_GT_EQ] = ACTIONS(4986),
    [anon_sym_AMP_EQ] = ACTIONS(4986),
    [anon_sym_CARET_EQ] = ACTIONS(4986),
    [anon_sym_PIPE_EQ] = ACTIONS(4986),
    [anon_sym_LT_EQ_GT] = ACTIONS(4986),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(4986),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4986),
    [anon_sym_DASH_GT] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_template] = ACTIONS(4984),
    [anon_sym_operator] = ACTIONS(4984),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4986),
  },
  [1589] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(2985),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_LPAREN2] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym___extension__] = ACTIONS(4152),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_signed] = ACTIONS(5038),
    [anon_sym_unsigned] = ACTIONS(5038),
    [anon_sym_long] = ACTIONS(5038),
    [anon_sym_short] = ACTIONS(5038),
    [anon_sym_LBRACK] = ACTIONS(4159),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_constexpr] = ACTIONS(4152),
    [anon_sym_volatile] = ACTIONS(4152),
    [anon_sym_restrict] = ACTIONS(4152),
    [anon_sym___restrict__] = ACTIONS(4152),
    [anon_sym__Atomic] = ACTIONS(4152),
    [anon_sym__Noreturn] = ACTIONS(4152),
    [anon_sym_noreturn] = ACTIONS(4152),
    [anon_sym__Nonnull] = ACTIONS(4152),
    [anon_sym_mutable] = ACTIONS(4152),
    [anon_sym_constinit] = ACTIONS(4152),
    [anon_sym_consteval] = ACTIONS(4152),
    [anon_sym_alignas] = ACTIONS(4152),
    [anon_sym__Alignas] = ACTIONS(4152),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4182),
    [anon_sym_or_eq] = ACTIONS(4182),
    [anon_sym_xor_eq] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4152),
    [anon_sym_decltype] = ACTIONS(4152),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [1590] = {
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2563),
    [anon_sym_RPAREN] = ACTIONS(2563),
    [aux_sym_preproc_if_token2] = ACTIONS(2563),
    [aux_sym_preproc_else_token1] = ACTIONS(2563),
    [aux_sym_preproc_elif_token1] = ACTIONS(2573),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2573),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_CARET] = ACTIONS(2573),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2563),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_RBRACE] = ACTIONS(2563),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_RBRACK] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_and_eq] = ACTIONS(2573),
    [anon_sym_or_eq] = ACTIONS(2573),
    [anon_sym_xor_eq] = ACTIONS(2573),
    [anon_sym_LT_EQ_GT] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2573),
    [anon_sym_and] = ACTIONS(2573),
    [anon_sym_bitor] = ACTIONS(2573),
    [anon_sym_xor] = ACTIONS(2573),
    [anon_sym_bitand] = ACTIONS(2573),
    [anon_sym_not_eq] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_PLUS] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2573),
    [anon_sym_DOT_STAR] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
  },
  [1591] = {
    [sym_identifier] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5082),
    [anon_sym_COMMA] = ACTIONS(5082),
    [anon_sym_RPAREN] = ACTIONS(5082),
    [aux_sym_preproc_if_token2] = ACTIONS(5082),
    [aux_sym_preproc_else_token1] = ACTIONS(5082),
    [aux_sym_preproc_elif_token1] = ACTIONS(5080),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5082),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5082),
    [anon_sym_LPAREN2] = ACTIONS(5082),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5080),
    [anon_sym_SLASH] = ACTIONS(5080),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5082),
    [anon_sym_AMP_AMP] = ACTIONS(5082),
    [anon_sym_PIPE] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5082),
    [anon_sym_BANG_EQ] = ACTIONS(5082),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_EQ] = ACTIONS(5080),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5080),
    [anon_sym___attribute__] = ACTIONS(5080),
    [anon_sym___attribute] = ACTIONS(5080),
    [anon_sym_COLON] = ACTIONS(5082),
    [anon_sym_LBRACE] = ACTIONS(5082),
    [anon_sym_RBRACE] = ACTIONS(5082),
    [anon_sym_signed] = ACTIONS(5080),
    [anon_sym_unsigned] = ACTIONS(5080),
    [anon_sym_long] = ACTIONS(5080),
    [anon_sym_short] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5082),
    [anon_sym_RBRACK] = ACTIONS(5082),
    [anon_sym_EQ] = ACTIONS(5080),
    [anon_sym_const] = ACTIONS(5080),
    [anon_sym_constexpr] = ACTIONS(5080),
    [anon_sym_volatile] = ACTIONS(5080),
    [anon_sym_restrict] = ACTIONS(5080),
    [anon_sym___restrict__] = ACTIONS(5080),
    [anon_sym__Atomic] = ACTIONS(5080),
    [anon_sym__Noreturn] = ACTIONS(5080),
    [anon_sym_noreturn] = ACTIONS(5080),
    [anon_sym__Nonnull] = ACTIONS(5080),
    [anon_sym_mutable] = ACTIONS(5080),
    [anon_sym_constinit] = ACTIONS(5080),
    [anon_sym_consteval] = ACTIONS(5080),
    [anon_sym_alignas] = ACTIONS(5080),
    [anon_sym__Alignas] = ACTIONS(5080),
    [sym_primitive_type] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5082),
    [anon_sym_STAR_EQ] = ACTIONS(5082),
    [anon_sym_SLASH_EQ] = ACTIONS(5082),
    [anon_sym_PERCENT_EQ] = ACTIONS(5082),
    [anon_sym_PLUS_EQ] = ACTIONS(5082),
    [anon_sym_DASH_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_GT_EQ] = ACTIONS(5082),
    [anon_sym_AMP_EQ] = ACTIONS(5082),
    [anon_sym_CARET_EQ] = ACTIONS(5082),
    [anon_sym_PIPE_EQ] = ACTIONS(5082),
    [anon_sym_and_eq] = ACTIONS(5080),
    [anon_sym_or_eq] = ACTIONS(5080),
    [anon_sym_xor_eq] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(5082),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_bitor] = ACTIONS(5080),
    [anon_sym_xor] = ACTIONS(5080),
    [anon_sym_bitand] = ACTIONS(5080),
    [anon_sym_not_eq] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5082),
    [anon_sym_PLUS_PLUS] = ACTIONS(5082),
    [anon_sym_DOT] = ACTIONS(5080),
    [anon_sym_DOT_STAR] = ACTIONS(5082),
    [anon_sym_DASH_GT] = ACTIONS(5082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5080),
    [anon_sym_decltype] = ACTIONS(5080),
  },
  [1592] = {
    [sym_type_qualifier] = STATE(1593),
    [sym_alignas_qualifier] = STATE(1590),
    [aux_sym__type_definition_type_repeat1] = STATE(1593),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1614),
    [sym_identifier] = ACTIONS(5084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5086),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_RPAREN] = ACTIONS(5086),
    [anon_sym_LPAREN2] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_STAR] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5088),
    [anon_sym_PERCENT] = ACTIONS(5088),
    [anon_sym_PIPE_PIPE] = ACTIONS(5086),
    [anon_sym_AMP_AMP] = ACTIONS(5086),
    [anon_sym_PIPE] = ACTIONS(5088),
    [anon_sym_CARET] = ACTIONS(5088),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_EQ_EQ] = ACTIONS(5086),
    [anon_sym_BANG_EQ] = ACTIONS(5086),
    [anon_sym_GT] = ACTIONS(5088),
    [anon_sym_GT_EQ] = ACTIONS(5086),
    [anon_sym_LT_EQ] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_LT_LT] = ACTIONS(5088),
    [anon_sym_GT_GT] = ACTIONS(5088),
    [anon_sym_SEMI] = ACTIONS(5086),
    [anon_sym___extension__] = ACTIONS(5090),
    [anon_sym___attribute__] = ACTIONS(5088),
    [anon_sym___attribute] = ACTIONS(5088),
    [anon_sym_COLON] = ACTIONS(5086),
    [anon_sym_LBRACE] = ACTIONS(5086),
    [anon_sym_RBRACE] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5092),
    [anon_sym_unsigned] = ACTIONS(5092),
    [anon_sym_long] = ACTIONS(5092),
    [anon_sym_short] = ACTIONS(5092),
    [anon_sym_LBRACK] = ACTIONS(5086),
    [anon_sym_RBRACK] = ACTIONS(5086),
    [anon_sym_EQ] = ACTIONS(5088),
    [anon_sym_const] = ACTIONS(5090),
    [anon_sym_constexpr] = ACTIONS(5090),
    [anon_sym_volatile] = ACTIONS(5090),
    [anon_sym_restrict] = ACTIONS(5090),
    [anon_sym___restrict__] = ACTIONS(5090),
    [anon_sym__Atomic] = ACTIONS(5090),
    [anon_sym__Noreturn] = ACTIONS(5090),
    [anon_sym_noreturn] = ACTIONS(5090),
    [anon_sym__Nonnull] = ACTIONS(5090),
    [anon_sym_mutable] = ACTIONS(5090),
    [anon_sym_constinit] = ACTIONS(5090),
    [anon_sym_consteval] = ACTIONS(5090),
    [anon_sym_alignas] = ACTIONS(5094),
    [anon_sym__Alignas] = ACTIONS(5094),
    [sym_primitive_type] = ACTIONS(5096),
    [anon_sym_QMARK] = ACTIONS(5086),
    [anon_sym_STAR_EQ] = ACTIONS(5086),
    [anon_sym_SLASH_EQ] = ACTIONS(5086),
    [anon_sym_PERCENT_EQ] = ACTIONS(5086),
    [anon_sym_PLUS_EQ] = ACTIONS(5086),
    [anon_sym_DASH_EQ] = ACTIONS(5086),
    [anon_sym_LT_LT_EQ] = ACTIONS(5086),
    [anon_sym_GT_GT_EQ] = ACTIONS(5086),
    [anon_sym_AMP_EQ] = ACTIONS(5086),
    [anon_sym_CARET_EQ] = ACTIONS(5086),
    [anon_sym_PIPE_EQ] = ACTIONS(5086),
    [anon_sym_and_eq] = ACTIONS(5088),
    [anon_sym_or_eq] = ACTIONS(5088),
    [anon_sym_xor_eq] = ACTIONS(5088),
    [anon_sym_LT_EQ_GT] = ACTIONS(5086),
    [anon_sym_or] = ACTIONS(5088),
    [anon_sym_and] = ACTIONS(5088),
    [anon_sym_bitor] = ACTIONS(5088),
    [anon_sym_xor] = ACTIONS(5088),
    [anon_sym_bitand] = ACTIONS(5088),
    [anon_sym_not_eq] = ACTIONS(5088),
    [anon_sym_DASH_DASH] = ACTIONS(5086),
    [anon_sym_PLUS_PLUS] = ACTIONS(5086),
    [anon_sym_DOT] = ACTIONS(5088),
    [anon_sym_DOT_STAR] = ACTIONS(5086),
    [anon_sym_DASH_GT] = ACTIONS(5086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5088),
    [anon_sym_decltype] = ACTIONS(5088),
  },
  [1593] = {
    [sym_type_qualifier] = STATE(1578),
    [sym_alignas_qualifier] = STATE(1590),
    [aux_sym__type_definition_type_repeat1] = STATE(1578),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(5098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5100),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_RPAREN] = ACTIONS(5100),
    [anon_sym_LPAREN2] = ACTIONS(5100),
    [anon_sym_DASH] = ACTIONS(5102),
    [anon_sym_PLUS] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5102),
    [anon_sym_SLASH] = ACTIONS(5102),
    [anon_sym_PERCENT] = ACTIONS(5102),
    [anon_sym_PIPE_PIPE] = ACTIONS(5100),
    [anon_sym_AMP_AMP] = ACTIONS(5100),
    [anon_sym_PIPE] = ACTIONS(5102),
    [anon_sym_CARET] = ACTIONS(5102),
    [anon_sym_AMP] = ACTIONS(5102),
    [anon_sym_EQ_EQ] = ACTIONS(5100),
    [anon_sym_BANG_EQ] = ACTIONS(5100),
    [anon_sym_GT] = ACTIONS(5102),
    [anon_sym_GT_EQ] = ACTIONS(5100),
    [anon_sym_LT_EQ] = ACTIONS(5102),
    [anon_sym_LT] = ACTIONS(5102),
    [anon_sym_LT_LT] = ACTIONS(5102),
    [anon_sym_GT_GT] = ACTIONS(5102),
    [anon_sym_SEMI] = ACTIONS(5100),
    [anon_sym___extension__] = ACTIONS(5090),
    [anon_sym___attribute__] = ACTIONS(5102),
    [anon_sym___attribute] = ACTIONS(5102),
    [anon_sym_COLON] = ACTIONS(5100),
    [anon_sym_LBRACE] = ACTIONS(5100),
    [anon_sym_RBRACE] = ACTIONS(5100),
    [anon_sym_signed] = ACTIONS(5104),
    [anon_sym_unsigned] = ACTIONS(5104),
    [anon_sym_long] = ACTIONS(5104),
    [anon_sym_short] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5100),
    [anon_sym_RBRACK] = ACTIONS(5100),
    [anon_sym_EQ] = ACTIONS(5102),
    [anon_sym_const] = ACTIONS(5090),
    [anon_sym_constexpr] = ACTIONS(5090),
    [anon_sym_volatile] = ACTIONS(5090),
    [anon_sym_restrict] = ACTIONS(5090),
    [anon_sym___restrict__] = ACTIONS(5090),
    [anon_sym__Atomic] = ACTIONS(5090),
    [anon_sym__Noreturn] = ACTIONS(5090),
    [anon_sym_noreturn] = ACTIONS(5090),
    [anon_sym__Nonnull] = ACTIONS(5090),
    [anon_sym_mutable] = ACTIONS(5090),
    [anon_sym_constinit] = ACTIONS(5090),
    [anon_sym_consteval] = ACTIONS(5090),
    [anon_sym_alignas] = ACTIONS(5094),
    [anon_sym__Alignas] = ACTIONS(5094),
    [sym_primitive_type] = ACTIONS(5106),
    [anon_sym_QMARK] = ACTIONS(5100),
    [anon_sym_STAR_EQ] = ACTIONS(5100),
    [anon_sym_SLASH_EQ] = ACTIONS(5100),
    [anon_sym_PERCENT_EQ] = ACTIONS(5100),
    [anon_sym_PLUS_EQ] = ACTIONS(5100),
    [anon_sym_DASH_EQ] = ACTIONS(5100),
    [anon_sym_LT_LT_EQ] = ACTIONS(5100),
    [anon_sym_GT_GT_EQ] = ACTIONS(5100),
    [anon_sym_AMP_EQ] = ACTIONS(5100),
    [anon_sym_CARET_EQ] = ACTIONS(5100),
    [anon_sym_PIPE_EQ] = ACTIONS(5100),
    [anon_sym_and_eq] = ACTIONS(5102),
    [anon_sym_or_eq] = ACTIONS(5102),
    [anon_sym_xor_eq] = ACTIONS(5102),
    [anon_sym_LT_EQ_GT] = ACTIONS(5100),
    [anon_sym_or] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5102),
    [anon_sym_bitor] = ACTIONS(5102),
    [anon_sym_xor] = ACTIONS(5102),
    [anon_sym_bitand] = ACTIONS(5102),
    [anon_sym_not_eq] = ACTIONS(5102),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_DOT] = ACTIONS(5102),
    [anon_sym_DOT_STAR] = ACTIONS(5100),
    [anon_sym_DASH_GT] = ACTIONS(5100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5102),
    [anon_sym_decltype] = ACTIONS(5102),
  },
  [1594] = {
    [sym_type_qualifier] = STATE(1595),
    [sym_alignas_qualifier] = STATE(1590),
    [aux_sym__type_definition_type_repeat1] = STATE(1595),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1617),
    [sym_identifier] = ACTIONS(5108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5086),
    [anon_sym_COMMA] = ACTIONS(5086),
    [aux_sym_preproc_if_token2] = ACTIONS(5086),
    [aux_sym_preproc_else_token1] = ACTIONS(5086),
    [aux_sym_preproc_elif_token1] = ACTIONS(5088),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5086),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5086),
    [anon_sym_LPAREN2] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_STAR] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5088),
    [anon_sym_PERCENT] = ACTIONS(5088),
    [anon_sym_PIPE_PIPE] = ACTIONS(5086),
    [anon_sym_AMP_AMP] = ACTIONS(5086),
    [anon_sym_PIPE] = ACTIONS(5088),
    [anon_sym_CARET] = ACTIONS(5088),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_EQ_EQ] = ACTIONS(5086),
    [anon_sym_BANG_EQ] = ACTIONS(5086),
    [anon_sym_GT] = ACTIONS(5088),
    [anon_sym_GT_EQ] = ACTIONS(5086),
    [anon_sym_LT_EQ] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_LT_LT] = ACTIONS(5088),
    [anon_sym_GT_GT] = ACTIONS(5088),
    [anon_sym___extension__] = ACTIONS(5090),
    [anon_sym___attribute__] = ACTIONS(5088),
    [anon_sym___attribute] = ACTIONS(5088),
    [anon_sym_LBRACE] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5111),
    [anon_sym_unsigned] = ACTIONS(5111),
    [anon_sym_long] = ACTIONS(5111),
    [anon_sym_short] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5086),
    [anon_sym_EQ] = ACTIONS(5088),
    [anon_sym_const] = ACTIONS(5090),
    [anon_sym_constexpr] = ACTIONS(5090),
    [anon_sym_volatile] = ACTIONS(5090),
    [anon_sym_restrict] = ACTIONS(5090),
    [anon_sym___restrict__] = ACTIONS(5090),
    [anon_sym__Atomic] = ACTIONS(5090),
    [anon_sym__Noreturn] = ACTIONS(5090),
    [anon_sym_noreturn] = ACTIONS(5090),
    [anon_sym__Nonnull] = ACTIONS(5090),
    [anon_sym_mutable] = ACTIONS(5090),
    [anon_sym_constinit] = ACTIONS(5090),
    [anon_sym_consteval] = ACTIONS(5090),
    [anon_sym_alignas] = ACTIONS(5094),
    [anon_sym__Alignas] = ACTIONS(5094),
    [sym_primitive_type] = ACTIONS(5113),
    [anon_sym_QMARK] = ACTIONS(5086),
    [anon_sym_STAR_EQ] = ACTIONS(5086),
    [anon_sym_SLASH_EQ] = ACTIONS(5086),
    [anon_sym_PERCENT_EQ] = ACTIONS(5086),
    [anon_sym_PLUS_EQ] = ACTIONS(5086),
    [anon_sym_DASH_EQ] = ACTIONS(5086),
    [anon_sym_LT_LT_EQ] = ACTIONS(5086),
    [anon_sym_GT_GT_EQ] = ACTIONS(5086),
    [anon_sym_AMP_EQ] = ACTIONS(5086),
    [anon_sym_CARET_EQ] = ACTIONS(5086),
    [anon_sym_PIPE_EQ] = ACTIONS(5086),
    [anon_sym_and_eq] = ACTIONS(5088),
    [anon_sym_or_eq] = ACTIONS(5088),
    [anon_sym_xor_eq] = ACTIONS(5088),
    [anon_sym_LT_EQ_GT] = ACTIONS(5086),
    [anon_sym_or] = ACTIONS(5088),
    [anon_sym_and] = ACTIONS(5088),
    [anon_sym_bitor] = ACTIONS(5088),
    [anon_sym_xor] = ACTIONS(5088),
    [anon_sym_bitand] = ACTIONS(5088),
    [anon_sym_not_eq] = ACTIONS(5088),
    [anon_sym_DASH_DASH] = ACTIONS(5086),
    [anon_sym_PLUS_PLUS] = ACTIONS(5086),
    [anon_sym_DOT] = ACTIONS(5088),
    [anon_sym_DOT_STAR] = ACTIONS(5086),
    [anon_sym_DASH_GT] = ACTIONS(5086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5088),
    [anon_sym_decltype] = ACTIONS(5088),
  },
  [1595] = {
    [sym_type_qualifier] = STATE(1578),
    [sym_alignas_qualifier] = STATE(1590),
    [aux_sym__type_definition_type_repeat1] = STATE(1578),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(5115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5100),
    [anon_sym_COMMA] = ACTIONS(5100),
    [aux_sym_preproc_if_token2] = ACTIONS(5100),
    [aux_sym_preproc_else_token1] = ACTIONS(5100),
    [aux_sym_preproc_elif_token1] = ACTIONS(5102),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5100),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5100),
    [anon_sym_LPAREN2] = ACTIONS(5100),
    [anon_sym_DASH] = ACTIONS(5102),
    [anon_sym_PLUS] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5102),
    [anon_sym_SLASH] = ACTIONS(5102),
    [anon_sym_PERCENT] = ACTIONS(5102),
    [anon_sym_PIPE_PIPE] = ACTIONS(5100),
    [anon_sym_AMP_AMP] = ACTIONS(5100),
    [anon_sym_PIPE] = ACTIONS(5102),
    [anon_sym_CARET] = ACTIONS(5102),
    [anon_sym_AMP] = ACTIONS(5102),
    [anon_sym_EQ_EQ] = ACTIONS(5100),
    [anon_sym_BANG_EQ] = ACTIONS(5100),
    [anon_sym_GT] = ACTIONS(5102),
    [anon_sym_GT_EQ] = ACTIONS(5100),
    [anon_sym_LT_EQ] = ACTIONS(5102),
    [anon_sym_LT] = ACTIONS(5102),
    [anon_sym_LT_LT] = ACTIONS(5102),
    [anon_sym_GT_GT] = ACTIONS(5102),
    [anon_sym___extension__] = ACTIONS(5090),
    [anon_sym___attribute__] = ACTIONS(5102),
    [anon_sym___attribute] = ACTIONS(5102),
    [anon_sym_LBRACE] = ACTIONS(5100),
    [anon_sym_signed] = ACTIONS(5118),
    [anon_sym_unsigned] = ACTIONS(5118),
    [anon_sym_long] = ACTIONS(5118),
    [anon_sym_short] = ACTIONS(5118),
    [anon_sym_LBRACK] = ACTIONS(5100),
    [anon_sym_EQ] = ACTIONS(5102),
    [anon_sym_const] = ACTIONS(5090),
    [anon_sym_constexpr] = ACTIONS(5090),
    [anon_sym_volatile] = ACTIONS(5090),
    [anon_sym_restrict] = ACTIONS(5090),
    [anon_sym___restrict__] = ACTIONS(5090),
    [anon_sym__Atomic] = ACTIONS(5090),
    [anon_sym__Noreturn] = ACTIONS(5090),
    [anon_sym_noreturn] = ACTIONS(5090),
    [anon_sym__Nonnull] = ACTIONS(5090),
    [anon_sym_mutable] = ACTIONS(5090),
    [anon_sym_constinit] = ACTIONS(5090),
    [anon_sym_consteval] = ACTIONS(5090),
    [anon_sym_alignas] = ACTIONS(5094),
    [anon_sym__Alignas] = ACTIONS(5094),
    [sym_primitive_type] = ACTIONS(5120),
    [anon_sym_QMARK] = ACTIONS(5100),
    [anon_sym_STAR_EQ] = ACTIONS(5100),
    [anon_sym_SLASH_EQ] = ACTIONS(5100),
    [anon_sym_PERCENT_EQ] = ACTIONS(5100),
    [anon_sym_PLUS_EQ] = ACTIONS(5100),
    [anon_sym_DASH_EQ] = ACTIONS(5100),
    [anon_sym_LT_LT_EQ] = ACTIONS(5100),
    [anon_sym_GT_GT_EQ] = ACTIONS(5100),
    [anon_sym_AMP_EQ] = ACTIONS(5100),
    [anon_sym_CARET_EQ] = ACTIONS(5100),
    [anon_sym_PIPE_EQ] = ACTIONS(5100),
    [anon_sym_and_eq] = ACTIONS(5102),
    [anon_sym_or_eq] = ACTIONS(5102),
    [anon_sym_xor_eq] = ACTIONS(5102),
    [anon_sym_LT_EQ_GT] = ACTIONS(5100),
    [anon_sym_or] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5102),
    [anon_sym_bitor] = ACTIONS(5102),
    [anon_sym_xor] = ACTIONS(5102),
    [anon_sym_bitand] = ACTIONS(5102),
    [anon_sym_not_eq] = ACTIONS(5102),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_DOT] = ACTIONS(5102),
    [anon_sym_DOT_STAR] = ACTIONS(5100),
    [anon_sym_DASH_GT] = ACTIONS(5100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5102),
    [anon_sym_decltype] = ACTIONS(5102),
  },
  [1596] = {
    [sym_identifier] = ACTIONS(4992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4994),
    [anon_sym_COMMA] = ACTIONS(4994),
    [anon_sym_RPAREN] = ACTIONS(4994),
    [aux_sym_preproc_if_token2] = ACTIONS(4994),
    [aux_sym_preproc_else_token1] = ACTIONS(4994),
    [aux_sym_preproc_elif_token1] = ACTIONS(4992),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4994),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4992),
    [anon_sym_PLUS] = ACTIONS(4992),
    [anon_sym_STAR] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4992),
    [anon_sym_PIPE_PIPE] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(4992),
    [anon_sym_CARET] = ACTIONS(4992),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4994),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_GT_EQ] = ACTIONS(4994),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_SEMI] = ACTIONS(4994),
    [anon_sym___extension__] = ACTIONS(4992),
    [anon_sym___attribute__] = ACTIONS(4992),
    [anon_sym___attribute] = ACTIONS(4992),
    [anon_sym_COLON] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACE] = ACTIONS(4994),
    [anon_sym_RBRACE] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(4994),
    [anon_sym_RBRACK] = ACTIONS(4994),
    [anon_sym_EQ] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym___restrict__] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym__Noreturn] = ACTIONS(4992),
    [anon_sym_noreturn] = ACTIONS(4992),
    [anon_sym__Nonnull] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_constinit] = ACTIONS(4992),
    [anon_sym_consteval] = ACTIONS(4992),
    [anon_sym_alignas] = ACTIONS(4992),
    [anon_sym__Alignas] = ACTIONS(4992),
    [anon_sym_QMARK] = ACTIONS(4994),
    [anon_sym_STAR_EQ] = ACTIONS(4994),
    [anon_sym_SLASH_EQ] = ACTIONS(4994),
    [anon_sym_PERCENT_EQ] = ACTIONS(4994),
    [anon_sym_PLUS_EQ] = ACTIONS(4994),
    [anon_sym_DASH_EQ] = ACTIONS(4994),
    [anon_sym_LT_LT_EQ] = ACTIONS(4994),
    [anon_sym_GT_GT_EQ] = ACTIONS(4994),
    [anon_sym_AMP_EQ] = ACTIONS(4994),
    [anon_sym_CARET_EQ] = ACTIONS(4994),
    [anon_sym_PIPE_EQ] = ACTIONS(4994),
    [anon_sym_and_eq] = ACTIONS(4992),
    [anon_sym_or_eq] = ACTIONS(4992),
    [anon_sym_xor_eq] = ACTIONS(4992),
    [anon_sym_LT_EQ_GT] = ACTIONS(4994),
    [anon_sym_or] = ACTIONS(4992),
    [anon_sym_and] = ACTIONS(4992),
    [anon_sym_bitor] = ACTIONS(4992),
    [anon_sym_xor] = ACTIONS(4992),
    [anon_sym_bitand] = ACTIONS(4992),
    [anon_sym_not_eq] = ACTIONS(4992),
    [anon_sym_DASH_DASH] = ACTIONS(4994),
    [anon_sym_PLUS_PLUS] = ACTIONS(4994),
    [anon_sym_DOT] = ACTIONS(4992),
    [anon_sym_DOT_STAR] = ACTIONS(4994),
    [anon_sym_DASH_GT] = ACTIONS(4994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_decltype] = ACTIONS(4992),
    [anon_sym_final] = ACTIONS(4992),
    [anon_sym_override] = ACTIONS(4992),
  },
  [1597] = {
    [sym_identifier] = ACTIONS(4951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4953),
    [anon_sym_COMMA] = ACTIONS(4953),
    [anon_sym_RPAREN] = ACTIONS(4953),
    [aux_sym_preproc_if_token2] = ACTIONS(4953),
    [aux_sym_preproc_else_token1] = ACTIONS(4953),
    [aux_sym_preproc_elif_token1] = ACTIONS(4951),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4953),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4953),
    [anon_sym_LPAREN2] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4951),
    [anon_sym_SLASH] = ACTIONS(4951),
    [anon_sym_PERCENT] = ACTIONS(4951),
    [anon_sym_PIPE_PIPE] = ACTIONS(4953),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_PIPE] = ACTIONS(4951),
    [anon_sym_CARET] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_EQ_EQ] = ACTIONS(4953),
    [anon_sym_BANG_EQ] = ACTIONS(4953),
    [anon_sym_GT] = ACTIONS(4951),
    [anon_sym_GT_EQ] = ACTIONS(4953),
    [anon_sym_LT_EQ] = ACTIONS(4951),
    [anon_sym_LT] = ACTIONS(4951),
    [anon_sym_LT_LT] = ACTIONS(4951),
    [anon_sym_GT_GT] = ACTIONS(4951),
    [anon_sym_SEMI] = ACTIONS(4953),
    [anon_sym___extension__] = ACTIONS(4951),
    [anon_sym___attribute__] = ACTIONS(4951),
    [anon_sym___attribute] = ACTIONS(4951),
    [anon_sym_COLON] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4953),
    [anon_sym_LBRACE] = ACTIONS(4953),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym_LBRACK] = ACTIONS(4953),
    [anon_sym_RBRACK] = ACTIONS(4953),
    [anon_sym_EQ] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym_restrict] = ACTIONS(4951),
    [anon_sym___restrict__] = ACTIONS(4951),
    [anon_sym__Atomic] = ACTIONS(4951),
    [anon_sym__Noreturn] = ACTIONS(4951),
    [anon_sym_noreturn] = ACTIONS(4951),
    [anon_sym__Nonnull] = ACTIONS(4951),
    [anon_sym_mutable] = ACTIONS(4951),
    [anon_sym_constinit] = ACTIONS(4951),
    [anon_sym_consteval] = ACTIONS(4951),
    [anon_sym_alignas] = ACTIONS(4951),
    [anon_sym__Alignas] = ACTIONS(4951),
    [anon_sym_QMARK] = ACTIONS(4953),
    [anon_sym_STAR_EQ] = ACTIONS(4953),
    [anon_sym_SLASH_EQ] = ACTIONS(4953),
    [anon_sym_PERCENT_EQ] = ACTIONS(4953),
    [anon_sym_PLUS_EQ] = ACTIONS(4953),
    [anon_sym_DASH_EQ] = ACTIONS(4953),
    [anon_sym_LT_LT_EQ] = ACTIONS(4953),
    [anon_sym_GT_GT_EQ] = ACTIONS(4953),
    [anon_sym_AMP_EQ] = ACTIONS(4953),
    [anon_sym_CARET_EQ] = ACTIONS(4953),
    [anon_sym_PIPE_EQ] = ACTIONS(4953),
    [anon_sym_and_eq] = ACTIONS(4951),
    [anon_sym_or_eq] = ACTIONS(4951),
    [anon_sym_xor_eq] = ACTIONS(4951),
    [anon_sym_LT_EQ_GT] = ACTIONS(4953),
    [anon_sym_or] = ACTIONS(4951),
    [anon_sym_and] = ACTIONS(4951),
    [anon_sym_bitor] = ACTIONS(4951),
    [anon_sym_xor] = ACTIONS(4951),
    [anon_sym_bitand] = ACTIONS(4951),
    [anon_sym_not_eq] = ACTIONS(4951),
    [anon_sym_DASH_DASH] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4953),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_DOT_STAR] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4951),
    [anon_sym_decltype] = ACTIONS(4951),
    [anon_sym_final] = ACTIONS(4951),
    [anon_sym_override] = ACTIONS(4951),
  },
  [1598] = {
    [sym_identifier] = ACTIONS(4980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_RPAREN] = ACTIONS(4982),
    [aux_sym_preproc_if_token2] = ACTIONS(4982),
    [aux_sym_preproc_else_token1] = ACTIONS(4982),
    [aux_sym_preproc_elif_token1] = ACTIONS(4980),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4982),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4982),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_DASH] = ACTIONS(4980),
    [anon_sym_PLUS] = ACTIONS(4980),
    [anon_sym_STAR] = ACTIONS(4980),
    [anon_sym_SLASH] = ACTIONS(4980),
    [anon_sym_PERCENT] = ACTIONS(4980),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4980),
    [anon_sym_CARET] = ACTIONS(4980),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4982),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_LT_LT] = ACTIONS(4980),
    [anon_sym_GT_GT] = ACTIONS(4980),
    [anon_sym_SEMI] = ACTIONS(4982),
    [anon_sym___extension__] = ACTIONS(4980),
    [anon_sym___attribute__] = ACTIONS(4980),
    [anon_sym___attribute] = ACTIONS(4980),
    [anon_sym_COLON] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACE] = ACTIONS(4982),
    [anon_sym_RBRACE] = ACTIONS(4982),
    [anon_sym_LBRACK] = ACTIONS(4982),
    [anon_sym_RBRACK] = ACTIONS(4982),
    [anon_sym_EQ] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4980),
    [anon_sym_volatile] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4980),
    [anon_sym___restrict__] = ACTIONS(4980),
    [anon_sym__Atomic] = ACTIONS(4980),
    [anon_sym__Noreturn] = ACTIONS(4980),
    [anon_sym_noreturn] = ACTIONS(4980),
    [anon_sym__Nonnull] = ACTIONS(4980),
    [anon_sym_mutable] = ACTIONS(4980),
    [anon_sym_constinit] = ACTIONS(4980),
    [anon_sym_consteval] = ACTIONS(4980),
    [anon_sym_alignas] = ACTIONS(4980),
    [anon_sym__Alignas] = ACTIONS(4980),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_STAR_EQ] = ACTIONS(4982),
    [anon_sym_SLASH_EQ] = ACTIONS(4982),
    [anon_sym_PERCENT_EQ] = ACTIONS(4982),
    [anon_sym_PLUS_EQ] = ACTIONS(4982),
    [anon_sym_DASH_EQ] = ACTIONS(4982),
    [anon_sym_LT_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT_GT_EQ] = ACTIONS(4982),
    [anon_sym_AMP_EQ] = ACTIONS(4982),
    [anon_sym_CARET_EQ] = ACTIONS(4982),
    [anon_sym_PIPE_EQ] = ACTIONS(4982),
    [anon_sym_and_eq] = ACTIONS(4980),
    [anon_sym_or_eq] = ACTIONS(4980),
    [anon_sym_xor_eq] = ACTIONS(4980),
    [anon_sym_LT_EQ_GT] = ACTIONS(4982),
    [anon_sym_or] = ACTIONS(4980),
    [anon_sym_and] = ACTIONS(4980),
    [anon_sym_bitor] = ACTIONS(4980),
    [anon_sym_xor] = ACTIONS(4980),
    [anon_sym_bitand] = ACTIONS(4980),
    [anon_sym_not_eq] = ACTIONS(4980),
    [anon_sym_DASH_DASH] = ACTIONS(4982),
    [anon_sym_PLUS_PLUS] = ACTIONS(4982),
    [anon_sym_DOT] = ACTIONS(4980),
    [anon_sym_DOT_STAR] = ACTIONS(4982),
    [anon_sym_DASH_GT] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4980),
    [anon_sym_decltype] = ACTIONS(4980),
    [anon_sym_final] = ACTIONS(4980),
    [anon_sym_override] = ACTIONS(4980),
  },
  [1599] = {
    [sym_identifier] = ACTIONS(4959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [aux_sym_preproc_if_token2] = ACTIONS(4961),
    [aux_sym_preproc_else_token1] = ACTIONS(4961),
    [aux_sym_preproc_elif_token1] = ACTIONS(4959),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4961),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_SLASH] = ACTIONS(4959),
    [anon_sym_PERCENT] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4959),
    [anon_sym_CARET] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4959),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym___extension__] = ACTIONS(4959),
    [anon_sym___attribute__] = ACTIONS(4959),
    [anon_sym___attribute] = ACTIONS(4959),
    [anon_sym_COLON] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(4961),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_RBRACE] = ACTIONS(4961),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_RBRACK] = ACTIONS(4961),
    [anon_sym_EQ] = ACTIONS(4959),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_constexpr] = ACTIONS(4959),
    [anon_sym_volatile] = ACTIONS(4959),
    [anon_sym_restrict] = ACTIONS(4959),
    [anon_sym___restrict__] = ACTIONS(4959),
    [anon_sym__Atomic] = ACTIONS(4959),
    [anon_sym__Noreturn] = ACTIONS(4959),
    [anon_sym_noreturn] = ACTIONS(4959),
    [anon_sym__Nonnull] = ACTIONS(4959),
    [anon_sym_mutable] = ACTIONS(4959),
    [anon_sym_constinit] = ACTIONS(4959),
    [anon_sym_consteval] = ACTIONS(4959),
    [anon_sym_alignas] = ACTIONS(4959),
    [anon_sym__Alignas] = ACTIONS(4959),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4961),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_and_eq] = ACTIONS(4959),
    [anon_sym_or_eq] = ACTIONS(4959),
    [anon_sym_xor_eq] = ACTIONS(4959),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4959),
    [anon_sym_and] = ACTIONS(4959),
    [anon_sym_bitor] = ACTIONS(4959),
    [anon_sym_xor] = ACTIONS(4959),
    [anon_sym_bitand] = ACTIONS(4959),
    [anon_sym_not_eq] = ACTIONS(4959),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4959),
    [anon_sym_decltype] = ACTIONS(4959),
    [anon_sym_final] = ACTIONS(4959),
    [anon_sym_override] = ACTIONS(4959),
  },
  [1600] = {
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4990),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_RPAREN] = ACTIONS(4990),
    [aux_sym_preproc_if_token2] = ACTIONS(4990),
    [aux_sym_preproc_else_token1] = ACTIONS(4990),
    [aux_sym_preproc_elif_token1] = ACTIONS(4988),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4990),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4990),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(4988),
    [anon_sym_SLASH] = ACTIONS(4988),
    [anon_sym_PERCENT] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym_EQ_EQ] = ACTIONS(4990),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4988),
    [anon_sym_GT_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4988),
    [anon_sym_GT_GT] = ACTIONS(4988),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym___attribute] = ACTIONS(4988),
    [anon_sym_COLON] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_RBRACE] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(4990),
    [anon_sym_RBRACK] = ACTIONS(4990),
    [anon_sym_EQ] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym__Nonnull] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym__Alignas] = ACTIONS(4988),
    [anon_sym_QMARK] = ACTIONS(4990),
    [anon_sym_STAR_EQ] = ACTIONS(4990),
    [anon_sym_SLASH_EQ] = ACTIONS(4990),
    [anon_sym_PERCENT_EQ] = ACTIONS(4990),
    [anon_sym_PLUS_EQ] = ACTIONS(4990),
    [anon_sym_DASH_EQ] = ACTIONS(4990),
    [anon_sym_LT_LT_EQ] = ACTIONS(4990),
    [anon_sym_GT_GT_EQ] = ACTIONS(4990),
    [anon_sym_AMP_EQ] = ACTIONS(4990),
    [anon_sym_CARET_EQ] = ACTIONS(4990),
    [anon_sym_PIPE_EQ] = ACTIONS(4990),
    [anon_sym_and_eq] = ACTIONS(4988),
    [anon_sym_or_eq] = ACTIONS(4988),
    [anon_sym_xor_eq] = ACTIONS(4988),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_and] = ACTIONS(4988),
    [anon_sym_bitor] = ACTIONS(4988),
    [anon_sym_xor] = ACTIONS(4988),
    [anon_sym_bitand] = ACTIONS(4988),
    [anon_sym_not_eq] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(4990),
    [anon_sym_PLUS_PLUS] = ACTIONS(4990),
    [anon_sym_DOT] = ACTIONS(4988),
    [anon_sym_DOT_STAR] = ACTIONS(4990),
    [anon_sym_DASH_GT] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_final] = ACTIONS(4988),
    [anon_sym_override] = ACTIONS(4988),
  },
  [1601] = {
    [sym_identifier] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_RPAREN] = ACTIONS(4986),
    [aux_sym_preproc_if_token2] = ACTIONS(4986),
    [aux_sym_preproc_else_token1] = ACTIONS(4986),
    [aux_sym_preproc_elif_token1] = ACTIONS(4984),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4986),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4986),
    [anon_sym_BANG_EQ] = ACTIONS(4986),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4986),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym_SEMI] = ACTIONS(4986),
    [anon_sym___extension__] = ACTIONS(4984),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_COLON] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(4986),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_LBRACK] = ACTIONS(4986),
    [anon_sym_RBRACK] = ACTIONS(4986),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym___restrict__] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym__Noreturn] = ACTIONS(4984),
    [anon_sym_noreturn] = ACTIONS(4984),
    [anon_sym__Nonnull] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_constinit] = ACTIONS(4984),
    [anon_sym_consteval] = ACTIONS(4984),
    [anon_sym_alignas] = ACTIONS(4984),
    [anon_sym__Alignas] = ACTIONS(4984),
    [anon_sym_QMARK] = ACTIONS(4986),
    [anon_sym_STAR_EQ] = ACTIONS(4986),
    [anon_sym_SLASH_EQ] = ACTIONS(4986),
    [anon_sym_PERCENT_EQ] = ACTIONS(4986),
    [anon_sym_PLUS_EQ] = ACTIONS(4986),
    [anon_sym_DASH_EQ] = ACTIONS(4986),
    [anon_sym_LT_LT_EQ] = ACTIONS(4986),
    [anon_sym_GT_GT_EQ] = ACTIONS(4986),
    [anon_sym_AMP_EQ] = ACTIONS(4986),
    [anon_sym_CARET_EQ] = ACTIONS(4986),
    [anon_sym_PIPE_EQ] = ACTIONS(4986),
    [anon_sym_and_eq] = ACTIONS(4984),
    [anon_sym_or_eq] = ACTIONS(4984),
    [anon_sym_xor_eq] = ACTIONS(4984),
    [anon_sym_LT_EQ_GT] = ACTIONS(4986),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(4986),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4986),
    [anon_sym_DASH_GT] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_final] = ACTIONS(4984),
    [anon_sym_override] = ACTIONS(4984),
  },
  [1602] = {
    [sym_identifier] = ACTIONS(4955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4957),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4957),
    [aux_sym_preproc_if_token2] = ACTIONS(4957),
    [aux_sym_preproc_else_token1] = ACTIONS(4957),
    [aux_sym_preproc_elif_token1] = ACTIONS(4955),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4957),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4957),
    [anon_sym_LPAREN2] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_SLASH] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4957),
    [anon_sym_AMP_AMP] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4955),
    [anon_sym_CARET] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4957),
    [anon_sym_BANG_EQ] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_GT_EQ] = ACTIONS(4957),
    [anon_sym_LT_EQ] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4955),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym___extension__] = ACTIONS(4955),
    [anon_sym___attribute__] = ACTIONS(4955),
    [anon_sym___attribute] = ACTIONS(4955),
    [anon_sym_COLON] = ACTIONS(4955),
    [anon_sym_COLON_COLON] = ACTIONS(4957),
    [anon_sym_LBRACE] = ACTIONS(4957),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4957),
    [anon_sym_RBRACK] = ACTIONS(4957),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_constexpr] = ACTIONS(4955),
    [anon_sym_volatile] = ACTIONS(4955),
    [anon_sym_restrict] = ACTIONS(4955),
    [anon_sym___restrict__] = ACTIONS(4955),
    [anon_sym__Atomic] = ACTIONS(4955),
    [anon_sym__Noreturn] = ACTIONS(4955),
    [anon_sym_noreturn] = ACTIONS(4955),
    [anon_sym__Nonnull] = ACTIONS(4955),
    [anon_sym_mutable] = ACTIONS(4955),
    [anon_sym_constinit] = ACTIONS(4955),
    [anon_sym_consteval] = ACTIONS(4955),
    [anon_sym_alignas] = ACTIONS(4955),
    [anon_sym__Alignas] = ACTIONS(4955),
    [anon_sym_QMARK] = ACTIONS(4957),
    [anon_sym_STAR_EQ] = ACTIONS(4957),
    [anon_sym_SLASH_EQ] = ACTIONS(4957),
    [anon_sym_PERCENT_EQ] = ACTIONS(4957),
    [anon_sym_PLUS_EQ] = ACTIONS(4957),
    [anon_sym_DASH_EQ] = ACTIONS(4957),
    [anon_sym_LT_LT_EQ] = ACTIONS(4957),
    [anon_sym_GT_GT_EQ] = ACTIONS(4957),
    [anon_sym_AMP_EQ] = ACTIONS(4957),
    [anon_sym_CARET_EQ] = ACTIONS(4957),
    [anon_sym_PIPE_EQ] = ACTIONS(4957),
    [anon_sym_and_eq] = ACTIONS(4955),
    [anon_sym_or_eq] = ACTIONS(4955),
    [anon_sym_xor_eq] = ACTIONS(4955),
    [anon_sym_LT_EQ_GT] = ACTIONS(4957),
    [anon_sym_or] = ACTIONS(4955),
    [anon_sym_and] = ACTIONS(4955),
    [anon_sym_bitor] = ACTIONS(4955),
    [anon_sym_xor] = ACTIONS(4955),
    [anon_sym_bitand] = ACTIONS(4955),
    [anon_sym_not_eq] = ACTIONS(4955),
    [anon_sym_DASH_DASH] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4957),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_DOT_STAR] = ACTIONS(4957),
    [anon_sym_DASH_GT] = ACTIONS(4957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4955),
    [anon_sym_decltype] = ACTIONS(4955),
    [anon_sym_final] = ACTIONS(4955),
    [anon_sym_override] = ACTIONS(4955),
  },
  [1603] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5003),
    [anon_sym_COMMA] = ACTIONS(5003),
    [anon_sym_RPAREN] = ACTIONS(5003),
    [anon_sym_LPAREN2] = ACTIONS(5003),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_STAR] = ACTIONS(5003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5003),
    [anon_sym_AMP_AMP] = ACTIONS(5003),
    [anon_sym_AMP] = ACTIONS(4996),
    [anon_sym_SEMI] = ACTIONS(5003),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_using] = ACTIONS(4996),
    [anon_sym_COLON] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5003),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym___cdecl] = ACTIONS(4996),
    [anon_sym___clrcall] = ACTIONS(4996),
    [anon_sym___stdcall] = ACTIONS(4996),
    [anon_sym___fastcall] = ACTIONS(4996),
    [anon_sym___thiscall] = ACTIONS(4996),
    [anon_sym___vectorcall] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_signed] = ACTIONS(4996),
    [anon_sym_unsigned] = ACTIONS(4996),
    [anon_sym_long] = ACTIONS(4996),
    [anon_sym_short] = ACTIONS(4996),
    [anon_sym_LBRACK] = ACTIONS(4996),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_EQ] = ACTIONS(5003),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym__Nonnull] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym__Alignas] = ACTIONS(4996),
    [sym_primitive_type] = ACTIONS(4996),
    [anon_sym_enum] = ACTIONS(4996),
    [anon_sym_class] = ACTIONS(4996),
    [anon_sym_struct] = ACTIONS(4996),
    [anon_sym_union] = ACTIONS(4996),
    [anon_sym_or] = ACTIONS(4996),
    [anon_sym_and] = ACTIONS(4996),
    [anon_sym_asm] = ACTIONS(4996),
    [anon_sym___asm__] = ACTIONS(4996),
    [anon_sym___asm] = ACTIONS(4996),
    [anon_sym_DASH_GT] = ACTIONS(5003),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_final] = ACTIONS(4996),
    [anon_sym_override] = ACTIONS(4996),
    [anon_sym_explicit] = ACTIONS(4996),
    [anon_sym_typename] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_GT2] = ACTIONS(5003),
    [anon_sym_operator] = ACTIONS(4996),
    [anon_sym_try] = ACTIONS(4996),
    [anon_sym_friend] = ACTIONS(4996),
    [anon_sym_noexcept] = ACTIONS(4996),
    [anon_sym_throw] = ACTIONS(4996),
    [anon_sym_concept] = ACTIONS(4996),
    [anon_sym_requires] = ACTIONS(4996),
  },
  [1604] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5000),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(4998),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(4998),
    [anon_sym_GT_GT] = ACTIONS(4998),
    [anon_sym_SEMI] = ACTIONS(5000),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5000),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym___cdecl] = ACTIONS(4996),
    [anon_sym___clrcall] = ACTIONS(4996),
    [anon_sym___stdcall] = ACTIONS(4996),
    [anon_sym___fastcall] = ACTIONS(4996),
    [anon_sym___thiscall] = ACTIONS(4996),
    [anon_sym___vectorcall] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_RBRACK] = ACTIONS(4998),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym__Nonnull] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym__Alignas] = ACTIONS(4996),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(5005),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(5005),
    [anon_sym_not_eq] = ACTIONS(5005),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
  },
  [1605] = {
    [sym_type_qualifier] = STATE(1626),
    [sym_alignas_qualifier] = STATE(1651),
    [aux_sym__type_definition_type_repeat1] = STATE(1626),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2552),
    [sym_identifier] = ACTIONS(5122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5100),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_RPAREN] = ACTIONS(5100),
    [anon_sym_LPAREN2] = ACTIONS(5100),
    [anon_sym_DASH] = ACTIONS(5102),
    [anon_sym_PLUS] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5102),
    [anon_sym_SLASH] = ACTIONS(5102),
    [anon_sym_PERCENT] = ACTIONS(5102),
    [anon_sym_PIPE_PIPE] = ACTIONS(5100),
    [anon_sym_AMP_AMP] = ACTIONS(5100),
    [anon_sym_PIPE] = ACTIONS(5102),
    [anon_sym_CARET] = ACTIONS(5102),
    [anon_sym_AMP] = ACTIONS(5102),
    [anon_sym_EQ_EQ] = ACTIONS(5100),
    [anon_sym_BANG_EQ] = ACTIONS(5100),
    [anon_sym_GT] = ACTIONS(5102),
    [anon_sym_GT_EQ] = ACTIONS(5100),
    [anon_sym_LT_EQ] = ACTIONS(5102),
    [anon_sym_LT] = ACTIONS(5102),
    [anon_sym_LT_LT] = ACTIONS(5102),
    [anon_sym_GT_GT] = ACTIONS(5102),
    [anon_sym___extension__] = ACTIONS(5124),
    [anon_sym___attribute__] = ACTIONS(5102),
    [anon_sym___attribute] = ACTIONS(5102),
    [anon_sym_LBRACE] = ACTIONS(5100),
    [anon_sym_signed] = ACTIONS(5126),
    [anon_sym_unsigned] = ACTIONS(5126),
    [anon_sym_long] = ACTIONS(5126),
    [anon_sym_short] = ACTIONS(5126),
    [anon_sym_LBRACK] = ACTIONS(5100),
    [anon_sym_EQ] = ACTIONS(5102),
    [anon_sym_const] = ACTIONS(5124),
    [anon_sym_constexpr] = ACTIONS(5124),
    [anon_sym_volatile] = ACTIONS(5124),
    [anon_sym_restrict] = ACTIONS(5124),
    [anon_sym___restrict__] = ACTIONS(5124),
    [anon_sym__Atomic] = ACTIONS(5124),
    [anon_sym__Noreturn] = ACTIONS(5124),
    [anon_sym_noreturn] = ACTIONS(5124),
    [anon_sym__Nonnull] = ACTIONS(5124),
    [anon_sym_mutable] = ACTIONS(5124),
    [anon_sym_constinit] = ACTIONS(5124),
    [anon_sym_consteval] = ACTIONS(5124),
    [anon_sym_alignas] = ACTIONS(5128),
    [anon_sym__Alignas] = ACTIONS(5128),
    [sym_primitive_type] = ACTIONS(5130),
    [anon_sym_QMARK] = ACTIONS(5100),
    [anon_sym_STAR_EQ] = ACTIONS(5100),
    [anon_sym_SLASH_EQ] = ACTIONS(5100),
    [anon_sym_PERCENT_EQ] = ACTIONS(5100),
    [anon_sym_PLUS_EQ] = ACTIONS(5100),
    [anon_sym_DASH_EQ] = ACTIONS(5100),
    [anon_sym_LT_LT_EQ] = ACTIONS(5100),
    [anon_sym_GT_GT_EQ] = ACTIONS(5100),
    [anon_sym_AMP_EQ] = ACTIONS(5100),
    [anon_sym_CARET_EQ] = ACTIONS(5100),
    [anon_sym_PIPE_EQ] = ACTIONS(5100),
    [anon_sym_and_eq] = ACTIONS(5102),
    [anon_sym_or_eq] = ACTIONS(5102),
    [anon_sym_xor_eq] = ACTIONS(5102),
    [anon_sym_LT_EQ_GT] = ACTIONS(5100),
    [anon_sym_or] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5102),
    [anon_sym_bitor] = ACTIONS(5102),
    [anon_sym_xor] = ACTIONS(5102),
    [anon_sym_bitand] = ACTIONS(5102),
    [anon_sym_not_eq] = ACTIONS(5102),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_DOT] = ACTIONS(5102),
    [anon_sym_DOT_STAR] = ACTIONS(5100),
    [anon_sym_DASH_GT] = ACTIONS(5102),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5102),
    [anon_sym_decltype] = ACTIONS(5102),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5100),
  },
  [1606] = {
    [sym_identifier] = ACTIONS(5132),
    [anon_sym_COMMA] = ACTIONS(5134),
    [anon_sym_RPAREN] = ACTIONS(5134),
    [anon_sym_LPAREN2] = ACTIONS(5134),
    [anon_sym_TILDE] = ACTIONS(5134),
    [anon_sym_STAR] = ACTIONS(5134),
    [anon_sym_PIPE_PIPE] = ACTIONS(5134),
    [anon_sym_AMP_AMP] = ACTIONS(5134),
    [anon_sym_AMP] = ACTIONS(5132),
    [anon_sym_SEMI] = ACTIONS(5134),
    [anon_sym___extension__] = ACTIONS(5132),
    [anon_sym_virtual] = ACTIONS(5132),
    [anon_sym_extern] = ACTIONS(5132),
    [anon_sym___attribute__] = ACTIONS(5132),
    [anon_sym___attribute] = ACTIONS(5132),
    [anon_sym_using] = ACTIONS(5132),
    [anon_sym_COLON_COLON] = ACTIONS(5134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5134),
    [anon_sym___declspec] = ACTIONS(5132),
    [anon_sym___based] = ACTIONS(5132),
    [anon_sym___cdecl] = ACTIONS(5132),
    [anon_sym___clrcall] = ACTIONS(5132),
    [anon_sym___stdcall] = ACTIONS(5132),
    [anon_sym___fastcall] = ACTIONS(5132),
    [anon_sym___thiscall] = ACTIONS(5132),
    [anon_sym___vectorcall] = ACTIONS(5132),
    [anon_sym_LBRACE] = ACTIONS(5134),
    [anon_sym_signed] = ACTIONS(5132),
    [anon_sym_unsigned] = ACTIONS(5132),
    [anon_sym_long] = ACTIONS(5132),
    [anon_sym_short] = ACTIONS(5132),
    [anon_sym_LBRACK] = ACTIONS(5132),
    [anon_sym_static] = ACTIONS(5132),
    [anon_sym_EQ] = ACTIONS(5134),
    [anon_sym_register] = ACTIONS(5132),
    [anon_sym_inline] = ACTIONS(5132),
    [anon_sym___inline] = ACTIONS(5132),
    [anon_sym___inline__] = ACTIONS(5132),
    [anon_sym___forceinline] = ACTIONS(5132),
    [anon_sym_thread_local] = ACTIONS(5132),
    [anon_sym___thread] = ACTIONS(5132),
    [anon_sym_const] = ACTIONS(5132),
    [anon_sym_constexpr] = ACTIONS(5132),
    [anon_sym_volatile] = ACTIONS(5132),
    [anon_sym_restrict] = ACTIONS(5132),
    [anon_sym___restrict__] = ACTIONS(5132),
    [anon_sym__Atomic] = ACTIONS(5132),
    [anon_sym__Noreturn] = ACTIONS(5132),
    [anon_sym_noreturn] = ACTIONS(5132),
    [anon_sym__Nonnull] = ACTIONS(5132),
    [anon_sym_mutable] = ACTIONS(5132),
    [anon_sym_constinit] = ACTIONS(5132),
    [anon_sym_consteval] = ACTIONS(5132),
    [anon_sym_alignas] = ACTIONS(5132),
    [anon_sym__Alignas] = ACTIONS(5132),
    [sym_primitive_type] = ACTIONS(5132),
    [anon_sym_enum] = ACTIONS(5132),
    [anon_sym_class] = ACTIONS(5132),
    [anon_sym_struct] = ACTIONS(5132),
    [anon_sym_union] = ACTIONS(5132),
    [anon_sym_or] = ACTIONS(5132),
    [anon_sym_and] = ACTIONS(5132),
    [anon_sym_asm] = ACTIONS(5132),
    [anon_sym___asm__] = ACTIONS(5132),
    [anon_sym___asm] = ACTIONS(5132),
    [anon_sym_DASH_GT] = ACTIONS(5134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5132),
    [anon_sym_decltype] = ACTIONS(5132),
    [anon_sym_final] = ACTIONS(5132),
    [anon_sym_override] = ACTIONS(5132),
    [anon_sym_explicit] = ACTIONS(5132),
    [anon_sym_typename] = ACTIONS(5132),
    [anon_sym_template] = ACTIONS(5132),
    [anon_sym_GT2] = ACTIONS(5134),
    [anon_sym_operator] = ACTIONS(5132),
    [anon_sym_try] = ACTIONS(5132),
    [anon_sym_friend] = ACTIONS(5132),
    [anon_sym_noexcept] = ACTIONS(5132),
    [anon_sym_throw] = ACTIONS(5132),
    [anon_sym_concept] = ACTIONS(5132),
    [anon_sym_requires] = ACTIONS(5132),
  },
  [1607] = {
    [sym_identifier] = ACTIONS(5136),
    [anon_sym_COMMA] = ACTIONS(5138),
    [anon_sym_RPAREN] = ACTIONS(5138),
    [anon_sym_LPAREN2] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5138),
    [anon_sym_AMP_AMP] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5136),
    [anon_sym_SEMI] = ACTIONS(5138),
    [anon_sym___extension__] = ACTIONS(5136),
    [anon_sym_virtual] = ACTIONS(5136),
    [anon_sym_extern] = ACTIONS(5136),
    [anon_sym___attribute__] = ACTIONS(5136),
    [anon_sym___attribute] = ACTIONS(5136),
    [anon_sym_using] = ACTIONS(5136),
    [anon_sym_COLON_COLON] = ACTIONS(5138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5138),
    [anon_sym___declspec] = ACTIONS(5136),
    [anon_sym___based] = ACTIONS(5136),
    [anon_sym___cdecl] = ACTIONS(5136),
    [anon_sym___clrcall] = ACTIONS(5136),
    [anon_sym___stdcall] = ACTIONS(5136),
    [anon_sym___fastcall] = ACTIONS(5136),
    [anon_sym___thiscall] = ACTIONS(5136),
    [anon_sym___vectorcall] = ACTIONS(5136),
    [anon_sym_LBRACE] = ACTIONS(5138),
    [anon_sym_signed] = ACTIONS(5136),
    [anon_sym_unsigned] = ACTIONS(5136),
    [anon_sym_long] = ACTIONS(5136),
    [anon_sym_short] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(5136),
    [anon_sym_static] = ACTIONS(5136),
    [anon_sym_EQ] = ACTIONS(5138),
    [anon_sym_register] = ACTIONS(5136),
    [anon_sym_inline] = ACTIONS(5136),
    [anon_sym___inline] = ACTIONS(5136),
    [anon_sym___inline__] = ACTIONS(5136),
    [anon_sym___forceinline] = ACTIONS(5136),
    [anon_sym_thread_local] = ACTIONS(5136),
    [anon_sym___thread] = ACTIONS(5136),
    [anon_sym_const] = ACTIONS(5136),
    [anon_sym_constexpr] = ACTIONS(5136),
    [anon_sym_volatile] = ACTIONS(5136),
    [anon_sym_restrict] = ACTIONS(5136),
    [anon_sym___restrict__] = ACTIONS(5136),
    [anon_sym__Atomic] = ACTIONS(5136),
    [anon_sym__Noreturn] = ACTIONS(5136),
    [anon_sym_noreturn] = ACTIONS(5136),
    [anon_sym__Nonnull] = ACTIONS(5136),
    [anon_sym_mutable] = ACTIONS(5136),
    [anon_sym_constinit] = ACTIONS(5136),
    [anon_sym_consteval] = ACTIONS(5136),
    [anon_sym_alignas] = ACTIONS(5136),
    [anon_sym__Alignas] = ACTIONS(5136),
    [sym_primitive_type] = ACTIONS(5136),
    [anon_sym_enum] = ACTIONS(5136),
    [anon_sym_class] = ACTIONS(5136),
    [anon_sym_struct] = ACTIONS(5136),
    [anon_sym_union] = ACTIONS(5136),
    [anon_sym_or] = ACTIONS(5136),
    [anon_sym_and] = ACTIONS(5136),
    [anon_sym_asm] = ACTIONS(5136),
    [anon_sym___asm__] = ACTIONS(5136),
    [anon_sym___asm] = ACTIONS(5136),
    [anon_sym_DASH_GT] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5136),
    [anon_sym_decltype] = ACTIONS(5136),
    [anon_sym_final] = ACTIONS(5136),
    [anon_sym_override] = ACTIONS(5136),
    [anon_sym_explicit] = ACTIONS(5136),
    [anon_sym_typename] = ACTIONS(5136),
    [anon_sym_template] = ACTIONS(5136),
    [anon_sym_GT2] = ACTIONS(5138),
    [anon_sym_operator] = ACTIONS(5136),
    [anon_sym_try] = ACTIONS(5136),
    [anon_sym_friend] = ACTIONS(5136),
    [anon_sym_noexcept] = ACTIONS(5136),
    [anon_sym_throw] = ACTIONS(5136),
    [anon_sym_concept] = ACTIONS(5136),
    [anon_sym_requires] = ACTIONS(5136),
  },
  [1608] = {
    [sym_identifier] = ACTIONS(5140),
    [anon_sym_COMMA] = ACTIONS(5142),
    [anon_sym_RPAREN] = ACTIONS(5142),
    [anon_sym_LPAREN2] = ACTIONS(5142),
    [anon_sym_TILDE] = ACTIONS(5142),
    [anon_sym_STAR] = ACTIONS(5142),
    [anon_sym_PIPE_PIPE] = ACTIONS(5142),
    [anon_sym_AMP_AMP] = ACTIONS(5142),
    [anon_sym_AMP] = ACTIONS(5140),
    [anon_sym_SEMI] = ACTIONS(5142),
    [anon_sym___extension__] = ACTIONS(5140),
    [anon_sym_virtual] = ACTIONS(5140),
    [anon_sym_extern] = ACTIONS(5140),
    [anon_sym___attribute__] = ACTIONS(5140),
    [anon_sym___attribute] = ACTIONS(5140),
    [anon_sym_using] = ACTIONS(5140),
    [anon_sym_COLON_COLON] = ACTIONS(5142),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5142),
    [anon_sym___declspec] = ACTIONS(5140),
    [anon_sym___based] = ACTIONS(5140),
    [anon_sym___cdecl] = ACTIONS(5140),
    [anon_sym___clrcall] = ACTIONS(5140),
    [anon_sym___stdcall] = ACTIONS(5140),
    [anon_sym___fastcall] = ACTIONS(5140),
    [anon_sym___thiscall] = ACTIONS(5140),
    [anon_sym___vectorcall] = ACTIONS(5140),
    [anon_sym_LBRACE] = ACTIONS(5142),
    [anon_sym_signed] = ACTIONS(5140),
    [anon_sym_unsigned] = ACTIONS(5140),
    [anon_sym_long] = ACTIONS(5140),
    [anon_sym_short] = ACTIONS(5140),
    [anon_sym_LBRACK] = ACTIONS(5140),
    [anon_sym_static] = ACTIONS(5140),
    [anon_sym_EQ] = ACTIONS(5142),
    [anon_sym_register] = ACTIONS(5140),
    [anon_sym_inline] = ACTIONS(5140),
    [anon_sym___inline] = ACTIONS(5140),
    [anon_sym___inline__] = ACTIONS(5140),
    [anon_sym___forceinline] = ACTIONS(5140),
    [anon_sym_thread_local] = ACTIONS(5140),
    [anon_sym___thread] = ACTIONS(5140),
    [anon_sym_const] = ACTIONS(5140),
    [anon_sym_constexpr] = ACTIONS(5140),
    [anon_sym_volatile] = ACTIONS(5140),
    [anon_sym_restrict] = ACTIONS(5140),
    [anon_sym___restrict__] = ACTIONS(5140),
    [anon_sym__Atomic] = ACTIONS(5140),
    [anon_sym__Noreturn] = ACTIONS(5140),
    [anon_sym_noreturn] = ACTIONS(5140),
    [anon_sym__Nonnull] = ACTIONS(5140),
    [anon_sym_mutable] = ACTIONS(5140),
    [anon_sym_constinit] = ACTIONS(5140),
    [anon_sym_consteval] = ACTIONS(5140),
    [anon_sym_alignas] = ACTIONS(5140),
    [anon_sym__Alignas] = ACTIONS(5140),
    [sym_primitive_type] = ACTIONS(5140),
    [anon_sym_enum] = ACTIONS(5140),
    [anon_sym_class] = ACTIONS(5140),
    [anon_sym_struct] = ACTIONS(5140),
    [anon_sym_union] = ACTIONS(5140),
    [anon_sym_or] = ACTIONS(5140),
    [anon_sym_and] = ACTIONS(5140),
    [anon_sym_asm] = ACTIONS(5140),
    [anon_sym___asm__] = ACTIONS(5140),
    [anon_sym___asm] = ACTIONS(5140),
    [anon_sym_DASH_GT] = ACTIONS(5142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5140),
    [anon_sym_decltype] = ACTIONS(5140),
    [anon_sym_final] = ACTIONS(5140),
    [anon_sym_override] = ACTIONS(5140),
    [anon_sym_explicit] = ACTIONS(5140),
    [anon_sym_typename] = ACTIONS(5140),
    [anon_sym_template] = ACTIONS(5140),
    [anon_sym_GT2] = ACTIONS(5142),
    [anon_sym_operator] = ACTIONS(5140),
    [anon_sym_try] = ACTIONS(5140),
    [anon_sym_friend] = ACTIONS(5140),
    [anon_sym_noexcept] = ACTIONS(5140),
    [anon_sym_throw] = ACTIONS(5140),
    [anon_sym_concept] = ACTIONS(5140),
    [anon_sym_requires] = ACTIONS(5140),
  },
  [1609] = {
    [sym_identifier] = ACTIONS(5136),
    [anon_sym_COMMA] = ACTIONS(5138),
    [anon_sym_RPAREN] = ACTIONS(5138),
    [anon_sym_LPAREN2] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5138),
    [anon_sym_AMP_AMP] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5136),
    [anon_sym_SEMI] = ACTIONS(5138),
    [anon_sym___extension__] = ACTIONS(5136),
    [anon_sym_virtual] = ACTIONS(5136),
    [anon_sym_extern] = ACTIONS(5136),
    [anon_sym___attribute__] = ACTIONS(5136),
    [anon_sym___attribute] = ACTIONS(5136),
    [anon_sym_using] = ACTIONS(5136),
    [anon_sym_COLON_COLON] = ACTIONS(5138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5138),
    [anon_sym___declspec] = ACTIONS(5136),
    [anon_sym___based] = ACTIONS(5136),
    [anon_sym___cdecl] = ACTIONS(5136),
    [anon_sym___clrcall] = ACTIONS(5136),
    [anon_sym___stdcall] = ACTIONS(5136),
    [anon_sym___fastcall] = ACTIONS(5136),
    [anon_sym___thiscall] = ACTIONS(5136),
    [anon_sym___vectorcall] = ACTIONS(5136),
    [anon_sym_LBRACE] = ACTIONS(5138),
    [anon_sym_signed] = ACTIONS(5136),
    [anon_sym_unsigned] = ACTIONS(5136),
    [anon_sym_long] = ACTIONS(5136),
    [anon_sym_short] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(5136),
    [anon_sym_static] = ACTIONS(5136),
    [anon_sym_EQ] = ACTIONS(5138),
    [anon_sym_register] = ACTIONS(5136),
    [anon_sym_inline] = ACTIONS(5136),
    [anon_sym___inline] = ACTIONS(5136),
    [anon_sym___inline__] = ACTIONS(5136),
    [anon_sym___forceinline] = ACTIONS(5136),
    [anon_sym_thread_local] = ACTIONS(5136),
    [anon_sym___thread] = ACTIONS(5136),
    [anon_sym_const] = ACTIONS(5136),
    [anon_sym_constexpr] = ACTIONS(5136),
    [anon_sym_volatile] = ACTIONS(5136),
    [anon_sym_restrict] = ACTIONS(5136),
    [anon_sym___restrict__] = ACTIONS(5136),
    [anon_sym__Atomic] = ACTIONS(5136),
    [anon_sym__Noreturn] = ACTIONS(5136),
    [anon_sym_noreturn] = ACTIONS(5136),
    [anon_sym__Nonnull] = ACTIONS(5136),
    [anon_sym_mutable] = ACTIONS(5136),
    [anon_sym_constinit] = ACTIONS(5136),
    [anon_sym_consteval] = ACTIONS(5136),
    [anon_sym_alignas] = ACTIONS(5136),
    [anon_sym__Alignas] = ACTIONS(5136),
    [sym_primitive_type] = ACTIONS(5136),
    [anon_sym_enum] = ACTIONS(5136),
    [anon_sym_class] = ACTIONS(5136),
    [anon_sym_struct] = ACTIONS(5136),
    [anon_sym_union] = ACTIONS(5136),
    [anon_sym_or] = ACTIONS(5136),
    [anon_sym_and] = ACTIONS(5136),
    [anon_sym_asm] = ACTIONS(5136),
    [anon_sym___asm__] = ACTIONS(5136),
    [anon_sym___asm] = ACTIONS(5136),
    [anon_sym_DASH_GT] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5136),
    [anon_sym_decltype] = ACTIONS(5136),
    [anon_sym_final] = ACTIONS(5136),
    [anon_sym_override] = ACTIONS(5136),
    [anon_sym_explicit] = ACTIONS(5136),
    [anon_sym_typename] = ACTIONS(5136),
    [anon_sym_template] = ACTIONS(5136),
    [anon_sym_GT2] = ACTIONS(5138),
    [anon_sym_operator] = ACTIONS(5136),
    [anon_sym_try] = ACTIONS(5136),
    [anon_sym_friend] = ACTIONS(5136),
    [anon_sym_noexcept] = ACTIONS(5136),
    [anon_sym_throw] = ACTIONS(5136),
    [anon_sym_concept] = ACTIONS(5136),
    [anon_sym_requires] = ACTIONS(5136),
  },
  [1610] = {
    [sym_identifier] = ACTIONS(5136),
    [anon_sym_COMMA] = ACTIONS(5138),
    [anon_sym_RPAREN] = ACTIONS(5138),
    [anon_sym_LPAREN2] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [anon_sym_STAR] = ACTIONS(5138),
    [anon_sym_PIPE_PIPE] = ACTIONS(5138),
    [anon_sym_AMP_AMP] = ACTIONS(5138),
    [anon_sym_AMP] = ACTIONS(5136),
    [anon_sym_SEMI] = ACTIONS(5138),
    [anon_sym___extension__] = ACTIONS(5136),
    [anon_sym_virtual] = ACTIONS(5136),
    [anon_sym_extern] = ACTIONS(5136),
    [anon_sym___attribute__] = ACTIONS(5136),
    [anon_sym___attribute] = ACTIONS(5136),
    [anon_sym_using] = ACTIONS(5136),
    [anon_sym_COLON_COLON] = ACTIONS(5138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5138),
    [anon_sym___declspec] = ACTIONS(5136),
    [anon_sym___based] = ACTIONS(5136),
    [anon_sym___cdecl] = ACTIONS(5136),
    [anon_sym___clrcall] = ACTIONS(5136),
    [anon_sym___stdcall] = ACTIONS(5136),
    [anon_sym___fastcall] = ACTIONS(5136),
    [anon_sym___thiscall] = ACTIONS(5136),
    [anon_sym___vectorcall] = ACTIONS(5136),
    [anon_sym_LBRACE] = ACTIONS(5138),
    [anon_sym_signed] = ACTIONS(5136),
    [anon_sym_unsigned] = ACTIONS(5136),
    [anon_sym_long] = ACTIONS(5136),
    [anon_sym_short] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(5136),
    [anon_sym_static] = ACTIONS(5136),
    [anon_sym_EQ] = ACTIONS(5138),
    [anon_sym_register] = ACTIONS(5136),
    [anon_sym_inline] = ACTIONS(5136),
    [anon_sym___inline] = ACTIONS(5136),
    [anon_sym___inline__] = ACTIONS(5136),
    [anon_sym___forceinline] = ACTIONS(5136),
    [anon_sym_thread_local] = ACTIONS(5136),
    [anon_sym___thread] = ACTIONS(5136),
    [anon_sym_const] = ACTIONS(5136),
    [anon_sym_constexpr] = ACTIONS(5136),
    [anon_sym_volatile] = ACTIONS(5136),
    [anon_sym_restrict] = ACTIONS(5136),
    [anon_sym___restrict__] = ACTIONS(5136),
    [anon_sym__Atomic] = ACTIONS(5136),
    [anon_sym__Noreturn] = ACTIONS(5136),
    [anon_sym_noreturn] = ACTIONS(5136),
    [anon_sym__Nonnull] = ACTIONS(5136),
    [anon_sym_mutable] = ACTIONS(5136),
    [anon_sym_constinit] = ACTIONS(5136),
    [anon_sym_consteval] = ACTIONS(5136),
    [anon_sym_alignas] = ACTIONS(5136),
    [anon_sym__Alignas] = ACTIONS(5136),
    [sym_primitive_type] = ACTIONS(5136),
    [anon_sym_enum] = ACTIONS(5136),
    [anon_sym_class] = ACTIONS(5136),
    [anon_sym_struct] = ACTIONS(5136),
    [anon_sym_union] = ACTIONS(5136),
    [anon_sym_or] = ACTIONS(5136),
    [anon_sym_and] = ACTIONS(5136),
    [anon_sym_asm] = ACTIONS(5136),
    [anon_sym___asm__] = ACTIONS(5136),
    [anon_sym___asm] = ACTIONS(5136),
    [anon_sym_DASH_GT] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5136),
    [anon_sym_decltype] = ACTIONS(5136),
    [anon_sym_final] = ACTIONS(5136),
    [anon_sym_override] = ACTIONS(5136),
    [anon_sym_explicit] = ACTIONS(5136),
    [anon_sym_typename] = ACTIONS(5136),
    [anon_sym_template] = ACTIONS(5136),
    [anon_sym_GT2] = ACTIONS(5138),
    [anon_sym_operator] = ACTIONS(5136),
    [anon_sym_try] = ACTIONS(5136),
    [anon_sym_friend] = ACTIONS(5136),
    [anon_sym_noexcept] = ACTIONS(5136),
    [anon_sym_throw] = ACTIONS(5136),
    [anon_sym_concept] = ACTIONS(5136),
    [anon_sym_requires] = ACTIONS(5136),
  },
  [1611] = {
    [sym_identifier] = ACTIONS(5144),
    [anon_sym_COMMA] = ACTIONS(5146),
    [anon_sym_RPAREN] = ACTIONS(5146),
    [anon_sym_LPAREN2] = ACTIONS(5146),
    [anon_sym_TILDE] = ACTIONS(5146),
    [anon_sym_STAR] = ACTIONS(5146),
    [anon_sym_PIPE_PIPE] = ACTIONS(5146),
    [anon_sym_AMP_AMP] = ACTIONS(5146),
    [anon_sym_AMP] = ACTIONS(5144),
    [anon_sym_SEMI] = ACTIONS(5146),
    [anon_sym___extension__] = ACTIONS(5144),
    [anon_sym_virtual] = ACTIONS(5144),
    [anon_sym_extern] = ACTIONS(5144),
    [anon_sym___attribute__] = ACTIONS(5144),
    [anon_sym___attribute] = ACTIONS(5144),
    [anon_sym_using] = ACTIONS(5144),
    [anon_sym_COLON_COLON] = ACTIONS(5146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5146),
    [anon_sym___declspec] = ACTIONS(5144),
    [anon_sym___based] = ACTIONS(5144),
    [anon_sym___cdecl] = ACTIONS(5144),
    [anon_sym___clrcall] = ACTIONS(5144),
    [anon_sym___stdcall] = ACTIONS(5144),
    [anon_sym___fastcall] = ACTIONS(5144),
    [anon_sym___thiscall] = ACTIONS(5144),
    [anon_sym___vectorcall] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(5146),
    [anon_sym_signed] = ACTIONS(5144),
    [anon_sym_unsigned] = ACTIONS(5144),
    [anon_sym_long] = ACTIONS(5144),
    [anon_sym_short] = ACTIONS(5144),
    [anon_sym_LBRACK] = ACTIONS(5144),
    [anon_sym_static] = ACTIONS(5144),
    [anon_sym_EQ] = ACTIONS(5146),
    [anon_sym_register] = ACTIONS(5144),
    [anon_sym_inline] = ACTIONS(5144),
    [anon_sym___inline] = ACTIONS(5144),
    [anon_sym___inline__] = ACTIONS(5144),
    [anon_sym___forceinline] = ACTIONS(5144),
    [anon_sym_thread_local] = ACTIONS(5144),
    [anon_sym___thread] = ACTIONS(5144),
    [anon_sym_const] = ACTIONS(5144),
    [anon_sym_constexpr] = ACTIONS(5144),
    [anon_sym_volatile] = ACTIONS(5144),
    [anon_sym_restrict] = ACTIONS(5144),
    [anon_sym___restrict__] = ACTIONS(5144),
    [anon_sym__Atomic] = ACTIONS(5144),
    [anon_sym__Noreturn] = ACTIONS(5144),
    [anon_sym_noreturn] = ACTIONS(5144),
    [anon_sym__Nonnull] = ACTIONS(5144),
    [anon_sym_mutable] = ACTIONS(5144),
    [anon_sym_constinit] = ACTIONS(5144),
    [anon_sym_consteval] = ACTIONS(5144),
    [anon_sym_alignas] = ACTIONS(5144),
    [anon_sym__Alignas] = ACTIONS(5144),
    [sym_primitive_type] = ACTIONS(5144),
    [anon_sym_enum] = ACTIONS(5144),
    [anon_sym_class] = ACTIONS(5144),
    [anon_sym_struct] = ACTIONS(5144),
    [anon_sym_union] = ACTIONS(5144),
    [anon_sym_or] = ACTIONS(5144),
    [anon_sym_and] = ACTIONS(5144),
    [anon_sym_asm] = ACTIONS(5144),
    [anon_sym___asm__] = ACTIONS(5144),
    [anon_sym___asm] = ACTIONS(5144),
    [anon_sym_DASH_GT] = ACTIONS(5146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5144),
    [anon_sym_decltype] = ACTIONS(5144),
    [anon_sym_final] = ACTIONS(5144),
    [anon_sym_override] = ACTIONS(5144),
    [anon_sym_explicit] = ACTIONS(5144),
    [anon_sym_typename] = ACTIONS(5144),
    [anon_sym_template] = ACTIONS(5144),
    [anon_sym_GT2] = ACTIONS(5146),
    [anon_sym_operator] = ACTIONS(5144),
    [anon_sym_try] = ACTIONS(5144),
    [anon_sym_friend] = ACTIONS(5144),
    [anon_sym_noexcept] = ACTIONS(5144),
    [anon_sym_throw] = ACTIONS(5144),
    [anon_sym_concept] = ACTIONS(5144),
    [anon_sym_requires] = ACTIONS(5144),
  },
  [1612] = {
    [sym_identifier] = ACTIONS(5148),
    [anon_sym_COMMA] = ACTIONS(5150),
    [anon_sym_RPAREN] = ACTIONS(5150),
    [anon_sym_LPAREN2] = ACTIONS(5150),
    [anon_sym_TILDE] = ACTIONS(5150),
    [anon_sym_STAR] = ACTIONS(5150),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_AMP] = ACTIONS(5148),
    [anon_sym_SEMI] = ACTIONS(5150),
    [anon_sym___extension__] = ACTIONS(5148),
    [anon_sym_virtual] = ACTIONS(5148),
    [anon_sym_extern] = ACTIONS(5148),
    [anon_sym___attribute__] = ACTIONS(5148),
    [anon_sym___attribute] = ACTIONS(5148),
    [anon_sym_using] = ACTIONS(5148),
    [anon_sym_COLON_COLON] = ACTIONS(5150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5150),
    [anon_sym___declspec] = ACTIONS(5148),
    [anon_sym___based] = ACTIONS(5148),
    [anon_sym___cdecl] = ACTIONS(5148),
    [anon_sym___clrcall] = ACTIONS(5148),
    [anon_sym___stdcall] = ACTIONS(5148),
    [anon_sym___fastcall] = ACTIONS(5148),
    [anon_sym___thiscall] = ACTIONS(5148),
    [anon_sym___vectorcall] = ACTIONS(5148),
    [anon_sym_LBRACE] = ACTIONS(5150),
    [anon_sym_signed] = ACTIONS(5148),
    [anon_sym_unsigned] = ACTIONS(5148),
    [anon_sym_long] = ACTIONS(5148),
    [anon_sym_short] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5148),
    [anon_sym_static] = ACTIONS(5148),
    [anon_sym_EQ] = ACTIONS(5150),
    [anon_sym_register] = ACTIONS(5148),
    [anon_sym_inline] = ACTIONS(5148),
    [anon_sym___inline] = ACTIONS(5148),
    [anon_sym___inline__] = ACTIONS(5148),
    [anon_sym___forceinline] = ACTIONS(5148),
    [anon_sym_thread_local] = ACTIONS(5148),
    [anon_sym___thread] = ACTIONS(5148),
    [anon_sym_const] = ACTIONS(5148),
    [anon_sym_constexpr] = ACTIONS(5148),
    [anon_sym_volatile] = ACTIONS(5148),
    [anon_sym_restrict] = ACTIONS(5148),
    [anon_sym___restrict__] = ACTIONS(5148),
    [anon_sym__Atomic] = ACTIONS(5148),
    [anon_sym__Noreturn] = ACTIONS(5148),
    [anon_sym_noreturn] = ACTIONS(5148),
    [anon_sym__Nonnull] = ACTIONS(5148),
    [anon_sym_mutable] = ACTIONS(5148),
    [anon_sym_constinit] = ACTIONS(5148),
    [anon_sym_consteval] = ACTIONS(5148),
    [anon_sym_alignas] = ACTIONS(5148),
    [anon_sym__Alignas] = ACTIONS(5148),
    [sym_primitive_type] = ACTIONS(5148),
    [anon_sym_enum] = ACTIONS(5148),
    [anon_sym_class] = ACTIONS(5148),
    [anon_sym_struct] = ACTIONS(5148),
    [anon_sym_union] = ACTIONS(5148),
    [anon_sym_or] = ACTIONS(5148),
    [anon_sym_and] = ACTIONS(5148),
    [anon_sym_asm] = ACTIONS(5148),
    [anon_sym___asm__] = ACTIONS(5148),
    [anon_sym___asm] = ACTIONS(5148),
    [anon_sym_DASH_GT] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5148),
    [anon_sym_decltype] = ACTIONS(5148),
    [anon_sym_final] = ACTIONS(5148),
    [anon_sym_override] = ACTIONS(5148),
    [anon_sym_explicit] = ACTIONS(5148),
    [anon_sym_typename] = ACTIONS(5148),
    [anon_sym_template] = ACTIONS(5148),
    [anon_sym_GT2] = ACTIONS(5150),
    [anon_sym_operator] = ACTIONS(5148),
    [anon_sym_try] = ACTIONS(5148),
    [anon_sym_friend] = ACTIONS(5148),
    [anon_sym_noexcept] = ACTIONS(5148),
    [anon_sym_throw] = ACTIONS(5148),
    [anon_sym_concept] = ACTIONS(5148),
    [anon_sym_requires] = ACTIONS(5148),
  },
  [1613] = {
    [sym_identifier] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5154),
    [anon_sym_RPAREN] = ACTIONS(5154),
    [anon_sym_LPAREN2] = ACTIONS(5154),
    [anon_sym_TILDE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5154),
    [anon_sym_PIPE_PIPE] = ACTIONS(5154),
    [anon_sym_AMP_AMP] = ACTIONS(5154),
    [anon_sym_AMP] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(5154),
    [anon_sym___extension__] = ACTIONS(5152),
    [anon_sym_virtual] = ACTIONS(5152),
    [anon_sym_extern] = ACTIONS(5152),
    [anon_sym___attribute__] = ACTIONS(5152),
    [anon_sym___attribute] = ACTIONS(5152),
    [anon_sym_using] = ACTIONS(5152),
    [anon_sym_COLON_COLON] = ACTIONS(5154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5154),
    [anon_sym___declspec] = ACTIONS(5152),
    [anon_sym___based] = ACTIONS(5152),
    [anon_sym___cdecl] = ACTIONS(5152),
    [anon_sym___clrcall] = ACTIONS(5152),
    [anon_sym___stdcall] = ACTIONS(5152),
    [anon_sym___fastcall] = ACTIONS(5152),
    [anon_sym___thiscall] = ACTIONS(5152),
    [anon_sym___vectorcall] = ACTIONS(5152),
    [anon_sym_LBRACE] = ACTIONS(5154),
    [anon_sym_signed] = ACTIONS(5152),
    [anon_sym_unsigned] = ACTIONS(5152),
    [anon_sym_long] = ACTIONS(5152),
    [anon_sym_short] = ACTIONS(5152),
    [anon_sym_LBRACK] = ACTIONS(5152),
    [anon_sym_static] = ACTIONS(5152),
    [anon_sym_EQ] = ACTIONS(5154),
    [anon_sym_register] = ACTIONS(5152),
    [anon_sym_inline] = ACTIONS(5152),
    [anon_sym___inline] = ACTIONS(5152),
    [anon_sym___inline__] = ACTIONS(5152),
    [anon_sym___forceinline] = ACTIONS(5152),
    [anon_sym_thread_local] = ACTIONS(5152),
    [anon_sym___thread] = ACTIONS(5152),
    [anon_sym_const] = ACTIONS(5152),
    [anon_sym_constexpr] = ACTIONS(5152),
    [anon_sym_volatile] = ACTIONS(5152),
    [anon_sym_restrict] = ACTIONS(5152),
    [anon_sym___restrict__] = ACTIONS(5152),
    [anon_sym__Atomic] = ACTIONS(5152),
    [anon_sym__Noreturn] = ACTIONS(5152),
    [anon_sym_noreturn] = ACTIONS(5152),
    [anon_sym__Nonnull] = ACTIONS(5152),
    [anon_sym_mutable] = ACTIONS(5152),
    [anon_sym_constinit] = ACTIONS(5152),
    [anon_sym_consteval] = ACTIONS(5152),
    [anon_sym_alignas] = ACTIONS(5152),
    [anon_sym__Alignas] = ACTIONS(5152),
    [sym_primitive_type] = ACTIONS(5152),
    [anon_sym_enum] = ACTIONS(5152),
    [anon_sym_class] = ACTIONS(5152),
    [anon_sym_struct] = ACTIONS(5152),
    [anon_sym_union] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5152),
    [anon_sym_and] = ACTIONS(5152),
    [anon_sym_asm] = ACTIONS(5152),
    [anon_sym___asm__] = ACTIONS(5152),
    [anon_sym___asm] = ACTIONS(5152),
    [anon_sym_DASH_GT] = ACTIONS(5154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5152),
    [anon_sym_decltype] = ACTIONS(5152),
    [anon_sym_final] = ACTIONS(5152),
    [anon_sym_override] = ACTIONS(5152),
    [anon_sym_explicit] = ACTIONS(5152),
    [anon_sym_typename] = ACTIONS(5152),
    [anon_sym_template] = ACTIONS(5152),
    [anon_sym_GT2] = ACTIONS(5154),
    [anon_sym_operator] = ACTIONS(5152),
    [anon_sym_try] = ACTIONS(5152),
    [anon_sym_friend] = ACTIONS(5152),
    [anon_sym_noexcept] = ACTIONS(5152),
    [anon_sym_throw] = ACTIONS(5152),
    [anon_sym_concept] = ACTIONS(5152),
    [anon_sym_requires] = ACTIONS(5152),
  },
  [1614] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1585),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5156),
    [anon_sym_COMMA] = ACTIONS(5156),
    [anon_sym_RPAREN] = ACTIONS(5156),
    [anon_sym_LPAREN2] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5159),
    [anon_sym_STAR] = ACTIONS(5159),
    [anon_sym_SLASH] = ACTIONS(5159),
    [anon_sym_PERCENT] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5156),
    [anon_sym_AMP_AMP] = ACTIONS(5156),
    [anon_sym_PIPE] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5159),
    [anon_sym_AMP] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5156),
    [anon_sym_BANG_EQ] = ACTIONS(5156),
    [anon_sym_GT] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5156),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5159),
    [anon_sym_LT_LT] = ACTIONS(5159),
    [anon_sym_GT_GT] = ACTIONS(5159),
    [anon_sym_SEMI] = ACTIONS(5156),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5159),
    [anon_sym___attribute] = ACTIONS(5159),
    [anon_sym_COLON] = ACTIONS(5156),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_RBRACE] = ACTIONS(5156),
    [anon_sym_signed] = ACTIONS(5074),
    [anon_sym_unsigned] = ACTIONS(5074),
    [anon_sym_long] = ACTIONS(5074),
    [anon_sym_short] = ACTIONS(5074),
    [anon_sym_LBRACK] = ACTIONS(5156),
    [anon_sym_RBRACK] = ACTIONS(5156),
    [anon_sym_EQ] = ACTIONS(5159),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5156),
    [anon_sym_STAR_EQ] = ACTIONS(5156),
    [anon_sym_SLASH_EQ] = ACTIONS(5156),
    [anon_sym_PERCENT_EQ] = ACTIONS(5156),
    [anon_sym_PLUS_EQ] = ACTIONS(5156),
    [anon_sym_DASH_EQ] = ACTIONS(5156),
    [anon_sym_LT_LT_EQ] = ACTIONS(5156),
    [anon_sym_GT_GT_EQ] = ACTIONS(5156),
    [anon_sym_AMP_EQ] = ACTIONS(5156),
    [anon_sym_CARET_EQ] = ACTIONS(5156),
    [anon_sym_PIPE_EQ] = ACTIONS(5156),
    [anon_sym_and_eq] = ACTIONS(5159),
    [anon_sym_or_eq] = ACTIONS(5159),
    [anon_sym_xor_eq] = ACTIONS(5159),
    [anon_sym_LT_EQ_GT] = ACTIONS(5156),
    [anon_sym_or] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_bitor] = ACTIONS(5159),
    [anon_sym_xor] = ACTIONS(5159),
    [anon_sym_bitand] = ACTIONS(5159),
    [anon_sym_not_eq] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5156),
    [anon_sym_PLUS_PLUS] = ACTIONS(5156),
    [anon_sym_DOT] = ACTIONS(5159),
    [anon_sym_DOT_STAR] = ACTIONS(5156),
    [anon_sym_DASH_GT] = ACTIONS(5156),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5159),
    [anon_sym_decltype] = ACTIONS(5159),
  },
  [1615] = {
    [sym_identifier] = ACTIONS(5162),
    [anon_sym_COMMA] = ACTIONS(5164),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [anon_sym_LPAREN2] = ACTIONS(5164),
    [anon_sym_TILDE] = ACTIONS(5164),
    [anon_sym_STAR] = ACTIONS(5164),
    [anon_sym_PIPE_PIPE] = ACTIONS(5164),
    [anon_sym_AMP_AMP] = ACTIONS(5164),
    [anon_sym_AMP] = ACTIONS(5162),
    [anon_sym_SEMI] = ACTIONS(5164),
    [anon_sym___extension__] = ACTIONS(5162),
    [anon_sym_virtual] = ACTIONS(5162),
    [anon_sym_extern] = ACTIONS(5162),
    [anon_sym___attribute__] = ACTIONS(5162),
    [anon_sym___attribute] = ACTIONS(5162),
    [anon_sym_using] = ACTIONS(5162),
    [anon_sym_COLON_COLON] = ACTIONS(5164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5164),
    [anon_sym___declspec] = ACTIONS(5162),
    [anon_sym___based] = ACTIONS(5162),
    [anon_sym___cdecl] = ACTIONS(5162),
    [anon_sym___clrcall] = ACTIONS(5162),
    [anon_sym___stdcall] = ACTIONS(5162),
    [anon_sym___fastcall] = ACTIONS(5162),
    [anon_sym___thiscall] = ACTIONS(5162),
    [anon_sym___vectorcall] = ACTIONS(5162),
    [anon_sym_LBRACE] = ACTIONS(5164),
    [anon_sym_signed] = ACTIONS(5162),
    [anon_sym_unsigned] = ACTIONS(5162),
    [anon_sym_long] = ACTIONS(5162),
    [anon_sym_short] = ACTIONS(5162),
    [anon_sym_LBRACK] = ACTIONS(5162),
    [anon_sym_static] = ACTIONS(5162),
    [anon_sym_EQ] = ACTIONS(5164),
    [anon_sym_register] = ACTIONS(5162),
    [anon_sym_inline] = ACTIONS(5162),
    [anon_sym___inline] = ACTIONS(5162),
    [anon_sym___inline__] = ACTIONS(5162),
    [anon_sym___forceinline] = ACTIONS(5162),
    [anon_sym_thread_local] = ACTIONS(5162),
    [anon_sym___thread] = ACTIONS(5162),
    [anon_sym_const] = ACTIONS(5162),
    [anon_sym_constexpr] = ACTIONS(5162),
    [anon_sym_volatile] = ACTIONS(5162),
    [anon_sym_restrict] = ACTIONS(5162),
    [anon_sym___restrict__] = ACTIONS(5162),
    [anon_sym__Atomic] = ACTIONS(5162),
    [anon_sym__Noreturn] = ACTIONS(5162),
    [anon_sym_noreturn] = ACTIONS(5162),
    [anon_sym__Nonnull] = ACTIONS(5162),
    [anon_sym_mutable] = ACTIONS(5162),
    [anon_sym_constinit] = ACTIONS(5162),
    [anon_sym_consteval] = ACTIONS(5162),
    [anon_sym_alignas] = ACTIONS(5162),
    [anon_sym__Alignas] = ACTIONS(5162),
    [sym_primitive_type] = ACTIONS(5162),
    [anon_sym_enum] = ACTIONS(5162),
    [anon_sym_class] = ACTIONS(5162),
    [anon_sym_struct] = ACTIONS(5162),
    [anon_sym_union] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5162),
    [anon_sym_and] = ACTIONS(5162),
    [anon_sym_asm] = ACTIONS(5162),
    [anon_sym___asm__] = ACTIONS(5162),
    [anon_sym___asm] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5164),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5162),
    [anon_sym_decltype] = ACTIONS(5162),
    [anon_sym_final] = ACTIONS(5162),
    [anon_sym_override] = ACTIONS(5162),
    [anon_sym_explicit] = ACTIONS(5162),
    [anon_sym_typename] = ACTIONS(5162),
    [anon_sym_template] = ACTIONS(5162),
    [anon_sym_GT2] = ACTIONS(5164),
    [anon_sym_operator] = ACTIONS(5162),
    [anon_sym_try] = ACTIONS(5162),
    [anon_sym_friend] = ACTIONS(5162),
    [anon_sym_noexcept] = ACTIONS(5162),
    [anon_sym_throw] = ACTIONS(5162),
    [anon_sym_concept] = ACTIONS(5162),
    [anon_sym_requires] = ACTIONS(5162),
  },
  [1616] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_TILDE] = ACTIONS(5168),
    [anon_sym_STAR] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5166),
    [anon_sym_SEMI] = ACTIONS(5168),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym_virtual] = ACTIONS(5166),
    [anon_sym_extern] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5166),
    [anon_sym___attribute] = ACTIONS(5166),
    [anon_sym_using] = ACTIONS(5166),
    [anon_sym_COLON_COLON] = ACTIONS(5168),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5168),
    [anon_sym___declspec] = ACTIONS(5166),
    [anon_sym___based] = ACTIONS(5166),
    [anon_sym___cdecl] = ACTIONS(5166),
    [anon_sym___clrcall] = ACTIONS(5166),
    [anon_sym___stdcall] = ACTIONS(5166),
    [anon_sym___fastcall] = ACTIONS(5166),
    [anon_sym___thiscall] = ACTIONS(5166),
    [anon_sym___vectorcall] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_signed] = ACTIONS(5166),
    [anon_sym_unsigned] = ACTIONS(5166),
    [anon_sym_long] = ACTIONS(5166),
    [anon_sym_short] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5166),
    [anon_sym_static] = ACTIONS(5166),
    [anon_sym_EQ] = ACTIONS(5168),
    [anon_sym_register] = ACTIONS(5166),
    [anon_sym_inline] = ACTIONS(5166),
    [anon_sym___inline] = ACTIONS(5166),
    [anon_sym___inline__] = ACTIONS(5166),
    [anon_sym___forceinline] = ACTIONS(5166),
    [anon_sym_thread_local] = ACTIONS(5166),
    [anon_sym___thread] = ACTIONS(5166),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_primitive_type] = ACTIONS(5166),
    [anon_sym_enum] = ACTIONS(5166),
    [anon_sym_class] = ACTIONS(5166),
    [anon_sym_struct] = ACTIONS(5166),
    [anon_sym_union] = ACTIONS(5166),
    [anon_sym_or] = ACTIONS(5166),
    [anon_sym_and] = ACTIONS(5166),
    [anon_sym_asm] = ACTIONS(5166),
    [anon_sym___asm__] = ACTIONS(5166),
    [anon_sym___asm] = ACTIONS(5166),
    [anon_sym_DASH_GT] = ACTIONS(5168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5166),
    [anon_sym_decltype] = ACTIONS(5166),
    [anon_sym_final] = ACTIONS(5166),
    [anon_sym_override] = ACTIONS(5166),
    [anon_sym_explicit] = ACTIONS(5166),
    [anon_sym_typename] = ACTIONS(5166),
    [anon_sym_template] = ACTIONS(5166),
    [anon_sym_GT2] = ACTIONS(5168),
    [anon_sym_operator] = ACTIONS(5166),
    [anon_sym_try] = ACTIONS(5166),
    [anon_sym_friend] = ACTIONS(5166),
    [anon_sym_noexcept] = ACTIONS(5166),
    [anon_sym_throw] = ACTIONS(5166),
    [anon_sym_concept] = ACTIONS(5166),
    [anon_sym_requires] = ACTIONS(5166),
  },
  [1617] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1585),
    [sym_identifier] = ACTIONS(5159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5156),
    [anon_sym_COMMA] = ACTIONS(5156),
    [aux_sym_preproc_if_token2] = ACTIONS(5156),
    [aux_sym_preproc_else_token1] = ACTIONS(5156),
    [aux_sym_preproc_elif_token1] = ACTIONS(5159),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5156),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5156),
    [anon_sym_LPAREN2] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5159),
    [anon_sym_STAR] = ACTIONS(5159),
    [anon_sym_SLASH] = ACTIONS(5159),
    [anon_sym_PERCENT] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5156),
    [anon_sym_AMP_AMP] = ACTIONS(5156),
    [anon_sym_PIPE] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5159),
    [anon_sym_AMP] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5156),
    [anon_sym_BANG_EQ] = ACTIONS(5156),
    [anon_sym_GT] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5156),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5159),
    [anon_sym_LT_LT] = ACTIONS(5159),
    [anon_sym_GT_GT] = ACTIONS(5159),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5159),
    [anon_sym___attribute] = ACTIONS(5159),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_signed] = ACTIONS(5074),
    [anon_sym_unsigned] = ACTIONS(5074),
    [anon_sym_long] = ACTIONS(5074),
    [anon_sym_short] = ACTIONS(5074),
    [anon_sym_LBRACK] = ACTIONS(5156),
    [anon_sym_EQ] = ACTIONS(5159),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5156),
    [anon_sym_STAR_EQ] = ACTIONS(5156),
    [anon_sym_SLASH_EQ] = ACTIONS(5156),
    [anon_sym_PERCENT_EQ] = ACTIONS(5156),
    [anon_sym_PLUS_EQ] = ACTIONS(5156),
    [anon_sym_DASH_EQ] = ACTIONS(5156),
    [anon_sym_LT_LT_EQ] = ACTIONS(5156),
    [anon_sym_GT_GT_EQ] = ACTIONS(5156),
    [anon_sym_AMP_EQ] = ACTIONS(5156),
    [anon_sym_CARET_EQ] = ACTIONS(5156),
    [anon_sym_PIPE_EQ] = ACTIONS(5156),
    [anon_sym_and_eq] = ACTIONS(5159),
    [anon_sym_or_eq] = ACTIONS(5159),
    [anon_sym_xor_eq] = ACTIONS(5159),
    [anon_sym_LT_EQ_GT] = ACTIONS(5156),
    [anon_sym_or] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_bitor] = ACTIONS(5159),
    [anon_sym_xor] = ACTIONS(5159),
    [anon_sym_bitand] = ACTIONS(5159),
    [anon_sym_not_eq] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5156),
    [anon_sym_PLUS_PLUS] = ACTIONS(5156),
    [anon_sym_DOT] = ACTIONS(5159),
    [anon_sym_DOT_STAR] = ACTIONS(5156),
    [anon_sym_DASH_GT] = ACTIONS(5156),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5159),
    [anon_sym_decltype] = ACTIONS(5159),
  },
  [1618] = {
    [sym_identifier] = ACTIONS(5170),
    [anon_sym_COMMA] = ACTIONS(5172),
    [anon_sym_RPAREN] = ACTIONS(5172),
    [anon_sym_LPAREN2] = ACTIONS(5172),
    [anon_sym_TILDE] = ACTIONS(5172),
    [anon_sym_STAR] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5170),
    [anon_sym_SEMI] = ACTIONS(5172),
    [anon_sym___extension__] = ACTIONS(5170),
    [anon_sym_virtual] = ACTIONS(5170),
    [anon_sym_extern] = ACTIONS(5170),
    [anon_sym___attribute__] = ACTIONS(5170),
    [anon_sym___attribute] = ACTIONS(5170),
    [anon_sym_using] = ACTIONS(5170),
    [anon_sym_COLON_COLON] = ACTIONS(5172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5172),
    [anon_sym___declspec] = ACTIONS(5170),
    [anon_sym___based] = ACTIONS(5170),
    [anon_sym___cdecl] = ACTIONS(5170),
    [anon_sym___clrcall] = ACTIONS(5170),
    [anon_sym___stdcall] = ACTIONS(5170),
    [anon_sym___fastcall] = ACTIONS(5170),
    [anon_sym___thiscall] = ACTIONS(5170),
    [anon_sym___vectorcall] = ACTIONS(5170),
    [anon_sym_LBRACE] = ACTIONS(5172),
    [anon_sym_signed] = ACTIONS(5170),
    [anon_sym_unsigned] = ACTIONS(5170),
    [anon_sym_long] = ACTIONS(5170),
    [anon_sym_short] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(5170),
    [anon_sym_static] = ACTIONS(5170),
    [anon_sym_EQ] = ACTIONS(5172),
    [anon_sym_register] = ACTIONS(5170),
    [anon_sym_inline] = ACTIONS(5170),
    [anon_sym___inline] = ACTIONS(5170),
    [anon_sym___inline__] = ACTIONS(5170),
    [anon_sym___forceinline] = ACTIONS(5170),
    [anon_sym_thread_local] = ACTIONS(5170),
    [anon_sym___thread] = ACTIONS(5170),
    [anon_sym_const] = ACTIONS(5170),
    [anon_sym_constexpr] = ACTIONS(5170),
    [anon_sym_volatile] = ACTIONS(5170),
    [anon_sym_restrict] = ACTIONS(5170),
    [anon_sym___restrict__] = ACTIONS(5170),
    [anon_sym__Atomic] = ACTIONS(5170),
    [anon_sym__Noreturn] = ACTIONS(5170),
    [anon_sym_noreturn] = ACTIONS(5170),
    [anon_sym__Nonnull] = ACTIONS(5170),
    [anon_sym_mutable] = ACTIONS(5170),
    [anon_sym_constinit] = ACTIONS(5170),
    [anon_sym_consteval] = ACTIONS(5170),
    [anon_sym_alignas] = ACTIONS(5170),
    [anon_sym__Alignas] = ACTIONS(5170),
    [sym_primitive_type] = ACTIONS(5170),
    [anon_sym_enum] = ACTIONS(5170),
    [anon_sym_class] = ACTIONS(5170),
    [anon_sym_struct] = ACTIONS(5170),
    [anon_sym_union] = ACTIONS(5170),
    [anon_sym_or] = ACTIONS(5170),
    [anon_sym_and] = ACTIONS(5170),
    [anon_sym_asm] = ACTIONS(5170),
    [anon_sym___asm__] = ACTIONS(5170),
    [anon_sym___asm] = ACTIONS(5170),
    [anon_sym_DASH_GT] = ACTIONS(5172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5170),
    [anon_sym_decltype] = ACTIONS(5170),
    [anon_sym_final] = ACTIONS(5170),
    [anon_sym_override] = ACTIONS(5170),
    [anon_sym_explicit] = ACTIONS(5170),
    [anon_sym_typename] = ACTIONS(5170),
    [anon_sym_template] = ACTIONS(5170),
    [anon_sym_GT2] = ACTIONS(5172),
    [anon_sym_operator] = ACTIONS(5170),
    [anon_sym_try] = ACTIONS(5170),
    [anon_sym_friend] = ACTIONS(5170),
    [anon_sym_noexcept] = ACTIONS(5170),
    [anon_sym_throw] = ACTIONS(5170),
    [anon_sym_concept] = ACTIONS(5170),
    [anon_sym_requires] = ACTIONS(5170),
  },
  [1619] = {
    [sym_type_qualifier] = STATE(1605),
    [sym_alignas_qualifier] = STATE(1651),
    [aux_sym__type_definition_type_repeat1] = STATE(1605),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1649),
    [sym_identifier] = ACTIONS(5174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5086),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_RPAREN] = ACTIONS(5086),
    [anon_sym_LPAREN2] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_STAR] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5088),
    [anon_sym_PERCENT] = ACTIONS(5088),
    [anon_sym_PIPE_PIPE] = ACTIONS(5086),
    [anon_sym_AMP_AMP] = ACTIONS(5086),
    [anon_sym_PIPE] = ACTIONS(5088),
    [anon_sym_CARET] = ACTIONS(5088),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_EQ_EQ] = ACTIONS(5086),
    [anon_sym_BANG_EQ] = ACTIONS(5086),
    [anon_sym_GT] = ACTIONS(5088),
    [anon_sym_GT_EQ] = ACTIONS(5086),
    [anon_sym_LT_EQ] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_LT_LT] = ACTIONS(5088),
    [anon_sym_GT_GT] = ACTIONS(5088),
    [anon_sym___extension__] = ACTIONS(5124),
    [anon_sym___attribute__] = ACTIONS(5088),
    [anon_sym___attribute] = ACTIONS(5088),
    [anon_sym_LBRACE] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5176),
    [anon_sym_unsigned] = ACTIONS(5176),
    [anon_sym_long] = ACTIONS(5176),
    [anon_sym_short] = ACTIONS(5176),
    [anon_sym_LBRACK] = ACTIONS(5086),
    [anon_sym_EQ] = ACTIONS(5088),
    [anon_sym_const] = ACTIONS(5124),
    [anon_sym_constexpr] = ACTIONS(5124),
    [anon_sym_volatile] = ACTIONS(5124),
    [anon_sym_restrict] = ACTIONS(5124),
    [anon_sym___restrict__] = ACTIONS(5124),
    [anon_sym__Atomic] = ACTIONS(5124),
    [anon_sym__Noreturn] = ACTIONS(5124),
    [anon_sym_noreturn] = ACTIONS(5124),
    [anon_sym__Nonnull] = ACTIONS(5124),
    [anon_sym_mutable] = ACTIONS(5124),
    [anon_sym_constinit] = ACTIONS(5124),
    [anon_sym_consteval] = ACTIONS(5124),
    [anon_sym_alignas] = ACTIONS(5128),
    [anon_sym__Alignas] = ACTIONS(5128),
    [sym_primitive_type] = ACTIONS(5178),
    [anon_sym_QMARK] = ACTIONS(5086),
    [anon_sym_STAR_EQ] = ACTIONS(5086),
    [anon_sym_SLASH_EQ] = ACTIONS(5086),
    [anon_sym_PERCENT_EQ] = ACTIONS(5086),
    [anon_sym_PLUS_EQ] = ACTIONS(5086),
    [anon_sym_DASH_EQ] = ACTIONS(5086),
    [anon_sym_LT_LT_EQ] = ACTIONS(5086),
    [anon_sym_GT_GT_EQ] = ACTIONS(5086),
    [anon_sym_AMP_EQ] = ACTIONS(5086),
    [anon_sym_CARET_EQ] = ACTIONS(5086),
    [anon_sym_PIPE_EQ] = ACTIONS(5086),
    [anon_sym_and_eq] = ACTIONS(5088),
    [anon_sym_or_eq] = ACTIONS(5088),
    [anon_sym_xor_eq] = ACTIONS(5088),
    [anon_sym_LT_EQ_GT] = ACTIONS(5086),
    [anon_sym_or] = ACTIONS(5088),
    [anon_sym_and] = ACTIONS(5088),
    [anon_sym_bitor] = ACTIONS(5088),
    [anon_sym_xor] = ACTIONS(5088),
    [anon_sym_bitand] = ACTIONS(5088),
    [anon_sym_not_eq] = ACTIONS(5088),
    [anon_sym_DASH_DASH] = ACTIONS(5086),
    [anon_sym_PLUS_PLUS] = ACTIONS(5086),
    [anon_sym_DOT] = ACTIONS(5088),
    [anon_sym_DOT_STAR] = ACTIONS(5086),
    [anon_sym_DASH_GT] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5088),
    [anon_sym_decltype] = ACTIONS(5088),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5086),
  },
  [1620] = {
    [sym_identifier] = ACTIONS(5180),
    [anon_sym_COMMA] = ACTIONS(5182),
    [anon_sym_RPAREN] = ACTIONS(5182),
    [anon_sym_LPAREN2] = ACTIONS(5182),
    [anon_sym_TILDE] = ACTIONS(5182),
    [anon_sym_STAR] = ACTIONS(5182),
    [anon_sym_PIPE_PIPE] = ACTIONS(5182),
    [anon_sym_AMP_AMP] = ACTIONS(5182),
    [anon_sym_AMP] = ACTIONS(5180),
    [anon_sym_SEMI] = ACTIONS(5182),
    [anon_sym___extension__] = ACTIONS(5180),
    [anon_sym_virtual] = ACTIONS(5180),
    [anon_sym_extern] = ACTIONS(5180),
    [anon_sym___attribute__] = ACTIONS(5180),
    [anon_sym___attribute] = ACTIONS(5180),
    [anon_sym_using] = ACTIONS(5180),
    [anon_sym_COLON_COLON] = ACTIONS(5182),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5182),
    [anon_sym___declspec] = ACTIONS(5180),
    [anon_sym___based] = ACTIONS(5180),
    [anon_sym___cdecl] = ACTIONS(5180),
    [anon_sym___clrcall] = ACTIONS(5180),
    [anon_sym___stdcall] = ACTIONS(5180),
    [anon_sym___fastcall] = ACTIONS(5180),
    [anon_sym___thiscall] = ACTIONS(5180),
    [anon_sym___vectorcall] = ACTIONS(5180),
    [anon_sym_LBRACE] = ACTIONS(5182),
    [anon_sym_signed] = ACTIONS(5180),
    [anon_sym_unsigned] = ACTIONS(5180),
    [anon_sym_long] = ACTIONS(5180),
    [anon_sym_short] = ACTIONS(5180),
    [anon_sym_LBRACK] = ACTIONS(5180),
    [anon_sym_static] = ACTIONS(5180),
    [anon_sym_EQ] = ACTIONS(5182),
    [anon_sym_register] = ACTIONS(5180),
    [anon_sym_inline] = ACTIONS(5180),
    [anon_sym___inline] = ACTIONS(5180),
    [anon_sym___inline__] = ACTIONS(5180),
    [anon_sym___forceinline] = ACTIONS(5180),
    [anon_sym_thread_local] = ACTIONS(5180),
    [anon_sym___thread] = ACTIONS(5180),
    [anon_sym_const] = ACTIONS(5180),
    [anon_sym_constexpr] = ACTIONS(5180),
    [anon_sym_volatile] = ACTIONS(5180),
    [anon_sym_restrict] = ACTIONS(5180),
    [anon_sym___restrict__] = ACTIONS(5180),
    [anon_sym__Atomic] = ACTIONS(5180),
    [anon_sym__Noreturn] = ACTIONS(5180),
    [anon_sym_noreturn] = ACTIONS(5180),
    [anon_sym__Nonnull] = ACTIONS(5180),
    [anon_sym_mutable] = ACTIONS(5180),
    [anon_sym_constinit] = ACTIONS(5180),
    [anon_sym_consteval] = ACTIONS(5180),
    [anon_sym_alignas] = ACTIONS(5180),
    [anon_sym__Alignas] = ACTIONS(5180),
    [sym_primitive_type] = ACTIONS(5180),
    [anon_sym_enum] = ACTIONS(5180),
    [anon_sym_class] = ACTIONS(5180),
    [anon_sym_struct] = ACTIONS(5180),
    [anon_sym_union] = ACTIONS(5180),
    [anon_sym_or] = ACTIONS(5180),
    [anon_sym_and] = ACTIONS(5180),
    [anon_sym_asm] = ACTIONS(5180),
    [anon_sym___asm__] = ACTIONS(5180),
    [anon_sym___asm] = ACTIONS(5180),
    [anon_sym_DASH_GT] = ACTIONS(5182),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5180),
    [anon_sym_decltype] = ACTIONS(5180),
    [anon_sym_final] = ACTIONS(5180),
    [anon_sym_override] = ACTIONS(5180),
    [anon_sym_explicit] = ACTIONS(5180),
    [anon_sym_typename] = ACTIONS(5180),
    [anon_sym_template] = ACTIONS(5180),
    [anon_sym_GT2] = ACTIONS(5182),
    [anon_sym_operator] = ACTIONS(5180),
    [anon_sym_try] = ACTIONS(5180),
    [anon_sym_friend] = ACTIONS(5180),
    [anon_sym_noexcept] = ACTIONS(5180),
    [anon_sym_throw] = ACTIONS(5180),
    [anon_sym_concept] = ACTIONS(5180),
    [anon_sym_requires] = ACTIONS(5180),
  },
  [1621] = {
    [sym_identifier] = ACTIONS(5184),
    [anon_sym_COMMA] = ACTIONS(5186),
    [anon_sym_RPAREN] = ACTIONS(5186),
    [anon_sym_LPAREN2] = ACTIONS(5186),
    [anon_sym_TILDE] = ACTIONS(5186),
    [anon_sym_STAR] = ACTIONS(5186),
    [anon_sym_PIPE_PIPE] = ACTIONS(5186),
    [anon_sym_AMP_AMP] = ACTIONS(5186),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_SEMI] = ACTIONS(5186),
    [anon_sym___extension__] = ACTIONS(5184),
    [anon_sym_virtual] = ACTIONS(5184),
    [anon_sym_extern] = ACTIONS(5184),
    [anon_sym___attribute__] = ACTIONS(5184),
    [anon_sym___attribute] = ACTIONS(5184),
    [anon_sym_using] = ACTIONS(5184),
    [anon_sym_COLON_COLON] = ACTIONS(5186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5186),
    [anon_sym___declspec] = ACTIONS(5184),
    [anon_sym___based] = ACTIONS(5184),
    [anon_sym___cdecl] = ACTIONS(5184),
    [anon_sym___clrcall] = ACTIONS(5184),
    [anon_sym___stdcall] = ACTIONS(5184),
    [anon_sym___fastcall] = ACTIONS(5184),
    [anon_sym___thiscall] = ACTIONS(5184),
    [anon_sym___vectorcall] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(5186),
    [anon_sym_signed] = ACTIONS(5184),
    [anon_sym_unsigned] = ACTIONS(5184),
    [anon_sym_long] = ACTIONS(5184),
    [anon_sym_short] = ACTIONS(5184),
    [anon_sym_LBRACK] = ACTIONS(5184),
    [anon_sym_static] = ACTIONS(5184),
    [anon_sym_EQ] = ACTIONS(5186),
    [anon_sym_register] = ACTIONS(5184),
    [anon_sym_inline] = ACTIONS(5184),
    [anon_sym___inline] = ACTIONS(5184),
    [anon_sym___inline__] = ACTIONS(5184),
    [anon_sym___forceinline] = ACTIONS(5184),
    [anon_sym_thread_local] = ACTIONS(5184),
    [anon_sym___thread] = ACTIONS(5184),
    [anon_sym_const] = ACTIONS(5184),
    [anon_sym_constexpr] = ACTIONS(5184),
    [anon_sym_volatile] = ACTIONS(5184),
    [anon_sym_restrict] = ACTIONS(5184),
    [anon_sym___restrict__] = ACTIONS(5184),
    [anon_sym__Atomic] = ACTIONS(5184),
    [anon_sym__Noreturn] = ACTIONS(5184),
    [anon_sym_noreturn] = ACTIONS(5184),
    [anon_sym__Nonnull] = ACTIONS(5184),
    [anon_sym_mutable] = ACTIONS(5184),
    [anon_sym_constinit] = ACTIONS(5184),
    [anon_sym_consteval] = ACTIONS(5184),
    [anon_sym_alignas] = ACTIONS(5184),
    [anon_sym__Alignas] = ACTIONS(5184),
    [sym_primitive_type] = ACTIONS(5184),
    [anon_sym_enum] = ACTIONS(5184),
    [anon_sym_class] = ACTIONS(5184),
    [anon_sym_struct] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5184),
    [anon_sym_or] = ACTIONS(5184),
    [anon_sym_and] = ACTIONS(5184),
    [anon_sym_asm] = ACTIONS(5184),
    [anon_sym___asm__] = ACTIONS(5184),
    [anon_sym___asm] = ACTIONS(5184),
    [anon_sym_DASH_GT] = ACTIONS(5186),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5184),
    [anon_sym_decltype] = ACTIONS(5184),
    [anon_sym_final] = ACTIONS(5184),
    [anon_sym_override] = ACTIONS(5184),
    [anon_sym_explicit] = ACTIONS(5184),
    [anon_sym_typename] = ACTIONS(5184),
    [anon_sym_template] = ACTIONS(5184),
    [anon_sym_GT2] = ACTIONS(5186),
    [anon_sym_operator] = ACTIONS(5184),
    [anon_sym_try] = ACTIONS(5184),
    [anon_sym_friend] = ACTIONS(5184),
    [anon_sym_noexcept] = ACTIONS(5184),
    [anon_sym_throw] = ACTIONS(5184),
    [anon_sym_concept] = ACTIONS(5184),
    [anon_sym_requires] = ACTIONS(5184),
  },
  [1622] = {
    [sym_identifier] = ACTIONS(5188),
    [anon_sym_COMMA] = ACTIONS(5190),
    [anon_sym_RPAREN] = ACTIONS(5190),
    [anon_sym_LPAREN2] = ACTIONS(5190),
    [anon_sym_TILDE] = ACTIONS(5190),
    [anon_sym_STAR] = ACTIONS(5190),
    [anon_sym_PIPE_PIPE] = ACTIONS(5190),
    [anon_sym_AMP_AMP] = ACTIONS(5190),
    [anon_sym_AMP] = ACTIONS(5188),
    [anon_sym_SEMI] = ACTIONS(5190),
    [anon_sym___extension__] = ACTIONS(5188),
    [anon_sym_virtual] = ACTIONS(5188),
    [anon_sym_extern] = ACTIONS(5188),
    [anon_sym___attribute__] = ACTIONS(5188),
    [anon_sym___attribute] = ACTIONS(5188),
    [anon_sym_using] = ACTIONS(5188),
    [anon_sym_COLON_COLON] = ACTIONS(5190),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5190),
    [anon_sym___declspec] = ACTIONS(5188),
    [anon_sym___based] = ACTIONS(5188),
    [anon_sym___cdecl] = ACTIONS(5188),
    [anon_sym___clrcall] = ACTIONS(5188),
    [anon_sym___stdcall] = ACTIONS(5188),
    [anon_sym___fastcall] = ACTIONS(5188),
    [anon_sym___thiscall] = ACTIONS(5188),
    [anon_sym___vectorcall] = ACTIONS(5188),
    [anon_sym_LBRACE] = ACTIONS(5190),
    [anon_sym_signed] = ACTIONS(5188),
    [anon_sym_unsigned] = ACTIONS(5188),
    [anon_sym_long] = ACTIONS(5188),
    [anon_sym_short] = ACTIONS(5188),
    [anon_sym_LBRACK] = ACTIONS(5188),
    [anon_sym_static] = ACTIONS(5188),
    [anon_sym_EQ] = ACTIONS(5190),
    [anon_sym_register] = ACTIONS(5188),
    [anon_sym_inline] = ACTIONS(5188),
    [anon_sym___inline] = ACTIONS(5188),
    [anon_sym___inline__] = ACTIONS(5188),
    [anon_sym___forceinline] = ACTIONS(5188),
    [anon_sym_thread_local] = ACTIONS(5188),
    [anon_sym___thread] = ACTIONS(5188),
    [anon_sym_const] = ACTIONS(5188),
    [anon_sym_constexpr] = ACTIONS(5188),
    [anon_sym_volatile] = ACTIONS(5188),
    [anon_sym_restrict] = ACTIONS(5188),
    [anon_sym___restrict__] = ACTIONS(5188),
    [anon_sym__Atomic] = ACTIONS(5188),
    [anon_sym__Noreturn] = ACTIONS(5188),
    [anon_sym_noreturn] = ACTIONS(5188),
    [anon_sym__Nonnull] = ACTIONS(5188),
    [anon_sym_mutable] = ACTIONS(5188),
    [anon_sym_constinit] = ACTIONS(5188),
    [anon_sym_consteval] = ACTIONS(5188),
    [anon_sym_alignas] = ACTIONS(5188),
    [anon_sym__Alignas] = ACTIONS(5188),
    [sym_primitive_type] = ACTIONS(5188),
    [anon_sym_enum] = ACTIONS(5188),
    [anon_sym_class] = ACTIONS(5188),
    [anon_sym_struct] = ACTIONS(5188),
    [anon_sym_union] = ACTIONS(5188),
    [anon_sym_or] = ACTIONS(5188),
    [anon_sym_and] = ACTIONS(5188),
    [anon_sym_asm] = ACTIONS(5188),
    [anon_sym___asm__] = ACTIONS(5188),
    [anon_sym___asm] = ACTIONS(5188),
    [anon_sym_DASH_GT] = ACTIONS(5190),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5188),
    [anon_sym_decltype] = ACTIONS(5188),
    [anon_sym_final] = ACTIONS(5188),
    [anon_sym_override] = ACTIONS(5188),
    [anon_sym_explicit] = ACTIONS(5188),
    [anon_sym_typename] = ACTIONS(5188),
    [anon_sym_template] = ACTIONS(5188),
    [anon_sym_GT2] = ACTIONS(5190),
    [anon_sym_operator] = ACTIONS(5188),
    [anon_sym_try] = ACTIONS(5188),
    [anon_sym_friend] = ACTIONS(5188),
    [anon_sym_noexcept] = ACTIONS(5188),
    [anon_sym_throw] = ACTIONS(5188),
    [anon_sym_concept] = ACTIONS(5188),
    [anon_sym_requires] = ACTIONS(5188),
  },
  [1623] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_TILDE] = ACTIONS(5194),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___extension__] = ACTIONS(5192),
    [anon_sym_virtual] = ACTIONS(5192),
    [anon_sym_extern] = ACTIONS(5192),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym___attribute] = ACTIONS(5192),
    [anon_sym_using] = ACTIONS(5192),
    [anon_sym_COLON_COLON] = ACTIONS(5194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5194),
    [anon_sym___declspec] = ACTIONS(5192),
    [anon_sym___based] = ACTIONS(5192),
    [anon_sym___cdecl] = ACTIONS(5192),
    [anon_sym___clrcall] = ACTIONS(5192),
    [anon_sym___stdcall] = ACTIONS(5192),
    [anon_sym___fastcall] = ACTIONS(5192),
    [anon_sym___thiscall] = ACTIONS(5192),
    [anon_sym___vectorcall] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_signed] = ACTIONS(5192),
    [anon_sym_unsigned] = ACTIONS(5192),
    [anon_sym_long] = ACTIONS(5192),
    [anon_sym_short] = ACTIONS(5192),
    [anon_sym_LBRACK] = ACTIONS(5192),
    [anon_sym_static] = ACTIONS(5192),
    [anon_sym_EQ] = ACTIONS(5194),
    [anon_sym_register] = ACTIONS(5192),
    [anon_sym_inline] = ACTIONS(5192),
    [anon_sym___inline] = ACTIONS(5192),
    [anon_sym___inline__] = ACTIONS(5192),
    [anon_sym___forceinline] = ACTIONS(5192),
    [anon_sym_thread_local] = ACTIONS(5192),
    [anon_sym___thread] = ACTIONS(5192),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5192),
    [anon_sym_volatile] = ACTIONS(5192),
    [anon_sym_restrict] = ACTIONS(5192),
    [anon_sym___restrict__] = ACTIONS(5192),
    [anon_sym__Atomic] = ACTIONS(5192),
    [anon_sym__Noreturn] = ACTIONS(5192),
    [anon_sym_noreturn] = ACTIONS(5192),
    [anon_sym__Nonnull] = ACTIONS(5192),
    [anon_sym_mutable] = ACTIONS(5192),
    [anon_sym_constinit] = ACTIONS(5192),
    [anon_sym_consteval] = ACTIONS(5192),
    [anon_sym_alignas] = ACTIONS(5192),
    [anon_sym__Alignas] = ACTIONS(5192),
    [sym_primitive_type] = ACTIONS(5192),
    [anon_sym_enum] = ACTIONS(5192),
    [anon_sym_class] = ACTIONS(5192),
    [anon_sym_struct] = ACTIONS(5192),
    [anon_sym_union] = ACTIONS(5192),
    [anon_sym_or] = ACTIONS(5192),
    [anon_sym_and] = ACTIONS(5192),
    [anon_sym_asm] = ACTIONS(5192),
    [anon_sym___asm__] = ACTIONS(5192),
    [anon_sym___asm] = ACTIONS(5192),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [anon_sym_final] = ACTIONS(5192),
    [anon_sym_override] = ACTIONS(5192),
    [anon_sym_explicit] = ACTIONS(5192),
    [anon_sym_typename] = ACTIONS(5192),
    [anon_sym_template] = ACTIONS(5192),
    [anon_sym_GT2] = ACTIONS(5194),
    [anon_sym_operator] = ACTIONS(5192),
    [anon_sym_try] = ACTIONS(5192),
    [anon_sym_friend] = ACTIONS(5192),
    [anon_sym_noexcept] = ACTIONS(5192),
    [anon_sym_throw] = ACTIONS(5192),
    [anon_sym_concept] = ACTIONS(5192),
    [anon_sym_requires] = ACTIONS(5192),
  },
  [1624] = {
    [sym_type_qualifier] = STATE(1628),
    [sym_alignas_qualifier] = STATE(1660),
    [aux_sym__type_definition_type_repeat1] = STATE(1628),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2608),
    [sym_identifier] = ACTIONS(5196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5100),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_LPAREN2] = ACTIONS(5100),
    [anon_sym_DASH] = ACTIONS(5102),
    [anon_sym_PLUS] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5102),
    [anon_sym_SLASH] = ACTIONS(5102),
    [anon_sym_PERCENT] = ACTIONS(5102),
    [anon_sym_PIPE_PIPE] = ACTIONS(5100),
    [anon_sym_AMP_AMP] = ACTIONS(5100),
    [anon_sym_PIPE] = ACTIONS(5102),
    [anon_sym_CARET] = ACTIONS(5102),
    [anon_sym_AMP] = ACTIONS(5102),
    [anon_sym_EQ_EQ] = ACTIONS(5100),
    [anon_sym_BANG_EQ] = ACTIONS(5100),
    [anon_sym_GT] = ACTIONS(5102),
    [anon_sym_GT_EQ] = ACTIONS(5102),
    [anon_sym_LT_EQ] = ACTIONS(5102),
    [anon_sym_LT] = ACTIONS(5102),
    [anon_sym_LT_LT] = ACTIONS(5102),
    [anon_sym_GT_GT] = ACTIONS(5102),
    [anon_sym___extension__] = ACTIONS(5198),
    [anon_sym___attribute__] = ACTIONS(5102),
    [anon_sym___attribute] = ACTIONS(5102),
    [anon_sym_LBRACE] = ACTIONS(5100),
    [anon_sym_signed] = ACTIONS(5200),
    [anon_sym_unsigned] = ACTIONS(5200),
    [anon_sym_long] = ACTIONS(5200),
    [anon_sym_short] = ACTIONS(5200),
    [anon_sym_LBRACK] = ACTIONS(5100),
    [anon_sym_EQ] = ACTIONS(5102),
    [anon_sym_const] = ACTIONS(5198),
    [anon_sym_constexpr] = ACTIONS(5198),
    [anon_sym_volatile] = ACTIONS(5198),
    [anon_sym_restrict] = ACTIONS(5198),
    [anon_sym___restrict__] = ACTIONS(5198),
    [anon_sym__Atomic] = ACTIONS(5198),
    [anon_sym__Noreturn] = ACTIONS(5198),
    [anon_sym_noreturn] = ACTIONS(5198),
    [anon_sym__Nonnull] = ACTIONS(5198),
    [anon_sym_mutable] = ACTIONS(5198),
    [anon_sym_constinit] = ACTIONS(5198),
    [anon_sym_consteval] = ACTIONS(5198),
    [anon_sym_alignas] = ACTIONS(5202),
    [anon_sym__Alignas] = ACTIONS(5202),
    [sym_primitive_type] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5100),
    [anon_sym_STAR_EQ] = ACTIONS(5100),
    [anon_sym_SLASH_EQ] = ACTIONS(5100),
    [anon_sym_PERCENT_EQ] = ACTIONS(5100),
    [anon_sym_PLUS_EQ] = ACTIONS(5100),
    [anon_sym_DASH_EQ] = ACTIONS(5100),
    [anon_sym_LT_LT_EQ] = ACTIONS(5100),
    [anon_sym_GT_GT_EQ] = ACTIONS(5102),
    [anon_sym_AMP_EQ] = ACTIONS(5100),
    [anon_sym_CARET_EQ] = ACTIONS(5100),
    [anon_sym_PIPE_EQ] = ACTIONS(5100),
    [anon_sym_and_eq] = ACTIONS(5102),
    [anon_sym_or_eq] = ACTIONS(5102),
    [anon_sym_xor_eq] = ACTIONS(5102),
    [anon_sym_LT_EQ_GT] = ACTIONS(5100),
    [anon_sym_or] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5102),
    [anon_sym_bitor] = ACTIONS(5102),
    [anon_sym_xor] = ACTIONS(5102),
    [anon_sym_bitand] = ACTIONS(5102),
    [anon_sym_not_eq] = ACTIONS(5102),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_DOT] = ACTIONS(5102),
    [anon_sym_DOT_STAR] = ACTIONS(5100),
    [anon_sym_DASH_GT] = ACTIONS(5100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5102),
    [anon_sym_decltype] = ACTIONS(5102),
    [anon_sym_GT2] = ACTIONS(5100),
  },
  [1625] = {
    [sym_type_qualifier] = STATE(1624),
    [sym_alignas_qualifier] = STATE(1660),
    [aux_sym__type_definition_type_repeat1] = STATE(1624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1653),
    [sym_identifier] = ACTIONS(5206),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5086),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_LPAREN2] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_STAR] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5088),
    [anon_sym_PERCENT] = ACTIONS(5088),
    [anon_sym_PIPE_PIPE] = ACTIONS(5086),
    [anon_sym_AMP_AMP] = ACTIONS(5086),
    [anon_sym_PIPE] = ACTIONS(5088),
    [anon_sym_CARET] = ACTIONS(5088),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_EQ_EQ] = ACTIONS(5086),
    [anon_sym_BANG_EQ] = ACTIONS(5086),
    [anon_sym_GT] = ACTIONS(5088),
    [anon_sym_GT_EQ] = ACTIONS(5088),
    [anon_sym_LT_EQ] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_LT_LT] = ACTIONS(5088),
    [anon_sym_GT_GT] = ACTIONS(5088),
    [anon_sym___extension__] = ACTIONS(5198),
    [anon_sym___attribute__] = ACTIONS(5088),
    [anon_sym___attribute] = ACTIONS(5088),
    [anon_sym_LBRACE] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5208),
    [anon_sym_unsigned] = ACTIONS(5208),
    [anon_sym_long] = ACTIONS(5208),
    [anon_sym_short] = ACTIONS(5208),
    [anon_sym_LBRACK] = ACTIONS(5086),
    [anon_sym_EQ] = ACTIONS(5088),
    [anon_sym_const] = ACTIONS(5198),
    [anon_sym_constexpr] = ACTIONS(5198),
    [anon_sym_volatile] = ACTIONS(5198),
    [anon_sym_restrict] = ACTIONS(5198),
    [anon_sym___restrict__] = ACTIONS(5198),
    [anon_sym__Atomic] = ACTIONS(5198),
    [anon_sym__Noreturn] = ACTIONS(5198),
    [anon_sym_noreturn] = ACTIONS(5198),
    [anon_sym__Nonnull] = ACTIONS(5198),
    [anon_sym_mutable] = ACTIONS(5198),
    [anon_sym_constinit] = ACTIONS(5198),
    [anon_sym_consteval] = ACTIONS(5198),
    [anon_sym_alignas] = ACTIONS(5202),
    [anon_sym__Alignas] = ACTIONS(5202),
    [sym_primitive_type] = ACTIONS(5210),
    [anon_sym_QMARK] = ACTIONS(5086),
    [anon_sym_STAR_EQ] = ACTIONS(5086),
    [anon_sym_SLASH_EQ] = ACTIONS(5086),
    [anon_sym_PERCENT_EQ] = ACTIONS(5086),
    [anon_sym_PLUS_EQ] = ACTIONS(5086),
    [anon_sym_DASH_EQ] = ACTIONS(5086),
    [anon_sym_LT_LT_EQ] = ACTIONS(5086),
    [anon_sym_GT_GT_EQ] = ACTIONS(5088),
    [anon_sym_AMP_EQ] = ACTIONS(5086),
    [anon_sym_CARET_EQ] = ACTIONS(5086),
    [anon_sym_PIPE_EQ] = ACTIONS(5086),
    [anon_sym_and_eq] = ACTIONS(5088),
    [anon_sym_or_eq] = ACTIONS(5088),
    [anon_sym_xor_eq] = ACTIONS(5088),
    [anon_sym_LT_EQ_GT] = ACTIONS(5086),
    [anon_sym_or] = ACTIONS(5088),
    [anon_sym_and] = ACTIONS(5088),
    [anon_sym_bitor] = ACTIONS(5088),
    [anon_sym_xor] = ACTIONS(5088),
    [anon_sym_bitand] = ACTIONS(5088),
    [anon_sym_not_eq] = ACTIONS(5088),
    [anon_sym_DASH_DASH] = ACTIONS(5086),
    [anon_sym_PLUS_PLUS] = ACTIONS(5086),
    [anon_sym_DOT] = ACTIONS(5088),
    [anon_sym_DOT_STAR] = ACTIONS(5086),
    [anon_sym_DASH_GT] = ACTIONS(5086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5088),
    [anon_sym_decltype] = ACTIONS(5088),
    [anon_sym_GT2] = ACTIONS(5086),
  },
  [1626] = {
    [sym_type_qualifier] = STATE(1626),
    [sym_alignas_qualifier] = STATE(1651),
    [aux_sym__type_definition_type_repeat1] = STATE(1626),
    [sym_identifier] = ACTIONS(5047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5049),
    [anon_sym_COMMA] = ACTIONS(5049),
    [anon_sym_RPAREN] = ACTIONS(5049),
    [anon_sym_LPAREN2] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5047),
    [anon_sym_STAR] = ACTIONS(5047),
    [anon_sym_SLASH] = ACTIONS(5047),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_PIPE] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5047),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5049),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(5047),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym___extension__] = ACTIONS(5212),
    [anon_sym___attribute__] = ACTIONS(5047),
    [anon_sym___attribute] = ACTIONS(5047),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_signed] = ACTIONS(5047),
    [anon_sym_unsigned] = ACTIONS(5047),
    [anon_sym_long] = ACTIONS(5047),
    [anon_sym_short] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [anon_sym_EQ] = ACTIONS(5047),
    [anon_sym_const] = ACTIONS(5212),
    [anon_sym_constexpr] = ACTIONS(5212),
    [anon_sym_volatile] = ACTIONS(5212),
    [anon_sym_restrict] = ACTIONS(5212),
    [anon_sym___restrict__] = ACTIONS(5212),
    [anon_sym__Atomic] = ACTIONS(5212),
    [anon_sym__Noreturn] = ACTIONS(5212),
    [anon_sym_noreturn] = ACTIONS(5212),
    [anon_sym__Nonnull] = ACTIONS(5212),
    [anon_sym_mutable] = ACTIONS(5212),
    [anon_sym_constinit] = ACTIONS(5212),
    [anon_sym_consteval] = ACTIONS(5212),
    [anon_sym_alignas] = ACTIONS(5215),
    [anon_sym__Alignas] = ACTIONS(5215),
    [sym_primitive_type] = ACTIONS(5047),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_STAR_EQ] = ACTIONS(5049),
    [anon_sym_SLASH_EQ] = ACTIONS(5049),
    [anon_sym_PERCENT_EQ] = ACTIONS(5049),
    [anon_sym_PLUS_EQ] = ACTIONS(5049),
    [anon_sym_DASH_EQ] = ACTIONS(5049),
    [anon_sym_LT_LT_EQ] = ACTIONS(5049),
    [anon_sym_GT_GT_EQ] = ACTIONS(5049),
    [anon_sym_AMP_EQ] = ACTIONS(5049),
    [anon_sym_CARET_EQ] = ACTIONS(5049),
    [anon_sym_PIPE_EQ] = ACTIONS(5049),
    [anon_sym_and_eq] = ACTIONS(5047),
    [anon_sym_or_eq] = ACTIONS(5047),
    [anon_sym_xor_eq] = ACTIONS(5047),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_or] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_bitor] = ACTIONS(5047),
    [anon_sym_xor] = ACTIONS(5047),
    [anon_sym_bitand] = ACTIONS(5047),
    [anon_sym_not_eq] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5049),
    [anon_sym_DOT] = ACTIONS(5047),
    [anon_sym_DOT_STAR] = ACTIONS(5049),
    [anon_sym_DASH_GT] = ACTIONS(5047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5047),
    [anon_sym_decltype] = ACTIONS(5047),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5049),
  },
  [1627] = {
    [sym_function_definition] = STATE(791),
    [sym_declaration] = STATE(791),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4658),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1912),
    [sym_declaration_list] = STATE(791),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(5222),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1628] = {
    [sym_type_qualifier] = STATE(1628),
    [sym_alignas_qualifier] = STATE(1660),
    [aux_sym__type_definition_type_repeat1] = STATE(1628),
    [sym_identifier] = ACTIONS(5047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5049),
    [anon_sym_COMMA] = ACTIONS(5049),
    [anon_sym_LPAREN2] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5047),
    [anon_sym_STAR] = ACTIONS(5047),
    [anon_sym_SLASH] = ACTIONS(5047),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_PIPE] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5047),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5049),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5047),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(5047),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym___extension__] = ACTIONS(5224),
    [anon_sym___attribute__] = ACTIONS(5047),
    [anon_sym___attribute] = ACTIONS(5047),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_signed] = ACTIONS(5047),
    [anon_sym_unsigned] = ACTIONS(5047),
    [anon_sym_long] = ACTIONS(5047),
    [anon_sym_short] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [anon_sym_EQ] = ACTIONS(5047),
    [anon_sym_const] = ACTIONS(5224),
    [anon_sym_constexpr] = ACTIONS(5224),
    [anon_sym_volatile] = ACTIONS(5224),
    [anon_sym_restrict] = ACTIONS(5224),
    [anon_sym___restrict__] = ACTIONS(5224),
    [anon_sym__Atomic] = ACTIONS(5224),
    [anon_sym__Noreturn] = ACTIONS(5224),
    [anon_sym_noreturn] = ACTIONS(5224),
    [anon_sym__Nonnull] = ACTIONS(5224),
    [anon_sym_mutable] = ACTIONS(5224),
    [anon_sym_constinit] = ACTIONS(5224),
    [anon_sym_consteval] = ACTIONS(5224),
    [anon_sym_alignas] = ACTIONS(5227),
    [anon_sym__Alignas] = ACTIONS(5227),
    [sym_primitive_type] = ACTIONS(5047),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_STAR_EQ] = ACTIONS(5049),
    [anon_sym_SLASH_EQ] = ACTIONS(5049),
    [anon_sym_PERCENT_EQ] = ACTIONS(5049),
    [anon_sym_PLUS_EQ] = ACTIONS(5049),
    [anon_sym_DASH_EQ] = ACTIONS(5049),
    [anon_sym_LT_LT_EQ] = ACTIONS(5049),
    [anon_sym_GT_GT_EQ] = ACTIONS(5047),
    [anon_sym_AMP_EQ] = ACTIONS(5049),
    [anon_sym_CARET_EQ] = ACTIONS(5049),
    [anon_sym_PIPE_EQ] = ACTIONS(5049),
    [anon_sym_and_eq] = ACTIONS(5047),
    [anon_sym_or_eq] = ACTIONS(5047),
    [anon_sym_xor_eq] = ACTIONS(5047),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_or] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_bitor] = ACTIONS(5047),
    [anon_sym_xor] = ACTIONS(5047),
    [anon_sym_bitand] = ACTIONS(5047),
    [anon_sym_not_eq] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5049),
    [anon_sym_DOT] = ACTIONS(5047),
    [anon_sym_DOT_STAR] = ACTIONS(5049),
    [anon_sym_DASH_GT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5047),
    [anon_sym_decltype] = ACTIONS(5047),
    [anon_sym_GT2] = ACTIONS(5049),
  },
  [1629] = {
    [sym_function_definition] = STATE(777),
    [sym_declaration] = STATE(777),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1924),
    [sym_declaration_list] = STATE(777),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(5230),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1630] = {
    [sym_function_definition] = STATE(484),
    [sym_declaration] = STATE(484),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4748),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1925),
    [sym_declaration_list] = STATE(484),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(5232),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1631] = {
    [sym_function_definition] = STATE(294),
    [sym_declaration] = STATE(294),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1929),
    [sym_declaration_list] = STATE(294),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(5234),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1632] = {
    [sym_function_definition] = STATE(611),
    [sym_declaration] = STATE(611),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4748),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1925),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8408),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5238),
    [anon_sym_struct] = ACTIONS(5240),
    [anon_sym_union] = ACTIONS(5242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1633] = {
    [sym_type_qualifier] = STATE(1633),
    [sym_alignas_qualifier] = STATE(1658),
    [aux_sym__type_definition_type_repeat1] = STATE(1633),
    [sym_identifier] = ACTIONS(5047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5049),
    [anon_sym_COMMA] = ACTIONS(5049),
    [anon_sym_RPAREN] = ACTIONS(5049),
    [anon_sym_LPAREN2] = ACTIONS(5049),
    [anon_sym_TILDE] = ACTIONS(5049),
    [anon_sym_STAR] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_SEMI] = ACTIONS(5049),
    [anon_sym___extension__] = ACTIONS(5244),
    [anon_sym_virtual] = ACTIONS(5047),
    [anon_sym_extern] = ACTIONS(5047),
    [anon_sym___attribute__] = ACTIONS(5047),
    [anon_sym___attribute] = ACTIONS(5047),
    [anon_sym_COLON_COLON] = ACTIONS(5049),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5049),
    [anon_sym___declspec] = ACTIONS(5047),
    [anon_sym___based] = ACTIONS(5047),
    [anon_sym___cdecl] = ACTIONS(5047),
    [anon_sym___clrcall] = ACTIONS(5047),
    [anon_sym___stdcall] = ACTIONS(5047),
    [anon_sym___fastcall] = ACTIONS(5047),
    [anon_sym___thiscall] = ACTIONS(5047),
    [anon_sym___vectorcall] = ACTIONS(5047),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_signed] = ACTIONS(5047),
    [anon_sym_unsigned] = ACTIONS(5047),
    [anon_sym_long] = ACTIONS(5047),
    [anon_sym_short] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [anon_sym_static] = ACTIONS(5047),
    [anon_sym_EQ] = ACTIONS(5049),
    [anon_sym_register] = ACTIONS(5047),
    [anon_sym_inline] = ACTIONS(5047),
    [anon_sym___inline] = ACTIONS(5047),
    [anon_sym___inline__] = ACTIONS(5047),
    [anon_sym___forceinline] = ACTIONS(5047),
    [anon_sym_thread_local] = ACTIONS(5047),
    [anon_sym___thread] = ACTIONS(5047),
    [anon_sym_const] = ACTIONS(5244),
    [anon_sym_constexpr] = ACTIONS(5244),
    [anon_sym_volatile] = ACTIONS(5244),
    [anon_sym_restrict] = ACTIONS(5244),
    [anon_sym___restrict__] = ACTIONS(5244),
    [anon_sym__Atomic] = ACTIONS(5244),
    [anon_sym__Noreturn] = ACTIONS(5244),
    [anon_sym_noreturn] = ACTIONS(5244),
    [anon_sym__Nonnull] = ACTIONS(5244),
    [anon_sym_mutable] = ACTIONS(5244),
    [anon_sym_constinit] = ACTIONS(5244),
    [anon_sym_consteval] = ACTIONS(5244),
    [anon_sym_alignas] = ACTIONS(5247),
    [anon_sym__Alignas] = ACTIONS(5247),
    [sym_primitive_type] = ACTIONS(5047),
    [anon_sym_enum] = ACTIONS(5047),
    [anon_sym_class] = ACTIONS(5047),
    [anon_sym_struct] = ACTIONS(5047),
    [anon_sym_union] = ACTIONS(5047),
    [anon_sym_asm] = ACTIONS(5047),
    [anon_sym___asm__] = ACTIONS(5047),
    [anon_sym___asm] = ACTIONS(5047),
    [anon_sym_DASH_GT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5047),
    [anon_sym_decltype] = ACTIONS(5047),
    [anon_sym_final] = ACTIONS(5047),
    [anon_sym_override] = ACTIONS(5047),
    [anon_sym_typename] = ACTIONS(5047),
    [anon_sym_template] = ACTIONS(5047),
    [anon_sym_GT2] = ACTIONS(5049),
    [anon_sym_operator] = ACTIONS(5047),
    [anon_sym_try] = ACTIONS(5047),
    [anon_sym_noexcept] = ACTIONS(5047),
    [anon_sym_throw] = ACTIONS(5047),
    [anon_sym_requires] = ACTIONS(5047),
  },
  [1634] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1634),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5072),
    [anon_sym_COMMA] = ACTIONS(5072),
    [anon_sym_RPAREN] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_PLUS] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5070),
    [anon_sym_SLASH] = ACTIONS(5070),
    [anon_sym_PERCENT] = ACTIONS(5070),
    [anon_sym_PIPE_PIPE] = ACTIONS(5072),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5070),
    [anon_sym_CARET] = ACTIONS(5070),
    [anon_sym_AMP] = ACTIONS(5070),
    [anon_sym_EQ_EQ] = ACTIONS(5072),
    [anon_sym_BANG_EQ] = ACTIONS(5072),
    [anon_sym_GT] = ACTIONS(5070),
    [anon_sym_GT_EQ] = ACTIONS(5072),
    [anon_sym_LT_EQ] = ACTIONS(5070),
    [anon_sym_LT] = ACTIONS(5070),
    [anon_sym_LT_LT] = ACTIONS(5070),
    [anon_sym_GT_GT] = ACTIONS(5070),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5070),
    [anon_sym___attribute] = ACTIONS(5070),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_signed] = ACTIONS(5250),
    [anon_sym_unsigned] = ACTIONS(5250),
    [anon_sym_long] = ACTIONS(5250),
    [anon_sym_short] = ACTIONS(5250),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_EQ] = ACTIONS(5070),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5072),
    [anon_sym_STAR_EQ] = ACTIONS(5072),
    [anon_sym_SLASH_EQ] = ACTIONS(5072),
    [anon_sym_PERCENT_EQ] = ACTIONS(5072),
    [anon_sym_PLUS_EQ] = ACTIONS(5072),
    [anon_sym_DASH_EQ] = ACTIONS(5072),
    [anon_sym_LT_LT_EQ] = ACTIONS(5072),
    [anon_sym_GT_GT_EQ] = ACTIONS(5072),
    [anon_sym_AMP_EQ] = ACTIONS(5072),
    [anon_sym_CARET_EQ] = ACTIONS(5072),
    [anon_sym_PIPE_EQ] = ACTIONS(5072),
    [anon_sym_and_eq] = ACTIONS(5070),
    [anon_sym_or_eq] = ACTIONS(5070),
    [anon_sym_xor_eq] = ACTIONS(5070),
    [anon_sym_LT_EQ_GT] = ACTIONS(5072),
    [anon_sym_or] = ACTIONS(5070),
    [anon_sym_and] = ACTIONS(5070),
    [anon_sym_bitor] = ACTIONS(5070),
    [anon_sym_xor] = ACTIONS(5070),
    [anon_sym_bitand] = ACTIONS(5070),
    [anon_sym_not_eq] = ACTIONS(5070),
    [anon_sym_DASH_DASH] = ACTIONS(5072),
    [anon_sym_PLUS_PLUS] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5070),
    [anon_sym_DOT_STAR] = ACTIONS(5072),
    [anon_sym_DASH_GT] = ACTIONS(5070),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5070),
    [anon_sym_decltype] = ACTIONS(5070),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5072),
  },
  [1635] = {
    [sym_type_qualifier] = STATE(1654),
    [sym_alignas_qualifier] = STATE(1688),
    [aux_sym__type_definition_type_repeat1] = STATE(1654),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2713),
    [sym_identifier] = ACTIONS(5253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5100),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_RPAREN] = ACTIONS(5100),
    [anon_sym_LPAREN2] = ACTIONS(5100),
    [anon_sym_DASH] = ACTIONS(5102),
    [anon_sym_PLUS] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5102),
    [anon_sym_SLASH] = ACTIONS(5102),
    [anon_sym_PERCENT] = ACTIONS(5102),
    [anon_sym_PIPE_PIPE] = ACTIONS(5100),
    [anon_sym_AMP_AMP] = ACTIONS(5100),
    [anon_sym_PIPE] = ACTIONS(5102),
    [anon_sym_CARET] = ACTIONS(5102),
    [anon_sym_AMP] = ACTIONS(5102),
    [anon_sym_EQ_EQ] = ACTIONS(5100),
    [anon_sym_BANG_EQ] = ACTIONS(5100),
    [anon_sym_GT] = ACTIONS(5102),
    [anon_sym_GT_EQ] = ACTIONS(5100),
    [anon_sym_LT_EQ] = ACTIONS(5102),
    [anon_sym_LT] = ACTIONS(5102),
    [anon_sym_LT_LT] = ACTIONS(5102),
    [anon_sym_GT_GT] = ACTIONS(5102),
    [anon_sym___extension__] = ACTIONS(5255),
    [anon_sym___attribute__] = ACTIONS(5102),
    [anon_sym___attribute] = ACTIONS(5102),
    [anon_sym_LBRACE] = ACTIONS(5100),
    [anon_sym_signed] = ACTIONS(5257),
    [anon_sym_unsigned] = ACTIONS(5257),
    [anon_sym_long] = ACTIONS(5257),
    [anon_sym_short] = ACTIONS(5257),
    [anon_sym_LBRACK] = ACTIONS(5100),
    [anon_sym_EQ] = ACTIONS(5102),
    [anon_sym_const] = ACTIONS(5255),
    [anon_sym_constexpr] = ACTIONS(5255),
    [anon_sym_volatile] = ACTIONS(5255),
    [anon_sym_restrict] = ACTIONS(5255),
    [anon_sym___restrict__] = ACTIONS(5255),
    [anon_sym__Atomic] = ACTIONS(5255),
    [anon_sym__Noreturn] = ACTIONS(5255),
    [anon_sym_noreturn] = ACTIONS(5255),
    [anon_sym__Nonnull] = ACTIONS(5255),
    [anon_sym_mutable] = ACTIONS(5255),
    [anon_sym_constinit] = ACTIONS(5255),
    [anon_sym_consteval] = ACTIONS(5255),
    [anon_sym_alignas] = ACTIONS(5259),
    [anon_sym__Alignas] = ACTIONS(5259),
    [sym_primitive_type] = ACTIONS(5261),
    [anon_sym_QMARK] = ACTIONS(5100),
    [anon_sym_STAR_EQ] = ACTIONS(5100),
    [anon_sym_SLASH_EQ] = ACTIONS(5100),
    [anon_sym_PERCENT_EQ] = ACTIONS(5100),
    [anon_sym_PLUS_EQ] = ACTIONS(5100),
    [anon_sym_DASH_EQ] = ACTIONS(5100),
    [anon_sym_LT_LT_EQ] = ACTIONS(5100),
    [anon_sym_GT_GT_EQ] = ACTIONS(5100),
    [anon_sym_AMP_EQ] = ACTIONS(5100),
    [anon_sym_CARET_EQ] = ACTIONS(5100),
    [anon_sym_PIPE_EQ] = ACTIONS(5100),
    [anon_sym_LT_EQ_GT] = ACTIONS(5100),
    [anon_sym_or] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5102),
    [anon_sym_bitor] = ACTIONS(5102),
    [anon_sym_xor] = ACTIONS(5102),
    [anon_sym_bitand] = ACTIONS(5102),
    [anon_sym_not_eq] = ACTIONS(5102),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_DOT] = ACTIONS(5102),
    [anon_sym_DOT_STAR] = ACTIONS(5100),
    [anon_sym_DASH_GT] = ACTIONS(5102),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5102),
    [anon_sym_decltype] = ACTIONS(5102),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5100),
  },
  [1636] = {
    [sym_function_definition] = STATE(1804),
    [sym_declaration] = STATE(1804),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4676),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1933),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8159),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5263),
    [anon_sym_struct] = ACTIONS(5265),
    [anon_sym_union] = ACTIONS(5267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1637] = {
    [sym_type_qualifier] = STATE(1635),
    [sym_alignas_qualifier] = STATE(1688),
    [aux_sym__type_definition_type_repeat1] = STATE(1635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1672),
    [sym_identifier] = ACTIONS(5269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5086),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_RPAREN] = ACTIONS(5086),
    [anon_sym_LPAREN2] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_STAR] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5088),
    [anon_sym_PERCENT] = ACTIONS(5088),
    [anon_sym_PIPE_PIPE] = ACTIONS(5086),
    [anon_sym_AMP_AMP] = ACTIONS(5086),
    [anon_sym_PIPE] = ACTIONS(5088),
    [anon_sym_CARET] = ACTIONS(5088),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_EQ_EQ] = ACTIONS(5086),
    [anon_sym_BANG_EQ] = ACTIONS(5086),
    [anon_sym_GT] = ACTIONS(5088),
    [anon_sym_GT_EQ] = ACTIONS(5086),
    [anon_sym_LT_EQ] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_LT_LT] = ACTIONS(5088),
    [anon_sym_GT_GT] = ACTIONS(5088),
    [anon_sym___extension__] = ACTIONS(5255),
    [anon_sym___attribute__] = ACTIONS(5088),
    [anon_sym___attribute] = ACTIONS(5088),
    [anon_sym_LBRACE] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5271),
    [anon_sym_unsigned] = ACTIONS(5271),
    [anon_sym_long] = ACTIONS(5271),
    [anon_sym_short] = ACTIONS(5271),
    [anon_sym_LBRACK] = ACTIONS(5086),
    [anon_sym_EQ] = ACTIONS(5088),
    [anon_sym_const] = ACTIONS(5255),
    [anon_sym_constexpr] = ACTIONS(5255),
    [anon_sym_volatile] = ACTIONS(5255),
    [anon_sym_restrict] = ACTIONS(5255),
    [anon_sym___restrict__] = ACTIONS(5255),
    [anon_sym__Atomic] = ACTIONS(5255),
    [anon_sym__Noreturn] = ACTIONS(5255),
    [anon_sym_noreturn] = ACTIONS(5255),
    [anon_sym__Nonnull] = ACTIONS(5255),
    [anon_sym_mutable] = ACTIONS(5255),
    [anon_sym_constinit] = ACTIONS(5255),
    [anon_sym_consteval] = ACTIONS(5255),
    [anon_sym_alignas] = ACTIONS(5259),
    [anon_sym__Alignas] = ACTIONS(5259),
    [sym_primitive_type] = ACTIONS(5273),
    [anon_sym_QMARK] = ACTIONS(5086),
    [anon_sym_STAR_EQ] = ACTIONS(5086),
    [anon_sym_SLASH_EQ] = ACTIONS(5086),
    [anon_sym_PERCENT_EQ] = ACTIONS(5086),
    [anon_sym_PLUS_EQ] = ACTIONS(5086),
    [anon_sym_DASH_EQ] = ACTIONS(5086),
    [anon_sym_LT_LT_EQ] = ACTIONS(5086),
    [anon_sym_GT_GT_EQ] = ACTIONS(5086),
    [anon_sym_AMP_EQ] = ACTIONS(5086),
    [anon_sym_CARET_EQ] = ACTIONS(5086),
    [anon_sym_PIPE_EQ] = ACTIONS(5086),
    [anon_sym_LT_EQ_GT] = ACTIONS(5086),
    [anon_sym_or] = ACTIONS(5088),
    [anon_sym_and] = ACTIONS(5088),
    [anon_sym_bitor] = ACTIONS(5088),
    [anon_sym_xor] = ACTIONS(5088),
    [anon_sym_bitand] = ACTIONS(5088),
    [anon_sym_not_eq] = ACTIONS(5088),
    [anon_sym_DASH_DASH] = ACTIONS(5086),
    [anon_sym_PLUS_PLUS] = ACTIONS(5086),
    [anon_sym_DOT] = ACTIONS(5088),
    [anon_sym_DOT_STAR] = ACTIONS(5086),
    [anon_sym_DASH_GT] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5088),
    [anon_sym_decltype] = ACTIONS(5088),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5086),
  },
  [1638] = {
    [sym_function_definition] = STATE(2098),
    [sym_declaration] = STATE(2098),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4668),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1932),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8305),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5275),
    [anon_sym_struct] = ACTIONS(5277),
    [anon_sym_union] = ACTIONS(5279),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1639] = {
    [sym_function_definition] = STATE(1749),
    [sym_declaration] = STATE(1749),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4676),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1933),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8258),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5281),
    [anon_sym_struct] = ACTIONS(5283),
    [anon_sym_union] = ACTIONS(5285),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1640] = {
    [sym_function_definition] = STATE(735),
    [sym_declaration] = STATE(735),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4658),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1912),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8074),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5287),
    [anon_sym_struct] = ACTIONS(5289),
    [anon_sym_union] = ACTIONS(5291),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1641] = {
    [sym_function_definition] = STATE(762),
    [sym_declaration] = STATE(762),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1924),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8034),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5293),
    [anon_sym_struct] = ACTIONS(5295),
    [anon_sym_union] = ACTIONS(5297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1642] = {
    [sym_function_definition] = STATE(738),
    [sym_declaration] = STATE(738),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4658),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1912),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8118),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5299),
    [anon_sym_struct] = ACTIONS(5301),
    [anon_sym_union] = ACTIONS(5303),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1643] = {
    [sym_function_definition] = STATE(360),
    [sym_declaration] = STATE(360),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1929),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8052),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5305),
    [anon_sym_struct] = ACTIONS(5307),
    [anon_sym_union] = ACTIONS(5309),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1644] = {
    [sym_function_definition] = STATE(2168),
    [sym_declaration] = STATE(2168),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4684),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1934),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8474),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5311),
    [anon_sym_struct] = ACTIONS(5313),
    [anon_sym_union] = ACTIONS(5315),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1645] = {
    [sym_function_definition] = STATE(433),
    [sym_declaration] = STATE(433),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4644),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1929),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8003),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5317),
    [anon_sym_struct] = ACTIONS(5319),
    [anon_sym_union] = ACTIONS(5321),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1646] = {
    [sym_function_definition] = STATE(2157),
    [sym_declaration] = STATE(2157),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4684),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1934),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8440),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5323),
    [anon_sym_struct] = ACTIONS(5325),
    [anon_sym_union] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1647] = {
    [sym_function_definition] = STATE(584),
    [sym_declaration] = STATE(584),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4748),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1925),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8377),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5329),
    [anon_sym_struct] = ACTIONS(5331),
    [anon_sym_union] = ACTIONS(5333),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1648] = {
    [sym_function_definition] = STATE(775),
    [sym_declaration] = STATE(775),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4599),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1924),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(8475),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5335),
    [anon_sym_struct] = ACTIONS(5337),
    [anon_sym_union] = ACTIONS(5339),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1649] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1634),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5156),
    [anon_sym_COMMA] = ACTIONS(5156),
    [anon_sym_RPAREN] = ACTIONS(5156),
    [anon_sym_LPAREN2] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5159),
    [anon_sym_STAR] = ACTIONS(5159),
    [anon_sym_SLASH] = ACTIONS(5159),
    [anon_sym_PERCENT] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5156),
    [anon_sym_AMP_AMP] = ACTIONS(5156),
    [anon_sym_PIPE] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5159),
    [anon_sym_AMP] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5156),
    [anon_sym_BANG_EQ] = ACTIONS(5156),
    [anon_sym_GT] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5156),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5159),
    [anon_sym_LT_LT] = ACTIONS(5159),
    [anon_sym_GT_GT] = ACTIONS(5159),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5159),
    [anon_sym___attribute] = ACTIONS(5159),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_signed] = ACTIONS(5250),
    [anon_sym_unsigned] = ACTIONS(5250),
    [anon_sym_long] = ACTIONS(5250),
    [anon_sym_short] = ACTIONS(5250),
    [anon_sym_LBRACK] = ACTIONS(5156),
    [anon_sym_EQ] = ACTIONS(5159),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5156),
    [anon_sym_STAR_EQ] = ACTIONS(5156),
    [anon_sym_SLASH_EQ] = ACTIONS(5156),
    [anon_sym_PERCENT_EQ] = ACTIONS(5156),
    [anon_sym_PLUS_EQ] = ACTIONS(5156),
    [anon_sym_DASH_EQ] = ACTIONS(5156),
    [anon_sym_LT_LT_EQ] = ACTIONS(5156),
    [anon_sym_GT_GT_EQ] = ACTIONS(5156),
    [anon_sym_AMP_EQ] = ACTIONS(5156),
    [anon_sym_CARET_EQ] = ACTIONS(5156),
    [anon_sym_PIPE_EQ] = ACTIONS(5156),
    [anon_sym_and_eq] = ACTIONS(5159),
    [anon_sym_or_eq] = ACTIONS(5159),
    [anon_sym_xor_eq] = ACTIONS(5159),
    [anon_sym_LT_EQ_GT] = ACTIONS(5156),
    [anon_sym_or] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_bitor] = ACTIONS(5159),
    [anon_sym_xor] = ACTIONS(5159),
    [anon_sym_bitand] = ACTIONS(5159),
    [anon_sym_not_eq] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5156),
    [anon_sym_PLUS_PLUS] = ACTIONS(5156),
    [anon_sym_DOT] = ACTIONS(5159),
    [anon_sym_DOT_STAR] = ACTIONS(5156),
    [anon_sym_DASH_GT] = ACTIONS(5159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5159),
    [anon_sym_decltype] = ACTIONS(5159),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5156),
  },
  [1650] = {
    [sym_function_definition] = STATE(2022),
    [sym_declaration] = STATE(2022),
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4668),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_ms_call_modifier] = STATE(1932),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym__class_name] = STATE(7976),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(3706),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3798),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(5341),
    [anon_sym_struct] = ACTIONS(5343),
    [anon_sym_union] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1651] = {
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2563),
    [anon_sym_RPAREN] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2573),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_CARET] = ACTIONS(2573),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_and_eq] = ACTIONS(2573),
    [anon_sym_or_eq] = ACTIONS(2573),
    [anon_sym_xor_eq] = ACTIONS(2573),
    [anon_sym_LT_EQ_GT] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2573),
    [anon_sym_and] = ACTIONS(2573),
    [anon_sym_bitor] = ACTIONS(2573),
    [anon_sym_xor] = ACTIONS(2573),
    [anon_sym_bitand] = ACTIONS(2573),
    [anon_sym_not_eq] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_PLUS] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2573),
    [anon_sym_DOT_STAR] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2563),
  },
  [1652] = {
    [sym_identifier] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5082),
    [anon_sym_COMMA] = ACTIONS(5082),
    [anon_sym_RPAREN] = ACTIONS(5082),
    [anon_sym_LPAREN2] = ACTIONS(5082),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5080),
    [anon_sym_SLASH] = ACTIONS(5080),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5082),
    [anon_sym_AMP_AMP] = ACTIONS(5082),
    [anon_sym_PIPE] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5082),
    [anon_sym_BANG_EQ] = ACTIONS(5082),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_EQ] = ACTIONS(5080),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym___extension__] = ACTIONS(5080),
    [anon_sym___attribute__] = ACTIONS(5080),
    [anon_sym___attribute] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5082),
    [anon_sym_signed] = ACTIONS(5080),
    [anon_sym_unsigned] = ACTIONS(5080),
    [anon_sym_long] = ACTIONS(5080),
    [anon_sym_short] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5082),
    [anon_sym_EQ] = ACTIONS(5080),
    [anon_sym_const] = ACTIONS(5080),
    [anon_sym_constexpr] = ACTIONS(5080),
    [anon_sym_volatile] = ACTIONS(5080),
    [anon_sym_restrict] = ACTIONS(5080),
    [anon_sym___restrict__] = ACTIONS(5080),
    [anon_sym__Atomic] = ACTIONS(5080),
    [anon_sym__Noreturn] = ACTIONS(5080),
    [anon_sym_noreturn] = ACTIONS(5080),
    [anon_sym__Nonnull] = ACTIONS(5080),
    [anon_sym_mutable] = ACTIONS(5080),
    [anon_sym_constinit] = ACTIONS(5080),
    [anon_sym_consteval] = ACTIONS(5080),
    [anon_sym_alignas] = ACTIONS(5080),
    [anon_sym__Alignas] = ACTIONS(5080),
    [sym_primitive_type] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5082),
    [anon_sym_STAR_EQ] = ACTIONS(5082),
    [anon_sym_SLASH_EQ] = ACTIONS(5082),
    [anon_sym_PERCENT_EQ] = ACTIONS(5082),
    [anon_sym_PLUS_EQ] = ACTIONS(5082),
    [anon_sym_DASH_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_GT_EQ] = ACTIONS(5082),
    [anon_sym_AMP_EQ] = ACTIONS(5082),
    [anon_sym_CARET_EQ] = ACTIONS(5082),
    [anon_sym_PIPE_EQ] = ACTIONS(5082),
    [anon_sym_and_eq] = ACTIONS(5080),
    [anon_sym_or_eq] = ACTIONS(5080),
    [anon_sym_xor_eq] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(5082),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_bitor] = ACTIONS(5080),
    [anon_sym_xor] = ACTIONS(5080),
    [anon_sym_bitand] = ACTIONS(5080),
    [anon_sym_not_eq] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5082),
    [anon_sym_PLUS_PLUS] = ACTIONS(5082),
    [anon_sym_DOT] = ACTIONS(5080),
    [anon_sym_DOT_STAR] = ACTIONS(5082),
    [anon_sym_DASH_GT] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5080),
    [anon_sym_decltype] = ACTIONS(5080),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5082),
  },
  [1653] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1656),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5156),
    [anon_sym_COMMA] = ACTIONS(5156),
    [anon_sym_LPAREN2] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5159),
    [anon_sym_STAR] = ACTIONS(5159),
    [anon_sym_SLASH] = ACTIONS(5159),
    [anon_sym_PERCENT] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5156),
    [anon_sym_AMP_AMP] = ACTIONS(5156),
    [anon_sym_PIPE] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5159),
    [anon_sym_AMP] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5156),
    [anon_sym_BANG_EQ] = ACTIONS(5156),
    [anon_sym_GT] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5159),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5159),
    [anon_sym_LT_LT] = ACTIONS(5159),
    [anon_sym_GT_GT] = ACTIONS(5159),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5159),
    [anon_sym___attribute] = ACTIONS(5159),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_signed] = ACTIONS(5347),
    [anon_sym_unsigned] = ACTIONS(5347),
    [anon_sym_long] = ACTIONS(5347),
    [anon_sym_short] = ACTIONS(5347),
    [anon_sym_LBRACK] = ACTIONS(5156),
    [anon_sym_EQ] = ACTIONS(5159),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5156),
    [anon_sym_STAR_EQ] = ACTIONS(5156),
    [anon_sym_SLASH_EQ] = ACTIONS(5156),
    [anon_sym_PERCENT_EQ] = ACTIONS(5156),
    [anon_sym_PLUS_EQ] = ACTIONS(5156),
    [anon_sym_DASH_EQ] = ACTIONS(5156),
    [anon_sym_LT_LT_EQ] = ACTIONS(5156),
    [anon_sym_GT_GT_EQ] = ACTIONS(5159),
    [anon_sym_AMP_EQ] = ACTIONS(5156),
    [anon_sym_CARET_EQ] = ACTIONS(5156),
    [anon_sym_PIPE_EQ] = ACTIONS(5156),
    [anon_sym_and_eq] = ACTIONS(5159),
    [anon_sym_or_eq] = ACTIONS(5159),
    [anon_sym_xor_eq] = ACTIONS(5159),
    [anon_sym_LT_EQ_GT] = ACTIONS(5156),
    [anon_sym_or] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_bitor] = ACTIONS(5159),
    [anon_sym_xor] = ACTIONS(5159),
    [anon_sym_bitand] = ACTIONS(5159),
    [anon_sym_not_eq] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5156),
    [anon_sym_PLUS_PLUS] = ACTIONS(5156),
    [anon_sym_DOT] = ACTIONS(5159),
    [anon_sym_DOT_STAR] = ACTIONS(5156),
    [anon_sym_DASH_GT] = ACTIONS(5156),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5159),
    [anon_sym_decltype] = ACTIONS(5159),
    [anon_sym_GT2] = ACTIONS(5156),
  },
  [1654] = {
    [sym_type_qualifier] = STATE(1654),
    [sym_alignas_qualifier] = STATE(1688),
    [aux_sym__type_definition_type_repeat1] = STATE(1654),
    [sym_identifier] = ACTIONS(5047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5049),
    [anon_sym_COMMA] = ACTIONS(5049),
    [anon_sym_RPAREN] = ACTIONS(5049),
    [anon_sym_LPAREN2] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5047),
    [anon_sym_STAR] = ACTIONS(5047),
    [anon_sym_SLASH] = ACTIONS(5047),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_PIPE] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5047),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5049),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(5047),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym___extension__] = ACTIONS(5350),
    [anon_sym___attribute__] = ACTIONS(5047),
    [anon_sym___attribute] = ACTIONS(5047),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_signed] = ACTIONS(5047),
    [anon_sym_unsigned] = ACTIONS(5047),
    [anon_sym_long] = ACTIONS(5047),
    [anon_sym_short] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [anon_sym_EQ] = ACTIONS(5047),
    [anon_sym_const] = ACTIONS(5350),
    [anon_sym_constexpr] = ACTIONS(5350),
    [anon_sym_volatile] = ACTIONS(5350),
    [anon_sym_restrict] = ACTIONS(5350),
    [anon_sym___restrict__] = ACTIONS(5350),
    [anon_sym__Atomic] = ACTIONS(5350),
    [anon_sym__Noreturn] = ACTIONS(5350),
    [anon_sym_noreturn] = ACTIONS(5350),
    [anon_sym__Nonnull] = ACTIONS(5350),
    [anon_sym_mutable] = ACTIONS(5350),
    [anon_sym_constinit] = ACTIONS(5350),
    [anon_sym_consteval] = ACTIONS(5350),
    [anon_sym_alignas] = ACTIONS(5353),
    [anon_sym__Alignas] = ACTIONS(5353),
    [sym_primitive_type] = ACTIONS(5047),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_STAR_EQ] = ACTIONS(5049),
    [anon_sym_SLASH_EQ] = ACTIONS(5049),
    [anon_sym_PERCENT_EQ] = ACTIONS(5049),
    [anon_sym_PLUS_EQ] = ACTIONS(5049),
    [anon_sym_DASH_EQ] = ACTIONS(5049),
    [anon_sym_LT_LT_EQ] = ACTIONS(5049),
    [anon_sym_GT_GT_EQ] = ACTIONS(5049),
    [anon_sym_AMP_EQ] = ACTIONS(5049),
    [anon_sym_CARET_EQ] = ACTIONS(5049),
    [anon_sym_PIPE_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_or] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_bitor] = ACTIONS(5047),
    [anon_sym_xor] = ACTIONS(5047),
    [anon_sym_bitand] = ACTIONS(5047),
    [anon_sym_not_eq] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5049),
    [anon_sym_DOT] = ACTIONS(5047),
    [anon_sym_DOT_STAR] = ACTIONS(5049),
    [anon_sym_DASH_GT] = ACTIONS(5047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5047),
    [anon_sym_decltype] = ACTIONS(5047),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5049),
  },
  [1655] = {
    [sym_type_qualifier] = STATE(1655),
    [sym_alignas_qualifier] = STATE(1695),
    [aux_sym__type_definition_type_repeat1] = STATE(1655),
    [sym_identifier] = ACTIONS(5047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5049),
    [anon_sym_COMMA] = ACTIONS(5049),
    [anon_sym_RPAREN] = ACTIONS(5049),
    [aux_sym_preproc_if_token2] = ACTIONS(5049),
    [aux_sym_preproc_else_token1] = ACTIONS(5049),
    [aux_sym_preproc_elif_token1] = ACTIONS(5047),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5049),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5049),
    [anon_sym_LPAREN2] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5047),
    [anon_sym_STAR] = ACTIONS(5049),
    [anon_sym_SLASH] = ACTIONS(5047),
    [anon_sym_PERCENT] = ACTIONS(5049),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_PIPE] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5049),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5049),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(5049),
    [anon_sym_GT_GT] = ACTIONS(5049),
    [anon_sym_SEMI] = ACTIONS(5049),
    [anon_sym___extension__] = ACTIONS(5356),
    [anon_sym___attribute__] = ACTIONS(5047),
    [anon_sym___attribute] = ACTIONS(5047),
    [anon_sym_COLON] = ACTIONS(5049),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_RBRACE] = ACTIONS(5049),
    [anon_sym_signed] = ACTIONS(5047),
    [anon_sym_unsigned] = ACTIONS(5047),
    [anon_sym_long] = ACTIONS(5047),
    [anon_sym_short] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [anon_sym_RBRACK] = ACTIONS(5049),
    [anon_sym_const] = ACTIONS(5356),
    [anon_sym_constexpr] = ACTIONS(5356),
    [anon_sym_volatile] = ACTIONS(5356),
    [anon_sym_restrict] = ACTIONS(5356),
    [anon_sym___restrict__] = ACTIONS(5356),
    [anon_sym__Atomic] = ACTIONS(5356),
    [anon_sym__Noreturn] = ACTIONS(5356),
    [anon_sym_noreturn] = ACTIONS(5356),
    [anon_sym__Nonnull] = ACTIONS(5356),
    [anon_sym_mutable] = ACTIONS(5356),
    [anon_sym_constinit] = ACTIONS(5356),
    [anon_sym_consteval] = ACTIONS(5356),
    [anon_sym_alignas] = ACTIONS(5359),
    [anon_sym__Alignas] = ACTIONS(5359),
    [sym_primitive_type] = ACTIONS(5047),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_or] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_bitor] = ACTIONS(5047),
    [anon_sym_xor] = ACTIONS(5047),
    [anon_sym_bitand] = ACTIONS(5047),
    [anon_sym_not_eq] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5049),
    [anon_sym_DOT] = ACTIONS(5047),
    [anon_sym_DOT_STAR] = ACTIONS(5049),
    [anon_sym_DASH_GT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5047),
    [anon_sym_decltype] = ACTIONS(5047),
    [anon_sym_final] = ACTIONS(5047),
    [anon_sym_override] = ACTIONS(5047),
    [anon_sym_requires] = ACTIONS(5047),
  },
  [1656] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1656),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5072),
    [anon_sym_COMMA] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_PLUS] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5070),
    [anon_sym_SLASH] = ACTIONS(5070),
    [anon_sym_PERCENT] = ACTIONS(5070),
    [anon_sym_PIPE_PIPE] = ACTIONS(5072),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5070),
    [anon_sym_CARET] = ACTIONS(5070),
    [anon_sym_AMP] = ACTIONS(5070),
    [anon_sym_EQ_EQ] = ACTIONS(5072),
    [anon_sym_BANG_EQ] = ACTIONS(5072),
    [anon_sym_GT] = ACTIONS(5070),
    [anon_sym_GT_EQ] = ACTIONS(5070),
    [anon_sym_LT_EQ] = ACTIONS(5070),
    [anon_sym_LT] = ACTIONS(5070),
    [anon_sym_LT_LT] = ACTIONS(5070),
    [anon_sym_GT_GT] = ACTIONS(5070),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5070),
    [anon_sym___attribute] = ACTIONS(5070),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_signed] = ACTIONS(5347),
    [anon_sym_unsigned] = ACTIONS(5347),
    [anon_sym_long] = ACTIONS(5347),
    [anon_sym_short] = ACTIONS(5347),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_EQ] = ACTIONS(5070),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5072),
    [anon_sym_STAR_EQ] = ACTIONS(5072),
    [anon_sym_SLASH_EQ] = ACTIONS(5072),
    [anon_sym_PERCENT_EQ] = ACTIONS(5072),
    [anon_sym_PLUS_EQ] = ACTIONS(5072),
    [anon_sym_DASH_EQ] = ACTIONS(5072),
    [anon_sym_LT_LT_EQ] = ACTIONS(5072),
    [anon_sym_GT_GT_EQ] = ACTIONS(5070),
    [anon_sym_AMP_EQ] = ACTIONS(5072),
    [anon_sym_CARET_EQ] = ACTIONS(5072),
    [anon_sym_PIPE_EQ] = ACTIONS(5072),
    [anon_sym_and_eq] = ACTIONS(5070),
    [anon_sym_or_eq] = ACTIONS(5070),
    [anon_sym_xor_eq] = ACTIONS(5070),
    [anon_sym_LT_EQ_GT] = ACTIONS(5072),
    [anon_sym_or] = ACTIONS(5070),
    [anon_sym_and] = ACTIONS(5070),
    [anon_sym_bitor] = ACTIONS(5070),
    [anon_sym_xor] = ACTIONS(5070),
    [anon_sym_bitand] = ACTIONS(5070),
    [anon_sym_not_eq] = ACTIONS(5070),
    [anon_sym_DASH_DASH] = ACTIONS(5072),
    [anon_sym_PLUS_PLUS] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5070),
    [anon_sym_DOT_STAR] = ACTIONS(5072),
    [anon_sym_DASH_GT] = ACTIONS(5072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5070),
    [anon_sym_decltype] = ACTIONS(5070),
    [anon_sym_GT2] = ACTIONS(5072),
  },
  [1657] = {
    [sym_identifier] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5082),
    [anon_sym_COMMA] = ACTIONS(5082),
    [anon_sym_RPAREN] = ACTIONS(5082),
    [anon_sym_LPAREN2] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP_AMP] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5080),
    [anon_sym_virtual] = ACTIONS(5080),
    [anon_sym_extern] = ACTIONS(5080),
    [anon_sym___attribute__] = ACTIONS(5080),
    [anon_sym___attribute] = ACTIONS(5080),
    [anon_sym_COLON_COLON] = ACTIONS(5082),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5082),
    [anon_sym___declspec] = ACTIONS(5080),
    [anon_sym___based] = ACTIONS(5080),
    [anon_sym___cdecl] = ACTIONS(5080),
    [anon_sym___clrcall] = ACTIONS(5080),
    [anon_sym___stdcall] = ACTIONS(5080),
    [anon_sym___fastcall] = ACTIONS(5080),
    [anon_sym___thiscall] = ACTIONS(5080),
    [anon_sym___vectorcall] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5082),
    [anon_sym_signed] = ACTIONS(5080),
    [anon_sym_unsigned] = ACTIONS(5080),
    [anon_sym_long] = ACTIONS(5080),
    [anon_sym_short] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_static] = ACTIONS(5080),
    [anon_sym_EQ] = ACTIONS(5082),
    [anon_sym_register] = ACTIONS(5080),
    [anon_sym_inline] = ACTIONS(5080),
    [anon_sym___inline] = ACTIONS(5080),
    [anon_sym___inline__] = ACTIONS(5080),
    [anon_sym___forceinline] = ACTIONS(5080),
    [anon_sym_thread_local] = ACTIONS(5080),
    [anon_sym___thread] = ACTIONS(5080),
    [anon_sym_const] = ACTIONS(5080),
    [anon_sym_constexpr] = ACTIONS(5080),
    [anon_sym_volatile] = ACTIONS(5080),
    [anon_sym_restrict] = ACTIONS(5080),
    [anon_sym___restrict__] = ACTIONS(5080),
    [anon_sym__Atomic] = ACTIONS(5080),
    [anon_sym__Noreturn] = ACTIONS(5080),
    [anon_sym_noreturn] = ACTIONS(5080),
    [anon_sym__Nonnull] = ACTIONS(5080),
    [anon_sym_mutable] = ACTIONS(5080),
    [anon_sym_constinit] = ACTIONS(5080),
    [anon_sym_consteval] = ACTIONS(5080),
    [anon_sym_alignas] = ACTIONS(5080),
    [anon_sym__Alignas] = ACTIONS(5080),
    [sym_primitive_type] = ACTIONS(5080),
    [anon_sym_enum] = ACTIONS(5080),
    [anon_sym_class] = ACTIONS(5080),
    [anon_sym_struct] = ACTIONS(5080),
    [anon_sym_union] = ACTIONS(5080),
    [anon_sym_asm] = ACTIONS(5080),
    [anon_sym___asm__] = ACTIONS(5080),
    [anon_sym___asm] = ACTIONS(5080),
    [anon_sym_DASH_GT] = ACTIONS(5082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5080),
    [anon_sym_decltype] = ACTIONS(5080),
    [anon_sym_final] = ACTIONS(5080),
    [anon_sym_override] = ACTIONS(5080),
    [anon_sym_explicit] = ACTIONS(5080),
    [anon_sym_typename] = ACTIONS(5080),
    [anon_sym_template] = ACTIONS(5080),
    [anon_sym_GT2] = ACTIONS(5082),
    [anon_sym_operator] = ACTIONS(5080),
    [anon_sym_try] = ACTIONS(5080),
    [anon_sym_noexcept] = ACTIONS(5080),
    [anon_sym_throw] = ACTIONS(5080),
    [anon_sym_requires] = ACTIONS(5080),
  },
  [1658] = {
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2563),
    [anon_sym_RPAREN] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2563),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2563),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2563),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym___cdecl] = ACTIONS(2573),
    [anon_sym___clrcall] = ACTIONS(2573),
    [anon_sym___stdcall] = ACTIONS(2573),
    [anon_sym___fastcall] = ACTIONS(2573),
    [anon_sym___thiscall] = ACTIONS(2573),
    [anon_sym___vectorcall] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2573),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_EQ] = ACTIONS(2563),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_asm] = ACTIONS(2573),
    [anon_sym___asm__] = ACTIONS(2573),
    [anon_sym___asm] = ACTIONS(2573),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_final] = ACTIONS(2573),
    [anon_sym_override] = ACTIONS(2573),
    [anon_sym_explicit] = ACTIONS(2573),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2573),
    [anon_sym_GT2] = ACTIONS(2563),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_try] = ACTIONS(2573),
    [anon_sym_noexcept] = ACTIONS(2573),
    [anon_sym_throw] = ACTIONS(2573),
    [anon_sym_requires] = ACTIONS(2573),
  },
  [1659] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5000),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(4998),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(4998),
    [anon_sym_GT_GT] = ACTIONS(4998),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5003),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym__Nonnull] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym__Alignas] = ACTIONS(4996),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(5005),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(5005),
    [anon_sym_not_eq] = ACTIONS(5005),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
  },
  [1660] = {
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2573),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_CARET] = ACTIONS(2573),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_GT_GT_EQ] = ACTIONS(2573),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_and_eq] = ACTIONS(2573),
    [anon_sym_or_eq] = ACTIONS(2573),
    [anon_sym_xor_eq] = ACTIONS(2573),
    [anon_sym_LT_EQ_GT] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2573),
    [anon_sym_and] = ACTIONS(2573),
    [anon_sym_bitor] = ACTIONS(2573),
    [anon_sym_xor] = ACTIONS(2573),
    [anon_sym_bitand] = ACTIONS(2573),
    [anon_sym_not_eq] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_PLUS] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2573),
    [anon_sym_DOT_STAR] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_GT2] = ACTIONS(2563),
  },
  [1661] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3972),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7283),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_type_parameter_declaration] = STATE(7283),
    [sym_variadic_type_parameter_declaration] = STATE(7283),
    [sym_optional_type_parameter_declaration] = STATE(7283),
    [sym_template_template_parameter_declaration] = STATE(7283),
    [sym_optional_parameter_declaration] = STATE(7283),
    [sym_variadic_parameter_declaration] = STATE(7283),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(5362),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5364),
    [anon_sym_template] = ACTIONS(5366),
    [anon_sym_GT2] = ACTIONS(5368),
  },
  [1662] = {
    [sym_identifier] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5082),
    [anon_sym_COMMA] = ACTIONS(5082),
    [anon_sym_LPAREN2] = ACTIONS(5082),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5080),
    [anon_sym_SLASH] = ACTIONS(5080),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5082),
    [anon_sym_AMP_AMP] = ACTIONS(5082),
    [anon_sym_PIPE] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5082),
    [anon_sym_BANG_EQ] = ACTIONS(5082),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5080),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym___extension__] = ACTIONS(5080),
    [anon_sym___attribute__] = ACTIONS(5080),
    [anon_sym___attribute] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5082),
    [anon_sym_signed] = ACTIONS(5080),
    [anon_sym_unsigned] = ACTIONS(5080),
    [anon_sym_long] = ACTIONS(5080),
    [anon_sym_short] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5082),
    [anon_sym_EQ] = ACTIONS(5080),
    [anon_sym_const] = ACTIONS(5080),
    [anon_sym_constexpr] = ACTIONS(5080),
    [anon_sym_volatile] = ACTIONS(5080),
    [anon_sym_restrict] = ACTIONS(5080),
    [anon_sym___restrict__] = ACTIONS(5080),
    [anon_sym__Atomic] = ACTIONS(5080),
    [anon_sym__Noreturn] = ACTIONS(5080),
    [anon_sym_noreturn] = ACTIONS(5080),
    [anon_sym__Nonnull] = ACTIONS(5080),
    [anon_sym_mutable] = ACTIONS(5080),
    [anon_sym_constinit] = ACTIONS(5080),
    [anon_sym_consteval] = ACTIONS(5080),
    [anon_sym_alignas] = ACTIONS(5080),
    [anon_sym__Alignas] = ACTIONS(5080),
    [sym_primitive_type] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5082),
    [anon_sym_STAR_EQ] = ACTIONS(5082),
    [anon_sym_SLASH_EQ] = ACTIONS(5082),
    [anon_sym_PERCENT_EQ] = ACTIONS(5082),
    [anon_sym_PLUS_EQ] = ACTIONS(5082),
    [anon_sym_DASH_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_GT_EQ] = ACTIONS(5080),
    [anon_sym_AMP_EQ] = ACTIONS(5082),
    [anon_sym_CARET_EQ] = ACTIONS(5082),
    [anon_sym_PIPE_EQ] = ACTIONS(5082),
    [anon_sym_and_eq] = ACTIONS(5080),
    [anon_sym_or_eq] = ACTIONS(5080),
    [anon_sym_xor_eq] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(5082),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_bitor] = ACTIONS(5080),
    [anon_sym_xor] = ACTIONS(5080),
    [anon_sym_bitand] = ACTIONS(5080),
    [anon_sym_not_eq] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5082),
    [anon_sym_PLUS_PLUS] = ACTIONS(5082),
    [anon_sym_DOT] = ACTIONS(5080),
    [anon_sym_DOT_STAR] = ACTIONS(5082),
    [anon_sym_DASH_GT] = ACTIONS(5082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5080),
    [anon_sym_decltype] = ACTIONS(5080),
    [anon_sym_GT2] = ACTIONS(5082),
  },
  [1663] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3972),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7744),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_type_parameter_declaration] = STATE(7744),
    [sym_variadic_type_parameter_declaration] = STATE(7744),
    [sym_optional_type_parameter_declaration] = STATE(7744),
    [sym_template_template_parameter_declaration] = STATE(7744),
    [sym_optional_parameter_declaration] = STATE(7744),
    [sym_variadic_parameter_declaration] = STATE(7744),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(5362),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5364),
    [anon_sym_template] = ACTIONS(5366),
  },
  [1664] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4953),
    [anon_sym_COMMA] = ACTIONS(4953),
    [anon_sym_RPAREN] = ACTIONS(4953),
    [anon_sym_LPAREN2] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4951),
    [anon_sym_SLASH] = ACTIONS(4951),
    [anon_sym_PERCENT] = ACTIONS(4951),
    [anon_sym_PIPE_PIPE] = ACTIONS(4953),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_PIPE] = ACTIONS(4951),
    [anon_sym_CARET] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_EQ_EQ] = ACTIONS(4953),
    [anon_sym_BANG_EQ] = ACTIONS(4953),
    [anon_sym_GT] = ACTIONS(4951),
    [anon_sym_GT_EQ] = ACTIONS(4953),
    [anon_sym_LT_EQ] = ACTIONS(4951),
    [anon_sym_LT] = ACTIONS(4951),
    [anon_sym_LT_LT] = ACTIONS(4951),
    [anon_sym_GT_GT] = ACTIONS(4951),
    [anon_sym___extension__] = ACTIONS(4953),
    [anon_sym___attribute__] = ACTIONS(4953),
    [anon_sym___attribute] = ACTIONS(4951),
    [anon_sym_COLON] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4953),
    [anon_sym_LBRACE] = ACTIONS(4953),
    [anon_sym_LBRACK] = ACTIONS(4953),
    [anon_sym_EQ] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4953),
    [anon_sym_volatile] = ACTIONS(4953),
    [anon_sym_restrict] = ACTIONS(4953),
    [anon_sym___restrict__] = ACTIONS(4953),
    [anon_sym__Atomic] = ACTIONS(4953),
    [anon_sym__Noreturn] = ACTIONS(4953),
    [anon_sym_noreturn] = ACTIONS(4953),
    [anon_sym__Nonnull] = ACTIONS(4953),
    [anon_sym_mutable] = ACTIONS(4953),
    [anon_sym_constinit] = ACTIONS(4953),
    [anon_sym_consteval] = ACTIONS(4953),
    [anon_sym_alignas] = ACTIONS(4953),
    [anon_sym__Alignas] = ACTIONS(4953),
    [anon_sym_QMARK] = ACTIONS(4953),
    [anon_sym_STAR_EQ] = ACTIONS(4953),
    [anon_sym_SLASH_EQ] = ACTIONS(4953),
    [anon_sym_PERCENT_EQ] = ACTIONS(4953),
    [anon_sym_PLUS_EQ] = ACTIONS(4953),
    [anon_sym_DASH_EQ] = ACTIONS(4953),
    [anon_sym_LT_LT_EQ] = ACTIONS(4953),
    [anon_sym_GT_GT_EQ] = ACTIONS(4953),
    [anon_sym_AMP_EQ] = ACTIONS(4953),
    [anon_sym_CARET_EQ] = ACTIONS(4953),
    [anon_sym_PIPE_EQ] = ACTIONS(4953),
    [anon_sym_and_eq] = ACTIONS(4953),
    [anon_sym_or_eq] = ACTIONS(4953),
    [anon_sym_xor_eq] = ACTIONS(4953),
    [anon_sym_LT_EQ_GT] = ACTIONS(4953),
    [anon_sym_or] = ACTIONS(4951),
    [anon_sym_and] = ACTIONS(4951),
    [anon_sym_bitor] = ACTIONS(4953),
    [anon_sym_xor] = ACTIONS(4951),
    [anon_sym_bitand] = ACTIONS(4953),
    [anon_sym_not_eq] = ACTIONS(4953),
    [anon_sym_DASH_DASH] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4953),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_DOT_STAR] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(4951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4953),
    [anon_sym_decltype] = ACTIONS(4953),
    [anon_sym_final] = ACTIONS(4953),
    [anon_sym_override] = ACTIONS(4953),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4953),
  },
  [1665] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_RPAREN] = ACTIONS(4982),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_DASH] = ACTIONS(4980),
    [anon_sym_PLUS] = ACTIONS(4980),
    [anon_sym_STAR] = ACTIONS(4980),
    [anon_sym_SLASH] = ACTIONS(4980),
    [anon_sym_PERCENT] = ACTIONS(4980),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4980),
    [anon_sym_CARET] = ACTIONS(4980),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4982),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_LT_LT] = ACTIONS(4980),
    [anon_sym_GT_GT] = ACTIONS(4980),
    [anon_sym___extension__] = ACTIONS(4982),
    [anon_sym___attribute__] = ACTIONS(4982),
    [anon_sym___attribute] = ACTIONS(4980),
    [anon_sym_COLON] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACE] = ACTIONS(4982),
    [anon_sym_LBRACK] = ACTIONS(4982),
    [anon_sym_EQ] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4982),
    [anon_sym_volatile] = ACTIONS(4982),
    [anon_sym_restrict] = ACTIONS(4982),
    [anon_sym___restrict__] = ACTIONS(4982),
    [anon_sym__Atomic] = ACTIONS(4982),
    [anon_sym__Noreturn] = ACTIONS(4982),
    [anon_sym_noreturn] = ACTIONS(4982),
    [anon_sym__Nonnull] = ACTIONS(4982),
    [anon_sym_mutable] = ACTIONS(4982),
    [anon_sym_constinit] = ACTIONS(4982),
    [anon_sym_consteval] = ACTIONS(4982),
    [anon_sym_alignas] = ACTIONS(4982),
    [anon_sym__Alignas] = ACTIONS(4982),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_STAR_EQ] = ACTIONS(4982),
    [anon_sym_SLASH_EQ] = ACTIONS(4982),
    [anon_sym_PERCENT_EQ] = ACTIONS(4982),
    [anon_sym_PLUS_EQ] = ACTIONS(4982),
    [anon_sym_DASH_EQ] = ACTIONS(4982),
    [anon_sym_LT_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT_GT_EQ] = ACTIONS(4982),
    [anon_sym_AMP_EQ] = ACTIONS(4982),
    [anon_sym_CARET_EQ] = ACTIONS(4982),
    [anon_sym_PIPE_EQ] = ACTIONS(4982),
    [anon_sym_and_eq] = ACTIONS(4982),
    [anon_sym_or_eq] = ACTIONS(4982),
    [anon_sym_xor_eq] = ACTIONS(4982),
    [anon_sym_LT_EQ_GT] = ACTIONS(4982),
    [anon_sym_or] = ACTIONS(4980),
    [anon_sym_and] = ACTIONS(4980),
    [anon_sym_bitor] = ACTIONS(4982),
    [anon_sym_xor] = ACTIONS(4980),
    [anon_sym_bitand] = ACTIONS(4982),
    [anon_sym_not_eq] = ACTIONS(4982),
    [anon_sym_DASH_DASH] = ACTIONS(4982),
    [anon_sym_PLUS_PLUS] = ACTIONS(4982),
    [anon_sym_DOT] = ACTIONS(4980),
    [anon_sym_DOT_STAR] = ACTIONS(4982),
    [anon_sym_DASH_GT] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4982),
    [anon_sym_decltype] = ACTIONS(4982),
    [anon_sym_final] = ACTIONS(4982),
    [anon_sym_override] = ACTIONS(4982),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4982),
  },
  [1666] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_RPAREN] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4986),
    [anon_sym_BANG_EQ] = ACTIONS(4986),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4986),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4986),
    [anon_sym___attribute__] = ACTIONS(4986),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_COLON] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(4986),
    [anon_sym_LBRACK] = ACTIONS(4986),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4986),
    [anon_sym_volatile] = ACTIONS(4986),
    [anon_sym_restrict] = ACTIONS(4986),
    [anon_sym___restrict__] = ACTIONS(4986),
    [anon_sym__Atomic] = ACTIONS(4986),
    [anon_sym__Noreturn] = ACTIONS(4986),
    [anon_sym_noreturn] = ACTIONS(4986),
    [anon_sym__Nonnull] = ACTIONS(4986),
    [anon_sym_mutable] = ACTIONS(4986),
    [anon_sym_constinit] = ACTIONS(4986),
    [anon_sym_consteval] = ACTIONS(4986),
    [anon_sym_alignas] = ACTIONS(4986),
    [anon_sym__Alignas] = ACTIONS(4986),
    [anon_sym_QMARK] = ACTIONS(4986),
    [anon_sym_STAR_EQ] = ACTIONS(4986),
    [anon_sym_SLASH_EQ] = ACTIONS(4986),
    [anon_sym_PERCENT_EQ] = ACTIONS(4986),
    [anon_sym_PLUS_EQ] = ACTIONS(4986),
    [anon_sym_DASH_EQ] = ACTIONS(4986),
    [anon_sym_LT_LT_EQ] = ACTIONS(4986),
    [anon_sym_GT_GT_EQ] = ACTIONS(4986),
    [anon_sym_AMP_EQ] = ACTIONS(4986),
    [anon_sym_CARET_EQ] = ACTIONS(4986),
    [anon_sym_PIPE_EQ] = ACTIONS(4986),
    [anon_sym_and_eq] = ACTIONS(4986),
    [anon_sym_or_eq] = ACTIONS(4986),
    [anon_sym_xor_eq] = ACTIONS(4986),
    [anon_sym_LT_EQ_GT] = ACTIONS(4986),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4986),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4986),
    [anon_sym_not_eq] = ACTIONS(4986),
    [anon_sym_DASH_DASH] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(4986),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4986),
    [anon_sym_DASH_GT] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4986),
    [anon_sym_decltype] = ACTIONS(4986),
    [anon_sym_final] = ACTIONS(4986),
    [anon_sym_override] = ACTIONS(4986),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4986),
  },
  [1667] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_SLASH] = ACTIONS(4959),
    [anon_sym_PERCENT] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4959),
    [anon_sym_CARET] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4959),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym___extension__] = ACTIONS(4961),
    [anon_sym___attribute__] = ACTIONS(4961),
    [anon_sym___attribute] = ACTIONS(4959),
    [anon_sym_COLON] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(4961),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_EQ] = ACTIONS(4959),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_constexpr] = ACTIONS(4961),
    [anon_sym_volatile] = ACTIONS(4961),
    [anon_sym_restrict] = ACTIONS(4961),
    [anon_sym___restrict__] = ACTIONS(4961),
    [anon_sym__Atomic] = ACTIONS(4961),
    [anon_sym__Noreturn] = ACTIONS(4961),
    [anon_sym_noreturn] = ACTIONS(4961),
    [anon_sym__Nonnull] = ACTIONS(4961),
    [anon_sym_mutable] = ACTIONS(4961),
    [anon_sym_constinit] = ACTIONS(4961),
    [anon_sym_consteval] = ACTIONS(4961),
    [anon_sym_alignas] = ACTIONS(4961),
    [anon_sym__Alignas] = ACTIONS(4961),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4961),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_and_eq] = ACTIONS(4961),
    [anon_sym_or_eq] = ACTIONS(4961),
    [anon_sym_xor_eq] = ACTIONS(4961),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4959),
    [anon_sym_and] = ACTIONS(4959),
    [anon_sym_bitor] = ACTIONS(4961),
    [anon_sym_xor] = ACTIONS(4959),
    [anon_sym_bitand] = ACTIONS(4961),
    [anon_sym_not_eq] = ACTIONS(4961),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4959),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4961),
    [anon_sym_decltype] = ACTIONS(4961),
    [anon_sym_final] = ACTIONS(4961),
    [anon_sym_override] = ACTIONS(4961),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4961),
  },
  [1668] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4990),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_RPAREN] = ACTIONS(4990),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(4988),
    [anon_sym_SLASH] = ACTIONS(4988),
    [anon_sym_PERCENT] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym_EQ_EQ] = ACTIONS(4990),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4988),
    [anon_sym_GT_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4988),
    [anon_sym_GT_GT] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4990),
    [anon_sym___attribute__] = ACTIONS(4990),
    [anon_sym___attribute] = ACTIONS(4988),
    [anon_sym_COLON] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(4990),
    [anon_sym_EQ] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4990),
    [anon_sym_volatile] = ACTIONS(4990),
    [anon_sym_restrict] = ACTIONS(4990),
    [anon_sym___restrict__] = ACTIONS(4990),
    [anon_sym__Atomic] = ACTIONS(4990),
    [anon_sym__Noreturn] = ACTIONS(4990),
    [anon_sym_noreturn] = ACTIONS(4990),
    [anon_sym__Nonnull] = ACTIONS(4990),
    [anon_sym_mutable] = ACTIONS(4990),
    [anon_sym_constinit] = ACTIONS(4990),
    [anon_sym_consteval] = ACTIONS(4990),
    [anon_sym_alignas] = ACTIONS(4990),
    [anon_sym__Alignas] = ACTIONS(4990),
    [anon_sym_QMARK] = ACTIONS(4990),
    [anon_sym_STAR_EQ] = ACTIONS(4990),
    [anon_sym_SLASH_EQ] = ACTIONS(4990),
    [anon_sym_PERCENT_EQ] = ACTIONS(4990),
    [anon_sym_PLUS_EQ] = ACTIONS(4990),
    [anon_sym_DASH_EQ] = ACTIONS(4990),
    [anon_sym_LT_LT_EQ] = ACTIONS(4990),
    [anon_sym_GT_GT_EQ] = ACTIONS(4990),
    [anon_sym_AMP_EQ] = ACTIONS(4990),
    [anon_sym_CARET_EQ] = ACTIONS(4990),
    [anon_sym_PIPE_EQ] = ACTIONS(4990),
    [anon_sym_and_eq] = ACTIONS(4990),
    [anon_sym_or_eq] = ACTIONS(4990),
    [anon_sym_xor_eq] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_and] = ACTIONS(4988),
    [anon_sym_bitor] = ACTIONS(4990),
    [anon_sym_xor] = ACTIONS(4988),
    [anon_sym_bitand] = ACTIONS(4990),
    [anon_sym_not_eq] = ACTIONS(4990),
    [anon_sym_DASH_DASH] = ACTIONS(4990),
    [anon_sym_PLUS_PLUS] = ACTIONS(4990),
    [anon_sym_DOT] = ACTIONS(4988),
    [anon_sym_DOT_STAR] = ACTIONS(4990),
    [anon_sym_DASH_GT] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4990),
    [anon_sym_decltype] = ACTIONS(4990),
    [anon_sym_final] = ACTIONS(4990),
    [anon_sym_override] = ACTIONS(4990),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4990),
  },
  [1669] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1669),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5072),
    [anon_sym_COMMA] = ACTIONS(5072),
    [anon_sym_RPAREN] = ACTIONS(5072),
    [aux_sym_preproc_if_token2] = ACTIONS(5072),
    [aux_sym_preproc_else_token1] = ACTIONS(5072),
    [aux_sym_preproc_elif_token1] = ACTIONS(5070),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_PLUS] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5072),
    [anon_sym_SLASH] = ACTIONS(5070),
    [anon_sym_PERCENT] = ACTIONS(5072),
    [anon_sym_PIPE_PIPE] = ACTIONS(5072),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5070),
    [anon_sym_CARET] = ACTIONS(5072),
    [anon_sym_AMP] = ACTIONS(5070),
    [anon_sym_EQ_EQ] = ACTIONS(5072),
    [anon_sym_BANG_EQ] = ACTIONS(5072),
    [anon_sym_GT] = ACTIONS(5070),
    [anon_sym_GT_EQ] = ACTIONS(5072),
    [anon_sym_LT_EQ] = ACTIONS(5070),
    [anon_sym_LT] = ACTIONS(5070),
    [anon_sym_LT_LT] = ACTIONS(5072),
    [anon_sym_GT_GT] = ACTIONS(5072),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5070),
    [anon_sym___attribute] = ACTIONS(5070),
    [anon_sym_COLON] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_RBRACE] = ACTIONS(5072),
    [anon_sym_signed] = ACTIONS(5370),
    [anon_sym_unsigned] = ACTIONS(5370),
    [anon_sym_long] = ACTIONS(5370),
    [anon_sym_short] = ACTIONS(5370),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_RBRACK] = ACTIONS(5072),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5072),
    [anon_sym_LT_EQ_GT] = ACTIONS(5072),
    [anon_sym_or] = ACTIONS(5070),
    [anon_sym_and] = ACTIONS(5070),
    [anon_sym_bitor] = ACTIONS(5070),
    [anon_sym_xor] = ACTIONS(5070),
    [anon_sym_bitand] = ACTIONS(5070),
    [anon_sym_not_eq] = ACTIONS(5070),
    [anon_sym_DASH_DASH] = ACTIONS(5072),
    [anon_sym_PLUS_PLUS] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5070),
    [anon_sym_DOT_STAR] = ACTIONS(5072),
    [anon_sym_DASH_GT] = ACTIONS(5072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5070),
    [anon_sym_decltype] = ACTIONS(5070),
    [anon_sym_final] = ACTIONS(5070),
    [anon_sym_override] = ACTIONS(5070),
    [anon_sym_requires] = ACTIONS(5070),
  },
  [1670] = {
    [sym_string_literal] = STATE(1684),
    [sym_template_argument_list] = STATE(2338),
    [sym_raw_string_literal] = STATE(1684),
    [sym_identifier] = ACTIONS(4154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [aux_sym_preproc_if_token2] = ACTIONS(4146),
    [aux_sym_preproc_else_token1] = ACTIONS(4146),
    [aux_sym_preproc_elif_token1] = ACTIONS(4154),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4146),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5373),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_RBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4154),
    [anon_sym_or_eq] = ACTIONS(4154),
    [anon_sym_xor_eq] = ACTIONS(4154),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
  },
  [1671] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4957),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4957),
    [anon_sym_LPAREN2] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_SLASH] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4957),
    [anon_sym_AMP_AMP] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4955),
    [anon_sym_CARET] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4957),
    [anon_sym_BANG_EQ] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_GT_EQ] = ACTIONS(4957),
    [anon_sym_LT_EQ] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4955),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym___extension__] = ACTIONS(4957),
    [anon_sym___attribute__] = ACTIONS(4957),
    [anon_sym___attribute] = ACTIONS(4955),
    [anon_sym_COLON] = ACTIONS(4955),
    [anon_sym_COLON_COLON] = ACTIONS(4957),
    [anon_sym_LBRACE] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4957),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_constexpr] = ACTIONS(4957),
    [anon_sym_volatile] = ACTIONS(4957),
    [anon_sym_restrict] = ACTIONS(4957),
    [anon_sym___restrict__] = ACTIONS(4957),
    [anon_sym__Atomic] = ACTIONS(4957),
    [anon_sym__Noreturn] = ACTIONS(4957),
    [anon_sym_noreturn] = ACTIONS(4957),
    [anon_sym__Nonnull] = ACTIONS(4957),
    [anon_sym_mutable] = ACTIONS(4957),
    [anon_sym_constinit] = ACTIONS(4957),
    [anon_sym_consteval] = ACTIONS(4957),
    [anon_sym_alignas] = ACTIONS(4957),
    [anon_sym__Alignas] = ACTIONS(4957),
    [anon_sym_QMARK] = ACTIONS(4957),
    [anon_sym_STAR_EQ] = ACTIONS(4957),
    [anon_sym_SLASH_EQ] = ACTIONS(4957),
    [anon_sym_PERCENT_EQ] = ACTIONS(4957),
    [anon_sym_PLUS_EQ] = ACTIONS(4957),
    [anon_sym_DASH_EQ] = ACTIONS(4957),
    [anon_sym_LT_LT_EQ] = ACTIONS(4957),
    [anon_sym_GT_GT_EQ] = ACTIONS(4957),
    [anon_sym_AMP_EQ] = ACTIONS(4957),
    [anon_sym_CARET_EQ] = ACTIONS(4957),
    [anon_sym_PIPE_EQ] = ACTIONS(4957),
    [anon_sym_and_eq] = ACTIONS(4957),
    [anon_sym_or_eq] = ACTIONS(4957),
    [anon_sym_xor_eq] = ACTIONS(4957),
    [anon_sym_LT_EQ_GT] = ACTIONS(4957),
    [anon_sym_or] = ACTIONS(4955),
    [anon_sym_and] = ACTIONS(4955),
    [anon_sym_bitor] = ACTIONS(4957),
    [anon_sym_xor] = ACTIONS(4955),
    [anon_sym_bitand] = ACTIONS(4957),
    [anon_sym_not_eq] = ACTIONS(4957),
    [anon_sym_DASH_DASH] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4957),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_DOT_STAR] = ACTIONS(4957),
    [anon_sym_DASH_GT] = ACTIONS(4955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4957),
    [anon_sym_decltype] = ACTIONS(4957),
    [anon_sym_final] = ACTIONS(4957),
    [anon_sym_override] = ACTIONS(4957),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4957),
  },
  [1672] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1674),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5156),
    [anon_sym_COMMA] = ACTIONS(5156),
    [anon_sym_RPAREN] = ACTIONS(5156),
    [anon_sym_LPAREN2] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5159),
    [anon_sym_STAR] = ACTIONS(5159),
    [anon_sym_SLASH] = ACTIONS(5159),
    [anon_sym_PERCENT] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5156),
    [anon_sym_AMP_AMP] = ACTIONS(5156),
    [anon_sym_PIPE] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5159),
    [anon_sym_AMP] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5156),
    [anon_sym_BANG_EQ] = ACTIONS(5156),
    [anon_sym_GT] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5156),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5159),
    [anon_sym_LT_LT] = ACTIONS(5159),
    [anon_sym_GT_GT] = ACTIONS(5159),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5159),
    [anon_sym___attribute] = ACTIONS(5159),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_signed] = ACTIONS(5376),
    [anon_sym_unsigned] = ACTIONS(5376),
    [anon_sym_long] = ACTIONS(5376),
    [anon_sym_short] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5156),
    [anon_sym_EQ] = ACTIONS(5159),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5156),
    [anon_sym_STAR_EQ] = ACTIONS(5156),
    [anon_sym_SLASH_EQ] = ACTIONS(5156),
    [anon_sym_PERCENT_EQ] = ACTIONS(5156),
    [anon_sym_PLUS_EQ] = ACTIONS(5156),
    [anon_sym_DASH_EQ] = ACTIONS(5156),
    [anon_sym_LT_LT_EQ] = ACTIONS(5156),
    [anon_sym_GT_GT_EQ] = ACTIONS(5156),
    [anon_sym_AMP_EQ] = ACTIONS(5156),
    [anon_sym_CARET_EQ] = ACTIONS(5156),
    [anon_sym_PIPE_EQ] = ACTIONS(5156),
    [anon_sym_LT_EQ_GT] = ACTIONS(5156),
    [anon_sym_or] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_bitor] = ACTIONS(5159),
    [anon_sym_xor] = ACTIONS(5159),
    [anon_sym_bitand] = ACTIONS(5159),
    [anon_sym_not_eq] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5156),
    [anon_sym_PLUS_PLUS] = ACTIONS(5156),
    [anon_sym_DOT] = ACTIONS(5159),
    [anon_sym_DOT_STAR] = ACTIONS(5156),
    [anon_sym_DASH_GT] = ACTIONS(5159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5159),
    [anon_sym_decltype] = ACTIONS(5159),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5156),
  },
  [1673] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5000),
    [anon_sym_COMMA] = ACTIONS(5000),
    [anon_sym_RPAREN] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5000),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(4998),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(4998),
    [anon_sym_GT_GT] = ACTIONS(4998),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5003),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_EQ] = ACTIONS(4996),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym__Nonnull] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym__Alignas] = ACTIONS(4996),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(5005),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(5005),
    [anon_sym_not_eq] = ACTIONS(5005),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
  },
  [1674] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1674),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5072),
    [anon_sym_COMMA] = ACTIONS(5072),
    [anon_sym_RPAREN] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_PLUS] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5070),
    [anon_sym_SLASH] = ACTIONS(5070),
    [anon_sym_PERCENT] = ACTIONS(5070),
    [anon_sym_PIPE_PIPE] = ACTIONS(5072),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5070),
    [anon_sym_CARET] = ACTIONS(5070),
    [anon_sym_AMP] = ACTIONS(5070),
    [anon_sym_EQ_EQ] = ACTIONS(5072),
    [anon_sym_BANG_EQ] = ACTIONS(5072),
    [anon_sym_GT] = ACTIONS(5070),
    [anon_sym_GT_EQ] = ACTIONS(5072),
    [anon_sym_LT_EQ] = ACTIONS(5070),
    [anon_sym_LT] = ACTIONS(5070),
    [anon_sym_LT_LT] = ACTIONS(5070),
    [anon_sym_GT_GT] = ACTIONS(5070),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5070),
    [anon_sym___attribute] = ACTIONS(5070),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_signed] = ACTIONS(5376),
    [anon_sym_unsigned] = ACTIONS(5376),
    [anon_sym_long] = ACTIONS(5376),
    [anon_sym_short] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_EQ] = ACTIONS(5070),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5072),
    [anon_sym_STAR_EQ] = ACTIONS(5072),
    [anon_sym_SLASH_EQ] = ACTIONS(5072),
    [anon_sym_PERCENT_EQ] = ACTIONS(5072),
    [anon_sym_PLUS_EQ] = ACTIONS(5072),
    [anon_sym_DASH_EQ] = ACTIONS(5072),
    [anon_sym_LT_LT_EQ] = ACTIONS(5072),
    [anon_sym_GT_GT_EQ] = ACTIONS(5072),
    [anon_sym_AMP_EQ] = ACTIONS(5072),
    [anon_sym_CARET_EQ] = ACTIONS(5072),
    [anon_sym_PIPE_EQ] = ACTIONS(5072),
    [anon_sym_LT_EQ_GT] = ACTIONS(5072),
    [anon_sym_or] = ACTIONS(5070),
    [anon_sym_and] = ACTIONS(5070),
    [anon_sym_bitor] = ACTIONS(5070),
    [anon_sym_xor] = ACTIONS(5070),
    [anon_sym_bitand] = ACTIONS(5070),
    [anon_sym_not_eq] = ACTIONS(5070),
    [anon_sym_DASH_DASH] = ACTIONS(5072),
    [anon_sym_PLUS_PLUS] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5070),
    [anon_sym_DOT_STAR] = ACTIONS(5072),
    [anon_sym_DASH_GT] = ACTIONS(5070),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5070),
    [anon_sym_decltype] = ACTIONS(5070),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5072),
  },
  [1675] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4994),
    [anon_sym_COMMA] = ACTIONS(4994),
    [anon_sym_RPAREN] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4992),
    [anon_sym_PLUS] = ACTIONS(4992),
    [anon_sym_STAR] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4992),
    [anon_sym_PIPE_PIPE] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(4992),
    [anon_sym_CARET] = ACTIONS(4992),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4994),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_GT_EQ] = ACTIONS(4994),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym___extension__] = ACTIONS(4994),
    [anon_sym___attribute__] = ACTIONS(4994),
    [anon_sym___attribute] = ACTIONS(4992),
    [anon_sym_COLON] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACE] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(4994),
    [anon_sym_EQ] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4994),
    [anon_sym_volatile] = ACTIONS(4994),
    [anon_sym_restrict] = ACTIONS(4994),
    [anon_sym___restrict__] = ACTIONS(4994),
    [anon_sym__Atomic] = ACTIONS(4994),
    [anon_sym__Noreturn] = ACTIONS(4994),
    [anon_sym_noreturn] = ACTIONS(4994),
    [anon_sym__Nonnull] = ACTIONS(4994),
    [anon_sym_mutable] = ACTIONS(4994),
    [anon_sym_constinit] = ACTIONS(4994),
    [anon_sym_consteval] = ACTIONS(4994),
    [anon_sym_alignas] = ACTIONS(4994),
    [anon_sym__Alignas] = ACTIONS(4994),
    [anon_sym_QMARK] = ACTIONS(4994),
    [anon_sym_STAR_EQ] = ACTIONS(4994),
    [anon_sym_SLASH_EQ] = ACTIONS(4994),
    [anon_sym_PERCENT_EQ] = ACTIONS(4994),
    [anon_sym_PLUS_EQ] = ACTIONS(4994),
    [anon_sym_DASH_EQ] = ACTIONS(4994),
    [anon_sym_LT_LT_EQ] = ACTIONS(4994),
    [anon_sym_GT_GT_EQ] = ACTIONS(4994),
    [anon_sym_AMP_EQ] = ACTIONS(4994),
    [anon_sym_CARET_EQ] = ACTIONS(4994),
    [anon_sym_PIPE_EQ] = ACTIONS(4994),
    [anon_sym_and_eq] = ACTIONS(4994),
    [anon_sym_or_eq] = ACTIONS(4994),
    [anon_sym_xor_eq] = ACTIONS(4994),
    [anon_sym_LT_EQ_GT] = ACTIONS(4994),
    [anon_sym_or] = ACTIONS(4992),
    [anon_sym_and] = ACTIONS(4992),
    [anon_sym_bitor] = ACTIONS(4994),
    [anon_sym_xor] = ACTIONS(4992),
    [anon_sym_bitand] = ACTIONS(4994),
    [anon_sym_not_eq] = ACTIONS(4994),
    [anon_sym_DASH_DASH] = ACTIONS(4994),
    [anon_sym_PLUS_PLUS] = ACTIONS(4994),
    [anon_sym_DOT] = ACTIONS(4992),
    [anon_sym_DOT_STAR] = ACTIONS(4994),
    [anon_sym_DASH_GT] = ACTIONS(4992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4994),
    [anon_sym_decltype] = ACTIONS(4994),
    [anon_sym_final] = ACTIONS(4994),
    [anon_sym_override] = ACTIONS(4994),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4994),
  },
  [1676] = {
    [sym_identifier] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5082),
    [anon_sym_COMMA] = ACTIONS(5082),
    [anon_sym_RPAREN] = ACTIONS(5082),
    [anon_sym_LPAREN2] = ACTIONS(5082),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5080),
    [anon_sym_SLASH] = ACTIONS(5080),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5082),
    [anon_sym_AMP_AMP] = ACTIONS(5082),
    [anon_sym_PIPE] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5082),
    [anon_sym_BANG_EQ] = ACTIONS(5082),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_EQ] = ACTIONS(5080),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym___extension__] = ACTIONS(5080),
    [anon_sym___attribute__] = ACTIONS(5080),
    [anon_sym___attribute] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5082),
    [anon_sym_signed] = ACTIONS(5080),
    [anon_sym_unsigned] = ACTIONS(5080),
    [anon_sym_long] = ACTIONS(5080),
    [anon_sym_short] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5082),
    [anon_sym_EQ] = ACTIONS(5080),
    [anon_sym_const] = ACTIONS(5080),
    [anon_sym_constexpr] = ACTIONS(5080),
    [anon_sym_volatile] = ACTIONS(5080),
    [anon_sym_restrict] = ACTIONS(5080),
    [anon_sym___restrict__] = ACTIONS(5080),
    [anon_sym__Atomic] = ACTIONS(5080),
    [anon_sym__Noreturn] = ACTIONS(5080),
    [anon_sym_noreturn] = ACTIONS(5080),
    [anon_sym__Nonnull] = ACTIONS(5080),
    [anon_sym_mutable] = ACTIONS(5080),
    [anon_sym_constinit] = ACTIONS(5080),
    [anon_sym_consteval] = ACTIONS(5080),
    [anon_sym_alignas] = ACTIONS(5080),
    [anon_sym__Alignas] = ACTIONS(5080),
    [sym_primitive_type] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5082),
    [anon_sym_STAR_EQ] = ACTIONS(5082),
    [anon_sym_SLASH_EQ] = ACTIONS(5082),
    [anon_sym_PERCENT_EQ] = ACTIONS(5082),
    [anon_sym_PLUS_EQ] = ACTIONS(5082),
    [anon_sym_DASH_EQ] = ACTIONS(5082),
    [anon_sym_LT_LT_EQ] = ACTIONS(5082),
    [anon_sym_GT_GT_EQ] = ACTIONS(5082),
    [anon_sym_AMP_EQ] = ACTIONS(5082),
    [anon_sym_CARET_EQ] = ACTIONS(5082),
    [anon_sym_PIPE_EQ] = ACTIONS(5082),
    [anon_sym_LT_EQ_GT] = ACTIONS(5082),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_bitor] = ACTIONS(5080),
    [anon_sym_xor] = ACTIONS(5080),
    [anon_sym_bitand] = ACTIONS(5080),
    [anon_sym_not_eq] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5082),
    [anon_sym_PLUS_PLUS] = ACTIONS(5082),
    [anon_sym_DOT] = ACTIONS(5080),
    [anon_sym_DOT_STAR] = ACTIONS(5082),
    [anon_sym_DASH_GT] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5080),
    [anon_sym_decltype] = ACTIONS(5080),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5082),
  },
  [1677] = {
    [sym_catch_clause] = STATE(1679),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1679),
    [sym_identifier] = ACTIONS(2547),
    [aux_sym_preproc_def_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token2] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2547),
    [aux_sym_preproc_else_token1] = ACTIONS(2547),
    [aux_sym_preproc_elif_token1] = ACTIONS(2547),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2547),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2547),
    [sym_preproc_directive] = ACTIONS(2547),
    [anon_sym_LPAREN2] = ACTIONS(2549),
    [anon_sym_TILDE] = ACTIONS(2549),
    [anon_sym_STAR] = ACTIONS(2549),
    [anon_sym_AMP_AMP] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(2549),
    [anon_sym___extension__] = ACTIONS(2547),
    [anon_sym_typedef] = ACTIONS(2547),
    [anon_sym_virtual] = ACTIONS(2547),
    [anon_sym_extern] = ACTIONS(2547),
    [anon_sym___attribute__] = ACTIONS(2547),
    [anon_sym___attribute] = ACTIONS(2547),
    [anon_sym_using] = ACTIONS(2547),
    [anon_sym_COLON_COLON] = ACTIONS(2549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2549),
    [anon_sym___declspec] = ACTIONS(2547),
    [anon_sym___based] = ACTIONS(2547),
    [anon_sym_signed] = ACTIONS(2547),
    [anon_sym_unsigned] = ACTIONS(2547),
    [anon_sym_long] = ACTIONS(2547),
    [anon_sym_short] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_register] = ACTIONS(2547),
    [anon_sym_inline] = ACTIONS(2547),
    [anon_sym___inline] = ACTIONS(2547),
    [anon_sym___inline__] = ACTIONS(2547),
    [anon_sym___forceinline] = ACTIONS(2547),
    [anon_sym_thread_local] = ACTIONS(2547),
    [anon_sym___thread] = ACTIONS(2547),
    [anon_sym_const] = ACTIONS(2547),
    [anon_sym_constexpr] = ACTIONS(2547),
    [anon_sym_volatile] = ACTIONS(2547),
    [anon_sym_restrict] = ACTIONS(2547),
    [anon_sym___restrict__] = ACTIONS(2547),
    [anon_sym__Atomic] = ACTIONS(2547),
    [anon_sym__Noreturn] = ACTIONS(2547),
    [anon_sym_noreturn] = ACTIONS(2547),
    [anon_sym__Nonnull] = ACTIONS(2547),
    [anon_sym_mutable] = ACTIONS(2547),
    [anon_sym_constinit] = ACTIONS(2547),
    [anon_sym_consteval] = ACTIONS(2547),
    [anon_sym_alignas] = ACTIONS(2547),
    [anon_sym__Alignas] = ACTIONS(2547),
    [sym_primitive_type] = ACTIONS(2547),
    [anon_sym_enum] = ACTIONS(2547),
    [anon_sym_class] = ACTIONS(2547),
    [anon_sym_struct] = ACTIONS(2547),
    [anon_sym_union] = ACTIONS(2547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2547),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_template] = ACTIONS(2547),
    [anon_sym_operator] = ACTIONS(2547),
    [anon_sym_friend] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_static_assert] = ACTIONS(2547),
    [anon_sym_catch] = ACTIONS(5379),
  },
  [1678] = {
    [sym_identifier] = ACTIONS(5381),
    [anon_sym_LPAREN2] = ACTIONS(5383),
    [anon_sym_BANG] = ACTIONS(5383),
    [anon_sym_TILDE] = ACTIONS(5383),
    [anon_sym_DASH] = ACTIONS(5381),
    [anon_sym_PLUS] = ACTIONS(5381),
    [anon_sym_STAR] = ACTIONS(5383),
    [anon_sym_AMP] = ACTIONS(5383),
    [anon_sym_SEMI] = ACTIONS(5383),
    [anon_sym___extension__] = ACTIONS(5381),
    [anon_sym_COLON_COLON] = ACTIONS(5383),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5383),
    [anon_sym_LBRACE] = ACTIONS(5383),
    [anon_sym_LBRACK] = ACTIONS(5381),
    [sym_primitive_type] = ACTIONS(5381),
    [anon_sym_if] = ACTIONS(5381),
    [anon_sym_switch] = ACTIONS(5381),
    [anon_sym_case] = ACTIONS(5381),
    [anon_sym_default] = ACTIONS(5381),
    [anon_sym_while] = ACTIONS(5381),
    [anon_sym_do] = ACTIONS(5381),
    [anon_sym_for] = ACTIONS(5381),
    [anon_sym_return] = ACTIONS(5381),
    [anon_sym_break] = ACTIONS(5381),
    [anon_sym_continue] = ACTIONS(5381),
    [anon_sym_goto] = ACTIONS(5381),
    [anon_sym___try] = ACTIONS(5381),
    [anon_sym___leave] = ACTIONS(5381),
    [anon_sym_not] = ACTIONS(5381),
    [anon_sym_compl] = ACTIONS(5381),
    [anon_sym_DASH_DASH] = ACTIONS(5383),
    [anon_sym_PLUS_PLUS] = ACTIONS(5383),
    [anon_sym_sizeof] = ACTIONS(5381),
    [anon_sym___alignof__] = ACTIONS(5381),
    [anon_sym___alignof] = ACTIONS(5381),
    [anon_sym__alignof] = ACTIONS(5381),
    [anon_sym_alignof] = ACTIONS(5381),
    [anon_sym__Alignof] = ACTIONS(5381),
    [anon_sym_offsetof] = ACTIONS(5381),
    [anon_sym__Generic] = ACTIONS(5381),
    [anon_sym_asm] = ACTIONS(5381),
    [anon_sym___asm__] = ACTIONS(5381),
    [anon_sym___asm] = ACTIONS(5381),
    [sym_number_literal] = ACTIONS(5383),
    [anon_sym_L_SQUOTE] = ACTIONS(5383),
    [anon_sym_u_SQUOTE] = ACTIONS(5383),
    [anon_sym_U_SQUOTE] = ACTIONS(5383),
    [anon_sym_u8_SQUOTE] = ACTIONS(5383),
    [anon_sym_SQUOTE] = ACTIONS(5383),
    [anon_sym_L_DQUOTE] = ACTIONS(5383),
    [anon_sym_u_DQUOTE] = ACTIONS(5383),
    [anon_sym_U_DQUOTE] = ACTIONS(5383),
    [anon_sym_u8_DQUOTE] = ACTIONS(5383),
    [anon_sym_DQUOTE] = ACTIONS(5383),
    [sym_true] = ACTIONS(5381),
    [sym_false] = ACTIONS(5381),
    [anon_sym_NULL] = ACTIONS(5381),
    [anon_sym_nullptr] = ACTIONS(5381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5381),
    [anon_sym_template] = ACTIONS(5381),
    [anon_sym_try] = ACTIONS(5381),
    [anon_sym_delete] = ACTIONS(5381),
    [anon_sym_throw] = ACTIONS(5381),
    [anon_sym_co_return] = ACTIONS(5381),
    [anon_sym_co_yield] = ACTIONS(5381),
    [anon_sym_R_DQUOTE] = ACTIONS(5383),
    [anon_sym_LR_DQUOTE] = ACTIONS(5383),
    [anon_sym_uR_DQUOTE] = ACTIONS(5383),
    [anon_sym_UR_DQUOTE] = ACTIONS(5383),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5383),
    [anon_sym_co_await] = ACTIONS(5381),
    [anon_sym_new] = ACTIONS(5381),
    [anon_sym_requires] = ACTIONS(5381),
    [sym_this] = ACTIONS(5381),
  },
  [1679] = {
    [sym_catch_clause] = STATE(1679),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1679),
    [sym_identifier] = ACTIONS(2476),
    [aux_sym_preproc_def_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token2] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2476),
    [aux_sym_preproc_else_token1] = ACTIONS(2476),
    [aux_sym_preproc_elif_token1] = ACTIONS(2476),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2476),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2476),
    [sym_preproc_directive] = ACTIONS(2476),
    [anon_sym_LPAREN2] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym___extension__] = ACTIONS(2476),
    [anon_sym_typedef] = ACTIONS(2476),
    [anon_sym_virtual] = ACTIONS(2476),
    [anon_sym_extern] = ACTIONS(2476),
    [anon_sym___attribute__] = ACTIONS(2476),
    [anon_sym___attribute] = ACTIONS(2476),
    [anon_sym_using] = ACTIONS(2476),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2478),
    [anon_sym___declspec] = ACTIONS(2476),
    [anon_sym___based] = ACTIONS(2476),
    [anon_sym_signed] = ACTIONS(2476),
    [anon_sym_unsigned] = ACTIONS(2476),
    [anon_sym_long] = ACTIONS(2476),
    [anon_sym_short] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_register] = ACTIONS(2476),
    [anon_sym_inline] = ACTIONS(2476),
    [anon_sym___inline] = ACTIONS(2476),
    [anon_sym___inline__] = ACTIONS(2476),
    [anon_sym___forceinline] = ACTIONS(2476),
    [anon_sym_thread_local] = ACTIONS(2476),
    [anon_sym___thread] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_constexpr] = ACTIONS(2476),
    [anon_sym_volatile] = ACTIONS(2476),
    [anon_sym_restrict] = ACTIONS(2476),
    [anon_sym___restrict__] = ACTIONS(2476),
    [anon_sym__Atomic] = ACTIONS(2476),
    [anon_sym__Noreturn] = ACTIONS(2476),
    [anon_sym_noreturn] = ACTIONS(2476),
    [anon_sym__Nonnull] = ACTIONS(2476),
    [anon_sym_mutable] = ACTIONS(2476),
    [anon_sym_constinit] = ACTIONS(2476),
    [anon_sym_consteval] = ACTIONS(2476),
    [anon_sym_alignas] = ACTIONS(2476),
    [anon_sym__Alignas] = ACTIONS(2476),
    [sym_primitive_type] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [anon_sym_class] = ACTIONS(2476),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2476),
    [anon_sym_decltype] = ACTIONS(2476),
    [anon_sym_explicit] = ACTIONS(2476),
    [anon_sym_typename] = ACTIONS(2476),
    [anon_sym_private] = ACTIONS(2476),
    [anon_sym_template] = ACTIONS(2476),
    [anon_sym_operator] = ACTIONS(2476),
    [anon_sym_friend] = ACTIONS(2476),
    [anon_sym_public] = ACTIONS(2476),
    [anon_sym_protected] = ACTIONS(2476),
    [anon_sym_static_assert] = ACTIONS(2476),
    [anon_sym_catch] = ACTIONS(5385),
  },
  [1680] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4957),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_LPAREN2] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_SLASH] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4957),
    [anon_sym_AMP_AMP] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4955),
    [anon_sym_CARET] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4957),
    [anon_sym_BANG_EQ] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_GT_EQ] = ACTIONS(4955),
    [anon_sym_LT_EQ] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4955),
    [anon_sym_GT_GT] = ACTIONS(4955),
    [anon_sym___extension__] = ACTIONS(4957),
    [anon_sym___attribute__] = ACTIONS(4957),
    [anon_sym___attribute] = ACTIONS(4955),
    [anon_sym_COLON] = ACTIONS(4955),
    [anon_sym_COLON_COLON] = ACTIONS(4957),
    [anon_sym_LBRACE] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4957),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_constexpr] = ACTIONS(4957),
    [anon_sym_volatile] = ACTIONS(4957),
    [anon_sym_restrict] = ACTIONS(4957),
    [anon_sym___restrict__] = ACTIONS(4957),
    [anon_sym__Atomic] = ACTIONS(4957),
    [anon_sym__Noreturn] = ACTIONS(4957),
    [anon_sym_noreturn] = ACTIONS(4957),
    [anon_sym__Nonnull] = ACTIONS(4957),
    [anon_sym_mutable] = ACTIONS(4957),
    [anon_sym_constinit] = ACTIONS(4957),
    [anon_sym_consteval] = ACTIONS(4957),
    [anon_sym_alignas] = ACTIONS(4957),
    [anon_sym__Alignas] = ACTIONS(4957),
    [anon_sym_QMARK] = ACTIONS(4957),
    [anon_sym_STAR_EQ] = ACTIONS(4957),
    [anon_sym_SLASH_EQ] = ACTIONS(4957),
    [anon_sym_PERCENT_EQ] = ACTIONS(4957),
    [anon_sym_PLUS_EQ] = ACTIONS(4957),
    [anon_sym_DASH_EQ] = ACTIONS(4957),
    [anon_sym_LT_LT_EQ] = ACTIONS(4957),
    [anon_sym_GT_GT_EQ] = ACTIONS(4955),
    [anon_sym_AMP_EQ] = ACTIONS(4957),
    [anon_sym_CARET_EQ] = ACTIONS(4957),
    [anon_sym_PIPE_EQ] = ACTIONS(4957),
    [anon_sym_and_eq] = ACTIONS(4957),
    [anon_sym_or_eq] = ACTIONS(4957),
    [anon_sym_xor_eq] = ACTIONS(4957),
    [anon_sym_LT_EQ_GT] = ACTIONS(4957),
    [anon_sym_or] = ACTIONS(4955),
    [anon_sym_and] = ACTIONS(4955),
    [anon_sym_bitor] = ACTIONS(4957),
    [anon_sym_xor] = ACTIONS(4955),
    [anon_sym_bitand] = ACTIONS(4957),
    [anon_sym_not_eq] = ACTIONS(4957),
    [anon_sym_DASH_DASH] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4957),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_DOT_STAR] = ACTIONS(4957),
    [anon_sym_DASH_GT] = ACTIONS(4957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4957),
    [anon_sym_decltype] = ACTIONS(4957),
    [anon_sym_final] = ACTIONS(4957),
    [anon_sym_override] = ACTIONS(4957),
    [anon_sym_GT2] = ACTIONS(4957),
  },
  [1681] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4986),
    [anon_sym_BANG_EQ] = ACTIONS(4986),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4984),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4986),
    [anon_sym___attribute__] = ACTIONS(4986),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_COLON] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(4986),
    [anon_sym_LBRACK] = ACTIONS(4986),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4986),
    [anon_sym_volatile] = ACTIONS(4986),
    [anon_sym_restrict] = ACTIONS(4986),
    [anon_sym___restrict__] = ACTIONS(4986),
    [anon_sym__Atomic] = ACTIONS(4986),
    [anon_sym__Noreturn] = ACTIONS(4986),
    [anon_sym_noreturn] = ACTIONS(4986),
    [anon_sym__Nonnull] = ACTIONS(4986),
    [anon_sym_mutable] = ACTIONS(4986),
    [anon_sym_constinit] = ACTIONS(4986),
    [anon_sym_consteval] = ACTIONS(4986),
    [anon_sym_alignas] = ACTIONS(4986),
    [anon_sym__Alignas] = ACTIONS(4986),
    [anon_sym_QMARK] = ACTIONS(4986),
    [anon_sym_STAR_EQ] = ACTIONS(4986),
    [anon_sym_SLASH_EQ] = ACTIONS(4986),
    [anon_sym_PERCENT_EQ] = ACTIONS(4986),
    [anon_sym_PLUS_EQ] = ACTIONS(4986),
    [anon_sym_DASH_EQ] = ACTIONS(4986),
    [anon_sym_LT_LT_EQ] = ACTIONS(4986),
    [anon_sym_GT_GT_EQ] = ACTIONS(4984),
    [anon_sym_AMP_EQ] = ACTIONS(4986),
    [anon_sym_CARET_EQ] = ACTIONS(4986),
    [anon_sym_PIPE_EQ] = ACTIONS(4986),
    [anon_sym_and_eq] = ACTIONS(4986),
    [anon_sym_or_eq] = ACTIONS(4986),
    [anon_sym_xor_eq] = ACTIONS(4986),
    [anon_sym_LT_EQ_GT] = ACTIONS(4986),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4986),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4986),
    [anon_sym_not_eq] = ACTIONS(4986),
    [anon_sym_DASH_DASH] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(4986),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4986),
    [anon_sym_DASH_GT] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4986),
    [anon_sym_decltype] = ACTIONS(4986),
    [anon_sym_final] = ACTIONS(4986),
    [anon_sym_override] = ACTIONS(4986),
    [anon_sym_GT2] = ACTIONS(4986),
  },
  [1682] = {
    [sym_identifier] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5082),
    [anon_sym_COMMA] = ACTIONS(5082),
    [anon_sym_RPAREN] = ACTIONS(5082),
    [aux_sym_preproc_if_token2] = ACTIONS(5082),
    [aux_sym_preproc_else_token1] = ACTIONS(5082),
    [aux_sym_preproc_elif_token1] = ACTIONS(5080),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5082),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5082),
    [anon_sym_LPAREN2] = ACTIONS(5082),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_SLASH] = ACTIONS(5080),
    [anon_sym_PERCENT] = ACTIONS(5082),
    [anon_sym_PIPE_PIPE] = ACTIONS(5082),
    [anon_sym_AMP_AMP] = ACTIONS(5082),
    [anon_sym_PIPE] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5082),
    [anon_sym_BANG_EQ] = ACTIONS(5082),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5082),
    [anon_sym_LT_EQ] = ACTIONS(5080),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5082),
    [anon_sym_GT_GT] = ACTIONS(5082),
    [anon_sym_SEMI] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5080),
    [anon_sym___attribute__] = ACTIONS(5080),
    [anon_sym___attribute] = ACTIONS(5080),
    [anon_sym_COLON] = ACTIONS(5082),
    [anon_sym_LBRACE] = ACTIONS(5082),
    [anon_sym_RBRACE] = ACTIONS(5082),
    [anon_sym_signed] = ACTIONS(5080),
    [anon_sym_unsigned] = ACTIONS(5080),
    [anon_sym_long] = ACTIONS(5080),
    [anon_sym_short] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5082),
    [anon_sym_RBRACK] = ACTIONS(5082),
    [anon_sym_const] = ACTIONS(5080),
    [anon_sym_constexpr] = ACTIONS(5080),
    [anon_sym_volatile] = ACTIONS(5080),
    [anon_sym_restrict] = ACTIONS(5080),
    [anon_sym___restrict__] = ACTIONS(5080),
    [anon_sym__Atomic] = ACTIONS(5080),
    [anon_sym__Noreturn] = ACTIONS(5080),
    [anon_sym_noreturn] = ACTIONS(5080),
    [anon_sym__Nonnull] = ACTIONS(5080),
    [anon_sym_mutable] = ACTIONS(5080),
    [anon_sym_constinit] = ACTIONS(5080),
    [anon_sym_consteval] = ACTIONS(5080),
    [anon_sym_alignas] = ACTIONS(5080),
    [anon_sym__Alignas] = ACTIONS(5080),
    [sym_primitive_type] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5082),
    [anon_sym_LT_EQ_GT] = ACTIONS(5082),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_bitor] = ACTIONS(5080),
    [anon_sym_xor] = ACTIONS(5080),
    [anon_sym_bitand] = ACTIONS(5080),
    [anon_sym_not_eq] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5082),
    [anon_sym_PLUS_PLUS] = ACTIONS(5082),
    [anon_sym_DOT] = ACTIONS(5080),
    [anon_sym_DOT_STAR] = ACTIONS(5082),
    [anon_sym_DASH_GT] = ACTIONS(5082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5080),
    [anon_sym_decltype] = ACTIONS(5080),
    [anon_sym_final] = ACTIONS(5080),
    [anon_sym_override] = ACTIONS(5080),
    [anon_sym_requires] = ACTIONS(5080),
  },
  [1683] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_DASH] = ACTIONS(4980),
    [anon_sym_PLUS] = ACTIONS(4980),
    [anon_sym_STAR] = ACTIONS(4980),
    [anon_sym_SLASH] = ACTIONS(4980),
    [anon_sym_PERCENT] = ACTIONS(4980),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4980),
    [anon_sym_CARET] = ACTIONS(4980),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4980),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_LT_LT] = ACTIONS(4980),
    [anon_sym_GT_GT] = ACTIONS(4980),
    [anon_sym___extension__] = ACTIONS(4982),
    [anon_sym___attribute__] = ACTIONS(4982),
    [anon_sym___attribute] = ACTIONS(4980),
    [anon_sym_COLON] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACE] = ACTIONS(4982),
    [anon_sym_LBRACK] = ACTIONS(4982),
    [anon_sym_EQ] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4982),
    [anon_sym_volatile] = ACTIONS(4982),
    [anon_sym_restrict] = ACTIONS(4982),
    [anon_sym___restrict__] = ACTIONS(4982),
    [anon_sym__Atomic] = ACTIONS(4982),
    [anon_sym__Noreturn] = ACTIONS(4982),
    [anon_sym_noreturn] = ACTIONS(4982),
    [anon_sym__Nonnull] = ACTIONS(4982),
    [anon_sym_mutable] = ACTIONS(4982),
    [anon_sym_constinit] = ACTIONS(4982),
    [anon_sym_consteval] = ACTIONS(4982),
    [anon_sym_alignas] = ACTIONS(4982),
    [anon_sym__Alignas] = ACTIONS(4982),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_STAR_EQ] = ACTIONS(4982),
    [anon_sym_SLASH_EQ] = ACTIONS(4982),
    [anon_sym_PERCENT_EQ] = ACTIONS(4982),
    [anon_sym_PLUS_EQ] = ACTIONS(4982),
    [anon_sym_DASH_EQ] = ACTIONS(4982),
    [anon_sym_LT_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT_GT_EQ] = ACTIONS(4980),
    [anon_sym_AMP_EQ] = ACTIONS(4982),
    [anon_sym_CARET_EQ] = ACTIONS(4982),
    [anon_sym_PIPE_EQ] = ACTIONS(4982),
    [anon_sym_and_eq] = ACTIONS(4982),
    [anon_sym_or_eq] = ACTIONS(4982),
    [anon_sym_xor_eq] = ACTIONS(4982),
    [anon_sym_LT_EQ_GT] = ACTIONS(4982),
    [anon_sym_or] = ACTIONS(4980),
    [anon_sym_and] = ACTIONS(4980),
    [anon_sym_bitor] = ACTIONS(4982),
    [anon_sym_xor] = ACTIONS(4980),
    [anon_sym_bitand] = ACTIONS(4982),
    [anon_sym_not_eq] = ACTIONS(4982),
    [anon_sym_DASH_DASH] = ACTIONS(4982),
    [anon_sym_PLUS_PLUS] = ACTIONS(4982),
    [anon_sym_DOT] = ACTIONS(4980),
    [anon_sym_DOT_STAR] = ACTIONS(4982),
    [anon_sym_DASH_GT] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4982),
    [anon_sym_decltype] = ACTIONS(4982),
    [anon_sym_final] = ACTIONS(4982),
    [anon_sym_override] = ACTIONS(4982),
    [anon_sym_GT2] = ACTIONS(4982),
  },
  [1684] = {
    [sym_string_literal] = STATE(1689),
    [sym_raw_string_literal] = STATE(1689),
    [aux_sym_concatenated_string_repeat1] = STATE(1689),
    [sym_identifier] = ACTIONS(5388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5390),
    [anon_sym_COMMA] = ACTIONS(5390),
    [anon_sym_RPAREN] = ACTIONS(5390),
    [aux_sym_preproc_if_token2] = ACTIONS(5390),
    [aux_sym_preproc_else_token1] = ACTIONS(5390),
    [aux_sym_preproc_elif_token1] = ACTIONS(5392),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5390),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5390),
    [anon_sym_LPAREN2] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5392),
    [anon_sym_PLUS] = ACTIONS(5392),
    [anon_sym_STAR] = ACTIONS(5392),
    [anon_sym_SLASH] = ACTIONS(5392),
    [anon_sym_PERCENT] = ACTIONS(5392),
    [anon_sym_PIPE_PIPE] = ACTIONS(5390),
    [anon_sym_AMP_AMP] = ACTIONS(5390),
    [anon_sym_PIPE] = ACTIONS(5392),
    [anon_sym_CARET] = ACTIONS(5392),
    [anon_sym_AMP] = ACTIONS(5392),
    [anon_sym_EQ_EQ] = ACTIONS(5390),
    [anon_sym_BANG_EQ] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5392),
    [anon_sym_GT_EQ] = ACTIONS(5390),
    [anon_sym_LT_EQ] = ACTIONS(5392),
    [anon_sym_LT] = ACTIONS(5392),
    [anon_sym_LT_LT] = ACTIONS(5392),
    [anon_sym_GT_GT] = ACTIONS(5392),
    [anon_sym_SEMI] = ACTIONS(5390),
    [anon_sym_COLON] = ACTIONS(5390),
    [anon_sym_RBRACE] = ACTIONS(5390),
    [anon_sym_LBRACK] = ACTIONS(5390),
    [anon_sym_RBRACK] = ACTIONS(5390),
    [anon_sym_EQ] = ACTIONS(5392),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_STAR_EQ] = ACTIONS(5390),
    [anon_sym_SLASH_EQ] = ACTIONS(5390),
    [anon_sym_PERCENT_EQ] = ACTIONS(5390),
    [anon_sym_PLUS_EQ] = ACTIONS(5390),
    [anon_sym_DASH_EQ] = ACTIONS(5390),
    [anon_sym_LT_LT_EQ] = ACTIONS(5390),
    [anon_sym_GT_GT_EQ] = ACTIONS(5390),
    [anon_sym_AMP_EQ] = ACTIONS(5390),
    [anon_sym_CARET_EQ] = ACTIONS(5390),
    [anon_sym_PIPE_EQ] = ACTIONS(5390),
    [anon_sym_and_eq] = ACTIONS(5392),
    [anon_sym_or_eq] = ACTIONS(5392),
    [anon_sym_xor_eq] = ACTIONS(5392),
    [anon_sym_LT_EQ_GT] = ACTIONS(5390),
    [anon_sym_or] = ACTIONS(5392),
    [anon_sym_and] = ACTIONS(5392),
    [anon_sym_bitor] = ACTIONS(5392),
    [anon_sym_xor] = ACTIONS(5392),
    [anon_sym_bitand] = ACTIONS(5392),
    [anon_sym_not_eq] = ACTIONS(5392),
    [anon_sym_DASH_DASH] = ACTIONS(5390),
    [anon_sym_PLUS_PLUS] = ACTIONS(5390),
    [anon_sym_DOT] = ACTIONS(5392),
    [anon_sym_DOT_STAR] = ACTIONS(5390),
    [anon_sym_DASH_GT] = ACTIONS(5390),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [sym_literal_suffix] = ACTIONS(5392),
  },
  [1685] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4994),
    [anon_sym_COMMA] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4992),
    [anon_sym_PLUS] = ACTIONS(4992),
    [anon_sym_STAR] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4992),
    [anon_sym_PIPE_PIPE] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(4992),
    [anon_sym_CARET] = ACTIONS(4992),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4994),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_GT_EQ] = ACTIONS(4992),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym___extension__] = ACTIONS(4994),
    [anon_sym___attribute__] = ACTIONS(4994),
    [anon_sym___attribute] = ACTIONS(4992),
    [anon_sym_COLON] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACE] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(4994),
    [anon_sym_EQ] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4994),
    [anon_sym_volatile] = ACTIONS(4994),
    [anon_sym_restrict] = ACTIONS(4994),
    [anon_sym___restrict__] = ACTIONS(4994),
    [anon_sym__Atomic] = ACTIONS(4994),
    [anon_sym__Noreturn] = ACTIONS(4994),
    [anon_sym_noreturn] = ACTIONS(4994),
    [anon_sym__Nonnull] = ACTIONS(4994),
    [anon_sym_mutable] = ACTIONS(4994),
    [anon_sym_constinit] = ACTIONS(4994),
    [anon_sym_consteval] = ACTIONS(4994),
    [anon_sym_alignas] = ACTIONS(4994),
    [anon_sym__Alignas] = ACTIONS(4994),
    [anon_sym_QMARK] = ACTIONS(4994),
    [anon_sym_STAR_EQ] = ACTIONS(4994),
    [anon_sym_SLASH_EQ] = ACTIONS(4994),
    [anon_sym_PERCENT_EQ] = ACTIONS(4994),
    [anon_sym_PLUS_EQ] = ACTIONS(4994),
    [anon_sym_DASH_EQ] = ACTIONS(4994),
    [anon_sym_LT_LT_EQ] = ACTIONS(4994),
    [anon_sym_GT_GT_EQ] = ACTIONS(4992),
    [anon_sym_AMP_EQ] = ACTIONS(4994),
    [anon_sym_CARET_EQ] = ACTIONS(4994),
    [anon_sym_PIPE_EQ] = ACTIONS(4994),
    [anon_sym_and_eq] = ACTIONS(4994),
    [anon_sym_or_eq] = ACTIONS(4994),
    [anon_sym_xor_eq] = ACTIONS(4994),
    [anon_sym_LT_EQ_GT] = ACTIONS(4994),
    [anon_sym_or] = ACTIONS(4992),
    [anon_sym_and] = ACTIONS(4992),
    [anon_sym_bitor] = ACTIONS(4994),
    [anon_sym_xor] = ACTIONS(4992),
    [anon_sym_bitand] = ACTIONS(4994),
    [anon_sym_not_eq] = ACTIONS(4994),
    [anon_sym_DASH_DASH] = ACTIONS(4994),
    [anon_sym_PLUS_PLUS] = ACTIONS(4994),
    [anon_sym_DOT] = ACTIONS(4992),
    [anon_sym_DOT_STAR] = ACTIONS(4994),
    [anon_sym_DASH_GT] = ACTIONS(4994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4994),
    [anon_sym_decltype] = ACTIONS(4994),
    [anon_sym_final] = ACTIONS(4994),
    [anon_sym_override] = ACTIONS(4994),
    [anon_sym_GT2] = ACTIONS(4994),
  },
  [1686] = {
    [sym_catch_clause] = STATE(1679),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1679),
    [sym_identifier] = ACTIONS(2590),
    [aux_sym_preproc_def_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token2] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2590),
    [aux_sym_preproc_else_token1] = ACTIONS(2590),
    [aux_sym_preproc_elif_token1] = ACTIONS(2590),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2590),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2590),
    [sym_preproc_directive] = ACTIONS(2590),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_TILDE] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym___extension__] = ACTIONS(2590),
    [anon_sym_typedef] = ACTIONS(2590),
    [anon_sym_virtual] = ACTIONS(2590),
    [anon_sym_extern] = ACTIONS(2590),
    [anon_sym___attribute__] = ACTIONS(2590),
    [anon_sym___attribute] = ACTIONS(2590),
    [anon_sym_using] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2592),
    [anon_sym___declspec] = ACTIONS(2590),
    [anon_sym___based] = ACTIONS(2590),
    [anon_sym_signed] = ACTIONS(2590),
    [anon_sym_unsigned] = ACTIONS(2590),
    [anon_sym_long] = ACTIONS(2590),
    [anon_sym_short] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2590),
    [anon_sym_register] = ACTIONS(2590),
    [anon_sym_inline] = ACTIONS(2590),
    [anon_sym___inline] = ACTIONS(2590),
    [anon_sym___inline__] = ACTIONS(2590),
    [anon_sym___forceinline] = ACTIONS(2590),
    [anon_sym_thread_local] = ACTIONS(2590),
    [anon_sym___thread] = ACTIONS(2590),
    [anon_sym_const] = ACTIONS(2590),
    [anon_sym_constexpr] = ACTIONS(2590),
    [anon_sym_volatile] = ACTIONS(2590),
    [anon_sym_restrict] = ACTIONS(2590),
    [anon_sym___restrict__] = ACTIONS(2590),
    [anon_sym__Atomic] = ACTIONS(2590),
    [anon_sym__Noreturn] = ACTIONS(2590),
    [anon_sym_noreturn] = ACTIONS(2590),
    [anon_sym__Nonnull] = ACTIONS(2590),
    [anon_sym_mutable] = ACTIONS(2590),
    [anon_sym_constinit] = ACTIONS(2590),
    [anon_sym_consteval] = ACTIONS(2590),
    [anon_sym_alignas] = ACTIONS(2590),
    [anon_sym__Alignas] = ACTIONS(2590),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_enum] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_struct] = ACTIONS(2590),
    [anon_sym_union] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2590),
    [anon_sym_decltype] = ACTIONS(2590),
    [anon_sym_explicit] = ACTIONS(2590),
    [anon_sym_typename] = ACTIONS(2590),
    [anon_sym_private] = ACTIONS(2590),
    [anon_sym_template] = ACTIONS(2590),
    [anon_sym_operator] = ACTIONS(2590),
    [anon_sym_friend] = ACTIONS(2590),
    [anon_sym_public] = ACTIONS(2590),
    [anon_sym_protected] = ACTIONS(2590),
    [anon_sym_static_assert] = ACTIONS(2590),
    [anon_sym_catch] = ACTIONS(5379),
  },
  [1687] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4953),
    [anon_sym_COMMA] = ACTIONS(4953),
    [anon_sym_LPAREN2] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4951),
    [anon_sym_SLASH] = ACTIONS(4951),
    [anon_sym_PERCENT] = ACTIONS(4951),
    [anon_sym_PIPE_PIPE] = ACTIONS(4953),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_PIPE] = ACTIONS(4951),
    [anon_sym_CARET] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_EQ_EQ] = ACTIONS(4953),
    [anon_sym_BANG_EQ] = ACTIONS(4953),
    [anon_sym_GT] = ACTIONS(4951),
    [anon_sym_GT_EQ] = ACTIONS(4951),
    [anon_sym_LT_EQ] = ACTIONS(4951),
    [anon_sym_LT] = ACTIONS(4951),
    [anon_sym_LT_LT] = ACTIONS(4951),
    [anon_sym_GT_GT] = ACTIONS(4951),
    [anon_sym___extension__] = ACTIONS(4953),
    [anon_sym___attribute__] = ACTIONS(4953),
    [anon_sym___attribute] = ACTIONS(4951),
    [anon_sym_COLON] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4953),
    [anon_sym_LBRACE] = ACTIONS(4953),
    [anon_sym_LBRACK] = ACTIONS(4953),
    [anon_sym_EQ] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4953),
    [anon_sym_volatile] = ACTIONS(4953),
    [anon_sym_restrict] = ACTIONS(4953),
    [anon_sym___restrict__] = ACTIONS(4953),
    [anon_sym__Atomic] = ACTIONS(4953),
    [anon_sym__Noreturn] = ACTIONS(4953),
    [anon_sym_noreturn] = ACTIONS(4953),
    [anon_sym__Nonnull] = ACTIONS(4953),
    [anon_sym_mutable] = ACTIONS(4953),
    [anon_sym_constinit] = ACTIONS(4953),
    [anon_sym_consteval] = ACTIONS(4953),
    [anon_sym_alignas] = ACTIONS(4953),
    [anon_sym__Alignas] = ACTIONS(4953),
    [anon_sym_QMARK] = ACTIONS(4953),
    [anon_sym_STAR_EQ] = ACTIONS(4953),
    [anon_sym_SLASH_EQ] = ACTIONS(4953),
    [anon_sym_PERCENT_EQ] = ACTIONS(4953),
    [anon_sym_PLUS_EQ] = ACTIONS(4953),
    [anon_sym_DASH_EQ] = ACTIONS(4953),
    [anon_sym_LT_LT_EQ] = ACTIONS(4953),
    [anon_sym_GT_GT_EQ] = ACTIONS(4951),
    [anon_sym_AMP_EQ] = ACTIONS(4953),
    [anon_sym_CARET_EQ] = ACTIONS(4953),
    [anon_sym_PIPE_EQ] = ACTIONS(4953),
    [anon_sym_and_eq] = ACTIONS(4953),
    [anon_sym_or_eq] = ACTIONS(4953),
    [anon_sym_xor_eq] = ACTIONS(4953),
    [anon_sym_LT_EQ_GT] = ACTIONS(4953),
    [anon_sym_or] = ACTIONS(4951),
    [anon_sym_and] = ACTIONS(4951),
    [anon_sym_bitor] = ACTIONS(4953),
    [anon_sym_xor] = ACTIONS(4951),
    [anon_sym_bitand] = ACTIONS(4953),
    [anon_sym_not_eq] = ACTIONS(4953),
    [anon_sym_DASH_DASH] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4953),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_DOT_STAR] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4953),
    [anon_sym_decltype] = ACTIONS(4953),
    [anon_sym_final] = ACTIONS(4953),
    [anon_sym_override] = ACTIONS(4953),
    [anon_sym_GT2] = ACTIONS(4953),
  },
  [1688] = {
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2563),
    [anon_sym_RPAREN] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2573),
    [anon_sym_PERCENT] = ACTIONS(2573),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_CARET] = ACTIONS(2573),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ_GT] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2573),
    [anon_sym_and] = ACTIONS(2573),
    [anon_sym_bitor] = ACTIONS(2573),
    [anon_sym_xor] = ACTIONS(2573),
    [anon_sym_bitand] = ACTIONS(2573),
    [anon_sym_not_eq] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_PLUS] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2573),
    [anon_sym_DOT_STAR] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2563),
  },
  [1689] = {
    [sym_string_literal] = STATE(1692),
    [sym_raw_string_literal] = STATE(1692),
    [aux_sym_concatenated_string_repeat1] = STATE(1692),
    [sym_identifier] = ACTIONS(5394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_RPAREN] = ACTIONS(5396),
    [aux_sym_preproc_if_token2] = ACTIONS(5396),
    [aux_sym_preproc_else_token1] = ACTIONS(5396),
    [aux_sym_preproc_elif_token1] = ACTIONS(5398),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5396),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5396),
    [anon_sym_LPAREN2] = ACTIONS(5396),
    [anon_sym_DASH] = ACTIONS(5398),
    [anon_sym_PLUS] = ACTIONS(5398),
    [anon_sym_STAR] = ACTIONS(5398),
    [anon_sym_SLASH] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5398),
    [anon_sym_PIPE_PIPE] = ACTIONS(5396),
    [anon_sym_AMP_AMP] = ACTIONS(5396),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_CARET] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
    [anon_sym_EQ_EQ] = ACTIONS(5396),
    [anon_sym_BANG_EQ] = ACTIONS(5396),
    [anon_sym_GT] = ACTIONS(5398),
    [anon_sym_GT_EQ] = ACTIONS(5396),
    [anon_sym_LT_EQ] = ACTIONS(5398),
    [anon_sym_LT] = ACTIONS(5398),
    [anon_sym_LT_LT] = ACTIONS(5398),
    [anon_sym_GT_GT] = ACTIONS(5398),
    [anon_sym_SEMI] = ACTIONS(5396),
    [anon_sym_COLON] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5396),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_RBRACK] = ACTIONS(5396),
    [anon_sym_EQ] = ACTIONS(5398),
    [anon_sym_QMARK] = ACTIONS(5396),
    [anon_sym_STAR_EQ] = ACTIONS(5396),
    [anon_sym_SLASH_EQ] = ACTIONS(5396),
    [anon_sym_PERCENT_EQ] = ACTIONS(5396),
    [anon_sym_PLUS_EQ] = ACTIONS(5396),
    [anon_sym_DASH_EQ] = ACTIONS(5396),
    [anon_sym_LT_LT_EQ] = ACTIONS(5396),
    [anon_sym_GT_GT_EQ] = ACTIONS(5396),
    [anon_sym_AMP_EQ] = ACTIONS(5396),
    [anon_sym_CARET_EQ] = ACTIONS(5396),
    [anon_sym_PIPE_EQ] = ACTIONS(5396),
    [anon_sym_and_eq] = ACTIONS(5398),
    [anon_sym_or_eq] = ACTIONS(5398),
    [anon_sym_xor_eq] = ACTIONS(5398),
    [anon_sym_LT_EQ_GT] = ACTIONS(5396),
    [anon_sym_or] = ACTIONS(5398),
    [anon_sym_and] = ACTIONS(5398),
    [anon_sym_bitor] = ACTIONS(5398),
    [anon_sym_xor] = ACTIONS(5398),
    [anon_sym_bitand] = ACTIONS(5398),
    [anon_sym_not_eq] = ACTIONS(5398),
    [anon_sym_DASH_DASH] = ACTIONS(5396),
    [anon_sym_PLUS_PLUS] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(5398),
    [anon_sym_DOT_STAR] = ACTIONS(5396),
    [anon_sym_DASH_GT] = ACTIONS(5396),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [sym_literal_suffix] = ACTIONS(5398),
  },
  [1690] = {
    [sym_catch_clause] = STATE(1679),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1679),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token2] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [aux_sym_preproc_else_token1] = ACTIONS(2483),
    [aux_sym_preproc_elif_token1] = ACTIONS(2483),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_virtual] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym___attribute] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym__Nonnull] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_private] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_friend] = ACTIONS(2483),
    [anon_sym_public] = ACTIONS(2483),
    [anon_sym_protected] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_catch] = ACTIONS(5379),
  },
  [1691] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_SLASH] = ACTIONS(4959),
    [anon_sym_PERCENT] = ACTIONS(4959),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4959),
    [anon_sym_CARET] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_GT_EQ] = ACTIONS(4959),
    [anon_sym_LT_EQ] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4959),
    [anon_sym_GT_GT] = ACTIONS(4959),
    [anon_sym___extension__] = ACTIONS(4961),
    [anon_sym___attribute__] = ACTIONS(4961),
    [anon_sym___attribute] = ACTIONS(4959),
    [anon_sym_COLON] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(4961),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_EQ] = ACTIONS(4959),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_constexpr] = ACTIONS(4961),
    [anon_sym_volatile] = ACTIONS(4961),
    [anon_sym_restrict] = ACTIONS(4961),
    [anon_sym___restrict__] = ACTIONS(4961),
    [anon_sym__Atomic] = ACTIONS(4961),
    [anon_sym__Noreturn] = ACTIONS(4961),
    [anon_sym_noreturn] = ACTIONS(4961),
    [anon_sym__Nonnull] = ACTIONS(4961),
    [anon_sym_mutable] = ACTIONS(4961),
    [anon_sym_constinit] = ACTIONS(4961),
    [anon_sym_consteval] = ACTIONS(4961),
    [anon_sym_alignas] = ACTIONS(4961),
    [anon_sym__Alignas] = ACTIONS(4961),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4959),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_and_eq] = ACTIONS(4961),
    [anon_sym_or_eq] = ACTIONS(4961),
    [anon_sym_xor_eq] = ACTIONS(4961),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4959),
    [anon_sym_and] = ACTIONS(4959),
    [anon_sym_bitor] = ACTIONS(4961),
    [anon_sym_xor] = ACTIONS(4959),
    [anon_sym_bitand] = ACTIONS(4961),
    [anon_sym_not_eq] = ACTIONS(4961),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4961),
    [anon_sym_decltype] = ACTIONS(4961),
    [anon_sym_final] = ACTIONS(4961),
    [anon_sym_override] = ACTIONS(4961),
    [anon_sym_GT2] = ACTIONS(4961),
  },
  [1692] = {
    [sym_string_literal] = STATE(1692),
    [sym_raw_string_literal] = STATE(1692),
    [aux_sym_concatenated_string_repeat1] = STATE(1692),
    [sym_identifier] = ACTIONS(5400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_RPAREN] = ACTIONS(5403),
    [aux_sym_preproc_if_token2] = ACTIONS(5403),
    [aux_sym_preproc_else_token1] = ACTIONS(5403),
    [aux_sym_preproc_elif_token1] = ACTIONS(5405),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5403),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5403),
    [anon_sym_LPAREN2] = ACTIONS(5403),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5405),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5405),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_CARET] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_LT_EQ] = ACTIONS(5405),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5405),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym_COLON] = ACTIONS(5403),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_RBRACK] = ACTIONS(5403),
    [anon_sym_EQ] = ACTIONS(5405),
    [anon_sym_QMARK] = ACTIONS(5403),
    [anon_sym_STAR_EQ] = ACTIONS(5403),
    [anon_sym_SLASH_EQ] = ACTIONS(5403),
    [anon_sym_PERCENT_EQ] = ACTIONS(5403),
    [anon_sym_PLUS_EQ] = ACTIONS(5403),
    [anon_sym_DASH_EQ] = ACTIONS(5403),
    [anon_sym_LT_LT_EQ] = ACTIONS(5403),
    [anon_sym_GT_GT_EQ] = ACTIONS(5403),
    [anon_sym_AMP_EQ] = ACTIONS(5403),
    [anon_sym_CARET_EQ] = ACTIONS(5403),
    [anon_sym_PIPE_EQ] = ACTIONS(5403),
    [anon_sym_and_eq] = ACTIONS(5405),
    [anon_sym_or_eq] = ACTIONS(5405),
    [anon_sym_xor_eq] = ACTIONS(5405),
    [anon_sym_LT_EQ_GT] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5405),
    [anon_sym_and] = ACTIONS(5405),
    [anon_sym_bitor] = ACTIONS(5405),
    [anon_sym_xor] = ACTIONS(5405),
    [anon_sym_bitand] = ACTIONS(5405),
    [anon_sym_not_eq] = ACTIONS(5405),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_DOT_STAR] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5403),
    [anon_sym_L_DQUOTE] = ACTIONS(5407),
    [anon_sym_u_DQUOTE] = ACTIONS(5407),
    [anon_sym_U_DQUOTE] = ACTIONS(5407),
    [anon_sym_u8_DQUOTE] = ACTIONS(5407),
    [anon_sym_DQUOTE] = ACTIONS(5407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5410),
    [anon_sym_LR_DQUOTE] = ACTIONS(5410),
    [anon_sym_uR_DQUOTE] = ACTIONS(5410),
    [anon_sym_UR_DQUOTE] = ACTIONS(5410),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5410),
    [sym_literal_suffix] = ACTIONS(5405),
  },
  [1693] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4990),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(4988),
    [anon_sym_SLASH] = ACTIONS(4988),
    [anon_sym_PERCENT] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym_EQ_EQ] = ACTIONS(4990),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4988),
    [anon_sym_GT_EQ] = ACTIONS(4988),
    [anon_sym_LT_EQ] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4988),
    [anon_sym_GT_GT] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4990),
    [anon_sym___attribute__] = ACTIONS(4990),
    [anon_sym___attribute] = ACTIONS(4988),
    [anon_sym_COLON] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(4990),
    [anon_sym_EQ] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4990),
    [anon_sym_volatile] = ACTIONS(4990),
    [anon_sym_restrict] = ACTIONS(4990),
    [anon_sym___restrict__] = ACTIONS(4990),
    [anon_sym__Atomic] = ACTIONS(4990),
    [anon_sym__Noreturn] = ACTIONS(4990),
    [anon_sym_noreturn] = ACTIONS(4990),
    [anon_sym__Nonnull] = ACTIONS(4990),
    [anon_sym_mutable] = ACTIONS(4990),
    [anon_sym_constinit] = ACTIONS(4990),
    [anon_sym_consteval] = ACTIONS(4990),
    [anon_sym_alignas] = ACTIONS(4990),
    [anon_sym__Alignas] = ACTIONS(4990),
    [anon_sym_QMARK] = ACTIONS(4990),
    [anon_sym_STAR_EQ] = ACTIONS(4990),
    [anon_sym_SLASH_EQ] = ACTIONS(4990),
    [anon_sym_PERCENT_EQ] = ACTIONS(4990),
    [anon_sym_PLUS_EQ] = ACTIONS(4990),
    [anon_sym_DASH_EQ] = ACTIONS(4990),
    [anon_sym_LT_LT_EQ] = ACTIONS(4990),
    [anon_sym_GT_GT_EQ] = ACTIONS(4988),
    [anon_sym_AMP_EQ] = ACTIONS(4990),
    [anon_sym_CARET_EQ] = ACTIONS(4990),
    [anon_sym_PIPE_EQ] = ACTIONS(4990),
    [anon_sym_and_eq] = ACTIONS(4990),
    [anon_sym_or_eq] = ACTIONS(4990),
    [anon_sym_xor_eq] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_and] = ACTIONS(4988),
    [anon_sym_bitor] = ACTIONS(4990),
    [anon_sym_xor] = ACTIONS(4988),
    [anon_sym_bitand] = ACTIONS(4990),
    [anon_sym_not_eq] = ACTIONS(4990),
    [anon_sym_DASH_DASH] = ACTIONS(4990),
    [anon_sym_PLUS_PLUS] = ACTIONS(4990),
    [anon_sym_DOT] = ACTIONS(4988),
    [anon_sym_DOT_STAR] = ACTIONS(4990),
    [anon_sym_DASH_GT] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4990),
    [anon_sym_decltype] = ACTIONS(4990),
    [anon_sym_final] = ACTIONS(4990),
    [anon_sym_override] = ACTIONS(4990),
    [anon_sym_GT2] = ACTIONS(4990),
  },
  [1694] = {
    [sym_identifier] = ACTIONS(5413),
    [anon_sym_LPAREN2] = ACTIONS(5415),
    [anon_sym_BANG] = ACTIONS(5415),
    [anon_sym_TILDE] = ACTIONS(5415),
    [anon_sym_DASH] = ACTIONS(5413),
    [anon_sym_PLUS] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5415),
    [anon_sym_AMP] = ACTIONS(5415),
    [anon_sym_SEMI] = ACTIONS(5415),
    [anon_sym___extension__] = ACTIONS(5413),
    [anon_sym_COLON_COLON] = ACTIONS(5415),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5415),
    [anon_sym_LBRACE] = ACTIONS(5415),
    [anon_sym_LBRACK] = ACTIONS(5413),
    [sym_primitive_type] = ACTIONS(5413),
    [anon_sym_if] = ACTIONS(5413),
    [anon_sym_switch] = ACTIONS(5413),
    [anon_sym_case] = ACTIONS(5413),
    [anon_sym_default] = ACTIONS(5413),
    [anon_sym_while] = ACTIONS(5413),
    [anon_sym_do] = ACTIONS(5413),
    [anon_sym_for] = ACTIONS(5413),
    [anon_sym_return] = ACTIONS(5413),
    [anon_sym_break] = ACTIONS(5413),
    [anon_sym_continue] = ACTIONS(5413),
    [anon_sym_goto] = ACTIONS(5413),
    [anon_sym___try] = ACTIONS(5413),
    [anon_sym___leave] = ACTIONS(5413),
    [anon_sym_not] = ACTIONS(5413),
    [anon_sym_compl] = ACTIONS(5413),
    [anon_sym_DASH_DASH] = ACTIONS(5415),
    [anon_sym_PLUS_PLUS] = ACTIONS(5415),
    [anon_sym_sizeof] = ACTIONS(5413),
    [anon_sym___alignof__] = ACTIONS(5413),
    [anon_sym___alignof] = ACTIONS(5413),
    [anon_sym__alignof] = ACTIONS(5413),
    [anon_sym_alignof] = ACTIONS(5413),
    [anon_sym__Alignof] = ACTIONS(5413),
    [anon_sym_offsetof] = ACTIONS(5413),
    [anon_sym__Generic] = ACTIONS(5413),
    [anon_sym_asm] = ACTIONS(5413),
    [anon_sym___asm__] = ACTIONS(5413),
    [anon_sym___asm] = ACTIONS(5413),
    [sym_number_literal] = ACTIONS(5415),
    [anon_sym_L_SQUOTE] = ACTIONS(5415),
    [anon_sym_u_SQUOTE] = ACTIONS(5415),
    [anon_sym_U_SQUOTE] = ACTIONS(5415),
    [anon_sym_u8_SQUOTE] = ACTIONS(5415),
    [anon_sym_SQUOTE] = ACTIONS(5415),
    [anon_sym_L_DQUOTE] = ACTIONS(5415),
    [anon_sym_u_DQUOTE] = ACTIONS(5415),
    [anon_sym_U_DQUOTE] = ACTIONS(5415),
    [anon_sym_u8_DQUOTE] = ACTIONS(5415),
    [anon_sym_DQUOTE] = ACTIONS(5415),
    [sym_true] = ACTIONS(5413),
    [sym_false] = ACTIONS(5413),
    [anon_sym_NULL] = ACTIONS(5413),
    [anon_sym_nullptr] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5413),
    [anon_sym_template] = ACTIONS(5413),
    [anon_sym_try] = ACTIONS(5413),
    [anon_sym_delete] = ACTIONS(5413),
    [anon_sym_throw] = ACTIONS(5413),
    [anon_sym_co_return] = ACTIONS(5413),
    [anon_sym_co_yield] = ACTIONS(5413),
    [anon_sym_R_DQUOTE] = ACTIONS(5415),
    [anon_sym_LR_DQUOTE] = ACTIONS(5415),
    [anon_sym_uR_DQUOTE] = ACTIONS(5415),
    [anon_sym_UR_DQUOTE] = ACTIONS(5415),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5415),
    [anon_sym_co_await] = ACTIONS(5413),
    [anon_sym_new] = ACTIONS(5413),
    [anon_sym_requires] = ACTIONS(5413),
    [sym_this] = ACTIONS(5413),
  },
  [1695] = {
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2563),
    [anon_sym_RPAREN] = ACTIONS(2563),
    [aux_sym_preproc_if_token2] = ACTIONS(2563),
    [aux_sym_preproc_else_token1] = ACTIONS(2563),
    [aux_sym_preproc_elif_token1] = ACTIONS(2573),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2573),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_CARET] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_LT_LT] = ACTIONS(2563),
    [anon_sym_GT_GT] = ACTIONS(2563),
    [anon_sym_SEMI] = ACTIONS(2563),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_RBRACE] = ACTIONS(2563),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_RBRACK] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_LT_EQ_GT] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2573),
    [anon_sym_and] = ACTIONS(2573),
    [anon_sym_bitor] = ACTIONS(2573),
    [anon_sym_xor] = ACTIONS(2573),
    [anon_sym_bitand] = ACTIONS(2573),
    [anon_sym_not_eq] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_PLUS] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2573),
    [anon_sym_DOT_STAR] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_final] = ACTIONS(2573),
    [anon_sym_override] = ACTIONS(2573),
    [anon_sym_requires] = ACTIONS(2573),
  },
  [1696] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7267),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7267),
    [sym_variadic_parameter_declaration] = STATE(7267),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5417),
    [anon_sym_RPAREN] = ACTIONS(5419),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1697] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7399),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7399),
    [sym_variadic_parameter_declaration] = STATE(7399),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1928),
    [anon_sym_RPAREN] = ACTIONS(4296),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1698] = {
    [sym_type_qualifier] = STATE(1698),
    [sym_alignas_qualifier] = STATE(1868),
    [aux_sym_array_declarator_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(5421),
    [anon_sym_LPAREN2] = ACTIONS(5423),
    [anon_sym_BANG] = ACTIONS(5423),
    [anon_sym_TILDE] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5423),
    [anon_sym_AMP] = ACTIONS(5423),
    [anon_sym___extension__] = ACTIONS(5425),
    [anon_sym_COLON_COLON] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_static] = ACTIONS(5428),
    [anon_sym_RBRACK] = ACTIONS(5423),
    [anon_sym_const] = ACTIONS(5425),
    [anon_sym_constexpr] = ACTIONS(5425),
    [anon_sym_volatile] = ACTIONS(5425),
    [anon_sym_restrict] = ACTIONS(5425),
    [anon_sym___restrict__] = ACTIONS(5425),
    [anon_sym__Atomic] = ACTIONS(5425),
    [anon_sym__Noreturn] = ACTIONS(5425),
    [anon_sym_noreturn] = ACTIONS(5425),
    [anon_sym__Nonnull] = ACTIONS(5425),
    [anon_sym_mutable] = ACTIONS(5425),
    [anon_sym_constinit] = ACTIONS(5425),
    [anon_sym_consteval] = ACTIONS(5425),
    [anon_sym_alignas] = ACTIONS(5431),
    [anon_sym__Alignas] = ACTIONS(5431),
    [sym_primitive_type] = ACTIONS(5421),
    [anon_sym_not] = ACTIONS(5421),
    [anon_sym_compl] = ACTIONS(5421),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_sizeof] = ACTIONS(5421),
    [anon_sym___alignof__] = ACTIONS(5421),
    [anon_sym___alignof] = ACTIONS(5421),
    [anon_sym__alignof] = ACTIONS(5421),
    [anon_sym_alignof] = ACTIONS(5421),
    [anon_sym__Alignof] = ACTIONS(5421),
    [anon_sym_offsetof] = ACTIONS(5421),
    [anon_sym__Generic] = ACTIONS(5421),
    [anon_sym_asm] = ACTIONS(5421),
    [anon_sym___asm__] = ACTIONS(5421),
    [anon_sym___asm] = ACTIONS(5421),
    [sym_number_literal] = ACTIONS(5423),
    [anon_sym_L_SQUOTE] = ACTIONS(5423),
    [anon_sym_u_SQUOTE] = ACTIONS(5423),
    [anon_sym_U_SQUOTE] = ACTIONS(5423),
    [anon_sym_u8_SQUOTE] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5423),
    [anon_sym_L_DQUOTE] = ACTIONS(5423),
    [anon_sym_u_DQUOTE] = ACTIONS(5423),
    [anon_sym_U_DQUOTE] = ACTIONS(5423),
    [anon_sym_u8_DQUOTE] = ACTIONS(5423),
    [anon_sym_DQUOTE] = ACTIONS(5423),
    [sym_true] = ACTIONS(5421),
    [sym_false] = ACTIONS(5421),
    [anon_sym_NULL] = ACTIONS(5421),
    [anon_sym_nullptr] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5421),
    [anon_sym_template] = ACTIONS(5421),
    [anon_sym_delete] = ACTIONS(5421),
    [anon_sym_R_DQUOTE] = ACTIONS(5423),
    [anon_sym_LR_DQUOTE] = ACTIONS(5423),
    [anon_sym_uR_DQUOTE] = ACTIONS(5423),
    [anon_sym_UR_DQUOTE] = ACTIONS(5423),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5423),
    [anon_sym_co_await] = ACTIONS(5421),
    [anon_sym_new] = ACTIONS(5421),
    [anon_sym_requires] = ACTIONS(5421),
    [sym_this] = ACTIONS(5421),
  },
  [1699] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7166),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7166),
    [sym_variadic_parameter_declaration] = STATE(7166),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5434),
    [anon_sym_RPAREN] = ACTIONS(5436),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1700] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7498),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7498),
    [sym_variadic_parameter_declaration] = STATE(7498),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5438),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1701] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5005),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5005),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym___extension__] = ACTIONS(5003),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_EQ] = ACTIONS(5005),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(5003),
    [anon_sym_volatile] = ACTIONS(5003),
    [anon_sym_restrict] = ACTIONS(5003),
    [anon_sym___restrict__] = ACTIONS(5003),
    [anon_sym__Atomic] = ACTIONS(5003),
    [anon_sym__Noreturn] = ACTIONS(5003),
    [anon_sym_noreturn] = ACTIONS(5003),
    [anon_sym__Nonnull] = ACTIONS(5003),
    [anon_sym_mutable] = ACTIONS(5003),
    [anon_sym_constinit] = ACTIONS(5003),
    [anon_sym_consteval] = ACTIONS(5003),
    [anon_sym_alignas] = ACTIONS(5003),
    [anon_sym__Alignas] = ACTIONS(5003),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_STAR_EQ] = ACTIONS(4998),
    [anon_sym_SLASH_EQ] = ACTIONS(4998),
    [anon_sym_PERCENT_EQ] = ACTIONS(4998),
    [anon_sym_PLUS_EQ] = ACTIONS(4998),
    [anon_sym_DASH_EQ] = ACTIONS(4998),
    [anon_sym_LT_LT_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT_EQ] = ACTIONS(4998),
    [anon_sym_AMP_EQ] = ACTIONS(4998),
    [anon_sym_CARET_EQ] = ACTIONS(4998),
    [anon_sym_PIPE_EQ] = ACTIONS(4998),
    [anon_sym_and_eq] = ACTIONS(4998),
    [anon_sym_or_eq] = ACTIONS(4998),
    [anon_sym_xor_eq] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(4998),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(4998),
    [anon_sym_not_eq] = ACTIONS(4998),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(5005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5003),
    [anon_sym_decltype] = ACTIONS(5003),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4998),
  },
  [1702] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token2] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [aux_sym_preproc_else_token1] = ACTIONS(1940),
    [aux_sym_preproc_elif_token1] = ACTIONS(1940),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_friend] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_catch] = ACTIONS(1940),
  },
  [1703] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7359),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7359),
    [sym_variadic_parameter_declaration] = STATE(7359),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1704] = {
    [sym_identifier] = ACTIONS(1936),
    [aux_sym_preproc_def_token1] = ACTIONS(1936),
    [aux_sym_preproc_if_token1] = ACTIONS(1936),
    [aux_sym_preproc_if_token2] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1936),
    [aux_sym_preproc_else_token1] = ACTIONS(1936),
    [aux_sym_preproc_elif_token1] = ACTIONS(1936),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1936),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1936),
    [sym_preproc_directive] = ACTIONS(1936),
    [anon_sym_LPAREN2] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(1934),
    [anon_sym_AMP_AMP] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym___extension__] = ACTIONS(1936),
    [anon_sym_typedef] = ACTIONS(1936),
    [anon_sym_virtual] = ACTIONS(1936),
    [anon_sym_extern] = ACTIONS(1936),
    [anon_sym___attribute__] = ACTIONS(1936),
    [anon_sym___attribute] = ACTIONS(1936),
    [anon_sym_using] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1934),
    [anon_sym___declspec] = ACTIONS(1936),
    [anon_sym___based] = ACTIONS(1936),
    [anon_sym_signed] = ACTIONS(1936),
    [anon_sym_unsigned] = ACTIONS(1936),
    [anon_sym_long] = ACTIONS(1936),
    [anon_sym_short] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_register] = ACTIONS(1936),
    [anon_sym_inline] = ACTIONS(1936),
    [anon_sym___inline] = ACTIONS(1936),
    [anon_sym___inline__] = ACTIONS(1936),
    [anon_sym___forceinline] = ACTIONS(1936),
    [anon_sym_thread_local] = ACTIONS(1936),
    [anon_sym___thread] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_constexpr] = ACTIONS(1936),
    [anon_sym_volatile] = ACTIONS(1936),
    [anon_sym_restrict] = ACTIONS(1936),
    [anon_sym___restrict__] = ACTIONS(1936),
    [anon_sym__Atomic] = ACTIONS(1936),
    [anon_sym__Noreturn] = ACTIONS(1936),
    [anon_sym_noreturn] = ACTIONS(1936),
    [anon_sym__Nonnull] = ACTIONS(1936),
    [anon_sym_mutable] = ACTIONS(1936),
    [anon_sym_constinit] = ACTIONS(1936),
    [anon_sym_consteval] = ACTIONS(1936),
    [anon_sym_alignas] = ACTIONS(1936),
    [anon_sym__Alignas] = ACTIONS(1936),
    [sym_primitive_type] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_struct] = ACTIONS(1936),
    [anon_sym_union] = ACTIONS(1936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1936),
    [anon_sym_decltype] = ACTIONS(1936),
    [anon_sym_explicit] = ACTIONS(1936),
    [anon_sym_typename] = ACTIONS(1936),
    [anon_sym_private] = ACTIONS(1936),
    [anon_sym_template] = ACTIONS(1936),
    [anon_sym_operator] = ACTIONS(1936),
    [anon_sym_friend] = ACTIONS(1936),
    [anon_sym_public] = ACTIONS(1936),
    [anon_sym_protected] = ACTIONS(1936),
    [anon_sym_static_assert] = ACTIONS(1936),
    [anon_sym_catch] = ACTIONS(1936),
  },
  [1705] = {
    [sym_template_argument_list] = STATE(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_LPAREN2] = ACTIONS(4967),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_SLASH] = ACTIONS(4972),
    [anon_sym_PERCENT] = ACTIONS(4972),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4972),
    [anon_sym_CARET] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4974),
    [anon_sym_EQ_EQ] = ACTIONS(4965),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_GT] = ACTIONS(4972),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(5030),
    [anon_sym_LT_LT] = ACTIONS(4972),
    [anon_sym_GT_GT] = ACTIONS(4972),
    [anon_sym___extension__] = ACTIONS(4970),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4965),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4974),
    [anon_sym_EQ] = ACTIONS(4972),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_constexpr] = ACTIONS(4970),
    [anon_sym_volatile] = ACTIONS(4970),
    [anon_sym_restrict] = ACTIONS(4970),
    [anon_sym___restrict__] = ACTIONS(4970),
    [anon_sym__Atomic] = ACTIONS(4970),
    [anon_sym__Noreturn] = ACTIONS(4970),
    [anon_sym_noreturn] = ACTIONS(4970),
    [anon_sym__Nonnull] = ACTIONS(4970),
    [anon_sym_mutable] = ACTIONS(4970),
    [anon_sym_constinit] = ACTIONS(4970),
    [anon_sym_consteval] = ACTIONS(4970),
    [anon_sym_alignas] = ACTIONS(4970),
    [anon_sym__Alignas] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_and_eq] = ACTIONS(4965),
    [anon_sym_or_eq] = ACTIONS(4965),
    [anon_sym_xor_eq] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4972),
    [anon_sym_and] = ACTIONS(4972),
    [anon_sym_bitor] = ACTIONS(4965),
    [anon_sym_xor] = ACTIONS(4972),
    [anon_sym_bitand] = ACTIONS(4965),
    [anon_sym_not_eq] = ACTIONS(4965),
    [anon_sym_DASH_DASH] = ACTIONS(4965),
    [anon_sym_PLUS_PLUS] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4972),
    [anon_sym_DOT_STAR] = ACTIONS(4965),
    [anon_sym_DASH_GT] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4970),
    [anon_sym_decltype] = ACTIONS(4970),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4965),
  },
  [1706] = {
    [sym_identifier] = ACTIONS(2619),
    [aux_sym_preproc_def_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token2] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2619),
    [aux_sym_preproc_else_token1] = ACTIONS(2619),
    [aux_sym_preproc_elif_token1] = ACTIONS(2619),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2619),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2619),
    [sym_preproc_directive] = ACTIONS(2619),
    [anon_sym_LPAREN2] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(2621),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(2619),
    [anon_sym_typedef] = ACTIONS(2619),
    [anon_sym_virtual] = ACTIONS(2619),
    [anon_sym_extern] = ACTIONS(2619),
    [anon_sym___attribute__] = ACTIONS(2619),
    [anon_sym___attribute] = ACTIONS(2619),
    [anon_sym_using] = ACTIONS(2619),
    [anon_sym_COLON_COLON] = ACTIONS(2621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2621),
    [anon_sym___declspec] = ACTIONS(2619),
    [anon_sym___based] = ACTIONS(2619),
    [anon_sym_signed] = ACTIONS(2619),
    [anon_sym_unsigned] = ACTIONS(2619),
    [anon_sym_long] = ACTIONS(2619),
    [anon_sym_short] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_register] = ACTIONS(2619),
    [anon_sym_inline] = ACTIONS(2619),
    [anon_sym___inline] = ACTIONS(2619),
    [anon_sym___inline__] = ACTIONS(2619),
    [anon_sym___forceinline] = ACTIONS(2619),
    [anon_sym_thread_local] = ACTIONS(2619),
    [anon_sym___thread] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_constexpr] = ACTIONS(2619),
    [anon_sym_volatile] = ACTIONS(2619),
    [anon_sym_restrict] = ACTIONS(2619),
    [anon_sym___restrict__] = ACTIONS(2619),
    [anon_sym__Atomic] = ACTIONS(2619),
    [anon_sym__Noreturn] = ACTIONS(2619),
    [anon_sym_noreturn] = ACTIONS(2619),
    [anon_sym__Nonnull] = ACTIONS(2619),
    [anon_sym_mutable] = ACTIONS(2619),
    [anon_sym_constinit] = ACTIONS(2619),
    [anon_sym_consteval] = ACTIONS(2619),
    [anon_sym_alignas] = ACTIONS(2619),
    [anon_sym__Alignas] = ACTIONS(2619),
    [sym_primitive_type] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_struct] = ACTIONS(2619),
    [anon_sym_union] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2619),
    [anon_sym_decltype] = ACTIONS(2619),
    [anon_sym_explicit] = ACTIONS(2619),
    [anon_sym_typename] = ACTIONS(2619),
    [anon_sym_private] = ACTIONS(2619),
    [anon_sym_template] = ACTIONS(2619),
    [anon_sym_operator] = ACTIONS(2619),
    [anon_sym_friend] = ACTIONS(2619),
    [anon_sym_public] = ACTIONS(2619),
    [anon_sym_protected] = ACTIONS(2619),
    [anon_sym_static_assert] = ACTIONS(2619),
    [anon_sym_catch] = ACTIONS(2619),
  },
  [1707] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token2] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [aux_sym_preproc_else_token1] = ACTIONS(1940),
    [aux_sym_preproc_elif_token1] = ACTIONS(1940),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(5442),
    [anon_sym___attribute] = ACTIONS(5442),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_friend] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
  },
  [1708] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7766),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7766),
    [sym_variadic_parameter_declaration] = STATE(7766),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5444),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1709] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token2] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [aux_sym_preproc_else_token1] = ACTIONS(1940),
    [aux_sym_preproc_elif_token1] = ACTIONS(1940),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_friend] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
  },
  [1710] = {
    [sym_identifier] = ACTIONS(2827),
    [aux_sym_preproc_def_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2827),
    [aux_sym_preproc_else_token1] = ACTIONS(2827),
    [aux_sym_preproc_elif_token1] = ACTIONS(2827),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2827),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2827),
    [sym_preproc_directive] = ACTIONS(2827),
    [anon_sym_LPAREN2] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym___extension__] = ACTIONS(2827),
    [anon_sym_typedef] = ACTIONS(2827),
    [anon_sym_virtual] = ACTIONS(2827),
    [anon_sym_extern] = ACTIONS(2827),
    [anon_sym___attribute__] = ACTIONS(2827),
    [anon_sym___attribute] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2829),
    [anon_sym___declspec] = ACTIONS(2827),
    [anon_sym___based] = ACTIONS(2827),
    [anon_sym_signed] = ACTIONS(2827),
    [anon_sym_unsigned] = ACTIONS(2827),
    [anon_sym_long] = ACTIONS(2827),
    [anon_sym_short] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_static] = ACTIONS(2827),
    [anon_sym_register] = ACTIONS(2827),
    [anon_sym_inline] = ACTIONS(2827),
    [anon_sym___inline] = ACTIONS(2827),
    [anon_sym___inline__] = ACTIONS(2827),
    [anon_sym___forceinline] = ACTIONS(2827),
    [anon_sym_thread_local] = ACTIONS(2827),
    [anon_sym___thread] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_constexpr] = ACTIONS(2827),
    [anon_sym_volatile] = ACTIONS(2827),
    [anon_sym_restrict] = ACTIONS(2827),
    [anon_sym___restrict__] = ACTIONS(2827),
    [anon_sym__Atomic] = ACTIONS(2827),
    [anon_sym__Noreturn] = ACTIONS(2827),
    [anon_sym_noreturn] = ACTIONS(2827),
    [anon_sym__Nonnull] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_constinit] = ACTIONS(2827),
    [anon_sym_consteval] = ACTIONS(2827),
    [anon_sym_alignas] = ACTIONS(2827),
    [anon_sym__Alignas] = ACTIONS(2827),
    [sym_primitive_type] = ACTIONS(2827),
    [anon_sym_enum] = ACTIONS(2827),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_union] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2827),
    [anon_sym_decltype] = ACTIONS(2827),
    [anon_sym_explicit] = ACTIONS(2827),
    [anon_sym_typename] = ACTIONS(2827),
    [anon_sym_private] = ACTIONS(2827),
    [anon_sym_template] = ACTIONS(2827),
    [anon_sym_operator] = ACTIONS(2827),
    [anon_sym_friend] = ACTIONS(2827),
    [anon_sym_public] = ACTIONS(2827),
    [anon_sym_protected] = ACTIONS(2827),
    [anon_sym_static_assert] = ACTIONS(2827),
  },
  [1711] = {
    [sym_identifier] = ACTIONS(5446),
    [aux_sym_preproc_def_token1] = ACTIONS(5446),
    [aux_sym_preproc_if_token1] = ACTIONS(5446),
    [aux_sym_preproc_if_token2] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5446),
    [aux_sym_preproc_else_token1] = ACTIONS(5446),
    [aux_sym_preproc_elif_token1] = ACTIONS(5446),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5446),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5446),
    [sym_preproc_directive] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5448),
    [anon_sym_TILDE] = ACTIONS(5448),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym___extension__] = ACTIONS(5446),
    [anon_sym_typedef] = ACTIONS(5446),
    [anon_sym_virtual] = ACTIONS(5446),
    [anon_sym_extern] = ACTIONS(5446),
    [anon_sym___attribute__] = ACTIONS(5446),
    [anon_sym___attribute] = ACTIONS(5446),
    [anon_sym_using] = ACTIONS(5446),
    [anon_sym_COLON_COLON] = ACTIONS(5448),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5448),
    [anon_sym___declspec] = ACTIONS(5446),
    [anon_sym___based] = ACTIONS(5446),
    [anon_sym_signed] = ACTIONS(5446),
    [anon_sym_unsigned] = ACTIONS(5446),
    [anon_sym_long] = ACTIONS(5446),
    [anon_sym_short] = ACTIONS(5446),
    [anon_sym_LBRACK] = ACTIONS(5446),
    [anon_sym_static] = ACTIONS(5446),
    [anon_sym_register] = ACTIONS(5446),
    [anon_sym_inline] = ACTIONS(5446),
    [anon_sym___inline] = ACTIONS(5446),
    [anon_sym___inline__] = ACTIONS(5446),
    [anon_sym___forceinline] = ACTIONS(5446),
    [anon_sym_thread_local] = ACTIONS(5446),
    [anon_sym___thread] = ACTIONS(5446),
    [anon_sym_const] = ACTIONS(5446),
    [anon_sym_constexpr] = ACTIONS(5446),
    [anon_sym_volatile] = ACTIONS(5446),
    [anon_sym_restrict] = ACTIONS(5446),
    [anon_sym___restrict__] = ACTIONS(5446),
    [anon_sym__Atomic] = ACTIONS(5446),
    [anon_sym__Noreturn] = ACTIONS(5446),
    [anon_sym_noreturn] = ACTIONS(5446),
    [anon_sym__Nonnull] = ACTIONS(5446),
    [anon_sym_mutable] = ACTIONS(5446),
    [anon_sym_constinit] = ACTIONS(5446),
    [anon_sym_consteval] = ACTIONS(5446),
    [anon_sym_alignas] = ACTIONS(5446),
    [anon_sym__Alignas] = ACTIONS(5446),
    [sym_primitive_type] = ACTIONS(5446),
    [anon_sym_enum] = ACTIONS(5446),
    [anon_sym_class] = ACTIONS(5446),
    [anon_sym_struct] = ACTIONS(5446),
    [anon_sym_union] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5446),
    [anon_sym_decltype] = ACTIONS(5446),
    [anon_sym_explicit] = ACTIONS(5446),
    [anon_sym_typename] = ACTIONS(5446),
    [anon_sym_private] = ACTIONS(5446),
    [anon_sym_template] = ACTIONS(5446),
    [anon_sym_operator] = ACTIONS(5446),
    [anon_sym_friend] = ACTIONS(5446),
    [anon_sym_public] = ACTIONS(5446),
    [anon_sym_protected] = ACTIONS(5446),
    [anon_sym_static_assert] = ACTIONS(5446),
  },
  [1712] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token2] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [aux_sym_preproc_else_token1] = ACTIONS(2911),
    [aux_sym_preproc_elif_token1] = ACTIONS(2911),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_friend] = ACTIONS(2911),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
  },
  [1713] = {
    [sym_identifier] = ACTIONS(5450),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym___extension__] = ACTIONS(5450),
    [anon_sym___attribute__] = ACTIONS(5450),
    [anon_sym___attribute] = ACTIONS(5450),
    [anon_sym_COLON] = ACTIONS(5450),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym___based] = ACTIONS(5450),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_signed] = ACTIONS(5450),
    [anon_sym_unsigned] = ACTIONS(5450),
    [anon_sym_long] = ACTIONS(5450),
    [anon_sym_short] = ACTIONS(5450),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_const] = ACTIONS(5450),
    [anon_sym_constexpr] = ACTIONS(5450),
    [anon_sym_volatile] = ACTIONS(5450),
    [anon_sym_restrict] = ACTIONS(5450),
    [anon_sym___restrict__] = ACTIONS(5450),
    [anon_sym__Atomic] = ACTIONS(5450),
    [anon_sym__Noreturn] = ACTIONS(5450),
    [anon_sym_noreturn] = ACTIONS(5450),
    [anon_sym__Nonnull] = ACTIONS(5450),
    [anon_sym_mutable] = ACTIONS(5450),
    [anon_sym_constinit] = ACTIONS(5450),
    [anon_sym_consteval] = ACTIONS(5450),
    [anon_sym_alignas] = ACTIONS(5450),
    [anon_sym__Alignas] = ACTIONS(5450),
    [sym_primitive_type] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_and] = ACTIONS(5450),
    [anon_sym_bitor] = ACTIONS(5450),
    [anon_sym_xor] = ACTIONS(5450),
    [anon_sym_bitand] = ACTIONS(5450),
    [anon_sym_not_eq] = ACTIONS(5450),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5450),
    [anon_sym_decltype] = ACTIONS(5450),
    [anon_sym_final] = ACTIONS(5450),
    [anon_sym_override] = ACTIONS(5450),
    [anon_sym_requires] = ACTIONS(5450),
  },
  [1714] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token2] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [aux_sym_preproc_else_token1] = ACTIONS(2911),
    [aux_sym_preproc_elif_token1] = ACTIONS(2911),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_friend] = ACTIONS(2911),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
  },
  [1715] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token2] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [aux_sym_preproc_else_token1] = ACTIONS(2915),
    [aux_sym_preproc_elif_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_private] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_friend] = ACTIONS(2915),
    [anon_sym_public] = ACTIONS(2915),
    [anon_sym_protected] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
  },
  [1716] = {
    [sym_identifier] = ACTIONS(3035),
    [aux_sym_preproc_def_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token2] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3035),
    [aux_sym_preproc_else_token1] = ACTIONS(3035),
    [aux_sym_preproc_elif_token1] = ACTIONS(3035),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3035),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3035),
    [sym_preproc_directive] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3037),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_AMP_AMP] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_SEMI] = ACTIONS(3037),
    [anon_sym___extension__] = ACTIONS(3035),
    [anon_sym_typedef] = ACTIONS(3035),
    [anon_sym_virtual] = ACTIONS(3035),
    [anon_sym_extern] = ACTIONS(3035),
    [anon_sym___attribute__] = ACTIONS(3035),
    [anon_sym___attribute] = ACTIONS(3035),
    [anon_sym_using] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3037),
    [anon_sym___declspec] = ACTIONS(3035),
    [anon_sym___based] = ACTIONS(3035),
    [anon_sym_signed] = ACTIONS(3035),
    [anon_sym_unsigned] = ACTIONS(3035),
    [anon_sym_long] = ACTIONS(3035),
    [anon_sym_short] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3035),
    [anon_sym_register] = ACTIONS(3035),
    [anon_sym_inline] = ACTIONS(3035),
    [anon_sym___inline] = ACTIONS(3035),
    [anon_sym___inline__] = ACTIONS(3035),
    [anon_sym___forceinline] = ACTIONS(3035),
    [anon_sym_thread_local] = ACTIONS(3035),
    [anon_sym___thread] = ACTIONS(3035),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_constexpr] = ACTIONS(3035),
    [anon_sym_volatile] = ACTIONS(3035),
    [anon_sym_restrict] = ACTIONS(3035),
    [anon_sym___restrict__] = ACTIONS(3035),
    [anon_sym__Atomic] = ACTIONS(3035),
    [anon_sym__Noreturn] = ACTIONS(3035),
    [anon_sym_noreturn] = ACTIONS(3035),
    [anon_sym__Nonnull] = ACTIONS(3035),
    [anon_sym_mutable] = ACTIONS(3035),
    [anon_sym_constinit] = ACTIONS(3035),
    [anon_sym_consteval] = ACTIONS(3035),
    [anon_sym_alignas] = ACTIONS(3035),
    [anon_sym__Alignas] = ACTIONS(3035),
    [sym_primitive_type] = ACTIONS(3035),
    [anon_sym_enum] = ACTIONS(3035),
    [anon_sym_class] = ACTIONS(3035),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_union] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3035),
    [anon_sym_decltype] = ACTIONS(3035),
    [anon_sym_explicit] = ACTIONS(3035),
    [anon_sym_typename] = ACTIONS(3035),
    [anon_sym_private] = ACTIONS(3035),
    [anon_sym_template] = ACTIONS(3035),
    [anon_sym_operator] = ACTIONS(3035),
    [anon_sym_friend] = ACTIONS(3035),
    [anon_sym_public] = ACTIONS(3035),
    [anon_sym_protected] = ACTIONS(3035),
    [anon_sym_static_assert] = ACTIONS(3035),
  },
  [1717] = {
    [sym_identifier] = ACTIONS(3039),
    [aux_sym_preproc_def_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token2] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3039),
    [aux_sym_preproc_else_token1] = ACTIONS(3039),
    [aux_sym_preproc_elif_token1] = ACTIONS(3039),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3039),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3039),
    [sym_preproc_directive] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym___extension__] = ACTIONS(3039),
    [anon_sym_typedef] = ACTIONS(3039),
    [anon_sym_virtual] = ACTIONS(3039),
    [anon_sym_extern] = ACTIONS(3039),
    [anon_sym___attribute__] = ACTIONS(3039),
    [anon_sym___attribute] = ACTIONS(3039),
    [anon_sym_using] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3041),
    [anon_sym___declspec] = ACTIONS(3039),
    [anon_sym___based] = ACTIONS(3039),
    [anon_sym_signed] = ACTIONS(3039),
    [anon_sym_unsigned] = ACTIONS(3039),
    [anon_sym_long] = ACTIONS(3039),
    [anon_sym_short] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3039),
    [anon_sym_register] = ACTIONS(3039),
    [anon_sym_inline] = ACTIONS(3039),
    [anon_sym___inline] = ACTIONS(3039),
    [anon_sym___inline__] = ACTIONS(3039),
    [anon_sym___forceinline] = ACTIONS(3039),
    [anon_sym_thread_local] = ACTIONS(3039),
    [anon_sym___thread] = ACTIONS(3039),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_constexpr] = ACTIONS(3039),
    [anon_sym_volatile] = ACTIONS(3039),
    [anon_sym_restrict] = ACTIONS(3039),
    [anon_sym___restrict__] = ACTIONS(3039),
    [anon_sym__Atomic] = ACTIONS(3039),
    [anon_sym__Noreturn] = ACTIONS(3039),
    [anon_sym_noreturn] = ACTIONS(3039),
    [anon_sym__Nonnull] = ACTIONS(3039),
    [anon_sym_mutable] = ACTIONS(3039),
    [anon_sym_constinit] = ACTIONS(3039),
    [anon_sym_consteval] = ACTIONS(3039),
    [anon_sym_alignas] = ACTIONS(3039),
    [anon_sym__Alignas] = ACTIONS(3039),
    [sym_primitive_type] = ACTIONS(3039),
    [anon_sym_enum] = ACTIONS(3039),
    [anon_sym_class] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3039),
    [anon_sym_union] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3039),
    [anon_sym_decltype] = ACTIONS(3039),
    [anon_sym_explicit] = ACTIONS(3039),
    [anon_sym_typename] = ACTIONS(3039),
    [anon_sym_private] = ACTIONS(3039),
    [anon_sym_template] = ACTIONS(3039),
    [anon_sym_operator] = ACTIONS(3039),
    [anon_sym_friend] = ACTIONS(3039),
    [anon_sym_public] = ACTIONS(3039),
    [anon_sym_protected] = ACTIONS(3039),
    [anon_sym_static_assert] = ACTIONS(3039),
  },
  [1718] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym___attribute] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym__Nonnull] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym__Alignas] = ACTIONS(2643),
    [sym_primitive_type] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_private] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_friend] = ACTIONS(2643),
    [anon_sym_public] = ACTIONS(2643),
    [anon_sym_protected] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
  },
  [1719] = {
    [sym_identifier] = ACTIONS(5456),
    [aux_sym_preproc_def_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token2] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5456),
    [aux_sym_preproc_else_token1] = ACTIONS(5456),
    [aux_sym_preproc_elif_token1] = ACTIONS(5456),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5456),
    [sym_preproc_directive] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5458),
    [anon_sym_TILDE] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5458),
    [anon_sym___extension__] = ACTIONS(5456),
    [anon_sym_typedef] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym___attribute__] = ACTIONS(5456),
    [anon_sym___attribute] = ACTIONS(5456),
    [anon_sym_using] = ACTIONS(5456),
    [anon_sym_COLON_COLON] = ACTIONS(5458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5458),
    [anon_sym___declspec] = ACTIONS(5456),
    [anon_sym___based] = ACTIONS(5456),
    [anon_sym_signed] = ACTIONS(5456),
    [anon_sym_unsigned] = ACTIONS(5456),
    [anon_sym_long] = ACTIONS(5456),
    [anon_sym_short] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_register] = ACTIONS(5456),
    [anon_sym_inline] = ACTIONS(5456),
    [anon_sym___inline] = ACTIONS(5456),
    [anon_sym___inline__] = ACTIONS(5456),
    [anon_sym___forceinline] = ACTIONS(5456),
    [anon_sym_thread_local] = ACTIONS(5456),
    [anon_sym___thread] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_constexpr] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_restrict] = ACTIONS(5456),
    [anon_sym___restrict__] = ACTIONS(5456),
    [anon_sym__Atomic] = ACTIONS(5456),
    [anon_sym__Noreturn] = ACTIONS(5456),
    [anon_sym_noreturn] = ACTIONS(5456),
    [anon_sym__Nonnull] = ACTIONS(5456),
    [anon_sym_mutable] = ACTIONS(5456),
    [anon_sym_constinit] = ACTIONS(5456),
    [anon_sym_consteval] = ACTIONS(5456),
    [anon_sym_alignas] = ACTIONS(5456),
    [anon_sym__Alignas] = ACTIONS(5456),
    [sym_primitive_type] = ACTIONS(5456),
    [anon_sym_enum] = ACTIONS(5456),
    [anon_sym_class] = ACTIONS(5456),
    [anon_sym_struct] = ACTIONS(5456),
    [anon_sym_union] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5456),
    [anon_sym_decltype] = ACTIONS(5456),
    [anon_sym_explicit] = ACTIONS(5456),
    [anon_sym_typename] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_template] = ACTIONS(5456),
    [anon_sym_operator] = ACTIONS(5456),
    [anon_sym_friend] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_static_assert] = ACTIONS(5456),
  },
  [1720] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6232),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6835),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6835),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1721] = {
    [sym_identifier] = ACTIONS(5478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5480),
    [anon_sym_COMMA] = ACTIONS(5480),
    [anon_sym_RPAREN] = ACTIONS(5480),
    [aux_sym_preproc_if_token2] = ACTIONS(5480),
    [aux_sym_preproc_else_token1] = ACTIONS(5480),
    [aux_sym_preproc_elif_token1] = ACTIONS(5478),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5480),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5480),
    [anon_sym_LPAREN2] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5478),
    [anon_sym_PLUS] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(5478),
    [anon_sym_SLASH] = ACTIONS(5478),
    [anon_sym_PERCENT] = ACTIONS(5478),
    [anon_sym_PIPE_PIPE] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_PIPE] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5478),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym_EQ_EQ] = ACTIONS(5480),
    [anon_sym_BANG_EQ] = ACTIONS(5480),
    [anon_sym_GT] = ACTIONS(5478),
    [anon_sym_GT_EQ] = ACTIONS(5480),
    [anon_sym_LT_EQ] = ACTIONS(5478),
    [anon_sym_LT] = ACTIONS(5478),
    [anon_sym_LT_LT] = ACTIONS(5478),
    [anon_sym_GT_GT] = ACTIONS(5478),
    [anon_sym_SEMI] = ACTIONS(5480),
    [anon_sym_COLON] = ACTIONS(5480),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_LBRACK] = ACTIONS(5480),
    [anon_sym_RBRACK] = ACTIONS(5480),
    [anon_sym_EQ] = ACTIONS(5478),
    [anon_sym_QMARK] = ACTIONS(5480),
    [anon_sym_STAR_EQ] = ACTIONS(5480),
    [anon_sym_SLASH_EQ] = ACTIONS(5480),
    [anon_sym_PERCENT_EQ] = ACTIONS(5480),
    [anon_sym_PLUS_EQ] = ACTIONS(5480),
    [anon_sym_DASH_EQ] = ACTIONS(5480),
    [anon_sym_LT_LT_EQ] = ACTIONS(5480),
    [anon_sym_GT_GT_EQ] = ACTIONS(5480),
    [anon_sym_AMP_EQ] = ACTIONS(5480),
    [anon_sym_CARET_EQ] = ACTIONS(5480),
    [anon_sym_PIPE_EQ] = ACTIONS(5480),
    [anon_sym_and_eq] = ACTIONS(5478),
    [anon_sym_or_eq] = ACTIONS(5478),
    [anon_sym_xor_eq] = ACTIONS(5478),
    [anon_sym_LT_EQ_GT] = ACTIONS(5480),
    [anon_sym_or] = ACTIONS(5478),
    [anon_sym_and] = ACTIONS(5478),
    [anon_sym_bitor] = ACTIONS(5478),
    [anon_sym_xor] = ACTIONS(5478),
    [anon_sym_bitand] = ACTIONS(5478),
    [anon_sym_not_eq] = ACTIONS(5478),
    [anon_sym_DASH_DASH] = ACTIONS(5480),
    [anon_sym_PLUS_PLUS] = ACTIONS(5480),
    [anon_sym_DOT] = ACTIONS(5478),
    [anon_sym_DOT_STAR] = ACTIONS(5480),
    [anon_sym_DASH_GT] = ACTIONS(5480),
    [anon_sym_L_DQUOTE] = ACTIONS(5480),
    [anon_sym_u_DQUOTE] = ACTIONS(5480),
    [anon_sym_U_DQUOTE] = ACTIONS(5480),
    [anon_sym_u8_DQUOTE] = ACTIONS(5480),
    [anon_sym_DQUOTE] = ACTIONS(5480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5480),
    [anon_sym_LR_DQUOTE] = ACTIONS(5480),
    [anon_sym_uR_DQUOTE] = ACTIONS(5480),
    [anon_sym_UR_DQUOTE] = ACTIONS(5480),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5480),
    [sym_literal_suffix] = ACTIONS(5478),
  },
  [1722] = {
    [sym_identifier] = ACTIONS(5482),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5484),
    [anon_sym_COMMA] = ACTIONS(5484),
    [anon_sym_RPAREN] = ACTIONS(5484),
    [aux_sym_preproc_if_token2] = ACTIONS(5484),
    [aux_sym_preproc_else_token1] = ACTIONS(5484),
    [aux_sym_preproc_elif_token1] = ACTIONS(5482),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5484),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5484),
    [anon_sym_LPAREN2] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5482),
    [anon_sym_STAR] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_PIPE] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5482),
    [anon_sym_AMP] = ACTIONS(5482),
    [anon_sym_EQ_EQ] = ACTIONS(5484),
    [anon_sym_BANG_EQ] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5482),
    [anon_sym_GT_EQ] = ACTIONS(5484),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5482),
    [anon_sym_LT_LT] = ACTIONS(5482),
    [anon_sym_GT_GT] = ACTIONS(5482),
    [anon_sym_SEMI] = ACTIONS(5484),
    [anon_sym_COLON] = ACTIONS(5484),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [anon_sym_LBRACK] = ACTIONS(5484),
    [anon_sym_RBRACK] = ACTIONS(5484),
    [anon_sym_EQ] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5484),
    [anon_sym_STAR_EQ] = ACTIONS(5484),
    [anon_sym_SLASH_EQ] = ACTIONS(5484),
    [anon_sym_PERCENT_EQ] = ACTIONS(5484),
    [anon_sym_PLUS_EQ] = ACTIONS(5484),
    [anon_sym_DASH_EQ] = ACTIONS(5484),
    [anon_sym_LT_LT_EQ] = ACTIONS(5484),
    [anon_sym_GT_GT_EQ] = ACTIONS(5484),
    [anon_sym_AMP_EQ] = ACTIONS(5484),
    [anon_sym_CARET_EQ] = ACTIONS(5484),
    [anon_sym_PIPE_EQ] = ACTIONS(5484),
    [anon_sym_and_eq] = ACTIONS(5482),
    [anon_sym_or_eq] = ACTIONS(5482),
    [anon_sym_xor_eq] = ACTIONS(5482),
    [anon_sym_LT_EQ_GT] = ACTIONS(5484),
    [anon_sym_or] = ACTIONS(5482),
    [anon_sym_and] = ACTIONS(5482),
    [anon_sym_bitor] = ACTIONS(5482),
    [anon_sym_xor] = ACTIONS(5482),
    [anon_sym_bitand] = ACTIONS(5482),
    [anon_sym_not_eq] = ACTIONS(5482),
    [anon_sym_DASH_DASH] = ACTIONS(5484),
    [anon_sym_PLUS_PLUS] = ACTIONS(5484),
    [anon_sym_DOT] = ACTIONS(5482),
    [anon_sym_DOT_STAR] = ACTIONS(5484),
    [anon_sym_DASH_GT] = ACTIONS(5484),
    [anon_sym_L_DQUOTE] = ACTIONS(5484),
    [anon_sym_u_DQUOTE] = ACTIONS(5484),
    [anon_sym_U_DQUOTE] = ACTIONS(5484),
    [anon_sym_u8_DQUOTE] = ACTIONS(5484),
    [anon_sym_DQUOTE] = ACTIONS(5484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5484),
    [anon_sym_LR_DQUOTE] = ACTIONS(5484),
    [anon_sym_uR_DQUOTE] = ACTIONS(5484),
    [anon_sym_UR_DQUOTE] = ACTIONS(5484),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5484),
    [sym_literal_suffix] = ACTIONS(5482),
  },
  [1723] = {
    [sym_template_argument_list] = STATE(1856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_LPAREN2] = ACTIONS(4967),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_SLASH] = ACTIONS(4972),
    [anon_sym_PERCENT] = ACTIONS(4972),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4972),
    [anon_sym_CARET] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4974),
    [anon_sym_EQ_EQ] = ACTIONS(4965),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_GT] = ACTIONS(4972),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(5486),
    [anon_sym_LT_LT] = ACTIONS(4972),
    [anon_sym_GT_GT] = ACTIONS(4972),
    [anon_sym___extension__] = ACTIONS(4970),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(4972),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_constexpr] = ACTIONS(4970),
    [anon_sym_volatile] = ACTIONS(4970),
    [anon_sym_restrict] = ACTIONS(4970),
    [anon_sym___restrict__] = ACTIONS(4970),
    [anon_sym__Atomic] = ACTIONS(4970),
    [anon_sym__Noreturn] = ACTIONS(4970),
    [anon_sym_noreturn] = ACTIONS(4970),
    [anon_sym__Nonnull] = ACTIONS(4970),
    [anon_sym_mutable] = ACTIONS(4970),
    [anon_sym_constinit] = ACTIONS(4970),
    [anon_sym_consteval] = ACTIONS(4970),
    [anon_sym_alignas] = ACTIONS(4970),
    [anon_sym__Alignas] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_and_eq] = ACTIONS(4965),
    [anon_sym_or_eq] = ACTIONS(4965),
    [anon_sym_xor_eq] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4972),
    [anon_sym_and] = ACTIONS(4972),
    [anon_sym_bitor] = ACTIONS(4965),
    [anon_sym_xor] = ACTIONS(4972),
    [anon_sym_bitand] = ACTIONS(4965),
    [anon_sym_not_eq] = ACTIONS(4965),
    [anon_sym_DASH_DASH] = ACTIONS(4965),
    [anon_sym_PLUS_PLUS] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4972),
    [anon_sym_DOT_STAR] = ACTIONS(4965),
    [anon_sym_DASH_GT] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4970),
    [anon_sym_decltype] = ACTIONS(4970),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4965),
  },
  [1724] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token2] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [aux_sym_preproc_else_token1] = ACTIONS(3063),
    [aux_sym_preproc_elif_token1] = ACTIONS(3063),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_friend] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
  },
  [1725] = {
    [sym_identifier] = ACTIONS(5489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [aux_sym_preproc_if_token2] = ACTIONS(5491),
    [aux_sym_preproc_else_token1] = ACTIONS(5491),
    [aux_sym_preproc_elif_token1] = ACTIONS(5489),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5491),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5491),
    [anon_sym_LPAREN2] = ACTIONS(5491),
    [anon_sym_DASH] = ACTIONS(5489),
    [anon_sym_PLUS] = ACTIONS(5489),
    [anon_sym_STAR] = ACTIONS(5489),
    [anon_sym_SLASH] = ACTIONS(5489),
    [anon_sym_PERCENT] = ACTIONS(5489),
    [anon_sym_PIPE_PIPE] = ACTIONS(5491),
    [anon_sym_AMP_AMP] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_CARET] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5489),
    [anon_sym_EQ_EQ] = ACTIONS(5491),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_GT] = ACTIONS(5489),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5489),
    [anon_sym_LT] = ACTIONS(5489),
    [anon_sym_LT_LT] = ACTIONS(5489),
    [anon_sym_GT_GT] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym_COLON] = ACTIONS(5491),
    [anon_sym_RBRACE] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_RBRACK] = ACTIONS(5491),
    [anon_sym_EQ] = ACTIONS(5489),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_STAR_EQ] = ACTIONS(5491),
    [anon_sym_SLASH_EQ] = ACTIONS(5491),
    [anon_sym_PERCENT_EQ] = ACTIONS(5491),
    [anon_sym_PLUS_EQ] = ACTIONS(5491),
    [anon_sym_DASH_EQ] = ACTIONS(5491),
    [anon_sym_LT_LT_EQ] = ACTIONS(5491),
    [anon_sym_GT_GT_EQ] = ACTIONS(5491),
    [anon_sym_AMP_EQ] = ACTIONS(5491),
    [anon_sym_CARET_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_and_eq] = ACTIONS(5489),
    [anon_sym_or_eq] = ACTIONS(5489),
    [anon_sym_xor_eq] = ACTIONS(5489),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5489),
    [anon_sym_and] = ACTIONS(5489),
    [anon_sym_bitor] = ACTIONS(5489),
    [anon_sym_xor] = ACTIONS(5489),
    [anon_sym_bitand] = ACTIONS(5489),
    [anon_sym_not_eq] = ACTIONS(5489),
    [anon_sym_DASH_DASH] = ACTIONS(5491),
    [anon_sym_PLUS_PLUS] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5489),
    [anon_sym_DOT_STAR] = ACTIONS(5491),
    [anon_sym_DASH_GT] = ACTIONS(5491),
    [anon_sym_L_DQUOTE] = ACTIONS(5491),
    [anon_sym_u_DQUOTE] = ACTIONS(5491),
    [anon_sym_U_DQUOTE] = ACTIONS(5491),
    [anon_sym_u8_DQUOTE] = ACTIONS(5491),
    [anon_sym_DQUOTE] = ACTIONS(5491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5491),
    [anon_sym_LR_DQUOTE] = ACTIONS(5491),
    [anon_sym_uR_DQUOTE] = ACTIONS(5491),
    [anon_sym_UR_DQUOTE] = ACTIONS(5491),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5491),
    [sym_literal_suffix] = ACTIONS(5489),
  },
  [1726] = {
    [sym_identifier] = ACTIONS(2711),
    [aux_sym_preproc_def_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token2] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2711),
    [aux_sym_preproc_else_token1] = ACTIONS(2711),
    [aux_sym_preproc_elif_token1] = ACTIONS(2711),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2711),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2711),
    [sym_preproc_directive] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym___extension__] = ACTIONS(2711),
    [anon_sym_typedef] = ACTIONS(2711),
    [anon_sym_virtual] = ACTIONS(2711),
    [anon_sym_extern] = ACTIONS(2711),
    [anon_sym___attribute__] = ACTIONS(2711),
    [anon_sym___attribute] = ACTIONS(2711),
    [anon_sym_using] = ACTIONS(2711),
    [anon_sym_COLON_COLON] = ACTIONS(2713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2713),
    [anon_sym___declspec] = ACTIONS(2711),
    [anon_sym___based] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2711),
    [anon_sym_unsigned] = ACTIONS(2711),
    [anon_sym_long] = ACTIONS(2711),
    [anon_sym_short] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_static] = ACTIONS(2711),
    [anon_sym_register] = ACTIONS(2711),
    [anon_sym_inline] = ACTIONS(2711),
    [anon_sym___inline] = ACTIONS(2711),
    [anon_sym___inline__] = ACTIONS(2711),
    [anon_sym___forceinline] = ACTIONS(2711),
    [anon_sym_thread_local] = ACTIONS(2711),
    [anon_sym___thread] = ACTIONS(2711),
    [anon_sym_const] = ACTIONS(2711),
    [anon_sym_constexpr] = ACTIONS(2711),
    [anon_sym_volatile] = ACTIONS(2711),
    [anon_sym_restrict] = ACTIONS(2711),
    [anon_sym___restrict__] = ACTIONS(2711),
    [anon_sym__Atomic] = ACTIONS(2711),
    [anon_sym__Noreturn] = ACTIONS(2711),
    [anon_sym_noreturn] = ACTIONS(2711),
    [anon_sym__Nonnull] = ACTIONS(2711),
    [anon_sym_mutable] = ACTIONS(2711),
    [anon_sym_constinit] = ACTIONS(2711),
    [anon_sym_consteval] = ACTIONS(2711),
    [anon_sym_alignas] = ACTIONS(2711),
    [anon_sym__Alignas] = ACTIONS(2711),
    [sym_primitive_type] = ACTIONS(2711),
    [anon_sym_enum] = ACTIONS(2711),
    [anon_sym_class] = ACTIONS(2711),
    [anon_sym_struct] = ACTIONS(2711),
    [anon_sym_union] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2711),
    [anon_sym_decltype] = ACTIONS(2711),
    [anon_sym_explicit] = ACTIONS(2711),
    [anon_sym_typename] = ACTIONS(2711),
    [anon_sym_private] = ACTIONS(2711),
    [anon_sym_template] = ACTIONS(2711),
    [anon_sym_operator] = ACTIONS(2711),
    [anon_sym_friend] = ACTIONS(2711),
    [anon_sym_public] = ACTIONS(2711),
    [anon_sym_protected] = ACTIONS(2711),
    [anon_sym_static_assert] = ACTIONS(2711),
  },
  [1727] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token2] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [aux_sym_preproc_else_token1] = ACTIONS(3063),
    [aux_sym_preproc_elif_token1] = ACTIONS(3063),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_friend] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
  },
  [1728] = {
    [sym_attribute_specifier] = STATE(2264),
    [sym_field_declaration_list] = STATE(2192),
    [sym_virtual_specifier] = STATE(7024),
    [sym_base_class_clause] = STATE(7634),
    [sym_identifier] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5495),
    [anon_sym_COMMA] = ACTIONS(5495),
    [anon_sym_RPAREN] = ACTIONS(5495),
    [aux_sym_preproc_if_token2] = ACTIONS(5495),
    [aux_sym_preproc_else_token1] = ACTIONS(5495),
    [aux_sym_preproc_elif_token1] = ACTIONS(5493),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5495),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5495),
    [anon_sym_LPAREN2] = ACTIONS(5495),
    [anon_sym_DASH] = ACTIONS(5493),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_STAR] = ACTIONS(5493),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_PERCENT] = ACTIONS(5493),
    [anon_sym_PIPE_PIPE] = ACTIONS(5495),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_CARET] = ACTIONS(5493),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5495),
    [anon_sym_BANG_EQ] = ACTIONS(5495),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5495),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5493),
    [anon_sym_GT_GT] = ACTIONS(5493),
    [anon_sym_SEMI] = ACTIONS(5495),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(5499),
    [anon_sym_LBRACE] = ACTIONS(5501),
    [anon_sym_RBRACE] = ACTIONS(5495),
    [anon_sym_LBRACK] = ACTIONS(5495),
    [anon_sym_RBRACK] = ACTIONS(5495),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_QMARK] = ACTIONS(5495),
    [anon_sym_STAR_EQ] = ACTIONS(5495),
    [anon_sym_SLASH_EQ] = ACTIONS(5495),
    [anon_sym_PERCENT_EQ] = ACTIONS(5495),
    [anon_sym_PLUS_EQ] = ACTIONS(5495),
    [anon_sym_DASH_EQ] = ACTIONS(5495),
    [anon_sym_LT_LT_EQ] = ACTIONS(5495),
    [anon_sym_GT_GT_EQ] = ACTIONS(5495),
    [anon_sym_AMP_EQ] = ACTIONS(5495),
    [anon_sym_CARET_EQ] = ACTIONS(5495),
    [anon_sym_PIPE_EQ] = ACTIONS(5495),
    [anon_sym_and_eq] = ACTIONS(5493),
    [anon_sym_or_eq] = ACTIONS(5493),
    [anon_sym_xor_eq] = ACTIONS(5493),
    [anon_sym_LT_EQ_GT] = ACTIONS(5495),
    [anon_sym_or] = ACTIONS(5493),
    [anon_sym_and] = ACTIONS(5493),
    [anon_sym_bitor] = ACTIONS(5493),
    [anon_sym_xor] = ACTIONS(5493),
    [anon_sym_bitand] = ACTIONS(5493),
    [anon_sym_not_eq] = ACTIONS(5493),
    [anon_sym_DASH_DASH] = ACTIONS(5495),
    [anon_sym_PLUS_PLUS] = ACTIONS(5495),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_DOT_STAR] = ACTIONS(5495),
    [anon_sym_DASH_GT] = ACTIONS(5495),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5493),
    [anon_sym_decltype] = ACTIONS(5493),
    [anon_sym_final] = ACTIONS(5503),
    [anon_sym_override] = ACTIONS(5503),
  },
  [1729] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token2] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [aux_sym_preproc_else_token1] = ACTIONS(2915),
    [aux_sym_preproc_elif_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_private] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_friend] = ACTIONS(2915),
    [anon_sym_public] = ACTIONS(2915),
    [anon_sym_protected] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
  },
  [1730] = {
    [sym_identifier] = ACTIONS(2699),
    [aux_sym_preproc_def_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token2] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2699),
    [aux_sym_preproc_else_token1] = ACTIONS(2699),
    [aux_sym_preproc_elif_token1] = ACTIONS(2699),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2699),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2699),
    [sym_preproc_directive] = ACTIONS(2699),
    [anon_sym_LPAREN2] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_AMP_AMP] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym___extension__] = ACTIONS(2699),
    [anon_sym_typedef] = ACTIONS(2699),
    [anon_sym_virtual] = ACTIONS(2699),
    [anon_sym_extern] = ACTIONS(2699),
    [anon_sym___attribute__] = ACTIONS(2699),
    [anon_sym___attribute] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2701),
    [anon_sym___declspec] = ACTIONS(2699),
    [anon_sym___based] = ACTIONS(2699),
    [anon_sym_signed] = ACTIONS(2699),
    [anon_sym_unsigned] = ACTIONS(2699),
    [anon_sym_long] = ACTIONS(2699),
    [anon_sym_short] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_register] = ACTIONS(2699),
    [anon_sym_inline] = ACTIONS(2699),
    [anon_sym___inline] = ACTIONS(2699),
    [anon_sym___inline__] = ACTIONS(2699),
    [anon_sym___forceinline] = ACTIONS(2699),
    [anon_sym_thread_local] = ACTIONS(2699),
    [anon_sym___thread] = ACTIONS(2699),
    [anon_sym_const] = ACTIONS(2699),
    [anon_sym_constexpr] = ACTIONS(2699),
    [anon_sym_volatile] = ACTIONS(2699),
    [anon_sym_restrict] = ACTIONS(2699),
    [anon_sym___restrict__] = ACTIONS(2699),
    [anon_sym__Atomic] = ACTIONS(2699),
    [anon_sym__Noreturn] = ACTIONS(2699),
    [anon_sym_noreturn] = ACTIONS(2699),
    [anon_sym__Nonnull] = ACTIONS(2699),
    [anon_sym_mutable] = ACTIONS(2699),
    [anon_sym_constinit] = ACTIONS(2699),
    [anon_sym_consteval] = ACTIONS(2699),
    [anon_sym_alignas] = ACTIONS(2699),
    [anon_sym__Alignas] = ACTIONS(2699),
    [sym_primitive_type] = ACTIONS(2699),
    [anon_sym_enum] = ACTIONS(2699),
    [anon_sym_class] = ACTIONS(2699),
    [anon_sym_struct] = ACTIONS(2699),
    [anon_sym_union] = ACTIONS(2699),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2699),
    [anon_sym_decltype] = ACTIONS(2699),
    [anon_sym_explicit] = ACTIONS(2699),
    [anon_sym_typename] = ACTIONS(2699),
    [anon_sym_private] = ACTIONS(2699),
    [anon_sym_template] = ACTIONS(2699),
    [anon_sym_operator] = ACTIONS(2699),
    [anon_sym_friend] = ACTIONS(2699),
    [anon_sym_public] = ACTIONS(2699),
    [anon_sym_protected] = ACTIONS(2699),
    [anon_sym_static_assert] = ACTIONS(2699),
  },
  [1731] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6342),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6801),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6801),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1732] = {
    [sym_identifier] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_RPAREN] = ACTIONS(4986),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4986),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4986),
    [anon_sym_PIPE_PIPE] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4986),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4986),
    [anon_sym_BANG_EQ] = ACTIONS(4986),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4986),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4986),
    [anon_sym_GT_GT] = ACTIONS(4986),
    [anon_sym_SEMI] = ACTIONS(4986),
    [anon_sym___extension__] = ACTIONS(4984),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_COLON] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym___based] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4986),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_signed] = ACTIONS(4984),
    [anon_sym_unsigned] = ACTIONS(4984),
    [anon_sym_long] = ACTIONS(4984),
    [anon_sym_short] = ACTIONS(4984),
    [anon_sym_LBRACK] = ACTIONS(4986),
    [anon_sym_RBRACK] = ACTIONS(4986),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym___restrict__] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym__Noreturn] = ACTIONS(4984),
    [anon_sym_noreturn] = ACTIONS(4984),
    [anon_sym__Nonnull] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_constinit] = ACTIONS(4984),
    [anon_sym_consteval] = ACTIONS(4984),
    [anon_sym_alignas] = ACTIONS(4984),
    [anon_sym__Alignas] = ACTIONS(4984),
    [sym_primitive_type] = ACTIONS(4984),
    [anon_sym_QMARK] = ACTIONS(4986),
    [anon_sym_LT_EQ_GT] = ACTIONS(4986),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4986),
    [anon_sym_PLUS_PLUS] = ACTIONS(4986),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4986),
    [anon_sym_DASH_GT] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_final] = ACTIONS(4984),
    [anon_sym_override] = ACTIONS(4984),
    [anon_sym_requires] = ACTIONS(4984),
  },
  [1733] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [aux_sym_preproc_else_token1] = ACTIONS(2639),
    [aux_sym_preproc_elif_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym___attribute] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym__Nonnull] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym__Alignas] = ACTIONS(2639),
    [sym_primitive_type] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_friend] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
  },
  [1734] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6257),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6801),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6801),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1735] = {
    [sym_identifier] = ACTIONS(2955),
    [aux_sym_preproc_def_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token2] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2955),
    [aux_sym_preproc_else_token1] = ACTIONS(2955),
    [aux_sym_preproc_elif_token1] = ACTIONS(2955),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2955),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2955),
    [sym_preproc_directive] = ACTIONS(2955),
    [anon_sym_LPAREN2] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym___extension__] = ACTIONS(2955),
    [anon_sym_typedef] = ACTIONS(2955),
    [anon_sym_virtual] = ACTIONS(2955),
    [anon_sym_extern] = ACTIONS(2955),
    [anon_sym___attribute__] = ACTIONS(2955),
    [anon_sym___attribute] = ACTIONS(2955),
    [anon_sym_using] = ACTIONS(2955),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2957),
    [anon_sym___declspec] = ACTIONS(2955),
    [anon_sym___based] = ACTIONS(2955),
    [anon_sym_signed] = ACTIONS(2955),
    [anon_sym_unsigned] = ACTIONS(2955),
    [anon_sym_long] = ACTIONS(2955),
    [anon_sym_short] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_register] = ACTIONS(2955),
    [anon_sym_inline] = ACTIONS(2955),
    [anon_sym___inline] = ACTIONS(2955),
    [anon_sym___inline__] = ACTIONS(2955),
    [anon_sym___forceinline] = ACTIONS(2955),
    [anon_sym_thread_local] = ACTIONS(2955),
    [anon_sym___thread] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_constexpr] = ACTIONS(2955),
    [anon_sym_volatile] = ACTIONS(2955),
    [anon_sym_restrict] = ACTIONS(2955),
    [anon_sym___restrict__] = ACTIONS(2955),
    [anon_sym__Atomic] = ACTIONS(2955),
    [anon_sym__Noreturn] = ACTIONS(2955),
    [anon_sym_noreturn] = ACTIONS(2955),
    [anon_sym__Nonnull] = ACTIONS(2955),
    [anon_sym_mutable] = ACTIONS(2955),
    [anon_sym_constinit] = ACTIONS(2955),
    [anon_sym_consteval] = ACTIONS(2955),
    [anon_sym_alignas] = ACTIONS(2955),
    [anon_sym__Alignas] = ACTIONS(2955),
    [sym_primitive_type] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2955),
    [anon_sym_union] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2955),
    [anon_sym_decltype] = ACTIONS(2955),
    [anon_sym_explicit] = ACTIONS(2955),
    [anon_sym_typename] = ACTIONS(2955),
    [anon_sym_private] = ACTIONS(2955),
    [anon_sym_template] = ACTIONS(2955),
    [anon_sym_operator] = ACTIONS(2955),
    [anon_sym_friend] = ACTIONS(2955),
    [anon_sym_public] = ACTIONS(2955),
    [anon_sym_protected] = ACTIONS(2955),
    [anon_sym_static_assert] = ACTIONS(2955),
  },
  [1736] = {
    [sym_identifier] = ACTIONS(5505),
    [aux_sym_preproc_def_token1] = ACTIONS(5505),
    [aux_sym_preproc_if_token1] = ACTIONS(5505),
    [aux_sym_preproc_if_token2] = ACTIONS(5505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5505),
    [aux_sym_preproc_else_token1] = ACTIONS(5505),
    [aux_sym_preproc_elif_token1] = ACTIONS(5505),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5505),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5505),
    [sym_preproc_directive] = ACTIONS(5505),
    [anon_sym_LPAREN2] = ACTIONS(5507),
    [anon_sym_TILDE] = ACTIONS(5507),
    [anon_sym_STAR] = ACTIONS(5507),
    [anon_sym_AMP_AMP] = ACTIONS(5507),
    [anon_sym_AMP] = ACTIONS(5505),
    [anon_sym_SEMI] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5505),
    [anon_sym_typedef] = ACTIONS(5505),
    [anon_sym_virtual] = ACTIONS(5505),
    [anon_sym_extern] = ACTIONS(5505),
    [anon_sym___attribute__] = ACTIONS(5505),
    [anon_sym___attribute] = ACTIONS(5505),
    [anon_sym_using] = ACTIONS(5505),
    [anon_sym_COLON_COLON] = ACTIONS(5507),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5507),
    [anon_sym___declspec] = ACTIONS(5505),
    [anon_sym___based] = ACTIONS(5505),
    [anon_sym_signed] = ACTIONS(5505),
    [anon_sym_unsigned] = ACTIONS(5505),
    [anon_sym_long] = ACTIONS(5505),
    [anon_sym_short] = ACTIONS(5505),
    [anon_sym_LBRACK] = ACTIONS(5505),
    [anon_sym_static] = ACTIONS(5505),
    [anon_sym_register] = ACTIONS(5505),
    [anon_sym_inline] = ACTIONS(5505),
    [anon_sym___inline] = ACTIONS(5505),
    [anon_sym___inline__] = ACTIONS(5505),
    [anon_sym___forceinline] = ACTIONS(5505),
    [anon_sym_thread_local] = ACTIONS(5505),
    [anon_sym___thread] = ACTIONS(5505),
    [anon_sym_const] = ACTIONS(5505),
    [anon_sym_constexpr] = ACTIONS(5505),
    [anon_sym_volatile] = ACTIONS(5505),
    [anon_sym_restrict] = ACTIONS(5505),
    [anon_sym___restrict__] = ACTIONS(5505),
    [anon_sym__Atomic] = ACTIONS(5505),
    [anon_sym__Noreturn] = ACTIONS(5505),
    [anon_sym_noreturn] = ACTIONS(5505),
    [anon_sym__Nonnull] = ACTIONS(5505),
    [anon_sym_mutable] = ACTIONS(5505),
    [anon_sym_constinit] = ACTIONS(5505),
    [anon_sym_consteval] = ACTIONS(5505),
    [anon_sym_alignas] = ACTIONS(5505),
    [anon_sym__Alignas] = ACTIONS(5505),
    [sym_primitive_type] = ACTIONS(5505),
    [anon_sym_enum] = ACTIONS(5505),
    [anon_sym_class] = ACTIONS(5505),
    [anon_sym_struct] = ACTIONS(5505),
    [anon_sym_union] = ACTIONS(5505),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5505),
    [anon_sym_decltype] = ACTIONS(5505),
    [anon_sym_explicit] = ACTIONS(5505),
    [anon_sym_typename] = ACTIONS(5505),
    [anon_sym_private] = ACTIONS(5505),
    [anon_sym_template] = ACTIONS(5505),
    [anon_sym_operator] = ACTIONS(5505),
    [anon_sym_friend] = ACTIONS(5505),
    [anon_sym_public] = ACTIONS(5505),
    [anon_sym_protected] = ACTIONS(5505),
    [anon_sym_static_assert] = ACTIONS(5505),
  },
  [1737] = {
    [sym_identifier] = ACTIONS(5509),
    [aux_sym_preproc_def_token1] = ACTIONS(5509),
    [aux_sym_preproc_if_token1] = ACTIONS(5509),
    [aux_sym_preproc_if_token2] = ACTIONS(5509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5509),
    [aux_sym_preproc_else_token1] = ACTIONS(5509),
    [aux_sym_preproc_elif_token1] = ACTIONS(5509),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5509),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5509),
    [sym_preproc_directive] = ACTIONS(5509),
    [anon_sym_LPAREN2] = ACTIONS(5511),
    [anon_sym_TILDE] = ACTIONS(5511),
    [anon_sym_STAR] = ACTIONS(5511),
    [anon_sym_AMP_AMP] = ACTIONS(5511),
    [anon_sym_AMP] = ACTIONS(5509),
    [anon_sym_SEMI] = ACTIONS(5511),
    [anon_sym___extension__] = ACTIONS(5509),
    [anon_sym_typedef] = ACTIONS(5509),
    [anon_sym_virtual] = ACTIONS(5509),
    [anon_sym_extern] = ACTIONS(5509),
    [anon_sym___attribute__] = ACTIONS(5509),
    [anon_sym___attribute] = ACTIONS(5509),
    [anon_sym_using] = ACTIONS(5509),
    [anon_sym_COLON_COLON] = ACTIONS(5511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5511),
    [anon_sym___declspec] = ACTIONS(5509),
    [anon_sym___based] = ACTIONS(5509),
    [anon_sym_signed] = ACTIONS(5509),
    [anon_sym_unsigned] = ACTIONS(5509),
    [anon_sym_long] = ACTIONS(5509),
    [anon_sym_short] = ACTIONS(5509),
    [anon_sym_LBRACK] = ACTIONS(5509),
    [anon_sym_static] = ACTIONS(5509),
    [anon_sym_register] = ACTIONS(5509),
    [anon_sym_inline] = ACTIONS(5509),
    [anon_sym___inline] = ACTIONS(5509),
    [anon_sym___inline__] = ACTIONS(5509),
    [anon_sym___forceinline] = ACTIONS(5509),
    [anon_sym_thread_local] = ACTIONS(5509),
    [anon_sym___thread] = ACTIONS(5509),
    [anon_sym_const] = ACTIONS(5509),
    [anon_sym_constexpr] = ACTIONS(5509),
    [anon_sym_volatile] = ACTIONS(5509),
    [anon_sym_restrict] = ACTIONS(5509),
    [anon_sym___restrict__] = ACTIONS(5509),
    [anon_sym__Atomic] = ACTIONS(5509),
    [anon_sym__Noreturn] = ACTIONS(5509),
    [anon_sym_noreturn] = ACTIONS(5509),
    [anon_sym__Nonnull] = ACTIONS(5509),
    [anon_sym_mutable] = ACTIONS(5509),
    [anon_sym_constinit] = ACTIONS(5509),
    [anon_sym_consteval] = ACTIONS(5509),
    [anon_sym_alignas] = ACTIONS(5509),
    [anon_sym__Alignas] = ACTIONS(5509),
    [sym_primitive_type] = ACTIONS(5509),
    [anon_sym_enum] = ACTIONS(5509),
    [anon_sym_class] = ACTIONS(5509),
    [anon_sym_struct] = ACTIONS(5509),
    [anon_sym_union] = ACTIONS(5509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5509),
    [anon_sym_decltype] = ACTIONS(5509),
    [anon_sym_explicit] = ACTIONS(5509),
    [anon_sym_typename] = ACTIONS(5509),
    [anon_sym_private] = ACTIONS(5509),
    [anon_sym_template] = ACTIONS(5509),
    [anon_sym_operator] = ACTIONS(5509),
    [anon_sym_friend] = ACTIONS(5509),
    [anon_sym_public] = ACTIONS(5509),
    [anon_sym_protected] = ACTIONS(5509),
    [anon_sym_static_assert] = ACTIONS(5509),
  },
  [1738] = {
    [sym_identifier] = ACTIONS(5513),
    [aux_sym_preproc_def_token1] = ACTIONS(5513),
    [aux_sym_preproc_if_token1] = ACTIONS(5513),
    [aux_sym_preproc_if_token2] = ACTIONS(5513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5513),
    [aux_sym_preproc_else_token1] = ACTIONS(5513),
    [aux_sym_preproc_elif_token1] = ACTIONS(5513),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5513),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5513),
    [sym_preproc_directive] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(5515),
    [anon_sym_TILDE] = ACTIONS(5515),
    [anon_sym_STAR] = ACTIONS(5515),
    [anon_sym_AMP_AMP] = ACTIONS(5515),
    [anon_sym_AMP] = ACTIONS(5513),
    [anon_sym_SEMI] = ACTIONS(5515),
    [anon_sym___extension__] = ACTIONS(5513),
    [anon_sym_typedef] = ACTIONS(5513),
    [anon_sym_virtual] = ACTIONS(5513),
    [anon_sym_extern] = ACTIONS(5513),
    [anon_sym___attribute__] = ACTIONS(5513),
    [anon_sym___attribute] = ACTIONS(5513),
    [anon_sym_using] = ACTIONS(5513),
    [anon_sym_COLON_COLON] = ACTIONS(5515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5515),
    [anon_sym___declspec] = ACTIONS(5513),
    [anon_sym___based] = ACTIONS(5513),
    [anon_sym_signed] = ACTIONS(5513),
    [anon_sym_unsigned] = ACTIONS(5513),
    [anon_sym_long] = ACTIONS(5513),
    [anon_sym_short] = ACTIONS(5513),
    [anon_sym_LBRACK] = ACTIONS(5513),
    [anon_sym_static] = ACTIONS(5513),
    [anon_sym_register] = ACTIONS(5513),
    [anon_sym_inline] = ACTIONS(5513),
    [anon_sym___inline] = ACTIONS(5513),
    [anon_sym___inline__] = ACTIONS(5513),
    [anon_sym___forceinline] = ACTIONS(5513),
    [anon_sym_thread_local] = ACTIONS(5513),
    [anon_sym___thread] = ACTIONS(5513),
    [anon_sym_const] = ACTIONS(5513),
    [anon_sym_constexpr] = ACTIONS(5513),
    [anon_sym_volatile] = ACTIONS(5513),
    [anon_sym_restrict] = ACTIONS(5513),
    [anon_sym___restrict__] = ACTIONS(5513),
    [anon_sym__Atomic] = ACTIONS(5513),
    [anon_sym__Noreturn] = ACTIONS(5513),
    [anon_sym_noreturn] = ACTIONS(5513),
    [anon_sym__Nonnull] = ACTIONS(5513),
    [anon_sym_mutable] = ACTIONS(5513),
    [anon_sym_constinit] = ACTIONS(5513),
    [anon_sym_consteval] = ACTIONS(5513),
    [anon_sym_alignas] = ACTIONS(5513),
    [anon_sym__Alignas] = ACTIONS(5513),
    [sym_primitive_type] = ACTIONS(5513),
    [anon_sym_enum] = ACTIONS(5513),
    [anon_sym_class] = ACTIONS(5513),
    [anon_sym_struct] = ACTIONS(5513),
    [anon_sym_union] = ACTIONS(5513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5513),
    [anon_sym_decltype] = ACTIONS(5513),
    [anon_sym_explicit] = ACTIONS(5513),
    [anon_sym_typename] = ACTIONS(5513),
    [anon_sym_private] = ACTIONS(5513),
    [anon_sym_template] = ACTIONS(5513),
    [anon_sym_operator] = ACTIONS(5513),
    [anon_sym_friend] = ACTIONS(5513),
    [anon_sym_public] = ACTIONS(5513),
    [anon_sym_protected] = ACTIONS(5513),
    [anon_sym_static_assert] = ACTIONS(5513),
  },
  [1739] = {
    [sym_identifier] = ACTIONS(2651),
    [aux_sym_preproc_def_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token2] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2651),
    [aux_sym_preproc_else_token1] = ACTIONS(2651),
    [aux_sym_preproc_elif_token1] = ACTIONS(2651),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2651),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2651),
    [sym_preproc_directive] = ACTIONS(2651),
    [anon_sym_LPAREN2] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym___extension__] = ACTIONS(2651),
    [anon_sym_typedef] = ACTIONS(2651),
    [anon_sym_virtual] = ACTIONS(2651),
    [anon_sym_extern] = ACTIONS(2651),
    [anon_sym___attribute__] = ACTIONS(2651),
    [anon_sym___attribute] = ACTIONS(2651),
    [anon_sym_using] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2653),
    [anon_sym___declspec] = ACTIONS(2651),
    [anon_sym___based] = ACTIONS(2651),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2651),
    [anon_sym_register] = ACTIONS(2651),
    [anon_sym_inline] = ACTIONS(2651),
    [anon_sym___inline] = ACTIONS(2651),
    [anon_sym___inline__] = ACTIONS(2651),
    [anon_sym___forceinline] = ACTIONS(2651),
    [anon_sym_thread_local] = ACTIONS(2651),
    [anon_sym___thread] = ACTIONS(2651),
    [anon_sym_const] = ACTIONS(2651),
    [anon_sym_constexpr] = ACTIONS(2651),
    [anon_sym_volatile] = ACTIONS(2651),
    [anon_sym_restrict] = ACTIONS(2651),
    [anon_sym___restrict__] = ACTIONS(2651),
    [anon_sym__Atomic] = ACTIONS(2651),
    [anon_sym__Noreturn] = ACTIONS(2651),
    [anon_sym_noreturn] = ACTIONS(2651),
    [anon_sym__Nonnull] = ACTIONS(2651),
    [anon_sym_mutable] = ACTIONS(2651),
    [anon_sym_constinit] = ACTIONS(2651),
    [anon_sym_consteval] = ACTIONS(2651),
    [anon_sym_alignas] = ACTIONS(2651),
    [anon_sym__Alignas] = ACTIONS(2651),
    [sym_primitive_type] = ACTIONS(2651),
    [anon_sym_enum] = ACTIONS(2651),
    [anon_sym_class] = ACTIONS(2651),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_union] = ACTIONS(2651),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2651),
    [anon_sym_decltype] = ACTIONS(2651),
    [anon_sym_explicit] = ACTIONS(2651),
    [anon_sym_typename] = ACTIONS(2651),
    [anon_sym_private] = ACTIONS(2651),
    [anon_sym_template] = ACTIONS(2651),
    [anon_sym_operator] = ACTIONS(2651),
    [anon_sym_friend] = ACTIONS(2651),
    [anon_sym_public] = ACTIONS(2651),
    [anon_sym_protected] = ACTIONS(2651),
    [anon_sym_static_assert] = ACTIONS(2651),
  },
  [1740] = {
    [sym_identifier] = ACTIONS(3079),
    [aux_sym_preproc_def_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token2] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3079),
    [aux_sym_preproc_else_token1] = ACTIONS(3079),
    [aux_sym_preproc_elif_token1] = ACTIONS(3079),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3079),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3079),
    [sym_preproc_directive] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_AMP_AMP] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym___extension__] = ACTIONS(3079),
    [anon_sym_typedef] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym___attribute__] = ACTIONS(3079),
    [anon_sym___attribute] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3081),
    [anon_sym___declspec] = ACTIONS(3079),
    [anon_sym___based] = ACTIONS(3079),
    [anon_sym_signed] = ACTIONS(3079),
    [anon_sym_unsigned] = ACTIONS(3079),
    [anon_sym_long] = ACTIONS(3079),
    [anon_sym_short] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_register] = ACTIONS(3079),
    [anon_sym_inline] = ACTIONS(3079),
    [anon_sym___inline] = ACTIONS(3079),
    [anon_sym___inline__] = ACTIONS(3079),
    [anon_sym___forceinline] = ACTIONS(3079),
    [anon_sym_thread_local] = ACTIONS(3079),
    [anon_sym___thread] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_constexpr] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_restrict] = ACTIONS(3079),
    [anon_sym___restrict__] = ACTIONS(3079),
    [anon_sym__Atomic] = ACTIONS(3079),
    [anon_sym__Noreturn] = ACTIONS(3079),
    [anon_sym_noreturn] = ACTIONS(3079),
    [anon_sym__Nonnull] = ACTIONS(3079),
    [anon_sym_mutable] = ACTIONS(3079),
    [anon_sym_constinit] = ACTIONS(3079),
    [anon_sym_consteval] = ACTIONS(3079),
    [anon_sym_alignas] = ACTIONS(3079),
    [anon_sym__Alignas] = ACTIONS(3079),
    [sym_primitive_type] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_union] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3079),
    [anon_sym_decltype] = ACTIONS(3079),
    [anon_sym_explicit] = ACTIONS(3079),
    [anon_sym_typename] = ACTIONS(3079),
    [anon_sym_private] = ACTIONS(3079),
    [anon_sym_template] = ACTIONS(3079),
    [anon_sym_operator] = ACTIONS(3079),
    [anon_sym_friend] = ACTIONS(3079),
    [anon_sym_public] = ACTIONS(3079),
    [anon_sym_protected] = ACTIONS(3079),
    [anon_sym_static_assert] = ACTIONS(3079),
  },
  [1741] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token2] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [aux_sym_preproc_else_token1] = ACTIONS(2703),
    [aux_sym_preproc_elif_token1] = ACTIONS(2703),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_private] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_friend] = ACTIONS(2703),
    [anon_sym_public] = ACTIONS(2703),
    [anon_sym_protected] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
  },
  [1742] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6340),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6827),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6827),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1743] = {
    [sym_identifier] = ACTIONS(5517),
    [aux_sym_preproc_def_token1] = ACTIONS(5517),
    [aux_sym_preproc_if_token1] = ACTIONS(5517),
    [aux_sym_preproc_if_token2] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5517),
    [aux_sym_preproc_else_token1] = ACTIONS(5517),
    [aux_sym_preproc_elif_token1] = ACTIONS(5517),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5517),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5517),
    [sym_preproc_directive] = ACTIONS(5517),
    [anon_sym_LPAREN2] = ACTIONS(5519),
    [anon_sym_TILDE] = ACTIONS(5519),
    [anon_sym_STAR] = ACTIONS(5519),
    [anon_sym_AMP_AMP] = ACTIONS(5519),
    [anon_sym_AMP] = ACTIONS(5517),
    [anon_sym_SEMI] = ACTIONS(5519),
    [anon_sym___extension__] = ACTIONS(5517),
    [anon_sym_typedef] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5517),
    [anon_sym___attribute__] = ACTIONS(5517),
    [anon_sym___attribute] = ACTIONS(5517),
    [anon_sym_using] = ACTIONS(5517),
    [anon_sym_COLON_COLON] = ACTIONS(5519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5519),
    [anon_sym___declspec] = ACTIONS(5517),
    [anon_sym___based] = ACTIONS(5517),
    [anon_sym_signed] = ACTIONS(5517),
    [anon_sym_unsigned] = ACTIONS(5517),
    [anon_sym_long] = ACTIONS(5517),
    [anon_sym_short] = ACTIONS(5517),
    [anon_sym_LBRACK] = ACTIONS(5517),
    [anon_sym_static] = ACTIONS(5517),
    [anon_sym_register] = ACTIONS(5517),
    [anon_sym_inline] = ACTIONS(5517),
    [anon_sym___inline] = ACTIONS(5517),
    [anon_sym___inline__] = ACTIONS(5517),
    [anon_sym___forceinline] = ACTIONS(5517),
    [anon_sym_thread_local] = ACTIONS(5517),
    [anon_sym___thread] = ACTIONS(5517),
    [anon_sym_const] = ACTIONS(5517),
    [anon_sym_constexpr] = ACTIONS(5517),
    [anon_sym_volatile] = ACTIONS(5517),
    [anon_sym_restrict] = ACTIONS(5517),
    [anon_sym___restrict__] = ACTIONS(5517),
    [anon_sym__Atomic] = ACTIONS(5517),
    [anon_sym__Noreturn] = ACTIONS(5517),
    [anon_sym_noreturn] = ACTIONS(5517),
    [anon_sym__Nonnull] = ACTIONS(5517),
    [anon_sym_mutable] = ACTIONS(5517),
    [anon_sym_constinit] = ACTIONS(5517),
    [anon_sym_consteval] = ACTIONS(5517),
    [anon_sym_alignas] = ACTIONS(5517),
    [anon_sym__Alignas] = ACTIONS(5517),
    [sym_primitive_type] = ACTIONS(5517),
    [anon_sym_enum] = ACTIONS(5517),
    [anon_sym_class] = ACTIONS(5517),
    [anon_sym_struct] = ACTIONS(5517),
    [anon_sym_union] = ACTIONS(5517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5517),
    [anon_sym_decltype] = ACTIONS(5517),
    [anon_sym_explicit] = ACTIONS(5517),
    [anon_sym_typename] = ACTIONS(5517),
    [anon_sym_private] = ACTIONS(5517),
    [anon_sym_template] = ACTIONS(5517),
    [anon_sym_operator] = ACTIONS(5517),
    [anon_sym_friend] = ACTIONS(5517),
    [anon_sym_public] = ACTIONS(5517),
    [anon_sym_protected] = ACTIONS(5517),
    [anon_sym_static_assert] = ACTIONS(5517),
  },
  [1744] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6224),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6808),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6808),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1745] = {
    [sym_identifier] = ACTIONS(5517),
    [aux_sym_preproc_def_token1] = ACTIONS(5517),
    [aux_sym_preproc_if_token1] = ACTIONS(5517),
    [aux_sym_preproc_if_token2] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5517),
    [aux_sym_preproc_else_token1] = ACTIONS(5517),
    [aux_sym_preproc_elif_token1] = ACTIONS(5517),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5517),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5517),
    [sym_preproc_directive] = ACTIONS(5517),
    [anon_sym_LPAREN2] = ACTIONS(5519),
    [anon_sym_TILDE] = ACTIONS(5519),
    [anon_sym_STAR] = ACTIONS(5519),
    [anon_sym_AMP_AMP] = ACTIONS(5519),
    [anon_sym_AMP] = ACTIONS(5517),
    [anon_sym_SEMI] = ACTIONS(5519),
    [anon_sym___extension__] = ACTIONS(5517),
    [anon_sym_typedef] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5517),
    [anon_sym___attribute__] = ACTIONS(5517),
    [anon_sym___attribute] = ACTIONS(5517),
    [anon_sym_using] = ACTIONS(5517),
    [anon_sym_COLON_COLON] = ACTIONS(5519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5519),
    [anon_sym___declspec] = ACTIONS(5517),
    [anon_sym___based] = ACTIONS(5517),
    [anon_sym_signed] = ACTIONS(5517),
    [anon_sym_unsigned] = ACTIONS(5517),
    [anon_sym_long] = ACTIONS(5517),
    [anon_sym_short] = ACTIONS(5517),
    [anon_sym_LBRACK] = ACTIONS(5517),
    [anon_sym_static] = ACTIONS(5517),
    [anon_sym_register] = ACTIONS(5517),
    [anon_sym_inline] = ACTIONS(5517),
    [anon_sym___inline] = ACTIONS(5517),
    [anon_sym___inline__] = ACTIONS(5517),
    [anon_sym___forceinline] = ACTIONS(5517),
    [anon_sym_thread_local] = ACTIONS(5517),
    [anon_sym___thread] = ACTIONS(5517),
    [anon_sym_const] = ACTIONS(5517),
    [anon_sym_constexpr] = ACTIONS(5517),
    [anon_sym_volatile] = ACTIONS(5517),
    [anon_sym_restrict] = ACTIONS(5517),
    [anon_sym___restrict__] = ACTIONS(5517),
    [anon_sym__Atomic] = ACTIONS(5517),
    [anon_sym__Noreturn] = ACTIONS(5517),
    [anon_sym_noreturn] = ACTIONS(5517),
    [anon_sym__Nonnull] = ACTIONS(5517),
    [anon_sym_mutable] = ACTIONS(5517),
    [anon_sym_constinit] = ACTIONS(5517),
    [anon_sym_consteval] = ACTIONS(5517),
    [anon_sym_alignas] = ACTIONS(5517),
    [anon_sym__Alignas] = ACTIONS(5517),
    [sym_primitive_type] = ACTIONS(5517),
    [anon_sym_enum] = ACTIONS(5517),
    [anon_sym_class] = ACTIONS(5517),
    [anon_sym_struct] = ACTIONS(5517),
    [anon_sym_union] = ACTIONS(5517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5517),
    [anon_sym_decltype] = ACTIONS(5517),
    [anon_sym_explicit] = ACTIONS(5517),
    [anon_sym_typename] = ACTIONS(5517),
    [anon_sym_private] = ACTIONS(5517),
    [anon_sym_template] = ACTIONS(5517),
    [anon_sym_operator] = ACTIONS(5517),
    [anon_sym_friend] = ACTIONS(5517),
    [anon_sym_public] = ACTIONS(5517),
    [anon_sym_protected] = ACTIONS(5517),
    [anon_sym_static_assert] = ACTIONS(5517),
  },
  [1746] = {
    [sym_identifier] = ACTIONS(5521),
    [aux_sym_preproc_def_token1] = ACTIONS(5521),
    [aux_sym_preproc_if_token1] = ACTIONS(5521),
    [aux_sym_preproc_if_token2] = ACTIONS(5521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5521),
    [aux_sym_preproc_else_token1] = ACTIONS(5521),
    [aux_sym_preproc_elif_token1] = ACTIONS(5521),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5521),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5521),
    [sym_preproc_directive] = ACTIONS(5521),
    [anon_sym_LPAREN2] = ACTIONS(5523),
    [anon_sym_TILDE] = ACTIONS(5523),
    [anon_sym_STAR] = ACTIONS(5523),
    [anon_sym_AMP_AMP] = ACTIONS(5523),
    [anon_sym_AMP] = ACTIONS(5521),
    [anon_sym_SEMI] = ACTIONS(5523),
    [anon_sym___extension__] = ACTIONS(5521),
    [anon_sym_typedef] = ACTIONS(5521),
    [anon_sym_virtual] = ACTIONS(5521),
    [anon_sym_extern] = ACTIONS(5521),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_using] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5523),
    [anon_sym___declspec] = ACTIONS(5521),
    [anon_sym___based] = ACTIONS(5521),
    [anon_sym_signed] = ACTIONS(5521),
    [anon_sym_unsigned] = ACTIONS(5521),
    [anon_sym_long] = ACTIONS(5521),
    [anon_sym_short] = ACTIONS(5521),
    [anon_sym_LBRACK] = ACTIONS(5521),
    [anon_sym_static] = ACTIONS(5521),
    [anon_sym_register] = ACTIONS(5521),
    [anon_sym_inline] = ACTIONS(5521),
    [anon_sym___inline] = ACTIONS(5521),
    [anon_sym___inline__] = ACTIONS(5521),
    [anon_sym___forceinline] = ACTIONS(5521),
    [anon_sym_thread_local] = ACTIONS(5521),
    [anon_sym___thread] = ACTIONS(5521),
    [anon_sym_const] = ACTIONS(5521),
    [anon_sym_constexpr] = ACTIONS(5521),
    [anon_sym_volatile] = ACTIONS(5521),
    [anon_sym_restrict] = ACTIONS(5521),
    [anon_sym___restrict__] = ACTIONS(5521),
    [anon_sym__Atomic] = ACTIONS(5521),
    [anon_sym__Noreturn] = ACTIONS(5521),
    [anon_sym_noreturn] = ACTIONS(5521),
    [anon_sym__Nonnull] = ACTIONS(5521),
    [anon_sym_mutable] = ACTIONS(5521),
    [anon_sym_constinit] = ACTIONS(5521),
    [anon_sym_consteval] = ACTIONS(5521),
    [anon_sym_alignas] = ACTIONS(5521),
    [anon_sym__Alignas] = ACTIONS(5521),
    [sym_primitive_type] = ACTIONS(5521),
    [anon_sym_enum] = ACTIONS(5521),
    [anon_sym_class] = ACTIONS(5521),
    [anon_sym_struct] = ACTIONS(5521),
    [anon_sym_union] = ACTIONS(5521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5521),
    [anon_sym_decltype] = ACTIONS(5521),
    [anon_sym_explicit] = ACTIONS(5521),
    [anon_sym_typename] = ACTIONS(5521),
    [anon_sym_private] = ACTIONS(5521),
    [anon_sym_template] = ACTIONS(5521),
    [anon_sym_operator] = ACTIONS(5521),
    [anon_sym_friend] = ACTIONS(5521),
    [anon_sym_public] = ACTIONS(5521),
    [anon_sym_protected] = ACTIONS(5521),
    [anon_sym_static_assert] = ACTIONS(5521),
  },
  [1747] = {
    [sym_identifier] = ACTIONS(5525),
    [aux_sym_preproc_def_token1] = ACTIONS(5525),
    [aux_sym_preproc_if_token1] = ACTIONS(5525),
    [aux_sym_preproc_if_token2] = ACTIONS(5525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5525),
    [aux_sym_preproc_else_token1] = ACTIONS(5525),
    [aux_sym_preproc_elif_token1] = ACTIONS(5525),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5525),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5525),
    [sym_preproc_directive] = ACTIONS(5525),
    [anon_sym_LPAREN2] = ACTIONS(5527),
    [anon_sym_TILDE] = ACTIONS(5527),
    [anon_sym_STAR] = ACTIONS(5527),
    [anon_sym_AMP_AMP] = ACTIONS(5527),
    [anon_sym_AMP] = ACTIONS(5525),
    [anon_sym_SEMI] = ACTIONS(5527),
    [anon_sym___extension__] = ACTIONS(5525),
    [anon_sym_typedef] = ACTIONS(5525),
    [anon_sym_virtual] = ACTIONS(5525),
    [anon_sym_extern] = ACTIONS(5525),
    [anon_sym___attribute__] = ACTIONS(5525),
    [anon_sym___attribute] = ACTIONS(5525),
    [anon_sym_using] = ACTIONS(5525),
    [anon_sym_COLON_COLON] = ACTIONS(5527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5527),
    [anon_sym___declspec] = ACTIONS(5525),
    [anon_sym___based] = ACTIONS(5525),
    [anon_sym_signed] = ACTIONS(5525),
    [anon_sym_unsigned] = ACTIONS(5525),
    [anon_sym_long] = ACTIONS(5525),
    [anon_sym_short] = ACTIONS(5525),
    [anon_sym_LBRACK] = ACTIONS(5525),
    [anon_sym_static] = ACTIONS(5525),
    [anon_sym_register] = ACTIONS(5525),
    [anon_sym_inline] = ACTIONS(5525),
    [anon_sym___inline] = ACTIONS(5525),
    [anon_sym___inline__] = ACTIONS(5525),
    [anon_sym___forceinline] = ACTIONS(5525),
    [anon_sym_thread_local] = ACTIONS(5525),
    [anon_sym___thread] = ACTIONS(5525),
    [anon_sym_const] = ACTIONS(5525),
    [anon_sym_constexpr] = ACTIONS(5525),
    [anon_sym_volatile] = ACTIONS(5525),
    [anon_sym_restrict] = ACTIONS(5525),
    [anon_sym___restrict__] = ACTIONS(5525),
    [anon_sym__Atomic] = ACTIONS(5525),
    [anon_sym__Noreturn] = ACTIONS(5525),
    [anon_sym_noreturn] = ACTIONS(5525),
    [anon_sym__Nonnull] = ACTIONS(5525),
    [anon_sym_mutable] = ACTIONS(5525),
    [anon_sym_constinit] = ACTIONS(5525),
    [anon_sym_consteval] = ACTIONS(5525),
    [anon_sym_alignas] = ACTIONS(5525),
    [anon_sym__Alignas] = ACTIONS(5525),
    [sym_primitive_type] = ACTIONS(5525),
    [anon_sym_enum] = ACTIONS(5525),
    [anon_sym_class] = ACTIONS(5525),
    [anon_sym_struct] = ACTIONS(5525),
    [anon_sym_union] = ACTIONS(5525),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5525),
    [anon_sym_decltype] = ACTIONS(5525),
    [anon_sym_explicit] = ACTIONS(5525),
    [anon_sym_typename] = ACTIONS(5525),
    [anon_sym_private] = ACTIONS(5525),
    [anon_sym_template] = ACTIONS(5525),
    [anon_sym_operator] = ACTIONS(5525),
    [anon_sym_friend] = ACTIONS(5525),
    [anon_sym_public] = ACTIONS(5525),
    [anon_sym_protected] = ACTIONS(5525),
    [anon_sym_static_assert] = ACTIONS(5525),
  },
  [1748] = {
    [sym_identifier] = ACTIONS(3093),
    [aux_sym_preproc_def_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token2] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3093),
    [aux_sym_preproc_else_token1] = ACTIONS(3093),
    [aux_sym_preproc_elif_token1] = ACTIONS(3093),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3093),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3093),
    [sym_preproc_directive] = ACTIONS(3093),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym___extension__] = ACTIONS(3093),
    [anon_sym_typedef] = ACTIONS(3093),
    [anon_sym_virtual] = ACTIONS(3093),
    [anon_sym_extern] = ACTIONS(3093),
    [anon_sym___attribute__] = ACTIONS(3093),
    [anon_sym___attribute] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_COLON_COLON] = ACTIONS(3095),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3095),
    [anon_sym___declspec] = ACTIONS(3093),
    [anon_sym___based] = ACTIONS(3093),
    [anon_sym_signed] = ACTIONS(3093),
    [anon_sym_unsigned] = ACTIONS(3093),
    [anon_sym_long] = ACTIONS(3093),
    [anon_sym_short] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3093),
    [anon_sym_register] = ACTIONS(3093),
    [anon_sym_inline] = ACTIONS(3093),
    [anon_sym___inline] = ACTIONS(3093),
    [anon_sym___inline__] = ACTIONS(3093),
    [anon_sym___forceinline] = ACTIONS(3093),
    [anon_sym_thread_local] = ACTIONS(3093),
    [anon_sym___thread] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_constexpr] = ACTIONS(3093),
    [anon_sym_volatile] = ACTIONS(3093),
    [anon_sym_restrict] = ACTIONS(3093),
    [anon_sym___restrict__] = ACTIONS(3093),
    [anon_sym__Atomic] = ACTIONS(3093),
    [anon_sym__Noreturn] = ACTIONS(3093),
    [anon_sym_noreturn] = ACTIONS(3093),
    [anon_sym__Nonnull] = ACTIONS(3093),
    [anon_sym_mutable] = ACTIONS(3093),
    [anon_sym_constinit] = ACTIONS(3093),
    [anon_sym_consteval] = ACTIONS(3093),
    [anon_sym_alignas] = ACTIONS(3093),
    [anon_sym__Alignas] = ACTIONS(3093),
    [sym_primitive_type] = ACTIONS(3093),
    [anon_sym_enum] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_union] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3093),
    [anon_sym_decltype] = ACTIONS(3093),
    [anon_sym_explicit] = ACTIONS(3093),
    [anon_sym_typename] = ACTIONS(3093),
    [anon_sym_private] = ACTIONS(3093),
    [anon_sym_template] = ACTIONS(3093),
    [anon_sym_operator] = ACTIONS(3093),
    [anon_sym_friend] = ACTIONS(3093),
    [anon_sym_public] = ACTIONS(3093),
    [anon_sym_protected] = ACTIONS(3093),
    [anon_sym_static_assert] = ACTIONS(3093),
  },
  [1749] = {
    [sym_identifier] = ACTIONS(3319),
    [aux_sym_preproc_def_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token2] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3319),
    [aux_sym_preproc_else_token1] = ACTIONS(3319),
    [aux_sym_preproc_elif_token1] = ACTIONS(3319),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3319),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3319),
    [sym_preproc_directive] = ACTIONS(3319),
    [anon_sym_LPAREN2] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym___extension__] = ACTIONS(3319),
    [anon_sym_typedef] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym___attribute__] = ACTIONS(3319),
    [anon_sym___attribute] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_COLON_COLON] = ACTIONS(3321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3321),
    [anon_sym___declspec] = ACTIONS(3319),
    [anon_sym___based] = ACTIONS(3319),
    [anon_sym_signed] = ACTIONS(3319),
    [anon_sym_unsigned] = ACTIONS(3319),
    [anon_sym_long] = ACTIONS(3319),
    [anon_sym_short] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_register] = ACTIONS(3319),
    [anon_sym_inline] = ACTIONS(3319),
    [anon_sym___inline] = ACTIONS(3319),
    [anon_sym___inline__] = ACTIONS(3319),
    [anon_sym___forceinline] = ACTIONS(3319),
    [anon_sym_thread_local] = ACTIONS(3319),
    [anon_sym___thread] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_constexpr] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_restrict] = ACTIONS(3319),
    [anon_sym___restrict__] = ACTIONS(3319),
    [anon_sym__Atomic] = ACTIONS(3319),
    [anon_sym__Noreturn] = ACTIONS(3319),
    [anon_sym_noreturn] = ACTIONS(3319),
    [anon_sym__Nonnull] = ACTIONS(3319),
    [anon_sym_mutable] = ACTIONS(3319),
    [anon_sym_constinit] = ACTIONS(3319),
    [anon_sym_consteval] = ACTIONS(3319),
    [anon_sym_alignas] = ACTIONS(3319),
    [anon_sym__Alignas] = ACTIONS(3319),
    [sym_primitive_type] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_union] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3319),
    [anon_sym_decltype] = ACTIONS(3319),
    [anon_sym_explicit] = ACTIONS(3319),
    [anon_sym_typename] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_template] = ACTIONS(3319),
    [anon_sym_operator] = ACTIONS(3319),
    [anon_sym_friend] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_static_assert] = ACTIONS(3319),
  },
  [1750] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token2] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [aux_sym_preproc_else_token1] = ACTIONS(3104),
    [aux_sym_preproc_elif_token1] = ACTIONS(3104),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_private] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_friend] = ACTIONS(3104),
    [anon_sym_public] = ACTIONS(3104),
    [anon_sym_protected] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
  },
  [1751] = {
    [sym_identifier] = ACTIONS(5529),
    [aux_sym_preproc_def_token1] = ACTIONS(5529),
    [aux_sym_preproc_if_token1] = ACTIONS(5529),
    [aux_sym_preproc_if_token2] = ACTIONS(5529),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5529),
    [aux_sym_preproc_else_token1] = ACTIONS(5529),
    [aux_sym_preproc_elif_token1] = ACTIONS(5529),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5529),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5529),
    [sym_preproc_directive] = ACTIONS(5529),
    [anon_sym_LPAREN2] = ACTIONS(5531),
    [anon_sym_TILDE] = ACTIONS(5531),
    [anon_sym_STAR] = ACTIONS(5531),
    [anon_sym_AMP_AMP] = ACTIONS(5531),
    [anon_sym_AMP] = ACTIONS(5529),
    [anon_sym_SEMI] = ACTIONS(5531),
    [anon_sym___extension__] = ACTIONS(5529),
    [anon_sym_typedef] = ACTIONS(5529),
    [anon_sym_virtual] = ACTIONS(5529),
    [anon_sym_extern] = ACTIONS(5529),
    [anon_sym___attribute__] = ACTIONS(5529),
    [anon_sym___attribute] = ACTIONS(5529),
    [anon_sym_using] = ACTIONS(5529),
    [anon_sym_COLON_COLON] = ACTIONS(5531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5531),
    [anon_sym___declspec] = ACTIONS(5529),
    [anon_sym___based] = ACTIONS(5529),
    [anon_sym_signed] = ACTIONS(5529),
    [anon_sym_unsigned] = ACTIONS(5529),
    [anon_sym_long] = ACTIONS(5529),
    [anon_sym_short] = ACTIONS(5529),
    [anon_sym_LBRACK] = ACTIONS(5529),
    [anon_sym_static] = ACTIONS(5529),
    [anon_sym_register] = ACTIONS(5529),
    [anon_sym_inline] = ACTIONS(5529),
    [anon_sym___inline] = ACTIONS(5529),
    [anon_sym___inline__] = ACTIONS(5529),
    [anon_sym___forceinline] = ACTIONS(5529),
    [anon_sym_thread_local] = ACTIONS(5529),
    [anon_sym___thread] = ACTIONS(5529),
    [anon_sym_const] = ACTIONS(5529),
    [anon_sym_constexpr] = ACTIONS(5529),
    [anon_sym_volatile] = ACTIONS(5529),
    [anon_sym_restrict] = ACTIONS(5529),
    [anon_sym___restrict__] = ACTIONS(5529),
    [anon_sym__Atomic] = ACTIONS(5529),
    [anon_sym__Noreturn] = ACTIONS(5529),
    [anon_sym_noreturn] = ACTIONS(5529),
    [anon_sym__Nonnull] = ACTIONS(5529),
    [anon_sym_mutable] = ACTIONS(5529),
    [anon_sym_constinit] = ACTIONS(5529),
    [anon_sym_consteval] = ACTIONS(5529),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_primitive_type] = ACTIONS(5529),
    [anon_sym_enum] = ACTIONS(5529),
    [anon_sym_class] = ACTIONS(5529),
    [anon_sym_struct] = ACTIONS(5529),
    [anon_sym_union] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5529),
    [anon_sym_decltype] = ACTIONS(5529),
    [anon_sym_explicit] = ACTIONS(5529),
    [anon_sym_typename] = ACTIONS(5529),
    [anon_sym_private] = ACTIONS(5529),
    [anon_sym_template] = ACTIONS(5529),
    [anon_sym_operator] = ACTIONS(5529),
    [anon_sym_friend] = ACTIONS(5529),
    [anon_sym_public] = ACTIONS(5529),
    [anon_sym_protected] = ACTIONS(5529),
    [anon_sym_static_assert] = ACTIONS(5529),
  },
  [1752] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6247),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6827),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6827),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1753] = {
    [sym_identifier] = ACTIONS(5533),
    [aux_sym_preproc_def_token1] = ACTIONS(5533),
    [aux_sym_preproc_if_token1] = ACTIONS(5533),
    [aux_sym_preproc_if_token2] = ACTIONS(5533),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5533),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5533),
    [aux_sym_preproc_else_token1] = ACTIONS(5533),
    [aux_sym_preproc_elif_token1] = ACTIONS(5533),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5533),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5533),
    [sym_preproc_directive] = ACTIONS(5533),
    [anon_sym_LPAREN2] = ACTIONS(5535),
    [anon_sym_TILDE] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5535),
    [anon_sym_AMP_AMP] = ACTIONS(5535),
    [anon_sym_AMP] = ACTIONS(5533),
    [anon_sym_SEMI] = ACTIONS(5535),
    [anon_sym___extension__] = ACTIONS(5533),
    [anon_sym_typedef] = ACTIONS(5533),
    [anon_sym_virtual] = ACTIONS(5533),
    [anon_sym_extern] = ACTIONS(5533),
    [anon_sym___attribute__] = ACTIONS(5533),
    [anon_sym___attribute] = ACTIONS(5533),
    [anon_sym_using] = ACTIONS(5533),
    [anon_sym_COLON_COLON] = ACTIONS(5535),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5535),
    [anon_sym___declspec] = ACTIONS(5533),
    [anon_sym___based] = ACTIONS(5533),
    [anon_sym_signed] = ACTIONS(5533),
    [anon_sym_unsigned] = ACTIONS(5533),
    [anon_sym_long] = ACTIONS(5533),
    [anon_sym_short] = ACTIONS(5533),
    [anon_sym_LBRACK] = ACTIONS(5533),
    [anon_sym_static] = ACTIONS(5533),
    [anon_sym_register] = ACTIONS(5533),
    [anon_sym_inline] = ACTIONS(5533),
    [anon_sym___inline] = ACTIONS(5533),
    [anon_sym___inline__] = ACTIONS(5533),
    [anon_sym___forceinline] = ACTIONS(5533),
    [anon_sym_thread_local] = ACTIONS(5533),
    [anon_sym___thread] = ACTIONS(5533),
    [anon_sym_const] = ACTIONS(5533),
    [anon_sym_constexpr] = ACTIONS(5533),
    [anon_sym_volatile] = ACTIONS(5533),
    [anon_sym_restrict] = ACTIONS(5533),
    [anon_sym___restrict__] = ACTIONS(5533),
    [anon_sym__Atomic] = ACTIONS(5533),
    [anon_sym__Noreturn] = ACTIONS(5533),
    [anon_sym_noreturn] = ACTIONS(5533),
    [anon_sym__Nonnull] = ACTIONS(5533),
    [anon_sym_mutable] = ACTIONS(5533),
    [anon_sym_constinit] = ACTIONS(5533),
    [anon_sym_consteval] = ACTIONS(5533),
    [anon_sym_alignas] = ACTIONS(5533),
    [anon_sym__Alignas] = ACTIONS(5533),
    [sym_primitive_type] = ACTIONS(5533),
    [anon_sym_enum] = ACTIONS(5533),
    [anon_sym_class] = ACTIONS(5533),
    [anon_sym_struct] = ACTIONS(5533),
    [anon_sym_union] = ACTIONS(5533),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5533),
    [anon_sym_decltype] = ACTIONS(5533),
    [anon_sym_explicit] = ACTIONS(5533),
    [anon_sym_typename] = ACTIONS(5533),
    [anon_sym_private] = ACTIONS(5533),
    [anon_sym_template] = ACTIONS(5533),
    [anon_sym_operator] = ACTIONS(5533),
    [anon_sym_friend] = ACTIONS(5533),
    [anon_sym_public] = ACTIONS(5533),
    [anon_sym_protected] = ACTIONS(5533),
    [anon_sym_static_assert] = ACTIONS(5533),
  },
  [1754] = {
    [sym_identifier] = ACTIONS(5537),
    [aux_sym_preproc_def_token1] = ACTIONS(5537),
    [aux_sym_preproc_if_token1] = ACTIONS(5537),
    [aux_sym_preproc_if_token2] = ACTIONS(5537),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5537),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5537),
    [aux_sym_preproc_else_token1] = ACTIONS(5537),
    [aux_sym_preproc_elif_token1] = ACTIONS(5537),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5537),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5537),
    [sym_preproc_directive] = ACTIONS(5537),
    [anon_sym_LPAREN2] = ACTIONS(5539),
    [anon_sym_TILDE] = ACTIONS(5539),
    [anon_sym_STAR] = ACTIONS(5539),
    [anon_sym_AMP_AMP] = ACTIONS(5539),
    [anon_sym_AMP] = ACTIONS(5537),
    [anon_sym_SEMI] = ACTIONS(5539),
    [anon_sym___extension__] = ACTIONS(5537),
    [anon_sym_typedef] = ACTIONS(5537),
    [anon_sym_virtual] = ACTIONS(5537),
    [anon_sym_extern] = ACTIONS(5537),
    [anon_sym___attribute__] = ACTIONS(5537),
    [anon_sym___attribute] = ACTIONS(5537),
    [anon_sym_using] = ACTIONS(5537),
    [anon_sym_COLON_COLON] = ACTIONS(5539),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5539),
    [anon_sym___declspec] = ACTIONS(5537),
    [anon_sym___based] = ACTIONS(5537),
    [anon_sym_signed] = ACTIONS(5537),
    [anon_sym_unsigned] = ACTIONS(5537),
    [anon_sym_long] = ACTIONS(5537),
    [anon_sym_short] = ACTIONS(5537),
    [anon_sym_LBRACK] = ACTIONS(5537),
    [anon_sym_static] = ACTIONS(5537),
    [anon_sym_register] = ACTIONS(5537),
    [anon_sym_inline] = ACTIONS(5537),
    [anon_sym___inline] = ACTIONS(5537),
    [anon_sym___inline__] = ACTIONS(5537),
    [anon_sym___forceinline] = ACTIONS(5537),
    [anon_sym_thread_local] = ACTIONS(5537),
    [anon_sym___thread] = ACTIONS(5537),
    [anon_sym_const] = ACTIONS(5537),
    [anon_sym_constexpr] = ACTIONS(5537),
    [anon_sym_volatile] = ACTIONS(5537),
    [anon_sym_restrict] = ACTIONS(5537),
    [anon_sym___restrict__] = ACTIONS(5537),
    [anon_sym__Atomic] = ACTIONS(5537),
    [anon_sym__Noreturn] = ACTIONS(5537),
    [anon_sym_noreturn] = ACTIONS(5537),
    [anon_sym__Nonnull] = ACTIONS(5537),
    [anon_sym_mutable] = ACTIONS(5537),
    [anon_sym_constinit] = ACTIONS(5537),
    [anon_sym_consteval] = ACTIONS(5537),
    [anon_sym_alignas] = ACTIONS(5537),
    [anon_sym__Alignas] = ACTIONS(5537),
    [sym_primitive_type] = ACTIONS(5537),
    [anon_sym_enum] = ACTIONS(5537),
    [anon_sym_class] = ACTIONS(5537),
    [anon_sym_struct] = ACTIONS(5537),
    [anon_sym_union] = ACTIONS(5537),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5537),
    [anon_sym_decltype] = ACTIONS(5537),
    [anon_sym_explicit] = ACTIONS(5537),
    [anon_sym_typename] = ACTIONS(5537),
    [anon_sym_private] = ACTIONS(5537),
    [anon_sym_template] = ACTIONS(5537),
    [anon_sym_operator] = ACTIONS(5537),
    [anon_sym_friend] = ACTIONS(5537),
    [anon_sym_public] = ACTIONS(5537),
    [anon_sym_protected] = ACTIONS(5537),
    [anon_sym_static_assert] = ACTIONS(5537),
  },
  [1755] = {
    [sym_identifier] = ACTIONS(5541),
    [aux_sym_preproc_def_token1] = ACTIONS(5541),
    [aux_sym_preproc_if_token1] = ACTIONS(5541),
    [aux_sym_preproc_if_token2] = ACTIONS(5541),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5541),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5541),
    [aux_sym_preproc_else_token1] = ACTIONS(5541),
    [aux_sym_preproc_elif_token1] = ACTIONS(5541),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5541),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5541),
    [sym_preproc_directive] = ACTIONS(5541),
    [anon_sym_LPAREN2] = ACTIONS(5543),
    [anon_sym_TILDE] = ACTIONS(5543),
    [anon_sym_STAR] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5543),
    [anon_sym___extension__] = ACTIONS(5541),
    [anon_sym_typedef] = ACTIONS(5541),
    [anon_sym_virtual] = ACTIONS(5541),
    [anon_sym_extern] = ACTIONS(5541),
    [anon_sym___attribute__] = ACTIONS(5541),
    [anon_sym___attribute] = ACTIONS(5541),
    [anon_sym_using] = ACTIONS(5541),
    [anon_sym_COLON_COLON] = ACTIONS(5543),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5543),
    [anon_sym___declspec] = ACTIONS(5541),
    [anon_sym___based] = ACTIONS(5541),
    [anon_sym_signed] = ACTIONS(5541),
    [anon_sym_unsigned] = ACTIONS(5541),
    [anon_sym_long] = ACTIONS(5541),
    [anon_sym_short] = ACTIONS(5541),
    [anon_sym_LBRACK] = ACTIONS(5541),
    [anon_sym_static] = ACTIONS(5541),
    [anon_sym_register] = ACTIONS(5541),
    [anon_sym_inline] = ACTIONS(5541),
    [anon_sym___inline] = ACTIONS(5541),
    [anon_sym___inline__] = ACTIONS(5541),
    [anon_sym___forceinline] = ACTIONS(5541),
    [anon_sym_thread_local] = ACTIONS(5541),
    [anon_sym___thread] = ACTIONS(5541),
    [anon_sym_const] = ACTIONS(5541),
    [anon_sym_constexpr] = ACTIONS(5541),
    [anon_sym_volatile] = ACTIONS(5541),
    [anon_sym_restrict] = ACTIONS(5541),
    [anon_sym___restrict__] = ACTIONS(5541),
    [anon_sym__Atomic] = ACTIONS(5541),
    [anon_sym__Noreturn] = ACTIONS(5541),
    [anon_sym_noreturn] = ACTIONS(5541),
    [anon_sym__Nonnull] = ACTIONS(5541),
    [anon_sym_mutable] = ACTIONS(5541),
    [anon_sym_constinit] = ACTIONS(5541),
    [anon_sym_consteval] = ACTIONS(5541),
    [anon_sym_alignas] = ACTIONS(5541),
    [anon_sym__Alignas] = ACTIONS(5541),
    [sym_primitive_type] = ACTIONS(5541),
    [anon_sym_enum] = ACTIONS(5541),
    [anon_sym_class] = ACTIONS(5541),
    [anon_sym_struct] = ACTIONS(5541),
    [anon_sym_union] = ACTIONS(5541),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5541),
    [anon_sym_decltype] = ACTIONS(5541),
    [anon_sym_explicit] = ACTIONS(5541),
    [anon_sym_typename] = ACTIONS(5541),
    [anon_sym_private] = ACTIONS(5541),
    [anon_sym_template] = ACTIONS(5541),
    [anon_sym_operator] = ACTIONS(5541),
    [anon_sym_friend] = ACTIONS(5541),
    [anon_sym_public] = ACTIONS(5541),
    [anon_sym_protected] = ACTIONS(5541),
    [anon_sym_static_assert] = ACTIONS(5541),
  },
  [1756] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token2] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [aux_sym_preproc_else_token1] = ACTIONS(2703),
    [aux_sym_preproc_elif_token1] = ACTIONS(2703),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_private] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_friend] = ACTIONS(2703),
    [anon_sym_public] = ACTIONS(2703),
    [anon_sym_protected] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
  },
  [1757] = {
    [sym_identifier] = ACTIONS(4980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_RPAREN] = ACTIONS(4982),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_DASH] = ACTIONS(4980),
    [anon_sym_PLUS] = ACTIONS(4980),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_SLASH] = ACTIONS(4980),
    [anon_sym_PERCENT] = ACTIONS(4982),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(4980),
    [anon_sym_CARET] = ACTIONS(4982),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4982),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_LT_LT] = ACTIONS(4982),
    [anon_sym_GT_GT] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(4982),
    [anon_sym___extension__] = ACTIONS(4980),
    [anon_sym___attribute__] = ACTIONS(4980),
    [anon_sym___attribute] = ACTIONS(4980),
    [anon_sym_COLON] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym___based] = ACTIONS(4980),
    [anon_sym_LBRACE] = ACTIONS(4982),
    [anon_sym_RBRACE] = ACTIONS(4982),
    [anon_sym_signed] = ACTIONS(4980),
    [anon_sym_unsigned] = ACTIONS(4980),
    [anon_sym_long] = ACTIONS(4980),
    [anon_sym_short] = ACTIONS(4980),
    [anon_sym_LBRACK] = ACTIONS(4982),
    [anon_sym_RBRACK] = ACTIONS(4982),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4980),
    [anon_sym_volatile] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4980),
    [anon_sym___restrict__] = ACTIONS(4980),
    [anon_sym__Atomic] = ACTIONS(4980),
    [anon_sym__Noreturn] = ACTIONS(4980),
    [anon_sym_noreturn] = ACTIONS(4980),
    [anon_sym__Nonnull] = ACTIONS(4980),
    [anon_sym_mutable] = ACTIONS(4980),
    [anon_sym_constinit] = ACTIONS(4980),
    [anon_sym_consteval] = ACTIONS(4980),
    [anon_sym_alignas] = ACTIONS(4980),
    [anon_sym__Alignas] = ACTIONS(4980),
    [sym_primitive_type] = ACTIONS(4980),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_LT_EQ_GT] = ACTIONS(4982),
    [anon_sym_or] = ACTIONS(4980),
    [anon_sym_and] = ACTIONS(4980),
    [anon_sym_bitor] = ACTIONS(4980),
    [anon_sym_xor] = ACTIONS(4980),
    [anon_sym_bitand] = ACTIONS(4980),
    [anon_sym_not_eq] = ACTIONS(4980),
    [anon_sym_DASH_DASH] = ACTIONS(4982),
    [anon_sym_PLUS_PLUS] = ACTIONS(4982),
    [anon_sym_DOT] = ACTIONS(4980),
    [anon_sym_DOT_STAR] = ACTIONS(4982),
    [anon_sym_DASH_GT] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4980),
    [anon_sym_decltype] = ACTIONS(4980),
    [anon_sym_final] = ACTIONS(4980),
    [anon_sym_override] = ACTIONS(4980),
    [anon_sym_requires] = ACTIONS(4980),
  },
  [1758] = {
    [sym_identifier] = ACTIONS(5545),
    [aux_sym_preproc_def_token1] = ACTIONS(5545),
    [aux_sym_preproc_if_token1] = ACTIONS(5545),
    [aux_sym_preproc_if_token2] = ACTIONS(5545),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5545),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5545),
    [aux_sym_preproc_else_token1] = ACTIONS(5545),
    [aux_sym_preproc_elif_token1] = ACTIONS(5545),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5545),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5545),
    [sym_preproc_directive] = ACTIONS(5545),
    [anon_sym_LPAREN2] = ACTIONS(5547),
    [anon_sym_TILDE] = ACTIONS(5547),
    [anon_sym_STAR] = ACTIONS(5547),
    [anon_sym_AMP_AMP] = ACTIONS(5547),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_SEMI] = ACTIONS(5547),
    [anon_sym___extension__] = ACTIONS(5545),
    [anon_sym_typedef] = ACTIONS(5545),
    [anon_sym_virtual] = ACTIONS(5545),
    [anon_sym_extern] = ACTIONS(5545),
    [anon_sym___attribute__] = ACTIONS(5545),
    [anon_sym___attribute] = ACTIONS(5545),
    [anon_sym_using] = ACTIONS(5545),
    [anon_sym_COLON_COLON] = ACTIONS(5547),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5547),
    [anon_sym___declspec] = ACTIONS(5545),
    [anon_sym___based] = ACTIONS(5545),
    [anon_sym_signed] = ACTIONS(5545),
    [anon_sym_unsigned] = ACTIONS(5545),
    [anon_sym_long] = ACTIONS(5545),
    [anon_sym_short] = ACTIONS(5545),
    [anon_sym_LBRACK] = ACTIONS(5545),
    [anon_sym_static] = ACTIONS(5545),
    [anon_sym_register] = ACTIONS(5545),
    [anon_sym_inline] = ACTIONS(5545),
    [anon_sym___inline] = ACTIONS(5545),
    [anon_sym___inline__] = ACTIONS(5545),
    [anon_sym___forceinline] = ACTIONS(5545),
    [anon_sym_thread_local] = ACTIONS(5545),
    [anon_sym___thread] = ACTIONS(5545),
    [anon_sym_const] = ACTIONS(5545),
    [anon_sym_constexpr] = ACTIONS(5545),
    [anon_sym_volatile] = ACTIONS(5545),
    [anon_sym_restrict] = ACTIONS(5545),
    [anon_sym___restrict__] = ACTIONS(5545),
    [anon_sym__Atomic] = ACTIONS(5545),
    [anon_sym__Noreturn] = ACTIONS(5545),
    [anon_sym_noreturn] = ACTIONS(5545),
    [anon_sym__Nonnull] = ACTIONS(5545),
    [anon_sym_mutable] = ACTIONS(5545),
    [anon_sym_constinit] = ACTIONS(5545),
    [anon_sym_consteval] = ACTIONS(5545),
    [anon_sym_alignas] = ACTIONS(5545),
    [anon_sym__Alignas] = ACTIONS(5545),
    [sym_primitive_type] = ACTIONS(5545),
    [anon_sym_enum] = ACTIONS(5545),
    [anon_sym_class] = ACTIONS(5545),
    [anon_sym_struct] = ACTIONS(5545),
    [anon_sym_union] = ACTIONS(5545),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5545),
    [anon_sym_decltype] = ACTIONS(5545),
    [anon_sym_explicit] = ACTIONS(5545),
    [anon_sym_typename] = ACTIONS(5545),
    [anon_sym_private] = ACTIONS(5545),
    [anon_sym_template] = ACTIONS(5545),
    [anon_sym_operator] = ACTIONS(5545),
    [anon_sym_friend] = ACTIONS(5545),
    [anon_sym_public] = ACTIONS(5545),
    [anon_sym_protected] = ACTIONS(5545),
    [anon_sym_static_assert] = ACTIONS(5545),
  },
  [1759] = {
    [sym_identifier] = ACTIONS(5549),
    [aux_sym_preproc_def_token1] = ACTIONS(5549),
    [aux_sym_preproc_if_token1] = ACTIONS(5549),
    [aux_sym_preproc_if_token2] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5549),
    [aux_sym_preproc_else_token1] = ACTIONS(5549),
    [aux_sym_preproc_elif_token1] = ACTIONS(5549),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5549),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5549),
    [sym_preproc_directive] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(5551),
    [anon_sym_TILDE] = ACTIONS(5551),
    [anon_sym_STAR] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5549),
    [anon_sym_SEMI] = ACTIONS(5551),
    [anon_sym___extension__] = ACTIONS(5549),
    [anon_sym_typedef] = ACTIONS(5549),
    [anon_sym_virtual] = ACTIONS(5549),
    [anon_sym_extern] = ACTIONS(5549),
    [anon_sym___attribute__] = ACTIONS(5549),
    [anon_sym___attribute] = ACTIONS(5549),
    [anon_sym_using] = ACTIONS(5549),
    [anon_sym_COLON_COLON] = ACTIONS(5551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5551),
    [anon_sym___declspec] = ACTIONS(5549),
    [anon_sym___based] = ACTIONS(5549),
    [anon_sym_signed] = ACTIONS(5549),
    [anon_sym_unsigned] = ACTIONS(5549),
    [anon_sym_long] = ACTIONS(5549),
    [anon_sym_short] = ACTIONS(5549),
    [anon_sym_LBRACK] = ACTIONS(5549),
    [anon_sym_static] = ACTIONS(5549),
    [anon_sym_register] = ACTIONS(5549),
    [anon_sym_inline] = ACTIONS(5549),
    [anon_sym___inline] = ACTIONS(5549),
    [anon_sym___inline__] = ACTIONS(5549),
    [anon_sym___forceinline] = ACTIONS(5549),
    [anon_sym_thread_local] = ACTIONS(5549),
    [anon_sym___thread] = ACTIONS(5549),
    [anon_sym_const] = ACTIONS(5549),
    [anon_sym_constexpr] = ACTIONS(5549),
    [anon_sym_volatile] = ACTIONS(5549),
    [anon_sym_restrict] = ACTIONS(5549),
    [anon_sym___restrict__] = ACTIONS(5549),
    [anon_sym__Atomic] = ACTIONS(5549),
    [anon_sym__Noreturn] = ACTIONS(5549),
    [anon_sym_noreturn] = ACTIONS(5549),
    [anon_sym__Nonnull] = ACTIONS(5549),
    [anon_sym_mutable] = ACTIONS(5549),
    [anon_sym_constinit] = ACTIONS(5549),
    [anon_sym_consteval] = ACTIONS(5549),
    [anon_sym_alignas] = ACTIONS(5549),
    [anon_sym__Alignas] = ACTIONS(5549),
    [sym_primitive_type] = ACTIONS(5549),
    [anon_sym_enum] = ACTIONS(5549),
    [anon_sym_class] = ACTIONS(5549),
    [anon_sym_struct] = ACTIONS(5549),
    [anon_sym_union] = ACTIONS(5549),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5549),
    [anon_sym_decltype] = ACTIONS(5549),
    [anon_sym_explicit] = ACTIONS(5549),
    [anon_sym_typename] = ACTIONS(5549),
    [anon_sym_private] = ACTIONS(5549),
    [anon_sym_template] = ACTIONS(5549),
    [anon_sym_operator] = ACTIONS(5549),
    [anon_sym_friend] = ACTIONS(5549),
    [anon_sym_public] = ACTIONS(5549),
    [anon_sym_protected] = ACTIONS(5549),
    [anon_sym_static_assert] = ACTIONS(5549),
  },
  [1760] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6231),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6786),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6786),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1761] = {
    [sym_identifier] = ACTIONS(3067),
    [aux_sym_preproc_def_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token2] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3067),
    [aux_sym_preproc_else_token1] = ACTIONS(3067),
    [aux_sym_preproc_elif_token1] = ACTIONS(3067),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3067),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3067),
    [sym_preproc_directive] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym___extension__] = ACTIONS(3067),
    [anon_sym_typedef] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym___attribute__] = ACTIONS(3067),
    [anon_sym___attribute] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3069),
    [anon_sym___declspec] = ACTIONS(3067),
    [anon_sym___based] = ACTIONS(3067),
    [anon_sym_signed] = ACTIONS(3067),
    [anon_sym_unsigned] = ACTIONS(3067),
    [anon_sym_long] = ACTIONS(3067),
    [anon_sym_short] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_register] = ACTIONS(3067),
    [anon_sym_inline] = ACTIONS(3067),
    [anon_sym___inline] = ACTIONS(3067),
    [anon_sym___inline__] = ACTIONS(3067),
    [anon_sym___forceinline] = ACTIONS(3067),
    [anon_sym_thread_local] = ACTIONS(3067),
    [anon_sym___thread] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_constexpr] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_restrict] = ACTIONS(3067),
    [anon_sym___restrict__] = ACTIONS(3067),
    [anon_sym__Atomic] = ACTIONS(3067),
    [anon_sym__Noreturn] = ACTIONS(3067),
    [anon_sym_noreturn] = ACTIONS(3067),
    [anon_sym__Nonnull] = ACTIONS(3067),
    [anon_sym_mutable] = ACTIONS(3067),
    [anon_sym_constinit] = ACTIONS(3067),
    [anon_sym_consteval] = ACTIONS(3067),
    [anon_sym_alignas] = ACTIONS(3067),
    [anon_sym__Alignas] = ACTIONS(3067),
    [sym_primitive_type] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_union] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3067),
    [anon_sym_decltype] = ACTIONS(3067),
    [anon_sym_explicit] = ACTIONS(3067),
    [anon_sym_typename] = ACTIONS(3067),
    [anon_sym_private] = ACTIONS(3067),
    [anon_sym_template] = ACTIONS(3067),
    [anon_sym_operator] = ACTIONS(3067),
    [anon_sym_friend] = ACTIONS(3067),
    [anon_sym_public] = ACTIONS(3067),
    [anon_sym_protected] = ACTIONS(3067),
    [anon_sym_static_assert] = ACTIONS(3067),
  },
  [1762] = {
    [sym_identifier] = ACTIONS(3071),
    [aux_sym_preproc_def_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token2] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3071),
    [aux_sym_preproc_else_token1] = ACTIONS(3071),
    [aux_sym_preproc_elif_token1] = ACTIONS(3071),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3071),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3071),
    [sym_preproc_directive] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym___extension__] = ACTIONS(3071),
    [anon_sym_typedef] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym___attribute__] = ACTIONS(3071),
    [anon_sym___attribute] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3073),
    [anon_sym___declspec] = ACTIONS(3071),
    [anon_sym___based] = ACTIONS(3071),
    [anon_sym_signed] = ACTIONS(3071),
    [anon_sym_unsigned] = ACTIONS(3071),
    [anon_sym_long] = ACTIONS(3071),
    [anon_sym_short] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_register] = ACTIONS(3071),
    [anon_sym_inline] = ACTIONS(3071),
    [anon_sym___inline] = ACTIONS(3071),
    [anon_sym___inline__] = ACTIONS(3071),
    [anon_sym___forceinline] = ACTIONS(3071),
    [anon_sym_thread_local] = ACTIONS(3071),
    [anon_sym___thread] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_constexpr] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_restrict] = ACTIONS(3071),
    [anon_sym___restrict__] = ACTIONS(3071),
    [anon_sym__Atomic] = ACTIONS(3071),
    [anon_sym__Noreturn] = ACTIONS(3071),
    [anon_sym_noreturn] = ACTIONS(3071),
    [anon_sym__Nonnull] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_constinit] = ACTIONS(3071),
    [anon_sym_consteval] = ACTIONS(3071),
    [anon_sym_alignas] = ACTIONS(3071),
    [anon_sym__Alignas] = ACTIONS(3071),
    [sym_primitive_type] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_union] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3071),
    [anon_sym_decltype] = ACTIONS(3071),
    [anon_sym_explicit] = ACTIONS(3071),
    [anon_sym_typename] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_template] = ACTIONS(3071),
    [anon_sym_operator] = ACTIONS(3071),
    [anon_sym_friend] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_static_assert] = ACTIONS(3071),
  },
  [1763] = {
    [sym_identifier] = ACTIONS(4992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4994),
    [anon_sym_COMMA] = ACTIONS(4994),
    [anon_sym_RPAREN] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4992),
    [anon_sym_PLUS] = ACTIONS(4992),
    [anon_sym_STAR] = ACTIONS(4994),
    [anon_sym_SLASH] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_PIPE_PIPE] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(4992),
    [anon_sym_CARET] = ACTIONS(4994),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4994),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_GT_EQ] = ACTIONS(4994),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_LT_LT] = ACTIONS(4994),
    [anon_sym_GT_GT] = ACTIONS(4994),
    [anon_sym_SEMI] = ACTIONS(4994),
    [anon_sym___extension__] = ACTIONS(4992),
    [anon_sym___attribute__] = ACTIONS(4992),
    [anon_sym___attribute] = ACTIONS(4992),
    [anon_sym_COLON] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym___based] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4994),
    [anon_sym_RBRACE] = ACTIONS(4994),
    [anon_sym_signed] = ACTIONS(4992),
    [anon_sym_unsigned] = ACTIONS(4992),
    [anon_sym_long] = ACTIONS(4992),
    [anon_sym_short] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4994),
    [anon_sym_RBRACK] = ACTIONS(4994),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym___restrict__] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym__Noreturn] = ACTIONS(4992),
    [anon_sym_noreturn] = ACTIONS(4992),
    [anon_sym__Nonnull] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_constinit] = ACTIONS(4992),
    [anon_sym_consteval] = ACTIONS(4992),
    [anon_sym_alignas] = ACTIONS(4992),
    [anon_sym__Alignas] = ACTIONS(4992),
    [sym_primitive_type] = ACTIONS(4992),
    [anon_sym_QMARK] = ACTIONS(4994),
    [anon_sym_LT_EQ_GT] = ACTIONS(4994),
    [anon_sym_or] = ACTIONS(4992),
    [anon_sym_and] = ACTIONS(4992),
    [anon_sym_bitor] = ACTIONS(4992),
    [anon_sym_xor] = ACTIONS(4992),
    [anon_sym_bitand] = ACTIONS(4992),
    [anon_sym_not_eq] = ACTIONS(4992),
    [anon_sym_DASH_DASH] = ACTIONS(4994),
    [anon_sym_PLUS_PLUS] = ACTIONS(4994),
    [anon_sym_DOT] = ACTIONS(4992),
    [anon_sym_DOT_STAR] = ACTIONS(4994),
    [anon_sym_DASH_GT] = ACTIONS(4994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_decltype] = ACTIONS(4992),
    [anon_sym_final] = ACTIONS(4992),
    [anon_sym_override] = ACTIONS(4992),
    [anon_sym_requires] = ACTIONS(4992),
  },
  [1764] = {
    [sym_identifier] = ACTIONS(5549),
    [aux_sym_preproc_def_token1] = ACTIONS(5549),
    [aux_sym_preproc_if_token1] = ACTIONS(5549),
    [aux_sym_preproc_if_token2] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5549),
    [aux_sym_preproc_else_token1] = ACTIONS(5549),
    [aux_sym_preproc_elif_token1] = ACTIONS(5549),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5549),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5549),
    [sym_preproc_directive] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(5551),
    [anon_sym_TILDE] = ACTIONS(5551),
    [anon_sym_STAR] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5549),
    [anon_sym_SEMI] = ACTIONS(5551),
    [anon_sym___extension__] = ACTIONS(5549),
    [anon_sym_typedef] = ACTIONS(5549),
    [anon_sym_virtual] = ACTIONS(5549),
    [anon_sym_extern] = ACTIONS(5549),
    [anon_sym___attribute__] = ACTIONS(5549),
    [anon_sym___attribute] = ACTIONS(5549),
    [anon_sym_using] = ACTIONS(5549),
    [anon_sym_COLON_COLON] = ACTIONS(5551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5551),
    [anon_sym___declspec] = ACTIONS(5549),
    [anon_sym___based] = ACTIONS(5549),
    [anon_sym_signed] = ACTIONS(5549),
    [anon_sym_unsigned] = ACTIONS(5549),
    [anon_sym_long] = ACTIONS(5549),
    [anon_sym_short] = ACTIONS(5549),
    [anon_sym_LBRACK] = ACTIONS(5549),
    [anon_sym_static] = ACTIONS(5549),
    [anon_sym_register] = ACTIONS(5549),
    [anon_sym_inline] = ACTIONS(5549),
    [anon_sym___inline] = ACTIONS(5549),
    [anon_sym___inline__] = ACTIONS(5549),
    [anon_sym___forceinline] = ACTIONS(5549),
    [anon_sym_thread_local] = ACTIONS(5549),
    [anon_sym___thread] = ACTIONS(5549),
    [anon_sym_const] = ACTIONS(5549),
    [anon_sym_constexpr] = ACTIONS(5549),
    [anon_sym_volatile] = ACTIONS(5549),
    [anon_sym_restrict] = ACTIONS(5549),
    [anon_sym___restrict__] = ACTIONS(5549),
    [anon_sym__Atomic] = ACTIONS(5549),
    [anon_sym__Noreturn] = ACTIONS(5549),
    [anon_sym_noreturn] = ACTIONS(5549),
    [anon_sym__Nonnull] = ACTIONS(5549),
    [anon_sym_mutable] = ACTIONS(5549),
    [anon_sym_constinit] = ACTIONS(5549),
    [anon_sym_consteval] = ACTIONS(5549),
    [anon_sym_alignas] = ACTIONS(5549),
    [anon_sym__Alignas] = ACTIONS(5549),
    [sym_primitive_type] = ACTIONS(5549),
    [anon_sym_enum] = ACTIONS(5549),
    [anon_sym_class] = ACTIONS(5549),
    [anon_sym_struct] = ACTIONS(5549),
    [anon_sym_union] = ACTIONS(5549),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5549),
    [anon_sym_decltype] = ACTIONS(5549),
    [anon_sym_explicit] = ACTIONS(5549),
    [anon_sym_typename] = ACTIONS(5549),
    [anon_sym_private] = ACTIONS(5549),
    [anon_sym_template] = ACTIONS(5549),
    [anon_sym_operator] = ACTIONS(5549),
    [anon_sym_friend] = ACTIONS(5549),
    [anon_sym_public] = ACTIONS(5549),
    [anon_sym_protected] = ACTIONS(5549),
    [anon_sym_static_assert] = ACTIONS(5549),
  },
  [1765] = {
    [sym_identifier] = ACTIONS(5553),
    [aux_sym_preproc_def_token1] = ACTIONS(5553),
    [aux_sym_preproc_if_token1] = ACTIONS(5553),
    [aux_sym_preproc_if_token2] = ACTIONS(5553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5553),
    [aux_sym_preproc_else_token1] = ACTIONS(5553),
    [aux_sym_preproc_elif_token1] = ACTIONS(5553),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5553),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5553),
    [sym_preproc_directive] = ACTIONS(5553),
    [anon_sym_LPAREN2] = ACTIONS(5555),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_STAR] = ACTIONS(5555),
    [anon_sym_AMP_AMP] = ACTIONS(5555),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_SEMI] = ACTIONS(5555),
    [anon_sym___extension__] = ACTIONS(5553),
    [anon_sym_typedef] = ACTIONS(5553),
    [anon_sym_virtual] = ACTIONS(5553),
    [anon_sym_extern] = ACTIONS(5553),
    [anon_sym___attribute__] = ACTIONS(5553),
    [anon_sym___attribute] = ACTIONS(5553),
    [anon_sym_using] = ACTIONS(5553),
    [anon_sym_COLON_COLON] = ACTIONS(5555),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5555),
    [anon_sym___declspec] = ACTIONS(5553),
    [anon_sym___based] = ACTIONS(5553),
    [anon_sym_signed] = ACTIONS(5553),
    [anon_sym_unsigned] = ACTIONS(5553),
    [anon_sym_long] = ACTIONS(5553),
    [anon_sym_short] = ACTIONS(5553),
    [anon_sym_LBRACK] = ACTIONS(5553),
    [anon_sym_static] = ACTIONS(5553),
    [anon_sym_register] = ACTIONS(5553),
    [anon_sym_inline] = ACTIONS(5553),
    [anon_sym___inline] = ACTIONS(5553),
    [anon_sym___inline__] = ACTIONS(5553),
    [anon_sym___forceinline] = ACTIONS(5553),
    [anon_sym_thread_local] = ACTIONS(5553),
    [anon_sym___thread] = ACTIONS(5553),
    [anon_sym_const] = ACTIONS(5553),
    [anon_sym_constexpr] = ACTIONS(5553),
    [anon_sym_volatile] = ACTIONS(5553),
    [anon_sym_restrict] = ACTIONS(5553),
    [anon_sym___restrict__] = ACTIONS(5553),
    [anon_sym__Atomic] = ACTIONS(5553),
    [anon_sym__Noreturn] = ACTIONS(5553),
    [anon_sym_noreturn] = ACTIONS(5553),
    [anon_sym__Nonnull] = ACTIONS(5553),
    [anon_sym_mutable] = ACTIONS(5553),
    [anon_sym_constinit] = ACTIONS(5553),
    [anon_sym_consteval] = ACTIONS(5553),
    [anon_sym_alignas] = ACTIONS(5553),
    [anon_sym__Alignas] = ACTIONS(5553),
    [sym_primitive_type] = ACTIONS(5553),
    [anon_sym_enum] = ACTIONS(5553),
    [anon_sym_class] = ACTIONS(5553),
    [anon_sym_struct] = ACTIONS(5553),
    [anon_sym_union] = ACTIONS(5553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5553),
    [anon_sym_decltype] = ACTIONS(5553),
    [anon_sym_explicit] = ACTIONS(5553),
    [anon_sym_typename] = ACTIONS(5553),
    [anon_sym_private] = ACTIONS(5553),
    [anon_sym_template] = ACTIONS(5553),
    [anon_sym_operator] = ACTIONS(5553),
    [anon_sym_friend] = ACTIONS(5553),
    [anon_sym_public] = ACTIONS(5553),
    [anon_sym_protected] = ACTIONS(5553),
    [anon_sym_static_assert] = ACTIONS(5553),
  },
  [1766] = {
    [sym_identifier] = ACTIONS(5557),
    [aux_sym_preproc_def_token1] = ACTIONS(5557),
    [aux_sym_preproc_if_token1] = ACTIONS(5557),
    [aux_sym_preproc_if_token2] = ACTIONS(5557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5557),
    [aux_sym_preproc_else_token1] = ACTIONS(5557),
    [aux_sym_preproc_elif_token1] = ACTIONS(5557),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5557),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5557),
    [sym_preproc_directive] = ACTIONS(5557),
    [anon_sym_LPAREN2] = ACTIONS(5559),
    [anon_sym_TILDE] = ACTIONS(5559),
    [anon_sym_STAR] = ACTIONS(5559),
    [anon_sym_AMP_AMP] = ACTIONS(5559),
    [anon_sym_AMP] = ACTIONS(5557),
    [anon_sym_SEMI] = ACTIONS(5559),
    [anon_sym___extension__] = ACTIONS(5557),
    [anon_sym_typedef] = ACTIONS(5557),
    [anon_sym_virtual] = ACTIONS(5557),
    [anon_sym_extern] = ACTIONS(5557),
    [anon_sym___attribute__] = ACTIONS(5557),
    [anon_sym___attribute] = ACTIONS(5557),
    [anon_sym_using] = ACTIONS(5557),
    [anon_sym_COLON_COLON] = ACTIONS(5559),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5559),
    [anon_sym___declspec] = ACTIONS(5557),
    [anon_sym___based] = ACTIONS(5557),
    [anon_sym_signed] = ACTIONS(5557),
    [anon_sym_unsigned] = ACTIONS(5557),
    [anon_sym_long] = ACTIONS(5557),
    [anon_sym_short] = ACTIONS(5557),
    [anon_sym_LBRACK] = ACTIONS(5557),
    [anon_sym_static] = ACTIONS(5557),
    [anon_sym_register] = ACTIONS(5557),
    [anon_sym_inline] = ACTIONS(5557),
    [anon_sym___inline] = ACTIONS(5557),
    [anon_sym___inline__] = ACTIONS(5557),
    [anon_sym___forceinline] = ACTIONS(5557),
    [anon_sym_thread_local] = ACTIONS(5557),
    [anon_sym___thread] = ACTIONS(5557),
    [anon_sym_const] = ACTIONS(5557),
    [anon_sym_constexpr] = ACTIONS(5557),
    [anon_sym_volatile] = ACTIONS(5557),
    [anon_sym_restrict] = ACTIONS(5557),
    [anon_sym___restrict__] = ACTIONS(5557),
    [anon_sym__Atomic] = ACTIONS(5557),
    [anon_sym__Noreturn] = ACTIONS(5557),
    [anon_sym_noreturn] = ACTIONS(5557),
    [anon_sym__Nonnull] = ACTIONS(5557),
    [anon_sym_mutable] = ACTIONS(5557),
    [anon_sym_constinit] = ACTIONS(5557),
    [anon_sym_consteval] = ACTIONS(5557),
    [anon_sym_alignas] = ACTIONS(5557),
    [anon_sym__Alignas] = ACTIONS(5557),
    [sym_primitive_type] = ACTIONS(5557),
    [anon_sym_enum] = ACTIONS(5557),
    [anon_sym_class] = ACTIONS(5557),
    [anon_sym_struct] = ACTIONS(5557),
    [anon_sym_union] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5557),
    [anon_sym_decltype] = ACTIONS(5557),
    [anon_sym_explicit] = ACTIONS(5557),
    [anon_sym_typename] = ACTIONS(5557),
    [anon_sym_private] = ACTIONS(5557),
    [anon_sym_template] = ACTIONS(5557),
    [anon_sym_operator] = ACTIONS(5557),
    [anon_sym_friend] = ACTIONS(5557),
    [anon_sym_public] = ACTIONS(5557),
    [anon_sym_protected] = ACTIONS(5557),
    [anon_sym_static_assert] = ACTIONS(5557),
  },
  [1767] = {
    [sym_identifier] = ACTIONS(5561),
    [aux_sym_preproc_def_token1] = ACTIONS(5561),
    [aux_sym_preproc_if_token1] = ACTIONS(5561),
    [aux_sym_preproc_if_token2] = ACTIONS(5561),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5561),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5561),
    [aux_sym_preproc_else_token1] = ACTIONS(5561),
    [aux_sym_preproc_elif_token1] = ACTIONS(5561),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5561),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5561),
    [sym_preproc_directive] = ACTIONS(5561),
    [anon_sym_LPAREN2] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5563),
    [anon_sym_STAR] = ACTIONS(5563),
    [anon_sym_AMP_AMP] = ACTIONS(5563),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_SEMI] = ACTIONS(5563),
    [anon_sym___extension__] = ACTIONS(5561),
    [anon_sym_typedef] = ACTIONS(5561),
    [anon_sym_virtual] = ACTIONS(5561),
    [anon_sym_extern] = ACTIONS(5561),
    [anon_sym___attribute__] = ACTIONS(5561),
    [anon_sym___attribute] = ACTIONS(5561),
    [anon_sym_using] = ACTIONS(5561),
    [anon_sym_COLON_COLON] = ACTIONS(5563),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5563),
    [anon_sym___declspec] = ACTIONS(5561),
    [anon_sym___based] = ACTIONS(5561),
    [anon_sym_signed] = ACTIONS(5561),
    [anon_sym_unsigned] = ACTIONS(5561),
    [anon_sym_long] = ACTIONS(5561),
    [anon_sym_short] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5561),
    [anon_sym_static] = ACTIONS(5561),
    [anon_sym_register] = ACTIONS(5561),
    [anon_sym_inline] = ACTIONS(5561),
    [anon_sym___inline] = ACTIONS(5561),
    [anon_sym___inline__] = ACTIONS(5561),
    [anon_sym___forceinline] = ACTIONS(5561),
    [anon_sym_thread_local] = ACTIONS(5561),
    [anon_sym___thread] = ACTIONS(5561),
    [anon_sym_const] = ACTIONS(5561),
    [anon_sym_constexpr] = ACTIONS(5561),
    [anon_sym_volatile] = ACTIONS(5561),
    [anon_sym_restrict] = ACTIONS(5561),
    [anon_sym___restrict__] = ACTIONS(5561),
    [anon_sym__Atomic] = ACTIONS(5561),
    [anon_sym__Noreturn] = ACTIONS(5561),
    [anon_sym_noreturn] = ACTIONS(5561),
    [anon_sym__Nonnull] = ACTIONS(5561),
    [anon_sym_mutable] = ACTIONS(5561),
    [anon_sym_constinit] = ACTIONS(5561),
    [anon_sym_consteval] = ACTIONS(5561),
    [anon_sym_alignas] = ACTIONS(5561),
    [anon_sym__Alignas] = ACTIONS(5561),
    [sym_primitive_type] = ACTIONS(5561),
    [anon_sym_enum] = ACTIONS(5561),
    [anon_sym_class] = ACTIONS(5561),
    [anon_sym_struct] = ACTIONS(5561),
    [anon_sym_union] = ACTIONS(5561),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5561),
    [anon_sym_decltype] = ACTIONS(5561),
    [anon_sym_explicit] = ACTIONS(5561),
    [anon_sym_typename] = ACTIONS(5561),
    [anon_sym_private] = ACTIONS(5561),
    [anon_sym_template] = ACTIONS(5561),
    [anon_sym_operator] = ACTIONS(5561),
    [anon_sym_friend] = ACTIONS(5561),
    [anon_sym_public] = ACTIONS(5561),
    [anon_sym_protected] = ACTIONS(5561),
    [anon_sym_static_assert] = ACTIONS(5561),
  },
  [1768] = {
    [sym_identifier] = ACTIONS(5565),
    [aux_sym_preproc_def_token1] = ACTIONS(5565),
    [aux_sym_preproc_if_token1] = ACTIONS(5565),
    [aux_sym_preproc_if_token2] = ACTIONS(5565),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5565),
    [aux_sym_preproc_else_token1] = ACTIONS(5565),
    [aux_sym_preproc_elif_token1] = ACTIONS(5565),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5565),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5565),
    [sym_preproc_directive] = ACTIONS(5565),
    [anon_sym_LPAREN2] = ACTIONS(5567),
    [anon_sym_TILDE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5567),
    [anon_sym_AMP_AMP] = ACTIONS(5567),
    [anon_sym_AMP] = ACTIONS(5565),
    [anon_sym_SEMI] = ACTIONS(5567),
    [anon_sym___extension__] = ACTIONS(5565),
    [anon_sym_typedef] = ACTIONS(5565),
    [anon_sym_virtual] = ACTIONS(5565),
    [anon_sym_extern] = ACTIONS(5565),
    [anon_sym___attribute__] = ACTIONS(5565),
    [anon_sym___attribute] = ACTIONS(5565),
    [anon_sym_using] = ACTIONS(5565),
    [anon_sym_COLON_COLON] = ACTIONS(5567),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5567),
    [anon_sym___declspec] = ACTIONS(5565),
    [anon_sym___based] = ACTIONS(5565),
    [anon_sym_signed] = ACTIONS(5565),
    [anon_sym_unsigned] = ACTIONS(5565),
    [anon_sym_long] = ACTIONS(5565),
    [anon_sym_short] = ACTIONS(5565),
    [anon_sym_LBRACK] = ACTIONS(5565),
    [anon_sym_static] = ACTIONS(5565),
    [anon_sym_register] = ACTIONS(5565),
    [anon_sym_inline] = ACTIONS(5565),
    [anon_sym___inline] = ACTIONS(5565),
    [anon_sym___inline__] = ACTIONS(5565),
    [anon_sym___forceinline] = ACTIONS(5565),
    [anon_sym_thread_local] = ACTIONS(5565),
    [anon_sym___thread] = ACTIONS(5565),
    [anon_sym_const] = ACTIONS(5565),
    [anon_sym_constexpr] = ACTIONS(5565),
    [anon_sym_volatile] = ACTIONS(5565),
    [anon_sym_restrict] = ACTIONS(5565),
    [anon_sym___restrict__] = ACTIONS(5565),
    [anon_sym__Atomic] = ACTIONS(5565),
    [anon_sym__Noreturn] = ACTIONS(5565),
    [anon_sym_noreturn] = ACTIONS(5565),
    [anon_sym__Nonnull] = ACTIONS(5565),
    [anon_sym_mutable] = ACTIONS(5565),
    [anon_sym_constinit] = ACTIONS(5565),
    [anon_sym_consteval] = ACTIONS(5565),
    [anon_sym_alignas] = ACTIONS(5565),
    [anon_sym__Alignas] = ACTIONS(5565),
    [sym_primitive_type] = ACTIONS(5565),
    [anon_sym_enum] = ACTIONS(5565),
    [anon_sym_class] = ACTIONS(5565),
    [anon_sym_struct] = ACTIONS(5565),
    [anon_sym_union] = ACTIONS(5565),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5565),
    [anon_sym_decltype] = ACTIONS(5565),
    [anon_sym_explicit] = ACTIONS(5565),
    [anon_sym_typename] = ACTIONS(5565),
    [anon_sym_private] = ACTIONS(5565),
    [anon_sym_template] = ACTIONS(5565),
    [anon_sym_operator] = ACTIONS(5565),
    [anon_sym_friend] = ACTIONS(5565),
    [anon_sym_public] = ACTIONS(5565),
    [anon_sym_protected] = ACTIONS(5565),
    [anon_sym_static_assert] = ACTIONS(5565),
  },
  [1769] = {
    [sym_identifier] = ACTIONS(5569),
    [aux_sym_preproc_def_token1] = ACTIONS(5569),
    [aux_sym_preproc_if_token1] = ACTIONS(5569),
    [aux_sym_preproc_if_token2] = ACTIONS(5569),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5569),
    [aux_sym_preproc_else_token1] = ACTIONS(5569),
    [aux_sym_preproc_elif_token1] = ACTIONS(5569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5569),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5569),
    [sym_preproc_directive] = ACTIONS(5569),
    [anon_sym_LPAREN2] = ACTIONS(5571),
    [anon_sym_TILDE] = ACTIONS(5571),
    [anon_sym_STAR] = ACTIONS(5571),
    [anon_sym_AMP_AMP] = ACTIONS(5571),
    [anon_sym_AMP] = ACTIONS(5569),
    [anon_sym_SEMI] = ACTIONS(5571),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_typedef] = ACTIONS(5569),
    [anon_sym_virtual] = ACTIONS(5569),
    [anon_sym_extern] = ACTIONS(5569),
    [anon_sym___attribute__] = ACTIONS(5569),
    [anon_sym___attribute] = ACTIONS(5569),
    [anon_sym_using] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5571),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5571),
    [anon_sym___declspec] = ACTIONS(5569),
    [anon_sym___based] = ACTIONS(5569),
    [anon_sym_signed] = ACTIONS(5569),
    [anon_sym_unsigned] = ACTIONS(5569),
    [anon_sym_long] = ACTIONS(5569),
    [anon_sym_short] = ACTIONS(5569),
    [anon_sym_LBRACK] = ACTIONS(5569),
    [anon_sym_static] = ACTIONS(5569),
    [anon_sym_register] = ACTIONS(5569),
    [anon_sym_inline] = ACTIONS(5569),
    [anon_sym___inline] = ACTIONS(5569),
    [anon_sym___inline__] = ACTIONS(5569),
    [anon_sym___forceinline] = ACTIONS(5569),
    [anon_sym_thread_local] = ACTIONS(5569),
    [anon_sym___thread] = ACTIONS(5569),
    [anon_sym_const] = ACTIONS(5569),
    [anon_sym_constexpr] = ACTIONS(5569),
    [anon_sym_volatile] = ACTIONS(5569),
    [anon_sym_restrict] = ACTIONS(5569),
    [anon_sym___restrict__] = ACTIONS(5569),
    [anon_sym__Atomic] = ACTIONS(5569),
    [anon_sym__Noreturn] = ACTIONS(5569),
    [anon_sym_noreturn] = ACTIONS(5569),
    [anon_sym__Nonnull] = ACTIONS(5569),
    [anon_sym_mutable] = ACTIONS(5569),
    [anon_sym_constinit] = ACTIONS(5569),
    [anon_sym_consteval] = ACTIONS(5569),
    [anon_sym_alignas] = ACTIONS(5569),
    [anon_sym__Alignas] = ACTIONS(5569),
    [sym_primitive_type] = ACTIONS(5569),
    [anon_sym_enum] = ACTIONS(5569),
    [anon_sym_class] = ACTIONS(5569),
    [anon_sym_struct] = ACTIONS(5569),
    [anon_sym_union] = ACTIONS(5569),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5569),
    [anon_sym_decltype] = ACTIONS(5569),
    [anon_sym_explicit] = ACTIONS(5569),
    [anon_sym_typename] = ACTIONS(5569),
    [anon_sym_private] = ACTIONS(5569),
    [anon_sym_template] = ACTIONS(5569),
    [anon_sym_operator] = ACTIONS(5569),
    [anon_sym_friend] = ACTIONS(5569),
    [anon_sym_public] = ACTIONS(5569),
    [anon_sym_protected] = ACTIONS(5569),
    [anon_sym_static_assert] = ACTIONS(5569),
  },
  [1770] = {
    [sym_identifier] = ACTIONS(5456),
    [aux_sym_preproc_def_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token2] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5456),
    [aux_sym_preproc_else_token1] = ACTIONS(5456),
    [aux_sym_preproc_elif_token1] = ACTIONS(5456),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5456),
    [sym_preproc_directive] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5458),
    [anon_sym_TILDE] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5458),
    [anon_sym___extension__] = ACTIONS(5456),
    [anon_sym_typedef] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym___attribute__] = ACTIONS(5456),
    [anon_sym___attribute] = ACTIONS(5456),
    [anon_sym_using] = ACTIONS(5456),
    [anon_sym_COLON_COLON] = ACTIONS(5458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5458),
    [anon_sym___declspec] = ACTIONS(5456),
    [anon_sym___based] = ACTIONS(5456),
    [anon_sym_signed] = ACTIONS(5456),
    [anon_sym_unsigned] = ACTIONS(5456),
    [anon_sym_long] = ACTIONS(5456),
    [anon_sym_short] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_register] = ACTIONS(5456),
    [anon_sym_inline] = ACTIONS(5456),
    [anon_sym___inline] = ACTIONS(5456),
    [anon_sym___inline__] = ACTIONS(5456),
    [anon_sym___forceinline] = ACTIONS(5456),
    [anon_sym_thread_local] = ACTIONS(5456),
    [anon_sym___thread] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_constexpr] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_restrict] = ACTIONS(5456),
    [anon_sym___restrict__] = ACTIONS(5456),
    [anon_sym__Atomic] = ACTIONS(5456),
    [anon_sym__Noreturn] = ACTIONS(5456),
    [anon_sym_noreturn] = ACTIONS(5456),
    [anon_sym__Nonnull] = ACTIONS(5456),
    [anon_sym_mutable] = ACTIONS(5456),
    [anon_sym_constinit] = ACTIONS(5456),
    [anon_sym_consteval] = ACTIONS(5456),
    [anon_sym_alignas] = ACTIONS(5456),
    [anon_sym__Alignas] = ACTIONS(5456),
    [sym_primitive_type] = ACTIONS(5456),
    [anon_sym_enum] = ACTIONS(5456),
    [anon_sym_class] = ACTIONS(5456),
    [anon_sym_struct] = ACTIONS(5456),
    [anon_sym_union] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5456),
    [anon_sym_decltype] = ACTIONS(5456),
    [anon_sym_explicit] = ACTIONS(5456),
    [anon_sym_typename] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_template] = ACTIONS(5456),
    [anon_sym_operator] = ACTIONS(5456),
    [anon_sym_friend] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_static_assert] = ACTIONS(5456),
  },
  [1771] = {
    [sym_identifier] = ACTIONS(5573),
    [aux_sym_preproc_def_token1] = ACTIONS(5573),
    [aux_sym_preproc_if_token1] = ACTIONS(5573),
    [aux_sym_preproc_if_token2] = ACTIONS(5573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5573),
    [aux_sym_preproc_else_token1] = ACTIONS(5573),
    [aux_sym_preproc_elif_token1] = ACTIONS(5573),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5573),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5573),
    [sym_preproc_directive] = ACTIONS(5573),
    [anon_sym_LPAREN2] = ACTIONS(5575),
    [anon_sym_TILDE] = ACTIONS(5575),
    [anon_sym_STAR] = ACTIONS(5575),
    [anon_sym_AMP_AMP] = ACTIONS(5575),
    [anon_sym_AMP] = ACTIONS(5573),
    [anon_sym_SEMI] = ACTIONS(5575),
    [anon_sym___extension__] = ACTIONS(5573),
    [anon_sym_typedef] = ACTIONS(5573),
    [anon_sym_virtual] = ACTIONS(5573),
    [anon_sym_extern] = ACTIONS(5573),
    [anon_sym___attribute__] = ACTIONS(5573),
    [anon_sym___attribute] = ACTIONS(5573),
    [anon_sym_using] = ACTIONS(5573),
    [anon_sym_COLON_COLON] = ACTIONS(5575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5575),
    [anon_sym___declspec] = ACTIONS(5573),
    [anon_sym___based] = ACTIONS(5573),
    [anon_sym_signed] = ACTIONS(5573),
    [anon_sym_unsigned] = ACTIONS(5573),
    [anon_sym_long] = ACTIONS(5573),
    [anon_sym_short] = ACTIONS(5573),
    [anon_sym_LBRACK] = ACTIONS(5573),
    [anon_sym_static] = ACTIONS(5573),
    [anon_sym_register] = ACTIONS(5573),
    [anon_sym_inline] = ACTIONS(5573),
    [anon_sym___inline] = ACTIONS(5573),
    [anon_sym___inline__] = ACTIONS(5573),
    [anon_sym___forceinline] = ACTIONS(5573),
    [anon_sym_thread_local] = ACTIONS(5573),
    [anon_sym___thread] = ACTIONS(5573),
    [anon_sym_const] = ACTIONS(5573),
    [anon_sym_constexpr] = ACTIONS(5573),
    [anon_sym_volatile] = ACTIONS(5573),
    [anon_sym_restrict] = ACTIONS(5573),
    [anon_sym___restrict__] = ACTIONS(5573),
    [anon_sym__Atomic] = ACTIONS(5573),
    [anon_sym__Noreturn] = ACTIONS(5573),
    [anon_sym_noreturn] = ACTIONS(5573),
    [anon_sym__Nonnull] = ACTIONS(5573),
    [anon_sym_mutable] = ACTIONS(5573),
    [anon_sym_constinit] = ACTIONS(5573),
    [anon_sym_consteval] = ACTIONS(5573),
    [anon_sym_alignas] = ACTIONS(5573),
    [anon_sym__Alignas] = ACTIONS(5573),
    [sym_primitive_type] = ACTIONS(5573),
    [anon_sym_enum] = ACTIONS(5573),
    [anon_sym_class] = ACTIONS(5573),
    [anon_sym_struct] = ACTIONS(5573),
    [anon_sym_union] = ACTIONS(5573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5573),
    [anon_sym_decltype] = ACTIONS(5573),
    [anon_sym_explicit] = ACTIONS(5573),
    [anon_sym_typename] = ACTIONS(5573),
    [anon_sym_private] = ACTIONS(5573),
    [anon_sym_template] = ACTIONS(5573),
    [anon_sym_operator] = ACTIONS(5573),
    [anon_sym_friend] = ACTIONS(5573),
    [anon_sym_public] = ACTIONS(5573),
    [anon_sym_protected] = ACTIONS(5573),
    [anon_sym_static_assert] = ACTIONS(5573),
  },
  [1772] = {
    [sym_identifier] = ACTIONS(3083),
    [aux_sym_preproc_def_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token2] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3083),
    [aux_sym_preproc_else_token1] = ACTIONS(3083),
    [aux_sym_preproc_elif_token1] = ACTIONS(3083),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3083),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3083),
    [sym_preproc_directive] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym___extension__] = ACTIONS(3083),
    [anon_sym_typedef] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym___attribute__] = ACTIONS(3083),
    [anon_sym___attribute] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3085),
    [anon_sym___declspec] = ACTIONS(3083),
    [anon_sym___based] = ACTIONS(3083),
    [anon_sym_signed] = ACTIONS(3083),
    [anon_sym_unsigned] = ACTIONS(3083),
    [anon_sym_long] = ACTIONS(3083),
    [anon_sym_short] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_register] = ACTIONS(3083),
    [anon_sym_inline] = ACTIONS(3083),
    [anon_sym___inline] = ACTIONS(3083),
    [anon_sym___inline__] = ACTIONS(3083),
    [anon_sym___forceinline] = ACTIONS(3083),
    [anon_sym_thread_local] = ACTIONS(3083),
    [anon_sym___thread] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_constexpr] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_restrict] = ACTIONS(3083),
    [anon_sym___restrict__] = ACTIONS(3083),
    [anon_sym__Atomic] = ACTIONS(3083),
    [anon_sym__Noreturn] = ACTIONS(3083),
    [anon_sym_noreturn] = ACTIONS(3083),
    [anon_sym__Nonnull] = ACTIONS(3083),
    [anon_sym_mutable] = ACTIONS(3083),
    [anon_sym_constinit] = ACTIONS(3083),
    [anon_sym_consteval] = ACTIONS(3083),
    [anon_sym_alignas] = ACTIONS(3083),
    [anon_sym__Alignas] = ACTIONS(3083),
    [sym_primitive_type] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3083),
    [anon_sym_union] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3083),
    [anon_sym_decltype] = ACTIONS(3083),
    [anon_sym_explicit] = ACTIONS(3083),
    [anon_sym_typename] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_template] = ACTIONS(3083),
    [anon_sym_operator] = ACTIONS(3083),
    [anon_sym_friend] = ACTIONS(3083),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_static_assert] = ACTIONS(3083),
  },
  [1773] = {
    [sym_identifier] = ACTIONS(5577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5579),
    [anon_sym_COMMA] = ACTIONS(5579),
    [anon_sym_RPAREN] = ACTIONS(5579),
    [aux_sym_preproc_if_token2] = ACTIONS(5579),
    [aux_sym_preproc_else_token1] = ACTIONS(5579),
    [aux_sym_preproc_elif_token1] = ACTIONS(5577),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5579),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5579),
    [anon_sym_LPAREN2] = ACTIONS(5579),
    [anon_sym_DASH] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5577),
    [anon_sym_STAR] = ACTIONS(5577),
    [anon_sym_SLASH] = ACTIONS(5577),
    [anon_sym_PERCENT] = ACTIONS(5577),
    [anon_sym_PIPE_PIPE] = ACTIONS(5579),
    [anon_sym_AMP_AMP] = ACTIONS(5579),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_CARET] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5577),
    [anon_sym_EQ_EQ] = ACTIONS(5579),
    [anon_sym_BANG_EQ] = ACTIONS(5579),
    [anon_sym_GT] = ACTIONS(5577),
    [anon_sym_GT_EQ] = ACTIONS(5579),
    [anon_sym_LT_EQ] = ACTIONS(5577),
    [anon_sym_LT] = ACTIONS(5577),
    [anon_sym_LT_LT] = ACTIONS(5577),
    [anon_sym_GT_GT] = ACTIONS(5577),
    [anon_sym_SEMI] = ACTIONS(5579),
    [anon_sym_COLON] = ACTIONS(5579),
    [anon_sym_RBRACE] = ACTIONS(5579),
    [anon_sym_LBRACK] = ACTIONS(5579),
    [anon_sym_RBRACK] = ACTIONS(5579),
    [anon_sym_EQ] = ACTIONS(5577),
    [anon_sym_QMARK] = ACTIONS(5579),
    [anon_sym_STAR_EQ] = ACTIONS(5579),
    [anon_sym_SLASH_EQ] = ACTIONS(5579),
    [anon_sym_PERCENT_EQ] = ACTIONS(5579),
    [anon_sym_PLUS_EQ] = ACTIONS(5579),
    [anon_sym_DASH_EQ] = ACTIONS(5579),
    [anon_sym_LT_LT_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_AMP_EQ] = ACTIONS(5579),
    [anon_sym_CARET_EQ] = ACTIONS(5579),
    [anon_sym_PIPE_EQ] = ACTIONS(5579),
    [anon_sym_and_eq] = ACTIONS(5577),
    [anon_sym_or_eq] = ACTIONS(5577),
    [anon_sym_xor_eq] = ACTIONS(5577),
    [anon_sym_LT_EQ_GT] = ACTIONS(5579),
    [anon_sym_or] = ACTIONS(5577),
    [anon_sym_and] = ACTIONS(5577),
    [anon_sym_bitor] = ACTIONS(5577),
    [anon_sym_xor] = ACTIONS(5577),
    [anon_sym_bitand] = ACTIONS(5577),
    [anon_sym_not_eq] = ACTIONS(5577),
    [anon_sym_DASH_DASH] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5579),
    [anon_sym_DOT] = ACTIONS(5577),
    [anon_sym_DOT_STAR] = ACTIONS(5579),
    [anon_sym_DASH_GT] = ACTIONS(5579),
    [anon_sym_L_DQUOTE] = ACTIONS(5579),
    [anon_sym_u_DQUOTE] = ACTIONS(5579),
    [anon_sym_U_DQUOTE] = ACTIONS(5579),
    [anon_sym_u8_DQUOTE] = ACTIONS(5579),
    [anon_sym_DQUOTE] = ACTIONS(5579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5579),
    [anon_sym_LR_DQUOTE] = ACTIONS(5579),
    [anon_sym_uR_DQUOTE] = ACTIONS(5579),
    [anon_sym_UR_DQUOTE] = ACTIONS(5579),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5579),
    [sym_literal_suffix] = ACTIONS(5577),
  },
  [1774] = {
    [sym_identifier] = ACTIONS(2863),
    [aux_sym_preproc_def_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token2] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2863),
    [aux_sym_preproc_else_token1] = ACTIONS(2863),
    [aux_sym_preproc_elif_token1] = ACTIONS(2863),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2863),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2863),
    [sym_preproc_directive] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym___extension__] = ACTIONS(2863),
    [anon_sym_typedef] = ACTIONS(2863),
    [anon_sym_virtual] = ACTIONS(2863),
    [anon_sym_extern] = ACTIONS(2863),
    [anon_sym___attribute__] = ACTIONS(2863),
    [anon_sym___attribute] = ACTIONS(2863),
    [anon_sym_using] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2865),
    [anon_sym___declspec] = ACTIONS(2863),
    [anon_sym___based] = ACTIONS(2863),
    [anon_sym_signed] = ACTIONS(2863),
    [anon_sym_unsigned] = ACTIONS(2863),
    [anon_sym_long] = ACTIONS(2863),
    [anon_sym_short] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_static] = ACTIONS(2863),
    [anon_sym_register] = ACTIONS(2863),
    [anon_sym_inline] = ACTIONS(2863),
    [anon_sym___inline] = ACTIONS(2863),
    [anon_sym___inline__] = ACTIONS(2863),
    [anon_sym___forceinline] = ACTIONS(2863),
    [anon_sym_thread_local] = ACTIONS(2863),
    [anon_sym___thread] = ACTIONS(2863),
    [anon_sym_const] = ACTIONS(2863),
    [anon_sym_constexpr] = ACTIONS(2863),
    [anon_sym_volatile] = ACTIONS(2863),
    [anon_sym_restrict] = ACTIONS(2863),
    [anon_sym___restrict__] = ACTIONS(2863),
    [anon_sym__Atomic] = ACTIONS(2863),
    [anon_sym__Noreturn] = ACTIONS(2863),
    [anon_sym_noreturn] = ACTIONS(2863),
    [anon_sym__Nonnull] = ACTIONS(2863),
    [anon_sym_mutable] = ACTIONS(2863),
    [anon_sym_constinit] = ACTIONS(2863),
    [anon_sym_consteval] = ACTIONS(2863),
    [anon_sym_alignas] = ACTIONS(2863),
    [anon_sym__Alignas] = ACTIONS(2863),
    [sym_primitive_type] = ACTIONS(2863),
    [anon_sym_enum] = ACTIONS(2863),
    [anon_sym_class] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2863),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2863),
    [anon_sym_decltype] = ACTIONS(2863),
    [anon_sym_explicit] = ACTIONS(2863),
    [anon_sym_typename] = ACTIONS(2863),
    [anon_sym_private] = ACTIONS(2863),
    [anon_sym_template] = ACTIONS(2863),
    [anon_sym_operator] = ACTIONS(2863),
    [anon_sym_friend] = ACTIONS(2863),
    [anon_sym_public] = ACTIONS(2863),
    [anon_sym_protected] = ACTIONS(2863),
    [anon_sym_static_assert] = ACTIONS(2863),
  },
  [1775] = {
    [sym_identifier] = ACTIONS(3112),
    [aux_sym_preproc_def_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token2] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3112),
    [aux_sym_preproc_else_token1] = ACTIONS(3112),
    [aux_sym_preproc_elif_token1] = ACTIONS(3112),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3112),
    [sym_preproc_directive] = ACTIONS(3112),
    [anon_sym_LPAREN2] = ACTIONS(3114),
    [anon_sym_TILDE] = ACTIONS(3114),
    [anon_sym_STAR] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3112),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym___extension__] = ACTIONS(3112),
    [anon_sym_typedef] = ACTIONS(3112),
    [anon_sym_virtual] = ACTIONS(3112),
    [anon_sym_extern] = ACTIONS(3112),
    [anon_sym___attribute__] = ACTIONS(3112),
    [anon_sym___attribute] = ACTIONS(3112),
    [anon_sym_using] = ACTIONS(3112),
    [anon_sym_COLON_COLON] = ACTIONS(3114),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3114),
    [anon_sym___declspec] = ACTIONS(3112),
    [anon_sym___based] = ACTIONS(3112),
    [anon_sym_signed] = ACTIONS(3112),
    [anon_sym_unsigned] = ACTIONS(3112),
    [anon_sym_long] = ACTIONS(3112),
    [anon_sym_short] = ACTIONS(3112),
    [anon_sym_LBRACK] = ACTIONS(3112),
    [anon_sym_static] = ACTIONS(3112),
    [anon_sym_register] = ACTIONS(3112),
    [anon_sym_inline] = ACTIONS(3112),
    [anon_sym___inline] = ACTIONS(3112),
    [anon_sym___inline__] = ACTIONS(3112),
    [anon_sym___forceinline] = ACTIONS(3112),
    [anon_sym_thread_local] = ACTIONS(3112),
    [anon_sym___thread] = ACTIONS(3112),
    [anon_sym_const] = ACTIONS(3112),
    [anon_sym_constexpr] = ACTIONS(3112),
    [anon_sym_volatile] = ACTIONS(3112),
    [anon_sym_restrict] = ACTIONS(3112),
    [anon_sym___restrict__] = ACTIONS(3112),
    [anon_sym__Atomic] = ACTIONS(3112),
    [anon_sym__Noreturn] = ACTIONS(3112),
    [anon_sym_noreturn] = ACTIONS(3112),
    [anon_sym__Nonnull] = ACTIONS(3112),
    [anon_sym_mutable] = ACTIONS(3112),
    [anon_sym_constinit] = ACTIONS(3112),
    [anon_sym_consteval] = ACTIONS(3112),
    [anon_sym_alignas] = ACTIONS(3112),
    [anon_sym__Alignas] = ACTIONS(3112),
    [sym_primitive_type] = ACTIONS(3112),
    [anon_sym_enum] = ACTIONS(3112),
    [anon_sym_class] = ACTIONS(3112),
    [anon_sym_struct] = ACTIONS(3112),
    [anon_sym_union] = ACTIONS(3112),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3112),
    [anon_sym_decltype] = ACTIONS(3112),
    [anon_sym_explicit] = ACTIONS(3112),
    [anon_sym_typename] = ACTIONS(3112),
    [anon_sym_private] = ACTIONS(3112),
    [anon_sym_template] = ACTIONS(3112),
    [anon_sym_operator] = ACTIONS(3112),
    [anon_sym_friend] = ACTIONS(3112),
    [anon_sym_public] = ACTIONS(3112),
    [anon_sym_protected] = ACTIONS(3112),
    [anon_sym_static_assert] = ACTIONS(3112),
  },
  [1776] = {
    [sym_identifier] = ACTIONS(2919),
    [aux_sym_preproc_def_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token2] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2919),
    [aux_sym_preproc_else_token1] = ACTIONS(2919),
    [aux_sym_preproc_elif_token1] = ACTIONS(2919),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2919),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2919),
    [sym_preproc_directive] = ACTIONS(2919),
    [anon_sym_LPAREN2] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym___extension__] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(2919),
    [anon_sym_virtual] = ACTIONS(2919),
    [anon_sym_extern] = ACTIONS(2919),
    [anon_sym___attribute__] = ACTIONS(2919),
    [anon_sym___attribute] = ACTIONS(2919),
    [anon_sym_using] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(2921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2921),
    [anon_sym___declspec] = ACTIONS(2919),
    [anon_sym___based] = ACTIONS(2919),
    [anon_sym_signed] = ACTIONS(2919),
    [anon_sym_unsigned] = ACTIONS(2919),
    [anon_sym_long] = ACTIONS(2919),
    [anon_sym_short] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_register] = ACTIONS(2919),
    [anon_sym_inline] = ACTIONS(2919),
    [anon_sym___inline] = ACTIONS(2919),
    [anon_sym___inline__] = ACTIONS(2919),
    [anon_sym___forceinline] = ACTIONS(2919),
    [anon_sym_thread_local] = ACTIONS(2919),
    [anon_sym___thread] = ACTIONS(2919),
    [anon_sym_const] = ACTIONS(2919),
    [anon_sym_constexpr] = ACTIONS(2919),
    [anon_sym_volatile] = ACTIONS(2919),
    [anon_sym_restrict] = ACTIONS(2919),
    [anon_sym___restrict__] = ACTIONS(2919),
    [anon_sym__Atomic] = ACTIONS(2919),
    [anon_sym__Noreturn] = ACTIONS(2919),
    [anon_sym_noreturn] = ACTIONS(2919),
    [anon_sym__Nonnull] = ACTIONS(2919),
    [anon_sym_mutable] = ACTIONS(2919),
    [anon_sym_constinit] = ACTIONS(2919),
    [anon_sym_consteval] = ACTIONS(2919),
    [anon_sym_alignas] = ACTIONS(2919),
    [anon_sym__Alignas] = ACTIONS(2919),
    [sym_primitive_type] = ACTIONS(2919),
    [anon_sym_enum] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2919),
    [anon_sym_decltype] = ACTIONS(2919),
    [anon_sym_explicit] = ACTIONS(2919),
    [anon_sym_typename] = ACTIONS(2919),
    [anon_sym_private] = ACTIONS(2919),
    [anon_sym_template] = ACTIONS(2919),
    [anon_sym_operator] = ACTIONS(2919),
    [anon_sym_friend] = ACTIONS(2919),
    [anon_sym_public] = ACTIONS(2919),
    [anon_sym_protected] = ACTIONS(2919),
    [anon_sym_static_assert] = ACTIONS(2919),
  },
  [1777] = {
    [sym_identifier] = ACTIONS(2923),
    [aux_sym_preproc_def_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token2] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2923),
    [aux_sym_preproc_else_token1] = ACTIONS(2923),
    [aux_sym_preproc_elif_token1] = ACTIONS(2923),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2923),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2923),
    [sym_preproc_directive] = ACTIONS(2923),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2923),
    [anon_sym_typedef] = ACTIONS(2923),
    [anon_sym_virtual] = ACTIONS(2923),
    [anon_sym_extern] = ACTIONS(2923),
    [anon_sym___attribute__] = ACTIONS(2923),
    [anon_sym___attribute] = ACTIONS(2923),
    [anon_sym_using] = ACTIONS(2923),
    [anon_sym_COLON_COLON] = ACTIONS(2925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2925),
    [anon_sym___declspec] = ACTIONS(2923),
    [anon_sym___based] = ACTIONS(2923),
    [anon_sym_signed] = ACTIONS(2923),
    [anon_sym_unsigned] = ACTIONS(2923),
    [anon_sym_long] = ACTIONS(2923),
    [anon_sym_short] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_register] = ACTIONS(2923),
    [anon_sym_inline] = ACTIONS(2923),
    [anon_sym___inline] = ACTIONS(2923),
    [anon_sym___inline__] = ACTIONS(2923),
    [anon_sym___forceinline] = ACTIONS(2923),
    [anon_sym_thread_local] = ACTIONS(2923),
    [anon_sym___thread] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_constexpr] = ACTIONS(2923),
    [anon_sym_volatile] = ACTIONS(2923),
    [anon_sym_restrict] = ACTIONS(2923),
    [anon_sym___restrict__] = ACTIONS(2923),
    [anon_sym__Atomic] = ACTIONS(2923),
    [anon_sym__Noreturn] = ACTIONS(2923),
    [anon_sym_noreturn] = ACTIONS(2923),
    [anon_sym__Nonnull] = ACTIONS(2923),
    [anon_sym_mutable] = ACTIONS(2923),
    [anon_sym_constinit] = ACTIONS(2923),
    [anon_sym_consteval] = ACTIONS(2923),
    [anon_sym_alignas] = ACTIONS(2923),
    [anon_sym__Alignas] = ACTIONS(2923),
    [sym_primitive_type] = ACTIONS(2923),
    [anon_sym_enum] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2923),
    [anon_sym_union] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2923),
    [anon_sym_decltype] = ACTIONS(2923),
    [anon_sym_explicit] = ACTIONS(2923),
    [anon_sym_typename] = ACTIONS(2923),
    [anon_sym_private] = ACTIONS(2923),
    [anon_sym_template] = ACTIONS(2923),
    [anon_sym_operator] = ACTIONS(2923),
    [anon_sym_friend] = ACTIONS(2923),
    [anon_sym_public] = ACTIONS(2923),
    [anon_sym_protected] = ACTIONS(2923),
    [anon_sym_static_assert] = ACTIONS(2923),
  },
  [1778] = {
    [sym_identifier] = ACTIONS(5581),
    [aux_sym_preproc_def_token1] = ACTIONS(5581),
    [aux_sym_preproc_if_token1] = ACTIONS(5581),
    [aux_sym_preproc_if_token2] = ACTIONS(5581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5581),
    [aux_sym_preproc_else_token1] = ACTIONS(5581),
    [aux_sym_preproc_elif_token1] = ACTIONS(5581),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5581),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5581),
    [sym_preproc_directive] = ACTIONS(5581),
    [anon_sym_LPAREN2] = ACTIONS(5583),
    [anon_sym_TILDE] = ACTIONS(5583),
    [anon_sym_STAR] = ACTIONS(5583),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5581),
    [anon_sym_SEMI] = ACTIONS(5583),
    [anon_sym___extension__] = ACTIONS(5581),
    [anon_sym_typedef] = ACTIONS(5581),
    [anon_sym_virtual] = ACTIONS(5581),
    [anon_sym_extern] = ACTIONS(5581),
    [anon_sym___attribute__] = ACTIONS(5581),
    [anon_sym___attribute] = ACTIONS(5581),
    [anon_sym_using] = ACTIONS(5581),
    [anon_sym_COLON_COLON] = ACTIONS(5583),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5583),
    [anon_sym___declspec] = ACTIONS(5581),
    [anon_sym___based] = ACTIONS(5581),
    [anon_sym_signed] = ACTIONS(5581),
    [anon_sym_unsigned] = ACTIONS(5581),
    [anon_sym_long] = ACTIONS(5581),
    [anon_sym_short] = ACTIONS(5581),
    [anon_sym_LBRACK] = ACTIONS(5581),
    [anon_sym_static] = ACTIONS(5581),
    [anon_sym_register] = ACTIONS(5581),
    [anon_sym_inline] = ACTIONS(5581),
    [anon_sym___inline] = ACTIONS(5581),
    [anon_sym___inline__] = ACTIONS(5581),
    [anon_sym___forceinline] = ACTIONS(5581),
    [anon_sym_thread_local] = ACTIONS(5581),
    [anon_sym___thread] = ACTIONS(5581),
    [anon_sym_const] = ACTIONS(5581),
    [anon_sym_constexpr] = ACTIONS(5581),
    [anon_sym_volatile] = ACTIONS(5581),
    [anon_sym_restrict] = ACTIONS(5581),
    [anon_sym___restrict__] = ACTIONS(5581),
    [anon_sym__Atomic] = ACTIONS(5581),
    [anon_sym__Noreturn] = ACTIONS(5581),
    [anon_sym_noreturn] = ACTIONS(5581),
    [anon_sym__Nonnull] = ACTIONS(5581),
    [anon_sym_mutable] = ACTIONS(5581),
    [anon_sym_constinit] = ACTIONS(5581),
    [anon_sym_consteval] = ACTIONS(5581),
    [anon_sym_alignas] = ACTIONS(5581),
    [anon_sym__Alignas] = ACTIONS(5581),
    [sym_primitive_type] = ACTIONS(5581),
    [anon_sym_enum] = ACTIONS(5581),
    [anon_sym_class] = ACTIONS(5581),
    [anon_sym_struct] = ACTIONS(5581),
    [anon_sym_union] = ACTIONS(5581),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5581),
    [anon_sym_decltype] = ACTIONS(5581),
    [anon_sym_explicit] = ACTIONS(5581),
    [anon_sym_typename] = ACTIONS(5581),
    [anon_sym_private] = ACTIONS(5581),
    [anon_sym_template] = ACTIONS(5581),
    [anon_sym_operator] = ACTIONS(5581),
    [anon_sym_friend] = ACTIONS(5581),
    [anon_sym_public] = ACTIONS(5581),
    [anon_sym_protected] = ACTIONS(5581),
    [anon_sym_static_assert] = ACTIONS(5581),
  },
  [1779] = {
    [sym_identifier] = ACTIONS(5585),
    [aux_sym_preproc_def_token1] = ACTIONS(5585),
    [aux_sym_preproc_if_token1] = ACTIONS(5585),
    [aux_sym_preproc_if_token2] = ACTIONS(5585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5585),
    [aux_sym_preproc_else_token1] = ACTIONS(5585),
    [aux_sym_preproc_elif_token1] = ACTIONS(5585),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5585),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5585),
    [sym_preproc_directive] = ACTIONS(5585),
    [anon_sym_LPAREN2] = ACTIONS(5587),
    [anon_sym_TILDE] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5587),
    [anon_sym_AMP_AMP] = ACTIONS(5587),
    [anon_sym_AMP] = ACTIONS(5585),
    [anon_sym_SEMI] = ACTIONS(5587),
    [anon_sym___extension__] = ACTIONS(5585),
    [anon_sym_typedef] = ACTIONS(5585),
    [anon_sym_virtual] = ACTIONS(5585),
    [anon_sym_extern] = ACTIONS(5585),
    [anon_sym___attribute__] = ACTIONS(5585),
    [anon_sym___attribute] = ACTIONS(5585),
    [anon_sym_using] = ACTIONS(5585),
    [anon_sym_COLON_COLON] = ACTIONS(5587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5587),
    [anon_sym___declspec] = ACTIONS(5585),
    [anon_sym___based] = ACTIONS(5585),
    [anon_sym_signed] = ACTIONS(5585),
    [anon_sym_unsigned] = ACTIONS(5585),
    [anon_sym_long] = ACTIONS(5585),
    [anon_sym_short] = ACTIONS(5585),
    [anon_sym_LBRACK] = ACTIONS(5585),
    [anon_sym_static] = ACTIONS(5585),
    [anon_sym_register] = ACTIONS(5585),
    [anon_sym_inline] = ACTIONS(5585),
    [anon_sym___inline] = ACTIONS(5585),
    [anon_sym___inline__] = ACTIONS(5585),
    [anon_sym___forceinline] = ACTIONS(5585),
    [anon_sym_thread_local] = ACTIONS(5585),
    [anon_sym___thread] = ACTIONS(5585),
    [anon_sym_const] = ACTIONS(5585),
    [anon_sym_constexpr] = ACTIONS(5585),
    [anon_sym_volatile] = ACTIONS(5585),
    [anon_sym_restrict] = ACTIONS(5585),
    [anon_sym___restrict__] = ACTIONS(5585),
    [anon_sym__Atomic] = ACTIONS(5585),
    [anon_sym__Noreturn] = ACTIONS(5585),
    [anon_sym_noreturn] = ACTIONS(5585),
    [anon_sym__Nonnull] = ACTIONS(5585),
    [anon_sym_mutable] = ACTIONS(5585),
    [anon_sym_constinit] = ACTIONS(5585),
    [anon_sym_consteval] = ACTIONS(5585),
    [anon_sym_alignas] = ACTIONS(5585),
    [anon_sym__Alignas] = ACTIONS(5585),
    [sym_primitive_type] = ACTIONS(5585),
    [anon_sym_enum] = ACTIONS(5585),
    [anon_sym_class] = ACTIONS(5585),
    [anon_sym_struct] = ACTIONS(5585),
    [anon_sym_union] = ACTIONS(5585),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5585),
    [anon_sym_decltype] = ACTIONS(5585),
    [anon_sym_explicit] = ACTIONS(5585),
    [anon_sym_typename] = ACTIONS(5585),
    [anon_sym_private] = ACTIONS(5585),
    [anon_sym_template] = ACTIONS(5585),
    [anon_sym_operator] = ACTIONS(5585),
    [anon_sym_friend] = ACTIONS(5585),
    [anon_sym_public] = ACTIONS(5585),
    [anon_sym_protected] = ACTIONS(5585),
    [anon_sym_static_assert] = ACTIONS(5585),
  },
  [1780] = {
    [sym__declaration_modifiers] = STATE(2061),
    [sym__declaration_specifiers] = STATE(3966),
    [sym_attribute_specifier] = STATE(2061),
    [sym_attribute_declaration] = STATE(2061),
    [sym_ms_declspec_modifier] = STATE(2061),
    [sym_storage_class_specifier] = STATE(2061),
    [sym_type_qualifier] = STATE(2061),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_parameter_declaration] = STATE(7758),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_optional_parameter_declaration] = STATE(7758),
    [sym_variadic_parameter_declaration] = STATE(7758),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2061),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1878),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1781] = {
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token2] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [aux_sym_preproc_else_token1] = ACTIONS(2927),
    [aux_sym_preproc_elif_token1] = ACTIONS(2927),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym___attribute] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2929),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym__Nonnull] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym__Alignas] = ACTIONS(2927),
    [sym_primitive_type] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_private] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_friend] = ACTIONS(2927),
    [anon_sym_public] = ACTIONS(2927),
    [anon_sym_protected] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
  },
  [1782] = {
    [sym_identifier] = ACTIONS(2867),
    [aux_sym_preproc_def_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token2] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2867),
    [aux_sym_preproc_else_token1] = ACTIONS(2867),
    [aux_sym_preproc_elif_token1] = ACTIONS(2867),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2867),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2867),
    [sym_preproc_directive] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2869),
    [anon_sym_STAR] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2869),
    [anon_sym___extension__] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2867),
    [anon_sym_virtual] = ACTIONS(2867),
    [anon_sym_extern] = ACTIONS(2867),
    [anon_sym___attribute__] = ACTIONS(2867),
    [anon_sym___attribute] = ACTIONS(2867),
    [anon_sym_using] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2869),
    [anon_sym___declspec] = ACTIONS(2867),
    [anon_sym___based] = ACTIONS(2867),
    [anon_sym_signed] = ACTIONS(2867),
    [anon_sym_unsigned] = ACTIONS(2867),
    [anon_sym_long] = ACTIONS(2867),
    [anon_sym_short] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2867),
    [anon_sym_register] = ACTIONS(2867),
    [anon_sym_inline] = ACTIONS(2867),
    [anon_sym___inline] = ACTIONS(2867),
    [anon_sym___inline__] = ACTIONS(2867),
    [anon_sym___forceinline] = ACTIONS(2867),
    [anon_sym_thread_local] = ACTIONS(2867),
    [anon_sym___thread] = ACTIONS(2867),
    [anon_sym_const] = ACTIONS(2867),
    [anon_sym_constexpr] = ACTIONS(2867),
    [anon_sym_volatile] = ACTIONS(2867),
    [anon_sym_restrict] = ACTIONS(2867),
    [anon_sym___restrict__] = ACTIONS(2867),
    [anon_sym__Atomic] = ACTIONS(2867),
    [anon_sym__Noreturn] = ACTIONS(2867),
    [anon_sym_noreturn] = ACTIONS(2867),
    [anon_sym__Nonnull] = ACTIONS(2867),
    [anon_sym_mutable] = ACTIONS(2867),
    [anon_sym_constinit] = ACTIONS(2867),
    [anon_sym_consteval] = ACTIONS(2867),
    [anon_sym_alignas] = ACTIONS(2867),
    [anon_sym__Alignas] = ACTIONS(2867),
    [sym_primitive_type] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2867),
    [anon_sym_class] = ACTIONS(2867),
    [anon_sym_struct] = ACTIONS(2867),
    [anon_sym_union] = ACTIONS(2867),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2867),
    [anon_sym_decltype] = ACTIONS(2867),
    [anon_sym_explicit] = ACTIONS(2867),
    [anon_sym_typename] = ACTIONS(2867),
    [anon_sym_private] = ACTIONS(2867),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(2867),
    [anon_sym_friend] = ACTIONS(2867),
    [anon_sym_public] = ACTIONS(2867),
    [anon_sym_protected] = ACTIONS(2867),
    [anon_sym_static_assert] = ACTIONS(2867),
  },
  [1783] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6271),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6785),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6785),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1784] = {
    [sym_decltype_auto] = STATE(1884),
    [sym_identifier] = ACTIONS(5589),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(5591),
    [anon_sym_RPAREN] = ACTIONS(5591),
    [anon_sym_LPAREN2] = ACTIONS(5591),
    [anon_sym_DASH] = ACTIONS(5589),
    [anon_sym_PLUS] = ACTIONS(5589),
    [anon_sym_STAR] = ACTIONS(5591),
    [anon_sym_SLASH] = ACTIONS(5589),
    [anon_sym_PERCENT] = ACTIONS(5591),
    [anon_sym_PIPE_PIPE] = ACTIONS(5591),
    [anon_sym_AMP_AMP] = ACTIONS(5591),
    [anon_sym_PIPE] = ACTIONS(5589),
    [anon_sym_CARET] = ACTIONS(5591),
    [anon_sym_AMP] = ACTIONS(5589),
    [anon_sym_EQ_EQ] = ACTIONS(5591),
    [anon_sym_BANG_EQ] = ACTIONS(5591),
    [anon_sym_GT] = ACTIONS(5589),
    [anon_sym_GT_EQ] = ACTIONS(5591),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5589),
    [anon_sym_LT_LT] = ACTIONS(5591),
    [anon_sym_GT_GT] = ACTIONS(5591),
    [anon_sym_SEMI] = ACTIONS(5591),
    [anon_sym___extension__] = ACTIONS(5589),
    [anon_sym___attribute__] = ACTIONS(5589),
    [anon_sym___attribute] = ACTIONS(5589),
    [anon_sym_COLON] = ACTIONS(5591),
    [anon_sym___based] = ACTIONS(5589),
    [anon_sym_LBRACE] = ACTIONS(5591),
    [anon_sym_RBRACE] = ACTIONS(5591),
    [anon_sym_signed] = ACTIONS(5589),
    [anon_sym_unsigned] = ACTIONS(5589),
    [anon_sym_long] = ACTIONS(5589),
    [anon_sym_short] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(5591),
    [anon_sym_RBRACK] = ACTIONS(5591),
    [anon_sym_const] = ACTIONS(5589),
    [anon_sym_constexpr] = ACTIONS(5589),
    [anon_sym_volatile] = ACTIONS(5589),
    [anon_sym_restrict] = ACTIONS(5589),
    [anon_sym___restrict__] = ACTIONS(5589),
    [anon_sym__Atomic] = ACTIONS(5589),
    [anon_sym__Noreturn] = ACTIONS(5589),
    [anon_sym_noreturn] = ACTIONS(5589),
    [anon_sym__Nonnull] = ACTIONS(5589),
    [anon_sym_mutable] = ACTIONS(5589),
    [anon_sym_constinit] = ACTIONS(5589),
    [anon_sym_consteval] = ACTIONS(5589),
    [anon_sym_alignas] = ACTIONS(5589),
    [anon_sym__Alignas] = ACTIONS(5589),
    [sym_primitive_type] = ACTIONS(5589),
    [anon_sym_QMARK] = ACTIONS(5591),
    [anon_sym_LT_EQ_GT] = ACTIONS(5591),
    [anon_sym_or] = ACTIONS(5589),
    [anon_sym_and] = ACTIONS(5589),
    [anon_sym_bitor] = ACTIONS(5589),
    [anon_sym_xor] = ACTIONS(5589),
    [anon_sym_bitand] = ACTIONS(5589),
    [anon_sym_not_eq] = ACTIONS(5589),
    [anon_sym_DASH_DASH] = ACTIONS(5591),
    [anon_sym_PLUS_PLUS] = ACTIONS(5591),
    [anon_sym_DOT] = ACTIONS(5589),
    [anon_sym_DOT_STAR] = ACTIONS(5591),
    [anon_sym_DASH_GT] = ACTIONS(5591),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5593),
    [anon_sym_decltype] = ACTIONS(5595),
    [anon_sym_final] = ACTIONS(5589),
    [anon_sym_override] = ACTIONS(5589),
    [anon_sym_requires] = ACTIONS(5589),
  },
  [1785] = {
    [sym_identifier] = ACTIONS(5597),
    [aux_sym_preproc_def_token1] = ACTIONS(5597),
    [aux_sym_preproc_if_token1] = ACTIONS(5597),
    [aux_sym_preproc_if_token2] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5597),
    [aux_sym_preproc_else_token1] = ACTIONS(5597),
    [aux_sym_preproc_elif_token1] = ACTIONS(5597),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5597),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5597),
    [sym_preproc_directive] = ACTIONS(5597),
    [anon_sym_LPAREN2] = ACTIONS(5599),
    [anon_sym_TILDE] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(5599),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5599),
    [anon_sym___extension__] = ACTIONS(5597),
    [anon_sym_typedef] = ACTIONS(5597),
    [anon_sym_virtual] = ACTIONS(5597),
    [anon_sym_extern] = ACTIONS(5597),
    [anon_sym___attribute__] = ACTIONS(5597),
    [anon_sym___attribute] = ACTIONS(5597),
    [anon_sym_using] = ACTIONS(5597),
    [anon_sym_COLON_COLON] = ACTIONS(5599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5599),
    [anon_sym___declspec] = ACTIONS(5597),
    [anon_sym___based] = ACTIONS(5597),
    [anon_sym_signed] = ACTIONS(5597),
    [anon_sym_unsigned] = ACTIONS(5597),
    [anon_sym_long] = ACTIONS(5597),
    [anon_sym_short] = ACTIONS(5597),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [anon_sym_static] = ACTIONS(5597),
    [anon_sym_register] = ACTIONS(5597),
    [anon_sym_inline] = ACTIONS(5597),
    [anon_sym___inline] = ACTIONS(5597),
    [anon_sym___inline__] = ACTIONS(5597),
    [anon_sym___forceinline] = ACTIONS(5597),
    [anon_sym_thread_local] = ACTIONS(5597),
    [anon_sym___thread] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5597),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym___restrict__] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym__Noreturn] = ACTIONS(5597),
    [anon_sym_noreturn] = ACTIONS(5597),
    [anon_sym__Nonnull] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_constinit] = ACTIONS(5597),
    [anon_sym_consteval] = ACTIONS(5597),
    [anon_sym_alignas] = ACTIONS(5597),
    [anon_sym__Alignas] = ACTIONS(5597),
    [sym_primitive_type] = ACTIONS(5597),
    [anon_sym_enum] = ACTIONS(5597),
    [anon_sym_class] = ACTIONS(5597),
    [anon_sym_struct] = ACTIONS(5597),
    [anon_sym_union] = ACTIONS(5597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_decltype] = ACTIONS(5597),
    [anon_sym_explicit] = ACTIONS(5597),
    [anon_sym_typename] = ACTIONS(5597),
    [anon_sym_private] = ACTIONS(5597),
    [anon_sym_template] = ACTIONS(5597),
    [anon_sym_operator] = ACTIONS(5597),
    [anon_sym_friend] = ACTIONS(5597),
    [anon_sym_public] = ACTIONS(5597),
    [anon_sym_protected] = ACTIONS(5597),
    [anon_sym_static_assert] = ACTIONS(5597),
  },
  [1786] = {
    [sym_identifier] = ACTIONS(4955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4957),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_RPAREN] = ACTIONS(4957),
    [anon_sym_LPAREN2] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_SLASH] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4957),
    [anon_sym_PIPE_PIPE] = ACTIONS(4957),
    [anon_sym_AMP_AMP] = ACTIONS(4957),
    [anon_sym_PIPE] = ACTIONS(4955),
    [anon_sym_CARET] = ACTIONS(4957),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_EQ_EQ] = ACTIONS(4957),
    [anon_sym_BANG_EQ] = ACTIONS(4957),
    [anon_sym_GT] = ACTIONS(4955),
    [anon_sym_GT_EQ] = ACTIONS(4957),
    [anon_sym_LT_EQ] = ACTIONS(4955),
    [anon_sym_LT] = ACTIONS(4955),
    [anon_sym_LT_LT] = ACTIONS(4957),
    [anon_sym_GT_GT] = ACTIONS(4957),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym___extension__] = ACTIONS(4955),
    [anon_sym___attribute__] = ACTIONS(4955),
    [anon_sym___attribute] = ACTIONS(4955),
    [anon_sym_COLON] = ACTIONS(4955),
    [anon_sym_COLON_COLON] = ACTIONS(4957),
    [anon_sym___based] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(4957),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_signed] = ACTIONS(4955),
    [anon_sym_unsigned] = ACTIONS(4955),
    [anon_sym_long] = ACTIONS(4955),
    [anon_sym_short] = ACTIONS(4955),
    [anon_sym_LBRACK] = ACTIONS(4957),
    [anon_sym_RBRACK] = ACTIONS(4957),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_constexpr] = ACTIONS(4955),
    [anon_sym_volatile] = ACTIONS(4955),
    [anon_sym_restrict] = ACTIONS(4955),
    [anon_sym___restrict__] = ACTIONS(4955),
    [anon_sym__Atomic] = ACTIONS(4955),
    [anon_sym__Noreturn] = ACTIONS(4955),
    [anon_sym_noreturn] = ACTIONS(4955),
    [anon_sym__Nonnull] = ACTIONS(4955),
    [anon_sym_mutable] = ACTIONS(4955),
    [anon_sym_constinit] = ACTIONS(4955),
    [anon_sym_consteval] = ACTIONS(4955),
    [anon_sym_alignas] = ACTIONS(4955),
    [anon_sym__Alignas] = ACTIONS(4955),
    [sym_primitive_type] = ACTIONS(4955),
    [anon_sym_QMARK] = ACTIONS(4957),
    [anon_sym_LT_EQ_GT] = ACTIONS(4957),
    [anon_sym_or] = ACTIONS(4955),
    [anon_sym_and] = ACTIONS(4955),
    [anon_sym_bitor] = ACTIONS(4955),
    [anon_sym_xor] = ACTIONS(4955),
    [anon_sym_bitand] = ACTIONS(4955),
    [anon_sym_not_eq] = ACTIONS(4955),
    [anon_sym_DASH_DASH] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4957),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_DOT_STAR] = ACTIONS(4957),
    [anon_sym_DASH_GT] = ACTIONS(4957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4955),
    [anon_sym_decltype] = ACTIONS(4955),
    [anon_sym_final] = ACTIONS(4955),
    [anon_sym_override] = ACTIONS(4955),
    [anon_sym_requires] = ACTIONS(4955),
  },
  [1787] = {
    [sym_identifier] = ACTIONS(2931),
    [aux_sym_preproc_def_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token2] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2931),
    [aux_sym_preproc_else_token1] = ACTIONS(2931),
    [aux_sym_preproc_elif_token1] = ACTIONS(2931),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2931),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2931),
    [sym_preproc_directive] = ACTIONS(2931),
    [anon_sym_LPAREN2] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym___extension__] = ACTIONS(2931),
    [anon_sym_typedef] = ACTIONS(2931),
    [anon_sym_virtual] = ACTIONS(2931),
    [anon_sym_extern] = ACTIONS(2931),
    [anon_sym___attribute__] = ACTIONS(2931),
    [anon_sym___attribute] = ACTIONS(2931),
    [anon_sym_using] = ACTIONS(2931),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2933),
    [anon_sym___declspec] = ACTIONS(2931),
    [anon_sym___based] = ACTIONS(2931),
    [anon_sym_signed] = ACTIONS(2931),
    [anon_sym_unsigned] = ACTIONS(2931),
    [anon_sym_long] = ACTIONS(2931),
    [anon_sym_short] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_register] = ACTIONS(2931),
    [anon_sym_inline] = ACTIONS(2931),
    [anon_sym___inline] = ACTIONS(2931),
    [anon_sym___inline__] = ACTIONS(2931),
    [anon_sym___forceinline] = ACTIONS(2931),
    [anon_sym_thread_local] = ACTIONS(2931),
    [anon_sym___thread] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_constexpr] = ACTIONS(2931),
    [anon_sym_volatile] = ACTIONS(2931),
    [anon_sym_restrict] = ACTIONS(2931),
    [anon_sym___restrict__] = ACTIONS(2931),
    [anon_sym__Atomic] = ACTIONS(2931),
    [anon_sym__Noreturn] = ACTIONS(2931),
    [anon_sym_noreturn] = ACTIONS(2931),
    [anon_sym__Nonnull] = ACTIONS(2931),
    [anon_sym_mutable] = ACTIONS(2931),
    [anon_sym_constinit] = ACTIONS(2931),
    [anon_sym_consteval] = ACTIONS(2931),
    [anon_sym_alignas] = ACTIONS(2931),
    [anon_sym__Alignas] = ACTIONS(2931),
    [sym_primitive_type] = ACTIONS(2931),
    [anon_sym_enum] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2931),
    [anon_sym_struct] = ACTIONS(2931),
    [anon_sym_union] = ACTIONS(2931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2931),
    [anon_sym_decltype] = ACTIONS(2931),
    [anon_sym_explicit] = ACTIONS(2931),
    [anon_sym_typename] = ACTIONS(2931),
    [anon_sym_private] = ACTIONS(2931),
    [anon_sym_template] = ACTIONS(2931),
    [anon_sym_operator] = ACTIONS(2931),
    [anon_sym_friend] = ACTIONS(2931),
    [anon_sym_public] = ACTIONS(2931),
    [anon_sym_protected] = ACTIONS(2931),
    [anon_sym_static_assert] = ACTIONS(2931),
  },
  [1788] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token2] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [aux_sym_preproc_else_token1] = ACTIONS(2883),
    [aux_sym_preproc_elif_token1] = ACTIONS(2883),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2885),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_private] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_friend] = ACTIONS(2883),
    [anon_sym_public] = ACTIONS(2883),
    [anon_sym_protected] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
  },
  [1789] = {
    [sym_identifier] = ACTIONS(5601),
    [aux_sym_preproc_def_token1] = ACTIONS(5601),
    [aux_sym_preproc_if_token1] = ACTIONS(5601),
    [aux_sym_preproc_if_token2] = ACTIONS(5601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5601),
    [aux_sym_preproc_else_token1] = ACTIONS(5601),
    [aux_sym_preproc_elif_token1] = ACTIONS(5601),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5601),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5601),
    [sym_preproc_directive] = ACTIONS(5601),
    [anon_sym_LPAREN2] = ACTIONS(5603),
    [anon_sym_TILDE] = ACTIONS(5603),
    [anon_sym_STAR] = ACTIONS(5603),
    [anon_sym_AMP_AMP] = ACTIONS(5603),
    [anon_sym_AMP] = ACTIONS(5601),
    [anon_sym_SEMI] = ACTIONS(5603),
    [anon_sym___extension__] = ACTIONS(5601),
    [anon_sym_typedef] = ACTIONS(5601),
    [anon_sym_virtual] = ACTIONS(5601),
    [anon_sym_extern] = ACTIONS(5601),
    [anon_sym___attribute__] = ACTIONS(5601),
    [anon_sym___attribute] = ACTIONS(5601),
    [anon_sym_using] = ACTIONS(5601),
    [anon_sym_COLON_COLON] = ACTIONS(5603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5603),
    [anon_sym___declspec] = ACTIONS(5601),
    [anon_sym___based] = ACTIONS(5601),
    [anon_sym_signed] = ACTIONS(5601),
    [anon_sym_unsigned] = ACTIONS(5601),
    [anon_sym_long] = ACTIONS(5601),
    [anon_sym_short] = ACTIONS(5601),
    [anon_sym_LBRACK] = ACTIONS(5601),
    [anon_sym_static] = ACTIONS(5601),
    [anon_sym_register] = ACTIONS(5601),
    [anon_sym_inline] = ACTIONS(5601),
    [anon_sym___inline] = ACTIONS(5601),
    [anon_sym___inline__] = ACTIONS(5601),
    [anon_sym___forceinline] = ACTIONS(5601),
    [anon_sym_thread_local] = ACTIONS(5601),
    [anon_sym___thread] = ACTIONS(5601),
    [anon_sym_const] = ACTIONS(5601),
    [anon_sym_constexpr] = ACTIONS(5601),
    [anon_sym_volatile] = ACTIONS(5601),
    [anon_sym_restrict] = ACTIONS(5601),
    [anon_sym___restrict__] = ACTIONS(5601),
    [anon_sym__Atomic] = ACTIONS(5601),
    [anon_sym__Noreturn] = ACTIONS(5601),
    [anon_sym_noreturn] = ACTIONS(5601),
    [anon_sym__Nonnull] = ACTIONS(5601),
    [anon_sym_mutable] = ACTIONS(5601),
    [anon_sym_constinit] = ACTIONS(5601),
    [anon_sym_consteval] = ACTIONS(5601),
    [anon_sym_alignas] = ACTIONS(5601),
    [anon_sym__Alignas] = ACTIONS(5601),
    [sym_primitive_type] = ACTIONS(5601),
    [anon_sym_enum] = ACTIONS(5601),
    [anon_sym_class] = ACTIONS(5601),
    [anon_sym_struct] = ACTIONS(5601),
    [anon_sym_union] = ACTIONS(5601),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5601),
    [anon_sym_decltype] = ACTIONS(5601),
    [anon_sym_explicit] = ACTIONS(5601),
    [anon_sym_typename] = ACTIONS(5601),
    [anon_sym_private] = ACTIONS(5601),
    [anon_sym_template] = ACTIONS(5601),
    [anon_sym_operator] = ACTIONS(5601),
    [anon_sym_friend] = ACTIONS(5601),
    [anon_sym_public] = ACTIONS(5601),
    [anon_sym_protected] = ACTIONS(5601),
    [anon_sym_static_assert] = ACTIONS(5601),
  },
  [1790] = {
    [sym_identifier] = ACTIONS(5605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5607),
    [anon_sym_COMMA] = ACTIONS(5607),
    [anon_sym_RPAREN] = ACTIONS(5607),
    [anon_sym_LPAREN2] = ACTIONS(5607),
    [anon_sym_DASH] = ACTIONS(5605),
    [anon_sym_PLUS] = ACTIONS(5605),
    [anon_sym_STAR] = ACTIONS(5607),
    [anon_sym_SLASH] = ACTIONS(5605),
    [anon_sym_PERCENT] = ACTIONS(5607),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_AMP_AMP] = ACTIONS(5607),
    [anon_sym_PIPE] = ACTIONS(5605),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_AMP] = ACTIONS(5605),
    [anon_sym_EQ_EQ] = ACTIONS(5607),
    [anon_sym_BANG_EQ] = ACTIONS(5607),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5607),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_LT_LT] = ACTIONS(5607),
    [anon_sym_GT_GT] = ACTIONS(5607),
    [anon_sym_SEMI] = ACTIONS(5607),
    [anon_sym___extension__] = ACTIONS(5605),
    [anon_sym___attribute__] = ACTIONS(5605),
    [anon_sym___attribute] = ACTIONS(5605),
    [anon_sym_COLON] = ACTIONS(5605),
    [anon_sym_COLON_COLON] = ACTIONS(5607),
    [anon_sym___based] = ACTIONS(5605),
    [anon_sym_LBRACE] = ACTIONS(5607),
    [anon_sym_RBRACE] = ACTIONS(5607),
    [anon_sym_signed] = ACTIONS(5605),
    [anon_sym_unsigned] = ACTIONS(5605),
    [anon_sym_long] = ACTIONS(5605),
    [anon_sym_short] = ACTIONS(5605),
    [anon_sym_LBRACK] = ACTIONS(5607),
    [anon_sym_RBRACK] = ACTIONS(5607),
    [anon_sym_const] = ACTIONS(5605),
    [anon_sym_constexpr] = ACTIONS(5605),
    [anon_sym_volatile] = ACTIONS(5605),
    [anon_sym_restrict] = ACTIONS(5605),
    [anon_sym___restrict__] = ACTIONS(5605),
    [anon_sym__Atomic] = ACTIONS(5605),
    [anon_sym__Noreturn] = ACTIONS(5605),
    [anon_sym_noreturn] = ACTIONS(5605),
    [anon_sym__Nonnull] = ACTIONS(5605),
    [anon_sym_mutable] = ACTIONS(5605),
    [anon_sym_constinit] = ACTIONS(5605),
    [anon_sym_consteval] = ACTIONS(5605),
    [anon_sym_alignas] = ACTIONS(5605),
    [anon_sym__Alignas] = ACTIONS(5605),
    [sym_primitive_type] = ACTIONS(5605),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_LT_EQ_GT] = ACTIONS(5607),
    [anon_sym_or] = ACTIONS(5605),
    [anon_sym_and] = ACTIONS(5605),
    [anon_sym_bitor] = ACTIONS(5605),
    [anon_sym_xor] = ACTIONS(5605),
    [anon_sym_bitand] = ACTIONS(5605),
    [anon_sym_not_eq] = ACTIONS(5605),
    [anon_sym_DASH_DASH] = ACTIONS(5607),
    [anon_sym_PLUS_PLUS] = ACTIONS(5607),
    [anon_sym_DOT] = ACTIONS(5605),
    [anon_sym_DOT_STAR] = ACTIONS(5607),
    [anon_sym_DASH_GT] = ACTIONS(5607),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5605),
    [anon_sym_decltype] = ACTIONS(5605),
    [anon_sym_final] = ACTIONS(5605),
    [anon_sym_override] = ACTIONS(5605),
    [anon_sym_requires] = ACTIONS(5605),
  },
  [1791] = {
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token2] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [aux_sym_preproc_else_token1] = ACTIONS(2759),
    [aux_sym_preproc_elif_token1] = ACTIONS(2759),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_private] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_friend] = ACTIONS(2759),
    [anon_sym_public] = ACTIONS(2759),
    [anon_sym_protected] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
  },
  [1792] = {
    [sym_identifier] = ACTIONS(3309),
    [aux_sym_preproc_def_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token2] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3309),
    [aux_sym_preproc_else_token1] = ACTIONS(3309),
    [aux_sym_preproc_elif_token1] = ACTIONS(3309),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3309),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3309),
    [sym_preproc_directive] = ACTIONS(3309),
    [anon_sym_LPAREN2] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_AMP_AMP] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym___extension__] = ACTIONS(3309),
    [anon_sym_typedef] = ACTIONS(3309),
    [anon_sym_virtual] = ACTIONS(3309),
    [anon_sym_extern] = ACTIONS(3309),
    [anon_sym___attribute__] = ACTIONS(3309),
    [anon_sym___attribute] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_COLON_COLON] = ACTIONS(3311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3311),
    [anon_sym___declspec] = ACTIONS(3309),
    [anon_sym___based] = ACTIONS(3309),
    [anon_sym_signed] = ACTIONS(3309),
    [anon_sym_unsigned] = ACTIONS(3309),
    [anon_sym_long] = ACTIONS(3309),
    [anon_sym_short] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_register] = ACTIONS(3309),
    [anon_sym_inline] = ACTIONS(3309),
    [anon_sym___inline] = ACTIONS(3309),
    [anon_sym___inline__] = ACTIONS(3309),
    [anon_sym___forceinline] = ACTIONS(3309),
    [anon_sym_thread_local] = ACTIONS(3309),
    [anon_sym___thread] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_constexpr] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(3309),
    [anon_sym_restrict] = ACTIONS(3309),
    [anon_sym___restrict__] = ACTIONS(3309),
    [anon_sym__Atomic] = ACTIONS(3309),
    [anon_sym__Noreturn] = ACTIONS(3309),
    [anon_sym_noreturn] = ACTIONS(3309),
    [anon_sym__Nonnull] = ACTIONS(3309),
    [anon_sym_mutable] = ACTIONS(3309),
    [anon_sym_constinit] = ACTIONS(3309),
    [anon_sym_consteval] = ACTIONS(3309),
    [anon_sym_alignas] = ACTIONS(3309),
    [anon_sym__Alignas] = ACTIONS(3309),
    [sym_primitive_type] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_struct] = ACTIONS(3309),
    [anon_sym_union] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3309),
    [anon_sym_decltype] = ACTIONS(3309),
    [anon_sym_explicit] = ACTIONS(3309),
    [anon_sym_typename] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_template] = ACTIONS(3309),
    [anon_sym_operator] = ACTIONS(3309),
    [anon_sym_friend] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_static_assert] = ACTIONS(3309),
  },
  [1793] = {
    [sym_identifier] = ACTIONS(5609),
    [aux_sym_preproc_def_token1] = ACTIONS(5609),
    [aux_sym_preproc_if_token1] = ACTIONS(5609),
    [aux_sym_preproc_if_token2] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5609),
    [aux_sym_preproc_else_token1] = ACTIONS(5609),
    [aux_sym_preproc_elif_token1] = ACTIONS(5609),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5609),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5609),
    [sym_preproc_directive] = ACTIONS(5609),
    [anon_sym_LPAREN2] = ACTIONS(5611),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_STAR] = ACTIONS(5611),
    [anon_sym_AMP_AMP] = ACTIONS(5611),
    [anon_sym_AMP] = ACTIONS(5609),
    [anon_sym_SEMI] = ACTIONS(5611),
    [anon_sym___extension__] = ACTIONS(5609),
    [anon_sym_typedef] = ACTIONS(5609),
    [anon_sym_virtual] = ACTIONS(5609),
    [anon_sym_extern] = ACTIONS(5609),
    [anon_sym___attribute__] = ACTIONS(5609),
    [anon_sym___attribute] = ACTIONS(5609),
    [anon_sym_using] = ACTIONS(5609),
    [anon_sym_COLON_COLON] = ACTIONS(5611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5611),
    [anon_sym___declspec] = ACTIONS(5609),
    [anon_sym___based] = ACTIONS(5609),
    [anon_sym_signed] = ACTIONS(5609),
    [anon_sym_unsigned] = ACTIONS(5609),
    [anon_sym_long] = ACTIONS(5609),
    [anon_sym_short] = ACTIONS(5609),
    [anon_sym_LBRACK] = ACTIONS(5609),
    [anon_sym_static] = ACTIONS(5609),
    [anon_sym_register] = ACTIONS(5609),
    [anon_sym_inline] = ACTIONS(5609),
    [anon_sym___inline] = ACTIONS(5609),
    [anon_sym___inline__] = ACTIONS(5609),
    [anon_sym___forceinline] = ACTIONS(5609),
    [anon_sym_thread_local] = ACTIONS(5609),
    [anon_sym___thread] = ACTIONS(5609),
    [anon_sym_const] = ACTIONS(5609),
    [anon_sym_constexpr] = ACTIONS(5609),
    [anon_sym_volatile] = ACTIONS(5609),
    [anon_sym_restrict] = ACTIONS(5609),
    [anon_sym___restrict__] = ACTIONS(5609),
    [anon_sym__Atomic] = ACTIONS(5609),
    [anon_sym__Noreturn] = ACTIONS(5609),
    [anon_sym_noreturn] = ACTIONS(5609),
    [anon_sym__Nonnull] = ACTIONS(5609),
    [anon_sym_mutable] = ACTIONS(5609),
    [anon_sym_constinit] = ACTIONS(5609),
    [anon_sym_consteval] = ACTIONS(5609),
    [anon_sym_alignas] = ACTIONS(5609),
    [anon_sym__Alignas] = ACTIONS(5609),
    [sym_primitive_type] = ACTIONS(5609),
    [anon_sym_enum] = ACTIONS(5609),
    [anon_sym_class] = ACTIONS(5609),
    [anon_sym_struct] = ACTIONS(5609),
    [anon_sym_union] = ACTIONS(5609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5609),
    [anon_sym_decltype] = ACTIONS(5609),
    [anon_sym_explicit] = ACTIONS(5609),
    [anon_sym_typename] = ACTIONS(5609),
    [anon_sym_private] = ACTIONS(5609),
    [anon_sym_template] = ACTIONS(5609),
    [anon_sym_operator] = ACTIONS(5609),
    [anon_sym_friend] = ACTIONS(5609),
    [anon_sym_public] = ACTIONS(5609),
    [anon_sym_protected] = ACTIONS(5609),
    [anon_sym_static_assert] = ACTIONS(5609),
  },
  [1794] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [aux_sym_preproc_else_token1] = ACTIONS(2767),
    [aux_sym_preproc_elif_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(2767),
    [anon_sym_public] = ACTIONS(2767),
    [anon_sym_protected] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
  },
  [1795] = {
    [sym_identifier] = ACTIONS(5613),
    [aux_sym_preproc_def_token1] = ACTIONS(5613),
    [aux_sym_preproc_if_token1] = ACTIONS(5613),
    [aux_sym_preproc_if_token2] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5613),
    [aux_sym_preproc_else_token1] = ACTIONS(5613),
    [aux_sym_preproc_elif_token1] = ACTIONS(5613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5613),
    [sym_preproc_directive] = ACTIONS(5613),
    [anon_sym_LPAREN2] = ACTIONS(5615),
    [anon_sym_TILDE] = ACTIONS(5615),
    [anon_sym_STAR] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5613),
    [anon_sym_SEMI] = ACTIONS(5615),
    [anon_sym___extension__] = ACTIONS(5613),
    [anon_sym_typedef] = ACTIONS(5613),
    [anon_sym_virtual] = ACTIONS(5613),
    [anon_sym_extern] = ACTIONS(5613),
    [anon_sym___attribute__] = ACTIONS(5613),
    [anon_sym___attribute] = ACTIONS(5613),
    [anon_sym_using] = ACTIONS(5613),
    [anon_sym_COLON_COLON] = ACTIONS(5615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5615),
    [anon_sym___declspec] = ACTIONS(5613),
    [anon_sym___based] = ACTIONS(5613),
    [anon_sym_signed] = ACTIONS(5613),
    [anon_sym_unsigned] = ACTIONS(5613),
    [anon_sym_long] = ACTIONS(5613),
    [anon_sym_short] = ACTIONS(5613),
    [anon_sym_LBRACK] = ACTIONS(5613),
    [anon_sym_static] = ACTIONS(5613),
    [anon_sym_register] = ACTIONS(5613),
    [anon_sym_inline] = ACTIONS(5613),
    [anon_sym___inline] = ACTIONS(5613),
    [anon_sym___inline__] = ACTIONS(5613),
    [anon_sym___forceinline] = ACTIONS(5613),
    [anon_sym_thread_local] = ACTIONS(5613),
    [anon_sym___thread] = ACTIONS(5613),
    [anon_sym_const] = ACTIONS(5613),
    [anon_sym_constexpr] = ACTIONS(5613),
    [anon_sym_volatile] = ACTIONS(5613),
    [anon_sym_restrict] = ACTIONS(5613),
    [anon_sym___restrict__] = ACTIONS(5613),
    [anon_sym__Atomic] = ACTIONS(5613),
    [anon_sym__Noreturn] = ACTIONS(5613),
    [anon_sym_noreturn] = ACTIONS(5613),
    [anon_sym__Nonnull] = ACTIONS(5613),
    [anon_sym_mutable] = ACTIONS(5613),
    [anon_sym_constinit] = ACTIONS(5613),
    [anon_sym_consteval] = ACTIONS(5613),
    [anon_sym_alignas] = ACTIONS(5613),
    [anon_sym__Alignas] = ACTIONS(5613),
    [sym_primitive_type] = ACTIONS(5613),
    [anon_sym_enum] = ACTIONS(5613),
    [anon_sym_class] = ACTIONS(5613),
    [anon_sym_struct] = ACTIONS(5613),
    [anon_sym_union] = ACTIONS(5613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5613),
    [anon_sym_decltype] = ACTIONS(5613),
    [anon_sym_explicit] = ACTIONS(5613),
    [anon_sym_typename] = ACTIONS(5613),
    [anon_sym_private] = ACTIONS(5613),
    [anon_sym_template] = ACTIONS(5613),
    [anon_sym_operator] = ACTIONS(5613),
    [anon_sym_friend] = ACTIONS(5613),
    [anon_sym_public] = ACTIONS(5613),
    [anon_sym_protected] = ACTIONS(5613),
    [anon_sym_static_assert] = ACTIONS(5613),
  },
  [1796] = {
    [sym_identifier] = ACTIONS(2775),
    [aux_sym_preproc_def_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token2] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2775),
    [aux_sym_preproc_else_token1] = ACTIONS(2775),
    [aux_sym_preproc_elif_token1] = ACTIONS(2775),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2775),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2775),
    [sym_preproc_directive] = ACTIONS(2775),
    [anon_sym_LPAREN2] = ACTIONS(2777),
    [anon_sym_TILDE] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym___extension__] = ACTIONS(2775),
    [anon_sym_typedef] = ACTIONS(2775),
    [anon_sym_virtual] = ACTIONS(2775),
    [anon_sym_extern] = ACTIONS(2775),
    [anon_sym___attribute__] = ACTIONS(2775),
    [anon_sym___attribute] = ACTIONS(2775),
    [anon_sym_using] = ACTIONS(2775),
    [anon_sym_COLON_COLON] = ACTIONS(2777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2777),
    [anon_sym___declspec] = ACTIONS(2775),
    [anon_sym___based] = ACTIONS(2775),
    [anon_sym_signed] = ACTIONS(2775),
    [anon_sym_unsigned] = ACTIONS(2775),
    [anon_sym_long] = ACTIONS(2775),
    [anon_sym_short] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_static] = ACTIONS(2775),
    [anon_sym_register] = ACTIONS(2775),
    [anon_sym_inline] = ACTIONS(2775),
    [anon_sym___inline] = ACTIONS(2775),
    [anon_sym___inline__] = ACTIONS(2775),
    [anon_sym___forceinline] = ACTIONS(2775),
    [anon_sym_thread_local] = ACTIONS(2775),
    [anon_sym___thread] = ACTIONS(2775),
    [anon_sym_const] = ACTIONS(2775),
    [anon_sym_constexpr] = ACTIONS(2775),
    [anon_sym_volatile] = ACTIONS(2775),
    [anon_sym_restrict] = ACTIONS(2775),
    [anon_sym___restrict__] = ACTIONS(2775),
    [anon_sym__Atomic] = ACTIONS(2775),
    [anon_sym__Noreturn] = ACTIONS(2775),
    [anon_sym_noreturn] = ACTIONS(2775),
    [anon_sym__Nonnull] = ACTIONS(2775),
    [anon_sym_mutable] = ACTIONS(2775),
    [anon_sym_constinit] = ACTIONS(2775),
    [anon_sym_consteval] = ACTIONS(2775),
    [anon_sym_alignas] = ACTIONS(2775),
    [anon_sym__Alignas] = ACTIONS(2775),
    [sym_primitive_type] = ACTIONS(2775),
    [anon_sym_enum] = ACTIONS(2775),
    [anon_sym_class] = ACTIONS(2775),
    [anon_sym_struct] = ACTIONS(2775),
    [anon_sym_union] = ACTIONS(2775),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2775),
    [anon_sym_decltype] = ACTIONS(2775),
    [anon_sym_explicit] = ACTIONS(2775),
    [anon_sym_typename] = ACTIONS(2775),
    [anon_sym_private] = ACTIONS(2775),
    [anon_sym_template] = ACTIONS(2775),
    [anon_sym_operator] = ACTIONS(2775),
    [anon_sym_friend] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2775),
    [anon_sym_protected] = ACTIONS(2775),
    [anon_sym_static_assert] = ACTIONS(2775),
  },
  [1797] = {
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token2] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [aux_sym_preproc_else_token1] = ACTIONS(2779),
    [aux_sym_preproc_elif_token1] = ACTIONS(2779),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym___attribute] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym__Nonnull] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym__Alignas] = ACTIONS(2779),
    [sym_primitive_type] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_private] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_friend] = ACTIONS(2779),
    [anon_sym_public] = ACTIONS(2779),
    [anon_sym_protected] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
  },
  [1798] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token2] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [aux_sym_preproc_else_token1] = ACTIONS(2783),
    [aux_sym_preproc_elif_token1] = ACTIONS(2783),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym___attribute] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym__Nonnull] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym__Alignas] = ACTIONS(2783),
    [sym_primitive_type] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_private] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_friend] = ACTIONS(2783),
    [anon_sym_public] = ACTIONS(2783),
    [anon_sym_protected] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
  },
  [1799] = {
    [sym_identifier] = ACTIONS(5597),
    [aux_sym_preproc_def_token1] = ACTIONS(5597),
    [aux_sym_preproc_if_token1] = ACTIONS(5597),
    [aux_sym_preproc_if_token2] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5597),
    [aux_sym_preproc_else_token1] = ACTIONS(5597),
    [aux_sym_preproc_elif_token1] = ACTIONS(5597),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5597),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5597),
    [sym_preproc_directive] = ACTIONS(5597),
    [anon_sym_LPAREN2] = ACTIONS(5599),
    [anon_sym_TILDE] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(5599),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5599),
    [anon_sym___extension__] = ACTIONS(5597),
    [anon_sym_typedef] = ACTIONS(5597),
    [anon_sym_virtual] = ACTIONS(5597),
    [anon_sym_extern] = ACTIONS(5597),
    [anon_sym___attribute__] = ACTIONS(5597),
    [anon_sym___attribute] = ACTIONS(5597),
    [anon_sym_using] = ACTIONS(5597),
    [anon_sym_COLON_COLON] = ACTIONS(5599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5599),
    [anon_sym___declspec] = ACTIONS(5597),
    [anon_sym___based] = ACTIONS(5597),
    [anon_sym_signed] = ACTIONS(5597),
    [anon_sym_unsigned] = ACTIONS(5597),
    [anon_sym_long] = ACTIONS(5597),
    [anon_sym_short] = ACTIONS(5597),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [anon_sym_static] = ACTIONS(5597),
    [anon_sym_register] = ACTIONS(5597),
    [anon_sym_inline] = ACTIONS(5597),
    [anon_sym___inline] = ACTIONS(5597),
    [anon_sym___inline__] = ACTIONS(5597),
    [anon_sym___forceinline] = ACTIONS(5597),
    [anon_sym_thread_local] = ACTIONS(5597),
    [anon_sym___thread] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5597),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym___restrict__] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym__Noreturn] = ACTIONS(5597),
    [anon_sym_noreturn] = ACTIONS(5597),
    [anon_sym__Nonnull] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_constinit] = ACTIONS(5597),
    [anon_sym_consteval] = ACTIONS(5597),
    [anon_sym_alignas] = ACTIONS(5597),
    [anon_sym__Alignas] = ACTIONS(5597),
    [sym_primitive_type] = ACTIONS(5597),
    [anon_sym_enum] = ACTIONS(5597),
    [anon_sym_class] = ACTIONS(5597),
    [anon_sym_struct] = ACTIONS(5597),
    [anon_sym_union] = ACTIONS(5597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_decltype] = ACTIONS(5597),
    [anon_sym_explicit] = ACTIONS(5597),
    [anon_sym_typename] = ACTIONS(5597),
    [anon_sym_private] = ACTIONS(5597),
    [anon_sym_template] = ACTIONS(5597),
    [anon_sym_operator] = ACTIONS(5597),
    [anon_sym_friend] = ACTIONS(5597),
    [anon_sym_public] = ACTIONS(5597),
    [anon_sym_protected] = ACTIONS(5597),
    [anon_sym_static_assert] = ACTIONS(5597),
  },
  [1800] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6345),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6835),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6835),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1801] = {
    [sym_identifier] = ACTIONS(2787),
    [aux_sym_preproc_def_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token2] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2787),
    [aux_sym_preproc_else_token1] = ACTIONS(2787),
    [aux_sym_preproc_elif_token1] = ACTIONS(2787),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2787),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2787),
    [sym_preproc_directive] = ACTIONS(2787),
    [anon_sym_LPAREN2] = ACTIONS(2789),
    [anon_sym_TILDE] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym___extension__] = ACTIONS(2787),
    [anon_sym_typedef] = ACTIONS(2787),
    [anon_sym_virtual] = ACTIONS(2787),
    [anon_sym_extern] = ACTIONS(2787),
    [anon_sym___attribute__] = ACTIONS(2787),
    [anon_sym___attribute] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2789),
    [anon_sym___declspec] = ACTIONS(2787),
    [anon_sym___based] = ACTIONS(2787),
    [anon_sym_signed] = ACTIONS(2787),
    [anon_sym_unsigned] = ACTIONS(2787),
    [anon_sym_long] = ACTIONS(2787),
    [anon_sym_short] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_static] = ACTIONS(2787),
    [anon_sym_register] = ACTIONS(2787),
    [anon_sym_inline] = ACTIONS(2787),
    [anon_sym___inline] = ACTIONS(2787),
    [anon_sym___inline__] = ACTIONS(2787),
    [anon_sym___forceinline] = ACTIONS(2787),
    [anon_sym_thread_local] = ACTIONS(2787),
    [anon_sym___thread] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_constexpr] = ACTIONS(2787),
    [anon_sym_volatile] = ACTIONS(2787),
    [anon_sym_restrict] = ACTIONS(2787),
    [anon_sym___restrict__] = ACTIONS(2787),
    [anon_sym__Atomic] = ACTIONS(2787),
    [anon_sym__Noreturn] = ACTIONS(2787),
    [anon_sym_noreturn] = ACTIONS(2787),
    [anon_sym__Nonnull] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_constinit] = ACTIONS(2787),
    [anon_sym_consteval] = ACTIONS(2787),
    [anon_sym_alignas] = ACTIONS(2787),
    [anon_sym__Alignas] = ACTIONS(2787),
    [sym_primitive_type] = ACTIONS(2787),
    [anon_sym_enum] = ACTIONS(2787),
    [anon_sym_class] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_union] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2787),
    [anon_sym_decltype] = ACTIONS(2787),
    [anon_sym_explicit] = ACTIONS(2787),
    [anon_sym_typename] = ACTIONS(2787),
    [anon_sym_private] = ACTIONS(2787),
    [anon_sym_template] = ACTIONS(2787),
    [anon_sym_operator] = ACTIONS(2787),
    [anon_sym_friend] = ACTIONS(2787),
    [anon_sym_public] = ACTIONS(2787),
    [anon_sym_protected] = ACTIONS(2787),
    [anon_sym_static_assert] = ACTIONS(2787),
  },
  [1802] = {
    [sym_identifier] = ACTIONS(2791),
    [aux_sym_preproc_def_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token2] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2791),
    [aux_sym_preproc_else_token1] = ACTIONS(2791),
    [aux_sym_preproc_elif_token1] = ACTIONS(2791),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2791),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2791),
    [sym_preproc_directive] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2793),
    [anon_sym_TILDE] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym___extension__] = ACTIONS(2791),
    [anon_sym_typedef] = ACTIONS(2791),
    [anon_sym_virtual] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym___attribute__] = ACTIONS(2791),
    [anon_sym___attribute] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2793),
    [anon_sym___declspec] = ACTIONS(2791),
    [anon_sym___based] = ACTIONS(2791),
    [anon_sym_signed] = ACTIONS(2791),
    [anon_sym_unsigned] = ACTIONS(2791),
    [anon_sym_long] = ACTIONS(2791),
    [anon_sym_short] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_register] = ACTIONS(2791),
    [anon_sym_inline] = ACTIONS(2791),
    [anon_sym___inline] = ACTIONS(2791),
    [anon_sym___inline__] = ACTIONS(2791),
    [anon_sym___forceinline] = ACTIONS(2791),
    [anon_sym_thread_local] = ACTIONS(2791),
    [anon_sym___thread] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_constexpr] = ACTIONS(2791),
    [anon_sym_volatile] = ACTIONS(2791),
    [anon_sym_restrict] = ACTIONS(2791),
    [anon_sym___restrict__] = ACTIONS(2791),
    [anon_sym__Atomic] = ACTIONS(2791),
    [anon_sym__Noreturn] = ACTIONS(2791),
    [anon_sym_noreturn] = ACTIONS(2791),
    [anon_sym__Nonnull] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_constinit] = ACTIONS(2791),
    [anon_sym_consteval] = ACTIONS(2791),
    [anon_sym_alignas] = ACTIONS(2791),
    [anon_sym__Alignas] = ACTIONS(2791),
    [sym_primitive_type] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_class] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2791),
    [anon_sym_decltype] = ACTIONS(2791),
    [anon_sym_explicit] = ACTIONS(2791),
    [anon_sym_typename] = ACTIONS(2791),
    [anon_sym_private] = ACTIONS(2791),
    [anon_sym_template] = ACTIONS(2791),
    [anon_sym_operator] = ACTIONS(2791),
    [anon_sym_friend] = ACTIONS(2791),
    [anon_sym_public] = ACTIONS(2791),
    [anon_sym_protected] = ACTIONS(2791),
    [anon_sym_static_assert] = ACTIONS(2791),
  },
  [1803] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [aux_sym_preproc_else_token1] = ACTIONS(2767),
    [aux_sym_preproc_elif_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(2767),
    [anon_sym_public] = ACTIONS(2767),
    [anon_sym_protected] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
  },
  [1804] = {
    [sym_identifier] = ACTIONS(3089),
    [aux_sym_preproc_def_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token2] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3089),
    [aux_sym_preproc_else_token1] = ACTIONS(3089),
    [aux_sym_preproc_elif_token1] = ACTIONS(3089),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3089),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3089),
    [sym_preproc_directive] = ACTIONS(3089),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_STAR] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym___extension__] = ACTIONS(3089),
    [anon_sym_typedef] = ACTIONS(3089),
    [anon_sym_virtual] = ACTIONS(3089),
    [anon_sym_extern] = ACTIONS(3089),
    [anon_sym___attribute__] = ACTIONS(3089),
    [anon_sym___attribute] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_COLON_COLON] = ACTIONS(3091),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3091),
    [anon_sym___declspec] = ACTIONS(3089),
    [anon_sym___based] = ACTIONS(3089),
    [anon_sym_signed] = ACTIONS(3089),
    [anon_sym_unsigned] = ACTIONS(3089),
    [anon_sym_long] = ACTIONS(3089),
    [anon_sym_short] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3089),
    [anon_sym_register] = ACTIONS(3089),
    [anon_sym_inline] = ACTIONS(3089),
    [anon_sym___inline] = ACTIONS(3089),
    [anon_sym___inline__] = ACTIONS(3089),
    [anon_sym___forceinline] = ACTIONS(3089),
    [anon_sym_thread_local] = ACTIONS(3089),
    [anon_sym___thread] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_constexpr] = ACTIONS(3089),
    [anon_sym_volatile] = ACTIONS(3089),
    [anon_sym_restrict] = ACTIONS(3089),
    [anon_sym___restrict__] = ACTIONS(3089),
    [anon_sym__Atomic] = ACTIONS(3089),
    [anon_sym__Noreturn] = ACTIONS(3089),
    [anon_sym_noreturn] = ACTIONS(3089),
    [anon_sym__Nonnull] = ACTIONS(3089),
    [anon_sym_mutable] = ACTIONS(3089),
    [anon_sym_constinit] = ACTIONS(3089),
    [anon_sym_consteval] = ACTIONS(3089),
    [anon_sym_alignas] = ACTIONS(3089),
    [anon_sym__Alignas] = ACTIONS(3089),
    [sym_primitive_type] = ACTIONS(3089),
    [anon_sym_enum] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_union] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3089),
    [anon_sym_decltype] = ACTIONS(3089),
    [anon_sym_explicit] = ACTIONS(3089),
    [anon_sym_typename] = ACTIONS(3089),
    [anon_sym_private] = ACTIONS(3089),
    [anon_sym_template] = ACTIONS(3089),
    [anon_sym_operator] = ACTIONS(3089),
    [anon_sym_friend] = ACTIONS(3089),
    [anon_sym_public] = ACTIONS(3089),
    [anon_sym_protected] = ACTIONS(3089),
    [anon_sym_static_assert] = ACTIONS(3089),
  },
  [1805] = {
    [sym_identifier] = ACTIONS(2935),
    [aux_sym_preproc_def_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token2] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2935),
    [aux_sym_preproc_else_token1] = ACTIONS(2935),
    [aux_sym_preproc_elif_token1] = ACTIONS(2935),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2935),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2935),
    [sym_preproc_directive] = ACTIONS(2935),
    [anon_sym_LPAREN2] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym___extension__] = ACTIONS(2935),
    [anon_sym_typedef] = ACTIONS(2935),
    [anon_sym_virtual] = ACTIONS(2935),
    [anon_sym_extern] = ACTIONS(2935),
    [anon_sym___attribute__] = ACTIONS(2935),
    [anon_sym___attribute] = ACTIONS(2935),
    [anon_sym_using] = ACTIONS(2935),
    [anon_sym_COLON_COLON] = ACTIONS(2937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2937),
    [anon_sym___declspec] = ACTIONS(2935),
    [anon_sym___based] = ACTIONS(2935),
    [anon_sym_signed] = ACTIONS(2935),
    [anon_sym_unsigned] = ACTIONS(2935),
    [anon_sym_long] = ACTIONS(2935),
    [anon_sym_short] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_register] = ACTIONS(2935),
    [anon_sym_inline] = ACTIONS(2935),
    [anon_sym___inline] = ACTIONS(2935),
    [anon_sym___inline__] = ACTIONS(2935),
    [anon_sym___forceinline] = ACTIONS(2935),
    [anon_sym_thread_local] = ACTIONS(2935),
    [anon_sym___thread] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_constexpr] = ACTIONS(2935),
    [anon_sym_volatile] = ACTIONS(2935),
    [anon_sym_restrict] = ACTIONS(2935),
    [anon_sym___restrict__] = ACTIONS(2935),
    [anon_sym__Atomic] = ACTIONS(2935),
    [anon_sym__Noreturn] = ACTIONS(2935),
    [anon_sym_noreturn] = ACTIONS(2935),
    [anon_sym__Nonnull] = ACTIONS(2935),
    [anon_sym_mutable] = ACTIONS(2935),
    [anon_sym_constinit] = ACTIONS(2935),
    [anon_sym_consteval] = ACTIONS(2935),
    [anon_sym_alignas] = ACTIONS(2935),
    [anon_sym__Alignas] = ACTIONS(2935),
    [sym_primitive_type] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_union] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2935),
    [anon_sym_decltype] = ACTIONS(2935),
    [anon_sym_explicit] = ACTIONS(2935),
    [anon_sym_typename] = ACTIONS(2935),
    [anon_sym_private] = ACTIONS(2935),
    [anon_sym_template] = ACTIONS(2935),
    [anon_sym_operator] = ACTIONS(2935),
    [anon_sym_friend] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2935),
    [anon_sym_protected] = ACTIONS(2935),
    [anon_sym_static_assert] = ACTIONS(2935),
  },
  [1806] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [aux_sym_preproc_else_token1] = ACTIONS(2799),
    [aux_sym_preproc_elif_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_private] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_friend] = ACTIONS(2799),
    [anon_sym_public] = ACTIONS(2799),
    [anon_sym_protected] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
  },
  [1807] = {
    [sym_identifier] = ACTIONS(2807),
    [aux_sym_preproc_def_token1] = ACTIONS(2807),
    [aux_sym_preproc_if_token1] = ACTIONS(2807),
    [aux_sym_preproc_if_token2] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2807),
    [aux_sym_preproc_else_token1] = ACTIONS(2807),
    [aux_sym_preproc_elif_token1] = ACTIONS(2807),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2807),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2807),
    [sym_preproc_directive] = ACTIONS(2807),
    [anon_sym_LPAREN2] = ACTIONS(2809),
    [anon_sym_TILDE] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2807),
    [anon_sym_typedef] = ACTIONS(2807),
    [anon_sym_virtual] = ACTIONS(2807),
    [anon_sym_extern] = ACTIONS(2807),
    [anon_sym___attribute__] = ACTIONS(2807),
    [anon_sym___attribute] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2809),
    [anon_sym___declspec] = ACTIONS(2807),
    [anon_sym___based] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2807),
    [anon_sym_unsigned] = ACTIONS(2807),
    [anon_sym_long] = ACTIONS(2807),
    [anon_sym_short] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_static] = ACTIONS(2807),
    [anon_sym_register] = ACTIONS(2807),
    [anon_sym_inline] = ACTIONS(2807),
    [anon_sym___inline] = ACTIONS(2807),
    [anon_sym___inline__] = ACTIONS(2807),
    [anon_sym___forceinline] = ACTIONS(2807),
    [anon_sym_thread_local] = ACTIONS(2807),
    [anon_sym___thread] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_constexpr] = ACTIONS(2807),
    [anon_sym_volatile] = ACTIONS(2807),
    [anon_sym_restrict] = ACTIONS(2807),
    [anon_sym___restrict__] = ACTIONS(2807),
    [anon_sym__Atomic] = ACTIONS(2807),
    [anon_sym__Noreturn] = ACTIONS(2807),
    [anon_sym_noreturn] = ACTIONS(2807),
    [anon_sym__Nonnull] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_constinit] = ACTIONS(2807),
    [anon_sym_consteval] = ACTIONS(2807),
    [anon_sym_alignas] = ACTIONS(2807),
    [anon_sym__Alignas] = ACTIONS(2807),
    [sym_primitive_type] = ACTIONS(2807),
    [anon_sym_enum] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_union] = ACTIONS(2807),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2807),
    [anon_sym_decltype] = ACTIONS(2807),
    [anon_sym_explicit] = ACTIONS(2807),
    [anon_sym_typename] = ACTIONS(2807),
    [anon_sym_private] = ACTIONS(2807),
    [anon_sym_template] = ACTIONS(2807),
    [anon_sym_operator] = ACTIONS(2807),
    [anon_sym_friend] = ACTIONS(2807),
    [anon_sym_public] = ACTIONS(2807),
    [anon_sym_protected] = ACTIONS(2807),
    [anon_sym_static_assert] = ACTIONS(2807),
  },
  [1808] = {
    [sym_identifier] = ACTIONS(5609),
    [aux_sym_preproc_def_token1] = ACTIONS(5609),
    [aux_sym_preproc_if_token1] = ACTIONS(5609),
    [aux_sym_preproc_if_token2] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5609),
    [aux_sym_preproc_else_token1] = ACTIONS(5609),
    [aux_sym_preproc_elif_token1] = ACTIONS(5609),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5609),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5609),
    [sym_preproc_directive] = ACTIONS(5609),
    [anon_sym_LPAREN2] = ACTIONS(5611),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_STAR] = ACTIONS(5611),
    [anon_sym_AMP_AMP] = ACTIONS(5611),
    [anon_sym_AMP] = ACTIONS(5609),
    [anon_sym_SEMI] = ACTIONS(5611),
    [anon_sym___extension__] = ACTIONS(5609),
    [anon_sym_typedef] = ACTIONS(5609),
    [anon_sym_virtual] = ACTIONS(5609),
    [anon_sym_extern] = ACTIONS(5609),
    [anon_sym___attribute__] = ACTIONS(5609),
    [anon_sym___attribute] = ACTIONS(5609),
    [anon_sym_using] = ACTIONS(5609),
    [anon_sym_COLON_COLON] = ACTIONS(5611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5611),
    [anon_sym___declspec] = ACTIONS(5609),
    [anon_sym___based] = ACTIONS(5609),
    [anon_sym_signed] = ACTIONS(5609),
    [anon_sym_unsigned] = ACTIONS(5609),
    [anon_sym_long] = ACTIONS(5609),
    [anon_sym_short] = ACTIONS(5609),
    [anon_sym_LBRACK] = ACTIONS(5609),
    [anon_sym_static] = ACTIONS(5609),
    [anon_sym_register] = ACTIONS(5609),
    [anon_sym_inline] = ACTIONS(5609),
    [anon_sym___inline] = ACTIONS(5609),
    [anon_sym___inline__] = ACTIONS(5609),
    [anon_sym___forceinline] = ACTIONS(5609),
    [anon_sym_thread_local] = ACTIONS(5609),
    [anon_sym___thread] = ACTIONS(5609),
    [anon_sym_const] = ACTIONS(5609),
    [anon_sym_constexpr] = ACTIONS(5609),
    [anon_sym_volatile] = ACTIONS(5609),
    [anon_sym_restrict] = ACTIONS(5609),
    [anon_sym___restrict__] = ACTIONS(5609),
    [anon_sym__Atomic] = ACTIONS(5609),
    [anon_sym__Noreturn] = ACTIONS(5609),
    [anon_sym_noreturn] = ACTIONS(5609),
    [anon_sym__Nonnull] = ACTIONS(5609),
    [anon_sym_mutable] = ACTIONS(5609),
    [anon_sym_constinit] = ACTIONS(5609),
    [anon_sym_consteval] = ACTIONS(5609),
    [anon_sym_alignas] = ACTIONS(5609),
    [anon_sym__Alignas] = ACTIONS(5609),
    [sym_primitive_type] = ACTIONS(5609),
    [anon_sym_enum] = ACTIONS(5609),
    [anon_sym_class] = ACTIONS(5609),
    [anon_sym_struct] = ACTIONS(5609),
    [anon_sym_union] = ACTIONS(5609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5609),
    [anon_sym_decltype] = ACTIONS(5609),
    [anon_sym_explicit] = ACTIONS(5609),
    [anon_sym_typename] = ACTIONS(5609),
    [anon_sym_private] = ACTIONS(5609),
    [anon_sym_template] = ACTIONS(5609),
    [anon_sym_operator] = ACTIONS(5609),
    [anon_sym_friend] = ACTIONS(5609),
    [anon_sym_public] = ACTIONS(5609),
    [anon_sym_protected] = ACTIONS(5609),
    [anon_sym_static_assert] = ACTIONS(5609),
  },
  [1809] = {
    [sym_identifier] = ACTIONS(2939),
    [aux_sym_preproc_def_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token2] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2939),
    [aux_sym_preproc_else_token1] = ACTIONS(2939),
    [aux_sym_preproc_elif_token1] = ACTIONS(2939),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2939),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2939),
    [sym_preproc_directive] = ACTIONS(2939),
    [anon_sym_LPAREN2] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2939),
    [anon_sym_typedef] = ACTIONS(2939),
    [anon_sym_virtual] = ACTIONS(2939),
    [anon_sym_extern] = ACTIONS(2939),
    [anon_sym___attribute__] = ACTIONS(2939),
    [anon_sym___attribute] = ACTIONS(2939),
    [anon_sym_using] = ACTIONS(2939),
    [anon_sym_COLON_COLON] = ACTIONS(2941),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2941),
    [anon_sym___declspec] = ACTIONS(2939),
    [anon_sym___based] = ACTIONS(2939),
    [anon_sym_signed] = ACTIONS(2939),
    [anon_sym_unsigned] = ACTIONS(2939),
    [anon_sym_long] = ACTIONS(2939),
    [anon_sym_short] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_static] = ACTIONS(2939),
    [anon_sym_register] = ACTIONS(2939),
    [anon_sym_inline] = ACTIONS(2939),
    [anon_sym___inline] = ACTIONS(2939),
    [anon_sym___inline__] = ACTIONS(2939),
    [anon_sym___forceinline] = ACTIONS(2939),
    [anon_sym_thread_local] = ACTIONS(2939),
    [anon_sym___thread] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_constexpr] = ACTIONS(2939),
    [anon_sym_volatile] = ACTIONS(2939),
    [anon_sym_restrict] = ACTIONS(2939),
    [anon_sym___restrict__] = ACTIONS(2939),
    [anon_sym__Atomic] = ACTIONS(2939),
    [anon_sym__Noreturn] = ACTIONS(2939),
    [anon_sym_noreturn] = ACTIONS(2939),
    [anon_sym__Nonnull] = ACTIONS(2939),
    [anon_sym_mutable] = ACTIONS(2939),
    [anon_sym_constinit] = ACTIONS(2939),
    [anon_sym_consteval] = ACTIONS(2939),
    [anon_sym_alignas] = ACTIONS(2939),
    [anon_sym__Alignas] = ACTIONS(2939),
    [sym_primitive_type] = ACTIONS(2939),
    [anon_sym_enum] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2939),
    [anon_sym_struct] = ACTIONS(2939),
    [anon_sym_union] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2939),
    [anon_sym_decltype] = ACTIONS(2939),
    [anon_sym_explicit] = ACTIONS(2939),
    [anon_sym_typename] = ACTIONS(2939),
    [anon_sym_private] = ACTIONS(2939),
    [anon_sym_template] = ACTIONS(2939),
    [anon_sym_operator] = ACTIONS(2939),
    [anon_sym_friend] = ACTIONS(2939),
    [anon_sym_public] = ACTIONS(2939),
    [anon_sym_protected] = ACTIONS(2939),
    [anon_sym_static_assert] = ACTIONS(2939),
  },
  [1810] = {
    [sym_identifier] = ACTIONS(5613),
    [aux_sym_preproc_def_token1] = ACTIONS(5613),
    [aux_sym_preproc_if_token1] = ACTIONS(5613),
    [aux_sym_preproc_if_token2] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5613),
    [aux_sym_preproc_else_token1] = ACTIONS(5613),
    [aux_sym_preproc_elif_token1] = ACTIONS(5613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5613),
    [sym_preproc_directive] = ACTIONS(5613),
    [anon_sym_LPAREN2] = ACTIONS(5615),
    [anon_sym_TILDE] = ACTIONS(5615),
    [anon_sym_STAR] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5613),
    [anon_sym_SEMI] = ACTIONS(5615),
    [anon_sym___extension__] = ACTIONS(5613),
    [anon_sym_typedef] = ACTIONS(5613),
    [anon_sym_virtual] = ACTIONS(5613),
    [anon_sym_extern] = ACTIONS(5613),
    [anon_sym___attribute__] = ACTIONS(5613),
    [anon_sym___attribute] = ACTIONS(5613),
    [anon_sym_using] = ACTIONS(5613),
    [anon_sym_COLON_COLON] = ACTIONS(5615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5615),
    [anon_sym___declspec] = ACTIONS(5613),
    [anon_sym___based] = ACTIONS(5613),
    [anon_sym_signed] = ACTIONS(5613),
    [anon_sym_unsigned] = ACTIONS(5613),
    [anon_sym_long] = ACTIONS(5613),
    [anon_sym_short] = ACTIONS(5613),
    [anon_sym_LBRACK] = ACTIONS(5613),
    [anon_sym_static] = ACTIONS(5613),
    [anon_sym_register] = ACTIONS(5613),
    [anon_sym_inline] = ACTIONS(5613),
    [anon_sym___inline] = ACTIONS(5613),
    [anon_sym___inline__] = ACTIONS(5613),
    [anon_sym___forceinline] = ACTIONS(5613),
    [anon_sym_thread_local] = ACTIONS(5613),
    [anon_sym___thread] = ACTIONS(5613),
    [anon_sym_const] = ACTIONS(5613),
    [anon_sym_constexpr] = ACTIONS(5613),
    [anon_sym_volatile] = ACTIONS(5613),
    [anon_sym_restrict] = ACTIONS(5613),
    [anon_sym___restrict__] = ACTIONS(5613),
    [anon_sym__Atomic] = ACTIONS(5613),
    [anon_sym__Noreturn] = ACTIONS(5613),
    [anon_sym_noreturn] = ACTIONS(5613),
    [anon_sym__Nonnull] = ACTIONS(5613),
    [anon_sym_mutable] = ACTIONS(5613),
    [anon_sym_constinit] = ACTIONS(5613),
    [anon_sym_consteval] = ACTIONS(5613),
    [anon_sym_alignas] = ACTIONS(5613),
    [anon_sym__Alignas] = ACTIONS(5613),
    [sym_primitive_type] = ACTIONS(5613),
    [anon_sym_enum] = ACTIONS(5613),
    [anon_sym_class] = ACTIONS(5613),
    [anon_sym_struct] = ACTIONS(5613),
    [anon_sym_union] = ACTIONS(5613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5613),
    [anon_sym_decltype] = ACTIONS(5613),
    [anon_sym_explicit] = ACTIONS(5613),
    [anon_sym_typename] = ACTIONS(5613),
    [anon_sym_private] = ACTIONS(5613),
    [anon_sym_template] = ACTIONS(5613),
    [anon_sym_operator] = ACTIONS(5613),
    [anon_sym_friend] = ACTIONS(5613),
    [anon_sym_public] = ACTIONS(5613),
    [anon_sym_protected] = ACTIONS(5613),
    [anon_sym_static_assert] = ACTIONS(5613),
  },
  [1811] = {
    [sym_identifier] = ACTIONS(2815),
    [aux_sym_preproc_def_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token2] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2815),
    [aux_sym_preproc_else_token1] = ACTIONS(2815),
    [aux_sym_preproc_elif_token1] = ACTIONS(2815),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2815),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2815),
    [sym_preproc_directive] = ACTIONS(2815),
    [anon_sym_LPAREN2] = ACTIONS(2817),
    [anon_sym_TILDE] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym___extension__] = ACTIONS(2815),
    [anon_sym_typedef] = ACTIONS(2815),
    [anon_sym_virtual] = ACTIONS(2815),
    [anon_sym_extern] = ACTIONS(2815),
    [anon_sym___attribute__] = ACTIONS(2815),
    [anon_sym___attribute] = ACTIONS(2815),
    [anon_sym_using] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2817),
    [anon_sym___declspec] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2815),
    [anon_sym_unsigned] = ACTIONS(2815),
    [anon_sym_long] = ACTIONS(2815),
    [anon_sym_short] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2815),
    [anon_sym_register] = ACTIONS(2815),
    [anon_sym_inline] = ACTIONS(2815),
    [anon_sym___inline] = ACTIONS(2815),
    [anon_sym___inline__] = ACTIONS(2815),
    [anon_sym___forceinline] = ACTIONS(2815),
    [anon_sym_thread_local] = ACTIONS(2815),
    [anon_sym___thread] = ACTIONS(2815),
    [anon_sym_const] = ACTIONS(2815),
    [anon_sym_constexpr] = ACTIONS(2815),
    [anon_sym_volatile] = ACTIONS(2815),
    [anon_sym_restrict] = ACTIONS(2815),
    [anon_sym___restrict__] = ACTIONS(2815),
    [anon_sym__Atomic] = ACTIONS(2815),
    [anon_sym__Noreturn] = ACTIONS(2815),
    [anon_sym_noreturn] = ACTIONS(2815),
    [anon_sym__Nonnull] = ACTIONS(2815),
    [anon_sym_mutable] = ACTIONS(2815),
    [anon_sym_constinit] = ACTIONS(2815),
    [anon_sym_consteval] = ACTIONS(2815),
    [anon_sym_alignas] = ACTIONS(2815),
    [anon_sym__Alignas] = ACTIONS(2815),
    [sym_primitive_type] = ACTIONS(2815),
    [anon_sym_enum] = ACTIONS(2815),
    [anon_sym_class] = ACTIONS(2815),
    [anon_sym_struct] = ACTIONS(2815),
    [anon_sym_union] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2815),
    [anon_sym_decltype] = ACTIONS(2815),
    [anon_sym_explicit] = ACTIONS(2815),
    [anon_sym_typename] = ACTIONS(2815),
    [anon_sym_private] = ACTIONS(2815),
    [anon_sym_template] = ACTIONS(2815),
    [anon_sym_operator] = ACTIONS(2815),
    [anon_sym_friend] = ACTIONS(2815),
    [anon_sym_public] = ACTIONS(2815),
    [anon_sym_protected] = ACTIONS(2815),
    [anon_sym_static_assert] = ACTIONS(2815),
  },
  [1812] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6275),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6796),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6796),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1813] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5619),
    [anon_sym_COMMA] = ACTIONS(5619),
    [anon_sym_RPAREN] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_DASH] = ACTIONS(5617),
    [anon_sym_PLUS] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_SLASH] = ACTIONS(5617),
    [anon_sym_PERCENT] = ACTIONS(5619),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_CARET] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5619),
    [anon_sym_BANG_EQ] = ACTIONS(5619),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_LT_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_LT_LT] = ACTIONS(5619),
    [anon_sym_GT_GT] = ACTIONS(5619),
    [anon_sym_SEMI] = ACTIONS(5619),
    [anon_sym___extension__] = ACTIONS(5617),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_COLON] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym___based] = ACTIONS(5617),
    [anon_sym_LBRACE] = ACTIONS(5619),
    [anon_sym_RBRACE] = ACTIONS(5619),
    [anon_sym_signed] = ACTIONS(5617),
    [anon_sym_unsigned] = ACTIONS(5617),
    [anon_sym_long] = ACTIONS(5617),
    [anon_sym_short] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5619),
    [anon_sym_RBRACK] = ACTIONS(5619),
    [anon_sym_const] = ACTIONS(5617),
    [anon_sym_constexpr] = ACTIONS(5617),
    [anon_sym_volatile] = ACTIONS(5617),
    [anon_sym_restrict] = ACTIONS(5617),
    [anon_sym___restrict__] = ACTIONS(5617),
    [anon_sym__Atomic] = ACTIONS(5617),
    [anon_sym__Noreturn] = ACTIONS(5617),
    [anon_sym_noreturn] = ACTIONS(5617),
    [anon_sym__Nonnull] = ACTIONS(5617),
    [anon_sym_mutable] = ACTIONS(5617),
    [anon_sym_constinit] = ACTIONS(5617),
    [anon_sym_consteval] = ACTIONS(5617),
    [anon_sym_alignas] = ACTIONS(5617),
    [anon_sym__Alignas] = ACTIONS(5617),
    [sym_primitive_type] = ACTIONS(5617),
    [anon_sym_QMARK] = ACTIONS(5619),
    [anon_sym_LT_EQ_GT] = ACTIONS(5619),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [anon_sym_bitor] = ACTIONS(5617),
    [anon_sym_xor] = ACTIONS(5617),
    [anon_sym_bitand] = ACTIONS(5617),
    [anon_sym_not_eq] = ACTIONS(5617),
    [anon_sym_DASH_DASH] = ACTIONS(5619),
    [anon_sym_PLUS_PLUS] = ACTIONS(5619),
    [anon_sym_DOT] = ACTIONS(5617),
    [anon_sym_DOT_STAR] = ACTIONS(5619),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_final] = ACTIONS(5617),
    [anon_sym_override] = ACTIONS(5617),
    [anon_sym_requires] = ACTIONS(5617),
  },
  [1814] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5619),
    [anon_sym_COMMA] = ACTIONS(5619),
    [anon_sym_RPAREN] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_DASH] = ACTIONS(5617),
    [anon_sym_PLUS] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_SLASH] = ACTIONS(5617),
    [anon_sym_PERCENT] = ACTIONS(5619),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_CARET] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5619),
    [anon_sym_BANG_EQ] = ACTIONS(5619),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_LT_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_LT_LT] = ACTIONS(5619),
    [anon_sym_GT_GT] = ACTIONS(5619),
    [anon_sym_SEMI] = ACTIONS(5619),
    [anon_sym___extension__] = ACTIONS(5617),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_COLON] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym___based] = ACTIONS(5617),
    [anon_sym_LBRACE] = ACTIONS(5619),
    [anon_sym_RBRACE] = ACTIONS(5619),
    [anon_sym_signed] = ACTIONS(5617),
    [anon_sym_unsigned] = ACTIONS(5617),
    [anon_sym_long] = ACTIONS(5617),
    [anon_sym_short] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5619),
    [anon_sym_RBRACK] = ACTIONS(5619),
    [anon_sym_const] = ACTIONS(5617),
    [anon_sym_constexpr] = ACTIONS(5617),
    [anon_sym_volatile] = ACTIONS(5617),
    [anon_sym_restrict] = ACTIONS(5617),
    [anon_sym___restrict__] = ACTIONS(5617),
    [anon_sym__Atomic] = ACTIONS(5617),
    [anon_sym__Noreturn] = ACTIONS(5617),
    [anon_sym_noreturn] = ACTIONS(5617),
    [anon_sym__Nonnull] = ACTIONS(5617),
    [anon_sym_mutable] = ACTIONS(5617),
    [anon_sym_constinit] = ACTIONS(5617),
    [anon_sym_consteval] = ACTIONS(5617),
    [anon_sym_alignas] = ACTIONS(5617),
    [anon_sym__Alignas] = ACTIONS(5617),
    [sym_primitive_type] = ACTIONS(5617),
    [anon_sym_QMARK] = ACTIONS(5619),
    [anon_sym_LT_EQ_GT] = ACTIONS(5619),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [anon_sym_bitor] = ACTIONS(5617),
    [anon_sym_xor] = ACTIONS(5617),
    [anon_sym_bitand] = ACTIONS(5617),
    [anon_sym_not_eq] = ACTIONS(5617),
    [anon_sym_DASH_DASH] = ACTIONS(5619),
    [anon_sym_PLUS_PLUS] = ACTIONS(5619),
    [anon_sym_DOT] = ACTIONS(5617),
    [anon_sym_DOT_STAR] = ACTIONS(5619),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_final] = ACTIONS(5617),
    [anon_sym_override] = ACTIONS(5617),
    [anon_sym_requires] = ACTIONS(5617),
  },
  [1815] = {
    [sym_identifier] = ACTIONS(5621),
    [aux_sym_preproc_def_token1] = ACTIONS(5621),
    [aux_sym_preproc_if_token1] = ACTIONS(5621),
    [aux_sym_preproc_if_token2] = ACTIONS(5621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5621),
    [aux_sym_preproc_else_token1] = ACTIONS(5621),
    [aux_sym_preproc_elif_token1] = ACTIONS(5621),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5621),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5621),
    [sym_preproc_directive] = ACTIONS(5621),
    [anon_sym_LPAREN2] = ACTIONS(5623),
    [anon_sym_TILDE] = ACTIONS(5623),
    [anon_sym_STAR] = ACTIONS(5623),
    [anon_sym_AMP_AMP] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5621),
    [anon_sym_SEMI] = ACTIONS(5623),
    [anon_sym___extension__] = ACTIONS(5621),
    [anon_sym_typedef] = ACTIONS(5621),
    [anon_sym_virtual] = ACTIONS(5621),
    [anon_sym_extern] = ACTIONS(5621),
    [anon_sym___attribute__] = ACTIONS(5621),
    [anon_sym___attribute] = ACTIONS(5621),
    [anon_sym_using] = ACTIONS(5621),
    [anon_sym_COLON_COLON] = ACTIONS(5623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5623),
    [anon_sym___declspec] = ACTIONS(5621),
    [anon_sym___based] = ACTIONS(5621),
    [anon_sym_signed] = ACTIONS(5621),
    [anon_sym_unsigned] = ACTIONS(5621),
    [anon_sym_long] = ACTIONS(5621),
    [anon_sym_short] = ACTIONS(5621),
    [anon_sym_LBRACK] = ACTIONS(5621),
    [anon_sym_static] = ACTIONS(5621),
    [anon_sym_register] = ACTIONS(5621),
    [anon_sym_inline] = ACTIONS(5621),
    [anon_sym___inline] = ACTIONS(5621),
    [anon_sym___inline__] = ACTIONS(5621),
    [anon_sym___forceinline] = ACTIONS(5621),
    [anon_sym_thread_local] = ACTIONS(5621),
    [anon_sym___thread] = ACTIONS(5621),
    [anon_sym_const] = ACTIONS(5621),
    [anon_sym_constexpr] = ACTIONS(5621),
    [anon_sym_volatile] = ACTIONS(5621),
    [anon_sym_restrict] = ACTIONS(5621),
    [anon_sym___restrict__] = ACTIONS(5621),
    [anon_sym__Atomic] = ACTIONS(5621),
    [anon_sym__Noreturn] = ACTIONS(5621),
    [anon_sym_noreturn] = ACTIONS(5621),
    [anon_sym__Nonnull] = ACTIONS(5621),
    [anon_sym_mutable] = ACTIONS(5621),
    [anon_sym_constinit] = ACTIONS(5621),
    [anon_sym_consteval] = ACTIONS(5621),
    [anon_sym_alignas] = ACTIONS(5621),
    [anon_sym__Alignas] = ACTIONS(5621),
    [sym_primitive_type] = ACTIONS(5621),
    [anon_sym_enum] = ACTIONS(5621),
    [anon_sym_class] = ACTIONS(5621),
    [anon_sym_struct] = ACTIONS(5621),
    [anon_sym_union] = ACTIONS(5621),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5621),
    [anon_sym_decltype] = ACTIONS(5621),
    [anon_sym_explicit] = ACTIONS(5621),
    [anon_sym_typename] = ACTIONS(5621),
    [anon_sym_private] = ACTIONS(5621),
    [anon_sym_template] = ACTIONS(5621),
    [anon_sym_operator] = ACTIONS(5621),
    [anon_sym_friend] = ACTIONS(5621),
    [anon_sym_public] = ACTIONS(5621),
    [anon_sym_protected] = ACTIONS(5621),
    [anon_sym_static_assert] = ACTIONS(5621),
  },
  [1816] = {
    [sym_identifier] = ACTIONS(5625),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5627),
    [anon_sym_COMMA] = ACTIONS(5627),
    [anon_sym_RPAREN] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5627),
    [anon_sym_DASH] = ACTIONS(5625),
    [anon_sym_PLUS] = ACTIONS(5625),
    [anon_sym_STAR] = ACTIONS(5627),
    [anon_sym_SLASH] = ACTIONS(5625),
    [anon_sym_PERCENT] = ACTIONS(5627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5627),
    [anon_sym_PIPE] = ACTIONS(5625),
    [anon_sym_CARET] = ACTIONS(5627),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_EQ_EQ] = ACTIONS(5627),
    [anon_sym_BANG_EQ] = ACTIONS(5627),
    [anon_sym_GT] = ACTIONS(5625),
    [anon_sym_GT_EQ] = ACTIONS(5627),
    [anon_sym_LT_EQ] = ACTIONS(5625),
    [anon_sym_LT] = ACTIONS(5625),
    [anon_sym_LT_LT] = ACTIONS(5627),
    [anon_sym_GT_GT] = ACTIONS(5627),
    [anon_sym_SEMI] = ACTIONS(5627),
    [anon_sym___extension__] = ACTIONS(5625),
    [anon_sym___attribute__] = ACTIONS(5625),
    [anon_sym___attribute] = ACTIONS(5625),
    [anon_sym_COLON] = ACTIONS(5625),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym___based] = ACTIONS(5625),
    [anon_sym_LBRACE] = ACTIONS(5627),
    [anon_sym_RBRACE] = ACTIONS(5627),
    [anon_sym_signed] = ACTIONS(5625),
    [anon_sym_unsigned] = ACTIONS(5625),
    [anon_sym_long] = ACTIONS(5625),
    [anon_sym_short] = ACTIONS(5625),
    [anon_sym_LBRACK] = ACTIONS(5627),
    [anon_sym_RBRACK] = ACTIONS(5627),
    [anon_sym_const] = ACTIONS(5625),
    [anon_sym_constexpr] = ACTIONS(5625),
    [anon_sym_volatile] = ACTIONS(5625),
    [anon_sym_restrict] = ACTIONS(5625),
    [anon_sym___restrict__] = ACTIONS(5625),
    [anon_sym__Atomic] = ACTIONS(5625),
    [anon_sym__Noreturn] = ACTIONS(5625),
    [anon_sym_noreturn] = ACTIONS(5625),
    [anon_sym__Nonnull] = ACTIONS(5625),
    [anon_sym_mutable] = ACTIONS(5625),
    [anon_sym_constinit] = ACTIONS(5625),
    [anon_sym_consteval] = ACTIONS(5625),
    [anon_sym_alignas] = ACTIONS(5625),
    [anon_sym__Alignas] = ACTIONS(5625),
    [sym_primitive_type] = ACTIONS(5625),
    [anon_sym_QMARK] = ACTIONS(5627),
    [anon_sym_LT_EQ_GT] = ACTIONS(5627),
    [anon_sym_or] = ACTIONS(5625),
    [anon_sym_and] = ACTIONS(5625),
    [anon_sym_bitor] = ACTIONS(5625),
    [anon_sym_xor] = ACTIONS(5625),
    [anon_sym_bitand] = ACTIONS(5625),
    [anon_sym_not_eq] = ACTIONS(5625),
    [anon_sym_DASH_DASH] = ACTIONS(5627),
    [anon_sym_PLUS_PLUS] = ACTIONS(5627),
    [anon_sym_DOT] = ACTIONS(5625),
    [anon_sym_DOT_STAR] = ACTIONS(5627),
    [anon_sym_DASH_GT] = ACTIONS(5627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5625),
    [anon_sym_decltype] = ACTIONS(5625),
    [anon_sym_final] = ACTIONS(5625),
    [anon_sym_override] = ACTIONS(5625),
    [anon_sym_requires] = ACTIONS(5625),
  },
  [1817] = {
    [sym_identifier] = ACTIONS(2903),
    [aux_sym_preproc_def_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token2] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2903),
    [aux_sym_preproc_else_token1] = ACTIONS(2903),
    [aux_sym_preproc_elif_token1] = ACTIONS(2903),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2903),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2903),
    [sym_preproc_directive] = ACTIONS(2903),
    [anon_sym_LPAREN2] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2903),
    [anon_sym_typedef] = ACTIONS(2903),
    [anon_sym_virtual] = ACTIONS(2903),
    [anon_sym_extern] = ACTIONS(2903),
    [anon_sym___attribute__] = ACTIONS(2903),
    [anon_sym___attribute] = ACTIONS(2903),
    [anon_sym_using] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2905),
    [anon_sym___declspec] = ACTIONS(2903),
    [anon_sym___based] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2903),
    [anon_sym_unsigned] = ACTIONS(2903),
    [anon_sym_long] = ACTIONS(2903),
    [anon_sym_short] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_register] = ACTIONS(2903),
    [anon_sym_inline] = ACTIONS(2903),
    [anon_sym___inline] = ACTIONS(2903),
    [anon_sym___inline__] = ACTIONS(2903),
    [anon_sym___forceinline] = ACTIONS(2903),
    [anon_sym_thread_local] = ACTIONS(2903),
    [anon_sym___thread] = ACTIONS(2903),
    [anon_sym_const] = ACTIONS(2903),
    [anon_sym_constexpr] = ACTIONS(2903),
    [anon_sym_volatile] = ACTIONS(2903),
    [anon_sym_restrict] = ACTIONS(2903),
    [anon_sym___restrict__] = ACTIONS(2903),
    [anon_sym__Atomic] = ACTIONS(2903),
    [anon_sym__Noreturn] = ACTIONS(2903),
    [anon_sym_noreturn] = ACTIONS(2903),
    [anon_sym__Nonnull] = ACTIONS(2903),
    [anon_sym_mutable] = ACTIONS(2903),
    [anon_sym_constinit] = ACTIONS(2903),
    [anon_sym_consteval] = ACTIONS(2903),
    [anon_sym_alignas] = ACTIONS(2903),
    [anon_sym__Alignas] = ACTIONS(2903),
    [sym_primitive_type] = ACTIONS(2903),
    [anon_sym_enum] = ACTIONS(2903),
    [anon_sym_class] = ACTIONS(2903),
    [anon_sym_struct] = ACTIONS(2903),
    [anon_sym_union] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2903),
    [anon_sym_decltype] = ACTIONS(2903),
    [anon_sym_explicit] = ACTIONS(2903),
    [anon_sym_typename] = ACTIONS(2903),
    [anon_sym_private] = ACTIONS(2903),
    [anon_sym_template] = ACTIONS(2903),
    [anon_sym_operator] = ACTIONS(2903),
    [anon_sym_friend] = ACTIONS(2903),
    [anon_sym_public] = ACTIONS(2903),
    [anon_sym_protected] = ACTIONS(2903),
    [anon_sym_static_assert] = ACTIONS(2903),
  },
  [1818] = {
    [sym_identifier] = ACTIONS(5629),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5631),
    [anon_sym_COMMA] = ACTIONS(5631),
    [anon_sym_RPAREN] = ACTIONS(5631),
    [anon_sym_LPAREN2] = ACTIONS(5631),
    [anon_sym_DASH] = ACTIONS(5629),
    [anon_sym_PLUS] = ACTIONS(5629),
    [anon_sym_STAR] = ACTIONS(5631),
    [anon_sym_SLASH] = ACTIONS(5629),
    [anon_sym_PERCENT] = ACTIONS(5631),
    [anon_sym_PIPE_PIPE] = ACTIONS(5631),
    [anon_sym_AMP_AMP] = ACTIONS(5631),
    [anon_sym_PIPE] = ACTIONS(5629),
    [anon_sym_CARET] = ACTIONS(5631),
    [anon_sym_AMP] = ACTIONS(5629),
    [anon_sym_EQ_EQ] = ACTIONS(5631),
    [anon_sym_BANG_EQ] = ACTIONS(5631),
    [anon_sym_GT] = ACTIONS(5629),
    [anon_sym_GT_EQ] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5629),
    [anon_sym_LT_LT] = ACTIONS(5631),
    [anon_sym_GT_GT] = ACTIONS(5631),
    [anon_sym_SEMI] = ACTIONS(5631),
    [anon_sym___extension__] = ACTIONS(5629),
    [anon_sym___attribute__] = ACTIONS(5629),
    [anon_sym___attribute] = ACTIONS(5629),
    [anon_sym_COLON] = ACTIONS(5629),
    [anon_sym_COLON_COLON] = ACTIONS(5631),
    [anon_sym___based] = ACTIONS(5629),
    [anon_sym_LBRACE] = ACTIONS(5631),
    [anon_sym_RBRACE] = ACTIONS(5631),
    [anon_sym_signed] = ACTIONS(5629),
    [anon_sym_unsigned] = ACTIONS(5629),
    [anon_sym_long] = ACTIONS(5629),
    [anon_sym_short] = ACTIONS(5629),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_RBRACK] = ACTIONS(5631),
    [anon_sym_const] = ACTIONS(5629),
    [anon_sym_constexpr] = ACTIONS(5629),
    [anon_sym_volatile] = ACTIONS(5629),
    [anon_sym_restrict] = ACTIONS(5629),
    [anon_sym___restrict__] = ACTIONS(5629),
    [anon_sym__Atomic] = ACTIONS(5629),
    [anon_sym__Noreturn] = ACTIONS(5629),
    [anon_sym_noreturn] = ACTIONS(5629),
    [anon_sym__Nonnull] = ACTIONS(5629),
    [anon_sym_mutable] = ACTIONS(5629),
    [anon_sym_constinit] = ACTIONS(5629),
    [anon_sym_consteval] = ACTIONS(5629),
    [anon_sym_alignas] = ACTIONS(5629),
    [anon_sym__Alignas] = ACTIONS(5629),
    [sym_primitive_type] = ACTIONS(5629),
    [anon_sym_QMARK] = ACTIONS(5631),
    [anon_sym_LT_EQ_GT] = ACTIONS(5631),
    [anon_sym_or] = ACTIONS(5629),
    [anon_sym_and] = ACTIONS(5629),
    [anon_sym_bitor] = ACTIONS(5629),
    [anon_sym_xor] = ACTIONS(5629),
    [anon_sym_bitand] = ACTIONS(5629),
    [anon_sym_not_eq] = ACTIONS(5629),
    [anon_sym_DASH_DASH] = ACTIONS(5631),
    [anon_sym_PLUS_PLUS] = ACTIONS(5631),
    [anon_sym_DOT] = ACTIONS(5629),
    [anon_sym_DOT_STAR] = ACTIONS(5631),
    [anon_sym_DASH_GT] = ACTIONS(5631),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5629),
    [anon_sym_decltype] = ACTIONS(5629),
    [anon_sym_final] = ACTIONS(5629),
    [anon_sym_override] = ACTIONS(5629),
    [anon_sym_requires] = ACTIONS(5629),
  },
  [1819] = {
    [sym_identifier] = ACTIONS(5633),
    [aux_sym_preproc_def_token1] = ACTIONS(5633),
    [aux_sym_preproc_if_token1] = ACTIONS(5633),
    [aux_sym_preproc_if_token2] = ACTIONS(5633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5633),
    [aux_sym_preproc_else_token1] = ACTIONS(5633),
    [aux_sym_preproc_elif_token1] = ACTIONS(5633),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5633),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5633),
    [sym_preproc_directive] = ACTIONS(5633),
    [anon_sym_LPAREN2] = ACTIONS(5635),
    [anon_sym_TILDE] = ACTIONS(5635),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_AMP_AMP] = ACTIONS(5635),
    [anon_sym_AMP] = ACTIONS(5633),
    [anon_sym_SEMI] = ACTIONS(5635),
    [anon_sym___extension__] = ACTIONS(5633),
    [anon_sym_typedef] = ACTIONS(5633),
    [anon_sym_virtual] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym___attribute__] = ACTIONS(5633),
    [anon_sym___attribute] = ACTIONS(5633),
    [anon_sym_using] = ACTIONS(5633),
    [anon_sym_COLON_COLON] = ACTIONS(5635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5635),
    [anon_sym___declspec] = ACTIONS(5633),
    [anon_sym___based] = ACTIONS(5633),
    [anon_sym_signed] = ACTIONS(5633),
    [anon_sym_unsigned] = ACTIONS(5633),
    [anon_sym_long] = ACTIONS(5633),
    [anon_sym_short] = ACTIONS(5633),
    [anon_sym_LBRACK] = ACTIONS(5633),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_register] = ACTIONS(5633),
    [anon_sym_inline] = ACTIONS(5633),
    [anon_sym___inline] = ACTIONS(5633),
    [anon_sym___inline__] = ACTIONS(5633),
    [anon_sym___forceinline] = ACTIONS(5633),
    [anon_sym_thread_local] = ACTIONS(5633),
    [anon_sym___thread] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym___restrict__] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym__Noreturn] = ACTIONS(5633),
    [anon_sym_noreturn] = ACTIONS(5633),
    [anon_sym__Nonnull] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_constinit] = ACTIONS(5633),
    [anon_sym_consteval] = ACTIONS(5633),
    [anon_sym_alignas] = ACTIONS(5633),
    [anon_sym__Alignas] = ACTIONS(5633),
    [sym_primitive_type] = ACTIONS(5633),
    [anon_sym_enum] = ACTIONS(5633),
    [anon_sym_class] = ACTIONS(5633),
    [anon_sym_struct] = ACTIONS(5633),
    [anon_sym_union] = ACTIONS(5633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_decltype] = ACTIONS(5633),
    [anon_sym_explicit] = ACTIONS(5633),
    [anon_sym_typename] = ACTIONS(5633),
    [anon_sym_private] = ACTIONS(5633),
    [anon_sym_template] = ACTIONS(5633),
    [anon_sym_operator] = ACTIONS(5633),
    [anon_sym_friend] = ACTIONS(5633),
    [anon_sym_public] = ACTIONS(5633),
    [anon_sym_protected] = ACTIONS(5633),
    [anon_sym_static_assert] = ACTIONS(5633),
  },
  [1820] = {
    [sym_identifier] = ACTIONS(5446),
    [aux_sym_preproc_def_token1] = ACTIONS(5446),
    [aux_sym_preproc_if_token1] = ACTIONS(5446),
    [aux_sym_preproc_if_token2] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5446),
    [aux_sym_preproc_else_token1] = ACTIONS(5446),
    [aux_sym_preproc_elif_token1] = ACTIONS(5446),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5446),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5446),
    [sym_preproc_directive] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5448),
    [anon_sym_TILDE] = ACTIONS(5448),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym___extension__] = ACTIONS(5446),
    [anon_sym_typedef] = ACTIONS(5446),
    [anon_sym_virtual] = ACTIONS(5446),
    [anon_sym_extern] = ACTIONS(5446),
    [anon_sym___attribute__] = ACTIONS(5446),
    [anon_sym___attribute] = ACTIONS(5446),
    [anon_sym_using] = ACTIONS(5446),
    [anon_sym_COLON_COLON] = ACTIONS(5448),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5448),
    [anon_sym___declspec] = ACTIONS(5446),
    [anon_sym___based] = ACTIONS(5446),
    [anon_sym_signed] = ACTIONS(5446),
    [anon_sym_unsigned] = ACTIONS(5446),
    [anon_sym_long] = ACTIONS(5446),
    [anon_sym_short] = ACTIONS(5446),
    [anon_sym_LBRACK] = ACTIONS(5446),
    [anon_sym_static] = ACTIONS(5446),
    [anon_sym_register] = ACTIONS(5446),
    [anon_sym_inline] = ACTIONS(5446),
    [anon_sym___inline] = ACTIONS(5446),
    [anon_sym___inline__] = ACTIONS(5446),
    [anon_sym___forceinline] = ACTIONS(5446),
    [anon_sym_thread_local] = ACTIONS(5446),
    [anon_sym___thread] = ACTIONS(5446),
    [anon_sym_const] = ACTIONS(5446),
    [anon_sym_constexpr] = ACTIONS(5446),
    [anon_sym_volatile] = ACTIONS(5446),
    [anon_sym_restrict] = ACTIONS(5446),
    [anon_sym___restrict__] = ACTIONS(5446),
    [anon_sym__Atomic] = ACTIONS(5446),
    [anon_sym__Noreturn] = ACTIONS(5446),
    [anon_sym_noreturn] = ACTIONS(5446),
    [anon_sym__Nonnull] = ACTIONS(5446),
    [anon_sym_mutable] = ACTIONS(5446),
    [anon_sym_constinit] = ACTIONS(5446),
    [anon_sym_consteval] = ACTIONS(5446),
    [anon_sym_alignas] = ACTIONS(5446),
    [anon_sym__Alignas] = ACTIONS(5446),
    [sym_primitive_type] = ACTIONS(5446),
    [anon_sym_enum] = ACTIONS(5446),
    [anon_sym_class] = ACTIONS(5446),
    [anon_sym_struct] = ACTIONS(5446),
    [anon_sym_union] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5446),
    [anon_sym_decltype] = ACTIONS(5446),
    [anon_sym_explicit] = ACTIONS(5446),
    [anon_sym_typename] = ACTIONS(5446),
    [anon_sym_private] = ACTIONS(5446),
    [anon_sym_template] = ACTIONS(5446),
    [anon_sym_operator] = ACTIONS(5446),
    [anon_sym_friend] = ACTIONS(5446),
    [anon_sym_public] = ACTIONS(5446),
    [anon_sym_protected] = ACTIONS(5446),
    [anon_sym_static_assert] = ACTIONS(5446),
  },
  [1821] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [aux_sym_preproc_else_token1] = ACTIONS(2843),
    [aux_sym_preproc_elif_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_friend] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
  },
  [1822] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [aux_sym_preproc_else_token1] = ACTIONS(2843),
    [aux_sym_preproc_elif_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_friend] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
  },
  [1823] = {
    [sym_identifier] = ACTIONS(2847),
    [aux_sym_preproc_def_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token2] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2847),
    [aux_sym_preproc_else_token1] = ACTIONS(2847),
    [aux_sym_preproc_elif_token1] = ACTIONS(2847),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2847),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2847),
    [sym_preproc_directive] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym___extension__] = ACTIONS(2847),
    [anon_sym_typedef] = ACTIONS(2847),
    [anon_sym_virtual] = ACTIONS(2847),
    [anon_sym_extern] = ACTIONS(2847),
    [anon_sym___attribute__] = ACTIONS(2847),
    [anon_sym___attribute] = ACTIONS(2847),
    [anon_sym_using] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2849),
    [anon_sym___declspec] = ACTIONS(2847),
    [anon_sym___based] = ACTIONS(2847),
    [anon_sym_signed] = ACTIONS(2847),
    [anon_sym_unsigned] = ACTIONS(2847),
    [anon_sym_long] = ACTIONS(2847),
    [anon_sym_short] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2847),
    [anon_sym_register] = ACTIONS(2847),
    [anon_sym_inline] = ACTIONS(2847),
    [anon_sym___inline] = ACTIONS(2847),
    [anon_sym___inline__] = ACTIONS(2847),
    [anon_sym___forceinline] = ACTIONS(2847),
    [anon_sym_thread_local] = ACTIONS(2847),
    [anon_sym___thread] = ACTIONS(2847),
    [anon_sym_const] = ACTIONS(2847),
    [anon_sym_constexpr] = ACTIONS(2847),
    [anon_sym_volatile] = ACTIONS(2847),
    [anon_sym_restrict] = ACTIONS(2847),
    [anon_sym___restrict__] = ACTIONS(2847),
    [anon_sym__Atomic] = ACTIONS(2847),
    [anon_sym__Noreturn] = ACTIONS(2847),
    [anon_sym_noreturn] = ACTIONS(2847),
    [anon_sym__Nonnull] = ACTIONS(2847),
    [anon_sym_mutable] = ACTIONS(2847),
    [anon_sym_constinit] = ACTIONS(2847),
    [anon_sym_consteval] = ACTIONS(2847),
    [anon_sym_alignas] = ACTIONS(2847),
    [anon_sym__Alignas] = ACTIONS(2847),
    [sym_primitive_type] = ACTIONS(2847),
    [anon_sym_enum] = ACTIONS(2847),
    [anon_sym_class] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2847),
    [anon_sym_union] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2847),
    [anon_sym_decltype] = ACTIONS(2847),
    [anon_sym_explicit] = ACTIONS(2847),
    [anon_sym_typename] = ACTIONS(2847),
    [anon_sym_private] = ACTIONS(2847),
    [anon_sym_template] = ACTIONS(2847),
    [anon_sym_operator] = ACTIONS(2847),
    [anon_sym_friend] = ACTIONS(2847),
    [anon_sym_public] = ACTIONS(2847),
    [anon_sym_protected] = ACTIONS(2847),
    [anon_sym_static_assert] = ACTIONS(2847),
  },
  [1824] = {
    [sym_identifier] = ACTIONS(5456),
    [aux_sym_preproc_def_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token2] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5456),
    [aux_sym_preproc_else_token1] = ACTIONS(5456),
    [aux_sym_preproc_elif_token1] = ACTIONS(5456),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5456),
    [sym_preproc_directive] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5458),
    [anon_sym_TILDE] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5458),
    [anon_sym___extension__] = ACTIONS(5456),
    [anon_sym_typedef] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym___attribute__] = ACTIONS(5456),
    [anon_sym___attribute] = ACTIONS(5456),
    [anon_sym_using] = ACTIONS(5456),
    [anon_sym_COLON_COLON] = ACTIONS(5458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5458),
    [anon_sym___declspec] = ACTIONS(5456),
    [anon_sym___based] = ACTIONS(5456),
    [anon_sym_signed] = ACTIONS(5456),
    [anon_sym_unsigned] = ACTIONS(5456),
    [anon_sym_long] = ACTIONS(5456),
    [anon_sym_short] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_register] = ACTIONS(5456),
    [anon_sym_inline] = ACTIONS(5456),
    [anon_sym___inline] = ACTIONS(5456),
    [anon_sym___inline__] = ACTIONS(5456),
    [anon_sym___forceinline] = ACTIONS(5456),
    [anon_sym_thread_local] = ACTIONS(5456),
    [anon_sym___thread] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_constexpr] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_restrict] = ACTIONS(5456),
    [anon_sym___restrict__] = ACTIONS(5456),
    [anon_sym__Atomic] = ACTIONS(5456),
    [anon_sym__Noreturn] = ACTIONS(5456),
    [anon_sym_noreturn] = ACTIONS(5456),
    [anon_sym__Nonnull] = ACTIONS(5456),
    [anon_sym_mutable] = ACTIONS(5456),
    [anon_sym_constinit] = ACTIONS(5456),
    [anon_sym_consteval] = ACTIONS(5456),
    [anon_sym_alignas] = ACTIONS(5456),
    [anon_sym__Alignas] = ACTIONS(5456),
    [sym_primitive_type] = ACTIONS(5456),
    [anon_sym_enum] = ACTIONS(5456),
    [anon_sym_class] = ACTIONS(5456),
    [anon_sym_struct] = ACTIONS(5456),
    [anon_sym_union] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5456),
    [anon_sym_decltype] = ACTIONS(5456),
    [anon_sym_explicit] = ACTIONS(5456),
    [anon_sym_typename] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_template] = ACTIONS(5456),
    [anon_sym_operator] = ACTIONS(5456),
    [anon_sym_friend] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_static_assert] = ACTIONS(5456),
  },
  [1825] = {
    [sym_identifier] = ACTIONS(4951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4953),
    [anon_sym_COMMA] = ACTIONS(4953),
    [anon_sym_RPAREN] = ACTIONS(4953),
    [anon_sym_LPAREN2] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4953),
    [anon_sym_SLASH] = ACTIONS(4951),
    [anon_sym_PERCENT] = ACTIONS(4953),
    [anon_sym_PIPE_PIPE] = ACTIONS(4953),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_PIPE] = ACTIONS(4951),
    [anon_sym_CARET] = ACTIONS(4953),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_EQ_EQ] = ACTIONS(4953),
    [anon_sym_BANG_EQ] = ACTIONS(4953),
    [anon_sym_GT] = ACTIONS(4951),
    [anon_sym_GT_EQ] = ACTIONS(4953),
    [anon_sym_LT_EQ] = ACTIONS(4951),
    [anon_sym_LT] = ACTIONS(4951),
    [anon_sym_LT_LT] = ACTIONS(4953),
    [anon_sym_GT_GT] = ACTIONS(4953),
    [anon_sym_SEMI] = ACTIONS(4953),
    [anon_sym___extension__] = ACTIONS(4951),
    [anon_sym___attribute__] = ACTIONS(4951),
    [anon_sym___attribute] = ACTIONS(4951),
    [anon_sym_COLON] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4953),
    [anon_sym___based] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4953),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym_signed] = ACTIONS(4951),
    [anon_sym_unsigned] = ACTIONS(4951),
    [anon_sym_long] = ACTIONS(4951),
    [anon_sym_short] = ACTIONS(4951),
    [anon_sym_LBRACK] = ACTIONS(4953),
    [anon_sym_RBRACK] = ACTIONS(4953),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym_restrict] = ACTIONS(4951),
    [anon_sym___restrict__] = ACTIONS(4951),
    [anon_sym__Atomic] = ACTIONS(4951),
    [anon_sym__Noreturn] = ACTIONS(4951),
    [anon_sym_noreturn] = ACTIONS(4951),
    [anon_sym__Nonnull] = ACTIONS(4951),
    [anon_sym_mutable] = ACTIONS(4951),
    [anon_sym_constinit] = ACTIONS(4951),
    [anon_sym_consteval] = ACTIONS(4951),
    [anon_sym_alignas] = ACTIONS(4951),
    [anon_sym__Alignas] = ACTIONS(4951),
    [sym_primitive_type] = ACTIONS(4951),
    [anon_sym_QMARK] = ACTIONS(4953),
    [anon_sym_LT_EQ_GT] = ACTIONS(4953),
    [anon_sym_or] = ACTIONS(4951),
    [anon_sym_and] = ACTIONS(4951),
    [anon_sym_bitor] = ACTIONS(4951),
    [anon_sym_xor] = ACTIONS(4951),
    [anon_sym_bitand] = ACTIONS(4951),
    [anon_sym_not_eq] = ACTIONS(4951),
    [anon_sym_DASH_DASH] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4953),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_DOT_STAR] = ACTIONS(4953),
    [anon_sym_DASH_GT] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4951),
    [anon_sym_decltype] = ACTIONS(4951),
    [anon_sym_final] = ACTIONS(4951),
    [anon_sym_override] = ACTIONS(4951),
    [anon_sym_requires] = ACTIONS(4951),
  },
  [1826] = {
    [sym_identifier] = ACTIONS(4959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4961),
    [anon_sym_SLASH] = ACTIONS(4959),
    [anon_sym_PERCENT] = ACTIONS(4961),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4959),
    [anon_sym_CARET] = ACTIONS(4961),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4959),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_LT_LT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym___extension__] = ACTIONS(4959),
    [anon_sym___attribute__] = ACTIONS(4959),
    [anon_sym___attribute] = ACTIONS(4959),
    [anon_sym_COLON] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(4961),
    [anon_sym___based] = ACTIONS(4959),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_RBRACE] = ACTIONS(4961),
    [anon_sym_signed] = ACTIONS(4959),
    [anon_sym_unsigned] = ACTIONS(4959),
    [anon_sym_long] = ACTIONS(4959),
    [anon_sym_short] = ACTIONS(4959),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_RBRACK] = ACTIONS(4961),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_constexpr] = ACTIONS(4959),
    [anon_sym_volatile] = ACTIONS(4959),
    [anon_sym_restrict] = ACTIONS(4959),
    [anon_sym___restrict__] = ACTIONS(4959),
    [anon_sym__Atomic] = ACTIONS(4959),
    [anon_sym__Noreturn] = ACTIONS(4959),
    [anon_sym_noreturn] = ACTIONS(4959),
    [anon_sym__Nonnull] = ACTIONS(4959),
    [anon_sym_mutable] = ACTIONS(4959),
    [anon_sym_constinit] = ACTIONS(4959),
    [anon_sym_consteval] = ACTIONS(4959),
    [anon_sym_alignas] = ACTIONS(4959),
    [anon_sym__Alignas] = ACTIONS(4959),
    [sym_primitive_type] = ACTIONS(4959),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4959),
    [anon_sym_and] = ACTIONS(4959),
    [anon_sym_bitor] = ACTIONS(4959),
    [anon_sym_xor] = ACTIONS(4959),
    [anon_sym_bitand] = ACTIONS(4959),
    [anon_sym_not_eq] = ACTIONS(4959),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4959),
    [anon_sym_decltype] = ACTIONS(4959),
    [anon_sym_final] = ACTIONS(4959),
    [anon_sym_override] = ACTIONS(4959),
    [anon_sym_requires] = ACTIONS(4959),
  },
  [1827] = {
    [sym_identifier] = ACTIONS(2851),
    [aux_sym_preproc_def_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token2] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2851),
    [aux_sym_preproc_else_token1] = ACTIONS(2851),
    [aux_sym_preproc_elif_token1] = ACTIONS(2851),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2851),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2851),
    [sym_preproc_directive] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2853),
    [anon_sym_TILDE] = ACTIONS(2853),
    [anon_sym_STAR] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym___extension__] = ACTIONS(2851),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_virtual] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(2851),
    [anon_sym___attribute__] = ACTIONS(2851),
    [anon_sym___attribute] = ACTIONS(2851),
    [anon_sym_using] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2853),
    [anon_sym___declspec] = ACTIONS(2851),
    [anon_sym___based] = ACTIONS(2851),
    [anon_sym_signed] = ACTIONS(2851),
    [anon_sym_unsigned] = ACTIONS(2851),
    [anon_sym_long] = ACTIONS(2851),
    [anon_sym_short] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_static] = ACTIONS(2851),
    [anon_sym_register] = ACTIONS(2851),
    [anon_sym_inline] = ACTIONS(2851),
    [anon_sym___inline] = ACTIONS(2851),
    [anon_sym___inline__] = ACTIONS(2851),
    [anon_sym___forceinline] = ACTIONS(2851),
    [anon_sym_thread_local] = ACTIONS(2851),
    [anon_sym___thread] = ACTIONS(2851),
    [anon_sym_const] = ACTIONS(2851),
    [anon_sym_constexpr] = ACTIONS(2851),
    [anon_sym_volatile] = ACTIONS(2851),
    [anon_sym_restrict] = ACTIONS(2851),
    [anon_sym___restrict__] = ACTIONS(2851),
    [anon_sym__Atomic] = ACTIONS(2851),
    [anon_sym__Noreturn] = ACTIONS(2851),
    [anon_sym_noreturn] = ACTIONS(2851),
    [anon_sym__Nonnull] = ACTIONS(2851),
    [anon_sym_mutable] = ACTIONS(2851),
    [anon_sym_constinit] = ACTIONS(2851),
    [anon_sym_consteval] = ACTIONS(2851),
    [anon_sym_alignas] = ACTIONS(2851),
    [anon_sym__Alignas] = ACTIONS(2851),
    [sym_primitive_type] = ACTIONS(2851),
    [anon_sym_enum] = ACTIONS(2851),
    [anon_sym_class] = ACTIONS(2851),
    [anon_sym_struct] = ACTIONS(2851),
    [anon_sym_union] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2851),
    [anon_sym_decltype] = ACTIONS(2851),
    [anon_sym_explicit] = ACTIONS(2851),
    [anon_sym_typename] = ACTIONS(2851),
    [anon_sym_private] = ACTIONS(2851),
    [anon_sym_template] = ACTIONS(2851),
    [anon_sym_operator] = ACTIONS(2851),
    [anon_sym_friend] = ACTIONS(2851),
    [anon_sym_public] = ACTIONS(2851),
    [anon_sym_protected] = ACTIONS(2851),
    [anon_sym_static_assert] = ACTIONS(2851),
  },
  [1828] = {
    [sym_identifier] = ACTIONS(2855),
    [aux_sym_preproc_def_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token2] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2855),
    [aux_sym_preproc_else_token1] = ACTIONS(2855),
    [aux_sym_preproc_elif_token1] = ACTIONS(2855),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2855),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2855),
    [sym_preproc_directive] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2857),
    [anon_sym_TILDE] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym___extension__] = ACTIONS(2855),
    [anon_sym_typedef] = ACTIONS(2855),
    [anon_sym_virtual] = ACTIONS(2855),
    [anon_sym_extern] = ACTIONS(2855),
    [anon_sym___attribute__] = ACTIONS(2855),
    [anon_sym___attribute] = ACTIONS(2855),
    [anon_sym_using] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2857),
    [anon_sym___declspec] = ACTIONS(2855),
    [anon_sym___based] = ACTIONS(2855),
    [anon_sym_signed] = ACTIONS(2855),
    [anon_sym_unsigned] = ACTIONS(2855),
    [anon_sym_long] = ACTIONS(2855),
    [anon_sym_short] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(2855),
    [anon_sym_register] = ACTIONS(2855),
    [anon_sym_inline] = ACTIONS(2855),
    [anon_sym___inline] = ACTIONS(2855),
    [anon_sym___inline__] = ACTIONS(2855),
    [anon_sym___forceinline] = ACTIONS(2855),
    [anon_sym_thread_local] = ACTIONS(2855),
    [anon_sym___thread] = ACTIONS(2855),
    [anon_sym_const] = ACTIONS(2855),
    [anon_sym_constexpr] = ACTIONS(2855),
    [anon_sym_volatile] = ACTIONS(2855),
    [anon_sym_restrict] = ACTIONS(2855),
    [anon_sym___restrict__] = ACTIONS(2855),
    [anon_sym__Atomic] = ACTIONS(2855),
    [anon_sym__Noreturn] = ACTIONS(2855),
    [anon_sym_noreturn] = ACTIONS(2855),
    [anon_sym__Nonnull] = ACTIONS(2855),
    [anon_sym_mutable] = ACTIONS(2855),
    [anon_sym_constinit] = ACTIONS(2855),
    [anon_sym_consteval] = ACTIONS(2855),
    [anon_sym_alignas] = ACTIONS(2855),
    [anon_sym__Alignas] = ACTIONS(2855),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_enum] = ACTIONS(2855),
    [anon_sym_class] = ACTIONS(2855),
    [anon_sym_struct] = ACTIONS(2855),
    [anon_sym_union] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2855),
    [anon_sym_explicit] = ACTIONS(2855),
    [anon_sym_typename] = ACTIONS(2855),
    [anon_sym_private] = ACTIONS(2855),
    [anon_sym_template] = ACTIONS(2855),
    [anon_sym_operator] = ACTIONS(2855),
    [anon_sym_friend] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(2855),
    [anon_sym_protected] = ACTIONS(2855),
    [anon_sym_static_assert] = ACTIONS(2855),
  },
  [1829] = {
    [sym_identifier] = ACTIONS(2859),
    [aux_sym_preproc_def_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token2] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2859),
    [aux_sym_preproc_else_token1] = ACTIONS(2859),
    [aux_sym_preproc_elif_token1] = ACTIONS(2859),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2859),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2859),
    [sym_preproc_directive] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [anon_sym_STAR] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym___extension__] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2859),
    [anon_sym_virtual] = ACTIONS(2859),
    [anon_sym_extern] = ACTIONS(2859),
    [anon_sym___attribute__] = ACTIONS(2859),
    [anon_sym___attribute] = ACTIONS(2859),
    [anon_sym_using] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2861),
    [anon_sym___declspec] = ACTIONS(2859),
    [anon_sym___based] = ACTIONS(2859),
    [anon_sym_signed] = ACTIONS(2859),
    [anon_sym_unsigned] = ACTIONS(2859),
    [anon_sym_long] = ACTIONS(2859),
    [anon_sym_short] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2859),
    [anon_sym_register] = ACTIONS(2859),
    [anon_sym_inline] = ACTIONS(2859),
    [anon_sym___inline] = ACTIONS(2859),
    [anon_sym___inline__] = ACTIONS(2859),
    [anon_sym___forceinline] = ACTIONS(2859),
    [anon_sym_thread_local] = ACTIONS(2859),
    [anon_sym___thread] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2859),
    [anon_sym_constexpr] = ACTIONS(2859),
    [anon_sym_volatile] = ACTIONS(2859),
    [anon_sym_restrict] = ACTIONS(2859),
    [anon_sym___restrict__] = ACTIONS(2859),
    [anon_sym__Atomic] = ACTIONS(2859),
    [anon_sym__Noreturn] = ACTIONS(2859),
    [anon_sym_noreturn] = ACTIONS(2859),
    [anon_sym__Nonnull] = ACTIONS(2859),
    [anon_sym_mutable] = ACTIONS(2859),
    [anon_sym_constinit] = ACTIONS(2859),
    [anon_sym_consteval] = ACTIONS(2859),
    [anon_sym_alignas] = ACTIONS(2859),
    [anon_sym__Alignas] = ACTIONS(2859),
    [sym_primitive_type] = ACTIONS(2859),
    [anon_sym_enum] = ACTIONS(2859),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2859),
    [anon_sym_union] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2859),
    [anon_sym_decltype] = ACTIONS(2859),
    [anon_sym_explicit] = ACTIONS(2859),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_private] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(2859),
    [anon_sym_operator] = ACTIONS(2859),
    [anon_sym_friend] = ACTIONS(2859),
    [anon_sym_public] = ACTIONS(2859),
    [anon_sym_protected] = ACTIONS(2859),
    [anon_sym_static_assert] = ACTIONS(2859),
  },
  [1830] = {
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4990),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_RPAREN] = ACTIONS(4990),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4988),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_SLASH] = ACTIONS(4988),
    [anon_sym_PERCENT] = ACTIONS(4990),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym_EQ_EQ] = ACTIONS(4990),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4988),
    [anon_sym_GT_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4990),
    [anon_sym_GT_GT] = ACTIONS(4990),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym___attribute] = ACTIONS(4988),
    [anon_sym_COLON] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_RBRACE] = ACTIONS(4990),
    [anon_sym_signed] = ACTIONS(4988),
    [anon_sym_unsigned] = ACTIONS(4988),
    [anon_sym_long] = ACTIONS(4988),
    [anon_sym_short] = ACTIONS(4988),
    [anon_sym_LBRACK] = ACTIONS(4990),
    [anon_sym_RBRACK] = ACTIONS(4990),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym__Nonnull] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym__Alignas] = ACTIONS(4988),
    [sym_primitive_type] = ACTIONS(4988),
    [anon_sym_QMARK] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_and] = ACTIONS(4988),
    [anon_sym_bitor] = ACTIONS(4988),
    [anon_sym_xor] = ACTIONS(4988),
    [anon_sym_bitand] = ACTIONS(4988),
    [anon_sym_not_eq] = ACTIONS(4988),
    [anon_sym_DASH_DASH] = ACTIONS(4990),
    [anon_sym_PLUS_PLUS] = ACTIONS(4990),
    [anon_sym_DOT] = ACTIONS(4988),
    [anon_sym_DOT_STAR] = ACTIONS(4990),
    [anon_sym_DASH_GT] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_final] = ACTIONS(4988),
    [anon_sym_override] = ACTIONS(4988),
    [anon_sym_requires] = ACTIONS(4988),
  },
  [1831] = {
    [sym__declaration_modifiers] = STATE(3282),
    [sym_attribute_specifier] = STATE(3282),
    [sym_attribute_declaration] = STATE(3282),
    [sym_ms_declspec_modifier] = STATE(3282),
    [sym_ms_based_modifier] = STATE(8682),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_function_declarator] = STATE(6296),
    [sym_array_declarator] = STATE(5998),
    [sym_storage_class_specifier] = STATE(3282),
    [sym_type_qualifier] = STATE(3282),
    [sym_alignas_qualifier] = STATE(2975),
    [sym_decltype] = STATE(8601),
    [sym_explicit_function_specifier] = STATE(3282),
    [sym_operator_cast] = STATE(6785),
    [sym__constructor_specifiers] = STATE(3282),
    [sym_reference_declarator] = STATE(5998),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5591),
    [sym_qualified_identifier] = STATE(5998),
    [sym_qualified_operator_cast_identifier] = STATE(6785),
    [sym_operator_name] = STATE(5998),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2983),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5464),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5468),
    [anon_sym___attribute] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5476),
    [anon_sym__Alignas] = ACTIONS(5476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(141),
  },
  [1832] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token2] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [aux_sym_preproc_else_token1] = ACTIONS(2771),
    [aux_sym_preproc_elif_token1] = ACTIONS(2771),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_private] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_friend] = ACTIONS(2771),
    [anon_sym_public] = ACTIONS(2771),
    [anon_sym_protected] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
  },
  [1833] = {
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token2] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [aux_sym_preproc_else_token1] = ACTIONS(3108),
    [aux_sym_preproc_elif_token1] = ACTIONS(3108),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym___attribute] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym__Nonnull] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym__Alignas] = ACTIONS(3108),
    [sym_primitive_type] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_private] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_friend] = ACTIONS(3108),
    [anon_sym_public] = ACTIONS(3108),
    [anon_sym_protected] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
  },
  [1834] = {
    [sym_identifier] = ACTIONS(5637),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5639),
    [anon_sym_COMMA] = ACTIONS(5639),
    [anon_sym_RPAREN] = ACTIONS(5639),
    [anon_sym_LPAREN2] = ACTIONS(5639),
    [anon_sym_DASH] = ACTIONS(5637),
    [anon_sym_PLUS] = ACTIONS(5637),
    [anon_sym_STAR] = ACTIONS(5639),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_PERCENT] = ACTIONS(5639),
    [anon_sym_PIPE_PIPE] = ACTIONS(5639),
    [anon_sym_AMP_AMP] = ACTIONS(5639),
    [anon_sym_PIPE] = ACTIONS(5637),
    [anon_sym_CARET] = ACTIONS(5639),
    [anon_sym_AMP] = ACTIONS(5637),
    [anon_sym_EQ_EQ] = ACTIONS(5639),
    [anon_sym_BANG_EQ] = ACTIONS(5639),
    [anon_sym_GT] = ACTIONS(5637),
    [anon_sym_GT_EQ] = ACTIONS(5639),
    [anon_sym_LT_EQ] = ACTIONS(5637),
    [anon_sym_LT] = ACTIONS(5637),
    [anon_sym_LT_LT] = ACTIONS(5639),
    [anon_sym_GT_GT] = ACTIONS(5639),
    [anon_sym_SEMI] = ACTIONS(5639),
    [anon_sym___extension__] = ACTIONS(5637),
    [anon_sym___attribute__] = ACTIONS(5637),
    [anon_sym___attribute] = ACTIONS(5637),
    [anon_sym_COLON] = ACTIONS(5639),
    [anon_sym___based] = ACTIONS(5637),
    [anon_sym_LBRACE] = ACTIONS(5639),
    [anon_sym_RBRACE] = ACTIONS(5639),
    [anon_sym_signed] = ACTIONS(5637),
    [anon_sym_unsigned] = ACTIONS(5637),
    [anon_sym_long] = ACTIONS(5637),
    [anon_sym_short] = ACTIONS(5637),
    [anon_sym_LBRACK] = ACTIONS(5639),
    [anon_sym_RBRACK] = ACTIONS(5639),
    [anon_sym_const] = ACTIONS(5637),
    [anon_sym_constexpr] = ACTIONS(5637),
    [anon_sym_volatile] = ACTIONS(5637),
    [anon_sym_restrict] = ACTIONS(5637),
    [anon_sym___restrict__] = ACTIONS(5637),
    [anon_sym__Atomic] = ACTIONS(5637),
    [anon_sym__Noreturn] = ACTIONS(5637),
    [anon_sym_noreturn] = ACTIONS(5637),
    [anon_sym__Nonnull] = ACTIONS(5637),
    [anon_sym_mutable] = ACTIONS(5637),
    [anon_sym_constinit] = ACTIONS(5637),
    [anon_sym_consteval] = ACTIONS(5637),
    [anon_sym_alignas] = ACTIONS(5637),
    [anon_sym__Alignas] = ACTIONS(5637),
    [sym_primitive_type] = ACTIONS(5637),
    [anon_sym_QMARK] = ACTIONS(5639),
    [anon_sym_LT_EQ_GT] = ACTIONS(5639),
    [anon_sym_or] = ACTIONS(5637),
    [anon_sym_and] = ACTIONS(5637),
    [anon_sym_bitor] = ACTIONS(5637),
    [anon_sym_xor] = ACTIONS(5637),
    [anon_sym_bitand] = ACTIONS(5637),
    [anon_sym_not_eq] = ACTIONS(5637),
    [anon_sym_DASH_DASH] = ACTIONS(5639),
    [anon_sym_PLUS_PLUS] = ACTIONS(5639),
    [anon_sym_DOT] = ACTIONS(5637),
    [anon_sym_DOT_STAR] = ACTIONS(5639),
    [anon_sym_DASH_GT] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5637),
    [anon_sym_decltype] = ACTIONS(5637),
    [anon_sym_final] = ACTIONS(5637),
    [anon_sym_override] = ACTIONS(5637),
    [anon_sym_requires] = ACTIONS(5637),
  },
  [1835] = {
    [sym_identifier] = ACTIONS(5641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5643),
    [anon_sym_COMMA] = ACTIONS(5643),
    [anon_sym_RPAREN] = ACTIONS(5643),
    [anon_sym_LPAREN2] = ACTIONS(5643),
    [anon_sym_TILDE] = ACTIONS(5643),
    [anon_sym_STAR] = ACTIONS(5643),
    [anon_sym_AMP_AMP] = ACTIONS(5643),
    [anon_sym_AMP] = ACTIONS(5641),
    [anon_sym_SEMI] = ACTIONS(5643),
    [anon_sym___extension__] = ACTIONS(5641),
    [anon_sym_virtual] = ACTIONS(5641),
    [anon_sym_extern] = ACTIONS(5641),
    [anon_sym___attribute__] = ACTIONS(5641),
    [anon_sym___attribute] = ACTIONS(5641),
    [anon_sym_COLON_COLON] = ACTIONS(5643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5643),
    [anon_sym___declspec] = ACTIONS(5641),
    [anon_sym___based] = ACTIONS(5641),
    [anon_sym_LBRACE] = ACTIONS(5643),
    [anon_sym_signed] = ACTIONS(5641),
    [anon_sym_unsigned] = ACTIONS(5641),
    [anon_sym_long] = ACTIONS(5641),
    [anon_sym_short] = ACTIONS(5641),
    [anon_sym_LBRACK] = ACTIONS(5641),
    [anon_sym_static] = ACTIONS(5641),
    [anon_sym_EQ] = ACTIONS(5643),
    [anon_sym_register] = ACTIONS(5641),
    [anon_sym_inline] = ACTIONS(5641),
    [anon_sym___inline] = ACTIONS(5641),
    [anon_sym___inline__] = ACTIONS(5641),
    [anon_sym___forceinline] = ACTIONS(5641),
    [anon_sym_thread_local] = ACTIONS(5641),
    [anon_sym___thread] = ACTIONS(5641),
    [anon_sym_const] = ACTIONS(5641),
    [anon_sym_constexpr] = ACTIONS(5641),
    [anon_sym_volatile] = ACTIONS(5641),
    [anon_sym_restrict] = ACTIONS(5641),
    [anon_sym___restrict__] = ACTIONS(5641),
    [anon_sym__Atomic] = ACTIONS(5641),
    [anon_sym__Noreturn] = ACTIONS(5641),
    [anon_sym_noreturn] = ACTIONS(5641),
    [anon_sym__Nonnull] = ACTIONS(5641),
    [anon_sym_mutable] = ACTIONS(5641),
    [anon_sym_constinit] = ACTIONS(5641),
    [anon_sym_consteval] = ACTIONS(5641),
    [anon_sym_alignas] = ACTIONS(5641),
    [anon_sym__Alignas] = ACTIONS(5641),
    [sym_primitive_type] = ACTIONS(5641),
    [anon_sym_enum] = ACTIONS(5641),
    [anon_sym_class] = ACTIONS(5641),
    [anon_sym_struct] = ACTIONS(5641),
    [anon_sym_union] = ACTIONS(5641),
    [anon_sym_asm] = ACTIONS(5641),
    [anon_sym___asm__] = ACTIONS(5641),
    [anon_sym___asm] = ACTIONS(5641),
    [anon_sym_DASH_GT] = ACTIONS(5643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5641),
    [anon_sym_decltype] = ACTIONS(5641),
    [anon_sym_final] = ACTIONS(5641),
    [anon_sym_override] = ACTIONS(5641),
    [anon_sym_explicit] = ACTIONS(5641),
    [anon_sym_typename] = ACTIONS(5641),
    [anon_sym_template] = ACTIONS(5641),
    [anon_sym_GT2] = ACTIONS(5643),
    [anon_sym_operator] = ACTIONS(5641),
    [anon_sym_try] = ACTIONS(5641),
    [anon_sym_noexcept] = ACTIONS(5641),
    [anon_sym_throw] = ACTIONS(5641),
    [anon_sym_requires] = ACTIONS(5641),
  },
  [1836] = {
    [sym_catch_clause] = STATE(1851),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1851),
    [sym_identifier] = ACTIONS(2547),
    [aux_sym_preproc_def_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token2] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2547),
    [sym_preproc_directive] = ACTIONS(2547),
    [anon_sym_LPAREN2] = ACTIONS(2549),
    [anon_sym_TILDE] = ACTIONS(2549),
    [anon_sym_STAR] = ACTIONS(2549),
    [anon_sym_AMP_AMP] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(2549),
    [anon_sym___extension__] = ACTIONS(2547),
    [anon_sym_typedef] = ACTIONS(2547),
    [anon_sym_virtual] = ACTIONS(2547),
    [anon_sym_extern] = ACTIONS(2547),
    [anon_sym___attribute__] = ACTIONS(2547),
    [anon_sym___attribute] = ACTIONS(2547),
    [anon_sym_using] = ACTIONS(2547),
    [anon_sym_COLON_COLON] = ACTIONS(2549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2549),
    [anon_sym___declspec] = ACTIONS(2547),
    [anon_sym___based] = ACTIONS(2547),
    [anon_sym_signed] = ACTIONS(2547),
    [anon_sym_unsigned] = ACTIONS(2547),
    [anon_sym_long] = ACTIONS(2547),
    [anon_sym_short] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_register] = ACTIONS(2547),
    [anon_sym_inline] = ACTIONS(2547),
    [anon_sym___inline] = ACTIONS(2547),
    [anon_sym___inline__] = ACTIONS(2547),
    [anon_sym___forceinline] = ACTIONS(2547),
    [anon_sym_thread_local] = ACTIONS(2547),
    [anon_sym___thread] = ACTIONS(2547),
    [anon_sym_const] = ACTIONS(2547),
    [anon_sym_constexpr] = ACTIONS(2547),
    [anon_sym_volatile] = ACTIONS(2547),
    [anon_sym_restrict] = ACTIONS(2547),
    [anon_sym___restrict__] = ACTIONS(2547),
    [anon_sym__Atomic] = ACTIONS(2547),
    [anon_sym__Noreturn] = ACTIONS(2547),
    [anon_sym_noreturn] = ACTIONS(2547),
    [anon_sym__Nonnull] = ACTIONS(2547),
    [anon_sym_mutable] = ACTIONS(2547),
    [anon_sym_constinit] = ACTIONS(2547),
    [anon_sym_consteval] = ACTIONS(2547),
    [anon_sym_alignas] = ACTIONS(2547),
    [anon_sym__Alignas] = ACTIONS(2547),
    [sym_primitive_type] = ACTIONS(2547),
    [anon_sym_enum] = ACTIONS(2547),
    [anon_sym_class] = ACTIONS(2547),
    [anon_sym_struct] = ACTIONS(2547),
    [anon_sym_union] = ACTIONS(2547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2547),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_template] = ACTIONS(2547),
    [anon_sym_operator] = ACTIONS(2547),
    [anon_sym_friend] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_static_assert] = ACTIONS(2547),
    [anon_sym_catch] = ACTIONS(5645),
  },
  [1837] = {
    [sym_identifier] = ACTIONS(5647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5649),
    [anon_sym_COMMA] = ACTIONS(5649),
    [anon_sym_RPAREN] = ACTIONS(5649),
    [anon_sym_LPAREN2] = ACTIONS(5649),
    [anon_sym_DASH] = ACTIONS(5647),
    [anon_sym_PLUS] = ACTIONS(5647),
    [anon_sym_STAR] = ACTIONS(5649),
    [anon_sym_SLASH] = ACTIONS(5647),
    [anon_sym_PERCENT] = ACTIONS(5649),
    [anon_sym_PIPE_PIPE] = ACTIONS(5649),
    [anon_sym_AMP_AMP] = ACTIONS(5649),
    [anon_sym_PIPE] = ACTIONS(5647),
    [anon_sym_CARET] = ACTIONS(5649),
    [anon_sym_AMP] = ACTIONS(5647),
    [anon_sym_EQ_EQ] = ACTIONS(5649),
    [anon_sym_BANG_EQ] = ACTIONS(5649),
    [anon_sym_GT] = ACTIONS(5647),
    [anon_sym_GT_EQ] = ACTIONS(5649),
    [anon_sym_LT_EQ] = ACTIONS(5647),
    [anon_sym_LT] = ACTIONS(5647),
    [anon_sym_LT_LT] = ACTIONS(5649),
    [anon_sym_GT_GT] = ACTIONS(5649),
    [anon_sym_SEMI] = ACTIONS(5649),
    [anon_sym___extension__] = ACTIONS(5647),
    [anon_sym___attribute__] = ACTIONS(5647),
    [anon_sym___attribute] = ACTIONS(5647),
    [anon_sym_COLON] = ACTIONS(5649),
    [anon_sym___based] = ACTIONS(5647),
    [anon_sym_LBRACE] = ACTIONS(5649),
    [anon_sym_RBRACE] = ACTIONS(5649),
    [anon_sym_signed] = ACTIONS(5647),
    [anon_sym_unsigned] = ACTIONS(5647),
    [anon_sym_long] = ACTIONS(5647),
    [anon_sym_short] = ACTIONS(5647),
    [anon_sym_LBRACK] = ACTIONS(5649),
    [anon_sym_RBRACK] = ACTIONS(5649),
    [anon_sym_const] = ACTIONS(5647),
    [anon_sym_constexpr] = ACTIONS(5647),
    [anon_sym_volatile] = ACTIONS(5647),
    [anon_sym_restrict] = ACTIONS(5647),
    [anon_sym___restrict__] = ACTIONS(5647),
    [anon_sym__Atomic] = ACTIONS(5647),
    [anon_sym__Noreturn] = ACTIONS(5647),
    [anon_sym_noreturn] = ACTIONS(5647),
    [anon_sym__Nonnull] = ACTIONS(5647),
    [anon_sym_mutable] = ACTIONS(5647),
    [anon_sym_constinit] = ACTIONS(5647),
    [anon_sym_consteval] = ACTIONS(5647),
    [anon_sym_alignas] = ACTIONS(5647),
    [anon_sym__Alignas] = ACTIONS(5647),
    [sym_primitive_type] = ACTIONS(5647),
    [anon_sym_QMARK] = ACTIONS(5649),
    [anon_sym_LT_EQ_GT] = ACTIONS(5649),
    [anon_sym_or] = ACTIONS(5647),
    [anon_sym_and] = ACTIONS(5647),
    [anon_sym_bitor] = ACTIONS(5647),
    [anon_sym_xor] = ACTIONS(5647),
    [anon_sym_bitand] = ACTIONS(5647),
    [anon_sym_not_eq] = ACTIONS(5647),
    [anon_sym_DASH_DASH] = ACTIONS(5649),
    [anon_sym_PLUS_PLUS] = ACTIONS(5649),
    [anon_sym_DOT] = ACTIONS(5647),
    [anon_sym_DOT_STAR] = ACTIONS(5649),
    [anon_sym_DASH_GT] = ACTIONS(5649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5647),
    [anon_sym_decltype] = ACTIONS(5647),
    [anon_sym_final] = ACTIONS(5647),
    [anon_sym_override] = ACTIONS(5647),
    [anon_sym_requires] = ACTIONS(5647),
  },
  [1838] = {
    [sym_catch_clause] = STATE(1851),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1851),
    [sym_identifier] = ACTIONS(2590),
    [aux_sym_preproc_def_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token2] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2590),
    [sym_preproc_directive] = ACTIONS(2590),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_TILDE] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym___extension__] = ACTIONS(2590),
    [anon_sym_typedef] = ACTIONS(2590),
    [anon_sym_virtual] = ACTIONS(2590),
    [anon_sym_extern] = ACTIONS(2590),
    [anon_sym___attribute__] = ACTIONS(2590),
    [anon_sym___attribute] = ACTIONS(2590),
    [anon_sym_using] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2592),
    [anon_sym___declspec] = ACTIONS(2590),
    [anon_sym___based] = ACTIONS(2590),
    [anon_sym_signed] = ACTIONS(2590),
    [anon_sym_unsigned] = ACTIONS(2590),
    [anon_sym_long] = ACTIONS(2590),
    [anon_sym_short] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2590),
    [anon_sym_register] = ACTIONS(2590),
    [anon_sym_inline] = ACTIONS(2590),
    [anon_sym___inline] = ACTIONS(2590),
    [anon_sym___inline__] = ACTIONS(2590),
    [anon_sym___forceinline] = ACTIONS(2590),
    [anon_sym_thread_local] = ACTIONS(2590),
    [anon_sym___thread] = ACTIONS(2590),
    [anon_sym_const] = ACTIONS(2590),
    [anon_sym_constexpr] = ACTIONS(2590),
    [anon_sym_volatile] = ACTIONS(2590),
    [anon_sym_restrict] = ACTIONS(2590),
    [anon_sym___restrict__] = ACTIONS(2590),
    [anon_sym__Atomic] = ACTIONS(2590),
    [anon_sym__Noreturn] = ACTIONS(2590),
    [anon_sym_noreturn] = ACTIONS(2590),
    [anon_sym__Nonnull] = ACTIONS(2590),
    [anon_sym_mutable] = ACTIONS(2590),
    [anon_sym_constinit] = ACTIONS(2590),
    [anon_sym_consteval] = ACTIONS(2590),
    [anon_sym_alignas] = ACTIONS(2590),
    [anon_sym__Alignas] = ACTIONS(2590),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_enum] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_struct] = ACTIONS(2590),
    [anon_sym_union] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2590),
    [anon_sym_decltype] = ACTIONS(2590),
    [anon_sym_explicit] = ACTIONS(2590),
    [anon_sym_typename] = ACTIONS(2590),
    [anon_sym_private] = ACTIONS(2590),
    [anon_sym_template] = ACTIONS(2590),
    [anon_sym_operator] = ACTIONS(2590),
    [anon_sym_friend] = ACTIONS(2590),
    [anon_sym_public] = ACTIONS(2590),
    [anon_sym_protected] = ACTIONS(2590),
    [anon_sym_static_assert] = ACTIONS(2590),
    [anon_sym_catch] = ACTIONS(5645),
  },
  [1839] = {
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5653),
    [anon_sym_COMMA] = ACTIONS(5653),
    [anon_sym_RPAREN] = ACTIONS(5653),
    [anon_sym_LPAREN2] = ACTIONS(5653),
    [anon_sym_DASH] = ACTIONS(5651),
    [anon_sym_PLUS] = ACTIONS(5651),
    [anon_sym_STAR] = ACTIONS(5653),
    [anon_sym_SLASH] = ACTIONS(5651),
    [anon_sym_PERCENT] = ACTIONS(5653),
    [anon_sym_PIPE_PIPE] = ACTIONS(5653),
    [anon_sym_AMP_AMP] = ACTIONS(5653),
    [anon_sym_PIPE] = ACTIONS(5651),
    [anon_sym_CARET] = ACTIONS(5653),
    [anon_sym_AMP] = ACTIONS(5651),
    [anon_sym_EQ_EQ] = ACTIONS(5653),
    [anon_sym_BANG_EQ] = ACTIONS(5653),
    [anon_sym_GT] = ACTIONS(5651),
    [anon_sym_GT_EQ] = ACTIONS(5653),
    [anon_sym_LT_EQ] = ACTIONS(5651),
    [anon_sym_LT] = ACTIONS(5651),
    [anon_sym_LT_LT] = ACTIONS(5653),
    [anon_sym_GT_GT] = ACTIONS(5653),
    [anon_sym_SEMI] = ACTIONS(5653),
    [anon_sym___extension__] = ACTIONS(5651),
    [anon_sym___attribute__] = ACTIONS(5651),
    [anon_sym___attribute] = ACTIONS(5651),
    [anon_sym_COLON] = ACTIONS(5653),
    [anon_sym___based] = ACTIONS(5651),
    [anon_sym_LBRACE] = ACTIONS(5653),
    [anon_sym_RBRACE] = ACTIONS(5653),
    [anon_sym_signed] = ACTIONS(5651),
    [anon_sym_unsigned] = ACTIONS(5651),
    [anon_sym_long] = ACTIONS(5651),
    [anon_sym_short] = ACTIONS(5651),
    [anon_sym_LBRACK] = ACTIONS(5653),
    [anon_sym_RBRACK] = ACTIONS(5653),
    [anon_sym_const] = ACTIONS(5651),
    [anon_sym_constexpr] = ACTIONS(5651),
    [anon_sym_volatile] = ACTIONS(5651),
    [anon_sym_restrict] = ACTIONS(5651),
    [anon_sym___restrict__] = ACTIONS(5651),
    [anon_sym__Atomic] = ACTIONS(5651),
    [anon_sym__Noreturn] = ACTIONS(5651),
    [anon_sym_noreturn] = ACTIONS(5651),
    [anon_sym__Nonnull] = ACTIONS(5651),
    [anon_sym_mutable] = ACTIONS(5651),
    [anon_sym_constinit] = ACTIONS(5651),
    [anon_sym_consteval] = ACTIONS(5651),
    [anon_sym_alignas] = ACTIONS(5651),
    [anon_sym__Alignas] = ACTIONS(5651),
    [sym_primitive_type] = ACTIONS(5651),
    [anon_sym_QMARK] = ACTIONS(5653),
    [anon_sym_LT_EQ_GT] = ACTIONS(5653),
    [anon_sym_or] = ACTIONS(5651),
    [anon_sym_and] = ACTIONS(5651),
    [anon_sym_bitor] = ACTIONS(5651),
    [anon_sym_xor] = ACTIONS(5651),
    [anon_sym_bitand] = ACTIONS(5651),
    [anon_sym_not_eq] = ACTIONS(5651),
    [anon_sym_DASH_DASH] = ACTIONS(5653),
    [anon_sym_PLUS_PLUS] = ACTIONS(5653),
    [anon_sym_DOT] = ACTIONS(5651),
    [anon_sym_DOT_STAR] = ACTIONS(5653),
    [anon_sym_DASH_GT] = ACTIONS(5653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5651),
    [anon_sym_decltype] = ACTIONS(5651),
    [anon_sym_final] = ACTIONS(5651),
    [anon_sym_override] = ACTIONS(5651),
    [anon_sym_requires] = ACTIONS(5651),
  },
  [1840] = {
    [sym_identifier] = ACTIONS(5655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5657),
    [anon_sym_COMMA] = ACTIONS(5657),
    [anon_sym_RPAREN] = ACTIONS(5657),
    [anon_sym_LPAREN2] = ACTIONS(5657),
    [anon_sym_DASH] = ACTIONS(5655),
    [anon_sym_PLUS] = ACTIONS(5655),
    [anon_sym_STAR] = ACTIONS(5657),
    [anon_sym_SLASH] = ACTIONS(5655),
    [anon_sym_PERCENT] = ACTIONS(5657),
    [anon_sym_PIPE_PIPE] = ACTIONS(5657),
    [anon_sym_AMP_AMP] = ACTIONS(5657),
    [anon_sym_PIPE] = ACTIONS(5655),
    [anon_sym_CARET] = ACTIONS(5657),
    [anon_sym_AMP] = ACTIONS(5655),
    [anon_sym_EQ_EQ] = ACTIONS(5657),
    [anon_sym_BANG_EQ] = ACTIONS(5657),
    [anon_sym_GT] = ACTIONS(5655),
    [anon_sym_GT_EQ] = ACTIONS(5657),
    [anon_sym_LT_EQ] = ACTIONS(5655),
    [anon_sym_LT] = ACTIONS(5655),
    [anon_sym_LT_LT] = ACTIONS(5657),
    [anon_sym_GT_GT] = ACTIONS(5657),
    [anon_sym_SEMI] = ACTIONS(5657),
    [anon_sym___extension__] = ACTIONS(5655),
    [anon_sym___attribute__] = ACTIONS(5655),
    [anon_sym___attribute] = ACTIONS(5655),
    [anon_sym_COLON] = ACTIONS(5657),
    [anon_sym___based] = ACTIONS(5655),
    [anon_sym_LBRACE] = ACTIONS(5657),
    [anon_sym_RBRACE] = ACTIONS(5657),
    [anon_sym_signed] = ACTIONS(5655),
    [anon_sym_unsigned] = ACTIONS(5655),
    [anon_sym_long] = ACTIONS(5655),
    [anon_sym_short] = ACTIONS(5655),
    [anon_sym_LBRACK] = ACTIONS(5657),
    [anon_sym_RBRACK] = ACTIONS(5657),
    [anon_sym_const] = ACTIONS(5655),
    [anon_sym_constexpr] = ACTIONS(5655),
    [anon_sym_volatile] = ACTIONS(5655),
    [anon_sym_restrict] = ACTIONS(5655),
    [anon_sym___restrict__] = ACTIONS(5655),
    [anon_sym__Atomic] = ACTIONS(5655),
    [anon_sym__Noreturn] = ACTIONS(5655),
    [anon_sym_noreturn] = ACTIONS(5655),
    [anon_sym__Nonnull] = ACTIONS(5655),
    [anon_sym_mutable] = ACTIONS(5655),
    [anon_sym_constinit] = ACTIONS(5655),
    [anon_sym_consteval] = ACTIONS(5655),
    [anon_sym_alignas] = ACTIONS(5655),
    [anon_sym__Alignas] = ACTIONS(5655),
    [sym_primitive_type] = ACTIONS(5655),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_LT_EQ_GT] = ACTIONS(5657),
    [anon_sym_or] = ACTIONS(5655),
    [anon_sym_and] = ACTIONS(5655),
    [anon_sym_bitor] = ACTIONS(5655),
    [anon_sym_xor] = ACTIONS(5655),
    [anon_sym_bitand] = ACTIONS(5655),
    [anon_sym_not_eq] = ACTIONS(5655),
    [anon_sym_DASH_DASH] = ACTIONS(5657),
    [anon_sym_PLUS_PLUS] = ACTIONS(5657),
    [anon_sym_DOT] = ACTIONS(5655),
    [anon_sym_DOT_STAR] = ACTIONS(5657),
    [anon_sym_DASH_GT] = ACTIONS(5657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5655),
    [anon_sym_decltype] = ACTIONS(5655),
    [anon_sym_final] = ACTIONS(5655),
    [anon_sym_override] = ACTIONS(5655),
    [anon_sym_requires] = ACTIONS(5655),
  },
  [1841] = {
    [sym_identifier] = ACTIONS(5659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5661),
    [anon_sym_COMMA] = ACTIONS(5661),
    [anon_sym_RPAREN] = ACTIONS(5661),
    [anon_sym_LPAREN2] = ACTIONS(5661),
    [anon_sym_DASH] = ACTIONS(5659),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5661),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_PERCENT] = ACTIONS(5661),
    [anon_sym_PIPE_PIPE] = ACTIONS(5661),
    [anon_sym_AMP_AMP] = ACTIONS(5661),
    [anon_sym_PIPE] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5661),
    [anon_sym_AMP] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5661),
    [anon_sym_BANG_EQ] = ACTIONS(5661),
    [anon_sym_GT] = ACTIONS(5659),
    [anon_sym_GT_EQ] = ACTIONS(5661),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5659),
    [anon_sym_LT_LT] = ACTIONS(5661),
    [anon_sym_GT_GT] = ACTIONS(5661),
    [anon_sym_SEMI] = ACTIONS(5661),
    [anon_sym___extension__] = ACTIONS(5659),
    [anon_sym___attribute__] = ACTIONS(5659),
    [anon_sym___attribute] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5661),
    [anon_sym___based] = ACTIONS(5659),
    [anon_sym_LBRACE] = ACTIONS(5661),
    [anon_sym_RBRACE] = ACTIONS(5661),
    [anon_sym_signed] = ACTIONS(5659),
    [anon_sym_unsigned] = ACTIONS(5659),
    [anon_sym_long] = ACTIONS(5659),
    [anon_sym_short] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5661),
    [anon_sym_RBRACK] = ACTIONS(5661),
    [anon_sym_const] = ACTIONS(5659),
    [anon_sym_constexpr] = ACTIONS(5659),
    [anon_sym_volatile] = ACTIONS(5659),
    [anon_sym_restrict] = ACTIONS(5659),
    [anon_sym___restrict__] = ACTIONS(5659),
    [anon_sym__Atomic] = ACTIONS(5659),
    [anon_sym__Noreturn] = ACTIONS(5659),
    [anon_sym_noreturn] = ACTIONS(5659),
    [anon_sym__Nonnull] = ACTIONS(5659),
    [anon_sym_mutable] = ACTIONS(5659),
    [anon_sym_constinit] = ACTIONS(5659),
    [anon_sym_consteval] = ACTIONS(5659),
    [anon_sym_alignas] = ACTIONS(5659),
    [anon_sym__Alignas] = ACTIONS(5659),
    [sym_primitive_type] = ACTIONS(5659),
    [anon_sym_QMARK] = ACTIONS(5661),
    [anon_sym_LT_EQ_GT] = ACTIONS(5661),
    [anon_sym_or] = ACTIONS(5659),
    [anon_sym_and] = ACTIONS(5659),
    [anon_sym_bitor] = ACTIONS(5659),
    [anon_sym_xor] = ACTIONS(5659),
    [anon_sym_bitand] = ACTIONS(5659),
    [anon_sym_not_eq] = ACTIONS(5659),
    [anon_sym_DASH_DASH] = ACTIONS(5661),
    [anon_sym_PLUS_PLUS] = ACTIONS(5661),
    [anon_sym_DOT] = ACTIONS(5659),
    [anon_sym_DOT_STAR] = ACTIONS(5661),
    [anon_sym_DASH_GT] = ACTIONS(5661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5659),
    [anon_sym_decltype] = ACTIONS(5659),
    [anon_sym_final] = ACTIONS(5659),
    [anon_sym_override] = ACTIONS(5659),
    [anon_sym_requires] = ACTIONS(5659),
  },
  [1842] = {
    [sym_identifier] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5665),
    [anon_sym_COMMA] = ACTIONS(5665),
    [anon_sym_RPAREN] = ACTIONS(5665),
    [anon_sym_LPAREN2] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5663),
    [anon_sym_STAR] = ACTIONS(5665),
    [anon_sym_SLASH] = ACTIONS(5663),
    [anon_sym_PERCENT] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5665),
    [anon_sym_AMP_AMP] = ACTIONS(5665),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_CARET] = ACTIONS(5665),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_EQ_EQ] = ACTIONS(5665),
    [anon_sym_BANG_EQ] = ACTIONS(5665),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_LT] = ACTIONS(5665),
    [anon_sym_GT_GT] = ACTIONS(5665),
    [anon_sym_SEMI] = ACTIONS(5665),
    [anon_sym___extension__] = ACTIONS(5663),
    [anon_sym___attribute__] = ACTIONS(5663),
    [anon_sym___attribute] = ACTIONS(5663),
    [anon_sym_COLON] = ACTIONS(5665),
    [anon_sym___based] = ACTIONS(5663),
    [anon_sym_LBRACE] = ACTIONS(5665),
    [anon_sym_RBRACE] = ACTIONS(5665),
    [anon_sym_signed] = ACTIONS(5663),
    [anon_sym_unsigned] = ACTIONS(5663),
    [anon_sym_long] = ACTIONS(5663),
    [anon_sym_short] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_RBRACK] = ACTIONS(5665),
    [anon_sym_const] = ACTIONS(5663),
    [anon_sym_constexpr] = ACTIONS(5663),
    [anon_sym_volatile] = ACTIONS(5663),
    [anon_sym_restrict] = ACTIONS(5663),
    [anon_sym___restrict__] = ACTIONS(5663),
    [anon_sym__Atomic] = ACTIONS(5663),
    [anon_sym__Noreturn] = ACTIONS(5663),
    [anon_sym_noreturn] = ACTIONS(5663),
    [anon_sym__Nonnull] = ACTIONS(5663),
    [anon_sym_mutable] = ACTIONS(5663),
    [anon_sym_constinit] = ACTIONS(5663),
    [anon_sym_consteval] = ACTIONS(5663),
    [anon_sym_alignas] = ACTIONS(5663),
    [anon_sym__Alignas] = ACTIONS(5663),
    [sym_primitive_type] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5665),
    [anon_sym_LT_EQ_GT] = ACTIONS(5665),
    [anon_sym_or] = ACTIONS(5663),
    [anon_sym_and] = ACTIONS(5663),
    [anon_sym_bitor] = ACTIONS(5663),
    [anon_sym_xor] = ACTIONS(5663),
    [anon_sym_bitand] = ACTIONS(5663),
    [anon_sym_not_eq] = ACTIONS(5663),
    [anon_sym_DASH_DASH] = ACTIONS(5665),
    [anon_sym_PLUS_PLUS] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5663),
    [anon_sym_DOT_STAR] = ACTIONS(5665),
    [anon_sym_DASH_GT] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5663),
    [anon_sym_decltype] = ACTIONS(5663),
    [anon_sym_final] = ACTIONS(5663),
    [anon_sym_override] = ACTIONS(5663),
    [anon_sym_requires] = ACTIONS(5663),
  },
  [1843] = {
    [sym_identifier] = ACTIONS(5667),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5669),
    [anon_sym_COMMA] = ACTIONS(5669),
    [anon_sym_RPAREN] = ACTIONS(5669),
    [anon_sym_LPAREN2] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5667),
    [anon_sym_PLUS] = ACTIONS(5667),
    [anon_sym_STAR] = ACTIONS(5669),
    [anon_sym_SLASH] = ACTIONS(5667),
    [anon_sym_PERCENT] = ACTIONS(5669),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5667),
    [anon_sym_CARET] = ACTIONS(5669),
    [anon_sym_AMP] = ACTIONS(5667),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5667),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_LT_EQ] = ACTIONS(5667),
    [anon_sym_LT] = ACTIONS(5667),
    [anon_sym_LT_LT] = ACTIONS(5669),
    [anon_sym_GT_GT] = ACTIONS(5669),
    [anon_sym_SEMI] = ACTIONS(5669),
    [anon_sym___extension__] = ACTIONS(5667),
    [anon_sym___attribute__] = ACTIONS(5667),
    [anon_sym___attribute] = ACTIONS(5667),
    [anon_sym_COLON] = ACTIONS(5669),
    [anon_sym___based] = ACTIONS(5667),
    [anon_sym_LBRACE] = ACTIONS(5669),
    [anon_sym_RBRACE] = ACTIONS(5669),
    [anon_sym_signed] = ACTIONS(5667),
    [anon_sym_unsigned] = ACTIONS(5667),
    [anon_sym_long] = ACTIONS(5667),
    [anon_sym_short] = ACTIONS(5667),
    [anon_sym_LBRACK] = ACTIONS(5669),
    [anon_sym_RBRACK] = ACTIONS(5669),
    [anon_sym_const] = ACTIONS(5667),
    [anon_sym_constexpr] = ACTIONS(5667),
    [anon_sym_volatile] = ACTIONS(5667),
    [anon_sym_restrict] = ACTIONS(5667),
    [anon_sym___restrict__] = ACTIONS(5667),
    [anon_sym__Atomic] = ACTIONS(5667),
    [anon_sym__Noreturn] = ACTIONS(5667),
    [anon_sym_noreturn] = ACTIONS(5667),
    [anon_sym__Nonnull] = ACTIONS(5667),
    [anon_sym_mutable] = ACTIONS(5667),
    [anon_sym_constinit] = ACTIONS(5667),
    [anon_sym_consteval] = ACTIONS(5667),
    [anon_sym_alignas] = ACTIONS(5667),
    [anon_sym__Alignas] = ACTIONS(5667),
    [sym_primitive_type] = ACTIONS(5667),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_LT_EQ_GT] = ACTIONS(5669),
    [anon_sym_or] = ACTIONS(5667),
    [anon_sym_and] = ACTIONS(5667),
    [anon_sym_bitor] = ACTIONS(5667),
    [anon_sym_xor] = ACTIONS(5667),
    [anon_sym_bitand] = ACTIONS(5667),
    [anon_sym_not_eq] = ACTIONS(5667),
    [anon_sym_DASH_DASH] = ACTIONS(5669),
    [anon_sym_PLUS_PLUS] = ACTIONS(5669),
    [anon_sym_DOT] = ACTIONS(5667),
    [anon_sym_DOT_STAR] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5667),
    [anon_sym_decltype] = ACTIONS(5667),
    [anon_sym_final] = ACTIONS(5667),
    [anon_sym_override] = ACTIONS(5667),
    [anon_sym_requires] = ACTIONS(5667),
  },
  [1844] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5003),
    [anon_sym_COMMA] = ACTIONS(5003),
    [anon_sym_RPAREN] = ACTIONS(5003),
    [aux_sym_preproc_if_token2] = ACTIONS(5003),
    [aux_sym_preproc_else_token1] = ACTIONS(5003),
    [aux_sym_preproc_elif_token1] = ACTIONS(4996),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5003),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5003),
    [anon_sym_LPAREN2] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_STAR] = ACTIONS(5003),
    [anon_sym_SLASH] = ACTIONS(4996),
    [anon_sym_PERCENT] = ACTIONS(5003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5003),
    [anon_sym_AMP_AMP] = ACTIONS(5003),
    [anon_sym_PIPE] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(5003),
    [anon_sym_AMP] = ACTIONS(4996),
    [anon_sym_EQ_EQ] = ACTIONS(5003),
    [anon_sym_BANG_EQ] = ACTIONS(5003),
    [anon_sym_GT] = ACTIONS(4996),
    [anon_sym_GT_EQ] = ACTIONS(5003),
    [anon_sym_LT_EQ] = ACTIONS(4996),
    [anon_sym_LT] = ACTIONS(4996),
    [anon_sym_LT_LT] = ACTIONS(5003),
    [anon_sym_GT_GT] = ACTIONS(5003),
    [anon_sym_SEMI] = ACTIONS(5003),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_COLON] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5003),
    [anon_sym_RBRACK] = ACTIONS(5003),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym__Nonnull] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym__Alignas] = ACTIONS(4996),
    [anon_sym_QMARK] = ACTIONS(5003),
    [anon_sym_LT_EQ_GT] = ACTIONS(5003),
    [anon_sym_or] = ACTIONS(4996),
    [anon_sym_and] = ACTIONS(4996),
    [anon_sym_bitor] = ACTIONS(4996),
    [anon_sym_xor] = ACTIONS(4996),
    [anon_sym_bitand] = ACTIONS(4996),
    [anon_sym_not_eq] = ACTIONS(4996),
    [anon_sym_DASH_DASH] = ACTIONS(5003),
    [anon_sym_PLUS_PLUS] = ACTIONS(5003),
    [anon_sym_DOT] = ACTIONS(4996),
    [anon_sym_DOT_STAR] = ACTIONS(5003),
    [anon_sym_DASH_GT] = ACTIONS(5003),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_final] = ACTIONS(4996),
    [anon_sym_override] = ACTIONS(4996),
    [anon_sym_requires] = ACTIONS(4996),
  },
  [1845] = {
    [sym_catch_clause] = STATE(1890),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1890),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_virtual] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym___attribute] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym__Nonnull] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_private] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_friend] = ACTIONS(2483),
    [anon_sym_public] = ACTIONS(2483),
    [anon_sym_protected] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_catch] = ACTIONS(5671),
  },
  [1846] = {
    [sym_catch_clause] = STATE(1851),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1851),
    [sym_identifier] = ACTIONS(2483),
    [aux_sym_preproc_def_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token1] = ACTIONS(2483),
    [aux_sym_preproc_if_token2] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2483),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2483),
    [sym_preproc_directive] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_STAR] = ACTIONS(2485),
    [anon_sym_AMP_AMP] = ACTIONS(2485),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym___extension__] = ACTIONS(2483),
    [anon_sym_typedef] = ACTIONS(2483),
    [anon_sym_virtual] = ACTIONS(2483),
    [anon_sym_extern] = ACTIONS(2483),
    [anon_sym___attribute__] = ACTIONS(2483),
    [anon_sym___attribute] = ACTIONS(2483),
    [anon_sym_using] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(2485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2485),
    [anon_sym___declspec] = ACTIONS(2483),
    [anon_sym___based] = ACTIONS(2483),
    [anon_sym_signed] = ACTIONS(2483),
    [anon_sym_unsigned] = ACTIONS(2483),
    [anon_sym_long] = ACTIONS(2483),
    [anon_sym_short] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2483),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_register] = ACTIONS(2483),
    [anon_sym_inline] = ACTIONS(2483),
    [anon_sym___inline] = ACTIONS(2483),
    [anon_sym___inline__] = ACTIONS(2483),
    [anon_sym___forceinline] = ACTIONS(2483),
    [anon_sym_thread_local] = ACTIONS(2483),
    [anon_sym___thread] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_constexpr] = ACTIONS(2483),
    [anon_sym_volatile] = ACTIONS(2483),
    [anon_sym_restrict] = ACTIONS(2483),
    [anon_sym___restrict__] = ACTIONS(2483),
    [anon_sym__Atomic] = ACTIONS(2483),
    [anon_sym__Noreturn] = ACTIONS(2483),
    [anon_sym_noreturn] = ACTIONS(2483),
    [anon_sym__Nonnull] = ACTIONS(2483),
    [anon_sym_mutable] = ACTIONS(2483),
    [anon_sym_constinit] = ACTIONS(2483),
    [anon_sym_consteval] = ACTIONS(2483),
    [anon_sym_alignas] = ACTIONS(2483),
    [anon_sym__Alignas] = ACTIONS(2483),
    [sym_primitive_type] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_struct] = ACTIONS(2483),
    [anon_sym_union] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2483),
    [anon_sym_decltype] = ACTIONS(2483),
    [anon_sym_explicit] = ACTIONS(2483),
    [anon_sym_typename] = ACTIONS(2483),
    [anon_sym_private] = ACTIONS(2483),
    [anon_sym_template] = ACTIONS(2483),
    [anon_sym_operator] = ACTIONS(2483),
    [anon_sym_friend] = ACTIONS(2483),
    [anon_sym_public] = ACTIONS(2483),
    [anon_sym_protected] = ACTIONS(2483),
    [anon_sym_static_assert] = ACTIONS(2483),
    [anon_sym_catch] = ACTIONS(5645),
  },
  [1847] = {
    [sym_identifier] = ACTIONS(5673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5675),
    [anon_sym_COMMA] = ACTIONS(5675),
    [anon_sym_RPAREN] = ACTIONS(5675),
    [anon_sym_LPAREN2] = ACTIONS(5675),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_STAR] = ACTIONS(5675),
    [anon_sym_SLASH] = ACTIONS(5673),
    [anon_sym_PERCENT] = ACTIONS(5675),
    [anon_sym_PIPE_PIPE] = ACTIONS(5675),
    [anon_sym_AMP_AMP] = ACTIONS(5675),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_CARET] = ACTIONS(5675),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_EQ_EQ] = ACTIONS(5675),
    [anon_sym_BANG_EQ] = ACTIONS(5675),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5675),
    [anon_sym_LT_EQ] = ACTIONS(5673),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_LT] = ACTIONS(5675),
    [anon_sym_GT_GT] = ACTIONS(5675),
    [anon_sym_SEMI] = ACTIONS(5675),
    [anon_sym___extension__] = ACTIONS(5673),
    [anon_sym___attribute__] = ACTIONS(5673),
    [anon_sym___attribute] = ACTIONS(5673),
    [anon_sym_COLON] = ACTIONS(5675),
    [anon_sym___based] = ACTIONS(5673),
    [anon_sym_LBRACE] = ACTIONS(5675),
    [anon_sym_RBRACE] = ACTIONS(5675),
    [anon_sym_signed] = ACTIONS(5673),
    [anon_sym_unsigned] = ACTIONS(5673),
    [anon_sym_long] = ACTIONS(5673),
    [anon_sym_short] = ACTIONS(5673),
    [anon_sym_LBRACK] = ACTIONS(5675),
    [anon_sym_RBRACK] = ACTIONS(5675),
    [anon_sym_const] = ACTIONS(5673),
    [anon_sym_constexpr] = ACTIONS(5673),
    [anon_sym_volatile] = ACTIONS(5673),
    [anon_sym_restrict] = ACTIONS(5673),
    [anon_sym___restrict__] = ACTIONS(5673),
    [anon_sym__Atomic] = ACTIONS(5673),
    [anon_sym__Noreturn] = ACTIONS(5673),
    [anon_sym_noreturn] = ACTIONS(5673),
    [anon_sym__Nonnull] = ACTIONS(5673),
    [anon_sym_mutable] = ACTIONS(5673),
    [anon_sym_constinit] = ACTIONS(5673),
    [anon_sym_consteval] = ACTIONS(5673),
    [anon_sym_alignas] = ACTIONS(5673),
    [anon_sym__Alignas] = ACTIONS(5673),
    [sym_primitive_type] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5675),
    [anon_sym_LT_EQ_GT] = ACTIONS(5675),
    [anon_sym_or] = ACTIONS(5673),
    [anon_sym_and] = ACTIONS(5673),
    [anon_sym_bitor] = ACTIONS(5673),
    [anon_sym_xor] = ACTIONS(5673),
    [anon_sym_bitand] = ACTIONS(5673),
    [anon_sym_not_eq] = ACTIONS(5673),
    [anon_sym_DASH_DASH] = ACTIONS(5675),
    [anon_sym_PLUS_PLUS] = ACTIONS(5675),
    [anon_sym_DOT] = ACTIONS(5673),
    [anon_sym_DOT_STAR] = ACTIONS(5675),
    [anon_sym_DASH_GT] = ACTIONS(5675),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5673),
    [anon_sym_decltype] = ACTIONS(5673),
    [anon_sym_final] = ACTIONS(5673),
    [anon_sym_override] = ACTIONS(5673),
    [anon_sym_requires] = ACTIONS(5673),
  },
  [1848] = {
    [sym_identifier] = ACTIONS(5677),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5679),
    [anon_sym_COMMA] = ACTIONS(5679),
    [anon_sym_RPAREN] = ACTIONS(5679),
    [anon_sym_LPAREN2] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5677),
    [anon_sym_PLUS] = ACTIONS(5677),
    [anon_sym_STAR] = ACTIONS(5679),
    [anon_sym_SLASH] = ACTIONS(5677),
    [anon_sym_PERCENT] = ACTIONS(5679),
    [anon_sym_PIPE_PIPE] = ACTIONS(5679),
    [anon_sym_AMP_AMP] = ACTIONS(5679),
    [anon_sym_PIPE] = ACTIONS(5677),
    [anon_sym_CARET] = ACTIONS(5679),
    [anon_sym_AMP] = ACTIONS(5677),
    [anon_sym_EQ_EQ] = ACTIONS(5679),
    [anon_sym_BANG_EQ] = ACTIONS(5679),
    [anon_sym_GT] = ACTIONS(5677),
    [anon_sym_GT_EQ] = ACTIONS(5679),
    [anon_sym_LT_EQ] = ACTIONS(5677),
    [anon_sym_LT] = ACTIONS(5677),
    [anon_sym_LT_LT] = ACTIONS(5679),
    [anon_sym_GT_GT] = ACTIONS(5679),
    [anon_sym_SEMI] = ACTIONS(5679),
    [anon_sym___extension__] = ACTIONS(5677),
    [anon_sym___attribute__] = ACTIONS(5677),
    [anon_sym___attribute] = ACTIONS(5677),
    [anon_sym_COLON] = ACTIONS(5679),
    [anon_sym___based] = ACTIONS(5677),
    [anon_sym_LBRACE] = ACTIONS(5679),
    [anon_sym_RBRACE] = ACTIONS(5679),
    [anon_sym_signed] = ACTIONS(5677),
    [anon_sym_unsigned] = ACTIONS(5677),
    [anon_sym_long] = ACTIONS(5677),
    [anon_sym_short] = ACTIONS(5677),
    [anon_sym_LBRACK] = ACTIONS(5679),
    [anon_sym_RBRACK] = ACTIONS(5679),
    [anon_sym_const] = ACTIONS(5677),
    [anon_sym_constexpr] = ACTIONS(5677),
    [anon_sym_volatile] = ACTIONS(5677),
    [anon_sym_restrict] = ACTIONS(5677),
    [anon_sym___restrict__] = ACTIONS(5677),
    [anon_sym__Atomic] = ACTIONS(5677),
    [anon_sym__Noreturn] = ACTIONS(5677),
    [anon_sym_noreturn] = ACTIONS(5677),
    [anon_sym__Nonnull] = ACTIONS(5677),
    [anon_sym_mutable] = ACTIONS(5677),
    [anon_sym_constinit] = ACTIONS(5677),
    [anon_sym_consteval] = ACTIONS(5677),
    [anon_sym_alignas] = ACTIONS(5677),
    [anon_sym__Alignas] = ACTIONS(5677),
    [sym_primitive_type] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_LT_EQ_GT] = ACTIONS(5679),
    [anon_sym_or] = ACTIONS(5677),
    [anon_sym_and] = ACTIONS(5677),
    [anon_sym_bitor] = ACTIONS(5677),
    [anon_sym_xor] = ACTIONS(5677),
    [anon_sym_bitand] = ACTIONS(5677),
    [anon_sym_not_eq] = ACTIONS(5677),
    [anon_sym_DASH_DASH] = ACTIONS(5679),
    [anon_sym_PLUS_PLUS] = ACTIONS(5679),
    [anon_sym_DOT] = ACTIONS(5677),
    [anon_sym_DOT_STAR] = ACTIONS(5679),
    [anon_sym_DASH_GT] = ACTIONS(5679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5677),
    [anon_sym_decltype] = ACTIONS(5677),
    [anon_sym_final] = ACTIONS(5677),
    [anon_sym_override] = ACTIONS(5677),
    [anon_sym_requires] = ACTIONS(5677),
  },
  [1849] = {
    [sym_identifier] = ACTIONS(5681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5683),
    [anon_sym_COMMA] = ACTIONS(5683),
    [anon_sym_RPAREN] = ACTIONS(5683),
    [anon_sym_LPAREN2] = ACTIONS(5683),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_PLUS] = ACTIONS(5681),
    [anon_sym_STAR] = ACTIONS(5683),
    [anon_sym_SLASH] = ACTIONS(5681),
    [anon_sym_PERCENT] = ACTIONS(5683),
    [anon_sym_PIPE_PIPE] = ACTIONS(5683),
    [anon_sym_AMP_AMP] = ACTIONS(5683),
    [anon_sym_PIPE] = ACTIONS(5681),
    [anon_sym_CARET] = ACTIONS(5683),
    [anon_sym_AMP] = ACTIONS(5681),
    [anon_sym_EQ_EQ] = ACTIONS(5683),
    [anon_sym_BANG_EQ] = ACTIONS(5683),
    [anon_sym_GT] = ACTIONS(5681),
    [anon_sym_GT_EQ] = ACTIONS(5683),
    [anon_sym_LT_EQ] = ACTIONS(5681),
    [anon_sym_LT] = ACTIONS(5681),
    [anon_sym_LT_LT] = ACTIONS(5683),
    [anon_sym_GT_GT] = ACTIONS(5683),
    [anon_sym_SEMI] = ACTIONS(5683),
    [anon_sym___extension__] = ACTIONS(5681),
    [anon_sym___attribute__] = ACTIONS(5681),
    [anon_sym___attribute] = ACTIONS(5681),
    [anon_sym_COLON] = ACTIONS(5683),
    [anon_sym___based] = ACTIONS(5681),
    [anon_sym_LBRACE] = ACTIONS(5683),
    [anon_sym_RBRACE] = ACTIONS(5683),
    [anon_sym_signed] = ACTIONS(5681),
    [anon_sym_unsigned] = ACTIONS(5681),
    [anon_sym_long] = ACTIONS(5681),
    [anon_sym_short] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_RBRACK] = ACTIONS(5683),
    [anon_sym_const] = ACTIONS(5681),
    [anon_sym_constexpr] = ACTIONS(5681),
    [anon_sym_volatile] = ACTIONS(5681),
    [anon_sym_restrict] = ACTIONS(5681),
    [anon_sym___restrict__] = ACTIONS(5681),
    [anon_sym__Atomic] = ACTIONS(5681),
    [anon_sym__Noreturn] = ACTIONS(5681),
    [anon_sym_noreturn] = ACTIONS(5681),
    [anon_sym__Nonnull] = ACTIONS(5681),
    [anon_sym_mutable] = ACTIONS(5681),
    [anon_sym_constinit] = ACTIONS(5681),
    [anon_sym_consteval] = ACTIONS(5681),
    [anon_sym_alignas] = ACTIONS(5681),
    [anon_sym__Alignas] = ACTIONS(5681),
    [sym_primitive_type] = ACTIONS(5681),
    [anon_sym_QMARK] = ACTIONS(5683),
    [anon_sym_LT_EQ_GT] = ACTIONS(5683),
    [anon_sym_or] = ACTIONS(5681),
    [anon_sym_and] = ACTIONS(5681),
    [anon_sym_bitor] = ACTIONS(5681),
    [anon_sym_xor] = ACTIONS(5681),
    [anon_sym_bitand] = ACTIONS(5681),
    [anon_sym_not_eq] = ACTIONS(5681),
    [anon_sym_DASH_DASH] = ACTIONS(5683),
    [anon_sym_PLUS_PLUS] = ACTIONS(5683),
    [anon_sym_DOT] = ACTIONS(5681),
    [anon_sym_DOT_STAR] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5683),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5681),
    [anon_sym_decltype] = ACTIONS(5681),
    [anon_sym_final] = ACTIONS(5681),
    [anon_sym_override] = ACTIONS(5681),
    [anon_sym_requires] = ACTIONS(5681),
  },
  [1850] = {
    [sym_identifier] = ACTIONS(5685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5687),
    [anon_sym_COMMA] = ACTIONS(5687),
    [anon_sym_RPAREN] = ACTIONS(5687),
    [anon_sym_LPAREN2] = ACTIONS(5687),
    [anon_sym_DASH] = ACTIONS(5685),
    [anon_sym_PLUS] = ACTIONS(5685),
    [anon_sym_STAR] = ACTIONS(5687),
    [anon_sym_SLASH] = ACTIONS(5685),
    [anon_sym_PERCENT] = ACTIONS(5687),
    [anon_sym_PIPE_PIPE] = ACTIONS(5687),
    [anon_sym_AMP_AMP] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5685),
    [anon_sym_CARET] = ACTIONS(5687),
    [anon_sym_AMP] = ACTIONS(5685),
    [anon_sym_EQ_EQ] = ACTIONS(5687),
    [anon_sym_BANG_EQ] = ACTIONS(5687),
    [anon_sym_GT] = ACTIONS(5685),
    [anon_sym_GT_EQ] = ACTIONS(5687),
    [anon_sym_LT_EQ] = ACTIONS(5685),
    [anon_sym_LT] = ACTIONS(5685),
    [anon_sym_LT_LT] = ACTIONS(5687),
    [anon_sym_GT_GT] = ACTIONS(5687),
    [anon_sym_SEMI] = ACTIONS(5687),
    [anon_sym___extension__] = ACTIONS(5685),
    [anon_sym___attribute__] = ACTIONS(5685),
    [anon_sym___attribute] = ACTIONS(5685),
    [anon_sym_COLON] = ACTIONS(5687),
    [anon_sym___based] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [anon_sym_RBRACE] = ACTIONS(5687),
    [anon_sym_signed] = ACTIONS(5685),
    [anon_sym_unsigned] = ACTIONS(5685),
    [anon_sym_long] = ACTIONS(5685),
    [anon_sym_short] = ACTIONS(5685),
    [anon_sym_LBRACK] = ACTIONS(5687),
    [anon_sym_RBRACK] = ACTIONS(5687),
    [anon_sym_const] = ACTIONS(5685),
    [anon_sym_constexpr] = ACTIONS(5685),
    [anon_sym_volatile] = ACTIONS(5685),
    [anon_sym_restrict] = ACTIONS(5685),
    [anon_sym___restrict__] = ACTIONS(5685),
    [anon_sym__Atomic] = ACTIONS(5685),
    [anon_sym__Noreturn] = ACTIONS(5685),
    [anon_sym_noreturn] = ACTIONS(5685),
    [anon_sym__Nonnull] = ACTIONS(5685),
    [anon_sym_mutable] = ACTIONS(5685),
    [anon_sym_constinit] = ACTIONS(5685),
    [anon_sym_consteval] = ACTIONS(5685),
    [anon_sym_alignas] = ACTIONS(5685),
    [anon_sym__Alignas] = ACTIONS(5685),
    [sym_primitive_type] = ACTIONS(5685),
    [anon_sym_QMARK] = ACTIONS(5687),
    [anon_sym_LT_EQ_GT] = ACTIONS(5687),
    [anon_sym_or] = ACTIONS(5685),
    [anon_sym_and] = ACTIONS(5685),
    [anon_sym_bitor] = ACTIONS(5685),
    [anon_sym_xor] = ACTIONS(5685),
    [anon_sym_bitand] = ACTIONS(5685),
    [anon_sym_not_eq] = ACTIONS(5685),
    [anon_sym_DASH_DASH] = ACTIONS(5687),
    [anon_sym_PLUS_PLUS] = ACTIONS(5687),
    [anon_sym_DOT] = ACTIONS(5685),
    [anon_sym_DOT_STAR] = ACTIONS(5687),
    [anon_sym_DASH_GT] = ACTIONS(5687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5685),
    [anon_sym_decltype] = ACTIONS(5685),
    [anon_sym_final] = ACTIONS(5685),
    [anon_sym_override] = ACTIONS(5685),
    [anon_sym_requires] = ACTIONS(5685),
  },
  [1851] = {
    [sym_catch_clause] = STATE(1851),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1851),
    [sym_identifier] = ACTIONS(2476),
    [aux_sym_preproc_def_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token2] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2476),
    [sym_preproc_directive] = ACTIONS(2476),
    [anon_sym_LPAREN2] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym___extension__] = ACTIONS(2476),
    [anon_sym_typedef] = ACTIONS(2476),
    [anon_sym_virtual] = ACTIONS(2476),
    [anon_sym_extern] = ACTIONS(2476),
    [anon_sym___attribute__] = ACTIONS(2476),
    [anon_sym___attribute] = ACTIONS(2476),
    [anon_sym_using] = ACTIONS(2476),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2478),
    [anon_sym___declspec] = ACTIONS(2476),
    [anon_sym___based] = ACTIONS(2476),
    [anon_sym_signed] = ACTIONS(2476),
    [anon_sym_unsigned] = ACTIONS(2476),
    [anon_sym_long] = ACTIONS(2476),
    [anon_sym_short] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_register] = ACTIONS(2476),
    [anon_sym_inline] = ACTIONS(2476),
    [anon_sym___inline] = ACTIONS(2476),
    [anon_sym___inline__] = ACTIONS(2476),
    [anon_sym___forceinline] = ACTIONS(2476),
    [anon_sym_thread_local] = ACTIONS(2476),
    [anon_sym___thread] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_constexpr] = ACTIONS(2476),
    [anon_sym_volatile] = ACTIONS(2476),
    [anon_sym_restrict] = ACTIONS(2476),
    [anon_sym___restrict__] = ACTIONS(2476),
    [anon_sym__Atomic] = ACTIONS(2476),
    [anon_sym__Noreturn] = ACTIONS(2476),
    [anon_sym_noreturn] = ACTIONS(2476),
    [anon_sym__Nonnull] = ACTIONS(2476),
    [anon_sym_mutable] = ACTIONS(2476),
    [anon_sym_constinit] = ACTIONS(2476),
    [anon_sym_consteval] = ACTIONS(2476),
    [anon_sym_alignas] = ACTIONS(2476),
    [anon_sym__Alignas] = ACTIONS(2476),
    [sym_primitive_type] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [anon_sym_class] = ACTIONS(2476),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2476),
    [anon_sym_decltype] = ACTIONS(2476),
    [anon_sym_explicit] = ACTIONS(2476),
    [anon_sym_typename] = ACTIONS(2476),
    [anon_sym_private] = ACTIONS(2476),
    [anon_sym_template] = ACTIONS(2476),
    [anon_sym_operator] = ACTIONS(2476),
    [anon_sym_friend] = ACTIONS(2476),
    [anon_sym_public] = ACTIONS(2476),
    [anon_sym_protected] = ACTIONS(2476),
    [anon_sym_static_assert] = ACTIONS(2476),
    [anon_sym_catch] = ACTIONS(5689),
  },
  [1852] = {
    [sym_identifier] = ACTIONS(5692),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5694),
    [anon_sym_COMMA] = ACTIONS(5694),
    [anon_sym_RPAREN] = ACTIONS(5694),
    [anon_sym_LPAREN2] = ACTIONS(5694),
    [anon_sym_DASH] = ACTIONS(5692),
    [anon_sym_PLUS] = ACTIONS(5692),
    [anon_sym_STAR] = ACTIONS(5694),
    [anon_sym_SLASH] = ACTIONS(5692),
    [anon_sym_PERCENT] = ACTIONS(5694),
    [anon_sym_PIPE_PIPE] = ACTIONS(5694),
    [anon_sym_AMP_AMP] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5694),
    [anon_sym_AMP] = ACTIONS(5692),
    [anon_sym_EQ_EQ] = ACTIONS(5694),
    [anon_sym_BANG_EQ] = ACTIONS(5694),
    [anon_sym_GT] = ACTIONS(5692),
    [anon_sym_GT_EQ] = ACTIONS(5694),
    [anon_sym_LT_EQ] = ACTIONS(5692),
    [anon_sym_LT] = ACTIONS(5692),
    [anon_sym_LT_LT] = ACTIONS(5694),
    [anon_sym_GT_GT] = ACTIONS(5694),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym___extension__] = ACTIONS(5692),
    [anon_sym___attribute__] = ACTIONS(5692),
    [anon_sym___attribute] = ACTIONS(5692),
    [anon_sym_COLON] = ACTIONS(5694),
    [anon_sym___based] = ACTIONS(5692),
    [anon_sym_LBRACE] = ACTIONS(5694),
    [anon_sym_RBRACE] = ACTIONS(5694),
    [anon_sym_signed] = ACTIONS(5692),
    [anon_sym_unsigned] = ACTIONS(5692),
    [anon_sym_long] = ACTIONS(5692),
    [anon_sym_short] = ACTIONS(5692),
    [anon_sym_LBRACK] = ACTIONS(5694),
    [anon_sym_RBRACK] = ACTIONS(5694),
    [anon_sym_const] = ACTIONS(5692),
    [anon_sym_constexpr] = ACTIONS(5692),
    [anon_sym_volatile] = ACTIONS(5692),
    [anon_sym_restrict] = ACTIONS(5692),
    [anon_sym___restrict__] = ACTIONS(5692),
    [anon_sym__Atomic] = ACTIONS(5692),
    [anon_sym__Noreturn] = ACTIONS(5692),
    [anon_sym_noreturn] = ACTIONS(5692),
    [anon_sym__Nonnull] = ACTIONS(5692),
    [anon_sym_mutable] = ACTIONS(5692),
    [anon_sym_constinit] = ACTIONS(5692),
    [anon_sym_consteval] = ACTIONS(5692),
    [anon_sym_alignas] = ACTIONS(5692),
    [anon_sym__Alignas] = ACTIONS(5692),
    [sym_primitive_type] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(5694),
    [anon_sym_LT_EQ_GT] = ACTIONS(5694),
    [anon_sym_or] = ACTIONS(5692),
    [anon_sym_and] = ACTIONS(5692),
    [anon_sym_bitor] = ACTIONS(5692),
    [anon_sym_xor] = ACTIONS(5692),
    [anon_sym_bitand] = ACTIONS(5692),
    [anon_sym_not_eq] = ACTIONS(5692),
    [anon_sym_DASH_DASH] = ACTIONS(5694),
    [anon_sym_PLUS_PLUS] = ACTIONS(5694),
    [anon_sym_DOT] = ACTIONS(5692),
    [anon_sym_DOT_STAR] = ACTIONS(5694),
    [anon_sym_DASH_GT] = ACTIONS(5694),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5692),
    [anon_sym_decltype] = ACTIONS(5692),
    [anon_sym_final] = ACTIONS(5692),
    [anon_sym_override] = ACTIONS(5692),
    [anon_sym_requires] = ACTIONS(5692),
  },
  [1853] = {
    [sym_identifier] = ACTIONS(5677),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5679),
    [anon_sym_COMMA] = ACTIONS(5679),
    [anon_sym_RPAREN] = ACTIONS(5679),
    [anon_sym_LPAREN2] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5677),
    [anon_sym_PLUS] = ACTIONS(5677),
    [anon_sym_STAR] = ACTIONS(5679),
    [anon_sym_SLASH] = ACTIONS(5677),
    [anon_sym_PERCENT] = ACTIONS(5679),
    [anon_sym_PIPE_PIPE] = ACTIONS(5679),
    [anon_sym_AMP_AMP] = ACTIONS(5679),
    [anon_sym_PIPE] = ACTIONS(5677),
    [anon_sym_CARET] = ACTIONS(5679),
    [anon_sym_AMP] = ACTIONS(5677),
    [anon_sym_EQ_EQ] = ACTIONS(5679),
    [anon_sym_BANG_EQ] = ACTIONS(5679),
    [anon_sym_GT] = ACTIONS(5677),
    [anon_sym_GT_EQ] = ACTIONS(5679),
    [anon_sym_LT_EQ] = ACTIONS(5677),
    [anon_sym_LT] = ACTIONS(5677),
    [anon_sym_LT_LT] = ACTIONS(5679),
    [anon_sym_GT_GT] = ACTIONS(5679),
    [anon_sym_SEMI] = ACTIONS(5679),
    [anon_sym___extension__] = ACTIONS(5677),
    [anon_sym___attribute__] = ACTIONS(5677),
    [anon_sym___attribute] = ACTIONS(5677),
    [anon_sym_COLON] = ACTIONS(5679),
    [anon_sym___based] = ACTIONS(5677),
    [anon_sym_LBRACE] = ACTIONS(5679),
    [anon_sym_RBRACE] = ACTIONS(5679),
    [anon_sym_signed] = ACTIONS(5677),
    [anon_sym_unsigned] = ACTIONS(5677),
    [anon_sym_long] = ACTIONS(5677),
    [anon_sym_short] = ACTIONS(5677),
    [anon_sym_LBRACK] = ACTIONS(5679),
    [anon_sym_RBRACK] = ACTIONS(5679),
    [anon_sym_const] = ACTIONS(5677),
    [anon_sym_constexpr] = ACTIONS(5677),
    [anon_sym_volatile] = ACTIONS(5677),
    [anon_sym_restrict] = ACTIONS(5677),
    [anon_sym___restrict__] = ACTIONS(5677),
    [anon_sym__Atomic] = ACTIONS(5677),
    [anon_sym__Noreturn] = ACTIONS(5677),
    [anon_sym_noreturn] = ACTIONS(5677),
    [anon_sym__Nonnull] = ACTIONS(5677),
    [anon_sym_mutable] = ACTIONS(5677),
    [anon_sym_constinit] = ACTIONS(5677),
    [anon_sym_consteval] = ACTIONS(5677),
    [anon_sym_alignas] = ACTIONS(5677),
    [anon_sym__Alignas] = ACTIONS(5677),
    [sym_primitive_type] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_LT_EQ_GT] = ACTIONS(5679),
    [anon_sym_or] = ACTIONS(5677),
    [anon_sym_and] = ACTIONS(5677),
    [anon_sym_bitor] = ACTIONS(5677),
    [anon_sym_xor] = ACTIONS(5677),
    [anon_sym_bitand] = ACTIONS(5677),
    [anon_sym_not_eq] = ACTIONS(5677),
    [anon_sym_DASH_DASH] = ACTIONS(5679),
    [anon_sym_PLUS_PLUS] = ACTIONS(5679),
    [anon_sym_DOT] = ACTIONS(5677),
    [anon_sym_DOT_STAR] = ACTIONS(5679),
    [anon_sym_DASH_GT] = ACTIONS(5679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5677),
    [anon_sym_decltype] = ACTIONS(5677),
    [anon_sym_final] = ACTIONS(5677),
    [anon_sym_override] = ACTIONS(5677),
    [anon_sym_requires] = ACTIONS(5677),
  },
  [1854] = {
    [sym_identifier] = ACTIONS(5677),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5679),
    [anon_sym_COMMA] = ACTIONS(5679),
    [anon_sym_RPAREN] = ACTIONS(5679),
    [anon_sym_LPAREN2] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5677),
    [anon_sym_PLUS] = ACTIONS(5677),
    [anon_sym_STAR] = ACTIONS(5679),
    [anon_sym_SLASH] = ACTIONS(5677),
    [anon_sym_PERCENT] = ACTIONS(5679),
    [anon_sym_PIPE_PIPE] = ACTIONS(5679),
    [anon_sym_AMP_AMP] = ACTIONS(5679),
    [anon_sym_PIPE] = ACTIONS(5677),
    [anon_sym_CARET] = ACTIONS(5679),
    [anon_sym_AMP] = ACTIONS(5677),
    [anon_sym_EQ_EQ] = ACTIONS(5679),
    [anon_sym_BANG_EQ] = ACTIONS(5679),
    [anon_sym_GT] = ACTIONS(5677),
    [anon_sym_GT_EQ] = ACTIONS(5679),
    [anon_sym_LT_EQ] = ACTIONS(5677),
    [anon_sym_LT] = ACTIONS(5677),
    [anon_sym_LT_LT] = ACTIONS(5679),
    [anon_sym_GT_GT] = ACTIONS(5679),
    [anon_sym_SEMI] = ACTIONS(5679),
    [anon_sym___extension__] = ACTIONS(5677),
    [anon_sym___attribute__] = ACTIONS(5677),
    [anon_sym___attribute] = ACTIONS(5677),
    [anon_sym_COLON] = ACTIONS(5679),
    [anon_sym___based] = ACTIONS(5677),
    [anon_sym_LBRACE] = ACTIONS(5679),
    [anon_sym_RBRACE] = ACTIONS(5679),
    [anon_sym_signed] = ACTIONS(5677),
    [anon_sym_unsigned] = ACTIONS(5677),
    [anon_sym_long] = ACTIONS(5677),
    [anon_sym_short] = ACTIONS(5677),
    [anon_sym_LBRACK] = ACTIONS(5679),
    [anon_sym_RBRACK] = ACTIONS(5679),
    [anon_sym_const] = ACTIONS(5677),
    [anon_sym_constexpr] = ACTIONS(5677),
    [anon_sym_volatile] = ACTIONS(5677),
    [anon_sym_restrict] = ACTIONS(5677),
    [anon_sym___restrict__] = ACTIONS(5677),
    [anon_sym__Atomic] = ACTIONS(5677),
    [anon_sym__Noreturn] = ACTIONS(5677),
    [anon_sym_noreturn] = ACTIONS(5677),
    [anon_sym__Nonnull] = ACTIONS(5677),
    [anon_sym_mutable] = ACTIONS(5677),
    [anon_sym_constinit] = ACTIONS(5677),
    [anon_sym_consteval] = ACTIONS(5677),
    [anon_sym_alignas] = ACTIONS(5677),
    [anon_sym__Alignas] = ACTIONS(5677),
    [sym_primitive_type] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_LT_EQ_GT] = ACTIONS(5679),
    [anon_sym_or] = ACTIONS(5677),
    [anon_sym_and] = ACTIONS(5677),
    [anon_sym_bitor] = ACTIONS(5677),
    [anon_sym_xor] = ACTIONS(5677),
    [anon_sym_bitand] = ACTIONS(5677),
    [anon_sym_not_eq] = ACTIONS(5677),
    [anon_sym_DASH_DASH] = ACTIONS(5679),
    [anon_sym_PLUS_PLUS] = ACTIONS(5679),
    [anon_sym_DOT] = ACTIONS(5677),
    [anon_sym_DOT_STAR] = ACTIONS(5679),
    [anon_sym_DASH_GT] = ACTIONS(5679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5677),
    [anon_sym_decltype] = ACTIONS(5677),
    [anon_sym_final] = ACTIONS(5677),
    [anon_sym_override] = ACTIONS(5677),
    [anon_sym_requires] = ACTIONS(5677),
  },
  [1855] = {
    [sym_catch_clause] = STATE(1890),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1890),
    [sym_identifier] = ACTIONS(2590),
    [aux_sym_preproc_def_token1] = ACTIONS(2590),
    [aux_sym_preproc_if_token1] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2590),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2590),
    [sym_preproc_directive] = ACTIONS(2590),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_TILDE] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym___extension__] = ACTIONS(2590),
    [anon_sym_typedef] = ACTIONS(2590),
    [anon_sym_virtual] = ACTIONS(2590),
    [anon_sym_extern] = ACTIONS(2590),
    [anon_sym___attribute__] = ACTIONS(2590),
    [anon_sym___attribute] = ACTIONS(2590),
    [anon_sym_using] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2592),
    [anon_sym___declspec] = ACTIONS(2590),
    [anon_sym___based] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2592),
    [anon_sym_signed] = ACTIONS(2590),
    [anon_sym_unsigned] = ACTIONS(2590),
    [anon_sym_long] = ACTIONS(2590),
    [anon_sym_short] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2590),
    [anon_sym_register] = ACTIONS(2590),
    [anon_sym_inline] = ACTIONS(2590),
    [anon_sym___inline] = ACTIONS(2590),
    [anon_sym___inline__] = ACTIONS(2590),
    [anon_sym___forceinline] = ACTIONS(2590),
    [anon_sym_thread_local] = ACTIONS(2590),
    [anon_sym___thread] = ACTIONS(2590),
    [anon_sym_const] = ACTIONS(2590),
    [anon_sym_constexpr] = ACTIONS(2590),
    [anon_sym_volatile] = ACTIONS(2590),
    [anon_sym_restrict] = ACTIONS(2590),
    [anon_sym___restrict__] = ACTIONS(2590),
    [anon_sym__Atomic] = ACTIONS(2590),
    [anon_sym__Noreturn] = ACTIONS(2590),
    [anon_sym_noreturn] = ACTIONS(2590),
    [anon_sym__Nonnull] = ACTIONS(2590),
    [anon_sym_mutable] = ACTIONS(2590),
    [anon_sym_constinit] = ACTIONS(2590),
    [anon_sym_consteval] = ACTIONS(2590),
    [anon_sym_alignas] = ACTIONS(2590),
    [anon_sym__Alignas] = ACTIONS(2590),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_enum] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_struct] = ACTIONS(2590),
    [anon_sym_union] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2590),
    [anon_sym_decltype] = ACTIONS(2590),
    [anon_sym_explicit] = ACTIONS(2590),
    [anon_sym_typename] = ACTIONS(2590),
    [anon_sym_private] = ACTIONS(2590),
    [anon_sym_template] = ACTIONS(2590),
    [anon_sym_operator] = ACTIONS(2590),
    [anon_sym_friend] = ACTIONS(2590),
    [anon_sym_public] = ACTIONS(2590),
    [anon_sym_protected] = ACTIONS(2590),
    [anon_sym_static_assert] = ACTIONS(2590),
    [anon_sym_catch] = ACTIONS(5671),
  },
  [1856] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5005),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5005),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym___extension__] = ACTIONS(5003),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5000),
    [anon_sym_EQ] = ACTIONS(5005),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(5003),
    [anon_sym_volatile] = ACTIONS(5003),
    [anon_sym_restrict] = ACTIONS(5003),
    [anon_sym___restrict__] = ACTIONS(5003),
    [anon_sym__Atomic] = ACTIONS(5003),
    [anon_sym__Noreturn] = ACTIONS(5003),
    [anon_sym_noreturn] = ACTIONS(5003),
    [anon_sym__Nonnull] = ACTIONS(5003),
    [anon_sym_mutable] = ACTIONS(5003),
    [anon_sym_constinit] = ACTIONS(5003),
    [anon_sym_consteval] = ACTIONS(5003),
    [anon_sym_alignas] = ACTIONS(5003),
    [anon_sym__Alignas] = ACTIONS(5003),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_STAR_EQ] = ACTIONS(4998),
    [anon_sym_SLASH_EQ] = ACTIONS(4998),
    [anon_sym_PERCENT_EQ] = ACTIONS(4998),
    [anon_sym_PLUS_EQ] = ACTIONS(4998),
    [anon_sym_DASH_EQ] = ACTIONS(4998),
    [anon_sym_LT_LT_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT_EQ] = ACTIONS(4998),
    [anon_sym_AMP_EQ] = ACTIONS(4998),
    [anon_sym_CARET_EQ] = ACTIONS(4998),
    [anon_sym_PIPE_EQ] = ACTIONS(4998),
    [anon_sym_and_eq] = ACTIONS(4998),
    [anon_sym_or_eq] = ACTIONS(4998),
    [anon_sym_xor_eq] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(4998),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(4998),
    [anon_sym_not_eq] = ACTIONS(4998),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(5005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5003),
    [anon_sym_decltype] = ACTIONS(5003),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4998),
  },
  [1857] = {
    [sym_template_argument_list] = STATE(1895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4967),
    [anon_sym_LPAREN2] = ACTIONS(4967),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_SLASH] = ACTIONS(4972),
    [anon_sym_PERCENT] = ACTIONS(4972),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4972),
    [anon_sym_CARET] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4974),
    [anon_sym_EQ_EQ] = ACTIONS(4965),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_GT] = ACTIONS(4972),
    [anon_sym_GT_EQ] = ACTIONS(4972),
    [anon_sym_LT_EQ] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4972),
    [anon_sym_GT_GT] = ACTIONS(4972),
    [anon_sym___extension__] = ACTIONS(4970),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(4972),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_constexpr] = ACTIONS(4970),
    [anon_sym_volatile] = ACTIONS(4970),
    [anon_sym_restrict] = ACTIONS(4970),
    [anon_sym___restrict__] = ACTIONS(4970),
    [anon_sym__Atomic] = ACTIONS(4970),
    [anon_sym__Noreturn] = ACTIONS(4970),
    [anon_sym_noreturn] = ACTIONS(4970),
    [anon_sym__Nonnull] = ACTIONS(4970),
    [anon_sym_mutable] = ACTIONS(4970),
    [anon_sym_constinit] = ACTIONS(4970),
    [anon_sym_consteval] = ACTIONS(4970),
    [anon_sym_alignas] = ACTIONS(4970),
    [anon_sym__Alignas] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4972),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_and_eq] = ACTIONS(4965),
    [anon_sym_or_eq] = ACTIONS(4965),
    [anon_sym_xor_eq] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4972),
    [anon_sym_and] = ACTIONS(4972),
    [anon_sym_bitor] = ACTIONS(4965),
    [anon_sym_xor] = ACTIONS(4972),
    [anon_sym_bitand] = ACTIONS(4965),
    [anon_sym_not_eq] = ACTIONS(4965),
    [anon_sym_DASH_DASH] = ACTIONS(4965),
    [anon_sym_PLUS_PLUS] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4972),
    [anon_sym_DOT_STAR] = ACTIONS(4965),
    [anon_sym_DASH_GT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4970),
    [anon_sym_decltype] = ACTIONS(4970),
    [anon_sym_GT2] = ACTIONS(4967),
  },
  [1858] = {
    [sym_identifier] = ACTIONS(5080),
    [anon_sym_LPAREN2] = ACTIONS(5082),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5080),
    [anon_sym_COLON_COLON] = ACTIONS(5082),
    [anon_sym_LBRACK] = ACTIONS(5082),
    [anon_sym_static] = ACTIONS(5080),
    [anon_sym_RBRACK] = ACTIONS(5082),
    [anon_sym_const] = ACTIONS(5080),
    [anon_sym_constexpr] = ACTIONS(5080),
    [anon_sym_volatile] = ACTIONS(5080),
    [anon_sym_restrict] = ACTIONS(5080),
    [anon_sym___restrict__] = ACTIONS(5080),
    [anon_sym__Atomic] = ACTIONS(5080),
    [anon_sym__Noreturn] = ACTIONS(5080),
    [anon_sym_noreturn] = ACTIONS(5080),
    [anon_sym__Nonnull] = ACTIONS(5080),
    [anon_sym_mutable] = ACTIONS(5080),
    [anon_sym_constinit] = ACTIONS(5080),
    [anon_sym_consteval] = ACTIONS(5080),
    [anon_sym_alignas] = ACTIONS(5080),
    [anon_sym__Alignas] = ACTIONS(5080),
    [sym_primitive_type] = ACTIONS(5080),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5082),
    [anon_sym_PLUS_PLUS] = ACTIONS(5082),
    [anon_sym_sizeof] = ACTIONS(5080),
    [anon_sym___alignof__] = ACTIONS(5080),
    [anon_sym___alignof] = ACTIONS(5080),
    [anon_sym__alignof] = ACTIONS(5080),
    [anon_sym_alignof] = ACTIONS(5080),
    [anon_sym__Alignof] = ACTIONS(5080),
    [anon_sym_offsetof] = ACTIONS(5080),
    [anon_sym__Generic] = ACTIONS(5080),
    [anon_sym_asm] = ACTIONS(5080),
    [anon_sym___asm__] = ACTIONS(5080),
    [anon_sym___asm] = ACTIONS(5080),
    [sym_number_literal] = ACTIONS(5082),
    [anon_sym_L_SQUOTE] = ACTIONS(5082),
    [anon_sym_u_SQUOTE] = ACTIONS(5082),
    [anon_sym_U_SQUOTE] = ACTIONS(5082),
    [anon_sym_u8_SQUOTE] = ACTIONS(5082),
    [anon_sym_SQUOTE] = ACTIONS(5082),
    [anon_sym_L_DQUOTE] = ACTIONS(5082),
    [anon_sym_u_DQUOTE] = ACTIONS(5082),
    [anon_sym_U_DQUOTE] = ACTIONS(5082),
    [anon_sym_u8_DQUOTE] = ACTIONS(5082),
    [anon_sym_DQUOTE] = ACTIONS(5082),
    [sym_true] = ACTIONS(5080),
    [sym_false] = ACTIONS(5080),
    [anon_sym_NULL] = ACTIONS(5080),
    [anon_sym_nullptr] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5080),
    [anon_sym_template] = ACTIONS(5080),
    [anon_sym_delete] = ACTIONS(5080),
    [anon_sym_R_DQUOTE] = ACTIONS(5082),
    [anon_sym_LR_DQUOTE] = ACTIONS(5082),
    [anon_sym_uR_DQUOTE] = ACTIONS(5082),
    [anon_sym_UR_DQUOTE] = ACTIONS(5082),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5082),
    [anon_sym_co_await] = ACTIONS(5080),
    [anon_sym_new] = ACTIONS(5080),
    [anon_sym_requires] = ACTIONS(5080),
    [sym_this] = ACTIONS(5080),
  },
  [1859] = {
    [sym_identifier] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_COMMA] = ACTIONS(5701),
    [anon_sym_RPAREN] = ACTIONS(5701),
    [anon_sym_LPAREN2] = ACTIONS(5701),
    [anon_sym_DASH] = ACTIONS(5699),
    [anon_sym_PLUS] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_SLASH] = ACTIONS(5699),
    [anon_sym_PERCENT] = ACTIONS(5701),
    [anon_sym_PIPE_PIPE] = ACTIONS(5701),
    [anon_sym_AMP_AMP] = ACTIONS(5701),
    [anon_sym_PIPE] = ACTIONS(5699),
    [anon_sym_CARET] = ACTIONS(5701),
    [anon_sym_AMP] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5701),
    [anon_sym_BANG_EQ] = ACTIONS(5701),
    [anon_sym_GT] = ACTIONS(5699),
    [anon_sym_GT_EQ] = ACTIONS(5701),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_LT] = ACTIONS(5699),
    [anon_sym_LT_LT] = ACTIONS(5701),
    [anon_sym_GT_GT] = ACTIONS(5701),
    [anon_sym_SEMI] = ACTIONS(5701),
    [anon_sym___extension__] = ACTIONS(5699),
    [anon_sym___attribute__] = ACTIONS(5699),
    [anon_sym___attribute] = ACTIONS(5699),
    [anon_sym_COLON] = ACTIONS(5701),
    [anon_sym___based] = ACTIONS(5699),
    [anon_sym_LBRACE] = ACTIONS(5701),
    [anon_sym_RBRACE] = ACTIONS(5701),
    [anon_sym_signed] = ACTIONS(5699),
    [anon_sym_unsigned] = ACTIONS(5699),
    [anon_sym_long] = ACTIONS(5699),
    [anon_sym_short] = ACTIONS(5699),
    [anon_sym_LBRACK] = ACTIONS(5701),
    [anon_sym_RBRACK] = ACTIONS(5701),
    [anon_sym_const] = ACTIONS(5699),
    [anon_sym_constexpr] = ACTIONS(5699),
    [anon_sym_volatile] = ACTIONS(5699),
    [anon_sym_restrict] = ACTIONS(5699),
    [anon_sym___restrict__] = ACTIONS(5699),
    [anon_sym__Atomic] = ACTIONS(5699),
    [anon_sym__Noreturn] = ACTIONS(5699),
    [anon_sym_noreturn] = ACTIONS(5699),
    [anon_sym__Nonnull] = ACTIONS(5699),
    [anon_sym_mutable] = ACTIONS(5699),
    [anon_sym_constinit] = ACTIONS(5699),
    [anon_sym_consteval] = ACTIONS(5699),
    [anon_sym_alignas] = ACTIONS(5699),
    [anon_sym__Alignas] = ACTIONS(5699),
    [sym_primitive_type] = ACTIONS(5699),
    [anon_sym_QMARK] = ACTIONS(5701),
    [anon_sym_LT_EQ_GT] = ACTIONS(5701),
    [anon_sym_or] = ACTIONS(5699),
    [anon_sym_and] = ACTIONS(5699),
    [anon_sym_bitor] = ACTIONS(5699),
    [anon_sym_xor] = ACTIONS(5699),
    [anon_sym_bitand] = ACTIONS(5699),
    [anon_sym_not_eq] = ACTIONS(5699),
    [anon_sym_DASH_DASH] = ACTIONS(5701),
    [anon_sym_PLUS_PLUS] = ACTIONS(5701),
    [anon_sym_DOT] = ACTIONS(5699),
    [anon_sym_DOT_STAR] = ACTIONS(5701),
    [anon_sym_DASH_GT] = ACTIONS(5701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5699),
    [anon_sym_decltype] = ACTIONS(5699),
    [anon_sym_final] = ACTIONS(5699),
    [anon_sym_override] = ACTIONS(5699),
    [anon_sym_requires] = ACTIONS(5699),
  },
  [1860] = {
    [sym_type_qualifier] = STATE(1861),
    [sym_alignas_qualifier] = STATE(1695),
    [aux_sym__type_definition_type_repeat1] = STATE(1861),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2055),
    [sym_identifier] = ACTIONS(5703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5086),
    [anon_sym_COMMA] = ACTIONS(5086),
    [aux_sym_preproc_if_token2] = ACTIONS(5086),
    [aux_sym_preproc_else_token1] = ACTIONS(5086),
    [aux_sym_preproc_elif_token1] = ACTIONS(5088),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5086),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5086),
    [anon_sym_LPAREN2] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_STAR] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5088),
    [anon_sym_PERCENT] = ACTIONS(5086),
    [anon_sym_PIPE_PIPE] = ACTIONS(5086),
    [anon_sym_AMP_AMP] = ACTIONS(5086),
    [anon_sym_PIPE] = ACTIONS(5088),
    [anon_sym_CARET] = ACTIONS(5086),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_EQ_EQ] = ACTIONS(5086),
    [anon_sym_BANG_EQ] = ACTIONS(5086),
    [anon_sym_GT] = ACTIONS(5088),
    [anon_sym_GT_EQ] = ACTIONS(5086),
    [anon_sym_LT_EQ] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_LT_LT] = ACTIONS(5086),
    [anon_sym_GT_GT] = ACTIONS(5086),
    [anon_sym___extension__] = ACTIONS(5706),
    [anon_sym___attribute__] = ACTIONS(5088),
    [anon_sym___attribute] = ACTIONS(5088),
    [anon_sym_LBRACE] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5708),
    [anon_sym_unsigned] = ACTIONS(5708),
    [anon_sym_long] = ACTIONS(5708),
    [anon_sym_short] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5086),
    [anon_sym_const] = ACTIONS(5706),
    [anon_sym_constexpr] = ACTIONS(5706),
    [anon_sym_volatile] = ACTIONS(5706),
    [anon_sym_restrict] = ACTIONS(5706),
    [anon_sym___restrict__] = ACTIONS(5706),
    [anon_sym__Atomic] = ACTIONS(5706),
    [anon_sym__Noreturn] = ACTIONS(5706),
    [anon_sym_noreturn] = ACTIONS(5706),
    [anon_sym__Nonnull] = ACTIONS(5706),
    [anon_sym_mutable] = ACTIONS(5706),
    [anon_sym_constinit] = ACTIONS(5706),
    [anon_sym_consteval] = ACTIONS(5706),
    [anon_sym_alignas] = ACTIONS(5710),
    [anon_sym__Alignas] = ACTIONS(5710),
    [sym_primitive_type] = ACTIONS(5712),
    [anon_sym_QMARK] = ACTIONS(5086),
    [anon_sym_LT_EQ_GT] = ACTIONS(5086),
    [anon_sym_or] = ACTIONS(5088),
    [anon_sym_and] = ACTIONS(5088),
    [anon_sym_bitor] = ACTIONS(5088),
    [anon_sym_xor] = ACTIONS(5088),
    [anon_sym_bitand] = ACTIONS(5088),
    [anon_sym_not_eq] = ACTIONS(5088),
    [anon_sym_DASH_DASH] = ACTIONS(5086),
    [anon_sym_PLUS_PLUS] = ACTIONS(5086),
    [anon_sym_DOT] = ACTIONS(5088),
    [anon_sym_DOT_STAR] = ACTIONS(5086),
    [anon_sym_DASH_GT] = ACTIONS(5086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5088),
    [anon_sym_decltype] = ACTIONS(5088),
  },
  [1861] = {
    [sym_type_qualifier] = STATE(1655),
    [sym_alignas_qualifier] = STATE(1695),
    [aux_sym__type_definition_type_repeat1] = STATE(1655),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3379),
    [sym_identifier] = ACTIONS(5714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5100),
    [anon_sym_COMMA] = ACTIONS(5100),
    [aux_sym_preproc_if_token2] = ACTIONS(5100),
    [aux_sym_preproc_else_token1] = ACTIONS(5100),
    [aux_sym_preproc_elif_token1] = ACTIONS(5102),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5100),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5100),
    [anon_sym_LPAREN2] = ACTIONS(5100),
    [anon_sym_DASH] = ACTIONS(5102),
    [anon_sym_PLUS] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5100),
    [anon_sym_SLASH] = ACTIONS(5102),
    [anon_sym_PERCENT] = ACTIONS(5100),
    [anon_sym_PIPE_PIPE] = ACTIONS(5100),
    [anon_sym_AMP_AMP] = ACTIONS(5100),
    [anon_sym_PIPE] = ACTIONS(5102),
    [anon_sym_CARET] = ACTIONS(5100),
    [anon_sym_AMP] = ACTIONS(5102),
    [anon_sym_EQ_EQ] = ACTIONS(5100),
    [anon_sym_BANG_EQ] = ACTIONS(5100),
    [anon_sym_GT] = ACTIONS(5102),
    [anon_sym_GT_EQ] = ACTIONS(5100),
    [anon_sym_LT_EQ] = ACTIONS(5102),
    [anon_sym_LT] = ACTIONS(5102),
    [anon_sym_LT_LT] = ACTIONS(5100),
    [anon_sym_GT_GT] = ACTIONS(5100),
    [anon_sym___extension__] = ACTIONS(5706),
    [anon_sym___attribute__] = ACTIONS(5102),
    [anon_sym___attribute] = ACTIONS(5102),
    [anon_sym_LBRACE] = ACTIONS(5100),
    [anon_sym_signed] = ACTIONS(5717),
    [anon_sym_unsigned] = ACTIONS(5717),
    [anon_sym_long] = ACTIONS(5717),
    [anon_sym_short] = ACTIONS(5717),
    [anon_sym_LBRACK] = ACTIONS(5100),
    [anon_sym_const] = ACTIONS(5706),
    [anon_sym_constexpr] = ACTIONS(5706),
    [anon_sym_volatile] = ACTIONS(5706),
    [anon_sym_restrict] = ACTIONS(5706),
    [anon_sym___restrict__] = ACTIONS(5706),
    [anon_sym__Atomic] = ACTIONS(5706),
    [anon_sym__Noreturn] = ACTIONS(5706),
    [anon_sym_noreturn] = ACTIONS(5706),
    [anon_sym__Nonnull] = ACTIONS(5706),
    [anon_sym_mutable] = ACTIONS(5706),
    [anon_sym_constinit] = ACTIONS(5706),
    [anon_sym_consteval] = ACTIONS(5706),
    [anon_sym_alignas] = ACTIONS(5710),
    [anon_sym__Alignas] = ACTIONS(5710),
    [sym_primitive_type] = ACTIONS(5719),
    [anon_sym_QMARK] = ACTIONS(5100),
    [anon_sym_LT_EQ_GT] = ACTIONS(5100),
    [anon_sym_or] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5102),
    [anon_sym_bitor] = ACTIONS(5102),
    [anon_sym_xor] = ACTIONS(5102),
    [anon_sym_bitand] = ACTIONS(5102),
    [anon_sym_not_eq] = ACTIONS(5102),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_DOT] = ACTIONS(5102),
    [anon_sym_DOT_STAR] = ACTIONS(5100),
    [anon_sym_DASH_GT] = ACTIONS(5100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5102),
    [anon_sym_decltype] = ACTIONS(5102),
  },
  [1862] = {
    [sym_catch_clause] = STATE(1890),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1890),
    [sym_identifier] = ACTIONS(2547),
    [aux_sym_preproc_def_token1] = ACTIONS(2547),
    [aux_sym_preproc_if_token1] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2547),
    [sym_preproc_directive] = ACTIONS(2547),
    [anon_sym_LPAREN2] = ACTIONS(2549),
    [anon_sym_TILDE] = ACTIONS(2549),
    [anon_sym_STAR] = ACTIONS(2549),
    [anon_sym_AMP_AMP] = ACTIONS(2549),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(2549),
    [anon_sym___extension__] = ACTIONS(2547),
    [anon_sym_typedef] = ACTIONS(2547),
    [anon_sym_virtual] = ACTIONS(2547),
    [anon_sym_extern] = ACTIONS(2547),
    [anon_sym___attribute__] = ACTIONS(2547),
    [anon_sym___attribute] = ACTIONS(2547),
    [anon_sym_using] = ACTIONS(2547),
    [anon_sym_COLON_COLON] = ACTIONS(2549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2549),
    [anon_sym___declspec] = ACTIONS(2547),
    [anon_sym___based] = ACTIONS(2547),
    [anon_sym_RBRACE] = ACTIONS(2549),
    [anon_sym_signed] = ACTIONS(2547),
    [anon_sym_unsigned] = ACTIONS(2547),
    [anon_sym_long] = ACTIONS(2547),
    [anon_sym_short] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_register] = ACTIONS(2547),
    [anon_sym_inline] = ACTIONS(2547),
    [anon_sym___inline] = ACTIONS(2547),
    [anon_sym___inline__] = ACTIONS(2547),
    [anon_sym___forceinline] = ACTIONS(2547),
    [anon_sym_thread_local] = ACTIONS(2547),
    [anon_sym___thread] = ACTIONS(2547),
    [anon_sym_const] = ACTIONS(2547),
    [anon_sym_constexpr] = ACTIONS(2547),
    [anon_sym_volatile] = ACTIONS(2547),
    [anon_sym_restrict] = ACTIONS(2547),
    [anon_sym___restrict__] = ACTIONS(2547),
    [anon_sym__Atomic] = ACTIONS(2547),
    [anon_sym__Noreturn] = ACTIONS(2547),
    [anon_sym_noreturn] = ACTIONS(2547),
    [anon_sym__Nonnull] = ACTIONS(2547),
    [anon_sym_mutable] = ACTIONS(2547),
    [anon_sym_constinit] = ACTIONS(2547),
    [anon_sym_consteval] = ACTIONS(2547),
    [anon_sym_alignas] = ACTIONS(2547),
    [anon_sym__Alignas] = ACTIONS(2547),
    [sym_primitive_type] = ACTIONS(2547),
    [anon_sym_enum] = ACTIONS(2547),
    [anon_sym_class] = ACTIONS(2547),
    [anon_sym_struct] = ACTIONS(2547),
    [anon_sym_union] = ACTIONS(2547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2547),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_template] = ACTIONS(2547),
    [anon_sym_operator] = ACTIONS(2547),
    [anon_sym_friend] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_static_assert] = ACTIONS(2547),
    [anon_sym_catch] = ACTIONS(5671),
  },
  [1863] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [sym_identifier] = ACTIONS(4154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [aux_sym_preproc_if_token2] = ACTIONS(4146),
    [aux_sym_preproc_else_token1] = ACTIONS(4146),
    [aux_sym_preproc_elif_token1] = ACTIONS(4154),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4146),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5721),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(5724),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(5726),
    [anon_sym_SLASH_EQ] = ACTIONS(5726),
    [anon_sym_PERCENT_EQ] = ACTIONS(5726),
    [anon_sym_PLUS_EQ] = ACTIONS(5726),
    [anon_sym_DASH_EQ] = ACTIONS(5726),
    [anon_sym_LT_LT_EQ] = ACTIONS(5726),
    [anon_sym_GT_GT_EQ] = ACTIONS(5726),
    [anon_sym_AMP_EQ] = ACTIONS(5726),
    [anon_sym_CARET_EQ] = ACTIONS(5726),
    [anon_sym_PIPE_EQ] = ACTIONS(5726),
    [anon_sym_and_eq] = ACTIONS(5724),
    [anon_sym_or_eq] = ACTIONS(5724),
    [anon_sym_xor_eq] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [1864] = {
    [sym_identifier] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5730),
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_RPAREN] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5728),
    [anon_sym_STAR] = ACTIONS(5730),
    [anon_sym_SLASH] = ACTIONS(5728),
    [anon_sym_PERCENT] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5730),
    [anon_sym_PIPE] = ACTIONS(5728),
    [anon_sym_CARET] = ACTIONS(5730),
    [anon_sym_AMP] = ACTIONS(5728),
    [anon_sym_EQ_EQ] = ACTIONS(5730),
    [anon_sym_BANG_EQ] = ACTIONS(5730),
    [anon_sym_GT] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5728),
    [anon_sym_LT_LT] = ACTIONS(5730),
    [anon_sym_GT_GT] = ACTIONS(5730),
    [anon_sym_SEMI] = ACTIONS(5730),
    [anon_sym___extension__] = ACTIONS(5728),
    [anon_sym___attribute__] = ACTIONS(5728),
    [anon_sym___attribute] = ACTIONS(5728),
    [anon_sym_COLON] = ACTIONS(5730),
    [anon_sym___based] = ACTIONS(5728),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_RBRACE] = ACTIONS(5730),
    [anon_sym_signed] = ACTIONS(5728),
    [anon_sym_unsigned] = ACTIONS(5728),
    [anon_sym_long] = ACTIONS(5728),
    [anon_sym_short] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_RBRACK] = ACTIONS(5730),
    [anon_sym_const] = ACTIONS(5728),
    [anon_sym_constexpr] = ACTIONS(5728),
    [anon_sym_volatile] = ACTIONS(5728),
    [anon_sym_restrict] = ACTIONS(5728),
    [anon_sym___restrict__] = ACTIONS(5728),
    [anon_sym__Atomic] = ACTIONS(5728),
    [anon_sym__Noreturn] = ACTIONS(5728),
    [anon_sym_noreturn] = ACTIONS(5728),
    [anon_sym__Nonnull] = ACTIONS(5728),
    [anon_sym_mutable] = ACTIONS(5728),
    [anon_sym_constinit] = ACTIONS(5728),
    [anon_sym_consteval] = ACTIONS(5728),
    [anon_sym_alignas] = ACTIONS(5728),
    [anon_sym__Alignas] = ACTIONS(5728),
    [sym_primitive_type] = ACTIONS(5728),
    [anon_sym_QMARK] = ACTIONS(5730),
    [anon_sym_LT_EQ_GT] = ACTIONS(5730),
    [anon_sym_or] = ACTIONS(5728),
    [anon_sym_and] = ACTIONS(5728),
    [anon_sym_bitor] = ACTIONS(5728),
    [anon_sym_xor] = ACTIONS(5728),
    [anon_sym_bitand] = ACTIONS(5728),
    [anon_sym_not_eq] = ACTIONS(5728),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5728),
    [anon_sym_DOT_STAR] = ACTIONS(5730),
    [anon_sym_DASH_GT] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5728),
    [anon_sym_decltype] = ACTIONS(5728),
    [anon_sym_final] = ACTIONS(5728),
    [anon_sym_override] = ACTIONS(5728),
    [anon_sym_requires] = ACTIONS(5728),
  },
  [1865] = {
    [sym_identifier] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5734),
    [anon_sym_COMMA] = ACTIONS(5734),
    [anon_sym_RPAREN] = ACTIONS(5734),
    [anon_sym_LPAREN2] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_STAR] = ACTIONS(5734),
    [anon_sym_SLASH] = ACTIONS(5732),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5734),
    [anon_sym_AMP_AMP] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5732),
    [anon_sym_CARET] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5732),
    [anon_sym_EQ_EQ] = ACTIONS(5734),
    [anon_sym_BANG_EQ] = ACTIONS(5734),
    [anon_sym_GT] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5732),
    [anon_sym_LT_LT] = ACTIONS(5734),
    [anon_sym_GT_GT] = ACTIONS(5734),
    [anon_sym_SEMI] = ACTIONS(5734),
    [anon_sym___extension__] = ACTIONS(5732),
    [anon_sym___attribute__] = ACTIONS(5732),
    [anon_sym___attribute] = ACTIONS(5732),
    [anon_sym_COLON] = ACTIONS(5734),
    [anon_sym___based] = ACTIONS(5732),
    [anon_sym_LBRACE] = ACTIONS(5734),
    [anon_sym_RBRACE] = ACTIONS(5734),
    [anon_sym_signed] = ACTIONS(5732),
    [anon_sym_unsigned] = ACTIONS(5732),
    [anon_sym_long] = ACTIONS(5732),
    [anon_sym_short] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_RBRACK] = ACTIONS(5734),
    [anon_sym_const] = ACTIONS(5732),
    [anon_sym_constexpr] = ACTIONS(5732),
    [anon_sym_volatile] = ACTIONS(5732),
    [anon_sym_restrict] = ACTIONS(5732),
    [anon_sym___restrict__] = ACTIONS(5732),
    [anon_sym__Atomic] = ACTIONS(5732),
    [anon_sym__Noreturn] = ACTIONS(5732),
    [anon_sym_noreturn] = ACTIONS(5732),
    [anon_sym__Nonnull] = ACTIONS(5732),
    [anon_sym_mutable] = ACTIONS(5732),
    [anon_sym_constinit] = ACTIONS(5732),
    [anon_sym_consteval] = ACTIONS(5732),
    [anon_sym_alignas] = ACTIONS(5732),
    [anon_sym__Alignas] = ACTIONS(5732),
    [sym_primitive_type] = ACTIONS(5732),
    [anon_sym_QMARK] = ACTIONS(5734),
    [anon_sym_LT_EQ_GT] = ACTIONS(5734),
    [anon_sym_or] = ACTIONS(5732),
    [anon_sym_and] = ACTIONS(5732),
    [anon_sym_bitor] = ACTIONS(5732),
    [anon_sym_xor] = ACTIONS(5732),
    [anon_sym_bitand] = ACTIONS(5732),
    [anon_sym_not_eq] = ACTIONS(5732),
    [anon_sym_DASH_DASH] = ACTIONS(5734),
    [anon_sym_PLUS_PLUS] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5732),
    [anon_sym_DOT_STAR] = ACTIONS(5734),
    [anon_sym_DASH_GT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5732),
    [anon_sym_decltype] = ACTIONS(5732),
    [anon_sym_final] = ACTIONS(5732),
    [anon_sym_override] = ACTIONS(5732),
    [anon_sym_requires] = ACTIONS(5732),
  },
  [1866] = {
    [sym_identifier] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_LPAREN2] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5736),
    [anon_sym_STAR] = ACTIONS(5738),
    [anon_sym_SLASH] = ACTIONS(5736),
    [anon_sym_PERCENT] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_CARET] = ACTIONS(5738),
    [anon_sym_AMP] = ACTIONS(5736),
    [anon_sym_EQ_EQ] = ACTIONS(5738),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_GT] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5736),
    [anon_sym_LT_LT] = ACTIONS(5738),
    [anon_sym_GT_GT] = ACTIONS(5738),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym___extension__] = ACTIONS(5736),
    [anon_sym___attribute__] = ACTIONS(5736),
    [anon_sym___attribute] = ACTIONS(5736),
    [anon_sym_COLON] = ACTIONS(5738),
    [anon_sym___based] = ACTIONS(5736),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_signed] = ACTIONS(5736),
    [anon_sym_unsigned] = ACTIONS(5736),
    [anon_sym_long] = ACTIONS(5736),
    [anon_sym_short] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_const] = ACTIONS(5736),
    [anon_sym_constexpr] = ACTIONS(5736),
    [anon_sym_volatile] = ACTIONS(5736),
    [anon_sym_restrict] = ACTIONS(5736),
    [anon_sym___restrict__] = ACTIONS(5736),
    [anon_sym__Atomic] = ACTIONS(5736),
    [anon_sym__Noreturn] = ACTIONS(5736),
    [anon_sym_noreturn] = ACTIONS(5736),
    [anon_sym__Nonnull] = ACTIONS(5736),
    [anon_sym_mutable] = ACTIONS(5736),
    [anon_sym_constinit] = ACTIONS(5736),
    [anon_sym_consteval] = ACTIONS(5736),
    [anon_sym_alignas] = ACTIONS(5736),
    [anon_sym__Alignas] = ACTIONS(5736),
    [sym_primitive_type] = ACTIONS(5736),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5736),
    [anon_sym_and] = ACTIONS(5736),
    [anon_sym_bitor] = ACTIONS(5736),
    [anon_sym_xor] = ACTIONS(5736),
    [anon_sym_bitand] = ACTIONS(5736),
    [anon_sym_not_eq] = ACTIONS(5736),
    [anon_sym_DASH_DASH] = ACTIONS(5738),
    [anon_sym_PLUS_PLUS] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5736),
    [anon_sym_DOT_STAR] = ACTIONS(5738),
    [anon_sym_DASH_GT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5736),
    [anon_sym_decltype] = ACTIONS(5736),
    [anon_sym_final] = ACTIONS(5736),
    [anon_sym_override] = ACTIONS(5736),
    [anon_sym_requires] = ACTIONS(5736),
  },
  [1867] = {
    [sym_identifier] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5742),
    [anon_sym_COMMA] = ACTIONS(5742),
    [anon_sym_RPAREN] = ACTIONS(5742),
    [anon_sym_LPAREN2] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_STAR] = ACTIONS(5742),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5742),
    [anon_sym_AMP_AMP] = ACTIONS(5742),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_CARET] = ACTIONS(5742),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5742),
    [anon_sym_BANG_EQ] = ACTIONS(5742),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5742),
    [anon_sym_GT_GT] = ACTIONS(5742),
    [anon_sym_SEMI] = ACTIONS(5742),
    [anon_sym___extension__] = ACTIONS(5740),
    [anon_sym___attribute__] = ACTIONS(5740),
    [anon_sym___attribute] = ACTIONS(5740),
    [anon_sym_COLON] = ACTIONS(5742),
    [anon_sym___based] = ACTIONS(5740),
    [anon_sym_LBRACE] = ACTIONS(5742),
    [anon_sym_RBRACE] = ACTIONS(5742),
    [anon_sym_signed] = ACTIONS(5740),
    [anon_sym_unsigned] = ACTIONS(5740),
    [anon_sym_long] = ACTIONS(5740),
    [anon_sym_short] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_RBRACK] = ACTIONS(5742),
    [anon_sym_const] = ACTIONS(5740),
    [anon_sym_constexpr] = ACTIONS(5740),
    [anon_sym_volatile] = ACTIONS(5740),
    [anon_sym_restrict] = ACTIONS(5740),
    [anon_sym___restrict__] = ACTIONS(5740),
    [anon_sym__Atomic] = ACTIONS(5740),
    [anon_sym__Noreturn] = ACTIONS(5740),
    [anon_sym_noreturn] = ACTIONS(5740),
    [anon_sym__Nonnull] = ACTIONS(5740),
    [anon_sym_mutable] = ACTIONS(5740),
    [anon_sym_constinit] = ACTIONS(5740),
    [anon_sym_consteval] = ACTIONS(5740),
    [anon_sym_alignas] = ACTIONS(5740),
    [anon_sym__Alignas] = ACTIONS(5740),
    [sym_primitive_type] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_LT_EQ_GT] = ACTIONS(5742),
    [anon_sym_or] = ACTIONS(5740),
    [anon_sym_and] = ACTIONS(5740),
    [anon_sym_bitor] = ACTIONS(5740),
    [anon_sym_xor] = ACTIONS(5740),
    [anon_sym_bitand] = ACTIONS(5740),
    [anon_sym_not_eq] = ACTIONS(5740),
    [anon_sym_DASH_DASH] = ACTIONS(5742),
    [anon_sym_PLUS_PLUS] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_DOT_STAR] = ACTIONS(5742),
    [anon_sym_DASH_GT] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5740),
    [anon_sym_decltype] = ACTIONS(5740),
    [anon_sym_final] = ACTIONS(5740),
    [anon_sym_override] = ACTIONS(5740),
    [anon_sym_requires] = ACTIONS(5740),
  },
  [1868] = {
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_BANG] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_RBRACK] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(2573),
    [anon_sym_compl] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_PLUS] = ACTIONS(2563),
    [anon_sym_sizeof] = ACTIONS(2573),
    [anon_sym___alignof__] = ACTIONS(2573),
    [anon_sym___alignof] = ACTIONS(2573),
    [anon_sym__alignof] = ACTIONS(2573),
    [anon_sym_alignof] = ACTIONS(2573),
    [anon_sym__Alignof] = ACTIONS(2573),
    [anon_sym_offsetof] = ACTIONS(2573),
    [anon_sym__Generic] = ACTIONS(2573),
    [anon_sym_asm] = ACTIONS(2573),
    [anon_sym___asm__] = ACTIONS(2573),
    [anon_sym___asm] = ACTIONS(2573),
    [sym_number_literal] = ACTIONS(2563),
    [anon_sym_L_SQUOTE] = ACTIONS(2563),
    [anon_sym_u_SQUOTE] = ACTIONS(2563),
    [anon_sym_U_SQUOTE] = ACTIONS(2563),
    [anon_sym_u8_SQUOTE] = ACTIONS(2563),
    [anon_sym_SQUOTE] = ACTIONS(2563),
    [anon_sym_L_DQUOTE] = ACTIONS(2563),
    [anon_sym_u_DQUOTE] = ACTIONS(2563),
    [anon_sym_U_DQUOTE] = ACTIONS(2563),
    [anon_sym_u8_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [sym_true] = ACTIONS(2573),
    [sym_false] = ACTIONS(2573),
    [anon_sym_NULL] = ACTIONS(2573),
    [anon_sym_nullptr] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(2573),
    [anon_sym_R_DQUOTE] = ACTIONS(2563),
    [anon_sym_LR_DQUOTE] = ACTIONS(2563),
    [anon_sym_uR_DQUOTE] = ACTIONS(2563),
    [anon_sym_UR_DQUOTE] = ACTIONS(2563),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2563),
    [anon_sym_co_await] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2573),
    [anon_sym_requires] = ACTIONS(2573),
    [sym_this] = ACTIONS(2573),
  },
  [1869] = {
    [sym_type_qualifier] = STATE(1889),
    [sym_alignas_qualifier] = STATE(1695),
    [aux_sym__type_definition_type_repeat1] = STATE(1889),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5086),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_RPAREN] = ACTIONS(5086),
    [anon_sym_LPAREN2] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_STAR] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5088),
    [anon_sym_PERCENT] = ACTIONS(5086),
    [anon_sym_PIPE_PIPE] = ACTIONS(5086),
    [anon_sym_AMP_AMP] = ACTIONS(5086),
    [anon_sym_PIPE] = ACTIONS(5088),
    [anon_sym_CARET] = ACTIONS(5086),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_EQ_EQ] = ACTIONS(5086),
    [anon_sym_BANG_EQ] = ACTIONS(5086),
    [anon_sym_GT] = ACTIONS(5088),
    [anon_sym_GT_EQ] = ACTIONS(5086),
    [anon_sym_LT_EQ] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_LT_LT] = ACTIONS(5086),
    [anon_sym_GT_GT] = ACTIONS(5086),
    [anon_sym_SEMI] = ACTIONS(5086),
    [anon_sym___extension__] = ACTIONS(5706),
    [anon_sym___attribute__] = ACTIONS(5088),
    [anon_sym___attribute] = ACTIONS(5088),
    [anon_sym_COLON] = ACTIONS(5086),
    [anon_sym_LBRACE] = ACTIONS(5086),
    [anon_sym_RBRACE] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5746),
    [anon_sym_unsigned] = ACTIONS(5746),
    [anon_sym_long] = ACTIONS(5746),
    [anon_sym_short] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5086),
    [anon_sym_RBRACK] = ACTIONS(5086),
    [anon_sym_const] = ACTIONS(5706),
    [anon_sym_constexpr] = ACTIONS(5706),
    [anon_sym_volatile] = ACTIONS(5706),
    [anon_sym_restrict] = ACTIONS(5706),
    [anon_sym___restrict__] = ACTIONS(5706),
    [anon_sym__Atomic] = ACTIONS(5706),
    [anon_sym__Noreturn] = ACTIONS(5706),
    [anon_sym_noreturn] = ACTIONS(5706),
    [anon_sym__Nonnull] = ACTIONS(5706),
    [anon_sym_mutable] = ACTIONS(5706),
    [anon_sym_constinit] = ACTIONS(5706),
    [anon_sym_consteval] = ACTIONS(5706),
    [anon_sym_alignas] = ACTIONS(5710),
    [anon_sym__Alignas] = ACTIONS(5710),
    [sym_primitive_type] = ACTIONS(5748),
    [anon_sym_QMARK] = ACTIONS(5086),
    [anon_sym_LT_EQ_GT] = ACTIONS(5086),
    [anon_sym_or] = ACTIONS(5088),
    [anon_sym_and] = ACTIONS(5088),
    [anon_sym_bitor] = ACTIONS(5088),
    [anon_sym_xor] = ACTIONS(5088),
    [anon_sym_bitand] = ACTIONS(5088),
    [anon_sym_not_eq] = ACTIONS(5088),
    [anon_sym_DASH_DASH] = ACTIONS(5086),
    [anon_sym_PLUS_PLUS] = ACTIONS(5086),
    [anon_sym_DOT] = ACTIONS(5088),
    [anon_sym_DOT_STAR] = ACTIONS(5086),
    [anon_sym_DASH_GT] = ACTIONS(5086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5088),
    [anon_sym_decltype] = ACTIONS(5088),
  },
  [1870] = {
    [sym_identifier] = ACTIONS(5750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_RPAREN] = ACTIONS(5752),
    [anon_sym_LPAREN2] = ACTIONS(5752),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_STAR] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_PIPE] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5750),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_LT] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5752),
    [anon_sym___extension__] = ACTIONS(5750),
    [anon_sym___attribute__] = ACTIONS(5750),
    [anon_sym___attribute] = ACTIONS(5750),
    [anon_sym_COLON] = ACTIONS(5752),
    [anon_sym___based] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(5752),
    [anon_sym_signed] = ACTIONS(5750),
    [anon_sym_unsigned] = ACTIONS(5750),
    [anon_sym_long] = ACTIONS(5750),
    [anon_sym_short] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_RBRACK] = ACTIONS(5752),
    [anon_sym_const] = ACTIONS(5750),
    [anon_sym_constexpr] = ACTIONS(5750),
    [anon_sym_volatile] = ACTIONS(5750),
    [anon_sym_restrict] = ACTIONS(5750),
    [anon_sym___restrict__] = ACTIONS(5750),
    [anon_sym__Atomic] = ACTIONS(5750),
    [anon_sym__Noreturn] = ACTIONS(5750),
    [anon_sym_noreturn] = ACTIONS(5750),
    [anon_sym__Nonnull] = ACTIONS(5750),
    [anon_sym_mutable] = ACTIONS(5750),
    [anon_sym_constinit] = ACTIONS(5750),
    [anon_sym_consteval] = ACTIONS(5750),
    [anon_sym_alignas] = ACTIONS(5750),
    [anon_sym__Alignas] = ACTIONS(5750),
    [sym_primitive_type] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_bitor] = ACTIONS(5750),
    [anon_sym_xor] = ACTIONS(5750),
    [anon_sym_bitand] = ACTIONS(5750),
    [anon_sym_not_eq] = ACTIONS(5750),
    [anon_sym_DASH_DASH] = ACTIONS(5752),
    [anon_sym_PLUS_PLUS] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_DOT_STAR] = ACTIONS(5752),
    [anon_sym_DASH_GT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5750),
    [anon_sym_decltype] = ACTIONS(5750),
    [anon_sym_final] = ACTIONS(5750),
    [anon_sym_override] = ACTIONS(5750),
    [anon_sym_requires] = ACTIONS(5750),
  },
  [1871] = {
    [sym_identifier] = ACTIONS(5754),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_RPAREN] = ACTIONS(5756),
    [anon_sym_LPAREN2] = ACTIONS(5756),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_PLUS] = ACTIONS(5754),
    [anon_sym_STAR] = ACTIONS(5756),
    [anon_sym_SLASH] = ACTIONS(5754),
    [anon_sym_PERCENT] = ACTIONS(5756),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_AMP_AMP] = ACTIONS(5756),
    [anon_sym_PIPE] = ACTIONS(5754),
    [anon_sym_CARET] = ACTIONS(5756),
    [anon_sym_AMP] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5756),
    [anon_sym_GT] = ACTIONS(5754),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_LT] = ACTIONS(5754),
    [anon_sym_LT_LT] = ACTIONS(5756),
    [anon_sym_GT_GT] = ACTIONS(5756),
    [anon_sym_SEMI] = ACTIONS(5756),
    [anon_sym___extension__] = ACTIONS(5754),
    [anon_sym___attribute__] = ACTIONS(5754),
    [anon_sym___attribute] = ACTIONS(5754),
    [anon_sym_COLON] = ACTIONS(5756),
    [anon_sym___based] = ACTIONS(5754),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_RBRACE] = ACTIONS(5756),
    [anon_sym_signed] = ACTIONS(5754),
    [anon_sym_unsigned] = ACTIONS(5754),
    [anon_sym_long] = ACTIONS(5754),
    [anon_sym_short] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5756),
    [anon_sym_RBRACK] = ACTIONS(5756),
    [anon_sym_const] = ACTIONS(5754),
    [anon_sym_constexpr] = ACTIONS(5754),
    [anon_sym_volatile] = ACTIONS(5754),
    [anon_sym_restrict] = ACTIONS(5754),
    [anon_sym___restrict__] = ACTIONS(5754),
    [anon_sym__Atomic] = ACTIONS(5754),
    [anon_sym__Noreturn] = ACTIONS(5754),
    [anon_sym_noreturn] = ACTIONS(5754),
    [anon_sym__Nonnull] = ACTIONS(5754),
    [anon_sym_mutable] = ACTIONS(5754),
    [anon_sym_constinit] = ACTIONS(5754),
    [anon_sym_consteval] = ACTIONS(5754),
    [anon_sym_alignas] = ACTIONS(5754),
    [anon_sym__Alignas] = ACTIONS(5754),
    [sym_primitive_type] = ACTIONS(5754),
    [anon_sym_QMARK] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_or] = ACTIONS(5754),
    [anon_sym_and] = ACTIONS(5754),
    [anon_sym_bitor] = ACTIONS(5754),
    [anon_sym_xor] = ACTIONS(5754),
    [anon_sym_bitand] = ACTIONS(5754),
    [anon_sym_not_eq] = ACTIONS(5754),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_DOT_STAR] = ACTIONS(5756),
    [anon_sym_DASH_GT] = ACTIONS(5756),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5754),
    [anon_sym_decltype] = ACTIONS(5754),
    [anon_sym_final] = ACTIONS(5754),
    [anon_sym_override] = ACTIONS(5754),
    [anon_sym_requires] = ACTIONS(5754),
  },
  [1872] = {
    [sym_identifier] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_RPAREN] = ACTIONS(5760),
    [anon_sym_LPAREN2] = ACTIONS(5760),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5760),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_PERCENT] = ACTIONS(5760),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_AMP_AMP] = ACTIONS(5760),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(5760),
    [anon_sym_BANG_EQ] = ACTIONS(5760),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5760),
    [anon_sym_GT_GT] = ACTIONS(5760),
    [anon_sym_SEMI] = ACTIONS(5760),
    [anon_sym___extension__] = ACTIONS(5758),
    [anon_sym___attribute__] = ACTIONS(5758),
    [anon_sym___attribute] = ACTIONS(5758),
    [anon_sym_COLON] = ACTIONS(5760),
    [anon_sym___based] = ACTIONS(5758),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_RBRACE] = ACTIONS(5760),
    [anon_sym_signed] = ACTIONS(5758),
    [anon_sym_unsigned] = ACTIONS(5758),
    [anon_sym_long] = ACTIONS(5758),
    [anon_sym_short] = ACTIONS(5758),
    [anon_sym_LBRACK] = ACTIONS(5760),
    [anon_sym_RBRACK] = ACTIONS(5760),
    [anon_sym_const] = ACTIONS(5758),
    [anon_sym_constexpr] = ACTIONS(5758),
    [anon_sym_volatile] = ACTIONS(5758),
    [anon_sym_restrict] = ACTIONS(5758),
    [anon_sym___restrict__] = ACTIONS(5758),
    [anon_sym__Atomic] = ACTIONS(5758),
    [anon_sym__Noreturn] = ACTIONS(5758),
    [anon_sym_noreturn] = ACTIONS(5758),
    [anon_sym__Nonnull] = ACTIONS(5758),
    [anon_sym_mutable] = ACTIONS(5758),
    [anon_sym_constinit] = ACTIONS(5758),
    [anon_sym_consteval] = ACTIONS(5758),
    [anon_sym_alignas] = ACTIONS(5758),
    [anon_sym__Alignas] = ACTIONS(5758),
    [sym_primitive_type] = ACTIONS(5758),
    [anon_sym_QMARK] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_or] = ACTIONS(5758),
    [anon_sym_and] = ACTIONS(5758),
    [anon_sym_bitor] = ACTIONS(5758),
    [anon_sym_xor] = ACTIONS(5758),
    [anon_sym_bitand] = ACTIONS(5758),
    [anon_sym_not_eq] = ACTIONS(5758),
    [anon_sym_DASH_DASH] = ACTIONS(5760),
    [anon_sym_PLUS_PLUS] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DOT_STAR] = ACTIONS(5760),
    [anon_sym_DASH_GT] = ACTIONS(5760),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5758),
    [anon_sym_decltype] = ACTIONS(5758),
    [anon_sym_final] = ACTIONS(5758),
    [anon_sym_override] = ACTIONS(5758),
    [anon_sym_requires] = ACTIONS(5758),
  },
  [1873] = {
    [sym_identifier] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_RPAREN] = ACTIONS(5764),
    [anon_sym_LPAREN2] = ACTIONS(5764),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5764),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_PERCENT] = ACTIONS(5764),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_AMP_AMP] = ACTIONS(5764),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_CARET] = ACTIONS(5764),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(5764),
    [anon_sym_BANG_EQ] = ACTIONS(5764),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5764),
    [anon_sym_GT_GT] = ACTIONS(5764),
    [anon_sym_SEMI] = ACTIONS(5764),
    [anon_sym___extension__] = ACTIONS(5762),
    [anon_sym___attribute__] = ACTIONS(5762),
    [anon_sym___attribute] = ACTIONS(5762),
    [anon_sym_COLON] = ACTIONS(5764),
    [anon_sym___based] = ACTIONS(5762),
    [anon_sym_LBRACE] = ACTIONS(5764),
    [anon_sym_RBRACE] = ACTIONS(5764),
    [anon_sym_signed] = ACTIONS(5762),
    [anon_sym_unsigned] = ACTIONS(5762),
    [anon_sym_long] = ACTIONS(5762),
    [anon_sym_short] = ACTIONS(5762),
    [anon_sym_LBRACK] = ACTIONS(5764),
    [anon_sym_RBRACK] = ACTIONS(5764),
    [anon_sym_const] = ACTIONS(5762),
    [anon_sym_constexpr] = ACTIONS(5762),
    [anon_sym_volatile] = ACTIONS(5762),
    [anon_sym_restrict] = ACTIONS(5762),
    [anon_sym___restrict__] = ACTIONS(5762),
    [anon_sym__Atomic] = ACTIONS(5762),
    [anon_sym__Noreturn] = ACTIONS(5762),
    [anon_sym_noreturn] = ACTIONS(5762),
    [anon_sym__Nonnull] = ACTIONS(5762),
    [anon_sym_mutable] = ACTIONS(5762),
    [anon_sym_constinit] = ACTIONS(5762),
    [anon_sym_consteval] = ACTIONS(5762),
    [anon_sym_alignas] = ACTIONS(5762),
    [anon_sym__Alignas] = ACTIONS(5762),
    [sym_primitive_type] = ACTIONS(5762),
    [anon_sym_QMARK] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_or] = ACTIONS(5762),
    [anon_sym_and] = ACTIONS(5762),
    [anon_sym_bitor] = ACTIONS(5762),
    [anon_sym_xor] = ACTIONS(5762),
    [anon_sym_bitand] = ACTIONS(5762),
    [anon_sym_not_eq] = ACTIONS(5762),
    [anon_sym_DASH_DASH] = ACTIONS(5764),
    [anon_sym_PLUS_PLUS] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DOT_STAR] = ACTIONS(5764),
    [anon_sym_DASH_GT] = ACTIONS(5764),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5762),
    [anon_sym_decltype] = ACTIONS(5762),
    [anon_sym_final] = ACTIONS(5762),
    [anon_sym_override] = ACTIONS(5762),
    [anon_sym_requires] = ACTIONS(5762),
  },
  [1874] = {
    [sym_identifier] = ACTIONS(5766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_RPAREN] = ACTIONS(5768),
    [anon_sym_LPAREN2] = ACTIONS(5768),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_PLUS] = ACTIONS(5766),
    [anon_sym_STAR] = ACTIONS(5768),
    [anon_sym_SLASH] = ACTIONS(5766),
    [anon_sym_PERCENT] = ACTIONS(5768),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_AMP_AMP] = ACTIONS(5768),
    [anon_sym_PIPE] = ACTIONS(5766),
    [anon_sym_CARET] = ACTIONS(5768),
    [anon_sym_AMP] = ACTIONS(5766),
    [anon_sym_EQ_EQ] = ACTIONS(5768),
    [anon_sym_BANG_EQ] = ACTIONS(5768),
    [anon_sym_GT] = ACTIONS(5766),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_LT] = ACTIONS(5766),
    [anon_sym_LT_LT] = ACTIONS(5768),
    [anon_sym_GT_GT] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(5768),
    [anon_sym___extension__] = ACTIONS(5766),
    [anon_sym___attribute__] = ACTIONS(5766),
    [anon_sym___attribute] = ACTIONS(5766),
    [anon_sym_COLON] = ACTIONS(5768),
    [anon_sym___based] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(5768),
    [anon_sym_RBRACE] = ACTIONS(5768),
    [anon_sym_signed] = ACTIONS(5766),
    [anon_sym_unsigned] = ACTIONS(5766),
    [anon_sym_long] = ACTIONS(5766),
    [anon_sym_short] = ACTIONS(5766),
    [anon_sym_LBRACK] = ACTIONS(5768),
    [anon_sym_RBRACK] = ACTIONS(5768),
    [anon_sym_const] = ACTIONS(5766),
    [anon_sym_constexpr] = ACTIONS(5766),
    [anon_sym_volatile] = ACTIONS(5766),
    [anon_sym_restrict] = ACTIONS(5766),
    [anon_sym___restrict__] = ACTIONS(5766),
    [anon_sym__Atomic] = ACTIONS(5766),
    [anon_sym__Noreturn] = ACTIONS(5766),
    [anon_sym_noreturn] = ACTIONS(5766),
    [anon_sym__Nonnull] = ACTIONS(5766),
    [anon_sym_mutable] = ACTIONS(5766),
    [anon_sym_constinit] = ACTIONS(5766),
    [anon_sym_consteval] = ACTIONS(5766),
    [anon_sym_alignas] = ACTIONS(5766),
    [anon_sym__Alignas] = ACTIONS(5766),
    [sym_primitive_type] = ACTIONS(5766),
    [anon_sym_QMARK] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_or] = ACTIONS(5766),
    [anon_sym_and] = ACTIONS(5766),
    [anon_sym_bitor] = ACTIONS(5766),
    [anon_sym_xor] = ACTIONS(5766),
    [anon_sym_bitand] = ACTIONS(5766),
    [anon_sym_not_eq] = ACTIONS(5766),
    [anon_sym_DASH_DASH] = ACTIONS(5768),
    [anon_sym_PLUS_PLUS] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_DOT_STAR] = ACTIONS(5768),
    [anon_sym_DASH_GT] = ACTIONS(5768),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5766),
    [anon_sym_decltype] = ACTIONS(5766),
    [anon_sym_final] = ACTIONS(5766),
    [anon_sym_override] = ACTIONS(5766),
    [anon_sym_requires] = ACTIONS(5766),
  },
  [1875] = {
    [sym_identifier] = ACTIONS(5770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_RPAREN] = ACTIONS(5772),
    [anon_sym_LPAREN2] = ACTIONS(5772),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_PLUS] = ACTIONS(5770),
    [anon_sym_STAR] = ACTIONS(5772),
    [anon_sym_SLASH] = ACTIONS(5770),
    [anon_sym_PERCENT] = ACTIONS(5772),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_AMP_AMP] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5770),
    [anon_sym_CARET] = ACTIONS(5772),
    [anon_sym_AMP] = ACTIONS(5770),
    [anon_sym_EQ_EQ] = ACTIONS(5772),
    [anon_sym_BANG_EQ] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5770),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5772),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym___extension__] = ACTIONS(5770),
    [anon_sym___attribute__] = ACTIONS(5770),
    [anon_sym___attribute] = ACTIONS(5770),
    [anon_sym_COLON] = ACTIONS(5772),
    [anon_sym___based] = ACTIONS(5770),
    [anon_sym_LBRACE] = ACTIONS(5772),
    [anon_sym_RBRACE] = ACTIONS(5772),
    [anon_sym_signed] = ACTIONS(5770),
    [anon_sym_unsigned] = ACTIONS(5770),
    [anon_sym_long] = ACTIONS(5770),
    [anon_sym_short] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(5772),
    [anon_sym_RBRACK] = ACTIONS(5772),
    [anon_sym_const] = ACTIONS(5770),
    [anon_sym_constexpr] = ACTIONS(5770),
    [anon_sym_volatile] = ACTIONS(5770),
    [anon_sym_restrict] = ACTIONS(5770),
    [anon_sym___restrict__] = ACTIONS(5770),
    [anon_sym__Atomic] = ACTIONS(5770),
    [anon_sym__Noreturn] = ACTIONS(5770),
    [anon_sym_noreturn] = ACTIONS(5770),
    [anon_sym__Nonnull] = ACTIONS(5770),
    [anon_sym_mutable] = ACTIONS(5770),
    [anon_sym_constinit] = ACTIONS(5770),
    [anon_sym_consteval] = ACTIONS(5770),
    [anon_sym_alignas] = ACTIONS(5770),
    [anon_sym__Alignas] = ACTIONS(5770),
    [sym_primitive_type] = ACTIONS(5770),
    [anon_sym_QMARK] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_or] = ACTIONS(5770),
    [anon_sym_and] = ACTIONS(5770),
    [anon_sym_bitor] = ACTIONS(5770),
    [anon_sym_xor] = ACTIONS(5770),
    [anon_sym_bitand] = ACTIONS(5770),
    [anon_sym_not_eq] = ACTIONS(5770),
    [anon_sym_DASH_DASH] = ACTIONS(5772),
    [anon_sym_PLUS_PLUS] = ACTIONS(5772),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_DOT_STAR] = ACTIONS(5772),
    [anon_sym_DASH_GT] = ACTIONS(5772),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5770),
    [anon_sym_decltype] = ACTIONS(5770),
    [anon_sym_final] = ACTIONS(5770),
    [anon_sym_override] = ACTIONS(5770),
    [anon_sym_requires] = ACTIONS(5770),
  },
  [1876] = {
    [sym_identifier] = ACTIONS(5774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5776),
    [anon_sym_COMMA] = ACTIONS(5776),
    [anon_sym_RPAREN] = ACTIONS(5776),
    [anon_sym_LPAREN2] = ACTIONS(5776),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_PLUS] = ACTIONS(5774),
    [anon_sym_STAR] = ACTIONS(5776),
    [anon_sym_SLASH] = ACTIONS(5774),
    [anon_sym_PERCENT] = ACTIONS(5776),
    [anon_sym_PIPE_PIPE] = ACTIONS(5776),
    [anon_sym_AMP_AMP] = ACTIONS(5776),
    [anon_sym_PIPE] = ACTIONS(5774),
    [anon_sym_CARET] = ACTIONS(5776),
    [anon_sym_AMP] = ACTIONS(5774),
    [anon_sym_EQ_EQ] = ACTIONS(5776),
    [anon_sym_BANG_EQ] = ACTIONS(5776),
    [anon_sym_GT] = ACTIONS(5774),
    [anon_sym_GT_EQ] = ACTIONS(5776),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_LT] = ACTIONS(5774),
    [anon_sym_LT_LT] = ACTIONS(5776),
    [anon_sym_GT_GT] = ACTIONS(5776),
    [anon_sym_SEMI] = ACTIONS(5776),
    [anon_sym___extension__] = ACTIONS(5774),
    [anon_sym___attribute__] = ACTIONS(5774),
    [anon_sym___attribute] = ACTIONS(5774),
    [anon_sym_COLON] = ACTIONS(5776),
    [anon_sym___based] = ACTIONS(5774),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_RBRACE] = ACTIONS(5776),
    [anon_sym_signed] = ACTIONS(5774),
    [anon_sym_unsigned] = ACTIONS(5774),
    [anon_sym_long] = ACTIONS(5774),
    [anon_sym_short] = ACTIONS(5774),
    [anon_sym_LBRACK] = ACTIONS(5776),
    [anon_sym_RBRACK] = ACTIONS(5776),
    [anon_sym_const] = ACTIONS(5774),
    [anon_sym_constexpr] = ACTIONS(5774),
    [anon_sym_volatile] = ACTIONS(5774),
    [anon_sym_restrict] = ACTIONS(5774),
    [anon_sym___restrict__] = ACTIONS(5774),
    [anon_sym__Atomic] = ACTIONS(5774),
    [anon_sym__Noreturn] = ACTIONS(5774),
    [anon_sym_noreturn] = ACTIONS(5774),
    [anon_sym__Nonnull] = ACTIONS(5774),
    [anon_sym_mutable] = ACTIONS(5774),
    [anon_sym_constinit] = ACTIONS(5774),
    [anon_sym_consteval] = ACTIONS(5774),
    [anon_sym_alignas] = ACTIONS(5774),
    [anon_sym__Alignas] = ACTIONS(5774),
    [sym_primitive_type] = ACTIONS(5774),
    [anon_sym_QMARK] = ACTIONS(5776),
    [anon_sym_LT_EQ_GT] = ACTIONS(5776),
    [anon_sym_or] = ACTIONS(5774),
    [anon_sym_and] = ACTIONS(5774),
    [anon_sym_bitor] = ACTIONS(5774),
    [anon_sym_xor] = ACTIONS(5774),
    [anon_sym_bitand] = ACTIONS(5774),
    [anon_sym_not_eq] = ACTIONS(5774),
    [anon_sym_DASH_DASH] = ACTIONS(5776),
    [anon_sym_PLUS_PLUS] = ACTIONS(5776),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_DOT_STAR] = ACTIONS(5776),
    [anon_sym_DASH_GT] = ACTIONS(5776),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5774),
    [anon_sym_decltype] = ACTIONS(5774),
    [anon_sym_final] = ACTIONS(5774),
    [anon_sym_override] = ACTIONS(5774),
    [anon_sym_requires] = ACTIONS(5774),
  },
  [1877] = {
    [sym_identifier] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5780),
    [anon_sym_COMMA] = ACTIONS(5780),
    [anon_sym_RPAREN] = ACTIONS(5780),
    [anon_sym_LPAREN2] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_STAR] = ACTIONS(5780),
    [anon_sym_SLASH] = ACTIONS(5778),
    [anon_sym_PERCENT] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5780),
    [anon_sym_AMP_AMP] = ACTIONS(5780),
    [anon_sym_PIPE] = ACTIONS(5778),
    [anon_sym_CARET] = ACTIONS(5780),
    [anon_sym_AMP] = ACTIONS(5778),
    [anon_sym_EQ_EQ] = ACTIONS(5780),
    [anon_sym_BANG_EQ] = ACTIONS(5780),
    [anon_sym_GT] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5778),
    [anon_sym_LT_LT] = ACTIONS(5780),
    [anon_sym_GT_GT] = ACTIONS(5780),
    [anon_sym_SEMI] = ACTIONS(5780),
    [anon_sym___extension__] = ACTIONS(5778),
    [anon_sym___attribute__] = ACTIONS(5778),
    [anon_sym___attribute] = ACTIONS(5778),
    [anon_sym_COLON] = ACTIONS(5780),
    [anon_sym___based] = ACTIONS(5778),
    [anon_sym_LBRACE] = ACTIONS(5780),
    [anon_sym_RBRACE] = ACTIONS(5780),
    [anon_sym_signed] = ACTIONS(5778),
    [anon_sym_unsigned] = ACTIONS(5778),
    [anon_sym_long] = ACTIONS(5778),
    [anon_sym_short] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_RBRACK] = ACTIONS(5780),
    [anon_sym_const] = ACTIONS(5778),
    [anon_sym_constexpr] = ACTIONS(5778),
    [anon_sym_volatile] = ACTIONS(5778),
    [anon_sym_restrict] = ACTIONS(5778),
    [anon_sym___restrict__] = ACTIONS(5778),
    [anon_sym__Atomic] = ACTIONS(5778),
    [anon_sym__Noreturn] = ACTIONS(5778),
    [anon_sym_noreturn] = ACTIONS(5778),
    [anon_sym__Nonnull] = ACTIONS(5778),
    [anon_sym_mutable] = ACTIONS(5778),
    [anon_sym_constinit] = ACTIONS(5778),
    [anon_sym_consteval] = ACTIONS(5778),
    [anon_sym_alignas] = ACTIONS(5778),
    [anon_sym__Alignas] = ACTIONS(5778),
    [sym_primitive_type] = ACTIONS(5778),
    [anon_sym_QMARK] = ACTIONS(5780),
    [anon_sym_LT_EQ_GT] = ACTIONS(5780),
    [anon_sym_or] = ACTIONS(5778),
    [anon_sym_and] = ACTIONS(5778),
    [anon_sym_bitor] = ACTIONS(5778),
    [anon_sym_xor] = ACTIONS(5778),
    [anon_sym_bitand] = ACTIONS(5778),
    [anon_sym_not_eq] = ACTIONS(5778),
    [anon_sym_DASH_DASH] = ACTIONS(5780),
    [anon_sym_PLUS_PLUS] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5778),
    [anon_sym_DOT_STAR] = ACTIONS(5780),
    [anon_sym_DASH_GT] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5778),
    [anon_sym_decltype] = ACTIONS(5778),
    [anon_sym_final] = ACTIONS(5778),
    [anon_sym_override] = ACTIONS(5778),
    [anon_sym_requires] = ACTIONS(5778),
  },
  [1878] = {
    [sym_identifier] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5784),
    [anon_sym_COMMA] = ACTIONS(5784),
    [anon_sym_RPAREN] = ACTIONS(5784),
    [anon_sym_LPAREN2] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5782),
    [anon_sym_STAR] = ACTIONS(5784),
    [anon_sym_SLASH] = ACTIONS(5782),
    [anon_sym_PERCENT] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5784),
    [anon_sym_AMP_AMP] = ACTIONS(5784),
    [anon_sym_PIPE] = ACTIONS(5782),
    [anon_sym_CARET] = ACTIONS(5784),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_EQ_EQ] = ACTIONS(5784),
    [anon_sym_BANG_EQ] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5782),
    [anon_sym_LT_LT] = ACTIONS(5784),
    [anon_sym_GT_GT] = ACTIONS(5784),
    [anon_sym_SEMI] = ACTIONS(5784),
    [anon_sym___extension__] = ACTIONS(5782),
    [anon_sym___attribute__] = ACTIONS(5782),
    [anon_sym___attribute] = ACTIONS(5782),
    [anon_sym_COLON] = ACTIONS(5784),
    [anon_sym___based] = ACTIONS(5782),
    [anon_sym_LBRACE] = ACTIONS(5784),
    [anon_sym_RBRACE] = ACTIONS(5784),
    [anon_sym_signed] = ACTIONS(5782),
    [anon_sym_unsigned] = ACTIONS(5782),
    [anon_sym_long] = ACTIONS(5782),
    [anon_sym_short] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_RBRACK] = ACTIONS(5784),
    [anon_sym_const] = ACTIONS(5782),
    [anon_sym_constexpr] = ACTIONS(5782),
    [anon_sym_volatile] = ACTIONS(5782),
    [anon_sym_restrict] = ACTIONS(5782),
    [anon_sym___restrict__] = ACTIONS(5782),
    [anon_sym__Atomic] = ACTIONS(5782),
    [anon_sym__Noreturn] = ACTIONS(5782),
    [anon_sym_noreturn] = ACTIONS(5782),
    [anon_sym__Nonnull] = ACTIONS(5782),
    [anon_sym_mutable] = ACTIONS(5782),
    [anon_sym_constinit] = ACTIONS(5782),
    [anon_sym_consteval] = ACTIONS(5782),
    [anon_sym_alignas] = ACTIONS(5782),
    [anon_sym__Alignas] = ACTIONS(5782),
    [sym_primitive_type] = ACTIONS(5782),
    [anon_sym_QMARK] = ACTIONS(5784),
    [anon_sym_LT_EQ_GT] = ACTIONS(5784),
    [anon_sym_or] = ACTIONS(5782),
    [anon_sym_and] = ACTIONS(5782),
    [anon_sym_bitor] = ACTIONS(5782),
    [anon_sym_xor] = ACTIONS(5782),
    [anon_sym_bitand] = ACTIONS(5782),
    [anon_sym_not_eq] = ACTIONS(5782),
    [anon_sym_DASH_DASH] = ACTIONS(5784),
    [anon_sym_PLUS_PLUS] = ACTIONS(5784),
    [anon_sym_DOT] = ACTIONS(5782),
    [anon_sym_DOT_STAR] = ACTIONS(5784),
    [anon_sym_DASH_GT] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5782),
    [anon_sym_decltype] = ACTIONS(5782),
    [anon_sym_final] = ACTIONS(5782),
    [anon_sym_override] = ACTIONS(5782),
    [anon_sym_requires] = ACTIONS(5782),
  },
  [1879] = {
    [sym_identifier] = ACTIONS(5450),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym___extension__] = ACTIONS(5450),
    [anon_sym___attribute__] = ACTIONS(5450),
    [anon_sym___attribute] = ACTIONS(5450),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym___based] = ACTIONS(5450),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_signed] = ACTIONS(5450),
    [anon_sym_unsigned] = ACTIONS(5450),
    [anon_sym_long] = ACTIONS(5450),
    [anon_sym_short] = ACTIONS(5450),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_const] = ACTIONS(5450),
    [anon_sym_constexpr] = ACTIONS(5450),
    [anon_sym_volatile] = ACTIONS(5450),
    [anon_sym_restrict] = ACTIONS(5450),
    [anon_sym___restrict__] = ACTIONS(5450),
    [anon_sym__Atomic] = ACTIONS(5450),
    [anon_sym__Noreturn] = ACTIONS(5450),
    [anon_sym_noreturn] = ACTIONS(5450),
    [anon_sym__Nonnull] = ACTIONS(5450),
    [anon_sym_mutable] = ACTIONS(5450),
    [anon_sym_constinit] = ACTIONS(5450),
    [anon_sym_consteval] = ACTIONS(5450),
    [anon_sym_alignas] = ACTIONS(5450),
    [anon_sym__Alignas] = ACTIONS(5450),
    [sym_primitive_type] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_and] = ACTIONS(5450),
    [anon_sym_bitor] = ACTIONS(5450),
    [anon_sym_xor] = ACTIONS(5450),
    [anon_sym_bitand] = ACTIONS(5450),
    [anon_sym_not_eq] = ACTIONS(5450),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5450),
    [anon_sym_decltype] = ACTIONS(5450),
    [anon_sym_final] = ACTIONS(5450),
    [anon_sym_override] = ACTIONS(5450),
    [anon_sym_requires] = ACTIONS(5450),
  },
  [1880] = {
    [sym_identifier] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5788),
    [anon_sym_RPAREN] = ACTIONS(5788),
    [anon_sym_LPAREN2] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5786),
    [anon_sym_STAR] = ACTIONS(5788),
    [anon_sym_SLASH] = ACTIONS(5786),
    [anon_sym_PERCENT] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5788),
    [anon_sym_AMP_AMP] = ACTIONS(5788),
    [anon_sym_PIPE] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5788),
    [anon_sym_AMP] = ACTIONS(5786),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5786),
    [anon_sym_LT_LT] = ACTIONS(5788),
    [anon_sym_GT_GT] = ACTIONS(5788),
    [anon_sym_SEMI] = ACTIONS(5788),
    [anon_sym___extension__] = ACTIONS(5786),
    [anon_sym___attribute__] = ACTIONS(5786),
    [anon_sym___attribute] = ACTIONS(5786),
    [anon_sym_COLON] = ACTIONS(5788),
    [anon_sym___based] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5788),
    [anon_sym_RBRACE] = ACTIONS(5788),
    [anon_sym_signed] = ACTIONS(5786),
    [anon_sym_unsigned] = ACTIONS(5786),
    [anon_sym_long] = ACTIONS(5786),
    [anon_sym_short] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_RBRACK] = ACTIONS(5788),
    [anon_sym_const] = ACTIONS(5786),
    [anon_sym_constexpr] = ACTIONS(5786),
    [anon_sym_volatile] = ACTIONS(5786),
    [anon_sym_restrict] = ACTIONS(5786),
    [anon_sym___restrict__] = ACTIONS(5786),
    [anon_sym__Atomic] = ACTIONS(5786),
    [anon_sym__Noreturn] = ACTIONS(5786),
    [anon_sym_noreturn] = ACTIONS(5786),
    [anon_sym__Nonnull] = ACTIONS(5786),
    [anon_sym_mutable] = ACTIONS(5786),
    [anon_sym_constinit] = ACTIONS(5786),
    [anon_sym_consteval] = ACTIONS(5786),
    [anon_sym_alignas] = ACTIONS(5786),
    [anon_sym__Alignas] = ACTIONS(5786),
    [sym_primitive_type] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5788),
    [anon_sym_LT_EQ_GT] = ACTIONS(5788),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_bitor] = ACTIONS(5786),
    [anon_sym_xor] = ACTIONS(5786),
    [anon_sym_bitand] = ACTIONS(5786),
    [anon_sym_not_eq] = ACTIONS(5786),
    [anon_sym_DASH_DASH] = ACTIONS(5788),
    [anon_sym_PLUS_PLUS] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5786),
    [anon_sym_DOT_STAR] = ACTIONS(5788),
    [anon_sym_DASH_GT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5786),
    [anon_sym_decltype] = ACTIONS(5786),
    [anon_sym_final] = ACTIONS(5786),
    [anon_sym_override] = ACTIONS(5786),
    [anon_sym_requires] = ACTIONS(5786),
  },
  [1881] = {
    [sym_identifier] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5792),
    [anon_sym_COMMA] = ACTIONS(5792),
    [anon_sym_RPAREN] = ACTIONS(5792),
    [anon_sym_LPAREN2] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5790),
    [anon_sym_STAR] = ACTIONS(5792),
    [anon_sym_SLASH] = ACTIONS(5790),
    [anon_sym_PERCENT] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5792),
    [anon_sym_AMP_AMP] = ACTIONS(5792),
    [anon_sym_PIPE] = ACTIONS(5790),
    [anon_sym_CARET] = ACTIONS(5792),
    [anon_sym_AMP] = ACTIONS(5790),
    [anon_sym_EQ_EQ] = ACTIONS(5792),
    [anon_sym_BANG_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5790),
    [anon_sym_LT_LT] = ACTIONS(5792),
    [anon_sym_GT_GT] = ACTIONS(5792),
    [anon_sym_SEMI] = ACTIONS(5792),
    [anon_sym___extension__] = ACTIONS(5790),
    [anon_sym___attribute__] = ACTIONS(5790),
    [anon_sym___attribute] = ACTIONS(5790),
    [anon_sym_COLON] = ACTIONS(5792),
    [anon_sym___based] = ACTIONS(5790),
    [anon_sym_LBRACE] = ACTIONS(5792),
    [anon_sym_RBRACE] = ACTIONS(5792),
    [anon_sym_signed] = ACTIONS(5790),
    [anon_sym_unsigned] = ACTIONS(5790),
    [anon_sym_long] = ACTIONS(5790),
    [anon_sym_short] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_RBRACK] = ACTIONS(5792),
    [anon_sym_const] = ACTIONS(5790),
    [anon_sym_constexpr] = ACTIONS(5790),
    [anon_sym_volatile] = ACTIONS(5790),
    [anon_sym_restrict] = ACTIONS(5790),
    [anon_sym___restrict__] = ACTIONS(5790),
    [anon_sym__Atomic] = ACTIONS(5790),
    [anon_sym__Noreturn] = ACTIONS(5790),
    [anon_sym_noreturn] = ACTIONS(5790),
    [anon_sym__Nonnull] = ACTIONS(5790),
    [anon_sym_mutable] = ACTIONS(5790),
    [anon_sym_constinit] = ACTIONS(5790),
    [anon_sym_consteval] = ACTIONS(5790),
    [anon_sym_alignas] = ACTIONS(5790),
    [anon_sym__Alignas] = ACTIONS(5790),
    [sym_primitive_type] = ACTIONS(5790),
    [anon_sym_QMARK] = ACTIONS(5792),
    [anon_sym_LT_EQ_GT] = ACTIONS(5792),
    [anon_sym_or] = ACTIONS(5790),
    [anon_sym_and] = ACTIONS(5790),
    [anon_sym_bitor] = ACTIONS(5790),
    [anon_sym_xor] = ACTIONS(5790),
    [anon_sym_bitand] = ACTIONS(5790),
    [anon_sym_not_eq] = ACTIONS(5790),
    [anon_sym_DASH_DASH] = ACTIONS(5792),
    [anon_sym_PLUS_PLUS] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5790),
    [anon_sym_DOT_STAR] = ACTIONS(5792),
    [anon_sym_DASH_GT] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5790),
    [anon_sym_decltype] = ACTIONS(5790),
    [anon_sym_final] = ACTIONS(5790),
    [anon_sym_override] = ACTIONS(5790),
    [anon_sym_requires] = ACTIONS(5790),
  },
  [1882] = {
    [sym_identifier] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5796),
    [anon_sym_COMMA] = ACTIONS(5796),
    [anon_sym_RPAREN] = ACTIONS(5796),
    [anon_sym_LPAREN2] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5794),
    [anon_sym_STAR] = ACTIONS(5796),
    [anon_sym_SLASH] = ACTIONS(5794),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_CARET] = ACTIONS(5796),
    [anon_sym_AMP] = ACTIONS(5794),
    [anon_sym_EQ_EQ] = ACTIONS(5796),
    [anon_sym_BANG_EQ] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_GT_GT] = ACTIONS(5796),
    [anon_sym_SEMI] = ACTIONS(5796),
    [anon_sym___extension__] = ACTIONS(5794),
    [anon_sym___attribute__] = ACTIONS(5794),
    [anon_sym___attribute] = ACTIONS(5794),
    [anon_sym_COLON] = ACTIONS(5796),
    [anon_sym___based] = ACTIONS(5794),
    [anon_sym_LBRACE] = ACTIONS(5796),
    [anon_sym_RBRACE] = ACTIONS(5796),
    [anon_sym_signed] = ACTIONS(5794),
    [anon_sym_unsigned] = ACTIONS(5794),
    [anon_sym_long] = ACTIONS(5794),
    [anon_sym_short] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_RBRACK] = ACTIONS(5796),
    [anon_sym_const] = ACTIONS(5794),
    [anon_sym_constexpr] = ACTIONS(5794),
    [anon_sym_volatile] = ACTIONS(5794),
    [anon_sym_restrict] = ACTIONS(5794),
    [anon_sym___restrict__] = ACTIONS(5794),
    [anon_sym__Atomic] = ACTIONS(5794),
    [anon_sym__Noreturn] = ACTIONS(5794),
    [anon_sym_noreturn] = ACTIONS(5794),
    [anon_sym__Nonnull] = ACTIONS(5794),
    [anon_sym_mutable] = ACTIONS(5794),
    [anon_sym_constinit] = ACTIONS(5794),
    [anon_sym_consteval] = ACTIONS(5794),
    [anon_sym_alignas] = ACTIONS(5794),
    [anon_sym__Alignas] = ACTIONS(5794),
    [sym_primitive_type] = ACTIONS(5794),
    [anon_sym_QMARK] = ACTIONS(5796),
    [anon_sym_LT_EQ_GT] = ACTIONS(5796),
    [anon_sym_or] = ACTIONS(5794),
    [anon_sym_and] = ACTIONS(5794),
    [anon_sym_bitor] = ACTIONS(5794),
    [anon_sym_xor] = ACTIONS(5794),
    [anon_sym_bitand] = ACTIONS(5794),
    [anon_sym_not_eq] = ACTIONS(5794),
    [anon_sym_DASH_DASH] = ACTIONS(5796),
    [anon_sym_PLUS_PLUS] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5794),
    [anon_sym_DOT_STAR] = ACTIONS(5796),
    [anon_sym_DASH_GT] = ACTIONS(5796),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5794),
    [anon_sym_decltype] = ACTIONS(5794),
    [anon_sym_final] = ACTIONS(5794),
    [anon_sym_override] = ACTIONS(5794),
    [anon_sym_requires] = ACTIONS(5794),
  },
  [1883] = {
    [sym_identifier] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5788),
    [anon_sym_RPAREN] = ACTIONS(5788),
    [anon_sym_LPAREN2] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5786),
    [anon_sym_STAR] = ACTIONS(5788),
    [anon_sym_SLASH] = ACTIONS(5786),
    [anon_sym_PERCENT] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5788),
    [anon_sym_AMP_AMP] = ACTIONS(5788),
    [anon_sym_PIPE] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5788),
    [anon_sym_AMP] = ACTIONS(5786),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5786),
    [anon_sym_LT_LT] = ACTIONS(5788),
    [anon_sym_GT_GT] = ACTIONS(5788),
    [anon_sym_SEMI] = ACTIONS(5788),
    [anon_sym___extension__] = ACTIONS(5786),
    [anon_sym___attribute__] = ACTIONS(5786),
    [anon_sym___attribute] = ACTIONS(5786),
    [anon_sym_COLON] = ACTIONS(5788),
    [anon_sym___based] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5788),
    [anon_sym_RBRACE] = ACTIONS(5788),
    [anon_sym_signed] = ACTIONS(5786),
    [anon_sym_unsigned] = ACTIONS(5786),
    [anon_sym_long] = ACTIONS(5786),
    [anon_sym_short] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_RBRACK] = ACTIONS(5788),
    [anon_sym_const] = ACTIONS(5786),
    [anon_sym_constexpr] = ACTIONS(5786),
    [anon_sym_volatile] = ACTIONS(5786),
    [anon_sym_restrict] = ACTIONS(5786),
    [anon_sym___restrict__] = ACTIONS(5786),
    [anon_sym__Atomic] = ACTIONS(5786),
    [anon_sym__Noreturn] = ACTIONS(5786),
    [anon_sym_noreturn] = ACTIONS(5786),
    [anon_sym__Nonnull] = ACTIONS(5786),
    [anon_sym_mutable] = ACTIONS(5786),
    [anon_sym_constinit] = ACTIONS(5786),
    [anon_sym_consteval] = ACTIONS(5786),
    [anon_sym_alignas] = ACTIONS(5786),
    [anon_sym__Alignas] = ACTIONS(5786),
    [sym_primitive_type] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5788),
    [anon_sym_LT_EQ_GT] = ACTIONS(5788),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_bitor] = ACTIONS(5786),
    [anon_sym_xor] = ACTIONS(5786),
    [anon_sym_bitand] = ACTIONS(5786),
    [anon_sym_not_eq] = ACTIONS(5786),
    [anon_sym_DASH_DASH] = ACTIONS(5788),
    [anon_sym_PLUS_PLUS] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5786),
    [anon_sym_DOT_STAR] = ACTIONS(5788),
    [anon_sym_DASH_GT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5786),
    [anon_sym_decltype] = ACTIONS(5786),
    [anon_sym_final] = ACTIONS(5786),
    [anon_sym_override] = ACTIONS(5786),
    [anon_sym_requires] = ACTIONS(5786),
  },
  [1884] = {
    [sym_identifier] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_COMMA] = ACTIONS(5800),
    [anon_sym_RPAREN] = ACTIONS(5800),
    [anon_sym_LPAREN2] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_SLASH] = ACTIONS(5798),
    [anon_sym_PERCENT] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5800),
    [anon_sym_AMP_AMP] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5798),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_AMP] = ACTIONS(5798),
    [anon_sym_EQ_EQ] = ACTIONS(5800),
    [anon_sym_BANG_EQ] = ACTIONS(5800),
    [anon_sym_GT] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5798),
    [anon_sym_LT_LT] = ACTIONS(5800),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_SEMI] = ACTIONS(5800),
    [anon_sym___extension__] = ACTIONS(5798),
    [anon_sym___attribute__] = ACTIONS(5798),
    [anon_sym___attribute] = ACTIONS(5798),
    [anon_sym_COLON] = ACTIONS(5800),
    [anon_sym___based] = ACTIONS(5798),
    [anon_sym_LBRACE] = ACTIONS(5800),
    [anon_sym_RBRACE] = ACTIONS(5800),
    [anon_sym_signed] = ACTIONS(5798),
    [anon_sym_unsigned] = ACTIONS(5798),
    [anon_sym_long] = ACTIONS(5798),
    [anon_sym_short] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_RBRACK] = ACTIONS(5800),
    [anon_sym_const] = ACTIONS(5798),
    [anon_sym_constexpr] = ACTIONS(5798),
    [anon_sym_volatile] = ACTIONS(5798),
    [anon_sym_restrict] = ACTIONS(5798),
    [anon_sym___restrict__] = ACTIONS(5798),
    [anon_sym__Atomic] = ACTIONS(5798),
    [anon_sym__Noreturn] = ACTIONS(5798),
    [anon_sym_noreturn] = ACTIONS(5798),
    [anon_sym__Nonnull] = ACTIONS(5798),
    [anon_sym_mutable] = ACTIONS(5798),
    [anon_sym_constinit] = ACTIONS(5798),
    [anon_sym_consteval] = ACTIONS(5798),
    [anon_sym_alignas] = ACTIONS(5798),
    [anon_sym__Alignas] = ACTIONS(5798),
    [sym_primitive_type] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5800),
    [anon_sym_LT_EQ_GT] = ACTIONS(5800),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_bitor] = ACTIONS(5798),
    [anon_sym_xor] = ACTIONS(5798),
    [anon_sym_bitand] = ACTIONS(5798),
    [anon_sym_not_eq] = ACTIONS(5798),
    [anon_sym_DASH_DASH] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(5800),
    [anon_sym_DOT] = ACTIONS(5798),
    [anon_sym_DOT_STAR] = ACTIONS(5800),
    [anon_sym_DASH_GT] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5798),
    [anon_sym_decltype] = ACTIONS(5798),
    [anon_sym_final] = ACTIONS(5798),
    [anon_sym_override] = ACTIONS(5798),
    [anon_sym_requires] = ACTIONS(5798),
  },
  [1885] = {
    [sym_identifier] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5804),
    [anon_sym_COMMA] = ACTIONS(5804),
    [anon_sym_RPAREN] = ACTIONS(5804),
    [anon_sym_LPAREN2] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5802),
    [anon_sym_STAR] = ACTIONS(5804),
    [anon_sym_SLASH] = ACTIONS(5802),
    [anon_sym_PERCENT] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_CARET] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5802),
    [anon_sym_EQ_EQ] = ACTIONS(5804),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5802),
    [anon_sym_LT_LT] = ACTIONS(5804),
    [anon_sym_GT_GT] = ACTIONS(5804),
    [anon_sym_SEMI] = ACTIONS(5804),
    [anon_sym___extension__] = ACTIONS(5802),
    [anon_sym___attribute__] = ACTIONS(5802),
    [anon_sym___attribute] = ACTIONS(5802),
    [anon_sym_COLON] = ACTIONS(5804),
    [anon_sym___based] = ACTIONS(5802),
    [anon_sym_LBRACE] = ACTIONS(5804),
    [anon_sym_RBRACE] = ACTIONS(5804),
    [anon_sym_signed] = ACTIONS(5802),
    [anon_sym_unsigned] = ACTIONS(5802),
    [anon_sym_long] = ACTIONS(5802),
    [anon_sym_short] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_RBRACK] = ACTIONS(5804),
    [anon_sym_const] = ACTIONS(5802),
    [anon_sym_constexpr] = ACTIONS(5802),
    [anon_sym_volatile] = ACTIONS(5802),
    [anon_sym_restrict] = ACTIONS(5802),
    [anon_sym___restrict__] = ACTIONS(5802),
    [anon_sym__Atomic] = ACTIONS(5802),
    [anon_sym__Noreturn] = ACTIONS(5802),
    [anon_sym_noreturn] = ACTIONS(5802),
    [anon_sym__Nonnull] = ACTIONS(5802),
    [anon_sym_mutable] = ACTIONS(5802),
    [anon_sym_constinit] = ACTIONS(5802),
    [anon_sym_consteval] = ACTIONS(5802),
    [anon_sym_alignas] = ACTIONS(5802),
    [anon_sym__Alignas] = ACTIONS(5802),
    [sym_primitive_type] = ACTIONS(5802),
    [anon_sym_QMARK] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_or] = ACTIONS(5802),
    [anon_sym_and] = ACTIONS(5802),
    [anon_sym_bitor] = ACTIONS(5802),
    [anon_sym_xor] = ACTIONS(5802),
    [anon_sym_bitand] = ACTIONS(5802),
    [anon_sym_not_eq] = ACTIONS(5802),
    [anon_sym_DASH_DASH] = ACTIONS(5804),
    [anon_sym_PLUS_PLUS] = ACTIONS(5804),
    [anon_sym_DOT] = ACTIONS(5802),
    [anon_sym_DOT_STAR] = ACTIONS(5804),
    [anon_sym_DASH_GT] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5802),
    [anon_sym_decltype] = ACTIONS(5802),
    [anon_sym_final] = ACTIONS(5802),
    [anon_sym_override] = ACTIONS(5802),
    [anon_sym_requires] = ACTIONS(5802),
  },
  [1886] = {
    [sym_identifier] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5808),
    [anon_sym_RPAREN] = ACTIONS(5808),
    [anon_sym_LPAREN2] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_SLASH] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_AMP_AMP] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5806),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_EQ] = ACTIONS(5808),
    [anon_sym_BANG_EQ] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5806),
    [anon_sym_LT_LT] = ACTIONS(5808),
    [anon_sym_GT_GT] = ACTIONS(5808),
    [anon_sym_SEMI] = ACTIONS(5808),
    [anon_sym___extension__] = ACTIONS(5806),
    [anon_sym___attribute__] = ACTIONS(5806),
    [anon_sym___attribute] = ACTIONS(5806),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym___based] = ACTIONS(5806),
    [anon_sym_LBRACE] = ACTIONS(5808),
    [anon_sym_RBRACE] = ACTIONS(5808),
    [anon_sym_signed] = ACTIONS(5806),
    [anon_sym_unsigned] = ACTIONS(5806),
    [anon_sym_long] = ACTIONS(5806),
    [anon_sym_short] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_RBRACK] = ACTIONS(5808),
    [anon_sym_const] = ACTIONS(5806),
    [anon_sym_constexpr] = ACTIONS(5806),
    [anon_sym_volatile] = ACTIONS(5806),
    [anon_sym_restrict] = ACTIONS(5806),
    [anon_sym___restrict__] = ACTIONS(5806),
    [anon_sym__Atomic] = ACTIONS(5806),
    [anon_sym__Noreturn] = ACTIONS(5806),
    [anon_sym_noreturn] = ACTIONS(5806),
    [anon_sym__Nonnull] = ACTIONS(5806),
    [anon_sym_mutable] = ACTIONS(5806),
    [anon_sym_constinit] = ACTIONS(5806),
    [anon_sym_consteval] = ACTIONS(5806),
    [anon_sym_alignas] = ACTIONS(5806),
    [anon_sym__Alignas] = ACTIONS(5806),
    [sym_primitive_type] = ACTIONS(5806),
    [anon_sym_QMARK] = ACTIONS(5808),
    [anon_sym_LT_EQ_GT] = ACTIONS(5808),
    [anon_sym_or] = ACTIONS(5806),
    [anon_sym_and] = ACTIONS(5806),
    [anon_sym_bitor] = ACTIONS(5806),
    [anon_sym_xor] = ACTIONS(5806),
    [anon_sym_bitand] = ACTIONS(5806),
    [anon_sym_not_eq] = ACTIONS(5806),
    [anon_sym_DASH_DASH] = ACTIONS(5808),
    [anon_sym_PLUS_PLUS] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5806),
    [anon_sym_DOT_STAR] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5806),
    [anon_sym_decltype] = ACTIONS(5806),
    [anon_sym_final] = ACTIONS(5806),
    [anon_sym_override] = ACTIONS(5806),
    [anon_sym_requires] = ACTIONS(5806),
  },
  [1887] = {
    [sym_identifier] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5812),
    [anon_sym_RPAREN] = ACTIONS(5812),
    [anon_sym_LPAREN2] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5812),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_EQ_EQ] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5812),
    [anon_sym_GT] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5810),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_GT_GT] = ACTIONS(5812),
    [anon_sym_SEMI] = ACTIONS(5812),
    [anon_sym___extension__] = ACTIONS(5810),
    [anon_sym___attribute__] = ACTIONS(5810),
    [anon_sym___attribute] = ACTIONS(5810),
    [anon_sym_COLON] = ACTIONS(5812),
    [anon_sym___based] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5812),
    [anon_sym_RBRACE] = ACTIONS(5812),
    [anon_sym_signed] = ACTIONS(5810),
    [anon_sym_unsigned] = ACTIONS(5810),
    [anon_sym_long] = ACTIONS(5810),
    [anon_sym_short] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_RBRACK] = ACTIONS(5812),
    [anon_sym_const] = ACTIONS(5810),
    [anon_sym_constexpr] = ACTIONS(5810),
    [anon_sym_volatile] = ACTIONS(5810),
    [anon_sym_restrict] = ACTIONS(5810),
    [anon_sym___restrict__] = ACTIONS(5810),
    [anon_sym__Atomic] = ACTIONS(5810),
    [anon_sym__Noreturn] = ACTIONS(5810),
    [anon_sym_noreturn] = ACTIONS(5810),
    [anon_sym__Nonnull] = ACTIONS(5810),
    [anon_sym_mutable] = ACTIONS(5810),
    [anon_sym_constinit] = ACTIONS(5810),
    [anon_sym_consteval] = ACTIONS(5810),
    [anon_sym_alignas] = ACTIONS(5810),
    [anon_sym__Alignas] = ACTIONS(5810),
    [sym_primitive_type] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5812),
    [anon_sym_LT_EQ_GT] = ACTIONS(5812),
    [anon_sym_or] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(5810),
    [anon_sym_bitor] = ACTIONS(5810),
    [anon_sym_xor] = ACTIONS(5810),
    [anon_sym_bitand] = ACTIONS(5810),
    [anon_sym_not_eq] = ACTIONS(5810),
    [anon_sym_DASH_DASH] = ACTIONS(5812),
    [anon_sym_PLUS_PLUS] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5810),
    [anon_sym_DOT_STAR] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5810),
    [anon_sym_decltype] = ACTIONS(5810),
    [anon_sym_final] = ACTIONS(5810),
    [anon_sym_override] = ACTIONS(5810),
    [anon_sym_requires] = ACTIONS(5810),
  },
  [1888] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5619),
    [anon_sym_COMMA] = ACTIONS(5619),
    [anon_sym_RPAREN] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_DASH] = ACTIONS(5617),
    [anon_sym_PLUS] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_SLASH] = ACTIONS(5617),
    [anon_sym_PERCENT] = ACTIONS(5619),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_CARET] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5619),
    [anon_sym_BANG_EQ] = ACTIONS(5619),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_LT_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_LT_LT] = ACTIONS(5619),
    [anon_sym_GT_GT] = ACTIONS(5619),
    [anon_sym_SEMI] = ACTIONS(5619),
    [anon_sym___extension__] = ACTIONS(5617),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_COLON] = ACTIONS(5619),
    [anon_sym___based] = ACTIONS(5617),
    [anon_sym_LBRACE] = ACTIONS(5619),
    [anon_sym_RBRACE] = ACTIONS(5619),
    [anon_sym_signed] = ACTIONS(5617),
    [anon_sym_unsigned] = ACTIONS(5617),
    [anon_sym_long] = ACTIONS(5617),
    [anon_sym_short] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5619),
    [anon_sym_RBRACK] = ACTIONS(5619),
    [anon_sym_const] = ACTIONS(5617),
    [anon_sym_constexpr] = ACTIONS(5617),
    [anon_sym_volatile] = ACTIONS(5617),
    [anon_sym_restrict] = ACTIONS(5617),
    [anon_sym___restrict__] = ACTIONS(5617),
    [anon_sym__Atomic] = ACTIONS(5617),
    [anon_sym__Noreturn] = ACTIONS(5617),
    [anon_sym_noreturn] = ACTIONS(5617),
    [anon_sym__Nonnull] = ACTIONS(5617),
    [anon_sym_mutable] = ACTIONS(5617),
    [anon_sym_constinit] = ACTIONS(5617),
    [anon_sym_consteval] = ACTIONS(5617),
    [anon_sym_alignas] = ACTIONS(5617),
    [anon_sym__Alignas] = ACTIONS(5617),
    [sym_primitive_type] = ACTIONS(5617),
    [anon_sym_QMARK] = ACTIONS(5619),
    [anon_sym_LT_EQ_GT] = ACTIONS(5619),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [anon_sym_bitor] = ACTIONS(5617),
    [anon_sym_xor] = ACTIONS(5617),
    [anon_sym_bitand] = ACTIONS(5617),
    [anon_sym_not_eq] = ACTIONS(5617),
    [anon_sym_DASH_DASH] = ACTIONS(5619),
    [anon_sym_PLUS_PLUS] = ACTIONS(5619),
    [anon_sym_DOT] = ACTIONS(5617),
    [anon_sym_DOT_STAR] = ACTIONS(5619),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_final] = ACTIONS(5617),
    [anon_sym_override] = ACTIONS(5617),
    [anon_sym_requires] = ACTIONS(5617),
  },
  [1889] = {
    [sym_type_qualifier] = STATE(1655),
    [sym_alignas_qualifier] = STATE(1695),
    [aux_sym__type_definition_type_repeat1] = STATE(1655),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1946),
    [sym_identifier] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5100),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_RPAREN] = ACTIONS(5100),
    [anon_sym_LPAREN2] = ACTIONS(5100),
    [anon_sym_DASH] = ACTIONS(5102),
    [anon_sym_PLUS] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5100),
    [anon_sym_SLASH] = ACTIONS(5102),
    [anon_sym_PERCENT] = ACTIONS(5100),
    [anon_sym_PIPE_PIPE] = ACTIONS(5100),
    [anon_sym_AMP_AMP] = ACTIONS(5100),
    [anon_sym_PIPE] = ACTIONS(5102),
    [anon_sym_CARET] = ACTIONS(5100),
    [anon_sym_AMP] = ACTIONS(5102),
    [anon_sym_EQ_EQ] = ACTIONS(5100),
    [anon_sym_BANG_EQ] = ACTIONS(5100),
    [anon_sym_GT] = ACTIONS(5102),
    [anon_sym_GT_EQ] = ACTIONS(5100),
    [anon_sym_LT_EQ] = ACTIONS(5102),
    [anon_sym_LT] = ACTIONS(5102),
    [anon_sym_LT_LT] = ACTIONS(5100),
    [anon_sym_GT_GT] = ACTIONS(5100),
    [anon_sym_SEMI] = ACTIONS(5100),
    [anon_sym___extension__] = ACTIONS(5706),
    [anon_sym___attribute__] = ACTIONS(5102),
    [anon_sym___attribute] = ACTIONS(5102),
    [anon_sym_COLON] = ACTIONS(5100),
    [anon_sym_LBRACE] = ACTIONS(5100),
    [anon_sym_RBRACE] = ACTIONS(5100),
    [anon_sym_signed] = ACTIONS(5816),
    [anon_sym_unsigned] = ACTIONS(5816),
    [anon_sym_long] = ACTIONS(5816),
    [anon_sym_short] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5100),
    [anon_sym_RBRACK] = ACTIONS(5100),
    [anon_sym_const] = ACTIONS(5706),
    [anon_sym_constexpr] = ACTIONS(5706),
    [anon_sym_volatile] = ACTIONS(5706),
    [anon_sym_restrict] = ACTIONS(5706),
    [anon_sym___restrict__] = ACTIONS(5706),
    [anon_sym__Atomic] = ACTIONS(5706),
    [anon_sym__Noreturn] = ACTIONS(5706),
    [anon_sym_noreturn] = ACTIONS(5706),
    [anon_sym__Nonnull] = ACTIONS(5706),
    [anon_sym_mutable] = ACTIONS(5706),
    [anon_sym_constinit] = ACTIONS(5706),
    [anon_sym_consteval] = ACTIONS(5706),
    [anon_sym_alignas] = ACTIONS(5710),
    [anon_sym__Alignas] = ACTIONS(5710),
    [sym_primitive_type] = ACTIONS(5818),
    [anon_sym_QMARK] = ACTIONS(5100),
    [anon_sym_LT_EQ_GT] = ACTIONS(5100),
    [anon_sym_or] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5102),
    [anon_sym_bitor] = ACTIONS(5102),
    [anon_sym_xor] = ACTIONS(5102),
    [anon_sym_bitand] = ACTIONS(5102),
    [anon_sym_not_eq] = ACTIONS(5102),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_DOT] = ACTIONS(5102),
    [anon_sym_DOT_STAR] = ACTIONS(5100),
    [anon_sym_DASH_GT] = ACTIONS(5100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5102),
    [anon_sym_decltype] = ACTIONS(5102),
  },
  [1890] = {
    [sym_catch_clause] = STATE(1890),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1890),
    [sym_identifier] = ACTIONS(2476),
    [aux_sym_preproc_def_token1] = ACTIONS(2476),
    [aux_sym_preproc_if_token1] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2476),
    [sym_preproc_directive] = ACTIONS(2476),
    [anon_sym_LPAREN2] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym___extension__] = ACTIONS(2476),
    [anon_sym_typedef] = ACTIONS(2476),
    [anon_sym_virtual] = ACTIONS(2476),
    [anon_sym_extern] = ACTIONS(2476),
    [anon_sym___attribute__] = ACTIONS(2476),
    [anon_sym___attribute] = ACTIONS(2476),
    [anon_sym_using] = ACTIONS(2476),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2478),
    [anon_sym___declspec] = ACTIONS(2476),
    [anon_sym___based] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_signed] = ACTIONS(2476),
    [anon_sym_unsigned] = ACTIONS(2476),
    [anon_sym_long] = ACTIONS(2476),
    [anon_sym_short] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_register] = ACTIONS(2476),
    [anon_sym_inline] = ACTIONS(2476),
    [anon_sym___inline] = ACTIONS(2476),
    [anon_sym___inline__] = ACTIONS(2476),
    [anon_sym___forceinline] = ACTIONS(2476),
    [anon_sym_thread_local] = ACTIONS(2476),
    [anon_sym___thread] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_constexpr] = ACTIONS(2476),
    [anon_sym_volatile] = ACTIONS(2476),
    [anon_sym_restrict] = ACTIONS(2476),
    [anon_sym___restrict__] = ACTIONS(2476),
    [anon_sym__Atomic] = ACTIONS(2476),
    [anon_sym__Noreturn] = ACTIONS(2476),
    [anon_sym_noreturn] = ACTIONS(2476),
    [anon_sym__Nonnull] = ACTIONS(2476),
    [anon_sym_mutable] = ACTIONS(2476),
    [anon_sym_constinit] = ACTIONS(2476),
    [anon_sym_consteval] = ACTIONS(2476),
    [anon_sym_alignas] = ACTIONS(2476),
    [anon_sym__Alignas] = ACTIONS(2476),
    [sym_primitive_type] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [anon_sym_class] = ACTIONS(2476),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2476),
    [anon_sym_decltype] = ACTIONS(2476),
    [anon_sym_explicit] = ACTIONS(2476),
    [anon_sym_typename] = ACTIONS(2476),
    [anon_sym_private] = ACTIONS(2476),
    [anon_sym_template] = ACTIONS(2476),
    [anon_sym_operator] = ACTIONS(2476),
    [anon_sym_friend] = ACTIONS(2476),
    [anon_sym_public] = ACTIONS(2476),
    [anon_sym_protected] = ACTIONS(2476),
    [anon_sym_static_assert] = ACTIONS(2476),
    [anon_sym_catch] = ACTIONS(5820),
  },
  [1891] = {
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_LPAREN2] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(1934),
    [anon_sym_PIPE_PIPE] = ACTIONS(1934),
    [anon_sym_AMP_AMP] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1936),
    [anon_sym___extension__] = ACTIONS(1936),
    [anon_sym_virtual] = ACTIONS(1936),
    [anon_sym_extern] = ACTIONS(1936),
    [anon_sym___attribute__] = ACTIONS(1936),
    [anon_sym___attribute] = ACTIONS(1936),
    [anon_sym_using] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1934),
    [anon_sym___declspec] = ACTIONS(1936),
    [anon_sym___based] = ACTIONS(1936),
    [anon_sym___cdecl] = ACTIONS(1936),
    [anon_sym___clrcall] = ACTIONS(1936),
    [anon_sym___stdcall] = ACTIONS(1936),
    [anon_sym___fastcall] = ACTIONS(1936),
    [anon_sym___thiscall] = ACTIONS(1936),
    [anon_sym___vectorcall] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_signed] = ACTIONS(1936),
    [anon_sym_unsigned] = ACTIONS(1936),
    [anon_sym_long] = ACTIONS(1936),
    [anon_sym_short] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_register] = ACTIONS(1936),
    [anon_sym_inline] = ACTIONS(1936),
    [anon_sym___inline] = ACTIONS(1936),
    [anon_sym___inline__] = ACTIONS(1936),
    [anon_sym___forceinline] = ACTIONS(1936),
    [anon_sym_thread_local] = ACTIONS(1936),
    [anon_sym___thread] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_constexpr] = ACTIONS(1936),
    [anon_sym_volatile] = ACTIONS(1936),
    [anon_sym_restrict] = ACTIONS(1936),
    [anon_sym___restrict__] = ACTIONS(1936),
    [anon_sym__Atomic] = ACTIONS(1936),
    [anon_sym__Noreturn] = ACTIONS(1936),
    [anon_sym_noreturn] = ACTIONS(1936),
    [anon_sym__Nonnull] = ACTIONS(1936),
    [anon_sym_mutable] = ACTIONS(1936),
    [anon_sym_constinit] = ACTIONS(1936),
    [anon_sym_consteval] = ACTIONS(1936),
    [anon_sym_alignas] = ACTIONS(1936),
    [anon_sym__Alignas] = ACTIONS(1936),
    [sym_primitive_type] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_struct] = ACTIONS(1936),
    [anon_sym_union] = ACTIONS(1936),
    [anon_sym_or] = ACTIONS(1936),
    [anon_sym_and] = ACTIONS(1936),
    [anon_sym_DASH_GT] = ACTIONS(1934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1936),
    [anon_sym_decltype] = ACTIONS(1936),
    [anon_sym_explicit] = ACTIONS(1936),
    [anon_sym_typename] = ACTIONS(1936),
    [anon_sym_template] = ACTIONS(1936),
    [anon_sym_operator] = ACTIONS(1936),
    [anon_sym_friend] = ACTIONS(1936),
    [anon_sym_noexcept] = ACTIONS(1936),
    [anon_sym_throw] = ACTIONS(1936),
    [anon_sym_concept] = ACTIONS(1936),
  },
  [1892] = {
    [sym_argument_list] = STATE(2426),
    [sym_initializer_list] = STATE(2426),
    [sym_decltype_auto] = STATE(2253),
    [sym_new_declarator] = STATE(2276),
    [sym_identifier] = ACTIONS(5823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5825),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_RPAREN] = ACTIONS(5825),
    [aux_sym_preproc_if_token2] = ACTIONS(5825),
    [aux_sym_preproc_else_token1] = ACTIONS(5825),
    [aux_sym_preproc_elif_token1] = ACTIONS(5823),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5825),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5825),
    [anon_sym_LPAREN2] = ACTIONS(5827),
    [anon_sym_DASH] = ACTIONS(5823),
    [anon_sym_PLUS] = ACTIONS(5823),
    [anon_sym_STAR] = ACTIONS(5823),
    [anon_sym_SLASH] = ACTIONS(5823),
    [anon_sym_PERCENT] = ACTIONS(5823),
    [anon_sym_PIPE_PIPE] = ACTIONS(5825),
    [anon_sym_AMP_AMP] = ACTIONS(5825),
    [anon_sym_PIPE] = ACTIONS(5823),
    [anon_sym_CARET] = ACTIONS(5823),
    [anon_sym_AMP] = ACTIONS(5823),
    [anon_sym_EQ_EQ] = ACTIONS(5825),
    [anon_sym_BANG_EQ] = ACTIONS(5825),
    [anon_sym_GT] = ACTIONS(5823),
    [anon_sym_GT_EQ] = ACTIONS(5825),
    [anon_sym_LT_EQ] = ACTIONS(5823),
    [anon_sym_LT] = ACTIONS(5823),
    [anon_sym_LT_LT] = ACTIONS(5823),
    [anon_sym_GT_GT] = ACTIONS(5823),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym___attribute__] = ACTIONS(5823),
    [anon_sym___attribute] = ACTIONS(5823),
    [anon_sym_COLON] = ACTIONS(5825),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(5825),
    [anon_sym_LBRACK] = ACTIONS(5829),
    [anon_sym_RBRACK] = ACTIONS(5825),
    [anon_sym_EQ] = ACTIONS(5823),
    [anon_sym_QMARK] = ACTIONS(5825),
    [anon_sym_STAR_EQ] = ACTIONS(5825),
    [anon_sym_SLASH_EQ] = ACTIONS(5825),
    [anon_sym_PERCENT_EQ] = ACTIONS(5825),
    [anon_sym_PLUS_EQ] = ACTIONS(5825),
    [anon_sym_DASH_EQ] = ACTIONS(5825),
    [anon_sym_LT_LT_EQ] = ACTIONS(5825),
    [anon_sym_GT_GT_EQ] = ACTIONS(5825),
    [anon_sym_AMP_EQ] = ACTIONS(5825),
    [anon_sym_CARET_EQ] = ACTIONS(5825),
    [anon_sym_PIPE_EQ] = ACTIONS(5825),
    [anon_sym_and_eq] = ACTIONS(5823),
    [anon_sym_or_eq] = ACTIONS(5823),
    [anon_sym_xor_eq] = ACTIONS(5823),
    [anon_sym_LT_EQ_GT] = ACTIONS(5825),
    [anon_sym_or] = ACTIONS(5823),
    [anon_sym_and] = ACTIONS(5823),
    [anon_sym_bitor] = ACTIONS(5823),
    [anon_sym_xor] = ACTIONS(5823),
    [anon_sym_bitand] = ACTIONS(5823),
    [anon_sym_not_eq] = ACTIONS(5823),
    [anon_sym_DASH_DASH] = ACTIONS(5825),
    [anon_sym_PLUS_PLUS] = ACTIONS(5825),
    [anon_sym_DOT] = ACTIONS(5823),
    [anon_sym_DOT_STAR] = ACTIONS(5825),
    [anon_sym_DASH_GT] = ACTIONS(5825),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5831),
    [anon_sym_decltype] = ACTIONS(5833),
  },
  [1893] = {
    [sym_identifier] = ACTIONS(5625),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5627),
    [anon_sym_COMMA] = ACTIONS(5627),
    [anon_sym_RPAREN] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5627),
    [anon_sym_TILDE] = ACTIONS(5627),
    [anon_sym_STAR] = ACTIONS(5627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5627),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_SEMI] = ACTIONS(5627),
    [anon_sym___extension__] = ACTIONS(5625),
    [anon_sym_virtual] = ACTIONS(5625),
    [anon_sym_extern] = ACTIONS(5625),
    [anon_sym___attribute__] = ACTIONS(5625),
    [anon_sym___attribute] = ACTIONS(5625),
    [anon_sym_COLON] = ACTIONS(5625),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5627),
    [anon_sym___declspec] = ACTIONS(5625),
    [anon_sym___based] = ACTIONS(5625),
    [anon_sym___cdecl] = ACTIONS(5625),
    [anon_sym___clrcall] = ACTIONS(5625),
    [anon_sym___stdcall] = ACTIONS(5625),
    [anon_sym___fastcall] = ACTIONS(5625),
    [anon_sym___thiscall] = ACTIONS(5625),
    [anon_sym___vectorcall] = ACTIONS(5625),
    [anon_sym_LBRACE] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(5625),
    [anon_sym_static] = ACTIONS(5625),
    [anon_sym_EQ] = ACTIONS(5627),
    [anon_sym_register] = ACTIONS(5625),
    [anon_sym_inline] = ACTIONS(5625),
    [anon_sym___inline] = ACTIONS(5625),
    [anon_sym___inline__] = ACTIONS(5625),
    [anon_sym___forceinline] = ACTIONS(5625),
    [anon_sym_thread_local] = ACTIONS(5625),
    [anon_sym___thread] = ACTIONS(5625),
    [anon_sym_const] = ACTIONS(5625),
    [anon_sym_constexpr] = ACTIONS(5625),
    [anon_sym_volatile] = ACTIONS(5625),
    [anon_sym_restrict] = ACTIONS(5625),
    [anon_sym___restrict__] = ACTIONS(5625),
    [anon_sym__Atomic] = ACTIONS(5625),
    [anon_sym__Noreturn] = ACTIONS(5625),
    [anon_sym_noreturn] = ACTIONS(5625),
    [anon_sym__Nonnull] = ACTIONS(5625),
    [anon_sym_mutable] = ACTIONS(5625),
    [anon_sym_constinit] = ACTIONS(5625),
    [anon_sym_consteval] = ACTIONS(5625),
    [anon_sym_alignas] = ACTIONS(5625),
    [anon_sym__Alignas] = ACTIONS(5625),
    [anon_sym_or] = ACTIONS(5625),
    [anon_sym_and] = ACTIONS(5625),
    [anon_sym_asm] = ACTIONS(5625),
    [anon_sym___asm__] = ACTIONS(5625),
    [anon_sym___asm] = ACTIONS(5625),
    [anon_sym_DASH_GT] = ACTIONS(5627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5625),
    [anon_sym_decltype] = ACTIONS(5625),
    [anon_sym_final] = ACTIONS(5625),
    [anon_sym_override] = ACTIONS(5625),
    [anon_sym_template] = ACTIONS(5625),
    [anon_sym_GT2] = ACTIONS(5627),
    [anon_sym_operator] = ACTIONS(5625),
    [anon_sym_try] = ACTIONS(5625),
    [anon_sym_noexcept] = ACTIONS(5625),
    [anon_sym_throw] = ACTIONS(5625),
    [anon_sym_requires] = ACTIONS(5625),
  },
  [1894] = {
    [sym_identifier] = ACTIONS(3951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3953),
    [anon_sym_COMMA] = ACTIONS(3953),
    [anon_sym_RPAREN] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym_SEMI] = ACTIONS(3953),
    [anon_sym___extension__] = ACTIONS(3951),
    [anon_sym_virtual] = ACTIONS(3951),
    [anon_sym_extern] = ACTIONS(3951),
    [anon_sym___attribute__] = ACTIONS(3951),
    [anon_sym___attribute] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3951),
    [anon_sym_COLON_COLON] = ACTIONS(3953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3953),
    [anon_sym___declspec] = ACTIONS(3951),
    [anon_sym___based] = ACTIONS(3951),
    [anon_sym___cdecl] = ACTIONS(3951),
    [anon_sym___clrcall] = ACTIONS(3951),
    [anon_sym___stdcall] = ACTIONS(3951),
    [anon_sym___fastcall] = ACTIONS(3951),
    [anon_sym___thiscall] = ACTIONS(3951),
    [anon_sym___vectorcall] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3951),
    [anon_sym_static] = ACTIONS(3951),
    [anon_sym_EQ] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3951),
    [anon_sym_inline] = ACTIONS(3951),
    [anon_sym___inline] = ACTIONS(3951),
    [anon_sym___inline__] = ACTIONS(3951),
    [anon_sym___forceinline] = ACTIONS(3951),
    [anon_sym_thread_local] = ACTIONS(3951),
    [anon_sym___thread] = ACTIONS(3951),
    [anon_sym_const] = ACTIONS(3951),
    [anon_sym_constexpr] = ACTIONS(3951),
    [anon_sym_volatile] = ACTIONS(3951),
    [anon_sym_restrict] = ACTIONS(3951),
    [anon_sym___restrict__] = ACTIONS(3951),
    [anon_sym__Atomic] = ACTIONS(3951),
    [anon_sym__Noreturn] = ACTIONS(3951),
    [anon_sym_noreturn] = ACTIONS(3951),
    [anon_sym__Nonnull] = ACTIONS(3951),
    [anon_sym_mutable] = ACTIONS(3951),
    [anon_sym_constinit] = ACTIONS(3951),
    [anon_sym_consteval] = ACTIONS(3951),
    [anon_sym_alignas] = ACTIONS(3951),
    [anon_sym__Alignas] = ACTIONS(3951),
    [anon_sym_asm] = ACTIONS(3951),
    [anon_sym___asm__] = ACTIONS(3951),
    [anon_sym___asm] = ACTIONS(3951),
    [anon_sym_DASH_GT] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3951),
    [anon_sym_final] = ACTIONS(3951),
    [anon_sym_override] = ACTIONS(3951),
    [anon_sym_explicit] = ACTIONS(3951),
    [anon_sym_private] = ACTIONS(3951),
    [anon_sym_template] = ACTIONS(3951),
    [anon_sym_GT2] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3951),
    [anon_sym_try] = ACTIONS(3951),
    [anon_sym_public] = ACTIONS(3951),
    [anon_sym_protected] = ACTIONS(3951),
    [anon_sym_noexcept] = ACTIONS(3951),
    [anon_sym_throw] = ACTIONS(3951),
    [anon_sym_requires] = ACTIONS(3951),
  },
  [1895] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5000),
    [anon_sym_COMMA] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5005),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(5005),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5005),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym___extension__] = ACTIONS(5003),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5000),
    [anon_sym_EQ] = ACTIONS(5005),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(5003),
    [anon_sym_volatile] = ACTIONS(5003),
    [anon_sym_restrict] = ACTIONS(5003),
    [anon_sym___restrict__] = ACTIONS(5003),
    [anon_sym__Atomic] = ACTIONS(5003),
    [anon_sym__Noreturn] = ACTIONS(5003),
    [anon_sym_noreturn] = ACTIONS(5003),
    [anon_sym__Nonnull] = ACTIONS(5003),
    [anon_sym_mutable] = ACTIONS(5003),
    [anon_sym_constinit] = ACTIONS(5003),
    [anon_sym_consteval] = ACTIONS(5003),
    [anon_sym_alignas] = ACTIONS(5003),
    [anon_sym__Alignas] = ACTIONS(5003),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_STAR_EQ] = ACTIONS(4998),
    [anon_sym_SLASH_EQ] = ACTIONS(4998),
    [anon_sym_PERCENT_EQ] = ACTIONS(4998),
    [anon_sym_PLUS_EQ] = ACTIONS(4998),
    [anon_sym_DASH_EQ] = ACTIONS(4998),
    [anon_sym_LT_LT_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT_EQ] = ACTIONS(5005),
    [anon_sym_AMP_EQ] = ACTIONS(4998),
    [anon_sym_CARET_EQ] = ACTIONS(4998),
    [anon_sym_PIPE_EQ] = ACTIONS(4998),
    [anon_sym_and_eq] = ACTIONS(4998),
    [anon_sym_or_eq] = ACTIONS(4998),
    [anon_sym_xor_eq] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(4998),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(4998),
    [anon_sym_not_eq] = ACTIONS(4998),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5003),
    [anon_sym_decltype] = ACTIONS(5003),
    [anon_sym_GT2] = ACTIONS(5000),
  },
  [1896] = {
    [sym_template_argument_list] = STATE(1916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_LPAREN2] = ACTIONS(4967),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_SLASH] = ACTIONS(4972),
    [anon_sym_PERCENT] = ACTIONS(4972),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4967),
    [anon_sym_PIPE] = ACTIONS(4972),
    [anon_sym_CARET] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4974),
    [anon_sym_EQ_EQ] = ACTIONS(4965),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_GT] = ACTIONS(4972),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(5835),
    [anon_sym_LT_LT] = ACTIONS(4972),
    [anon_sym_GT_GT] = ACTIONS(4972),
    [anon_sym___extension__] = ACTIONS(4970),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(4972),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_constexpr] = ACTIONS(4970),
    [anon_sym_volatile] = ACTIONS(4970),
    [anon_sym_restrict] = ACTIONS(4970),
    [anon_sym___restrict__] = ACTIONS(4970),
    [anon_sym__Atomic] = ACTIONS(4970),
    [anon_sym__Noreturn] = ACTIONS(4970),
    [anon_sym_noreturn] = ACTIONS(4970),
    [anon_sym__Nonnull] = ACTIONS(4970),
    [anon_sym_mutable] = ACTIONS(4970),
    [anon_sym_constinit] = ACTIONS(4970),
    [anon_sym_consteval] = ACTIONS(4970),
    [anon_sym_alignas] = ACTIONS(4970),
    [anon_sym__Alignas] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_and_eq] = ACTIONS(4965),
    [anon_sym_or_eq] = ACTIONS(4965),
    [anon_sym_xor_eq] = ACTIONS(4965),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4972),
    [anon_sym_and] = ACTIONS(4972),
    [anon_sym_bitor] = ACTIONS(4965),
    [anon_sym_xor] = ACTIONS(4972),
    [anon_sym_bitand] = ACTIONS(4965),
    [anon_sym_not_eq] = ACTIONS(4965),
    [anon_sym_DASH_DASH] = ACTIONS(4965),
    [anon_sym_PLUS_PLUS] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4972),
    [anon_sym_DOT_STAR] = ACTIONS(4965),
    [anon_sym_DASH_GT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4970),
    [anon_sym_decltype] = ACTIONS(4970),
  },
  [1897] = {
    [sym_identifier] = ACTIONS(3947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3949),
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_RPAREN] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3949),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_AMP_AMP] = ACTIONS(3949),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym___extension__] = ACTIONS(3947),
    [anon_sym_virtual] = ACTIONS(3947),
    [anon_sym_extern] = ACTIONS(3947),
    [anon_sym___attribute__] = ACTIONS(3947),
    [anon_sym___attribute] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3947),
    [anon_sym_COLON_COLON] = ACTIONS(3949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3949),
    [anon_sym___declspec] = ACTIONS(3947),
    [anon_sym___based] = ACTIONS(3947),
    [anon_sym___cdecl] = ACTIONS(3947),
    [anon_sym___clrcall] = ACTIONS(3947),
    [anon_sym___stdcall] = ACTIONS(3947),
    [anon_sym___fastcall] = ACTIONS(3947),
    [anon_sym___thiscall] = ACTIONS(3947),
    [anon_sym___vectorcall] = ACTIONS(3947),
    [anon_sym_LBRACE] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_static] = ACTIONS(3947),
    [anon_sym_EQ] = ACTIONS(3949),
    [anon_sym_register] = ACTIONS(3947),
    [anon_sym_inline] = ACTIONS(3947),
    [anon_sym___inline] = ACTIONS(3947),
    [anon_sym___inline__] = ACTIONS(3947),
    [anon_sym___forceinline] = ACTIONS(3947),
    [anon_sym_thread_local] = ACTIONS(3947),
    [anon_sym___thread] = ACTIONS(3947),
    [anon_sym_const] = ACTIONS(3947),
    [anon_sym_constexpr] = ACTIONS(3947),
    [anon_sym_volatile] = ACTIONS(3947),
    [anon_sym_restrict] = ACTIONS(3947),
    [anon_sym___restrict__] = ACTIONS(3947),
    [anon_sym__Atomic] = ACTIONS(3947),
    [anon_sym__Noreturn] = ACTIONS(3947),
    [anon_sym_noreturn] = ACTIONS(3947),
    [anon_sym__Nonnull] = ACTIONS(3947),
    [anon_sym_mutable] = ACTIONS(3947),
    [anon_sym_constinit] = ACTIONS(3947),
    [anon_sym_consteval] = ACTIONS(3947),
    [anon_sym_alignas] = ACTIONS(3947),
    [anon_sym__Alignas] = ACTIONS(3947),
    [anon_sym_asm] = ACTIONS(3947),
    [anon_sym___asm__] = ACTIONS(3947),
    [anon_sym___asm] = ACTIONS(3947),
    [anon_sym_DASH_GT] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3947),
    [anon_sym_final] = ACTIONS(3947),
    [anon_sym_override] = ACTIONS(3947),
    [anon_sym_explicit] = ACTIONS(3947),
    [anon_sym_private] = ACTIONS(3947),
    [anon_sym_template] = ACTIONS(3947),
    [anon_sym_GT2] = ACTIONS(3949),
    [anon_sym_operator] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(3947),
    [anon_sym_public] = ACTIONS(3947),
    [anon_sym_protected] = ACTIONS(3947),
    [anon_sym_noexcept] = ACTIONS(3947),
    [anon_sym_throw] = ACTIONS(3947),
    [anon_sym_requires] = ACTIONS(3947),
  },
  [1898] = {
    [sym_identifier] = ACTIONS(5641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5643),
    [anon_sym_COMMA] = ACTIONS(5643),
    [anon_sym_RPAREN] = ACTIONS(5643),
    [aux_sym_preproc_if_token2] = ACTIONS(5643),
    [aux_sym_preproc_else_token1] = ACTIONS(5643),
    [aux_sym_preproc_elif_token1] = ACTIONS(5641),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5643),
    [anon_sym_LPAREN2] = ACTIONS(5643),
    [anon_sym_DASH] = ACTIONS(5641),
    [anon_sym_PLUS] = ACTIONS(5641),
    [anon_sym_STAR] = ACTIONS(5643),
    [anon_sym_SLASH] = ACTIONS(5641),
    [anon_sym_PERCENT] = ACTIONS(5643),
    [anon_sym_PIPE_PIPE] = ACTIONS(5643),
    [anon_sym_AMP_AMP] = ACTIONS(5643),
    [anon_sym_PIPE] = ACTIONS(5641),
    [anon_sym_CARET] = ACTIONS(5643),
    [anon_sym_AMP] = ACTIONS(5641),
    [anon_sym_EQ_EQ] = ACTIONS(5643),
    [anon_sym_BANG_EQ] = ACTIONS(5643),
    [anon_sym_GT] = ACTIONS(5641),
    [anon_sym_GT_EQ] = ACTIONS(5643),
    [anon_sym_LT_EQ] = ACTIONS(5641),
    [anon_sym_LT] = ACTIONS(5641),
    [anon_sym_LT_LT] = ACTIONS(5643),
    [anon_sym_GT_GT] = ACTIONS(5643),
    [anon_sym_SEMI] = ACTIONS(5643),
    [anon_sym___extension__] = ACTIONS(5641),
    [anon_sym___attribute__] = ACTIONS(5641),
    [anon_sym___attribute] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_LBRACE] = ACTIONS(5643),
    [anon_sym_RBRACE] = ACTIONS(5643),
    [anon_sym_LBRACK] = ACTIONS(5643),
    [anon_sym_RBRACK] = ACTIONS(5643),
    [anon_sym_const] = ACTIONS(5641),
    [anon_sym_constexpr] = ACTIONS(5641),
    [anon_sym_volatile] = ACTIONS(5641),
    [anon_sym_restrict] = ACTIONS(5641),
    [anon_sym___restrict__] = ACTIONS(5641),
    [anon_sym__Atomic] = ACTIONS(5641),
    [anon_sym__Noreturn] = ACTIONS(5641),
    [anon_sym_noreturn] = ACTIONS(5641),
    [anon_sym__Nonnull] = ACTIONS(5641),
    [anon_sym_mutable] = ACTIONS(5641),
    [anon_sym_constinit] = ACTIONS(5641),
    [anon_sym_consteval] = ACTIONS(5641),
    [anon_sym_alignas] = ACTIONS(5641),
    [anon_sym__Alignas] = ACTIONS(5641),
    [anon_sym_QMARK] = ACTIONS(5643),
    [anon_sym_LT_EQ_GT] = ACTIONS(5643),
    [anon_sym_or] = ACTIONS(5641),
    [anon_sym_and] = ACTIONS(5641),
    [anon_sym_bitor] = ACTIONS(5641),
    [anon_sym_xor] = ACTIONS(5641),
    [anon_sym_bitand] = ACTIONS(5641),
    [anon_sym_not_eq] = ACTIONS(5641),
    [anon_sym_DASH_DASH] = ACTIONS(5643),
    [anon_sym_PLUS_PLUS] = ACTIONS(5643),
    [anon_sym_DOT] = ACTIONS(5641),
    [anon_sym_DOT_STAR] = ACTIONS(5643),
    [anon_sym_DASH_GT] = ACTIONS(5643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5641),
    [anon_sym_decltype] = ACTIONS(5641),
    [anon_sym_final] = ACTIONS(5641),
    [anon_sym_override] = ACTIONS(5641),
    [anon_sym_requires] = ACTIONS(5641),
  },
  [1899] = {
    [sym_template_argument_list] = STATE(1941),
    [sym_identifier] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4172),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_RPAREN] = ACTIONS(4172),
    [aux_sym_preproc_if_token2] = ACTIONS(4172),
    [aux_sym_preproc_else_token1] = ACTIONS(4172),
    [aux_sym_preproc_elif_token1] = ACTIONS(5838),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4172),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4172),
    [anon_sym_LPAREN2] = ACTIONS(4172),
    [anon_sym_DASH] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5838),
    [anon_sym_STAR] = ACTIONS(5838),
    [anon_sym_SLASH] = ACTIONS(5838),
    [anon_sym_PERCENT] = ACTIONS(5838),
    [anon_sym_PIPE_PIPE] = ACTIONS(4172),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_PIPE] = ACTIONS(5838),
    [anon_sym_CARET] = ACTIONS(5838),
    [anon_sym_AMP] = ACTIONS(5838),
    [anon_sym_EQ_EQ] = ACTIONS(4172),
    [anon_sym_BANG_EQ] = ACTIONS(4172),
    [anon_sym_GT] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(4172),
    [anon_sym_LT_EQ] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [anon_sym_LT_LT] = ACTIONS(5838),
    [anon_sym_GT_GT] = ACTIONS(5838),
    [anon_sym_SEMI] = ACTIONS(4172),
    [anon_sym___attribute__] = ACTIONS(5838),
    [anon_sym___attribute] = ACTIONS(5838),
    [anon_sym_COLON] = ACTIONS(5838),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4172),
    [anon_sym_RBRACK] = ACTIONS(4172),
    [anon_sym_EQ] = ACTIONS(5838),
    [anon_sym_QMARK] = ACTIONS(4172),
    [anon_sym_STAR_EQ] = ACTIONS(4172),
    [anon_sym_SLASH_EQ] = ACTIONS(4172),
    [anon_sym_PERCENT_EQ] = ACTIONS(4172),
    [anon_sym_PLUS_EQ] = ACTIONS(4172),
    [anon_sym_DASH_EQ] = ACTIONS(4172),
    [anon_sym_LT_LT_EQ] = ACTIONS(4172),
    [anon_sym_GT_GT_EQ] = ACTIONS(4172),
    [anon_sym_AMP_EQ] = ACTIONS(4172),
    [anon_sym_CARET_EQ] = ACTIONS(4172),
    [anon_sym_PIPE_EQ] = ACTIONS(4172),
    [anon_sym_and_eq] = ACTIONS(5838),
    [anon_sym_or_eq] = ACTIONS(5838),
    [anon_sym_xor_eq] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(4172),
    [anon_sym_or] = ACTIONS(5838),
    [anon_sym_and] = ACTIONS(5838),
    [anon_sym_bitor] = ACTIONS(5838),
    [anon_sym_xor] = ACTIONS(5838),
    [anon_sym_bitand] = ACTIONS(5838),
    [anon_sym_not_eq] = ACTIONS(5838),
    [anon_sym_DASH_DASH] = ACTIONS(4172),
    [anon_sym_PLUS_PLUS] = ACTIONS(4172),
    [anon_sym_DOT] = ACTIONS(5838),
    [anon_sym_DOT_STAR] = ACTIONS(4172),
    [anon_sym_DASH_GT] = ACTIONS(4172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5838),
    [anon_sym_decltype] = ACTIONS(5838),
    [anon_sym_final] = ACTIONS(5838),
    [anon_sym_override] = ACTIONS(5838),
  },
  [1900] = {
    [sym_argument_list] = STATE(2465),
    [sym_initializer_list] = STATE(2465),
    [sym_decltype_auto] = STATE(2253),
    [sym_new_declarator] = STATE(2217),
    [sym_identifier] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5844),
    [anon_sym_COMMA] = ACTIONS(5844),
    [anon_sym_RPAREN] = ACTIONS(5844),
    [aux_sym_preproc_if_token2] = ACTIONS(5844),
    [aux_sym_preproc_else_token1] = ACTIONS(5844),
    [aux_sym_preproc_elif_token1] = ACTIONS(5842),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5844),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5844),
    [anon_sym_LPAREN2] = ACTIONS(5827),
    [anon_sym_DASH] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5842),
    [anon_sym_STAR] = ACTIONS(5842),
    [anon_sym_SLASH] = ACTIONS(5842),
    [anon_sym_PERCENT] = ACTIONS(5842),
    [anon_sym_PIPE_PIPE] = ACTIONS(5844),
    [anon_sym_AMP_AMP] = ACTIONS(5844),
    [anon_sym_PIPE] = ACTIONS(5842),
    [anon_sym_CARET] = ACTIONS(5842),
    [anon_sym_AMP] = ACTIONS(5842),
    [anon_sym_EQ_EQ] = ACTIONS(5844),
    [anon_sym_BANG_EQ] = ACTIONS(5844),
    [anon_sym_GT] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5842),
    [anon_sym_LT_LT] = ACTIONS(5842),
    [anon_sym_GT_GT] = ACTIONS(5842),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym___attribute__] = ACTIONS(5842),
    [anon_sym___attribute] = ACTIONS(5842),
    [anon_sym_COLON] = ACTIONS(5844),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(5844),
    [anon_sym_LBRACK] = ACTIONS(5829),
    [anon_sym_RBRACK] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(5844),
    [anon_sym_STAR_EQ] = ACTIONS(5844),
    [anon_sym_SLASH_EQ] = ACTIONS(5844),
    [anon_sym_PERCENT_EQ] = ACTIONS(5844),
    [anon_sym_PLUS_EQ] = ACTIONS(5844),
    [anon_sym_DASH_EQ] = ACTIONS(5844),
    [anon_sym_LT_LT_EQ] = ACTIONS(5844),
    [anon_sym_GT_GT_EQ] = ACTIONS(5844),
    [anon_sym_AMP_EQ] = ACTIONS(5844),
    [anon_sym_CARET_EQ] = ACTIONS(5844),
    [anon_sym_PIPE_EQ] = ACTIONS(5844),
    [anon_sym_and_eq] = ACTIONS(5842),
    [anon_sym_or_eq] = ACTIONS(5842),
    [anon_sym_xor_eq] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5844),
    [anon_sym_or] = ACTIONS(5842),
    [anon_sym_and] = ACTIONS(5842),
    [anon_sym_bitor] = ACTIONS(5842),
    [anon_sym_xor] = ACTIONS(5842),
    [anon_sym_bitand] = ACTIONS(5842),
    [anon_sym_not_eq] = ACTIONS(5842),
    [anon_sym_DASH_DASH] = ACTIONS(5844),
    [anon_sym_PLUS_PLUS] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5842),
    [anon_sym_DOT_STAR] = ACTIONS(5844),
    [anon_sym_DASH_GT] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5831),
    [anon_sym_decltype] = ACTIONS(5833),
  },
  [1901] = {
    [sym_template_argument_list] = STATE(1941),
    [sym_identifier] = ACTIONS(4963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [aux_sym_preproc_if_token2] = ACTIONS(4970),
    [aux_sym_preproc_else_token1] = ACTIONS(4970),
    [aux_sym_preproc_elif_token1] = ACTIONS(4963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4970),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4970),
    [anon_sym_LPAREN2] = ACTIONS(4970),
    [anon_sym_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4963),
    [anon_sym_SLASH] = ACTIONS(4963),
    [anon_sym_PERCENT] = ACTIONS(4963),
    [anon_sym_PIPE_PIPE] = ACTIONS(4970),
    [anon_sym_AMP_AMP] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4963),
    [anon_sym_CARET] = ACTIONS(4963),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_EQ_EQ] = ACTIONS(4970),
    [anon_sym_BANG_EQ] = ACTIONS(4970),
    [anon_sym_GT] = ACTIONS(4963),
    [anon_sym_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_EQ] = ACTIONS(4963),
    [anon_sym_LT] = ACTIONS(5846),
    [anon_sym_LT_LT] = ACTIONS(4963),
    [anon_sym_GT_GT] = ACTIONS(4963),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_COLON] = ACTIONS(4963),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_RBRACK] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(4963),
    [anon_sym_QMARK] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_and_eq] = ACTIONS(4963),
    [anon_sym_or_eq] = ACTIONS(4963),
    [anon_sym_xor_eq] = ACTIONS(4963),
    [anon_sym_LT_EQ_GT] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4963),
    [anon_sym_and] = ACTIONS(4963),
    [anon_sym_bitor] = ACTIONS(4963),
    [anon_sym_xor] = ACTIONS(4963),
    [anon_sym_bitand] = ACTIONS(4963),
    [anon_sym_not_eq] = ACTIONS(4963),
    [anon_sym_DASH_DASH] = ACTIONS(4970),
    [anon_sym_PLUS_PLUS] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_DOT_STAR] = ACTIONS(4970),
    [anon_sym_DASH_GT] = ACTIONS(4970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_final] = ACTIONS(4963),
    [anon_sym_override] = ACTIONS(4963),
  },
  [1902] = {
    [sym_identifier] = ACTIONS(5450),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [aux_sym_preproc_if_token2] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5450),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5452),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym___extension__] = ACTIONS(5450),
    [anon_sym___attribute__] = ACTIONS(5450),
    [anon_sym___attribute] = ACTIONS(5450),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_const] = ACTIONS(5450),
    [anon_sym_constexpr] = ACTIONS(5450),
    [anon_sym_volatile] = ACTIONS(5450),
    [anon_sym_restrict] = ACTIONS(5450),
    [anon_sym___restrict__] = ACTIONS(5450),
    [anon_sym__Atomic] = ACTIONS(5450),
    [anon_sym__Noreturn] = ACTIONS(5450),
    [anon_sym_noreturn] = ACTIONS(5450),
    [anon_sym__Nonnull] = ACTIONS(5450),
    [anon_sym_mutable] = ACTIONS(5450),
    [anon_sym_constinit] = ACTIONS(5450),
    [anon_sym_consteval] = ACTIONS(5450),
    [anon_sym_alignas] = ACTIONS(5450),
    [anon_sym__Alignas] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_and] = ACTIONS(5450),
    [anon_sym_bitor] = ACTIONS(5450),
    [anon_sym_xor] = ACTIONS(5450),
    [anon_sym_bitand] = ACTIONS(5450),
    [anon_sym_not_eq] = ACTIONS(5450),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5450),
    [anon_sym_decltype] = ACTIONS(5450),
    [anon_sym_final] = ACTIONS(5450),
    [anon_sym_override] = ACTIONS(5450),
    [anon_sym_requires] = ACTIONS(5450),
  },
  [1903] = {
    [sym_ms_based_modifier] = STATE(8106),
    [sym_ms_unaligned_ptr_modifier] = STATE(4043),
    [sym_ms_pointer_modifier] = STATE(1904),
    [sym__declarator] = STATE(6313),
    [sym__abstract_declarator] = STATE(6537),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_function_declarator] = STATE(5998),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_array_declarator] = STATE(5998),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_type_qualifier] = STATE(2564),
    [sym_alignas_qualifier] = STATE(4289),
    [sym_parameter_list] = STATE(3087),
    [sym_decltype] = STATE(8601),
    [sym_reference_declarator] = STATE(5998),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5860),
    [sym_qualified_identifier] = STATE(5998),
    [sym_operator_name] = STATE(5998),
    [aux_sym__type_definition_type_repeat1] = STATE(2564),
    [aux_sym_pointer_declarator_repeat1] = STATE(1904),
    [sym_identifier] = ACTIONS(5849),
    [anon_sym_COMMA] = ACTIONS(5851),
    [anon_sym_RPAREN] = ACTIONS(5851),
    [anon_sym_LPAREN2] = ACTIONS(4298),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(5853),
    [anon_sym_AMP_AMP] = ACTIONS(5855),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym___extension__] = ACTIONS(3331),
    [anon_sym___attribute__] = ACTIONS(5859),
    [anon_sym___attribute] = ACTIONS(5859),
    [anon_sym_COLON_COLON] = ACTIONS(5861),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(3327),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3327),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3327),
    [anon_sym__unaligned] = ACTIONS(3329),
    [anon_sym___unaligned] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(5863),
    [anon_sym_EQ] = ACTIONS(5851),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_constexpr] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_restrict] = ACTIONS(3331),
    [anon_sym___restrict__] = ACTIONS(3331),
    [anon_sym__Atomic] = ACTIONS(3331),
    [anon_sym__Noreturn] = ACTIONS(3331),
    [anon_sym_noreturn] = ACTIONS(3331),
    [anon_sym__Nonnull] = ACTIONS(3331),
    [anon_sym_mutable] = ACTIONS(3331),
    [anon_sym_constinit] = ACTIONS(3331),
    [anon_sym_consteval] = ACTIONS(3331),
    [anon_sym_alignas] = ACTIONS(3333),
    [anon_sym__Alignas] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(5851),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [1904] = {
    [sym_ms_based_modifier] = STATE(8106),
    [sym_ms_unaligned_ptr_modifier] = STATE(4043),
    [sym_ms_pointer_modifier] = STATE(3820),
    [sym__declarator] = STATE(6349),
    [sym__abstract_declarator] = STATE(6538),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_function_declarator] = STATE(5998),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_array_declarator] = STATE(5998),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_type_qualifier] = STATE(2565),
    [sym_alignas_qualifier] = STATE(4289),
    [sym_parameter_list] = STATE(3087),
    [sym_decltype] = STATE(8601),
    [sym_reference_declarator] = STATE(5998),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5860),
    [sym_qualified_identifier] = STATE(5998),
    [sym_operator_name] = STATE(5998),
    [aux_sym__type_definition_type_repeat1] = STATE(2565),
    [aux_sym_pointer_declarator_repeat1] = STATE(3820),
    [sym_identifier] = ACTIONS(5849),
    [anon_sym_COMMA] = ACTIONS(5865),
    [anon_sym_RPAREN] = ACTIONS(5865),
    [anon_sym_LPAREN2] = ACTIONS(4298),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(5853),
    [anon_sym_AMP_AMP] = ACTIONS(5855),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym___extension__] = ACTIONS(3331),
    [anon_sym___attribute__] = ACTIONS(5867),
    [anon_sym___attribute] = ACTIONS(5867),
    [anon_sym_COLON_COLON] = ACTIONS(5861),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(3327),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3327),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3327),
    [anon_sym__unaligned] = ACTIONS(3329),
    [anon_sym___unaligned] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(5863),
    [anon_sym_EQ] = ACTIONS(5865),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_constexpr] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_restrict] = ACTIONS(3331),
    [anon_sym___restrict__] = ACTIONS(3331),
    [anon_sym__Atomic] = ACTIONS(3331),
    [anon_sym__Noreturn] = ACTIONS(3331),
    [anon_sym_noreturn] = ACTIONS(3331),
    [anon_sym__Nonnull] = ACTIONS(3331),
    [anon_sym_mutable] = ACTIONS(3331),
    [anon_sym_constinit] = ACTIONS(3331),
    [anon_sym_consteval] = ACTIONS(3331),
    [anon_sym_alignas] = ACTIONS(3333),
    [anon_sym__Alignas] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(5865),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [1905] = {
    [sym_argument_list] = STATE(2456),
    [sym_initializer_list] = STATE(2456),
    [sym_decltype_auto] = STATE(2253),
    [sym_new_declarator] = STATE(2222),
    [sym_identifier] = ACTIONS(5869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5871),
    [anon_sym_COMMA] = ACTIONS(5871),
    [anon_sym_RPAREN] = ACTIONS(5871),
    [aux_sym_preproc_if_token2] = ACTIONS(5871),
    [aux_sym_preproc_else_token1] = ACTIONS(5871),
    [aux_sym_preproc_elif_token1] = ACTIONS(5869),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5871),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5871),
    [anon_sym_LPAREN2] = ACTIONS(5827),
    [anon_sym_DASH] = ACTIONS(5869),
    [anon_sym_PLUS] = ACTIONS(5869),
    [anon_sym_STAR] = ACTIONS(5869),
    [anon_sym_SLASH] = ACTIONS(5869),
    [anon_sym_PERCENT] = ACTIONS(5869),
    [anon_sym_PIPE_PIPE] = ACTIONS(5871),
    [anon_sym_AMP_AMP] = ACTIONS(5871),
    [anon_sym_PIPE] = ACTIONS(5869),
    [anon_sym_CARET] = ACTIONS(5869),
    [anon_sym_AMP] = ACTIONS(5869),
    [anon_sym_EQ_EQ] = ACTIONS(5871),
    [anon_sym_BANG_EQ] = ACTIONS(5871),
    [anon_sym_GT] = ACTIONS(5869),
    [anon_sym_GT_EQ] = ACTIONS(5871),
    [anon_sym_LT_EQ] = ACTIONS(5869),
    [anon_sym_LT] = ACTIONS(5869),
    [anon_sym_LT_LT] = ACTIONS(5869),
    [anon_sym_GT_GT] = ACTIONS(5869),
    [anon_sym_SEMI] = ACTIONS(5871),
    [anon_sym___attribute__] = ACTIONS(5869),
    [anon_sym___attribute] = ACTIONS(5869),
    [anon_sym_COLON] = ACTIONS(5871),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(5871),
    [anon_sym_LBRACK] = ACTIONS(5829),
    [anon_sym_RBRACK] = ACTIONS(5871),
    [anon_sym_EQ] = ACTIONS(5869),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_STAR_EQ] = ACTIONS(5871),
    [anon_sym_SLASH_EQ] = ACTIONS(5871),
    [anon_sym_PERCENT_EQ] = ACTIONS(5871),
    [anon_sym_PLUS_EQ] = ACTIONS(5871),
    [anon_sym_DASH_EQ] = ACTIONS(5871),
    [anon_sym_LT_LT_EQ] = ACTIONS(5871),
    [anon_sym_GT_GT_EQ] = ACTIONS(5871),
    [anon_sym_AMP_EQ] = ACTIONS(5871),
    [anon_sym_CARET_EQ] = ACTIONS(5871),
    [anon_sym_PIPE_EQ] = ACTIONS(5871),
    [anon_sym_and_eq] = ACTIONS(5869),
    [anon_sym_or_eq] = ACTIONS(5869),
    [anon_sym_xor_eq] = ACTIONS(5869),
    [anon_sym_LT_EQ_GT] = ACTIONS(5871),
    [anon_sym_or] = ACTIONS(5869),
    [anon_sym_and] = ACTIONS(5869),
    [anon_sym_bitor] = ACTIONS(5869),
    [anon_sym_xor] = ACTIONS(5869),
    [anon_sym_bitand] = ACTIONS(5869),
    [anon_sym_not_eq] = ACTIONS(5869),
    [anon_sym_DASH_DASH] = ACTIONS(5871),
    [anon_sym_PLUS_PLUS] = ACTIONS(5871),
    [anon_sym_DOT] = ACTIONS(5869),
    [anon_sym_DOT_STAR] = ACTIONS(5871),
    [anon_sym_DASH_GT] = ACTIONS(5871),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5831),
    [anon_sym_decltype] = ACTIONS(5833),
  },
  [1906] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5619),
    [anon_sym_COMMA] = ACTIONS(5619),
    [anon_sym_RPAREN] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_TILDE] = ACTIONS(5619),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym_SEMI] = ACTIONS(5619),
    [anon_sym___extension__] = ACTIONS(5617),
    [anon_sym_virtual] = ACTIONS(5617),
    [anon_sym_extern] = ACTIONS(5617),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_COLON] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5619),
    [anon_sym___declspec] = ACTIONS(5617),
    [anon_sym___based] = ACTIONS(5617),
    [anon_sym___cdecl] = ACTIONS(5617),
    [anon_sym___clrcall] = ACTIONS(5617),
    [anon_sym___stdcall] = ACTIONS(5617),
    [anon_sym___fastcall] = ACTIONS(5617),
    [anon_sym___thiscall] = ACTIONS(5617),
    [anon_sym___vectorcall] = ACTIONS(5617),
    [anon_sym_LBRACE] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5617),
    [anon_sym_static] = ACTIONS(5617),
    [anon_sym_EQ] = ACTIONS(5619),
    [anon_sym_register] = ACTIONS(5617),
    [anon_sym_inline] = ACTIONS(5617),
    [anon_sym___inline] = ACTIONS(5617),
    [anon_sym___inline__] = ACTIONS(5617),
    [anon_sym___forceinline] = ACTIONS(5617),
    [anon_sym_thread_local] = ACTIONS(5617),
    [anon_sym___thread] = ACTIONS(5617),
    [anon_sym_const] = ACTIONS(5617),
    [anon_sym_constexpr] = ACTIONS(5617),
    [anon_sym_volatile] = ACTIONS(5617),
    [anon_sym_restrict] = ACTIONS(5617),
    [anon_sym___restrict__] = ACTIONS(5617),
    [anon_sym__Atomic] = ACTIONS(5617),
    [anon_sym__Noreturn] = ACTIONS(5617),
    [anon_sym_noreturn] = ACTIONS(5617),
    [anon_sym__Nonnull] = ACTIONS(5617),
    [anon_sym_mutable] = ACTIONS(5617),
    [anon_sym_constinit] = ACTIONS(5617),
    [anon_sym_consteval] = ACTIONS(5617),
    [anon_sym_alignas] = ACTIONS(5617),
    [anon_sym__Alignas] = ACTIONS(5617),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [anon_sym_asm] = ACTIONS(5617),
    [anon_sym___asm__] = ACTIONS(5617),
    [anon_sym___asm] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_final] = ACTIONS(5617),
    [anon_sym_override] = ACTIONS(5617),
    [anon_sym_template] = ACTIONS(5617),
    [anon_sym_GT2] = ACTIONS(5619),
    [anon_sym_operator] = ACTIONS(5617),
    [anon_sym_try] = ACTIONS(5617),
    [anon_sym_noexcept] = ACTIONS(5617),
    [anon_sym_throw] = ACTIONS(5617),
    [anon_sym_requires] = ACTIONS(5617),
  },
  [1907] = {
    [sym_identifier] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_PIPE_PIPE] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym___cdecl] = ACTIONS(1940),
    [anon_sym___clrcall] = ACTIONS(1940),
    [anon_sym___stdcall] = ACTIONS(1940),
    [anon_sym___fastcall] = ACTIONS(1940),
    [anon_sym___thiscall] = ACTIONS(1940),
    [anon_sym___vectorcall] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1940),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_DASH_GT] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_friend] = ACTIONS(1940),
    [anon_sym_noexcept] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_concept] = ACTIONS(1940),
  },
  [1908] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5619),
    [anon_sym_COMMA] = ACTIONS(5619),
    [anon_sym_RPAREN] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_TILDE] = ACTIONS(5619),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym_SEMI] = ACTIONS(5619),
    [anon_sym___extension__] = ACTIONS(5617),
    [anon_sym_virtual] = ACTIONS(5617),
    [anon_sym_extern] = ACTIONS(5617),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_COLON] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5619),
    [anon_sym___declspec] = ACTIONS(5617),
    [anon_sym___based] = ACTIONS(5617),
    [anon_sym___cdecl] = ACTIONS(5617),
    [anon_sym___clrcall] = ACTIONS(5617),
    [anon_sym___stdcall] = ACTIONS(5617),
    [anon_sym___fastcall] = ACTIONS(5617),
    [anon_sym___thiscall] = ACTIONS(5617),
    [anon_sym___vectorcall] = ACTIONS(5617),
    [anon_sym_LBRACE] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5617),
    [anon_sym_static] = ACTIONS(5617),
    [anon_sym_EQ] = ACTIONS(5619),
    [anon_sym_register] = ACTIONS(5617),
    [anon_sym_inline] = ACTIONS(5617),
    [anon_sym___inline] = ACTIONS(5617),
    [anon_sym___inline__] = ACTIONS(5617),
    [anon_sym___forceinline] = ACTIONS(5617),
    [anon_sym_thread_local] = ACTIONS(5617),
    [anon_sym___thread] = ACTIONS(5617),
    [anon_sym_const] = ACTIONS(5617),
    [anon_sym_constexpr] = ACTIONS(5617),
    [anon_sym_volatile] = ACTIONS(5617),
    [anon_sym_restrict] = ACTIONS(5617),
    [anon_sym___restrict__] = ACTIONS(5617),
    [anon_sym__Atomic] = ACTIONS(5617),
    [anon_sym__Noreturn] = ACTIONS(5617),
    [anon_sym_noreturn] = ACTIONS(5617),
    [anon_sym__Nonnull] = ACTIONS(5617),
    [anon_sym_mutable] = ACTIONS(5617),
    [anon_sym_constinit] = ACTIONS(5617),
    [anon_sym_consteval] = ACTIONS(5617),
    [anon_sym_alignas] = ACTIONS(5617),
    [anon_sym__Alignas] = ACTIONS(5617),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [anon_sym_asm] = ACTIONS(5617),
    [anon_sym___asm__] = ACTIONS(5617),
    [anon_sym___asm] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_final] = ACTIONS(5617),
    [anon_sym_override] = ACTIONS(5617),
    [anon_sym_template] = ACTIONS(5617),
    [anon_sym_GT2] = ACTIONS(5619),
    [anon_sym_operator] = ACTIONS(5617),
    [anon_sym_try] = ACTIONS(5617),
    [anon_sym_noexcept] = ACTIONS(5617),
    [anon_sym_throw] = ACTIONS(5617),
    [anon_sym_requires] = ACTIONS(5617),
  },
  [1909] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5619),
    [anon_sym_COMMA] = ACTIONS(5619),
    [anon_sym_RPAREN] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_TILDE] = ACTIONS(5619),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym_SEMI] = ACTIONS(5619),
    [anon_sym___extension__] = ACTIONS(5617),
    [anon_sym_virtual] = ACTIONS(5617),
    [anon_sym_extern] = ACTIONS(5617),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_COLON] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5619),
    [anon_sym___declspec] = ACTIONS(5617),
    [anon_sym___based] = ACTIONS(5617),
    [anon_sym___cdecl] = ACTIONS(5617),
    [anon_sym___clrcall] = ACTIONS(5617),
    [anon_sym___stdcall] = ACTIONS(5617),
    [anon_sym___fastcall] = ACTIONS(5617),
    [anon_sym___thiscall] = ACTIONS(5617),
    [anon_sym___vectorcall] = ACTIONS(5617),
    [anon_sym_LBRACE] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5617),
    [anon_sym_static] = ACTIONS(5617),
    [anon_sym_EQ] = ACTIONS(5619),
    [anon_sym_register] = ACTIONS(5617),
    [anon_sym_inline] = ACTIONS(5617),
    [anon_sym___inline] = ACTIONS(5617),
    [anon_sym___inline__] = ACTIONS(5617),
    [anon_sym___forceinline] = ACTIONS(5617),
    [anon_sym_thread_local] = ACTIONS(5617),
    [anon_sym___thread] = ACTIONS(5617),
    [anon_sym_const] = ACTIONS(5617),
    [anon_sym_constexpr] = ACTIONS(5617),
    [anon_sym_volatile] = ACTIONS(5617),
    [anon_sym_restrict] = ACTIONS(5617),
    [anon_sym___restrict__] = ACTIONS(5617),
    [anon_sym__Atomic] = ACTIONS(5617),
    [anon_sym__Noreturn] = ACTIONS(5617),
    [anon_sym_noreturn] = ACTIONS(5617),
    [anon_sym__Nonnull] = ACTIONS(5617),
    [anon_sym_mutable] = ACTIONS(5617),
    [anon_sym_constinit] = ACTIONS(5617),
    [anon_sym_consteval] = ACTIONS(5617),
    [anon_sym_alignas] = ACTIONS(5617),
    [anon_sym__Alignas] = ACTIONS(5617),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [anon_sym_asm] = ACTIONS(5617),
    [anon_sym___asm__] = ACTIONS(5617),
    [anon_sym___asm] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_final] = ACTIONS(5617),
    [anon_sym_override] = ACTIONS(5617),
    [anon_sym_template] = ACTIONS(5617),
    [anon_sym_GT2] = ACTIONS(5619),
    [anon_sym_operator] = ACTIONS(5617),
    [anon_sym_try] = ACTIONS(5617),
    [anon_sym_noexcept] = ACTIONS(5617),
    [anon_sym_throw] = ACTIONS(5617),
    [anon_sym_requires] = ACTIONS(5617),
  },
  [1910] = {
    [sym_identifier] = ACTIONS(5605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5607),
    [anon_sym_COMMA] = ACTIONS(5607),
    [anon_sym_RPAREN] = ACTIONS(5607),
    [anon_sym_LPAREN2] = ACTIONS(5607),
    [anon_sym_TILDE] = ACTIONS(5607),
    [anon_sym_STAR] = ACTIONS(5607),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_AMP_AMP] = ACTIONS(5607),
    [anon_sym_AMP] = ACTIONS(5605),
    [anon_sym_SEMI] = ACTIONS(5607),
    [anon_sym___extension__] = ACTIONS(5605),
    [anon_sym_virtual] = ACTIONS(5605),
    [anon_sym_extern] = ACTIONS(5605),
    [anon_sym___attribute__] = ACTIONS(5605),
    [anon_sym___attribute] = ACTIONS(5605),
    [anon_sym_COLON] = ACTIONS(5605),
    [anon_sym_COLON_COLON] = ACTIONS(5607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5607),
    [anon_sym___declspec] = ACTIONS(5605),
    [anon_sym___based] = ACTIONS(5605),
    [anon_sym___cdecl] = ACTIONS(5605),
    [anon_sym___clrcall] = ACTIONS(5605),
    [anon_sym___stdcall] = ACTIONS(5605),
    [anon_sym___fastcall] = ACTIONS(5605),
    [anon_sym___thiscall] = ACTIONS(5605),
    [anon_sym___vectorcall] = ACTIONS(5605),
    [anon_sym_LBRACE] = ACTIONS(5607),
    [anon_sym_LBRACK] = ACTIONS(5605),
    [anon_sym_static] = ACTIONS(5605),
    [anon_sym_EQ] = ACTIONS(5607),
    [anon_sym_register] = ACTIONS(5605),
    [anon_sym_inline] = ACTIONS(5605),
    [anon_sym___inline] = ACTIONS(5605),
    [anon_sym___inline__] = ACTIONS(5605),
    [anon_sym___forceinline] = ACTIONS(5605),
    [anon_sym_thread_local] = ACTIONS(5605),
    [anon_sym___thread] = ACTIONS(5605),
    [anon_sym_const] = ACTIONS(5605),
    [anon_sym_constexpr] = ACTIONS(5605),
    [anon_sym_volatile] = ACTIONS(5605),
    [anon_sym_restrict] = ACTIONS(5605),
    [anon_sym___restrict__] = ACTIONS(5605),
    [anon_sym__Atomic] = ACTIONS(5605),
    [anon_sym__Noreturn] = ACTIONS(5605),
    [anon_sym_noreturn] = ACTIONS(5605),
    [anon_sym__Nonnull] = ACTIONS(5605),
    [anon_sym_mutable] = ACTIONS(5605),
    [anon_sym_constinit] = ACTIONS(5605),
    [anon_sym_consteval] = ACTIONS(5605),
    [anon_sym_alignas] = ACTIONS(5605),
    [anon_sym__Alignas] = ACTIONS(5605),
    [anon_sym_or] = ACTIONS(5605),
    [anon_sym_and] = ACTIONS(5605),
    [anon_sym_asm] = ACTIONS(5605),
    [anon_sym___asm__] = ACTIONS(5605),
    [anon_sym___asm] = ACTIONS(5605),
    [anon_sym_DASH_GT] = ACTIONS(5607),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5605),
    [anon_sym_decltype] = ACTIONS(5605),
    [anon_sym_final] = ACTIONS(5605),
    [anon_sym_override] = ACTIONS(5605),
    [anon_sym_template] = ACTIONS(5605),
    [anon_sym_GT2] = ACTIONS(5607),
    [anon_sym_operator] = ACTIONS(5605),
    [anon_sym_try] = ACTIONS(5605),
    [anon_sym_noexcept] = ACTIONS(5605),
    [anon_sym_throw] = ACTIONS(5605),
    [anon_sym_requires] = ACTIONS(5605),
  },
  [1911] = {
    [sym_argument_list] = STATE(2442),
    [sym_initializer_list] = STATE(2442),
    [sym_decltype_auto] = STATE(2253),
    [sym_new_declarator] = STATE(2210),
    [sym_identifier] = ACTIONS(5873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5875),
    [anon_sym_RPAREN] = ACTIONS(5875),
    [aux_sym_preproc_if_token2] = ACTIONS(5875),
    [aux_sym_preproc_else_token1] = ACTIONS(5875),
    [aux_sym_preproc_elif_token1] = ACTIONS(5873),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5875),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5875),
    [anon_sym_LPAREN2] = ACTIONS(5827),
    [anon_sym_DASH] = ACTIONS(5873),
    [anon_sym_PLUS] = ACTIONS(5873),
    [anon_sym_STAR] = ACTIONS(5873),
    [anon_sym_SLASH] = ACTIONS(5873),
    [anon_sym_PERCENT] = ACTIONS(5873),
    [anon_sym_PIPE_PIPE] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5875),
    [anon_sym_PIPE] = ACTIONS(5873),
    [anon_sym_CARET] = ACTIONS(5873),
    [anon_sym_AMP] = ACTIONS(5873),
    [anon_sym_EQ_EQ] = ACTIONS(5875),
    [anon_sym_BANG_EQ] = ACTIONS(5875),
    [anon_sym_GT] = ACTIONS(5873),
    [anon_sym_GT_EQ] = ACTIONS(5875),
    [anon_sym_LT_EQ] = ACTIONS(5873),
    [anon_sym_LT] = ACTIONS(5873),
    [anon_sym_LT_LT] = ACTIONS(5873),
    [anon_sym_GT_GT] = ACTIONS(5873),
    [anon_sym_SEMI] = ACTIONS(5875),
    [anon_sym___attribute__] = ACTIONS(5873),
    [anon_sym___attribute] = ACTIONS(5873),
    [anon_sym_COLON] = ACTIONS(5875),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(5875),
    [anon_sym_LBRACK] = ACTIONS(5829),
    [anon_sym_RBRACK] = ACTIONS(5875),
    [anon_sym_EQ] = ACTIONS(5873),
    [anon_sym_QMARK] = ACTIONS(5875),
    [anon_sym_STAR_EQ] = ACTIONS(5875),
    [anon_sym_SLASH_EQ] = ACTIONS(5875),
    [anon_sym_PERCENT_EQ] = ACTIONS(5875),
    [anon_sym_PLUS_EQ] = ACTIONS(5875),
    [anon_sym_DASH_EQ] = ACTIONS(5875),
    [anon_sym_LT_LT_EQ] = ACTIONS(5875),
    [anon_sym_GT_GT_EQ] = ACTIONS(5875),
    [anon_sym_AMP_EQ] = ACTIONS(5875),
    [anon_sym_CARET_EQ] = ACTIONS(5875),
    [anon_sym_PIPE_EQ] = ACTIONS(5875),
    [anon_sym_and_eq] = ACTIONS(5873),
    [anon_sym_or_eq] = ACTIONS(5873),
    [anon_sym_xor_eq] = ACTIONS(5873),
    [anon_sym_LT_EQ_GT] = ACTIONS(5875),
    [anon_sym_or] = ACTIONS(5873),
    [anon_sym_and] = ACTIONS(5873),
    [anon_sym_bitor] = ACTIONS(5873),
    [anon_sym_xor] = ACTIONS(5873),
    [anon_sym_bitand] = ACTIONS(5873),
    [anon_sym_not_eq] = ACTIONS(5873),
    [anon_sym_DASH_DASH] = ACTIONS(5875),
    [anon_sym_PLUS_PLUS] = ACTIONS(5875),
    [anon_sym_DOT] = ACTIONS(5873),
    [anon_sym_DOT_STAR] = ACTIONS(5875),
    [anon_sym_DASH_GT] = ACTIONS(5875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5831),
    [anon_sym_decltype] = ACTIONS(5833),
  },
  [1912] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4791),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1913] = {
    [sym_identifier] = ACTIONS(1936),
    [aux_sym_preproc_def_token1] = ACTIONS(1936),
    [aux_sym_preproc_if_token1] = ACTIONS(1936),
    [aux_sym_preproc_if_token2] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1936),
    [sym_preproc_directive] = ACTIONS(1936),
    [anon_sym_LPAREN2] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(1934),
    [anon_sym_AMP_AMP] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym___extension__] = ACTIONS(1936),
    [anon_sym_typedef] = ACTIONS(1936),
    [anon_sym_virtual] = ACTIONS(1936),
    [anon_sym_extern] = ACTIONS(1936),
    [anon_sym___attribute__] = ACTIONS(1936),
    [anon_sym___attribute] = ACTIONS(1936),
    [anon_sym_using] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1934),
    [anon_sym___declspec] = ACTIONS(1936),
    [anon_sym___based] = ACTIONS(1936),
    [anon_sym_signed] = ACTIONS(1936),
    [anon_sym_unsigned] = ACTIONS(1936),
    [anon_sym_long] = ACTIONS(1936),
    [anon_sym_short] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_register] = ACTIONS(1936),
    [anon_sym_inline] = ACTIONS(1936),
    [anon_sym___inline] = ACTIONS(1936),
    [anon_sym___inline__] = ACTIONS(1936),
    [anon_sym___forceinline] = ACTIONS(1936),
    [anon_sym_thread_local] = ACTIONS(1936),
    [anon_sym___thread] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_constexpr] = ACTIONS(1936),
    [anon_sym_volatile] = ACTIONS(1936),
    [anon_sym_restrict] = ACTIONS(1936),
    [anon_sym___restrict__] = ACTIONS(1936),
    [anon_sym__Atomic] = ACTIONS(1936),
    [anon_sym__Noreturn] = ACTIONS(1936),
    [anon_sym_noreturn] = ACTIONS(1936),
    [anon_sym__Nonnull] = ACTIONS(1936),
    [anon_sym_mutable] = ACTIONS(1936),
    [anon_sym_constinit] = ACTIONS(1936),
    [anon_sym_consteval] = ACTIONS(1936),
    [anon_sym_alignas] = ACTIONS(1936),
    [anon_sym__Alignas] = ACTIONS(1936),
    [sym_primitive_type] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_struct] = ACTIONS(1936),
    [anon_sym_union] = ACTIONS(1936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1936),
    [anon_sym_decltype] = ACTIONS(1936),
    [anon_sym_explicit] = ACTIONS(1936),
    [anon_sym_typename] = ACTIONS(1936),
    [anon_sym_private] = ACTIONS(1936),
    [anon_sym_template] = ACTIONS(1936),
    [anon_sym_operator] = ACTIONS(1936),
    [anon_sym_friend] = ACTIONS(1936),
    [anon_sym_public] = ACTIONS(1936),
    [anon_sym_protected] = ACTIONS(1936),
    [anon_sym_static_assert] = ACTIONS(1936),
    [anon_sym_catch] = ACTIONS(1936),
  },
  [1914] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token2] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_friend] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
  },
  [1915] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(5234),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1916] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5000),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5007),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5005),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(5000),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5007),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5005),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym___extension__] = ACTIONS(5003),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5000),
    [anon_sym_EQ] = ACTIONS(5005),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(5003),
    [anon_sym_volatile] = ACTIONS(5003),
    [anon_sym_restrict] = ACTIONS(5003),
    [anon_sym___restrict__] = ACTIONS(5003),
    [anon_sym__Atomic] = ACTIONS(5003),
    [anon_sym__Noreturn] = ACTIONS(5003),
    [anon_sym_noreturn] = ACTIONS(5003),
    [anon_sym__Nonnull] = ACTIONS(5003),
    [anon_sym_mutable] = ACTIONS(5003),
    [anon_sym_constinit] = ACTIONS(5003),
    [anon_sym_consteval] = ACTIONS(5003),
    [anon_sym_alignas] = ACTIONS(5003),
    [anon_sym__Alignas] = ACTIONS(5003),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_STAR_EQ] = ACTIONS(4998),
    [anon_sym_SLASH_EQ] = ACTIONS(4998),
    [anon_sym_PERCENT_EQ] = ACTIONS(4998),
    [anon_sym_PLUS_EQ] = ACTIONS(4998),
    [anon_sym_DASH_EQ] = ACTIONS(4998),
    [anon_sym_LT_LT_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT_EQ] = ACTIONS(4998),
    [anon_sym_AMP_EQ] = ACTIONS(4998),
    [anon_sym_CARET_EQ] = ACTIONS(4998),
    [anon_sym_PIPE_EQ] = ACTIONS(4998),
    [anon_sym_and_eq] = ACTIONS(4998),
    [anon_sym_or_eq] = ACTIONS(4998),
    [anon_sym_xor_eq] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(4998),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(4998),
    [anon_sym_not_eq] = ACTIONS(4998),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5003),
    [anon_sym_decltype] = ACTIONS(5003),
  },
  [1917] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(5442),
    [anon_sym___attribute] = ACTIONS(5442),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_friend] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
  },
  [1918] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1918),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5072),
    [anon_sym_COMMA] = ACTIONS(5072),
    [anon_sym_RPAREN] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5072),
    [anon_sym_TILDE] = ACTIONS(5072),
    [anon_sym_STAR] = ACTIONS(5072),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_AMP] = ACTIONS(5070),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym_virtual] = ACTIONS(5070),
    [anon_sym_extern] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5070),
    [anon_sym___attribute] = ACTIONS(5070),
    [anon_sym_COLON_COLON] = ACTIONS(5072),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5072),
    [anon_sym___declspec] = ACTIONS(5070),
    [anon_sym___based] = ACTIONS(5070),
    [anon_sym___cdecl] = ACTIONS(5070),
    [anon_sym___clrcall] = ACTIONS(5070),
    [anon_sym___stdcall] = ACTIONS(5070),
    [anon_sym___fastcall] = ACTIONS(5070),
    [anon_sym___thiscall] = ACTIONS(5070),
    [anon_sym___vectorcall] = ACTIONS(5070),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_signed] = ACTIONS(5877),
    [anon_sym_unsigned] = ACTIONS(5877),
    [anon_sym_long] = ACTIONS(5877),
    [anon_sym_short] = ACTIONS(5877),
    [anon_sym_LBRACK] = ACTIONS(5070),
    [anon_sym_static] = ACTIONS(5070),
    [anon_sym_EQ] = ACTIONS(5072),
    [anon_sym_register] = ACTIONS(5070),
    [anon_sym_inline] = ACTIONS(5070),
    [anon_sym___inline] = ACTIONS(5070),
    [anon_sym___inline__] = ACTIONS(5070),
    [anon_sym___forceinline] = ACTIONS(5070),
    [anon_sym_thread_local] = ACTIONS(5070),
    [anon_sym___thread] = ACTIONS(5070),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_asm] = ACTIONS(5070),
    [anon_sym___asm__] = ACTIONS(5070),
    [anon_sym___asm] = ACTIONS(5070),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5070),
    [anon_sym_decltype] = ACTIONS(5070),
    [anon_sym_final] = ACTIONS(5070),
    [anon_sym_override] = ACTIONS(5070),
    [anon_sym_template] = ACTIONS(5070),
    [anon_sym_GT2] = ACTIONS(5072),
    [anon_sym_operator] = ACTIONS(5070),
    [anon_sym_try] = ACTIONS(5070),
    [anon_sym_requires] = ACTIONS(5070),
  },
  [1919] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token2] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_friend] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_catch] = ACTIONS(1940),
  },
  [1920] = {
    [sym_identifier] = ACTIONS(2619),
    [aux_sym_preproc_def_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token2] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2619),
    [sym_preproc_directive] = ACTIONS(2619),
    [anon_sym_LPAREN2] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(2621),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(2619),
    [anon_sym_typedef] = ACTIONS(2619),
    [anon_sym_virtual] = ACTIONS(2619),
    [anon_sym_extern] = ACTIONS(2619),
    [anon_sym___attribute__] = ACTIONS(2619),
    [anon_sym___attribute] = ACTIONS(2619),
    [anon_sym_using] = ACTIONS(2619),
    [anon_sym_COLON_COLON] = ACTIONS(2621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2621),
    [anon_sym___declspec] = ACTIONS(2619),
    [anon_sym___based] = ACTIONS(2619),
    [anon_sym_signed] = ACTIONS(2619),
    [anon_sym_unsigned] = ACTIONS(2619),
    [anon_sym_long] = ACTIONS(2619),
    [anon_sym_short] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_register] = ACTIONS(2619),
    [anon_sym_inline] = ACTIONS(2619),
    [anon_sym___inline] = ACTIONS(2619),
    [anon_sym___inline__] = ACTIONS(2619),
    [anon_sym___forceinline] = ACTIONS(2619),
    [anon_sym_thread_local] = ACTIONS(2619),
    [anon_sym___thread] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_constexpr] = ACTIONS(2619),
    [anon_sym_volatile] = ACTIONS(2619),
    [anon_sym_restrict] = ACTIONS(2619),
    [anon_sym___restrict__] = ACTIONS(2619),
    [anon_sym__Atomic] = ACTIONS(2619),
    [anon_sym__Noreturn] = ACTIONS(2619),
    [anon_sym_noreturn] = ACTIONS(2619),
    [anon_sym__Nonnull] = ACTIONS(2619),
    [anon_sym_mutable] = ACTIONS(2619),
    [anon_sym_constinit] = ACTIONS(2619),
    [anon_sym_consteval] = ACTIONS(2619),
    [anon_sym_alignas] = ACTIONS(2619),
    [anon_sym__Alignas] = ACTIONS(2619),
    [sym_primitive_type] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_struct] = ACTIONS(2619),
    [anon_sym_union] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2619),
    [anon_sym_decltype] = ACTIONS(2619),
    [anon_sym_explicit] = ACTIONS(2619),
    [anon_sym_typename] = ACTIONS(2619),
    [anon_sym_private] = ACTIONS(2619),
    [anon_sym_template] = ACTIONS(2619),
    [anon_sym_operator] = ACTIONS(2619),
    [anon_sym_friend] = ACTIONS(2619),
    [anon_sym_public] = ACTIONS(2619),
    [anon_sym_protected] = ACTIONS(2619),
    [anon_sym_static_assert] = ACTIONS(2619),
    [anon_sym_catch] = ACTIONS(2619),
  },
  [1921] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5619),
    [anon_sym_COMMA] = ACTIONS(5619),
    [anon_sym_RPAREN] = ACTIONS(5619),
    [aux_sym_preproc_if_token2] = ACTIONS(5619),
    [aux_sym_preproc_else_token1] = ACTIONS(5619),
    [aux_sym_preproc_elif_token1] = ACTIONS(5617),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5619),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_DASH] = ACTIONS(5617),
    [anon_sym_PLUS] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5617),
    [anon_sym_SLASH] = ACTIONS(5617),
    [anon_sym_PERCENT] = ACTIONS(5617),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_CARET] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5619),
    [anon_sym_BANG_EQ] = ACTIONS(5619),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_LT_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5617),
    [anon_sym_SEMI] = ACTIONS(5619),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_COLON] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5619),
    [anon_sym_RBRACE] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5619),
    [anon_sym_RBRACK] = ACTIONS(5619),
    [anon_sym_EQ] = ACTIONS(5617),
    [anon_sym_QMARK] = ACTIONS(5619),
    [anon_sym_STAR_EQ] = ACTIONS(5619),
    [anon_sym_SLASH_EQ] = ACTIONS(5619),
    [anon_sym_PERCENT_EQ] = ACTIONS(5619),
    [anon_sym_PLUS_EQ] = ACTIONS(5619),
    [anon_sym_DASH_EQ] = ACTIONS(5619),
    [anon_sym_LT_LT_EQ] = ACTIONS(5619),
    [anon_sym_GT_GT_EQ] = ACTIONS(5619),
    [anon_sym_AMP_EQ] = ACTIONS(5619),
    [anon_sym_CARET_EQ] = ACTIONS(5619),
    [anon_sym_PIPE_EQ] = ACTIONS(5619),
    [anon_sym_and_eq] = ACTIONS(5617),
    [anon_sym_or_eq] = ACTIONS(5617),
    [anon_sym_xor_eq] = ACTIONS(5617),
    [anon_sym_LT_EQ_GT] = ACTIONS(5619),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [anon_sym_bitor] = ACTIONS(5617),
    [anon_sym_xor] = ACTIONS(5617),
    [anon_sym_bitand] = ACTIONS(5617),
    [anon_sym_not_eq] = ACTIONS(5617),
    [anon_sym_DASH_DASH] = ACTIONS(5619),
    [anon_sym_PLUS_PLUS] = ACTIONS(5619),
    [anon_sym_DOT] = ACTIONS(5617),
    [anon_sym_DOT_STAR] = ACTIONS(5619),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_final] = ACTIONS(5617),
    [anon_sym_override] = ACTIONS(5617),
  },
  [1922] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_friend] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
  },
  [1923] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5619),
    [anon_sym_COMMA] = ACTIONS(5619),
    [anon_sym_RPAREN] = ACTIONS(5619),
    [aux_sym_preproc_if_token2] = ACTIONS(5619),
    [aux_sym_preproc_else_token1] = ACTIONS(5619),
    [aux_sym_preproc_elif_token1] = ACTIONS(5617),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5619),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_DASH] = ACTIONS(5617),
    [anon_sym_PLUS] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5617),
    [anon_sym_SLASH] = ACTIONS(5617),
    [anon_sym_PERCENT] = ACTIONS(5617),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_CARET] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5619),
    [anon_sym_BANG_EQ] = ACTIONS(5619),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_LT_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5617),
    [anon_sym_SEMI] = ACTIONS(5619),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_COLON] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5619),
    [anon_sym_RBRACE] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5619),
    [anon_sym_RBRACK] = ACTIONS(5619),
    [anon_sym_EQ] = ACTIONS(5617),
    [anon_sym_QMARK] = ACTIONS(5619),
    [anon_sym_STAR_EQ] = ACTIONS(5619),
    [anon_sym_SLASH_EQ] = ACTIONS(5619),
    [anon_sym_PERCENT_EQ] = ACTIONS(5619),
    [anon_sym_PLUS_EQ] = ACTIONS(5619),
    [anon_sym_DASH_EQ] = ACTIONS(5619),
    [anon_sym_LT_LT_EQ] = ACTIONS(5619),
    [anon_sym_GT_GT_EQ] = ACTIONS(5619),
    [anon_sym_AMP_EQ] = ACTIONS(5619),
    [anon_sym_CARET_EQ] = ACTIONS(5619),
    [anon_sym_PIPE_EQ] = ACTIONS(5619),
    [anon_sym_and_eq] = ACTIONS(5617),
    [anon_sym_or_eq] = ACTIONS(5617),
    [anon_sym_xor_eq] = ACTIONS(5617),
    [anon_sym_LT_EQ_GT] = ACTIONS(5619),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [anon_sym_bitor] = ACTIONS(5617),
    [anon_sym_xor] = ACTIONS(5617),
    [anon_sym_bitand] = ACTIONS(5617),
    [anon_sym_not_eq] = ACTIONS(5617),
    [anon_sym_DASH_DASH] = ACTIONS(5619),
    [anon_sym_PLUS_PLUS] = ACTIONS(5619),
    [anon_sym_DOT] = ACTIONS(5617),
    [anon_sym_DOT_STAR] = ACTIONS(5619),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_final] = ACTIONS(5617),
    [anon_sym_override] = ACTIONS(5617),
  },
  [1924] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4798),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1925] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4780),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1926] = {
    [sym_type_qualifier] = STATE(1926),
    [sym_alignas_qualifier] = STATE(2229),
    [aux_sym__type_definition_type_repeat1] = STATE(1926),
    [sym_identifier] = ACTIONS(5047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5049),
    [anon_sym_COMMA] = ACTIONS(5049),
    [anon_sym_LPAREN2] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5047),
    [anon_sym_STAR] = ACTIONS(5049),
    [anon_sym_SLASH] = ACTIONS(5047),
    [anon_sym_PERCENT] = ACTIONS(5049),
    [anon_sym_PIPE_PIPE] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_PIPE] = ACTIONS(5047),
    [anon_sym_CARET] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym_EQ_EQ] = ACTIONS(5049),
    [anon_sym_BANG_EQ] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5047),
    [anon_sym_GT_EQ] = ACTIONS(5047),
    [anon_sym_LT_EQ] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5047),
    [anon_sym_LT_LT] = ACTIONS(5049),
    [anon_sym_GT_GT] = ACTIONS(5047),
    [anon_sym___extension__] = ACTIONS(5880),
    [anon_sym___attribute__] = ACTIONS(5047),
    [anon_sym___attribute] = ACTIONS(5047),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_signed] = ACTIONS(5047),
    [anon_sym_unsigned] = ACTIONS(5047),
    [anon_sym_long] = ACTIONS(5047),
    [anon_sym_short] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [anon_sym_const] = ACTIONS(5880),
    [anon_sym_constexpr] = ACTIONS(5880),
    [anon_sym_volatile] = ACTIONS(5880),
    [anon_sym_restrict] = ACTIONS(5880),
    [anon_sym___restrict__] = ACTIONS(5880),
    [anon_sym__Atomic] = ACTIONS(5880),
    [anon_sym__Noreturn] = ACTIONS(5880),
    [anon_sym_noreturn] = ACTIONS(5880),
    [anon_sym__Nonnull] = ACTIONS(5880),
    [anon_sym_mutable] = ACTIONS(5880),
    [anon_sym_constinit] = ACTIONS(5880),
    [anon_sym_consteval] = ACTIONS(5880),
    [anon_sym_alignas] = ACTIONS(5883),
    [anon_sym__Alignas] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(5047),
    [anon_sym_QMARK] = ACTIONS(5049),
    [anon_sym_LT_EQ_GT] = ACTIONS(5049),
    [anon_sym_or] = ACTIONS(5047),
    [anon_sym_and] = ACTIONS(5047),
    [anon_sym_bitor] = ACTIONS(5047),
    [anon_sym_xor] = ACTIONS(5047),
    [anon_sym_bitand] = ACTIONS(5047),
    [anon_sym_not_eq] = ACTIONS(5047),
    [anon_sym_DASH_DASH] = ACTIONS(5049),
    [anon_sym_PLUS_PLUS] = ACTIONS(5049),
    [anon_sym_DOT] = ACTIONS(5047),
    [anon_sym_DOT_STAR] = ACTIONS(5049),
    [anon_sym_DASH_GT] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5047),
    [anon_sym_decltype] = ACTIONS(5047),
    [anon_sym_final] = ACTIONS(5047),
    [anon_sym_override] = ACTIONS(5047),
    [anon_sym_GT2] = ACTIONS(5049),
    [anon_sym_requires] = ACTIONS(5047),
  },
  [1927] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_RPAREN] = ACTIONS(5752),
    [anon_sym_LPAREN2] = ACTIONS(5752),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_STAR] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_PIPE] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5750),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_LT] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5752),
    [anon_sym___extension__] = ACTIONS(5752),
    [anon_sym___attribute__] = ACTIONS(5752),
    [anon_sym___attribute] = ACTIONS(5750),
    [anon_sym_COLON] = ACTIONS(5752),
    [anon_sym_LBRACE] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(5752),
    [anon_sym_signed] = ACTIONS(5886),
    [anon_sym_unsigned] = ACTIONS(5886),
    [anon_sym_long] = ACTIONS(5886),
    [anon_sym_short] = ACTIONS(5886),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_RBRACK] = ACTIONS(5752),
    [anon_sym_const] = ACTIONS(5750),
    [anon_sym_constexpr] = ACTIONS(5752),
    [anon_sym_volatile] = ACTIONS(5752),
    [anon_sym_restrict] = ACTIONS(5752),
    [anon_sym___restrict__] = ACTIONS(5752),
    [anon_sym__Atomic] = ACTIONS(5752),
    [anon_sym__Noreturn] = ACTIONS(5752),
    [anon_sym_noreturn] = ACTIONS(5752),
    [anon_sym__Nonnull] = ACTIONS(5752),
    [anon_sym_mutable] = ACTIONS(5752),
    [anon_sym_constinit] = ACTIONS(5752),
    [anon_sym_consteval] = ACTIONS(5752),
    [anon_sym_alignas] = ACTIONS(5752),
    [anon_sym__Alignas] = ACTIONS(5752),
    [anon_sym_QMARK] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_or] = ACTIONS(5752),
    [anon_sym_and] = ACTIONS(5752),
    [anon_sym_bitor] = ACTIONS(5752),
    [anon_sym_xor] = ACTIONS(5752),
    [anon_sym_bitand] = ACTIONS(5752),
    [anon_sym_not_eq] = ACTIONS(5752),
    [anon_sym_DASH_DASH] = ACTIONS(5752),
    [anon_sym_PLUS_PLUS] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_DOT_STAR] = ACTIONS(5752),
    [anon_sym_DASH_GT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5752),
    [anon_sym_decltype] = ACTIONS(5752),
    [anon_sym_final] = ACTIONS(5752),
    [anon_sym_override] = ACTIONS(5752),
    [anon_sym_requires] = ACTIONS(5752),
  },
  [1928] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(5888),
    [anon_sym_RPAREN] = ACTIONS(5888),
    [anon_sym_LPAREN2] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5890),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_SLASH] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5888),
    [anon_sym_AMP_AMP] = ACTIONS(5888),
    [anon_sym_PIPE] = ACTIONS(5890),
    [anon_sym_CARET] = ACTIONS(5888),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_EQ_EQ] = ACTIONS(5888),
    [anon_sym_BANG_EQ] = ACTIONS(5888),
    [anon_sym_GT] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5890),
    [anon_sym_LT_LT] = ACTIONS(5888),
    [anon_sym_GT_GT] = ACTIONS(5888),
    [anon_sym_SEMI] = ACTIONS(5888),
    [anon_sym___extension__] = ACTIONS(5888),
    [anon_sym___attribute__] = ACTIONS(5888),
    [anon_sym___attribute] = ACTIONS(5890),
    [anon_sym_COLON] = ACTIONS(5888),
    [anon_sym_LBRACE] = ACTIONS(5888),
    [anon_sym_RBRACE] = ACTIONS(5888),
    [anon_sym_signed] = ACTIONS(5892),
    [anon_sym_unsigned] = ACTIONS(5892),
    [anon_sym_long] = ACTIONS(5892),
    [anon_sym_short] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_RBRACK] = ACTIONS(5888),
    [anon_sym_const] = ACTIONS(5890),
    [anon_sym_constexpr] = ACTIONS(5888),
    [anon_sym_volatile] = ACTIONS(5888),
    [anon_sym_restrict] = ACTIONS(5888),
    [anon_sym___restrict__] = ACTIONS(5888),
    [anon_sym__Atomic] = ACTIONS(5888),
    [anon_sym__Noreturn] = ACTIONS(5888),
    [anon_sym_noreturn] = ACTIONS(5888),
    [anon_sym__Nonnull] = ACTIONS(5888),
    [anon_sym_mutable] = ACTIONS(5888),
    [anon_sym_constinit] = ACTIONS(5888),
    [anon_sym_consteval] = ACTIONS(5888),
    [anon_sym_alignas] = ACTIONS(5888),
    [anon_sym__Alignas] = ACTIONS(5888),
    [anon_sym_QMARK] = ACTIONS(5888),
    [anon_sym_LT_EQ_GT] = ACTIONS(5888),
    [anon_sym_or] = ACTIONS(5888),
    [anon_sym_and] = ACTIONS(5888),
    [anon_sym_bitor] = ACTIONS(5888),
    [anon_sym_xor] = ACTIONS(5888),
    [anon_sym_bitand] = ACTIONS(5888),
    [anon_sym_not_eq] = ACTIONS(5888),
    [anon_sym_DASH_DASH] = ACTIONS(5888),
    [anon_sym_PLUS_PLUS] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5890),
    [anon_sym_DOT_STAR] = ACTIONS(5888),
    [anon_sym_DASH_GT] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5888),
    [anon_sym_decltype] = ACTIONS(5888),
    [anon_sym_final] = ACTIONS(5888),
    [anon_sym_override] = ACTIONS(5888),
    [anon_sym_requires] = ACTIONS(5888),
  },
  [1929] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4785),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1930] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5894),
    [anon_sym_COMMA] = ACTIONS(5894),
    [anon_sym_RPAREN] = ACTIONS(5894),
    [anon_sym_LPAREN2] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5896),
    [anon_sym_STAR] = ACTIONS(5894),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5894),
    [anon_sym_AMP_AMP] = ACTIONS(5894),
    [anon_sym_PIPE] = ACTIONS(5896),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5896),
    [anon_sym_LT_LT] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(5894),
    [anon_sym___extension__] = ACTIONS(5894),
    [anon_sym___attribute__] = ACTIONS(5894),
    [anon_sym___attribute] = ACTIONS(5896),
    [anon_sym_COLON] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5894),
    [anon_sym_RBRACE] = ACTIONS(5894),
    [anon_sym_signed] = ACTIONS(5892),
    [anon_sym_unsigned] = ACTIONS(5892),
    [anon_sym_long] = ACTIONS(5892),
    [anon_sym_short] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_RBRACK] = ACTIONS(5894),
    [anon_sym_const] = ACTIONS(5896),
    [anon_sym_constexpr] = ACTIONS(5894),
    [anon_sym_volatile] = ACTIONS(5894),
    [anon_sym_restrict] = ACTIONS(5894),
    [anon_sym___restrict__] = ACTIONS(5894),
    [anon_sym__Atomic] = ACTIONS(5894),
    [anon_sym__Noreturn] = ACTIONS(5894),
    [anon_sym_noreturn] = ACTIONS(5894),
    [anon_sym__Nonnull] = ACTIONS(5894),
    [anon_sym_mutable] = ACTIONS(5894),
    [anon_sym_constinit] = ACTIONS(5894),
    [anon_sym_consteval] = ACTIONS(5894),
    [anon_sym_alignas] = ACTIONS(5894),
    [anon_sym__Alignas] = ACTIONS(5894),
    [anon_sym_QMARK] = ACTIONS(5894),
    [anon_sym_LT_EQ_GT] = ACTIONS(5894),
    [anon_sym_or] = ACTIONS(5894),
    [anon_sym_and] = ACTIONS(5894),
    [anon_sym_bitor] = ACTIONS(5894),
    [anon_sym_xor] = ACTIONS(5894),
    [anon_sym_bitand] = ACTIONS(5894),
    [anon_sym_not_eq] = ACTIONS(5894),
    [anon_sym_DASH_DASH] = ACTIONS(5894),
    [anon_sym_PLUS_PLUS] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5896),
    [anon_sym_DOT_STAR] = ACTIONS(5894),
    [anon_sym_DASH_GT] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5894),
    [anon_sym_decltype] = ACTIONS(5894),
    [anon_sym_final] = ACTIONS(5894),
    [anon_sym_override] = ACTIONS(5894),
    [anon_sym_requires] = ACTIONS(5894),
  },
  [1931] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(1940),
    [anon_sym___attribute] = ACTIONS(1940),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1938),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_friend] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
    [anon_sym_catch] = ACTIONS(1940),
  },
  [1932] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4796),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1933] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4800),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1934] = {
    [sym__declaration_modifiers] = STATE(2136),
    [sym__declaration_specifiers] = STATE(4801),
    [sym_attribute_specifier] = STATE(2136),
    [sym_attribute_declaration] = STATE(2136),
    [sym_ms_declspec_modifier] = STATE(2136),
    [sym_storage_class_specifier] = STATE(2136),
    [sym_type_qualifier] = STATE(2136),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2394),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1935] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5898),
    [anon_sym_COMMA] = ACTIONS(5898),
    [anon_sym_RPAREN] = ACTIONS(5898),
    [anon_sym_LPAREN2] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5900),
    [anon_sym_STAR] = ACTIONS(5898),
    [anon_sym_SLASH] = ACTIONS(5900),
    [anon_sym_PERCENT] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5898),
    [anon_sym_AMP_AMP] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_AMP] = ACTIONS(5900),
    [anon_sym_EQ_EQ] = ACTIONS(5898),
    [anon_sym_BANG_EQ] = ACTIONS(5898),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5898),
    [anon_sym_GT_GT] = ACTIONS(5898),
    [anon_sym_SEMI] = ACTIONS(5898),
    [anon_sym___extension__] = ACTIONS(5898),
    [anon_sym___attribute__] = ACTIONS(5898),
    [anon_sym___attribute] = ACTIONS(5900),
    [anon_sym_COLON] = ACTIONS(5898),
    [anon_sym_LBRACE] = ACTIONS(5898),
    [anon_sym_RBRACE] = ACTIONS(5898),
    [anon_sym_signed] = ACTIONS(5892),
    [anon_sym_unsigned] = ACTIONS(5892),
    [anon_sym_long] = ACTIONS(5892),
    [anon_sym_short] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_RBRACK] = ACTIONS(5898),
    [anon_sym_const] = ACTIONS(5900),
    [anon_sym_constexpr] = ACTIONS(5898),
    [anon_sym_volatile] = ACTIONS(5898),
    [anon_sym_restrict] = ACTIONS(5898),
    [anon_sym___restrict__] = ACTIONS(5898),
    [anon_sym__Atomic] = ACTIONS(5898),
    [anon_sym__Noreturn] = ACTIONS(5898),
    [anon_sym_noreturn] = ACTIONS(5898),
    [anon_sym__Nonnull] = ACTIONS(5898),
    [anon_sym_mutable] = ACTIONS(5898),
    [anon_sym_constinit] = ACTIONS(5898),
    [anon_sym_consteval] = ACTIONS(5898),
    [anon_sym_alignas] = ACTIONS(5898),
    [anon_sym__Alignas] = ACTIONS(5898),
    [anon_sym_QMARK] = ACTIONS(5898),
    [anon_sym_LT_EQ_GT] = ACTIONS(5898),
    [anon_sym_or] = ACTIONS(5898),
    [anon_sym_and] = ACTIONS(5898),
    [anon_sym_bitor] = ACTIONS(5898),
    [anon_sym_xor] = ACTIONS(5898),
    [anon_sym_bitand] = ACTIONS(5898),
    [anon_sym_not_eq] = ACTIONS(5898),
    [anon_sym_DASH_DASH] = ACTIONS(5898),
    [anon_sym_PLUS_PLUS] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5900),
    [anon_sym_DOT_STAR] = ACTIONS(5898),
    [anon_sym_DASH_GT] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5898),
    [anon_sym_decltype] = ACTIONS(5898),
    [anon_sym_final] = ACTIONS(5898),
    [anon_sym_override] = ACTIONS(5898),
    [anon_sym_requires] = ACTIONS(5898),
  },
  [1936] = {
    [sym_identifier] = ACTIONS(5605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5607),
    [anon_sym_COMMA] = ACTIONS(5607),
    [anon_sym_RPAREN] = ACTIONS(5607),
    [aux_sym_preproc_if_token2] = ACTIONS(5607),
    [aux_sym_preproc_else_token1] = ACTIONS(5607),
    [aux_sym_preproc_elif_token1] = ACTIONS(5605),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5607),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5607),
    [anon_sym_LPAREN2] = ACTIONS(5607),
    [anon_sym_DASH] = ACTIONS(5605),
    [anon_sym_PLUS] = ACTIONS(5605),
    [anon_sym_STAR] = ACTIONS(5605),
    [anon_sym_SLASH] = ACTIONS(5605),
    [anon_sym_PERCENT] = ACTIONS(5605),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_AMP_AMP] = ACTIONS(5607),
    [anon_sym_PIPE] = ACTIONS(5605),
    [anon_sym_CARET] = ACTIONS(5605),
    [anon_sym_AMP] = ACTIONS(5605),
    [anon_sym_EQ_EQ] = ACTIONS(5607),
    [anon_sym_BANG_EQ] = ACTIONS(5607),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5607),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_LT_LT] = ACTIONS(5605),
    [anon_sym_GT_GT] = ACTIONS(5605),
    [anon_sym_SEMI] = ACTIONS(5607),
    [anon_sym___attribute__] = ACTIONS(5605),
    [anon_sym___attribute] = ACTIONS(5605),
    [anon_sym_COLON] = ACTIONS(5605),
    [anon_sym_COLON_COLON] = ACTIONS(5607),
    [anon_sym_LBRACE] = ACTIONS(5607),
    [anon_sym_RBRACE] = ACTIONS(5607),
    [anon_sym_LBRACK] = ACTIONS(5607),
    [anon_sym_RBRACK] = ACTIONS(5607),
    [anon_sym_EQ] = ACTIONS(5605),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_STAR_EQ] = ACTIONS(5607),
    [anon_sym_SLASH_EQ] = ACTIONS(5607),
    [anon_sym_PERCENT_EQ] = ACTIONS(5607),
    [anon_sym_PLUS_EQ] = ACTIONS(5607),
    [anon_sym_DASH_EQ] = ACTIONS(5607),
    [anon_sym_LT_LT_EQ] = ACTIONS(5607),
    [anon_sym_GT_GT_EQ] = ACTIONS(5607),
    [anon_sym_AMP_EQ] = ACTIONS(5607),
    [anon_sym_CARET_EQ] = ACTIONS(5607),
    [anon_sym_PIPE_EQ] = ACTIONS(5607),
    [anon_sym_and_eq] = ACTIONS(5605),
    [anon_sym_or_eq] = ACTIONS(5605),
    [anon_sym_xor_eq] = ACTIONS(5605),
    [anon_sym_LT_EQ_GT] = ACTIONS(5607),
    [anon_sym_or] = ACTIONS(5605),
    [anon_sym_and] = ACTIONS(5605),
    [anon_sym_bitor] = ACTIONS(5605),
    [anon_sym_xor] = ACTIONS(5605),
    [anon_sym_bitand] = ACTIONS(5605),
    [anon_sym_not_eq] = ACTIONS(5605),
    [anon_sym_DASH_DASH] = ACTIONS(5607),
    [anon_sym_PLUS_PLUS] = ACTIONS(5607),
    [anon_sym_DOT] = ACTIONS(5605),
    [anon_sym_DOT_STAR] = ACTIONS(5607),
    [anon_sym_DASH_GT] = ACTIONS(5607),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5605),
    [anon_sym_decltype] = ACTIONS(5605),
    [anon_sym_final] = ACTIONS(5605),
    [anon_sym_override] = ACTIONS(5605),
  },
  [1937] = {
    [sym_identifier] = ACTIONS(2619),
    [aux_sym_preproc_def_token1] = ACTIONS(2619),
    [aux_sym_preproc_if_token1] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2619),
    [sym_preproc_directive] = ACTIONS(2619),
    [anon_sym_LPAREN2] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(2621),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(2619),
    [anon_sym_typedef] = ACTIONS(2619),
    [anon_sym_virtual] = ACTIONS(2619),
    [anon_sym_extern] = ACTIONS(2619),
    [anon_sym___attribute__] = ACTIONS(2619),
    [anon_sym___attribute] = ACTIONS(2619),
    [anon_sym_using] = ACTIONS(2619),
    [anon_sym_COLON_COLON] = ACTIONS(2621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2621),
    [anon_sym___declspec] = ACTIONS(2619),
    [anon_sym___based] = ACTIONS(2619),
    [anon_sym_RBRACE] = ACTIONS(2621),
    [anon_sym_signed] = ACTIONS(2619),
    [anon_sym_unsigned] = ACTIONS(2619),
    [anon_sym_long] = ACTIONS(2619),
    [anon_sym_short] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_register] = ACTIONS(2619),
    [anon_sym_inline] = ACTIONS(2619),
    [anon_sym___inline] = ACTIONS(2619),
    [anon_sym___inline__] = ACTIONS(2619),
    [anon_sym___forceinline] = ACTIONS(2619),
    [anon_sym_thread_local] = ACTIONS(2619),
    [anon_sym___thread] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_constexpr] = ACTIONS(2619),
    [anon_sym_volatile] = ACTIONS(2619),
    [anon_sym_restrict] = ACTIONS(2619),
    [anon_sym___restrict__] = ACTIONS(2619),
    [anon_sym__Atomic] = ACTIONS(2619),
    [anon_sym__Noreturn] = ACTIONS(2619),
    [anon_sym_noreturn] = ACTIONS(2619),
    [anon_sym__Nonnull] = ACTIONS(2619),
    [anon_sym_mutable] = ACTIONS(2619),
    [anon_sym_constinit] = ACTIONS(2619),
    [anon_sym_consteval] = ACTIONS(2619),
    [anon_sym_alignas] = ACTIONS(2619),
    [anon_sym__Alignas] = ACTIONS(2619),
    [sym_primitive_type] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_struct] = ACTIONS(2619),
    [anon_sym_union] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2619),
    [anon_sym_decltype] = ACTIONS(2619),
    [anon_sym_explicit] = ACTIONS(2619),
    [anon_sym_typename] = ACTIONS(2619),
    [anon_sym_private] = ACTIONS(2619),
    [anon_sym_template] = ACTIONS(2619),
    [anon_sym_operator] = ACTIONS(2619),
    [anon_sym_friend] = ACTIONS(2619),
    [anon_sym_public] = ACTIONS(2619),
    [anon_sym_protected] = ACTIONS(2619),
    [anon_sym_static_assert] = ACTIONS(2619),
    [anon_sym_catch] = ACTIONS(2619),
  },
  [1938] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1940),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5902),
    [anon_sym_COMMA] = ACTIONS(5902),
    [anon_sym_RPAREN] = ACTIONS(5902),
    [anon_sym_LPAREN2] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5904),
    [anon_sym_STAR] = ACTIONS(5902),
    [anon_sym_SLASH] = ACTIONS(5904),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5902),
    [anon_sym_PIPE] = ACTIONS(5904),
    [anon_sym_CARET] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_EQ_EQ] = ACTIONS(5902),
    [anon_sym_BANG_EQ] = ACTIONS(5902),
    [anon_sym_GT] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5904),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_SEMI] = ACTIONS(5902),
    [anon_sym___extension__] = ACTIONS(5902),
    [anon_sym___attribute__] = ACTIONS(5902),
    [anon_sym___attribute] = ACTIONS(5904),
    [anon_sym_COLON] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5902),
    [anon_sym_RBRACE] = ACTIONS(5902),
    [anon_sym_signed] = ACTIONS(5906),
    [anon_sym_unsigned] = ACTIONS(5906),
    [anon_sym_long] = ACTIONS(5906),
    [anon_sym_short] = ACTIONS(5906),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_RBRACK] = ACTIONS(5902),
    [anon_sym_const] = ACTIONS(5904),
    [anon_sym_constexpr] = ACTIONS(5902),
    [anon_sym_volatile] = ACTIONS(5902),
    [anon_sym_restrict] = ACTIONS(5902),
    [anon_sym___restrict__] = ACTIONS(5902),
    [anon_sym__Atomic] = ACTIONS(5902),
    [anon_sym__Noreturn] = ACTIONS(5902),
    [anon_sym_noreturn] = ACTIONS(5902),
    [anon_sym__Nonnull] = ACTIONS(5902),
    [anon_sym_mutable] = ACTIONS(5902),
    [anon_sym_constinit] = ACTIONS(5902),
    [anon_sym_consteval] = ACTIONS(5902),
    [anon_sym_alignas] = ACTIONS(5902),
    [anon_sym__Alignas] = ACTIONS(5902),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_LT_EQ_GT] = ACTIONS(5902),
    [anon_sym_or] = ACTIONS(5902),
    [anon_sym_and] = ACTIONS(5902),
    [anon_sym_bitor] = ACTIONS(5902),
    [anon_sym_xor] = ACTIONS(5902),
    [anon_sym_bitand] = ACTIONS(5902),
    [anon_sym_not_eq] = ACTIONS(5902),
    [anon_sym_DASH_DASH] = ACTIONS(5902),
    [anon_sym_PLUS_PLUS] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5904),
    [anon_sym_DOT_STAR] = ACTIONS(5902),
    [anon_sym_DASH_GT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5902),
    [anon_sym_decltype] = ACTIONS(5902),
    [anon_sym_final] = ACTIONS(5902),
    [anon_sym_override] = ACTIONS(5902),
    [anon_sym_requires] = ACTIONS(5902),
  },
  [1939] = {
    [sym_identifier] = ACTIONS(1940),
    [aux_sym_preproc_def_token1] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(1940),
    [aux_sym_preproc_if_token2] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1940),
    [sym_preproc_directive] = ACTIONS(1940),
    [anon_sym_LPAREN2] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_AMP_AMP] = ACTIONS(1938),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(1940),
    [anon_sym_typedef] = ACTIONS(1940),
    [anon_sym_virtual] = ACTIONS(1940),
    [anon_sym_extern] = ACTIONS(1940),
    [anon_sym___attribute__] = ACTIONS(5442),
    [anon_sym___attribute] = ACTIONS(5442),
    [anon_sym_using] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1938),
    [anon_sym___declspec] = ACTIONS(1940),
    [anon_sym___based] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1940),
    [anon_sym_unsigned] = ACTIONS(1940),
    [anon_sym_long] = ACTIONS(1940),
    [anon_sym_short] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_register] = ACTIONS(1940),
    [anon_sym_inline] = ACTIONS(1940),
    [anon_sym___inline] = ACTIONS(1940),
    [anon_sym___inline__] = ACTIONS(1940),
    [anon_sym___forceinline] = ACTIONS(1940),
    [anon_sym_thread_local] = ACTIONS(1940),
    [anon_sym___thread] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_constexpr] = ACTIONS(1940),
    [anon_sym_volatile] = ACTIONS(1940),
    [anon_sym_restrict] = ACTIONS(1940),
    [anon_sym___restrict__] = ACTIONS(1940),
    [anon_sym__Atomic] = ACTIONS(1940),
    [anon_sym__Noreturn] = ACTIONS(1940),
    [anon_sym_noreturn] = ACTIONS(1940),
    [anon_sym__Nonnull] = ACTIONS(1940),
    [anon_sym_mutable] = ACTIONS(1940),
    [anon_sym_constinit] = ACTIONS(1940),
    [anon_sym_consteval] = ACTIONS(1940),
    [anon_sym_alignas] = ACTIONS(1940),
    [anon_sym__Alignas] = ACTIONS(1940),
    [sym_primitive_type] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_struct] = ACTIONS(1940),
    [anon_sym_union] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1940),
    [anon_sym_decltype] = ACTIONS(1940),
    [anon_sym_explicit] = ACTIONS(1940),
    [anon_sym_typename] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_template] = ACTIONS(1940),
    [anon_sym_operator] = ACTIONS(1940),
    [anon_sym_friend] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_static_assert] = ACTIONS(1940),
  },
  [1940] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_RPAREN] = ACTIONS(5908),
    [anon_sym_LPAREN2] = ACTIONS(5908),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_PLUS] = ACTIONS(5910),
    [anon_sym_STAR] = ACTIONS(5908),
    [anon_sym_SLASH] = ACTIONS(5910),
    [anon_sym_PERCENT] = ACTIONS(5908),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_PIPE] = ACTIONS(5910),
    [anon_sym_CARET] = ACTIONS(5908),
    [anon_sym_AMP] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5908),
    [anon_sym_GT] = ACTIONS(5910),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_LT] = ACTIONS(5910),
    [anon_sym_LT_LT] = ACTIONS(5908),
    [anon_sym_GT_GT] = ACTIONS(5908),
    [anon_sym_SEMI] = ACTIONS(5908),
    [anon_sym___extension__] = ACTIONS(5908),
    [anon_sym___attribute__] = ACTIONS(5908),
    [anon_sym___attribute] = ACTIONS(5910),
    [anon_sym_COLON] = ACTIONS(5908),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_RBRACE] = ACTIONS(5908),
    [anon_sym_signed] = ACTIONS(5892),
    [anon_sym_unsigned] = ACTIONS(5892),
    [anon_sym_long] = ACTIONS(5892),
    [anon_sym_short] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5908),
    [anon_sym_RBRACK] = ACTIONS(5908),
    [anon_sym_const] = ACTIONS(5910),
    [anon_sym_constexpr] = ACTIONS(5908),
    [anon_sym_volatile] = ACTIONS(5908),
    [anon_sym_restrict] = ACTIONS(5908),
    [anon_sym___restrict__] = ACTIONS(5908),
    [anon_sym__Atomic] = ACTIONS(5908),
    [anon_sym__Noreturn] = ACTIONS(5908),
    [anon_sym_noreturn] = ACTIONS(5908),
    [anon_sym__Nonnull] = ACTIONS(5908),
    [anon_sym_mutable] = ACTIONS(5908),
    [anon_sym_constinit] = ACTIONS(5908),
    [anon_sym_consteval] = ACTIONS(5908),
    [anon_sym_alignas] = ACTIONS(5908),
    [anon_sym__Alignas] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_or] = ACTIONS(5908),
    [anon_sym_and] = ACTIONS(5908),
    [anon_sym_bitor] = ACTIONS(5908),
    [anon_sym_xor] = ACTIONS(5908),
    [anon_sym_bitand] = ACTIONS(5908),
    [anon_sym_not_eq] = ACTIONS(5908),
    [anon_sym_DASH_DASH] = ACTIONS(5908),
    [anon_sym_PLUS_PLUS] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_DOT_STAR] = ACTIONS(5908),
    [anon_sym_DASH_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5908),
    [anon_sym_decltype] = ACTIONS(5908),
    [anon_sym_final] = ACTIONS(5908),
    [anon_sym_override] = ACTIONS(5908),
    [anon_sym_requires] = ACTIONS(5908),
  },
  [1941] = {
    [sym_identifier] = ACTIONS(4996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5003),
    [anon_sym_COMMA] = ACTIONS(5003),
    [anon_sym_RPAREN] = ACTIONS(5003),
    [aux_sym_preproc_if_token2] = ACTIONS(5003),
    [aux_sym_preproc_else_token1] = ACTIONS(5003),
    [aux_sym_preproc_elif_token1] = ACTIONS(4996),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5003),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5003),
    [anon_sym_LPAREN2] = ACTIONS(5003),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_STAR] = ACTIONS(4996),
    [anon_sym_SLASH] = ACTIONS(4996),
    [anon_sym_PERCENT] = ACTIONS(4996),
    [anon_sym_PIPE_PIPE] = ACTIONS(5003),
    [anon_sym_AMP_AMP] = ACTIONS(5003),
    [anon_sym_PIPE] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4996),
    [anon_sym_AMP] = ACTIONS(4996),
    [anon_sym_EQ_EQ] = ACTIONS(5003),
    [anon_sym_BANG_EQ] = ACTIONS(5003),
    [anon_sym_GT] = ACTIONS(4996),
    [anon_sym_GT_EQ] = ACTIONS(5003),
    [anon_sym_LT_EQ] = ACTIONS(4996),
    [anon_sym_LT] = ACTIONS(4996),
    [anon_sym_LT_LT] = ACTIONS(4996),
    [anon_sym_GT_GT] = ACTIONS(4996),
    [anon_sym_SEMI] = ACTIONS(5003),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym___attribute] = ACTIONS(4996),
    [anon_sym_COLON] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_LBRACK] = ACTIONS(5003),
    [anon_sym_RBRACK] = ACTIONS(5003),
    [anon_sym_EQ] = ACTIONS(4996),
    [anon_sym_QMARK] = ACTIONS(5003),
    [anon_sym_STAR_EQ] = ACTIONS(5003),
    [anon_sym_SLASH_EQ] = ACTIONS(5003),
    [anon_sym_PERCENT_EQ] = ACTIONS(5003),
    [anon_sym_PLUS_EQ] = ACTIONS(5003),
    [anon_sym_DASH_EQ] = ACTIONS(5003),
    [anon_sym_LT_LT_EQ] = ACTIONS(5003),
    [anon_sym_GT_GT_EQ] = ACTIONS(5003),
    [anon_sym_AMP_EQ] = ACTIONS(5003),
    [anon_sym_CARET_EQ] = ACTIONS(5003),
    [anon_sym_PIPE_EQ] = ACTIONS(5003),
    [anon_sym_and_eq] = ACTIONS(4996),
    [anon_sym_or_eq] = ACTIONS(4996),
    [anon_sym_xor_eq] = ACTIONS(4996),
    [anon_sym_LT_EQ_GT] = ACTIONS(5003),
    [anon_sym_or] = ACTIONS(4996),
    [anon_sym_and] = ACTIONS(4996),
    [anon_sym_bitor] = ACTIONS(4996),
    [anon_sym_xor] = ACTIONS(4996),
    [anon_sym_bitand] = ACTIONS(4996),
    [anon_sym_not_eq] = ACTIONS(4996),
    [anon_sym_DASH_DASH] = ACTIONS(5003),
    [anon_sym_PLUS_PLUS] = ACTIONS(5003),
    [anon_sym_DOT] = ACTIONS(4996),
    [anon_sym_DOT_STAR] = ACTIONS(5003),
    [anon_sym_DASH_GT] = ACTIONS(5003),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_final] = ACTIONS(4996),
    [anon_sym_override] = ACTIONS(4996),
  },
  [1942] = {
    [sym_string_literal] = STATE(1684),
    [sym_raw_string_literal] = STATE(1684),
    [sym_identifier] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_COMMA] = ACTIONS(5914),
    [aux_sym_preproc_if_token2] = ACTIONS(5914),
    [aux_sym_preproc_else_token1] = ACTIONS(5914),
    [aux_sym_preproc_elif_token1] = ACTIONS(5912),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5914),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5914),
    [anon_sym_LPAREN2] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5912),
    [anon_sym_STAR] = ACTIONS(5912),
    [anon_sym_SLASH] = ACTIONS(5912),
    [anon_sym_PERCENT] = ACTIONS(5912),
    [anon_sym_PIPE_PIPE] = ACTIONS(5914),
    [anon_sym_AMP_AMP] = ACTIONS(5914),
    [anon_sym_PIPE] = ACTIONS(5912),
    [anon_sym_CARET] = ACTIONS(5912),
    [anon_sym_AMP] = ACTIONS(5912),
    [anon_sym_EQ_EQ] = ACTIONS(5914),
    [anon_sym_BANG_EQ] = ACTIONS(5914),
    [anon_sym_GT] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5912),
    [anon_sym_LT_LT] = ACTIONS(5912),
    [anon_sym_GT_GT] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5912),
    [anon_sym_QMARK] = ACTIONS(5914),
    [anon_sym_STAR_EQ] = ACTIONS(5914),
    [anon_sym_SLASH_EQ] = ACTIONS(5914),
    [anon_sym_PERCENT_EQ] = ACTIONS(5914),
    [anon_sym_PLUS_EQ] = ACTIONS(5914),
    [anon_sym_DASH_EQ] = ACTIONS(5914),
    [anon_sym_LT_LT_EQ] = ACTIONS(5914),
    [anon_sym_GT_GT_EQ] = ACTIONS(5914),
    [anon_sym_AMP_EQ] = ACTIONS(5914),
    [anon_sym_CARET_EQ] = ACTIONS(5914),
    [anon_sym_PIPE_EQ] = ACTIONS(5914),
    [anon_sym_and_eq] = ACTIONS(5912),
    [anon_sym_or_eq] = ACTIONS(5912),
    [anon_sym_xor_eq] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5914),
    [anon_sym_or] = ACTIONS(5912),
    [anon_sym_and] = ACTIONS(5912),
    [anon_sym_bitor] = ACTIONS(5912),
    [anon_sym_xor] = ACTIONS(5912),
    [anon_sym_bitand] = ACTIONS(5912),
    [anon_sym_not_eq] = ACTIONS(5912),
    [anon_sym_DASH_DASH] = ACTIONS(5914),
    [anon_sym_PLUS_PLUS] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5912),
    [anon_sym_DOT_STAR] = ACTIONS(5914),
    [anon_sym_DASH_GT] = ACTIONS(5914),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [sym_literal_suffix] = ACTIONS(5912),
  },
  [1943] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_RPAREN] = ACTIONS(5916),
    [anon_sym_LPAREN2] = ACTIONS(5916),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_PLUS] = ACTIONS(5918),
    [anon_sym_STAR] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5918),
    [anon_sym_PERCENT] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_AMP_AMP] = ACTIONS(5916),
    [anon_sym_PIPE] = ACTIONS(5918),
    [anon_sym_CARET] = ACTIONS(5916),
    [anon_sym_AMP] = ACTIONS(5918),
    [anon_sym_EQ_EQ] = ACTIONS(5916),
    [anon_sym_BANG_EQ] = ACTIONS(5916),
    [anon_sym_GT] = ACTIONS(5918),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_LT] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5916),
    [anon_sym_GT_GT] = ACTIONS(5916),
    [anon_sym_SEMI] = ACTIONS(5916),
    [anon_sym___extension__] = ACTIONS(5916),
    [anon_sym___attribute__] = ACTIONS(5916),
    [anon_sym___attribute] = ACTIONS(5918),
    [anon_sym_COLON] = ACTIONS(5916),
    [anon_sym_LBRACE] = ACTIONS(5916),
    [anon_sym_RBRACE] = ACTIONS(5916),
    [anon_sym_signed] = ACTIONS(5892),
    [anon_sym_unsigned] = ACTIONS(5892),
    [anon_sym_long] = ACTIONS(5892),
    [anon_sym_short] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5916),
    [anon_sym_RBRACK] = ACTIONS(5916),
    [anon_sym_const] = ACTIONS(5918),
    [anon_sym_constexpr] = ACTIONS(5916),
    [anon_sym_volatile] = ACTIONS(5916),
    [anon_sym_restrict] = ACTIONS(5916),
    [anon_sym___restrict__] = ACTIONS(5916),
    [anon_sym__Atomic] = ACTIONS(5916),
    [anon_sym__Noreturn] = ACTIONS(5916),
    [anon_sym_noreturn] = ACTIONS(5916),
    [anon_sym__Nonnull] = ACTIONS(5916),
    [anon_sym_mutable] = ACTIONS(5916),
    [anon_sym_constinit] = ACTIONS(5916),
    [anon_sym_consteval] = ACTIONS(5916),
    [anon_sym_alignas] = ACTIONS(5916),
    [anon_sym__Alignas] = ACTIONS(5916),
    [anon_sym_QMARK] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_bitor] = ACTIONS(5916),
    [anon_sym_xor] = ACTIONS(5916),
    [anon_sym_bitand] = ACTIONS(5916),
    [anon_sym_not_eq] = ACTIONS(5916),
    [anon_sym_DASH_DASH] = ACTIONS(5916),
    [anon_sym_PLUS_PLUS] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_DOT_STAR] = ACTIONS(5916),
    [anon_sym_DASH_GT] = ACTIONS(5916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5916),
    [anon_sym_decltype] = ACTIONS(5916),
    [anon_sym_final] = ACTIONS(5916),
    [anon_sym_override] = ACTIONS(5916),
    [anon_sym_requires] = ACTIONS(5916),
  },
  [1944] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_RPAREN] = ACTIONS(5920),
    [anon_sym_LPAREN2] = ACTIONS(5920),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_STAR] = ACTIONS(5920),
    [anon_sym_SLASH] = ACTIONS(5922),
    [anon_sym_PERCENT] = ACTIONS(5920),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_AMP_AMP] = ACTIONS(5920),
    [anon_sym_PIPE] = ACTIONS(5922),
    [anon_sym_CARET] = ACTIONS(5920),
    [anon_sym_AMP] = ACTIONS(5922),
    [anon_sym_EQ_EQ] = ACTIONS(5920),
    [anon_sym_BANG_EQ] = ACTIONS(5920),
    [anon_sym_GT] = ACTIONS(5922),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_LT] = ACTIONS(5922),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_SEMI] = ACTIONS(5920),
    [anon_sym___extension__] = ACTIONS(5920),
    [anon_sym___attribute__] = ACTIONS(5920),
    [anon_sym___attribute] = ACTIONS(5922),
    [anon_sym_COLON] = ACTIONS(5920),
    [anon_sym_LBRACE] = ACTIONS(5920),
    [anon_sym_RBRACE] = ACTIONS(5920),
    [anon_sym_signed] = ACTIONS(5924),
    [anon_sym_unsigned] = ACTIONS(5924),
    [anon_sym_long] = ACTIONS(5924),
    [anon_sym_short] = ACTIONS(5924),
    [anon_sym_LBRACK] = ACTIONS(5920),
    [anon_sym_RBRACK] = ACTIONS(5920),
    [anon_sym_const] = ACTIONS(5922),
    [anon_sym_constexpr] = ACTIONS(5920),
    [anon_sym_volatile] = ACTIONS(5920),
    [anon_sym_restrict] = ACTIONS(5920),
    [anon_sym___restrict__] = ACTIONS(5920),
    [anon_sym__Atomic] = ACTIONS(5920),
    [anon_sym__Noreturn] = ACTIONS(5920),
    [anon_sym_noreturn] = ACTIONS(5920),
    [anon_sym__Nonnull] = ACTIONS(5920),
    [anon_sym_mutable] = ACTIONS(5920),
    [anon_sym_constinit] = ACTIONS(5920),
    [anon_sym_consteval] = ACTIONS(5920),
    [anon_sym_alignas] = ACTIONS(5920),
    [anon_sym__Alignas] = ACTIONS(5920),
    [anon_sym_QMARK] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_or] = ACTIONS(5920),
    [anon_sym_and] = ACTIONS(5920),
    [anon_sym_bitor] = ACTIONS(5920),
    [anon_sym_xor] = ACTIONS(5920),
    [anon_sym_bitand] = ACTIONS(5920),
    [anon_sym_not_eq] = ACTIONS(5920),
    [anon_sym_DASH_DASH] = ACTIONS(5920),
    [anon_sym_PLUS_PLUS] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_DOT_STAR] = ACTIONS(5920),
    [anon_sym_DASH_GT] = ACTIONS(5920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5920),
    [anon_sym_decltype] = ACTIONS(5920),
    [anon_sym_final] = ACTIONS(5920),
    [anon_sym_override] = ACTIONS(5920),
    [anon_sym_requires] = ACTIONS(5920),
  },
  [1945] = {
    [sym_identifier] = ACTIONS(5625),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5627),
    [anon_sym_COMMA] = ACTIONS(5627),
    [anon_sym_RPAREN] = ACTIONS(5627),
    [aux_sym_preproc_if_token2] = ACTIONS(5627),
    [aux_sym_preproc_else_token1] = ACTIONS(5627),
    [aux_sym_preproc_elif_token1] = ACTIONS(5625),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5627),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5627),
    [anon_sym_DASH] = ACTIONS(5625),
    [anon_sym_PLUS] = ACTIONS(5625),
    [anon_sym_STAR] = ACTIONS(5625),
    [anon_sym_SLASH] = ACTIONS(5625),
    [anon_sym_PERCENT] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5627),
    [anon_sym_PIPE] = ACTIONS(5625),
    [anon_sym_CARET] = ACTIONS(5625),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_EQ_EQ] = ACTIONS(5627),
    [anon_sym_BANG_EQ] = ACTIONS(5627),
    [anon_sym_GT] = ACTIONS(5625),
    [anon_sym_GT_EQ] = ACTIONS(5627),
    [anon_sym_LT_EQ] = ACTIONS(5625),
    [anon_sym_LT] = ACTIONS(5625),
    [anon_sym_LT_LT] = ACTIONS(5625),
    [anon_sym_GT_GT] = ACTIONS(5625),
    [anon_sym_SEMI] = ACTIONS(5627),
    [anon_sym___attribute__] = ACTIONS(5625),
    [anon_sym___attribute] = ACTIONS(5625),
    [anon_sym_COLON] = ACTIONS(5625),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5627),
    [anon_sym_RBRACE] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(5627),
    [anon_sym_RBRACK] = ACTIONS(5627),
    [anon_sym_EQ] = ACTIONS(5625),
    [anon_sym_QMARK] = ACTIONS(5627),
    [anon_sym_STAR_EQ] = ACTIONS(5627),
    [anon_sym_SLASH_EQ] = ACTIONS(5627),
    [anon_sym_PERCENT_EQ] = ACTIONS(5627),
    [anon_sym_PLUS_EQ] = ACTIONS(5627),
    [anon_sym_DASH_EQ] = ACTIONS(5627),
    [anon_sym_LT_LT_EQ] = ACTIONS(5627),
    [anon_sym_GT_GT_EQ] = ACTIONS(5627),
    [anon_sym_AMP_EQ] = ACTIONS(5627),
    [anon_sym_CARET_EQ] = ACTIONS(5627),
    [anon_sym_PIPE_EQ] = ACTIONS(5627),
    [anon_sym_and_eq] = ACTIONS(5625),
    [anon_sym_or_eq] = ACTIONS(5625),
    [anon_sym_xor_eq] = ACTIONS(5625),
    [anon_sym_LT_EQ_GT] = ACTIONS(5627),
    [anon_sym_or] = ACTIONS(5625),
    [anon_sym_and] = ACTIONS(5625),
    [anon_sym_bitor] = ACTIONS(5625),
    [anon_sym_xor] = ACTIONS(5625),
    [anon_sym_bitand] = ACTIONS(5625),
    [anon_sym_not_eq] = ACTIONS(5625),
    [anon_sym_DASH_DASH] = ACTIONS(5627),
    [anon_sym_PLUS_PLUS] = ACTIONS(5627),
    [anon_sym_DOT] = ACTIONS(5625),
    [anon_sym_DOT_STAR] = ACTIONS(5627),
    [anon_sym_DASH_GT] = ACTIONS(5627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5625),
    [anon_sym_decltype] = ACTIONS(5625),
    [anon_sym_final] = ACTIONS(5625),
    [anon_sym_override] = ACTIONS(5625),
  },
  [1946] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_LPAREN2] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_STAR] = ACTIONS(5926),
    [anon_sym_SLASH] = ACTIONS(5928),
    [anon_sym_PERCENT] = ACTIONS(5926),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5926),
    [anon_sym_PIPE] = ACTIONS(5928),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5928),
    [anon_sym_EQ_EQ] = ACTIONS(5926),
    [anon_sym_BANG_EQ] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5928),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_LT] = ACTIONS(5928),
    [anon_sym_LT_LT] = ACTIONS(5926),
    [anon_sym_GT_GT] = ACTIONS(5926),
    [anon_sym_SEMI] = ACTIONS(5926),
    [anon_sym___extension__] = ACTIONS(5926),
    [anon_sym___attribute__] = ACTIONS(5926),
    [anon_sym___attribute] = ACTIONS(5928),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_LBRACE] = ACTIONS(5926),
    [anon_sym_RBRACE] = ACTIONS(5926),
    [anon_sym_signed] = ACTIONS(5892),
    [anon_sym_unsigned] = ACTIONS(5892),
    [anon_sym_long] = ACTIONS(5892),
    [anon_sym_short] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_RBRACK] = ACTIONS(5926),
    [anon_sym_const] = ACTIONS(5928),
    [anon_sym_constexpr] = ACTIONS(5926),
    [anon_sym_volatile] = ACTIONS(5926),
    [anon_sym_restrict] = ACTIONS(5926),
    [anon_sym___restrict__] = ACTIONS(5926),
    [anon_sym__Atomic] = ACTIONS(5926),
    [anon_sym__Noreturn] = ACTIONS(5926),
    [anon_sym_noreturn] = ACTIONS(5926),
    [anon_sym__Nonnull] = ACTIONS(5926),
    [anon_sym_mutable] = ACTIONS(5926),
    [anon_sym_constinit] = ACTIONS(5926),
    [anon_sym_consteval] = ACTIONS(5926),
    [anon_sym_alignas] = ACTIONS(5926),
    [anon_sym__Alignas] = ACTIONS(5926),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_or] = ACTIONS(5926),
    [anon_sym_and] = ACTIONS(5926),
    [anon_sym_bitor] = ACTIONS(5926),
    [anon_sym_xor] = ACTIONS(5926),
    [anon_sym_bitand] = ACTIONS(5926),
    [anon_sym_not_eq] = ACTIONS(5926),
    [anon_sym_DASH_DASH] = ACTIONS(5926),
    [anon_sym_PLUS_PLUS] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_DOT_STAR] = ACTIONS(5926),
    [anon_sym_DASH_GT] = ACTIONS(5926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5926),
    [anon_sym_decltype] = ACTIONS(5926),
    [anon_sym_final] = ACTIONS(5926),
    [anon_sym_override] = ACTIONS(5926),
    [anon_sym_requires] = ACTIONS(5926),
  },
  [1947] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym___extension__] = ACTIONS(5452),
    [anon_sym___attribute__] = ACTIONS(5452),
    [anon_sym___attribute] = ACTIONS(5450),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_signed] = ACTIONS(5886),
    [anon_sym_unsigned] = ACTIONS(5886),
    [anon_sym_long] = ACTIONS(5886),
    [anon_sym_short] = ACTIONS(5886),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_const] = ACTIONS(5450),
    [anon_sym_constexpr] = ACTIONS(5452),
    [anon_sym_volatile] = ACTIONS(5452),
    [anon_sym_restrict] = ACTIONS(5452),
    [anon_sym___restrict__] = ACTIONS(5452),
    [anon_sym__Atomic] = ACTIONS(5452),
    [anon_sym__Noreturn] = ACTIONS(5452),
    [anon_sym_noreturn] = ACTIONS(5452),
    [anon_sym__Nonnull] = ACTIONS(5452),
    [anon_sym_mutable] = ACTIONS(5452),
    [anon_sym_constinit] = ACTIONS(5452),
    [anon_sym_consteval] = ACTIONS(5452),
    [anon_sym_alignas] = ACTIONS(5452),
    [anon_sym__Alignas] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_bitor] = ACTIONS(5452),
    [anon_sym_xor] = ACTIONS(5452),
    [anon_sym_bitand] = ACTIONS(5452),
    [anon_sym_not_eq] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5452),
    [anon_sym_decltype] = ACTIONS(5452),
    [anon_sym_final] = ACTIONS(5452),
    [anon_sym_override] = ACTIONS(5452),
    [anon_sym_requires] = ACTIONS(5452),
  },
  [1948] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_RPAREN] = ACTIONS(5930),
    [anon_sym_LPAREN2] = ACTIONS(5930),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_PLUS] = ACTIONS(5932),
    [anon_sym_STAR] = ACTIONS(5930),
    [anon_sym_SLASH] = ACTIONS(5932),
    [anon_sym_PERCENT] = ACTIONS(5930),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_AMP_AMP] = ACTIONS(5930),
    [anon_sym_PIPE] = ACTIONS(5932),
    [anon_sym_CARET] = ACTIONS(5930),
    [anon_sym_AMP] = ACTIONS(5932),
    [anon_sym_EQ_EQ] = ACTIONS(5930),
    [anon_sym_BANG_EQ] = ACTIONS(5930),
    [anon_sym_GT] = ACTIONS(5932),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_LT] = ACTIONS(5932),
    [anon_sym_LT_LT] = ACTIONS(5930),
    [anon_sym_GT_GT] = ACTIONS(5930),
    [anon_sym_SEMI] = ACTIONS(5930),
    [anon_sym___extension__] = ACTIONS(5930),
    [anon_sym___attribute__] = ACTIONS(5930),
    [anon_sym___attribute] = ACTIONS(5932),
    [anon_sym_COLON] = ACTIONS(5930),
    [anon_sym_LBRACE] = ACTIONS(5930),
    [anon_sym_RBRACE] = ACTIONS(5930),
    [anon_sym_signed] = ACTIONS(5934),
    [anon_sym_unsigned] = ACTIONS(5934),
    [anon_sym_long] = ACTIONS(5934),
    [anon_sym_short] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5930),
    [anon_sym_RBRACK] = ACTIONS(5930),
    [anon_sym_const] = ACTIONS(5932),
    [anon_sym_constexpr] = ACTIONS(5930),
    [anon_sym_volatile] = ACTIONS(5930),
    [anon_sym_restrict] = ACTIONS(5930),
    [anon_sym___restrict__] = ACTIONS(5930),
    [anon_sym__Atomic] = ACTIONS(5930),
    [anon_sym__Noreturn] = ACTIONS(5930),
    [anon_sym_noreturn] = ACTIONS(5930),
    [anon_sym__Nonnull] = ACTIONS(5930),
    [anon_sym_mutable] = ACTIONS(5930),
    [anon_sym_constinit] = ACTIONS(5930),
    [anon_sym_consteval] = ACTIONS(5930),
    [anon_sym_alignas] = ACTIONS(5930),
    [anon_sym__Alignas] = ACTIONS(5930),
    [anon_sym_QMARK] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_or] = ACTIONS(5930),
    [anon_sym_and] = ACTIONS(5930),
    [anon_sym_bitor] = ACTIONS(5930),
    [anon_sym_xor] = ACTIONS(5930),
    [anon_sym_bitand] = ACTIONS(5930),
    [anon_sym_not_eq] = ACTIONS(5930),
    [anon_sym_DASH_DASH] = ACTIONS(5930),
    [anon_sym_PLUS_PLUS] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_DOT_STAR] = ACTIONS(5930),
    [anon_sym_DASH_GT] = ACTIONS(5930),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5930),
    [anon_sym_decltype] = ACTIONS(5930),
    [anon_sym_final] = ACTIONS(5930),
    [anon_sym_override] = ACTIONS(5930),
    [anon_sym_requires] = ACTIONS(5930),
  },
  [1949] = {
    [sym_identifier] = ACTIONS(1936),
    [aux_sym_preproc_def_token1] = ACTIONS(1936),
    [aux_sym_preproc_if_token1] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1936),
    [sym_preproc_directive] = ACTIONS(1936),
    [anon_sym_LPAREN2] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(1934),
    [anon_sym_AMP_AMP] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym___extension__] = ACTIONS(1936),
    [anon_sym_typedef] = ACTIONS(1936),
    [anon_sym_virtual] = ACTIONS(1936),
    [anon_sym_extern] = ACTIONS(1936),
    [anon_sym___attribute__] = ACTIONS(1936),
    [anon_sym___attribute] = ACTIONS(1936),
    [anon_sym_using] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(1934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1934),
    [anon_sym___declspec] = ACTIONS(1936),
    [anon_sym___based] = ACTIONS(1936),
    [anon_sym_RBRACE] = ACTIONS(1934),
    [anon_sym_signed] = ACTIONS(1936),
    [anon_sym_unsigned] = ACTIONS(1936),
    [anon_sym_long] = ACTIONS(1936),
    [anon_sym_short] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_register] = ACTIONS(1936),
    [anon_sym_inline] = ACTIONS(1936),
    [anon_sym___inline] = ACTIONS(1936),
    [anon_sym___inline__] = ACTIONS(1936),
    [anon_sym___forceinline] = ACTIONS(1936),
    [anon_sym_thread_local] = ACTIONS(1936),
    [anon_sym___thread] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_constexpr] = ACTIONS(1936),
    [anon_sym_volatile] = ACTIONS(1936),
    [anon_sym_restrict] = ACTIONS(1936),
    [anon_sym___restrict__] = ACTIONS(1936),
    [anon_sym__Atomic] = ACTIONS(1936),
    [anon_sym__Noreturn] = ACTIONS(1936),
    [anon_sym_noreturn] = ACTIONS(1936),
    [anon_sym__Nonnull] = ACTIONS(1936),
    [anon_sym_mutable] = ACTIONS(1936),
    [anon_sym_constinit] = ACTIONS(1936),
    [anon_sym_consteval] = ACTIONS(1936),
    [anon_sym_alignas] = ACTIONS(1936),
    [anon_sym__Alignas] = ACTIONS(1936),
    [sym_primitive_type] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_struct] = ACTIONS(1936),
    [anon_sym_union] = ACTIONS(1936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1936),
    [anon_sym_decltype] = ACTIONS(1936),
    [anon_sym_explicit] = ACTIONS(1936),
    [anon_sym_typename] = ACTIONS(1936),
    [anon_sym_private] = ACTIONS(1936),
    [anon_sym_template] = ACTIONS(1936),
    [anon_sym_operator] = ACTIONS(1936),
    [anon_sym_friend] = ACTIONS(1936),
    [anon_sym_public] = ACTIONS(1936),
    [anon_sym_protected] = ACTIONS(1936),
    [anon_sym_static_assert] = ACTIONS(1936),
    [anon_sym_catch] = ACTIONS(1936),
  },
  [1950] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5936),
    [anon_sym_COMMA] = ACTIONS(5936),
    [anon_sym_RPAREN] = ACTIONS(5936),
    [anon_sym_LPAREN2] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_STAR] = ACTIONS(5936),
    [anon_sym_SLASH] = ACTIONS(5938),
    [anon_sym_PERCENT] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5936),
    [anon_sym_AMP_AMP] = ACTIONS(5936),
    [anon_sym_PIPE] = ACTIONS(5938),
    [anon_sym_CARET] = ACTIONS(5936),
    [anon_sym_AMP] = ACTIONS(5938),
    [anon_sym_EQ_EQ] = ACTIONS(5936),
    [anon_sym_BANG_EQ] = ACTIONS(5936),
    [anon_sym_GT] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5938),
    [anon_sym_LT_LT] = ACTIONS(5936),
    [anon_sym_GT_GT] = ACTIONS(5936),
    [anon_sym_SEMI] = ACTIONS(5936),
    [anon_sym___extension__] = ACTIONS(5936),
    [anon_sym___attribute__] = ACTIONS(5936),
    [anon_sym___attribute] = ACTIONS(5938),
    [anon_sym_COLON] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(5936),
    [anon_sym_RBRACE] = ACTIONS(5936),
    [anon_sym_signed] = ACTIONS(5940),
    [anon_sym_unsigned] = ACTIONS(5940),
    [anon_sym_long] = ACTIONS(5940),
    [anon_sym_short] = ACTIONS(5940),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_RBRACK] = ACTIONS(5936),
    [anon_sym_const] = ACTIONS(5938),
    [anon_sym_constexpr] = ACTIONS(5936),
    [anon_sym_volatile] = ACTIONS(5936),
    [anon_sym_restrict] = ACTIONS(5936),
    [anon_sym___restrict__] = ACTIONS(5936),
    [anon_sym__Atomic] = ACTIONS(5936),
    [anon_sym__Noreturn] = ACTIONS(5936),
    [anon_sym_noreturn] = ACTIONS(5936),
    [anon_sym__Nonnull] = ACTIONS(5936),
    [anon_sym_mutable] = ACTIONS(5936),
    [anon_sym_constinit] = ACTIONS(5936),
    [anon_sym_consteval] = ACTIONS(5936),
    [anon_sym_alignas] = ACTIONS(5936),
    [anon_sym__Alignas] = ACTIONS(5936),
    [anon_sym_QMARK] = ACTIONS(5936),
    [anon_sym_LT_EQ_GT] = ACTIONS(5936),
    [anon_sym_or] = ACTIONS(5936),
    [anon_sym_and] = ACTIONS(5936),
    [anon_sym_bitor] = ACTIONS(5936),
    [anon_sym_xor] = ACTIONS(5936),
    [anon_sym_bitand] = ACTIONS(5936),
    [anon_sym_not_eq] = ACTIONS(5936),
    [anon_sym_DASH_DASH] = ACTIONS(5936),
    [anon_sym_PLUS_PLUS] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5938),
    [anon_sym_DOT_STAR] = ACTIONS(5936),
    [anon_sym_DASH_GT] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5936),
    [anon_sym_decltype] = ACTIONS(5936),
    [anon_sym_final] = ACTIONS(5936),
    [anon_sym_override] = ACTIONS(5936),
    [anon_sym_requires] = ACTIONS(5936),
  },
  [1951] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_RPAREN] = ACTIONS(5942),
    [anon_sym_LPAREN2] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5944),
    [anon_sym_PLUS] = ACTIONS(5944),
    [anon_sym_STAR] = ACTIONS(5942),
    [anon_sym_SLASH] = ACTIONS(5944),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_AMP_AMP] = ACTIONS(5942),
    [anon_sym_PIPE] = ACTIONS(5944),
    [anon_sym_CARET] = ACTIONS(5942),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_EQ_EQ] = ACTIONS(5942),
    [anon_sym_BANG_EQ] = ACTIONS(5942),
    [anon_sym_GT] = ACTIONS(5944),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_LT_EQ] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5942),
    [anon_sym_GT_GT] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(5942),
    [anon_sym___extension__] = ACTIONS(5942),
    [anon_sym___attribute__] = ACTIONS(5942),
    [anon_sym___attribute] = ACTIONS(5944),
    [anon_sym_COLON] = ACTIONS(5942),
    [anon_sym_LBRACE] = ACTIONS(5942),
    [anon_sym_RBRACE] = ACTIONS(5942),
    [anon_sym_signed] = ACTIONS(5892),
    [anon_sym_unsigned] = ACTIONS(5892),
    [anon_sym_long] = ACTIONS(5892),
    [anon_sym_short] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5942),
    [anon_sym_RBRACK] = ACTIONS(5942),
    [anon_sym_const] = ACTIONS(5944),
    [anon_sym_constexpr] = ACTIONS(5942),
    [anon_sym_volatile] = ACTIONS(5942),
    [anon_sym_restrict] = ACTIONS(5942),
    [anon_sym___restrict__] = ACTIONS(5942),
    [anon_sym__Atomic] = ACTIONS(5942),
    [anon_sym__Noreturn] = ACTIONS(5942),
    [anon_sym_noreturn] = ACTIONS(5942),
    [anon_sym__Nonnull] = ACTIONS(5942),
    [anon_sym_mutable] = ACTIONS(5942),
    [anon_sym_constinit] = ACTIONS(5942),
    [anon_sym_consteval] = ACTIONS(5942),
    [anon_sym_alignas] = ACTIONS(5942),
    [anon_sym__Alignas] = ACTIONS(5942),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_or] = ACTIONS(5942),
    [anon_sym_and] = ACTIONS(5942),
    [anon_sym_bitor] = ACTIONS(5942),
    [anon_sym_xor] = ACTIONS(5942),
    [anon_sym_bitand] = ACTIONS(5942),
    [anon_sym_not_eq] = ACTIONS(5942),
    [anon_sym_DASH_DASH] = ACTIONS(5942),
    [anon_sym_PLUS_PLUS] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5944),
    [anon_sym_DOT_STAR] = ACTIONS(5942),
    [anon_sym_DASH_GT] = ACTIONS(5942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5942),
    [anon_sym_decltype] = ACTIONS(5942),
    [anon_sym_final] = ACTIONS(5942),
    [anon_sym_override] = ACTIONS(5942),
    [anon_sym_requires] = ACTIONS(5942),
  },
  [1952] = {
    [sym_identifier] = ACTIONS(2791),
    [aux_sym_preproc_def_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token1] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2791),
    [sym_preproc_directive] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2793),
    [anon_sym_TILDE] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym___extension__] = ACTIONS(2791),
    [anon_sym_typedef] = ACTIONS(2791),
    [anon_sym_virtual] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym___attribute__] = ACTIONS(2791),
    [anon_sym___attribute] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2793),
    [anon_sym___declspec] = ACTIONS(2791),
    [anon_sym___based] = ACTIONS(2791),
    [anon_sym_RBRACE] = ACTIONS(2793),
    [anon_sym_signed] = ACTIONS(2791),
    [anon_sym_unsigned] = ACTIONS(2791),
    [anon_sym_long] = ACTIONS(2791),
    [anon_sym_short] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_register] = ACTIONS(2791),
    [anon_sym_inline] = ACTIONS(2791),
    [anon_sym___inline] = ACTIONS(2791),
    [anon_sym___inline__] = ACTIONS(2791),
    [anon_sym___forceinline] = ACTIONS(2791),
    [anon_sym_thread_local] = ACTIONS(2791),
    [anon_sym___thread] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_constexpr] = ACTIONS(2791),
    [anon_sym_volatile] = ACTIONS(2791),
    [anon_sym_restrict] = ACTIONS(2791),
    [anon_sym___restrict__] = ACTIONS(2791),
    [anon_sym__Atomic] = ACTIONS(2791),
    [anon_sym__Noreturn] = ACTIONS(2791),
    [anon_sym_noreturn] = ACTIONS(2791),
    [anon_sym__Nonnull] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_constinit] = ACTIONS(2791),
    [anon_sym_consteval] = ACTIONS(2791),
    [anon_sym_alignas] = ACTIONS(2791),
    [anon_sym__Alignas] = ACTIONS(2791),
    [sym_primitive_type] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_class] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2791),
    [anon_sym_decltype] = ACTIONS(2791),
    [anon_sym_explicit] = ACTIONS(2791),
    [anon_sym_typename] = ACTIONS(2791),
    [anon_sym_private] = ACTIONS(2791),
    [anon_sym_template] = ACTIONS(2791),
    [anon_sym_operator] = ACTIONS(2791),
    [anon_sym_friend] = ACTIONS(2791),
    [anon_sym_public] = ACTIONS(2791),
    [anon_sym_protected] = ACTIONS(2791),
    [anon_sym_static_assert] = ACTIONS(2791),
  },
  [1953] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token2] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_private] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_friend] = ACTIONS(2703),
    [anon_sym_public] = ACTIONS(2703),
    [anon_sym_protected] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
  },
  [1954] = {
    [sym_identifier] = ACTIONS(2859),
    [aux_sym_preproc_def_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token2] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2859),
    [sym_preproc_directive] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [anon_sym_STAR] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym___extension__] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2859),
    [anon_sym_virtual] = ACTIONS(2859),
    [anon_sym_extern] = ACTIONS(2859),
    [anon_sym___attribute__] = ACTIONS(2859),
    [anon_sym___attribute] = ACTIONS(2859),
    [anon_sym_using] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2861),
    [anon_sym___declspec] = ACTIONS(2859),
    [anon_sym___based] = ACTIONS(2859),
    [anon_sym_signed] = ACTIONS(2859),
    [anon_sym_unsigned] = ACTIONS(2859),
    [anon_sym_long] = ACTIONS(2859),
    [anon_sym_short] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2859),
    [anon_sym_register] = ACTIONS(2859),
    [anon_sym_inline] = ACTIONS(2859),
    [anon_sym___inline] = ACTIONS(2859),
    [anon_sym___inline__] = ACTIONS(2859),
    [anon_sym___forceinline] = ACTIONS(2859),
    [anon_sym_thread_local] = ACTIONS(2859),
    [anon_sym___thread] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2859),
    [anon_sym_constexpr] = ACTIONS(2859),
    [anon_sym_volatile] = ACTIONS(2859),
    [anon_sym_restrict] = ACTIONS(2859),
    [anon_sym___restrict__] = ACTIONS(2859),
    [anon_sym__Atomic] = ACTIONS(2859),
    [anon_sym__Noreturn] = ACTIONS(2859),
    [anon_sym_noreturn] = ACTIONS(2859),
    [anon_sym__Nonnull] = ACTIONS(2859),
    [anon_sym_mutable] = ACTIONS(2859),
    [anon_sym_constinit] = ACTIONS(2859),
    [anon_sym_consteval] = ACTIONS(2859),
    [anon_sym_alignas] = ACTIONS(2859),
    [anon_sym__Alignas] = ACTIONS(2859),
    [sym_primitive_type] = ACTIONS(2859),
    [anon_sym_enum] = ACTIONS(2859),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2859),
    [anon_sym_union] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2859),
    [anon_sym_decltype] = ACTIONS(2859),
    [anon_sym_explicit] = ACTIONS(2859),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_private] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(2859),
    [anon_sym_operator] = ACTIONS(2859),
    [anon_sym_friend] = ACTIONS(2859),
    [anon_sym_public] = ACTIONS(2859),
    [anon_sym_protected] = ACTIONS(2859),
    [anon_sym_static_assert] = ACTIONS(2859),
  },
  [1955] = {
    [sym_identifier] = ACTIONS(5521),
    [aux_sym_preproc_def_token1] = ACTIONS(5521),
    [aux_sym_preproc_if_token1] = ACTIONS(5521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5521),
    [sym_preproc_directive] = ACTIONS(5521),
    [anon_sym_LPAREN2] = ACTIONS(5523),
    [anon_sym_TILDE] = ACTIONS(5523),
    [anon_sym_STAR] = ACTIONS(5523),
    [anon_sym_AMP_AMP] = ACTIONS(5523),
    [anon_sym_AMP] = ACTIONS(5521),
    [anon_sym_SEMI] = ACTIONS(5523),
    [anon_sym___extension__] = ACTIONS(5521),
    [anon_sym_typedef] = ACTIONS(5521),
    [anon_sym_virtual] = ACTIONS(5521),
    [anon_sym_extern] = ACTIONS(5521),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_using] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5523),
    [anon_sym___declspec] = ACTIONS(5521),
    [anon_sym___based] = ACTIONS(5521),
    [anon_sym_RBRACE] = ACTIONS(5523),
    [anon_sym_signed] = ACTIONS(5521),
    [anon_sym_unsigned] = ACTIONS(5521),
    [anon_sym_long] = ACTIONS(5521),
    [anon_sym_short] = ACTIONS(5521),
    [anon_sym_LBRACK] = ACTIONS(5521),
    [anon_sym_static] = ACTIONS(5521),
    [anon_sym_register] = ACTIONS(5521),
    [anon_sym_inline] = ACTIONS(5521),
    [anon_sym___inline] = ACTIONS(5521),
    [anon_sym___inline__] = ACTIONS(5521),
    [anon_sym___forceinline] = ACTIONS(5521),
    [anon_sym_thread_local] = ACTIONS(5521),
    [anon_sym___thread] = ACTIONS(5521),
    [anon_sym_const] = ACTIONS(5521),
    [anon_sym_constexpr] = ACTIONS(5521),
    [anon_sym_volatile] = ACTIONS(5521),
    [anon_sym_restrict] = ACTIONS(5521),
    [anon_sym___restrict__] = ACTIONS(5521),
    [anon_sym__Atomic] = ACTIONS(5521),
    [anon_sym__Noreturn] = ACTIONS(5521),
    [anon_sym_noreturn] = ACTIONS(5521),
    [anon_sym__Nonnull] = ACTIONS(5521),
    [anon_sym_mutable] = ACTIONS(5521),
    [anon_sym_constinit] = ACTIONS(5521),
    [anon_sym_consteval] = ACTIONS(5521),
    [anon_sym_alignas] = ACTIONS(5521),
    [anon_sym__Alignas] = ACTIONS(5521),
    [sym_primitive_type] = ACTIONS(5521),
    [anon_sym_enum] = ACTIONS(5521),
    [anon_sym_class] = ACTIONS(5521),
    [anon_sym_struct] = ACTIONS(5521),
    [anon_sym_union] = ACTIONS(5521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5521),
    [anon_sym_decltype] = ACTIONS(5521),
    [anon_sym_explicit] = ACTIONS(5521),
    [anon_sym_typename] = ACTIONS(5521),
    [anon_sym_private] = ACTIONS(5521),
    [anon_sym_template] = ACTIONS(5521),
    [anon_sym_operator] = ACTIONS(5521),
    [anon_sym_friend] = ACTIONS(5521),
    [anon_sym_public] = ACTIONS(5521),
    [anon_sym_protected] = ACTIONS(5521),
    [anon_sym_static_assert] = ACTIONS(5521),
  },
  [1956] = {
    [sym_string_literal] = STATE(2189),
    [sym_template_argument_list] = STATE(3094),
    [sym_raw_string_literal] = STATE(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(5946),
    [anon_sym_LPAREN2] = ACTIONS(5946),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5033),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5036),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(5949),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4146),
    [anon_sym_or_eq] = ACTIONS(4146),
    [anon_sym_xor_eq] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4154),
    [anon_sym_L_DQUOTE] = ACTIONS(5040),
    [anon_sym_u_DQUOTE] = ACTIONS(5040),
    [anon_sym_U_DQUOTE] = ACTIONS(5040),
    [anon_sym_u8_DQUOTE] = ACTIONS(5040),
    [anon_sym_DQUOTE] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5042),
    [anon_sym_LR_DQUOTE] = ACTIONS(5042),
    [anon_sym_uR_DQUOTE] = ACTIONS(5042),
    [anon_sym_UR_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5042),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4146),
  },
  [1957] = {
    [sym_identifier] = ACTIONS(5557),
    [aux_sym_preproc_def_token1] = ACTIONS(5557),
    [aux_sym_preproc_if_token1] = ACTIONS(5557),
    [aux_sym_preproc_if_token2] = ACTIONS(5557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5557),
    [sym_preproc_directive] = ACTIONS(5557),
    [anon_sym_LPAREN2] = ACTIONS(5559),
    [anon_sym_TILDE] = ACTIONS(5559),
    [anon_sym_STAR] = ACTIONS(5559),
    [anon_sym_AMP_AMP] = ACTIONS(5559),
    [anon_sym_AMP] = ACTIONS(5557),
    [anon_sym_SEMI] = ACTIONS(5559),
    [anon_sym___extension__] = ACTIONS(5557),
    [anon_sym_typedef] = ACTIONS(5557),
    [anon_sym_virtual] = ACTIONS(5557),
    [anon_sym_extern] = ACTIONS(5557),
    [anon_sym___attribute__] = ACTIONS(5557),
    [anon_sym___attribute] = ACTIONS(5557),
    [anon_sym_using] = ACTIONS(5557),
    [anon_sym_COLON_COLON] = ACTIONS(5559),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5559),
    [anon_sym___declspec] = ACTIONS(5557),
    [anon_sym___based] = ACTIONS(5557),
    [anon_sym_signed] = ACTIONS(5557),
    [anon_sym_unsigned] = ACTIONS(5557),
    [anon_sym_long] = ACTIONS(5557),
    [anon_sym_short] = ACTIONS(5557),
    [anon_sym_LBRACK] = ACTIONS(5557),
    [anon_sym_static] = ACTIONS(5557),
    [anon_sym_register] = ACTIONS(5557),
    [anon_sym_inline] = ACTIONS(5557),
    [anon_sym___inline] = ACTIONS(5557),
    [anon_sym___inline__] = ACTIONS(5557),
    [anon_sym___forceinline] = ACTIONS(5557),
    [anon_sym_thread_local] = ACTIONS(5557),
    [anon_sym___thread] = ACTIONS(5557),
    [anon_sym_const] = ACTIONS(5557),
    [anon_sym_constexpr] = ACTIONS(5557),
    [anon_sym_volatile] = ACTIONS(5557),
    [anon_sym_restrict] = ACTIONS(5557),
    [anon_sym___restrict__] = ACTIONS(5557),
    [anon_sym__Atomic] = ACTIONS(5557),
    [anon_sym__Noreturn] = ACTIONS(5557),
    [anon_sym_noreturn] = ACTIONS(5557),
    [anon_sym__Nonnull] = ACTIONS(5557),
    [anon_sym_mutable] = ACTIONS(5557),
    [anon_sym_constinit] = ACTIONS(5557),
    [anon_sym_consteval] = ACTIONS(5557),
    [anon_sym_alignas] = ACTIONS(5557),
    [anon_sym__Alignas] = ACTIONS(5557),
    [sym_primitive_type] = ACTIONS(5557),
    [anon_sym_enum] = ACTIONS(5557),
    [anon_sym_class] = ACTIONS(5557),
    [anon_sym_struct] = ACTIONS(5557),
    [anon_sym_union] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5557),
    [anon_sym_decltype] = ACTIONS(5557),
    [anon_sym_explicit] = ACTIONS(5557),
    [anon_sym_typename] = ACTIONS(5557),
    [anon_sym_private] = ACTIONS(5557),
    [anon_sym_template] = ACTIONS(5557),
    [anon_sym_operator] = ACTIONS(5557),
    [anon_sym_friend] = ACTIONS(5557),
    [anon_sym_public] = ACTIONS(5557),
    [anon_sym_protected] = ACTIONS(5557),
    [anon_sym_static_assert] = ACTIONS(5557),
  },
  [1958] = {
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token2] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_private] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_friend] = ACTIONS(2759),
    [anon_sym_public] = ACTIONS(2759),
    [anon_sym_protected] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
  },
  [1959] = {
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym___attribute] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym_RBRACE] = ACTIONS(3110),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym__Nonnull] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym__Alignas] = ACTIONS(3108),
    [sym_primitive_type] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_private] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_friend] = ACTIONS(3108),
    [anon_sym_public] = ACTIONS(3108),
    [anon_sym_protected] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
  },
  [1960] = {
    [sym_identifier] = ACTIONS(5456),
    [aux_sym_preproc_def_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5456),
    [sym_preproc_directive] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5458),
    [anon_sym_TILDE] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5458),
    [anon_sym___extension__] = ACTIONS(5456),
    [anon_sym_typedef] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym___attribute__] = ACTIONS(5456),
    [anon_sym___attribute] = ACTIONS(5456),
    [anon_sym_using] = ACTIONS(5456),
    [anon_sym_COLON_COLON] = ACTIONS(5458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5458),
    [anon_sym___declspec] = ACTIONS(5456),
    [anon_sym___based] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5458),
    [anon_sym_signed] = ACTIONS(5456),
    [anon_sym_unsigned] = ACTIONS(5456),
    [anon_sym_long] = ACTIONS(5456),
    [anon_sym_short] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_register] = ACTIONS(5456),
    [anon_sym_inline] = ACTIONS(5456),
    [anon_sym___inline] = ACTIONS(5456),
    [anon_sym___inline__] = ACTIONS(5456),
    [anon_sym___forceinline] = ACTIONS(5456),
    [anon_sym_thread_local] = ACTIONS(5456),
    [anon_sym___thread] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_constexpr] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_restrict] = ACTIONS(5456),
    [anon_sym___restrict__] = ACTIONS(5456),
    [anon_sym__Atomic] = ACTIONS(5456),
    [anon_sym__Noreturn] = ACTIONS(5456),
    [anon_sym_noreturn] = ACTIONS(5456),
    [anon_sym__Nonnull] = ACTIONS(5456),
    [anon_sym_mutable] = ACTIONS(5456),
    [anon_sym_constinit] = ACTIONS(5456),
    [anon_sym_consteval] = ACTIONS(5456),
    [anon_sym_alignas] = ACTIONS(5456),
    [anon_sym__Alignas] = ACTIONS(5456),
    [sym_primitive_type] = ACTIONS(5456),
    [anon_sym_enum] = ACTIONS(5456),
    [anon_sym_class] = ACTIONS(5456),
    [anon_sym_struct] = ACTIONS(5456),
    [anon_sym_union] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5456),
    [anon_sym_decltype] = ACTIONS(5456),
    [anon_sym_explicit] = ACTIONS(5456),
    [anon_sym_typename] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_template] = ACTIONS(5456),
    [anon_sym_operator] = ACTIONS(5456),
    [anon_sym_friend] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_static_assert] = ACTIONS(5456),
  },
  [1961] = {
    [sym_identifier] = ACTIONS(5456),
    [aux_sym_preproc_def_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5456),
    [sym_preproc_directive] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5458),
    [anon_sym_TILDE] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5458),
    [anon_sym___extension__] = ACTIONS(5456),
    [anon_sym_typedef] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym___attribute__] = ACTIONS(5456),
    [anon_sym___attribute] = ACTIONS(5456),
    [anon_sym_using] = ACTIONS(5456),
    [anon_sym_COLON_COLON] = ACTIONS(5458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5458),
    [anon_sym___declspec] = ACTIONS(5456),
    [anon_sym___based] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5458),
    [anon_sym_signed] = ACTIONS(5456),
    [anon_sym_unsigned] = ACTIONS(5456),
    [anon_sym_long] = ACTIONS(5456),
    [anon_sym_short] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_register] = ACTIONS(5456),
    [anon_sym_inline] = ACTIONS(5456),
    [anon_sym___inline] = ACTIONS(5456),
    [anon_sym___inline__] = ACTIONS(5456),
    [anon_sym___forceinline] = ACTIONS(5456),
    [anon_sym_thread_local] = ACTIONS(5456),
    [anon_sym___thread] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_constexpr] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_restrict] = ACTIONS(5456),
    [anon_sym___restrict__] = ACTIONS(5456),
    [anon_sym__Atomic] = ACTIONS(5456),
    [anon_sym__Noreturn] = ACTIONS(5456),
    [anon_sym_noreturn] = ACTIONS(5456),
    [anon_sym__Nonnull] = ACTIONS(5456),
    [anon_sym_mutable] = ACTIONS(5456),
    [anon_sym_constinit] = ACTIONS(5456),
    [anon_sym_consteval] = ACTIONS(5456),
    [anon_sym_alignas] = ACTIONS(5456),
    [anon_sym__Alignas] = ACTIONS(5456),
    [sym_primitive_type] = ACTIONS(5456),
    [anon_sym_enum] = ACTIONS(5456),
    [anon_sym_class] = ACTIONS(5456),
    [anon_sym_struct] = ACTIONS(5456),
    [anon_sym_union] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5456),
    [anon_sym_decltype] = ACTIONS(5456),
    [anon_sym_explicit] = ACTIONS(5456),
    [anon_sym_typename] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_template] = ACTIONS(5456),
    [anon_sym_operator] = ACTIONS(5456),
    [anon_sym_friend] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_static_assert] = ACTIONS(5456),
  },
  [1962] = {
    [sym_identifier] = ACTIONS(5456),
    [aux_sym_preproc_def_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5456),
    [sym_preproc_directive] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5458),
    [anon_sym_TILDE] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5458),
    [anon_sym___extension__] = ACTIONS(5456),
    [anon_sym_typedef] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym___attribute__] = ACTIONS(5456),
    [anon_sym___attribute] = ACTIONS(5456),
    [anon_sym_using] = ACTIONS(5456),
    [anon_sym_COLON_COLON] = ACTIONS(5458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5458),
    [anon_sym___declspec] = ACTIONS(5456),
    [anon_sym___based] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5458),
    [anon_sym_signed] = ACTIONS(5456),
    [anon_sym_unsigned] = ACTIONS(5456),
    [anon_sym_long] = ACTIONS(5456),
    [anon_sym_short] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_register] = ACTIONS(5456),
    [anon_sym_inline] = ACTIONS(5456),
    [anon_sym___inline] = ACTIONS(5456),
    [anon_sym___inline__] = ACTIONS(5456),
    [anon_sym___forceinline] = ACTIONS(5456),
    [anon_sym_thread_local] = ACTIONS(5456),
    [anon_sym___thread] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_constexpr] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_restrict] = ACTIONS(5456),
    [anon_sym___restrict__] = ACTIONS(5456),
    [anon_sym__Atomic] = ACTIONS(5456),
    [anon_sym__Noreturn] = ACTIONS(5456),
    [anon_sym_noreturn] = ACTIONS(5456),
    [anon_sym__Nonnull] = ACTIONS(5456),
    [anon_sym_mutable] = ACTIONS(5456),
    [anon_sym_constinit] = ACTIONS(5456),
    [anon_sym_consteval] = ACTIONS(5456),
    [anon_sym_alignas] = ACTIONS(5456),
    [anon_sym__Alignas] = ACTIONS(5456),
    [sym_primitive_type] = ACTIONS(5456),
    [anon_sym_enum] = ACTIONS(5456),
    [anon_sym_class] = ACTIONS(5456),
    [anon_sym_struct] = ACTIONS(5456),
    [anon_sym_union] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5456),
    [anon_sym_decltype] = ACTIONS(5456),
    [anon_sym_explicit] = ACTIONS(5456),
    [anon_sym_typename] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_template] = ACTIONS(5456),
    [anon_sym_operator] = ACTIONS(5456),
    [anon_sym_friend] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_static_assert] = ACTIONS(5456),
  },
  [1963] = {
    [sym_identifier] = ACTIONS(5597),
    [aux_sym_preproc_def_token1] = ACTIONS(5597),
    [aux_sym_preproc_if_token1] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5597),
    [sym_preproc_directive] = ACTIONS(5597),
    [anon_sym_LPAREN2] = ACTIONS(5599),
    [anon_sym_TILDE] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(5599),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5599),
    [anon_sym___extension__] = ACTIONS(5597),
    [anon_sym_typedef] = ACTIONS(5597),
    [anon_sym_virtual] = ACTIONS(5597),
    [anon_sym_extern] = ACTIONS(5597),
    [anon_sym___attribute__] = ACTIONS(5597),
    [anon_sym___attribute] = ACTIONS(5597),
    [anon_sym_using] = ACTIONS(5597),
    [anon_sym_COLON_COLON] = ACTIONS(5599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5599),
    [anon_sym___declspec] = ACTIONS(5597),
    [anon_sym___based] = ACTIONS(5597),
    [anon_sym_RBRACE] = ACTIONS(5599),
    [anon_sym_signed] = ACTIONS(5597),
    [anon_sym_unsigned] = ACTIONS(5597),
    [anon_sym_long] = ACTIONS(5597),
    [anon_sym_short] = ACTIONS(5597),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [anon_sym_static] = ACTIONS(5597),
    [anon_sym_register] = ACTIONS(5597),
    [anon_sym_inline] = ACTIONS(5597),
    [anon_sym___inline] = ACTIONS(5597),
    [anon_sym___inline__] = ACTIONS(5597),
    [anon_sym___forceinline] = ACTIONS(5597),
    [anon_sym_thread_local] = ACTIONS(5597),
    [anon_sym___thread] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5597),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym___restrict__] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym__Noreturn] = ACTIONS(5597),
    [anon_sym_noreturn] = ACTIONS(5597),
    [anon_sym__Nonnull] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_constinit] = ACTIONS(5597),
    [anon_sym_consteval] = ACTIONS(5597),
    [anon_sym_alignas] = ACTIONS(5597),
    [anon_sym__Alignas] = ACTIONS(5597),
    [sym_primitive_type] = ACTIONS(5597),
    [anon_sym_enum] = ACTIONS(5597),
    [anon_sym_class] = ACTIONS(5597),
    [anon_sym_struct] = ACTIONS(5597),
    [anon_sym_union] = ACTIONS(5597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_decltype] = ACTIONS(5597),
    [anon_sym_explicit] = ACTIONS(5597),
    [anon_sym_typename] = ACTIONS(5597),
    [anon_sym_private] = ACTIONS(5597),
    [anon_sym_template] = ACTIONS(5597),
    [anon_sym_operator] = ACTIONS(5597),
    [anon_sym_friend] = ACTIONS(5597),
    [anon_sym_public] = ACTIONS(5597),
    [anon_sym_protected] = ACTIONS(5597),
    [anon_sym_static_assert] = ACTIONS(5597),
  },
  [1964] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym_RBRACE] = ACTIONS(3106),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_private] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_friend] = ACTIONS(3104),
    [anon_sym_public] = ACTIONS(3104),
    [anon_sym_protected] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
  },
  [1965] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(2767),
    [anon_sym_public] = ACTIONS(2767),
    [anon_sym_protected] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
  },
  [1966] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(2767),
    [anon_sym_public] = ACTIONS(2767),
    [anon_sym_protected] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
  },
  [1967] = {
    [sym_identifier] = ACTIONS(5549),
    [aux_sym_preproc_def_token1] = ACTIONS(5549),
    [aux_sym_preproc_if_token1] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5549),
    [sym_preproc_directive] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(5551),
    [anon_sym_TILDE] = ACTIONS(5551),
    [anon_sym_STAR] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5549),
    [anon_sym_SEMI] = ACTIONS(5551),
    [anon_sym___extension__] = ACTIONS(5549),
    [anon_sym_typedef] = ACTIONS(5549),
    [anon_sym_virtual] = ACTIONS(5549),
    [anon_sym_extern] = ACTIONS(5549),
    [anon_sym___attribute__] = ACTIONS(5549),
    [anon_sym___attribute] = ACTIONS(5549),
    [anon_sym_using] = ACTIONS(5549),
    [anon_sym_COLON_COLON] = ACTIONS(5551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5551),
    [anon_sym___declspec] = ACTIONS(5549),
    [anon_sym___based] = ACTIONS(5549),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [anon_sym_signed] = ACTIONS(5549),
    [anon_sym_unsigned] = ACTIONS(5549),
    [anon_sym_long] = ACTIONS(5549),
    [anon_sym_short] = ACTIONS(5549),
    [anon_sym_LBRACK] = ACTIONS(5549),
    [anon_sym_static] = ACTIONS(5549),
    [anon_sym_register] = ACTIONS(5549),
    [anon_sym_inline] = ACTIONS(5549),
    [anon_sym___inline] = ACTIONS(5549),
    [anon_sym___inline__] = ACTIONS(5549),
    [anon_sym___forceinline] = ACTIONS(5549),
    [anon_sym_thread_local] = ACTIONS(5549),
    [anon_sym___thread] = ACTIONS(5549),
    [anon_sym_const] = ACTIONS(5549),
    [anon_sym_constexpr] = ACTIONS(5549),
    [anon_sym_volatile] = ACTIONS(5549),
    [anon_sym_restrict] = ACTIONS(5549),
    [anon_sym___restrict__] = ACTIONS(5549),
    [anon_sym__Atomic] = ACTIONS(5549),
    [anon_sym__Noreturn] = ACTIONS(5549),
    [anon_sym_noreturn] = ACTIONS(5549),
    [anon_sym__Nonnull] = ACTIONS(5549),
    [anon_sym_mutable] = ACTIONS(5549),
    [anon_sym_constinit] = ACTIONS(5549),
    [anon_sym_consteval] = ACTIONS(5549),
    [anon_sym_alignas] = ACTIONS(5549),
    [anon_sym__Alignas] = ACTIONS(5549),
    [sym_primitive_type] = ACTIONS(5549),
    [anon_sym_enum] = ACTIONS(5549),
    [anon_sym_class] = ACTIONS(5549),
    [anon_sym_struct] = ACTIONS(5549),
    [anon_sym_union] = ACTIONS(5549),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5549),
    [anon_sym_decltype] = ACTIONS(5549),
    [anon_sym_explicit] = ACTIONS(5549),
    [anon_sym_typename] = ACTIONS(5549),
    [anon_sym_private] = ACTIONS(5549),
    [anon_sym_template] = ACTIONS(5549),
    [anon_sym_operator] = ACTIONS(5549),
    [anon_sym_friend] = ACTIONS(5549),
    [anon_sym_public] = ACTIONS(5549),
    [anon_sym_protected] = ACTIONS(5549),
    [anon_sym_static_assert] = ACTIONS(5549),
  },
  [1968] = {
    [sym_identifier] = ACTIONS(2903),
    [aux_sym_preproc_def_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token2] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2903),
    [sym_preproc_directive] = ACTIONS(2903),
    [anon_sym_LPAREN2] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2903),
    [anon_sym_typedef] = ACTIONS(2903),
    [anon_sym_virtual] = ACTIONS(2903),
    [anon_sym_extern] = ACTIONS(2903),
    [anon_sym___attribute__] = ACTIONS(2903),
    [anon_sym___attribute] = ACTIONS(2903),
    [anon_sym_using] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2905),
    [anon_sym___declspec] = ACTIONS(2903),
    [anon_sym___based] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2903),
    [anon_sym_unsigned] = ACTIONS(2903),
    [anon_sym_long] = ACTIONS(2903),
    [anon_sym_short] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_register] = ACTIONS(2903),
    [anon_sym_inline] = ACTIONS(2903),
    [anon_sym___inline] = ACTIONS(2903),
    [anon_sym___inline__] = ACTIONS(2903),
    [anon_sym___forceinline] = ACTIONS(2903),
    [anon_sym_thread_local] = ACTIONS(2903),
    [anon_sym___thread] = ACTIONS(2903),
    [anon_sym_const] = ACTIONS(2903),
    [anon_sym_constexpr] = ACTIONS(2903),
    [anon_sym_volatile] = ACTIONS(2903),
    [anon_sym_restrict] = ACTIONS(2903),
    [anon_sym___restrict__] = ACTIONS(2903),
    [anon_sym__Atomic] = ACTIONS(2903),
    [anon_sym__Noreturn] = ACTIONS(2903),
    [anon_sym_noreturn] = ACTIONS(2903),
    [anon_sym__Nonnull] = ACTIONS(2903),
    [anon_sym_mutable] = ACTIONS(2903),
    [anon_sym_constinit] = ACTIONS(2903),
    [anon_sym_consteval] = ACTIONS(2903),
    [anon_sym_alignas] = ACTIONS(2903),
    [anon_sym__Alignas] = ACTIONS(2903),
    [sym_primitive_type] = ACTIONS(2903),
    [anon_sym_enum] = ACTIONS(2903),
    [anon_sym_class] = ACTIONS(2903),
    [anon_sym_struct] = ACTIONS(2903),
    [anon_sym_union] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2903),
    [anon_sym_decltype] = ACTIONS(2903),
    [anon_sym_explicit] = ACTIONS(2903),
    [anon_sym_typename] = ACTIONS(2903),
    [anon_sym_private] = ACTIONS(2903),
    [anon_sym_template] = ACTIONS(2903),
    [anon_sym_operator] = ACTIONS(2903),
    [anon_sym_friend] = ACTIONS(2903),
    [anon_sym_public] = ACTIONS(2903),
    [anon_sym_protected] = ACTIONS(2903),
    [anon_sym_static_assert] = ACTIONS(2903),
  },
  [1969] = {
    [sym_identifier] = ACTIONS(5549),
    [aux_sym_preproc_def_token1] = ACTIONS(5549),
    [aux_sym_preproc_if_token1] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5549),
    [sym_preproc_directive] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(5551),
    [anon_sym_TILDE] = ACTIONS(5551),
    [anon_sym_STAR] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5549),
    [anon_sym_SEMI] = ACTIONS(5551),
    [anon_sym___extension__] = ACTIONS(5549),
    [anon_sym_typedef] = ACTIONS(5549),
    [anon_sym_virtual] = ACTIONS(5549),
    [anon_sym_extern] = ACTIONS(5549),
    [anon_sym___attribute__] = ACTIONS(5549),
    [anon_sym___attribute] = ACTIONS(5549),
    [anon_sym_using] = ACTIONS(5549),
    [anon_sym_COLON_COLON] = ACTIONS(5551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5551),
    [anon_sym___declspec] = ACTIONS(5549),
    [anon_sym___based] = ACTIONS(5549),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [anon_sym_signed] = ACTIONS(5549),
    [anon_sym_unsigned] = ACTIONS(5549),
    [anon_sym_long] = ACTIONS(5549),
    [anon_sym_short] = ACTIONS(5549),
    [anon_sym_LBRACK] = ACTIONS(5549),
    [anon_sym_static] = ACTIONS(5549),
    [anon_sym_register] = ACTIONS(5549),
    [anon_sym_inline] = ACTIONS(5549),
    [anon_sym___inline] = ACTIONS(5549),
    [anon_sym___inline__] = ACTIONS(5549),
    [anon_sym___forceinline] = ACTIONS(5549),
    [anon_sym_thread_local] = ACTIONS(5549),
    [anon_sym___thread] = ACTIONS(5549),
    [anon_sym_const] = ACTIONS(5549),
    [anon_sym_constexpr] = ACTIONS(5549),
    [anon_sym_volatile] = ACTIONS(5549),
    [anon_sym_restrict] = ACTIONS(5549),
    [anon_sym___restrict__] = ACTIONS(5549),
    [anon_sym__Atomic] = ACTIONS(5549),
    [anon_sym__Noreturn] = ACTIONS(5549),
    [anon_sym_noreturn] = ACTIONS(5549),
    [anon_sym__Nonnull] = ACTIONS(5549),
    [anon_sym_mutable] = ACTIONS(5549),
    [anon_sym_constinit] = ACTIONS(5549),
    [anon_sym_consteval] = ACTIONS(5549),
    [anon_sym_alignas] = ACTIONS(5549),
    [anon_sym__Alignas] = ACTIONS(5549),
    [sym_primitive_type] = ACTIONS(5549),
    [anon_sym_enum] = ACTIONS(5549),
    [anon_sym_class] = ACTIONS(5549),
    [anon_sym_struct] = ACTIONS(5549),
    [anon_sym_union] = ACTIONS(5549),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5549),
    [anon_sym_decltype] = ACTIONS(5549),
    [anon_sym_explicit] = ACTIONS(5549),
    [anon_sym_typename] = ACTIONS(5549),
    [anon_sym_private] = ACTIONS(5549),
    [anon_sym_template] = ACTIONS(5549),
    [anon_sym_operator] = ACTIONS(5549),
    [anon_sym_friend] = ACTIONS(5549),
    [anon_sym_public] = ACTIONS(5549),
    [anon_sym_protected] = ACTIONS(5549),
    [anon_sym_static_assert] = ACTIONS(5549),
  },
  [1970] = {
    [sym_identifier] = ACTIONS(5505),
    [aux_sym_preproc_def_token1] = ACTIONS(5505),
    [aux_sym_preproc_if_token1] = ACTIONS(5505),
    [aux_sym_preproc_if_token2] = ACTIONS(5505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5505),
    [sym_preproc_directive] = ACTIONS(5505),
    [anon_sym_LPAREN2] = ACTIONS(5507),
    [anon_sym_TILDE] = ACTIONS(5507),
    [anon_sym_STAR] = ACTIONS(5507),
    [anon_sym_AMP_AMP] = ACTIONS(5507),
    [anon_sym_AMP] = ACTIONS(5505),
    [anon_sym_SEMI] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5505),
    [anon_sym_typedef] = ACTIONS(5505),
    [anon_sym_virtual] = ACTIONS(5505),
    [anon_sym_extern] = ACTIONS(5505),
    [anon_sym___attribute__] = ACTIONS(5505),
    [anon_sym___attribute] = ACTIONS(5505),
    [anon_sym_using] = ACTIONS(5505),
    [anon_sym_COLON_COLON] = ACTIONS(5507),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5507),
    [anon_sym___declspec] = ACTIONS(5505),
    [anon_sym___based] = ACTIONS(5505),
    [anon_sym_signed] = ACTIONS(5505),
    [anon_sym_unsigned] = ACTIONS(5505),
    [anon_sym_long] = ACTIONS(5505),
    [anon_sym_short] = ACTIONS(5505),
    [anon_sym_LBRACK] = ACTIONS(5505),
    [anon_sym_static] = ACTIONS(5505),
    [anon_sym_register] = ACTIONS(5505),
    [anon_sym_inline] = ACTIONS(5505),
    [anon_sym___inline] = ACTIONS(5505),
    [anon_sym___inline__] = ACTIONS(5505),
    [anon_sym___forceinline] = ACTIONS(5505),
    [anon_sym_thread_local] = ACTIONS(5505),
    [anon_sym___thread] = ACTIONS(5505),
    [anon_sym_const] = ACTIONS(5505),
    [anon_sym_constexpr] = ACTIONS(5505),
    [anon_sym_volatile] = ACTIONS(5505),
    [anon_sym_restrict] = ACTIONS(5505),
    [anon_sym___restrict__] = ACTIONS(5505),
    [anon_sym__Atomic] = ACTIONS(5505),
    [anon_sym__Noreturn] = ACTIONS(5505),
    [anon_sym_noreturn] = ACTIONS(5505),
    [anon_sym__Nonnull] = ACTIONS(5505),
    [anon_sym_mutable] = ACTIONS(5505),
    [anon_sym_constinit] = ACTIONS(5505),
    [anon_sym_consteval] = ACTIONS(5505),
    [anon_sym_alignas] = ACTIONS(5505),
    [anon_sym__Alignas] = ACTIONS(5505),
    [sym_primitive_type] = ACTIONS(5505),
    [anon_sym_enum] = ACTIONS(5505),
    [anon_sym_class] = ACTIONS(5505),
    [anon_sym_struct] = ACTIONS(5505),
    [anon_sym_union] = ACTIONS(5505),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5505),
    [anon_sym_decltype] = ACTIONS(5505),
    [anon_sym_explicit] = ACTIONS(5505),
    [anon_sym_typename] = ACTIONS(5505),
    [anon_sym_private] = ACTIONS(5505),
    [anon_sym_template] = ACTIONS(5505),
    [anon_sym_operator] = ACTIONS(5505),
    [anon_sym_friend] = ACTIONS(5505),
    [anon_sym_public] = ACTIONS(5505),
    [anon_sym_protected] = ACTIONS(5505),
    [anon_sym_static_assert] = ACTIONS(5505),
  },
  [1971] = {
    [sym_identifier] = ACTIONS(5509),
    [aux_sym_preproc_def_token1] = ACTIONS(5509),
    [aux_sym_preproc_if_token1] = ACTIONS(5509),
    [aux_sym_preproc_if_token2] = ACTIONS(5509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5509),
    [sym_preproc_directive] = ACTIONS(5509),
    [anon_sym_LPAREN2] = ACTIONS(5511),
    [anon_sym_TILDE] = ACTIONS(5511),
    [anon_sym_STAR] = ACTIONS(5511),
    [anon_sym_AMP_AMP] = ACTIONS(5511),
    [anon_sym_AMP] = ACTIONS(5509),
    [anon_sym_SEMI] = ACTIONS(5511),
    [anon_sym___extension__] = ACTIONS(5509),
    [anon_sym_typedef] = ACTIONS(5509),
    [anon_sym_virtual] = ACTIONS(5509),
    [anon_sym_extern] = ACTIONS(5509),
    [anon_sym___attribute__] = ACTIONS(5509),
    [anon_sym___attribute] = ACTIONS(5509),
    [anon_sym_using] = ACTIONS(5509),
    [anon_sym_COLON_COLON] = ACTIONS(5511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5511),
    [anon_sym___declspec] = ACTIONS(5509),
    [anon_sym___based] = ACTIONS(5509),
    [anon_sym_signed] = ACTIONS(5509),
    [anon_sym_unsigned] = ACTIONS(5509),
    [anon_sym_long] = ACTIONS(5509),
    [anon_sym_short] = ACTIONS(5509),
    [anon_sym_LBRACK] = ACTIONS(5509),
    [anon_sym_static] = ACTIONS(5509),
    [anon_sym_register] = ACTIONS(5509),
    [anon_sym_inline] = ACTIONS(5509),
    [anon_sym___inline] = ACTIONS(5509),
    [anon_sym___inline__] = ACTIONS(5509),
    [anon_sym___forceinline] = ACTIONS(5509),
    [anon_sym_thread_local] = ACTIONS(5509),
    [anon_sym___thread] = ACTIONS(5509),
    [anon_sym_const] = ACTIONS(5509),
    [anon_sym_constexpr] = ACTIONS(5509),
    [anon_sym_volatile] = ACTIONS(5509),
    [anon_sym_restrict] = ACTIONS(5509),
    [anon_sym___restrict__] = ACTIONS(5509),
    [anon_sym__Atomic] = ACTIONS(5509),
    [anon_sym__Noreturn] = ACTIONS(5509),
    [anon_sym_noreturn] = ACTIONS(5509),
    [anon_sym__Nonnull] = ACTIONS(5509),
    [anon_sym_mutable] = ACTIONS(5509),
    [anon_sym_constinit] = ACTIONS(5509),
    [anon_sym_consteval] = ACTIONS(5509),
    [anon_sym_alignas] = ACTIONS(5509),
    [anon_sym__Alignas] = ACTIONS(5509),
    [sym_primitive_type] = ACTIONS(5509),
    [anon_sym_enum] = ACTIONS(5509),
    [anon_sym_class] = ACTIONS(5509),
    [anon_sym_struct] = ACTIONS(5509),
    [anon_sym_union] = ACTIONS(5509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5509),
    [anon_sym_decltype] = ACTIONS(5509),
    [anon_sym_explicit] = ACTIONS(5509),
    [anon_sym_typename] = ACTIONS(5509),
    [anon_sym_private] = ACTIONS(5509),
    [anon_sym_template] = ACTIONS(5509),
    [anon_sym_operator] = ACTIONS(5509),
    [anon_sym_friend] = ACTIONS(5509),
    [anon_sym_public] = ACTIONS(5509),
    [anon_sym_protected] = ACTIONS(5509),
    [anon_sym_static_assert] = ACTIONS(5509),
  },
  [1972] = {
    [sym_identifier] = ACTIONS(5513),
    [aux_sym_preproc_def_token1] = ACTIONS(5513),
    [aux_sym_preproc_if_token1] = ACTIONS(5513),
    [aux_sym_preproc_if_token2] = ACTIONS(5513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5513),
    [sym_preproc_directive] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(5515),
    [anon_sym_TILDE] = ACTIONS(5515),
    [anon_sym_STAR] = ACTIONS(5515),
    [anon_sym_AMP_AMP] = ACTIONS(5515),
    [anon_sym_AMP] = ACTIONS(5513),
    [anon_sym_SEMI] = ACTIONS(5515),
    [anon_sym___extension__] = ACTIONS(5513),
    [anon_sym_typedef] = ACTIONS(5513),
    [anon_sym_virtual] = ACTIONS(5513),
    [anon_sym_extern] = ACTIONS(5513),
    [anon_sym___attribute__] = ACTIONS(5513),
    [anon_sym___attribute] = ACTIONS(5513),
    [anon_sym_using] = ACTIONS(5513),
    [anon_sym_COLON_COLON] = ACTIONS(5515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5515),
    [anon_sym___declspec] = ACTIONS(5513),
    [anon_sym___based] = ACTIONS(5513),
    [anon_sym_signed] = ACTIONS(5513),
    [anon_sym_unsigned] = ACTIONS(5513),
    [anon_sym_long] = ACTIONS(5513),
    [anon_sym_short] = ACTIONS(5513),
    [anon_sym_LBRACK] = ACTIONS(5513),
    [anon_sym_static] = ACTIONS(5513),
    [anon_sym_register] = ACTIONS(5513),
    [anon_sym_inline] = ACTIONS(5513),
    [anon_sym___inline] = ACTIONS(5513),
    [anon_sym___inline__] = ACTIONS(5513),
    [anon_sym___forceinline] = ACTIONS(5513),
    [anon_sym_thread_local] = ACTIONS(5513),
    [anon_sym___thread] = ACTIONS(5513),
    [anon_sym_const] = ACTIONS(5513),
    [anon_sym_constexpr] = ACTIONS(5513),
    [anon_sym_volatile] = ACTIONS(5513),
    [anon_sym_restrict] = ACTIONS(5513),
    [anon_sym___restrict__] = ACTIONS(5513),
    [anon_sym__Atomic] = ACTIONS(5513),
    [anon_sym__Noreturn] = ACTIONS(5513),
    [anon_sym_noreturn] = ACTIONS(5513),
    [anon_sym__Nonnull] = ACTIONS(5513),
    [anon_sym_mutable] = ACTIONS(5513),
    [anon_sym_constinit] = ACTIONS(5513),
    [anon_sym_consteval] = ACTIONS(5513),
    [anon_sym_alignas] = ACTIONS(5513),
    [anon_sym__Alignas] = ACTIONS(5513),
    [sym_primitive_type] = ACTIONS(5513),
    [anon_sym_enum] = ACTIONS(5513),
    [anon_sym_class] = ACTIONS(5513),
    [anon_sym_struct] = ACTIONS(5513),
    [anon_sym_union] = ACTIONS(5513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5513),
    [anon_sym_decltype] = ACTIONS(5513),
    [anon_sym_explicit] = ACTIONS(5513),
    [anon_sym_typename] = ACTIONS(5513),
    [anon_sym_private] = ACTIONS(5513),
    [anon_sym_template] = ACTIONS(5513),
    [anon_sym_operator] = ACTIONS(5513),
    [anon_sym_friend] = ACTIONS(5513),
    [anon_sym_public] = ACTIONS(5513),
    [anon_sym_protected] = ACTIONS(5513),
    [anon_sym_static_assert] = ACTIONS(5513),
  },
  [1973] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_private] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_friend] = ACTIONS(2703),
    [anon_sym_public] = ACTIONS(2703),
    [anon_sym_protected] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
  },
  [1974] = {
    [sym_identifier] = ACTIONS(5517),
    [aux_sym_preproc_def_token1] = ACTIONS(5517),
    [aux_sym_preproc_if_token1] = ACTIONS(5517),
    [aux_sym_preproc_if_token2] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5517),
    [sym_preproc_directive] = ACTIONS(5517),
    [anon_sym_LPAREN2] = ACTIONS(5519),
    [anon_sym_TILDE] = ACTIONS(5519),
    [anon_sym_STAR] = ACTIONS(5519),
    [anon_sym_AMP_AMP] = ACTIONS(5519),
    [anon_sym_AMP] = ACTIONS(5517),
    [anon_sym_SEMI] = ACTIONS(5519),
    [anon_sym___extension__] = ACTIONS(5517),
    [anon_sym_typedef] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5517),
    [anon_sym___attribute__] = ACTIONS(5517),
    [anon_sym___attribute] = ACTIONS(5517),
    [anon_sym_using] = ACTIONS(5517),
    [anon_sym_COLON_COLON] = ACTIONS(5519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5519),
    [anon_sym___declspec] = ACTIONS(5517),
    [anon_sym___based] = ACTIONS(5517),
    [anon_sym_signed] = ACTIONS(5517),
    [anon_sym_unsigned] = ACTIONS(5517),
    [anon_sym_long] = ACTIONS(5517),
    [anon_sym_short] = ACTIONS(5517),
    [anon_sym_LBRACK] = ACTIONS(5517),
    [anon_sym_static] = ACTIONS(5517),
    [anon_sym_register] = ACTIONS(5517),
    [anon_sym_inline] = ACTIONS(5517),
    [anon_sym___inline] = ACTIONS(5517),
    [anon_sym___inline__] = ACTIONS(5517),
    [anon_sym___forceinline] = ACTIONS(5517),
    [anon_sym_thread_local] = ACTIONS(5517),
    [anon_sym___thread] = ACTIONS(5517),
    [anon_sym_const] = ACTIONS(5517),
    [anon_sym_constexpr] = ACTIONS(5517),
    [anon_sym_volatile] = ACTIONS(5517),
    [anon_sym_restrict] = ACTIONS(5517),
    [anon_sym___restrict__] = ACTIONS(5517),
    [anon_sym__Atomic] = ACTIONS(5517),
    [anon_sym__Noreturn] = ACTIONS(5517),
    [anon_sym_noreturn] = ACTIONS(5517),
    [anon_sym__Nonnull] = ACTIONS(5517),
    [anon_sym_mutable] = ACTIONS(5517),
    [anon_sym_constinit] = ACTIONS(5517),
    [anon_sym_consteval] = ACTIONS(5517),
    [anon_sym_alignas] = ACTIONS(5517),
    [anon_sym__Alignas] = ACTIONS(5517),
    [sym_primitive_type] = ACTIONS(5517),
    [anon_sym_enum] = ACTIONS(5517),
    [anon_sym_class] = ACTIONS(5517),
    [anon_sym_struct] = ACTIONS(5517),
    [anon_sym_union] = ACTIONS(5517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5517),
    [anon_sym_decltype] = ACTIONS(5517),
    [anon_sym_explicit] = ACTIONS(5517),
    [anon_sym_typename] = ACTIONS(5517),
    [anon_sym_private] = ACTIONS(5517),
    [anon_sym_template] = ACTIONS(5517),
    [anon_sym_operator] = ACTIONS(5517),
    [anon_sym_friend] = ACTIONS(5517),
    [anon_sym_public] = ACTIONS(5517),
    [anon_sym_protected] = ACTIONS(5517),
    [anon_sym_static_assert] = ACTIONS(5517),
  },
  [1975] = {
    [sym_identifier] = ACTIONS(5517),
    [aux_sym_preproc_def_token1] = ACTIONS(5517),
    [aux_sym_preproc_if_token1] = ACTIONS(5517),
    [aux_sym_preproc_if_token2] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5517),
    [sym_preproc_directive] = ACTIONS(5517),
    [anon_sym_LPAREN2] = ACTIONS(5519),
    [anon_sym_TILDE] = ACTIONS(5519),
    [anon_sym_STAR] = ACTIONS(5519),
    [anon_sym_AMP_AMP] = ACTIONS(5519),
    [anon_sym_AMP] = ACTIONS(5517),
    [anon_sym_SEMI] = ACTIONS(5519),
    [anon_sym___extension__] = ACTIONS(5517),
    [anon_sym_typedef] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5517),
    [anon_sym___attribute__] = ACTIONS(5517),
    [anon_sym___attribute] = ACTIONS(5517),
    [anon_sym_using] = ACTIONS(5517),
    [anon_sym_COLON_COLON] = ACTIONS(5519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5519),
    [anon_sym___declspec] = ACTIONS(5517),
    [anon_sym___based] = ACTIONS(5517),
    [anon_sym_signed] = ACTIONS(5517),
    [anon_sym_unsigned] = ACTIONS(5517),
    [anon_sym_long] = ACTIONS(5517),
    [anon_sym_short] = ACTIONS(5517),
    [anon_sym_LBRACK] = ACTIONS(5517),
    [anon_sym_static] = ACTIONS(5517),
    [anon_sym_register] = ACTIONS(5517),
    [anon_sym_inline] = ACTIONS(5517),
    [anon_sym___inline] = ACTIONS(5517),
    [anon_sym___inline__] = ACTIONS(5517),
    [anon_sym___forceinline] = ACTIONS(5517),
    [anon_sym_thread_local] = ACTIONS(5517),
    [anon_sym___thread] = ACTIONS(5517),
    [anon_sym_const] = ACTIONS(5517),
    [anon_sym_constexpr] = ACTIONS(5517),
    [anon_sym_volatile] = ACTIONS(5517),
    [anon_sym_restrict] = ACTIONS(5517),
    [anon_sym___restrict__] = ACTIONS(5517),
    [anon_sym__Atomic] = ACTIONS(5517),
    [anon_sym__Noreturn] = ACTIONS(5517),
    [anon_sym_noreturn] = ACTIONS(5517),
    [anon_sym__Nonnull] = ACTIONS(5517),
    [anon_sym_mutable] = ACTIONS(5517),
    [anon_sym_constinit] = ACTIONS(5517),
    [anon_sym_consteval] = ACTIONS(5517),
    [anon_sym_alignas] = ACTIONS(5517),
    [anon_sym__Alignas] = ACTIONS(5517),
    [sym_primitive_type] = ACTIONS(5517),
    [anon_sym_enum] = ACTIONS(5517),
    [anon_sym_class] = ACTIONS(5517),
    [anon_sym_struct] = ACTIONS(5517),
    [anon_sym_union] = ACTIONS(5517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5517),
    [anon_sym_decltype] = ACTIONS(5517),
    [anon_sym_explicit] = ACTIONS(5517),
    [anon_sym_typename] = ACTIONS(5517),
    [anon_sym_private] = ACTIONS(5517),
    [anon_sym_template] = ACTIONS(5517),
    [anon_sym_operator] = ACTIONS(5517),
    [anon_sym_friend] = ACTIONS(5517),
    [anon_sym_public] = ACTIONS(5517),
    [anon_sym_protected] = ACTIONS(5517),
    [anon_sym_static_assert] = ACTIONS(5517),
  },
  [1976] = {
    [sym_identifier] = ACTIONS(5521),
    [aux_sym_preproc_def_token1] = ACTIONS(5521),
    [aux_sym_preproc_if_token1] = ACTIONS(5521),
    [aux_sym_preproc_if_token2] = ACTIONS(5521),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5521),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5521),
    [sym_preproc_directive] = ACTIONS(5521),
    [anon_sym_LPAREN2] = ACTIONS(5523),
    [anon_sym_TILDE] = ACTIONS(5523),
    [anon_sym_STAR] = ACTIONS(5523),
    [anon_sym_AMP_AMP] = ACTIONS(5523),
    [anon_sym_AMP] = ACTIONS(5521),
    [anon_sym_SEMI] = ACTIONS(5523),
    [anon_sym___extension__] = ACTIONS(5521),
    [anon_sym_typedef] = ACTIONS(5521),
    [anon_sym_virtual] = ACTIONS(5521),
    [anon_sym_extern] = ACTIONS(5521),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_using] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5523),
    [anon_sym___declspec] = ACTIONS(5521),
    [anon_sym___based] = ACTIONS(5521),
    [anon_sym_signed] = ACTIONS(5521),
    [anon_sym_unsigned] = ACTIONS(5521),
    [anon_sym_long] = ACTIONS(5521),
    [anon_sym_short] = ACTIONS(5521),
    [anon_sym_LBRACK] = ACTIONS(5521),
    [anon_sym_static] = ACTIONS(5521),
    [anon_sym_register] = ACTIONS(5521),
    [anon_sym_inline] = ACTIONS(5521),
    [anon_sym___inline] = ACTIONS(5521),
    [anon_sym___inline__] = ACTIONS(5521),
    [anon_sym___forceinline] = ACTIONS(5521),
    [anon_sym_thread_local] = ACTIONS(5521),
    [anon_sym___thread] = ACTIONS(5521),
    [anon_sym_const] = ACTIONS(5521),
    [anon_sym_constexpr] = ACTIONS(5521),
    [anon_sym_volatile] = ACTIONS(5521),
    [anon_sym_restrict] = ACTIONS(5521),
    [anon_sym___restrict__] = ACTIONS(5521),
    [anon_sym__Atomic] = ACTIONS(5521),
    [anon_sym__Noreturn] = ACTIONS(5521),
    [anon_sym_noreturn] = ACTIONS(5521),
    [anon_sym__Nonnull] = ACTIONS(5521),
    [anon_sym_mutable] = ACTIONS(5521),
    [anon_sym_constinit] = ACTIONS(5521),
    [anon_sym_consteval] = ACTIONS(5521),
    [anon_sym_alignas] = ACTIONS(5521),
    [anon_sym__Alignas] = ACTIONS(5521),
    [sym_primitive_type] = ACTIONS(5521),
    [anon_sym_enum] = ACTIONS(5521),
    [anon_sym_class] = ACTIONS(5521),
    [anon_sym_struct] = ACTIONS(5521),
    [anon_sym_union] = ACTIONS(5521),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5521),
    [anon_sym_decltype] = ACTIONS(5521),
    [anon_sym_explicit] = ACTIONS(5521),
    [anon_sym_typename] = ACTIONS(5521),
    [anon_sym_private] = ACTIONS(5521),
    [anon_sym_template] = ACTIONS(5521),
    [anon_sym_operator] = ACTIONS(5521),
    [anon_sym_friend] = ACTIONS(5521),
    [anon_sym_public] = ACTIONS(5521),
    [anon_sym_protected] = ACTIONS(5521),
    [anon_sym_static_assert] = ACTIONS(5521),
  },
  [1977] = {
    [sym_identifier] = ACTIONS(5525),
    [aux_sym_preproc_def_token1] = ACTIONS(5525),
    [aux_sym_preproc_if_token1] = ACTIONS(5525),
    [aux_sym_preproc_if_token2] = ACTIONS(5525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5525),
    [sym_preproc_directive] = ACTIONS(5525),
    [anon_sym_LPAREN2] = ACTIONS(5527),
    [anon_sym_TILDE] = ACTIONS(5527),
    [anon_sym_STAR] = ACTIONS(5527),
    [anon_sym_AMP_AMP] = ACTIONS(5527),
    [anon_sym_AMP] = ACTIONS(5525),
    [anon_sym_SEMI] = ACTIONS(5527),
    [anon_sym___extension__] = ACTIONS(5525),
    [anon_sym_typedef] = ACTIONS(5525),
    [anon_sym_virtual] = ACTIONS(5525),
    [anon_sym_extern] = ACTIONS(5525),
    [anon_sym___attribute__] = ACTIONS(5525),
    [anon_sym___attribute] = ACTIONS(5525),
    [anon_sym_using] = ACTIONS(5525),
    [anon_sym_COLON_COLON] = ACTIONS(5527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5527),
    [anon_sym___declspec] = ACTIONS(5525),
    [anon_sym___based] = ACTIONS(5525),
    [anon_sym_signed] = ACTIONS(5525),
    [anon_sym_unsigned] = ACTIONS(5525),
    [anon_sym_long] = ACTIONS(5525),
    [anon_sym_short] = ACTIONS(5525),
    [anon_sym_LBRACK] = ACTIONS(5525),
    [anon_sym_static] = ACTIONS(5525),
    [anon_sym_register] = ACTIONS(5525),
    [anon_sym_inline] = ACTIONS(5525),
    [anon_sym___inline] = ACTIONS(5525),
    [anon_sym___inline__] = ACTIONS(5525),
    [anon_sym___forceinline] = ACTIONS(5525),
    [anon_sym_thread_local] = ACTIONS(5525),
    [anon_sym___thread] = ACTIONS(5525),
    [anon_sym_const] = ACTIONS(5525),
    [anon_sym_constexpr] = ACTIONS(5525),
    [anon_sym_volatile] = ACTIONS(5525),
    [anon_sym_restrict] = ACTIONS(5525),
    [anon_sym___restrict__] = ACTIONS(5525),
    [anon_sym__Atomic] = ACTIONS(5525),
    [anon_sym__Noreturn] = ACTIONS(5525),
    [anon_sym_noreturn] = ACTIONS(5525),
    [anon_sym__Nonnull] = ACTIONS(5525),
    [anon_sym_mutable] = ACTIONS(5525),
    [anon_sym_constinit] = ACTIONS(5525),
    [anon_sym_consteval] = ACTIONS(5525),
    [anon_sym_alignas] = ACTIONS(5525),
    [anon_sym__Alignas] = ACTIONS(5525),
    [sym_primitive_type] = ACTIONS(5525),
    [anon_sym_enum] = ACTIONS(5525),
    [anon_sym_class] = ACTIONS(5525),
    [anon_sym_struct] = ACTIONS(5525),
    [anon_sym_union] = ACTIONS(5525),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5525),
    [anon_sym_decltype] = ACTIONS(5525),
    [anon_sym_explicit] = ACTIONS(5525),
    [anon_sym_typename] = ACTIONS(5525),
    [anon_sym_private] = ACTIONS(5525),
    [anon_sym_template] = ACTIONS(5525),
    [anon_sym_operator] = ACTIONS(5525),
    [anon_sym_friend] = ACTIONS(5525),
    [anon_sym_public] = ACTIONS(5525),
    [anon_sym_protected] = ACTIONS(5525),
    [anon_sym_static_assert] = ACTIONS(5525),
  },
  [1978] = {
    [sym_identifier] = ACTIONS(5529),
    [aux_sym_preproc_def_token1] = ACTIONS(5529),
    [aux_sym_preproc_if_token1] = ACTIONS(5529),
    [aux_sym_preproc_if_token2] = ACTIONS(5529),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5529),
    [sym_preproc_directive] = ACTIONS(5529),
    [anon_sym_LPAREN2] = ACTIONS(5531),
    [anon_sym_TILDE] = ACTIONS(5531),
    [anon_sym_STAR] = ACTIONS(5531),
    [anon_sym_AMP_AMP] = ACTIONS(5531),
    [anon_sym_AMP] = ACTIONS(5529),
    [anon_sym_SEMI] = ACTIONS(5531),
    [anon_sym___extension__] = ACTIONS(5529),
    [anon_sym_typedef] = ACTIONS(5529),
    [anon_sym_virtual] = ACTIONS(5529),
    [anon_sym_extern] = ACTIONS(5529),
    [anon_sym___attribute__] = ACTIONS(5529),
    [anon_sym___attribute] = ACTIONS(5529),
    [anon_sym_using] = ACTIONS(5529),
    [anon_sym_COLON_COLON] = ACTIONS(5531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5531),
    [anon_sym___declspec] = ACTIONS(5529),
    [anon_sym___based] = ACTIONS(5529),
    [anon_sym_signed] = ACTIONS(5529),
    [anon_sym_unsigned] = ACTIONS(5529),
    [anon_sym_long] = ACTIONS(5529),
    [anon_sym_short] = ACTIONS(5529),
    [anon_sym_LBRACK] = ACTIONS(5529),
    [anon_sym_static] = ACTIONS(5529),
    [anon_sym_register] = ACTIONS(5529),
    [anon_sym_inline] = ACTIONS(5529),
    [anon_sym___inline] = ACTIONS(5529),
    [anon_sym___inline__] = ACTIONS(5529),
    [anon_sym___forceinline] = ACTIONS(5529),
    [anon_sym_thread_local] = ACTIONS(5529),
    [anon_sym___thread] = ACTIONS(5529),
    [anon_sym_const] = ACTIONS(5529),
    [anon_sym_constexpr] = ACTIONS(5529),
    [anon_sym_volatile] = ACTIONS(5529),
    [anon_sym_restrict] = ACTIONS(5529),
    [anon_sym___restrict__] = ACTIONS(5529),
    [anon_sym__Atomic] = ACTIONS(5529),
    [anon_sym__Noreturn] = ACTIONS(5529),
    [anon_sym_noreturn] = ACTIONS(5529),
    [anon_sym__Nonnull] = ACTIONS(5529),
    [anon_sym_mutable] = ACTIONS(5529),
    [anon_sym_constinit] = ACTIONS(5529),
    [anon_sym_consteval] = ACTIONS(5529),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_primitive_type] = ACTIONS(5529),
    [anon_sym_enum] = ACTIONS(5529),
    [anon_sym_class] = ACTIONS(5529),
    [anon_sym_struct] = ACTIONS(5529),
    [anon_sym_union] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5529),
    [anon_sym_decltype] = ACTIONS(5529),
    [anon_sym_explicit] = ACTIONS(5529),
    [anon_sym_typename] = ACTIONS(5529),
    [anon_sym_private] = ACTIONS(5529),
    [anon_sym_template] = ACTIONS(5529),
    [anon_sym_operator] = ACTIONS(5529),
    [anon_sym_friend] = ACTIONS(5529),
    [anon_sym_public] = ACTIONS(5529),
    [anon_sym_protected] = ACTIONS(5529),
    [anon_sym_static_assert] = ACTIONS(5529),
  },
  [1979] = {
    [sym_identifier] = ACTIONS(5533),
    [aux_sym_preproc_def_token1] = ACTIONS(5533),
    [aux_sym_preproc_if_token1] = ACTIONS(5533),
    [aux_sym_preproc_if_token2] = ACTIONS(5533),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5533),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5533),
    [sym_preproc_directive] = ACTIONS(5533),
    [anon_sym_LPAREN2] = ACTIONS(5535),
    [anon_sym_TILDE] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5535),
    [anon_sym_AMP_AMP] = ACTIONS(5535),
    [anon_sym_AMP] = ACTIONS(5533),
    [anon_sym_SEMI] = ACTIONS(5535),
    [anon_sym___extension__] = ACTIONS(5533),
    [anon_sym_typedef] = ACTIONS(5533),
    [anon_sym_virtual] = ACTIONS(5533),
    [anon_sym_extern] = ACTIONS(5533),
    [anon_sym___attribute__] = ACTIONS(5533),
    [anon_sym___attribute] = ACTIONS(5533),
    [anon_sym_using] = ACTIONS(5533),
    [anon_sym_COLON_COLON] = ACTIONS(5535),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5535),
    [anon_sym___declspec] = ACTIONS(5533),
    [anon_sym___based] = ACTIONS(5533),
    [anon_sym_signed] = ACTIONS(5533),
    [anon_sym_unsigned] = ACTIONS(5533),
    [anon_sym_long] = ACTIONS(5533),
    [anon_sym_short] = ACTIONS(5533),
    [anon_sym_LBRACK] = ACTIONS(5533),
    [anon_sym_static] = ACTIONS(5533),
    [anon_sym_register] = ACTIONS(5533),
    [anon_sym_inline] = ACTIONS(5533),
    [anon_sym___inline] = ACTIONS(5533),
    [anon_sym___inline__] = ACTIONS(5533),
    [anon_sym___forceinline] = ACTIONS(5533),
    [anon_sym_thread_local] = ACTIONS(5533),
    [anon_sym___thread] = ACTIONS(5533),
    [anon_sym_const] = ACTIONS(5533),
    [anon_sym_constexpr] = ACTIONS(5533),
    [anon_sym_volatile] = ACTIONS(5533),
    [anon_sym_restrict] = ACTIONS(5533),
    [anon_sym___restrict__] = ACTIONS(5533),
    [anon_sym__Atomic] = ACTIONS(5533),
    [anon_sym__Noreturn] = ACTIONS(5533),
    [anon_sym_noreturn] = ACTIONS(5533),
    [anon_sym__Nonnull] = ACTIONS(5533),
    [anon_sym_mutable] = ACTIONS(5533),
    [anon_sym_constinit] = ACTIONS(5533),
    [anon_sym_consteval] = ACTIONS(5533),
    [anon_sym_alignas] = ACTIONS(5533),
    [anon_sym__Alignas] = ACTIONS(5533),
    [sym_primitive_type] = ACTIONS(5533),
    [anon_sym_enum] = ACTIONS(5533),
    [anon_sym_class] = ACTIONS(5533),
    [anon_sym_struct] = ACTIONS(5533),
    [anon_sym_union] = ACTIONS(5533),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5533),
    [anon_sym_decltype] = ACTIONS(5533),
    [anon_sym_explicit] = ACTIONS(5533),
    [anon_sym_typename] = ACTIONS(5533),
    [anon_sym_private] = ACTIONS(5533),
    [anon_sym_template] = ACTIONS(5533),
    [anon_sym_operator] = ACTIONS(5533),
    [anon_sym_friend] = ACTIONS(5533),
    [anon_sym_public] = ACTIONS(5533),
    [anon_sym_protected] = ACTIONS(5533),
    [anon_sym_static_assert] = ACTIONS(5533),
  },
  [1980] = {
    [sym_identifier] = ACTIONS(5537),
    [aux_sym_preproc_def_token1] = ACTIONS(5537),
    [aux_sym_preproc_if_token1] = ACTIONS(5537),
    [aux_sym_preproc_if_token2] = ACTIONS(5537),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5537),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5537),
    [sym_preproc_directive] = ACTIONS(5537),
    [anon_sym_LPAREN2] = ACTIONS(5539),
    [anon_sym_TILDE] = ACTIONS(5539),
    [anon_sym_STAR] = ACTIONS(5539),
    [anon_sym_AMP_AMP] = ACTIONS(5539),
    [anon_sym_AMP] = ACTIONS(5537),
    [anon_sym_SEMI] = ACTIONS(5539),
    [anon_sym___extension__] = ACTIONS(5537),
    [anon_sym_typedef] = ACTIONS(5537),
    [anon_sym_virtual] = ACTIONS(5537),
    [anon_sym_extern] = ACTIONS(5537),
    [anon_sym___attribute__] = ACTIONS(5537),
    [anon_sym___attribute] = ACTIONS(5537),
    [anon_sym_using] = ACTIONS(5537),
    [anon_sym_COLON_COLON] = ACTIONS(5539),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5539),
    [anon_sym___declspec] = ACTIONS(5537),
    [anon_sym___based] = ACTIONS(5537),
    [anon_sym_signed] = ACTIONS(5537),
    [anon_sym_unsigned] = ACTIONS(5537),
    [anon_sym_long] = ACTIONS(5537),
    [anon_sym_short] = ACTIONS(5537),
    [anon_sym_LBRACK] = ACTIONS(5537),
    [anon_sym_static] = ACTIONS(5537),
    [anon_sym_register] = ACTIONS(5537),
    [anon_sym_inline] = ACTIONS(5537),
    [anon_sym___inline] = ACTIONS(5537),
    [anon_sym___inline__] = ACTIONS(5537),
    [anon_sym___forceinline] = ACTIONS(5537),
    [anon_sym_thread_local] = ACTIONS(5537),
    [anon_sym___thread] = ACTIONS(5537),
    [anon_sym_const] = ACTIONS(5537),
    [anon_sym_constexpr] = ACTIONS(5537),
    [anon_sym_volatile] = ACTIONS(5537),
    [anon_sym_restrict] = ACTIONS(5537),
    [anon_sym___restrict__] = ACTIONS(5537),
    [anon_sym__Atomic] = ACTIONS(5537),
    [anon_sym__Noreturn] = ACTIONS(5537),
    [anon_sym_noreturn] = ACTIONS(5537),
    [anon_sym__Nonnull] = ACTIONS(5537),
    [anon_sym_mutable] = ACTIONS(5537),
    [anon_sym_constinit] = ACTIONS(5537),
    [anon_sym_consteval] = ACTIONS(5537),
    [anon_sym_alignas] = ACTIONS(5537),
    [anon_sym__Alignas] = ACTIONS(5537),
    [sym_primitive_type] = ACTIONS(5537),
    [anon_sym_enum] = ACTIONS(5537),
    [anon_sym_class] = ACTIONS(5537),
    [anon_sym_struct] = ACTIONS(5537),
    [anon_sym_union] = ACTIONS(5537),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5537),
    [anon_sym_decltype] = ACTIONS(5537),
    [anon_sym_explicit] = ACTIONS(5537),
    [anon_sym_typename] = ACTIONS(5537),
    [anon_sym_private] = ACTIONS(5537),
    [anon_sym_template] = ACTIONS(5537),
    [anon_sym_operator] = ACTIONS(5537),
    [anon_sym_friend] = ACTIONS(5537),
    [anon_sym_public] = ACTIONS(5537),
    [anon_sym_protected] = ACTIONS(5537),
    [anon_sym_static_assert] = ACTIONS(5537),
  },
  [1981] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym___attribute] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym__Nonnull] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym__Alignas] = ACTIONS(2643),
    [sym_primitive_type] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_private] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_friend] = ACTIONS(2643),
    [anon_sym_public] = ACTIONS(2643),
    [anon_sym_protected] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
  },
  [1982] = {
    [sym_identifier] = ACTIONS(5553),
    [aux_sym_preproc_def_token1] = ACTIONS(5553),
    [aux_sym_preproc_if_token1] = ACTIONS(5553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5553),
    [sym_preproc_directive] = ACTIONS(5553),
    [anon_sym_LPAREN2] = ACTIONS(5555),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_STAR] = ACTIONS(5555),
    [anon_sym_AMP_AMP] = ACTIONS(5555),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_SEMI] = ACTIONS(5555),
    [anon_sym___extension__] = ACTIONS(5553),
    [anon_sym_typedef] = ACTIONS(5553),
    [anon_sym_virtual] = ACTIONS(5553),
    [anon_sym_extern] = ACTIONS(5553),
    [anon_sym___attribute__] = ACTIONS(5553),
    [anon_sym___attribute] = ACTIONS(5553),
    [anon_sym_using] = ACTIONS(5553),
    [anon_sym_COLON_COLON] = ACTIONS(5555),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5555),
    [anon_sym___declspec] = ACTIONS(5553),
    [anon_sym___based] = ACTIONS(5553),
    [anon_sym_RBRACE] = ACTIONS(5555),
    [anon_sym_signed] = ACTIONS(5553),
    [anon_sym_unsigned] = ACTIONS(5553),
    [anon_sym_long] = ACTIONS(5553),
    [anon_sym_short] = ACTIONS(5553),
    [anon_sym_LBRACK] = ACTIONS(5553),
    [anon_sym_static] = ACTIONS(5553),
    [anon_sym_register] = ACTIONS(5553),
    [anon_sym_inline] = ACTIONS(5553),
    [anon_sym___inline] = ACTIONS(5553),
    [anon_sym___inline__] = ACTIONS(5553),
    [anon_sym___forceinline] = ACTIONS(5553),
    [anon_sym_thread_local] = ACTIONS(5553),
    [anon_sym___thread] = ACTIONS(5553),
    [anon_sym_const] = ACTIONS(5553),
    [anon_sym_constexpr] = ACTIONS(5553),
    [anon_sym_volatile] = ACTIONS(5553),
    [anon_sym_restrict] = ACTIONS(5553),
    [anon_sym___restrict__] = ACTIONS(5553),
    [anon_sym__Atomic] = ACTIONS(5553),
    [anon_sym__Noreturn] = ACTIONS(5553),
    [anon_sym_noreturn] = ACTIONS(5553),
    [anon_sym__Nonnull] = ACTIONS(5553),
    [anon_sym_mutable] = ACTIONS(5553),
    [anon_sym_constinit] = ACTIONS(5553),
    [anon_sym_consteval] = ACTIONS(5553),
    [anon_sym_alignas] = ACTIONS(5553),
    [anon_sym__Alignas] = ACTIONS(5553),
    [sym_primitive_type] = ACTIONS(5553),
    [anon_sym_enum] = ACTIONS(5553),
    [anon_sym_class] = ACTIONS(5553),
    [anon_sym_struct] = ACTIONS(5553),
    [anon_sym_union] = ACTIONS(5553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5553),
    [anon_sym_decltype] = ACTIONS(5553),
    [anon_sym_explicit] = ACTIONS(5553),
    [anon_sym_typename] = ACTIONS(5553),
    [anon_sym_private] = ACTIONS(5553),
    [anon_sym_template] = ACTIONS(5553),
    [anon_sym_operator] = ACTIONS(5553),
    [anon_sym_friend] = ACTIONS(5553),
    [anon_sym_public] = ACTIONS(5553),
    [anon_sym_protected] = ACTIONS(5553),
    [anon_sym_static_assert] = ACTIONS(5553),
  },
  [1983] = {
    [sym_identifier] = ACTIONS(5549),
    [aux_sym_preproc_def_token1] = ACTIONS(5549),
    [aux_sym_preproc_if_token1] = ACTIONS(5549),
    [aux_sym_preproc_if_token2] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5549),
    [sym_preproc_directive] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(5551),
    [anon_sym_TILDE] = ACTIONS(5551),
    [anon_sym_STAR] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5549),
    [anon_sym_SEMI] = ACTIONS(5551),
    [anon_sym___extension__] = ACTIONS(5549),
    [anon_sym_typedef] = ACTIONS(5549),
    [anon_sym_virtual] = ACTIONS(5549),
    [anon_sym_extern] = ACTIONS(5549),
    [anon_sym___attribute__] = ACTIONS(5549),
    [anon_sym___attribute] = ACTIONS(5549),
    [anon_sym_using] = ACTIONS(5549),
    [anon_sym_COLON_COLON] = ACTIONS(5551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5551),
    [anon_sym___declspec] = ACTIONS(5549),
    [anon_sym___based] = ACTIONS(5549),
    [anon_sym_signed] = ACTIONS(5549),
    [anon_sym_unsigned] = ACTIONS(5549),
    [anon_sym_long] = ACTIONS(5549),
    [anon_sym_short] = ACTIONS(5549),
    [anon_sym_LBRACK] = ACTIONS(5549),
    [anon_sym_static] = ACTIONS(5549),
    [anon_sym_register] = ACTIONS(5549),
    [anon_sym_inline] = ACTIONS(5549),
    [anon_sym___inline] = ACTIONS(5549),
    [anon_sym___inline__] = ACTIONS(5549),
    [anon_sym___forceinline] = ACTIONS(5549),
    [anon_sym_thread_local] = ACTIONS(5549),
    [anon_sym___thread] = ACTIONS(5549),
    [anon_sym_const] = ACTIONS(5549),
    [anon_sym_constexpr] = ACTIONS(5549),
    [anon_sym_volatile] = ACTIONS(5549),
    [anon_sym_restrict] = ACTIONS(5549),
    [anon_sym___restrict__] = ACTIONS(5549),
    [anon_sym__Atomic] = ACTIONS(5549),
    [anon_sym__Noreturn] = ACTIONS(5549),
    [anon_sym_noreturn] = ACTIONS(5549),
    [anon_sym__Nonnull] = ACTIONS(5549),
    [anon_sym_mutable] = ACTIONS(5549),
    [anon_sym_constinit] = ACTIONS(5549),
    [anon_sym_consteval] = ACTIONS(5549),
    [anon_sym_alignas] = ACTIONS(5549),
    [anon_sym__Alignas] = ACTIONS(5549),
    [sym_primitive_type] = ACTIONS(5549),
    [anon_sym_enum] = ACTIONS(5549),
    [anon_sym_class] = ACTIONS(5549),
    [anon_sym_struct] = ACTIONS(5549),
    [anon_sym_union] = ACTIONS(5549),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5549),
    [anon_sym_decltype] = ACTIONS(5549),
    [anon_sym_explicit] = ACTIONS(5549),
    [anon_sym_typename] = ACTIONS(5549),
    [anon_sym_private] = ACTIONS(5549),
    [anon_sym_template] = ACTIONS(5549),
    [anon_sym_operator] = ACTIONS(5549),
    [anon_sym_friend] = ACTIONS(5549),
    [anon_sym_public] = ACTIONS(5549),
    [anon_sym_protected] = ACTIONS(5549),
    [anon_sym_static_assert] = ACTIONS(5549),
  },
  [1984] = {
    [sym_identifier] = ACTIONS(5549),
    [aux_sym_preproc_def_token1] = ACTIONS(5549),
    [aux_sym_preproc_if_token1] = ACTIONS(5549),
    [aux_sym_preproc_if_token2] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5549),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5549),
    [sym_preproc_directive] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(5551),
    [anon_sym_TILDE] = ACTIONS(5551),
    [anon_sym_STAR] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5549),
    [anon_sym_SEMI] = ACTIONS(5551),
    [anon_sym___extension__] = ACTIONS(5549),
    [anon_sym_typedef] = ACTIONS(5549),
    [anon_sym_virtual] = ACTIONS(5549),
    [anon_sym_extern] = ACTIONS(5549),
    [anon_sym___attribute__] = ACTIONS(5549),
    [anon_sym___attribute] = ACTIONS(5549),
    [anon_sym_using] = ACTIONS(5549),
    [anon_sym_COLON_COLON] = ACTIONS(5551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5551),
    [anon_sym___declspec] = ACTIONS(5549),
    [anon_sym___based] = ACTIONS(5549),
    [anon_sym_signed] = ACTIONS(5549),
    [anon_sym_unsigned] = ACTIONS(5549),
    [anon_sym_long] = ACTIONS(5549),
    [anon_sym_short] = ACTIONS(5549),
    [anon_sym_LBRACK] = ACTIONS(5549),
    [anon_sym_static] = ACTIONS(5549),
    [anon_sym_register] = ACTIONS(5549),
    [anon_sym_inline] = ACTIONS(5549),
    [anon_sym___inline] = ACTIONS(5549),
    [anon_sym___inline__] = ACTIONS(5549),
    [anon_sym___forceinline] = ACTIONS(5549),
    [anon_sym_thread_local] = ACTIONS(5549),
    [anon_sym___thread] = ACTIONS(5549),
    [anon_sym_const] = ACTIONS(5549),
    [anon_sym_constexpr] = ACTIONS(5549),
    [anon_sym_volatile] = ACTIONS(5549),
    [anon_sym_restrict] = ACTIONS(5549),
    [anon_sym___restrict__] = ACTIONS(5549),
    [anon_sym__Atomic] = ACTIONS(5549),
    [anon_sym__Noreturn] = ACTIONS(5549),
    [anon_sym_noreturn] = ACTIONS(5549),
    [anon_sym__Nonnull] = ACTIONS(5549),
    [anon_sym_mutable] = ACTIONS(5549),
    [anon_sym_constinit] = ACTIONS(5549),
    [anon_sym_consteval] = ACTIONS(5549),
    [anon_sym_alignas] = ACTIONS(5549),
    [anon_sym__Alignas] = ACTIONS(5549),
    [sym_primitive_type] = ACTIONS(5549),
    [anon_sym_enum] = ACTIONS(5549),
    [anon_sym_class] = ACTIONS(5549),
    [anon_sym_struct] = ACTIONS(5549),
    [anon_sym_union] = ACTIONS(5549),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5549),
    [anon_sym_decltype] = ACTIONS(5549),
    [anon_sym_explicit] = ACTIONS(5549),
    [anon_sym_typename] = ACTIONS(5549),
    [anon_sym_private] = ACTIONS(5549),
    [anon_sym_template] = ACTIONS(5549),
    [anon_sym_operator] = ACTIONS(5549),
    [anon_sym_friend] = ACTIONS(5549),
    [anon_sym_public] = ACTIONS(5549),
    [anon_sym_protected] = ACTIONS(5549),
    [anon_sym_static_assert] = ACTIONS(5549),
  },
  [1985] = {
    [sym_identifier] = ACTIONS(5553),
    [aux_sym_preproc_def_token1] = ACTIONS(5553),
    [aux_sym_preproc_if_token1] = ACTIONS(5553),
    [aux_sym_preproc_if_token2] = ACTIONS(5553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5553),
    [sym_preproc_directive] = ACTIONS(5553),
    [anon_sym_LPAREN2] = ACTIONS(5555),
    [anon_sym_TILDE] = ACTIONS(5555),
    [anon_sym_STAR] = ACTIONS(5555),
    [anon_sym_AMP_AMP] = ACTIONS(5555),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_SEMI] = ACTIONS(5555),
    [anon_sym___extension__] = ACTIONS(5553),
    [anon_sym_typedef] = ACTIONS(5553),
    [anon_sym_virtual] = ACTIONS(5553),
    [anon_sym_extern] = ACTIONS(5553),
    [anon_sym___attribute__] = ACTIONS(5553),
    [anon_sym___attribute] = ACTIONS(5553),
    [anon_sym_using] = ACTIONS(5553),
    [anon_sym_COLON_COLON] = ACTIONS(5555),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5555),
    [anon_sym___declspec] = ACTIONS(5553),
    [anon_sym___based] = ACTIONS(5553),
    [anon_sym_signed] = ACTIONS(5553),
    [anon_sym_unsigned] = ACTIONS(5553),
    [anon_sym_long] = ACTIONS(5553),
    [anon_sym_short] = ACTIONS(5553),
    [anon_sym_LBRACK] = ACTIONS(5553),
    [anon_sym_static] = ACTIONS(5553),
    [anon_sym_register] = ACTIONS(5553),
    [anon_sym_inline] = ACTIONS(5553),
    [anon_sym___inline] = ACTIONS(5553),
    [anon_sym___inline__] = ACTIONS(5553),
    [anon_sym___forceinline] = ACTIONS(5553),
    [anon_sym_thread_local] = ACTIONS(5553),
    [anon_sym___thread] = ACTIONS(5553),
    [anon_sym_const] = ACTIONS(5553),
    [anon_sym_constexpr] = ACTIONS(5553),
    [anon_sym_volatile] = ACTIONS(5553),
    [anon_sym_restrict] = ACTIONS(5553),
    [anon_sym___restrict__] = ACTIONS(5553),
    [anon_sym__Atomic] = ACTIONS(5553),
    [anon_sym__Noreturn] = ACTIONS(5553),
    [anon_sym_noreturn] = ACTIONS(5553),
    [anon_sym__Nonnull] = ACTIONS(5553),
    [anon_sym_mutable] = ACTIONS(5553),
    [anon_sym_constinit] = ACTIONS(5553),
    [anon_sym_consteval] = ACTIONS(5553),
    [anon_sym_alignas] = ACTIONS(5553),
    [anon_sym__Alignas] = ACTIONS(5553),
    [sym_primitive_type] = ACTIONS(5553),
    [anon_sym_enum] = ACTIONS(5553),
    [anon_sym_class] = ACTIONS(5553),
    [anon_sym_struct] = ACTIONS(5553),
    [anon_sym_union] = ACTIONS(5553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5553),
    [anon_sym_decltype] = ACTIONS(5553),
    [anon_sym_explicit] = ACTIONS(5553),
    [anon_sym_typename] = ACTIONS(5553),
    [anon_sym_private] = ACTIONS(5553),
    [anon_sym_template] = ACTIONS(5553),
    [anon_sym_operator] = ACTIONS(5553),
    [anon_sym_friend] = ACTIONS(5553),
    [anon_sym_public] = ACTIONS(5553),
    [anon_sym_protected] = ACTIONS(5553),
    [anon_sym_static_assert] = ACTIONS(5553),
  },
  [1986] = {
    [sym_identifier] = ACTIONS(5561),
    [aux_sym_preproc_def_token1] = ACTIONS(5561),
    [aux_sym_preproc_if_token1] = ACTIONS(5561),
    [aux_sym_preproc_if_token2] = ACTIONS(5561),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5561),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5561),
    [sym_preproc_directive] = ACTIONS(5561),
    [anon_sym_LPAREN2] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5563),
    [anon_sym_STAR] = ACTIONS(5563),
    [anon_sym_AMP_AMP] = ACTIONS(5563),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_SEMI] = ACTIONS(5563),
    [anon_sym___extension__] = ACTIONS(5561),
    [anon_sym_typedef] = ACTIONS(5561),
    [anon_sym_virtual] = ACTIONS(5561),
    [anon_sym_extern] = ACTIONS(5561),
    [anon_sym___attribute__] = ACTIONS(5561),
    [anon_sym___attribute] = ACTIONS(5561),
    [anon_sym_using] = ACTIONS(5561),
    [anon_sym_COLON_COLON] = ACTIONS(5563),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5563),
    [anon_sym___declspec] = ACTIONS(5561),
    [anon_sym___based] = ACTIONS(5561),
    [anon_sym_signed] = ACTIONS(5561),
    [anon_sym_unsigned] = ACTIONS(5561),
    [anon_sym_long] = ACTIONS(5561),
    [anon_sym_short] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5561),
    [anon_sym_static] = ACTIONS(5561),
    [anon_sym_register] = ACTIONS(5561),
    [anon_sym_inline] = ACTIONS(5561),
    [anon_sym___inline] = ACTIONS(5561),
    [anon_sym___inline__] = ACTIONS(5561),
    [anon_sym___forceinline] = ACTIONS(5561),
    [anon_sym_thread_local] = ACTIONS(5561),
    [anon_sym___thread] = ACTIONS(5561),
    [anon_sym_const] = ACTIONS(5561),
    [anon_sym_constexpr] = ACTIONS(5561),
    [anon_sym_volatile] = ACTIONS(5561),
    [anon_sym_restrict] = ACTIONS(5561),
    [anon_sym___restrict__] = ACTIONS(5561),
    [anon_sym__Atomic] = ACTIONS(5561),
    [anon_sym__Noreturn] = ACTIONS(5561),
    [anon_sym_noreturn] = ACTIONS(5561),
    [anon_sym__Nonnull] = ACTIONS(5561),
    [anon_sym_mutable] = ACTIONS(5561),
    [anon_sym_constinit] = ACTIONS(5561),
    [anon_sym_consteval] = ACTIONS(5561),
    [anon_sym_alignas] = ACTIONS(5561),
    [anon_sym__Alignas] = ACTIONS(5561),
    [sym_primitive_type] = ACTIONS(5561),
    [anon_sym_enum] = ACTIONS(5561),
    [anon_sym_class] = ACTIONS(5561),
    [anon_sym_struct] = ACTIONS(5561),
    [anon_sym_union] = ACTIONS(5561),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5561),
    [anon_sym_decltype] = ACTIONS(5561),
    [anon_sym_explicit] = ACTIONS(5561),
    [anon_sym_typename] = ACTIONS(5561),
    [anon_sym_private] = ACTIONS(5561),
    [anon_sym_template] = ACTIONS(5561),
    [anon_sym_operator] = ACTIONS(5561),
    [anon_sym_friend] = ACTIONS(5561),
    [anon_sym_public] = ACTIONS(5561),
    [anon_sym_protected] = ACTIONS(5561),
    [anon_sym_static_assert] = ACTIONS(5561),
  },
  [1987] = {
    [sym_identifier] = ACTIONS(5565),
    [aux_sym_preproc_def_token1] = ACTIONS(5565),
    [aux_sym_preproc_if_token1] = ACTIONS(5565),
    [aux_sym_preproc_if_token2] = ACTIONS(5565),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5565),
    [sym_preproc_directive] = ACTIONS(5565),
    [anon_sym_LPAREN2] = ACTIONS(5567),
    [anon_sym_TILDE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5567),
    [anon_sym_AMP_AMP] = ACTIONS(5567),
    [anon_sym_AMP] = ACTIONS(5565),
    [anon_sym_SEMI] = ACTIONS(5567),
    [anon_sym___extension__] = ACTIONS(5565),
    [anon_sym_typedef] = ACTIONS(5565),
    [anon_sym_virtual] = ACTIONS(5565),
    [anon_sym_extern] = ACTIONS(5565),
    [anon_sym___attribute__] = ACTIONS(5565),
    [anon_sym___attribute] = ACTIONS(5565),
    [anon_sym_using] = ACTIONS(5565),
    [anon_sym_COLON_COLON] = ACTIONS(5567),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5567),
    [anon_sym___declspec] = ACTIONS(5565),
    [anon_sym___based] = ACTIONS(5565),
    [anon_sym_signed] = ACTIONS(5565),
    [anon_sym_unsigned] = ACTIONS(5565),
    [anon_sym_long] = ACTIONS(5565),
    [anon_sym_short] = ACTIONS(5565),
    [anon_sym_LBRACK] = ACTIONS(5565),
    [anon_sym_static] = ACTIONS(5565),
    [anon_sym_register] = ACTIONS(5565),
    [anon_sym_inline] = ACTIONS(5565),
    [anon_sym___inline] = ACTIONS(5565),
    [anon_sym___inline__] = ACTIONS(5565),
    [anon_sym___forceinline] = ACTIONS(5565),
    [anon_sym_thread_local] = ACTIONS(5565),
    [anon_sym___thread] = ACTIONS(5565),
    [anon_sym_const] = ACTIONS(5565),
    [anon_sym_constexpr] = ACTIONS(5565),
    [anon_sym_volatile] = ACTIONS(5565),
    [anon_sym_restrict] = ACTIONS(5565),
    [anon_sym___restrict__] = ACTIONS(5565),
    [anon_sym__Atomic] = ACTIONS(5565),
    [anon_sym__Noreturn] = ACTIONS(5565),
    [anon_sym_noreturn] = ACTIONS(5565),
    [anon_sym__Nonnull] = ACTIONS(5565),
    [anon_sym_mutable] = ACTIONS(5565),
    [anon_sym_constinit] = ACTIONS(5565),
    [anon_sym_consteval] = ACTIONS(5565),
    [anon_sym_alignas] = ACTIONS(5565),
    [anon_sym__Alignas] = ACTIONS(5565),
    [sym_primitive_type] = ACTIONS(5565),
    [anon_sym_enum] = ACTIONS(5565),
    [anon_sym_class] = ACTIONS(5565),
    [anon_sym_struct] = ACTIONS(5565),
    [anon_sym_union] = ACTIONS(5565),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5565),
    [anon_sym_decltype] = ACTIONS(5565),
    [anon_sym_explicit] = ACTIONS(5565),
    [anon_sym_typename] = ACTIONS(5565),
    [anon_sym_private] = ACTIONS(5565),
    [anon_sym_template] = ACTIONS(5565),
    [anon_sym_operator] = ACTIONS(5565),
    [anon_sym_friend] = ACTIONS(5565),
    [anon_sym_public] = ACTIONS(5565),
    [anon_sym_protected] = ACTIONS(5565),
    [anon_sym_static_assert] = ACTIONS(5565),
  },
  [1988] = {
    [sym_identifier] = ACTIONS(5569),
    [aux_sym_preproc_def_token1] = ACTIONS(5569),
    [aux_sym_preproc_if_token1] = ACTIONS(5569),
    [aux_sym_preproc_if_token2] = ACTIONS(5569),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5569),
    [sym_preproc_directive] = ACTIONS(5569),
    [anon_sym_LPAREN2] = ACTIONS(5571),
    [anon_sym_TILDE] = ACTIONS(5571),
    [anon_sym_STAR] = ACTIONS(5571),
    [anon_sym_AMP_AMP] = ACTIONS(5571),
    [anon_sym_AMP] = ACTIONS(5569),
    [anon_sym_SEMI] = ACTIONS(5571),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_typedef] = ACTIONS(5569),
    [anon_sym_virtual] = ACTIONS(5569),
    [anon_sym_extern] = ACTIONS(5569),
    [anon_sym___attribute__] = ACTIONS(5569),
    [anon_sym___attribute] = ACTIONS(5569),
    [anon_sym_using] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5571),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5571),
    [anon_sym___declspec] = ACTIONS(5569),
    [anon_sym___based] = ACTIONS(5569),
    [anon_sym_signed] = ACTIONS(5569),
    [anon_sym_unsigned] = ACTIONS(5569),
    [anon_sym_long] = ACTIONS(5569),
    [anon_sym_short] = ACTIONS(5569),
    [anon_sym_LBRACK] = ACTIONS(5569),
    [anon_sym_static] = ACTIONS(5569),
    [anon_sym_register] = ACTIONS(5569),
    [anon_sym_inline] = ACTIONS(5569),
    [anon_sym___inline] = ACTIONS(5569),
    [anon_sym___inline__] = ACTIONS(5569),
    [anon_sym___forceinline] = ACTIONS(5569),
    [anon_sym_thread_local] = ACTIONS(5569),
    [anon_sym___thread] = ACTIONS(5569),
    [anon_sym_const] = ACTIONS(5569),
    [anon_sym_constexpr] = ACTIONS(5569),
    [anon_sym_volatile] = ACTIONS(5569),
    [anon_sym_restrict] = ACTIONS(5569),
    [anon_sym___restrict__] = ACTIONS(5569),
    [anon_sym__Atomic] = ACTIONS(5569),
    [anon_sym__Noreturn] = ACTIONS(5569),
    [anon_sym_noreturn] = ACTIONS(5569),
    [anon_sym__Nonnull] = ACTIONS(5569),
    [anon_sym_mutable] = ACTIONS(5569),
    [anon_sym_constinit] = ACTIONS(5569),
    [anon_sym_consteval] = ACTIONS(5569),
    [anon_sym_alignas] = ACTIONS(5569),
    [anon_sym__Alignas] = ACTIONS(5569),
    [sym_primitive_type] = ACTIONS(5569),
    [anon_sym_enum] = ACTIONS(5569),
    [anon_sym_class] = ACTIONS(5569),
    [anon_sym_struct] = ACTIONS(5569),
    [anon_sym_union] = ACTIONS(5569),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5569),
    [anon_sym_decltype] = ACTIONS(5569),
    [anon_sym_explicit] = ACTIONS(5569),
    [anon_sym_typename] = ACTIONS(5569),
    [anon_sym_private] = ACTIONS(5569),
    [anon_sym_template] = ACTIONS(5569),
    [anon_sym_operator] = ACTIONS(5569),
    [anon_sym_friend] = ACTIONS(5569),
    [anon_sym_public] = ACTIONS(5569),
    [anon_sym_protected] = ACTIONS(5569),
    [anon_sym_static_assert] = ACTIONS(5569),
  },
  [1989] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_friend] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
  },
  [1990] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2705),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_private] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_friend] = ACTIONS(2703),
    [anon_sym_public] = ACTIONS(2703),
    [anon_sym_protected] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
  },
  [1991] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_friend] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
  },
  [1992] = {
    [sym_string_literal] = STATE(2005),
    [sym_raw_string_literal] = STATE(2005),
    [aux_sym_concatenated_string_repeat1] = STATE(2005),
    [sym_identifier] = ACTIONS(5952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5390),
    [anon_sym_COMMA] = ACTIONS(5390),
    [anon_sym_LPAREN2] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5392),
    [anon_sym_PLUS] = ACTIONS(5392),
    [anon_sym_STAR] = ACTIONS(5392),
    [anon_sym_SLASH] = ACTIONS(5392),
    [anon_sym_PERCENT] = ACTIONS(5392),
    [anon_sym_PIPE_PIPE] = ACTIONS(5390),
    [anon_sym_AMP_AMP] = ACTIONS(5390),
    [anon_sym_PIPE] = ACTIONS(5392),
    [anon_sym_CARET] = ACTIONS(5392),
    [anon_sym_AMP] = ACTIONS(5392),
    [anon_sym_EQ_EQ] = ACTIONS(5390),
    [anon_sym_BANG_EQ] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5392),
    [anon_sym_GT_EQ] = ACTIONS(5390),
    [anon_sym_LT_EQ] = ACTIONS(5392),
    [anon_sym_LT] = ACTIONS(5392),
    [anon_sym_LT_LT] = ACTIONS(5392),
    [anon_sym_GT_GT] = ACTIONS(5392),
    [anon_sym_SEMI] = ACTIONS(5390),
    [anon_sym___attribute__] = ACTIONS(5392),
    [anon_sym___attribute] = ACTIONS(5392),
    [anon_sym_LBRACK] = ACTIONS(5390),
    [anon_sym_EQ] = ACTIONS(5392),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_STAR_EQ] = ACTIONS(5390),
    [anon_sym_SLASH_EQ] = ACTIONS(5390),
    [anon_sym_PERCENT_EQ] = ACTIONS(5390),
    [anon_sym_PLUS_EQ] = ACTIONS(5390),
    [anon_sym_DASH_EQ] = ACTIONS(5390),
    [anon_sym_LT_LT_EQ] = ACTIONS(5390),
    [anon_sym_GT_GT_EQ] = ACTIONS(5390),
    [anon_sym_AMP_EQ] = ACTIONS(5390),
    [anon_sym_CARET_EQ] = ACTIONS(5390),
    [anon_sym_PIPE_EQ] = ACTIONS(5390),
    [anon_sym_and_eq] = ACTIONS(5392),
    [anon_sym_or_eq] = ACTIONS(5392),
    [anon_sym_xor_eq] = ACTIONS(5392),
    [anon_sym_LT_EQ_GT] = ACTIONS(5390),
    [anon_sym_or] = ACTIONS(5392),
    [anon_sym_and] = ACTIONS(5392),
    [anon_sym_bitor] = ACTIONS(5392),
    [anon_sym_xor] = ACTIONS(5392),
    [anon_sym_bitand] = ACTIONS(5392),
    [anon_sym_not_eq] = ACTIONS(5392),
    [anon_sym_DASH_DASH] = ACTIONS(5390),
    [anon_sym_PLUS_PLUS] = ACTIONS(5390),
    [anon_sym_DOT] = ACTIONS(5392),
    [anon_sym_DOT_STAR] = ACTIONS(5390),
    [anon_sym_DASH_GT] = ACTIONS(5390),
    [anon_sym_L_DQUOTE] = ACTIONS(5954),
    [anon_sym_u_DQUOTE] = ACTIONS(5954),
    [anon_sym_U_DQUOTE] = ACTIONS(5954),
    [anon_sym_u8_DQUOTE] = ACTIONS(5954),
    [anon_sym_DQUOTE] = ACTIONS(5954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5956),
    [anon_sym_LR_DQUOTE] = ACTIONS(5956),
    [anon_sym_uR_DQUOTE] = ACTIONS(5956),
    [anon_sym_UR_DQUOTE] = ACTIONS(5956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5956),
    [sym_literal_suffix] = ACTIONS(5392),
  },
  [1993] = {
    [sym__declaration_modifiers] = STATE(3269),
    [sym_attribute_specifier] = STATE(3269),
    [sym_attribute_declaration] = STATE(3269),
    [sym_ms_declspec_modifier] = STATE(3269),
    [sym_storage_class_specifier] = STATE(3269),
    [sym_type_qualifier] = STATE(3269),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2385),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3269),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(5958),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3005),
    [anon_sym_union] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_template] = ACTIONS(1452),
  },
  [1994] = {
    [sym_identifier] = ACTIONS(5561),
    [aux_sym_preproc_def_token1] = ACTIONS(5561),
    [aux_sym_preproc_if_token1] = ACTIONS(5561),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5561),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5561),
    [sym_preproc_directive] = ACTIONS(5561),
    [anon_sym_LPAREN2] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5563),
    [anon_sym_STAR] = ACTIONS(5563),
    [anon_sym_AMP_AMP] = ACTIONS(5563),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_SEMI] = ACTIONS(5563),
    [anon_sym___extension__] = ACTIONS(5561),
    [anon_sym_typedef] = ACTIONS(5561),
    [anon_sym_virtual] = ACTIONS(5561),
    [anon_sym_extern] = ACTIONS(5561),
    [anon_sym___attribute__] = ACTIONS(5561),
    [anon_sym___attribute] = ACTIONS(5561),
    [anon_sym_using] = ACTIONS(5561),
    [anon_sym_COLON_COLON] = ACTIONS(5563),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5563),
    [anon_sym___declspec] = ACTIONS(5561),
    [anon_sym___based] = ACTIONS(5561),
    [anon_sym_RBRACE] = ACTIONS(5563),
    [anon_sym_signed] = ACTIONS(5561),
    [anon_sym_unsigned] = ACTIONS(5561),
    [anon_sym_long] = ACTIONS(5561),
    [anon_sym_short] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5561),
    [anon_sym_static] = ACTIONS(5561),
    [anon_sym_register] = ACTIONS(5561),
    [anon_sym_inline] = ACTIONS(5561),
    [anon_sym___inline] = ACTIONS(5561),
    [anon_sym___inline__] = ACTIONS(5561),
    [anon_sym___forceinline] = ACTIONS(5561),
    [anon_sym_thread_local] = ACTIONS(5561),
    [anon_sym___thread] = ACTIONS(5561),
    [anon_sym_const] = ACTIONS(5561),
    [anon_sym_constexpr] = ACTIONS(5561),
    [anon_sym_volatile] = ACTIONS(5561),
    [anon_sym_restrict] = ACTIONS(5561),
    [anon_sym___restrict__] = ACTIONS(5561),
    [anon_sym__Atomic] = ACTIONS(5561),
    [anon_sym__Noreturn] = ACTIONS(5561),
    [anon_sym_noreturn] = ACTIONS(5561),
    [anon_sym__Nonnull] = ACTIONS(5561),
    [anon_sym_mutable] = ACTIONS(5561),
    [anon_sym_constinit] = ACTIONS(5561),
    [anon_sym_consteval] = ACTIONS(5561),
    [anon_sym_alignas] = ACTIONS(5561),
    [anon_sym__Alignas] = ACTIONS(5561),
    [sym_primitive_type] = ACTIONS(5561),
    [anon_sym_enum] = ACTIONS(5561),
    [anon_sym_class] = ACTIONS(5561),
    [anon_sym_struct] = ACTIONS(5561),
    [anon_sym_union] = ACTIONS(5561),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5561),
    [anon_sym_decltype] = ACTIONS(5561),
    [anon_sym_explicit] = ACTIONS(5561),
    [anon_sym_typename] = ACTIONS(5561),
    [anon_sym_private] = ACTIONS(5561),
    [anon_sym_template] = ACTIONS(5561),
    [anon_sym_operator] = ACTIONS(5561),
    [anon_sym_friend] = ACTIONS(5561),
    [anon_sym_public] = ACTIONS(5561),
    [anon_sym_protected] = ACTIONS(5561),
    [anon_sym_static_assert] = ACTIONS(5561),
  },
  [1995] = {
    [sym_identifier] = ACTIONS(5573),
    [aux_sym_preproc_def_token1] = ACTIONS(5573),
    [aux_sym_preproc_if_token1] = ACTIONS(5573),
    [aux_sym_preproc_if_token2] = ACTIONS(5573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5573),
    [sym_preproc_directive] = ACTIONS(5573),
    [anon_sym_LPAREN2] = ACTIONS(5575),
    [anon_sym_TILDE] = ACTIONS(5575),
    [anon_sym_STAR] = ACTIONS(5575),
    [anon_sym_AMP_AMP] = ACTIONS(5575),
    [anon_sym_AMP] = ACTIONS(5573),
    [anon_sym_SEMI] = ACTIONS(5575),
    [anon_sym___extension__] = ACTIONS(5573),
    [anon_sym_typedef] = ACTIONS(5573),
    [anon_sym_virtual] = ACTIONS(5573),
    [anon_sym_extern] = ACTIONS(5573),
    [anon_sym___attribute__] = ACTIONS(5573),
    [anon_sym___attribute] = ACTIONS(5573),
    [anon_sym_using] = ACTIONS(5573),
    [anon_sym_COLON_COLON] = ACTIONS(5575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5575),
    [anon_sym___declspec] = ACTIONS(5573),
    [anon_sym___based] = ACTIONS(5573),
    [anon_sym_signed] = ACTIONS(5573),
    [anon_sym_unsigned] = ACTIONS(5573),
    [anon_sym_long] = ACTIONS(5573),
    [anon_sym_short] = ACTIONS(5573),
    [anon_sym_LBRACK] = ACTIONS(5573),
    [anon_sym_static] = ACTIONS(5573),
    [anon_sym_register] = ACTIONS(5573),
    [anon_sym_inline] = ACTIONS(5573),
    [anon_sym___inline] = ACTIONS(5573),
    [anon_sym___inline__] = ACTIONS(5573),
    [anon_sym___forceinline] = ACTIONS(5573),
    [anon_sym_thread_local] = ACTIONS(5573),
    [anon_sym___thread] = ACTIONS(5573),
    [anon_sym_const] = ACTIONS(5573),
    [anon_sym_constexpr] = ACTIONS(5573),
    [anon_sym_volatile] = ACTIONS(5573),
    [anon_sym_restrict] = ACTIONS(5573),
    [anon_sym___restrict__] = ACTIONS(5573),
    [anon_sym__Atomic] = ACTIONS(5573),
    [anon_sym__Noreturn] = ACTIONS(5573),
    [anon_sym_noreturn] = ACTIONS(5573),
    [anon_sym__Nonnull] = ACTIONS(5573),
    [anon_sym_mutable] = ACTIONS(5573),
    [anon_sym_constinit] = ACTIONS(5573),
    [anon_sym_consteval] = ACTIONS(5573),
    [anon_sym_alignas] = ACTIONS(5573),
    [anon_sym__Alignas] = ACTIONS(5573),
    [sym_primitive_type] = ACTIONS(5573),
    [anon_sym_enum] = ACTIONS(5573),
    [anon_sym_class] = ACTIONS(5573),
    [anon_sym_struct] = ACTIONS(5573),
    [anon_sym_union] = ACTIONS(5573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5573),
    [anon_sym_decltype] = ACTIONS(5573),
    [anon_sym_explicit] = ACTIONS(5573),
    [anon_sym_typename] = ACTIONS(5573),
    [anon_sym_private] = ACTIONS(5573),
    [anon_sym_template] = ACTIONS(5573),
    [anon_sym_operator] = ACTIONS(5573),
    [anon_sym_friend] = ACTIONS(5573),
    [anon_sym_public] = ACTIONS(5573),
    [anon_sym_protected] = ACTIONS(5573),
    [anon_sym_static_assert] = ACTIONS(5573),
  },
  [1996] = {
    [sym_identifier] = ACTIONS(5581),
    [aux_sym_preproc_def_token1] = ACTIONS(5581),
    [aux_sym_preproc_if_token1] = ACTIONS(5581),
    [aux_sym_preproc_if_token2] = ACTIONS(5581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5581),
    [sym_preproc_directive] = ACTIONS(5581),
    [anon_sym_LPAREN2] = ACTIONS(5583),
    [anon_sym_TILDE] = ACTIONS(5583),
    [anon_sym_STAR] = ACTIONS(5583),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5581),
    [anon_sym_SEMI] = ACTIONS(5583),
    [anon_sym___extension__] = ACTIONS(5581),
    [anon_sym_typedef] = ACTIONS(5581),
    [anon_sym_virtual] = ACTIONS(5581),
    [anon_sym_extern] = ACTIONS(5581),
    [anon_sym___attribute__] = ACTIONS(5581),
    [anon_sym___attribute] = ACTIONS(5581),
    [anon_sym_using] = ACTIONS(5581),
    [anon_sym_COLON_COLON] = ACTIONS(5583),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5583),
    [anon_sym___declspec] = ACTIONS(5581),
    [anon_sym___based] = ACTIONS(5581),
    [anon_sym_signed] = ACTIONS(5581),
    [anon_sym_unsigned] = ACTIONS(5581),
    [anon_sym_long] = ACTIONS(5581),
    [anon_sym_short] = ACTIONS(5581),
    [anon_sym_LBRACK] = ACTIONS(5581),
    [anon_sym_static] = ACTIONS(5581),
    [anon_sym_register] = ACTIONS(5581),
    [anon_sym_inline] = ACTIONS(5581),
    [anon_sym___inline] = ACTIONS(5581),
    [anon_sym___inline__] = ACTIONS(5581),
    [anon_sym___forceinline] = ACTIONS(5581),
    [anon_sym_thread_local] = ACTIONS(5581),
    [anon_sym___thread] = ACTIONS(5581),
    [anon_sym_const] = ACTIONS(5581),
    [anon_sym_constexpr] = ACTIONS(5581),
    [anon_sym_volatile] = ACTIONS(5581),
    [anon_sym_restrict] = ACTIONS(5581),
    [anon_sym___restrict__] = ACTIONS(5581),
    [anon_sym__Atomic] = ACTIONS(5581),
    [anon_sym__Noreturn] = ACTIONS(5581),
    [anon_sym_noreturn] = ACTIONS(5581),
    [anon_sym__Nonnull] = ACTIONS(5581),
    [anon_sym_mutable] = ACTIONS(5581),
    [anon_sym_constinit] = ACTIONS(5581),
    [anon_sym_consteval] = ACTIONS(5581),
    [anon_sym_alignas] = ACTIONS(5581),
    [anon_sym__Alignas] = ACTIONS(5581),
    [sym_primitive_type] = ACTIONS(5581),
    [anon_sym_enum] = ACTIONS(5581),
    [anon_sym_class] = ACTIONS(5581),
    [anon_sym_struct] = ACTIONS(5581),
    [anon_sym_union] = ACTIONS(5581),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5581),
    [anon_sym_decltype] = ACTIONS(5581),
    [anon_sym_explicit] = ACTIONS(5581),
    [anon_sym_typename] = ACTIONS(5581),
    [anon_sym_private] = ACTIONS(5581),
    [anon_sym_template] = ACTIONS(5581),
    [anon_sym_operator] = ACTIONS(5581),
    [anon_sym_friend] = ACTIONS(5581),
    [anon_sym_public] = ACTIONS(5581),
    [anon_sym_protected] = ACTIONS(5581),
    [anon_sym_static_assert] = ACTIONS(5581),
  },
  [1997] = {
    [sym_identifier] = ACTIONS(5609),
    [aux_sym_preproc_def_token1] = ACTIONS(5609),
    [aux_sym_preproc_if_token1] = ACTIONS(5609),
    [aux_sym_preproc_if_token2] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5609),
    [sym_preproc_directive] = ACTIONS(5609),
    [anon_sym_LPAREN2] = ACTIONS(5611),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_STAR] = ACTIONS(5611),
    [anon_sym_AMP_AMP] = ACTIONS(5611),
    [anon_sym_AMP] = ACTIONS(5609),
    [anon_sym_SEMI] = ACTIONS(5611),
    [anon_sym___extension__] = ACTIONS(5609),
    [anon_sym_typedef] = ACTIONS(5609),
    [anon_sym_virtual] = ACTIONS(5609),
    [anon_sym_extern] = ACTIONS(5609),
    [anon_sym___attribute__] = ACTIONS(5609),
    [anon_sym___attribute] = ACTIONS(5609),
    [anon_sym_using] = ACTIONS(5609),
    [anon_sym_COLON_COLON] = ACTIONS(5611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5611),
    [anon_sym___declspec] = ACTIONS(5609),
    [anon_sym___based] = ACTIONS(5609),
    [anon_sym_signed] = ACTIONS(5609),
    [anon_sym_unsigned] = ACTIONS(5609),
    [anon_sym_long] = ACTIONS(5609),
    [anon_sym_short] = ACTIONS(5609),
    [anon_sym_LBRACK] = ACTIONS(5609),
    [anon_sym_static] = ACTIONS(5609),
    [anon_sym_register] = ACTIONS(5609),
    [anon_sym_inline] = ACTIONS(5609),
    [anon_sym___inline] = ACTIONS(5609),
    [anon_sym___inline__] = ACTIONS(5609),
    [anon_sym___forceinline] = ACTIONS(5609),
    [anon_sym_thread_local] = ACTIONS(5609),
    [anon_sym___thread] = ACTIONS(5609),
    [anon_sym_const] = ACTIONS(5609),
    [anon_sym_constexpr] = ACTIONS(5609),
    [anon_sym_volatile] = ACTIONS(5609),
    [anon_sym_restrict] = ACTIONS(5609),
    [anon_sym___restrict__] = ACTIONS(5609),
    [anon_sym__Atomic] = ACTIONS(5609),
    [anon_sym__Noreturn] = ACTIONS(5609),
    [anon_sym_noreturn] = ACTIONS(5609),
    [anon_sym__Nonnull] = ACTIONS(5609),
    [anon_sym_mutable] = ACTIONS(5609),
    [anon_sym_constinit] = ACTIONS(5609),
    [anon_sym_consteval] = ACTIONS(5609),
    [anon_sym_alignas] = ACTIONS(5609),
    [anon_sym__Alignas] = ACTIONS(5609),
    [sym_primitive_type] = ACTIONS(5609),
    [anon_sym_enum] = ACTIONS(5609),
    [anon_sym_class] = ACTIONS(5609),
    [anon_sym_struct] = ACTIONS(5609),
    [anon_sym_union] = ACTIONS(5609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5609),
    [anon_sym_decltype] = ACTIONS(5609),
    [anon_sym_explicit] = ACTIONS(5609),
    [anon_sym_typename] = ACTIONS(5609),
    [anon_sym_private] = ACTIONS(5609),
    [anon_sym_template] = ACTIONS(5609),
    [anon_sym_operator] = ACTIONS(5609),
    [anon_sym_friend] = ACTIONS(5609),
    [anon_sym_public] = ACTIONS(5609),
    [anon_sym_protected] = ACTIONS(5609),
    [anon_sym_static_assert] = ACTIONS(5609),
  },
  [1998] = {
    [sym_identifier] = ACTIONS(5613),
    [aux_sym_preproc_def_token1] = ACTIONS(5613),
    [aux_sym_preproc_if_token1] = ACTIONS(5613),
    [aux_sym_preproc_if_token2] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5613),
    [sym_preproc_directive] = ACTIONS(5613),
    [anon_sym_LPAREN2] = ACTIONS(5615),
    [anon_sym_TILDE] = ACTIONS(5615),
    [anon_sym_STAR] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5613),
    [anon_sym_SEMI] = ACTIONS(5615),
    [anon_sym___extension__] = ACTIONS(5613),
    [anon_sym_typedef] = ACTIONS(5613),
    [anon_sym_virtual] = ACTIONS(5613),
    [anon_sym_extern] = ACTIONS(5613),
    [anon_sym___attribute__] = ACTIONS(5613),
    [anon_sym___attribute] = ACTIONS(5613),
    [anon_sym_using] = ACTIONS(5613),
    [anon_sym_COLON_COLON] = ACTIONS(5615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5615),
    [anon_sym___declspec] = ACTIONS(5613),
    [anon_sym___based] = ACTIONS(5613),
    [anon_sym_signed] = ACTIONS(5613),
    [anon_sym_unsigned] = ACTIONS(5613),
    [anon_sym_long] = ACTIONS(5613),
    [anon_sym_short] = ACTIONS(5613),
    [anon_sym_LBRACK] = ACTIONS(5613),
    [anon_sym_static] = ACTIONS(5613),
    [anon_sym_register] = ACTIONS(5613),
    [anon_sym_inline] = ACTIONS(5613),
    [anon_sym___inline] = ACTIONS(5613),
    [anon_sym___inline__] = ACTIONS(5613),
    [anon_sym___forceinline] = ACTIONS(5613),
    [anon_sym_thread_local] = ACTIONS(5613),
    [anon_sym___thread] = ACTIONS(5613),
    [anon_sym_const] = ACTIONS(5613),
    [anon_sym_constexpr] = ACTIONS(5613),
    [anon_sym_volatile] = ACTIONS(5613),
    [anon_sym_restrict] = ACTIONS(5613),
    [anon_sym___restrict__] = ACTIONS(5613),
    [anon_sym__Atomic] = ACTIONS(5613),
    [anon_sym__Noreturn] = ACTIONS(5613),
    [anon_sym_noreturn] = ACTIONS(5613),
    [anon_sym__Nonnull] = ACTIONS(5613),
    [anon_sym_mutable] = ACTIONS(5613),
    [anon_sym_constinit] = ACTIONS(5613),
    [anon_sym_consteval] = ACTIONS(5613),
    [anon_sym_alignas] = ACTIONS(5613),
    [anon_sym__Alignas] = ACTIONS(5613),
    [sym_primitive_type] = ACTIONS(5613),
    [anon_sym_enum] = ACTIONS(5613),
    [anon_sym_class] = ACTIONS(5613),
    [anon_sym_struct] = ACTIONS(5613),
    [anon_sym_union] = ACTIONS(5613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5613),
    [anon_sym_decltype] = ACTIONS(5613),
    [anon_sym_explicit] = ACTIONS(5613),
    [anon_sym_typename] = ACTIONS(5613),
    [anon_sym_private] = ACTIONS(5613),
    [anon_sym_template] = ACTIONS(5613),
    [anon_sym_operator] = ACTIONS(5613),
    [anon_sym_friend] = ACTIONS(5613),
    [anon_sym_public] = ACTIONS(5613),
    [anon_sym_protected] = ACTIONS(5613),
    [anon_sym_static_assert] = ACTIONS(5613),
  },
  [1999] = {
    [sym_identifier] = ACTIONS(5609),
    [aux_sym_preproc_def_token1] = ACTIONS(5609),
    [aux_sym_preproc_if_token1] = ACTIONS(5609),
    [aux_sym_preproc_if_token2] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5609),
    [sym_preproc_directive] = ACTIONS(5609),
    [anon_sym_LPAREN2] = ACTIONS(5611),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_STAR] = ACTIONS(5611),
    [anon_sym_AMP_AMP] = ACTIONS(5611),
    [anon_sym_AMP] = ACTIONS(5609),
    [anon_sym_SEMI] = ACTIONS(5611),
    [anon_sym___extension__] = ACTIONS(5609),
    [anon_sym_typedef] = ACTIONS(5609),
    [anon_sym_virtual] = ACTIONS(5609),
    [anon_sym_extern] = ACTIONS(5609),
    [anon_sym___attribute__] = ACTIONS(5609),
    [anon_sym___attribute] = ACTIONS(5609),
    [anon_sym_using] = ACTIONS(5609),
    [anon_sym_COLON_COLON] = ACTIONS(5611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5611),
    [anon_sym___declspec] = ACTIONS(5609),
    [anon_sym___based] = ACTIONS(5609),
    [anon_sym_signed] = ACTIONS(5609),
    [anon_sym_unsigned] = ACTIONS(5609),
    [anon_sym_long] = ACTIONS(5609),
    [anon_sym_short] = ACTIONS(5609),
    [anon_sym_LBRACK] = ACTIONS(5609),
    [anon_sym_static] = ACTIONS(5609),
    [anon_sym_register] = ACTIONS(5609),
    [anon_sym_inline] = ACTIONS(5609),
    [anon_sym___inline] = ACTIONS(5609),
    [anon_sym___inline__] = ACTIONS(5609),
    [anon_sym___forceinline] = ACTIONS(5609),
    [anon_sym_thread_local] = ACTIONS(5609),
    [anon_sym___thread] = ACTIONS(5609),
    [anon_sym_const] = ACTIONS(5609),
    [anon_sym_constexpr] = ACTIONS(5609),
    [anon_sym_volatile] = ACTIONS(5609),
    [anon_sym_restrict] = ACTIONS(5609),
    [anon_sym___restrict__] = ACTIONS(5609),
    [anon_sym__Atomic] = ACTIONS(5609),
    [anon_sym__Noreturn] = ACTIONS(5609),
    [anon_sym_noreturn] = ACTIONS(5609),
    [anon_sym__Nonnull] = ACTIONS(5609),
    [anon_sym_mutable] = ACTIONS(5609),
    [anon_sym_constinit] = ACTIONS(5609),
    [anon_sym_consteval] = ACTIONS(5609),
    [anon_sym_alignas] = ACTIONS(5609),
    [anon_sym__Alignas] = ACTIONS(5609),
    [sym_primitive_type] = ACTIONS(5609),
    [anon_sym_enum] = ACTIONS(5609),
    [anon_sym_class] = ACTIONS(5609),
    [anon_sym_struct] = ACTIONS(5609),
    [anon_sym_union] = ACTIONS(5609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5609),
    [anon_sym_decltype] = ACTIONS(5609),
    [anon_sym_explicit] = ACTIONS(5609),
    [anon_sym_typename] = ACTIONS(5609),
    [anon_sym_private] = ACTIONS(5609),
    [anon_sym_template] = ACTIONS(5609),
    [anon_sym_operator] = ACTIONS(5609),
    [anon_sym_friend] = ACTIONS(5609),
    [anon_sym_public] = ACTIONS(5609),
    [anon_sym_protected] = ACTIONS(5609),
    [anon_sym_static_assert] = ACTIONS(5609),
  },
  [2000] = {
    [sym_identifier] = ACTIONS(5613),
    [aux_sym_preproc_def_token1] = ACTIONS(5613),
    [aux_sym_preproc_if_token1] = ACTIONS(5613),
    [aux_sym_preproc_if_token2] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5613),
    [sym_preproc_directive] = ACTIONS(5613),
    [anon_sym_LPAREN2] = ACTIONS(5615),
    [anon_sym_TILDE] = ACTIONS(5615),
    [anon_sym_STAR] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5613),
    [anon_sym_SEMI] = ACTIONS(5615),
    [anon_sym___extension__] = ACTIONS(5613),
    [anon_sym_typedef] = ACTIONS(5613),
    [anon_sym_virtual] = ACTIONS(5613),
    [anon_sym_extern] = ACTIONS(5613),
    [anon_sym___attribute__] = ACTIONS(5613),
    [anon_sym___attribute] = ACTIONS(5613),
    [anon_sym_using] = ACTIONS(5613),
    [anon_sym_COLON_COLON] = ACTIONS(5615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5615),
    [anon_sym___declspec] = ACTIONS(5613),
    [anon_sym___based] = ACTIONS(5613),
    [anon_sym_signed] = ACTIONS(5613),
    [anon_sym_unsigned] = ACTIONS(5613),
    [anon_sym_long] = ACTIONS(5613),
    [anon_sym_short] = ACTIONS(5613),
    [anon_sym_LBRACK] = ACTIONS(5613),
    [anon_sym_static] = ACTIONS(5613),
    [anon_sym_register] = ACTIONS(5613),
    [anon_sym_inline] = ACTIONS(5613),
    [anon_sym___inline] = ACTIONS(5613),
    [anon_sym___inline__] = ACTIONS(5613),
    [anon_sym___forceinline] = ACTIONS(5613),
    [anon_sym_thread_local] = ACTIONS(5613),
    [anon_sym___thread] = ACTIONS(5613),
    [anon_sym_const] = ACTIONS(5613),
    [anon_sym_constexpr] = ACTIONS(5613),
    [anon_sym_volatile] = ACTIONS(5613),
    [anon_sym_restrict] = ACTIONS(5613),
    [anon_sym___restrict__] = ACTIONS(5613),
    [anon_sym__Atomic] = ACTIONS(5613),
    [anon_sym__Noreturn] = ACTIONS(5613),
    [anon_sym_noreturn] = ACTIONS(5613),
    [anon_sym__Nonnull] = ACTIONS(5613),
    [anon_sym_mutable] = ACTIONS(5613),
    [anon_sym_constinit] = ACTIONS(5613),
    [anon_sym_consteval] = ACTIONS(5613),
    [anon_sym_alignas] = ACTIONS(5613),
    [anon_sym__Alignas] = ACTIONS(5613),
    [sym_primitive_type] = ACTIONS(5613),
    [anon_sym_enum] = ACTIONS(5613),
    [anon_sym_class] = ACTIONS(5613),
    [anon_sym_struct] = ACTIONS(5613),
    [anon_sym_union] = ACTIONS(5613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5613),
    [anon_sym_decltype] = ACTIONS(5613),
    [anon_sym_explicit] = ACTIONS(5613),
    [anon_sym_typename] = ACTIONS(5613),
    [anon_sym_private] = ACTIONS(5613),
    [anon_sym_template] = ACTIONS(5613),
    [anon_sym_operator] = ACTIONS(5613),
    [anon_sym_friend] = ACTIONS(5613),
    [anon_sym_public] = ACTIONS(5613),
    [anon_sym_protected] = ACTIONS(5613),
    [anon_sym_static_assert] = ACTIONS(5613),
  },
  [2001] = {
    [sym_identifier] = ACTIONS(5621),
    [aux_sym_preproc_def_token1] = ACTIONS(5621),
    [aux_sym_preproc_if_token1] = ACTIONS(5621),
    [aux_sym_preproc_if_token2] = ACTIONS(5621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5621),
    [sym_preproc_directive] = ACTIONS(5621),
    [anon_sym_LPAREN2] = ACTIONS(5623),
    [anon_sym_TILDE] = ACTIONS(5623),
    [anon_sym_STAR] = ACTIONS(5623),
    [anon_sym_AMP_AMP] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5621),
    [anon_sym_SEMI] = ACTIONS(5623),
    [anon_sym___extension__] = ACTIONS(5621),
    [anon_sym_typedef] = ACTIONS(5621),
    [anon_sym_virtual] = ACTIONS(5621),
    [anon_sym_extern] = ACTIONS(5621),
    [anon_sym___attribute__] = ACTIONS(5621),
    [anon_sym___attribute] = ACTIONS(5621),
    [anon_sym_using] = ACTIONS(5621),
    [anon_sym_COLON_COLON] = ACTIONS(5623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5623),
    [anon_sym___declspec] = ACTIONS(5621),
    [anon_sym___based] = ACTIONS(5621),
    [anon_sym_signed] = ACTIONS(5621),
    [anon_sym_unsigned] = ACTIONS(5621),
    [anon_sym_long] = ACTIONS(5621),
    [anon_sym_short] = ACTIONS(5621),
    [anon_sym_LBRACK] = ACTIONS(5621),
    [anon_sym_static] = ACTIONS(5621),
    [anon_sym_register] = ACTIONS(5621),
    [anon_sym_inline] = ACTIONS(5621),
    [anon_sym___inline] = ACTIONS(5621),
    [anon_sym___inline__] = ACTIONS(5621),
    [anon_sym___forceinline] = ACTIONS(5621),
    [anon_sym_thread_local] = ACTIONS(5621),
    [anon_sym___thread] = ACTIONS(5621),
    [anon_sym_const] = ACTIONS(5621),
    [anon_sym_constexpr] = ACTIONS(5621),
    [anon_sym_volatile] = ACTIONS(5621),
    [anon_sym_restrict] = ACTIONS(5621),
    [anon_sym___restrict__] = ACTIONS(5621),
    [anon_sym__Atomic] = ACTIONS(5621),
    [anon_sym__Noreturn] = ACTIONS(5621),
    [anon_sym_noreturn] = ACTIONS(5621),
    [anon_sym__Nonnull] = ACTIONS(5621),
    [anon_sym_mutable] = ACTIONS(5621),
    [anon_sym_constinit] = ACTIONS(5621),
    [anon_sym_consteval] = ACTIONS(5621),
    [anon_sym_alignas] = ACTIONS(5621),
    [anon_sym__Alignas] = ACTIONS(5621),
    [sym_primitive_type] = ACTIONS(5621),
    [anon_sym_enum] = ACTIONS(5621),
    [anon_sym_class] = ACTIONS(5621),
    [anon_sym_struct] = ACTIONS(5621),
    [anon_sym_union] = ACTIONS(5621),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5621),
    [anon_sym_decltype] = ACTIONS(5621),
    [anon_sym_explicit] = ACTIONS(5621),
    [anon_sym_typename] = ACTIONS(5621),
    [anon_sym_private] = ACTIONS(5621),
    [anon_sym_template] = ACTIONS(5621),
    [anon_sym_operator] = ACTIONS(5621),
    [anon_sym_friend] = ACTIONS(5621),
    [anon_sym_public] = ACTIONS(5621),
    [anon_sym_protected] = ACTIONS(5621),
    [anon_sym_static_assert] = ACTIONS(5621),
  },
  [2002] = {
    [sym_identifier] = ACTIONS(5633),
    [aux_sym_preproc_def_token1] = ACTIONS(5633),
    [aux_sym_preproc_if_token1] = ACTIONS(5633),
    [aux_sym_preproc_if_token2] = ACTIONS(5633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5633),
    [sym_preproc_directive] = ACTIONS(5633),
    [anon_sym_LPAREN2] = ACTIONS(5635),
    [anon_sym_TILDE] = ACTIONS(5635),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_AMP_AMP] = ACTIONS(5635),
    [anon_sym_AMP] = ACTIONS(5633),
    [anon_sym_SEMI] = ACTIONS(5635),
    [anon_sym___extension__] = ACTIONS(5633),
    [anon_sym_typedef] = ACTIONS(5633),
    [anon_sym_virtual] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym___attribute__] = ACTIONS(5633),
    [anon_sym___attribute] = ACTIONS(5633),
    [anon_sym_using] = ACTIONS(5633),
    [anon_sym_COLON_COLON] = ACTIONS(5635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5635),
    [anon_sym___declspec] = ACTIONS(5633),
    [anon_sym___based] = ACTIONS(5633),
    [anon_sym_signed] = ACTIONS(5633),
    [anon_sym_unsigned] = ACTIONS(5633),
    [anon_sym_long] = ACTIONS(5633),
    [anon_sym_short] = ACTIONS(5633),
    [anon_sym_LBRACK] = ACTIONS(5633),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_register] = ACTIONS(5633),
    [anon_sym_inline] = ACTIONS(5633),
    [anon_sym___inline] = ACTIONS(5633),
    [anon_sym___inline__] = ACTIONS(5633),
    [anon_sym___forceinline] = ACTIONS(5633),
    [anon_sym_thread_local] = ACTIONS(5633),
    [anon_sym___thread] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym___restrict__] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym__Noreturn] = ACTIONS(5633),
    [anon_sym_noreturn] = ACTIONS(5633),
    [anon_sym__Nonnull] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_constinit] = ACTIONS(5633),
    [anon_sym_consteval] = ACTIONS(5633),
    [anon_sym_alignas] = ACTIONS(5633),
    [anon_sym__Alignas] = ACTIONS(5633),
    [sym_primitive_type] = ACTIONS(5633),
    [anon_sym_enum] = ACTIONS(5633),
    [anon_sym_class] = ACTIONS(5633),
    [anon_sym_struct] = ACTIONS(5633),
    [anon_sym_union] = ACTIONS(5633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_decltype] = ACTIONS(5633),
    [anon_sym_explicit] = ACTIONS(5633),
    [anon_sym_typename] = ACTIONS(5633),
    [anon_sym_private] = ACTIONS(5633),
    [anon_sym_template] = ACTIONS(5633),
    [anon_sym_operator] = ACTIONS(5633),
    [anon_sym_friend] = ACTIONS(5633),
    [anon_sym_public] = ACTIONS(5633),
    [anon_sym_protected] = ACTIONS(5633),
    [anon_sym_static_assert] = ACTIONS(5633),
  },
  [2003] = {
    [sym_identifier] = ACTIONS(5446),
    [aux_sym_preproc_def_token1] = ACTIONS(5446),
    [aux_sym_preproc_if_token1] = ACTIONS(5446),
    [aux_sym_preproc_if_token2] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5446),
    [sym_preproc_directive] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5448),
    [anon_sym_TILDE] = ACTIONS(5448),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym___extension__] = ACTIONS(5446),
    [anon_sym_typedef] = ACTIONS(5446),
    [anon_sym_virtual] = ACTIONS(5446),
    [anon_sym_extern] = ACTIONS(5446),
    [anon_sym___attribute__] = ACTIONS(5446),
    [anon_sym___attribute] = ACTIONS(5446),
    [anon_sym_using] = ACTIONS(5446),
    [anon_sym_COLON_COLON] = ACTIONS(5448),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5448),
    [anon_sym___declspec] = ACTIONS(5446),
    [anon_sym___based] = ACTIONS(5446),
    [anon_sym_signed] = ACTIONS(5446),
    [anon_sym_unsigned] = ACTIONS(5446),
    [anon_sym_long] = ACTIONS(5446),
    [anon_sym_short] = ACTIONS(5446),
    [anon_sym_LBRACK] = ACTIONS(5446),
    [anon_sym_static] = ACTIONS(5446),
    [anon_sym_register] = ACTIONS(5446),
    [anon_sym_inline] = ACTIONS(5446),
    [anon_sym___inline] = ACTIONS(5446),
    [anon_sym___inline__] = ACTIONS(5446),
    [anon_sym___forceinline] = ACTIONS(5446),
    [anon_sym_thread_local] = ACTIONS(5446),
    [anon_sym___thread] = ACTIONS(5446),
    [anon_sym_const] = ACTIONS(5446),
    [anon_sym_constexpr] = ACTIONS(5446),
    [anon_sym_volatile] = ACTIONS(5446),
    [anon_sym_restrict] = ACTIONS(5446),
    [anon_sym___restrict__] = ACTIONS(5446),
    [anon_sym__Atomic] = ACTIONS(5446),
    [anon_sym__Noreturn] = ACTIONS(5446),
    [anon_sym_noreturn] = ACTIONS(5446),
    [anon_sym__Nonnull] = ACTIONS(5446),
    [anon_sym_mutable] = ACTIONS(5446),
    [anon_sym_constinit] = ACTIONS(5446),
    [anon_sym_consteval] = ACTIONS(5446),
    [anon_sym_alignas] = ACTIONS(5446),
    [anon_sym__Alignas] = ACTIONS(5446),
    [sym_primitive_type] = ACTIONS(5446),
    [anon_sym_enum] = ACTIONS(5446),
    [anon_sym_class] = ACTIONS(5446),
    [anon_sym_struct] = ACTIONS(5446),
    [anon_sym_union] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5446),
    [anon_sym_decltype] = ACTIONS(5446),
    [anon_sym_explicit] = ACTIONS(5446),
    [anon_sym_typename] = ACTIONS(5446),
    [anon_sym_private] = ACTIONS(5446),
    [anon_sym_template] = ACTIONS(5446),
    [anon_sym_operator] = ACTIONS(5446),
    [anon_sym_friend] = ACTIONS(5446),
    [anon_sym_public] = ACTIONS(5446),
    [anon_sym_protected] = ACTIONS(5446),
    [anon_sym_static_assert] = ACTIONS(5446),
  },
  [2004] = {
    [sym_identifier] = ACTIONS(5446),
    [aux_sym_preproc_def_token1] = ACTIONS(5446),
    [aux_sym_preproc_if_token1] = ACTIONS(5446),
    [aux_sym_preproc_if_token2] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5446),
    [sym_preproc_directive] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5448),
    [anon_sym_TILDE] = ACTIONS(5448),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym___extension__] = ACTIONS(5446),
    [anon_sym_typedef] = ACTIONS(5446),
    [anon_sym_virtual] = ACTIONS(5446),
    [anon_sym_extern] = ACTIONS(5446),
    [anon_sym___attribute__] = ACTIONS(5446),
    [anon_sym___attribute] = ACTIONS(5446),
    [anon_sym_using] = ACTIONS(5446),
    [anon_sym_COLON_COLON] = ACTIONS(5448),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5448),
    [anon_sym___declspec] = ACTIONS(5446),
    [anon_sym___based] = ACTIONS(5446),
    [anon_sym_signed] = ACTIONS(5446),
    [anon_sym_unsigned] = ACTIONS(5446),
    [anon_sym_long] = ACTIONS(5446),
    [anon_sym_short] = ACTIONS(5446),
    [anon_sym_LBRACK] = ACTIONS(5446),
    [anon_sym_static] = ACTIONS(5446),
    [anon_sym_register] = ACTIONS(5446),
    [anon_sym_inline] = ACTIONS(5446),
    [anon_sym___inline] = ACTIONS(5446),
    [anon_sym___inline__] = ACTIONS(5446),
    [anon_sym___forceinline] = ACTIONS(5446),
    [anon_sym_thread_local] = ACTIONS(5446),
    [anon_sym___thread] = ACTIONS(5446),
    [anon_sym_const] = ACTIONS(5446),
    [anon_sym_constexpr] = ACTIONS(5446),
    [anon_sym_volatile] = ACTIONS(5446),
    [anon_sym_restrict] = ACTIONS(5446),
    [anon_sym___restrict__] = ACTIONS(5446),
    [anon_sym__Atomic] = ACTIONS(5446),
    [anon_sym__Noreturn] = ACTIONS(5446),
    [anon_sym_noreturn] = ACTIONS(5446),
    [anon_sym__Nonnull] = ACTIONS(5446),
    [anon_sym_mutable] = ACTIONS(5446),
    [anon_sym_constinit] = ACTIONS(5446),
    [anon_sym_consteval] = ACTIONS(5446),
    [anon_sym_alignas] = ACTIONS(5446),
    [anon_sym__Alignas] = ACTIONS(5446),
    [sym_primitive_type] = ACTIONS(5446),
    [anon_sym_enum] = ACTIONS(5446),
    [anon_sym_class] = ACTIONS(5446),
    [anon_sym_struct] = ACTIONS(5446),
    [anon_sym_union] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5446),
    [anon_sym_decltype] = ACTIONS(5446),
    [anon_sym_explicit] = ACTIONS(5446),
    [anon_sym_typename] = ACTIONS(5446),
    [anon_sym_private] = ACTIONS(5446),
    [anon_sym_template] = ACTIONS(5446),
    [anon_sym_operator] = ACTIONS(5446),
    [anon_sym_friend] = ACTIONS(5446),
    [anon_sym_public] = ACTIONS(5446),
    [anon_sym_protected] = ACTIONS(5446),
    [anon_sym_static_assert] = ACTIONS(5446),
  },
  [2005] = {
    [sym_string_literal] = STATE(2010),
    [sym_raw_string_literal] = STATE(2010),
    [aux_sym_concatenated_string_repeat1] = STATE(2010),
    [sym_identifier] = ACTIONS(5960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_LPAREN2] = ACTIONS(5396),
    [anon_sym_DASH] = ACTIONS(5398),
    [anon_sym_PLUS] = ACTIONS(5398),
    [anon_sym_STAR] = ACTIONS(5398),
    [anon_sym_SLASH] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5398),
    [anon_sym_PIPE_PIPE] = ACTIONS(5396),
    [anon_sym_AMP_AMP] = ACTIONS(5396),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_CARET] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
    [anon_sym_EQ_EQ] = ACTIONS(5396),
    [anon_sym_BANG_EQ] = ACTIONS(5396),
    [anon_sym_GT] = ACTIONS(5398),
    [anon_sym_GT_EQ] = ACTIONS(5396),
    [anon_sym_LT_EQ] = ACTIONS(5398),
    [anon_sym_LT] = ACTIONS(5398),
    [anon_sym_LT_LT] = ACTIONS(5398),
    [anon_sym_GT_GT] = ACTIONS(5398),
    [anon_sym_SEMI] = ACTIONS(5396),
    [anon_sym___attribute__] = ACTIONS(5398),
    [anon_sym___attribute] = ACTIONS(5398),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_EQ] = ACTIONS(5398),
    [anon_sym_QMARK] = ACTIONS(5396),
    [anon_sym_STAR_EQ] = ACTIONS(5396),
    [anon_sym_SLASH_EQ] = ACTIONS(5396),
    [anon_sym_PERCENT_EQ] = ACTIONS(5396),
    [anon_sym_PLUS_EQ] = ACTIONS(5396),
    [anon_sym_DASH_EQ] = ACTIONS(5396),
    [anon_sym_LT_LT_EQ] = ACTIONS(5396),
    [anon_sym_GT_GT_EQ] = ACTIONS(5396),
    [anon_sym_AMP_EQ] = ACTIONS(5396),
    [anon_sym_CARET_EQ] = ACTIONS(5396),
    [anon_sym_PIPE_EQ] = ACTIONS(5396),
    [anon_sym_and_eq] = ACTIONS(5398),
    [anon_sym_or_eq] = ACTIONS(5398),
    [anon_sym_xor_eq] = ACTIONS(5398),
    [anon_sym_LT_EQ_GT] = ACTIONS(5396),
    [anon_sym_or] = ACTIONS(5398),
    [anon_sym_and] = ACTIONS(5398),
    [anon_sym_bitor] = ACTIONS(5398),
    [anon_sym_xor] = ACTIONS(5398),
    [anon_sym_bitand] = ACTIONS(5398),
    [anon_sym_not_eq] = ACTIONS(5398),
    [anon_sym_DASH_DASH] = ACTIONS(5396),
    [anon_sym_PLUS_PLUS] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(5398),
    [anon_sym_DOT_STAR] = ACTIONS(5396),
    [anon_sym_DASH_GT] = ACTIONS(5396),
    [anon_sym_L_DQUOTE] = ACTIONS(5954),
    [anon_sym_u_DQUOTE] = ACTIONS(5954),
    [anon_sym_U_DQUOTE] = ACTIONS(5954),
    [anon_sym_u8_DQUOTE] = ACTIONS(5954),
    [anon_sym_DQUOTE] = ACTIONS(5954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5956),
    [anon_sym_LR_DQUOTE] = ACTIONS(5956),
    [anon_sym_uR_DQUOTE] = ACTIONS(5956),
    [anon_sym_UR_DQUOTE] = ACTIONS(5956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5956),
    [sym_literal_suffix] = ACTIONS(5398),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(2711),
    [aux_sym_preproc_def_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token2] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2711),
    [sym_preproc_directive] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym___extension__] = ACTIONS(2711),
    [anon_sym_typedef] = ACTIONS(2711),
    [anon_sym_virtual] = ACTIONS(2711),
    [anon_sym_extern] = ACTIONS(2711),
    [anon_sym___attribute__] = ACTIONS(2711),
    [anon_sym___attribute] = ACTIONS(2711),
    [anon_sym_using] = ACTIONS(2711),
    [anon_sym_COLON_COLON] = ACTIONS(2713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2713),
    [anon_sym___declspec] = ACTIONS(2711),
    [anon_sym___based] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2711),
    [anon_sym_unsigned] = ACTIONS(2711),
    [anon_sym_long] = ACTIONS(2711),
    [anon_sym_short] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_static] = ACTIONS(2711),
    [anon_sym_register] = ACTIONS(2711),
    [anon_sym_inline] = ACTIONS(2711),
    [anon_sym___inline] = ACTIONS(2711),
    [anon_sym___inline__] = ACTIONS(2711),
    [anon_sym___forceinline] = ACTIONS(2711),
    [anon_sym_thread_local] = ACTIONS(2711),
    [anon_sym___thread] = ACTIONS(2711),
    [anon_sym_const] = ACTIONS(2711),
    [anon_sym_constexpr] = ACTIONS(2711),
    [anon_sym_volatile] = ACTIONS(2711),
    [anon_sym_restrict] = ACTIONS(2711),
    [anon_sym___restrict__] = ACTIONS(2711),
    [anon_sym__Atomic] = ACTIONS(2711),
    [anon_sym__Noreturn] = ACTIONS(2711),
    [anon_sym_noreturn] = ACTIONS(2711),
    [anon_sym__Nonnull] = ACTIONS(2711),
    [anon_sym_mutable] = ACTIONS(2711),
    [anon_sym_constinit] = ACTIONS(2711),
    [anon_sym_consteval] = ACTIONS(2711),
    [anon_sym_alignas] = ACTIONS(2711),
    [anon_sym__Alignas] = ACTIONS(2711),
    [sym_primitive_type] = ACTIONS(2711),
    [anon_sym_enum] = ACTIONS(2711),
    [anon_sym_class] = ACTIONS(2711),
    [anon_sym_struct] = ACTIONS(2711),
    [anon_sym_union] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2711),
    [anon_sym_decltype] = ACTIONS(2711),
    [anon_sym_explicit] = ACTIONS(2711),
    [anon_sym_typename] = ACTIONS(2711),
    [anon_sym_private] = ACTIONS(2711),
    [anon_sym_template] = ACTIONS(2711),
    [anon_sym_operator] = ACTIONS(2711),
    [anon_sym_friend] = ACTIONS(2711),
    [anon_sym_public] = ACTIONS(2711),
    [anon_sym_protected] = ACTIONS(2711),
    [anon_sym_static_assert] = ACTIONS(2711),
  },
  [2007] = {
    [sym_identifier] = ACTIONS(3309),
    [aux_sym_preproc_def_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3309),
    [sym_preproc_directive] = ACTIONS(3309),
    [anon_sym_LPAREN2] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_AMP_AMP] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym___extension__] = ACTIONS(3309),
    [anon_sym_typedef] = ACTIONS(3309),
    [anon_sym_virtual] = ACTIONS(3309),
    [anon_sym_extern] = ACTIONS(3309),
    [anon_sym___attribute__] = ACTIONS(3309),
    [anon_sym___attribute] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_COLON_COLON] = ACTIONS(3311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3311),
    [anon_sym___declspec] = ACTIONS(3309),
    [anon_sym___based] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3311),
    [anon_sym_signed] = ACTIONS(3309),
    [anon_sym_unsigned] = ACTIONS(3309),
    [anon_sym_long] = ACTIONS(3309),
    [anon_sym_short] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_register] = ACTIONS(3309),
    [anon_sym_inline] = ACTIONS(3309),
    [anon_sym___inline] = ACTIONS(3309),
    [anon_sym___inline__] = ACTIONS(3309),
    [anon_sym___forceinline] = ACTIONS(3309),
    [anon_sym_thread_local] = ACTIONS(3309),
    [anon_sym___thread] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_constexpr] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(3309),
    [anon_sym_restrict] = ACTIONS(3309),
    [anon_sym___restrict__] = ACTIONS(3309),
    [anon_sym__Atomic] = ACTIONS(3309),
    [anon_sym__Noreturn] = ACTIONS(3309),
    [anon_sym_noreturn] = ACTIONS(3309),
    [anon_sym__Nonnull] = ACTIONS(3309),
    [anon_sym_mutable] = ACTIONS(3309),
    [anon_sym_constinit] = ACTIONS(3309),
    [anon_sym_consteval] = ACTIONS(3309),
    [anon_sym_alignas] = ACTIONS(3309),
    [anon_sym__Alignas] = ACTIONS(3309),
    [sym_primitive_type] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_struct] = ACTIONS(3309),
    [anon_sym_union] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3309),
    [anon_sym_decltype] = ACTIONS(3309),
    [anon_sym_explicit] = ACTIONS(3309),
    [anon_sym_typename] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_template] = ACTIONS(3309),
    [anon_sym_operator] = ACTIONS(3309),
    [anon_sym_friend] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_static_assert] = ACTIONS(3309),
  },
  [2008] = {
    [sym_identifier] = ACTIONS(5525),
    [aux_sym_preproc_def_token1] = ACTIONS(5525),
    [aux_sym_preproc_if_token1] = ACTIONS(5525),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5525),
    [sym_preproc_directive] = ACTIONS(5525),
    [anon_sym_LPAREN2] = ACTIONS(5527),
    [anon_sym_TILDE] = ACTIONS(5527),
    [anon_sym_STAR] = ACTIONS(5527),
    [anon_sym_AMP_AMP] = ACTIONS(5527),
    [anon_sym_AMP] = ACTIONS(5525),
    [anon_sym_SEMI] = ACTIONS(5527),
    [anon_sym___extension__] = ACTIONS(5525),
    [anon_sym_typedef] = ACTIONS(5525),
    [anon_sym_virtual] = ACTIONS(5525),
    [anon_sym_extern] = ACTIONS(5525),
    [anon_sym___attribute__] = ACTIONS(5525),
    [anon_sym___attribute] = ACTIONS(5525),
    [anon_sym_using] = ACTIONS(5525),
    [anon_sym_COLON_COLON] = ACTIONS(5527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5527),
    [anon_sym___declspec] = ACTIONS(5525),
    [anon_sym___based] = ACTIONS(5525),
    [anon_sym_RBRACE] = ACTIONS(5527),
    [anon_sym_signed] = ACTIONS(5525),
    [anon_sym_unsigned] = ACTIONS(5525),
    [anon_sym_long] = ACTIONS(5525),
    [anon_sym_short] = ACTIONS(5525),
    [anon_sym_LBRACK] = ACTIONS(5525),
    [anon_sym_static] = ACTIONS(5525),
    [anon_sym_register] = ACTIONS(5525),
    [anon_sym_inline] = ACTIONS(5525),
    [anon_sym___inline] = ACTIONS(5525),
    [anon_sym___inline__] = ACTIONS(5525),
    [anon_sym___forceinline] = ACTIONS(5525),
    [anon_sym_thread_local] = ACTIONS(5525),
    [anon_sym___thread] = ACTIONS(5525),
    [anon_sym_const] = ACTIONS(5525),
    [anon_sym_constexpr] = ACTIONS(5525),
    [anon_sym_volatile] = ACTIONS(5525),
    [anon_sym_restrict] = ACTIONS(5525),
    [anon_sym___restrict__] = ACTIONS(5525),
    [anon_sym__Atomic] = ACTIONS(5525),
    [anon_sym__Noreturn] = ACTIONS(5525),
    [anon_sym_noreturn] = ACTIONS(5525),
    [anon_sym__Nonnull] = ACTIONS(5525),
    [anon_sym_mutable] = ACTIONS(5525),
    [anon_sym_constinit] = ACTIONS(5525),
    [anon_sym_consteval] = ACTIONS(5525),
    [anon_sym_alignas] = ACTIONS(5525),
    [anon_sym__Alignas] = ACTIONS(5525),
    [sym_primitive_type] = ACTIONS(5525),
    [anon_sym_enum] = ACTIONS(5525),
    [anon_sym_class] = ACTIONS(5525),
    [anon_sym_struct] = ACTIONS(5525),
    [anon_sym_union] = ACTIONS(5525),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5525),
    [anon_sym_decltype] = ACTIONS(5525),
    [anon_sym_explicit] = ACTIONS(5525),
    [anon_sym_typename] = ACTIONS(5525),
    [anon_sym_private] = ACTIONS(5525),
    [anon_sym_template] = ACTIONS(5525),
    [anon_sym_operator] = ACTIONS(5525),
    [anon_sym_friend] = ACTIONS(5525),
    [anon_sym_public] = ACTIONS(5525),
    [anon_sym_protected] = ACTIONS(5525),
    [anon_sym_static_assert] = ACTIONS(5525),
  },
  [2009] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token2] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_friend] = ACTIONS(2911),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
  },
  [2010] = {
    [sym_string_literal] = STATE(2010),
    [sym_raw_string_literal] = STATE(2010),
    [aux_sym_concatenated_string_repeat1] = STATE(2010),
    [sym_identifier] = ACTIONS(5962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_LPAREN2] = ACTIONS(5403),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5405),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5405),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_CARET] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_LT_EQ] = ACTIONS(5405),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5405),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym___attribute__] = ACTIONS(5405),
    [anon_sym___attribute] = ACTIONS(5405),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_EQ] = ACTIONS(5405),
    [anon_sym_QMARK] = ACTIONS(5403),
    [anon_sym_STAR_EQ] = ACTIONS(5403),
    [anon_sym_SLASH_EQ] = ACTIONS(5403),
    [anon_sym_PERCENT_EQ] = ACTIONS(5403),
    [anon_sym_PLUS_EQ] = ACTIONS(5403),
    [anon_sym_DASH_EQ] = ACTIONS(5403),
    [anon_sym_LT_LT_EQ] = ACTIONS(5403),
    [anon_sym_GT_GT_EQ] = ACTIONS(5403),
    [anon_sym_AMP_EQ] = ACTIONS(5403),
    [anon_sym_CARET_EQ] = ACTIONS(5403),
    [anon_sym_PIPE_EQ] = ACTIONS(5403),
    [anon_sym_and_eq] = ACTIONS(5405),
    [anon_sym_or_eq] = ACTIONS(5405),
    [anon_sym_xor_eq] = ACTIONS(5405),
    [anon_sym_LT_EQ_GT] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5405),
    [anon_sym_and] = ACTIONS(5405),
    [anon_sym_bitor] = ACTIONS(5405),
    [anon_sym_xor] = ACTIONS(5405),
    [anon_sym_bitand] = ACTIONS(5405),
    [anon_sym_not_eq] = ACTIONS(5405),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_DOT_STAR] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5403),
    [anon_sym_L_DQUOTE] = ACTIONS(5965),
    [anon_sym_u_DQUOTE] = ACTIONS(5965),
    [anon_sym_U_DQUOTE] = ACTIONS(5965),
    [anon_sym_u8_DQUOTE] = ACTIONS(5965),
    [anon_sym_DQUOTE] = ACTIONS(5965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5968),
    [anon_sym_LR_DQUOTE] = ACTIONS(5968),
    [anon_sym_uR_DQUOTE] = ACTIONS(5968),
    [anon_sym_UR_DQUOTE] = ACTIONS(5968),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5968),
    [sym_literal_suffix] = ACTIONS(5405),
  },
  [2011] = {
    [sym_identifier] = ACTIONS(2699),
    [aux_sym_preproc_def_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token2] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2699),
    [sym_preproc_directive] = ACTIONS(2699),
    [anon_sym_LPAREN2] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_AMP_AMP] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym___extension__] = ACTIONS(2699),
    [anon_sym_typedef] = ACTIONS(2699),
    [anon_sym_virtual] = ACTIONS(2699),
    [anon_sym_extern] = ACTIONS(2699),
    [anon_sym___attribute__] = ACTIONS(2699),
    [anon_sym___attribute] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2701),
    [anon_sym___declspec] = ACTIONS(2699),
    [anon_sym___based] = ACTIONS(2699),
    [anon_sym_signed] = ACTIONS(2699),
    [anon_sym_unsigned] = ACTIONS(2699),
    [anon_sym_long] = ACTIONS(2699),
    [anon_sym_short] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_register] = ACTIONS(2699),
    [anon_sym_inline] = ACTIONS(2699),
    [anon_sym___inline] = ACTIONS(2699),
    [anon_sym___inline__] = ACTIONS(2699),
    [anon_sym___forceinline] = ACTIONS(2699),
    [anon_sym_thread_local] = ACTIONS(2699),
    [anon_sym___thread] = ACTIONS(2699),
    [anon_sym_const] = ACTIONS(2699),
    [anon_sym_constexpr] = ACTIONS(2699),
    [anon_sym_volatile] = ACTIONS(2699),
    [anon_sym_restrict] = ACTIONS(2699),
    [anon_sym___restrict__] = ACTIONS(2699),
    [anon_sym__Atomic] = ACTIONS(2699),
    [anon_sym__Noreturn] = ACTIONS(2699),
    [anon_sym_noreturn] = ACTIONS(2699),
    [anon_sym__Nonnull] = ACTIONS(2699),
    [anon_sym_mutable] = ACTIONS(2699),
    [anon_sym_constinit] = ACTIONS(2699),
    [anon_sym_consteval] = ACTIONS(2699),
    [anon_sym_alignas] = ACTIONS(2699),
    [anon_sym__Alignas] = ACTIONS(2699),
    [sym_primitive_type] = ACTIONS(2699),
    [anon_sym_enum] = ACTIONS(2699),
    [anon_sym_class] = ACTIONS(2699),
    [anon_sym_struct] = ACTIONS(2699),
    [anon_sym_union] = ACTIONS(2699),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2699),
    [anon_sym_decltype] = ACTIONS(2699),
    [anon_sym_explicit] = ACTIONS(2699),
    [anon_sym_typename] = ACTIONS(2699),
    [anon_sym_private] = ACTIONS(2699),
    [anon_sym_template] = ACTIONS(2699),
    [anon_sym_operator] = ACTIONS(2699),
    [anon_sym_friend] = ACTIONS(2699),
    [anon_sym_public] = ACTIONS(2699),
    [anon_sym_protected] = ACTIONS(2699),
    [anon_sym_static_assert] = ACTIONS(2699),
  },
  [2012] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym___attribute] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym__Nonnull] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym__Alignas] = ACTIONS(2639),
    [sym_primitive_type] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_friend] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
  },
  [2013] = {
    [sym_identifier] = ACTIONS(2955),
    [aux_sym_preproc_def_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token2] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2955),
    [sym_preproc_directive] = ACTIONS(2955),
    [anon_sym_LPAREN2] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym___extension__] = ACTIONS(2955),
    [anon_sym_typedef] = ACTIONS(2955),
    [anon_sym_virtual] = ACTIONS(2955),
    [anon_sym_extern] = ACTIONS(2955),
    [anon_sym___attribute__] = ACTIONS(2955),
    [anon_sym___attribute] = ACTIONS(2955),
    [anon_sym_using] = ACTIONS(2955),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2957),
    [anon_sym___declspec] = ACTIONS(2955),
    [anon_sym___based] = ACTIONS(2955),
    [anon_sym_signed] = ACTIONS(2955),
    [anon_sym_unsigned] = ACTIONS(2955),
    [anon_sym_long] = ACTIONS(2955),
    [anon_sym_short] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_register] = ACTIONS(2955),
    [anon_sym_inline] = ACTIONS(2955),
    [anon_sym___inline] = ACTIONS(2955),
    [anon_sym___inline__] = ACTIONS(2955),
    [anon_sym___forceinline] = ACTIONS(2955),
    [anon_sym_thread_local] = ACTIONS(2955),
    [anon_sym___thread] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_constexpr] = ACTIONS(2955),
    [anon_sym_volatile] = ACTIONS(2955),
    [anon_sym_restrict] = ACTIONS(2955),
    [anon_sym___restrict__] = ACTIONS(2955),
    [anon_sym__Atomic] = ACTIONS(2955),
    [anon_sym__Noreturn] = ACTIONS(2955),
    [anon_sym_noreturn] = ACTIONS(2955),
    [anon_sym__Nonnull] = ACTIONS(2955),
    [anon_sym_mutable] = ACTIONS(2955),
    [anon_sym_constinit] = ACTIONS(2955),
    [anon_sym_consteval] = ACTIONS(2955),
    [anon_sym_alignas] = ACTIONS(2955),
    [anon_sym__Alignas] = ACTIONS(2955),
    [sym_primitive_type] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2955),
    [anon_sym_union] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2955),
    [anon_sym_decltype] = ACTIONS(2955),
    [anon_sym_explicit] = ACTIONS(2955),
    [anon_sym_typename] = ACTIONS(2955),
    [anon_sym_private] = ACTIONS(2955),
    [anon_sym_template] = ACTIONS(2955),
    [anon_sym_operator] = ACTIONS(2955),
    [anon_sym_friend] = ACTIONS(2955),
    [anon_sym_public] = ACTIONS(2955),
    [anon_sym_protected] = ACTIONS(2955),
    [anon_sym_static_assert] = ACTIONS(2955),
  },
  [2014] = {
    [sym_identifier] = ACTIONS(3067),
    [aux_sym_preproc_def_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3067),
    [sym_preproc_directive] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym___extension__] = ACTIONS(3067),
    [anon_sym_typedef] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym___attribute__] = ACTIONS(3067),
    [anon_sym___attribute] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3069),
    [anon_sym___declspec] = ACTIONS(3067),
    [anon_sym___based] = ACTIONS(3067),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_signed] = ACTIONS(3067),
    [anon_sym_unsigned] = ACTIONS(3067),
    [anon_sym_long] = ACTIONS(3067),
    [anon_sym_short] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_register] = ACTIONS(3067),
    [anon_sym_inline] = ACTIONS(3067),
    [anon_sym___inline] = ACTIONS(3067),
    [anon_sym___inline__] = ACTIONS(3067),
    [anon_sym___forceinline] = ACTIONS(3067),
    [anon_sym_thread_local] = ACTIONS(3067),
    [anon_sym___thread] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_constexpr] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_restrict] = ACTIONS(3067),
    [anon_sym___restrict__] = ACTIONS(3067),
    [anon_sym__Atomic] = ACTIONS(3067),
    [anon_sym__Noreturn] = ACTIONS(3067),
    [anon_sym_noreturn] = ACTIONS(3067),
    [anon_sym__Nonnull] = ACTIONS(3067),
    [anon_sym_mutable] = ACTIONS(3067),
    [anon_sym_constinit] = ACTIONS(3067),
    [anon_sym_consteval] = ACTIONS(3067),
    [anon_sym_alignas] = ACTIONS(3067),
    [anon_sym__Alignas] = ACTIONS(3067),
    [sym_primitive_type] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_union] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3067),
    [anon_sym_decltype] = ACTIONS(3067),
    [anon_sym_explicit] = ACTIONS(3067),
    [anon_sym_typename] = ACTIONS(3067),
    [anon_sym_private] = ACTIONS(3067),
    [anon_sym_template] = ACTIONS(3067),
    [anon_sym_operator] = ACTIONS(3067),
    [anon_sym_friend] = ACTIONS(3067),
    [anon_sym_public] = ACTIONS(3067),
    [anon_sym_protected] = ACTIONS(3067),
    [anon_sym_static_assert] = ACTIONS(3067),
  },
  [2015] = {
    [sym_identifier] = ACTIONS(3071),
    [aux_sym_preproc_def_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3071),
    [sym_preproc_directive] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym___extension__] = ACTIONS(3071),
    [anon_sym_typedef] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym___attribute__] = ACTIONS(3071),
    [anon_sym___attribute] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3073),
    [anon_sym___declspec] = ACTIONS(3071),
    [anon_sym___based] = ACTIONS(3071),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_signed] = ACTIONS(3071),
    [anon_sym_unsigned] = ACTIONS(3071),
    [anon_sym_long] = ACTIONS(3071),
    [anon_sym_short] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_register] = ACTIONS(3071),
    [anon_sym_inline] = ACTIONS(3071),
    [anon_sym___inline] = ACTIONS(3071),
    [anon_sym___inline__] = ACTIONS(3071),
    [anon_sym___forceinline] = ACTIONS(3071),
    [anon_sym_thread_local] = ACTIONS(3071),
    [anon_sym___thread] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_constexpr] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_restrict] = ACTIONS(3071),
    [anon_sym___restrict__] = ACTIONS(3071),
    [anon_sym__Atomic] = ACTIONS(3071),
    [anon_sym__Noreturn] = ACTIONS(3071),
    [anon_sym_noreturn] = ACTIONS(3071),
    [anon_sym__Nonnull] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_constinit] = ACTIONS(3071),
    [anon_sym_consteval] = ACTIONS(3071),
    [anon_sym_alignas] = ACTIONS(3071),
    [anon_sym__Alignas] = ACTIONS(3071),
    [sym_primitive_type] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_union] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3071),
    [anon_sym_decltype] = ACTIONS(3071),
    [anon_sym_explicit] = ACTIONS(3071),
    [anon_sym_typename] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_template] = ACTIONS(3071),
    [anon_sym_operator] = ACTIONS(3071),
    [anon_sym_friend] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_static_assert] = ACTIONS(3071),
  },
  [2016] = {
    [sym_identifier] = ACTIONS(2651),
    [aux_sym_preproc_def_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token2] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2651),
    [sym_preproc_directive] = ACTIONS(2651),
    [anon_sym_LPAREN2] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym___extension__] = ACTIONS(2651),
    [anon_sym_typedef] = ACTIONS(2651),
    [anon_sym_virtual] = ACTIONS(2651),
    [anon_sym_extern] = ACTIONS(2651),
    [anon_sym___attribute__] = ACTIONS(2651),
    [anon_sym___attribute] = ACTIONS(2651),
    [anon_sym_using] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2653),
    [anon_sym___declspec] = ACTIONS(2651),
    [anon_sym___based] = ACTIONS(2651),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2651),
    [anon_sym_register] = ACTIONS(2651),
    [anon_sym_inline] = ACTIONS(2651),
    [anon_sym___inline] = ACTIONS(2651),
    [anon_sym___inline__] = ACTIONS(2651),
    [anon_sym___forceinline] = ACTIONS(2651),
    [anon_sym_thread_local] = ACTIONS(2651),
    [anon_sym___thread] = ACTIONS(2651),
    [anon_sym_const] = ACTIONS(2651),
    [anon_sym_constexpr] = ACTIONS(2651),
    [anon_sym_volatile] = ACTIONS(2651),
    [anon_sym_restrict] = ACTIONS(2651),
    [anon_sym___restrict__] = ACTIONS(2651),
    [anon_sym__Atomic] = ACTIONS(2651),
    [anon_sym__Noreturn] = ACTIONS(2651),
    [anon_sym_noreturn] = ACTIONS(2651),
    [anon_sym__Nonnull] = ACTIONS(2651),
    [anon_sym_mutable] = ACTIONS(2651),
    [anon_sym_constinit] = ACTIONS(2651),
    [anon_sym_consteval] = ACTIONS(2651),
    [anon_sym_alignas] = ACTIONS(2651),
    [anon_sym__Alignas] = ACTIONS(2651),
    [sym_primitive_type] = ACTIONS(2651),
    [anon_sym_enum] = ACTIONS(2651),
    [anon_sym_class] = ACTIONS(2651),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_union] = ACTIONS(2651),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2651),
    [anon_sym_decltype] = ACTIONS(2651),
    [anon_sym_explicit] = ACTIONS(2651),
    [anon_sym_typename] = ACTIONS(2651),
    [anon_sym_private] = ACTIONS(2651),
    [anon_sym_template] = ACTIONS(2651),
    [anon_sym_operator] = ACTIONS(2651),
    [anon_sym_friend] = ACTIONS(2651),
    [anon_sym_public] = ACTIONS(2651),
    [anon_sym_protected] = ACTIONS(2651),
    [anon_sym_static_assert] = ACTIONS(2651),
  },
  [2017] = {
    [sym_identifier] = ACTIONS(3079),
    [aux_sym_preproc_def_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token2] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3079),
    [sym_preproc_directive] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_AMP_AMP] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym___extension__] = ACTIONS(3079),
    [anon_sym_typedef] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym___attribute__] = ACTIONS(3079),
    [anon_sym___attribute] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3081),
    [anon_sym___declspec] = ACTIONS(3079),
    [anon_sym___based] = ACTIONS(3079),
    [anon_sym_signed] = ACTIONS(3079),
    [anon_sym_unsigned] = ACTIONS(3079),
    [anon_sym_long] = ACTIONS(3079),
    [anon_sym_short] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_register] = ACTIONS(3079),
    [anon_sym_inline] = ACTIONS(3079),
    [anon_sym___inline] = ACTIONS(3079),
    [anon_sym___inline__] = ACTIONS(3079),
    [anon_sym___forceinline] = ACTIONS(3079),
    [anon_sym_thread_local] = ACTIONS(3079),
    [anon_sym___thread] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_constexpr] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_restrict] = ACTIONS(3079),
    [anon_sym___restrict__] = ACTIONS(3079),
    [anon_sym__Atomic] = ACTIONS(3079),
    [anon_sym__Noreturn] = ACTIONS(3079),
    [anon_sym_noreturn] = ACTIONS(3079),
    [anon_sym__Nonnull] = ACTIONS(3079),
    [anon_sym_mutable] = ACTIONS(3079),
    [anon_sym_constinit] = ACTIONS(3079),
    [anon_sym_consteval] = ACTIONS(3079),
    [anon_sym_alignas] = ACTIONS(3079),
    [anon_sym__Alignas] = ACTIONS(3079),
    [sym_primitive_type] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_union] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3079),
    [anon_sym_decltype] = ACTIONS(3079),
    [anon_sym_explicit] = ACTIONS(3079),
    [anon_sym_typename] = ACTIONS(3079),
    [anon_sym_private] = ACTIONS(3079),
    [anon_sym_template] = ACTIONS(3079),
    [anon_sym_operator] = ACTIONS(3079),
    [anon_sym_friend] = ACTIONS(3079),
    [anon_sym_public] = ACTIONS(3079),
    [anon_sym_protected] = ACTIONS(3079),
    [anon_sym_static_assert] = ACTIONS(3079),
  },
  [2018] = {
    [sym_identifier] = ACTIONS(2651),
    [aux_sym_preproc_def_token1] = ACTIONS(2651),
    [aux_sym_preproc_if_token1] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2651),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2651),
    [sym_preproc_directive] = ACTIONS(2651),
    [anon_sym_LPAREN2] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2653),
    [anon_sym___extension__] = ACTIONS(2651),
    [anon_sym_typedef] = ACTIONS(2651),
    [anon_sym_virtual] = ACTIONS(2651),
    [anon_sym_extern] = ACTIONS(2651),
    [anon_sym___attribute__] = ACTIONS(2651),
    [anon_sym___attribute] = ACTIONS(2651),
    [anon_sym_using] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2653),
    [anon_sym___declspec] = ACTIONS(2651),
    [anon_sym___based] = ACTIONS(2651),
    [anon_sym_RBRACE] = ACTIONS(2653),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2651),
    [anon_sym_register] = ACTIONS(2651),
    [anon_sym_inline] = ACTIONS(2651),
    [anon_sym___inline] = ACTIONS(2651),
    [anon_sym___inline__] = ACTIONS(2651),
    [anon_sym___forceinline] = ACTIONS(2651),
    [anon_sym_thread_local] = ACTIONS(2651),
    [anon_sym___thread] = ACTIONS(2651),
    [anon_sym_const] = ACTIONS(2651),
    [anon_sym_constexpr] = ACTIONS(2651),
    [anon_sym_volatile] = ACTIONS(2651),
    [anon_sym_restrict] = ACTIONS(2651),
    [anon_sym___restrict__] = ACTIONS(2651),
    [anon_sym__Atomic] = ACTIONS(2651),
    [anon_sym__Noreturn] = ACTIONS(2651),
    [anon_sym_noreturn] = ACTIONS(2651),
    [anon_sym__Nonnull] = ACTIONS(2651),
    [anon_sym_mutable] = ACTIONS(2651),
    [anon_sym_constinit] = ACTIONS(2651),
    [anon_sym_consteval] = ACTIONS(2651),
    [anon_sym_alignas] = ACTIONS(2651),
    [anon_sym__Alignas] = ACTIONS(2651),
    [sym_primitive_type] = ACTIONS(2651),
    [anon_sym_enum] = ACTIONS(2651),
    [anon_sym_class] = ACTIONS(2651),
    [anon_sym_struct] = ACTIONS(2651),
    [anon_sym_union] = ACTIONS(2651),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2651),
    [anon_sym_decltype] = ACTIONS(2651),
    [anon_sym_explicit] = ACTIONS(2651),
    [anon_sym_typename] = ACTIONS(2651),
    [anon_sym_private] = ACTIONS(2651),
    [anon_sym_template] = ACTIONS(2651),
    [anon_sym_operator] = ACTIONS(2651),
    [anon_sym_friend] = ACTIONS(2651),
    [anon_sym_public] = ACTIONS(2651),
    [anon_sym_protected] = ACTIONS(2651),
    [anon_sym_static_assert] = ACTIONS(2651),
  },
  [2019] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token2] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_friend] = ACTIONS(2911),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
  },
  [2020] = {
    [sym_identifier] = ACTIONS(3112),
    [aux_sym_preproc_def_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3112),
    [sym_preproc_directive] = ACTIONS(3112),
    [anon_sym_LPAREN2] = ACTIONS(3114),
    [anon_sym_TILDE] = ACTIONS(3114),
    [anon_sym_STAR] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3112),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym___extension__] = ACTIONS(3112),
    [anon_sym_typedef] = ACTIONS(3112),
    [anon_sym_virtual] = ACTIONS(3112),
    [anon_sym_extern] = ACTIONS(3112),
    [anon_sym___attribute__] = ACTIONS(3112),
    [anon_sym___attribute] = ACTIONS(3112),
    [anon_sym_using] = ACTIONS(3112),
    [anon_sym_COLON_COLON] = ACTIONS(3114),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3114),
    [anon_sym___declspec] = ACTIONS(3112),
    [anon_sym___based] = ACTIONS(3112),
    [anon_sym_RBRACE] = ACTIONS(3114),
    [anon_sym_signed] = ACTIONS(3112),
    [anon_sym_unsigned] = ACTIONS(3112),
    [anon_sym_long] = ACTIONS(3112),
    [anon_sym_short] = ACTIONS(3112),
    [anon_sym_LBRACK] = ACTIONS(3112),
    [anon_sym_static] = ACTIONS(3112),
    [anon_sym_register] = ACTIONS(3112),
    [anon_sym_inline] = ACTIONS(3112),
    [anon_sym___inline] = ACTIONS(3112),
    [anon_sym___inline__] = ACTIONS(3112),
    [anon_sym___forceinline] = ACTIONS(3112),
    [anon_sym_thread_local] = ACTIONS(3112),
    [anon_sym___thread] = ACTIONS(3112),
    [anon_sym_const] = ACTIONS(3112),
    [anon_sym_constexpr] = ACTIONS(3112),
    [anon_sym_volatile] = ACTIONS(3112),
    [anon_sym_restrict] = ACTIONS(3112),
    [anon_sym___restrict__] = ACTIONS(3112),
    [anon_sym__Atomic] = ACTIONS(3112),
    [anon_sym__Noreturn] = ACTIONS(3112),
    [anon_sym_noreturn] = ACTIONS(3112),
    [anon_sym__Nonnull] = ACTIONS(3112),
    [anon_sym_mutable] = ACTIONS(3112),
    [anon_sym_constinit] = ACTIONS(3112),
    [anon_sym_consteval] = ACTIONS(3112),
    [anon_sym_alignas] = ACTIONS(3112),
    [anon_sym__Alignas] = ACTIONS(3112),
    [sym_primitive_type] = ACTIONS(3112),
    [anon_sym_enum] = ACTIONS(3112),
    [anon_sym_class] = ACTIONS(3112),
    [anon_sym_struct] = ACTIONS(3112),
    [anon_sym_union] = ACTIONS(3112),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3112),
    [anon_sym_decltype] = ACTIONS(3112),
    [anon_sym_explicit] = ACTIONS(3112),
    [anon_sym_typename] = ACTIONS(3112),
    [anon_sym_private] = ACTIONS(3112),
    [anon_sym_template] = ACTIONS(3112),
    [anon_sym_operator] = ACTIONS(3112),
    [anon_sym_friend] = ACTIONS(3112),
    [anon_sym_public] = ACTIONS(3112),
    [anon_sym_protected] = ACTIONS(3112),
    [anon_sym_static_assert] = ACTIONS(3112),
  },
  [2021] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token2] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_private] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_friend] = ACTIONS(2771),
    [anon_sym_public] = ACTIONS(2771),
    [anon_sym_protected] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
  },
  [2022] = {
    [sym_identifier] = ACTIONS(3089),
    [aux_sym_preproc_def_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token1] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3089),
    [sym_preproc_directive] = ACTIONS(3089),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_STAR] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym___extension__] = ACTIONS(3089),
    [anon_sym_typedef] = ACTIONS(3089),
    [anon_sym_virtual] = ACTIONS(3089),
    [anon_sym_extern] = ACTIONS(3089),
    [anon_sym___attribute__] = ACTIONS(3089),
    [anon_sym___attribute] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_COLON_COLON] = ACTIONS(3091),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3091),
    [anon_sym___declspec] = ACTIONS(3089),
    [anon_sym___based] = ACTIONS(3089),
    [anon_sym_RBRACE] = ACTIONS(3091),
    [anon_sym_signed] = ACTIONS(3089),
    [anon_sym_unsigned] = ACTIONS(3089),
    [anon_sym_long] = ACTIONS(3089),
    [anon_sym_short] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3089),
    [anon_sym_register] = ACTIONS(3089),
    [anon_sym_inline] = ACTIONS(3089),
    [anon_sym___inline] = ACTIONS(3089),
    [anon_sym___inline__] = ACTIONS(3089),
    [anon_sym___forceinline] = ACTIONS(3089),
    [anon_sym_thread_local] = ACTIONS(3089),
    [anon_sym___thread] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_constexpr] = ACTIONS(3089),
    [anon_sym_volatile] = ACTIONS(3089),
    [anon_sym_restrict] = ACTIONS(3089),
    [anon_sym___restrict__] = ACTIONS(3089),
    [anon_sym__Atomic] = ACTIONS(3089),
    [anon_sym__Noreturn] = ACTIONS(3089),
    [anon_sym_noreturn] = ACTIONS(3089),
    [anon_sym__Nonnull] = ACTIONS(3089),
    [anon_sym_mutable] = ACTIONS(3089),
    [anon_sym_constinit] = ACTIONS(3089),
    [anon_sym_consteval] = ACTIONS(3089),
    [anon_sym_alignas] = ACTIONS(3089),
    [anon_sym__Alignas] = ACTIONS(3089),
    [sym_primitive_type] = ACTIONS(3089),
    [anon_sym_enum] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_union] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3089),
    [anon_sym_decltype] = ACTIONS(3089),
    [anon_sym_explicit] = ACTIONS(3089),
    [anon_sym_typename] = ACTIONS(3089),
    [anon_sym_private] = ACTIONS(3089),
    [anon_sym_template] = ACTIONS(3089),
    [anon_sym_operator] = ACTIONS(3089),
    [anon_sym_friend] = ACTIONS(3089),
    [anon_sym_public] = ACTIONS(3089),
    [anon_sym_protected] = ACTIONS(3089),
    [anon_sym_static_assert] = ACTIONS(3089),
  },
  [2023] = {
    [sym_identifier] = ACTIONS(5545),
    [aux_sym_preproc_def_token1] = ACTIONS(5545),
    [aux_sym_preproc_if_token1] = ACTIONS(5545),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5545),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5545),
    [sym_preproc_directive] = ACTIONS(5545),
    [anon_sym_LPAREN2] = ACTIONS(5547),
    [anon_sym_TILDE] = ACTIONS(5547),
    [anon_sym_STAR] = ACTIONS(5547),
    [anon_sym_AMP_AMP] = ACTIONS(5547),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_SEMI] = ACTIONS(5547),
    [anon_sym___extension__] = ACTIONS(5545),
    [anon_sym_typedef] = ACTIONS(5545),
    [anon_sym_virtual] = ACTIONS(5545),
    [anon_sym_extern] = ACTIONS(5545),
    [anon_sym___attribute__] = ACTIONS(5545),
    [anon_sym___attribute] = ACTIONS(5545),
    [anon_sym_using] = ACTIONS(5545),
    [anon_sym_COLON_COLON] = ACTIONS(5547),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5547),
    [anon_sym___declspec] = ACTIONS(5545),
    [anon_sym___based] = ACTIONS(5545),
    [anon_sym_RBRACE] = ACTIONS(5547),
    [anon_sym_signed] = ACTIONS(5545),
    [anon_sym_unsigned] = ACTIONS(5545),
    [anon_sym_long] = ACTIONS(5545),
    [anon_sym_short] = ACTIONS(5545),
    [anon_sym_LBRACK] = ACTIONS(5545),
    [anon_sym_static] = ACTIONS(5545),
    [anon_sym_register] = ACTIONS(5545),
    [anon_sym_inline] = ACTIONS(5545),
    [anon_sym___inline] = ACTIONS(5545),
    [anon_sym___inline__] = ACTIONS(5545),
    [anon_sym___forceinline] = ACTIONS(5545),
    [anon_sym_thread_local] = ACTIONS(5545),
    [anon_sym___thread] = ACTIONS(5545),
    [anon_sym_const] = ACTIONS(5545),
    [anon_sym_constexpr] = ACTIONS(5545),
    [anon_sym_volatile] = ACTIONS(5545),
    [anon_sym_restrict] = ACTIONS(5545),
    [anon_sym___restrict__] = ACTIONS(5545),
    [anon_sym__Atomic] = ACTIONS(5545),
    [anon_sym__Noreturn] = ACTIONS(5545),
    [anon_sym_noreturn] = ACTIONS(5545),
    [anon_sym__Nonnull] = ACTIONS(5545),
    [anon_sym_mutable] = ACTIONS(5545),
    [anon_sym_constinit] = ACTIONS(5545),
    [anon_sym_consteval] = ACTIONS(5545),
    [anon_sym_alignas] = ACTIONS(5545),
    [anon_sym__Alignas] = ACTIONS(5545),
    [sym_primitive_type] = ACTIONS(5545),
    [anon_sym_enum] = ACTIONS(5545),
    [anon_sym_class] = ACTIONS(5545),
    [anon_sym_struct] = ACTIONS(5545),
    [anon_sym_union] = ACTIONS(5545),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5545),
    [anon_sym_decltype] = ACTIONS(5545),
    [anon_sym_explicit] = ACTIONS(5545),
    [anon_sym_typename] = ACTIONS(5545),
    [anon_sym_private] = ACTIONS(5545),
    [anon_sym_template] = ACTIONS(5545),
    [anon_sym_operator] = ACTIONS(5545),
    [anon_sym_friend] = ACTIONS(5545),
    [anon_sym_public] = ACTIONS(5545),
    [anon_sym_protected] = ACTIONS(5545),
    [anon_sym_static_assert] = ACTIONS(5545),
  },
  [2024] = {
    [sym_identifier] = ACTIONS(3093),
    [aux_sym_preproc_def_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token1] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3093),
    [sym_preproc_directive] = ACTIONS(3093),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym___extension__] = ACTIONS(3093),
    [anon_sym_typedef] = ACTIONS(3093),
    [anon_sym_virtual] = ACTIONS(3093),
    [anon_sym_extern] = ACTIONS(3093),
    [anon_sym___attribute__] = ACTIONS(3093),
    [anon_sym___attribute] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_COLON_COLON] = ACTIONS(3095),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3095),
    [anon_sym___declspec] = ACTIONS(3093),
    [anon_sym___based] = ACTIONS(3093),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_signed] = ACTIONS(3093),
    [anon_sym_unsigned] = ACTIONS(3093),
    [anon_sym_long] = ACTIONS(3093),
    [anon_sym_short] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3093),
    [anon_sym_register] = ACTIONS(3093),
    [anon_sym_inline] = ACTIONS(3093),
    [anon_sym___inline] = ACTIONS(3093),
    [anon_sym___inline__] = ACTIONS(3093),
    [anon_sym___forceinline] = ACTIONS(3093),
    [anon_sym_thread_local] = ACTIONS(3093),
    [anon_sym___thread] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_constexpr] = ACTIONS(3093),
    [anon_sym_volatile] = ACTIONS(3093),
    [anon_sym_restrict] = ACTIONS(3093),
    [anon_sym___restrict__] = ACTIONS(3093),
    [anon_sym__Atomic] = ACTIONS(3093),
    [anon_sym__Noreturn] = ACTIONS(3093),
    [anon_sym_noreturn] = ACTIONS(3093),
    [anon_sym__Nonnull] = ACTIONS(3093),
    [anon_sym_mutable] = ACTIONS(3093),
    [anon_sym_constinit] = ACTIONS(3093),
    [anon_sym_consteval] = ACTIONS(3093),
    [anon_sym_alignas] = ACTIONS(3093),
    [anon_sym__Alignas] = ACTIONS(3093),
    [sym_primitive_type] = ACTIONS(3093),
    [anon_sym_enum] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_union] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3093),
    [anon_sym_decltype] = ACTIONS(3093),
    [anon_sym_explicit] = ACTIONS(3093),
    [anon_sym_typename] = ACTIONS(3093),
    [anon_sym_private] = ACTIONS(3093),
    [anon_sym_template] = ACTIONS(3093),
    [anon_sym_operator] = ACTIONS(3093),
    [anon_sym_friend] = ACTIONS(3093),
    [anon_sym_public] = ACTIONS(3093),
    [anon_sym_protected] = ACTIONS(3093),
    [anon_sym_static_assert] = ACTIONS(3093),
  },
  [2025] = {
    [sym_identifier] = ACTIONS(5557),
    [aux_sym_preproc_def_token1] = ACTIONS(5557),
    [aux_sym_preproc_if_token1] = ACTIONS(5557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5557),
    [sym_preproc_directive] = ACTIONS(5557),
    [anon_sym_LPAREN2] = ACTIONS(5559),
    [anon_sym_TILDE] = ACTIONS(5559),
    [anon_sym_STAR] = ACTIONS(5559),
    [anon_sym_AMP_AMP] = ACTIONS(5559),
    [anon_sym_AMP] = ACTIONS(5557),
    [anon_sym_SEMI] = ACTIONS(5559),
    [anon_sym___extension__] = ACTIONS(5557),
    [anon_sym_typedef] = ACTIONS(5557),
    [anon_sym_virtual] = ACTIONS(5557),
    [anon_sym_extern] = ACTIONS(5557),
    [anon_sym___attribute__] = ACTIONS(5557),
    [anon_sym___attribute] = ACTIONS(5557),
    [anon_sym_using] = ACTIONS(5557),
    [anon_sym_COLON_COLON] = ACTIONS(5559),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5559),
    [anon_sym___declspec] = ACTIONS(5557),
    [anon_sym___based] = ACTIONS(5557),
    [anon_sym_RBRACE] = ACTIONS(5559),
    [anon_sym_signed] = ACTIONS(5557),
    [anon_sym_unsigned] = ACTIONS(5557),
    [anon_sym_long] = ACTIONS(5557),
    [anon_sym_short] = ACTIONS(5557),
    [anon_sym_LBRACK] = ACTIONS(5557),
    [anon_sym_static] = ACTIONS(5557),
    [anon_sym_register] = ACTIONS(5557),
    [anon_sym_inline] = ACTIONS(5557),
    [anon_sym___inline] = ACTIONS(5557),
    [anon_sym___inline__] = ACTIONS(5557),
    [anon_sym___forceinline] = ACTIONS(5557),
    [anon_sym_thread_local] = ACTIONS(5557),
    [anon_sym___thread] = ACTIONS(5557),
    [anon_sym_const] = ACTIONS(5557),
    [anon_sym_constexpr] = ACTIONS(5557),
    [anon_sym_volatile] = ACTIONS(5557),
    [anon_sym_restrict] = ACTIONS(5557),
    [anon_sym___restrict__] = ACTIONS(5557),
    [anon_sym__Atomic] = ACTIONS(5557),
    [anon_sym__Noreturn] = ACTIONS(5557),
    [anon_sym_noreturn] = ACTIONS(5557),
    [anon_sym__Nonnull] = ACTIONS(5557),
    [anon_sym_mutable] = ACTIONS(5557),
    [anon_sym_constinit] = ACTIONS(5557),
    [anon_sym_consteval] = ACTIONS(5557),
    [anon_sym_alignas] = ACTIONS(5557),
    [anon_sym__Alignas] = ACTIONS(5557),
    [sym_primitive_type] = ACTIONS(5557),
    [anon_sym_enum] = ACTIONS(5557),
    [anon_sym_class] = ACTIONS(5557),
    [anon_sym_struct] = ACTIONS(5557),
    [anon_sym_union] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5557),
    [anon_sym_decltype] = ACTIONS(5557),
    [anon_sym_explicit] = ACTIONS(5557),
    [anon_sym_typename] = ACTIONS(5557),
    [anon_sym_private] = ACTIONS(5557),
    [anon_sym_template] = ACTIONS(5557),
    [anon_sym_operator] = ACTIONS(5557),
    [anon_sym_friend] = ACTIONS(5557),
    [anon_sym_public] = ACTIONS(5557),
    [anon_sym_protected] = ACTIONS(5557),
    [anon_sym_static_assert] = ACTIONS(5557),
  },
  [2026] = {
    [sym_identifier] = ACTIONS(5565),
    [aux_sym_preproc_def_token1] = ACTIONS(5565),
    [aux_sym_preproc_if_token1] = ACTIONS(5565),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5565),
    [sym_preproc_directive] = ACTIONS(5565),
    [anon_sym_LPAREN2] = ACTIONS(5567),
    [anon_sym_TILDE] = ACTIONS(5567),
    [anon_sym_STAR] = ACTIONS(5567),
    [anon_sym_AMP_AMP] = ACTIONS(5567),
    [anon_sym_AMP] = ACTIONS(5565),
    [anon_sym_SEMI] = ACTIONS(5567),
    [anon_sym___extension__] = ACTIONS(5565),
    [anon_sym_typedef] = ACTIONS(5565),
    [anon_sym_virtual] = ACTIONS(5565),
    [anon_sym_extern] = ACTIONS(5565),
    [anon_sym___attribute__] = ACTIONS(5565),
    [anon_sym___attribute] = ACTIONS(5565),
    [anon_sym_using] = ACTIONS(5565),
    [anon_sym_COLON_COLON] = ACTIONS(5567),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5567),
    [anon_sym___declspec] = ACTIONS(5565),
    [anon_sym___based] = ACTIONS(5565),
    [anon_sym_RBRACE] = ACTIONS(5567),
    [anon_sym_signed] = ACTIONS(5565),
    [anon_sym_unsigned] = ACTIONS(5565),
    [anon_sym_long] = ACTIONS(5565),
    [anon_sym_short] = ACTIONS(5565),
    [anon_sym_LBRACK] = ACTIONS(5565),
    [anon_sym_static] = ACTIONS(5565),
    [anon_sym_register] = ACTIONS(5565),
    [anon_sym_inline] = ACTIONS(5565),
    [anon_sym___inline] = ACTIONS(5565),
    [anon_sym___inline__] = ACTIONS(5565),
    [anon_sym___forceinline] = ACTIONS(5565),
    [anon_sym_thread_local] = ACTIONS(5565),
    [anon_sym___thread] = ACTIONS(5565),
    [anon_sym_const] = ACTIONS(5565),
    [anon_sym_constexpr] = ACTIONS(5565),
    [anon_sym_volatile] = ACTIONS(5565),
    [anon_sym_restrict] = ACTIONS(5565),
    [anon_sym___restrict__] = ACTIONS(5565),
    [anon_sym__Atomic] = ACTIONS(5565),
    [anon_sym__Noreturn] = ACTIONS(5565),
    [anon_sym_noreturn] = ACTIONS(5565),
    [anon_sym__Nonnull] = ACTIONS(5565),
    [anon_sym_mutable] = ACTIONS(5565),
    [anon_sym_constinit] = ACTIONS(5565),
    [anon_sym_consteval] = ACTIONS(5565),
    [anon_sym_alignas] = ACTIONS(5565),
    [anon_sym__Alignas] = ACTIONS(5565),
    [sym_primitive_type] = ACTIONS(5565),
    [anon_sym_enum] = ACTIONS(5565),
    [anon_sym_class] = ACTIONS(5565),
    [anon_sym_struct] = ACTIONS(5565),
    [anon_sym_union] = ACTIONS(5565),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5565),
    [anon_sym_decltype] = ACTIONS(5565),
    [anon_sym_explicit] = ACTIONS(5565),
    [anon_sym_typename] = ACTIONS(5565),
    [anon_sym_private] = ACTIONS(5565),
    [anon_sym_template] = ACTIONS(5565),
    [anon_sym_operator] = ACTIONS(5565),
    [anon_sym_friend] = ACTIONS(5565),
    [anon_sym_public] = ACTIONS(5565),
    [anon_sym_protected] = ACTIONS(5565),
    [anon_sym_static_assert] = ACTIONS(5565),
  },
  [2027] = {
    [sym_identifier] = ACTIONS(5569),
    [aux_sym_preproc_def_token1] = ACTIONS(5569),
    [aux_sym_preproc_if_token1] = ACTIONS(5569),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5569),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5569),
    [sym_preproc_directive] = ACTIONS(5569),
    [anon_sym_LPAREN2] = ACTIONS(5571),
    [anon_sym_TILDE] = ACTIONS(5571),
    [anon_sym_STAR] = ACTIONS(5571),
    [anon_sym_AMP_AMP] = ACTIONS(5571),
    [anon_sym_AMP] = ACTIONS(5569),
    [anon_sym_SEMI] = ACTIONS(5571),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_typedef] = ACTIONS(5569),
    [anon_sym_virtual] = ACTIONS(5569),
    [anon_sym_extern] = ACTIONS(5569),
    [anon_sym___attribute__] = ACTIONS(5569),
    [anon_sym___attribute] = ACTIONS(5569),
    [anon_sym_using] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5571),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5571),
    [anon_sym___declspec] = ACTIONS(5569),
    [anon_sym___based] = ACTIONS(5569),
    [anon_sym_RBRACE] = ACTIONS(5571),
    [anon_sym_signed] = ACTIONS(5569),
    [anon_sym_unsigned] = ACTIONS(5569),
    [anon_sym_long] = ACTIONS(5569),
    [anon_sym_short] = ACTIONS(5569),
    [anon_sym_LBRACK] = ACTIONS(5569),
    [anon_sym_static] = ACTIONS(5569),
    [anon_sym_register] = ACTIONS(5569),
    [anon_sym_inline] = ACTIONS(5569),
    [anon_sym___inline] = ACTIONS(5569),
    [anon_sym___inline__] = ACTIONS(5569),
    [anon_sym___forceinline] = ACTIONS(5569),
    [anon_sym_thread_local] = ACTIONS(5569),
    [anon_sym___thread] = ACTIONS(5569),
    [anon_sym_const] = ACTIONS(5569),
    [anon_sym_constexpr] = ACTIONS(5569),
    [anon_sym_volatile] = ACTIONS(5569),
    [anon_sym_restrict] = ACTIONS(5569),
    [anon_sym___restrict__] = ACTIONS(5569),
    [anon_sym__Atomic] = ACTIONS(5569),
    [anon_sym__Noreturn] = ACTIONS(5569),
    [anon_sym_noreturn] = ACTIONS(5569),
    [anon_sym__Nonnull] = ACTIONS(5569),
    [anon_sym_mutable] = ACTIONS(5569),
    [anon_sym_constinit] = ACTIONS(5569),
    [anon_sym_consteval] = ACTIONS(5569),
    [anon_sym_alignas] = ACTIONS(5569),
    [anon_sym__Alignas] = ACTIONS(5569),
    [sym_primitive_type] = ACTIONS(5569),
    [anon_sym_enum] = ACTIONS(5569),
    [anon_sym_class] = ACTIONS(5569),
    [anon_sym_struct] = ACTIONS(5569),
    [anon_sym_union] = ACTIONS(5569),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5569),
    [anon_sym_decltype] = ACTIONS(5569),
    [anon_sym_explicit] = ACTIONS(5569),
    [anon_sym_typename] = ACTIONS(5569),
    [anon_sym_private] = ACTIONS(5569),
    [anon_sym_template] = ACTIONS(5569),
    [anon_sym_operator] = ACTIONS(5569),
    [anon_sym_friend] = ACTIONS(5569),
    [anon_sym_public] = ACTIONS(5569),
    [anon_sym_protected] = ACTIONS(5569),
    [anon_sym_static_assert] = ACTIONS(5569),
  },
  [2028] = {
    [sym_identifier] = ACTIONS(5573),
    [aux_sym_preproc_def_token1] = ACTIONS(5573),
    [aux_sym_preproc_if_token1] = ACTIONS(5573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5573),
    [sym_preproc_directive] = ACTIONS(5573),
    [anon_sym_LPAREN2] = ACTIONS(5575),
    [anon_sym_TILDE] = ACTIONS(5575),
    [anon_sym_STAR] = ACTIONS(5575),
    [anon_sym_AMP_AMP] = ACTIONS(5575),
    [anon_sym_AMP] = ACTIONS(5573),
    [anon_sym_SEMI] = ACTIONS(5575),
    [anon_sym___extension__] = ACTIONS(5573),
    [anon_sym_typedef] = ACTIONS(5573),
    [anon_sym_virtual] = ACTIONS(5573),
    [anon_sym_extern] = ACTIONS(5573),
    [anon_sym___attribute__] = ACTIONS(5573),
    [anon_sym___attribute] = ACTIONS(5573),
    [anon_sym_using] = ACTIONS(5573),
    [anon_sym_COLON_COLON] = ACTIONS(5575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5575),
    [anon_sym___declspec] = ACTIONS(5573),
    [anon_sym___based] = ACTIONS(5573),
    [anon_sym_RBRACE] = ACTIONS(5575),
    [anon_sym_signed] = ACTIONS(5573),
    [anon_sym_unsigned] = ACTIONS(5573),
    [anon_sym_long] = ACTIONS(5573),
    [anon_sym_short] = ACTIONS(5573),
    [anon_sym_LBRACK] = ACTIONS(5573),
    [anon_sym_static] = ACTIONS(5573),
    [anon_sym_register] = ACTIONS(5573),
    [anon_sym_inline] = ACTIONS(5573),
    [anon_sym___inline] = ACTIONS(5573),
    [anon_sym___inline__] = ACTIONS(5573),
    [anon_sym___forceinline] = ACTIONS(5573),
    [anon_sym_thread_local] = ACTIONS(5573),
    [anon_sym___thread] = ACTIONS(5573),
    [anon_sym_const] = ACTIONS(5573),
    [anon_sym_constexpr] = ACTIONS(5573),
    [anon_sym_volatile] = ACTIONS(5573),
    [anon_sym_restrict] = ACTIONS(5573),
    [anon_sym___restrict__] = ACTIONS(5573),
    [anon_sym__Atomic] = ACTIONS(5573),
    [anon_sym__Noreturn] = ACTIONS(5573),
    [anon_sym_noreturn] = ACTIONS(5573),
    [anon_sym__Nonnull] = ACTIONS(5573),
    [anon_sym_mutable] = ACTIONS(5573),
    [anon_sym_constinit] = ACTIONS(5573),
    [anon_sym_consteval] = ACTIONS(5573),
    [anon_sym_alignas] = ACTIONS(5573),
    [anon_sym__Alignas] = ACTIONS(5573),
    [sym_primitive_type] = ACTIONS(5573),
    [anon_sym_enum] = ACTIONS(5573),
    [anon_sym_class] = ACTIONS(5573),
    [anon_sym_struct] = ACTIONS(5573),
    [anon_sym_union] = ACTIONS(5573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5573),
    [anon_sym_decltype] = ACTIONS(5573),
    [anon_sym_explicit] = ACTIONS(5573),
    [anon_sym_typename] = ACTIONS(5573),
    [anon_sym_private] = ACTIONS(5573),
    [anon_sym_template] = ACTIONS(5573),
    [anon_sym_operator] = ACTIONS(5573),
    [anon_sym_friend] = ACTIONS(5573),
    [anon_sym_public] = ACTIONS(5573),
    [anon_sym_protected] = ACTIONS(5573),
    [anon_sym_static_assert] = ACTIONS(5573),
  },
  [2029] = {
    [sym_identifier] = ACTIONS(3079),
    [aux_sym_preproc_def_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3079),
    [sym_preproc_directive] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_AMP_AMP] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym___extension__] = ACTIONS(3079),
    [anon_sym_typedef] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym___attribute__] = ACTIONS(3079),
    [anon_sym___attribute] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3081),
    [anon_sym___declspec] = ACTIONS(3079),
    [anon_sym___based] = ACTIONS(3079),
    [anon_sym_RBRACE] = ACTIONS(3081),
    [anon_sym_signed] = ACTIONS(3079),
    [anon_sym_unsigned] = ACTIONS(3079),
    [anon_sym_long] = ACTIONS(3079),
    [anon_sym_short] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_register] = ACTIONS(3079),
    [anon_sym_inline] = ACTIONS(3079),
    [anon_sym___inline] = ACTIONS(3079),
    [anon_sym___inline__] = ACTIONS(3079),
    [anon_sym___forceinline] = ACTIONS(3079),
    [anon_sym_thread_local] = ACTIONS(3079),
    [anon_sym___thread] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_constexpr] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_restrict] = ACTIONS(3079),
    [anon_sym___restrict__] = ACTIONS(3079),
    [anon_sym__Atomic] = ACTIONS(3079),
    [anon_sym__Noreturn] = ACTIONS(3079),
    [anon_sym_noreturn] = ACTIONS(3079),
    [anon_sym__Nonnull] = ACTIONS(3079),
    [anon_sym_mutable] = ACTIONS(3079),
    [anon_sym_constinit] = ACTIONS(3079),
    [anon_sym_consteval] = ACTIONS(3079),
    [anon_sym_alignas] = ACTIONS(3079),
    [anon_sym__Alignas] = ACTIONS(3079),
    [sym_primitive_type] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_union] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3079),
    [anon_sym_decltype] = ACTIONS(3079),
    [anon_sym_explicit] = ACTIONS(3079),
    [anon_sym_typename] = ACTIONS(3079),
    [anon_sym_private] = ACTIONS(3079),
    [anon_sym_template] = ACTIONS(3079),
    [anon_sym_operator] = ACTIONS(3079),
    [anon_sym_friend] = ACTIONS(3079),
    [anon_sym_public] = ACTIONS(3079),
    [anon_sym_protected] = ACTIONS(3079),
    [anon_sym_static_assert] = ACTIONS(3079),
  },
  [2030] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token2] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_private] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_friend] = ACTIONS(2915),
    [anon_sym_public] = ACTIONS(2915),
    [anon_sym_protected] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
  },
  [2031] = {
    [sym_identifier] = ACTIONS(2775),
    [aux_sym_preproc_def_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token1] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2775),
    [sym_preproc_directive] = ACTIONS(2775),
    [anon_sym_LPAREN2] = ACTIONS(2777),
    [anon_sym_TILDE] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym___extension__] = ACTIONS(2775),
    [anon_sym_typedef] = ACTIONS(2775),
    [anon_sym_virtual] = ACTIONS(2775),
    [anon_sym_extern] = ACTIONS(2775),
    [anon_sym___attribute__] = ACTIONS(2775),
    [anon_sym___attribute] = ACTIONS(2775),
    [anon_sym_using] = ACTIONS(2775),
    [anon_sym_COLON_COLON] = ACTIONS(2777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2777),
    [anon_sym___declspec] = ACTIONS(2775),
    [anon_sym___based] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_signed] = ACTIONS(2775),
    [anon_sym_unsigned] = ACTIONS(2775),
    [anon_sym_long] = ACTIONS(2775),
    [anon_sym_short] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_static] = ACTIONS(2775),
    [anon_sym_register] = ACTIONS(2775),
    [anon_sym_inline] = ACTIONS(2775),
    [anon_sym___inline] = ACTIONS(2775),
    [anon_sym___inline__] = ACTIONS(2775),
    [anon_sym___forceinline] = ACTIONS(2775),
    [anon_sym_thread_local] = ACTIONS(2775),
    [anon_sym___thread] = ACTIONS(2775),
    [anon_sym_const] = ACTIONS(2775),
    [anon_sym_constexpr] = ACTIONS(2775),
    [anon_sym_volatile] = ACTIONS(2775),
    [anon_sym_restrict] = ACTIONS(2775),
    [anon_sym___restrict__] = ACTIONS(2775),
    [anon_sym__Atomic] = ACTIONS(2775),
    [anon_sym__Noreturn] = ACTIONS(2775),
    [anon_sym_noreturn] = ACTIONS(2775),
    [anon_sym__Nonnull] = ACTIONS(2775),
    [anon_sym_mutable] = ACTIONS(2775),
    [anon_sym_constinit] = ACTIONS(2775),
    [anon_sym_consteval] = ACTIONS(2775),
    [anon_sym_alignas] = ACTIONS(2775),
    [anon_sym__Alignas] = ACTIONS(2775),
    [sym_primitive_type] = ACTIONS(2775),
    [anon_sym_enum] = ACTIONS(2775),
    [anon_sym_class] = ACTIONS(2775),
    [anon_sym_struct] = ACTIONS(2775),
    [anon_sym_union] = ACTIONS(2775),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2775),
    [anon_sym_decltype] = ACTIONS(2775),
    [anon_sym_explicit] = ACTIONS(2775),
    [anon_sym_typename] = ACTIONS(2775),
    [anon_sym_private] = ACTIONS(2775),
    [anon_sym_template] = ACTIONS(2775),
    [anon_sym_operator] = ACTIONS(2775),
    [anon_sym_friend] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2775),
    [anon_sym_protected] = ACTIONS(2775),
    [anon_sym_static_assert] = ACTIONS(2775),
  },
  [2032] = {
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym___attribute] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym__Nonnull] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym__Alignas] = ACTIONS(2779),
    [sym_primitive_type] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_private] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_friend] = ACTIONS(2779),
    [anon_sym_public] = ACTIONS(2779),
    [anon_sym_protected] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
  },
  [2033] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token2] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_private] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_friend] = ACTIONS(2915),
    [anon_sym_public] = ACTIONS(2915),
    [anon_sym_protected] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
  },
  [2034] = {
    [sym_string_literal] = STATE(1684),
    [sym_raw_string_literal] = STATE(1684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_COMMA] = ACTIONS(5914),
    [anon_sym_RPAREN] = ACTIONS(5914),
    [anon_sym_LPAREN2] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5912),
    [anon_sym_STAR] = ACTIONS(5912),
    [anon_sym_SLASH] = ACTIONS(5912),
    [anon_sym_PERCENT] = ACTIONS(5912),
    [anon_sym_PIPE_PIPE] = ACTIONS(5914),
    [anon_sym_AMP_AMP] = ACTIONS(5914),
    [anon_sym_PIPE] = ACTIONS(5912),
    [anon_sym_CARET] = ACTIONS(5912),
    [anon_sym_AMP] = ACTIONS(5912),
    [anon_sym_EQ_EQ] = ACTIONS(5914),
    [anon_sym_BANG_EQ] = ACTIONS(5914),
    [anon_sym_GT] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5912),
    [anon_sym_LT_LT] = ACTIONS(5912),
    [anon_sym_GT_GT] = ACTIONS(5912),
    [anon_sym_SEMI] = ACTIONS(5914),
    [anon_sym_COLON] = ACTIONS(5914),
    [anon_sym_RBRACE] = ACTIONS(5914),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_RBRACK] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5912),
    [anon_sym_QMARK] = ACTIONS(5914),
    [anon_sym_STAR_EQ] = ACTIONS(5914),
    [anon_sym_SLASH_EQ] = ACTIONS(5914),
    [anon_sym_PERCENT_EQ] = ACTIONS(5914),
    [anon_sym_PLUS_EQ] = ACTIONS(5914),
    [anon_sym_DASH_EQ] = ACTIONS(5914),
    [anon_sym_LT_LT_EQ] = ACTIONS(5914),
    [anon_sym_GT_GT_EQ] = ACTIONS(5914),
    [anon_sym_AMP_EQ] = ACTIONS(5914),
    [anon_sym_CARET_EQ] = ACTIONS(5914),
    [anon_sym_PIPE_EQ] = ACTIONS(5914),
    [anon_sym_and_eq] = ACTIONS(5912),
    [anon_sym_or_eq] = ACTIONS(5912),
    [anon_sym_xor_eq] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5914),
    [anon_sym_or] = ACTIONS(5912),
    [anon_sym_and] = ACTIONS(5912),
    [anon_sym_bitor] = ACTIONS(5912),
    [anon_sym_xor] = ACTIONS(5912),
    [anon_sym_bitand] = ACTIONS(5912),
    [anon_sym_not_eq] = ACTIONS(5912),
    [anon_sym_DASH_DASH] = ACTIONS(5914),
    [anon_sym_PLUS_PLUS] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5912),
    [anon_sym_DOT_STAR] = ACTIONS(5914),
    [anon_sym_DASH_GT] = ACTIONS(5914),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [sym_literal_suffix] = ACTIONS(5912),
  },
  [2035] = {
    [sym_identifier] = ACTIONS(2919),
    [aux_sym_preproc_def_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token2] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2919),
    [sym_preproc_directive] = ACTIONS(2919),
    [anon_sym_LPAREN2] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym___extension__] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(2919),
    [anon_sym_virtual] = ACTIONS(2919),
    [anon_sym_extern] = ACTIONS(2919),
    [anon_sym___attribute__] = ACTIONS(2919),
    [anon_sym___attribute] = ACTIONS(2919),
    [anon_sym_using] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(2921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2921),
    [anon_sym___declspec] = ACTIONS(2919),
    [anon_sym___based] = ACTIONS(2919),
    [anon_sym_signed] = ACTIONS(2919),
    [anon_sym_unsigned] = ACTIONS(2919),
    [anon_sym_long] = ACTIONS(2919),
    [anon_sym_short] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_register] = ACTIONS(2919),
    [anon_sym_inline] = ACTIONS(2919),
    [anon_sym___inline] = ACTIONS(2919),
    [anon_sym___inline__] = ACTIONS(2919),
    [anon_sym___forceinline] = ACTIONS(2919),
    [anon_sym_thread_local] = ACTIONS(2919),
    [anon_sym___thread] = ACTIONS(2919),
    [anon_sym_const] = ACTIONS(2919),
    [anon_sym_constexpr] = ACTIONS(2919),
    [anon_sym_volatile] = ACTIONS(2919),
    [anon_sym_restrict] = ACTIONS(2919),
    [anon_sym___restrict__] = ACTIONS(2919),
    [anon_sym__Atomic] = ACTIONS(2919),
    [anon_sym__Noreturn] = ACTIONS(2919),
    [anon_sym_noreturn] = ACTIONS(2919),
    [anon_sym__Nonnull] = ACTIONS(2919),
    [anon_sym_mutable] = ACTIONS(2919),
    [anon_sym_constinit] = ACTIONS(2919),
    [anon_sym_consteval] = ACTIONS(2919),
    [anon_sym_alignas] = ACTIONS(2919),
    [anon_sym__Alignas] = ACTIONS(2919),
    [sym_primitive_type] = ACTIONS(2919),
    [anon_sym_enum] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2919),
    [anon_sym_decltype] = ACTIONS(2919),
    [anon_sym_explicit] = ACTIONS(2919),
    [anon_sym_typename] = ACTIONS(2919),
    [anon_sym_private] = ACTIONS(2919),
    [anon_sym_template] = ACTIONS(2919),
    [anon_sym_operator] = ACTIONS(2919),
    [anon_sym_friend] = ACTIONS(2919),
    [anon_sym_public] = ACTIONS(2919),
    [anon_sym_protected] = ACTIONS(2919),
    [anon_sym_static_assert] = ACTIONS(2919),
  },
  [2036] = {
    [sym_identifier] = ACTIONS(5581),
    [aux_sym_preproc_def_token1] = ACTIONS(5581),
    [aux_sym_preproc_if_token1] = ACTIONS(5581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5581),
    [sym_preproc_directive] = ACTIONS(5581),
    [anon_sym_LPAREN2] = ACTIONS(5583),
    [anon_sym_TILDE] = ACTIONS(5583),
    [anon_sym_STAR] = ACTIONS(5583),
    [anon_sym_AMP_AMP] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5581),
    [anon_sym_SEMI] = ACTIONS(5583),
    [anon_sym___extension__] = ACTIONS(5581),
    [anon_sym_typedef] = ACTIONS(5581),
    [anon_sym_virtual] = ACTIONS(5581),
    [anon_sym_extern] = ACTIONS(5581),
    [anon_sym___attribute__] = ACTIONS(5581),
    [anon_sym___attribute] = ACTIONS(5581),
    [anon_sym_using] = ACTIONS(5581),
    [anon_sym_COLON_COLON] = ACTIONS(5583),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5583),
    [anon_sym___declspec] = ACTIONS(5581),
    [anon_sym___based] = ACTIONS(5581),
    [anon_sym_RBRACE] = ACTIONS(5583),
    [anon_sym_signed] = ACTIONS(5581),
    [anon_sym_unsigned] = ACTIONS(5581),
    [anon_sym_long] = ACTIONS(5581),
    [anon_sym_short] = ACTIONS(5581),
    [anon_sym_LBRACK] = ACTIONS(5581),
    [anon_sym_static] = ACTIONS(5581),
    [anon_sym_register] = ACTIONS(5581),
    [anon_sym_inline] = ACTIONS(5581),
    [anon_sym___inline] = ACTIONS(5581),
    [anon_sym___inline__] = ACTIONS(5581),
    [anon_sym___forceinline] = ACTIONS(5581),
    [anon_sym_thread_local] = ACTIONS(5581),
    [anon_sym___thread] = ACTIONS(5581),
    [anon_sym_const] = ACTIONS(5581),
    [anon_sym_constexpr] = ACTIONS(5581),
    [anon_sym_volatile] = ACTIONS(5581),
    [anon_sym_restrict] = ACTIONS(5581),
    [anon_sym___restrict__] = ACTIONS(5581),
    [anon_sym__Atomic] = ACTIONS(5581),
    [anon_sym__Noreturn] = ACTIONS(5581),
    [anon_sym_noreturn] = ACTIONS(5581),
    [anon_sym__Nonnull] = ACTIONS(5581),
    [anon_sym_mutable] = ACTIONS(5581),
    [anon_sym_constinit] = ACTIONS(5581),
    [anon_sym_consteval] = ACTIONS(5581),
    [anon_sym_alignas] = ACTIONS(5581),
    [anon_sym__Alignas] = ACTIONS(5581),
    [sym_primitive_type] = ACTIONS(5581),
    [anon_sym_enum] = ACTIONS(5581),
    [anon_sym_class] = ACTIONS(5581),
    [anon_sym_struct] = ACTIONS(5581),
    [anon_sym_union] = ACTIONS(5581),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5581),
    [anon_sym_decltype] = ACTIONS(5581),
    [anon_sym_explicit] = ACTIONS(5581),
    [anon_sym_typename] = ACTIONS(5581),
    [anon_sym_private] = ACTIONS(5581),
    [anon_sym_template] = ACTIONS(5581),
    [anon_sym_operator] = ACTIONS(5581),
    [anon_sym_friend] = ACTIONS(5581),
    [anon_sym_public] = ACTIONS(5581),
    [anon_sym_protected] = ACTIONS(5581),
    [anon_sym_static_assert] = ACTIONS(5581),
  },
  [2037] = {
    [sym_identifier] = ACTIONS(2923),
    [aux_sym_preproc_def_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token2] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2923),
    [sym_preproc_directive] = ACTIONS(2923),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2923),
    [anon_sym_typedef] = ACTIONS(2923),
    [anon_sym_virtual] = ACTIONS(2923),
    [anon_sym_extern] = ACTIONS(2923),
    [anon_sym___attribute__] = ACTIONS(2923),
    [anon_sym___attribute] = ACTIONS(2923),
    [anon_sym_using] = ACTIONS(2923),
    [anon_sym_COLON_COLON] = ACTIONS(2925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2925),
    [anon_sym___declspec] = ACTIONS(2923),
    [anon_sym___based] = ACTIONS(2923),
    [anon_sym_signed] = ACTIONS(2923),
    [anon_sym_unsigned] = ACTIONS(2923),
    [anon_sym_long] = ACTIONS(2923),
    [anon_sym_short] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_register] = ACTIONS(2923),
    [anon_sym_inline] = ACTIONS(2923),
    [anon_sym___inline] = ACTIONS(2923),
    [anon_sym___inline__] = ACTIONS(2923),
    [anon_sym___forceinline] = ACTIONS(2923),
    [anon_sym_thread_local] = ACTIONS(2923),
    [anon_sym___thread] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_constexpr] = ACTIONS(2923),
    [anon_sym_volatile] = ACTIONS(2923),
    [anon_sym_restrict] = ACTIONS(2923),
    [anon_sym___restrict__] = ACTIONS(2923),
    [anon_sym__Atomic] = ACTIONS(2923),
    [anon_sym__Noreturn] = ACTIONS(2923),
    [anon_sym_noreturn] = ACTIONS(2923),
    [anon_sym__Nonnull] = ACTIONS(2923),
    [anon_sym_mutable] = ACTIONS(2923),
    [anon_sym_constinit] = ACTIONS(2923),
    [anon_sym_consteval] = ACTIONS(2923),
    [anon_sym_alignas] = ACTIONS(2923),
    [anon_sym__Alignas] = ACTIONS(2923),
    [sym_primitive_type] = ACTIONS(2923),
    [anon_sym_enum] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2923),
    [anon_sym_union] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2923),
    [anon_sym_decltype] = ACTIONS(2923),
    [anon_sym_explicit] = ACTIONS(2923),
    [anon_sym_typename] = ACTIONS(2923),
    [anon_sym_private] = ACTIONS(2923),
    [anon_sym_template] = ACTIONS(2923),
    [anon_sym_operator] = ACTIONS(2923),
    [anon_sym_friend] = ACTIONS(2923),
    [anon_sym_public] = ACTIONS(2923),
    [anon_sym_protected] = ACTIONS(2923),
    [anon_sym_static_assert] = ACTIONS(2923),
  },
  [2038] = {
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token2] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym___attribute] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2929),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym__Nonnull] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym__Alignas] = ACTIONS(2927),
    [sym_primitive_type] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_private] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_friend] = ACTIONS(2927),
    [anon_sym_public] = ACTIONS(2927),
    [anon_sym_protected] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
  },
  [2039] = {
    [sym_identifier] = ACTIONS(2787),
    [aux_sym_preproc_def_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token1] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2787),
    [sym_preproc_directive] = ACTIONS(2787),
    [anon_sym_LPAREN2] = ACTIONS(2789),
    [anon_sym_TILDE] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym___extension__] = ACTIONS(2787),
    [anon_sym_typedef] = ACTIONS(2787),
    [anon_sym_virtual] = ACTIONS(2787),
    [anon_sym_extern] = ACTIONS(2787),
    [anon_sym___attribute__] = ACTIONS(2787),
    [anon_sym___attribute] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2789),
    [anon_sym___declspec] = ACTIONS(2787),
    [anon_sym___based] = ACTIONS(2787),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_signed] = ACTIONS(2787),
    [anon_sym_unsigned] = ACTIONS(2787),
    [anon_sym_long] = ACTIONS(2787),
    [anon_sym_short] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_static] = ACTIONS(2787),
    [anon_sym_register] = ACTIONS(2787),
    [anon_sym_inline] = ACTIONS(2787),
    [anon_sym___inline] = ACTIONS(2787),
    [anon_sym___inline__] = ACTIONS(2787),
    [anon_sym___forceinline] = ACTIONS(2787),
    [anon_sym_thread_local] = ACTIONS(2787),
    [anon_sym___thread] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_constexpr] = ACTIONS(2787),
    [anon_sym_volatile] = ACTIONS(2787),
    [anon_sym_restrict] = ACTIONS(2787),
    [anon_sym___restrict__] = ACTIONS(2787),
    [anon_sym__Atomic] = ACTIONS(2787),
    [anon_sym__Noreturn] = ACTIONS(2787),
    [anon_sym_noreturn] = ACTIONS(2787),
    [anon_sym__Nonnull] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_constinit] = ACTIONS(2787),
    [anon_sym_consteval] = ACTIONS(2787),
    [anon_sym_alignas] = ACTIONS(2787),
    [anon_sym__Alignas] = ACTIONS(2787),
    [sym_primitive_type] = ACTIONS(2787),
    [anon_sym_enum] = ACTIONS(2787),
    [anon_sym_class] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_union] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2787),
    [anon_sym_decltype] = ACTIONS(2787),
    [anon_sym_explicit] = ACTIONS(2787),
    [anon_sym_typename] = ACTIONS(2787),
    [anon_sym_private] = ACTIONS(2787),
    [anon_sym_template] = ACTIONS(2787),
    [anon_sym_operator] = ACTIONS(2787),
    [anon_sym_friend] = ACTIONS(2787),
    [anon_sym_public] = ACTIONS(2787),
    [anon_sym_protected] = ACTIONS(2787),
    [anon_sym_static_assert] = ACTIONS(2787),
  },
  [2040] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5619),
    [anon_sym_COMMA] = ACTIONS(5619),
    [anon_sym_RPAREN] = ACTIONS(5619),
    [aux_sym_preproc_if_token2] = ACTIONS(5619),
    [aux_sym_preproc_else_token1] = ACTIONS(5619),
    [aux_sym_preproc_elif_token1] = ACTIONS(5617),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5619),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_DASH] = ACTIONS(5617),
    [anon_sym_PLUS] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5617),
    [anon_sym_SLASH] = ACTIONS(5617),
    [anon_sym_PERCENT] = ACTIONS(5617),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_CARET] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5619),
    [anon_sym_BANG_EQ] = ACTIONS(5619),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_LT_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5617),
    [anon_sym_SEMI] = ACTIONS(5619),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_COLON] = ACTIONS(5619),
    [anon_sym_LBRACE] = ACTIONS(5619),
    [anon_sym_RBRACE] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5619),
    [anon_sym_RBRACK] = ACTIONS(5619),
    [anon_sym_EQ] = ACTIONS(5617),
    [anon_sym_QMARK] = ACTIONS(5619),
    [anon_sym_STAR_EQ] = ACTIONS(5619),
    [anon_sym_SLASH_EQ] = ACTIONS(5619),
    [anon_sym_PERCENT_EQ] = ACTIONS(5619),
    [anon_sym_PLUS_EQ] = ACTIONS(5619),
    [anon_sym_DASH_EQ] = ACTIONS(5619),
    [anon_sym_LT_LT_EQ] = ACTIONS(5619),
    [anon_sym_GT_GT_EQ] = ACTIONS(5619),
    [anon_sym_AMP_EQ] = ACTIONS(5619),
    [anon_sym_CARET_EQ] = ACTIONS(5619),
    [anon_sym_PIPE_EQ] = ACTIONS(5619),
    [anon_sym_and_eq] = ACTIONS(5617),
    [anon_sym_or_eq] = ACTIONS(5617),
    [anon_sym_xor_eq] = ACTIONS(5617),
    [anon_sym_LT_EQ_GT] = ACTIONS(5619),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [anon_sym_bitor] = ACTIONS(5617),
    [anon_sym_xor] = ACTIONS(5617),
    [anon_sym_bitand] = ACTIONS(5617),
    [anon_sym_not_eq] = ACTIONS(5617),
    [anon_sym_DASH_DASH] = ACTIONS(5619),
    [anon_sym_PLUS_PLUS] = ACTIONS(5619),
    [anon_sym_DOT] = ACTIONS(5617),
    [anon_sym_DOT_STAR] = ACTIONS(5619),
    [anon_sym_DASH_GT] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_final] = ACTIONS(5617),
    [anon_sym_override] = ACTIONS(5617),
  },
  [2041] = {
    [sym_identifier] = ACTIONS(2851),
    [aux_sym_preproc_def_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token2] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2851),
    [sym_preproc_directive] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2853),
    [anon_sym_TILDE] = ACTIONS(2853),
    [anon_sym_STAR] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym___extension__] = ACTIONS(2851),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_virtual] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(2851),
    [anon_sym___attribute__] = ACTIONS(2851),
    [anon_sym___attribute] = ACTIONS(2851),
    [anon_sym_using] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2853),
    [anon_sym___declspec] = ACTIONS(2851),
    [anon_sym___based] = ACTIONS(2851),
    [anon_sym_signed] = ACTIONS(2851),
    [anon_sym_unsigned] = ACTIONS(2851),
    [anon_sym_long] = ACTIONS(2851),
    [anon_sym_short] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_static] = ACTIONS(2851),
    [anon_sym_register] = ACTIONS(2851),
    [anon_sym_inline] = ACTIONS(2851),
    [anon_sym___inline] = ACTIONS(2851),
    [anon_sym___inline__] = ACTIONS(2851),
    [anon_sym___forceinline] = ACTIONS(2851),
    [anon_sym_thread_local] = ACTIONS(2851),
    [anon_sym___thread] = ACTIONS(2851),
    [anon_sym_const] = ACTIONS(2851),
    [anon_sym_constexpr] = ACTIONS(2851),
    [anon_sym_volatile] = ACTIONS(2851),
    [anon_sym_restrict] = ACTIONS(2851),
    [anon_sym___restrict__] = ACTIONS(2851),
    [anon_sym__Atomic] = ACTIONS(2851),
    [anon_sym__Noreturn] = ACTIONS(2851),
    [anon_sym_noreturn] = ACTIONS(2851),
    [anon_sym__Nonnull] = ACTIONS(2851),
    [anon_sym_mutable] = ACTIONS(2851),
    [anon_sym_constinit] = ACTIONS(2851),
    [anon_sym_consteval] = ACTIONS(2851),
    [anon_sym_alignas] = ACTIONS(2851),
    [anon_sym__Alignas] = ACTIONS(2851),
    [sym_primitive_type] = ACTIONS(2851),
    [anon_sym_enum] = ACTIONS(2851),
    [anon_sym_class] = ACTIONS(2851),
    [anon_sym_struct] = ACTIONS(2851),
    [anon_sym_union] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2851),
    [anon_sym_decltype] = ACTIONS(2851),
    [anon_sym_explicit] = ACTIONS(2851),
    [anon_sym_typename] = ACTIONS(2851),
    [anon_sym_private] = ACTIONS(2851),
    [anon_sym_template] = ACTIONS(2851),
    [anon_sym_operator] = ACTIONS(2851),
    [anon_sym_friend] = ACTIONS(2851),
    [anon_sym_public] = ACTIONS(2851),
    [anon_sym_protected] = ACTIONS(2851),
    [anon_sym_static_assert] = ACTIONS(2851),
  },
  [2042] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_private] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_friend] = ACTIONS(2799),
    [anon_sym_public] = ACTIONS(2799),
    [anon_sym_protected] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
  },
  [2043] = {
    [sym_identifier] = ACTIONS(2807),
    [aux_sym_preproc_def_token1] = ACTIONS(2807),
    [aux_sym_preproc_if_token1] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2807),
    [sym_preproc_directive] = ACTIONS(2807),
    [anon_sym_LPAREN2] = ACTIONS(2809),
    [anon_sym_TILDE] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2807),
    [anon_sym_typedef] = ACTIONS(2807),
    [anon_sym_virtual] = ACTIONS(2807),
    [anon_sym_extern] = ACTIONS(2807),
    [anon_sym___attribute__] = ACTIONS(2807),
    [anon_sym___attribute] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2809),
    [anon_sym___declspec] = ACTIONS(2807),
    [anon_sym___based] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2809),
    [anon_sym_signed] = ACTIONS(2807),
    [anon_sym_unsigned] = ACTIONS(2807),
    [anon_sym_long] = ACTIONS(2807),
    [anon_sym_short] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_static] = ACTIONS(2807),
    [anon_sym_register] = ACTIONS(2807),
    [anon_sym_inline] = ACTIONS(2807),
    [anon_sym___inline] = ACTIONS(2807),
    [anon_sym___inline__] = ACTIONS(2807),
    [anon_sym___forceinline] = ACTIONS(2807),
    [anon_sym_thread_local] = ACTIONS(2807),
    [anon_sym___thread] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_constexpr] = ACTIONS(2807),
    [anon_sym_volatile] = ACTIONS(2807),
    [anon_sym_restrict] = ACTIONS(2807),
    [anon_sym___restrict__] = ACTIONS(2807),
    [anon_sym__Atomic] = ACTIONS(2807),
    [anon_sym__Noreturn] = ACTIONS(2807),
    [anon_sym_noreturn] = ACTIONS(2807),
    [anon_sym__Nonnull] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_constinit] = ACTIONS(2807),
    [anon_sym_consteval] = ACTIONS(2807),
    [anon_sym_alignas] = ACTIONS(2807),
    [anon_sym__Alignas] = ACTIONS(2807),
    [sym_primitive_type] = ACTIONS(2807),
    [anon_sym_enum] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_union] = ACTIONS(2807),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2807),
    [anon_sym_decltype] = ACTIONS(2807),
    [anon_sym_explicit] = ACTIONS(2807),
    [anon_sym_typename] = ACTIONS(2807),
    [anon_sym_private] = ACTIONS(2807),
    [anon_sym_template] = ACTIONS(2807),
    [anon_sym_operator] = ACTIONS(2807),
    [anon_sym_friend] = ACTIONS(2807),
    [anon_sym_public] = ACTIONS(2807),
    [anon_sym_protected] = ACTIONS(2807),
    [anon_sym_static_assert] = ACTIONS(2807),
  },
  [2044] = {
    [sym_identifier] = ACTIONS(2931),
    [aux_sym_preproc_def_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token2] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2931),
    [sym_preproc_directive] = ACTIONS(2931),
    [anon_sym_LPAREN2] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym___extension__] = ACTIONS(2931),
    [anon_sym_typedef] = ACTIONS(2931),
    [anon_sym_virtual] = ACTIONS(2931),
    [anon_sym_extern] = ACTIONS(2931),
    [anon_sym___attribute__] = ACTIONS(2931),
    [anon_sym___attribute] = ACTIONS(2931),
    [anon_sym_using] = ACTIONS(2931),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2933),
    [anon_sym___declspec] = ACTIONS(2931),
    [anon_sym___based] = ACTIONS(2931),
    [anon_sym_signed] = ACTIONS(2931),
    [anon_sym_unsigned] = ACTIONS(2931),
    [anon_sym_long] = ACTIONS(2931),
    [anon_sym_short] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_register] = ACTIONS(2931),
    [anon_sym_inline] = ACTIONS(2931),
    [anon_sym___inline] = ACTIONS(2931),
    [anon_sym___inline__] = ACTIONS(2931),
    [anon_sym___forceinline] = ACTIONS(2931),
    [anon_sym_thread_local] = ACTIONS(2931),
    [anon_sym___thread] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_constexpr] = ACTIONS(2931),
    [anon_sym_volatile] = ACTIONS(2931),
    [anon_sym_restrict] = ACTIONS(2931),
    [anon_sym___restrict__] = ACTIONS(2931),
    [anon_sym__Atomic] = ACTIONS(2931),
    [anon_sym__Noreturn] = ACTIONS(2931),
    [anon_sym_noreturn] = ACTIONS(2931),
    [anon_sym__Nonnull] = ACTIONS(2931),
    [anon_sym_mutable] = ACTIONS(2931),
    [anon_sym_constinit] = ACTIONS(2931),
    [anon_sym_consteval] = ACTIONS(2931),
    [anon_sym_alignas] = ACTIONS(2931),
    [anon_sym__Alignas] = ACTIONS(2931),
    [sym_primitive_type] = ACTIONS(2931),
    [anon_sym_enum] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2931),
    [anon_sym_struct] = ACTIONS(2931),
    [anon_sym_union] = ACTIONS(2931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2931),
    [anon_sym_decltype] = ACTIONS(2931),
    [anon_sym_explicit] = ACTIONS(2931),
    [anon_sym_typename] = ACTIONS(2931),
    [anon_sym_private] = ACTIONS(2931),
    [anon_sym_template] = ACTIONS(2931),
    [anon_sym_operator] = ACTIONS(2931),
    [anon_sym_friend] = ACTIONS(2931),
    [anon_sym_public] = ACTIONS(2931),
    [anon_sym_protected] = ACTIONS(2931),
    [anon_sym_static_assert] = ACTIONS(2931),
  },
  [2045] = {
    [sym_identifier] = ACTIONS(5505),
    [aux_sym_preproc_def_token1] = ACTIONS(5505),
    [aux_sym_preproc_if_token1] = ACTIONS(5505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5505),
    [sym_preproc_directive] = ACTIONS(5505),
    [anon_sym_LPAREN2] = ACTIONS(5507),
    [anon_sym_TILDE] = ACTIONS(5507),
    [anon_sym_STAR] = ACTIONS(5507),
    [anon_sym_AMP_AMP] = ACTIONS(5507),
    [anon_sym_AMP] = ACTIONS(5505),
    [anon_sym_SEMI] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5505),
    [anon_sym_typedef] = ACTIONS(5505),
    [anon_sym_virtual] = ACTIONS(5505),
    [anon_sym_extern] = ACTIONS(5505),
    [anon_sym___attribute__] = ACTIONS(5505),
    [anon_sym___attribute] = ACTIONS(5505),
    [anon_sym_using] = ACTIONS(5505),
    [anon_sym_COLON_COLON] = ACTIONS(5507),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5507),
    [anon_sym___declspec] = ACTIONS(5505),
    [anon_sym___based] = ACTIONS(5505),
    [anon_sym_RBRACE] = ACTIONS(5507),
    [anon_sym_signed] = ACTIONS(5505),
    [anon_sym_unsigned] = ACTIONS(5505),
    [anon_sym_long] = ACTIONS(5505),
    [anon_sym_short] = ACTIONS(5505),
    [anon_sym_LBRACK] = ACTIONS(5505),
    [anon_sym_static] = ACTIONS(5505),
    [anon_sym_register] = ACTIONS(5505),
    [anon_sym_inline] = ACTIONS(5505),
    [anon_sym___inline] = ACTIONS(5505),
    [anon_sym___inline__] = ACTIONS(5505),
    [anon_sym___forceinline] = ACTIONS(5505),
    [anon_sym_thread_local] = ACTIONS(5505),
    [anon_sym___thread] = ACTIONS(5505),
    [anon_sym_const] = ACTIONS(5505),
    [anon_sym_constexpr] = ACTIONS(5505),
    [anon_sym_volatile] = ACTIONS(5505),
    [anon_sym_restrict] = ACTIONS(5505),
    [anon_sym___restrict__] = ACTIONS(5505),
    [anon_sym__Atomic] = ACTIONS(5505),
    [anon_sym__Noreturn] = ACTIONS(5505),
    [anon_sym_noreturn] = ACTIONS(5505),
    [anon_sym__Nonnull] = ACTIONS(5505),
    [anon_sym_mutable] = ACTIONS(5505),
    [anon_sym_constinit] = ACTIONS(5505),
    [anon_sym_consteval] = ACTIONS(5505),
    [anon_sym_alignas] = ACTIONS(5505),
    [anon_sym__Alignas] = ACTIONS(5505),
    [sym_primitive_type] = ACTIONS(5505),
    [anon_sym_enum] = ACTIONS(5505),
    [anon_sym_class] = ACTIONS(5505),
    [anon_sym_struct] = ACTIONS(5505),
    [anon_sym_union] = ACTIONS(5505),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5505),
    [anon_sym_decltype] = ACTIONS(5505),
    [anon_sym_explicit] = ACTIONS(5505),
    [anon_sym_typename] = ACTIONS(5505),
    [anon_sym_private] = ACTIONS(5505),
    [anon_sym_template] = ACTIONS(5505),
    [anon_sym_operator] = ACTIONS(5505),
    [anon_sym_friend] = ACTIONS(5505),
    [anon_sym_public] = ACTIONS(5505),
    [anon_sym_protected] = ACTIONS(5505),
    [anon_sym_static_assert] = ACTIONS(5505),
  },
  [2046] = {
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2761),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_private] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_friend] = ACTIONS(2759),
    [anon_sym_public] = ACTIONS(2759),
    [anon_sym_protected] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
  },
  [2047] = {
    [sym_identifier] = ACTIONS(2815),
    [aux_sym_preproc_def_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token1] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2815),
    [sym_preproc_directive] = ACTIONS(2815),
    [anon_sym_LPAREN2] = ACTIONS(2817),
    [anon_sym_TILDE] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym___extension__] = ACTIONS(2815),
    [anon_sym_typedef] = ACTIONS(2815),
    [anon_sym_virtual] = ACTIONS(2815),
    [anon_sym_extern] = ACTIONS(2815),
    [anon_sym___attribute__] = ACTIONS(2815),
    [anon_sym___attribute] = ACTIONS(2815),
    [anon_sym_using] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2817),
    [anon_sym___declspec] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2817),
    [anon_sym_signed] = ACTIONS(2815),
    [anon_sym_unsigned] = ACTIONS(2815),
    [anon_sym_long] = ACTIONS(2815),
    [anon_sym_short] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2815),
    [anon_sym_register] = ACTIONS(2815),
    [anon_sym_inline] = ACTIONS(2815),
    [anon_sym___inline] = ACTIONS(2815),
    [anon_sym___inline__] = ACTIONS(2815),
    [anon_sym___forceinline] = ACTIONS(2815),
    [anon_sym_thread_local] = ACTIONS(2815),
    [anon_sym___thread] = ACTIONS(2815),
    [anon_sym_const] = ACTIONS(2815),
    [anon_sym_constexpr] = ACTIONS(2815),
    [anon_sym_volatile] = ACTIONS(2815),
    [anon_sym_restrict] = ACTIONS(2815),
    [anon_sym___restrict__] = ACTIONS(2815),
    [anon_sym__Atomic] = ACTIONS(2815),
    [anon_sym__Noreturn] = ACTIONS(2815),
    [anon_sym_noreturn] = ACTIONS(2815),
    [anon_sym__Nonnull] = ACTIONS(2815),
    [anon_sym_mutable] = ACTIONS(2815),
    [anon_sym_constinit] = ACTIONS(2815),
    [anon_sym_consteval] = ACTIONS(2815),
    [anon_sym_alignas] = ACTIONS(2815),
    [anon_sym__Alignas] = ACTIONS(2815),
    [sym_primitive_type] = ACTIONS(2815),
    [anon_sym_enum] = ACTIONS(2815),
    [anon_sym_class] = ACTIONS(2815),
    [anon_sym_struct] = ACTIONS(2815),
    [anon_sym_union] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2815),
    [anon_sym_decltype] = ACTIONS(2815),
    [anon_sym_explicit] = ACTIONS(2815),
    [anon_sym_typename] = ACTIONS(2815),
    [anon_sym_private] = ACTIONS(2815),
    [anon_sym_template] = ACTIONS(2815),
    [anon_sym_operator] = ACTIONS(2815),
    [anon_sym_friend] = ACTIONS(2815),
    [anon_sym_public] = ACTIONS(2815),
    [anon_sym_protected] = ACTIONS(2815),
    [anon_sym_static_assert] = ACTIONS(2815),
  },
  [2048] = {
    [sym_ms_based_modifier] = STATE(8106),
    [sym_ms_unaligned_ptr_modifier] = STATE(4043),
    [sym_ms_pointer_modifier] = STATE(3820),
    [sym__declarator] = STATE(6349),
    [sym__abstract_declarator] = STATE(6655),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_function_declarator] = STATE(5998),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_array_declarator] = STATE(5998),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_type_qualifier] = STATE(2656),
    [sym_alignas_qualifier] = STATE(4289),
    [sym_parameter_list] = STATE(3216),
    [sym_decltype] = STATE(8601),
    [sym_reference_declarator] = STATE(5998),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5860),
    [sym_qualified_identifier] = STATE(5998),
    [sym_operator_name] = STATE(5998),
    [aux_sym__type_definition_type_repeat1] = STATE(2656),
    [aux_sym_pointer_declarator_repeat1] = STATE(3820),
    [sym_identifier] = ACTIONS(5849),
    [anon_sym_COMMA] = ACTIONS(5865),
    [anon_sym_LPAREN2] = ACTIONS(4298),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(5971),
    [anon_sym_AMP_AMP] = ACTIONS(5973),
    [anon_sym_AMP] = ACTIONS(5975),
    [anon_sym___extension__] = ACTIONS(3331),
    [anon_sym___attribute__] = ACTIONS(5867),
    [anon_sym___attribute] = ACTIONS(5867),
    [anon_sym_COLON_COLON] = ACTIONS(5861),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(3327),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3327),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3327),
    [anon_sym__unaligned] = ACTIONS(3329),
    [anon_sym___unaligned] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(5863),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_constexpr] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_restrict] = ACTIONS(3331),
    [anon_sym___restrict__] = ACTIONS(3331),
    [anon_sym__Atomic] = ACTIONS(3331),
    [anon_sym__Noreturn] = ACTIONS(3331),
    [anon_sym_noreturn] = ACTIONS(3331),
    [anon_sym__Nonnull] = ACTIONS(3331),
    [anon_sym_mutable] = ACTIONS(3331),
    [anon_sym_constinit] = ACTIONS(3331),
    [anon_sym_consteval] = ACTIONS(3331),
    [anon_sym_alignas] = ACTIONS(3333),
    [anon_sym__Alignas] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(5865),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [2049] = {
    [sym_identifier] = ACTIONS(2935),
    [aux_sym_preproc_def_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token2] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2935),
    [sym_preproc_directive] = ACTIONS(2935),
    [anon_sym_LPAREN2] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym___extension__] = ACTIONS(2935),
    [anon_sym_typedef] = ACTIONS(2935),
    [anon_sym_virtual] = ACTIONS(2935),
    [anon_sym_extern] = ACTIONS(2935),
    [anon_sym___attribute__] = ACTIONS(2935),
    [anon_sym___attribute] = ACTIONS(2935),
    [anon_sym_using] = ACTIONS(2935),
    [anon_sym_COLON_COLON] = ACTIONS(2937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2937),
    [anon_sym___declspec] = ACTIONS(2935),
    [anon_sym___based] = ACTIONS(2935),
    [anon_sym_signed] = ACTIONS(2935),
    [anon_sym_unsigned] = ACTIONS(2935),
    [anon_sym_long] = ACTIONS(2935),
    [anon_sym_short] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_register] = ACTIONS(2935),
    [anon_sym_inline] = ACTIONS(2935),
    [anon_sym___inline] = ACTIONS(2935),
    [anon_sym___inline__] = ACTIONS(2935),
    [anon_sym___forceinline] = ACTIONS(2935),
    [anon_sym_thread_local] = ACTIONS(2935),
    [anon_sym___thread] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_constexpr] = ACTIONS(2935),
    [anon_sym_volatile] = ACTIONS(2935),
    [anon_sym_restrict] = ACTIONS(2935),
    [anon_sym___restrict__] = ACTIONS(2935),
    [anon_sym__Atomic] = ACTIONS(2935),
    [anon_sym__Noreturn] = ACTIONS(2935),
    [anon_sym_noreturn] = ACTIONS(2935),
    [anon_sym__Nonnull] = ACTIONS(2935),
    [anon_sym_mutable] = ACTIONS(2935),
    [anon_sym_constinit] = ACTIONS(2935),
    [anon_sym_consteval] = ACTIONS(2935),
    [anon_sym_alignas] = ACTIONS(2935),
    [anon_sym__Alignas] = ACTIONS(2935),
    [sym_primitive_type] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_union] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2935),
    [anon_sym_decltype] = ACTIONS(2935),
    [anon_sym_explicit] = ACTIONS(2935),
    [anon_sym_typename] = ACTIONS(2935),
    [anon_sym_private] = ACTIONS(2935),
    [anon_sym_template] = ACTIONS(2935),
    [anon_sym_operator] = ACTIONS(2935),
    [anon_sym_friend] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2935),
    [anon_sym_protected] = ACTIONS(2935),
    [anon_sym_static_assert] = ACTIONS(2935),
  },
  [2050] = {
    [sym_template_argument_list] = STATE(1603),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2248),
    [sym_identifier] = ACTIONS(5977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5979),
    [anon_sym_COMMA] = ACTIONS(5979),
    [aux_sym_preproc_if_token2] = ACTIONS(5979),
    [aux_sym_preproc_else_token1] = ACTIONS(5979),
    [aux_sym_preproc_elif_token1] = ACTIONS(5977),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5979),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5979),
    [anon_sym_LPAREN2] = ACTIONS(5979),
    [anon_sym_DASH] = ACTIONS(5977),
    [anon_sym_PLUS] = ACTIONS(5977),
    [anon_sym_STAR] = ACTIONS(5977),
    [anon_sym_SLASH] = ACTIONS(5977),
    [anon_sym_PERCENT] = ACTIONS(5977),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_AMP_AMP] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [anon_sym_AMP] = ACTIONS(5977),
    [anon_sym_EQ_EQ] = ACTIONS(5979),
    [anon_sym_BANG_EQ] = ACTIONS(5979),
    [anon_sym_GT] = ACTIONS(5977),
    [anon_sym_GT_EQ] = ACTIONS(5979),
    [anon_sym_LT_EQ] = ACTIONS(5977),
    [anon_sym_LT] = ACTIONS(5977),
    [anon_sym_LT_LT] = ACTIONS(5977),
    [anon_sym_GT_GT] = ACTIONS(5977),
    [anon_sym___attribute__] = ACTIONS(5977),
    [anon_sym___attribute] = ACTIONS(5977),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(5979),
    [anon_sym_signed] = ACTIONS(5981),
    [anon_sym_unsigned] = ACTIONS(5981),
    [anon_sym_long] = ACTIONS(5981),
    [anon_sym_short] = ACTIONS(5981),
    [anon_sym_LBRACK] = ACTIONS(5979),
    [anon_sym_EQ] = ACTIONS(5977),
    [anon_sym_QMARK] = ACTIONS(5979),
    [anon_sym_STAR_EQ] = ACTIONS(5979),
    [anon_sym_SLASH_EQ] = ACTIONS(5979),
    [anon_sym_PERCENT_EQ] = ACTIONS(5979),
    [anon_sym_PLUS_EQ] = ACTIONS(5979),
    [anon_sym_DASH_EQ] = ACTIONS(5979),
    [anon_sym_LT_LT_EQ] = ACTIONS(5979),
    [anon_sym_GT_GT_EQ] = ACTIONS(5979),
    [anon_sym_AMP_EQ] = ACTIONS(5979),
    [anon_sym_CARET_EQ] = ACTIONS(5979),
    [anon_sym_PIPE_EQ] = ACTIONS(5979),
    [anon_sym_and_eq] = ACTIONS(5977),
    [anon_sym_or_eq] = ACTIONS(5977),
    [anon_sym_xor_eq] = ACTIONS(5977),
    [anon_sym_LT_EQ_GT] = ACTIONS(5979),
    [anon_sym_or] = ACTIONS(5977),
    [anon_sym_and] = ACTIONS(5977),
    [anon_sym_bitor] = ACTIONS(5977),
    [anon_sym_xor] = ACTIONS(5977),
    [anon_sym_bitand] = ACTIONS(5977),
    [anon_sym_not_eq] = ACTIONS(5977),
    [anon_sym_DASH_DASH] = ACTIONS(5979),
    [anon_sym_PLUS_PLUS] = ACTIONS(5979),
    [anon_sym_DOT] = ACTIONS(5977),
    [anon_sym_DOT_STAR] = ACTIONS(5979),
    [anon_sym_DASH_GT] = ACTIONS(5979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5977),
    [anon_sym_decltype] = ACTIONS(5977),
  },
  [2051] = {
    [sym_attribute_specifier] = STATE(2233),
    [sym_enumerator_list] = STATE(2183),
    [sym_identifier] = ACTIONS(5983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5985),
    [anon_sym_COMMA] = ACTIONS(5985),
    [anon_sym_RPAREN] = ACTIONS(5985),
    [aux_sym_preproc_if_token2] = ACTIONS(5985),
    [aux_sym_preproc_else_token1] = ACTIONS(5985),
    [aux_sym_preproc_elif_token1] = ACTIONS(5983),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5985),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5985),
    [anon_sym_LPAREN2] = ACTIONS(5985),
    [anon_sym_DASH] = ACTIONS(5983),
    [anon_sym_PLUS] = ACTIONS(5983),
    [anon_sym_STAR] = ACTIONS(5983),
    [anon_sym_SLASH] = ACTIONS(5983),
    [anon_sym_PERCENT] = ACTIONS(5983),
    [anon_sym_PIPE_PIPE] = ACTIONS(5985),
    [anon_sym_AMP_AMP] = ACTIONS(5985),
    [anon_sym_PIPE] = ACTIONS(5983),
    [anon_sym_CARET] = ACTIONS(5983),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_EQ_EQ] = ACTIONS(5985),
    [anon_sym_BANG_EQ] = ACTIONS(5985),
    [anon_sym_GT] = ACTIONS(5983),
    [anon_sym_GT_EQ] = ACTIONS(5985),
    [anon_sym_LT_EQ] = ACTIONS(5983),
    [anon_sym_LT] = ACTIONS(5983),
    [anon_sym_LT_LT] = ACTIONS(5983),
    [anon_sym_GT_GT] = ACTIONS(5983),
    [anon_sym_SEMI] = ACTIONS(5985),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(5985),
    [anon_sym_LBRACE] = ACTIONS(5987),
    [anon_sym_RBRACE] = ACTIONS(5985),
    [anon_sym_LBRACK] = ACTIONS(5985),
    [anon_sym_RBRACK] = ACTIONS(5985),
    [anon_sym_EQ] = ACTIONS(5983),
    [anon_sym_QMARK] = ACTIONS(5985),
    [anon_sym_STAR_EQ] = ACTIONS(5985),
    [anon_sym_SLASH_EQ] = ACTIONS(5985),
    [anon_sym_PERCENT_EQ] = ACTIONS(5985),
    [anon_sym_PLUS_EQ] = ACTIONS(5985),
    [anon_sym_DASH_EQ] = ACTIONS(5985),
    [anon_sym_LT_LT_EQ] = ACTIONS(5985),
    [anon_sym_GT_GT_EQ] = ACTIONS(5985),
    [anon_sym_AMP_EQ] = ACTIONS(5985),
    [anon_sym_CARET_EQ] = ACTIONS(5985),
    [anon_sym_PIPE_EQ] = ACTIONS(5985),
    [anon_sym_and_eq] = ACTIONS(5983),
    [anon_sym_or_eq] = ACTIONS(5983),
    [anon_sym_xor_eq] = ACTIONS(5983),
    [anon_sym_LT_EQ_GT] = ACTIONS(5985),
    [anon_sym_or] = ACTIONS(5983),
    [anon_sym_and] = ACTIONS(5983),
    [anon_sym_bitor] = ACTIONS(5983),
    [anon_sym_xor] = ACTIONS(5983),
    [anon_sym_bitand] = ACTIONS(5983),
    [anon_sym_not_eq] = ACTIONS(5983),
    [anon_sym_DASH_DASH] = ACTIONS(5985),
    [anon_sym_PLUS_PLUS] = ACTIONS(5985),
    [anon_sym_DOT] = ACTIONS(5983),
    [anon_sym_DOT_STAR] = ACTIONS(5985),
    [anon_sym_DASH_GT] = ACTIONS(5985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5983),
    [anon_sym_decltype] = ACTIONS(5983),
  },
  [2052] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(2767),
    [anon_sym_public] = ACTIONS(2767),
    [anon_sym_protected] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
  },
  [2053] = {
    [sym_identifier] = ACTIONS(5989),
    [anon_sym_LPAREN2] = ACTIONS(5991),
    [anon_sym_TILDE] = ACTIONS(5991),
    [anon_sym_STAR] = ACTIONS(5991),
    [anon_sym_AMP_AMP] = ACTIONS(5991),
    [anon_sym_AMP] = ACTIONS(5989),
    [anon_sym___extension__] = ACTIONS(5989),
    [anon_sym_virtual] = ACTIONS(5989),
    [anon_sym_extern] = ACTIONS(5989),
    [anon_sym___attribute__] = ACTIONS(5989),
    [anon_sym___attribute] = ACTIONS(5989),
    [anon_sym_using] = ACTIONS(5989),
    [anon_sym_COLON_COLON] = ACTIONS(5991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5991),
    [anon_sym___declspec] = ACTIONS(5989),
    [anon_sym___based] = ACTIONS(5989),
    [anon_sym___cdecl] = ACTIONS(5989),
    [anon_sym___clrcall] = ACTIONS(5989),
    [anon_sym___stdcall] = ACTIONS(5989),
    [anon_sym___fastcall] = ACTIONS(5989),
    [anon_sym___thiscall] = ACTIONS(5989),
    [anon_sym___vectorcall] = ACTIONS(5989),
    [anon_sym_LBRACE] = ACTIONS(5991),
    [anon_sym_signed] = ACTIONS(5989),
    [anon_sym_unsigned] = ACTIONS(5989),
    [anon_sym_long] = ACTIONS(5989),
    [anon_sym_short] = ACTIONS(5989),
    [anon_sym_LBRACK] = ACTIONS(5989),
    [anon_sym_static] = ACTIONS(5989),
    [anon_sym_register] = ACTIONS(5989),
    [anon_sym_inline] = ACTIONS(5989),
    [anon_sym___inline] = ACTIONS(5989),
    [anon_sym___inline__] = ACTIONS(5989),
    [anon_sym___forceinline] = ACTIONS(5989),
    [anon_sym_thread_local] = ACTIONS(5989),
    [anon_sym___thread] = ACTIONS(5989),
    [anon_sym_const] = ACTIONS(5989),
    [anon_sym_constexpr] = ACTIONS(5989),
    [anon_sym_volatile] = ACTIONS(5989),
    [anon_sym_restrict] = ACTIONS(5989),
    [anon_sym___restrict__] = ACTIONS(5989),
    [anon_sym__Atomic] = ACTIONS(5989),
    [anon_sym__Noreturn] = ACTIONS(5989),
    [anon_sym_noreturn] = ACTIONS(5989),
    [anon_sym__Nonnull] = ACTIONS(5989),
    [anon_sym_mutable] = ACTIONS(5989),
    [anon_sym_constinit] = ACTIONS(5989),
    [anon_sym_consteval] = ACTIONS(5989),
    [anon_sym_alignas] = ACTIONS(5989),
    [anon_sym__Alignas] = ACTIONS(5989),
    [sym_primitive_type] = ACTIONS(5989),
    [anon_sym_enum] = ACTIONS(5989),
    [anon_sym_class] = ACTIONS(5989),
    [anon_sym_struct] = ACTIONS(5989),
    [anon_sym_union] = ACTIONS(5989),
    [anon_sym_DASH_GT] = ACTIONS(5991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5989),
    [anon_sym_decltype] = ACTIONS(5989),
    [anon_sym_explicit] = ACTIONS(5989),
    [anon_sym_typename] = ACTIONS(5989),
    [anon_sym_template] = ACTIONS(5989),
    [anon_sym_operator] = ACTIONS(5989),
    [anon_sym_friend] = ACTIONS(5989),
    [anon_sym_noexcept] = ACTIONS(5989),
    [anon_sym_throw] = ACTIONS(5989),
    [anon_sym_concept] = ACTIONS(5989),
    [anon_sym_requires] = ACTIONS(5989),
  },
  [2054] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(2767),
    [anon_sym_public] = ACTIONS(2767),
    [anon_sym_protected] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
  },
  [2055] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1669),
    [sym_identifier] = ACTIONS(5159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5156),
    [anon_sym_COMMA] = ACTIONS(5156),
    [aux_sym_preproc_if_token2] = ACTIONS(5156),
    [aux_sym_preproc_else_token1] = ACTIONS(5156),
    [aux_sym_preproc_elif_token1] = ACTIONS(5159),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5156),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5156),
    [anon_sym_LPAREN2] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5159),
    [anon_sym_STAR] = ACTIONS(5156),
    [anon_sym_SLASH] = ACTIONS(5159),
    [anon_sym_PERCENT] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE] = ACTIONS(5156),
    [anon_sym_AMP_AMP] = ACTIONS(5156),
    [anon_sym_PIPE] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5156),
    [anon_sym_AMP] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5156),
    [anon_sym_BANG_EQ] = ACTIONS(5156),
    [anon_sym_GT] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5156),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5159),
    [anon_sym_LT_LT] = ACTIONS(5156),
    [anon_sym_GT_GT] = ACTIONS(5156),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5159),
    [anon_sym___attribute] = ACTIONS(5159),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_signed] = ACTIONS(5370),
    [anon_sym_unsigned] = ACTIONS(5370),
    [anon_sym_long] = ACTIONS(5370),
    [anon_sym_short] = ACTIONS(5370),
    [anon_sym_LBRACK] = ACTIONS(5156),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5156),
    [anon_sym_LT_EQ_GT] = ACTIONS(5156),
    [anon_sym_or] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_bitor] = ACTIONS(5159),
    [anon_sym_xor] = ACTIONS(5159),
    [anon_sym_bitand] = ACTIONS(5159),
    [anon_sym_not_eq] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5156),
    [anon_sym_PLUS_PLUS] = ACTIONS(5156),
    [anon_sym_DOT] = ACTIONS(5159),
    [anon_sym_DOT_STAR] = ACTIONS(5156),
    [anon_sym_DASH_GT] = ACTIONS(5156),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5159),
    [anon_sym_decltype] = ACTIONS(5159),
  },
  [2056] = {
    [sym_identifier] = ACTIONS(5993),
    [anon_sym_LPAREN2] = ACTIONS(5995),
    [anon_sym_TILDE] = ACTIONS(5995),
    [anon_sym_STAR] = ACTIONS(5995),
    [anon_sym_AMP_AMP] = ACTIONS(5995),
    [anon_sym_AMP] = ACTIONS(5993),
    [anon_sym___extension__] = ACTIONS(5993),
    [anon_sym_virtual] = ACTIONS(5993),
    [anon_sym_extern] = ACTIONS(5993),
    [anon_sym___attribute__] = ACTIONS(5993),
    [anon_sym___attribute] = ACTIONS(5993),
    [anon_sym_using] = ACTIONS(5993),
    [anon_sym_COLON_COLON] = ACTIONS(5995),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5995),
    [anon_sym___declspec] = ACTIONS(5993),
    [anon_sym___based] = ACTIONS(5993),
    [anon_sym___cdecl] = ACTIONS(5993),
    [anon_sym___clrcall] = ACTIONS(5993),
    [anon_sym___stdcall] = ACTIONS(5993),
    [anon_sym___fastcall] = ACTIONS(5993),
    [anon_sym___thiscall] = ACTIONS(5993),
    [anon_sym___vectorcall] = ACTIONS(5993),
    [anon_sym_LBRACE] = ACTIONS(5995),
    [anon_sym_signed] = ACTIONS(5993),
    [anon_sym_unsigned] = ACTIONS(5993),
    [anon_sym_long] = ACTIONS(5993),
    [anon_sym_short] = ACTIONS(5993),
    [anon_sym_LBRACK] = ACTIONS(5993),
    [anon_sym_static] = ACTIONS(5993),
    [anon_sym_register] = ACTIONS(5993),
    [anon_sym_inline] = ACTIONS(5993),
    [anon_sym___inline] = ACTIONS(5993),
    [anon_sym___inline__] = ACTIONS(5993),
    [anon_sym___forceinline] = ACTIONS(5993),
    [anon_sym_thread_local] = ACTIONS(5993),
    [anon_sym___thread] = ACTIONS(5993),
    [anon_sym_const] = ACTIONS(5993),
    [anon_sym_constexpr] = ACTIONS(5993),
    [anon_sym_volatile] = ACTIONS(5993),
    [anon_sym_restrict] = ACTIONS(5993),
    [anon_sym___restrict__] = ACTIONS(5993),
    [anon_sym__Atomic] = ACTIONS(5993),
    [anon_sym__Noreturn] = ACTIONS(5993),
    [anon_sym_noreturn] = ACTIONS(5993),
    [anon_sym__Nonnull] = ACTIONS(5993),
    [anon_sym_mutable] = ACTIONS(5993),
    [anon_sym_constinit] = ACTIONS(5993),
    [anon_sym_consteval] = ACTIONS(5993),
    [anon_sym_alignas] = ACTIONS(5993),
    [anon_sym__Alignas] = ACTIONS(5993),
    [sym_primitive_type] = ACTIONS(5993),
    [anon_sym_enum] = ACTIONS(5993),
    [anon_sym_class] = ACTIONS(5993),
    [anon_sym_struct] = ACTIONS(5993),
    [anon_sym_union] = ACTIONS(5993),
    [anon_sym_DASH_GT] = ACTIONS(5995),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5993),
    [anon_sym_decltype] = ACTIONS(5993),
    [anon_sym_explicit] = ACTIONS(5993),
    [anon_sym_typename] = ACTIONS(5993),
    [anon_sym_template] = ACTIONS(5993),
    [anon_sym_operator] = ACTIONS(5993),
    [anon_sym_friend] = ACTIONS(5993),
    [anon_sym_noexcept] = ACTIONS(5993),
    [anon_sym_throw] = ACTIONS(5993),
    [anon_sym_concept] = ACTIONS(5993),
    [anon_sym_requires] = ACTIONS(5993),
  },
  [2057] = {
    [sym_identifier] = ACTIONS(2939),
    [aux_sym_preproc_def_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token2] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2939),
    [sym_preproc_directive] = ACTIONS(2939),
    [anon_sym_LPAREN2] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2939),
    [anon_sym_typedef] = ACTIONS(2939),
    [anon_sym_virtual] = ACTIONS(2939),
    [anon_sym_extern] = ACTIONS(2939),
    [anon_sym___attribute__] = ACTIONS(2939),
    [anon_sym___attribute] = ACTIONS(2939),
    [anon_sym_using] = ACTIONS(2939),
    [anon_sym_COLON_COLON] = ACTIONS(2941),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2941),
    [anon_sym___declspec] = ACTIONS(2939),
    [anon_sym___based] = ACTIONS(2939),
    [anon_sym_signed] = ACTIONS(2939),
    [anon_sym_unsigned] = ACTIONS(2939),
    [anon_sym_long] = ACTIONS(2939),
    [anon_sym_short] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_static] = ACTIONS(2939),
    [anon_sym_register] = ACTIONS(2939),
    [anon_sym_inline] = ACTIONS(2939),
    [anon_sym___inline] = ACTIONS(2939),
    [anon_sym___inline__] = ACTIONS(2939),
    [anon_sym___forceinline] = ACTIONS(2939),
    [anon_sym_thread_local] = ACTIONS(2939),
    [anon_sym___thread] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_constexpr] = ACTIONS(2939),
    [anon_sym_volatile] = ACTIONS(2939),
    [anon_sym_restrict] = ACTIONS(2939),
    [anon_sym___restrict__] = ACTIONS(2939),
    [anon_sym__Atomic] = ACTIONS(2939),
    [anon_sym__Noreturn] = ACTIONS(2939),
    [anon_sym_noreturn] = ACTIONS(2939),
    [anon_sym__Nonnull] = ACTIONS(2939),
    [anon_sym_mutable] = ACTIONS(2939),
    [anon_sym_constinit] = ACTIONS(2939),
    [anon_sym_consteval] = ACTIONS(2939),
    [anon_sym_alignas] = ACTIONS(2939),
    [anon_sym__Alignas] = ACTIONS(2939),
    [sym_primitive_type] = ACTIONS(2939),
    [anon_sym_enum] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2939),
    [anon_sym_struct] = ACTIONS(2939),
    [anon_sym_union] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2939),
    [anon_sym_decltype] = ACTIONS(2939),
    [anon_sym_explicit] = ACTIONS(2939),
    [anon_sym_typename] = ACTIONS(2939),
    [anon_sym_private] = ACTIONS(2939),
    [anon_sym_template] = ACTIONS(2939),
    [anon_sym_operator] = ACTIONS(2939),
    [anon_sym_friend] = ACTIONS(2939),
    [anon_sym_public] = ACTIONS(2939),
    [anon_sym_protected] = ACTIONS(2939),
    [anon_sym_static_assert] = ACTIONS(2939),
  },
  [2058] = {
    [sym_identifier] = ACTIONS(5609),
    [aux_sym_preproc_def_token1] = ACTIONS(5609),
    [aux_sym_preproc_if_token1] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5609),
    [sym_preproc_directive] = ACTIONS(5609),
    [anon_sym_LPAREN2] = ACTIONS(5611),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_STAR] = ACTIONS(5611),
    [anon_sym_AMP_AMP] = ACTIONS(5611),
    [anon_sym_AMP] = ACTIONS(5609),
    [anon_sym_SEMI] = ACTIONS(5611),
    [anon_sym___extension__] = ACTIONS(5609),
    [anon_sym_typedef] = ACTIONS(5609),
    [anon_sym_virtual] = ACTIONS(5609),
    [anon_sym_extern] = ACTIONS(5609),
    [anon_sym___attribute__] = ACTIONS(5609),
    [anon_sym___attribute] = ACTIONS(5609),
    [anon_sym_using] = ACTIONS(5609),
    [anon_sym_COLON_COLON] = ACTIONS(5611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5611),
    [anon_sym___declspec] = ACTIONS(5609),
    [anon_sym___based] = ACTIONS(5609),
    [anon_sym_RBRACE] = ACTIONS(5611),
    [anon_sym_signed] = ACTIONS(5609),
    [anon_sym_unsigned] = ACTIONS(5609),
    [anon_sym_long] = ACTIONS(5609),
    [anon_sym_short] = ACTIONS(5609),
    [anon_sym_LBRACK] = ACTIONS(5609),
    [anon_sym_static] = ACTIONS(5609),
    [anon_sym_register] = ACTIONS(5609),
    [anon_sym_inline] = ACTIONS(5609),
    [anon_sym___inline] = ACTIONS(5609),
    [anon_sym___inline__] = ACTIONS(5609),
    [anon_sym___forceinline] = ACTIONS(5609),
    [anon_sym_thread_local] = ACTIONS(5609),
    [anon_sym___thread] = ACTIONS(5609),
    [anon_sym_const] = ACTIONS(5609),
    [anon_sym_constexpr] = ACTIONS(5609),
    [anon_sym_volatile] = ACTIONS(5609),
    [anon_sym_restrict] = ACTIONS(5609),
    [anon_sym___restrict__] = ACTIONS(5609),
    [anon_sym__Atomic] = ACTIONS(5609),
    [anon_sym__Noreturn] = ACTIONS(5609),
    [anon_sym_noreturn] = ACTIONS(5609),
    [anon_sym__Nonnull] = ACTIONS(5609),
    [anon_sym_mutable] = ACTIONS(5609),
    [anon_sym_constinit] = ACTIONS(5609),
    [anon_sym_consteval] = ACTIONS(5609),
    [anon_sym_alignas] = ACTIONS(5609),
    [anon_sym__Alignas] = ACTIONS(5609),
    [sym_primitive_type] = ACTIONS(5609),
    [anon_sym_enum] = ACTIONS(5609),
    [anon_sym_class] = ACTIONS(5609),
    [anon_sym_struct] = ACTIONS(5609),
    [anon_sym_union] = ACTIONS(5609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5609),
    [anon_sym_decltype] = ACTIONS(5609),
    [anon_sym_explicit] = ACTIONS(5609),
    [anon_sym_typename] = ACTIONS(5609),
    [anon_sym_private] = ACTIONS(5609),
    [anon_sym_template] = ACTIONS(5609),
    [anon_sym_operator] = ACTIONS(5609),
    [anon_sym_friend] = ACTIONS(5609),
    [anon_sym_public] = ACTIONS(5609),
    [anon_sym_protected] = ACTIONS(5609),
    [anon_sym_static_assert] = ACTIONS(5609),
  },
  [2059] = {
    [sym_identifier] = ACTIONS(5613),
    [aux_sym_preproc_def_token1] = ACTIONS(5613),
    [aux_sym_preproc_if_token1] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5613),
    [sym_preproc_directive] = ACTIONS(5613),
    [anon_sym_LPAREN2] = ACTIONS(5615),
    [anon_sym_TILDE] = ACTIONS(5615),
    [anon_sym_STAR] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5613),
    [anon_sym_SEMI] = ACTIONS(5615),
    [anon_sym___extension__] = ACTIONS(5613),
    [anon_sym_typedef] = ACTIONS(5613),
    [anon_sym_virtual] = ACTIONS(5613),
    [anon_sym_extern] = ACTIONS(5613),
    [anon_sym___attribute__] = ACTIONS(5613),
    [anon_sym___attribute] = ACTIONS(5613),
    [anon_sym_using] = ACTIONS(5613),
    [anon_sym_COLON_COLON] = ACTIONS(5615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5615),
    [anon_sym___declspec] = ACTIONS(5613),
    [anon_sym___based] = ACTIONS(5613),
    [anon_sym_RBRACE] = ACTIONS(5615),
    [anon_sym_signed] = ACTIONS(5613),
    [anon_sym_unsigned] = ACTIONS(5613),
    [anon_sym_long] = ACTIONS(5613),
    [anon_sym_short] = ACTIONS(5613),
    [anon_sym_LBRACK] = ACTIONS(5613),
    [anon_sym_static] = ACTIONS(5613),
    [anon_sym_register] = ACTIONS(5613),
    [anon_sym_inline] = ACTIONS(5613),
    [anon_sym___inline] = ACTIONS(5613),
    [anon_sym___inline__] = ACTIONS(5613),
    [anon_sym___forceinline] = ACTIONS(5613),
    [anon_sym_thread_local] = ACTIONS(5613),
    [anon_sym___thread] = ACTIONS(5613),
    [anon_sym_const] = ACTIONS(5613),
    [anon_sym_constexpr] = ACTIONS(5613),
    [anon_sym_volatile] = ACTIONS(5613),
    [anon_sym_restrict] = ACTIONS(5613),
    [anon_sym___restrict__] = ACTIONS(5613),
    [anon_sym__Atomic] = ACTIONS(5613),
    [anon_sym__Noreturn] = ACTIONS(5613),
    [anon_sym_noreturn] = ACTIONS(5613),
    [anon_sym__Nonnull] = ACTIONS(5613),
    [anon_sym_mutable] = ACTIONS(5613),
    [anon_sym_constinit] = ACTIONS(5613),
    [anon_sym_consteval] = ACTIONS(5613),
    [anon_sym_alignas] = ACTIONS(5613),
    [anon_sym__Alignas] = ACTIONS(5613),
    [sym_primitive_type] = ACTIONS(5613),
    [anon_sym_enum] = ACTIONS(5613),
    [anon_sym_class] = ACTIONS(5613),
    [anon_sym_struct] = ACTIONS(5613),
    [anon_sym_union] = ACTIONS(5613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5613),
    [anon_sym_decltype] = ACTIONS(5613),
    [anon_sym_explicit] = ACTIONS(5613),
    [anon_sym_typename] = ACTIONS(5613),
    [anon_sym_private] = ACTIONS(5613),
    [anon_sym_template] = ACTIONS(5613),
    [anon_sym_operator] = ACTIONS(5613),
    [anon_sym_friend] = ACTIONS(5613),
    [anon_sym_public] = ACTIONS(5613),
    [anon_sym_protected] = ACTIONS(5613),
    [anon_sym_static_assert] = ACTIONS(5613),
  },
  [2060] = {
    [sym_identifier] = ACTIONS(5609),
    [aux_sym_preproc_def_token1] = ACTIONS(5609),
    [aux_sym_preproc_if_token1] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5609),
    [sym_preproc_directive] = ACTIONS(5609),
    [anon_sym_LPAREN2] = ACTIONS(5611),
    [anon_sym_TILDE] = ACTIONS(5611),
    [anon_sym_STAR] = ACTIONS(5611),
    [anon_sym_AMP_AMP] = ACTIONS(5611),
    [anon_sym_AMP] = ACTIONS(5609),
    [anon_sym_SEMI] = ACTIONS(5611),
    [anon_sym___extension__] = ACTIONS(5609),
    [anon_sym_typedef] = ACTIONS(5609),
    [anon_sym_virtual] = ACTIONS(5609),
    [anon_sym_extern] = ACTIONS(5609),
    [anon_sym___attribute__] = ACTIONS(5609),
    [anon_sym___attribute] = ACTIONS(5609),
    [anon_sym_using] = ACTIONS(5609),
    [anon_sym_COLON_COLON] = ACTIONS(5611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5611),
    [anon_sym___declspec] = ACTIONS(5609),
    [anon_sym___based] = ACTIONS(5609),
    [anon_sym_RBRACE] = ACTIONS(5611),
    [anon_sym_signed] = ACTIONS(5609),
    [anon_sym_unsigned] = ACTIONS(5609),
    [anon_sym_long] = ACTIONS(5609),
    [anon_sym_short] = ACTIONS(5609),
    [anon_sym_LBRACK] = ACTIONS(5609),
    [anon_sym_static] = ACTIONS(5609),
    [anon_sym_register] = ACTIONS(5609),
    [anon_sym_inline] = ACTIONS(5609),
    [anon_sym___inline] = ACTIONS(5609),
    [anon_sym___inline__] = ACTIONS(5609),
    [anon_sym___forceinline] = ACTIONS(5609),
    [anon_sym_thread_local] = ACTIONS(5609),
    [anon_sym___thread] = ACTIONS(5609),
    [anon_sym_const] = ACTIONS(5609),
    [anon_sym_constexpr] = ACTIONS(5609),
    [anon_sym_volatile] = ACTIONS(5609),
    [anon_sym_restrict] = ACTIONS(5609),
    [anon_sym___restrict__] = ACTIONS(5609),
    [anon_sym__Atomic] = ACTIONS(5609),
    [anon_sym__Noreturn] = ACTIONS(5609),
    [anon_sym_noreturn] = ACTIONS(5609),
    [anon_sym__Nonnull] = ACTIONS(5609),
    [anon_sym_mutable] = ACTIONS(5609),
    [anon_sym_constinit] = ACTIONS(5609),
    [anon_sym_consteval] = ACTIONS(5609),
    [anon_sym_alignas] = ACTIONS(5609),
    [anon_sym__Alignas] = ACTIONS(5609),
    [sym_primitive_type] = ACTIONS(5609),
    [anon_sym_enum] = ACTIONS(5609),
    [anon_sym_class] = ACTIONS(5609),
    [anon_sym_struct] = ACTIONS(5609),
    [anon_sym_union] = ACTIONS(5609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5609),
    [anon_sym_decltype] = ACTIONS(5609),
    [anon_sym_explicit] = ACTIONS(5609),
    [anon_sym_typename] = ACTIONS(5609),
    [anon_sym_private] = ACTIONS(5609),
    [anon_sym_template] = ACTIONS(5609),
    [anon_sym_operator] = ACTIONS(5609),
    [anon_sym_friend] = ACTIONS(5609),
    [anon_sym_public] = ACTIONS(5609),
    [anon_sym_protected] = ACTIONS(5609),
    [anon_sym_static_assert] = ACTIONS(5609),
  },
  [2061] = {
    [sym__declaration_modifiers] = STATE(3269),
    [sym_attribute_specifier] = STATE(3269),
    [sym_attribute_declaration] = STATE(3269),
    [sym_ms_declspec_modifier] = STATE(3269),
    [sym_storage_class_specifier] = STATE(3269),
    [sym_type_qualifier] = STATE(3269),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2385),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6606),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3269),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5010),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(5958),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_struct] = ACTIONS(1888),
    [anon_sym_union] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1914),
    [anon_sym_template] = ACTIONS(1452),
  },
  [2062] = {
    [sym_identifier] = ACTIONS(5613),
    [aux_sym_preproc_def_token1] = ACTIONS(5613),
    [aux_sym_preproc_if_token1] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5613),
    [sym_preproc_directive] = ACTIONS(5613),
    [anon_sym_LPAREN2] = ACTIONS(5615),
    [anon_sym_TILDE] = ACTIONS(5615),
    [anon_sym_STAR] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5613),
    [anon_sym_SEMI] = ACTIONS(5615),
    [anon_sym___extension__] = ACTIONS(5613),
    [anon_sym_typedef] = ACTIONS(5613),
    [anon_sym_virtual] = ACTIONS(5613),
    [anon_sym_extern] = ACTIONS(5613),
    [anon_sym___attribute__] = ACTIONS(5613),
    [anon_sym___attribute] = ACTIONS(5613),
    [anon_sym_using] = ACTIONS(5613),
    [anon_sym_COLON_COLON] = ACTIONS(5615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5615),
    [anon_sym___declspec] = ACTIONS(5613),
    [anon_sym___based] = ACTIONS(5613),
    [anon_sym_RBRACE] = ACTIONS(5615),
    [anon_sym_signed] = ACTIONS(5613),
    [anon_sym_unsigned] = ACTIONS(5613),
    [anon_sym_long] = ACTIONS(5613),
    [anon_sym_short] = ACTIONS(5613),
    [anon_sym_LBRACK] = ACTIONS(5613),
    [anon_sym_static] = ACTIONS(5613),
    [anon_sym_register] = ACTIONS(5613),
    [anon_sym_inline] = ACTIONS(5613),
    [anon_sym___inline] = ACTIONS(5613),
    [anon_sym___inline__] = ACTIONS(5613),
    [anon_sym___forceinline] = ACTIONS(5613),
    [anon_sym_thread_local] = ACTIONS(5613),
    [anon_sym___thread] = ACTIONS(5613),
    [anon_sym_const] = ACTIONS(5613),
    [anon_sym_constexpr] = ACTIONS(5613),
    [anon_sym_volatile] = ACTIONS(5613),
    [anon_sym_restrict] = ACTIONS(5613),
    [anon_sym___restrict__] = ACTIONS(5613),
    [anon_sym__Atomic] = ACTIONS(5613),
    [anon_sym__Noreturn] = ACTIONS(5613),
    [anon_sym_noreturn] = ACTIONS(5613),
    [anon_sym__Nonnull] = ACTIONS(5613),
    [anon_sym_mutable] = ACTIONS(5613),
    [anon_sym_constinit] = ACTIONS(5613),
    [anon_sym_consteval] = ACTIONS(5613),
    [anon_sym_alignas] = ACTIONS(5613),
    [anon_sym__Alignas] = ACTIONS(5613),
    [sym_primitive_type] = ACTIONS(5613),
    [anon_sym_enum] = ACTIONS(5613),
    [anon_sym_class] = ACTIONS(5613),
    [anon_sym_struct] = ACTIONS(5613),
    [anon_sym_union] = ACTIONS(5613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5613),
    [anon_sym_decltype] = ACTIONS(5613),
    [anon_sym_explicit] = ACTIONS(5613),
    [anon_sym_typename] = ACTIONS(5613),
    [anon_sym_private] = ACTIONS(5613),
    [anon_sym_template] = ACTIONS(5613),
    [anon_sym_operator] = ACTIONS(5613),
    [anon_sym_friend] = ACTIONS(5613),
    [anon_sym_public] = ACTIONS(5613),
    [anon_sym_protected] = ACTIONS(5613),
    [anon_sym_static_assert] = ACTIONS(5613),
  },
  [2063] = {
    [sym_identifier] = ACTIONS(5621),
    [aux_sym_preproc_def_token1] = ACTIONS(5621),
    [aux_sym_preproc_if_token1] = ACTIONS(5621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5621),
    [sym_preproc_directive] = ACTIONS(5621),
    [anon_sym_LPAREN2] = ACTIONS(5623),
    [anon_sym_TILDE] = ACTIONS(5623),
    [anon_sym_STAR] = ACTIONS(5623),
    [anon_sym_AMP_AMP] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5621),
    [anon_sym_SEMI] = ACTIONS(5623),
    [anon_sym___extension__] = ACTIONS(5621),
    [anon_sym_typedef] = ACTIONS(5621),
    [anon_sym_virtual] = ACTIONS(5621),
    [anon_sym_extern] = ACTIONS(5621),
    [anon_sym___attribute__] = ACTIONS(5621),
    [anon_sym___attribute] = ACTIONS(5621),
    [anon_sym_using] = ACTIONS(5621),
    [anon_sym_COLON_COLON] = ACTIONS(5623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5623),
    [anon_sym___declspec] = ACTIONS(5621),
    [anon_sym___based] = ACTIONS(5621),
    [anon_sym_RBRACE] = ACTIONS(5623),
    [anon_sym_signed] = ACTIONS(5621),
    [anon_sym_unsigned] = ACTIONS(5621),
    [anon_sym_long] = ACTIONS(5621),
    [anon_sym_short] = ACTIONS(5621),
    [anon_sym_LBRACK] = ACTIONS(5621),
    [anon_sym_static] = ACTIONS(5621),
    [anon_sym_register] = ACTIONS(5621),
    [anon_sym_inline] = ACTIONS(5621),
    [anon_sym___inline] = ACTIONS(5621),
    [anon_sym___inline__] = ACTIONS(5621),
    [anon_sym___forceinline] = ACTIONS(5621),
    [anon_sym_thread_local] = ACTIONS(5621),
    [anon_sym___thread] = ACTIONS(5621),
    [anon_sym_const] = ACTIONS(5621),
    [anon_sym_constexpr] = ACTIONS(5621),
    [anon_sym_volatile] = ACTIONS(5621),
    [anon_sym_restrict] = ACTIONS(5621),
    [anon_sym___restrict__] = ACTIONS(5621),
    [anon_sym__Atomic] = ACTIONS(5621),
    [anon_sym__Noreturn] = ACTIONS(5621),
    [anon_sym_noreturn] = ACTIONS(5621),
    [anon_sym__Nonnull] = ACTIONS(5621),
    [anon_sym_mutable] = ACTIONS(5621),
    [anon_sym_constinit] = ACTIONS(5621),
    [anon_sym_consteval] = ACTIONS(5621),
    [anon_sym_alignas] = ACTIONS(5621),
    [anon_sym__Alignas] = ACTIONS(5621),
    [sym_primitive_type] = ACTIONS(5621),
    [anon_sym_enum] = ACTIONS(5621),
    [anon_sym_class] = ACTIONS(5621),
    [anon_sym_struct] = ACTIONS(5621),
    [anon_sym_union] = ACTIONS(5621),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5621),
    [anon_sym_decltype] = ACTIONS(5621),
    [anon_sym_explicit] = ACTIONS(5621),
    [anon_sym_typename] = ACTIONS(5621),
    [anon_sym_private] = ACTIONS(5621),
    [anon_sym_template] = ACTIONS(5621),
    [anon_sym_operator] = ACTIONS(5621),
    [anon_sym_friend] = ACTIONS(5621),
    [anon_sym_public] = ACTIONS(5621),
    [anon_sym_protected] = ACTIONS(5621),
    [anon_sym_static_assert] = ACTIONS(5621),
  },
  [2064] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(5997),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5997),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_LBRACK] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4182),
    [anon_sym_or_eq] = ACTIONS(4182),
    [anon_sym_xor_eq] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2065] = {
    [sym_string_literal] = STATE(1684),
    [sym_template_argument_list] = STATE(2864),
    [sym_raw_string_literal] = STATE(1684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(5946),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(6001),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5036),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_LBRACK] = ACTIONS(5949),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4146),
    [anon_sym_or_eq] = ACTIONS(4146),
    [anon_sym_xor_eq] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
  },
  [2066] = {
    [sym_identifier] = ACTIONS(2827),
    [aux_sym_preproc_def_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2827),
    [sym_preproc_directive] = ACTIONS(2827),
    [anon_sym_LPAREN2] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym___extension__] = ACTIONS(2827),
    [anon_sym_typedef] = ACTIONS(2827),
    [anon_sym_virtual] = ACTIONS(2827),
    [anon_sym_extern] = ACTIONS(2827),
    [anon_sym___attribute__] = ACTIONS(2827),
    [anon_sym___attribute] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2829),
    [anon_sym___declspec] = ACTIONS(2827),
    [anon_sym___based] = ACTIONS(2827),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_signed] = ACTIONS(2827),
    [anon_sym_unsigned] = ACTIONS(2827),
    [anon_sym_long] = ACTIONS(2827),
    [anon_sym_short] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_static] = ACTIONS(2827),
    [anon_sym_register] = ACTIONS(2827),
    [anon_sym_inline] = ACTIONS(2827),
    [anon_sym___inline] = ACTIONS(2827),
    [anon_sym___inline__] = ACTIONS(2827),
    [anon_sym___forceinline] = ACTIONS(2827),
    [anon_sym_thread_local] = ACTIONS(2827),
    [anon_sym___thread] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_constexpr] = ACTIONS(2827),
    [anon_sym_volatile] = ACTIONS(2827),
    [anon_sym_restrict] = ACTIONS(2827),
    [anon_sym___restrict__] = ACTIONS(2827),
    [anon_sym__Atomic] = ACTIONS(2827),
    [anon_sym__Noreturn] = ACTIONS(2827),
    [anon_sym_noreturn] = ACTIONS(2827),
    [anon_sym__Nonnull] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_constinit] = ACTIONS(2827),
    [anon_sym_consteval] = ACTIONS(2827),
    [anon_sym_alignas] = ACTIONS(2827),
    [anon_sym__Alignas] = ACTIONS(2827),
    [sym_primitive_type] = ACTIONS(2827),
    [anon_sym_enum] = ACTIONS(2827),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_union] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2827),
    [anon_sym_decltype] = ACTIONS(2827),
    [anon_sym_explicit] = ACTIONS(2827),
    [anon_sym_typename] = ACTIONS(2827),
    [anon_sym_private] = ACTIONS(2827),
    [anon_sym_template] = ACTIONS(2827),
    [anon_sym_operator] = ACTIONS(2827),
    [anon_sym_friend] = ACTIONS(2827),
    [anon_sym_public] = ACTIONS(2827),
    [anon_sym_protected] = ACTIONS(2827),
    [anon_sym_static_assert] = ACTIONS(2827),
  },
  [2067] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token2] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_private] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_friend] = ACTIONS(3104),
    [anon_sym_public] = ACTIONS(3104),
    [anon_sym_protected] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
  },
  [2068] = {
    [sym_ms_based_modifier] = STATE(8106),
    [sym_ms_unaligned_ptr_modifier] = STATE(4043),
    [sym_ms_pointer_modifier] = STATE(2048),
    [sym__declarator] = STATE(6313),
    [sym__abstract_declarator] = STATE(6712),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_function_declarator] = STATE(5998),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_array_declarator] = STATE(5998),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_type_qualifier] = STATE(2654),
    [sym_alignas_qualifier] = STATE(4289),
    [sym_parameter_list] = STATE(3216),
    [sym_decltype] = STATE(8601),
    [sym_reference_declarator] = STATE(5998),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5860),
    [sym_qualified_identifier] = STATE(5998),
    [sym_operator_name] = STATE(5998),
    [aux_sym__type_definition_type_repeat1] = STATE(2654),
    [aux_sym_pointer_declarator_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(5849),
    [anon_sym_COMMA] = ACTIONS(5851),
    [anon_sym_LPAREN2] = ACTIONS(4298),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(5971),
    [anon_sym_AMP_AMP] = ACTIONS(5973),
    [anon_sym_AMP] = ACTIONS(5975),
    [anon_sym___extension__] = ACTIONS(3331),
    [anon_sym___attribute__] = ACTIONS(5859),
    [anon_sym___attribute] = ACTIONS(5859),
    [anon_sym_COLON_COLON] = ACTIONS(5861),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(3327),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3327),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3327),
    [anon_sym__unaligned] = ACTIONS(3329),
    [anon_sym___unaligned] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(5863),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_constexpr] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_restrict] = ACTIONS(3331),
    [anon_sym___restrict__] = ACTIONS(3331),
    [anon_sym__Atomic] = ACTIONS(3331),
    [anon_sym__Noreturn] = ACTIONS(3331),
    [anon_sym_noreturn] = ACTIONS(3331),
    [anon_sym__Nonnull] = ACTIONS(3331),
    [anon_sym_mutable] = ACTIONS(3331),
    [anon_sym_constinit] = ACTIONS(3331),
    [anon_sym_consteval] = ACTIONS(3331),
    [anon_sym_alignas] = ACTIONS(3333),
    [anon_sym__Alignas] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_GT2] = ACTIONS(5851),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [2069] = {
    [sym_template_argument_list] = STATE(1603),
    [sym_identifier] = ACTIONS(4963),
    [anon_sym_LPAREN2] = ACTIONS(4970),
    [anon_sym_TILDE] = ACTIONS(4970),
    [anon_sym_STAR] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4970),
    [anon_sym_AMP_AMP] = ACTIONS(4970),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_LT] = ACTIONS(6004),
    [anon_sym___extension__] = ACTIONS(4963),
    [anon_sym_virtual] = ACTIONS(4963),
    [anon_sym_extern] = ACTIONS(4963),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_using] = ACTIONS(4963),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4970),
    [anon_sym___declspec] = ACTIONS(4963),
    [anon_sym___based] = ACTIONS(4963),
    [anon_sym___cdecl] = ACTIONS(4963),
    [anon_sym___clrcall] = ACTIONS(4963),
    [anon_sym___stdcall] = ACTIONS(4963),
    [anon_sym___fastcall] = ACTIONS(4963),
    [anon_sym___thiscall] = ACTIONS(4963),
    [anon_sym___vectorcall] = ACTIONS(4963),
    [anon_sym_signed] = ACTIONS(4963),
    [anon_sym_unsigned] = ACTIONS(4963),
    [anon_sym_long] = ACTIONS(4963),
    [anon_sym_short] = ACTIONS(4963),
    [anon_sym_LBRACK] = ACTIONS(4963),
    [anon_sym_static] = ACTIONS(4963),
    [anon_sym_register] = ACTIONS(4963),
    [anon_sym_inline] = ACTIONS(4963),
    [anon_sym___inline] = ACTIONS(4963),
    [anon_sym___inline__] = ACTIONS(4963),
    [anon_sym___forceinline] = ACTIONS(4963),
    [anon_sym_thread_local] = ACTIONS(4963),
    [anon_sym___thread] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_constexpr] = ACTIONS(4963),
    [anon_sym_volatile] = ACTIONS(4963),
    [anon_sym_restrict] = ACTIONS(4963),
    [anon_sym___restrict__] = ACTIONS(4963),
    [anon_sym__Atomic] = ACTIONS(4963),
    [anon_sym__Noreturn] = ACTIONS(4963),
    [anon_sym_noreturn] = ACTIONS(4963),
    [anon_sym__Nonnull] = ACTIONS(4963),
    [anon_sym_mutable] = ACTIONS(4963),
    [anon_sym_constinit] = ACTIONS(4963),
    [anon_sym_consteval] = ACTIONS(4963),
    [anon_sym_alignas] = ACTIONS(4963),
    [anon_sym__Alignas] = ACTIONS(4963),
    [sym_primitive_type] = ACTIONS(4963),
    [anon_sym_enum] = ACTIONS(4963),
    [anon_sym_class] = ACTIONS(4963),
    [anon_sym_struct] = ACTIONS(4963),
    [anon_sym_union] = ACTIONS(4963),
    [anon_sym_or] = ACTIONS(4963),
    [anon_sym_and] = ACTIONS(4963),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_explicit] = ACTIONS(4963),
    [anon_sym_typename] = ACTIONS(4963),
    [anon_sym_template] = ACTIONS(4963),
    [anon_sym_operator] = ACTIONS(4963),
    [anon_sym_friend] = ACTIONS(4963),
    [anon_sym_concept] = ACTIONS(4963),
  },
  [2070] = {
    [sym_identifier] = ACTIONS(5517),
    [aux_sym_preproc_def_token1] = ACTIONS(5517),
    [aux_sym_preproc_if_token1] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5517),
    [sym_preproc_directive] = ACTIONS(5517),
    [anon_sym_LPAREN2] = ACTIONS(5519),
    [anon_sym_TILDE] = ACTIONS(5519),
    [anon_sym_STAR] = ACTIONS(5519),
    [anon_sym_AMP_AMP] = ACTIONS(5519),
    [anon_sym_AMP] = ACTIONS(5517),
    [anon_sym_SEMI] = ACTIONS(5519),
    [anon_sym___extension__] = ACTIONS(5517),
    [anon_sym_typedef] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5517),
    [anon_sym___attribute__] = ACTIONS(5517),
    [anon_sym___attribute] = ACTIONS(5517),
    [anon_sym_using] = ACTIONS(5517),
    [anon_sym_COLON_COLON] = ACTIONS(5519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5519),
    [anon_sym___declspec] = ACTIONS(5517),
    [anon_sym___based] = ACTIONS(5517),
    [anon_sym_RBRACE] = ACTIONS(5519),
    [anon_sym_signed] = ACTIONS(5517),
    [anon_sym_unsigned] = ACTIONS(5517),
    [anon_sym_long] = ACTIONS(5517),
    [anon_sym_short] = ACTIONS(5517),
    [anon_sym_LBRACK] = ACTIONS(5517),
    [anon_sym_static] = ACTIONS(5517),
    [anon_sym_register] = ACTIONS(5517),
    [anon_sym_inline] = ACTIONS(5517),
    [anon_sym___inline] = ACTIONS(5517),
    [anon_sym___inline__] = ACTIONS(5517),
    [anon_sym___forceinline] = ACTIONS(5517),
    [anon_sym_thread_local] = ACTIONS(5517),
    [anon_sym___thread] = ACTIONS(5517),
    [anon_sym_const] = ACTIONS(5517),
    [anon_sym_constexpr] = ACTIONS(5517),
    [anon_sym_volatile] = ACTIONS(5517),
    [anon_sym_restrict] = ACTIONS(5517),
    [anon_sym___restrict__] = ACTIONS(5517),
    [anon_sym__Atomic] = ACTIONS(5517),
    [anon_sym__Noreturn] = ACTIONS(5517),
    [anon_sym_noreturn] = ACTIONS(5517),
    [anon_sym__Nonnull] = ACTIONS(5517),
    [anon_sym_mutable] = ACTIONS(5517),
    [anon_sym_constinit] = ACTIONS(5517),
    [anon_sym_consteval] = ACTIONS(5517),
    [anon_sym_alignas] = ACTIONS(5517),
    [anon_sym__Alignas] = ACTIONS(5517),
    [sym_primitive_type] = ACTIONS(5517),
    [anon_sym_enum] = ACTIONS(5517),
    [anon_sym_class] = ACTIONS(5517),
    [anon_sym_struct] = ACTIONS(5517),
    [anon_sym_union] = ACTIONS(5517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5517),
    [anon_sym_decltype] = ACTIONS(5517),
    [anon_sym_explicit] = ACTIONS(5517),
    [anon_sym_typename] = ACTIONS(5517),
    [anon_sym_private] = ACTIONS(5517),
    [anon_sym_template] = ACTIONS(5517),
    [anon_sym_operator] = ACTIONS(5517),
    [anon_sym_friend] = ACTIONS(5517),
    [anon_sym_public] = ACTIONS(5517),
    [anon_sym_protected] = ACTIONS(5517),
    [anon_sym_static_assert] = ACTIONS(5517),
  },
  [2071] = {
    [sym_identifier] = ACTIONS(3083),
    [aux_sym_preproc_def_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3083),
    [sym_preproc_directive] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym___extension__] = ACTIONS(3083),
    [anon_sym_typedef] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym___attribute__] = ACTIONS(3083),
    [anon_sym___attribute] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3085),
    [anon_sym___declspec] = ACTIONS(3083),
    [anon_sym___based] = ACTIONS(3083),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_signed] = ACTIONS(3083),
    [anon_sym_unsigned] = ACTIONS(3083),
    [anon_sym_long] = ACTIONS(3083),
    [anon_sym_short] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_register] = ACTIONS(3083),
    [anon_sym_inline] = ACTIONS(3083),
    [anon_sym___inline] = ACTIONS(3083),
    [anon_sym___inline__] = ACTIONS(3083),
    [anon_sym___forceinline] = ACTIONS(3083),
    [anon_sym_thread_local] = ACTIONS(3083),
    [anon_sym___thread] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_constexpr] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_restrict] = ACTIONS(3083),
    [anon_sym___restrict__] = ACTIONS(3083),
    [anon_sym__Atomic] = ACTIONS(3083),
    [anon_sym__Noreturn] = ACTIONS(3083),
    [anon_sym_noreturn] = ACTIONS(3083),
    [anon_sym__Nonnull] = ACTIONS(3083),
    [anon_sym_mutable] = ACTIONS(3083),
    [anon_sym_constinit] = ACTIONS(3083),
    [anon_sym_consteval] = ACTIONS(3083),
    [anon_sym_alignas] = ACTIONS(3083),
    [anon_sym__Alignas] = ACTIONS(3083),
    [sym_primitive_type] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3083),
    [anon_sym_union] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3083),
    [anon_sym_decltype] = ACTIONS(3083),
    [anon_sym_explicit] = ACTIONS(3083),
    [anon_sym_typename] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_template] = ACTIONS(3083),
    [anon_sym_operator] = ACTIONS(3083),
    [anon_sym_friend] = ACTIONS(3083),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_static_assert] = ACTIONS(3083),
  },
  [2072] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_friend] = ACTIONS(2911),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
  },
  [2073] = {
    [sym_identifier] = ACTIONS(2911),
    [aux_sym_preproc_def_token1] = ACTIONS(2911),
    [aux_sym_preproc_if_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2911),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2911),
    [sym_preproc_directive] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2911),
    [anon_sym_typedef] = ACTIONS(2911),
    [anon_sym_virtual] = ACTIONS(2911),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2911),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2911),
    [anon_sym___based] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym___inline] = ACTIONS(2911),
    [anon_sym___inline__] = ACTIONS(2911),
    [anon_sym___forceinline] = ACTIONS(2911),
    [anon_sym_thread_local] = ACTIONS(2911),
    [anon_sym___thread] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_constexpr] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym___restrict__] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym__Noreturn] = ACTIONS(2911),
    [anon_sym_noreturn] = ACTIONS(2911),
    [anon_sym__Nonnull] = ACTIONS(2911),
    [anon_sym_mutable] = ACTIONS(2911),
    [anon_sym_constinit] = ACTIONS(2911),
    [anon_sym_consteval] = ACTIONS(2911),
    [anon_sym_alignas] = ACTIONS(2911),
    [anon_sym__Alignas] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2911),
    [anon_sym_decltype] = ACTIONS(2911),
    [anon_sym_explicit] = ACTIONS(2911),
    [anon_sym_typename] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_template] = ACTIONS(2911),
    [anon_sym_operator] = ACTIONS(2911),
    [anon_sym_friend] = ACTIONS(2911),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_static_assert] = ACTIONS(2911),
  },
  [2074] = {
    [sym_identifier] = ACTIONS(5633),
    [aux_sym_preproc_def_token1] = ACTIONS(5633),
    [aux_sym_preproc_if_token1] = ACTIONS(5633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5633),
    [sym_preproc_directive] = ACTIONS(5633),
    [anon_sym_LPAREN2] = ACTIONS(5635),
    [anon_sym_TILDE] = ACTIONS(5635),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_AMP_AMP] = ACTIONS(5635),
    [anon_sym_AMP] = ACTIONS(5633),
    [anon_sym_SEMI] = ACTIONS(5635),
    [anon_sym___extension__] = ACTIONS(5633),
    [anon_sym_typedef] = ACTIONS(5633),
    [anon_sym_virtual] = ACTIONS(5633),
    [anon_sym_extern] = ACTIONS(5633),
    [anon_sym___attribute__] = ACTIONS(5633),
    [anon_sym___attribute] = ACTIONS(5633),
    [anon_sym_using] = ACTIONS(5633),
    [anon_sym_COLON_COLON] = ACTIONS(5635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5635),
    [anon_sym___declspec] = ACTIONS(5633),
    [anon_sym___based] = ACTIONS(5633),
    [anon_sym_RBRACE] = ACTIONS(5635),
    [anon_sym_signed] = ACTIONS(5633),
    [anon_sym_unsigned] = ACTIONS(5633),
    [anon_sym_long] = ACTIONS(5633),
    [anon_sym_short] = ACTIONS(5633),
    [anon_sym_LBRACK] = ACTIONS(5633),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_register] = ACTIONS(5633),
    [anon_sym_inline] = ACTIONS(5633),
    [anon_sym___inline] = ACTIONS(5633),
    [anon_sym___inline__] = ACTIONS(5633),
    [anon_sym___forceinline] = ACTIONS(5633),
    [anon_sym_thread_local] = ACTIONS(5633),
    [anon_sym___thread] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5633),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym___restrict__] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym__Noreturn] = ACTIONS(5633),
    [anon_sym_noreturn] = ACTIONS(5633),
    [anon_sym__Nonnull] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_constinit] = ACTIONS(5633),
    [anon_sym_consteval] = ACTIONS(5633),
    [anon_sym_alignas] = ACTIONS(5633),
    [anon_sym__Alignas] = ACTIONS(5633),
    [sym_primitive_type] = ACTIONS(5633),
    [anon_sym_enum] = ACTIONS(5633),
    [anon_sym_class] = ACTIONS(5633),
    [anon_sym_struct] = ACTIONS(5633),
    [anon_sym_union] = ACTIONS(5633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_decltype] = ACTIONS(5633),
    [anon_sym_explicit] = ACTIONS(5633),
    [anon_sym_typename] = ACTIONS(5633),
    [anon_sym_private] = ACTIONS(5633),
    [anon_sym_template] = ACTIONS(5633),
    [anon_sym_operator] = ACTIONS(5633),
    [anon_sym_friend] = ACTIONS(5633),
    [anon_sym_public] = ACTIONS(5633),
    [anon_sym_protected] = ACTIONS(5633),
    [anon_sym_static_assert] = ACTIONS(5633),
  },
  [2075] = {
    [sym_identifier] = ACTIONS(3035),
    [aux_sym_preproc_def_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token2] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3035),
    [sym_preproc_directive] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3037),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_AMP_AMP] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_SEMI] = ACTIONS(3037),
    [anon_sym___extension__] = ACTIONS(3035),
    [anon_sym_typedef] = ACTIONS(3035),
    [anon_sym_virtual] = ACTIONS(3035),
    [anon_sym_extern] = ACTIONS(3035),
    [anon_sym___attribute__] = ACTIONS(3035),
    [anon_sym___attribute] = ACTIONS(3035),
    [anon_sym_using] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3037),
    [anon_sym___declspec] = ACTIONS(3035),
    [anon_sym___based] = ACTIONS(3035),
    [anon_sym_signed] = ACTIONS(3035),
    [anon_sym_unsigned] = ACTIONS(3035),
    [anon_sym_long] = ACTIONS(3035),
    [anon_sym_short] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3035),
    [anon_sym_register] = ACTIONS(3035),
    [anon_sym_inline] = ACTIONS(3035),
    [anon_sym___inline] = ACTIONS(3035),
    [anon_sym___inline__] = ACTIONS(3035),
    [anon_sym___forceinline] = ACTIONS(3035),
    [anon_sym_thread_local] = ACTIONS(3035),
    [anon_sym___thread] = ACTIONS(3035),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_constexpr] = ACTIONS(3035),
    [anon_sym_volatile] = ACTIONS(3035),
    [anon_sym_restrict] = ACTIONS(3035),
    [anon_sym___restrict__] = ACTIONS(3035),
    [anon_sym__Atomic] = ACTIONS(3035),
    [anon_sym__Noreturn] = ACTIONS(3035),
    [anon_sym_noreturn] = ACTIONS(3035),
    [anon_sym__Nonnull] = ACTIONS(3035),
    [anon_sym_mutable] = ACTIONS(3035),
    [anon_sym_constinit] = ACTIONS(3035),
    [anon_sym_consteval] = ACTIONS(3035),
    [anon_sym_alignas] = ACTIONS(3035),
    [anon_sym__Alignas] = ACTIONS(3035),
    [sym_primitive_type] = ACTIONS(3035),
    [anon_sym_enum] = ACTIONS(3035),
    [anon_sym_class] = ACTIONS(3035),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_union] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3035),
    [anon_sym_decltype] = ACTIONS(3035),
    [anon_sym_explicit] = ACTIONS(3035),
    [anon_sym_typename] = ACTIONS(3035),
    [anon_sym_private] = ACTIONS(3035),
    [anon_sym_template] = ACTIONS(3035),
    [anon_sym_operator] = ACTIONS(3035),
    [anon_sym_friend] = ACTIONS(3035),
    [anon_sym_public] = ACTIONS(3035),
    [anon_sym_protected] = ACTIONS(3035),
    [anon_sym_static_assert] = ACTIONS(3035),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(3039),
    [aux_sym_preproc_def_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token2] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3039),
    [sym_preproc_directive] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym___extension__] = ACTIONS(3039),
    [anon_sym_typedef] = ACTIONS(3039),
    [anon_sym_virtual] = ACTIONS(3039),
    [anon_sym_extern] = ACTIONS(3039),
    [anon_sym___attribute__] = ACTIONS(3039),
    [anon_sym___attribute] = ACTIONS(3039),
    [anon_sym_using] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3041),
    [anon_sym___declspec] = ACTIONS(3039),
    [anon_sym___based] = ACTIONS(3039),
    [anon_sym_signed] = ACTIONS(3039),
    [anon_sym_unsigned] = ACTIONS(3039),
    [anon_sym_long] = ACTIONS(3039),
    [anon_sym_short] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3039),
    [anon_sym_register] = ACTIONS(3039),
    [anon_sym_inline] = ACTIONS(3039),
    [anon_sym___inline] = ACTIONS(3039),
    [anon_sym___inline__] = ACTIONS(3039),
    [anon_sym___forceinline] = ACTIONS(3039),
    [anon_sym_thread_local] = ACTIONS(3039),
    [anon_sym___thread] = ACTIONS(3039),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_constexpr] = ACTIONS(3039),
    [anon_sym_volatile] = ACTIONS(3039),
    [anon_sym_restrict] = ACTIONS(3039),
    [anon_sym___restrict__] = ACTIONS(3039),
    [anon_sym__Atomic] = ACTIONS(3039),
    [anon_sym__Noreturn] = ACTIONS(3039),
    [anon_sym_noreturn] = ACTIONS(3039),
    [anon_sym__Nonnull] = ACTIONS(3039),
    [anon_sym_mutable] = ACTIONS(3039),
    [anon_sym_constinit] = ACTIONS(3039),
    [anon_sym_consteval] = ACTIONS(3039),
    [anon_sym_alignas] = ACTIONS(3039),
    [anon_sym__Alignas] = ACTIONS(3039),
    [sym_primitive_type] = ACTIONS(3039),
    [anon_sym_enum] = ACTIONS(3039),
    [anon_sym_class] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3039),
    [anon_sym_union] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3039),
    [anon_sym_decltype] = ACTIONS(3039),
    [anon_sym_explicit] = ACTIONS(3039),
    [anon_sym_typename] = ACTIONS(3039),
    [anon_sym_private] = ACTIONS(3039),
    [anon_sym_template] = ACTIONS(3039),
    [anon_sym_operator] = ACTIONS(3039),
    [anon_sym_friend] = ACTIONS(3039),
    [anon_sym_public] = ACTIONS(3039),
    [anon_sym_protected] = ACTIONS(3039),
    [anon_sym_static_assert] = ACTIONS(3039),
  },
  [2077] = {
    [sym_identifier] = ACTIONS(5446),
    [aux_sym_preproc_def_token1] = ACTIONS(5446),
    [aux_sym_preproc_if_token1] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5446),
    [sym_preproc_directive] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5448),
    [anon_sym_TILDE] = ACTIONS(5448),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym___extension__] = ACTIONS(5446),
    [anon_sym_typedef] = ACTIONS(5446),
    [anon_sym_virtual] = ACTIONS(5446),
    [anon_sym_extern] = ACTIONS(5446),
    [anon_sym___attribute__] = ACTIONS(5446),
    [anon_sym___attribute] = ACTIONS(5446),
    [anon_sym_using] = ACTIONS(5446),
    [anon_sym_COLON_COLON] = ACTIONS(5448),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5448),
    [anon_sym___declspec] = ACTIONS(5446),
    [anon_sym___based] = ACTIONS(5446),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_signed] = ACTIONS(5446),
    [anon_sym_unsigned] = ACTIONS(5446),
    [anon_sym_long] = ACTIONS(5446),
    [anon_sym_short] = ACTIONS(5446),
    [anon_sym_LBRACK] = ACTIONS(5446),
    [anon_sym_static] = ACTIONS(5446),
    [anon_sym_register] = ACTIONS(5446),
    [anon_sym_inline] = ACTIONS(5446),
    [anon_sym___inline] = ACTIONS(5446),
    [anon_sym___inline__] = ACTIONS(5446),
    [anon_sym___forceinline] = ACTIONS(5446),
    [anon_sym_thread_local] = ACTIONS(5446),
    [anon_sym___thread] = ACTIONS(5446),
    [anon_sym_const] = ACTIONS(5446),
    [anon_sym_constexpr] = ACTIONS(5446),
    [anon_sym_volatile] = ACTIONS(5446),
    [anon_sym_restrict] = ACTIONS(5446),
    [anon_sym___restrict__] = ACTIONS(5446),
    [anon_sym__Atomic] = ACTIONS(5446),
    [anon_sym__Noreturn] = ACTIONS(5446),
    [anon_sym_noreturn] = ACTIONS(5446),
    [anon_sym__Nonnull] = ACTIONS(5446),
    [anon_sym_mutable] = ACTIONS(5446),
    [anon_sym_constinit] = ACTIONS(5446),
    [anon_sym_consteval] = ACTIONS(5446),
    [anon_sym_alignas] = ACTIONS(5446),
    [anon_sym__Alignas] = ACTIONS(5446),
    [sym_primitive_type] = ACTIONS(5446),
    [anon_sym_enum] = ACTIONS(5446),
    [anon_sym_class] = ACTIONS(5446),
    [anon_sym_struct] = ACTIONS(5446),
    [anon_sym_union] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5446),
    [anon_sym_decltype] = ACTIONS(5446),
    [anon_sym_explicit] = ACTIONS(5446),
    [anon_sym_typename] = ACTIONS(5446),
    [anon_sym_private] = ACTIONS(5446),
    [anon_sym_template] = ACTIONS(5446),
    [anon_sym_operator] = ACTIONS(5446),
    [anon_sym_friend] = ACTIONS(5446),
    [anon_sym_public] = ACTIONS(5446),
    [anon_sym_protected] = ACTIONS(5446),
    [anon_sym_static_assert] = ACTIONS(5446),
  },
  [2078] = {
    [sym_identifier] = ACTIONS(5446),
    [aux_sym_preproc_def_token1] = ACTIONS(5446),
    [aux_sym_preproc_if_token1] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5446),
    [sym_preproc_directive] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5448),
    [anon_sym_TILDE] = ACTIONS(5448),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym___extension__] = ACTIONS(5446),
    [anon_sym_typedef] = ACTIONS(5446),
    [anon_sym_virtual] = ACTIONS(5446),
    [anon_sym_extern] = ACTIONS(5446),
    [anon_sym___attribute__] = ACTIONS(5446),
    [anon_sym___attribute] = ACTIONS(5446),
    [anon_sym_using] = ACTIONS(5446),
    [anon_sym_COLON_COLON] = ACTIONS(5448),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5448),
    [anon_sym___declspec] = ACTIONS(5446),
    [anon_sym___based] = ACTIONS(5446),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_signed] = ACTIONS(5446),
    [anon_sym_unsigned] = ACTIONS(5446),
    [anon_sym_long] = ACTIONS(5446),
    [anon_sym_short] = ACTIONS(5446),
    [anon_sym_LBRACK] = ACTIONS(5446),
    [anon_sym_static] = ACTIONS(5446),
    [anon_sym_register] = ACTIONS(5446),
    [anon_sym_inline] = ACTIONS(5446),
    [anon_sym___inline] = ACTIONS(5446),
    [anon_sym___inline__] = ACTIONS(5446),
    [anon_sym___forceinline] = ACTIONS(5446),
    [anon_sym_thread_local] = ACTIONS(5446),
    [anon_sym___thread] = ACTIONS(5446),
    [anon_sym_const] = ACTIONS(5446),
    [anon_sym_constexpr] = ACTIONS(5446),
    [anon_sym_volatile] = ACTIONS(5446),
    [anon_sym_restrict] = ACTIONS(5446),
    [anon_sym___restrict__] = ACTIONS(5446),
    [anon_sym__Atomic] = ACTIONS(5446),
    [anon_sym__Noreturn] = ACTIONS(5446),
    [anon_sym_noreturn] = ACTIONS(5446),
    [anon_sym__Nonnull] = ACTIONS(5446),
    [anon_sym_mutable] = ACTIONS(5446),
    [anon_sym_constinit] = ACTIONS(5446),
    [anon_sym_consteval] = ACTIONS(5446),
    [anon_sym_alignas] = ACTIONS(5446),
    [anon_sym__Alignas] = ACTIONS(5446),
    [sym_primitive_type] = ACTIONS(5446),
    [anon_sym_enum] = ACTIONS(5446),
    [anon_sym_class] = ACTIONS(5446),
    [anon_sym_struct] = ACTIONS(5446),
    [anon_sym_union] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5446),
    [anon_sym_decltype] = ACTIONS(5446),
    [anon_sym_explicit] = ACTIONS(5446),
    [anon_sym_typename] = ACTIONS(5446),
    [anon_sym_private] = ACTIONS(5446),
    [anon_sym_template] = ACTIONS(5446),
    [anon_sym_operator] = ACTIONS(5446),
    [anon_sym_friend] = ACTIONS(5446),
    [anon_sym_public] = ACTIONS(5446),
    [anon_sym_protected] = ACTIONS(5446),
    [anon_sym_static_assert] = ACTIONS(5446),
  },
  [2079] = {
    [sym_identifier] = ACTIONS(3035),
    [aux_sym_preproc_def_token1] = ACTIONS(3035),
    [aux_sym_preproc_if_token1] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3035),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3035),
    [sym_preproc_directive] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3037),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_AMP_AMP] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_SEMI] = ACTIONS(3037),
    [anon_sym___extension__] = ACTIONS(3035),
    [anon_sym_typedef] = ACTIONS(3035),
    [anon_sym_virtual] = ACTIONS(3035),
    [anon_sym_extern] = ACTIONS(3035),
    [anon_sym___attribute__] = ACTIONS(3035),
    [anon_sym___attribute] = ACTIONS(3035),
    [anon_sym_using] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3037),
    [anon_sym___declspec] = ACTIONS(3035),
    [anon_sym___based] = ACTIONS(3035),
    [anon_sym_RBRACE] = ACTIONS(3037),
    [anon_sym_signed] = ACTIONS(3035),
    [anon_sym_unsigned] = ACTIONS(3035),
    [anon_sym_long] = ACTIONS(3035),
    [anon_sym_short] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3035),
    [anon_sym_register] = ACTIONS(3035),
    [anon_sym_inline] = ACTIONS(3035),
    [anon_sym___inline] = ACTIONS(3035),
    [anon_sym___inline__] = ACTIONS(3035),
    [anon_sym___forceinline] = ACTIONS(3035),
    [anon_sym_thread_local] = ACTIONS(3035),
    [anon_sym___thread] = ACTIONS(3035),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_constexpr] = ACTIONS(3035),
    [anon_sym_volatile] = ACTIONS(3035),
    [anon_sym_restrict] = ACTIONS(3035),
    [anon_sym___restrict__] = ACTIONS(3035),
    [anon_sym__Atomic] = ACTIONS(3035),
    [anon_sym__Noreturn] = ACTIONS(3035),
    [anon_sym_noreturn] = ACTIONS(3035),
    [anon_sym__Nonnull] = ACTIONS(3035),
    [anon_sym_mutable] = ACTIONS(3035),
    [anon_sym_constinit] = ACTIONS(3035),
    [anon_sym_consteval] = ACTIONS(3035),
    [anon_sym_alignas] = ACTIONS(3035),
    [anon_sym__Alignas] = ACTIONS(3035),
    [sym_primitive_type] = ACTIONS(3035),
    [anon_sym_enum] = ACTIONS(3035),
    [anon_sym_class] = ACTIONS(3035),
    [anon_sym_struct] = ACTIONS(3035),
    [anon_sym_union] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3035),
    [anon_sym_decltype] = ACTIONS(3035),
    [anon_sym_explicit] = ACTIONS(3035),
    [anon_sym_typename] = ACTIONS(3035),
    [anon_sym_private] = ACTIONS(3035),
    [anon_sym_template] = ACTIONS(3035),
    [anon_sym_operator] = ACTIONS(3035),
    [anon_sym_friend] = ACTIONS(3035),
    [anon_sym_public] = ACTIONS(3035),
    [anon_sym_protected] = ACTIONS(3035),
    [anon_sym_static_assert] = ACTIONS(3035),
  },
  [2080] = {
    [sym_identifier] = ACTIONS(2847),
    [aux_sym_preproc_def_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token1] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2847),
    [sym_preproc_directive] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym___extension__] = ACTIONS(2847),
    [anon_sym_typedef] = ACTIONS(2847),
    [anon_sym_virtual] = ACTIONS(2847),
    [anon_sym_extern] = ACTIONS(2847),
    [anon_sym___attribute__] = ACTIONS(2847),
    [anon_sym___attribute] = ACTIONS(2847),
    [anon_sym_using] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2849),
    [anon_sym___declspec] = ACTIONS(2847),
    [anon_sym___based] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2849),
    [anon_sym_signed] = ACTIONS(2847),
    [anon_sym_unsigned] = ACTIONS(2847),
    [anon_sym_long] = ACTIONS(2847),
    [anon_sym_short] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2847),
    [anon_sym_register] = ACTIONS(2847),
    [anon_sym_inline] = ACTIONS(2847),
    [anon_sym___inline] = ACTIONS(2847),
    [anon_sym___inline__] = ACTIONS(2847),
    [anon_sym___forceinline] = ACTIONS(2847),
    [anon_sym_thread_local] = ACTIONS(2847),
    [anon_sym___thread] = ACTIONS(2847),
    [anon_sym_const] = ACTIONS(2847),
    [anon_sym_constexpr] = ACTIONS(2847),
    [anon_sym_volatile] = ACTIONS(2847),
    [anon_sym_restrict] = ACTIONS(2847),
    [anon_sym___restrict__] = ACTIONS(2847),
    [anon_sym__Atomic] = ACTIONS(2847),
    [anon_sym__Noreturn] = ACTIONS(2847),
    [anon_sym_noreturn] = ACTIONS(2847),
    [anon_sym__Nonnull] = ACTIONS(2847),
    [anon_sym_mutable] = ACTIONS(2847),
    [anon_sym_constinit] = ACTIONS(2847),
    [anon_sym_consteval] = ACTIONS(2847),
    [anon_sym_alignas] = ACTIONS(2847),
    [anon_sym__Alignas] = ACTIONS(2847),
    [sym_primitive_type] = ACTIONS(2847),
    [anon_sym_enum] = ACTIONS(2847),
    [anon_sym_class] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2847),
    [anon_sym_union] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2847),
    [anon_sym_decltype] = ACTIONS(2847),
    [anon_sym_explicit] = ACTIONS(2847),
    [anon_sym_typename] = ACTIONS(2847),
    [anon_sym_private] = ACTIONS(2847),
    [anon_sym_template] = ACTIONS(2847),
    [anon_sym_operator] = ACTIONS(2847),
    [anon_sym_friend] = ACTIONS(2847),
    [anon_sym_public] = ACTIONS(2847),
    [anon_sym_protected] = ACTIONS(2847),
    [anon_sym_static_assert] = ACTIONS(2847),
  },
  [2081] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_private] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_friend] = ACTIONS(2915),
    [anon_sym_public] = ACTIONS(2915),
    [anon_sym_protected] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_STAR] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2917),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2917),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_signed] = ACTIONS(2915),
    [anon_sym_unsigned] = ACTIONS(2915),
    [anon_sym_long] = ACTIONS(2915),
    [anon_sym_short] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_private] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_friend] = ACTIONS(2915),
    [anon_sym_public] = ACTIONS(2915),
    [anon_sym_protected] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
  },
  [2083] = {
    [sym_identifier] = ACTIONS(5541),
    [aux_sym_preproc_def_token1] = ACTIONS(5541),
    [aux_sym_preproc_if_token1] = ACTIONS(5541),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5541),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5541),
    [sym_preproc_directive] = ACTIONS(5541),
    [anon_sym_LPAREN2] = ACTIONS(5543),
    [anon_sym_TILDE] = ACTIONS(5543),
    [anon_sym_STAR] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5543),
    [anon_sym___extension__] = ACTIONS(5541),
    [anon_sym_typedef] = ACTIONS(5541),
    [anon_sym_virtual] = ACTIONS(5541),
    [anon_sym_extern] = ACTIONS(5541),
    [anon_sym___attribute__] = ACTIONS(5541),
    [anon_sym___attribute] = ACTIONS(5541),
    [anon_sym_using] = ACTIONS(5541),
    [anon_sym_COLON_COLON] = ACTIONS(5543),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5543),
    [anon_sym___declspec] = ACTIONS(5541),
    [anon_sym___based] = ACTIONS(5541),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_signed] = ACTIONS(5541),
    [anon_sym_unsigned] = ACTIONS(5541),
    [anon_sym_long] = ACTIONS(5541),
    [anon_sym_short] = ACTIONS(5541),
    [anon_sym_LBRACK] = ACTIONS(5541),
    [anon_sym_static] = ACTIONS(5541),
    [anon_sym_register] = ACTIONS(5541),
    [anon_sym_inline] = ACTIONS(5541),
    [anon_sym___inline] = ACTIONS(5541),
    [anon_sym___inline__] = ACTIONS(5541),
    [anon_sym___forceinline] = ACTIONS(5541),
    [anon_sym_thread_local] = ACTIONS(5541),
    [anon_sym___thread] = ACTIONS(5541),
    [anon_sym_const] = ACTIONS(5541),
    [anon_sym_constexpr] = ACTIONS(5541),
    [anon_sym_volatile] = ACTIONS(5541),
    [anon_sym_restrict] = ACTIONS(5541),
    [anon_sym___restrict__] = ACTIONS(5541),
    [anon_sym__Atomic] = ACTIONS(5541),
    [anon_sym__Noreturn] = ACTIONS(5541),
    [anon_sym_noreturn] = ACTIONS(5541),
    [anon_sym__Nonnull] = ACTIONS(5541),
    [anon_sym_mutable] = ACTIONS(5541),
    [anon_sym_constinit] = ACTIONS(5541),
    [anon_sym_consteval] = ACTIONS(5541),
    [anon_sym_alignas] = ACTIONS(5541),
    [anon_sym__Alignas] = ACTIONS(5541),
    [sym_primitive_type] = ACTIONS(5541),
    [anon_sym_enum] = ACTIONS(5541),
    [anon_sym_class] = ACTIONS(5541),
    [anon_sym_struct] = ACTIONS(5541),
    [anon_sym_union] = ACTIONS(5541),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5541),
    [anon_sym_decltype] = ACTIONS(5541),
    [anon_sym_explicit] = ACTIONS(5541),
    [anon_sym_typename] = ACTIONS(5541),
    [anon_sym_private] = ACTIONS(5541),
    [anon_sym_template] = ACTIONS(5541),
    [anon_sym_operator] = ACTIONS(5541),
    [anon_sym_friend] = ACTIONS(5541),
    [anon_sym_public] = ACTIONS(5541),
    [anon_sym_protected] = ACTIONS(5541),
    [anon_sym_static_assert] = ACTIONS(5541),
  },
  [2084] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token2] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_friend] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
  },
  [2085] = {
    [sym_identifier] = ACTIONS(2851),
    [aux_sym_preproc_def_token1] = ACTIONS(2851),
    [aux_sym_preproc_if_token1] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2851),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2851),
    [sym_preproc_directive] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2853),
    [anon_sym_TILDE] = ACTIONS(2853),
    [anon_sym_STAR] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym___extension__] = ACTIONS(2851),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_virtual] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(2851),
    [anon_sym___attribute__] = ACTIONS(2851),
    [anon_sym___attribute] = ACTIONS(2851),
    [anon_sym_using] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2853),
    [anon_sym___declspec] = ACTIONS(2851),
    [anon_sym___based] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_signed] = ACTIONS(2851),
    [anon_sym_unsigned] = ACTIONS(2851),
    [anon_sym_long] = ACTIONS(2851),
    [anon_sym_short] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_static] = ACTIONS(2851),
    [anon_sym_register] = ACTIONS(2851),
    [anon_sym_inline] = ACTIONS(2851),
    [anon_sym___inline] = ACTIONS(2851),
    [anon_sym___inline__] = ACTIONS(2851),
    [anon_sym___forceinline] = ACTIONS(2851),
    [anon_sym_thread_local] = ACTIONS(2851),
    [anon_sym___thread] = ACTIONS(2851),
    [anon_sym_const] = ACTIONS(2851),
    [anon_sym_constexpr] = ACTIONS(2851),
    [anon_sym_volatile] = ACTIONS(2851),
    [anon_sym_restrict] = ACTIONS(2851),
    [anon_sym___restrict__] = ACTIONS(2851),
    [anon_sym__Atomic] = ACTIONS(2851),
    [anon_sym__Noreturn] = ACTIONS(2851),
    [anon_sym_noreturn] = ACTIONS(2851),
    [anon_sym__Nonnull] = ACTIONS(2851),
    [anon_sym_mutable] = ACTIONS(2851),
    [anon_sym_constinit] = ACTIONS(2851),
    [anon_sym_consteval] = ACTIONS(2851),
    [anon_sym_alignas] = ACTIONS(2851),
    [anon_sym__Alignas] = ACTIONS(2851),
    [sym_primitive_type] = ACTIONS(2851),
    [anon_sym_enum] = ACTIONS(2851),
    [anon_sym_class] = ACTIONS(2851),
    [anon_sym_struct] = ACTIONS(2851),
    [anon_sym_union] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2851),
    [anon_sym_decltype] = ACTIONS(2851),
    [anon_sym_explicit] = ACTIONS(2851),
    [anon_sym_typename] = ACTIONS(2851),
    [anon_sym_private] = ACTIONS(2851),
    [anon_sym_template] = ACTIONS(2851),
    [anon_sym_operator] = ACTIONS(2851),
    [anon_sym_friend] = ACTIONS(2851),
    [anon_sym_public] = ACTIONS(2851),
    [anon_sym_protected] = ACTIONS(2851),
    [anon_sym_static_assert] = ACTIONS(2851),
  },
  [2086] = {
    [sym_identifier] = ACTIONS(2855),
    [aux_sym_preproc_def_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token1] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2855),
    [sym_preproc_directive] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2857),
    [anon_sym_TILDE] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym___extension__] = ACTIONS(2855),
    [anon_sym_typedef] = ACTIONS(2855),
    [anon_sym_virtual] = ACTIONS(2855),
    [anon_sym_extern] = ACTIONS(2855),
    [anon_sym___attribute__] = ACTIONS(2855),
    [anon_sym___attribute] = ACTIONS(2855),
    [anon_sym_using] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2857),
    [anon_sym___declspec] = ACTIONS(2855),
    [anon_sym___based] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_signed] = ACTIONS(2855),
    [anon_sym_unsigned] = ACTIONS(2855),
    [anon_sym_long] = ACTIONS(2855),
    [anon_sym_short] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(2855),
    [anon_sym_register] = ACTIONS(2855),
    [anon_sym_inline] = ACTIONS(2855),
    [anon_sym___inline] = ACTIONS(2855),
    [anon_sym___inline__] = ACTIONS(2855),
    [anon_sym___forceinline] = ACTIONS(2855),
    [anon_sym_thread_local] = ACTIONS(2855),
    [anon_sym___thread] = ACTIONS(2855),
    [anon_sym_const] = ACTIONS(2855),
    [anon_sym_constexpr] = ACTIONS(2855),
    [anon_sym_volatile] = ACTIONS(2855),
    [anon_sym_restrict] = ACTIONS(2855),
    [anon_sym___restrict__] = ACTIONS(2855),
    [anon_sym__Atomic] = ACTIONS(2855),
    [anon_sym__Noreturn] = ACTIONS(2855),
    [anon_sym_noreturn] = ACTIONS(2855),
    [anon_sym__Nonnull] = ACTIONS(2855),
    [anon_sym_mutable] = ACTIONS(2855),
    [anon_sym_constinit] = ACTIONS(2855),
    [anon_sym_consteval] = ACTIONS(2855),
    [anon_sym_alignas] = ACTIONS(2855),
    [anon_sym__Alignas] = ACTIONS(2855),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_enum] = ACTIONS(2855),
    [anon_sym_class] = ACTIONS(2855),
    [anon_sym_struct] = ACTIONS(2855),
    [anon_sym_union] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2855),
    [anon_sym_explicit] = ACTIONS(2855),
    [anon_sym_typename] = ACTIONS(2855),
    [anon_sym_private] = ACTIONS(2855),
    [anon_sym_template] = ACTIONS(2855),
    [anon_sym_operator] = ACTIONS(2855),
    [anon_sym_friend] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(2855),
    [anon_sym_protected] = ACTIONS(2855),
    [anon_sym_static_assert] = ACTIONS(2855),
  },
  [2087] = {
    [sym_identifier] = ACTIONS(2859),
    [aux_sym_preproc_def_token1] = ACTIONS(2859),
    [aux_sym_preproc_if_token1] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2859),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2859),
    [sym_preproc_directive] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [anon_sym_STAR] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym___extension__] = ACTIONS(2859),
    [anon_sym_typedef] = ACTIONS(2859),
    [anon_sym_virtual] = ACTIONS(2859),
    [anon_sym_extern] = ACTIONS(2859),
    [anon_sym___attribute__] = ACTIONS(2859),
    [anon_sym___attribute] = ACTIONS(2859),
    [anon_sym_using] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2861),
    [anon_sym___declspec] = ACTIONS(2859),
    [anon_sym___based] = ACTIONS(2859),
    [anon_sym_RBRACE] = ACTIONS(2861),
    [anon_sym_signed] = ACTIONS(2859),
    [anon_sym_unsigned] = ACTIONS(2859),
    [anon_sym_long] = ACTIONS(2859),
    [anon_sym_short] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2859),
    [anon_sym_register] = ACTIONS(2859),
    [anon_sym_inline] = ACTIONS(2859),
    [anon_sym___inline] = ACTIONS(2859),
    [anon_sym___inline__] = ACTIONS(2859),
    [anon_sym___forceinline] = ACTIONS(2859),
    [anon_sym_thread_local] = ACTIONS(2859),
    [anon_sym___thread] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2859),
    [anon_sym_constexpr] = ACTIONS(2859),
    [anon_sym_volatile] = ACTIONS(2859),
    [anon_sym_restrict] = ACTIONS(2859),
    [anon_sym___restrict__] = ACTIONS(2859),
    [anon_sym__Atomic] = ACTIONS(2859),
    [anon_sym__Noreturn] = ACTIONS(2859),
    [anon_sym_noreturn] = ACTIONS(2859),
    [anon_sym__Nonnull] = ACTIONS(2859),
    [anon_sym_mutable] = ACTIONS(2859),
    [anon_sym_constinit] = ACTIONS(2859),
    [anon_sym_consteval] = ACTIONS(2859),
    [anon_sym_alignas] = ACTIONS(2859),
    [anon_sym__Alignas] = ACTIONS(2859),
    [sym_primitive_type] = ACTIONS(2859),
    [anon_sym_enum] = ACTIONS(2859),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2859),
    [anon_sym_union] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2859),
    [anon_sym_decltype] = ACTIONS(2859),
    [anon_sym_explicit] = ACTIONS(2859),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_private] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(2859),
    [anon_sym_operator] = ACTIONS(2859),
    [anon_sym_friend] = ACTIONS(2859),
    [anon_sym_public] = ACTIONS(2859),
    [anon_sym_protected] = ACTIONS(2859),
    [anon_sym_static_assert] = ACTIONS(2859),
  },
  [2088] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_private] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_friend] = ACTIONS(2771),
    [anon_sym_public] = ACTIONS(2771),
    [anon_sym_protected] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
  },
  [2089] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym___attribute] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym__Nonnull] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym__Alignas] = ACTIONS(2643),
    [sym_primitive_type] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_private] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_friend] = ACTIONS(2643),
    [anon_sym_public] = ACTIONS(2643),
    [anon_sym_protected] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
  },
  [2090] = {
    [sym_identifier] = ACTIONS(2699),
    [aux_sym_preproc_def_token1] = ACTIONS(2699),
    [aux_sym_preproc_if_token1] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2699),
    [sym_preproc_directive] = ACTIONS(2699),
    [anon_sym_LPAREN2] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_AMP_AMP] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym___extension__] = ACTIONS(2699),
    [anon_sym_typedef] = ACTIONS(2699),
    [anon_sym_virtual] = ACTIONS(2699),
    [anon_sym_extern] = ACTIONS(2699),
    [anon_sym___attribute__] = ACTIONS(2699),
    [anon_sym___attribute] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2701),
    [anon_sym___declspec] = ACTIONS(2699),
    [anon_sym___based] = ACTIONS(2699),
    [anon_sym_RBRACE] = ACTIONS(2701),
    [anon_sym_signed] = ACTIONS(2699),
    [anon_sym_unsigned] = ACTIONS(2699),
    [anon_sym_long] = ACTIONS(2699),
    [anon_sym_short] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_static] = ACTIONS(2699),
    [anon_sym_register] = ACTIONS(2699),
    [anon_sym_inline] = ACTIONS(2699),
    [anon_sym___inline] = ACTIONS(2699),
    [anon_sym___inline__] = ACTIONS(2699),
    [anon_sym___forceinline] = ACTIONS(2699),
    [anon_sym_thread_local] = ACTIONS(2699),
    [anon_sym___thread] = ACTIONS(2699),
    [anon_sym_const] = ACTIONS(2699),
    [anon_sym_constexpr] = ACTIONS(2699),
    [anon_sym_volatile] = ACTIONS(2699),
    [anon_sym_restrict] = ACTIONS(2699),
    [anon_sym___restrict__] = ACTIONS(2699),
    [anon_sym__Atomic] = ACTIONS(2699),
    [anon_sym__Noreturn] = ACTIONS(2699),
    [anon_sym_noreturn] = ACTIONS(2699),
    [anon_sym__Nonnull] = ACTIONS(2699),
    [anon_sym_mutable] = ACTIONS(2699),
    [anon_sym_constinit] = ACTIONS(2699),
    [anon_sym_consteval] = ACTIONS(2699),
    [anon_sym_alignas] = ACTIONS(2699),
    [anon_sym__Alignas] = ACTIONS(2699),
    [sym_primitive_type] = ACTIONS(2699),
    [anon_sym_enum] = ACTIONS(2699),
    [anon_sym_class] = ACTIONS(2699),
    [anon_sym_struct] = ACTIONS(2699),
    [anon_sym_union] = ACTIONS(2699),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2699),
    [anon_sym_decltype] = ACTIONS(2699),
    [anon_sym_explicit] = ACTIONS(2699),
    [anon_sym_typename] = ACTIONS(2699),
    [anon_sym_private] = ACTIONS(2699),
    [anon_sym_template] = ACTIONS(2699),
    [anon_sym_operator] = ACTIONS(2699),
    [anon_sym_friend] = ACTIONS(2699),
    [anon_sym_public] = ACTIONS(2699),
    [anon_sym_protected] = ACTIONS(2699),
    [anon_sym_static_assert] = ACTIONS(2699),
  },
  [2091] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token2] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_friend] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
  },
  [2092] = {
    [sym__declaration_modifiers] = STATE(3269),
    [sym_attribute_specifier] = STATE(3269),
    [sym_attribute_declaration] = STATE(3269),
    [sym_ms_declspec_modifier] = STATE(3269),
    [sym_storage_class_specifier] = STATE(3269),
    [sym_type_qualifier] = STATE(3269),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(4048),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6599),
    [sym_qualified_type_identifier] = STATE(2809),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3269),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2674),
    [sym_identifier] = ACTIONS(3899),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(5958),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(3909),
    [anon_sym_unsigned] = ACTIONS(3909),
    [anon_sym_long] = ACTIONS(3909),
    [anon_sym_short] = ACTIONS(3909),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(3911),
    [anon_sym_enum] = ACTIONS(3913),
    [anon_sym_class] = ACTIONS(3915),
    [anon_sym_struct] = ACTIONS(3917),
    [anon_sym_union] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3921),
    [anon_sym_template] = ACTIONS(1452),
  },
  [2093] = {
    [sym_identifier] = ACTIONS(2863),
    [aux_sym_preproc_def_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token1] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2863),
    [sym_preproc_directive] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym___extension__] = ACTIONS(2863),
    [anon_sym_typedef] = ACTIONS(2863),
    [anon_sym_virtual] = ACTIONS(2863),
    [anon_sym_extern] = ACTIONS(2863),
    [anon_sym___attribute__] = ACTIONS(2863),
    [anon_sym___attribute] = ACTIONS(2863),
    [anon_sym_using] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2865),
    [anon_sym___declspec] = ACTIONS(2863),
    [anon_sym___based] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_signed] = ACTIONS(2863),
    [anon_sym_unsigned] = ACTIONS(2863),
    [anon_sym_long] = ACTIONS(2863),
    [anon_sym_short] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_static] = ACTIONS(2863),
    [anon_sym_register] = ACTIONS(2863),
    [anon_sym_inline] = ACTIONS(2863),
    [anon_sym___inline] = ACTIONS(2863),
    [anon_sym___inline__] = ACTIONS(2863),
    [anon_sym___forceinline] = ACTIONS(2863),
    [anon_sym_thread_local] = ACTIONS(2863),
    [anon_sym___thread] = ACTIONS(2863),
    [anon_sym_const] = ACTIONS(2863),
    [anon_sym_constexpr] = ACTIONS(2863),
    [anon_sym_volatile] = ACTIONS(2863),
    [anon_sym_restrict] = ACTIONS(2863),
    [anon_sym___restrict__] = ACTIONS(2863),
    [anon_sym__Atomic] = ACTIONS(2863),
    [anon_sym__Noreturn] = ACTIONS(2863),
    [anon_sym_noreturn] = ACTIONS(2863),
    [anon_sym__Nonnull] = ACTIONS(2863),
    [anon_sym_mutable] = ACTIONS(2863),
    [anon_sym_constinit] = ACTIONS(2863),
    [anon_sym_consteval] = ACTIONS(2863),
    [anon_sym_alignas] = ACTIONS(2863),
    [anon_sym__Alignas] = ACTIONS(2863),
    [sym_primitive_type] = ACTIONS(2863),
    [anon_sym_enum] = ACTIONS(2863),
    [anon_sym_class] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2863),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2863),
    [anon_sym_decltype] = ACTIONS(2863),
    [anon_sym_explicit] = ACTIONS(2863),
    [anon_sym_typename] = ACTIONS(2863),
    [anon_sym_private] = ACTIONS(2863),
    [anon_sym_template] = ACTIONS(2863),
    [anon_sym_operator] = ACTIONS(2863),
    [anon_sym_friend] = ACTIONS(2863),
    [anon_sym_public] = ACTIONS(2863),
    [anon_sym_protected] = ACTIONS(2863),
    [anon_sym_static_assert] = ACTIONS(2863),
  },
  [2094] = {
    [sym_identifier] = ACTIONS(2867),
    [aux_sym_preproc_def_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token1] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2867),
    [sym_preproc_directive] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2869),
    [anon_sym_STAR] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2869),
    [anon_sym___extension__] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2867),
    [anon_sym_virtual] = ACTIONS(2867),
    [anon_sym_extern] = ACTIONS(2867),
    [anon_sym___attribute__] = ACTIONS(2867),
    [anon_sym___attribute] = ACTIONS(2867),
    [anon_sym_using] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2869),
    [anon_sym___declspec] = ACTIONS(2867),
    [anon_sym___based] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [anon_sym_signed] = ACTIONS(2867),
    [anon_sym_unsigned] = ACTIONS(2867),
    [anon_sym_long] = ACTIONS(2867),
    [anon_sym_short] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2867),
    [anon_sym_register] = ACTIONS(2867),
    [anon_sym_inline] = ACTIONS(2867),
    [anon_sym___inline] = ACTIONS(2867),
    [anon_sym___inline__] = ACTIONS(2867),
    [anon_sym___forceinline] = ACTIONS(2867),
    [anon_sym_thread_local] = ACTIONS(2867),
    [anon_sym___thread] = ACTIONS(2867),
    [anon_sym_const] = ACTIONS(2867),
    [anon_sym_constexpr] = ACTIONS(2867),
    [anon_sym_volatile] = ACTIONS(2867),
    [anon_sym_restrict] = ACTIONS(2867),
    [anon_sym___restrict__] = ACTIONS(2867),
    [anon_sym__Atomic] = ACTIONS(2867),
    [anon_sym__Noreturn] = ACTIONS(2867),
    [anon_sym_noreturn] = ACTIONS(2867),
    [anon_sym__Nonnull] = ACTIONS(2867),
    [anon_sym_mutable] = ACTIONS(2867),
    [anon_sym_constinit] = ACTIONS(2867),
    [anon_sym_consteval] = ACTIONS(2867),
    [anon_sym_alignas] = ACTIONS(2867),
    [anon_sym__Alignas] = ACTIONS(2867),
    [sym_primitive_type] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2867),
    [anon_sym_class] = ACTIONS(2867),
    [anon_sym_struct] = ACTIONS(2867),
    [anon_sym_union] = ACTIONS(2867),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2867),
    [anon_sym_decltype] = ACTIONS(2867),
    [anon_sym_explicit] = ACTIONS(2867),
    [anon_sym_typename] = ACTIONS(2867),
    [anon_sym_private] = ACTIONS(2867),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(2867),
    [anon_sym_friend] = ACTIONS(2867),
    [anon_sym_public] = ACTIONS(2867),
    [anon_sym_protected] = ACTIONS(2867),
    [anon_sym_static_assert] = ACTIONS(2867),
  },
  [2095] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym___attribute] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym__Nonnull] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym__Alignas] = ACTIONS(2639),
    [sym_primitive_type] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_friend] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
  },
  [2096] = {
    [sym_identifier] = ACTIONS(2863),
    [aux_sym_preproc_def_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token1] = ACTIONS(2863),
    [aux_sym_preproc_if_token2] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2863),
    [sym_preproc_directive] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym___extension__] = ACTIONS(2863),
    [anon_sym_typedef] = ACTIONS(2863),
    [anon_sym_virtual] = ACTIONS(2863),
    [anon_sym_extern] = ACTIONS(2863),
    [anon_sym___attribute__] = ACTIONS(2863),
    [anon_sym___attribute] = ACTIONS(2863),
    [anon_sym_using] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2865),
    [anon_sym___declspec] = ACTIONS(2863),
    [anon_sym___based] = ACTIONS(2863),
    [anon_sym_signed] = ACTIONS(2863),
    [anon_sym_unsigned] = ACTIONS(2863),
    [anon_sym_long] = ACTIONS(2863),
    [anon_sym_short] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_static] = ACTIONS(2863),
    [anon_sym_register] = ACTIONS(2863),
    [anon_sym_inline] = ACTIONS(2863),
    [anon_sym___inline] = ACTIONS(2863),
    [anon_sym___inline__] = ACTIONS(2863),
    [anon_sym___forceinline] = ACTIONS(2863),
    [anon_sym_thread_local] = ACTIONS(2863),
    [anon_sym___thread] = ACTIONS(2863),
    [anon_sym_const] = ACTIONS(2863),
    [anon_sym_constexpr] = ACTIONS(2863),
    [anon_sym_volatile] = ACTIONS(2863),
    [anon_sym_restrict] = ACTIONS(2863),
    [anon_sym___restrict__] = ACTIONS(2863),
    [anon_sym__Atomic] = ACTIONS(2863),
    [anon_sym__Noreturn] = ACTIONS(2863),
    [anon_sym_noreturn] = ACTIONS(2863),
    [anon_sym__Nonnull] = ACTIONS(2863),
    [anon_sym_mutable] = ACTIONS(2863),
    [anon_sym_constinit] = ACTIONS(2863),
    [anon_sym_consteval] = ACTIONS(2863),
    [anon_sym_alignas] = ACTIONS(2863),
    [anon_sym__Alignas] = ACTIONS(2863),
    [sym_primitive_type] = ACTIONS(2863),
    [anon_sym_enum] = ACTIONS(2863),
    [anon_sym_class] = ACTIONS(2863),
    [anon_sym_struct] = ACTIONS(2863),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2863),
    [anon_sym_decltype] = ACTIONS(2863),
    [anon_sym_explicit] = ACTIONS(2863),
    [anon_sym_typename] = ACTIONS(2863),
    [anon_sym_private] = ACTIONS(2863),
    [anon_sym_template] = ACTIONS(2863),
    [anon_sym_operator] = ACTIONS(2863),
    [anon_sym_friend] = ACTIONS(2863),
    [anon_sym_public] = ACTIONS(2863),
    [anon_sym_protected] = ACTIONS(2863),
    [anon_sym_static_assert] = ACTIONS(2863),
  },
  [2097] = {
    [sym_string_literal] = STATE(1684),
    [sym_template_argument_list] = STATE(2338),
    [sym_raw_string_literal] = STATE(1684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(5997),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5373),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5997),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_LBRACK] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4146),
    [anon_sym_or_eq] = ACTIONS(4146),
    [anon_sym_xor_eq] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
  },
  [2098] = {
    [sym_identifier] = ACTIONS(3319),
    [aux_sym_preproc_def_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token1] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3319),
    [sym_preproc_directive] = ACTIONS(3319),
    [anon_sym_LPAREN2] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym___extension__] = ACTIONS(3319),
    [anon_sym_typedef] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym___attribute__] = ACTIONS(3319),
    [anon_sym___attribute] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_COLON_COLON] = ACTIONS(3321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3321),
    [anon_sym___declspec] = ACTIONS(3319),
    [anon_sym___based] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_signed] = ACTIONS(3319),
    [anon_sym_unsigned] = ACTIONS(3319),
    [anon_sym_long] = ACTIONS(3319),
    [anon_sym_short] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_register] = ACTIONS(3319),
    [anon_sym_inline] = ACTIONS(3319),
    [anon_sym___inline] = ACTIONS(3319),
    [anon_sym___inline__] = ACTIONS(3319),
    [anon_sym___forceinline] = ACTIONS(3319),
    [anon_sym_thread_local] = ACTIONS(3319),
    [anon_sym___thread] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_constexpr] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_restrict] = ACTIONS(3319),
    [anon_sym___restrict__] = ACTIONS(3319),
    [anon_sym__Atomic] = ACTIONS(3319),
    [anon_sym__Noreturn] = ACTIONS(3319),
    [anon_sym_noreturn] = ACTIONS(3319),
    [anon_sym__Nonnull] = ACTIONS(3319),
    [anon_sym_mutable] = ACTIONS(3319),
    [anon_sym_constinit] = ACTIONS(3319),
    [anon_sym_consteval] = ACTIONS(3319),
    [anon_sym_alignas] = ACTIONS(3319),
    [anon_sym__Alignas] = ACTIONS(3319),
    [sym_primitive_type] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_union] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3319),
    [anon_sym_decltype] = ACTIONS(3319),
    [anon_sym_explicit] = ACTIONS(3319),
    [anon_sym_typename] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_template] = ACTIONS(3319),
    [anon_sym_operator] = ACTIONS(3319),
    [anon_sym_friend] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_static_assert] = ACTIONS(3319),
  },
  [2099] = {
    [sym_string_literal] = STATE(3128),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(3128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___attribute__] = ACTIONS(4146),
    [anon_sym___attribute] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(6006),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(6008),
    [anon_sym_SLASH_EQ] = ACTIONS(6008),
    [anon_sym_PERCENT_EQ] = ACTIONS(6008),
    [anon_sym_PLUS_EQ] = ACTIONS(6008),
    [anon_sym_DASH_EQ] = ACTIONS(6008),
    [anon_sym_LT_LT_EQ] = ACTIONS(6008),
    [anon_sym_GT_GT_EQ] = ACTIONS(6008),
    [anon_sym_AMP_EQ] = ACTIONS(6008),
    [anon_sym_CARET_EQ] = ACTIONS(6008),
    [anon_sym_PIPE_EQ] = ACTIONS(6008),
    [anon_sym_and_eq] = ACTIONS(6008),
    [anon_sym_or_eq] = ACTIONS(6008),
    [anon_sym_xor_eq] = ACTIONS(6008),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(6010),
    [anon_sym_u_DQUOTE] = ACTIONS(6010),
    [anon_sym_U_DQUOTE] = ACTIONS(6010),
    [anon_sym_u8_DQUOTE] = ACTIONS(6010),
    [anon_sym_DQUOTE] = ACTIONS(6010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6012),
    [anon_sym_LR_DQUOTE] = ACTIONS(6012),
    [anon_sym_uR_DQUOTE] = ACTIONS(6012),
    [anon_sym_UR_DQUOTE] = ACTIONS(6012),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6012),
  },
  [2100] = {
    [sym_identifier] = ACTIONS(2711),
    [aux_sym_preproc_def_token1] = ACTIONS(2711),
    [aux_sym_preproc_if_token1] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2711),
    [sym_preproc_directive] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym___extension__] = ACTIONS(2711),
    [anon_sym_typedef] = ACTIONS(2711),
    [anon_sym_virtual] = ACTIONS(2711),
    [anon_sym_extern] = ACTIONS(2711),
    [anon_sym___attribute__] = ACTIONS(2711),
    [anon_sym___attribute] = ACTIONS(2711),
    [anon_sym_using] = ACTIONS(2711),
    [anon_sym_COLON_COLON] = ACTIONS(2713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2713),
    [anon_sym___declspec] = ACTIONS(2711),
    [anon_sym___based] = ACTIONS(2711),
    [anon_sym_RBRACE] = ACTIONS(2713),
    [anon_sym_signed] = ACTIONS(2711),
    [anon_sym_unsigned] = ACTIONS(2711),
    [anon_sym_long] = ACTIONS(2711),
    [anon_sym_short] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_static] = ACTIONS(2711),
    [anon_sym_register] = ACTIONS(2711),
    [anon_sym_inline] = ACTIONS(2711),
    [anon_sym___inline] = ACTIONS(2711),
    [anon_sym___inline__] = ACTIONS(2711),
    [anon_sym___forceinline] = ACTIONS(2711),
    [anon_sym_thread_local] = ACTIONS(2711),
    [anon_sym___thread] = ACTIONS(2711),
    [anon_sym_const] = ACTIONS(2711),
    [anon_sym_constexpr] = ACTIONS(2711),
    [anon_sym_volatile] = ACTIONS(2711),
    [anon_sym_restrict] = ACTIONS(2711),
    [anon_sym___restrict__] = ACTIONS(2711),
    [anon_sym__Atomic] = ACTIONS(2711),
    [anon_sym__Noreturn] = ACTIONS(2711),
    [anon_sym_noreturn] = ACTIONS(2711),
    [anon_sym__Nonnull] = ACTIONS(2711),
    [anon_sym_mutable] = ACTIONS(2711),
    [anon_sym_constinit] = ACTIONS(2711),
    [anon_sym_consteval] = ACTIONS(2711),
    [anon_sym_alignas] = ACTIONS(2711),
    [anon_sym__Alignas] = ACTIONS(2711),
    [sym_primitive_type] = ACTIONS(2711),
    [anon_sym_enum] = ACTIONS(2711),
    [anon_sym_class] = ACTIONS(2711),
    [anon_sym_struct] = ACTIONS(2711),
    [anon_sym_union] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2711),
    [anon_sym_decltype] = ACTIONS(2711),
    [anon_sym_explicit] = ACTIONS(2711),
    [anon_sym_typename] = ACTIONS(2711),
    [anon_sym_private] = ACTIONS(2711),
    [anon_sym_template] = ACTIONS(2711),
    [anon_sym_operator] = ACTIONS(2711),
    [anon_sym_friend] = ACTIONS(2711),
    [anon_sym_public] = ACTIONS(2711),
    [anon_sym_protected] = ACTIONS(2711),
    [anon_sym_static_assert] = ACTIONS(2711),
  },
  [2101] = {
    [sym_identifier] = ACTIONS(5585),
    [aux_sym_preproc_def_token1] = ACTIONS(5585),
    [aux_sym_preproc_if_token1] = ACTIONS(5585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5585),
    [sym_preproc_directive] = ACTIONS(5585),
    [anon_sym_LPAREN2] = ACTIONS(5587),
    [anon_sym_TILDE] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5587),
    [anon_sym_AMP_AMP] = ACTIONS(5587),
    [anon_sym_AMP] = ACTIONS(5585),
    [anon_sym_SEMI] = ACTIONS(5587),
    [anon_sym___extension__] = ACTIONS(5585),
    [anon_sym_typedef] = ACTIONS(5585),
    [anon_sym_virtual] = ACTIONS(5585),
    [anon_sym_extern] = ACTIONS(5585),
    [anon_sym___attribute__] = ACTIONS(5585),
    [anon_sym___attribute] = ACTIONS(5585),
    [anon_sym_using] = ACTIONS(5585),
    [anon_sym_COLON_COLON] = ACTIONS(5587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5587),
    [anon_sym___declspec] = ACTIONS(5585),
    [anon_sym___based] = ACTIONS(5585),
    [anon_sym_RBRACE] = ACTIONS(5587),
    [anon_sym_signed] = ACTIONS(5585),
    [anon_sym_unsigned] = ACTIONS(5585),
    [anon_sym_long] = ACTIONS(5585),
    [anon_sym_short] = ACTIONS(5585),
    [anon_sym_LBRACK] = ACTIONS(5585),
    [anon_sym_static] = ACTIONS(5585),
    [anon_sym_register] = ACTIONS(5585),
    [anon_sym_inline] = ACTIONS(5585),
    [anon_sym___inline] = ACTIONS(5585),
    [anon_sym___inline__] = ACTIONS(5585),
    [anon_sym___forceinline] = ACTIONS(5585),
    [anon_sym_thread_local] = ACTIONS(5585),
    [anon_sym___thread] = ACTIONS(5585),
    [anon_sym_const] = ACTIONS(5585),
    [anon_sym_constexpr] = ACTIONS(5585),
    [anon_sym_volatile] = ACTIONS(5585),
    [anon_sym_restrict] = ACTIONS(5585),
    [anon_sym___restrict__] = ACTIONS(5585),
    [anon_sym__Atomic] = ACTIONS(5585),
    [anon_sym__Noreturn] = ACTIONS(5585),
    [anon_sym_noreturn] = ACTIONS(5585),
    [anon_sym__Nonnull] = ACTIONS(5585),
    [anon_sym_mutable] = ACTIONS(5585),
    [anon_sym_constinit] = ACTIONS(5585),
    [anon_sym_consteval] = ACTIONS(5585),
    [anon_sym_alignas] = ACTIONS(5585),
    [anon_sym__Alignas] = ACTIONS(5585),
    [sym_primitive_type] = ACTIONS(5585),
    [anon_sym_enum] = ACTIONS(5585),
    [anon_sym_class] = ACTIONS(5585),
    [anon_sym_struct] = ACTIONS(5585),
    [anon_sym_union] = ACTIONS(5585),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5585),
    [anon_sym_decltype] = ACTIONS(5585),
    [anon_sym_explicit] = ACTIONS(5585),
    [anon_sym_typename] = ACTIONS(5585),
    [anon_sym_private] = ACTIONS(5585),
    [anon_sym_template] = ACTIONS(5585),
    [anon_sym_operator] = ACTIONS(5585),
    [anon_sym_friend] = ACTIONS(5585),
    [anon_sym_public] = ACTIONS(5585),
    [anon_sym_protected] = ACTIONS(5585),
    [anon_sym_static_assert] = ACTIONS(5585),
  },
  [2102] = {
    [sym_identifier] = ACTIONS(2867),
    [aux_sym_preproc_def_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token1] = ACTIONS(2867),
    [aux_sym_preproc_if_token2] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2867),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2867),
    [sym_preproc_directive] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2869),
    [anon_sym_STAR] = ACTIONS(2869),
    [anon_sym_AMP_AMP] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2869),
    [anon_sym___extension__] = ACTIONS(2867),
    [anon_sym_typedef] = ACTIONS(2867),
    [anon_sym_virtual] = ACTIONS(2867),
    [anon_sym_extern] = ACTIONS(2867),
    [anon_sym___attribute__] = ACTIONS(2867),
    [anon_sym___attribute] = ACTIONS(2867),
    [anon_sym_using] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2869),
    [anon_sym___declspec] = ACTIONS(2867),
    [anon_sym___based] = ACTIONS(2867),
    [anon_sym_signed] = ACTIONS(2867),
    [anon_sym_unsigned] = ACTIONS(2867),
    [anon_sym_long] = ACTIONS(2867),
    [anon_sym_short] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2867),
    [anon_sym_register] = ACTIONS(2867),
    [anon_sym_inline] = ACTIONS(2867),
    [anon_sym___inline] = ACTIONS(2867),
    [anon_sym___inline__] = ACTIONS(2867),
    [anon_sym___forceinline] = ACTIONS(2867),
    [anon_sym_thread_local] = ACTIONS(2867),
    [anon_sym___thread] = ACTIONS(2867),
    [anon_sym_const] = ACTIONS(2867),
    [anon_sym_constexpr] = ACTIONS(2867),
    [anon_sym_volatile] = ACTIONS(2867),
    [anon_sym_restrict] = ACTIONS(2867),
    [anon_sym___restrict__] = ACTIONS(2867),
    [anon_sym__Atomic] = ACTIONS(2867),
    [anon_sym__Noreturn] = ACTIONS(2867),
    [anon_sym_noreturn] = ACTIONS(2867),
    [anon_sym__Nonnull] = ACTIONS(2867),
    [anon_sym_mutable] = ACTIONS(2867),
    [anon_sym_constinit] = ACTIONS(2867),
    [anon_sym_consteval] = ACTIONS(2867),
    [anon_sym_alignas] = ACTIONS(2867),
    [anon_sym__Alignas] = ACTIONS(2867),
    [sym_primitive_type] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2867),
    [anon_sym_class] = ACTIONS(2867),
    [anon_sym_struct] = ACTIONS(2867),
    [anon_sym_union] = ACTIONS(2867),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2867),
    [anon_sym_decltype] = ACTIONS(2867),
    [anon_sym_explicit] = ACTIONS(2867),
    [anon_sym_typename] = ACTIONS(2867),
    [anon_sym_private] = ACTIONS(2867),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(2867),
    [anon_sym_friend] = ACTIONS(2867),
    [anon_sym_public] = ACTIONS(2867),
    [anon_sym_protected] = ACTIONS(2867),
    [anon_sym_static_assert] = ACTIONS(2867),
  },
  [2103] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2885),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_private] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_friend] = ACTIONS(2883),
    [anon_sym_public] = ACTIONS(2883),
    [anon_sym_protected] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
  },
  [2104] = {
    [sym_identifier] = ACTIONS(5601),
    [aux_sym_preproc_def_token1] = ACTIONS(5601),
    [aux_sym_preproc_if_token1] = ACTIONS(5601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5601),
    [sym_preproc_directive] = ACTIONS(5601),
    [anon_sym_LPAREN2] = ACTIONS(5603),
    [anon_sym_TILDE] = ACTIONS(5603),
    [anon_sym_STAR] = ACTIONS(5603),
    [anon_sym_AMP_AMP] = ACTIONS(5603),
    [anon_sym_AMP] = ACTIONS(5601),
    [anon_sym_SEMI] = ACTIONS(5603),
    [anon_sym___extension__] = ACTIONS(5601),
    [anon_sym_typedef] = ACTIONS(5601),
    [anon_sym_virtual] = ACTIONS(5601),
    [anon_sym_extern] = ACTIONS(5601),
    [anon_sym___attribute__] = ACTIONS(5601),
    [anon_sym___attribute] = ACTIONS(5601),
    [anon_sym_using] = ACTIONS(5601),
    [anon_sym_COLON_COLON] = ACTIONS(5603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5603),
    [anon_sym___declspec] = ACTIONS(5601),
    [anon_sym___based] = ACTIONS(5601),
    [anon_sym_RBRACE] = ACTIONS(5603),
    [anon_sym_signed] = ACTIONS(5601),
    [anon_sym_unsigned] = ACTIONS(5601),
    [anon_sym_long] = ACTIONS(5601),
    [anon_sym_short] = ACTIONS(5601),
    [anon_sym_LBRACK] = ACTIONS(5601),
    [anon_sym_static] = ACTIONS(5601),
    [anon_sym_register] = ACTIONS(5601),
    [anon_sym_inline] = ACTIONS(5601),
    [anon_sym___inline] = ACTIONS(5601),
    [anon_sym___inline__] = ACTIONS(5601),
    [anon_sym___forceinline] = ACTIONS(5601),
    [anon_sym_thread_local] = ACTIONS(5601),
    [anon_sym___thread] = ACTIONS(5601),
    [anon_sym_const] = ACTIONS(5601),
    [anon_sym_constexpr] = ACTIONS(5601),
    [anon_sym_volatile] = ACTIONS(5601),
    [anon_sym_restrict] = ACTIONS(5601),
    [anon_sym___restrict__] = ACTIONS(5601),
    [anon_sym__Atomic] = ACTIONS(5601),
    [anon_sym__Noreturn] = ACTIONS(5601),
    [anon_sym_noreturn] = ACTIONS(5601),
    [anon_sym__Nonnull] = ACTIONS(5601),
    [anon_sym_mutable] = ACTIONS(5601),
    [anon_sym_constinit] = ACTIONS(5601),
    [anon_sym_consteval] = ACTIONS(5601),
    [anon_sym_alignas] = ACTIONS(5601),
    [anon_sym__Alignas] = ACTIONS(5601),
    [sym_primitive_type] = ACTIONS(5601),
    [anon_sym_enum] = ACTIONS(5601),
    [anon_sym_class] = ACTIONS(5601),
    [anon_sym_struct] = ACTIONS(5601),
    [anon_sym_union] = ACTIONS(5601),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5601),
    [anon_sym_decltype] = ACTIONS(5601),
    [anon_sym_explicit] = ACTIONS(5601),
    [anon_sym_typename] = ACTIONS(5601),
    [anon_sym_private] = ACTIONS(5601),
    [anon_sym_template] = ACTIONS(5601),
    [anon_sym_operator] = ACTIONS(5601),
    [anon_sym_friend] = ACTIONS(5601),
    [anon_sym_public] = ACTIONS(5601),
    [anon_sym_protected] = ACTIONS(5601),
    [anon_sym_static_assert] = ACTIONS(5601),
  },
  [2105] = {
    [sym_identifier] = ACTIONS(3067),
    [aux_sym_preproc_def_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token2] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3067),
    [sym_preproc_directive] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym___extension__] = ACTIONS(3067),
    [anon_sym_typedef] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym___attribute__] = ACTIONS(3067),
    [anon_sym___attribute] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3069),
    [anon_sym___declspec] = ACTIONS(3067),
    [anon_sym___based] = ACTIONS(3067),
    [anon_sym_signed] = ACTIONS(3067),
    [anon_sym_unsigned] = ACTIONS(3067),
    [anon_sym_long] = ACTIONS(3067),
    [anon_sym_short] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_register] = ACTIONS(3067),
    [anon_sym_inline] = ACTIONS(3067),
    [anon_sym___inline] = ACTIONS(3067),
    [anon_sym___inline__] = ACTIONS(3067),
    [anon_sym___forceinline] = ACTIONS(3067),
    [anon_sym_thread_local] = ACTIONS(3067),
    [anon_sym___thread] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_constexpr] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_restrict] = ACTIONS(3067),
    [anon_sym___restrict__] = ACTIONS(3067),
    [anon_sym__Atomic] = ACTIONS(3067),
    [anon_sym__Noreturn] = ACTIONS(3067),
    [anon_sym_noreturn] = ACTIONS(3067),
    [anon_sym__Nonnull] = ACTIONS(3067),
    [anon_sym_mutable] = ACTIONS(3067),
    [anon_sym_constinit] = ACTIONS(3067),
    [anon_sym_consteval] = ACTIONS(3067),
    [anon_sym_alignas] = ACTIONS(3067),
    [anon_sym__Alignas] = ACTIONS(3067),
    [sym_primitive_type] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_union] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3067),
    [anon_sym_decltype] = ACTIONS(3067),
    [anon_sym_explicit] = ACTIONS(3067),
    [anon_sym_typename] = ACTIONS(3067),
    [anon_sym_private] = ACTIONS(3067),
    [anon_sym_template] = ACTIONS(3067),
    [anon_sym_operator] = ACTIONS(3067),
    [anon_sym_friend] = ACTIONS(3067),
    [anon_sym_public] = ACTIONS(3067),
    [anon_sym_protected] = ACTIONS(3067),
    [anon_sym_static_assert] = ACTIONS(3067),
  },
  [2106] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4182),
    [anon_sym_or_eq] = ACTIONS(4182),
    [anon_sym_xor_eq] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2107] = {
    [sym_attribute_specifier] = STATE(1852),
    [sym_field_declaration_list] = STATE(2352),
    [sym_virtual_specifier] = STATE(6930),
    [sym_base_class_clause] = STATE(7902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5495),
    [anon_sym_COMMA] = ACTIONS(5495),
    [anon_sym_RPAREN] = ACTIONS(5495),
    [anon_sym_LPAREN2] = ACTIONS(5495),
    [anon_sym_DASH] = ACTIONS(5493),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_STAR] = ACTIONS(5495),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_PERCENT] = ACTIONS(5495),
    [anon_sym_PIPE_PIPE] = ACTIONS(5495),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_CARET] = ACTIONS(5495),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5495),
    [anon_sym_BANG_EQ] = ACTIONS(5495),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5495),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5495),
    [anon_sym_GT_GT] = ACTIONS(5495),
    [anon_sym_SEMI] = ACTIONS(5495),
    [anon_sym___extension__] = ACTIONS(5495),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(5499),
    [anon_sym_LBRACE] = ACTIONS(6018),
    [anon_sym_RBRACE] = ACTIONS(5495),
    [anon_sym_LBRACK] = ACTIONS(5495),
    [anon_sym_RBRACK] = ACTIONS(5495),
    [anon_sym_const] = ACTIONS(5493),
    [anon_sym_constexpr] = ACTIONS(5495),
    [anon_sym_volatile] = ACTIONS(5495),
    [anon_sym_restrict] = ACTIONS(5495),
    [anon_sym___restrict__] = ACTIONS(5495),
    [anon_sym__Atomic] = ACTIONS(5495),
    [anon_sym__Noreturn] = ACTIONS(5495),
    [anon_sym_noreturn] = ACTIONS(5495),
    [anon_sym__Nonnull] = ACTIONS(5495),
    [anon_sym_mutable] = ACTIONS(5495),
    [anon_sym_constinit] = ACTIONS(5495),
    [anon_sym_consteval] = ACTIONS(5495),
    [anon_sym_alignas] = ACTIONS(5495),
    [anon_sym__Alignas] = ACTIONS(5495),
    [anon_sym_QMARK] = ACTIONS(5495),
    [anon_sym_LT_EQ_GT] = ACTIONS(5495),
    [anon_sym_or] = ACTIONS(5495),
    [anon_sym_and] = ACTIONS(5495),
    [anon_sym_bitor] = ACTIONS(5495),
    [anon_sym_xor] = ACTIONS(5495),
    [anon_sym_bitand] = ACTIONS(5495),
    [anon_sym_not_eq] = ACTIONS(5495),
    [anon_sym_DASH_DASH] = ACTIONS(5495),
    [anon_sym_PLUS_PLUS] = ACTIONS(5495),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_DOT_STAR] = ACTIONS(5495),
    [anon_sym_DASH_GT] = ACTIONS(5495),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5495),
    [anon_sym_decltype] = ACTIONS(5495),
    [anon_sym_final] = ACTIONS(6020),
    [anon_sym_override] = ACTIONS(6020),
    [anon_sym_requires] = ACTIONS(5495),
  },
  [2108] = {
    [sym_identifier] = ACTIONS(3071),
    [aux_sym_preproc_def_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token2] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3071),
    [sym_preproc_directive] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym___extension__] = ACTIONS(3071),
    [anon_sym_typedef] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym___attribute__] = ACTIONS(3071),
    [anon_sym___attribute] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3073),
    [anon_sym___declspec] = ACTIONS(3071),
    [anon_sym___based] = ACTIONS(3071),
    [anon_sym_signed] = ACTIONS(3071),
    [anon_sym_unsigned] = ACTIONS(3071),
    [anon_sym_long] = ACTIONS(3071),
    [anon_sym_short] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_register] = ACTIONS(3071),
    [anon_sym_inline] = ACTIONS(3071),
    [anon_sym___inline] = ACTIONS(3071),
    [anon_sym___inline__] = ACTIONS(3071),
    [anon_sym___forceinline] = ACTIONS(3071),
    [anon_sym_thread_local] = ACTIONS(3071),
    [anon_sym___thread] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_constexpr] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_restrict] = ACTIONS(3071),
    [anon_sym___restrict__] = ACTIONS(3071),
    [anon_sym__Atomic] = ACTIONS(3071),
    [anon_sym__Noreturn] = ACTIONS(3071),
    [anon_sym_noreturn] = ACTIONS(3071),
    [anon_sym__Nonnull] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_constinit] = ACTIONS(3071),
    [anon_sym_consteval] = ACTIONS(3071),
    [anon_sym_alignas] = ACTIONS(3071),
    [anon_sym__Alignas] = ACTIONS(3071),
    [sym_primitive_type] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_union] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3071),
    [anon_sym_decltype] = ACTIONS(3071),
    [anon_sym_explicit] = ACTIONS(3071),
    [anon_sym_typename] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_template] = ACTIONS(3071),
    [anon_sym_operator] = ACTIONS(3071),
    [anon_sym_friend] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_static_assert] = ACTIONS(3071),
  },
  [2109] = {
    [sym_identifier] = ACTIONS(5513),
    [aux_sym_preproc_def_token1] = ACTIONS(5513),
    [aux_sym_preproc_if_token1] = ACTIONS(5513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5513),
    [sym_preproc_directive] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(5515),
    [anon_sym_TILDE] = ACTIONS(5515),
    [anon_sym_STAR] = ACTIONS(5515),
    [anon_sym_AMP_AMP] = ACTIONS(5515),
    [anon_sym_AMP] = ACTIONS(5513),
    [anon_sym_SEMI] = ACTIONS(5515),
    [anon_sym___extension__] = ACTIONS(5513),
    [anon_sym_typedef] = ACTIONS(5513),
    [anon_sym_virtual] = ACTIONS(5513),
    [anon_sym_extern] = ACTIONS(5513),
    [anon_sym___attribute__] = ACTIONS(5513),
    [anon_sym___attribute] = ACTIONS(5513),
    [anon_sym_using] = ACTIONS(5513),
    [anon_sym_COLON_COLON] = ACTIONS(5515),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5515),
    [anon_sym___declspec] = ACTIONS(5513),
    [anon_sym___based] = ACTIONS(5513),
    [anon_sym_RBRACE] = ACTIONS(5515),
    [anon_sym_signed] = ACTIONS(5513),
    [anon_sym_unsigned] = ACTIONS(5513),
    [anon_sym_long] = ACTIONS(5513),
    [anon_sym_short] = ACTIONS(5513),
    [anon_sym_LBRACK] = ACTIONS(5513),
    [anon_sym_static] = ACTIONS(5513),
    [anon_sym_register] = ACTIONS(5513),
    [anon_sym_inline] = ACTIONS(5513),
    [anon_sym___inline] = ACTIONS(5513),
    [anon_sym___inline__] = ACTIONS(5513),
    [anon_sym___forceinline] = ACTIONS(5513),
    [anon_sym_thread_local] = ACTIONS(5513),
    [anon_sym___thread] = ACTIONS(5513),
    [anon_sym_const] = ACTIONS(5513),
    [anon_sym_constexpr] = ACTIONS(5513),
    [anon_sym_volatile] = ACTIONS(5513),
    [anon_sym_restrict] = ACTIONS(5513),
    [anon_sym___restrict__] = ACTIONS(5513),
    [anon_sym__Atomic] = ACTIONS(5513),
    [anon_sym__Noreturn] = ACTIONS(5513),
    [anon_sym_noreturn] = ACTIONS(5513),
    [anon_sym__Nonnull] = ACTIONS(5513),
    [anon_sym_mutable] = ACTIONS(5513),
    [anon_sym_constinit] = ACTIONS(5513),
    [anon_sym_consteval] = ACTIONS(5513),
    [anon_sym_alignas] = ACTIONS(5513),
    [anon_sym__Alignas] = ACTIONS(5513),
    [sym_primitive_type] = ACTIONS(5513),
    [anon_sym_enum] = ACTIONS(5513),
    [anon_sym_class] = ACTIONS(5513),
    [anon_sym_struct] = ACTIONS(5513),
    [anon_sym_union] = ACTIONS(5513),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5513),
    [anon_sym_decltype] = ACTIONS(5513),
    [anon_sym_explicit] = ACTIONS(5513),
    [anon_sym_typename] = ACTIONS(5513),
    [anon_sym_private] = ACTIONS(5513),
    [anon_sym_template] = ACTIONS(5513),
    [anon_sym_operator] = ACTIONS(5513),
    [anon_sym_friend] = ACTIONS(5513),
    [anon_sym_public] = ACTIONS(5513),
    [anon_sym_protected] = ACTIONS(5513),
    [anon_sym_static_assert] = ACTIONS(5513),
  },
  [2110] = {
    [sym_identifier] = ACTIONS(5597),
    [aux_sym_preproc_def_token1] = ACTIONS(5597),
    [aux_sym_preproc_if_token1] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5597),
    [sym_preproc_directive] = ACTIONS(5597),
    [anon_sym_LPAREN2] = ACTIONS(5599),
    [anon_sym_TILDE] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(5599),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5599),
    [anon_sym___extension__] = ACTIONS(5597),
    [anon_sym_typedef] = ACTIONS(5597),
    [anon_sym_virtual] = ACTIONS(5597),
    [anon_sym_extern] = ACTIONS(5597),
    [anon_sym___attribute__] = ACTIONS(5597),
    [anon_sym___attribute] = ACTIONS(5597),
    [anon_sym_using] = ACTIONS(5597),
    [anon_sym_COLON_COLON] = ACTIONS(5599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5599),
    [anon_sym___declspec] = ACTIONS(5597),
    [anon_sym___based] = ACTIONS(5597),
    [anon_sym_RBRACE] = ACTIONS(5599),
    [anon_sym_signed] = ACTIONS(5597),
    [anon_sym_unsigned] = ACTIONS(5597),
    [anon_sym_long] = ACTIONS(5597),
    [anon_sym_short] = ACTIONS(5597),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [anon_sym_static] = ACTIONS(5597),
    [anon_sym_register] = ACTIONS(5597),
    [anon_sym_inline] = ACTIONS(5597),
    [anon_sym___inline] = ACTIONS(5597),
    [anon_sym___inline__] = ACTIONS(5597),
    [anon_sym___forceinline] = ACTIONS(5597),
    [anon_sym_thread_local] = ACTIONS(5597),
    [anon_sym___thread] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5597),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym___restrict__] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym__Noreturn] = ACTIONS(5597),
    [anon_sym_noreturn] = ACTIONS(5597),
    [anon_sym__Nonnull] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_constinit] = ACTIONS(5597),
    [anon_sym_consteval] = ACTIONS(5597),
    [anon_sym_alignas] = ACTIONS(5597),
    [anon_sym__Alignas] = ACTIONS(5597),
    [sym_primitive_type] = ACTIONS(5597),
    [anon_sym_enum] = ACTIONS(5597),
    [anon_sym_class] = ACTIONS(5597),
    [anon_sym_struct] = ACTIONS(5597),
    [anon_sym_union] = ACTIONS(5597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_decltype] = ACTIONS(5597),
    [anon_sym_explicit] = ACTIONS(5597),
    [anon_sym_typename] = ACTIONS(5597),
    [anon_sym_private] = ACTIONS(5597),
    [anon_sym_template] = ACTIONS(5597),
    [anon_sym_operator] = ACTIONS(5597),
    [anon_sym_friend] = ACTIONS(5597),
    [anon_sym_public] = ACTIONS(5597),
    [anon_sym_protected] = ACTIONS(5597),
    [anon_sym_static_assert] = ACTIONS(5597),
  },
  [2111] = {
    [sym_identifier] = ACTIONS(3309),
    [aux_sym_preproc_def_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token1] = ACTIONS(3309),
    [aux_sym_preproc_if_token2] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3309),
    [sym_preproc_directive] = ACTIONS(3309),
    [anon_sym_LPAREN2] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_AMP_AMP] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym___extension__] = ACTIONS(3309),
    [anon_sym_typedef] = ACTIONS(3309),
    [anon_sym_virtual] = ACTIONS(3309),
    [anon_sym_extern] = ACTIONS(3309),
    [anon_sym___attribute__] = ACTIONS(3309),
    [anon_sym___attribute] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_COLON_COLON] = ACTIONS(3311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3311),
    [anon_sym___declspec] = ACTIONS(3309),
    [anon_sym___based] = ACTIONS(3309),
    [anon_sym_signed] = ACTIONS(3309),
    [anon_sym_unsigned] = ACTIONS(3309),
    [anon_sym_long] = ACTIONS(3309),
    [anon_sym_short] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_register] = ACTIONS(3309),
    [anon_sym_inline] = ACTIONS(3309),
    [anon_sym___inline] = ACTIONS(3309),
    [anon_sym___inline__] = ACTIONS(3309),
    [anon_sym___forceinline] = ACTIONS(3309),
    [anon_sym_thread_local] = ACTIONS(3309),
    [anon_sym___thread] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_constexpr] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(3309),
    [anon_sym_restrict] = ACTIONS(3309),
    [anon_sym___restrict__] = ACTIONS(3309),
    [anon_sym__Atomic] = ACTIONS(3309),
    [anon_sym__Noreturn] = ACTIONS(3309),
    [anon_sym_noreturn] = ACTIONS(3309),
    [anon_sym__Nonnull] = ACTIONS(3309),
    [anon_sym_mutable] = ACTIONS(3309),
    [anon_sym_constinit] = ACTIONS(3309),
    [anon_sym_consteval] = ACTIONS(3309),
    [anon_sym_alignas] = ACTIONS(3309),
    [anon_sym__Alignas] = ACTIONS(3309),
    [sym_primitive_type] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_struct] = ACTIONS(3309),
    [anon_sym_union] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3309),
    [anon_sym_decltype] = ACTIONS(3309),
    [anon_sym_explicit] = ACTIONS(3309),
    [anon_sym_typename] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_template] = ACTIONS(3309),
    [anon_sym_operator] = ACTIONS(3309),
    [anon_sym_friend] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_static_assert] = ACTIONS(3309),
  },
  [2112] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON] = ACTIONS(6022),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4182),
    [anon_sym_or_eq] = ACTIONS(4182),
    [anon_sym_xor_eq] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2113] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token2] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2885),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_private] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_friend] = ACTIONS(2883),
    [anon_sym_public] = ACTIONS(2883),
    [anon_sym_protected] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
  },
  [2114] = {
    [sym_identifier] = ACTIONS(2955),
    [aux_sym_preproc_def_token1] = ACTIONS(2955),
    [aux_sym_preproc_if_token1] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2955),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2955),
    [sym_preproc_directive] = ACTIONS(2955),
    [anon_sym_LPAREN2] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym___extension__] = ACTIONS(2955),
    [anon_sym_typedef] = ACTIONS(2955),
    [anon_sym_virtual] = ACTIONS(2955),
    [anon_sym_extern] = ACTIONS(2955),
    [anon_sym___attribute__] = ACTIONS(2955),
    [anon_sym___attribute] = ACTIONS(2955),
    [anon_sym_using] = ACTIONS(2955),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2957),
    [anon_sym___declspec] = ACTIONS(2955),
    [anon_sym___based] = ACTIONS(2955),
    [anon_sym_RBRACE] = ACTIONS(2957),
    [anon_sym_signed] = ACTIONS(2955),
    [anon_sym_unsigned] = ACTIONS(2955),
    [anon_sym_long] = ACTIONS(2955),
    [anon_sym_short] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_register] = ACTIONS(2955),
    [anon_sym_inline] = ACTIONS(2955),
    [anon_sym___inline] = ACTIONS(2955),
    [anon_sym___inline__] = ACTIONS(2955),
    [anon_sym___forceinline] = ACTIONS(2955),
    [anon_sym_thread_local] = ACTIONS(2955),
    [anon_sym___thread] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_constexpr] = ACTIONS(2955),
    [anon_sym_volatile] = ACTIONS(2955),
    [anon_sym_restrict] = ACTIONS(2955),
    [anon_sym___restrict__] = ACTIONS(2955),
    [anon_sym__Atomic] = ACTIONS(2955),
    [anon_sym__Noreturn] = ACTIONS(2955),
    [anon_sym_noreturn] = ACTIONS(2955),
    [anon_sym__Nonnull] = ACTIONS(2955),
    [anon_sym_mutable] = ACTIONS(2955),
    [anon_sym_constinit] = ACTIONS(2955),
    [anon_sym_consteval] = ACTIONS(2955),
    [anon_sym_alignas] = ACTIONS(2955),
    [anon_sym__Alignas] = ACTIONS(2955),
    [sym_primitive_type] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2955),
    [anon_sym_union] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2955),
    [anon_sym_decltype] = ACTIONS(2955),
    [anon_sym_explicit] = ACTIONS(2955),
    [anon_sym_typename] = ACTIONS(2955),
    [anon_sym_private] = ACTIONS(2955),
    [anon_sym_template] = ACTIONS(2955),
    [anon_sym_operator] = ACTIONS(2955),
    [anon_sym_friend] = ACTIONS(2955),
    [anon_sym_public] = ACTIONS(2955),
    [anon_sym_protected] = ACTIONS(2955),
    [anon_sym_static_assert] = ACTIONS(2955),
  },
  [2115] = {
    [sym_string_literal] = STATE(2189),
    [sym_template_argument_list] = STATE(3129),
    [sym_raw_string_literal] = STATE(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(5997),
    [anon_sym_LPAREN2] = ACTIONS(5997),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5044),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5997),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4146),
    [anon_sym_or_eq] = ACTIONS(4146),
    [anon_sym_xor_eq] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4154),
    [anon_sym_L_DQUOTE] = ACTIONS(5040),
    [anon_sym_u_DQUOTE] = ACTIONS(5040),
    [anon_sym_U_DQUOTE] = ACTIONS(5040),
    [anon_sym_u8_DQUOTE] = ACTIONS(5040),
    [anon_sym_DQUOTE] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5042),
    [anon_sym_LR_DQUOTE] = ACTIONS(5042),
    [anon_sym_uR_DQUOTE] = ACTIONS(5042),
    [anon_sym_UR_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5042),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4146),
  },
  [2116] = {
    [sym_attribute_specifier] = STATE(2207),
    [sym_enumerator_list] = STATE(2173),
    [sym_identifier] = ACTIONS(6024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6026),
    [anon_sym_COMMA] = ACTIONS(6026),
    [anon_sym_RPAREN] = ACTIONS(6026),
    [aux_sym_preproc_if_token2] = ACTIONS(6026),
    [aux_sym_preproc_else_token1] = ACTIONS(6026),
    [aux_sym_preproc_elif_token1] = ACTIONS(6024),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6026),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6026),
    [anon_sym_LPAREN2] = ACTIONS(6026),
    [anon_sym_DASH] = ACTIONS(6024),
    [anon_sym_PLUS] = ACTIONS(6024),
    [anon_sym_STAR] = ACTIONS(6024),
    [anon_sym_SLASH] = ACTIONS(6024),
    [anon_sym_PERCENT] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(6026),
    [anon_sym_PIPE] = ACTIONS(6024),
    [anon_sym_CARET] = ACTIONS(6024),
    [anon_sym_AMP] = ACTIONS(6024),
    [anon_sym_EQ_EQ] = ACTIONS(6026),
    [anon_sym_BANG_EQ] = ACTIONS(6026),
    [anon_sym_GT] = ACTIONS(6024),
    [anon_sym_GT_EQ] = ACTIONS(6026),
    [anon_sym_LT_EQ] = ACTIONS(6024),
    [anon_sym_LT] = ACTIONS(6024),
    [anon_sym_LT_LT] = ACTIONS(6024),
    [anon_sym_GT_GT] = ACTIONS(6024),
    [anon_sym_SEMI] = ACTIONS(6026),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6026),
    [anon_sym_LBRACE] = ACTIONS(5987),
    [anon_sym_RBRACE] = ACTIONS(6026),
    [anon_sym_LBRACK] = ACTIONS(6026),
    [anon_sym_RBRACK] = ACTIONS(6026),
    [anon_sym_EQ] = ACTIONS(6024),
    [anon_sym_QMARK] = ACTIONS(6026),
    [anon_sym_STAR_EQ] = ACTIONS(6026),
    [anon_sym_SLASH_EQ] = ACTIONS(6026),
    [anon_sym_PERCENT_EQ] = ACTIONS(6026),
    [anon_sym_PLUS_EQ] = ACTIONS(6026),
    [anon_sym_DASH_EQ] = ACTIONS(6026),
    [anon_sym_LT_LT_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_AMP_EQ] = ACTIONS(6026),
    [anon_sym_CARET_EQ] = ACTIONS(6026),
    [anon_sym_PIPE_EQ] = ACTIONS(6026),
    [anon_sym_and_eq] = ACTIONS(6024),
    [anon_sym_or_eq] = ACTIONS(6024),
    [anon_sym_xor_eq] = ACTIONS(6024),
    [anon_sym_LT_EQ_GT] = ACTIONS(6026),
    [anon_sym_or] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_bitor] = ACTIONS(6024),
    [anon_sym_xor] = ACTIONS(6024),
    [anon_sym_bitand] = ACTIONS(6024),
    [anon_sym_not_eq] = ACTIONS(6024),
    [anon_sym_DASH_DASH] = ACTIONS(6026),
    [anon_sym_PLUS_PLUS] = ACTIONS(6026),
    [anon_sym_DOT] = ACTIONS(6024),
    [anon_sym_DOT_STAR] = ACTIONS(6026),
    [anon_sym_DASH_GT] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6024),
    [anon_sym_decltype] = ACTIONS(6024),
  },
  [2117] = {
    [sym_template_argument_list] = STATE(1603),
    [sym_identifier] = ACTIONS(5838),
    [anon_sym_LPAREN2] = ACTIONS(4172),
    [anon_sym_TILDE] = ACTIONS(4172),
    [anon_sym_STAR] = ACTIONS(4172),
    [anon_sym_PIPE_PIPE] = ACTIONS(4172),
    [anon_sym_AMP_AMP] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(6004),
    [anon_sym___extension__] = ACTIONS(5838),
    [anon_sym_virtual] = ACTIONS(5838),
    [anon_sym_extern] = ACTIONS(5838),
    [anon_sym___attribute__] = ACTIONS(5838),
    [anon_sym___attribute] = ACTIONS(5838),
    [anon_sym_using] = ACTIONS(5838),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4172),
    [anon_sym___declspec] = ACTIONS(5838),
    [anon_sym___based] = ACTIONS(5838),
    [anon_sym___cdecl] = ACTIONS(5838),
    [anon_sym___clrcall] = ACTIONS(5838),
    [anon_sym___stdcall] = ACTIONS(5838),
    [anon_sym___fastcall] = ACTIONS(5838),
    [anon_sym___thiscall] = ACTIONS(5838),
    [anon_sym___vectorcall] = ACTIONS(5838),
    [anon_sym_signed] = ACTIONS(5838),
    [anon_sym_unsigned] = ACTIONS(5838),
    [anon_sym_long] = ACTIONS(5838),
    [anon_sym_short] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5838),
    [anon_sym_static] = ACTIONS(5838),
    [anon_sym_register] = ACTIONS(5838),
    [anon_sym_inline] = ACTIONS(5838),
    [anon_sym___inline] = ACTIONS(5838),
    [anon_sym___inline__] = ACTIONS(5838),
    [anon_sym___forceinline] = ACTIONS(5838),
    [anon_sym_thread_local] = ACTIONS(5838),
    [anon_sym___thread] = ACTIONS(5838),
    [anon_sym_const] = ACTIONS(5838),
    [anon_sym_constexpr] = ACTIONS(5838),
    [anon_sym_volatile] = ACTIONS(5838),
    [anon_sym_restrict] = ACTIONS(5838),
    [anon_sym___restrict__] = ACTIONS(5838),
    [anon_sym__Atomic] = ACTIONS(5838),
    [anon_sym__Noreturn] = ACTIONS(5838),
    [anon_sym_noreturn] = ACTIONS(5838),
    [anon_sym__Nonnull] = ACTIONS(5838),
    [anon_sym_mutable] = ACTIONS(5838),
    [anon_sym_constinit] = ACTIONS(5838),
    [anon_sym_consteval] = ACTIONS(5838),
    [anon_sym_alignas] = ACTIONS(5838),
    [anon_sym__Alignas] = ACTIONS(5838),
    [sym_primitive_type] = ACTIONS(5838),
    [anon_sym_enum] = ACTIONS(5838),
    [anon_sym_class] = ACTIONS(5838),
    [anon_sym_struct] = ACTIONS(5838),
    [anon_sym_union] = ACTIONS(5838),
    [anon_sym_or] = ACTIONS(5838),
    [anon_sym_and] = ACTIONS(5838),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5838),
    [anon_sym_decltype] = ACTIONS(5838),
    [anon_sym_explicit] = ACTIONS(5838),
    [anon_sym_typename] = ACTIONS(5838),
    [anon_sym_template] = ACTIONS(5838),
    [anon_sym_operator] = ACTIONS(5838),
    [anon_sym_friend] = ACTIONS(5838),
    [anon_sym_concept] = ACTIONS(5838),
  },
  [2118] = {
    [sym_identifier] = ACTIONS(5541),
    [aux_sym_preproc_def_token1] = ACTIONS(5541),
    [aux_sym_preproc_if_token1] = ACTIONS(5541),
    [aux_sym_preproc_if_token2] = ACTIONS(5541),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5541),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5541),
    [sym_preproc_directive] = ACTIONS(5541),
    [anon_sym_LPAREN2] = ACTIONS(5543),
    [anon_sym_TILDE] = ACTIONS(5543),
    [anon_sym_STAR] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5543),
    [anon_sym___extension__] = ACTIONS(5541),
    [anon_sym_typedef] = ACTIONS(5541),
    [anon_sym_virtual] = ACTIONS(5541),
    [anon_sym_extern] = ACTIONS(5541),
    [anon_sym___attribute__] = ACTIONS(5541),
    [anon_sym___attribute] = ACTIONS(5541),
    [anon_sym_using] = ACTIONS(5541),
    [anon_sym_COLON_COLON] = ACTIONS(5543),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5543),
    [anon_sym___declspec] = ACTIONS(5541),
    [anon_sym___based] = ACTIONS(5541),
    [anon_sym_signed] = ACTIONS(5541),
    [anon_sym_unsigned] = ACTIONS(5541),
    [anon_sym_long] = ACTIONS(5541),
    [anon_sym_short] = ACTIONS(5541),
    [anon_sym_LBRACK] = ACTIONS(5541),
    [anon_sym_static] = ACTIONS(5541),
    [anon_sym_register] = ACTIONS(5541),
    [anon_sym_inline] = ACTIONS(5541),
    [anon_sym___inline] = ACTIONS(5541),
    [anon_sym___inline__] = ACTIONS(5541),
    [anon_sym___forceinline] = ACTIONS(5541),
    [anon_sym_thread_local] = ACTIONS(5541),
    [anon_sym___thread] = ACTIONS(5541),
    [anon_sym_const] = ACTIONS(5541),
    [anon_sym_constexpr] = ACTIONS(5541),
    [anon_sym_volatile] = ACTIONS(5541),
    [anon_sym_restrict] = ACTIONS(5541),
    [anon_sym___restrict__] = ACTIONS(5541),
    [anon_sym__Atomic] = ACTIONS(5541),
    [anon_sym__Noreturn] = ACTIONS(5541),
    [anon_sym_noreturn] = ACTIONS(5541),
    [anon_sym__Nonnull] = ACTIONS(5541),
    [anon_sym_mutable] = ACTIONS(5541),
    [anon_sym_constinit] = ACTIONS(5541),
    [anon_sym_consteval] = ACTIONS(5541),
    [anon_sym_alignas] = ACTIONS(5541),
    [anon_sym__Alignas] = ACTIONS(5541),
    [sym_primitive_type] = ACTIONS(5541),
    [anon_sym_enum] = ACTIONS(5541),
    [anon_sym_class] = ACTIONS(5541),
    [anon_sym_struct] = ACTIONS(5541),
    [anon_sym_union] = ACTIONS(5541),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5541),
    [anon_sym_decltype] = ACTIONS(5541),
    [anon_sym_explicit] = ACTIONS(5541),
    [anon_sym_typename] = ACTIONS(5541),
    [anon_sym_private] = ACTIONS(5541),
    [anon_sym_template] = ACTIONS(5541),
    [anon_sym_operator] = ACTIONS(5541),
    [anon_sym_friend] = ACTIONS(5541),
    [anon_sym_public] = ACTIONS(5541),
    [anon_sym_protected] = ACTIONS(5541),
    [anon_sym_static_assert] = ACTIONS(5541),
  },
  [2119] = {
    [sym_identifier] = ACTIONS(2775),
    [aux_sym_preproc_def_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token1] = ACTIONS(2775),
    [aux_sym_preproc_if_token2] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2775),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2775),
    [sym_preproc_directive] = ACTIONS(2775),
    [anon_sym_LPAREN2] = ACTIONS(2777),
    [anon_sym_TILDE] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym___extension__] = ACTIONS(2775),
    [anon_sym_typedef] = ACTIONS(2775),
    [anon_sym_virtual] = ACTIONS(2775),
    [anon_sym_extern] = ACTIONS(2775),
    [anon_sym___attribute__] = ACTIONS(2775),
    [anon_sym___attribute] = ACTIONS(2775),
    [anon_sym_using] = ACTIONS(2775),
    [anon_sym_COLON_COLON] = ACTIONS(2777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2777),
    [anon_sym___declspec] = ACTIONS(2775),
    [anon_sym___based] = ACTIONS(2775),
    [anon_sym_signed] = ACTIONS(2775),
    [anon_sym_unsigned] = ACTIONS(2775),
    [anon_sym_long] = ACTIONS(2775),
    [anon_sym_short] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_static] = ACTIONS(2775),
    [anon_sym_register] = ACTIONS(2775),
    [anon_sym_inline] = ACTIONS(2775),
    [anon_sym___inline] = ACTIONS(2775),
    [anon_sym___inline__] = ACTIONS(2775),
    [anon_sym___forceinline] = ACTIONS(2775),
    [anon_sym_thread_local] = ACTIONS(2775),
    [anon_sym___thread] = ACTIONS(2775),
    [anon_sym_const] = ACTIONS(2775),
    [anon_sym_constexpr] = ACTIONS(2775),
    [anon_sym_volatile] = ACTIONS(2775),
    [anon_sym_restrict] = ACTIONS(2775),
    [anon_sym___restrict__] = ACTIONS(2775),
    [anon_sym__Atomic] = ACTIONS(2775),
    [anon_sym__Noreturn] = ACTIONS(2775),
    [anon_sym_noreturn] = ACTIONS(2775),
    [anon_sym__Nonnull] = ACTIONS(2775),
    [anon_sym_mutable] = ACTIONS(2775),
    [anon_sym_constinit] = ACTIONS(2775),
    [anon_sym_consteval] = ACTIONS(2775),
    [anon_sym_alignas] = ACTIONS(2775),
    [anon_sym__Alignas] = ACTIONS(2775),
    [sym_primitive_type] = ACTIONS(2775),
    [anon_sym_enum] = ACTIONS(2775),
    [anon_sym_class] = ACTIONS(2775),
    [anon_sym_struct] = ACTIONS(2775),
    [anon_sym_union] = ACTIONS(2775),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2775),
    [anon_sym_decltype] = ACTIONS(2775),
    [anon_sym_explicit] = ACTIONS(2775),
    [anon_sym_typename] = ACTIONS(2775),
    [anon_sym_private] = ACTIONS(2775),
    [anon_sym_template] = ACTIONS(2775),
    [anon_sym_operator] = ACTIONS(2775),
    [anon_sym_friend] = ACTIONS(2775),
    [anon_sym_public] = ACTIONS(2775),
    [anon_sym_protected] = ACTIONS(2775),
    [anon_sym_static_assert] = ACTIONS(2775),
  },
  [2120] = {
    [sym_identifier] = ACTIONS(5585),
    [aux_sym_preproc_def_token1] = ACTIONS(5585),
    [aux_sym_preproc_if_token1] = ACTIONS(5585),
    [aux_sym_preproc_if_token2] = ACTIONS(5585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5585),
    [sym_preproc_directive] = ACTIONS(5585),
    [anon_sym_LPAREN2] = ACTIONS(5587),
    [anon_sym_TILDE] = ACTIONS(5587),
    [anon_sym_STAR] = ACTIONS(5587),
    [anon_sym_AMP_AMP] = ACTIONS(5587),
    [anon_sym_AMP] = ACTIONS(5585),
    [anon_sym_SEMI] = ACTIONS(5587),
    [anon_sym___extension__] = ACTIONS(5585),
    [anon_sym_typedef] = ACTIONS(5585),
    [anon_sym_virtual] = ACTIONS(5585),
    [anon_sym_extern] = ACTIONS(5585),
    [anon_sym___attribute__] = ACTIONS(5585),
    [anon_sym___attribute] = ACTIONS(5585),
    [anon_sym_using] = ACTIONS(5585),
    [anon_sym_COLON_COLON] = ACTIONS(5587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5587),
    [anon_sym___declspec] = ACTIONS(5585),
    [anon_sym___based] = ACTIONS(5585),
    [anon_sym_signed] = ACTIONS(5585),
    [anon_sym_unsigned] = ACTIONS(5585),
    [anon_sym_long] = ACTIONS(5585),
    [anon_sym_short] = ACTIONS(5585),
    [anon_sym_LBRACK] = ACTIONS(5585),
    [anon_sym_static] = ACTIONS(5585),
    [anon_sym_register] = ACTIONS(5585),
    [anon_sym_inline] = ACTIONS(5585),
    [anon_sym___inline] = ACTIONS(5585),
    [anon_sym___inline__] = ACTIONS(5585),
    [anon_sym___forceinline] = ACTIONS(5585),
    [anon_sym_thread_local] = ACTIONS(5585),
    [anon_sym___thread] = ACTIONS(5585),
    [anon_sym_const] = ACTIONS(5585),
    [anon_sym_constexpr] = ACTIONS(5585),
    [anon_sym_volatile] = ACTIONS(5585),
    [anon_sym_restrict] = ACTIONS(5585),
    [anon_sym___restrict__] = ACTIONS(5585),
    [anon_sym__Atomic] = ACTIONS(5585),
    [anon_sym__Noreturn] = ACTIONS(5585),
    [anon_sym_noreturn] = ACTIONS(5585),
    [anon_sym__Nonnull] = ACTIONS(5585),
    [anon_sym_mutable] = ACTIONS(5585),
    [anon_sym_constinit] = ACTIONS(5585),
    [anon_sym_consteval] = ACTIONS(5585),
    [anon_sym_alignas] = ACTIONS(5585),
    [anon_sym__Alignas] = ACTIONS(5585),
    [sym_primitive_type] = ACTIONS(5585),
    [anon_sym_enum] = ACTIONS(5585),
    [anon_sym_class] = ACTIONS(5585),
    [anon_sym_struct] = ACTIONS(5585),
    [anon_sym_union] = ACTIONS(5585),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5585),
    [anon_sym_decltype] = ACTIONS(5585),
    [anon_sym_explicit] = ACTIONS(5585),
    [anon_sym_typename] = ACTIONS(5585),
    [anon_sym_private] = ACTIONS(5585),
    [anon_sym_template] = ACTIONS(5585),
    [anon_sym_operator] = ACTIONS(5585),
    [anon_sym_friend] = ACTIONS(5585),
    [anon_sym_public] = ACTIONS(5585),
    [anon_sym_protected] = ACTIONS(5585),
    [anon_sym_static_assert] = ACTIONS(5585),
  },
  [2121] = {
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token2] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym___attribute] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym__Nonnull] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym__Alignas] = ACTIONS(2779),
    [sym_primitive_type] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_private] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_friend] = ACTIONS(2779),
    [anon_sym_public] = ACTIONS(2779),
    [anon_sym_protected] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
  },
  [2122] = {
    [sym_identifier] = ACTIONS(5601),
    [aux_sym_preproc_def_token1] = ACTIONS(5601),
    [aux_sym_preproc_if_token1] = ACTIONS(5601),
    [aux_sym_preproc_if_token2] = ACTIONS(5601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5601),
    [sym_preproc_directive] = ACTIONS(5601),
    [anon_sym_LPAREN2] = ACTIONS(5603),
    [anon_sym_TILDE] = ACTIONS(5603),
    [anon_sym_STAR] = ACTIONS(5603),
    [anon_sym_AMP_AMP] = ACTIONS(5603),
    [anon_sym_AMP] = ACTIONS(5601),
    [anon_sym_SEMI] = ACTIONS(5603),
    [anon_sym___extension__] = ACTIONS(5601),
    [anon_sym_typedef] = ACTIONS(5601),
    [anon_sym_virtual] = ACTIONS(5601),
    [anon_sym_extern] = ACTIONS(5601),
    [anon_sym___attribute__] = ACTIONS(5601),
    [anon_sym___attribute] = ACTIONS(5601),
    [anon_sym_using] = ACTIONS(5601),
    [anon_sym_COLON_COLON] = ACTIONS(5603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5603),
    [anon_sym___declspec] = ACTIONS(5601),
    [anon_sym___based] = ACTIONS(5601),
    [anon_sym_signed] = ACTIONS(5601),
    [anon_sym_unsigned] = ACTIONS(5601),
    [anon_sym_long] = ACTIONS(5601),
    [anon_sym_short] = ACTIONS(5601),
    [anon_sym_LBRACK] = ACTIONS(5601),
    [anon_sym_static] = ACTIONS(5601),
    [anon_sym_register] = ACTIONS(5601),
    [anon_sym_inline] = ACTIONS(5601),
    [anon_sym___inline] = ACTIONS(5601),
    [anon_sym___inline__] = ACTIONS(5601),
    [anon_sym___forceinline] = ACTIONS(5601),
    [anon_sym_thread_local] = ACTIONS(5601),
    [anon_sym___thread] = ACTIONS(5601),
    [anon_sym_const] = ACTIONS(5601),
    [anon_sym_constexpr] = ACTIONS(5601),
    [anon_sym_volatile] = ACTIONS(5601),
    [anon_sym_restrict] = ACTIONS(5601),
    [anon_sym___restrict__] = ACTIONS(5601),
    [anon_sym__Atomic] = ACTIONS(5601),
    [anon_sym__Noreturn] = ACTIONS(5601),
    [anon_sym_noreturn] = ACTIONS(5601),
    [anon_sym__Nonnull] = ACTIONS(5601),
    [anon_sym_mutable] = ACTIONS(5601),
    [anon_sym_constinit] = ACTIONS(5601),
    [anon_sym_consteval] = ACTIONS(5601),
    [anon_sym_alignas] = ACTIONS(5601),
    [anon_sym__Alignas] = ACTIONS(5601),
    [sym_primitive_type] = ACTIONS(5601),
    [anon_sym_enum] = ACTIONS(5601),
    [anon_sym_class] = ACTIONS(5601),
    [anon_sym_struct] = ACTIONS(5601),
    [anon_sym_union] = ACTIONS(5601),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5601),
    [anon_sym_decltype] = ACTIONS(5601),
    [anon_sym_explicit] = ACTIONS(5601),
    [anon_sym_typename] = ACTIONS(5601),
    [anon_sym_private] = ACTIONS(5601),
    [anon_sym_template] = ACTIONS(5601),
    [anon_sym_operator] = ACTIONS(5601),
    [anon_sym_friend] = ACTIONS(5601),
    [anon_sym_public] = ACTIONS(5601),
    [anon_sym_protected] = ACTIONS(5601),
    [anon_sym_static_assert] = ACTIONS(5601),
  },
  [2123] = {
    [sym_identifier] = ACTIONS(5597),
    [aux_sym_preproc_def_token1] = ACTIONS(5597),
    [aux_sym_preproc_if_token1] = ACTIONS(5597),
    [aux_sym_preproc_if_token2] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5597),
    [sym_preproc_directive] = ACTIONS(5597),
    [anon_sym_LPAREN2] = ACTIONS(5599),
    [anon_sym_TILDE] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(5599),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5599),
    [anon_sym___extension__] = ACTIONS(5597),
    [anon_sym_typedef] = ACTIONS(5597),
    [anon_sym_virtual] = ACTIONS(5597),
    [anon_sym_extern] = ACTIONS(5597),
    [anon_sym___attribute__] = ACTIONS(5597),
    [anon_sym___attribute] = ACTIONS(5597),
    [anon_sym_using] = ACTIONS(5597),
    [anon_sym_COLON_COLON] = ACTIONS(5599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5599),
    [anon_sym___declspec] = ACTIONS(5597),
    [anon_sym___based] = ACTIONS(5597),
    [anon_sym_signed] = ACTIONS(5597),
    [anon_sym_unsigned] = ACTIONS(5597),
    [anon_sym_long] = ACTIONS(5597),
    [anon_sym_short] = ACTIONS(5597),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [anon_sym_static] = ACTIONS(5597),
    [anon_sym_register] = ACTIONS(5597),
    [anon_sym_inline] = ACTIONS(5597),
    [anon_sym___inline] = ACTIONS(5597),
    [anon_sym___inline__] = ACTIONS(5597),
    [anon_sym___forceinline] = ACTIONS(5597),
    [anon_sym_thread_local] = ACTIONS(5597),
    [anon_sym___thread] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5597),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym___restrict__] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym__Noreturn] = ACTIONS(5597),
    [anon_sym_noreturn] = ACTIONS(5597),
    [anon_sym__Nonnull] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_constinit] = ACTIONS(5597),
    [anon_sym_consteval] = ACTIONS(5597),
    [anon_sym_alignas] = ACTIONS(5597),
    [anon_sym__Alignas] = ACTIONS(5597),
    [sym_primitive_type] = ACTIONS(5597),
    [anon_sym_enum] = ACTIONS(5597),
    [anon_sym_class] = ACTIONS(5597),
    [anon_sym_struct] = ACTIONS(5597),
    [anon_sym_union] = ACTIONS(5597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_decltype] = ACTIONS(5597),
    [anon_sym_explicit] = ACTIONS(5597),
    [anon_sym_typename] = ACTIONS(5597),
    [anon_sym_private] = ACTIONS(5597),
    [anon_sym_template] = ACTIONS(5597),
    [anon_sym_operator] = ACTIONS(5597),
    [anon_sym_friend] = ACTIONS(5597),
    [anon_sym_public] = ACTIONS(5597),
    [anon_sym_protected] = ACTIONS(5597),
    [anon_sym_static_assert] = ACTIONS(5597),
  },
  [2124] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token2] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym___attribute] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym__Nonnull] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym__Alignas] = ACTIONS(2783),
    [sym_primitive_type] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_private] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_friend] = ACTIONS(2783),
    [anon_sym_public] = ACTIONS(2783),
    [anon_sym_protected] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
  },
  [2125] = {
    [sym_identifier] = ACTIONS(5456),
    [aux_sym_preproc_def_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token2] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5456),
    [sym_preproc_directive] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5458),
    [anon_sym_TILDE] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5458),
    [anon_sym___extension__] = ACTIONS(5456),
    [anon_sym_typedef] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym___attribute__] = ACTIONS(5456),
    [anon_sym___attribute] = ACTIONS(5456),
    [anon_sym_using] = ACTIONS(5456),
    [anon_sym_COLON_COLON] = ACTIONS(5458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5458),
    [anon_sym___declspec] = ACTIONS(5456),
    [anon_sym___based] = ACTIONS(5456),
    [anon_sym_signed] = ACTIONS(5456),
    [anon_sym_unsigned] = ACTIONS(5456),
    [anon_sym_long] = ACTIONS(5456),
    [anon_sym_short] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_register] = ACTIONS(5456),
    [anon_sym_inline] = ACTIONS(5456),
    [anon_sym___inline] = ACTIONS(5456),
    [anon_sym___inline__] = ACTIONS(5456),
    [anon_sym___forceinline] = ACTIONS(5456),
    [anon_sym_thread_local] = ACTIONS(5456),
    [anon_sym___thread] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_constexpr] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_restrict] = ACTIONS(5456),
    [anon_sym___restrict__] = ACTIONS(5456),
    [anon_sym__Atomic] = ACTIONS(5456),
    [anon_sym__Noreturn] = ACTIONS(5456),
    [anon_sym_noreturn] = ACTIONS(5456),
    [anon_sym__Nonnull] = ACTIONS(5456),
    [anon_sym_mutable] = ACTIONS(5456),
    [anon_sym_constinit] = ACTIONS(5456),
    [anon_sym_consteval] = ACTIONS(5456),
    [anon_sym_alignas] = ACTIONS(5456),
    [anon_sym__Alignas] = ACTIONS(5456),
    [sym_primitive_type] = ACTIONS(5456),
    [anon_sym_enum] = ACTIONS(5456),
    [anon_sym_class] = ACTIONS(5456),
    [anon_sym_struct] = ACTIONS(5456),
    [anon_sym_union] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5456),
    [anon_sym_decltype] = ACTIONS(5456),
    [anon_sym_explicit] = ACTIONS(5456),
    [anon_sym_typename] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_template] = ACTIONS(5456),
    [anon_sym_operator] = ACTIONS(5456),
    [anon_sym_friend] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_static_assert] = ACTIONS(5456),
  },
  [2126] = {
    [sym_identifier] = ACTIONS(5456),
    [aux_sym_preproc_def_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token2] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5456),
    [sym_preproc_directive] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5458),
    [anon_sym_TILDE] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5458),
    [anon_sym___extension__] = ACTIONS(5456),
    [anon_sym_typedef] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym___attribute__] = ACTIONS(5456),
    [anon_sym___attribute] = ACTIONS(5456),
    [anon_sym_using] = ACTIONS(5456),
    [anon_sym_COLON_COLON] = ACTIONS(5458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5458),
    [anon_sym___declspec] = ACTIONS(5456),
    [anon_sym___based] = ACTIONS(5456),
    [anon_sym_signed] = ACTIONS(5456),
    [anon_sym_unsigned] = ACTIONS(5456),
    [anon_sym_long] = ACTIONS(5456),
    [anon_sym_short] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_register] = ACTIONS(5456),
    [anon_sym_inline] = ACTIONS(5456),
    [anon_sym___inline] = ACTIONS(5456),
    [anon_sym___inline__] = ACTIONS(5456),
    [anon_sym___forceinline] = ACTIONS(5456),
    [anon_sym_thread_local] = ACTIONS(5456),
    [anon_sym___thread] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_constexpr] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_restrict] = ACTIONS(5456),
    [anon_sym___restrict__] = ACTIONS(5456),
    [anon_sym__Atomic] = ACTIONS(5456),
    [anon_sym__Noreturn] = ACTIONS(5456),
    [anon_sym_noreturn] = ACTIONS(5456),
    [anon_sym__Nonnull] = ACTIONS(5456),
    [anon_sym_mutable] = ACTIONS(5456),
    [anon_sym_constinit] = ACTIONS(5456),
    [anon_sym_consteval] = ACTIONS(5456),
    [anon_sym_alignas] = ACTIONS(5456),
    [anon_sym__Alignas] = ACTIONS(5456),
    [sym_primitive_type] = ACTIONS(5456),
    [anon_sym_enum] = ACTIONS(5456),
    [anon_sym_class] = ACTIONS(5456),
    [anon_sym_struct] = ACTIONS(5456),
    [anon_sym_union] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5456),
    [anon_sym_decltype] = ACTIONS(5456),
    [anon_sym_explicit] = ACTIONS(5456),
    [anon_sym_typename] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_template] = ACTIONS(5456),
    [anon_sym_operator] = ACTIONS(5456),
    [anon_sym_friend] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_static_assert] = ACTIONS(5456),
  },
  [2127] = {
    [sym_identifier] = ACTIONS(5529),
    [aux_sym_preproc_def_token1] = ACTIONS(5529),
    [aux_sym_preproc_if_token1] = ACTIONS(5529),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5529),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5529),
    [sym_preproc_directive] = ACTIONS(5529),
    [anon_sym_LPAREN2] = ACTIONS(5531),
    [anon_sym_TILDE] = ACTIONS(5531),
    [anon_sym_STAR] = ACTIONS(5531),
    [anon_sym_AMP_AMP] = ACTIONS(5531),
    [anon_sym_AMP] = ACTIONS(5529),
    [anon_sym_SEMI] = ACTIONS(5531),
    [anon_sym___extension__] = ACTIONS(5529),
    [anon_sym_typedef] = ACTIONS(5529),
    [anon_sym_virtual] = ACTIONS(5529),
    [anon_sym_extern] = ACTIONS(5529),
    [anon_sym___attribute__] = ACTIONS(5529),
    [anon_sym___attribute] = ACTIONS(5529),
    [anon_sym_using] = ACTIONS(5529),
    [anon_sym_COLON_COLON] = ACTIONS(5531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5531),
    [anon_sym___declspec] = ACTIONS(5529),
    [anon_sym___based] = ACTIONS(5529),
    [anon_sym_RBRACE] = ACTIONS(5531),
    [anon_sym_signed] = ACTIONS(5529),
    [anon_sym_unsigned] = ACTIONS(5529),
    [anon_sym_long] = ACTIONS(5529),
    [anon_sym_short] = ACTIONS(5529),
    [anon_sym_LBRACK] = ACTIONS(5529),
    [anon_sym_static] = ACTIONS(5529),
    [anon_sym_register] = ACTIONS(5529),
    [anon_sym_inline] = ACTIONS(5529),
    [anon_sym___inline] = ACTIONS(5529),
    [anon_sym___inline__] = ACTIONS(5529),
    [anon_sym___forceinline] = ACTIONS(5529),
    [anon_sym_thread_local] = ACTIONS(5529),
    [anon_sym___thread] = ACTIONS(5529),
    [anon_sym_const] = ACTIONS(5529),
    [anon_sym_constexpr] = ACTIONS(5529),
    [anon_sym_volatile] = ACTIONS(5529),
    [anon_sym_restrict] = ACTIONS(5529),
    [anon_sym___restrict__] = ACTIONS(5529),
    [anon_sym__Atomic] = ACTIONS(5529),
    [anon_sym__Noreturn] = ACTIONS(5529),
    [anon_sym_noreturn] = ACTIONS(5529),
    [anon_sym__Nonnull] = ACTIONS(5529),
    [anon_sym_mutable] = ACTIONS(5529),
    [anon_sym_constinit] = ACTIONS(5529),
    [anon_sym_consteval] = ACTIONS(5529),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_primitive_type] = ACTIONS(5529),
    [anon_sym_enum] = ACTIONS(5529),
    [anon_sym_class] = ACTIONS(5529),
    [anon_sym_struct] = ACTIONS(5529),
    [anon_sym_union] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5529),
    [anon_sym_decltype] = ACTIONS(5529),
    [anon_sym_explicit] = ACTIONS(5529),
    [anon_sym_typename] = ACTIONS(5529),
    [anon_sym_private] = ACTIONS(5529),
    [anon_sym_template] = ACTIONS(5529),
    [anon_sym_operator] = ACTIONS(5529),
    [anon_sym_friend] = ACTIONS(5529),
    [anon_sym_public] = ACTIONS(5529),
    [anon_sym_protected] = ACTIONS(5529),
    [anon_sym_static_assert] = ACTIONS(5529),
  },
  [2128] = {
    [sym_identifier] = ACTIONS(5456),
    [aux_sym_preproc_def_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token1] = ACTIONS(5456),
    [aux_sym_preproc_if_token2] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5456),
    [sym_preproc_directive] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5458),
    [anon_sym_TILDE] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5458),
    [anon_sym___extension__] = ACTIONS(5456),
    [anon_sym_typedef] = ACTIONS(5456),
    [anon_sym_virtual] = ACTIONS(5456),
    [anon_sym_extern] = ACTIONS(5456),
    [anon_sym___attribute__] = ACTIONS(5456),
    [anon_sym___attribute] = ACTIONS(5456),
    [anon_sym_using] = ACTIONS(5456),
    [anon_sym_COLON_COLON] = ACTIONS(5458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5458),
    [anon_sym___declspec] = ACTIONS(5456),
    [anon_sym___based] = ACTIONS(5456),
    [anon_sym_signed] = ACTIONS(5456),
    [anon_sym_unsigned] = ACTIONS(5456),
    [anon_sym_long] = ACTIONS(5456),
    [anon_sym_short] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_static] = ACTIONS(5456),
    [anon_sym_register] = ACTIONS(5456),
    [anon_sym_inline] = ACTIONS(5456),
    [anon_sym___inline] = ACTIONS(5456),
    [anon_sym___inline__] = ACTIONS(5456),
    [anon_sym___forceinline] = ACTIONS(5456),
    [anon_sym_thread_local] = ACTIONS(5456),
    [anon_sym___thread] = ACTIONS(5456),
    [anon_sym_const] = ACTIONS(5456),
    [anon_sym_constexpr] = ACTIONS(5456),
    [anon_sym_volatile] = ACTIONS(5456),
    [anon_sym_restrict] = ACTIONS(5456),
    [anon_sym___restrict__] = ACTIONS(5456),
    [anon_sym__Atomic] = ACTIONS(5456),
    [anon_sym__Noreturn] = ACTIONS(5456),
    [anon_sym_noreturn] = ACTIONS(5456),
    [anon_sym__Nonnull] = ACTIONS(5456),
    [anon_sym_mutable] = ACTIONS(5456),
    [anon_sym_constinit] = ACTIONS(5456),
    [anon_sym_consteval] = ACTIONS(5456),
    [anon_sym_alignas] = ACTIONS(5456),
    [anon_sym__Alignas] = ACTIONS(5456),
    [sym_primitive_type] = ACTIONS(5456),
    [anon_sym_enum] = ACTIONS(5456),
    [anon_sym_class] = ACTIONS(5456),
    [anon_sym_struct] = ACTIONS(5456),
    [anon_sym_union] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5456),
    [anon_sym_decltype] = ACTIONS(5456),
    [anon_sym_explicit] = ACTIONS(5456),
    [anon_sym_typename] = ACTIONS(5456),
    [anon_sym_private] = ACTIONS(5456),
    [anon_sym_template] = ACTIONS(5456),
    [anon_sym_operator] = ACTIONS(5456),
    [anon_sym_friend] = ACTIONS(5456),
    [anon_sym_public] = ACTIONS(5456),
    [anon_sym_protected] = ACTIONS(5456),
    [anon_sym_static_assert] = ACTIONS(5456),
  },
  [2129] = {
    [sym_identifier] = ACTIONS(2787),
    [aux_sym_preproc_def_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token1] = ACTIONS(2787),
    [aux_sym_preproc_if_token2] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2787),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2787),
    [sym_preproc_directive] = ACTIONS(2787),
    [anon_sym_LPAREN2] = ACTIONS(2789),
    [anon_sym_TILDE] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym___extension__] = ACTIONS(2787),
    [anon_sym_typedef] = ACTIONS(2787),
    [anon_sym_virtual] = ACTIONS(2787),
    [anon_sym_extern] = ACTIONS(2787),
    [anon_sym___attribute__] = ACTIONS(2787),
    [anon_sym___attribute] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2789),
    [anon_sym___declspec] = ACTIONS(2787),
    [anon_sym___based] = ACTIONS(2787),
    [anon_sym_signed] = ACTIONS(2787),
    [anon_sym_unsigned] = ACTIONS(2787),
    [anon_sym_long] = ACTIONS(2787),
    [anon_sym_short] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_static] = ACTIONS(2787),
    [anon_sym_register] = ACTIONS(2787),
    [anon_sym_inline] = ACTIONS(2787),
    [anon_sym___inline] = ACTIONS(2787),
    [anon_sym___inline__] = ACTIONS(2787),
    [anon_sym___forceinline] = ACTIONS(2787),
    [anon_sym_thread_local] = ACTIONS(2787),
    [anon_sym___thread] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_constexpr] = ACTIONS(2787),
    [anon_sym_volatile] = ACTIONS(2787),
    [anon_sym_restrict] = ACTIONS(2787),
    [anon_sym___restrict__] = ACTIONS(2787),
    [anon_sym__Atomic] = ACTIONS(2787),
    [anon_sym__Noreturn] = ACTIONS(2787),
    [anon_sym_noreturn] = ACTIONS(2787),
    [anon_sym__Nonnull] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_constinit] = ACTIONS(2787),
    [anon_sym_consteval] = ACTIONS(2787),
    [anon_sym_alignas] = ACTIONS(2787),
    [anon_sym__Alignas] = ACTIONS(2787),
    [sym_primitive_type] = ACTIONS(2787),
    [anon_sym_enum] = ACTIONS(2787),
    [anon_sym_class] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_union] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2787),
    [anon_sym_decltype] = ACTIONS(2787),
    [anon_sym_explicit] = ACTIONS(2787),
    [anon_sym_typename] = ACTIONS(2787),
    [anon_sym_private] = ACTIONS(2787),
    [anon_sym_template] = ACTIONS(2787),
    [anon_sym_operator] = ACTIONS(2787),
    [anon_sym_friend] = ACTIONS(2787),
    [anon_sym_public] = ACTIONS(2787),
    [anon_sym_protected] = ACTIONS(2787),
    [anon_sym_static_assert] = ACTIONS(2787),
  },
  [2130] = {
    [sym_identifier] = ACTIONS(5597),
    [aux_sym_preproc_def_token1] = ACTIONS(5597),
    [aux_sym_preproc_if_token1] = ACTIONS(5597),
    [aux_sym_preproc_if_token2] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5597),
    [sym_preproc_directive] = ACTIONS(5597),
    [anon_sym_LPAREN2] = ACTIONS(5599),
    [anon_sym_TILDE] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(5599),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5599),
    [anon_sym___extension__] = ACTIONS(5597),
    [anon_sym_typedef] = ACTIONS(5597),
    [anon_sym_virtual] = ACTIONS(5597),
    [anon_sym_extern] = ACTIONS(5597),
    [anon_sym___attribute__] = ACTIONS(5597),
    [anon_sym___attribute] = ACTIONS(5597),
    [anon_sym_using] = ACTIONS(5597),
    [anon_sym_COLON_COLON] = ACTIONS(5599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5599),
    [anon_sym___declspec] = ACTIONS(5597),
    [anon_sym___based] = ACTIONS(5597),
    [anon_sym_signed] = ACTIONS(5597),
    [anon_sym_unsigned] = ACTIONS(5597),
    [anon_sym_long] = ACTIONS(5597),
    [anon_sym_short] = ACTIONS(5597),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [anon_sym_static] = ACTIONS(5597),
    [anon_sym_register] = ACTIONS(5597),
    [anon_sym_inline] = ACTIONS(5597),
    [anon_sym___inline] = ACTIONS(5597),
    [anon_sym___inline__] = ACTIONS(5597),
    [anon_sym___forceinline] = ACTIONS(5597),
    [anon_sym_thread_local] = ACTIONS(5597),
    [anon_sym___thread] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5597),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym___restrict__] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym__Noreturn] = ACTIONS(5597),
    [anon_sym_noreturn] = ACTIONS(5597),
    [anon_sym__Nonnull] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_constinit] = ACTIONS(5597),
    [anon_sym_consteval] = ACTIONS(5597),
    [anon_sym_alignas] = ACTIONS(5597),
    [anon_sym__Alignas] = ACTIONS(5597),
    [sym_primitive_type] = ACTIONS(5597),
    [anon_sym_enum] = ACTIONS(5597),
    [anon_sym_class] = ACTIONS(5597),
    [anon_sym_struct] = ACTIONS(5597),
    [anon_sym_union] = ACTIONS(5597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_decltype] = ACTIONS(5597),
    [anon_sym_explicit] = ACTIONS(5597),
    [anon_sym_typename] = ACTIONS(5597),
    [anon_sym_private] = ACTIONS(5597),
    [anon_sym_template] = ACTIONS(5597),
    [anon_sym_operator] = ACTIONS(5597),
    [anon_sym_friend] = ACTIONS(5597),
    [anon_sym_public] = ACTIONS(5597),
    [anon_sym_protected] = ACTIONS(5597),
    [anon_sym_static_assert] = ACTIONS(5597),
  },
  [2131] = {
    [sym_string_literal] = STATE(1992),
    [sym_template_argument_list] = STATE(2338),
    [sym_raw_string_literal] = STATE(1992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5373),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___attribute__] = ACTIONS(4146),
    [anon_sym___attribute] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4146),
    [anon_sym_or_eq] = ACTIONS(4146),
    [anon_sym_xor_eq] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(5954),
    [anon_sym_u_DQUOTE] = ACTIONS(5954),
    [anon_sym_U_DQUOTE] = ACTIONS(5954),
    [anon_sym_u8_DQUOTE] = ACTIONS(5954),
    [anon_sym_DQUOTE] = ACTIONS(5954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5956),
    [anon_sym_LR_DQUOTE] = ACTIONS(5956),
    [anon_sym_uR_DQUOTE] = ACTIONS(5956),
    [anon_sym_UR_DQUOTE] = ACTIONS(5956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5956),
  },
  [2132] = {
    [sym_identifier] = ACTIONS(2791),
    [aux_sym_preproc_def_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token1] = ACTIONS(2791),
    [aux_sym_preproc_if_token2] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2791),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2791),
    [sym_preproc_directive] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2793),
    [anon_sym_TILDE] = ACTIONS(2793),
    [anon_sym_STAR] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym___extension__] = ACTIONS(2791),
    [anon_sym_typedef] = ACTIONS(2791),
    [anon_sym_virtual] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym___attribute__] = ACTIONS(2791),
    [anon_sym___attribute] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2793),
    [anon_sym___declspec] = ACTIONS(2791),
    [anon_sym___based] = ACTIONS(2791),
    [anon_sym_signed] = ACTIONS(2791),
    [anon_sym_unsigned] = ACTIONS(2791),
    [anon_sym_long] = ACTIONS(2791),
    [anon_sym_short] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_register] = ACTIONS(2791),
    [anon_sym_inline] = ACTIONS(2791),
    [anon_sym___inline] = ACTIONS(2791),
    [anon_sym___inline__] = ACTIONS(2791),
    [anon_sym___forceinline] = ACTIONS(2791),
    [anon_sym_thread_local] = ACTIONS(2791),
    [anon_sym___thread] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_constexpr] = ACTIONS(2791),
    [anon_sym_volatile] = ACTIONS(2791),
    [anon_sym_restrict] = ACTIONS(2791),
    [anon_sym___restrict__] = ACTIONS(2791),
    [anon_sym__Atomic] = ACTIONS(2791),
    [anon_sym__Noreturn] = ACTIONS(2791),
    [anon_sym_noreturn] = ACTIONS(2791),
    [anon_sym__Nonnull] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_constinit] = ACTIONS(2791),
    [anon_sym_consteval] = ACTIONS(2791),
    [anon_sym_alignas] = ACTIONS(2791),
    [anon_sym__Alignas] = ACTIONS(2791),
    [sym_primitive_type] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_class] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2791),
    [anon_sym_decltype] = ACTIONS(2791),
    [anon_sym_explicit] = ACTIONS(2791),
    [anon_sym_typename] = ACTIONS(2791),
    [anon_sym_private] = ACTIONS(2791),
    [anon_sym_template] = ACTIONS(2791),
    [anon_sym_operator] = ACTIONS(2791),
    [anon_sym_friend] = ACTIONS(2791),
    [anon_sym_public] = ACTIONS(2791),
    [anon_sym_protected] = ACTIONS(2791),
    [anon_sym_static_assert] = ACTIONS(2791),
  },
  [2133] = {
    [sym_identifier] = ACTIONS(5533),
    [aux_sym_preproc_def_token1] = ACTIONS(5533),
    [aux_sym_preproc_if_token1] = ACTIONS(5533),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5533),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5533),
    [sym_preproc_directive] = ACTIONS(5533),
    [anon_sym_LPAREN2] = ACTIONS(5535),
    [anon_sym_TILDE] = ACTIONS(5535),
    [anon_sym_STAR] = ACTIONS(5535),
    [anon_sym_AMP_AMP] = ACTIONS(5535),
    [anon_sym_AMP] = ACTIONS(5533),
    [anon_sym_SEMI] = ACTIONS(5535),
    [anon_sym___extension__] = ACTIONS(5533),
    [anon_sym_typedef] = ACTIONS(5533),
    [anon_sym_virtual] = ACTIONS(5533),
    [anon_sym_extern] = ACTIONS(5533),
    [anon_sym___attribute__] = ACTIONS(5533),
    [anon_sym___attribute] = ACTIONS(5533),
    [anon_sym_using] = ACTIONS(5533),
    [anon_sym_COLON_COLON] = ACTIONS(5535),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5535),
    [anon_sym___declspec] = ACTIONS(5533),
    [anon_sym___based] = ACTIONS(5533),
    [anon_sym_RBRACE] = ACTIONS(5535),
    [anon_sym_signed] = ACTIONS(5533),
    [anon_sym_unsigned] = ACTIONS(5533),
    [anon_sym_long] = ACTIONS(5533),
    [anon_sym_short] = ACTIONS(5533),
    [anon_sym_LBRACK] = ACTIONS(5533),
    [anon_sym_static] = ACTIONS(5533),
    [anon_sym_register] = ACTIONS(5533),
    [anon_sym_inline] = ACTIONS(5533),
    [anon_sym___inline] = ACTIONS(5533),
    [anon_sym___inline__] = ACTIONS(5533),
    [anon_sym___forceinline] = ACTIONS(5533),
    [anon_sym_thread_local] = ACTIONS(5533),
    [anon_sym___thread] = ACTIONS(5533),
    [anon_sym_const] = ACTIONS(5533),
    [anon_sym_constexpr] = ACTIONS(5533),
    [anon_sym_volatile] = ACTIONS(5533),
    [anon_sym_restrict] = ACTIONS(5533),
    [anon_sym___restrict__] = ACTIONS(5533),
    [anon_sym__Atomic] = ACTIONS(5533),
    [anon_sym__Noreturn] = ACTIONS(5533),
    [anon_sym_noreturn] = ACTIONS(5533),
    [anon_sym__Nonnull] = ACTIONS(5533),
    [anon_sym_mutable] = ACTIONS(5533),
    [anon_sym_constinit] = ACTIONS(5533),
    [anon_sym_consteval] = ACTIONS(5533),
    [anon_sym_alignas] = ACTIONS(5533),
    [anon_sym__Alignas] = ACTIONS(5533),
    [sym_primitive_type] = ACTIONS(5533),
    [anon_sym_enum] = ACTIONS(5533),
    [anon_sym_class] = ACTIONS(5533),
    [anon_sym_struct] = ACTIONS(5533),
    [anon_sym_union] = ACTIONS(5533),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5533),
    [anon_sym_decltype] = ACTIONS(5533),
    [anon_sym_explicit] = ACTIONS(5533),
    [anon_sym_typename] = ACTIONS(5533),
    [anon_sym_private] = ACTIONS(5533),
    [anon_sym_template] = ACTIONS(5533),
    [anon_sym_operator] = ACTIONS(5533),
    [anon_sym_friend] = ACTIONS(5533),
    [anon_sym_public] = ACTIONS(5533),
    [anon_sym_protected] = ACTIONS(5533),
    [anon_sym_static_assert] = ACTIONS(5533),
  },
  [2134] = {
    [sym_identifier] = ACTIONS(2855),
    [aux_sym_preproc_def_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token1] = ACTIONS(2855),
    [aux_sym_preproc_if_token2] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2855),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2855),
    [sym_preproc_directive] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2857),
    [anon_sym_TILDE] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym___extension__] = ACTIONS(2855),
    [anon_sym_typedef] = ACTIONS(2855),
    [anon_sym_virtual] = ACTIONS(2855),
    [anon_sym_extern] = ACTIONS(2855),
    [anon_sym___attribute__] = ACTIONS(2855),
    [anon_sym___attribute] = ACTIONS(2855),
    [anon_sym_using] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2857),
    [anon_sym___declspec] = ACTIONS(2855),
    [anon_sym___based] = ACTIONS(2855),
    [anon_sym_signed] = ACTIONS(2855),
    [anon_sym_unsigned] = ACTIONS(2855),
    [anon_sym_long] = ACTIONS(2855),
    [anon_sym_short] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(2855),
    [anon_sym_register] = ACTIONS(2855),
    [anon_sym_inline] = ACTIONS(2855),
    [anon_sym___inline] = ACTIONS(2855),
    [anon_sym___inline__] = ACTIONS(2855),
    [anon_sym___forceinline] = ACTIONS(2855),
    [anon_sym_thread_local] = ACTIONS(2855),
    [anon_sym___thread] = ACTIONS(2855),
    [anon_sym_const] = ACTIONS(2855),
    [anon_sym_constexpr] = ACTIONS(2855),
    [anon_sym_volatile] = ACTIONS(2855),
    [anon_sym_restrict] = ACTIONS(2855),
    [anon_sym___restrict__] = ACTIONS(2855),
    [anon_sym__Atomic] = ACTIONS(2855),
    [anon_sym__Noreturn] = ACTIONS(2855),
    [anon_sym_noreturn] = ACTIONS(2855),
    [anon_sym__Nonnull] = ACTIONS(2855),
    [anon_sym_mutable] = ACTIONS(2855),
    [anon_sym_constinit] = ACTIONS(2855),
    [anon_sym_consteval] = ACTIONS(2855),
    [anon_sym_alignas] = ACTIONS(2855),
    [anon_sym__Alignas] = ACTIONS(2855),
    [sym_primitive_type] = ACTIONS(2855),
    [anon_sym_enum] = ACTIONS(2855),
    [anon_sym_class] = ACTIONS(2855),
    [anon_sym_struct] = ACTIONS(2855),
    [anon_sym_union] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2855),
    [anon_sym_explicit] = ACTIONS(2855),
    [anon_sym_typename] = ACTIONS(2855),
    [anon_sym_private] = ACTIONS(2855),
    [anon_sym_template] = ACTIONS(2855),
    [anon_sym_operator] = ACTIONS(2855),
    [anon_sym_friend] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(2855),
    [anon_sym_protected] = ACTIONS(2855),
    [anon_sym_static_assert] = ACTIONS(2855),
  },
  [2135] = {
    [sym_identifier] = ACTIONS(6028),
    [anon_sym_LPAREN2] = ACTIONS(6030),
    [anon_sym_TILDE] = ACTIONS(6030),
    [anon_sym_STAR] = ACTIONS(6030),
    [anon_sym_AMP_AMP] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(6028),
    [anon_sym___extension__] = ACTIONS(6028),
    [anon_sym_virtual] = ACTIONS(6028),
    [anon_sym_extern] = ACTIONS(6028),
    [anon_sym___attribute__] = ACTIONS(6028),
    [anon_sym___attribute] = ACTIONS(6028),
    [anon_sym_using] = ACTIONS(6028),
    [anon_sym_COLON_COLON] = ACTIONS(6030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6030),
    [anon_sym___declspec] = ACTIONS(6028),
    [anon_sym___based] = ACTIONS(6028),
    [anon_sym___cdecl] = ACTIONS(6028),
    [anon_sym___clrcall] = ACTIONS(6028),
    [anon_sym___stdcall] = ACTIONS(6028),
    [anon_sym___fastcall] = ACTIONS(6028),
    [anon_sym___thiscall] = ACTIONS(6028),
    [anon_sym___vectorcall] = ACTIONS(6028),
    [anon_sym_LBRACE] = ACTIONS(6030),
    [anon_sym_signed] = ACTIONS(6028),
    [anon_sym_unsigned] = ACTIONS(6028),
    [anon_sym_long] = ACTIONS(6028),
    [anon_sym_short] = ACTIONS(6028),
    [anon_sym_LBRACK] = ACTIONS(6028),
    [anon_sym_static] = ACTIONS(6028),
    [anon_sym_register] = ACTIONS(6028),
    [anon_sym_inline] = ACTIONS(6028),
    [anon_sym___inline] = ACTIONS(6028),
    [anon_sym___inline__] = ACTIONS(6028),
    [anon_sym___forceinline] = ACTIONS(6028),
    [anon_sym_thread_local] = ACTIONS(6028),
    [anon_sym___thread] = ACTIONS(6028),
    [anon_sym_const] = ACTIONS(6028),
    [anon_sym_constexpr] = ACTIONS(6028),
    [anon_sym_volatile] = ACTIONS(6028),
    [anon_sym_restrict] = ACTIONS(6028),
    [anon_sym___restrict__] = ACTIONS(6028),
    [anon_sym__Atomic] = ACTIONS(6028),
    [anon_sym__Noreturn] = ACTIONS(6028),
    [anon_sym_noreturn] = ACTIONS(6028),
    [anon_sym__Nonnull] = ACTIONS(6028),
    [anon_sym_mutable] = ACTIONS(6028),
    [anon_sym_constinit] = ACTIONS(6028),
    [anon_sym_consteval] = ACTIONS(6028),
    [anon_sym_alignas] = ACTIONS(6028),
    [anon_sym__Alignas] = ACTIONS(6028),
    [sym_primitive_type] = ACTIONS(6028),
    [anon_sym_enum] = ACTIONS(6028),
    [anon_sym_class] = ACTIONS(6028),
    [anon_sym_struct] = ACTIONS(6028),
    [anon_sym_union] = ACTIONS(6028),
    [anon_sym_DASH_GT] = ACTIONS(6030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6028),
    [anon_sym_decltype] = ACTIONS(6028),
    [anon_sym_explicit] = ACTIONS(6028),
    [anon_sym_typename] = ACTIONS(6028),
    [anon_sym_template] = ACTIONS(6028),
    [anon_sym_operator] = ACTIONS(6028),
    [anon_sym_friend] = ACTIONS(6028),
    [anon_sym_noexcept] = ACTIONS(6028),
    [anon_sym_throw] = ACTIONS(6028),
    [anon_sym_concept] = ACTIONS(6028),
    [anon_sym_requires] = ACTIONS(6028),
  },
  [2136] = {
    [sym__declaration_modifiers] = STATE(3269),
    [sym_attribute_specifier] = STATE(3269),
    [sym_attribute_declaration] = STATE(3269),
    [sym_ms_declspec_modifier] = STATE(3269),
    [sym_storage_class_specifier] = STATE(3269),
    [sym_type_qualifier] = STATE(3269),
    [sym_alignas_qualifier] = STATE(1658),
    [sym_type_specifier] = STATE(2385),
    [sym_sized_type_specifier] = STATE(2523),
    [sym_enum_specifier] = STATE(2523),
    [sym_struct_specifier] = STATE(2523),
    [sym_union_specifier] = STATE(2523),
    [sym_placeholder_type_specifier] = STATE(2523),
    [sym_decltype_auto] = STATE(2501),
    [sym_decltype] = STATE(2406),
    [sym_class_specifier] = STATE(2523),
    [sym_dependent_type] = STATE(2523),
    [sym_template_type] = STATE(2406),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(6627),
    [sym_qualified_type_identifier] = STATE(3015),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3269),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2359),
    [sym_identifier] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_virtual] = ACTIONS(5958),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1452),
  },
  [2137] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_private] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_friend] = ACTIONS(2799),
    [anon_sym_public] = ACTIONS(2799),
    [anon_sym_protected] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
  },
  [2138] = {
    [sym_identifier] = ACTIONS(2807),
    [aux_sym_preproc_def_token1] = ACTIONS(2807),
    [aux_sym_preproc_if_token1] = ACTIONS(2807),
    [aux_sym_preproc_if_token2] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2807),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2807),
    [sym_preproc_directive] = ACTIONS(2807),
    [anon_sym_LPAREN2] = ACTIONS(2809),
    [anon_sym_TILDE] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2807),
    [anon_sym_typedef] = ACTIONS(2807),
    [anon_sym_virtual] = ACTIONS(2807),
    [anon_sym_extern] = ACTIONS(2807),
    [anon_sym___attribute__] = ACTIONS(2807),
    [anon_sym___attribute] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2809),
    [anon_sym___declspec] = ACTIONS(2807),
    [anon_sym___based] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2807),
    [anon_sym_unsigned] = ACTIONS(2807),
    [anon_sym_long] = ACTIONS(2807),
    [anon_sym_short] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_static] = ACTIONS(2807),
    [anon_sym_register] = ACTIONS(2807),
    [anon_sym_inline] = ACTIONS(2807),
    [anon_sym___inline] = ACTIONS(2807),
    [anon_sym___inline__] = ACTIONS(2807),
    [anon_sym___forceinline] = ACTIONS(2807),
    [anon_sym_thread_local] = ACTIONS(2807),
    [anon_sym___thread] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_constexpr] = ACTIONS(2807),
    [anon_sym_volatile] = ACTIONS(2807),
    [anon_sym_restrict] = ACTIONS(2807),
    [anon_sym___restrict__] = ACTIONS(2807),
    [anon_sym__Atomic] = ACTIONS(2807),
    [anon_sym__Noreturn] = ACTIONS(2807),
    [anon_sym_noreturn] = ACTIONS(2807),
    [anon_sym__Nonnull] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_constinit] = ACTIONS(2807),
    [anon_sym_consteval] = ACTIONS(2807),
    [anon_sym_alignas] = ACTIONS(2807),
    [anon_sym__Alignas] = ACTIONS(2807),
    [sym_primitive_type] = ACTIONS(2807),
    [anon_sym_enum] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_union] = ACTIONS(2807),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2807),
    [anon_sym_decltype] = ACTIONS(2807),
    [anon_sym_explicit] = ACTIONS(2807),
    [anon_sym_typename] = ACTIONS(2807),
    [anon_sym_private] = ACTIONS(2807),
    [anon_sym_template] = ACTIONS(2807),
    [anon_sym_operator] = ACTIONS(2807),
    [anon_sym_friend] = ACTIONS(2807),
    [anon_sym_public] = ACTIONS(2807),
    [anon_sym_protected] = ACTIONS(2807),
    [anon_sym_static_assert] = ACTIONS(2807),
  },
  [2139] = {
    [sym_identifier] = ACTIONS(3108),
    [aux_sym_preproc_def_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token1] = ACTIONS(3108),
    [aux_sym_preproc_if_token2] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3108),
    [sym_preproc_directive] = ACTIONS(3108),
    [anon_sym_LPAREN2] = ACTIONS(3110),
    [anon_sym_TILDE] = ACTIONS(3110),
    [anon_sym_STAR] = ACTIONS(3110),
    [anon_sym_AMP_AMP] = ACTIONS(3110),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_SEMI] = ACTIONS(3110),
    [anon_sym___extension__] = ACTIONS(3108),
    [anon_sym_typedef] = ACTIONS(3108),
    [anon_sym_virtual] = ACTIONS(3108),
    [anon_sym_extern] = ACTIONS(3108),
    [anon_sym___attribute__] = ACTIONS(3108),
    [anon_sym___attribute] = ACTIONS(3108),
    [anon_sym_using] = ACTIONS(3108),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3110),
    [anon_sym___declspec] = ACTIONS(3108),
    [anon_sym___based] = ACTIONS(3108),
    [anon_sym_signed] = ACTIONS(3108),
    [anon_sym_unsigned] = ACTIONS(3108),
    [anon_sym_long] = ACTIONS(3108),
    [anon_sym_short] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_static] = ACTIONS(3108),
    [anon_sym_register] = ACTIONS(3108),
    [anon_sym_inline] = ACTIONS(3108),
    [anon_sym___inline] = ACTIONS(3108),
    [anon_sym___inline__] = ACTIONS(3108),
    [anon_sym___forceinline] = ACTIONS(3108),
    [anon_sym_thread_local] = ACTIONS(3108),
    [anon_sym___thread] = ACTIONS(3108),
    [anon_sym_const] = ACTIONS(3108),
    [anon_sym_constexpr] = ACTIONS(3108),
    [anon_sym_volatile] = ACTIONS(3108),
    [anon_sym_restrict] = ACTIONS(3108),
    [anon_sym___restrict__] = ACTIONS(3108),
    [anon_sym__Atomic] = ACTIONS(3108),
    [anon_sym__Noreturn] = ACTIONS(3108),
    [anon_sym_noreturn] = ACTIONS(3108),
    [anon_sym__Nonnull] = ACTIONS(3108),
    [anon_sym_mutable] = ACTIONS(3108),
    [anon_sym_constinit] = ACTIONS(3108),
    [anon_sym_consteval] = ACTIONS(3108),
    [anon_sym_alignas] = ACTIONS(3108),
    [anon_sym__Alignas] = ACTIONS(3108),
    [sym_primitive_type] = ACTIONS(3108),
    [anon_sym_enum] = ACTIONS(3108),
    [anon_sym_class] = ACTIONS(3108),
    [anon_sym_struct] = ACTIONS(3108),
    [anon_sym_union] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3108),
    [anon_sym_decltype] = ACTIONS(3108),
    [anon_sym_explicit] = ACTIONS(3108),
    [anon_sym_typename] = ACTIONS(3108),
    [anon_sym_private] = ACTIONS(3108),
    [anon_sym_template] = ACTIONS(3108),
    [anon_sym_operator] = ACTIONS(3108),
    [anon_sym_friend] = ACTIONS(3108),
    [anon_sym_public] = ACTIONS(3108),
    [anon_sym_protected] = ACTIONS(3108),
    [anon_sym_static_assert] = ACTIONS(3108),
  },
  [2140] = {
    [sym_identifier] = ACTIONS(3039),
    [aux_sym_preproc_def_token1] = ACTIONS(3039),
    [aux_sym_preproc_if_token1] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3039),
    [sym_preproc_directive] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3041),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym___extension__] = ACTIONS(3039),
    [anon_sym_typedef] = ACTIONS(3039),
    [anon_sym_virtual] = ACTIONS(3039),
    [anon_sym_extern] = ACTIONS(3039),
    [anon_sym___attribute__] = ACTIONS(3039),
    [anon_sym___attribute] = ACTIONS(3039),
    [anon_sym_using] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3041),
    [anon_sym___declspec] = ACTIONS(3039),
    [anon_sym___based] = ACTIONS(3039),
    [anon_sym_RBRACE] = ACTIONS(3041),
    [anon_sym_signed] = ACTIONS(3039),
    [anon_sym_unsigned] = ACTIONS(3039),
    [anon_sym_long] = ACTIONS(3039),
    [anon_sym_short] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3039),
    [anon_sym_register] = ACTIONS(3039),
    [anon_sym_inline] = ACTIONS(3039),
    [anon_sym___inline] = ACTIONS(3039),
    [anon_sym___inline__] = ACTIONS(3039),
    [anon_sym___forceinline] = ACTIONS(3039),
    [anon_sym_thread_local] = ACTIONS(3039),
    [anon_sym___thread] = ACTIONS(3039),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_constexpr] = ACTIONS(3039),
    [anon_sym_volatile] = ACTIONS(3039),
    [anon_sym_restrict] = ACTIONS(3039),
    [anon_sym___restrict__] = ACTIONS(3039),
    [anon_sym__Atomic] = ACTIONS(3039),
    [anon_sym__Noreturn] = ACTIONS(3039),
    [anon_sym_noreturn] = ACTIONS(3039),
    [anon_sym__Nonnull] = ACTIONS(3039),
    [anon_sym_mutable] = ACTIONS(3039),
    [anon_sym_constinit] = ACTIONS(3039),
    [anon_sym_consteval] = ACTIONS(3039),
    [anon_sym_alignas] = ACTIONS(3039),
    [anon_sym__Alignas] = ACTIONS(3039),
    [sym_primitive_type] = ACTIONS(3039),
    [anon_sym_enum] = ACTIONS(3039),
    [anon_sym_class] = ACTIONS(3039),
    [anon_sym_struct] = ACTIONS(3039),
    [anon_sym_union] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3039),
    [anon_sym_decltype] = ACTIONS(3039),
    [anon_sym_explicit] = ACTIONS(3039),
    [anon_sym_typename] = ACTIONS(3039),
    [anon_sym_private] = ACTIONS(3039),
    [anon_sym_template] = ACTIONS(3039),
    [anon_sym_operator] = ACTIONS(3039),
    [anon_sym_friend] = ACTIONS(3039),
    [anon_sym_public] = ACTIONS(3039),
    [anon_sym_protected] = ACTIONS(3039),
    [anon_sym_static_assert] = ACTIONS(3039),
  },
  [2141] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_friend] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
  },
  [2142] = {
    [sym_identifier] = ACTIONS(3063),
    [aux_sym_preproc_def_token1] = ACTIONS(3063),
    [aux_sym_preproc_if_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3063),
    [sym_preproc_directive] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3063),
    [anon_sym_typedef] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym___attribute__] = ACTIONS(3063),
    [anon_sym___attribute] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3063),
    [anon_sym___based] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3063),
    [anon_sym_unsigned] = ACTIONS(3063),
    [anon_sym_long] = ACTIONS(3063),
    [anon_sym_short] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_register] = ACTIONS(3063),
    [anon_sym_inline] = ACTIONS(3063),
    [anon_sym___inline] = ACTIONS(3063),
    [anon_sym___inline__] = ACTIONS(3063),
    [anon_sym___forceinline] = ACTIONS(3063),
    [anon_sym_thread_local] = ACTIONS(3063),
    [anon_sym___thread] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_constexpr] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_restrict] = ACTIONS(3063),
    [anon_sym___restrict__] = ACTIONS(3063),
    [anon_sym__Atomic] = ACTIONS(3063),
    [anon_sym__Noreturn] = ACTIONS(3063),
    [anon_sym_noreturn] = ACTIONS(3063),
    [anon_sym__Nonnull] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_constinit] = ACTIONS(3063),
    [anon_sym_consteval] = ACTIONS(3063),
    [anon_sym_alignas] = ACTIONS(3063),
    [anon_sym__Alignas] = ACTIONS(3063),
    [sym_primitive_type] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3063),
    [anon_sym_decltype] = ACTIONS(3063),
    [anon_sym_explicit] = ACTIONS(3063),
    [anon_sym_typename] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_template] = ACTIONS(3063),
    [anon_sym_operator] = ACTIONS(3063),
    [anon_sym_friend] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_static_assert] = ACTIONS(3063),
  },
  [2143] = {
    [sym_identifier] = ACTIONS(2815),
    [aux_sym_preproc_def_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token1] = ACTIONS(2815),
    [aux_sym_preproc_if_token2] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2815),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2815),
    [sym_preproc_directive] = ACTIONS(2815),
    [anon_sym_LPAREN2] = ACTIONS(2817),
    [anon_sym_TILDE] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym___extension__] = ACTIONS(2815),
    [anon_sym_typedef] = ACTIONS(2815),
    [anon_sym_virtual] = ACTIONS(2815),
    [anon_sym_extern] = ACTIONS(2815),
    [anon_sym___attribute__] = ACTIONS(2815),
    [anon_sym___attribute] = ACTIONS(2815),
    [anon_sym_using] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2817),
    [anon_sym___declspec] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2815),
    [anon_sym_unsigned] = ACTIONS(2815),
    [anon_sym_long] = ACTIONS(2815),
    [anon_sym_short] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2815),
    [anon_sym_register] = ACTIONS(2815),
    [anon_sym_inline] = ACTIONS(2815),
    [anon_sym___inline] = ACTIONS(2815),
    [anon_sym___inline__] = ACTIONS(2815),
    [anon_sym___forceinline] = ACTIONS(2815),
    [anon_sym_thread_local] = ACTIONS(2815),
    [anon_sym___thread] = ACTIONS(2815),
    [anon_sym_const] = ACTIONS(2815),
    [anon_sym_constexpr] = ACTIONS(2815),
    [anon_sym_volatile] = ACTIONS(2815),
    [anon_sym_restrict] = ACTIONS(2815),
    [anon_sym___restrict__] = ACTIONS(2815),
    [anon_sym__Atomic] = ACTIONS(2815),
    [anon_sym__Noreturn] = ACTIONS(2815),
    [anon_sym_noreturn] = ACTIONS(2815),
    [anon_sym__Nonnull] = ACTIONS(2815),
    [anon_sym_mutable] = ACTIONS(2815),
    [anon_sym_constinit] = ACTIONS(2815),
    [anon_sym_consteval] = ACTIONS(2815),
    [anon_sym_alignas] = ACTIONS(2815),
    [anon_sym__Alignas] = ACTIONS(2815),
    [sym_primitive_type] = ACTIONS(2815),
    [anon_sym_enum] = ACTIONS(2815),
    [anon_sym_class] = ACTIONS(2815),
    [anon_sym_struct] = ACTIONS(2815),
    [anon_sym_union] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2815),
    [anon_sym_decltype] = ACTIONS(2815),
    [anon_sym_explicit] = ACTIONS(2815),
    [anon_sym_typename] = ACTIONS(2815),
    [anon_sym_private] = ACTIONS(2815),
    [anon_sym_template] = ACTIONS(2815),
    [anon_sym_operator] = ACTIONS(2815),
    [anon_sym_friend] = ACTIONS(2815),
    [anon_sym_public] = ACTIONS(2815),
    [anon_sym_protected] = ACTIONS(2815),
    [anon_sym_static_assert] = ACTIONS(2815),
  },
  [2144] = {
    [sym_identifier] = ACTIONS(3112),
    [aux_sym_preproc_def_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token1] = ACTIONS(3112),
    [aux_sym_preproc_if_token2] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3112),
    [sym_preproc_directive] = ACTIONS(3112),
    [anon_sym_LPAREN2] = ACTIONS(3114),
    [anon_sym_TILDE] = ACTIONS(3114),
    [anon_sym_STAR] = ACTIONS(3114),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3112),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym___extension__] = ACTIONS(3112),
    [anon_sym_typedef] = ACTIONS(3112),
    [anon_sym_virtual] = ACTIONS(3112),
    [anon_sym_extern] = ACTIONS(3112),
    [anon_sym___attribute__] = ACTIONS(3112),
    [anon_sym___attribute] = ACTIONS(3112),
    [anon_sym_using] = ACTIONS(3112),
    [anon_sym_COLON_COLON] = ACTIONS(3114),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3114),
    [anon_sym___declspec] = ACTIONS(3112),
    [anon_sym___based] = ACTIONS(3112),
    [anon_sym_signed] = ACTIONS(3112),
    [anon_sym_unsigned] = ACTIONS(3112),
    [anon_sym_long] = ACTIONS(3112),
    [anon_sym_short] = ACTIONS(3112),
    [anon_sym_LBRACK] = ACTIONS(3112),
    [anon_sym_static] = ACTIONS(3112),
    [anon_sym_register] = ACTIONS(3112),
    [anon_sym_inline] = ACTIONS(3112),
    [anon_sym___inline] = ACTIONS(3112),
    [anon_sym___inline__] = ACTIONS(3112),
    [anon_sym___forceinline] = ACTIONS(3112),
    [anon_sym_thread_local] = ACTIONS(3112),
    [anon_sym___thread] = ACTIONS(3112),
    [anon_sym_const] = ACTIONS(3112),
    [anon_sym_constexpr] = ACTIONS(3112),
    [anon_sym_volatile] = ACTIONS(3112),
    [anon_sym_restrict] = ACTIONS(3112),
    [anon_sym___restrict__] = ACTIONS(3112),
    [anon_sym__Atomic] = ACTIONS(3112),
    [anon_sym__Noreturn] = ACTIONS(3112),
    [anon_sym_noreturn] = ACTIONS(3112),
    [anon_sym__Nonnull] = ACTIONS(3112),
    [anon_sym_mutable] = ACTIONS(3112),
    [anon_sym_constinit] = ACTIONS(3112),
    [anon_sym_consteval] = ACTIONS(3112),
    [anon_sym_alignas] = ACTIONS(3112),
    [anon_sym__Alignas] = ACTIONS(3112),
    [sym_primitive_type] = ACTIONS(3112),
    [anon_sym_enum] = ACTIONS(3112),
    [anon_sym_class] = ACTIONS(3112),
    [anon_sym_struct] = ACTIONS(3112),
    [anon_sym_union] = ACTIONS(3112),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3112),
    [anon_sym_decltype] = ACTIONS(3112),
    [anon_sym_explicit] = ACTIONS(3112),
    [anon_sym_typename] = ACTIONS(3112),
    [anon_sym_private] = ACTIONS(3112),
    [anon_sym_template] = ACTIONS(3112),
    [anon_sym_operator] = ACTIONS(3112),
    [anon_sym_friend] = ACTIONS(3112),
    [anon_sym_public] = ACTIONS(3112),
    [anon_sym_protected] = ACTIONS(3112),
    [anon_sym_static_assert] = ACTIONS(3112),
  },
  [2145] = {
    [sym_identifier] = ACTIONS(2903),
    [aux_sym_preproc_def_token1] = ACTIONS(2903),
    [aux_sym_preproc_if_token1] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2903),
    [sym_preproc_directive] = ACTIONS(2903),
    [anon_sym_LPAREN2] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2903),
    [anon_sym_typedef] = ACTIONS(2903),
    [anon_sym_virtual] = ACTIONS(2903),
    [anon_sym_extern] = ACTIONS(2903),
    [anon_sym___attribute__] = ACTIONS(2903),
    [anon_sym___attribute] = ACTIONS(2903),
    [anon_sym_using] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2905),
    [anon_sym___declspec] = ACTIONS(2903),
    [anon_sym___based] = ACTIONS(2903),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_signed] = ACTIONS(2903),
    [anon_sym_unsigned] = ACTIONS(2903),
    [anon_sym_long] = ACTIONS(2903),
    [anon_sym_short] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_register] = ACTIONS(2903),
    [anon_sym_inline] = ACTIONS(2903),
    [anon_sym___inline] = ACTIONS(2903),
    [anon_sym___inline__] = ACTIONS(2903),
    [anon_sym___forceinline] = ACTIONS(2903),
    [anon_sym_thread_local] = ACTIONS(2903),
    [anon_sym___thread] = ACTIONS(2903),
    [anon_sym_const] = ACTIONS(2903),
    [anon_sym_constexpr] = ACTIONS(2903),
    [anon_sym_volatile] = ACTIONS(2903),
    [anon_sym_restrict] = ACTIONS(2903),
    [anon_sym___restrict__] = ACTIONS(2903),
    [anon_sym__Atomic] = ACTIONS(2903),
    [anon_sym__Noreturn] = ACTIONS(2903),
    [anon_sym_noreturn] = ACTIONS(2903),
    [anon_sym__Nonnull] = ACTIONS(2903),
    [anon_sym_mutable] = ACTIONS(2903),
    [anon_sym_constinit] = ACTIONS(2903),
    [anon_sym_consteval] = ACTIONS(2903),
    [anon_sym_alignas] = ACTIONS(2903),
    [anon_sym__Alignas] = ACTIONS(2903),
    [sym_primitive_type] = ACTIONS(2903),
    [anon_sym_enum] = ACTIONS(2903),
    [anon_sym_class] = ACTIONS(2903),
    [anon_sym_struct] = ACTIONS(2903),
    [anon_sym_union] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2903),
    [anon_sym_decltype] = ACTIONS(2903),
    [anon_sym_explicit] = ACTIONS(2903),
    [anon_sym_typename] = ACTIONS(2903),
    [anon_sym_private] = ACTIONS(2903),
    [anon_sym_template] = ACTIONS(2903),
    [anon_sym_operator] = ACTIONS(2903),
    [anon_sym_friend] = ACTIONS(2903),
    [anon_sym_public] = ACTIONS(2903),
    [anon_sym_protected] = ACTIONS(2903),
    [anon_sym_static_assert] = ACTIONS(2903),
  },
  [2146] = {
    [sym_identifier] = ACTIONS(5537),
    [aux_sym_preproc_def_token1] = ACTIONS(5537),
    [aux_sym_preproc_if_token1] = ACTIONS(5537),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5537),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5537),
    [sym_preproc_directive] = ACTIONS(5537),
    [anon_sym_LPAREN2] = ACTIONS(5539),
    [anon_sym_TILDE] = ACTIONS(5539),
    [anon_sym_STAR] = ACTIONS(5539),
    [anon_sym_AMP_AMP] = ACTIONS(5539),
    [anon_sym_AMP] = ACTIONS(5537),
    [anon_sym_SEMI] = ACTIONS(5539),
    [anon_sym___extension__] = ACTIONS(5537),
    [anon_sym_typedef] = ACTIONS(5537),
    [anon_sym_virtual] = ACTIONS(5537),
    [anon_sym_extern] = ACTIONS(5537),
    [anon_sym___attribute__] = ACTIONS(5537),
    [anon_sym___attribute] = ACTIONS(5537),
    [anon_sym_using] = ACTIONS(5537),
    [anon_sym_COLON_COLON] = ACTIONS(5539),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5539),
    [anon_sym___declspec] = ACTIONS(5537),
    [anon_sym___based] = ACTIONS(5537),
    [anon_sym_RBRACE] = ACTIONS(5539),
    [anon_sym_signed] = ACTIONS(5537),
    [anon_sym_unsigned] = ACTIONS(5537),
    [anon_sym_long] = ACTIONS(5537),
    [anon_sym_short] = ACTIONS(5537),
    [anon_sym_LBRACK] = ACTIONS(5537),
    [anon_sym_static] = ACTIONS(5537),
    [anon_sym_register] = ACTIONS(5537),
    [anon_sym_inline] = ACTIONS(5537),
    [anon_sym___inline] = ACTIONS(5537),
    [anon_sym___inline__] = ACTIONS(5537),
    [anon_sym___forceinline] = ACTIONS(5537),
    [anon_sym_thread_local] = ACTIONS(5537),
    [anon_sym___thread] = ACTIONS(5537),
    [anon_sym_const] = ACTIONS(5537),
    [anon_sym_constexpr] = ACTIONS(5537),
    [anon_sym_volatile] = ACTIONS(5537),
    [anon_sym_restrict] = ACTIONS(5537),
    [anon_sym___restrict__] = ACTIONS(5537),
    [anon_sym__Atomic] = ACTIONS(5537),
    [anon_sym__Noreturn] = ACTIONS(5537),
    [anon_sym_noreturn] = ACTIONS(5537),
    [anon_sym__Nonnull] = ACTIONS(5537),
    [anon_sym_mutable] = ACTIONS(5537),
    [anon_sym_constinit] = ACTIONS(5537),
    [anon_sym_consteval] = ACTIONS(5537),
    [anon_sym_alignas] = ACTIONS(5537),
    [anon_sym__Alignas] = ACTIONS(5537),
    [sym_primitive_type] = ACTIONS(5537),
    [anon_sym_enum] = ACTIONS(5537),
    [anon_sym_class] = ACTIONS(5537),
    [anon_sym_struct] = ACTIONS(5537),
    [anon_sym_union] = ACTIONS(5537),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5537),
    [anon_sym_decltype] = ACTIONS(5537),
    [anon_sym_explicit] = ACTIONS(5537),
    [anon_sym_typename] = ACTIONS(5537),
    [anon_sym_private] = ACTIONS(5537),
    [anon_sym_template] = ACTIONS(5537),
    [anon_sym_operator] = ACTIONS(5537),
    [anon_sym_friend] = ACTIONS(5537),
    [anon_sym_public] = ACTIONS(5537),
    [anon_sym_protected] = ACTIONS(5537),
    [anon_sym_static_assert] = ACTIONS(5537),
  },
  [2147] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym___attribute] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym__Nonnull] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym__Alignas] = ACTIONS(2783),
    [sym_primitive_type] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_private] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_friend] = ACTIONS(2783),
    [anon_sym_public] = ACTIONS(2783),
    [anon_sym_protected] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
  },
  [2148] = {
    [sym_identifier] = ACTIONS(3083),
    [aux_sym_preproc_def_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token2] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3083),
    [sym_preproc_directive] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym___extension__] = ACTIONS(3083),
    [anon_sym_typedef] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym___attribute__] = ACTIONS(3083),
    [anon_sym___attribute] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3085),
    [anon_sym___declspec] = ACTIONS(3083),
    [anon_sym___based] = ACTIONS(3083),
    [anon_sym_signed] = ACTIONS(3083),
    [anon_sym_unsigned] = ACTIONS(3083),
    [anon_sym_long] = ACTIONS(3083),
    [anon_sym_short] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_register] = ACTIONS(3083),
    [anon_sym_inline] = ACTIONS(3083),
    [anon_sym___inline] = ACTIONS(3083),
    [anon_sym___inline__] = ACTIONS(3083),
    [anon_sym___forceinline] = ACTIONS(3083),
    [anon_sym_thread_local] = ACTIONS(3083),
    [anon_sym___thread] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_constexpr] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_restrict] = ACTIONS(3083),
    [anon_sym___restrict__] = ACTIONS(3083),
    [anon_sym__Atomic] = ACTIONS(3083),
    [anon_sym__Noreturn] = ACTIONS(3083),
    [anon_sym_noreturn] = ACTIONS(3083),
    [anon_sym__Nonnull] = ACTIONS(3083),
    [anon_sym_mutable] = ACTIONS(3083),
    [anon_sym_constinit] = ACTIONS(3083),
    [anon_sym_consteval] = ACTIONS(3083),
    [anon_sym_alignas] = ACTIONS(3083),
    [anon_sym__Alignas] = ACTIONS(3083),
    [sym_primitive_type] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3083),
    [anon_sym_union] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3083),
    [anon_sym_decltype] = ACTIONS(3083),
    [anon_sym_explicit] = ACTIONS(3083),
    [anon_sym_typename] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_template] = ACTIONS(3083),
    [anon_sym_operator] = ACTIONS(3083),
    [anon_sym_friend] = ACTIONS(3083),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_static_assert] = ACTIONS(3083),
  },
  [2149] = {
    [sym_ms_based_modifier] = STATE(8106),
    [sym_ms_unaligned_ptr_modifier] = STATE(4043),
    [sym_ms_pointer_modifier] = STATE(2155),
    [sym__declarator] = STATE(6313),
    [sym__abstract_declarator] = STATE(6648),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_function_declarator] = STATE(5998),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_array_declarator] = STATE(5998),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_type_qualifier] = STATE(2663),
    [sym_alignas_qualifier] = STATE(4289),
    [sym_parameter_list] = STATE(3223),
    [sym_decltype] = STATE(8601),
    [sym_reference_declarator] = STATE(5998),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5860),
    [sym_qualified_identifier] = STATE(5998),
    [sym_operator_name] = STATE(5998),
    [aux_sym__type_definition_type_repeat1] = STATE(2663),
    [aux_sym_pointer_declarator_repeat1] = STATE(2155),
    [sym_identifier] = ACTIONS(5849),
    [anon_sym_COMMA] = ACTIONS(5851),
    [anon_sym_RPAREN] = ACTIONS(5851),
    [anon_sym_LPAREN2] = ACTIONS(4298),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(6032),
    [anon_sym_AMP_AMP] = ACTIONS(6034),
    [anon_sym_AMP] = ACTIONS(6036),
    [anon_sym___extension__] = ACTIONS(3331),
    [anon_sym___attribute__] = ACTIONS(5859),
    [anon_sym___attribute] = ACTIONS(5859),
    [anon_sym_COLON_COLON] = ACTIONS(5861),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(3327),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3327),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3327),
    [anon_sym__unaligned] = ACTIONS(3329),
    [anon_sym___unaligned] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(5863),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_constexpr] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_restrict] = ACTIONS(3331),
    [anon_sym___restrict__] = ACTIONS(3331),
    [anon_sym__Atomic] = ACTIONS(3331),
    [anon_sym__Noreturn] = ACTIONS(3331),
    [anon_sym_noreturn] = ACTIONS(3331),
    [anon_sym__Nonnull] = ACTIONS(3331),
    [anon_sym_mutable] = ACTIONS(3331),
    [anon_sym_constinit] = ACTIONS(3331),
    [anon_sym_consteval] = ACTIONS(3331),
    [anon_sym_alignas] = ACTIONS(3333),
    [anon_sym__Alignas] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [2150] = {
    [sym_identifier] = ACTIONS(2827),
    [aux_sym_preproc_def_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2827),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2827),
    [sym_preproc_directive] = ACTIONS(2827),
    [anon_sym_LPAREN2] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym___extension__] = ACTIONS(2827),
    [anon_sym_typedef] = ACTIONS(2827),
    [anon_sym_virtual] = ACTIONS(2827),
    [anon_sym_extern] = ACTIONS(2827),
    [anon_sym___attribute__] = ACTIONS(2827),
    [anon_sym___attribute] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2829),
    [anon_sym___declspec] = ACTIONS(2827),
    [anon_sym___based] = ACTIONS(2827),
    [anon_sym_signed] = ACTIONS(2827),
    [anon_sym_unsigned] = ACTIONS(2827),
    [anon_sym_long] = ACTIONS(2827),
    [anon_sym_short] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_static] = ACTIONS(2827),
    [anon_sym_register] = ACTIONS(2827),
    [anon_sym_inline] = ACTIONS(2827),
    [anon_sym___inline] = ACTIONS(2827),
    [anon_sym___inline__] = ACTIONS(2827),
    [anon_sym___forceinline] = ACTIONS(2827),
    [anon_sym_thread_local] = ACTIONS(2827),
    [anon_sym___thread] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_constexpr] = ACTIONS(2827),
    [anon_sym_volatile] = ACTIONS(2827),
    [anon_sym_restrict] = ACTIONS(2827),
    [anon_sym___restrict__] = ACTIONS(2827),
    [anon_sym__Atomic] = ACTIONS(2827),
    [anon_sym__Noreturn] = ACTIONS(2827),
    [anon_sym_noreturn] = ACTIONS(2827),
    [anon_sym__Nonnull] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_constinit] = ACTIONS(2827),
    [anon_sym_consteval] = ACTIONS(2827),
    [anon_sym_alignas] = ACTIONS(2827),
    [anon_sym__Alignas] = ACTIONS(2827),
    [sym_primitive_type] = ACTIONS(2827),
    [anon_sym_enum] = ACTIONS(2827),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_union] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2827),
    [anon_sym_decltype] = ACTIONS(2827),
    [anon_sym_explicit] = ACTIONS(2827),
    [anon_sym_typename] = ACTIONS(2827),
    [anon_sym_private] = ACTIONS(2827),
    [anon_sym_template] = ACTIONS(2827),
    [anon_sym_operator] = ACTIONS(2827),
    [anon_sym_friend] = ACTIONS(2827),
    [anon_sym_public] = ACTIONS(2827),
    [anon_sym_protected] = ACTIONS(2827),
    [anon_sym_static_assert] = ACTIONS(2827),
  },
  [2151] = {
    [sym_identifier] = ACTIONS(5509),
    [aux_sym_preproc_def_token1] = ACTIONS(5509),
    [aux_sym_preproc_if_token1] = ACTIONS(5509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5509),
    [sym_preproc_directive] = ACTIONS(5509),
    [anon_sym_LPAREN2] = ACTIONS(5511),
    [anon_sym_TILDE] = ACTIONS(5511),
    [anon_sym_STAR] = ACTIONS(5511),
    [anon_sym_AMP_AMP] = ACTIONS(5511),
    [anon_sym_AMP] = ACTIONS(5509),
    [anon_sym_SEMI] = ACTIONS(5511),
    [anon_sym___extension__] = ACTIONS(5509),
    [anon_sym_typedef] = ACTIONS(5509),
    [anon_sym_virtual] = ACTIONS(5509),
    [anon_sym_extern] = ACTIONS(5509),
    [anon_sym___attribute__] = ACTIONS(5509),
    [anon_sym___attribute] = ACTIONS(5509),
    [anon_sym_using] = ACTIONS(5509),
    [anon_sym_COLON_COLON] = ACTIONS(5511),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5511),
    [anon_sym___declspec] = ACTIONS(5509),
    [anon_sym___based] = ACTIONS(5509),
    [anon_sym_RBRACE] = ACTIONS(5511),
    [anon_sym_signed] = ACTIONS(5509),
    [anon_sym_unsigned] = ACTIONS(5509),
    [anon_sym_long] = ACTIONS(5509),
    [anon_sym_short] = ACTIONS(5509),
    [anon_sym_LBRACK] = ACTIONS(5509),
    [anon_sym_static] = ACTIONS(5509),
    [anon_sym_register] = ACTIONS(5509),
    [anon_sym_inline] = ACTIONS(5509),
    [anon_sym___inline] = ACTIONS(5509),
    [anon_sym___inline__] = ACTIONS(5509),
    [anon_sym___forceinline] = ACTIONS(5509),
    [anon_sym_thread_local] = ACTIONS(5509),
    [anon_sym___thread] = ACTIONS(5509),
    [anon_sym_const] = ACTIONS(5509),
    [anon_sym_constexpr] = ACTIONS(5509),
    [anon_sym_volatile] = ACTIONS(5509),
    [anon_sym_restrict] = ACTIONS(5509),
    [anon_sym___restrict__] = ACTIONS(5509),
    [anon_sym__Atomic] = ACTIONS(5509),
    [anon_sym__Noreturn] = ACTIONS(5509),
    [anon_sym_noreturn] = ACTIONS(5509),
    [anon_sym__Nonnull] = ACTIONS(5509),
    [anon_sym_mutable] = ACTIONS(5509),
    [anon_sym_constinit] = ACTIONS(5509),
    [anon_sym_consteval] = ACTIONS(5509),
    [anon_sym_alignas] = ACTIONS(5509),
    [anon_sym__Alignas] = ACTIONS(5509),
    [sym_primitive_type] = ACTIONS(5509),
    [anon_sym_enum] = ACTIONS(5509),
    [anon_sym_class] = ACTIONS(5509),
    [anon_sym_struct] = ACTIONS(5509),
    [anon_sym_union] = ACTIONS(5509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5509),
    [anon_sym_decltype] = ACTIONS(5509),
    [anon_sym_explicit] = ACTIONS(5509),
    [anon_sym_typename] = ACTIONS(5509),
    [anon_sym_private] = ACTIONS(5509),
    [anon_sym_template] = ACTIONS(5509),
    [anon_sym_operator] = ACTIONS(5509),
    [anon_sym_friend] = ACTIONS(5509),
    [anon_sym_public] = ACTIONS(5509),
    [anon_sym_protected] = ACTIONS(5509),
    [anon_sym_static_assert] = ACTIONS(5509),
  },
  [2152] = {
    [sym_identifier] = ACTIONS(5517),
    [aux_sym_preproc_def_token1] = ACTIONS(5517),
    [aux_sym_preproc_if_token1] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5517),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5517),
    [sym_preproc_directive] = ACTIONS(5517),
    [anon_sym_LPAREN2] = ACTIONS(5519),
    [anon_sym_TILDE] = ACTIONS(5519),
    [anon_sym_STAR] = ACTIONS(5519),
    [anon_sym_AMP_AMP] = ACTIONS(5519),
    [anon_sym_AMP] = ACTIONS(5517),
    [anon_sym_SEMI] = ACTIONS(5519),
    [anon_sym___extension__] = ACTIONS(5517),
    [anon_sym_typedef] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5517),
    [anon_sym___attribute__] = ACTIONS(5517),
    [anon_sym___attribute] = ACTIONS(5517),
    [anon_sym_using] = ACTIONS(5517),
    [anon_sym_COLON_COLON] = ACTIONS(5519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5519),
    [anon_sym___declspec] = ACTIONS(5517),
    [anon_sym___based] = ACTIONS(5517),
    [anon_sym_RBRACE] = ACTIONS(5519),
    [anon_sym_signed] = ACTIONS(5517),
    [anon_sym_unsigned] = ACTIONS(5517),
    [anon_sym_long] = ACTIONS(5517),
    [anon_sym_short] = ACTIONS(5517),
    [anon_sym_LBRACK] = ACTIONS(5517),
    [anon_sym_static] = ACTIONS(5517),
    [anon_sym_register] = ACTIONS(5517),
    [anon_sym_inline] = ACTIONS(5517),
    [anon_sym___inline] = ACTIONS(5517),
    [anon_sym___inline__] = ACTIONS(5517),
    [anon_sym___forceinline] = ACTIONS(5517),
    [anon_sym_thread_local] = ACTIONS(5517),
    [anon_sym___thread] = ACTIONS(5517),
    [anon_sym_const] = ACTIONS(5517),
    [anon_sym_constexpr] = ACTIONS(5517),
    [anon_sym_volatile] = ACTIONS(5517),
    [anon_sym_restrict] = ACTIONS(5517),
    [anon_sym___restrict__] = ACTIONS(5517),
    [anon_sym__Atomic] = ACTIONS(5517),
    [anon_sym__Noreturn] = ACTIONS(5517),
    [anon_sym_noreturn] = ACTIONS(5517),
    [anon_sym__Nonnull] = ACTIONS(5517),
    [anon_sym_mutable] = ACTIONS(5517),
    [anon_sym_constinit] = ACTIONS(5517),
    [anon_sym_consteval] = ACTIONS(5517),
    [anon_sym_alignas] = ACTIONS(5517),
    [anon_sym__Alignas] = ACTIONS(5517),
    [sym_primitive_type] = ACTIONS(5517),
    [anon_sym_enum] = ACTIONS(5517),
    [anon_sym_class] = ACTIONS(5517),
    [anon_sym_struct] = ACTIONS(5517),
    [anon_sym_union] = ACTIONS(5517),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5517),
    [anon_sym_decltype] = ACTIONS(5517),
    [anon_sym_explicit] = ACTIONS(5517),
    [anon_sym_typename] = ACTIONS(5517),
    [anon_sym_private] = ACTIONS(5517),
    [anon_sym_template] = ACTIONS(5517),
    [anon_sym_operator] = ACTIONS(5517),
    [anon_sym_friend] = ACTIONS(5517),
    [anon_sym_public] = ACTIONS(5517),
    [anon_sym_protected] = ACTIONS(5517),
    [anon_sym_static_assert] = ACTIONS(5517),
  },
  [2153] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_friend] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
  },
  [2154] = {
    [sym_identifier] = ACTIONS(2843),
    [aux_sym_preproc_def_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token1] = ACTIONS(2843),
    [aux_sym_preproc_if_token2] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2843),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2843),
    [sym_preproc_directive] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym___extension__] = ACTIONS(2843),
    [anon_sym_typedef] = ACTIONS(2843),
    [anon_sym_virtual] = ACTIONS(2843),
    [anon_sym_extern] = ACTIONS(2843),
    [anon_sym___attribute__] = ACTIONS(2843),
    [anon_sym___attribute] = ACTIONS(2843),
    [anon_sym_using] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2845),
    [anon_sym___declspec] = ACTIONS(2843),
    [anon_sym___based] = ACTIONS(2843),
    [anon_sym_signed] = ACTIONS(2843),
    [anon_sym_unsigned] = ACTIONS(2843),
    [anon_sym_long] = ACTIONS(2843),
    [anon_sym_short] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_register] = ACTIONS(2843),
    [anon_sym_inline] = ACTIONS(2843),
    [anon_sym___inline] = ACTIONS(2843),
    [anon_sym___inline__] = ACTIONS(2843),
    [anon_sym___forceinline] = ACTIONS(2843),
    [anon_sym_thread_local] = ACTIONS(2843),
    [anon_sym___thread] = ACTIONS(2843),
    [anon_sym_const] = ACTIONS(2843),
    [anon_sym_constexpr] = ACTIONS(2843),
    [anon_sym_volatile] = ACTIONS(2843),
    [anon_sym_restrict] = ACTIONS(2843),
    [anon_sym___restrict__] = ACTIONS(2843),
    [anon_sym__Atomic] = ACTIONS(2843),
    [anon_sym__Noreturn] = ACTIONS(2843),
    [anon_sym_noreturn] = ACTIONS(2843),
    [anon_sym__Nonnull] = ACTIONS(2843),
    [anon_sym_mutable] = ACTIONS(2843),
    [anon_sym_constinit] = ACTIONS(2843),
    [anon_sym_consteval] = ACTIONS(2843),
    [anon_sym_alignas] = ACTIONS(2843),
    [anon_sym__Alignas] = ACTIONS(2843),
    [sym_primitive_type] = ACTIONS(2843),
    [anon_sym_enum] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2843),
    [anon_sym_struct] = ACTIONS(2843),
    [anon_sym_union] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2843),
    [anon_sym_decltype] = ACTIONS(2843),
    [anon_sym_explicit] = ACTIONS(2843),
    [anon_sym_typename] = ACTIONS(2843),
    [anon_sym_private] = ACTIONS(2843),
    [anon_sym_template] = ACTIONS(2843),
    [anon_sym_operator] = ACTIONS(2843),
    [anon_sym_friend] = ACTIONS(2843),
    [anon_sym_public] = ACTIONS(2843),
    [anon_sym_protected] = ACTIONS(2843),
    [anon_sym_static_assert] = ACTIONS(2843),
  },
  [2155] = {
    [sym_ms_based_modifier] = STATE(8106),
    [sym_ms_unaligned_ptr_modifier] = STATE(4043),
    [sym_ms_pointer_modifier] = STATE(3820),
    [sym__declarator] = STATE(6349),
    [sym__abstract_declarator] = STATE(6654),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_function_declarator] = STATE(5998),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_array_declarator] = STATE(5998),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_type_qualifier] = STATE(2664),
    [sym_alignas_qualifier] = STATE(4289),
    [sym_parameter_list] = STATE(3223),
    [sym_decltype] = STATE(8601),
    [sym_reference_declarator] = STATE(5998),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5860),
    [sym_qualified_identifier] = STATE(5998),
    [sym_operator_name] = STATE(5998),
    [aux_sym__type_definition_type_repeat1] = STATE(2664),
    [aux_sym_pointer_declarator_repeat1] = STATE(3820),
    [sym_identifier] = ACTIONS(5849),
    [anon_sym_COMMA] = ACTIONS(5865),
    [anon_sym_RPAREN] = ACTIONS(5865),
    [anon_sym_LPAREN2] = ACTIONS(4298),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(6032),
    [anon_sym_AMP_AMP] = ACTIONS(6034),
    [anon_sym_AMP] = ACTIONS(6036),
    [anon_sym___extension__] = ACTIONS(3331),
    [anon_sym___attribute__] = ACTIONS(5867),
    [anon_sym___attribute] = ACTIONS(5867),
    [anon_sym_COLON_COLON] = ACTIONS(5861),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(3327),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3327),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3327),
    [anon_sym__unaligned] = ACTIONS(3329),
    [anon_sym___unaligned] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(5863),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_constexpr] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_restrict] = ACTIONS(3331),
    [anon_sym___restrict__] = ACTIONS(3331),
    [anon_sym__Atomic] = ACTIONS(3331),
    [anon_sym__Noreturn] = ACTIONS(3331),
    [anon_sym_noreturn] = ACTIONS(3331),
    [anon_sym__Nonnull] = ACTIONS(3331),
    [anon_sym_mutable] = ACTIONS(3331),
    [anon_sym_constinit] = ACTIONS(3331),
    [anon_sym_consteval] = ACTIONS(3331),
    [anon_sym_alignas] = ACTIONS(3333),
    [anon_sym__Alignas] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [2156] = {
    [sym_identifier] = ACTIONS(2847),
    [aux_sym_preproc_def_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token1] = ACTIONS(2847),
    [aux_sym_preproc_if_token2] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2847),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2847),
    [sym_preproc_directive] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_AMP_AMP] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_SEMI] = ACTIONS(2849),
    [anon_sym___extension__] = ACTIONS(2847),
    [anon_sym_typedef] = ACTIONS(2847),
    [anon_sym_virtual] = ACTIONS(2847),
    [anon_sym_extern] = ACTIONS(2847),
    [anon_sym___attribute__] = ACTIONS(2847),
    [anon_sym___attribute] = ACTIONS(2847),
    [anon_sym_using] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2849),
    [anon_sym___declspec] = ACTIONS(2847),
    [anon_sym___based] = ACTIONS(2847),
    [anon_sym_signed] = ACTIONS(2847),
    [anon_sym_unsigned] = ACTIONS(2847),
    [anon_sym_long] = ACTIONS(2847),
    [anon_sym_short] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2847),
    [anon_sym_register] = ACTIONS(2847),
    [anon_sym_inline] = ACTIONS(2847),
    [anon_sym___inline] = ACTIONS(2847),
    [anon_sym___inline__] = ACTIONS(2847),
    [anon_sym___forceinline] = ACTIONS(2847),
    [anon_sym_thread_local] = ACTIONS(2847),
    [anon_sym___thread] = ACTIONS(2847),
    [anon_sym_const] = ACTIONS(2847),
    [anon_sym_constexpr] = ACTIONS(2847),
    [anon_sym_volatile] = ACTIONS(2847),
    [anon_sym_restrict] = ACTIONS(2847),
    [anon_sym___restrict__] = ACTIONS(2847),
    [anon_sym__Atomic] = ACTIONS(2847),
    [anon_sym__Noreturn] = ACTIONS(2847),
    [anon_sym_noreturn] = ACTIONS(2847),
    [anon_sym__Nonnull] = ACTIONS(2847),
    [anon_sym_mutable] = ACTIONS(2847),
    [anon_sym_constinit] = ACTIONS(2847),
    [anon_sym_consteval] = ACTIONS(2847),
    [anon_sym_alignas] = ACTIONS(2847),
    [anon_sym__Alignas] = ACTIONS(2847),
    [sym_primitive_type] = ACTIONS(2847),
    [anon_sym_enum] = ACTIONS(2847),
    [anon_sym_class] = ACTIONS(2847),
    [anon_sym_struct] = ACTIONS(2847),
    [anon_sym_union] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2847),
    [anon_sym_decltype] = ACTIONS(2847),
    [anon_sym_explicit] = ACTIONS(2847),
    [anon_sym_typename] = ACTIONS(2847),
    [anon_sym_private] = ACTIONS(2847),
    [anon_sym_template] = ACTIONS(2847),
    [anon_sym_operator] = ACTIONS(2847),
    [anon_sym_friend] = ACTIONS(2847),
    [anon_sym_public] = ACTIONS(2847),
    [anon_sym_protected] = ACTIONS(2847),
    [anon_sym_static_assert] = ACTIONS(2847),
  },
  [2157] = {
    [sym_identifier] = ACTIONS(3089),
    [aux_sym_preproc_def_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token2] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3089),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3089),
    [sym_preproc_directive] = ACTIONS(3089),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3091),
    [anon_sym_STAR] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym___extension__] = ACTIONS(3089),
    [anon_sym_typedef] = ACTIONS(3089),
    [anon_sym_virtual] = ACTIONS(3089),
    [anon_sym_extern] = ACTIONS(3089),
    [anon_sym___attribute__] = ACTIONS(3089),
    [anon_sym___attribute] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_COLON_COLON] = ACTIONS(3091),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3091),
    [anon_sym___declspec] = ACTIONS(3089),
    [anon_sym___based] = ACTIONS(3089),
    [anon_sym_signed] = ACTIONS(3089),
    [anon_sym_unsigned] = ACTIONS(3089),
    [anon_sym_long] = ACTIONS(3089),
    [anon_sym_short] = ACTIONS(3089),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3089),
    [anon_sym_register] = ACTIONS(3089),
    [anon_sym_inline] = ACTIONS(3089),
    [anon_sym___inline] = ACTIONS(3089),
    [anon_sym___inline__] = ACTIONS(3089),
    [anon_sym___forceinline] = ACTIONS(3089),
    [anon_sym_thread_local] = ACTIONS(3089),
    [anon_sym___thread] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_constexpr] = ACTIONS(3089),
    [anon_sym_volatile] = ACTIONS(3089),
    [anon_sym_restrict] = ACTIONS(3089),
    [anon_sym___restrict__] = ACTIONS(3089),
    [anon_sym__Atomic] = ACTIONS(3089),
    [anon_sym__Noreturn] = ACTIONS(3089),
    [anon_sym_noreturn] = ACTIONS(3089),
    [anon_sym__Nonnull] = ACTIONS(3089),
    [anon_sym_mutable] = ACTIONS(3089),
    [anon_sym_constinit] = ACTIONS(3089),
    [anon_sym_consteval] = ACTIONS(3089),
    [anon_sym_alignas] = ACTIONS(3089),
    [anon_sym__Alignas] = ACTIONS(3089),
    [sym_primitive_type] = ACTIONS(3089),
    [anon_sym_enum] = ACTIONS(3089),
    [anon_sym_class] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_union] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3089),
    [anon_sym_decltype] = ACTIONS(3089),
    [anon_sym_explicit] = ACTIONS(3089),
    [anon_sym_typename] = ACTIONS(3089),
    [anon_sym_private] = ACTIONS(3089),
    [anon_sym_template] = ACTIONS(3089),
    [anon_sym_operator] = ACTIONS(3089),
    [anon_sym_friend] = ACTIONS(3089),
    [anon_sym_public] = ACTIONS(3089),
    [anon_sym_protected] = ACTIONS(3089),
    [anon_sym_static_assert] = ACTIONS(3089),
  },
  [2158] = {
    [sym_identifier] = ACTIONS(5545),
    [aux_sym_preproc_def_token1] = ACTIONS(5545),
    [aux_sym_preproc_if_token1] = ACTIONS(5545),
    [aux_sym_preproc_if_token2] = ACTIONS(5545),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5545),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5545),
    [sym_preproc_directive] = ACTIONS(5545),
    [anon_sym_LPAREN2] = ACTIONS(5547),
    [anon_sym_TILDE] = ACTIONS(5547),
    [anon_sym_STAR] = ACTIONS(5547),
    [anon_sym_AMP_AMP] = ACTIONS(5547),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_SEMI] = ACTIONS(5547),
    [anon_sym___extension__] = ACTIONS(5545),
    [anon_sym_typedef] = ACTIONS(5545),
    [anon_sym_virtual] = ACTIONS(5545),
    [anon_sym_extern] = ACTIONS(5545),
    [anon_sym___attribute__] = ACTIONS(5545),
    [anon_sym___attribute] = ACTIONS(5545),
    [anon_sym_using] = ACTIONS(5545),
    [anon_sym_COLON_COLON] = ACTIONS(5547),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5547),
    [anon_sym___declspec] = ACTIONS(5545),
    [anon_sym___based] = ACTIONS(5545),
    [anon_sym_signed] = ACTIONS(5545),
    [anon_sym_unsigned] = ACTIONS(5545),
    [anon_sym_long] = ACTIONS(5545),
    [anon_sym_short] = ACTIONS(5545),
    [anon_sym_LBRACK] = ACTIONS(5545),
    [anon_sym_static] = ACTIONS(5545),
    [anon_sym_register] = ACTIONS(5545),
    [anon_sym_inline] = ACTIONS(5545),
    [anon_sym___inline] = ACTIONS(5545),
    [anon_sym___inline__] = ACTIONS(5545),
    [anon_sym___forceinline] = ACTIONS(5545),
    [anon_sym_thread_local] = ACTIONS(5545),
    [anon_sym___thread] = ACTIONS(5545),
    [anon_sym_const] = ACTIONS(5545),
    [anon_sym_constexpr] = ACTIONS(5545),
    [anon_sym_volatile] = ACTIONS(5545),
    [anon_sym_restrict] = ACTIONS(5545),
    [anon_sym___restrict__] = ACTIONS(5545),
    [anon_sym__Atomic] = ACTIONS(5545),
    [anon_sym__Noreturn] = ACTIONS(5545),
    [anon_sym_noreturn] = ACTIONS(5545),
    [anon_sym__Nonnull] = ACTIONS(5545),
    [anon_sym_mutable] = ACTIONS(5545),
    [anon_sym_constinit] = ACTIONS(5545),
    [anon_sym_consteval] = ACTIONS(5545),
    [anon_sym_alignas] = ACTIONS(5545),
    [anon_sym__Alignas] = ACTIONS(5545),
    [sym_primitive_type] = ACTIONS(5545),
    [anon_sym_enum] = ACTIONS(5545),
    [anon_sym_class] = ACTIONS(5545),
    [anon_sym_struct] = ACTIONS(5545),
    [anon_sym_union] = ACTIONS(5545),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5545),
    [anon_sym_decltype] = ACTIONS(5545),
    [anon_sym_explicit] = ACTIONS(5545),
    [anon_sym_typename] = ACTIONS(5545),
    [anon_sym_private] = ACTIONS(5545),
    [anon_sym_template] = ACTIONS(5545),
    [anon_sym_operator] = ACTIONS(5545),
    [anon_sym_friend] = ACTIONS(5545),
    [anon_sym_public] = ACTIONS(5545),
    [anon_sym_protected] = ACTIONS(5545),
    [anon_sym_static_assert] = ACTIONS(5545),
  },
  [2159] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1669),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5156),
    [anon_sym_COMMA] = ACTIONS(5156),
    [anon_sym_RPAREN] = ACTIONS(5156),
    [anon_sym_LPAREN2] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5159),
    [anon_sym_PLUS] = ACTIONS(5159),
    [anon_sym_STAR] = ACTIONS(5156),
    [anon_sym_SLASH] = ACTIONS(5159),
    [anon_sym_PERCENT] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE] = ACTIONS(5156),
    [anon_sym_AMP_AMP] = ACTIONS(5156),
    [anon_sym_PIPE] = ACTIONS(5159),
    [anon_sym_CARET] = ACTIONS(5156),
    [anon_sym_AMP] = ACTIONS(5159),
    [anon_sym_EQ_EQ] = ACTIONS(5156),
    [anon_sym_BANG_EQ] = ACTIONS(5156),
    [anon_sym_GT] = ACTIONS(5159),
    [anon_sym_GT_EQ] = ACTIONS(5156),
    [anon_sym_LT_EQ] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5159),
    [anon_sym_LT_LT] = ACTIONS(5156),
    [anon_sym_GT_GT] = ACTIONS(5156),
    [anon_sym_SEMI] = ACTIONS(5156),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5159),
    [anon_sym___attribute] = ACTIONS(5159),
    [anon_sym_COLON] = ACTIONS(5156),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_RBRACE] = ACTIONS(5156),
    [anon_sym_signed] = ACTIONS(5370),
    [anon_sym_unsigned] = ACTIONS(5370),
    [anon_sym_long] = ACTIONS(5370),
    [anon_sym_short] = ACTIONS(5370),
    [anon_sym_LBRACK] = ACTIONS(5156),
    [anon_sym_RBRACK] = ACTIONS(5156),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5156),
    [anon_sym_LT_EQ_GT] = ACTIONS(5156),
    [anon_sym_or] = ACTIONS(5159),
    [anon_sym_and] = ACTIONS(5159),
    [anon_sym_bitor] = ACTIONS(5159),
    [anon_sym_xor] = ACTIONS(5159),
    [anon_sym_bitand] = ACTIONS(5159),
    [anon_sym_not_eq] = ACTIONS(5159),
    [anon_sym_DASH_DASH] = ACTIONS(5156),
    [anon_sym_PLUS_PLUS] = ACTIONS(5156),
    [anon_sym_DOT] = ACTIONS(5159),
    [anon_sym_DOT_STAR] = ACTIONS(5156),
    [anon_sym_DASH_GT] = ACTIONS(5156),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5159),
    [anon_sym_decltype] = ACTIONS(5159),
  },
  [2160] = {
    [sym_identifier] = ACTIONS(2919),
    [aux_sym_preproc_def_token1] = ACTIONS(2919),
    [aux_sym_preproc_if_token1] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2919),
    [sym_preproc_directive] = ACTIONS(2919),
    [anon_sym_LPAREN2] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_STAR] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym___extension__] = ACTIONS(2919),
    [anon_sym_typedef] = ACTIONS(2919),
    [anon_sym_virtual] = ACTIONS(2919),
    [anon_sym_extern] = ACTIONS(2919),
    [anon_sym___attribute__] = ACTIONS(2919),
    [anon_sym___attribute] = ACTIONS(2919),
    [anon_sym_using] = ACTIONS(2919),
    [anon_sym_COLON_COLON] = ACTIONS(2921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2921),
    [anon_sym___declspec] = ACTIONS(2919),
    [anon_sym___based] = ACTIONS(2919),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_signed] = ACTIONS(2919),
    [anon_sym_unsigned] = ACTIONS(2919),
    [anon_sym_long] = ACTIONS(2919),
    [anon_sym_short] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_register] = ACTIONS(2919),
    [anon_sym_inline] = ACTIONS(2919),
    [anon_sym___inline] = ACTIONS(2919),
    [anon_sym___inline__] = ACTIONS(2919),
    [anon_sym___forceinline] = ACTIONS(2919),
    [anon_sym_thread_local] = ACTIONS(2919),
    [anon_sym___thread] = ACTIONS(2919),
    [anon_sym_const] = ACTIONS(2919),
    [anon_sym_constexpr] = ACTIONS(2919),
    [anon_sym_volatile] = ACTIONS(2919),
    [anon_sym_restrict] = ACTIONS(2919),
    [anon_sym___restrict__] = ACTIONS(2919),
    [anon_sym__Atomic] = ACTIONS(2919),
    [anon_sym__Noreturn] = ACTIONS(2919),
    [anon_sym_noreturn] = ACTIONS(2919),
    [anon_sym__Nonnull] = ACTIONS(2919),
    [anon_sym_mutable] = ACTIONS(2919),
    [anon_sym_constinit] = ACTIONS(2919),
    [anon_sym_consteval] = ACTIONS(2919),
    [anon_sym_alignas] = ACTIONS(2919),
    [anon_sym__Alignas] = ACTIONS(2919),
    [sym_primitive_type] = ACTIONS(2919),
    [anon_sym_enum] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_struct] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2919),
    [anon_sym_decltype] = ACTIONS(2919),
    [anon_sym_explicit] = ACTIONS(2919),
    [anon_sym_typename] = ACTIONS(2919),
    [anon_sym_private] = ACTIONS(2919),
    [anon_sym_template] = ACTIONS(2919),
    [anon_sym_operator] = ACTIONS(2919),
    [anon_sym_friend] = ACTIONS(2919),
    [anon_sym_public] = ACTIONS(2919),
    [anon_sym_protected] = ACTIONS(2919),
    [anon_sym_static_assert] = ACTIONS(2919),
  },
  [2161] = {
    [sym_identifier] = ACTIONS(2923),
    [aux_sym_preproc_def_token1] = ACTIONS(2923),
    [aux_sym_preproc_if_token1] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2923),
    [sym_preproc_directive] = ACTIONS(2923),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2923),
    [anon_sym_typedef] = ACTIONS(2923),
    [anon_sym_virtual] = ACTIONS(2923),
    [anon_sym_extern] = ACTIONS(2923),
    [anon_sym___attribute__] = ACTIONS(2923),
    [anon_sym___attribute] = ACTIONS(2923),
    [anon_sym_using] = ACTIONS(2923),
    [anon_sym_COLON_COLON] = ACTIONS(2925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2925),
    [anon_sym___declspec] = ACTIONS(2923),
    [anon_sym___based] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_signed] = ACTIONS(2923),
    [anon_sym_unsigned] = ACTIONS(2923),
    [anon_sym_long] = ACTIONS(2923),
    [anon_sym_short] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_register] = ACTIONS(2923),
    [anon_sym_inline] = ACTIONS(2923),
    [anon_sym___inline] = ACTIONS(2923),
    [anon_sym___inline__] = ACTIONS(2923),
    [anon_sym___forceinline] = ACTIONS(2923),
    [anon_sym_thread_local] = ACTIONS(2923),
    [anon_sym___thread] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_constexpr] = ACTIONS(2923),
    [anon_sym_volatile] = ACTIONS(2923),
    [anon_sym_restrict] = ACTIONS(2923),
    [anon_sym___restrict__] = ACTIONS(2923),
    [anon_sym__Atomic] = ACTIONS(2923),
    [anon_sym__Noreturn] = ACTIONS(2923),
    [anon_sym_noreturn] = ACTIONS(2923),
    [anon_sym__Nonnull] = ACTIONS(2923),
    [anon_sym_mutable] = ACTIONS(2923),
    [anon_sym_constinit] = ACTIONS(2923),
    [anon_sym_consteval] = ACTIONS(2923),
    [anon_sym_alignas] = ACTIONS(2923),
    [anon_sym__Alignas] = ACTIONS(2923),
    [sym_primitive_type] = ACTIONS(2923),
    [anon_sym_enum] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2923),
    [anon_sym_union] = ACTIONS(2923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2923),
    [anon_sym_decltype] = ACTIONS(2923),
    [anon_sym_explicit] = ACTIONS(2923),
    [anon_sym_typename] = ACTIONS(2923),
    [anon_sym_private] = ACTIONS(2923),
    [anon_sym_template] = ACTIONS(2923),
    [anon_sym_operator] = ACTIONS(2923),
    [anon_sym_friend] = ACTIONS(2923),
    [anon_sym_public] = ACTIONS(2923),
    [anon_sym_protected] = ACTIONS(2923),
    [anon_sym_static_assert] = ACTIONS(2923),
  },
  [2162] = {
    [sym_identifier] = ACTIONS(2927),
    [aux_sym_preproc_def_token1] = ACTIONS(2927),
    [aux_sym_preproc_if_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2927),
    [sym_preproc_directive] = ACTIONS(2927),
    [anon_sym_LPAREN2] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym___extension__] = ACTIONS(2927),
    [anon_sym_typedef] = ACTIONS(2927),
    [anon_sym_virtual] = ACTIONS(2927),
    [anon_sym_extern] = ACTIONS(2927),
    [anon_sym___attribute__] = ACTIONS(2927),
    [anon_sym___attribute] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2929),
    [anon_sym___declspec] = ACTIONS(2927),
    [anon_sym___based] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_signed] = ACTIONS(2927),
    [anon_sym_unsigned] = ACTIONS(2927),
    [anon_sym_long] = ACTIONS(2927),
    [anon_sym_short] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_register] = ACTIONS(2927),
    [anon_sym_inline] = ACTIONS(2927),
    [anon_sym___inline] = ACTIONS(2927),
    [anon_sym___inline__] = ACTIONS(2927),
    [anon_sym___forceinline] = ACTIONS(2927),
    [anon_sym_thread_local] = ACTIONS(2927),
    [anon_sym___thread] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_constexpr] = ACTIONS(2927),
    [anon_sym_volatile] = ACTIONS(2927),
    [anon_sym_restrict] = ACTIONS(2927),
    [anon_sym___restrict__] = ACTIONS(2927),
    [anon_sym__Atomic] = ACTIONS(2927),
    [anon_sym__Noreturn] = ACTIONS(2927),
    [anon_sym_noreturn] = ACTIONS(2927),
    [anon_sym__Nonnull] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_constinit] = ACTIONS(2927),
    [anon_sym_consteval] = ACTIONS(2927),
    [anon_sym_alignas] = ACTIONS(2927),
    [anon_sym__Alignas] = ACTIONS(2927),
    [sym_primitive_type] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_union] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2927),
    [anon_sym_decltype] = ACTIONS(2927),
    [anon_sym_explicit] = ACTIONS(2927),
    [anon_sym_typename] = ACTIONS(2927),
    [anon_sym_private] = ACTIONS(2927),
    [anon_sym_template] = ACTIONS(2927),
    [anon_sym_operator] = ACTIONS(2927),
    [anon_sym_friend] = ACTIONS(2927),
    [anon_sym_public] = ACTIONS(2927),
    [anon_sym_protected] = ACTIONS(2927),
    [anon_sym_static_assert] = ACTIONS(2927),
  },
  [2163] = {
    [sym_identifier] = ACTIONS(3093),
    [aux_sym_preproc_def_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token2] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3093),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3093),
    [sym_preproc_directive] = ACTIONS(3093),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym___extension__] = ACTIONS(3093),
    [anon_sym_typedef] = ACTIONS(3093),
    [anon_sym_virtual] = ACTIONS(3093),
    [anon_sym_extern] = ACTIONS(3093),
    [anon_sym___attribute__] = ACTIONS(3093),
    [anon_sym___attribute] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_COLON_COLON] = ACTIONS(3095),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3095),
    [anon_sym___declspec] = ACTIONS(3093),
    [anon_sym___based] = ACTIONS(3093),
    [anon_sym_signed] = ACTIONS(3093),
    [anon_sym_unsigned] = ACTIONS(3093),
    [anon_sym_long] = ACTIONS(3093),
    [anon_sym_short] = ACTIONS(3093),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3093),
    [anon_sym_register] = ACTIONS(3093),
    [anon_sym_inline] = ACTIONS(3093),
    [anon_sym___inline] = ACTIONS(3093),
    [anon_sym___inline__] = ACTIONS(3093),
    [anon_sym___forceinline] = ACTIONS(3093),
    [anon_sym_thread_local] = ACTIONS(3093),
    [anon_sym___thread] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_constexpr] = ACTIONS(3093),
    [anon_sym_volatile] = ACTIONS(3093),
    [anon_sym_restrict] = ACTIONS(3093),
    [anon_sym___restrict__] = ACTIONS(3093),
    [anon_sym__Atomic] = ACTIONS(3093),
    [anon_sym__Noreturn] = ACTIONS(3093),
    [anon_sym_noreturn] = ACTIONS(3093),
    [anon_sym__Nonnull] = ACTIONS(3093),
    [anon_sym_mutable] = ACTIONS(3093),
    [anon_sym_constinit] = ACTIONS(3093),
    [anon_sym_consteval] = ACTIONS(3093),
    [anon_sym_alignas] = ACTIONS(3093),
    [anon_sym__Alignas] = ACTIONS(3093),
    [sym_primitive_type] = ACTIONS(3093),
    [anon_sym_enum] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_union] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3093),
    [anon_sym_decltype] = ACTIONS(3093),
    [anon_sym_explicit] = ACTIONS(3093),
    [anon_sym_typename] = ACTIONS(3093),
    [anon_sym_private] = ACTIONS(3093),
    [anon_sym_template] = ACTIONS(3093),
    [anon_sym_operator] = ACTIONS(3093),
    [anon_sym_friend] = ACTIONS(3093),
    [anon_sym_public] = ACTIONS(3093),
    [anon_sym_protected] = ACTIONS(3093),
    [anon_sym_static_assert] = ACTIONS(3093),
  },
  [2164] = {
    [sym_identifier] = ACTIONS(2703),
    [aux_sym_preproc_def_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token1] = ACTIONS(2703),
    [aux_sym_preproc_if_token2] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2703),
    [sym_preproc_directive] = ACTIONS(2703),
    [anon_sym_LPAREN2] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2705),
    [anon_sym___extension__] = ACTIONS(2703),
    [anon_sym_typedef] = ACTIONS(2703),
    [anon_sym_virtual] = ACTIONS(2703),
    [anon_sym_extern] = ACTIONS(2703),
    [anon_sym___attribute__] = ACTIONS(2703),
    [anon_sym___attribute] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2705),
    [anon_sym___declspec] = ACTIONS(2703),
    [anon_sym___based] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2703),
    [anon_sym_unsigned] = ACTIONS(2703),
    [anon_sym_long] = ACTIONS(2703),
    [anon_sym_short] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2703),
    [anon_sym_register] = ACTIONS(2703),
    [anon_sym_inline] = ACTIONS(2703),
    [anon_sym___inline] = ACTIONS(2703),
    [anon_sym___inline__] = ACTIONS(2703),
    [anon_sym___forceinline] = ACTIONS(2703),
    [anon_sym_thread_local] = ACTIONS(2703),
    [anon_sym___thread] = ACTIONS(2703),
    [anon_sym_const] = ACTIONS(2703),
    [anon_sym_constexpr] = ACTIONS(2703),
    [anon_sym_volatile] = ACTIONS(2703),
    [anon_sym_restrict] = ACTIONS(2703),
    [anon_sym___restrict__] = ACTIONS(2703),
    [anon_sym__Atomic] = ACTIONS(2703),
    [anon_sym__Noreturn] = ACTIONS(2703),
    [anon_sym_noreturn] = ACTIONS(2703),
    [anon_sym__Nonnull] = ACTIONS(2703),
    [anon_sym_mutable] = ACTIONS(2703),
    [anon_sym_constinit] = ACTIONS(2703),
    [anon_sym_consteval] = ACTIONS(2703),
    [anon_sym_alignas] = ACTIONS(2703),
    [anon_sym__Alignas] = ACTIONS(2703),
    [sym_primitive_type] = ACTIONS(2703),
    [anon_sym_enum] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2703),
    [anon_sym_struct] = ACTIONS(2703),
    [anon_sym_union] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2703),
    [anon_sym_decltype] = ACTIONS(2703),
    [anon_sym_explicit] = ACTIONS(2703),
    [anon_sym_typename] = ACTIONS(2703),
    [anon_sym_private] = ACTIONS(2703),
    [anon_sym_template] = ACTIONS(2703),
    [anon_sym_operator] = ACTIONS(2703),
    [anon_sym_friend] = ACTIONS(2703),
    [anon_sym_public] = ACTIONS(2703),
    [anon_sym_protected] = ACTIONS(2703),
    [anon_sym_static_assert] = ACTIONS(2703),
  },
  [2165] = {
    [sym_identifier] = ACTIONS(2931),
    [aux_sym_preproc_def_token1] = ACTIONS(2931),
    [aux_sym_preproc_if_token1] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2931),
    [sym_preproc_directive] = ACTIONS(2931),
    [anon_sym_LPAREN2] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym___extension__] = ACTIONS(2931),
    [anon_sym_typedef] = ACTIONS(2931),
    [anon_sym_virtual] = ACTIONS(2931),
    [anon_sym_extern] = ACTIONS(2931),
    [anon_sym___attribute__] = ACTIONS(2931),
    [anon_sym___attribute] = ACTIONS(2931),
    [anon_sym_using] = ACTIONS(2931),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2933),
    [anon_sym___declspec] = ACTIONS(2931),
    [anon_sym___based] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2933),
    [anon_sym_signed] = ACTIONS(2931),
    [anon_sym_unsigned] = ACTIONS(2931),
    [anon_sym_long] = ACTIONS(2931),
    [anon_sym_short] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_register] = ACTIONS(2931),
    [anon_sym_inline] = ACTIONS(2931),
    [anon_sym___inline] = ACTIONS(2931),
    [anon_sym___inline__] = ACTIONS(2931),
    [anon_sym___forceinline] = ACTIONS(2931),
    [anon_sym_thread_local] = ACTIONS(2931),
    [anon_sym___thread] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_constexpr] = ACTIONS(2931),
    [anon_sym_volatile] = ACTIONS(2931),
    [anon_sym_restrict] = ACTIONS(2931),
    [anon_sym___restrict__] = ACTIONS(2931),
    [anon_sym__Atomic] = ACTIONS(2931),
    [anon_sym__Noreturn] = ACTIONS(2931),
    [anon_sym_noreturn] = ACTIONS(2931),
    [anon_sym__Nonnull] = ACTIONS(2931),
    [anon_sym_mutable] = ACTIONS(2931),
    [anon_sym_constinit] = ACTIONS(2931),
    [anon_sym_consteval] = ACTIONS(2931),
    [anon_sym_alignas] = ACTIONS(2931),
    [anon_sym__Alignas] = ACTIONS(2931),
    [sym_primitive_type] = ACTIONS(2931),
    [anon_sym_enum] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2931),
    [anon_sym_struct] = ACTIONS(2931),
    [anon_sym_union] = ACTIONS(2931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2931),
    [anon_sym_decltype] = ACTIONS(2931),
    [anon_sym_explicit] = ACTIONS(2931),
    [anon_sym_typename] = ACTIONS(2931),
    [anon_sym_private] = ACTIONS(2931),
    [anon_sym_template] = ACTIONS(2931),
    [anon_sym_operator] = ACTIONS(2931),
    [anon_sym_friend] = ACTIONS(2931),
    [anon_sym_public] = ACTIONS(2931),
    [anon_sym_protected] = ACTIONS(2931),
    [anon_sym_static_assert] = ACTIONS(2931),
  },
  [2166] = {
    [sym_identifier] = ACTIONS(2935),
    [aux_sym_preproc_def_token1] = ACTIONS(2935),
    [aux_sym_preproc_if_token1] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2935),
    [sym_preproc_directive] = ACTIONS(2935),
    [anon_sym_LPAREN2] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym___extension__] = ACTIONS(2935),
    [anon_sym_typedef] = ACTIONS(2935),
    [anon_sym_virtual] = ACTIONS(2935),
    [anon_sym_extern] = ACTIONS(2935),
    [anon_sym___attribute__] = ACTIONS(2935),
    [anon_sym___attribute] = ACTIONS(2935),
    [anon_sym_using] = ACTIONS(2935),
    [anon_sym_COLON_COLON] = ACTIONS(2937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2937),
    [anon_sym___declspec] = ACTIONS(2935),
    [anon_sym___based] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2937),
    [anon_sym_signed] = ACTIONS(2935),
    [anon_sym_unsigned] = ACTIONS(2935),
    [anon_sym_long] = ACTIONS(2935),
    [anon_sym_short] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_register] = ACTIONS(2935),
    [anon_sym_inline] = ACTIONS(2935),
    [anon_sym___inline] = ACTIONS(2935),
    [anon_sym___inline__] = ACTIONS(2935),
    [anon_sym___forceinline] = ACTIONS(2935),
    [anon_sym_thread_local] = ACTIONS(2935),
    [anon_sym___thread] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_constexpr] = ACTIONS(2935),
    [anon_sym_volatile] = ACTIONS(2935),
    [anon_sym_restrict] = ACTIONS(2935),
    [anon_sym___restrict__] = ACTIONS(2935),
    [anon_sym__Atomic] = ACTIONS(2935),
    [anon_sym__Noreturn] = ACTIONS(2935),
    [anon_sym_noreturn] = ACTIONS(2935),
    [anon_sym__Nonnull] = ACTIONS(2935),
    [anon_sym_mutable] = ACTIONS(2935),
    [anon_sym_constinit] = ACTIONS(2935),
    [anon_sym_consteval] = ACTIONS(2935),
    [anon_sym_alignas] = ACTIONS(2935),
    [anon_sym__Alignas] = ACTIONS(2935),
    [sym_primitive_type] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_union] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2935),
    [anon_sym_decltype] = ACTIONS(2935),
    [anon_sym_explicit] = ACTIONS(2935),
    [anon_sym_typename] = ACTIONS(2935),
    [anon_sym_private] = ACTIONS(2935),
    [anon_sym_template] = ACTIONS(2935),
    [anon_sym_operator] = ACTIONS(2935),
    [anon_sym_friend] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2935),
    [anon_sym_protected] = ACTIONS(2935),
    [anon_sym_static_assert] = ACTIONS(2935),
  },
  [2167] = {
    [sym_identifier] = ACTIONS(2939),
    [aux_sym_preproc_def_token1] = ACTIONS(2939),
    [aux_sym_preproc_if_token1] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2939),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2939),
    [sym_preproc_directive] = ACTIONS(2939),
    [anon_sym_LPAREN2] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2939),
    [anon_sym_typedef] = ACTIONS(2939),
    [anon_sym_virtual] = ACTIONS(2939),
    [anon_sym_extern] = ACTIONS(2939),
    [anon_sym___attribute__] = ACTIONS(2939),
    [anon_sym___attribute] = ACTIONS(2939),
    [anon_sym_using] = ACTIONS(2939),
    [anon_sym_COLON_COLON] = ACTIONS(2941),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2941),
    [anon_sym___declspec] = ACTIONS(2939),
    [anon_sym___based] = ACTIONS(2939),
    [anon_sym_RBRACE] = ACTIONS(2941),
    [anon_sym_signed] = ACTIONS(2939),
    [anon_sym_unsigned] = ACTIONS(2939),
    [anon_sym_long] = ACTIONS(2939),
    [anon_sym_short] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_static] = ACTIONS(2939),
    [anon_sym_register] = ACTIONS(2939),
    [anon_sym_inline] = ACTIONS(2939),
    [anon_sym___inline] = ACTIONS(2939),
    [anon_sym___inline__] = ACTIONS(2939),
    [anon_sym___forceinline] = ACTIONS(2939),
    [anon_sym_thread_local] = ACTIONS(2939),
    [anon_sym___thread] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_constexpr] = ACTIONS(2939),
    [anon_sym_volatile] = ACTIONS(2939),
    [anon_sym_restrict] = ACTIONS(2939),
    [anon_sym___restrict__] = ACTIONS(2939),
    [anon_sym__Atomic] = ACTIONS(2939),
    [anon_sym__Noreturn] = ACTIONS(2939),
    [anon_sym_noreturn] = ACTIONS(2939),
    [anon_sym__Nonnull] = ACTIONS(2939),
    [anon_sym_mutable] = ACTIONS(2939),
    [anon_sym_constinit] = ACTIONS(2939),
    [anon_sym_consteval] = ACTIONS(2939),
    [anon_sym_alignas] = ACTIONS(2939),
    [anon_sym__Alignas] = ACTIONS(2939),
    [sym_primitive_type] = ACTIONS(2939),
    [anon_sym_enum] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2939),
    [anon_sym_struct] = ACTIONS(2939),
    [anon_sym_union] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2939),
    [anon_sym_decltype] = ACTIONS(2939),
    [anon_sym_explicit] = ACTIONS(2939),
    [anon_sym_typename] = ACTIONS(2939),
    [anon_sym_private] = ACTIONS(2939),
    [anon_sym_template] = ACTIONS(2939),
    [anon_sym_operator] = ACTIONS(2939),
    [anon_sym_friend] = ACTIONS(2939),
    [anon_sym_public] = ACTIONS(2939),
    [anon_sym_protected] = ACTIONS(2939),
    [anon_sym_static_assert] = ACTIONS(2939),
  },
  [2168] = {
    [sym_identifier] = ACTIONS(3319),
    [aux_sym_preproc_def_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token2] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3319),
    [sym_preproc_directive] = ACTIONS(3319),
    [anon_sym_LPAREN2] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym___extension__] = ACTIONS(3319),
    [anon_sym_typedef] = ACTIONS(3319),
    [anon_sym_virtual] = ACTIONS(3319),
    [anon_sym_extern] = ACTIONS(3319),
    [anon_sym___attribute__] = ACTIONS(3319),
    [anon_sym___attribute] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_COLON_COLON] = ACTIONS(3321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3321),
    [anon_sym___declspec] = ACTIONS(3319),
    [anon_sym___based] = ACTIONS(3319),
    [anon_sym_signed] = ACTIONS(3319),
    [anon_sym_unsigned] = ACTIONS(3319),
    [anon_sym_long] = ACTIONS(3319),
    [anon_sym_short] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_register] = ACTIONS(3319),
    [anon_sym_inline] = ACTIONS(3319),
    [anon_sym___inline] = ACTIONS(3319),
    [anon_sym___inline__] = ACTIONS(3319),
    [anon_sym___forceinline] = ACTIONS(3319),
    [anon_sym_thread_local] = ACTIONS(3319),
    [anon_sym___thread] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_constexpr] = ACTIONS(3319),
    [anon_sym_volatile] = ACTIONS(3319),
    [anon_sym_restrict] = ACTIONS(3319),
    [anon_sym___restrict__] = ACTIONS(3319),
    [anon_sym__Atomic] = ACTIONS(3319),
    [anon_sym__Noreturn] = ACTIONS(3319),
    [anon_sym_noreturn] = ACTIONS(3319),
    [anon_sym__Nonnull] = ACTIONS(3319),
    [anon_sym_mutable] = ACTIONS(3319),
    [anon_sym_constinit] = ACTIONS(3319),
    [anon_sym_consteval] = ACTIONS(3319),
    [anon_sym_alignas] = ACTIONS(3319),
    [anon_sym__Alignas] = ACTIONS(3319),
    [sym_primitive_type] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_struct] = ACTIONS(3319),
    [anon_sym_union] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3319),
    [anon_sym_decltype] = ACTIONS(3319),
    [anon_sym_explicit] = ACTIONS(3319),
    [anon_sym_typename] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_template] = ACTIONS(3319),
    [anon_sym_operator] = ACTIONS(3319),
    [anon_sym_friend] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_static_assert] = ACTIONS(3319),
  },
  [2169] = {
    [sym_attribute_declaration] = STATE(2270),
    [sym_parameter_list] = STATE(2298),
    [aux_sym_attributed_declarator_repeat1] = STATE(2270),
    [sym_identifier] = ACTIONS(6038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6040),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [aux_sym_preproc_if_token2] = ACTIONS(6040),
    [aux_sym_preproc_else_token1] = ACTIONS(6040),
    [aux_sym_preproc_elif_token1] = ACTIONS(6038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6040),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6040),
    [anon_sym_LPAREN2] = ACTIONS(6042),
    [anon_sym_DASH] = ACTIONS(6038),
    [anon_sym_PLUS] = ACTIONS(6038),
    [anon_sym_STAR] = ACTIONS(6038),
    [anon_sym_SLASH] = ACTIONS(6038),
    [anon_sym_PERCENT] = ACTIONS(6038),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_CARET] = ACTIONS(6038),
    [anon_sym_AMP] = ACTIONS(6038),
    [anon_sym_EQ_EQ] = ACTIONS(6040),
    [anon_sym_BANG_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6038),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_LT_EQ] = ACTIONS(6038),
    [anon_sym_LT] = ACTIONS(6038),
    [anon_sym_LT_LT] = ACTIONS(6038),
    [anon_sym_GT_GT] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym___attribute__] = ACTIONS(6038),
    [anon_sym___attribute] = ACTIONS(6038),
    [anon_sym_COLON] = ACTIONS(6040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6044),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6046),
    [anon_sym_RBRACK] = ACTIONS(6040),
    [anon_sym_EQ] = ACTIONS(6038),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_STAR_EQ] = ACTIONS(6040),
    [anon_sym_SLASH_EQ] = ACTIONS(6040),
    [anon_sym_PERCENT_EQ] = ACTIONS(6040),
    [anon_sym_PLUS_EQ] = ACTIONS(6040),
    [anon_sym_DASH_EQ] = ACTIONS(6040),
    [anon_sym_LT_LT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_AMP_EQ] = ACTIONS(6040),
    [anon_sym_CARET_EQ] = ACTIONS(6040),
    [anon_sym_PIPE_EQ] = ACTIONS(6040),
    [anon_sym_and_eq] = ACTIONS(6038),
    [anon_sym_or_eq] = ACTIONS(6038),
    [anon_sym_xor_eq] = ACTIONS(6038),
    [anon_sym_LT_EQ_GT] = ACTIONS(6040),
    [anon_sym_or] = ACTIONS(6038),
    [anon_sym_and] = ACTIONS(6038),
    [anon_sym_bitor] = ACTIONS(6038),
    [anon_sym_xor] = ACTIONS(6038),
    [anon_sym_bitand] = ACTIONS(6038),
    [anon_sym_not_eq] = ACTIONS(6038),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_DOT] = ACTIONS(6038),
    [anon_sym_DOT_STAR] = ACTIONS(6040),
    [anon_sym_DASH_GT] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [2170] = {
    [sym_type_qualifier] = STATE(2180),
    [sym_alignas_qualifier] = STATE(2229),
    [aux_sym__type_definition_type_repeat1] = STATE(2180),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2383),
    [sym_identifier] = ACTIONS(6048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5086),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_LPAREN2] = ACTIONS(5086),
    [anon_sym_DASH] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_STAR] = ACTIONS(5086),
    [anon_sym_SLASH] = ACTIONS(5088),
    [anon_sym_PERCENT] = ACTIONS(5086),
    [anon_sym_PIPE_PIPE] = ACTIONS(5086),
    [anon_sym_AMP_AMP] = ACTIONS(5086),
    [anon_sym_PIPE] = ACTIONS(5088),
    [anon_sym_CARET] = ACTIONS(5086),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_EQ_EQ] = ACTIONS(5086),
    [anon_sym_BANG_EQ] = ACTIONS(5086),
    [anon_sym_GT] = ACTIONS(5088),
    [anon_sym_GT_EQ] = ACTIONS(5088),
    [anon_sym_LT_EQ] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_LT_LT] = ACTIONS(5086),
    [anon_sym_GT_GT] = ACTIONS(5088),
    [anon_sym___extension__] = ACTIONS(6050),
    [anon_sym___attribute__] = ACTIONS(5088),
    [anon_sym___attribute] = ACTIONS(5088),
    [anon_sym_LBRACE] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(6052),
    [anon_sym_unsigned] = ACTIONS(6052),
    [anon_sym_long] = ACTIONS(6052),
    [anon_sym_short] = ACTIONS(6052),
    [anon_sym_LBRACK] = ACTIONS(5086),
    [anon_sym_const] = ACTIONS(6050),
    [anon_sym_constexpr] = ACTIONS(6050),
    [anon_sym_volatile] = ACTIONS(6050),
    [anon_sym_restrict] = ACTIONS(6050),
    [anon_sym___restrict__] = ACTIONS(6050),
    [anon_sym__Atomic] = ACTIONS(6050),
    [anon_sym__Noreturn] = ACTIONS(6050),
    [anon_sym_noreturn] = ACTIONS(6050),
    [anon_sym__Nonnull] = ACTIONS(6050),
    [anon_sym_mutable] = ACTIONS(6050),
    [anon_sym_constinit] = ACTIONS(6050),
    [anon_sym_consteval] = ACTIONS(6050),
    [anon_sym_alignas] = ACTIONS(6054),
    [anon_sym__Alignas] = ACTIONS(6054),
    [sym_primitive_type] = ACTIONS(6056),
    [anon_sym_QMARK] = ACTIONS(5086),
    [anon_sym_LT_EQ_GT] = ACTIONS(5086),
    [anon_sym_or] = ACTIONS(5088),
    [anon_sym_and] = ACTIONS(5088),
    [anon_sym_bitor] = ACTIONS(5088),
    [anon_sym_xor] = ACTIONS(5088),
    [anon_sym_bitand] = ACTIONS(5088),
    [anon_sym_not_eq] = ACTIONS(5088),
    [anon_sym_DASH_DASH] = ACTIONS(5086),
    [anon_sym_PLUS_PLUS] = ACTIONS(5086),
    [anon_sym_DOT] = ACTIONS(5088),
    [anon_sym_DOT_STAR] = ACTIONS(5086),
    [anon_sym_DASH_GT] = ACTIONS(5086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5088),
    [anon_sym_decltype] = ACTIONS(5088),
    [anon_sym_GT2] = ACTIONS(5086),
  },
  [2171] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4182),
    [anon_sym_or_eq] = ACTIONS(4182),
    [anon_sym_xor_eq] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2172] = {
    [sym_decltype_auto] = STATE(2253),
    [sym_identifier] = ACTIONS(5589),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(5591),
    [anon_sym_RPAREN] = ACTIONS(5591),
    [aux_sym_preproc_if_token2] = ACTIONS(5591),
    [aux_sym_preproc_else_token1] = ACTIONS(5591),
    [aux_sym_preproc_elif_token1] = ACTIONS(5589),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5591),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5591),
    [anon_sym_LPAREN2] = ACTIONS(5591),
    [anon_sym_DASH] = ACTIONS(5589),
    [anon_sym_PLUS] = ACTIONS(5589),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5589),
    [anon_sym_PERCENT] = ACTIONS(5589),
    [anon_sym_PIPE_PIPE] = ACTIONS(5591),
    [anon_sym_AMP_AMP] = ACTIONS(5591),
    [anon_sym_PIPE] = ACTIONS(5589),
    [anon_sym_CARET] = ACTIONS(5589),
    [anon_sym_AMP] = ACTIONS(5589),
    [anon_sym_EQ_EQ] = ACTIONS(5591),
    [anon_sym_BANG_EQ] = ACTIONS(5591),
    [anon_sym_GT] = ACTIONS(5589),
    [anon_sym_GT_EQ] = ACTIONS(5591),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5589),
    [anon_sym_LT_LT] = ACTIONS(5589),
    [anon_sym_GT_GT] = ACTIONS(5589),
    [anon_sym_SEMI] = ACTIONS(5591),
    [anon_sym___attribute__] = ACTIONS(5589),
    [anon_sym___attribute] = ACTIONS(5589),
    [anon_sym_COLON] = ACTIONS(5591),
    [anon_sym_LBRACE] = ACTIONS(5591),
    [anon_sym_RBRACE] = ACTIONS(5591),
    [anon_sym_LBRACK] = ACTIONS(5591),
    [anon_sym_RBRACK] = ACTIONS(5591),
    [anon_sym_EQ] = ACTIONS(5589),
    [anon_sym_QMARK] = ACTIONS(5591),
    [anon_sym_STAR_EQ] = ACTIONS(5591),
    [anon_sym_SLASH_EQ] = ACTIONS(5591),
    [anon_sym_PERCENT_EQ] = ACTIONS(5591),
    [anon_sym_PLUS_EQ] = ACTIONS(5591),
    [anon_sym_DASH_EQ] = ACTIONS(5591),
    [anon_sym_LT_LT_EQ] = ACTIONS(5591),
    [anon_sym_GT_GT_EQ] = ACTIONS(5591),
    [anon_sym_AMP_EQ] = ACTIONS(5591),
    [anon_sym_CARET_EQ] = ACTIONS(5591),
    [anon_sym_PIPE_EQ] = ACTIONS(5591),
    [anon_sym_and_eq] = ACTIONS(5589),
    [anon_sym_or_eq] = ACTIONS(5589),
    [anon_sym_xor_eq] = ACTIONS(5589),
    [anon_sym_LT_EQ_GT] = ACTIONS(5591),
    [anon_sym_or] = ACTIONS(5589),
    [anon_sym_and] = ACTIONS(5589),
    [anon_sym_bitor] = ACTIONS(5589),
    [anon_sym_xor] = ACTIONS(5589),
    [anon_sym_bitand] = ACTIONS(5589),
    [anon_sym_not_eq] = ACTIONS(5589),
    [anon_sym_DASH_DASH] = ACTIONS(5591),
    [anon_sym_PLUS_PLUS] = ACTIONS(5591),
    [anon_sym_DOT] = ACTIONS(5589),
    [anon_sym_DOT_STAR] = ACTIONS(5591),
    [anon_sym_DASH_GT] = ACTIONS(5591),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5831),
    [anon_sym_decltype] = ACTIONS(5833),
  },
  [2173] = {
    [sym_attribute_specifier] = STATE(2289),
    [sym_identifier] = ACTIONS(6058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [aux_sym_preproc_if_token2] = ACTIONS(6060),
    [aux_sym_preproc_else_token1] = ACTIONS(6060),
    [aux_sym_preproc_elif_token1] = ACTIONS(6058),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6060),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6060),
    [anon_sym_LPAREN2] = ACTIONS(6060),
    [anon_sym_DASH] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6058),
    [anon_sym_STAR] = ACTIONS(6058),
    [anon_sym_SLASH] = ACTIONS(6058),
    [anon_sym_PERCENT] = ACTIONS(6058),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6058),
    [anon_sym_CARET] = ACTIONS(6058),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_EQ_EQ] = ACTIONS(6060),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_GT] = ACTIONS(6058),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6058),
    [anon_sym_LT] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6058),
    [anon_sym_GT_GT] = ACTIONS(6058),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_EQ] = ACTIONS(6058),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_and_eq] = ACTIONS(6058),
    [anon_sym_or_eq] = ACTIONS(6058),
    [anon_sym_xor_eq] = ACTIONS(6058),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6058),
    [anon_sym_and] = ACTIONS(6058),
    [anon_sym_bitor] = ACTIONS(6058),
    [anon_sym_xor] = ACTIONS(6058),
    [anon_sym_bitand] = ACTIONS(6058),
    [anon_sym_not_eq] = ACTIONS(6058),
    [anon_sym_DASH_DASH] = ACTIONS(6060),
    [anon_sym_PLUS_PLUS] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6058),
    [anon_sym_DOT_STAR] = ACTIONS(6060),
    [anon_sym_DASH_GT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6058),
    [anon_sym_decltype] = ACTIONS(6058),
  },
  [2174] = {
    [sym_identifier] = ACTIONS(5450),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [aux_sym_preproc_if_token2] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5450),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5452),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5450),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5450),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5450),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym___attribute__] = ACTIONS(5450),
    [anon_sym___attribute] = ACTIONS(5450),
    [anon_sym_COLON] = ACTIONS(5450),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_STAR_EQ] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5452),
    [anon_sym_PLUS_EQ] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5452),
    [anon_sym_CARET_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_EQ] = ACTIONS(5452),
    [anon_sym_and_eq] = ACTIONS(5450),
    [anon_sym_or_eq] = ACTIONS(5450),
    [anon_sym_xor_eq] = ACTIONS(5450),
    [anon_sym_LT_EQ_GT] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_and] = ACTIONS(5450),
    [anon_sym_bitor] = ACTIONS(5450),
    [anon_sym_xor] = ACTIONS(5450),
    [anon_sym_bitand] = ACTIONS(5450),
    [anon_sym_not_eq] = ACTIONS(5450),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5450),
    [anon_sym_decltype] = ACTIONS(5450),
  },
  [2175] = {
    [sym_attribute_specifier] = STATE(2225),
    [sym_identifier] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6064),
    [anon_sym_COMMA] = ACTIONS(6064),
    [anon_sym_RPAREN] = ACTIONS(6064),
    [aux_sym_preproc_if_token2] = ACTIONS(6064),
    [aux_sym_preproc_else_token1] = ACTIONS(6064),
    [aux_sym_preproc_elif_token1] = ACTIONS(6062),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6064),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6064),
    [anon_sym_LPAREN2] = ACTIONS(6064),
    [anon_sym_DASH] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_STAR] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [anon_sym_PIPE_PIPE] = ACTIONS(6064),
    [anon_sym_AMP_AMP] = ACTIONS(6064),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6064),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6064),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6064),
    [anon_sym_LBRACE] = ACTIONS(6064),
    [anon_sym_RBRACE] = ACTIONS(6064),
    [anon_sym_LBRACK] = ACTIONS(6064),
    [anon_sym_RBRACK] = ACTIONS(6064),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_QMARK] = ACTIONS(6064),
    [anon_sym_STAR_EQ] = ACTIONS(6064),
    [anon_sym_SLASH_EQ] = ACTIONS(6064),
    [anon_sym_PERCENT_EQ] = ACTIONS(6064),
    [anon_sym_PLUS_EQ] = ACTIONS(6064),
    [anon_sym_DASH_EQ] = ACTIONS(6064),
    [anon_sym_LT_LT_EQ] = ACTIONS(6064),
    [anon_sym_GT_GT_EQ] = ACTIONS(6064),
    [anon_sym_AMP_EQ] = ACTIONS(6064),
    [anon_sym_CARET_EQ] = ACTIONS(6064),
    [anon_sym_PIPE_EQ] = ACTIONS(6064),
    [anon_sym_and_eq] = ACTIONS(6062),
    [anon_sym_or_eq] = ACTIONS(6062),
    [anon_sym_xor_eq] = ACTIONS(6062),
    [anon_sym_LT_EQ_GT] = ACTIONS(6064),
    [anon_sym_or] = ACTIONS(6062),
    [anon_sym_and] = ACTIONS(6062),
    [anon_sym_bitor] = ACTIONS(6062),
    [anon_sym_xor] = ACTIONS(6062),
    [anon_sym_bitand] = ACTIONS(6062),
    [anon_sym_not_eq] = ACTIONS(6062),
    [anon_sym_DASH_DASH] = ACTIONS(6064),
    [anon_sym_PLUS_PLUS] = ACTIONS(6064),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_DOT_STAR] = ACTIONS(6064),
    [anon_sym_DASH_GT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6062),
    [anon_sym_decltype] = ACTIONS(6062),
  },
  [2176] = {
    [sym_attribute_declaration] = STATE(2270),
    [sym_parameter_list] = STATE(2298),
    [aux_sym_attributed_declarator_repeat1] = STATE(2270),
    [sym_identifier] = ACTIONS(6066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6068),
    [anon_sym_COMMA] = ACTIONS(6068),
    [anon_sym_RPAREN] = ACTIONS(6068),
    [aux_sym_preproc_if_token2] = ACTIONS(6068),
    [aux_sym_preproc_else_token1] = ACTIONS(6068),
    [aux_sym_preproc_elif_token1] = ACTIONS(6066),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6068),
    [anon_sym_LPAREN2] = ACTIONS(6042),
    [anon_sym_DASH] = ACTIONS(6066),
    [anon_sym_PLUS] = ACTIONS(6066),
    [anon_sym_STAR] = ACTIONS(6066),
    [anon_sym_SLASH] = ACTIONS(6066),
    [anon_sym_PERCENT] = ACTIONS(6066),
    [anon_sym_PIPE_PIPE] = ACTIONS(6068),
    [anon_sym_AMP_AMP] = ACTIONS(6068),
    [anon_sym_PIPE] = ACTIONS(6066),
    [anon_sym_CARET] = ACTIONS(6066),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ_EQ] = ACTIONS(6068),
    [anon_sym_BANG_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6066),
    [anon_sym_GT_EQ] = ACTIONS(6068),
    [anon_sym_LT_EQ] = ACTIONS(6066),
    [anon_sym_LT] = ACTIONS(6066),
    [anon_sym_LT_LT] = ACTIONS(6066),
    [anon_sym_GT_GT] = ACTIONS(6066),
    [anon_sym_SEMI] = ACTIONS(6068),
    [anon_sym___attribute__] = ACTIONS(6066),
    [anon_sym___attribute] = ACTIONS(6066),
    [anon_sym_COLON] = ACTIONS(6068),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6044),
    [anon_sym_RBRACE] = ACTIONS(6068),
    [anon_sym_LBRACK] = ACTIONS(6046),
    [anon_sym_RBRACK] = ACTIONS(6068),
    [anon_sym_EQ] = ACTIONS(6066),
    [anon_sym_QMARK] = ACTIONS(6068),
    [anon_sym_STAR_EQ] = ACTIONS(6068),
    [anon_sym_SLASH_EQ] = ACTIONS(6068),
    [anon_sym_PERCENT_EQ] = ACTIONS(6068),
    [anon_sym_PLUS_EQ] = ACTIONS(6068),
    [anon_sym_DASH_EQ] = ACTIONS(6068),
    [anon_sym_LT_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT_GT_EQ] = ACTIONS(6068),
    [anon_sym_AMP_EQ] = ACTIONS(6068),
    [anon_sym_CARET_EQ] = ACTIONS(6068),
    [anon_sym_PIPE_EQ] = ACTIONS(6068),
    [anon_sym_and_eq] = ACTIONS(6066),
    [anon_sym_or_eq] = ACTIONS(6066),
    [anon_sym_xor_eq] = ACTIONS(6066),
    [anon_sym_LT_EQ_GT] = ACTIONS(6068),
    [anon_sym_or] = ACTIONS(6066),
    [anon_sym_and] = ACTIONS(6066),
    [anon_sym_bitor] = ACTIONS(6066),
    [anon_sym_xor] = ACTIONS(6066),
    [anon_sym_bitand] = ACTIONS(6066),
    [anon_sym_not_eq] = ACTIONS(6066),
    [anon_sym_DASH_DASH] = ACTIONS(6068),
    [anon_sym_PLUS_PLUS] = ACTIONS(6068),
    [anon_sym_DOT] = ACTIONS(6066),
    [anon_sym_DOT_STAR] = ACTIONS(6068),
    [anon_sym_DASH_GT] = ACTIONS(6068),
    [sym_comment] = ACTIONS(3),
  },
  [2177] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(7258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6070),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_RBRACK] = ACTIONS(6076),
    [anon_sym_EQ] = ACTIONS(6080),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(6082),
    [anon_sym_SLASH_EQ] = ACTIONS(6082),
    [anon_sym_PERCENT_EQ] = ACTIONS(6082),
    [anon_sym_PLUS_EQ] = ACTIONS(6082),
    [anon_sym_DASH_EQ] = ACTIONS(6082),
    [anon_sym_LT_LT_EQ] = ACTIONS(6082),
    [anon_sym_GT_GT_EQ] = ACTIONS(6082),
    [anon_sym_AMP_EQ] = ACTIONS(6082),
    [anon_sym_CARET_EQ] = ACTIONS(6082),
    [anon_sym_PIPE_EQ] = ACTIONS(6082),
    [anon_sym_and_eq] = ACTIONS(6082),
    [anon_sym_or_eq] = ACTIONS(6082),
    [anon_sym_xor_eq] = ACTIONS(6082),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2178] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON] = ACTIONS(4218),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4182),
    [anon_sym_or_eq] = ACTIONS(4182),
    [anon_sym_xor_eq] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2179] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4182),
    [anon_sym_or_eq] = ACTIONS(4182),
    [anon_sym_xor_eq] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2180] = {
    [sym_type_qualifier] = STATE(1926),
    [sym_alignas_qualifier] = STATE(2229),
    [aux_sym__type_definition_type_repeat1] = STATE(1926),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2344),
    [sym_identifier] = ACTIONS(6084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5100),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_LPAREN2] = ACTIONS(5100),
    [anon_sym_DASH] = ACTIONS(5102),
    [anon_sym_PLUS] = ACTIONS(5102),
    [anon_sym_STAR] = ACTIONS(5100),
    [anon_sym_SLASH] = ACTIONS(5102),
    [anon_sym_PERCENT] = ACTIONS(5100),
    [anon_sym_PIPE_PIPE] = ACTIONS(5100),
    [anon_sym_AMP_AMP] = ACTIONS(5100),
    [anon_sym_PIPE] = ACTIONS(5102),
    [anon_sym_CARET] = ACTIONS(5100),
    [anon_sym_AMP] = ACTIONS(5102),
    [anon_sym_EQ_EQ] = ACTIONS(5100),
    [anon_sym_BANG_EQ] = ACTIONS(5100),
    [anon_sym_GT] = ACTIONS(5102),
    [anon_sym_GT_EQ] = ACTIONS(5102),
    [anon_sym_LT_EQ] = ACTIONS(5102),
    [anon_sym_LT] = ACTIONS(5102),
    [anon_sym_LT_LT] = ACTIONS(5100),
    [anon_sym_GT_GT] = ACTIONS(5102),
    [anon_sym___extension__] = ACTIONS(6050),
    [anon_sym___attribute__] = ACTIONS(5102),
    [anon_sym___attribute] = ACTIONS(5102),
    [anon_sym_LBRACE] = ACTIONS(5100),
    [anon_sym_signed] = ACTIONS(6086),
    [anon_sym_unsigned] = ACTIONS(6086),
    [anon_sym_long] = ACTIONS(6086),
    [anon_sym_short] = ACTIONS(6086),
    [anon_sym_LBRACK] = ACTIONS(5100),
    [anon_sym_const] = ACTIONS(6050),
    [anon_sym_constexpr] = ACTIONS(6050),
    [anon_sym_volatile] = ACTIONS(6050),
    [anon_sym_restrict] = ACTIONS(6050),
    [anon_sym___restrict__] = ACTIONS(6050),
    [anon_sym__Atomic] = ACTIONS(6050),
    [anon_sym__Noreturn] = ACTIONS(6050),
    [anon_sym_noreturn] = ACTIONS(6050),
    [anon_sym__Nonnull] = ACTIONS(6050),
    [anon_sym_mutable] = ACTIONS(6050),
    [anon_sym_constinit] = ACTIONS(6050),
    [anon_sym_consteval] = ACTIONS(6050),
    [anon_sym_alignas] = ACTIONS(6054),
    [anon_sym__Alignas] = ACTIONS(6054),
    [sym_primitive_type] = ACTIONS(6088),
    [anon_sym_QMARK] = ACTIONS(5100),
    [anon_sym_LT_EQ_GT] = ACTIONS(5100),
    [anon_sym_or] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5102),
    [anon_sym_bitor] = ACTIONS(5102),
    [anon_sym_xor] = ACTIONS(5102),
    [anon_sym_bitand] = ACTIONS(5102),
    [anon_sym_not_eq] = ACTIONS(5102),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_DOT] = ACTIONS(5102),
    [anon_sym_DOT_STAR] = ACTIONS(5100),
    [anon_sym_DASH_GT] = ACTIONS(5100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5102),
    [anon_sym_decltype] = ACTIONS(5102),
    [anon_sym_GT2] = ACTIONS(5100),
  },
  [2181] = {
    [sym_attribute_specifier] = STATE(2283),
    [sym_identifier] = ACTIONS(6090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6092),
    [anon_sym_COMMA] = ACTIONS(6092),
    [anon_sym_RPAREN] = ACTIONS(6092),
    [aux_sym_preproc_if_token2] = ACTIONS(6092),
    [aux_sym_preproc_else_token1] = ACTIONS(6092),
    [aux_sym_preproc_elif_token1] = ACTIONS(6090),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6092),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6092),
    [anon_sym_LPAREN2] = ACTIONS(6092),
    [anon_sym_DASH] = ACTIONS(6090),
    [anon_sym_PLUS] = ACTIONS(6090),
    [anon_sym_STAR] = ACTIONS(6090),
    [anon_sym_SLASH] = ACTIONS(6090),
    [anon_sym_PERCENT] = ACTIONS(6090),
    [anon_sym_PIPE_PIPE] = ACTIONS(6092),
    [anon_sym_AMP_AMP] = ACTIONS(6092),
    [anon_sym_PIPE] = ACTIONS(6090),
    [anon_sym_CARET] = ACTIONS(6090),
    [anon_sym_AMP] = ACTIONS(6090),
    [anon_sym_EQ_EQ] = ACTIONS(6092),
    [anon_sym_BANG_EQ] = ACTIONS(6092),
    [anon_sym_GT] = ACTIONS(6090),
    [anon_sym_GT_EQ] = ACTIONS(6092),
    [anon_sym_LT_EQ] = ACTIONS(6090),
    [anon_sym_LT] = ACTIONS(6090),
    [anon_sym_LT_LT] = ACTIONS(6090),
    [anon_sym_GT_GT] = ACTIONS(6090),
    [anon_sym_SEMI] = ACTIONS(6092),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6092),
    [anon_sym_LBRACE] = ACTIONS(6092),
    [anon_sym_RBRACE] = ACTIONS(6092),
    [anon_sym_LBRACK] = ACTIONS(6092),
    [anon_sym_RBRACK] = ACTIONS(6092),
    [anon_sym_EQ] = ACTIONS(6090),
    [anon_sym_QMARK] = ACTIONS(6092),
    [anon_sym_STAR_EQ] = ACTIONS(6092),
    [anon_sym_SLASH_EQ] = ACTIONS(6092),
    [anon_sym_PERCENT_EQ] = ACTIONS(6092),
    [anon_sym_PLUS_EQ] = ACTIONS(6092),
    [anon_sym_DASH_EQ] = ACTIONS(6092),
    [anon_sym_LT_LT_EQ] = ACTIONS(6092),
    [anon_sym_GT_GT_EQ] = ACTIONS(6092),
    [anon_sym_AMP_EQ] = ACTIONS(6092),
    [anon_sym_CARET_EQ] = ACTIONS(6092),
    [anon_sym_PIPE_EQ] = ACTIONS(6092),
    [anon_sym_and_eq] = ACTIONS(6090),
    [anon_sym_or_eq] = ACTIONS(6090),
    [anon_sym_xor_eq] = ACTIONS(6090),
    [anon_sym_LT_EQ_GT] = ACTIONS(6092),
    [anon_sym_or] = ACTIONS(6090),
    [anon_sym_and] = ACTIONS(6090),
    [anon_sym_bitor] = ACTIONS(6090),
    [anon_sym_xor] = ACTIONS(6090),
    [anon_sym_bitand] = ACTIONS(6090),
    [anon_sym_not_eq] = ACTIONS(6090),
    [anon_sym_DASH_DASH] = ACTIONS(6092),
    [anon_sym_PLUS_PLUS] = ACTIONS(6092),
    [anon_sym_DOT] = ACTIONS(6090),
    [anon_sym_DOT_STAR] = ACTIONS(6092),
    [anon_sym_DASH_GT] = ACTIONS(6092),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6090),
    [anon_sym_decltype] = ACTIONS(6090),
  },
  [2182] = {
    [sym_string_literal] = STATE(2196),
    [sym_raw_string_literal] = STATE(2196),
    [aux_sym_concatenated_string_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(6094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_RPAREN] = ACTIONS(5396),
    [anon_sym_LPAREN2] = ACTIONS(5396),
    [anon_sym_DASH] = ACTIONS(5398),
    [anon_sym_PLUS] = ACTIONS(5398),
    [anon_sym_STAR] = ACTIONS(5398),
    [anon_sym_SLASH] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5398),
    [anon_sym_PIPE_PIPE] = ACTIONS(5396),
    [anon_sym_AMP_AMP] = ACTIONS(5396),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_CARET] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
    [anon_sym_EQ_EQ] = ACTIONS(5396),
    [anon_sym_BANG_EQ] = ACTIONS(5396),
    [anon_sym_GT] = ACTIONS(5398),
    [anon_sym_GT_EQ] = ACTIONS(5396),
    [anon_sym_LT_EQ] = ACTIONS(5398),
    [anon_sym_LT] = ACTIONS(5398),
    [anon_sym_LT_LT] = ACTIONS(5398),
    [anon_sym_GT_GT] = ACTIONS(5398),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_EQ] = ACTIONS(5398),
    [anon_sym_QMARK] = ACTIONS(5396),
    [anon_sym_STAR_EQ] = ACTIONS(5396),
    [anon_sym_SLASH_EQ] = ACTIONS(5396),
    [anon_sym_PERCENT_EQ] = ACTIONS(5396),
    [anon_sym_PLUS_EQ] = ACTIONS(5396),
    [anon_sym_DASH_EQ] = ACTIONS(5396),
    [anon_sym_LT_LT_EQ] = ACTIONS(5396),
    [anon_sym_GT_GT_EQ] = ACTIONS(5396),
    [anon_sym_AMP_EQ] = ACTIONS(5396),
    [anon_sym_CARET_EQ] = ACTIONS(5396),
    [anon_sym_PIPE_EQ] = ACTIONS(5396),
    [anon_sym_and_eq] = ACTIONS(5398),
    [anon_sym_or_eq] = ACTIONS(5398),
    [anon_sym_xor_eq] = ACTIONS(5398),
    [anon_sym_LT_EQ_GT] = ACTIONS(5396),
    [anon_sym_or] = ACTIONS(5398),
    [anon_sym_and] = ACTIONS(5398),
    [anon_sym_bitor] = ACTIONS(5398),
    [anon_sym_xor] = ACTIONS(5398),
    [anon_sym_bitand] = ACTIONS(5398),
    [anon_sym_not_eq] = ACTIONS(5398),
    [anon_sym_DASH_DASH] = ACTIONS(5396),
    [anon_sym_PLUS_PLUS] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(5398),
    [anon_sym_DOT_STAR] = ACTIONS(5396),
    [anon_sym_DASH_GT] = ACTIONS(5398),
    [anon_sym_L_DQUOTE] = ACTIONS(5040),
    [anon_sym_u_DQUOTE] = ACTIONS(5040),
    [anon_sym_U_DQUOTE] = ACTIONS(5040),
    [anon_sym_u8_DQUOTE] = ACTIONS(5040),
    [anon_sym_DQUOTE] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5042),
    [anon_sym_LR_DQUOTE] = ACTIONS(5042),
    [anon_sym_uR_DQUOTE] = ACTIONS(5042),
    [anon_sym_UR_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5042),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5396),
    [sym_literal_suffix] = ACTIONS(5398),
  },
  [2183] = {
    [sym_attribute_specifier] = STATE(2251),
    [sym_identifier] = ACTIONS(6096),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6098),
    [anon_sym_COMMA] = ACTIONS(6098),
    [anon_sym_RPAREN] = ACTIONS(6098),
    [aux_sym_preproc_if_token2] = ACTIONS(6098),
    [aux_sym_preproc_else_token1] = ACTIONS(6098),
    [aux_sym_preproc_elif_token1] = ACTIONS(6096),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6098),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6098),
    [anon_sym_LPAREN2] = ACTIONS(6098),
    [anon_sym_DASH] = ACTIONS(6096),
    [anon_sym_PLUS] = ACTIONS(6096),
    [anon_sym_STAR] = ACTIONS(6096),
    [anon_sym_SLASH] = ACTIONS(6096),
    [anon_sym_PERCENT] = ACTIONS(6096),
    [anon_sym_PIPE_PIPE] = ACTIONS(6098),
    [anon_sym_AMP_AMP] = ACTIONS(6098),
    [anon_sym_PIPE] = ACTIONS(6096),
    [anon_sym_CARET] = ACTIONS(6096),
    [anon_sym_AMP] = ACTIONS(6096),
    [anon_sym_EQ_EQ] = ACTIONS(6098),
    [anon_sym_BANG_EQ] = ACTIONS(6098),
    [anon_sym_GT] = ACTIONS(6096),
    [anon_sym_GT_EQ] = ACTIONS(6098),
    [anon_sym_LT_EQ] = ACTIONS(6096),
    [anon_sym_LT] = ACTIONS(6096),
    [anon_sym_LT_LT] = ACTIONS(6096),
    [anon_sym_GT_GT] = ACTIONS(6096),
    [anon_sym_SEMI] = ACTIONS(6098),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6098),
    [anon_sym_LBRACE] = ACTIONS(6098),
    [anon_sym_RBRACE] = ACTIONS(6098),
    [anon_sym_LBRACK] = ACTIONS(6098),
    [anon_sym_RBRACK] = ACTIONS(6098),
    [anon_sym_EQ] = ACTIONS(6096),
    [anon_sym_QMARK] = ACTIONS(6098),
    [anon_sym_STAR_EQ] = ACTIONS(6098),
    [anon_sym_SLASH_EQ] = ACTIONS(6098),
    [anon_sym_PERCENT_EQ] = ACTIONS(6098),
    [anon_sym_PLUS_EQ] = ACTIONS(6098),
    [anon_sym_DASH_EQ] = ACTIONS(6098),
    [anon_sym_LT_LT_EQ] = ACTIONS(6098),
    [anon_sym_GT_GT_EQ] = ACTIONS(6098),
    [anon_sym_AMP_EQ] = ACTIONS(6098),
    [anon_sym_CARET_EQ] = ACTIONS(6098),
    [anon_sym_PIPE_EQ] = ACTIONS(6098),
    [anon_sym_and_eq] = ACTIONS(6096),
    [anon_sym_or_eq] = ACTIONS(6096),
    [anon_sym_xor_eq] = ACTIONS(6096),
    [anon_sym_LT_EQ_GT] = ACTIONS(6098),
    [anon_sym_or] = ACTIONS(6096),
    [anon_sym_and] = ACTIONS(6096),
    [anon_sym_bitor] = ACTIONS(6096),
    [anon_sym_xor] = ACTIONS(6096),
    [anon_sym_bitand] = ACTIONS(6096),
    [anon_sym_not_eq] = ACTIONS(6096),
    [anon_sym_DASH_DASH] = ACTIONS(6098),
    [anon_sym_PLUS_PLUS] = ACTIONS(6098),
    [anon_sym_DOT] = ACTIONS(6096),
    [anon_sym_DOT_STAR] = ACTIONS(6098),
    [anon_sym_DASH_GT] = ACTIONS(6098),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6096),
    [anon_sym_decltype] = ACTIONS(6096),
  },
  [2184] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4182),
    [anon_sym_or_eq] = ACTIONS(4182),
    [anon_sym_xor_eq] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2185] = {
    [sym_attribute_declaration] = STATE(2270),
    [sym_parameter_list] = STATE(2298),
    [aux_sym_attributed_declarator_repeat1] = STATE(2270),
    [sym_identifier] = ACTIONS(6100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6102),
    [anon_sym_COMMA] = ACTIONS(6102),
    [anon_sym_RPAREN] = ACTIONS(6102),
    [aux_sym_preproc_if_token2] = ACTIONS(6102),
    [aux_sym_preproc_else_token1] = ACTIONS(6102),
    [aux_sym_preproc_elif_token1] = ACTIONS(6100),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6102),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6102),
    [anon_sym_LPAREN2] = ACTIONS(6042),
    [anon_sym_DASH] = ACTIONS(6100),
    [anon_sym_PLUS] = ACTIONS(6100),
    [anon_sym_STAR] = ACTIONS(6100),
    [anon_sym_SLASH] = ACTIONS(6100),
    [anon_sym_PERCENT] = ACTIONS(6100),
    [anon_sym_PIPE_PIPE] = ACTIONS(6102),
    [anon_sym_AMP_AMP] = ACTIONS(6102),
    [anon_sym_PIPE] = ACTIONS(6100),
    [anon_sym_CARET] = ACTIONS(6100),
    [anon_sym_AMP] = ACTIONS(6100),
    [anon_sym_EQ_EQ] = ACTIONS(6102),
    [anon_sym_BANG_EQ] = ACTIONS(6102),
    [anon_sym_GT] = ACTIONS(6100),
    [anon_sym_GT_EQ] = ACTIONS(6102),
    [anon_sym_LT_EQ] = ACTIONS(6100),
    [anon_sym_LT] = ACTIONS(6100),
    [anon_sym_LT_LT] = ACTIONS(6100),
    [anon_sym_GT_GT] = ACTIONS(6100),
    [anon_sym_SEMI] = ACTIONS(6102),
    [anon_sym___attribute__] = ACTIONS(6100),
    [anon_sym___attribute] = ACTIONS(6100),
    [anon_sym_COLON] = ACTIONS(6102),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6044),
    [anon_sym_RBRACE] = ACTIONS(6102),
    [anon_sym_LBRACK] = ACTIONS(6046),
    [anon_sym_RBRACK] = ACTIONS(6102),
    [anon_sym_EQ] = ACTIONS(6100),
    [anon_sym_QMARK] = ACTIONS(6102),
    [anon_sym_STAR_EQ] = ACTIONS(6102),
    [anon_sym_SLASH_EQ] = ACTIONS(6102),
    [anon_sym_PERCENT_EQ] = ACTIONS(6102),
    [anon_sym_PLUS_EQ] = ACTIONS(6102),
    [anon_sym_DASH_EQ] = ACTIONS(6102),
    [anon_sym_LT_LT_EQ] = ACTIONS(6102),
    [anon_sym_GT_GT_EQ] = ACTIONS(6102),
    [anon_sym_AMP_EQ] = ACTIONS(6102),
    [anon_sym_CARET_EQ] = ACTIONS(6102),
    [anon_sym_PIPE_EQ] = ACTIONS(6102),
    [anon_sym_and_eq] = ACTIONS(6100),
    [anon_sym_or_eq] = ACTIONS(6100),
    [anon_sym_xor_eq] = ACTIONS(6100),
    [anon_sym_LT_EQ_GT] = ACTIONS(6102),
    [anon_sym_or] = ACTIONS(6100),
    [anon_sym_and] = ACTIONS(6100),
    [anon_sym_bitor] = ACTIONS(6100),
    [anon_sym_xor] = ACTIONS(6100),
    [anon_sym_bitand] = ACTIONS(6100),
    [anon_sym_not_eq] = ACTIONS(6100),
    [anon_sym_DASH_DASH] = ACTIONS(6102),
    [anon_sym_PLUS_PLUS] = ACTIONS(6102),
    [anon_sym_DOT] = ACTIONS(6100),
    [anon_sym_DOT_STAR] = ACTIONS(6102),
    [anon_sym_DASH_GT] = ACTIONS(6102),
    [sym_comment] = ACTIONS(3),
  },
  [2186] = {
    [sym_attribute_specifier] = STATE(2221),
    [sym_identifier] = ACTIONS(6104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6106),
    [anon_sym_COMMA] = ACTIONS(6106),
    [anon_sym_RPAREN] = ACTIONS(6106),
    [aux_sym_preproc_if_token2] = ACTIONS(6106),
    [aux_sym_preproc_else_token1] = ACTIONS(6106),
    [aux_sym_preproc_elif_token1] = ACTIONS(6104),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6106),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6106),
    [anon_sym_LPAREN2] = ACTIONS(6106),
    [anon_sym_DASH] = ACTIONS(6104),
    [anon_sym_PLUS] = ACTIONS(6104),
    [anon_sym_STAR] = ACTIONS(6104),
    [anon_sym_SLASH] = ACTIONS(6104),
    [anon_sym_PERCENT] = ACTIONS(6104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6106),
    [anon_sym_AMP_AMP] = ACTIONS(6106),
    [anon_sym_PIPE] = ACTIONS(6104),
    [anon_sym_CARET] = ACTIONS(6104),
    [anon_sym_AMP] = ACTIONS(6104),
    [anon_sym_EQ_EQ] = ACTIONS(6106),
    [anon_sym_BANG_EQ] = ACTIONS(6106),
    [anon_sym_GT] = ACTIONS(6104),
    [anon_sym_GT_EQ] = ACTIONS(6106),
    [anon_sym_LT_EQ] = ACTIONS(6104),
    [anon_sym_LT] = ACTIONS(6104),
    [anon_sym_LT_LT] = ACTIONS(6104),
    [anon_sym_GT_GT] = ACTIONS(6104),
    [anon_sym_SEMI] = ACTIONS(6106),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6106),
    [anon_sym_LBRACE] = ACTIONS(6106),
    [anon_sym_RBRACE] = ACTIONS(6106),
    [anon_sym_LBRACK] = ACTIONS(6106),
    [anon_sym_RBRACK] = ACTIONS(6106),
    [anon_sym_EQ] = ACTIONS(6104),
    [anon_sym_QMARK] = ACTIONS(6106),
    [anon_sym_STAR_EQ] = ACTIONS(6106),
    [anon_sym_SLASH_EQ] = ACTIONS(6106),
    [anon_sym_PERCENT_EQ] = ACTIONS(6106),
    [anon_sym_PLUS_EQ] = ACTIONS(6106),
    [anon_sym_DASH_EQ] = ACTIONS(6106),
    [anon_sym_LT_LT_EQ] = ACTIONS(6106),
    [anon_sym_GT_GT_EQ] = ACTIONS(6106),
    [anon_sym_AMP_EQ] = ACTIONS(6106),
    [anon_sym_CARET_EQ] = ACTIONS(6106),
    [anon_sym_PIPE_EQ] = ACTIONS(6106),
    [anon_sym_and_eq] = ACTIONS(6104),
    [anon_sym_or_eq] = ACTIONS(6104),
    [anon_sym_xor_eq] = ACTIONS(6104),
    [anon_sym_LT_EQ_GT] = ACTIONS(6106),
    [anon_sym_or] = ACTIONS(6104),
    [anon_sym_and] = ACTIONS(6104),
    [anon_sym_bitor] = ACTIONS(6104),
    [anon_sym_xor] = ACTIONS(6104),
    [anon_sym_bitand] = ACTIONS(6104),
    [anon_sym_not_eq] = ACTIONS(6104),
    [anon_sym_DASH_DASH] = ACTIONS(6106),
    [anon_sym_PLUS_PLUS] = ACTIONS(6106),
    [anon_sym_DOT] = ACTIONS(6104),
    [anon_sym_DOT_STAR] = ACTIONS(6106),
    [anon_sym_DASH_GT] = ACTIONS(6106),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6104),
    [anon_sym_decltype] = ACTIONS(6104),
  },
  [2187] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(7258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(6108),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_RBRACK] = ACTIONS(6110),
    [anon_sym_EQ] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(6082),
    [anon_sym_SLASH_EQ] = ACTIONS(6082),
    [anon_sym_PERCENT_EQ] = ACTIONS(6082),
    [anon_sym_PLUS_EQ] = ACTIONS(6082),
    [anon_sym_DASH_EQ] = ACTIONS(6082),
    [anon_sym_LT_LT_EQ] = ACTIONS(6082),
    [anon_sym_GT_GT_EQ] = ACTIONS(6082),
    [anon_sym_AMP_EQ] = ACTIONS(6082),
    [anon_sym_CARET_EQ] = ACTIONS(6082),
    [anon_sym_PIPE_EQ] = ACTIONS(6082),
    [anon_sym_and_eq] = ACTIONS(6082),
    [anon_sym_or_eq] = ACTIONS(6082),
    [anon_sym_xor_eq] = ACTIONS(6082),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2188] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON] = ACTIONS(4222),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4182),
    [anon_sym_or_eq] = ACTIONS(4182),
    [anon_sym_xor_eq] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2189] = {
    [sym_string_literal] = STATE(2182),
    [sym_raw_string_literal] = STATE(2182),
    [aux_sym_concatenated_string_repeat1] = STATE(2182),
    [sym_identifier] = ACTIONS(6115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5390),
    [anon_sym_COMMA] = ACTIONS(5390),
    [anon_sym_RPAREN] = ACTIONS(5390),
    [anon_sym_LPAREN2] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5392),
    [anon_sym_PLUS] = ACTIONS(5392),
    [anon_sym_STAR] = ACTIONS(5392),
    [anon_sym_SLASH] = ACTIONS(5392),
    [anon_sym_PERCENT] = ACTIONS(5392),
    [anon_sym_PIPE_PIPE] = ACTIONS(5390),
    [anon_sym_AMP_AMP] = ACTIONS(5390),
    [anon_sym_PIPE] = ACTIONS(5392),
    [anon_sym_CARET] = ACTIONS(5392),
    [anon_sym_AMP] = ACTIONS(5392),
    [anon_sym_EQ_EQ] = ACTIONS(5390),
    [anon_sym_BANG_EQ] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5392),
    [anon_sym_GT_EQ] = ACTIONS(5390),
    [anon_sym_LT_EQ] = ACTIONS(5392),
    [anon_sym_LT] = ACTIONS(5392),
    [anon_sym_LT_LT] = ACTIONS(5392),
    [anon_sym_GT_GT] = ACTIONS(5392),
    [anon_sym_LBRACK] = ACTIONS(5390),
    [anon_sym_EQ] = ACTIONS(5392),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_STAR_EQ] = ACTIONS(5390),
    [anon_sym_SLASH_EQ] = ACTIONS(5390),
    [anon_sym_PERCENT_EQ] = ACTIONS(5390),
    [anon_sym_PLUS_EQ] = ACTIONS(5390),
    [anon_sym_DASH_EQ] = ACTIONS(5390),
    [anon_sym_LT_LT_EQ] = ACTIONS(5390),
    [anon_sym_GT_GT_EQ] = ACTIONS(5390),
    [anon_sym_AMP_EQ] = ACTIONS(5390),
    [anon_sym_CARET_EQ] = ACTIONS(5390),
    [anon_sym_PIPE_EQ] = ACTIONS(5390),
    [anon_sym_and_eq] = ACTIONS(5392),
    [anon_sym_or_eq] = ACTIONS(5392),
    [anon_sym_xor_eq] = ACTIONS(5392),
    [anon_sym_LT_EQ_GT] = ACTIONS(5390),
    [anon_sym_or] = ACTIONS(5392),
    [anon_sym_and] = ACTIONS(5392),
    [anon_sym_bitor] = ACTIONS(5392),
    [anon_sym_xor] = ACTIONS(5392),
    [anon_sym_bitand] = ACTIONS(5392),
    [anon_sym_not_eq] = ACTIONS(5392),
    [anon_sym_DASH_DASH] = ACTIONS(5390),
    [anon_sym_PLUS_PLUS] = ACTIONS(5390),
    [anon_sym_DOT] = ACTIONS(5392),
    [anon_sym_DOT_STAR] = ACTIONS(5390),
    [anon_sym_DASH_GT] = ACTIONS(5392),
    [anon_sym_L_DQUOTE] = ACTIONS(5040),
    [anon_sym_u_DQUOTE] = ACTIONS(5040),
    [anon_sym_U_DQUOTE] = ACTIONS(5040),
    [anon_sym_u8_DQUOTE] = ACTIONS(5040),
    [anon_sym_DQUOTE] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5042),
    [anon_sym_LR_DQUOTE] = ACTIONS(5042),
    [anon_sym_uR_DQUOTE] = ACTIONS(5042),
    [anon_sym_UR_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5042),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5390),
    [sym_literal_suffix] = ACTIONS(5392),
  },
  [2190] = {
    [sym_attribute_specifier] = STATE(2227),
    [sym_identifier] = ACTIONS(6117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6119),
    [anon_sym_COMMA] = ACTIONS(6119),
    [anon_sym_RPAREN] = ACTIONS(6119),
    [aux_sym_preproc_if_token2] = ACTIONS(6119),
    [aux_sym_preproc_else_token1] = ACTIONS(6119),
    [aux_sym_preproc_elif_token1] = ACTIONS(6117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6119),
    [anon_sym_LPAREN2] = ACTIONS(6119),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_STAR] = ACTIONS(6117),
    [anon_sym_SLASH] = ACTIONS(6117),
    [anon_sym_PERCENT] = ACTIONS(6117),
    [anon_sym_PIPE_PIPE] = ACTIONS(6119),
    [anon_sym_AMP_AMP] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6117),
    [anon_sym_CARET] = ACTIONS(6117),
    [anon_sym_AMP] = ACTIONS(6117),
    [anon_sym_EQ_EQ] = ACTIONS(6119),
    [anon_sym_BANG_EQ] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6117),
    [anon_sym_GT_EQ] = ACTIONS(6119),
    [anon_sym_LT_EQ] = ACTIONS(6117),
    [anon_sym_LT] = ACTIONS(6117),
    [anon_sym_LT_LT] = ACTIONS(6117),
    [anon_sym_GT_GT] = ACTIONS(6117),
    [anon_sym_SEMI] = ACTIONS(6119),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_LBRACE] = ACTIONS(6119),
    [anon_sym_RBRACE] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6119),
    [anon_sym_RBRACK] = ACTIONS(6119),
    [anon_sym_EQ] = ACTIONS(6117),
    [anon_sym_QMARK] = ACTIONS(6119),
    [anon_sym_STAR_EQ] = ACTIONS(6119),
    [anon_sym_SLASH_EQ] = ACTIONS(6119),
    [anon_sym_PERCENT_EQ] = ACTIONS(6119),
    [anon_sym_PLUS_EQ] = ACTIONS(6119),
    [anon_sym_DASH_EQ] = ACTIONS(6119),
    [anon_sym_LT_LT_EQ] = ACTIONS(6119),
    [anon_sym_GT_GT_EQ] = ACTIONS(6119),
    [anon_sym_AMP_EQ] = ACTIONS(6119),
    [anon_sym_CARET_EQ] = ACTIONS(6119),
    [anon_sym_PIPE_EQ] = ACTIONS(6119),
    [anon_sym_and_eq] = ACTIONS(6117),
    [anon_sym_or_eq] = ACTIONS(6117),
    [anon_sym_xor_eq] = ACTIONS(6117),
    [anon_sym_LT_EQ_GT] = ACTIONS(6119),
    [anon_sym_or] = ACTIONS(6117),
    [anon_sym_and] = ACTIONS(6117),
    [anon_sym_bitor] = ACTIONS(6117),
    [anon_sym_xor] = ACTIONS(6117),
    [anon_sym_bitand] = ACTIONS(6117),
    [anon_sym_not_eq] = ACTIONS(6117),
    [anon_sym_DASH_DASH] = ACTIONS(6119),
    [anon_sym_PLUS_PLUS] = ACTIONS(6119),
    [anon_sym_DOT] = ACTIONS(6117),
    [anon_sym_DOT_STAR] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6117),
    [anon_sym_decltype] = ACTIONS(6117),
  },
  [2191] = {
    [sym_attribute_specifier] = STATE(2232),
    [sym_identifier] = ACTIONS(6121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6123),
    [anon_sym_COMMA] = ACTIONS(6123),
    [anon_sym_RPAREN] = ACTIONS(6123),
    [aux_sym_preproc_if_token2] = ACTIONS(6123),
    [aux_sym_preproc_else_token1] = ACTIONS(6123),
    [aux_sym_preproc_elif_token1] = ACTIONS(6121),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6123),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6123),
    [anon_sym_LPAREN2] = ACTIONS(6123),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [anon_sym_PIPE_PIPE] = ACTIONS(6123),
    [anon_sym_AMP_AMP] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6121),
    [anon_sym_EQ_EQ] = ACTIONS(6123),
    [anon_sym_BANG_EQ] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6121),
    [anon_sym_GT_EQ] = ACTIONS(6123),
    [anon_sym_LT_EQ] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_LT_LT] = ACTIONS(6121),
    [anon_sym_GT_GT] = ACTIONS(6121),
    [anon_sym_SEMI] = ACTIONS(6123),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_LBRACE] = ACTIONS(6123),
    [anon_sym_RBRACE] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6123),
    [anon_sym_RBRACK] = ACTIONS(6123),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_QMARK] = ACTIONS(6123),
    [anon_sym_STAR_EQ] = ACTIONS(6123),
    [anon_sym_SLASH_EQ] = ACTIONS(6123),
    [anon_sym_PERCENT_EQ] = ACTIONS(6123),
    [anon_sym_PLUS_EQ] = ACTIONS(6123),
    [anon_sym_DASH_EQ] = ACTIONS(6123),
    [anon_sym_LT_LT_EQ] = ACTIONS(6123),
    [anon_sym_GT_GT_EQ] = ACTIONS(6123),
    [anon_sym_AMP_EQ] = ACTIONS(6123),
    [anon_sym_CARET_EQ] = ACTIONS(6123),
    [anon_sym_PIPE_EQ] = ACTIONS(6123),
    [anon_sym_and_eq] = ACTIONS(6121),
    [anon_sym_or_eq] = ACTIONS(6121),
    [anon_sym_xor_eq] = ACTIONS(6121),
    [anon_sym_LT_EQ_GT] = ACTIONS(6123),
    [anon_sym_or] = ACTIONS(6121),
    [anon_sym_and] = ACTIONS(6121),
    [anon_sym_bitor] = ACTIONS(6121),
    [anon_sym_xor] = ACTIONS(6121),
    [anon_sym_bitand] = ACTIONS(6121),
    [anon_sym_not_eq] = ACTIONS(6121),
    [anon_sym_DASH_DASH] = ACTIONS(6123),
    [anon_sym_PLUS_PLUS] = ACTIONS(6123),
    [anon_sym_DOT] = ACTIONS(6121),
    [anon_sym_DOT_STAR] = ACTIONS(6123),
    [anon_sym_DASH_GT] = ACTIONS(6123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6121),
    [anon_sym_decltype] = ACTIONS(6121),
  },
  [2192] = {
    [sym_attribute_specifier] = STATE(2243),
    [sym_identifier] = ACTIONS(6125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6127),
    [anon_sym_COMMA] = ACTIONS(6127),
    [anon_sym_RPAREN] = ACTIONS(6127),
    [aux_sym_preproc_if_token2] = ACTIONS(6127),
    [aux_sym_preproc_else_token1] = ACTIONS(6127),
    [aux_sym_preproc_elif_token1] = ACTIONS(6125),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6127),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6127),
    [anon_sym_LPAREN2] = ACTIONS(6127),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_PERCENT] = ACTIONS(6125),
    [anon_sym_PIPE_PIPE] = ACTIONS(6127),
    [anon_sym_AMP_AMP] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_EQ_EQ] = ACTIONS(6127),
    [anon_sym_BANG_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_GT_EQ] = ACTIONS(6127),
    [anon_sym_LT_EQ] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_LT_LT] = ACTIONS(6125),
    [anon_sym_GT_GT] = ACTIONS(6125),
    [anon_sym_SEMI] = ACTIONS(6127),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_LBRACE] = ACTIONS(6127),
    [anon_sym_RBRACE] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6127),
    [anon_sym_RBRACK] = ACTIONS(6127),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_STAR_EQ] = ACTIONS(6127),
    [anon_sym_SLASH_EQ] = ACTIONS(6127),
    [anon_sym_PERCENT_EQ] = ACTIONS(6127),
    [anon_sym_PLUS_EQ] = ACTIONS(6127),
    [anon_sym_DASH_EQ] = ACTIONS(6127),
    [anon_sym_LT_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT_EQ] = ACTIONS(6127),
    [anon_sym_AMP_EQ] = ACTIONS(6127),
    [anon_sym_CARET_EQ] = ACTIONS(6127),
    [anon_sym_PIPE_EQ] = ACTIONS(6127),
    [anon_sym_and_eq] = ACTIONS(6125),
    [anon_sym_or_eq] = ACTIONS(6125),
    [anon_sym_xor_eq] = ACTIONS(6125),
    [anon_sym_LT_EQ_GT] = ACTIONS(6127),
    [anon_sym_or] = ACTIONS(6125),
    [anon_sym_and] = ACTIONS(6125),
    [anon_sym_bitor] = ACTIONS(6125),
    [anon_sym_xor] = ACTIONS(6125),
    [anon_sym_bitand] = ACTIONS(6125),
    [anon_sym_not_eq] = ACTIONS(6125),
    [anon_sym_DASH_DASH] = ACTIONS(6127),
    [anon_sym_PLUS_PLUS] = ACTIONS(6127),
    [anon_sym_DOT] = ACTIONS(6125),
    [anon_sym_DOT_STAR] = ACTIONS(6127),
    [anon_sym_DASH_GT] = ACTIONS(6127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6125),
    [anon_sym_decltype] = ACTIONS(6125),
  },
  [2193] = {
    [sym_attribute_specifier] = STATE(2246),
    [sym_identifier] = ACTIONS(6129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6131),
    [anon_sym_COMMA] = ACTIONS(6131),
    [anon_sym_RPAREN] = ACTIONS(6131),
    [aux_sym_preproc_if_token2] = ACTIONS(6131),
    [aux_sym_preproc_else_token1] = ACTIONS(6131),
    [aux_sym_preproc_elif_token1] = ACTIONS(6129),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6131),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6131),
    [anon_sym_LPAREN2] = ACTIONS(6131),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_PERCENT] = ACTIONS(6129),
    [anon_sym_PIPE_PIPE] = ACTIONS(6131),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_AMP] = ACTIONS(6129),
    [anon_sym_EQ_EQ] = ACTIONS(6131),
    [anon_sym_BANG_EQ] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6129),
    [anon_sym_GT_EQ] = ACTIONS(6131),
    [anon_sym_LT_EQ] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6129),
    [anon_sym_LT_LT] = ACTIONS(6129),
    [anon_sym_GT_GT] = ACTIONS(6129),
    [anon_sym_SEMI] = ACTIONS(6131),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_LBRACE] = ACTIONS(6131),
    [anon_sym_RBRACE] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6131),
    [anon_sym_RBRACK] = ACTIONS(6131),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_QMARK] = ACTIONS(6131),
    [anon_sym_STAR_EQ] = ACTIONS(6131),
    [anon_sym_SLASH_EQ] = ACTIONS(6131),
    [anon_sym_PERCENT_EQ] = ACTIONS(6131),
    [anon_sym_PLUS_EQ] = ACTIONS(6131),
    [anon_sym_DASH_EQ] = ACTIONS(6131),
    [anon_sym_LT_LT_EQ] = ACTIONS(6131),
    [anon_sym_GT_GT_EQ] = ACTIONS(6131),
    [anon_sym_AMP_EQ] = ACTIONS(6131),
    [anon_sym_CARET_EQ] = ACTIONS(6131),
    [anon_sym_PIPE_EQ] = ACTIONS(6131),
    [anon_sym_and_eq] = ACTIONS(6129),
    [anon_sym_or_eq] = ACTIONS(6129),
    [anon_sym_xor_eq] = ACTIONS(6129),
    [anon_sym_LT_EQ_GT] = ACTIONS(6131),
    [anon_sym_or] = ACTIONS(6129),
    [anon_sym_and] = ACTIONS(6129),
    [anon_sym_bitor] = ACTIONS(6129),
    [anon_sym_xor] = ACTIONS(6129),
    [anon_sym_bitand] = ACTIONS(6129),
    [anon_sym_not_eq] = ACTIONS(6129),
    [anon_sym_DASH_DASH] = ACTIONS(6131),
    [anon_sym_PLUS_PLUS] = ACTIONS(6131),
    [anon_sym_DOT] = ACTIONS(6129),
    [anon_sym_DOT_STAR] = ACTIONS(6131),
    [anon_sym_DASH_GT] = ACTIONS(6131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6129),
    [anon_sym_decltype] = ACTIONS(6129),
  },
  [2194] = {
    [sym_attribute_declaration] = STATE(2270),
    [sym_parameter_list] = STATE(2298),
    [aux_sym_attributed_declarator_repeat1] = STATE(2270),
    [sym_identifier] = ACTIONS(6133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [aux_sym_preproc_if_token2] = ACTIONS(6135),
    [aux_sym_preproc_else_token1] = ACTIONS(6135),
    [aux_sym_preproc_elif_token1] = ACTIONS(6133),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6135),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6135),
    [anon_sym_LPAREN2] = ACTIONS(6042),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6133),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6133),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_LT] = ACTIONS(6133),
    [anon_sym_GT_GT] = ACTIONS(6133),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym___attribute__] = ACTIONS(6133),
    [anon_sym___attribute] = ACTIONS(6133),
    [anon_sym_COLON] = ACTIONS(6135),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6044),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6046),
    [anon_sym_RBRACK] = ACTIONS(6135),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_QMARK] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_and_eq] = ACTIONS(6133),
    [anon_sym_or_eq] = ACTIONS(6133),
    [anon_sym_xor_eq] = ACTIONS(6133),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(6133),
    [anon_sym_bitor] = ACTIONS(6133),
    [anon_sym_xor] = ACTIONS(6133),
    [anon_sym_bitand] = ACTIONS(6133),
    [anon_sym_not_eq] = ACTIONS(6133),
    [anon_sym_DASH_DASH] = ACTIONS(6135),
    [anon_sym_PLUS_PLUS] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(6133),
    [anon_sym_DOT_STAR] = ACTIONS(6135),
    [anon_sym_DASH_GT] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
  },
  [2195] = {
    [sym_identifier] = ACTIONS(5629),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5631),
    [anon_sym_COMMA] = ACTIONS(5631),
    [anon_sym_RPAREN] = ACTIONS(5631),
    [aux_sym_preproc_if_token2] = ACTIONS(5631),
    [aux_sym_preproc_else_token1] = ACTIONS(5631),
    [aux_sym_preproc_elif_token1] = ACTIONS(5629),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5631),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5631),
    [anon_sym_LPAREN2] = ACTIONS(5631),
    [anon_sym_DASH] = ACTIONS(5629),
    [anon_sym_PLUS] = ACTIONS(5629),
    [anon_sym_STAR] = ACTIONS(5629),
    [anon_sym_SLASH] = ACTIONS(5629),
    [anon_sym_PERCENT] = ACTIONS(5629),
    [anon_sym_PIPE_PIPE] = ACTIONS(5631),
    [anon_sym_AMP_AMP] = ACTIONS(5631),
    [anon_sym_PIPE] = ACTIONS(5629),
    [anon_sym_CARET] = ACTIONS(5629),
    [anon_sym_AMP] = ACTIONS(5629),
    [anon_sym_EQ_EQ] = ACTIONS(5631),
    [anon_sym_BANG_EQ] = ACTIONS(5631),
    [anon_sym_GT] = ACTIONS(5629),
    [anon_sym_GT_EQ] = ACTIONS(5631),
    [anon_sym_LT_EQ] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5629),
    [anon_sym_LT_LT] = ACTIONS(5629),
    [anon_sym_GT_GT] = ACTIONS(5629),
    [anon_sym_SEMI] = ACTIONS(5631),
    [anon_sym___attribute__] = ACTIONS(5629),
    [anon_sym___attribute] = ACTIONS(5629),
    [anon_sym_COLON] = ACTIONS(5629),
    [anon_sym_COLON_COLON] = ACTIONS(5631),
    [anon_sym_LBRACE] = ACTIONS(5631),
    [anon_sym_RBRACE] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_RBRACK] = ACTIONS(5631),
    [anon_sym_EQ] = ACTIONS(5629),
    [anon_sym_QMARK] = ACTIONS(5631),
    [anon_sym_STAR_EQ] = ACTIONS(5631),
    [anon_sym_SLASH_EQ] = ACTIONS(5631),
    [anon_sym_PERCENT_EQ] = ACTIONS(5631),
    [anon_sym_PLUS_EQ] = ACTIONS(5631),
    [anon_sym_DASH_EQ] = ACTIONS(5631),
    [anon_sym_LT_LT_EQ] = ACTIONS(5631),
    [anon_sym_GT_GT_EQ] = ACTIONS(5631),
    [anon_sym_AMP_EQ] = ACTIONS(5631),
    [anon_sym_CARET_EQ] = ACTIONS(5631),
    [anon_sym_PIPE_EQ] = ACTIONS(5631),
    [anon_sym_and_eq] = ACTIONS(5629),
    [anon_sym_or_eq] = ACTIONS(5629),
    [anon_sym_xor_eq] = ACTIONS(5629),
    [anon_sym_LT_EQ_GT] = ACTIONS(5631),
    [anon_sym_or] = ACTIONS(5629),
    [anon_sym_and] = ACTIONS(5629),
    [anon_sym_bitor] = ACTIONS(5629),
    [anon_sym_xor] = ACTIONS(5629),
    [anon_sym_bitand] = ACTIONS(5629),
    [anon_sym_not_eq] = ACTIONS(5629),
    [anon_sym_DASH_DASH] = ACTIONS(5631),
    [anon_sym_PLUS_PLUS] = ACTIONS(5631),
    [anon_sym_DOT] = ACTIONS(5629),
    [anon_sym_DOT_STAR] = ACTIONS(5631),
    [anon_sym_DASH_GT] = ACTIONS(5631),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5629),
    [anon_sym_decltype] = ACTIONS(5629),
  },
  [2196] = {
    [sym_string_literal] = STATE(2196),
    [sym_raw_string_literal] = STATE(2196),
    [aux_sym_concatenated_string_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(6137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_RPAREN] = ACTIONS(5403),
    [anon_sym_LPAREN2] = ACTIONS(5403),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5405),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5405),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_CARET] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_LT_EQ] = ACTIONS(5405),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5405),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_EQ] = ACTIONS(5405),
    [anon_sym_QMARK] = ACTIONS(5403),
    [anon_sym_STAR_EQ] = ACTIONS(5403),
    [anon_sym_SLASH_EQ] = ACTIONS(5403),
    [anon_sym_PERCENT_EQ] = ACTIONS(5403),
    [anon_sym_PLUS_EQ] = ACTIONS(5403),
    [anon_sym_DASH_EQ] = ACTIONS(5403),
    [anon_sym_LT_LT_EQ] = ACTIONS(5403),
    [anon_sym_GT_GT_EQ] = ACTIONS(5403),
    [anon_sym_AMP_EQ] = ACTIONS(5403),
    [anon_sym_CARET_EQ] = ACTIONS(5403),
    [anon_sym_PIPE_EQ] = ACTIONS(5403),
    [anon_sym_and_eq] = ACTIONS(5405),
    [anon_sym_or_eq] = ACTIONS(5405),
    [anon_sym_xor_eq] = ACTIONS(5405),
    [anon_sym_LT_EQ_GT] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5405),
    [anon_sym_and] = ACTIONS(5405),
    [anon_sym_bitor] = ACTIONS(5405),
    [anon_sym_xor] = ACTIONS(5405),
    [anon_sym_bitand] = ACTIONS(5405),
    [anon_sym_not_eq] = ACTIONS(5405),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_DOT_STAR] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5405),
    [anon_sym_L_DQUOTE] = ACTIONS(6140),
    [anon_sym_u_DQUOTE] = ACTIONS(6140),
    [anon_sym_U_DQUOTE] = ACTIONS(6140),
    [anon_sym_u8_DQUOTE] = ACTIONS(6140),
    [anon_sym_DQUOTE] = ACTIONS(6140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6143),
    [anon_sym_LR_DQUOTE] = ACTIONS(6143),
    [anon_sym_uR_DQUOTE] = ACTIONS(6143),
    [anon_sym_UR_DQUOTE] = ACTIONS(6143),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6143),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5403),
    [sym_literal_suffix] = ACTIONS(5405),
  },
  [2197] = {
    [sym_template_argument_list] = STATE(1941),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [anon_sym_RPAREN] = ACTIONS(4152),
    [anon_sym_LPAREN2] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4144),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4144),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4152),
    [anon_sym_AMP_AMP] = ACTIONS(4152),
    [anon_sym_PIPE] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_AMP] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(4152),
    [anon_sym_GT] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4152),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(5840),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4144),
    [anon_sym_SEMI] = ACTIONS(4152),
    [anon_sym___attribute__] = ACTIONS(4152),
    [anon_sym___attribute] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4152),
    [anon_sym_RBRACE] = ACTIONS(4152),
    [anon_sym_signed] = ACTIONS(6146),
    [anon_sym_unsigned] = ACTIONS(6146),
    [anon_sym_long] = ACTIONS(6146),
    [anon_sym_short] = ACTIONS(6146),
    [anon_sym_LBRACK] = ACTIONS(4152),
    [anon_sym_RBRACK] = ACTIONS(4152),
    [anon_sym_EQ] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4152),
    [anon_sym_STAR_EQ] = ACTIONS(4152),
    [anon_sym_SLASH_EQ] = ACTIONS(4152),
    [anon_sym_PERCENT_EQ] = ACTIONS(4152),
    [anon_sym_PLUS_EQ] = ACTIONS(4152),
    [anon_sym_DASH_EQ] = ACTIONS(4152),
    [anon_sym_LT_LT_EQ] = ACTIONS(4152),
    [anon_sym_GT_GT_EQ] = ACTIONS(4152),
    [anon_sym_AMP_EQ] = ACTIONS(4152),
    [anon_sym_CARET_EQ] = ACTIONS(4152),
    [anon_sym_PIPE_EQ] = ACTIONS(4152),
    [anon_sym_and_eq] = ACTIONS(4152),
    [anon_sym_or_eq] = ACTIONS(4152),
    [anon_sym_xor_eq] = ACTIONS(4152),
    [anon_sym_LT_EQ_GT] = ACTIONS(4152),
    [anon_sym_or] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_bitor] = ACTIONS(4152),
    [anon_sym_xor] = ACTIONS(4144),
    [anon_sym_bitand] = ACTIONS(4152),
    [anon_sym_not_eq] = ACTIONS(4152),
    [anon_sym_DASH_DASH] = ACTIONS(4152),
    [anon_sym_PLUS_PLUS] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(4144),
    [anon_sym_DOT_STAR] = ACTIONS(4152),
    [anon_sym_DASH_GT] = ACTIONS(4152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4152),
    [anon_sym_decltype] = ACTIONS(4152),
  },
  [2198] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2198),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5072),
    [anon_sym_COMMA] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_PLUS] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5072),
    [anon_sym_SLASH] = ACTIONS(5070),
    [anon_sym_PERCENT] = ACTIONS(5072),
    [anon_sym_PIPE_PIPE] = ACTIONS(5072),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5070),
    [anon_sym_CARET] = ACTIONS(5072),
    [anon_sym_AMP] = ACTIONS(5070),
    [anon_sym_EQ_EQ] = ACTIONS(5072),
    [anon_sym_BANG_EQ] = ACTIONS(5072),
    [anon_sym_GT] = ACTIONS(5070),
    [anon_sym_GT_EQ] = ACTIONS(5070),
    [anon_sym_LT_EQ] = ACTIONS(5070),
    [anon_sym_LT] = ACTIONS(5070),
    [anon_sym_LT_LT] = ACTIONS(5072),
    [anon_sym_GT_GT] = ACTIONS(5070),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5070),
    [anon_sym___attribute] = ACTIONS(5070),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_signed] = ACTIONS(6148),
    [anon_sym_unsigned] = ACTIONS(6148),
    [anon_sym_long] = ACTIONS(6148),
    [anon_sym_short] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym__Nonnull] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_alignas] = ACTIONS(5070),
    [anon_sym__Alignas] = ACTIONS(5070),
    [sym_primitive_type] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5072),
    [anon_sym_LT_EQ_GT] = ACTIONS(5072),
    [anon_sym_or] = ACTIONS(5070),
    [anon_sym_and] = ACTIONS(5070),
    [anon_sym_bitor] = ACTIONS(5070),
    [anon_sym_xor] = ACTIONS(5070),
    [anon_sym_bitand] = ACTIONS(5070),
    [anon_sym_not_eq] = ACTIONS(5070),
    [anon_sym_DASH_DASH] = ACTIONS(5072),
    [anon_sym_PLUS_PLUS] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5070),
    [anon_sym_DOT_STAR] = ACTIONS(5072),
    [anon_sym_DASH_GT] = ACTIONS(5072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5070),
    [anon_sym_decltype] = ACTIONS(5070),
    [anon_sym_final] = ACTIONS(5070),
    [anon_sym_override] = ACTIONS(5070),
    [anon_sym_GT2] = ACTIONS(5072),
    [anon_sym_requires] = ACTIONS(5070),
  },
  [2199] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COLON] = ACTIONS(4380),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4182),
    [anon_sym_SLASH_EQ] = ACTIONS(4182),
    [anon_sym_PERCENT_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_DASH_EQ] = ACTIONS(4182),
    [anon_sym_LT_LT_EQ] = ACTIONS(4182),
    [anon_sym_GT_GT_EQ] = ACTIONS(4182),
    [anon_sym_AMP_EQ] = ACTIONS(4182),
    [anon_sym_CARET_EQ] = ACTIONS(4182),
    [anon_sym_PIPE_EQ] = ACTIONS(4182),
    [anon_sym_and_eq] = ACTIONS(4182),
    [anon_sym_or_eq] = ACTIONS(4182),
    [anon_sym_xor_eq] = ACTIONS(4182),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2200] = {
    [sym_attribute_specifier] = STATE(2257),
    [sym_identifier] = ACTIONS(6151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6153),
    [anon_sym_COMMA] = ACTIONS(6153),
    [anon_sym_RPAREN] = ACTIONS(6153),
    [aux_sym_preproc_if_token2] = ACTIONS(6153),
    [aux_sym_preproc_else_token1] = ACTIONS(6153),
    [aux_sym_preproc_elif_token1] = ACTIONS(6151),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6153),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6153),
    [anon_sym_LPAREN2] = ACTIONS(6153),
    [anon_sym_DASH] = ACTIONS(6151),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_STAR] = ACTIONS(6151),
    [anon_sym_SLASH] = ACTIONS(6151),
    [anon_sym_PERCENT] = ACTIONS(6151),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_AMP_AMP] = ACTIONS(6153),
    [anon_sym_PIPE] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6151),
    [anon_sym_EQ_EQ] = ACTIONS(6153),
    [anon_sym_BANG_EQ] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(6151),
    [anon_sym_GT_EQ] = ACTIONS(6153),
    [anon_sym_LT_EQ] = ACTIONS(6151),
    [anon_sym_LT] = ACTIONS(6151),
    [anon_sym_LT_LT] = ACTIONS(6151),
    [anon_sym_GT_GT] = ACTIONS(6151),
    [anon_sym_SEMI] = ACTIONS(6153),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6153),
    [anon_sym_LBRACE] = ACTIONS(6153),
    [anon_sym_RBRACE] = ACTIONS(6153),
    [anon_sym_LBRACK] = ACTIONS(6153),
    [anon_sym_RBRACK] = ACTIONS(6153),
    [anon_sym_EQ] = ACTIONS(6151),
    [anon_sym_QMARK] = ACTIONS(6153),
    [anon_sym_STAR_EQ] = ACTIONS(6153),
    [anon_sym_SLASH_EQ] = ACTIONS(6153),
    [anon_sym_PERCENT_EQ] = ACTIONS(6153),
    [anon_sym_PLUS_EQ] = ACTIONS(6153),
    [anon_sym_DASH_EQ] = ACTIONS(6153),
    [anon_sym_LT_LT_EQ] = ACTIONS(6153),
    [anon_sym_GT_GT_EQ] = ACTIONS(6153),
    [anon_sym_AMP_EQ] = ACTIONS(6153),
    [anon_sym_CARET_EQ] = ACTIONS(6153),
    [anon_sym_PIPE_EQ] = ACTIONS(6153),
    [anon_sym_and_eq] = ACTIONS(6151),
    [anon_sym_or_eq] = ACTIONS(6151),
    [anon_sym_xor_eq] = ACTIONS(6151),
    [anon_sym_LT_EQ_GT] = ACTIONS(6153),
    [anon_sym_or] = ACTIONS(6151),
    [anon_sym_and] = ACTIONS(6151),
    [anon_sym_bitor] = ACTIONS(6151),
    [anon_sym_xor] = ACTIONS(6151),
    [anon_sym_bitand] = ACTIONS(6151),
    [anon_sym_not_eq] = ACTIONS(6151),
    [anon_sym_DASH_DASH] = ACTIONS(6153),
    [anon_sym_PLUS_PLUS] = ACTIONS(6153),
    [anon_sym_DOT] = ACTIONS(6151),
    [anon_sym_DOT_STAR] = ACTIONS(6153),
    [anon_sym_DASH_GT] = ACTIONS(6153),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6151),
    [anon_sym_decltype] = ACTIONS(6151),
  },
  [2201] = {
    [sym_attribute_specifier] = STATE(2263),
    [sym_identifier] = ACTIONS(6155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6157),
    [anon_sym_COMMA] = ACTIONS(6157),
    [anon_sym_RPAREN] = ACTIONS(6157),
    [aux_sym_preproc_if_token2] = ACTIONS(6157),
    [aux_sym_preproc_else_token1] = ACTIONS(6157),
    [aux_sym_preproc_elif_token1] = ACTIONS(6155),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6157),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6157),
    [anon_sym_LPAREN2] = ACTIONS(6157),
    [anon_sym_DASH] = ACTIONS(6155),
    [anon_sym_PLUS] = ACTIONS(6155),
    [anon_sym_STAR] = ACTIONS(6155),
    [anon_sym_SLASH] = ACTIONS(6155),
    [anon_sym_PERCENT] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE] = ACTIONS(6157),
    [anon_sym_AMP_AMP] = ACTIONS(6157),
    [anon_sym_PIPE] = ACTIONS(6155),
    [anon_sym_CARET] = ACTIONS(6155),
    [anon_sym_AMP] = ACTIONS(6155),
    [anon_sym_EQ_EQ] = ACTIONS(6157),
    [anon_sym_BANG_EQ] = ACTIONS(6157),
    [anon_sym_GT] = ACTIONS(6155),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [anon_sym_LT_EQ] = ACTIONS(6155),
    [anon_sym_LT] = ACTIONS(6155),
    [anon_sym_LT_LT] = ACTIONS(6155),
    [anon_sym_GT_GT] = ACTIONS(6155),
    [anon_sym_SEMI] = ACTIONS(6157),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6157),
    [anon_sym_LBRACE] = ACTIONS(6157),
    [anon_sym_RBRACE] = ACTIONS(6157),
    [anon_sym_LBRACK] = ACTIONS(6157),
    [anon_sym_RBRACK] = ACTIONS(6157),
    [anon_sym_EQ] = ACTIONS(6155),
    [anon_sym_QMARK] = ACTIONS(6157),
    [anon_sym_STAR_EQ] = ACTIONS(6157),
    [anon_sym_SLASH_EQ] = ACTIONS(6157),
    [anon_sym_PERCENT_EQ] = ACTIONS(6157),
    [anon_sym_PLUS_EQ] = ACTIONS(6157),
    [anon_sym_DASH_EQ] = ACTIONS(6157),
    [anon_sym_LT_LT_EQ] = ACTIONS(6157),
    [anon_sym_GT_GT_EQ] = ACTIONS(6157),
    [anon_sym_AMP_EQ] = ACTIONS(6157),
    [anon_sym_CARET_EQ] = ACTIONS(6157),
    [anon_sym_PIPE_EQ] = ACTIONS(6157),
    [anon_sym_and_eq] = ACTIONS(6155),
    [anon_sym_or_eq] = ACTIONS(6155),
    [anon_sym_xor_eq] = ACTIONS(6155),
    [anon_sym_LT_EQ_GT] = ACTIONS(6157),
    [anon_sym_or] = ACTIONS(6155),
    [anon_sym_and] = ACTIONS(6155),
    [anon_sym_bitor] = ACTIONS(6155),
    [anon_sym_xor] = ACTIONS(6155),
    [anon_sym_bitand] = ACTIONS(6155),
    [anon_sym_not_eq] = ACTIONS(6155),
    [anon_sym_DASH_DASH] = ACTIONS(6157),
    [anon_sym_PLUS_PLUS] = ACTIONS(6157),
    [anon_sym_DOT] = ACTIONS(6155),
    [anon_sym_DOT_STAR] = ACTIONS(6157),
    [anon_sym_DASH_GT] = ACTIONS(6157),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6155),
    [anon_sym_decltype] = ACTIONS(6155),
  },
  [2202] = {
    [sym_string_literal] = STATE(2370),
    [sym_template_argument_list] = STATE(3664),
    [sym_raw_string_literal] = STATE(2370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(6159),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(6162),
    [anon_sym_or_eq] = ACTIONS(6162),
    [anon_sym_xor_eq] = ACTIONS(6162),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4154),
    [anon_sym_L_DQUOTE] = ACTIONS(4411),
    [anon_sym_u_DQUOTE] = ACTIONS(4411),
    [anon_sym_U_DQUOTE] = ACTIONS(4411),
    [anon_sym_u8_DQUOTE] = ACTIONS(4411),
    [anon_sym_DQUOTE] = ACTIONS(4411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4413),
    [anon_sym_LR_DQUOTE] = ACTIONS(4413),
    [anon_sym_uR_DQUOTE] = ACTIONS(4413),
    [anon_sym_UR_DQUOTE] = ACTIONS(4413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4413),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4146),
  },
  [2203] = {
    [sym_attribute_declaration] = STATE(2270),
    [sym_parameter_list] = STATE(2298),
    [aux_sym_attributed_declarator_repeat1] = STATE(2270),
    [sym_identifier] = ACTIONS(6164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6166),
    [anon_sym_COMMA] = ACTIONS(6166),
    [anon_sym_RPAREN] = ACTIONS(6166),
    [aux_sym_preproc_if_token2] = ACTIONS(6166),
    [aux_sym_preproc_else_token1] = ACTIONS(6166),
    [aux_sym_preproc_elif_token1] = ACTIONS(6164),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6166),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6166),
    [anon_sym_LPAREN2] = ACTIONS(6042),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_PERCENT] = ACTIONS(6164),
    [anon_sym_PIPE_PIPE] = ACTIONS(6166),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_AMP] = ACTIONS(6164),
    [anon_sym_EQ_EQ] = ACTIONS(6166),
    [anon_sym_BANG_EQ] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6164),
    [anon_sym_GT_EQ] = ACTIONS(6166),
    [anon_sym_LT_EQ] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6164),
    [anon_sym_LT_LT] = ACTIONS(6164),
    [anon_sym_GT_GT] = ACTIONS(6164),
    [anon_sym_SEMI] = ACTIONS(6166),
    [anon_sym___attribute__] = ACTIONS(6164),
    [anon_sym___attribute] = ACTIONS(6164),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6044),
    [anon_sym_RBRACE] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(6046),
    [anon_sym_RBRACK] = ACTIONS(6166),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_QMARK] = ACTIONS(6166),
    [anon_sym_STAR_EQ] = ACTIONS(6166),
    [anon_sym_SLASH_EQ] = ACTIONS(6166),
    [anon_sym_PERCENT_EQ] = ACTIONS(6166),
    [anon_sym_PLUS_EQ] = ACTIONS(6166),
    [anon_sym_DASH_EQ] = ACTIONS(6166),
    [anon_sym_LT_LT_EQ] = ACTIONS(6166),
    [anon_sym_GT_GT_EQ] = ACTIONS(6166),
    [anon_sym_AMP_EQ] = ACTIONS(6166),
    [anon_sym_CARET_EQ] = ACTIONS(6166),
    [anon_sym_PIPE_EQ] = ACTIONS(6166),
    [anon_sym_and_eq] = ACTIONS(6164),
    [anon_sym_or_eq] = ACTIONS(6164),
    [anon_sym_xor_eq] = ACTIONS(6164),
    [anon_sym_LT_EQ_GT] = ACTIONS(6166),
    [anon_sym_or] = ACTIONS(6164),
    [anon_sym_and] = ACTIONS(6164),
    [anon_sym_bitor] = ACTIONS(6164),
    [anon_sym_xor] = ACTIONS(6164),
    [anon_sym_bitand] = ACTIONS(6164),
    [anon_sym_not_eq] = ACTIONS(6164),
    [anon_sym_DASH_DASH] = ACTIONS(6166),
    [anon_sym_PLUS_PLUS] = ACTIONS(6166),
    [anon_sym_DOT] = ACTIONS(6164),
    [anon_sym_DOT_STAR] = ACTIONS(6166),
    [anon_sym_DASH_GT] = ACTIONS(6166),
    [sym_comment] = ACTIONS(3),
  },
  [2204] = {
    [sym_string_literal] = STATE(2189),
    [sym_template_argument_list] = STATE(3129),
    [sym_raw_string_literal] = STATE(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5044),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4146),
    [anon_sym_or_eq] = ACTIONS(4146),
    [anon_sym_xor_eq] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4154),
    [anon_sym_L_DQUOTE] = ACTIONS(5040),
    [anon_sym_u_DQUOTE] = ACTIONS(5040),
    [anon_sym_U_DQUOTE] = ACTIONS(5040),
    [anon_sym_u8_DQUOTE] = ACTIONS(5040),
    [anon_sym_DQUOTE] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5042),
    [anon_sym_LR_DQUOTE] = ACTIONS(5042),
    [anon_sym_uR_DQUOTE] = ACTIONS(5042),
    [anon_sym_UR_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5042),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4146),
  },
  [2205] = {
    [sym_template_argument_list] = STATE(1603),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5979),
    [anon_sym_COMMA] = ACTIONS(5979),
    [anon_sym_RPAREN] = ACTIONS(5979),
    [anon_sym_LPAREN2] = ACTIONS(5979),
    [anon_sym_DASH] = ACTIONS(5977),
    [anon_sym_PLUS] = ACTIONS(5977),
    [anon_sym_STAR] = ACTIONS(5977),
    [anon_sym_SLASH] = ACTIONS(5977),
    [anon_sym_PERCENT] = ACTIONS(5977),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_AMP_AMP] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [anon_sym_AMP] = ACTIONS(5977),
    [anon_sym_EQ_EQ] = ACTIONS(5979),
    [anon_sym_BANG_EQ] = ACTIONS(5979),
    [anon_sym_GT] = ACTIONS(5977),
    [anon_sym_GT_EQ] = ACTIONS(5979),
    [anon_sym_LT_EQ] = ACTIONS(5977),
    [anon_sym_LT] = ACTIONS(5977),
    [anon_sym_LT_LT] = ACTIONS(5977),
    [anon_sym_GT_GT] = ACTIONS(5977),
    [anon_sym_SEMI] = ACTIONS(5979),
    [anon_sym___attribute__] = ACTIONS(5979),
    [anon_sym___attribute] = ACTIONS(5977),
    [anon_sym_COLON] = ACTIONS(5977),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(5979),
    [anon_sym_RBRACE] = ACTIONS(5979),
    [anon_sym_signed] = ACTIONS(6146),
    [anon_sym_unsigned] = ACTIONS(6146),
    [anon_sym_long] = ACTIONS(6146),
    [anon_sym_short] = ACTIONS(6146),
    [anon_sym_LBRACK] = ACTIONS(5979),
    [anon_sym_RBRACK] = ACTIONS(5979),
    [anon_sym_EQ] = ACTIONS(5977),
    [anon_sym_QMARK] = ACTIONS(5979),
    [anon_sym_STAR_EQ] = ACTIONS(5979),
    [anon_sym_SLASH_EQ] = ACTIONS(5979),
    [anon_sym_PERCENT_EQ] = ACTIONS(5979),
    [anon_sym_PLUS_EQ] = ACTIONS(5979),
    [anon_sym_DASH_EQ] = ACTIONS(5979),
    [anon_sym_LT_LT_EQ] = ACTIONS(5979),
    [anon_sym_GT_GT_EQ] = ACTIONS(5979),
    [anon_sym_AMP_EQ] = ACTIONS(5979),
    [anon_sym_CARET_EQ] = ACTIONS(5979),
    [anon_sym_PIPE_EQ] = ACTIONS(5979),
    [anon_sym_and_eq] = ACTIONS(5979),
    [anon_sym_or_eq] = ACTIONS(5979),
    [anon_sym_xor_eq] = ACTIONS(5979),
    [anon_sym_LT_EQ_GT] = ACTIONS(5979),
    [anon_sym_or] = ACTIONS(5977),
    [anon_sym_and] = ACTIONS(5977),
    [anon_sym_bitor] = ACTIONS(5979),
    [anon_sym_xor] = ACTIONS(5977),
    [anon_sym_bitand] = ACTIONS(5979),
    [anon_sym_not_eq] = ACTIONS(5979),
    [anon_sym_DASH_DASH] = ACTIONS(5979),
    [anon_sym_PLUS_PLUS] = ACTIONS(5979),
    [anon_sym_DOT] = ACTIONS(5977),
    [anon_sym_DOT_STAR] = ACTIONS(5979),
    [anon_sym_DASH_GT] = ACTIONS(5979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5979),
    [anon_sym_decltype] = ACTIONS(5979),
  },
  [2206] = {
    [sym_attribute_specifier] = STATE(2290),
    [sym_identifier] = ACTIONS(6168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6170),
    [anon_sym_COMMA] = ACTIONS(6170),
    [anon_sym_RPAREN] = ACTIONS(6170),
    [aux_sym_preproc_if_token2] = ACTIONS(6170),
    [aux_sym_preproc_else_token1] = ACTIONS(6170),
    [aux_sym_preproc_elif_token1] = ACTIONS(6168),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6170),
    [anon_sym_LPAREN2] = ACTIONS(6170),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_PERCENT] = ACTIONS(6168),
    [anon_sym_PIPE_PIPE] = ACTIONS(6170),
    [anon_sym_AMP_AMP] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_AMP] = ACTIONS(6168),
    [anon_sym_EQ_EQ] = ACTIONS(6170),
    [anon_sym_BANG_EQ] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6168),
    [anon_sym_GT_EQ] = ACTIONS(6170),
    [anon_sym_LT_EQ] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6168),
    [anon_sym_LT_LT] = ACTIONS(6168),
    [anon_sym_GT_GT] = ACTIONS(6168),
    [anon_sym_SEMI] = ACTIONS(6170),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_LBRACE] = ACTIONS(6170),
    [anon_sym_RBRACE] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6170),
    [anon_sym_RBRACK] = ACTIONS(6170),
    [anon_sym_EQ] = ACTIONS(6168),
    [anon_sym_QMARK] = ACTIONS(6170),
    [anon_sym_STAR_EQ] = ACTIONS(6170),
    [anon_sym_SLASH_EQ] = ACTIONS(6170),
    [anon_sym_PERCENT_EQ] = ACTIONS(6170),
    [anon_sym_PLUS_EQ] = ACTIONS(6170),
    [anon_sym_DASH_EQ] = ACTIONS(6170),
    [anon_sym_LT_LT_EQ] = ACTIONS(6170),
    [anon_sym_GT_GT_EQ] = ACTIONS(6170),
    [anon_sym_AMP_EQ] = ACTIONS(6170),
    [anon_sym_CARET_EQ] = ACTIONS(6170),
    [anon_sym_PIPE_EQ] = ACTIONS(6170),
    [anon_sym_and_eq] = ACTIONS(6168),
    [anon_sym_or_eq] = ACTIONS(6168),
    [anon_sym_xor_eq] = ACTIONS(6168),
    [anon_sym_LT_EQ_GT] = ACTIONS(6170),
    [anon_sym_or] = ACTIONS(6168),
    [anon_sym_and] = ACTIONS(6168),
    [anon_sym_bitor] = ACTIONS(6168),
    [anon_sym_xor] = ACTIONS(6168),
    [anon_sym_bitand] = ACTIONS(6168),
    [anon_sym_not_eq] = ACTIONS(6168),
    [anon_sym_DASH_DASH] = ACTIONS(6170),
    [anon_sym_PLUS_PLUS] = ACTIONS(6170),
    [anon_sym_DOT] = ACTIONS(6168),
    [anon_sym_DOT_STAR] = ACTIONS(6170),
    [anon_sym_DASH_GT] = ACTIONS(6170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6168),
    [anon_sym_decltype] = ACTIONS(6168),
  },
  [2207] = {
    [sym_identifier] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5812),
    [anon_sym_RPAREN] = ACTIONS(5812),
    [aux_sym_preproc_if_token2] = ACTIONS(5812),
    [aux_sym_preproc_else_token1] = ACTIONS(5812),
    [aux_sym_preproc_elif_token1] = ACTIONS(5810),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5812),
    [anon_sym_LPAREN2] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_PERCENT] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_PIPE] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_AMP] = ACTIONS(5810),
    [anon_sym_EQ_EQ] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5812),
    [anon_sym_GT] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5810),
    [anon_sym_LT_LT] = ACTIONS(5810),
    [anon_sym_GT_GT] = ACTIONS(5810),
    [anon_sym_SEMI] = ACTIONS(5812),
    [anon_sym___attribute__] = ACTIONS(5810),
    [anon_sym___attribute] = ACTIONS(5810),
    [anon_sym_COLON] = ACTIONS(5812),
    [anon_sym_LBRACE] = ACTIONS(5812),
    [anon_sym_RBRACE] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_RBRACK] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5812),
    [anon_sym_STAR_EQ] = ACTIONS(5812),
    [anon_sym_SLASH_EQ] = ACTIONS(5812),
    [anon_sym_PERCENT_EQ] = ACTIONS(5812),
    [anon_sym_PLUS_EQ] = ACTIONS(5812),
    [anon_sym_DASH_EQ] = ACTIONS(5812),
    [anon_sym_LT_LT_EQ] = ACTIONS(5812),
    [anon_sym_GT_GT_EQ] = ACTIONS(5812),
    [anon_sym_AMP_EQ] = ACTIONS(5812),
    [anon_sym_CARET_EQ] = ACTIONS(5812),
    [anon_sym_PIPE_EQ] = ACTIONS(5812),
    [anon_sym_and_eq] = ACTIONS(5810),
    [anon_sym_or_eq] = ACTIONS(5810),
    [anon_sym_xor_eq] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5812),
    [anon_sym_or] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(5810),
    [anon_sym_bitor] = ACTIONS(5810),
    [anon_sym_xor] = ACTIONS(5810),
    [anon_sym_bitand] = ACTIONS(5810),
    [anon_sym_not_eq] = ACTIONS(5810),
    [anon_sym_DASH_DASH] = ACTIONS(5812),
    [anon_sym_PLUS_PLUS] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5810),
    [anon_sym_DOT_STAR] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5810),
    [anon_sym_decltype] = ACTIONS(5810),
  },
  [2208] = {
    [sym_string_literal] = STATE(3517),
    [sym_template_argument_list] = STATE(4509),
    [sym_raw_string_literal] = STATE(3517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4154),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5057),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(5062),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(5064),
    [anon_sym_SLASH_EQ] = ACTIONS(5064),
    [anon_sym_PERCENT_EQ] = ACTIONS(5064),
    [anon_sym_PLUS_EQ] = ACTIONS(5064),
    [anon_sym_DASH_EQ] = ACTIONS(5064),
    [anon_sym_LT_LT_EQ] = ACTIONS(5064),
    [anon_sym_GT_GT_EQ] = ACTIONS(5062),
    [anon_sym_AMP_EQ] = ACTIONS(5064),
    [anon_sym_CARET_EQ] = ACTIONS(5064),
    [anon_sym_PIPE_EQ] = ACTIONS(5064),
    [anon_sym_and_eq] = ACTIONS(5064),
    [anon_sym_or_eq] = ACTIONS(5064),
    [anon_sym_xor_eq] = ACTIONS(5064),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(5066),
    [anon_sym_u_DQUOTE] = ACTIONS(5066),
    [anon_sym_U_DQUOTE] = ACTIONS(5066),
    [anon_sym_u8_DQUOTE] = ACTIONS(5066),
    [anon_sym_DQUOTE] = ACTIONS(5066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4146),
    [anon_sym_R_DQUOTE] = ACTIONS(5068),
    [anon_sym_LR_DQUOTE] = ACTIONS(5068),
    [anon_sym_uR_DQUOTE] = ACTIONS(5068),
    [anon_sym_UR_DQUOTE] = ACTIONS(5068),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5068),
  },
  [2209] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5484),
    [anon_sym_COMMA] = ACTIONS(5484),
    [anon_sym_RPAREN] = ACTIONS(5484),
    [anon_sym_LPAREN2] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5482),
    [anon_sym_STAR] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_PIPE] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5482),
    [anon_sym_AMP] = ACTIONS(5482),
    [anon_sym_EQ_EQ] = ACTIONS(5484),
    [anon_sym_BANG_EQ] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5482),
    [anon_sym_GT_EQ] = ACTIONS(5484),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5482),
    [anon_sym_LT_LT] = ACTIONS(5482),
    [anon_sym_GT_GT] = ACTIONS(5482),
    [anon_sym_SEMI] = ACTIONS(5484),
    [anon_sym_COLON] = ACTIONS(5484),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [anon_sym_LBRACK] = ACTIONS(5484),
    [anon_sym_RBRACK] = ACTIONS(5484),
    [anon_sym_EQ] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5484),
    [anon_sym_STAR_EQ] = ACTIONS(5484),
    [anon_sym_SLASH_EQ] = ACTIONS(5484),
    [anon_sym_PERCENT_EQ] = ACTIONS(5484),
    [anon_sym_PLUS_EQ] = ACTIONS(5484),
    [anon_sym_DASH_EQ] = ACTIONS(5484),
    [anon_sym_LT_LT_EQ] = ACTIONS(5484),
    [anon_sym_GT_GT_EQ] = ACTIONS(5484),
    [anon_sym_AMP_EQ] = ACTIONS(5484),
    [anon_sym_CARET_EQ] = ACTIONS(5484),
    [anon_sym_PIPE_EQ] = ACTIONS(5484),
    [anon_sym_and_eq] = ACTIONS(5482),
    [anon_sym_or_eq] = ACTIONS(5482),
    [anon_sym_xor_eq] = ACTIONS(5482),
    [anon_sym_LT_EQ_GT] = ACTIONS(5484),
    [anon_sym_or] = ACTIONS(5482),
    [anon_sym_and] = ACTIONS(5482),
    [anon_sym_bitor] = ACTIONS(5482),
    [anon_sym_xor] = ACTIONS(5482),
    [anon_sym_bitand] = ACTIONS(5482),
    [anon_sym_not_eq] = ACTIONS(5482),
    [anon_sym_DASH_DASH] = ACTIONS(5484),
    [anon_sym_PLUS_PLUS] = ACTIONS(5484),
    [anon_sym_DOT] = ACTIONS(5482),
    [anon_sym_DOT_STAR] = ACTIONS(5484),
    [anon_sym_DASH_GT] = ACTIONS(5484),
    [anon_sym_L_DQUOTE] = ACTIONS(5484),
    [anon_sym_u_DQUOTE] = ACTIONS(5484),
    [anon_sym_U_DQUOTE] = ACTIONS(5484),
    [anon_sym_u8_DQUOTE] = ACTIONS(5484),
    [anon_sym_DQUOTE] = ACTIONS(5484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5484),
    [anon_sym_LR_DQUOTE] = ACTIONS(5484),
    [anon_sym_uR_DQUOTE] = ACTIONS(5484),
    [anon_sym_UR_DQUOTE] = ACTIONS(5484),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5484),
    [sym_literal_suffix] = ACTIONS(5482),
  },
  [2210] = {
    [sym_argument_list] = STATE(2464),
    [sym_initializer_list] = STATE(2464),
    [sym_identifier] = ACTIONS(6172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6174),
    [anon_sym_COMMA] = ACTIONS(6174),
    [anon_sym_RPAREN] = ACTIONS(6174),
    [aux_sym_preproc_if_token2] = ACTIONS(6174),
    [aux_sym_preproc_else_token1] = ACTIONS(6174),
    [aux_sym_preproc_elif_token1] = ACTIONS(6172),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6174),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6174),
    [anon_sym_LPAREN2] = ACTIONS(5827),
    [anon_sym_DASH] = ACTIONS(6172),
    [anon_sym_PLUS] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_SLASH] = ACTIONS(6172),
    [anon_sym_PERCENT] = ACTIONS(6172),
    [anon_sym_PIPE_PIPE] = ACTIONS(6174),
    [anon_sym_AMP_AMP] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6172),
    [anon_sym_CARET] = ACTIONS(6172),
    [anon_sym_AMP] = ACTIONS(6172),
    [anon_sym_EQ_EQ] = ACTIONS(6174),
    [anon_sym_BANG_EQ] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6172),
    [anon_sym_GT_EQ] = ACTIONS(6174),
    [anon_sym_LT_EQ] = ACTIONS(6172),
    [anon_sym_LT] = ACTIONS(6172),
    [anon_sym_LT_LT] = ACTIONS(6172),
    [anon_sym_GT_GT] = ACTIONS(6172),
    [anon_sym_SEMI] = ACTIONS(6174),
    [anon_sym___attribute__] = ACTIONS(6172),
    [anon_sym___attribute] = ACTIONS(6172),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(6174),
    [anon_sym_LBRACK] = ACTIONS(6174),
    [anon_sym_RBRACK] = ACTIONS(6174),
    [anon_sym_EQ] = ACTIONS(6172),
    [anon_sym_QMARK] = ACTIONS(6174),
    [anon_sym_STAR_EQ] = ACTIONS(6174),
    [anon_sym_SLASH_EQ] = ACTIONS(6174),
    [anon_sym_PERCENT_EQ] = ACTIONS(6174),
    [anon_sym_PLUS_EQ] = ACTIONS(6174),
    [anon_sym_DASH_EQ] = ACTIONS(6174),
    [anon_sym_LT_LT_EQ] = ACTIONS(6174),
    [anon_sym_GT_GT_EQ] = ACTIONS(6174),
    [anon_sym_AMP_EQ] = ACTIONS(6174),
    [anon_sym_CARET_EQ] = ACTIONS(6174),
    [anon_sym_PIPE_EQ] = ACTIONS(6174),
    [anon_sym_and_eq] = ACTIONS(6172),
    [anon_sym_or_eq] = ACTIONS(6172),
    [anon_sym_xor_eq] = ACTIONS(6172),
    [anon_sym_LT_EQ_GT] = ACTIONS(6174),
    [anon_sym_or] = ACTIONS(6172),
    [anon_sym_and] = ACTIONS(6172),
    [anon_sym_bitor] = ACTIONS(6172),
    [anon_sym_xor] = ACTIONS(6172),
    [anon_sym_bitand] = ACTIONS(6172),
    [anon_sym_not_eq] = ACTIONS(6172),
    [anon_sym_DASH_DASH] = ACTIONS(6174),
    [anon_sym_PLUS_PLUS] = ACTIONS(6174),
    [anon_sym_DOT] = ACTIONS(6172),
    [anon_sym_DOT_STAR] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(6174),
    [sym_comment] = ACTIONS(3),
  },
  [2211] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(5910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [aux_sym_preproc_if_token2] = ACTIONS(5908),
    [aux_sym_preproc_else_token1] = ACTIONS(5908),
    [aux_sym_preproc_elif_token1] = ACTIONS(5910),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5908),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5908),
    [anon_sym_LPAREN2] = ACTIONS(5908),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_PLUS] = ACTIONS(5910),
    [anon_sym_STAR] = ACTIONS(5910),
    [anon_sym_SLASH] = ACTIONS(5910),
    [anon_sym_PERCENT] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_PIPE] = ACTIONS(5910),
    [anon_sym_CARET] = ACTIONS(5910),
    [anon_sym_AMP] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5908),
    [anon_sym_GT] = ACTIONS(5910),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_LT] = ACTIONS(5910),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym___attribute__] = ACTIONS(5910),
    [anon_sym___attribute] = ACTIONS(5910),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_signed] = ACTIONS(6176),
    [anon_sym_unsigned] = ACTIONS(6176),
    [anon_sym_long] = ACTIONS(6176),
    [anon_sym_short] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(5908),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_STAR_EQ] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_PERCENT_EQ] = ACTIONS(5908),
    [anon_sym_PLUS_EQ] = ACTIONS(5908),
    [anon_sym_DASH_EQ] = ACTIONS(5908),
    [anon_sym_LT_LT_EQ] = ACTIONS(5908),
    [anon_sym_GT_GT_EQ] = ACTIONS(5908),
    [anon_sym_AMP_EQ] = ACTIONS(5908),
    [anon_sym_CARET_EQ] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_and_eq] = ACTIONS(5910),
    [anon_sym_or_eq] = ACTIONS(5910),
    [anon_sym_xor_eq] = ACTIONS(5910),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_or] = ACTIONS(5910),
    [anon_sym_and] = ACTIONS(5910),
    [anon_sym_bitor] = ACTIONS(5910),
    [anon_sym_xor] = ACTIONS(5910),
    [anon_sym_bitand] = ACTIONS(5910),
    [anon_sym_not_eq] = ACTIONS(5910),
    [anon_sym_DASH_DASH] = ACTIONS(5908),
    [anon_sym_PLUS_PLUS] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_DOT_STAR] = ACTIONS(5908),
    [anon_sym_DASH_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5910),
    [anon_sym_decltype] = ACTIONS(5910),
  },
  [2212] = {
    [sym_identifier] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5082),
    [anon_sym_COMMA] = ACTIONS(5082),
    [anon_sym_LPAREN2] = ACTIONS(5082),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_SLASH] = ACTIONS(5080),
    [anon_sym_PERCENT] = ACTIONS(5082),
    [anon_sym_PIPE_PIPE] = ACTIONS(5082),
    [anon_sym_AMP_AMP] = ACTIONS(5082),
    [anon_sym_PIPE] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5082),
    [anon_sym_BANG_EQ] = ACTIONS(5082),
    [anon_sym_GT] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5080),
    [anon_sym_LT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5082),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym___extension__] = ACTIONS(5080),
    [anon_sym___attribute__] = ACTIONS(5080),
    [anon_sym___attribute] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5082),
    [anon_sym_signed] = ACTIONS(5080),
    [anon_sym_unsigned] = ACTIONS(5080),
    [anon_sym_long] = ACTIONS(5080),
    [anon_sym_short] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5082),
    [anon_sym_const] = ACTIONS(5080),
    [anon_sym_constexpr] = ACTIONS(5080),
    [anon_sym_volatile] = ACTIONS(5080),
    [anon_sym_restrict] = ACTIONS(5080),
    [anon_sym___restrict__] = ACTIONS(5080),
    [anon_sym__Atomic] = ACTIONS(5080),
    [anon_sym__Noreturn] = ACTIONS(5080),
    [anon_sym_noreturn] = ACTIONS(5080),
    [anon_sym__Nonnull] = ACTIONS(5080),
    [anon_sym_mutable] = ACTIONS(5080),
    [anon_sym_constinit] = ACTIONS(5080),
    [anon_sym_consteval] = ACTIONS(5080),
    [anon_sym_alignas] = ACTIONS(5080),
    [anon_sym__Alignas] = ACTIONS(5080),
    [sym_primitive_type] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5082),
    [anon_sym_LT_EQ_GT] = ACTIONS(5082),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_bitor] = ACTIONS(5080),
    [anon_sym_xor] = ACTIONS(5080),
    [anon_sym_bitand] = ACTIONS(5080),
    [anon_sym_not_eq] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5082),
    [anon_sym_PLUS_PLUS] = ACTIONS(5082),
    [anon_sym_DOT] = ACTIONS(5080),
    [anon_sym_DOT_STAR] = ACTIONS(5082),
    [anon_sym_DASH_GT] = ACTIONS(5082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5080),
    [anon_sym_decltype] = ACTIONS(5080),
    [anon_sym_final] = ACTIONS(5080),
    [anon_sym_override] = ACTIONS(5080),
    [anon_sym_GT2] = ACTIONS(5082),
    [anon_sym_requires] = ACTIONS(5080),
  },
  [2213] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5480),
    [anon_sym_COMMA] = ACTIONS(5480),
    [anon_sym_RPAREN] = ACTIONS(5480),
    [anon_sym_LPAREN2] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5478),
    [anon_sym_PLUS] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(5478),
    [anon_sym_SLASH] = ACTIONS(5478),
    [anon_sym_PERCENT] = ACTIONS(5478),
    [anon_sym_PIPE_PIPE] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_PIPE] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5478),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym_EQ_EQ] = ACTIONS(5480),
    [anon_sym_BANG_EQ] = ACTIONS(5480),
    [anon_sym_GT] = ACTIONS(5478),
    [anon_sym_GT_EQ] = ACTIONS(5480),
    [anon_sym_LT_EQ] = ACTIONS(5478),
    [anon_sym_LT] = ACTIONS(5478),
    [anon_sym_LT_LT] = ACTIONS(5478),
    [anon_sym_GT_GT] = ACTIONS(5478),
    [anon_sym_SEMI] = ACTIONS(5480),
    [anon_sym_COLON] = ACTIONS(5480),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_LBRACK] = ACTIONS(5480),
    [anon_sym_RBRACK] = ACTIONS(5480),
    [anon_sym_EQ] = ACTIONS(5478),
    [anon_sym_QMARK] = ACTIONS(5480),
    [anon_sym_STAR_EQ] = ACTIONS(5480),
    [anon_sym_SLASH_EQ] = ACTIONS(5480),
    [anon_sym_PERCENT_EQ] = ACTIONS(5480),
    [anon_sym_PLUS_EQ] = ACTIONS(5480),
    [anon_sym_DASH_EQ] = ACTIONS(5480),
    [anon_sym_LT_LT_EQ] = ACTIONS(5480),
    [anon_sym_GT_GT_EQ] = ACTIONS(5480),
    [anon_sym_AMP_EQ] = ACTIONS(5480),
    [anon_sym_CARET_EQ] = ACTIONS(5480),
    [anon_sym_PIPE_EQ] = ACTIONS(5480),
    [anon_sym_and_eq] = ACTIONS(5478),
    [anon_sym_or_eq] = ACTIONS(5478),
    [anon_sym_xor_eq] = ACTIONS(5478),
    [anon_sym_LT_EQ_GT] = ACTIONS(5480),
    [anon_sym_or] = ACTIONS(5478),
    [anon_sym_and] = ACTIONS(5478),
    [anon_sym_bitor] = ACTIONS(5478),
    [anon_sym_xor] = ACTIONS(5478),
    [anon_sym_bitand] = ACTIONS(5478),
    [anon_sym_not_eq] = ACTIONS(5478),
    [anon_sym_DASH_DASH] = ACTIONS(5480),
    [anon_sym_PLUS_PLUS] = ACTIONS(5480),
    [anon_sym_DOT] = ACTIONS(5478),
    [anon_sym_DOT_STAR] = ACTIONS(5480),
    [anon_sym_DASH_GT] = ACTIONS(5480),
    [anon_sym_L_DQUOTE] = ACTIONS(5480),
    [anon_sym_u_DQUOTE] = ACTIONS(5480),
    [anon_sym_U_DQUOTE] = ACTIONS(5480),
    [anon_sym_u8_DQUOTE] = ACTIONS(5480),
    [anon_sym_DQUOTE] = ACTIONS(5480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5480),
    [anon_sym_LR_DQUOTE] = ACTIONS(5480),
    [anon_sym_uR_DQUOTE] = ACTIONS(5480),
    [anon_sym_UR_DQUOTE] = ACTIONS(5480),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5480),
    [sym_literal_suffix] = ACTIONS(5478),
  },
  [2214] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(5918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [aux_sym_preproc_if_token2] = ACTIONS(5916),
    [aux_sym_preproc_else_token1] = ACTIONS(5916),
    [aux_sym_preproc_elif_token1] = ACTIONS(5918),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5916),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5916),
    [anon_sym_LPAREN2] = ACTIONS(5916),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_PLUS] = ACTIONS(5918),
    [anon_sym_STAR] = ACTIONS(5918),
    [anon_sym_SLASH] = ACTIONS(5918),
    [anon_sym_PERCENT] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_AMP_AMP] = ACTIONS(5916),
    [anon_sym_PIPE] = ACTIONS(5918),
    [anon_sym_CARET] = ACTIONS(5918),
    [anon_sym_AMP] = ACTIONS(5918),
    [anon_sym_EQ_EQ] = ACTIONS(5916),
    [anon_sym_BANG_EQ] = ACTIONS(5916),
    [anon_sym_GT] = ACTIONS(5918),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_LT] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5918),
    [anon_sym_GT_GT] = ACTIONS(5918),
    [anon_sym___attribute__] = ACTIONS(5918),
    [anon_sym___attribute] = ACTIONS(5918),
    [anon_sym_LBRACE] = ACTIONS(5916),
    [anon_sym_signed] = ACTIONS(6176),
    [anon_sym_unsigned] = ACTIONS(6176),
    [anon_sym_long] = ACTIONS(6176),
    [anon_sym_short] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(5916),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_QMARK] = ACTIONS(5916),
    [anon_sym_STAR_EQ] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_PERCENT_EQ] = ACTIONS(5916),
    [anon_sym_PLUS_EQ] = ACTIONS(5916),
    [anon_sym_DASH_EQ] = ACTIONS(5916),
    [anon_sym_LT_LT_EQ] = ACTIONS(5916),
    [anon_sym_GT_GT_EQ] = ACTIONS(5916),
    [anon_sym_AMP_EQ] = ACTIONS(5916),
    [anon_sym_CARET_EQ] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_and_eq] = ACTIONS(5918),
    [anon_sym_or_eq] = ACTIONS(5918),
    [anon_sym_xor_eq] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5918),
    [anon_sym_and] = ACTIONS(5918),
    [anon_sym_bitor] = ACTIONS(5918),
    [anon_sym_xor] = ACTIONS(5918),
    [anon_sym_bitand] = ACTIONS(5918),
    [anon_sym_not_eq] = ACTIONS(5918),
    [anon_sym_DASH_DASH] = ACTIONS(5916),
    [anon_sym_PLUS_PLUS] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_DOT_STAR] = ACTIONS(5916),
    [anon_sym_DASH_GT] = ACTIONS(5916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5918),
    [anon_sym_decltype] = ACTIONS(5918),
  },
  [2215] = {
    [sym_identifier] = ACTIONS(6178),
    [anon_sym_LPAREN2] = ACTIONS(6180),
    [anon_sym_TILDE] = ACTIONS(6180),
    [anon_sym_STAR] = ACTIONS(6180),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_AMP_AMP] = ACTIONS(6182),
    [anon_sym_AMP] = ACTIONS(6178),
    [anon_sym___extension__] = ACTIONS(6178),
    [anon_sym_virtual] = ACTIONS(6178),
    [anon_sym_extern] = ACTIONS(6178),
    [anon_sym___attribute__] = ACTIONS(6178),
    [anon_sym___attribute] = ACTIONS(6178),
    [anon_sym_using] = ACTIONS(6178),
    [anon_sym_COLON_COLON] = ACTIONS(6180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6180),
    [anon_sym___declspec] = ACTIONS(6178),
    [anon_sym___based] = ACTIONS(6178),
    [anon_sym___cdecl] = ACTIONS(6178),
    [anon_sym___clrcall] = ACTIONS(6178),
    [anon_sym___stdcall] = ACTIONS(6178),
    [anon_sym___fastcall] = ACTIONS(6178),
    [anon_sym___thiscall] = ACTIONS(6178),
    [anon_sym___vectorcall] = ACTIONS(6178),
    [anon_sym_signed] = ACTIONS(6178),
    [anon_sym_unsigned] = ACTIONS(6178),
    [anon_sym_long] = ACTIONS(6178),
    [anon_sym_short] = ACTIONS(6178),
    [anon_sym_LBRACK] = ACTIONS(6178),
    [anon_sym_static] = ACTIONS(6178),
    [anon_sym_register] = ACTIONS(6178),
    [anon_sym_inline] = ACTIONS(6178),
    [anon_sym___inline] = ACTIONS(6178),
    [anon_sym___inline__] = ACTIONS(6178),
    [anon_sym___forceinline] = ACTIONS(6178),
    [anon_sym_thread_local] = ACTIONS(6178),
    [anon_sym___thread] = ACTIONS(6178),
    [anon_sym_const] = ACTIONS(6178),
    [anon_sym_constexpr] = ACTIONS(6178),
    [anon_sym_volatile] = ACTIONS(6178),
    [anon_sym_restrict] = ACTIONS(6178),
    [anon_sym___restrict__] = ACTIONS(6178),
    [anon_sym__Atomic] = ACTIONS(6178),
    [anon_sym__Noreturn] = ACTIONS(6178),
    [anon_sym_noreturn] = ACTIONS(6178),
    [anon_sym__Nonnull] = ACTIONS(6178),
    [anon_sym_mutable] = ACTIONS(6178),
    [anon_sym_constinit] = ACTIONS(6178),
    [anon_sym_consteval] = ACTIONS(6178),
    [anon_sym_alignas] = ACTIONS(6178),
    [anon_sym__Alignas] = ACTIONS(6178),
    [sym_primitive_type] = ACTIONS(6178),
    [anon_sym_enum] = ACTIONS(6178),
    [anon_sym_class] = ACTIONS(6178),
    [anon_sym_struct] = ACTIONS(6178),
    [anon_sym_union] = ACTIONS(6178),
    [anon_sym_or] = ACTIONS(6178),
    [anon_sym_and] = ACTIONS(6184),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6178),
    [anon_sym_decltype] = ACTIONS(6178),
    [anon_sym_explicit] = ACTIONS(6178),
    [anon_sym_typename] = ACTIONS(6178),
    [anon_sym_template] = ACTIONS(6178),
    [anon_sym_operator] = ACTIONS(6178),
    [anon_sym_friend] = ACTIONS(6178),
    [anon_sym_concept] = ACTIONS(6178),
  },
  [2216] = {
    [sym_attribute_specifier] = STATE(1887),
    [sym_enumerator_list] = STATE(2360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6026),
    [anon_sym_COMMA] = ACTIONS(6026),
    [anon_sym_RPAREN] = ACTIONS(6026),
    [anon_sym_LPAREN2] = ACTIONS(6026),
    [anon_sym_DASH] = ACTIONS(6024),
    [anon_sym_PLUS] = ACTIONS(6024),
    [anon_sym_STAR] = ACTIONS(6026),
    [anon_sym_SLASH] = ACTIONS(6024),
    [anon_sym_PERCENT] = ACTIONS(6026),
    [anon_sym_PIPE_PIPE] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(6026),
    [anon_sym_PIPE] = ACTIONS(6024),
    [anon_sym_CARET] = ACTIONS(6026),
    [anon_sym_AMP] = ACTIONS(6024),
    [anon_sym_EQ_EQ] = ACTIONS(6026),
    [anon_sym_BANG_EQ] = ACTIONS(6026),
    [anon_sym_GT] = ACTIONS(6024),
    [anon_sym_GT_EQ] = ACTIONS(6026),
    [anon_sym_LT_EQ] = ACTIONS(6024),
    [anon_sym_LT] = ACTIONS(6024),
    [anon_sym_LT_LT] = ACTIONS(6026),
    [anon_sym_GT_GT] = ACTIONS(6026),
    [anon_sym_SEMI] = ACTIONS(6026),
    [anon_sym___extension__] = ACTIONS(6026),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6026),
    [anon_sym_LBRACE] = ACTIONS(6186),
    [anon_sym_RBRACE] = ACTIONS(6026),
    [anon_sym_LBRACK] = ACTIONS(6026),
    [anon_sym_RBRACK] = ACTIONS(6026),
    [anon_sym_const] = ACTIONS(6024),
    [anon_sym_constexpr] = ACTIONS(6026),
    [anon_sym_volatile] = ACTIONS(6026),
    [anon_sym_restrict] = ACTIONS(6026),
    [anon_sym___restrict__] = ACTIONS(6026),
    [anon_sym__Atomic] = ACTIONS(6026),
    [anon_sym__Noreturn] = ACTIONS(6026),
    [anon_sym_noreturn] = ACTIONS(6026),
    [anon_sym__Nonnull] = ACTIONS(6026),
    [anon_sym_mutable] = ACTIONS(6026),
    [anon_sym_constinit] = ACTIONS(6026),
    [anon_sym_consteval] = ACTIONS(6026),
    [anon_sym_alignas] = ACTIONS(6026),
    [anon_sym__Alignas] = ACTIONS(6026),
    [anon_sym_QMARK] = ACTIONS(6026),
    [anon_sym_LT_EQ_GT] = ACTIONS(6026),
    [anon_sym_or] = ACTIONS(6026),
    [anon_sym_and] = ACTIONS(6026),
    [anon_sym_bitor] = ACTIONS(6026),
    [anon_sym_xor] = ACTIONS(6026),
    [anon_sym_bitand] = ACTIONS(6026),
    [anon_sym_not_eq] = ACTIONS(6026),
    [anon_sym_DASH_DASH] = ACTIONS(6026),
    [anon_sym_PLUS_PLUS] = ACTIONS(6026),
    [anon_sym_DOT] = ACTIONS(6024),
    [anon_sym_DOT_STAR] = ACTIONS(6026),
    [anon_sym_DASH_GT] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6026),
    [anon_sym_decltype] = ACTIONS(6026),
    [anon_sym_final] = ACTIONS(6026),
    [anon_sym_override] = ACTIONS(6026),
    [anon_sym_requires] = ACTIONS(6026),
  },
  [2217] = {
    [sym_argument_list] = STATE(2481),
    [sym_initializer_list] = STATE(2481),
    [sym_identifier] = ACTIONS(6188),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6190),
    [anon_sym_COMMA] = ACTIONS(6190),
    [anon_sym_RPAREN] = ACTIONS(6190),
    [aux_sym_preproc_if_token2] = ACTIONS(6190),
    [aux_sym_preproc_else_token1] = ACTIONS(6190),
    [aux_sym_preproc_elif_token1] = ACTIONS(6188),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6190),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6190),
    [anon_sym_LPAREN2] = ACTIONS(5827),
    [anon_sym_DASH] = ACTIONS(6188),
    [anon_sym_PLUS] = ACTIONS(6188),
    [anon_sym_STAR] = ACTIONS(6188),
    [anon_sym_SLASH] = ACTIONS(6188),
    [anon_sym_PERCENT] = ACTIONS(6188),
    [anon_sym_PIPE_PIPE] = ACTIONS(6190),
    [anon_sym_AMP_AMP] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6188),
    [anon_sym_CARET] = ACTIONS(6188),
    [anon_sym_AMP] = ACTIONS(6188),
    [anon_sym_EQ_EQ] = ACTIONS(6190),
    [anon_sym_BANG_EQ] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6188),
    [anon_sym_GT_EQ] = ACTIONS(6190),
    [anon_sym_LT_EQ] = ACTIONS(6188),
    [anon_sym_LT] = ACTIONS(6188),
    [anon_sym_LT_LT] = ACTIONS(6188),
    [anon_sym_GT_GT] = ACTIONS(6188),
    [anon_sym_SEMI] = ACTIONS(6190),
    [anon_sym___attribute__] = ACTIONS(6188),
    [anon_sym___attribute] = ACTIONS(6188),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6190),
    [anon_sym_RBRACK] = ACTIONS(6190),
    [anon_sym_EQ] = ACTIONS(6188),
    [anon_sym_QMARK] = ACTIONS(6190),
    [anon_sym_STAR_EQ] = ACTIONS(6190),
    [anon_sym_SLASH_EQ] = ACTIONS(6190),
    [anon_sym_PERCENT_EQ] = ACTIONS(6190),
    [anon_sym_PLUS_EQ] = ACTIONS(6190),
    [anon_sym_DASH_EQ] = ACTIONS(6190),
    [anon_sym_LT_LT_EQ] = ACTIONS(6190),
    [anon_sym_GT_GT_EQ] = ACTIONS(6190),
    [anon_sym_AMP_EQ] = ACTIONS(6190),
    [anon_sym_CARET_EQ] = ACTIONS(6190),
    [anon_sym_PIPE_EQ] = ACTIONS(6190),
    [anon_sym_and_eq] = ACTIONS(6188),
    [anon_sym_or_eq] = ACTIONS(6188),
    [anon_sym_xor_eq] = ACTIONS(6188),
    [anon_sym_LT_EQ_GT] = ACTIONS(6190),
    [anon_sym_or] = ACTIONS(6188),
    [anon_sym_and] = ACTIONS(6188),
    [anon_sym_bitor] = ACTIONS(6188),
    [anon_sym_xor] = ACTIONS(6188),
    [anon_sym_bitand] = ACTIONS(6188),
    [anon_sym_not_eq] = ACTIONS(6188),
    [anon_sym_DASH_DASH] = ACTIONS(6190),
    [anon_sym_PLUS_PLUS] = ACTIONS(6190),
    [anon_sym_DOT] = ACTIONS(6188),
    [anon_sym_DOT_STAR] = ACTIONS(6190),
    [anon_sym_DASH_GT] = ACTIONS(6190),
    [sym_comment] = ACTIONS(3),
  },
  [2218] = {
    [sym_identifier] = ACTIONS(6192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6194),
    [anon_sym_COMMA] = ACTIONS(6194),
    [anon_sym_RPAREN] = ACTIONS(6194),
    [aux_sym_preproc_if_token2] = ACTIONS(6194),
    [aux_sym_preproc_else_token1] = ACTIONS(6194),
    [aux_sym_preproc_elif_token1] = ACTIONS(6192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6194),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6194),
    [anon_sym_LPAREN2] = ACTIONS(6194),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_PERCENT] = ACTIONS(6192),
    [anon_sym_PIPE_PIPE] = ACTIONS(6194),
    [anon_sym_AMP_AMP] = ACTIONS(6194),
    [anon_sym_PIPE] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6192),
    [anon_sym_EQ_EQ] = ACTIONS(6194),
    [anon_sym_BANG_EQ] = ACTIONS(6194),
    [anon_sym_GT] = ACTIONS(6192),
    [anon_sym_GT_EQ] = ACTIONS(6194),
    [anon_sym_LT_EQ] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6192),
    [anon_sym_LT_LT] = ACTIONS(6192),
    [anon_sym_GT_GT] = ACTIONS(6192),
    [anon_sym_SEMI] = ACTIONS(6194),
    [anon_sym___attribute__] = ACTIONS(6192),
    [anon_sym___attribute] = ACTIONS(6192),
    [anon_sym_COLON] = ACTIONS(6194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6194),
    [anon_sym_LBRACE] = ACTIONS(6194),
    [anon_sym_RBRACE] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_RBRACK] = ACTIONS(6194),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_QMARK] = ACTIONS(6194),
    [anon_sym_STAR_EQ] = ACTIONS(6194),
    [anon_sym_SLASH_EQ] = ACTIONS(6194),
    [anon_sym_PERCENT_EQ] = ACTIONS(6194),
    [anon_sym_PLUS_EQ] = ACTIONS(6194),
    [anon_sym_DASH_EQ] = ACTIONS(6194),
    [anon_sym_LT_LT_EQ] = ACTIONS(6194),
    [anon_sym_GT_GT_EQ] = ACTIONS(6194),
    [anon_sym_AMP_EQ] = ACTIONS(6194),
    [anon_sym_CARET_EQ] = ACTIONS(6194),
    [anon_sym_PIPE_EQ] = ACTIONS(6194),
    [anon_sym_and_eq] = ACTIONS(6192),
    [anon_sym_or_eq] = ACTIONS(6192),
    [anon_sym_xor_eq] = ACTIONS(6192),
    [anon_sym_LT_EQ_GT] = ACTIONS(6194),
    [anon_sym_or] = ACTIONS(6192),
    [anon_sym_and] = ACTIONS(6192),
    [anon_sym_bitor] = ACTIONS(6192),
    [anon_sym_xor] = ACTIONS(6192),
    [anon_sym_bitand] = ACTIONS(6192),
    [anon_sym_not_eq] = ACTIONS(6192),
    [anon_sym_DASH_DASH] = ACTIONS(6194),
    [anon_sym_PLUS_PLUS] = ACTIONS(6194),
    [anon_sym_DOT] = ACTIONS(6192),
    [anon_sym_DOT_STAR] = ACTIONS(6194),
    [anon_sym_DASH_GT] = ACTIONS(6194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6192),
  },
  [2219] = {
    [sym_identifier] = ACTIONS(6196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6198),
    [anon_sym_COMMA] = ACTIONS(6198),
    [anon_sym_RPAREN] = ACTIONS(6198),
    [aux_sym_preproc_if_token2] = ACTIONS(6198),
    [aux_sym_preproc_else_token1] = ACTIONS(6198),
    [aux_sym_preproc_elif_token1] = ACTIONS(6196),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6198),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6198),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_DASH] = ACTIONS(6196),
    [anon_sym_PLUS] = ACTIONS(6196),
    [anon_sym_STAR] = ACTIONS(6196),
    [anon_sym_SLASH] = ACTIONS(6196),
    [anon_sym_PERCENT] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE] = ACTIONS(6198),
    [anon_sym_AMP_AMP] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6196),
    [anon_sym_AMP] = ACTIONS(6196),
    [anon_sym_EQ_EQ] = ACTIONS(6198),
    [anon_sym_BANG_EQ] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6196),
    [anon_sym_GT_EQ] = ACTIONS(6198),
    [anon_sym_LT_EQ] = ACTIONS(6196),
    [anon_sym_LT] = ACTIONS(6196),
    [anon_sym_LT_LT] = ACTIONS(6196),
    [anon_sym_GT_GT] = ACTIONS(6196),
    [anon_sym_SEMI] = ACTIONS(6198),
    [anon_sym___attribute__] = ACTIONS(6196),
    [anon_sym___attribute] = ACTIONS(6196),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6198),
    [anon_sym_LBRACE] = ACTIONS(6198),
    [anon_sym_RBRACE] = ACTIONS(6198),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_RBRACK] = ACTIONS(6198),
    [anon_sym_EQ] = ACTIONS(6196),
    [anon_sym_QMARK] = ACTIONS(6198),
    [anon_sym_STAR_EQ] = ACTIONS(6198),
    [anon_sym_SLASH_EQ] = ACTIONS(6198),
    [anon_sym_PERCENT_EQ] = ACTIONS(6198),
    [anon_sym_PLUS_EQ] = ACTIONS(6198),
    [anon_sym_DASH_EQ] = ACTIONS(6198),
    [anon_sym_LT_LT_EQ] = ACTIONS(6198),
    [anon_sym_GT_GT_EQ] = ACTIONS(6198),
    [anon_sym_AMP_EQ] = ACTIONS(6198),
    [anon_sym_CARET_EQ] = ACTIONS(6198),
    [anon_sym_PIPE_EQ] = ACTIONS(6198),
    [anon_sym_and_eq] = ACTIONS(6196),
    [anon_sym_or_eq] = ACTIONS(6196),
    [anon_sym_xor_eq] = ACTIONS(6196),
    [anon_sym_LT_EQ_GT] = ACTIONS(6198),
    [anon_sym_or] = ACTIONS(6196),
    [anon_sym_and] = ACTIONS(6196),
    [anon_sym_bitor] = ACTIONS(6196),
    [anon_sym_xor] = ACTIONS(6196),
    [anon_sym_bitand] = ACTIONS(6196),
    [anon_sym_not_eq] = ACTIONS(6196),
    [anon_sym_DASH_DASH] = ACTIONS(6198),
    [anon_sym_PLUS_PLUS] = ACTIONS(6198),
    [anon_sym_DOT] = ACTIONS(6196),
    [anon_sym_DOT_STAR] = ACTIONS(6198),
    [anon_sym_DASH_GT] = ACTIONS(6198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6196),
  },
  [2220] = {
    [sym_identifier] = ACTIONS(6200),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6202),
    [anon_sym_COMMA] = ACTIONS(6202),
    [anon_sym_RPAREN] = ACTIONS(6202),
    [aux_sym_preproc_if_token2] = ACTIONS(6202),
    [aux_sym_preproc_else_token1] = ACTIONS(6202),
    [aux_sym_preproc_elif_token1] = ACTIONS(6200),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6202),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6202),
    [anon_sym_LPAREN2] = ACTIONS(6202),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_PERCENT] = ACTIONS(6200),
    [anon_sym_PIPE_PIPE] = ACTIONS(6202),
    [anon_sym_AMP_AMP] = ACTIONS(6202),
    [anon_sym_PIPE] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_AMP] = ACTIONS(6200),
    [anon_sym_EQ_EQ] = ACTIONS(6202),
    [anon_sym_BANG_EQ] = ACTIONS(6202),
    [anon_sym_GT] = ACTIONS(6200),
    [anon_sym_GT_EQ] = ACTIONS(6202),
    [anon_sym_LT_EQ] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6200),
    [anon_sym_LT_LT] = ACTIONS(6200),
    [anon_sym_GT_GT] = ACTIONS(6200),
    [anon_sym_SEMI] = ACTIONS(6202),
    [anon_sym___attribute__] = ACTIONS(6200),
    [anon_sym___attribute] = ACTIONS(6200),
    [anon_sym_COLON] = ACTIONS(6202),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6202),
    [anon_sym_LBRACE] = ACTIONS(6202),
    [anon_sym_RBRACE] = ACTIONS(6202),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_RBRACK] = ACTIONS(6202),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_QMARK] = ACTIONS(6202),
    [anon_sym_STAR_EQ] = ACTIONS(6202),
    [anon_sym_SLASH_EQ] = ACTIONS(6202),
    [anon_sym_PERCENT_EQ] = ACTIONS(6202),
    [anon_sym_PLUS_EQ] = ACTIONS(6202),
    [anon_sym_DASH_EQ] = ACTIONS(6202),
    [anon_sym_LT_LT_EQ] = ACTIONS(6202),
    [anon_sym_GT_GT_EQ] = ACTIONS(6202),
    [anon_sym_AMP_EQ] = ACTIONS(6202),
    [anon_sym_CARET_EQ] = ACTIONS(6202),
    [anon_sym_PIPE_EQ] = ACTIONS(6202),
    [anon_sym_and_eq] = ACTIONS(6200),
    [anon_sym_or_eq] = ACTIONS(6200),
    [anon_sym_xor_eq] = ACTIONS(6200),
    [anon_sym_LT_EQ_GT] = ACTIONS(6202),
    [anon_sym_or] = ACTIONS(6200),
    [anon_sym_and] = ACTIONS(6200),
    [anon_sym_bitor] = ACTIONS(6200),
    [anon_sym_xor] = ACTIONS(6200),
    [anon_sym_bitand] = ACTIONS(6200),
    [anon_sym_not_eq] = ACTIONS(6200),
    [anon_sym_DASH_DASH] = ACTIONS(6202),
    [anon_sym_PLUS_PLUS] = ACTIONS(6202),
    [anon_sym_DOT] = ACTIONS(6200),
    [anon_sym_DOT_STAR] = ACTIONS(6202),
    [anon_sym_DASH_GT] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6200),
  },
  [2221] = {
    [sym_identifier] = ACTIONS(5667),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5669),
    [anon_sym_COMMA] = ACTIONS(5669),
    [anon_sym_RPAREN] = ACTIONS(5669),
    [aux_sym_preproc_if_token2] = ACTIONS(5669),
    [aux_sym_preproc_else_token1] = ACTIONS(5669),
    [aux_sym_preproc_elif_token1] = ACTIONS(5667),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5669),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5669),
    [anon_sym_LPAREN2] = ACTIONS(5669),
    [anon_sym_DASH] = ACTIONS(5667),
    [anon_sym_PLUS] = ACTIONS(5667),
    [anon_sym_STAR] = ACTIONS(5667),
    [anon_sym_SLASH] = ACTIONS(5667),
    [anon_sym_PERCENT] = ACTIONS(5667),
    [anon_sym_PIPE_PIPE] = ACTIONS(5669),
    [anon_sym_AMP_AMP] = ACTIONS(5669),
    [anon_sym_PIPE] = ACTIONS(5667),
    [anon_sym_CARET] = ACTIONS(5667),
    [anon_sym_AMP] = ACTIONS(5667),
    [anon_sym_EQ_EQ] = ACTIONS(5669),
    [anon_sym_BANG_EQ] = ACTIONS(5669),
    [anon_sym_GT] = ACTIONS(5667),
    [anon_sym_GT_EQ] = ACTIONS(5669),
    [anon_sym_LT_EQ] = ACTIONS(5667),
    [anon_sym_LT] = ACTIONS(5667),
    [anon_sym_LT_LT] = ACTIONS(5667),
    [anon_sym_GT_GT] = ACTIONS(5667),
    [anon_sym_SEMI] = ACTIONS(5669),
    [anon_sym___attribute__] = ACTIONS(5667),
    [anon_sym___attribute] = ACTIONS(5667),
    [anon_sym_COLON] = ACTIONS(5669),
    [anon_sym_LBRACE] = ACTIONS(5669),
    [anon_sym_RBRACE] = ACTIONS(5669),
    [anon_sym_LBRACK] = ACTIONS(5669),
    [anon_sym_RBRACK] = ACTIONS(5669),
    [anon_sym_EQ] = ACTIONS(5667),
    [anon_sym_QMARK] = ACTIONS(5669),
    [anon_sym_STAR_EQ] = ACTIONS(5669),
    [anon_sym_SLASH_EQ] = ACTIONS(5669),
    [anon_sym_PERCENT_EQ] = ACTIONS(5669),
    [anon_sym_PLUS_EQ] = ACTIONS(5669),
    [anon_sym_DASH_EQ] = ACTIONS(5669),
    [anon_sym_LT_LT_EQ] = ACTIONS(5669),
    [anon_sym_GT_GT_EQ] = ACTIONS(5669),
    [anon_sym_AMP_EQ] = ACTIONS(5669),
    [anon_sym_CARET_EQ] = ACTIONS(5669),
    [anon_sym_PIPE_EQ] = ACTIONS(5669),
    [anon_sym_and_eq] = ACTIONS(5667),
    [anon_sym_or_eq] = ACTIONS(5667),
    [anon_sym_xor_eq] = ACTIONS(5667),
    [anon_sym_LT_EQ_GT] = ACTIONS(5669),
    [anon_sym_or] = ACTIONS(5667),
    [anon_sym_and] = ACTIONS(5667),
    [anon_sym_bitor] = ACTIONS(5667),
    [anon_sym_xor] = ACTIONS(5667),
    [anon_sym_bitand] = ACTIONS(5667),
    [anon_sym_not_eq] = ACTIONS(5667),
    [anon_sym_DASH_DASH] = ACTIONS(5669),
    [anon_sym_PLUS_PLUS] = ACTIONS(5669),
    [anon_sym_DOT] = ACTIONS(5667),
    [anon_sym_DOT_STAR] = ACTIONS(5669),
    [anon_sym_DASH_GT] = ACTIONS(5669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5667),
    [anon_sym_decltype] = ACTIONS(5667),
  },
  [2222] = {
    [sym_argument_list] = STATE(2477),
    [sym_initializer_list] = STATE(2477),
    [sym_identifier] = ACTIONS(6204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6206),
    [anon_sym_COMMA] = ACTIONS(6206),
    [anon_sym_RPAREN] = ACTIONS(6206),
    [aux_sym_preproc_if_token2] = ACTIONS(6206),
    [aux_sym_preproc_else_token1] = ACTIONS(6206),
    [aux_sym_preproc_elif_token1] = ACTIONS(6204),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6206),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6206),
    [anon_sym_LPAREN2] = ACTIONS(5827),
    [anon_sym_DASH] = ACTIONS(6204),
    [anon_sym_PLUS] = ACTIONS(6204),
    [anon_sym_STAR] = ACTIONS(6204),
    [anon_sym_SLASH] = ACTIONS(6204),
    [anon_sym_PERCENT] = ACTIONS(6204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6206),
    [anon_sym_AMP_AMP] = ACTIONS(6206),
    [anon_sym_PIPE] = ACTIONS(6204),
    [anon_sym_CARET] = ACTIONS(6204),
    [anon_sym_AMP] = ACTIONS(6204),
    [anon_sym_EQ_EQ] = ACTIONS(6206),
    [anon_sym_BANG_EQ] = ACTIONS(6206),
    [anon_sym_GT] = ACTIONS(6204),
    [anon_sym_GT_EQ] = ACTIONS(6206),
    [anon_sym_LT_EQ] = ACTIONS(6204),
    [anon_sym_LT] = ACTIONS(6204),
    [anon_sym_LT_LT] = ACTIONS(6204),
    [anon_sym_GT_GT] = ACTIONS(6204),
    [anon_sym_SEMI] = ACTIONS(6206),
    [anon_sym___attribute__] = ACTIONS(6204),
    [anon_sym___attribute] = ACTIONS(6204),
    [anon_sym_COLON] = ACTIONS(6206),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(6206),
    [anon_sym_LBRACK] = ACTIONS(6206),
    [anon_sym_RBRACK] = ACTIONS(6206),
    [anon_sym_EQ] = ACTIONS(6204),
    [anon_sym_QMARK] = ACTIONS(6206),
    [anon_sym_STAR_EQ] = ACTIONS(6206),
    [anon_sym_SLASH_EQ] = ACTIONS(6206),
    [anon_sym_PERCENT_EQ] = ACTIONS(6206),
    [anon_sym_PLUS_EQ] = ACTIONS(6206),
    [anon_sym_DASH_EQ] = ACTIONS(6206),
    [anon_sym_LT_LT_EQ] = ACTIONS(6206),
    [anon_sym_GT_GT_EQ] = ACTIONS(6206),
    [anon_sym_AMP_EQ] = ACTIONS(6206),
    [anon_sym_CARET_EQ] = ACTIONS(6206),
    [anon_sym_PIPE_EQ] = ACTIONS(6206),
    [anon_sym_and_eq] = ACTIONS(6204),
    [anon_sym_or_eq] = ACTIONS(6204),
    [anon_sym_xor_eq] = ACTIONS(6204),
    [anon_sym_LT_EQ_GT] = ACTIONS(6206),
    [anon_sym_or] = ACTIONS(6204),
    [anon_sym_and] = ACTIONS(6204),
    [anon_sym_bitor] = ACTIONS(6204),
    [anon_sym_xor] = ACTIONS(6204),
    [anon_sym_bitand] = ACTIONS(6204),
    [anon_sym_not_eq] = ACTIONS(6204),
    [anon_sym_DASH_DASH] = ACTIONS(6206),
    [anon_sym_PLUS_PLUS] = ACTIONS(6206),
    [anon_sym_DOT] = ACTIONS(6204),
    [anon_sym_DOT_STAR] = ACTIONS(6206),
    [anon_sym_DASH_GT] = ACTIONS(6206),
    [sym_comment] = ACTIONS(3),
  },
  [2223] = {
    [sym_identifier] = ACTIONS(5681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5683),
    [anon_sym_COMMA] = ACTIONS(5683),
    [anon_sym_RPAREN] = ACTIONS(5683),
    [aux_sym_preproc_if_token2] = ACTIONS(5683),
    [aux_sym_preproc_else_token1] = ACTIONS(5683),
    [aux_sym_preproc_elif_token1] = ACTIONS(5681),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5683),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5683),
    [anon_sym_LPAREN2] = ACTIONS(5683),
    [anon_sym_DASH] = ACTIONS(5681),
    [anon_sym_PLUS] = ACTIONS(5681),
    [anon_sym_STAR] = ACTIONS(5681),
    [anon_sym_SLASH] = ACTIONS(5681),
    [anon_sym_PERCENT] = ACTIONS(5681),
    [anon_sym_PIPE_PIPE] = ACTIONS(5683),
    [anon_sym_AMP_AMP] = ACTIONS(5683),
    [anon_sym_PIPE] = ACTIONS(5681),
    [anon_sym_CARET] = ACTIONS(5681),
    [anon_sym_AMP] = ACTIONS(5681),
    [anon_sym_EQ_EQ] = ACTIONS(5683),
    [anon_sym_BANG_EQ] = ACTIONS(5683),
    [anon_sym_GT] = ACTIONS(5681),
    [anon_sym_GT_EQ] = ACTIONS(5683),
    [anon_sym_LT_EQ] = ACTIONS(5681),
    [anon_sym_LT] = ACTIONS(5681),
    [anon_sym_LT_LT] = ACTIONS(5681),
    [anon_sym_GT_GT] = ACTIONS(5681),
    [anon_sym_SEMI] = ACTIONS(5683),
    [anon_sym___attribute__] = ACTIONS(5681),
    [anon_sym___attribute] = ACTIONS(5681),
    [anon_sym_COLON] = ACTIONS(5683),
    [anon_sym_LBRACE] = ACTIONS(5683),
    [anon_sym_RBRACE] = ACTIONS(5683),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_RBRACK] = ACTIONS(5683),
    [anon_sym_EQ] = ACTIONS(5681),
    [anon_sym_QMARK] = ACTIONS(5683),
    [anon_sym_STAR_EQ] = ACTIONS(5683),
    [anon_sym_SLASH_EQ] = ACTIONS(5683),
    [anon_sym_PERCENT_EQ] = ACTIONS(5683),
    [anon_sym_PLUS_EQ] = ACTIONS(5683),
    [anon_sym_DASH_EQ] = ACTIONS(5683),
    [anon_sym_LT_LT_EQ] = ACTIONS(5683),
    [anon_sym_GT_GT_EQ] = ACTIONS(5683),
    [anon_sym_AMP_EQ] = ACTIONS(5683),
    [anon_sym_CARET_EQ] = ACTIONS(5683),
    [anon_sym_PIPE_EQ] = ACTIONS(5683),
    [anon_sym_and_eq] = ACTIONS(5681),
    [anon_sym_or_eq] = ACTIONS(5681),
    [anon_sym_xor_eq] = ACTIONS(5681),
    [anon_sym_LT_EQ_GT] = ACTIONS(5683),
    [anon_sym_or] = ACTIONS(5681),
    [anon_sym_and] = ACTIONS(5681),
    [anon_sym_bitor] = ACTIONS(5681),
    [anon_sym_xor] = ACTIONS(5681),
    [anon_sym_bitand] = ACTIONS(5681),
    [anon_sym_not_eq] = ACTIONS(5681),
    [anon_sym_DASH_DASH] = ACTIONS(5683),
    [anon_sym_PLUS_PLUS] = ACTIONS(5683),
    [anon_sym_DOT] = ACTIONS(5681),
    [anon_sym_DOT_STAR] = ACTIONS(5683),
    [anon_sym_DASH_GT] = ACTIONS(5683),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5681),
    [anon_sym_decltype] = ACTIONS(5681),
  },
  [2224] = {
    [sym_identifier] = ACTIONS(6208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6210),
    [anon_sym_COMMA] = ACTIONS(6210),
    [anon_sym_RPAREN] = ACTIONS(6210),
    [aux_sym_preproc_if_token2] = ACTIONS(6210),
    [aux_sym_preproc_else_token1] = ACTIONS(6210),
    [aux_sym_preproc_elif_token1] = ACTIONS(6208),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6210),
    [anon_sym_LPAREN2] = ACTIONS(6210),
    [anon_sym_DASH] = ACTIONS(6208),
    [anon_sym_PLUS] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_SLASH] = ACTIONS(6208),
    [anon_sym_PERCENT] = ACTIONS(6208),
    [anon_sym_PIPE_PIPE] = ACTIONS(6210),
    [anon_sym_AMP_AMP] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6208),
    [anon_sym_CARET] = ACTIONS(6208),
    [anon_sym_AMP] = ACTIONS(6208),
    [anon_sym_EQ_EQ] = ACTIONS(6210),
    [anon_sym_BANG_EQ] = ACTIONS(6210),
    [anon_sym_GT] = ACTIONS(6208),
    [anon_sym_GT_EQ] = ACTIONS(6210),
    [anon_sym_LT_EQ] = ACTIONS(6208),
    [anon_sym_LT] = ACTIONS(6208),
    [anon_sym_LT_LT] = ACTIONS(6208),
    [anon_sym_GT_GT] = ACTIONS(6208),
    [anon_sym_SEMI] = ACTIONS(6210),
    [anon_sym___attribute__] = ACTIONS(6208),
    [anon_sym___attribute] = ACTIONS(6208),
    [anon_sym_COLON] = ACTIONS(6210),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6210),
    [anon_sym_LBRACE] = ACTIONS(6210),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6208),
    [anon_sym_RBRACK] = ACTIONS(6210),
    [anon_sym_EQ] = ACTIONS(6208),
    [anon_sym_QMARK] = ACTIONS(6210),
    [anon_sym_STAR_EQ] = ACTIONS(6210),
    [anon_sym_SLASH_EQ] = ACTIONS(6210),
    [anon_sym_PERCENT_EQ] = ACTIONS(6210),
    [anon_sym_PLUS_EQ] = ACTIONS(6210),
    [anon_sym_DASH_EQ] = ACTIONS(6210),
    [anon_sym_LT_LT_EQ] = ACTIONS(6210),
    [anon_sym_GT_GT_EQ] = ACTIONS(6210),
    [anon_sym_AMP_EQ] = ACTIONS(6210),
    [anon_sym_CARET_EQ] = ACTIONS(6210),
    [anon_sym_PIPE_EQ] = ACTIONS(6210),
    [anon_sym_and_eq] = ACTIONS(6208),
    [anon_sym_or_eq] = ACTIONS(6208),
    [anon_sym_xor_eq] = ACTIONS(6208),
    [anon_sym_LT_EQ_GT] = ACTIONS(6210),
    [anon_sym_or] = ACTIONS(6208),
    [anon_sym_and] = ACTIONS(6208),
    [anon_sym_bitor] = ACTIONS(6208),
    [anon_sym_xor] = ACTIONS(6208),
    [anon_sym_bitand] = ACTIONS(6208),
    [anon_sym_not_eq] = ACTIONS(6208),
    [anon_sym_DASH_DASH] = ACTIONS(6210),
    [anon_sym_PLUS_PLUS] = ACTIONS(6210),
    [anon_sym_DOT] = ACTIONS(6208),
    [anon_sym_DOT_STAR] = ACTIONS(6210),
    [anon_sym_DASH_GT] = ACTIONS(6210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6208),
  },
  [2225] = {
    [sym_identifier] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5780),
    [anon_sym_COMMA] = ACTIONS(5780),
    [anon_sym_RPAREN] = ACTIONS(5780),
    [aux_sym_preproc_if_token2] = ACTIONS(5780),
    [aux_sym_preproc_else_token1] = ACTIONS(5780),
    [aux_sym_preproc_elif_token1] = ACTIONS(5778),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5780),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5780),
    [anon_sym_LPAREN2] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_STAR] = ACTIONS(5778),
    [anon_sym_SLASH] = ACTIONS(5778),
    [anon_sym_PERCENT] = ACTIONS(5778),
    [anon_sym_PIPE_PIPE] = ACTIONS(5780),
    [anon_sym_AMP_AMP] = ACTIONS(5780),
    [anon_sym_PIPE] = ACTIONS(5778),
    [anon_sym_CARET] = ACTIONS(5778),
    [anon_sym_AMP] = ACTIONS(5778),
    [anon_sym_EQ_EQ] = ACTIONS(5780),
    [anon_sym_BANG_EQ] = ACTIONS(5780),
    [anon_sym_GT] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5778),
    [anon_sym_LT_LT] = ACTIONS(5778),
    [anon_sym_GT_GT] = ACTIONS(5778),
    [anon_sym_SEMI] = ACTIONS(5780),
    [anon_sym___attribute__] = ACTIONS(5778),
    [anon_sym___attribute] = ACTIONS(5778),
    [anon_sym_COLON] = ACTIONS(5780),
    [anon_sym_LBRACE] = ACTIONS(5780),
    [anon_sym_RBRACE] = ACTIONS(5780),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_RBRACK] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5778),
    [anon_sym_QMARK] = ACTIONS(5780),
    [anon_sym_STAR_EQ] = ACTIONS(5780),
    [anon_sym_SLASH_EQ] = ACTIONS(5780),
    [anon_sym_PERCENT_EQ] = ACTIONS(5780),
    [anon_sym_PLUS_EQ] = ACTIONS(5780),
    [anon_sym_DASH_EQ] = ACTIONS(5780),
    [anon_sym_LT_LT_EQ] = ACTIONS(5780),
    [anon_sym_GT_GT_EQ] = ACTIONS(5780),
    [anon_sym_AMP_EQ] = ACTIONS(5780),
    [anon_sym_CARET_EQ] = ACTIONS(5780),
    [anon_sym_PIPE_EQ] = ACTIONS(5780),
    [anon_sym_and_eq] = ACTIONS(5778),
    [anon_sym_or_eq] = ACTIONS(5778),
    [anon_sym_xor_eq] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5780),
    [anon_sym_or] = ACTIONS(5778),
    [anon_sym_and] = ACTIONS(5778),
    [anon_sym_bitor] = ACTIONS(5778),
    [anon_sym_xor] = ACTIONS(5778),
    [anon_sym_bitand] = ACTIONS(5778),
    [anon_sym_not_eq] = ACTIONS(5778),
    [anon_sym_DASH_DASH] = ACTIONS(5780),
    [anon_sym_PLUS_PLUS] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5778),
    [anon_sym_DOT_STAR] = ACTIONS(5780),
    [anon_sym_DASH_GT] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5778),
    [anon_sym_decltype] = ACTIONS(5778),
  },
  [2226] = {
    [sym_identifier] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5730),
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_RPAREN] = ACTIONS(5730),
    [aux_sym_preproc_if_token2] = ACTIONS(5730),
    [aux_sym_preproc_else_token1] = ACTIONS(5730),
    [aux_sym_preproc_elif_token1] = ACTIONS(5728),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5730),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5728),
    [anon_sym_STAR] = ACTIONS(5728),
    [anon_sym_SLASH] = ACTIONS(5728),
    [anon_sym_PERCENT] = ACTIONS(5728),
    [anon_sym_PIPE_PIPE] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5730),
    [anon_sym_PIPE] = ACTIONS(5728),
    [anon_sym_CARET] = ACTIONS(5728),
    [anon_sym_AMP] = ACTIONS(5728),
    [anon_sym_EQ_EQ] = ACTIONS(5730),
    [anon_sym_BANG_EQ] = ACTIONS(5730),
    [anon_sym_GT] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5728),
    [anon_sym_LT_LT] = ACTIONS(5728),
    [anon_sym_GT_GT] = ACTIONS(5728),
    [anon_sym_SEMI] = ACTIONS(5730),
    [anon_sym___attribute__] = ACTIONS(5728),
    [anon_sym___attribute] = ACTIONS(5728),
    [anon_sym_COLON] = ACTIONS(5730),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_RBRACE] = ACTIONS(5730),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_RBRACK] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5728),
    [anon_sym_QMARK] = ACTIONS(5730),
    [anon_sym_STAR_EQ] = ACTIONS(5730),
    [anon_sym_SLASH_EQ] = ACTIONS(5730),
    [anon_sym_PERCENT_EQ] = ACTIONS(5730),
    [anon_sym_PLUS_EQ] = ACTIONS(5730),
    [anon_sym_DASH_EQ] = ACTIONS(5730),
    [anon_sym_LT_LT_EQ] = ACTIONS(5730),
    [anon_sym_GT_GT_EQ] = ACTIONS(5730),
    [anon_sym_AMP_EQ] = ACTIONS(5730),
    [anon_sym_CARET_EQ] = ACTIONS(5730),
    [anon_sym_PIPE_EQ] = ACTIONS(5730),
    [anon_sym_and_eq] = ACTIONS(5728),
    [anon_sym_or_eq] = ACTIONS(5728),
    [anon_sym_xor_eq] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5730),
    [anon_sym_or] = ACTIONS(5728),
    [anon_sym_and] = ACTIONS(5728),
    [anon_sym_bitor] = ACTIONS(5728),
    [anon_sym_xor] = ACTIONS(5728),
    [anon_sym_bitand] = ACTIONS(5728),
    [anon_sym_not_eq] = ACTIONS(5728),
    [anon_sym_DASH_DASH] = ACTIONS(5730),
    [anon_sym_PLUS_PLUS] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5728),
    [anon_sym_DOT_STAR] = ACTIONS(5730),
    [anon_sym_DASH_GT] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5728),
    [anon_sym_decltype] = ACTIONS(5728),
  },
  [2227] = {
    [sym_identifier] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5734),
    [anon_sym_COMMA] = ACTIONS(5734),
    [anon_sym_RPAREN] = ACTIONS(5734),
    [aux_sym_preproc_if_token2] = ACTIONS(5734),
    [aux_sym_preproc_else_token1] = ACTIONS(5734),
    [aux_sym_preproc_elif_token1] = ACTIONS(5732),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5734),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5734),
    [anon_sym_LPAREN2] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_STAR] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5732),
    [anon_sym_PERCENT] = ACTIONS(5732),
    [anon_sym_PIPE_PIPE] = ACTIONS(5734),
    [anon_sym_AMP_AMP] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5732),
    [anon_sym_CARET] = ACTIONS(5732),
    [anon_sym_AMP] = ACTIONS(5732),
    [anon_sym_EQ_EQ] = ACTIONS(5734),
    [anon_sym_BANG_EQ] = ACTIONS(5734),
    [anon_sym_GT] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5732),
    [anon_sym_LT_LT] = ACTIONS(5732),
    [anon_sym_GT_GT] = ACTIONS(5732),
    [anon_sym_SEMI] = ACTIONS(5734),
    [anon_sym___attribute__] = ACTIONS(5732),
    [anon_sym___attribute] = ACTIONS(5732),
    [anon_sym_COLON] = ACTIONS(5734),
    [anon_sym_LBRACE] = ACTIONS(5734),
    [anon_sym_RBRACE] = ACTIONS(5734),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_RBRACK] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5732),
    [anon_sym_QMARK] = ACTIONS(5734),
    [anon_sym_STAR_EQ] = ACTIONS(5734),
    [anon_sym_SLASH_EQ] = ACTIONS(5734),
    [anon_sym_PERCENT_EQ] = ACTIONS(5734),
    [anon_sym_PLUS_EQ] = ACTIONS(5734),
    [anon_sym_DASH_EQ] = ACTIONS(5734),
    [anon_sym_LT_LT_EQ] = ACTIONS(5734),
    [anon_sym_GT_GT_EQ] = ACTIONS(5734),
    [anon_sym_AMP_EQ] = ACTIONS(5734),
    [anon_sym_CARET_EQ] = ACTIONS(5734),
    [anon_sym_PIPE_EQ] = ACTIONS(5734),
    [anon_sym_and_eq] = ACTIONS(5732),
    [anon_sym_or_eq] = ACTIONS(5732),
    [anon_sym_xor_eq] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5734),
    [anon_sym_or] = ACTIONS(5732),
    [anon_sym_and] = ACTIONS(5732),
    [anon_sym_bitor] = ACTIONS(5732),
    [anon_sym_xor] = ACTIONS(5732),
    [anon_sym_bitand] = ACTIONS(5732),
    [anon_sym_not_eq] = ACTIONS(5732),
    [anon_sym_DASH_DASH] = ACTIONS(5734),
    [anon_sym_PLUS_PLUS] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5732),
    [anon_sym_DOT_STAR] = ACTIONS(5734),
    [anon_sym_DASH_GT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5732),
    [anon_sym_decltype] = ACTIONS(5732),
  },
  [2228] = {
    [sym_identifier] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [aux_sym_preproc_if_token2] = ACTIONS(5738),
    [aux_sym_preproc_else_token1] = ACTIONS(5738),
    [aux_sym_preproc_elif_token1] = ACTIONS(5736),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5738),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5738),
    [anon_sym_LPAREN2] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5736),
    [anon_sym_STAR] = ACTIONS(5736),
    [anon_sym_SLASH] = ACTIONS(5736),
    [anon_sym_PERCENT] = ACTIONS(5736),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_CARET] = ACTIONS(5736),
    [anon_sym_AMP] = ACTIONS(5736),
    [anon_sym_EQ_EQ] = ACTIONS(5738),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_GT] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5736),
    [anon_sym_LT_LT] = ACTIONS(5736),
    [anon_sym_GT_GT] = ACTIONS(5736),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym___attribute__] = ACTIONS(5736),
    [anon_sym___attribute] = ACTIONS(5736),
    [anon_sym_COLON] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5736),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_STAR_EQ] = ACTIONS(5738),
    [anon_sym_SLASH_EQ] = ACTIONS(5738),
    [anon_sym_PERCENT_EQ] = ACTIONS(5738),
    [anon_sym_PLUS_EQ] = ACTIONS(5738),
    [anon_sym_DASH_EQ] = ACTIONS(5738),
    [anon_sym_LT_LT_EQ] = ACTIONS(5738),
    [anon_sym_GT_GT_EQ] = ACTIONS(5738),
    [anon_sym_AMP_EQ] = ACTIONS(5738),
    [anon_sym_CARET_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_and_eq] = ACTIONS(5736),
    [anon_sym_or_eq] = ACTIONS(5736),
    [anon_sym_xor_eq] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5736),
    [anon_sym_and] = ACTIONS(5736),
    [anon_sym_bitor] = ACTIONS(5736),
    [anon_sym_xor] = ACTIONS(5736),
    [anon_sym_bitand] = ACTIONS(5736),
    [anon_sym_not_eq] = ACTIONS(5736),
    [anon_sym_DASH_DASH] = ACTIONS(5738),
    [anon_sym_PLUS_PLUS] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5736),
    [anon_sym_DOT_STAR] = ACTIONS(5738),
    [anon_sym_DASH_GT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5736),
    [anon_sym_decltype] = ACTIONS(5736),
  },
  [2229] = {
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2573),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_CARET] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_EQ_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_GT_EQ] = ACTIONS(2573),
    [anon_sym_LT_EQ] = ACTIONS(2573),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_LT_LT] = ACTIONS(2563),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_LT_EQ_GT] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2573),
    [anon_sym_and] = ACTIONS(2573),
    [anon_sym_bitor] = ACTIONS(2573),
    [anon_sym_xor] = ACTIONS(2573),
    [anon_sym_bitand] = ACTIONS(2573),
    [anon_sym_not_eq] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_PLUS] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2573),
    [anon_sym_DOT_STAR] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_final] = ACTIONS(2573),
    [anon_sym_override] = ACTIONS(2573),
    [anon_sym_GT2] = ACTIONS(2563),
    [anon_sym_requires] = ACTIONS(2573),
  },
  [2230] = {
    [sym_template_argument_list] = STATE(1941),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2248),
    [sym_identifier] = ACTIONS(4144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [aux_sym_preproc_if_token2] = ACTIONS(4152),
    [aux_sym_preproc_else_token1] = ACTIONS(4152),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4152),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4152),
    [anon_sym_LPAREN2] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4144),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4144),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4152),
    [anon_sym_AMP_AMP] = ACTIONS(4152),
    [anon_sym_PIPE] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_AMP] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(4152),
    [anon_sym_GT] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4152),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(5840),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4144),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4152),
    [anon_sym_signed] = ACTIONS(5981),
    [anon_sym_unsigned] = ACTIONS(5981),
    [anon_sym_long] = ACTIONS(5981),
    [anon_sym_short] = ACTIONS(5981),
    [anon_sym_LBRACK] = ACTIONS(4152),
    [anon_sym_EQ] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4152),
    [anon_sym_STAR_EQ] = ACTIONS(4152),
    [anon_sym_SLASH_EQ] = ACTIONS(4152),
    [anon_sym_PERCENT_EQ] = ACTIONS(4152),
    [anon_sym_PLUS_EQ] = ACTIONS(4152),
    [anon_sym_DASH_EQ] = ACTIONS(4152),
    [anon_sym_LT_LT_EQ] = ACTIONS(4152),
    [anon_sym_GT_GT_EQ] = ACTIONS(4152),
    [anon_sym_AMP_EQ] = ACTIONS(4152),
    [anon_sym_CARET_EQ] = ACTIONS(4152),
    [anon_sym_PIPE_EQ] = ACTIONS(4152),
    [anon_sym_and_eq] = ACTIONS(4144),
    [anon_sym_or_eq] = ACTIONS(4144),
    [anon_sym_xor_eq] = ACTIONS(4144),
    [anon_sym_LT_EQ_GT] = ACTIONS(4152),
    [anon_sym_or] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_bitor] = ACTIONS(4144),
    [anon_sym_xor] = ACTIONS(4144),
    [anon_sym_bitand] = ACTIONS(4144),
    [anon_sym_not_eq] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4152),
    [anon_sym_PLUS_PLUS] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(4144),
    [anon_sym_DOT_STAR] = ACTIONS(4152),
    [anon_sym_DASH_GT] = ACTIONS(4152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4144),
    [anon_sym_decltype] = ACTIONS(4144),
  },
  [2231] = {
    [sym_identifier] = ACTIONS(5750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_RPAREN] = ACTIONS(5752),
    [aux_sym_preproc_if_token2] = ACTIONS(5752),
    [aux_sym_preproc_else_token1] = ACTIONS(5752),
    [aux_sym_preproc_elif_token1] = ACTIONS(5750),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5752),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5752),
    [anon_sym_LPAREN2] = ACTIONS(5752),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_STAR] = ACTIONS(5750),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_PIPE] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5750),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_LT] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym_SEMI] = ACTIONS(5752),
    [anon_sym___attribute__] = ACTIONS(5750),
    [anon_sym___attribute] = ACTIONS(5750),
    [anon_sym_COLON] = ACTIONS(5752),
    [anon_sym_LBRACE] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_RBRACK] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5752),
    [anon_sym_STAR_EQ] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_PERCENT_EQ] = ACTIONS(5752),
    [anon_sym_PLUS_EQ] = ACTIONS(5752),
    [anon_sym_DASH_EQ] = ACTIONS(5752),
    [anon_sym_LT_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT_GT_EQ] = ACTIONS(5752),
    [anon_sym_AMP_EQ] = ACTIONS(5752),
    [anon_sym_CARET_EQ] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_and_eq] = ACTIONS(5750),
    [anon_sym_or_eq] = ACTIONS(5750),
    [anon_sym_xor_eq] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_bitor] = ACTIONS(5750),
    [anon_sym_xor] = ACTIONS(5750),
    [anon_sym_bitand] = ACTIONS(5750),
    [anon_sym_not_eq] = ACTIONS(5750),
    [anon_sym_DASH_DASH] = ACTIONS(5752),
    [anon_sym_PLUS_PLUS] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_DOT_STAR] = ACTIONS(5752),
    [anon_sym_DASH_GT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5750),
    [anon_sym_decltype] = ACTIONS(5750),
  },
  [2232] = {
    [sym_identifier] = ACTIONS(5754),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_RPAREN] = ACTIONS(5756),
    [aux_sym_preproc_if_token2] = ACTIONS(5756),
    [aux_sym_preproc_else_token1] = ACTIONS(5756),
    [aux_sym_preproc_elif_token1] = ACTIONS(5754),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5756),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5756),
    [anon_sym_LPAREN2] = ACTIONS(5756),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_PLUS] = ACTIONS(5754),
    [anon_sym_STAR] = ACTIONS(5754),
    [anon_sym_SLASH] = ACTIONS(5754),
    [anon_sym_PERCENT] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_AMP_AMP] = ACTIONS(5756),
    [anon_sym_PIPE] = ACTIONS(5754),
    [anon_sym_CARET] = ACTIONS(5754),
    [anon_sym_AMP] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5756),
    [anon_sym_GT] = ACTIONS(5754),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_LT] = ACTIONS(5754),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_SEMI] = ACTIONS(5756),
    [anon_sym___attribute__] = ACTIONS(5754),
    [anon_sym___attribute] = ACTIONS(5754),
    [anon_sym_COLON] = ACTIONS(5756),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_RBRACE] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5756),
    [anon_sym_RBRACK] = ACTIONS(5756),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_QMARK] = ACTIONS(5756),
    [anon_sym_STAR_EQ] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_PERCENT_EQ] = ACTIONS(5756),
    [anon_sym_PLUS_EQ] = ACTIONS(5756),
    [anon_sym_DASH_EQ] = ACTIONS(5756),
    [anon_sym_LT_LT_EQ] = ACTIONS(5756),
    [anon_sym_GT_GT_EQ] = ACTIONS(5756),
    [anon_sym_AMP_EQ] = ACTIONS(5756),
    [anon_sym_CARET_EQ] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_and_eq] = ACTIONS(5754),
    [anon_sym_or_eq] = ACTIONS(5754),
    [anon_sym_xor_eq] = ACTIONS(5754),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_or] = ACTIONS(5754),
    [anon_sym_and] = ACTIONS(5754),
    [anon_sym_bitor] = ACTIONS(5754),
    [anon_sym_xor] = ACTIONS(5754),
    [anon_sym_bitand] = ACTIONS(5754),
    [anon_sym_not_eq] = ACTIONS(5754),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_DOT_STAR] = ACTIONS(5756),
    [anon_sym_DASH_GT] = ACTIONS(5756),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5754),
    [anon_sym_decltype] = ACTIONS(5754),
  },
  [2233] = {
    [sym_identifier] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_RPAREN] = ACTIONS(5760),
    [aux_sym_preproc_if_token2] = ACTIONS(5760),
    [aux_sym_preproc_else_token1] = ACTIONS(5760),
    [aux_sym_preproc_elif_token1] = ACTIONS(5758),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5760),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5760),
    [anon_sym_LPAREN2] = ACTIONS(5760),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_AMP_AMP] = ACTIONS(5760),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(5760),
    [anon_sym_BANG_EQ] = ACTIONS(5760),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_SEMI] = ACTIONS(5760),
    [anon_sym___attribute__] = ACTIONS(5758),
    [anon_sym___attribute] = ACTIONS(5758),
    [anon_sym_COLON] = ACTIONS(5760),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_RBRACE] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5760),
    [anon_sym_RBRACK] = ACTIONS(5760),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_QMARK] = ACTIONS(5760),
    [anon_sym_STAR_EQ] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_PERCENT_EQ] = ACTIONS(5760),
    [anon_sym_PLUS_EQ] = ACTIONS(5760),
    [anon_sym_DASH_EQ] = ACTIONS(5760),
    [anon_sym_LT_LT_EQ] = ACTIONS(5760),
    [anon_sym_GT_GT_EQ] = ACTIONS(5760),
    [anon_sym_AMP_EQ] = ACTIONS(5760),
    [anon_sym_CARET_EQ] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_and_eq] = ACTIONS(5758),
    [anon_sym_or_eq] = ACTIONS(5758),
    [anon_sym_xor_eq] = ACTIONS(5758),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_or] = ACTIONS(5758),
    [anon_sym_and] = ACTIONS(5758),
    [anon_sym_bitor] = ACTIONS(5758),
    [anon_sym_xor] = ACTIONS(5758),
    [anon_sym_bitand] = ACTIONS(5758),
    [anon_sym_not_eq] = ACTIONS(5758),
    [anon_sym_DASH_DASH] = ACTIONS(5760),
    [anon_sym_PLUS_PLUS] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DOT_STAR] = ACTIONS(5760),
    [anon_sym_DASH_GT] = ACTIONS(5760),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5758),
    [anon_sym_decltype] = ACTIONS(5758),
  },
  [2234] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(5888),
    [aux_sym_preproc_if_token2] = ACTIONS(5888),
    [aux_sym_preproc_else_token1] = ACTIONS(5888),
    [aux_sym_preproc_elif_token1] = ACTIONS(5890),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5888),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5888),
    [anon_sym_LPAREN2] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5890),
    [anon_sym_STAR] = ACTIONS(5890),
    [anon_sym_SLASH] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5890),
    [anon_sym_PIPE_PIPE] = ACTIONS(5888),
    [anon_sym_AMP_AMP] = ACTIONS(5888),
    [anon_sym_PIPE] = ACTIONS(5890),
    [anon_sym_CARET] = ACTIONS(5890),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_EQ_EQ] = ACTIONS(5888),
    [anon_sym_BANG_EQ] = ACTIONS(5888),
    [anon_sym_GT] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5890),
    [anon_sym_LT_LT] = ACTIONS(5890),
    [anon_sym_GT_GT] = ACTIONS(5890),
    [anon_sym___attribute__] = ACTIONS(5890),
    [anon_sym___attribute] = ACTIONS(5890),
    [anon_sym_LBRACE] = ACTIONS(5888),
    [anon_sym_signed] = ACTIONS(6176),
    [anon_sym_unsigned] = ACTIONS(6176),
    [anon_sym_long] = ACTIONS(6176),
    [anon_sym_short] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5890),
    [anon_sym_QMARK] = ACTIONS(5888),
    [anon_sym_STAR_EQ] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(5888),
    [anon_sym_PLUS_EQ] = ACTIONS(5888),
    [anon_sym_DASH_EQ] = ACTIONS(5888),
    [anon_sym_LT_LT_EQ] = ACTIONS(5888),
    [anon_sym_GT_GT_EQ] = ACTIONS(5888),
    [anon_sym_AMP_EQ] = ACTIONS(5888),
    [anon_sym_CARET_EQ] = ACTIONS(5888),
    [anon_sym_PIPE_EQ] = ACTIONS(5888),
    [anon_sym_and_eq] = ACTIONS(5890),
    [anon_sym_or_eq] = ACTIONS(5890),
    [anon_sym_xor_eq] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5888),
    [anon_sym_or] = ACTIONS(5890),
    [anon_sym_and] = ACTIONS(5890),
    [anon_sym_bitor] = ACTIONS(5890),
    [anon_sym_xor] = ACTIONS(5890),
    [anon_sym_bitand] = ACTIONS(5890),
    [anon_sym_not_eq] = ACTIONS(5890),
    [anon_sym_DASH_DASH] = ACTIONS(5888),
    [anon_sym_PLUS_PLUS] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5890),
    [anon_sym_DOT_STAR] = ACTIONS(5888),
    [anon_sym_DASH_GT] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5890),
    [anon_sym_decltype] = ACTIONS(5890),
  },
  [2235] = {
    [sym_identifier] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5804),
    [anon_sym_COMMA] = ACTIONS(5804),
    [anon_sym_RPAREN] = ACTIONS(5804),
    [aux_sym_preproc_if_token2] = ACTIONS(5804),
    [aux_sym_preproc_else_token1] = ACTIONS(5804),
    [aux_sym_preproc_elif_token1] = ACTIONS(5802),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5804),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5804),
    [anon_sym_LPAREN2] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5802),
    [anon_sym_STAR] = ACTIONS(5802),
    [anon_sym_SLASH] = ACTIONS(5802),
    [anon_sym_PERCENT] = ACTIONS(5802),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_PIPE] = ACTIONS(5802),
    [anon_sym_CARET] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5802),
    [anon_sym_EQ_EQ] = ACTIONS(5804),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5802),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_SEMI] = ACTIONS(5804),
    [anon_sym___attribute__] = ACTIONS(5802),
    [anon_sym___attribute] = ACTIONS(5802),
    [anon_sym_COLON] = ACTIONS(5804),
    [anon_sym_LBRACE] = ACTIONS(5804),
    [anon_sym_RBRACE] = ACTIONS(5804),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_RBRACK] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5802),
    [anon_sym_QMARK] = ACTIONS(5804),
    [anon_sym_STAR_EQ] = ACTIONS(5804),
    [anon_sym_SLASH_EQ] = ACTIONS(5804),
    [anon_sym_PERCENT_EQ] = ACTIONS(5804),
    [anon_sym_PLUS_EQ] = ACTIONS(5804),
    [anon_sym_DASH_EQ] = ACTIONS(5804),
    [anon_sym_LT_LT_EQ] = ACTIONS(5804),
    [anon_sym_GT_GT_EQ] = ACTIONS(5804),
    [anon_sym_AMP_EQ] = ACTIONS(5804),
    [anon_sym_CARET_EQ] = ACTIONS(5804),
    [anon_sym_PIPE_EQ] = ACTIONS(5804),
    [anon_sym_and_eq] = ACTIONS(5802),
    [anon_sym_or_eq] = ACTIONS(5802),
    [anon_sym_xor_eq] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_or] = ACTIONS(5802),
    [anon_sym_and] = ACTIONS(5802),
    [anon_sym_bitor] = ACTIONS(5802),
    [anon_sym_xor] = ACTIONS(5802),
    [anon_sym_bitand] = ACTIONS(5802),
    [anon_sym_not_eq] = ACTIONS(5802),
    [anon_sym_DASH_DASH] = ACTIONS(5804),
    [anon_sym_PLUS_PLUS] = ACTIONS(5804),
    [anon_sym_DOT] = ACTIONS(5802),
    [anon_sym_DOT_STAR] = ACTIONS(5804),
    [anon_sym_DASH_GT] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5802),
    [anon_sym_decltype] = ACTIONS(5802),
  },
  [2236] = {
    [sym_string_literal] = STATE(2285),
    [sym_raw_string_literal] = STATE(2285),
    [aux_sym_concatenated_string_repeat1] = STATE(2285),
    [sym_identifier] = ACTIONS(6212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5390),
    [anon_sym_COMMA] = ACTIONS(5390),
    [anon_sym_LPAREN2] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5392),
    [anon_sym_PLUS] = ACTIONS(5392),
    [anon_sym_STAR] = ACTIONS(5392),
    [anon_sym_SLASH] = ACTIONS(5392),
    [anon_sym_PERCENT] = ACTIONS(5392),
    [anon_sym_PIPE_PIPE] = ACTIONS(5390),
    [anon_sym_AMP_AMP] = ACTIONS(5390),
    [anon_sym_PIPE] = ACTIONS(5392),
    [anon_sym_CARET] = ACTIONS(5392),
    [anon_sym_AMP] = ACTIONS(5392),
    [anon_sym_EQ_EQ] = ACTIONS(5390),
    [anon_sym_BANG_EQ] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5392),
    [anon_sym_GT_EQ] = ACTIONS(5392),
    [anon_sym_LT_EQ] = ACTIONS(5392),
    [anon_sym_LT] = ACTIONS(5392),
    [anon_sym_LT_LT] = ACTIONS(5392),
    [anon_sym_GT_GT] = ACTIONS(5392),
    [anon_sym_LBRACK] = ACTIONS(5390),
    [anon_sym_EQ] = ACTIONS(5392),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_STAR_EQ] = ACTIONS(5390),
    [anon_sym_SLASH_EQ] = ACTIONS(5390),
    [anon_sym_PERCENT_EQ] = ACTIONS(5390),
    [anon_sym_PLUS_EQ] = ACTIONS(5390),
    [anon_sym_DASH_EQ] = ACTIONS(5390),
    [anon_sym_LT_LT_EQ] = ACTIONS(5390),
    [anon_sym_GT_GT_EQ] = ACTIONS(5392),
    [anon_sym_AMP_EQ] = ACTIONS(5390),
    [anon_sym_CARET_EQ] = ACTIONS(5390),
    [anon_sym_PIPE_EQ] = ACTIONS(5390),
    [anon_sym_and_eq] = ACTIONS(5392),
    [anon_sym_or_eq] = ACTIONS(5392),
    [anon_sym_xor_eq] = ACTIONS(5392),
    [anon_sym_LT_EQ_GT] = ACTIONS(5390),
    [anon_sym_or] = ACTIONS(5392),
    [anon_sym_and] = ACTIONS(5392),
    [anon_sym_bitor] = ACTIONS(5392),
    [anon_sym_xor] = ACTIONS(5392),
    [anon_sym_bitand] = ACTIONS(5392),
    [anon_sym_not_eq] = ACTIONS(5392),
    [anon_sym_DASH_DASH] = ACTIONS(5390),
    [anon_sym_PLUS_PLUS] = ACTIONS(5390),
    [anon_sym_DOT] = ACTIONS(5392),
    [anon_sym_DOT_STAR] = ACTIONS(5390),
    [anon_sym_DASH_GT] = ACTIONS(5390),
    [anon_sym_L_DQUOTE] = ACTIONS(6214),
    [anon_sym_u_DQUOTE] = ACTIONS(6214),
    [anon_sym_U_DQUOTE] = ACTIONS(6214),
    [anon_sym_u8_DQUOTE] = ACTIONS(6214),
    [anon_sym_DQUOTE] = ACTIONS(6214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5390),
    [anon_sym_R_DQUOTE] = ACTIONS(6216),
    [anon_sym_LR_DQUOTE] = ACTIONS(6216),
    [anon_sym_uR_DQUOTE] = ACTIONS(6216),
    [anon_sym_UR_DQUOTE] = ACTIONS(6216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6216),
    [sym_literal_suffix] = ACTIONS(5392),
  },
  [2237] = {
    [sym_identifier] = ACTIONS(6218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6220),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [aux_sym_preproc_if_token2] = ACTIONS(6220),
    [aux_sym_preproc_else_token1] = ACTIONS(6220),
    [aux_sym_preproc_elif_token1] = ACTIONS(6218),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6220),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6220),
    [anon_sym_LPAREN2] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6218),
    [anon_sym_PLUS] = ACTIONS(6218),
    [anon_sym_STAR] = ACTIONS(6218),
    [anon_sym_SLASH] = ACTIONS(6218),
    [anon_sym_PERCENT] = ACTIONS(6218),
    [anon_sym_PIPE_PIPE] = ACTIONS(6220),
    [anon_sym_AMP_AMP] = ACTIONS(6220),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_CARET] = ACTIONS(6218),
    [anon_sym_AMP] = ACTIONS(6218),
    [anon_sym_EQ_EQ] = ACTIONS(6220),
    [anon_sym_BANG_EQ] = ACTIONS(6220),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_GT_EQ] = ACTIONS(6220),
    [anon_sym_LT_EQ] = ACTIONS(6218),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_LT_LT] = ACTIONS(6218),
    [anon_sym_GT_GT] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym___attribute__] = ACTIONS(6218),
    [anon_sym___attribute] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [anon_sym_RBRACE] = ACTIONS(6220),
    [anon_sym_LBRACK] = ACTIONS(6218),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_EQ] = ACTIONS(6218),
    [anon_sym_QMARK] = ACTIONS(6220),
    [anon_sym_STAR_EQ] = ACTIONS(6220),
    [anon_sym_SLASH_EQ] = ACTIONS(6220),
    [anon_sym_PERCENT_EQ] = ACTIONS(6220),
    [anon_sym_PLUS_EQ] = ACTIONS(6220),
    [anon_sym_DASH_EQ] = ACTIONS(6220),
    [anon_sym_LT_LT_EQ] = ACTIONS(6220),
    [anon_sym_GT_GT_EQ] = ACTIONS(6220),
    [anon_sym_AMP_EQ] = ACTIONS(6220),
    [anon_sym_CARET_EQ] = ACTIONS(6220),
    [anon_sym_PIPE_EQ] = ACTIONS(6220),
    [anon_sym_and_eq] = ACTIONS(6218),
    [anon_sym_or_eq] = ACTIONS(6218),
    [anon_sym_xor_eq] = ACTIONS(6218),
    [anon_sym_LT_EQ_GT] = ACTIONS(6220),
    [anon_sym_or] = ACTIONS(6218),
    [anon_sym_and] = ACTIONS(6218),
    [anon_sym_bitor] = ACTIONS(6218),
    [anon_sym_xor] = ACTIONS(6218),
    [anon_sym_bitand] = ACTIONS(6218),
    [anon_sym_not_eq] = ACTIONS(6218),
    [anon_sym_DASH_DASH] = ACTIONS(6220),
    [anon_sym_PLUS_PLUS] = ACTIONS(6220),
    [anon_sym_DOT] = ACTIONS(6218),
    [anon_sym_DOT_STAR] = ACTIONS(6220),
    [anon_sym_DASH_GT] = ACTIONS(6220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6218),
  },
  [2238] = {
    [sym_identifier] = ACTIONS(6222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6224),
    [anon_sym_COMMA] = ACTIONS(6224),
    [anon_sym_RPAREN] = ACTIONS(6224),
    [aux_sym_preproc_if_token2] = ACTIONS(6224),
    [aux_sym_preproc_else_token1] = ACTIONS(6224),
    [aux_sym_preproc_elif_token1] = ACTIONS(6222),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6224),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6224),
    [anon_sym_LPAREN2] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6222),
    [anon_sym_PLUS] = ACTIONS(6222),
    [anon_sym_STAR] = ACTIONS(6222),
    [anon_sym_SLASH] = ACTIONS(6222),
    [anon_sym_PERCENT] = ACTIONS(6222),
    [anon_sym_PIPE_PIPE] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_CARET] = ACTIONS(6222),
    [anon_sym_AMP] = ACTIONS(6222),
    [anon_sym_EQ_EQ] = ACTIONS(6224),
    [anon_sym_BANG_EQ] = ACTIONS(6224),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_GT_EQ] = ACTIONS(6224),
    [anon_sym_LT_EQ] = ACTIONS(6222),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_LT_LT] = ACTIONS(6222),
    [anon_sym_GT_GT] = ACTIONS(6222),
    [anon_sym_SEMI] = ACTIONS(6224),
    [anon_sym___attribute__] = ACTIONS(6222),
    [anon_sym___attribute] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(6224),
    [anon_sym_RBRACE] = ACTIONS(6224),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_EQ] = ACTIONS(6222),
    [anon_sym_QMARK] = ACTIONS(6224),
    [anon_sym_STAR_EQ] = ACTIONS(6224),
    [anon_sym_SLASH_EQ] = ACTIONS(6224),
    [anon_sym_PERCENT_EQ] = ACTIONS(6224),
    [anon_sym_PLUS_EQ] = ACTIONS(6224),
    [anon_sym_DASH_EQ] = ACTIONS(6224),
    [anon_sym_LT_LT_EQ] = ACTIONS(6224),
    [anon_sym_GT_GT_EQ] = ACTIONS(6224),
    [anon_sym_AMP_EQ] = ACTIONS(6224),
    [anon_sym_CARET_EQ] = ACTIONS(6224),
    [anon_sym_PIPE_EQ] = ACTIONS(6224),
    [anon_sym_and_eq] = ACTIONS(6222),
    [anon_sym_or_eq] = ACTIONS(6222),
    [anon_sym_xor_eq] = ACTIONS(6222),
    [anon_sym_LT_EQ_GT] = ACTIONS(6224),
    [anon_sym_or] = ACTIONS(6222),
    [anon_sym_and] = ACTIONS(6222),
    [anon_sym_bitor] = ACTIONS(6222),
    [anon_sym_xor] = ACTIONS(6222),
    [anon_sym_bitand] = ACTIONS(6222),
    [anon_sym_not_eq] = ACTIONS(6222),
    [anon_sym_DASH_DASH] = ACTIONS(6224),
    [anon_sym_PLUS_PLUS] = ACTIONS(6224),
    [anon_sym_DOT] = ACTIONS(6222),
    [anon_sym_DOT_STAR] = ACTIONS(6224),
    [anon_sym_DASH_GT] = ACTIONS(6224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6222),
  },
  [2239] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(6226),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(6228),
    [anon_sym_SLASH_EQ] = ACTIONS(6228),
    [anon_sym_PERCENT_EQ] = ACTIONS(6228),
    [anon_sym_PLUS_EQ] = ACTIONS(6228),
    [anon_sym_DASH_EQ] = ACTIONS(6228),
    [anon_sym_LT_LT_EQ] = ACTIONS(6228),
    [anon_sym_GT_GT_EQ] = ACTIONS(6228),
    [anon_sym_AMP_EQ] = ACTIONS(6228),
    [anon_sym_CARET_EQ] = ACTIONS(6228),
    [anon_sym_PIPE_EQ] = ACTIONS(6228),
    [anon_sym_and_eq] = ACTIONS(6228),
    [anon_sym_or_eq] = ACTIONS(6228),
    [anon_sym_xor_eq] = ACTIONS(6228),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2240] = {
    [sym_identifier] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5784),
    [anon_sym_COMMA] = ACTIONS(5784),
    [anon_sym_RPAREN] = ACTIONS(5784),
    [aux_sym_preproc_if_token2] = ACTIONS(5784),
    [aux_sym_preproc_else_token1] = ACTIONS(5784),
    [aux_sym_preproc_elif_token1] = ACTIONS(5782),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5784),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5784),
    [anon_sym_LPAREN2] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5782),
    [anon_sym_STAR] = ACTIONS(5782),
    [anon_sym_SLASH] = ACTIONS(5782),
    [anon_sym_PERCENT] = ACTIONS(5782),
    [anon_sym_PIPE_PIPE] = ACTIONS(5784),
    [anon_sym_AMP_AMP] = ACTIONS(5784),
    [anon_sym_PIPE] = ACTIONS(5782),
    [anon_sym_CARET] = ACTIONS(5782),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_EQ_EQ] = ACTIONS(5784),
    [anon_sym_BANG_EQ] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5782),
    [anon_sym_LT_LT] = ACTIONS(5782),
    [anon_sym_GT_GT] = ACTIONS(5782),
    [anon_sym_SEMI] = ACTIONS(5784),
    [anon_sym___attribute__] = ACTIONS(5782),
    [anon_sym___attribute] = ACTIONS(5782),
    [anon_sym_COLON] = ACTIONS(5784),
    [anon_sym_LBRACE] = ACTIONS(5784),
    [anon_sym_RBRACE] = ACTIONS(5784),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_RBRACK] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5782),
    [anon_sym_QMARK] = ACTIONS(5784),
    [anon_sym_STAR_EQ] = ACTIONS(5784),
    [anon_sym_SLASH_EQ] = ACTIONS(5784),
    [anon_sym_PERCENT_EQ] = ACTIONS(5784),
    [anon_sym_PLUS_EQ] = ACTIONS(5784),
    [anon_sym_DASH_EQ] = ACTIONS(5784),
    [anon_sym_LT_LT_EQ] = ACTIONS(5784),
    [anon_sym_GT_GT_EQ] = ACTIONS(5784),
    [anon_sym_AMP_EQ] = ACTIONS(5784),
    [anon_sym_CARET_EQ] = ACTIONS(5784),
    [anon_sym_PIPE_EQ] = ACTIONS(5784),
    [anon_sym_and_eq] = ACTIONS(5782),
    [anon_sym_or_eq] = ACTIONS(5782),
    [anon_sym_xor_eq] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5784),
    [anon_sym_or] = ACTIONS(5782),
    [anon_sym_and] = ACTIONS(5782),
    [anon_sym_bitor] = ACTIONS(5782),
    [anon_sym_xor] = ACTIONS(5782),
    [anon_sym_bitand] = ACTIONS(5782),
    [anon_sym_not_eq] = ACTIONS(5782),
    [anon_sym_DASH_DASH] = ACTIONS(5784),
    [anon_sym_PLUS_PLUS] = ACTIONS(5784),
    [anon_sym_DOT] = ACTIONS(5782),
    [anon_sym_DOT_STAR] = ACTIONS(5784),
    [anon_sym_DASH_GT] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5782),
    [anon_sym_decltype] = ACTIONS(5782),
  },
  [2241] = {
    [sym_identifier] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5788),
    [anon_sym_RPAREN] = ACTIONS(5788),
    [aux_sym_preproc_if_token2] = ACTIONS(5788),
    [aux_sym_preproc_else_token1] = ACTIONS(5788),
    [aux_sym_preproc_elif_token1] = ACTIONS(5786),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5788),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5788),
    [anon_sym_LPAREN2] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5786),
    [anon_sym_STAR] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(5786),
    [anon_sym_PERCENT] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5788),
    [anon_sym_AMP_AMP] = ACTIONS(5788),
    [anon_sym_PIPE] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5786),
    [anon_sym_AMP] = ACTIONS(5786),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5786),
    [anon_sym_LT_LT] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5786),
    [anon_sym_SEMI] = ACTIONS(5788),
    [anon_sym___attribute__] = ACTIONS(5786),
    [anon_sym___attribute] = ACTIONS(5786),
    [anon_sym_COLON] = ACTIONS(5788),
    [anon_sym_LBRACE] = ACTIONS(5788),
    [anon_sym_RBRACE] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_RBRACK] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5788),
    [anon_sym_STAR_EQ] = ACTIONS(5788),
    [anon_sym_SLASH_EQ] = ACTIONS(5788),
    [anon_sym_PERCENT_EQ] = ACTIONS(5788),
    [anon_sym_PLUS_EQ] = ACTIONS(5788),
    [anon_sym_DASH_EQ] = ACTIONS(5788),
    [anon_sym_LT_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT_GT_EQ] = ACTIONS(5788),
    [anon_sym_AMP_EQ] = ACTIONS(5788),
    [anon_sym_CARET_EQ] = ACTIONS(5788),
    [anon_sym_PIPE_EQ] = ACTIONS(5788),
    [anon_sym_and_eq] = ACTIONS(5786),
    [anon_sym_or_eq] = ACTIONS(5786),
    [anon_sym_xor_eq] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5788),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_bitor] = ACTIONS(5786),
    [anon_sym_xor] = ACTIONS(5786),
    [anon_sym_bitand] = ACTIONS(5786),
    [anon_sym_not_eq] = ACTIONS(5786),
    [anon_sym_DASH_DASH] = ACTIONS(5788),
    [anon_sym_PLUS_PLUS] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5786),
    [anon_sym_DOT_STAR] = ACTIONS(5788),
    [anon_sym_DASH_GT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5786),
    [anon_sym_decltype] = ACTIONS(5786),
  },
  [2242] = {
    [sym_string_literal] = STATE(1684),
    [sym_template_argument_list] = STATE(2338),
    [sym_raw_string_literal] = STATE(1684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6070),
    [anon_sym_COMMA] = ACTIONS(6230),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5373),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4146),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4146),
    [anon_sym_or_eq] = ACTIONS(4146),
    [anon_sym_xor_eq] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(1972),
    [anon_sym_u_DQUOTE] = ACTIONS(1972),
    [anon_sym_U_DQUOTE] = ACTIONS(1972),
    [anon_sym_u8_DQUOTE] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
  },
  [2243] = {
    [sym_identifier] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5792),
    [anon_sym_COMMA] = ACTIONS(5792),
    [anon_sym_RPAREN] = ACTIONS(5792),
    [aux_sym_preproc_if_token2] = ACTIONS(5792),
    [aux_sym_preproc_else_token1] = ACTIONS(5792),
    [aux_sym_preproc_elif_token1] = ACTIONS(5790),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5792),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5792),
    [anon_sym_LPAREN2] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5790),
    [anon_sym_STAR] = ACTIONS(5790),
    [anon_sym_SLASH] = ACTIONS(5790),
    [anon_sym_PERCENT] = ACTIONS(5790),
    [anon_sym_PIPE_PIPE] = ACTIONS(5792),
    [anon_sym_AMP_AMP] = ACTIONS(5792),
    [anon_sym_PIPE] = ACTIONS(5790),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_AMP] = ACTIONS(5790),
    [anon_sym_EQ_EQ] = ACTIONS(5792),
    [anon_sym_BANG_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5790),
    [anon_sym_LT_LT] = ACTIONS(5790),
    [anon_sym_GT_GT] = ACTIONS(5790),
    [anon_sym_SEMI] = ACTIONS(5792),
    [anon_sym___attribute__] = ACTIONS(5790),
    [anon_sym___attribute] = ACTIONS(5790),
    [anon_sym_COLON] = ACTIONS(5792),
    [anon_sym_LBRACE] = ACTIONS(5792),
    [anon_sym_RBRACE] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_RBRACK] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5790),
    [anon_sym_QMARK] = ACTIONS(5792),
    [anon_sym_STAR_EQ] = ACTIONS(5792),
    [anon_sym_SLASH_EQ] = ACTIONS(5792),
    [anon_sym_PERCENT_EQ] = ACTIONS(5792),
    [anon_sym_PLUS_EQ] = ACTIONS(5792),
    [anon_sym_DASH_EQ] = ACTIONS(5792),
    [anon_sym_LT_LT_EQ] = ACTIONS(5792),
    [anon_sym_GT_GT_EQ] = ACTIONS(5792),
    [anon_sym_AMP_EQ] = ACTIONS(5792),
    [anon_sym_CARET_EQ] = ACTIONS(5792),
    [anon_sym_PIPE_EQ] = ACTIONS(5792),
    [anon_sym_and_eq] = ACTIONS(5790),
    [anon_sym_or_eq] = ACTIONS(5790),
    [anon_sym_xor_eq] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5792),
    [anon_sym_or] = ACTIONS(5790),
    [anon_sym_and] = ACTIONS(5790),
    [anon_sym_bitor] = ACTIONS(5790),
    [anon_sym_xor] = ACTIONS(5790),
    [anon_sym_bitand] = ACTIONS(5790),
    [anon_sym_not_eq] = ACTIONS(5790),
    [anon_sym_DASH_DASH] = ACTIONS(5792),
    [anon_sym_PLUS_PLUS] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5790),
    [anon_sym_DOT_STAR] = ACTIONS(5792),
    [anon_sym_DASH_GT] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5790),
    [anon_sym_decltype] = ACTIONS(5790),
  },
  [2244] = {
    [sym_identifier] = ACTIONS(4959),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_TILDE] = ACTIONS(4961),
    [anon_sym_STAR] = ACTIONS(4961),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym___extension__] = ACTIONS(4959),
    [anon_sym_virtual] = ACTIONS(4959),
    [anon_sym_extern] = ACTIONS(4959),
    [anon_sym___attribute__] = ACTIONS(4959),
    [anon_sym___attribute] = ACTIONS(4959),
    [anon_sym_using] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(4961),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4961),
    [anon_sym___declspec] = ACTIONS(4959),
    [anon_sym___based] = ACTIONS(4959),
    [anon_sym___cdecl] = ACTIONS(4959),
    [anon_sym___clrcall] = ACTIONS(4959),
    [anon_sym___stdcall] = ACTIONS(4959),
    [anon_sym___fastcall] = ACTIONS(4959),
    [anon_sym___thiscall] = ACTIONS(4959),
    [anon_sym___vectorcall] = ACTIONS(4959),
    [anon_sym_signed] = ACTIONS(4959),
    [anon_sym_unsigned] = ACTIONS(4959),
    [anon_sym_long] = ACTIONS(4959),
    [anon_sym_short] = ACTIONS(4959),
    [anon_sym_LBRACK] = ACTIONS(4959),
    [anon_sym_static] = ACTIONS(4959),
    [anon_sym_register] = ACTIONS(4959),
    [anon_sym_inline] = ACTIONS(4959),
    [anon_sym___inline] = ACTIONS(4959),
    [anon_sym___inline__] = ACTIONS(4959),
    [anon_sym___forceinline] = ACTIONS(4959),
    [anon_sym_thread_local] = ACTIONS(4959),
    [anon_sym___thread] = ACTIONS(4959),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_constexpr] = ACTIONS(4959),
    [anon_sym_volatile] = ACTIONS(4959),
    [anon_sym_restrict] = ACTIONS(4959),
    [anon_sym___restrict__] = ACTIONS(4959),
    [anon_sym__Atomic] = ACTIONS(4959),
    [anon_sym__Noreturn] = ACTIONS(4959),
    [anon_sym_noreturn] = ACTIONS(4959),
    [anon_sym__Nonnull] = ACTIONS(4959),
    [anon_sym_mutable] = ACTIONS(4959),
    [anon_sym_constinit] = ACTIONS(4959),
    [anon_sym_consteval] = ACTIONS(4959),
    [anon_sym_alignas] = ACTIONS(4959),
    [anon_sym__Alignas] = ACTIONS(4959),
    [sym_primitive_type] = ACTIONS(4959),
    [anon_sym_enum] = ACTIONS(4959),
    [anon_sym_class] = ACTIONS(4959),
    [anon_sym_struct] = ACTIONS(4959),
    [anon_sym_union] = ACTIONS(4959),
    [anon_sym_or] = ACTIONS(4959),
    [anon_sym_and] = ACTIONS(4959),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4959),
    [anon_sym_decltype] = ACTIONS(4959),
    [anon_sym_explicit] = ACTIONS(4959),
    [anon_sym_typename] = ACTIONS(4959),
    [anon_sym_template] = ACTIONS(4959),
    [anon_sym_operator] = ACTIONS(4959),
    [anon_sym_friend] = ACTIONS(4959),
    [anon_sym_concept] = ACTIONS(4959),
  },
  [2245] = {
    [sym_identifier] = ACTIONS(5450),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [aux_sym_preproc_if_token2] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5450),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5452),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5450),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5450),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5450),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym___attribute__] = ACTIONS(5450),
    [anon_sym___attribute] = ACTIONS(5450),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_STAR_EQ] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5452),
    [anon_sym_PLUS_EQ] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5452),
    [anon_sym_CARET_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_EQ] = ACTIONS(5452),
    [anon_sym_and_eq] = ACTIONS(5450),
    [anon_sym_or_eq] = ACTIONS(5450),
    [anon_sym_xor_eq] = ACTIONS(5450),
    [anon_sym_LT_EQ_GT] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_and] = ACTIONS(5450),
    [anon_sym_bitor] = ACTIONS(5450),
    [anon_sym_xor] = ACTIONS(5450),
    [anon_sym_bitand] = ACTIONS(5450),
    [anon_sym_not_eq] = ACTIONS(5450),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5450),
    [anon_sym_decltype] = ACTIONS(5450),
  },
  [2246] = {
    [sym_identifier] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5796),
    [anon_sym_COMMA] = ACTIONS(5796),
    [anon_sym_RPAREN] = ACTIONS(5796),
    [aux_sym_preproc_if_token2] = ACTIONS(5796),
    [aux_sym_preproc_else_token1] = ACTIONS(5796),
    [aux_sym_preproc_elif_token1] = ACTIONS(5794),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5796),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5796),
    [anon_sym_LPAREN2] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5794),
    [anon_sym_STAR] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5794),
    [anon_sym_PERCENT] = ACTIONS(5794),
    [anon_sym_PIPE_PIPE] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_CARET] = ACTIONS(5794),
    [anon_sym_AMP] = ACTIONS(5794),
    [anon_sym_EQ_EQ] = ACTIONS(5796),
    [anon_sym_BANG_EQ] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5794),
    [anon_sym_GT_GT] = ACTIONS(5794),
    [anon_sym_SEMI] = ACTIONS(5796),
    [anon_sym___attribute__] = ACTIONS(5794),
    [anon_sym___attribute] = ACTIONS(5794),
    [anon_sym_COLON] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(5796),
    [anon_sym_RBRACE] = ACTIONS(5796),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_RBRACK] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5794),
    [anon_sym_QMARK] = ACTIONS(5796),
    [anon_sym_STAR_EQ] = ACTIONS(5796),
    [anon_sym_SLASH_EQ] = ACTIONS(5796),
    [anon_sym_PERCENT_EQ] = ACTIONS(5796),
    [anon_sym_PLUS_EQ] = ACTIONS(5796),
    [anon_sym_DASH_EQ] = ACTIONS(5796),
    [anon_sym_LT_LT_EQ] = ACTIONS(5796),
    [anon_sym_GT_GT_EQ] = ACTIONS(5796),
    [anon_sym_AMP_EQ] = ACTIONS(5796),
    [anon_sym_CARET_EQ] = ACTIONS(5796),
    [anon_sym_PIPE_EQ] = ACTIONS(5796),
    [anon_sym_and_eq] = ACTIONS(5794),
    [anon_sym_or_eq] = ACTIONS(5794),
    [anon_sym_xor_eq] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5796),
    [anon_sym_or] = ACTIONS(5794),
    [anon_sym_and] = ACTIONS(5794),
    [anon_sym_bitor] = ACTIONS(5794),
    [anon_sym_xor] = ACTIONS(5794),
    [anon_sym_bitand] = ACTIONS(5794),
    [anon_sym_not_eq] = ACTIONS(5794),
    [anon_sym_DASH_DASH] = ACTIONS(5796),
    [anon_sym_PLUS_PLUS] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5794),
    [anon_sym_DOT_STAR] = ACTIONS(5796),
    [anon_sym_DASH_GT] = ACTIONS(5796),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5794),
    [anon_sym_decltype] = ACTIONS(5794),
  },
  [2247] = {
    [sym_attribute_declaration] = STATE(2247),
    [aux_sym_attributed_declarator_repeat1] = STATE(2247),
    [sym_identifier] = ACTIONS(2051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6235),
    [anon_sym_COMMA] = ACTIONS(6235),
    [anon_sym_RPAREN] = ACTIONS(6235),
    [aux_sym_preproc_if_token2] = ACTIONS(6235),
    [aux_sym_preproc_else_token1] = ACTIONS(6235),
    [aux_sym_preproc_elif_token1] = ACTIONS(2051),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6235),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6235),
    [anon_sym_LPAREN2] = ACTIONS(6235),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_SLASH] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(6235),
    [anon_sym_AMP_AMP] = ACTIONS(6235),
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_EQ_EQ] = ACTIONS(6235),
    [anon_sym_BANG_EQ] = ACTIONS(6235),
    [anon_sym_GT] = ACTIONS(2051),
    [anon_sym_GT_EQ] = ACTIONS(6235),
    [anon_sym_LT_EQ] = ACTIONS(2051),
    [anon_sym_LT] = ACTIONS(2051),
    [anon_sym_LT_LT] = ACTIONS(2051),
    [anon_sym_GT_GT] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(6235),
    [anon_sym___attribute__] = ACTIONS(2051),
    [anon_sym___attribute] = ACTIONS(2051),
    [anon_sym_COLON] = ACTIONS(6235),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6237),
    [anon_sym_RBRACE] = ACTIONS(6235),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [anon_sym_RBRACK] = ACTIONS(6235),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_QMARK] = ACTIONS(6235),
    [anon_sym_STAR_EQ] = ACTIONS(6235),
    [anon_sym_SLASH_EQ] = ACTIONS(6235),
    [anon_sym_PERCENT_EQ] = ACTIONS(6235),
    [anon_sym_PLUS_EQ] = ACTIONS(6235),
    [anon_sym_DASH_EQ] = ACTIONS(6235),
    [anon_sym_LT_LT_EQ] = ACTIONS(6235),
    [anon_sym_GT_GT_EQ] = ACTIONS(6235),
    [anon_sym_AMP_EQ] = ACTIONS(6235),
    [anon_sym_CARET_EQ] = ACTIONS(6235),
    [anon_sym_PIPE_EQ] = ACTIONS(6235),
    [anon_sym_and_eq] = ACTIONS(2051),
    [anon_sym_or_eq] = ACTIONS(2051),
    [anon_sym_xor_eq] = ACTIONS(2051),
    [anon_sym_LT_EQ_GT] = ACTIONS(6235),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_bitor] = ACTIONS(2051),
    [anon_sym_xor] = ACTIONS(2051),
    [anon_sym_bitand] = ACTIONS(2051),
    [anon_sym_not_eq] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(6235),
    [anon_sym_PLUS_PLUS] = ACTIONS(6235),
    [anon_sym_DOT] = ACTIONS(2051),
    [anon_sym_DOT_STAR] = ACTIONS(6235),
    [anon_sym_DASH_GT] = ACTIONS(6235),
    [sym_comment] = ACTIONS(3),
  },
  [2248] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5898),
    [anon_sym_COMMA] = ACTIONS(5898),
    [aux_sym_preproc_if_token2] = ACTIONS(5898),
    [aux_sym_preproc_else_token1] = ACTIONS(5898),
    [aux_sym_preproc_elif_token1] = ACTIONS(5900),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5898),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5898),
    [anon_sym_LPAREN2] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5900),
    [anon_sym_STAR] = ACTIONS(5900),
    [anon_sym_SLASH] = ACTIONS(5900),
    [anon_sym_PERCENT] = ACTIONS(5900),
    [anon_sym_PIPE_PIPE] = ACTIONS(5898),
    [anon_sym_AMP_AMP] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_CARET] = ACTIONS(5900),
    [anon_sym_AMP] = ACTIONS(5900),
    [anon_sym_EQ_EQ] = ACTIONS(5898),
    [anon_sym_BANG_EQ] = ACTIONS(5898),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5900),
    [anon_sym_GT_GT] = ACTIONS(5900),
    [anon_sym___attribute__] = ACTIONS(5900),
    [anon_sym___attribute] = ACTIONS(5900),
    [anon_sym_LBRACE] = ACTIONS(5898),
    [anon_sym_signed] = ACTIONS(6176),
    [anon_sym_unsigned] = ACTIONS(6176),
    [anon_sym_long] = ACTIONS(6176),
    [anon_sym_short] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5900),
    [anon_sym_QMARK] = ACTIONS(5898),
    [anon_sym_STAR_EQ] = ACTIONS(5898),
    [anon_sym_SLASH_EQ] = ACTIONS(5898),
    [anon_sym_PERCENT_EQ] = ACTIONS(5898),
    [anon_sym_PLUS_EQ] = ACTIONS(5898),
    [anon_sym_DASH_EQ] = ACTIONS(5898),
    [anon_sym_LT_LT_EQ] = ACTIONS(5898),
    [anon_sym_GT_GT_EQ] = ACTIONS(5898),
    [anon_sym_AMP_EQ] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(5898),
    [anon_sym_PIPE_EQ] = ACTIONS(5898),
    [anon_sym_and_eq] = ACTIONS(5900),
    [anon_sym_or_eq] = ACTIONS(5900),
    [anon_sym_xor_eq] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5898),
    [anon_sym_or] = ACTIONS(5900),
    [anon_sym_and] = ACTIONS(5900),
    [anon_sym_bitor] = ACTIONS(5900),
    [anon_sym_xor] = ACTIONS(5900),
    [anon_sym_bitand] = ACTIONS(5900),
    [anon_sym_not_eq] = ACTIONS(5900),
    [anon_sym_DASH_DASH] = ACTIONS(5898),
    [anon_sym_PLUS_PLUS] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5900),
    [anon_sym_DOT_STAR] = ACTIONS(5898),
    [anon_sym_DASH_GT] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5900),
    [anon_sym_decltype] = ACTIONS(5900),
  },
  [2249] = {
    [sym_identifier] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5788),
    [anon_sym_RPAREN] = ACTIONS(5788),
    [aux_sym_preproc_if_token2] = ACTIONS(5788),
    [aux_sym_preproc_else_token1] = ACTIONS(5788),
    [aux_sym_preproc_elif_token1] = ACTIONS(5786),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5788),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5788),
    [anon_sym_LPAREN2] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5786),
    [anon_sym_STAR] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(5786),
    [anon_sym_PERCENT] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5788),
    [anon_sym_AMP_AMP] = ACTIONS(5788),
    [anon_sym_PIPE] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5786),
    [anon_sym_AMP] = ACTIONS(5786),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5786),
    [anon_sym_LT_LT] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5786),
    [anon_sym_SEMI] = ACTIONS(5788),
    [anon_sym___attribute__] = ACTIONS(5786),
    [anon_sym___attribute] = ACTIONS(5786),
    [anon_sym_COLON] = ACTIONS(5788),
    [anon_sym_LBRACE] = ACTIONS(5788),
    [anon_sym_RBRACE] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_RBRACK] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5788),
    [anon_sym_STAR_EQ] = ACTIONS(5788),
    [anon_sym_SLASH_EQ] = ACTIONS(5788),
    [anon_sym_PERCENT_EQ] = ACTIONS(5788),
    [anon_sym_PLUS_EQ] = ACTIONS(5788),
    [anon_sym_DASH_EQ] = ACTIONS(5788),
    [anon_sym_LT_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT_GT_EQ] = ACTIONS(5788),
    [anon_sym_AMP_EQ] = ACTIONS(5788),
    [anon_sym_CARET_EQ] = ACTIONS(5788),
    [anon_sym_PIPE_EQ] = ACTIONS(5788),
    [anon_sym_and_eq] = ACTIONS(5786),
    [anon_sym_or_eq] = ACTIONS(5786),
    [anon_sym_xor_eq] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5788),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_bitor] = ACTIONS(5786),
    [anon_sym_xor] = ACTIONS(5786),
    [anon_sym_bitand] = ACTIONS(5786),
    [anon_sym_not_eq] = ACTIONS(5786),
    [anon_sym_DASH_DASH] = ACTIONS(5788),
    [anon_sym_PLUS_PLUS] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5786),
    [anon_sym_DOT_STAR] = ACTIONS(5788),
    [anon_sym_DASH_GT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5786),
    [anon_sym_decltype] = ACTIONS(5786),
  },
  [2250] = {
    [sym_identifier] = ACTIONS(5605),
    [anon_sym_LPAREN2] = ACTIONS(5607),
    [anon_sym_TILDE] = ACTIONS(5607),
    [anon_sym_STAR] = ACTIONS(5607),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_AMP_AMP] = ACTIONS(5607),
    [anon_sym_AMP] = ACTIONS(5605),
    [anon_sym___extension__] = ACTIONS(5605),
    [anon_sym_virtual] = ACTIONS(5605),
    [anon_sym_extern] = ACTIONS(5605),
    [anon_sym___attribute__] = ACTIONS(5605),
    [anon_sym___attribute] = ACTIONS(5605),
    [anon_sym_using] = ACTIONS(5605),
    [anon_sym_COLON_COLON] = ACTIONS(5607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5607),
    [anon_sym___declspec] = ACTIONS(5605),
    [anon_sym___based] = ACTIONS(5605),
    [anon_sym___cdecl] = ACTIONS(5605),
    [anon_sym___clrcall] = ACTIONS(5605),
    [anon_sym___stdcall] = ACTIONS(5605),
    [anon_sym___fastcall] = ACTIONS(5605),
    [anon_sym___thiscall] = ACTIONS(5605),
    [anon_sym___vectorcall] = ACTIONS(5605),
    [anon_sym_signed] = ACTIONS(5605),
    [anon_sym_unsigned] = ACTIONS(5605),
    [anon_sym_long] = ACTIONS(5605),
    [anon_sym_short] = ACTIONS(5605),
    [anon_sym_LBRACK] = ACTIONS(5605),
    [anon_sym_static] = ACTIONS(5605),
    [anon_sym_register] = ACTIONS(5605),
    [anon_sym_inline] = ACTIONS(5605),
    [anon_sym___inline] = ACTIONS(5605),
    [anon_sym___inline__] = ACTIONS(5605),
    [anon_sym___forceinline] = ACTIONS(5605),
    [anon_sym_thread_local] = ACTIONS(5605),
    [anon_sym___thread] = ACTIONS(5605),
    [anon_sym_const] = ACTIONS(5605),
    [anon_sym_constexpr] = ACTIONS(5605),
    [anon_sym_volatile] = ACTIONS(5605),
    [anon_sym_restrict] = ACTIONS(5605),
    [anon_sym___restrict__] = ACTIONS(5605),
    [anon_sym__Atomic] = ACTIONS(5605),
    [anon_sym__Noreturn] = ACTIONS(5605),
    [anon_sym_noreturn] = ACTIONS(5605),
    [anon_sym__Nonnull] = ACTIONS(5605),
    [anon_sym_mutable] = ACTIONS(5605),
    [anon_sym_constinit] = ACTIONS(5605),
    [anon_sym_consteval] = ACTIONS(5605),
    [anon_sym_alignas] = ACTIONS(5605),
    [anon_sym__Alignas] = ACTIONS(5605),
    [sym_primitive_type] = ACTIONS(5605),
    [anon_sym_enum] = ACTIONS(5605),
    [anon_sym_class] = ACTIONS(5605),
    [anon_sym_struct] = ACTIONS(5605),
    [anon_sym_union] = ACTIONS(5605),
    [anon_sym_or] = ACTIONS(5605),
    [anon_sym_and] = ACTIONS(5605),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5605),
    [anon_sym_decltype] = ACTIONS(5605),
    [anon_sym_explicit] = ACTIONS(5605),
    [anon_sym_typename] = ACTIONS(5605),
    [anon_sym_template] = ACTIONS(5605),
    [anon_sym_operator] = ACTIONS(5605),
    [anon_sym_friend] = ACTIONS(5605),
    [anon_sym_concept] = ACTIONS(5605),
  },
  [2251] = {
    [sym_identifier] = ACTIONS(5637),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5639),
    [anon_sym_COMMA] = ACTIONS(5639),
    [anon_sym_RPAREN] = ACTIONS(5639),
    [aux_sym_preproc_if_token2] = ACTIONS(5639),
    [aux_sym_preproc_else_token1] = ACTIONS(5639),
    [aux_sym_preproc_elif_token1] = ACTIONS(5637),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5639),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5639),
    [anon_sym_LPAREN2] = ACTIONS(5639),
    [anon_sym_DASH] = ACTIONS(5637),
    [anon_sym_PLUS] = ACTIONS(5637),
    [anon_sym_STAR] = ACTIONS(5637),
    [anon_sym_SLASH] = ACTIONS(5637),
    [anon_sym_PERCENT] = ACTIONS(5637),
    [anon_sym_PIPE_PIPE] = ACTIONS(5639),
    [anon_sym_AMP_AMP] = ACTIONS(5639),
    [anon_sym_PIPE] = ACTIONS(5637),
    [anon_sym_CARET] = ACTIONS(5637),
    [anon_sym_AMP] = ACTIONS(5637),
    [anon_sym_EQ_EQ] = ACTIONS(5639),
    [anon_sym_BANG_EQ] = ACTIONS(5639),
    [anon_sym_GT] = ACTIONS(5637),
    [anon_sym_GT_EQ] = ACTIONS(5639),
    [anon_sym_LT_EQ] = ACTIONS(5637),
    [anon_sym_LT] = ACTIONS(5637),
    [anon_sym_LT_LT] = ACTIONS(5637),
    [anon_sym_GT_GT] = ACTIONS(5637),
    [anon_sym_SEMI] = ACTIONS(5639),
    [anon_sym___attribute__] = ACTIONS(5637),
    [anon_sym___attribute] = ACTIONS(5637),
    [anon_sym_COLON] = ACTIONS(5639),
    [anon_sym_LBRACE] = ACTIONS(5639),
    [anon_sym_RBRACE] = ACTIONS(5639),
    [anon_sym_LBRACK] = ACTIONS(5639),
    [anon_sym_RBRACK] = ACTIONS(5639),
    [anon_sym_EQ] = ACTIONS(5637),
    [anon_sym_QMARK] = ACTIONS(5639),
    [anon_sym_STAR_EQ] = ACTIONS(5639),
    [anon_sym_SLASH_EQ] = ACTIONS(5639),
    [anon_sym_PERCENT_EQ] = ACTIONS(5639),
    [anon_sym_PLUS_EQ] = ACTIONS(5639),
    [anon_sym_DASH_EQ] = ACTIONS(5639),
    [anon_sym_LT_LT_EQ] = ACTIONS(5639),
    [anon_sym_GT_GT_EQ] = ACTIONS(5639),
    [anon_sym_AMP_EQ] = ACTIONS(5639),
    [anon_sym_CARET_EQ] = ACTIONS(5639),
    [anon_sym_PIPE_EQ] = ACTIONS(5639),
    [anon_sym_and_eq] = ACTIONS(5637),
    [anon_sym_or_eq] = ACTIONS(5637),
    [anon_sym_xor_eq] = ACTIONS(5637),
    [anon_sym_LT_EQ_GT] = ACTIONS(5639),
    [anon_sym_or] = ACTIONS(5637),
    [anon_sym_and] = ACTIONS(5637),
    [anon_sym_bitor] = ACTIONS(5637),
    [anon_sym_xor] = ACTIONS(5637),
    [anon_sym_bitand] = ACTIONS(5637),
    [anon_sym_not_eq] = ACTIONS(5637),
    [anon_sym_DASH_DASH] = ACTIONS(5639),
    [anon_sym_PLUS_PLUS] = ACTIONS(5639),
    [anon_sym_DOT] = ACTIONS(5637),
    [anon_sym_DOT_STAR] = ACTIONS(5639),
    [anon_sym_DASH_GT] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5637),
    [anon_sym_decltype] = ACTIONS(5637),
  },
  [2252] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5579),
    [anon_sym_COMMA] = ACTIONS(5579),
    [anon_sym_RPAREN] = ACTIONS(5579),
    [anon_sym_LPAREN2] = ACTIONS(5579),
    [anon_sym_DASH] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5577),
    [anon_sym_STAR] = ACTIONS(5577),
    [anon_sym_SLASH] = ACTIONS(5577),
    [anon_sym_PERCENT] = ACTIONS(5577),
    [anon_sym_PIPE_PIPE] = ACTIONS(5579),
    [anon_sym_AMP_AMP] = ACTIONS(5579),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_CARET] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5577),
    [anon_sym_EQ_EQ] = ACTIONS(5579),
    [anon_sym_BANG_EQ] = ACTIONS(5579),
    [anon_sym_GT] = ACTIONS(5577),
    [anon_sym_GT_EQ] = ACTIONS(5579),
    [anon_sym_LT_EQ] = ACTIONS(5577),
    [anon_sym_LT] = ACTIONS(5577),
    [anon_sym_LT_LT] = ACTIONS(5577),
    [anon_sym_GT_GT] = ACTIONS(5577),
    [anon_sym_SEMI] = ACTIONS(5579),
    [anon_sym_COLON] = ACTIONS(5579),
    [anon_sym_RBRACE] = ACTIONS(5579),
    [anon_sym_LBRACK] = ACTIONS(5579),
    [anon_sym_RBRACK] = ACTIONS(5579),
    [anon_sym_EQ] = ACTIONS(5577),
    [anon_sym_QMARK] = ACTIONS(5579),
    [anon_sym_STAR_EQ] = ACTIONS(5579),
    [anon_sym_SLASH_EQ] = ACTIONS(5579),
    [anon_sym_PERCENT_EQ] = ACTIONS(5579),
    [anon_sym_PLUS_EQ] = ACTIONS(5579),
    [anon_sym_DASH_EQ] = ACTIONS(5579),
    [anon_sym_LT_LT_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_AMP_EQ] = ACTIONS(5579),
    [anon_sym_CARET_EQ] = ACTIONS(5579),
    [anon_sym_PIPE_EQ] = ACTIONS(5579),
    [anon_sym_and_eq] = ACTIONS(5577),
    [anon_sym_or_eq] = ACTIONS(5577),
    [anon_sym_xor_eq] = ACTIONS(5577),
    [anon_sym_LT_EQ_GT] = ACTIONS(5579),
    [anon_sym_or] = ACTIONS(5577),
    [anon_sym_and] = ACTIONS(5577),
    [anon_sym_bitor] = ACTIONS(5577),
    [anon_sym_xor] = ACTIONS(5577),
    [anon_sym_bitand] = ACTIONS(5577),
    [anon_sym_not_eq] = ACTIONS(5577),
    [anon_sym_DASH_DASH] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5579),
    [anon_sym_DOT] = ACTIONS(5577),
    [anon_sym_DOT_STAR] = ACTIONS(5579),
    [anon_sym_DASH_GT] = ACTIONS(5579),
    [anon_sym_L_DQUOTE] = ACTIONS(5579),
    [anon_sym_u_DQUOTE] = ACTIONS(5579),
    [anon_sym_U_DQUOTE] = ACTIONS(5579),
    [anon_sym_u8_DQUOTE] = ACTIONS(5579),
    [anon_sym_DQUOTE] = ACTIONS(5579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5579),
    [anon_sym_LR_DQUOTE] = ACTIONS(5579),
    [anon_sym_uR_DQUOTE] = ACTIONS(5579),
    [anon_sym_UR_DQUOTE] = ACTIONS(5579),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5579),
    [sym_literal_suffix] = ACTIONS(5577),
  },
  [2253] = {
    [sym_identifier] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_COMMA] = ACTIONS(5800),
    [anon_sym_RPAREN] = ACTIONS(5800),
    [aux_sym_preproc_if_token2] = ACTIONS(5800),
    [aux_sym_preproc_else_token1] = ACTIONS(5800),
    [aux_sym_preproc_elif_token1] = ACTIONS(5798),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5800),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5800),
    [anon_sym_LPAREN2] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5798),
    [anon_sym_SLASH] = ACTIONS(5798),
    [anon_sym_PERCENT] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5800),
    [anon_sym_AMP_AMP] = ACTIONS(5800),
    [anon_sym_PIPE] = ACTIONS(5798),
    [anon_sym_CARET] = ACTIONS(5798),
    [anon_sym_AMP] = ACTIONS(5798),
    [anon_sym_EQ_EQ] = ACTIONS(5800),
    [anon_sym_BANG_EQ] = ACTIONS(5800),
    [anon_sym_GT] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5798),
    [anon_sym_LT_LT] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5798),
    [anon_sym_SEMI] = ACTIONS(5800),
    [anon_sym___attribute__] = ACTIONS(5798),
    [anon_sym___attribute] = ACTIONS(5798),
    [anon_sym_COLON] = ACTIONS(5800),
    [anon_sym_LBRACE] = ACTIONS(5800),
    [anon_sym_RBRACE] = ACTIONS(5800),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_RBRACK] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5800),
    [anon_sym_STAR_EQ] = ACTIONS(5800),
    [anon_sym_SLASH_EQ] = ACTIONS(5800),
    [anon_sym_PERCENT_EQ] = ACTIONS(5800),
    [anon_sym_PLUS_EQ] = ACTIONS(5800),
    [anon_sym_DASH_EQ] = ACTIONS(5800),
    [anon_sym_LT_LT_EQ] = ACTIONS(5800),
    [anon_sym_GT_GT_EQ] = ACTIONS(5800),
    [anon_sym_AMP_EQ] = ACTIONS(5800),
    [anon_sym_CARET_EQ] = ACTIONS(5800),
    [anon_sym_PIPE_EQ] = ACTIONS(5800),
    [anon_sym_and_eq] = ACTIONS(5798),
    [anon_sym_or_eq] = ACTIONS(5798),
    [anon_sym_xor_eq] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5800),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_bitor] = ACTIONS(5798),
    [anon_sym_xor] = ACTIONS(5798),
    [anon_sym_bitand] = ACTIONS(5798),
    [anon_sym_not_eq] = ACTIONS(5798),
    [anon_sym_DASH_DASH] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(5800),
    [anon_sym_DOT] = ACTIONS(5798),
    [anon_sym_DOT_STAR] = ACTIONS(5800),
    [anon_sym_DASH_GT] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5798),
    [anon_sym_decltype] = ACTIONS(5798),
  },
  [2254] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2265),
    [sym_identifier] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5936),
    [anon_sym_COMMA] = ACTIONS(5936),
    [aux_sym_preproc_if_token2] = ACTIONS(5936),
    [aux_sym_preproc_else_token1] = ACTIONS(5936),
    [aux_sym_preproc_elif_token1] = ACTIONS(5938),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5936),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5936),
    [anon_sym_LPAREN2] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_STAR] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5938),
    [anon_sym_PERCENT] = ACTIONS(5938),
    [anon_sym_PIPE_PIPE] = ACTIONS(5936),
    [anon_sym_AMP_AMP] = ACTIONS(5936),
    [anon_sym_PIPE] = ACTIONS(5938),
    [anon_sym_CARET] = ACTIONS(5938),
    [anon_sym_AMP] = ACTIONS(5938),
    [anon_sym_EQ_EQ] = ACTIONS(5936),
    [anon_sym_BANG_EQ] = ACTIONS(5936),
    [anon_sym_GT] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5938),
    [anon_sym_LT_LT] = ACTIONS(5938),
    [anon_sym_GT_GT] = ACTIONS(5938),
    [anon_sym___attribute__] = ACTIONS(5938),
    [anon_sym___attribute] = ACTIONS(5938),
    [anon_sym_LBRACE] = ACTIONS(5936),
    [anon_sym_signed] = ACTIONS(6240),
    [anon_sym_unsigned] = ACTIONS(6240),
    [anon_sym_long] = ACTIONS(6240),
    [anon_sym_short] = ACTIONS(6240),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5938),
    [anon_sym_QMARK] = ACTIONS(5936),
    [anon_sym_STAR_EQ] = ACTIONS(5936),
    [anon_sym_SLASH_EQ] = ACTIONS(5936),
    [anon_sym_PERCENT_EQ] = ACTIONS(5936),
    [anon_sym_PLUS_EQ] = ACTIONS(5936),
    [anon_sym_DASH_EQ] = ACTIONS(5936),
    [anon_sym_LT_LT_EQ] = ACTIONS(5936),
    [anon_sym_GT_GT_EQ] = ACTIONS(5936),
    [anon_sym_AMP_EQ] = ACTIONS(5936),
    [anon_sym_CARET_EQ] = ACTIONS(5936),
    [anon_sym_PIPE_EQ] = ACTIONS(5936),
    [anon_sym_and_eq] = ACTIONS(5938),
    [anon_sym_or_eq] = ACTIONS(5938),
    [anon_sym_xor_eq] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5936),
    [anon_sym_or] = ACTIONS(5938),
    [anon_sym_and] = ACTIONS(5938),
    [anon_sym_bitor] = ACTIONS(5938),
    [anon_sym_xor] = ACTIONS(5938),
    [anon_sym_bitand] = ACTIONS(5938),
    [anon_sym_not_eq] = ACTIONS(5938),
    [anon_sym_DASH_DASH] = ACTIONS(5936),
    [anon_sym_PLUS_PLUS] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5938),
    [anon_sym_DOT_STAR] = ACTIONS(5936),
    [anon_sym_DASH_GT] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5938),
    [anon_sym_decltype] = ACTIONS(5938),
  },
  [2255] = {
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5653),
    [anon_sym_COMMA] = ACTIONS(5653),
    [anon_sym_RPAREN] = ACTIONS(5653),
    [aux_sym_preproc_if_token2] = ACTIONS(5653),
    [aux_sym_preproc_else_token1] = ACTIONS(5653),
    [aux_sym_preproc_elif_token1] = ACTIONS(5651),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5653),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5653),
    [anon_sym_LPAREN2] = ACTIONS(5653),
    [anon_sym_DASH] = ACTIONS(5651),
    [anon_sym_PLUS] = ACTIONS(5651),
    [anon_sym_STAR] = ACTIONS(5651),
    [anon_sym_SLASH] = ACTIONS(5651),
    [anon_sym_PERCENT] = ACTIONS(5651),
    [anon_sym_PIPE_PIPE] = ACTIONS(5653),
    [anon_sym_AMP_AMP] = ACTIONS(5653),
    [anon_sym_PIPE] = ACTIONS(5651),
    [anon_sym_CARET] = ACTIONS(5651),
    [anon_sym_AMP] = ACTIONS(5651),
    [anon_sym_EQ_EQ] = ACTIONS(5653),
    [anon_sym_BANG_EQ] = ACTIONS(5653),
    [anon_sym_GT] = ACTIONS(5651),
    [anon_sym_GT_EQ] = ACTIONS(5653),
    [anon_sym_LT_EQ] = ACTIONS(5651),
    [anon_sym_LT] = ACTIONS(5651),
    [anon_sym_LT_LT] = ACTIONS(5651),
    [anon_sym_GT_GT] = ACTIONS(5651),
    [anon_sym_SEMI] = ACTIONS(5653),
    [anon_sym___attribute__] = ACTIONS(5651),
    [anon_sym___attribute] = ACTIONS(5651),
    [anon_sym_COLON] = ACTIONS(5653),
    [anon_sym_LBRACE] = ACTIONS(5653),
    [anon_sym_RBRACE] = ACTIONS(5653),
    [anon_sym_LBRACK] = ACTIONS(5653),
    [anon_sym_RBRACK] = ACTIONS(5653),
    [anon_sym_EQ] = ACTIONS(5651),
    [anon_sym_QMARK] = ACTIONS(5653),
    [anon_sym_STAR_EQ] = ACTIONS(5653),
    [anon_sym_SLASH_EQ] = ACTIONS(5653),
    [anon_sym_PERCENT_EQ] = ACTIONS(5653),
    [anon_sym_PLUS_EQ] = ACTIONS(5653),
    [anon_sym_DASH_EQ] = ACTIONS(5653),
    [anon_sym_LT_LT_EQ] = ACTIONS(5653),
    [anon_sym_GT_GT_EQ] = ACTIONS(5653),
    [anon_sym_AMP_EQ] = ACTIONS(5653),
    [anon_sym_CARET_EQ] = ACTIONS(5653),
    [anon_sym_PIPE_EQ] = ACTIONS(5653),
    [anon_sym_and_eq] = ACTIONS(5651),
    [anon_sym_or_eq] = ACTIONS(5651),
    [anon_sym_xor_eq] = ACTIONS(5651),
    [anon_sym_LT_EQ_GT] = ACTIONS(5653),
    [anon_sym_or] = ACTIONS(5651),
    [anon_sym_and] = ACTIONS(5651),
    [anon_sym_bitor] = ACTIONS(5651),
    [anon_sym_xor] = ACTIONS(5651),
    [anon_sym_bitand] = ACTIONS(5651),
    [anon_sym_not_eq] = ACTIONS(5651),
    [anon_sym_DASH_DASH] = ACTIONS(5653),
    [anon_sym_PLUS_PLUS] = ACTIONS(5653),
    [anon_sym_DOT] = ACTIONS(5651),
    [anon_sym_DOT_STAR] = ACTIONS(5653),
    [anon_sym_DASH_GT] = ACTIONS(5653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5651),
    [anon_sym_decltype] = ACTIONS(5651),
  },
  [2256] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [aux_sym_preproc_if_token2] = ACTIONS(5930),
    [aux_sym_preproc_else_token1] = ACTIONS(5930),
    [aux_sym_preproc_elif_token1] = ACTIONS(5932),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5930),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5930),
    [anon_sym_LPAREN2] = ACTIONS(5930),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_PLUS] = ACTIONS(5932),
    [anon_sym_STAR] = ACTIONS(5932),
    [anon_sym_SLASH] = ACTIONS(5932),
    [anon_sym_PERCENT] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_AMP_AMP] = ACTIONS(5930),
    [anon_sym_PIPE] = ACTIONS(5932),
    [anon_sym_CARET] = ACTIONS(5932),
    [anon_sym_AMP] = ACTIONS(5932),
    [anon_sym_EQ_EQ] = ACTIONS(5930),
    [anon_sym_BANG_EQ] = ACTIONS(5930),
    [anon_sym_GT] = ACTIONS(5932),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_LT] = ACTIONS(5932),
    [anon_sym_LT_LT] = ACTIONS(5932),
    [anon_sym_GT_GT] = ACTIONS(5932),
    [anon_sym___attribute__] = ACTIONS(5932),
    [anon_sym___attribute] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(5930),
    [anon_sym_signed] = ACTIONS(6242),
    [anon_sym_unsigned] = ACTIONS(6242),
    [anon_sym_long] = ACTIONS(6242),
    [anon_sym_short] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(5930),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_QMARK] = ACTIONS(5930),
    [anon_sym_STAR_EQ] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_PERCENT_EQ] = ACTIONS(5930),
    [anon_sym_PLUS_EQ] = ACTIONS(5930),
    [anon_sym_DASH_EQ] = ACTIONS(5930),
    [anon_sym_LT_LT_EQ] = ACTIONS(5930),
    [anon_sym_GT_GT_EQ] = ACTIONS(5930),
    [anon_sym_AMP_EQ] = ACTIONS(5930),
    [anon_sym_CARET_EQ] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_and_eq] = ACTIONS(5932),
    [anon_sym_or_eq] = ACTIONS(5932),
    [anon_sym_xor_eq] = ACTIONS(5932),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_or] = ACTIONS(5932),
    [anon_sym_and] = ACTIONS(5932),
    [anon_sym_bitor] = ACTIONS(5932),
    [anon_sym_xor] = ACTIONS(5932),
    [anon_sym_bitand] = ACTIONS(5932),
    [anon_sym_not_eq] = ACTIONS(5932),
    [anon_sym_DASH_DASH] = ACTIONS(5930),
    [anon_sym_PLUS_PLUS] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_DOT_STAR] = ACTIONS(5930),
    [anon_sym_DASH_GT] = ACTIONS(5930),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5932),
    [anon_sym_decltype] = ACTIONS(5932),
  },
  [2257] = {
    [sym_identifier] = ACTIONS(5655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5657),
    [anon_sym_COMMA] = ACTIONS(5657),
    [anon_sym_RPAREN] = ACTIONS(5657),
    [aux_sym_preproc_if_token2] = ACTIONS(5657),
    [aux_sym_preproc_else_token1] = ACTIONS(5657),
    [aux_sym_preproc_elif_token1] = ACTIONS(5655),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5657),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5657),
    [anon_sym_LPAREN2] = ACTIONS(5657),
    [anon_sym_DASH] = ACTIONS(5655),
    [anon_sym_PLUS] = ACTIONS(5655),
    [anon_sym_STAR] = ACTIONS(5655),
    [anon_sym_SLASH] = ACTIONS(5655),
    [anon_sym_PERCENT] = ACTIONS(5655),
    [anon_sym_PIPE_PIPE] = ACTIONS(5657),
    [anon_sym_AMP_AMP] = ACTIONS(5657),
    [anon_sym_PIPE] = ACTIONS(5655),
    [anon_sym_CARET] = ACTIONS(5655),
    [anon_sym_AMP] = ACTIONS(5655),
    [anon_sym_EQ_EQ] = ACTIONS(5657),
    [anon_sym_BANG_EQ] = ACTIONS(5657),
    [anon_sym_GT] = ACTIONS(5655),
    [anon_sym_GT_EQ] = ACTIONS(5657),
    [anon_sym_LT_EQ] = ACTIONS(5655),
    [anon_sym_LT] = ACTIONS(5655),
    [anon_sym_LT_LT] = ACTIONS(5655),
    [anon_sym_GT_GT] = ACTIONS(5655),
    [anon_sym_SEMI] = ACTIONS(5657),
    [anon_sym___attribute__] = ACTIONS(5655),
    [anon_sym___attribute] = ACTIONS(5655),
    [anon_sym_COLON] = ACTIONS(5657),
    [anon_sym_LBRACE] = ACTIONS(5657),
    [anon_sym_RBRACE] = ACTIONS(5657),
    [anon_sym_LBRACK] = ACTIONS(5657),
    [anon_sym_RBRACK] = ACTIONS(5657),
    [anon_sym_EQ] = ACTIONS(5655),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_STAR_EQ] = ACTIONS(5657),
    [anon_sym_SLASH_EQ] = ACTIONS(5657),
    [anon_sym_PERCENT_EQ] = ACTIONS(5657),
    [anon_sym_PLUS_EQ] = ACTIONS(5657),
    [anon_sym_DASH_EQ] = ACTIONS(5657),
    [anon_sym_LT_LT_EQ] = ACTIONS(5657),
    [anon_sym_GT_GT_EQ] = ACTIONS(5657),
    [anon_sym_AMP_EQ] = ACTIONS(5657),
    [anon_sym_CARET_EQ] = ACTIONS(5657),
    [anon_sym_PIPE_EQ] = ACTIONS(5657),
    [anon_sym_and_eq] = ACTIONS(5655),
    [anon_sym_or_eq] = ACTIONS(5655),
    [anon_sym_xor_eq] = ACTIONS(5655),
    [anon_sym_LT_EQ_GT] = ACTIONS(5657),
    [anon_sym_or] = ACTIONS(5655),
    [anon_sym_and] = ACTIONS(5655),
    [anon_sym_bitor] = ACTIONS(5655),
    [anon_sym_xor] = ACTIONS(5655),
    [anon_sym_bitand] = ACTIONS(5655),
    [anon_sym_not_eq] = ACTIONS(5655),
    [anon_sym_DASH_DASH] = ACTIONS(5657),
    [anon_sym_PLUS_PLUS] = ACTIONS(5657),
    [anon_sym_DOT] = ACTIONS(5655),
    [anon_sym_DOT_STAR] = ACTIONS(5657),
    [anon_sym_DASH_GT] = ACTIONS(5657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5655),
    [anon_sym_decltype] = ACTIONS(5655),
  },
  [2258] = {
    [sym_identifier] = ACTIONS(5659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5661),
    [anon_sym_COMMA] = ACTIONS(5661),
    [anon_sym_RPAREN] = ACTIONS(5661),
    [aux_sym_preproc_if_token2] = ACTIONS(5661),
    [aux_sym_preproc_else_token1] = ACTIONS(5661),
    [aux_sym_preproc_elif_token1] = ACTIONS(5659),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5661),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5661),
    [anon_sym_LPAREN2] = ACTIONS(5661),
    [anon_sym_DASH] = ACTIONS(5659),
    [anon_sym_PLUS] = ACTIONS(5659),
    [anon_sym_STAR] = ACTIONS(5659),
    [anon_sym_SLASH] = ACTIONS(5659),
    [anon_sym_PERCENT] = ACTIONS(5659),
    [anon_sym_PIPE_PIPE] = ACTIONS(5661),
    [anon_sym_AMP_AMP] = ACTIONS(5661),
    [anon_sym_PIPE] = ACTIONS(5659),
    [anon_sym_CARET] = ACTIONS(5659),
    [anon_sym_AMP] = ACTIONS(5659),
    [anon_sym_EQ_EQ] = ACTIONS(5661),
    [anon_sym_BANG_EQ] = ACTIONS(5661),
    [anon_sym_GT] = ACTIONS(5659),
    [anon_sym_GT_EQ] = ACTIONS(5661),
    [anon_sym_LT_EQ] = ACTIONS(5659),
    [anon_sym_LT] = ACTIONS(5659),
    [anon_sym_LT_LT] = ACTIONS(5659),
    [anon_sym_GT_GT] = ACTIONS(5659),
    [anon_sym_SEMI] = ACTIONS(5661),
    [anon_sym___attribute__] = ACTIONS(5659),
    [anon_sym___attribute] = ACTIONS(5659),
    [anon_sym_COLON] = ACTIONS(5661),
    [anon_sym_LBRACE] = ACTIONS(5661),
    [anon_sym_RBRACE] = ACTIONS(5661),
    [anon_sym_LBRACK] = ACTIONS(5661),
    [anon_sym_RBRACK] = ACTIONS(5661),
    [anon_sym_EQ] = ACTIONS(5659),
    [anon_sym_QMARK] = ACTIONS(5661),
    [anon_sym_STAR_EQ] = ACTIONS(5661),
    [anon_sym_SLASH_EQ] = ACTIONS(5661),
    [anon_sym_PERCENT_EQ] = ACTIONS(5661),
    [anon_sym_PLUS_EQ] = ACTIONS(5661),
    [anon_sym_DASH_EQ] = ACTIONS(5661),
    [anon_sym_LT_LT_EQ] = ACTIONS(5661),
    [anon_sym_GT_GT_EQ] = ACTIONS(5661),
    [anon_sym_AMP_EQ] = ACTIONS(5661),
    [anon_sym_CARET_EQ] = ACTIONS(5661),
    [anon_sym_PIPE_EQ] = ACTIONS(5661),
    [anon_sym_and_eq] = ACTIONS(5659),
    [anon_sym_or_eq] = ACTIONS(5659),
    [anon_sym_xor_eq] = ACTIONS(5659),
    [anon_sym_LT_EQ_GT] = ACTIONS(5661),
    [anon_sym_or] = ACTIONS(5659),
    [anon_sym_and] = ACTIONS(5659),
    [anon_sym_bitor] = ACTIONS(5659),
    [anon_sym_xor] = ACTIONS(5659),
    [anon_sym_bitand] = ACTIONS(5659),
    [anon_sym_not_eq] = ACTIONS(5659),
    [anon_sym_DASH_DASH] = ACTIONS(5661),
    [anon_sym_PLUS_PLUS] = ACTIONS(5661),
    [anon_sym_DOT] = ACTIONS(5659),
    [anon_sym_DOT_STAR] = ACTIONS(5661),
    [anon_sym_DASH_GT] = ACTIONS(5661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5659),
    [anon_sym_decltype] = ACTIONS(5659),
  },
  [2259] = {
    [sym_identifier] = ACTIONS(4988),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym___attribute] = ACTIONS(4988),
    [anon_sym_using] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym___cdecl] = ACTIONS(4988),
    [anon_sym___clrcall] = ACTIONS(4988),
    [anon_sym___stdcall] = ACTIONS(4988),
    [anon_sym___fastcall] = ACTIONS(4988),
    [anon_sym___thiscall] = ACTIONS(4988),
    [anon_sym___vectorcall] = ACTIONS(4988),
    [anon_sym_signed] = ACTIONS(4988),
    [anon_sym_unsigned] = ACTIONS(4988),
    [anon_sym_long] = ACTIONS(4988),
    [anon_sym_short] = ACTIONS(4988),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym__Nonnull] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym__Alignas] = ACTIONS(4988),
    [sym_primitive_type] = ACTIONS(4988),
    [anon_sym_enum] = ACTIONS(4988),
    [anon_sym_class] = ACTIONS(4988),
    [anon_sym_struct] = ACTIONS(4988),
    [anon_sym_union] = ACTIONS(4988),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_and] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_explicit] = ACTIONS(4988),
    [anon_sym_typename] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
    [anon_sym_friend] = ACTIONS(4988),
    [anon_sym_concept] = ACTIONS(4988),
  },
  [2260] = {
    [sym_identifier] = ACTIONS(5625),
    [anon_sym_LPAREN2] = ACTIONS(5627),
    [anon_sym_TILDE] = ACTIONS(5627),
    [anon_sym_STAR] = ACTIONS(5627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5627),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym___extension__] = ACTIONS(5625),
    [anon_sym_virtual] = ACTIONS(5625),
    [anon_sym_extern] = ACTIONS(5625),
    [anon_sym___attribute__] = ACTIONS(5625),
    [anon_sym___attribute] = ACTIONS(5625),
    [anon_sym_using] = ACTIONS(5625),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5627),
    [anon_sym___declspec] = ACTIONS(5625),
    [anon_sym___based] = ACTIONS(5625),
    [anon_sym___cdecl] = ACTIONS(5625),
    [anon_sym___clrcall] = ACTIONS(5625),
    [anon_sym___stdcall] = ACTIONS(5625),
    [anon_sym___fastcall] = ACTIONS(5625),
    [anon_sym___thiscall] = ACTIONS(5625),
    [anon_sym___vectorcall] = ACTIONS(5625),
    [anon_sym_signed] = ACTIONS(5625),
    [anon_sym_unsigned] = ACTIONS(5625),
    [anon_sym_long] = ACTIONS(5625),
    [anon_sym_short] = ACTIONS(5625),
    [anon_sym_LBRACK] = ACTIONS(5625),
    [anon_sym_static] = ACTIONS(5625),
    [anon_sym_register] = ACTIONS(5625),
    [anon_sym_inline] = ACTIONS(5625),
    [anon_sym___inline] = ACTIONS(5625),
    [anon_sym___inline__] = ACTIONS(5625),
    [anon_sym___forceinline] = ACTIONS(5625),
    [anon_sym_thread_local] = ACTIONS(5625),
    [anon_sym___thread] = ACTIONS(5625),
    [anon_sym_const] = ACTIONS(5625),
    [anon_sym_constexpr] = ACTIONS(5625),
    [anon_sym_volatile] = ACTIONS(5625),
    [anon_sym_restrict] = ACTIONS(5625),
    [anon_sym___restrict__] = ACTIONS(5625),
    [anon_sym__Atomic] = ACTIONS(5625),
    [anon_sym__Noreturn] = ACTIONS(5625),
    [anon_sym_noreturn] = ACTIONS(5625),
    [anon_sym__Nonnull] = ACTIONS(5625),
    [anon_sym_mutable] = ACTIONS(5625),
    [anon_sym_constinit] = ACTIONS(5625),
    [anon_sym_consteval] = ACTIONS(5625),
    [anon_sym_alignas] = ACTIONS(5625),
    [anon_sym__Alignas] = ACTIONS(5625),
    [sym_primitive_type] = ACTIONS(5625),
    [anon_sym_enum] = ACTIONS(5625),
    [anon_sym_class] = ACTIONS(5625),
    [anon_sym_struct] = ACTIONS(5625),
    [anon_sym_union] = ACTIONS(5625),
    [anon_sym_or] = ACTIONS(5625),
    [anon_sym_and] = ACTIONS(5625),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5625),
    [anon_sym_decltype] = ACTIONS(5625),
    [anon_sym_explicit] = ACTIONS(5625),
    [anon_sym_typename] = ACTIONS(5625),
    [anon_sym_template] = ACTIONS(5625),
    [anon_sym_operator] = ACTIONS(5625),
    [anon_sym_friend] = ACTIONS(5625),
    [anon_sym_concept] = ACTIONS(5625),
  },
  [2261] = {
    [sym_identifier] = ACTIONS(5673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5675),
    [anon_sym_COMMA] = ACTIONS(5675),
    [anon_sym_RPAREN] = ACTIONS(5675),
    [aux_sym_preproc_if_token2] = ACTIONS(5675),
    [aux_sym_preproc_else_token1] = ACTIONS(5675),
    [aux_sym_preproc_elif_token1] = ACTIONS(5673),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5675),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5675),
    [anon_sym_LPAREN2] = ACTIONS(5675),
    [anon_sym_DASH] = ACTIONS(5673),
    [anon_sym_PLUS] = ACTIONS(5673),
    [anon_sym_STAR] = ACTIONS(5673),
    [anon_sym_SLASH] = ACTIONS(5673),
    [anon_sym_PERCENT] = ACTIONS(5673),
    [anon_sym_PIPE_PIPE] = ACTIONS(5675),
    [anon_sym_AMP_AMP] = ACTIONS(5675),
    [anon_sym_PIPE] = ACTIONS(5673),
    [anon_sym_CARET] = ACTIONS(5673),
    [anon_sym_AMP] = ACTIONS(5673),
    [anon_sym_EQ_EQ] = ACTIONS(5675),
    [anon_sym_BANG_EQ] = ACTIONS(5675),
    [anon_sym_GT] = ACTIONS(5673),
    [anon_sym_GT_EQ] = ACTIONS(5675),
    [anon_sym_LT_EQ] = ACTIONS(5673),
    [anon_sym_LT] = ACTIONS(5673),
    [anon_sym_LT_LT] = ACTIONS(5673),
    [anon_sym_GT_GT] = ACTIONS(5673),
    [anon_sym_SEMI] = ACTIONS(5675),
    [anon_sym___attribute__] = ACTIONS(5673),
    [anon_sym___attribute] = ACTIONS(5673),
    [anon_sym_COLON] = ACTIONS(5675),
    [anon_sym_LBRACE] = ACTIONS(5675),
    [anon_sym_RBRACE] = ACTIONS(5675),
    [anon_sym_LBRACK] = ACTIONS(5675),
    [anon_sym_RBRACK] = ACTIONS(5675),
    [anon_sym_EQ] = ACTIONS(5673),
    [anon_sym_QMARK] = ACTIONS(5675),
    [anon_sym_STAR_EQ] = ACTIONS(5675),
    [anon_sym_SLASH_EQ] = ACTIONS(5675),
    [anon_sym_PERCENT_EQ] = ACTIONS(5675),
    [anon_sym_PLUS_EQ] = ACTIONS(5675),
    [anon_sym_DASH_EQ] = ACTIONS(5675),
    [anon_sym_LT_LT_EQ] = ACTIONS(5675),
    [anon_sym_GT_GT_EQ] = ACTIONS(5675),
    [anon_sym_AMP_EQ] = ACTIONS(5675),
    [anon_sym_CARET_EQ] = ACTIONS(5675),
    [anon_sym_PIPE_EQ] = ACTIONS(5675),
    [anon_sym_and_eq] = ACTIONS(5673),
    [anon_sym_or_eq] = ACTIONS(5673),
    [anon_sym_xor_eq] = ACTIONS(5673),
    [anon_sym_LT_EQ_GT] = ACTIONS(5675),
    [anon_sym_or] = ACTIONS(5673),
    [anon_sym_and] = ACTIONS(5673),
    [anon_sym_bitor] = ACTIONS(5673),
    [anon_sym_xor] = ACTIONS(5673),
    [anon_sym_bitand] = ACTIONS(5673),
    [anon_sym_not_eq] = ACTIONS(5673),
    [anon_sym_DASH_DASH] = ACTIONS(5675),
    [anon_sym_PLUS_PLUS] = ACTIONS(5675),
    [anon_sym_DOT] = ACTIONS(5673),
    [anon_sym_DOT_STAR] = ACTIONS(5675),
    [anon_sym_DASH_GT] = ACTIONS(5675),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5673),
    [anon_sym_decltype] = ACTIONS(5673),
  },
  [2262] = {
    [sym_identifier] = ACTIONS(5677),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5679),
    [anon_sym_COMMA] = ACTIONS(5679),
    [anon_sym_RPAREN] = ACTIONS(5679),
    [aux_sym_preproc_if_token2] = ACTIONS(5679),
    [aux_sym_preproc_else_token1] = ACTIONS(5679),
    [aux_sym_preproc_elif_token1] = ACTIONS(5677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5679),
    [anon_sym_LPAREN2] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5677),
    [anon_sym_PLUS] = ACTIONS(5677),
    [anon_sym_STAR] = ACTIONS(5677),
    [anon_sym_SLASH] = ACTIONS(5677),
    [anon_sym_PERCENT] = ACTIONS(5677),
    [anon_sym_PIPE_PIPE] = ACTIONS(5679),
    [anon_sym_AMP_AMP] = ACTIONS(5679),
    [anon_sym_PIPE] = ACTIONS(5677),
    [anon_sym_CARET] = ACTIONS(5677),
    [anon_sym_AMP] = ACTIONS(5677),
    [anon_sym_EQ_EQ] = ACTIONS(5679),
    [anon_sym_BANG_EQ] = ACTIONS(5679),
    [anon_sym_GT] = ACTIONS(5677),
    [anon_sym_GT_EQ] = ACTIONS(5679),
    [anon_sym_LT_EQ] = ACTIONS(5677),
    [anon_sym_LT] = ACTIONS(5677),
    [anon_sym_LT_LT] = ACTIONS(5677),
    [anon_sym_GT_GT] = ACTIONS(5677),
    [anon_sym_SEMI] = ACTIONS(5679),
    [anon_sym___attribute__] = ACTIONS(5677),
    [anon_sym___attribute] = ACTIONS(5677),
    [anon_sym_COLON] = ACTIONS(5679),
    [anon_sym_LBRACE] = ACTIONS(5679),
    [anon_sym_RBRACE] = ACTIONS(5679),
    [anon_sym_LBRACK] = ACTIONS(5679),
    [anon_sym_RBRACK] = ACTIONS(5679),
    [anon_sym_EQ] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_STAR_EQ] = ACTIONS(5679),
    [anon_sym_SLASH_EQ] = ACTIONS(5679),
    [anon_sym_PERCENT_EQ] = ACTIONS(5679),
    [anon_sym_PLUS_EQ] = ACTIONS(5679),
    [anon_sym_DASH_EQ] = ACTIONS(5679),
    [anon_sym_LT_LT_EQ] = ACTIONS(5679),
    [anon_sym_GT_GT_EQ] = ACTIONS(5679),
    [anon_sym_AMP_EQ] = ACTIONS(5679),
    [anon_sym_CARET_EQ] = ACTIONS(5679),
    [anon_sym_PIPE_EQ] = ACTIONS(5679),
    [anon_sym_and_eq] = ACTIONS(5677),
    [anon_sym_or_eq] = ACTIONS(5677),
    [anon_sym_xor_eq] = ACTIONS(5677),
    [anon_sym_LT_EQ_GT] = ACTIONS(5679),
    [anon_sym_or] = ACTIONS(5677),
    [anon_sym_and] = ACTIONS(5677),
    [anon_sym_bitor] = ACTIONS(5677),
    [anon_sym_xor] = ACTIONS(5677),
    [anon_sym_bitand] = ACTIONS(5677),
    [anon_sym_not_eq] = ACTIONS(5677),
    [anon_sym_DASH_DASH] = ACTIONS(5679),
    [anon_sym_PLUS_PLUS] = ACTIONS(5679),
    [anon_sym_DOT] = ACTIONS(5677),
    [anon_sym_DOT_STAR] = ACTIONS(5679),
    [anon_sym_DASH_GT] = ACTIONS(5679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5677),
    [anon_sym_decltype] = ACTIONS(5677),
  },
  [2263] = {
    [sym_identifier] = ACTIONS(5685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5687),
    [anon_sym_COMMA] = ACTIONS(5687),
    [anon_sym_RPAREN] = ACTIONS(5687),
    [aux_sym_preproc_if_token2] = ACTIONS(5687),
    [aux_sym_preproc_else_token1] = ACTIONS(5687),
    [aux_sym_preproc_elif_token1] = ACTIONS(5685),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5687),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5687),
    [anon_sym_LPAREN2] = ACTIONS(5687),
    [anon_sym_DASH] = ACTIONS(5685),
    [anon_sym_PLUS] = ACTIONS(5685),
    [anon_sym_STAR] = ACTIONS(5685),
    [anon_sym_SLASH] = ACTIONS(5685),
    [anon_sym_PERCENT] = ACTIONS(5685),
    [anon_sym_PIPE_PIPE] = ACTIONS(5687),
    [anon_sym_AMP_AMP] = ACTIONS(5687),
    [anon_sym_PIPE] = ACTIONS(5685),
    [anon_sym_CARET] = ACTIONS(5685),
    [anon_sym_AMP] = ACTIONS(5685),
    [anon_sym_EQ_EQ] = ACTIONS(5687),
    [anon_sym_BANG_EQ] = ACTIONS(5687),
    [anon_sym_GT] = ACTIONS(5685),
    [anon_sym_GT_EQ] = ACTIONS(5687),
    [anon_sym_LT_EQ] = ACTIONS(5685),
    [anon_sym_LT] = ACTIONS(5685),
    [anon_sym_LT_LT] = ACTIONS(5685),
    [anon_sym_GT_GT] = ACTIONS(5685),
    [anon_sym_SEMI] = ACTIONS(5687),
    [anon_sym___attribute__] = ACTIONS(5685),
    [anon_sym___attribute] = ACTIONS(5685),
    [anon_sym_COLON] = ACTIONS(5687),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [anon_sym_RBRACE] = ACTIONS(5687),
    [anon_sym_LBRACK] = ACTIONS(5687),
    [anon_sym_RBRACK] = ACTIONS(5687),
    [anon_sym_EQ] = ACTIONS(5685),
    [anon_sym_QMARK] = ACTIONS(5687),
    [anon_sym_STAR_EQ] = ACTIONS(5687),
    [anon_sym_SLASH_EQ] = ACTIONS(5687),
    [anon_sym_PERCENT_EQ] = ACTIONS(5687),
    [anon_sym_PLUS_EQ] = ACTIONS(5687),
    [anon_sym_DASH_EQ] = ACTIONS(5687),
    [anon_sym_LT_LT_EQ] = ACTIONS(5687),
    [anon_sym_GT_GT_EQ] = ACTIONS(5687),
    [anon_sym_AMP_EQ] = ACTIONS(5687),
    [anon_sym_CARET_EQ] = ACTIONS(5687),
    [anon_sym_PIPE_EQ] = ACTIONS(5687),
    [anon_sym_and_eq] = ACTIONS(5685),
    [anon_sym_or_eq] = ACTIONS(5685),
    [anon_sym_xor_eq] = ACTIONS(5685),
    [anon_sym_LT_EQ_GT] = ACTIONS(5687),
    [anon_sym_or] = ACTIONS(5685),
    [anon_sym_and] = ACTIONS(5685),
    [anon_sym_bitor] = ACTIONS(5685),
    [anon_sym_xor] = ACTIONS(5685),
    [anon_sym_bitand] = ACTIONS(5685),
    [anon_sym_not_eq] = ACTIONS(5685),
    [anon_sym_DASH_DASH] = ACTIONS(5687),
    [anon_sym_PLUS_PLUS] = ACTIONS(5687),
    [anon_sym_DOT] = ACTIONS(5685),
    [anon_sym_DOT_STAR] = ACTIONS(5687),
    [anon_sym_DASH_GT] = ACTIONS(5687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5685),
    [anon_sym_decltype] = ACTIONS(5685),
  },
  [2264] = {
    [sym_identifier] = ACTIONS(5692),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5694),
    [anon_sym_COMMA] = ACTIONS(5694),
    [anon_sym_RPAREN] = ACTIONS(5694),
    [aux_sym_preproc_if_token2] = ACTIONS(5694),
    [aux_sym_preproc_else_token1] = ACTIONS(5694),
    [aux_sym_preproc_elif_token1] = ACTIONS(5692),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5694),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5694),
    [anon_sym_LPAREN2] = ACTIONS(5694),
    [anon_sym_DASH] = ACTIONS(5692),
    [anon_sym_PLUS] = ACTIONS(5692),
    [anon_sym_STAR] = ACTIONS(5692),
    [anon_sym_SLASH] = ACTIONS(5692),
    [anon_sym_PERCENT] = ACTIONS(5692),
    [anon_sym_PIPE_PIPE] = ACTIONS(5694),
    [anon_sym_AMP_AMP] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5692),
    [anon_sym_AMP] = ACTIONS(5692),
    [anon_sym_EQ_EQ] = ACTIONS(5694),
    [anon_sym_BANG_EQ] = ACTIONS(5694),
    [anon_sym_GT] = ACTIONS(5692),
    [anon_sym_GT_EQ] = ACTIONS(5694),
    [anon_sym_LT_EQ] = ACTIONS(5692),
    [anon_sym_LT] = ACTIONS(5692),
    [anon_sym_LT_LT] = ACTIONS(5692),
    [anon_sym_GT_GT] = ACTIONS(5692),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym___attribute__] = ACTIONS(5692),
    [anon_sym___attribute] = ACTIONS(5692),
    [anon_sym_COLON] = ACTIONS(5694),
    [anon_sym_LBRACE] = ACTIONS(5694),
    [anon_sym_RBRACE] = ACTIONS(5694),
    [anon_sym_LBRACK] = ACTIONS(5694),
    [anon_sym_RBRACK] = ACTIONS(5694),
    [anon_sym_EQ] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(5694),
    [anon_sym_STAR_EQ] = ACTIONS(5694),
    [anon_sym_SLASH_EQ] = ACTIONS(5694),
    [anon_sym_PERCENT_EQ] = ACTIONS(5694),
    [anon_sym_PLUS_EQ] = ACTIONS(5694),
    [anon_sym_DASH_EQ] = ACTIONS(5694),
    [anon_sym_LT_LT_EQ] = ACTIONS(5694),
    [anon_sym_GT_GT_EQ] = ACTIONS(5694),
    [anon_sym_AMP_EQ] = ACTIONS(5694),
    [anon_sym_CARET_EQ] = ACTIONS(5694),
    [anon_sym_PIPE_EQ] = ACTIONS(5694),
    [anon_sym_and_eq] = ACTIONS(5692),
    [anon_sym_or_eq] = ACTIONS(5692),
    [anon_sym_xor_eq] = ACTIONS(5692),
    [anon_sym_LT_EQ_GT] = ACTIONS(5694),
    [anon_sym_or] = ACTIONS(5692),
    [anon_sym_and] = ACTIONS(5692),
    [anon_sym_bitor] = ACTIONS(5692),
    [anon_sym_xor] = ACTIONS(5692),
    [anon_sym_bitand] = ACTIONS(5692),
    [anon_sym_not_eq] = ACTIONS(5692),
    [anon_sym_DASH_DASH] = ACTIONS(5694),
    [anon_sym_PLUS_PLUS] = ACTIONS(5694),
    [anon_sym_DOT] = ACTIONS(5692),
    [anon_sym_DOT_STAR] = ACTIONS(5694),
    [anon_sym_DASH_GT] = ACTIONS(5694),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5692),
    [anon_sym_decltype] = ACTIONS(5692),
  },
  [2265] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(5944),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [aux_sym_preproc_if_token2] = ACTIONS(5942),
    [aux_sym_preproc_else_token1] = ACTIONS(5942),
    [aux_sym_preproc_elif_token1] = ACTIONS(5944),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5942),
    [anon_sym_LPAREN2] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5944),
    [anon_sym_PLUS] = ACTIONS(5944),
    [anon_sym_STAR] = ACTIONS(5944),
    [anon_sym_SLASH] = ACTIONS(5944),
    [anon_sym_PERCENT] = ACTIONS(5944),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_AMP_AMP] = ACTIONS(5942),
    [anon_sym_PIPE] = ACTIONS(5944),
    [anon_sym_CARET] = ACTIONS(5944),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_EQ_EQ] = ACTIONS(5942),
    [anon_sym_BANG_EQ] = ACTIONS(5942),
    [anon_sym_GT] = ACTIONS(5944),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_LT_EQ] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5944),
    [anon_sym_GT_GT] = ACTIONS(5944),
    [anon_sym___attribute__] = ACTIONS(5944),
    [anon_sym___attribute] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(5942),
    [anon_sym_signed] = ACTIONS(6176),
    [anon_sym_unsigned] = ACTIONS(6176),
    [anon_sym_long] = ACTIONS(6176),
    [anon_sym_short] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(5942),
    [anon_sym_EQ] = ACTIONS(5944),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_STAR_EQ] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_PERCENT_EQ] = ACTIONS(5942),
    [anon_sym_PLUS_EQ] = ACTIONS(5942),
    [anon_sym_DASH_EQ] = ACTIONS(5942),
    [anon_sym_LT_LT_EQ] = ACTIONS(5942),
    [anon_sym_GT_GT_EQ] = ACTIONS(5942),
    [anon_sym_AMP_EQ] = ACTIONS(5942),
    [anon_sym_CARET_EQ] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_and_eq] = ACTIONS(5944),
    [anon_sym_or_eq] = ACTIONS(5944),
    [anon_sym_xor_eq] = ACTIONS(5944),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_or] = ACTIONS(5944),
    [anon_sym_and] = ACTIONS(5944),
    [anon_sym_bitor] = ACTIONS(5944),
    [anon_sym_xor] = ACTIONS(5944),
    [anon_sym_bitand] = ACTIONS(5944),
    [anon_sym_not_eq] = ACTIONS(5944),
    [anon_sym_DASH_DASH] = ACTIONS(5942),
    [anon_sym_PLUS_PLUS] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5944),
    [anon_sym_DOT_STAR] = ACTIONS(5942),
    [anon_sym_DASH_GT] = ACTIONS(5942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5944),
    [anon_sym_decltype] = ACTIONS(5944),
  },
  [2266] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6070),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_RBRACK] = ACTIONS(6246),
    [anon_sym_EQ] = ACTIONS(6080),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(6082),
    [anon_sym_SLASH_EQ] = ACTIONS(6082),
    [anon_sym_PERCENT_EQ] = ACTIONS(6082),
    [anon_sym_PLUS_EQ] = ACTIONS(6082),
    [anon_sym_DASH_EQ] = ACTIONS(6082),
    [anon_sym_LT_LT_EQ] = ACTIONS(6082),
    [anon_sym_GT_GT_EQ] = ACTIONS(6082),
    [anon_sym_AMP_EQ] = ACTIONS(6082),
    [anon_sym_CARET_EQ] = ACTIONS(6082),
    [anon_sym_PIPE_EQ] = ACTIONS(6082),
    [anon_sym_and_eq] = ACTIONS(6082),
    [anon_sym_or_eq] = ACTIONS(6082),
    [anon_sym_xor_eq] = ACTIONS(6082),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2267] = {
    [sym_identifier] = ACTIONS(5677),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5679),
    [anon_sym_COMMA] = ACTIONS(5679),
    [anon_sym_RPAREN] = ACTIONS(5679),
    [aux_sym_preproc_if_token2] = ACTIONS(5679),
    [aux_sym_preproc_else_token1] = ACTIONS(5679),
    [aux_sym_preproc_elif_token1] = ACTIONS(5677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5679),
    [anon_sym_LPAREN2] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5677),
    [anon_sym_PLUS] = ACTIONS(5677),
    [anon_sym_STAR] = ACTIONS(5677),
    [anon_sym_SLASH] = ACTIONS(5677),
    [anon_sym_PERCENT] = ACTIONS(5677),
    [anon_sym_PIPE_PIPE] = ACTIONS(5679),
    [anon_sym_AMP_AMP] = ACTIONS(5679),
    [anon_sym_PIPE] = ACTIONS(5677),
    [anon_sym_CARET] = ACTIONS(5677),
    [anon_sym_AMP] = ACTIONS(5677),
    [anon_sym_EQ_EQ] = ACTIONS(5679),
    [anon_sym_BANG_EQ] = ACTIONS(5679),
    [anon_sym_GT] = ACTIONS(5677),
    [anon_sym_GT_EQ] = ACTIONS(5679),
    [anon_sym_LT_EQ] = ACTIONS(5677),
    [anon_sym_LT] = ACTIONS(5677),
    [anon_sym_LT_LT] = ACTIONS(5677),
    [anon_sym_GT_GT] = ACTIONS(5677),
    [anon_sym_SEMI] = ACTIONS(5679),
    [anon_sym___attribute__] = ACTIONS(5677),
    [anon_sym___attribute] = ACTIONS(5677),
    [anon_sym_COLON] = ACTIONS(5679),
    [anon_sym_LBRACE] = ACTIONS(5679),
    [anon_sym_RBRACE] = ACTIONS(5679),
    [anon_sym_LBRACK] = ACTIONS(5679),
    [anon_sym_RBRACK] = ACTIONS(5679),
    [anon_sym_EQ] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_STAR_EQ] = ACTIONS(5679),
    [anon_sym_SLASH_EQ] = ACTIONS(5679),
    [anon_sym_PERCENT_EQ] = ACTIONS(5679),
    [anon_sym_PLUS_EQ] = ACTIONS(5679),
    [anon_sym_DASH_EQ] = ACTIONS(5679),
    [anon_sym_LT_LT_EQ] = ACTIONS(5679),
    [anon_sym_GT_GT_EQ] = ACTIONS(5679),
    [anon_sym_AMP_EQ] = ACTIONS(5679),
    [anon_sym_CARET_EQ] = ACTIONS(5679),
    [anon_sym_PIPE_EQ] = ACTIONS(5679),
    [anon_sym_and_eq] = ACTIONS(5677),
    [anon_sym_or_eq] = ACTIONS(5677),
    [anon_sym_xor_eq] = ACTIONS(5677),
    [anon_sym_LT_EQ_GT] = ACTIONS(5679),
    [anon_sym_or] = ACTIONS(5677),
    [anon_sym_and] = ACTIONS(5677),
    [anon_sym_bitor] = ACTIONS(5677),
    [anon_sym_xor] = ACTIONS(5677),
    [anon_sym_bitand] = ACTIONS(5677),
    [anon_sym_not_eq] = ACTIONS(5677),
    [anon_sym_DASH_DASH] = ACTIONS(5679),
    [anon_sym_PLUS_PLUS] = ACTIONS(5679),
    [anon_sym_DOT] = ACTIONS(5677),
    [anon_sym_DOT_STAR] = ACTIONS(5679),
    [anon_sym_DASH_GT] = ACTIONS(5679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5677),
    [anon_sym_decltype] = ACTIONS(5677),
  },
  [2268] = {
    [sym_identifier] = ACTIONS(5677),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5679),
    [anon_sym_COMMA] = ACTIONS(5679),
    [anon_sym_RPAREN] = ACTIONS(5679),
    [aux_sym_preproc_if_token2] = ACTIONS(5679),
    [aux_sym_preproc_else_token1] = ACTIONS(5679),
    [aux_sym_preproc_elif_token1] = ACTIONS(5677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5679),
    [anon_sym_LPAREN2] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5677),
    [anon_sym_PLUS] = ACTIONS(5677),
    [anon_sym_STAR] = ACTIONS(5677),
    [anon_sym_SLASH] = ACTIONS(5677),
    [anon_sym_PERCENT] = ACTIONS(5677),
    [anon_sym_PIPE_PIPE] = ACTIONS(5679),
    [anon_sym_AMP_AMP] = ACTIONS(5679),
    [anon_sym_PIPE] = ACTIONS(5677),
    [anon_sym_CARET] = ACTIONS(5677),
    [anon_sym_AMP] = ACTIONS(5677),
    [anon_sym_EQ_EQ] = ACTIONS(5679),
    [anon_sym_BANG_EQ] = ACTIONS(5679),
    [anon_sym_GT] = ACTIONS(5677),
    [anon_sym_GT_EQ] = ACTIONS(5679),
    [anon_sym_LT_EQ] = ACTIONS(5677),
    [anon_sym_LT] = ACTIONS(5677),
    [anon_sym_LT_LT] = ACTIONS(5677),
    [anon_sym_GT_GT] = ACTIONS(5677),
    [anon_sym_SEMI] = ACTIONS(5679),
    [anon_sym___attribute__] = ACTIONS(5677),
    [anon_sym___attribute] = ACTIONS(5677),
    [anon_sym_COLON] = ACTIONS(5679),
    [anon_sym_LBRACE] = ACTIONS(5679),
    [anon_sym_RBRACE] = ACTIONS(5679),
    [anon_sym_LBRACK] = ACTIONS(5679),
    [anon_sym_RBRACK] = ACTIONS(5679),
    [anon_sym_EQ] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_STAR_EQ] = ACTIONS(5679),
    [anon_sym_SLASH_EQ] = ACTIONS(5679),
    [anon_sym_PERCENT_EQ] = ACTIONS(5679),
    [anon_sym_PLUS_EQ] = ACTIONS(5679),
    [anon_sym_DASH_EQ] = ACTIONS(5679),
    [anon_sym_LT_LT_EQ] = ACTIONS(5679),
    [anon_sym_GT_GT_EQ] = ACTIONS(5679),
    [anon_sym_AMP_EQ] = ACTIONS(5679),
    [anon_sym_CARET_EQ] = ACTIONS(5679),
    [anon_sym_PIPE_EQ] = ACTIONS(5679),
    [anon_sym_and_eq] = ACTIONS(5677),
    [anon_sym_or_eq] = ACTIONS(5677),
    [anon_sym_xor_eq] = ACTIONS(5677),
    [anon_sym_LT_EQ_GT] = ACTIONS(5679),
    [anon_sym_or] = ACTIONS(5677),
    [anon_sym_and] = ACTIONS(5677),
    [anon_sym_bitor] = ACTIONS(5677),
    [anon_sym_xor] = ACTIONS(5677),
    [anon_sym_bitand] = ACTIONS(5677),
    [anon_sym_not_eq] = ACTIONS(5677),
    [anon_sym_DASH_DASH] = ACTIONS(5679),
    [anon_sym_PLUS_PLUS] = ACTIONS(5679),
    [anon_sym_DOT] = ACTIONS(5677),
    [anon_sym_DOT_STAR] = ACTIONS(5679),
    [anon_sym_DASH_GT] = ACTIONS(5679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5677),
    [anon_sym_decltype] = ACTIONS(5677),
  },
  [2269] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5894),
    [anon_sym_COMMA] = ACTIONS(5894),
    [aux_sym_preproc_if_token2] = ACTIONS(5894),
    [aux_sym_preproc_else_token1] = ACTIONS(5894),
    [aux_sym_preproc_elif_token1] = ACTIONS(5896),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5894),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5894),
    [anon_sym_LPAREN2] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5896),
    [anon_sym_STAR] = ACTIONS(5896),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [anon_sym_PIPE_PIPE] = ACTIONS(5894),
    [anon_sym_AMP_AMP] = ACTIONS(5894),
    [anon_sym_PIPE] = ACTIONS(5896),
    [anon_sym_CARET] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5896),
    [anon_sym_LT_LT] = ACTIONS(5896),
    [anon_sym_GT_GT] = ACTIONS(5896),
    [anon_sym___attribute__] = ACTIONS(5896),
    [anon_sym___attribute] = ACTIONS(5896),
    [anon_sym_LBRACE] = ACTIONS(5894),
    [anon_sym_signed] = ACTIONS(6176),
    [anon_sym_unsigned] = ACTIONS(6176),
    [anon_sym_long] = ACTIONS(6176),
    [anon_sym_short] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5896),
    [anon_sym_QMARK] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(5894),
    [anon_sym_SLASH_EQ] = ACTIONS(5894),
    [anon_sym_PERCENT_EQ] = ACTIONS(5894),
    [anon_sym_PLUS_EQ] = ACTIONS(5894),
    [anon_sym_DASH_EQ] = ACTIONS(5894),
    [anon_sym_LT_LT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT_EQ] = ACTIONS(5894),
    [anon_sym_AMP_EQ] = ACTIONS(5894),
    [anon_sym_CARET_EQ] = ACTIONS(5894),
    [anon_sym_PIPE_EQ] = ACTIONS(5894),
    [anon_sym_and_eq] = ACTIONS(5896),
    [anon_sym_or_eq] = ACTIONS(5896),
    [anon_sym_xor_eq] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5894),
    [anon_sym_or] = ACTIONS(5896),
    [anon_sym_and] = ACTIONS(5896),
    [anon_sym_bitor] = ACTIONS(5896),
    [anon_sym_xor] = ACTIONS(5896),
    [anon_sym_bitand] = ACTIONS(5896),
    [anon_sym_not_eq] = ACTIONS(5896),
    [anon_sym_DASH_DASH] = ACTIONS(5894),
    [anon_sym_PLUS_PLUS] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5896),
    [anon_sym_DOT_STAR] = ACTIONS(5894),
    [anon_sym_DASH_GT] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5896),
    [anon_sym_decltype] = ACTIONS(5896),
  },
  [2270] = {
    [sym_attribute_declaration] = STATE(2247),
    [aux_sym_attributed_declarator_repeat1] = STATE(2247),
    [sym_identifier] = ACTIONS(6249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6251),
    [anon_sym_COMMA] = ACTIONS(6251),
    [anon_sym_RPAREN] = ACTIONS(6251),
    [aux_sym_preproc_if_token2] = ACTIONS(6251),
    [aux_sym_preproc_else_token1] = ACTIONS(6251),
    [aux_sym_preproc_elif_token1] = ACTIONS(6249),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6251),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6251),
    [anon_sym_LPAREN2] = ACTIONS(6251),
    [anon_sym_DASH] = ACTIONS(6249),
    [anon_sym_PLUS] = ACTIONS(6249),
    [anon_sym_STAR] = ACTIONS(6249),
    [anon_sym_SLASH] = ACTIONS(6249),
    [anon_sym_PERCENT] = ACTIONS(6249),
    [anon_sym_PIPE_PIPE] = ACTIONS(6251),
    [anon_sym_AMP_AMP] = ACTIONS(6251),
    [anon_sym_PIPE] = ACTIONS(6249),
    [anon_sym_CARET] = ACTIONS(6249),
    [anon_sym_AMP] = ACTIONS(6249),
    [anon_sym_EQ_EQ] = ACTIONS(6251),
    [anon_sym_BANG_EQ] = ACTIONS(6251),
    [anon_sym_GT] = ACTIONS(6249),
    [anon_sym_GT_EQ] = ACTIONS(6251),
    [anon_sym_LT_EQ] = ACTIONS(6249),
    [anon_sym_LT] = ACTIONS(6249),
    [anon_sym_LT_LT] = ACTIONS(6249),
    [anon_sym_GT_GT] = ACTIONS(6249),
    [anon_sym_SEMI] = ACTIONS(6251),
    [anon_sym___attribute__] = ACTIONS(6249),
    [anon_sym___attribute] = ACTIONS(6249),
    [anon_sym_COLON] = ACTIONS(6251),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6044),
    [anon_sym_RBRACE] = ACTIONS(6251),
    [anon_sym_LBRACK] = ACTIONS(6249),
    [anon_sym_RBRACK] = ACTIONS(6251),
    [anon_sym_EQ] = ACTIONS(6249),
    [anon_sym_QMARK] = ACTIONS(6251),
    [anon_sym_STAR_EQ] = ACTIONS(6251),
    [anon_sym_SLASH_EQ] = ACTIONS(6251),
    [anon_sym_PERCENT_EQ] = ACTIONS(6251),
    [anon_sym_PLUS_EQ] = ACTIONS(6251),
    [anon_sym_DASH_EQ] = ACTIONS(6251),
    [anon_sym_LT_LT_EQ] = ACTIONS(6251),
    [anon_sym_GT_GT_EQ] = ACTIONS(6251),
    [anon_sym_AMP_EQ] = ACTIONS(6251),
    [anon_sym_CARET_EQ] = ACTIONS(6251),
    [anon_sym_PIPE_EQ] = ACTIONS(6251),
    [anon_sym_and_eq] = ACTIONS(6249),
    [anon_sym_or_eq] = ACTIONS(6249),
    [anon_sym_xor_eq] = ACTIONS(6249),
    [anon_sym_LT_EQ_GT] = ACTIONS(6251),
    [anon_sym_or] = ACTIONS(6249),
    [anon_sym_and] = ACTIONS(6249),
    [anon_sym_bitor] = ACTIONS(6249),
    [anon_sym_xor] = ACTIONS(6249),
    [anon_sym_bitand] = ACTIONS(6249),
    [anon_sym_not_eq] = ACTIONS(6249),
    [anon_sym_DASH_DASH] = ACTIONS(6251),
    [anon_sym_PLUS_PLUS] = ACTIONS(6251),
    [anon_sym_DOT] = ACTIONS(6249),
    [anon_sym_DOT_STAR] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6251),
    [sym_comment] = ACTIONS(3),
  },
  [2271] = {
    [sym_identifier] = ACTIONS(6253),
    [anon_sym_LPAREN2] = ACTIONS(6255),
    [anon_sym_TILDE] = ACTIONS(6255),
    [anon_sym_STAR] = ACTIONS(6255),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6182),
    [anon_sym_AMP] = ACTIONS(6253),
    [anon_sym___extension__] = ACTIONS(6253),
    [anon_sym_virtual] = ACTIONS(6253),
    [anon_sym_extern] = ACTIONS(6253),
    [anon_sym___attribute__] = ACTIONS(6253),
    [anon_sym___attribute] = ACTIONS(6253),
    [anon_sym_using] = ACTIONS(6253),
    [anon_sym_COLON_COLON] = ACTIONS(6255),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6255),
    [anon_sym___declspec] = ACTIONS(6253),
    [anon_sym___based] = ACTIONS(6253),
    [anon_sym___cdecl] = ACTIONS(6253),
    [anon_sym___clrcall] = ACTIONS(6253),
    [anon_sym___stdcall] = ACTIONS(6253),
    [anon_sym___fastcall] = ACTIONS(6253),
    [anon_sym___thiscall] = ACTIONS(6253),
    [anon_sym___vectorcall] = ACTIONS(6253),
    [anon_sym_signed] = ACTIONS(6253),
    [anon_sym_unsigned] = ACTIONS(6253),
    [anon_sym_long] = ACTIONS(6253),
    [anon_sym_short] = ACTIONS(6253),
    [anon_sym_LBRACK] = ACTIONS(6253),
    [anon_sym_static] = ACTIONS(6253),
    [anon_sym_register] = ACTIONS(6253),
    [anon_sym_inline] = ACTIONS(6253),
    [anon_sym___inline] = ACTIONS(6253),
    [anon_sym___inline__] = ACTIONS(6253),
    [anon_sym___forceinline] = ACTIONS(6253),
    [anon_sym_thread_local] = ACTIONS(6253),
    [anon_sym___thread] = ACTIONS(6253),
    [anon_sym_const] = ACTIONS(6253),
    [anon_sym_constexpr] = ACTIONS(6253),
    [anon_sym_volatile] = ACTIONS(6253),
    [anon_sym_restrict] = ACTIONS(6253),
    [anon_sym___restrict__] = ACTIONS(6253),
    [anon_sym__Atomic] = ACTIONS(6253),
    [anon_sym__Noreturn] = ACTIONS(6253),
    [anon_sym_noreturn] = ACTIONS(6253),
    [anon_sym__Nonnull] = ACTIONS(6253),
    [anon_sym_mutable] = ACTIONS(6253),
    [anon_sym_constinit] = ACTIONS(6253),
    [anon_sym_consteval] = ACTIONS(6253),
    [anon_sym_alignas] = ACTIONS(6253),
    [anon_sym__Alignas] = ACTIONS(6253),
    [sym_primitive_type] = ACTIONS(6253),
    [anon_sym_enum] = ACTIONS(6253),
    [anon_sym_class] = ACTIONS(6253),
    [anon_sym_struct] = ACTIONS(6253),
    [anon_sym_union] = ACTIONS(6253),
    [anon_sym_or] = ACTIONS(6259),
    [anon_sym_and] = ACTIONS(6184),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6253),
    [anon_sym_decltype] = ACTIONS(6253),
    [anon_sym_explicit] = ACTIONS(6253),
    [anon_sym_typename] = ACTIONS(6253),
    [anon_sym_template] = ACTIONS(6253),
    [anon_sym_operator] = ACTIONS(6253),
    [anon_sym_friend] = ACTIONS(6253),
    [anon_sym_concept] = ACTIONS(6253),
  },
  [2272] = {
    [sym_identifier] = ACTIONS(5641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5643),
    [anon_sym_COMMA] = ACTIONS(5643),
    [anon_sym_RPAREN] = ACTIONS(5643),
    [aux_sym_preproc_if_token2] = ACTIONS(5643),
    [aux_sym_preproc_else_token1] = ACTIONS(5643),
    [aux_sym_preproc_elif_token1] = ACTIONS(5641),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5643),
    [anon_sym_LPAREN2] = ACTIONS(5643),
    [anon_sym_DASH] = ACTIONS(5641),
    [anon_sym_PLUS] = ACTIONS(5641),
    [anon_sym_STAR] = ACTIONS(5641),
    [anon_sym_SLASH] = ACTIONS(5641),
    [anon_sym_PERCENT] = ACTIONS(5641),
    [anon_sym_PIPE_PIPE] = ACTIONS(5643),
    [anon_sym_AMP_AMP] = ACTIONS(5643),
    [anon_sym_PIPE] = ACTIONS(5641),
    [anon_sym_CARET] = ACTIONS(5641),
    [anon_sym_AMP] = ACTIONS(5641),
    [anon_sym_EQ_EQ] = ACTIONS(5643),
    [anon_sym_BANG_EQ] = ACTIONS(5643),
    [anon_sym_GT] = ACTIONS(5641),
    [anon_sym_GT_EQ] = ACTIONS(5643),
    [anon_sym_LT_EQ] = ACTIONS(5641),
    [anon_sym_LT] = ACTIONS(5641),
    [anon_sym_LT_LT] = ACTIONS(5641),
    [anon_sym_GT_GT] = ACTIONS(5641),
    [anon_sym_SEMI] = ACTIONS(5643),
    [anon_sym___attribute__] = ACTIONS(5641),
    [anon_sym___attribute] = ACTIONS(5641),
    [anon_sym_COLON] = ACTIONS(5643),
    [anon_sym_LBRACE] = ACTIONS(5643),
    [anon_sym_RBRACE] = ACTIONS(5643),
    [anon_sym_LBRACK] = ACTIONS(5643),
    [anon_sym_RBRACK] = ACTIONS(5643),
    [anon_sym_EQ] = ACTIONS(5641),
    [anon_sym_QMARK] = ACTIONS(5643),
    [anon_sym_STAR_EQ] = ACTIONS(5643),
    [anon_sym_SLASH_EQ] = ACTIONS(5643),
    [anon_sym_PERCENT_EQ] = ACTIONS(5643),
    [anon_sym_PLUS_EQ] = ACTIONS(5643),
    [anon_sym_DASH_EQ] = ACTIONS(5643),
    [anon_sym_LT_LT_EQ] = ACTIONS(5643),
    [anon_sym_GT_GT_EQ] = ACTIONS(5643),
    [anon_sym_AMP_EQ] = ACTIONS(5643),
    [anon_sym_CARET_EQ] = ACTIONS(5643),
    [anon_sym_PIPE_EQ] = ACTIONS(5643),
    [anon_sym_and_eq] = ACTIONS(5641),
    [anon_sym_or_eq] = ACTIONS(5641),
    [anon_sym_xor_eq] = ACTIONS(5641),
    [anon_sym_LT_EQ_GT] = ACTIONS(5643),
    [anon_sym_or] = ACTIONS(5641),
    [anon_sym_and] = ACTIONS(5641),
    [anon_sym_bitor] = ACTIONS(5641),
    [anon_sym_xor] = ACTIONS(5641),
    [anon_sym_bitand] = ACTIONS(5641),
    [anon_sym_not_eq] = ACTIONS(5641),
    [anon_sym_DASH_DASH] = ACTIONS(5643),
    [anon_sym_PLUS_PLUS] = ACTIONS(5643),
    [anon_sym_DOT] = ACTIONS(5641),
    [anon_sym_DOT_STAR] = ACTIONS(5643),
    [anon_sym_DASH_GT] = ACTIONS(5643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5641),
    [anon_sym_decltype] = ACTIONS(5641),
  },
  [2273] = {
    [sym_identifier] = ACTIONS(5450),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [aux_sym_preproc_if_token2] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5450),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5452),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5450),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5450),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5450),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym___attribute__] = ACTIONS(5450),
    [anon_sym___attribute] = ACTIONS(5450),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_STAR_EQ] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5452),
    [anon_sym_PLUS_EQ] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5452),
    [anon_sym_CARET_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_EQ] = ACTIONS(5452),
    [anon_sym_and_eq] = ACTIONS(5450),
    [anon_sym_or_eq] = ACTIONS(5450),
    [anon_sym_xor_eq] = ACTIONS(5450),
    [anon_sym_LT_EQ_GT] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_and] = ACTIONS(5450),
    [anon_sym_bitor] = ACTIONS(5450),
    [anon_sym_xor] = ACTIONS(5450),
    [anon_sym_bitand] = ACTIONS(5450),
    [anon_sym_not_eq] = ACTIONS(5450),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5450),
    [anon_sym_decltype] = ACTIONS(5450),
  },
  [2274] = {
    [sym_identifier] = ACTIONS(5647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5649),
    [anon_sym_COMMA] = ACTIONS(5649),
    [anon_sym_RPAREN] = ACTIONS(5649),
    [aux_sym_preproc_if_token2] = ACTIONS(5649),
    [aux_sym_preproc_else_token1] = ACTIONS(5649),
    [aux_sym_preproc_elif_token1] = ACTIONS(5647),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5649),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5649),
    [anon_sym_LPAREN2] = ACTIONS(5649),
    [anon_sym_DASH] = ACTIONS(5647),
    [anon_sym_PLUS] = ACTIONS(5647),
    [anon_sym_STAR] = ACTIONS(5647),
    [anon_sym_SLASH] = ACTIONS(5647),
    [anon_sym_PERCENT] = ACTIONS(5647),
    [anon_sym_PIPE_PIPE] = ACTIONS(5649),
    [anon_sym_AMP_AMP] = ACTIONS(5649),
    [anon_sym_PIPE] = ACTIONS(5647),
    [anon_sym_CARET] = ACTIONS(5647),
    [anon_sym_AMP] = ACTIONS(5647),
    [anon_sym_EQ_EQ] = ACTIONS(5649),
    [anon_sym_BANG_EQ] = ACTIONS(5649),
    [anon_sym_GT] = ACTIONS(5647),
    [anon_sym_GT_EQ] = ACTIONS(5649),
    [anon_sym_LT_EQ] = ACTIONS(5647),
    [anon_sym_LT] = ACTIONS(5647),
    [anon_sym_LT_LT] = ACTIONS(5647),
    [anon_sym_GT_GT] = ACTIONS(5647),
    [anon_sym_SEMI] = ACTIONS(5649),
    [anon_sym___attribute__] = ACTIONS(5647),
    [anon_sym___attribute] = ACTIONS(5647),
    [anon_sym_COLON] = ACTIONS(5649),
    [anon_sym_LBRACE] = ACTIONS(5649),
    [anon_sym_RBRACE] = ACTIONS(5649),
    [anon_sym_LBRACK] = ACTIONS(5649),
    [anon_sym_RBRACK] = ACTIONS(5649),
    [anon_sym_EQ] = ACTIONS(5647),
    [anon_sym_QMARK] = ACTIONS(5649),
    [anon_sym_STAR_EQ] = ACTIONS(5649),
    [anon_sym_SLASH_EQ] = ACTIONS(5649),
    [anon_sym_PERCENT_EQ] = ACTIONS(5649),
    [anon_sym_PLUS_EQ] = ACTIONS(5649),
    [anon_sym_DASH_EQ] = ACTIONS(5649),
    [anon_sym_LT_LT_EQ] = ACTIONS(5649),
    [anon_sym_GT_GT_EQ] = ACTIONS(5649),
    [anon_sym_AMP_EQ] = ACTIONS(5649),
    [anon_sym_CARET_EQ] = ACTIONS(5649),
    [anon_sym_PIPE_EQ] = ACTIONS(5649),
    [anon_sym_and_eq] = ACTIONS(5647),
    [anon_sym_or_eq] = ACTIONS(5647),
    [anon_sym_xor_eq] = ACTIONS(5647),
    [anon_sym_LT_EQ_GT] = ACTIONS(5649),
    [anon_sym_or] = ACTIONS(5647),
    [anon_sym_and] = ACTIONS(5647),
    [anon_sym_bitor] = ACTIONS(5647),
    [anon_sym_xor] = ACTIONS(5647),
    [anon_sym_bitand] = ACTIONS(5647),
    [anon_sym_not_eq] = ACTIONS(5647),
    [anon_sym_DASH_DASH] = ACTIONS(5649),
    [anon_sym_PLUS_PLUS] = ACTIONS(5649),
    [anon_sym_DOT] = ACTIONS(5647),
    [anon_sym_DOT_STAR] = ACTIONS(5649),
    [anon_sym_DASH_GT] = ACTIONS(5649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5647),
    [anon_sym_decltype] = ACTIONS(5647),
  },
  [2275] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2211),
    [sym_identifier] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5902),
    [anon_sym_COMMA] = ACTIONS(5902),
    [aux_sym_preproc_if_token2] = ACTIONS(5902),
    [aux_sym_preproc_else_token1] = ACTIONS(5902),
    [aux_sym_preproc_elif_token1] = ACTIONS(5904),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5902),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5902),
    [anon_sym_LPAREN2] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5904),
    [anon_sym_STAR] = ACTIONS(5904),
    [anon_sym_SLASH] = ACTIONS(5904),
    [anon_sym_PERCENT] = ACTIONS(5904),
    [anon_sym_PIPE_PIPE] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5902),
    [anon_sym_PIPE] = ACTIONS(5904),
    [anon_sym_CARET] = ACTIONS(5904),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_EQ_EQ] = ACTIONS(5902),
    [anon_sym_BANG_EQ] = ACTIONS(5902),
    [anon_sym_GT] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5904),
    [anon_sym_LT_LT] = ACTIONS(5904),
    [anon_sym_GT_GT] = ACTIONS(5904),
    [anon_sym___attribute__] = ACTIONS(5904),
    [anon_sym___attribute] = ACTIONS(5904),
    [anon_sym_LBRACE] = ACTIONS(5902),
    [anon_sym_signed] = ACTIONS(6261),
    [anon_sym_unsigned] = ACTIONS(6261),
    [anon_sym_long] = ACTIONS(6261),
    [anon_sym_short] = ACTIONS(6261),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_STAR_EQ] = ACTIONS(5902),
    [anon_sym_SLASH_EQ] = ACTIONS(5902),
    [anon_sym_PERCENT_EQ] = ACTIONS(5902),
    [anon_sym_PLUS_EQ] = ACTIONS(5902),
    [anon_sym_DASH_EQ] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_AMP_EQ] = ACTIONS(5902),
    [anon_sym_CARET_EQ] = ACTIONS(5902),
    [anon_sym_PIPE_EQ] = ACTIONS(5902),
    [anon_sym_and_eq] = ACTIONS(5904),
    [anon_sym_or_eq] = ACTIONS(5904),
    [anon_sym_xor_eq] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5902),
    [anon_sym_or] = ACTIONS(5904),
    [anon_sym_and] = ACTIONS(5904),
    [anon_sym_bitor] = ACTIONS(5904),
    [anon_sym_xor] = ACTIONS(5904),
    [anon_sym_bitand] = ACTIONS(5904),
    [anon_sym_not_eq] = ACTIONS(5904),
    [anon_sym_DASH_DASH] = ACTIONS(5902),
    [anon_sym_PLUS_PLUS] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5904),
    [anon_sym_DOT_STAR] = ACTIONS(5902),
    [anon_sym_DASH_GT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5904),
    [anon_sym_decltype] = ACTIONS(5904),
  },
  [2276] = {
    [sym_argument_list] = STATE(2455),
    [sym_initializer_list] = STATE(2455),
    [sym_identifier] = ACTIONS(6263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6265),
    [anon_sym_COMMA] = ACTIONS(6265),
    [anon_sym_RPAREN] = ACTIONS(6265),
    [aux_sym_preproc_if_token2] = ACTIONS(6265),
    [aux_sym_preproc_else_token1] = ACTIONS(6265),
    [aux_sym_preproc_elif_token1] = ACTIONS(6263),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6265),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6265),
    [anon_sym_LPAREN2] = ACTIONS(5827),
    [anon_sym_DASH] = ACTIONS(6263),
    [anon_sym_PLUS] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6263),
    [anon_sym_SLASH] = ACTIONS(6263),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_PIPE_PIPE] = ACTIONS(6265),
    [anon_sym_AMP_AMP] = ACTIONS(6265),
    [anon_sym_PIPE] = ACTIONS(6263),
    [anon_sym_CARET] = ACTIONS(6263),
    [anon_sym_AMP] = ACTIONS(6263),
    [anon_sym_EQ_EQ] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6265),
    [anon_sym_GT] = ACTIONS(6263),
    [anon_sym_GT_EQ] = ACTIONS(6265),
    [anon_sym_LT_EQ] = ACTIONS(6263),
    [anon_sym_LT] = ACTIONS(6263),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_GT_GT] = ACTIONS(6263),
    [anon_sym_SEMI] = ACTIONS(6265),
    [anon_sym___attribute__] = ACTIONS(6263),
    [anon_sym___attribute] = ACTIONS(6263),
    [anon_sym_COLON] = ACTIONS(6265),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(6265),
    [anon_sym_LBRACK] = ACTIONS(6265),
    [anon_sym_RBRACK] = ACTIONS(6265),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6265),
    [anon_sym_STAR_EQ] = ACTIONS(6265),
    [anon_sym_SLASH_EQ] = ACTIONS(6265),
    [anon_sym_PERCENT_EQ] = ACTIONS(6265),
    [anon_sym_PLUS_EQ] = ACTIONS(6265),
    [anon_sym_DASH_EQ] = ACTIONS(6265),
    [anon_sym_LT_LT_EQ] = ACTIONS(6265),
    [anon_sym_GT_GT_EQ] = ACTIONS(6265),
    [anon_sym_AMP_EQ] = ACTIONS(6265),
    [anon_sym_CARET_EQ] = ACTIONS(6265),
    [anon_sym_PIPE_EQ] = ACTIONS(6265),
    [anon_sym_and_eq] = ACTIONS(6263),
    [anon_sym_or_eq] = ACTIONS(6263),
    [anon_sym_xor_eq] = ACTIONS(6263),
    [anon_sym_LT_EQ_GT] = ACTIONS(6265),
    [anon_sym_or] = ACTIONS(6263),
    [anon_sym_and] = ACTIONS(6263),
    [anon_sym_bitor] = ACTIONS(6263),
    [anon_sym_xor] = ACTIONS(6263),
    [anon_sym_bitand] = ACTIONS(6263),
    [anon_sym_not_eq] = ACTIONS(6263),
    [anon_sym_DASH_DASH] = ACTIONS(6265),
    [anon_sym_PLUS_PLUS] = ACTIONS(6265),
    [anon_sym_DOT] = ACTIONS(6263),
    [anon_sym_DOT_STAR] = ACTIONS(6265),
    [anon_sym_DASH_GT] = ACTIONS(6265),
    [sym_comment] = ACTIONS(3),
  },
  [2277] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2214),
    [sym_identifier] = ACTIONS(5922),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [aux_sym_preproc_if_token2] = ACTIONS(5920),
    [aux_sym_preproc_else_token1] = ACTIONS(5920),
    [aux_sym_preproc_elif_token1] = ACTIONS(5922),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5920),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5920),
    [anon_sym_LPAREN2] = ACTIONS(5920),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_STAR] = ACTIONS(5922),
    [anon_sym_SLASH] = ACTIONS(5922),
    [anon_sym_PERCENT] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_AMP_AMP] = ACTIONS(5920),
    [anon_sym_PIPE] = ACTIONS(5922),
    [anon_sym_CARET] = ACTIONS(5922),
    [anon_sym_AMP] = ACTIONS(5922),
    [anon_sym_EQ_EQ] = ACTIONS(5920),
    [anon_sym_BANG_EQ] = ACTIONS(5920),
    [anon_sym_GT] = ACTIONS(5922),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_LT] = ACTIONS(5922),
    [anon_sym_LT_LT] = ACTIONS(5922),
    [anon_sym_GT_GT] = ACTIONS(5922),
    [anon_sym___attribute__] = ACTIONS(5922),
    [anon_sym___attribute] = ACTIONS(5922),
    [anon_sym_LBRACE] = ACTIONS(5920),
    [anon_sym_signed] = ACTIONS(6267),
    [anon_sym_unsigned] = ACTIONS(6267),
    [anon_sym_long] = ACTIONS(6267),
    [anon_sym_short] = ACTIONS(6267),
    [anon_sym_LBRACK] = ACTIONS(5920),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_QMARK] = ACTIONS(5920),
    [anon_sym_STAR_EQ] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_PERCENT_EQ] = ACTIONS(5920),
    [anon_sym_PLUS_EQ] = ACTIONS(5920),
    [anon_sym_DASH_EQ] = ACTIONS(5920),
    [anon_sym_LT_LT_EQ] = ACTIONS(5920),
    [anon_sym_GT_GT_EQ] = ACTIONS(5920),
    [anon_sym_AMP_EQ] = ACTIONS(5920),
    [anon_sym_CARET_EQ] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_and_eq] = ACTIONS(5922),
    [anon_sym_or_eq] = ACTIONS(5922),
    [anon_sym_xor_eq] = ACTIONS(5922),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_or] = ACTIONS(5922),
    [anon_sym_and] = ACTIONS(5922),
    [anon_sym_bitor] = ACTIONS(5922),
    [anon_sym_xor] = ACTIONS(5922),
    [anon_sym_bitand] = ACTIONS(5922),
    [anon_sym_not_eq] = ACTIONS(5922),
    [anon_sym_DASH_DASH] = ACTIONS(5920),
    [anon_sym_PLUS_PLUS] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_DOT_STAR] = ACTIONS(5920),
    [anon_sym_DASH_GT] = ACTIONS(5920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5922),
    [anon_sym_decltype] = ACTIONS(5922),
  },
  [2278] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(5928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [aux_sym_preproc_if_token2] = ACTIONS(5926),
    [aux_sym_preproc_else_token1] = ACTIONS(5926),
    [aux_sym_preproc_elif_token1] = ACTIONS(5928),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5926),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5926),
    [anon_sym_LPAREN2] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_STAR] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5928),
    [anon_sym_PERCENT] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5926),
    [anon_sym_PIPE] = ACTIONS(5928),
    [anon_sym_CARET] = ACTIONS(5928),
    [anon_sym_AMP] = ACTIONS(5928),
    [anon_sym_EQ_EQ] = ACTIONS(5926),
    [anon_sym_BANG_EQ] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5928),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_LT] = ACTIONS(5928),
    [anon_sym_LT_LT] = ACTIONS(5928),
    [anon_sym_GT_GT] = ACTIONS(5928),
    [anon_sym___attribute__] = ACTIONS(5928),
    [anon_sym___attribute] = ACTIONS(5928),
    [anon_sym_LBRACE] = ACTIONS(5926),
    [anon_sym_signed] = ACTIONS(6176),
    [anon_sym_unsigned] = ACTIONS(6176),
    [anon_sym_long] = ACTIONS(6176),
    [anon_sym_short] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_STAR_EQ] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_PERCENT_EQ] = ACTIONS(5926),
    [anon_sym_PLUS_EQ] = ACTIONS(5926),
    [anon_sym_DASH_EQ] = ACTIONS(5926),
    [anon_sym_LT_LT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT_EQ] = ACTIONS(5926),
    [anon_sym_AMP_EQ] = ACTIONS(5926),
    [anon_sym_CARET_EQ] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_and_eq] = ACTIONS(5928),
    [anon_sym_or_eq] = ACTIONS(5928),
    [anon_sym_xor_eq] = ACTIONS(5928),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_or] = ACTIONS(5928),
    [anon_sym_and] = ACTIONS(5928),
    [anon_sym_bitor] = ACTIONS(5928),
    [anon_sym_xor] = ACTIONS(5928),
    [anon_sym_bitand] = ACTIONS(5928),
    [anon_sym_not_eq] = ACTIONS(5928),
    [anon_sym_DASH_DASH] = ACTIONS(5926),
    [anon_sym_PLUS_PLUS] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_DOT_STAR] = ACTIONS(5926),
    [anon_sym_DASH_GT] = ACTIONS(5926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5928),
    [anon_sym_decltype] = ACTIONS(5928),
  },
  [2279] = {
    [sym_identifier] = ACTIONS(6269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6271),
    [anon_sym_COMMA] = ACTIONS(6271),
    [anon_sym_RPAREN] = ACTIONS(6271),
    [aux_sym_preproc_if_token2] = ACTIONS(6271),
    [aux_sym_preproc_else_token1] = ACTIONS(6271),
    [aux_sym_preproc_elif_token1] = ACTIONS(6269),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6271),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6271),
    [anon_sym_LPAREN2] = ACTIONS(6271),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_SLASH] = ACTIONS(6269),
    [anon_sym_PERCENT] = ACTIONS(6269),
    [anon_sym_PIPE_PIPE] = ACTIONS(6271),
    [anon_sym_AMP_AMP] = ACTIONS(6271),
    [anon_sym_PIPE] = ACTIONS(6269),
    [anon_sym_CARET] = ACTIONS(6269),
    [anon_sym_AMP] = ACTIONS(6269),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_GT] = ACTIONS(6269),
    [anon_sym_GT_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6269),
    [anon_sym_LT] = ACTIONS(6269),
    [anon_sym_LT_LT] = ACTIONS(6269),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_SEMI] = ACTIONS(6271),
    [anon_sym___attribute__] = ACTIONS(6269),
    [anon_sym___attribute] = ACTIONS(6269),
    [anon_sym_COLON] = ACTIONS(6271),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(6271),
    [anon_sym_RBRACE] = ACTIONS(6271),
    [anon_sym_LBRACK] = ACTIONS(6269),
    [anon_sym_RBRACK] = ACTIONS(6271),
    [anon_sym_EQ] = ACTIONS(6269),
    [anon_sym_QMARK] = ACTIONS(6271),
    [anon_sym_STAR_EQ] = ACTIONS(6271),
    [anon_sym_SLASH_EQ] = ACTIONS(6271),
    [anon_sym_PERCENT_EQ] = ACTIONS(6271),
    [anon_sym_PLUS_EQ] = ACTIONS(6271),
    [anon_sym_DASH_EQ] = ACTIONS(6271),
    [anon_sym_LT_LT_EQ] = ACTIONS(6271),
    [anon_sym_GT_GT_EQ] = ACTIONS(6271),
    [anon_sym_AMP_EQ] = ACTIONS(6271),
    [anon_sym_CARET_EQ] = ACTIONS(6271),
    [anon_sym_PIPE_EQ] = ACTIONS(6271),
    [anon_sym_and_eq] = ACTIONS(6269),
    [anon_sym_or_eq] = ACTIONS(6269),
    [anon_sym_xor_eq] = ACTIONS(6269),
    [anon_sym_LT_EQ_GT] = ACTIONS(6271),
    [anon_sym_or] = ACTIONS(6269),
    [anon_sym_and] = ACTIONS(6269),
    [anon_sym_bitor] = ACTIONS(6269),
    [anon_sym_xor] = ACTIONS(6269),
    [anon_sym_bitand] = ACTIONS(6269),
    [anon_sym_not_eq] = ACTIONS(6269),
    [anon_sym_DASH_DASH] = ACTIONS(6271),
    [anon_sym_PLUS_PLUS] = ACTIONS(6271),
    [anon_sym_DOT] = ACTIONS(6269),
    [anon_sym_DOT_STAR] = ACTIONS(6271),
    [anon_sym_DASH_GT] = ACTIONS(6271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6269),
  },
  [2280] = {
    [sym_identifier] = ACTIONS(6273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6275),
    [anon_sym_COMMA] = ACTIONS(6275),
    [anon_sym_RPAREN] = ACTIONS(6275),
    [aux_sym_preproc_if_token2] = ACTIONS(6275),
    [aux_sym_preproc_else_token1] = ACTIONS(6275),
    [aux_sym_preproc_elif_token1] = ACTIONS(6273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6275),
    [anon_sym_LPAREN2] = ACTIONS(6275),
    [anon_sym_DASH] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_STAR] = ACTIONS(6273),
    [anon_sym_SLASH] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6273),
    [anon_sym_PIPE_PIPE] = ACTIONS(6275),
    [anon_sym_AMP_AMP] = ACTIONS(6275),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_EQ_EQ] = ACTIONS(6275),
    [anon_sym_BANG_EQ] = ACTIONS(6275),
    [anon_sym_GT] = ACTIONS(6273),
    [anon_sym_GT_EQ] = ACTIONS(6275),
    [anon_sym_LT_EQ] = ACTIONS(6273),
    [anon_sym_LT] = ACTIONS(6273),
    [anon_sym_LT_LT] = ACTIONS(6273),
    [anon_sym_GT_GT] = ACTIONS(6273),
    [anon_sym_SEMI] = ACTIONS(6275),
    [anon_sym___attribute__] = ACTIONS(6273),
    [anon_sym___attribute] = ACTIONS(6273),
    [anon_sym_COLON] = ACTIONS(6275),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6275),
    [anon_sym_LBRACE] = ACTIONS(6275),
    [anon_sym_RBRACE] = ACTIONS(6275),
    [anon_sym_LBRACK] = ACTIONS(6273),
    [anon_sym_RBRACK] = ACTIONS(6275),
    [anon_sym_EQ] = ACTIONS(6273),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_STAR_EQ] = ACTIONS(6275),
    [anon_sym_SLASH_EQ] = ACTIONS(6275),
    [anon_sym_PERCENT_EQ] = ACTIONS(6275),
    [anon_sym_PLUS_EQ] = ACTIONS(6275),
    [anon_sym_DASH_EQ] = ACTIONS(6275),
    [anon_sym_LT_LT_EQ] = ACTIONS(6275),
    [anon_sym_GT_GT_EQ] = ACTIONS(6275),
    [anon_sym_AMP_EQ] = ACTIONS(6275),
    [anon_sym_CARET_EQ] = ACTIONS(6275),
    [anon_sym_PIPE_EQ] = ACTIONS(6275),
    [anon_sym_and_eq] = ACTIONS(6273),
    [anon_sym_or_eq] = ACTIONS(6273),
    [anon_sym_xor_eq] = ACTIONS(6273),
    [anon_sym_LT_EQ_GT] = ACTIONS(6275),
    [anon_sym_or] = ACTIONS(6273),
    [anon_sym_and] = ACTIONS(6273),
    [anon_sym_bitor] = ACTIONS(6273),
    [anon_sym_xor] = ACTIONS(6273),
    [anon_sym_bitand] = ACTIONS(6273),
    [anon_sym_not_eq] = ACTIONS(6273),
    [anon_sym_DASH_DASH] = ACTIONS(6275),
    [anon_sym_PLUS_PLUS] = ACTIONS(6275),
    [anon_sym_DOT] = ACTIONS(6273),
    [anon_sym_DOT_STAR] = ACTIONS(6275),
    [anon_sym_DASH_GT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6273),
  },
  [2281] = {
    [sym_attribute_specifier] = STATE(1872),
    [sym_enumerator_list] = STATE(2350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5985),
    [anon_sym_COMMA] = ACTIONS(5985),
    [anon_sym_RPAREN] = ACTIONS(5985),
    [anon_sym_LPAREN2] = ACTIONS(5985),
    [anon_sym_DASH] = ACTIONS(5983),
    [anon_sym_PLUS] = ACTIONS(5983),
    [anon_sym_STAR] = ACTIONS(5985),
    [anon_sym_SLASH] = ACTIONS(5983),
    [anon_sym_PERCENT] = ACTIONS(5985),
    [anon_sym_PIPE_PIPE] = ACTIONS(5985),
    [anon_sym_AMP_AMP] = ACTIONS(5985),
    [anon_sym_PIPE] = ACTIONS(5983),
    [anon_sym_CARET] = ACTIONS(5985),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_EQ_EQ] = ACTIONS(5985),
    [anon_sym_BANG_EQ] = ACTIONS(5985),
    [anon_sym_GT] = ACTIONS(5983),
    [anon_sym_GT_EQ] = ACTIONS(5985),
    [anon_sym_LT_EQ] = ACTIONS(5983),
    [anon_sym_LT] = ACTIONS(5983),
    [anon_sym_LT_LT] = ACTIONS(5985),
    [anon_sym_GT_GT] = ACTIONS(5985),
    [anon_sym_SEMI] = ACTIONS(5985),
    [anon_sym___extension__] = ACTIONS(5985),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(5985),
    [anon_sym_LBRACE] = ACTIONS(6186),
    [anon_sym_RBRACE] = ACTIONS(5985),
    [anon_sym_LBRACK] = ACTIONS(5985),
    [anon_sym_RBRACK] = ACTIONS(5985),
    [anon_sym_const] = ACTIONS(5983),
    [anon_sym_constexpr] = ACTIONS(5985),
    [anon_sym_volatile] = ACTIONS(5985),
    [anon_sym_restrict] = ACTIONS(5985),
    [anon_sym___restrict__] = ACTIONS(5985),
    [anon_sym__Atomic] = ACTIONS(5985),
    [anon_sym__Noreturn] = ACTIONS(5985),
    [anon_sym_noreturn] = ACTIONS(5985),
    [anon_sym__Nonnull] = ACTIONS(5985),
    [anon_sym_mutable] = ACTIONS(5985),
    [anon_sym_constinit] = ACTIONS(5985),
    [anon_sym_consteval] = ACTIONS(5985),
    [anon_sym_alignas] = ACTIONS(5985),
    [anon_sym__Alignas] = ACTIONS(5985),
    [anon_sym_QMARK] = ACTIONS(5985),
    [anon_sym_LT_EQ_GT] = ACTIONS(5985),
    [anon_sym_or] = ACTIONS(5985),
    [anon_sym_and] = ACTIONS(5985),
    [anon_sym_bitor] = ACTIONS(5985),
    [anon_sym_xor] = ACTIONS(5985),
    [anon_sym_bitand] = ACTIONS(5985),
    [anon_sym_not_eq] = ACTIONS(5985),
    [anon_sym_DASH_DASH] = ACTIONS(5985),
    [anon_sym_PLUS_PLUS] = ACTIONS(5985),
    [anon_sym_DOT] = ACTIONS(5983),
    [anon_sym_DOT_STAR] = ACTIONS(5985),
    [anon_sym_DASH_GT] = ACTIONS(5985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5985),
    [anon_sym_decltype] = ACTIONS(5985),
    [anon_sym_final] = ACTIONS(5985),
    [anon_sym_override] = ACTIONS(5985),
    [anon_sym_requires] = ACTIONS(5985),
  },
  [2282] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [anon_sym_LPAREN2] = ACTIONS(5491),
    [anon_sym_DASH] = ACTIONS(5489),
    [anon_sym_PLUS] = ACTIONS(5489),
    [anon_sym_STAR] = ACTIONS(5489),
    [anon_sym_SLASH] = ACTIONS(5489),
    [anon_sym_PERCENT] = ACTIONS(5489),
    [anon_sym_PIPE_PIPE] = ACTIONS(5491),
    [anon_sym_AMP_AMP] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_CARET] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5489),
    [anon_sym_EQ_EQ] = ACTIONS(5491),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_GT] = ACTIONS(5489),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5489),
    [anon_sym_LT] = ACTIONS(5489),
    [anon_sym_LT_LT] = ACTIONS(5489),
    [anon_sym_GT_GT] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym_COLON] = ACTIONS(5491),
    [anon_sym_RBRACE] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_RBRACK] = ACTIONS(5491),
    [anon_sym_EQ] = ACTIONS(5489),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_STAR_EQ] = ACTIONS(5491),
    [anon_sym_SLASH_EQ] = ACTIONS(5491),
    [anon_sym_PERCENT_EQ] = ACTIONS(5491),
    [anon_sym_PLUS_EQ] = ACTIONS(5491),
    [anon_sym_DASH_EQ] = ACTIONS(5491),
    [anon_sym_LT_LT_EQ] = ACTIONS(5491),
    [anon_sym_GT_GT_EQ] = ACTIONS(5491),
    [anon_sym_AMP_EQ] = ACTIONS(5491),
    [anon_sym_CARET_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_and_eq] = ACTIONS(5489),
    [anon_sym_or_eq] = ACTIONS(5489),
    [anon_sym_xor_eq] = ACTIONS(5489),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5489),
    [anon_sym_and] = ACTIONS(5489),
    [anon_sym_bitor] = ACTIONS(5489),
    [anon_sym_xor] = ACTIONS(5489),
    [anon_sym_bitand] = ACTIONS(5489),
    [anon_sym_not_eq] = ACTIONS(5489),
    [anon_sym_DASH_DASH] = ACTIONS(5491),
    [anon_sym_PLUS_PLUS] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5489),
    [anon_sym_DOT_STAR] = ACTIONS(5491),
    [anon_sym_DASH_GT] = ACTIONS(5491),
    [anon_sym_L_DQUOTE] = ACTIONS(5491),
    [anon_sym_u_DQUOTE] = ACTIONS(5491),
    [anon_sym_U_DQUOTE] = ACTIONS(5491),
    [anon_sym_u8_DQUOTE] = ACTIONS(5491),
    [anon_sym_DQUOTE] = ACTIONS(5491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5491),
    [anon_sym_LR_DQUOTE] = ACTIONS(5491),
    [anon_sym_uR_DQUOTE] = ACTIONS(5491),
    [anon_sym_UR_DQUOTE] = ACTIONS(5491),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5491),
    [sym_literal_suffix] = ACTIONS(5489),
  },
  [2283] = {
    [sym_identifier] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5808),
    [anon_sym_RPAREN] = ACTIONS(5808),
    [aux_sym_preproc_if_token2] = ACTIONS(5808),
    [aux_sym_preproc_else_token1] = ACTIONS(5808),
    [aux_sym_preproc_elif_token1] = ACTIONS(5806),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5808),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5808),
    [anon_sym_LPAREN2] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5806),
    [anon_sym_SLASH] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5806),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_AMP_AMP] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5806),
    [anon_sym_CARET] = ACTIONS(5806),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_EQ] = ACTIONS(5808),
    [anon_sym_BANG_EQ] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5806),
    [anon_sym_LT_LT] = ACTIONS(5806),
    [anon_sym_GT_GT] = ACTIONS(5806),
    [anon_sym_SEMI] = ACTIONS(5808),
    [anon_sym___attribute__] = ACTIONS(5806),
    [anon_sym___attribute] = ACTIONS(5806),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_LBRACE] = ACTIONS(5808),
    [anon_sym_RBRACE] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_RBRACK] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5806),
    [anon_sym_QMARK] = ACTIONS(5808),
    [anon_sym_STAR_EQ] = ACTIONS(5808),
    [anon_sym_SLASH_EQ] = ACTIONS(5808),
    [anon_sym_PERCENT_EQ] = ACTIONS(5808),
    [anon_sym_PLUS_EQ] = ACTIONS(5808),
    [anon_sym_DASH_EQ] = ACTIONS(5808),
    [anon_sym_LT_LT_EQ] = ACTIONS(5808),
    [anon_sym_GT_GT_EQ] = ACTIONS(5808),
    [anon_sym_AMP_EQ] = ACTIONS(5808),
    [anon_sym_CARET_EQ] = ACTIONS(5808),
    [anon_sym_PIPE_EQ] = ACTIONS(5808),
    [anon_sym_and_eq] = ACTIONS(5806),
    [anon_sym_or_eq] = ACTIONS(5806),
    [anon_sym_xor_eq] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5808),
    [anon_sym_or] = ACTIONS(5806),
    [anon_sym_and] = ACTIONS(5806),
    [anon_sym_bitor] = ACTIONS(5806),
    [anon_sym_xor] = ACTIONS(5806),
    [anon_sym_bitand] = ACTIONS(5806),
    [anon_sym_not_eq] = ACTIONS(5806),
    [anon_sym_DASH_DASH] = ACTIONS(5808),
    [anon_sym_PLUS_PLUS] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5806),
    [anon_sym_DOT_STAR] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5806),
    [anon_sym_decltype] = ACTIONS(5806),
  },
  [2284] = {
    [sym_identifier] = ACTIONS(6277),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6279),
    [anon_sym_COMMA] = ACTIONS(6279),
    [anon_sym_RPAREN] = ACTIONS(6279),
    [aux_sym_preproc_if_token2] = ACTIONS(6279),
    [aux_sym_preproc_else_token1] = ACTIONS(6279),
    [aux_sym_preproc_elif_token1] = ACTIONS(6277),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6279),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6279),
    [anon_sym_LPAREN2] = ACTIONS(6279),
    [anon_sym_DASH] = ACTIONS(6277),
    [anon_sym_PLUS] = ACTIONS(6277),
    [anon_sym_STAR] = ACTIONS(6277),
    [anon_sym_SLASH] = ACTIONS(6277),
    [anon_sym_PERCENT] = ACTIONS(6277),
    [anon_sym_PIPE_PIPE] = ACTIONS(6279),
    [anon_sym_AMP_AMP] = ACTIONS(6279),
    [anon_sym_PIPE] = ACTIONS(6277),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ_EQ] = ACTIONS(6279),
    [anon_sym_BANG_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6277),
    [anon_sym_GT_EQ] = ACTIONS(6279),
    [anon_sym_LT_EQ] = ACTIONS(6277),
    [anon_sym_LT] = ACTIONS(6277),
    [anon_sym_LT_LT] = ACTIONS(6277),
    [anon_sym_GT_GT] = ACTIONS(6277),
    [anon_sym_SEMI] = ACTIONS(6279),
    [anon_sym___attribute__] = ACTIONS(6277),
    [anon_sym___attribute] = ACTIONS(6277),
    [anon_sym_COLON] = ACTIONS(6279),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6279),
    [anon_sym_LBRACE] = ACTIONS(6279),
    [anon_sym_RBRACE] = ACTIONS(6279),
    [anon_sym_LBRACK] = ACTIONS(6277),
    [anon_sym_RBRACK] = ACTIONS(6279),
    [anon_sym_EQ] = ACTIONS(6277),
    [anon_sym_QMARK] = ACTIONS(6279),
    [anon_sym_STAR_EQ] = ACTIONS(6279),
    [anon_sym_SLASH_EQ] = ACTIONS(6279),
    [anon_sym_PERCENT_EQ] = ACTIONS(6279),
    [anon_sym_PLUS_EQ] = ACTIONS(6279),
    [anon_sym_DASH_EQ] = ACTIONS(6279),
    [anon_sym_LT_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT_GT_EQ] = ACTIONS(6279),
    [anon_sym_AMP_EQ] = ACTIONS(6279),
    [anon_sym_CARET_EQ] = ACTIONS(6279),
    [anon_sym_PIPE_EQ] = ACTIONS(6279),
    [anon_sym_and_eq] = ACTIONS(6277),
    [anon_sym_or_eq] = ACTIONS(6277),
    [anon_sym_xor_eq] = ACTIONS(6277),
    [anon_sym_LT_EQ_GT] = ACTIONS(6279),
    [anon_sym_or] = ACTIONS(6277),
    [anon_sym_and] = ACTIONS(6277),
    [anon_sym_bitor] = ACTIONS(6277),
    [anon_sym_xor] = ACTIONS(6277),
    [anon_sym_bitand] = ACTIONS(6277),
    [anon_sym_not_eq] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(6279),
    [anon_sym_PLUS_PLUS] = ACTIONS(6279),
    [anon_sym_DOT] = ACTIONS(6277),
    [anon_sym_DOT_STAR] = ACTIONS(6279),
    [anon_sym_DASH_GT] = ACTIONS(6279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6277),
  },
  [2285] = {
    [sym_string_literal] = STATE(2301),
    [sym_raw_string_literal] = STATE(2301),
    [aux_sym_concatenated_string_repeat1] = STATE(2301),
    [sym_identifier] = ACTIONS(6281),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_LPAREN2] = ACTIONS(5396),
    [anon_sym_DASH] = ACTIONS(5398),
    [anon_sym_PLUS] = ACTIONS(5398),
    [anon_sym_STAR] = ACTIONS(5398),
    [anon_sym_SLASH] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5398),
    [anon_sym_PIPE_PIPE] = ACTIONS(5396),
    [anon_sym_AMP_AMP] = ACTIONS(5396),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_CARET] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
    [anon_sym_EQ_EQ] = ACTIONS(5396),
    [anon_sym_BANG_EQ] = ACTIONS(5396),
    [anon_sym_GT] = ACTIONS(5398),
    [anon_sym_GT_EQ] = ACTIONS(5398),
    [anon_sym_LT_EQ] = ACTIONS(5398),
    [anon_sym_LT] = ACTIONS(5398),
    [anon_sym_LT_LT] = ACTIONS(5398),
    [anon_sym_GT_GT] = ACTIONS(5398),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_EQ] = ACTIONS(5398),
    [anon_sym_QMARK] = ACTIONS(5396),
    [anon_sym_STAR_EQ] = ACTIONS(5396),
    [anon_sym_SLASH_EQ] = ACTIONS(5396),
    [anon_sym_PERCENT_EQ] = ACTIONS(5396),
    [anon_sym_PLUS_EQ] = ACTIONS(5396),
    [anon_sym_DASH_EQ] = ACTIONS(5396),
    [anon_sym_LT_LT_EQ] = ACTIONS(5396),
    [anon_sym_GT_GT_EQ] = ACTIONS(5398),
    [anon_sym_AMP_EQ] = ACTIONS(5396),
    [anon_sym_CARET_EQ] = ACTIONS(5396),
    [anon_sym_PIPE_EQ] = ACTIONS(5396),
    [anon_sym_and_eq] = ACTIONS(5398),
    [anon_sym_or_eq] = ACTIONS(5398),
    [anon_sym_xor_eq] = ACTIONS(5398),
    [anon_sym_LT_EQ_GT] = ACTIONS(5396),
    [anon_sym_or] = ACTIONS(5398),
    [anon_sym_and] = ACTIONS(5398),
    [anon_sym_bitor] = ACTIONS(5398),
    [anon_sym_xor] = ACTIONS(5398),
    [anon_sym_bitand] = ACTIONS(5398),
    [anon_sym_not_eq] = ACTIONS(5398),
    [anon_sym_DASH_DASH] = ACTIONS(5396),
    [anon_sym_PLUS_PLUS] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(5398),
    [anon_sym_DOT_STAR] = ACTIONS(5396),
    [anon_sym_DASH_GT] = ACTIONS(5396),
    [anon_sym_L_DQUOTE] = ACTIONS(6214),
    [anon_sym_u_DQUOTE] = ACTIONS(6214),
    [anon_sym_U_DQUOTE] = ACTIONS(6214),
    [anon_sym_u8_DQUOTE] = ACTIONS(6214),
    [anon_sym_DQUOTE] = ACTIONS(6214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5396),
    [anon_sym_R_DQUOTE] = ACTIONS(6216),
    [anon_sym_LR_DQUOTE] = ACTIONS(6216),
    [anon_sym_uR_DQUOTE] = ACTIONS(6216),
    [anon_sym_UR_DQUOTE] = ACTIONS(6216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6216),
    [sym_literal_suffix] = ACTIONS(5398),
  },
  [2286] = {
    [sym_string_literal] = STATE(2236),
    [sym_template_argument_list] = STATE(3335),
    [sym_raw_string_literal] = STATE(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4154),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(6283),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(4146),
    [anon_sym_SLASH_EQ] = ACTIONS(4146),
    [anon_sym_PERCENT_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_DASH_EQ] = ACTIONS(4146),
    [anon_sym_LT_LT_EQ] = ACTIONS(4146),
    [anon_sym_GT_GT_EQ] = ACTIONS(4154),
    [anon_sym_AMP_EQ] = ACTIONS(4146),
    [anon_sym_CARET_EQ] = ACTIONS(4146),
    [anon_sym_PIPE_EQ] = ACTIONS(4146),
    [anon_sym_and_eq] = ACTIONS(4146),
    [anon_sym_or_eq] = ACTIONS(4146),
    [anon_sym_xor_eq] = ACTIONS(4146),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(6214),
    [anon_sym_u_DQUOTE] = ACTIONS(6214),
    [anon_sym_U_DQUOTE] = ACTIONS(6214),
    [anon_sym_u8_DQUOTE] = ACTIONS(6214),
    [anon_sym_DQUOTE] = ACTIONS(6214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4146),
    [anon_sym_R_DQUOTE] = ACTIONS(6216),
    [anon_sym_LR_DQUOTE] = ACTIONS(6216),
    [anon_sym_uR_DQUOTE] = ACTIONS(6216),
    [anon_sym_UR_DQUOTE] = ACTIONS(6216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6216),
  },
  [2287] = {
    [sym_identifier] = ACTIONS(6286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6288),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_RPAREN] = ACTIONS(6288),
    [aux_sym_preproc_if_token2] = ACTIONS(6288),
    [aux_sym_preproc_else_token1] = ACTIONS(6288),
    [aux_sym_preproc_elif_token1] = ACTIONS(6286),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6288),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6288),
    [anon_sym_LPAREN2] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6286),
    [anon_sym_PLUS] = ACTIONS(6286),
    [anon_sym_STAR] = ACTIONS(6286),
    [anon_sym_SLASH] = ACTIONS(6286),
    [anon_sym_PERCENT] = ACTIONS(6286),
    [anon_sym_PIPE_PIPE] = ACTIONS(6288),
    [anon_sym_AMP_AMP] = ACTIONS(6288),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_CARET] = ACTIONS(6286),
    [anon_sym_AMP] = ACTIONS(6286),
    [anon_sym_EQ_EQ] = ACTIONS(6288),
    [anon_sym_BANG_EQ] = ACTIONS(6288),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_GT_EQ] = ACTIONS(6288),
    [anon_sym_LT_EQ] = ACTIONS(6286),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_LT_LT] = ACTIONS(6286),
    [anon_sym_GT_GT] = ACTIONS(6286),
    [anon_sym_SEMI] = ACTIONS(6288),
    [anon_sym___attribute__] = ACTIONS(6286),
    [anon_sym___attribute] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6288),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [anon_sym_RBRACE] = ACTIONS(6288),
    [anon_sym_LBRACK] = ACTIONS(6286),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [anon_sym_EQ] = ACTIONS(6286),
    [anon_sym_QMARK] = ACTIONS(6288),
    [anon_sym_STAR_EQ] = ACTIONS(6288),
    [anon_sym_SLASH_EQ] = ACTIONS(6288),
    [anon_sym_PERCENT_EQ] = ACTIONS(6288),
    [anon_sym_PLUS_EQ] = ACTIONS(6288),
    [anon_sym_DASH_EQ] = ACTIONS(6288),
    [anon_sym_LT_LT_EQ] = ACTIONS(6288),
    [anon_sym_GT_GT_EQ] = ACTIONS(6288),
    [anon_sym_AMP_EQ] = ACTIONS(6288),
    [anon_sym_CARET_EQ] = ACTIONS(6288),
    [anon_sym_PIPE_EQ] = ACTIONS(6288),
    [anon_sym_and_eq] = ACTIONS(6286),
    [anon_sym_or_eq] = ACTIONS(6286),
    [anon_sym_xor_eq] = ACTIONS(6286),
    [anon_sym_LT_EQ_GT] = ACTIONS(6288),
    [anon_sym_or] = ACTIONS(6286),
    [anon_sym_and] = ACTIONS(6286),
    [anon_sym_bitor] = ACTIONS(6286),
    [anon_sym_xor] = ACTIONS(6286),
    [anon_sym_bitand] = ACTIONS(6286),
    [anon_sym_not_eq] = ACTIONS(6286),
    [anon_sym_DASH_DASH] = ACTIONS(6288),
    [anon_sym_PLUS_PLUS] = ACTIONS(6288),
    [anon_sym_DOT] = ACTIONS(6286),
    [anon_sym_DOT_STAR] = ACTIONS(6288),
    [anon_sym_DASH_GT] = ACTIONS(6288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6286),
  },
  [2288] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2234),
    [sym_identifier] = ACTIONS(5750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [aux_sym_preproc_if_token2] = ACTIONS(5752),
    [aux_sym_preproc_else_token1] = ACTIONS(5752),
    [aux_sym_preproc_elif_token1] = ACTIONS(5750),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5752),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5752),
    [anon_sym_LPAREN2] = ACTIONS(5752),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_STAR] = ACTIONS(5750),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_PIPE] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5750),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_LT] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym___attribute__] = ACTIONS(5750),
    [anon_sym___attribute] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5752),
    [anon_sym_signed] = ACTIONS(6290),
    [anon_sym_unsigned] = ACTIONS(6290),
    [anon_sym_long] = ACTIONS(6290),
    [anon_sym_short] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5752),
    [anon_sym_STAR_EQ] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_PERCENT_EQ] = ACTIONS(5752),
    [anon_sym_PLUS_EQ] = ACTIONS(5752),
    [anon_sym_DASH_EQ] = ACTIONS(5752),
    [anon_sym_LT_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT_GT_EQ] = ACTIONS(5752),
    [anon_sym_AMP_EQ] = ACTIONS(5752),
    [anon_sym_CARET_EQ] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_and_eq] = ACTIONS(5750),
    [anon_sym_or_eq] = ACTIONS(5750),
    [anon_sym_xor_eq] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_bitor] = ACTIONS(5750),
    [anon_sym_xor] = ACTIONS(5750),
    [anon_sym_bitand] = ACTIONS(5750),
    [anon_sym_not_eq] = ACTIONS(5750),
    [anon_sym_DASH_DASH] = ACTIONS(5752),
    [anon_sym_PLUS_PLUS] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_DOT_STAR] = ACTIONS(5752),
    [anon_sym_DASH_GT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5750),
    [anon_sym_decltype] = ACTIONS(5750),
  },
  [2289] = {
    [sym_identifier] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5742),
    [anon_sym_COMMA] = ACTIONS(5742),
    [anon_sym_RPAREN] = ACTIONS(5742),
    [aux_sym_preproc_if_token2] = ACTIONS(5742),
    [aux_sym_preproc_else_token1] = ACTIONS(5742),
    [aux_sym_preproc_elif_token1] = ACTIONS(5740),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5742),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5742),
    [anon_sym_LPAREN2] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_STAR] = ACTIONS(5740),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5740),
    [anon_sym_PIPE_PIPE] = ACTIONS(5742),
    [anon_sym_AMP_AMP] = ACTIONS(5742),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_CARET] = ACTIONS(5740),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5742),
    [anon_sym_BANG_EQ] = ACTIONS(5742),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5740),
    [anon_sym_GT_GT] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5742),
    [anon_sym___attribute__] = ACTIONS(5740),
    [anon_sym___attribute] = ACTIONS(5740),
    [anon_sym_COLON] = ACTIONS(5742),
    [anon_sym_LBRACE] = ACTIONS(5742),
    [anon_sym_RBRACE] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_RBRACK] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_STAR_EQ] = ACTIONS(5742),
    [anon_sym_SLASH_EQ] = ACTIONS(5742),
    [anon_sym_PERCENT_EQ] = ACTIONS(5742),
    [anon_sym_PLUS_EQ] = ACTIONS(5742),
    [anon_sym_DASH_EQ] = ACTIONS(5742),
    [anon_sym_LT_LT_EQ] = ACTIONS(5742),
    [anon_sym_GT_GT_EQ] = ACTIONS(5742),
    [anon_sym_AMP_EQ] = ACTIONS(5742),
    [anon_sym_CARET_EQ] = ACTIONS(5742),
    [anon_sym_PIPE_EQ] = ACTIONS(5742),
    [anon_sym_and_eq] = ACTIONS(5740),
    [anon_sym_or_eq] = ACTIONS(5740),
    [anon_sym_xor_eq] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5742),
    [anon_sym_or] = ACTIONS(5740),
    [anon_sym_and] = ACTIONS(5740),
    [anon_sym_bitor] = ACTIONS(5740),
    [anon_sym_xor] = ACTIONS(5740),
    [anon_sym_bitand] = ACTIONS(5740),
    [anon_sym_not_eq] = ACTIONS(5740),
    [anon_sym_DASH_DASH] = ACTIONS(5742),
    [anon_sym_PLUS_PLUS] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_DOT_STAR] = ACTIONS(5742),
    [anon_sym_DASH_GT] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5740),
    [anon_sym_decltype] = ACTIONS(5740),
  },
  [2290] = {
    [sym_identifier] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5665),
    [anon_sym_COMMA] = ACTIONS(5665),
    [anon_sym_RPAREN] = ACTIONS(5665),
    [aux_sym_preproc_if_token2] = ACTIONS(5665),
    [aux_sym_preproc_else_token1] = ACTIONS(5665),
    [aux_sym_preproc_elif_token1] = ACTIONS(5663),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5665),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5665),
    [anon_sym_LPAREN2] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5663),
    [anon_sym_STAR] = ACTIONS(5663),
    [anon_sym_SLASH] = ACTIONS(5663),
    [anon_sym_PERCENT] = ACTIONS(5663),
    [anon_sym_PIPE_PIPE] = ACTIONS(5665),
    [anon_sym_AMP_AMP] = ACTIONS(5665),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_CARET] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5663),
    [anon_sym_EQ_EQ] = ACTIONS(5665),
    [anon_sym_BANG_EQ] = ACTIONS(5665),
    [anon_sym_GT] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_LT] = ACTIONS(5663),
    [anon_sym_GT_GT] = ACTIONS(5663),
    [anon_sym_SEMI] = ACTIONS(5665),
    [anon_sym___attribute__] = ACTIONS(5663),
    [anon_sym___attribute] = ACTIONS(5663),
    [anon_sym_COLON] = ACTIONS(5665),
    [anon_sym_LBRACE] = ACTIONS(5665),
    [anon_sym_RBRACE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_RBRACK] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_QMARK] = ACTIONS(5665),
    [anon_sym_STAR_EQ] = ACTIONS(5665),
    [anon_sym_SLASH_EQ] = ACTIONS(5665),
    [anon_sym_PERCENT_EQ] = ACTIONS(5665),
    [anon_sym_PLUS_EQ] = ACTIONS(5665),
    [anon_sym_DASH_EQ] = ACTIONS(5665),
    [anon_sym_LT_LT_EQ] = ACTIONS(5665),
    [anon_sym_GT_GT_EQ] = ACTIONS(5665),
    [anon_sym_AMP_EQ] = ACTIONS(5665),
    [anon_sym_CARET_EQ] = ACTIONS(5665),
    [anon_sym_PIPE_EQ] = ACTIONS(5665),
    [anon_sym_and_eq] = ACTIONS(5663),
    [anon_sym_or_eq] = ACTIONS(5663),
    [anon_sym_xor_eq] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5665),
    [anon_sym_or] = ACTIONS(5663),
    [anon_sym_and] = ACTIONS(5663),
    [anon_sym_bitor] = ACTIONS(5663),
    [anon_sym_xor] = ACTIONS(5663),
    [anon_sym_bitand] = ACTIONS(5663),
    [anon_sym_not_eq] = ACTIONS(5663),
    [anon_sym_DASH_DASH] = ACTIONS(5665),
    [anon_sym_PLUS_PLUS] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5663),
    [anon_sym_DOT_STAR] = ACTIONS(5665),
    [anon_sym_DASH_GT] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5663),
    [anon_sym_decltype] = ACTIONS(5663),
  },
  [2291] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_TILDE] = ACTIONS(5619),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym___extension__] = ACTIONS(5617),
    [anon_sym_virtual] = ACTIONS(5617),
    [anon_sym_extern] = ACTIONS(5617),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_using] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5619),
    [anon_sym___declspec] = ACTIONS(5617),
    [anon_sym___based] = ACTIONS(5617),
    [anon_sym___cdecl] = ACTIONS(5617),
    [anon_sym___clrcall] = ACTIONS(5617),
    [anon_sym___stdcall] = ACTIONS(5617),
    [anon_sym___fastcall] = ACTIONS(5617),
    [anon_sym___thiscall] = ACTIONS(5617),
    [anon_sym___vectorcall] = ACTIONS(5617),
    [anon_sym_signed] = ACTIONS(5617),
    [anon_sym_unsigned] = ACTIONS(5617),
    [anon_sym_long] = ACTIONS(5617),
    [anon_sym_short] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5617),
    [anon_sym_static] = ACTIONS(5617),
    [anon_sym_register] = ACTIONS(5617),
    [anon_sym_inline] = ACTIONS(5617),
    [anon_sym___inline] = ACTIONS(5617),
    [anon_sym___inline__] = ACTIONS(5617),
    [anon_sym___forceinline] = ACTIONS(5617),
    [anon_sym_thread_local] = ACTIONS(5617),
    [anon_sym___thread] = ACTIONS(5617),
    [anon_sym_const] = ACTIONS(5617),
    [anon_sym_constexpr] = ACTIONS(5617),
    [anon_sym_volatile] = ACTIONS(5617),
    [anon_sym_restrict] = ACTIONS(5617),
    [anon_sym___restrict__] = ACTIONS(5617),
    [anon_sym__Atomic] = ACTIONS(5617),
    [anon_sym__Noreturn] = ACTIONS(5617),
    [anon_sym_noreturn] = ACTIONS(5617),
    [anon_sym__Nonnull] = ACTIONS(5617),
    [anon_sym_mutable] = ACTIONS(5617),
    [anon_sym_constinit] = ACTIONS(5617),
    [anon_sym_consteval] = ACTIONS(5617),
    [anon_sym_alignas] = ACTIONS(5617),
    [anon_sym__Alignas] = ACTIONS(5617),
    [sym_primitive_type] = ACTIONS(5617),
    [anon_sym_enum] = ACTIONS(5617),
    [anon_sym_class] = ACTIONS(5617),
    [anon_sym_struct] = ACTIONS(5617),
    [anon_sym_union] = ACTIONS(5617),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_explicit] = ACTIONS(5617),
    [anon_sym_typename] = ACTIONS(5617),
    [anon_sym_template] = ACTIONS(5617),
    [anon_sym_operator] = ACTIONS(5617),
    [anon_sym_friend] = ACTIONS(5617),
    [anon_sym_concept] = ACTIONS(5617),
  },
  [2292] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_TILDE] = ACTIONS(5619),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym___extension__] = ACTIONS(5617),
    [anon_sym_virtual] = ACTIONS(5617),
    [anon_sym_extern] = ACTIONS(5617),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_using] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5619),
    [anon_sym___declspec] = ACTIONS(5617),
    [anon_sym___based] = ACTIONS(5617),
    [anon_sym___cdecl] = ACTIONS(5617),
    [anon_sym___clrcall] = ACTIONS(5617),
    [anon_sym___stdcall] = ACTIONS(5617),
    [anon_sym___fastcall] = ACTIONS(5617),
    [anon_sym___thiscall] = ACTIONS(5617),
    [anon_sym___vectorcall] = ACTIONS(5617),
    [anon_sym_signed] = ACTIONS(5617),
    [anon_sym_unsigned] = ACTIONS(5617),
    [anon_sym_long] = ACTIONS(5617),
    [anon_sym_short] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5617),
    [anon_sym_static] = ACTIONS(5617),
    [anon_sym_register] = ACTIONS(5617),
    [anon_sym_inline] = ACTIONS(5617),
    [anon_sym___inline] = ACTIONS(5617),
    [anon_sym___inline__] = ACTIONS(5617),
    [anon_sym___forceinline] = ACTIONS(5617),
    [anon_sym_thread_local] = ACTIONS(5617),
    [anon_sym___thread] = ACTIONS(5617),
    [anon_sym_const] = ACTIONS(5617),
    [anon_sym_constexpr] = ACTIONS(5617),
    [anon_sym_volatile] = ACTIONS(5617),
    [anon_sym_restrict] = ACTIONS(5617),
    [anon_sym___restrict__] = ACTIONS(5617),
    [anon_sym__Atomic] = ACTIONS(5617),
    [anon_sym__Noreturn] = ACTIONS(5617),
    [anon_sym_noreturn] = ACTIONS(5617),
    [anon_sym__Nonnull] = ACTIONS(5617),
    [anon_sym_mutable] = ACTIONS(5617),
    [anon_sym_constinit] = ACTIONS(5617),
    [anon_sym_consteval] = ACTIONS(5617),
    [anon_sym_alignas] = ACTIONS(5617),
    [anon_sym__Alignas] = ACTIONS(5617),
    [sym_primitive_type] = ACTIONS(5617),
    [anon_sym_enum] = ACTIONS(5617),
    [anon_sym_class] = ACTIONS(5617),
    [anon_sym_struct] = ACTIONS(5617),
    [anon_sym_union] = ACTIONS(5617),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_explicit] = ACTIONS(5617),
    [anon_sym_typename] = ACTIONS(5617),
    [anon_sym_template] = ACTIONS(5617),
    [anon_sym_operator] = ACTIONS(5617),
    [anon_sym_friend] = ACTIONS(5617),
    [anon_sym_concept] = ACTIONS(5617),
  },
  [2293] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5072),
    [anon_sym_COMMA] = ACTIONS(5072),
    [aux_sym_preproc_if_token2] = ACTIONS(5072),
    [aux_sym_preproc_else_token1] = ACTIONS(5072),
    [aux_sym_preproc_elif_token1] = ACTIONS(5070),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_PLUS] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5070),
    [anon_sym_SLASH] = ACTIONS(5070),
    [anon_sym_PERCENT] = ACTIONS(5070),
    [anon_sym_PIPE_PIPE] = ACTIONS(5072),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5070),
    [anon_sym_CARET] = ACTIONS(5070),
    [anon_sym_AMP] = ACTIONS(5070),
    [anon_sym_EQ_EQ] = ACTIONS(5072),
    [anon_sym_BANG_EQ] = ACTIONS(5072),
    [anon_sym_GT] = ACTIONS(5070),
    [anon_sym_GT_EQ] = ACTIONS(5072),
    [anon_sym_LT_EQ] = ACTIONS(5070),
    [anon_sym_LT] = ACTIONS(5070),
    [anon_sym_LT_LT] = ACTIONS(5070),
    [anon_sym_GT_GT] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5070),
    [anon_sym___attribute] = ACTIONS(5070),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_signed] = ACTIONS(6292),
    [anon_sym_unsigned] = ACTIONS(6292),
    [anon_sym_long] = ACTIONS(6292),
    [anon_sym_short] = ACTIONS(6292),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_EQ] = ACTIONS(5070),
    [anon_sym_QMARK] = ACTIONS(5072),
    [anon_sym_STAR_EQ] = ACTIONS(5072),
    [anon_sym_SLASH_EQ] = ACTIONS(5072),
    [anon_sym_PERCENT_EQ] = ACTIONS(5072),
    [anon_sym_PLUS_EQ] = ACTIONS(5072),
    [anon_sym_DASH_EQ] = ACTIONS(5072),
    [anon_sym_LT_LT_EQ] = ACTIONS(5072),
    [anon_sym_GT_GT_EQ] = ACTIONS(5072),
    [anon_sym_AMP_EQ] = ACTIONS(5072),
    [anon_sym_CARET_EQ] = ACTIONS(5072),
    [anon_sym_PIPE_EQ] = ACTIONS(5072),
    [anon_sym_and_eq] = ACTIONS(5070),
    [anon_sym_or_eq] = ACTIONS(5070),
    [anon_sym_xor_eq] = ACTIONS(5070),
    [anon_sym_LT_EQ_GT] = ACTIONS(5072),
    [anon_sym_or] = ACTIONS(5070),
    [anon_sym_and] = ACTIONS(5070),
    [anon_sym_bitor] = ACTIONS(5070),
    [anon_sym_xor] = ACTIONS(5070),
    [anon_sym_bitand] = ACTIONS(5070),
    [anon_sym_not_eq] = ACTIONS(5070),
    [anon_sym_DASH_DASH] = ACTIONS(5072),
    [anon_sym_PLUS_PLUS] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5070),
    [anon_sym_DOT_STAR] = ACTIONS(5072),
    [anon_sym_DASH_GT] = ACTIONS(5072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5070),
    [anon_sym_decltype] = ACTIONS(5070),
  },
  [2294] = {
    [sym_identifier] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_RPAREN] = ACTIONS(5764),
    [aux_sym_preproc_if_token2] = ACTIONS(5764),
    [aux_sym_preproc_else_token1] = ACTIONS(5764),
    [aux_sym_preproc_elif_token1] = ACTIONS(5762),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5764),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5764),
    [anon_sym_LPAREN2] = ACTIONS(5764),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_AMP_AMP] = ACTIONS(5764),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(5764),
    [anon_sym_BANG_EQ] = ACTIONS(5764),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_SEMI] = ACTIONS(5764),
    [anon_sym___attribute__] = ACTIONS(5762),
    [anon_sym___attribute] = ACTIONS(5762),
    [anon_sym_COLON] = ACTIONS(5764),
    [anon_sym_LBRACE] = ACTIONS(5764),
    [anon_sym_RBRACE] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5764),
    [anon_sym_RBRACK] = ACTIONS(5764),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_QMARK] = ACTIONS(5764),
    [anon_sym_STAR_EQ] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_PERCENT_EQ] = ACTIONS(5764),
    [anon_sym_PLUS_EQ] = ACTIONS(5764),
    [anon_sym_DASH_EQ] = ACTIONS(5764),
    [anon_sym_LT_LT_EQ] = ACTIONS(5764),
    [anon_sym_GT_GT_EQ] = ACTIONS(5764),
    [anon_sym_AMP_EQ] = ACTIONS(5764),
    [anon_sym_CARET_EQ] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_and_eq] = ACTIONS(5762),
    [anon_sym_or_eq] = ACTIONS(5762),
    [anon_sym_xor_eq] = ACTIONS(5762),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_or] = ACTIONS(5762),
    [anon_sym_and] = ACTIONS(5762),
    [anon_sym_bitor] = ACTIONS(5762),
    [anon_sym_xor] = ACTIONS(5762),
    [anon_sym_bitand] = ACTIONS(5762),
    [anon_sym_not_eq] = ACTIONS(5762),
    [anon_sym_DASH_DASH] = ACTIONS(5764),
    [anon_sym_PLUS_PLUS] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DOT_STAR] = ACTIONS(5764),
    [anon_sym_DASH_GT] = ACTIONS(5764),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5762),
    [anon_sym_decltype] = ACTIONS(5762),
  },
  [2295] = {
    [sym_template_argument_list] = STATE(2338),
    [sym_identifier] = ACTIONS(4972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4965),
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [aux_sym_preproc_if_token2] = ACTIONS(4965),
    [aux_sym_preproc_else_token1] = ACTIONS(4965),
    [aux_sym_preproc_elif_token1] = ACTIONS(4972),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4965),
    [anon_sym_LPAREN2] = ACTIONS(4965),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4972),
    [anon_sym_PERCENT] = ACTIONS(4972),
    [anon_sym_PIPE_PIPE] = ACTIONS(4965),
    [anon_sym_AMP_AMP] = ACTIONS(4965),
    [anon_sym_PIPE] = ACTIONS(4972),
    [anon_sym_CARET] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4972),
    [anon_sym_EQ_EQ] = ACTIONS(4965),
    [anon_sym_BANG_EQ] = ACTIONS(4965),
    [anon_sym_GT] = ACTIONS(4972),
    [anon_sym_GT_EQ] = ACTIONS(4965),
    [anon_sym_LT_EQ] = ACTIONS(4972),
    [anon_sym_LT] = ACTIONS(5835),
    [anon_sym_LT_LT] = ACTIONS(4972),
    [anon_sym_GT_GT] = ACTIONS(4972),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym___attribute__] = ACTIONS(4972),
    [anon_sym___attribute] = ACTIONS(4972),
    [anon_sym_COLON] = ACTIONS(4972),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACK] = ACTIONS(4965),
    [anon_sym_EQ] = ACTIONS(4972),
    [anon_sym_QMARK] = ACTIONS(4965),
    [anon_sym_STAR_EQ] = ACTIONS(4965),
    [anon_sym_SLASH_EQ] = ACTIONS(4965),
    [anon_sym_PERCENT_EQ] = ACTIONS(4965),
    [anon_sym_PLUS_EQ] = ACTIONS(4965),
    [anon_sym_DASH_EQ] = ACTIONS(4965),
    [anon_sym_LT_LT_EQ] = ACTIONS(4965),
    [anon_sym_GT_GT_EQ] = ACTIONS(4965),
    [anon_sym_AMP_EQ] = ACTIONS(4965),
    [anon_sym_CARET_EQ] = ACTIONS(4965),
    [anon_sym_PIPE_EQ] = ACTIONS(4965),
    [anon_sym_and_eq] = ACTIONS(4972),
    [anon_sym_or_eq] = ACTIONS(4972),
    [anon_sym_xor_eq] = ACTIONS(4972),
    [anon_sym_LT_EQ_GT] = ACTIONS(4965),
    [anon_sym_or] = ACTIONS(4972),
    [anon_sym_and] = ACTIONS(4972),
    [anon_sym_bitor] = ACTIONS(4972),
    [anon_sym_xor] = ACTIONS(4972),
    [anon_sym_bitand] = ACTIONS(4972),
    [anon_sym_not_eq] = ACTIONS(4972),
    [anon_sym_DASH_DASH] = ACTIONS(4965),
    [anon_sym_PLUS_PLUS] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4972),
    [anon_sym_DOT_STAR] = ACTIONS(4965),
    [anon_sym_DASH_GT] = ACTIONS(4965),
    [sym_comment] = ACTIONS(3),
  },
  [2296] = {
    [sym_identifier] = ACTIONS(5617),
    [anon_sym_LPAREN2] = ACTIONS(5619),
    [anon_sym_TILDE] = ACTIONS(5619),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(5617),
    [anon_sym___extension__] = ACTIONS(5617),
    [anon_sym_virtual] = ACTIONS(5617),
    [anon_sym_extern] = ACTIONS(5617),
    [anon_sym___attribute__] = ACTIONS(5617),
    [anon_sym___attribute] = ACTIONS(5617),
    [anon_sym_using] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5619),
    [anon_sym___declspec] = ACTIONS(5617),
    [anon_sym___based] = ACTIONS(5617),
    [anon_sym___cdecl] = ACTIONS(5617),
    [anon_sym___clrcall] = ACTIONS(5617),
    [anon_sym___stdcall] = ACTIONS(5617),
    [anon_sym___fastcall] = ACTIONS(5617),
    [anon_sym___thiscall] = ACTIONS(5617),
    [anon_sym___vectorcall] = ACTIONS(5617),
    [anon_sym_signed] = ACTIONS(5617),
    [anon_sym_unsigned] = ACTIONS(5617),
    [anon_sym_long] = ACTIONS(5617),
    [anon_sym_short] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5617),
    [anon_sym_static] = ACTIONS(5617),
    [anon_sym_register] = ACTIONS(5617),
    [anon_sym_inline] = ACTIONS(5617),
    [anon_sym___inline] = ACTIONS(5617),
    [anon_sym___inline__] = ACTIONS(5617),
    [anon_sym___forceinline] = ACTIONS(5617),
    [anon_sym_thread_local] = ACTIONS(5617),
    [anon_sym___thread] = ACTIONS(5617),
    [anon_sym_const] = ACTIONS(5617),
    [anon_sym_constexpr] = ACTIONS(5617),
    [anon_sym_volatile] = ACTIONS(5617),
    [anon_sym_restrict] = ACTIONS(5617),
    [anon_sym___restrict__] = ACTIONS(5617),
    [anon_sym__Atomic] = ACTIONS(5617),
    [anon_sym__Noreturn] = ACTIONS(5617),
    [anon_sym_noreturn] = ACTIONS(5617),
    [anon_sym__Nonnull] = ACTIONS(5617),
    [anon_sym_mutable] = ACTIONS(5617),
    [anon_sym_constinit] = ACTIONS(5617),
    [anon_sym_consteval] = ACTIONS(5617),
    [anon_sym_alignas] = ACTIONS(5617),
    [anon_sym__Alignas] = ACTIONS(5617),
    [sym_primitive_type] = ACTIONS(5617),
    [anon_sym_enum] = ACTIONS(5617),
    [anon_sym_class] = ACTIONS(5617),
    [anon_sym_struct] = ACTIONS(5617),
    [anon_sym_union] = ACTIONS(5617),
    [anon_sym_or] = ACTIONS(5617),
    [anon_sym_and] = ACTIONS(5617),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5617),
    [anon_sym_decltype] = ACTIONS(5617),
    [anon_sym_explicit] = ACTIONS(5617),
    [anon_sym_typename] = ACTIONS(5617),
    [anon_sym_template] = ACTIONS(5617),
    [anon_sym_operator] = ACTIONS(5617),
    [anon_sym_friend] = ACTIONS(5617),
    [anon_sym_concept] = ACTIONS(5617),
  },
  [2297] = {
    [sym_string_literal] = STATE(1992),
    [sym_raw_string_literal] = STATE(1992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_COMMA] = ACTIONS(5914),
    [anon_sym_LPAREN2] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5912),
    [anon_sym_STAR] = ACTIONS(5912),
    [anon_sym_SLASH] = ACTIONS(5912),
    [anon_sym_PERCENT] = ACTIONS(5912),
    [anon_sym_PIPE_PIPE] = ACTIONS(5914),
    [anon_sym_AMP_AMP] = ACTIONS(5914),
    [anon_sym_PIPE] = ACTIONS(5912),
    [anon_sym_CARET] = ACTIONS(5912),
    [anon_sym_AMP] = ACTIONS(5912),
    [anon_sym_EQ_EQ] = ACTIONS(5914),
    [anon_sym_BANG_EQ] = ACTIONS(5914),
    [anon_sym_GT] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5912),
    [anon_sym_LT_LT] = ACTIONS(5912),
    [anon_sym_GT_GT] = ACTIONS(5912),
    [anon_sym_SEMI] = ACTIONS(5914),
    [anon_sym___attribute__] = ACTIONS(5912),
    [anon_sym___attribute] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5912),
    [anon_sym_QMARK] = ACTIONS(5914),
    [anon_sym_STAR_EQ] = ACTIONS(5914),
    [anon_sym_SLASH_EQ] = ACTIONS(5914),
    [anon_sym_PERCENT_EQ] = ACTIONS(5914),
    [anon_sym_PLUS_EQ] = ACTIONS(5914),
    [anon_sym_DASH_EQ] = ACTIONS(5914),
    [anon_sym_LT_LT_EQ] = ACTIONS(5914),
    [anon_sym_GT_GT_EQ] = ACTIONS(5914),
    [anon_sym_AMP_EQ] = ACTIONS(5914),
    [anon_sym_CARET_EQ] = ACTIONS(5914),
    [anon_sym_PIPE_EQ] = ACTIONS(5914),
    [anon_sym_and_eq] = ACTIONS(5912),
    [anon_sym_or_eq] = ACTIONS(5912),
    [anon_sym_xor_eq] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5914),
    [anon_sym_or] = ACTIONS(5912),
    [anon_sym_and] = ACTIONS(5912),
    [anon_sym_bitor] = ACTIONS(5912),
    [anon_sym_xor] = ACTIONS(5912),
    [anon_sym_bitand] = ACTIONS(5912),
    [anon_sym_not_eq] = ACTIONS(5912),
    [anon_sym_DASH_DASH] = ACTIONS(5914),
    [anon_sym_PLUS_PLUS] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5912),
    [anon_sym_DOT_STAR] = ACTIONS(5914),
    [anon_sym_DASH_GT] = ACTIONS(5914),
    [anon_sym_L_DQUOTE] = ACTIONS(5954),
    [anon_sym_u_DQUOTE] = ACTIONS(5954),
    [anon_sym_U_DQUOTE] = ACTIONS(5954),
    [anon_sym_u8_DQUOTE] = ACTIONS(5954),
    [anon_sym_DQUOTE] = ACTIONS(5954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5956),
    [anon_sym_LR_DQUOTE] = ACTIONS(5956),
    [anon_sym_uR_DQUOTE] = ACTIONS(5956),
    [anon_sym_UR_DQUOTE] = ACTIONS(5956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5956),
    [sym_literal_suffix] = ACTIONS(5912),
  },
  [2298] = {
    [sym_identifier] = ACTIONS(6295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6297),
    [anon_sym_COMMA] = ACTIONS(6297),
    [anon_sym_RPAREN] = ACTIONS(6297),
    [aux_sym_preproc_if_token2] = ACTIONS(6297),
    [aux_sym_preproc_else_token1] = ACTIONS(6297),
    [aux_sym_preproc_elif_token1] = ACTIONS(6295),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6297),
    [anon_sym_LPAREN2] = ACTIONS(6297),
    [anon_sym_DASH] = ACTIONS(6295),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_STAR] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6295),
    [anon_sym_PERCENT] = ACTIONS(6295),
    [anon_sym_PIPE_PIPE] = ACTIONS(6297),
    [anon_sym_AMP_AMP] = ACTIONS(6297),
    [anon_sym_PIPE] = ACTIONS(6295),
    [anon_sym_CARET] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6295),
    [anon_sym_EQ_EQ] = ACTIONS(6297),
    [anon_sym_BANG_EQ] = ACTIONS(6297),
    [anon_sym_GT] = ACTIONS(6295),
    [anon_sym_GT_EQ] = ACTIONS(6297),
    [anon_sym_LT_EQ] = ACTIONS(6295),
    [anon_sym_LT] = ACTIONS(6295),
    [anon_sym_LT_LT] = ACTIONS(6295),
    [anon_sym_GT_GT] = ACTIONS(6295),
    [anon_sym_SEMI] = ACTIONS(6297),
    [anon_sym___attribute__] = ACTIONS(6295),
    [anon_sym___attribute] = ACTIONS(6295),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6297),
    [anon_sym_LBRACE] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(6295),
    [anon_sym_RBRACK] = ACTIONS(6297),
    [anon_sym_EQ] = ACTIONS(6295),
    [anon_sym_QMARK] = ACTIONS(6297),
    [anon_sym_STAR_EQ] = ACTIONS(6297),
    [anon_sym_SLASH_EQ] = ACTIONS(6297),
    [anon_sym_PERCENT_EQ] = ACTIONS(6297),
    [anon_sym_PLUS_EQ] = ACTIONS(6297),
    [anon_sym_DASH_EQ] = ACTIONS(6297),
    [anon_sym_LT_LT_EQ] = ACTIONS(6297),
    [anon_sym_GT_GT_EQ] = ACTIONS(6297),
    [anon_sym_AMP_EQ] = ACTIONS(6297),
    [anon_sym_CARET_EQ] = ACTIONS(6297),
    [anon_sym_PIPE_EQ] = ACTIONS(6297),
    [anon_sym_and_eq] = ACTIONS(6295),
    [anon_sym_or_eq] = ACTIONS(6295),
    [anon_sym_xor_eq] = ACTIONS(6295),
    [anon_sym_LT_EQ_GT] = ACTIONS(6297),
    [anon_sym_or] = ACTIONS(6295),
    [anon_sym_and] = ACTIONS(6295),
    [anon_sym_bitor] = ACTIONS(6295),
    [anon_sym_xor] = ACTIONS(6295),
    [anon_sym_bitand] = ACTIONS(6295),
    [anon_sym_not_eq] = ACTIONS(6295),
    [anon_sym_DASH_DASH] = ACTIONS(6297),
    [anon_sym_PLUS_PLUS] = ACTIONS(6297),
    [anon_sym_DOT] = ACTIONS(6295),
    [anon_sym_DOT_STAR] = ACTIONS(6297),
    [anon_sym_DASH_GT] = ACTIONS(6297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6295),
  },
  [2299] = {
    [sym_identifier] = ACTIONS(5766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_RPAREN] = ACTIONS(5768),
    [aux_sym_preproc_if_token2] = ACTIONS(5768),
    [aux_sym_preproc_else_token1] = ACTIONS(5768),
    [aux_sym_preproc_elif_token1] = ACTIONS(5766),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5768),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5768),
    [anon_sym_LPAREN2] = ACTIONS(5768),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_PLUS] = ACTIONS(5766),
    [anon_sym_STAR] = ACTIONS(5766),
    [anon_sym_SLASH] = ACTIONS(5766),
    [anon_sym_PERCENT] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_AMP_AMP] = ACTIONS(5768),
    [anon_sym_PIPE] = ACTIONS(5766),
    [anon_sym_CARET] = ACTIONS(5766),
    [anon_sym_AMP] = ACTIONS(5766),
    [anon_sym_EQ_EQ] = ACTIONS(5768),
    [anon_sym_BANG_EQ] = ACTIONS(5768),
    [anon_sym_GT] = ACTIONS(5766),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_LT] = ACTIONS(5766),
    [anon_sym_LT_LT] = ACTIONS(5766),
    [anon_sym_GT_GT] = ACTIONS(5766),
    [anon_sym_SEMI] = ACTIONS(5768),
    [anon_sym___attribute__] = ACTIONS(5766),
    [anon_sym___attribute] = ACTIONS(5766),
    [anon_sym_COLON] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(5768),
    [anon_sym_RBRACE] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5768),
    [anon_sym_RBRACK] = ACTIONS(5768),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_QMARK] = ACTIONS(5768),
    [anon_sym_STAR_EQ] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_PERCENT_EQ] = ACTIONS(5768),
    [anon_sym_PLUS_EQ] = ACTIONS(5768),
    [anon_sym_DASH_EQ] = ACTIONS(5768),
    [anon_sym_LT_LT_EQ] = ACTIONS(5768),
    [anon_sym_GT_GT_EQ] = ACTIONS(5768),
    [anon_sym_AMP_EQ] = ACTIONS(5768),
    [anon_sym_CARET_EQ] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_and_eq] = ACTIONS(5766),
    [anon_sym_or_eq] = ACTIONS(5766),
    [anon_sym_xor_eq] = ACTIONS(5766),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_or] = ACTIONS(5766),
    [anon_sym_and] = ACTIONS(5766),
    [anon_sym_bitor] = ACTIONS(5766),
    [anon_sym_xor] = ACTIONS(5766),
    [anon_sym_bitand] = ACTIONS(5766),
    [anon_sym_not_eq] = ACTIONS(5766),
    [anon_sym_DASH_DASH] = ACTIONS(5768),
    [anon_sym_PLUS_PLUS] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_DOT_STAR] = ACTIONS(5768),
    [anon_sym_DASH_GT] = ACTIONS(5768),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5766),
    [anon_sym_decltype] = ACTIONS(5766),
  },
  [2300] = {
    [sym_string_literal] = STATE(2624),
    [sym_template_argument_list] = STATE(3588),
    [sym_raw_string_literal] = STATE(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4154),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4146),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4154),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4154),
    [anon_sym_EQ_EQ] = ACTIONS(4146),
    [anon_sym_BANG_EQ] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4154),
    [anon_sym_GT_EQ] = ACTIONS(4146),
    [anon_sym_LT_EQ] = ACTIONS(4154),
    [anon_sym_LT] = ACTIONS(5077),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_RBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(6113),
    [anon_sym_QMARK] = ACTIONS(4146),
    [anon_sym_STAR_EQ] = ACTIONS(6082),
    [anon_sym_SLASH_EQ] = ACTIONS(6082),
    [anon_sym_PERCENT_EQ] = ACTIONS(6082),
    [anon_sym_PLUS_EQ] = ACTIONS(6082),
    [anon_sym_DASH_EQ] = ACTIONS(6082),
    [anon_sym_LT_LT_EQ] = ACTIONS(6082),
    [anon_sym_GT_GT_EQ] = ACTIONS(6082),
    [anon_sym_AMP_EQ] = ACTIONS(6082),
    [anon_sym_CARET_EQ] = ACTIONS(6082),
    [anon_sym_PIPE_EQ] = ACTIONS(6082),
    [anon_sym_and_eq] = ACTIONS(6082),
    [anon_sym_or_eq] = ACTIONS(6082),
    [anon_sym_xor_eq] = ACTIONS(6082),
    [anon_sym_LT_EQ_GT] = ACTIONS(4146),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4146),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4146),
    [anon_sym_not_eq] = ACTIONS(4146),
    [anon_sym_DASH_DASH] = ACTIONS(4146),
    [anon_sym_PLUS_PLUS] = ACTIONS(4146),
    [anon_sym_DOT] = ACTIONS(4154),
    [anon_sym_DOT_STAR] = ACTIONS(4146),
    [anon_sym_DASH_GT] = ACTIONS(4146),
    [anon_sym_L_DQUOTE] = ACTIONS(3623),
    [anon_sym_u_DQUOTE] = ACTIONS(3623),
    [anon_sym_U_DQUOTE] = ACTIONS(3623),
    [anon_sym_u8_DQUOTE] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3627),
    [anon_sym_LR_DQUOTE] = ACTIONS(3627),
    [anon_sym_uR_DQUOTE] = ACTIONS(3627),
    [anon_sym_UR_DQUOTE] = ACTIONS(3627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3627),
  },
  [2301] = {
    [sym_string_literal] = STATE(2301),
    [sym_raw_string_literal] = STATE(2301),
    [aux_sym_concatenated_string_repeat1] = STATE(2301),
    [sym_identifier] = ACTIONS(6299),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_LPAREN2] = ACTIONS(5403),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5405),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5405),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_CARET] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_GT_EQ] = ACTIONS(5405),
    [anon_sym_LT_EQ] = ACTIONS(5405),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5405),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_EQ] = ACTIONS(5405),
    [anon_sym_QMARK] = ACTIONS(5403),
    [anon_sym_STAR_EQ] = ACTIONS(5403),
    [anon_sym_SLASH_EQ] = ACTIONS(5403),
    [anon_sym_PERCENT_EQ] = ACTIONS(5403),
    [anon_sym_PLUS_EQ] = ACTIONS(5403),
    [anon_sym_DASH_EQ] = ACTIONS(5403),
    [anon_sym_LT_LT_EQ] = ACTIONS(5403),
    [anon_sym_GT_GT_EQ] = ACTIONS(5405),
    [anon_sym_AMP_EQ] = ACTIONS(5403),
    [anon_sym_CARET_EQ] = ACTIONS(5403),
    [anon_sym_PIPE_EQ] = ACTIONS(5403),
    [anon_sym_and_eq] = ACTIONS(5405),
    [anon_sym_or_eq] = ACTIONS(5405),
    [anon_sym_xor_eq] = ACTIONS(5405),
    [anon_sym_LT_EQ_GT] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5405),
    [anon_sym_and] = ACTIONS(5405),
    [anon_sym_bitor] = ACTIONS(5405),
    [anon_sym_xor] = ACTIONS(5405),
    [anon_sym_bitand] = ACTIONS(5405),
    [anon_sym_not_eq] = ACTIONS(5405),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_DOT_STAR] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5403),
    [anon_sym_L_DQUOTE] = ACTIONS(6302),
    [anon_sym_u_DQUOTE] = ACTIONS(6302),
    [anon_sym_U_DQUOTE] = ACTIONS(6302),
    [anon_sym_u8_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(6305),
    [anon_sym_LR_DQUOTE] = ACTIONS(6305),
    [anon_sym_uR_DQUOTE] = ACTIONS(6305),
    [anon_sym_UR_DQUOTE] = ACTIONS(6305),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6305),
    [sym_literal_suffix] = ACTIONS(5405),
  },
  [2302] = {
    [sym_identifier] = ACTIONS(5770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_RPAREN] = ACTIONS(5772),
    [aux_sym_preproc_if_token2] = ACTIONS(5772),
    [aux_sym_preproc_else_token1] = ACTIONS(5772),
    [aux_sym_preproc_elif_token1] = ACTIONS(5770),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5772),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5772),
    [anon_sym_LPAREN2] = ACTIONS(5772),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_PLUS] = ACTIONS(5770),
    [anon_sym_STAR] = ACTIONS(5770),
    [anon_sym_SLASH] = ACTIONS(5770),
    [anon_sym_PERCENT] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_AMP_AMP] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5770),
    [anon_sym_CARET] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5770),
    [anon_sym_EQ_EQ] = ACTIONS(5772),
    [anon_sym_BANG_EQ] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5770),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5770),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym___attribute__] = ACTIONS(5770),
    [anon_sym___attribute] = ACTIONS(5770),
    [anon_sym_COLON] = ACTIONS(5772),
    [anon_sym_LBRACE] = ACTIONS(5772),
    [anon_sym_RBRACE] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5772),
    [anon_sym_RBRACK] = ACTIONS(5772),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_QMARK] = ACTIONS(5772),
    [anon_sym_STAR_EQ] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_PERCENT_EQ] = ACTIONS(5772),
    [anon_sym_PLUS_EQ] = ACTIONS(5772),
    [anon_sym_DASH_EQ] = ACTIONS(5772),
    [anon_sym_LT_LT_EQ] = ACTIONS(5772),
    [anon_sym_GT_GT_EQ] = ACTIONS(5772),
    [anon_sym_AMP_EQ] = ACTIONS(5772),
    [anon_sym_CARET_EQ] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_and_eq] = ACTIONS(5770),
    [anon_sym_or_eq] = ACTIONS(5770),
    [anon_sym_xor_eq] = ACTIONS(5770),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_or] = ACTIONS(5770),
    [anon_sym_and] = ACTIONS(5770),
    [anon_sym_bitor] = ACTIONS(5770),
    [anon_sym_xor] = ACTIONS(5770),
    [anon_sym_bitand] = ACTIONS(5770),
    [anon_sym_not_eq] = ACTIONS(5770),
    [anon_sym_DASH_DASH] = ACTIONS(5772),
    [anon_sym_PLUS_PLUS] = ACTIONS(5772),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_DOT_STAR] = ACTIONS(5772),
    [anon_sym_DASH_GT] = ACTIONS(5772),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5770),
    [anon_sym_decltype] = ACTIONS(5770),
  },
  [2303] = {
    [sym_identifier] = ACTIONS(5774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5776),
    [anon_sym_COMMA] = ACTIONS(5776),
    [anon_sym_RPAREN] = ACTIONS(5776),
    [aux_sym_preproc_if_token2] = ACTIONS(5776),
    [aux_sym_preproc_else_token1] = ACTIONS(5776),
    [aux_sym_preproc_elif_token1] = ACTIONS(5774),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5776),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5776),
    [anon_sym_LPAREN2] = ACTIONS(5776),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_PLUS] = ACTIONS(5774),
    [anon_sym_STAR] = ACTIONS(5774),
    [anon_sym_SLASH] = ACTIONS(5774),
    [anon_sym_PERCENT] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5776),
    [anon_sym_AMP_AMP] = ACTIONS(5776),
    [anon_sym_PIPE] = ACTIONS(5774),
    [anon_sym_CARET] = ACTIONS(5774),
    [anon_sym_AMP] = ACTIONS(5774),
    [anon_sym_EQ_EQ] = ACTIONS(5776),
    [anon_sym_BANG_EQ] = ACTIONS(5776),
    [anon_sym_GT] = ACTIONS(5774),
    [anon_sym_GT_EQ] = ACTIONS(5776),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_LT] = ACTIONS(5774),
    [anon_sym_LT_LT] = ACTIONS(5774),
    [anon_sym_GT_GT] = ACTIONS(5774),
    [anon_sym_SEMI] = ACTIONS(5776),
    [anon_sym___attribute__] = ACTIONS(5774),
    [anon_sym___attribute] = ACTIONS(5774),
    [anon_sym_COLON] = ACTIONS(5776),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_RBRACE] = ACTIONS(5776),
    [anon_sym_LBRACK] = ACTIONS(5776),
    [anon_sym_RBRACK] = ACTIONS(5776),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_QMARK] = ACTIONS(5776),
    [anon_sym_STAR_EQ] = ACTIONS(5776),
    [anon_sym_SLASH_EQ] = ACTIONS(5776),
    [anon_sym_PERCENT_EQ] = ACTIONS(5776),
    [anon_sym_PLUS_EQ] = ACTIONS(5776),
    [anon_sym_DASH_EQ] = ACTIONS(5776),
    [anon_sym_LT_LT_EQ] = ACTIONS(5776),
    [anon_sym_GT_GT_EQ] = ACTIONS(5776),
    [anon_sym_AMP_EQ] = ACTIONS(5776),
    [anon_sym_CARET_EQ] = ACTIONS(5776),
    [anon_sym_PIPE_EQ] = ACTIONS(5776),
    [anon_sym_and_eq] = ACTIONS(5774),
    [anon_sym_or_eq] = ACTIONS(5774),
    [anon_sym_xor_eq] = ACTIONS(5774),
    [anon_sym_LT_EQ_GT] = ACTIONS(5776),
    [anon_sym_or] = ACTIONS(5774),
    [anon_sym_and] = ACTIONS(5774),
    [anon_sym_bitor] = ACTIONS(5774),
    [anon_sym_xor] = ACTIONS(5774),
    [anon_sym_bitand] = ACTIONS(5774),
    [anon_sym_not_eq] = ACTIONS(5774),
    [anon_sym_DASH_DASH] = ACTIONS(5776),
    [anon_sym_PLUS_PLUS] = ACTIONS(5776),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_DOT_STAR] = ACTIONS(5776),
    [anon_sym_DASH_GT] = ACTIONS(5776),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5774),
    [anon_sym_decltype] = ACTIONS(5774),
  },
  [2304] = {
    [sym_identifier] = ACTIONS(4955),
    [anon_sym_LPAREN2] = ACTIONS(4957),
    [anon_sym_TILDE] = ACTIONS(4957),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_PIPE_PIPE] = ACTIONS(4957),
    [anon_sym_AMP_AMP] = ACTIONS(4957),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym___extension__] = ACTIONS(4955),
    [anon_sym_virtual] = ACTIONS(4955),
    [anon_sym_extern] = ACTIONS(4955),
    [anon_sym___attribute__] = ACTIONS(4955),
    [anon_sym___attribute] = ACTIONS(4955),
    [anon_sym_using] = ACTIONS(4955),
    [anon_sym_COLON_COLON] = ACTIONS(4957),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4957),
    [anon_sym___declspec] = ACTIONS(4955),
    [anon_sym___based] = ACTIONS(4955),
    [anon_sym___cdecl] = ACTIONS(4955),
    [anon_sym___clrcall] = ACTIONS(4955),
    [anon_sym___stdcall] = ACTIONS(4955),
    [anon_sym___fastcall] = ACTIONS(4955),
    [anon_sym___thiscall] = ACTIONS(4955),
    [anon_sym___vectorcall] = ACTIONS(4955),
    [anon_sym_signed] = ACTIONS(4955),
    [anon_sym_unsigned] = ACTIONS(4955),
    [anon_sym_long] = ACTIONS(4955),
    [anon_sym_short] = ACTIONS(4955),
    [anon_sym_LBRACK] = ACTIONS(4955),
    [anon_sym_static] = ACTIONS(4955),
    [anon_sym_register] = ACTIONS(4955),
    [anon_sym_inline] = ACTIONS(4955),
    [anon_sym___inline] = ACTIONS(4955),
    [anon_sym___inline__] = ACTIONS(4955),
    [anon_sym___forceinline] = ACTIONS(4955),
    [anon_sym_thread_local] = ACTIONS(4955),
    [anon_sym___thread] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_constexpr] = ACTIONS(4955),
    [anon_sym_volatile] = ACTIONS(4955),
    [anon_sym_restrict] = ACTIONS(4955),
    [anon_sym___restrict__] = ACTIONS(4955),
    [anon_sym__Atomic] = ACTIONS(4955),
    [anon_sym__Noreturn] = ACTIONS(4955),
    [anon_sym_noreturn] = ACTIONS(4955),
    [anon_sym__Nonnull] = ACTIONS(4955),
    [anon_sym_mutable] = ACTIONS(4955),
    [anon_sym_constinit] = ACTIONS(4955),
    [anon_sym_consteval] = ACTIONS(4955),
    [anon_sym_alignas] = ACTIONS(4955),
    [anon_sym__Alignas] = ACTIONS(4955),
    [sym_primitive_type] = ACTIONS(4955),
    [anon_sym_enum] = ACTIONS(4955),
    [anon_sym_class] = ACTIONS(4955),
    [anon_sym_struct] = ACTIONS(4955),
    [anon_sym_union] = ACTIONS(4955),
    [anon_sym_or] = ACTIONS(4955),
    [anon_sym_and] = ACTIONS(4955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4955),
    [anon_sym_decltype] = ACTIONS(4955),
    [anon_sym_explicit] = ACTIONS(4955),
    [anon_sym_typename] = ACTIONS(4955),
    [anon_sym_template] = ACTIONS(4955),
    [anon_sym_operator] = ACTIONS(4955),
    [anon_sym_friend] = ACTIONS(4955),
    [anon_sym_concept] = ACTIONS(4955),
  },
  [2305] = {
    [sym_identifier] = ACTIONS(4984),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_STAR] = ACTIONS(4986),
    [anon_sym_PIPE_PIPE] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4984),
    [anon_sym_virtual] = ACTIONS(4984),
    [anon_sym_extern] = ACTIONS(4984),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_using] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4986),
    [anon_sym___declspec] = ACTIONS(4984),
    [anon_sym___based] = ACTIONS(4984),
    [anon_sym___cdecl] = ACTIONS(4984),
    [anon_sym___clrcall] = ACTIONS(4984),
    [anon_sym___stdcall] = ACTIONS(4984),
    [anon_sym___fastcall] = ACTIONS(4984),
    [anon_sym___thiscall] = ACTIONS(4984),
    [anon_sym___vectorcall] = ACTIONS(4984),
    [anon_sym_signed] = ACTIONS(4984),
    [anon_sym_unsigned] = ACTIONS(4984),
    [anon_sym_long] = ACTIONS(4984),
    [anon_sym_short] = ACTIONS(4984),
    [anon_sym_LBRACK] = ACTIONS(4984),
    [anon_sym_static] = ACTIONS(4984),
    [anon_sym_register] = ACTIONS(4984),
    [anon_sym_inline] = ACTIONS(4984),
    [anon_sym___inline] = ACTIONS(4984),
    [anon_sym___inline__] = ACTIONS(4984),
    [anon_sym___forceinline] = ACTIONS(4984),
    [anon_sym_thread_local] = ACTIONS(4984),
    [anon_sym___thread] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym___restrict__] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym__Noreturn] = ACTIONS(4984),
    [anon_sym_noreturn] = ACTIONS(4984),
    [anon_sym__Nonnull] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_constinit] = ACTIONS(4984),
    [anon_sym_consteval] = ACTIONS(4984),
    [anon_sym_alignas] = ACTIONS(4984),
    [anon_sym__Alignas] = ACTIONS(4984),
    [sym_primitive_type] = ACTIONS(4984),
    [anon_sym_enum] = ACTIONS(4984),
    [anon_sym_class] = ACTIONS(4984),
    [anon_sym_struct] = ACTIONS(4984),
    [anon_sym_union] = ACTIONS(4984),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_explicit] = ACTIONS(4984),
    [anon_sym_typename] = ACTIONS(4984),
    [anon_sym_template] = ACTIONS(4984),
    [anon_sym_operator] = ACTIONS(4984),
    [anon_sym_friend] = ACTIONS(4984),
    [anon_sym_concept] = ACTIONS(4984),
  },
  [2306] = {
    [sym_identifier] = ACTIONS(4980),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(4982),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym___extension__] = ACTIONS(4980),
    [anon_sym_virtual] = ACTIONS(4980),
    [anon_sym_extern] = ACTIONS(4980),
    [anon_sym___attribute__] = ACTIONS(4980),
    [anon_sym___attribute] = ACTIONS(4980),
    [anon_sym_using] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4982),
    [anon_sym___declspec] = ACTIONS(4980),
    [anon_sym___based] = ACTIONS(4980),
    [anon_sym___cdecl] = ACTIONS(4980),
    [anon_sym___clrcall] = ACTIONS(4980),
    [anon_sym___stdcall] = ACTIONS(4980),
    [anon_sym___fastcall] = ACTIONS(4980),
    [anon_sym___thiscall] = ACTIONS(4980),
    [anon_sym___vectorcall] = ACTIONS(4980),
    [anon_sym_signed] = ACTIONS(4980),
    [anon_sym_unsigned] = ACTIONS(4980),
    [anon_sym_long] = ACTIONS(4980),
    [anon_sym_short] = ACTIONS(4980),
    [anon_sym_LBRACK] = ACTIONS(4980),
    [anon_sym_static] = ACTIONS(4980),
    [anon_sym_register] = ACTIONS(4980),
    [anon_sym_inline] = ACTIONS(4980),
    [anon_sym___inline] = ACTIONS(4980),
    [anon_sym___inline__] = ACTIONS(4980),
    [anon_sym___forceinline] = ACTIONS(4980),
    [anon_sym_thread_local] = ACTIONS(4980),
    [anon_sym___thread] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4980),
    [anon_sym_volatile] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4980),
    [anon_sym___restrict__] = ACTIONS(4980),
    [anon_sym__Atomic] = ACTIONS(4980),
    [anon_sym__Noreturn] = ACTIONS(4980),
    [anon_sym_noreturn] = ACTIONS(4980),
    [anon_sym__Nonnull] = ACTIONS(4980),
    [anon_sym_mutable] = ACTIONS(4980),
    [anon_sym_constinit] = ACTIONS(4980),
    [anon_sym_consteval] = ACTIONS(4980),
    [anon_sym_alignas] = ACTIONS(4980),
    [anon_sym__Alignas] = ACTIONS(4980),
    [sym_primitive_type] = ACTIONS(4980),
    [anon_sym_enum] = ACTIONS(4980),
    [anon_sym_class] = ACTIONS(4980),
    [anon_sym_struct] = ACTIONS(4980),
    [anon_sym_union] = ACTIONS(4980),
    [anon_sym_or] = ACTIONS(4980),
    [anon_sym_and] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4980),
    [anon_sym_decltype] = ACTIONS(4980),
    [anon_sym_explicit] = ACTIONS(4980),
    [anon_sym_typename] = ACTIONS(4980),
    [anon_sym_template] = ACTIONS(4980),
    [anon_sym_operator] = ACTIONS(4980),
    [anon_sym_friend] = ACTIONS(4980),
    [anon_sym_concept] = ACTIONS(4980),
  },
  [2307] = {
    [sym_identifier] = ACTIONS(4992),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_TILDE] = ACTIONS(4994),
    [anon_sym_STAR] = ACTIONS(4994),
    [anon_sym_PIPE_PIPE] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym___extension__] = ACTIONS(4992),
    [anon_sym_virtual] = ACTIONS(4992),
    [anon_sym_extern] = ACTIONS(4992),
    [anon_sym___attribute__] = ACTIONS(4992),
    [anon_sym___attribute] = ACTIONS(4992),
    [anon_sym_using] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4994),
    [anon_sym___declspec] = ACTIONS(4992),
    [anon_sym___based] = ACTIONS(4992),
    [anon_sym___cdecl] = ACTIONS(4992),
    [anon_sym___clrcall] = ACTIONS(4992),
    [anon_sym___stdcall] = ACTIONS(4992),
    [anon_sym___fastcall] = ACTIONS(4992),
    [anon_sym___thiscall] = ACTIONS(4992),
    [anon_sym___vectorcall] = ACTIONS(4992),
    [anon_sym_signed] = ACTIONS(4992),
    [anon_sym_unsigned] = ACTIONS(4992),
    [anon_sym_long] = ACTIONS(4992),
    [anon_sym_short] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4992),
    [anon_sym_static] = ACTIONS(4992),
    [anon_sym_register] = ACTIONS(4992),
    [anon_sym_inline] = ACTIONS(4992),
    [anon_sym___inline] = ACTIONS(4992),
    [anon_sym___inline__] = ACTIONS(4992),
    [anon_sym___forceinline] = ACTIONS(4992),
    [anon_sym_thread_local] = ACTIONS(4992),
    [anon_sym___thread] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym___restrict__] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym__Noreturn] = ACTIONS(4992),
    [anon_sym_noreturn] = ACTIONS(4992),
    [anon_sym__Nonnull] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_constinit] = ACTIONS(4992),
    [anon_sym_consteval] = ACTIONS(4992),
    [anon_sym_alignas] = ACTIONS(4992),
    [anon_sym__Alignas] = ACTIONS(4992),
    [sym_primitive_type] = ACTIONS(4992),
    [anon_sym_enum] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(4992),
    [anon_sym_struct] = ACTIONS(4992),
    [anon_sym_union] = ACTIONS(4992),
    [anon_sym_or] = ACTIONS(4992),
    [anon_sym_and] = ACTIONS(4992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_decltype] = ACTIONS(4992),
    [anon_sym_explicit] = ACTIONS(4992),
    [anon_sym_typename] = ACTIONS(4992),
    [anon_sym_template] = ACTIONS(4992),
    [anon_sym_operator] = ACTIONS(4992),
    [anon_sym_friend] = ACTIONS(4992),
    [anon_sym_concept] = ACTIONS(4992),
  },
  [2308] = {
    [sym_identifier] = ACTIONS(4951),
    [anon_sym_LPAREN2] = ACTIONS(4953),
    [anon_sym_TILDE] = ACTIONS(4953),
    [anon_sym_STAR] = ACTIONS(4953),
    [anon_sym_PIPE_PIPE] = ACTIONS(4953),
    [anon_sym_AMP_AMP] = ACTIONS(4953),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym___extension__] = ACTIONS(4951),
    [anon_sym_virtual] = ACTIONS(4951),
    [anon_sym_extern] = ACTIONS(4951),
    [anon_sym___attribute__] = ACTIONS(4951),
    [anon_sym___attribute] = ACTIONS(4951),
    [anon_sym_using] = ACTIONS(4951),
    [anon_sym_COLON_COLON] = ACTIONS(4953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4953),
    [anon_sym___declspec] = ACTIONS(4951),
    [anon_sym___based] = ACTIONS(4951),
    [anon_sym___cdecl] = ACTIONS(4951),
    [anon_sym___clrcall] = ACTIONS(4951),
    [anon_sym___stdcall] = ACTIONS(4951),
    [anon_sym___fastcall] = ACTIONS(4951),
    [anon_sym___thiscall] = ACTIONS(4951),
    [anon_sym___vectorcall] = ACTIONS(4951),
    [anon_sym_signed] = ACTIONS(4951),
    [anon_sym_unsigned] = ACTIONS(4951),
    [anon_sym_long] = ACTIONS(4951),
    [anon_sym_short] = ACTIONS(4951),
    [anon_sym_LBRACK] = ACTIONS(4951),
    [anon_sym_static] = ACTIONS(4951),
    [anon_sym_register] = ACTIONS(4951),
    [anon_sym_inline] = ACTIONS(4951),
    [anon_sym___inline] = ACTIONS(4951),
    [anon_sym___inline__] = ACTIONS(4951),
    [anon_sym___forceinline] = ACTIONS(4951),
    [anon_sym_thread_local] = ACTIONS(4951),
    [anon_sym___thread] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_constexpr] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym_restrict] = ACTIONS(4951),
    [anon_sym___restrict__] = ACTIONS(4951),
    [anon_sym__Atomic] = ACTIONS(4951),
    [anon_sym__Noreturn] = ACTIONS(4951),
    [anon_sym_noreturn] = ACTIONS(4951),
    [anon_sym__Nonnull] = ACTIONS(4951),
    [anon_sym_mutable] = ACTIONS(4951),
    [anon_sym_constinit] = ACTIONS(4951),
    [anon_sym_consteval] = ACTIONS(4951),
    [anon_sym_alignas] = ACTIONS(4951),
    [anon_sym__Alignas] = ACTIONS(4951),
    [sym_primitive_type] = ACTIONS(4951),
    [anon_sym_enum] = ACTIONS(4951),
    [anon_sym_class] = ACTIONS(4951),
    [anon_sym_struct] = ACTIONS(4951),
    [anon_sym_union] = ACTIONS(4951),
    [anon_sym_or] = ACTIONS(4951),
    [anon_sym_and] = ACTIONS(4951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4951),
    [anon_sym_decltype] = ACTIONS(4951),
    [anon_sym_explicit] = ACTIONS(4951),
    [anon_sym_typename] = ACTIONS(4951),
    [anon_sym_template] = ACTIONS(4951),
    [anon_sym_operator] = ACTIONS(4951),
    [anon_sym_friend] = ACTIONS(4951),
    [anon_sym_concept] = ACTIONS(4951),
  },
  [2309] = {
    [sym_identifier] = ACTIONS(5699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5701),
    [anon_sym_COMMA] = ACTIONS(5701),
    [anon_sym_RPAREN] = ACTIONS(5701),
    [aux_sym_preproc_if_token2] = ACTIONS(5701),
    [aux_sym_preproc_else_token1] = ACTIONS(5701),
    [aux_sym_preproc_elif_token1] = ACTIONS(5699),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5701),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5701),
    [anon_sym_LPAREN2] = ACTIONS(5701),
    [anon_sym_DASH] = ACTIONS(5699),
    [anon_sym_PLUS] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5699),
    [anon_sym_SLASH] = ACTIONS(5699),
    [anon_sym_PERCENT] = ACTIONS(5699),
    [anon_sym_PIPE_PIPE] = ACTIONS(5701),
    [anon_sym_AMP_AMP] = ACTIONS(5701),
    [anon_sym_PIPE] = ACTIONS(5699),
    [anon_sym_CARET] = ACTIONS(5699),
    [anon_sym_AMP] = ACTIONS(5699),
    [anon_sym_EQ_EQ] = ACTIONS(5701),
    [anon_sym_BANG_EQ] = ACTIONS(5701),
    [anon_sym_GT] = ACTIONS(5699),
    [anon_sym_GT_EQ] = ACTIONS(5701),
    [anon_sym_LT_EQ] = ACTIONS(5699),
    [anon_sym_LT] = ACTIONS(5699),
    [anon_sym_LT_LT] = ACTIONS(5699),
    [anon_sym_GT_GT] = ACTIONS(5699),
    [anon_sym_SEMI] = ACTIONS(5701),
    [anon_sym___attribute__] = ACTIONS(5699),
    [anon_sym___attribute] = ACTIONS(5699),
    [anon_sym_COLON] = ACTIONS(5701),
    [anon_sym_LBRACE] = ACTIONS(5701),
    [anon_sym_RBRACE] = ACTIONS(5701),
    [anon_sym_LBRACK] = ACTIONS(5701),
    [anon_sym_RBRACK] = ACTIONS(5701),
    [anon_sym_EQ] = ACTIONS(5699),
    [anon_sym_QMARK] = ACTIONS(5701),
    [anon_sym_STAR_EQ] = ACTIONS(5701),
    [anon_sym_SLASH_EQ] = ACTIONS(5701),
    [anon_sym_PERCENT_EQ] = ACTIONS(5701),
    [anon_sym_PLUS_EQ] = ACTIONS(5701),
    [anon_sym_DASH_EQ] = ACTIONS(5701),
    [anon_sym_LT_LT_EQ] = ACTIONS(5701),
    [anon_sym_GT_GT_EQ] = ACTIONS(5701),
    [anon_sym_AMP_EQ] = ACTIONS(5701),
    [anon_sym_CARET_EQ] = ACTIONS(5701),
    [anon_sym_PIPE_EQ] = ACTIONS(5701),
    [anon_sym_and_eq] = ACTIONS(5699),
    [anon_sym_or_eq] = ACTIONS(5699),
    [anon_sym_xor_eq] = ACTIONS(5699),
    [anon_sym_LT_EQ_GT] = ACTIONS(5701),
    [anon_sym_or] = ACTIONS(5699),
    [anon_sym_and] = ACTIONS(5699),
    [anon_sym_bitor] = ACTIONS(5699),
    [anon_sym_xor] = ACTIONS(5699),
    [anon_sym_bitand] = ACTIONS(5699),
    [anon_sym_not_eq] = ACTIONS(5699),
    [anon_sym_DASH_DASH] = ACTIONS(5701),
    [anon_sym_PLUS_PLUS] = ACTIONS(5701),
    [anon_sym_DOT] = ACTIONS(5699),
    [anon_sym_DOT_STAR] = ACTIONS(5701),
    [anon_sym_DASH_GT] = ACTIONS(5701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5699),
    [anon_sym_decltype] = ACTIONS(5699),
  },
  [2310] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5894),
    [anon_sym_COMMA] = ACTIONS(5894),
    [anon_sym_RPAREN] = ACTIONS(5894),
    [anon_sym_LPAREN2] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5896),
    [anon_sym_STAR] = ACTIONS(5896),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [anon_sym_PIPE_PIPE] = ACTIONS(5894),
    [anon_sym_AMP_AMP] = ACTIONS(5894),
    [anon_sym_PIPE] = ACTIONS(5896),
    [anon_sym_CARET] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5896),
    [anon_sym_LT_LT] = ACTIONS(5896),
    [anon_sym_GT_GT] = ACTIONS(5896),
    [anon_sym_SEMI] = ACTIONS(5894),
    [anon_sym___attribute__] = ACTIONS(5894),
    [anon_sym___attribute] = ACTIONS(5896),
    [anon_sym_COLON] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5894),
    [anon_sym_RBRACE] = ACTIONS(5894),
    [anon_sym_signed] = ACTIONS(6308),
    [anon_sym_unsigned] = ACTIONS(6308),
    [anon_sym_long] = ACTIONS(6308),
    [anon_sym_short] = ACTIONS(6308),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_RBRACK] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5896),
    [anon_sym_QMARK] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(5894),
    [anon_sym_SLASH_EQ] = ACTIONS(5894),
    [anon_sym_PERCENT_EQ] = ACTIONS(5894),
    [anon_sym_PLUS_EQ] = ACTIONS(5894),
    [anon_sym_DASH_EQ] = ACTIONS(5894),
    [anon_sym_LT_LT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT_EQ] = ACTIONS(5894),
    [anon_sym_AMP_EQ] = ACTIONS(5894),
    [anon_sym_CARET_EQ] = ACTIONS(5894),
    [anon_sym_PIPE_EQ] = ACTIONS(5894),
    [anon_sym_and_eq] = ACTIONS(5894),
    [anon_sym_or_eq] = ACTIONS(5894),
    [anon_sym_xor_eq] = ACTIONS(5894),
    [anon_sym_LT_EQ_GT] = ACTIONS(5894),
    [anon_sym_or] = ACTIONS(5896),
    [anon_sym_and] = ACTIONS(5896),
    [anon_sym_bitor] = ACTIONS(5894),
    [anon_sym_xor] = ACTIONS(5896),
    [anon_sym_bitand] = ACTIONS(5894),
    [anon_sym_not_eq] = ACTIONS(5894),
    [anon_sym_DASH_DASH] = ACTIONS(5894),
    [anon_sym_PLUS_PLUS] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5896),
    [anon_sym_DOT_STAR] = ACTIONS(5894),
    [anon_sym_DASH_GT] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5894),
    [anon_sym_decltype] = ACTIONS(5894),
  },
  [2311] = {
    [sym_attribute_specifier] = STATE(1886),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6092),
    [anon_sym_COMMA] = ACTIONS(6092),
    [anon_sym_RPAREN] = ACTIONS(6092),
    [anon_sym_LPAREN2] = ACTIONS(6092),
    [anon_sym_DASH] = ACTIONS(6090),
    [anon_sym_PLUS] = ACTIONS(6090),
    [anon_sym_STAR] = ACTIONS(6092),
    [anon_sym_SLASH] = ACTIONS(6090),
    [anon_sym_PERCENT] = ACTIONS(6092),
    [anon_sym_PIPE_PIPE] = ACTIONS(6092),
    [anon_sym_AMP_AMP] = ACTIONS(6092),
    [anon_sym_PIPE] = ACTIONS(6090),
    [anon_sym_CARET] = ACTIONS(6092),
    [anon_sym_AMP] = ACTIONS(6090),
    [anon_sym_EQ_EQ] = ACTIONS(6092),
    [anon_sym_BANG_EQ] = ACTIONS(6092),
    [anon_sym_GT] = ACTIONS(6090),
    [anon_sym_GT_EQ] = ACTIONS(6092),
    [anon_sym_LT_EQ] = ACTIONS(6090),
    [anon_sym_LT] = ACTIONS(6090),
    [anon_sym_LT_LT] = ACTIONS(6092),
    [anon_sym_GT_GT] = ACTIONS(6092),
    [anon_sym_SEMI] = ACTIONS(6092),
    [anon_sym___extension__] = ACTIONS(6092),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6092),
    [anon_sym_LBRACE] = ACTIONS(6092),
    [anon_sym_RBRACE] = ACTIONS(6092),
    [anon_sym_LBRACK] = ACTIONS(6092),
    [anon_sym_RBRACK] = ACTIONS(6092),
    [anon_sym_const] = ACTIONS(6090),
    [anon_sym_constexpr] = ACTIONS(6092),
    [anon_sym_volatile] = ACTIONS(6092),
    [anon_sym_restrict] = ACTIONS(6092),
    [anon_sym___restrict__] = ACTIONS(6092),
    [anon_sym__Atomic] = ACTIONS(6092),
    [anon_sym__Noreturn] = ACTIONS(6092),
    [anon_sym_noreturn] = ACTIONS(6092),
    [anon_sym__Nonnull] = ACTIONS(6092),
    [anon_sym_mutable] = ACTIONS(6092),
    [anon_sym_constinit] = ACTIONS(6092),
    [anon_sym_consteval] = ACTIONS(6092),
    [anon_sym_alignas] = ACTIONS(6092),
    [anon_sym__Alignas] = ACTIONS(6092),
    [anon_sym_QMARK] = ACTIONS(6092),
    [anon_sym_LT_EQ_GT] = ACTIONS(6092),
    [anon_sym_or] = ACTIONS(6092),
    [anon_sym_and] = ACTIONS(6092),
    [anon_sym_bitor] = ACTIONS(6092),
    [anon_sym_xor] = ACTIONS(6092),
    [anon_sym_bitand] = ACTIONS(6092),
    [anon_sym_not_eq] = ACTIONS(6092),
    [anon_sym_DASH_DASH] = ACTIONS(6092),
    [anon_sym_PLUS_PLUS] = ACTIONS(6092),
    [anon_sym_DOT] = ACTIONS(6090),
    [anon_sym_DOT_STAR] = ACTIONS(6092),
    [anon_sym_DASH_GT] = ACTIONS(6092),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6092),
    [anon_sym_decltype] = ACTIONS(6092),
    [anon_sym_final] = ACTIONS(6092),
    [anon_sym_override] = ACTIONS(6092),
    [anon_sym_requires] = ACTIONS(6092),
  },
  [2312] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5898),
    [anon_sym_COMMA] = ACTIONS(5898),
    [anon_sym_RPAREN] = ACTIONS(5898),
    [anon_sym_LPAREN2] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5900),
    [anon_sym_STAR] = ACTIONS(5900),
    [anon_sym_SLASH] = ACTIONS(5900),
    [anon_sym_PERCENT] = ACTIONS(5900),
    [anon_sym_PIPE_PIPE] = ACTIONS(5898),
    [anon_sym_AMP_AMP] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_CARET] = ACTIONS(5900),
    [anon_sym_AMP] = ACTIONS(5900),
    [anon_sym_EQ_EQ] = ACTIONS(5898),
    [anon_sym_BANG_EQ] = ACTIONS(5898),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5900),
    [anon_sym_GT_GT] = ACTIONS(5900),
    [anon_sym_SEMI] = ACTIONS(5898),
    [anon_sym___attribute__] = ACTIONS(5898),
    [anon_sym___attribute] = ACTIONS(5900),
    [anon_sym_COLON] = ACTIONS(5898),
    [anon_sym_LBRACE] = ACTIONS(5898),
    [anon_sym_RBRACE] = ACTIONS(5898),
    [anon_sym_signed] = ACTIONS(6308),
    [anon_sym_unsigned] = ACTIONS(6308),
    [anon_sym_long] = ACTIONS(6308),
    [anon_sym_short] = ACTIONS(6308),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_RBRACK] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5900),
    [anon_sym_QMARK] = ACTIONS(5898),
    [anon_sym_STAR_EQ] = ACTIONS(5898),
    [anon_sym_SLASH_EQ] = ACTIONS(5898),
    [anon_sym_PERCENT_EQ] = ACTIONS(5898),
    [anon_sym_PLUS_EQ] = ACTIONS(5898),
    [anon_sym_DASH_EQ] = ACTIONS(5898),
    [anon_sym_LT_LT_EQ] = ACTIONS(5898),
    [anon_sym_GT_GT_EQ] = ACTIONS(5898),
    [anon_sym_AMP_EQ] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(5898),
    [anon_sym_PIPE_EQ] = ACTIONS(5898),
    [anon_sym_and_eq] = ACTIONS(5898),
    [anon_sym_or_eq] = ACTIONS(5898),
    [anon_sym_xor_eq] = ACTIONS(5898),
    [anon_sym_LT_EQ_GT] = ACTIONS(5898),
    [anon_sym_or] = ACTIONS(5900),
    [anon_sym_and] = ACTIONS(5900),
    [anon_sym_bitor] = ACTIONS(5898),
    [anon_sym_xor] = ACTIONS(5900),
    [anon_sym_bitand] = ACTIONS(5898),
    [anon_sym_not_eq] = ACTIONS(5898),
    [anon_sym_DASH_DASH] = ACTIONS(5898),
    [anon_sym_PLUS_PLUS] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5900),
    [anon_sym_DOT_STAR] = ACTIONS(5898),
    [anon_sym_DASH_GT] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5898),
    [anon_sym_decltype] = ACTIONS(5898),
  },
  [2313] = {
    [sym_template_argument_list] = STATE(2324),
    [sym_identifier] = ACTIONS(6310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6312),
    [anon_sym_COMMA] = ACTIONS(6312),
    [anon_sym_RPAREN] = ACTIONS(6312),
    [aux_sym_preproc_if_token2] = ACTIONS(6312),
    [aux_sym_preproc_else_token1] = ACTIONS(6312),
    [aux_sym_preproc_elif_token1] = ACTIONS(6310),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6312),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6312),
    [anon_sym_LPAREN2] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6310),
    [anon_sym_PLUS] = ACTIONS(6310),
    [anon_sym_STAR] = ACTIONS(6310),
    [anon_sym_SLASH] = ACTIONS(6310),
    [anon_sym_PERCENT] = ACTIONS(6310),
    [anon_sym_PIPE_PIPE] = ACTIONS(6312),
    [anon_sym_AMP_AMP] = ACTIONS(6312),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_CARET] = ACTIONS(6310),
    [anon_sym_AMP] = ACTIONS(6310),
    [anon_sym_EQ_EQ] = ACTIONS(6312),
    [anon_sym_BANG_EQ] = ACTIONS(6312),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_GT_EQ] = ACTIONS(6312),
    [anon_sym_LT_EQ] = ACTIONS(6310),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_LT_LT] = ACTIONS(6310),
    [anon_sym_GT_GT] = ACTIONS(6310),
    [anon_sym_SEMI] = ACTIONS(6312),
    [anon_sym___attribute__] = ACTIONS(6310),
    [anon_sym___attribute] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(6312),
    [anon_sym_LBRACK] = ACTIONS(6312),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_EQ] = ACTIONS(6310),
    [anon_sym_QMARK] = ACTIONS(6312),
    [anon_sym_STAR_EQ] = ACTIONS(6312),
    [anon_sym_SLASH_EQ] = ACTIONS(6312),
    [anon_sym_PERCENT_EQ] = ACTIONS(6312),
    [anon_sym_PLUS_EQ] = ACTIONS(6312),
    [anon_sym_DASH_EQ] = ACTIONS(6312),
    [anon_sym_LT_LT_EQ] = ACTIONS(6312),
    [anon_sym_GT_GT_EQ] = ACTIONS(6312),
    [anon_sym_AMP_EQ] = ACTIONS(6312),
    [anon_sym_CARET_EQ] = ACTIONS(6312),
    [anon_sym_PIPE_EQ] = ACTIONS(6312),
    [anon_sym_and_eq] = ACTIONS(6310),
    [anon_sym_or_eq] = ACTIONS(6310),
    [anon_sym_xor_eq] = ACTIONS(6310),
    [anon_sym_LT_EQ_GT] = ACTIONS(6312),
    [anon_sym_or] = ACTIONS(6310),
    [anon_sym_and] = ACTIONS(6310),
    [anon_sym_bitor] = ACTIONS(6310),
    [anon_sym_xor] = ACTIONS(6310),
    [anon_sym_bitand] = ACTIONS(6310),
    [anon_sym_not_eq] = ACTIONS(6310),
    [anon_sym_DASH_DASH] = ACTIONS(6312),
    [anon_sym_PLUS_PLUS] = ACTIONS(6312),
    [anon_sym_DOT] = ACTIONS(6310),
    [anon_sym_DOT_STAR] = ACTIONS(6312),
    [anon_sym_DASH_GT] = ACTIONS(6312),
    [sym_comment] = ACTIONS(3),
  },
  [2314] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_LPAREN2] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_STAR] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5928),
    [anon_sym_PERCENT] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5926),
    [anon_sym_PIPE] = ACTIONS(5928),
    [anon_sym_CARET] = ACTIONS(5928),
    [anon_sym_AMP] = ACTIONS(5928),
    [anon_sym_EQ_EQ] = ACTIONS(5926),
    [anon_sym_BANG_EQ] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5928),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_LT] = ACTIONS(5928),
    [anon_sym_LT_LT] = ACTIONS(5928),
    [anon_sym_GT_GT] = ACTIONS(5928),
    [anon_sym_SEMI] = ACTIONS(5926),
    [anon_sym___attribute__] = ACTIONS(5926),
    [anon_sym___attribute] = ACTIONS(5928),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_LBRACE] = ACTIONS(5926),
    [anon_sym_RBRACE] = ACTIONS(5926),
    [anon_sym_signed] = ACTIONS(6308),
    [anon_sym_unsigned] = ACTIONS(6308),
    [anon_sym_long] = ACTIONS(6308),
    [anon_sym_short] = ACTIONS(6308),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_RBRACK] = ACTIONS(5926),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_STAR_EQ] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_PERCENT_EQ] = ACTIONS(5926),
    [anon_sym_PLUS_EQ] = ACTIONS(5926),
    [anon_sym_DASH_EQ] = ACTIONS(5926),
    [anon_sym_LT_LT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT_EQ] = ACTIONS(5926),
    [anon_sym_AMP_EQ] = ACTIONS(5926),
    [anon_sym_CARET_EQ] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_and_eq] = ACTIONS(5926),
    [anon_sym_or_eq] = ACTIONS(5926),
    [anon_sym_xor_eq] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_or] = ACTIONS(5928),
    [anon_sym_and] = ACTIONS(5928),
    [anon_sym_bitor] = ACTIONS(5926),
    [anon_sym_xor] = ACTIONS(5928),
    [anon_sym_bitand] = ACTIONS(5926),
    [anon_sym_not_eq] = ACTIONS(5926),
    [anon_sym_DASH_DASH] = ACTIONS(5926),
    [anon_sym_PLUS_PLUS] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_DOT_STAR] = ACTIONS(5926),
    [anon_sym_DASH_GT] = ACTIONS(5926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5926),
    [anon_sym_decltype] = ACTIONS(5926),
  },
  [2315] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(5888),
    [anon_sym_RPAREN] = ACTIONS(5888),
    [anon_sym_LPAREN2] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5890),
    [anon_sym_STAR] = ACTIONS(5890),
    [anon_sym_SLASH] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5890),
    [anon_sym_PIPE_PIPE] = ACTIONS(5888),
    [anon_sym_AMP_AMP] = ACTIONS(5888),
    [anon_sym_PIPE] = ACTIONS(5890),
    [anon_sym_CARET] = ACTIONS(5890),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_EQ_EQ] = ACTIONS(5888),
    [anon_sym_BANG_EQ] = ACTIONS(5888),
    [anon_sym_GT] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5890),
    [anon_sym_LT_LT] = ACTIONS(5890),
    [anon_sym_GT_GT] = ACTIONS(5890),
    [anon_sym_SEMI] = ACTIONS(5888),
    [anon_sym___attribute__] = ACTIONS(5888),
    [anon_sym___attribute] = ACTIONS(5890),
    [anon_sym_COLON] = ACTIONS(5888),
    [anon_sym_LBRACE] = ACTIONS(5888),
    [anon_sym_RBRACE] = ACTIONS(5888),
    [anon_sym_signed] = ACTIONS(6308),
    [anon_sym_unsigned] = ACTIONS(6308),
    [anon_sym_long] = ACTIONS(6308),
    [anon_sym_short] = ACTIONS(6308),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_RBRACK] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5890),
    [anon_sym_QMARK] = ACTIONS(5888),
    [anon_sym_STAR_EQ] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(5888),
    [anon_sym_PLUS_EQ] = ACTIONS(5888),
    [anon_sym_DASH_EQ] = ACTIONS(5888),
    [anon_sym_LT_LT_EQ] = ACTIONS(5888),
    [anon_sym_GT_GT_EQ] = ACTIONS(5888),
    [anon_sym_AMP_EQ] = ACTIONS(5888),
    [anon_sym_CARET_EQ] = ACTIONS(5888),
    [anon_sym_PIPE_EQ] = ACTIONS(5888),
    [anon_sym_and_eq] = ACTIONS(5888),
    [anon_sym_or_eq] = ACTIONS(5888),
    [anon_sym_xor_eq] = ACTIONS(5888),
    [anon_sym_LT_EQ_GT] = ACTIONS(5888),
    [anon_sym_or] = ACTIONS(5890),
    [anon_sym_and] = ACTIONS(5890),
    [anon_sym_bitor] = ACTIONS(5888),
    [anon_sym_xor] = ACTIONS(5890),
    [anon_sym_bitand] = ACTIONS(5888),
    [anon_sym_not_eq] = ACTIONS(5888),
    [anon_sym_DASH_DASH] = ACTIONS(5888),
    [anon_sym_PLUS_PLUS] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5890),
    [anon_sym_DOT_STAR] = ACTIONS(5888),
    [anon_sym_DASH_GT] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5888),
    [anon_sym_decltype] = ACTIONS(5888),
  },
  [2316] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2315),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5450),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5450),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5450),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym___attribute__] = ACTIONS(5452),
    [anon_sym___attribute] = ACTIONS(5450),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_signed] = ACTIONS(6317),
    [anon_sym_unsigned] = ACTIONS(6317),
    [anon_sym_long] = ACTIONS(6317),
    [anon_sym_short] = ACTIONS(6317),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_STAR_EQ] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5452),
    [anon_sym_PLUS_EQ] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5452),
    [anon_sym_CARET_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_EQ] = ACTIONS(5452),
    [anon_sym_and_eq] = ACTIONS(5452),
    [anon_sym_or_eq] = ACTIONS(5452),
    [anon_sym_xor_eq] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_and] = ACTIONS(5450),
    [anon_sym_bitor] = ACTIONS(5452),
    [anon_sym_xor] = ACTIONS(5450),
    [anon_sym_bitand] = ACTIONS(5452),
    [anon_sym_not_eq] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5452),
    [anon_sym_decltype] = ACTIONS(5452),
  },
  [2317] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5902),
    [anon_sym_COMMA] = ACTIONS(5902),
    [anon_sym_RPAREN] = ACTIONS(5902),
    [anon_sym_LPAREN2] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5904),
    [anon_sym_STAR] = ACTIONS(5904),
    [anon_sym_SLASH] = ACTIONS(5904),
    [anon_sym_PERCENT] = ACTIONS(5904),
    [anon_sym_PIPE_PIPE] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5902),
    [anon_sym_PIPE] = ACTIONS(5904),
    [anon_sym_CARET] = ACTIONS(5904),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_EQ_EQ] = ACTIONS(5902),
    [anon_sym_BANG_EQ] = ACTIONS(5902),
    [anon_sym_GT] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5904),
    [anon_sym_LT_LT] = ACTIONS(5904),
    [anon_sym_GT_GT] = ACTIONS(5904),
    [anon_sym_SEMI] = ACTIONS(5902),
    [anon_sym___attribute__] = ACTIONS(5902),
    [anon_sym___attribute] = ACTIONS(5904),
    [anon_sym_COLON] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5902),
    [anon_sym_RBRACE] = ACTIONS(5902),
    [anon_sym_signed] = ACTIONS(6319),
    [anon_sym_unsigned] = ACTIONS(6319),
    [anon_sym_long] = ACTIONS(6319),
    [anon_sym_short] = ACTIONS(6319),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_RBRACK] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_STAR_EQ] = ACTIONS(5902),
    [anon_sym_SLASH_EQ] = ACTIONS(5902),
    [anon_sym_PERCENT_EQ] = ACTIONS(5902),
    [anon_sym_PLUS_EQ] = ACTIONS(5902),
    [anon_sym_DASH_EQ] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5902),
    [anon_sym_AMP_EQ] = ACTIONS(5902),
    [anon_sym_CARET_EQ] = ACTIONS(5902),
    [anon_sym_PIPE_EQ] = ACTIONS(5902),
    [anon_sym_and_eq] = ACTIONS(5902),
    [anon_sym_or_eq] = ACTIONS(5902),
    [anon_sym_xor_eq] = ACTIONS(5902),
    [anon_sym_LT_EQ_GT] = ACTIONS(5902),
    [anon_sym_or] = ACTIONS(5904),
    [anon_sym_and] = ACTIONS(5904),
    [anon_sym_bitor] = ACTIONS(5902),
    [anon_sym_xor] = ACTIONS(5904),
    [anon_sym_bitand] = ACTIONS(5902),
    [anon_sym_not_eq] = ACTIONS(5902),
    [anon_sym_DASH_DASH] = ACTIONS(5902),
    [anon_sym_PLUS_PLUS] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5904),
    [anon_sym_DOT_STAR] = ACTIONS(5902),
    [anon_sym_DASH_GT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5902),
    [anon_sym_decltype] = ACTIONS(5902),
  },
  [2318] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_RPAREN] = ACTIONS(5916),
    [anon_sym_LPAREN2] = ACTIONS(5916),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_PLUS] = ACTIONS(5918),
    [anon_sym_STAR] = ACTIONS(5918),
    [anon_sym_SLASH] = ACTIONS(5918),
    [anon_sym_PERCENT] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_AMP_AMP] = ACTIONS(5916),
    [anon_sym_PIPE] = ACTIONS(5918),
    [anon_sym_CARET] = ACTIONS(5918),
    [anon_sym_AMP] = ACTIONS(5918),
    [anon_sym_EQ_EQ] = ACTIONS(5916),
    [anon_sym_BANG_EQ] = ACTIONS(5916),
    [anon_sym_GT] = ACTIONS(5918),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_LT] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5918),
    [anon_sym_GT_GT] = ACTIONS(5918),
    [anon_sym_SEMI] = ACTIONS(5916),
    [anon_sym___attribute__] = ACTIONS(5916),
    [anon_sym___attribute] = ACTIONS(5918),
    [anon_sym_COLON] = ACTIONS(5916),
    [anon_sym_LBRACE] = ACTIONS(5916),
    [anon_sym_RBRACE] = ACTIONS(5916),
    [anon_sym_signed] = ACTIONS(6308),
    [anon_sym_unsigned] = ACTIONS(6308),
    [anon_sym_long] = ACTIONS(6308),
    [anon_sym_short] = ACTIONS(6308),
    [anon_sym_LBRACK] = ACTIONS(5916),
    [anon_sym_RBRACK] = ACTIONS(5916),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_QMARK] = ACTIONS(5916),
    [anon_sym_STAR_EQ] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_PERCENT_EQ] = ACTIONS(5916),
    [anon_sym_PLUS_EQ] = ACTIONS(5916),
    [anon_sym_DASH_EQ] = ACTIONS(5916),
    [anon_sym_LT_LT_EQ] = ACTIONS(5916),
    [anon_sym_GT_GT_EQ] = ACTIONS(5916),
    [anon_sym_AMP_EQ] = ACTIONS(5916),
    [anon_sym_CARET_EQ] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_and_eq] = ACTIONS(5916),
    [anon_sym_or_eq] = ACTIONS(5916),
    [anon_sym_xor_eq] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5918),
    [anon_sym_and] = ACTIONS(5918),
    [anon_sym_bitor] = ACTIONS(5916),
    [anon_sym_xor] = ACTIONS(5918),
    [anon_sym_bitand] = ACTIONS(5916),
    [anon_sym_not_eq] = ACTIONS(5916),
    [anon_sym_DASH_DASH] = ACTIONS(5916),
    [anon_sym_PLUS_PLUS] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_DOT_STAR] = ACTIONS(5916),
    [anon_sym_DASH_GT] = ACTIONS(5916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5916),
    [anon_sym_decltype] = ACTIONS(5916),
  },
  [2319] = {
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_unaligned_ptr_modifier] = STATE(4043),
    [sym_ms_pointer_modifier] = STATE(2340),
    [sym__declarator] = STATE(6493),
    [sym__abstract_declarator] = STATE(6646),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_function_declarator] = STATE(5998),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_array_declarator] = STATE(5998),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_type_qualifier] = STATE(2845),
    [sym_alignas_qualifier] = STATE(4289),
    [sym_parameter_list] = STATE(3004),
    [sym_decltype] = STATE(8601),
    [sym_reference_declarator] = STATE(5998),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5847),
    [sym_qualified_identifier] = STATE(5998),
    [sym_operator_name] = STATE(5998),
    [aux_sym__type_definition_type_repeat1] = STATE(2845),
    [aux_sym_pointer_declarator_repeat1] = STATE(2340),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_RPAREN] = ACTIONS(5851),
    [anon_sym_LPAREN2] = ACTIONS(4298),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_AMP] = ACTIONS(4304),
    [anon_sym___extension__] = ACTIONS(3331),
    [anon_sym_COLON_COLON] = ACTIONS(6321),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(3327),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3327),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3327),
    [anon_sym__unaligned] = ACTIONS(3329),
    [anon_sym___unaligned] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(5863),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_constexpr] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_restrict] = ACTIONS(3331),
    [anon_sym___restrict__] = ACTIONS(3331),
    [anon_sym__Atomic] = ACTIONS(3331),
    [anon_sym__Noreturn] = ACTIONS(3331),
    [anon_sym_noreturn] = ACTIONS(3331),
    [anon_sym__Nonnull] = ACTIONS(3331),
    [anon_sym_mutable] = ACTIONS(3331),
    [anon_sym_constinit] = ACTIONS(3331),
    [anon_sym_consteval] = ACTIONS(3331),
    [anon_sym_alignas] = ACTIONS(3333),
    [anon_sym__Alignas] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [2320] = {
    [sym_type_qualifier] = STATE(1633),
    [sym_alignas_qualifier] = STATE(1658),
    [aux_sym__type_definition_type_repeat1] = STATE(1633),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2617),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5100),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_RPAREN] = ACTIONS(5100),
    [anon_sym_LPAREN2] = ACTIONS(5100),
    [anon_sym_TILDE] = ACTIONS(5100),
    [anon_sym_STAR] = ACTIONS(5100),
    [anon_sym_AMP_AMP] = ACTIONS(5100),
    [anon_sym_AMP] = ACTIONS(5102),
    [anon_sym_SEMI] = ACTIONS(5100),
    [anon_sym___extension__] = ACTIONS(6326),
    [anon_sym_virtual] = ACTIONS(5102),
    [anon_sym_extern] = ACTIONS(5102),
    [anon_sym___attribute__] = ACTIONS(5102),
    [anon_sym___attribute] = ACTIONS(5102),
    [anon_sym_COLON_COLON] = ACTIONS(5100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5100),
    [anon_sym___declspec] = ACTIONS(5102),
    [anon_sym___based] = ACTIONS(5102),
    [anon_sym___cdecl] = ACTIONS(5102),
    [anon_sym___clrcall] = ACTIONS(5102),
    [anon_sym___stdcall] = ACTIONS(5102),
    [anon_sym___fastcall] = ACTIONS(5102),
    [anon_sym___thiscall] = ACTIONS(5102),
    [anon_sym___vectorcall] = ACTIONS(5102),
    [anon_sym_LBRACE] = ACTIONS(5100),
    [anon_sym_signed] = ACTIONS(6329),
    [anon_sym_unsigned] = ACTIONS(6329),
    [anon_sym_long] = ACTIONS(6329),
    [anon_sym_short] = ACTIONS(6329),
    [anon_sym_LBRACK] = ACTIONS(5102),
    [anon_sym_static] = ACTIONS(5102),
    [anon_sym_EQ] = ACTIONS(5100),
    [anon_sym_register] = ACTIONS(5102),
    [anon_sym_inline] = ACTIONS(5102),
    [anon_sym___inline] = ACTIONS(5102),
    [anon_sym___inline__] = ACTIONS(5102),
    [anon_sym___forceinline] = ACTIONS(5102),
    [anon_sym_thread_local] = ACTIONS(5102),
    [anon_sym___thread] = ACTIONS(5102),
    [anon_sym_const] = ACTIONS(6326),
    [anon_sym_constexpr] = ACTIONS(6326),
    [anon_sym_volatile] = ACTIONS(6326),
    [anon_sym_restrict] = ACTIONS(6326),
    [anon_sym___restrict__] = ACTIONS(6326),
    [anon_sym__Atomic] = ACTIONS(6326),
    [anon_sym__Noreturn] = ACTIONS(6326),
    [anon_sym_noreturn] = ACTIONS(6326),
    [anon_sym__Nonnull] = ACTIONS(6326),
    [anon_sym_mutable] = ACTIONS(6326),
    [anon_sym_constinit] = ACTIONS(6326),
    [anon_sym_consteval] = ACTIONS(6326),
    [anon_sym_alignas] = ACTIONS(6331),
    [anon_sym__Alignas] = ACTIONS(6331),
    [sym_primitive_type] = ACTIONS(6334),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5102),
    [anon_sym_decltype] = ACTIONS(5102),
    [anon_sym_template] = ACTIONS(5102),
    [anon_sym_GT2] = ACTIONS(5100),
    [anon_sym_operator] = ACTIONS(5102),
  },
  [2321] = {
    [sym_attribute_specifier] = STATE(2258),
    [sym_enumerator_list] = STATE(2191),
    [sym__enum_base_clause] = STATE(2051),
    [sym_identifier] = ACTIONS(6336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6338),
    [anon_sym_COMMA] = ACTIONS(6338),
    [aux_sym_preproc_if_token2] = ACTIONS(6338),
    [aux_sym_preproc_else_token1] = ACTIONS(6338),
    [aux_sym_preproc_elif_token1] = ACTIONS(6336),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6338),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6338),
    [anon_sym_LPAREN2] = ACTIONS(6338),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_PERCENT] = ACTIONS(6336),
    [anon_sym_PIPE_PIPE] = ACTIONS(6338),
    [anon_sym_AMP_AMP] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_AMP] = ACTIONS(6336),
    [anon_sym_EQ_EQ] = ACTIONS(6338),
    [anon_sym_BANG_EQ] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6336),
    [anon_sym_GT_EQ] = ACTIONS(6338),
    [anon_sym_LT_EQ] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6336),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(5987),
    [anon_sym_LBRACK] = ACTIONS(6338),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_QMARK] = ACTIONS(6338),
    [anon_sym_STAR_EQ] = ACTIONS(6338),
    [anon_sym_SLASH_EQ] = ACTIONS(6338),
    [anon_sym_PERCENT_EQ] = ACTIONS(6338),
    [anon_sym_PLUS_EQ] = ACTIONS(6338),
    [anon_sym_DASH_EQ] = ACTIONS(6338),
    [anon_sym_LT_LT_EQ] = ACTIONS(6338),
    [anon_sym_GT_GT_EQ] = ACTIONS(6338),
    [anon_sym_AMP_EQ] = ACTIONS(6338),
    [anon_sym_CARET_EQ] = ACTIONS(6338),
    [anon_sym_PIPE_EQ] = ACTIONS(6338),
    [anon_sym_and_eq] = ACTIONS(6336),
    [anon_sym_or_eq] = ACTIONS(6336),
    [anon_sym_xor_eq] = ACTIONS(6336),
    [anon_sym_LT_EQ_GT] = ACTIONS(6338),
    [anon_sym_or] = ACTIONS(6336),
    [anon_sym_and] = ACTIONS(6336),
    [anon_sym_bitor] = ACTIONS(6336),
    [anon_sym_xor] = ACTIONS(6336),
    [anon_sym_bitand] = ACTIONS(6336),
    [anon_sym_not_eq] = ACTIONS(6336),
    [anon_sym_DASH_DASH] = ACTIONS(6338),
    [anon_sym_PLUS_PLUS] = ACTIONS(6338),
    [anon_sym_DOT] = ACTIONS(6336),
    [anon_sym_DOT_STAR] = ACTIONS(6338),
    [anon_sym_DASH_GT] = ACTIONS(6338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6336),
    [anon_sym_decltype] = ACTIONS(6336),
  },
  [2322] = {
    [sym_attribute_specifier] = STATE(2228),
    [sym_enumerator_list] = STATE(2181),
    [sym__enum_base_clause] = STATE(2116),
    [sym_identifier] = ACTIONS(6342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6344),
    [anon_sym_COMMA] = ACTIONS(6344),
    [aux_sym_preproc_if_token2] = ACTIONS(6344),
    [aux_sym_preproc_else_token1] = ACTIONS(6344),
    [aux_sym_preproc_elif_token1] = ACTIONS(6342),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6344),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6344),
    [anon_sym_LPAREN2] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6342),
    [anon_sym_PLUS] = ACTIONS(6342),
    [anon_sym_STAR] = ACTIONS(6342),
    [anon_sym_SLASH] = ACTIONS(6342),
    [anon_sym_PERCENT] = ACTIONS(6342),
    [anon_sym_PIPE_PIPE] = ACTIONS(6344),
    [anon_sym_AMP_AMP] = ACTIONS(6344),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_CARET] = ACTIONS(6342),
    [anon_sym_AMP] = ACTIONS(6342),
    [anon_sym_EQ_EQ] = ACTIONS(6344),
    [anon_sym_BANG_EQ] = ACTIONS(6344),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_GT_EQ] = ACTIONS(6344),
    [anon_sym_LT_EQ] = ACTIONS(6342),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_LT_LT] = ACTIONS(6342),
    [anon_sym_GT_GT] = ACTIONS(6342),
    [anon_sym___attribute__] = ACTIONS(5497),
    [anon_sym___attribute] = ACTIONS(5497),
    [anon_sym_COLON] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(5987),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6342),
    [anon_sym_QMARK] = ACTIONS(6344),
    [anon_sym_STAR_EQ] = ACTIONS(6344),
    [anon_sym_SLASH_EQ] = ACTIONS(6344),
    [anon_sym_PERCENT_EQ] = ACTIONS(6344),
    [anon_sym_PLUS_EQ] = ACTIONS(6344),
    [anon_sym_DASH_EQ] = ACTIONS(6344),
    [anon_sym_LT_LT_EQ] = ACTIONS(6344),
    [anon_sym_GT_GT_EQ] = ACTIONS(6344),
    [anon_sym_AMP_EQ] = ACTIONS(6344),
    [anon_sym_CARET_EQ] = ACTIONS(6344),
    [anon_sym_PIPE_EQ] = ACTIONS(6344),
    [anon_sym_and_eq] = ACTIONS(6342),
    [anon_sym_or_eq] = ACTIONS(6342),
    [anon_sym_xor_eq] = ACTIONS(6342),
    [anon_sym_LT_EQ_GT] = ACTIONS(6344),
    [anon_sym_or] = ACTIONS(6342),
    [anon_sym_and] = ACTIONS(6342),
    [anon_sym_bitor] = ACTIONS(6342),
    [anon_sym_xor] = ACTIONS(6342),
    [anon_sym_bitand] = ACTIONS(6342),
    [anon_sym_not_eq] = ACTIONS(6342),
    [anon_sym_DASH_DASH] = ACTIONS(6344),
    [anon_sym_PLUS_PLUS] = ACTIONS(6344),
    [anon_sym_DOT] = ACTIONS(6342),
    [anon_sym_DOT_STAR] = ACTIONS(6344),
    [anon_sym_DASH_GT] = ACTIONS(6344),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6342),
    [anon_sym_decltype] = ACTIONS(6342),
  },
  [2323] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5450),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym___extension__] = ACTIONS(5452),
    [anon_sym___attribute__] = ACTIONS(5452),
    [anon_sym___attribute] = ACTIONS(5450),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_signed] = ACTIONS(6346),
    [anon_sym_unsigned] = ACTIONS(6346),
    [anon_sym_long] = ACTIONS(6346),
    [anon_sym_short] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_const] = ACTIONS(5450),
    [anon_sym_constexpr] = ACTIONS(5452),
    [anon_sym_volatile] = ACTIONS(5452),
    [anon_sym_restrict] = ACTIONS(5452),
    [anon_sym___restrict__] = ACTIONS(5452),
    [anon_sym__Atomic] = ACTIONS(5452),
    [anon_sym__Noreturn] = ACTIONS(5452),
    [anon_sym_noreturn] = ACTIONS(5452),
    [anon_sym__Nonnull] = ACTIONS(5452),
    [anon_sym_mutable] = ACTIONS(5452),
    [anon_sym_constinit] = ACTIONS(5452),
    [anon_sym_consteval] = ACTIONS(5452),
    [anon_sym_alignas] = ACTIONS(5452),
    [anon_sym__Alignas] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_bitor] = ACTIONS(5452),
    [anon_sym_xor] = ACTIONS(5452),
    [anon_sym_bitand] = ACTIONS(5452),
    [anon_sym_not_eq] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5452),
    [anon_sym_decltype] = ACTIONS(5452),
    [anon_sym_final] = ACTIONS(5452),
    [anon_sym_override] = ACTIONS(5452),
    [anon_sym_GT2] = ACTIONS(5452),
    [anon_sym_requires] = ACTIONS(5452),
  },
  [2324] = {
    [sym_identifier] = ACTIONS(6348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6350),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_RPAREN] = ACTIONS(6350),
    [aux_sym_preproc_if_token2] = ACTIONS(6350),
    [aux_sym_preproc_else_token1] = ACTIONS(6350),
    [aux_sym_preproc_elif_token1] = ACTIONS(6348),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6350),
    [anon_sym_LPAREN2] = ACTIONS(6350),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_PERCENT] = ACTIONS(6348),
    [anon_sym_PIPE_PIPE] = ACTIONS(6350),
    [anon_sym_AMP_AMP] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_AMP] = ACTIONS(6348),
    [anon_sym_EQ_EQ] = ACTIONS(6350),
    [anon_sym_BANG_EQ] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6348),
    [anon_sym_GT_EQ] = ACTIONS(6350),
    [anon_sym_LT_EQ] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6348),
    [anon_sym_LT_LT] = ACTIONS(6348),
    [anon_sym_GT_GT] = ACTIONS(6348),
    [anon_sym_SEMI] = ACTIONS(6350),
    [anon_sym___attribute__] = ACTIONS(6348),
    [anon_sym___attribute] = ACTIONS(6348),
    [anon_sym_COLON] = ACTIONS(6348),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACE] = ACTIONS(6350),
    [anon_sym_RBRACE] = ACTIONS(6350),
    [anon_sym_LBRACK] = ACTIONS(6350),
    [anon_sym_RBRACK] = ACTIONS(6350),
    [anon_sym_EQ] = ACTIONS(6348),
    [anon_sym_QMARK] = ACTIONS(6350),
    [anon_sym_STAR_EQ] = ACTIONS(6350),
    [anon_sym_SLASH_EQ] = ACTIONS(6350),
    [anon_sym_PERCENT_EQ] = ACTIONS(6350),
    [anon_sym_PLUS_EQ] = ACTIONS(6350),
    [anon_sym_DASH_EQ] = ACTIONS(6350),
    [anon_sym_LT_LT_EQ] = ACTIONS(6350),
    [anon_sym_GT_GT_EQ] = ACTIONS(6350),
    [anon_sym_AMP_EQ] = ACTIONS(6350),
    [anon_sym_CARET_EQ] = ACTIONS(6350),
    [anon_sym_PIPE_EQ] = ACTIONS(6350),
    [anon_sym_and_eq] = ACTIONS(6348),
    [anon_sym_or_eq] = ACTIONS(6348),
    [anon_sym_xor_eq] = ACTIONS(6348),
    [anon_sym_LT_EQ_GT] = ACTIONS(6350),
    [anon_sym_or] = ACTIONS(6348),
    [anon_sym_and] = ACTIONS(6348),
    [anon_sym_bitor] = ACTIONS(6348),
    [anon_sym_xor] = ACTIONS(6348),
    [anon_sym_bitand] = ACTIONS(6348),
    [anon_sym_not_eq] = ACTIONS(6348),
    [anon_sym_DASH_DASH] = ACTIONS(6350),
    [anon_sym_PLUS_PLUS] = ACTIONS(6350),
    [anon_sym_DOT] = ACTIONS(6348),
    [anon_sym_DOT_STAR] = ACTIONS(6350),
    [anon_sym_DASH_GT] = ACTIONS(6350),
    [sym_comment] = ACTIONS(3),
  },
  [2325] = {
    [sym_new_declarator] = STATE(2397),
    [sym_identifier] = ACTIONS(6352),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6354),
    [anon_sym_COMMA] = ACTIONS(6354),
    [anon_sym_RPAREN] = ACTIONS(6354),
    [aux_sym_preproc_if_token2] = ACTIONS(6354),
    [aux_sym_preproc_else_token1] = ACTIONS(6354),
    [aux_sym_preproc_elif_token1] = ACTIONS(6352),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6354),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6354),
    [anon_sym_LPAREN2] = ACTIONS(6354),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_PERCENT] = ACTIONS(6352),
    [anon_sym_PIPE_PIPE] = ACTIONS(6354),
    [anon_sym_AMP_AMP] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_AMP] = ACTIONS(6352),
    [anon_sym_EQ_EQ] = ACTIONS(6354),
    [anon_sym_BANG_EQ] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6352),
    [anon_sym_GT_EQ] = ACTIONS(6354),
    [anon_sym_LT_EQ] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6352),
    [anon_sym_LT_LT] = ACTIONS(6352),
    [anon_sym_GT_GT] = ACTIONS(6352),
    [anon_sym_SEMI] = ACTIONS(6354),
    [anon_sym___attribute__] = ACTIONS(6352),
    [anon_sym___attribute] = ACTIONS(6352),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_LBRACE] = ACTIONS(6354),
    [anon_sym_RBRACE] = ACTIONS(6354),
    [anon_sym_LBRACK] = ACTIONS(5829),
    [anon_sym_RBRACK] = ACTIONS(6354),
    [anon_sym_EQ] = ACTIONS(6352),
    [anon_sym_QMARK] = ACTIONS(6354),
    [anon_sym_STAR_EQ] = ACTIONS(6354),
    [anon_sym_SLASH_EQ] = ACTIONS(6354),
    [anon_sym_PERCENT_EQ] = ACTIONS(6354),
    [anon_sym_PLUS_EQ] = ACTIONS(6354),
    [anon_sym_DASH_EQ] = ACTIONS(6354),
    [anon_sym_LT_LT_EQ] = ACTIONS(6354),
    [anon_sym_GT_GT_EQ] = ACTIONS(6354),
    [anon_sym_AMP_EQ] = ACTIONS(6354),
    [anon_sym_CARET_EQ] = ACTIONS(6354),
    [anon_sym_PIPE_EQ] = ACTIONS(6354),
    [anon_sym_and_eq] = ACTIONS(6352),
    [anon_sym_or_eq] = ACTIONS(6352),
    [anon_sym_xor_eq] = ACTIONS(6352),
    [anon_sym_LT_EQ_GT] = ACTIONS(6354),
    [anon_sym_or] = ACTIONS(6352),
    [anon_sym_and] = ACTIONS(6352),
    [anon_sym_bitor] = ACTIONS(6352),
    [anon_sym_xor] = ACTIONS(6352),
    [anon_sym_bitand] = ACTIONS(6352),
    [anon_sym_not_eq] = ACTIONS(6352),
    [anon_sym_DASH_DASH] = ACTIONS(6354),
    [anon_sym_PLUS_PLUS] = ACTIONS(6354),
    [anon_sym_DOT] = ACTIONS(6352),
    [anon_sym_DOT_STAR] = ACTIONS(6354),
    [anon_sym_DASH_GT] = ACTIONS(6354),
    [sym_comment] = ACTIONS(3),
  },
  [2326] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_LPAREN2] = ACTIONS(5916),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_PLUS] = ACTIONS(5918),
    [anon_sym_STAR] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5918),
    [anon_sym_PERCENT] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_AMP_AMP] = ACTIONS(5916),
    [anon_sym_PIPE] = ACTIONS(5918),
    [anon_sym_CARET] = ACTIONS(5916),
    [anon_sym_AMP] = ACTIONS(5918),
    [anon_sym_EQ_EQ] = ACTIONS(5916),
    [anon_sym_BANG_EQ] = ACTIONS(5916),
    [anon_sym_GT] = ACTIONS(5918),
    [anon_sym_GT_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_LT] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5916),
    [anon_sym_GT_GT] = ACTIONS(5918),
    [anon_sym___extension__] = ACTIONS(5916),
    [anon_sym___attribute__] = ACTIONS(5916),
    [anon_sym___attribute] = ACTIONS(5918),
    [anon_sym_LBRACE] = ACTIONS(5916),
    [anon_sym_signed] = ACTIONS(6356),
    [anon_sym_unsigned] = ACTIONS(6356),
    [anon_sym_long] = ACTIONS(6356),
    [anon_sym_short] = ACTIONS(6356),
    [anon_sym_LBRACK] = ACTIONS(5916),
    [anon_sym_const] = ACTIONS(5918),
    [anon_sym_constexpr] = ACTIONS(5916),
    [anon_sym_volatile] = ACTIONS(5916),
    [anon_sym_restrict] = ACTIONS(5916),
    [anon_sym___restrict__] = ACTIONS(5916),
    [anon_sym__Atomic] = ACTIONS(5916),
    [anon_sym__Noreturn] = ACTIONS(5916),
    [anon_sym_noreturn] = ACTIONS(5916),
    [anon_sym__Nonnull] = ACTIONS(5916),
    [anon_sym_mutable] = ACTIONS(5916),
    [anon_sym_constinit] = ACTIONS(5916),
    [anon_sym_consteval] = ACTIONS(5916),
    [anon_sym_alignas] = ACTIONS(5916),
    [anon_sym__Alignas] = ACTIONS(5916),
    [anon_sym_QMARK] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_bitor] = ACTIONS(5916),
    [anon_sym_xor] = ACTIONS(5916),
    [anon_sym_bitand] = ACTIONS(5916),
    [anon_sym_not_eq] = ACTIONS(5916),
    [anon_sym_DASH_DASH] = ACTIONS(5916),
    [anon_sym_PLUS_PLUS] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_DOT_STAR] = ACTIONS(5916),
    [anon_sym_DASH_GT] = ACTIONS(5916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5916),
    [anon_sym_decltype] = ACTIONS(5916),
    [anon_sym_final] = ACTIONS(5916),
    [anon_sym_override] = ACTIONS(5916),
    [anon_sym_GT2] = ACTIONS(5916),
    [anon_sym_requires] = ACTIONS(5916),
  },
  [2327] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_RPAREN] = ACTIONS(5942),
    [anon_sym_LPAREN2] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5944),
    [anon_sym_PLUS] = ACTIONS(5944),
    [anon_sym_STAR] = ACTIONS(5944),
    [anon_sym_SLASH] = ACTIONS(5944),
    [anon_sym_PERCENT] = ACTIONS(5944),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_AMP_AMP] = ACTIONS(5942),
    [anon_sym_PIPE] = ACTIONS(5944),
    [anon_sym_CARET] = ACTIONS(5944),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_EQ_EQ] = ACTIONS(5942),
    [anon_sym_BANG_EQ] = ACTIONS(5942),
    [anon_sym_GT] = ACTIONS(5944),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_LT_EQ] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5944),
    [anon_sym_GT_GT] = ACTIONS(5944),
    [anon_sym_SEMI] = ACTIONS(5942),
    [anon_sym___attribute__] = ACTIONS(5942),
    [anon_sym___attribute] = ACTIONS(5944),
    [anon_sym_COLON] = ACTIONS(5942),
    [anon_sym_LBRACE] = ACTIONS(5942),
    [anon_sym_RBRACE] = ACTIONS(5942),
    [anon_sym_signed] = ACTIONS(6308),
    [anon_sym_unsigned] = ACTIONS(6308),
    [anon_sym_long] = ACTIONS(6308),
    [anon_sym_short] = ACTIONS(6308),
    [anon_sym_LBRACK] = ACTIONS(5942),
    [anon_sym_RBRACK] = ACTIONS(5942),
    [anon_sym_EQ] = ACTIONS(5944),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_STAR_EQ] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_PERCENT_EQ] = ACTIONS(5942),
    [anon_sym_PLUS_EQ] = ACTIONS(5942),
    [anon_sym_DASH_EQ] = ACTIONS(5942),
    [anon_sym_LT_LT_EQ] = ACTIONS(5942),
    [anon_sym_GT_GT_EQ] = ACTIONS(5942),
    [anon_sym_AMP_EQ] = ACTIONS(5942),
    [anon_sym_CARET_EQ] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_and_eq] = ACTIONS(5942),
    [anon_sym_or_eq] = ACTIONS(5942),
    [anon_sym_xor_eq] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_or] = ACTIONS(5944),
    [anon_sym_and] = ACTIONS(5944),
    [anon_sym_bitor] = ACTIONS(5942),
    [anon_sym_xor] = ACTIONS(5944),
    [anon_sym_bitand] = ACTIONS(5942),
    [anon_sym_not_eq] = ACTIONS(5942),
    [anon_sym_DASH_DASH] = ACTIONS(5942),
    [anon_sym_PLUS_PLUS] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5944),
    [anon_sym_DOT_STAR] = ACTIONS(5942),
    [anon_sym_DASH_GT] = ACTIONS(5942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5942),
    [anon_sym_decltype] = ACTIONS(5942),
  },
  [2328] = {
    [sym_attribute_specifier] = STATE(2686),
    [sym_field_declaration_list] = STATE(2637),
    [sym_virtual_specifier] = STATE(7044),
    [sym_base_class_clause] = STATE(7605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5495),
    [anon_sym_COMMA] = ACTIONS(5495),
    [anon_sym_LPAREN2] = ACTIONS(5495),
    [anon_sym_DASH] = ACTIONS(5493),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_STAR] = ACTIONS(5495),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_PERCENT] = ACTIONS(5495),
    [anon_sym_PIPE_PIPE] = ACTIONS(5495),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_CARET] = ACTIONS(5495),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5495),
    [anon_sym_BANG_EQ] = ACTIONS(5495),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5493),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5495),
    [anon_sym_GT_GT] = ACTIONS(5493),
    [anon_sym___extension__] = ACTIONS(5495),
    [anon_sym___attribute__] = ACTIONS(6358),
    [anon_sym___attribute] = ACTIONS(6360),
    [anon_sym_COLON] = ACTIONS(5499),
    [anon_sym_LBRACE] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(5495),
    [anon_sym_const] = ACTIONS(5493),
    [anon_sym_constexpr] = ACTIONS(5495),
    [anon_sym_volatile] = ACTIONS(5495),
    [anon_sym_restrict] = ACTIONS(5495),
    [anon_sym___restrict__] = ACTIONS(5495),
    [anon_sym__Atomic] = ACTIONS(5495),
    [anon_sym__Noreturn] = ACTIONS(5495),
    [anon_sym_noreturn] = ACTIONS(5495),
    [anon_sym__Nonnull] = ACTIONS(5495),
    [anon_sym_mutable] = ACTIONS(5495),
    [anon_sym_constinit] = ACTIONS(5495),
    [anon_sym_consteval] = ACTIONS(5495),
    [anon_sym_alignas] = ACTIONS(5495),
    [anon_sym__Alignas] = ACTIONS(5495),
    [anon_sym_QMARK] = ACTIONS(5495),
    [anon_sym_LT_EQ_GT] = ACTIONS(5495),
    [anon_sym_or] = ACTIONS(5495),
    [anon_sym_and] = ACTIONS(5495),
    [anon_sym_bitor] = ACTIONS(5495),
    [anon_sym_xor] = ACTIONS(5495),
    [anon_sym_bitand] = ACTIONS(5495),
    [anon_sym_not_eq] = ACTIONS(5495),
    [anon_sym_DASH_DASH] = ACTIONS(5495),
    [anon_sym_PLUS_PLUS] = ACTIONS(5495),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_DOT_STAR] = ACTIONS(5495),
    [anon_sym_DASH_GT] = ACTIONS(5495),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5495),
    [anon_sym_decltype] = ACTIONS(5495),
    [anon_sym_final] = ACTIONS(6020),
    [anon_sym_override] = ACTIONS(6020),
    [anon_sym_GT2] = ACTIONS(5495),
    [anon_sym_requires] = ACTIONS(5495),
  },
  [2329] = {
    [sym_attribute_specifier] = STATE(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6123),
    [anon_sym_COMMA] = ACTIONS(6123),
    [anon_sym_RPAREN] = ACTIONS(6123),
    [anon_sym_LPAREN2] = ACTIONS(6123),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6123),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6123),
    [anon_sym_PIPE_PIPE] = ACTIONS(6123),
    [anon_sym_AMP_AMP] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6123),
    [anon_sym_AMP] = ACTIONS(6121),
    [anon_sym_EQ_EQ] = ACTIONS(6123),
    [anon_sym_BANG_EQ] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6121),
    [anon_sym_GT_EQ] = ACTIONS(6123),
    [anon_sym_LT_EQ] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_LT_LT] = ACTIONS(6123),
    [anon_sym_GT_GT] = ACTIONS(6123),
    [anon_sym_SEMI] = ACTIONS(6123),
    [anon_sym___extension__] = ACTIONS(6123),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_LBRACE] = ACTIONS(6123),
    [anon_sym_RBRACE] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6123),
    [anon_sym_RBRACK] = ACTIONS(6123),
    [anon_sym_const] = ACTIONS(6121),
    [anon_sym_constexpr] = ACTIONS(6123),
    [anon_sym_volatile] = ACTIONS(6123),
    [anon_sym_restrict] = ACTIONS(6123),
    [anon_sym___restrict__] = ACTIONS(6123),
    [anon_sym__Atomic] = ACTIONS(6123),
    [anon_sym__Noreturn] = ACTIONS(6123),
    [anon_sym_noreturn] = ACTIONS(6123),
    [anon_sym__Nonnull] = ACTIONS(6123),
    [anon_sym_mutable] = ACTIONS(6123),
    [anon_sym_constinit] = ACTIONS(6123),
    [anon_sym_consteval] = ACTIONS(6123),
    [anon_sym_alignas] = ACTIONS(6123),
    [anon_sym__Alignas] = ACTIONS(6123),
    [anon_sym_QMARK] = ACTIONS(6123),
    [anon_sym_LT_EQ_GT] = ACTIONS(6123),
    [anon_sym_or] = ACTIONS(6123),
    [anon_sym_and] = ACTIONS(6123),
    [anon_sym_bitor] = ACTIONS(6123),
    [anon_sym_xor] = ACTIONS(6123),
    [anon_sym_bitand] = ACTIONS(6123),
    [anon_sym_not_eq] = ACTIONS(6123),
    [anon_sym_DASH_DASH] = ACTIONS(6123),
    [anon_sym_PLUS_PLUS] = ACTIONS(6123),
    [anon_sym_DOT] = ACTIONS(6121),
    [anon_sym_DOT_STAR] = ACTIONS(6123),
    [anon_sym_DASH_GT] = ACTIONS(6123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6123),
    [anon_sym_decltype] = ACTIONS(6123),
    [anon_sym_final] = ACTIONS(6123),
    [anon_sym_override] = ACTIONS(6123),
    [anon_sym_requires] = ACTIONS(6123),
  },
  [2330] = {
    [sym_attribute_specifier] = STATE(1842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6170),
    [anon_sym_COMMA] = ACTIONS(6170),
    [anon_sym_RPAREN] = ACTIONS(6170),
    [anon_sym_LPAREN2] = ACTIONS(6170),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6170),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_PERCENT] = ACTIONS(6170),
    [anon_sym_PIPE_PIPE] = ACTIONS(6170),
    [anon_sym_AMP_AMP] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6170),
    [anon_sym_AMP] = ACTIONS(6168),
    [anon_sym_EQ_EQ] = ACTIONS(6170),
    [anon_sym_BANG_EQ] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6168),
    [anon_sym_GT_EQ] = ACTIONS(6170),
    [anon_sym_LT_EQ] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6168),
    [anon_sym_LT_LT] = ACTIONS(6170),
    [anon_sym_GT_GT] = ACTIONS(6170),
    [anon_sym_SEMI] = ACTIONS(6170),
    [anon_sym___extension__] = ACTIONS(6170),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_LBRACE] = ACTIONS(6170),
    [anon_sym_RBRACE] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6170),
    [anon_sym_RBRACK] = ACTIONS(6170),
    [anon_sym_const] = ACTIONS(6168),
    [anon_sym_constexpr] = ACTIONS(6170),
    [anon_sym_volatile] = ACTIONS(6170),
    [anon_sym_restrict] = ACTIONS(6170),
    [anon_sym___restrict__] = ACTIONS(6170),
    [anon_sym__Atomic] = ACTIONS(6170),
    [anon_sym__Noreturn] = ACTIONS(6170),
    [anon_sym_noreturn] = ACTIONS(6170),
    [anon_sym__Nonnull] = ACTIONS(6170),
    [anon_sym_mutable] = ACTIONS(6170),
    [anon_sym_constinit] = ACTIONS(6170),
    [anon_sym_consteval] = ACTIONS(6170),
    [anon_sym_alignas] = ACTIONS(6170),
    [anon_sym__Alignas] = ACTIONS(6170),
    [anon_sym_QMARK] = ACTIONS(6170),
    [anon_sym_LT_EQ_GT] = ACTIONS(6170),
    [anon_sym_or] = ACTIONS(6170),
    [anon_sym_and] = ACTIONS(6170),
    [anon_sym_bitor] = ACTIONS(6170),
    [anon_sym_xor] = ACTIONS(6170),
    [anon_sym_bitand] = ACTIONS(6170),
    [anon_sym_not_eq] = ACTIONS(6170),
    [anon_sym_DASH_DASH] = ACTIONS(6170),
    [anon_sym_PLUS_PLUS] = ACTIONS(6170),
    [anon_sym_DOT] = ACTIONS(6168),
    [anon_sym_DOT_STAR] = ACTIONS(6170),
    [anon_sym_DASH_GT] = ACTIONS(6170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6170),
    [anon_sym_decltype] = ACTIONS(6170),
    [anon_sym_final] = ACTIONS(6170),
    [anon_sym_override] = ACTIONS(6170),
    [anon_sym_requires] = ACTIONS(6170),
  },
  [2331] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_RPAREN] = ACTIONS(5920),
    [anon_sym_LPAREN2] = ACTIONS(5920),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_STAR] = ACTIONS(5922),
    [anon_sym_SLASH] = ACTIONS(5922),
    [anon_sym_PERCENT] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_AMP_AMP] = ACTIONS(5920),
    [anon_sym_PIPE] = ACTIONS(5922),
    [anon_sym_CARET] = ACTIONS(5922),
    [anon_sym_AMP] = ACTIONS(5922),
    [anon_sym_EQ_EQ] = ACTIONS(5920),
    [anon_sym_BANG_EQ] = ACTIONS(5920),
    [anon_sym_GT] = ACTIONS(5922),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_LT] = ACTIONS(5922),
    [anon_sym_LT_LT] = ACTIONS(5922),
    [anon_sym_GT_GT] = ACTIONS(5922),
    [anon_sym_SEMI] = ACTIONS(5920),
    [anon_sym___attribute__] = ACTIONS(5920),
    [anon_sym___attribute] = ACTIONS(5922),
    [anon_sym_COLON] = ACTIONS(5920),
    [anon_sym_LBRACE] = ACTIONS(5920),
    [anon_sym_RBRACE] = ACTIONS(5920),
    [anon_sym_signed] = ACTIONS(6364),
    [anon_sym_unsigned] = ACTIONS(6364),
    [anon_sym_long] = ACTIONS(6364),
    [anon_sym_short] = ACTIONS(6364),
    [anon_sym_LBRACK] = ACTIONS(5920),
    [anon_sym_RBRACK] = ACTIONS(5920),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_QMARK] = ACTIONS(5920),
    [anon_sym_STAR_EQ] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_PERCENT_EQ] = ACTIONS(5920),
    [anon_sym_PLUS_EQ] = ACTIONS(5920),
    [anon_sym_DASH_EQ] = ACTIONS(5920),
    [anon_sym_LT_LT_EQ] = ACTIONS(5920),
    [anon_sym_GT_GT_EQ] = ACTIONS(5920),
    [anon_sym_AMP_EQ] = ACTIONS(5920),
    [anon_sym_CARET_EQ] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_and_eq] = ACTIONS(5920),
    [anon_sym_or_eq] = ACTIONS(5920),
    [anon_sym_xor_eq] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_or] = ACTIONS(5922),
    [anon_sym_and] = ACTIONS(5922),
    [anon_sym_bitor] = ACTIONS(5920),
    [anon_sym_xor] = ACTIONS(5922),
    [anon_sym_bitand] = ACTIONS(5920),
    [anon_sym_not_eq] = ACTIONS(5920),
    [anon_sym_DASH_DASH] = ACTIONS(5920),
    [anon_sym_PLUS_PLUS] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_DOT_STAR] = ACTIONS(5920),
    [anon_sym_DASH_GT] = ACTIONS(5920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5920),
    [anon_sym_decltype] = ACTIONS(5920),
  },
  [2332] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(5888),
    [anon_sym_LPAREN2] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5890),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_SLASH] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5888),
    [anon_sym_AMP_AMP] = ACTIONS(5888),
    [anon_sym_PIPE] = ACTIONS(5890),
    [anon_sym_CARET] = ACTIONS(5888),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_EQ_EQ] = ACTIONS(5888),
    [anon_sym_BANG_EQ] = ACTIONS(5888),
    [anon_sym_GT] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_LT_EQ] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5890),
    [anon_sym_LT_LT] = ACTIONS(5888),
    [anon_sym_GT_GT] = ACTIONS(5890),
    [anon_sym___extension__] = ACTIONS(5888),
    [anon_sym___attribute__] = ACTIONS(5888),
    [anon_sym___attribute] = ACTIONS(5890),
    [anon_sym_LBRACE] = ACTIONS(5888),
    [anon_sym_signed] = ACTIONS(6356),
    [anon_sym_unsigned] = ACTIONS(6356),
    [anon_sym_long] = ACTIONS(6356),
    [anon_sym_short] = ACTIONS(6356),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_const] = ACTIONS(5890),
    [anon_sym_constexpr] = ACTIONS(5888),
    [anon_sym_volatile] = ACTIONS(5888),
    [anon_sym_restrict] = ACTIONS(5888),
    [anon_sym___restrict__] = ACTIONS(5888),
    [anon_sym__Atomic] = ACTIONS(5888),
    [anon_sym__Noreturn] = ACTIONS(5888),
    [anon_sym_noreturn] = ACTIONS(5888),
    [anon_sym__Nonnull] = ACTIONS(5888),
    [anon_sym_mutable] = ACTIONS(5888),
    [anon_sym_constinit] = ACTIONS(5888),
    [anon_sym_consteval] = ACTIONS(5888),
    [anon_sym_alignas] = ACTIONS(5888),
    [anon_sym__Alignas] = ACTIONS(5888),
    [anon_sym_QMARK] = ACTIONS(5888),
    [anon_sym_LT_EQ_GT] = ACTIONS(5888),
    [anon_sym_or] = ACTIONS(5888),
    [anon_sym_and] = ACTIONS(5888),
    [anon_sym_bitor] = ACTIONS(5888),
    [anon_sym_xor] = ACTIONS(5888),
    [anon_sym_bitand] = ACTIONS(5888),
    [anon_sym_not_eq] = ACTIONS(5888),
    [anon_sym_DASH_DASH] = ACTIONS(5888),
    [anon_sym_PLUS_PLUS] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5890),
    [anon_sym_DOT_STAR] = ACTIONS(5888),
    [anon_sym_DASH_GT] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5888),
    [anon_sym_decltype] = ACTIONS(5888),
    [anon_sym_final] = ACTIONS(5888),
    [anon_sym_override] = ACTIONS(5888),
    [anon_sym_GT2] = ACTIONS(5888),
    [anon_sym_requires] = ACTIONS(5888),
  },
  [2333] = {
    [sym_identifier] = ACTIONS(5577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5579),
    [anon_sym_COMMA] = ACTIONS(5579),
    [anon_sym_LPAREN2] = ACTIONS(5579),
    [anon_sym_DASH] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5577),
    [anon_sym_STAR] = ACTIONS(5577),
    [anon_sym_SLASH] = ACTIONS(5577),
    [anon_sym_PERCENT] = ACTIONS(5577),
    [anon_sym_PIPE_PIPE] = ACTIONS(5579),
    [anon_sym_AMP_AMP] = ACTIONS(5579),
    [anon_sym_PIPE] = ACTIONS(5577),
    [anon_sym_CARET] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5577),
    [anon_sym_EQ_EQ] = ACTIONS(5579),
    [anon_sym_BANG_EQ] = ACTIONS(5579),
    [anon_sym_GT] = ACTIONS(5577),
    [anon_sym_GT_EQ] = ACTIONS(5579),
    [anon_sym_LT_EQ] = ACTIONS(5577),
    [anon_sym_LT] = ACTIONS(5577),
    [anon_sym_LT_LT] = ACTIONS(5577),
    [anon_sym_GT_GT] = ACTIONS(5577),
    [anon_sym_SEMI] = ACTIONS(5579),
    [anon_sym___attribute__] = ACTIONS(5577),
    [anon_sym___attribute] = ACTIONS(5577),
    [anon_sym_LBRACK] = ACTIONS(5579),
    [anon_sym_EQ] = ACTIONS(5577),
    [anon_sym_QMARK] = ACTIONS(5579),
    [anon_sym_STAR_EQ] = ACTIONS(5579),
    [anon_sym_SLASH_EQ] = ACTIONS(5579),
    [anon_sym_PERCENT_EQ] = ACTIONS(5579),
    [anon_sym_PLUS_EQ] = ACTIONS(5579),
    [anon_sym_DASH_EQ] = ACTIONS(5579),
    [anon_sym_LT_LT_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_AMP_EQ] = ACTIONS(5579),
    [anon_sym_CARET_EQ] = ACTIONS(5579),
    [anon_sym_PIPE_EQ] = ACTIONS(5579),
    [anon_sym_and_eq] = ACTIONS(5577),
    [anon_sym_or_eq] = ACTIONS(5577),
    [anon_sym_xor_eq] = ACTIONS(5577),
    [anon_sym_LT_EQ_GT] = ACTIONS(5579),
    [anon_sym_or] = ACTIONS(5577),
    [anon_sym_and] = ACTIONS(5577),
    [anon_sym_bitor] = ACTIONS(5577),
    [anon_sym_xor] = ACTIONS(5577),
    [anon_sym_bitand] = ACTIONS(5577),
    [anon_sym_not_eq] = ACTIONS(5577),
    [anon_sym_DASH_DASH] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5579),
    [anon_sym_DOT] = ACTIONS(5577),
    [anon_sym_DOT_STAR] = ACTIONS(5579),
    [anon_sym_DASH_GT] = ACTIONS(5579),
    [anon_sym_L_DQUOTE] = ACTIONS(5579),
    [anon_sym_u_DQUOTE] = ACTIONS(5579),
    [anon_sym_U_DQUOTE] = ACTIONS(5579),
    [anon_sym_u8_DQUOTE] = ACTIONS(5579),
    [anon_sym_DQUOTE] = ACTIONS(5579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5579),
    [anon_sym_LR_DQUOTE] = ACTIONS(5579),
    [anon_sym_uR_DQUOTE] = ACTIONS(5579),
    [anon_sym_UR_DQUOTE] = ACTIONS(5579),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5579),
    [sym_literal_suffix] = ACTIONS(5577),
  },
  [2334] = {
    [sym_attribute_specifier] = STATE(1865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6119),
    [anon_sym_COMMA] = ACTIONS(6119),
    [anon_sym_RPAREN] = ACTIONS(6119),
    [anon_sym_LPAREN2] = ACTIONS(6119),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_STAR] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6117),
    [anon_sym_PERCENT] = ACTIONS(6119),
    [anon_sym_PIPE_PIPE] = ACTIONS(6119),
    [anon_sym_AMP_AMP] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6117),
    [anon_sym_CARET] = ACTIONS(6119),
    [anon_sym_AMP] = ACTIONS(6117),
    [anon_sym_EQ_EQ] = ACTIONS(6119),
    [anon_sym_BANG_EQ] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6117),
    [anon_sym_GT_EQ] = ACTIONS(6119),
    [anon_sym_LT_EQ] = ACTIONS(6117),
    [anon_sym_LT] = ACTIONS(6117),
    [anon_sym_LT_LT] = ACTIONS(6119),
    [anon_sym_GT_GT] = ACTIONS(6119),
    [anon_sym_SEMI] = ACTIONS(6119),
    [anon_sym___extension__] = ACTIONS(6119),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_LBRACE] = ACTIONS(6119),
    [anon_sym_RBRACE] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6119),
    [anon_sym_RBRACK] = ACTIONS(6119),
    [anon_sym_const] = ACTIONS(6117),
    [anon_sym_constexpr] = ACTIONS(6119),
    [anon_sym_volatile] = ACTIONS(6119),
    [anon_sym_restrict] = ACTIONS(6119),
    [anon_sym___restrict__] = ACTIONS(6119),
    [anon_sym__Atomic] = ACTIONS(6119),
    [anon_sym__Noreturn] = ACTIONS(6119),
    [anon_sym_noreturn] = ACTIONS(6119),
    [anon_sym__Nonnull] = ACTIONS(6119),
    [anon_sym_mutable] = ACTIONS(6119),
    [anon_sym_constinit] = ACTIONS(6119),
    [anon_sym_consteval] = ACTIONS(6119),
    [anon_sym_alignas] = ACTIONS(6119),
    [anon_sym__Alignas] = ACTIONS(6119),
    [anon_sym_QMARK] = ACTIONS(6119),
    [anon_sym_LT_EQ_GT] = ACTIONS(6119),
    [anon_sym_or] = ACTIONS(6119),
    [anon_sym_and] = ACTIONS(6119),
    [anon_sym_bitor] = ACTIONS(6119),
    [anon_sym_xor] = ACTIONS(6119),
    [anon_sym_bitand] = ACTIONS(6119),
    [anon_sym_not_eq] = ACTIONS(6119),
    [anon_sym_DASH_DASH] = ACTIONS(6119),
    [anon_sym_PLUS_PLUS] = ACTIONS(6119),
    [anon_sym_DOT] = ACTIONS(6117),
    [anon_sym_DOT_STAR] = ACTIONS(6119),
    [anon_sym_DASH_GT] = ACTIONS(6119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6119),
    [anon_sym_decltype] = ACTIONS(6119),
    [anon_sym_final] = ACTIONS(6119),
    [anon_sym_override] = ACTIONS(6119),
    [anon_sym_requires] = ACTIONS(6119),
  },
  [2335] = {
    [sym_attribute_specifier] = STATE(1840),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6153),
    [anon_sym_COMMA] = ACTIONS(6153),
    [anon_sym_RPAREN] = ACTIONS(6153),
    [anon_sym_LPAREN2] = ACTIONS(6153),
    [anon_sym_DASH] = ACTIONS(6151),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_STAR] = ACTIONS(6153),
    [anon_sym_SLASH] = ACTIONS(6151),
    [anon_sym_PERCENT] = ACTIONS(6153),
    [anon_sym_PIPE_PIPE] = ACTIONS(6153),
    [anon_sym_AMP_AMP] = ACTIONS(6153),
    [anon_sym_PIPE] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6153),
    [anon_sym_AMP] = ACTIONS(6151),
    [anon_sym_EQ_EQ] = ACTIONS(6153),
    [anon_sym_BANG_EQ] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(6151),
    [anon_sym_GT_EQ] = ACTIONS(6153),
    [anon_sym_LT_EQ] = ACTIONS(6151),
    [anon_sym_LT] = ACTIONS(6151),
    [anon_sym_LT_LT] = ACTIONS(6153),
    [anon_sym_GT_GT] = ACTIONS(6153),
    [anon_sym_SEMI] = ACTIONS(6153),
    [anon_sym___extension__] = ACTIONS(6153),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6153),
    [anon_sym_LBRACE] = ACTIONS(6153),
    [anon_sym_RBRACE] = ACTIONS(6153),
    [anon_sym_LBRACK] = ACTIONS(6153),
    [anon_sym_RBRACK] = ACTIONS(6153),
    [anon_sym_const] = ACTIONS(6151),
    [anon_sym_constexpr] = ACTIONS(6153),
    [anon_sym_volatile] = ACTIONS(6153),
    [anon_sym_restrict] = ACTIONS(6153),
    [anon_sym___restrict__] = ACTIONS(6153),
    [anon_sym__Atomic] = ACTIONS(6153),
    [anon_sym__Noreturn] = ACTIONS(6153),
    [anon_sym_noreturn] = ACTIONS(6153),
    [anon_sym__Nonnull] = ACTIONS(6153),
    [anon_sym_mutable] = ACTIONS(6153),
    [anon_sym_constinit] = ACTIONS(6153),
    [anon_sym_consteval] = ACTIONS(6153),
    [anon_sym_alignas] = ACTIONS(6153),
    [anon_sym__Alignas] = ACTIONS(6153),
    [anon_sym_QMARK] = ACTIONS(6153),
    [anon_sym_LT_EQ_GT] = ACTIONS(6153),
    [anon_sym_or] = ACTIONS(6153),
    [anon_sym_and] = ACTIONS(6153),
    [anon_sym_bitor] = ACTIONS(6153),
    [anon_sym_xor] = ACTIONS(6153),
    [anon_sym_bitand] = ACTIONS(6153),
    [anon_sym_not_eq] = ACTIONS(6153),
    [anon_sym_DASH_DASH] = ACTIONS(6153),
    [anon_sym_PLUS_PLUS] = ACTIONS(6153),
    [anon_sym_DOT] = ACTIONS(6151),
    [anon_sym_DOT_STAR] = ACTIONS(6153),
    [anon_sym_DASH_GT] = ACTIONS(6153),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6153),
    [anon_sym_decltype] = ACTIONS(6153),
    [anon_sym_final] = ACTIONS(6153),
    [anon_sym_override] = ACTIONS(6153),
    [anon_sym_requires] = ACTIONS(6153),
  },
  [2336] = {
    [sym_attribute_specifier] = STATE(1850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6157),
    [anon_sym_COMMA] = ACTIONS(6157),
    [anon_sym_RPAREN] = ACTIONS(6157),
    [anon_sym_LPAREN2] = ACTIONS(6157),
    [anon_sym_DASH] = ACTIONS(6155),
    [anon_sym_PLUS] = ACTIONS(6155),
    [anon_sym_STAR] = ACTIONS(6157),
    [anon_sym_SLASH] = ACTIONS(6155),
    [anon_sym_PERCENT] = ACTIONS(6157),
    [anon_sym_PIPE_PIPE] = ACTIONS(6157),
    [anon_sym_AMP_AMP] = ACTIONS(6157),
    [anon_sym_PIPE] = ACTIONS(6155),
    [anon_sym_CARET] = ACTIONS(6157),
    [anon_sym_AMP] = ACTIONS(6155),
    [anon_sym_EQ_EQ] = ACTIONS(6157),
    [anon_sym_BANG_EQ] = ACTIONS(6157),
    [anon_sym_GT] = ACTIONS(6155),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [anon_sym_LT_EQ] = ACTIONS(6155),
    [anon_sym_LT] = ACTIONS(6155),
    [anon_sym_LT_LT] = ACTIONS(6157),
    [anon_sym_GT_GT] = ACTIONS(6157),
    [anon_sym_SEMI] = ACTIONS(6157),
    [anon_sym___extension__] = ACTIONS(6157),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6157),
    [anon_sym_LBRACE] = ACTIONS(6157),
    [anon_sym_RBRACE] = ACTIONS(6157),
    [anon_sym_LBRACK] = ACTIONS(6157),
    [anon_sym_RBRACK] = ACTIONS(6157),
    [anon_sym_const] = ACTIONS(6155),
    [anon_sym_constexpr] = ACTIONS(6157),
    [anon_sym_volatile] = ACTIONS(6157),
    [anon_sym_restrict] = ACTIONS(6157),
    [anon_sym___restrict__] = ACTIONS(6157),
    [anon_sym__Atomic] = ACTIONS(6157),
    [anon_sym__Noreturn] = ACTIONS(6157),
    [anon_sym_noreturn] = ACTIONS(6157),
    [anon_sym__Nonnull] = ACTIONS(6157),
    [anon_sym_mutable] = ACTIONS(6157),
    [anon_sym_constinit] = ACTIONS(6157),
    [anon_sym_consteval] = ACTIONS(6157),
    [anon_sym_alignas] = ACTIONS(6157),
    [anon_sym__Alignas] = ACTIONS(6157),
    [anon_sym_QMARK] = ACTIONS(6157),
    [anon_sym_LT_EQ_GT] = ACTIONS(6157),
    [anon_sym_or] = ACTIONS(6157),
    [anon_sym_and] = ACTIONS(6157),
    [anon_sym_bitor] = ACTIONS(6157),
    [anon_sym_xor] = ACTIONS(6157),
    [anon_sym_bitand] = ACTIONS(6157),
    [anon_sym_not_eq] = ACTIONS(6157),
    [anon_sym_DASH_DASH] = ACTIONS(6157),
    [anon_sym_PLUS_PLUS] = ACTIONS(6157),
    [anon_sym_DOT] = ACTIONS(6155),
    [anon_sym_DOT_STAR] = ACTIONS(6157),
    [anon_sym_DASH_GT] = ACTIONS(6157),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6157),
    [anon_sym_decltype] = ACTIONS(6157),
    [anon_sym_final] = ACTIONS(6157),
    [anon_sym_override] = ACTIONS(6157),
    [anon_sym_requires] = ACTIONS(6157),
  },
  [2337] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_LPAREN2] = ACTIONS(5920),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_STAR] = ACTIONS(5920),
    [anon_sym_SLASH] = ACTIONS(5922),
    [anon_sym_PERCENT] = ACTIONS(5920),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_AMP_AMP] = ACTIONS(5920),
    [anon_sym_PIPE] = ACTIONS(5922),
    [anon_sym_CARET] = ACTIONS(5920),
    [anon_sym_AMP] = ACTIONS(5922),
    [anon_sym_EQ_EQ] = ACTIONS(5920),
    [anon_sym_BANG_EQ] = ACTIONS(5920),
    [anon_sym_GT] = ACTIONS(5922),
    [anon_sym_GT_EQ] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_LT] = ACTIONS(5922),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5922),
    [anon_sym___extension__] = ACTIONS(5920),
    [anon_sym___attribute__] = ACTIONS(5920),
    [anon_sym___attribute] = ACTIONS(5922),
    [anon_sym_LBRACE] = ACTIONS(5920),
    [anon_sym_signed] = ACTIONS(6366),
    [anon_sym_unsigned] = ACTIONS(6366),
    [anon_sym_long] = ACTIONS(6366),
    [anon_sym_short] = ACTIONS(6366),
    [anon_sym_LBRACK] = ACTIONS(5920),
    [anon_sym_const] = ACTIONS(5922),
    [anon_sym_constexpr] = ACTIONS(5920),
    [anon_sym_volatile] = ACTIONS(5920),
    [anon_sym_restrict] = ACTIONS(5920),
    [anon_sym___restrict__] = ACTIONS(5920),
    [anon_sym__Atomic] = ACTIONS(5920),
    [anon_sym__Noreturn] = ACTIONS(5920),
    [anon_sym_noreturn] = ACTIONS(5920),
    [anon_sym__Nonnull] = ACTIONS(5920),
    [anon_sym_mutable] = ACTIONS(5920),
    [anon_sym_constinit] = ACTIONS(5920),
    [anon_sym_consteval] = ACTIONS(5920),
    [anon_sym_alignas] = ACTIONS(5920),
    [anon_sym__Alignas] = ACTIONS(5920),
    [anon_sym_QMARK] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_or] = ACTIONS(5920),
    [anon_sym_and] = ACTIONS(5920),
    [anon_sym_bitor] = ACTIONS(5920),
    [anon_sym_xor] = ACTIONS(5920),
    [anon_sym_bitand] = ACTIONS(5920),
    [anon_sym_not_eq] = ACTIONS(5920),
    [anon_sym_DASH_DASH] = ACTIONS(5920),
    [anon_sym_PLUS_PLUS] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_DOT_STAR] = ACTIONS(5920),
    [anon_sym_DASH_GT] = ACTIONS(5920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5920),
    [anon_sym_decltype] = ACTIONS(5920),
    [anon_sym_final] = ACTIONS(5920),
    [anon_sym_override] = ACTIONS(5920),
    [anon_sym_GT2] = ACTIONS(5920),
    [anon_sym_requires] = ACTIONS(5920),
  },
  [2338] = {
    [sym_identifier] = ACTIONS(5005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4998),
    [anon_sym_COMMA] = ACTIONS(4998),
    [anon_sym_RPAREN] = ACTIONS(4998),
    [aux_sym_preproc_if_token2] = ACTIONS(4998),
    [aux_sym_preproc_else_token1] = ACTIONS(4998),
    [aux_sym_preproc_elif_token1] = ACTIONS(5005),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4998),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(4998),
    [anon_sym_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5005),
    [anon_sym_SLASH] = ACTIONS(5005),
    [anon_sym_PERCENT] = ACTIONS(5005),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_PIPE] = ACTIONS(5005),
    [anon_sym_CARET] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5005),
    [anon_sym_EQ_EQ] = ACTIONS(4998),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_GT] = ACTIONS(5005),
    [anon_sym_GT_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(5005),
    [anon_sym_LT] = ACTIONS(5005),
    [anon_sym_LT_LT] = ACTIONS(5005),
    [anon_sym_GT_GT] = ACTIONS(5005),
    [anon_sym_SEMI] = ACTIONS(4998),
    [anon_sym___attribute__] = ACTIONS(5005),
    [anon_sym___attribute] = ACTIONS(5005),
    [anon_sym_COLON] = ACTIONS(5005),
    [anon_sym_COLON_COLON] = ACTIONS(5003),
    [anon_sym_LBRACE] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(4998),
    [anon_sym_RBRACK] = ACTIONS(4998),
    [anon_sym_EQ] = ACTIONS(5005),
    [anon_sym_QMARK] = ACTIONS(4998),
    [anon_sym_STAR_EQ] = ACTIONS(4998),
    [anon_sym_SLASH_EQ] = ACTIONS(4998),
    [anon_sym_PERCENT_EQ] = ACTIONS(4998),
    [anon_sym_PLUS_EQ] = ACTIONS(4998),
    [anon_sym_DASH_EQ] = ACTIONS(4998),
    [anon_sym_LT_LT_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT_EQ] = ACTIONS(4998),
    [anon_sym_AMP_EQ] = ACTIONS(4998),
    [anon_sym_CARET_EQ] = ACTIONS(4998),
    [anon_sym_PIPE_EQ] = ACTIONS(4998),
    [anon_sym_and_eq] = ACTIONS(5005),
    [anon_sym_or_eq] = ACTIONS(5005),
    [anon_sym_xor_eq] = ACTIONS(5005),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_or] = ACTIONS(5005),
    [anon_sym_and] = ACTIONS(5005),
    [anon_sym_bitor] = ACTIONS(5005),
    [anon_sym_xor] = ACTIONS(5005),
    [anon_sym_bitand] = ACTIONS(5005),
    [anon_sym_not_eq] = ACTIONS(5005),
    [anon_sym_DASH_DASH] = ACTIONS(4998),
    [anon_sym_PLUS_PLUS] = ACTIONS(4998),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_DOT_STAR] = ACTIONS(4998),
    [anon_sym_DASH_GT] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2339] = {
    [sym_identifier] = ACTIONS(5489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_LPAREN2] = ACTIONS(5491),
    [anon_sym_DASH] = ACTIONS(5489),
    [anon_sym_PLUS] = ACTIONS(5489),
    [anon_sym_STAR] = ACTIONS(5489),
    [anon_sym_SLASH] = ACTIONS(5489),
    [anon_sym_PERCENT] = ACTIONS(5489),
    [anon_sym_PIPE_PIPE] = ACTIONS(5491),
    [anon_sym_AMP_AMP] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_CARET] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5489),
    [anon_sym_EQ_EQ] = ACTIONS(5491),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_GT] = ACTIONS(5489),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5489),
    [anon_sym_LT] = ACTIONS(5489),
    [anon_sym_LT_LT] = ACTIONS(5489),
    [anon_sym_GT_GT] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym___attribute__] = ACTIONS(5489),
    [anon_sym___attribute] = ACTIONS(5489),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_EQ] = ACTIONS(5489),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_STAR_EQ] = ACTIONS(5491),
    [anon_sym_SLASH_EQ] = ACTIONS(5491),
    [anon_sym_PERCENT_EQ] = ACTIONS(5491),
    [anon_sym_PLUS_EQ] = ACTIONS(5491),
    [anon_sym_DASH_EQ] = ACTIONS(5491),
    [anon_sym_LT_LT_EQ] = ACTIONS(5491),
    [anon_sym_GT_GT_EQ] = ACTIONS(5491),
    [anon_sym_AMP_EQ] = ACTIONS(5491),
    [anon_sym_CARET_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_and_eq] = ACTIONS(5489),
    [anon_sym_or_eq] = ACTIONS(5489),
    [anon_sym_xor_eq] = ACTIONS(5489),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5489),
    [anon_sym_and] = ACTIONS(5489),
    [anon_sym_bitor] = ACTIONS(5489),
    [anon_sym_xor] = ACTIONS(5489),
    [anon_sym_bitand] = ACTIONS(5489),
    [anon_sym_not_eq] = ACTIONS(5489),
    [anon_sym_DASH_DASH] = ACTIONS(5491),
    [anon_sym_PLUS_PLUS] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5489),
    [anon_sym_DOT_STAR] = ACTIONS(5491),
    [anon_sym_DASH_GT] = ACTIONS(5491),
    [anon_sym_L_DQUOTE] = ACTIONS(5491),
    [anon_sym_u_DQUOTE] = ACTIONS(5491),
    [anon_sym_U_DQUOTE] = ACTIONS(5491),
    [anon_sym_u8_DQUOTE] = ACTIONS(5491),
    [anon_sym_DQUOTE] = ACTIONS(5491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5491),
    [anon_sym_LR_DQUOTE] = ACTIONS(5491),
    [anon_sym_uR_DQUOTE] = ACTIONS(5491),
    [anon_sym_UR_DQUOTE] = ACTIONS(5491),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5491),
    [sym_literal_suffix] = ACTIONS(5489),
  },
  [2340] = {
    [sym_ms_based_modifier] = STATE(8682),
    [sym_ms_unaligned_ptr_modifier] = STATE(4043),
    [sym_ms_pointer_modifier] = STATE(3820),
    [sym__declarator] = STATE(6447),
    [sym__abstract_declarator] = STATE(6687),
    [sym_parenthesized_declarator] = STATE(5998),
    [sym_abstract_parenthesized_declarator] = STATE(6092),
    [sym_attributed_declarator] = STATE(5998),
    [sym_pointer_declarator] = STATE(5998),
    [sym_abstract_pointer_declarator] = STATE(6092),
    [sym_function_declarator] = STATE(5998),
    [sym_abstract_function_declarator] = STATE(6092),
    [sym_array_declarator] = STATE(5998),
    [sym_abstract_array_declarator] = STATE(6092),
    [sym_type_qualifier] = STATE(2847),
    [sym_alignas_qualifier] = STATE(4289),
    [sym_parameter_list] = STATE(3004),
    [sym_decltype] = STATE(8601),
    [sym_reference_declarator] = STATE(5998),
    [sym_abstract_reference_declarator] = STATE(6092),
    [sym_structured_binding_declarator] = STATE(5998),
    [sym__function_declarator_seq] = STATE(6087),
    [sym_template_type] = STATE(8601),
    [sym_template_function] = STATE(5998),
    [sym_destructor_name] = STATE(5998),
    [sym_dependent_type_identifier] = STATE(8601),
    [sym__scope_resolution] = STATE(5847),
    [sym_qualified_identifier] = STATE(5998),
    [sym_operator_name] = STATE(5998),
    [aux_sym__type_definition_type_repeat1] = STATE(2847),
    [aux_sym_pointer_declarator_repeat1] = STATE(3820),
    [sym_identifier] = ACTIONS(5460),
    [anon_sym_RPAREN] = ACTIONS(5865),
    [anon_sym_LPAREN2] = ACTIONS(4298),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(4300),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_AMP] = ACTIONS(4304),
    [anon_sym___extension__] = ACTIONS(3331),
    [anon_sym_COLON_COLON] = ACTIONS(6321),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(3327),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3327),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3327),
    [anon_sym__unaligned] = ACTIONS(3329),
    [anon_sym___unaligned] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(5863),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_constexpr] = ACTIONS(3331),
    [anon_sym_volatile] = ACTIONS(3331),
    [anon_sym_restrict] = ACTIONS(3331),
    [anon_sym___restrict__] = ACTIONS(3331),
    [anon_sym__Atomic] = ACTIONS(3331),
    [anon_sym__Noreturn] = ACTIONS(3331),
    [anon_sym_noreturn] = ACTIONS(3331),
    [anon_sym__Nonnull] = ACTIONS(3331),
    [anon_sym_mutable] = ACTIONS(3331),
    [anon_sym_constinit] = ACTIONS(3331),
    [anon_sym_consteval] = ACTIONS(3331),
    [anon_sym_alignas] = ACTIONS(3333),
    [anon_sym__Alignas] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1978),
    [anon_sym_template] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1852),
  },
  [2341] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_LPAREN2] = ACTIONS(5752),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_STAR] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_PIPE] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5750),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_LT] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym___extension__] = ACTIONS(5752),
    [anon_sym___attribute__] = ACTIONS(5752),
    [anon_sym___attribute] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5752),
    [anon_sym_signed] = ACTIONS(6346),
    [anon_sym_unsigned] = ACTIONS(6346),
    [anon_sym_long] = ACTIONS(6346),
    [anon_sym_short] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_const] = ACTIONS(5750),
    [anon_sym_constexpr] = ACTIONS(5752),
    [anon_sym_volatile] = ACTIONS(5752),
    [anon_sym_restrict] = ACTIONS(5752),
    [anon_sym___restrict__] = ACTIONS(5752),
    [anon_sym__Atomic] = ACTIONS(5752),
    [anon_sym__Noreturn] = ACTIONS(5752),
    [anon_sym_noreturn] = ACTIONS(5752),
    [anon_sym__Nonnull] = ACTIONS(5752),
    [anon_sym_mutable] = ACTIONS(5752),
    [anon_sym_constinit] = ACTIONS(5752),
    [anon_sym_consteval] = ACTIONS(5752),
    [anon_sym_alignas] = ACTIONS(5752),
    [anon_sym__Alignas] = ACTIONS(5752),
    [anon_sym_QMARK] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_or] = ACTIONS(5752),
    [anon_sym_and] = ACTIONS(5752),
    [anon_sym_bitor] = ACTIONS(5752),
    [anon_sym_xor] = ACTIONS(5752),
    [anon_sym_bitand] = ACTIONS(5752),
    [anon_sym_not_eq] = ACTIONS(5752),
    [anon_sym_DASH_DASH] = ACTIONS(5752),
    [anon_sym_PLUS_PLUS] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_DOT_STAR] = ACTIONS(5752),
    [anon_sym_DASH_GT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5752),
    [anon_sym_decltype] = ACTIONS(5752),
    [anon_sym_final] = ACTIONS(5752),
    [anon_sym_override] = ACTIONS(5752),
    [anon_sym_GT2] = ACTIONS(5752),
    [anon_sym_requires] = ACTIONS(5752),
  },
  [2342] = {
    [sym_identifier] = ACTIONS(5478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5480),
    [anon_sym_COMMA] = ACTIONS(5480),
    [anon_sym_LPAREN2] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5478),
    [anon_sym_PLUS] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(5478),
    [anon_sym_SLASH] = ACTIONS(5478),
    [anon_sym_PERCENT] = ACTIONS(5478),
    [anon_sym_PIPE_PIPE] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_PIPE] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5478),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym_EQ_EQ] = ACTIONS(5480),
    [anon_sym_BANG_EQ] = ACTIONS(5480),
    [anon_sym_GT] = ACTIONS(5478),
    [anon_sym_GT_EQ] = ACTIONS(5480),
    [anon_sym_LT_EQ] = ACTIONS(5478),
    [anon_sym_LT] = ACTIONS(5478),
    [anon_sym_LT_LT] = ACTIONS(5478),
    [anon_sym_GT_GT] = ACTIONS(5478),
    [anon_sym_SEMI] = ACTIONS(5480),
    [anon_sym___attribute__] = ACTIONS(5478),
    [anon_sym___attribute] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5480),
    [anon_sym_EQ] = ACTIONS(5478),
    [anon_sym_QMARK] = ACTIONS(5480),
    [anon_sym_STAR_EQ] = ACTIONS(5480),
    [anon_sym_SLASH_EQ] = ACTIONS(5480),
    [anon_sym_PERCENT_EQ] = ACTIONS(5480),
    [anon_sym_PLUS_EQ] = ACTIONS(5480),
    [anon_sym_DASH_EQ] = ACTIONS(5480),
    [anon_sym_LT_LT_EQ] = ACTIONS(5480),
    [anon_sym_GT_GT_EQ] = ACTIONS(5480),
    [anon_sym_AMP_EQ] = ACTIONS(5480),
    [anon_sym_CARET_EQ] = ACTIONS(5480),
    [anon_sym_PIPE_EQ] = ACTIONS(5480),
    [anon_sym_and_eq] = ACTIONS(5478),
    [anon_sym_or_eq] = ACTIONS(5478),
    [anon_sym_xor_eq] = ACTIONS(5478),
    [anon_sym_LT_EQ_GT] = ACTIONS(5480),
    [anon_sym_or] = ACTIONS(5478),
    [anon_sym_and] = ACTIONS(5478),
    [anon_sym_bitor] = ACTIONS(5478),
    [anon_sym_xor] = ACTIONS(5478),
    [anon_sym_bitand] = ACTIONS(5478),
    [anon_sym_not_eq] = ACTIONS(5478),
    [anon_sym_DASH_DASH] = ACTIONS(5480),
    [anon_sym_PLUS_PLUS] = ACTIONS(5480),
    [anon_sym_DOT] = ACTIONS(5478),
    [anon_sym_DOT_STAR] = ACTIONS(5480),
    [anon_sym_DASH_GT] = ACTIONS(5480),
    [anon_sym_L_DQUOTE] = ACTIONS(5480),
    [anon_sym_u_DQUOTE] = ACTIONS(5480),
    [anon_sym_U_DQUOTE] = ACTIONS(5480),
    [anon_sym_u8_DQUOTE] = ACTIONS(5480),
    [anon_sym_DQUOTE] = ACTIONS(5480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5480),
    [anon_sym_LR_DQUOTE] = ACTIONS(5480),
    [anon_sym_uR_DQUOTE] = ACTIONS(5480),
    [anon_sym_UR_DQUOTE] = ACTIONS(5480),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5480),
    [sym_literal_suffix] = ACTIONS(5478),
  },
  [2343] = {
    [sym_attribute_specifier] = STATE(1877),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6064),
    [anon_sym_COMMA] = ACTIONS(6064),
    [anon_sym_RPAREN] = ACTIONS(6064),
    [anon_sym_LPAREN2] = ACTIONS(6064),
    [anon_sym_DASH] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_STAR] = ACTIONS(6064),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [anon_sym_PIPE_PIPE] = ACTIONS(6064),
    [anon_sym_AMP_AMP] = ACTIONS(6064),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_CARET] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6064),
    [anon_sym_BANG_EQ] = ACTIONS(6064),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6064),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6064),
    [anon_sym_GT_GT] = ACTIONS(6064),
    [anon_sym_SEMI] = ACTIONS(6064),
    [anon_sym___extension__] = ACTIONS(6064),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6064),
    [anon_sym_LBRACE] = ACTIONS(6064),
    [anon_sym_RBRACE] = ACTIONS(6064),
    [anon_sym_LBRACK] = ACTIONS(6064),
    [anon_sym_RBRACK] = ACTIONS(6064),
    [anon_sym_const] = ACTIONS(6062),
    [anon_sym_constexpr] = ACTIONS(6064),
    [anon_sym_volatile] = ACTIONS(6064),
    [anon_sym_restrict] = ACTIONS(6064),
    [anon_sym___restrict__] = ACTIONS(6064),
    [anon_sym__Atomic] = ACTIONS(6064),
    [anon_sym__Noreturn] = ACTIONS(6064),
    [anon_sym_noreturn] = ACTIONS(6064),
    [anon_sym__Nonnull] = ACTIONS(6064),
    [anon_sym_mutable] = ACTIONS(6064),
    [anon_sym_constinit] = ACTIONS(6064),
    [anon_sym_consteval] = ACTIONS(6064),
    [anon_sym_alignas] = ACTIONS(6064),
    [anon_sym__Alignas] = ACTIONS(6064),
    [anon_sym_QMARK] = ACTIONS(6064),
    [anon_sym_LT_EQ_GT] = ACTIONS(6064),
    [anon_sym_or] = ACTIONS(6064),
    [anon_sym_and] = ACTIONS(6064),
    [anon_sym_bitor] = ACTIONS(6064),
    [anon_sym_xor] = ACTIONS(6064),
    [anon_sym_bitand] = ACTIONS(6064),
    [anon_sym_not_eq] = ACTIONS(6064),
    [anon_sym_DASH_DASH] = ACTIONS(6064),
    [anon_sym_PLUS_PLUS] = ACTIONS(6064),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_DOT_STAR] = ACTIONS(6064),
    [anon_sym_DASH_GT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6064),
    [anon_sym_decltype] = ACTIONS(6064),
    [anon_sym_final] = ACTIONS(6064),
    [anon_sym_override] = ACTIONS(6064),
    [anon_sym_requires] = ACTIONS(6064),
  },
  [2344] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_LPAREN2] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_STAR] = ACTIONS(5926),
    [anon_sym_SLASH] = ACTIONS(5928),
    [anon_sym_PERCENT] = ACTIONS(5926),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5926),
    [anon_sym_PIPE] = ACTIONS(5928),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5928),
    [anon_sym_EQ_EQ] = ACTIONS(5926),
    [anon_sym_BANG_EQ] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5928),
    [anon_sym_GT_EQ] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_LT] = ACTIONS(5928),
    [anon_sym_LT_LT] = ACTIONS(5926),
    [anon_sym_GT_GT] = ACTIONS(5928),
    [anon_sym___extension__] = ACTIONS(5926),
    [anon_sym___attribute__] = ACTIONS(5926),
    [anon_sym___attribute] = ACTIONS(5928),
    [anon_sym_LBRACE] = ACTIONS(5926),
    [anon_sym_signed] = ACTIONS(6356),
    [anon_sym_unsigned] = ACTIONS(6356),
    [anon_sym_long] = ACTIONS(6356),
    [anon_sym_short] = ACTIONS(6356),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_const] = ACTIONS(5928),
    [anon_sym_constexpr] = ACTIONS(5926),
    [anon_sym_volatile] = ACTIONS(5926),
    [anon_sym_restrict] = ACTIONS(5926),
    [anon_sym___restrict__] = ACTIONS(5926),
    [anon_sym__Atomic] = ACTIONS(5926),
    [anon_sym__Noreturn] = ACTIONS(5926),
    [anon_sym_noreturn] = ACTIONS(5926),
    [anon_sym__Nonnull] = ACTIONS(5926),
    [anon_sym_mutable] = ACTIONS(5926),
    [anon_sym_constinit] = ACTIONS(5926),
    [anon_sym_consteval] = ACTIONS(5926),
    [anon_sym_alignas] = ACTIONS(5926),
    [anon_sym__Alignas] = ACTIONS(5926),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_or] = ACTIONS(5926),
    [anon_sym_and] = ACTIONS(5926),
    [anon_sym_bitor] = ACTIONS(5926),
    [anon_sym_xor] = ACTIONS(5926),
    [anon_sym_bitand] = ACTIONS(5926),
    [anon_sym_not_eq] = ACTIONS(5926),
    [anon_sym_DASH_DASH] = ACTIONS(5926),
    [anon_sym_PLUS_PLUS] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_DOT_STAR] = ACTIONS(5926),
    [anon_sym_DASH_GT] = ACTIONS(5926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5926),
    [anon_sym_decltype] = ACTIONS(5926),
    [anon_sym_final] = ACTIONS(5926),
    [anon_sym_override] = ACTIONS(5926),
    [anon_sym_GT2] = ACTIONS(5926),
    [anon_sym_requires] = ACTIONS(5926),
  },
  [2345] = {
    [sym_identifier] = ACTIONS(5482),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5484),
    [anon_sym_COMMA] = ACTIONS(5484),
    [anon_sym_LPAREN2] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5482),
    [anon_sym_STAR] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_PIPE] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5482),
    [anon_sym_AMP] = ACTIONS(5482),
    [anon_sym_EQ_EQ] = ACTIONS(5484),
    [anon_sym_BANG_EQ] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5482),
    [anon_sym_GT_EQ] = ACTIONS(5484),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5482),
    [anon_sym_LT_LT] = ACTIONS(5482),
    [anon_sym_GT_GT] = ACTIONS(5482),
    [anon_sym_SEMI] = ACTIONS(5484),
    [anon_sym___attribute__] = ACTIONS(5482),
    [anon_sym___attribute] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5484),
    [anon_sym_EQ] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5484),
    [anon_sym_STAR_EQ] = ACTIONS(5484),
    [anon_sym_SLASH_EQ] = ACTIONS(5484),
    [anon_sym_PERCENT_EQ] = ACTIONS(5484),
    [anon_sym_PLUS_EQ] = ACTIONS(5484),
    [anon_sym_DASH_EQ] = ACTIONS(5484),
    [anon_sym_LT_LT_EQ] = ACTIONS(5484),
    [anon_sym_GT_GT_EQ] = ACTIONS(5484),
    [anon_sym_AMP_EQ] = ACTIONS(5484),
    [anon_sym_CARET_EQ] = ACTIONS(5484),
    [anon_sym_PIPE_EQ] = ACTIONS(5484),
    [anon_sym_and_eq] = ACTIONS(5482),
    [anon_sym_or_eq] = ACTIONS(5482),
    [anon_sym_xor_eq] = ACTIONS(5482),
    [anon_sym_LT_EQ_GT] = ACTIONS(5484),
    [anon_sym_or] = ACTIONS(5482),
    [anon_sym_and] = ACTIONS(5482),
    [anon_sym_bitor] = ACTIONS(5482),
    [anon_sym_xor] = ACTIONS(5482),
    [anon_sym_bitand] = ACTIONS(5482),
    [anon_sym_not_eq] = ACTIONS(5482),
    [anon_sym_DASH_DASH] = ACTIONS(5484),
    [anon_sym_PLUS_PLUS] = ACTIONS(5484),
    [anon_sym_DOT] = ACTIONS(5482),
    [anon_sym_DOT_STAR] = ACTIONS(5484),
    [anon_sym_DASH_GT] = ACTIONS(5484),
    [anon_sym_L_DQUOTE] = ACTIONS(5484),
    [anon_sym_u_DQUOTE] = ACTIONS(5484),
    [anon_sym_U_DQUOTE] = ACTIONS(5484),
    [anon_sym_u8_DQUOTE] = ACTIONS(5484),
    [anon_sym_DQUOTE] = ACTIONS(5484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5484),
    [anon_sym_LR_DQUOTE] = ACTIONS(5484),
    [anon_sym_uR_DQUOTE] = ACTIONS(5484),
    [anon_sym_UR_DQUOTE] = ACTIONS(5484),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5484),
    [sym_literal_suffix] = ACTIONS(5482),
  },
  [2346] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2315),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_RPAREN] = ACTIONS(5752),
    [anon_sym_LPAREN2] = ACTIONS(5752),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_STAR] = ACTIONS(5750),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_PIPE] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5750),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_LT] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym_SEMI] = ACTIONS(5752),
    [anon_sym___attribute__] = ACTIONS(5752),
    [anon_sym___attribute] = ACTIONS(5750),
    [anon_sym_COLON] = ACTIONS(5752),
    [anon_sym_LBRACE] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(5752),
    [anon_sym_signed] = ACTIONS(6317),
    [anon_sym_unsigned] = ACTIONS(6317),
    [anon_sym_long] = ACTIONS(6317),
    [anon_sym_short] = ACTIONS(6317),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_RBRACK] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5752),
    [anon_sym_STAR_EQ] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_PERCENT_EQ] = ACTIONS(5752),
    [anon_sym_PLUS_EQ] = ACTIONS(5752),
    [anon_sym_DASH_EQ] = ACTIONS(5752),
    [anon_sym_LT_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT_GT_EQ] = ACTIONS(5752),
    [anon_sym_AMP_EQ] = ACTIONS(5752),
    [anon_sym_CARET_EQ] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_and_eq] = ACTIONS(5752),
    [anon_sym_or_eq] = ACTIONS(5752),
    [anon_sym_xor_eq] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_bitor] = ACTIONS(5752),
    [anon_sym_xor] = ACTIONS(5750),
    [anon_sym_bitand] = ACTIONS(5752),
    [anon_sym_not_eq] = ACTIONS(5752),
    [anon_sym_DASH_DASH] = ACTIONS(5752),
    [anon_sym_PLUS_PLUS] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_DOT_STAR] = ACTIONS(5752),
    [anon_sym_DASH_GT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5752),
    [anon_sym_decltype] = ACTIONS(5752),
  },
  [2347] = {
    [sym_template_argument_list] = STATE(2324),
    [sym_identifier] = ACTIONS(6368),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6370),
    [anon_sym_COMMA] = ACTIONS(6370),
    [anon_sym_RPAREN] = ACTIONS(6370),
    [aux_sym_preproc_if_token2] = ACTIONS(6370),
    [aux_sym_preproc_else_token1] = ACTIONS(6370),
    [aux_sym_preproc_elif_token1] = ACTIONS(6368),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6370),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6370),
    [anon_sym_LPAREN2] = ACTIONS(6370),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_PERCENT] = ACTIONS(6368),
    [anon_sym_PIPE_PIPE] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_AMP] = ACTIONS(6368),
    [anon_sym_EQ_EQ] = ACTIONS(6370),
    [anon_sym_BANG_EQ] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6368),
    [anon_sym_GT_EQ] = ACTIONS(6370),
    [anon_sym_LT_EQ] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_LT_LT] = ACTIONS(6368),
    [anon_sym_GT_GT] = ACTIONS(6368),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym___attribute__] = ACTIONS(6368),
    [anon_sym___attribute] = ACTIONS(6368),
    [anon_sym_COLON] = ACTIONS(6368),
    [anon_sym_COLON_COLON] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6370),
    [anon_sym_RBRACK] = ACTIONS(6370),
    [anon_sym_EQ] = ACTIONS(6368),
    [anon_sym_QMARK] = ACTIONS(6370),
    [anon_sym_STAR_EQ] = ACTIONS(6370),
    [anon_sym_SLASH_EQ] = ACTIONS(6370),
    [anon_sym_PERCENT_EQ] = ACTIONS(6370),
    [anon_sym_PLUS_EQ] = ACTIONS(6370),
    [anon_sym_DASH_EQ] = ACTIONS(6370),
    [anon_sym_LT_LT_EQ] = ACTIONS(6370),
    [anon_sym_GT_GT_EQ] = ACTIONS(6370),
    [anon_sym_AMP_EQ] = ACTIONS(6370),
    [anon_sym_CARET_EQ] = ACTIONS(6370),
    [anon_sym_PIPE_EQ] = ACTIONS(6370),
    [anon_sym_and_eq] = ACTIONS(6368),
    [anon_sym_or_eq] = ACTIONS(6368),
    [anon_sym_xor_eq] = ACTIONS(6368),
    [anon_sym_LT_EQ_GT] = ACTIONS(6370),
    [anon_sym_or] = ACTIONS(6368),
    [anon_sym_and] = ACTIONS(6368),
    [anon_sym_bitor] = ACTIONS(6368),
    [anon_sym_xor] = ACTIONS(6368),
    [anon_sym_bitand] = ACTIONS(6368),
    [anon_sym_not_eq] = ACTIONS(6368),
    [anon_sym_DASH_DASH] = ACTIONS(6370),
    [anon_sym_PLUS_PLUS] = ACTIONS(6370),
    [anon_sym_DOT] = ACTIONS(6368),
    [anon_sym_DOT_STAR] = ACTIONS(6370),
    [anon_sym_DASH_GT] = ACTIONS(6370),
    [sym_comment] = ACTIONS(3),
  },
  [2348] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5936),
    [anon_sym_COMMA] = ACTIONS(5936),
    [anon_sym_LPAREN2] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_STAR] = ACTIONS(5936),
    [anon_sym_SLASH] = ACTIONS(5938),
    [anon_sym_PERCENT] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5936),
    [anon_sym_AMP_AMP] = ACTIONS(5936),
    [anon_sym_PIPE] = ACTIONS(5938),
    [anon_sym_CARET] = ACTIONS(5936),
    [anon_sym_AMP] = ACTIONS(5938),
    [anon_sym_EQ_EQ] = ACTIONS(5936),
    [anon_sym_BANG_EQ] = ACTIONS(5936),
    [anon_sym_GT] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_LT_EQ] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5938),
    [anon_sym_LT_LT] = ACTIONS(5936),
    [anon_sym_GT_GT] = ACTIONS(5938),
    [anon_sym___extension__] = ACTIONS(5936),
    [anon_sym___attribute__] = ACTIONS(5936),
    [anon_sym___attribute] = ACTIONS(5938),
    [anon_sym_LBRACE] = ACTIONS(5936),
    [anon_sym_signed] = ACTIONS(6375),
    [anon_sym_unsigned] = ACTIONS(6375),
    [anon_sym_long] = ACTIONS(6375),
    [anon_sym_short] = ACTIONS(6375),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_const] = ACTIONS(5938),
    [anon_sym_constexpr] = ACTIONS(5936),
    [anon_sym_volatile] = ACTIONS(5936),
    [anon_sym_restrict] = ACTIONS(5936),
    [anon_sym___restrict__] = ACTIONS(5936),
    [anon_sym__Atomic] = ACTIONS(5936),
    [anon_sym__Noreturn] = ACTIONS(5936),
    [anon_sym_noreturn] = ACTIONS(5936),
    [anon_sym__Nonnull] = ACTIONS(5936),
    [anon_sym_mutable] = ACTIONS(5936),
    [anon_sym_constinit] = ACTIONS(5936),
    [anon_sym_consteval] = ACTIONS(5936),
    [anon_sym_alignas] = ACTIONS(5936),
    [anon_sym__Alignas] = ACTIONS(5936),
    [anon_sym_QMARK] = ACTIONS(5936),
    [anon_sym_LT_EQ_GT] = ACTIONS(5936),
    [anon_sym_or] = ACTIONS(5936),
    [anon_sym_and] = ACTIONS(5936),
    [anon_sym_bitor] = ACTIONS(5936),
    [anon_sym_xor] = ACTIONS(5936),
    [anon_sym_bitand] = ACTIONS(5936),
    [anon_sym_not_eq] = ACTIONS(5936),
    [anon_sym_DASH_DASH] = ACTIONS(5936),
    [anon_sym_PLUS_PLUS] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5938),
    [anon_sym_DOT_STAR] = ACTIONS(5936),
    [anon_sym_DASH_GT] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5936),
    [anon_sym_decltype] = ACTIONS(5936),
    [anon_sym_final] = ACTIONS(5936),
    [anon_sym_override] = ACTIONS(5936),
    [anon_sym_GT2] = ACTIONS(5936),
    [anon_sym_requires] = ACTIONS(5936),
  },
  [2349] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_LPAREN2] = ACTIONS(5930),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_PLUS] = ACTIONS(5932),
    [anon_sym_STAR] = ACTIONS(5930),
    [anon_sym_SLASH] = ACTIONS(5932),
    [anon_sym_PERCENT] = ACTIONS(5930),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_AMP_AMP] = ACTIONS(5930),
    [anon_sym_PIPE] = ACTIONS(5932),
    [anon_sym_CARET] = ACTIONS(5930),
    [anon_sym_AMP] = ACTIONS(5932),
    [anon_sym_EQ_EQ] = ACTIONS(5930),
    [anon_sym_BANG_EQ] = ACTIONS(5930),
    [anon_sym_GT] = ACTIONS(5932),
    [anon_sym_GT_EQ] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_LT] = ACTIONS(5932),
    [anon_sym_LT_LT] = ACTIONS(5930),
    [anon_sym_GT_GT] = ACTIONS(5932),
    [anon_sym___extension__] = ACTIONS(5930),
    [anon_sym___attribute__] = ACTIONS(5930),
    [anon_sym___attribute] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(5930),
    [anon_sym_signed] = ACTIONS(6377),
    [anon_sym_unsigned] = ACTIONS(6377),
    [anon_sym_long] = ACTIONS(6377),
    [anon_sym_short] = ACTIONS(6377),
    [anon_sym_LBRACK] = ACTIONS(5930),
    [anon_sym_const] = ACTIONS(5932),
    [anon_sym_constexpr] = ACTIONS(5930),
    [anon_sym_volatile] = ACTIONS(5930),
    [anon_sym_restrict] = ACTIONS(5930),
    [anon_sym___restrict__] = ACTIONS(5930),
    [anon_sym__Atomic] = ACTIONS(5930),
    [anon_sym__Noreturn] = ACTIONS(5930),
    [anon_sym_noreturn] = ACTIONS(5930),
    [anon_sym__Nonnull] = ACTIONS(5930),
    [anon_sym_mutable] = ACTIONS(5930),
    [anon_sym_constinit] = ACTIONS(5930),
    [anon_sym_consteval] = ACTIONS(5930),
    [anon_sym_alignas] = ACTIONS(5930),
    [anon_sym__Alignas] = ACTIONS(5930),
    [anon_sym_QMARK] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_or] = ACTIONS(5930),
    [anon_sym_and] = ACTIONS(5930),
    [anon_sym_bitor] = ACTIONS(5930),
    [anon_sym_xor] = ACTIONS(5930),
    [anon_sym_bitand] = ACTIONS(5930),
    [anon_sym_not_eq] = ACTIONS(5930),
    [anon_sym_DASH_DASH] = ACTIONS(5930),
    [anon_sym_PLUS_PLUS] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_DOT_STAR] = ACTIONS(5930),
    [anon_sym_DASH_GT] = ACTIONS(5930),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5930),
    [anon_sym_decltype] = ACTIONS(5930),
    [anon_sym_final] = ACTIONS(5930),
    [anon_sym_override] = ACTIONS(5930),
    [anon_sym_GT2] = ACTIONS(5930),
    [anon_sym_requires] = ACTIONS(5930),
  },
  [2350] = {
    [sym_attribute_specifier] = STATE(1834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6098),
    [anon_sym_COMMA] = ACTIONS(6098),
    [anon_sym_RPAREN] = ACTIONS(6098),
    [anon_sym_LPAREN2] = ACTIONS(6098),
    [anon_sym_DASH] = ACTIONS(6096),
    [anon_sym_PLUS] = ACTIONS(6096),
    [anon_sym_STAR] = ACTIONS(6098),
    [anon_sym_SLASH] = ACTIONS(6096),
    [anon_sym_PERCENT] = ACTIONS(6098),
    [anon_sym_PIPE_PIPE] = ACTIONS(6098),
    [anon_sym_AMP_AMP] = ACTIONS(6098),
    [anon_sym_PIPE] = ACTIONS(6096),
    [anon_sym_CARET] = ACTIONS(6098),
    [anon_sym_AMP] = ACTIONS(6096),
    [anon_sym_EQ_EQ] = ACTIONS(6098),
    [anon_sym_BANG_EQ] = ACTIONS(6098),
    [anon_sym_GT] = ACTIONS(6096),
    [anon_sym_GT_EQ] = ACTIONS(6098),
    [anon_sym_LT_EQ] = ACTIONS(6096),
    [anon_sym_LT] = ACTIONS(6096),
    [anon_sym_LT_LT] = ACTIONS(6098),
    [anon_sym_GT_GT] = ACTIONS(6098),
    [anon_sym_SEMI] = ACTIONS(6098),
    [anon_sym___extension__] = ACTIONS(6098),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6098),
    [anon_sym_LBRACE] = ACTIONS(6098),
    [anon_sym_RBRACE] = ACTIONS(6098),
    [anon_sym_LBRACK] = ACTIONS(6098),
    [anon_sym_RBRACK] = ACTIONS(6098),
    [anon_sym_const] = ACTIONS(6096),
    [anon_sym_constexpr] = ACTIONS(6098),
    [anon_sym_volatile] = ACTIONS(6098),
    [anon_sym_restrict] = ACTIONS(6098),
    [anon_sym___restrict__] = ACTIONS(6098),
    [anon_sym__Atomic] = ACTIONS(6098),
    [anon_sym__Noreturn] = ACTIONS(6098),
    [anon_sym_noreturn] = ACTIONS(6098),
    [anon_sym__Nonnull] = ACTIONS(6098),
    [anon_sym_mutable] = ACTIONS(6098),
    [anon_sym_constinit] = ACTIONS(6098),
    [anon_sym_consteval] = ACTIONS(6098),
    [anon_sym_alignas] = ACTIONS(6098),
    [anon_sym__Alignas] = ACTIONS(6098),
    [anon_sym_QMARK] = ACTIONS(6098),
    [anon_sym_LT_EQ_GT] = ACTIONS(6098),
    [anon_sym_or] = ACTIONS(6098),
    [anon_sym_and] = ACTIONS(6098),
    [anon_sym_bitor] = ACTIONS(6098),
    [anon_sym_xor] = ACTIONS(6098),
    [anon_sym_bitand] = ACTIONS(6098),
    [anon_sym_not_eq] = ACTIONS(6098),
    [anon_sym_DASH_DASH] = ACTIONS(6098),
    [anon_sym_PLUS_PLUS] = ACTIONS(6098),
    [anon_sym_DOT] = ACTIONS(6096),
    [anon_sym_DOT_STAR] = ACTIONS(6098),
    [anon_sym_DASH_GT] = ACTIONS(6098),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6098),
    [anon_sym_decltype] = ACTIONS(6098),
    [anon_sym_final] = ACTIONS(6098),
    [anon_sym_override] = ACTIONS(6098),
    [anon_sym_requires] = ACTIONS(6098),
  },
  [2351] = {
    [sym_attribute_specifier] = STATE(1882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6131),
    [anon_sym_COMMA] = ACTIONS(6131),
    [anon_sym_RPAREN] = ACTIONS(6131),
    [anon_sym_LPAREN2] = ACTIONS(6131),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_PIPE_PIPE] = ACTIONS(6131),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6131),
    [anon_sym_AMP] = ACTIONS(6129),
    [anon_sym_EQ_EQ] = ACTIONS(6131),
    [anon_sym_BANG_EQ] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6129),
    [anon_sym_GT_EQ] = ACTIONS(6131),
    [anon_sym_LT_EQ] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6129),
    [anon_sym_LT_LT] = ACTIONS(6131),
    [anon_sym_GT_GT] = ACTIONS(6131),
    [anon_sym_SEMI] = ACTIONS(6131),
    [anon_sym___extension__] = ACTIONS(6131),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_LBRACE] = ACTIONS(6131),
    [anon_sym_RBRACE] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6131),
    [anon_sym_RBRACK] = ACTIONS(6131),
    [anon_sym_const] = ACTIONS(6129),
    [anon_sym_constexpr] = ACTIONS(6131),
    [anon_sym_volatile] = ACTIONS(6131),
    [anon_sym_restrict] = ACTIONS(6131),
    [anon_sym___restrict__] = ACTIONS(6131),
    [anon_sym__Atomic] = ACTIONS(6131),
    [anon_sym__Noreturn] = ACTIONS(6131),
    [anon_sym_noreturn] = ACTIONS(6131),
    [anon_sym__Nonnull] = ACTIONS(6131),
    [anon_sym_mutable] = ACTIONS(6131),
    [anon_sym_constinit] = ACTIONS(6131),
    [anon_sym_consteval] = ACTIONS(6131),
    [anon_sym_alignas] = ACTIONS(6131),
    [anon_sym__Alignas] = ACTIONS(6131),
    [anon_sym_QMARK] = ACTIONS(6131),
    [anon_sym_LT_EQ_GT] = ACTIONS(6131),
    [anon_sym_or] = ACTIONS(6131),
    [anon_sym_and] = ACTIONS(6131),
    [anon_sym_bitor] = ACTIONS(6131),
    [anon_sym_xor] = ACTIONS(6131),
    [anon_sym_bitand] = ACTIONS(6131),
    [anon_sym_not_eq] = ACTIONS(6131),
    [anon_sym_DASH_DASH] = ACTIONS(6131),
    [anon_sym_PLUS_PLUS] = ACTIONS(6131),
    [anon_sym_DOT] = ACTIONS(6129),
    [anon_sym_DOT_STAR] = ACTIONS(6131),
    [anon_sym_DASH_GT] = ACTIONS(6131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6131),
    [anon_sym_decltype] = ACTIONS(6131),
    [anon_sym_final] = ACTIONS(6131),
    [anon_sym_override] = ACTIONS(6131),
    [anon_sym_requires] = ACTIONS(6131),
  },
  [2352] = {
    [sym_attribute_specifier] = STATE(1881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6127),
    [anon_sym_COMMA] = ACTIONS(6127),
    [anon_sym_RPAREN] = ACTIONS(6127),
    [anon_sym_LPAREN2] = ACTIONS(6127),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6127),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_PERCENT] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6127),
    [anon_sym_AMP_AMP] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6127),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_EQ_EQ] = ACTIONS(6127),
    [anon_sym_BANG_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_GT_EQ] = ACTIONS(6127),
    [anon_sym_LT_EQ] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_LT_LT] = ACTIONS(6127),
    [anon_sym_GT_GT] = ACTIONS(6127),
    [anon_sym_SEMI] = ACTIONS(6127),
    [anon_sym___extension__] = ACTIONS(6127),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_LBRACE] = ACTIONS(6127),
    [anon_sym_RBRACE] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6127),
    [anon_sym_RBRACK] = ACTIONS(6127),
    [anon_sym_const] = ACTIONS(6125),
    [anon_sym_constexpr] = ACTIONS(6127),
    [anon_sym_volatile] = ACTIONS(6127),
    [anon_sym_restrict] = ACTIONS(6127),
    [anon_sym___restrict__] = ACTIONS(6127),
    [anon_sym__Atomic] = ACTIONS(6127),
    [anon_sym__Noreturn] = ACTIONS(6127),
    [anon_sym_noreturn] = ACTIONS(6127),
    [anon_sym__Nonnull] = ACTIONS(6127),
    [anon_sym_mutable] = ACTIONS(6127),
    [anon_sym_constinit] = ACTIONS(6127),
    [anon_sym_consteval] = ACTIONS(6127),
    [anon_sym_alignas] = ACTIONS(6127),
    [anon_sym__Alignas] = ACTIONS(6127),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_LT_EQ_GT] = ACTIONS(6127),
    [anon_sym_or] = ACTIONS(6127),
    [anon_sym_and] = ACTIONS(6127),
    [anon_sym_bitor] = ACTIONS(6127),
    [anon_sym_xor] = ACTIONS(6127),
    [anon_sym_bitand] = ACTIONS(6127),
    [anon_sym_not_eq] = ACTIONS(6127),
    [anon_sym_DASH_DASH] = ACTIONS(6127),
    [anon_sym_PLUS_PLUS] = ACTIONS(6127),
    [anon_sym_DOT] = ACTIONS(6125),
    [anon_sym_DOT_STAR] = ACTIONS(6127),
    [anon_sym_DASH_GT] = ACTIONS(6127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6127),
    [anon_sym_decltype] = ACTIONS(6127),
    [anon_sym_final] = ACTIONS(6127),
    [anon_sym_override] = ACTIONS(6127),
    [anon_sym_requires] = ACTIONS(6127),
  },
  [2353] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5936),
    [anon_sym_COMMA] = ACTIONS(5936),
    [anon_sym_RPAREN] = ACTIONS(5936),
    [anon_sym_LPAREN2] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_STAR] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5938),
    [anon_sym_PERCENT] = ACTIONS(5938),
    [anon_sym_PIPE_PIPE] = ACTIONS(5936),
    [anon_sym_AMP_AMP] = ACTIONS(5936),
    [anon_sym_PIPE] = ACTIONS(5938),
    [anon_sym_CARET] = ACTIONS(5938),
    [anon_sym_AMP] = ACTIONS(5938),
    [anon_sym_EQ_EQ] = ACTIONS(5936),
    [anon_sym_BANG_EQ] = ACTIONS(5936),
    [anon_sym_GT] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5938),
    [anon_sym_LT_LT] = ACTIONS(5938),
    [anon_sym_GT_GT] = ACTIONS(5938),
    [anon_sym_SEMI] = ACTIONS(5936),
    [anon_sym___attribute__] = ACTIONS(5936),
    [anon_sym___attribute] = ACTIONS(5938),
    [anon_sym_COLON] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(5936),
    [anon_sym_RBRACE] = ACTIONS(5936),
    [anon_sym_signed] = ACTIONS(6379),
    [anon_sym_unsigned] = ACTIONS(6379),
    [anon_sym_long] = ACTIONS(6379),
    [anon_sym_short] = ACTIONS(6379),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_RBRACK] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5938),
    [anon_sym_QMARK] = ACTIONS(5936),
    [anon_sym_STAR_EQ] = ACTIONS(5936),
    [anon_sym_SLASH_EQ] = ACTIONS(5936),
    [anon_sym_PERCENT_EQ] = ACTIONS(5936),
    [anon_sym_PLUS_EQ] = ACTIONS(5936),
    [anon_sym_DASH_EQ] = ACTIONS(5936),
    [anon_sym_LT_LT_EQ] = ACTIONS(5936),
    [anon_sym_GT_GT_EQ] = ACTIONS(5936),
    [anon_sym_AMP_EQ] = ACTIONS(5936),
    [anon_sym_CARET_EQ] = ACTIONS(5936),
    [anon_sym_PIPE_EQ] = ACTIONS(5936),
    [anon_sym_and_eq] = ACTIONS(5936),
    [anon_sym_or_eq] = ACTIONS(5936),
    [anon_sym_xor_eq] = ACTIONS(5936),
    [anon_sym_LT_EQ_GT] = ACTIONS(5936),
    [anon_sym_or] = ACTIONS(5938),
    [anon_sym_and] = ACTIONS(5938),
    [anon_sym_bitor] = ACTIONS(5936),
    [anon_sym_xor] = ACTIONS(5938),
    [anon_sym_bitand] = ACTIONS(5936),
    [anon_sym_not_eq] = ACTIONS(5936),
    [anon_sym_DASH_DASH] = ACTIONS(5936),
    [anon_sym_PLUS_PLUS] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5938),
    [anon_sym_DOT_STAR] = ACTIONS(5936),
    [anon_sym_DASH_GT] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5936),
    [anon_sym_decltype] = ACTIONS(5936),
  },
  [2354] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_RPAREN] = ACTIONS(5930),
    [anon_sym_LPAREN2] = ACTIONS(5930),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_PLUS] = ACTIONS(5932),
    [anon_sym_STAR] = ACTIONS(5932),
    [anon_sym_SLASH] = ACTIONS(5932),
    [anon_sym_PERCENT] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_AMP_AMP] = ACTIONS(5930),
    [anon_sym_PIPE] = ACTIONS(5932),
    [anon_sym_CARET] = ACTIONS(5932),
    [anon_sym_AMP] = ACTIONS(5932),
    [anon_sym_EQ_EQ] = ACTIONS(5930),
    [anon_sym_BANG_EQ] = ACTIONS(5930),
    [anon_sym_GT] = ACTIONS(5932),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_LT] = ACTIONS(5932),
    [anon_sym_LT_LT] = ACTIONS(5932),
    [anon_sym_GT_GT] = ACTIONS(5932),
    [anon_sym_SEMI] = ACTIONS(5930),
    [anon_sym___attribute__] = ACTIONS(5930),
    [anon_sym___attribute] = ACTIONS(5932),
    [anon_sym_COLON] = ACTIONS(5930),
    [anon_sym_LBRACE] = ACTIONS(5930),
    [anon_sym_RBRACE] = ACTIONS(5930),
    [anon_sym_signed] = ACTIONS(6381),
    [anon_sym_unsigned] = ACTIONS(6381),
    [anon_sym_long] = ACTIONS(6381),
    [anon_sym_short] = ACTIONS(6381),
    [anon_sym_LBRACK] = ACTIONS(5930),
    [anon_sym_RBRACK] = ACTIONS(5930),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_QMARK] = ACTIONS(5930),
    [anon_sym_STAR_EQ] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_PERCENT_EQ] = ACTIONS(5930),
    [anon_sym_PLUS_EQ] = ACTIONS(5930),
    [anon_sym_DASH_EQ] = ACTIONS(5930),
    [anon_sym_LT_LT_EQ] = ACTIONS(5930),
    [anon_sym_GT_GT_EQ] = ACTIONS(5930),
    [anon_sym_AMP_EQ] = ACTIONS(5930),
    [anon_sym_CARET_EQ] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_and_eq] = ACTIONS(5930),
    [anon_sym_or_eq] = ACTIONS(5930),
    [anon_sym_xor_eq] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_or] = ACTIONS(5932),
    [anon_sym_and] = ACTIONS(5932),
    [anon_sym_bitor] = ACTIONS(5930),
    [anon_sym_xor] = ACTIONS(5932),
    [anon_sym_bitand] = ACTIONS(5930),
    [anon_sym_not_eq] = ACTIONS(5930),
    [anon_sym_DASH_DASH] = ACTIONS(5930),
    [anon_sym_PLUS_PLUS] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_DOT_STAR] = ACTIONS(5930),
    [anon_sym_DASH_GT] = ACTIONS(5930),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5930),
    [anon_sym_decltype] = ACTIONS(5930),
  },
  [2355] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5898),
    [anon_sym_COMMA] = ACTIONS(5898),
    [anon_sym_LPAREN2] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5900),
    [anon_sym_STAR] = ACTIONS(5898),
    [anon_sym_SLASH] = ACTIONS(5900),
    [anon_sym_PERCENT] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5898),
    [anon_sym_AMP_AMP] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_AMP] = ACTIONS(5900),
    [anon_sym_EQ_EQ] = ACTIONS(5898),
    [anon_sym_BANG_EQ] = ACTIONS(5898),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5898),
    [anon_sym_GT_GT] = ACTIONS(5900),
    [anon_sym___extension__] = ACTIONS(5898),
    [anon_sym___attribute__] = ACTIONS(5898),
    [anon_sym___attribute] = ACTIONS(5900),
    [anon_sym_LBRACE] = ACTIONS(5898),
    [anon_sym_signed] = ACTIONS(6356),
    [anon_sym_unsigned] = ACTIONS(6356),
    [anon_sym_long] = ACTIONS(6356),
    [anon_sym_short] = ACTIONS(6356),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_const] = ACTIONS(5900),
    [anon_sym_constexpr] = ACTIONS(5898),
    [anon_sym_volatile] = ACTIONS(5898),
    [anon_sym_restrict] = ACTIONS(5898),
    [anon_sym___restrict__] = ACTIONS(5898),
    [anon_sym__Atomic] = ACTIONS(5898),
    [anon_sym__Noreturn] = ACTIONS(5898),
    [anon_sym_noreturn] = ACTIONS(5898),
    [anon_sym__Nonnull] = ACTIONS(5898),
    [anon_sym_mutable] = ACTIONS(5898),
    [anon_sym_constinit] = ACTIONS(5898),
    [anon_sym_consteval] = ACTIONS(5898),
    [anon_sym_alignas] = ACTIONS(5898),
    [anon_sym__Alignas] = ACTIONS(5898),
    [anon_sym_QMARK] = ACTIONS(5898),
    [anon_sym_LT_EQ_GT] = ACTIONS(5898),
    [anon_sym_or] = ACTIONS(5898),
    [anon_sym_and] = ACTIONS(5898),
    [anon_sym_bitor] = ACTIONS(5898),
    [anon_sym_xor] = ACTIONS(5898),
    [anon_sym_bitand] = ACTIONS(5898),
    [anon_sym_not_eq] = ACTIONS(5898),
    [anon_sym_DASH_DASH] = ACTIONS(5898),
    [anon_sym_PLUS_PLUS] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5900),
    [anon_sym_DOT_STAR] = ACTIONS(5898),
    [anon_sym_DASH_GT] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5898),
    [anon_sym_decltype] = ACTIONS(5898),
    [anon_sym_final] = ACTIONS(5898),
    [anon_sym_override] = ACTIONS(5898),
    [anon_sym_GT2] = ACTIONS(5898),
    [anon_sym_requires] = ACTIONS(5898),
  },
  [2356] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_RPAREN] = ACTIONS(5908),
    [anon_sym_LPAREN2] = ACTIONS(5908),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_PLUS] = ACTIONS(5910),
    [anon_sym_STAR] = ACTIONS(5910),
    [anon_sym_SLASH] = ACTIONS(5910),
    [anon_sym_PERCENT] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_PIPE] = ACTIONS(5910),
    [anon_sym_CARET] = ACTIONS(5910),
    [anon_sym_AMP] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5908),
    [anon_sym_GT] = ACTIONS(5910),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_LT] = ACTIONS(5910),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_SEMI] = ACTIONS(5908),
    [anon_sym___attribute__] = ACTIONS(5908),
    [anon_sym___attribute] = ACTIONS(5910),
    [anon_sym_COLON] = ACTIONS(5908),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_RBRACE] = ACTIONS(5908),
    [anon_sym_signed] = ACTIONS(6308),
    [anon_sym_unsigned] = ACTIONS(6308),
    [anon_sym_long] = ACTIONS(6308),
    [anon_sym_short] = ACTIONS(6308),
    [anon_sym_LBRACK] = ACTIONS(5908),
    [anon_sym_RBRACK] = ACTIONS(5908),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_STAR_EQ] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_PERCENT_EQ] = ACTIONS(5908),
    [anon_sym_PLUS_EQ] = ACTIONS(5908),
    [anon_sym_DASH_EQ] = ACTIONS(5908),
    [anon_sym_LT_LT_EQ] = ACTIONS(5908),
    [anon_sym_GT_GT_EQ] = ACTIONS(5908),
    [anon_sym_AMP_EQ] = ACTIONS(5908),
    [anon_sym_CARET_EQ] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_and_eq] = ACTIONS(5908),
    [anon_sym_or_eq] = ACTIONS(5908),
    [anon_sym_xor_eq] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_or] = ACTIONS(5910),
    [anon_sym_and] = ACTIONS(5910),
    [anon_sym_bitor] = ACTIONS(5908),
    [anon_sym_xor] = ACTIONS(5910),
    [anon_sym_bitand] = ACTIONS(5908),
    [anon_sym_not_eq] = ACTIONS(5908),
    [anon_sym_DASH_DASH] = ACTIONS(5908),
    [anon_sym_PLUS_PLUS] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_DOT_STAR] = ACTIONS(5908),
    [anon_sym_DASH_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5908),
    [anon_sym_decltype] = ACTIONS(5908),
  },
  [2357] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_LPAREN2] = ACTIONS(5908),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_PLUS] = ACTIONS(5910),
    [anon_sym_STAR] = ACTIONS(5908),
    [anon_sym_SLASH] = ACTIONS(5910),
    [anon_sym_PERCENT] = ACTIONS(5908),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_PIPE] = ACTIONS(5910),
    [anon_sym_CARET] = ACTIONS(5908),
    [anon_sym_AMP] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5908),
    [anon_sym_GT] = ACTIONS(5910),
    [anon_sym_GT_EQ] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_LT] = ACTIONS(5910),
    [anon_sym_LT_LT] = ACTIONS(5908),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym___extension__] = ACTIONS(5908),
    [anon_sym___attribute__] = ACTIONS(5908),
    [anon_sym___attribute] = ACTIONS(5910),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_signed] = ACTIONS(6356),
    [anon_sym_unsigned] = ACTIONS(6356),
    [anon_sym_long] = ACTIONS(6356),
    [anon_sym_short] = ACTIONS(6356),
    [anon_sym_LBRACK] = ACTIONS(5908),
    [anon_sym_const] = ACTIONS(5910),
    [anon_sym_constexpr] = ACTIONS(5908),
    [anon_sym_volatile] = ACTIONS(5908),
    [anon_sym_restrict] = ACTIONS(5908),
    [anon_sym___restrict__] = ACTIONS(5908),
    [anon_sym__Atomic] = ACTIONS(5908),
    [anon_sym__Noreturn] = ACTIONS(5908),
    [anon_sym_noreturn] = ACTIONS(5908),
    [anon_sym__Nonnull] = ACTIONS(5908),
    [anon_sym_mutable] = ACTIONS(5908),
    [anon_sym_constinit] = ACTIONS(5908),
    [anon_sym_consteval] = ACTIONS(5908),
    [anon_sym_alignas] = ACTIONS(5908),
    [anon_sym__Alignas] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_or] = ACTIONS(5908),
    [anon_sym_and] = ACTIONS(5908),
    [anon_sym_bitor] = ACTIONS(5908),
    [anon_sym_xor] = ACTIONS(5908),
    [anon_sym_bitand] = ACTIONS(5908),
    [anon_sym_not_eq] = ACTIONS(5908),
    [anon_sym_DASH_DASH] = ACTIONS(5908),
    [anon_sym_PLUS_PLUS] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_DOT_STAR] = ACTIONS(5908),
    [anon_sym_DASH_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5908),
    [anon_sym_decltype] = ACTIONS(5908),
    [anon_sym_final] = ACTIONS(5908),
    [anon_sym_override] = ACTIONS(5908),
    [anon_sym_GT2] = ACTIONS(5908),
    [anon_sym_requires] = ACTIONS(5908),
  },
  [2358] = {
    [sym_string_literal] = STATE(2189),
    [sym_raw_string_literal] = STATE(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_COMMA] = ACTIONS(5914),
    [anon_sym_RPAREN] = ACTIONS(5914),
    [anon_sym_LPAREN2] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5912),
    [anon_sym_STAR] = ACTIONS(5912),
    [anon_sym_SLASH] = ACTIONS(5912),
    [anon_sym_PERCENT] = ACTIONS(5912),
    [anon_sym_PIPE_PIPE] = ACTIONS(5914),
    [anon_sym_AMP_AMP] = ACTIONS(5914),
    [anon_sym_PIPE] = ACTIONS(5912),
    [anon_sym_CARET] = ACTIONS(5912),
    [anon_sym_AMP] = ACTIONS(5912),
    [anon_sym_EQ_EQ] = ACTIONS(5914),
    [anon_sym_BANG_EQ] = ACTIONS(5914),
    [anon_sym_GT] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5912),
    [anon_sym_LT_LT] = ACTIONS(5912),
    [anon_sym_GT_GT] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5912),
    [anon_sym_QMARK] = ACTIONS(5914),
    [anon_sym_STAR_EQ] = ACTIONS(5914),
    [anon_sym_SLASH_EQ] = ACTIONS(5914),
    [anon_sym_PERCENT_EQ] = ACTIONS(5914),
    [anon_sym_PLUS_EQ] = ACTIONS(5914),
    [anon_sym_DASH_EQ] = ACTIONS(5914),
    [anon_sym_LT_LT_EQ] = ACTIONS(5914),
    [anon_sym_GT_GT_EQ] = ACTIONS(5914),
    [anon_sym_AMP_EQ] = ACTIONS(5914),
    [anon_sym_CARET_EQ] = ACTIONS(5914),
    [anon_sym_PIPE_EQ] = ACTIONS(5914),
    [anon_sym_and_eq] = ACTIONS(5912),
    [anon_sym_or_eq] = ACTIONS(5912),
    [anon_sym_xor_eq] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5914),
    [anon_sym_or] = ACTIONS(5912),
    [anon_sym_and] = ACTIONS(5912),
    [anon_sym_bitor] = ACTIONS(5912),
    [anon_sym_xor] = ACTIONS(5912),
    [anon_sym_bitand] = ACTIONS(5912),
    [anon_sym_not_eq] = ACTIONS(5912),
    [anon_sym_DASH_DASH] = ACTIONS(5914),
    [anon_sym_PLUS_PLUS] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5912),
    [anon_sym_DOT_STAR] = ACTIONS(5914),
    [anon_sym_DASH_GT] = ACTIONS(5912),
    [anon_sym_L_DQUOTE] = ACTIONS(5040),
    [anon_sym_u_DQUOTE] = ACTIONS(5040),
    [anon_sym_U_DQUOTE] = ACTIONS(5040),
    [anon_sym_u8_DQUOTE] = ACTIONS(5040),
    [anon_sym_DQUOTE] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5042),
    [anon_sym_LR_DQUOTE] = ACTIONS(5042),
    [anon_sym_uR_DQUOTE] = ACTIONS(5042),
    [anon_sym_UR_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5042),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5914),
    [sym_literal_suffix] = ACTIONS(5912),
  },
  [2359] = {
    [sym_type_qualifier] = STATE(2320),
    [sym_alignas_qualifier] = STATE(1658),
    [aux_sym__type_definition_type_repeat1] = STATE(2320),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2544),
    [sym_identifier] = ACTIONS(6383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5086),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_RPAREN] = ACTIONS(5086),
    [anon_sym_LPAREN2] = ACTIONS(5086),
    [anon_sym_TILDE] = ACTIONS(5086),
    [anon_sym_STAR] = ACTIONS(5086),
    [anon_sym_AMP_AMP] = ACTIONS(5086),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_SEMI] = ACTIONS(5086),
    [anon_sym___extension__] = ACTIONS(6386),
    [anon_sym_virtual] = ACTIONS(5088),
    [anon_sym_extern] = ACTIONS(5088),
    [anon_sym___attribute__] = ACTIONS(5088),
    [anon_sym___attribute] = ACTIONS(5088),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5086),
    [anon_sym___declspec] = ACTIONS(5088),
    [anon_sym___based] = ACTIONS(5088),
    [anon_sym___cdecl] = ACTIONS(5088),
    [anon_sym___clrcall] = ACTIONS(5088),
    [anon_sym___stdcall] = ACTIONS(5088),
    [anon_sym___fastcall] = ACTIONS(5088),
    [anon_sym___thiscall] = ACTIONS(5088),
    [anon_sym___vectorcall] = ACTIONS(5088),
    [anon_sym_LBRACE] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(6389),
    [anon_sym_unsigned] = ACTIONS(6389),
    [anon_sym_long] = ACTIONS(6389),
    [anon_sym_short] = ACTIONS(6389),
    [anon_sym_LBRACK] = ACTIONS(5088),
    [anon_sym_static] = ACTIONS(5088),
    [anon_sym_EQ] = ACTIONS(5086),
    [anon_sym_register] = ACTIONS(5088),
    [anon_sym_inline] = ACTIONS(5088),
    [anon_sym___inline] = ACTIONS(5088),
    [anon_sym___inline__] = ACTIONS(5088),
    [anon_sym___forceinline] = ACTIONS(5088),
    [anon_sym_thread_local] = ACTIONS(5088),
    [anon_sym___thread] = ACTIONS(5088),
    [anon_sym_const] = ACTIONS(6386),
    [anon_sym_constexpr] = ACTIONS(6386),
    [anon_sym_volatile] = ACTIONS(6386),
    [anon_sym_restrict] = ACTIONS(6386),
    [anon_sym___restrict__] = ACTIONS(6386),
    [anon_sym__Atomic] = ACTIONS(6386),
    [anon_sym__Noreturn] = ACTIONS(6386),
    [anon_sym_noreturn] = ACTIONS(6386),
    [anon_sym__Nonnull] = ACTIONS(6386),
    [anon_sym_mutable] = ACTIONS(6386),
    [anon_sym_constinit] = ACTIONS(6386),
    [anon_sym_consteval] = ACTIONS(6386),
    [anon_sym_alignas] = ACTIONS(6391),
    [anon_sym__Alignas] = ACTIONS(6391),
    [sym_primitive_type] = ACTIONS(6394),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5088),
    [anon_sym_decltype] = ACTIONS(5088),
    [anon_sym_template] = ACTIONS(5088),
    [anon_sym_GT2] = ACTIONS(5086),
    [anon_sym_operator] = ACTIONS(5088),
  },
  [2360] = {
    [sym_attribute_specifier] = STATE(1867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_LPAREN2] = ACTIONS(6060),
    [anon_sym_DASH] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6058),
    [anon_sym_STAR] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6058),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6058),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6058),
    [anon_sym_EQ_EQ] = ACTIONS(6060),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_GT] = ACTIONS(6058),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6058),
    [anon_sym_LT] = ACTIONS(6058),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym___extension__] = ACTIONS(6060),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_const] = ACTIONS(6058),
    [anon_sym_constexpr] = ACTIONS(6060),
    [anon_sym_volatile] = ACTIONS(6060),
    [anon_sym_restrict] = ACTIONS(6060),
    [anon_sym___restrict__] = ACTIONS(6060),
    [anon_sym__Atomic] = ACTIONS(6060),
    [anon_sym__Noreturn] = ACTIONS(6060),
    [anon_sym_noreturn] = ACTIONS(6060),
    [anon_sym__Nonnull] = ACTIONS(6060),
    [anon_sym_mutable] = ACTIONS(6060),
    [anon_sym_constinit] = ACTIONS(6060),
    [anon_sym_consteval] = ACTIONS(6060),
    [anon_sym_alignas] = ACTIONS(6060),
    [anon_sym__Alignas] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_bitor] = ACTIONS(6060),
    [anon_sym_xor] = ACTIONS(6060),
    [anon_sym_bitand] = ACTIONS(6060),
    [anon_sym_not_eq] = ACTIONS(6060),
    [anon_sym_DASH_DASH] = ACTIONS(6060),
    [anon_sym_PLUS_PLUS] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6058),
    [anon_sym_DOT_STAR] = ACTIONS(6060),
    [anon_sym_DASH_GT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6060),
    [anon_sym_decltype] = ACTIONS(6060),
    [anon_sym_final] = ACTIONS(6060),
    [anon_sym_override] = ACTIONS(6060),
    [anon_sym_requires] = ACTIONS(6060),
  },
  [2361] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_LPAREN2] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5944),
    [anon_sym_PLUS] = ACTIONS(5944),
    [anon_sym_STAR] = ACTIONS(5942),
    [anon_sym_SLASH] = ACTIONS(5944),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_AMP_AMP] = ACTIONS(5942),
    [anon_sym_PIPE] = ACTIONS(5944),
    [anon_sym_CARET] = ACTIONS(5942),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_EQ_EQ] = ACTIONS(5942),
    [anon_sym_BANG_EQ] = ACTIONS(5942),
    [anon_sym_GT] = ACTIONS(5944),
    [anon_sym_GT_EQ] = ACTIONS(5944),
    [anon_sym_LT_EQ] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5942),
    [anon_sym_GT_GT] = ACTIONS(5944),
    [anon_sym___extension__] = ACTIONS(5942),
    [anon_sym___attribute__] = ACTIONS(5942),
    [anon_sym___attribute] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(5942),
    [anon_sym_signed] = ACTIONS(6356),
    [anon_sym_unsigned] = ACTIONS(6356),
    [anon_sym_long] = ACTIONS(6356),
    [anon_sym_short] = ACTIONS(6356),
    [anon_sym_LBRACK] = ACTIONS(5942),
    [anon_sym_const] = ACTIONS(5944),
    [anon_sym_constexpr] = ACTIONS(5942),
    [anon_sym_volatile] = ACTIONS(5942),
    [anon_sym_restrict] = ACTIONS(5942),
    [anon_sym___restrict__] = ACTIONS(5942),
    [anon_sym__Atomic] = ACTIONS(5942),
    [anon_sym__Noreturn] = ACTIONS(5942),
    [anon_sym_noreturn] = ACTIONS(5942),
    [anon_sym__Nonnull] = ACTIONS(5942),
    [anon_sym_mutable] = ACTIONS(5942),
    [anon_sym_constinit] = ACTIONS(5942),
    [anon_sym_consteval] = ACTIONS(5942),
    [anon_sym_alignas] = ACTIONS(5942),
    [anon_sym__Alignas] = ACTIONS(5942),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_or] = ACTIONS(5942),
    [anon_sym_and] = ACTIONS(5942),
    [anon_sym_bitor] = ACTIONS(5942),
    [anon_sym_xor] = ACTIONS(5942),
    [anon_sym_bitand] = ACTIONS(5942),
    [anon_sym_not_eq] = ACTIONS(5942),
    [anon_sym_DASH_DASH] = ACTIONS(5942),
    [anon_sym_PLUS_PLUS] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5944),
    [anon_sym_DOT_STAR] = ACTIONS(5942),
    [anon_sym_DASH_GT] = ACTIONS(5942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5942),
    [anon_sym_decltype] = ACTIONS(5942),
    [anon_sym_final] = ACTIONS(5942),
    [anon_sym_override] = ACTIONS(5942),
    [anon_sym_GT2] = ACTIONS(5942),
    [anon_sym_requires] = ACTIONS(5942),
  },
  [2362] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5894),
    [anon_sym_COMMA] = ACTIONS(5894),
    [anon_sym_LPAREN2] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5896),
    [anon_sym_STAR] = ACTIONS(5894),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5894),
    [anon_sym_AMP_AMP] = ACTIONS(5894),
    [anon_sym_PIPE] = ACTIONS(5896),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_LT_EQ] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5896),
    [anon_sym_LT_LT] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5896),
    [anon_sym___extension__] = ACTIONS(5894),
    [anon_sym___attribute__] = ACTIONS(5894),
    [anon_sym___attribute] = ACTIONS(5896),
    [anon_sym_LBRACE] = ACTIONS(5894),
    [anon_sym_signed] = ACTIONS(6356),
    [anon_sym_unsigned] = ACTIONS(6356),
    [anon_sym_long] = ACTIONS(6356),
    [anon_sym_short] = ACTIONS(6356),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_const] = ACTIONS(5896),
    [anon_sym_constexpr] = ACTIONS(5894),
    [anon_sym_volatile] = ACTIONS(5894),
    [anon_sym_restrict] = ACTIONS(5894),
    [anon_sym___restrict__] = ACTIONS(5894),
    [anon_sym__Atomic] = ACTIONS(5894),
    [anon_sym__Noreturn] = ACTIONS(5894),
    [anon_sym_noreturn] = ACTIONS(5894),
    [anon_sym__Nonnull] = ACTIONS(5894),
    [anon_sym_mutable] = ACTIONS(5894),
    [anon_sym_constinit] = ACTIONS(5894),
    [anon_sym_consteval] = ACTIONS(5894),
    [anon_sym_alignas] = ACTIONS(5894),
    [anon_sym__Alignas] = ACTIONS(5894),
    [anon_sym_QMARK] = ACTIONS(5894),
    [anon_sym_LT_EQ_GT] = ACTIONS(5894),
    [anon_sym_or] = ACTIONS(5894),
    [anon_sym_and] = ACTIONS(5894),
    [anon_sym_bitor] = ACTIONS(5894),
    [anon_sym_xor] = ACTIONS(5894),
    [anon_sym_bitand] = ACTIONS(5894),
    [anon_sym_not_eq] = ACTIONS(5894),
    [anon_sym_DASH_DASH] = ACTIONS(5894),
    [anon_sym_PLUS_PLUS] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5896),
    [anon_sym_DOT_STAR] = ACTIONS(5894),
    [anon_sym_DASH_GT] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5894),
    [anon_sym_decltype] = ACTIONS(5894),
    [anon_sym_final] = ACTIONS(5894),
    [anon_sym_override] = ACTIONS(5894),
    [anon_sym_GT2] = ACTIONS(5894),
    [anon_sym_requires] = ACTIONS(5894),
  },
  [2363] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5902),
    [anon_sym_COMMA] = ACTIONS(5902),
    [anon_sym_LPAREN2] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5904),
    [anon_sym_STAR] = ACTIONS(5902),
    [anon_sym_SLASH] = ACTIONS(5904),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5902),
    [anon_sym_AMP_AMP] = ACTIONS(5902),
    [anon_sym_PIPE] = ACTIONS(5904),
    [anon_sym_CARET] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_EQ_EQ] = ACTIONS(5902),
    [anon_sym_BANG_EQ] = ACTIONS(5902),
    [anon_sym_GT] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_LT_EQ] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5904),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_GT_GT] = ACTIONS(5904),
    [anon_sym___extension__] = ACTIONS(5902),
    [anon_sym___attribute__] = ACTIONS(5902),
    [anon_sym___attribute] = ACTIONS(5904),
    [anon_sym_LBRACE] = ACTIONS(5902),
    [anon_sym_signed] = ACTIONS(6396),
    [anon_sym_unsigned] = ACTIONS(6396),
    [anon_sym_long] = ACTIONS(6396),
    [anon_sym_short] = ACTIONS(6396),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_const] = ACTIONS(5904),
    [anon_sym_constexpr] = ACTIONS(5902),
    [anon_sym_volatile] = ACTIONS(5902),
    [anon_sym_restrict] = ACTIONS(5902),
    [anon_sym___restrict__] = ACTIONS(5902),
    [anon_sym__Atomic] = ACTIONS(5902),
    [anon_sym__Noreturn] = ACTIONS(5902),
    [anon_sym_noreturn] = ACTIONS(5902),
    [anon_sym__Nonnull] = ACTIONS(5902),
    [anon_sym_mutable] = ACTIONS(5902),
    [anon_sym_constinit] = ACTIONS(5902),
    [anon_sym_consteval] = ACTIONS(5902),
    [anon_sym_alignas] = ACTIONS(5902),
    [anon_sym__Alignas] = ACTIONS(5902),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_LT_EQ_GT] = ACTIONS(5902),
    [anon_sym_or] = ACTIONS(5902),
    [anon_sym_and] = ACTIONS(5902),
    [anon_sym_bitor] = ACTIONS(5902),
    [anon_sym_xor] = ACTIONS(5902),
    [anon_sym_bitand] = ACTIONS(5902),
    [anon_sym_not_eq] = ACTIONS(5902),
    [anon_sym_DASH_DASH] = ACTIONS(5902),
    [anon_sym_PLUS_PLUS] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5904),
    [anon_sym_DOT_STAR] = ACTIONS(5902),
    [anon_sym_DASH_GT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5902),
    [anon_sym_decltype] = ACTIONS(5902),
    [anon_sym_final] = ACTIONS(5902),
    [anon_sym_override] = ACTIONS(5902),
    [anon_sym_GT2] = ACTIONS(5902),
    [anon_sym_requires] = ACTIONS(5902),
  },
  [2364] = {
    [sym_attribute_specifier] = STATE(1843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6106),
    [anon_sym_COMMA] = ACTIONS(6106),
    [anon_sym_RPAREN] = ACTIONS(6106),
    [anon_sym_LPAREN2] = ACTIONS(6106),
    [anon_sym_DASH] = ACTIONS(6104),
    [anon_sym_PLUS] = ACTIONS(6104),
    [anon_sym_STAR] = ACTIONS(6106),
    [anon_sym_SLASH] = ACTIONS(6104),
    [anon_sym_PERCENT] = ACTIONS(6106),
    [anon_sym_PIPE_PIPE] = ACTIONS(6106),
    [anon_sym_AMP_AMP] = ACTIONS(6106),
    [anon_sym_PIPE] = ACTIONS(6104),
    [anon_sym_CARET] = ACTIONS(6106),
    [anon_sym_AMP] = ACTIONS(6104),
    [anon_sym_EQ_EQ] = ACTIONS(6106),
    [anon_sym_BANG_EQ] = ACTIONS(6106),
    [anon_sym_GT] = ACTIONS(6104),
    [anon_sym_GT_EQ] = ACTIONS(6106),
    [anon_sym_LT_EQ] = ACTIONS(6104),
    [anon_sym_LT] = ACTIONS(6104),
    [anon_sym_LT_LT] = ACTIONS(6106),
    [anon_sym_GT_GT] = ACTIONS(6106),
    [anon_sym_SEMI] = ACTIONS(6106),
    [anon_sym___extension__] = ACTIONS(6106),
    [anon_sym___attribute__] = ACTIONS(6014),
    [anon_sym___attribute] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6106),
    [anon_sym_LBRACE] = ACTIONS(6106),
    [anon_sym_RBRACE] = ACTIONS(6106),
    [anon_sym_LBRACK] = ACTIONS(6106),
    [anon_sym_RBRACK] = ACTIONS(6106),
    [anon_sym_const] = ACTIONS(6104),
    [anon_sym_constexpr] = ACTIONS(6106),
    [anon_sym_volatile] = ACTIONS(6106),
    [anon_sym_restrict] = ACTIONS(6106),
    [anon_sym___restrict__] = ACTIONS(6106),
    [anon_sym__Atomic] = ACTIONS(6106),
    [anon_sym__Noreturn] = ACTIONS(6106),
    [anon_sym_noreturn] = ACTIONS(6106),
    [anon_sym__Nonnull] = ACTIONS(6106),
    [anon_sym_mutable] = ACTIONS(6106),
    [anon_sym_constinit] = ACTIONS(6106),
    [anon_sym_consteval] = ACTIONS(6106),
    [anon_sym_alignas] = ACTIONS(6106),
    [anon_sym__Alignas] = ACTIONS(6106),
    [anon_sym_QMARK] = ACTIONS(6106),
    [anon_sym_LT_EQ_GT] = ACTIONS(6106),
    [anon_sym_or] = ACTIONS(6106),
    [anon_sym_and] = ACTIONS(6106),
    [anon_sym_bitor] = ACTIONS(6106),
    [anon_sym_xor] = ACTIONS(6106),
    [anon_sym_bitand] = ACTIONS(6106),
    [anon_sym_not_eq] = ACTIONS(6106),
    [anon_sym_DASH_DASH] = ACTIONS(6106),
    [anon_sym_PLUS_PLUS] = ACTIONS(6106),
    [anon_sym_DOT] = ACTIONS(6104),
    [anon_sym_DOT_STAR] = ACTIONS(6106),
    [anon_sym_DASH_GT] = ACTIONS(6106),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6106),
    [anon_sym_decltype] = ACTIONS(6106),
    [anon_sym_final] = ACTIONS(6106),
    [anon_sym_override] = ACTIONS(6106),
    [anon_sym_requires] = ACTIONS(6106),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6400), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [71] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5480), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6402), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6404), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5579), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [284] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2236), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6214), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6216), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5914), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5912), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6406), 1,
      sym_identifier,
    STATE(2372), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4411), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4413), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5392), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5390), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3949), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [511] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      sym_identifier,
    STATE(2376), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4411), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4413), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5398), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5396), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6412), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3951), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3953), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [732] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(2571), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6414), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5977), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5979), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [811] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 1,
      sym_identifier,
    STATE(2376), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6419), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6422), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5405), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5403), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [890] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6425), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6427), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5484), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [1044] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6435), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6437), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [1129] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6441), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6443), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [1214] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6445), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6447), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [1297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5491), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [1368] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2198), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6148), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5070), 17,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(5156), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5159), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
  [1445] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [1530] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6457), 1,
      anon_sym_virtual,
    ACTIONS(6459), 1,
      sym_auto,
    ACTIONS(6461), 1,
      anon_sym_decltype,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2550), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6455), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6453), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [1625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6465), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2234), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5452), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1771] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6467), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6469), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [1856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5480), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5579), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5484), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [2069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5491), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [2140] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      sym_auto,
    ACTIONS(6461), 1,
      anon_sym_decltype,
    STATE(2504), 1,
      sym_decltype_auto,
    ACTIONS(5591), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5589), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [2217] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6459), 1,
      sym_auto,
    ACTIONS(6461), 1,
      anon_sym_decltype,
    ACTIONS(6475), 1,
      anon_sym_virtual,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2558), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6473), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6471), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [2312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6477), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6479), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6485), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6487), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6489), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2527] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6491), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6493), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [2612] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    STATE(2814), 1,
      sym_field_declaration_list,
    STATE(3052), 1,
      sym_attribute_specifier,
    STATE(7113), 1,
      sym_virtual_specifier,
    STATE(7769), 1,
      sym_base_class_clause,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5493), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5495), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [2701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5631), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5629), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [2772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6400), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6400), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6503), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6507), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6511), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5452), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5450), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [3200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym_LT,
    STATE(2338), 1,
      sym_template_argument_list,
    ACTIONS(6513), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6515), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5142), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5768), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5766), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [3415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3891), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5780), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5778), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [3555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6522), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5182), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4965), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4965), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4965), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4965), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4965), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4965), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5138), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5138), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5138), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5442), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2685), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5491), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [4465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6526), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6530), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5154), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5168), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1934), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6534), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6538), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5172), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5188), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5190), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5095] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [5181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6546), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6550), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5579), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [5391] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(2589), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6552), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5977), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5979), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [5469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6554), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6556), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5770), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [5609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6558), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6560), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6564), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6568), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5480), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5579), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5484), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [6029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5491), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [6099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6572), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6574), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6576), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5480), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [6309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6578), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6580), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6582), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6584), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6586), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6588), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5665), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5663), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [6589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6592), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6594), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6596), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5194), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5164), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6600), 1,
      anon_sym_and,
    ACTIONS(6178), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6180), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5150), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4146), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5132), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5134), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7153] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5497), 1,
      anon_sym___attribute,
    ACTIONS(5987), 1,
      anon_sym_LBRACE,
    ACTIONS(6602), 1,
      anon_sym___attribute__,
    ACTIONS(6604), 1,
      anon_sym_COLON,
    STATE(2116), 1,
      sym__enum_base_clause,
    STATE(2181), 1,
      sym_enumerator_list,
    STATE(2228), 1,
      sym_attribute_specifier,
    ACTIONS(6342), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6344), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [7237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6608), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6610), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6612), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6614), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6616), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5728), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5732), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5738), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5736), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6620), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6622), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6624), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7797] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6600), 1,
      anon_sym_and,
    ACTIONS(6626), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6628), 1,
      anon_sym_or,
    ACTIONS(6253), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6255), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7875] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(2641), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5979), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5977), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [7955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5752), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5750), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [8025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5756), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5754), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [8095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5760), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5758), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [8165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6634), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6479), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5186), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4146), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6638), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6640), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6642), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5776), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5774), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [8655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6646), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6650), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6652), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6654), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5740), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [8935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5784), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5782), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5788), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5786), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5792), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5790), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5796), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5794), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5788), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5786), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6656), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6658), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6662), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6664), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6666), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6668), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6670), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6672), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6674), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6678), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6682), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6686), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5701), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5699), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5649), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5647), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9985] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    STATE(2858), 1,
      sym_field_declaration_list,
    STATE(3172), 1,
      sym_attribute_specifier,
    STATE(7111), 1,
      sym_virtual_specifier,
    STATE(7888), 1,
      sym_base_class_clause,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5493), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5495), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [10073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5798), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5997), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6696), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5651), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5657), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5655), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5659), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5675), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5673), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5679), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5677), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5687), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5685), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5692), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6700), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5679), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5677), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5679), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5677), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5667), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [11053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5683), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5681), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [11123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1938), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5484), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [11263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6702), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6704), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5764), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5762), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [11403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5452), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5450), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [11473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6708), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6550), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6712), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5146), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11753] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5497), 1,
      anon_sym___attribute,
    ACTIONS(5987), 1,
      anon_sym_LBRACE,
    ACTIONS(6602), 1,
      anon_sym___attribute__,
    ACTIONS(6604), 1,
      anon_sym_COLON,
    STATE(2051), 1,
      sym__enum_base_clause,
    STATE(2191), 1,
      sym_enumerator_list,
    STATE(2258), 1,
      sym_attribute_specifier,
    ACTIONS(6336), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6338), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [11837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5804), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5802), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [11907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5808), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5806), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [11977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5812), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5810), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [12047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5639), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5637), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [12117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6716), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5619), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12258] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2545), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6718), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5904), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5902), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [12331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4957), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12400] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    STATE(2436), 1,
      sym_argument_list,
    STATE(2616), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3806), 1,
      sym_initializer_list,
    ACTIONS(6723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5452), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5450), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [12481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4984), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4986), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4980), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4982), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4992), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4994), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4953), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4961), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4988), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4990), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12895] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 1,
      sym_primitive_type,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5156), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5159), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [12970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1634), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6725), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5910), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5908), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1634), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6725), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5918), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5916), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5003), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2546), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6727), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5922), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5920), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13258] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    STATE(2577), 1,
      sym_enumerator_list,
    STATE(2700), 1,
      sym_attribute_specifier,
    ACTIONS(5983), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5985), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13337] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6735), 1,
      anon_sym_virtual,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2574), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6733), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6731), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [13424] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    STATE(2580), 1,
      sym_enumerator_list,
    STATE(2646), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6026), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1634), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6725), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5928), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5926), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1634), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6725), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5894), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2553), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6737), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5932), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5930), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13722] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6739), 1,
      anon_sym_LT,
    STATE(2591), 1,
      sym_template_argument_list,
    ACTIONS(5838), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4172), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [13797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5619), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5605), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5607), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13937] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6735), 1,
      anon_sym_virtual,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2574), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6743), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6741), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [14024] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6745), 1,
      anon_sym_LT,
    STATE(2591), 1,
      sym_template_argument_list,
    ACTIONS(4963), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4970), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [14099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5480), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [14168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5579), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [14237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5484), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [14306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5491), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [14375] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5853), 1,
      anon_sym_STAR,
    ACTIONS(5855), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5857), 1,
      anon_sym_AMP,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    STATE(3087), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6349), 1,
      sym__declarator,
    STATE(6538), 1,
      sym__abstract_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5867), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(5865), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [14494] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5853), 1,
      anon_sym_STAR,
    ACTIONS(5855), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5857), 1,
      anon_sym_AMP,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    STATE(3087), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6294), 1,
      sym__declarator,
    STATE(6539), 1,
      sym__abstract_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6750), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(6748), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [14613] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2370), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4411), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4413), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5912), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5914), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [14688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5625), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5627), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14759] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6739), 1,
      anon_sym_LT,
    STATE(2571), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2591), 1,
      sym_template_argument_list,
    ACTIONS(6414), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4152), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [14838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1634), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6725), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5888), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [14911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2569), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6752), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5750), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5752), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [14984] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1634), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6725), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5900), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5898), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1634), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6725), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5944), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5942), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2572), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6754), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5938), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5936), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15203] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6763), 1,
      anon_sym_virtual,
    ACTIONS(6772), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6775), 1,
      anon_sym___declspec,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(6769), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6778), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2574), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6766), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6758), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6756), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(6760), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [15290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2622), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5902), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5904), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [15362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4982), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4980), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [15430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2647), 1,
      sym_attribute_specifier,
    ACTIONS(6096), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6098), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15504] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2648), 1,
      sym_attribute_specifier,
    ACTIONS(6168), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6170), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15578] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2649), 1,
      sym_attribute_specifier,
    ACTIONS(6104), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6106), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15652] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2651), 1,
      sym_attribute_specifier,
    ACTIONS(6058), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6060), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15726] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2652), 1,
      sym_attribute_specifier,
    ACTIONS(6062), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6064), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5629), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5631), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4957), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4955), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [15936] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2602), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5942), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5944), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [16008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2602), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5894), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5896), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [16080] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6785), 1,
      anon_sym_LT,
    STATE(2589), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2687), 1,
      sym_template_argument_list,
    ACTIONS(6552), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4152), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [16158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1656), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5888), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [16230] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6785), 1,
      anon_sym_LT,
    STATE(2687), 1,
      sym_template_argument_list,
    ACTIONS(5838), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4172), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [16304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1656), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5900), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5898), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [16376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4992), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [16444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5003), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [16512] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    STATE(3079), 1,
      sym_field_declaration_list,
    STATE(3409), 1,
      sym_attribute_specifier,
    STATE(7112), 1,
      sym_virtual_specifier,
    STATE(7692), 1,
      sym_base_class_clause,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5493), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5495), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [16598] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    ACTIONS(6795), 1,
      anon_sym_COLON,
    ACTIONS(6797), 1,
      anon_sym_LBRACE,
    STATE(2749), 1,
      sym__enum_base_clause,
    STATE(2811), 1,
      sym_enumerator_list,
    STATE(3048), 1,
      sym_attribute_specifier,
    ACTIONS(6336), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6338), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [16680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2585), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6799), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5930), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5932), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [16752] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6801), 1,
      sym_identifier,
    STATE(2595), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6804), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6807), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5405), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5403), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2603), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5938), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5936), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [16900] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2604), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6812), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5932), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5930), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [16972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5450), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5452), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17042] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2616), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5752), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5750), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [17114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2623), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6814), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5920), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5922), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [17186] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6816), 1,
      anon_sym_LT,
    STATE(2747), 1,
      sym_template_argument_list,
    ACTIONS(4970), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4963), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [17260] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2602), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6818), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5072), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5070), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [17332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1656), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5944), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5942), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17404] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1656), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5894), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17476] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    ACTIONS(6795), 1,
      anon_sym_COLON,
    ACTIONS(6797), 1,
      anon_sym_LBRACE,
    STATE(2761), 1,
      sym__enum_base_clause,
    STATE(2779), 1,
      sym_enumerator_list,
    STATE(2993), 1,
      sym_attribute_specifier,
    ACTIONS(6342), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6344), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [17558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2643), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6821), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5904), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5902), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2612), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6823), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5922), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5920), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1656), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5928), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5926), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2587), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6825), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5750), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5752), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17846] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(2757), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5977), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5979), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [17922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5619), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [17992] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1656), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5918), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5916), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [18064] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6816), 1,
      anon_sym_LT,
    STATE(2747), 1,
      sym_template_argument_list,
    ACTIONS(4172), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5838), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18138] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2681), 1,
      sym_attribute_specifier,
    ACTIONS(6151), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6153), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5619), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2602), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5888), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5890), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [18352] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2602), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5926), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5928), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [18424] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2685), 1,
      sym_attribute_specifier,
    ACTIONS(6155), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6157), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4951), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [18566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4961), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4959), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [18634] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    STATE(2677), 1,
      sym_decltype_auto,
    ACTIONS(5589), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5591), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2602), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5908), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5910), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [18780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2602), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5916), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5918), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [18852] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6833), 1,
      sym_identifier,
    STATE(2628), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3623), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3627), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5392), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5390), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [18928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4990), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4988), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [18996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5619), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [19066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5480), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [19134] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6835), 1,
      sym_identifier,
    STATE(2595), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3623), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3627), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5398), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5396), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [19210] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2584), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6837), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5936), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5938), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [19282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5625), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5627), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [19352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6839), 1,
      anon_sym_LT,
    STATE(2687), 1,
      sym_template_argument_list,
    ACTIONS(4963), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4970), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [19426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5605), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5607), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [19494] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2693), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6119), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [19568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2699), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6123), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [19642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5579), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [19710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4986), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4984), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19778] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2704), 1,
      sym_attribute_specifier,
    ACTIONS(6125), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6127), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [19852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2705), 1,
      sym_attribute_specifier,
    ACTIONS(6129), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6131), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [19926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5484), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [19994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5491), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [20062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2602), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5898), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5900), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [20134] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    STATE(2645), 1,
      sym_attribute_specifier,
    ACTIONS(6090), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6092), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1656), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5910), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5908), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [20280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5491), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [20347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5808), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5812), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5639), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5665), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5667), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5669), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5681), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5683), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5742), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5780), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5484), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [20950] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(5971), 1,
      anon_sym_STAR,
    ACTIONS(5973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5975), 1,
      anon_sym_AMP,
    STATE(3216), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6349), 1,
      sym__declarator,
    STATE(6655), 1,
      sym__abstract_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5865), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(5867), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [21067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5619), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [21134] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(5971), 1,
      anon_sym_STAR,
    ACTIONS(5973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5975), 1,
      anon_sym_AMP,
    STATE(3216), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6294), 1,
      sym__declarator,
    STATE(6716), 1,
      sym__abstract_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6748), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(6750), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [21251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5452), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5619), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [21387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5619), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [21456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1630), 1,
      sym_string_literal,
    ACTIONS(6846), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6844), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6842), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [21527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2616), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5452), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5450), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [21598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5605), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5607), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [21665] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(6032), 1,
      anon_sym_STAR,
    ACTIONS(6034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6036), 1,
      anon_sym_AMP,
    STATE(3223), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6349), 1,
      sym__declarator,
    STATE(6654), 1,
      sym__abstract_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5865), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(5867), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [21782] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(6032), 1,
      anon_sym_STAR,
    ACTIONS(6034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6036), 1,
      anon_sym_AMP,
    STATE(3223), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6294), 1,
      sym__declarator,
    STATE(6664), 1,
      sym__abstract_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6748), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(6750), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [21899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5480), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [21966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5579), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [22033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5804), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5452), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5625), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5627), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [22236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5003), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_DASH_GT_STAR,
  [22303] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    ACTIONS(6848), 1,
      anon_sym_COLON,
    ACTIONS(6850), 1,
      anon_sym_LBRACE,
    STATE(2839), 1,
      sym__enum_base_clause,
    STATE(2873), 1,
      sym_enumerator_list,
    STATE(3149), 1,
      sym_attribute_specifier,
    ACTIONS(6336), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6338), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [22384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5762), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5764), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5768), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22518] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6852), 1,
      sym_identifier,
    ACTIONS(6856), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2850), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6391), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2678), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6854), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5086), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6386), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(5088), 24,
      anon_sym_AMP,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [22601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5772), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5776), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5798), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5800), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22802] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6858), 1,
      sym_identifier,
    ACTIONS(6862), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3075), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6331), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6860), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5100), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6326), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(5102), 24,
      anon_sym_AMP,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [22885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5653), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22952] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    ACTIONS(6848), 1,
      anon_sym_COLON,
    ACTIONS(6850), 1,
      anon_sym_LBRACE,
    STATE(2789), 1,
      sym__enum_base_clause,
    STATE(2869), 1,
      sym_enumerator_list,
    STATE(3144), 1,
      sym_attribute_specifier,
    ACTIONS(6342), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6344), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [23033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5655), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5657), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5661), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5673), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5675), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5679), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5687), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5694), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5003), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [23502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5679), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5679), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23636] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1629), 1,
      sym_string_literal,
    ACTIONS(6846), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6844), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6842), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [23707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5643), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5730), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5734), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5643), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5641), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [23975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1631), 1,
      sym_string_literal,
    ACTIONS(6846), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6844), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6842), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [24046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5738), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1627), 1,
      sym_string_literal,
    ACTIONS(6846), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6844), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6842), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [24184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5752), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5756), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5760), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5784), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5788), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2569), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6752), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5452), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [24590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5790), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5792), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5796), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5788), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5649), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5699), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5701), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24925] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(6866), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      sym_auto,
    ACTIONS(6870), 1,
      anon_sym_decltype,
    STATE(3012), 1,
      sym_decltype_auto,
    STATE(3090), 1,
      sym_new_declarator,
    STATE(3465), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5873), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5875), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [25007] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1674), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5894), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2716), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6874), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5904), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5902), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25147] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2717), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6876), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5922), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5920), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1674), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5928), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5926), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2755), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6878), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5750), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5752), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2587), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6825), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5452), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [25427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1674), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5910), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5908), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1674), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5918), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5916), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25567] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(6866), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      sym_auto,
    ACTIONS(6870), 1,
      anon_sym_decltype,
    STATE(3012), 1,
      sym_decltype_auto,
    STATE(3076), 1,
      sym_new_declarator,
    STATE(3425), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5823), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5825), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [25649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2731), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [25715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6882), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6880), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [25781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6886), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6884), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [25847] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6888), 1,
      anon_sym_LT,
    STATE(2670), 1,
      sym_template_argument_list,
    STATE(2757), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4152), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5082), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5080), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [25989] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6459), 1,
      sym_auto,
    ACTIONS(6461), 1,
      anon_sym_decltype,
    ACTIONS(6475), 1,
      anon_sym_virtual,
    ACTIONS(6890), 1,
      anon_sym_SEMI,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6473), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2558), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6471), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [26081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6892), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5619), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5617), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5619), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5617), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5619), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [26349] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6459), 1,
      sym_auto,
    ACTIONS(6461), 1,
      anon_sym_decltype,
    ACTIONS(6475), 1,
      anon_sym_virtual,
    ACTIONS(6896), 1,
      anon_sym_SEMI,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6473), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2558), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6471), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [26441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5607), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5605), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4996), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [26573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2710), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6898), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5932), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5930), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26643] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1674), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5944), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5942), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4957), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4955), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4986), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4984), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26845] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6459), 1,
      sym_auto,
    ACTIONS(6461), 1,
      anon_sym_decltype,
    ACTIONS(6475), 1,
      anon_sym_virtual,
    ACTIONS(6900), 1,
      anon_sym_SEMI,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6473), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2558), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6471), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [26937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4982), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4980), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6904), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6902), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4992), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4951), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4961), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4959), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27267] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6459), 1,
      sym_auto,
    ACTIONS(6461), 1,
      anon_sym_decltype,
    ACTIONS(6475), 1,
      anon_sym_virtual,
    ACTIONS(6906), 1,
      anon_sym_SEMI,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6473), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2558), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6471), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [27359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4990), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4988), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27425] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6908), 1,
      anon_sym_LT,
    STATE(2670), 1,
      sym_template_argument_list,
    ACTIONS(4963), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4970), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [27497] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6459), 1,
      sym_auto,
    ACTIONS(6461), 1,
      anon_sym_decltype,
    ACTIONS(6475), 1,
      anon_sym_virtual,
    ACTIONS(6911), 1,
      anon_sym_SEMI,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6473), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2558), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6471), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [27589] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(6866), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      sym_auto,
    ACTIONS(6870), 1,
      anon_sym_decltype,
    STATE(3012), 1,
      sym_decltype_auto,
    STATE(3108), 1,
      sym_new_declarator,
    STATE(3521), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5869), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5871), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [27671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4996), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27737] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6459), 1,
      sym_auto,
    ACTIONS(6461), 1,
      anon_sym_decltype,
    ACTIONS(6475), 1,
      anon_sym_virtual,
    ACTIONS(6913), 1,
      anon_sym_SEMI,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6473), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2558), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6471), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [27829] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    ACTIONS(6797), 1,
      anon_sym_LBRACE,
    STATE(2804), 1,
      sym_enumerator_list,
    STATE(2997), 1,
      sym_attribute_specifier,
    ACTIONS(5983), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5985), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27905] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(6866), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      sym_auto,
    ACTIONS(6870), 1,
      anon_sym_decltype,
    STATE(3012), 1,
      sym_decltype_auto,
    STATE(3104), 1,
      sym_new_declarator,
    STATE(3470), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5842), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5844), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [27987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6915), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [28053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6919), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [28119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5627), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5625), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [28187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2733), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6923), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5938), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5936), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1674), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5888), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6888), 1,
      anon_sym_LT,
    STATE(2670), 1,
      sym_template_argument_list,
    ACTIONS(5838), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4172), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [28399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1674), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5900), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5898), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28469] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6459), 1,
      sym_auto,
    ACTIONS(6461), 1,
      anon_sym_decltype,
    ACTIONS(6475), 1,
      anon_sym_virtual,
    ACTIONS(6925), 1,
      anon_sym_SEMI,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6473), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2558), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5466), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6471), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5462), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [28561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2745), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2743), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [28627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5619), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5617), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [28693] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    ACTIONS(6797), 1,
      anon_sym_LBRACE,
    STATE(2828), 1,
      sym_enumerator_list,
    STATE(3020), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6026), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6572), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6570), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [28834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4980), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4982), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [28899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4992), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4994), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [28964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4953), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29029] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [29112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4961), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6696), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6694), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [29242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5484), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [29307] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(6929), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [29390] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(6931), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [29473] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6941), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6961), 1,
      anon_sym_or,
    ACTIONS(6963), 1,
      anon_sym_and,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6945), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6933), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6935), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29582] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6941), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6961), 1,
      anon_sym_or,
    ACTIONS(6963), 1,
      anon_sym_and,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6945), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6967), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6969), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6546), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [29756] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    STATE(2531), 1,
      sym_attribute_specifier,
    STATE(2965), 1,
      sym_enumerator_list,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6026), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6024), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [29829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [29894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4988), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4990), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29959] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(6973), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [30042] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(3019), 1,
      sym_attribute_specifier,
    ACTIONS(6090), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6092), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [30113] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(6975), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [30196] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(6977), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [30279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [30344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5619), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [30411] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_LBRACE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(6981), 1,
      anon_sym_LBRACK,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    STATE(3169), 1,
      sym_decltype_auto,
    STATE(3199), 1,
      sym_new_declarator,
    STATE(3537), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5823), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5825), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [30492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5491), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [30557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [30622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5605), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5607), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [30687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    STATE(2476), 1,
      sym_attribute_specifier,
    STATE(2957), 1,
      sym_enumerator_list,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5985), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5983), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [30760] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    ACTIONS(6850), 1,
      anon_sym_LBRACE,
    STATE(2865), 1,
      sym_enumerator_list,
    STATE(3192), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6026), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [30835] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6941), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6961), 1,
      anon_sym_or,
    ACTIONS(6963), 1,
      anon_sym_and,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6945), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6987), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6989), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30944] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6941), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6961), 1,
      anon_sym_or,
    ACTIONS(6963), 1,
      anon_sym_and,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6993), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6945), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6524), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6526), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31057] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(6995), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [31140] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(6997), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [31223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5619), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [31290] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6963), 1,
      anon_sym_and,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6945), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      sym_identifier,
    ACTIONS(6451), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31395] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6945), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 8,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31496] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31595] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 12,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31692] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31787] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(6999), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [31870] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(7001), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [31953] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32044] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(2992), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6119), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32115] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(3022), 1,
      sym_attribute_specifier,
    ACTIONS(6096), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6098), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32186] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(7003), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [32269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4984), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4986), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [32334] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32421] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6941), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6961), 1,
      anon_sym_or,
    ACTIONS(6963), 1,
      anon_sym_and,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6945), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7005), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7007), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5452), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5450), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [32595] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(3047), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7009), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5977), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5979), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [32670] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(2996), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6123), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32741] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6941), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6961), 1,
      anon_sym_or,
    ACTIONS(6963), 1,
      anon_sym_and,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6993), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6945), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7011), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7013), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32854] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6941), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6961), 1,
      anon_sym_or,
    ACTIONS(6963), 1,
      anon_sym_and,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6945), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7015), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7017), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32963] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(3001), 1,
      sym_attribute_specifier,
    ACTIONS(6125), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6127), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33034] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(3002), 1,
      sym_attribute_specifier,
    ACTIONS(6129), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6131), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33105] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(3025), 1,
      sym_attribute_specifier,
    ACTIONS(6168), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6170), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33176] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [33257] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [33340] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [33425] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(3027), 1,
      sym_attribute_specifier,
    ACTIONS(6104), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6106), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33496] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6941), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6955), 1,
      anon_sym_GT_EQ,
    ACTIONS(6959), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6961), 1,
      anon_sym_or,
    ACTIONS(6963), 1,
      anon_sym_and,
    ACTIONS(6965), 1,
      anon_sym_not_eq,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6993), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6937), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6945), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6947), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6949), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6957), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6939), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6953), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7019), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7021), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [33609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [33674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(3046), 1,
      sym_attribute_specifier,
    ACTIONS(6151), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6153), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33745] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(3050), 1,
      sym_attribute_specifier,
    ACTIONS(6155), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6157), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5480), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [33881] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_LBRACE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(6981), 1,
      anon_sym_LBRACK,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    STATE(3161), 1,
      sym_new_declarator,
    STATE(3169), 1,
      sym_decltype_auto,
    STATE(3688), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5873), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5875), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [33962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6708), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6706), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [34027] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(3032), 1,
      sym_attribute_specifier,
    ACTIONS(6058), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6060), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5579), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [34163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5625), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5627), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [34230] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    ACTIONS(7023), 1,
      anon_sym_COLON,
    ACTIONS(7025), 1,
      anon_sym_LBRACE,
    STATE(2918), 1,
      sym__enum_base_clause,
    STATE(2974), 1,
      sym_enumerator_list,
    STATE(3450), 1,
      sym_attribute_specifier,
    ACTIONS(6342), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6344), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34309] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    ACTIONS(7023), 1,
      anon_sym_COLON,
    ACTIONS(7025), 1,
      anon_sym_LBRACE,
    STATE(2910), 1,
      sym__enum_base_clause,
    STATE(3060), 1,
      sym_enumerator_list,
    STATE(3483), 1,
      sym_attribute_specifier,
    ACTIONS(6336), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6338), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34388] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(7027), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [34471] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_LBRACE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(6981), 1,
      anon_sym_LBRACK,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    STATE(3169), 1,
      sym_decltype_auto,
    STATE(3206), 1,
      sym_new_declarator,
    STATE(3612), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5869), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5871), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [34552] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      anon_sym___attribute__,
    ACTIONS(6497), 1,
      anon_sym___attribute,
    STATE(3035), 1,
      sym_attribute_specifier,
    ACTIONS(6062), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6064), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [34688] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(7029), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [34771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [34836] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    ACTIONS(6850), 1,
      anon_sym_LBRACE,
    STATE(2844), 1,
      sym_enumerator_list,
    STATE(3148), 1,
      sym_attribute_specifier,
    ACTIONS(5983), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5985), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [34911] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_LBRACE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(6981), 1,
      anon_sym_LBRACK,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    STATE(3169), 1,
      sym_decltype_auto,
    STATE(3202), 1,
      sym_new_declarator,
    STATE(3686), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5842), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5844), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [34992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4957), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [35057] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(7031), 1,
      anon_sym_SEMI,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [35140] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(7033), 1,
      anon_sym_LBRACK,
    STATE(2641), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3695), 1,
      sym_template_argument_list,
    ACTIONS(4169), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4152), 4,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 41,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [35218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3194), 1,
      sym_attribute_specifier,
    ACTIONS(6096), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6098), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35288] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(4300), 1,
      anon_sym_STAR,
    ACTIONS(4302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(5865), 1,
      anon_sym_RPAREN,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6447), 1,
      sym__declarator,
    STATE(6687), 1,
      sym__abstract_declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5619), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [35464] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(4300), 1,
      anon_sym_STAR,
    ACTIONS(4302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6748), 1,
      anon_sym_RPAREN,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6509), 1,
      sym__declarator,
    STATE(6690), 1,
      sym__abstract_declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35576] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3196), 1,
      sym_attribute_specifier,
    ACTIONS(6168), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6170), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3198), 1,
      sym_attribute_specifier,
    ACTIONS(6104), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6106), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35716] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5070), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(5877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5156), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5159), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [35786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5752), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [35850] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3141), 1,
      sym_attribute_specifier,
    ACTIONS(6151), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6153), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35920] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3157), 1,
      sym_attribute_specifier,
    ACTIONS(6155), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6157), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5673), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5675), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7036), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7038), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5784), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36182] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4172), 1,
      anon_sym_SEMI,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2641), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2731), 1,
      sym_template_argument_list,
    ACTIONS(4174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4152), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4144), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [36258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3178), 1,
      sym_attribute_specifier,
    ACTIONS(6125), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6127), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [36328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2755), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6878), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5452), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36396] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7048), 1,
      anon_sym___attribute__,
    ACTIONS(7051), 1,
      anon_sym___attribute,
    ACTIONS(7054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7076), 1,
      anon_sym_requires,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4709), 1,
      sym__function_attributes_start,
    STATE(4911), 1,
      sym_ref_qualifier,
    STATE(5615), 1,
      sym_trailing_return_type,
    STATE(5669), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7069), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4072), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5277), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5730), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36578] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3180), 1,
      sym_attribute_specifier,
    ACTIONS(6129), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6131), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [36648] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7048), 1,
      anon_sym___attribute__,
    ACTIONS(7051), 1,
      anon_sym___attribute,
    ACTIONS(7054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4725), 1,
      sym__function_attributes_start,
    STATE(4943), 1,
      sym_ref_qualifier,
    STATE(5603), 1,
      sym_trailing_return_type,
    STATE(5653), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4072), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5245), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5005), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4998), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36832] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3115), 1,
      sym_attribute_specifier,
    ACTIONS(6058), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6060), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [36902] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3142), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6119), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [36972] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3118), 1,
      sym_attribute_specifier,
    ACTIONS(6062), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6064), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [37042] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2641), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2731), 1,
      sym_template_argument_list,
    ACTIONS(4174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4152), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4144), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [37116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3191), 1,
      sym_attribute_specifier,
    ACTIONS(6090), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6092), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [37186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7081), 1,
      sym_literal_suffix,
    ACTIONS(4154), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4146), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5653), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [37316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5804), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [37380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6690), 1,
      anon_sym___attribute,
    STATE(3146), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6123), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [37450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5619), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5617), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [37514] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2508), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6153), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6151), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [37581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2468), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6119), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6117), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [37648] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4823), 1,
      sym__function_attributes_start,
    STATE(4970), 1,
      sym_ref_qualifier,
    STATE(5603), 1,
      sym_trailing_return_type,
    STATE(5972), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4072), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5293), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37765] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6493), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2954), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3928), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37874] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7091), 1,
      anon_sym_LPAREN2,
    ACTIONS(7093), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7095), 1,
      anon_sym_LBRACK,
    STATE(3267), 1,
      sym_parameter_list,
    STATE(3086), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6038), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6040), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [37947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2475), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6123), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6121), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [38014] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(7097), 1,
      anon_sym_LPAREN2,
    ACTIONS(7099), 1,
      anon_sym_LBRACK,
    ACTIONS(7101), 1,
      sym_auto,
    ACTIONS(7103), 1,
      anon_sym_decltype,
    STATE(3493), 1,
      sym_new_declarator,
    STATE(3525), 1,
      sym_decltype_auto,
    STATE(3831), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5869), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5871), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [38093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2530), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6092), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6090), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [38160] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7105), 1,
      anon_sym_STAR,
    ACTIONS(7107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7109), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6313), 1,
      sym__declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2946), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3948), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38269] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7019), 1,
      anon_sym_EQ,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7133), 1,
      anon_sym_QMARK,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7137), 1,
      anon_sym_or,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7021), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [38382] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7157), 1,
      anon_sym___asm,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4802), 1,
      sym__function_attributes_start,
    STATE(4951), 1,
      sym_ref_qualifier,
    STATE(5446), 1,
      sym_trailing_return_type,
    STATE(5677), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7069), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7154), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5302), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7036), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7038), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [38562] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7105), 1,
      anon_sym_STAR,
    ACTIONS(7107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7109), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6349), 1,
      sym__declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2888), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3927), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38671] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7105), 1,
      anon_sym_STAR,
    ACTIONS(7107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7109), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6294), 1,
      sym__declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3930), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38780] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7091), 1,
      anon_sym_LPAREN2,
    ACTIONS(7093), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7095), 1,
      anon_sym_LBRACK,
    STATE(3267), 1,
      sym_parameter_list,
    STATE(3086), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6100), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6102), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [38853] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7076), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4804), 1,
      sym__function_attributes_start,
    STATE(4952), 1,
      sym_ref_qualifier,
    STATE(5615), 1,
      sym_trailing_return_type,
    STATE(5955), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7069), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4072), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5291), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38970] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(7097), 1,
      anon_sym_LPAREN2,
    ACTIONS(7099), 1,
      anon_sym_LBRACK,
    ACTIONS(7101), 1,
      sym_auto,
    ACTIONS(7103), 1,
      anon_sym_decltype,
    STATE(3387), 1,
      sym_new_declarator,
    STATE(3525), 1,
      sym_decltype_auto,
    STATE(3811), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5842), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5844), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [39049] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7091), 1,
      anon_sym_LPAREN2,
    ACTIONS(7093), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7095), 1,
      anon_sym_LBRACK,
    STATE(3267), 1,
      sym_parameter_list,
    STATE(3086), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6164), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6166), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [39122] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6933), 1,
      anon_sym_EQ,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7137), 1,
      anon_sym_or,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [39231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2490), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6127), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6125), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [39298] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2491), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6131), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6129), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [39365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5784), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [39428] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6509), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3932), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39537] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7165), 1,
      anon_sym_STAR,
    ACTIONS(7167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6609), 1,
      sym__declarator,
    STATE(8161), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2900), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3936), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39646] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7171), 1,
      anon_sym_STAR,
    ACTIONS(7173), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5850), 1,
      sym__scope_resolution,
    STATE(6641), 1,
      sym__declarator,
    STATE(8214), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3945), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39755] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7165), 1,
      anon_sym_STAR,
    ACTIONS(7167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6611), 1,
      sym__declarator,
    STATE(8161), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3938), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39864] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4970), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_LT,
    STATE(2864), 1,
      sym_template_argument_list,
    ACTIONS(4972), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [39935] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7076), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7157), 1,
      anon_sym___asm,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4824), 1,
      sym__function_attributes_start,
    STATE(4965), 1,
      sym_ref_qualifier,
    STATE(5615), 1,
      sym_trailing_return_type,
    STATE(5713), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7069), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7154), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4072), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5297), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40052] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6987), 1,
      anon_sym_EQ,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7137), 1,
      anon_sym_or,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [40161] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7171), 1,
      anon_sym_STAR,
    ACTIONS(7173), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5850), 1,
      sym__scope_resolution,
    STATE(6652), 1,
      sym__declarator,
    STATE(8214), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2907), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3946), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5804), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [40333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5629), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5631), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40396] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7171), 1,
      anon_sym_STAR,
    ACTIONS(7173), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5850), 1,
      sym__scope_resolution,
    STATE(6662), 1,
      sym__declarator,
    STATE(8214), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40505] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7005), 1,
      anon_sym_EQ,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7137), 1,
      anon_sym_or,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [40614] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6524), 1,
      anon_sym_EQ,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7133), 1,
      anon_sym_QMARK,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7137), 1,
      anon_sym_or,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6526), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [40727] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    ACTIONS(7025), 1,
      anon_sym_LBRACE,
    STATE(2979), 1,
      sym_enumerator_list,
    STATE(3358), 1,
      sym_attribute_specifier,
    ACTIONS(5983), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5985), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40800] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6967), 1,
      anon_sym_EQ,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7137), 1,
      anon_sym_or,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [40909] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7181), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7183), 1,
      anon_sym_COMMA,
    ACTIONS(7185), 1,
      anon_sym_RPAREN,
    ACTIONS(7187), 1,
      anon_sym_DASH,
    ACTIONS(7189), 1,
      anon_sym_PLUS,
    ACTIONS(7191), 1,
      anon_sym_STAR,
    ACTIONS(7193), 1,
      anon_sym_SLASH,
    ACTIONS(7195), 1,
      anon_sym_PERCENT,
    ACTIONS(7197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7201), 1,
      anon_sym_PIPE,
    ACTIONS(7203), 1,
      anon_sym_CARET,
    ACTIONS(7205), 1,
      anon_sym_AMP,
    ACTIONS(7207), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7209), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7211), 1,
      anon_sym_GT,
    ACTIONS(7213), 1,
      anon_sym_GT_EQ,
    ACTIONS(7215), 1,
      anon_sym_LT_EQ,
    ACTIONS(7217), 1,
      anon_sym_LT,
    ACTIONS(7219), 1,
      anon_sym_LT_LT,
    ACTIONS(7221), 1,
      anon_sym_GT_GT,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7225), 1,
      anon_sym_EQ,
    ACTIONS(7227), 1,
      anon_sym_QMARK,
    ACTIONS(7229), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7231), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7233), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7235), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7237), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7239), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7241), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7243), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7245), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7247), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7253), 1,
      anon_sym_or,
    ACTIONS(7255), 1,
      anon_sym_and,
    ACTIONS(7257), 1,
      anon_sym_bitor,
    ACTIONS(7259), 1,
      anon_sym_xor,
    ACTIONS(7261), 1,
      anon_sym_bitand,
    ACTIONS(7263), 1,
      anon_sym_not_eq,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7249), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [41070] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [41175] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [41276] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [41355] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7091), 1,
      anon_sym_LPAREN2,
    ACTIONS(7093), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7095), 1,
      anon_sym_LBRACK,
    STATE(3267), 1,
      sym_parameter_list,
    STATE(3086), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6066), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6068), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [41428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2512), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6157), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6155), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [41495] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    ACTIONS(7025), 1,
      anon_sym_LBRACE,
    STATE(3014), 1,
      sym_enumerator_list,
    STATE(3406), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6026), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41568] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7181), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7183), 1,
      anon_sym_COMMA,
    ACTIONS(7187), 1,
      anon_sym_DASH,
    ACTIONS(7189), 1,
      anon_sym_PLUS,
    ACTIONS(7191), 1,
      anon_sym_STAR,
    ACTIONS(7193), 1,
      anon_sym_SLASH,
    ACTIONS(7195), 1,
      anon_sym_PERCENT,
    ACTIONS(7197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7201), 1,
      anon_sym_PIPE,
    ACTIONS(7203), 1,
      anon_sym_CARET,
    ACTIONS(7205), 1,
      anon_sym_AMP,
    ACTIONS(7207), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7209), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7211), 1,
      anon_sym_GT,
    ACTIONS(7213), 1,
      anon_sym_GT_EQ,
    ACTIONS(7215), 1,
      anon_sym_LT_EQ,
    ACTIONS(7217), 1,
      anon_sym_LT,
    ACTIONS(7219), 1,
      anon_sym_LT_LT,
    ACTIONS(7221), 1,
      anon_sym_GT_GT,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7225), 1,
      anon_sym_EQ,
    ACTIONS(7227), 1,
      anon_sym_QMARK,
    ACTIONS(7229), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7231), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7233), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7235), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7237), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7239), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7241), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7243), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7245), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7247), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7253), 1,
      anon_sym_or,
    ACTIONS(7255), 1,
      anon_sym_and,
    ACTIONS(7257), 1,
      anon_sym_bitor,
    ACTIONS(7259), 1,
      anon_sym_xor,
    ACTIONS(7261), 1,
      anon_sym_bitand,
    ACTIONS(7263), 1,
      anon_sym_not_eq,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7273), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7249), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [41729] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6168), 1,
      sym__declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3973), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41838] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6493), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2932), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3935), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41947] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6451), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [42044] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [42139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5450), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5452), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42204] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7091), 1,
      anon_sym_LPAREN2,
    ACTIONS(7093), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7095), 1,
      anon_sym_LBRACK,
    STATE(3267), 1,
      sym_parameter_list,
    STATE(3086), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6133), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6135), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [42277] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6147), 1,
      sym__declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2920), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5673), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5675), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [42449] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6868), 1,
      sym_auto,
    ACTIONS(6870), 1,
      anon_sym_decltype,
    STATE(3012), 1,
      sym_decltype_auto,
    ACTIONS(5589), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5591), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [42518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2454), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6170), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6168), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [42585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5730), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [42648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2517), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6106), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6104), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [42715] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6447), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3926), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42824] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7165), 1,
      anon_sym_STAR,
    ACTIONS(7167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6607), 1,
      sym__declarator,
    STATE(8161), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2941), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3944), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42933] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7011), 1,
      anon_sym_EQ,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7133), 1,
      anon_sym_QMARK,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7137), 1,
      anon_sym_or,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7013), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [43046] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 4,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(5726), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(4146), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4154), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
  [43113] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2731), 1,
      sym_template_argument_list,
    ACTIONS(4172), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5838), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [43182] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6168), 1,
      sym__declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2960), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3973), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5653), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [43354] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7291), 1,
      anon_sym_STAR,
    ACTIONS(7293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5838), 1,
      sym__scope_resolution,
    STATE(6155), 1,
      sym__declarator,
    STATE(8021), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3958), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43463] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7291), 1,
      anon_sym_STAR,
    ACTIONS(7293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5838), 1,
      sym__scope_resolution,
    STATE(6155), 1,
      sym__declarator,
    STATE(8021), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2948), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3958), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43572] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7165), 1,
      anon_sym_STAR,
    ACTIONS(7167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6609), 1,
      sym__declarator,
    STATE(8161), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3936), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43681] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7181), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7183), 1,
      anon_sym_COMMA,
    ACTIONS(7187), 1,
      anon_sym_DASH,
    ACTIONS(7189), 1,
      anon_sym_PLUS,
    ACTIONS(7191), 1,
      anon_sym_STAR,
    ACTIONS(7193), 1,
      anon_sym_SLASH,
    ACTIONS(7195), 1,
      anon_sym_PERCENT,
    ACTIONS(7197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7201), 1,
      anon_sym_PIPE,
    ACTIONS(7203), 1,
      anon_sym_CARET,
    ACTIONS(7205), 1,
      anon_sym_AMP,
    ACTIONS(7207), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7209), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7211), 1,
      anon_sym_GT,
    ACTIONS(7213), 1,
      anon_sym_GT_EQ,
    ACTIONS(7215), 1,
      anon_sym_LT_EQ,
    ACTIONS(7217), 1,
      anon_sym_LT,
    ACTIONS(7219), 1,
      anon_sym_LT_LT,
    ACTIONS(7221), 1,
      anon_sym_GT_GT,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7225), 1,
      anon_sym_EQ,
    ACTIONS(7227), 1,
      anon_sym_QMARK,
    ACTIONS(7229), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7231), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7233), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7235), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7237), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7239), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7241), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7243), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7245), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7247), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7253), 1,
      anon_sym_or,
    ACTIONS(7255), 1,
      anon_sym_and,
    ACTIONS(7257), 1,
      anon_sym_bitor,
    ACTIONS(7259), 1,
      anon_sym_xor,
    ACTIONS(7261), 1,
      anon_sym_bitand,
    ACTIONS(7263), 1,
      anon_sym_not_eq,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7299), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7249), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [43842] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7291), 1,
      anon_sym_STAR,
    ACTIONS(7293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5838), 1,
      sym__scope_resolution,
    STATE(6171), 1,
      sym__declarator,
    STATE(8021), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2939), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3941), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43951] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7171), 1,
      anon_sym_STAR,
    ACTIONS(7173), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5850), 1,
      sym__scope_resolution,
    STATE(6652), 1,
      sym__declarator,
    STATE(8214), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3946), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44060] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4970), 1,
      anon_sym_LBRACE,
    ACTIONS(5030), 1,
      anon_sym_LT,
    STATE(3094), 1,
      sym_template_argument_list,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [44131] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7105), 1,
      anon_sym_STAR,
    ACTIONS(7107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7109), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6349), 1,
      sym__declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3927), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44240] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2731), 1,
      sym_template_argument_list,
    ACTIONS(4970), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(4963), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [44309] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7291), 1,
      anon_sym_STAR,
    ACTIONS(7293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5838), 1,
      sym__scope_resolution,
    STATE(6141), 1,
      sym__declarator,
    STATE(8021), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44418] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7015), 1,
      anon_sym_EQ,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7137), 1,
      anon_sym_or,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [44527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7081), 1,
      sym_literal_suffix,
    ACTIONS(4154), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4146), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [44592] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6447), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2958), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3926), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44701] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 1,
      anon_sym_const,
    ACTIONS(5007), 1,
      anon_sym_AMP,
    ACTIONS(5000), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(5005), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4998), 18,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5003), 18,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [44772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    ACTIONS(4963), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(4970), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [44841] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6447), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3963), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44950] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(7097), 1,
      anon_sym_LPAREN2,
    ACTIONS(7099), 1,
      anon_sym_LBRACK,
    ACTIONS(7101), 1,
      sym_auto,
    ACTIONS(7103), 1,
      anon_sym_decltype,
    STATE(3471), 1,
      sym_new_declarator,
    STATE(3525), 1,
      sym_decltype_auto,
    STATE(3888), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5873), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5875), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [45029] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7157), 1,
      anon_sym___asm,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4779), 1,
      sym__function_attributes_start,
    STATE(4959), 1,
      sym_ref_qualifier,
    STATE(5603), 1,
      sym_trailing_return_type,
    STATE(5701), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7154), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4072), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5287), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2532), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6098), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6096), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [45213] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6509), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3940), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5752), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [45385] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6167), 1,
      sym__declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3964), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45494] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(7097), 1,
      anon_sym_LPAREN2,
    ACTIONS(7099), 1,
      anon_sym_LBRACK,
    ACTIONS(7101), 1,
      sym_auto,
    ACTIONS(7103), 1,
      anon_sym_decltype,
    STATE(3367), 1,
      sym_new_declarator,
    STATE(3525), 1,
      sym_decltype_auto,
    STATE(3832), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5823), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5825), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [45573] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7157), 1,
      anon_sym___asm,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4789), 1,
      sym__function_attributes_start,
    STATE(4968), 1,
      sym_ref_qualifier,
    STATE(5479), 1,
      sym_trailing_return_type,
    STATE(5662), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7154), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5288), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45690] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [45781] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [45870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2487), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6060), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6058), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [45937] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [46022] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2411), 1,
      sym_attribute_specifier,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6064), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6062), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [46089] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [46170] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6447), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2897), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3963), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46279] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [46362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    ACTIONS(5838), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(4172), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [46431] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3427), 1,
      sym_attribute_specifier,
    ACTIONS(6104), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6106), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [46499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7303), 1,
      anon_sym_typedef,
    ACTIONS(2563), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2573), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [46563] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3397), 1,
      sym_attribute_specifier,
    ACTIONS(6090), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6092), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [46631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2573), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [46693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5699), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5701), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [46755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5629), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5631), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [46817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5452), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [46879] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3415), 1,
      sym_attribute_specifier,
    ACTIONS(6096), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6098), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [46947] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7305), 1,
      anon_sym_COLON,
    STATE(2509), 1,
      sym_attribute_specifier,
    STATE(2788), 1,
      sym__enum_base_clause,
    STATE(2880), 1,
      sym_enumerator_list,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6338), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6336), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [47021] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7149), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7307), 1,
      anon_sym___attribute__,
    ACTIONS(7310), 1,
      anon_sym___attribute,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4864), 1,
      sym__function_attributes_start,
    STATE(5028), 1,
      sym_ref_qualifier,
    STATE(5479), 1,
      sym_trailing_return_type,
    STATE(5915), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5311), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3045), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7315), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5452), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [47203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5452), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3419), 1,
      sym_attribute_specifier,
    ACTIONS(6168), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6170), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47333] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 1,
      anon_sym_const,
    ACTIONS(5007), 1,
      anon_sym_AMP,
    ACTIONS(5000), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
    ACTIONS(5005), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5003), 18,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4998), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [47403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5762), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5764), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5768), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47527] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(3614), 1,
      sym_field_declaration_list,
    STATE(7086), 1,
      sym_virtual_specifier,
    STATE(7881), 1,
      sym_base_class_clause,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5493), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5495), 39,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [47607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5772), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5776), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47731] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7319), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4879), 1,
      sym__function_attributes_start,
    STATE(5004), 1,
      sym_ref_qualifier,
    STATE(5993), 1,
      sym__function_attributes_end,
    STATE(6237), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7069), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5321), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5734), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5738), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47971] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7327), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4883), 1,
      sym__function_attributes_start,
    STATE(5026), 1,
      sym_ref_qualifier,
    STATE(6038), 1,
      sym_trailing_return_type,
    STATE(6139), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7324), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5324), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48087] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6983), 1,
      sym_auto,
    ACTIONS(6985), 1,
      anon_sym_decltype,
    STATE(3169), 1,
      sym_decltype_auto,
    ACTIONS(5589), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5591), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [48155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5756), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5760), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48279] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7332), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4872), 1,
      sym__function_attributes_start,
    STATE(5005), 1,
      sym_ref_qualifier,
    STATE(5929), 1,
      sym_trailing_return_type,
    STATE(6153), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7324), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5328), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6844), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6842), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [48457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5788), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5790), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5792), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5796), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5788), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48705] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4893), 1,
      sym__function_attributes_start,
    STATE(5017), 1,
      sym_ref_qualifier,
    STATE(5985), 1,
      sym_trailing_return_type,
    STATE(6110), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5309), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48821] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4106), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4111), 1,
      anon_sym_using,
    ACTIONS(4113), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(4115), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [48887] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7345), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7347), 1,
      anon_sym_PIPE,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7363), 1,
      anon_sym_or,
    ACTIONS(7365), 1,
      anon_sym_and,
    ACTIONS(7367), 1,
      anon_sym_bitor,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6987), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [48995] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7149), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7307), 1,
      anon_sym___attribute__,
    ACTIONS(7310), 1,
      anon_sym___attribute,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4866), 1,
      sym__function_attributes_start,
    STATE(4987), 1,
      sym_ref_qualifier,
    STATE(5446), 1,
      sym_trailing_return_type,
    STATE(5936), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7069), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5331), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5649), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7371), 1,
      anon_sym_namespace,
    ACTIONS(6844), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6842), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [49237] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(7373), 1,
      anon_sym_LPAREN2,
    STATE(2616), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3421), 1,
      sym_argument_list,
    STATE(3912), 1,
      sym_initializer_list,
    ACTIONS(6723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5452), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5450), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [49311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7382), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7380), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7378), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7376), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [49377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5798), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5800), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49439] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7345), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7347), 1,
      anon_sym_PIPE,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7363), 1,
      anon_sym_or,
    ACTIONS(7365), 1,
      anon_sym_and,
    ACTIONS(7367), 1,
      anon_sym_bitor,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    ACTIONS(7384), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6524), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6526), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [49551] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3497), 1,
      sym_attribute_specifier,
    ACTIONS(6058), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6060), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5452), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5450), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [49681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3458), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6119), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49749] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3499), 1,
      sym_attribute_specifier,
    ACTIONS(6062), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6064), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49817] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7345), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7347), 1,
      anon_sym_PIPE,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7365), 1,
      anon_sym_and,
    ACTIONS(7367), 1,
      anon_sym_bitor,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 3,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [49921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5808), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5812), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50045] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7347), 1,
      anon_sym_PIPE,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7367), 1,
      anon_sym_bitor,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 4,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6451), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [50145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5639), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50207] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [50303] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [50397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5665), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50459] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [50549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5667), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5669), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5681), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5683), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50673] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [50761] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 11,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [50845] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(2641), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2731), 1,
      sym_template_argument_list,
    ACTIONS(4174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4152), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4144), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [50917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5742), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50979] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4892), 1,
      sym__function_attributes_start,
    STATE(5020), 1,
      sym_ref_qualifier,
    STATE(5983), 1,
      sym__function_attributes_end,
    STATE(6248), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5306), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51095] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7345), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7347), 1,
      anon_sym_PIPE,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7363), 1,
      anon_sym_or,
    ACTIONS(7365), 1,
      anon_sym_and,
    ACTIONS(7367), 1,
      anon_sym_bitor,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6933), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [51203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5780), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [51265] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7345), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7347), 1,
      anon_sym_PIPE,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7363), 1,
      anon_sym_or,
    ACTIONS(7365), 1,
      anon_sym_and,
    ACTIONS(7367), 1,
      anon_sym_bitor,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [51373] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [51451] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 13,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [51531] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 11,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [51613] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7345), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7347), 1,
      anon_sym_PIPE,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7363), 1,
      anon_sym_or,
    ACTIONS(7365), 1,
      anon_sym_and,
    ACTIONS(7367), 1,
      anon_sym_bitor,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7005), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [51721] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7345), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7347), 1,
      anon_sym_PIPE,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7363), 1,
      anon_sym_or,
    ACTIONS(7365), 1,
      anon_sym_and,
    ACTIONS(7367), 1,
      anon_sym_bitor,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    ACTIONS(7384), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7011), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7013), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [51833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7394), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7392), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7390), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [51899] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7345), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7347), 1,
      anon_sym_PIPE,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7363), 1,
      anon_sym_or,
    ACTIONS(7365), 1,
      anon_sym_and,
    ACTIONS(7367), 1,
      anon_sym_bitor,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7015), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [52007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5450), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5452), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [52071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7398), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5888), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [52137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5655), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5657), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7398), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5900), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5898), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [52265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5661), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5679), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5687), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52451] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7343), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7345), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7347), 1,
      anon_sym_PIPE,
    ACTIONS(7351), 1,
      anon_sym_AMP,
    ACTIONS(7357), 1,
      anon_sym_GT_EQ,
    ACTIONS(7361), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7363), 1,
      anon_sym_or,
    ACTIONS(7365), 1,
      anon_sym_and,
    ACTIONS(7367), 1,
      anon_sym_bitor,
    ACTIONS(7369), 1,
      anon_sym_bitand,
    ACTIONS(7384), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7019), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7349), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7341), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7353), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7355), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7021), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [52563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5694), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52625] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4857), 1,
      sym__function_attributes_start,
    STATE(4993), 1,
      sym_ref_qualifier,
    STATE(5906), 1,
      sym_trailing_return_type,
    STATE(6130), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5304), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5679), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5679), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52865] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3925), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7402), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3903), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3901), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [52931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3071), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7404), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5938), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5936), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [52997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3072), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7406), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5932), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5930), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [53063] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2624), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3623), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3627), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5912), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5914), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53131] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3534), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6123), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3949), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3947), 48,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_using,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53261] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7305), 1,
      anon_sym_COLON,
    STATE(2469), 1,
      sym_attribute_specifier,
    STATE(2775), 1,
      sym__enum_base_clause,
    STATE(2882), 1,
      sym_enumerator_list,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6344), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6342), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [53335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 1,
      anon_sym_typedef,
    ACTIONS(2563), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2573), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7414), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7412), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7410), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [53465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7418), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3065), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2051), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6235), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [53531] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7421), 1,
      anon_sym_friend,
    ACTIONS(2563), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2573), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7429), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7427), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7425), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7423), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [53661] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4970), 1,
      anon_sym_LBRACE,
    ACTIONS(5486), 1,
      anon_sym_LT,
    STATE(3129), 1,
      sym_template_argument_list,
    ACTIONS(4972), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [53731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3933), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7431), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3929), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3927), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [53797] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_LPAREN2,
    ACTIONS(7435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7437), 1,
      anon_sym_LBRACK,
    STATE(3429), 1,
      sym_parameter_list,
    STATE(3152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6066), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6068), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [53869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7398), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5944), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5942), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [53935] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7398), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5894), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [54001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3084), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7439), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5904), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5902), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [54067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3085), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7441), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5922), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5920), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [54133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7398), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5928), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5926), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [54199] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    STATE(3520), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6263), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6265), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54267] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_LPAREN2,
    ACTIONS(7435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7437), 1,
      anon_sym_LBRACK,
    STATE(3429), 1,
      sym_parameter_list,
    STATE(3152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6133), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6135), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [54339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3953), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3951), 48,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_using,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [54401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3488), 1,
      sym_attribute_specifier,
    ACTIONS(6125), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6127), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [54469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3045), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7315), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5750), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5752), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [54535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7443), 1,
      anon_sym_namespace,
    ACTIONS(6844), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6842), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [54599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7445), 1,
      anon_sym_friend,
    ACTIONS(2563), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2573), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [54663] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_LPAREN2,
    ACTIONS(7435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7437), 1,
      anon_sym_LBRACK,
    STATE(3429), 1,
      sym_parameter_list,
    STATE(3152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6164), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6166), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [54735] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7398), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5910), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5908), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [54801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7398), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5918), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5916), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [54867] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7093), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3065), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6249), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6251), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54933] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7307), 1,
      anon_sym___attribute__,
    ACTIONS(7310), 1,
      anon_sym___attribute,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4896), 1,
      sym__function_attributes_start,
    STATE(5034), 1,
      sym_ref_qualifier,
    STATE(5906), 1,
      sym_trailing_return_type,
    STATE(5974), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5314), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55049] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7307), 1,
      anon_sym___attribute__,
    ACTIONS(7310), 1,
      anon_sym___attribute,
    ACTIONS(7332), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4843), 1,
      sym__function_attributes_start,
    STATE(5027), 1,
      sym_ref_qualifier,
    STATE(5929), 1,
      sym_trailing_return_type,
    STATE(5942), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7324), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5317), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7449), 1,
      anon_sym_namespace,
    ACTIONS(6844), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6842), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [55229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    STATE(3467), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6172), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6174), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [55297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5643), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7451), 1,
      anon_sym_friend,
    ACTIONS(2563), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2573), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [55423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_namespace,
    ACTIONS(6844), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6842), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [55487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5005), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4998), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [55551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7455), 1,
      anon_sym_friend,
    ACTIONS(2563), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2573), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [55615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7459), 25,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7457), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [55677] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3400), 1,
      sym_attribute_specifier,
    ACTIONS(6129), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6131), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7461), 1,
      anon_sym_friend,
    ACTIONS(2563), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2573), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [55809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7463), 1,
      anon_sym_friend,
    ACTIONS(2563), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2573), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [55873] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_LPAREN2,
    ACTIONS(7435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7437), 1,
      anon_sym_LBRACK,
    STATE(3429), 1,
      sym_parameter_list,
    STATE(3152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6100), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6102), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [55945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7465), 1,
      anon_sym_friend,
    ACTIONS(2563), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2573), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [56009] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_LPAREN2,
    ACTIONS(7435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7437), 1,
      anon_sym_LBRACK,
    STATE(3429), 1,
      sym_parameter_list,
    STATE(3152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6038), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6040), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [56081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5627), 1,
      anon_sym_LBRACE,
    ACTIONS(5452), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5450), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [56147] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    STATE(3391), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6188), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6190), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7467), 1,
      anon_sym_typedef,
    ACTIONS(2563), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2573), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [56279] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3445), 1,
      sym_attribute_specifier,
    ACTIONS(6151), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6153), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [56347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym___attribute__,
    ACTIONS(6791), 1,
      anon_sym___attribute,
    STATE(3404), 1,
      sym_attribute_specifier,
    ACTIONS(6155), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6157), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [56415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    STATE(3466), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6204), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6206), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5627), 1,
      anon_sym_LBRACE,
    ACTIONS(5452), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5450), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [56547] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [56640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5699), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5701), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [56701] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7011), 1,
      anon_sym_EQ,
    ACTIONS(7181), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7227), 1,
      anon_sym_QMARK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7491), 1,
      anon_sym_PIPE,
    ACTIONS(7495), 1,
      anon_sym_or,
    ACTIONS(7497), 1,
      anon_sym_and,
    ACTIONS(7499), 1,
      anon_sym_bitor,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7013), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [56812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5452), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [56873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5452), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [56934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5742), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [56995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7501), 1,
      anon_sym_LT,
    STATE(1565), 1,
      sym_template_argument_list,
    ACTIONS(6513), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6515), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5762), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5764), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5780), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57182] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    ACTIONS(7506), 1,
      anon_sym_EQ,
    STATE(2641), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2731), 1,
      sym_template_argument_list,
    ACTIONS(7504), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(4174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4152), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4144), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [57257] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7515), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7511), 4,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7513), 5,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_explicit,
      anon_sym_operator,
    ACTIONS(7518), 11,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_auto,
      anon_sym_typename,
    ACTIONS(7508), 31,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
  [57324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5768), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7501), 1,
      anon_sym_LT,
    STATE(2864), 1,
      sym_template_argument_list,
    ACTIONS(6513), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6515), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5772), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5776), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5653), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57633] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(6987), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7491), 1,
      anon_sym_PIPE,
    ACTIONS(7495), 1,
      anon_sym_or,
    ACTIONS(7497), 1,
      anon_sym_and,
    ACTIONS(7499), 1,
      anon_sym_bitor,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [57740] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    STATE(3954), 1,
      sym_field_declaration_list,
    STATE(4095), 1,
      sym_attribute_specifier,
    STATE(7095), 1,
      sym_virtual_specifier,
    STATE(7864), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5493), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5495), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57817] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 1,
      sym_identifier,
    STATE(3137), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6010), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6012), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5392), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5390), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5005), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4998), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [57949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7501), 1,
      anon_sym_LT,
    STATE(1546), 1,
      sym_template_argument_list,
    ACTIONS(6513), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6515), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5673), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5675), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [58075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6844), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6842), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [58136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7524), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6477), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6479), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [58199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5752), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [58260] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7526), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3135), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2051), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6235), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [58325] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6435), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6437), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [58400] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      sym_identifier,
    STATE(3151), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6010), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6012), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5398), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5396), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58469] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      anon_sym_EQ,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7181), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7227), 1,
      anon_sym_QMARK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7491), 1,
      anon_sym_PIPE,
    ACTIONS(7495), 1,
      anon_sym_or,
    ACTIONS(7497), 1,
      anon_sym_and,
    ACTIONS(7499), 1,
      anon_sym_bitor,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6526), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [58580] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6441), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6443), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [58655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_LBRACK,
    STATE(3266), 1,
      sym_new_declarator,
    ACTIONS(6352), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6354), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [58720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5655), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5657), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5734), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5643), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5738), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58964] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(6967), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7491), 1,
      anon_sym_PIPE,
    ACTIONS(7495), 1,
      anon_sym_or,
    ACTIONS(7497), 1,
      anon_sym_and,
    ACTIONS(7499), 1,
      anon_sym_bitor,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [59071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5756), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [59132] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6445), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6447), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [59205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5760), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [59266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5661), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [59327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(2731), 1,
      sym_template_argument_list,
    ACTIONS(4970), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4963), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [59394] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7531), 1,
      sym_identifier,
    STATE(3151), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7534), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7537), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5405), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5403), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [59463] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3135), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6249), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6251), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [59528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7540), 1,
      anon_sym_LT,
    STATE(3094), 1,
      sym_template_argument_list,
    ACTIONS(6513), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6515), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [59593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5679), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [59654] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [59731] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6449), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [59806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5687), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [59867] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7491), 1,
      anon_sym_PIPE,
    ACTIONS(7497), 1,
      anon_sym_and,
    ACTIONS(7499), 1,
      anon_sym_bitor,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(6449), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [59970] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7491), 1,
      anon_sym_PIPE,
    ACTIONS(7499), 1,
      anon_sym_bitor,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6449), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [60069] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [60164] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_LBRACE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    STATE(3685), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6172), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6174), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [60231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5784), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [60292] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [60379] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [60462] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [60541] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [60622] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7543), 1,
      anon_sym_LT,
    STATE(3321), 1,
      sym_template_argument_list,
    ACTIONS(6368), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6370), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7540), 1,
      anon_sym_LT,
    STATE(1701), 1,
      sym_template_argument_list,
    ACTIONS(6513), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6515), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5798), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5800), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60815] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(2731), 1,
      sym_template_argument_list,
    ACTIONS(4172), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5838), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [60882] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6467), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6469), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [60957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5694), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5804), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [61079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7546), 1,
      anon_sym_LT,
    STATE(3321), 1,
      sym_template_argument_list,
    ACTIONS(6310), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6312), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5679), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5788), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61268] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4938), 1,
      sym__function_attributes_start,
    STATE(5133), 1,
      sym_ref_qualifier,
    STATE(6196), 1,
      sym_trailing_return_type,
    STATE(6268), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5335), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5790), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5792), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61444] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7553), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4902), 1,
      sym__function_attributes_start,
    STATE(5068), 1,
      sym_ref_qualifier,
    STATE(6187), 1,
      sym_trailing_return_type,
    STATE(6209), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7324), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5338), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7040), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5796), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7081), 1,
      sym_literal_suffix,
    ACTIONS(4146), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4154), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [61683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5788), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61744] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7015), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7491), 1,
      anon_sym_PIPE,
    ACTIONS(7495), 1,
      anon_sym_or,
    ACTIONS(7497), 1,
      anon_sym_and,
    ACTIONS(7499), 1,
      anon_sym_bitor,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [61851] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7019), 1,
      anon_sym_EQ,
    ACTIONS(7181), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7227), 1,
      anon_sym_QMARK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7491), 1,
      anon_sym_PIPE,
    ACTIONS(7495), 1,
      anon_sym_or,
    ACTIONS(7497), 1,
      anon_sym_and,
    ACTIONS(7499), 1,
      anon_sym_bitor,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7021), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [61962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5649), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62023] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6425), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6427), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [62096] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2624), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3623), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3627), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5912), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5914), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [62163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5679), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62224] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7033), 1,
      anon_sym_LBRACK,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(2641), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3962), 1,
      sym_template_argument_list,
    ACTIONS(4169), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4152), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_EQ,
    ACTIONS(4144), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [62299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4970), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_LT,
    STATE(3335), 1,
      sym_template_argument_list,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [62368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5808), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5812), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62490] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(3363), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7556), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5977), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5979), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [62559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5639), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5730), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [62681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5665), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62742] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6491), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6493), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [62817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5667), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5669), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_LBRACE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    STATE(3586), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6263), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6265), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [62945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5681), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5683), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [63006] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(6933), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7491), 1,
      anon_sym_PIPE,
    ACTIONS(7495), 1,
      anon_sym_or,
    ACTIONS(7497), 1,
      anon_sym_and,
    ACTIONS(7499), 1,
      anon_sym_bitor,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [63113] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_LBRACE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    STATE(3627), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6188), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6190), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [63180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6915), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [63241] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7005), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7473), 1,
      anon_sym_AMP,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7491), 1,
      anon_sym_PIPE,
    ACTIONS(7495), 1,
      anon_sym_or,
    ACTIONS(7497), 1,
      anon_sym_and,
    ACTIONS(7499), 1,
      anon_sym_bitor,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7493), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [63348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7558), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6477), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6479), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63411] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_LBRACE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    STATE(3625), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6204), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6206), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [63478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7038), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7036), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [63539] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7479), 1,
      anon_sym_GT_EQ,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7265), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7481), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7471), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7475), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7477), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [63628] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [63706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5194), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5164), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7568), 1,
      anon_sym_LT,
    STATE(3129), 1,
      sym_template_argument_list,
    ACTIONS(6513), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6515), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7036), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(7038), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5150), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64010] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7573), 1,
      anon_sym_COMMA,
    ACTIONS(7575), 1,
      anon_sym_RPAREN,
    ACTIONS(7577), 1,
      anon_sym_DASH,
    ACTIONS(7579), 1,
      anon_sym_PLUS,
    ACTIONS(7581), 1,
      anon_sym_STAR,
    ACTIONS(7583), 1,
      anon_sym_SLASH,
    ACTIONS(7585), 1,
      anon_sym_PERCENT,
    ACTIONS(7587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7589), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7591), 1,
      anon_sym_PIPE,
    ACTIONS(7593), 1,
      anon_sym_CARET,
    ACTIONS(7595), 1,
      anon_sym_AMP,
    ACTIONS(7597), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7599), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7601), 1,
      anon_sym_GT,
    ACTIONS(7603), 1,
      anon_sym_GT_EQ,
    ACTIONS(7605), 1,
      anon_sym_LT_EQ,
    ACTIONS(7607), 1,
      anon_sym_LT,
    ACTIONS(7609), 1,
      anon_sym_LT_LT,
    ACTIONS(7611), 1,
      anon_sym_GT_GT,
    ACTIONS(7613), 1,
      anon_sym_EQ,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7617), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7619), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7621), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7623), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7625), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7627), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7629), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7631), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7633), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7635), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7639), 1,
      anon_sym_or,
    ACTIONS(7641), 1,
      anon_sym_and,
    ACTIONS(7643), 1,
      anon_sym_bitor,
    ACTIONS(7645), 1,
      anon_sym_xor,
    ACTIONS(7647), 1,
      anon_sym_bitand,
    ACTIONS(7649), 1,
      anon_sym_not_eq,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [64166] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7307), 1,
      anon_sym___attribute__,
    ACTIONS(7310), 1,
      anon_sym___attribute,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4960), 1,
      sym__function_attributes_start,
    STATE(5229), 1,
      sym_ref_qualifier,
    STATE(6113), 1,
      sym__function_attributes_end,
    STATE(6196), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(7040), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5366), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5168), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64340] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6524), 1,
      anon_sym_EQ,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7133), 1,
      anon_sym_QMARK,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7137), 1,
      anon_sym_or,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7655), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6526), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [64452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(1934), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64512] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7573), 1,
      anon_sym_COMMA,
    ACTIONS(7577), 1,
      anon_sym_DASH,
    ACTIONS(7579), 1,
      anon_sym_PLUS,
    ACTIONS(7581), 1,
      anon_sym_STAR,
    ACTIONS(7583), 1,
      anon_sym_SLASH,
    ACTIONS(7585), 1,
      anon_sym_PERCENT,
    ACTIONS(7587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7589), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7591), 1,
      anon_sym_PIPE,
    ACTIONS(7593), 1,
      anon_sym_CARET,
    ACTIONS(7595), 1,
      anon_sym_AMP,
    ACTIONS(7597), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7599), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7601), 1,
      anon_sym_GT,
    ACTIONS(7603), 1,
      anon_sym_GT_EQ,
    ACTIONS(7605), 1,
      anon_sym_LT_EQ,
    ACTIONS(7607), 1,
      anon_sym_LT,
    ACTIONS(7609), 1,
      anon_sym_LT_LT,
    ACTIONS(7611), 1,
      anon_sym_GT_GT,
    ACTIONS(7613), 1,
      anon_sym_EQ,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7617), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7619), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7621), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7623), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7625), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7627), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7629), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7631), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7633), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7635), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7639), 1,
      anon_sym_or,
    ACTIONS(7641), 1,
      anon_sym_and,
    ACTIONS(7643), 1,
      anon_sym_bitor,
    ACTIONS(7645), 1,
      anon_sym_xor,
    ACTIONS(7647), 1,
      anon_sym_bitand,
    ACTIONS(7649), 1,
      anon_sym_not_eq,
    ACTIONS(7657), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [64668] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6491), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6493), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [64742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5138), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64802] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7307), 1,
      anon_sym___attribute__,
    ACTIONS(7310), 1,
      anon_sym___attribute,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4973), 1,
      sym__function_attributes_start,
    STATE(5219), 1,
      sym_ref_qualifier,
    STATE(5985), 1,
      sym_trailing_return_type,
    STATE(6094), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(7040), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5356), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64916] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7669), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7677), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7691), 1,
      anon_sym_QMARK,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7695), 1,
      anon_sym_or,
    ACTIONS(7697), 1,
      anon_sym_and,
    ACTIONS(7699), 1,
      anon_sym_bitor,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7011), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7013), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [65024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5629), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5631), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [65144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6700), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65324] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7573), 1,
      anon_sym_COMMA,
    ACTIONS(7577), 1,
      anon_sym_DASH,
    ACTIONS(7579), 1,
      anon_sym_PLUS,
    ACTIONS(7581), 1,
      anon_sym_STAR,
    ACTIONS(7583), 1,
      anon_sym_SLASH,
    ACTIONS(7585), 1,
      anon_sym_PERCENT,
    ACTIONS(7587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7589), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7591), 1,
      anon_sym_PIPE,
    ACTIONS(7593), 1,
      anon_sym_CARET,
    ACTIONS(7595), 1,
      anon_sym_AMP,
    ACTIONS(7597), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7599), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7601), 1,
      anon_sym_GT,
    ACTIONS(7603), 1,
      anon_sym_GT_EQ,
    ACTIONS(7605), 1,
      anon_sym_LT_EQ,
    ACTIONS(7607), 1,
      anon_sym_LT,
    ACTIONS(7609), 1,
      anon_sym_LT_LT,
    ACTIONS(7611), 1,
      anon_sym_GT_GT,
    ACTIONS(7613), 1,
      anon_sym_EQ,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7617), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7619), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7621), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7623), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7625), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7627), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7629), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7631), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7633), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7635), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7639), 1,
      anon_sym_or,
    ACTIONS(7641), 1,
      anon_sym_and,
    ACTIONS(7643), 1,
      anon_sym_bitor,
    ACTIONS(7645), 1,
      anon_sym_xor,
    ACTIONS(7647), 1,
      anon_sym_bitand,
    ACTIONS(7649), 1,
      anon_sym_not_eq,
    ACTIONS(7703), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [65480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6208), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6210), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5036), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5949), 1,
      anon_sym_LBRACK,
    ACTIONS(5946), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(4154), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4146), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7705), 1,
      sym_literal_suffix,
    ACTIONS(4154), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4146), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65788] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7573), 1,
      anon_sym_COMMA,
    ACTIONS(7577), 1,
      anon_sym_DASH,
    ACTIONS(7579), 1,
      anon_sym_PLUS,
    ACTIONS(7581), 1,
      anon_sym_STAR,
    ACTIONS(7583), 1,
      anon_sym_SLASH,
    ACTIONS(7585), 1,
      anon_sym_PERCENT,
    ACTIONS(7587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7589), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7591), 1,
      anon_sym_PIPE,
    ACTIONS(7593), 1,
      anon_sym_CARET,
    ACTIONS(7595), 1,
      anon_sym_AMP,
    ACTIONS(7597), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7599), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7601), 1,
      anon_sym_GT,
    ACTIONS(7603), 1,
      anon_sym_GT_EQ,
    ACTIONS(7605), 1,
      anon_sym_LT_EQ,
    ACTIONS(7607), 1,
      anon_sym_LT,
    ACTIONS(7609), 1,
      anon_sym_LT_LT,
    ACTIONS(7611), 1,
      anon_sym_GT_GT,
    ACTIONS(7613), 1,
      anon_sym_EQ,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7617), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7619), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7621), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7623), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7625), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7627), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7629), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7631), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7633), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7635), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7639), 1,
      anon_sym_or,
    ACTIONS(7641), 1,
      anon_sym_and,
    ACTIONS(7643), 1,
      anon_sym_bitor,
    ACTIONS(7645), 1,
      anon_sym_xor,
    ACTIONS(7647), 1,
      anon_sym_bitand,
    ACTIONS(7649), 1,
      anon_sym_not_eq,
    ACTIONS(7707), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [65944] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7709), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
    STATE(1935), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5038), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4152), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [66014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66074] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7573), 1,
      anon_sym_COMMA,
    ACTIONS(7577), 1,
      anon_sym_DASH,
    ACTIONS(7579), 1,
      anon_sym_PLUS,
    ACTIONS(7581), 1,
      anon_sym_STAR,
    ACTIONS(7583), 1,
      anon_sym_SLASH,
    ACTIONS(7585), 1,
      anon_sym_PERCENT,
    ACTIONS(7587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7589), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7591), 1,
      anon_sym_PIPE,
    ACTIONS(7593), 1,
      anon_sym_CARET,
    ACTIONS(7595), 1,
      anon_sym_AMP,
    ACTIONS(7597), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7599), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7601), 1,
      anon_sym_GT,
    ACTIONS(7603), 1,
      anon_sym_GT_EQ,
    ACTIONS(7605), 1,
      anon_sym_LT_EQ,
    ACTIONS(7607), 1,
      anon_sym_LT,
    ACTIONS(7609), 1,
      anon_sym_LT_LT,
    ACTIONS(7611), 1,
      anon_sym_GT_GT,
    ACTIONS(7613), 1,
      anon_sym_EQ,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7617), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7619), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7621), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7623), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7625), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7627), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7629), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7631), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7633), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7635), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7639), 1,
      anon_sym_or,
    ACTIONS(7641), 1,
      anon_sym_and,
    ACTIONS(7643), 1,
      anon_sym_bitor,
    ACTIONS(7645), 1,
      anon_sym_xor,
    ACTIONS(7647), 1,
      anon_sym_bitand,
    ACTIONS(7649), 1,
      anon_sym_not_eq,
    ACTIONS(7711), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [66230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5146), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5997), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      anon_sym_EQ,
    ACTIONS(4182), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4154), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5036), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5946), 1,
      anon_sym_LPAREN2,
    ACTIONS(5949), 1,
      anon_sym_LBRACK,
    ACTIONS(4154), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66480] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7573), 1,
      anon_sym_COMMA,
    ACTIONS(7577), 1,
      anon_sym_DASH,
    ACTIONS(7579), 1,
      anon_sym_PLUS,
    ACTIONS(7581), 1,
      anon_sym_STAR,
    ACTIONS(7583), 1,
      anon_sym_SLASH,
    ACTIONS(7585), 1,
      anon_sym_PERCENT,
    ACTIONS(7587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7589), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7591), 1,
      anon_sym_PIPE,
    ACTIONS(7593), 1,
      anon_sym_CARET,
    ACTIONS(7595), 1,
      anon_sym_AMP,
    ACTIONS(7597), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7599), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7601), 1,
      anon_sym_GT,
    ACTIONS(7603), 1,
      anon_sym_GT_EQ,
    ACTIONS(7605), 1,
      anon_sym_LT_EQ,
    ACTIONS(7607), 1,
      anon_sym_LT,
    ACTIONS(7609), 1,
      anon_sym_LT_LT,
    ACTIONS(7611), 1,
      anon_sym_GT_GT,
    ACTIONS(7613), 1,
      anon_sym_EQ,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7617), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7619), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7621), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7623), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7625), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7627), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7629), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7631), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7633), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7635), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7639), 1,
      anon_sym_or,
    ACTIONS(7641), 1,
      anon_sym_and,
    ACTIONS(7643), 1,
      anon_sym_bitor,
    ACTIONS(7645), 1,
      anon_sym_xor,
    ACTIONS(7647), 1,
      anon_sym_bitand,
    ACTIONS(7649), 1,
      anon_sym_not_eq,
    ACTIONS(7713), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [66636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6269), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6271), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5138), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5138), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3951), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3953), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66876] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6425), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6427), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [66948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6275), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67008] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7677), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7695), 1,
      anon_sym_or,
    ACTIONS(7697), 1,
      anon_sym_and,
    ACTIONS(7699), 1,
      anon_sym_bitor,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(6933), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [67112] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5036), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5946), 1,
      anon_sym_LPAREN2,
    ACTIONS(5949), 1,
      anon_sym_LBRACK,
    ACTIONS(4154), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67178] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 1,
      anon_sym_EQ,
    ACTIONS(6008), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4154), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6546), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6402), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6404), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6220), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67422] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7119), 1,
      anon_sym_PIPE,
    ACTIONS(7123), 1,
      anon_sym_AMP,
    ACTIONS(7129), 1,
      anon_sym_GT_EQ,
    ACTIONS(7133), 1,
      anon_sym_QMARK,
    ACTIONS(7135), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7137), 1,
      anon_sym_or,
    ACTIONS(7139), 1,
      anon_sym_and,
    ACTIONS(7141), 1,
      anon_sym_bitor,
    ACTIONS(7143), 1,
      anon_sym_bitand,
    ACTIONS(7185), 1,
      anon_sym_RPAREN,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(7717), 1,
      anon_sym_EQ,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7111), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7121), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7131), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7125), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7127), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7249), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [67536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5132), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5134), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5142), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7719), 1,
      anon_sym_LT,
    STATE(3399), 1,
      sym_template_argument_list,
    ACTIONS(6310), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6312), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [67722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7722), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6477), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6479), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6286), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6288), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 1,
      anon_sym_LBRACK,
    STATE(3388), 1,
      sym_new_declarator,
    ACTIONS(6352), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6354), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [67908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6465), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(1938), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6487), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6489), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6297), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5172), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68208] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6758), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7727), 1,
      anon_sym_virtual,
    ACTIONS(7736), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7739), 1,
      anon_sym___declspec,
    STATE(1658), 1,
      sym_alignas_qualifier,
    ACTIONS(7733), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(7742), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3269), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(7730), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(7724), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6756), 14,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [68286] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4972), 1,
      sym__function_attributes_start,
    STATE(5179), 1,
      sym_ref_qualifier,
    STATE(5479), 1,
      sym_trailing_return_type,
    STATE(6199), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(7040), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5362), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7540), 1,
      anon_sym_LT,
    STATE(1574), 1,
      sym_template_argument_list,
    ACTIONS(6513), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6515), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68464] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7573), 1,
      anon_sym_COMMA,
    ACTIONS(7577), 1,
      anon_sym_DASH,
    ACTIONS(7579), 1,
      anon_sym_PLUS,
    ACTIONS(7581), 1,
      anon_sym_STAR,
    ACTIONS(7583), 1,
      anon_sym_SLASH,
    ACTIONS(7585), 1,
      anon_sym_PERCENT,
    ACTIONS(7587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7589), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7591), 1,
      anon_sym_PIPE,
    ACTIONS(7593), 1,
      anon_sym_CARET,
    ACTIONS(7595), 1,
      anon_sym_AMP,
    ACTIONS(7597), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7599), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7601), 1,
      anon_sym_GT,
    ACTIONS(7603), 1,
      anon_sym_GT_EQ,
    ACTIONS(7605), 1,
      anon_sym_LT_EQ,
    ACTIONS(7607), 1,
      anon_sym_LT,
    ACTIONS(7609), 1,
      anon_sym_LT_LT,
    ACTIONS(7611), 1,
      anon_sym_GT_GT,
    ACTIONS(7613), 1,
      anon_sym_EQ,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7617), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7619), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7621), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7623), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7625), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7627), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7629), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7631), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7633), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7635), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7639), 1,
      anon_sym_or,
    ACTIONS(7641), 1,
      anon_sym_and,
    ACTIONS(7643), 1,
      anon_sym_bitor,
    ACTIONS(7645), 1,
      anon_sym_xor,
    ACTIONS(7647), 1,
      anon_sym_bitand,
    ACTIONS(7649), 1,
      anon_sym_not_eq,
    ACTIONS(7747), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [68620] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4967), 1,
      sym__function_attributes_start,
    STATE(5204), 1,
      sym_ref_qualifier,
    STATE(5446), 1,
      sym_trailing_return_type,
    STATE(6203), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7069), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(7040), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5348), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68734] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    ACTIONS(7506), 1,
      anon_sym_EQ,
    STATE(2731), 1,
      sym_template_argument_list,
    ACTIONS(7504), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(4172), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5838), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [68804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5154), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5997), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5188), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5190), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69044] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7669), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7677), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7691), 1,
      anon_sym_QMARK,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7695), 1,
      anon_sym_or,
    ACTIONS(7697), 1,
      anon_sym_and,
    ACTIONS(7699), 1,
      anon_sym_bitor,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7019), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7021), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [69152] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7677), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7695), 1,
      anon_sym_or,
    ACTIONS(7697), 1,
      anon_sym_and,
    ACTIONS(7699), 1,
      anon_sym_bitor,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(6987), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [69256] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      anon_sym_EQ,
    ACTIONS(5036), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5946), 1,
      anon_sym_LPAREN2,
    ACTIONS(5949), 1,
      anon_sym_LBRACK,
    ACTIONS(4182), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4154), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69326] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7756), 1,
      anon_sym_virtual,
    ACTIONS(7765), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7768), 1,
      anon_sym___declspec,
    ACTIONS(7774), 1,
      anon_sym_explicit,
    STATE(2975), 1,
      sym_alignas_qualifier,
    ACTIONS(7762), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(7771), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7751), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(7749), 7,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(7759), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3282), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_explicit_function_specifier,
      sym__constructor_specifiers,
      aux_sym_operator_cast_definition_repeat1,
    ACTIONS(7753), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69406] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7784), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7781), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7779), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7777), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [69474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6279), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6194), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6196), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6198), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69654] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7669), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7677), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7691), 1,
      anon_sym_QMARK,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7695), 1,
      anon_sym_or,
    ACTIONS(7697), 1,
      anon_sym_and,
    ACTIONS(7699), 1,
      anon_sym_bitor,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(6524), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6526), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [69762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6200), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6202), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69822] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6445), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6447), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [69894] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7573), 1,
      anon_sym_COMMA,
    ACTIONS(7577), 1,
      anon_sym_DASH,
    ACTIONS(7579), 1,
      anon_sym_PLUS,
    ACTIONS(7581), 1,
      anon_sym_STAR,
    ACTIONS(7583), 1,
      anon_sym_SLASH,
    ACTIONS(7585), 1,
      anon_sym_PERCENT,
    ACTIONS(7587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7589), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7591), 1,
      anon_sym_PIPE,
    ACTIONS(7593), 1,
      anon_sym_CARET,
    ACTIONS(7595), 1,
      anon_sym_AMP,
    ACTIONS(7597), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7599), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7601), 1,
      anon_sym_GT,
    ACTIONS(7603), 1,
      anon_sym_GT_EQ,
    ACTIONS(7605), 1,
      anon_sym_LT_EQ,
    ACTIONS(7607), 1,
      anon_sym_LT,
    ACTIONS(7609), 1,
      anon_sym_LT_LT,
    ACTIONS(7611), 1,
      anon_sym_GT_GT,
    ACTIONS(7613), 1,
      anon_sym_EQ,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7617), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7619), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7621), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7623), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7625), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7627), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7629), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7631), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7633), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7635), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7639), 1,
      anon_sym_or,
    ACTIONS(7641), 1,
      anon_sym_and,
    ACTIONS(7643), 1,
      anon_sym_bitor,
    ACTIONS(7645), 1,
      anon_sym_xor,
    ACTIONS(7647), 1,
      anon_sym_bitand,
    ACTIONS(7649), 1,
      anon_sym_not_eq,
    ACTIONS(7787), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [70050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 4,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5489), 48,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [70110] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5036), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5949), 1,
      anon_sym_LBRACK,
    ACTIONS(5946), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(4154), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4146), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6700), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6507), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70296] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7307), 1,
      anon_sym___attribute__,
    ACTIONS(7310), 1,
      anon_sym___attribute,
    ACTIONS(7553), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4955), 1,
      sym__function_attributes_start,
    STATE(5165), 1,
      sym_ref_qualifier,
    STATE(6122), 1,
      sym__function_attributes_end,
    STATE(6187), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7324), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(7040), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5358), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70410] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6435), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6437), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [70484] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7789), 1,
      anon_sym_LT,
    STATE(3399), 1,
      sym_template_argument_list,
    ACTIONS(6368), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6370), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [70550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7568), 1,
      anon_sym_LT,
    STATE(1856), 1,
      sym_template_argument_list,
    ACTIONS(6513), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6515), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70614] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7307), 1,
      anon_sym___attribute__,
    ACTIONS(7310), 1,
      anon_sym___attribute,
    ACTIONS(7327), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4957), 1,
      sym__function_attributes_start,
    STATE(5200), 1,
      sym_ref_qualifier,
    STATE(6038), 1,
      sym_trailing_return_type,
    STATE(6100), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7324), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(7040), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5361), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5186), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70788] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7792), 1,
      anon_sym_COLON,
    STATE(2509), 1,
      sym_attribute_specifier,
    STATE(2788), 1,
      sym__enum_base_clause,
    STATE(2880), 1,
      sym_enumerator_list,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6338), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6336), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [70860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5182), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70920] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7792), 1,
      anon_sym_COLON,
    STATE(2469), 1,
      sym_attribute_specifier,
    STATE(2775), 1,
      sym__enum_base_clause,
    STATE(2882), 1,
      sym_enumerator_list,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6344), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6342), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [70992] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6425), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6427), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [71064] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6933), 1,
      anon_sym_EQ,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7794), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7798), 1,
      anon_sym_PIPE,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7814), 1,
      anon_sym_or,
    ACTIONS(7816), 1,
      anon_sym_and,
    ACTIONS(7818), 1,
      anon_sym_bitor,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71170] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6435), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6437), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [71244] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6441), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6443), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [71318] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6967), 1,
      anon_sym_EQ,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7794), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7798), 1,
      anon_sym_PIPE,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7814), 1,
      anon_sym_or,
    ACTIONS(7816), 1,
      anon_sym_and,
    ACTIONS(7818), 1,
      anon_sym_bitor,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71424] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6445), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6447), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [71496] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6987), 1,
      anon_sym_EQ,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7794), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7798), 1,
      anon_sym_PIPE,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7814), 1,
      anon_sym_or,
    ACTIONS(7816), 1,
      anon_sym_and,
    ACTIONS(7818), 1,
      anon_sym_bitor,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71602] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6524), 1,
      anon_sym_EQ,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7794), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7798), 1,
      anon_sym_PIPE,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7814), 1,
      anon_sym_or,
    ACTIONS(7816), 1,
      anon_sym_and,
    ACTIONS(7818), 1,
      anon_sym_bitor,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    ACTIONS(7822), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6526), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71712] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [71788] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6449), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [71862] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7798), 1,
      anon_sym_PIPE,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7816), 1,
      anon_sym_and,
    ACTIONS(7818), 1,
      anon_sym_bitor,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71964] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7798), 1,
      anon_sym_PIPE,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7818), 1,
      anon_sym_bitor,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [72062] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6451), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [72156] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [72248] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [72336] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72422] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6348), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6350), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72566] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72646] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6467), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6469), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72720] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7005), 1,
      anon_sym_EQ,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7794), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7798), 1,
      anon_sym_PIPE,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7814), 1,
      anon_sym_or,
    ACTIONS(7816), 1,
      anon_sym_and,
    ACTIONS(7818), 1,
      anon_sym_bitor,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [72826] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7011), 1,
      anon_sym_EQ,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7794), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7798), 1,
      anon_sym_PIPE,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7814), 1,
      anon_sym_or,
    ACTIONS(7816), 1,
      anon_sym_and,
    ACTIONS(7818), 1,
      anon_sym_bitor,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    ACTIONS(7822), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7013), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [72936] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7015), 1,
      anon_sym_EQ,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7794), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7798), 1,
      anon_sym_PIPE,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7814), 1,
      anon_sym_or,
    ACTIONS(7816), 1,
      anon_sym_and,
    ACTIONS(7818), 1,
      anon_sym_bitor,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [73042] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7019), 1,
      anon_sym_EQ,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(7794), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7796), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7798), 1,
      anon_sym_PIPE,
    ACTIONS(7802), 1,
      anon_sym_AMP,
    ACTIONS(7808), 1,
      anon_sym_GT_EQ,
    ACTIONS(7812), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7814), 1,
      anon_sym_or,
    ACTIONS(7816), 1,
      anon_sym_and,
    ACTIONS(7818), 1,
      anon_sym_bitor,
    ACTIONS(7820), 1,
      anon_sym_bitand,
    ACTIONS(7822), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7560), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7800), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7810), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7562), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7804), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7806), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7021), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [73152] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(1935), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5038), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5977), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5979), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [73220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5450), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5452), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [73282] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6441), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6443), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [73356] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [73432] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6449), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [73506] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6439), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6491), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6493), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [73580] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7677), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7697), 1,
      anon_sym_and,
    ACTIONS(7699), 1,
      anon_sym_bitor,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 3,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [73680] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5005), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4998), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6479), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [73802] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7699), 1,
      anon_sym_bitor,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6449), 4,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [73898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3949), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [73958] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6467), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6469), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [74032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 4,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5482), 48,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [74092] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [74184] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [74274] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7101), 1,
      sym_auto,
    ACTIONS(7103), 1,
      anon_sym_decltype,
    STATE(3525), 1,
      sym_decltype_auto,
    ACTIONS(5589), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5591), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6479), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74400] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7269), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7271), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7573), 1,
      anon_sym_COMMA,
    ACTIONS(7577), 1,
      anon_sym_DASH,
    ACTIONS(7579), 1,
      anon_sym_PLUS,
    ACTIONS(7581), 1,
      anon_sym_STAR,
    ACTIONS(7583), 1,
      anon_sym_SLASH,
    ACTIONS(7585), 1,
      anon_sym_PERCENT,
    ACTIONS(7587), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7589), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7591), 1,
      anon_sym_PIPE,
    ACTIONS(7593), 1,
      anon_sym_CARET,
    ACTIONS(7595), 1,
      anon_sym_AMP,
    ACTIONS(7597), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7599), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7601), 1,
      anon_sym_GT,
    ACTIONS(7603), 1,
      anon_sym_GT_EQ,
    ACTIONS(7605), 1,
      anon_sym_LT_EQ,
    ACTIONS(7607), 1,
      anon_sym_LT,
    ACTIONS(7609), 1,
      anon_sym_LT_LT,
    ACTIONS(7611), 1,
      anon_sym_GT_GT,
    ACTIONS(7613), 1,
      anon_sym_EQ,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7617), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7619), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7621), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7623), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7625), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7627), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7629), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7631), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7633), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7635), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7639), 1,
      anon_sym_or,
    ACTIONS(7641), 1,
      anon_sym_and,
    ACTIONS(7643), 1,
      anon_sym_bitor,
    ACTIONS(7645), 1,
      anon_sym_xor,
    ACTIONS(7647), 1,
      anon_sym_bitand,
    ACTIONS(7649), 1,
      anon_sym_not_eq,
    ACTIONS(7824), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym__binary_fold_operator,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    STATE(8694), 1,
      sym__fold_operator,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [74556] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_GT2,
  [74642] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7677), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7695), 1,
      anon_sym_or,
    ACTIONS(7697), 1,
      anon_sym_and,
    ACTIONS(7699), 1,
      anon_sym_bitor,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(6967), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [74746] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [74830] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [74912] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 14,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [74990] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6451), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [75070] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7677), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7695), 1,
      anon_sym_or,
    ACTIONS(7697), 1,
      anon_sym_and,
    ACTIONS(7699), 1,
      anon_sym_bitor,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7005), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [75174] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(7675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7677), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7693), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7695), 1,
      anon_sym_or,
    ACTIONS(7697), 1,
      anon_sym_and,
    ACTIONS(7699), 1,
      anon_sym_bitor,
    ACTIONS(7701), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7015), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7661), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7671), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7673), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7687), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [75278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6279), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6662), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6578), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6580), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5142), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5760), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [75573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1934), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7826), 1,
      sym_literal_suffix,
    ACTIONS(4146), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4154), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [75693] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7828), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
    STATE(3363), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7556), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4152), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3472), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7830), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5888), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3472), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7830), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5900), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5898), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6412), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4146), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7832), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6477), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6479), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76067] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(7097), 1,
      anon_sym_LPAREN2,
    STATE(3829), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6263), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6265), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76132] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3374), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7834), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5938), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5936), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76195] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3375), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7836), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5932), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5930), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76258] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7327), 1,
      anon_sym_requires,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4977), 1,
      sym__function_attributes_start,
    STATE(5237), 1,
      sym_ref_qualifier,
    STATE(6038), 1,
      sym_trailing_return_type,
    STATE(6370), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7040), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7324), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4072), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5380), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76371] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 1,
      anon_sym___asm,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7844), 1,
      anon_sym_STAR,
    ACTIONS(7846), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7848), 1,
      anon_sym_AMP,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6077), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3372), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4123), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76468] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 1,
      anon_sym___asm,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7844), 1,
      anon_sym_STAR,
    ACTIONS(7846), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7848), 1,
      anon_sym_AMP,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6083), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4125), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4146), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3472), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7830), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5944), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5942), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3472), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7830), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5894), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6620), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76809] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3389), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7858), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5904), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5902), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3395), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7860), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5922), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5920), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76935] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3472), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7830), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5928), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5926), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6622), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6624), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5138), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5138), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5138), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6485), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77293] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3362), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7862), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5750), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5752), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [77356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6716), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(7097), 1,
      anon_sym_LPAREN2,
    STATE(3880), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6188), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6190), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6487), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6489), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77539] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3472), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7830), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5910), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5908), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [77602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6400), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6638), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6194), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6196), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6198), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6200), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6202), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3472), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7830), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5918), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5916), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [77960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6640), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6642), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5808), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78078] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(3047), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7009), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(4152), 38,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [78147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6348), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6350), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5796), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5442), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2685), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7501), 1,
      anon_sym_LT,
    STATE(1577), 1,
      sym_template_argument_list,
    ACTIONS(6513), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6515), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5679), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5687), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78507] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7327), 1,
      anon_sym_requires,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(5036), 1,
      sym__function_attributes_start,
    STATE(5255), 1,
      sym_ref_qualifier,
    STATE(6377), 1,
      sym__function_attributes_end,
    STATE(6536), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7040), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3982), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4184), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5386), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [78620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5812), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3949), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7038), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7036), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [78797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5694), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6702), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6704), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5679), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6526), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5480), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [79092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6507), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5639), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79210] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3128), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6010), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6012), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5912), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5914), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [79275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6682), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6400), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5665), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6572), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6550), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3951), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3953), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6700), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6668), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6670), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6530), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6686), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5667), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5669), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6708), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6297), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5154), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5168), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5788), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [80219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6672), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6674), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6614), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6616), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80337] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4974), 1,
      anon_sym_LBRACK,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(3695), 1,
      sym_template_argument_list,
    ACTIONS(4967), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4970), 4,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4963), 41,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [80406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6503), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6511), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6554), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6556), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6664), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6666), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5681), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5683), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [80701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6574), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6576), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5172), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5188), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5190), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6646), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5655), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5657), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [80996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6650), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6652), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6654), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5579), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [81173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6465), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5738), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6558), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6560), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6534), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5643), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6400), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7828), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
    ACTIONS(5838), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4172), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [81592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7864), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
    ACTIONS(4963), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4970), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [81657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6208), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6210), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5734), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81775] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7869), 1,
      anon_sym_requires,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4998), 1,
      sym__function_attributes_start,
    STATE(5253), 1,
      sym_ref_qualifier,
    STATE(6314), 1,
      sym__function_attributes_end,
    STATE(6469), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7040), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7069), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4072), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5375), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81888] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7872), 1,
      sym_identifier,
    STATE(3463), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5066), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5068), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5398), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5396), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5788), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6220), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82073] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7874), 1,
      sym_identifier,
    STATE(3463), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7877), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7880), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5405), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5403), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5484), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [82199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6564), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6634), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6608), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5649), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6568), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6610), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6612), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82553] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(7097), 1,
      anon_sym_LPAREN2,
    STATE(3810), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6172), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6174), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3472), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5070), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5072), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [82681] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 1,
      anon_sym___attribute,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 1,
      anon_sym_STAR,
    ACTIONS(7888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6052), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3477), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4139), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5491), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [82837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5146), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6402), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6404), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82955] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 1,
      anon_sym___attribute,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 1,
      anon_sym_STAR,
    ACTIONS(7888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6057), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4142), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83052] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7894), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7896), 1,
      anon_sym_or,
    ACTIONS(7898), 1,
      anon_sym_and,
    ACTIONS(6253), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6255), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5132), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5134), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6269), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6271), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6275), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6286), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6288), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5661), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6224), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83473] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4991), 1,
      sym__function_attributes_start,
    STATE(5235), 1,
      sym_ref_qualifier,
    STATE(5985), 1,
      sym_trailing_return_type,
    STATE(6358), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7040), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4072), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5984), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5382), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83586] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5859), 1,
      anon_sym___asm,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_STAR,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6003), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3492), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4151), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83683] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7057), 1,
      anon_sym_LBRACK,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5011), 1,
      sym__function_attributes_start,
    STATE(5282), 1,
      sym_ref_qualifier,
    STATE(6330), 1,
      sym__function_attributes_end,
    STATE(6449), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7040), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4072), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5816), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5392), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5790), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5792), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83855] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2476), 1,
      sym_attribute_specifier,
    STATE(3618), 1,
      sym_enumerator_list,
    ACTIONS(5983), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5985), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [83924] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2531), 1,
      sym_attribute_specifier,
    STATE(3621), 1,
      sym_enumerator_list,
    ACTIONS(6024), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6026), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [83993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5699), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5701), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [84052] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5867), 1,
      anon_sym___asm,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_STAR,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6007), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4153), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(7097), 1,
      anon_sym_LPAREN2,
    STATE(3862), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6204), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6206), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7908), 1,
      anon_sym_LT,
    STATE(3335), 1,
      sym_template_argument_list,
    ACTIONS(6513), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6515), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6479), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6538), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5742), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [84454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6678), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5780), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [84572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3891), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5186), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5997), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6582), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6584), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5452), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [84867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6586), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6588), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6162), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4154), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4146), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5452), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [85046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1938), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6696), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6522), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5762), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5764), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [85282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5768), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [85341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5772), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [85400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5776), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [85459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6550), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6712), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85577] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 1,
      sym_identifier,
    STATE(3460), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5066), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5068), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5392), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5390), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5182), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6546), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6592), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6594), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6596), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5194), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5164), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7894), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7898), 1,
      anon_sym_and,
    ACTIONS(6178), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6180), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5798), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5800), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [86120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5150), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6656), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6658), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4965), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5756), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [86651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7908), 1,
      anon_sym_LT,
    STATE(1895), 1,
      sym_template_argument_list,
    ACTIONS(6513), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6515), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5679), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [86773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6530), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6614), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6616), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4953), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6696), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6686), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4961), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [87121] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(6987), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7921), 1,
      anon_sym_PIPE,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7935), 1,
      anon_sym_bitor,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7919), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [87223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6550), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6712), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4988), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4990), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [87513] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [87587] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [87659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5484), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [87717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5138), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87775] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6449), 1,
      anon_sym_EQ,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7921), 1,
      anon_sym_PIPE,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7935), 1,
      anon_sym_bitor,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7919), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_DASH_GT_STAR,
  [87875] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6449), 1,
      anon_sym_EQ,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7921), 1,
      anon_sym_PIPE,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7935), 1,
      anon_sym_bitor,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT_STAR,
  [87973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6400), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88031] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [88125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6503), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5138), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88241] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7941), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7945), 1,
      anon_sym_or,
    ACTIONS(7947), 1,
      anon_sym_and,
    ACTIONS(6253), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6255), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6400), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6554), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6556), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88423] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_DASH_GT_STAR,
  [88513] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(6451), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [88599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5138), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6620), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7099), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_new_declarator,
    ACTIONS(6352), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6354), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6640), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6642), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88835] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_EQ,
    ACTIONS(6228), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4154), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1938), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88955] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(6451), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [89039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6400), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89097] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      anon_sym_EQ,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7921), 1,
      anon_sym_PIPE,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7935), 1,
      anon_sym_bitor,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7919), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6526), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [89203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6664), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6666), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89261] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5036), 1,
      anon_sym_SEMI,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(7033), 1,
      anon_sym_LBRACK,
    STATE(2641), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3962), 1,
      sym_template_argument_list,
    ACTIONS(4169), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4152), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(4174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [89335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6702), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6704), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89393] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7949), 1,
      anon_sym_COLON,
    ACTIONS(7951), 1,
      anon_sym_LBRACE,
    STATE(3905), 1,
      sym__enum_base_clause,
    STATE(3952), 1,
      sym_enumerator_list,
    STATE(4067), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6336), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6338), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [89463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5491), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [89521] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6467), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6469), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [89593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6538), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6572), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6511), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89767] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7019), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7921), 1,
      anon_sym_PIPE,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7935), 1,
      anon_sym_bitor,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7919), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7021), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [89873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6534), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89931] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(6451), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [90011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5442), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2685), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6592), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6479), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5005), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4998), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5146), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6700), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90361] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7011), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7571), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7921), 1,
      anon_sym_PIPE,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7935), 1,
      anon_sym_bitor,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7919), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7013), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [90467] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7949), 1,
      anon_sym_COLON,
    ACTIONS(7951), 1,
      anon_sym_LBRACE,
    STATE(3909), 1,
      sym__enum_base_clause,
    STATE(3956), 1,
      sym_enumerator_list,
    STATE(4063), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6342), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6344), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6678), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6526), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90653] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 9,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [90729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6646), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6650), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6550), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6652), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6654), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5619), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5619), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5062), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(5064), 12,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4146), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4154), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [91143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3891), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1934), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6558), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6560), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91317] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7005), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7921), 1,
      anon_sym_PIPE,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7935), 1,
      anon_sym_bitor,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7919), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [91419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    STATE(3719), 1,
      sym_new_declarator,
    ACTIONS(6352), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6354), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2508), 1,
      sym_attribute_specifier,
    ACTIONS(6151), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6153), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [91545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6522), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91603] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2512), 1,
      sym_attribute_specifier,
    ACTIONS(6155), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6157), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [91667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6574), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6576), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6594), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6596), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2475), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6123), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [91847] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2490), 1,
      sym_attribute_specifier,
    ACTIONS(6125), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6127), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [91911] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2491), 1,
      sym_attribute_specifier,
    ACTIONS(6129), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6131), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [91975] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2530), 1,
      sym_attribute_specifier,
    ACTIONS(6090), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6092), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [92039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5182), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2532), 1,
      sym_attribute_specifier,
    ACTIONS(6096), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6098), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [92161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2454), 1,
      sym_attribute_specifier,
    ACTIONS(6168), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6170), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [92225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2517), 1,
      sym_attribute_specifier,
    ACTIONS(6104), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6106), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [92289] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2487), 1,
      sym_attribute_specifier,
    ACTIONS(6058), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6060), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [92353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2411), 1,
      sym_attribute_specifier,
    ACTIONS(6062), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6064), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [92417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5605), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5607), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5186), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6634), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92591] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym_LT,
    STATE(1916), 1,
      sym_template_argument_list,
    ACTIONS(6513), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6515), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6638), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6656), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6658), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92769] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7957), 1,
      anon_sym_RPAREN,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(7185), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [92875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6662), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6568), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92991] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7015), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7921), 1,
      anon_sym_PIPE,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7935), 1,
      anon_sym_bitor,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7919), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [93093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5164), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6586), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6588), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6412), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6668), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6670), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6672), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6674), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7963), 1,
      anon_sym_COMMA,
    ACTIONS(7965), 1,
      anon_sym_RBRACK,
    ACTIONS(4154), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93445] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(6451), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [93523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6485), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7943), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7947), 1,
      anon_sym_and,
    ACTIONS(6178), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6180), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6682), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 1,
      anon_sym_COMMA,
    ACTIONS(6232), 1,
      anon_sym_RBRACK,
    ACTIONS(4154), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4984), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4986), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93879] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6425), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6427), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [93949] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(6933), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7921), 1,
      anon_sym_PIPE,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7935), 1,
      anon_sym_bitor,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7919), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [94051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5154), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5168), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6578), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6580), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4957), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4984), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4986), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5132), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5134), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4980), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4982), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4980), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4982), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5997), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5142), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4992), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4994), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94863] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6435), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6437), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [94935] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6441), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6443), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [95007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5005), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4998), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4992), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4994), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6582), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6584), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95241] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(6967), 1,
      anon_sym_EQ,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7637), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7921), 1,
      anon_sym_PIPE,
    ACTIONS(7923), 1,
      anon_sym_CARET,
    ACTIONS(7925), 1,
      anon_sym_AMP,
    ACTIONS(7931), 1,
      anon_sym_GT_EQ,
    ACTIONS(7935), 1,
      anon_sym_bitor,
    ACTIONS(7937), 1,
      anon_sym_xor,
    ACTIONS(7939), 1,
      anon_sym_bitand,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7651), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7913), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7919), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7933), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7915), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7927), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7929), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [95343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5194), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6708), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95459] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    ACTIONS(7223), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 1,
      anon_sym_DOT_STAR,
    STATE(3515), 1,
      sym_argument_list,
    STATE(3516), 1,
      sym_subscript_argument_list,
    ACTIONS(7267), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6445), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6447), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [95529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4953), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4961), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5150), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95703] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6113), 1,
      anon_sym_EQ,
    ACTIONS(6244), 1,
      anon_sym_COMMA,
    ACTIONS(6246), 1,
      anon_sym_RBRACK,
    ACTIONS(6082), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4146), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4154), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [95769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4988), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4990), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5480), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [95885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6113), 1,
      anon_sym_EQ,
    ACTIONS(6082), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4154), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4146), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6622), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6624), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4965), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5625), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5627), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5579), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [96181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6716), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5172), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6608), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6610), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6612), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5188), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5190), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6564), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6546), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4957), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96645] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      anon_sym_EQ,
    ACTIONS(4290), 1,
      anon_sym_SEMI,
    ACTIONS(5036), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5946), 1,
      anon_sym_LPAREN2,
    ACTIONS(5949), 1,
      anon_sym_LBRACK,
    ACTIONS(4182), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4146), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4154), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [96715] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(2468), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6119), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [96779] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      anon_sym_EQ,
    ACTIONS(4290), 1,
      anon_sym_SEMI,
    ACTIONS(4182), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4146), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4154), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [96842] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(7989), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [96945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 1,
      anon_sym_LBRACK,
    ACTIONS(5000), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5003), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(4996), 41,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [97006] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8062), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97109] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7972), 1,
      anon_sym_enum,
    ACTIONS(7974), 1,
      anon_sym_class,
    ACTIONS(7976), 1,
      anon_sym_struct,
    ACTIONS(7978), 1,
      anon_sym_union,
    ACTIONS(7980), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3983), 1,
      sym_type_specifier,
    STATE(5862), 1,
      sym_type_descriptor,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    STATE(3876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6487), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6489), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97269] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(8736), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97372] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4215), 1,
      sym_type_specifier,
    STATE(5988), 1,
      sym_type_descriptor,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3894), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97475] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8082), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97578] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8115), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97681] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(7958), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97784] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5859), 1,
      anon_sym___attribute,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7982), 1,
      anon_sym_STAR,
    ACTIONS(7984), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7986), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6176), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3707), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4223), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97879] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5744), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5627), 1,
      anon_sym_SEMI,
    ACTIONS(5452), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5450), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [98043] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5867), 1,
      anon_sym___attribute,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7982), 1,
      anon_sym_STAR,
    ACTIONS(7984), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7986), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6262), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4225), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98138] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8006), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
    ACTIONS(4963), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4970), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [98201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5491), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [98258] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4235), 1,
      sym_type_specifier,
    STATE(5988), 1,
      sym_type_descriptor,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98361] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5694), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5442), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2685), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98521] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5696), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7705), 1,
      sym_literal_suffix,
    ACTIONS(4154), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4146), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98683] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8435), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98786] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5791), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98889] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5723), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98992] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8320), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6487), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6489), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99152] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5728), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99255] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8473), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99358] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5732), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99461] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(7640), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99564] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5735), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99667] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(8728), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99770] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5736), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99873] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3992), 1,
      sym_alignas_qualifier,
    ACTIONS(8012), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5049), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(8009), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(5047), 21,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [99938] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5745), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100041] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(8806), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100144] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5746), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100247] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(8780), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100350] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5752), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100453] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5754), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100556] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5756), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100659] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5757), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100762] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8040), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100865] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3362), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7862), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5452), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [100926] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(7929), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101029] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8358), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101132] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5644), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101235] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4845), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8386), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3835), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6614), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6616), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8017), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8015), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [101452] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(7948), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101555] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(5862), 1,
      sym_type_descriptor,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101658] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8019), 1,
      sym_identifier,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8025), 1,
      sym_primitive_type,
    ACTIONS(8027), 1,
      anon_sym_enum,
    ACTIONS(8029), 1,
      anon_sym_class,
    ACTIONS(8031), 1,
      anon_sym_struct,
    ACTIONS(8033), 1,
      anon_sym_union,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    ACTIONS(8039), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4069), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4234), 1,
      sym_type_specifier,
    STATE(4947), 1,
      sym_qualified_type_identifier,
    STATE(4948), 1,
      sym_decltype_auto,
    STATE(5988), 1,
      sym_type_descriptor,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3842), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4894), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8023), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4919), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101761] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5650), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8043), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8041), 38,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [101921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5484), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [101978] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6435), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6437), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [102049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5619), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102106] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3134), 1,
      anon_sym_enum,
    ACTIONS(3136), 1,
      anon_sym_class,
    ACTIONS(3138), 1,
      anon_sym_struct,
    ACTIONS(3140), 1,
      anon_sym_union,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(3168), 1,
      anon_sym_typename,
    ACTIONS(8047), 1,
      sym_identifier,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8051), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4276), 1,
      sym_type_specifier,
    STATE(5988), 1,
      sym_type_descriptor,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    STATE(3879), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102209] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8053), 1,
      sym_identifier,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8059), 1,
      sym_primitive_type,
    ACTIONS(8061), 1,
      anon_sym_enum,
    ACTIONS(8063), 1,
      anon_sym_class,
    ACTIONS(8065), 1,
      anon_sym_struct,
    ACTIONS(8067), 1,
      anon_sym_union,
    ACTIONS(8069), 1,
      sym_auto,
    ACTIONS(8071), 1,
      anon_sym_decltype,
    ACTIONS(8073), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3999), 1,
      sym_type_specifier,
    STATE(4612), 1,
      sym_decltype_auto,
    STATE(5862), 1,
      sym_type_descriptor,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    STATE(3848), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4706), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102312] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8455), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102415] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6441), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6443), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [102486] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7972), 1,
      anon_sym_enum,
    ACTIONS(7974), 1,
      anon_sym_class,
    ACTIONS(7976), 1,
      anon_sym_struct,
    ACTIONS(7978), 1,
      anon_sym_union,
    ACTIONS(7980), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4085), 1,
      sym_type_specifier,
    STATE(5862), 1,
      sym_type_descriptor,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    STATE(3890), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102589] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3899), 1,
      sym_identifier,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(3913), 1,
      anon_sym_enum,
    ACTIONS(3915), 1,
      anon_sym_class,
    ACTIONS(3917), 1,
      anon_sym_struct,
    ACTIONS(3919), 1,
      anon_sym_union,
    ACTIONS(3921), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4182), 1,
      sym_type_specifier,
    STATE(5862), 1,
      sym_type_descriptor,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    STATE(3911), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6568), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102749] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3517), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5066), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5068), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5912), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5914), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102812] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [102883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8077), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8075), 38,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [102940] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8470), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103043] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8059), 1,
      sym_primitive_type,
    ACTIONS(8069), 1,
      sym_auto,
    ACTIONS(8071), 1,
      anon_sym_decltype,
    ACTIONS(8079), 1,
      sym_identifier,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8083), 1,
      anon_sym_enum,
    ACTIONS(8085), 1,
      anon_sym_class,
    ACTIONS(8087), 1,
      anon_sym_struct,
    ACTIONS(8089), 1,
      anon_sym_union,
    ACTIONS(8091), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4373), 1,
      sym_type_specifier,
    STATE(4612), 1,
      sym_decltype_auto,
    STATE(5862), 1,
      sym_type_descriptor,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    STATE(3881), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4706), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7036), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(7038), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [103203] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(8669), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6445), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6447), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [103375] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(8766), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103478] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(7925), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103581] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8053), 1,
      sym_identifier,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8059), 1,
      sym_primitive_type,
    ACTIONS(8061), 1,
      anon_sym_enum,
    ACTIONS(8063), 1,
      anon_sym_class,
    ACTIONS(8065), 1,
      anon_sym_struct,
    ACTIONS(8067), 1,
      anon_sym_union,
    ACTIONS(8069), 1,
      sym_auto,
    ACTIONS(8071), 1,
      anon_sym_decltype,
    ACTIONS(8073), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3984), 1,
      sym_type_specifier,
    STATE(4612), 1,
      sym_decltype_auto,
    STATE(5862), 1,
      sym_type_descriptor,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    STATE(3850), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4706), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103684] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7709), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
    ACTIONS(5838), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4172), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [103747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6640), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6642), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5480), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [103861] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5002), 1,
      sym_type_specifier,
    STATE(5668), 1,
      sym__type_definition_type,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103964] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(7993), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104067] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(8716), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104170] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4799), 1,
      sym_type_specifier,
    STATE(5862), 1,
      sym_type_descriptor,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3869), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104273] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7972), 1,
      anon_sym_enum,
    ACTIONS(7974), 1,
      anon_sym_class,
    ACTIONS(7976), 1,
      anon_sym_struct,
    ACTIONS(7978), 1,
      anon_sym_union,
    ACTIONS(7980), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4299), 1,
      sym_type_specifier,
    STATE(5862), 1,
      sym_type_descriptor,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    STATE(3799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104376] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4428), 1,
      sym_type_specifier,
    STATE(5988), 1,
      sym_type_descriptor,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3856), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104479] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4845), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8013), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3835), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104582] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8019), 1,
      sym_identifier,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8025), 1,
      sym_primitive_type,
    ACTIONS(8027), 1,
      anon_sym_enum,
    ACTIONS(8029), 1,
      anon_sym_class,
    ACTIONS(8031), 1,
      anon_sym_struct,
    ACTIONS(8033), 1,
      anon_sym_union,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    ACTIONS(8039), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4069), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4147), 1,
      sym_type_specifier,
    STATE(4947), 1,
      sym_qualified_type_identifier,
    STATE(4948), 1,
      sym_decltype_auto,
    STATE(5988), 1,
      sym_type_descriptor,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3882), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4894), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8023), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4919), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104685] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8000), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104788] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6425), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6427), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [104857] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3134), 1,
      anon_sym_enum,
    ACTIONS(3136), 1,
      anon_sym_class,
    ACTIONS(3138), 1,
      anon_sym_struct,
    ACTIONS(3140), 1,
      anon_sym_union,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(3168), 1,
      anon_sym_typename,
    ACTIONS(8047), 1,
      sym_identifier,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8051), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4253), 1,
      sym_type_specifier,
    STATE(5988), 1,
      sym_type_descriptor,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    STATE(3891), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104960] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8532), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105063] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8132), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105166] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4845), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8536), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3835), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105269] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4845), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8035), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3835), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105372] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8053), 1,
      sym_identifier,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8059), 1,
      sym_primitive_type,
    ACTIONS(8061), 1,
      anon_sym_enum,
    ACTIONS(8063), 1,
      anon_sym_class,
    ACTIONS(8065), 1,
      anon_sym_struct,
    ACTIONS(8067), 1,
      anon_sym_union,
    ACTIONS(8069), 1,
      sym_auto,
    ACTIONS(8071), 1,
      anon_sym_decltype,
    ACTIONS(8073), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4164), 1,
      sym_type_specifier,
    STATE(4612), 1,
      sym_decltype_auto,
    STATE(5862), 1,
      sym_type_descriptor,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    STATE(3819), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4706), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105475] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8554), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105578] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4845), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8558), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3835), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5579), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [105738] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8574), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105841] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4845), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8578), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3835), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105944] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8252), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106047] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4455), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8593), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106150] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4845), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8597), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    STATE(3835), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106253] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6467), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6469), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [106324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5627), 1,
      anon_sym_SEMI,
    ACTIONS(5452), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5450), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [106383] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7972), 1,
      anon_sym_enum,
    ACTIONS(7974), 1,
      anon_sym_class,
    ACTIONS(7976), 1,
      anon_sym_struct,
    ACTIONS(7978), 1,
      anon_sym_union,
    ACTIONS(7980), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4301), 1,
      sym_type_specifier,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6672), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6674), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6678), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6662), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6682), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5188), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5190), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6558), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6560), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6686), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106875] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    STATE(2641), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4226), 1,
      sym_template_argument_list,
    ACTIONS(4169), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4152), 3,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [106945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6708), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6568), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6608), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6610), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6612), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6582), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6584), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6572), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6614), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6616), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6586), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6588), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5442), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2685), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107449] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4974), 1,
      anon_sym_LBRACK,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(3962), 1,
      sym_template_argument_list,
    ACTIONS(4967), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4970), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_EQ,
    ACTIONS(4963), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [107515] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(2355), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5060), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5977), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5979), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [107579] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8053), 1,
      sym_identifier,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8059), 1,
      sym_primitive_type,
    ACTIONS(8061), 1,
      anon_sym_enum,
    ACTIONS(8063), 1,
      anon_sym_class,
    ACTIONS(8065), 1,
      anon_sym_struct,
    ACTIONS(8067), 1,
      anon_sym_union,
    ACTIONS(8069), 1,
      sym_auto,
    ACTIONS(8071), 1,
      anon_sym_decltype,
    ACTIONS(8073), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4130), 1,
      sym_type_specifier,
    STATE(4612), 1,
      sym_decltype_auto,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4706), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [107679] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(8098), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(8095), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7779), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7777), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [107743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6646), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107799] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    ACTIONS(8103), 1,
      sym_auto,
    ACTIONS(8105), 1,
      anon_sym_decltype,
    STATE(4006), 1,
      sym_new_declarator,
    STATE(4096), 1,
      sym_decltype_auto,
    STATE(3840), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5823), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5825), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107871] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    ACTIONS(8103), 1,
      sym_auto,
    ACTIONS(8105), 1,
      anon_sym_decltype,
    STATE(3993), 1,
      sym_new_declarator,
    STATE(4096), 1,
      sym_decltype_auto,
    STATE(3865), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5873), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5875), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107943] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    ACTIONS(8103), 1,
      sym_auto,
    ACTIONS(8105), 1,
      anon_sym_decltype,
    STATE(4004), 1,
      sym_new_declarator,
    STATE(4096), 1,
      sym_decltype_auto,
    STATE(3844), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5869), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5871), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108015] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8107), 1,
      anon_sym_STAR,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8111), 1,
      anon_sym_AMP,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6344), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3872), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4271), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [108107] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    ACTIONS(8103), 1,
      sym_auto,
    ACTIONS(8105), 1,
      anon_sym_decltype,
    STATE(3976), 1,
      sym_new_declarator,
    STATE(4096), 1,
      sym_decltype_auto,
    STATE(3898), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5842), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5844), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6582), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6584), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6586), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6588), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6592), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6638), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6594), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6596), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6530), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6650), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6652), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6654), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108627] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4860), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [108727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5194), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8113), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8115), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6253), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6255), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8115), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6178), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6180), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5150), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6530), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6620), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109069] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8019), 1,
      sym_identifier,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8025), 1,
      sym_primitive_type,
    ACTIONS(8027), 1,
      anon_sym_enum,
    ACTIONS(8029), 1,
      anon_sym_class,
    ACTIONS(8031), 1,
      anon_sym_struct,
    ACTIONS(8033), 1,
      anon_sym_union,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    ACTIONS(8039), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4069), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4245), 1,
      sym_type_specifier,
    STATE(4947), 1,
      sym_qualified_type_identifier,
    STATE(4948), 1,
      sym_decltype_auto,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4894), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8023), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4919), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6592), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6594), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6596), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3891), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1938), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6622), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6624), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109449] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8053), 1,
      sym_identifier,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8059), 1,
      sym_primitive_type,
    ACTIONS(8061), 1,
      anon_sym_enum,
    ACTIONS(8063), 1,
      anon_sym_class,
    ACTIONS(8065), 1,
      anon_sym_struct,
    ACTIONS(8067), 1,
      anon_sym_union,
    ACTIONS(8069), 1,
      sym_auto,
    ACTIONS(8071), 1,
      anon_sym_decltype,
    ACTIONS(8073), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3977), 1,
      sym_type_specifier,
    STATE(4612), 1,
      sym_decltype_auto,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4706), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1934), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109605] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8053), 1,
      sym_identifier,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8059), 1,
      sym_primitive_type,
    ACTIONS(8061), 1,
      anon_sym_enum,
    ACTIONS(8063), 1,
      anon_sym_class,
    ACTIONS(8065), 1,
      anon_sym_struct,
    ACTIONS(8067), 1,
      anon_sym_union,
    ACTIONS(8069), 1,
      sym_auto,
    ACTIONS(8071), 1,
      anon_sym_decltype,
    ACTIONS(8073), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3988), 1,
      sym_type_specifier,
    STATE(4612), 1,
      sym_decltype_auto,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4706), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6716), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5164), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6634), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6664), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6666), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6696), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109985] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4560), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [110085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5480), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [110141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5579), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [110197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6668), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6670), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6526), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6672), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6674), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6634), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5138), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6558), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6560), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6564), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6678), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6682), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5154), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110757] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4837), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [110857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6578), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6580), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5484), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [110969] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8107), 1,
      anon_sym_STAR,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8111), 1,
      anon_sym_AMP,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6304), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4300), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5168), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5491), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [111173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5186), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111229] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7972), 1,
      anon_sym_enum,
    ACTIONS(7974), 1,
      anon_sym_class,
    ACTIONS(7976), 1,
      anon_sym_struct,
    ACTIONS(7978), 1,
      anon_sym_union,
    ACTIONS(7980), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3991), 1,
      sym_type_specifier,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111329] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6014), 1,
      anon_sym___attribute__,
    ACTIONS(6016), 1,
      anon_sym___attribute,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(8117), 1,
      anon_sym_COLON,
    STATE(1841), 1,
      sym_attribute_specifier,
    STATE(2281), 1,
      sym__enum_base_clause,
    STATE(2329), 1,
      sym_enumerator_list,
    ACTIONS(6336), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6338), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [111399] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6014), 1,
      anon_sym___attribute__,
    ACTIONS(6016), 1,
      anon_sym___attribute,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(8117), 1,
      anon_sym_COLON,
    STATE(1866), 1,
      sym_attribute_specifier,
    STATE(2216), 1,
      sym__enum_base_clause,
    STATE(2311), 1,
      sym_enumerator_list,
    ACTIONS(6342), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6344), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [111469] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3134), 1,
      anon_sym_enum,
    ACTIONS(3136), 1,
      anon_sym_class,
    ACTIONS(3138), 1,
      anon_sym_struct,
    ACTIONS(3140), 1,
      anon_sym_union,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(3168), 1,
      anon_sym_typename,
    ACTIONS(8047), 1,
      sym_identifier,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8051), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4259), 1,
      sym_type_specifier,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6638), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111625] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8059), 1,
      sym_primitive_type,
    ACTIONS(8069), 1,
      sym_auto,
    ACTIONS(8071), 1,
      anon_sym_decltype,
    ACTIONS(8079), 1,
      sym_identifier,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8083), 1,
      anon_sym_enum,
    ACTIONS(8085), 1,
      anon_sym_class,
    ACTIONS(8087), 1,
      anon_sym_struct,
    ACTIONS(8089), 1,
      anon_sym_union,
    ACTIONS(8091), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4374), 1,
      sym_type_specifier,
    STATE(4612), 1,
      sym_decltype_auto,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4706), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111725] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8019), 1,
      sym_identifier,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8025), 1,
      sym_primitive_type,
    ACTIONS(8027), 1,
      anon_sym_enum,
    ACTIONS(8029), 1,
      anon_sym_class,
    ACTIONS(8031), 1,
      anon_sym_struct,
    ACTIONS(8033), 1,
      anon_sym_union,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    ACTIONS(8039), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4069), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4145), 1,
      sym_type_specifier,
    STATE(4947), 1,
      sym_qualified_type_identifier,
    STATE(4948), 1,
      sym_decltype_auto,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4894), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8023), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4919), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111825] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5859), 1,
      anon_sym___attribute,
    ACTIONS(8119), 1,
      anon_sym_STAR,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6290), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3884), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4262), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111919] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5867), 1,
      anon_sym___attribute,
    ACTIONS(8119), 1,
      anon_sym_STAR,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6292), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4264), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6640), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6642), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112069] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4255), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6620), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6564), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4146), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112337] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7972), 1,
      anon_sym_enum,
    ACTIONS(7974), 1,
      anon_sym_class,
    ACTIONS(7976), 1,
      anon_sym_struct,
    ACTIONS(7978), 1,
      anon_sym_union,
    ACTIONS(7980), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4088), 1,
      sym_type_specifier,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112437] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3134), 1,
      anon_sym_enum,
    ACTIONS(3136), 1,
      anon_sym_class,
    ACTIONS(3138), 1,
      anon_sym_struct,
    ACTIONS(3140), 1,
      anon_sym_union,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(3168), 1,
      anon_sym_typename,
    ACTIONS(8047), 1,
      sym_identifier,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8051), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4246), 1,
      sym_type_specifier,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6522), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6622), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6624), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112649] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4213), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5138), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6608), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6646), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6610), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6612), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6650), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6526), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6652), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6654), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6716), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5132), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5134), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113253] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4414), 1,
      sym_type_specifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [113353] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7951), 1,
      anon_sym_LBRACE,
    STATE(3959), 1,
      sym_enumerator_list,
    STATE(4071), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5983), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5985), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6578), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6580), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5138), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4146), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113585] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7951), 1,
      anon_sym_LBRACE,
    STATE(3974), 1,
      sym_enumerator_list,
    STATE(4100), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6024), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6026), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113649] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3134), 1,
      anon_sym_enum,
    ACTIONS(3136), 1,
      anon_sym_class,
    ACTIONS(3138), 1,
      anon_sym_struct,
    ACTIONS(3140), 1,
      anon_sym_union,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(3168), 1,
      anon_sym_typename,
    ACTIONS(8047), 1,
      sym_identifier,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8051), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4768), 1,
      sym_type_specifier,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [113749] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3899), 1,
      sym_identifier,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(3913), 1,
      anon_sym_enum,
    ACTIONS(3915), 1,
      anon_sym_class,
    ACTIONS(3917), 1,
      anon_sym_struct,
    ACTIONS(3919), 1,
      anon_sym_union,
    ACTIONS(3921), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4176), 1,
      sym_type_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [113849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6686), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6656), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6658), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6662), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5142), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5146), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5172), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6664), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6666), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3891), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6522), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5182), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6668), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6670), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6656), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6658), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114521] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5018), 1,
      sym_type_specifier,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114621] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(2513), 1,
      sym_attribute_specifier,
    STATE(2894), 1,
      sym_field_declaration_list,
    STATE(7003), 1,
      sym_virtual_specifier,
    STATE(7790), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5493), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [114692] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6509), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114785] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7105), 1,
      anon_sym_STAR,
    ACTIONS(7107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7109), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6294), 1,
      sym__declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114878] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6447), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5579), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [115026] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7105), 1,
      anon_sym_STAR,
    ACTIONS(7107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7109), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6301), 1,
      sym__declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115119] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      sym_identifier,
    ACTIONS(8145), 1,
      sym_primitive_type,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4073), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8142), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3937), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8140), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5086), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
    ACTIONS(5088), 13,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8137), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115190] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6423), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5484), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [115338] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(4148), 1,
      sym_new_declarator,
    STATE(3865), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5873), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5875), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115409] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6447), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115502] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7165), 1,
      anon_sym_STAR,
    ACTIONS(7167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6611), 1,
      sym__declarator,
    STATE(8161), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115595] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8153), 1,
      sym_identifier,
    ACTIONS(8163), 1,
      sym_primitive_type,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4196), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8160), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8158), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5100), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
    ACTIONS(5102), 13,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8155), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115666] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7165), 1,
      anon_sym_STAR,
    ACTIONS(7167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6614), 1,
      sym__declarator,
    STATE(8161), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115759] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8165), 1,
      anon_sym_COLON,
    STATE(2509), 1,
      sym_attribute_specifier,
    STATE(3489), 1,
      sym__enum_base_clause,
    STATE(3613), 1,
      sym_enumerator_list,
    ACTIONS(6336), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6338), 36,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [115828] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6423), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115921] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7291), 1,
      anon_sym_STAR,
    ACTIONS(7293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_COLON_COLON,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5838), 1,
      sym__scope_resolution,
    STATE(6155), 1,
      sym__declarator,
    STATE(8021), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4064), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6151), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6153), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4094), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6155), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6157), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116132] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7165), 1,
      anon_sym_STAR,
    ACTIONS(7167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6609), 1,
      sym__declarator,
    STATE(8161), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116225] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7171), 1,
      anon_sym_STAR,
    ACTIONS(7173), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_COLON_COLON,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5850), 1,
      sym__scope_resolution,
    STATE(6652), 1,
      sym__declarator,
    STATE(8214), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116318] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7171), 1,
      anon_sym_STAR,
    ACTIONS(7173), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_COLON_COLON,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5850), 1,
      sym__scope_resolution,
    STATE(6662), 1,
      sym__declarator,
    STATE(8214), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116411] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8165), 1,
      anon_sym_COLON,
    STATE(2469), 1,
      sym_attribute_specifier,
    STATE(3490), 1,
      sym__enum_base_clause,
    STATE(3616), 1,
      sym_enumerator_list,
    ACTIONS(6342), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6344), 36,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [116480] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7105), 1,
      anon_sym_STAR,
    ACTIONS(7107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7109), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6349), 1,
      sym__declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116573] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(4138), 1,
      sym_new_declarator,
    STATE(3840), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5823), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5825), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116644] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(4135), 1,
      sym_new_declarator,
    STATE(3844), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5869), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5871), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4054), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6117), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6119), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4070), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6121), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6123), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5491), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [116888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4075), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6125), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6127), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4077), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6129), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6131), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4098), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6090), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6092), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117065] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6391), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4399), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117156] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7291), 1,
      anon_sym_STAR,
    ACTIONS(7293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_COLON_COLON,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5838), 1,
      sym__scope_resolution,
    STATE(6141), 1,
      sym__declarator,
    STATE(8021), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117249] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4061), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6096), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6098), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4062), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6168), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6170), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4080), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6104), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6106), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117426] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_SEMI,
    ACTIONS(5007), 1,
      anon_sym_LBRACK,
    ACTIONS(5000), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5003), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
    ACTIONS(4996), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [117487] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6509), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117580] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6142), 1,
      sym__declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5480), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [117728] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(6032), 1,
      anon_sym_STAR,
    ACTIONS(8173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    STATE(3223), 1,
      sym_parameter_list,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6208), 1,
      sym__declarator,
    STATE(6526), 1,
      sym__abstract_declarator,
    STATE(6729), 1,
      sym_abstract_reference_declarator,
    STATE(7367), 1,
      sym_variadic_declarator,
    STATE(7368), 1,
      sym_variadic_reference_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8175), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6720), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [117837] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6385), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3957), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4404), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117928] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(4161), 1,
      sym_new_declarator,
    STATE(3898), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5842), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5844), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117999] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7291), 1,
      anon_sym_STAR,
    ACTIONS(7293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_COLON_COLON,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5838), 1,
      sym__scope_resolution,
    STATE(6098), 1,
      sym__declarator,
    STATE(8021), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118092] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6168), 1,
      sym__declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4078), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6062), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6064), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118244] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(5971), 1,
      anon_sym_STAR,
    ACTIONS(8173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    ACTIONS(8183), 1,
      anon_sym_EQ,
    STATE(3216), 1,
      sym_parameter_list,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6273), 1,
      sym__declarator,
    STATE(6569), 1,
      sym__abstract_declarator,
    STATE(6772), 1,
      sym_abstract_reference_declarator,
    STATE(7367), 1,
      sym_variadic_declarator,
    STATE(7368), 1,
      sym_variadic_reference_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8175), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6720), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [118353] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6167), 1,
      sym__declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118446] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4092), 1,
      sym_attribute_specifier,
    ACTIONS(6016), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6058), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6060), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118505] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7171), 1,
      anon_sym_STAR,
    ACTIONS(7173), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_COLON_COLON,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(5850), 1,
      sym__scope_resolution,
    STATE(6670), 1,
      sym__declarator,
    STATE(8214), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118598] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    STATE(3830), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6188), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6190), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118658] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 1,
      anon_sym_STAR,
    ACTIONS(7888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(8187), 1,
      anon_sym___attribute,
    ACTIONS(8189), 1,
      sym_auto,
    ACTIONS(8191), 1,
      anon_sym_decltype,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4633), 1,
      sym_decltype_auto,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6055), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4140), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5082), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5080), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [118800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5730), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118854] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8193), 1,
      anon_sym_LT,
    STATE(2355), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2547), 1,
      sym_template_argument_list,
    ACTIONS(5060), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4152), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [118918] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8195), 1,
      anon_sym_STAR,
    ACTIONS(8197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8199), 1,
      anon_sym_AMP,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6517), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3996), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4563), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119008] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    STATE(1658), 1,
      sym_alignas_qualifier,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4188), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5442), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8203), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8201), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [119076] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_STAR,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_AMP,
    ACTIONS(8207), 1,
      anon_sym___asm,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6001), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119164] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7844), 1,
      anon_sym_STAR,
    ACTIONS(7846), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7848), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8189), 1,
      sym_auto,
    ACTIONS(8191), 1,
      anon_sym_decltype,
    ACTIONS(8207), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4633), 1,
      sym_decltype_auto,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6072), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4122), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5752), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119306] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8213), 1,
      anon_sym_LT,
    STATE(2547), 1,
      sym_template_argument_list,
    ACTIONS(4963), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4970), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [119366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5784), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119420] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7844), 1,
      anon_sym_STAR,
    ACTIONS(7846), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7848), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8187), 1,
      anon_sym___asm,
    ACTIONS(8189), 1,
      sym_auto,
    ACTIONS(8191), 1,
      anon_sym_decltype,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4633), 1,
      sym_decltype_auto,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6080), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4124), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119508] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5867), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8216), 1,
      anon_sym_STAR,
    ACTIONS(8218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6467), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4499), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119600] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5859), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8222), 1,
      anon_sym_STAR,
    ACTIONS(8224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8226), 1,
      anon_sym_AMP,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6413), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4000), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4438), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119692] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_STAR,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_AMP,
    ACTIONS(8187), 1,
      anon_sym___asm,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6006), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4152), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(2573), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [119834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    STATE(3896), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6172), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6174), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5653), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119948] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8228), 1,
      anon_sym_STAR,
    ACTIONS(8230), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8232), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6426), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3997), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120038] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8195), 1,
      anon_sym_STAR,
    ACTIONS(8197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8199), 1,
      anon_sym_AMP,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6497), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4436), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120128] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8228), 1,
      anon_sym_STAR,
    ACTIONS(8230), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8232), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6519), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4465), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8193), 1,
      anon_sym_LT,
    STATE(2547), 1,
      sym_template_argument_list,
    ACTIONS(5838), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4172), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [120278] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 1,
      anon_sym_STAR,
    ACTIONS(7888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(8189), 1,
      sym_auto,
    ACTIONS(8191), 1,
      anon_sym_decltype,
    ACTIONS(8207), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4633), 1,
      sym_decltype_auto,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6051), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120366] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5867), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8222), 1,
      anon_sym_STAR,
    ACTIONS(8224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8226), 1,
      anon_sym_AMP,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6418), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4445), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120458] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(3047), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7009), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(4152), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [120522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5804), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5673), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5675), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120630] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    STATE(3853), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6204), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6206), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120690] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5859), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8216), 1,
      anon_sym_STAR,
    ACTIONS(8218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6465), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3989), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4484), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120782] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    STATE(3843), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6263), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6265), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120842] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(8234), 1,
      anon_sym_COLON,
    STATE(2551), 1,
      sym__enum_base_clause,
    STATE(2642), 1,
      sym_enumerator_list,
    STATE(2696), 1,
      sym_attribute_specifier,
    ACTIONS(6342), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6344), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [120909] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8236), 1,
      sym_identifier,
    ACTIONS(8238), 1,
      anon_sym_LPAREN2,
    ACTIONS(8240), 1,
      anon_sym_STAR,
    ACTIONS(8242), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8250), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3070), 1,
      sym__type_declarator,
    STATE(3394), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8712), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4014), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4675), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120998] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8256), 1,
      anon_sym_STAR,
    ACTIONS(8258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8260), 1,
      anon_sym_AMP,
    ACTIONS(8264), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5889), 1,
      sym__type_declarator,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(8067), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4757), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121087] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8266), 1,
      sym_identifier,
    ACTIONS(8268), 1,
      anon_sym_LPAREN2,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(8272), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8274), 1,
      anon_sym_AMP,
    ACTIONS(8278), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2889), 1,
      sym__type_declarator,
    STATE(3288), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8665), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4647), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8276), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3285), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121176] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8266), 1,
      sym_identifier,
    ACTIONS(8268), 1,
      anon_sym_LPAREN2,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(8272), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8274), 1,
      anon_sym_AMP,
    ACTIONS(8278), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      sym__type_declarator,
    STATE(3288), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8665), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4707), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8276), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3285), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121265] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8266), 1,
      sym_identifier,
    ACTIONS(8268), 1,
      anon_sym_LPAREN2,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(8272), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8274), 1,
      anon_sym_AMP,
    ACTIONS(8278), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      sym__type_declarator,
    STATE(3288), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8665), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4010), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4707), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8276), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3285), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5629), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5631), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121407] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8236), 1,
      sym_identifier,
    ACTIONS(8238), 1,
      anon_sym_LPAREN2,
    ACTIONS(8240), 1,
      anon_sym_STAR,
    ACTIONS(8242), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8250), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3083), 1,
      sym__type_declarator,
    STATE(3394), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8712), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121496] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8236), 1,
      sym_identifier,
    ACTIONS(8238), 1,
      anon_sym_LPAREN2,
    ACTIONS(8240), 1,
      anon_sym_STAR,
    ACTIONS(8242), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8250), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3083), 1,
      sym__type_declarator,
    STATE(3394), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8712), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4021), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121585] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    ACTIONS(8292), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2185), 1,
      sym__type_declarator,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7984), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4680), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121674] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8256), 1,
      anon_sym_STAR,
    ACTIONS(8258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8260), 1,
      anon_sym_AMP,
    ACTIONS(8264), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5889), 1,
      sym__type_declarator,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(8067), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4044), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4757), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121763] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(63), 1,
      anon_sym___inline,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    ACTIONS(8294), 1,
      anon_sym_virtual,
    ACTIONS(8298), 1,
      anon_sym___declspec,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2504), 1,
      sym_decltype_auto,
    ACTIONS(6471), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6473), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    STATE(4197), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8296), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121846] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8103), 1,
      sym_auto,
    ACTIONS(8105), 1,
      anon_sym_decltype,
    STATE(4096), 1,
      sym_decltype_auto,
    ACTIONS(5589), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5591), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121905] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6246), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4022), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4624), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121994] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8236), 1,
      sym_identifier,
    ACTIONS(8238), 1,
      anon_sym_LPAREN2,
    ACTIONS(8240), 1,
      anon_sym_STAR,
    ACTIONS(8242), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8250), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3100), 1,
      sym__type_declarator,
    STATE(3394), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8712), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4679), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122083] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6251), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4626), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122172] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6251), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4053), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4626), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5450), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5452), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122316] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5853), 1,
      anon_sym_STAR,
    ACTIONS(5855), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5857), 1,
      anon_sym_AMP,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(8173), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(3087), 1,
      sym_parameter_list,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6319), 1,
      sym__declarator,
    STATE(6573), 1,
      sym__abstract_declarator,
    STATE(7434), 1,
      sym_variadic_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(8308), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8306), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [122415] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(4175), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8310), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5977), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5979), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [122478] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8256), 1,
      anon_sym_STAR,
    ACTIONS(8258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8260), 1,
      anon_sym_AMP,
    ACTIONS(8264), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5907), 1,
      sym__type_declarator,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(8067), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4009), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4761), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8043), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8041), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [122620] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    ACTIONS(8292), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2203), 1,
      sym__type_declarator,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7984), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4016), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4610), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122709] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8264), 1,
      sym_primitive_type,
    ACTIONS(8312), 1,
      anon_sym_STAR,
    ACTIONS(8314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8316), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(6225), 1,
      sym__type_declarator,
    STATE(8365), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4630), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122798] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8264), 1,
      sym_primitive_type,
    ACTIONS(8312), 1,
      anon_sym_STAR,
    ACTIONS(8314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8316), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(6225), 1,
      sym__type_declarator,
    STATE(8365), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4033), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4630), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122887] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8318), 1,
      anon_sym_STAR,
    ACTIONS(8320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8322), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6529), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4034), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4718), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122976] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8264), 1,
      sym_primitive_type,
    ACTIONS(8312), 1,
      anon_sym_STAR,
    ACTIONS(8314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8316), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(6227), 1,
      sym__type_declarator,
    STATE(8365), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4631), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123065] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8318), 1,
      anon_sym_STAR,
    ACTIONS(8320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8322), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6533), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4722), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123154] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(8234), 1,
      anon_sym_COLON,
    STATE(2549), 1,
      sym__enum_base_clause,
    STATE(2634), 1,
      sym_enumerator_list,
    STATE(2682), 1,
      sym_attribute_specifier,
    ACTIONS(6336), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6338), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [123221] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    ACTIONS(8292), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2176), 1,
      sym__type_declarator,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7984), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4729), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123310] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    ACTIONS(8292), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2203), 1,
      sym__type_declarator,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7984), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4610), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123399] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(4175), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8310), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(4152), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [123462] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8264), 1,
      sym_primitive_type,
    ACTIONS(8312), 1,
      anon_sym_STAR,
    ACTIONS(8314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8316), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(6184), 1,
      sym__type_declarator,
    STATE(8365), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4030), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4629), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123551] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8324), 1,
      anon_sym_STAR,
    ACTIONS(8326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8328), 1,
      anon_sym_AMP,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6545), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4041), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4639), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5851), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123640] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8324), 1,
      anon_sym_STAR,
    ACTIONS(8326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8328), 1,
      anon_sym_AMP,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6547), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4641), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123729] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    ACTIONS(5838), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(4172), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [123788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8077), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8075), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [123841] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8256), 1,
      anon_sym_STAR,
    ACTIONS(8258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8260), 1,
      anon_sym_AMP,
    ACTIONS(8264), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5912), 1,
      sym__type_declarator,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(8067), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4646), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123930] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8330), 1,
      anon_sym_STAR,
    ACTIONS(8332), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8334), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6749), 1,
      sym__type_declarator,
    STATE(8527), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4049), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124019] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    ACTIONS(4963), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(4970), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [124078] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4965), 1,
      anon_sym_SEMI,
    ACTIONS(4974), 1,
      anon_sym_LBRACK,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(3962), 1,
      sym_template_argument_list,
    ACTIONS(4967), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4970), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(4963), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [124143] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(63), 1,
      anon_sym___inline,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    ACTIONS(8298), 1,
      anon_sym___declspec,
    ACTIONS(8336), 1,
      anon_sym_virtual,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2504), 1,
      sym_decltype_auto,
    ACTIONS(6453), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6455), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    STATE(4185), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8296), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124226] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8330), 1,
      anon_sym_STAR,
    ACTIONS(8332), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8334), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6723), 1,
      sym__type_declarator,
    STATE(8527), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4652), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124315] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8266), 1,
      sym_identifier,
    ACTIONS(8268), 1,
      anon_sym_LPAREN2,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(8272), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8274), 1,
      anon_sym_AMP,
    ACTIONS(8278), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2916), 1,
      sym__type_declarator,
    STATE(3288), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8665), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4011), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4594), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8276), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3285), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124404] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8330), 1,
      anon_sym_STAR,
    ACTIONS(8332), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8334), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6723), 1,
      sym__type_declarator,
    STATE(8527), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4052), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4652), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124493] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8330), 1,
      anon_sym_STAR,
    ACTIONS(8332), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8334), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6753), 1,
      sym__type_declarator,
    STATE(8527), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4655), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124582] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6238), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8246), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4583), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7850), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5734), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5679), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5679), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124827] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(8338), 1,
      anon_sym_COLON,
    STATE(2469), 1,
      sym_attribute_specifier,
    STATE(2775), 1,
      sym__enum_base_clause,
    STATE(2882), 1,
      sym_enumerator_list,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6344), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6342), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [124891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4058), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8340), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5072), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
    ACTIONS(5070), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [124947] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3976), 1,
      sym_new_declarator,
    STATE(3898), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5842), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5844), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125015] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(8338), 1,
      anon_sym_COLON,
    STATE(2509), 1,
      sym_attribute_specifier,
    STATE(2788), 1,
      sym__enum_base_clause,
    STATE(2880), 1,
      sym_enumerator_list,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6338), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6336), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [125079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5639), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5665), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5738), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5655), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5657), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125287] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(4004), 1,
      sym_new_declarator,
    STATE(3844), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5869), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5871), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3287), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3282), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [125407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5661), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2699), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [125511] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8343), 1,
      sym_identifier,
    ACTIONS(8353), 1,
      sym_primitive_type,
    STATE(4238), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4316), 1,
      sym_alignas_qualifier,
    ACTIONS(8350), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4084), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8348), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5088), 9,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(5086), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8345), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5756), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5760), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125683] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    STATE(3992), 1,
      sym_alignas_qualifier,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4295), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4337), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5688), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8203), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8201), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [125749] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4058), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5070), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8340), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5156), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
    ACTIONS(5159), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [125807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5788), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5790), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5792), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2641), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2639), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [125963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5796), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5780), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5788), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5667), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5669), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5699), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5701), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5772), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5649), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126327] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8355), 1,
      sym_identifier,
    ACTIONS(8365), 1,
      sym_primitive_type,
    STATE(4316), 1,
      sym_alignas_qualifier,
    STATE(4388), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8362), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4128), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8360), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5102), 9,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(5100), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8357), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126395] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7982), 1,
      anon_sym_STAR,
    ACTIONS(7984), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7986), 1,
      anon_sym_AMP,
    ACTIONS(8207), 1,
      anon_sym___attribute,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6258), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4219), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126481] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(4006), 1,
      sym_new_declarator,
    STATE(3840), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5823), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5825), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5452), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126601] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7982), 1,
      anon_sym_STAR,
    ACTIONS(7984), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7986), 1,
      anon_sym_AMP,
    ACTIONS(8187), 1,
      anon_sym___attribute,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6236), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4224), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5681), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5683), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5679), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126791] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8367), 1,
      anon_sym_STAR,
    ACTIONS(8369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8371), 1,
      anon_sym_AMP,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6619), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4093), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4819), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5851), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5742), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126931] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7850), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8367), 1,
      anon_sym_STAR,
    ACTIONS(8369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8371), 1,
      anon_sym_AMP,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(3761), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6623), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7852), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7854), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4822), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5865), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5687), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5694), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5798), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5800), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5776), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5808), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2653), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2651), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [127331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5812), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3079), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [127435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5762), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5764), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127487] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7953), 1,
      anon_sym_LBRACK,
    ACTIONS(8101), 1,
      anon_sym_LPAREN2,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3993), 1,
      sym_new_declarator,
    STATE(3865), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5873), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5875), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5768), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2713), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2711), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [127659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2955), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [127711] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8373), 1,
      anon_sym_STAR,
    ACTIONS(8375), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8377), 1,
      anon_sym_AMP,
    ACTIONS(8381), 1,
      sym_ms_restrict_modifier,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(5267), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6638), 1,
      sym__abstract_declarator,
    ACTIONS(8383), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8385), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4155), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5851), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127798] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(6451), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [127889] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(6451), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [127978] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(6451), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [128063] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(6451), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [128146] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6449), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
  [128225] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
  [128300] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6449), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [128371] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [128444] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    ACTIONS(8415), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8417), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8419), 1,
      anon_sym_or,
    ACTIONS(8421), 1,
      anon_sym_and,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7005), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [128543] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    ACTIONS(8415), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8417), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8419), 1,
      anon_sym_or,
    ACTIONS(8421), 1,
      anon_sym_and,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8425), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7011), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7013), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [128646] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6137), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8049), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4898), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128731] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    ACTIONS(8415), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8417), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8419), 1,
      anon_sym_or,
    ACTIONS(8421), 1,
      anon_sym_and,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7015), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [128830] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    ACTIONS(8415), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8417), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8419), 1,
      anon_sym_or,
    ACTIONS(8421), 1,
      anon_sym_and,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8425), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7019), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7021), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [128933] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    ACTIONS(8437), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(2677), 1,
      sym_decltype_auto,
    STATE(4324), 1,
      sym_new_declarator,
    STATE(4835), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5823), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5825), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [129000] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7844), 1,
      anon_sym_STAR,
    ACTIONS(7846), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7848), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8443), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6079), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129079] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 1,
      anon_sym___asm,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7844), 1,
      anon_sym_STAR,
    ACTIONS(7846), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7848), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6083), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129158] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7844), 1,
      anon_sym_STAR,
    ACTIONS(7846), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7848), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8447), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6084), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129237] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 1,
      anon_sym___asm,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7844), 1,
      anon_sym_STAR,
    ACTIONS(7846), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7848), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6085), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129316] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4972), 1,
      anon_sym_LBRACK,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(4226), 1,
      sym_template_argument_list,
    ACTIONS(4967), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4963), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [129377] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    ACTIONS(8415), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8417), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8419), 1,
      anon_sym_or,
    ACTIONS(8421), 1,
      anon_sym_and,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8425), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8449), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8451), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [129480] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4316), 1,
      sym_alignas_qualifier,
    ACTIONS(8456), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4128), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5049), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8453), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(5047), 15,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [129539] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8459), 1,
      sym_identifier,
    ACTIONS(8461), 1,
      anon_sym_STAR,
    ACTIONS(8463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8465), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6677), 1,
      sym__field_declarator,
    STATE(6800), 1,
      sym_operator_name,
    STATE(8225), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4873), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129624] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8107), 1,
      anon_sym_STAR,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8111), 1,
      anon_sym_AMP,
    ACTIONS(8189), 1,
      sym_auto,
    ACTIONS(8191), 1,
      anon_sym_decltype,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4633), 1,
      sym_decltype_auto,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6284), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4297), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129707] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4289), 1,
      sym_alignas_qualifier,
    ACTIONS(8470), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5047), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(5049), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8467), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129766] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8459), 1,
      sym_identifier,
    ACTIONS(8461), 1,
      anon_sym_STAR,
    ACTIONS(8463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8465), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6677), 1,
      sym__field_declarator,
    STATE(6800), 1,
      sym_operator_name,
    STATE(8225), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4134), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4873), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129851] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    ACTIONS(8437), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(2677), 1,
      sym_decltype_auto,
    STATE(4369), 1,
      sym_new_declarator,
    STATE(4833), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5873), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5875), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [129918] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8459), 1,
      sym_identifier,
    ACTIONS(8461), 1,
      anon_sym_STAR,
    ACTIONS(8463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8465), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6693), 1,
      sym__field_declarator,
    STATE(6800), 1,
      sym_operator_name,
    STATE(8225), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4861), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130003] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(3853), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6204), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6206), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130060] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    ACTIONS(8437), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(2677), 1,
      sym_decltype_auto,
    STATE(4341), 1,
      sym_new_declarator,
    STATE(4790), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5869), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5871), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [130127] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 1,
      anon_sym_STAR,
    ACTIONS(7888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(8443), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6054), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130206] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(3843), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6263), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6265), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130263] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 1,
      anon_sym___attribute,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 1,
      anon_sym_STAR,
    ACTIONS(7888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6057), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130342] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 1,
      anon_sym_STAR,
    ACTIONS(7888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(8447), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6058), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130421] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8473), 1,
      anon_sym_STAR,
    ACTIONS(8475), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8477), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6698), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4848), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5865), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130508] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 1,
      anon_sym___attribute,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 1,
      anon_sym_STAR,
    ACTIONS(7888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6059), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130587] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    ACTIONS(8437), 1,
      anon_sym_LPAREN2,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(2677), 1,
      sym_decltype_auto,
    STATE(4329), 1,
      sym_new_declarator,
    STATE(4782), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5842), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5844), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [130654] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6106), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8049), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4118), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4849), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130739] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8119), 1,
      anon_sym_STAR,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8187), 1,
      anon_sym___attribute,
    ACTIONS(8479), 1,
      sym_auto,
    ACTIONS(8481), 1,
      anon_sym_decltype,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(4924), 1,
      sym_decltype_auto,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6288), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4263), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6572), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130875] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8119), 1,
      anon_sym_STAR,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8207), 1,
      anon_sym___attribute,
    ACTIONS(8479), 1,
      sym_auto,
    ACTIONS(8481), 1,
      anon_sym_decltype,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(4924), 1,
      sym_decltype_auto,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6286), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4261), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130960] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(3896), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6172), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6174), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131017] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_STAR,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_AMP,
    ACTIONS(8443), 1,
      anon_sym___asm,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6005), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131096] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6646), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4162), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5851), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131183] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5867), 1,
      anon_sym___asm,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_STAR,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6007), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131262] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_STAR,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_AMP,
    ACTIONS(8447), 1,
      anon_sym___asm,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6008), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131341] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6750), 1,
      anon_sym___asm,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_STAR,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6009), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131420] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8459), 1,
      sym_identifier,
    ACTIONS(8461), 1,
      anon_sym_STAR,
    ACTIONS(8463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8465), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6688), 1,
      sym__field_declarator,
    STATE(6800), 1,
      sym_operator_name,
    STATE(8225), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4129), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4851), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131505] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8373), 1,
      anon_sym_STAR,
    ACTIONS(8375), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8377), 1,
      anon_sym_AMP,
    ACTIONS(8381), 1,
      sym_ms_restrict_modifier,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(5267), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6650), 1,
      sym__abstract_declarator,
    ACTIONS(8383), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8385), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4889), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5019), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(5865), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131592] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5853), 1,
      anon_sym_STAR,
    ACTIONS(5855), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5857), 1,
      anon_sym_AMP,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    STATE(3087), 1,
      sym_parameter_list,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6319), 1,
      sym__declarator,
    STATE(6573), 1,
      sym__abstract_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(8308), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8306), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [131685] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6137), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8049), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4165), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4898), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131770] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    ACTIONS(8415), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8417), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8419), 1,
      anon_sym_or,
    ACTIONS(8421), 1,
      anon_sym_and,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6933), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [131869] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    ACTIONS(8415), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8417), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8419), 1,
      anon_sym_or,
    ACTIONS(8421), 1,
      anon_sym_and,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6967), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [131968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6708), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132019] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(3830), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6188), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6190), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132076] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6687), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4855), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5865), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6696), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132214] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8107), 1,
      anon_sym_STAR,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8111), 1,
      anon_sym_AMP,
    ACTIONS(8189), 1,
      sym_auto,
    ACTIONS(8191), 1,
      anon_sym_decltype,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4633), 1,
      sym_decltype_auto,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6300), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4298), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132297] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6152), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8049), 1,
      sym_ms_based_modifier,
    ACTIONS(3329), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4842), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3327), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132382] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6449), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6451), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [132451] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    ACTIONS(8415), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8417), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8419), 1,
      anon_sym_or,
    ACTIONS(8421), 1,
      anon_sym_and,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6987), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [132550] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    ACTIONS(8415), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8417), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8419), 1,
      anon_sym_or,
    ACTIONS(8421), 1,
      anon_sym_and,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8425), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6524), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6526), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [132653] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8473), 1,
      anon_sym_STAR,
    ACTIONS(8475), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8477), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6682), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4141), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4875), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5851), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132740] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8393), 1,
      anon_sym_SLASH,
    ACTIONS(8397), 1,
      anon_sym_CARET,
    ACTIONS(8405), 1,
      anon_sym_GT_EQ,
    ACTIONS(8409), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8411), 1,
      anon_sym_xor,
    ACTIONS(8413), 1,
      anon_sym_not_eq,
    ACTIONS(8417), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8421), 1,
      anon_sym_and,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8389), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8391), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8395), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8399), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8401), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8407), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      sym_identifier,
    ACTIONS(8403), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [132835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6507), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [132885] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8509), 1,
      anon_sym_SEMI,
    ACTIONS(8511), 1,
      anon_sym_QMARK,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(6847), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7941), 1,
      sym_attribute_specifier,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132991] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8511), 1,
      anon_sym_QMARK,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    ACTIONS(8519), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(6821), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7957), 1,
      sym_attribute_specifier,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8521), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6178), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6180), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4058), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8523), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5900), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5898), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [133203] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6367), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4406), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8527), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8525), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [133335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6465), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [133385] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8511), 1,
      anon_sym_QMARK,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    ACTIONS(8529), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(6806), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8787), 1,
      sym_attribute_specifier,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4192), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8531), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5938), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5936), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [133545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4193), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8533), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5932), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5930), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [133599] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6368), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4333), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8521), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8535), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6253), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6255), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133735] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    STATE(1658), 1,
      sym_alignas_qualifier,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8203), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8201), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [133795] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(63), 1,
      anon_sym___inline,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8298), 1,
      anon_sym___declspec,
    ACTIONS(8537), 1,
      anon_sym_virtual,
    STATE(1658), 1,
      sym_alignas_qualifier,
    ACTIONS(6731), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6733), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    STATE(4186), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8296), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133869] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7724), 1,
      anon_sym_const,
    ACTIONS(7730), 1,
      anon_sym___inline,
    ACTIONS(7733), 1,
      anon_sym___attribute,
    ACTIONS(8542), 1,
      anon_sym_virtual,
    ACTIONS(8548), 1,
      anon_sym___attribute__,
    ACTIONS(8551), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8554), 1,
      anon_sym___declspec,
    STATE(1658), 1,
      sym_alignas_qualifier,
    ACTIONS(6756), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(8557), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6758), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    STATE(4186), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8545), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(8539), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6402), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6404), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [133993] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    STATE(1658), 1,
      sym_alignas_qualifier,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8562), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8560), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [134053] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8564), 1,
      anon_sym_LT,
    STATE(4378), 1,
      sym_template_argument_list,
    STATE(4409), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4144), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8566), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4152), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [134113] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8568), 1,
      anon_sym_STAR,
    ACTIONS(8570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8572), 1,
      anon_sym_AMP,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6763), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4211), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4907), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5851), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5452), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5450), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [134251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4058), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8523), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5944), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5942), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [134305] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4058), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8523), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5894), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [134359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4206), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8574), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5904), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5902), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [134413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4207), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8576), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5922), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5920), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [134467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4058), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8523), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5928), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5926), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [134521] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(63), 1,
      anon_sym___inline,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8298), 1,
      anon_sym___declspec,
    ACTIONS(8537), 1,
      anon_sym_virtual,
    STATE(1658), 1,
      sym_alignas_qualifier,
    ACTIONS(6741), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6743), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    STATE(4186), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8296), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4203), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8578), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5750), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5752), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [134649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7081), 1,
      sym_literal_suffix,
    ACTIONS(4154), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4146), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134701] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(4409), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5977), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8566), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5979), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [134761] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8580), 1,
      anon_sym_COLON,
    STATE(2509), 1,
      sym_attribute_specifier,
    STATE(3489), 1,
      sym__enum_base_clause,
    STATE(3613), 1,
      sym_enumerator_list,
    ACTIONS(6336), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6338), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [134825] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8580), 1,
      anon_sym_COLON,
    STATE(2469), 1,
      sym_attribute_specifier,
    STATE(3490), 1,
      sym__enum_base_clause,
    STATE(3616), 1,
      sym_enumerator_list,
    ACTIONS(6342), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6344), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [134889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4058), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8523), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5888), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [134943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8584), 1,
      anon_sym_LPAREN2,
    ACTIONS(8586), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8582), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [134995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7036), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7038), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4058), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8523), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5910), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5908), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [135099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4058), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8523), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5918), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5916), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [135153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4203), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8578), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5452), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [135207] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      sym_identifier,
    ACTIONS(5748), 1,
      sym_primitive_type,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(4393), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8593), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4210), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8591), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5088), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5086), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8588), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135273] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5814), 1,
      sym_identifier,
    ACTIONS(5818), 1,
      sym_primitive_type,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(1946), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8599), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1655), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5816), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5102), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5100), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8596), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135339] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8568), 1,
      anon_sym_STAR,
    ACTIONS(8570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8572), 1,
      anon_sym_AMP,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6760), 1,
      sym__abstract_declarator,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4901), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5865), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135425] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8602), 1,
      anon_sym_STAR,
    ACTIONS(8604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6778), 1,
      sym__abstract_declarator,
    ACTIONS(5851), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4216), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4958), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135510] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    ACTIONS(8187), 1,
      anon_sym___attribute,
    ACTIONS(8216), 1,
      anon_sym_STAR,
    ACTIONS(8218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6516), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4487), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135593] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8610), 1,
      anon_sym_and,
    ACTIONS(6178), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6180), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135646] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    ACTIONS(8207), 1,
      anon_sym___attribute,
    ACTIONS(8216), 1,
      anon_sym_STAR,
    ACTIONS(8218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6450), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4467), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135729] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8602), 1,
      anon_sym_STAR,
    ACTIONS(8604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(4043), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6789), 1,
      sym__abstract_declarator,
    ACTIONS(5865), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(8127), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8129), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4963), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4217), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8612), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5072), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5070), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [135867] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    STATE(4537), 1,
      sym_field_declaration_list,
    STATE(4733), 1,
      sym_attribute_specifier,
    STATE(7096), 1,
      sym_virtual_specifier,
    STATE(7811), 1,
      sym_base_class_clause,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5493), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5495), 27,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_try,
      anon_sym_requires,
  [135934] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7982), 1,
      anon_sym_STAR,
    ACTIONS(7984), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7986), 1,
      anon_sym_AMP,
    ACTIONS(8443), 1,
      anon_sym___attribute,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6223), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5194), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5164), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5150), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136158] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5867), 1,
      anon_sym___attribute,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7982), 1,
      anon_sym_STAR,
    ACTIONS(7984), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7986), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6262), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136235] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7982), 1,
      anon_sym_STAR,
    ACTIONS(7984), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7986), 1,
      anon_sym_AMP,
    ACTIONS(8447), 1,
      anon_sym___attribute,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6266), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136312] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6750), 1,
      anon_sym___attribute,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7982), 1,
      anon_sym_STAR,
    ACTIONS(7984), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7986), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6173), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136389] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5005), 1,
      anon_sym_LBRACK,
    ACTIONS(5000), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5003), 4,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(4996), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [136442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5132), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5134), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5142), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136540] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8564), 1,
      anon_sym_LT,
    STATE(4378), 1,
      sym_template_argument_list,
    ACTIONS(4963), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4970), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [136595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5154), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8564), 1,
      anon_sym_LT,
    STATE(4378), 1,
      sym_template_argument_list,
    ACTIONS(5838), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4172), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [136699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(1934), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5168), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136797] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8228), 1,
      anon_sym_STAR,
    ACTIONS(8230), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8232), 1,
      anon_sym_AMP,
    ACTIONS(8479), 1,
      sym_auto,
    ACTIONS(8481), 1,
      anon_sym_decltype,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(4924), 1,
      sym_decltype_auto,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6407), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4572), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136878] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    ACTIONS(8195), 1,
      anon_sym_STAR,
    ACTIONS(8197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8199), 1,
      anon_sym_AMP,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6507), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4442), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(1938), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5182), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137057] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4217), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5070), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8612), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5156), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5159), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [137112] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6048), 1,
      sym_identifier,
    ACTIONS(6056), 1,
      sym_primitive_type,
    STATE(2229), 1,
      sym_alignas_qualifier,
    STATE(4488), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8622), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4247), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8620), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5086), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(5088), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8617), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5172), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5188), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5190), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137275] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(6032), 1,
      anon_sym_STAR,
    ACTIONS(6034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6036), 1,
      anon_sym_AMP,
    STATE(3223), 1,
      sym_parameter_list,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6319), 1,
      sym__declarator,
    STATE(6666), 1,
      sym__abstract_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(8306), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8308), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [137366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7036), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7038), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5186), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137464] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8228), 1,
      anon_sym_STAR,
    ACTIONS(8230), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8232), 1,
      anon_sym_AMP,
    ACTIONS(8479), 1,
      sym_auto,
    ACTIONS(8481), 1,
      anon_sym_decltype,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(4924), 1,
      sym_decltype_auto,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6441), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4451), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137545] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8187), 1,
      anon_sym___attribute,
    ACTIONS(8222), 1,
      anon_sym_STAR,
    ACTIONS(8224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8226), 1,
      anon_sym_AMP,
    STATE(2677), 1,
      sym_decltype_auto,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6470), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4439), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137628] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6084), 1,
      sym_identifier,
    ACTIONS(6088), 1,
      sym_primitive_type,
    STATE(2229), 1,
      sym_alignas_qualifier,
    STATE(2344), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8628), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1926), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6086), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5100), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(5102), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8625), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5146), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8635), 1,
      anon_sym___attribute__,
    ACTIONS(8638), 1,
      anon_sym___attribute,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(8633), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(8631), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [137797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7081), 1,
      sym_literal_suffix,
    ACTIONS(4154), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4146), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5138), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5138), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137946] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8207), 1,
      anon_sym___attribute,
    ACTIONS(8222), 1,
      anon_sym_STAR,
    ACTIONS(8224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8226), 1,
      anon_sym_AMP,
    STATE(2677), 1,
      sym_decltype_auto,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6522), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4416), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138029] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(5971), 1,
      anon_sym_STAR,
    ACTIONS(5973), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5975), 1,
      anon_sym_AMP,
    STATE(3216), 1,
      sym_parameter_list,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6319), 1,
      sym__declarator,
    STATE(6658), 1,
      sym__abstract_declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    ACTIONS(8306), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8308), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [138120] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    ACTIONS(8195), 1,
      anon_sym_STAR,
    ACTIONS(8197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8199), 1,
      anon_sym_AMP,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6405), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4415), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5138), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [138250] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8610), 1,
      anon_sym_and,
    ACTIONS(8641), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8643), 1,
      anon_sym_or,
    ACTIONS(6253), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6255), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [138307] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6449), 1,
      anon_sym_PIPE,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [138391] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8324), 1,
      anon_sym_STAR,
    ACTIONS(8326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8328), 1,
      anon_sym_AMP,
    STATE(2677), 1,
      sym_decltype_auto,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6542), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4640), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138471] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
  [138559] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8119), 1,
      anon_sym_STAR,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8443), 1,
      anon_sym___attribute,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6287), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138635] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5867), 1,
      anon_sym___attribute,
    ACTIONS(8119), 1,
      anon_sym_STAR,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6292), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138711] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8119), 1,
      anon_sym_STAR,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8447), 1,
      anon_sym___attribute,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6289), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138787] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(6750), 1,
      anon_sym___attribute,
    ACTIONS(8119), 1,
      anon_sym_STAR,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6293), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138863] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym___attribute,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [138939] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6967), 1,
      anon_sym___attribute,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [139031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5643), 35,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [139079] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7019), 1,
      anon_sym___attribute,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8511), 1,
      anon_sym_QMARK,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7021), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139175] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [139247] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8511), 1,
      anon_sym_QMARK,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    ACTIONS(8675), 1,
      anon_sym___attribute,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8673), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [139343] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8107), 1,
      anon_sym_STAR,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8111), 1,
      anon_sym_AMP,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6304), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [139417] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [139487] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6449), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [139553] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6449), 1,
      anon_sym_PIPE,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [139635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5082), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5080), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [139683] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8324), 1,
      anon_sym_STAR,
    ACTIONS(8326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8328), 1,
      anon_sym_AMP,
    STATE(2677), 1,
      sym_decltype_auto,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6540), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4638), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [139763] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(6451), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [139833] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6449), 1,
      anon_sym___attribute,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
  [139923] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(8677), 1,
      anon_sym_COLON,
    ACTIONS(8679), 1,
      anon_sym_LBRACE,
    STATE(4382), 1,
      sym__enum_base_clause,
    STATE(4514), 1,
      sym_enumerator_list,
    STATE(4720), 1,
      sym_attribute_specifier,
    ACTIONS(6336), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6338), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [139985] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(1935), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5038), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5977), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(5979), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [140043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5082), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5080), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [140091] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6524), 1,
      anon_sym___attribute,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8511), 1,
      anon_sym_QMARK,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6526), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [140187] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6526), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [140281] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [140371] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [140457] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym___attribute,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [140539] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    STATE(3992), 1,
      sym_alignas_qualifier,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8203), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8201), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [140597] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [140675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2573), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [140723] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [140799] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6449), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(6451), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [140867] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(5851), 1,
      anon_sym_COLON,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8381), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8685), 1,
      anon_sym_STAR,
    ACTIONS(8687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8689), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(5267), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6903), 1,
      sym__abstract_declarator,
    ACTIONS(8383), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8385), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4304), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4996), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140951] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym___attribute,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [141029] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [141119] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    STATE(3992), 1,
      sym_alignas_qualifier,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8562), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8560), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [141177] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(8677), 1,
      anon_sym_COLON,
    ACTIONS(8679), 1,
      anon_sym_LBRACE,
    STATE(4358), 1,
      sym__enum_base_clause,
    STATE(4471), 1,
      sym_enumerator_list,
    STATE(4667), 1,
      sym_attribute_specifier,
    ACTIONS(6342), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6344), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [141239] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8107), 1,
      anon_sym_STAR,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8111), 1,
      anon_sym_AMP,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6305), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141313] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8107), 1,
      anon_sym_STAR,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8111), 1,
      anon_sym_AMP,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6281), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141387] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    ACTIONS(8318), 1,
      anon_sym_STAR,
    ACTIONS(8320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8322), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6528), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4711), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8205), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141467] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8107), 1,
      anon_sym_STAR,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8111), 1,
      anon_sym_AMP,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6278), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141541] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    ACTIONS(8318), 1,
      anon_sym_STAR,
    ACTIONS(8320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8322), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2504), 1,
      sym_decltype_auto,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6532), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4719), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8185), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141621] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [141689] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8691), 1,
      anon_sym_COMMA,
    ACTIONS(8693), 1,
      anon_sym_SEMI,
    ACTIONS(8695), 1,
      anon_sym_RBRACE,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7483), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [141789] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(5865), 1,
      anon_sym_COLON,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8381), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8685), 1,
      anon_sym_STAR,
    ACTIONS(8687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8689), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(5267), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6905), 1,
      sym__abstract_declarator,
    ACTIONS(8383), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8385), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5009), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5019), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141873] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym___attribute,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [141957] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [142047] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7013), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [142141] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
    STATE(1935), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4144), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(5038), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4152), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [142199] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7005), 1,
      anon_sym___attribute,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [142291] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6933), 1,
      anon_sym___attribute,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [142383] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6449), 1,
      anon_sym___attribute,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [142471] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8511), 1,
      anon_sym_QMARK,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    ACTIONS(8701), 1,
      anon_sym___attribute,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8699), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [142567] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7021), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [142661] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(6451), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [142733] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [142823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2573), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [142871] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7015), 1,
      anon_sym___attribute,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [142963] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym___attribute,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8511), 1,
      anon_sym_QMARK,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7013), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143059] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [143149] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6987), 1,
      anon_sym___attribute,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    ACTIONS(8495), 1,
      anon_sym_PIPE,
    ACTIONS(8499), 1,
      anon_sym_AMP,
    ACTIONS(8505), 1,
      anon_sym_GT_EQ,
    ACTIONS(8513), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8515), 1,
      anon_sym_bitor,
    ACTIONS(8517), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8485), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8491), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8493), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8497), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8507), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8501), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8503), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [143241] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8489), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6449), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(6451), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [143307] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8703), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143402] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8743), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7181), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    ACTIONS(8437), 1,
      anon_sym_LPAREN2,
    STATE(4777), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6263), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6265), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [143552] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8745), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7194), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143649] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8749), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8747), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143744] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8753), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7223), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143841] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8755), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7189), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143938] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    ACTIONS(8437), 1,
      anon_sym_LPAREN2,
    STATE(4803), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6188), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6190), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [143991] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8757), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7204), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144088] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(8761), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7387), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144185] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8763), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7212), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144282] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6389), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [144355] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8765), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7219), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144452] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8767), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7321), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144549] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8769), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7230), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8771), 1,
      anon_sym___attribute__,
    ACTIONS(8774), 1,
      anon_sym___attribute,
    STATE(4337), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(8633), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(8631), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [144699] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8777), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7499), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144796] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8779), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7239), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144893] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8781), 1,
      anon_sym_COMMA,
    ACTIONS(8783), 1,
      anon_sym_RBRACE,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7322), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144990] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    ACTIONS(8437), 1,
      anon_sym_LPAREN2,
    STATE(4797), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6204), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6206), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [145043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1296), 1,
      sym__fold_operator,
    ACTIONS(8787), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(8785), 25,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [145092] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8789), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7503), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145189] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8791), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7329), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145286] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8793), 1,
      anon_sym_COMMA,
    ACTIONS(8795), 1,
      anon_sym_RBRACE,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7256), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(5619), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4957), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145479] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8797), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7410), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145576] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8799), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7293), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4984), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4986), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4980), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4982), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4992), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4994), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4953), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(5619), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4961), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4359), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5450), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8801), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5452), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [146008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4988), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4990), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [146055] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(8679), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_enumerator_list,
    STATE(4588), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6026), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [146112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4217), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5890), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8803), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5888), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [146163] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(8805), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7233), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146260] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8695), 1,
      anon_sym_RBRACE,
    ACTIONS(8807), 1,
      anon_sym_COMMA,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7483), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7036), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7038), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [146404] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8809), 1,
      anon_sym_COMMA,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8835), 1,
      anon_sym_RBRACK,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7170), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146501] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8845), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7413), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146598] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8847), 1,
      anon_sym_COMMA,
    ACTIONS(8849), 1,
      anon_sym_RBRACE,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7414), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146695] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8851), 1,
      anon_sym_COMMA,
    ACTIONS(8853), 1,
      anon_sym_RBRACE,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7178), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146792] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8855), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7552), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146889] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8809), 1,
      anon_sym_COMMA,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    ACTIONS(8857), 1,
      anon_sym_RBRACK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7345), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146986] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    ACTIONS(8437), 1,
      anon_sym_LPAREN2,
    STATE(4781), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6172), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6174), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [147039] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8859), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7417), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4379), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5938), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5936), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147187] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8703), 1,
      anon_sym_SEMI,
    ACTIONS(8863), 1,
      anon_sym_COMMA,
    ACTIONS(8866), 1,
      anon_sym_RBRACE,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147284] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8189), 1,
      sym_auto,
    ACTIONS(8191), 1,
      anon_sym_decltype,
    ACTIONS(8367), 1,
      anon_sym_STAR,
    ACTIONS(8369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8371), 1,
      anon_sym_AMP,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4633), 1,
      sym_decltype_auto,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6616), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4818), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8205), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [147363] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8189), 1,
      sym_auto,
    ACTIONS(8191), 1,
      anon_sym_decltype,
    ACTIONS(8367), 1,
      anon_sym_STAR,
    ACTIONS(8369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8371), 1,
      anon_sym_AMP,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(4633), 1,
      sym_decltype_auto,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6622), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4821), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8185), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [147442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4381), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5932), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8868), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5930), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5625), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(5627), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147542] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(8870), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7341), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(5003), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147686] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4217), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5944), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8803), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5942), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7081), 1,
      sym_literal_suffix,
    ACTIONS(4154), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4146), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4217), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5896), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8803), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5894), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147837] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(8679), 1,
      anon_sym_LBRACE,
    STATE(4501), 1,
      sym_enumerator_list,
    STATE(4701), 1,
      sym_attribute_specifier,
    ACTIONS(5983), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5985), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [147894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4392), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5904), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5902), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147945] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    STATE(4885), 1,
      sym_field_declaration_list,
    STATE(4941), 1,
      sym_attribute_specifier,
    STATE(7016), 1,
      sym_virtual_specifier,
    STATE(7624), 1,
      sym_base_class_clause,
    ACTIONS(5493), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148010] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8880), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7175), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148107] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(2355), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5977), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5060), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5979), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [148164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4394), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5922), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8882), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5920), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4217), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5928), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8803), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5926), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4359), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5750), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8801), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5752), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148317] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(8884), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7438), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148414] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8886), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7156), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4217), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5910), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8803), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5908), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148562] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1669), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5070), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(5370), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5156), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5159), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [148615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4217), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5918), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8803), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5916), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148666] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8888), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7305), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148763] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8890), 1,
      anon_sym_COMMA,
    ACTIONS(8892), 1,
      anon_sym_RBRACE,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7307), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148860] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(8894), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7137), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5605), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(5607), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [149004] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6397), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [149077] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8896), 1,
      anon_sym_RPAREN,
    ACTIONS(8898), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149174] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(8900), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7436), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149271] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8902), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7325), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149368] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8693), 1,
      anon_sym_SEMI,
    ACTIONS(8904), 1,
      anon_sym_COMMA,
    ACTIONS(8907), 1,
      anon_sym_RBRACE,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149465] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6391), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [149538] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8909), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7172), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149635] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6395), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [149708] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8809), 1,
      anon_sym_COMMA,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    ACTIONS(8911), 1,
      anon_sym_RBRACK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    STATE(7533), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149805] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    ACTIONS(8913), 1,
      anon_sym_GT2,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    STATE(7377), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149902] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4217), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5900), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8803), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5898), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [149953] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6425), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6427), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [150011] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8915), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150105] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6449), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_GT2,
  [150185] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8917), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150279] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6680), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4874), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8185), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [150357] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8195), 1,
      anon_sym_STAR,
    ACTIONS(8197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8199), 1,
      anon_sym_AMP,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6508), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [150429] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8222), 1,
      anon_sym_STAR,
    ACTIONS(8224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8226), 1,
      anon_sym_AMP,
    ACTIONS(8443), 1,
      anon_sym___attribute,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6464), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [150503] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8945), 1,
      anon_sym_COLON,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150597] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8955), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150689] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_GT2,
  [150765] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6445), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6447), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [150823] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6989), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150911] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [150985] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4732), 1,
      sym_attribute_specifier,
    ACTIONS(6155), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6157), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [151037] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8957), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5619), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [151177] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [151249] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6441), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6443), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [151309] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    ACTIONS(8373), 1,
      anon_sym_STAR,
    ACTIONS(8375), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8377), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6696), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4869), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8205), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [151387] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7017), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151475] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6451), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [151541] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8959), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151635] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8961), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151727] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8963), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4660), 1,
      sym_attribute_specifier,
    ACTIONS(6058), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6060), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [151873] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(6526), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151965] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8195), 1,
      anon_sym_STAR,
    ACTIONS(8197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8199), 1,
      anon_sym_AMP,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6503), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152037] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(8965), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152131] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5867), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8222), 1,
      anon_sym_STAR,
    ACTIONS(8224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8226), 1,
      anon_sym_AMP,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6418), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152205] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8222), 1,
      anon_sym_STAR,
    ACTIONS(8224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8226), 1,
      anon_sym_AMP,
    ACTIONS(8447), 1,
      anon_sym___attribute,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6486), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152279] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    ACTIONS(8969), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152373] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [152443] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8195), 1,
      anon_sym_STAR,
    ACTIONS(8197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8199), 1,
      anon_sym_AMP,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6468), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152515] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(8971), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152609] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8973), 1,
      anon_sym_LT,
    STATE(2547), 1,
      sym_template_argument_list,
    ACTIONS(4963), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4970), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [152661] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(6750), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8222), 1,
      anon_sym_STAR,
    ACTIONS(8224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8226), 1,
      anon_sym_AMP,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6421), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152735] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8975), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152829] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(8977), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152923] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(8979), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153017] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8228), 1,
      anon_sym_STAR,
    ACTIONS(8230), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8232), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6519), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153089] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8981), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153181] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8228), 1,
      anon_sym_STAR,
    ACTIONS(8230), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8232), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6510), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153253] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8983), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153347] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8985), 1,
      anon_sym_COMMA,
    ACTIONS(8987), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153441] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    ACTIONS(8989), 1,
      anon_sym_COLON,
    ACTIONS(8991), 1,
      anon_sym_LBRACE,
    STATE(4826), 1,
      sym__enum_base_clause,
    STATE(4868), 1,
      sym_enumerator_list,
    STATE(4927), 1,
      sym_attribute_specifier,
    ACTIONS(6342), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6344), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [153501] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6700), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4891), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8205), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153579] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7007), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153667] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8693), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153761] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(8993), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153855] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4678), 1,
      sym_attribute_specifier,
    ACTIONS(6062), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6064), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [153907] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8995), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153999] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8997), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154093] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8999), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8439), 1,
      anon_sym_LBRACK,
    STATE(4690), 1,
      sym_new_declarator,
    ACTIONS(6352), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6354), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [154235] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9001), 1,
      anon_sym_COMMA,
    ACTIONS(9003), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154329] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8228), 1,
      anon_sym_STAR,
    ACTIONS(8230), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8232), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6420), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154401] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9005), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154495] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8216), 1,
      anon_sym_STAR,
    ACTIONS(8218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8443), 1,
      anon_sym___attribute,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6505), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8189), 1,
      sym_auto,
    ACTIONS(8191), 1,
      anon_sym_decltype,
    STATE(4633), 1,
      sym_decltype_auto,
    ACTIONS(5589), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5591), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [154621] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8747), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154713] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9007), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154807] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4586), 1,
      sym_attribute_specifier,
    ACTIONS(6090), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6092), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [154859] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8955), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154951] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7021), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155043] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9009), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155135] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9011), 1,
      anon_sym_COMMA,
    ACTIONS(9013), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155229] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9009), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155321] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9015), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155415] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6435), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6437), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [155475] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8733), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7013), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155567] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8973), 1,
      anon_sym_LT,
    STATE(2547), 1,
      sym_template_argument_list,
    ACTIONS(5838), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4172), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [155619] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9019), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155713] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9021), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155807] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9023), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155899] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5867), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8216), 1,
      anon_sym_STAR,
    ACTIONS(8218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6467), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [155973] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7655), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156065] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6969), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156153] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8216), 1,
      anon_sym_STAR,
    ACTIONS(8218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8447), 1,
      anon_sym___attribute,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6521), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [156227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2198), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5070), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(6148), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5156), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(5159), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [156279] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156371] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [156459] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4663), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6119), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [156511] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [156599] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9027), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5036), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5946), 1,
      anon_sym_LPAREN2,
    ACTIONS(5949), 1,
      anon_sym_LBRACK,
    ACTIONS(4154), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4146), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [156745] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [156833] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [156893] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9029), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156987] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6467), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6469), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [157047] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(6750), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8216), 1,
      anon_sym_STAR,
    ACTIONS(8218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6524), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157121] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9031), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157215] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4590), 1,
      sym_attribute_specifier,
    ACTIONS(6096), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6098), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [157267] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6449), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_GT2,
  [157349] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    ACTIONS(8989), 1,
      anon_sym_COLON,
    ACTIONS(8991), 1,
      anon_sym_LBRACE,
    STATE(4836), 1,
      sym__enum_base_clause,
    STATE(4878), 1,
      sym_enumerator_list,
    STATE(4937), 1,
      sym_attribute_specifier,
    ACTIONS(6336), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6338), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [157409] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(1852), 1,
      sym_attribute_specifier,
    STATE(5044), 1,
      sym_field_declaration_list,
    STATE(7011), 1,
      sym_virtual_specifier,
    STATE(7844), 1,
      sym_base_class_clause,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5495), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [157471] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6526), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157563] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9033), 1,
      anon_sym_COMMA,
    ACTIONS(9035), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157657] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6467), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6469), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [157717] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9037), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(5005), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4998), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [157859] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6449), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [157923] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
  [158009] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [158093] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8973), 1,
      anon_sym_LT,
    STATE(2355), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2547), 1,
      sym_template_argument_list,
    ACTIONS(4144), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5060), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4152), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [158149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4699), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6123), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [158201] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6449), 1,
      anon_sym_PIPE,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [158283] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6449), 1,
      anon_sym_PIPE,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [158363] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6989), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [158451] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6526), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158543] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6449), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [158607] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
  [158693] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [158777] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6449), 1,
      anon_sym_PIPE,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [158859] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(6449), 1,
      anon_sym_PIPE,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [158939] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [159015] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [159089] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [159159] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [159225] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [159293] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [159381] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7013), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159473] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [159561] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7021), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159653] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6935), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [159741] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [159817] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6969), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [159905] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6449), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [159979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4736), 1,
      sym_attribute_specifier,
    ACTIONS(6125), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6127), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [160031] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [160101] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4597), 1,
      sym_attribute_specifier,
    ACTIONS(6168), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6170), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [160153] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8981), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160245] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4739), 1,
      sym_attribute_specifier,
    ACTIONS(6129), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6131), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [160297] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [160363] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8907), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160455] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9039), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160549] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6425), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6427), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [160607] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4605), 1,
      sym_attribute_specifier,
    ACTIONS(6104), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6106), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [160659] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6435), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6437), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [160719] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6449), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [160787] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6441), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6443), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [160847] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6445), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6447), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [160905] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8715), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6935), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160993] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9041), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161087] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9043), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161181] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9045), 1,
      anon_sym_COMMA,
    ACTIONS(9047), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161275] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8703), 1,
      anon_sym_COLON,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161369] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8866), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161461] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9049), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161553] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8451), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161645] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9051), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161739] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    ACTIONS(8373), 1,
      anon_sym_STAR,
    ACTIONS(8375), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8377), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6703), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4881), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8185), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [161817] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9053), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161911] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9055), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162005] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8195), 1,
      anon_sym_STAR,
    ACTIONS(8197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8199), 1,
      anon_sym_AMP,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6497), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [162077] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9057), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162171] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7007), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [162259] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7013), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162351] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7017), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [162439] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9059), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162533] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7021), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162625] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(4300), 1,
      anon_sym_STAR,
    ACTIONS(4302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8306), 1,
      anon_sym_RPAREN,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6451), 1,
      sym__declarator,
    STATE(6649), 1,
      sym__abstract_declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [162711] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8898), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162805] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8228), 1,
      anon_sym_STAR,
    ACTIONS(8230), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8232), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6436), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [162877] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9061), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162971] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6451), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [163035] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9063), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163129] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6449), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6451), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [163189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    STATE(4716), 1,
      sym_attribute_specifier,
    ACTIONS(6151), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6153), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [163241] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9009), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163333] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8717), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_GT2,
  [163419] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    ACTIONS(7659), 1,
      anon_sym_LBRACK,
    ACTIONS(7663), 1,
      anon_sym_DOT,
    ACTIONS(8713), 1,
      anon_sym_SLASH,
    ACTIONS(8719), 1,
      anon_sym_PIPE,
    ACTIONS(8723), 1,
      anon_sym_AMP,
    ACTIONS(8729), 1,
      anon_sym_LT_LT,
    ACTIONS(8731), 1,
      anon_sym_GT_GT,
    ACTIONS(8735), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8737), 1,
      anon_sym_bitor,
    ACTIONS(8739), 1,
      anon_sym_bitand,
    STATE(3545), 1,
      sym_argument_list,
    STATE(3546), 1,
      sym_subscript_argument_list,
    ACTIONS(7665), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8709), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8741), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8725), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8727), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6451), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT2,
  [163503] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9009), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163595] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(7715), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9065), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163689] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6195), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [163762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5804), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [163807] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9067), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5808), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [163943] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    ACTIONS(9069), 1,
      anon_sym_RBRACK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5812), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [164079] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9071), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5639), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [164215] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9073), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164306] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9075), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164397] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9077), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164488] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8266), 1,
      sym_identifier,
    ACTIONS(8268), 1,
      anon_sym_LPAREN2,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(8272), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8274), 1,
      anon_sym_AMP,
    ACTIONS(8278), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2892), 1,
      sym__type_declarator,
    STATE(3288), 1,
      sym_pointer_type_declarator,
    STATE(8665), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8276), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3285), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [164561] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9079), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164652] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9081), 1,
      anon_sym_RBRACE,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5665), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [164788] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9083), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164879] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5251), 1,
      sym_ms_call_modifier,
    STATE(5632), 1,
      sym__declarator,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(7524), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [164960] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9085), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165051] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    ACTIONS(4172), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5838), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [165102] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9087), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165193] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9089), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165284] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9091), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5667), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5669), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [165420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5681), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5683), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [165465] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9093), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165556] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9095), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165647] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9097), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165738] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    ACTIONS(8292), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2185), 1,
      sym__type_declarator,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(7984), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [165811] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4298), 1,
      anon_sym_LPAREN2,
    ACTIONS(4300), 1,
      anon_sym_STAR,
    ACTIONS(4302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(5863), 1,
      anon_sym_LBRACK,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6686), 1,
      sym__declarator,
    STATE(6915), 1,
      sym__abstract_declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [165894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5699), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5701), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [165939] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9099), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166030] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9101), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166121] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166212] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9103), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166303] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8236), 1,
      sym_identifier,
    ACTIONS(8238), 1,
      anon_sym_LPAREN2,
    ACTIONS(8240), 1,
      anon_sym_STAR,
    ACTIONS(8242), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8250), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3100), 1,
      sym__type_declarator,
    STATE(3394), 1,
      sym_pointer_type_declarator,
    STATE(8712), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [166376] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9105), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166467] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4764), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166558] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9107), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166649] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    ACTIONS(9109), 1,
      anon_sym_RBRACK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166740] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9111), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9113), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6505), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6507), 30,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [166878] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6251), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [166951] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167042] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6238), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [167115] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9116), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5649), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [167251] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8264), 1,
      sym_primitive_type,
    ACTIONS(8312), 1,
      anon_sym_STAR,
    ACTIONS(8314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8316), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(6225), 1,
      sym__type_declarator,
    STATE(8365), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [167324] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8264), 1,
      sym_primitive_type,
    ACTIONS(8312), 1,
      anon_sym_STAR,
    ACTIONS(8314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8316), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(6227), 1,
      sym__type_declarator,
    STATE(8365), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [167397] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8264), 1,
      sym_primitive_type,
    ACTIONS(8312), 1,
      anon_sym_STAR,
    ACTIONS(8314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8316), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(6276), 1,
      sym__type_declarator,
    STATE(8365), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [167470] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4835), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5798), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5800), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [167606] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9118), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167697] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9120), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167788] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9122), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167879] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9124), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167970] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8324), 1,
      anon_sym_STAR,
    ACTIONS(8326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8328), 1,
      anon_sym_AMP,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6541), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [168041] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8324), 1,
      anon_sym_STAR,
    ACTIONS(8326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8328), 1,
      anon_sym_AMP,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6547), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [168112] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8324), 1,
      anon_sym_STAR,
    ACTIONS(8326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8328), 1,
      anon_sym_AMP,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6543), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [168183] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8324), 1,
      anon_sym_STAR,
    ACTIONS(8326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8328), 1,
      anon_sym_AMP,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6548), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [168254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5762), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5764), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [168299] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9126), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168390] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5260), 1,
      sym_ms_call_modifier,
    STATE(5502), 1,
      sym__declarator,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(7396), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [168471] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9128), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168562] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8256), 1,
      anon_sym_STAR,
    ACTIONS(8258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8260), 1,
      anon_sym_AMP,
    ACTIONS(8264), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(5934), 1,
      sym__type_declarator,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(8067), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [168635] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8266), 1,
      sym_identifier,
    ACTIONS(8268), 1,
      anon_sym_LPAREN2,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(8272), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8274), 1,
      anon_sym_AMP,
    ACTIONS(8278), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2879), 1,
      sym__type_declarator,
    STATE(3288), 1,
      sym_pointer_type_declarator,
    STATE(8665), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8276), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3285), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [168708] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9130), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168799] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9132), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168890] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8330), 1,
      anon_sym_STAR,
    ACTIONS(8332), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8334), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6723), 1,
      sym__type_declarator,
    STATE(8527), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [168963] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9134), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169054] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8330), 1,
      anon_sym_STAR,
    ACTIONS(8332), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8334), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6753), 1,
      sym__type_declarator,
    STATE(8527), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [169127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5768), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [169172] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9136), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169263] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8330), 1,
      anon_sym_STAR,
    ACTIONS(8332), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8334), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6731), 1,
      sym__type_declarator,
    STATE(8527), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [169336] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9138), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169427] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4774), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169518] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5265), 1,
      sym_ms_call_modifier,
    STATE(5585), 1,
      sym__declarator,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(7288), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [169599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5772), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [169644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5742), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [169689] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4770), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5730), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [169825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5734), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [169870] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9140), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169961] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9142), 1,
      anon_sym_COMMA,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170052] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4879), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5738), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [170188] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5270), 1,
      sym_ms_call_modifier,
    STATE(5617), 1,
      sym__declarator,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(7376), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [170269] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9144), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170360] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    ACTIONS(9146), 1,
      anon_sym_RBRACK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170451] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4772), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170542] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9148), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170633] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9150), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170724] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4776), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170815] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8236), 1,
      sym_identifier,
    ACTIONS(8238), 1,
      anon_sym_LPAREN2,
    ACTIONS(8240), 1,
      anon_sym_STAR,
    ACTIONS(8242), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8250), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3083), 1,
      sym__type_declarator,
    STATE(3394), 1,
      sym_pointer_type_declarator,
    STATE(8712), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [170888] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5273), 1,
      sym_ms_call_modifier,
    STATE(5497), 1,
      sym__declarator,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(7469), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [170969] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5780), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [171105] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8236), 1,
      sym_identifier,
    ACTIONS(8238), 1,
      anon_sym_LPAREN2,
    ACTIONS(8240), 1,
      anon_sym_STAR,
    ACTIONS(8242), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8250), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3102), 1,
      sym__type_declarator,
    STATE(3394), 1,
      sym_pointer_type_declarator,
    STATE(8712), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171178] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    ACTIONS(8292), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2169), 1,
      sym__type_declarator,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(7984), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171251] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9152), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171342] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9154), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5776), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [171478] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5276), 1,
      sym_ms_call_modifier,
    STATE(5515), 1,
      sym__declarator,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(7531), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [171559] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9156), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171650] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9158), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171741] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    ACTIONS(9160), 1,
      anon_sym_RBRACK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171832] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9162), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171923] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4839), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6487), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6489), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [172059] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9164), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172150] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4782), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5653), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172286] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4887), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5752), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172422] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9166), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172513] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9168), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172604] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4802), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5756), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172740] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9170), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5760), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172876] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9172), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172967] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    ACTIONS(9174), 1,
      anon_sym_RBRACK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173058] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9176), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173149] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9178), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5452), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173285] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8266), 1,
      sym_identifier,
    ACTIONS(8268), 1,
      anon_sym_LPAREN2,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(8272), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8274), 1,
      anon_sym_AMP,
    ACTIONS(8278), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2889), 1,
      sym__type_declarator,
    STATE(3288), 1,
      sym_pointer_type_declarator,
    STATE(8665), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8276), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3285), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173358] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9180), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173449] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9184), 1,
      anon_sym___attribute__,
    ACTIONS(9187), 1,
      anon_sym___attribute,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9198), 1,
      anon_sym_requires,
    STATE(4914), 1,
      sym_ref_qualifier,
    STATE(5514), 1,
      sym_trailing_return_type,
    STATE(5670), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5278), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [173536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5784), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173581] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8318), 1,
      anon_sym_STAR,
    ACTIONS(8320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8322), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6531), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8441), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173652] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9201), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173743] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173834] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9205), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173925] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4778), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5655), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5657), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174061] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4809), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174152] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8318), 1,
      anon_sym_STAR,
    ACTIONS(8320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8322), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6533), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5865), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174223] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8318), 1,
      anon_sym_STAR,
    ACTIONS(8320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8322), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6534), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8445), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5661), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174339] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9207), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174430] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8318), 1,
      anon_sym_STAR,
    ACTIONS(8320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8322), 1,
      anon_sym_AMP,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6535), 1,
      sym__abstract_declarator,
    ACTIONS(7152), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6748), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7145), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174501] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9209), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174592] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9211), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174683] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(9184), 1,
      anon_sym___attribute__,
    ACTIONS(9187), 1,
      anon_sym___attribute,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(4939), 1,
      sym_ref_qualifier,
    STATE(5534), 1,
      sym_trailing_return_type,
    STATE(5655), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5247), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [174770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5673), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5675), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174815] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174906] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    ACTIONS(9213), 1,
      anon_sym_RBRACK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174997] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    ACTIONS(8292), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(2203), 1,
      sym__type_declarator,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(7984), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [175070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5788), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5679), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5687), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5694), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175250] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4883), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175341] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9215), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5790), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5792), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175477] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8568), 1,
      anon_sym_STAR,
    ACTIONS(8570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8572), 1,
      anon_sym_AMP,
    STATE(2677), 1,
      sym_decltype_auto,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6758), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4944), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8205), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [175554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7826), 1,
      sym_literal_suffix,
    ACTIONS(4154), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4146), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [175601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5796), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175646] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9217), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175737] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9219), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175828] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    ACTIONS(4970), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(4963), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [175879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5788), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175924] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9221), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176015] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(7564), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8925), 1,
      anon_sym_SLASH,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8941), 1,
      anon_sym_GT_EQ,
    ACTIONS(8947), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8951), 1,
      anon_sym_bitor,
    ACTIONS(8953), 1,
      anon_sym_bitand,
    ACTIONS(9223), 1,
      anon_sym_COLON,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(7566), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8921), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8923), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8943), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8939), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5679), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [176151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5679), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [176196] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5246), 1,
      sym_ms_call_modifier,
    STATE(5486), 1,
      sym__declarator,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(7346), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [176277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7036), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7038), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [176322] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9225), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176413] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9227), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176504] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(8749), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176595] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9229), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176686] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9231), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176777] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9233), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176868] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    ACTIONS(9235), 1,
      anon_sym_RBRACK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176959] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8256), 1,
      anon_sym_STAR,
    ACTIONS(8258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8260), 1,
      anon_sym_AMP,
    ACTIONS(8264), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(5912), 1,
      sym__type_declarator,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(8067), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177032] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9237), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177123] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9239), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177214] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9241), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177305] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8256), 1,
      anon_sym_STAR,
    ACTIONS(8258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8260), 1,
      anon_sym_AMP,
    ACTIONS(8264), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(5889), 1,
      sym__type_declarator,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(8067), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177378] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9243), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177469] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4821), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177560] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9245), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177651] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9247), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177742] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    ACTIONS(9249), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9251), 1,
      anon_sym_RBRACK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177833] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9253), 1,
      anon_sym_RPAREN,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177924] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(6829), 1,
      sym_auto,
    ACTIONS(6831), 1,
      anon_sym_decltype,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8568), 1,
      anon_sym_STAR,
    ACTIONS(8570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8572), 1,
      anon_sym_AMP,
    STATE(2677), 1,
      sym_decltype_auto,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6737), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4909), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8185), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [178001] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4881), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8815), 1,
      anon_sym_SLASH,
    ACTIONS(8821), 1,
      anon_sym_PIPE,
    ACTIONS(8825), 1,
      anon_sym_AMP,
    ACTIONS(8831), 1,
      anon_sym_GT_EQ,
    ACTIONS(8837), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8841), 1,
      anon_sym_bitor,
    ACTIONS(8843), 1,
      anon_sym_bitand,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178092] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9255), 1,
      anon_sym_COMMA,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178183] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9257), 1,
      anon_sym_COMMA,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178274] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9259), 1,
      anon_sym_COMMA,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178365] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9261), 1,
      anon_sym_COMMA,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178456] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9263), 1,
      anon_sym_COMMA,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178547] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    ACTIONS(9265), 1,
      anon_sym_SEMI,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178638] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9267), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6235), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(2051), 24,
      anon_sym_virtual,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_private,
      anon_sym_template,
      anon_sym_try,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [178687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6592), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6696), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178775] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym___asm,
    STATE(4956), 1,
      sym_ref_qualifier,
    STATE(5534), 1,
      sym_trailing_return_type,
    STATE(5703), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5290), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [178861] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5262), 1,
      sym_ms_call_modifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6475), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [178939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6608), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6610), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6612), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6614), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6616), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179071] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(5281), 1,
      sym_ms_call_modifier,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6672), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [179149] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5283), 1,
      sym_ms_call_modifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6474), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [179227] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    ACTIONS(6429), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8649), 1,
      anon_sym_SLASH,
    ACTIONS(8653), 1,
      anon_sym_AMP,
    ACTIONS(8659), 1,
      anon_sym_GT_EQ,
    ACTIONS(8663), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8665), 1,
      anon_sym_bitand,
    ACTIONS(8669), 1,
      anon_sym_PIPE,
    ACTIONS(8671), 1,
      anon_sym_bitor,
    ACTIONS(8683), 1,
      anon_sym_QMARK,
    STATE(2525), 1,
      sym_argument_list,
    STATE(2526), 1,
      sym_subscript_argument_list,
    ACTIONS(6433), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8045), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8645), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8647), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8651), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8661), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8667), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8655), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8657), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179315] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 1,
      anon_sym_SEMI,
    ACTIONS(7081), 1,
      sym_literal_suffix,
    ACTIONS(4154), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4146), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [179363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3891), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179407] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym___asm,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4974), 1,
      sym_ref_qualifier,
    STATE(5453), 1,
      sym_trailing_return_type,
    STATE(5663), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5301), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [179493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6594), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6596), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179537] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5266), 1,
      sym_ms_call_modifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6431), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [179615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6620), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6622), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6624), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6716), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9279), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6178), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6180), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179793] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5271), 1,
      sym_ms_call_modifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6439), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [179871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6634), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179915] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5252), 1,
      sym_ms_call_modifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6432), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [179993] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    ACTIONS(8602), 1,
      anon_sym_STAR,
    ACTIONS(8604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6788), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8205), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(4971), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [180069] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5274), 1,
      sym_ms_call_modifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6462), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [180147] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5279), 1,
      sym_ms_call_modifier,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6445), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [180225] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym___asm,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9281), 1,
      anon_sym_requires,
    STATE(4953), 1,
      sym_ref_qualifier,
    STATE(5447), 1,
      sym_trailing_return_type,
    STATE(5678), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5284), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [180311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6638), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180355] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9198), 1,
      anon_sym_requires,
    STATE(4969), 1,
      sym_ref_qualifier,
    STATE(5514), 1,
      sym_trailing_return_type,
    STATE(5953), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5292), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [180441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6640), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6642), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6646), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6650), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6652), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6654), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6656), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6658), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6662), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6664), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6666), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6668), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6670), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180793] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9284), 1,
      anon_sym_COMMA,
    ACTIONS(9286), 1,
      anon_sym_RBRACK,
    ACTIONS(4154), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4146), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [180841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6678), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6682), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6526), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6522), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181017] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8367), 1,
      anon_sym_STAR,
    ACTIONS(8369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8371), 1,
      anon_sym_AMP,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6621), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8441), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [181087] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8367), 1,
      anon_sym_STAR,
    ACTIONS(8369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8371), 1,
      anon_sym_AMP,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6623), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5865), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [181157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6578), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6580), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181201] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8367), 1,
      anon_sym_STAR,
    ACTIONS(8369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8371), 1,
      anon_sym_AMP,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6624), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8445), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [181271] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_const,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8367), 1,
      anon_sym_STAR,
    ACTIONS(8369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8371), 1,
      anon_sym_AMP,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(3992), 1,
      sym_alignas_qualifier,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6625), 1,
      sym__abstract_declarator,
    ACTIONS(7061), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3727), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6748), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7046), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [181341] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(4954), 1,
      sym_ref_qualifier,
    STATE(5534), 1,
      sym_trailing_return_type,
    STATE(5963), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5289), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [181427] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9198), 1,
      anon_sym_requires,
    ACTIONS(9273), 1,
      anon_sym___asm,
    STATE(4966), 1,
      sym_ref_qualifier,
    STATE(5514), 1,
      sym_trailing_return_type,
    STATE(5714), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5298), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [181513] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9279), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9289), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6253), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6255), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181561] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    ACTIONS(8991), 1,
      anon_sym_LBRACE,
    STATE(4870), 1,
      sym_enumerator_list,
    STATE(4915), 1,
      sym_attribute_specifier,
    ACTIONS(6024), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6026), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [181615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6572), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6558), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6560), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4146), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181747] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 1,
      anon_sym_SEMI,
    ACTIONS(5036), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5946), 1,
      anon_sym_LPAREN2,
    ACTIONS(5949), 1,
      anon_sym_LBRACK,
    ACTIONS(4154), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4146), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [181799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6708), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5442), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2685), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6564), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6582), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6584), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6530), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [182019] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    ACTIONS(8991), 1,
      anon_sym_LBRACE,
    STATE(4884), 1,
      sym_enumerator_list,
    STATE(4913), 1,
      sym_attribute_specifier,
    ACTIONS(5983), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5985), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [182073] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    ACTIONS(8602), 1,
      anon_sym_STAR,
    ACTIONS(8604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6807), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8185), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(4964), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6586), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6588), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [182193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6686), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [182237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6568), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [182281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6672), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6674), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [182325] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6146), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8049), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182394] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    ACTIONS(9300), 1,
      anon_sym_requires,
    STATE(5031), 1,
      sym_ref_qualifier,
    STATE(5932), 1,
      sym_trailing_return_type,
    STATE(5943), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5318), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [182479] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4925), 1,
      sym_attribute_specifier,
    ACTIONS(6129), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6131), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [182528] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    ACTIONS(8205), 1,
      anon_sym_COLON,
    ACTIONS(8685), 1,
      anon_sym_STAR,
    ACTIONS(8687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8689), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6886), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4997), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182603] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(9303), 1,
      anon_sym_COLON,
    STATE(1841), 1,
      sym_attribute_specifier,
    STATE(4961), 1,
      sym__enum_base_clause,
    STATE(5154), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6338), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6336), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [182658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
    ACTIONS(4963), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4970), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [182707] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8473), 1,
      anon_sym_STAR,
    ACTIONS(8475), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8477), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6701), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6748), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182776] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6137), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8049), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 1,
      anon_sym_SEMI,
    ACTIONS(4154), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4146), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [182890] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8459), 1,
      sym_identifier,
    ACTIONS(8461), 1,
      anon_sym_STAR,
    ACTIONS(8463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8465), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6677), 1,
      sym__field_declarator,
    STATE(6800), 1,
      sym_operator_name,
    STATE(8225), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8479), 1,
      sym_auto,
    ACTIONS(8481), 1,
      anon_sym_decltype,
    STATE(4924), 1,
      sym_decltype_auto,
    ACTIONS(5589), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5591), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183008] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(5029), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5979), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5977), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [183059] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6687), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5865), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183128] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6690), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6748), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4916), 1,
      sym_attribute_specifier,
    ACTIONS(6151), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6153), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183246] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5000), 1,
      sym_ref_qualifier,
    STATE(5909), 1,
      sym_trailing_return_type,
    STATE(6127), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5307), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [183331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4940), 1,
      sym_attribute_specifier,
    ACTIONS(6062), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6064), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5629), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5631), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183423] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      sym_auto,
    ACTIONS(8151), 1,
      anon_sym_decltype,
    ACTIONS(8185), 1,
      anon_sym_COLON,
    ACTIONS(8685), 1,
      anon_sym_STAR,
    ACTIONS(8687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8689), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(1884), 1,
      sym_decltype_auto,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6857), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183498] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8459), 1,
      sym_identifier,
    ACTIONS(8461), 1,
      anon_sym_STAR,
    ACTIONS(8463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8465), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6681), 1,
      sym__field_declarator,
    STATE(6800), 1,
      sym_operator_name,
    STATE(8225), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183567] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4926), 1,
      sym_attribute_specifier,
    ACTIONS(6117), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6119), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183616] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(9305), 1,
      anon_sym_COLON,
    STATE(2551), 1,
      sym__enum_base_clause,
    STATE(2642), 1,
      sym_enumerator_list,
    STATE(2696), 1,
      sym_attribute_specifier,
    ACTIONS(6342), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6344), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [183673] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(5040), 1,
      sym_ref_qualifier,
    STATE(5453), 1,
      sym_trailing_return_type,
    STATE(5881), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5312), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [183758] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      sym_identifier,
    ACTIONS(9313), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(4984), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6331), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5100), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9310), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5102), 6,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6326), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183817] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9281), 1,
      anon_sym_requires,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(4989), 1,
      sym_ref_qualifier,
    STATE(5447), 1,
      sym_trailing_return_type,
    STATE(5882), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5332), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [183902] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(9303), 1,
      anon_sym_COLON,
    STATE(1866), 1,
      sym_attribute_specifier,
    STATE(4962), 1,
      sym__enum_base_clause,
    STATE(5048), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6344), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6342), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [183957] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4936), 1,
      sym_attribute_specifier,
    ACTIONS(6090), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6092), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184006] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8373), 1,
      anon_sym_STAR,
    ACTIONS(8375), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8377), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6702), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1655), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8441), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4900), 1,
      sym_attribute_specifier,
    ACTIONS(6058), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6060), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184124] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8373), 1,
      anon_sym_STAR,
    ACTIONS(8375), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8377), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6650), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1655), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5865), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184193] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9300), 1,
      anon_sym_requires,
    STATE(5013), 1,
      sym_ref_qualifier,
    STATE(5932), 1,
      sym_trailing_return_type,
    STATE(6099), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5329), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [184278] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8459), 1,
      sym_identifier,
    ACTIONS(8461), 1,
      anon_sym_STAR,
    ACTIONS(8463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8465), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6693), 1,
      sym__field_declarator,
    STATE(6800), 1,
      sym_operator_name,
    STATE(8225), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184347] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6645), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8445), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184416] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8473), 1,
      anon_sym_STAR,
    ACTIONS(8475), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8477), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6698), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5865), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184485] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym___attribute__,
    ACTIONS(6360), 1,
      anon_sym___attribute,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(9305), 1,
      anon_sym_COLON,
    STATE(2549), 1,
      sym__enum_base_clause,
    STATE(2634), 1,
      sym_enumerator_list,
    STATE(2682), 1,
      sym_attribute_specifier,
    ACTIONS(6336), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6338), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [184542] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4934), 1,
      sym_attribute_specifier,
    ACTIONS(6155), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6157), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184591] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4912), 1,
      sym_attribute_specifier,
    ACTIONS(6121), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6123), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184640] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9316), 1,
      anon_sym_requires,
    STATE(4992), 1,
      sym_ref_qualifier,
    STATE(6023), 1,
      sym__function_attributes_end,
    STATE(6254), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5322), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [184725] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(4175), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4144), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8310), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4152), 23,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [184778] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8373), 1,
      anon_sym_STAR,
    ACTIONS(8375), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8377), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6704), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1655), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8445), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184847] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9319), 1,
      sym_identifier,
    ACTIONS(9325), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(5038), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6391), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4865), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5086), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9322), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5088), 6,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6386), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184906] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(5003), 1,
      sym_ref_qualifier,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6169), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5325), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [184991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4899), 1,
      sym_attribute_specifier,
    ACTIONS(6096), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6098), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185040] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4920), 1,
      sym_attribute_specifier,
    ACTIONS(6125), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6127), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4908), 1,
      sym_attribute_specifier,
    ACTIONS(6168), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6170), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185138] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9331), 1,
      sym_identifier,
    ACTIONS(9333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9337), 1,
      anon_sym_EQ,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5559), 1,
      sym_ms_declspec_modifier,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9335), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5560), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5173), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym___attribute__,
    ACTIONS(8876), 1,
      anon_sym___attribute,
    STATE(4905), 1,
      sym_attribute_specifier,
    ACTIONS(6104), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6106), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185278] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8373), 1,
      anon_sym_STAR,
    ACTIONS(8375), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8377), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6656), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1655), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6748), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [185347] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6014), 1,
      anon_sym___attribute__,
    ACTIONS(6016), 1,
      anon_sym___attribute,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(9339), 1,
      anon_sym_COLON,
    STATE(1841), 1,
      sym_attribute_specifier,
    STATE(2281), 1,
      sym__enum_base_clause,
    STATE(2329), 1,
      sym_enumerator_list,
    ACTIONS(6336), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6338), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [185404] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6673), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8441), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [185473] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5039), 1,
      sym_ref_qualifier,
    STATE(6011), 1,
      sym__function_attributes_end,
    STATE(6252), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5310), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [185558] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5041), 1,
      sym_ref_qualifier,
    STATE(6013), 1,
      sym_trailing_return_type,
    STATE(6133), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5305), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [185643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5450), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5452), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
    ACTIONS(5838), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_const,
    ACTIONS(4172), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [185737] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(5037), 1,
      sym_ref_qualifier,
    STATE(5909), 1,
      sym_trailing_return_type,
    STATE(5976), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5315), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [185822] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6014), 1,
      anon_sym___attribute__,
    ACTIONS(6016), 1,
      anon_sym___attribute,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(9339), 1,
      anon_sym_COLON,
    STATE(1866), 1,
      sym_attribute_specifier,
    STATE(2216), 1,
      sym__enum_base_clause,
    STATE(2311), 1,
      sym_enumerator_list,
    ACTIONS(6342), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6344), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [185879] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6152), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8049), 1,
      sym_ms_based_modifier,
    ACTIONS(3333), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3331), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [185948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5639), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5742), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186032] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8568), 1,
      anon_sym_STAR,
    ACTIONS(8570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8572), 1,
      anon_sym_AMP,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6762), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6748), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [186100] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9341), 1,
      anon_sym_requires,
    STATE(5100), 1,
      sym_ref_qualifier,
    STATE(6188), 1,
      sym_trailing_return_type,
    STATE(6211), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5340), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [186184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5730), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5679), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5667), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5669), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5752), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186352] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8568), 1,
      anon_sym_STAR,
    ACTIONS(8570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8572), 1,
      anon_sym_AMP,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6760), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5865), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [186420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5665), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186462] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8568), 1,
      anon_sym_STAR,
    ACTIONS(8570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8572), 1,
      anon_sym_AMP,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6718), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8445), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [186530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5681), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5683), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186572] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9184), 1,
      anon_sym___attribute__,
    ACTIONS(9187), 1,
      anon_sym___attribute,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9198), 1,
      anon_sym_requires,
    STATE(5514), 1,
      sym_trailing_return_type,
    STATE(5670), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5278), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [186650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5756), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5760), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186734] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9346), 1,
      anon_sym___attribute__,
    ACTIONS(9349), 1,
      anon_sym___attribute,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9360), 1,
      anon_sym_requires,
    STATE(5544), 1,
      sym_trailing_return_type,
    STATE(5671), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5280), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [186812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5812), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5655), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5657), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5784), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5788), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5452), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5790), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5792), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5643), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5804), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5772), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5798), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5800), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5796), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5734), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5738), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5788), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5762), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5764), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5673), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5675), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5768), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5679), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5776), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5687), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5649), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5808), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5661), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187778] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5138), 1,
      sym_ref_qualifier,
    STATE(6175), 1,
      sym__function_attributes_end,
    STATE(6207), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5336), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [187862] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(9346), 1,
      anon_sym___attribute__,
    ACTIONS(9349), 1,
      anon_sym___attribute,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(5616), 1,
      sym_trailing_return_type,
    STATE(5658), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5248), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [187940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5780), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5694), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [188024] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1884), 1,
      anon_sym_enum,
    ACTIONS(1886), 1,
      anon_sym_class,
    ACTIONS(1888), 1,
      anon_sym_struct,
    ACTIONS(1890), 1,
      anon_sym_union,
    ACTIONS(1914), 1,
      anon_sym_typename,
    ACTIONS(2999), 1,
      sym_primitive_type,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9337), 1,
      anon_sym_EQ,
    ACTIONS(9363), 1,
      sym_identifier,
    STATE(2359), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2393), 1,
      sym_type_specifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(3015), 1,
      sym_qualified_type_identifier,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    ACTIONS(9335), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [188108] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(9184), 1,
      anon_sym___attribute__,
    ACTIONS(9187), 1,
      anon_sym___attribute,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5534), 1,
      sym_trailing_return_type,
    STATE(5655), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5247), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [188186] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8568), 1,
      anon_sym_STAR,
    ACTIONS(8570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8572), 1,
      anon_sym_AMP,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6741), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8441), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [188254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5677), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5679), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [188296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5653), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [188338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5452), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [188380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5699), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5701), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [188422] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(8679), 1,
      anon_sym_LBRACE,
    ACTIONS(9365), 1,
      anon_sym_COLON,
    STATE(4382), 1,
      sym__enum_base_clause,
    STATE(4514), 1,
      sym_enumerator_list,
    STATE(4720), 1,
      sym_attribute_specifier,
    ACTIONS(6336), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6338), 23,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [188477] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(8679), 1,
      anon_sym_LBRACE,
    ACTIONS(9365), 1,
      anon_sym_COLON,
    STATE(4358), 1,
      sym__enum_base_clause,
    STATE(4471), 1,
      sym_enumerator_list,
    STATE(4667), 1,
      sym_attribute_specifier,
    ACTIONS(6342), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6344), 23,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [188532] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym___asm,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9281), 1,
      anon_sym_requires,
    STATE(5447), 1,
      sym_trailing_return_type,
    STATE(5678), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5284), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [188609] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9198), 1,
      anon_sym_requires,
    STATE(5514), 1,
      sym_trailing_return_type,
    STATE(5953), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5292), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [188686] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9373), 1,
      anon_sym___asm,
    ACTIONS(9376), 1,
      anon_sym_requires,
    STATE(5448), 1,
      sym_trailing_return_type,
    STATE(5679), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9370), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5286), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [188763] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(5616), 1,
      sym_trailing_return_type,
    STATE(5966), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5296), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [188840] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    ACTIONS(9341), 1,
      anon_sym_requires,
    STATE(5223), 1,
      sym_ref_qualifier,
    STATE(6123), 1,
      sym__function_attributes_end,
    STATE(6188), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5359), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [188923] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9373), 1,
      anon_sym___asm,
    STATE(5616), 1,
      sym_trailing_return_type,
    STATE(5706), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9370), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5295), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [189000] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(5203), 1,
      sym_ref_qualifier,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6101), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5363), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [189083] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8602), 1,
      anon_sym_STAR,
    ACTIONS(8604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6789), 1,
      sym__abstract_declarator,
    ACTIONS(5865), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [189150] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym___asm,
    STATE(5534), 1,
      sym_trailing_return_type,
    STATE(5703), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5290), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [189227] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(5192), 1,
      sym_ref_qualifier,
    STATE(6114), 1,
      sym__function_attributes_end,
    STATE(6207), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5346), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [189310] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    STATE(1872), 1,
      sym_attribute_specifier,
    STATE(5050), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5985), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5983), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [189359] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    STATE(1887), 1,
      sym_attribute_specifier,
    STATE(5053), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6026), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6024), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [189408] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8602), 1,
      anon_sym_STAR,
    ACTIONS(8604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6794), 1,
      sym__abstract_declarator,
    ACTIONS(6748), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [189475] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8602), 1,
      anon_sym_STAR,
    ACTIONS(8604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6825), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8445), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [189542] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9198), 1,
      anon_sym_requires,
    ACTIONS(9273), 1,
      anon_sym___asm,
    STATE(5514), 1,
      sym_trailing_return_type,
    STATE(5714), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5298), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [189619] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9360), 1,
      anon_sym_requires,
    ACTIONS(9373), 1,
      anon_sym___asm,
    STATE(5544), 1,
      sym_trailing_return_type,
    STATE(5715), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9370), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5299), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [189696] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9281), 1,
      anon_sym_requires,
    STATE(5210), 1,
      sym_ref_qualifier,
    STATE(5447), 1,
      sym_trailing_return_type,
    STATE(6204), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5349), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [189779] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym___asm,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5453), 1,
      sym_trailing_return_type,
    STATE(5663), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5301), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [189856] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9360), 1,
      anon_sym_requires,
    STATE(5544), 1,
      sym_trailing_return_type,
    STATE(5958), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5294), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [189933] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5534), 1,
      sym_trailing_return_type,
    STATE(5963), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5289), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [190010] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_const,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8602), 1,
      anon_sym_STAR,
    ACTIONS(8604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(4289), 1,
      sym_alignas_qualifier,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6837), 1,
      sym__abstract_declarator,
    ACTIONS(8133), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8441), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(4131), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [190077] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5181), 1,
      sym_ref_qualifier,
    STATE(5453), 1,
      sym_trailing_return_type,
    STATE(6200), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5369), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [190160] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(5198), 1,
      sym_ref_qualifier,
    STATE(6013), 1,
      sym_trailing_return_type,
    STATE(6095), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5344), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [190243] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9373), 1,
      anon_sym___asm,
    STATE(5418), 1,
      sym_trailing_return_type,
    STATE(5664), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9370), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5300), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [190320] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    ACTIONS(9379), 1,
      anon_sym_LPAREN2,
    STATE(2332), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3598), 1,
      sym_argument_list,
    STATE(4839), 1,
      sym_initializer_list,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5452), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [190373] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8445), 1,
      anon_sym_COLON,
    ACTIONS(8685), 1,
      anon_sym_STAR,
    ACTIONS(8687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8689), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6873), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1655), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [190439] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(5238), 1,
      sym_ref_qualifier,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6372), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5391), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [190521] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9382), 1,
      sym_identifier,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9388), 1,
      sym_primitive_type,
    ACTIONS(9390), 1,
      anon_sym_enum,
    ACTIONS(9392), 1,
      anon_sym_class,
    ACTIONS(9394), 1,
      anon_sym_struct,
    ACTIONS(9396), 1,
      anon_sym_union,
    ACTIONS(9398), 1,
      sym_auto,
    ACTIONS(9400), 1,
      anon_sym_decltype,
    ACTIONS(9402), 1,
      anon_sym_typename,
    STATE(1592), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1911), 1,
      sym_type_specifier,
    STATE(2273), 1,
      sym_qualified_type_identifier,
    STATE(2309), 1,
      sym_decltype_auto,
    STATE(5186), 1,
      sym_argument_list,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2174), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9386), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2245), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190601] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(8051), 1,
      sym_primitive_type,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9404), 1,
      sym_identifier,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9410), 1,
      anon_sym_enum,
    ACTIONS(9412), 1,
      anon_sym_class,
    ACTIONS(9414), 1,
      anon_sym_struct,
    ACTIONS(9416), 1,
      anon_sym_union,
    ACTIONS(9418), 1,
      anon_sym_typename,
    STATE(2170), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(4133), 1,
      sym_type_specifier,
    STATE(5197), 1,
      sym_argument_list,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9408), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190681] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(5029), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4152), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9420), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4144), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [190731] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7961), 1,
      sym_primitive_type,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9422), 1,
      sym_identifier,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_class,
    ACTIONS(9432), 1,
      anon_sym_struct,
    ACTIONS(9434), 1,
      anon_sym_union,
    ACTIONS(9436), 1,
      anon_sym_typename,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1869), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4086), 1,
      sym_type_specifier,
    STATE(5182), 1,
      sym_argument_list,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190811] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9438), 1,
      sym_identifier,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9444), 1,
      sym_primitive_type,
    ACTIONS(9446), 1,
      anon_sym_enum,
    ACTIONS(9448), 1,
      anon_sym_class,
    ACTIONS(9450), 1,
      anon_sym_struct,
    ACTIONS(9452), 1,
      anon_sym_union,
    ACTIONS(9454), 1,
      sym_auto,
    ACTIONS(9456), 1,
      anon_sym_decltype,
    ACTIONS(9458), 1,
      anon_sym_typename,
    STATE(1625), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2784), 1,
      sym_type_specifier,
    STATE(3111), 1,
      sym_decltype_auto,
    STATE(3113), 1,
      sym_qualified_type_identifier,
    STATE(5162), 1,
      sym_argument_list,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(3044), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9442), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3114), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190891] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9438), 1,
      sym_identifier,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9444), 1,
      sym_primitive_type,
    ACTIONS(9446), 1,
      anon_sym_enum,
    ACTIONS(9448), 1,
      anon_sym_class,
    ACTIONS(9450), 1,
      anon_sym_struct,
    ACTIONS(9452), 1,
      anon_sym_union,
    ACTIONS(9454), 1,
      sym_auto,
    ACTIONS(9456), 1,
      anon_sym_decltype,
    ACTIONS(9458), 1,
      anon_sym_typename,
    STATE(1625), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2826), 1,
      sym_type_specifier,
    STATE(3111), 1,
      sym_decltype_auto,
    STATE(3113), 1,
      sym_qualified_type_identifier,
    STATE(5206), 1,
      sym_argument_list,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(3044), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9442), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3114), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5926), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9460), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5928), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [191015] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5023), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5902), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9463), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5904), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [191059] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6858), 1,
      sym_identifier,
    ACTIONS(6862), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(3075), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5100), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_GT2,
    ACTIONS(5102), 4,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6860), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191115] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9281), 1,
      anon_sym_requires,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(5447), 1,
      sym_trailing_return_type,
    STATE(5882), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5332), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [191191] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7961), 1,
      sym_primitive_type,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9422), 1,
      sym_identifier,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_class,
    ACTIONS(9432), 1,
      anon_sym_struct,
    ACTIONS(9434), 1,
      anon_sym_union,
    ACTIONS(9436), 1,
      anon_sym_typename,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1869), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(3934), 1,
      sym_type_specifier,
    STATE(5230), 1,
      sym_argument_list,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191271] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9376), 1,
      anon_sym_requires,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    STATE(5448), 1,
      sym_trailing_return_type,
    STATE(5883), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5333), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [191347] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7961), 1,
      sym_primitive_type,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9422), 1,
      sym_identifier,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_class,
    ACTIONS(9432), 1,
      anon_sym_struct,
    ACTIONS(9434), 1,
      anon_sym_union,
    ACTIONS(9436), 1,
      anon_sym_typename,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1869), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4103), 1,
      sym_type_specifier,
    STATE(5174), 1,
      sym_argument_list,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191427] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5236), 1,
      sym_ref_qualifier,
    STATE(6013), 1,
      sym_trailing_return_type,
    STATE(6360), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5383), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [191509] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9472), 1,
      anon_sym_requires,
    STATE(6036), 1,
      sym__function_attributes_end,
    STATE(6260), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5323), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [191585] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5909), 1,
      sym_trailing_return_type,
    STATE(6127), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5307), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [191661] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9382), 1,
      sym_identifier,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9388), 1,
      sym_primitive_type,
    ACTIONS(9390), 1,
      anon_sym_enum,
    ACTIONS(9392), 1,
      anon_sym_class,
    ACTIONS(9394), 1,
      anon_sym_struct,
    ACTIONS(9396), 1,
      anon_sym_union,
    ACTIONS(9398), 1,
      sym_auto,
    ACTIONS(9400), 1,
      anon_sym_decltype,
    ACTIONS(9402), 1,
      anon_sym_typename,
    STATE(1592), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1892), 1,
      sym_type_specifier,
    STATE(2273), 1,
      sym_qualified_type_identifier,
    STATE(2309), 1,
      sym_decltype_auto,
    STATE(5218), 1,
      sym_argument_list,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2174), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9386), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2245), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5888), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9475), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [191785] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(5865), 1,
      anon_sym_COLON,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8685), 1,
      anon_sym_STAR,
    ACTIONS(8687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8689), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6905), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1655), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191851] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_COLON,
    ACTIONS(8685), 1,
      anon_sym_STAR,
    ACTIONS(8687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8689), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6868), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1655), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191917] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9478), 1,
      anon_sym_requires,
    STATE(5254), 1,
      sym_ref_qualifier,
    STATE(6315), 1,
      sym__function_attributes_end,
    STATE(6471), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5377), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [191999] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9392), 1,
      anon_sym_class,
    ACTIONS(9394), 1,
      anon_sym_struct,
    ACTIONS(9396), 1,
      anon_sym_union,
    ACTIONS(9398), 1,
      sym_auto,
    ACTIONS(9400), 1,
      anon_sym_decltype,
    ACTIONS(9481), 1,
      sym_identifier,
    ACTIONS(9485), 1,
      sym_primitive_type,
    ACTIONS(9487), 1,
      anon_sym_enum,
    ACTIONS(9489), 1,
      anon_sym_typename,
    STATE(1594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1892), 1,
      sym_type_specifier,
    STATE(2273), 1,
      sym_qualified_type_identifier,
    STATE(2309), 1,
      sym_decltype_auto,
    STATE(5167), 1,
      sym_argument_list,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2174), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9483), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2245), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192079] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(5927), 1,
      sym_trailing_return_type,
    STATE(6104), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5308), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [192155] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9392), 1,
      anon_sym_class,
    ACTIONS(9394), 1,
      anon_sym_struct,
    ACTIONS(9396), 1,
      anon_sym_union,
    ACTIONS(9398), 1,
      sym_auto,
    ACTIONS(9400), 1,
      anon_sym_decltype,
    ACTIONS(9481), 1,
      sym_identifier,
    ACTIONS(9485), 1,
      sym_primitive_type,
    ACTIONS(9487), 1,
      anon_sym_enum,
    ACTIONS(9489), 1,
      anon_sym_typename,
    STATE(1594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1911), 1,
      sym_type_specifier,
    STATE(2273), 1,
      sym_qualified_type_identifier,
    STATE(2309), 1,
      sym_decltype_auto,
    STATE(5208), 1,
      sym_argument_list,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2174), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9483), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2245), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192235] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5593), 1,
      sym_auto,
    ACTIONS(5595), 1,
      anon_sym_decltype,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1884), 1,
      sym_decltype_auto,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9493), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9491), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [192289] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6063), 1,
      sym_trailing_return_type,
    STATE(6150), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5326), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [192365] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9316), 1,
      anon_sym_requires,
    STATE(6023), 1,
      sym__function_attributes_end,
    STATE(6254), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5322), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [192441] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9300), 1,
      anon_sym_requires,
    STATE(5932), 1,
      sym_trailing_return_type,
    STATE(6099), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5329), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [192517] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9501), 1,
      sym_identifier,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9507), 1,
      sym_primitive_type,
    ACTIONS(9509), 1,
      anon_sym_enum,
    ACTIONS(9511), 1,
      anon_sym_class,
    ACTIONS(9513), 1,
      anon_sym_struct,
    ACTIONS(9515), 1,
      anon_sym_union,
    ACTIONS(9517), 1,
      sym_auto,
    ACTIONS(9519), 1,
      anon_sym_decltype,
    ACTIONS(9521), 1,
      anon_sym_typename,
    STATE(1619), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2718), 1,
      sym_type_specifier,
    STATE(2976), 1,
      sym_decltype_auto,
    STATE(2983), 1,
      sym_qualified_type_identifier,
    STATE(5185), 1,
      sym_argument_list,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2924), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9505), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2978), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192597] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5016), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5936), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9523), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5938), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [192641] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7961), 1,
      sym_primitive_type,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9422), 1,
      sym_identifier,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_class,
    ACTIONS(9432), 1,
      anon_sym_struct,
    ACTIONS(9434), 1,
      anon_sym_union,
    ACTIONS(9436), 1,
      anon_sym_typename,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1869), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(3949), 1,
      sym_type_specifier,
    STATE(5188), 1,
      sym_argument_list,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192721] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym_const,
    ACTIONS(6748), 1,
      anon_sym_COLON,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8685), 1,
      anon_sym_STAR,
    ACTIONS(8687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8689), 1,
      anon_sym_AMP,
    STATE(1695), 1,
      sym_alignas_qualifier,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6879), 1,
      sym__abstract_declarator,
    ACTIONS(8387), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1655), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8379), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [192787] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9532), 1,
      sym_primitive_type,
    ACTIONS(9534), 1,
      anon_sym_enum,
    ACTIONS(9536), 1,
      anon_sym_class,
    ACTIONS(9538), 1,
      anon_sym_struct,
    ACTIONS(9540), 1,
      anon_sym_union,
    ACTIONS(9542), 1,
      sym_auto,
    ACTIONS(9544), 1,
      anon_sym_decltype,
    ACTIONS(9546), 1,
      anon_sym_typename,
    STATE(1637), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2955), 1,
      sym_type_specifier,
    STATE(3491), 1,
      sym_decltype_auto,
    STATE(3507), 1,
      sym_qualified_type_identifier,
    STATE(5191), 1,
      sym_argument_list,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(3329), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9530), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3504), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192867] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5261), 1,
      sym_ref_qualifier,
    STATE(6333), 1,
      sym__function_attributes_end,
    STATE(6455), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5373), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [192949] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(8051), 1,
      sym_primitive_type,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9404), 1,
      sym_identifier,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9410), 1,
      anon_sym_enum,
    ACTIONS(9412), 1,
      anon_sym_class,
    ACTIONS(9414), 1,
      anon_sym_struct,
    ACTIONS(9416), 1,
      anon_sym_union,
    ACTIONS(9418), 1,
      anon_sym_typename,
    STATE(2170), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(4121), 1,
      sym_type_specifier,
    STATE(5226), 1,
      sym_argument_list,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9408), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193029] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(5904), 1,
      sym_trailing_return_type,
    STATE(6108), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5330), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [193105] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9501), 1,
      sym_identifier,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9507), 1,
      sym_primitive_type,
    ACTIONS(9509), 1,
      anon_sym_enum,
    ACTIONS(9511), 1,
      anon_sym_class,
    ACTIONS(9513), 1,
      anon_sym_struct,
    ACTIONS(9515), 1,
      anon_sym_union,
    ACTIONS(9517), 1,
      sym_auto,
    ACTIONS(9519), 1,
      anon_sym_decltype,
    ACTIONS(9521), 1,
      anon_sym_typename,
    STATE(1619), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2709), 1,
      sym_type_specifier,
    STATE(2976), 1,
      sym_decltype_auto,
    STATE(2983), 1,
      sym_qualified_type_identifier,
    STATE(5221), 1,
      sym_argument_list,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2924), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9505), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2978), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4995), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5752), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5750), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [193227] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5942), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9551), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5944), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [193271] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(6013), 1,
      sym_trailing_return_type,
    STATE(6133), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5305), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [193347] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5593), 1,
      sym_auto,
    ACTIONS(5595), 1,
      anon_sym_decltype,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(1884), 1,
      sym_decltype_auto,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5239), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9556), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9554), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [193401] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9558), 1,
      sym_ms_restrict_modifier,
    STATE(5267), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7777), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9561), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9564), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5019), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7779), 22,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [193451] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6011), 1,
      sym__function_attributes_end,
    STATE(6252), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5310), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [193527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5024), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5920), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9567), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5922), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [193571] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9532), 1,
      sym_primitive_type,
    ACTIONS(9534), 1,
      anon_sym_enum,
    ACTIONS(9536), 1,
      anon_sym_class,
    ACTIONS(9538), 1,
      anon_sym_struct,
    ACTIONS(9540), 1,
      anon_sym_union,
    ACTIONS(9542), 1,
      sym_auto,
    ACTIONS(9544), 1,
      anon_sym_decltype,
    ACTIONS(9546), 1,
      anon_sym_typename,
    STATE(1637), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2961), 1,
      sym_type_specifier,
    STATE(3491), 1,
      sym_decltype_auto,
    STATE(3507), 1,
      sym_qualified_type_identifier,
    STATE(5214), 1,
      sym_argument_list,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(3329), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9530), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3504), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5908), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9570), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5910), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [193695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5916), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9573), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5918), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [193739] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9582), 1,
      sym_primitive_type,
    ACTIONS(9584), 1,
      anon_sym_enum,
    ACTIONS(9586), 1,
      anon_sym_class,
    ACTIONS(9588), 1,
      anon_sym_struct,
    ACTIONS(9590), 1,
      anon_sym_union,
    ACTIONS(9592), 1,
      sym_auto,
    ACTIONS(9594), 1,
      anon_sym_decltype,
    ACTIONS(9596), 1,
      anon_sym_typename,
    STATE(1860), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(3823), 1,
      sym_type_specifier,
    STATE(4081), 1,
      sym_decltype_auto,
    STATE(5227), 1,
      sym_argument_list,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(4024), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193819] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6169), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5325), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [193895] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    ACTIONS(9300), 1,
      anon_sym_requires,
    STATE(5932), 1,
      sym_trailing_return_type,
    STATE(5943), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5318), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [193971] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(5453), 1,
      sym_trailing_return_type,
    STATE(5881), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5312), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [194047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5898), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9598), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5900), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [194091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5894), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9601), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [194135] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(5904), 1,
      sym_trailing_return_type,
    STATE(5944), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5319), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [194211] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6852), 1,
      sym_identifier,
    ACTIONS(6856), 1,
      sym_primitive_type,
    STATE(1658), 1,
      sym_alignas_qualifier,
    STATE(5258), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4986), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5086), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_GT2,
    ACTIONS(5088), 4,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(9604), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [194267] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9582), 1,
      sym_primitive_type,
    ACTIONS(9584), 1,
      anon_sym_enum,
    ACTIONS(9586), 1,
      anon_sym_class,
    ACTIONS(9588), 1,
      anon_sym_struct,
    ACTIONS(9590), 1,
      anon_sym_union,
    ACTIONS(9592), 1,
      sym_auto,
    ACTIONS(9594), 1,
      anon_sym_decltype,
    ACTIONS(9596), 1,
      anon_sym_typename,
    STATE(1860), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(3822), 1,
      sym_type_specifier,
    STATE(4081), 1,
      sym_decltype_auto,
    STATE(5160), 1,
      sym_argument_list,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(4024), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [194347] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(5909), 1,
      sym_trailing_return_type,
    STATE(5976), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5315), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [194423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5030), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5930), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9606), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5932), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [194467] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7044), 1,
      anon_sym_AMP,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(5256), 1,
      sym_ref_qualifier,
    STATE(6388), 1,
      sym__function_attributes_end,
    STATE(6562), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5387), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [194549] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    STATE(5927), 1,
      sym_trailing_return_type,
    STATE(5956), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5316), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [194625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5156), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9609), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5159), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [194669] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6031), 1,
      sym__function_attributes_end,
    STATE(6198), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5303), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [194745] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    STATE(5418), 1,
      sym_trailing_return_type,
    STATE(5921), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5313), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [194821] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(6033), 1,
      sym_trailing_return_type,
    STATE(6163), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5320), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [194897] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194978] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(5629), 1,
      sym_ms_declspec_modifier,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5630), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5161), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1881), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6127), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6125), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [195102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1882), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6131), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6129), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [195145] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2778), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195226] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3107), 1,
      sym_field_declaration_list,
    STATE(3512), 1,
      sym__class_declaration_item,
    STATE(3513), 1,
      sym__class_declaration,
    STATE(5518), 1,
      sym_ms_declspec_modifier,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(7127), 1,
      sym_virtual_specifier,
    STATE(7665), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2592), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5519), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5205), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1886), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6092), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6090), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [195350] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2800), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1834), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6098), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6096), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [195474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1842), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6170), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6168), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [195517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1843), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6106), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6104), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [195560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1867), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6060), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6058), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [195603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1877), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6064), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6062), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [195646] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2800), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195727] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3107), 1,
      sym_field_declaration_list,
    STATE(3512), 1,
      sym__class_declaration_item,
    STATE(3514), 1,
      sym__class_declaration,
    STATE(5518), 1,
      sym_ms_declspec_modifier,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(7127), 1,
      sym_virtual_specifier,
    STATE(7665), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2592), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5519), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5205), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195808] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4877), 1,
      sym_field_declaration_list,
    STATE(4929), 1,
      sym__class_declaration,
    STATE(4931), 1,
      sym__class_declaration_item,
    STATE(5539), 1,
      sym_ms_declspec_modifier,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(6984), 1,
      sym_virtual_specifier,
    STATE(7729), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4384), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5540), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5201), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195889] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3107), 1,
      sym_field_declaration_list,
    STATE(3511), 1,
      sym__class_declaration,
    STATE(3512), 1,
      sym__class_declaration_item,
    STATE(5518), 1,
      sym_ms_declspec_modifier,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(7127), 1,
      sym_virtual_specifier,
    STATE(7665), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2592), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5519), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5205), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195970] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4877), 1,
      sym_field_declaration_list,
    STATE(4923), 1,
      sym__class_declaration,
    STATE(4931), 1,
      sym__class_declaration_item,
    STATE(5539), 1,
      sym_ms_declspec_modifier,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(6984), 1,
      sym_virtual_specifier,
    STATE(7729), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4384), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5540), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5201), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196051] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5559), 1,
      sym_ms_declspec_modifier,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5560), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5173), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196132] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2801), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196213] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(5612), 1,
      sym_ms_declspec_modifier,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5613), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5190), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196294] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5559), 1,
      sym_ms_declspec_modifier,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5560), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5173), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196375] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4877), 1,
      sym_field_declaration_list,
    STATE(4931), 1,
      sym__class_declaration_item,
    STATE(4933), 1,
      sym__class_declaration,
    STATE(5539), 1,
      sym_ms_declspec_modifier,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(6984), 1,
      sym_virtual_specifier,
    STATE(7729), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4384), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5540), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5201), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196456] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2778), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196537] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2801), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196618] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    ACTIONS(7373), 1,
      anon_sym_LPAREN2,
    STATE(1928), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3421), 1,
      sym_argument_list,
    STATE(3426), 1,
      sym_initializer_list,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5886), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5452), 20,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [196669] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9341), 1,
      anon_sym_requires,
    STATE(6188), 1,
      sym_trailing_return_type,
    STATE(6211), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5340), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [196744] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2770), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196825] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2770), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196906] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2766), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196987] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2770), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197068] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2833), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197149] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2780), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197230] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2833), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197311] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2780), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197392] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2780), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197473] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2833), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197554] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3925), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5500), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5189), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197635] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3925), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5500), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5189), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197716] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3925), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5500), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5189), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197797] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4642), 1,
      sym__class_declaration,
    STATE(4653), 1,
      sym__class_declaration_item,
    STATE(5583), 1,
      sym_ms_declspec_modifier,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5584), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5176), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197878] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(5612), 1,
      sym_ms_declspec_modifier,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5613), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5190), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197959] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198040] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1873), 1,
      sym__class_declaration,
    STATE(1874), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(5567), 1,
      sym_ms_declspec_modifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5569), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5202), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198121] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198202] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1874), 1,
      sym__class_declaration_item,
    STATE(1875), 1,
      sym__class_declaration,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(5567), 1,
      sym_ms_declspec_modifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5569), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5202), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198283] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(5629), 1,
      sym_ms_declspec_modifier,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5630), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5161), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198364] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1874), 1,
      sym__class_declaration_item,
    STATE(1876), 1,
      sym__class_declaration,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(5567), 1,
      sym_ms_declspec_modifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5569), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5202), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198445] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2801), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198526] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4653), 1,
      sym__class_declaration_item,
    STATE(4659), 1,
      sym__class_declaration,
    STATE(5583), 1,
      sym_ms_declspec_modifier,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5584), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5176), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198607] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2771), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198688] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5559), 1,
      sym_ms_declspec_modifier,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5560), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5173), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198769] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2771), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198850] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198931] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2837), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199012] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2771), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199093] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2837), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199174] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2837), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199255] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9629), 1,
      anon_sym_requires,
    STATE(6189), 1,
      sym_trailing_return_type,
    STATE(6212), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5342), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [199330] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199411] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4653), 1,
      sym__class_declaration_item,
    STATE(4659), 1,
      sym__class_declaration,
    STATE(5495), 1,
      sym_ms_declspec_modifier,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5496), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5164), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199492] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2766), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199573] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4642), 1,
      sym__class_declaration,
    STATE(4653), 1,
      sym__class_declaration_item,
    STATE(5495), 1,
      sym_ms_declspec_modifier,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5496), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5164), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199654] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2800), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199735] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2853), 1,
      sym_field_declaration_list,
    STATE(3117), 1,
      sym__class_declaration,
    STATE(3121), 1,
      sym__class_declaration_item,
    STATE(5529), 1,
      sym_ms_declspec_modifier,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(6970), 1,
      sym_virtual_specifier,
    STATE(7867), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5222), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199816] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2853), 1,
      sym_field_declaration_list,
    STATE(3121), 1,
      sym__class_declaration_item,
    STATE(3123), 1,
      sym__class_declaration,
    STATE(5529), 1,
      sym_ms_declspec_modifier,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(6970), 1,
      sym_virtual_specifier,
    STATE(7867), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5222), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199897] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(5612), 1,
      sym_ms_declspec_modifier,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5613), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5190), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199978] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2672), 1,
      sym__class_declaration,
    STATE(2673), 1,
      sym__class_declaration_item,
    STATE(5501), 1,
      sym_ms_declspec_modifier,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5568), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5158), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200059] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2673), 1,
      sym__class_declaration_item,
    STATE(2675), 1,
      sym__class_declaration,
    STATE(5501), 1,
      sym_ms_declspec_modifier,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5568), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5158), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200140] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2673), 1,
      sym__class_declaration_item,
    STATE(2676), 1,
      sym__class_declaration,
    STATE(5501), 1,
      sym_ms_declspec_modifier,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5568), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5158), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200221] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2805), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200302] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2805), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200383] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(6720), 1,
      anon_sym_LPAREN2,
    STATE(1928), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2436), 1,
      sym_argument_list,
    STATE(3806), 1,
      sym_initializer_list,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5886), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5452), 20,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [200434] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1873), 1,
      sym__class_declaration,
    STATE(1874), 1,
      sym__class_declaration_item,
    STATE(5147), 1,
      sym_field_declaration_list,
    STATE(5535), 1,
      sym_ms_declspec_modifier,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7843), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4504), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5537), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200515] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2792), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200596] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2792), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200677] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2792), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200758] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2766), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200839] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2793), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200920] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2793), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201001] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3943), 1,
      sym_field_declaration_list,
    STATE(4102), 1,
      sym__class_declaration,
    STATE(4104), 1,
      sym__class_declaration_item,
    STATE(5573), 1,
      sym_ms_declspec_modifier,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(6934), 1,
      sym_virtual_specifier,
    STATE(7796), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3127), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5574), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5220), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201082] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2793), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201163] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1874), 1,
      sym__class_declaration_item,
    STATE(1875), 1,
      sym__class_declaration,
    STATE(5147), 1,
      sym_field_declaration_list,
    STATE(5535), 1,
      sym_ms_declspec_modifier,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7843), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4504), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5537), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201244] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3943), 1,
      sym_field_declaration_list,
    STATE(4082), 1,
      sym__class_declaration,
    STATE(4104), 1,
      sym__class_declaration_item,
    STATE(5573), 1,
      sym_ms_declspec_modifier,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(6934), 1,
      sym_virtual_specifier,
    STATE(7796), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3127), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5574), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5220), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201325] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3943), 1,
      sym_field_declaration_list,
    STATE(4097), 1,
      sym__class_declaration,
    STATE(4104), 1,
      sym__class_declaration_item,
    STATE(5573), 1,
      sym_ms_declspec_modifier,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(6934), 1,
      sym_virtual_specifier,
    STATE(7796), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3127), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5574), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5220), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201406] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2201), 1,
      sym_field_declaration_list,
    STATE(2294), 1,
      sym__class_declaration,
    STATE(2299), 1,
      sym__class_declaration_item,
    STATE(5597), 1,
      sym_ms_declspec_modifier,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(7013), 1,
      sym_virtual_specifier,
    STATE(7856), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1728), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5598), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5156), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201487] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1874), 1,
      sym__class_declaration_item,
    STATE(1876), 1,
      sym__class_declaration,
    STATE(5147), 1,
      sym_field_declaration_list,
    STATE(5535), 1,
      sym_ms_declspec_modifier,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7843), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4504), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5537), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5194), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201568] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2201), 1,
      sym_field_declaration_list,
    STATE(2299), 1,
      sym__class_declaration_item,
    STATE(2302), 1,
      sym__class_declaration,
    STATE(5597), 1,
      sym_ms_declspec_modifier,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(7013), 1,
      sym_virtual_specifier,
    STATE(7856), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1728), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5598), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5156), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201649] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201730] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2201), 1,
      sym_field_declaration_list,
    STATE(2299), 1,
      sym__class_declaration_item,
    STATE(2303), 1,
      sym__class_declaration,
    STATE(5597), 1,
      sym_ms_declspec_modifier,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(7013), 1,
      sym_virtual_specifier,
    STATE(7856), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1728), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5598), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5156), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201811] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4653), 1,
      sym__class_declaration_item,
    STATE(4683), 1,
      sym__class_declaration,
    STATE(5583), 1,
      sym_ms_declspec_modifier,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5584), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5176), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201892] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(6175), 1,
      sym__function_attributes_end,
    STATE(6207), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5336), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9182), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [201967] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2778), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202048] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2805), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202129] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1873), 1,
      sym__class_declaration,
    STATE(1874), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(5607), 1,
      sym_ms_declspec_modifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5608), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5232), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202210] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2672), 1,
      sym__class_declaration,
    STATE(2673), 1,
      sym__class_declaration_item,
    STATE(5509), 1,
      sym_ms_declspec_modifier,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5510), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5163), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202291] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(6177), 1,
      sym__function_attributes_end,
    STATE(6229), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5343), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9344), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [202366] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4653), 1,
      sym__class_declaration_item,
    STATE(4683), 1,
      sym__class_declaration,
    STATE(5495), 1,
      sym_ms_declspec_modifier,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5496), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5164), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202447] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2673), 1,
      sym__class_declaration_item,
    STATE(2675), 1,
      sym__class_declaration,
    STATE(5509), 1,
      sym_ms_declspec_modifier,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5510), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5163), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202528] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2673), 1,
      sym__class_declaration_item,
    STATE(2676), 1,
      sym__class_declaration,
    STATE(5509), 1,
      sym_ms_declspec_modifier,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5510), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5163), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202609] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1874), 1,
      sym__class_declaration_item,
    STATE(1875), 1,
      sym__class_declaration,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(5607), 1,
      sym_ms_declspec_modifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5608), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5232), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202690] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2522), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2842), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202771] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2824), 1,
      sym_field_declaration_list,
    STATE(2986), 1,
      sym__class_declaration,
    STATE(2987), 1,
      sym__class_declaration_item,
    STATE(5562), 1,
      sym_ms_declspec_modifier,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(7126), 1,
      sym_virtual_specifier,
    STATE(7850), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5565), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5157), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202852] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1874), 1,
      sym__class_declaration_item,
    STATE(1876), 1,
      sym__class_declaration,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(5607), 1,
      sym_ms_declspec_modifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5608), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5232), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1840), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6153), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6151), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1850), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6157), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6155), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [203019] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2853), 1,
      sym_field_declaration_list,
    STATE(3121), 1,
      sym__class_declaration_item,
    STATE(3124), 1,
      sym__class_declaration,
    STATE(5529), 1,
      sym_ms_declspec_modifier,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(6970), 1,
      sym_virtual_specifier,
    STATE(7867), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5530), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5222), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203100] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2440), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2842), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203181] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5586), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2842), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5588), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5225), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203262] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2824), 1,
      sym_field_declaration_list,
    STATE(2987), 1,
      sym__class_declaration_item,
    STATE(2990), 1,
      sym__class_declaration,
    STATE(5562), 1,
      sym_ms_declspec_modifier,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(7126), 1,
      sym_virtual_specifier,
    STATE(7850), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5565), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5157), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203343] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2824), 1,
      sym_field_declaration_list,
    STATE(2987), 1,
      sym__class_declaration_item,
    STATE(2989), 1,
      sym__class_declaration,
    STATE(5562), 1,
      sym_ms_declspec_modifier,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(7126), 1,
      sym_virtual_specifier,
    STATE(7850), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5565), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5157), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1865), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6119), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6117), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [203467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1871), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6123), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6121), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [203510] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2409), 1,
      sym__class_declaration_item,
    STATE(2483), 1,
      sym__class_declaration,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(5629), 1,
      sym_ms_declspec_modifier,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5630), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5161), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203591] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2201), 1,
      sym_field_declaration_list,
    STATE(2268), 1,
      sym__class_declaration_item,
    STATE(5601), 1,
      sym_ms_declspec_modifier,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(7013), 1,
      sym_virtual_specifier,
    STATE(7856), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1728), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5600), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203669] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2824), 1,
      sym_field_declaration_list,
    STATE(3055), 1,
      sym__class_declaration_item,
    STATE(5571), 1,
      sym_ms_declspec_modifier,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(7126), 1,
      sym_virtual_specifier,
    STATE(7850), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5570), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203747] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2689), 1,
      sym__class_declaration_item,
    STATE(5488), 1,
      sym_ms_declspec_modifier,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5487), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203825] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9501), 1,
      sym_identifier,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9507), 1,
      sym_primitive_type,
    ACTIONS(9509), 1,
      anon_sym_enum,
    ACTIONS(9511), 1,
      anon_sym_class,
    ACTIONS(9513), 1,
      anon_sym_struct,
    ACTIONS(9515), 1,
      anon_sym_union,
    ACTIONS(9517), 1,
      sym_auto,
    ACTIONS(9519), 1,
      anon_sym_decltype,
    ACTIONS(9521), 1,
      anon_sym_typename,
    STATE(1619), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2928), 1,
      sym_type_specifier,
    STATE(2976), 1,
      sym_decltype_auto,
    STATE(2983), 1,
      sym_qualified_type_identifier,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2924), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9505), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2978), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203899] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9582), 1,
      sym_primitive_type,
    ACTIONS(9584), 1,
      anon_sym_enum,
    ACTIONS(9586), 1,
      anon_sym_class,
    ACTIONS(9588), 1,
      anon_sym_struct,
    ACTIONS(9590), 1,
      anon_sym_union,
    ACTIONS(9592), 1,
      sym_auto,
    ACTIONS(9594), 1,
      anon_sym_decltype,
    ACTIONS(9596), 1,
      anon_sym_typename,
    STATE(1860), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(3824), 1,
      sym_type_specifier,
    STATE(4081), 1,
      sym_decltype_auto,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(4024), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203973] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2516), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(5639), 1,
      sym_ms_declspec_modifier,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5638), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [204051] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9438), 1,
      sym_identifier,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9444), 1,
      sym_primitive_type,
    ACTIONS(9446), 1,
      anon_sym_enum,
    ACTIONS(9448), 1,
      anon_sym_class,
    ACTIONS(9450), 1,
      anon_sym_struct,
    ACTIONS(9452), 1,
      anon_sym_union,
    ACTIONS(9454), 1,
      sym_auto,
    ACTIONS(9456), 1,
      anon_sym_decltype,
    ACTIONS(9458), 1,
      anon_sym_typename,
    STATE(1625), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2834), 1,
      sym_type_specifier,
    STATE(3111), 1,
      sym_decltype_auto,
    STATE(3113), 1,
      sym_qualified_type_identifier,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(3044), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9442), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3114), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204125] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2689), 1,
      sym__class_declaration_item,
    STATE(5512), 1,
      sym_ms_declspec_modifier,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5511), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [204203] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4747), 1,
      sym__class_declaration_item,
    STATE(5505), 1,
      sym_ms_declspec_modifier,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [204281] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    ACTIONS(9341), 1,
      anon_sym_requires,
    STATE(6123), 1,
      sym__function_attributes_end,
    STATE(6188), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5359), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [204355] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7974), 1,
      anon_sym_class,
    ACTIONS(7976), 1,
      anon_sym_struct,
    ACTIONS(7978), 1,
      anon_sym_union,
    ACTIONS(9650), 1,
      anon_sym_enum,
    ACTIONS(9652), 1,
      anon_sym_typename,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(5032), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(6917), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9648), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204429] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9392), 1,
      anon_sym_class,
    ACTIONS(9394), 1,
      anon_sym_struct,
    ACTIONS(9396), 1,
      anon_sym_union,
    ACTIONS(9398), 1,
      sym_auto,
    ACTIONS(9400), 1,
      anon_sym_decltype,
    ACTIONS(9481), 1,
      sym_identifier,
    ACTIONS(9485), 1,
      sym_primitive_type,
    ACTIONS(9487), 1,
      anon_sym_enum,
    ACTIONS(9489), 1,
      anon_sym_typename,
    STATE(1594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1905), 1,
      sym_type_specifier,
    STATE(2273), 1,
      sym_qualified_type_identifier,
    STATE(2309), 1,
      sym_decltype_auto,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2174), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9483), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2245), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204503] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(5937), 1,
      sym__declarator,
    STATE(7536), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [204573] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9532), 1,
      sym_primitive_type,
    ACTIONS(9534), 1,
      anon_sym_enum,
    ACTIONS(9536), 1,
      anon_sym_class,
    ACTIONS(9538), 1,
      anon_sym_struct,
    ACTIONS(9540), 1,
      anon_sym_union,
    ACTIONS(9542), 1,
      sym_auto,
    ACTIONS(9544), 1,
      anon_sym_decltype,
    ACTIONS(9546), 1,
      anon_sym_typename,
    STATE(1637), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3343), 1,
      sym_type_specifier,
    STATE(3491), 1,
      sym_decltype_auto,
    STATE(3507), 1,
      sym_qualified_type_identifier,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(3329), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9530), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3504), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204647] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8019), 1,
      sym_identifier,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8025), 1,
      sym_primitive_type,
    ACTIONS(8027), 1,
      anon_sym_enum,
    ACTIONS(8029), 1,
      anon_sym_class,
    ACTIONS(8031), 1,
      anon_sym_struct,
    ACTIONS(8033), 1,
      anon_sym_union,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    ACTIONS(8039), 1,
      anon_sym_typename,
    STATE(4069), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4852), 1,
      sym_type_specifier,
    STATE(4947), 1,
      sym_qualified_type_identifier,
    STATE(4948), 1,
      sym_decltype_auto,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(4894), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8023), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4919), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204721] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9392), 1,
      anon_sym_class,
    ACTIONS(9394), 1,
      anon_sym_struct,
    ACTIONS(9396), 1,
      anon_sym_union,
    ACTIONS(9398), 1,
      sym_auto,
    ACTIONS(9400), 1,
      anon_sym_decltype,
    ACTIONS(9481), 1,
      sym_identifier,
    ACTIONS(9485), 1,
      sym_primitive_type,
    ACTIONS(9487), 1,
      anon_sym_enum,
    ACTIONS(9489), 1,
      anon_sym_typename,
    STATE(1594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2172), 1,
      sym_type_specifier,
    STATE(2273), 1,
      sym_qualified_type_identifier,
    STATE(2309), 1,
      sym_decltype_auto,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2174), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9483), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2245), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204795] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3899), 1,
      sym_identifier,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(3913), 1,
      anon_sym_enum,
    ACTIONS(3915), 1,
      anon_sym_class,
    ACTIONS(3917), 1,
      anon_sym_struct,
    ACTIONS(3919), 1,
      anon_sym_union,
    ACTIONS(3921), 1,
      anon_sym_typename,
    STATE(2393), 1,
      sym_type_specifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204869] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2516), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5564), 1,
      sym_ms_declspec_modifier,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5563), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [204947] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7961), 1,
      sym_primitive_type,
    ACTIONS(9422), 1,
      sym_identifier,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_class,
    ACTIONS(9432), 1,
      anon_sym_struct,
    ACTIONS(9434), 1,
      anon_sym_union,
    ACTIONS(9436), 1,
      anon_sym_typename,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1869), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4059), 1,
      sym_type_specifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205021] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9438), 1,
      sym_identifier,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9444), 1,
      sym_primitive_type,
    ACTIONS(9446), 1,
      anon_sym_enum,
    ACTIONS(9448), 1,
      anon_sym_class,
    ACTIONS(9450), 1,
      anon_sym_struct,
    ACTIONS(9452), 1,
      anon_sym_union,
    ACTIONS(9454), 1,
      sym_auto,
    ACTIONS(9456), 1,
      anon_sym_decltype,
    ACTIONS(9458), 1,
      anon_sym_typename,
    STATE(1625), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2995), 1,
      sym_type_specifier,
    STATE(3111), 1,
      sym_decltype_auto,
    STATE(3113), 1,
      sym_qualified_type_identifier,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(3044), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9442), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3114), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205095] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4747), 1,
      sym__class_declaration_item,
    STATE(5590), 1,
      sym_ms_declspec_modifier,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5589), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [205173] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3134), 1,
      anon_sym_enum,
    ACTIONS(3136), 1,
      anon_sym_class,
    ACTIONS(3138), 1,
      anon_sym_struct,
    ACTIONS(3140), 1,
      anon_sym_union,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(3168), 1,
      anon_sym_typename,
    ACTIONS(8047), 1,
      sym_identifier,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8051), 1,
      sym_primitive_type,
    STATE(2621), 1,
      sym_type_specifier,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205247] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1816), 1,
      anon_sym_enum,
    ACTIONS(1818), 1,
      anon_sym_class,
    ACTIONS(1820), 1,
      anon_sym_struct,
    ACTIONS(1822), 1,
      anon_sym_union,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(1850), 1,
      anon_sym_typename,
    ACTIONS(7955), 1,
      sym_identifier,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7961), 1,
      sym_primitive_type,
    STATE(1784), 1,
      sym_type_specifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205321] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5453), 1,
      sym_trailing_return_type,
    STATE(6200), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5369), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [205395] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(5902), 1,
      sym__declarator,
    STATE(7396), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205465] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5418), 1,
      sym_trailing_return_type,
    STATE(6201), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5370), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [205539] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7961), 1,
      sym_primitive_type,
    ACTIONS(9422), 1,
      sym_identifier,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_class,
    ACTIONS(9432), 1,
      anon_sym_struct,
    ACTIONS(9434), 1,
      anon_sym_union,
    ACTIONS(9436), 1,
      anon_sym_typename,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1869), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4065), 1,
      sym_type_specifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205613] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7994), 1,
      sym_primitive_type,
    ACTIONS(7996), 1,
      anon_sym_enum,
    ACTIONS(7998), 1,
      anon_sym_class,
    ACTIONS(8000), 1,
      anon_sym_struct,
    ACTIONS(8002), 1,
      anon_sym_union,
    ACTIONS(8004), 1,
      anon_sym_typename,
    STATE(1784), 1,
      sym_type_specifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205687] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(5916), 1,
      sym__declarator,
    STATE(7524), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205757] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9501), 1,
      sym_identifier,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9507), 1,
      sym_primitive_type,
    ACTIONS(9509), 1,
      anon_sym_enum,
    ACTIONS(9511), 1,
      anon_sym_class,
    ACTIONS(9513), 1,
      anon_sym_struct,
    ACTIONS(9515), 1,
      anon_sym_union,
    ACTIONS(9517), 1,
      sym_auto,
    ACTIONS(9519), 1,
      anon_sym_decltype,
    ACTIONS(9521), 1,
      anon_sym_typename,
    STATE(1619), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2746), 1,
      sym_type_specifier,
    STATE(2976), 1,
      sym_decltype_auto,
    STATE(2983), 1,
      sym_qualified_type_identifier,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2924), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9505), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2978), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205831] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9382), 1,
      sym_identifier,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9388), 1,
      sym_primitive_type,
    ACTIONS(9390), 1,
      anon_sym_enum,
    ACTIONS(9392), 1,
      anon_sym_class,
    ACTIONS(9394), 1,
      anon_sym_struct,
    ACTIONS(9396), 1,
      anon_sym_union,
    ACTIONS(9398), 1,
      sym_auto,
    ACTIONS(9400), 1,
      anon_sym_decltype,
    ACTIONS(9402), 1,
      anon_sym_typename,
    STATE(1592), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1900), 1,
      sym_type_specifier,
    STATE(2273), 1,
      sym_qualified_type_identifier,
    STATE(2309), 1,
      sym_decltype_auto,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2174), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9386), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2245), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205905] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(8051), 1,
      sym_primitive_type,
    ACTIONS(9404), 1,
      sym_identifier,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9410), 1,
      anon_sym_enum,
    ACTIONS(9412), 1,
      anon_sym_class,
    ACTIONS(9414), 1,
      anon_sym_struct,
    ACTIONS(9416), 1,
      anon_sym_union,
    ACTIONS(9418), 1,
      anon_sym_typename,
    STATE(2170), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2621), 1,
      sym_type_specifier,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9408), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205979] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7961), 1,
      sym_primitive_type,
    ACTIONS(9422), 1,
      sym_identifier,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_class,
    ACTIONS(9432), 1,
      anon_sym_struct,
    ACTIONS(9434), 1,
      anon_sym_union,
    ACTIONS(9436), 1,
      anon_sym_typename,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1869), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(3950), 1,
      sym_type_specifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206053] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2516), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5527), 1,
      sym_ms_declspec_modifier,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3925), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5526), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [206131] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2516), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(5624), 1,
      sym_ms_declspec_modifier,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [206209] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9532), 1,
      sym_primitive_type,
    ACTIONS(9534), 1,
      anon_sym_enum,
    ACTIONS(9536), 1,
      anon_sym_class,
    ACTIONS(9538), 1,
      anon_sym_struct,
    ACTIONS(9540), 1,
      anon_sym_union,
    ACTIONS(9542), 1,
      sym_auto,
    ACTIONS(9544), 1,
      anon_sym_decltype,
    ACTIONS(9546), 1,
      anon_sym_typename,
    STATE(1637), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2891), 1,
      sym_type_specifier,
    STATE(3491), 1,
      sym_decltype_auto,
    STATE(3507), 1,
      sym_qualified_type_identifier,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(3329), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9530), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3504), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206283] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    STATE(6115), 1,
      sym__function_attributes_end,
    STATE(6229), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5347), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [206357] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7974), 1,
      anon_sym_class,
    ACTIONS(7976), 1,
      anon_sym_struct,
    ACTIONS(7978), 1,
      anon_sym_union,
    ACTIONS(9650), 1,
      anon_sym_enum,
    ACTIONS(9652), 1,
      anon_sym_typename,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(5032), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(6925), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9648), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206431] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1854), 1,
      sym__class_declaration_item,
    STATE(5147), 1,
      sym_field_declaration_list,
    STATE(5558), 1,
      sym_ms_declspec_modifier,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7843), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4504), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5557), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [206509] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1884), 1,
      anon_sym_enum,
    ACTIONS(1886), 1,
      anon_sym_class,
    ACTIONS(1888), 1,
      anon_sym_struct,
    ACTIONS(1890), 1,
      anon_sym_union,
    ACTIONS(1914), 1,
      anon_sym_typename,
    ACTIONS(2999), 1,
      sym_primitive_type,
    ACTIONS(5010), 1,
      sym_identifier,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    STATE(2359), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2393), 1,
      sym_type_specifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(3015), 1,
      sym_qualified_type_identifier,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206583] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(5890), 1,
      sym__declarator,
    STATE(7288), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [206653] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(8051), 1,
      sym_primitive_type,
    ACTIONS(9404), 1,
      sym_identifier,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9410), 1,
      anon_sym_enum,
    ACTIONS(9412), 1,
      anon_sym_class,
    ACTIONS(9414), 1,
      anon_sym_struct,
    ACTIONS(9416), 1,
      anon_sym_union,
    ACTIONS(9418), 1,
      anon_sym_typename,
    STATE(2170), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(4143), 1,
      sym_type_specifier,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9408), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206727] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    STATE(6033), 1,
      sym_trailing_return_type,
    STATE(6096), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5368), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [206801] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7972), 1,
      anon_sym_enum,
    ACTIONS(7974), 1,
      anon_sym_class,
    ACTIONS(7976), 1,
      anon_sym_struct,
    ACTIONS(7978), 1,
      anon_sym_union,
    ACTIONS(7980), 1,
      anon_sym_typename,
    STATE(2393), 1,
      sym_type_specifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206875] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6101), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5363), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [206949] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4877), 1,
      sym_field_declaration_list,
    STATE(4904), 1,
      sym__class_declaration_item,
    STATE(5542), 1,
      sym_ms_declspec_modifier,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(6984), 1,
      sym_virtual_specifier,
    STATE(7729), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4384), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5541), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [207027] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1854), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(5485), 1,
      sym_ms_declspec_modifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5635), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [207105] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6063), 1,
      sym_trailing_return_type,
    STATE(6102), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5364), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [207179] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9281), 1,
      anon_sym_requires,
    STATE(5447), 1,
      sym_trailing_return_type,
    STATE(6204), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5349), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [207253] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3107), 1,
      sym_field_declaration_list,
    STATE(3411), 1,
      sym__class_declaration_item,
    STATE(5522), 1,
      sym_ms_declspec_modifier,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(7127), 1,
      sym_virtual_specifier,
    STATE(7665), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2592), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5521), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [207331] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9438), 1,
      sym_identifier,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9444), 1,
      sym_primitive_type,
    ACTIONS(9446), 1,
      anon_sym_enum,
    ACTIONS(9448), 1,
      anon_sym_class,
    ACTIONS(9450), 1,
      anon_sym_struct,
    ACTIONS(9452), 1,
      anon_sym_union,
    ACTIONS(9454), 1,
      sym_auto,
    ACTIONS(9456), 1,
      anon_sym_decltype,
    ACTIONS(9458), 1,
      anon_sym_typename,
    STATE(1625), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2840), 1,
      sym_type_specifier,
    STATE(3111), 1,
      sym_decltype_auto,
    STATE(3113), 1,
      sym_qualified_type_identifier,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(3044), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9442), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3114), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207405] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7961), 1,
      sym_primitive_type,
    ACTIONS(9422), 1,
      sym_identifier,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_class,
    ACTIONS(9432), 1,
      anon_sym_struct,
    ACTIONS(9434), 1,
      anon_sym_union,
    ACTIONS(9436), 1,
      anon_sym_typename,
    STATE(1784), 1,
      sym_type_specifier,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1869), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207479] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9392), 1,
      anon_sym_class,
    ACTIONS(9394), 1,
      anon_sym_struct,
    ACTIONS(9396), 1,
      anon_sym_union,
    ACTIONS(9398), 1,
      sym_auto,
    ACTIONS(9400), 1,
      anon_sym_decltype,
    ACTIONS(9481), 1,
      sym_identifier,
    ACTIONS(9485), 1,
      sym_primitive_type,
    ACTIONS(9487), 1,
      anon_sym_enum,
    ACTIONS(9489), 1,
      anon_sym_typename,
    STATE(1594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1900), 1,
      sym_type_specifier,
    STATE(2273), 1,
      sym_qualified_type_identifier,
    STATE(2309), 1,
      sym_decltype_auto,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2174), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9483), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2245), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207553] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(5905), 1,
      sym__declarator,
    STATE(7536), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207623] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9376), 1,
      anon_sym_requires,
    STATE(5448), 1,
      sym_trailing_return_type,
    STATE(6205), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5350), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [207697] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9382), 1,
      sym_identifier,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9388), 1,
      sym_primitive_type,
    ACTIONS(9390), 1,
      anon_sym_enum,
    ACTIONS(9392), 1,
      anon_sym_class,
    ACTIONS(9394), 1,
      anon_sym_struct,
    ACTIONS(9396), 1,
      anon_sym_union,
    ACTIONS(9398), 1,
      sym_auto,
    ACTIONS(9400), 1,
      anon_sym_decltype,
    ACTIONS(9402), 1,
      anon_sym_typename,
    STATE(1592), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2172), 1,
      sym_type_specifier,
    STATE(2273), 1,
      sym_qualified_type_identifier,
    STATE(2309), 1,
      sym_decltype_auto,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2174), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9386), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2245), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207771] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3911), 1,
      sym_primitive_type,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7974), 1,
      anon_sym_class,
    ACTIONS(7976), 1,
      anon_sym_struct,
    ACTIONS(7978), 1,
      anon_sym_union,
    ACTIONS(9650), 1,
      anon_sym_enum,
    ACTIONS(9652), 1,
      anon_sym_typename,
    STATE(2393), 1,
      sym_type_specifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(5032), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9648), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207845] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9582), 1,
      sym_primitive_type,
    ACTIONS(9584), 1,
      anon_sym_enum,
    ACTIONS(9586), 1,
      anon_sym_class,
    ACTIONS(9588), 1,
      anon_sym_struct,
    ACTIONS(9590), 1,
      anon_sym_union,
    ACTIONS(9592), 1,
      sym_auto,
    ACTIONS(9594), 1,
      anon_sym_decltype,
    ACTIONS(9596), 1,
      anon_sym_typename,
    STATE(1860), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(4019), 1,
      sym_type_specifier,
    STATE(4081), 1,
      sym_decltype_auto,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(4024), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207919] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9532), 1,
      sym_primitive_type,
    ACTIONS(9534), 1,
      anon_sym_enum,
    ACTIONS(9536), 1,
      anon_sym_class,
    ACTIONS(9538), 1,
      anon_sym_struct,
    ACTIONS(9540), 1,
      anon_sym_union,
    ACTIONS(9542), 1,
      sym_auto,
    ACTIONS(9544), 1,
      anon_sym_decltype,
    ACTIONS(9546), 1,
      anon_sym_typename,
    STATE(1637), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2881), 1,
      sym_type_specifier,
    STATE(3491), 1,
      sym_decltype_auto,
    STATE(3507), 1,
      sym_qualified_type_identifier,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(3329), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9530), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3504), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207993] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(5914), 1,
      sym__declarator,
    STATE(7346), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [208063] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(2999), 1,
      sym_primitive_type,
    ACTIONS(3001), 1,
      anon_sym_enum,
    ACTIONS(3003), 1,
      anon_sym_class,
    ACTIONS(3005), 1,
      anon_sym_struct,
    ACTIONS(3007), 1,
      anon_sym_union,
    ACTIONS(3009), 1,
      anon_sym_typename,
    ACTIONS(5218), 1,
      sym_identifier,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    STATE(2359), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2393), 1,
      sym_type_specifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(3015), 1,
      sym_qualified_type_identifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208137] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7291), 1,
      anon_sym_STAR,
    ACTIONS(7293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_COLON_COLON,
    STATE(5835), 1,
      sym__declarator,
    STATE(5838), 1,
      sym__scope_resolution,
    STATE(7536), 1,
      sym_init_declarator,
    STATE(8021), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [208207] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9382), 1,
      sym_identifier,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9388), 1,
      sym_primitive_type,
    ACTIONS(9390), 1,
      anon_sym_enum,
    ACTIONS(9392), 1,
      anon_sym_class,
    ACTIONS(9394), 1,
      anon_sym_struct,
    ACTIONS(9396), 1,
      anon_sym_union,
    ACTIONS(9398), 1,
      sym_auto,
    ACTIONS(9400), 1,
      anon_sym_decltype,
    ACTIONS(9402), 1,
      anon_sym_typename,
    STATE(1592), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1905), 1,
      sym_type_specifier,
    STATE(2273), 1,
      sym_qualified_type_identifier,
    STATE(2309), 1,
      sym_decltype_auto,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2174), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9386), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2245), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208281] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(6013), 1,
      sym_trailing_return_type,
    STATE(6095), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5344), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [208355] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3943), 1,
      sym_field_declaration_list,
    STATE(4056), 1,
      sym__class_declaration_item,
    STATE(5576), 1,
      sym_ms_declspec_modifier,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(6934), 1,
      sym_virtual_specifier,
    STATE(7796), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3127), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [208433] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9501), 1,
      sym_identifier,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9507), 1,
      sym_primitive_type,
    ACTIONS(9509), 1,
      anon_sym_enum,
    ACTIONS(9511), 1,
      anon_sym_class,
    ACTIONS(9513), 1,
      anon_sym_struct,
    ACTIONS(9515), 1,
      anon_sym_union,
    ACTIONS(9517), 1,
      sym_auto,
    ACTIONS(9519), 1,
      anon_sym_decltype,
    ACTIONS(9521), 1,
      anon_sym_typename,
    STATE(1619), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2750), 1,
      sym_type_specifier,
    STATE(2976), 1,
      sym_decltype_auto,
    STATE(2983), 1,
      sym_qualified_type_identifier,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2924), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9505), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2978), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208507] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2853), 1,
      sym_field_declaration_list,
    STATE(3188), 1,
      sym__class_declaration_item,
    STATE(5532), 1,
      sym_ms_declspec_modifier,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(6970), 1,
      sym_virtual_specifier,
    STATE(7867), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5531), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [208585] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    ACTIONS(9629), 1,
      anon_sym_requires,
    STATE(6124), 1,
      sym__function_attributes_end,
    STATE(6189), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5360), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [208659] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8059), 1,
      sym_primitive_type,
    ACTIONS(8069), 1,
      sym_auto,
    ACTIONS(8071), 1,
      anon_sym_decltype,
    ACTIONS(8079), 1,
      sym_identifier,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8083), 1,
      anon_sym_enum,
    ACTIONS(8085), 1,
      anon_sym_class,
    ACTIONS(8087), 1,
      anon_sym_struct,
    ACTIONS(8089), 1,
      anon_sym_union,
    ACTIONS(8091), 1,
      anon_sym_typename,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4468), 1,
      sym_type_specifier,
    STATE(4612), 1,
      sym_decltype_auto,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4706), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208733] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2516), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(5516), 1,
      sym_ms_declspec_modifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5508), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [208811] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(3164), 1,
      sym_auto,
    ACTIONS(3166), 1,
      anon_sym_decltype,
    ACTIONS(8051), 1,
      sym_primitive_type,
    ACTIONS(9404), 1,
      sym_identifier,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9410), 1,
      anon_sym_enum,
    ACTIONS(9412), 1,
      anon_sym_class,
    ACTIONS(9414), 1,
      anon_sym_struct,
    ACTIONS(9416), 1,
      anon_sym_union,
    ACTIONS(9418), 1,
      anon_sym_typename,
    STATE(2170), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2657), 1,
      sym_qualified_type_identifier,
    STATE(2708), 1,
      sym_decltype_auto,
    STATE(4136), 1,
      sym_type_specifier,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2598), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9408), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2668), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208885] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(9576), 1,
      sym_identifier,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9582), 1,
      sym_primitive_type,
    ACTIONS(9584), 1,
      anon_sym_enum,
    ACTIONS(9586), 1,
      anon_sym_class,
    ACTIONS(9588), 1,
      anon_sym_struct,
    ACTIONS(9590), 1,
      anon_sym_union,
    ACTIONS(9592), 1,
      sym_auto,
    ACTIONS(9594), 1,
      anon_sym_decltype,
    ACTIONS(9596), 1,
      anon_sym_typename,
    STATE(1860), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(3826), 1,
      sym_type_specifier,
    STATE(4081), 1,
      sym_decltype_auto,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(4024), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4087), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208959] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(5965), 1,
      sym__declarator,
    STATE(7810), 1,
      sym_init_declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209029] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(6114), 1,
      sym__function_attributes_end,
    STATE(6207), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5346), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [209103] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1846), 1,
      sym_auto,
    ACTIONS(1848), 1,
      anon_sym_decltype,
    ACTIONS(7961), 1,
      sym_primitive_type,
    ACTIONS(9422), 1,
      sym_identifier,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9428), 1,
      anon_sym_enum,
    ACTIONS(9430), 1,
      anon_sym_class,
    ACTIONS(9432), 1,
      anon_sym_struct,
    ACTIONS(9434), 1,
      anon_sym_union,
    ACTIONS(9436), 1,
      anon_sym_typename,
    STATE(1859), 1,
      sym_decltype_auto,
    STATE(1869), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1902), 1,
      sym_qualified_type_identifier,
    STATE(3968), 1,
      sym_type_specifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(1713), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209177] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(8053), 1,
      sym_identifier,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8059), 1,
      sym_primitive_type,
    ACTIONS(8061), 1,
      anon_sym_enum,
    ACTIONS(8063), 1,
      anon_sym_class,
    ACTIONS(8065), 1,
      anon_sym_struct,
    ACTIONS(8067), 1,
      anon_sym_union,
    ACTIONS(8069), 1,
      sym_auto,
    ACTIONS(8071), 1,
      anon_sym_decltype,
    ACTIONS(8073), 1,
      anon_sym_typename,
    STATE(2809), 1,
      sym_qualified_type_identifier,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4468), 1,
      sym_type_specifier,
    STATE(4612), 1,
      sym_decltype_auto,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4706), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209251] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5474), 1,
      anon_sym___declspec,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1854), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(5634), 1,
      sym_ms_declspec_modifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5484), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [209329] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 1,
      anon_sym_enum,
    ACTIONS(75), 1,
      anon_sym_class,
    ACTIONS(77), 1,
      anon_sym_struct,
    ACTIONS(79), 1,
      anon_sym_union,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(131), 1,
      anon_sym_typename,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(2999), 1,
      sym_primitive_type,
    ACTIONS(5218), 1,
      sym_identifier,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    STATE(2359), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2393), 1,
      sym_type_specifier,
    STATE(2501), 1,
      sym_decltype_auto,
    STATE(3015), 1,
      sym_qualified_type_identifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_dependent_type_identifier,
    STATE(2406), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2523), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209403] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7171), 1,
      anon_sym_STAR,
    ACTIONS(7173), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_COLON_COLON,
    STATE(5850), 1,
      sym__scope_resolution,
    STATE(6689), 1,
      sym__declarator,
    STATE(8214), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209470] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(6013), 1,
      sym_trailing_return_type,
    STATE(6360), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5383), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [209543] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(6033), 1,
      sym_trailing_return_type,
    STATE(6361), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9344), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5374), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [209616] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6372), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5391), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [209689] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6063), 1,
      sym_trailing_return_type,
    STATE(6373), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9344), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5385), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [209762] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1658), 1,
      sym_alignas_qualifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9656), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9654), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [209807] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6671), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209874] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1658), 1,
      sym_alignas_qualifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1633), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9660), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9658), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [209919] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6451), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4995), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5452), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9662), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [210027] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7165), 1,
      anon_sym_STAR,
    ACTIONS(7167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6552), 1,
      sym__declarator,
    STATE(8161), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210094] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(9184), 1,
      anon_sym___attribute__,
    ACTIONS(9187), 1,
      anon_sym___attribute,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5534), 1,
      sym_trailing_return_type,
    STATE(5655), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [210161] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6504), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210228] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(9346), 1,
      anon_sym___attribute__,
    ACTIONS(9349), 1,
      anon_sym___attribute,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(5616), 1,
      sym_trailing_return_type,
    STATE(5658), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [210295] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(9667), 1,
      anon_sym___attribute__,
    ACTIONS(9670), 1,
      anon_sym___attribute,
    ACTIONS(9673), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(5491), 1,
      sym_trailing_return_type,
    STATE(5660), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [210362] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_STAR,
    ACTIONS(7277), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7279), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6149), 1,
      sym__declarator,
    STATE(8398), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210429] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6660), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210496] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6448), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210563] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6518), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210630] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9478), 1,
      anon_sym_requires,
    STATE(6315), 1,
      sym__function_attributes_end,
    STATE(6471), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5377), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [210703] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9678), 1,
      anon_sym_requires,
    STATE(6316), 1,
      sym__function_attributes_end,
    STATE(6476), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9344), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5379), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [210776] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6388), 1,
      sym__function_attributes_end,
    STATE(6562), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5387), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [210849] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6384), 1,
      sym__function_attributes_end,
    STATE(6565), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9344), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5390), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [210922] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6451), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210989] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5156), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_GT2,
    ACTIONS(5159), 4,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5070), 17,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [211032] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6679), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211099] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6461), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211166] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(6334), 1,
      sym__function_attributes_end,
    STATE(6457), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9344), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5372), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [211239] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6483), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211306] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7291), 1,
      anon_sym_STAR,
    ACTIONS(7293), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7295), 1,
      anon_sym_AMP,
    ACTIONS(7297), 1,
      anon_sym_COLON_COLON,
    STATE(5838), 1,
      sym__scope_resolution,
    STATE(6135), 1,
      sym__declarator,
    STATE(8021), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211373] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6639), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211440] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6495), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211507] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6482), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8075), 3,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(8077), 26,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_COLON,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [211611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8041), 3,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(8043), 26,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_COLON,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [211648] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7165), 1,
      anon_sym_STAR,
    ACTIONS(7167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7169), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6608), 1,
      sym__declarator,
    STATE(8161), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211715] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6437), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211782] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6444), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211849] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7171), 1,
      anon_sym_STAR,
    ACTIONS(7173), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7175), 1,
      anon_sym_AMP,
    ACTIONS(7177), 1,
      anon_sym_COLON_COLON,
    STATE(5850), 1,
      sym__scope_resolution,
    STATE(6642), 1,
      sym__declarator,
    STATE(8214), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211916] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6459), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211983] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6489), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212050] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5849), 1,
      sym_identifier,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7105), 1,
      anon_sym_STAR,
    ACTIONS(7107), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7109), 1,
      anon_sym_AMP,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6319), 1,
      sym__declarator,
    STATE(8106), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212117] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6442), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212184] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(9184), 1,
      anon_sym___attribute__,
    ACTIONS(9187), 1,
      anon_sym___attribute,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9198), 1,
      anon_sym_requires,
    STATE(5514), 1,
      sym_trailing_return_type,
    STATE(5670), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212251] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(9346), 1,
      anon_sym___attribute__,
    ACTIONS(9349), 1,
      anon_sym___attribute,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9360), 1,
      anon_sym_requires,
    STATE(5544), 1,
      sym_trailing_return_type,
    STATE(5671), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212318] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6478), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212385] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(9667), 1,
      anon_sym___attribute__,
    ACTIONS(9670), 1,
      anon_sym___attribute,
    ACTIONS(9673), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9684), 1,
      anon_sym_requires,
    STATE(5554), 1,
      sym_trailing_return_type,
    STATE(5672), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212452] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2983), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(6686), 1,
      sym__declarator,
    STATE(8682), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212519] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(6333), 1,
      sym__function_attributes_end,
    STATE(6455), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5373), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [212592] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2977), 1,
      anon_sym_LPAREN2,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7089), 1,
      anon_sym_LBRACK,
    ACTIONS(7281), 1,
      sym_identifier,
    ACTIONS(7283), 1,
      anon_sym_STAR,
    ACTIONS(7285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7287), 1,
      anon_sym_AMP,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(6501), 1,
      sym__declarator,
    STATE(8592), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5998), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212659] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9373), 1,
      anon_sym___asm,
    ACTIONS(9376), 1,
      anon_sym_requires,
    STATE(5448), 1,
      sym_trailing_return_type,
    STATE(5679), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9370), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5627), 1,
      anon_sym_LBRACE,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5452), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [212765] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9687), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9693), 1,
      anon_sym___asm,
    ACTIONS(9696), 1,
      anon_sym_requires,
    STATE(5450), 1,
      sym_trailing_return_type,
    STATE(5680), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9690), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212831] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym___asm,
    STATE(5534), 1,
      sym_trailing_return_type,
    STATE(5703), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [212897] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym___asm,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5453), 1,
      sym_trailing_return_type,
    STATE(5663), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212963] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(5616), 1,
      sym_trailing_return_type,
    STATE(5966), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213029] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9373), 1,
      anon_sym___asm,
    STATE(5616), 1,
      sym_trailing_return_type,
    STATE(5706), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9370), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [213095] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9198), 1,
      anon_sym_requires,
    STATE(5514), 1,
      sym_trailing_return_type,
    STATE(5953), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213161] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9360), 1,
      anon_sym_requires,
    STATE(5544), 1,
      sym_trailing_return_type,
    STATE(5958), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213227] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5534), 1,
      sym_trailing_return_type,
    STATE(5963), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213293] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9673), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9684), 1,
      anon_sym_requires,
    STATE(5554), 1,
      sym_trailing_return_type,
    STATE(5950), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213359] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9673), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9693), 1,
      anon_sym___asm,
    STATE(5491), 1,
      sym_trailing_return_type,
    STATE(5709), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9690), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [213425] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9673), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(5491), 1,
      sym_trailing_return_type,
    STATE(5941), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213491] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9198), 1,
      anon_sym_requires,
    ACTIONS(9273), 1,
      anon_sym___asm,
    STATE(5514), 1,
      sym_trailing_return_type,
    STATE(5714), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [213557] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9360), 1,
      anon_sym_requires,
    ACTIONS(9373), 1,
      anon_sym___asm,
    STATE(5544), 1,
      sym_trailing_return_type,
    STATE(5715), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9370), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [213623] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9673), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9684), 1,
      anon_sym_requires,
    ACTIONS(9693), 1,
      anon_sym___asm,
    STATE(5554), 1,
      sym_trailing_return_type,
    STATE(5716), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9690), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [213689] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9687), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9693), 1,
      anon_sym___asm,
    STATE(5419), 1,
      sym_trailing_return_type,
    STATE(5665), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9690), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213755] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9373), 1,
      anon_sym___asm,
    STATE(5418), 1,
      sym_trailing_return_type,
    STATE(5664), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9370), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213821] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      anon_sym___asm,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9281), 1,
      anon_sym_requires,
    STATE(5447), 1,
      sym_trailing_return_type,
    STATE(5678), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9270), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213887] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9687), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6043), 1,
      sym__function_attributes_end,
    STATE(6228), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [213952] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5909), 1,
      sym_trailing_return_type,
    STATE(6127), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [214017] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(6033), 1,
      sym_trailing_return_type,
    STATE(6163), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [214082] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6011), 1,
      sym__function_attributes_end,
    STATE(6252), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [214147] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(5927), 1,
      sym_trailing_return_type,
    STATE(6104), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [214212] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(5940), 1,
      sym_trailing_return_type,
    STATE(6117), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [214277] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(6013), 1,
      sym_trailing_return_type,
    STATE(6133), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [214342] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6031), 1,
      sym__function_attributes_end,
    STATE(6198), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [214407] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(5453), 1,
      sym_trailing_return_type,
    STATE(5881), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214472] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    STATE(5418), 1,
      sym_trailing_return_type,
    STATE(5921), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214537] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9687), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9699), 1,
      anon_sym___attribute__,
    ACTIONS(9702), 1,
      anon_sym___attribute,
    STATE(5419), 1,
      sym_trailing_return_type,
    STATE(5922), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214602] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(5909), 1,
      sym_trailing_return_type,
    STATE(5976), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214667] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    STATE(5927), 1,
      sym_trailing_return_type,
    STATE(5956), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214732] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9699), 1,
      anon_sym___attribute__,
    ACTIONS(9702), 1,
      anon_sym___attribute,
    STATE(5940), 1,
      sym_trailing_return_type,
    STATE(5957), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214797] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    ACTIONS(9300), 1,
      anon_sym_requires,
    STATE(5932), 1,
      sym_trailing_return_type,
    STATE(5943), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214862] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(5904), 1,
      sym_trailing_return_type,
    STATE(5944), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214927] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9699), 1,
      anon_sym___attribute__,
    ACTIONS(9702), 1,
      anon_sym___attribute,
    ACTIONS(9708), 1,
      anon_sym_requires,
    STATE(5935), 1,
      sym_trailing_return_type,
    STATE(5945), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214992] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(6042), 1,
      sym_trailing_return_type,
    STATE(6119), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [215057] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9316), 1,
      anon_sym_requires,
    STATE(6023), 1,
      sym__function_attributes_end,
    STATE(6254), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [215122] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9472), 1,
      anon_sym_requires,
    STATE(6036), 1,
      sym__function_attributes_end,
    STATE(6260), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [215187] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9687), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9711), 1,
      anon_sym_requires,
    STATE(6040), 1,
      sym__function_attributes_end,
    STATE(6261), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [215252] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6169), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [215317] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6063), 1,
      sym_trailing_return_type,
    STATE(6150), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [215382] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9714), 1,
      anon_sym_requires,
    STATE(6064), 1,
      sym_trailing_return_type,
    STATE(6118), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [215447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5627), 1,
      anon_sym_LBRACE,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5452), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [215484] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9300), 1,
      anon_sym_requires,
    STATE(5932), 1,
      sym_trailing_return_type,
    STATE(6099), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [215549] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(5904), 1,
      sym_trailing_return_type,
    STATE(6108), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [215614] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9708), 1,
      anon_sym_requires,
    STATE(5935), 1,
      sym_trailing_return_type,
    STATE(6112), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [215679] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9281), 1,
      anon_sym_requires,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(5447), 1,
      sym_trailing_return_type,
    STATE(5882), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [215744] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9376), 1,
      anon_sym_requires,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    STATE(5448), 1,
      sym_trailing_return_type,
    STATE(5883), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [215809] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9687), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9696), 1,
      anon_sym_requires,
    ACTIONS(9699), 1,
      anon_sym___attribute__,
    ACTIONS(9702), 1,
      anon_sym___attribute,
    STATE(5450), 1,
      sym_trailing_return_type,
    STATE(5892), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [215874] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(5799), 1,
      sym_ms_call_modifier,
    STATE(6765), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(55), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [215932] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(6175), 1,
      sym__function_attributes_end,
    STATE(6207), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [215996] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(6177), 1,
      sym__function_attributes_end,
    STATE(6229), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [216060] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(5814), 1,
      sym_ms_call_modifier,
    STATE(6721), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(55), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [216118] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9341), 1,
      anon_sym_requires,
    STATE(6188), 1,
      sym_trailing_return_type,
    STATE(6211), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [216182] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(5878), 1,
      sym_ms_call_modifier,
    STATE(6735), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(55), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [216240] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9629), 1,
      anon_sym_requires,
    STATE(6189), 1,
      sym_trailing_return_type,
    STATE(6212), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [216304] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(5845), 1,
      sym_ms_call_modifier,
    STATE(6769), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(55), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [216362] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9717), 1,
      anon_sym_requires,
    STATE(6190), 1,
      sym_trailing_return_type,
    STATE(6213), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [216426] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(6178), 1,
      sym__function_attributes_end,
    STATE(6239), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [216490] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    STATE(6033), 1,
      sym_trailing_return_type,
    STATE(6096), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [216553] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 1,
      anon_sym_STAR,
    ACTIONS(7888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7890), 1,
      anon_sym_AMP,
    ACTIONS(8308), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6053), 1,
      sym__abstract_declarator,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [216604] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    STATE(6115), 1,
      sym__function_attributes_end,
    STATE(6229), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [216667] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9699), 1,
      anon_sym___attribute__,
    ACTIONS(9702), 1,
      anon_sym___attribute,
    STATE(6116), 1,
      sym__function_attributes_end,
    STATE(6239), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [216730] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9281), 1,
      anon_sym_requires,
    STATE(5447), 1,
      sym_trailing_return_type,
    STATE(6204), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [216793] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9376), 1,
      anon_sym_requires,
    STATE(5448), 1,
      sym_trailing_return_type,
    STATE(6205), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [216856] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9687), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9696), 1,
      anon_sym_requires,
    STATE(5450), 1,
      sym_trailing_return_type,
    STATE(6206), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [216919] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    ACTIONS(9720), 1,
      anon_sym_LPAREN2,
    ACTIONS(9722), 1,
      anon_sym_LBRACE,
    ACTIONS(9726), 1,
      anon_sym_requires,
    STATE(1945), 1,
      sym_template_type,
    STATE(2527), 1,
      sym_requirement_seq,
    STATE(5402), 1,
      sym_lambda_capture_specifier,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(7921), 1,
      sym_requires_parameter_list,
    ACTIONS(9724), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2472), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [216980] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_STAR,
    ACTIONS(7902), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7904), 1,
      anon_sym_AMP,
    ACTIONS(8308), 1,
      anon_sym___asm,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6004), 1,
      sym__abstract_declarator,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [217031] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    ACTIONS(9728), 1,
      anon_sym_LPAREN2,
    ACTIONS(9730), 1,
      anon_sym_LBRACE,
    ACTIONS(9734), 1,
      anon_sym_requires,
    STATE(1816), 1,
      sym_template_type,
    STATE(3240), 1,
      sym_requirement_seq,
    STATE(5399), 1,
      sym_lambda_capture_specifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(7633), 1,
      sym_requires_parameter_list,
    ACTIONS(9732), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4183), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [217092] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    ACTIONS(9728), 1,
      anon_sym_LPAREN2,
    ACTIONS(9730), 1,
      anon_sym_LBRACE,
    ACTIONS(9734), 1,
      anon_sym_requires,
    STATE(3240), 1,
      sym_requirement_seq,
    STATE(3681), 1,
      sym_template_type,
    STATE(5399), 1,
      sym_lambda_capture_specifier,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(7633), 1,
      sym_requires_parameter_list,
    ACTIONS(9736), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4257), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [217153] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    ACTIONS(9738), 1,
      anon_sym_LPAREN2,
    ACTIONS(9740), 1,
      anon_sym_LBRACE,
    ACTIONS(9744), 1,
      anon_sym_requires,
    STATE(2669), 1,
      sym_template_type,
    STATE(3589), 1,
      sym_requirement_seq,
    STATE(5395), 1,
      sym_lambda_capture_specifier,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(7672), 1,
      sym_requires_parameter_list,
    ACTIONS(9742), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3559), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [217214] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(6013), 1,
      sym_trailing_return_type,
    STATE(6095), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [217277] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7844), 1,
      anon_sym_STAR,
    ACTIONS(7846), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7848), 1,
      anon_sym_AMP,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8308), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6078), 1,
      sym__abstract_declarator,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [217328] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    ACTIONS(9341), 1,
      anon_sym_requires,
    STATE(6123), 1,
      sym__function_attributes_end,
    STATE(6188), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [217391] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    ACTIONS(9629), 1,
      anon_sym_requires,
    STATE(6124), 1,
      sym__function_attributes_end,
    STATE(6189), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [217454] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9699), 1,
      anon_sym___attribute__,
    ACTIONS(9702), 1,
      anon_sym___attribute,
    ACTIONS(9717), 1,
      anon_sym_requires,
    STATE(6125), 1,
      sym__function_attributes_end,
    STATE(6190), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [217517] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6101), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [217580] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9276), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5453), 1,
      sym_trailing_return_type,
    STATE(6200), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [217643] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9466), 1,
      anon_sym___attribute__,
    ACTIONS(9469), 1,
      anon_sym___attribute,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6063), 1,
      sym_trailing_return_type,
    STATE(6102), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [217706] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9699), 1,
      anon_sym___attribute__,
    ACTIONS(9702), 1,
      anon_sym___attribute,
    ACTIONS(9714), 1,
      anon_sym_requires,
    STATE(6064), 1,
      sym_trailing_return_type,
    STATE(6103), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [217769] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    ACTIONS(9746), 1,
      anon_sym_LPAREN2,
    ACTIONS(9748), 1,
      anon_sym_LBRACE,
    ACTIONS(9752), 1,
      anon_sym_requires,
    STATE(2567), 1,
      sym_template_type,
    STATE(4248), 1,
      sym_requirement_seq,
    STATE(5401), 1,
      sym_lambda_capture_specifier,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(7874), 1,
      sym_requires_parameter_list,
    ACTIONS(9750), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4825), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [217830] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9291), 1,
      anon_sym___attribute__,
    ACTIONS(9294), 1,
      anon_sym___attribute,
    STATE(6114), 1,
      sym__function_attributes_end,
    STATE(6207), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [217893] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9756), 1,
      anon_sym_LBRACE,
    ACTIONS(9760), 1,
      anon_sym_requires,
    STATE(2830), 1,
      sym_template_type,
    STATE(3916), 1,
      sym_requirement_seq,
    STATE(5415), 1,
      sym_lambda_capture_specifier,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(7583), 1,
      sym_requires_parameter_list,
    ACTIONS(9758), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3837), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [217954] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9699), 1,
      anon_sym___attribute__,
    ACTIONS(9702), 1,
      anon_sym___attribute,
    STATE(6042), 1,
      sym_trailing_return_type,
    STATE(6097), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [218017] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5418), 1,
      sym_trailing_return_type,
    STATE(6201), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [218080] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9687), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5419), 1,
      sym_trailing_return_type,
    STATE(6202), 1,
      sym__function_attributes_end,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [218143] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    ACTIONS(9762), 1,
      anon_sym_LPAREN2,
    ACTIONS(9764), 1,
      anon_sym_LBRACE,
    ACTIONS(9768), 1,
      anon_sym_requires,
    STATE(2630), 1,
      sym_template_type,
    STATE(3475), 1,
      sym_requirement_seq,
    STATE(5414), 1,
      sym_lambda_capture_specifier,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(7862), 1,
      sym_requires_parameter_list,
    ACTIONS(9766), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3478), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218204] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9673), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(6335), 1,
      sym__function_attributes_end,
    STATE(6458), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9665), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
  [218266] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(6334), 1,
      sym__function_attributes_end,
    STATE(6457), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9344), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
  [218328] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(6042), 1,
      sym_trailing_return_type,
    STATE(6363), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9665), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
  [218390] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9478), 1,
      anon_sym_requires,
    STATE(6315), 1,
      sym__function_attributes_end,
    STATE(6471), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
  [218452] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9772), 1,
      anon_sym_SEMI,
    ACTIONS(9774), 1,
      anon_sym_COLON,
    ACTIONS(9776), 1,
      anon_sym_LBRACE,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(9780), 1,
      anon_sym_EQ,
    ACTIONS(9782), 1,
      anon_sym_try,
    STATE(2123), 1,
      sym_compound_statement,
    STATE(2125), 1,
      sym_default_method_clause,
    STATE(2126), 1,
      sym_delete_method_clause,
    STATE(2128), 1,
      sym_pure_virtual_clause,
    STATE(2130), 1,
      sym_try_statement,
    STATE(2863), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6777), 1,
      aux_sym_field_declaration_repeat1,
    STATE(6845), 1,
      sym_bitfield_clause,
    STATE(6846), 1,
      sym_initializer_list,
    STATE(8478), 1,
      sym_attribute_specifier,
    STATE(6298), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [218526] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(9352), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9678), 1,
      anon_sym_requires,
    STATE(6316), 1,
      sym__function_attributes_end,
    STATE(6476), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9344), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
  [218588] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_COLON,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(9784), 1,
      anon_sym_SEMI,
    ACTIONS(9786), 1,
      anon_sym_LBRACE,
    ACTIONS(9788), 1,
      anon_sym_EQ,
    ACTIONS(9790), 1,
      anon_sym_try,
    STATE(1719), 1,
      sym_delete_method_clause,
    STATE(1770), 1,
      sym_pure_virtual_clause,
    STATE(1785), 1,
      sym_try_statement,
    STATE(1799), 1,
      sym_compound_statement,
    STATE(1824), 1,
      sym_default_method_clause,
    STATE(2863), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6798), 1,
      sym_bitfield_clause,
    STATE(6802), 1,
      sym_initializer_list,
    STATE(6815), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8595), 1,
      sym_attribute_specifier,
    STATE(6298), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [218662] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(9673), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9792), 1,
      anon_sym_requires,
    STATE(6317), 1,
      sym__function_attributes_end,
    STATE(6477), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9665), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
  [218724] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6372), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
  [218786] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(9797), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5471), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9795), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218828] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(6013), 1,
      sym_trailing_return_type,
    STATE(6360), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
  [218890] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(6033), 1,
      sym_trailing_return_type,
    STATE(6361), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9344), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
  [218952] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(9801), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5442), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9799), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218994] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9714), 1,
      anon_sym_requires,
    STATE(6064), 1,
      sym_trailing_return_type,
    STATE(6351), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9665), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
  [219056] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6388), 1,
      sym__function_attributes_end,
    STATE(6562), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
  [219118] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6384), 1,
      sym__function_attributes_end,
    STATE(6565), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9344), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
  [219180] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8459), 1,
      sym_identifier,
    ACTIONS(8461), 1,
      anon_sym_STAR,
    ACTIONS(8463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8465), 1,
      anon_sym_AMP,
    STATE(5962), 1,
      sym_ms_call_modifier,
    STATE(6663), 1,
      sym__field_declarator,
    STATE(6800), 1,
      sym_operator_name,
    STATE(8225), 1,
      sym_ms_based_modifier,
    ACTIONS(1808), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [219234] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_COLON,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(9803), 1,
      anon_sym_SEMI,
    ACTIONS(9805), 1,
      anon_sym_LBRACE,
    ACTIONS(9807), 1,
      anon_sym_EQ,
    ACTIONS(9809), 1,
      anon_sym_try,
    STATE(1960), 1,
      sym_default_method_clause,
    STATE(1961), 1,
      sym_delete_method_clause,
    STATE(1962), 1,
      sym_pure_virtual_clause,
    STATE(1963), 1,
      sym_try_statement,
    STATE(2110), 1,
      sym_compound_statement,
    STATE(2863), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6781), 1,
      sym_initializer_list,
    STATE(6791), 1,
      aux_sym_field_declaration_repeat1,
    STATE(6842), 1,
      sym_bitfield_clause,
    STATE(8589), 1,
      sym_attribute_specifier,
    STATE(6298), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [219308] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9714), 1,
      anon_sym_requires,
    STATE(6362), 1,
      sym__function_attributes_end,
    STATE(6567), 1,
      sym_trailing_return_type,
    STATE(6766), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9665), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5384), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5458), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
  [219370] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6063), 1,
      sym_trailing_return_type,
    STATE(6373), 1,
      sym__function_attributes_end,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9344), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
  [219432] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___asm,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9190), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(6333), 1,
      sym__function_attributes_end,
    STATE(6455), 1,
      sym_trailing_return_type,
    STATE(6745), 1,
      sym_gnu_asm_expression,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7063), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9182), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5428), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5733), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
  [219494] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    STATE(3268), 1,
      sym_compound_statement,
    STATE(5538), 1,
      sym_requires_clause,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7652), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [219553] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    ACTIONS(9817), 1,
      anon_sym_LBRACE,
    STATE(5551), 1,
      sym_requires_clause,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(5931), 1,
      sym_compound_statement,
    STATE(7610), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [219612] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9819), 1,
      anon_sym_LBRACE,
    STATE(3617), 1,
      sym_compound_statement,
    STATE(5412), 1,
      sym_template_parameter_list,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7676), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [219671] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    STATE(1620), 1,
      sym_compound_statement,
    STATE(5397), 1,
      sym_template_parameter_list,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7805), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [219730] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    STATE(1618), 1,
      sym_compound_statement,
    STATE(5547), 1,
      sym_requires_clause,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7563), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [219789] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    ACTIONS(9821), 1,
      anon_sym_LBRACE,
    STATE(3268), 1,
      sym_compound_statement,
    STATE(5631), 1,
      sym_requires_clause,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7854), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [219848] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9821), 1,
      anon_sym_LBRACE,
    STATE(3302), 1,
      sym_compound_statement,
    STATE(5398), 1,
      sym_template_parameter_list,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7891), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [219907] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9823), 1,
      anon_sym_LBRACE,
    STATE(5405), 1,
      sym_template_parameter_list,
    STATE(5605), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7872), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [219966] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9825), 1,
      anon_sym_LBRACE,
    STATE(4237), 1,
      sym_compound_statement,
    STATE(5403), 1,
      sym_template_parameter_list,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7890), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220025] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9827), 1,
      anon_sym_LBRACE,
    STATE(2413), 1,
      sym_compound_statement,
    STATE(5413), 1,
      sym_template_parameter_list,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7667), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220084] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    ACTIONS(9825), 1,
      anon_sym_LBRACE,
    STATE(4240), 1,
      sym_compound_statement,
    STATE(5592), 1,
      sym_requires_clause,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7803), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220143] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9829), 1,
      anon_sym_LBRACE,
    STATE(1620), 1,
      sym_compound_statement,
    STATE(5410), 1,
      sym_template_parameter_list,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7795), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220202] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    ACTIONS(9823), 1,
      anon_sym_LBRACE,
    STATE(5528), 1,
      sym_requires_clause,
    STATE(5625), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7893), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220261] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(7982), 1,
      anon_sym_STAR,
    ACTIONS(7984), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7986), 1,
      anon_sym_AMP,
    ACTIONS(8308), 1,
      anon_sym___attribute,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6220), 1,
      sym__abstract_declarator,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [220310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9833), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9831), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [220341] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    ACTIONS(9835), 1,
      anon_sym_LBRACE,
    STATE(3917), 1,
      sym_compound_statement,
    STATE(5627), 1,
      sym_requires_clause,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7613), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220400] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    STATE(3302), 1,
      sym_compound_statement,
    STATE(5393), 1,
      sym_template_parameter_list,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7574), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220459] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    ACTIONS(9829), 1,
      anon_sym_LBRACE,
    STATE(1618), 1,
      sym_compound_statement,
    STATE(5517), 1,
      sym_requires_clause,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7824), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220518] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9817), 1,
      anon_sym_LBRACE,
    STATE(5394), 1,
      sym_template_parameter_list,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(5933), 1,
      sym_compound_statement,
    STATE(7601), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220577] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    ACTIONS(9819), 1,
      anon_sym_LBRACE,
    STATE(3684), 1,
      sym_compound_statement,
    STATE(5506), 1,
      sym_requires_clause,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7709), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220636] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    ACTIONS(9827), 1,
      anon_sym_LBRACE,
    STATE(2432), 1,
      sym_compound_statement,
    STATE(5545), 1,
      sym_requires_clause,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7578), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220695] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9837), 1,
      anon_sym_LBRACE,
    STATE(3518), 1,
      sym_compound_statement,
    STATE(5416), 1,
      sym_template_parameter_list,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7879), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220754] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9835), 1,
      anon_sym_LBRACE,
    STATE(3921), 1,
      sym_compound_statement,
    STATE(5408), 1,
      sym_template_parameter_list,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7587), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220813] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9815), 1,
      anon_sym_requires,
    ACTIONS(9837), 1,
      anon_sym_LBRACE,
    STATE(3442), 1,
      sym_compound_statement,
    STATE(5561), 1,
      sym_requires_clause,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7851), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [220872] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    ACTIONS(9726), 1,
      anon_sym_requires,
    ACTIONS(9839), 1,
      anon_sym_LPAREN2,
    STATE(1945), 1,
      sym_template_type,
    STATE(5402), 1,
      sym_lambda_capture_specifier,
    STATE(6580), 1,
      sym__scope_resolution,
    ACTIONS(9841), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2459), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220924] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9676), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9665), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [220962] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9845), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9843), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [221000] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5836), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9849), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9847), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [221038] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5396), 1,
      sym_lambda_capture_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    ACTIONS(9853), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6210), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221090] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    ACTIONS(9734), 1,
      anon_sym_requires,
    ACTIONS(9857), 1,
      anon_sym_LPAREN2,
    STATE(3681), 1,
      sym_template_type,
    STATE(5399), 1,
      sym_lambda_capture_specifier,
    STATE(6634), 1,
      sym__scope_resolution,
    ACTIONS(9859), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3214), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221142] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5396), 1,
      sym_lambda_capture_specifier,
    STATE(6630), 1,
      sym__scope_resolution,
    ACTIONS(9861), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5425), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221194] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5396), 1,
      sym_lambda_capture_specifier,
    STATE(6630), 1,
      sym__scope_resolution,
    ACTIONS(9863), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1612), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9865), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6178), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6180), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [221278] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5396), 1,
      sym_lambda_capture_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    ACTIONS(9863), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1612), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221330] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9865), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9867), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6253), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6255), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [221364] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9801), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(4337), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5688), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9799), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [221404] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    ACTIONS(9726), 1,
      anon_sym_requires,
    ACTIONS(9839), 1,
      anon_sym_LPAREN2,
    STATE(1945), 1,
      sym_template_type,
    STATE(5402), 1,
      sym_lambda_capture_specifier,
    STATE(6580), 1,
      sym__scope_resolution,
    ACTIONS(9869), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2460), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221456] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    ACTIONS(9760), 1,
      anon_sym_requires,
    ACTIONS(9871), 1,
      anon_sym_LPAREN2,
    STATE(2830), 1,
      sym_template_type,
    STATE(5415), 1,
      sym_lambda_capture_specifier,
    STATE(6578), 1,
      sym__scope_resolution,
    ACTIONS(9873), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3839), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221508] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    ACTIONS(9752), 1,
      anon_sym_requires,
    ACTIONS(9875), 1,
      anon_sym_LPAREN2,
    STATE(2567), 1,
      sym_template_type,
    STATE(5401), 1,
      sym_lambda_capture_specifier,
    STATE(6594), 1,
      sym__scope_resolution,
    ACTIONS(9877), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4222), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221560] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9734), 1,
      anon_sym_requires,
    ACTIONS(9857), 1,
      anon_sym_LPAREN2,
    STATE(1893), 1,
      sym_template_type,
    STATE(5409), 1,
      sym_lambda_capture_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    ACTIONS(9879), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6878), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221612] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9734), 1,
      anon_sym_requires,
    ACTIONS(9857), 1,
      anon_sym_LPAREN2,
    STATE(1893), 1,
      sym_template_type,
    STATE(5409), 1,
      sym_lambda_capture_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    ACTIONS(9859), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3214), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221664] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    ACTIONS(9881), 1,
      anon_sym_LPAREN2,
    ACTIONS(9885), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5400), 1,
      sym_lambda_capture_specifier,
    STATE(6592), 1,
      sym__scope_resolution,
    ACTIONS(9883), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5520), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221716] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    ACTIONS(9881), 1,
      anon_sym_LPAREN2,
    ACTIONS(9885), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5400), 1,
      sym_lambda_capture_specifier,
    STATE(6592), 1,
      sym__scope_resolution,
    ACTIONS(9887), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5578), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221768] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    ACTIONS(9881), 1,
      anon_sym_LPAREN2,
    ACTIONS(9885), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5400), 1,
      sym_lambda_capture_specifier,
    STATE(6592), 1,
      sym__scope_resolution,
    ACTIONS(9889), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5579), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221820] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    ACTIONS(9891), 1,
      sym_identifier,
    ACTIONS(9893), 1,
      anon_sym_COLON_COLON,
    STATE(2260), 1,
      sym_template_type,
    STATE(5404), 1,
      sym_lambda_capture_specifier,
    STATE(6612), 1,
      sym__scope_resolution,
    ACTIONS(9895), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2271), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9899), 1,
      anon_sym_LPAREN2,
    STATE(5771), 1,
      sym_preproc_argument_list,
    ACTIONS(9901), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9897), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [221906] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_LPAREN2,
    ACTIONS(9907), 1,
      anon_sym_requires,
    STATE(4376), 1,
      sym_template_type,
    STATE(5411), 1,
      sym_lambda_capture_specifier,
    STATE(6632), 1,
      sym__scope_resolution,
    ACTIONS(9905), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5926), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221958] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_LPAREN2,
    ACTIONS(9907), 1,
      anon_sym_requires,
    STATE(4376), 1,
      sym_template_type,
    STATE(5411), 1,
      sym_lambda_capture_specifier,
    STATE(6632), 1,
      sym__scope_resolution,
    ACTIONS(9909), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5898), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222010] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5404), 1,
      sym_lambda_capture_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    ACTIONS(9911), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6265), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9797), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9795), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222096] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9881), 1,
      anon_sym_LPAREN2,
    ACTIONS(9885), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5400), 1,
      sym_lambda_capture_specifier,
    STATE(6615), 1,
      sym__scope_resolution,
    ACTIONS(9913), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6484), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222148] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5396), 1,
      sym_lambda_capture_specifier,
    STATE(6630), 1,
      sym__scope_resolution,
    ACTIONS(9915), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5427), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222200] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5404), 1,
      sym_lambda_capture_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    ACTIONS(9863), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1612), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222252] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9281), 1,
      anon_sym_requires,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9193), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9182), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [222290] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9376), 1,
      anon_sym_requires,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9355), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9344), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [222328] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9696), 1,
      anon_sym_requires,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9676), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9665), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [222366] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5404), 1,
      sym_lambda_capture_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    ACTIONS(9917), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6264), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222418] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9922), 1,
      anon_sym_requires,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9845), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9843), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [222456] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    ACTIONS(9891), 1,
      sym_identifier,
    ACTIONS(9893), 1,
      anon_sym_COLON_COLON,
    STATE(2260), 1,
      sym_template_type,
    STATE(5404), 1,
      sym_lambda_capture_specifier,
    STATE(6612), 1,
      sym__scope_resolution,
    ACTIONS(9925), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2215), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222508] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(9927), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5836), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9849), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9847), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [222546] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9355), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9344), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [222584] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    ACTIONS(9752), 1,
      anon_sym_requires,
    ACTIONS(9875), 1,
      anon_sym_LPAREN2,
    STATE(2567), 1,
      sym_template_type,
    STATE(5401), 1,
      sym_lambda_capture_specifier,
    STATE(6579), 1,
      sym__scope_resolution,
    ACTIONS(9933), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6235), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222636] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    ACTIONS(9752), 1,
      anon_sym_requires,
    ACTIONS(9875), 1,
      anon_sym_LPAREN2,
    STATE(2567), 1,
      sym_template_type,
    STATE(5401), 1,
      sym_lambda_capture_specifier,
    STATE(6579), 1,
      sym__scope_resolution,
    ACTIONS(9877), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4222), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222688] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_requires,
    ACTIONS(9935), 1,
      anon_sym_LPAREN2,
    STATE(2630), 1,
      sym_template_type,
    STATE(5414), 1,
      sym_lambda_capture_specifier,
    STATE(6633), 1,
      sym__scope_resolution,
    ACTIONS(9937), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3526), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222740] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    ACTIONS(9891), 1,
      sym_identifier,
    ACTIONS(9893), 1,
      anon_sym_COLON_COLON,
    STATE(2260), 1,
      sym_template_type,
    STATE(5404), 1,
      sym_lambda_capture_specifier,
    STATE(6612), 1,
      sym__scope_resolution,
    ACTIONS(9863), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1612), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9801), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9799), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222826] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9851), 1,
      anon_sym_LPAREN2,
    ACTIONS(9855), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5396), 1,
      sym_lambda_capture_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    ACTIONS(9939), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6234), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [222878] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(9941), 1,
      sym_identifier,
    ACTIONS(9943), 1,
      anon_sym_TILDE,
    ACTIONS(9945), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9947), 1,
      anon_sym_template,
    ACTIONS(9949), 1,
      anon_sym_operator,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5460), 1,
      sym__scope_resolution,
    STATE(6940), 1,
      sym_operator_cast,
    STATE(6969), 1,
      sym_qualified_operator_cast_identifier,
    STATE(7984), 1,
      sym_ms_based_modifier,
    STATE(8601), 1,
      sym_decltype,
  [222948] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    ACTIONS(9744), 1,
      anon_sym_requires,
    ACTIONS(9951), 1,
      anon_sym_LPAREN2,
    STATE(2669), 1,
      sym_template_type,
    STATE(5395), 1,
      sym_lambda_capture_specifier,
    STATE(6620), 1,
      sym__scope_resolution,
    ACTIONS(9953), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3642), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223000] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(141), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(3971), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(9955), 1,
      sym_identifier,
    ACTIONS(9957), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5462), 1,
      sym__scope_resolution,
    STATE(6940), 1,
      sym_operator_cast,
    STATE(6969), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8344), 1,
      sym_ms_based_modifier,
    STATE(8601), 1,
      sym_decltype,
  [223070] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8119), 1,
      anon_sym_STAR,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8308), 1,
      anon_sym___attribute,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6291), 1,
      sym__abstract_declarator,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [223118] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9734), 1,
      anon_sym_requires,
    ACTIONS(9857), 1,
      anon_sym_LPAREN2,
    ACTIONS(9959), 1,
      sym_identifier,
    ACTIONS(9961), 1,
      anon_sym_COLON_COLON,
    STATE(1816), 1,
      sym_template_type,
    STATE(5399), 1,
      sym_lambda_capture_specifier,
    STATE(6618), 1,
      sym__scope_resolution,
    ACTIONS(9963), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6019), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223170] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9734), 1,
      anon_sym_requires,
    ACTIONS(9857), 1,
      anon_sym_LPAREN2,
    ACTIONS(9959), 1,
      sym_identifier,
    ACTIONS(9961), 1,
      anon_sym_COLON_COLON,
    STATE(1816), 1,
      sym_template_type,
    STATE(5399), 1,
      sym_lambda_capture_specifier,
    STATE(6618), 1,
      sym__scope_resolution,
    ACTIONS(9859), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3214), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223222] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    ACTIONS(9760), 1,
      anon_sym_requires,
    ACTIONS(9871), 1,
      anon_sym_LPAREN2,
    STATE(2830), 1,
      sym_template_type,
    STATE(5415), 1,
      sym_lambda_capture_specifier,
    STATE(6578), 1,
      sym__scope_resolution,
    ACTIONS(9965), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3838), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223274] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    ACTIONS(9744), 1,
      anon_sym_requires,
    ACTIONS(9951), 1,
      anon_sym_LPAREN2,
    STATE(2669), 1,
      sym_template_type,
    STATE(5395), 1,
      sym_lambda_capture_specifier,
    STATE(6620), 1,
      sym__scope_resolution,
    ACTIONS(9967), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3674), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223326] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9797), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(4337), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5747), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9795), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [223366] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    ACTIONS(9752), 1,
      anon_sym_requires,
    ACTIONS(9875), 1,
      anon_sym_LPAREN2,
    STATE(2567), 1,
      sym_template_type,
    STATE(5401), 1,
      sym_lambda_capture_specifier,
    STATE(6579), 1,
      sym__scope_resolution,
    ACTIONS(9969), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6230), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223418] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8107), 1,
      anon_sym_STAR,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8111), 1,
      anon_sym_AMP,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6347), 1,
      sym__abstract_declarator,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [223464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9973), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9971), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223498] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9734), 1,
      anon_sym_requires,
    ACTIONS(9857), 1,
      anon_sym_LPAREN2,
    ACTIONS(9959), 1,
      sym_identifier,
    ACTIONS(9961), 1,
      anon_sym_COLON_COLON,
    STATE(1816), 1,
      sym_template_type,
    STATE(5399), 1,
      sym_lambda_capture_specifier,
    STATE(6618), 1,
      sym__scope_resolution,
    ACTIONS(9975), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6020), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223550] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    ACTIONS(9734), 1,
      anon_sym_requires,
    ACTIONS(9857), 1,
      anon_sym_LPAREN2,
    STATE(1816), 1,
      sym_template_type,
    STATE(5399), 1,
      sym_lambda_capture_specifier,
    STATE(6626), 1,
      sym__scope_resolution,
    ACTIONS(9977), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4174), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223602] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    ACTIONS(9734), 1,
      anon_sym_requires,
    ACTIONS(9857), 1,
      anon_sym_LPAREN2,
    STATE(1816), 1,
      sym_template_type,
    STATE(5399), 1,
      sym_lambda_capture_specifier,
    STATE(6626), 1,
      sym__scope_resolution,
    ACTIONS(9859), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3214), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223654] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    ACTIONS(9752), 1,
      anon_sym_requires,
    ACTIONS(9875), 1,
      anon_sym_LPAREN2,
    STATE(2567), 1,
      sym_template_type,
    STATE(5401), 1,
      sym_lambda_capture_specifier,
    STATE(6594), 1,
      sym__scope_resolution,
    ACTIONS(9979), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4795), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223706] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9881), 1,
      anon_sym_LPAREN2,
    ACTIONS(9885), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5400), 1,
      sym_lambda_capture_specifier,
    STATE(6615), 1,
      sym__scope_resolution,
    ACTIONS(9981), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6487), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223758] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    ACTIONS(9734), 1,
      anon_sym_requires,
    ACTIONS(9857), 1,
      anon_sym_LPAREN2,
    STATE(3681), 1,
      sym_template_type,
    STATE(5399), 1,
      sym_lambda_capture_specifier,
    STATE(6634), 1,
      sym__scope_resolution,
    ACTIONS(9983), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4214), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223810] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(141), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(2993), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5478), 1,
      sym__scope_resolution,
    STATE(6940), 1,
      sym_operator_cast,
    STATE(6969), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8344), 1,
      sym_ms_based_modifier,
    STATE(8601), 1,
      sym_decltype,
  [223880] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9193), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9182), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [223918] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9619), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_LPAREN2,
    ACTIONS(9907), 1,
      anon_sym_requires,
    STATE(4376), 1,
      sym_template_type,
    STATE(5411), 1,
      sym_lambda_capture_specifier,
    STATE(6632), 1,
      sym__scope_resolution,
    ACTIONS(9989), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5885), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [223970] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9881), 1,
      anon_sym_LPAREN2,
    ACTIONS(9885), 1,
      anon_sym_requires,
    STATE(1893), 1,
      sym_template_type,
    STATE(5400), 1,
      sym_lambda_capture_specifier,
    STATE(6615), 1,
      sym__scope_resolution,
    ACTIONS(9889), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5579), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [224022] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(9734), 1,
      anon_sym_requires,
    ACTIONS(9857), 1,
      anon_sym_LPAREN2,
    STATE(1893), 1,
      sym_template_type,
    STATE(5409), 1,
      sym_lambda_capture_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    ACTIONS(9991), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6881), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [224074] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2020), 1,
      anon_sym_LBRACK,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_requires,
    ACTIONS(9935), 1,
      anon_sym_LPAREN2,
    STATE(2630), 1,
      sym_template_type,
    STATE(5414), 1,
      sym_lambda_capture_specifier,
    STATE(6633), 1,
      sym__scope_resolution,
    ACTIONS(9993), 2,
      sym_true,
      sym_false,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3524), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [224126] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1880), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224185] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1883), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5552), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224244] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(1932), 1,
      anon_sym_LBRACE,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(9999), 1,
      anon_sym_SEMI,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10007), 1,
      anon_sym_try,
    STATE(605), 1,
      sym_compound_statement,
    STATE(619), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7380), 1,
      sym_gnu_asm_expression,
    STATE(7381), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [224305] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2702), 1,
      sym__class_declaration_item,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224364] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2706), 1,
      sym__class_declaration_item,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224423] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2650), 1,
      sym__class_declaration_item,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5164), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [224511] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9845), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9843), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [224548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5132), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5134), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [224577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5142), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [224606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10011), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10009), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224635] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4731), 1,
      sym__class_declaration_item,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224694] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4746), 1,
      sym__class_declaration_item,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224753] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(9790), 1,
      anon_sym_try,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10013), 1,
      anon_sym_SEMI,
    ACTIONS(10015), 1,
      anon_sym_LBRACE,
    STATE(1821), 1,
      sym_compound_statement,
    STATE(1822), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7488), 1,
      sym_gnu_asm_expression,
    STATE(7489), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [224814] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    ACTIONS(10017), 1,
      anon_sym_SEMI,
    STATE(5389), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8041), 1,
      sym_attribute_specifier,
    STATE(8049), 1,
      sym_ms_based_modifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [224867] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2511), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3925), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5526), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224926] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2515), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3925), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224985] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2684), 1,
      sym__class_declaration_item,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5487), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225044] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10019), 1,
      anon_sym_SEMI,
    ACTIONS(10021), 1,
      anon_sym_LBRACE,
    ACTIONS(10023), 1,
      anon_sym_try,
    STATE(306), 1,
      sym_compound_statement,
    STATE(307), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7260), 1,
      sym_gnu_asm_expression,
    STATE(7262), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [225105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5186), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [225134] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4730), 1,
      sym__class_declaration_item,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225193] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4743), 1,
      sym__class_declaration_item,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5507), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225252] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9819), 1,
      anon_sym_LBRACE,
    STATE(3656), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7725), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [225305] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4606), 1,
      sym__class_declaration_item,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225364] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2489), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225423] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2684), 1,
      sym__class_declaration_item,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5511), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225482] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2688), 1,
      sym__class_declaration_item,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225541] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2702), 1,
      sym__class_declaration_item,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225600] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2706), 1,
      sym__class_declaration_item,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5513), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225659] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2650), 1,
      sym__class_declaration_item,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225718] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9360), 1,
      anon_sym_requires,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9355), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9344), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [225755] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(9782), 1,
      anon_sym_try,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10025), 1,
      anon_sym_SEMI,
    ACTIONS(10027), 1,
      anon_sym_LBRACE,
    STATE(2153), 1,
      sym_compound_statement,
    STATE(2154), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7541), 1,
      sym_gnu_asm_expression,
    STATE(7542), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [225816] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5599), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225875] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9829), 1,
      anon_sym_LBRACE,
    STATE(1606), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7839), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [225928] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3107), 1,
      sym_field_declaration_list,
    STATE(3403), 1,
      sym__class_declaration_item,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(7127), 1,
      sym_virtual_specifier,
    STATE(7665), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2592), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5521), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225987] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3107), 1,
      sym_field_declaration_list,
    STATE(3536), 1,
      sym__class_declaration_item,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(7127), 1,
      sym_virtual_specifier,
    STATE(7665), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2592), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226046] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10029), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10031), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6253), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6255), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [226079] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3107), 1,
      sym_field_declaration_list,
    STATE(3461), 1,
      sym__class_declaration_item,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(7127), 1,
      sym_virtual_specifier,
    STATE(7665), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2592), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226138] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3107), 1,
      sym_field_declaration_list,
    STATE(3432), 1,
      sym__class_declaration_item,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(7127), 1,
      sym_virtual_specifier,
    STATE(7665), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2592), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5523), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226197] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3107), 1,
      sym_field_declaration_list,
    STATE(3440), 1,
      sym__class_declaration_item,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(7127), 1,
      sym_virtual_specifier,
    STATE(7665), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2592), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226256] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10035), 1,
      anon_sym_RPAREN,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10045), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5546), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [226299] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    ACTIONS(10049), 1,
      anon_sym_SEMI,
    STATE(5376), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8037), 1,
      sym_attribute_specifier,
    STATE(8049), 1,
      sym_ms_based_modifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [226352] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2489), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3925), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226411] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3925), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5549), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226470] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9823), 1,
      anon_sym_LBRACE,
    STATE(5492), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7904), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [226523] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2853), 1,
      sym_field_declaration_list,
    STATE(3154), 1,
      sym__class_declaration_item,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(6970), 1,
      sym_virtual_specifier,
    STATE(7867), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5531), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226582] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2853), 1,
      sym_field_declaration_list,
    STATE(3175), 1,
      sym__class_declaration_item,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(6970), 1,
      sym_virtual_specifier,
    STATE(7867), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226641] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2853), 1,
      sym_field_declaration_list,
    STATE(3176), 1,
      sym__class_declaration_item,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(6970), 1,
      sym_virtual_specifier,
    STATE(7867), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226700] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2853), 1,
      sym_field_declaration_list,
    STATE(3182), 1,
      sym__class_declaration_item,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(6970), 1,
      sym_virtual_specifier,
    STATE(7867), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5533), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226759] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2853), 1,
      sym_field_declaration_list,
    STATE(3200), 1,
      sym__class_declaration_item,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(6970), 1,
      sym_virtual_specifier,
    STATE(7867), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226818] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9355), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9344), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [226855] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1848), 1,
      sym__class_declaration_item,
    STATE(5147), 1,
      sym_field_declaration_list,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7843), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4504), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5557), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5536), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10053), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10051), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226947] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1853), 1,
      sym__class_declaration_item,
    STATE(5147), 1,
      sym_field_declaration_list,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7843), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4504), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227006] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    STATE(3258), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7694), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [227059] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4877), 1,
      sym_field_declaration_list,
    STATE(4932), 1,
      sym__class_declaration_item,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(6984), 1,
      sym_virtual_specifier,
    STATE(7729), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4384), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5541), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227118] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4877), 1,
      sym_field_declaration_list,
    STATE(4945), 1,
      sym__class_declaration_item,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(6984), 1,
      sym_virtual_specifier,
    STATE(7729), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4384), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227177] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4877), 1,
      sym_field_declaration_list,
    STATE(4918), 1,
      sym__class_declaration_item,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(6984), 1,
      sym_virtual_specifier,
    STATE(7729), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4384), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227236] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4877), 1,
      sym_field_declaration_list,
    STATE(4928), 1,
      sym__class_declaration_item,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(6984), 1,
      sym_virtual_specifier,
    STATE(7729), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4384), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5543), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227295] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4877), 1,
      sym_field_declaration_list,
    STATE(4910), 1,
      sym__class_declaration_item,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(6984), 1,
      sym_virtual_specifier,
    STATE(7729), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4384), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227354] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9684), 1,
      anon_sym_requires,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9676), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9665), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [227391] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9827), 1,
      anon_sym_LBRACE,
    STATE(2462), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7643), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [227444] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_COMMA,
    ACTIONS(10060), 1,
      anon_sym_RPAREN,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10072), 1,
      anon_sym_PIPE,
    ACTIONS(10074), 1,
      anon_sym_CARET,
    ACTIONS(10076), 1,
      anon_sym_AMP,
    STATE(7348), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [227499] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    STATE(1606), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7577), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [227552] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1849), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227611] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2518), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3925), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10088), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10086), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227699] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9817), 1,
      anon_sym_LBRACE,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(5908), 1,
      sym_compound_statement,
    STATE(7617), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [227752] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1849), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10092), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10090), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227840] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10094), 1,
      anon_sym_requires,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9845), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9843), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [227877] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10097), 1,
      anon_sym_requires,
    ACTIONS(9927), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5836), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9849), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9847), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [227914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10102), 1,
      anon_sym_LPAREN2,
    ACTIONS(10104), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10100), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227945] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1880), 1,
      sym__class_declaration_item,
    STATE(5147), 1,
      sym_field_declaration_list,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7843), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4504), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228004] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1883), 1,
      sym__class_declaration_item,
    STATE(5147), 1,
      sym_field_declaration_list,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7843), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4504), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5566), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228063] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2511), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5563), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228122] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2515), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228181] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9837), 1,
      anon_sym_LBRACE,
    STATE(3479), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7841), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [228234] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2824), 1,
      sym_field_declaration_list,
    STATE(3049), 1,
      sym__class_declaration_item,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(7126), 1,
      sym_virtual_specifier,
    STATE(7850), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5570), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228293] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2489), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228352] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5640), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228411] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2824), 1,
      sym_field_declaration_list,
    STATE(3054), 1,
      sym__class_declaration_item,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(7126), 1,
      sym_virtual_specifier,
    STATE(7850), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228470] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1849), 1,
      sym__class_declaration_item,
    STATE(5147), 1,
      sym_field_declaration_list,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7843), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4504), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228529] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1848), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5635), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228588] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2618), 1,
      sym_field_declaration_list,
    STATE(2688), 1,
      sym__class_declaration_item,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(6946), 1,
      sym_virtual_specifier,
    STATE(7567), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228647] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1853), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228706] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2824), 1,
      sym_field_declaration_list,
    STATE(3000), 1,
      sym__class_declaration_item,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(7126), 1,
      sym_virtual_specifier,
    STATE(7850), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228765] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2824), 1,
      sym_field_declaration_list,
    STATE(3003), 1,
      sym__class_declaration_item,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(7126), 1,
      sym_virtual_specifier,
    STATE(7850), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5572), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228824] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2824), 1,
      sym_field_declaration_list,
    STATE(3028), 1,
      sym__class_declaration_item,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(7126), 1,
      sym_virtual_specifier,
    STATE(7850), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228883] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3943), 1,
      sym_field_declaration_list,
    STATE(4090), 1,
      sym__class_declaration_item,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(6934), 1,
      sym_virtual_specifier,
    STATE(7796), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3127), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228942] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3943), 1,
      sym_field_declaration_list,
    STATE(4055), 1,
      sym__class_declaration_item,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(6934), 1,
      sym_virtual_specifier,
    STATE(7796), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3127), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [229001] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3943), 1,
      sym_field_declaration_list,
    STATE(4074), 1,
      sym__class_declaration_item,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(6934), 1,
      sym_virtual_specifier,
    STATE(7796), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3127), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [229060] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3943), 1,
      sym_field_declaration_list,
    STATE(4079), 1,
      sym__class_declaration_item,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(6934), 1,
      sym_virtual_specifier,
    STATE(7796), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3127), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5582), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [229119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5194), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [229148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10031), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6178), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6180), 16,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [229179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5150), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [229208] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_COMMA,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10072), 1,
      anon_sym_PIPE,
    ACTIONS(10074), 1,
      anon_sym_CARET,
    ACTIONS(10076), 1,
      anon_sym_AMP,
    ACTIONS(10106), 1,
      anon_sym_RPAREN,
    STATE(7149), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [229263] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_COMMA,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10072), 1,
      anon_sym_PIPE,
    ACTIONS(10074), 1,
      anon_sym_CARET,
    ACTIONS(10076), 1,
      anon_sym_AMP,
    ACTIONS(10108), 1,
      anon_sym_RPAREN,
    STATE(7226), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [229318] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3943), 1,
      sym_field_declaration_list,
    STATE(4089), 1,
      sym__class_declaration_item,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(6934), 1,
      sym_virtual_specifier,
    STATE(7796), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3127), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [229377] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4731), 1,
      sym__class_declaration_item,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5589), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [229436] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4746), 1,
      sym__class_declaration_item,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [229495] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10110), 1,
      anon_sym_SEMI,
    ACTIONS(10112), 1,
      anon_sym_LBRACE,
    ACTIONS(10114), 1,
      anon_sym_try,
    STATE(662), 1,
      sym_compound_statement,
    STATE(663), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7310), 1,
      sym_gnu_asm_expression,
    STATE(7311), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [229556] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2511), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5508), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [229615] = 5,
    ACTIONS(9897), 1,
      anon_sym_LF,
    ACTIONS(10116), 1,
      anon_sym_LPAREN2,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(5865), 1,
      sym_preproc_argument_list,
    ACTIONS(9901), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [229648] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2515), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [229707] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4730), 1,
      sym__class_declaration_item,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [229766] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4743), 1,
      sym__class_declaration_item,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5596), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [229825] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(141), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5470), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(10120), 1,
      sym_identifier,
    ACTIONS(10122), 1,
      anon_sym_template,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5591), 1,
      sym__scope_resolution,
    STATE(6940), 1,
      sym_operator_cast,
    STATE(6969), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8344), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [229888] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9825), 1,
      anon_sym_LBRACE,
    STATE(4227), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7664), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [229941] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10124), 1,
      anon_sym_RPAREN,
    ACTIONS(10126), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5581), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [229984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(1938), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(1934), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230042] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4423), 1,
      sym_field_declaration_list,
    STATE(4606), 1,
      sym__class_declaration_item,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(6965), 1,
      sym_virtual_specifier,
    STATE(7777), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4218), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230101] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2201), 1,
      sym_field_declaration_list,
    STATE(2262), 1,
      sym__class_declaration_item,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(7013), 1,
      sym_virtual_specifier,
    STATE(7856), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1728), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5600), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230160] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2201), 1,
      sym_field_declaration_list,
    STATE(2267), 1,
      sym__class_declaration_item,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(7013), 1,
      sym_virtual_specifier,
    STATE(7856), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1728), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230219] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2518), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230278] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2201), 1,
      sym_field_declaration_list,
    STATE(2241), 1,
      sym__class_declaration_item,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(7013), 1,
      sym_virtual_specifier,
    STATE(7856), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1728), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230337] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2201), 1,
      sym_field_declaration_list,
    STATE(2249), 1,
      sym__class_declaration_item,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(7013), 1,
      sym_virtual_specifier,
    STATE(7856), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1728), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5602), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230396] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2201), 1,
      sym_field_declaration_list,
    STATE(2223), 1,
      sym__class_declaration_item,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(7013), 1,
      sym_virtual_specifier,
    STATE(7856), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1728), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230455] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9193), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9182), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [230492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5146), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5182), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5536), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10130), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10128), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230583] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1848), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5484), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230642] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1853), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5138), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5138), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5138), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230788] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2511), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230847] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2515), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230906] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2518), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230965] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9198), 1,
      anon_sym_requires,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9193), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9182), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [231002] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9676), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9665), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [231039] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(9809), 1,
      anon_sym_try,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10132), 1,
      anon_sym_SEMI,
    ACTIONS(10134), 1,
      anon_sym_LBRACE,
    STATE(1989), 1,
      sym_compound_statement,
    STATE(1991), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7397), 1,
      sym_gnu_asm_expression,
    STATE(7398), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [231100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5154), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [231129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10138), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10136), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10142), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10140), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5836), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9849), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9847), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [231224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5168), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [231253] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2489), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231312] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5633), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5172), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [231400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5188), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5190), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [231429] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9835), 1,
      anon_sym_LBRACE,
    STATE(3903), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7626), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [231482] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6392), 1,
      sym__abstract_declarator,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [231527] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2511), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5638), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231586] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2515), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231645] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(9821), 1,
      anon_sym_LBRACE,
    STATE(3258), 1,
      sym_compound_statement,
    STATE(5874), 1,
      sym_parameter_list,
    STATE(7655), 1,
      sym_lambda_declarator,
    STATE(8493), 1,
      sym_trailing_return_type,
    STATE(5866), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5969), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [231698] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10144), 1,
      anon_sym_SEMI,
    ACTIONS(10146), 1,
      anon_sym_LBRACE,
    ACTIONS(10148), 1,
      anon_sym_try,
    STATE(651), 1,
      sym_try_statement,
    STATE(730), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7295), 1,
      sym_gnu_asm_expression,
    STATE(7522), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [231759] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2518), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231818] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1883), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5548), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231877] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(1880), 1,
      sym__class_declaration_item,
    STATE(2336), 1,
      sym_field_declaration_list,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(6997), 1,
      sym_virtual_specifier,
    STATE(7837), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2107), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231936] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10150), 1,
      anon_sym_RPAREN,
    ACTIONS(10152), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5580), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [231979] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    ACTIONS(10154), 1,
      anon_sym_SEMI,
    STATE(5378), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8049), 1,
      sym_ms_based_modifier,
    STATE(8617), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [232032] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2489), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232091] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(3610), 1,
      sym_field_declaration_list,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(7084), 1,
      sym_virtual_specifier,
    STATE(7878), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5614), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232150] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2518), 1,
      sym__class_declaration_item,
    STATE(2917), 1,
      sym_field_declaration_list,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(6995), 1,
      sym_virtual_specifier,
    STATE(7645), 1,
      sym_base_class_clause,
    ACTIONS(5503), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232209] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10164), 1,
      anon_sym_RBRACK,
    ACTIONS(10166), 1,
      sym_this,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [232261] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10076), 1,
      anon_sym_AMP,
    ACTIONS(10170), 1,
      anon_sym_PIPE,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10168), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [232305] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10170), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(10168), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [232347] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6909), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [232397] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10170), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(10168), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [232437] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10170), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10168), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [232473] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10172), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [232525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10176), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10174), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [232553] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10170), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10168), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [232587] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6906), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [232637] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10178), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [232689] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10190), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5880), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232729] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7079), 1,
      anon_sym_requires,
    STATE(5534), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9193), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [232769] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(9943), 1,
      anon_sym_TILDE,
    ACTIONS(10194), 1,
      sym_identifier,
    ACTIONS(10196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10198), 1,
      anon_sym_template,
    ACTIONS(10200), 1,
      anon_sym_operator,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5654), 1,
      sym__scope_resolution,
    STATE(7984), 1,
      sym_ms_based_modifier,
    STATE(8601), 1,
      sym_decltype,
  [232833] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7079), 1,
      anon_sym_requires,
    STATE(5616), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9355), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [232873] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10202), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5793), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232913] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10204), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5867), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232953] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7079), 1,
      anon_sym_requires,
    STATE(5491), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9676), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [232993] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(10206), 1,
      sym_identifier,
    ACTIONS(10208), 1,
      anon_sym_TILDE,
    ACTIONS(10210), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10212), 1,
      anon_sym_template,
    ACTIONS(10214), 1,
      anon_sym_operator,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(3225), 1,
      sym_pointer_type_declarator,
    STATE(3228), 1,
      sym_template_function,
    STATE(3229), 1,
      sym_destructor_name,
    STATE(3232), 1,
      sym_dependent_identifier,
    STATE(3234), 1,
      sym_qualified_identifier,
    STATE(3238), 1,
      sym_operator_name,
    STATE(5659), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
    STATE(8665), 1,
      sym_ms_based_modifier,
  [233057] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(7079), 1,
      anon_sym_requires,
    STATE(5621), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9845), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [233097] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10216), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5872), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233137] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    STATE(5453), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9193), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233177] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    STATE(5418), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9355), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233217] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    STATE(5419), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9676), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233257] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7301), 1,
      anon_sym_requires,
    STATE(5420), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9845), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233297] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10218), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5808), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233337] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4541), 1,
      anon_sym_RBRACK,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [233389] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6866), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [233439] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(9198), 1,
      anon_sym_requires,
    STATE(5514), 1,
      sym_trailing_return_type,
    ACTIONS(9193), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [233479] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(9360), 1,
      anon_sym_requires,
    STATE(5544), 1,
      sym_trailing_return_type,
    ACTIONS(9355), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [233519] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(9684), 1,
      anon_sym_requires,
    STATE(5554), 1,
      sym_trailing_return_type,
    ACTIONS(9676), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [233559] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_DASH_GT,
    ACTIONS(10094), 1,
      anon_sym_requires,
    STATE(5555), 1,
      sym_trailing_return_type,
    ACTIONS(9845), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [233599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10220), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [233627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7036), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7038), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [233655] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10224), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [233707] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(10226), 1,
      sym_identifier,
    ACTIONS(10228), 1,
      anon_sym_TILDE,
    ACTIONS(10230), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10232), 1,
      anon_sym_template,
    ACTIONS(10234), 1,
      anon_sym_operator,
    STATE(1813), 1,
      sym_template_type,
    STATE(1814), 1,
      sym_dependent_type_identifier,
    STATE(1888), 1,
      sym_qualified_type_identifier,
    STATE(2414), 1,
      sym_pointer_type_declarator,
    STATE(2415), 1,
      sym_template_function,
    STATE(2416), 1,
      sym_destructor_name,
    STATE(2417), 1,
      sym_dependent_identifier,
    STATE(2418), 1,
      sym_qualified_identifier,
    STATE(2419), 1,
      sym_operator_name,
    STATE(5676), 1,
      sym__scope_resolution,
    STATE(7984), 1,
      sym_ms_based_modifier,
    STATE(8601), 1,
      sym_decltype,
  [233771] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9281), 1,
      anon_sym_requires,
    STATE(5447), 1,
      sym_trailing_return_type,
    ACTIONS(9193), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233811] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9376), 1,
      anon_sym_requires,
    STATE(5448), 1,
      sym_trailing_return_type,
    ACTIONS(9355), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233851] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9696), 1,
      anon_sym_requires,
    STATE(5450), 1,
      sym_trailing_return_type,
    ACTIONS(9676), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233891] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9922), 1,
      anon_sym_requires,
    STATE(5452), 1,
      sym_trailing_return_type,
    ACTIONS(9845), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233931] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10236), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [233983] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10238), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234035] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8222), 1,
      anon_sym_STAR,
    ACTIONS(8224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8226), 1,
      anon_sym_AMP,
    ACTIONS(8308), 1,
      anon_sym___attribute,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6417), 1,
      sym__abstract_declarator,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [234081] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10240), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234133] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5028), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(10242), 1,
      sym_identifier,
    ACTIONS(10244), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5685), 1,
      sym__scope_resolution,
    STATE(8344), 1,
      sym_ms_based_modifier,
    STATE(8601), 1,
      sym_decltype,
  [234197] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10246), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5840), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [234237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10248), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2051), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6235), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [234269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9797), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9795), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [234301] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10251), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234353] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10253), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234405] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10255), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234457] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8195), 1,
      anon_sym_STAR,
    ACTIONS(8197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8199), 1,
      anon_sym_AMP,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6409), 1,
      sym__abstract_declarator,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [234501] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10257), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234553] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6918), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [234603] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10259), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234655] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6848), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [234705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10263), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10261), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [234733] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10265), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10269), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10267), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [234813] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10271), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5766), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [234853] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    STATE(5534), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9193), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [234893] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(10273), 1,
      sym_identifier,
    ACTIONS(10275), 1,
      anon_sym_TILDE,
    ACTIONS(10277), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10279), 1,
      anon_sym_template,
    ACTIONS(10281), 1,
      anon_sym_operator,
    STATE(1813), 1,
      sym_template_type,
    STATE(1814), 1,
      sym_dependent_type_identifier,
    STATE(1888), 1,
      sym_qualified_type_identifier,
    STATE(3527), 1,
      sym_pointer_type_declarator,
    STATE(3529), 1,
      sym_template_function,
    STATE(3530), 1,
      sym_destructor_name,
    STATE(3531), 1,
      sym_dependent_identifier,
    STATE(3532), 1,
      sym_qualified_identifier,
    STATE(3533), 1,
      sym_operator_name,
    STATE(5702), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
    STATE(8665), 1,
      sym_ms_based_modifier,
  [234957] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    STATE(5616), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9355), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [234997] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10283), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5767), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10287), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10285), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [235065] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    STATE(5491), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9676), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [235105] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10289), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5774), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235145] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10291), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5780), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235185] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    STATE(5621), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9845), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [235225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10293), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5722), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235265] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10295), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5642), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235305] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10297), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5844), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235345] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9198), 1,
      anon_sym_requires,
    STATE(5514), 1,
      sym_trailing_return_type,
    ACTIONS(9193), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [235385] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9360), 1,
      anon_sym_requires,
    STATE(5544), 1,
      sym_trailing_return_type,
    ACTIONS(9355), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [235425] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(9684), 1,
      anon_sym_requires,
    STATE(5554), 1,
      sym_trailing_return_type,
    ACTIONS(9676), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [235465] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_DASH_GT,
    ACTIONS(10094), 1,
      anon_sym_requires,
    STATE(5555), 1,
      sym_trailing_return_type,
    ACTIONS(9845), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [235505] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10299), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5643), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235545] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10301), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5645), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235585] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10303), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5646), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235625] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10305), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5649), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235665] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10307), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5871), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235705] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10074), 1,
      anon_sym_CARET,
    ACTIONS(10076), 1,
      anon_sym_AMP,
    ACTIONS(10170), 1,
      anon_sym_PIPE,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10168), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [235751] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6912), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [235801] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10309), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5823), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235841] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(10228), 1,
      anon_sym_TILDE,
    ACTIONS(10234), 1,
      anon_sym_operator,
    ACTIONS(10311), 1,
      sym_identifier,
    ACTIONS(10313), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10315), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(2414), 1,
      sym_pointer_type_declarator,
    STATE(2415), 1,
      sym_template_function,
    STATE(2416), 1,
      sym_destructor_name,
    STATE(2417), 1,
      sym_dependent_identifier,
    STATE(2418), 1,
      sym_qualified_identifier,
    STATE(2419), 1,
      sym_operator_name,
    STATE(5725), 1,
      sym__scope_resolution,
    STATE(7984), 1,
      sym_ms_based_modifier,
    STATE(8601), 1,
      sym_decltype,
  [235905] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10317), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5825), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235945] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10319), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5833), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235985] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6901), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236035] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10321), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5834), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [236075] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10323), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5842), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [236115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10327), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10325), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [236143] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6849), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9801), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9799), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [236225] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10329), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [236277] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6913), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236327] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6920), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236377] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(10275), 1,
      anon_sym_TILDE,
    ACTIONS(10281), 1,
      anon_sym_operator,
    ACTIONS(10331), 1,
      sym_identifier,
    ACTIONS(10333), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10335), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(3527), 1,
      sym_pointer_type_declarator,
    STATE(3529), 1,
      sym_template_function,
    STATE(3530), 1,
      sym_destructor_name,
    STATE(3531), 1,
      sym_dependent_identifier,
    STATE(3532), 1,
      sym_qualified_identifier,
    STATE(3533), 1,
      sym_operator_name,
    STATE(5737), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
    STATE(8665), 1,
      sym_ms_based_modifier,
  [236441] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10337), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5854), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [236481] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10339), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5856), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [236521] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8216), 1,
      anon_sym_STAR,
    ACTIONS(8218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8220), 1,
      anon_sym_AMP,
    ACTIONS(8308), 1,
      anon_sym___attribute,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6466), 1,
      sym__abstract_declarator,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [236567] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10341), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5826), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [236607] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10343), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5821), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [236647] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10345), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5824), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [236687] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6927), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236737] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6921), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236787] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6907), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9973), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9971), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [236869] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10347), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [236921] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10349), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [236973] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8240), 1,
      anon_sym_STAR,
    ACTIONS(10351), 1,
      sym_identifier,
    ACTIONS(10353), 1,
      anon_sym_TILDE,
    ACTIONS(10355), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10357), 1,
      anon_sym_template,
    ACTIONS(10359), 1,
      anon_sym_operator,
    STATE(2534), 1,
      sym_template_type,
    STATE(2556), 1,
      sym_dependent_type_identifier,
    STATE(2615), 1,
      sym_qualified_type_identifier,
    STATE(3544), 1,
      sym_operator_name,
    STATE(3641), 1,
      sym_pointer_type_declarator,
    STATE(3652), 1,
      sym_template_function,
    STATE(3653), 1,
      sym_destructor_name,
    STATE(3665), 1,
      sym_dependent_identifier,
    STATE(3680), 1,
      sym_qualified_identifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
    STATE(8712), 1,
      sym_ms_based_modifier,
  [237037] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4541), 1,
      anon_sym_RBRACK,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10361), 1,
      sym_identifier,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [237089] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6856), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [237139] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8228), 1,
      anon_sym_STAR,
    ACTIONS(8230), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8232), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6452), 1,
      sym__abstract_declarator,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [237183] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6883), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [237233] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10363), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5843), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [237273] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6858), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [237323] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6895), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [237373] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10365), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5837), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [237413] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10367), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [237465] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10369), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [237517] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10371), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [237569] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10373), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5801), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [237609] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(10275), 1,
      anon_sym_TILDE,
    ACTIONS(10281), 1,
      anon_sym_operator,
    ACTIONS(10375), 1,
      sym_identifier,
    ACTIONS(10377), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10379), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(3527), 1,
      sym_pointer_type_declarator,
    STATE(3529), 1,
      sym_template_function,
    STATE(3530), 1,
      sym_destructor_name,
    STATE(3531), 1,
      sym_dependent_identifier,
    STATE(3532), 1,
      sym_qualified_identifier,
    STATE(3533), 1,
      sym_operator_name,
    STATE(5763), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
    STATE(8665), 1,
      sym_ms_based_modifier,
  [237673] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10072), 1,
      anon_sym_PIPE,
    ACTIONS(10074), 1,
      anon_sym_CARET,
    ACTIONS(10076), 1,
      anon_sym_AMP,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10381), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [237723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10385), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10383), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [237751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10170), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10168), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [237783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10170), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10168), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [237811] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10387), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5831), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [237851] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10389), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [237903] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10391), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5699), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [237943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10395), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10393), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [237971] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(10228), 1,
      anon_sym_TILDE,
    ACTIONS(10234), 1,
      anon_sym_operator,
    ACTIONS(10397), 1,
      sym_identifier,
    ACTIONS(10399), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10401), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(2414), 1,
      sym_pointer_type_declarator,
    STATE(2415), 1,
      sym_template_function,
    STATE(2416), 1,
      sym_destructor_name,
    STATE(2417), 1,
      sym_dependent_identifier,
    STATE(2418), 1,
      sym_qualified_identifier,
    STATE(2419), 1,
      sym_operator_name,
    STATE(5772), 1,
      sym__scope_resolution,
    STATE(7984), 1,
      sym_ms_based_modifier,
    STATE(8601), 1,
      sym_decltype,
  [238035] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8240), 1,
      anon_sym_STAR,
    ACTIONS(10353), 1,
      anon_sym_TILDE,
    ACTIONS(10359), 1,
      anon_sym_operator,
    ACTIONS(10403), 1,
      sym_identifier,
    ACTIONS(10405), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10407), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(3544), 1,
      sym_operator_name,
    STATE(3641), 1,
      sym_pointer_type_declarator,
    STATE(3652), 1,
      sym_template_function,
    STATE(3653), 1,
      sym_destructor_name,
    STATE(3665), 1,
      sym_dependent_identifier,
    STATE(3680), 1,
      sym_qualified_identifier,
    STATE(5773), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
    STATE(8712), 1,
      sym_ms_based_modifier,
  [238099] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10072), 1,
      anon_sym_PIPE,
    ACTIONS(10074), 1,
      anon_sym_CARET,
    ACTIONS(10076), 1,
      anon_sym_AMP,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10168), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [238147] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(10228), 1,
      anon_sym_TILDE,
    ACTIONS(10234), 1,
      anon_sym_operator,
    ACTIONS(10409), 1,
      sym_identifier,
    ACTIONS(10411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10413), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(2414), 1,
      sym_pointer_type_declarator,
    STATE(2415), 1,
      sym_template_function,
    STATE(2416), 1,
      sym_destructor_name,
    STATE(2417), 1,
      sym_dependent_identifier,
    STATE(2418), 1,
      sym_qualified_identifier,
    STATE(2419), 1,
      sym_operator_name,
    STATE(5775), 1,
      sym__scope_resolution,
    STATE(7984), 1,
      sym_ms_based_modifier,
    STATE(8601), 1,
      sym_decltype,
  [238211] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10415), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [238263] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10417), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5857), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [238303] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10419), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5798), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [238343] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10421), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5805), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [238383] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10072), 1,
      anon_sym_PIPE,
    ACTIONS(10074), 1,
      anon_sym_CARET,
    ACTIONS(10076), 1,
      anon_sym_AMP,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10168), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [238429] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(4306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(10423), 1,
      sym_identifier,
    ACTIONS(10425), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5781), 1,
      sym__scope_resolution,
    STATE(8344), 1,
      sym_ms_based_modifier,
    STATE(8601), 1,
      sym_decltype,
  [238493] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10427), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5879), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [238533] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10033), 1,
      sym_identifier,
    ACTIONS(10037), 1,
      anon_sym_LPAREN2,
    ACTIONS(10039), 1,
      anon_sym_defined,
    ACTIONS(10429), 1,
      sym_number_literal,
    ACTIONS(10041), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10047), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5764), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [238573] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10180), 1,
      sym_identifier,
    ACTIONS(10182), 1,
      anon_sym_LPAREN2,
    ACTIONS(10184), 1,
      anon_sym_defined,
    ACTIONS(10431), 1,
      sym_number_literal,
    ACTIONS(10186), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10188), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10192), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5815), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [238613] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10433), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [238665] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10435), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [238717] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10437), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [238769] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(10208), 1,
      anon_sym_TILDE,
    ACTIONS(10214), 1,
      anon_sym_operator,
    ACTIONS(10439), 1,
      sym_identifier,
    ACTIONS(10441), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10443), 1,
      anon_sym_template,
    STATE(1813), 1,
      sym_template_type,
    STATE(1814), 1,
      sym_dependent_type_identifier,
    STATE(1888), 1,
      sym_qualified_type_identifier,
    STATE(3225), 1,
      sym_pointer_type_declarator,
    STATE(3228), 1,
      sym_template_function,
    STATE(3229), 1,
      sym_destructor_name,
    STATE(3232), 1,
      sym_dependent_identifier,
    STATE(3234), 1,
      sym_qualified_identifier,
    STATE(3238), 1,
      sym_operator_name,
    STATE(5788), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
    STATE(8665), 1,
      sym_ms_based_modifier,
  [238833] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10445), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [238885] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10160), 1,
      anon_sym_AMP,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_this,
    ACTIONS(10447), 1,
      anon_sym_RBRACK,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7699), 1,
      sym_lambda_default_capture,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7222), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [238937] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6424), 1,
      sym__type_declarator,
    STATE(6899), 1,
      sym__type_definition_declarators,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [238987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10451), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10449), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239014] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10072), 1,
      anon_sym_PIPE,
    ACTIONS(10074), 1,
      anon_sym_CARET,
    ACTIONS(10076), 1,
      anon_sym_AMP,
    ACTIONS(10453), 1,
      anon_sym_RPAREN,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [239063] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8256), 1,
      anon_sym_STAR,
    ACTIONS(8258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8260), 1,
      anon_sym_AMP,
    ACTIONS(8264), 1,
      sym_primitive_type,
    STATE(5920), 1,
      sym__type_declarator,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(8067), 1,
      sym_ms_based_modifier,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [239110] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10455), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2051), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6235), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_using,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [239141] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(10458), 1,
      sym_identifier,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10462), 1,
      anon_sym_template,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8344), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [239198] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10383), 1,
      anon_sym_LF,
    ACTIONS(10385), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [239225] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10464), 1,
      anon_sym_LF,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [239270] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6774), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [239317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10486), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6477), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6479), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [239346] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10488), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [239391] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10325), 1,
      anon_sym_LF,
    ACTIONS(10327), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [239418] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6560), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [239465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10492), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10490), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239492] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10494), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [239537] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10261), 1,
      anon_sym_LF,
    ACTIONS(10263), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [239564] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7289), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(10496), 1,
      sym_identifier,
    ACTIONS(10498), 1,
      anon_sym_template,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5807), 1,
      sym__scope_resolution,
    STATE(8344), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [239621] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10267), 1,
      anon_sym_LF,
    ACTIONS(10269), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [239648] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(2670), 1,
      sym_template_argument_list,
    ACTIONS(4963), 2,
      anon_sym___attribute,
      anon_sym_COLON,
    ACTIONS(4970), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239681] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6219), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [239728] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10285), 1,
      anon_sym_LF,
    ACTIONS(10287), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [239755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10502), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10500), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10506), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10504), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239809] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6743), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [239856] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10508), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [239901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9193), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9182), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(2670), 1,
      sym_template_argument_list,
    ACTIONS(5838), 2,
      anon_sym___attribute,
      anon_sym_COLON,
    ACTIONS(4172), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10512), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10510), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10516), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10514), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10520), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10518), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240042] = 6,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10168), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10170), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [240075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10524), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10522), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240102] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10168), 1,
      anon_sym_LF,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10170), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [240131] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10168), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10170), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [240162] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10168), 1,
      anon_sym_LF,
    ACTIONS(10170), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [240189] = 7,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10168), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10170), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [240224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10528), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10526), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240251] = 3,
    ACTIONS(7038), 1,
      anon_sym_LF,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(7036), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [240278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10532), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10530), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10536), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10534), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240332] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10538), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [240377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10542), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10540), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240404] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10168), 1,
      anon_sym_LF,
    ACTIONS(10170), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [240449] = 11,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10168), 1,
      anon_sym_LF,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10170), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [240492] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10544), 1,
      anon_sym_SEMI,
    ACTIONS(10546), 1,
      anon_sym_COLON,
    STATE(2956), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7162), 1,
      sym_gnu_asm_expression,
    STATE(7163), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [240547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10550), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10548), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240574] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10552), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [240619] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7297), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8312), 1,
      anon_sym_STAR,
    ACTIONS(10554), 1,
      sym_identifier,
    ACTIONS(10556), 1,
      anon_sym_template,
    STATE(5838), 1,
      sym__scope_resolution,
    STATE(6024), 1,
      sym_pointer_type_declarator,
    STATE(6025), 1,
      sym_template_function,
    STATE(6026), 1,
      sym_destructor_name,
    STATE(6027), 1,
      sym_dependent_identifier,
    STATE(6028), 1,
      sym_qualified_identifier,
    STATE(6029), 1,
      sym_operator_name,
    STATE(8365), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9676), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9665), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240703] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10558), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [240748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10562), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10560), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240775] = 10,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10168), 1,
      anon_sym_LF,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10170), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [240816] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10564), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [240861] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10566), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [240906] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6734), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [240953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9849), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9847), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240980] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(6321), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(10120), 1,
      sym_identifier,
    ACTIONS(10122), 1,
      anon_sym_template,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5847), 1,
      sym__scope_resolution,
    STATE(8344), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [241037] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8252), 1,
      sym_identifier,
    ACTIONS(8254), 1,
      anon_sym_LPAREN2,
    ACTIONS(8264), 1,
      sym_primitive_type,
    ACTIONS(8312), 1,
      anon_sym_STAR,
    ACTIONS(8314), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8316), 1,
      anon_sym_AMP,
    STATE(6089), 1,
      sym_pointer_type_declarator,
    STATE(6216), 1,
      sym__type_declarator,
    STATE(8365), 1,
      sym_ms_based_modifier,
    ACTIONS(8262), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6082), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [241084] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(5954), 1,
      sym_template_argument_list,
    ACTIONS(4972), 4,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4965), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [241117] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(7177), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8330), 1,
      anon_sym_STAR,
    ACTIONS(10120), 1,
      sym_identifier,
    ACTIONS(10122), 1,
      anon_sym_template,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5850), 1,
      sym__scope_resolution,
    STATE(8527), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [241174] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8324), 1,
      anon_sym_STAR,
    ACTIONS(8326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8328), 1,
      anon_sym_AMP,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6546), 1,
      sym__abstract_declarator,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [241217] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8236), 1,
      sym_identifier,
    ACTIONS(8238), 1,
      anon_sym_LPAREN2,
    ACTIONS(8240), 1,
      anon_sym_STAR,
    ACTIONS(8242), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8250), 1,
      sym_primitive_type,
    STATE(3077), 1,
      sym__type_declarator,
    STATE(3394), 1,
      sym_pointer_type_declarator,
    STATE(8712), 1,
      sym_ms_based_modifier,
    ACTIONS(8248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [241264] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10220), 1,
      anon_sym_LF,
    ACTIONS(10222), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [241291] = 9,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10168), 1,
      anon_sym_LF,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10170), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [241330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10570), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10568), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [241357] = 8,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10168), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10170), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [241394] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10572), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [241439] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10574), 1,
      sym_identifier,
    ACTIONS(10576), 1,
      anon_sym_template,
    STATE(2776), 1,
      sym_operator_name,
    STATE(2782), 1,
      sym_destructor_name,
    STATE(2786), 1,
      sym_dependent_identifier,
    STATE(2822), 1,
      sym_qualified_identifier,
    STATE(2836), 1,
      sym_pointer_type_declarator,
    STATE(2838), 1,
      sym_template_function,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(8344), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [241496] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(5954), 1,
      sym_template_argument_list,
    ACTIONS(8093), 4,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5036), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [241529] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(2979), 1,
      anon_sym_TILDE,
    ACTIONS(5861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8256), 1,
      anon_sym_STAR,
    ACTIONS(10554), 1,
      sym_identifier,
    ACTIONS(10556), 1,
      anon_sym_template,
    STATE(5860), 1,
      sym__scope_resolution,
    STATE(6024), 1,
      sym_pointer_type_declarator,
    STATE(6025), 1,
      sym_template_function,
    STATE(6026), 1,
      sym_destructor_name,
    STATE(6027), 1,
      sym_dependent_identifier,
    STATE(6028), 1,
      sym_qualified_identifier,
    STATE(6029), 1,
      sym_operator_name,
    STATE(8067), 1,
      sym_ms_based_modifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [241586] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8318), 1,
      anon_sym_STAR,
    ACTIONS(8320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8322), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6530), 1,
      sym__abstract_declarator,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8306), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [241629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10580), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10578), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [241656] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    ACTIONS(8292), 1,
      sym_primitive_type,
    STATE(2194), 1,
      sym__type_declarator,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(7984), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [241703] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(10582), 1,
      anon_sym_LBRACE,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    STATE(7188), 1,
      sym_trailing_return_type,
    STATE(8327), 1,
      sym_requires_clause,
    STATE(6402), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6665), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6676), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [241750] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10393), 1,
      anon_sym_LF,
    ACTIONS(10395), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [241777] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(10588), 1,
      anon_sym_LBRACE,
    STATE(5875), 1,
      sym_parameter_list,
    STATE(8505), 1,
      sym_trailing_return_type,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5975), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6844), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [241824] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10590), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [241869] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8330), 1,
      anon_sym_STAR,
    ACTIONS(8332), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8334), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6727), 1,
      sym__type_declarator,
    STATE(8527), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [241916] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(10592), 1,
      anon_sym_LBRACE,
    STATE(7474), 1,
      sym_trailing_return_type,
    STATE(8330), 1,
      sym_requires_clause,
    STATE(6402), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6668), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6669), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [241963] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10174), 1,
      anon_sym_LF,
    ACTIONS(10176), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [241990] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10066), 1,
      anon_sym_SLASH,
    ACTIONS(10068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10072), 1,
      anon_sym_PIPE,
    ACTIONS(10074), 1,
      anon_sym_CARET,
    ACTIONS(10076), 1,
      anon_sym_AMP,
    ACTIONS(10594), 1,
      anon_sym_RPAREN,
    ACTIONS(10062), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10064), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10078), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10080), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10082), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [242039] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10596), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [242084] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8266), 1,
      sym_identifier,
    ACTIONS(8268), 1,
      anon_sym_LPAREN2,
    ACTIONS(8270), 1,
      anon_sym_STAR,
    ACTIONS(8272), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8274), 1,
      anon_sym_AMP,
    ACTIONS(8278), 1,
      sym_primitive_type,
    STATE(2925), 1,
      sym__type_declarator,
    STATE(3288), 1,
      sym_pointer_type_declarator,
    STATE(8665), 1,
      sym_ms_based_modifier,
    ACTIONS(8276), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3285), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [242131] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(10598), 1,
      anon_sym_LBRACE,
    STATE(7514), 1,
      sym_trailing_return_type,
    STATE(8488), 1,
      sym_requires_clause,
    STATE(5864), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6697), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6695), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [242178] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(10600), 1,
      anon_sym_LBRACE,
    STATE(7208), 1,
      sym_trailing_return_type,
    STATE(7927), 1,
      sym_requires_clause,
    STATE(5869), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6643), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6707), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [242225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9845), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9843), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [242252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9355), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9344), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [242279] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8280), 1,
      sym_identifier,
    ACTIONS(8282), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      sym_primitive_type,
    ACTIONS(8300), 1,
      anon_sym_STAR,
    ACTIONS(8302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8304), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_pointer_type_declarator,
    STATE(6717), 1,
      sym__type_declarator,
    STATE(8344), 1,
      sym_ms_based_modifier,
    ACTIONS(8290), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2218), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [242326] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10602), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [242371] = 12,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10470), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10474), 1,
      anon_sym_PIPE,
    ACTIONS(10476), 1,
      anon_sym_CARET,
    ACTIONS(10478), 1,
      anon_sym_AMP,
    ACTIONS(10604), 1,
      anon_sym_LF,
    ACTIONS(10466), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10484), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10468), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10482), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [242416] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    STATE(5418), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9355), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [242454] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9376), 1,
      anon_sym_requires,
    STATE(5448), 1,
      sym_trailing_return_type,
    ACTIONS(9355), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [242492] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9696), 1,
      anon_sym_requires,
    STATE(5450), 1,
      sym_trailing_return_type,
    ACTIONS(9676), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [242530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym___attribute,
    ACTIONS(5138), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [242556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym___attribute,
    ACTIONS(10606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10608), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6255), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [242586] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(10610), 1,
      anon_sym_virtual,
    STATE(1893), 1,
      sym_template_type,
    STATE(6404), 1,
      sym_access_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(5923), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7314), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10612), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [242634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym___attribute,
    ACTIONS(5138), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [242660] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9849), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6048), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [242694] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(6056), 1,
      sym_parameter_list,
    ACTIONS(6164), 2,
      anon_sym___attribute,
      anon_sym___asm,
    STATE(5960), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6166), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [242730] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10110), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7310), 1,
      sym_gnu_asm_expression,
    STATE(7311), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [242782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 1,
      anon_sym___attribute,
    ACTIONS(5194), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [242808] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9922), 1,
      anon_sym_requires,
    STATE(5452), 1,
      sym_trailing_return_type,
    ACTIONS(9845), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [242846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(5954), 1,
      sym_template_argument_list,
    ACTIONS(6513), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6515), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [242876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 1,
      anon_sym___attribute,
    ACTIONS(5164), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [242902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9849), 1,
      anon_sym___attribute,
    ACTIONS(10619), 1,
      anon_sym_requires,
    ACTIONS(10616), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6048), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [242936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym___attribute,
    ACTIONS(1938), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [242962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6700), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [242988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym___attribute,
    ACTIONS(5150), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 1,
      anon_sym___attribute,
    ACTIONS(5186), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3949), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [243066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym___attribute,
    ACTIONS(1934), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243092] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10019), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7260), 1,
      sym_gnu_asm_expression,
    STATE(7262), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [243144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6479), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243170] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    ACTIONS(9708), 1,
      anon_sym_requires,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [243204] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10544), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7162), 1,
      sym_gnu_asm_expression,
    STATE(7163), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [243256] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [243290] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(6056), 1,
      sym_parameter_list,
    ACTIONS(6066), 2,
      anon_sym___attribute,
      anon_sym___asm,
    STATE(5960), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6068), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5132), 1,
      anon_sym___attribute,
    ACTIONS(5134), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243352] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [243386] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      anon_sym_LPAREN2,
    ACTIONS(7856), 1,
      anon_sym_LBRACK,
    ACTIONS(8367), 1,
      anon_sym_STAR,
    ACTIONS(8369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8371), 1,
      anon_sym_AMP,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(5792), 1,
      sym__function_declarator_seq,
    STATE(6575), 1,
      sym__abstract_declarator,
    ACTIONS(8306), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5804), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [243428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      anon_sym___attribute,
    ACTIONS(5154), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243454] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(6056), 1,
      sym_parameter_list,
    ACTIONS(6100), 2,
      anon_sym___attribute,
      anon_sym___asm,
    STATE(5960), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6102), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 1,
      anon_sym___attribute,
    ACTIONS(5142), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243516] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(9999), 1,
      anon_sym_SEMI,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7380), 1,
      sym_gnu_asm_expression,
    STATE(7381), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [243568] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    STATE(5453), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9193), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [243606] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    ACTIONS(10144), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7295), 1,
      sym_gnu_asm_expression,
    STATE(7522), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [243658] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(10622), 1,
      anon_sym_virtual,
    STATE(1893), 1,
      sym_template_type,
    STATE(6488), 1,
      sym_access_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6990), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10612), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [243706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 1,
      anon_sym___attribute,
    ACTIONS(5146), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5188), 1,
      anon_sym___attribute,
    ACTIONS(5190), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243758] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(6056), 1,
      sym_parameter_list,
    ACTIONS(6133), 2,
      anon_sym___attribute,
      anon_sym___asm,
    STATE(5960), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6135), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243794] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    STATE(5419), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9676), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [243832] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    STATE(5420), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9845), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [243870] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(10624), 1,
      anon_sym_virtual,
    STATE(1893), 1,
      sym_template_type,
    STATE(6520), 1,
      sym_access_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10612), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [243918] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(10626), 1,
      anon_sym_virtual,
    STATE(1893), 1,
      sym_template_type,
    STATE(6502), 1,
      sym_access_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(5917), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10612), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [243966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10130), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10128), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6178), 1,
      anon_sym___attribute,
    ACTIONS(10608), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6180), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244024] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [244058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3951), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3953), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [244084] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    ACTIONS(9300), 1,
      anon_sym_requires,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [244118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym___attribute,
    ACTIONS(5138), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 1,
      anon_sym___attribute,
    ACTIONS(5172), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244170] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_requires,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [244204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 1,
      anon_sym___attribute,
    ACTIONS(5182), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244230] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(6056), 1,
      sym_parameter_list,
    ACTIONS(6038), 2,
      anon_sym___attribute,
      anon_sym___asm,
    STATE(5960), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6040), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244266] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    ACTIONS(10631), 1,
      anon_sym_requires,
    ACTIONS(10628), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [244300] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7313), 1,
      anon_sym_DASH_GT,
    ACTIONS(9281), 1,
      anon_sym_requires,
    STATE(5447), 1,
      sym_trailing_return_type,
    ACTIONS(9193), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [244338] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10544), 1,
      anon_sym_SEMI,
    ACTIONS(10634), 1,
      anon_sym_EQ,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7162), 1,
      sym_gnu_asm_expression,
    STATE(7163), 1,
      aux_sym_declaration_repeat1,
    STATE(7373), 1,
      sym_initializer_list,
    STATE(7680), 1,
      sym_argument_list,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10053), 1,
      anon_sym___attribute,
    ACTIONS(10636), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10051), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 1,
      anon_sym___attribute,
    ACTIONS(5168), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244448] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [244482] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    STATE(5621), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [244519] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    ACTIONS(9300), 1,
      anon_sym_requires,
    STATE(5932), 1,
      sym_trailing_return_type,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [244556] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(5904), 1,
      sym_trailing_return_type,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [244593] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    ACTIONS(9708), 1,
      anon_sym_requires,
    STATE(5935), 1,
      sym_trailing_return_type,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [244630] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    ACTIONS(10631), 1,
      anon_sym_requires,
    STATE(5895), 1,
      sym_trailing_return_type,
    ACTIONS(10628), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [244667] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8373), 1,
      anon_sym_STAR,
    ACTIONS(8375), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8377), 1,
      anon_sym_AMP,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6640), 1,
      sym__abstract_declarator,
    ACTIONS(8306), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [244708] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    STATE(5991), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8049), 1,
      sym_ms_based_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [244751] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8427), 1,
      sym_identifier,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8431), 1,
      anon_sym_STAR,
    ACTIONS(8433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8435), 1,
      anon_sym_AMP,
    STATE(6107), 1,
      sym__field_declarator,
    STATE(6299), 1,
      sym_operator_name,
    STATE(8049), 1,
      sym_ms_based_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [244794] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10641), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10639), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244823] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    ACTIONS(10094), 1,
      anon_sym_requires,
    STATE(5555), 1,
      sym_trailing_return_type,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [244860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5997), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10645), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10650), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(10648), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    STATE(5952), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
    ACTIONS(10643), 7,
      anon_sym_COLON,
      anon_sym___declspec,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
  [244916] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9360), 1,
      anon_sym_requires,
    STATE(5544), 1,
      sym_trailing_return_type,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [244953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5005), 4,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4998), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244980] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9198), 1,
      anon_sym_requires,
    STATE(5514), 1,
      sym_trailing_return_type,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [245017] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    STATE(5940), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [245054] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    STATE(5888), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [245091] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9684), 1,
      anon_sym_requires,
    STATE(5554), 1,
      sym_trailing_return_type,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [245128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10653), 1,
      sym_identifier,
    ACTIONS(5396), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(5970), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10655), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10657), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [245159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6249), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6251), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245188] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8473), 1,
      anon_sym_STAR,
    ACTIONS(8475), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8477), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6684), 1,
      sym__abstract_declarator,
    ACTIONS(8306), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [245229] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8459), 1,
      sym_identifier,
    ACTIONS(8461), 1,
      anon_sym_STAR,
    ACTIONS(8463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8465), 1,
      anon_sym_AMP,
    STATE(6710), 1,
      sym__field_declarator,
    STATE(6800), 1,
      sym_operator_name,
    STATE(8225), 1,
      sym_ms_based_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [245272] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(5616), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [245309] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(8429), 1,
      anon_sym_LPAREN2,
    ACTIONS(8459), 1,
      sym_identifier,
    ACTIONS(8461), 1,
      anon_sym_STAR,
    ACTIONS(8463), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8465), 1,
      anon_sym_AMP,
    STATE(6715), 1,
      sym__field_declarator,
    STATE(6800), 1,
      sym_operator_name,
    STATE(8225), 1,
      sym_ms_based_modifier,
    STATE(6399), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [245352] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(113), 1,
      anon_sym___asm,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(9997), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10003), 1,
      anon_sym_EQ,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(7760), 1,
      sym_gnu_asm_expression,
    ACTIONS(10005), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10659), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7680), 2,
      sym_argument_list,
      sym_initializer_list,
  [245399] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(5491), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [245436] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10661), 1,
      sym_identifier,
    ACTIONS(5390), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(5959), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10655), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10657), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [245467] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10663), 1,
      anon_sym_AMP,
    ACTIONS(10665), 1,
      sym_this,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7445), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [245510] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(10588), 1,
      anon_sym_LBRACE,
    STATE(8505), 1,
      sym_trailing_return_type,
    STATE(6402), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6844), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [245551] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10667), 1,
      sym_identifier,
    ACTIONS(5403), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(5970), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10670), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10673), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [245582] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6649), 1,
      sym__abstract_declarator,
    ACTIONS(8306), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [245623] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_requires,
    ACTIONS(7087), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5534), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [245660] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4535), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10156), 1,
      sym_identifier,
    ACTIONS(10158), 1,
      anon_sym_STAR,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10663), 1,
      anon_sym_AMP,
    ACTIONS(10676), 1,
      sym_this,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7750), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [245703] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    STATE(5909), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [245740] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_noexcept,
    ACTIONS(7074), 1,
      anon_sym_throw,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(10678), 1,
      anon_sym_LBRACE,
    STATE(8729), 1,
      sym_trailing_return_type,
    STATE(6402), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    STATE(6784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6787), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9811), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
  [245781] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7447), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    STATE(5927), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [245818] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    ACTIONS(10682), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(6936), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [245851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6208), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6210), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10686), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10684), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6269), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6271), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6275), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6286), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6288), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245971] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(6252), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [246007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    ACTIONS(9182), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246031] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [246063] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10688), 1,
      sym_identifier,
    ACTIONS(10690), 1,
      sym_primitive_type,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(2474), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [246103] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10692), 1,
      sym_identifier,
    ACTIONS(10694), 1,
      sym_primitive_type,
    STATE(1625), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(2959), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9442), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [246143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10580), 1,
      anon_sym___attribute,
    ACTIONS(10578), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6224), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10570), 1,
      anon_sym___attribute,
    ACTIONS(10568), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246215] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9774), 1,
      anon_sym_COLON,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10698), 1,
      anon_sym___attribute,
    ACTIONS(10700), 1,
      anon_sym_EQ,
    STATE(2863), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(7031), 1,
      sym_bitfield_clause,
    STATE(7050), 1,
      sym_initializer_list,
    STATE(6298), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10696), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [246261] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10702), 1,
      sym_identifier,
    ACTIONS(10704), 1,
      sym_primitive_type,
    STATE(4069), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(4906), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8023), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [246301] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9316), 1,
      anon_sym_requires,
    STATE(6254), 1,
      sym_trailing_return_type,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [246337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10708), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10706), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10712), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10710), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246385] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10275), 1,
      anon_sym_TILDE,
    ACTIONS(10714), 1,
      sym_identifier,
    ACTIONS(10716), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10719), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10721), 1,
      anon_sym_template,
    STATE(6350), 1,
      sym__scope_resolution,
    STATE(7892), 1,
      sym_operator_name,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3441), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [246427] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10723), 1,
      sym_identifier,
    ACTIONS(10725), 1,
      sym_primitive_type,
    STATE(1594), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(2231), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9483), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [246467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5036), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10562), 1,
      anon_sym___attribute,
    ACTIONS(10560), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246515] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10727), 1,
      sym_identifier,
    ACTIONS(10729), 1,
      sym_primitive_type,
    STATE(1869), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(1870), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9426), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [246555] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10735), 1,
      anon_sym___asm,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246587] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10737), 1,
      sym_identifier,
    ACTIONS(10739), 1,
      sym_primitive_type,
    STATE(1860), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(3985), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [246627] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10743), 1,
      anon_sym___asm,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246659] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym___asm,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246691] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10751), 1,
      anon_sym___asm,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246723] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym___asm,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246755] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10759), 1,
      anon_sym___asm,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246787] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10763), 1,
      anon_sym___asm,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246819] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10767), 1,
      anon_sym___asm,
    STATE(2885), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10771), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10769), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246875] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(6198), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [246911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    ACTIONS(9344), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246935] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [246967] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10773), 1,
      sym_identifier,
    ACTIONS(10775), 1,
      sym_primitive_type,
    STATE(4239), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(2698), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [247007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10512), 1,
      anon_sym___attribute,
    ACTIONS(10510), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [247031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym___attribute,
    ACTIONS(10530), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [247055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10536), 1,
      anon_sym___attribute,
    ACTIONS(10534), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [247079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10542), 1,
      anon_sym___attribute,
    ACTIONS(10540), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [247103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6178), 1,
      anon_sym___attribute,
    ACTIONS(10777), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6180), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [247129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym___attribute,
    ACTIONS(10777), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10779), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6255), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [247157] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10781), 1,
      sym_identifier,
    ACTIONS(10783), 1,
      sym_primitive_type,
    STATE(2359), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(2474), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [247197] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10785), 1,
      sym_identifier,
    ACTIONS(10787), 1,
      sym_primitive_type,
    STATE(1592), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(2231), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9386), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [247237] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9472), 1,
      anon_sym_requires,
    STATE(6260), 1,
      sym_trailing_return_type,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [247273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4965), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [247297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4965), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [247321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4965), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [247345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4965), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [247369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4965), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [247393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4965), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [247417] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10789), 1,
      sym_identifier,
    ACTIONS(10791), 1,
      sym_primitive_type,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(4695), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [247457] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(6228), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [247493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    ACTIONS(9665), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [247517] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [247549] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    ACTIONS(9498), 1,
      anon_sym_requires,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [247581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10795), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10793), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [247605] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9711), 1,
      anon_sym_requires,
    STATE(6261), 1,
      sym_trailing_return_type,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [247641] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10688), 1,
      sym_identifier,
    ACTIONS(10690), 1,
      sym_primitive_type,
    STATE(5032), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(2474), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9648), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [247681] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    ACTIONS(9328), 1,
      anon_sym_requires,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [247713] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8568), 1,
      anon_sym_STAR,
    ACTIONS(8570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8572), 1,
      anon_sym_AMP,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6755), 1,
      sym__abstract_declarator,
    ACTIONS(8306), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [247753] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    ACTIONS(10797), 1,
      anon_sym_requires,
    STATE(6263), 1,
      sym_trailing_return_type,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [247789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    ACTIONS(9843), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [247813] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [247845] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 1,
      anon_sym_DASH_GT,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    STATE(6197), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [247881] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10789), 1,
      sym_identifier,
    ACTIONS(10791), 1,
      sym_primitive_type,
    STATE(3931), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(4695), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8057), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [247921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9849), 1,
      anon_sym___attribute,
    ACTIONS(9847), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [247945] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(9849), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6048), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [247977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10502), 1,
      anon_sym___attribute,
    ACTIONS(10500), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10550), 1,
      anon_sym___attribute,
    ACTIONS(10548), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10506), 1,
      anon_sym___attribute,
    ACTIONS(10504), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6220), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [248073] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10735), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248105] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10743), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248169] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10751), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248201] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6297), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [248257] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10759), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248289] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10763), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248321] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10767), 1,
      anon_sym___attribute,
    STATE(2860), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248353] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10775), 1,
      sym_primitive_type,
    ACTIONS(10800), 1,
      sym_identifier,
    STATE(2170), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(2698), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9408), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [248393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10804), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10802), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [248417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10808), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10806), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [248441] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    ACTIONS(9714), 1,
      anon_sym_requires,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [248473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    ACTIONS(10810), 1,
      anon_sym_requires,
    ACTIONS(10628), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [248505] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10688), 1,
      sym_identifier,
    ACTIONS(10690), 1,
      sym_primitive_type,
    STATE(2674), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(2474), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3909), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [248545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10815), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10813), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [248569] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9849), 1,
      anon_sym___attribute,
    ACTIONS(10817), 1,
      anon_sym_requires,
    ACTIONS(10616), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6048), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [248601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6546), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [248625] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10729), 1,
      sym_primitive_type,
    ACTIONS(10820), 1,
      sym_identifier,
    STATE(4209), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(1870), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1810), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [248665] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10781), 1,
      sym_identifier,
    ACTIONS(10783), 1,
      sym_primitive_type,
    STATE(2359), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(2474), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [248705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10516), 1,
      anon_sym___attribute,
    ACTIONS(10514), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10735), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10520), 1,
      anon_sym___attribute,
    ACTIONS(10518), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10524), 1,
      anon_sym___attribute,
    ACTIONS(10522), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10824), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10822), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [248833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10528), 1,
      anon_sym___attribute,
    ACTIONS(10526), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248857] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10743), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248889] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248921] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10751), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248953] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6279), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [249009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6194), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [249033] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10759), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [249065] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10763), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [249097] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10767), 1,
      anon_sym___asm,
    STATE(2902), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [249129] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10826), 1,
      sym_identifier,
    ACTIONS(10828), 1,
      sym_primitive_type,
    STATE(1637), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(3134), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9530), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [249169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10451), 1,
      anon_sym___attribute,
    ACTIONS(10449), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [249193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6196), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6198), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [249217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6200), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6202), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [249241] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10830), 1,
      sym_identifier,
    ACTIONS(10832), 1,
      sym_primitive_type,
    STATE(1619), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(2851), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9505), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [249281] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10834), 1,
      sym_identifier,
    ACTIONS(10836), 1,
      sym_primitive_type,
    STATE(4882), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(1870), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7992), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [249321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10492), 1,
      anon_sym___attribute,
    ACTIONS(10490), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [249345] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7391), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249374] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    STATE(6013), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [249409] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    STATE(6033), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [249444] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    STATE(6042), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [249479] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    STATE(6046), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [249514] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10840), 1,
      anon_sym___asm,
    STATE(2956), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10838), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [249549] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(5904), 1,
      sym_trailing_return_type,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [249582] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [249617] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6063), 1,
      sym_trailing_return_type,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [249652] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    ACTIONS(9714), 1,
      anon_sym_requires,
    STATE(6064), 1,
      sym_trailing_return_type,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [249687] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    ACTIONS(10810), 1,
      anon_sym_requires,
    STATE(6067), 1,
      sym_trailing_return_type,
    ACTIONS(10628), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [249722] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    STATE(5940), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [249755] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10228), 1,
      anon_sym_TILDE,
    ACTIONS(10842), 1,
      sym_identifier,
    ACTIONS(10844), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10846), 1,
      anon_sym_template,
    STATE(6302), 1,
      sym__scope_resolution,
    STATE(7700), 1,
      sym_operator_name,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2449), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [249794] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10850), 1,
      anon_sym___attribute,
    STATE(2863), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6298), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10848), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [249829] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10854), 1,
      anon_sym___attribute,
    STATE(2863), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6298), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10852), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [249864] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(9708), 1,
      anon_sym_requires,
    STATE(5935), 1,
      sym_trailing_return_type,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [249897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7247), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249926] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    STATE(6013), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [249959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7320), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249988] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(10631), 1,
      anon_sym_requires,
    STATE(5895), 1,
      sym_trailing_return_type,
    ACTIONS(10628), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [250021] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    STATE(6207), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250056] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    STATE(6229), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250091] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    STATE(6239), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250126] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    STATE(6253), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250161] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    STATE(5888), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [250194] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(10810), 1,
      anon_sym_requires,
    STATE(6067), 1,
      sym_trailing_return_type,
    ACTIONS(10628), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [250227] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    STATE(6046), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [250260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8172), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [250289] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7291), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [250318] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    ACTIONS(9341), 1,
      anon_sym_requires,
    STATE(6188), 1,
      sym_trailing_return_type,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250353] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    ACTIONS(9629), 1,
      anon_sym_requires,
    STATE(6189), 1,
      sym_trailing_return_type,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250388] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    ACTIONS(9717), 1,
      anon_sym_requires,
    STATE(6190), 1,
      sym_trailing_return_type,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250423] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7653), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    ACTIONS(10856), 1,
      anon_sym_requires,
    STATE(6191), 1,
      sym_trailing_return_type,
    ACTIONS(10628), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250458] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7154), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [250487] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    STATE(5927), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [250520] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7187), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [250549] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7308), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [250578] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    STATE(5909), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [250611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7328), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [250640] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10353), 1,
      anon_sym_TILDE,
    ACTIONS(10859), 1,
      sym_identifier,
    ACTIONS(10861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10863), 1,
      anon_sym_template,
    STATE(6285), 1,
      sym__scope_resolution,
    STATE(7745), 1,
      sym_operator_name,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3611), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [250679] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    STATE(6033), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [250712] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7416), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [250741] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10867), 1,
      anon_sym___asm,
    STATE(2956), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10865), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [250776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7485), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [250805] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10871), 1,
      anon_sym___attribute,
    STATE(2863), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6298), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10869), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [250840] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7502), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [250869] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [250902] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8602), 1,
      anon_sym_STAR,
    ACTIONS(8604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6779), 1,
      sym__abstract_declarator,
    ACTIONS(8306), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [250941] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10875), 1,
      anon_sym___asm,
    STATE(2956), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10873), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [250976] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10840), 1,
      anon_sym___asm,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10838), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [251011] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10228), 1,
      anon_sym_TILDE,
    ACTIONS(10842), 1,
      sym_identifier,
    ACTIONS(10877), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10879), 1,
      anon_sym_template,
    STATE(6277), 1,
      sym__scope_resolution,
    STATE(7632), 1,
      sym_operator_name,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2449), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [251050] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5967), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5914), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(10655), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10657), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251077] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8428), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251106] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10883), 1,
      anon_sym___attribute,
    STATE(2863), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6298), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10881), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [251141] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10887), 1,
      anon_sym___asm,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10885), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [251176] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(10891), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10893), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10895), 1,
      aux_sym_preproc_elif_token1,
    STATE(6411), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6412), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6732), 1,
      sym_enumerator,
    ACTIONS(10897), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8202), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8213), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [251215] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10867), 1,
      anon_sym___asm,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10865), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [251250] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9714), 1,
      anon_sym_requires,
    STATE(6064), 1,
      sym_trailing_return_type,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [251283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7557), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251312] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10901), 1,
      anon_sym___attribute,
    STATE(2863), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6298), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10899), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [251347] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_DASH_GT,
    ACTIONS(9300), 1,
      anon_sym_requires,
    STATE(5932), 1,
      sym_trailing_return_type,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [251380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7366), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251409] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10905), 1,
      anon_sym___asm,
    STATE(2956), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10903), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [251444] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(10893), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10895), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10907), 1,
      aux_sym_preproc_if_token2,
    STATE(6427), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6428), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6732), 1,
      sym_enumerator,
    ACTIONS(10897), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8504), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8573), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [251483] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(10893), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10895), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10909), 1,
      aux_sym_preproc_if_token2,
    STATE(6494), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6496), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6732), 1,
      sym_enumerator,
    ACTIONS(10897), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8523), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8524), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [251522] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7954), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251551] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8078), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251580] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8151), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251609] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8204), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251638] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(10893), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10895), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10911), 1,
      aux_sym_preproc_if_token2,
    STATE(6514), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6523), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6732), 1,
      sym_enumerator,
    ACTIONS(10897), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8472), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
    STATE(8837), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [251677] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(7337), 1,
      anon_sym_requires,
    STATE(6042), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [251710] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8250), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7201), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251768] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10275), 1,
      anon_sym_TILDE,
    ACTIONS(10714), 1,
      sym_identifier,
    ACTIONS(10719), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10721), 1,
      anon_sym_template,
    STATE(6350), 1,
      sym__scope_resolution,
    STATE(7892), 1,
      sym_operator_name,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3441), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [251807] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10875), 1,
      anon_sym___asm,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10873), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [251842] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10905), 1,
      anon_sym___asm,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10903), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [251877] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6063), 1,
      sym_trailing_return_type,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [251910] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10680), 1,
      sym_identifier,
    STATE(6144), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7252), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251939] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10887), 1,
      anon_sym___asm,
    STATE(2956), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10885), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [251974] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8679), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4577), 1,
      sym_enumerator_list,
    STATE(6615), 1,
      sym__scope_resolution,
    ACTIONS(10913), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4949), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252014] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10767), 1,
      anon_sym___attribute,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [252044] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10915), 1,
      anon_sym_SEMI,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10919), 1,
      anon_sym_EQ,
    ACTIONS(10921), 1,
      anon_sym_try,
    STATE(696), 1,
      sym_compound_statement,
    STATE(7585), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(650), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [252082] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    STATE(6229), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252114] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10743), 1,
      anon_sym___attribute,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [252144] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    STATE(6239), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252176] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    STATE(6253), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252208] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5987), 1,
      anon_sym_LBRACE,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2200), 1,
      sym_enumerator_list,
    STATE(6580), 1,
      sym__scope_resolution,
    ACTIONS(10923), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2528), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252248] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6850), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2852), 1,
      sym_enumerator_list,
    STATE(6620), 1,
      sym__scope_resolution,
    ACTIONS(10925), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2671), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252288] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(6572), 1,
      sym_access_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(7548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10612), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [252326] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8306), 1,
      anon_sym_COLON,
    ACTIONS(8685), 1,
      anon_sym_STAR,
    ACTIONS(8687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8689), 1,
      anon_sym_AMP,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6863), 1,
      sym__abstract_declarator,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [252364] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(3608), 1,
      sym_enumerator_list,
    STATE(6592), 1,
      sym__scope_resolution,
    ACTIONS(10927), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6512), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252404] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6066), 1,
      anon_sym___asm,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(6056), 1,
      sym_parameter_list,
    STATE(6308), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6068), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [252436] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(6527), 1,
      sym_access_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(7068), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10612), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [252474] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8991), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4856), 1,
      sym_enumerator_list,
    STATE(6632), 1,
      sym__scope_resolution,
    ACTIONS(10929), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252514] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    ACTIONS(9341), 1,
      anon_sym_requires,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252544] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    ACTIONS(9629), 1,
      anon_sym_requires,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252574] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    ACTIONS(9717), 1,
      anon_sym_requires,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252604] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    ACTIONS(10856), 1,
      anon_sym_requires,
    ACTIONS(10628), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252634] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9849), 1,
      anon_sym___attribute,
    ACTIONS(10931), 1,
      anon_sym_requires,
    ACTIONS(10616), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6048), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252664] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_enumerator_list,
    STATE(6626), 1,
      sym__scope_resolution,
    ACTIONS(10934), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3877), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252704] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7951), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3942), 1,
      sym_enumerator_list,
    STATE(6634), 1,
      sym__scope_resolution,
    ACTIONS(10936), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3576), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252744] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(5146), 1,
      sym_enumerator_list,
    STATE(6593), 1,
      sym__scope_resolution,
    ACTIONS(10938), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4846), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252784] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6038), 1,
      anon_sym___attribute,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6040), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [252816] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252846] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9849), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5836), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [252876] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [252906] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(5453), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [252940] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(5418), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [252974] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(5419), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [253008] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_requires,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    STATE(5420), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [253042] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9281), 1,
      anon_sym_requires,
    STATE(5447), 1,
      sym_trailing_return_type,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [253076] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9376), 1,
      anon_sym_requires,
    STATE(5448), 1,
      sym_trailing_return_type,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [253110] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9696), 1,
      anon_sym_requires,
    STATE(5450), 1,
      sym_trailing_return_type,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [253144] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    ACTIONS(9922), 1,
      anon_sym_requires,
    STATE(5452), 1,
      sym_trailing_return_type,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [253178] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [253208] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10942), 1,
      anon_sym_EQ,
    STATE(2981), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    ACTIONS(10940), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6759), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [253248] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(9341), 1,
      anon_sym_requires,
    STATE(6188), 1,
      sym_trailing_return_type,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [253280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6178), 1,
      anon_sym_LBRACK,
    ACTIONS(10944), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6180), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [253304] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(9629), 1,
      anon_sym_requires,
    STATE(6189), 1,
      sym_trailing_return_type,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [253336] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(9717), 1,
      anon_sym_requires,
    STATE(6190), 1,
      sym_trailing_return_type,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [253368] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(10856), 1,
      anon_sym_requires,
    STATE(6191), 1,
      sym_trailing_return_type,
    ACTIONS(10628), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [253400] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10946), 1,
      anon_sym_SEMI,
    ACTIONS(10948), 1,
      anon_sym_LBRACE,
    ACTIONS(10950), 1,
      anon_sym_EQ,
    ACTIONS(10952), 1,
      anon_sym_try,
    STATE(2031), 1,
      sym_compound_statement,
    STATE(7886), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2032), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [253438] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2614), 1,
      sym_enumerator_list,
    STATE(6594), 1,
      sym__scope_resolution,
    ACTIONS(10954), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4035), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253478] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 1,
      anon_sym___asm,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(6056), 1,
      sym_parameter_list,
    STATE(6308), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6135), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [253510] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10956), 1,
      anon_sym_SEMI,
    ACTIONS(10958), 1,
      anon_sym_LBRACE,
    ACTIONS(10960), 1,
      anon_sym_EQ,
    ACTIONS(10962), 1,
      anon_sym_try,
    STATE(2119), 1,
      sym_compound_statement,
    STATE(7791), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2121), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [253548] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10964), 1,
      anon_sym_SEMI,
    ACTIONS(10966), 1,
      anon_sym_LBRACE,
    ACTIONS(10968), 1,
      anon_sym_EQ,
    ACTIONS(10970), 1,
      anon_sym_try,
    STATE(1796), 1,
      sym_compound_statement,
    STATE(7674), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1797), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [253586] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(6133), 1,
      anon_sym___attribute,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6135), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [253618] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym___attribute,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [253648] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2875), 1,
      sym_enumerator_list,
    STATE(6606), 1,
      sym__scope_resolution,
    ACTIONS(10972), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253688] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10974), 1,
      anon_sym_SEMI,
    ACTIONS(10976), 1,
      anon_sym_EQ,
    ACTIONS(10978), 1,
      anon_sym_try,
    STATE(284), 1,
      sym_compound_statement,
    STATE(7686), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(285), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [253726] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10751), 1,
      anon_sym___attribute,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [253756] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10966), 1,
      anon_sym_LBRACE,
    ACTIONS(10968), 1,
      anon_sym_EQ,
    ACTIONS(10970), 1,
      anon_sym_try,
    ACTIONS(10980), 1,
      anon_sym_SEMI,
    STATE(1827), 1,
      sym_compound_statement,
    STATE(7710), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1828), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [253794] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 1,
      anon_sym___asm,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(6056), 1,
      sym_parameter_list,
    STATE(6308), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6166), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [253826] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_enumerator_list,
    STATE(6587), 1,
      sym__scope_resolution,
    ACTIONS(10982), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4890), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [253866] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6100), 1,
      anon_sym___asm,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(6056), 1,
      sym_parameter_list,
    STATE(6308), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6102), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [253898] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [253928] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [253958] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym___attribute,
    ACTIONS(10984), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10986), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6255), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [253984] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10958), 1,
      anon_sym_LBRACE,
    ACTIONS(10960), 1,
      anon_sym_EQ,
    ACTIONS(10962), 1,
      anon_sym_try,
    ACTIONS(10988), 1,
      anon_sym_SEMI,
    STATE(2041), 1,
      sym_compound_statement,
    STATE(7825), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2134), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [254022] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10990), 1,
      anon_sym_SEMI,
    ACTIONS(10992), 1,
      anon_sym_EQ,
    ACTIONS(10994), 1,
      anon_sym_try,
    STATE(653), 1,
      sym_compound_statement,
    STATE(7594), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(655), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [254060] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(6549), 1,
      sym_access_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(6990), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10612), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [254098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym_LBRACK,
    ACTIONS(10944), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10996), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6255), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [254124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6178), 1,
      anon_sym___attribute,
    ACTIONS(10986), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6180), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [254148] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym___attribute,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [254178] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9316), 1,
      anon_sym_requires,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [254208] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(6100), 1,
      anon_sym___attribute,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6102), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [254240] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9845), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [254270] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(3608), 1,
      sym_enumerator_list,
    STATE(6615), 1,
      sym__scope_resolution,
    ACTIONS(10998), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3939), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254310] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2875), 1,
      sym_enumerator_list,
    STATE(6604), 1,
      sym__scope_resolution,
    ACTIONS(11000), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4060), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254350] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10992), 1,
      anon_sym_EQ,
    ACTIONS(10994), 1,
      anon_sym_try,
    ACTIONS(11002), 1,
      anon_sym_SEMI,
    STATE(765), 1,
      sym_compound_statement,
    STATE(7866), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(766), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [254388] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5987), 1,
      anon_sym_LBRACE,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2200), 1,
      sym_enumerator_list,
    STATE(6580), 1,
      sym__scope_resolution,
    ACTIONS(11004), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2321), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 1,
      sym_identifier,
    ACTIONS(5480), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [254450] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2875), 1,
      sym_enumerator_list,
    STATE(6627), 1,
      sym__scope_resolution,
    ACTIONS(11006), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2980), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254490] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(6066), 1,
      anon_sym___attribute,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6068), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [254522] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10919), 1,
      anon_sym_EQ,
    ACTIONS(10921), 1,
      anon_sym_try,
    ACTIONS(11008), 1,
      anon_sym_SEMI,
    STATE(708), 1,
      sym_compound_statement,
    STATE(7614), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(709), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [254560] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [254590] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7025), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3106), 1,
      sym_enumerator_list,
    STATE(6578), 1,
      sym__scope_resolution,
    ACTIONS(11010), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2832), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5484), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [254652] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(6164), 1,
      anon_sym___attribute,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6166), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [254684] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7388), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [254714] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_requires,
    ACTIONS(9849), 1,
      anon_sym___attribute,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6048), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [254744] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9472), 1,
      anon_sym_requires,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [254774] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(3608), 1,
      sym_enumerator_list,
    STATE(6592), 1,
      sym__scope_resolution,
    ACTIONS(11012), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4201), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254814] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6797), 1,
      anon_sym_LBRACE,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2823), 1,
      sym_enumerator_list,
    STATE(6633), 1,
      sym__scope_resolution,
    ACTIONS(11014), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2593), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [254854] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10976), 1,
      anon_sym_EQ,
    ACTIONS(10978), 1,
      anon_sym_try,
    ACTIONS(11016), 1,
      anon_sym_SEMI,
    STATE(309), 1,
      sym_compound_statement,
    STATE(7581), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(310), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [254892] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10735), 1,
      anon_sym___attribute,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [254922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym_identifier,
    ACTIONS(5491), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [254944] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9711), 1,
      anon_sym_requires,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [254974] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    ACTIONS(10797), 1,
      anon_sym_requires,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [255004] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10759), 1,
      anon_sym___attribute,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255034] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9849), 1,
      anon_sym_LBRACK,
    ACTIONS(11018), 1,
      anon_sym_requires,
    ACTIONS(9927), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5836), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [255064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11021), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(11023), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6255), 10,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [255088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11023), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6180), 12,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
      anon_sym_or,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [255110] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    ACTIONS(10763), 1,
      anon_sym___attribute,
    STATE(3007), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255140] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2614), 1,
      sym_enumerator_list,
    STATE(6579), 1,
      sym__scope_resolution,
    ACTIONS(11025), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4876), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255180] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_DASH_GT,
    ACTIONS(7551), 1,
      anon_sym_requires,
    STATE(6207), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [255212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 1,
      sym_identifier,
    ACTIONS(5579), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [255234] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8679), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4577), 1,
      sym_enumerator_list,
    STATE(6592), 1,
      sym__scope_resolution,
    ACTIONS(11027), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4279), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255274] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(11029), 1,
      anon_sym_SEMI,
    ACTIONS(11031), 1,
      anon_sym_EQ,
    ACTIONS(11033), 1,
      anon_sym_try,
    STATE(503), 1,
      sym_compound_statement,
    STATE(7832), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(523), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [255312] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(6557), 1,
      sym_access_specifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(7159), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10612), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [255350] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11035), 1,
      anon_sym_EQ,
    STATE(2981), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    ACTIONS(10940), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6759), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [255390] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(11031), 1,
      anon_sym_EQ,
    ACTIONS(11033), 1,
      anon_sym_try,
    ACTIONS(11037), 1,
      anon_sym_SEMI,
    STATE(510), 1,
      sym_compound_statement,
    STATE(7755), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(512), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [255428] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10948), 1,
      anon_sym_LBRACE,
    ACTIONS(10950), 1,
      anon_sym_EQ,
    ACTIONS(10952), 1,
      anon_sym_try,
    ACTIONS(11039), 1,
      anon_sym_SEMI,
    STATE(2085), 1,
      sym_compound_statement,
    STATE(7836), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2086), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [255466] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6038), 1,
      anon_sym___asm,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10614), 1,
      anon_sym_LBRACK,
    STATE(6056), 1,
      sym_parameter_list,
    STATE(6308), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6040), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [255498] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10877), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10879), 1,
      anon_sym_template,
    ACTIONS(11041), 1,
      sym_identifier,
    STATE(2365), 1,
      sym_qualified_field_identifier,
    STATE(2401), 1,
      sym_template_method,
    STATE(2402), 1,
      sym_dependent_field_identifier,
    STATE(6277), 1,
      sym__scope_resolution,
    STATE(7632), 1,
      sym_operator_name,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [255537] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255564] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11049), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7884), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8675), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6295), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [255597] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11051), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7609), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8039), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [255630] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255657] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6915), 1,
      sym__abstract_declarator,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [255692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11055), 1,
      anon_sym_LT,
    STATE(6369), 1,
      sym_template_argument_list,
    ACTIONS(11057), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11053), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [255717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255744] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10863), 1,
      anon_sym_template,
    ACTIONS(11059), 1,
      sym_identifier,
    STATE(3555), 1,
      sym_template_method,
    STATE(3560), 1,
      sym_dependent_field_identifier,
    STATE(3571), 1,
      sym_qualified_field_identifier,
    STATE(6285), 1,
      sym__scope_resolution,
    STATE(7745), 1,
      sym_operator_name,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [255783] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10735), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255812] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10751), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255841] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10755), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255870] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10763), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255899] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10743), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255928] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10747), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255957] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10759), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255986] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10767), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [256015] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10875), 1,
      anon_sym___attribute,
    STATE(2981), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10873), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [256048] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11063), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7898), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8730), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [256081] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(11031), 1,
      anon_sym_EQ,
    ACTIONS(11033), 1,
      anon_sym_try,
    STATE(503), 1,
      sym_compound_statement,
    STATE(7832), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(523), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [256116] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11065), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7809), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8367), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6325), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [256149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11069), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11067), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [256174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11055), 1,
      anon_sym_LT,
    STATE(6357), 1,
      sym_template_argument_list,
    ACTIONS(11073), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11071), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [256199] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256226] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10840), 1,
      anon_sym___attribute,
    STATE(2981), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10838), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [256259] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10844), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10846), 1,
      anon_sym_template,
    ACTIONS(11041), 1,
      sym_identifier,
    STATE(2365), 1,
      sym_qualified_field_identifier,
    STATE(2401), 1,
      sym_template_method,
    STATE(2402), 1,
      sym_dependent_field_identifier,
    STATE(6302), 1,
      sym__scope_resolution,
    STATE(7700), 1,
      sym_operator_name,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [256298] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    ACTIONS(8473), 1,
      anon_sym_STAR,
    ACTIONS(8475), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8477), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6678), 1,
      sym__abstract_declarator,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [256333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256360] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256387] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10919), 1,
      anon_sym_EQ,
    ACTIONS(10921), 1,
      anon_sym_try,
    STATE(696), 1,
      sym_compound_statement,
    STATE(7585), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(650), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [256422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6249), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6251), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [256447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6249), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6251), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [256472] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11075), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7616), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8127), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6320), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [256505] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10976), 1,
      anon_sym_EQ,
    ACTIONS(10978), 1,
      anon_sym_try,
    STATE(284), 1,
      sym_compound_statement,
    STATE(7686), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(285), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [256540] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_LPAREN2,
    ACTIONS(5014), 1,
      anon_sym_STAR,
    ACTIONS(5016), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6087), 1,
      sym__function_declarator_seq,
    STATE(6928), 1,
      sym__abstract_declarator,
    STATE(6092), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [256575] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11077), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7615), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8200), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6329), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [256608] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10887), 1,
      anon_sym___attribute,
    STATE(2981), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10885), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [256641] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9478), 1,
      anon_sym_requires,
    STATE(6471), 1,
      sym_trailing_return_type,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [256674] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9678), 1,
      anon_sym_requires,
    STATE(6476), 1,
      sym_trailing_return_type,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [256707] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9792), 1,
      anon_sym_requires,
    STATE(6477), 1,
      sym_trailing_return_type,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [256740] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    ACTIONS(11079), 1,
      anon_sym_requires,
    STATE(6479), 1,
      sym_trailing_return_type,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [256773] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(11082), 1,
      sym_identifier,
    ACTIONS(11084), 1,
      anon_sym_COLON_COLON,
    STATE(6322), 1,
      sym__scope_resolution,
    STATE(7748), 1,
      sym_operator_name,
    STATE(7776), 1,
      sym_field_initializer,
    STATE(6975), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [256810] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10867), 1,
      anon_sym___attribute,
    STATE(2981), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10865), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [256843] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11086), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7671), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8439), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [256876] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11088), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7599), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7953), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6324), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [256909] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(11084), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11090), 1,
      sym_identifier,
    ACTIONS(11092), 1,
      anon_sym_template,
    STATE(2365), 1,
      sym_qualified_field_identifier,
    STATE(2401), 1,
      sym_template_method,
    STATE(2402), 1,
      sym_dependent_field_identifier,
    STATE(6322), 1,
      sym__scope_resolution,
    STATE(7748), 1,
      sym_operator_name,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [256948] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11094), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7595), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7949), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6280), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [256981] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11096), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7620), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8153), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257014] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11098), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7831), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8438), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257047] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(11031), 1,
      anon_sym_EQ,
    ACTIONS(11033), 1,
      anon_sym_try,
    STATE(510), 1,
      sym_compound_statement,
    STATE(7755), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(512), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [257082] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4551), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11100), 1,
      sym_identifier,
    STATE(5858), 1,
      sym__scope_resolution,
    ACTIONS(4553), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(7778), 2,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [257117] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11102), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7696), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8007), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6337), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257150] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11104), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7842), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8485), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257183] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    STATE(6455), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [257216] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10992), 1,
      anon_sym_EQ,
    ACTIONS(10994), 1,
      anon_sym_try,
    STATE(765), 1,
      sym_compound_statement,
    STATE(7866), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(766), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [257251] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11106), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7853), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8544), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6336), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257284] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    STATE(6457), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [257317] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    STATE(6458), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [257350] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    STATE(6460), 1,
      sym_trailing_return_type,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [257383] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11108), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7565), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8238), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257416] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11110), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7607), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8012), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11112), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7896), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8723), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6346), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257482] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(11082), 1,
      sym_identifier,
    ACTIONS(11084), 1,
      anon_sym_COLON_COLON,
    STATE(6322), 1,
      sym__scope_resolution,
    STATE(7437), 1,
      sym_field_initializer,
    STATE(7748), 1,
      sym_operator_name,
    STATE(6975), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [257519] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10919), 1,
      anon_sym_EQ,
    ACTIONS(10921), 1,
      anon_sym_try,
    STATE(708), 1,
      sym_compound_statement,
    STATE(7614), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(709), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [257554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10641), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10639), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [257579] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10976), 1,
      anon_sym_EQ,
    ACTIONS(10978), 1,
      anon_sym_try,
    STATE(309), 1,
      sym_compound_statement,
    STATE(7581), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(310), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [257614] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11114), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7719), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8070), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257647] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257674] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    ACTIONS(10992), 1,
      anon_sym_EQ,
    ACTIONS(10994), 1,
      anon_sym_try,
    STATE(653), 1,
      sym_compound_statement,
    STATE(7594), 1,
      sym_field_initializer_list,
    ACTIONS(5036), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(655), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [257709] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11116), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7852), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8664), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2890), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257769] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11045), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11118), 1,
      anon_sym_RBRACE,
    ACTIONS(11047), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7688), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7978), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6343), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [257802] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10905), 1,
      anon_sym___attribute,
    STATE(2981), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10903), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [257835] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10719), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10721), 1,
      anon_sym_template,
    ACTIONS(11120), 1,
      sym_identifier,
    STATE(3390), 1,
      sym_template_method,
    STATE(3418), 1,
      sym_qualified_field_identifier,
    STATE(3454), 1,
      sym_dependent_field_identifier,
    STATE(6350), 1,
      sym__scope_resolution,
    STATE(7892), 1,
      sym_operator_name,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [257874] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(10810), 1,
      anon_sym_requires,
    STATE(6067), 1,
      sym_trailing_return_type,
    ACTIONS(10628), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [257904] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    STATE(1893), 1,
      sym_template_type,
    STATE(2876), 1,
      sym_enumerator_list,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(4057), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257940] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(3692), 1,
      sym_enumerator_list,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(6408), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257976] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7951), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9638), 1,
      sym_identifier,
    STATE(3681), 1,
      sym_template_type,
    STATE(3951), 1,
      sym_enumerator_list,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(3592), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258012] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(2334), 1,
      sym_enumerator_list,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(3878), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8015), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(8017), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
  [258068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6503), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [258088] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    STATE(6013), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [258118] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(3692), 1,
      sym_enumerator_list,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(3947), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258154] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    STATE(6033), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [258184] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    STATE(6042), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [258214] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(10810), 1,
      anon_sym_requires,
    STATE(6568), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [258244] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_requires,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    STATE(6046), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [258274] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8679), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4491), 1,
      sym_enumerator_list,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(4950), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11124), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11122), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [258330] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(5153), 1,
      sym_enumerator_list,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(4867), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258392] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6348), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6350), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [258438] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    ACTIONS(9297), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [258468] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9644), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2633), 1,
      sym_enumerator_list,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(4007), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258504] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6063), 1,
      sym_trailing_return_type,
    ACTIONS(9495), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [258534] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9714), 1,
      anon_sym_requires,
    STATE(6064), 1,
      sym_trailing_return_type,
    ACTIONS(9705), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [258564] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8991), 1,
      anon_sym_LBRACE,
    ACTIONS(9619), 1,
      sym_identifier,
    STATE(4376), 1,
      sym_template_type,
    STATE(4862), 1,
      sym_enumerator_list,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(4454), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258600] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(9621), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2876), 1,
      sym_enumerator_list,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(3303), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258636] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5987), 1,
      anon_sym_LBRACE,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2190), 1,
      sym_enumerator_list,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(2322), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258672] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9328), 1,
      anon_sym_requires,
    STATE(6562), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [258702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11128), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11126), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [258722] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6186), 1,
      anon_sym_LBRACE,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9627), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_template_type,
    STATE(2334), 1,
      sym_enumerator_list,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(4897), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11132), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11130), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [258778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11136), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11134), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [258798] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7025), 1,
      anon_sym_LBRACE,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9617), 1,
      sym_identifier,
    STATE(2830), 1,
      sym_template_type,
    STATE(3016), 1,
      sym_enumerator_list,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(2831), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258834] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(3692), 1,
      sym_enumerator_list,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(4202), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258870] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9714), 1,
      anon_sym_requires,
    STATE(6567), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [258900] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258926] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9634), 1,
      sym_identifier,
    STATE(2567), 1,
      sym_template_type,
    STATE(2633), 1,
      sym_enumerator_list,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(4863), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258962] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5987), 1,
      anon_sym_LBRACE,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9640), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_template_type,
    STATE(2190), 1,
      sym_enumerator_list,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(2463), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258998] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DASH_GT,
    ACTIONS(9498), 1,
      anon_sym_requires,
    STATE(6565), 1,
      sym_trailing_return_type,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [259028] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259054] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8679), 1,
      anon_sym_LBRACE,
    ACTIONS(9623), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(4491), 1,
      sym_enumerator_list,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(4296), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [259090] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259142] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(9613), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(2876), 1,
      sym_enumerator_list,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(3062), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [259178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5967), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10655), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10657), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [259200] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259226] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6850), 1,
      anon_sym_LBRACE,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9632), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_template_type,
    STATE(2866), 1,
      sym_enumerator_list,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(2680), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [259262] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(2991), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11140), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11138), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [259308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11073), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11071), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [259328] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(6797), 1,
      anon_sym_LBRACE,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9646), 1,
      sym_identifier,
    STATE(2630), 1,
      sym_template_type,
    STATE(2803), 1,
      sym_enumerator_list,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(2605), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [259364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11144), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11142), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [259384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6402), 2,
      sym_lambda_specifier,
      aux_sym_lambda_declarator_repeat1,
    ACTIONS(11148), 4,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
    ACTIONS(11146), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [259406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11153), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11151), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [259426] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(11155), 1,
      anon_sym_virtual,
    STATE(1893), 1,
      sym_template_type,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(7548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [259459] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [259484] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11157), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8281), 1,
      sym_qualified_identifier,
    ACTIONS(11159), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [259515] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259540] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11161), 1,
      anon_sym_COLON,
    STATE(2469), 1,
      sym_attribute_specifier,
    STATE(3490), 1,
      sym__enum_base_clause,
    STATE(3616), 1,
      sym_enumerator_list,
    ACTIONS(6344), 4,
      anon_sym_COMMA,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [259571] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [259596] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11163), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8743), 1,
      sym_qualified_identifier,
    ACTIONS(11165), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [259627] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11167), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11169), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11171), 1,
      aux_sym_preproc_elif_token1,
    STATE(6705), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
    ACTIONS(11173), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8160), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [259658] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(11175), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11177), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11179), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11181), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6706), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8179), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [259687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10743), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [259714] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10891), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11169), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11171), 1,
      aux_sym_preproc_elif_token1,
    STATE(6411), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
    ACTIONS(11173), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8202), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [259745] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11183), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8530), 1,
      sym_qualified_identifier,
    ACTIONS(11185), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [259776] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11187), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8677), 1,
      sym_qualified_identifier,
    ACTIONS(11189), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [259807] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10747), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [259834] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10759), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [259861] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11191), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(7965), 1,
      sym_qualified_identifier,
    ACTIONS(11193), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [259892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259917] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10767), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [259944] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(11177), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11179), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11195), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11181), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6412), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8213), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [259973] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10838), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [260002] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11197), 1,
      anon_sym_COMMA,
    ACTIONS(11201), 1,
      anon_sym___attribute,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6897), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(11199), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [260035] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11203), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8235), 1,
      sym_qualified_identifier,
    ACTIONS(11205), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [260066] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [260091] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11169), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11171), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11207), 1,
      aux_sym_preproc_if_token2,
    STATE(6705), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
    ACTIONS(11173), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8663), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [260122] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(11177), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11179), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11209), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11181), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6706), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8688), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [260151] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10911), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11169), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11171), 1,
      aux_sym_preproc_elif_token1,
    STATE(6514), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
    ACTIONS(11173), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8837), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [260182] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11211), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8351), 1,
      sym_qualified_identifier,
    ACTIONS(11213), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [260213] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_try,
    STATE(679), 1,
      sym_compound_statement,
    STATE(680), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [260248] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10148), 1,
      anon_sym_try,
    STATE(717), 1,
      sym_compound_statement,
    STATE(718), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [260283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4984), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4986), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [260302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4980), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4982), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [260321] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11215), 1,
      sym_identifier,
    ACTIONS(11218), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11224), 1,
      sym_preproc_directive,
    ACTIONS(11227), 1,
      anon_sym_RBRACE,
    ACTIONS(11221), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8762), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(6435), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [260350] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [260375] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9809), 1,
      anon_sym_try,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10948), 1,
      anon_sym_LBRACE,
    STATE(2072), 1,
      sym_compound_statement,
    STATE(2073), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [260410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4992), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4994), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [260429] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9809), 1,
      anon_sym_try,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10948), 1,
      anon_sym_LBRACE,
    STATE(2081), 1,
      sym_compound_statement,
    STATE(2082), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [260464] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11229), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8701), 1,
      sym_qualified_identifier,
    ACTIONS(11231), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [260495] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [260520] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9782), 1,
      anon_sym_try,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10958), 1,
      anon_sym_LBRACE,
    STATE(2009), 1,
      sym_compound_statement,
    STATE(2019), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [260555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4310), 11,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [260572] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9809), 1,
      anon_sym_try,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10948), 1,
      anon_sym_LBRACE,
    STATE(2141), 1,
      sym_compound_statement,
    STATE(2142), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [260607] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9782), 1,
      anon_sym_try,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10958), 1,
      anon_sym_LBRACE,
    STATE(2030), 1,
      sym_compound_statement,
    STATE(2033), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [260642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4957), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [260661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10903), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [260690] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10148), 1,
      anon_sym_try,
    STATE(706), 1,
      sym_compound_statement,
    STATE(715), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [260725] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [260752] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10735), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [260779] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10865), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [260808] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [260833] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11233), 1,
      sym_identifier,
    ACTIONS(11235), 1,
      anon_sym_COLON,
    ACTIONS(11237), 1,
      sym_system_lib_string,
    STATE(7364), 1,
      sym_string_literal,
    STATE(7365), 1,
      sym_module_name,
    STATE(7375), 1,
      sym_module_partition,
    ACTIONS(6846), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [260862] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(4551), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11100), 1,
      sym_identifier,
    STATE(5858), 1,
      sym__scope_resolution,
    STATE(7778), 2,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [260893] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [260920] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11239), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8706), 1,
      sym_qualified_identifier,
    ACTIONS(11241), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [260951] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [260978] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [261005] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9790), 1,
      anon_sym_try,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10966), 1,
      anon_sym_LBRACE,
    STATE(1712), 1,
      sym_compound_statement,
    STATE(1714), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261040] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7906), 1,
      anon_sym_requires,
    ACTIONS(9849), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5836), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [261067] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10023), 1,
      anon_sym_try,
    STATE(325), 1,
      sym_compound_statement,
    STATE(326), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261102] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9790), 1,
      anon_sym_try,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10966), 1,
      anon_sym_LBRACE,
    STATE(1715), 1,
      sym_compound_statement,
    STATE(1729), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261137] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11243), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8048), 1,
      sym_qualified_identifier,
    ACTIONS(11245), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [261168] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10751), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [261195] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10743), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261222] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10747), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261249] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10759), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261276] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261301] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9193), 1,
      anon_sym_LBRACK,
    ACTIONS(9478), 1,
      anon_sym_requires,
    ACTIONS(9195), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5877), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [261328] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10755), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [261355] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9355), 1,
      anon_sym_LBRACK,
    ACTIONS(9678), 1,
      anon_sym_requires,
    ACTIONS(9357), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5839), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [261382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4953), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [261401] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11233), 1,
      sym_identifier,
    ACTIONS(11235), 1,
      anon_sym_COLON,
    ACTIONS(11247), 1,
      sym_system_lib_string,
    STATE(7261), 1,
      sym_string_literal,
    STATE(7264), 1,
      sym_module_name,
    STATE(7266), 1,
      sym_module_partition,
    ACTIONS(6846), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [261430] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10023), 1,
      anon_sym_try,
    STATE(327), 1,
      sym_compound_statement,
    STATE(328), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261465] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10007), 1,
      anon_sym_try,
    STATE(623), 1,
      sym_compound_statement,
    STATE(624), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9676), 1,
      anon_sym_LBRACK,
    ACTIONS(9792), 1,
      anon_sym_requires,
    ACTIONS(9681), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5876), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [261527] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9845), 1,
      anon_sym_LBRACK,
    ACTIONS(11079), 1,
      anon_sym_requires,
    ACTIONS(9919), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5846), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [261554] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9782), 1,
      anon_sym_try,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10958), 1,
      anon_sym_LBRACE,
    STATE(2084), 1,
      sym_compound_statement,
    STATE(2091), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9849), 1,
      anon_sym_LBRACK,
    ACTIONS(11249), 1,
      anon_sym_requires,
    ACTIONS(9927), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5606), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5836), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [261616] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(11177), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11179), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11252), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11181), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6523), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8472), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [261645] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11254), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8457), 1,
      sym_qualified_identifier,
    ACTIONS(11256), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [261676] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_try,
    STATE(692), 1,
      sym_compound_statement,
    STATE(693), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261711] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10007), 1,
      anon_sym_try,
    STATE(517), 1,
      sym_compound_statement,
    STATE(518), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym_LBRACK,
    ACTIONS(11258), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(11260), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6255), 6,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261769] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11169), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11171), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11262), 1,
      aux_sym_preproc_if_token2,
    STATE(6494), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
    ACTIONS(11173), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8523), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [261800] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10763), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [261827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6178), 1,
      anon_sym_LBRACK,
    ACTIONS(11260), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6180), 8,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261848] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(11264), 1,
      anon_sym_virtual,
    STATE(1893), 1,
      sym_template_type,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(7068), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [261881] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9790), 1,
      anon_sym_try,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10966), 1,
      anon_sym_LBRACE,
    STATE(1724), 1,
      sym_compound_statement,
    STATE(1727), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4961), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [261935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11266), 11,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [261952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4988), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4990), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [261971] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10885), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [262000] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11169), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11171), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11268), 1,
      aux_sym_preproc_if_token2,
    STATE(6705), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
    ACTIONS(11173), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8387), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [262031] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_try,
    STATE(677), 1,
      sym_compound_statement,
    STATE(678), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262066] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(11177), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11179), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11270), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11181), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6706), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8433), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [262095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11272), 11,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [262137] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11274), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8197), 1,
      sym_qualified_identifier,
    ACTIONS(11276), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [262168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11278), 11,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [262185] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10023), 1,
      anon_sym_try,
    STATE(351), 1,
      sym_compound_statement,
    STATE(352), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262220] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(11280), 1,
      anon_sym_virtual,
    STATE(1893), 1,
      sym_template_type,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(6990), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [262253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262278] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10007), 1,
      anon_sym_try,
    STATE(562), 1,
      sym_compound_statement,
    STATE(618), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262313] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10751), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11282), 11,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [262357] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262382] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262407] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10873), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [262436] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [262461] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11169), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11171), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11284), 1,
      aux_sym_preproc_if_token2,
    STATE(6427), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
    ACTIONS(11173), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8504), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [262492] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6971), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11161), 1,
      anon_sym_COLON,
    STATE(2509), 1,
      sym_attribute_specifier,
    STATE(3489), 1,
      sym__enum_base_clause,
    STATE(3613), 1,
      sym_enumerator_list,
    ACTIONS(6338), 4,
      anon_sym_COMMA,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [262523] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11286), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8442), 1,
      sym_qualified_identifier,
    ACTIONS(11288), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [262554] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11169), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11171), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11290), 1,
      aux_sym_preproc_if_token2,
    STATE(6705), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
    ACTIONS(11173), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8247), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [262585] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11292), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8372), 1,
      sym_qualified_identifier,
    ACTIONS(11294), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [262616] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10755), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2994), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262668] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10148), 1,
      anon_sym_try,
    STATE(753), 1,
      sym_compound_statement,
    STATE(754), 1,
      sym_try_statement,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [262728] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    ACTIONS(11296), 1,
      anon_sym_virtual,
    STATE(1893), 1,
      sym_template_type,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(7159), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [262761] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10763), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262788] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10735), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [262815] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(11177), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11179), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11298), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11181), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6706), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8257), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [262844] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10767), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3299), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262871] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11304), 1,
      anon_sym_delete,
    ACTIONS(11306), 1,
      anon_sym_new,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [262893] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3223), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10940), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6768), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [262923] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(7122), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [262953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263025] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263121] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3273), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9328), 1,
      anon_sym_requires,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6012), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9182), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [263169] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10743), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3087), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [263195] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10759), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3087), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [263221] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10767), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3087), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [263247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [263271] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [263295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [263319] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [263343] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11308), 1,
      anon_sym_delete,
    ACTIONS(11310), 1,
      anon_sym_new,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263365] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [263389] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [263413] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [263437] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3179), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [263461] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(7068), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11312), 1,
      anon_sym_delete,
    ACTIONS(11314), 1,
      anon_sym_new,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263513] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(11316), 1,
      sym_identifier,
    ACTIONS(11318), 1,
      anon_sym_COLON_COLON,
    STATE(2753), 1,
      sym_template_type,
    STATE(6589), 1,
      sym__scope_resolution,
    STATE(2738), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263543] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11320), 1,
      anon_sym_EQ,
    STATE(3270), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(8445), 1,
      sym_initializer_list,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11322), 1,
      anon_sym_delete,
    ACTIONS(11324), 1,
      anon_sym_new,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 10,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_constexpr,
      anon_sym_mutable,
      anon_sym_consteval,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [263613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11324), 1,
      anon_sym_new,
    ACTIONS(11328), 1,
      anon_sym_delete,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11330), 1,
      anon_sym_delete,
    ACTIONS(11332), 1,
      anon_sym_new,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263657] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(7497), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263687] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11336), 1,
      anon_sym_LBRACK,
    STATE(7093), 1,
      sym_gnu_asm_input_operand,
    STATE(8516), 1,
      sym_string_literal,
    ACTIONS(11334), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [263711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11338), 1,
      anon_sym_delete,
    ACTIONS(11340), 1,
      anon_sym_new,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263733] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11344), 1,
      anon_sym___attribute,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11342), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [263761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11346), 1,
      anon_sym_delete,
    ACTIONS(11348), 1,
      anon_sym_new,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9498), 1,
      anon_sym_requires,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6032), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9344), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [263807] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11352), 1,
      anon_sym_LBRACK,
    STATE(7028), 1,
      sym_gnu_asm_output_operand,
    STATE(8022), 1,
      sym_string_literal,
    ACTIONS(11350), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [263831] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11306), 1,
      anon_sym_new,
    ACTIONS(11354), 1,
      anon_sym_delete,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263853] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9714), 1,
      anon_sym_requires,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6041), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9665), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [263877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11356), 1,
      anon_sym_delete,
    ACTIONS(11358), 1,
      anon_sym_new,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263899] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10810), 1,
      anon_sym_requires,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6045), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9843), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [263923] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10817), 1,
      anon_sym_requires,
    ACTIONS(7335), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5925), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6048), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9847), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [263947] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3216), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10940), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6768), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [263977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11360), 1,
      anon_sym_delete,
    ACTIONS(11362), 1,
      anon_sym_new,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11340), 1,
      anon_sym_new,
    ACTIONS(11364), 1,
      anon_sym_delete,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [264021] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_template_type,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(7159), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8601), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [264051] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10747), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3087), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [264077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11340), 1,
      anon_sym_new,
    ACTIONS(11366), 1,
      anon_sym_delete,
    ACTIONS(11302), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11300), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [264099] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [264122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2864), 1,
      sym_template_argument_list,
    ACTIONS(4972), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(4965), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [264145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11368), 1,
      sym_identifier,
    ACTIONS(11372), 1,
      sym_system_lib_string,
    STATE(8368), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11370), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [264166] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9528), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11374), 1,
      sym_identifier,
    ACTIONS(11376), 1,
      anon_sym_template,
    STATE(2783), 1,
      sym_dependent_type_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(2846), 1,
      sym_qualified_type_identifier,
    STATE(6578), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264197] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8049), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11378), 1,
      sym_identifier,
    ACTIONS(11380), 1,
      anon_sym_template,
    STATE(2534), 1,
      sym_template_type,
    STATE(2556), 1,
      sym_dependent_type_identifier,
    STATE(2615), 1,
      sym_qualified_type_identifier,
    STATE(6579), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264228] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11382), 1,
      sym_identifier,
    ACTIONS(11384), 1,
      anon_sym_template,
    STATE(1921), 1,
      sym_template_type,
    STATE(1923), 1,
      sym_dependent_type_identifier,
    STATE(2040), 1,
      sym_qualified_type_identifier,
    STATE(6580), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264259] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11386), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8027), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11243), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8048), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264313] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11274), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8197), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264340] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11229), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8701), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264367] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11388), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8827), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264394] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11390), 1,
      sym_identifier,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    STATE(363), 1,
      sym_declaration_list,
    STATE(6733), 1,
      sym_attribute_declaration,
    STATE(7880), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [264425] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7959), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11396), 1,
      sym_identifier,
    ACTIONS(11398), 1,
      anon_sym_template,
    STATE(1813), 1,
      sym_template_type,
    STATE(1814), 1,
      sym_dependent_type_identifier,
    STATE(1888), 1,
      sym_qualified_type_identifier,
    STATE(6587), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11400), 1,
      sym_identifier,
    ACTIONS(11402), 1,
      sym_system_lib_string,
    STATE(8460), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11370), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [264477] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(11318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11404), 1,
      sym_identifier,
    ACTIONS(11406), 1,
      anon_sym_template,
    STATE(2726), 1,
      sym_template_type,
    STATE(2727), 1,
      sym_dependent_type_identifier,
    STATE(2760), 1,
      sym_qualified_type_identifier,
    STATE(6589), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264508] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11408), 1,
      sym_identifier,
    STATE(547), 1,
      sym_declaration_list,
    STATE(6771), 1,
      sym_attribute_declaration,
    STATE(7570), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [264539] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11163), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8743), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264566] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11410), 1,
      sym_identifier,
    ACTIONS(11412), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(2874), 1,
      sym_qualified_type_identifier,
    STATE(6592), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264597] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11414), 1,
      sym_identifier,
    ACTIONS(11416), 1,
      anon_sym_template,
    STATE(1813), 1,
      sym_template_type,
    STATE(1814), 1,
      sym_dependent_type_identifier,
    STATE(1888), 1,
      sym_qualified_type_identifier,
    STATE(6593), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264628] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11380), 1,
      anon_sym_template,
    ACTIONS(11418), 1,
      sym_identifier,
    STATE(2534), 1,
      sym_template_type,
    STATE(2556), 1,
      sym_dependent_type_identifier,
    STATE(2615), 1,
      sym_qualified_type_identifier,
    STATE(6594), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264659] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11420), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8234), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264686] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11191), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(7965), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264713] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11422), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8104), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264740] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11424), 1,
      sym_identifier,
    STATE(786), 1,
      sym_declaration_list,
    STATE(6736), 1,
      sym_attribute_declaration,
    STATE(7869), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [264771] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(3907), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11426), 1,
      sym_identifier,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(6599), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264802] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11211), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8351), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264829] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11428), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8467), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264856] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11430), 1,
      sym_identifier,
    STATE(296), 1,
      sym_declaration_list,
    STATE(6730), 1,
      sym_attribute_declaration,
    STATE(7675), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [264887] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11432), 1,
      sym_identifier,
    ACTIONS(11434), 1,
      sym_system_lib_string,
    STATE(8174), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11370), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [264908] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9625), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11436), 1,
      sym_identifier,
    ACTIONS(11438), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(2874), 1,
      sym_qualified_type_identifier,
    STATE(6604), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264939] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11440), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8392), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264966] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5020), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11442), 1,
      sym_identifier,
    ACTIONS(11444), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(6606), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [264997] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(3270), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    ACTIONS(10885), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265024] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(3270), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    ACTIONS(10865), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265051] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(3270), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    ACTIONS(10903), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265078] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11446), 1,
      sym_identifier,
    STATE(764), 1,
      sym_declaration_list,
    STATE(6740), 1,
      sym_attribute_declaration,
    STATE(7858), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [265109] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(3270), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    ACTIONS(10873), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265136] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9893), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11448), 1,
      sym_identifier,
    ACTIONS(11450), 1,
      anon_sym_template,
    STATE(2291), 1,
      sym_template_type,
    STATE(2292), 1,
      sym_dependent_type_identifier,
    STATE(2296), 1,
      sym_qualified_type_identifier,
    STATE(6612), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [265167] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11452), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8044), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [265194] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(3270), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    ACTIONS(10838), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265221] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11426), 1,
      sym_identifier,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(2874), 1,
      sym_qualified_type_identifier,
    STATE(6615), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [265252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [265275] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_template,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(10460), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11183), 1,
      sym_identifier,
    STATE(5796), 1,
      sym__scope_resolution,
    STATE(8530), 1,
      sym_qualified_identifier,
    STATE(8601), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [265302] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9961), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11454), 1,
      sym_identifier,
    ACTIONS(11456), 1,
      anon_sym_template,
    STATE(1813), 1,
      sym_template_type,
    STATE(1814), 1,
      sym_dependent_type_identifier,
    STATE(1888), 1,
      sym_qualified_type_identifier,
    STATE(6618), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [265333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [265356] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11458), 1,
      sym_identifier,
    ACTIONS(11460), 1,
      anon_sym_template,
    STATE(2658), 1,
      sym_template_type,
    STATE(2659), 1,
      sym_dependent_type_identifier,
    STATE(2728), 1,
      sym_qualified_type_identifier,
    STATE(6620), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [265387] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [265410] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [265433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [265456] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [265479] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10733), 1,
      anon_sym_LBRACK,
    STATE(3459), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 5,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [265502] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11398), 1,
      anon_sym_template,
    ACTIONS(11462), 1,
      sym_identifier,
    STATE(1813), 1,
      sym_template_type,
    STATE(1814), 1,
      sym_dependent_type_identifier,
    STATE(1888), 1,
      sym_qualified_type_identifier,
    STATE(6626), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [265533] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(5220), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11436), 1,
      sym_identifier,
    ACTIONS(11438), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(6627), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [265564] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11464), 1,
      sym_identifier,
    STATE(779), 1,
      sym_declaration_list,
    STATE(6764), 1,
      sym_attribute_declaration,
    STATE(7894), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [265595] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11466), 1,
      sym_identifier,
    STATE(785), 1,
      sym_declaration_list,
    STATE(6761), 1,
      sym_attribute_declaration,
    STATE(7727), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [265626] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(7970), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11410), 1,
      sym_identifier,
    ACTIONS(11412), 1,
      anon_sym_template,
    STATE(1906), 1,
      sym_template_type,
    STATE(1908), 1,
      sym_dependent_type_identifier,
    STATE(1909), 1,
      sym_qualified_type_identifier,
    STATE(6630), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [265657] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11468), 1,
      sym_identifier,
    STATE(649), 1,
      sym_declaration_list,
    STATE(6719), 1,
      sym_attribute_declaration,
    STATE(7622), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [265688] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(8021), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11470), 1,
      sym_identifier,
    ACTIONS(11472), 1,
      anon_sym_template,
    STATE(4346), 1,
      sym_template_type,
    STATE(4354), 1,
      sym_dependent_type_identifier,
    STATE(4425), 1,
      sym_qualified_type_identifier,
    STATE(6632), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [265719] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9503), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11474), 1,
      sym_identifier,
    ACTIONS(11476), 1,
      anon_sym_template,
    STATE(2611), 1,
      sym_dependent_type_identifier,
    STATE(2626), 1,
      sym_template_type,
    STATE(2655), 1,
      sym_qualified_type_identifier,
    STATE(6633), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [265750] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_decltype,
    ACTIONS(9578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11478), 1,
      sym_identifier,
    ACTIONS(11480), 1,
      anon_sym_template,
    STATE(3600), 1,
      sym_template_type,
    STATE(3601), 1,
      sym_dependent_type_identifier,
    STATE(3751), 1,
      sym_qualified_type_identifier,
    STATE(6634), 1,
      sym__scope_resolution,
    STATE(8601), 1,
      sym_decltype,
  [265781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11482), 1,
      sym_identifier,
    ACTIONS(11484), 1,
      sym_system_lib_string,
    STATE(8397), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11370), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [265802] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2864), 1,
      sym_template_argument_list,
    ACTIONS(8093), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(5036), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [265825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11488), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11486), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [265841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [265863] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11490), 1,
      anon_sym_SEMI,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [265911] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10885), 1,
      anon_sym_COLON,
    STATE(3487), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265937] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10865), 1,
      anon_sym_COLON,
    STATE(3487), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265963] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(10592), 1,
      anon_sym_LBRACE,
    STATE(7474), 1,
      sym_trailing_return_type,
    STATE(8330), 1,
      sym_requires_clause,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265989] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11492), 1,
      anon_sym_SEMI,
    ACTIONS(11494), 1,
      anon_sym_EQ,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(7071), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [266037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [266059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11498), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11496), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [266075] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10743), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3223), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [266099] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [266121] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [266143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(8093), 1,
      anon_sym_LBRACK,
    STATE(5954), 1,
      sym_template_argument_list,
    ACTIONS(5036), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [266165] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10903), 1,
      anon_sym_COLON,
    STATE(3487), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266191] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4972), 1,
      anon_sym_LBRACK,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(5954), 1,
      sym_template_argument_list,
    ACTIONS(4965), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [266213] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10759), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3223), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [266237] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10759), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3216), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 3,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_GT2,
  [266261] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [266283] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11500), 1,
      anon_sym_SEMI,
    ACTIONS(11502), 1,
      anon_sym_EQ,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(7034), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266309] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10747), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3216), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 3,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_GT2,
  [266333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11506), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11508), 1,
      anon_sym_EQ,
    ACTIONS(11504), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [266351] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11510), 1,
      anon_sym_SEMI,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym_LBRACK,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2864), 1,
      sym_template_argument_list,
    ACTIONS(6515), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [266397] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10873), 1,
      anon_sym_COLON,
    STATE(3487), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266423] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(11512), 1,
      anon_sym_RPAREN,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6811), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266449] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10767), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3223), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [266473] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(11514), 1,
      anon_sym_LBRACE,
    STATE(7471), 1,
      sym_trailing_return_type,
    STATE(8318), 1,
      sym_requires_clause,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266499] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10747), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3223), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [266523] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(11516), 1,
      anon_sym_LBRACE,
    STATE(7382), 1,
      sym_trailing_return_type,
    STATE(8545), 1,
      sym_requires_clause,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266549] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(11518), 1,
      anon_sym_LBRACE,
    STATE(7441), 1,
      sym_trailing_return_type,
    STATE(8075), 1,
      sym_requires_clause,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266575] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(11518), 1,
      anon_sym_LBRACE,
    STATE(7441), 1,
      sym_trailing_return_type,
    STATE(8075), 1,
      sym_requires_clause,
    STATE(6714), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266601] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(10838), 1,
      anon_sym_COLON,
    STATE(3487), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266627] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11520), 1,
      anon_sym_SEMI,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266653] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11522), 1,
      anon_sym_RPAREN,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266679] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [266701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11336), 1,
      anon_sym_LBRACK,
    STATE(7145), 1,
      sym_gnu_asm_input_operand,
    STATE(8516), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [266721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11352), 1,
      anon_sym_LBRACK,
    STATE(7350), 1,
      sym_gnu_asm_output_operand,
    STATE(8022), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [266741] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(11514), 1,
      anon_sym_LBRACE,
    STATE(7471), 1,
      sym_trailing_return_type,
    STATE(8318), 1,
      sym_requires_clause,
    STATE(6667), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266767] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10869), 1,
      anon_sym_RPAREN,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6811), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266793] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(11524), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [266815] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11526), 1,
      anon_sym_SEMI,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [266863] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10881), 1,
      anon_sym_RPAREN,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6811), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [266911] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6073), 1,
      anon_sym_COMMA,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11530), 1,
      anon_sym_RBRACK,
    ACTIONS(11533), 1,
      anon_sym_EQ,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(7258), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [266939] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [266961] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11535), 1,
      anon_sym_SEMI,
    ACTIONS(11537), 1,
      anon_sym_EQ,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(7097), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266987] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11539), 1,
      anon_sym_RPAREN,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [267035] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10848), 1,
      anon_sym_RPAREN,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6811), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267061] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11541), 1,
      anon_sym_COLON,
    STATE(3487), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(6341), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267087] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [267109] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11543), 1,
      anon_sym_SEMI,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267135] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11545), 1,
      anon_sym_SEMI,
    ACTIONS(11547), 1,
      anon_sym_EQ,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(7046), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267161] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10899), 1,
      anon_sym_RPAREN,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6811), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267187] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11549), 1,
      anon_sym_SEMI,
    ACTIONS(11551), 1,
      anon_sym_EQ,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(7118), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267213] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10582), 1,
      anon_sym_LBRACE,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    STATE(7188), 1,
      sym_trailing_return_type,
    STATE(8327), 1,
      sym_requires_clause,
    STATE(6665), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267239] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [267261] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10582), 1,
      anon_sym_LBRACE,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    STATE(7188), 1,
      sym_trailing_return_type,
    STATE(8327), 1,
      sym_requires_clause,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267287] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [267309] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11553), 1,
      anon_sym_SEMI,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [267357] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [267379] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [267401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [267423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3370), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [267445] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11555), 1,
      sym_identifier,
    ACTIONS(11560), 1,
      aux_sym_preproc_elif_token1,
    STATE(6705), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
    ACTIONS(11558), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [267467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11562), 1,
      sym_identifier,
    ACTIONS(11567), 1,
      aux_sym_preproc_elif_token1,
    STATE(6706), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(11565), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [267487] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(10592), 1,
      anon_sym_LBRACE,
    STATE(7474), 1,
      sym_trailing_return_type,
    STATE(8330), 1,
      sym_requires_clause,
    STATE(6668), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11569), 1,
      anon_sym_SEMI,
    ACTIONS(11571), 1,
      anon_sym_EQ,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(7075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267539] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11573), 1,
      anon_sym_SEMI,
    ACTIONS(11575), 1,
      anon_sym_EQ,
    STATE(1603), 1,
      sym_template_argument_list,
    STATE(7079), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267565] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(11577), 1,
      anon_sym_RPAREN,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6811), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267591] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11579), 1,
      anon_sym_SEMI,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267617] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10743), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3216), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 3,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_GT2,
  [267641] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    ACTIONS(11581), 1,
      anon_sym_SEMI,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267667] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10584), 1,
      anon_sym_DASH_GT,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(11583), 1,
      anon_sym_LBRACE,
    STATE(7427), 1,
      sym_trailing_return_type,
    STATE(8109), 1,
      sym_requires_clause,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267693] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(9778), 1,
      anon_sym_LBRACK,
    ACTIONS(10852), 1,
      anon_sym_RPAREN,
    STATE(3033), 1,
      sym_parameter_list,
    STATE(6381), 1,
      sym__function_declarator_seq,
    STATE(6811), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267719] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10767), 1,
      anon_sym___attribute,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3216), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 3,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_GT2,
  [267743] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11585), 1,
      anon_sym_RPAREN,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267766] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [267787] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11408), 1,
      sym_identifier,
    STATE(547), 1,
      sym_declaration_list,
    STATE(7570), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [267812] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(11587), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [267831] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11589), 1,
      anon_sym_RPAREN,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11591), 1,
      anon_sym_LPAREN2,
    STATE(6725), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [267871] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(6166), 1,
      anon_sym_COLON,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6782), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267894] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11595), 1,
      anon_sym_EQ,
    STATE(1603), 1,
      sym_template_argument_list,
    ACTIONS(6230), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [267917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11597), 1,
      anon_sym_LPAREN2,
    STATE(6725), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11599), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [267934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11602), 1,
      anon_sym_LPAREN2,
    STATE(6738), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [267951] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(6135), 1,
      anon_sym_COLON,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6782), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [267974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11604), 1,
      anon_sym_LBRACK,
    ACTIONS(11606), 1,
      anon_sym_EQ,
    ACTIONS(11608), 1,
      anon_sym_DOT,
    STATE(6756), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [267993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10492), 1,
      anon_sym___attribute,
    ACTIONS(11610), 1,
      anon_sym_EQ,
    ACTIONS(10490), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [268010] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LBRACE,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11612), 1,
      sym_identifier,
    STATE(319), 1,
      sym_declaration_list,
    STATE(7604), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [268035] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6040), 1,
      anon_sym_COLON,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6782), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11616), 1,
      anon_sym_COMMA,
    ACTIONS(11618), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11614), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [268075] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LBRACE,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11430), 1,
      sym_identifier,
    STATE(296), 1,
      sym_declaration_list,
    STATE(7675), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [268100] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11620), 1,
      anon_sym_RPAREN,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268123] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11622), 1,
      anon_sym_RPAREN,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268146] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11466), 1,
      sym_identifier,
    STATE(785), 1,
      sym_declaration_list,
    STATE(7727), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [268171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [268192] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11624), 1,
      anon_sym_LPAREN2,
    STATE(6725), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11626), 1,
      anon_sym_LPAREN2,
    STATE(6742), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268226] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACE,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11464), 1,
      sym_identifier,
    STATE(779), 1,
      sym_declaration_list,
    STATE(7894), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [268251] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [268272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11628), 1,
      anon_sym_LPAREN2,
    STATE(6725), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268289] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11630), 1,
      anon_sym_RPAREN,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268312] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_LBRACK,
    STATE(2877), 1,
      sym_parameter_list,
    STATE(5979), 1,
      sym__function_declarator_seq,
    STATE(5949), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym___attribute__,
    ACTIONS(7085), 1,
      anon_sym___attribute,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5468), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5688), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11632), 1,
      anon_sym_LPAREN2,
    STATE(6725), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_LPAREN2,
    STATE(6748), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11636), 1,
      anon_sym_LPAREN2,
    STATE(6725), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268407] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(6068), 1,
      anon_sym_COLON,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6782), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11638), 1,
      anon_sym_LPAREN2,
    STATE(6751), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11640), 1,
      anon_sym_LPAREN2,
    STATE(6725), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11642), 1,
      anon_sym_LPAREN2,
    STATE(6754), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268481] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(6102), 1,
      anon_sym_COLON,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6782), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11644), 1,
      anon_sym_LPAREN2,
    STATE(6725), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268521] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [268542] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11646), 1,
      anon_sym_LBRACK,
    ACTIONS(11649), 1,
      anon_sym_EQ,
    ACTIONS(11651), 1,
      anon_sym_DOT,
    STATE(6756), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [268561] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(2324), 1,
      sym_template_argument_list,
    STATE(7139), 2,
      sym_argument_list,
      sym_initializer_list,
  [268584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [268605] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(11654), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [268624] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [268645] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11656), 1,
      sym_identifier,
    STATE(670), 1,
      sym_declaration_list,
    STATE(7600), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [268670] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [268691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3177), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [268712] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACE,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11658), 1,
      sym_identifier,
    STATE(687), 1,
      sym_declaration_list,
    STATE(7827), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [268737] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11660), 1,
      anon_sym_RPAREN,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268760] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(5381), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5442), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym_LBRACK,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(5954), 1,
      sym_template_argument_list,
    ACTIONS(6515), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [268800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(11654), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [268819] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11662), 1,
      anon_sym_RPAREN,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11664), 1,
      anon_sym_LPAREN2,
    STATE(6722), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268859] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11666), 1,
      sym_identifier,
    STATE(620), 1,
      sym_declaration_list,
    STATE(7922), 1,
      sym_nested_namespace_specifier,
    STATE(7980), 1,
      sym__namespace_specifier,
  [268884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10492), 1,
      anon_sym___attribute,
    ACTIONS(11668), 1,
      anon_sym_EQ,
    ACTIONS(10490), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268901] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11533), 1,
      anon_sym_EQ,
    STATE(1603), 1,
      sym_template_argument_list,
    ACTIONS(6244), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [268924] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6046), 1,
      anon_sym_LBRACK,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11670), 1,
      anon_sym_RPAREN,
    STATE(2298), 1,
      sym_parameter_list,
    STATE(6307), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11672), 1,
      anon_sym_LPAREN2,
    STATE(6746), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11593), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [268964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11674), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11676), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [268978] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11678), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8783), 1,
      sym_attribute_specifier,
  [269000] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10741), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [269020] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10745), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [269040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11680), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11682), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [269054] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11684), 1,
      anon_sym_SEMI,
    STATE(6823), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8576), 1,
      sym_attribute_specifier,
  [269076] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym_LBRACK,
    ACTIONS(7838), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6251), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269094] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11686), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8695), 1,
      sym_attribute_specifier,
  [269116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(11688), 1,
      anon_sym_LBRACE,
    STATE(8349), 1,
      sym_trailing_return_type,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269136] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10007), 1,
      anon_sym_try,
    ACTIONS(11690), 1,
      anon_sym_SEMI,
    ACTIONS(11692), 1,
      anon_sym_EQ,
    STATE(602), 2,
      sym_compound_statement,
      sym_try_statement,
  [269156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9782), 1,
      anon_sym_try,
    ACTIONS(10958), 1,
      anon_sym_LBRACE,
    ACTIONS(11694), 1,
      anon_sym_SEMI,
    ACTIONS(11696), 1,
      anon_sym_EQ,
    STATE(2021), 2,
      sym_compound_statement,
      sym_try_statement,
  [269176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(11688), 1,
      anon_sym_LBRACE,
    STATE(8349), 1,
      sym_trailing_return_type,
    STATE(6790), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10731), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [269216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10757), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [269236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(11698), 1,
      anon_sym_LBRACE,
    STATE(8189), 1,
      sym_trailing_return_type,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269256] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11700), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8329), 1,
      sym_attribute_specifier,
  [269278] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11702), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8375), 1,
      sym_attribute_specifier,
  [269300] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    ACTIONS(10114), 1,
      anon_sym_try,
    ACTIONS(11704), 1,
      anon_sym_SEMI,
    ACTIONS(11706), 1,
      anon_sym_EQ,
    STATE(699), 2,
      sym_compound_statement,
      sym_try_statement,
  [269320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10765), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [269340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11708), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11710), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [269354] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9809), 1,
      anon_sym_try,
    ACTIONS(10948), 1,
      anon_sym_LBRACE,
    ACTIONS(11712), 1,
      anon_sym_SEMI,
    ACTIONS(11714), 1,
      anon_sym_EQ,
    STATE(2088), 2,
      sym_compound_statement,
      sym_try_statement,
  [269374] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11716), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8066), 1,
      sym_attribute_specifier,
  [269396] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11718), 1,
      anon_sym_SEMI,
    STATE(6797), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8441), 1,
      sym_attribute_specifier,
  [269418] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(10148), 1,
      anon_sym_try,
    ACTIONS(11720), 1,
      anon_sym_SEMI,
    ACTIONS(11722), 1,
      anon_sym_EQ,
    STATE(769), 2,
      sym_compound_statement,
      sym_try_statement,
  [269438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11073), 1,
      anon_sym_LBRACK,
    STATE(6357), 1,
      sym_template_argument_list,
    ACTIONS(11071), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [269456] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    ACTIONS(10023), 1,
      anon_sym_try,
    ACTIONS(11724), 1,
      anon_sym_SEMI,
    ACTIONS(11726), 1,
      anon_sym_EQ,
    STATE(283), 2,
      sym_compound_statement,
      sym_try_statement,
  [269476] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11728), 1,
      anon_sym_SEMI,
    STATE(6820), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8463), 1,
      sym_attribute_specifier,
  [269498] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11730), 1,
      anon_sym_SEMI,
    STATE(6818), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7956), 1,
      sym_attribute_specifier,
  [269520] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    ACTIONS(10023), 1,
      anon_sym_try,
    ACTIONS(11732), 1,
      anon_sym_SEMI,
    ACTIONS(11734), 1,
      anon_sym_EQ,
    STATE(288), 2,
      sym_compound_statement,
      sym_try_statement,
  [269540] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(10588), 1,
      anon_sym_LBRACE,
    STATE(8505), 1,
      sym_trailing_return_type,
    STATE(6822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269560] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11736), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8611), 1,
      sym_attribute_specifier,
  [269582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10753), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [269602] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_try,
    ACTIONS(10966), 1,
      anon_sym_LBRACE,
    ACTIONS(11738), 1,
      anon_sym_SEMI,
    ACTIONS(11740), 1,
      anon_sym_EQ,
    STATE(1832), 2,
      sym_compound_statement,
      sym_try_statement,
  [269622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11680), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11682), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [269636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11227), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11742), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [269650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11069), 1,
      anon_sym_LBRACK,
    ACTIONS(11067), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269668] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11744), 1,
      anon_sym_SEMI,
    STATE(6783), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8112), 1,
      sym_attribute_specifier,
  [269690] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11746), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7960), 1,
      sym_attribute_specifier,
  [269712] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11748), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7961), 1,
      sym_attribute_specifier,
  [269734] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11750), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8477), 1,
      sym_attribute_specifier,
  [269756] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9782), 1,
      anon_sym_try,
    ACTIONS(10958), 1,
      anon_sym_LBRACE,
    ACTIONS(11752), 1,
      anon_sym_SEMI,
    ACTIONS(11754), 1,
      anon_sym_EQ,
    STATE(2132), 2,
      sym_compound_statement,
      sym_try_statement,
  [269776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11756), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11758), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [269790] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11760), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7971), 1,
      sym_attribute_specifier,
  [269812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(8028), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [269826] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11762), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8071), 1,
      sym_attribute_specifier,
  [269848] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11764), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8114), 1,
      sym_attribute_specifier,
  [269870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(10678), 1,
      anon_sym_LBRACE,
    STATE(8729), 1,
      sym_trailing_return_type,
    STATE(4776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269890] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11766), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8393), 1,
      sym_attribute_specifier,
  [269912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11768), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11770), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [269926] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10761), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [269946] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11772), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8117), 1,
      sym_attribute_specifier,
  [269968] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    ACTIONS(10114), 1,
      anon_sym_try,
    ACTIONS(11774), 1,
      anon_sym_SEMI,
    ACTIONS(11776), 1,
      anon_sym_EQ,
    STATE(711), 2,
      sym_compound_statement,
      sym_try_statement,
  [269988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11057), 1,
      anon_sym_LBRACK,
    STATE(6369), 1,
      sym_template_argument_list,
    ACTIONS(11053), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [270006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11778), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11780), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [270020] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11782), 1,
      anon_sym_SEMI,
    STATE(6826), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7999), 1,
      sym_attribute_specifier,
  [270042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11560), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11558), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [270056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11784), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11786), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [270070] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10007), 1,
      anon_sym_try,
    ACTIONS(11788), 1,
      anon_sym_SEMI,
    ACTIONS(11790), 1,
      anon_sym_EQ,
    STATE(476), 2,
      sym_compound_statement,
      sym_try_statement,
  [270090] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_try,
    ACTIONS(10966), 1,
      anon_sym_LBRACE,
    ACTIONS(11792), 1,
      anon_sym_SEMI,
    ACTIONS(11794), 1,
      anon_sym_EQ,
    STATE(1802), 2,
      sym_compound_statement,
      sym_try_statement,
  [270110] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(10148), 1,
      anon_sym_try,
    ACTIONS(11796), 1,
      anon_sym_SEMI,
    ACTIONS(11798), 1,
      anon_sym_EQ,
    STATE(660), 2,
      sym_compound_statement,
      sym_try_statement,
  [270130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(8278), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [270144] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3405), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
    ACTIONS(10749), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [270164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11800), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11802), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [270178] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9809), 1,
      anon_sym_try,
    ACTIONS(10948), 1,
      anon_sym_LBRACE,
    ACTIONS(11804), 1,
      anon_sym_SEMI,
    ACTIONS(11806), 1,
      anon_sym_EQ,
    STATE(1952), 2,
      sym_compound_statement,
      sym_try_statement,
  [270198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11768), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11770), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [270212] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym_LBRACK,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(3962), 1,
      sym_template_argument_list,
    ACTIONS(6515), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [270230] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11808), 1,
      anon_sym_SEMI,
    STATE(6792), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8483), 1,
      sym_attribute_specifier,
  [270252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym_LBRACK,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(3962), 1,
      sym_template_argument_list,
    ACTIONS(6515), 3,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [270270] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(10678), 1,
      anon_sym_LBRACE,
    STATE(8729), 1,
      sym_trailing_return_type,
    STATE(6784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [270290] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11810), 1,
      anon_sym_SEMI,
    STATE(6813), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8753), 1,
      sym_attribute_specifier,
  [270312] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11812), 1,
      anon_sym_SEMI,
    STATE(6814), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8770), 1,
      sym_attribute_specifier,
  [270334] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(8483), 1,
      anon_sym_COMMA,
    ACTIONS(11814), 1,
      anon_sym_SEMI,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7969), 1,
      sym_attribute_specifier,
  [270356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11816), 1,
      anon_sym_SEMI,
    STATE(6908), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [270373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11818), 1,
      anon_sym_SEMI,
    STATE(6929), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [270390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9337), 1,
      anon_sym_EQ,
    ACTIONS(11820), 1,
      sym_identifier,
    ACTIONS(9335), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [270407] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11822), 1,
      sym_identifier,
    STATE(7980), 1,
      sym__namespace_specifier,
    STATE(8354), 1,
      sym_nested_namespace_specifier,
  [270426] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(11824), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(3437), 1,
      sym_template_method,
    STATE(7892), 1,
      sym_operator_name,
  [270445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11826), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [270462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11828), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [270479] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1604), 1,
      sym_template_argument_list,
    ACTIONS(4965), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [270496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11830), 1,
      anon_sym_SEMI,
    STATE(6885), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [270513] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10753), 1,
      anon_sym_COLON,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [270532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11832), 1,
      anon_sym_SEMI,
    STATE(6898), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [270549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11834), 4,
      anon_sym_virtual,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
  [270562] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11838), 1,
      sym_identifier,
    STATE(7980), 1,
      sym__namespace_specifier,
    STATE(8341), 1,
      sym_nested_namespace_specifier,
  [270581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11842), 1,
      anon_sym_DOT,
    STATE(6872), 1,
      aux_sym_module_name_repeat1,
    ACTIONS(11840), 3,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [270596] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(11844), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2405), 1,
      sym_template_method,
    STATE(7748), 1,
      sym_operator_name,
  [270615] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_COLON,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [270634] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11846), 1,
      anon_sym_COMMA,
    ACTIONS(11851), 1,
      anon_sym___attribute,
    STATE(6864), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(11849), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [270651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11853), 1,
      anon_sym_COMMA,
    ACTIONS(11858), 1,
      anon_sym___attribute,
    STATE(6865), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(11856), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [270668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11860), 1,
      anon_sym_SEMI,
    STATE(6900), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [270685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(11864), 1,
      anon_sym_COLON_COLON,
    STATE(7908), 1,
      sym_argument_list,
    ACTIONS(11862), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [270702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10749), 1,
      anon_sym_COLON,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [270721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11866), 2,
      anon_sym_class,
      anon_sym_typename,
    STATE(7730), 3,
      sym_type_parameter_declaration,
      sym_variadic_type_parameter_declaration,
      sym_optional_type_parameter_declaration,
  [270734] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    ACTIONS(11868), 1,
      anon_sym_RPAREN,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [270753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11870), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [270770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11874), 1,
      anon_sym_DOT,
    STATE(6872), 1,
      aux_sym_module_name_repeat1,
    ACTIONS(11872), 3,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [270785] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10761), 1,
      anon_sym_COLON,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [270804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym_LBRACK,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(3695), 1,
      sym_template_argument_list,
    ACTIONS(6515), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [270821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11877), 1,
      sym_identifier,
    STATE(7980), 1,
      sym__namespace_specifier,
    STATE(8246), 1,
      sym_nested_namespace_specifier,
  [270840] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11879), 1,
      sym_identifier,
    STATE(7980), 1,
      sym__namespace_specifier,
    STATE(7982), 1,
      sym_nested_namespace_specifier,
  [270859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2324), 1,
      sym_template_argument_list,
    ACTIONS(6312), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [270876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11881), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6180), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_or,
  [270889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [270908] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11883), 1,
      sym_identifier,
    STATE(7392), 1,
      sym__namespace_specifier,
    STATE(7698), 1,
      sym_nested_namespace_specifier,
  [270927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6255), 1,
      anon_sym_LBRACE,
    ACTIONS(11881), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11885), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
  [270942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(11887), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(3581), 1,
      sym_template_method,
    STATE(7745), 1,
      sym_operator_name,
  [270961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11889), 1,
      anon_sym_SEMI,
    STATE(6894), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [270978] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11392), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11394), 1,
      anon_sym_inline,
    ACTIONS(11883), 1,
      sym_identifier,
    STATE(7297), 1,
      sym__namespace_specifier,
    STATE(7596), 1,
      sym_nested_namespace_specifier,
  [270997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11891), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271014] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10731), 1,
      anon_sym_COLON,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [271033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11893), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271050] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym_LBRACK,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(4226), 1,
      sym_template_argument_list,
    ACTIONS(6515), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [271067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11895), 5,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [271078] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11897), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(11899), 1,
      aux_sym_preproc_if_token2,
    STATE(6732), 1,
      sym_enumerator,
    STATE(7058), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7059), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [271114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(11901), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2405), 1,
      sym_template_method,
    STATE(7700), 1,
      sym_operator_name,
  [271133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11903), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11905), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271167] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11907), 1,
      anon_sym_SEMI,
    STATE(6902), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271184] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11235), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_SEMI,
    STATE(7324), 1,
      sym_module_partition,
    STATE(8142), 1,
      sym_attribute_declaration,
  [271203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11197), 1,
      anon_sym_COMMA,
    ACTIONS(11913), 1,
      anon_sym___attribute,
    STATE(6865), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(11911), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [271220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11915), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11917), 1,
      anon_sym_SEMI,
    STATE(6922), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271254] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11919), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11921), 1,
      anon_sym_SEMI,
    STATE(6853), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11923), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271305] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10741), 1,
      anon_sym_COLON,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [271324] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    ACTIONS(11925), 1,
      anon_sym_RPAREN,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [271343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(10757), 1,
      anon_sym_COLON,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    STATE(3485), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [271362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11927), 1,
      anon_sym_SEMI,
    STATE(6854), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11929), 1,
      anon_sym_SEMI,
    STATE(6871), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11931), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11933), 1,
      anon_sym_SEMI,
    STATE(6911), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271430] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11935), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11937), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11939), 1,
      anon_sym_SEMI,
    STATE(6890), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11941), 1,
      anon_sym_SEMI,
    STATE(6893), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271498] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    ACTIONS(11945), 1,
      anon_sym_COLON_COLON,
    STATE(7849), 1,
      sym_argument_list,
    ACTIONS(11943), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [271515] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    ACTIONS(11947), 1,
      anon_sym_RPAREN,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [271534] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11235), 1,
      anon_sym_COLON,
    ACTIONS(11949), 1,
      anon_sym_SEMI,
    STATE(7271), 1,
      sym_module_partition,
    STATE(8732), 1,
      sym_attribute_declaration,
  [271553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    STATE(2504), 1,
      sym_decltype_auto,
    ACTIONS(11951), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [271570] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11953), 1,
      anon_sym_SEMI,
    STATE(6919), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271587] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11955), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11957), 1,
      anon_sym_SEMI,
    STATE(6887), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11959), 1,
      anon_sym_SEMI,
    STATE(6910), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271638] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11961), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11842), 1,
      anon_sym_DOT,
    STATE(6861), 1,
      aux_sym_module_name_repeat1,
    ACTIONS(11963), 3,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
  [271670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11965), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8209), 1,
      sym_auto,
    ACTIONS(8211), 1,
      anon_sym_decltype,
    STATE(2504), 1,
      sym_decltype_auto,
    ACTIONS(11967), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [271704] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_operator,
    ACTIONS(11901), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2405), 1,
      sym_template_method,
    STATE(7632), 1,
      sym_operator_name,
  [271723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11969), 1,
      anon_sym_SEMI,
    STATE(6924), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271740] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    ACTIONS(11061), 1,
      anon_sym_LBRACK,
    ACTIONS(11971), 1,
      anon_sym_RPAREN,
    STATE(3004), 1,
      sym_parameter_list,
    STATE(6049), 1,
      sym__function_declarator_seq,
  [271759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7147), 1,
      anon_sym___attribute__,
    ACTIONS(11973), 1,
      anon_sym_SEMI,
    STATE(4249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [271776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(2330), 1,
      sym_field_declaration_list,
    STATE(7597), 1,
      sym_base_class_clause,
  [271792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(11975), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [271808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11977), 1,
      anon_sym___except,
    ACTIONS(11979), 1,
      anon_sym___finally,
    STATE(592), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [271822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11983), 1,
      anon_sym_GT2,
    STATE(7300), 1,
      aux_sym_template_argument_list_repeat1,
  [271838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    STATE(3955), 1,
      sym_field_declaration_list,
    STATE(7865), 1,
      sym_base_class_clause,
  [271854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11985), 1,
      anon_sym_COMMA,
    STATE(7092), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(11987), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [271868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11989), 1,
      anon_sym_COMMA,
    STATE(7107), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(11991), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [271882] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11993), 1,
      anon_sym_DQUOTE,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [271898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11999), 1,
      anon_sym_GT2,
    STATE(7195), 1,
      aux_sym_template_argument_list_repeat1,
  [271914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12001), 1,
      anon_sym_GT2,
    STATE(7240), 1,
      aux_sym_template_argument_list_repeat1,
  [271930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12003), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [271940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11872), 4,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOT,
  [271950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12005), 1,
      anon_sym_EQ,
    STATE(7062), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271964] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12007), 1,
      anon_sym_DQUOTE,
    ACTIONS(12009), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12011), 1,
      sym_escape_sequence,
    STATE(6945), 1,
      aux_sym_string_literal_repeat1,
  [271980] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12013), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [271994] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12017), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [272010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2638), 1,
      sym_field_declaration_list,
    STATE(7606), 1,
      sym_base_class_clause,
  [272026] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12019), 1,
      anon_sym_DQUOTE,
    ACTIONS(12021), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12023), 1,
      sym_escape_sequence,
    STATE(6993), 1,
      aux_sym_string_literal_repeat1,
  [272042] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12025), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [272056] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_DQUOTE,
    ACTIONS(12029), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12031), 1,
      sym_escape_sequence,
    STATE(6958), 1,
      aux_sym_string_literal_repeat1,
  [272072] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12033), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [272088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8701), 1,
      anon_sym___attribute,
    ACTIONS(8699), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [272100] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12035), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [272116] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12037), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12039), 1,
      anon_sym_LPAREN,
    ACTIONS(12041), 1,
      sym_preproc_arg,
    STATE(7779), 1,
      sym_preproc_params,
  [272132] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    STATE(7180), 1,
      sym_compound_statement,
    STATE(7572), 1,
      sym_field_initializer_list,
  [272148] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    STATE(7316), 1,
      sym_compound_statement,
    STATE(7740), 1,
      sym_field_initializer_list,
  [272164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    STATE(3598), 1,
      sym_argument_list,
    STATE(4839), 1,
      sym_initializer_list,
  [272180] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12043), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [272194] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12045), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [272210] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12039), 1,
      anon_sym_LPAREN,
    ACTIONS(12047), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12049), 1,
      sym_preproc_arg,
    STATE(7885), 1,
      sym_preproc_params,
  [272226] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12051), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [272242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12053), 1,
      anon_sym_GT2,
    STATE(7418), 1,
      aux_sym_template_argument_list_repeat1,
  [272258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12055), 1,
      anon_sym_COMMA,
    STATE(6962), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12058), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [272272] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12060), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [272286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(12062), 1,
      sym_identifier,
    STATE(836), 1,
      sym_template_parameter_list,
    STATE(1910), 1,
      sym_template_type,
  [272302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    STATE(4541), 1,
      sym_field_declaration_list,
    STATE(7812), 1,
      sym_base_class_clause,
  [272318] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12064), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [272334] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12066), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [272350] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12039), 1,
      anon_sym_LPAREN,
    ACTIONS(12068), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12070), 1,
      sym_preproc_arg,
    STATE(7797), 1,
      sym_preproc_params,
  [272366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12003), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [272376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    STATE(2862), 1,
      sym_field_declaration_list,
    STATE(7889), 1,
      sym_base_class_clause,
  [272392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12072), 1,
      anon_sym_LPAREN2,
    ACTIONS(12074), 1,
      anon_sym_LBRACE,
    STATE(1611), 1,
      sym_requirement_seq,
    STATE(7788), 1,
      sym_requires_parameter_list,
  [272408] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12076), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [272422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11537), 1,
      anon_sym_EQ,
    STATE(7097), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [272436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1954), 1,
      anon_sym_LBRACE,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    STATE(2436), 1,
      sym_argument_list,
    STATE(2500), 1,
      sym_initializer_list,
  [272452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(7144), 2,
      sym_argument_list,
      sym_initializer_list,
  [272466] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12039), 1,
      anon_sym_LPAREN,
    ACTIONS(12078), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12080), 1,
      sym_preproc_arg,
    STATE(7681), 1,
      sym_preproc_params,
  [272482] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12082), 1,
      sym_identifier,
    ACTIONS(12084), 1,
      anon_sym_SEMI,
    ACTIONS(12086), 1,
      anon_sym_COLON,
    STATE(6916), 1,
      sym_module_name,
  [272498] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12088), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [272514] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12090), 1,
      anon_sym_GT2,
    STATE(7213), 1,
      aux_sym_template_argument_list_repeat1,
  [272530] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(12062), 1,
      sym_identifier,
    STATE(833), 1,
      sym_template_parameter_list,
    STATE(1910), 1,
      sym_template_type,
  [272546] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12092), 1,
      anon_sym_DQUOTE,
    ACTIONS(12094), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12096), 1,
      sym_escape_sequence,
    STATE(7064), 1,
      aux_sym_string_literal_repeat1,
  [272562] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    STATE(3421), 1,
      sym_argument_list,
    STATE(3426), 1,
      sym_initializer_list,
  [272578] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [272592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    STATE(4844), 1,
      sym_field_declaration_list,
    STATE(7625), 1,
      sym_base_class_clause,
  [272608] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9730), 1,
      anon_sym_LBRACE,
    ACTIONS(12072), 1,
      anon_sym_LPAREN2,
    STATE(3240), 1,
      sym_requirement_seq,
    STATE(7633), 1,
      sym_requires_parameter_list,
  [272624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9748), 1,
      anon_sym_LBRACE,
    ACTIONS(12072), 1,
      anon_sym_LPAREN2,
    STATE(4248), 1,
      sym_requirement_seq,
    STATE(7874), 1,
      sym_requires_parameter_list,
  [272640] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12100), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [272656] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12102), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [272670] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12104), 1,
      anon_sym_DQUOTE,
    ACTIONS(12106), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12108), 1,
      sym_escape_sequence,
    STATE(6978), 1,
      aux_sym_string_literal_repeat1,
  [272686] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12114), 1,
      anon_sym_LBRACE,
    STATE(7304), 1,
      aux_sym_base_class_clause_repeat1,
  [272702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    STATE(7405), 1,
      sym_compound_statement,
    STATE(7757), 1,
      sym_field_initializer_list,
  [272718] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12116), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [272734] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12118), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [272750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12072), 1,
      anon_sym_LPAREN2,
    ACTIONS(12120), 1,
      anon_sym_LBRACE,
    STATE(5918), 1,
      sym_requirement_seq,
    STATE(7813), 1,
      sym_requires_parameter_list,
  [272766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(2895), 1,
      sym_field_declaration_list,
    STATE(7794), 1,
      sym_base_class_clause,
  [272782] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12122), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [272796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(2351), 1,
      sym_field_declaration_list,
    STATE(7903), 1,
      sym_base_class_clause,
  [272812] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12124), 1,
      anon_sym_DQUOTE,
    ACTIONS(12126), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12128), 1,
      sym_escape_sequence,
    STATE(7015), 1,
      aux_sym_string_literal_repeat1,
  [272828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(12062), 1,
      sym_identifier,
    STATE(832), 1,
      sym_template_parameter_list,
    STATE(1910), 1,
      sym_template_type,
  [272844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9740), 1,
      anon_sym_LBRACE,
    ACTIONS(12072), 1,
      anon_sym_LPAREN2,
    STATE(3589), 1,
      sym_requirement_seq,
    STATE(7672), 1,
      sym_requires_parameter_list,
  [272860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12132), 1,
      anon_sym_EQ,
    STATE(304), 1,
      sym_declaration_list,
  [272876] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12134), 1,
      anon_sym_DQUOTE,
    ACTIONS(12136), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12138), 1,
      sym_escape_sequence,
    STATE(6967), 1,
      aux_sym_string_literal_repeat1,
  [272892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(2929), 1,
      sym_field_declaration_list,
    STATE(7746), 1,
      sym_base_class_clause,
  [272908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12140), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [272924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12142), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [272940] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    STATE(7269), 1,
      sym_compound_statement,
    STATE(7673), 1,
      sym_field_initializer_list,
  [272956] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12144), 1,
      anon_sym_DQUOTE,
    ACTIONS(12146), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12148), 1,
      sym_escape_sequence,
    STATE(7053), 1,
      aux_sym_string_literal_repeat1,
  [272972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(12150), 1,
      anon_sym_SEMI,
    ACTIONS(12152), 1,
      anon_sym_noexcept,
    STATE(8102), 1,
      sym_trailing_return_type,
  [272988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12154), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12156), 1,
      anon_sym_LBRACE,
    STATE(7539), 1,
      aux_sym_base_class_clause_repeat1,
  [273004] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(5045), 1,
      sym_field_declaration_list,
    STATE(7845), 1,
      sym_base_class_clause,
  [273020] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(5051), 1,
      sym_field_declaration_list,
    STATE(7846), 1,
      sym_base_class_clause,
  [273036] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12158), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [273052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    STATE(2193), 1,
      sym_field_declaration_list,
    STATE(7641), 1,
      sym_base_class_clause,
  [273068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12160), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [273084] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12162), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [273100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    STATE(4886), 1,
      sym_field_declaration_list,
    STATE(7684), 1,
      sym_base_class_clause,
  [273116] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12164), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [273130] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12166), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [273146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12168), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [273162] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12170), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12172), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [273176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(5827), 1,
      anon_sym_LPAREN2,
    STATE(2436), 1,
      sym_argument_list,
    STATE(3806), 1,
      sym_initializer_list,
  [273192] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9722), 1,
      anon_sym_LBRACE,
    ACTIONS(12072), 1,
      anon_sym_LPAREN2,
    STATE(2527), 1,
      sym_requirement_seq,
    STATE(7921), 1,
      sym_requires_parameter_list,
  [273208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12072), 1,
      anon_sym_LPAREN2,
    ACTIONS(12175), 1,
      anon_sym_LBRACE,
    STATE(5604), 1,
      sym_requirement_seq,
    STATE(7870), 1,
      sym_requires_parameter_list,
  [273224] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    STATE(2206), 1,
      sym_field_declaration_list,
    STATE(7619), 1,
      sym_base_class_clause,
  [273240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12177), 1,
      anon_sym_GT2,
    STATE(7157), 1,
      aux_sym_template_argument_list_repeat1,
  [273256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12179), 1,
      anon_sym___except,
    ACTIONS(12181), 1,
      anon_sym___finally,
    STATE(911), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [273270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12183), 1,
      anon_sym_EQ,
    STATE(792), 1,
      sym_declaration_list,
  [273286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12185), 1,
      anon_sym_COMMA,
    STATE(7120), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(12187), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [273300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1604), 1,
      sym_template_argument_list,
    ACTIONS(6515), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [273314] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12189), 1,
      anon_sym_GT2,
    STATE(7220), 1,
      aux_sym_template_argument_list_repeat1,
  [273330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12193), 1,
      anon_sym___attribute,
    ACTIONS(12191), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [273342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12195), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [273358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    STATE(7493), 1,
      sym_compound_statement,
    STATE(7773), 1,
      sym_field_initializer_list,
  [273374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12197), 1,
      anon_sym_EQ,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12199), 1,
      anon_sym___except,
    ACTIONS(12201), 1,
      anon_sym___finally,
    STATE(502), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [273402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12203), 1,
      anon_sym_using,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11551), 1,
      anon_sym_EQ,
    STATE(7118), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273430] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12205), 1,
      anon_sym_DQUOTE,
    ACTIONS(12207), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12209), 1,
      sym_escape_sequence,
    STATE(6987), 1,
      aux_sym_string_literal_repeat1,
  [273446] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12211), 1,
      anon_sym_DQUOTE,
    ACTIONS(12213), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12216), 1,
      sym_escape_sequence,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [273462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12219), 1,
      anon_sym_GT2,
    STATE(7182), 1,
      aux_sym_template_argument_list_repeat1,
  [273478] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12221), 1,
      anon_sym_DQUOTE,
    ACTIONS(12223), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12225), 1,
      sym_escape_sequence,
    STATE(6960), 1,
      aux_sym_string_literal_repeat1,
  [273494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12227), 1,
      anon_sym_EQ,
    STATE(658), 1,
      sym_declaration_list,
  [273510] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(12062), 1,
      sym_identifier,
    STATE(837), 1,
      sym_template_parameter_list,
    STATE(1910), 1,
      sym_template_type,
  [273526] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2578), 1,
      sym_field_declaration_list,
    STATE(7621), 1,
      sym_base_class_clause,
  [273542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      sym_identifier,
    ACTIONS(12231), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [273554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12233), 1,
      anon_sym_EQ,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11502), 1,
      anon_sym_EQ,
    STATE(7034), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(7564), 1,
      sym_argument_list,
    ACTIONS(12235), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [273596] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12237), 1,
      anon_sym_DQUOTE,
    ACTIONS(12239), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12241), 1,
      sym_escape_sequence,
    STATE(7130), 1,
      aux_sym_string_literal_repeat1,
  [273612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12245), 1,
      anon_sym___attribute,
    ACTIONS(12243), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [273624] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12247), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [273638] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(12062), 1,
      sym_identifier,
    STATE(835), 1,
      sym_template_parameter_list,
    STATE(1910), 1,
      sym_template_type,
  [273654] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12249), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [273670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12251), 1,
      anon_sym_EQ,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11547), 1,
      anon_sym_EQ,
    STATE(7046), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12253), 1,
      anon_sym_GT2,
    STATE(7330), 1,
      aux_sym_template_argument_list_repeat1,
  [273714] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12039), 1,
      anon_sym_LPAREN,
    ACTIONS(12255), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12257), 1,
      sym_preproc_arg,
    STATE(7897), 1,
      sym_preproc_params,
  [273730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(12259), 1,
      aux_sym_preproc_if_token2,
    STATE(6705), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
  [273746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(12261), 1,
      aux_sym_preproc_if_token2,
    STATE(6706), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [273760] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12263), 1,
      anon_sym_DQUOTE,
    ACTIONS(12265), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12267), 1,
      sym_escape_sequence,
    STATE(7089), 1,
      aux_sym_string_literal_repeat1,
  [273776] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12269), 1,
      anon_sym_DQUOTE,
    ACTIONS(12271), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12273), 1,
      sym_escape_sequence,
    STATE(7124), 1,
      aux_sym_string_literal_repeat1,
  [273792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12275), 1,
      anon_sym_EQ,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11494), 1,
      anon_sym_EQ,
    STATE(7071), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273820] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12277), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [273836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    STATE(7448), 1,
      sym_compound_statement,
    STATE(7753), 1,
      sym_field_initializer_list,
  [273852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10917), 1,
      anon_sym_COLON,
    STATE(7167), 1,
      sym_compound_statement,
    STATE(7717), 1,
      sym_field_initializer_list,
  [273868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12279), 1,
      anon_sym_using,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273882] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12283), 1,
      anon_sym_LBRACE,
    STATE(7545), 1,
      aux_sym_base_class_clause_repeat1,
  [273898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12285), 1,
      anon_sym_GT2,
    STATE(7190), 1,
      aux_sym_template_argument_list_repeat1,
  [273914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(12062), 1,
      sym_identifier,
    STATE(834), 1,
      sym_template_parameter_list,
    STATE(1910), 1,
      sym_template_type,
  [273930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12287), 1,
      anon_sym_EQ,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11571), 1,
      anon_sym_EQ,
    STATE(7075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273958] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12289), 1,
      anon_sym_DQUOTE,
    ACTIONS(12291), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12293), 1,
      sym_escape_sequence,
    STATE(6950), 1,
      aux_sym_string_literal_repeat1,
  [273974] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12295), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [273990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12297), 1,
      anon_sym_EQ,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11575), 1,
      anon_sym_EQ,
    STATE(7079), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274018] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12299), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [274034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11043), 1,
      sym_identifier,
    ACTIONS(11899), 1,
      aux_sym_preproc_if_token2,
    STATE(7058), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8666), 1,
      sym_enumerator,
  [274050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12301), 1,
      anon_sym_EQ,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274064] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12039), 1,
      anon_sym_LPAREN,
    ACTIONS(12303), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12305), 1,
      sym_preproc_arg,
    STATE(7588), 1,
      sym_preproc_params,
  [274080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12307), 1,
      anon_sym_GT2,
    STATE(7326), 1,
      aux_sym_template_argument_list_repeat1,
  [274096] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12309), 1,
      anon_sym_DQUOTE,
    ACTIONS(12311), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12313), 1,
      sym_escape_sequence,
    STATE(6966), 1,
      aux_sym_string_literal_repeat1,
  [274112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12315), 1,
      anon_sym_GT2,
    STATE(7205), 1,
      aux_sym_template_argument_list_repeat1,
  [274128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(3615), 1,
      sym_field_declaration_list,
    STATE(7882), 1,
      sym_base_class_clause,
  [274144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12317), 1,
      anon_sym___except,
    ACTIONS(12319), 1,
      anon_sym___finally,
    STATE(502), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [274158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(3619), 1,
      sym_field_declaration_list,
    STATE(7883), 1,
      sym_base_class_clause,
  [274174] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12321), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [274188] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12039), 1,
      anon_sym_LPAREN,
    ACTIONS(12323), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12325), 1,
      sym_preproc_arg,
    STATE(7678), 1,
      sym_preproc_params,
  [274204] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12327), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [274220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_LBRACE,
    ACTIONS(6979), 1,
      anon_sym_LPAREN2,
    STATE(3541), 1,
      sym_initializer_list,
    STATE(3598), 1,
      sym_argument_list,
  [274236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    ACTIONS(12329), 1,
      aux_sym_preproc_if_token2,
    STATE(7059), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [274250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12331), 1,
      anon_sym_COMMA,
    STATE(7092), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(12334), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [274264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11985), 1,
      anon_sym_COMMA,
    STATE(6935), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(12336), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [274278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12338), 1,
      anon_sym_GT2,
    STATE(7231), 1,
      aux_sym_template_argument_list_repeat1,
  [274294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    STATE(3960), 1,
      sym_field_declaration_list,
    STATE(7573), 1,
      sym_base_class_clause,
  [274310] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    STATE(4539), 1,
      sym_field_declaration_list,
    STATE(7833), 1,
      sym_base_class_clause,
  [274326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12340), 1,
      anon_sym_EQ,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274340] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4965), 1,
      anon_sym_SEMI,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1701), 1,
      sym_template_argument_list,
  [274356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_LPAREN2,
    STATE(3421), 1,
      sym_argument_list,
    STATE(3912), 1,
      sym_initializer_list,
  [274372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12342), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [274388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12344), 1,
      anon_sym_GT2,
    STATE(7504), 1,
      aux_sym_template_argument_list_repeat1,
  [274404] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12346), 1,
      anon_sym_DQUOTE,
    ACTIONS(12348), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12350), 1,
      sym_escape_sequence,
    STATE(6952), 1,
      aux_sym_string_literal_repeat1,
  [274420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12352), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [274436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(7742), 1,
      sym_argument_list,
    ACTIONS(12354), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [274450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12356), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [274466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12358), 1,
      anon_sym_GT2,
    STATE(7173), 1,
      aux_sym_template_argument_list_repeat1,
  [274482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11989), 1,
      anon_sym_COMMA,
    STATE(6962), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12360), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [274496] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12362), 1,
      anon_sym_DQUOTE,
    ACTIONS(12364), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12366), 1,
      sym_escape_sequence,
    STATE(6937), 1,
      aux_sym_string_literal_repeat1,
  [274512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12368), 1,
      anon_sym___except,
    ACTIONS(12370), 1,
      anon_sym___finally,
    STATE(413), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [274526] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12372), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [274542] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    STATE(2848), 1,
      sym_field_declaration_list,
    STATE(7899), 1,
      sym_base_class_clause,
  [274558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    STATE(2984), 1,
      sym_field_declaration_list,
    STATE(7721), 1,
      sym_base_class_clause,
  [274574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    STATE(2816), 1,
      sym_field_declaration_list,
    STATE(7612), 1,
      sym_base_class_clause,
  [274590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(12062), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(6869), 1,
      sym_template_parameter_list,
  [274606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_LT,
    ACTIONS(12062), 1,
      sym_identifier,
    STATE(838), 1,
      sym_template_parameter_list,
    STATE(1910), 1,
      sym_template_type,
  [274622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12374), 1,
      anon_sym_COMMA,
    STATE(7116), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(12377), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [274636] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12379), 1,
      anon_sym_DQUOTE,
    ACTIONS(12381), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12383), 1,
      sym_escape_sequence,
    STATE(7074), 1,
      aux_sym_string_literal_repeat1,
  [274652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12385), 1,
      anon_sym_EQ,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12387), 1,
      anon_sym_GT2,
    STATE(7553), 1,
      aux_sym_template_argument_list_repeat1,
  [274682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12185), 1,
      anon_sym_COMMA,
    STATE(7116), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(12389), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [274696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9756), 1,
      anon_sym_LBRACE,
    ACTIONS(12072), 1,
      anon_sym_LPAREN2,
    STATE(3916), 1,
      sym_requirement_seq,
    STATE(7583), 1,
      sym_requires_parameter_list,
  [274712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12391), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12393), 1,
      anon_sym_LBRACE,
    STATE(7150), 1,
      aux_sym_base_class_clause_repeat1,
  [274728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12395), 1,
      anon_sym___except,
    ACTIONS(12397), 1,
      anon_sym___finally,
    STATE(268), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [274742] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12399), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [274758] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12401), 1,
      anon_sym_DQUOTE,
    ACTIONS(12403), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12405), 1,
      sym_escape_sequence,
    STATE(7018), 1,
      aux_sym_string_literal_repeat1,
  [274774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    STATE(2815), 1,
      sym_field_declaration_list,
    STATE(7772), 1,
      sym_base_class_clause,
  [274790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_COLON,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    STATE(3097), 1,
      sym_field_declaration_list,
    STATE(7693), 1,
      sym_base_class_clause,
  [274806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12407), 1,
      anon_sym_using,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274820] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12409), 1,
      anon_sym_GT2,
    STATE(7390), 1,
      aux_sym_template_argument_list_repeat1,
  [274836] = 5,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(11995), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11997), 1,
      sym_escape_sequence,
    ACTIONS(12411), 1,
      anon_sym_DQUOTE,
    STATE(7039), 1,
      aux_sym_string_literal_repeat1,
  [274852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12413), 1,
      anon_sym_EQ,
    STATE(7054), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274866] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12415), 1,
      anon_sym_EQ,
    STATE(516), 1,
      sym_declaration_list,
  [274882] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6630), 1,
      anon_sym_LT,
    ACTIONS(12417), 1,
      anon_sym_SEMI,
    STATE(1603), 1,
      sym_template_argument_list,
  [274898] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_SQUOTE,
    STATE(7020), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12015), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [274912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9764), 1,
      anon_sym_LBRACE,
    ACTIONS(12072), 1,
      anon_sym_LPAREN2,
    STATE(3475), 1,
      sym_requirement_seq,
    STATE(7862), 1,
      sym_requires_parameter_list,
  [274928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(12423), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7184), 1,
      aux_sym_attribute_declaration_repeat1,
  [274941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(12425), 1,
      anon_sym_RPAREN,
    STATE(7243), 1,
      aux_sym_generic_expression_repeat1,
  [274954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(12427), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7395), 1,
      aux_sym_attribute_declaration_repeat1,
  [274967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12429), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12431), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [274978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8880), 1,
      anon_sym_RPAREN,
    STATE(7175), 1,
      aux_sym_argument_list_repeat1,
  [274991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    STATE(669), 1,
      sym_declaration_list,
  [275004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12433), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [275013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12435), 1,
      anon_sym_COMMA,
    ACTIONS(12437), 1,
      anon_sym_LBRACE,
    STATE(7459), 1,
      aux_sym_field_initializer_list_repeat1,
  [275026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12439), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12441), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [275037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12443), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [275046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8851), 1,
      anon_sym_COMMA,
    ACTIONS(8853), 1,
      anon_sym_RBRACE,
    STATE(7178), 1,
      aux_sym_initializer_list_repeat1,
  [275059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12445), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(3519), 1,
      sym_template_function,
  [275072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6586), 1,
      anon_sym___attribute,
    ACTIONS(6588), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [275083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_COMMA,
    ACTIONS(12447), 1,
      anon_sym_RPAREN,
    STATE(7487), 1,
      aux_sym_preproc_argument_list_repeat1,
  [275096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12449), 1,
      anon_sym_LBRACE,
    STATE(7318), 1,
      aux_sym_base_class_clause_repeat1,
  [275109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12451), 1,
      anon_sym_GT2,
    STATE(7158), 1,
      aux_sym_template_argument_list_repeat1,
  [275122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12453), 1,
      anon_sym_COMMA,
    ACTIONS(12455), 1,
      anon_sym_RPAREN,
    STATE(7257), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [275135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8797), 1,
      anon_sym_RPAREN,
    STATE(7410), 1,
      aux_sym_argument_list_repeat1,
  [275148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12457), 1,
      anon_sym_RPAREN,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    STATE(7186), 1,
      sym_gnu_asm_output_operand_list,
  [275161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12461), 1,
      anon_sym_GT2,
    STATE(7191), 1,
      aux_sym_template_argument_list_repeat1,
  [275174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12463), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12465), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12467), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12469), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12471), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [275224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12473), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2435), 1,
      sym_template_function,
  [275237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_COMMA,
    ACTIONS(8911), 1,
      anon_sym_RBRACK,
    STATE(7533), 1,
      aux_sym_subscript_argument_list_repeat1,
  [275250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12475), 1,
      anon_sym_SEMI,
    STATE(7198), 1,
      aux_sym_declaration_repeat1,
  [275263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12477), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [275276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12479), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [275289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12449), 1,
      anon_sym_LBRACE,
    STATE(7509), 1,
      aux_sym_base_class_clause_repeat1,
  [275302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    ACTIONS(12483), 1,
      anon_sym_RPAREN,
    STATE(7199), 1,
      aux_sym_parameter_list_repeat1,
  [275315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12485), 1,
      anon_sym_catch,
    STATE(1862), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [275326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12487), 1,
      anon_sym_catch,
    STATE(388), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [275337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12489), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(3254), 1,
      sym_template_function,
  [275350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_COMMA,
    ACTIONS(12491), 1,
      anon_sym_RBRACK,
    STATE(7465), 1,
      aux_sym_subscript_argument_list_repeat1,
  [275363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12493), 1,
      anon_sym_GT2,
    STATE(7174), 1,
      aux_sym_template_argument_list_repeat1,
  [275376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12495), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12497), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12499), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(12501), 1,
      anon_sym_RPAREN,
    STATE(7279), 1,
      aux_sym_argument_list_repeat1,
  [275428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    STATE(685), 1,
      sym_declaration_list,
  [275441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12503), 1,
      sym_identifier,
    STATE(1790), 1,
      sym_template_type,
    STATE(3519), 1,
      sym_template_function,
  [275454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4521), 1,
      anon_sym_RBRACE,
    ACTIONS(12505), 1,
      anon_sym_COMMA,
    STATE(7289), 1,
      aux_sym_initializer_list_repeat1,
  [275467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12507), 1,
      anon_sym_GT2,
    STATE(7183), 1,
      aux_sym_template_argument_list_repeat1,
  [275480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12509), 1,
      anon_sym_catch,
    STATE(445), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [275491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12511), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12513), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12515), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(12517), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7395), 1,
      aux_sym_attribute_declaration_repeat1,
  [275543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_COMMA,
    ACTIONS(12521), 1,
      anon_sym_RPAREN,
    STATE(7470), 1,
      aux_sym_throw_specifier_repeat1,
  [275556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12523), 1,
      anon_sym_RPAREN,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    STATE(7215), 1,
      sym_gnu_asm_input_operand_list,
  [275569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(12527), 1,
      anon_sym_RPAREN,
    STATE(7216), 1,
      sym_gnu_asm_output_operand_list,
  [275582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(11514), 1,
      anon_sym_LBRACE,
    STATE(8318), 1,
      sym_requires_clause,
  [275595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12529), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12531), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12533), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12535), 1,
      sym_identifier,
    STATE(1790), 1,
      sym_template_type,
    STATE(2435), 1,
      sym_template_function,
  [275647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12537), 1,
      anon_sym_GT2,
    STATE(7196), 1,
      aux_sym_template_argument_list_repeat1,
  [275660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12539), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12541), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12543), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8888), 1,
      anon_sym_RPAREN,
    STATE(7305), 1,
      aux_sym_argument_list_repeat1,
  [275712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12545), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [275725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    ACTIONS(12547), 1,
      anon_sym_RPAREN,
    STATE(7454), 1,
      aux_sym_parameter_list_repeat1,
  [275738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12485), 1,
      anon_sym_catch,
    STATE(1855), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [275749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(12549), 1,
      anon_sym_RPAREN,
    STATE(7290), 1,
      sym_gnu_asm_output_operand_list,
  [275762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12551), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_template_function,
  [275775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12553), 1,
      anon_sym_GT2,
    STATE(7206), 1,
      aux_sym_template_argument_list_repeat1,
  [275788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12555), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12557), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12559), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    STATE(318), 1,
      sym_declaration_list,
  [275840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(10592), 1,
      anon_sym_LBRACE,
    STATE(8330), 1,
      sym_requires_clause,
  [275853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8890), 1,
      anon_sym_COMMA,
    ACTIONS(8892), 1,
      anon_sym_RBRACE,
    STATE(7307), 1,
      aux_sym_initializer_list_repeat1,
  [275866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12561), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2435), 1,
      sym_template_function,
  [275879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12563), 1,
      anon_sym_GT2,
    STATE(7214), 1,
      aux_sym_template_argument_list_repeat1,
  [275892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12565), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12567), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12569), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12571), 1,
      anon_sym_RPAREN,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    STATE(7224), 1,
      sym_gnu_asm_clobber_list,
  [275944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(12575), 1,
      anon_sym_RPAREN,
    STATE(7225), 1,
      sym_gnu_asm_input_operand_list,
  [275957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12577), 1,
      sym_identifier,
    STATE(2557), 1,
      sym_template_type,
    STATE(3689), 1,
      sym_template_function,
  [275970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12579), 1,
      anon_sym_GT2,
    STATE(7221), 1,
      aux_sym_template_argument_list_repeat1,
  [275983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12581), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [275996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12583), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [276009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12585), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [276022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12587), 1,
      anon_sym_COMMA,
    ACTIONS(12589), 1,
      anon_sym_RBRACK,
    STATE(7265), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [276035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(12591), 1,
      anon_sym_RPAREN,
    STATE(7279), 1,
      aux_sym_argument_list_repeat1,
  [276048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12593), 1,
      anon_sym_RPAREN,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    STATE(8098), 1,
      sym_gnu_asm_goto_list,
  [276061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(12597), 1,
      anon_sym_RPAREN,
    STATE(7228), 1,
      sym_gnu_asm_clobber_list,
  [276074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_COMMA,
    ACTIONS(12599), 1,
      anon_sym_RPAREN,
    STATE(7487), 1,
      aux_sym_preproc_argument_list_repeat1,
  [276087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12601), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_template_function,
  [276100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(12603), 1,
      anon_sym_RPAREN,
    STATE(8143), 1,
      sym_gnu_asm_goto_list,
  [276113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12605), 1,
      anon_sym_GT2,
    STATE(7232), 1,
      aux_sym_template_argument_list_repeat1,
  [276126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12607), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [276139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12609), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [276152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12611), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [276165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(12613), 1,
      anon_sym_RPAREN,
    STATE(7243), 1,
      aux_sym_generic_expression_repeat1,
  [276178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12615), 1,
      anon_sym_COMMA,
    ACTIONS(12617), 1,
      anon_sym_RPAREN,
    STATE(7494), 1,
      aux_sym_preproc_params_repeat1,
  [276191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(12619), 1,
      anon_sym_RPAREN,
    STATE(7981), 1,
      sym_gnu_asm_goto_list,
  [276204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12621), 1,
      anon_sym_GT2,
    STATE(7303), 1,
      aux_sym_template_argument_list_repeat1,
  [276217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(3519), 1,
      sym_template_function,
  [276230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12625), 1,
      anon_sym_GT2,
    STATE(7241), 1,
      aux_sym_template_argument_list_repeat1,
  [276243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12627), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [276256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12629), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [276269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12631), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [276282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12633), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_template_function,
  [276295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12635), 1,
      anon_sym_COMMA,
    ACTIONS(12638), 1,
      anon_sym_RPAREN,
    STATE(7243), 1,
      aux_sym_generic_expression_repeat1,
  [276308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12640), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(3689), 1,
      sym_template_function,
  [276321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12642), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2435), 1,
      sym_template_function,
  [276334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12644), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_template_function,
  [276347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(12646), 1,
      anon_sym_RPAREN,
    STATE(7319), 1,
      sym_gnu_asm_output_operand_list,
  [276360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12648), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [276369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12650), 1,
      sym_identifier,
    ACTIONS(12652), 1,
      anon_sym_using,
    STATE(7501), 1,
      sym_attribute,
  [276382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    STATE(747), 1,
      sym_declaration_list,
  [276395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12654), 1,
      anon_sym_GT2,
    STATE(7333), 1,
      aux_sym_template_argument_list_repeat1,
  [276408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12656), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [276417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    ACTIONS(12660), 1,
      anon_sym_constexpr,
    STATE(180), 1,
      sym_condition_clause,
  [276430] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(7017), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12662), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [276441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(12664), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      sym_gnu_asm_clobber_list,
  [276454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4511), 1,
      anon_sym_RBRACE,
    ACTIONS(12666), 1,
      anon_sym_COMMA,
    STATE(7289), 1,
      aux_sym_initializer_list_repeat1,
  [276467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12453), 1,
      anon_sym_COMMA,
    ACTIONS(12668), 1,
      anon_sym_RPAREN,
    STATE(7274), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [276480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6108), 1,
      anon_sym_COMMA,
    ACTIONS(12670), 1,
      anon_sym_RBRACK,
    STATE(7440), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [276493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 1,
      anon_sym_EQ,
    ACTIONS(7504), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [276504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12672), 1,
      anon_sym_SEMI,
    STATE(7342), 1,
      aux_sym_declaration_repeat1,
  [276517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12674), 1,
      anon_sym_SEMI,
    STATE(8217), 1,
      sym_attribute_declaration,
  [276530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12676), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [276543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12678), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [276556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12680), 1,
      anon_sym_SEMI,
    STATE(8256), 1,
      sym_attribute_declaration,
  [276569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12587), 1,
      anon_sym_COMMA,
    ACTIONS(12682), 1,
      anon_sym_RBRACK,
    STATE(7446), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [276582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12684), 1,
      anon_sym_SEMI,
    STATE(8307), 1,
      sym_attribute_declaration,
  [276595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    ACTIONS(12686), 1,
      anon_sym_RPAREN,
    STATE(7343), 1,
      aux_sym_parameter_list_repeat1,
  [276608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12688), 1,
      anon_sym_default,
    ACTIONS(12690), 1,
      anon_sym_delete,
    ACTIONS(12692), 1,
      aux_sym_pure_virtual_clause_token1,
  [276621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12694), 1,
      anon_sym_catch,
    STATE(228), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [276632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12696), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_template_function,
  [276645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12698), 1,
      anon_sym_SEMI,
    STATE(8369), 1,
      sym_attribute_declaration,
  [276658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(12700), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7296), 1,
      aux_sym_attribute_declaration_repeat1,
  [276671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    STATE(527), 1,
      sym_declaration_list,
  [276684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      anon_sym_COMMA,
    ACTIONS(12705), 1,
      anon_sym_RPAREN,
    STATE(7274), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [276697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12707), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [276706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12709), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [276715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_COMMA,
    ACTIONS(8857), 1,
      anon_sym_RBRACK,
    STATE(7345), 1,
      aux_sym_subscript_argument_list_repeat1,
  [276728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12615), 1,
      anon_sym_COMMA,
    ACTIONS(12711), 1,
      anon_sym_RPAREN,
    STATE(7234), 1,
      aux_sym_preproc_params_repeat1,
  [276741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9023), 1,
      anon_sym_RPAREN,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    STATE(7279), 1,
      aux_sym_argument_list_repeat1,
  [276754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12716), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_template_function,
  [276767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12587), 1,
      anon_sym_COMMA,
    ACTIONS(12718), 1,
      anon_sym_RBRACK,
    STATE(7446), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [276780] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12720), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12722), 1,
      anon_sym_LPAREN2,
    STATE(7932), 1,
      sym_preproc_argument_list,
  [276793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12724), 1,
      anon_sym_COMMA,
    ACTIONS(12726), 1,
      anon_sym_GT2,
    STATE(7560), 1,
      aux_sym_template_parameter_list_repeat1,
  [276806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12485), 1,
      anon_sym_catch,
    STATE(1845), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [276817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12728), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [276826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(12730), 1,
      anon_sym_RPAREN,
    STATE(7352), 1,
      sym_gnu_asm_clobber_list,
  [276839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(12732), 1,
      anon_sym_RPAREN,
    STATE(7353), 1,
      sym_gnu_asm_input_operand_list,
  [276852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12734), 1,
      anon_sym_SEMI,
    STATE(7312), 1,
      aux_sym_declaration_repeat1,
  [276865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8866), 1,
      anon_sym_RBRACE,
    ACTIONS(12736), 1,
      anon_sym_COMMA,
    STATE(7289), 1,
      aux_sym_initializer_list_repeat1,
  [276878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(12739), 1,
      anon_sym_RPAREN,
    STATE(7404), 1,
      sym_gnu_asm_input_operand_list,
  [276891] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(12741), 1,
      anon_sym_RPAREN,
    STATE(7407), 1,
      sym_gnu_asm_output_operand_list,
  [276904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12743), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_template_function,
  [276917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12745), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [276930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12130), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [276939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12747), 1,
      anon_sym_SEMI,
    STATE(7517), 1,
      aux_sym_declaration_repeat1,
  [276952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(12749), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7395), 1,
      aux_sym_attribute_declaration_repeat1,
  [276965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12751), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [276976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8767), 1,
      anon_sym_RPAREN,
    STATE(7321), 1,
      aux_sym_argument_list_repeat1,
  [276989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8695), 1,
      anon_sym_RBRACE,
    ACTIONS(8807), 1,
      anon_sym_COMMA,
    STATE(7483), 1,
      aux_sym_initializer_list_repeat1,
  [277002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12755), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [277015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8781), 1,
      anon_sym_COMMA,
    ACTIONS(8783), 1,
      anon_sym_RBRACE,
    STATE(7322), 1,
      aux_sym_initializer_list_repeat1,
  [277028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12283), 1,
      anon_sym_LBRACE,
    STATE(7545), 1,
      aux_sym_base_class_clause_repeat1,
  [277041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12757), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [277054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12283), 1,
      anon_sym_LBRACE,
    STATE(7318), 1,
      aux_sym_base_class_clause_repeat1,
  [277067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(12759), 1,
      anon_sym_RPAREN,
    STATE(7279), 1,
      aux_sym_argument_list_repeat1,
  [277080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    STATE(340), 1,
      sym_declaration_list,
  [277093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_RBRACE,
    ACTIONS(12761), 1,
      anon_sym_COMMA,
    STATE(7289), 1,
      aux_sym_initializer_list_repeat1,
  [277106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(12763), 1,
      anon_sym_RPAREN,
    STATE(7327), 1,
      sym_gnu_asm_output_operand_list,
  [277119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12765), 1,
      anon_sym_GT2,
    STATE(7331), 1,
      aux_sym_template_argument_list_repeat1,
  [277132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12767), 1,
      anon_sym_SEMI,
    STATE(7332), 1,
      aux_sym_declaration_repeat1,
  [277145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12769), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [277158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12771), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [277171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6515), 1,
      anon_sym_SEMI,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1701), 1,
      sym_template_argument_list,
  [277184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12773), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12775), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [277195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9813), 1,
      anon_sym_DASH_GT,
    ACTIONS(12777), 1,
      anon_sym_SEMI,
    STATE(8051), 1,
      sym_trailing_return_type,
  [277208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12779), 1,
      anon_sym_catch,
    STATE(438), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [277219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12781), 1,
      anon_sym_EQ,
    ACTIONS(11504), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [277230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12775), 1,
      anon_sym_LBRACE,
    ACTIONS(12783), 1,
      anon_sym_COMMA,
    STATE(7318), 1,
      aux_sym_base_class_clause_repeat1,
  [277243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(12786), 1,
      anon_sym_RPAREN,
    STATE(7354), 1,
      sym_gnu_asm_input_operand_list,
  [277256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(12788), 1,
      anon_sym_RPAREN,
    STATE(7356), 1,
      sym_gnu_asm_output_operand_list,
  [277269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(12790), 1,
      anon_sym_RPAREN,
    STATE(7279), 1,
      aux_sym_argument_list_repeat1,
  [277282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4515), 1,
      anon_sym_RBRACE,
    ACTIONS(12792), 1,
      anon_sym_COMMA,
    STATE(7289), 1,
      aux_sym_initializer_list_repeat1,
  [277295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12794), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [277304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12796), 1,
      anon_sym_SEMI,
    STATE(8072), 1,
      sym_attribute_declaration,
  [277317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12798), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [277330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12800), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [277343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(12802), 1,
      anon_sym_RPAREN,
    STATE(7336), 1,
      sym_gnu_asm_input_operand_list,
  [277356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(12804), 1,
      anon_sym_RPAREN,
    STATE(7337), 1,
      sym_gnu_asm_output_operand_list,
  [277369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12806), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [277382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12808), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [277395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12810), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [277408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12812), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [277421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12814), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [277434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12779), 1,
      anon_sym_catch,
    STATE(439), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [277445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2615), 1,
      anon_sym_while,
    ACTIONS(12816), 1,
      anon_sym_else,
    STATE(380), 1,
      sym_else_clause,
  [277458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(12818), 1,
      anon_sym_RPAREN,
    STATE(7338), 1,
      sym_gnu_asm_clobber_list,
  [277471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(12820), 1,
      anon_sym_RPAREN,
    STATE(7339), 1,
      sym_gnu_asm_input_operand_list,
  [277484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(12822), 1,
      anon_sym_RPAREN,
    STATE(8325), 1,
      sym_gnu_asm_goto_list,
  [277497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(12824), 1,
      anon_sym_RPAREN,
    STATE(7340), 1,
      sym_gnu_asm_clobber_list,
  [277510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(12826), 1,
      anon_sym_RPAREN,
    STATE(8334), 1,
      sym_gnu_asm_goto_list,
  [277523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(12828), 1,
      anon_sym_RPAREN,
    STATE(7243), 1,
      aux_sym_generic_expression_repeat1,
  [277536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12830), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [277549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    ACTIONS(12832), 1,
      anon_sym_RPAREN,
    STATE(7454), 1,
      aux_sym_parameter_list_repeat1,
  [277562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12694), 1,
      anon_sym_catch,
    STATE(230), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [277573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_COMMA,
    ACTIONS(12834), 1,
      anon_sym_RBRACK,
    STATE(7465), 1,
      aux_sym_subscript_argument_list_repeat1,
  [277586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12836), 1,
      anon_sym_SEMI,
    STATE(7383), 1,
      aux_sym_declaration_repeat1,
  [277599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12838), 1,
      sym_identifier,
    ACTIONS(12840), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [277610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_COMMA,
    ACTIONS(12842), 1,
      anon_sym_RPAREN,
    STATE(7487), 1,
      aux_sym_preproc_argument_list_repeat1,
  [277623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12844), 1,
      anon_sym_COMMA,
    ACTIONS(12847), 1,
      anon_sym_RPAREN,
    STATE(7349), 1,
      aux_sym_throw_specifier_repeat1,
  [277636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12849), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [277645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(12851), 1,
      anon_sym_RPAREN,
    STATE(7286), 1,
      sym_gnu_asm_input_operand_list,
  [277658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(12853), 1,
      anon_sym_RPAREN,
    STATE(8077), 1,
      sym_gnu_asm_goto_list,
  [277671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(12855), 1,
      anon_sym_RPAREN,
    STATE(7421), 1,
      sym_gnu_asm_clobber_list,
  [277684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(12857), 1,
      anon_sym_RPAREN,
    STATE(7370), 1,
      sym_gnu_asm_clobber_list,
  [277697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12650), 1,
      sym_identifier,
    ACTIONS(12652), 1,
      anon_sym_using,
    STATE(7136), 1,
      sym_attribute,
  [277710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(12859), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      sym_gnu_asm_input_operand_list,
  [277723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    ACTIONS(12861), 1,
      anon_sym_constexpr,
    STATE(176), 1,
      sym_condition_clause,
  [277736] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(6948), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12863), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [277747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12865), 1,
      anon_sym_COMMA,
    ACTIONS(12867), 1,
      anon_sym_RPAREN,
    STATE(7433), 1,
      aux_sym_requires_parameter_list_repeat1,
  [277760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6622), 1,
      anon_sym___attribute,
    ACTIONS(6624), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [277771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 1,
      anon_sym___attribute,
    ACTIONS(6716), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [277782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(12869), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7385), 1,
      aux_sym_attribute_declaration_repeat1,
  [277795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12871), 1,
      anon_sym_default,
    ACTIONS(12873), 1,
      anon_sym_delete,
    ACTIONS(12875), 1,
      aux_sym_pure_virtual_clause_token1,
  [277808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12877), 1,
      anon_sym_SEMI,
    STATE(7986), 1,
      sym_attribute_declaration,
  [277821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12879), 1,
      anon_sym_SEMI,
    STATE(7939), 1,
      sym_attribute_declaration,
  [277834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(12881), 1,
      anon_sym_RPAREN,
    STATE(7287), 1,
      sym_gnu_asm_output_operand_list,
  [277847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12883), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [277856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12883), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [277865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12885), 1,
      anon_sym_catch,
    STATE(872), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [277876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(12887), 1,
      anon_sym_RPAREN,
    STATE(7964), 1,
      sym_gnu_asm_goto_list,
  [277889] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(6996), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12889), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [277900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(12891), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7395), 1,
      aux_sym_attribute_declaration_repeat1,
  [277913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12895), 1,
      anon_sym_RPAREN,
    ACTIONS(12893), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [277924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(12897), 1,
      anon_sym_RPAREN,
    STATE(7384), 1,
      sym_gnu_asm_clobber_list,
  [277937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12899), 1,
      anon_sym_SEMI,
    STATE(8453), 1,
      sym_attribute_declaration,
  [277950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12901), 1,
      anon_sym_SEMI,
    STATE(7400), 1,
      aux_sym_declaration_repeat1,
  [277963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12903), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [277976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12907), 1,
      anon_sym_RPAREN,
    ACTIONS(12905), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [277987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12909), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_template_function,
  [278000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12911), 1,
      anon_sym_SEMI,
    STATE(7491), 1,
      aux_sym_declaration_repeat1,
  [278013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12913), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [278026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(12915), 1,
      anon_sym_LBRACE,
    STATE(8100), 1,
      sym_requires_clause,
  [278039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12917), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [278052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(12919), 1,
      anon_sym_RPAREN,
    STATE(7975), 1,
      sym_gnu_asm_goto_list,
  [278065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(12921), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7395), 1,
      aux_sym_attribute_declaration_repeat1,
  [278078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8845), 1,
      anon_sym_RPAREN,
    STATE(7413), 1,
      aux_sym_argument_list_repeat1,
  [278091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(12923), 1,
      anon_sym_RPAREN,
    STATE(7243), 1,
      aux_sym_generic_expression_repeat1,
  [278104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8847), 1,
      anon_sym_COMMA,
    ACTIONS(8849), 1,
      anon_sym_RBRACE,
    STATE(7414), 1,
      aux_sym_initializer_list_repeat1,
  [278117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8703), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [278126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12925), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [278139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(12927), 1,
      anon_sym_RPAREN,
    STATE(7415), 1,
      sym_gnu_asm_output_operand_list,
  [278152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12929), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [278163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(12931), 1,
      anon_sym_RPAREN,
    STATE(8218), 1,
      sym_gnu_asm_goto_list,
  [278176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12933), 1,
      anon_sym_GT2,
    STATE(7419), 1,
      aux_sym_template_argument_list_repeat1,
  [278189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12935), 1,
      anon_sym_COMMA,
    ACTIONS(12938), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7395), 1,
      aux_sym_attribute_declaration_repeat1,
  [278202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12940), 1,
      anon_sym_SEMI,
    STATE(7263), 1,
      aux_sym_declaration_repeat1,
  [278215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12942), 1,
      anon_sym_SEMI,
    STATE(7420), 1,
      aux_sym_declaration_repeat1,
  [278228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12944), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [278241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    ACTIONS(12946), 1,
      anon_sym_RPAREN,
    STATE(7534), 1,
      aux_sym_parameter_list_repeat1,
  [278254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12948), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [278267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12650), 1,
      sym_identifier,
    ACTIONS(12652), 1,
      anon_sym_using,
    STATE(7507), 1,
      sym_attribute,
  [278280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    ACTIONS(12950), 1,
      anon_sym_constexpr,
    STATE(188), 1,
      sym_condition_clause,
  [278293] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(7051), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12952), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [278304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(12954), 1,
      anon_sym_RPAREN,
    STATE(7235), 1,
      sym_gnu_asm_clobber_list,
  [278317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12956), 1,
      anon_sym_catch,
    STATE(1677), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [278328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    ACTIONS(12958), 1,
      anon_sym_constexpr,
    STATE(207), 1,
      sym_condition_clause,
  [278341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(12960), 1,
      anon_sym_RPAREN,
    STATE(7255), 1,
      sym_gnu_asm_input_operand_list,
  [278354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12962), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [278365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_default,
    ACTIONS(12966), 1,
      anon_sym_delete,
    ACTIONS(12968), 1,
      aux_sym_pure_virtual_clause_token1,
  [278378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(12970), 1,
      anon_sym_RPAREN,
    STATE(7279), 1,
      aux_sym_argument_list_repeat1,
  [278391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12972), 1,
      anon_sym_COMMA,
    ACTIONS(12975), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [278404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12977), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [278417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(12979), 1,
      anon_sym_RPAREN,
    STATE(7279), 1,
      aux_sym_argument_list_repeat1,
  [278430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4525), 1,
      anon_sym_RBRACE,
    ACTIONS(12981), 1,
      anon_sym_COMMA,
    STATE(7289), 1,
      aux_sym_initializer_list_repeat1,
  [278443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(12983), 1,
      anon_sym_RPAREN,
    STATE(7429), 1,
      sym_gnu_asm_input_operand_list,
  [278456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(12985), 1,
      anon_sym_RPAREN,
    STATE(7430), 1,
      sym_gnu_asm_output_operand_list,
  [278469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12987), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [278482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12989), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [278495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(12991), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [278508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(12993), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [278521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(12995), 1,
      anon_sym_RPAREN,
    STATE(8150), 1,
      sym_gnu_asm_goto_list,
  [278534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12956), 1,
      anon_sym_catch,
    STATE(1686), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [278545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12650), 1,
      sym_identifier,
    ACTIONS(12652), 1,
      anon_sym_using,
    STATE(7272), 1,
      sym_attribute,
  [278558] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(6957), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12997), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [278569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12999), 1,
      anon_sym_default,
    ACTIONS(13001), 1,
      anon_sym_delete,
    ACTIONS(13003), 1,
      aux_sym_pure_virtual_clause_token1,
  [278582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13005), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [278591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(13007), 1,
      anon_sym_LBRACE,
    STATE(8156), 1,
      sym_requires_clause,
  [278604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13009), 1,
      anon_sym_default,
    ACTIONS(13011), 1,
      anon_sym_delete,
    ACTIONS(13013), 1,
      aux_sym_pure_virtual_clause_token1,
  [278617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(13015), 1,
      anon_sym_RPAREN,
    STATE(7431), 1,
      sym_gnu_asm_clobber_list,
  [278630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(13017), 1,
      anon_sym_RPAREN,
    STATE(7432), 1,
      sym_gnu_asm_input_operand_list,
  [278643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(13019), 1,
      anon_sym_RPAREN,
    STATE(8137), 1,
      sym_gnu_asm_goto_list,
  [278656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(13021), 1,
      anon_sym_RPAREN,
    STATE(7435), 1,
      sym_gnu_asm_clobber_list,
  [278669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12865), 1,
      anon_sym_COMMA,
    ACTIONS(13023), 1,
      anon_sym_RPAREN,
    STATE(7451), 1,
      aux_sym_requires_parameter_list_repeat1,
  [278682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13025), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [278691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(13027), 1,
      anon_sym_RPAREN,
    STATE(8141), 1,
      sym_gnu_asm_goto_list,
  [278704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(13029), 1,
      anon_sym_RPAREN,
    STATE(7243), 1,
      aux_sym_generic_expression_repeat1,
  [278717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12435), 1,
      anon_sym_COMMA,
    ACTIONS(13031), 1,
      anon_sym_LBRACE,
    STATE(7143), 1,
      aux_sym_field_initializer_list_repeat1,
  [278730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8759), 1,
      anon_sym_COMMA,
    ACTIONS(13033), 1,
      anon_sym_RPAREN,
    STATE(7243), 1,
      aux_sym_generic_expression_repeat1,
  [278743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6108), 1,
      anon_sym_COMMA,
    ACTIONS(13035), 1,
      anon_sym_RBRACK,
    STATE(7258), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [278756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13037), 1,
      anon_sym_COMMA,
    ACTIONS(13040), 1,
      anon_sym_RBRACK,
    STATE(7440), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [278769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(11583), 1,
      anon_sym_LBRACE,
    STATE(8109), 1,
      sym_requires_clause,
  [278782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12650), 1,
      sym_identifier,
    ACTIONS(12652), 1,
      anon_sym_using,
    STATE(7362), 1,
      sym_attribute,
  [278795] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(7134), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13042), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [278806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13044), 1,
      anon_sym_COMMA,
    ACTIONS(13047), 1,
      anon_sym_GT2,
    STATE(7444), 1,
      aux_sym_template_parameter_list_repeat1,
  [278819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12587), 1,
      anon_sym_COMMA,
    ACTIONS(13049), 1,
      anon_sym_RBRACK,
    STATE(7281), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [278832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13051), 1,
      anon_sym_COMMA,
    ACTIONS(13054), 1,
      anon_sym_RBRACK,
    STATE(7446), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [278845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13056), 1,
      anon_sym_default,
    ACTIONS(13058), 1,
      anon_sym_delete,
    ACTIONS(13060), 1,
      aux_sym_pure_virtual_clause_token1,
  [278858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12487), 1,
      anon_sym_catch,
    STATE(370), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [278869] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12722), 1,
      anon_sym_LPAREN2,
    ACTIONS(13062), 1,
      aux_sym_preproc_include_token2,
    STATE(7932), 1,
      sym_preproc_argument_list,
  [278882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    STATE(495), 1,
      sym_declaration_list,
  [278895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13064), 1,
      anon_sym_COMMA,
    ACTIONS(13067), 1,
      anon_sym_RPAREN,
    STATE(7451), 1,
      aux_sym_requires_parameter_list_repeat1,
  [278908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12650), 1,
      sym_identifier,
    ACTIONS(12652), 1,
      anon_sym_using,
    STATE(7456), 1,
      sym_attribute,
  [278921] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(6983), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13069), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [278932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13071), 1,
      anon_sym_COMMA,
    ACTIONS(13074), 1,
      anon_sym_RPAREN,
    STATE(7454), 1,
      aux_sym_parameter_list_repeat1,
  [278945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13076), 1,
      anon_sym_default,
    ACTIONS(13078), 1,
      anon_sym_delete,
    ACTIONS(13080), 1,
      aux_sym_pure_virtual_clause_token1,
  [278958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(13082), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7480), 1,
      aux_sym_attribute_declaration_repeat1,
  [278971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12650), 1,
      sym_identifier,
    ACTIONS(12652), 1,
      anon_sym_using,
    STATE(7479), 1,
      sym_attribute,
  [278984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12487), 1,
      anon_sym_catch,
    STATE(233), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [278995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13084), 1,
      anon_sym_COMMA,
    ACTIONS(13087), 1,
      anon_sym_LBRACE,
    STATE(7459), 1,
      aux_sym_field_initializer_list_repeat1,
  [279008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12650), 1,
      sym_identifier,
    ACTIONS(12652), 1,
      anon_sym_using,
    STATE(7526), 1,
      sym_attribute,
  [279021] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(6972), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13089), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [279032] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(6988), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13091), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [279043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12956), 1,
      anon_sym_catch,
    STATE(1690), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [279054] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(6963), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13093), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [279065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9025), 1,
      anon_sym_RBRACK,
    ACTIONS(13095), 1,
      anon_sym_COMMA,
    STATE(7465), 1,
      aux_sym_subscript_argument_list_repeat1,
  [279078] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(6944), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13098), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [279089] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    STATE(7087), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13100), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [279100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 1,
      anon_sym___attribute,
    ACTIONS(6650), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [279111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13102), 1,
      anon_sym_SEMI,
    STATE(7490), 1,
      aux_sym_declaration_repeat1,
  [279124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_COMMA,
    ACTIONS(13104), 1,
      anon_sym_RPAREN,
    STATE(7349), 1,
      aux_sym_throw_specifier_repeat1,
  [279137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(11516), 1,
      anon_sym_LBRACE,
    STATE(8545), 1,
      sym_requires_clause,
  [279150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13106), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_template_function,
  [279163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    ACTIONS(13108), 1,
      anon_sym_constexpr,
    STATE(186), 1,
      sym_condition_clause,
  [279176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10586), 1,
      anon_sym_requires,
    ACTIONS(11518), 1,
      anon_sym_LBRACE,
    STATE(8075), 1,
      sym_requires_clause,
  [279189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6652), 1,
      anon_sym___attribute,
    ACTIONS(6654), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [279200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    ACTIONS(13110), 1,
      anon_sym_constexpr,
    STATE(215), 1,
      sym_condition_clause,
  [279213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13112), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [279222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13114), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [279231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(13116), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7372), 1,
      aux_sym_attribute_declaration_repeat1,
  [279244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(13118), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7395), 1,
      aux_sym_attribute_declaration_repeat1,
  [279257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_COMMA,
    ACTIONS(8835), 1,
      anon_sym_RBRACK,
    STATE(7170), 1,
      aux_sym_subscript_argument_list_repeat1,
  [279270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8777), 1,
      anon_sym_RPAREN,
    STATE(7499), 1,
      aux_sym_argument_list_repeat1,
  [279283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4346), 1,
      anon_sym_RBRACE,
    ACTIONS(13120), 1,
      anon_sym_COMMA,
    STATE(7289), 1,
      aux_sym_initializer_list_repeat1,
  [279296] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12722), 1,
      anon_sym_LPAREN2,
    ACTIONS(13122), 1,
      aux_sym_preproc_include_token2,
    STATE(7932), 1,
      sym_preproc_argument_list,
  [279309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(13124), 1,
      anon_sym_RPAREN,
    STATE(7500), 1,
      sym_gnu_asm_output_operand_list,
  [279322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(13126), 1,
      anon_sym_GT2,
    STATE(7505), 1,
      aux_sym_template_argument_list_repeat1,
  [279335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10381), 1,
      anon_sym_RPAREN,
    ACTIONS(13128), 1,
      anon_sym_COMMA,
    STATE(7487), 1,
      aux_sym_preproc_argument_list_repeat1,
  [279348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13131), 1,
      anon_sym_SEMI,
    STATE(7506), 1,
      aux_sym_declaration_repeat1,
  [279361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13133), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [279374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13135), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [279387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13137), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [279400] = 4,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12722), 1,
      anon_sym_LPAREN2,
    ACTIONS(13139), 1,
      aux_sym_preproc_include_token2,
    STATE(7932), 1,
      sym_preproc_argument_list,
  [279413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13141), 1,
      anon_sym_catch,
    STATE(1836), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [279424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13143), 1,
      anon_sym_COMMA,
    ACTIONS(13146), 1,
      anon_sym_RPAREN,
    STATE(7494), 1,
      aux_sym_preproc_params_repeat1,
  [279437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6656), 1,
      anon_sym___attribute,
    ACTIONS(6658), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [279448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym___attribute,
    ACTIONS(6662), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [279459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13148), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13150), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [279470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    ACTIONS(13152), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_parameter_list_repeat1,
  [279483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(13154), 1,
      anon_sym_RPAREN,
    STATE(7279), 1,
      aux_sym_argument_list_repeat1,
  [279496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(13156), 1,
      anon_sym_RPAREN,
    STATE(7511), 1,
      sym_gnu_asm_input_operand_list,
  [279509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(13158), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7547), 1,
      aux_sym_attribute_declaration_repeat1,
  [279522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(13160), 1,
      anon_sym_RPAREN,
    STATE(7512), 1,
      sym_gnu_asm_output_operand_list,
  [279535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(13162), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [279548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(13164), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [279561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(13166), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [279574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13168), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [279587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(13170), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7138), 1,
      aux_sym_attribute_declaration_repeat1,
  [279600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13141), 1,
      anon_sym_catch,
    STATE(1838), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [279611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(13172), 1,
      anon_sym_LBRACE,
    STATE(7318), 1,
      aux_sym_base_class_clause_repeat1,
  [279624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6668), 1,
      anon_sym___attribute,
    ACTIONS(6670), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [279635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(13174), 1,
      anon_sym_RPAREN,
    STATE(7513), 1,
      sym_gnu_asm_clobber_list,
  [279648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_COLON,
    ACTIONS(13176), 1,
      anon_sym_RPAREN,
    STATE(7515), 1,
      sym_gnu_asm_input_operand_list,
  [279661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(13178), 1,
      anon_sym_RPAREN,
    STATE(8496), 1,
      sym_gnu_asm_goto_list,
  [279674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10582), 1,
      anon_sym_LBRACE,
    ACTIONS(10586), 1,
      anon_sym_requires,
    STATE(8327), 1,
      sym_requires_clause,
  [279687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_COLON,
    ACTIONS(13180), 1,
      anon_sym_RPAREN,
    STATE(7516), 1,
      sym_gnu_asm_clobber_list,
  [279700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_COLON,
    ACTIONS(13182), 1,
      anon_sym_RPAREN,
    STATE(8498), 1,
      sym_gnu_asm_goto_list,
  [279713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13184), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [279726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12509), 1,
      anon_sym_catch,
    STATE(409), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [279737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6672), 1,
      anon_sym___attribute,
    ACTIONS(6674), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [279748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 1,
      anon_sym___attribute,
    ACTIONS(6682), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [279759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13186), 1,
      anon_sym_COMMA,
    ACTIONS(13189), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [279772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13191), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [279785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    ACTIONS(13193), 1,
      anon_sym_RPAREN,
    STATE(7454), 1,
      aux_sym_parameter_list_repeat1,
  [279798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13195), 1,
      anon_sym_SEMI,
    STATE(7525), 1,
      aux_sym_declaration_repeat1,
  [279811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13197), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [279824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(13199), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7535), 1,
      aux_sym_attribute_declaration_repeat1,
  [279837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12779), 1,
      anon_sym_catch,
    STATE(359), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [279848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12694), 1,
      anon_sym_catch,
    STATE(225), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [279859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12509), 1,
      anon_sym_catch,
    STATE(447), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [279870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13141), 1,
      anon_sym_catch,
    STATE(1846), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [279881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13201), 1,
      anon_sym_SEMI,
    STATE(7543), 1,
      aux_sym_declaration_repeat1,
  [279894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13203), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(6068), 1,
      sym_template_function,
  [279907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_COMMA,
    ACTIONS(13205), 1,
      anon_sym_RBRACK,
    STATE(7465), 1,
      aux_sym_subscript_argument_list_repeat1,
  [279920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 1,
      anon_sym_COMMA,
    ACTIONS(13207), 1,
      anon_sym_RPAREN,
    STATE(7454), 1,
      aux_sym_parameter_list_repeat1,
  [279933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(13209), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7395), 1,
      aux_sym_attribute_declaration_repeat1,
  [279946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13211), 1,
      anon_sym_SEMI,
    STATE(7164), 1,
      aux_sym_declaration_repeat1,
  [279959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13213), 1,
      sym_identifier,
    STATE(1790), 1,
      sym_template_type,
    STATE(3254), 1,
      sym_template_function,
  [279972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12114), 1,
      anon_sym_LBRACE,
    STATE(7304), 1,
      aux_sym_base_class_clause_repeat1,
  [279985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12114), 1,
      anon_sym_LBRACE,
    STATE(7318), 1,
      aux_sym_base_class_clause_repeat1,
  [279998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(13215), 1,
      anon_sym_GT2,
    STATE(7554), 1,
      aux_sym_template_argument_list_repeat1,
  [280011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13217), 1,
      anon_sym_SEMI,
    STATE(7555), 1,
      aux_sym_declaration_repeat1,
  [280024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13219), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [280037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13221), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [280050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13223), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_template_function,
  [280063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12393), 1,
      anon_sym_LBRACE,
    STATE(7318), 1,
      aux_sym_base_class_clause_repeat1,
  [280076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_COMMA,
    ACTIONS(12393), 1,
      anon_sym_LBRACE,
    STATE(7150), 1,
      aux_sym_base_class_clause_repeat1,
  [280089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    ACTIONS(13225), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7395), 1,
      aux_sym_attribute_declaration_repeat1,
  [280102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13229), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [280113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_COMMA,
    ACTIONS(8753), 1,
      anon_sym_RPAREN,
    STATE(7223), 1,
      aux_sym_argument_list_repeat1,
  [280126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACE,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    STATE(684), 1,
      sym_declaration_list,
  [280139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8793), 1,
      anon_sym_COMMA,
    ACTIONS(8795), 1,
      anon_sym_RBRACE,
    STATE(7256), 1,
      aux_sym_initializer_list_repeat1,
  [280152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(13231), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [280165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(13233), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [280178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(13235), 1,
      anon_sym_GT2,
    STATE(7411), 1,
      aux_sym_template_argument_list_repeat1,
  [280191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(13237), 1,
      anon_sym_SEMI,
    STATE(7521), 1,
      aux_sym_declaration_repeat1,
  [280204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_while,
    ACTIONS(12816), 1,
      anon_sym_else,
    STATE(344), 1,
      sym_else_clause,
  [280217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(13239), 1,
      anon_sym_RPAREN,
    STATE(7351), 1,
      sym_gnu_asm_output_operand_list,
  [280230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    ACTIONS(13241), 1,
      anon_sym_GT2,
    STATE(7412), 1,
      aux_sym_template_argument_list_repeat1,
  [280243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12650), 1,
      sym_identifier,
    ACTIONS(12652), 1,
      anon_sym_using,
    STATE(7690), 1,
      sym_attribute,
  [280256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12724), 1,
      anon_sym_COMMA,
    ACTIONS(13243), 1,
      anon_sym_GT2,
    STATE(7444), 1,
      aux_sym_template_parameter_list_repeat1,
  [280269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      sym_identifier,
    STATE(1790), 1,
      sym_template_type,
  [280279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13247), 2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [280287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(1608), 1,
      sym_compound_statement,
  [280297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [280305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    ACTIONS(13253), 1,
      anon_sym_RBRACE,
  [280315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(8322), 1,
      sym_parenthesized_expression,
  [280325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2638), 1,
      sym_field_declaration_list,
  [280335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(7792), 1,
      sym_parameter_list,
  [280345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9023), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [280353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    STATE(629), 1,
      sym_declaration_list,
  [280363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LBRACE,
    STATE(902), 1,
      sym_compound_statement,
  [280373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7529), 1,
      sym_compound_statement,
  [280383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    STATE(3971), 1,
      sym_field_declaration_list,
  [280393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(3277), 1,
      sym_compound_statement,
  [280403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    STATE(530), 1,
      sym_compound_statement,
  [280413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13257), 1,
      anon_sym_LT,
    STATE(2670), 1,
      sym_template_argument_list,
  [280423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(1621), 1,
      sym_compound_statement,
  [280433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      anon_sym_LBRACE,
    STATE(2408), 1,
      sym_compound_statement,
  [280443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(7768), 1,
      sym_parenthesized_expression,
  [280453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8907), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [280461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    STATE(333), 1,
      sym_compound_statement,
  [280471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(7682), 1,
      sym_parameter_list,
  [280481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9756), 1,
      anon_sym_LBRACE,
    STATE(3873), 1,
      sym_requirement_seq,
  [280491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8866), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [280499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    STATE(707), 1,
      sym_compound_statement,
  [280509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9049), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [280517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9835), 1,
      anon_sym_LBRACE,
    STATE(3804), 1,
      sym_compound_statement,
  [280527] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13259), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13261), 1,
      sym_preproc_arg,
  [280537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13263), 1,
      anon_sym_LT,
    STATE(2591), 1,
      sym_template_argument_list,
  [280547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [280555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13267), 1,
      sym_identifier,
    ACTIONS(13269), 1,
      anon_sym_LPAREN2,
  [280565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13271), 1,
      sym_identifier,
    STATE(3623), 1,
      sym_template_type,
  [280575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13273), 1,
      anon_sym_LT,
    STATE(2324), 1,
      sym_template_argument_list,
  [280585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    STATE(733), 1,
      sym_compound_statement,
  [280595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11051), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [280605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12751), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [280613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(2343), 1,
      sym_field_declaration_list,
  [280623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    STATE(250), 1,
      sym_compound_statement,
  [280633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11096), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [280643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    STATE(686), 1,
      sym_declaration_list,
  [280653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9817), 1,
      anon_sym_LBRACE,
    STATE(5919), 1,
      sym_compound_statement,
  [280663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(428), 1,
      sym_compound_statement,
  [280673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(2670), 1,
      sym_template_argument_list,
  [280683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LBRACE,
    STATE(341), 1,
      sym_declaration_list,
  [280693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2578), 1,
      sym_field_declaration_list,
  [280703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2579), 1,
      sym_field_declaration_list,
  [280713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    ACTIONS(13275), 1,
      anon_sym_RBRACE,
  [280723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    STATE(3806), 1,
      sym_initializer_list,
  [280733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    ACTIONS(13277), 1,
      anon_sym_RBRACE,
  [280743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9817), 1,
      anon_sym_LBRACE,
    STATE(5913), 1,
      sym_compound_statement,
  [280753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(8461), 1,
      sym_argument_list,
  [280763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    STATE(2835), 1,
      sym_field_declaration_list,
  [280773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9835), 1,
      anon_sym_LBRACE,
    STATE(3915), 1,
      sym_compound_statement,
  [280783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    STATE(724), 1,
      sym_compound_statement,
  [280793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11104), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [280803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11086), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [280813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9817), 1,
      anon_sym_LBRACE,
    STATE(5899), 1,
      sym_compound_statement,
  [280823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    STATE(600), 1,
      sym_compound_statement,
  [280833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    STATE(2175), 1,
      sym_field_declaration_list,
  [280843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    ACTIONS(13279), 1,
      anon_sym_RBRACE,
  [280853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2581), 1,
      sym_field_declaration_list,
  [280863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    STATE(494), 1,
      sym_declaration_list,
  [280873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10948), 1,
      anon_sym_LBRACE,
    STATE(1937), 1,
      sym_compound_statement,
  [280883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    STATE(4886), 1,
      sym_field_declaration_list,
  [280893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    STATE(4888), 1,
      sym_field_declaration_list,
  [280903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9835), 1,
      anon_sym_LBRACE,
    STATE(3875), 1,
      sym_compound_statement,
  [280913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    STATE(238), 1,
      sym_compound_statement,
  [280923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13281), 1,
      anon_sym_SEMI,
  [280933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13283), 1,
      sym_identifier,
    STATE(1790), 1,
      sym_template_type,
  [280943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
  [280953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_compound_statement,
  [280963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13285), 1,
      anon_sym_LT,
    STATE(2403), 1,
      sym_template_argument_list,
  [280973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9730), 1,
      anon_sym_LBRACE,
    STATE(3217), 1,
      sym_requirement_seq,
  [280983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    STATE(2206), 1,
      sym_field_declaration_list,
  [280993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_compound_statement,
  [281003] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13287), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13289), 1,
      sym_preproc_arg,
  [281013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13291), 1,
      sym_identifier,
    STATE(2662), 1,
      sym_template_type,
  [281023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13293), 1,
      anon_sym_LT,
    STATE(2687), 1,
      sym_template_argument_list,
  [281033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13295), 1,
      anon_sym_SEMI,
  [281043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12847), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [281051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    STATE(2186), 1,
      sym_field_declaration_list,
  [281061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2324), 1,
      sym_template_argument_list,
  [281071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      anon_sym_LBRACE,
    STATE(2479), 1,
      sym_compound_statement,
  [281081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(8476), 1,
      sym_argument_list,
  [281091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(2895), 1,
      sym_field_declaration_list,
  [281101] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13297), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13299), 1,
      sym_preproc_arg,
  [281111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(429), 1,
      sym_compound_statement,
  [281121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13301), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [281129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_LBRACE,
    STATE(3541), 1,
      sym_initializer_list,
  [281139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12471), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [281147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13303), 1,
      sym_identifier,
    STATE(2250), 1,
      sym_template_type,
  [281157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(3259), 1,
      sym_compound_statement,
  [281167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(7857), 1,
      sym_condition_clause,
  [281177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(177), 1,
      sym_condition_clause,
  [281187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9821), 1,
      anon_sym_LBRACE,
    STATE(3300), 1,
      sym_compound_statement,
  [281197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7528), 1,
      sym_compound_statement,
  [281207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13305), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
  [281217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13293), 1,
      anon_sym_LT,
    STATE(3399), 1,
      sym_template_argument_list,
  [281227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(8797), 1,
      sym_argument_list,
  [281237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7123), 1,
      sym_compound_statement,
  [281247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(181), 1,
      sym_condition_clause,
  [281257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12082), 1,
      sym_identifier,
    STATE(7562), 1,
      sym_module_name,
  [281267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8564), 1,
      anon_sym_LT,
    STATE(4378), 1,
      sym_template_argument_list,
  [281277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9825), 1,
      anon_sym_LBRACE,
    STATE(4244), 1,
      sym_compound_statement,
  [281287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    STATE(3097), 1,
      sym_field_declaration_list,
  [281297] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13307), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13309), 1,
      sym_preproc_arg,
  [281307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      anon_sym_LBRACE,
    STATE(2433), 1,
      sym_compound_statement,
  [281317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13311), 1,
      sym_identifier,
    ACTIONS(13313), 1,
      anon_sym_RPAREN,
  [281327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(8108), 1,
      sym_parenthesized_expression,
  [281337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(7627), 1,
      sym_parameter_list,
  [281347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    ACTIONS(13315), 1,
      anon_sym_RBRACE,
  [281357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9740), 1,
      anon_sym_LBRACE,
    STATE(3649), 1,
      sym_requirement_seq,
  [281367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7344), 1,
      sym_compound_statement,
  [281377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10966), 1,
      anon_sym_LBRACE,
    STATE(1823), 1,
      sym_compound_statement,
  [281387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LBRACE,
    STATE(320), 1,
      sym_declaration_list,
  [281397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9819), 1,
      anon_sym_LBRACE,
    STATE(3687), 1,
      sym_compound_statement,
  [281407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(7647), 1,
      sym_parenthesized_expression,
  [281417] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13317), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13319), 1,
      sym_preproc_arg,
  [281427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13273), 1,
      anon_sym_LT,
    STATE(1941), 1,
      sym_template_argument_list,
  [281437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12893), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [281445] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13321), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13323), 1,
      sym_preproc_arg,
  [281455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(282), 1,
      sym_compound_statement,
  [281465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12082), 1,
      sym_identifier,
    STATE(6896), 1,
      sym_module_name,
  [281475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    STATE(4858), 1,
      sym_field_declaration_list,
  [281485] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13325), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13327), 1,
      sym_preproc_arg,
  [281495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    STATE(308), 1,
      sym_compound_statement,
  [281505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13329), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
  [281515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11114), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [281525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13331), 1,
      anon_sym_SEMI,
  [281535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [281543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(8517), 1,
      sym_parenthesized_expression,
  [281553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    STATE(2984), 1,
      sym_field_declaration_list,
  [281563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    STATE(2972), 1,
      sym_field_declaration_list,
  [281573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(3300), 1,
      sym_compound_statement,
  [281583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    STATE(249), 1,
      sym_compound_statement,
  [281593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11110), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [281603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
  [281613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12929), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [281621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12589), 1,
      anon_sym_RBRACK,
    ACTIONS(13333), 1,
      anon_sym_COMMA,
  [281631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13273), 1,
      anon_sym_LT,
    STATE(2403), 1,
      sym_template_argument_list,
  [281641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(7859), 1,
      sym_condition_clause,
  [281651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(189), 1,
      sym_condition_clause,
  [281661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7527), 1,
      sym_compound_statement,
  [281671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13335), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
  [281681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(8085), 1,
      sym_argument_list,
  [281691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(6932), 1,
      sym_compound_statement,
  [281701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(194), 1,
      sym_condition_clause,
  [281711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(208), 1,
      sym_condition_clause,
  [281721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9819), 1,
      anon_sym_LBRACE,
    STATE(3660), 1,
      sym_compound_statement,
  [281731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10966), 1,
      anon_sym_LBRACE,
    STATE(1805), 1,
      sym_compound_statement,
  [281741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13337), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [281749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(200), 1,
      sym_condition_clause,
  [281759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(7575), 1,
      sym_parenthesized_expression,
  [281769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(8166), 1,
      sym_parenthesized_expression,
  [281779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(7635), 1,
      sym_parameter_list,
  [281789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    STATE(491), 1,
      sym_compound_statement,
  [281799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7200), 1,
      sym_compound_statement,
  [281809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LBRACE,
    STATE(897), 1,
      sym_compound_statement,
  [281819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    ACTIONS(13339), 1,
      anon_sym_RBRACE,
  [281829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(7695), 1,
      sym_parenthesized_expression,
  [281839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    STATE(3017), 1,
      sym_field_declaration_list,
  [281849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13341), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [281857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LBRACE,
    STATE(882), 1,
      sym_compound_statement,
  [281867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13343), 1,
      anon_sym_LPAREN2,
    ACTIONS(13345), 1,
      sym_raw_string_delimiter,
  [281877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9819), 1,
      anon_sym_LBRACE,
    STATE(3624), 1,
      sym_compound_statement,
  [281887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(7571), 1,
      sym_condition_clause,
  [281897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    STATE(671), 1,
      sym_declaration_list,
  [281907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7284), 1,
      sym_compound_statement,
  [281917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8878), 1,
      anon_sym_LBRACE,
    STATE(4844), 1,
      sym_field_declaration_list,
  [281927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13347), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [281935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13349), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [281943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(8740), 1,
      sym_argument_list,
  [281953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7026), 1,
      sym_compound_statement,
  [281963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LBRACE,
    STATE(923), 1,
      sym_compound_statement,
  [281973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13040), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [281981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13263), 1,
      anon_sym_LT,
    STATE(3321), 1,
      sym_template_argument_list,
  [281991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(8171), 1,
      sym_parenthesized_expression,
  [282001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(7623), 1,
      sym_parameter_list,
  [282011] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13351), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13353), 1,
      sym_preproc_arg,
  [282021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7334), 1,
      sym_compound_statement,
  [282031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(7631), 1,
      sym_parenthesized_expression,
  [282041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13355), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [282049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1954), 1,
      anon_sym_LBRACE,
    STATE(2500), 1,
      sym_initializer_list,
  [282059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13047), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [282067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13293), 1,
      anon_sym_LT,
    STATE(3557), 1,
      sym_template_argument_list,
  [282077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(2967), 1,
      sym_field_declaration_list,
  [282087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7369), 1,
      sym_compound_statement,
  [282097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2403), 1,
      sym_template_argument_list,
  [282107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(7963), 1,
      sym_argument_list,
  [282117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13054), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [282125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7963), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [282133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13357), 1,
      sym_identifier,
    STATE(4398), 1,
      sym_template_type,
  [282143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7168), 1,
      sym_compound_statement,
  [282153] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13359), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13361), 1,
      sym_preproc_arg,
  [282163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(498), 1,
      sym_compound_statement,
  [282173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(7723), 1,
      sym_parameter_list,
  [282183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7422), 1,
      sym_compound_statement,
  [282193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13067), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [282201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LPAREN2,
    STATE(7734), 1,
      sym_parenthesized_expression,
  [282211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13363), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [282219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13365), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [282227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13367), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
  [282237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7463), 1,
      sym_compound_statement,
  [282247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13369), 1,
      sym_identifier,
    STATE(2787), 1,
      sym_template_type,
  [282257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(8347), 1,
      sym_argument_list,
  [282267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13074), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [282275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7458), 1,
      sym_compound_statement,
  [282285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(530), 1,
      sym_compound_statement,
  [282295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    STATE(2816), 1,
      sym_field_declaration_list,
  [282305] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13371), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13373), 1,
      sym_preproc_arg,
  [282315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(7835), 1,
      sym_parameter_list,
  [282325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    STATE(2820), 1,
      sym_field_declaration_list,
  [282335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7508), 1,
      sym_compound_statement,
  [282345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(491), 1,
      sym_compound_statement,
  [282355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13375), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [282363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13087), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [282371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    STATE(4541), 1,
      sym_field_declaration_list,
  [282381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [282389] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13377), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13379), 1,
      sym_preproc_arg,
  [282399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7530), 1,
      sym_compound_statement,
  [282409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(8651), 1,
      sym_argument_list,
  [282419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13381), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [282427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(406), 1,
      sym_compound_statement,
  [282437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(7901), 1,
      sym_parameter_list,
  [282447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [282455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(8006), 1,
      sym_argument_list,
  [282465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(8452), 1,
      sym_argument_list,
  [282475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12074), 1,
      anon_sym_LBRACE,
    STATE(1616), 1,
      sym_requirement_seq,
  [282485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12062), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
  [282495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(2929), 1,
      sym_field_declaration_list,
  [282505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10958), 1,
      anon_sym_LBRACE,
    STATE(2156), 1,
      sym_compound_statement,
  [282515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    STATE(473), 1,
      sym_compound_statement,
  [282525] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13383), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13385), 1,
      sym_preproc_arg,
  [282535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(2931), 1,
      sym_field_declaration_list,
  [282545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9829), 1,
      anon_sym_LBRACE,
    STATE(1622), 1,
      sym_compound_statement,
  [282555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    STATE(3955), 1,
      sym_field_declaration_list,
  [282565] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13387), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13389), 1,
      sym_preproc_arg,
  [282575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7035), 1,
      sym_compound_statement,
  [282585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7386), 1,
      anon_sym_LT,
    STATE(2731), 1,
      sym_template_argument_list,
  [282595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [282603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13391), 1,
      anon_sym_SEMI,
  [282613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(220), 1,
      sym_condition_clause,
  [282623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9825), 1,
      anon_sym_LBRACE,
    STATE(4228), 1,
      sym_compound_statement,
  [282633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_LBRACE,
    STATE(4839), 1,
      sym_initializer_list,
  [282643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(1622), 1,
      sym_compound_statement,
  [282653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(7847), 1,
      sym_condition_clause,
  [282663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
  [282673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(174), 1,
      sym_condition_clause,
  [282683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11098), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [282693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10659), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [282701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    STATE(4539), 1,
      sym_field_declaration_list,
  [282711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    STATE(4546), 1,
      sym_field_declaration_list,
  [282721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12120), 1,
      anon_sym_LBRACE,
    STATE(5939), 1,
      sym_requirement_seq,
  [282731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_LBRACE,
    STATE(3426), 1,
      sym_initializer_list,
  [282741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13393), 1,
      sym_identifier,
    STATE(1936), 1,
      sym_template_type,
  [282751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8747), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [282759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7518), 1,
      sym_compound_statement,
  [282769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(205), 1,
      sym_condition_clause,
  [282779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13146), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [282787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6816), 1,
      anon_sym_LT,
    STATE(2747), 1,
      sym_template_argument_list,
  [282797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13395), 1,
      sym_identifier,
    ACTIONS(13397), 1,
      anon_sym_LPAREN2,
  [282807] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13399), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13401), 1,
      sym_preproc_arg,
  [282817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13403), 1,
      sym_identifier,
    STATE(1790), 1,
      sym_template_type,
  [282827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9829), 1,
      anon_sym_LBRACE,
    STATE(1608), 1,
      sym_compound_statement,
  [282837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10958), 1,
      anon_sym_LBRACE,
    STATE(2049), 1,
      sym_compound_statement,
  [282847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13405), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [282855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACE,
    STATE(748), 1,
      sym_declaration_list,
  [282865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13150), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [282873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13407), 1,
      sym_identifier,
    STATE(1910), 1,
      sym_template_type,
  [282883] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13409), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13411), 1,
      sym_preproc_arg,
  [282893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    ACTIONS(13413), 1,
      anon_sym_RBRACE,
  [282903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(479), 1,
      sym_compound_statement,
  [282913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8615), 1,
      anon_sym_LBRACE,
    STATE(4459), 1,
      sym_field_declaration_list,
  [282923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(7783), 1,
      sym_condition_clause,
  [282933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10966), 1,
      anon_sym_LBRACE,
    STATE(1706), 1,
      sym_compound_statement,
  [282943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10948), 1,
      anon_sym_LBRACE,
    STATE(2166), 1,
      sym_compound_statement,
  [282953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(2351), 1,
      sym_field_declaration_list,
  [282963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(178), 1,
      sym_condition_clause,
  [282973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9829), 1,
      anon_sym_LBRACE,
    STATE(1621), 1,
      sym_compound_statement,
  [282983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LPAREN2,
    STATE(8698), 1,
      sym_argument_list,
  [282993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9837), 1,
      anon_sym_LBRACE,
    STATE(3501), 1,
      sym_compound_statement,
  [283003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    ACTIONS(13415), 1,
      anon_sym_RBRACE,
  [283013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(5045), 1,
      sym_field_declaration_list,
  [283023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(5051), 1,
      sym_field_declaration_list,
  [283033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(5052), 1,
      sym_field_declaration_list,
  [283043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(5054), 1,
      sym_field_declaration_list,
  [283053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    STATE(564), 1,
      sym_compound_statement,
  [283063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7109), 1,
      sym_compound_statement,
  [283073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13417), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [283081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6499), 1,
      anon_sym_LBRACE,
    STATE(2815), 1,
      sym_field_declaration_list,
  [283091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9837), 1,
      anon_sym_LBRACE,
    STATE(3357), 1,
      sym_compound_statement,
  [283101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    ACTIONS(13419), 1,
      anon_sym_RBRACE,
  [283111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11108), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [283121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9821), 1,
      anon_sym_LBRACE,
    STATE(3259), 1,
      sym_compound_statement,
  [283131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(211), 1,
      sym_condition_clause,
  [283141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    STATE(2193), 1,
      sym_field_declaration_list,
  [283151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 1,
      anon_sym_LBRACE,
    STATE(265), 1,
      sym_compound_statement,
  [283161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACE,
    STATE(770), 1,
      sym_declaration_list,
  [283171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LBRACE,
    STATE(560), 1,
      sym_compound_statement,
  [283181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_LPAREN2,
    STATE(199), 1,
      sym_condition_clause,
  [283191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13421), 1,
      sym_identifier,
    STATE(2730), 1,
      sym_template_type,
  [283201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9764), 1,
      anon_sym_LBRACE,
    STATE(3431), 1,
      sym_requirement_seq,
  [283211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8896), 1,
      anon_sym_RPAREN,
    ACTIONS(8898), 1,
      anon_sym_SEMI,
  [283221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    STATE(3960), 1,
      sym_field_declaration_list,
  [283231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7520), 1,
      anon_sym_LBRACE,
    STATE(3961), 1,
      sym_field_declaration_list,
  [283241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    STATE(652), 1,
      sym_compound_statement,
  [283251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    STATE(2862), 1,
      sym_field_declaration_list,
  [283261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LBRACE,
    STATE(3912), 1,
      sym_initializer_list,
  [283271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    STATE(659), 1,
      sym_declaration_list,
  [283281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12175), 1,
      anon_sym_LBRACE,
    STATE(5622), 1,
      sym_requirement_seq,
  [283291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7085), 1,
      sym_compound_statement,
  [283301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9823), 1,
      anon_sym_LBRACE,
    STATE(5626), 1,
      sym_compound_statement,
  [283311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8973), 1,
      anon_sym_LT,
    STATE(2547), 1,
      sym_template_argument_list,
  [283321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9748), 1,
      anon_sym_LBRACE,
    STATE(4233), 1,
      sym_requirement_seq,
  [283331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13423), 1,
      anon_sym_LPAREN2,
    ACTIONS(13425), 1,
      sym_raw_string_delimiter,
  [283341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13427), 1,
      sym_identifier,
    STATE(2557), 1,
      sym_template_type,
  [283351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6630), 1,
      anon_sym_LT,
    STATE(2731), 1,
      sym_template_argument_list,
  [283361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(3615), 1,
      sym_field_declaration_list,
  [283371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9837), 1,
      anon_sym_LBRACE,
    STATE(3443), 1,
      sym_compound_statement,
  [283381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LBRACE,
    STATE(305), 1,
      sym_declaration_list,
  [283391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(3619), 1,
      sym_field_declaration_list,
  [283401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(3620), 1,
      sym_field_declaration_list,
  [283411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 1,
      anon_sym_LBRACE,
    STATE(3622), 1,
      sym_field_declaration_list,
  [283421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11063), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [283431] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13429), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13431), 1,
      sym_preproc_arg,
  [283441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10948), 1,
      anon_sym_LBRACE,
    STATE(2080), 1,
      sym_compound_statement,
  [283451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(1603), 1,
      sym_template_argument_list,
  [283461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    STATE(2848), 1,
      sym_field_declaration_list,
  [283471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    STATE(2849), 1,
      sym_field_declaration_list,
  [283481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9825), 1,
      anon_sym_LBRACE,
    STATE(4241), 1,
      sym_compound_statement,
  [283491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9821), 1,
      anon_sym_LBRACE,
    STATE(3277), 1,
      sym_compound_statement,
  [283501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13263), 1,
      anon_sym_LT,
    STATE(3436), 1,
      sym_template_argument_list,
  [283511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9823), 1,
      anon_sym_LBRACE,
    STATE(5493), 1,
      sym_compound_statement,
  [283521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACE,
    STATE(688), 1,
      sym_declaration_list,
  [283531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13229), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [283539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11116), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [283549] = 3,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13433), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13435), 1,
      sym_preproc_arg,
  [283559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    ACTIONS(13437), 1,
      anon_sym_RBRACE,
  [283569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6692), 1,
      anon_sym_LBRACE,
    STATE(2867), 1,
      sym_field_declaration_list,
  [283579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13439), 1,
      anon_sym_LPAREN2,
    ACTIONS(13441), 1,
      sym_raw_string_delimiter,
  [283589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10958), 1,
      anon_sym_LBRACE,
    STATE(1920), 1,
      sym_compound_statement,
  [283599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(2330), 1,
      sym_field_declaration_list,
  [283609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    STATE(2364), 1,
      sym_field_declaration_list,
  [283619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9823), 1,
      anon_sym_LBRACE,
    STATE(5503), 1,
      sym_compound_statement,
  [283629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13443), 1,
      anon_sym_LPAREN2,
    ACTIONS(13445), 1,
      sym_raw_string_delimiter,
  [283639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13447), 1,
      anon_sym_LPAREN2,
    ACTIONS(13449), 1,
      sym_raw_string_delimiter,
  [283649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13451), 1,
      anon_sym_LPAREN2,
    ACTIONS(13453), 1,
      sym_raw_string_delimiter,
  [283659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13455), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [283667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8697), 1,
      anon_sym_LT,
    STATE(1844), 1,
      sym_template_argument_list,
  [283677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13457), 1,
      anon_sym_LPAREN2,
    ACTIONS(13459), 1,
      sym_raw_string_delimiter,
  [283687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13461), 1,
      anon_sym_LPAREN2,
    ACTIONS(13463), 1,
      sym_raw_string_delimiter,
  [283697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13465), 1,
      anon_sym_LPAREN2,
    ACTIONS(13467), 1,
      sym_raw_string_delimiter,
  [283707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13469), 1,
      anon_sym_LPAREN2,
    ACTIONS(13471), 1,
      sym_raw_string_delimiter,
  [283717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13473), 1,
      anon_sym_LPAREN2,
    ACTIONS(13475), 1,
      sym_raw_string_delimiter,
  [283727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13477), 1,
      anon_sym_LPAREN2,
    ACTIONS(13479), 1,
      sym_raw_string_delimiter,
  [283737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13481), 1,
      anon_sym_LPAREN2,
    ACTIONS(13483), 1,
      sym_raw_string_delimiter,
  [283747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13485), 1,
      anon_sym_LPAREN2,
    ACTIONS(13487), 1,
      sym_raw_string_delimiter,
  [283757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13489), 1,
      anon_sym_LPAREN2,
    ACTIONS(13491), 1,
      sym_raw_string_delimiter,
  [283767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13493), 1,
      anon_sym_LPAREN2,
    ACTIONS(13495), 1,
      sym_raw_string_delimiter,
  [283777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13497), 1,
      anon_sym_LPAREN2,
    ACTIONS(13499), 1,
      sym_raw_string_delimiter,
  [283787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9722), 1,
      anon_sym_LBRACE,
    STATE(2428), 1,
      sym_requirement_seq,
  [283797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_LBRACE,
    STATE(496), 1,
      sym_declaration_list,
  [283807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13501), 1,
      aux_sym_preproc_if_token2,
  [283814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13503), 1,
      anon_sym_RPAREN,
  [283821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13505), 1,
      anon_sym_SEMI,
  [283828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13507), 1,
      aux_sym_preproc_if_token2,
  [283835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10592), 1,
      anon_sym_LBRACE,
  [283842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13509), 1,
      anon_sym_SEMI,
  [283849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13511), 1,
      anon_sym_RPAREN,
  [283856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_LT_LT_EQ,
  [283863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8971), 1,
      anon_sym_COLON,
  [283870] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10393), 1,
      aux_sym_preproc_include_token2,
  [283877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13515), 1,
      anon_sym_DQUOTE,
  [283884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13517), 1,
      aux_sym_preproc_if_token2,
  [283891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13519), 1,
      aux_sym_preproc_if_token2,
  [283898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13521), 1,
      anon_sym_RPAREN,
  [283905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9055), 1,
      anon_sym_SEMI,
  [283912] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13523), 1,
      aux_sym_preproc_include_token2,
  [283919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13525), 1,
      anon_sym_SEMI,
  [283926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_EQ,
  [283933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13527), 1,
      anon_sym_SEMI,
  [283940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9239), 1,
      anon_sym_RPAREN,
  [283947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8915), 1,
      anon_sym_RPAREN,
  [283954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13529), 1,
      sym_identifier,
  [283961] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13531), 1,
      aux_sym_preproc_include_token2,
  [283968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9101), 1,
      anon_sym_RPAREN,
  [283975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8783), 1,
      anon_sym_RBRACE,
  [283982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13533), 1,
      anon_sym_SEMI,
  [283989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11051), 1,
      anon_sym_RBRACE,
  [283996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8957), 1,
      anon_sym_RPAREN,
  [284003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13535), 1,
      anon_sym_SEMI,
  [284010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8892), 1,
      anon_sym_RBRACE,
  [284017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11096), 1,
      anon_sym_RBRACE,
  [284024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13537), 1,
      anon_sym_RPAREN,
  [284031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13539), 1,
      sym_raw_string_delimiter,
  [284038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13541), 1,
      anon_sym_SEMI,
  [284045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13543), 1,
      anon_sym_SEMI,
  [284052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13545), 1,
      anon_sym_COMMA,
  [284059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13547), 1,
      sym_identifier,
  [284066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13549), 1,
      anon_sym_SEMI,
  [284073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13551), 1,
      anon_sym_SEMI,
  [284080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_not_eq,
  [284087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 1,
      anon_sym_RPAREN,
  [284094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13555), 1,
      anon_sym_RPAREN,
  [284101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12299), 1,
      anon_sym_SEMI,
  [284108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_DOT_STAR,
  [284115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13557), 1,
      anon_sym_COLON,
  [284122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_GT_GT_EQ,
  [284129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13559), 1,
      anon_sym_SEMI,
  [284136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13561), 1,
      anon_sym_EQ,
  [284143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13563), 1,
      anon_sym_SEMI,
  [284150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13565), 1,
      anon_sym_LPAREN2,
  [284157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9130), 1,
      anon_sym_RPAREN,
  [284164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8849), 1,
      anon_sym_RBRACE,
  [284171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13567), 1,
      anon_sym_RPAREN,
  [284178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13569), 1,
      anon_sym_SEMI,
  [284185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13571), 1,
      anon_sym_LPAREN2,
  [284192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11114), 1,
      anon_sym_RBRACE,
  [284199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13573), 1,
      sym_identifier,
  [284206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12753), 1,
      anon_sym_COLON_COLON,
  [284213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13575), 1,
      anon_sym_RPAREN,
  [284220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13577), 1,
      anon_sym_SEMI,
  [284227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8977), 1,
      anon_sym_COLON,
  [284234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13579), 1,
      anon_sym_STAR,
  [284241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_CARET_EQ,
  [284248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13581), 1,
      anon_sym_SEMI,
  [284255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13583), 1,
      anon_sym_DQUOTE,
  [284262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13585), 1,
      anon_sym_RPAREN,
  [284269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13587), 1,
      anon_sym_RPAREN,
  [284276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13589), 1,
      anon_sym_DQUOTE,
  [284283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13591), 1,
      anon_sym_DQUOTE,
  [284290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13593), 1,
      anon_sym_DQUOTE,
  [284297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13595), 1,
      anon_sym_SEMI,
  [284304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13597), 1,
      anon_sym_RPAREN,
  [284311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_DASH_GT_STAR,
  [284318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13599), 1,
      anon_sym_SEMI,
  [284325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8917), 1,
      anon_sym_SEMI,
  [284332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13601), 1,
      anon_sym_RPAREN,
  [284339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13603), 1,
      anon_sym_SEMI,
  [284346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13605), 1,
      anon_sym_RPAREN,
  [284353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_DASH,
  [284360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_PLUS,
  [284367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 1,
      anon_sym_SEMI,
  [284374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13607), 1,
      sym_identifier,
  [284381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13609), 1,
      sym_identifier,
  [284388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13611), 1,
      anon_sym_RPAREN,
  [284395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11110), 1,
      anon_sym_RBRACE,
  [284402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13613), 1,
      anon_sym_RPAREN,
  [284409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13615), 1,
      anon_sym_RPAREN,
  [284416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13617), 1,
      anon_sym_RPAREN,
  [284423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9039), 1,
      anon_sym_COLON,
  [284430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13275), 1,
      anon_sym_RBRACE,
  [284437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13619), 1,
      anon_sym_COLON,
  [284444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9071), 1,
      anon_sym_RPAREN,
  [284451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13621), 1,
      sym_identifier,
  [284458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13623), 1,
      aux_sym_preproc_if_token2,
  [284465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13625), 1,
      sym_identifier,
  [284472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13627), 1,
      anon_sym_RPAREN,
  [284479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_STAR,
  [284486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13629), 1,
      sym_identifier,
  [284493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13631), 1,
      anon_sym_STAR,
  [284500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13633), 1,
      anon_sym_LPAREN2,
  [284507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13635), 1,
      anon_sym_SEMI,
  [284514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13637), 1,
      anon_sym_RPAREN,
  [284521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4790), 1,
      anon_sym_SEMI,
  [284528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13639), 1,
      anon_sym_SEMI,
  [284535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12140), 1,
      anon_sym_SEMI,
  [284542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13641), 1,
      anon_sym_LPAREN2,
  [284549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13643), 1,
      sym_auto,
  [284556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_AMP_EQ,
  [284563] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10220), 1,
      aux_sym_preproc_include_token2,
  [284570] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13645), 1,
      aux_sym_preproc_include_token2,
  [284577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8965), 1,
      anon_sym_COLON,
  [284584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13647), 1,
      anon_sym_SEMI,
  [284591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13649), 1,
      anon_sym_COLON,
  [284598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13651), 1,
      anon_sym_COLON,
  [284605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13653), 1,
      anon_sym_SEMI,
  [284612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      anon_sym_RPAREN,
  [284619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13277), 1,
      anon_sym_RBRACE,
  [284626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13655), 1,
      anon_sym_SEMI,
  [284633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13657), 1,
      anon_sym_SEMI,
  [284640] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13659), 1,
      aux_sym_preproc_include_token2,
  [284647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13661), 1,
      anon_sym_LPAREN2,
  [284654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12158), 1,
      anon_sym_SEMI,
  [284661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13663), 1,
      sym_identifier,
  [284668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13665), 1,
      anon_sym_DQUOTE,
  [284675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13667), 1,
      anon_sym_SEMI,
  [284682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_SEMI,
  [284689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13669), 1,
      anon_sym_STAR,
  [284696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_PIPE_EQ,
  [284703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13671), 1,
      anon_sym_SEMI,
  [284710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13673), 1,
      anon_sym_SEMI,
  [284717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13675), 1,
      anon_sym_RPAREN,
  [284724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13677), 1,
      anon_sym_RPAREN,
  [284731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13679), 1,
      sym_identifier,
  [284738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13681), 1,
      anon_sym_SEMI,
  [284745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13683), 1,
      anon_sym_SEMI,
  [284752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13685), 1,
      anon_sym_SEMI,
  [284759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13687), 1,
      anon_sym_SEMI,
  [284766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13689), 1,
      anon_sym_DQUOTE,
  [284773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13691), 1,
      anon_sym_RPAREN,
  [284780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13693), 1,
      anon_sym_SEMI,
  [284787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13695), 1,
      anon_sym_DQUOTE,
  [284794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13697), 1,
      anon_sym_SEMI,
  [284801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_LT_EQ,
  [284808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13699), 1,
      anon_sym_SEMI,
  [284815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13701), 1,
      anon_sym_STAR,
  [284822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13703), 1,
      sym_auto,
  [284829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13705), 1,
      sym_identifier,
  [284836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13339), 1,
      anon_sym_RBRACE,
  [284843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13707), 1,
      anon_sym_SEMI,
  [284850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13709), 1,
      anon_sym_SEMI,
  [284857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13711), 1,
      sym_identifier,
  [284864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13713), 1,
      anon_sym_SEMI,
  [284871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11583), 1,
      anon_sym_LBRACE,
  [284878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8979), 1,
      anon_sym_COLON,
  [284885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13715), 1,
      anon_sym_RPAREN,
  [284892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13717), 1,
      anon_sym_RPAREN,
  [284899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13719), 1,
      sym_raw_string_delimiter,
  [284906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13721), 1,
      anon_sym_RPAREN,
  [284913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13723), 1,
      anon_sym_RPAREN,
  [284920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13725), 1,
      anon_sym_SEMI,
  [284927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13727), 1,
      sym_identifier,
  [284934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_LT,
  [284941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13729), 1,
      anon_sym_RPAREN,
  [284948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13731), 1,
      anon_sym_SEMI,
  [284955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7722), 1,
      sym_identifier,
  [284962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13733), 1,
      anon_sym_SEMI,
  [284969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13735), 1,
      anon_sym_RPAREN,
  [284976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13737), 1,
      anon_sym_DQUOTE,
  [284983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13739), 1,
      anon_sym_DQUOTE,
  [284990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13741), 1,
      anon_sym_DQUOTE,
  [284997] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10325), 1,
      aux_sym_preproc_include_token2,
  [285004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13743), 1,
      aux_sym_preproc_if_token2,
  [285011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13745), 1,
      sym_identifier,
  [285018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13747), 1,
      anon_sym_COLON,
  [285025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13749), 1,
      anon_sym_RPAREN,
  [285032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13751), 1,
      anon_sym_RPAREN,
  [285039] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13753), 1,
      aux_sym_preproc_include_token2,
  [285046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13755), 1,
      anon_sym_LBRACE,
  [285053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13757), 1,
      sym_identifier,
  [285060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12777), 1,
      anon_sym_SEMI,
  [285067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9233), 1,
      anon_sym_RPAREN,
  [285074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11975), 1,
      anon_sym_SEMI,
  [285081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8695), 1,
      anon_sym_RBRACE,
  [285088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13759), 1,
      anon_sym_STAR,
  [285095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13761), 1,
      anon_sym_SEMI,
  [285102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13763), 1,
      anon_sym_SEMI,
  [285109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13007), 1,
      anon_sym_LBRACE,
  [285116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13765), 1,
      anon_sym_SEMI,
  [285123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13767), 1,
      sym_this,
  [285130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13769), 1,
      anon_sym_SEMI,
  [285137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13771), 1,
      anon_sym_EQ,
  [285144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13773), 1,
      anon_sym_SEMI,
  [285151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13775), 1,
      anon_sym_SEMI,
  [285158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13777), 1,
      aux_sym_preproc_if_token2,
  [285165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13779), 1,
      anon_sym_SEMI,
  [285172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6999), 1,
      anon_sym_SEMI,
  [285179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13781), 1,
      anon_sym_RPAREN,
  [285186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13783), 1,
      sym_identifier,
  [285193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13785), 1,
      anon_sym_LPAREN2,
  [285200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13787), 1,
      anon_sym_RPAREN,
  [285207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13789), 1,
      anon_sym_LPAREN2,
  [285214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9138), 1,
      anon_sym_RPAREN,
  [285221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13791), 1,
      anon_sym_RPAREN,
  [285228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13793), 1,
      anon_sym_LBRACE,
  [285235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11086), 1,
      anon_sym_RBRACE,
  [285242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13795), 1,
      anon_sym_DQUOTE,
  [285249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13797), 1,
      anon_sym_DQUOTE,
  [285256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13799), 1,
      sym_identifier,
  [285263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13801), 1,
      anon_sym_SEMI,
  [285270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13803), 1,
      anon_sym_SEMI,
  [285277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13805), 1,
      anon_sym_DQUOTE,
  [285284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13807), 1,
      anon_sym_DQUOTE,
  [285291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13809), 1,
      anon_sym_RPAREN,
  [285298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13811), 1,
      sym_identifier,
  [285305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13813), 1,
      anon_sym_RPAREN,
  [285312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_LT_LT,
  [285319] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13815), 1,
      aux_sym_preproc_include_token2,
  [285326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13817), 1,
      anon_sym_RPAREN,
  [285333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13819), 1,
      anon_sym_RPAREN,
  [285340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13821), 1,
      anon_sym_SEMI,
  [285347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13823), 1,
      anon_sym_RPAREN,
  [285354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13825), 1,
      anon_sym_RPAREN,
  [285361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13827), 1,
      anon_sym_DQUOTE,
  [285368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13829), 1,
      sym_identifier,
  [285375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
  [285382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13831), 1,
      anon_sym_LPAREN2,
  [285389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13833), 1,
      anon_sym_LPAREN2,
  [285396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13835), 1,
      anon_sym_RPAREN,
  [285403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13837), 1,
      anon_sym_RPAREN,
  [285410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13839), 1,
      sym_raw_string_delimiter,
  [285417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13279), 1,
      anon_sym_RBRACE,
  [285424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13841), 1,
      sym_identifier,
  [285431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9215), 1,
      anon_sym_RPAREN,
  [285438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13843), 1,
      anon_sym_LBRACE,
  [285445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11595), 1,
      anon_sym_EQ,
  [285452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13845), 1,
      anon_sym_DQUOTE,
  [285459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13847), 1,
      anon_sym_SEMI,
  [285466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13849), 1,
      aux_sym_preproc_if_token2,
  [285473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13851), 1,
      anon_sym_STAR,
  [285480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13853), 1,
      anon_sym_SEMI,
  [285487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13855), 1,
      anon_sym_SEMI,
  [285494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4827), 1,
      anon_sym_SEMI,
  [285501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13857), 1,
      sym_identifier,
  [285508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13859), 1,
      anon_sym_SEMI,
  [285515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13861), 1,
      anon_sym_SEMI,
  [285522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13863), 1,
      anon_sym_SEMI,
  [285529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13865), 1,
      anon_sym_RPAREN,
  [285536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13867), 1,
      anon_sym_RBRACE,
  [285543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13869), 1,
      anon_sym_SEMI,
  [285550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13871), 1,
      anon_sym_RPAREN,
  [285557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13873), 1,
      sym_identifier,
  [285564] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13062), 1,
      aux_sym_preproc_include_token2,
  [285571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13875), 1,
      anon_sym_LPAREN2,
  [285578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13877), 1,
      anon_sym_RPAREN,
  [285585] = 2,
    ACTIONS(5484), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10118), 1,
      sym_comment,
  [285592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8975), 1,
      anon_sym_SEMI,
  [285599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13879), 1,
      aux_sym_preproc_if_token2,
  [285606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13881), 1,
      anon_sym_SEMI,
  [285613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13883), 1,
      anon_sym_RPAREN,
  [285620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13885), 1,
      sym_raw_string_delimiter,
  [285627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13887), 1,
      sym_identifier,
  [285634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13889), 1,
      anon_sym_SEMI,
  [285641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13891), 1,
      anon_sym_RPAREN,
  [285648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4617), 1,
      anon_sym_DOT_DOT_DOT,
  [285655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13893), 1,
      sym_auto,
  [285662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13895), 1,
      anon_sym_RPAREN,
  [285669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13897), 1,
      anon_sym_LBRACE,
  [285676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4611), 1,
      anon_sym_DOT_DOT_DOT,
  [285683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13899), 1,
      anon_sym_RPAREN,
  [285690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_DOT_DOT_DOT,
  [285697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13901), 1,
      sym_identifier,
  [285704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4622), 1,
      anon_sym_DOT_DOT_DOT,
  [285711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13903), 1,
      anon_sym_SEMI,
  [285718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13905), 1,
      anon_sym_LBRACE,
  [285725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12372), 1,
      anon_sym_SEMI,
  [285732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_DOT_DOT_DOT,
  [285739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13907), 1,
      sym_identifier,
  [285746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11104), 1,
      anon_sym_RBRACE,
  [285753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13909), 1,
      anon_sym_DQUOTE,
  [285760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13911), 1,
      aux_sym_preproc_if_token2,
  [285767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_DOT_DOT_DOT,
  [285774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13913), 1,
      anon_sym_RPAREN,
  [285781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13915), 1,
      sym_raw_string_delimiter,
  [285788] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13917), 1,
      aux_sym_preproc_include_token2,
  [285795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13919), 1,
      sym_identifier,
  [285802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_DOT_DOT_DOT,
  [285809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11836), 1,
      anon_sym_COLON,
  [285816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13921), 1,
      anon_sym_DQUOTE,
  [285823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13923), 1,
      anon_sym_DQUOTE,
  [285830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13925), 1,
      anon_sym_RPAREN,
  [285837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13927), 1,
      aux_sym_preproc_if_token2,
  [285844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13929), 1,
      anon_sym_STAR,
  [285851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7299), 1,
      anon_sym_RPAREN,
  [285858] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13931), 1,
      aux_sym_preproc_include_token2,
  [285865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13933), 1,
      anon_sym_SEMI,
  [285872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13935), 1,
      anon_sym_RPAREN,
  [285879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13937), 1,
      aux_sym_preproc_if_token2,
  [285886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13939), 1,
      sym_identifier,
  [285893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13941), 1,
      anon_sym_RPAREN,
  [285900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13943), 1,
      aux_sym_preproc_if_token2,
  [285907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13945), 1,
      anon_sym_RPAREN,
  [285914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13947), 1,
      anon_sym_RPAREN,
  [285921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13949), 1,
      anon_sym_STAR,
  [285928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13951), 1,
      anon_sym_RPAREN,
  [285935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13953), 1,
      anon_sym_LPAREN2,
  [285942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13955), 1,
      anon_sym_RPAREN,
  [285949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13957), 1,
      aux_sym_preproc_if_token2,
  [285956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13959), 1,
      anon_sym_RPAREN,
  [285963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4634), 1,
      anon_sym_DOT_DOT_DOT,
  [285970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13961), 1,
      anon_sym_RPAREN,
  [285977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13963), 1,
      aux_sym_preproc_if_token2,
  [285984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12356), 1,
      anon_sym_SEMI,
  [285991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11573), 1,
      anon_sym_SEMI,
  [285998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13965), 1,
      anon_sym_RPAREN,
  [286005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13967), 1,
      anon_sym_RPAREN,
  [286012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13253), 1,
      anon_sym_RBRACE,
  [286019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13969), 1,
      aux_sym_preproc_if_token2,
  [286026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13971), 1,
      anon_sym_RPAREN,
  [286033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10486), 1,
      sym_identifier,
  [286040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13973), 1,
      anon_sym_RPAREN,
  [286047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13975), 1,
      anon_sym_RPAREN,
  [286054] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13977), 1,
      aux_sym_preproc_include_token2,
  [286061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8993), 1,
      anon_sym_COLON,
  [286068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13979), 1,
      anon_sym_SEMI,
  [286075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13981), 1,
      aux_sym_preproc_if_token2,
  [286082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13983), 1,
      anon_sym_SEMI,
  [286089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13985), 1,
      sym_auto,
  [286096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_RPAREN,
  [286103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13989), 1,
      sym_raw_string_delimiter,
  [286110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13991), 1,
      anon_sym_SEMI,
  [286117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13993), 1,
      sym_identifier,
  [286124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_GT_GT,
  [286131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13995), 1,
      anon_sym_COLON,
  [286138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13997), 1,
      anon_sym_SEMI,
  [286145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13999), 1,
      aux_sym_preproc_if_token2,
  [286152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6995), 1,
      anon_sym_SEMI,
  [286159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14001), 1,
      anon_sym_LPAREN2,
  [286166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
  [286173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14003), 1,
      sym_identifier,
  [286180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14005), 1,
      aux_sym_preproc_if_token2,
  [286187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14007), 1,
      anon_sym_RPAREN,
  [286194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_DOT_DOT_DOT,
  [286201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14009), 1,
      anon_sym_RPAREN,
  [286208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14011), 1,
      sym_raw_string_delimiter,
  [286215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_STAR_EQ,
  [286222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9037), 1,
      anon_sym_COLON,
  [286229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14013), 1,
      aux_sym_preproc_if_token2,
  [286236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14015), 1,
      anon_sym_SEMI,
  [286243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4604), 1,
      anon_sym_DOT_DOT_DOT,
  [286250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14017), 1,
      anon_sym_LPAREN2,
  [286257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14019), 1,
      anon_sym_SEMI,
  [286264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14021), 1,
      sym_identifier,
  [286271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14023), 1,
      anon_sym_RPAREN,
  [286278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14025), 1,
      aux_sym_preproc_if_token2,
  [286285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14027), 1,
      sym_raw_string_delimiter,
  [286292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14029), 1,
      anon_sym_LPAREN2,
  [286299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14031), 1,
      anon_sym_LPAREN2,
  [286306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14033), 1,
      anon_sym_RPAREN,
  [286313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11492), 1,
      anon_sym_SEMI,
  [286320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14035), 1,
      anon_sym_LPAREN2,
  [286327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14037), 1,
      anon_sym_RPAREN,
  [286334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14039), 1,
      sym_raw_string_delimiter,
  [286341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14041), 1,
      anon_sym_RPAREN,
  [286348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14043), 1,
      aux_sym_preproc_if_token2,
  [286355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14045), 1,
      anon_sym_RPAREN,
  [286362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14047), 1,
      sym_raw_string_delimiter,
  [286369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      sym_identifier,
  [286376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14051), 1,
      anon_sym_DQUOTE,
  [286383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14053), 1,
      anon_sym_RPAREN,
  [286390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14055), 1,
      sym_raw_string_delimiter,
  [286397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14057), 1,
      anon_sym_RPAREN,
  [286404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14059), 1,
      sym_raw_string_delimiter,
  [286411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14061), 1,
      anon_sym_RPAREN,
  [286418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14063), 1,
      sym_raw_string_delimiter,
  [286425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14065), 1,
      anon_sym_RPAREN,
  [286432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14067), 1,
      sym_raw_string_delimiter,
  [286439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14069), 1,
      anon_sym_RPAREN,
  [286446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14071), 1,
      sym_raw_string_delimiter,
  [286453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14073), 1,
      anon_sym_RPAREN,
  [286460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14075), 1,
      sym_raw_string_delimiter,
  [286467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14077), 1,
      sym_identifier,
  [286474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14079), 1,
      anon_sym_RPAREN,
  [286481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6927), 1,
      anon_sym_SEMI,
  [286488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14081), 1,
      anon_sym_LPAREN2,
  [286495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14083), 1,
      anon_sym_SEMI,
  [286502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14085), 1,
      anon_sym_LPAREN2,
  [286509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14087), 1,
      anon_sym_LPAREN2,
  [286516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14089), 1,
      anon_sym_LPAREN2,
  [286523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9031), 1,
      anon_sym_SEMI,
  [286530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_or,
  [286537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14091), 1,
      anon_sym_LPAREN2,
  [286544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14093), 1,
      anon_sym_SEMI,
  [286551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14095), 1,
      anon_sym_LPAREN2,
  [286558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14097), 1,
      anon_sym_SEMI,
  [286565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14099), 1,
      anon_sym_RPAREN,
  [286572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11516), 1,
      anon_sym_LBRACE,
  [286579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14101), 1,
      anon_sym_RPAREN,
  [286586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14103), 1,
      anon_sym_RPAREN,
  [286593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14105), 1,
      anon_sym_DQUOTE,
  [286600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14107), 1,
      anon_sym_SEMI,
  [286607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14109), 1,
      sym_identifier,
  [286614] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14111), 1,
      aux_sym_preproc_include_token2,
  [286621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14113), 1,
      anon_sym_RPAREN,
  [286628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14115), 1,
      aux_sym_preproc_if_token2,
  [286635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11514), 1,
      anon_sym_LBRACE,
  [286642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9075), 1,
      anon_sym_RPAREN,
  [286649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14117), 1,
      anon_sym_SEMI,
  [286656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11518), 1,
      anon_sym_LBRACE,
  [286663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14119), 1,
      anon_sym_while,
  [286670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8853), 1,
      anon_sym_RBRACE,
  [286677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14121), 1,
      anon_sym_LPAREN2,
  [286684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14123), 1,
      anon_sym_RPAREN,
  [286691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14125), 1,
      aux_sym_preproc_if_token2,
  [286698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9128), 1,
      anon_sym_RPAREN,
  [286705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14127), 1,
      anon_sym_COLON,
  [286712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8959), 1,
      anon_sym_RPAREN,
  [286719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14129), 1,
      anon_sym_EQ,
  [286726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14131), 1,
      sym_raw_string_content,
  [286733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_SEMI,
  [286740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14135), 1,
      anon_sym_SEMI,
  [286747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14137), 1,
      anon_sym_LPAREN2,
  [286754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14139), 1,
      anon_sym_STAR,
  [286761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14141), 1,
      anon_sym_private,
  [286768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14143), 1,
      anon_sym_SEMI,
  [286775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14145), 1,
      anon_sym_RPAREN,
  [286782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14147), 1,
      anon_sym_SEMI,
  [286789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11698), 1,
      anon_sym_LBRACE,
  [286796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14149), 1,
      aux_sym_preproc_if_token2,
  [286803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12142), 1,
      anon_sym_SEMI,
  [286810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14151), 1,
      anon_sym_RBRACE,
  [286817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14153), 1,
      sym_identifier,
  [286824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14155), 1,
      anon_sym_SEMI,
  [286831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14157), 1,
      anon_sym_RPAREN,
  [286838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14159), 1,
      sym_identifier,
  [286845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14161), 1,
      anon_sym_RPAREN,
  [286852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14163), 1,
      anon_sym_COMMA,
  [286859] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14165), 1,
      aux_sym_preproc_include_token2,
  [286866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14167), 1,
      anon_sym_SEMI,
  [286873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14169), 1,
      aux_sym_preproc_if_token2,
  [286880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14171), 1,
      anon_sym_LPAREN2,
  [286887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14173), 1,
      anon_sym_LPAREN2,
  [286894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9168), 1,
      anon_sym_RPAREN,
  [286901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_STAR,
  [286908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9029), 1,
      anon_sym_COLON,
  [286915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11098), 1,
      anon_sym_RBRACE,
  [286922] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13122), 1,
      aux_sym_preproc_include_token2,
  [286929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14177), 1,
      anon_sym_SEMI,
  [286936] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(10285), 1,
      aux_sym_preproc_include_token2,
  [286943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14179), 1,
      sym_identifier,
  [286950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11500), 1,
      anon_sym_SEMI,
  [286957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14181), 1,
      sym_identifier,
  [286964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_GT_EQ,
  [286971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14183), 1,
      anon_sym_SEMI,
  [286978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14185), 1,
      anon_sym_RPAREN,
  [286985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14187), 1,
      anon_sym_SEMI,
  [286992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14189), 1,
      anon_sym_RPAREN,
  [286999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14191), 1,
      sym_identifier,
  [287006] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14193), 1,
      aux_sym_preproc_include_token2,
  [287013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14195), 1,
      anon_sym_RPAREN,
  [287020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14197), 1,
      anon_sym_RPAREN,
  [287027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14199), 1,
      anon_sym_RPAREN,
  [287034] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14201), 1,
      aux_sym_preproc_include_token2,
  [287041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14203), 1,
      anon_sym_COLON,
  [287048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14205), 1,
      anon_sym_COLON,
  [287055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14207), 1,
      aux_sym_preproc_if_token2,
  [287062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14209), 1,
      anon_sym_LPAREN2,
  [287069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14211), 1,
      anon_sym_RBRACE,
  [287076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14213), 1,
      anon_sym_RPAREN,
  [287083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14215), 1,
      ts_builtin_sym_end,
  [287090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12160), 1,
      anon_sym_SEMI,
  [287097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14217), 1,
      anon_sym_SEMI,
  [287104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14219), 1,
      aux_sym_preproc_if_token2,
  [287111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14221), 1,
      sym_raw_string_content,
  [287118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_RPAREN,
  [287125] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(13139), 1,
      aux_sym_preproc_include_token2,
  [287132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14225), 1,
      anon_sym_STAR,
  [287139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14227), 1,
      anon_sym_SEMI,
  [287146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14229), 1,
      anon_sym_RPAREN,
  [287153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_SEMI,
  [287160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14231), 1,
      anon_sym_DQUOTE,
  [287167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14233), 1,
      anon_sym_SEMI,
  [287174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14235), 1,
      sym_identifier,
  [287181] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14237), 1,
      aux_sym_preproc_include_token2,
  [287188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14239), 1,
      sym_auto,
  [287195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14241), 1,
      aux_sym_preproc_if_token2,
  [287202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 1,
      anon_sym_SEMI,
  [287209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_RPAREN,
  [287216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14243), 1,
      anon_sym_RPAREN,
  [287223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8945), 1,
      anon_sym_COLON,
  [287230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9021), 1,
      anon_sym_COLON,
  [287237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14245), 1,
      anon_sym_RPAREN,
  [287244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14247), 1,
      anon_sym_RPAREN,
  [287251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14249), 1,
      anon_sym_RPAREN,
  [287258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14251), 1,
      anon_sym_DQUOTE,
  [287265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_LPAREN2,
  [287272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14255), 1,
      anon_sym_RPAREN,
  [287279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_RPAREN,
  [287286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14259), 1,
      anon_sym_DQUOTE,
  [287293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14261), 1,
      anon_sym_RPAREN,
  [287300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14263), 1,
      aux_sym_preproc_if_token2,
  [287307] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14265), 1,
      aux_sym_preproc_include_token2,
  [287314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14267), 1,
      anon_sym_RPAREN,
  [287321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14269), 1,
      aux_sym_preproc_if_token2,
  [287328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_SEMI,
  [287335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      anon_sym_LPAREN2,
  [287342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      anon_sym_RPAREN,
  [287349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9027), 1,
      anon_sym_SEMI,
  [287356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14277), 1,
      sym_identifier,
  [287363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9059), 1,
      anon_sym_RPAREN,
  [287370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14279), 1,
      sym_identifier,
  [287377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14281), 1,
      aux_sym_preproc_if_token2,
  [287384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14283), 1,
      anon_sym_RPAREN,
  [287391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14285), 1,
      anon_sym_SEMI,
  [287398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14287), 1,
      anon_sym_SEMI,
  [287405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9243), 1,
      anon_sym_RPAREN,
  [287412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13413), 1,
      anon_sym_RBRACE,
  [287419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13315), 1,
      anon_sym_RBRACE,
  [287426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14289), 1,
      anon_sym_SEMI,
  [287433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14291), 1,
      anon_sym_SEMI,
  [287440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11549), 1,
      anon_sym_SEMI,
  [287447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14293), 1,
      sym_raw_string_delimiter,
  [287454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9007), 1,
      anon_sym_RPAREN,
  [287461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12895), 1,
      anon_sym_RPAREN,
  [287468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14295), 1,
      anon_sym_RPAREN,
  [287475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14297), 1,
      anon_sym_SEMI,
  [287482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14299), 1,
      anon_sym_while,
  [287489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7185), 1,
      anon_sym_RPAREN,
  [287496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9041), 1,
      anon_sym_SEMI,
  [287503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14301), 1,
      sym_identifier,
  [287510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14303), 1,
      anon_sym_RPAREN,
  [287517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14305), 1,
      anon_sym_SEMI,
  [287524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14307), 1,
      sym_identifier,
  [287531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14309), 1,
      anon_sym_SEMI,
  [287538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      anon_sym_SEMI,
  [287545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11545), 1,
      anon_sym_SEMI,
  [287552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14313), 1,
      anon_sym_DQUOTE,
  [287559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8983), 1,
      anon_sym_RPAREN,
  [287566] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(12720), 1,
      aux_sym_preproc_include_token2,
  [287573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14315), 1,
      anon_sym_RPAREN,
  [287580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14317), 1,
      sym_raw_string_content,
  [287587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_SEMI,
  [287594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14321), 1,
      anon_sym_COLON,
  [287601] = 2,
    ACTIONS(5491), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10118), 1,
      sym_comment,
  [287608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14323), 1,
      anon_sym_SEMI,
  [287615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12342), 1,
      anon_sym_SEMI,
  [287622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14325), 1,
      anon_sym_SEMI,
  [287629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14327), 1,
      aux_sym_preproc_if_token2,
  [287636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14329), 1,
      anon_sym_SEMI,
  [287643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9005), 1,
      anon_sym_SEMI,
  [287650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14331), 1,
      aux_sym_preproc_if_token2,
  [287657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14333), 1,
      anon_sym_SEMI,
  [287664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 1,
      anon_sym_SEMI,
  [287671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6929), 1,
      anon_sym_SEMI,
  [287678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14335), 1,
      anon_sym_STAR,
  [287685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14337), 1,
      anon_sym_SEMI,
  [287692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14339), 1,
      anon_sym_SEMI,
  [287699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14341), 1,
      anon_sym_SEMI,
  [287706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14343), 1,
      anon_sym_RBRACK,
  [287713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14345), 1,
      anon_sym_DQUOTE,
  [287720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14347), 1,
      anon_sym_SEMI,
  [287727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14349), 1,
      anon_sym_SEMI,
  [287734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14351), 1,
      anon_sym_RPAREN,
  [287741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13415), 1,
      anon_sym_RBRACE,
  [287748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14353), 1,
      sym_identifier,
  [287755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14355), 1,
      sym_identifier,
  [287762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10582), 1,
      anon_sym_LBRACE,
  [287769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14357), 1,
      sym_identifier,
  [287776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9053), 1,
      anon_sym_SEMI,
  [287783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14359), 1,
      anon_sym_SEMI,
  [287790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14361), 1,
      sym_auto,
  [287797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10588), 1,
      anon_sym_LBRACE,
  [287804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14363), 1,
      anon_sym_SEMI,
  [287811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14365), 1,
      anon_sym_DQUOTE,
  [287818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14367), 1,
      anon_sym_RPAREN,
  [287825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9067), 1,
      anon_sym_RPAREN,
  [287832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14369), 1,
      anon_sym_RPAREN,
  [287839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14371), 1,
      sym_identifier,
  [287846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14373), 1,
      sym_identifier,
  [287853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7558), 1,
      sym_identifier,
  [287860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14375), 1,
      anon_sym_LBRACE,
  [287867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14377), 1,
      anon_sym_RPAREN,
  [287874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14379), 1,
      aux_sym_preproc_if_token2,
  [287881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10678), 1,
      anon_sym_LBRACE,
  [287888] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14381), 1,
      aux_sym_preproc_include_token2,
  [287895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14383), 1,
      anon_sym_SLASH,
  [287902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14385), 1,
      anon_sym_LPAREN2,
  [287909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14387), 1,
      anon_sym_LPAREN2,
  [287916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14389), 1,
      anon_sym_LPAREN2,
  [287923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14391), 1,
      anon_sym_LPAREN2,
  [287930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_and,
  [287937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14393), 1,
      anon_sym_LPAREN2,
  [287944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14395), 1,
      aux_sym_preproc_if_token2,
  [287951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14397), 1,
      anon_sym_RPAREN,
  [287958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14399), 1,
      anon_sym_LPAREN2,
  [287965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14401), 1,
      anon_sym_SEMI,
  [287972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14403), 1,
      aux_sym_preproc_if_token2,
  [287979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14405), 1,
      anon_sym_while,
  [287986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_bitor,
  [287993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14407), 1,
      anon_sym_LPAREN2,
  [288000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_PERCENT,
  [288007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14409), 1,
      aux_sym_preproc_if_token2,
  [288014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14411), 1,
      aux_sym_preproc_if_token2,
  [288021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14413), 1,
      anon_sym_EQ,
  [288028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14415), 1,
      sym_raw_string_content,
  [288035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14417), 1,
      anon_sym_STAR,
  [288042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14419), 1,
      aux_sym_preproc_if_token2,
  [288049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14421), 1,
      anon_sym_RPAREN,
  [288056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12116), 1,
      anon_sym_SEMI,
  [288063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14423), 1,
      anon_sym_RPAREN,
  [288070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14425), 1,
      anon_sym_COMMA,
  [288077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9065), 1,
      anon_sym_SEMI,
  [288084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9015), 1,
      anon_sym_SEMI,
  [288091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14427), 1,
      anon_sym_RPAREN,
  [288098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14429), 1,
      anon_sym_COLON,
  [288105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14431), 1,
      anon_sym_SEMI,
  [288112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14433), 1,
      anon_sym_SEMI,
  [288119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14435), 1,
      anon_sym_LPAREN2,
  [288126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14437), 1,
      anon_sym_LPAREN2,
  [288133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14439), 1,
      anon_sym_LPAREN2,
  [288140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14441), 1,
      anon_sym_RPAREN,
  [288147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14443), 1,
      anon_sym_LPAREN2,
  [288154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11108), 1,
      anon_sym_RBRACE,
  [288161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12915), 1,
      anon_sym_LBRACE,
  [288168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14445), 1,
      anon_sym_while,
  [288175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14447), 1,
      sym_auto,
  [288182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14449), 1,
      anon_sym_LPAREN2,
  [288189] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14451), 1,
      aux_sym_preproc_include_token2,
  [288196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14453), 1,
      anon_sym_RPAREN,
  [288203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14455), 1,
      anon_sym_EQ,
  [288210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14457), 1,
      sym_raw_string_content,
  [288217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14459), 1,
      anon_sym_RPAREN,
  [288224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14461), 1,
      anon_sym_COMMA,
  [288231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14463), 1,
      anon_sym_RPAREN,
  [288238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14465), 1,
      anon_sym_RPAREN,
  [288245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14467), 1,
      anon_sym_RPAREN,
  [288252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14469), 1,
      anon_sym_COLON,
  [288259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14471), 1,
      sym_identifier,
  [288266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14473), 1,
      anon_sym_LPAREN2,
  [288273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14475), 1,
      anon_sym_LPAREN2,
  [288280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14477), 1,
      anon_sym_LPAREN2,
  [288287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_PIPE_PIPE,
  [288294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14479), 1,
      anon_sym_LPAREN2,
  [288301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14481), 1,
      sym_identifier,
  [288308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14483), 1,
      aux_sym_preproc_if_token2,
  [288315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14485), 1,
      anon_sym_while,
  [288322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14487), 1,
      anon_sym_LPAREN2,
  [288329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14489), 1,
      anon_sym_RPAREN,
  [288336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 1,
      sym_identifier,
  [288343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14491), 1,
      anon_sym_EQ,
  [288350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14493), 1,
      sym_raw_string_content,
  [288357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14495), 1,
      aux_sym_preproc_if_token2,
  [288364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14497), 1,
      anon_sym_COMMA,
  [288371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14499), 1,
      anon_sym_RPAREN,
  [288378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14501), 1,
      anon_sym_SEMI,
  [288385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14503), 1,
      anon_sym_RPAREN,
  [288392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14505), 1,
      anon_sym_COLON,
  [288399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14507), 1,
      anon_sym_SEMI,
  [288406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14509), 1,
      anon_sym_LPAREN2,
  [288413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14511), 1,
      anon_sym_LPAREN2,
  [288420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14513), 1,
      anon_sym_LPAREN2,
  [288427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14515), 1,
      sym_identifier,
  [288434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14517), 1,
      anon_sym_LPAREN2,
  [288441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_AMP_AMP,
  [288448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7524), 1,
      sym_identifier,
  [288455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14519), 1,
      anon_sym_LPAREN2,
  [288462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14521), 1,
      anon_sym_RPAREN,
  [288469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14523), 1,
      anon_sym_SEMI,
  [288476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14525), 1,
      anon_sym_EQ,
  [288483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14527), 1,
      sym_raw_string_content,
  [288490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14529), 1,
      anon_sym_STAR,
  [288497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14531), 1,
      anon_sym_COMMA,
  [288504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_SLASH_EQ,
  [288511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14533), 1,
      anon_sym_SEMI,
  [288518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14535), 1,
      anon_sym_RPAREN,
  [288525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14537), 1,
      anon_sym_COLON,
  [288532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14539), 1,
      anon_sym_COLON,
  [288539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14541), 1,
      anon_sym_LPAREN2,
  [288546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14543), 1,
      anon_sym_LPAREN2,
  [288553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_COLON_COLON,
  [288560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14545), 1,
      anon_sym_LPAREN2,
  [288567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14547), 1,
      sym_identifier,
  [288574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_PIPE,
  [288581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14549), 1,
      anon_sym_RPAREN,
  [288588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14551), 1,
      anon_sym_RPAREN,
  [288595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14553), 1,
      anon_sym_EQ,
  [288602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14555), 1,
      sym_raw_string_content,
  [288609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8896), 1,
      anon_sym_RPAREN,
  [288616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14557), 1,
      anon_sym_RPAREN,
  [288623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14559), 1,
      anon_sym_SEMI,
  [288630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14561), 1,
      anon_sym_RPAREN,
  [288637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14563), 1,
      anon_sym_RBRACE,
  [288644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14565), 1,
      anon_sym_LPAREN2,
  [288651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14567), 1,
      anon_sym_LPAREN2,
  [288658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14569), 1,
      anon_sym_LPAREN2,
  [288665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14571), 1,
      anon_sym_SEMI,
  [288672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14573), 1,
      sym_raw_string_content,
  [288679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14575), 1,
      anon_sym_SEMI,
  [288686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14577), 1,
      anon_sym_RPAREN,
  [288693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14579), 1,
      anon_sym_RPAREN,
  [288700] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14581), 1,
      aux_sym_preproc_include_token2,
  [288707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14583), 1,
      anon_sym_LPAREN2,
  [288714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14585), 1,
      anon_sym_LPAREN2,
  [288721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14587), 1,
      anon_sym_LPAREN2,
  [288728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14589), 1,
      anon_sym_SEMI,
  [288735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14591), 1,
      sym_raw_string_content,
  [288742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14593), 1,
      anon_sym_RPAREN,
  [288749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14595), 1,
      anon_sym_RPAREN,
  [288756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14597), 1,
      anon_sym_LPAREN2,
  [288763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14599), 1,
      anon_sym_LPAREN2,
  [288770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14601), 1,
      anon_sym_LPAREN2,
  [288777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14603), 1,
      sym_raw_string_content,
  [288784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14605), 1,
      anon_sym_RPAREN,
  [288791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14607), 1,
      anon_sym_LPAREN2,
  [288798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14609), 1,
      sym_raw_string_content,
  [288805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14611), 1,
      anon_sym_RPAREN,
  [288812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14613), 1,
      anon_sym_LPAREN2,
  [288819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14615), 1,
      sym_raw_string_content,
  [288826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14617), 1,
      anon_sym_RPAREN,
  [288833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14619), 1,
      sym_raw_string_content,
  [288840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14621), 1,
      anon_sym_RPAREN,
  [288847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14623), 1,
      sym_raw_string_content,
  [288854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14625), 1,
      anon_sym_RPAREN,
  [288861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14627), 1,
      sym_raw_string_content,
  [288868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14629), 1,
      anon_sym_RPAREN,
  [288875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14631), 1,
      sym_raw_string_content,
  [288882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14633), 1,
      anon_sym_RPAREN,
  [288889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14635), 1,
      sym_raw_string_content,
  [288896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14637), 1,
      anon_sym_RPAREN,
  [288903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14639), 1,
      anon_sym_RPAREN,
  [288910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14641), 1,
      sym_identifier,
  [288917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14643), 1,
      anon_sym_LPAREN2,
  [288924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14645), 1,
      anon_sym_LPAREN2,
  [288931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14647), 1,
      sym_identifier,
  [288938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14649), 1,
      anon_sym_SEMI,
  [288945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14651), 1,
      anon_sym_RBRACK,
  [288952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_COMMA,
  [288959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9043), 1,
      anon_sym_SEMI,
  [288966] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14653), 1,
      aux_sym_preproc_include_token2,
  [288973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14655), 1,
      sym_identifier,
  [288980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_xor,
  [288987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14657), 1,
      aux_sym_preproc_if_token2,
  [288994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13419), 1,
      anon_sym_RBRACE,
  [289001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14659), 1,
      anon_sym_STAR,
  [289008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11616), 1,
      anon_sym_COMMA,
  [289015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14661), 1,
      sym_identifier,
  [289022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9217), 1,
      anon_sym_RPAREN,
  [289029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14663), 1,
      anon_sym_RPAREN,
  [289036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9051), 1,
      anon_sym_SEMI,
  [289043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14665), 1,
      sym_identifier,
  [289050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14667), 1,
      sym_raw_string_content,
  [289057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14669), 1,
      anon_sym_DQUOTE,
  [289064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14671), 1,
      sym_identifier,
  [289071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11063), 1,
      anon_sym_RBRACE,
  [289078] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14673), 1,
      aux_sym_preproc_include_token2,
  [289085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11569), 1,
      anon_sym_SEMI,
  [289092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14675), 1,
      anon_sym_LPAREN2,
  [289099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14677), 1,
      anon_sym_LPAREN2,
  [289106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14679), 1,
      aux_sym_preproc_if_token2,
  [289113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14681), 1,
      anon_sym_RBRACE,
  [289120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14683), 1,
      anon_sym_STAR,
  [289127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_CARET,
  [289134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14685), 1,
      anon_sym_RPAREN,
  [289141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14687), 1,
      anon_sym_DOT_DOT_DOT,
  [289148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14690), 1,
      anon_sym_RPAREN,
  [289155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14692), 1,
      sym_identifier,
  [289162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14694), 1,
      aux_sym_preproc_if_token2,
  [289169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14696), 1,
      sym_identifier,
  [289176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_AMP,
  [289183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14698), 1,
      anon_sym_RPAREN,
  [289190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14700), 1,
      anon_sym_RPAREN,
  [289197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14702), 1,
      sym_identifier,
  [289204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14704), 1,
      anon_sym_DOT_DOT_DOT,
  [289211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14706), 1,
      anon_sym_SEMI,
  [289218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8898), 1,
      anon_sym_SEMI,
  [289225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14708), 1,
      anon_sym_RPAREN,
  [289232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14710), 1,
      anon_sym_RPAREN,
  [289239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14712), 1,
      anon_sym_RPAREN,
  [289246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14714), 1,
      anon_sym_RPAREN,
  [289253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12352), 1,
      anon_sym_SEMI,
  [289260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14716), 1,
      sym_auto,
  [289267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14718), 1,
      anon_sym_RPAREN,
  [289274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9057), 1,
      anon_sym_COLON,
  [289281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9063), 1,
      anon_sym_COLON,
  [289288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11535), 1,
      anon_sym_SEMI,
  [289295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14720), 1,
      anon_sym_SEMI,
  [289302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14722), 1,
      anon_sym_SEMI,
  [289309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14724), 1,
      anon_sym_RPAREN,
  [289316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14726), 1,
      anon_sym_SEMI,
  [289323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8693), 1,
      anon_sym_SEMI,
  [289330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14728), 1,
      anon_sym_STAR,
  [289337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14730), 1,
      aux_sym_preproc_if_token2,
  [289344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14732), 1,
      sym_identifier,
  [289351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_EQ_EQ,
  [289358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14734), 1,
      anon_sym_SEMI,
  [289365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_BANG_EQ,
  [289372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9097), 1,
      anon_sym_RPAREN,
  [289379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8795), 1,
      anon_sym_RBRACE,
  [289386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14736), 1,
      aux_sym_preproc_if_token2,
  [289393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14738), 1,
      sym_auto,
  [289400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14740), 1,
      anon_sym_DQUOTE,
  [289407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11116), 1,
      anon_sym_RBRACE,
  [289414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_GT,
  [289421] = 2,
    ACTIONS(10118), 1,
      sym_comment,
    ACTIONS(14742), 1,
      aux_sym_preproc_include_token2,
  [289428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14744), 1,
      sym_identifier,
  [289435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14746), 1,
      anon_sym_RPAREN,
  [289442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14748), 1,
      anon_sym_SEMI,
  [289449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11688), 1,
      anon_sym_LBRACE,
  [289456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13437), 1,
      anon_sym_RBRACE,
  [289463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14750), 1,
      anon_sym_LPAREN2,
  [289470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14752), 1,
      anon_sym_SEMI,
  [289477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14754), 1,
      anon_sym_COLON,
  [289484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9061), 1,
      anon_sym_COLON,
  [289491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14756), 1,
      anon_sym_RPAREN,
  [289498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 1,
      anon_sym_SEMI,
  [289505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14760), 1,
      anon_sym_LPAREN2,
  [289512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14762), 1,
      anon_sym_LPAREN2,
  [289519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14764), 1,
      sym_identifier,
  [289526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14766), 1,
      anon_sym_RPAREN,
  [289533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9073), 1,
      anon_sym_RPAREN,
  [289540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14768), 1,
      anon_sym_DQUOTE,
  [289547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_SEMI,
  [289554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14770), 1,
      sym_identifier,
  [289561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14772), 1,
      sym_raw_string_content,
  [289568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14774), 1,
      sym_identifier,
  [289575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_PERCENT_EQ,
  [289582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14776), 1,
      anon_sym_RPAREN,
  [289589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14778), 1,
      sym_identifier,
  [289596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14780), 1,
      anon_sym_LPAREN2,
  [289603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14782), 1,
      anon_sym_LPAREN2,
  [289610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14784), 1,
      sym_identifier,
  [289617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14786), 1,
      anon_sym_SEMI,
  [289624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14788), 1,
      aux_sym_preproc_if_token2,
  [289631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      sym_identifier,
  [289638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14792), 1,
      sym_raw_string_content,
  [289645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14794), 1,
      aux_sym_preproc_if_token2,
  [289652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14796), 1,
      anon_sym_RPAREN,
  [289659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14798), 1,
      anon_sym_RPAREN,
  [289666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14800), 1,
      anon_sym_LPAREN2,
  [289673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14802), 1,
      sym_identifier,
  [289680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
  [289687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14804), 1,
      anon_sym_RPAREN,
  [289694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14806), 1,
      sym_identifier,
  [289701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14808), 1,
      sym_raw_string_content,
  [289708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14810), 1,
      anon_sym_RPAREN,
  [289715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_PLUS_EQ,
  [289722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14812), 1,
      anon_sym_LPAREN2,
  [289729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14814), 1,
      sym_identifier,
  [289736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14816), 1,
      anon_sym_SEMI,
  [289743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14818), 1,
      aux_sym_preproc_if_token2,
  [289750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14820), 1,
      sym_identifier,
  [289757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14822), 1,
      sym_raw_string_content,
  [289764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7832), 1,
      sym_identifier,
  [289771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14824), 1,
      anon_sym_LPAREN2,
  [289778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14826), 1,
      sym_identifier,
  [289785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14828), 1,
      sym_identifier,
  [289792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14830), 1,
      sym_identifier,
  [289799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14832), 1,
      sym_raw_string_content,
  [289806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14834), 1,
      anon_sym_SEMI,
  [289813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14836), 1,
      sym_identifier,
  [289820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14838), 1,
      sym_raw_string_content,
  [289827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14840), 1,
      anon_sym_SEMI,
  [289834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14842), 1,
      sym_raw_string_content,
  [289841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14844), 1,
      anon_sym_DQUOTE,
  [289848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14846), 1,
      sym_raw_string_content,
  [289855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14848), 1,
      anon_sym_SEMI,
  [289862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14850), 1,
      sym_raw_string_content,
  [289869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14852), 1,
      anon_sym_RPAREN,
  [289876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14854), 1,
      sym_raw_string_content,
  [289883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14856), 1,
      anon_sym_RPAREN,
  [289890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14858), 1,
      sym_raw_string_content,
  [289897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14860), 1,
      sym_identifier,
  [289904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14862), 1,
      sym_raw_string_content,
  [289911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14864), 1,
      anon_sym_DQUOTE,
  [289918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14866), 1,
      sym_raw_string_content,
  [289925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14868), 1,
      anon_sym_RPAREN,
  [289932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14870), 1,
      sym_raw_string_content,
  [289939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_bitand,
  [289946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14872), 1,
      sym_raw_string_content,
  [289953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14874), 1,
      anon_sym_LPAREN2,
  [289960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14876), 1,
      anon_sym_LPAREN2,
  [289967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14878), 1,
      sym_auto,
  [289974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14880), 1,
      anon_sym_LPAREN2,
  [289981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14882), 1,
      anon_sym_LPAREN2,
  [289988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14884), 1,
      anon_sym_SEMI,
  [289995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14886), 1,
      anon_sym_LPAREN2,
  [290002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14888), 1,
      anon_sym_LPAREN2,
  [290009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14890), 1,
      anon_sym_RPAREN,
  [290016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14892), 1,
      anon_sym_LPAREN2,
  [290023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14894), 1,
      anon_sym_LPAREN2,
  [290030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      anon_sym_DASH_EQ,
  [290037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14896), 1,
      anon_sym_LPAREN2,
  [290044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14898), 1,
      anon_sym_LPAREN2,
  [290051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14900), 1,
      anon_sym_DQUOTE,
  [290058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14902), 1,
      anon_sym_LPAREN2,
  [290065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14904), 1,
      anon_sym_LPAREN2,
  [290072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14906), 1,
      anon_sym_LPAREN2,
  [290079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14908), 1,
      anon_sym_LPAREN2,
  [290086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14910), 1,
      anon_sym_LPAREN2,
  [290093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14912), 1,
      anon_sym_LPAREN2,
  [290100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14914), 1,
      anon_sym_LPAREN2,
  [290107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14916), 1,
      anon_sym_LPAREN2,
  [290114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14918), 1,
      anon_sym_LPAREN2,
  [290121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14920), 1,
      anon_sym_LPAREN2,
  [290128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14922), 1,
      anon_sym_LPAREN2,
  [290135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12195), 1,
      anon_sym_SEMI,
  [290142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14924), 1,
      anon_sym_RBRACE,
  [290149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14926), 1,
      anon_sym_LPAREN2,
  [290156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14928), 1,
      aux_sym_preproc_if_token2,
  [290163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8997), 1,
      anon_sym_SEMI,
  [290170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14930), 1,
      anon_sym_LPAREN2,
  [290177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14932), 1,
      anon_sym_LPAREN2,
  [290184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14934), 1,
      anon_sym_LPAREN2,
  [290191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14936), 1,
      anon_sym_LPAREN2,
  [290198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14938), 1,
      anon_sym_LPAREN2,
  [290205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14940), 1,
      aux_sym_preproc_if_token2,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2365)] = 0,
  [SMALL_STATE(2366)] = 71,
  [SMALL_STATE(2367)] = 142,
  [SMALL_STATE(2368)] = 213,
  [SMALL_STATE(2369)] = 284,
  [SMALL_STATE(2370)] = 361,
  [SMALL_STATE(2371)] = 440,
  [SMALL_STATE(2372)] = 511,
  [SMALL_STATE(2373)] = 590,
  [SMALL_STATE(2374)] = 661,
  [SMALL_STATE(2375)] = 732,
  [SMALL_STATE(2376)] = 811,
  [SMALL_STATE(2377)] = 890,
  [SMALL_STATE(2378)] = 973,
  [SMALL_STATE(2379)] = 1044,
  [SMALL_STATE(2380)] = 1129,
  [SMALL_STATE(2381)] = 1214,
  [SMALL_STATE(2382)] = 1297,
  [SMALL_STATE(2383)] = 1368,
  [SMALL_STATE(2384)] = 1445,
  [SMALL_STATE(2385)] = 1530,
  [SMALL_STATE(2386)] = 1625,
  [SMALL_STATE(2387)] = 1696,
  [SMALL_STATE(2388)] = 1771,
  [SMALL_STATE(2389)] = 1856,
  [SMALL_STATE(2390)] = 1927,
  [SMALL_STATE(2391)] = 1998,
  [SMALL_STATE(2392)] = 2069,
  [SMALL_STATE(2393)] = 2140,
  [SMALL_STATE(2394)] = 2217,
  [SMALL_STATE(2395)] = 2312,
  [SMALL_STATE(2396)] = 2385,
  [SMALL_STATE(2397)] = 2456,
  [SMALL_STATE(2398)] = 2527,
  [SMALL_STATE(2399)] = 2612,
  [SMALL_STATE(2400)] = 2701,
  [SMALL_STATE(2401)] = 2772,
  [SMALL_STATE(2402)] = 2843,
  [SMALL_STATE(2403)] = 2914,
  [SMALL_STATE(2404)] = 2985,
  [SMALL_STATE(2405)] = 3056,
  [SMALL_STATE(2406)] = 3127,
  [SMALL_STATE(2407)] = 3200,
  [SMALL_STATE(2408)] = 3275,
  [SMALL_STATE(2409)] = 3345,
  [SMALL_STATE(2410)] = 3415,
  [SMALL_STATE(2411)] = 3485,
  [SMALL_STATE(2412)] = 3555,
  [SMALL_STATE(2413)] = 3625,
  [SMALL_STATE(2414)] = 3695,
  [SMALL_STATE(2415)] = 3765,
  [SMALL_STATE(2416)] = 3835,
  [SMALL_STATE(2417)] = 3905,
  [SMALL_STATE(2418)] = 3975,
  [SMALL_STATE(2419)] = 4045,
  [SMALL_STATE(2420)] = 4115,
  [SMALL_STATE(2421)] = 4185,
  [SMALL_STATE(2422)] = 4255,
  [SMALL_STATE(2423)] = 4325,
  [SMALL_STATE(2424)] = 4395,
  [SMALL_STATE(2425)] = 4465,
  [SMALL_STATE(2426)] = 4535,
  [SMALL_STATE(2427)] = 4605,
  [SMALL_STATE(2428)] = 4675,
  [SMALL_STATE(2429)] = 4745,
  [SMALL_STATE(2430)] = 4815,
  [SMALL_STATE(2431)] = 4885,
  [SMALL_STATE(2432)] = 4955,
  [SMALL_STATE(2433)] = 5025,
  [SMALL_STATE(2434)] = 5095,
  [SMALL_STATE(2435)] = 5181,
  [SMALL_STATE(2436)] = 5251,
  [SMALL_STATE(2437)] = 5321,
  [SMALL_STATE(2438)] = 5391,
  [SMALL_STATE(2439)] = 5469,
  [SMALL_STATE(2440)] = 5539,
  [SMALL_STATE(2441)] = 5609,
  [SMALL_STATE(2442)] = 5679,
  [SMALL_STATE(2443)] = 5749,
  [SMALL_STATE(2444)] = 5819,
  [SMALL_STATE(2445)] = 5889,
  [SMALL_STATE(2446)] = 5959,
  [SMALL_STATE(2447)] = 6029,
  [SMALL_STATE(2448)] = 6099,
  [SMALL_STATE(2449)] = 6169,
  [SMALL_STATE(2450)] = 6239,
  [SMALL_STATE(2451)] = 6309,
  [SMALL_STATE(2452)] = 6379,
  [SMALL_STATE(2453)] = 6449,
  [SMALL_STATE(2454)] = 6519,
  [SMALL_STATE(2455)] = 6589,
  [SMALL_STATE(2456)] = 6659,
  [SMALL_STATE(2457)] = 6729,
  [SMALL_STATE(2458)] = 6799,
  [SMALL_STATE(2459)] = 6869,
  [SMALL_STATE(2460)] = 6943,
  [SMALL_STATE(2461)] = 7013,
  [SMALL_STATE(2462)] = 7083,
  [SMALL_STATE(2463)] = 7153,
  [SMALL_STATE(2464)] = 7237,
  [SMALL_STATE(2465)] = 7307,
  [SMALL_STATE(2466)] = 7377,
  [SMALL_STATE(2467)] = 7447,
  [SMALL_STATE(2468)] = 7517,
  [SMALL_STATE(2469)] = 7587,
  [SMALL_STATE(2470)] = 7657,
  [SMALL_STATE(2471)] = 7727,
  [SMALL_STATE(2472)] = 7797,
  [SMALL_STATE(2473)] = 7875,
  [SMALL_STATE(2474)] = 7955,
  [SMALL_STATE(2475)] = 8025,
  [SMALL_STATE(2476)] = 8095,
  [SMALL_STATE(2477)] = 8165,
  [SMALL_STATE(2478)] = 8235,
  [SMALL_STATE(2479)] = 8305,
  [SMALL_STATE(2480)] = 8375,
  [SMALL_STATE(2481)] = 8445,
  [SMALL_STATE(2482)] = 8515,
  [SMALL_STATE(2483)] = 8585,
  [SMALL_STATE(2484)] = 8655,
  [SMALL_STATE(2485)] = 8725,
  [SMALL_STATE(2486)] = 8795,
  [SMALL_STATE(2487)] = 8865,
  [SMALL_STATE(2488)] = 8935,
  [SMALL_STATE(2489)] = 9005,
  [SMALL_STATE(2490)] = 9075,
  [SMALL_STATE(2491)] = 9145,
  [SMALL_STATE(2492)] = 9215,
  [SMALL_STATE(2493)] = 9285,
  [SMALL_STATE(2494)] = 9355,
  [SMALL_STATE(2495)] = 9425,
  [SMALL_STATE(2496)] = 9495,
  [SMALL_STATE(2497)] = 9565,
  [SMALL_STATE(2498)] = 9635,
  [SMALL_STATE(2499)] = 9705,
  [SMALL_STATE(2500)] = 9775,
  [SMALL_STATE(2501)] = 9845,
  [SMALL_STATE(2502)] = 9915,
  [SMALL_STATE(2503)] = 9985,
  [SMALL_STATE(2504)] = 10073,
  [SMALL_STATE(2505)] = 10143,
  [SMALL_STATE(2506)] = 10213,
  [SMALL_STATE(2507)] = 10283,
  [SMALL_STATE(2508)] = 10353,
  [SMALL_STATE(2509)] = 10423,
  [SMALL_STATE(2510)] = 10493,
  [SMALL_STATE(2511)] = 10563,
  [SMALL_STATE(2512)] = 10633,
  [SMALL_STATE(2513)] = 10703,
  [SMALL_STATE(2514)] = 10773,
  [SMALL_STATE(2515)] = 10843,
  [SMALL_STATE(2516)] = 10913,
  [SMALL_STATE(2517)] = 10983,
  [SMALL_STATE(2518)] = 11053,
  [SMALL_STATE(2519)] = 11123,
  [SMALL_STATE(2520)] = 11193,
  [SMALL_STATE(2521)] = 11263,
  [SMALL_STATE(2522)] = 11333,
  [SMALL_STATE(2523)] = 11403,
  [SMALL_STATE(2524)] = 11473,
  [SMALL_STATE(2525)] = 11543,
  [SMALL_STATE(2526)] = 11613,
  [SMALL_STATE(2527)] = 11683,
  [SMALL_STATE(2528)] = 11753,
  [SMALL_STATE(2529)] = 11837,
  [SMALL_STATE(2530)] = 11907,
  [SMALL_STATE(2531)] = 11977,
  [SMALL_STATE(2532)] = 12047,
  [SMALL_STATE(2533)] = 12117,
  [SMALL_STATE(2534)] = 12187,
  [SMALL_STATE(2535)] = 12258,
  [SMALL_STATE(2536)] = 12331,
  [SMALL_STATE(2537)] = 12400,
  [SMALL_STATE(2538)] = 12481,
  [SMALL_STATE(2539)] = 12550,
  [SMALL_STATE(2540)] = 12619,
  [SMALL_STATE(2541)] = 12688,
  [SMALL_STATE(2542)] = 12757,
  [SMALL_STATE(2543)] = 12826,
  [SMALL_STATE(2544)] = 12895,
  [SMALL_STATE(2545)] = 12970,
  [SMALL_STATE(2546)] = 13043,
  [SMALL_STATE(2547)] = 13116,
  [SMALL_STATE(2548)] = 13185,
  [SMALL_STATE(2549)] = 13258,
  [SMALL_STATE(2550)] = 13337,
  [SMALL_STATE(2551)] = 13424,
  [SMALL_STATE(2552)] = 13503,
  [SMALL_STATE(2553)] = 13576,
  [SMALL_STATE(2554)] = 13649,
  [SMALL_STATE(2555)] = 13722,
  [SMALL_STATE(2556)] = 13797,
  [SMALL_STATE(2557)] = 13868,
  [SMALL_STATE(2558)] = 13937,
  [SMALL_STATE(2559)] = 14024,
  [SMALL_STATE(2560)] = 14099,
  [SMALL_STATE(2561)] = 14168,
  [SMALL_STATE(2562)] = 14237,
  [SMALL_STATE(2563)] = 14306,
  [SMALL_STATE(2564)] = 14375,
  [SMALL_STATE(2565)] = 14494,
  [SMALL_STATE(2566)] = 14613,
  [SMALL_STATE(2567)] = 14688,
  [SMALL_STATE(2568)] = 14759,
  [SMALL_STATE(2569)] = 14838,
  [SMALL_STATE(2570)] = 14911,
  [SMALL_STATE(2571)] = 14984,
  [SMALL_STATE(2572)] = 15057,
  [SMALL_STATE(2573)] = 15130,
  [SMALL_STATE(2574)] = 15203,
  [SMALL_STATE(2575)] = 15290,
  [SMALL_STATE(2576)] = 15362,
  [SMALL_STATE(2577)] = 15430,
  [SMALL_STATE(2578)] = 15504,
  [SMALL_STATE(2579)] = 15578,
  [SMALL_STATE(2580)] = 15652,
  [SMALL_STATE(2581)] = 15726,
  [SMALL_STATE(2582)] = 15800,
  [SMALL_STATE(2583)] = 15868,
  [SMALL_STATE(2584)] = 15936,
  [SMALL_STATE(2585)] = 16008,
  [SMALL_STATE(2586)] = 16080,
  [SMALL_STATE(2587)] = 16158,
  [SMALL_STATE(2588)] = 16230,
  [SMALL_STATE(2589)] = 16304,
  [SMALL_STATE(2590)] = 16376,
  [SMALL_STATE(2591)] = 16444,
  [SMALL_STATE(2592)] = 16512,
  [SMALL_STATE(2593)] = 16598,
  [SMALL_STATE(2594)] = 16680,
  [SMALL_STATE(2595)] = 16752,
  [SMALL_STATE(2596)] = 16828,
  [SMALL_STATE(2597)] = 16900,
  [SMALL_STATE(2598)] = 16972,
  [SMALL_STATE(2599)] = 17042,
  [SMALL_STATE(2600)] = 17114,
  [SMALL_STATE(2601)] = 17186,
  [SMALL_STATE(2602)] = 17260,
  [SMALL_STATE(2603)] = 17332,
  [SMALL_STATE(2604)] = 17404,
  [SMALL_STATE(2605)] = 17476,
  [SMALL_STATE(2606)] = 17558,
  [SMALL_STATE(2607)] = 17630,
  [SMALL_STATE(2608)] = 17702,
  [SMALL_STATE(2609)] = 17774,
  [SMALL_STATE(2610)] = 17846,
  [SMALL_STATE(2611)] = 17922,
  [SMALL_STATE(2612)] = 17992,
  [SMALL_STATE(2613)] = 18064,
  [SMALL_STATE(2614)] = 18138,
  [SMALL_STATE(2615)] = 18212,
  [SMALL_STATE(2616)] = 18280,
  [SMALL_STATE(2617)] = 18352,
  [SMALL_STATE(2618)] = 18424,
  [SMALL_STATE(2619)] = 18498,
  [SMALL_STATE(2620)] = 18566,
  [SMALL_STATE(2621)] = 18634,
  [SMALL_STATE(2622)] = 18708,
  [SMALL_STATE(2623)] = 18780,
  [SMALL_STATE(2624)] = 18852,
  [SMALL_STATE(2625)] = 18928,
  [SMALL_STATE(2626)] = 18996,
  [SMALL_STATE(2627)] = 19066,
  [SMALL_STATE(2628)] = 19134,
  [SMALL_STATE(2629)] = 19210,
  [SMALL_STATE(2630)] = 19282,
  [SMALL_STATE(2631)] = 19352,
  [SMALL_STATE(2632)] = 19426,
  [SMALL_STATE(2633)] = 19494,
  [SMALL_STATE(2634)] = 19568,
  [SMALL_STATE(2635)] = 19642,
  [SMALL_STATE(2636)] = 19710,
  [SMALL_STATE(2637)] = 19778,
  [SMALL_STATE(2638)] = 19852,
  [SMALL_STATE(2639)] = 19926,
  [SMALL_STATE(2640)] = 19994,
  [SMALL_STATE(2641)] = 20062,
  [SMALL_STATE(2642)] = 20134,
  [SMALL_STATE(2643)] = 20208,
  [SMALL_STATE(2644)] = 20280,
  [SMALL_STATE(2645)] = 20347,
  [SMALL_STATE(2646)] = 20414,
  [SMALL_STATE(2647)] = 20481,
  [SMALL_STATE(2648)] = 20548,
  [SMALL_STATE(2649)] = 20615,
  [SMALL_STATE(2650)] = 20682,
  [SMALL_STATE(2651)] = 20749,
  [SMALL_STATE(2652)] = 20816,
  [SMALL_STATE(2653)] = 20883,
  [SMALL_STATE(2654)] = 20950,
  [SMALL_STATE(2655)] = 21067,
  [SMALL_STATE(2656)] = 21134,
  [SMALL_STATE(2657)] = 21251,
  [SMALL_STATE(2658)] = 21318,
  [SMALL_STATE(2659)] = 21387,
  [SMALL_STATE(2660)] = 21456,
  [SMALL_STATE(2661)] = 21527,
  [SMALL_STATE(2662)] = 21598,
  [SMALL_STATE(2663)] = 21665,
  [SMALL_STATE(2664)] = 21782,
  [SMALL_STATE(2665)] = 21899,
  [SMALL_STATE(2666)] = 21966,
  [SMALL_STATE(2667)] = 22033,
  [SMALL_STATE(2668)] = 22100,
  [SMALL_STATE(2669)] = 22167,
  [SMALL_STATE(2670)] = 22236,
  [SMALL_STATE(2671)] = 22303,
  [SMALL_STATE(2672)] = 22384,
  [SMALL_STATE(2673)] = 22451,
  [SMALL_STATE(2674)] = 22518,
  [SMALL_STATE(2675)] = 22601,
  [SMALL_STATE(2676)] = 22668,
  [SMALL_STATE(2677)] = 22735,
  [SMALL_STATE(2678)] = 22802,
  [SMALL_STATE(2679)] = 22885,
  [SMALL_STATE(2680)] = 22952,
  [SMALL_STATE(2681)] = 23033,
  [SMALL_STATE(2682)] = 23100,
  [SMALL_STATE(2683)] = 23167,
  [SMALL_STATE(2684)] = 23234,
  [SMALL_STATE(2685)] = 23301,
  [SMALL_STATE(2686)] = 23368,
  [SMALL_STATE(2687)] = 23435,
  [SMALL_STATE(2688)] = 23502,
  [SMALL_STATE(2689)] = 23569,
  [SMALL_STATE(2690)] = 23636,
  [SMALL_STATE(2691)] = 23707,
  [SMALL_STATE(2692)] = 23774,
  [SMALL_STATE(2693)] = 23841,
  [SMALL_STATE(2694)] = 23908,
  [SMALL_STATE(2695)] = 23975,
  [SMALL_STATE(2696)] = 24046,
  [SMALL_STATE(2697)] = 24113,
  [SMALL_STATE(2698)] = 24184,
  [SMALL_STATE(2699)] = 24251,
  [SMALL_STATE(2700)] = 24318,
  [SMALL_STATE(2701)] = 24385,
  [SMALL_STATE(2702)] = 24452,
  [SMALL_STATE(2703)] = 24519,
  [SMALL_STATE(2704)] = 24590,
  [SMALL_STATE(2705)] = 24657,
  [SMALL_STATE(2706)] = 24724,
  [SMALL_STATE(2707)] = 24791,
  [SMALL_STATE(2708)] = 24858,
  [SMALL_STATE(2709)] = 24925,
  [SMALL_STATE(2710)] = 25007,
  [SMALL_STATE(2711)] = 25077,
  [SMALL_STATE(2712)] = 25147,
  [SMALL_STATE(2713)] = 25217,
  [SMALL_STATE(2714)] = 25287,
  [SMALL_STATE(2715)] = 25357,
  [SMALL_STATE(2716)] = 25427,
  [SMALL_STATE(2717)] = 25497,
  [SMALL_STATE(2718)] = 25567,
  [SMALL_STATE(2719)] = 25649,
  [SMALL_STATE(2720)] = 25715,
  [SMALL_STATE(2721)] = 25781,
  [SMALL_STATE(2722)] = 25847,
  [SMALL_STATE(2723)] = 25923,
  [SMALL_STATE(2724)] = 25989,
  [SMALL_STATE(2725)] = 26081,
  [SMALL_STATE(2726)] = 26147,
  [SMALL_STATE(2727)] = 26215,
  [SMALL_STATE(2728)] = 26283,
  [SMALL_STATE(2729)] = 26349,
  [SMALL_STATE(2730)] = 26441,
  [SMALL_STATE(2731)] = 26507,
  [SMALL_STATE(2732)] = 26573,
  [SMALL_STATE(2733)] = 26643,
  [SMALL_STATE(2734)] = 26713,
  [SMALL_STATE(2735)] = 26779,
  [SMALL_STATE(2736)] = 26845,
  [SMALL_STATE(2737)] = 26937,
  [SMALL_STATE(2738)] = 27003,
  [SMALL_STATE(2739)] = 27069,
  [SMALL_STATE(2740)] = 27135,
  [SMALL_STATE(2741)] = 27201,
  [SMALL_STATE(2742)] = 27267,
  [SMALL_STATE(2743)] = 27359,
  [SMALL_STATE(2744)] = 27425,
  [SMALL_STATE(2745)] = 27497,
  [SMALL_STATE(2746)] = 27589,
  [SMALL_STATE(2747)] = 27671,
  [SMALL_STATE(2748)] = 27737,
  [SMALL_STATE(2749)] = 27829,
  [SMALL_STATE(2750)] = 27905,
  [SMALL_STATE(2751)] = 27987,
  [SMALL_STATE(2752)] = 28053,
  [SMALL_STATE(2753)] = 28119,
  [SMALL_STATE(2754)] = 28187,
  [SMALL_STATE(2755)] = 28257,
  [SMALL_STATE(2756)] = 28327,
  [SMALL_STATE(2757)] = 28399,
  [SMALL_STATE(2758)] = 28469,
  [SMALL_STATE(2759)] = 28561,
  [SMALL_STATE(2760)] = 28627,
  [SMALL_STATE(2761)] = 28693,
  [SMALL_STATE(2762)] = 28769,
  [SMALL_STATE(2763)] = 28834,
  [SMALL_STATE(2764)] = 28899,
  [SMALL_STATE(2765)] = 28964,
  [SMALL_STATE(2766)] = 29029,
  [SMALL_STATE(2767)] = 29112,
  [SMALL_STATE(2768)] = 29177,
  [SMALL_STATE(2769)] = 29242,
  [SMALL_STATE(2770)] = 29307,
  [SMALL_STATE(2771)] = 29390,
  [SMALL_STATE(2772)] = 29473,
  [SMALL_STATE(2773)] = 29582,
  [SMALL_STATE(2774)] = 29691,
  [SMALL_STATE(2775)] = 29756,
  [SMALL_STATE(2776)] = 29829,
  [SMALL_STATE(2777)] = 29894,
  [SMALL_STATE(2778)] = 29959,
  [SMALL_STATE(2779)] = 30042,
  [SMALL_STATE(2780)] = 30113,
  [SMALL_STATE(2781)] = 30196,
  [SMALL_STATE(2782)] = 30279,
  [SMALL_STATE(2783)] = 30344,
  [SMALL_STATE(2784)] = 30411,
  [SMALL_STATE(2785)] = 30492,
  [SMALL_STATE(2786)] = 30557,
  [SMALL_STATE(2787)] = 30622,
  [SMALL_STATE(2788)] = 30687,
  [SMALL_STATE(2789)] = 30760,
  [SMALL_STATE(2790)] = 30835,
  [SMALL_STATE(2791)] = 30944,
  [SMALL_STATE(2792)] = 31057,
  [SMALL_STATE(2793)] = 31140,
  [SMALL_STATE(2794)] = 31223,
  [SMALL_STATE(2795)] = 31290,
  [SMALL_STATE(2796)] = 31395,
  [SMALL_STATE(2797)] = 31496,
  [SMALL_STATE(2798)] = 31595,
  [SMALL_STATE(2799)] = 31692,
  [SMALL_STATE(2800)] = 31787,
  [SMALL_STATE(2801)] = 31870,
  [SMALL_STATE(2802)] = 31953,
  [SMALL_STATE(2803)] = 32044,
  [SMALL_STATE(2804)] = 32115,
  [SMALL_STATE(2805)] = 32186,
  [SMALL_STATE(2806)] = 32269,
  [SMALL_STATE(2807)] = 32334,
  [SMALL_STATE(2808)] = 32421,
  [SMALL_STATE(2809)] = 32530,
  [SMALL_STATE(2810)] = 32595,
  [SMALL_STATE(2811)] = 32670,
  [SMALL_STATE(2812)] = 32741,
  [SMALL_STATE(2813)] = 32854,
  [SMALL_STATE(2814)] = 32963,
  [SMALL_STATE(2815)] = 33034,
  [SMALL_STATE(2816)] = 33105,
  [SMALL_STATE(2817)] = 33176,
  [SMALL_STATE(2818)] = 33257,
  [SMALL_STATE(2819)] = 33340,
  [SMALL_STATE(2820)] = 33425,
  [SMALL_STATE(2821)] = 33496,
  [SMALL_STATE(2822)] = 33609,
  [SMALL_STATE(2823)] = 33674,
  [SMALL_STATE(2824)] = 33745,
  [SMALL_STATE(2825)] = 33816,
  [SMALL_STATE(2826)] = 33881,
  [SMALL_STATE(2827)] = 33962,
  [SMALL_STATE(2828)] = 34027,
  [SMALL_STATE(2829)] = 34098,
  [SMALL_STATE(2830)] = 34163,
  [SMALL_STATE(2831)] = 34230,
  [SMALL_STATE(2832)] = 34309,
  [SMALL_STATE(2833)] = 34388,
  [SMALL_STATE(2834)] = 34471,
  [SMALL_STATE(2835)] = 34552,
  [SMALL_STATE(2836)] = 34623,
  [SMALL_STATE(2837)] = 34688,
  [SMALL_STATE(2838)] = 34771,
  [SMALL_STATE(2839)] = 34836,
  [SMALL_STATE(2840)] = 34911,
  [SMALL_STATE(2841)] = 34992,
  [SMALL_STATE(2842)] = 35057,
  [SMALL_STATE(2843)] = 35140,
  [SMALL_STATE(2844)] = 35218,
  [SMALL_STATE(2845)] = 35288,
  [SMALL_STATE(2846)] = 35400,
  [SMALL_STATE(2847)] = 35464,
  [SMALL_STATE(2848)] = 35576,
  [SMALL_STATE(2849)] = 35646,
  [SMALL_STATE(2850)] = 35716,
  [SMALL_STATE(2851)] = 35786,
  [SMALL_STATE(2852)] = 35850,
  [SMALL_STATE(2853)] = 35920,
  [SMALL_STATE(2854)] = 35990,
  [SMALL_STATE(2855)] = 36054,
  [SMALL_STATE(2856)] = 36118,
  [SMALL_STATE(2857)] = 36182,
  [SMALL_STATE(2858)] = 36258,
  [SMALL_STATE(2859)] = 36328,
  [SMALL_STATE(2860)] = 36396,
  [SMALL_STATE(2861)] = 36514,
  [SMALL_STATE(2862)] = 36578,
  [SMALL_STATE(2863)] = 36648,
  [SMALL_STATE(2864)] = 36766,
  [SMALL_STATE(2865)] = 36832,
  [SMALL_STATE(2866)] = 36902,
  [SMALL_STATE(2867)] = 36972,
  [SMALL_STATE(2868)] = 37042,
  [SMALL_STATE(2869)] = 37116,
  [SMALL_STATE(2870)] = 37186,
  [SMALL_STATE(2871)] = 37252,
  [SMALL_STATE(2872)] = 37316,
  [SMALL_STATE(2873)] = 37380,
  [SMALL_STATE(2874)] = 37450,
  [SMALL_STATE(2875)] = 37514,
  [SMALL_STATE(2876)] = 37581,
  [SMALL_STATE(2877)] = 37648,
  [SMALL_STATE(2878)] = 37765,
  [SMALL_STATE(2879)] = 37874,
  [SMALL_STATE(2880)] = 37947,
  [SMALL_STATE(2881)] = 38014,
  [SMALL_STATE(2882)] = 38093,
  [SMALL_STATE(2883)] = 38160,
  [SMALL_STATE(2884)] = 38269,
  [SMALL_STATE(2885)] = 38382,
  [SMALL_STATE(2886)] = 38499,
  [SMALL_STATE(2887)] = 38562,
  [SMALL_STATE(2888)] = 38671,
  [SMALL_STATE(2889)] = 38780,
  [SMALL_STATE(2890)] = 38853,
  [SMALL_STATE(2891)] = 38970,
  [SMALL_STATE(2892)] = 39049,
  [SMALL_STATE(2893)] = 39122,
  [SMALL_STATE(2894)] = 39231,
  [SMALL_STATE(2895)] = 39298,
  [SMALL_STATE(2896)] = 39365,
  [SMALL_STATE(2897)] = 39428,
  [SMALL_STATE(2898)] = 39537,
  [SMALL_STATE(2899)] = 39646,
  [SMALL_STATE(2900)] = 39755,
  [SMALL_STATE(2901)] = 39864,
  [SMALL_STATE(2902)] = 39935,
  [SMALL_STATE(2903)] = 40052,
  [SMALL_STATE(2904)] = 40161,
  [SMALL_STATE(2905)] = 40270,
  [SMALL_STATE(2906)] = 40333,
  [SMALL_STATE(2907)] = 40396,
  [SMALL_STATE(2908)] = 40505,
  [SMALL_STATE(2909)] = 40614,
  [SMALL_STATE(2910)] = 40727,
  [SMALL_STATE(2911)] = 40800,
  [SMALL_STATE(2912)] = 40909,
  [SMALL_STATE(2913)] = 41070,
  [SMALL_STATE(2914)] = 41175,
  [SMALL_STATE(2915)] = 41276,
  [SMALL_STATE(2916)] = 41355,
  [SMALL_STATE(2917)] = 41428,
  [SMALL_STATE(2918)] = 41495,
  [SMALL_STATE(2919)] = 41568,
  [SMALL_STATE(2920)] = 41729,
  [SMALL_STATE(2921)] = 41838,
  [SMALL_STATE(2922)] = 41947,
  [SMALL_STATE(2923)] = 42044,
  [SMALL_STATE(2924)] = 42139,
  [SMALL_STATE(2925)] = 42204,
  [SMALL_STATE(2926)] = 42277,
  [SMALL_STATE(2927)] = 42386,
  [SMALL_STATE(2928)] = 42449,
  [SMALL_STATE(2929)] = 42518,
  [SMALL_STATE(2930)] = 42585,
  [SMALL_STATE(2931)] = 42648,
  [SMALL_STATE(2932)] = 42715,
  [SMALL_STATE(2933)] = 42824,
  [SMALL_STATE(2934)] = 42933,
  [SMALL_STATE(2935)] = 43046,
  [SMALL_STATE(2936)] = 43113,
  [SMALL_STATE(2937)] = 43182,
  [SMALL_STATE(2938)] = 43291,
  [SMALL_STATE(2939)] = 43354,
  [SMALL_STATE(2940)] = 43463,
  [SMALL_STATE(2941)] = 43572,
  [SMALL_STATE(2942)] = 43681,
  [SMALL_STATE(2943)] = 43842,
  [SMALL_STATE(2944)] = 43951,
  [SMALL_STATE(2945)] = 44060,
  [SMALL_STATE(2946)] = 44131,
  [SMALL_STATE(2947)] = 44240,
  [SMALL_STATE(2948)] = 44309,
  [SMALL_STATE(2949)] = 44418,
  [SMALL_STATE(2950)] = 44527,
  [SMALL_STATE(2951)] = 44592,
  [SMALL_STATE(2952)] = 44701,
  [SMALL_STATE(2953)] = 44772,
  [SMALL_STATE(2954)] = 44841,
  [SMALL_STATE(2955)] = 44950,
  [SMALL_STATE(2956)] = 45029,
  [SMALL_STATE(2957)] = 45146,
  [SMALL_STATE(2958)] = 45213,
  [SMALL_STATE(2959)] = 45322,
  [SMALL_STATE(2960)] = 45385,
  [SMALL_STATE(2961)] = 45494,
  [SMALL_STATE(2962)] = 45573,
  [SMALL_STATE(2963)] = 45690,
  [SMALL_STATE(2964)] = 45781,
  [SMALL_STATE(2965)] = 45870,
  [SMALL_STATE(2966)] = 45937,
  [SMALL_STATE(2967)] = 46022,
  [SMALL_STATE(2968)] = 46089,
  [SMALL_STATE(2969)] = 46170,
  [SMALL_STATE(2970)] = 46279,
  [SMALL_STATE(2971)] = 46362,
  [SMALL_STATE(2972)] = 46431,
  [SMALL_STATE(2973)] = 46499,
  [SMALL_STATE(2974)] = 46563,
  [SMALL_STATE(2975)] = 46631,
  [SMALL_STATE(2976)] = 46693,
  [SMALL_STATE(2977)] = 46755,
  [SMALL_STATE(2978)] = 46817,
  [SMALL_STATE(2979)] = 46879,
  [SMALL_STATE(2980)] = 46947,
  [SMALL_STATE(2981)] = 47021,
  [SMALL_STATE(2982)] = 47137,
  [SMALL_STATE(2983)] = 47203,
  [SMALL_STATE(2984)] = 47265,
  [SMALL_STATE(2985)] = 47333,
  [SMALL_STATE(2986)] = 47403,
  [SMALL_STATE(2987)] = 47465,
  [SMALL_STATE(2988)] = 47527,
  [SMALL_STATE(2989)] = 47607,
  [SMALL_STATE(2990)] = 47669,
  [SMALL_STATE(2991)] = 47731,
  [SMALL_STATE(2992)] = 47847,
  [SMALL_STATE(2993)] = 47909,
  [SMALL_STATE(2994)] = 47971,
  [SMALL_STATE(2995)] = 48087,
  [SMALL_STATE(2996)] = 48155,
  [SMALL_STATE(2997)] = 48217,
  [SMALL_STATE(2998)] = 48279,
  [SMALL_STATE(2999)] = 48395,
  [SMALL_STATE(3000)] = 48457,
  [SMALL_STATE(3001)] = 48519,
  [SMALL_STATE(3002)] = 48581,
  [SMALL_STATE(3003)] = 48643,
  [SMALL_STATE(3004)] = 48705,
  [SMALL_STATE(3005)] = 48821,
  [SMALL_STATE(3006)] = 48887,
  [SMALL_STATE(3007)] = 48995,
  [SMALL_STATE(3008)] = 49111,
  [SMALL_STATE(3009)] = 49173,
  [SMALL_STATE(3010)] = 49237,
  [SMALL_STATE(3011)] = 49311,
  [SMALL_STATE(3012)] = 49377,
  [SMALL_STATE(3013)] = 49439,
  [SMALL_STATE(3014)] = 49551,
  [SMALL_STATE(3015)] = 49619,
  [SMALL_STATE(3016)] = 49681,
  [SMALL_STATE(3017)] = 49749,
  [SMALL_STATE(3018)] = 49817,
  [SMALL_STATE(3019)] = 49921,
  [SMALL_STATE(3020)] = 49983,
  [SMALL_STATE(3021)] = 50045,
  [SMALL_STATE(3022)] = 50145,
  [SMALL_STATE(3023)] = 50207,
  [SMALL_STATE(3024)] = 50303,
  [SMALL_STATE(3025)] = 50397,
  [SMALL_STATE(3026)] = 50459,
  [SMALL_STATE(3027)] = 50549,
  [SMALL_STATE(3028)] = 50611,
  [SMALL_STATE(3029)] = 50673,
  [SMALL_STATE(3030)] = 50761,
  [SMALL_STATE(3031)] = 50845,
  [SMALL_STATE(3032)] = 50917,
  [SMALL_STATE(3033)] = 50979,
  [SMALL_STATE(3034)] = 51095,
  [SMALL_STATE(3035)] = 51203,
  [SMALL_STATE(3036)] = 51265,
  [SMALL_STATE(3037)] = 51373,
  [SMALL_STATE(3038)] = 51451,
  [SMALL_STATE(3039)] = 51531,
  [SMALL_STATE(3040)] = 51613,
  [SMALL_STATE(3041)] = 51721,
  [SMALL_STATE(3042)] = 51833,
  [SMALL_STATE(3043)] = 51899,
  [SMALL_STATE(3044)] = 52007,
  [SMALL_STATE(3045)] = 52071,
  [SMALL_STATE(3046)] = 52137,
  [SMALL_STATE(3047)] = 52199,
  [SMALL_STATE(3048)] = 52265,
  [SMALL_STATE(3049)] = 52327,
  [SMALL_STATE(3050)] = 52389,
  [SMALL_STATE(3051)] = 52451,
  [SMALL_STATE(3052)] = 52563,
  [SMALL_STATE(3053)] = 52625,
  [SMALL_STATE(3054)] = 52741,
  [SMALL_STATE(3055)] = 52803,
  [SMALL_STATE(3056)] = 52865,
  [SMALL_STATE(3057)] = 52931,
  [SMALL_STATE(3058)] = 52997,
  [SMALL_STATE(3059)] = 53063,
  [SMALL_STATE(3060)] = 53131,
  [SMALL_STATE(3061)] = 53199,
  [SMALL_STATE(3062)] = 53261,
  [SMALL_STATE(3063)] = 53335,
  [SMALL_STATE(3064)] = 53399,
  [SMALL_STATE(3065)] = 53465,
  [SMALL_STATE(3066)] = 53531,
  [SMALL_STATE(3067)] = 53595,
  [SMALL_STATE(3068)] = 53661,
  [SMALL_STATE(3069)] = 53731,
  [SMALL_STATE(3070)] = 53797,
  [SMALL_STATE(3071)] = 53869,
  [SMALL_STATE(3072)] = 53935,
  [SMALL_STATE(3073)] = 54001,
  [SMALL_STATE(3074)] = 54067,
  [SMALL_STATE(3075)] = 54133,
  [SMALL_STATE(3076)] = 54199,
  [SMALL_STATE(3077)] = 54267,
  [SMALL_STATE(3078)] = 54339,
  [SMALL_STATE(3079)] = 54401,
  [SMALL_STATE(3080)] = 54469,
  [SMALL_STATE(3081)] = 54535,
  [SMALL_STATE(3082)] = 54599,
  [SMALL_STATE(3083)] = 54663,
  [SMALL_STATE(3084)] = 54735,
  [SMALL_STATE(3085)] = 54801,
  [SMALL_STATE(3086)] = 54867,
  [SMALL_STATE(3087)] = 54933,
  [SMALL_STATE(3088)] = 55049,
  [SMALL_STATE(3089)] = 55165,
  [SMALL_STATE(3090)] = 55229,
  [SMALL_STATE(3091)] = 55297,
  [SMALL_STATE(3092)] = 55359,
  [SMALL_STATE(3093)] = 55423,
  [SMALL_STATE(3094)] = 55487,
  [SMALL_STATE(3095)] = 55551,
  [SMALL_STATE(3096)] = 55615,
  [SMALL_STATE(3097)] = 55677,
  [SMALL_STATE(3098)] = 55745,
  [SMALL_STATE(3099)] = 55809,
  [SMALL_STATE(3100)] = 55873,
  [SMALL_STATE(3101)] = 55945,
  [SMALL_STATE(3102)] = 56009,
  [SMALL_STATE(3103)] = 56081,
  [SMALL_STATE(3104)] = 56147,
  [SMALL_STATE(3105)] = 56215,
  [SMALL_STATE(3106)] = 56279,
  [SMALL_STATE(3107)] = 56347,
  [SMALL_STATE(3108)] = 56415,
  [SMALL_STATE(3109)] = 56483,
  [SMALL_STATE(3110)] = 56547,
  [SMALL_STATE(3111)] = 56640,
  [SMALL_STATE(3112)] = 56701,
  [SMALL_STATE(3113)] = 56812,
  [SMALL_STATE(3114)] = 56873,
  [SMALL_STATE(3115)] = 56934,
  [SMALL_STATE(3116)] = 56995,
  [SMALL_STATE(3117)] = 57060,
  [SMALL_STATE(3118)] = 57121,
  [SMALL_STATE(3119)] = 57182,
  [SMALL_STATE(3120)] = 57257,
  [SMALL_STATE(3121)] = 57324,
  [SMALL_STATE(3122)] = 57385,
  [SMALL_STATE(3123)] = 57450,
  [SMALL_STATE(3124)] = 57511,
  [SMALL_STATE(3125)] = 57572,
  [SMALL_STATE(3126)] = 57633,
  [SMALL_STATE(3127)] = 57740,
  [SMALL_STATE(3128)] = 57817,
  [SMALL_STATE(3129)] = 57886,
  [SMALL_STATE(3130)] = 57949,
  [SMALL_STATE(3131)] = 58014,
  [SMALL_STATE(3132)] = 58075,
  [SMALL_STATE(3133)] = 58136,
  [SMALL_STATE(3134)] = 58199,
  [SMALL_STATE(3135)] = 58260,
  [SMALL_STATE(3136)] = 58325,
  [SMALL_STATE(3137)] = 58400,
  [SMALL_STATE(3138)] = 58469,
  [SMALL_STATE(3139)] = 58580,
  [SMALL_STATE(3140)] = 58655,
  [SMALL_STATE(3141)] = 58720,
  [SMALL_STATE(3142)] = 58781,
  [SMALL_STATE(3143)] = 58842,
  [SMALL_STATE(3144)] = 58903,
  [SMALL_STATE(3145)] = 58964,
  [SMALL_STATE(3146)] = 59071,
  [SMALL_STATE(3147)] = 59132,
  [SMALL_STATE(3148)] = 59205,
  [SMALL_STATE(3149)] = 59266,
  [SMALL_STATE(3150)] = 59327,
  [SMALL_STATE(3151)] = 59394,
  [SMALL_STATE(3152)] = 59463,
  [SMALL_STATE(3153)] = 59528,
  [SMALL_STATE(3154)] = 59593,
  [SMALL_STATE(3155)] = 59654,
  [SMALL_STATE(3156)] = 59731,
  [SMALL_STATE(3157)] = 59806,
  [SMALL_STATE(3158)] = 59867,
  [SMALL_STATE(3159)] = 59970,
  [SMALL_STATE(3160)] = 60069,
  [SMALL_STATE(3161)] = 60164,
  [SMALL_STATE(3162)] = 60231,
  [SMALL_STATE(3163)] = 60292,
  [SMALL_STATE(3164)] = 60379,
  [SMALL_STATE(3165)] = 60462,
  [SMALL_STATE(3166)] = 60541,
  [SMALL_STATE(3167)] = 60622,
  [SMALL_STATE(3168)] = 60689,
  [SMALL_STATE(3169)] = 60754,
  [SMALL_STATE(3170)] = 60815,
  [SMALL_STATE(3171)] = 60882,
  [SMALL_STATE(3172)] = 60957,
  [SMALL_STATE(3173)] = 61018,
  [SMALL_STATE(3174)] = 61079,
  [SMALL_STATE(3175)] = 61146,
  [SMALL_STATE(3176)] = 61207,
  [SMALL_STATE(3177)] = 61268,
  [SMALL_STATE(3178)] = 61383,
  [SMALL_STATE(3179)] = 61444,
  [SMALL_STATE(3180)] = 61559,
  [SMALL_STATE(3181)] = 61620,
  [SMALL_STATE(3182)] = 61683,
  [SMALL_STATE(3183)] = 61744,
  [SMALL_STATE(3184)] = 61851,
  [SMALL_STATE(3185)] = 61962,
  [SMALL_STATE(3186)] = 62023,
  [SMALL_STATE(3187)] = 62096,
  [SMALL_STATE(3188)] = 62163,
  [SMALL_STATE(3189)] = 62224,
  [SMALL_STATE(3190)] = 62299,
  [SMALL_STATE(3191)] = 62368,
  [SMALL_STATE(3192)] = 62429,
  [SMALL_STATE(3193)] = 62490,
  [SMALL_STATE(3194)] = 62559,
  [SMALL_STATE(3195)] = 62620,
  [SMALL_STATE(3196)] = 62681,
  [SMALL_STATE(3197)] = 62742,
  [SMALL_STATE(3198)] = 62817,
  [SMALL_STATE(3199)] = 62878,
  [SMALL_STATE(3200)] = 62945,
  [SMALL_STATE(3201)] = 63006,
  [SMALL_STATE(3202)] = 63113,
  [SMALL_STATE(3203)] = 63180,
  [SMALL_STATE(3204)] = 63241,
  [SMALL_STATE(3205)] = 63348,
  [SMALL_STATE(3206)] = 63411,
  [SMALL_STATE(3207)] = 63478,
  [SMALL_STATE(3208)] = 63539,
  [SMALL_STATE(3209)] = 63628,
  [SMALL_STATE(3210)] = 63706,
  [SMALL_STATE(3211)] = 63766,
  [SMALL_STATE(3212)] = 63826,
  [SMALL_STATE(3213)] = 63890,
  [SMALL_STATE(3214)] = 63950,
  [SMALL_STATE(3215)] = 64010,
  [SMALL_STATE(3216)] = 64166,
  [SMALL_STATE(3217)] = 64280,
  [SMALL_STATE(3218)] = 64340,
  [SMALL_STATE(3219)] = 64452,
  [SMALL_STATE(3220)] = 64512,
  [SMALL_STATE(3221)] = 64668,
  [SMALL_STATE(3222)] = 64742,
  [SMALL_STATE(3223)] = 64802,
  [SMALL_STATE(3224)] = 64916,
  [SMALL_STATE(3225)] = 65024,
  [SMALL_STATE(3226)] = 65084,
  [SMALL_STATE(3227)] = 65144,
  [SMALL_STATE(3228)] = 65204,
  [SMALL_STATE(3229)] = 65264,
  [SMALL_STATE(3230)] = 65324,
  [SMALL_STATE(3231)] = 65480,
  [SMALL_STATE(3232)] = 65540,
  [SMALL_STATE(3233)] = 65600,
  [SMALL_STATE(3234)] = 65666,
  [SMALL_STATE(3235)] = 65726,
  [SMALL_STATE(3236)] = 65788,
  [SMALL_STATE(3237)] = 65944,
  [SMALL_STATE(3238)] = 66014,
  [SMALL_STATE(3239)] = 66074,
  [SMALL_STATE(3240)] = 66230,
  [SMALL_STATE(3241)] = 66290,
  [SMALL_STATE(3242)] = 66350,
  [SMALL_STATE(3243)] = 66414,
  [SMALL_STATE(3244)] = 66480,
  [SMALL_STATE(3245)] = 66636,
  [SMALL_STATE(3246)] = 66696,
  [SMALL_STATE(3247)] = 66756,
  [SMALL_STATE(3248)] = 66816,
  [SMALL_STATE(3249)] = 66876,
  [SMALL_STATE(3250)] = 66948,
  [SMALL_STATE(3251)] = 67008,
  [SMALL_STATE(3252)] = 67112,
  [SMALL_STATE(3253)] = 67178,
  [SMALL_STATE(3254)] = 67242,
  [SMALL_STATE(3255)] = 67302,
  [SMALL_STATE(3256)] = 67362,
  [SMALL_STATE(3257)] = 67422,
  [SMALL_STATE(3258)] = 67536,
  [SMALL_STATE(3259)] = 67596,
  [SMALL_STATE(3260)] = 67656,
  [SMALL_STATE(3261)] = 67722,
  [SMALL_STATE(3262)] = 67784,
  [SMALL_STATE(3263)] = 67844,
  [SMALL_STATE(3264)] = 67908,
  [SMALL_STATE(3265)] = 67968,
  [SMALL_STATE(3266)] = 68028,
  [SMALL_STATE(3267)] = 68088,
  [SMALL_STATE(3268)] = 68148,
  [SMALL_STATE(3269)] = 68208,
  [SMALL_STATE(3270)] = 68286,
  [SMALL_STATE(3271)] = 68400,
  [SMALL_STATE(3272)] = 68464,
  [SMALL_STATE(3273)] = 68620,
  [SMALL_STATE(3274)] = 68734,
  [SMALL_STATE(3275)] = 68804,
  [SMALL_STATE(3276)] = 68864,
  [SMALL_STATE(3277)] = 68924,
  [SMALL_STATE(3278)] = 68984,
  [SMALL_STATE(3279)] = 69044,
  [SMALL_STATE(3280)] = 69152,
  [SMALL_STATE(3281)] = 69256,
  [SMALL_STATE(3282)] = 69326,
  [SMALL_STATE(3283)] = 69406,
  [SMALL_STATE(3284)] = 69474,
  [SMALL_STATE(3285)] = 69534,
  [SMALL_STATE(3286)] = 69594,
  [SMALL_STATE(3287)] = 69654,
  [SMALL_STATE(3288)] = 69762,
  [SMALL_STATE(3289)] = 69822,
  [SMALL_STATE(3290)] = 69894,
  [SMALL_STATE(3291)] = 70050,
  [SMALL_STATE(3292)] = 70110,
  [SMALL_STATE(3293)] = 70176,
  [SMALL_STATE(3294)] = 70236,
  [SMALL_STATE(3295)] = 70296,
  [SMALL_STATE(3296)] = 70410,
  [SMALL_STATE(3297)] = 70484,
  [SMALL_STATE(3298)] = 70550,
  [SMALL_STATE(3299)] = 70614,
  [SMALL_STATE(3300)] = 70728,
  [SMALL_STATE(3301)] = 70788,
  [SMALL_STATE(3302)] = 70860,
  [SMALL_STATE(3303)] = 70920,
  [SMALL_STATE(3304)] = 70992,
  [SMALL_STATE(3305)] = 71064,
  [SMALL_STATE(3306)] = 71170,
  [SMALL_STATE(3307)] = 71244,
  [SMALL_STATE(3308)] = 71318,
  [SMALL_STATE(3309)] = 71424,
  [SMALL_STATE(3310)] = 71496,
  [SMALL_STATE(3311)] = 71602,
  [SMALL_STATE(3312)] = 71712,
  [SMALL_STATE(3313)] = 71788,
  [SMALL_STATE(3314)] = 71862,
  [SMALL_STATE(3315)] = 71964,
  [SMALL_STATE(3316)] = 72062,
  [SMALL_STATE(3317)] = 72156,
  [SMALL_STATE(3318)] = 72248,
  [SMALL_STATE(3319)] = 72336,
  [SMALL_STATE(3320)] = 72422,
  [SMALL_STATE(3321)] = 72504,
  [SMALL_STATE(3322)] = 72566,
  [SMALL_STATE(3323)] = 72646,
  [SMALL_STATE(3324)] = 72720,
  [SMALL_STATE(3325)] = 72826,
  [SMALL_STATE(3326)] = 72936,
  [SMALL_STATE(3327)] = 73042,
  [SMALL_STATE(3328)] = 73152,
  [SMALL_STATE(3329)] = 73220,
  [SMALL_STATE(3330)] = 73282,
  [SMALL_STATE(3331)] = 73356,
  [SMALL_STATE(3332)] = 73432,
  [SMALL_STATE(3333)] = 73506,
  [SMALL_STATE(3334)] = 73580,
  [SMALL_STATE(3335)] = 73680,
  [SMALL_STATE(3336)] = 73742,
  [SMALL_STATE(3337)] = 73802,
  [SMALL_STATE(3338)] = 73898,
  [SMALL_STATE(3339)] = 73958,
  [SMALL_STATE(3340)] = 74032,
  [SMALL_STATE(3341)] = 74092,
  [SMALL_STATE(3342)] = 74184,
  [SMALL_STATE(3343)] = 74274,
  [SMALL_STATE(3344)] = 74340,
  [SMALL_STATE(3345)] = 74400,
  [SMALL_STATE(3346)] = 74556,
  [SMALL_STATE(3347)] = 74642,
  [SMALL_STATE(3348)] = 74746,
  [SMALL_STATE(3349)] = 74830,
  [SMALL_STATE(3350)] = 74912,
  [SMALL_STATE(3351)] = 74990,
  [SMALL_STATE(3352)] = 75070,
  [SMALL_STATE(3353)] = 75174,
  [SMALL_STATE(3354)] = 75278,
  [SMALL_STATE(3355)] = 75337,
  [SMALL_STATE(3356)] = 75396,
  [SMALL_STATE(3357)] = 75455,
  [SMALL_STATE(3358)] = 75514,
  [SMALL_STATE(3359)] = 75573,
  [SMALL_STATE(3360)] = 75632,
  [SMALL_STATE(3361)] = 75693,
  [SMALL_STATE(3362)] = 75762,
  [SMALL_STATE(3363)] = 75825,
  [SMALL_STATE(3364)] = 75888,
  [SMALL_STATE(3365)] = 75947,
  [SMALL_STATE(3366)] = 76006,
  [SMALL_STATE(3367)] = 76067,
  [SMALL_STATE(3368)] = 76132,
  [SMALL_STATE(3369)] = 76195,
  [SMALL_STATE(3370)] = 76258,
  [SMALL_STATE(3371)] = 76371,
  [SMALL_STATE(3372)] = 76468,
  [SMALL_STATE(3373)] = 76565,
  [SMALL_STATE(3374)] = 76624,
  [SMALL_STATE(3375)] = 76687,
  [SMALL_STATE(3376)] = 76750,
  [SMALL_STATE(3377)] = 76809,
  [SMALL_STATE(3378)] = 76872,
  [SMALL_STATE(3379)] = 76935,
  [SMALL_STATE(3380)] = 76998,
  [SMALL_STATE(3381)] = 77057,
  [SMALL_STATE(3382)] = 77116,
  [SMALL_STATE(3383)] = 77175,
  [SMALL_STATE(3384)] = 77234,
  [SMALL_STATE(3385)] = 77293,
  [SMALL_STATE(3386)] = 77356,
  [SMALL_STATE(3387)] = 77415,
  [SMALL_STATE(3388)] = 77480,
  [SMALL_STATE(3389)] = 77539,
  [SMALL_STATE(3390)] = 77602,
  [SMALL_STATE(3391)] = 77661,
  [SMALL_STATE(3392)] = 77720,
  [SMALL_STATE(3393)] = 77779,
  [SMALL_STATE(3394)] = 77838,
  [SMALL_STATE(3395)] = 77897,
  [SMALL_STATE(3396)] = 77960,
  [SMALL_STATE(3397)] = 78019,
  [SMALL_STATE(3398)] = 78078,
  [SMALL_STATE(3399)] = 78147,
  [SMALL_STATE(3400)] = 78208,
  [SMALL_STATE(3401)] = 78267,
  [SMALL_STATE(3402)] = 78326,
  [SMALL_STATE(3403)] = 78389,
  [SMALL_STATE(3404)] = 78448,
  [SMALL_STATE(3405)] = 78507,
  [SMALL_STATE(3406)] = 78620,
  [SMALL_STATE(3407)] = 78679,
  [SMALL_STATE(3408)] = 78738,
  [SMALL_STATE(3409)] = 78797,
  [SMALL_STATE(3410)] = 78856,
  [SMALL_STATE(3411)] = 78915,
  [SMALL_STATE(3412)] = 78974,
  [SMALL_STATE(3413)] = 79033,
  [SMALL_STATE(3414)] = 79092,
  [SMALL_STATE(3415)] = 79151,
  [SMALL_STATE(3416)] = 79210,
  [SMALL_STATE(3417)] = 79275,
  [SMALL_STATE(3418)] = 79334,
  [SMALL_STATE(3419)] = 79393,
  [SMALL_STATE(3420)] = 79452,
  [SMALL_STATE(3421)] = 79511,
  [SMALL_STATE(3422)] = 79570,
  [SMALL_STATE(3423)] = 79629,
  [SMALL_STATE(3424)] = 79688,
  [SMALL_STATE(3425)] = 79747,
  [SMALL_STATE(3426)] = 79806,
  [SMALL_STATE(3427)] = 79865,
  [SMALL_STATE(3428)] = 79924,
  [SMALL_STATE(3429)] = 79983,
  [SMALL_STATE(3430)] = 80042,
  [SMALL_STATE(3431)] = 80101,
  [SMALL_STATE(3432)] = 80160,
  [SMALL_STATE(3433)] = 80219,
  [SMALL_STATE(3434)] = 80278,
  [SMALL_STATE(3435)] = 80337,
  [SMALL_STATE(3436)] = 80406,
  [SMALL_STATE(3437)] = 80465,
  [SMALL_STATE(3438)] = 80524,
  [SMALL_STATE(3439)] = 80583,
  [SMALL_STATE(3440)] = 80642,
  [SMALL_STATE(3441)] = 80701,
  [SMALL_STATE(3442)] = 80760,
  [SMALL_STATE(3443)] = 80819,
  [SMALL_STATE(3444)] = 80878,
  [SMALL_STATE(3445)] = 80937,
  [SMALL_STATE(3446)] = 80996,
  [SMALL_STATE(3447)] = 81055,
  [SMALL_STATE(3448)] = 81114,
  [SMALL_STATE(3449)] = 81173,
  [SMALL_STATE(3450)] = 81232,
  [SMALL_STATE(3451)] = 81291,
  [SMALL_STATE(3452)] = 81350,
  [SMALL_STATE(3453)] = 81409,
  [SMALL_STATE(3454)] = 81468,
  [SMALL_STATE(3455)] = 81527,
  [SMALL_STATE(3456)] = 81592,
  [SMALL_STATE(3457)] = 81657,
  [SMALL_STATE(3458)] = 81716,
  [SMALL_STATE(3459)] = 81775,
  [SMALL_STATE(3460)] = 81888,
  [SMALL_STATE(3461)] = 81955,
  [SMALL_STATE(3462)] = 82014,
  [SMALL_STATE(3463)] = 82073,
  [SMALL_STATE(3464)] = 82140,
  [SMALL_STATE(3465)] = 82199,
  [SMALL_STATE(3466)] = 82258,
  [SMALL_STATE(3467)] = 82317,
  [SMALL_STATE(3468)] = 82376,
  [SMALL_STATE(3469)] = 82435,
  [SMALL_STATE(3470)] = 82494,
  [SMALL_STATE(3471)] = 82553,
  [SMALL_STATE(3472)] = 82618,
  [SMALL_STATE(3473)] = 82681,
  [SMALL_STATE(3474)] = 82778,
  [SMALL_STATE(3475)] = 82837,
  [SMALL_STATE(3476)] = 82896,
  [SMALL_STATE(3477)] = 82955,
  [SMALL_STATE(3478)] = 83052,
  [SMALL_STATE(3479)] = 83119,
  [SMALL_STATE(3480)] = 83178,
  [SMALL_STATE(3481)] = 83237,
  [SMALL_STATE(3482)] = 83296,
  [SMALL_STATE(3483)] = 83355,
  [SMALL_STATE(3484)] = 83414,
  [SMALL_STATE(3485)] = 83473,
  [SMALL_STATE(3486)] = 83586,
  [SMALL_STATE(3487)] = 83683,
  [SMALL_STATE(3488)] = 83796,
  [SMALL_STATE(3489)] = 83855,
  [SMALL_STATE(3490)] = 83924,
  [SMALL_STATE(3491)] = 83993,
  [SMALL_STATE(3492)] = 84052,
  [SMALL_STATE(3493)] = 84149,
  [SMALL_STATE(3494)] = 84214,
  [SMALL_STATE(3495)] = 84277,
  [SMALL_STATE(3496)] = 84336,
  [SMALL_STATE(3497)] = 84395,
  [SMALL_STATE(3498)] = 84454,
  [SMALL_STATE(3499)] = 84513,
  [SMALL_STATE(3500)] = 84572,
  [SMALL_STATE(3501)] = 84631,
  [SMALL_STATE(3502)] = 84690,
  [SMALL_STATE(3503)] = 84749,
  [SMALL_STATE(3504)] = 84808,
  [SMALL_STATE(3505)] = 84867,
  [SMALL_STATE(3506)] = 84926,
  [SMALL_STATE(3507)] = 84987,
  [SMALL_STATE(3508)] = 85046,
  [SMALL_STATE(3509)] = 85105,
  [SMALL_STATE(3510)] = 85164,
  [SMALL_STATE(3511)] = 85223,
  [SMALL_STATE(3512)] = 85282,
  [SMALL_STATE(3513)] = 85341,
  [SMALL_STATE(3514)] = 85400,
  [SMALL_STATE(3515)] = 85459,
  [SMALL_STATE(3516)] = 85518,
  [SMALL_STATE(3517)] = 85577,
  [SMALL_STATE(3518)] = 85644,
  [SMALL_STATE(3519)] = 85703,
  [SMALL_STATE(3520)] = 85762,
  [SMALL_STATE(3521)] = 85821,
  [SMALL_STATE(3522)] = 85880,
  [SMALL_STATE(3523)] = 85939,
  [SMALL_STATE(3524)] = 85998,
  [SMALL_STATE(3525)] = 86061,
  [SMALL_STATE(3526)] = 86120,
  [SMALL_STATE(3527)] = 86179,
  [SMALL_STATE(3528)] = 86238,
  [SMALL_STATE(3529)] = 86297,
  [SMALL_STATE(3530)] = 86356,
  [SMALL_STATE(3531)] = 86415,
  [SMALL_STATE(3532)] = 86474,
  [SMALL_STATE(3533)] = 86533,
  [SMALL_STATE(3534)] = 86592,
  [SMALL_STATE(3535)] = 86651,
  [SMALL_STATE(3536)] = 86714,
  [SMALL_STATE(3537)] = 86773,
  [SMALL_STATE(3538)] = 86831,
  [SMALL_STATE(3539)] = 86889,
  [SMALL_STATE(3540)] = 86947,
  [SMALL_STATE(3541)] = 87005,
  [SMALL_STATE(3542)] = 87063,
  [SMALL_STATE(3543)] = 87121,
  [SMALL_STATE(3544)] = 87223,
  [SMALL_STATE(3545)] = 87281,
  [SMALL_STATE(3546)] = 87339,
  [SMALL_STATE(3547)] = 87397,
  [SMALL_STATE(3548)] = 87455,
  [SMALL_STATE(3549)] = 87513,
  [SMALL_STATE(3550)] = 87587,
  [SMALL_STATE(3551)] = 87659,
  [SMALL_STATE(3552)] = 87717,
  [SMALL_STATE(3553)] = 87775,
  [SMALL_STATE(3554)] = 87875,
  [SMALL_STATE(3555)] = 87973,
  [SMALL_STATE(3556)] = 88031,
  [SMALL_STATE(3557)] = 88125,
  [SMALL_STATE(3558)] = 88183,
  [SMALL_STATE(3559)] = 88241,
  [SMALL_STATE(3560)] = 88307,
  [SMALL_STATE(3561)] = 88365,
  [SMALL_STATE(3562)] = 88423,
  [SMALL_STATE(3563)] = 88513,
  [SMALL_STATE(3564)] = 88599,
  [SMALL_STATE(3565)] = 88657,
  [SMALL_STATE(3566)] = 88715,
  [SMALL_STATE(3567)] = 88777,
  [SMALL_STATE(3568)] = 88835,
  [SMALL_STATE(3569)] = 88897,
  [SMALL_STATE(3570)] = 88955,
  [SMALL_STATE(3571)] = 89039,
  [SMALL_STATE(3572)] = 89097,
  [SMALL_STATE(3573)] = 89203,
  [SMALL_STATE(3574)] = 89261,
  [SMALL_STATE(3575)] = 89335,
  [SMALL_STATE(3576)] = 89393,
  [SMALL_STATE(3577)] = 89463,
  [SMALL_STATE(3578)] = 89521,
  [SMALL_STATE(3579)] = 89593,
  [SMALL_STATE(3580)] = 89651,
  [SMALL_STATE(3581)] = 89709,
  [SMALL_STATE(3582)] = 89767,
  [SMALL_STATE(3583)] = 89873,
  [SMALL_STATE(3584)] = 89931,
  [SMALL_STATE(3585)] = 90011,
  [SMALL_STATE(3586)] = 90069,
  [SMALL_STATE(3587)] = 90127,
  [SMALL_STATE(3588)] = 90185,
  [SMALL_STATE(3589)] = 90245,
  [SMALL_STATE(3590)] = 90303,
  [SMALL_STATE(3591)] = 90361,
  [SMALL_STATE(3592)] = 90467,
  [SMALL_STATE(3593)] = 90537,
  [SMALL_STATE(3594)] = 90595,
  [SMALL_STATE(3595)] = 90653,
  [SMALL_STATE(3596)] = 90729,
  [SMALL_STATE(3597)] = 90787,
  [SMALL_STATE(3598)] = 90845,
  [SMALL_STATE(3599)] = 90903,
  [SMALL_STATE(3600)] = 90961,
  [SMALL_STATE(3601)] = 91021,
  [SMALL_STATE(3602)] = 91081,
  [SMALL_STATE(3603)] = 91143,
  [SMALL_STATE(3604)] = 91201,
  [SMALL_STATE(3605)] = 91259,
  [SMALL_STATE(3606)] = 91317,
  [SMALL_STATE(3607)] = 91419,
  [SMALL_STATE(3608)] = 91481,
  [SMALL_STATE(3609)] = 91545,
  [SMALL_STATE(3610)] = 91603,
  [SMALL_STATE(3611)] = 91667,
  [SMALL_STATE(3612)] = 91725,
  [SMALL_STATE(3613)] = 91783,
  [SMALL_STATE(3614)] = 91847,
  [SMALL_STATE(3615)] = 91911,
  [SMALL_STATE(3616)] = 91975,
  [SMALL_STATE(3617)] = 92039,
  [SMALL_STATE(3618)] = 92097,
  [SMALL_STATE(3619)] = 92161,
  [SMALL_STATE(3620)] = 92225,
  [SMALL_STATE(3621)] = 92289,
  [SMALL_STATE(3622)] = 92353,
  [SMALL_STATE(3623)] = 92417,
  [SMALL_STATE(3624)] = 92475,
  [SMALL_STATE(3625)] = 92533,
  [SMALL_STATE(3626)] = 92591,
  [SMALL_STATE(3627)] = 92653,
  [SMALL_STATE(3628)] = 92711,
  [SMALL_STATE(3629)] = 92769,
  [SMALL_STATE(3630)] = 92875,
  [SMALL_STATE(3631)] = 92933,
  [SMALL_STATE(3632)] = 92991,
  [SMALL_STATE(3633)] = 93093,
  [SMALL_STATE(3634)] = 93151,
  [SMALL_STATE(3635)] = 93209,
  [SMALL_STATE(3636)] = 93267,
  [SMALL_STATE(3637)] = 93325,
  [SMALL_STATE(3638)] = 93383,
  [SMALL_STATE(3639)] = 93445,
  [SMALL_STATE(3640)] = 93523,
  [SMALL_STATE(3641)] = 93581,
  [SMALL_STATE(3642)] = 93639,
  [SMALL_STATE(3643)] = 93701,
  [SMALL_STATE(3644)] = 93759,
  [SMALL_STATE(3645)] = 93821,
  [SMALL_STATE(3646)] = 93879,
  [SMALL_STATE(3647)] = 93949,
  [SMALL_STATE(3648)] = 94051,
  [SMALL_STATE(3649)] = 94109,
  [SMALL_STATE(3650)] = 94167,
  [SMALL_STATE(3651)] = 94225,
  [SMALL_STATE(3652)] = 94283,
  [SMALL_STATE(3653)] = 94341,
  [SMALL_STATE(3654)] = 94399,
  [SMALL_STATE(3655)] = 94457,
  [SMALL_STATE(3656)] = 94515,
  [SMALL_STATE(3657)] = 94573,
  [SMALL_STATE(3658)] = 94631,
  [SMALL_STATE(3659)] = 94689,
  [SMALL_STATE(3660)] = 94747,
  [SMALL_STATE(3661)] = 94805,
  [SMALL_STATE(3662)] = 94863,
  [SMALL_STATE(3663)] = 94935,
  [SMALL_STATE(3664)] = 95007,
  [SMALL_STATE(3665)] = 95067,
  [SMALL_STATE(3666)] = 95125,
  [SMALL_STATE(3667)] = 95183,
  [SMALL_STATE(3668)] = 95241,
  [SMALL_STATE(3669)] = 95343,
  [SMALL_STATE(3670)] = 95401,
  [SMALL_STATE(3671)] = 95459,
  [SMALL_STATE(3672)] = 95529,
  [SMALL_STATE(3673)] = 95587,
  [SMALL_STATE(3674)] = 95645,
  [SMALL_STATE(3675)] = 95703,
  [SMALL_STATE(3676)] = 95769,
  [SMALL_STATE(3677)] = 95827,
  [SMALL_STATE(3678)] = 95885,
  [SMALL_STATE(3679)] = 95947,
  [SMALL_STATE(3680)] = 96005,
  [SMALL_STATE(3681)] = 96063,
  [SMALL_STATE(3682)] = 96123,
  [SMALL_STATE(3683)] = 96181,
  [SMALL_STATE(3684)] = 96239,
  [SMALL_STATE(3685)] = 96297,
  [SMALL_STATE(3686)] = 96355,
  [SMALL_STATE(3687)] = 96413,
  [SMALL_STATE(3688)] = 96471,
  [SMALL_STATE(3689)] = 96529,
  [SMALL_STATE(3690)] = 96587,
  [SMALL_STATE(3691)] = 96645,
  [SMALL_STATE(3692)] = 96715,
  [SMALL_STATE(3693)] = 96779,
  [SMALL_STATE(3694)] = 96842,
  [SMALL_STATE(3695)] = 96945,
  [SMALL_STATE(3696)] = 97006,
  [SMALL_STATE(3697)] = 97109,
  [SMALL_STATE(3698)] = 97212,
  [SMALL_STATE(3699)] = 97269,
  [SMALL_STATE(3700)] = 97372,
  [SMALL_STATE(3701)] = 97475,
  [SMALL_STATE(3702)] = 97578,
  [SMALL_STATE(3703)] = 97681,
  [SMALL_STATE(3704)] = 97784,
  [SMALL_STATE(3705)] = 97879,
  [SMALL_STATE(3706)] = 97982,
  [SMALL_STATE(3707)] = 98043,
  [SMALL_STATE(3708)] = 98138,
  [SMALL_STATE(3709)] = 98201,
  [SMALL_STATE(3710)] = 98258,
  [SMALL_STATE(3711)] = 98361,
  [SMALL_STATE(3712)] = 98464,
  [SMALL_STATE(3713)] = 98521,
  [SMALL_STATE(3714)] = 98624,
  [SMALL_STATE(3715)] = 98683,
  [SMALL_STATE(3716)] = 98786,
  [SMALL_STATE(3717)] = 98889,
  [SMALL_STATE(3718)] = 98992,
  [SMALL_STATE(3719)] = 99095,
  [SMALL_STATE(3720)] = 99152,
  [SMALL_STATE(3721)] = 99255,
  [SMALL_STATE(3722)] = 99358,
  [SMALL_STATE(3723)] = 99461,
  [SMALL_STATE(3724)] = 99564,
  [SMALL_STATE(3725)] = 99667,
  [SMALL_STATE(3726)] = 99770,
  [SMALL_STATE(3727)] = 99873,
  [SMALL_STATE(3728)] = 99938,
  [SMALL_STATE(3729)] = 100041,
  [SMALL_STATE(3730)] = 100144,
  [SMALL_STATE(3731)] = 100247,
  [SMALL_STATE(3732)] = 100350,
  [SMALL_STATE(3733)] = 100453,
  [SMALL_STATE(3734)] = 100556,
  [SMALL_STATE(3735)] = 100659,
  [SMALL_STATE(3736)] = 100762,
  [SMALL_STATE(3737)] = 100865,
  [SMALL_STATE(3738)] = 100926,
  [SMALL_STATE(3739)] = 101029,
  [SMALL_STATE(3740)] = 101132,
  [SMALL_STATE(3741)] = 101235,
  [SMALL_STATE(3742)] = 101338,
  [SMALL_STATE(3743)] = 101395,
  [SMALL_STATE(3744)] = 101452,
  [SMALL_STATE(3745)] = 101555,
  [SMALL_STATE(3746)] = 101658,
  [SMALL_STATE(3747)] = 101761,
  [SMALL_STATE(3748)] = 101864,
  [SMALL_STATE(3749)] = 101921,
  [SMALL_STATE(3750)] = 101978,
  [SMALL_STATE(3751)] = 102049,
  [SMALL_STATE(3752)] = 102106,
  [SMALL_STATE(3753)] = 102209,
  [SMALL_STATE(3754)] = 102312,
  [SMALL_STATE(3755)] = 102415,
  [SMALL_STATE(3756)] = 102486,
  [SMALL_STATE(3757)] = 102589,
  [SMALL_STATE(3758)] = 102692,
  [SMALL_STATE(3759)] = 102749,
  [SMALL_STATE(3760)] = 102812,
  [SMALL_STATE(3761)] = 102883,
  [SMALL_STATE(3762)] = 102940,
  [SMALL_STATE(3763)] = 103043,
  [SMALL_STATE(3764)] = 103146,
  [SMALL_STATE(3765)] = 103203,
  [SMALL_STATE(3766)] = 103306,
  [SMALL_STATE(3767)] = 103375,
  [SMALL_STATE(3768)] = 103478,
  [SMALL_STATE(3769)] = 103581,
  [SMALL_STATE(3770)] = 103684,
  [SMALL_STATE(3771)] = 103747,
  [SMALL_STATE(3772)] = 103804,
  [SMALL_STATE(3773)] = 103861,
  [SMALL_STATE(3774)] = 103964,
  [SMALL_STATE(3775)] = 104067,
  [SMALL_STATE(3776)] = 104170,
  [SMALL_STATE(3777)] = 104273,
  [SMALL_STATE(3778)] = 104376,
  [SMALL_STATE(3779)] = 104479,
  [SMALL_STATE(3780)] = 104582,
  [SMALL_STATE(3781)] = 104685,
  [SMALL_STATE(3782)] = 104788,
  [SMALL_STATE(3783)] = 104857,
  [SMALL_STATE(3784)] = 104960,
  [SMALL_STATE(3785)] = 105063,
  [SMALL_STATE(3786)] = 105166,
  [SMALL_STATE(3787)] = 105269,
  [SMALL_STATE(3788)] = 105372,
  [SMALL_STATE(3789)] = 105475,
  [SMALL_STATE(3790)] = 105578,
  [SMALL_STATE(3791)] = 105681,
  [SMALL_STATE(3792)] = 105738,
  [SMALL_STATE(3793)] = 105841,
  [SMALL_STATE(3794)] = 105944,
  [SMALL_STATE(3795)] = 106047,
  [SMALL_STATE(3796)] = 106150,
  [SMALL_STATE(3797)] = 106253,
  [SMALL_STATE(3798)] = 106324,
  [SMALL_STATE(3799)] = 106383,
  [SMALL_STATE(3800)] = 106483,
  [SMALL_STATE(3801)] = 106539,
  [SMALL_STATE(3802)] = 106595,
  [SMALL_STATE(3803)] = 106651,
  [SMALL_STATE(3804)] = 106707,
  [SMALL_STATE(3805)] = 106763,
  [SMALL_STATE(3806)] = 106819,
  [SMALL_STATE(3807)] = 106875,
  [SMALL_STATE(3808)] = 106945,
  [SMALL_STATE(3809)] = 107001,
  [SMALL_STATE(3810)] = 107057,
  [SMALL_STATE(3811)] = 107113,
  [SMALL_STATE(3812)] = 107169,
  [SMALL_STATE(3813)] = 107225,
  [SMALL_STATE(3814)] = 107281,
  [SMALL_STATE(3815)] = 107337,
  [SMALL_STATE(3816)] = 107393,
  [SMALL_STATE(3817)] = 107449,
  [SMALL_STATE(3818)] = 107515,
  [SMALL_STATE(3819)] = 107579,
  [SMALL_STATE(3820)] = 107679,
  [SMALL_STATE(3821)] = 107743,
  [SMALL_STATE(3822)] = 107799,
  [SMALL_STATE(3823)] = 107871,
  [SMALL_STATE(3824)] = 107943,
  [SMALL_STATE(3825)] = 108015,
  [SMALL_STATE(3826)] = 108107,
  [SMALL_STATE(3827)] = 108179,
  [SMALL_STATE(3828)] = 108235,
  [SMALL_STATE(3829)] = 108291,
  [SMALL_STATE(3830)] = 108347,
  [SMALL_STATE(3831)] = 108403,
  [SMALL_STATE(3832)] = 108459,
  [SMALL_STATE(3833)] = 108515,
  [SMALL_STATE(3834)] = 108571,
  [SMALL_STATE(3835)] = 108627,
  [SMALL_STATE(3836)] = 108727,
  [SMALL_STATE(3837)] = 108783,
  [SMALL_STATE(3838)] = 108843,
  [SMALL_STATE(3839)] = 108901,
  [SMALL_STATE(3840)] = 108957,
  [SMALL_STATE(3841)] = 109013,
  [SMALL_STATE(3842)] = 109069,
  [SMALL_STATE(3843)] = 109169,
  [SMALL_STATE(3844)] = 109225,
  [SMALL_STATE(3845)] = 109281,
  [SMALL_STATE(3846)] = 109337,
  [SMALL_STATE(3847)] = 109393,
  [SMALL_STATE(3848)] = 109449,
  [SMALL_STATE(3849)] = 109549,
  [SMALL_STATE(3850)] = 109605,
  [SMALL_STATE(3851)] = 109705,
  [SMALL_STATE(3852)] = 109761,
  [SMALL_STATE(3853)] = 109817,
  [SMALL_STATE(3854)] = 109873,
  [SMALL_STATE(3855)] = 109929,
  [SMALL_STATE(3856)] = 109985,
  [SMALL_STATE(3857)] = 110085,
  [SMALL_STATE(3858)] = 110141,
  [SMALL_STATE(3859)] = 110197,
  [SMALL_STATE(3860)] = 110253,
  [SMALL_STATE(3861)] = 110309,
  [SMALL_STATE(3862)] = 110365,
  [SMALL_STATE(3863)] = 110421,
  [SMALL_STATE(3864)] = 110477,
  [SMALL_STATE(3865)] = 110533,
  [SMALL_STATE(3866)] = 110589,
  [SMALL_STATE(3867)] = 110645,
  [SMALL_STATE(3868)] = 110701,
  [SMALL_STATE(3869)] = 110757,
  [SMALL_STATE(3870)] = 110857,
  [SMALL_STATE(3871)] = 110913,
  [SMALL_STATE(3872)] = 110969,
  [SMALL_STATE(3873)] = 111061,
  [SMALL_STATE(3874)] = 111117,
  [SMALL_STATE(3875)] = 111173,
  [SMALL_STATE(3876)] = 111229,
  [SMALL_STATE(3877)] = 111329,
  [SMALL_STATE(3878)] = 111399,
  [SMALL_STATE(3879)] = 111469,
  [SMALL_STATE(3880)] = 111569,
  [SMALL_STATE(3881)] = 111625,
  [SMALL_STATE(3882)] = 111725,
  [SMALL_STATE(3883)] = 111825,
  [SMALL_STATE(3884)] = 111919,
  [SMALL_STATE(3885)] = 112013,
  [SMALL_STATE(3886)] = 112069,
  [SMALL_STATE(3887)] = 112169,
  [SMALL_STATE(3888)] = 112225,
  [SMALL_STATE(3889)] = 112281,
  [SMALL_STATE(3890)] = 112337,
  [SMALL_STATE(3891)] = 112437,
  [SMALL_STATE(3892)] = 112537,
  [SMALL_STATE(3893)] = 112593,
  [SMALL_STATE(3894)] = 112649,
  [SMALL_STATE(3895)] = 112749,
  [SMALL_STATE(3896)] = 112805,
  [SMALL_STATE(3897)] = 112861,
  [SMALL_STATE(3898)] = 112917,
  [SMALL_STATE(3899)] = 112973,
  [SMALL_STATE(3900)] = 113029,
  [SMALL_STATE(3901)] = 113085,
  [SMALL_STATE(3902)] = 113141,
  [SMALL_STATE(3903)] = 113197,
  [SMALL_STATE(3904)] = 113253,
  [SMALL_STATE(3905)] = 113353,
  [SMALL_STATE(3906)] = 113417,
  [SMALL_STATE(3907)] = 113473,
  [SMALL_STATE(3908)] = 113529,
  [SMALL_STATE(3909)] = 113585,
  [SMALL_STATE(3910)] = 113649,
  [SMALL_STATE(3911)] = 113749,
  [SMALL_STATE(3912)] = 113849,
  [SMALL_STATE(3913)] = 113905,
  [SMALL_STATE(3914)] = 113961,
  [SMALL_STATE(3915)] = 114017,
  [SMALL_STATE(3916)] = 114073,
  [SMALL_STATE(3917)] = 114129,
  [SMALL_STATE(3918)] = 114185,
  [SMALL_STATE(3919)] = 114241,
  [SMALL_STATE(3920)] = 114297,
  [SMALL_STATE(3921)] = 114353,
  [SMALL_STATE(3922)] = 114409,
  [SMALL_STATE(3923)] = 114465,
  [SMALL_STATE(3924)] = 114521,
  [SMALL_STATE(3925)] = 114621,
  [SMALL_STATE(3926)] = 114692,
  [SMALL_STATE(3927)] = 114785,
  [SMALL_STATE(3928)] = 114878,
  [SMALL_STATE(3929)] = 114971,
  [SMALL_STATE(3930)] = 115026,
  [SMALL_STATE(3931)] = 115119,
  [SMALL_STATE(3932)] = 115190,
  [SMALL_STATE(3933)] = 115283,
  [SMALL_STATE(3934)] = 115338,
  [SMALL_STATE(3935)] = 115409,
  [SMALL_STATE(3936)] = 115502,
  [SMALL_STATE(3937)] = 115595,
  [SMALL_STATE(3938)] = 115666,
  [SMALL_STATE(3939)] = 115759,
  [SMALL_STATE(3940)] = 115828,
  [SMALL_STATE(3941)] = 115921,
  [SMALL_STATE(3942)] = 116014,
  [SMALL_STATE(3943)] = 116073,
  [SMALL_STATE(3944)] = 116132,
  [SMALL_STATE(3945)] = 116225,
  [SMALL_STATE(3946)] = 116318,
  [SMALL_STATE(3947)] = 116411,
  [SMALL_STATE(3948)] = 116480,
  [SMALL_STATE(3949)] = 116573,
  [SMALL_STATE(3950)] = 116644,
  [SMALL_STATE(3951)] = 116715,
  [SMALL_STATE(3952)] = 116774,
  [SMALL_STATE(3953)] = 116833,
  [SMALL_STATE(3954)] = 116888,
  [SMALL_STATE(3955)] = 116947,
  [SMALL_STATE(3956)] = 117006,
  [SMALL_STATE(3957)] = 117065,
  [SMALL_STATE(3958)] = 117156,
  [SMALL_STATE(3959)] = 117249,
  [SMALL_STATE(3960)] = 117308,
  [SMALL_STATE(3961)] = 117367,
  [SMALL_STATE(3962)] = 117426,
  [SMALL_STATE(3963)] = 117487,
  [SMALL_STATE(3964)] = 117580,
  [SMALL_STATE(3965)] = 117673,
  [SMALL_STATE(3966)] = 117728,
  [SMALL_STATE(3967)] = 117837,
  [SMALL_STATE(3968)] = 117928,
  [SMALL_STATE(3969)] = 117999,
  [SMALL_STATE(3970)] = 118092,
  [SMALL_STATE(3971)] = 118185,
  [SMALL_STATE(3972)] = 118244,
  [SMALL_STATE(3973)] = 118353,
  [SMALL_STATE(3974)] = 118446,
  [SMALL_STATE(3975)] = 118505,
  [SMALL_STATE(3976)] = 118598,
  [SMALL_STATE(3977)] = 118658,
  [SMALL_STATE(3978)] = 118746,
  [SMALL_STATE(3979)] = 118800,
  [SMALL_STATE(3980)] = 118854,
  [SMALL_STATE(3981)] = 118918,
  [SMALL_STATE(3982)] = 119008,
  [SMALL_STATE(3983)] = 119076,
  [SMALL_STATE(3984)] = 119164,
  [SMALL_STATE(3985)] = 119252,
  [SMALL_STATE(3986)] = 119306,
  [SMALL_STATE(3987)] = 119366,
  [SMALL_STATE(3988)] = 119420,
  [SMALL_STATE(3989)] = 119508,
  [SMALL_STATE(3990)] = 119600,
  [SMALL_STATE(3991)] = 119692,
  [SMALL_STATE(3992)] = 119780,
  [SMALL_STATE(3993)] = 119834,
  [SMALL_STATE(3994)] = 119894,
  [SMALL_STATE(3995)] = 119948,
  [SMALL_STATE(3996)] = 120038,
  [SMALL_STATE(3997)] = 120128,
  [SMALL_STATE(3998)] = 120218,
  [SMALL_STATE(3999)] = 120278,
  [SMALL_STATE(4000)] = 120366,
  [SMALL_STATE(4001)] = 120458,
  [SMALL_STATE(4002)] = 120522,
  [SMALL_STATE(4003)] = 120576,
  [SMALL_STATE(4004)] = 120630,
  [SMALL_STATE(4005)] = 120690,
  [SMALL_STATE(4006)] = 120782,
  [SMALL_STATE(4007)] = 120842,
  [SMALL_STATE(4008)] = 120909,
  [SMALL_STATE(4009)] = 120998,
  [SMALL_STATE(4010)] = 121087,
  [SMALL_STATE(4011)] = 121176,
  [SMALL_STATE(4012)] = 121265,
  [SMALL_STATE(4013)] = 121354,
  [SMALL_STATE(4014)] = 121407,
  [SMALL_STATE(4015)] = 121496,
  [SMALL_STATE(4016)] = 121585,
  [SMALL_STATE(4017)] = 121674,
  [SMALL_STATE(4018)] = 121763,
  [SMALL_STATE(4019)] = 121846,
  [SMALL_STATE(4020)] = 121905,
  [SMALL_STATE(4021)] = 121994,
  [SMALL_STATE(4022)] = 122083,
  [SMALL_STATE(4023)] = 122172,
  [SMALL_STATE(4024)] = 122261,
  [SMALL_STATE(4025)] = 122316,
  [SMALL_STATE(4026)] = 122415,
  [SMALL_STATE(4027)] = 122478,
  [SMALL_STATE(4028)] = 122567,
  [SMALL_STATE(4029)] = 122620,
  [SMALL_STATE(4030)] = 122709,
  [SMALL_STATE(4031)] = 122798,
  [SMALL_STATE(4032)] = 122887,
  [SMALL_STATE(4033)] = 122976,
  [SMALL_STATE(4034)] = 123065,
  [SMALL_STATE(4035)] = 123154,
  [SMALL_STATE(4036)] = 123221,
  [SMALL_STATE(4037)] = 123310,
  [SMALL_STATE(4038)] = 123399,
  [SMALL_STATE(4039)] = 123462,
  [SMALL_STATE(4040)] = 123551,
  [SMALL_STATE(4041)] = 123640,
  [SMALL_STATE(4042)] = 123729,
  [SMALL_STATE(4043)] = 123788,
  [SMALL_STATE(4044)] = 123841,
  [SMALL_STATE(4045)] = 123930,
  [SMALL_STATE(4046)] = 124019,
  [SMALL_STATE(4047)] = 124078,
  [SMALL_STATE(4048)] = 124143,
  [SMALL_STATE(4049)] = 124226,
  [SMALL_STATE(4050)] = 124315,
  [SMALL_STATE(4051)] = 124404,
  [SMALL_STATE(4052)] = 124493,
  [SMALL_STATE(4053)] = 124582,
  [SMALL_STATE(4054)] = 124671,
  [SMALL_STATE(4055)] = 124723,
  [SMALL_STATE(4056)] = 124775,
  [SMALL_STATE(4057)] = 124827,
  [SMALL_STATE(4058)] = 124891,
  [SMALL_STATE(4059)] = 124947,
  [SMALL_STATE(4060)] = 125015,
  [SMALL_STATE(4061)] = 125079,
  [SMALL_STATE(4062)] = 125131,
  [SMALL_STATE(4063)] = 125183,
  [SMALL_STATE(4064)] = 125235,
  [SMALL_STATE(4065)] = 125287,
  [SMALL_STATE(4066)] = 125355,
  [SMALL_STATE(4067)] = 125407,
  [SMALL_STATE(4068)] = 125459,
  [SMALL_STATE(4069)] = 125511,
  [SMALL_STATE(4070)] = 125579,
  [SMALL_STATE(4071)] = 125631,
  [SMALL_STATE(4072)] = 125683,
  [SMALL_STATE(4073)] = 125749,
  [SMALL_STATE(4074)] = 125807,
  [SMALL_STATE(4075)] = 125859,
  [SMALL_STATE(4076)] = 125911,
  [SMALL_STATE(4077)] = 125963,
  [SMALL_STATE(4078)] = 126015,
  [SMALL_STATE(4079)] = 126067,
  [SMALL_STATE(4080)] = 126119,
  [SMALL_STATE(4081)] = 126171,
  [SMALL_STATE(4082)] = 126223,
  [SMALL_STATE(4083)] = 126275,
  [SMALL_STATE(4084)] = 126327,
  [SMALL_STATE(4085)] = 126395,
  [SMALL_STATE(4086)] = 126481,
  [SMALL_STATE(4087)] = 126549,
  [SMALL_STATE(4088)] = 126601,
  [SMALL_STATE(4089)] = 126687,
  [SMALL_STATE(4090)] = 126739,
  [SMALL_STATE(4091)] = 126791,
  [SMALL_STATE(4092)] = 126879,
  [SMALL_STATE(4093)] = 126931,
  [SMALL_STATE(4094)] = 127019,
  [SMALL_STATE(4095)] = 127071,
  [SMALL_STATE(4096)] = 127123,
  [SMALL_STATE(4097)] = 127175,
  [SMALL_STATE(4098)] = 127227,
  [SMALL_STATE(4099)] = 127279,
  [SMALL_STATE(4100)] = 127331,
  [SMALL_STATE(4101)] = 127383,
  [SMALL_STATE(4102)] = 127435,
  [SMALL_STATE(4103)] = 127487,
  [SMALL_STATE(4104)] = 127555,
  [SMALL_STATE(4105)] = 127607,
  [SMALL_STATE(4106)] = 127659,
  [SMALL_STATE(4107)] = 127711,
  [SMALL_STATE(4108)] = 127798,
  [SMALL_STATE(4109)] = 127889,
  [SMALL_STATE(4110)] = 127978,
  [SMALL_STATE(4111)] = 128063,
  [SMALL_STATE(4112)] = 128146,
  [SMALL_STATE(4113)] = 128225,
  [SMALL_STATE(4114)] = 128300,
  [SMALL_STATE(4115)] = 128371,
  [SMALL_STATE(4116)] = 128444,
  [SMALL_STATE(4117)] = 128543,
  [SMALL_STATE(4118)] = 128646,
  [SMALL_STATE(4119)] = 128731,
  [SMALL_STATE(4120)] = 128830,
  [SMALL_STATE(4121)] = 128933,
  [SMALL_STATE(4122)] = 129000,
  [SMALL_STATE(4123)] = 129079,
  [SMALL_STATE(4124)] = 129158,
  [SMALL_STATE(4125)] = 129237,
  [SMALL_STATE(4126)] = 129316,
  [SMALL_STATE(4127)] = 129377,
  [SMALL_STATE(4128)] = 129480,
  [SMALL_STATE(4129)] = 129539,
  [SMALL_STATE(4130)] = 129624,
  [SMALL_STATE(4131)] = 129707,
  [SMALL_STATE(4132)] = 129766,
  [SMALL_STATE(4133)] = 129851,
  [SMALL_STATE(4134)] = 129918,
  [SMALL_STATE(4135)] = 130003,
  [SMALL_STATE(4136)] = 130060,
  [SMALL_STATE(4137)] = 130127,
  [SMALL_STATE(4138)] = 130206,
  [SMALL_STATE(4139)] = 130263,
  [SMALL_STATE(4140)] = 130342,
  [SMALL_STATE(4141)] = 130421,
  [SMALL_STATE(4142)] = 130508,
  [SMALL_STATE(4143)] = 130587,
  [SMALL_STATE(4144)] = 130654,
  [SMALL_STATE(4145)] = 130739,
  [SMALL_STATE(4146)] = 130824,
  [SMALL_STATE(4147)] = 130875,
  [SMALL_STATE(4148)] = 130960,
  [SMALL_STATE(4149)] = 131017,
  [SMALL_STATE(4150)] = 131096,
  [SMALL_STATE(4151)] = 131183,
  [SMALL_STATE(4152)] = 131262,
  [SMALL_STATE(4153)] = 131341,
  [SMALL_STATE(4154)] = 131420,
  [SMALL_STATE(4155)] = 131505,
  [SMALL_STATE(4156)] = 131592,
  [SMALL_STATE(4157)] = 131685,
  [SMALL_STATE(4158)] = 131770,
  [SMALL_STATE(4159)] = 131869,
  [SMALL_STATE(4160)] = 131968,
  [SMALL_STATE(4161)] = 132019,
  [SMALL_STATE(4162)] = 132076,
  [SMALL_STATE(4163)] = 132163,
  [SMALL_STATE(4164)] = 132214,
  [SMALL_STATE(4165)] = 132297,
  [SMALL_STATE(4166)] = 132382,
  [SMALL_STATE(4167)] = 132451,
  [SMALL_STATE(4168)] = 132550,
  [SMALL_STATE(4169)] = 132653,
  [SMALL_STATE(4170)] = 132740,
  [SMALL_STATE(4171)] = 132835,
  [SMALL_STATE(4172)] = 132885,
  [SMALL_STATE(4173)] = 132991,
  [SMALL_STATE(4174)] = 133097,
  [SMALL_STATE(4175)] = 133149,
  [SMALL_STATE(4176)] = 133203,
  [SMALL_STATE(4177)] = 133285,
  [SMALL_STATE(4178)] = 133335,
  [SMALL_STATE(4179)] = 133385,
  [SMALL_STATE(4180)] = 133491,
  [SMALL_STATE(4181)] = 133545,
  [SMALL_STATE(4182)] = 133599,
  [SMALL_STATE(4183)] = 133681,
  [SMALL_STATE(4184)] = 133735,
  [SMALL_STATE(4185)] = 133795,
  [SMALL_STATE(4186)] = 133869,
  [SMALL_STATE(4187)] = 133943,
  [SMALL_STATE(4188)] = 133993,
  [SMALL_STATE(4189)] = 134053,
  [SMALL_STATE(4190)] = 134113,
  [SMALL_STATE(4191)] = 134199,
  [SMALL_STATE(4192)] = 134251,
  [SMALL_STATE(4193)] = 134305,
  [SMALL_STATE(4194)] = 134359,
  [SMALL_STATE(4195)] = 134413,
  [SMALL_STATE(4196)] = 134467,
  [SMALL_STATE(4197)] = 134521,
  [SMALL_STATE(4198)] = 134595,
  [SMALL_STATE(4199)] = 134649,
  [SMALL_STATE(4200)] = 134701,
  [SMALL_STATE(4201)] = 134761,
  [SMALL_STATE(4202)] = 134825,
  [SMALL_STATE(4203)] = 134889,
  [SMALL_STATE(4204)] = 134943,
  [SMALL_STATE(4205)] = 134995,
  [SMALL_STATE(4206)] = 135045,
  [SMALL_STATE(4207)] = 135099,
  [SMALL_STATE(4208)] = 135153,
  [SMALL_STATE(4209)] = 135207,
  [SMALL_STATE(4210)] = 135273,
  [SMALL_STATE(4211)] = 135339,
  [SMALL_STATE(4212)] = 135425,
  [SMALL_STATE(4213)] = 135510,
  [SMALL_STATE(4214)] = 135593,
  [SMALL_STATE(4215)] = 135646,
  [SMALL_STATE(4216)] = 135729,
  [SMALL_STATE(4217)] = 135814,
  [SMALL_STATE(4218)] = 135867,
  [SMALL_STATE(4219)] = 135934,
  [SMALL_STATE(4220)] = 136011,
  [SMALL_STATE(4221)] = 136060,
  [SMALL_STATE(4222)] = 136109,
  [SMALL_STATE(4223)] = 136158,
  [SMALL_STATE(4224)] = 136235,
  [SMALL_STATE(4225)] = 136312,
  [SMALL_STATE(4226)] = 136389,
  [SMALL_STATE(4227)] = 136442,
  [SMALL_STATE(4228)] = 136491,
  [SMALL_STATE(4229)] = 136540,
  [SMALL_STATE(4230)] = 136595,
  [SMALL_STATE(4231)] = 136644,
  [SMALL_STATE(4232)] = 136699,
  [SMALL_STATE(4233)] = 136748,
  [SMALL_STATE(4234)] = 136797,
  [SMALL_STATE(4235)] = 136878,
  [SMALL_STATE(4236)] = 136959,
  [SMALL_STATE(4237)] = 137008,
  [SMALL_STATE(4238)] = 137057,
  [SMALL_STATE(4239)] = 137112,
  [SMALL_STATE(4240)] = 137177,
  [SMALL_STATE(4241)] = 137226,
  [SMALL_STATE(4242)] = 137275,
  [SMALL_STATE(4243)] = 137366,
  [SMALL_STATE(4244)] = 137415,
  [SMALL_STATE(4245)] = 137464,
  [SMALL_STATE(4246)] = 137545,
  [SMALL_STATE(4247)] = 137628,
  [SMALL_STATE(4248)] = 137693,
  [SMALL_STATE(4249)] = 137742,
  [SMALL_STATE(4250)] = 137797,
  [SMALL_STATE(4251)] = 137848,
  [SMALL_STATE(4252)] = 137897,
  [SMALL_STATE(4253)] = 137946,
  [SMALL_STATE(4254)] = 138029,
  [SMALL_STATE(4255)] = 138120,
  [SMALL_STATE(4256)] = 138201,
  [SMALL_STATE(4257)] = 138250,
  [SMALL_STATE(4258)] = 138307,
  [SMALL_STATE(4259)] = 138391,
  [SMALL_STATE(4260)] = 138471,
  [SMALL_STATE(4261)] = 138559,
  [SMALL_STATE(4262)] = 138635,
  [SMALL_STATE(4263)] = 138711,
  [SMALL_STATE(4264)] = 138787,
  [SMALL_STATE(4265)] = 138863,
  [SMALL_STATE(4266)] = 138939,
  [SMALL_STATE(4267)] = 139031,
  [SMALL_STATE(4268)] = 139079,
  [SMALL_STATE(4269)] = 139175,
  [SMALL_STATE(4270)] = 139247,
  [SMALL_STATE(4271)] = 139343,
  [SMALL_STATE(4272)] = 139417,
  [SMALL_STATE(4273)] = 139487,
  [SMALL_STATE(4274)] = 139553,
  [SMALL_STATE(4275)] = 139635,
  [SMALL_STATE(4276)] = 139683,
  [SMALL_STATE(4277)] = 139763,
  [SMALL_STATE(4278)] = 139833,
  [SMALL_STATE(4279)] = 139923,
  [SMALL_STATE(4280)] = 139985,
  [SMALL_STATE(4281)] = 140043,
  [SMALL_STATE(4282)] = 140091,
  [SMALL_STATE(4283)] = 140187,
  [SMALL_STATE(4284)] = 140281,
  [SMALL_STATE(4285)] = 140371,
  [SMALL_STATE(4286)] = 140457,
  [SMALL_STATE(4287)] = 140539,
  [SMALL_STATE(4288)] = 140597,
  [SMALL_STATE(4289)] = 140675,
  [SMALL_STATE(4290)] = 140723,
  [SMALL_STATE(4291)] = 140799,
  [SMALL_STATE(4292)] = 140867,
  [SMALL_STATE(4293)] = 140951,
  [SMALL_STATE(4294)] = 141029,
  [SMALL_STATE(4295)] = 141119,
  [SMALL_STATE(4296)] = 141177,
  [SMALL_STATE(4297)] = 141239,
  [SMALL_STATE(4298)] = 141313,
  [SMALL_STATE(4299)] = 141387,
  [SMALL_STATE(4300)] = 141467,
  [SMALL_STATE(4301)] = 141541,
  [SMALL_STATE(4302)] = 141621,
  [SMALL_STATE(4303)] = 141689,
  [SMALL_STATE(4304)] = 141789,
  [SMALL_STATE(4305)] = 141873,
  [SMALL_STATE(4306)] = 141957,
  [SMALL_STATE(4307)] = 142047,
  [SMALL_STATE(4308)] = 142141,
  [SMALL_STATE(4309)] = 142199,
  [SMALL_STATE(4310)] = 142291,
  [SMALL_STATE(4311)] = 142383,
  [SMALL_STATE(4312)] = 142471,
  [SMALL_STATE(4313)] = 142567,
  [SMALL_STATE(4314)] = 142661,
  [SMALL_STATE(4315)] = 142733,
  [SMALL_STATE(4316)] = 142823,
  [SMALL_STATE(4317)] = 142871,
  [SMALL_STATE(4318)] = 142963,
  [SMALL_STATE(4319)] = 143059,
  [SMALL_STATE(4320)] = 143149,
  [SMALL_STATE(4321)] = 143241,
  [SMALL_STATE(4322)] = 143307,
  [SMALL_STATE(4323)] = 143402,
  [SMALL_STATE(4324)] = 143499,
  [SMALL_STATE(4325)] = 143552,
  [SMALL_STATE(4326)] = 143649,
  [SMALL_STATE(4327)] = 143744,
  [SMALL_STATE(4328)] = 143841,
  [SMALL_STATE(4329)] = 143938,
  [SMALL_STATE(4330)] = 143991,
  [SMALL_STATE(4331)] = 144088,
  [SMALL_STATE(4332)] = 144185,
  [SMALL_STATE(4333)] = 144282,
  [SMALL_STATE(4334)] = 144355,
  [SMALL_STATE(4335)] = 144452,
  [SMALL_STATE(4336)] = 144549,
  [SMALL_STATE(4337)] = 144646,
  [SMALL_STATE(4338)] = 144699,
  [SMALL_STATE(4339)] = 144796,
  [SMALL_STATE(4340)] = 144893,
  [SMALL_STATE(4341)] = 144990,
  [SMALL_STATE(4342)] = 145043,
  [SMALL_STATE(4343)] = 145092,
  [SMALL_STATE(4344)] = 145189,
  [SMALL_STATE(4345)] = 145286,
  [SMALL_STATE(4346)] = 145383,
  [SMALL_STATE(4347)] = 145432,
  [SMALL_STATE(4348)] = 145479,
  [SMALL_STATE(4349)] = 145576,
  [SMALL_STATE(4350)] = 145673,
  [SMALL_STATE(4351)] = 145720,
  [SMALL_STATE(4352)] = 145767,
  [SMALL_STATE(4353)] = 145814,
  [SMALL_STATE(4354)] = 145861,
  [SMALL_STATE(4355)] = 145910,
  [SMALL_STATE(4356)] = 145957,
  [SMALL_STATE(4357)] = 146008,
  [SMALL_STATE(4358)] = 146055,
  [SMALL_STATE(4359)] = 146112,
  [SMALL_STATE(4360)] = 146163,
  [SMALL_STATE(4361)] = 146260,
  [SMALL_STATE(4362)] = 146357,
  [SMALL_STATE(4363)] = 146404,
  [SMALL_STATE(4364)] = 146501,
  [SMALL_STATE(4365)] = 146598,
  [SMALL_STATE(4366)] = 146695,
  [SMALL_STATE(4367)] = 146792,
  [SMALL_STATE(4368)] = 146889,
  [SMALL_STATE(4369)] = 146986,
  [SMALL_STATE(4370)] = 147039,
  [SMALL_STATE(4371)] = 147136,
  [SMALL_STATE(4372)] = 147187,
  [SMALL_STATE(4373)] = 147284,
  [SMALL_STATE(4374)] = 147363,
  [SMALL_STATE(4375)] = 147442,
  [SMALL_STATE(4376)] = 147493,
  [SMALL_STATE(4377)] = 147542,
  [SMALL_STATE(4378)] = 147639,
  [SMALL_STATE(4379)] = 147686,
  [SMALL_STATE(4380)] = 147737,
  [SMALL_STATE(4381)] = 147786,
  [SMALL_STATE(4382)] = 147837,
  [SMALL_STATE(4383)] = 147894,
  [SMALL_STATE(4384)] = 147945,
  [SMALL_STATE(4385)] = 148010,
  [SMALL_STATE(4386)] = 148107,
  [SMALL_STATE(4387)] = 148164,
  [SMALL_STATE(4388)] = 148215,
  [SMALL_STATE(4389)] = 148266,
  [SMALL_STATE(4390)] = 148317,
  [SMALL_STATE(4391)] = 148414,
  [SMALL_STATE(4392)] = 148511,
  [SMALL_STATE(4393)] = 148562,
  [SMALL_STATE(4394)] = 148615,
  [SMALL_STATE(4395)] = 148666,
  [SMALL_STATE(4396)] = 148763,
  [SMALL_STATE(4397)] = 148860,
  [SMALL_STATE(4398)] = 148957,
  [SMALL_STATE(4399)] = 149004,
  [SMALL_STATE(4400)] = 149077,
  [SMALL_STATE(4401)] = 149174,
  [SMALL_STATE(4402)] = 149271,
  [SMALL_STATE(4403)] = 149368,
  [SMALL_STATE(4404)] = 149465,
  [SMALL_STATE(4405)] = 149538,
  [SMALL_STATE(4406)] = 149635,
  [SMALL_STATE(4407)] = 149708,
  [SMALL_STATE(4408)] = 149805,
  [SMALL_STATE(4409)] = 149902,
  [SMALL_STATE(4410)] = 149953,
  [SMALL_STATE(4411)] = 150011,
  [SMALL_STATE(4412)] = 150105,
  [SMALL_STATE(4413)] = 150185,
  [SMALL_STATE(4414)] = 150279,
  [SMALL_STATE(4415)] = 150357,
  [SMALL_STATE(4416)] = 150429,
  [SMALL_STATE(4417)] = 150503,
  [SMALL_STATE(4418)] = 150597,
  [SMALL_STATE(4419)] = 150689,
  [SMALL_STATE(4420)] = 150765,
  [SMALL_STATE(4421)] = 150823,
  [SMALL_STATE(4422)] = 150911,
  [SMALL_STATE(4423)] = 150985,
  [SMALL_STATE(4424)] = 151037,
  [SMALL_STATE(4425)] = 151131,
  [SMALL_STATE(4426)] = 151177,
  [SMALL_STATE(4427)] = 151249,
  [SMALL_STATE(4428)] = 151309,
  [SMALL_STATE(4429)] = 151387,
  [SMALL_STATE(4430)] = 151475,
  [SMALL_STATE(4431)] = 151541,
  [SMALL_STATE(4432)] = 151635,
  [SMALL_STATE(4433)] = 151727,
  [SMALL_STATE(4434)] = 151821,
  [SMALL_STATE(4435)] = 151873,
  [SMALL_STATE(4436)] = 151965,
  [SMALL_STATE(4437)] = 152037,
  [SMALL_STATE(4438)] = 152131,
  [SMALL_STATE(4439)] = 152205,
  [SMALL_STATE(4440)] = 152279,
  [SMALL_STATE(4441)] = 152373,
  [SMALL_STATE(4442)] = 152443,
  [SMALL_STATE(4443)] = 152515,
  [SMALL_STATE(4444)] = 152609,
  [SMALL_STATE(4445)] = 152661,
  [SMALL_STATE(4446)] = 152735,
  [SMALL_STATE(4447)] = 152829,
  [SMALL_STATE(4448)] = 152923,
  [SMALL_STATE(4449)] = 153017,
  [SMALL_STATE(4450)] = 153089,
  [SMALL_STATE(4451)] = 153181,
  [SMALL_STATE(4452)] = 153253,
  [SMALL_STATE(4453)] = 153347,
  [SMALL_STATE(4454)] = 153441,
  [SMALL_STATE(4455)] = 153501,
  [SMALL_STATE(4456)] = 153579,
  [SMALL_STATE(4457)] = 153667,
  [SMALL_STATE(4458)] = 153761,
  [SMALL_STATE(4459)] = 153855,
  [SMALL_STATE(4460)] = 153907,
  [SMALL_STATE(4461)] = 153999,
  [SMALL_STATE(4462)] = 154093,
  [SMALL_STATE(4463)] = 154185,
  [SMALL_STATE(4464)] = 154235,
  [SMALL_STATE(4465)] = 154329,
  [SMALL_STATE(4466)] = 154401,
  [SMALL_STATE(4467)] = 154495,
  [SMALL_STATE(4468)] = 154569,
  [SMALL_STATE(4469)] = 154621,
  [SMALL_STATE(4470)] = 154713,
  [SMALL_STATE(4471)] = 154807,
  [SMALL_STATE(4472)] = 154859,
  [SMALL_STATE(4473)] = 154951,
  [SMALL_STATE(4474)] = 155043,
  [SMALL_STATE(4475)] = 155135,
  [SMALL_STATE(4476)] = 155229,
  [SMALL_STATE(4477)] = 155321,
  [SMALL_STATE(4478)] = 155415,
  [SMALL_STATE(4479)] = 155475,
  [SMALL_STATE(4480)] = 155567,
  [SMALL_STATE(4481)] = 155619,
  [SMALL_STATE(4482)] = 155713,
  [SMALL_STATE(4483)] = 155807,
  [SMALL_STATE(4484)] = 155899,
  [SMALL_STATE(4485)] = 155973,
  [SMALL_STATE(4486)] = 156065,
  [SMALL_STATE(4487)] = 156153,
  [SMALL_STATE(4488)] = 156227,
  [SMALL_STATE(4489)] = 156279,
  [SMALL_STATE(4490)] = 156371,
  [SMALL_STATE(4491)] = 156459,
  [SMALL_STATE(4492)] = 156511,
  [SMALL_STATE(4493)] = 156599,
  [SMALL_STATE(4494)] = 156693,
  [SMALL_STATE(4495)] = 156745,
  [SMALL_STATE(4496)] = 156833,
  [SMALL_STATE(4497)] = 156893,
  [SMALL_STATE(4498)] = 156987,
  [SMALL_STATE(4499)] = 157047,
  [SMALL_STATE(4500)] = 157121,
  [SMALL_STATE(4501)] = 157215,
  [SMALL_STATE(4502)] = 157267,
  [SMALL_STATE(4503)] = 157349,
  [SMALL_STATE(4504)] = 157409,
  [SMALL_STATE(4505)] = 157471,
  [SMALL_STATE(4506)] = 157563,
  [SMALL_STATE(4507)] = 157657,
  [SMALL_STATE(4508)] = 157717,
  [SMALL_STATE(4509)] = 157811,
  [SMALL_STATE(4510)] = 157859,
  [SMALL_STATE(4511)] = 157923,
  [SMALL_STATE(4512)] = 158009,
  [SMALL_STATE(4513)] = 158093,
  [SMALL_STATE(4514)] = 158149,
  [SMALL_STATE(4515)] = 158201,
  [SMALL_STATE(4516)] = 158283,
  [SMALL_STATE(4517)] = 158363,
  [SMALL_STATE(4518)] = 158451,
  [SMALL_STATE(4519)] = 158543,
  [SMALL_STATE(4520)] = 158607,
  [SMALL_STATE(4521)] = 158693,
  [SMALL_STATE(4522)] = 158777,
  [SMALL_STATE(4523)] = 158859,
  [SMALL_STATE(4524)] = 158939,
  [SMALL_STATE(4525)] = 159015,
  [SMALL_STATE(4526)] = 159089,
  [SMALL_STATE(4527)] = 159159,
  [SMALL_STATE(4528)] = 159225,
  [SMALL_STATE(4529)] = 159293,
  [SMALL_STATE(4530)] = 159381,
  [SMALL_STATE(4531)] = 159473,
  [SMALL_STATE(4532)] = 159561,
  [SMALL_STATE(4533)] = 159653,
  [SMALL_STATE(4534)] = 159741,
  [SMALL_STATE(4535)] = 159817,
  [SMALL_STATE(4536)] = 159905,
  [SMALL_STATE(4537)] = 159979,
  [SMALL_STATE(4538)] = 160031,
  [SMALL_STATE(4539)] = 160101,
  [SMALL_STATE(4540)] = 160153,
  [SMALL_STATE(4541)] = 160245,
  [SMALL_STATE(4542)] = 160297,
  [SMALL_STATE(4543)] = 160363,
  [SMALL_STATE(4544)] = 160455,
  [SMALL_STATE(4545)] = 160549,
  [SMALL_STATE(4546)] = 160607,
  [SMALL_STATE(4547)] = 160659,
  [SMALL_STATE(4548)] = 160719,
  [SMALL_STATE(4549)] = 160787,
  [SMALL_STATE(4550)] = 160847,
  [SMALL_STATE(4551)] = 160905,
  [SMALL_STATE(4552)] = 160993,
  [SMALL_STATE(4553)] = 161087,
  [SMALL_STATE(4554)] = 161181,
  [SMALL_STATE(4555)] = 161275,
  [SMALL_STATE(4556)] = 161369,
  [SMALL_STATE(4557)] = 161461,
  [SMALL_STATE(4558)] = 161553,
  [SMALL_STATE(4559)] = 161645,
  [SMALL_STATE(4560)] = 161739,
  [SMALL_STATE(4561)] = 161817,
  [SMALL_STATE(4562)] = 161911,
  [SMALL_STATE(4563)] = 162005,
  [SMALL_STATE(4564)] = 162077,
  [SMALL_STATE(4565)] = 162171,
  [SMALL_STATE(4566)] = 162259,
  [SMALL_STATE(4567)] = 162351,
  [SMALL_STATE(4568)] = 162439,
  [SMALL_STATE(4569)] = 162533,
  [SMALL_STATE(4570)] = 162625,
  [SMALL_STATE(4571)] = 162711,
  [SMALL_STATE(4572)] = 162805,
  [SMALL_STATE(4573)] = 162877,
  [SMALL_STATE(4574)] = 162971,
  [SMALL_STATE(4575)] = 163035,
  [SMALL_STATE(4576)] = 163129,
  [SMALL_STATE(4577)] = 163189,
  [SMALL_STATE(4578)] = 163241,
  [SMALL_STATE(4579)] = 163333,
  [SMALL_STATE(4580)] = 163419,
  [SMALL_STATE(4581)] = 163503,
  [SMALL_STATE(4582)] = 163595,
  [SMALL_STATE(4583)] = 163689,
  [SMALL_STATE(4584)] = 163762,
  [SMALL_STATE(4585)] = 163807,
  [SMALL_STATE(4586)] = 163898,
  [SMALL_STATE(4587)] = 163943,
  [SMALL_STATE(4588)] = 164034,
  [SMALL_STATE(4589)] = 164079,
  [SMALL_STATE(4590)] = 164170,
  [SMALL_STATE(4591)] = 164215,
  [SMALL_STATE(4592)] = 164306,
  [SMALL_STATE(4593)] = 164397,
  [SMALL_STATE(4594)] = 164488,
  [SMALL_STATE(4595)] = 164561,
  [SMALL_STATE(4596)] = 164652,
  [SMALL_STATE(4597)] = 164743,
  [SMALL_STATE(4598)] = 164788,
  [SMALL_STATE(4599)] = 164879,
  [SMALL_STATE(4600)] = 164960,
  [SMALL_STATE(4601)] = 165051,
  [SMALL_STATE(4602)] = 165102,
  [SMALL_STATE(4603)] = 165193,
  [SMALL_STATE(4604)] = 165284,
  [SMALL_STATE(4605)] = 165375,
  [SMALL_STATE(4606)] = 165420,
  [SMALL_STATE(4607)] = 165465,
  [SMALL_STATE(4608)] = 165556,
  [SMALL_STATE(4609)] = 165647,
  [SMALL_STATE(4610)] = 165738,
  [SMALL_STATE(4611)] = 165811,
  [SMALL_STATE(4612)] = 165894,
  [SMALL_STATE(4613)] = 165939,
  [SMALL_STATE(4614)] = 166030,
  [SMALL_STATE(4615)] = 166121,
  [SMALL_STATE(4616)] = 166212,
  [SMALL_STATE(4617)] = 166303,
  [SMALL_STATE(4618)] = 166376,
  [SMALL_STATE(4619)] = 166467,
  [SMALL_STATE(4620)] = 166558,
  [SMALL_STATE(4621)] = 166649,
  [SMALL_STATE(4622)] = 166740,
  [SMALL_STATE(4623)] = 166831,
  [SMALL_STATE(4624)] = 166878,
  [SMALL_STATE(4625)] = 166951,
  [SMALL_STATE(4626)] = 167042,
  [SMALL_STATE(4627)] = 167115,
  [SMALL_STATE(4628)] = 167206,
  [SMALL_STATE(4629)] = 167251,
  [SMALL_STATE(4630)] = 167324,
  [SMALL_STATE(4631)] = 167397,
  [SMALL_STATE(4632)] = 167470,
  [SMALL_STATE(4633)] = 167561,
  [SMALL_STATE(4634)] = 167606,
  [SMALL_STATE(4635)] = 167697,
  [SMALL_STATE(4636)] = 167788,
  [SMALL_STATE(4637)] = 167879,
  [SMALL_STATE(4638)] = 167970,
  [SMALL_STATE(4639)] = 168041,
  [SMALL_STATE(4640)] = 168112,
  [SMALL_STATE(4641)] = 168183,
  [SMALL_STATE(4642)] = 168254,
  [SMALL_STATE(4643)] = 168299,
  [SMALL_STATE(4644)] = 168390,
  [SMALL_STATE(4645)] = 168471,
  [SMALL_STATE(4646)] = 168562,
  [SMALL_STATE(4647)] = 168635,
  [SMALL_STATE(4648)] = 168708,
  [SMALL_STATE(4649)] = 168799,
  [SMALL_STATE(4650)] = 168890,
  [SMALL_STATE(4651)] = 168963,
  [SMALL_STATE(4652)] = 169054,
  [SMALL_STATE(4653)] = 169127,
  [SMALL_STATE(4654)] = 169172,
  [SMALL_STATE(4655)] = 169263,
  [SMALL_STATE(4656)] = 169336,
  [SMALL_STATE(4657)] = 169427,
  [SMALL_STATE(4658)] = 169518,
  [SMALL_STATE(4659)] = 169599,
  [SMALL_STATE(4660)] = 169644,
  [SMALL_STATE(4661)] = 169689,
  [SMALL_STATE(4662)] = 169780,
  [SMALL_STATE(4663)] = 169825,
  [SMALL_STATE(4664)] = 169870,
  [SMALL_STATE(4665)] = 169961,
  [SMALL_STATE(4666)] = 170052,
  [SMALL_STATE(4667)] = 170143,
  [SMALL_STATE(4668)] = 170188,
  [SMALL_STATE(4669)] = 170269,
  [SMALL_STATE(4670)] = 170360,
  [SMALL_STATE(4671)] = 170451,
  [SMALL_STATE(4672)] = 170542,
  [SMALL_STATE(4673)] = 170633,
  [SMALL_STATE(4674)] = 170724,
  [SMALL_STATE(4675)] = 170815,
  [SMALL_STATE(4676)] = 170888,
  [SMALL_STATE(4677)] = 170969,
  [SMALL_STATE(4678)] = 171060,
  [SMALL_STATE(4679)] = 171105,
  [SMALL_STATE(4680)] = 171178,
  [SMALL_STATE(4681)] = 171251,
  [SMALL_STATE(4682)] = 171342,
  [SMALL_STATE(4683)] = 171433,
  [SMALL_STATE(4684)] = 171478,
  [SMALL_STATE(4685)] = 171559,
  [SMALL_STATE(4686)] = 171650,
  [SMALL_STATE(4687)] = 171741,
  [SMALL_STATE(4688)] = 171832,
  [SMALL_STATE(4689)] = 171923,
  [SMALL_STATE(4690)] = 172014,
  [SMALL_STATE(4691)] = 172059,
  [SMALL_STATE(4692)] = 172150,
  [SMALL_STATE(4693)] = 172241,
  [SMALL_STATE(4694)] = 172286,
  [SMALL_STATE(4695)] = 172377,
  [SMALL_STATE(4696)] = 172422,
  [SMALL_STATE(4697)] = 172513,
  [SMALL_STATE(4698)] = 172604,
  [SMALL_STATE(4699)] = 172695,
  [SMALL_STATE(4700)] = 172740,
  [SMALL_STATE(4701)] = 172831,
  [SMALL_STATE(4702)] = 172876,
  [SMALL_STATE(4703)] = 172967,
  [SMALL_STATE(4704)] = 173058,
  [SMALL_STATE(4705)] = 173149,
  [SMALL_STATE(4706)] = 173240,
  [SMALL_STATE(4707)] = 173285,
  [SMALL_STATE(4708)] = 173358,
  [SMALL_STATE(4709)] = 173449,
  [SMALL_STATE(4710)] = 173536,
  [SMALL_STATE(4711)] = 173581,
  [SMALL_STATE(4712)] = 173652,
  [SMALL_STATE(4713)] = 173743,
  [SMALL_STATE(4714)] = 173834,
  [SMALL_STATE(4715)] = 173925,
  [SMALL_STATE(4716)] = 174016,
  [SMALL_STATE(4717)] = 174061,
  [SMALL_STATE(4718)] = 174152,
  [SMALL_STATE(4719)] = 174223,
  [SMALL_STATE(4720)] = 174294,
  [SMALL_STATE(4721)] = 174339,
  [SMALL_STATE(4722)] = 174430,
  [SMALL_STATE(4723)] = 174501,
  [SMALL_STATE(4724)] = 174592,
  [SMALL_STATE(4725)] = 174683,
  [SMALL_STATE(4726)] = 174770,
  [SMALL_STATE(4727)] = 174815,
  [SMALL_STATE(4728)] = 174906,
  [SMALL_STATE(4729)] = 174997,
  [SMALL_STATE(4730)] = 175070,
  [SMALL_STATE(4731)] = 175115,
  [SMALL_STATE(4732)] = 175160,
  [SMALL_STATE(4733)] = 175205,
  [SMALL_STATE(4734)] = 175250,
  [SMALL_STATE(4735)] = 175341,
  [SMALL_STATE(4736)] = 175432,
  [SMALL_STATE(4737)] = 175477,
  [SMALL_STATE(4738)] = 175554,
  [SMALL_STATE(4739)] = 175601,
  [SMALL_STATE(4740)] = 175646,
  [SMALL_STATE(4741)] = 175737,
  [SMALL_STATE(4742)] = 175828,
  [SMALL_STATE(4743)] = 175879,
  [SMALL_STATE(4744)] = 175924,
  [SMALL_STATE(4745)] = 176015,
  [SMALL_STATE(4746)] = 176106,
  [SMALL_STATE(4747)] = 176151,
  [SMALL_STATE(4748)] = 176196,
  [SMALL_STATE(4749)] = 176277,
  [SMALL_STATE(4750)] = 176322,
  [SMALL_STATE(4751)] = 176413,
  [SMALL_STATE(4752)] = 176504,
  [SMALL_STATE(4753)] = 176595,
  [SMALL_STATE(4754)] = 176686,
  [SMALL_STATE(4755)] = 176777,
  [SMALL_STATE(4756)] = 176868,
  [SMALL_STATE(4757)] = 176959,
  [SMALL_STATE(4758)] = 177032,
  [SMALL_STATE(4759)] = 177123,
  [SMALL_STATE(4760)] = 177214,
  [SMALL_STATE(4761)] = 177305,
  [SMALL_STATE(4762)] = 177378,
  [SMALL_STATE(4763)] = 177469,
  [SMALL_STATE(4764)] = 177560,
  [SMALL_STATE(4765)] = 177651,
  [SMALL_STATE(4766)] = 177742,
  [SMALL_STATE(4767)] = 177833,
  [SMALL_STATE(4768)] = 177924,
  [SMALL_STATE(4769)] = 178001,
  [SMALL_STATE(4770)] = 178092,
  [SMALL_STATE(4771)] = 178183,
  [SMALL_STATE(4772)] = 178274,
  [SMALL_STATE(4773)] = 178365,
  [SMALL_STATE(4774)] = 178456,
  [SMALL_STATE(4775)] = 178547,
  [SMALL_STATE(4776)] = 178638,
  [SMALL_STATE(4777)] = 178687,
  [SMALL_STATE(4778)] = 178731,
  [SMALL_STATE(4779)] = 178775,
  [SMALL_STATE(4780)] = 178861,
  [SMALL_STATE(4781)] = 178939,
  [SMALL_STATE(4782)] = 178983,
  [SMALL_STATE(4783)] = 179027,
  [SMALL_STATE(4784)] = 179071,
  [SMALL_STATE(4785)] = 179149,
  [SMALL_STATE(4786)] = 179227,
  [SMALL_STATE(4787)] = 179315,
  [SMALL_STATE(4788)] = 179363,
  [SMALL_STATE(4789)] = 179407,
  [SMALL_STATE(4790)] = 179493,
  [SMALL_STATE(4791)] = 179537,
  [SMALL_STATE(4792)] = 179615,
  [SMALL_STATE(4793)] = 179659,
  [SMALL_STATE(4794)] = 179703,
  [SMALL_STATE(4795)] = 179747,
  [SMALL_STATE(4796)] = 179793,
  [SMALL_STATE(4797)] = 179871,
  [SMALL_STATE(4798)] = 179915,
  [SMALL_STATE(4799)] = 179993,
  [SMALL_STATE(4800)] = 180069,
  [SMALL_STATE(4801)] = 180147,
  [SMALL_STATE(4802)] = 180225,
  [SMALL_STATE(4803)] = 180311,
  [SMALL_STATE(4804)] = 180355,
  [SMALL_STATE(4805)] = 180441,
  [SMALL_STATE(4806)] = 180485,
  [SMALL_STATE(4807)] = 180529,
  [SMALL_STATE(4808)] = 180573,
  [SMALL_STATE(4809)] = 180617,
  [SMALL_STATE(4810)] = 180661,
  [SMALL_STATE(4811)] = 180705,
  [SMALL_STATE(4812)] = 180749,
  [SMALL_STATE(4813)] = 180793,
  [SMALL_STATE(4814)] = 180841,
  [SMALL_STATE(4815)] = 180885,
  [SMALL_STATE(4816)] = 180929,
  [SMALL_STATE(4817)] = 180973,
  [SMALL_STATE(4818)] = 181017,
  [SMALL_STATE(4819)] = 181087,
  [SMALL_STATE(4820)] = 181157,
  [SMALL_STATE(4821)] = 181201,
  [SMALL_STATE(4822)] = 181271,
  [SMALL_STATE(4823)] = 181341,
  [SMALL_STATE(4824)] = 181427,
  [SMALL_STATE(4825)] = 181513,
  [SMALL_STATE(4826)] = 181561,
  [SMALL_STATE(4827)] = 181615,
  [SMALL_STATE(4828)] = 181659,
  [SMALL_STATE(4829)] = 181703,
  [SMALL_STATE(4830)] = 181747,
  [SMALL_STATE(4831)] = 181799,
  [SMALL_STATE(4832)] = 181843,
  [SMALL_STATE(4833)] = 181887,
  [SMALL_STATE(4834)] = 181931,
  [SMALL_STATE(4835)] = 181975,
  [SMALL_STATE(4836)] = 182019,
  [SMALL_STATE(4837)] = 182073,
  [SMALL_STATE(4838)] = 182149,
  [SMALL_STATE(4839)] = 182193,
  [SMALL_STATE(4840)] = 182237,
  [SMALL_STATE(4841)] = 182281,
  [SMALL_STATE(4842)] = 182325,
  [SMALL_STATE(4843)] = 182394,
  [SMALL_STATE(4844)] = 182479,
  [SMALL_STATE(4845)] = 182528,
  [SMALL_STATE(4846)] = 182603,
  [SMALL_STATE(4847)] = 182658,
  [SMALL_STATE(4848)] = 182707,
  [SMALL_STATE(4849)] = 182776,
  [SMALL_STATE(4850)] = 182845,
  [SMALL_STATE(4851)] = 182890,
  [SMALL_STATE(4852)] = 182959,
  [SMALL_STATE(4853)] = 183008,
  [SMALL_STATE(4854)] = 183059,
  [SMALL_STATE(4855)] = 183128,
  [SMALL_STATE(4856)] = 183197,
  [SMALL_STATE(4857)] = 183246,
  [SMALL_STATE(4858)] = 183331,
  [SMALL_STATE(4859)] = 183380,
  [SMALL_STATE(4860)] = 183423,
  [SMALL_STATE(4861)] = 183498,
  [SMALL_STATE(4862)] = 183567,
  [SMALL_STATE(4863)] = 183616,
  [SMALL_STATE(4864)] = 183673,
  [SMALL_STATE(4865)] = 183758,
  [SMALL_STATE(4866)] = 183817,
  [SMALL_STATE(4867)] = 183902,
  [SMALL_STATE(4868)] = 183957,
  [SMALL_STATE(4869)] = 184006,
  [SMALL_STATE(4870)] = 184075,
  [SMALL_STATE(4871)] = 184124,
  [SMALL_STATE(4872)] = 184193,
  [SMALL_STATE(4873)] = 184278,
  [SMALL_STATE(4874)] = 184347,
  [SMALL_STATE(4875)] = 184416,
  [SMALL_STATE(4876)] = 184485,
  [SMALL_STATE(4877)] = 184542,
  [SMALL_STATE(4878)] = 184591,
  [SMALL_STATE(4879)] = 184640,
  [SMALL_STATE(4880)] = 184725,
  [SMALL_STATE(4881)] = 184778,
  [SMALL_STATE(4882)] = 184847,
  [SMALL_STATE(4883)] = 184906,
  [SMALL_STATE(4884)] = 184991,
  [SMALL_STATE(4885)] = 185040,
  [SMALL_STATE(4886)] = 185089,
  [SMALL_STATE(4887)] = 185138,
  [SMALL_STATE(4888)] = 185229,
  [SMALL_STATE(4889)] = 185278,
  [SMALL_STATE(4890)] = 185347,
  [SMALL_STATE(4891)] = 185404,
  [SMALL_STATE(4892)] = 185473,
  [SMALL_STATE(4893)] = 185558,
  [SMALL_STATE(4894)] = 185643,
  [SMALL_STATE(4895)] = 185688,
  [SMALL_STATE(4896)] = 185737,
  [SMALL_STATE(4897)] = 185822,
  [SMALL_STATE(4898)] = 185879,
  [SMALL_STATE(4899)] = 185948,
  [SMALL_STATE(4900)] = 185990,
  [SMALL_STATE(4901)] = 186032,
  [SMALL_STATE(4902)] = 186100,
  [SMALL_STATE(4903)] = 186184,
  [SMALL_STATE(4904)] = 186226,
  [SMALL_STATE(4905)] = 186268,
  [SMALL_STATE(4906)] = 186310,
  [SMALL_STATE(4907)] = 186352,
  [SMALL_STATE(4908)] = 186420,
  [SMALL_STATE(4909)] = 186462,
  [SMALL_STATE(4910)] = 186530,
  [SMALL_STATE(4911)] = 186572,
  [SMALL_STATE(4912)] = 186650,
  [SMALL_STATE(4913)] = 186692,
  [SMALL_STATE(4914)] = 186734,
  [SMALL_STATE(4915)] = 186812,
  [SMALL_STATE(4916)] = 186854,
  [SMALL_STATE(4917)] = 186896,
  [SMALL_STATE(4918)] = 186938,
  [SMALL_STATE(4919)] = 186980,
  [SMALL_STATE(4920)] = 187022,
  [SMALL_STATE(4921)] = 187064,
  [SMALL_STATE(4922)] = 187106,
  [SMALL_STATE(4923)] = 187148,
  [SMALL_STATE(4924)] = 187190,
  [SMALL_STATE(4925)] = 187232,
  [SMALL_STATE(4926)] = 187274,
  [SMALL_STATE(4927)] = 187316,
  [SMALL_STATE(4928)] = 187358,
  [SMALL_STATE(4929)] = 187400,
  [SMALL_STATE(4930)] = 187442,
  [SMALL_STATE(4931)] = 187484,
  [SMALL_STATE(4932)] = 187526,
  [SMALL_STATE(4933)] = 187568,
  [SMALL_STATE(4934)] = 187610,
  [SMALL_STATE(4935)] = 187652,
  [SMALL_STATE(4936)] = 187694,
  [SMALL_STATE(4937)] = 187736,
  [SMALL_STATE(4938)] = 187778,
  [SMALL_STATE(4939)] = 187862,
  [SMALL_STATE(4940)] = 187940,
  [SMALL_STATE(4941)] = 187982,
  [SMALL_STATE(4942)] = 188024,
  [SMALL_STATE(4943)] = 188108,
  [SMALL_STATE(4944)] = 188186,
  [SMALL_STATE(4945)] = 188254,
  [SMALL_STATE(4946)] = 188296,
  [SMALL_STATE(4947)] = 188338,
  [SMALL_STATE(4948)] = 188380,
  [SMALL_STATE(4949)] = 188422,
  [SMALL_STATE(4950)] = 188477,
  [SMALL_STATE(4951)] = 188532,
  [SMALL_STATE(4952)] = 188609,
  [SMALL_STATE(4953)] = 188686,
  [SMALL_STATE(4954)] = 188763,
  [SMALL_STATE(4955)] = 188840,
  [SMALL_STATE(4956)] = 188923,
  [SMALL_STATE(4957)] = 189000,
  [SMALL_STATE(4958)] = 189083,
  [SMALL_STATE(4959)] = 189150,
  [SMALL_STATE(4960)] = 189227,
  [SMALL_STATE(4961)] = 189310,
  [SMALL_STATE(4962)] = 189359,
  [SMALL_STATE(4963)] = 189408,
  [SMALL_STATE(4964)] = 189475,
  [SMALL_STATE(4965)] = 189542,
  [SMALL_STATE(4966)] = 189619,
  [SMALL_STATE(4967)] = 189696,
  [SMALL_STATE(4968)] = 189779,
  [SMALL_STATE(4969)] = 189856,
  [SMALL_STATE(4970)] = 189933,
  [SMALL_STATE(4971)] = 190010,
  [SMALL_STATE(4972)] = 190077,
  [SMALL_STATE(4973)] = 190160,
  [SMALL_STATE(4974)] = 190243,
  [SMALL_STATE(4975)] = 190320,
  [SMALL_STATE(4976)] = 190373,
  [SMALL_STATE(4977)] = 190439,
  [SMALL_STATE(4978)] = 190521,
  [SMALL_STATE(4979)] = 190601,
  [SMALL_STATE(4980)] = 190681,
  [SMALL_STATE(4981)] = 190731,
  [SMALL_STATE(4982)] = 190811,
  [SMALL_STATE(4983)] = 190891,
  [SMALL_STATE(4984)] = 190971,
  [SMALL_STATE(4985)] = 191015,
  [SMALL_STATE(4986)] = 191059,
  [SMALL_STATE(4987)] = 191115,
  [SMALL_STATE(4988)] = 191191,
  [SMALL_STATE(4989)] = 191271,
  [SMALL_STATE(4990)] = 191347,
  [SMALL_STATE(4991)] = 191427,
  [SMALL_STATE(4992)] = 191509,
  [SMALL_STATE(4993)] = 191585,
  [SMALL_STATE(4994)] = 191661,
  [SMALL_STATE(4995)] = 191741,
  [SMALL_STATE(4996)] = 191785,
  [SMALL_STATE(4997)] = 191851,
  [SMALL_STATE(4998)] = 191917,
  [SMALL_STATE(4999)] = 191999,
  [SMALL_STATE(5000)] = 192079,
  [SMALL_STATE(5001)] = 192155,
  [SMALL_STATE(5002)] = 192235,
  [SMALL_STATE(5003)] = 192289,
  [SMALL_STATE(5004)] = 192365,
  [SMALL_STATE(5005)] = 192441,
  [SMALL_STATE(5006)] = 192517,
  [SMALL_STATE(5007)] = 192597,
  [SMALL_STATE(5008)] = 192641,
  [SMALL_STATE(5009)] = 192721,
  [SMALL_STATE(5010)] = 192787,
  [SMALL_STATE(5011)] = 192867,
  [SMALL_STATE(5012)] = 192949,
  [SMALL_STATE(5013)] = 193029,
  [SMALL_STATE(5014)] = 193105,
  [SMALL_STATE(5015)] = 193185,
  [SMALL_STATE(5016)] = 193227,
  [SMALL_STATE(5017)] = 193271,
  [SMALL_STATE(5018)] = 193347,
  [SMALL_STATE(5019)] = 193401,
  [SMALL_STATE(5020)] = 193451,
  [SMALL_STATE(5021)] = 193527,
  [SMALL_STATE(5022)] = 193571,
  [SMALL_STATE(5023)] = 193651,
  [SMALL_STATE(5024)] = 193695,
  [SMALL_STATE(5025)] = 193739,
  [SMALL_STATE(5026)] = 193819,
  [SMALL_STATE(5027)] = 193895,
  [SMALL_STATE(5028)] = 193971,
  [SMALL_STATE(5029)] = 194047,
  [SMALL_STATE(5030)] = 194091,
  [SMALL_STATE(5031)] = 194135,
  [SMALL_STATE(5032)] = 194211,
  [SMALL_STATE(5033)] = 194267,
  [SMALL_STATE(5034)] = 194347,
  [SMALL_STATE(5035)] = 194423,
  [SMALL_STATE(5036)] = 194467,
  [SMALL_STATE(5037)] = 194549,
  [SMALL_STATE(5038)] = 194625,
  [SMALL_STATE(5039)] = 194669,
  [SMALL_STATE(5040)] = 194745,
  [SMALL_STATE(5041)] = 194821,
  [SMALL_STATE(5042)] = 194897,
  [SMALL_STATE(5043)] = 194978,
  [SMALL_STATE(5044)] = 195059,
  [SMALL_STATE(5045)] = 195102,
  [SMALL_STATE(5046)] = 195145,
  [SMALL_STATE(5047)] = 195226,
  [SMALL_STATE(5048)] = 195307,
  [SMALL_STATE(5049)] = 195350,
  [SMALL_STATE(5050)] = 195431,
  [SMALL_STATE(5051)] = 195474,
  [SMALL_STATE(5052)] = 195517,
  [SMALL_STATE(5053)] = 195560,
  [SMALL_STATE(5054)] = 195603,
  [SMALL_STATE(5055)] = 195646,
  [SMALL_STATE(5056)] = 195727,
  [SMALL_STATE(5057)] = 195808,
  [SMALL_STATE(5058)] = 195889,
  [SMALL_STATE(5059)] = 195970,
  [SMALL_STATE(5060)] = 196051,
  [SMALL_STATE(5061)] = 196132,
  [SMALL_STATE(5062)] = 196213,
  [SMALL_STATE(5063)] = 196294,
  [SMALL_STATE(5064)] = 196375,
  [SMALL_STATE(5065)] = 196456,
  [SMALL_STATE(5066)] = 196537,
  [SMALL_STATE(5067)] = 196618,
  [SMALL_STATE(5068)] = 196669,
  [SMALL_STATE(5069)] = 196744,
  [SMALL_STATE(5070)] = 196825,
  [SMALL_STATE(5071)] = 196906,
  [SMALL_STATE(5072)] = 196987,
  [SMALL_STATE(5073)] = 197068,
  [SMALL_STATE(5074)] = 197149,
  [SMALL_STATE(5075)] = 197230,
  [SMALL_STATE(5076)] = 197311,
  [SMALL_STATE(5077)] = 197392,
  [SMALL_STATE(5078)] = 197473,
  [SMALL_STATE(5079)] = 197554,
  [SMALL_STATE(5080)] = 197635,
  [SMALL_STATE(5081)] = 197716,
  [SMALL_STATE(5082)] = 197797,
  [SMALL_STATE(5083)] = 197878,
  [SMALL_STATE(5084)] = 197959,
  [SMALL_STATE(5085)] = 198040,
  [SMALL_STATE(5086)] = 198121,
  [SMALL_STATE(5087)] = 198202,
  [SMALL_STATE(5088)] = 198283,
  [SMALL_STATE(5089)] = 198364,
  [SMALL_STATE(5090)] = 198445,
  [SMALL_STATE(5091)] = 198526,
  [SMALL_STATE(5092)] = 198607,
  [SMALL_STATE(5093)] = 198688,
  [SMALL_STATE(5094)] = 198769,
  [SMALL_STATE(5095)] = 198850,
  [SMALL_STATE(5096)] = 198931,
  [SMALL_STATE(5097)] = 199012,
  [SMALL_STATE(5098)] = 199093,
  [SMALL_STATE(5099)] = 199174,
  [SMALL_STATE(5100)] = 199255,
  [SMALL_STATE(5101)] = 199330,
  [SMALL_STATE(5102)] = 199411,
  [SMALL_STATE(5103)] = 199492,
  [SMALL_STATE(5104)] = 199573,
  [SMALL_STATE(5105)] = 199654,
  [SMALL_STATE(5106)] = 199735,
  [SMALL_STATE(5107)] = 199816,
  [SMALL_STATE(5108)] = 199897,
  [SMALL_STATE(5109)] = 199978,
  [SMALL_STATE(5110)] = 200059,
  [SMALL_STATE(5111)] = 200140,
  [SMALL_STATE(5112)] = 200221,
  [SMALL_STATE(5113)] = 200302,
  [SMALL_STATE(5114)] = 200383,
  [SMALL_STATE(5115)] = 200434,
  [SMALL_STATE(5116)] = 200515,
  [SMALL_STATE(5117)] = 200596,
  [SMALL_STATE(5118)] = 200677,
  [SMALL_STATE(5119)] = 200758,
  [SMALL_STATE(5120)] = 200839,
  [SMALL_STATE(5121)] = 200920,
  [SMALL_STATE(5122)] = 201001,
  [SMALL_STATE(5123)] = 201082,
  [SMALL_STATE(5124)] = 201163,
  [SMALL_STATE(5125)] = 201244,
  [SMALL_STATE(5126)] = 201325,
  [SMALL_STATE(5127)] = 201406,
  [SMALL_STATE(5128)] = 201487,
  [SMALL_STATE(5129)] = 201568,
  [SMALL_STATE(5130)] = 201649,
  [SMALL_STATE(5131)] = 201730,
  [SMALL_STATE(5132)] = 201811,
  [SMALL_STATE(5133)] = 201892,
  [SMALL_STATE(5134)] = 201967,
  [SMALL_STATE(5135)] = 202048,
  [SMALL_STATE(5136)] = 202129,
  [SMALL_STATE(5137)] = 202210,
  [SMALL_STATE(5138)] = 202291,
  [SMALL_STATE(5139)] = 202366,
  [SMALL_STATE(5140)] = 202447,
  [SMALL_STATE(5141)] = 202528,
  [SMALL_STATE(5142)] = 202609,
  [SMALL_STATE(5143)] = 202690,
  [SMALL_STATE(5144)] = 202771,
  [SMALL_STATE(5145)] = 202852,
  [SMALL_STATE(5146)] = 202933,
  [SMALL_STATE(5147)] = 202976,
  [SMALL_STATE(5148)] = 203019,
  [SMALL_STATE(5149)] = 203100,
  [SMALL_STATE(5150)] = 203181,
  [SMALL_STATE(5151)] = 203262,
  [SMALL_STATE(5152)] = 203343,
  [SMALL_STATE(5153)] = 203424,
  [SMALL_STATE(5154)] = 203467,
  [SMALL_STATE(5155)] = 203510,
  [SMALL_STATE(5156)] = 203591,
  [SMALL_STATE(5157)] = 203669,
  [SMALL_STATE(5158)] = 203747,
  [SMALL_STATE(5159)] = 203825,
  [SMALL_STATE(5160)] = 203899,
  [SMALL_STATE(5161)] = 203973,
  [SMALL_STATE(5162)] = 204051,
  [SMALL_STATE(5163)] = 204125,
  [SMALL_STATE(5164)] = 204203,
  [SMALL_STATE(5165)] = 204281,
  [SMALL_STATE(5166)] = 204355,
  [SMALL_STATE(5167)] = 204429,
  [SMALL_STATE(5168)] = 204503,
  [SMALL_STATE(5169)] = 204573,
  [SMALL_STATE(5170)] = 204647,
  [SMALL_STATE(5171)] = 204721,
  [SMALL_STATE(5172)] = 204795,
  [SMALL_STATE(5173)] = 204869,
  [SMALL_STATE(5174)] = 204947,
  [SMALL_STATE(5175)] = 205021,
  [SMALL_STATE(5176)] = 205095,
  [SMALL_STATE(5177)] = 205173,
  [SMALL_STATE(5178)] = 205247,
  [SMALL_STATE(5179)] = 205321,
  [SMALL_STATE(5180)] = 205395,
  [SMALL_STATE(5181)] = 205465,
  [SMALL_STATE(5182)] = 205539,
  [SMALL_STATE(5183)] = 205613,
  [SMALL_STATE(5184)] = 205687,
  [SMALL_STATE(5185)] = 205757,
  [SMALL_STATE(5186)] = 205831,
  [SMALL_STATE(5187)] = 205905,
  [SMALL_STATE(5188)] = 205979,
  [SMALL_STATE(5189)] = 206053,
  [SMALL_STATE(5190)] = 206131,
  [SMALL_STATE(5191)] = 206209,
  [SMALL_STATE(5192)] = 206283,
  [SMALL_STATE(5193)] = 206357,
  [SMALL_STATE(5194)] = 206431,
  [SMALL_STATE(5195)] = 206509,
  [SMALL_STATE(5196)] = 206583,
  [SMALL_STATE(5197)] = 206653,
  [SMALL_STATE(5198)] = 206727,
  [SMALL_STATE(5199)] = 206801,
  [SMALL_STATE(5200)] = 206875,
  [SMALL_STATE(5201)] = 206949,
  [SMALL_STATE(5202)] = 207027,
  [SMALL_STATE(5203)] = 207105,
  [SMALL_STATE(5204)] = 207179,
  [SMALL_STATE(5205)] = 207253,
  [SMALL_STATE(5206)] = 207331,
  [SMALL_STATE(5207)] = 207405,
  [SMALL_STATE(5208)] = 207479,
  [SMALL_STATE(5209)] = 207553,
  [SMALL_STATE(5210)] = 207623,
  [SMALL_STATE(5211)] = 207697,
  [SMALL_STATE(5212)] = 207771,
  [SMALL_STATE(5213)] = 207845,
  [SMALL_STATE(5214)] = 207919,
  [SMALL_STATE(5215)] = 207993,
  [SMALL_STATE(5216)] = 208063,
  [SMALL_STATE(5217)] = 208137,
  [SMALL_STATE(5218)] = 208207,
  [SMALL_STATE(5219)] = 208281,
  [SMALL_STATE(5220)] = 208355,
  [SMALL_STATE(5221)] = 208433,
  [SMALL_STATE(5222)] = 208507,
  [SMALL_STATE(5223)] = 208585,
  [SMALL_STATE(5224)] = 208659,
  [SMALL_STATE(5225)] = 208733,
  [SMALL_STATE(5226)] = 208811,
  [SMALL_STATE(5227)] = 208885,
  [SMALL_STATE(5228)] = 208959,
  [SMALL_STATE(5229)] = 209029,
  [SMALL_STATE(5230)] = 209103,
  [SMALL_STATE(5231)] = 209177,
  [SMALL_STATE(5232)] = 209251,
  [SMALL_STATE(5233)] = 209329,
  [SMALL_STATE(5234)] = 209403,
  [SMALL_STATE(5235)] = 209470,
  [SMALL_STATE(5236)] = 209543,
  [SMALL_STATE(5237)] = 209616,
  [SMALL_STATE(5238)] = 209689,
  [SMALL_STATE(5239)] = 209762,
  [SMALL_STATE(5240)] = 209807,
  [SMALL_STATE(5241)] = 209874,
  [SMALL_STATE(5242)] = 209919,
  [SMALL_STATE(5243)] = 209986,
  [SMALL_STATE(5244)] = 210027,
  [SMALL_STATE(5245)] = 210094,
  [SMALL_STATE(5246)] = 210161,
  [SMALL_STATE(5247)] = 210228,
  [SMALL_STATE(5248)] = 210295,
  [SMALL_STATE(5249)] = 210362,
  [SMALL_STATE(5250)] = 210429,
  [SMALL_STATE(5251)] = 210496,
  [SMALL_STATE(5252)] = 210563,
  [SMALL_STATE(5253)] = 210630,
  [SMALL_STATE(5254)] = 210703,
  [SMALL_STATE(5255)] = 210776,
  [SMALL_STATE(5256)] = 210849,
  [SMALL_STATE(5257)] = 210922,
  [SMALL_STATE(5258)] = 210989,
  [SMALL_STATE(5259)] = 211032,
  [SMALL_STATE(5260)] = 211099,
  [SMALL_STATE(5261)] = 211166,
  [SMALL_STATE(5262)] = 211239,
  [SMALL_STATE(5263)] = 211306,
  [SMALL_STATE(5264)] = 211373,
  [SMALL_STATE(5265)] = 211440,
  [SMALL_STATE(5266)] = 211507,
  [SMALL_STATE(5267)] = 211574,
  [SMALL_STATE(5268)] = 211611,
  [SMALL_STATE(5269)] = 211648,
  [SMALL_STATE(5270)] = 211715,
  [SMALL_STATE(5271)] = 211782,
  [SMALL_STATE(5272)] = 211849,
  [SMALL_STATE(5273)] = 211916,
  [SMALL_STATE(5274)] = 211983,
  [SMALL_STATE(5275)] = 212050,
  [SMALL_STATE(5276)] = 212117,
  [SMALL_STATE(5277)] = 212184,
  [SMALL_STATE(5278)] = 212251,
  [SMALL_STATE(5279)] = 212318,
  [SMALL_STATE(5280)] = 212385,
  [SMALL_STATE(5281)] = 212452,
  [SMALL_STATE(5282)] = 212519,
  [SMALL_STATE(5283)] = 212592,
  [SMALL_STATE(5284)] = 212659,
  [SMALL_STATE(5285)] = 212725,
  [SMALL_STATE(5286)] = 212765,
  [SMALL_STATE(5287)] = 212831,
  [SMALL_STATE(5288)] = 212897,
  [SMALL_STATE(5289)] = 212963,
  [SMALL_STATE(5290)] = 213029,
  [SMALL_STATE(5291)] = 213095,
  [SMALL_STATE(5292)] = 213161,
  [SMALL_STATE(5293)] = 213227,
  [SMALL_STATE(5294)] = 213293,
  [SMALL_STATE(5295)] = 213359,
  [SMALL_STATE(5296)] = 213425,
  [SMALL_STATE(5297)] = 213491,
  [SMALL_STATE(5298)] = 213557,
  [SMALL_STATE(5299)] = 213623,
  [SMALL_STATE(5300)] = 213689,
  [SMALL_STATE(5301)] = 213755,
  [SMALL_STATE(5302)] = 213821,
  [SMALL_STATE(5303)] = 213887,
  [SMALL_STATE(5304)] = 213952,
  [SMALL_STATE(5305)] = 214017,
  [SMALL_STATE(5306)] = 214082,
  [SMALL_STATE(5307)] = 214147,
  [SMALL_STATE(5308)] = 214212,
  [SMALL_STATE(5309)] = 214277,
  [SMALL_STATE(5310)] = 214342,
  [SMALL_STATE(5311)] = 214407,
  [SMALL_STATE(5312)] = 214472,
  [SMALL_STATE(5313)] = 214537,
  [SMALL_STATE(5314)] = 214602,
  [SMALL_STATE(5315)] = 214667,
  [SMALL_STATE(5316)] = 214732,
  [SMALL_STATE(5317)] = 214797,
  [SMALL_STATE(5318)] = 214862,
  [SMALL_STATE(5319)] = 214927,
  [SMALL_STATE(5320)] = 214992,
  [SMALL_STATE(5321)] = 215057,
  [SMALL_STATE(5322)] = 215122,
  [SMALL_STATE(5323)] = 215187,
  [SMALL_STATE(5324)] = 215252,
  [SMALL_STATE(5325)] = 215317,
  [SMALL_STATE(5326)] = 215382,
  [SMALL_STATE(5327)] = 215447,
  [SMALL_STATE(5328)] = 215484,
  [SMALL_STATE(5329)] = 215549,
  [SMALL_STATE(5330)] = 215614,
  [SMALL_STATE(5331)] = 215679,
  [SMALL_STATE(5332)] = 215744,
  [SMALL_STATE(5333)] = 215809,
  [SMALL_STATE(5334)] = 215874,
  [SMALL_STATE(5335)] = 215932,
  [SMALL_STATE(5336)] = 215996,
  [SMALL_STATE(5337)] = 216060,
  [SMALL_STATE(5338)] = 216118,
  [SMALL_STATE(5339)] = 216182,
  [SMALL_STATE(5340)] = 216240,
  [SMALL_STATE(5341)] = 216304,
  [SMALL_STATE(5342)] = 216362,
  [SMALL_STATE(5343)] = 216426,
  [SMALL_STATE(5344)] = 216490,
  [SMALL_STATE(5345)] = 216553,
  [SMALL_STATE(5346)] = 216604,
  [SMALL_STATE(5347)] = 216667,
  [SMALL_STATE(5348)] = 216730,
  [SMALL_STATE(5349)] = 216793,
  [SMALL_STATE(5350)] = 216856,
  [SMALL_STATE(5351)] = 216919,
  [SMALL_STATE(5352)] = 216980,
  [SMALL_STATE(5353)] = 217031,
  [SMALL_STATE(5354)] = 217092,
  [SMALL_STATE(5355)] = 217153,
  [SMALL_STATE(5356)] = 217214,
  [SMALL_STATE(5357)] = 217277,
  [SMALL_STATE(5358)] = 217328,
  [SMALL_STATE(5359)] = 217391,
  [SMALL_STATE(5360)] = 217454,
  [SMALL_STATE(5361)] = 217517,
  [SMALL_STATE(5362)] = 217580,
  [SMALL_STATE(5363)] = 217643,
  [SMALL_STATE(5364)] = 217706,
  [SMALL_STATE(5365)] = 217769,
  [SMALL_STATE(5366)] = 217830,
  [SMALL_STATE(5367)] = 217893,
  [SMALL_STATE(5368)] = 217954,
  [SMALL_STATE(5369)] = 218017,
  [SMALL_STATE(5370)] = 218080,
  [SMALL_STATE(5371)] = 218143,
  [SMALL_STATE(5372)] = 218204,
  [SMALL_STATE(5373)] = 218266,
  [SMALL_STATE(5374)] = 218328,
  [SMALL_STATE(5375)] = 218390,
  [SMALL_STATE(5376)] = 218452,
  [SMALL_STATE(5377)] = 218526,
  [SMALL_STATE(5378)] = 218588,
  [SMALL_STATE(5379)] = 218662,
  [SMALL_STATE(5380)] = 218724,
  [SMALL_STATE(5381)] = 218786,
  [SMALL_STATE(5382)] = 218828,
  [SMALL_STATE(5383)] = 218890,
  [SMALL_STATE(5384)] = 218952,
  [SMALL_STATE(5385)] = 218994,
  [SMALL_STATE(5386)] = 219056,
  [SMALL_STATE(5387)] = 219118,
  [SMALL_STATE(5388)] = 219180,
  [SMALL_STATE(5389)] = 219234,
  [SMALL_STATE(5390)] = 219308,
  [SMALL_STATE(5391)] = 219370,
  [SMALL_STATE(5392)] = 219432,
  [SMALL_STATE(5393)] = 219494,
  [SMALL_STATE(5394)] = 219553,
  [SMALL_STATE(5395)] = 219612,
  [SMALL_STATE(5396)] = 219671,
  [SMALL_STATE(5397)] = 219730,
  [SMALL_STATE(5398)] = 219789,
  [SMALL_STATE(5399)] = 219848,
  [SMALL_STATE(5400)] = 219907,
  [SMALL_STATE(5401)] = 219966,
  [SMALL_STATE(5402)] = 220025,
  [SMALL_STATE(5403)] = 220084,
  [SMALL_STATE(5404)] = 220143,
  [SMALL_STATE(5405)] = 220202,
  [SMALL_STATE(5406)] = 220261,
  [SMALL_STATE(5407)] = 220310,
  [SMALL_STATE(5408)] = 220341,
  [SMALL_STATE(5409)] = 220400,
  [SMALL_STATE(5410)] = 220459,
  [SMALL_STATE(5411)] = 220518,
  [SMALL_STATE(5412)] = 220577,
  [SMALL_STATE(5413)] = 220636,
  [SMALL_STATE(5414)] = 220695,
  [SMALL_STATE(5415)] = 220754,
  [SMALL_STATE(5416)] = 220813,
  [SMALL_STATE(5417)] = 220872,
  [SMALL_STATE(5418)] = 220924,
  [SMALL_STATE(5419)] = 220962,
  [SMALL_STATE(5420)] = 221000,
  [SMALL_STATE(5421)] = 221038,
  [SMALL_STATE(5422)] = 221090,
  [SMALL_STATE(5423)] = 221142,
  [SMALL_STATE(5424)] = 221194,
  [SMALL_STATE(5425)] = 221246,
  [SMALL_STATE(5426)] = 221278,
  [SMALL_STATE(5427)] = 221330,
  [SMALL_STATE(5428)] = 221364,
  [SMALL_STATE(5429)] = 221404,
  [SMALL_STATE(5430)] = 221456,
  [SMALL_STATE(5431)] = 221508,
  [SMALL_STATE(5432)] = 221560,
  [SMALL_STATE(5433)] = 221612,
  [SMALL_STATE(5434)] = 221664,
  [SMALL_STATE(5435)] = 221716,
  [SMALL_STATE(5436)] = 221768,
  [SMALL_STATE(5437)] = 221820,
  [SMALL_STATE(5438)] = 221872,
  [SMALL_STATE(5439)] = 221906,
  [SMALL_STATE(5440)] = 221958,
  [SMALL_STATE(5441)] = 222010,
  [SMALL_STATE(5442)] = 222062,
  [SMALL_STATE(5443)] = 222096,
  [SMALL_STATE(5444)] = 222148,
  [SMALL_STATE(5445)] = 222200,
  [SMALL_STATE(5446)] = 222252,
  [SMALL_STATE(5447)] = 222290,
  [SMALL_STATE(5448)] = 222328,
  [SMALL_STATE(5449)] = 222366,
  [SMALL_STATE(5450)] = 222418,
  [SMALL_STATE(5451)] = 222456,
  [SMALL_STATE(5452)] = 222508,
  [SMALL_STATE(5453)] = 222546,
  [SMALL_STATE(5454)] = 222584,
  [SMALL_STATE(5455)] = 222636,
  [SMALL_STATE(5456)] = 222688,
  [SMALL_STATE(5457)] = 222740,
  [SMALL_STATE(5458)] = 222792,
  [SMALL_STATE(5459)] = 222826,
  [SMALL_STATE(5460)] = 222878,
  [SMALL_STATE(5461)] = 222948,
  [SMALL_STATE(5462)] = 223000,
  [SMALL_STATE(5463)] = 223070,
  [SMALL_STATE(5464)] = 223118,
  [SMALL_STATE(5465)] = 223170,
  [SMALL_STATE(5466)] = 223222,
  [SMALL_STATE(5467)] = 223274,
  [SMALL_STATE(5468)] = 223326,
  [SMALL_STATE(5469)] = 223366,
  [SMALL_STATE(5470)] = 223418,
  [SMALL_STATE(5471)] = 223464,
  [SMALL_STATE(5472)] = 223498,
  [SMALL_STATE(5473)] = 223550,
  [SMALL_STATE(5474)] = 223602,
  [SMALL_STATE(5475)] = 223654,
  [SMALL_STATE(5476)] = 223706,
  [SMALL_STATE(5477)] = 223758,
  [SMALL_STATE(5478)] = 223810,
  [SMALL_STATE(5479)] = 223880,
  [SMALL_STATE(5480)] = 223918,
  [SMALL_STATE(5481)] = 223970,
  [SMALL_STATE(5482)] = 224022,
  [SMALL_STATE(5483)] = 224074,
  [SMALL_STATE(5484)] = 224126,
  [SMALL_STATE(5485)] = 224185,
  [SMALL_STATE(5486)] = 224244,
  [SMALL_STATE(5487)] = 224305,
  [SMALL_STATE(5488)] = 224364,
  [SMALL_STATE(5489)] = 224423,
  [SMALL_STATE(5490)] = 224482,
  [SMALL_STATE(5491)] = 224511,
  [SMALL_STATE(5492)] = 224548,
  [SMALL_STATE(5493)] = 224577,
  [SMALL_STATE(5494)] = 224606,
  [SMALL_STATE(5495)] = 224635,
  [SMALL_STATE(5496)] = 224694,
  [SMALL_STATE(5497)] = 224753,
  [SMALL_STATE(5498)] = 224814,
  [SMALL_STATE(5499)] = 224867,
  [SMALL_STATE(5500)] = 224926,
  [SMALL_STATE(5501)] = 224985,
  [SMALL_STATE(5502)] = 225044,
  [SMALL_STATE(5503)] = 225105,
  [SMALL_STATE(5504)] = 225134,
  [SMALL_STATE(5505)] = 225193,
  [SMALL_STATE(5506)] = 225252,
  [SMALL_STATE(5507)] = 225305,
  [SMALL_STATE(5508)] = 225364,
  [SMALL_STATE(5509)] = 225423,
  [SMALL_STATE(5510)] = 225482,
  [SMALL_STATE(5511)] = 225541,
  [SMALL_STATE(5512)] = 225600,
  [SMALL_STATE(5513)] = 225659,
  [SMALL_STATE(5514)] = 225718,
  [SMALL_STATE(5515)] = 225755,
  [SMALL_STATE(5516)] = 225816,
  [SMALL_STATE(5517)] = 225875,
  [SMALL_STATE(5518)] = 225928,
  [SMALL_STATE(5519)] = 225987,
  [SMALL_STATE(5520)] = 226046,
  [SMALL_STATE(5521)] = 226079,
  [SMALL_STATE(5522)] = 226138,
  [SMALL_STATE(5523)] = 226197,
  [SMALL_STATE(5524)] = 226256,
  [SMALL_STATE(5525)] = 226299,
  [SMALL_STATE(5526)] = 226352,
  [SMALL_STATE(5527)] = 226411,
  [SMALL_STATE(5528)] = 226470,
  [SMALL_STATE(5529)] = 226523,
  [SMALL_STATE(5530)] = 226582,
  [SMALL_STATE(5531)] = 226641,
  [SMALL_STATE(5532)] = 226700,
  [SMALL_STATE(5533)] = 226759,
  [SMALL_STATE(5534)] = 226818,
  [SMALL_STATE(5535)] = 226855,
  [SMALL_STATE(5536)] = 226914,
  [SMALL_STATE(5537)] = 226947,
  [SMALL_STATE(5538)] = 227006,
  [SMALL_STATE(5539)] = 227059,
  [SMALL_STATE(5540)] = 227118,
  [SMALL_STATE(5541)] = 227177,
  [SMALL_STATE(5542)] = 227236,
  [SMALL_STATE(5543)] = 227295,
  [SMALL_STATE(5544)] = 227354,
  [SMALL_STATE(5545)] = 227391,
  [SMALL_STATE(5546)] = 227444,
  [SMALL_STATE(5547)] = 227499,
  [SMALL_STATE(5548)] = 227552,
  [SMALL_STATE(5549)] = 227611,
  [SMALL_STATE(5550)] = 227670,
  [SMALL_STATE(5551)] = 227699,
  [SMALL_STATE(5552)] = 227752,
  [SMALL_STATE(5553)] = 227811,
  [SMALL_STATE(5554)] = 227840,
  [SMALL_STATE(5555)] = 227877,
  [SMALL_STATE(5556)] = 227914,
  [SMALL_STATE(5557)] = 227945,
  [SMALL_STATE(5558)] = 228004,
  [SMALL_STATE(5559)] = 228063,
  [SMALL_STATE(5560)] = 228122,
  [SMALL_STATE(5561)] = 228181,
  [SMALL_STATE(5562)] = 228234,
  [SMALL_STATE(5563)] = 228293,
  [SMALL_STATE(5564)] = 228352,
  [SMALL_STATE(5565)] = 228411,
  [SMALL_STATE(5566)] = 228470,
  [SMALL_STATE(5567)] = 228529,
  [SMALL_STATE(5568)] = 228588,
  [SMALL_STATE(5569)] = 228647,
  [SMALL_STATE(5570)] = 228706,
  [SMALL_STATE(5571)] = 228765,
  [SMALL_STATE(5572)] = 228824,
  [SMALL_STATE(5573)] = 228883,
  [SMALL_STATE(5574)] = 228942,
  [SMALL_STATE(5575)] = 229001,
  [SMALL_STATE(5576)] = 229060,
  [SMALL_STATE(5577)] = 229119,
  [SMALL_STATE(5578)] = 229148,
  [SMALL_STATE(5579)] = 229179,
  [SMALL_STATE(5580)] = 229208,
  [SMALL_STATE(5581)] = 229263,
  [SMALL_STATE(5582)] = 229318,
  [SMALL_STATE(5583)] = 229377,
  [SMALL_STATE(5584)] = 229436,
  [SMALL_STATE(5585)] = 229495,
  [SMALL_STATE(5586)] = 229556,
  [SMALL_STATE(5587)] = 229615,
  [SMALL_STATE(5588)] = 229648,
  [SMALL_STATE(5589)] = 229707,
  [SMALL_STATE(5590)] = 229766,
  [SMALL_STATE(5591)] = 229825,
  [SMALL_STATE(5592)] = 229888,
  [SMALL_STATE(5593)] = 229941,
  [SMALL_STATE(5594)] = 229984,
  [SMALL_STATE(5595)] = 230013,
  [SMALL_STATE(5596)] = 230042,
  [SMALL_STATE(5597)] = 230101,
  [SMALL_STATE(5598)] = 230160,
  [SMALL_STATE(5599)] = 230219,
  [SMALL_STATE(5600)] = 230278,
  [SMALL_STATE(5601)] = 230337,
  [SMALL_STATE(5602)] = 230396,
  [SMALL_STATE(5603)] = 230455,
  [SMALL_STATE(5604)] = 230492,
  [SMALL_STATE(5605)] = 230521,
  [SMALL_STATE(5606)] = 230550,
  [SMALL_STATE(5607)] = 230583,
  [SMALL_STATE(5608)] = 230642,
  [SMALL_STATE(5609)] = 230701,
  [SMALL_STATE(5610)] = 230730,
  [SMALL_STATE(5611)] = 230759,
  [SMALL_STATE(5612)] = 230788,
  [SMALL_STATE(5613)] = 230847,
  [SMALL_STATE(5614)] = 230906,
  [SMALL_STATE(5615)] = 230965,
  [SMALL_STATE(5616)] = 231002,
  [SMALL_STATE(5617)] = 231039,
  [SMALL_STATE(5618)] = 231100,
  [SMALL_STATE(5619)] = 231129,
  [SMALL_STATE(5620)] = 231158,
  [SMALL_STATE(5621)] = 231187,
  [SMALL_STATE(5622)] = 231224,
  [SMALL_STATE(5623)] = 231253,
  [SMALL_STATE(5624)] = 231312,
  [SMALL_STATE(5625)] = 231371,
  [SMALL_STATE(5626)] = 231400,
  [SMALL_STATE(5627)] = 231429,
  [SMALL_STATE(5628)] = 231482,
  [SMALL_STATE(5629)] = 231527,
  [SMALL_STATE(5630)] = 231586,
  [SMALL_STATE(5631)] = 231645,
  [SMALL_STATE(5632)] = 231698,
  [SMALL_STATE(5633)] = 231759,
  [SMALL_STATE(5634)] = 231818,
  [SMALL_STATE(5635)] = 231877,
  [SMALL_STATE(5636)] = 231936,
  [SMALL_STATE(5637)] = 231979,
  [SMALL_STATE(5638)] = 232032,
  [SMALL_STATE(5639)] = 232091,
  [SMALL_STATE(5640)] = 232150,
  [SMALL_STATE(5641)] = 232209,
  [SMALL_STATE(5642)] = 232261,
  [SMALL_STATE(5643)] = 232305,
  [SMALL_STATE(5644)] = 232347,
  [SMALL_STATE(5645)] = 232397,
  [SMALL_STATE(5646)] = 232437,
  [SMALL_STATE(5647)] = 232473,
  [SMALL_STATE(5648)] = 232525,
  [SMALL_STATE(5649)] = 232553,
  [SMALL_STATE(5650)] = 232587,
  [SMALL_STATE(5651)] = 232637,
  [SMALL_STATE(5652)] = 232689,
  [SMALL_STATE(5653)] = 232729,
  [SMALL_STATE(5654)] = 232769,
  [SMALL_STATE(5655)] = 232833,
  [SMALL_STATE(5656)] = 232873,
  [SMALL_STATE(5657)] = 232913,
  [SMALL_STATE(5658)] = 232953,
  [SMALL_STATE(5659)] = 232993,
  [SMALL_STATE(5660)] = 233057,
  [SMALL_STATE(5661)] = 233097,
  [SMALL_STATE(5662)] = 233137,
  [SMALL_STATE(5663)] = 233177,
  [SMALL_STATE(5664)] = 233217,
  [SMALL_STATE(5665)] = 233257,
  [SMALL_STATE(5666)] = 233297,
  [SMALL_STATE(5667)] = 233337,
  [SMALL_STATE(5668)] = 233389,
  [SMALL_STATE(5669)] = 233439,
  [SMALL_STATE(5670)] = 233479,
  [SMALL_STATE(5671)] = 233519,
  [SMALL_STATE(5672)] = 233559,
  [SMALL_STATE(5673)] = 233599,
  [SMALL_STATE(5674)] = 233627,
  [SMALL_STATE(5675)] = 233655,
  [SMALL_STATE(5676)] = 233707,
  [SMALL_STATE(5677)] = 233771,
  [SMALL_STATE(5678)] = 233811,
  [SMALL_STATE(5679)] = 233851,
  [SMALL_STATE(5680)] = 233891,
  [SMALL_STATE(5681)] = 233931,
  [SMALL_STATE(5682)] = 233983,
  [SMALL_STATE(5683)] = 234035,
  [SMALL_STATE(5684)] = 234081,
  [SMALL_STATE(5685)] = 234133,
  [SMALL_STATE(5686)] = 234197,
  [SMALL_STATE(5687)] = 234237,
  [SMALL_STATE(5688)] = 234269,
  [SMALL_STATE(5689)] = 234301,
  [SMALL_STATE(5690)] = 234353,
  [SMALL_STATE(5691)] = 234405,
  [SMALL_STATE(5692)] = 234457,
  [SMALL_STATE(5693)] = 234501,
  [SMALL_STATE(5694)] = 234553,
  [SMALL_STATE(5695)] = 234603,
  [SMALL_STATE(5696)] = 234655,
  [SMALL_STATE(5697)] = 234705,
  [SMALL_STATE(5698)] = 234733,
  [SMALL_STATE(5699)] = 234785,
  [SMALL_STATE(5700)] = 234813,
  [SMALL_STATE(5701)] = 234853,
  [SMALL_STATE(5702)] = 234893,
  [SMALL_STATE(5703)] = 234957,
  [SMALL_STATE(5704)] = 234997,
  [SMALL_STATE(5705)] = 235037,
  [SMALL_STATE(5706)] = 235065,
  [SMALL_STATE(5707)] = 235105,
  [SMALL_STATE(5708)] = 235145,
  [SMALL_STATE(5709)] = 235185,
  [SMALL_STATE(5710)] = 235225,
  [SMALL_STATE(5711)] = 235265,
  [SMALL_STATE(5712)] = 235305,
  [SMALL_STATE(5713)] = 235345,
  [SMALL_STATE(5714)] = 235385,
  [SMALL_STATE(5715)] = 235425,
  [SMALL_STATE(5716)] = 235465,
  [SMALL_STATE(5717)] = 235505,
  [SMALL_STATE(5718)] = 235545,
  [SMALL_STATE(5719)] = 235585,
  [SMALL_STATE(5720)] = 235625,
  [SMALL_STATE(5721)] = 235665,
  [SMALL_STATE(5722)] = 235705,
  [SMALL_STATE(5723)] = 235751,
  [SMALL_STATE(5724)] = 235801,
  [SMALL_STATE(5725)] = 235841,
  [SMALL_STATE(5726)] = 235905,
  [SMALL_STATE(5727)] = 235945,
  [SMALL_STATE(5728)] = 235985,
  [SMALL_STATE(5729)] = 236035,
  [SMALL_STATE(5730)] = 236075,
  [SMALL_STATE(5731)] = 236115,
  [SMALL_STATE(5732)] = 236143,
  [SMALL_STATE(5733)] = 236193,
  [SMALL_STATE(5734)] = 236225,
  [SMALL_STATE(5735)] = 236277,
  [SMALL_STATE(5736)] = 236327,
  [SMALL_STATE(5737)] = 236377,
  [SMALL_STATE(5738)] = 236441,
  [SMALL_STATE(5739)] = 236481,
  [SMALL_STATE(5740)] = 236521,
  [SMALL_STATE(5741)] = 236567,
  [SMALL_STATE(5742)] = 236607,
  [SMALL_STATE(5743)] = 236647,
  [SMALL_STATE(5744)] = 236687,
  [SMALL_STATE(5745)] = 236737,
  [SMALL_STATE(5746)] = 236787,
  [SMALL_STATE(5747)] = 236837,
  [SMALL_STATE(5748)] = 236869,
  [SMALL_STATE(5749)] = 236921,
  [SMALL_STATE(5750)] = 236973,
  [SMALL_STATE(5751)] = 237037,
  [SMALL_STATE(5752)] = 237089,
  [SMALL_STATE(5753)] = 237139,
  [SMALL_STATE(5754)] = 237183,
  [SMALL_STATE(5755)] = 237233,
  [SMALL_STATE(5756)] = 237273,
  [SMALL_STATE(5757)] = 237323,
  [SMALL_STATE(5758)] = 237373,
  [SMALL_STATE(5759)] = 237413,
  [SMALL_STATE(5760)] = 237465,
  [SMALL_STATE(5761)] = 237517,
  [SMALL_STATE(5762)] = 237569,
  [SMALL_STATE(5763)] = 237609,
  [SMALL_STATE(5764)] = 237673,
  [SMALL_STATE(5765)] = 237723,
  [SMALL_STATE(5766)] = 237751,
  [SMALL_STATE(5767)] = 237783,
  [SMALL_STATE(5768)] = 237811,
  [SMALL_STATE(5769)] = 237851,
  [SMALL_STATE(5770)] = 237903,
  [SMALL_STATE(5771)] = 237943,
  [SMALL_STATE(5772)] = 237971,
  [SMALL_STATE(5773)] = 238035,
  [SMALL_STATE(5774)] = 238099,
  [SMALL_STATE(5775)] = 238147,
  [SMALL_STATE(5776)] = 238211,
  [SMALL_STATE(5777)] = 238263,
  [SMALL_STATE(5778)] = 238303,
  [SMALL_STATE(5779)] = 238343,
  [SMALL_STATE(5780)] = 238383,
  [SMALL_STATE(5781)] = 238429,
  [SMALL_STATE(5782)] = 238493,
  [SMALL_STATE(5783)] = 238533,
  [SMALL_STATE(5784)] = 238573,
  [SMALL_STATE(5785)] = 238613,
  [SMALL_STATE(5786)] = 238665,
  [SMALL_STATE(5787)] = 238717,
  [SMALL_STATE(5788)] = 238769,
  [SMALL_STATE(5789)] = 238833,
  [SMALL_STATE(5790)] = 238885,
  [SMALL_STATE(5791)] = 238937,
  [SMALL_STATE(5792)] = 238987,
  [SMALL_STATE(5793)] = 239014,
  [SMALL_STATE(5794)] = 239063,
  [SMALL_STATE(5795)] = 239110,
  [SMALL_STATE(5796)] = 239141,
  [SMALL_STATE(5797)] = 239198,
  [SMALL_STATE(5798)] = 239225,
  [SMALL_STATE(5799)] = 239270,
  [SMALL_STATE(5800)] = 239317,
  [SMALL_STATE(5801)] = 239346,
  [SMALL_STATE(5802)] = 239391,
  [SMALL_STATE(5803)] = 239418,
  [SMALL_STATE(5804)] = 239465,
  [SMALL_STATE(5805)] = 239492,
  [SMALL_STATE(5806)] = 239537,
  [SMALL_STATE(5807)] = 239564,
  [SMALL_STATE(5808)] = 239621,
  [SMALL_STATE(5809)] = 239648,
  [SMALL_STATE(5810)] = 239681,
  [SMALL_STATE(5811)] = 239728,
  [SMALL_STATE(5812)] = 239755,
  [SMALL_STATE(5813)] = 239782,
  [SMALL_STATE(5814)] = 239809,
  [SMALL_STATE(5815)] = 239856,
  [SMALL_STATE(5816)] = 239901,
  [SMALL_STATE(5817)] = 239928,
  [SMALL_STATE(5818)] = 239961,
  [SMALL_STATE(5819)] = 239988,
  [SMALL_STATE(5820)] = 240015,
  [SMALL_STATE(5821)] = 240042,
  [SMALL_STATE(5822)] = 240075,
  [SMALL_STATE(5823)] = 240102,
  [SMALL_STATE(5824)] = 240131,
  [SMALL_STATE(5825)] = 240162,
  [SMALL_STATE(5826)] = 240189,
  [SMALL_STATE(5827)] = 240224,
  [SMALL_STATE(5828)] = 240251,
  [SMALL_STATE(5829)] = 240278,
  [SMALL_STATE(5830)] = 240305,
  [SMALL_STATE(5831)] = 240332,
  [SMALL_STATE(5832)] = 240377,
  [SMALL_STATE(5833)] = 240404,
  [SMALL_STATE(5834)] = 240449,
  [SMALL_STATE(5835)] = 240492,
  [SMALL_STATE(5836)] = 240547,
  [SMALL_STATE(5837)] = 240574,
  [SMALL_STATE(5838)] = 240619,
  [SMALL_STATE(5839)] = 240676,
  [SMALL_STATE(5840)] = 240703,
  [SMALL_STATE(5841)] = 240748,
  [SMALL_STATE(5842)] = 240775,
  [SMALL_STATE(5843)] = 240816,
  [SMALL_STATE(5844)] = 240861,
  [SMALL_STATE(5845)] = 240906,
  [SMALL_STATE(5846)] = 240953,
  [SMALL_STATE(5847)] = 240980,
  [SMALL_STATE(5848)] = 241037,
  [SMALL_STATE(5849)] = 241084,
  [SMALL_STATE(5850)] = 241117,
  [SMALL_STATE(5851)] = 241174,
  [SMALL_STATE(5852)] = 241217,
  [SMALL_STATE(5853)] = 241264,
  [SMALL_STATE(5854)] = 241291,
  [SMALL_STATE(5855)] = 241330,
  [SMALL_STATE(5856)] = 241357,
  [SMALL_STATE(5857)] = 241394,
  [SMALL_STATE(5858)] = 241439,
  [SMALL_STATE(5859)] = 241496,
  [SMALL_STATE(5860)] = 241529,
  [SMALL_STATE(5861)] = 241586,
  [SMALL_STATE(5862)] = 241629,
  [SMALL_STATE(5863)] = 241656,
  [SMALL_STATE(5864)] = 241703,
  [SMALL_STATE(5865)] = 241750,
  [SMALL_STATE(5866)] = 241777,
  [SMALL_STATE(5867)] = 241824,
  [SMALL_STATE(5868)] = 241869,
  [SMALL_STATE(5869)] = 241916,
  [SMALL_STATE(5870)] = 241963,
  [SMALL_STATE(5871)] = 241990,
  [SMALL_STATE(5872)] = 242039,
  [SMALL_STATE(5873)] = 242084,
  [SMALL_STATE(5874)] = 242131,
  [SMALL_STATE(5875)] = 242178,
  [SMALL_STATE(5876)] = 242225,
  [SMALL_STATE(5877)] = 242252,
  [SMALL_STATE(5878)] = 242279,
  [SMALL_STATE(5879)] = 242326,
  [SMALL_STATE(5880)] = 242371,
  [SMALL_STATE(5881)] = 242416,
  [SMALL_STATE(5882)] = 242454,
  [SMALL_STATE(5883)] = 242492,
  [SMALL_STATE(5884)] = 242530,
  [SMALL_STATE(5885)] = 242556,
  [SMALL_STATE(5886)] = 242586,
  [SMALL_STATE(5887)] = 242634,
  [SMALL_STATE(5888)] = 242660,
  [SMALL_STATE(5889)] = 242694,
  [SMALL_STATE(5890)] = 242730,
  [SMALL_STATE(5891)] = 242782,
  [SMALL_STATE(5892)] = 242808,
  [SMALL_STATE(5893)] = 242846,
  [SMALL_STATE(5894)] = 242876,
  [SMALL_STATE(5895)] = 242902,
  [SMALL_STATE(5896)] = 242936,
  [SMALL_STATE(5897)] = 242962,
  [SMALL_STATE(5898)] = 242988,
  [SMALL_STATE(5899)] = 243014,
  [SMALL_STATE(5900)] = 243040,
  [SMALL_STATE(5901)] = 243066,
  [SMALL_STATE(5902)] = 243092,
  [SMALL_STATE(5903)] = 243144,
  [SMALL_STATE(5904)] = 243170,
  [SMALL_STATE(5905)] = 243204,
  [SMALL_STATE(5906)] = 243256,
  [SMALL_STATE(5907)] = 243290,
  [SMALL_STATE(5908)] = 243326,
  [SMALL_STATE(5909)] = 243352,
  [SMALL_STATE(5910)] = 243386,
  [SMALL_STATE(5911)] = 243428,
  [SMALL_STATE(5912)] = 243454,
  [SMALL_STATE(5913)] = 243490,
  [SMALL_STATE(5914)] = 243516,
  [SMALL_STATE(5915)] = 243568,
  [SMALL_STATE(5916)] = 243606,
  [SMALL_STATE(5917)] = 243658,
  [SMALL_STATE(5918)] = 243706,
  [SMALL_STATE(5919)] = 243732,
  [SMALL_STATE(5920)] = 243758,
  [SMALL_STATE(5921)] = 243794,
  [SMALL_STATE(5922)] = 243832,
  [SMALL_STATE(5923)] = 243870,
  [SMALL_STATE(5924)] = 243918,
  [SMALL_STATE(5925)] = 243966,
  [SMALL_STATE(5926)] = 243996,
  [SMALL_STATE(5927)] = 244024,
  [SMALL_STATE(5928)] = 244058,
  [SMALL_STATE(5929)] = 244084,
  [SMALL_STATE(5930)] = 244118,
  [SMALL_STATE(5931)] = 244144,
  [SMALL_STATE(5932)] = 244170,
  [SMALL_STATE(5933)] = 244204,
  [SMALL_STATE(5934)] = 244230,
  [SMALL_STATE(5935)] = 244266,
  [SMALL_STATE(5936)] = 244300,
  [SMALL_STATE(5937)] = 244338,
  [SMALL_STATE(5938)] = 244392,
  [SMALL_STATE(5939)] = 244422,
  [SMALL_STATE(5940)] = 244448,
  [SMALL_STATE(5941)] = 244482,
  [SMALL_STATE(5942)] = 244519,
  [SMALL_STATE(5943)] = 244556,
  [SMALL_STATE(5944)] = 244593,
  [SMALL_STATE(5945)] = 244630,
  [SMALL_STATE(5946)] = 244667,
  [SMALL_STATE(5947)] = 244708,
  [SMALL_STATE(5948)] = 244751,
  [SMALL_STATE(5949)] = 244794,
  [SMALL_STATE(5950)] = 244823,
  [SMALL_STATE(5951)] = 244860,
  [SMALL_STATE(5952)] = 244885,
  [SMALL_STATE(5953)] = 244916,
  [SMALL_STATE(5954)] = 244953,
  [SMALL_STATE(5955)] = 244980,
  [SMALL_STATE(5956)] = 245017,
  [SMALL_STATE(5957)] = 245054,
  [SMALL_STATE(5958)] = 245091,
  [SMALL_STATE(5959)] = 245128,
  [SMALL_STATE(5960)] = 245159,
  [SMALL_STATE(5961)] = 245188,
  [SMALL_STATE(5962)] = 245229,
  [SMALL_STATE(5963)] = 245272,
  [SMALL_STATE(5964)] = 245309,
  [SMALL_STATE(5965)] = 245352,
  [SMALL_STATE(5966)] = 245399,
  [SMALL_STATE(5967)] = 245436,
  [SMALL_STATE(5968)] = 245467,
  [SMALL_STATE(5969)] = 245510,
  [SMALL_STATE(5970)] = 245551,
  [SMALL_STATE(5971)] = 245582,
  [SMALL_STATE(5972)] = 245623,
  [SMALL_STATE(5973)] = 245660,
  [SMALL_STATE(5974)] = 245703,
  [SMALL_STATE(5975)] = 245740,
  [SMALL_STATE(5976)] = 245781,
  [SMALL_STATE(5977)] = 245818,
  [SMALL_STATE(5978)] = 245851,
  [SMALL_STATE(5979)] = 245875,
  [SMALL_STATE(5980)] = 245899,
  [SMALL_STATE(5981)] = 245923,
  [SMALL_STATE(5982)] = 245947,
  [SMALL_STATE(5983)] = 245971,
  [SMALL_STATE(5984)] = 246007,
  [SMALL_STATE(5985)] = 246031,
  [SMALL_STATE(5986)] = 246063,
  [SMALL_STATE(5987)] = 246103,
  [SMALL_STATE(5988)] = 246143,
  [SMALL_STATE(5989)] = 246167,
  [SMALL_STATE(5990)] = 246191,
  [SMALL_STATE(5991)] = 246215,
  [SMALL_STATE(5992)] = 246261,
  [SMALL_STATE(5993)] = 246301,
  [SMALL_STATE(5994)] = 246337,
  [SMALL_STATE(5995)] = 246361,
  [SMALL_STATE(5996)] = 246385,
  [SMALL_STATE(5997)] = 246427,
  [SMALL_STATE(5998)] = 246467,
  [SMALL_STATE(5999)] = 246491,
  [SMALL_STATE(6000)] = 246515,
  [SMALL_STATE(6001)] = 246555,
  [SMALL_STATE(6002)] = 246587,
  [SMALL_STATE(6003)] = 246627,
  [SMALL_STATE(6004)] = 246659,
  [SMALL_STATE(6005)] = 246691,
  [SMALL_STATE(6006)] = 246723,
  [SMALL_STATE(6007)] = 246755,
  [SMALL_STATE(6008)] = 246787,
  [SMALL_STATE(6009)] = 246819,
  [SMALL_STATE(6010)] = 246851,
  [SMALL_STATE(6011)] = 246875,
  [SMALL_STATE(6012)] = 246911,
  [SMALL_STATE(6013)] = 246935,
  [SMALL_STATE(6014)] = 246967,
  [SMALL_STATE(6015)] = 247007,
  [SMALL_STATE(6016)] = 247031,
  [SMALL_STATE(6017)] = 247055,
  [SMALL_STATE(6018)] = 247079,
  [SMALL_STATE(6019)] = 247103,
  [SMALL_STATE(6020)] = 247129,
  [SMALL_STATE(6021)] = 247157,
  [SMALL_STATE(6022)] = 247197,
  [SMALL_STATE(6023)] = 247237,
  [SMALL_STATE(6024)] = 247273,
  [SMALL_STATE(6025)] = 247297,
  [SMALL_STATE(6026)] = 247321,
  [SMALL_STATE(6027)] = 247345,
  [SMALL_STATE(6028)] = 247369,
  [SMALL_STATE(6029)] = 247393,
  [SMALL_STATE(6030)] = 247417,
  [SMALL_STATE(6031)] = 247457,
  [SMALL_STATE(6032)] = 247493,
  [SMALL_STATE(6033)] = 247517,
  [SMALL_STATE(6034)] = 247549,
  [SMALL_STATE(6035)] = 247581,
  [SMALL_STATE(6036)] = 247605,
  [SMALL_STATE(6037)] = 247641,
  [SMALL_STATE(6038)] = 247681,
  [SMALL_STATE(6039)] = 247713,
  [SMALL_STATE(6040)] = 247753,
  [SMALL_STATE(6041)] = 247789,
  [SMALL_STATE(6042)] = 247813,
  [SMALL_STATE(6043)] = 247845,
  [SMALL_STATE(6044)] = 247881,
  [SMALL_STATE(6045)] = 247921,
  [SMALL_STATE(6046)] = 247945,
  [SMALL_STATE(6047)] = 247977,
  [SMALL_STATE(6048)] = 248001,
  [SMALL_STATE(6049)] = 248025,
  [SMALL_STATE(6050)] = 248049,
  [SMALL_STATE(6051)] = 248073,
  [SMALL_STATE(6052)] = 248105,
  [SMALL_STATE(6053)] = 248137,
  [SMALL_STATE(6054)] = 248169,
  [SMALL_STATE(6055)] = 248201,
  [SMALL_STATE(6056)] = 248233,
  [SMALL_STATE(6057)] = 248257,
  [SMALL_STATE(6058)] = 248289,
  [SMALL_STATE(6059)] = 248321,
  [SMALL_STATE(6060)] = 248353,
  [SMALL_STATE(6061)] = 248393,
  [SMALL_STATE(6062)] = 248417,
  [SMALL_STATE(6063)] = 248441,
  [SMALL_STATE(6064)] = 248473,
  [SMALL_STATE(6065)] = 248505,
  [SMALL_STATE(6066)] = 248545,
  [SMALL_STATE(6067)] = 248569,
  [SMALL_STATE(6068)] = 248601,
  [SMALL_STATE(6069)] = 248625,
  [SMALL_STATE(6070)] = 248665,
  [SMALL_STATE(6071)] = 248705,
  [SMALL_STATE(6072)] = 248729,
  [SMALL_STATE(6073)] = 248761,
  [SMALL_STATE(6074)] = 248785,
  [SMALL_STATE(6075)] = 248809,
  [SMALL_STATE(6076)] = 248833,
  [SMALL_STATE(6077)] = 248857,
  [SMALL_STATE(6078)] = 248889,
  [SMALL_STATE(6079)] = 248921,
  [SMALL_STATE(6080)] = 248953,
  [SMALL_STATE(6081)] = 248985,
  [SMALL_STATE(6082)] = 249009,
  [SMALL_STATE(6083)] = 249033,
  [SMALL_STATE(6084)] = 249065,
  [SMALL_STATE(6085)] = 249097,
  [SMALL_STATE(6086)] = 249129,
  [SMALL_STATE(6087)] = 249169,
  [SMALL_STATE(6088)] = 249193,
  [SMALL_STATE(6089)] = 249217,
  [SMALL_STATE(6090)] = 249241,
  [SMALL_STATE(6091)] = 249281,
  [SMALL_STATE(6092)] = 249321,
  [SMALL_STATE(6093)] = 249345,
  [SMALL_STATE(6094)] = 249374,
  [SMALL_STATE(6095)] = 249409,
  [SMALL_STATE(6096)] = 249444,
  [SMALL_STATE(6097)] = 249479,
  [SMALL_STATE(6098)] = 249514,
  [SMALL_STATE(6099)] = 249549,
  [SMALL_STATE(6100)] = 249582,
  [SMALL_STATE(6101)] = 249617,
  [SMALL_STATE(6102)] = 249652,
  [SMALL_STATE(6103)] = 249687,
  [SMALL_STATE(6104)] = 249722,
  [SMALL_STATE(6105)] = 249755,
  [SMALL_STATE(6106)] = 249794,
  [SMALL_STATE(6107)] = 249829,
  [SMALL_STATE(6108)] = 249864,
  [SMALL_STATE(6109)] = 249897,
  [SMALL_STATE(6110)] = 249926,
  [SMALL_STATE(6111)] = 249959,
  [SMALL_STATE(6112)] = 249988,
  [SMALL_STATE(6113)] = 250021,
  [SMALL_STATE(6114)] = 250056,
  [SMALL_STATE(6115)] = 250091,
  [SMALL_STATE(6116)] = 250126,
  [SMALL_STATE(6117)] = 250161,
  [SMALL_STATE(6118)] = 250194,
  [SMALL_STATE(6119)] = 250227,
  [SMALL_STATE(6120)] = 250260,
  [SMALL_STATE(6121)] = 250289,
  [SMALL_STATE(6122)] = 250318,
  [SMALL_STATE(6123)] = 250353,
  [SMALL_STATE(6124)] = 250388,
  [SMALL_STATE(6125)] = 250423,
  [SMALL_STATE(6126)] = 250458,
  [SMALL_STATE(6127)] = 250487,
  [SMALL_STATE(6128)] = 250520,
  [SMALL_STATE(6129)] = 250549,
  [SMALL_STATE(6130)] = 250578,
  [SMALL_STATE(6131)] = 250611,
  [SMALL_STATE(6132)] = 250640,
  [SMALL_STATE(6133)] = 250679,
  [SMALL_STATE(6134)] = 250712,
  [SMALL_STATE(6135)] = 250741,
  [SMALL_STATE(6136)] = 250776,
  [SMALL_STATE(6137)] = 250805,
  [SMALL_STATE(6138)] = 250840,
  [SMALL_STATE(6139)] = 250869,
  [SMALL_STATE(6140)] = 250902,
  [SMALL_STATE(6141)] = 250941,
  [SMALL_STATE(6142)] = 250976,
  [SMALL_STATE(6143)] = 251011,
  [SMALL_STATE(6144)] = 251050,
  [SMALL_STATE(6145)] = 251077,
  [SMALL_STATE(6146)] = 251106,
  [SMALL_STATE(6147)] = 251141,
  [SMALL_STATE(6148)] = 251176,
  [SMALL_STATE(6149)] = 251215,
  [SMALL_STATE(6150)] = 251250,
  [SMALL_STATE(6151)] = 251283,
  [SMALL_STATE(6152)] = 251312,
  [SMALL_STATE(6153)] = 251347,
  [SMALL_STATE(6154)] = 251380,
  [SMALL_STATE(6155)] = 251409,
  [SMALL_STATE(6156)] = 251444,
  [SMALL_STATE(6157)] = 251483,
  [SMALL_STATE(6158)] = 251522,
  [SMALL_STATE(6159)] = 251551,
  [SMALL_STATE(6160)] = 251580,
  [SMALL_STATE(6161)] = 251609,
  [SMALL_STATE(6162)] = 251638,
  [SMALL_STATE(6163)] = 251677,
  [SMALL_STATE(6164)] = 251710,
  [SMALL_STATE(6165)] = 251739,
  [SMALL_STATE(6166)] = 251768,
  [SMALL_STATE(6167)] = 251807,
  [SMALL_STATE(6168)] = 251842,
  [SMALL_STATE(6169)] = 251877,
  [SMALL_STATE(6170)] = 251910,
  [SMALL_STATE(6171)] = 251939,
  [SMALL_STATE(6172)] = 251974,
  [SMALL_STATE(6173)] = 252014,
  [SMALL_STATE(6174)] = 252044,
  [SMALL_STATE(6175)] = 252082,
  [SMALL_STATE(6176)] = 252114,
  [SMALL_STATE(6177)] = 252144,
  [SMALL_STATE(6178)] = 252176,
  [SMALL_STATE(6179)] = 252208,
  [SMALL_STATE(6180)] = 252248,
  [SMALL_STATE(6181)] = 252288,
  [SMALL_STATE(6182)] = 252326,
  [SMALL_STATE(6183)] = 252364,
  [SMALL_STATE(6184)] = 252404,
  [SMALL_STATE(6185)] = 252436,
  [SMALL_STATE(6186)] = 252474,
  [SMALL_STATE(6187)] = 252514,
  [SMALL_STATE(6188)] = 252544,
  [SMALL_STATE(6189)] = 252574,
  [SMALL_STATE(6190)] = 252604,
  [SMALL_STATE(6191)] = 252634,
  [SMALL_STATE(6192)] = 252664,
  [SMALL_STATE(6193)] = 252704,
  [SMALL_STATE(6194)] = 252744,
  [SMALL_STATE(6195)] = 252784,
  [SMALL_STATE(6196)] = 252816,
  [SMALL_STATE(6197)] = 252846,
  [SMALL_STATE(6198)] = 252876,
  [SMALL_STATE(6199)] = 252906,
  [SMALL_STATE(6200)] = 252940,
  [SMALL_STATE(6201)] = 252974,
  [SMALL_STATE(6202)] = 253008,
  [SMALL_STATE(6203)] = 253042,
  [SMALL_STATE(6204)] = 253076,
  [SMALL_STATE(6205)] = 253110,
  [SMALL_STATE(6206)] = 253144,
  [SMALL_STATE(6207)] = 253178,
  [SMALL_STATE(6208)] = 253208,
  [SMALL_STATE(6209)] = 253248,
  [SMALL_STATE(6210)] = 253280,
  [SMALL_STATE(6211)] = 253304,
  [SMALL_STATE(6212)] = 253336,
  [SMALL_STATE(6213)] = 253368,
  [SMALL_STATE(6214)] = 253400,
  [SMALL_STATE(6215)] = 253438,
  [SMALL_STATE(6216)] = 253478,
  [SMALL_STATE(6217)] = 253510,
  [SMALL_STATE(6218)] = 253548,
  [SMALL_STATE(6219)] = 253586,
  [SMALL_STATE(6220)] = 253618,
  [SMALL_STATE(6221)] = 253648,
  [SMALL_STATE(6222)] = 253688,
  [SMALL_STATE(6223)] = 253726,
  [SMALL_STATE(6224)] = 253756,
  [SMALL_STATE(6225)] = 253794,
  [SMALL_STATE(6226)] = 253826,
  [SMALL_STATE(6227)] = 253866,
  [SMALL_STATE(6228)] = 253898,
  [SMALL_STATE(6229)] = 253928,
  [SMALL_STATE(6230)] = 253958,
  [SMALL_STATE(6231)] = 253984,
  [SMALL_STATE(6232)] = 254022,
  [SMALL_STATE(6233)] = 254060,
  [SMALL_STATE(6234)] = 254098,
  [SMALL_STATE(6235)] = 254124,
  [SMALL_STATE(6236)] = 254148,
  [SMALL_STATE(6237)] = 254178,
  [SMALL_STATE(6238)] = 254208,
  [SMALL_STATE(6239)] = 254240,
  [SMALL_STATE(6240)] = 254270,
  [SMALL_STATE(6241)] = 254310,
  [SMALL_STATE(6242)] = 254350,
  [SMALL_STATE(6243)] = 254388,
  [SMALL_STATE(6244)] = 254428,
  [SMALL_STATE(6245)] = 254450,
  [SMALL_STATE(6246)] = 254490,
  [SMALL_STATE(6247)] = 254522,
  [SMALL_STATE(6248)] = 254560,
  [SMALL_STATE(6249)] = 254590,
  [SMALL_STATE(6250)] = 254630,
  [SMALL_STATE(6251)] = 254652,
  [SMALL_STATE(6252)] = 254684,
  [SMALL_STATE(6253)] = 254714,
  [SMALL_STATE(6254)] = 254744,
  [SMALL_STATE(6255)] = 254774,
  [SMALL_STATE(6256)] = 254814,
  [SMALL_STATE(6257)] = 254854,
  [SMALL_STATE(6258)] = 254892,
  [SMALL_STATE(6259)] = 254922,
  [SMALL_STATE(6260)] = 254944,
  [SMALL_STATE(6261)] = 254974,
  [SMALL_STATE(6262)] = 255004,
  [SMALL_STATE(6263)] = 255034,
  [SMALL_STATE(6264)] = 255064,
  [SMALL_STATE(6265)] = 255088,
  [SMALL_STATE(6266)] = 255110,
  [SMALL_STATE(6267)] = 255140,
  [SMALL_STATE(6268)] = 255180,
  [SMALL_STATE(6269)] = 255212,
  [SMALL_STATE(6270)] = 255234,
  [SMALL_STATE(6271)] = 255274,
  [SMALL_STATE(6272)] = 255312,
  [SMALL_STATE(6273)] = 255350,
  [SMALL_STATE(6274)] = 255390,
  [SMALL_STATE(6275)] = 255428,
  [SMALL_STATE(6276)] = 255466,
  [SMALL_STATE(6277)] = 255498,
  [SMALL_STATE(6278)] = 255537,
  [SMALL_STATE(6279)] = 255564,
  [SMALL_STATE(6280)] = 255597,
  [SMALL_STATE(6281)] = 255630,
  [SMALL_STATE(6282)] = 255657,
  [SMALL_STATE(6283)] = 255692,
  [SMALL_STATE(6284)] = 255717,
  [SMALL_STATE(6285)] = 255744,
  [SMALL_STATE(6286)] = 255783,
  [SMALL_STATE(6287)] = 255812,
  [SMALL_STATE(6288)] = 255841,
  [SMALL_STATE(6289)] = 255870,
  [SMALL_STATE(6290)] = 255899,
  [SMALL_STATE(6291)] = 255928,
  [SMALL_STATE(6292)] = 255957,
  [SMALL_STATE(6293)] = 255986,
  [SMALL_STATE(6294)] = 256015,
  [SMALL_STATE(6295)] = 256048,
  [SMALL_STATE(6296)] = 256081,
  [SMALL_STATE(6297)] = 256116,
  [SMALL_STATE(6298)] = 256149,
  [SMALL_STATE(6299)] = 256174,
  [SMALL_STATE(6300)] = 256199,
  [SMALL_STATE(6301)] = 256226,
  [SMALL_STATE(6302)] = 256259,
  [SMALL_STATE(6303)] = 256298,
  [SMALL_STATE(6304)] = 256333,
  [SMALL_STATE(6305)] = 256360,
  [SMALL_STATE(6306)] = 256387,
  [SMALL_STATE(6307)] = 256422,
  [SMALL_STATE(6308)] = 256447,
  [SMALL_STATE(6309)] = 256472,
  [SMALL_STATE(6310)] = 256505,
  [SMALL_STATE(6311)] = 256540,
  [SMALL_STATE(6312)] = 256575,
  [SMALL_STATE(6313)] = 256608,
  [SMALL_STATE(6314)] = 256641,
  [SMALL_STATE(6315)] = 256674,
  [SMALL_STATE(6316)] = 256707,
  [SMALL_STATE(6317)] = 256740,
  [SMALL_STATE(6318)] = 256773,
  [SMALL_STATE(6319)] = 256810,
  [SMALL_STATE(6320)] = 256843,
  [SMALL_STATE(6321)] = 256876,
  [SMALL_STATE(6322)] = 256909,
  [SMALL_STATE(6323)] = 256948,
  [SMALL_STATE(6324)] = 256981,
  [SMALL_STATE(6325)] = 257014,
  [SMALL_STATE(6326)] = 257047,
  [SMALL_STATE(6327)] = 257082,
  [SMALL_STATE(6328)] = 257117,
  [SMALL_STATE(6329)] = 257150,
  [SMALL_STATE(6330)] = 257183,
  [SMALL_STATE(6331)] = 257216,
  [SMALL_STATE(6332)] = 257251,
  [SMALL_STATE(6333)] = 257284,
  [SMALL_STATE(6334)] = 257317,
  [SMALL_STATE(6335)] = 257350,
  [SMALL_STATE(6336)] = 257383,
  [SMALL_STATE(6337)] = 257416,
  [SMALL_STATE(6338)] = 257449,
  [SMALL_STATE(6339)] = 257482,
  [SMALL_STATE(6340)] = 257519,
  [SMALL_STATE(6341)] = 257554,
  [SMALL_STATE(6342)] = 257579,
  [SMALL_STATE(6343)] = 257614,
  [SMALL_STATE(6344)] = 257647,
  [SMALL_STATE(6345)] = 257674,
  [SMALL_STATE(6346)] = 257709,
  [SMALL_STATE(6347)] = 257742,
  [SMALL_STATE(6348)] = 257769,
  [SMALL_STATE(6349)] = 257802,
  [SMALL_STATE(6350)] = 257835,
  [SMALL_STATE(6351)] = 257874,
  [SMALL_STATE(6352)] = 257904,
  [SMALL_STATE(6353)] = 257940,
  [SMALL_STATE(6354)] = 257976,
  [SMALL_STATE(6355)] = 258012,
  [SMALL_STATE(6356)] = 258048,
  [SMALL_STATE(6357)] = 258068,
  [SMALL_STATE(6358)] = 258088,
  [SMALL_STATE(6359)] = 258118,
  [SMALL_STATE(6360)] = 258154,
  [SMALL_STATE(6361)] = 258184,
  [SMALL_STATE(6362)] = 258214,
  [SMALL_STATE(6363)] = 258244,
  [SMALL_STATE(6364)] = 258274,
  [SMALL_STATE(6365)] = 258310,
  [SMALL_STATE(6366)] = 258330,
  [SMALL_STATE(6367)] = 258366,
  [SMALL_STATE(6368)] = 258392,
  [SMALL_STATE(6369)] = 258418,
  [SMALL_STATE(6370)] = 258438,
  [SMALL_STATE(6371)] = 258468,
  [SMALL_STATE(6372)] = 258504,
  [SMALL_STATE(6373)] = 258534,
  [SMALL_STATE(6374)] = 258564,
  [SMALL_STATE(6375)] = 258600,
  [SMALL_STATE(6376)] = 258636,
  [SMALL_STATE(6377)] = 258672,
  [SMALL_STATE(6378)] = 258702,
  [SMALL_STATE(6379)] = 258722,
  [SMALL_STATE(6380)] = 258758,
  [SMALL_STATE(6381)] = 258778,
  [SMALL_STATE(6382)] = 258798,
  [SMALL_STATE(6383)] = 258834,
  [SMALL_STATE(6384)] = 258870,
  [SMALL_STATE(6385)] = 258900,
  [SMALL_STATE(6386)] = 258926,
  [SMALL_STATE(6387)] = 258962,
  [SMALL_STATE(6388)] = 258998,
  [SMALL_STATE(6389)] = 259028,
  [SMALL_STATE(6390)] = 259054,
  [SMALL_STATE(6391)] = 259090,
  [SMALL_STATE(6392)] = 259116,
  [SMALL_STATE(6393)] = 259142,
  [SMALL_STATE(6394)] = 259178,
  [SMALL_STATE(6395)] = 259200,
  [SMALL_STATE(6396)] = 259226,
  [SMALL_STATE(6397)] = 259262,
  [SMALL_STATE(6398)] = 259288,
  [SMALL_STATE(6399)] = 259308,
  [SMALL_STATE(6400)] = 259328,
  [SMALL_STATE(6401)] = 259364,
  [SMALL_STATE(6402)] = 259384,
  [SMALL_STATE(6403)] = 259406,
  [SMALL_STATE(6404)] = 259426,
  [SMALL_STATE(6405)] = 259459,
  [SMALL_STATE(6406)] = 259484,
  [SMALL_STATE(6407)] = 259515,
  [SMALL_STATE(6408)] = 259540,
  [SMALL_STATE(6409)] = 259571,
  [SMALL_STATE(6410)] = 259596,
  [SMALL_STATE(6411)] = 259627,
  [SMALL_STATE(6412)] = 259658,
  [SMALL_STATE(6413)] = 259687,
  [SMALL_STATE(6414)] = 259714,
  [SMALL_STATE(6415)] = 259745,
  [SMALL_STATE(6416)] = 259776,
  [SMALL_STATE(6417)] = 259807,
  [SMALL_STATE(6418)] = 259834,
  [SMALL_STATE(6419)] = 259861,
  [SMALL_STATE(6420)] = 259892,
  [SMALL_STATE(6421)] = 259917,
  [SMALL_STATE(6422)] = 259944,
  [SMALL_STATE(6423)] = 259973,
  [SMALL_STATE(6424)] = 260002,
  [SMALL_STATE(6425)] = 260035,
  [SMALL_STATE(6426)] = 260066,
  [SMALL_STATE(6427)] = 260091,
  [SMALL_STATE(6428)] = 260122,
  [SMALL_STATE(6429)] = 260151,
  [SMALL_STATE(6430)] = 260182,
  [SMALL_STATE(6431)] = 260213,
  [SMALL_STATE(6432)] = 260248,
  [SMALL_STATE(6433)] = 260283,
  [SMALL_STATE(6434)] = 260302,
  [SMALL_STATE(6435)] = 260321,
  [SMALL_STATE(6436)] = 260350,
  [SMALL_STATE(6437)] = 260375,
  [SMALL_STATE(6438)] = 260410,
  [SMALL_STATE(6439)] = 260429,
  [SMALL_STATE(6440)] = 260464,
  [SMALL_STATE(6441)] = 260495,
  [SMALL_STATE(6442)] = 260520,
  [SMALL_STATE(6443)] = 260555,
  [SMALL_STATE(6444)] = 260572,
  [SMALL_STATE(6445)] = 260607,
  [SMALL_STATE(6446)] = 260642,
  [SMALL_STATE(6447)] = 260661,
  [SMALL_STATE(6448)] = 260690,
  [SMALL_STATE(6449)] = 260725,
  [SMALL_STATE(6450)] = 260752,
  [SMALL_STATE(6451)] = 260779,
  [SMALL_STATE(6452)] = 260808,
  [SMALL_STATE(6453)] = 260833,
  [SMALL_STATE(6454)] = 260862,
  [SMALL_STATE(6455)] = 260893,
  [SMALL_STATE(6456)] = 260920,
  [SMALL_STATE(6457)] = 260951,
  [SMALL_STATE(6458)] = 260978,
  [SMALL_STATE(6459)] = 261005,
  [SMALL_STATE(6460)] = 261040,
  [SMALL_STATE(6461)] = 261067,
  [SMALL_STATE(6462)] = 261102,
  [SMALL_STATE(6463)] = 261137,
  [SMALL_STATE(6464)] = 261168,
  [SMALL_STATE(6465)] = 261195,
  [SMALL_STATE(6466)] = 261222,
  [SMALL_STATE(6467)] = 261249,
  [SMALL_STATE(6468)] = 261276,
  [SMALL_STATE(6469)] = 261301,
  [SMALL_STATE(6470)] = 261328,
  [SMALL_STATE(6471)] = 261355,
  [SMALL_STATE(6472)] = 261382,
  [SMALL_STATE(6473)] = 261401,
  [SMALL_STATE(6474)] = 261430,
  [SMALL_STATE(6475)] = 261465,
  [SMALL_STATE(6476)] = 261500,
  [SMALL_STATE(6477)] = 261527,
  [SMALL_STATE(6478)] = 261554,
  [SMALL_STATE(6479)] = 261589,
  [SMALL_STATE(6480)] = 261616,
  [SMALL_STATE(6481)] = 261645,
  [SMALL_STATE(6482)] = 261676,
  [SMALL_STATE(6483)] = 261711,
  [SMALL_STATE(6484)] = 261746,
  [SMALL_STATE(6485)] = 261769,
  [SMALL_STATE(6486)] = 261800,
  [SMALL_STATE(6487)] = 261827,
  [SMALL_STATE(6488)] = 261848,
  [SMALL_STATE(6489)] = 261881,
  [SMALL_STATE(6490)] = 261916,
  [SMALL_STATE(6491)] = 261935,
  [SMALL_STATE(6492)] = 261952,
  [SMALL_STATE(6493)] = 261971,
  [SMALL_STATE(6494)] = 262000,
  [SMALL_STATE(6495)] = 262031,
  [SMALL_STATE(6496)] = 262066,
  [SMALL_STATE(6497)] = 262095,
  [SMALL_STATE(6498)] = 262120,
  [SMALL_STATE(6499)] = 262137,
  [SMALL_STATE(6500)] = 262168,
  [SMALL_STATE(6501)] = 262185,
  [SMALL_STATE(6502)] = 262220,
  [SMALL_STATE(6503)] = 262253,
  [SMALL_STATE(6504)] = 262278,
  [SMALL_STATE(6505)] = 262313,
  [SMALL_STATE(6506)] = 262340,
  [SMALL_STATE(6507)] = 262357,
  [SMALL_STATE(6508)] = 262382,
  [SMALL_STATE(6509)] = 262407,
  [SMALL_STATE(6510)] = 262436,
  [SMALL_STATE(6511)] = 262461,
  [SMALL_STATE(6512)] = 262492,
  [SMALL_STATE(6513)] = 262523,
  [SMALL_STATE(6514)] = 262554,
  [SMALL_STATE(6515)] = 262585,
  [SMALL_STATE(6516)] = 262616,
  [SMALL_STATE(6517)] = 262643,
  [SMALL_STATE(6518)] = 262668,
  [SMALL_STATE(6519)] = 262703,
  [SMALL_STATE(6520)] = 262728,
  [SMALL_STATE(6521)] = 262761,
  [SMALL_STATE(6522)] = 262788,
  [SMALL_STATE(6523)] = 262815,
  [SMALL_STATE(6524)] = 262844,
  [SMALL_STATE(6525)] = 262871,
  [SMALL_STATE(6526)] = 262893,
  [SMALL_STATE(6527)] = 262923,
  [SMALL_STATE(6528)] = 262953,
  [SMALL_STATE(6529)] = 262977,
  [SMALL_STATE(6530)] = 263001,
  [SMALL_STATE(6531)] = 263025,
  [SMALL_STATE(6532)] = 263049,
  [SMALL_STATE(6533)] = 263073,
  [SMALL_STATE(6534)] = 263097,
  [SMALL_STATE(6535)] = 263121,
  [SMALL_STATE(6536)] = 263145,
  [SMALL_STATE(6537)] = 263169,
  [SMALL_STATE(6538)] = 263195,
  [SMALL_STATE(6539)] = 263221,
  [SMALL_STATE(6540)] = 263247,
  [SMALL_STATE(6541)] = 263271,
  [SMALL_STATE(6542)] = 263295,
  [SMALL_STATE(6543)] = 263319,
  [SMALL_STATE(6544)] = 263343,
  [SMALL_STATE(6545)] = 263365,
  [SMALL_STATE(6546)] = 263389,
  [SMALL_STATE(6547)] = 263413,
  [SMALL_STATE(6548)] = 263437,
  [SMALL_STATE(6549)] = 263461,
  [SMALL_STATE(6550)] = 263491,
  [SMALL_STATE(6551)] = 263513,
  [SMALL_STATE(6552)] = 263543,
  [SMALL_STATE(6553)] = 263575,
  [SMALL_STATE(6554)] = 263597,
  [SMALL_STATE(6555)] = 263613,
  [SMALL_STATE(6556)] = 263635,
  [SMALL_STATE(6557)] = 263657,
  [SMALL_STATE(6558)] = 263687,
  [SMALL_STATE(6559)] = 263711,
  [SMALL_STATE(6560)] = 263733,
  [SMALL_STATE(6561)] = 263761,
  [SMALL_STATE(6562)] = 263783,
  [SMALL_STATE(6563)] = 263807,
  [SMALL_STATE(6564)] = 263831,
  [SMALL_STATE(6565)] = 263853,
  [SMALL_STATE(6566)] = 263877,
  [SMALL_STATE(6567)] = 263899,
  [SMALL_STATE(6568)] = 263923,
  [SMALL_STATE(6569)] = 263947,
  [SMALL_STATE(6570)] = 263977,
  [SMALL_STATE(6571)] = 263999,
  [SMALL_STATE(6572)] = 264021,
  [SMALL_STATE(6573)] = 264051,
  [SMALL_STATE(6574)] = 264077,
  [SMALL_STATE(6575)] = 264099,
  [SMALL_STATE(6576)] = 264122,
  [SMALL_STATE(6577)] = 264145,
  [SMALL_STATE(6578)] = 264166,
  [SMALL_STATE(6579)] = 264197,
  [SMALL_STATE(6580)] = 264228,
  [SMALL_STATE(6581)] = 264259,
  [SMALL_STATE(6582)] = 264286,
  [SMALL_STATE(6583)] = 264313,
  [SMALL_STATE(6584)] = 264340,
  [SMALL_STATE(6585)] = 264367,
  [SMALL_STATE(6586)] = 264394,
  [SMALL_STATE(6587)] = 264425,
  [SMALL_STATE(6588)] = 264456,
  [SMALL_STATE(6589)] = 264477,
  [SMALL_STATE(6590)] = 264508,
  [SMALL_STATE(6591)] = 264539,
  [SMALL_STATE(6592)] = 264566,
  [SMALL_STATE(6593)] = 264597,
  [SMALL_STATE(6594)] = 264628,
  [SMALL_STATE(6595)] = 264659,
  [SMALL_STATE(6596)] = 264686,
  [SMALL_STATE(6597)] = 264713,
  [SMALL_STATE(6598)] = 264740,
  [SMALL_STATE(6599)] = 264771,
  [SMALL_STATE(6600)] = 264802,
  [SMALL_STATE(6601)] = 264829,
  [SMALL_STATE(6602)] = 264856,
  [SMALL_STATE(6603)] = 264887,
  [SMALL_STATE(6604)] = 264908,
  [SMALL_STATE(6605)] = 264939,
  [SMALL_STATE(6606)] = 264966,
  [SMALL_STATE(6607)] = 264997,
  [SMALL_STATE(6608)] = 265024,
  [SMALL_STATE(6609)] = 265051,
  [SMALL_STATE(6610)] = 265078,
  [SMALL_STATE(6611)] = 265109,
  [SMALL_STATE(6612)] = 265136,
  [SMALL_STATE(6613)] = 265167,
  [SMALL_STATE(6614)] = 265194,
  [SMALL_STATE(6615)] = 265221,
  [SMALL_STATE(6616)] = 265252,
  [SMALL_STATE(6617)] = 265275,
  [SMALL_STATE(6618)] = 265302,
  [SMALL_STATE(6619)] = 265333,
  [SMALL_STATE(6620)] = 265356,
  [SMALL_STATE(6621)] = 265387,
  [SMALL_STATE(6622)] = 265410,
  [SMALL_STATE(6623)] = 265433,
  [SMALL_STATE(6624)] = 265456,
  [SMALL_STATE(6625)] = 265479,
  [SMALL_STATE(6626)] = 265502,
  [SMALL_STATE(6627)] = 265533,
  [SMALL_STATE(6628)] = 265564,
  [SMALL_STATE(6629)] = 265595,
  [SMALL_STATE(6630)] = 265626,
  [SMALL_STATE(6631)] = 265657,
  [SMALL_STATE(6632)] = 265688,
  [SMALL_STATE(6633)] = 265719,
  [SMALL_STATE(6634)] = 265750,
  [SMALL_STATE(6635)] = 265781,
  [SMALL_STATE(6636)] = 265802,
  [SMALL_STATE(6637)] = 265825,
  [SMALL_STATE(6638)] = 265841,
  [SMALL_STATE(6639)] = 265863,
  [SMALL_STATE(6640)] = 265889,
  [SMALL_STATE(6641)] = 265911,
  [SMALL_STATE(6642)] = 265937,
  [SMALL_STATE(6643)] = 265963,
  [SMALL_STATE(6644)] = 265989,
  [SMALL_STATE(6645)] = 266015,
  [SMALL_STATE(6646)] = 266037,
  [SMALL_STATE(6647)] = 266059,
  [SMALL_STATE(6648)] = 266075,
  [SMALL_STATE(6649)] = 266099,
  [SMALL_STATE(6650)] = 266121,
  [SMALL_STATE(6651)] = 266143,
  [SMALL_STATE(6652)] = 266165,
  [SMALL_STATE(6653)] = 266191,
  [SMALL_STATE(6654)] = 266213,
  [SMALL_STATE(6655)] = 266237,
  [SMALL_STATE(6656)] = 266261,
  [SMALL_STATE(6657)] = 266283,
  [SMALL_STATE(6658)] = 266309,
  [SMALL_STATE(6659)] = 266333,
  [SMALL_STATE(6660)] = 266351,
  [SMALL_STATE(6661)] = 266377,
  [SMALL_STATE(6662)] = 266397,
  [SMALL_STATE(6663)] = 266423,
  [SMALL_STATE(6664)] = 266449,
  [SMALL_STATE(6665)] = 266473,
  [SMALL_STATE(6666)] = 266499,
  [SMALL_STATE(6667)] = 266523,
  [SMALL_STATE(6668)] = 266549,
  [SMALL_STATE(6669)] = 266575,
  [SMALL_STATE(6670)] = 266601,
  [SMALL_STATE(6671)] = 266627,
  [SMALL_STATE(6672)] = 266653,
  [SMALL_STATE(6673)] = 266679,
  [SMALL_STATE(6674)] = 266701,
  [SMALL_STATE(6675)] = 266721,
  [SMALL_STATE(6676)] = 266741,
  [SMALL_STATE(6677)] = 266767,
  [SMALL_STATE(6678)] = 266793,
  [SMALL_STATE(6679)] = 266815,
  [SMALL_STATE(6680)] = 266841,
  [SMALL_STATE(6681)] = 266863,
  [SMALL_STATE(6682)] = 266889,
  [SMALL_STATE(6683)] = 266911,
  [SMALL_STATE(6684)] = 266939,
  [SMALL_STATE(6685)] = 266961,
  [SMALL_STATE(6686)] = 266987,
  [SMALL_STATE(6687)] = 267013,
  [SMALL_STATE(6688)] = 267035,
  [SMALL_STATE(6689)] = 267061,
  [SMALL_STATE(6690)] = 267087,
  [SMALL_STATE(6691)] = 267109,
  [SMALL_STATE(6692)] = 267135,
  [SMALL_STATE(6693)] = 267161,
  [SMALL_STATE(6694)] = 267187,
  [SMALL_STATE(6695)] = 267213,
  [SMALL_STATE(6696)] = 267239,
  [SMALL_STATE(6697)] = 267261,
  [SMALL_STATE(6698)] = 267287,
  [SMALL_STATE(6699)] = 267309,
  [SMALL_STATE(6700)] = 267335,
  [SMALL_STATE(6701)] = 267357,
  [SMALL_STATE(6702)] = 267379,
  [SMALL_STATE(6703)] = 267401,
  [SMALL_STATE(6704)] = 267423,
  [SMALL_STATE(6705)] = 267445,
  [SMALL_STATE(6706)] = 267467,
  [SMALL_STATE(6707)] = 267487,
  [SMALL_STATE(6708)] = 267513,
  [SMALL_STATE(6709)] = 267539,
  [SMALL_STATE(6710)] = 267565,
  [SMALL_STATE(6711)] = 267591,
  [SMALL_STATE(6712)] = 267617,
  [SMALL_STATE(6713)] = 267641,
  [SMALL_STATE(6714)] = 267667,
  [SMALL_STATE(6715)] = 267693,
  [SMALL_STATE(6716)] = 267719,
  [SMALL_STATE(6717)] = 267743,
  [SMALL_STATE(6718)] = 267766,
  [SMALL_STATE(6719)] = 267787,
  [SMALL_STATE(6720)] = 267812,
  [SMALL_STATE(6721)] = 267831,
  [SMALL_STATE(6722)] = 267854,
  [SMALL_STATE(6723)] = 267871,
  [SMALL_STATE(6724)] = 267894,
  [SMALL_STATE(6725)] = 267917,
  [SMALL_STATE(6726)] = 267934,
  [SMALL_STATE(6727)] = 267951,
  [SMALL_STATE(6728)] = 267974,
  [SMALL_STATE(6729)] = 267993,
  [SMALL_STATE(6730)] = 268010,
  [SMALL_STATE(6731)] = 268035,
  [SMALL_STATE(6732)] = 268058,
  [SMALL_STATE(6733)] = 268075,
  [SMALL_STATE(6734)] = 268100,
  [SMALL_STATE(6735)] = 268123,
  [SMALL_STATE(6736)] = 268146,
  [SMALL_STATE(6737)] = 268171,
  [SMALL_STATE(6738)] = 268192,
  [SMALL_STATE(6739)] = 268209,
  [SMALL_STATE(6740)] = 268226,
  [SMALL_STATE(6741)] = 268251,
  [SMALL_STATE(6742)] = 268272,
  [SMALL_STATE(6743)] = 268289,
  [SMALL_STATE(6744)] = 268312,
  [SMALL_STATE(6745)] = 268335,
  [SMALL_STATE(6746)] = 268356,
  [SMALL_STATE(6747)] = 268373,
  [SMALL_STATE(6748)] = 268390,
  [SMALL_STATE(6749)] = 268407,
  [SMALL_STATE(6750)] = 268430,
  [SMALL_STATE(6751)] = 268447,
  [SMALL_STATE(6752)] = 268464,
  [SMALL_STATE(6753)] = 268481,
  [SMALL_STATE(6754)] = 268504,
  [SMALL_STATE(6755)] = 268521,
  [SMALL_STATE(6756)] = 268542,
  [SMALL_STATE(6757)] = 268561,
  [SMALL_STATE(6758)] = 268584,
  [SMALL_STATE(6759)] = 268605,
  [SMALL_STATE(6760)] = 268624,
  [SMALL_STATE(6761)] = 268645,
  [SMALL_STATE(6762)] = 268670,
  [SMALL_STATE(6763)] = 268691,
  [SMALL_STATE(6764)] = 268712,
  [SMALL_STATE(6765)] = 268737,
  [SMALL_STATE(6766)] = 268760,
  [SMALL_STATE(6767)] = 268781,
  [SMALL_STATE(6768)] = 268800,
  [SMALL_STATE(6769)] = 268819,
  [SMALL_STATE(6770)] = 268842,
  [SMALL_STATE(6771)] = 268859,
  [SMALL_STATE(6772)] = 268884,
  [SMALL_STATE(6773)] = 268901,
  [SMALL_STATE(6774)] = 268924,
  [SMALL_STATE(6775)] = 268947,
  [SMALL_STATE(6776)] = 268964,
  [SMALL_STATE(6777)] = 268978,
  [SMALL_STATE(6778)] = 269000,
  [SMALL_STATE(6779)] = 269020,
  [SMALL_STATE(6780)] = 269040,
  [SMALL_STATE(6781)] = 269054,
  [SMALL_STATE(6782)] = 269076,
  [SMALL_STATE(6783)] = 269094,
  [SMALL_STATE(6784)] = 269116,
  [SMALL_STATE(6785)] = 269136,
  [SMALL_STATE(6786)] = 269156,
  [SMALL_STATE(6787)] = 269176,
  [SMALL_STATE(6788)] = 269196,
  [SMALL_STATE(6789)] = 269216,
  [SMALL_STATE(6790)] = 269236,
  [SMALL_STATE(6791)] = 269256,
  [SMALL_STATE(6792)] = 269278,
  [SMALL_STATE(6793)] = 269300,
  [SMALL_STATE(6794)] = 269320,
  [SMALL_STATE(6795)] = 269340,
  [SMALL_STATE(6796)] = 269354,
  [SMALL_STATE(6797)] = 269374,
  [SMALL_STATE(6798)] = 269396,
  [SMALL_STATE(6799)] = 269418,
  [SMALL_STATE(6800)] = 269438,
  [SMALL_STATE(6801)] = 269456,
  [SMALL_STATE(6802)] = 269476,
  [SMALL_STATE(6803)] = 269498,
  [SMALL_STATE(6804)] = 269520,
  [SMALL_STATE(6805)] = 269540,
  [SMALL_STATE(6806)] = 269560,
  [SMALL_STATE(6807)] = 269582,
  [SMALL_STATE(6808)] = 269602,
  [SMALL_STATE(6809)] = 269622,
  [SMALL_STATE(6810)] = 269636,
  [SMALL_STATE(6811)] = 269650,
  [SMALL_STATE(6812)] = 269668,
  [SMALL_STATE(6813)] = 269690,
  [SMALL_STATE(6814)] = 269712,
  [SMALL_STATE(6815)] = 269734,
  [SMALL_STATE(6816)] = 269756,
  [SMALL_STATE(6817)] = 269776,
  [SMALL_STATE(6818)] = 269790,
  [SMALL_STATE(6819)] = 269812,
  [SMALL_STATE(6820)] = 269826,
  [SMALL_STATE(6821)] = 269848,
  [SMALL_STATE(6822)] = 269870,
  [SMALL_STATE(6823)] = 269890,
  [SMALL_STATE(6824)] = 269912,
  [SMALL_STATE(6825)] = 269926,
  [SMALL_STATE(6826)] = 269946,
  [SMALL_STATE(6827)] = 269968,
  [SMALL_STATE(6828)] = 269988,
  [SMALL_STATE(6829)] = 270006,
  [SMALL_STATE(6830)] = 270020,
  [SMALL_STATE(6831)] = 270042,
  [SMALL_STATE(6832)] = 270056,
  [SMALL_STATE(6833)] = 270070,
  [SMALL_STATE(6834)] = 270090,
  [SMALL_STATE(6835)] = 270110,
  [SMALL_STATE(6836)] = 270130,
  [SMALL_STATE(6837)] = 270144,
  [SMALL_STATE(6838)] = 270164,
  [SMALL_STATE(6839)] = 270178,
  [SMALL_STATE(6840)] = 270198,
  [SMALL_STATE(6841)] = 270212,
  [SMALL_STATE(6842)] = 270230,
  [SMALL_STATE(6843)] = 270252,
  [SMALL_STATE(6844)] = 270270,
  [SMALL_STATE(6845)] = 270290,
  [SMALL_STATE(6846)] = 270312,
  [SMALL_STATE(6847)] = 270334,
  [SMALL_STATE(6848)] = 270356,
  [SMALL_STATE(6849)] = 270373,
  [SMALL_STATE(6850)] = 270390,
  [SMALL_STATE(6851)] = 270407,
  [SMALL_STATE(6852)] = 270426,
  [SMALL_STATE(6853)] = 270445,
  [SMALL_STATE(6854)] = 270462,
  [SMALL_STATE(6855)] = 270479,
  [SMALL_STATE(6856)] = 270496,
  [SMALL_STATE(6857)] = 270513,
  [SMALL_STATE(6858)] = 270532,
  [SMALL_STATE(6859)] = 270549,
  [SMALL_STATE(6860)] = 270562,
  [SMALL_STATE(6861)] = 270581,
  [SMALL_STATE(6862)] = 270596,
  [SMALL_STATE(6863)] = 270615,
  [SMALL_STATE(6864)] = 270634,
  [SMALL_STATE(6865)] = 270651,
  [SMALL_STATE(6866)] = 270668,
  [SMALL_STATE(6867)] = 270685,
  [SMALL_STATE(6868)] = 270702,
  [SMALL_STATE(6869)] = 270721,
  [SMALL_STATE(6870)] = 270734,
  [SMALL_STATE(6871)] = 270753,
  [SMALL_STATE(6872)] = 270770,
  [SMALL_STATE(6873)] = 270785,
  [SMALL_STATE(6874)] = 270804,
  [SMALL_STATE(6875)] = 270821,
  [SMALL_STATE(6876)] = 270840,
  [SMALL_STATE(6877)] = 270859,
  [SMALL_STATE(6878)] = 270876,
  [SMALL_STATE(6879)] = 270889,
  [SMALL_STATE(6880)] = 270908,
  [SMALL_STATE(6881)] = 270927,
  [SMALL_STATE(6882)] = 270942,
  [SMALL_STATE(6883)] = 270961,
  [SMALL_STATE(6884)] = 270978,
  [SMALL_STATE(6885)] = 270997,
  [SMALL_STATE(6886)] = 271014,
  [SMALL_STATE(6887)] = 271033,
  [SMALL_STATE(6888)] = 271050,
  [SMALL_STATE(6889)] = 271067,
  [SMALL_STATE(6890)] = 271078,
  [SMALL_STATE(6891)] = 271095,
  [SMALL_STATE(6892)] = 271114,
  [SMALL_STATE(6893)] = 271133,
  [SMALL_STATE(6894)] = 271150,
  [SMALL_STATE(6895)] = 271167,
  [SMALL_STATE(6896)] = 271184,
  [SMALL_STATE(6897)] = 271203,
  [SMALL_STATE(6898)] = 271220,
  [SMALL_STATE(6899)] = 271237,
  [SMALL_STATE(6900)] = 271254,
  [SMALL_STATE(6901)] = 271271,
  [SMALL_STATE(6902)] = 271288,
  [SMALL_STATE(6903)] = 271305,
  [SMALL_STATE(6904)] = 271324,
  [SMALL_STATE(6905)] = 271343,
  [SMALL_STATE(6906)] = 271362,
  [SMALL_STATE(6907)] = 271379,
  [SMALL_STATE(6908)] = 271396,
  [SMALL_STATE(6909)] = 271413,
  [SMALL_STATE(6910)] = 271430,
  [SMALL_STATE(6911)] = 271447,
  [SMALL_STATE(6912)] = 271464,
  [SMALL_STATE(6913)] = 271481,
  [SMALL_STATE(6914)] = 271498,
  [SMALL_STATE(6915)] = 271515,
  [SMALL_STATE(6916)] = 271534,
  [SMALL_STATE(6917)] = 271553,
  [SMALL_STATE(6918)] = 271570,
  [SMALL_STATE(6919)] = 271587,
  [SMALL_STATE(6920)] = 271604,
  [SMALL_STATE(6921)] = 271621,
  [SMALL_STATE(6922)] = 271638,
  [SMALL_STATE(6923)] = 271655,
  [SMALL_STATE(6924)] = 271670,
  [SMALL_STATE(6925)] = 271687,
  [SMALL_STATE(6926)] = 271704,
  [SMALL_STATE(6927)] = 271723,
  [SMALL_STATE(6928)] = 271740,
  [SMALL_STATE(6929)] = 271759,
  [SMALL_STATE(6930)] = 271776,
  [SMALL_STATE(6931)] = 271792,
  [SMALL_STATE(6932)] = 271808,
  [SMALL_STATE(6933)] = 271822,
  [SMALL_STATE(6934)] = 271838,
  [SMALL_STATE(6935)] = 271854,
  [SMALL_STATE(6936)] = 271868,
  [SMALL_STATE(6937)] = 271882,
  [SMALL_STATE(6938)] = 271898,
  [SMALL_STATE(6939)] = 271914,
  [SMALL_STATE(6940)] = 271930,
  [SMALL_STATE(6941)] = 271940,
  [SMALL_STATE(6942)] = 271950,
  [SMALL_STATE(6943)] = 271964,
  [SMALL_STATE(6944)] = 271980,
  [SMALL_STATE(6945)] = 271994,
  [SMALL_STATE(6946)] = 272010,
  [SMALL_STATE(6947)] = 272026,
  [SMALL_STATE(6948)] = 272042,
  [SMALL_STATE(6949)] = 272056,
  [SMALL_STATE(6950)] = 272072,
  [SMALL_STATE(6951)] = 272088,
  [SMALL_STATE(6952)] = 272100,
  [SMALL_STATE(6953)] = 272116,
  [SMALL_STATE(6954)] = 272132,
  [SMALL_STATE(6955)] = 272148,
  [SMALL_STATE(6956)] = 272164,
  [SMALL_STATE(6957)] = 272180,
  [SMALL_STATE(6958)] = 272194,
  [SMALL_STATE(6959)] = 272210,
  [SMALL_STATE(6960)] = 272226,
  [SMALL_STATE(6961)] = 272242,
  [SMALL_STATE(6962)] = 272258,
  [SMALL_STATE(6963)] = 272272,
  [SMALL_STATE(6964)] = 272286,
  [SMALL_STATE(6965)] = 272302,
  [SMALL_STATE(6966)] = 272318,
  [SMALL_STATE(6967)] = 272334,
  [SMALL_STATE(6968)] = 272350,
  [SMALL_STATE(6969)] = 272366,
  [SMALL_STATE(6970)] = 272376,
  [SMALL_STATE(6971)] = 272392,
  [SMALL_STATE(6972)] = 272408,
  [SMALL_STATE(6973)] = 272422,
  [SMALL_STATE(6974)] = 272436,
  [SMALL_STATE(6975)] = 272452,
  [SMALL_STATE(6976)] = 272466,
  [SMALL_STATE(6977)] = 272482,
  [SMALL_STATE(6978)] = 272498,
  [SMALL_STATE(6979)] = 272514,
  [SMALL_STATE(6980)] = 272530,
  [SMALL_STATE(6981)] = 272546,
  [SMALL_STATE(6982)] = 272562,
  [SMALL_STATE(6983)] = 272578,
  [SMALL_STATE(6984)] = 272592,
  [SMALL_STATE(6985)] = 272608,
  [SMALL_STATE(6986)] = 272624,
  [SMALL_STATE(6987)] = 272640,
  [SMALL_STATE(6988)] = 272656,
  [SMALL_STATE(6989)] = 272670,
  [SMALL_STATE(6990)] = 272686,
  [SMALL_STATE(6991)] = 272702,
  [SMALL_STATE(6992)] = 272718,
  [SMALL_STATE(6993)] = 272734,
  [SMALL_STATE(6994)] = 272750,
  [SMALL_STATE(6995)] = 272766,
  [SMALL_STATE(6996)] = 272782,
  [SMALL_STATE(6997)] = 272796,
  [SMALL_STATE(6998)] = 272812,
  [SMALL_STATE(6999)] = 272828,
  [SMALL_STATE(7000)] = 272844,
  [SMALL_STATE(7001)] = 272860,
  [SMALL_STATE(7002)] = 272876,
  [SMALL_STATE(7003)] = 272892,
  [SMALL_STATE(7004)] = 272908,
  [SMALL_STATE(7005)] = 272924,
  [SMALL_STATE(7006)] = 272940,
  [SMALL_STATE(7007)] = 272956,
  [SMALL_STATE(7008)] = 272972,
  [SMALL_STATE(7009)] = 272988,
  [SMALL_STATE(7010)] = 273004,
  [SMALL_STATE(7011)] = 273020,
  [SMALL_STATE(7012)] = 273036,
  [SMALL_STATE(7013)] = 273052,
  [SMALL_STATE(7014)] = 273068,
  [SMALL_STATE(7015)] = 273084,
  [SMALL_STATE(7016)] = 273100,
  [SMALL_STATE(7017)] = 273116,
  [SMALL_STATE(7018)] = 273130,
  [SMALL_STATE(7019)] = 273146,
  [SMALL_STATE(7020)] = 273162,
  [SMALL_STATE(7021)] = 273176,
  [SMALL_STATE(7022)] = 273192,
  [SMALL_STATE(7023)] = 273208,
  [SMALL_STATE(7024)] = 273224,
  [SMALL_STATE(7025)] = 273240,
  [SMALL_STATE(7026)] = 273256,
  [SMALL_STATE(7027)] = 273270,
  [SMALL_STATE(7028)] = 273286,
  [SMALL_STATE(7029)] = 273300,
  [SMALL_STATE(7030)] = 273314,
  [SMALL_STATE(7031)] = 273330,
  [SMALL_STATE(7032)] = 273342,
  [SMALL_STATE(7033)] = 273358,
  [SMALL_STATE(7034)] = 273374,
  [SMALL_STATE(7035)] = 273388,
  [SMALL_STATE(7036)] = 273402,
  [SMALL_STATE(7037)] = 273416,
  [SMALL_STATE(7038)] = 273430,
  [SMALL_STATE(7039)] = 273446,
  [SMALL_STATE(7040)] = 273462,
  [SMALL_STATE(7041)] = 273478,
  [SMALL_STATE(7042)] = 273494,
  [SMALL_STATE(7043)] = 273510,
  [SMALL_STATE(7044)] = 273526,
  [SMALL_STATE(7045)] = 273542,
  [SMALL_STATE(7046)] = 273554,
  [SMALL_STATE(7047)] = 273568,
  [SMALL_STATE(7048)] = 273582,
  [SMALL_STATE(7049)] = 273596,
  [SMALL_STATE(7050)] = 273612,
  [SMALL_STATE(7051)] = 273624,
  [SMALL_STATE(7052)] = 273638,
  [SMALL_STATE(7053)] = 273654,
  [SMALL_STATE(7054)] = 273670,
  [SMALL_STATE(7055)] = 273684,
  [SMALL_STATE(7056)] = 273698,
  [SMALL_STATE(7057)] = 273714,
  [SMALL_STATE(7058)] = 273730,
  [SMALL_STATE(7059)] = 273746,
  [SMALL_STATE(7060)] = 273760,
  [SMALL_STATE(7061)] = 273776,
  [SMALL_STATE(7062)] = 273792,
  [SMALL_STATE(7063)] = 273806,
  [SMALL_STATE(7064)] = 273820,
  [SMALL_STATE(7065)] = 273836,
  [SMALL_STATE(7066)] = 273852,
  [SMALL_STATE(7067)] = 273868,
  [SMALL_STATE(7068)] = 273882,
  [SMALL_STATE(7069)] = 273898,
  [SMALL_STATE(7070)] = 273914,
  [SMALL_STATE(7071)] = 273930,
  [SMALL_STATE(7072)] = 273944,
  [SMALL_STATE(7073)] = 273958,
  [SMALL_STATE(7074)] = 273974,
  [SMALL_STATE(7075)] = 273990,
  [SMALL_STATE(7076)] = 274004,
  [SMALL_STATE(7077)] = 274018,
  [SMALL_STATE(7078)] = 274034,
  [SMALL_STATE(7079)] = 274050,
  [SMALL_STATE(7080)] = 274064,
  [SMALL_STATE(7081)] = 274080,
  [SMALL_STATE(7082)] = 274096,
  [SMALL_STATE(7083)] = 274112,
  [SMALL_STATE(7084)] = 274128,
  [SMALL_STATE(7085)] = 274144,
  [SMALL_STATE(7086)] = 274158,
  [SMALL_STATE(7087)] = 274174,
  [SMALL_STATE(7088)] = 274188,
  [SMALL_STATE(7089)] = 274204,
  [SMALL_STATE(7090)] = 274220,
  [SMALL_STATE(7091)] = 274236,
  [SMALL_STATE(7092)] = 274250,
  [SMALL_STATE(7093)] = 274264,
  [SMALL_STATE(7094)] = 274278,
  [SMALL_STATE(7095)] = 274294,
  [SMALL_STATE(7096)] = 274310,
  [SMALL_STATE(7097)] = 274326,
  [SMALL_STATE(7098)] = 274340,
  [SMALL_STATE(7099)] = 274356,
  [SMALL_STATE(7100)] = 274372,
  [SMALL_STATE(7101)] = 274388,
  [SMALL_STATE(7102)] = 274404,
  [SMALL_STATE(7103)] = 274420,
  [SMALL_STATE(7104)] = 274436,
  [SMALL_STATE(7105)] = 274450,
  [SMALL_STATE(7106)] = 274466,
  [SMALL_STATE(7107)] = 274482,
  [SMALL_STATE(7108)] = 274496,
  [SMALL_STATE(7109)] = 274512,
  [SMALL_STATE(7110)] = 274526,
  [SMALL_STATE(7111)] = 274542,
  [SMALL_STATE(7112)] = 274558,
  [SMALL_STATE(7113)] = 274574,
  [SMALL_STATE(7114)] = 274590,
  [SMALL_STATE(7115)] = 274606,
  [SMALL_STATE(7116)] = 274622,
  [SMALL_STATE(7117)] = 274636,
  [SMALL_STATE(7118)] = 274652,
  [SMALL_STATE(7119)] = 274666,
  [SMALL_STATE(7120)] = 274682,
  [SMALL_STATE(7121)] = 274696,
  [SMALL_STATE(7122)] = 274712,
  [SMALL_STATE(7123)] = 274728,
  [SMALL_STATE(7124)] = 274742,
  [SMALL_STATE(7125)] = 274758,
  [SMALL_STATE(7126)] = 274774,
  [SMALL_STATE(7127)] = 274790,
  [SMALL_STATE(7128)] = 274806,
  [SMALL_STATE(7129)] = 274820,
  [SMALL_STATE(7130)] = 274836,
  [SMALL_STATE(7131)] = 274852,
  [SMALL_STATE(7132)] = 274866,
  [SMALL_STATE(7133)] = 274882,
  [SMALL_STATE(7134)] = 274898,
  [SMALL_STATE(7135)] = 274912,
  [SMALL_STATE(7136)] = 274928,
  [SMALL_STATE(7137)] = 274941,
  [SMALL_STATE(7138)] = 274954,
  [SMALL_STATE(7139)] = 274967,
  [SMALL_STATE(7140)] = 274978,
  [SMALL_STATE(7141)] = 274991,
  [SMALL_STATE(7142)] = 275004,
  [SMALL_STATE(7143)] = 275013,
  [SMALL_STATE(7144)] = 275026,
  [SMALL_STATE(7145)] = 275037,
  [SMALL_STATE(7146)] = 275046,
  [SMALL_STATE(7147)] = 275059,
  [SMALL_STATE(7148)] = 275072,
  [SMALL_STATE(7149)] = 275083,
  [SMALL_STATE(7150)] = 275096,
  [SMALL_STATE(7151)] = 275109,
  [SMALL_STATE(7152)] = 275122,
  [SMALL_STATE(7153)] = 275135,
  [SMALL_STATE(7154)] = 275148,
  [SMALL_STATE(7155)] = 275161,
  [SMALL_STATE(7156)] = 275174,
  [SMALL_STATE(7157)] = 275187,
  [SMALL_STATE(7158)] = 275200,
  [SMALL_STATE(7159)] = 275213,
  [SMALL_STATE(7160)] = 275224,
  [SMALL_STATE(7161)] = 275237,
  [SMALL_STATE(7162)] = 275250,
  [SMALL_STATE(7163)] = 275263,
  [SMALL_STATE(7164)] = 275276,
  [SMALL_STATE(7165)] = 275289,
  [SMALL_STATE(7166)] = 275302,
  [SMALL_STATE(7167)] = 275315,
  [SMALL_STATE(7168)] = 275326,
  [SMALL_STATE(7169)] = 275337,
  [SMALL_STATE(7170)] = 275350,
  [SMALL_STATE(7171)] = 275363,
  [SMALL_STATE(7172)] = 275376,
  [SMALL_STATE(7173)] = 275389,
  [SMALL_STATE(7174)] = 275402,
  [SMALL_STATE(7175)] = 275415,
  [SMALL_STATE(7176)] = 275428,
  [SMALL_STATE(7177)] = 275441,
  [SMALL_STATE(7178)] = 275454,
  [SMALL_STATE(7179)] = 275467,
  [SMALL_STATE(7180)] = 275480,
  [SMALL_STATE(7181)] = 275491,
  [SMALL_STATE(7182)] = 275504,
  [SMALL_STATE(7183)] = 275517,
  [SMALL_STATE(7184)] = 275530,
  [SMALL_STATE(7185)] = 275543,
  [SMALL_STATE(7186)] = 275556,
  [SMALL_STATE(7187)] = 275569,
  [SMALL_STATE(7188)] = 275582,
  [SMALL_STATE(7189)] = 275595,
  [SMALL_STATE(7190)] = 275608,
  [SMALL_STATE(7191)] = 275621,
  [SMALL_STATE(7192)] = 275634,
  [SMALL_STATE(7193)] = 275647,
  [SMALL_STATE(7194)] = 275660,
  [SMALL_STATE(7195)] = 275673,
  [SMALL_STATE(7196)] = 275686,
  [SMALL_STATE(7197)] = 275699,
  [SMALL_STATE(7198)] = 275712,
  [SMALL_STATE(7199)] = 275725,
  [SMALL_STATE(7200)] = 275738,
  [SMALL_STATE(7201)] = 275749,
  [SMALL_STATE(7202)] = 275762,
  [SMALL_STATE(7203)] = 275775,
  [SMALL_STATE(7204)] = 275788,
  [SMALL_STATE(7205)] = 275801,
  [SMALL_STATE(7206)] = 275814,
  [SMALL_STATE(7207)] = 275827,
  [SMALL_STATE(7208)] = 275840,
  [SMALL_STATE(7209)] = 275853,
  [SMALL_STATE(7210)] = 275866,
  [SMALL_STATE(7211)] = 275879,
  [SMALL_STATE(7212)] = 275892,
  [SMALL_STATE(7213)] = 275905,
  [SMALL_STATE(7214)] = 275918,
  [SMALL_STATE(7215)] = 275931,
  [SMALL_STATE(7216)] = 275944,
  [SMALL_STATE(7217)] = 275957,
  [SMALL_STATE(7218)] = 275970,
  [SMALL_STATE(7219)] = 275983,
  [SMALL_STATE(7220)] = 275996,
  [SMALL_STATE(7221)] = 276009,
  [SMALL_STATE(7222)] = 276022,
  [SMALL_STATE(7223)] = 276035,
  [SMALL_STATE(7224)] = 276048,
  [SMALL_STATE(7225)] = 276061,
  [SMALL_STATE(7226)] = 276074,
  [SMALL_STATE(7227)] = 276087,
  [SMALL_STATE(7228)] = 276100,
  [SMALL_STATE(7229)] = 276113,
  [SMALL_STATE(7230)] = 276126,
  [SMALL_STATE(7231)] = 276139,
  [SMALL_STATE(7232)] = 276152,
  [SMALL_STATE(7233)] = 276165,
  [SMALL_STATE(7234)] = 276178,
  [SMALL_STATE(7235)] = 276191,
  [SMALL_STATE(7236)] = 276204,
  [SMALL_STATE(7237)] = 276217,
  [SMALL_STATE(7238)] = 276230,
  [SMALL_STATE(7239)] = 276243,
  [SMALL_STATE(7240)] = 276256,
  [SMALL_STATE(7241)] = 276269,
  [SMALL_STATE(7242)] = 276282,
  [SMALL_STATE(7243)] = 276295,
  [SMALL_STATE(7244)] = 276308,
  [SMALL_STATE(7245)] = 276321,
  [SMALL_STATE(7246)] = 276334,
  [SMALL_STATE(7247)] = 276347,
  [SMALL_STATE(7248)] = 276360,
  [SMALL_STATE(7249)] = 276369,
  [SMALL_STATE(7250)] = 276382,
  [SMALL_STATE(7251)] = 276395,
  [SMALL_STATE(7252)] = 276408,
  [SMALL_STATE(7253)] = 276417,
  [SMALL_STATE(7254)] = 276430,
  [SMALL_STATE(7255)] = 276441,
  [SMALL_STATE(7256)] = 276454,
  [SMALL_STATE(7257)] = 276467,
  [SMALL_STATE(7258)] = 276480,
  [SMALL_STATE(7259)] = 276493,
  [SMALL_STATE(7260)] = 276504,
  [SMALL_STATE(7261)] = 276517,
  [SMALL_STATE(7262)] = 276530,
  [SMALL_STATE(7263)] = 276543,
  [SMALL_STATE(7264)] = 276556,
  [SMALL_STATE(7265)] = 276569,
  [SMALL_STATE(7266)] = 276582,
  [SMALL_STATE(7267)] = 276595,
  [SMALL_STATE(7268)] = 276608,
  [SMALL_STATE(7269)] = 276621,
  [SMALL_STATE(7270)] = 276632,
  [SMALL_STATE(7271)] = 276645,
  [SMALL_STATE(7272)] = 276658,
  [SMALL_STATE(7273)] = 276671,
  [SMALL_STATE(7274)] = 276684,
  [SMALL_STATE(7275)] = 276697,
  [SMALL_STATE(7276)] = 276706,
  [SMALL_STATE(7277)] = 276715,
  [SMALL_STATE(7278)] = 276728,
  [SMALL_STATE(7279)] = 276741,
  [SMALL_STATE(7280)] = 276754,
  [SMALL_STATE(7281)] = 276767,
  [SMALL_STATE(7282)] = 276780,
  [SMALL_STATE(7283)] = 276793,
  [SMALL_STATE(7284)] = 276806,
  [SMALL_STATE(7285)] = 276817,
  [SMALL_STATE(7286)] = 276826,
  [SMALL_STATE(7287)] = 276839,
  [SMALL_STATE(7288)] = 276852,
  [SMALL_STATE(7289)] = 276865,
  [SMALL_STATE(7290)] = 276878,
  [SMALL_STATE(7291)] = 276891,
  [SMALL_STATE(7292)] = 276904,
  [SMALL_STATE(7293)] = 276917,
  [SMALL_STATE(7294)] = 276930,
  [SMALL_STATE(7295)] = 276939,
  [SMALL_STATE(7296)] = 276952,
  [SMALL_STATE(7297)] = 276965,
  [SMALL_STATE(7298)] = 276976,
  [SMALL_STATE(7299)] = 276989,
  [SMALL_STATE(7300)] = 277002,
  [SMALL_STATE(7301)] = 277015,
  [SMALL_STATE(7302)] = 277028,
  [SMALL_STATE(7303)] = 277041,
  [SMALL_STATE(7304)] = 277054,
  [SMALL_STATE(7305)] = 277067,
  [SMALL_STATE(7306)] = 277080,
  [SMALL_STATE(7307)] = 277093,
  [SMALL_STATE(7308)] = 277106,
  [SMALL_STATE(7309)] = 277119,
  [SMALL_STATE(7310)] = 277132,
  [SMALL_STATE(7311)] = 277145,
  [SMALL_STATE(7312)] = 277158,
  [SMALL_STATE(7313)] = 277171,
  [SMALL_STATE(7314)] = 277184,
  [SMALL_STATE(7315)] = 277195,
  [SMALL_STATE(7316)] = 277208,
  [SMALL_STATE(7317)] = 277219,
  [SMALL_STATE(7318)] = 277230,
  [SMALL_STATE(7319)] = 277243,
  [SMALL_STATE(7320)] = 277256,
  [SMALL_STATE(7321)] = 277269,
  [SMALL_STATE(7322)] = 277282,
  [SMALL_STATE(7323)] = 277295,
  [SMALL_STATE(7324)] = 277304,
  [SMALL_STATE(7325)] = 277317,
  [SMALL_STATE(7326)] = 277330,
  [SMALL_STATE(7327)] = 277343,
  [SMALL_STATE(7328)] = 277356,
  [SMALL_STATE(7329)] = 277369,
  [SMALL_STATE(7330)] = 277382,
  [SMALL_STATE(7331)] = 277395,
  [SMALL_STATE(7332)] = 277408,
  [SMALL_STATE(7333)] = 277421,
  [SMALL_STATE(7334)] = 277434,
  [SMALL_STATE(7335)] = 277445,
  [SMALL_STATE(7336)] = 277458,
  [SMALL_STATE(7337)] = 277471,
  [SMALL_STATE(7338)] = 277484,
  [SMALL_STATE(7339)] = 277497,
  [SMALL_STATE(7340)] = 277510,
  [SMALL_STATE(7341)] = 277523,
  [SMALL_STATE(7342)] = 277536,
  [SMALL_STATE(7343)] = 277549,
  [SMALL_STATE(7344)] = 277562,
  [SMALL_STATE(7345)] = 277573,
  [SMALL_STATE(7346)] = 277586,
  [SMALL_STATE(7347)] = 277599,
  [SMALL_STATE(7348)] = 277610,
  [SMALL_STATE(7349)] = 277623,
  [SMALL_STATE(7350)] = 277636,
  [SMALL_STATE(7351)] = 277645,
  [SMALL_STATE(7352)] = 277658,
  [SMALL_STATE(7353)] = 277671,
  [SMALL_STATE(7354)] = 277684,
  [SMALL_STATE(7355)] = 277697,
  [SMALL_STATE(7356)] = 277710,
  [SMALL_STATE(7357)] = 277723,
  [SMALL_STATE(7358)] = 277736,
  [SMALL_STATE(7359)] = 277747,
  [SMALL_STATE(7360)] = 277760,
  [SMALL_STATE(7361)] = 277771,
  [SMALL_STATE(7362)] = 277782,
  [SMALL_STATE(7363)] = 277795,
  [SMALL_STATE(7364)] = 277808,
  [SMALL_STATE(7365)] = 277821,
  [SMALL_STATE(7366)] = 277834,
  [SMALL_STATE(7367)] = 277847,
  [SMALL_STATE(7368)] = 277856,
  [SMALL_STATE(7369)] = 277865,
  [SMALL_STATE(7370)] = 277876,
  [SMALL_STATE(7371)] = 277889,
  [SMALL_STATE(7372)] = 277900,
  [SMALL_STATE(7373)] = 277913,
  [SMALL_STATE(7374)] = 277924,
  [SMALL_STATE(7375)] = 277937,
  [SMALL_STATE(7376)] = 277950,
  [SMALL_STATE(7377)] = 277963,
  [SMALL_STATE(7378)] = 277976,
  [SMALL_STATE(7379)] = 277987,
  [SMALL_STATE(7380)] = 278000,
  [SMALL_STATE(7381)] = 278013,
  [SMALL_STATE(7382)] = 278026,
  [SMALL_STATE(7383)] = 278039,
  [SMALL_STATE(7384)] = 278052,
  [SMALL_STATE(7385)] = 278065,
  [SMALL_STATE(7386)] = 278078,
  [SMALL_STATE(7387)] = 278091,
  [SMALL_STATE(7388)] = 278104,
  [SMALL_STATE(7389)] = 278117,
  [SMALL_STATE(7390)] = 278126,
  [SMALL_STATE(7391)] = 278139,
  [SMALL_STATE(7392)] = 278152,
  [SMALL_STATE(7393)] = 278163,
  [SMALL_STATE(7394)] = 278176,
  [SMALL_STATE(7395)] = 278189,
  [SMALL_STATE(7396)] = 278202,
  [SMALL_STATE(7397)] = 278215,
  [SMALL_STATE(7398)] = 278228,
  [SMALL_STATE(7399)] = 278241,
  [SMALL_STATE(7400)] = 278254,
  [SMALL_STATE(7401)] = 278267,
  [SMALL_STATE(7402)] = 278280,
  [SMALL_STATE(7403)] = 278293,
  [SMALL_STATE(7404)] = 278304,
  [SMALL_STATE(7405)] = 278317,
  [SMALL_STATE(7406)] = 278328,
  [SMALL_STATE(7407)] = 278341,
  [SMALL_STATE(7408)] = 278354,
  [SMALL_STATE(7409)] = 278365,
  [SMALL_STATE(7410)] = 278378,
  [SMALL_STATE(7411)] = 278391,
  [SMALL_STATE(7412)] = 278404,
  [SMALL_STATE(7413)] = 278417,
  [SMALL_STATE(7414)] = 278430,
  [SMALL_STATE(7415)] = 278443,
  [SMALL_STATE(7416)] = 278456,
  [SMALL_STATE(7417)] = 278469,
  [SMALL_STATE(7418)] = 278482,
  [SMALL_STATE(7419)] = 278495,
  [SMALL_STATE(7420)] = 278508,
  [SMALL_STATE(7421)] = 278521,
  [SMALL_STATE(7422)] = 278534,
  [SMALL_STATE(7423)] = 278545,
  [SMALL_STATE(7424)] = 278558,
  [SMALL_STATE(7425)] = 278569,
  [SMALL_STATE(7426)] = 278582,
  [SMALL_STATE(7427)] = 278591,
  [SMALL_STATE(7428)] = 278604,
  [SMALL_STATE(7429)] = 278617,
  [SMALL_STATE(7430)] = 278630,
  [SMALL_STATE(7431)] = 278643,
  [SMALL_STATE(7432)] = 278656,
  [SMALL_STATE(7433)] = 278669,
  [SMALL_STATE(7434)] = 278682,
  [SMALL_STATE(7435)] = 278691,
  [SMALL_STATE(7436)] = 278704,
  [SMALL_STATE(7437)] = 278717,
  [SMALL_STATE(7438)] = 278730,
  [SMALL_STATE(7439)] = 278743,
  [SMALL_STATE(7440)] = 278756,
  [SMALL_STATE(7441)] = 278769,
  [SMALL_STATE(7442)] = 278782,
  [SMALL_STATE(7443)] = 278795,
  [SMALL_STATE(7444)] = 278806,
  [SMALL_STATE(7445)] = 278819,
  [SMALL_STATE(7446)] = 278832,
  [SMALL_STATE(7447)] = 278845,
  [SMALL_STATE(7448)] = 278858,
  [SMALL_STATE(7449)] = 278869,
  [SMALL_STATE(7450)] = 278882,
  [SMALL_STATE(7451)] = 278895,
  [SMALL_STATE(7452)] = 278908,
  [SMALL_STATE(7453)] = 278921,
  [SMALL_STATE(7454)] = 278932,
  [SMALL_STATE(7455)] = 278945,
  [SMALL_STATE(7456)] = 278958,
  [SMALL_STATE(7457)] = 278971,
  [SMALL_STATE(7458)] = 278984,
  [SMALL_STATE(7459)] = 278995,
  [SMALL_STATE(7460)] = 279008,
  [SMALL_STATE(7461)] = 279021,
  [SMALL_STATE(7462)] = 279032,
  [SMALL_STATE(7463)] = 279043,
  [SMALL_STATE(7464)] = 279054,
  [SMALL_STATE(7465)] = 279065,
  [SMALL_STATE(7466)] = 279078,
  [SMALL_STATE(7467)] = 279089,
  [SMALL_STATE(7468)] = 279100,
  [SMALL_STATE(7469)] = 279111,
  [SMALL_STATE(7470)] = 279124,
  [SMALL_STATE(7471)] = 279137,
  [SMALL_STATE(7472)] = 279150,
  [SMALL_STATE(7473)] = 279163,
  [SMALL_STATE(7474)] = 279176,
  [SMALL_STATE(7475)] = 279189,
  [SMALL_STATE(7476)] = 279200,
  [SMALL_STATE(7477)] = 279213,
  [SMALL_STATE(7478)] = 279222,
  [SMALL_STATE(7479)] = 279231,
  [SMALL_STATE(7480)] = 279244,
  [SMALL_STATE(7481)] = 279257,
  [SMALL_STATE(7482)] = 279270,
  [SMALL_STATE(7483)] = 279283,
  [SMALL_STATE(7484)] = 279296,
  [SMALL_STATE(7485)] = 279309,
  [SMALL_STATE(7486)] = 279322,
  [SMALL_STATE(7487)] = 279335,
  [SMALL_STATE(7488)] = 279348,
  [SMALL_STATE(7489)] = 279361,
  [SMALL_STATE(7490)] = 279374,
  [SMALL_STATE(7491)] = 279387,
  [SMALL_STATE(7492)] = 279400,
  [SMALL_STATE(7493)] = 279413,
  [SMALL_STATE(7494)] = 279424,
  [SMALL_STATE(7495)] = 279437,
  [SMALL_STATE(7496)] = 279448,
  [SMALL_STATE(7497)] = 279459,
  [SMALL_STATE(7498)] = 279470,
  [SMALL_STATE(7499)] = 279483,
  [SMALL_STATE(7500)] = 279496,
  [SMALL_STATE(7501)] = 279509,
  [SMALL_STATE(7502)] = 279522,
  [SMALL_STATE(7503)] = 279535,
  [SMALL_STATE(7504)] = 279548,
  [SMALL_STATE(7505)] = 279561,
  [SMALL_STATE(7506)] = 279574,
  [SMALL_STATE(7507)] = 279587,
  [SMALL_STATE(7508)] = 279600,
  [SMALL_STATE(7509)] = 279611,
  [SMALL_STATE(7510)] = 279624,
  [SMALL_STATE(7511)] = 279635,
  [SMALL_STATE(7512)] = 279648,
  [SMALL_STATE(7513)] = 279661,
  [SMALL_STATE(7514)] = 279674,
  [SMALL_STATE(7515)] = 279687,
  [SMALL_STATE(7516)] = 279700,
  [SMALL_STATE(7517)] = 279713,
  [SMALL_STATE(7518)] = 279726,
  [SMALL_STATE(7519)] = 279737,
  [SMALL_STATE(7520)] = 279748,
  [SMALL_STATE(7521)] = 279759,
  [SMALL_STATE(7522)] = 279772,
  [SMALL_STATE(7523)] = 279785,
  [SMALL_STATE(7524)] = 279798,
  [SMALL_STATE(7525)] = 279811,
  [SMALL_STATE(7526)] = 279824,
  [SMALL_STATE(7527)] = 279837,
  [SMALL_STATE(7528)] = 279848,
  [SMALL_STATE(7529)] = 279859,
  [SMALL_STATE(7530)] = 279870,
  [SMALL_STATE(7531)] = 279881,
  [SMALL_STATE(7532)] = 279894,
  [SMALL_STATE(7533)] = 279907,
  [SMALL_STATE(7534)] = 279920,
  [SMALL_STATE(7535)] = 279933,
  [SMALL_STATE(7536)] = 279946,
  [SMALL_STATE(7537)] = 279959,
  [SMALL_STATE(7538)] = 279972,
  [SMALL_STATE(7539)] = 279985,
  [SMALL_STATE(7540)] = 279998,
  [SMALL_STATE(7541)] = 280011,
  [SMALL_STATE(7542)] = 280024,
  [SMALL_STATE(7543)] = 280037,
  [SMALL_STATE(7544)] = 280050,
  [SMALL_STATE(7545)] = 280063,
  [SMALL_STATE(7546)] = 280076,
  [SMALL_STATE(7547)] = 280089,
  [SMALL_STATE(7548)] = 280102,
  [SMALL_STATE(7549)] = 280113,
  [SMALL_STATE(7550)] = 280126,
  [SMALL_STATE(7551)] = 280139,
  [SMALL_STATE(7552)] = 280152,
  [SMALL_STATE(7553)] = 280165,
  [SMALL_STATE(7554)] = 280178,
  [SMALL_STATE(7555)] = 280191,
  [SMALL_STATE(7556)] = 280204,
  [SMALL_STATE(7557)] = 280217,
  [SMALL_STATE(7558)] = 280230,
  [SMALL_STATE(7559)] = 280243,
  [SMALL_STATE(7560)] = 280256,
  [SMALL_STATE(7561)] = 280269,
  [SMALL_STATE(7562)] = 280279,
  [SMALL_STATE(7563)] = 280287,
  [SMALL_STATE(7564)] = 280297,
  [SMALL_STATE(7565)] = 280305,
  [SMALL_STATE(7566)] = 280315,
  [SMALL_STATE(7567)] = 280325,
  [SMALL_STATE(7568)] = 280335,
  [SMALL_STATE(7569)] = 280345,
  [SMALL_STATE(7570)] = 280353,
  [SMALL_STATE(7571)] = 280363,
  [SMALL_STATE(7572)] = 280373,
  [SMALL_STATE(7573)] = 280383,
  [SMALL_STATE(7574)] = 280393,
  [SMALL_STATE(7575)] = 280403,
  [SMALL_STATE(7576)] = 280413,
  [SMALL_STATE(7577)] = 280423,
  [SMALL_STATE(7578)] = 280433,
  [SMALL_STATE(7579)] = 280443,
  [SMALL_STATE(7580)] = 280453,
  [SMALL_STATE(7581)] = 280461,
  [SMALL_STATE(7582)] = 280471,
  [SMALL_STATE(7583)] = 280481,
  [SMALL_STATE(7584)] = 280491,
  [SMALL_STATE(7585)] = 280499,
  [SMALL_STATE(7586)] = 280509,
  [SMALL_STATE(7587)] = 280517,
  [SMALL_STATE(7588)] = 280527,
  [SMALL_STATE(7589)] = 280537,
  [SMALL_STATE(7590)] = 280547,
  [SMALL_STATE(7591)] = 280555,
  [SMALL_STATE(7592)] = 280565,
  [SMALL_STATE(7593)] = 280575,
  [SMALL_STATE(7594)] = 280585,
  [SMALL_STATE(7595)] = 280595,
  [SMALL_STATE(7596)] = 280605,
  [SMALL_STATE(7597)] = 280613,
  [SMALL_STATE(7598)] = 280623,
  [SMALL_STATE(7599)] = 280633,
  [SMALL_STATE(7600)] = 280643,
  [SMALL_STATE(7601)] = 280653,
  [SMALL_STATE(7602)] = 280663,
  [SMALL_STATE(7603)] = 280673,
  [SMALL_STATE(7604)] = 280683,
  [SMALL_STATE(7605)] = 280693,
  [SMALL_STATE(7606)] = 280703,
  [SMALL_STATE(7607)] = 280713,
  [SMALL_STATE(7608)] = 280723,
  [SMALL_STATE(7609)] = 280733,
  [SMALL_STATE(7610)] = 280743,
  [SMALL_STATE(7611)] = 280753,
  [SMALL_STATE(7612)] = 280763,
  [SMALL_STATE(7613)] = 280773,
  [SMALL_STATE(7614)] = 280783,
  [SMALL_STATE(7615)] = 280793,
  [SMALL_STATE(7616)] = 280803,
  [SMALL_STATE(7617)] = 280813,
  [SMALL_STATE(7618)] = 280823,
  [SMALL_STATE(7619)] = 280833,
  [SMALL_STATE(7620)] = 280843,
  [SMALL_STATE(7621)] = 280853,
  [SMALL_STATE(7622)] = 280863,
  [SMALL_STATE(7623)] = 280873,
  [SMALL_STATE(7624)] = 280883,
  [SMALL_STATE(7625)] = 280893,
  [SMALL_STATE(7626)] = 280903,
  [SMALL_STATE(7627)] = 280913,
  [SMALL_STATE(7628)] = 280923,
  [SMALL_STATE(7629)] = 280933,
  [SMALL_STATE(7630)] = 280943,
  [SMALL_STATE(7631)] = 280953,
  [SMALL_STATE(7632)] = 280963,
  [SMALL_STATE(7633)] = 280973,
  [SMALL_STATE(7634)] = 280983,
  [SMALL_STATE(7635)] = 280993,
  [SMALL_STATE(7636)] = 281003,
  [SMALL_STATE(7637)] = 281013,
  [SMALL_STATE(7638)] = 281023,
  [SMALL_STATE(7639)] = 281033,
  [SMALL_STATE(7640)] = 281043,
  [SMALL_STATE(7641)] = 281051,
  [SMALL_STATE(7642)] = 281061,
  [SMALL_STATE(7643)] = 281071,
  [SMALL_STATE(7644)] = 281081,
  [SMALL_STATE(7645)] = 281091,
  [SMALL_STATE(7646)] = 281101,
  [SMALL_STATE(7647)] = 281111,
  [SMALL_STATE(7648)] = 281121,
  [SMALL_STATE(7649)] = 281129,
  [SMALL_STATE(7650)] = 281139,
  [SMALL_STATE(7651)] = 281147,
  [SMALL_STATE(7652)] = 281157,
  [SMALL_STATE(7653)] = 281167,
  [SMALL_STATE(7654)] = 281177,
  [SMALL_STATE(7655)] = 281187,
  [SMALL_STATE(7656)] = 281197,
  [SMALL_STATE(7657)] = 281207,
  [SMALL_STATE(7658)] = 281217,
  [SMALL_STATE(7659)] = 281227,
  [SMALL_STATE(7660)] = 281237,
  [SMALL_STATE(7661)] = 281247,
  [SMALL_STATE(7662)] = 281257,
  [SMALL_STATE(7663)] = 281267,
  [SMALL_STATE(7664)] = 281277,
  [SMALL_STATE(7665)] = 281287,
  [SMALL_STATE(7666)] = 281297,
  [SMALL_STATE(7667)] = 281307,
  [SMALL_STATE(7668)] = 281317,
  [SMALL_STATE(7669)] = 281327,
  [SMALL_STATE(7670)] = 281337,
  [SMALL_STATE(7671)] = 281347,
  [SMALL_STATE(7672)] = 281357,
  [SMALL_STATE(7673)] = 281367,
  [SMALL_STATE(7674)] = 281377,
  [SMALL_STATE(7675)] = 281387,
  [SMALL_STATE(7676)] = 281397,
  [SMALL_STATE(7677)] = 281407,
  [SMALL_STATE(7678)] = 281417,
  [SMALL_STATE(7679)] = 281427,
  [SMALL_STATE(7680)] = 281437,
  [SMALL_STATE(7681)] = 281445,
  [SMALL_STATE(7682)] = 281455,
  [SMALL_STATE(7683)] = 281465,
  [SMALL_STATE(7684)] = 281475,
  [SMALL_STATE(7685)] = 281485,
  [SMALL_STATE(7686)] = 281495,
  [SMALL_STATE(7687)] = 281505,
  [SMALL_STATE(7688)] = 281515,
  [SMALL_STATE(7689)] = 281525,
  [SMALL_STATE(7690)] = 281535,
  [SMALL_STATE(7691)] = 281543,
  [SMALL_STATE(7692)] = 281553,
  [SMALL_STATE(7693)] = 281563,
  [SMALL_STATE(7694)] = 281573,
  [SMALL_STATE(7695)] = 281583,
  [SMALL_STATE(7696)] = 281593,
  [SMALL_STATE(7697)] = 281603,
  [SMALL_STATE(7698)] = 281613,
  [SMALL_STATE(7699)] = 281621,
  [SMALL_STATE(7700)] = 281631,
  [SMALL_STATE(7701)] = 281641,
  [SMALL_STATE(7702)] = 281651,
  [SMALL_STATE(7703)] = 281661,
  [SMALL_STATE(7704)] = 281671,
  [SMALL_STATE(7705)] = 281681,
  [SMALL_STATE(7706)] = 281691,
  [SMALL_STATE(7707)] = 281701,
  [SMALL_STATE(7708)] = 281711,
  [SMALL_STATE(7709)] = 281721,
  [SMALL_STATE(7710)] = 281731,
  [SMALL_STATE(7711)] = 281741,
  [SMALL_STATE(7712)] = 281749,
  [SMALL_STATE(7713)] = 281759,
  [SMALL_STATE(7714)] = 281769,
  [SMALL_STATE(7715)] = 281779,
  [SMALL_STATE(7716)] = 281789,
  [SMALL_STATE(7717)] = 281799,
  [SMALL_STATE(7718)] = 281809,
  [SMALL_STATE(7719)] = 281819,
  [SMALL_STATE(7720)] = 281829,
  [SMALL_STATE(7721)] = 281839,
  [SMALL_STATE(7722)] = 281849,
  [SMALL_STATE(7723)] = 281857,
  [SMALL_STATE(7724)] = 281867,
  [SMALL_STATE(7725)] = 281877,
  [SMALL_STATE(7726)] = 281887,
  [SMALL_STATE(7727)] = 281897,
  [SMALL_STATE(7728)] = 281907,
  [SMALL_STATE(7729)] = 281917,
  [SMALL_STATE(7730)] = 281927,
  [SMALL_STATE(7731)] = 281935,
  [SMALL_STATE(7732)] = 281943,
  [SMALL_STATE(7733)] = 281953,
  [SMALL_STATE(7734)] = 281963,
  [SMALL_STATE(7735)] = 281973,
  [SMALL_STATE(7736)] = 281981,
  [SMALL_STATE(7737)] = 281991,
  [SMALL_STATE(7738)] = 282001,
  [SMALL_STATE(7739)] = 282011,
  [SMALL_STATE(7740)] = 282021,
  [SMALL_STATE(7741)] = 282031,
  [SMALL_STATE(7742)] = 282041,
  [SMALL_STATE(7743)] = 282049,
  [SMALL_STATE(7744)] = 282059,
  [SMALL_STATE(7745)] = 282067,
  [SMALL_STATE(7746)] = 282077,
  [SMALL_STATE(7747)] = 282087,
  [SMALL_STATE(7748)] = 282097,
  [SMALL_STATE(7749)] = 282107,
  [SMALL_STATE(7750)] = 282117,
  [SMALL_STATE(7751)] = 282125,
  [SMALL_STATE(7752)] = 282133,
  [SMALL_STATE(7753)] = 282143,
  [SMALL_STATE(7754)] = 282153,
  [SMALL_STATE(7755)] = 282163,
  [SMALL_STATE(7756)] = 282173,
  [SMALL_STATE(7757)] = 282183,
  [SMALL_STATE(7758)] = 282193,
  [SMALL_STATE(7759)] = 282201,
  [SMALL_STATE(7760)] = 282211,
  [SMALL_STATE(7761)] = 282219,
  [SMALL_STATE(7762)] = 282227,
  [SMALL_STATE(7763)] = 282237,
  [SMALL_STATE(7764)] = 282247,
  [SMALL_STATE(7765)] = 282257,
  [SMALL_STATE(7766)] = 282267,
  [SMALL_STATE(7767)] = 282275,
  [SMALL_STATE(7768)] = 282285,
  [SMALL_STATE(7769)] = 282295,
  [SMALL_STATE(7770)] = 282305,
  [SMALL_STATE(7771)] = 282315,
  [SMALL_STATE(7772)] = 282325,
  [SMALL_STATE(7773)] = 282335,
  [SMALL_STATE(7774)] = 282345,
  [SMALL_STATE(7775)] = 282355,
  [SMALL_STATE(7776)] = 282363,
  [SMALL_STATE(7777)] = 282371,
  [SMALL_STATE(7778)] = 282381,
  [SMALL_STATE(7779)] = 282389,
  [SMALL_STATE(7780)] = 282399,
  [SMALL_STATE(7781)] = 282409,
  [SMALL_STATE(7782)] = 282419,
  [SMALL_STATE(7783)] = 282427,
  [SMALL_STATE(7784)] = 282437,
  [SMALL_STATE(7785)] = 282447,
  [SMALL_STATE(7786)] = 282455,
  [SMALL_STATE(7787)] = 282465,
  [SMALL_STATE(7788)] = 282475,
  [SMALL_STATE(7789)] = 282485,
  [SMALL_STATE(7790)] = 282495,
  [SMALL_STATE(7791)] = 282505,
  [SMALL_STATE(7792)] = 282515,
  [SMALL_STATE(7793)] = 282525,
  [SMALL_STATE(7794)] = 282535,
  [SMALL_STATE(7795)] = 282545,
  [SMALL_STATE(7796)] = 282555,
  [SMALL_STATE(7797)] = 282565,
  [SMALL_STATE(7798)] = 282575,
  [SMALL_STATE(7799)] = 282585,
  [SMALL_STATE(7800)] = 282595,
  [SMALL_STATE(7801)] = 282603,
  [SMALL_STATE(7802)] = 282613,
  [SMALL_STATE(7803)] = 282623,
  [SMALL_STATE(7804)] = 282633,
  [SMALL_STATE(7805)] = 282643,
  [SMALL_STATE(7806)] = 282653,
  [SMALL_STATE(7807)] = 282663,
  [SMALL_STATE(7808)] = 282673,
  [SMALL_STATE(7809)] = 282683,
  [SMALL_STATE(7810)] = 282693,
  [SMALL_STATE(7811)] = 282701,
  [SMALL_STATE(7812)] = 282711,
  [SMALL_STATE(7813)] = 282721,
  [SMALL_STATE(7814)] = 282731,
  [SMALL_STATE(7815)] = 282741,
  [SMALL_STATE(7816)] = 282751,
  [SMALL_STATE(7817)] = 282759,
  [SMALL_STATE(7818)] = 282769,
  [SMALL_STATE(7819)] = 282779,
  [SMALL_STATE(7820)] = 282787,
  [SMALL_STATE(7821)] = 282797,
  [SMALL_STATE(7822)] = 282807,
  [SMALL_STATE(7823)] = 282817,
  [SMALL_STATE(7824)] = 282827,
  [SMALL_STATE(7825)] = 282837,
  [SMALL_STATE(7826)] = 282847,
  [SMALL_STATE(7827)] = 282855,
  [SMALL_STATE(7828)] = 282865,
  [SMALL_STATE(7829)] = 282873,
  [SMALL_STATE(7830)] = 282883,
  [SMALL_STATE(7831)] = 282893,
  [SMALL_STATE(7832)] = 282903,
  [SMALL_STATE(7833)] = 282913,
  [SMALL_STATE(7834)] = 282923,
  [SMALL_STATE(7835)] = 282933,
  [SMALL_STATE(7836)] = 282943,
  [SMALL_STATE(7837)] = 282953,
  [SMALL_STATE(7838)] = 282963,
  [SMALL_STATE(7839)] = 282973,
  [SMALL_STATE(7840)] = 282983,
  [SMALL_STATE(7841)] = 282993,
  [SMALL_STATE(7842)] = 283003,
  [SMALL_STATE(7843)] = 283013,
  [SMALL_STATE(7844)] = 283023,
  [SMALL_STATE(7845)] = 283033,
  [SMALL_STATE(7846)] = 283043,
  [SMALL_STATE(7847)] = 283053,
  [SMALL_STATE(7848)] = 283063,
  [SMALL_STATE(7849)] = 283073,
  [SMALL_STATE(7850)] = 283081,
  [SMALL_STATE(7851)] = 283091,
  [SMALL_STATE(7852)] = 283101,
  [SMALL_STATE(7853)] = 283111,
  [SMALL_STATE(7854)] = 283121,
  [SMALL_STATE(7855)] = 283131,
  [SMALL_STATE(7856)] = 283141,
  [SMALL_STATE(7857)] = 283151,
  [SMALL_STATE(7858)] = 283161,
  [SMALL_STATE(7859)] = 283171,
  [SMALL_STATE(7860)] = 283181,
  [SMALL_STATE(7861)] = 283191,
  [SMALL_STATE(7862)] = 283201,
  [SMALL_STATE(7863)] = 283211,
  [SMALL_STATE(7864)] = 283221,
  [SMALL_STATE(7865)] = 283231,
  [SMALL_STATE(7866)] = 283241,
  [SMALL_STATE(7867)] = 283251,
  [SMALL_STATE(7868)] = 283261,
  [SMALL_STATE(7869)] = 283271,
  [SMALL_STATE(7870)] = 283281,
  [SMALL_STATE(7871)] = 283291,
  [SMALL_STATE(7872)] = 283301,
  [SMALL_STATE(7873)] = 283311,
  [SMALL_STATE(7874)] = 283321,
  [SMALL_STATE(7875)] = 283331,
  [SMALL_STATE(7876)] = 283341,
  [SMALL_STATE(7877)] = 283351,
  [SMALL_STATE(7878)] = 283361,
  [SMALL_STATE(7879)] = 283371,
  [SMALL_STATE(7880)] = 283381,
  [SMALL_STATE(7881)] = 283391,
  [SMALL_STATE(7882)] = 283401,
  [SMALL_STATE(7883)] = 283411,
  [SMALL_STATE(7884)] = 283421,
  [SMALL_STATE(7885)] = 283431,
  [SMALL_STATE(7886)] = 283441,
  [SMALL_STATE(7887)] = 283451,
  [SMALL_STATE(7888)] = 283461,
  [SMALL_STATE(7889)] = 283471,
  [SMALL_STATE(7890)] = 283481,
  [SMALL_STATE(7891)] = 283491,
  [SMALL_STATE(7892)] = 283501,
  [SMALL_STATE(7893)] = 283511,
  [SMALL_STATE(7894)] = 283521,
  [SMALL_STATE(7895)] = 283531,
  [SMALL_STATE(7896)] = 283539,
  [SMALL_STATE(7897)] = 283549,
  [SMALL_STATE(7898)] = 283559,
  [SMALL_STATE(7899)] = 283569,
  [SMALL_STATE(7900)] = 283579,
  [SMALL_STATE(7901)] = 283589,
  [SMALL_STATE(7902)] = 283599,
  [SMALL_STATE(7903)] = 283609,
  [SMALL_STATE(7904)] = 283619,
  [SMALL_STATE(7905)] = 283629,
  [SMALL_STATE(7906)] = 283639,
  [SMALL_STATE(7907)] = 283649,
  [SMALL_STATE(7908)] = 283659,
  [SMALL_STATE(7909)] = 283667,
  [SMALL_STATE(7910)] = 283677,
  [SMALL_STATE(7911)] = 283687,
  [SMALL_STATE(7912)] = 283697,
  [SMALL_STATE(7913)] = 283707,
  [SMALL_STATE(7914)] = 283717,
  [SMALL_STATE(7915)] = 283727,
  [SMALL_STATE(7916)] = 283737,
  [SMALL_STATE(7917)] = 283747,
  [SMALL_STATE(7918)] = 283757,
  [SMALL_STATE(7919)] = 283767,
  [SMALL_STATE(7920)] = 283777,
  [SMALL_STATE(7921)] = 283787,
  [SMALL_STATE(7922)] = 283797,
  [SMALL_STATE(7923)] = 283807,
  [SMALL_STATE(7924)] = 283814,
  [SMALL_STATE(7925)] = 283821,
  [SMALL_STATE(7926)] = 283828,
  [SMALL_STATE(7927)] = 283835,
  [SMALL_STATE(7928)] = 283842,
  [SMALL_STATE(7929)] = 283849,
  [SMALL_STATE(7930)] = 283856,
  [SMALL_STATE(7931)] = 283863,
  [SMALL_STATE(7932)] = 283870,
  [SMALL_STATE(7933)] = 283877,
  [SMALL_STATE(7934)] = 283884,
  [SMALL_STATE(7935)] = 283891,
  [SMALL_STATE(7936)] = 283898,
  [SMALL_STATE(7937)] = 283905,
  [SMALL_STATE(7938)] = 283912,
  [SMALL_STATE(7939)] = 283919,
  [SMALL_STATE(7940)] = 283926,
  [SMALL_STATE(7941)] = 283933,
  [SMALL_STATE(7942)] = 283940,
  [SMALL_STATE(7943)] = 283947,
  [SMALL_STATE(7944)] = 283954,
  [SMALL_STATE(7945)] = 283961,
  [SMALL_STATE(7946)] = 283968,
  [SMALL_STATE(7947)] = 283975,
  [SMALL_STATE(7948)] = 283982,
  [SMALL_STATE(7949)] = 283989,
  [SMALL_STATE(7950)] = 283996,
  [SMALL_STATE(7951)] = 284003,
  [SMALL_STATE(7952)] = 284010,
  [SMALL_STATE(7953)] = 284017,
  [SMALL_STATE(7954)] = 284024,
  [SMALL_STATE(7955)] = 284031,
  [SMALL_STATE(7956)] = 284038,
  [SMALL_STATE(7957)] = 284045,
  [SMALL_STATE(7958)] = 284052,
  [SMALL_STATE(7959)] = 284059,
  [SMALL_STATE(7960)] = 284066,
  [SMALL_STATE(7961)] = 284073,
  [SMALL_STATE(7962)] = 284080,
  [SMALL_STATE(7963)] = 284087,
  [SMALL_STATE(7964)] = 284094,
  [SMALL_STATE(7965)] = 284101,
  [SMALL_STATE(7966)] = 284108,
  [SMALL_STATE(7967)] = 284115,
  [SMALL_STATE(7968)] = 284122,
  [SMALL_STATE(7969)] = 284129,
  [SMALL_STATE(7970)] = 284136,
  [SMALL_STATE(7971)] = 284143,
  [SMALL_STATE(7972)] = 284150,
  [SMALL_STATE(7973)] = 284157,
  [SMALL_STATE(7974)] = 284164,
  [SMALL_STATE(7975)] = 284171,
  [SMALL_STATE(7976)] = 284178,
  [SMALL_STATE(7977)] = 284185,
  [SMALL_STATE(7978)] = 284192,
  [SMALL_STATE(7979)] = 284199,
  [SMALL_STATE(7980)] = 284206,
  [SMALL_STATE(7981)] = 284213,
  [SMALL_STATE(7982)] = 284220,
  [SMALL_STATE(7983)] = 284227,
  [SMALL_STATE(7984)] = 284234,
  [SMALL_STATE(7985)] = 284241,
  [SMALL_STATE(7986)] = 284248,
  [SMALL_STATE(7987)] = 284255,
  [SMALL_STATE(7988)] = 284262,
  [SMALL_STATE(7989)] = 284269,
  [SMALL_STATE(7990)] = 284276,
  [SMALL_STATE(7991)] = 284283,
  [SMALL_STATE(7992)] = 284290,
  [SMALL_STATE(7993)] = 284297,
  [SMALL_STATE(7994)] = 284304,
  [SMALL_STATE(7995)] = 284311,
  [SMALL_STATE(7996)] = 284318,
  [SMALL_STATE(7997)] = 284325,
  [SMALL_STATE(7998)] = 284332,
  [SMALL_STATE(7999)] = 284339,
  [SMALL_STATE(8000)] = 284346,
  [SMALL_STATE(8001)] = 284353,
  [SMALL_STATE(8002)] = 284360,
  [SMALL_STATE(8003)] = 284367,
  [SMALL_STATE(8004)] = 284374,
  [SMALL_STATE(8005)] = 284381,
  [SMALL_STATE(8006)] = 284388,
  [SMALL_STATE(8007)] = 284395,
  [SMALL_STATE(8008)] = 284402,
  [SMALL_STATE(8009)] = 284409,
  [SMALL_STATE(8010)] = 284416,
  [SMALL_STATE(8011)] = 284423,
  [SMALL_STATE(8012)] = 284430,
  [SMALL_STATE(8013)] = 284437,
  [SMALL_STATE(8014)] = 284444,
  [SMALL_STATE(8015)] = 284451,
  [SMALL_STATE(8016)] = 284458,
  [SMALL_STATE(8017)] = 284465,
  [SMALL_STATE(8018)] = 284472,
  [SMALL_STATE(8019)] = 284479,
  [SMALL_STATE(8020)] = 284486,
  [SMALL_STATE(8021)] = 284493,
  [SMALL_STATE(8022)] = 284500,
  [SMALL_STATE(8023)] = 284507,
  [SMALL_STATE(8024)] = 284514,
  [SMALL_STATE(8025)] = 284521,
  [SMALL_STATE(8026)] = 284528,
  [SMALL_STATE(8027)] = 284535,
  [SMALL_STATE(8028)] = 284542,
  [SMALL_STATE(8029)] = 284549,
  [SMALL_STATE(8030)] = 284556,
  [SMALL_STATE(8031)] = 284563,
  [SMALL_STATE(8032)] = 284570,
  [SMALL_STATE(8033)] = 284577,
  [SMALL_STATE(8034)] = 284584,
  [SMALL_STATE(8035)] = 284591,
  [SMALL_STATE(8036)] = 284598,
  [SMALL_STATE(8037)] = 284605,
  [SMALL_STATE(8038)] = 284612,
  [SMALL_STATE(8039)] = 284619,
  [SMALL_STATE(8040)] = 284626,
  [SMALL_STATE(8041)] = 284633,
  [SMALL_STATE(8042)] = 284640,
  [SMALL_STATE(8043)] = 284647,
  [SMALL_STATE(8044)] = 284654,
  [SMALL_STATE(8045)] = 284661,
  [SMALL_STATE(8046)] = 284668,
  [SMALL_STATE(8047)] = 284675,
  [SMALL_STATE(8048)] = 284682,
  [SMALL_STATE(8049)] = 284689,
  [SMALL_STATE(8050)] = 284696,
  [SMALL_STATE(8051)] = 284703,
  [SMALL_STATE(8052)] = 284710,
  [SMALL_STATE(8053)] = 284717,
  [SMALL_STATE(8054)] = 284724,
  [SMALL_STATE(8055)] = 284731,
  [SMALL_STATE(8056)] = 284738,
  [SMALL_STATE(8057)] = 284745,
  [SMALL_STATE(8058)] = 284752,
  [SMALL_STATE(8059)] = 284759,
  [SMALL_STATE(8060)] = 284766,
  [SMALL_STATE(8061)] = 284773,
  [SMALL_STATE(8062)] = 284780,
  [SMALL_STATE(8063)] = 284787,
  [SMALL_STATE(8064)] = 284794,
  [SMALL_STATE(8065)] = 284801,
  [SMALL_STATE(8066)] = 284808,
  [SMALL_STATE(8067)] = 284815,
  [SMALL_STATE(8068)] = 284822,
  [SMALL_STATE(8069)] = 284829,
  [SMALL_STATE(8070)] = 284836,
  [SMALL_STATE(8071)] = 284843,
  [SMALL_STATE(8072)] = 284850,
  [SMALL_STATE(8073)] = 284857,
  [SMALL_STATE(8074)] = 284864,
  [SMALL_STATE(8075)] = 284871,
  [SMALL_STATE(8076)] = 284878,
  [SMALL_STATE(8077)] = 284885,
  [SMALL_STATE(8078)] = 284892,
  [SMALL_STATE(8079)] = 284899,
  [SMALL_STATE(8080)] = 284906,
  [SMALL_STATE(8081)] = 284913,
  [SMALL_STATE(8082)] = 284920,
  [SMALL_STATE(8083)] = 284927,
  [SMALL_STATE(8084)] = 284934,
  [SMALL_STATE(8085)] = 284941,
  [SMALL_STATE(8086)] = 284948,
  [SMALL_STATE(8087)] = 284955,
  [SMALL_STATE(8088)] = 284962,
  [SMALL_STATE(8089)] = 284969,
  [SMALL_STATE(8090)] = 284976,
  [SMALL_STATE(8091)] = 284983,
  [SMALL_STATE(8092)] = 284990,
  [SMALL_STATE(8093)] = 284997,
  [SMALL_STATE(8094)] = 285004,
  [SMALL_STATE(8095)] = 285011,
  [SMALL_STATE(8096)] = 285018,
  [SMALL_STATE(8097)] = 285025,
  [SMALL_STATE(8098)] = 285032,
  [SMALL_STATE(8099)] = 285039,
  [SMALL_STATE(8100)] = 285046,
  [SMALL_STATE(8101)] = 285053,
  [SMALL_STATE(8102)] = 285060,
  [SMALL_STATE(8103)] = 285067,
  [SMALL_STATE(8104)] = 285074,
  [SMALL_STATE(8105)] = 285081,
  [SMALL_STATE(8106)] = 285088,
  [SMALL_STATE(8107)] = 285095,
  [SMALL_STATE(8108)] = 285102,
  [SMALL_STATE(8109)] = 285109,
  [SMALL_STATE(8110)] = 285116,
  [SMALL_STATE(8111)] = 285123,
  [SMALL_STATE(8112)] = 285130,
  [SMALL_STATE(8113)] = 285137,
  [SMALL_STATE(8114)] = 285144,
  [SMALL_STATE(8115)] = 285151,
  [SMALL_STATE(8116)] = 285158,
  [SMALL_STATE(8117)] = 285165,
  [SMALL_STATE(8118)] = 285172,
  [SMALL_STATE(8119)] = 285179,
  [SMALL_STATE(8120)] = 285186,
  [SMALL_STATE(8121)] = 285193,
  [SMALL_STATE(8122)] = 285200,
  [SMALL_STATE(8123)] = 285207,
  [SMALL_STATE(8124)] = 285214,
  [SMALL_STATE(8125)] = 285221,
  [SMALL_STATE(8126)] = 285228,
  [SMALL_STATE(8127)] = 285235,
  [SMALL_STATE(8128)] = 285242,
  [SMALL_STATE(8129)] = 285249,
  [SMALL_STATE(8130)] = 285256,
  [SMALL_STATE(8131)] = 285263,
  [SMALL_STATE(8132)] = 285270,
  [SMALL_STATE(8133)] = 285277,
  [SMALL_STATE(8134)] = 285284,
  [SMALL_STATE(8135)] = 285291,
  [SMALL_STATE(8136)] = 285298,
  [SMALL_STATE(8137)] = 285305,
  [SMALL_STATE(8138)] = 285312,
  [SMALL_STATE(8139)] = 285319,
  [SMALL_STATE(8140)] = 285326,
  [SMALL_STATE(8141)] = 285333,
  [SMALL_STATE(8142)] = 285340,
  [SMALL_STATE(8143)] = 285347,
  [SMALL_STATE(8144)] = 285354,
  [SMALL_STATE(8145)] = 285361,
  [SMALL_STATE(8146)] = 285368,
  [SMALL_STATE(8147)] = 285375,
  [SMALL_STATE(8148)] = 285382,
  [SMALL_STATE(8149)] = 285389,
  [SMALL_STATE(8150)] = 285396,
  [SMALL_STATE(8151)] = 285403,
  [SMALL_STATE(8152)] = 285410,
  [SMALL_STATE(8153)] = 285417,
  [SMALL_STATE(8154)] = 285424,
  [SMALL_STATE(8155)] = 285431,
  [SMALL_STATE(8156)] = 285438,
  [SMALL_STATE(8157)] = 285445,
  [SMALL_STATE(8158)] = 285452,
  [SMALL_STATE(8159)] = 285459,
  [SMALL_STATE(8160)] = 285466,
  [SMALL_STATE(8161)] = 285473,
  [SMALL_STATE(8162)] = 285480,
  [SMALL_STATE(8163)] = 285487,
  [SMALL_STATE(8164)] = 285494,
  [SMALL_STATE(8165)] = 285501,
  [SMALL_STATE(8166)] = 285508,
  [SMALL_STATE(8167)] = 285515,
  [SMALL_STATE(8168)] = 285522,
  [SMALL_STATE(8169)] = 285529,
  [SMALL_STATE(8170)] = 285536,
  [SMALL_STATE(8171)] = 285543,
  [SMALL_STATE(8172)] = 285550,
  [SMALL_STATE(8173)] = 285557,
  [SMALL_STATE(8174)] = 285564,
  [SMALL_STATE(8175)] = 285571,
  [SMALL_STATE(8176)] = 285578,
  [SMALL_STATE(8177)] = 285585,
  [SMALL_STATE(8178)] = 285592,
  [SMALL_STATE(8179)] = 285599,
  [SMALL_STATE(8180)] = 285606,
  [SMALL_STATE(8181)] = 285613,
  [SMALL_STATE(8182)] = 285620,
  [SMALL_STATE(8183)] = 285627,
  [SMALL_STATE(8184)] = 285634,
  [SMALL_STATE(8185)] = 285641,
  [SMALL_STATE(8186)] = 285648,
  [SMALL_STATE(8187)] = 285655,
  [SMALL_STATE(8188)] = 285662,
  [SMALL_STATE(8189)] = 285669,
  [SMALL_STATE(8190)] = 285676,
  [SMALL_STATE(8191)] = 285683,
  [SMALL_STATE(8192)] = 285690,
  [SMALL_STATE(8193)] = 285697,
  [SMALL_STATE(8194)] = 285704,
  [SMALL_STATE(8195)] = 285711,
  [SMALL_STATE(8196)] = 285718,
  [SMALL_STATE(8197)] = 285725,
  [SMALL_STATE(8198)] = 285732,
  [SMALL_STATE(8199)] = 285739,
  [SMALL_STATE(8200)] = 285746,
  [SMALL_STATE(8201)] = 285753,
  [SMALL_STATE(8202)] = 285760,
  [SMALL_STATE(8203)] = 285767,
  [SMALL_STATE(8204)] = 285774,
  [SMALL_STATE(8205)] = 285781,
  [SMALL_STATE(8206)] = 285788,
  [SMALL_STATE(8207)] = 285795,
  [SMALL_STATE(8208)] = 285802,
  [SMALL_STATE(8209)] = 285809,
  [SMALL_STATE(8210)] = 285816,
  [SMALL_STATE(8211)] = 285823,
  [SMALL_STATE(8212)] = 285830,
  [SMALL_STATE(8213)] = 285837,
  [SMALL_STATE(8214)] = 285844,
  [SMALL_STATE(8215)] = 285851,
  [SMALL_STATE(8216)] = 285858,
  [SMALL_STATE(8217)] = 285865,
  [SMALL_STATE(8218)] = 285872,
  [SMALL_STATE(8219)] = 285879,
  [SMALL_STATE(8220)] = 285886,
  [SMALL_STATE(8221)] = 285893,
  [SMALL_STATE(8222)] = 285900,
  [SMALL_STATE(8223)] = 285907,
  [SMALL_STATE(8224)] = 285914,
  [SMALL_STATE(8225)] = 285921,
  [SMALL_STATE(8226)] = 285928,
  [SMALL_STATE(8227)] = 285935,
  [SMALL_STATE(8228)] = 285942,
  [SMALL_STATE(8229)] = 285949,
  [SMALL_STATE(8230)] = 285956,
  [SMALL_STATE(8231)] = 285963,
  [SMALL_STATE(8232)] = 285970,
  [SMALL_STATE(8233)] = 285977,
  [SMALL_STATE(8234)] = 285984,
  [SMALL_STATE(8235)] = 285991,
  [SMALL_STATE(8236)] = 285998,
  [SMALL_STATE(8237)] = 286005,
  [SMALL_STATE(8238)] = 286012,
  [SMALL_STATE(8239)] = 286019,
  [SMALL_STATE(8240)] = 286026,
  [SMALL_STATE(8241)] = 286033,
  [SMALL_STATE(8242)] = 286040,
  [SMALL_STATE(8243)] = 286047,
  [SMALL_STATE(8244)] = 286054,
  [SMALL_STATE(8245)] = 286061,
  [SMALL_STATE(8246)] = 286068,
  [SMALL_STATE(8247)] = 286075,
  [SMALL_STATE(8248)] = 286082,
  [SMALL_STATE(8249)] = 286089,
  [SMALL_STATE(8250)] = 286096,
  [SMALL_STATE(8251)] = 286103,
  [SMALL_STATE(8252)] = 286110,
  [SMALL_STATE(8253)] = 286117,
  [SMALL_STATE(8254)] = 286124,
  [SMALL_STATE(8255)] = 286131,
  [SMALL_STATE(8256)] = 286138,
  [SMALL_STATE(8257)] = 286145,
  [SMALL_STATE(8258)] = 286152,
  [SMALL_STATE(8259)] = 286159,
  [SMALL_STATE(8260)] = 286166,
  [SMALL_STATE(8261)] = 286173,
  [SMALL_STATE(8262)] = 286180,
  [SMALL_STATE(8263)] = 286187,
  [SMALL_STATE(8264)] = 286194,
  [SMALL_STATE(8265)] = 286201,
  [SMALL_STATE(8266)] = 286208,
  [SMALL_STATE(8267)] = 286215,
  [SMALL_STATE(8268)] = 286222,
  [SMALL_STATE(8269)] = 286229,
  [SMALL_STATE(8270)] = 286236,
  [SMALL_STATE(8271)] = 286243,
  [SMALL_STATE(8272)] = 286250,
  [SMALL_STATE(8273)] = 286257,
  [SMALL_STATE(8274)] = 286264,
  [SMALL_STATE(8275)] = 286271,
  [SMALL_STATE(8276)] = 286278,
  [SMALL_STATE(8277)] = 286285,
  [SMALL_STATE(8278)] = 286292,
  [SMALL_STATE(8279)] = 286299,
  [SMALL_STATE(8280)] = 286306,
  [SMALL_STATE(8281)] = 286313,
  [SMALL_STATE(8282)] = 286320,
  [SMALL_STATE(8283)] = 286327,
  [SMALL_STATE(8284)] = 286334,
  [SMALL_STATE(8285)] = 286341,
  [SMALL_STATE(8286)] = 286348,
  [SMALL_STATE(8287)] = 286355,
  [SMALL_STATE(8288)] = 286362,
  [SMALL_STATE(8289)] = 286369,
  [SMALL_STATE(8290)] = 286376,
  [SMALL_STATE(8291)] = 286383,
  [SMALL_STATE(8292)] = 286390,
  [SMALL_STATE(8293)] = 286397,
  [SMALL_STATE(8294)] = 286404,
  [SMALL_STATE(8295)] = 286411,
  [SMALL_STATE(8296)] = 286418,
  [SMALL_STATE(8297)] = 286425,
  [SMALL_STATE(8298)] = 286432,
  [SMALL_STATE(8299)] = 286439,
  [SMALL_STATE(8300)] = 286446,
  [SMALL_STATE(8301)] = 286453,
  [SMALL_STATE(8302)] = 286460,
  [SMALL_STATE(8303)] = 286467,
  [SMALL_STATE(8304)] = 286474,
  [SMALL_STATE(8305)] = 286481,
  [SMALL_STATE(8306)] = 286488,
  [SMALL_STATE(8307)] = 286495,
  [SMALL_STATE(8308)] = 286502,
  [SMALL_STATE(8309)] = 286509,
  [SMALL_STATE(8310)] = 286516,
  [SMALL_STATE(8311)] = 286523,
  [SMALL_STATE(8312)] = 286530,
  [SMALL_STATE(8313)] = 286537,
  [SMALL_STATE(8314)] = 286544,
  [SMALL_STATE(8315)] = 286551,
  [SMALL_STATE(8316)] = 286558,
  [SMALL_STATE(8317)] = 286565,
  [SMALL_STATE(8318)] = 286572,
  [SMALL_STATE(8319)] = 286579,
  [SMALL_STATE(8320)] = 286586,
  [SMALL_STATE(8321)] = 286593,
  [SMALL_STATE(8322)] = 286600,
  [SMALL_STATE(8323)] = 286607,
  [SMALL_STATE(8324)] = 286614,
  [SMALL_STATE(8325)] = 286621,
  [SMALL_STATE(8326)] = 286628,
  [SMALL_STATE(8327)] = 286635,
  [SMALL_STATE(8328)] = 286642,
  [SMALL_STATE(8329)] = 286649,
  [SMALL_STATE(8330)] = 286656,
  [SMALL_STATE(8331)] = 286663,
  [SMALL_STATE(8332)] = 286670,
  [SMALL_STATE(8333)] = 286677,
  [SMALL_STATE(8334)] = 286684,
  [SMALL_STATE(8335)] = 286691,
  [SMALL_STATE(8336)] = 286698,
  [SMALL_STATE(8337)] = 286705,
  [SMALL_STATE(8338)] = 286712,
  [SMALL_STATE(8339)] = 286719,
  [SMALL_STATE(8340)] = 286726,
  [SMALL_STATE(8341)] = 286733,
  [SMALL_STATE(8342)] = 286740,
  [SMALL_STATE(8343)] = 286747,
  [SMALL_STATE(8344)] = 286754,
  [SMALL_STATE(8345)] = 286761,
  [SMALL_STATE(8346)] = 286768,
  [SMALL_STATE(8347)] = 286775,
  [SMALL_STATE(8348)] = 286782,
  [SMALL_STATE(8349)] = 286789,
  [SMALL_STATE(8350)] = 286796,
  [SMALL_STATE(8351)] = 286803,
  [SMALL_STATE(8352)] = 286810,
  [SMALL_STATE(8353)] = 286817,
  [SMALL_STATE(8354)] = 286824,
  [SMALL_STATE(8355)] = 286831,
  [SMALL_STATE(8356)] = 286838,
  [SMALL_STATE(8357)] = 286845,
  [SMALL_STATE(8358)] = 286852,
  [SMALL_STATE(8359)] = 286859,
  [SMALL_STATE(8360)] = 286866,
  [SMALL_STATE(8361)] = 286873,
  [SMALL_STATE(8362)] = 286880,
  [SMALL_STATE(8363)] = 286887,
  [SMALL_STATE(8364)] = 286894,
  [SMALL_STATE(8365)] = 286901,
  [SMALL_STATE(8366)] = 286908,
  [SMALL_STATE(8367)] = 286915,
  [SMALL_STATE(8368)] = 286922,
  [SMALL_STATE(8369)] = 286929,
  [SMALL_STATE(8370)] = 286936,
  [SMALL_STATE(8371)] = 286943,
  [SMALL_STATE(8372)] = 286950,
  [SMALL_STATE(8373)] = 286957,
  [SMALL_STATE(8374)] = 286964,
  [SMALL_STATE(8375)] = 286971,
  [SMALL_STATE(8376)] = 286978,
  [SMALL_STATE(8377)] = 286985,
  [SMALL_STATE(8378)] = 286992,
  [SMALL_STATE(8379)] = 286999,
  [SMALL_STATE(8380)] = 287006,
  [SMALL_STATE(8381)] = 287013,
  [SMALL_STATE(8382)] = 287020,
  [SMALL_STATE(8383)] = 287027,
  [SMALL_STATE(8384)] = 287034,
  [SMALL_STATE(8385)] = 287041,
  [SMALL_STATE(8386)] = 287048,
  [SMALL_STATE(8387)] = 287055,
  [SMALL_STATE(8388)] = 287062,
  [SMALL_STATE(8389)] = 287069,
  [SMALL_STATE(8390)] = 287076,
  [SMALL_STATE(8391)] = 287083,
  [SMALL_STATE(8392)] = 287090,
  [SMALL_STATE(8393)] = 287097,
  [SMALL_STATE(8394)] = 287104,
  [SMALL_STATE(8395)] = 287111,
  [SMALL_STATE(8396)] = 287118,
  [SMALL_STATE(8397)] = 287125,
  [SMALL_STATE(8398)] = 287132,
  [SMALL_STATE(8399)] = 287139,
  [SMALL_STATE(8400)] = 287146,
  [SMALL_STATE(8401)] = 287153,
  [SMALL_STATE(8402)] = 287160,
  [SMALL_STATE(8403)] = 287167,
  [SMALL_STATE(8404)] = 287174,
  [SMALL_STATE(8405)] = 287181,
  [SMALL_STATE(8406)] = 287188,
  [SMALL_STATE(8407)] = 287195,
  [SMALL_STATE(8408)] = 287202,
  [SMALL_STATE(8409)] = 287209,
  [SMALL_STATE(8410)] = 287216,
  [SMALL_STATE(8411)] = 287223,
  [SMALL_STATE(8412)] = 287230,
  [SMALL_STATE(8413)] = 287237,
  [SMALL_STATE(8414)] = 287244,
  [SMALL_STATE(8415)] = 287251,
  [SMALL_STATE(8416)] = 287258,
  [SMALL_STATE(8417)] = 287265,
  [SMALL_STATE(8418)] = 287272,
  [SMALL_STATE(8419)] = 287279,
  [SMALL_STATE(8420)] = 287286,
  [SMALL_STATE(8421)] = 287293,
  [SMALL_STATE(8422)] = 287300,
  [SMALL_STATE(8423)] = 287307,
  [SMALL_STATE(8424)] = 287314,
  [SMALL_STATE(8425)] = 287321,
  [SMALL_STATE(8426)] = 287328,
  [SMALL_STATE(8427)] = 287335,
  [SMALL_STATE(8428)] = 287342,
  [SMALL_STATE(8429)] = 287349,
  [SMALL_STATE(8430)] = 287356,
  [SMALL_STATE(8431)] = 287363,
  [SMALL_STATE(8432)] = 287370,
  [SMALL_STATE(8433)] = 287377,
  [SMALL_STATE(8434)] = 287384,
  [SMALL_STATE(8435)] = 287391,
  [SMALL_STATE(8436)] = 287398,
  [SMALL_STATE(8437)] = 287405,
  [SMALL_STATE(8438)] = 287412,
  [SMALL_STATE(8439)] = 287419,
  [SMALL_STATE(8440)] = 287426,
  [SMALL_STATE(8441)] = 287433,
  [SMALL_STATE(8442)] = 287440,
  [SMALL_STATE(8443)] = 287447,
  [SMALL_STATE(8444)] = 287454,
  [SMALL_STATE(8445)] = 287461,
  [SMALL_STATE(8446)] = 287468,
  [SMALL_STATE(8447)] = 287475,
  [SMALL_STATE(8448)] = 287482,
  [SMALL_STATE(8449)] = 287489,
  [SMALL_STATE(8450)] = 287496,
  [SMALL_STATE(8451)] = 287503,
  [SMALL_STATE(8452)] = 287510,
  [SMALL_STATE(8453)] = 287517,
  [SMALL_STATE(8454)] = 287524,
  [SMALL_STATE(8455)] = 287531,
  [SMALL_STATE(8456)] = 287538,
  [SMALL_STATE(8457)] = 287545,
  [SMALL_STATE(8458)] = 287552,
  [SMALL_STATE(8459)] = 287559,
  [SMALL_STATE(8460)] = 287566,
  [SMALL_STATE(8461)] = 287573,
  [SMALL_STATE(8462)] = 287580,
  [SMALL_STATE(8463)] = 287587,
  [SMALL_STATE(8464)] = 287594,
  [SMALL_STATE(8465)] = 287601,
  [SMALL_STATE(8466)] = 287608,
  [SMALL_STATE(8467)] = 287615,
  [SMALL_STATE(8468)] = 287622,
  [SMALL_STATE(8469)] = 287629,
  [SMALL_STATE(8470)] = 287636,
  [SMALL_STATE(8471)] = 287643,
  [SMALL_STATE(8472)] = 287650,
  [SMALL_STATE(8473)] = 287657,
  [SMALL_STATE(8474)] = 287664,
  [SMALL_STATE(8475)] = 287671,
  [SMALL_STATE(8476)] = 287678,
  [SMALL_STATE(8477)] = 287685,
  [SMALL_STATE(8478)] = 287692,
  [SMALL_STATE(8479)] = 287699,
  [SMALL_STATE(8480)] = 287706,
  [SMALL_STATE(8481)] = 287713,
  [SMALL_STATE(8482)] = 287720,
  [SMALL_STATE(8483)] = 287727,
  [SMALL_STATE(8484)] = 287734,
  [SMALL_STATE(8485)] = 287741,
  [SMALL_STATE(8486)] = 287748,
  [SMALL_STATE(8487)] = 287755,
  [SMALL_STATE(8488)] = 287762,
  [SMALL_STATE(8489)] = 287769,
  [SMALL_STATE(8490)] = 287776,
  [SMALL_STATE(8491)] = 287783,
  [SMALL_STATE(8492)] = 287790,
  [SMALL_STATE(8493)] = 287797,
  [SMALL_STATE(8494)] = 287804,
  [SMALL_STATE(8495)] = 287811,
  [SMALL_STATE(8496)] = 287818,
  [SMALL_STATE(8497)] = 287825,
  [SMALL_STATE(8498)] = 287832,
  [SMALL_STATE(8499)] = 287839,
  [SMALL_STATE(8500)] = 287846,
  [SMALL_STATE(8501)] = 287853,
  [SMALL_STATE(8502)] = 287860,
  [SMALL_STATE(8503)] = 287867,
  [SMALL_STATE(8504)] = 287874,
  [SMALL_STATE(8505)] = 287881,
  [SMALL_STATE(8506)] = 287888,
  [SMALL_STATE(8507)] = 287895,
  [SMALL_STATE(8508)] = 287902,
  [SMALL_STATE(8509)] = 287909,
  [SMALL_STATE(8510)] = 287916,
  [SMALL_STATE(8511)] = 287923,
  [SMALL_STATE(8512)] = 287930,
  [SMALL_STATE(8513)] = 287937,
  [SMALL_STATE(8514)] = 287944,
  [SMALL_STATE(8515)] = 287951,
  [SMALL_STATE(8516)] = 287958,
  [SMALL_STATE(8517)] = 287965,
  [SMALL_STATE(8518)] = 287972,
  [SMALL_STATE(8519)] = 287979,
  [SMALL_STATE(8520)] = 287986,
  [SMALL_STATE(8521)] = 287993,
  [SMALL_STATE(8522)] = 288000,
  [SMALL_STATE(8523)] = 288007,
  [SMALL_STATE(8524)] = 288014,
  [SMALL_STATE(8525)] = 288021,
  [SMALL_STATE(8526)] = 288028,
  [SMALL_STATE(8527)] = 288035,
  [SMALL_STATE(8528)] = 288042,
  [SMALL_STATE(8529)] = 288049,
  [SMALL_STATE(8530)] = 288056,
  [SMALL_STATE(8531)] = 288063,
  [SMALL_STATE(8532)] = 288070,
  [SMALL_STATE(8533)] = 288077,
  [SMALL_STATE(8534)] = 288084,
  [SMALL_STATE(8535)] = 288091,
  [SMALL_STATE(8536)] = 288098,
  [SMALL_STATE(8537)] = 288105,
  [SMALL_STATE(8538)] = 288112,
  [SMALL_STATE(8539)] = 288119,
  [SMALL_STATE(8540)] = 288126,
  [SMALL_STATE(8541)] = 288133,
  [SMALL_STATE(8542)] = 288140,
  [SMALL_STATE(8543)] = 288147,
  [SMALL_STATE(8544)] = 288154,
  [SMALL_STATE(8545)] = 288161,
  [SMALL_STATE(8546)] = 288168,
  [SMALL_STATE(8547)] = 288175,
  [SMALL_STATE(8548)] = 288182,
  [SMALL_STATE(8549)] = 288189,
  [SMALL_STATE(8550)] = 288196,
  [SMALL_STATE(8551)] = 288203,
  [SMALL_STATE(8552)] = 288210,
  [SMALL_STATE(8553)] = 288217,
  [SMALL_STATE(8554)] = 288224,
  [SMALL_STATE(8555)] = 288231,
  [SMALL_STATE(8556)] = 288238,
  [SMALL_STATE(8557)] = 288245,
  [SMALL_STATE(8558)] = 288252,
  [SMALL_STATE(8559)] = 288259,
  [SMALL_STATE(8560)] = 288266,
  [SMALL_STATE(8561)] = 288273,
  [SMALL_STATE(8562)] = 288280,
  [SMALL_STATE(8563)] = 288287,
  [SMALL_STATE(8564)] = 288294,
  [SMALL_STATE(8565)] = 288301,
  [SMALL_STATE(8566)] = 288308,
  [SMALL_STATE(8567)] = 288315,
  [SMALL_STATE(8568)] = 288322,
  [SMALL_STATE(8569)] = 288329,
  [SMALL_STATE(8570)] = 288336,
  [SMALL_STATE(8571)] = 288343,
  [SMALL_STATE(8572)] = 288350,
  [SMALL_STATE(8573)] = 288357,
  [SMALL_STATE(8574)] = 288364,
  [SMALL_STATE(8575)] = 288371,
  [SMALL_STATE(8576)] = 288378,
  [SMALL_STATE(8577)] = 288385,
  [SMALL_STATE(8578)] = 288392,
  [SMALL_STATE(8579)] = 288399,
  [SMALL_STATE(8580)] = 288406,
  [SMALL_STATE(8581)] = 288413,
  [SMALL_STATE(8582)] = 288420,
  [SMALL_STATE(8583)] = 288427,
  [SMALL_STATE(8584)] = 288434,
  [SMALL_STATE(8585)] = 288441,
  [SMALL_STATE(8586)] = 288448,
  [SMALL_STATE(8587)] = 288455,
  [SMALL_STATE(8588)] = 288462,
  [SMALL_STATE(8589)] = 288469,
  [SMALL_STATE(8590)] = 288476,
  [SMALL_STATE(8591)] = 288483,
  [SMALL_STATE(8592)] = 288490,
  [SMALL_STATE(8593)] = 288497,
  [SMALL_STATE(8594)] = 288504,
  [SMALL_STATE(8595)] = 288511,
  [SMALL_STATE(8596)] = 288518,
  [SMALL_STATE(8597)] = 288525,
  [SMALL_STATE(8598)] = 288532,
  [SMALL_STATE(8599)] = 288539,
  [SMALL_STATE(8600)] = 288546,
  [SMALL_STATE(8601)] = 288553,
  [SMALL_STATE(8602)] = 288560,
  [SMALL_STATE(8603)] = 288567,
  [SMALL_STATE(8604)] = 288574,
  [SMALL_STATE(8605)] = 288581,
  [SMALL_STATE(8606)] = 288588,
  [SMALL_STATE(8607)] = 288595,
  [SMALL_STATE(8608)] = 288602,
  [SMALL_STATE(8609)] = 288609,
  [SMALL_STATE(8610)] = 288616,
  [SMALL_STATE(8611)] = 288623,
  [SMALL_STATE(8612)] = 288630,
  [SMALL_STATE(8613)] = 288637,
  [SMALL_STATE(8614)] = 288644,
  [SMALL_STATE(8615)] = 288651,
  [SMALL_STATE(8616)] = 288658,
  [SMALL_STATE(8617)] = 288665,
  [SMALL_STATE(8618)] = 288672,
  [SMALL_STATE(8619)] = 288679,
  [SMALL_STATE(8620)] = 288686,
  [SMALL_STATE(8621)] = 288693,
  [SMALL_STATE(8622)] = 288700,
  [SMALL_STATE(8623)] = 288707,
  [SMALL_STATE(8624)] = 288714,
  [SMALL_STATE(8625)] = 288721,
  [SMALL_STATE(8626)] = 288728,
  [SMALL_STATE(8627)] = 288735,
  [SMALL_STATE(8628)] = 288742,
  [SMALL_STATE(8629)] = 288749,
  [SMALL_STATE(8630)] = 288756,
  [SMALL_STATE(8631)] = 288763,
  [SMALL_STATE(8632)] = 288770,
  [SMALL_STATE(8633)] = 288777,
  [SMALL_STATE(8634)] = 288784,
  [SMALL_STATE(8635)] = 288791,
  [SMALL_STATE(8636)] = 288798,
  [SMALL_STATE(8637)] = 288805,
  [SMALL_STATE(8638)] = 288812,
  [SMALL_STATE(8639)] = 288819,
  [SMALL_STATE(8640)] = 288826,
  [SMALL_STATE(8641)] = 288833,
  [SMALL_STATE(8642)] = 288840,
  [SMALL_STATE(8643)] = 288847,
  [SMALL_STATE(8644)] = 288854,
  [SMALL_STATE(8645)] = 288861,
  [SMALL_STATE(8646)] = 288868,
  [SMALL_STATE(8647)] = 288875,
  [SMALL_STATE(8648)] = 288882,
  [SMALL_STATE(8649)] = 288889,
  [SMALL_STATE(8650)] = 288896,
  [SMALL_STATE(8651)] = 288903,
  [SMALL_STATE(8652)] = 288910,
  [SMALL_STATE(8653)] = 288917,
  [SMALL_STATE(8654)] = 288924,
  [SMALL_STATE(8655)] = 288931,
  [SMALL_STATE(8656)] = 288938,
  [SMALL_STATE(8657)] = 288945,
  [SMALL_STATE(8658)] = 288952,
  [SMALL_STATE(8659)] = 288959,
  [SMALL_STATE(8660)] = 288966,
  [SMALL_STATE(8661)] = 288973,
  [SMALL_STATE(8662)] = 288980,
  [SMALL_STATE(8663)] = 288987,
  [SMALL_STATE(8664)] = 288994,
  [SMALL_STATE(8665)] = 289001,
  [SMALL_STATE(8666)] = 289008,
  [SMALL_STATE(8667)] = 289015,
  [SMALL_STATE(8668)] = 289022,
  [SMALL_STATE(8669)] = 289029,
  [SMALL_STATE(8670)] = 289036,
  [SMALL_STATE(8671)] = 289043,
  [SMALL_STATE(8672)] = 289050,
  [SMALL_STATE(8673)] = 289057,
  [SMALL_STATE(8674)] = 289064,
  [SMALL_STATE(8675)] = 289071,
  [SMALL_STATE(8676)] = 289078,
  [SMALL_STATE(8677)] = 289085,
  [SMALL_STATE(8678)] = 289092,
  [SMALL_STATE(8679)] = 289099,
  [SMALL_STATE(8680)] = 289106,
  [SMALL_STATE(8681)] = 289113,
  [SMALL_STATE(8682)] = 289120,
  [SMALL_STATE(8683)] = 289127,
  [SMALL_STATE(8684)] = 289134,
  [SMALL_STATE(8685)] = 289141,
  [SMALL_STATE(8686)] = 289148,
  [SMALL_STATE(8687)] = 289155,
  [SMALL_STATE(8688)] = 289162,
  [SMALL_STATE(8689)] = 289169,
  [SMALL_STATE(8690)] = 289176,
  [SMALL_STATE(8691)] = 289183,
  [SMALL_STATE(8692)] = 289190,
  [SMALL_STATE(8693)] = 289197,
  [SMALL_STATE(8694)] = 289204,
  [SMALL_STATE(8695)] = 289211,
  [SMALL_STATE(8696)] = 289218,
  [SMALL_STATE(8697)] = 289225,
  [SMALL_STATE(8698)] = 289232,
  [SMALL_STATE(8699)] = 289239,
  [SMALL_STATE(8700)] = 289246,
  [SMALL_STATE(8701)] = 289253,
  [SMALL_STATE(8702)] = 289260,
  [SMALL_STATE(8703)] = 289267,
  [SMALL_STATE(8704)] = 289274,
  [SMALL_STATE(8705)] = 289281,
  [SMALL_STATE(8706)] = 289288,
  [SMALL_STATE(8707)] = 289295,
  [SMALL_STATE(8708)] = 289302,
  [SMALL_STATE(8709)] = 289309,
  [SMALL_STATE(8710)] = 289316,
  [SMALL_STATE(8711)] = 289323,
  [SMALL_STATE(8712)] = 289330,
  [SMALL_STATE(8713)] = 289337,
  [SMALL_STATE(8714)] = 289344,
  [SMALL_STATE(8715)] = 289351,
  [SMALL_STATE(8716)] = 289358,
  [SMALL_STATE(8717)] = 289365,
  [SMALL_STATE(8718)] = 289372,
  [SMALL_STATE(8719)] = 289379,
  [SMALL_STATE(8720)] = 289386,
  [SMALL_STATE(8721)] = 289393,
  [SMALL_STATE(8722)] = 289400,
  [SMALL_STATE(8723)] = 289407,
  [SMALL_STATE(8724)] = 289414,
  [SMALL_STATE(8725)] = 289421,
  [SMALL_STATE(8726)] = 289428,
  [SMALL_STATE(8727)] = 289435,
  [SMALL_STATE(8728)] = 289442,
  [SMALL_STATE(8729)] = 289449,
  [SMALL_STATE(8730)] = 289456,
  [SMALL_STATE(8731)] = 289463,
  [SMALL_STATE(8732)] = 289470,
  [SMALL_STATE(8733)] = 289477,
  [SMALL_STATE(8734)] = 289484,
  [SMALL_STATE(8735)] = 289491,
  [SMALL_STATE(8736)] = 289498,
  [SMALL_STATE(8737)] = 289505,
  [SMALL_STATE(8738)] = 289512,
  [SMALL_STATE(8739)] = 289519,
  [SMALL_STATE(8740)] = 289526,
  [SMALL_STATE(8741)] = 289533,
  [SMALL_STATE(8742)] = 289540,
  [SMALL_STATE(8743)] = 289547,
  [SMALL_STATE(8744)] = 289554,
  [SMALL_STATE(8745)] = 289561,
  [SMALL_STATE(8746)] = 289568,
  [SMALL_STATE(8747)] = 289575,
  [SMALL_STATE(8748)] = 289582,
  [SMALL_STATE(8749)] = 289589,
  [SMALL_STATE(8750)] = 289596,
  [SMALL_STATE(8751)] = 289603,
  [SMALL_STATE(8752)] = 289610,
  [SMALL_STATE(8753)] = 289617,
  [SMALL_STATE(8754)] = 289624,
  [SMALL_STATE(8755)] = 289631,
  [SMALL_STATE(8756)] = 289638,
  [SMALL_STATE(8757)] = 289645,
  [SMALL_STATE(8758)] = 289652,
  [SMALL_STATE(8759)] = 289659,
  [SMALL_STATE(8760)] = 289666,
  [SMALL_STATE(8761)] = 289673,
  [SMALL_STATE(8762)] = 289680,
  [SMALL_STATE(8763)] = 289687,
  [SMALL_STATE(8764)] = 289694,
  [SMALL_STATE(8765)] = 289701,
  [SMALL_STATE(8766)] = 289708,
  [SMALL_STATE(8767)] = 289715,
  [SMALL_STATE(8768)] = 289722,
  [SMALL_STATE(8769)] = 289729,
  [SMALL_STATE(8770)] = 289736,
  [SMALL_STATE(8771)] = 289743,
  [SMALL_STATE(8772)] = 289750,
  [SMALL_STATE(8773)] = 289757,
  [SMALL_STATE(8774)] = 289764,
  [SMALL_STATE(8775)] = 289771,
  [SMALL_STATE(8776)] = 289778,
  [SMALL_STATE(8777)] = 289785,
  [SMALL_STATE(8778)] = 289792,
  [SMALL_STATE(8779)] = 289799,
  [SMALL_STATE(8780)] = 289806,
  [SMALL_STATE(8781)] = 289813,
  [SMALL_STATE(8782)] = 289820,
  [SMALL_STATE(8783)] = 289827,
  [SMALL_STATE(8784)] = 289834,
  [SMALL_STATE(8785)] = 289841,
  [SMALL_STATE(8786)] = 289848,
  [SMALL_STATE(8787)] = 289855,
  [SMALL_STATE(8788)] = 289862,
  [SMALL_STATE(8789)] = 289869,
  [SMALL_STATE(8790)] = 289876,
  [SMALL_STATE(8791)] = 289883,
  [SMALL_STATE(8792)] = 289890,
  [SMALL_STATE(8793)] = 289897,
  [SMALL_STATE(8794)] = 289904,
  [SMALL_STATE(8795)] = 289911,
  [SMALL_STATE(8796)] = 289918,
  [SMALL_STATE(8797)] = 289925,
  [SMALL_STATE(8798)] = 289932,
  [SMALL_STATE(8799)] = 289939,
  [SMALL_STATE(8800)] = 289946,
  [SMALL_STATE(8801)] = 289953,
  [SMALL_STATE(8802)] = 289960,
  [SMALL_STATE(8803)] = 289967,
  [SMALL_STATE(8804)] = 289974,
  [SMALL_STATE(8805)] = 289981,
  [SMALL_STATE(8806)] = 289988,
  [SMALL_STATE(8807)] = 289995,
  [SMALL_STATE(8808)] = 290002,
  [SMALL_STATE(8809)] = 290009,
  [SMALL_STATE(8810)] = 290016,
  [SMALL_STATE(8811)] = 290023,
  [SMALL_STATE(8812)] = 290030,
  [SMALL_STATE(8813)] = 290037,
  [SMALL_STATE(8814)] = 290044,
  [SMALL_STATE(8815)] = 290051,
  [SMALL_STATE(8816)] = 290058,
  [SMALL_STATE(8817)] = 290065,
  [SMALL_STATE(8818)] = 290072,
  [SMALL_STATE(8819)] = 290079,
  [SMALL_STATE(8820)] = 290086,
  [SMALL_STATE(8821)] = 290093,
  [SMALL_STATE(8822)] = 290100,
  [SMALL_STATE(8823)] = 290107,
  [SMALL_STATE(8824)] = 290114,
  [SMALL_STATE(8825)] = 290121,
  [SMALL_STATE(8826)] = 290128,
  [SMALL_STATE(8827)] = 290135,
  [SMALL_STATE(8828)] = 290142,
  [SMALL_STATE(8829)] = 290149,
  [SMALL_STATE(8830)] = 290156,
  [SMALL_STATE(8831)] = 290163,
  [SMALL_STATE(8832)] = 290170,
  [SMALL_STATE(8833)] = 290177,
  [SMALL_STATE(8834)] = 290184,
  [SMALL_STATE(8835)] = 290191,
  [SMALL_STATE(8836)] = 290198,
  [SMALL_STATE(8837)] = 290205,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6588),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8693),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5712),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8404),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7666),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3705),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3120),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8417),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6456),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6553),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7457),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8279),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7644),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3743),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2359),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5751),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3132),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3009),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7977),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2537),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6245),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5130),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5095),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5101),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7473),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7834),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8385),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7818),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8427),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8436),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8107),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8020),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7972),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8148),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8679),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6726),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4787),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7371),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4850),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3870),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8343),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4204),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5233),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6977),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6453),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7767),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6631),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8829),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8746),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7724),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5008),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5353),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6635),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8289),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8105),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5758),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8303),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7793),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3740),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6513),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7476),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7806),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8337),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7802),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8310),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8342),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8348),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8371),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7871),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8626),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8165),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3889),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7817),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6610),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8654),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8655),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6603),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8499),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5777),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8500),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5755),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8274),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7685),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3711),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6515),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7253),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7653),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8255),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7808),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8653),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8056),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8058),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8565),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7660),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8426),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7656),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6586),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8738),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8739),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, 0, 10),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, 0, 10),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, 0, 81),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, 0, 81),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(875),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6603),
  [387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8499),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5777),
  [393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8500),
  [398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7685),
  [401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1321),
  [410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5242),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(901),
  [422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(274),
  [425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(234),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3711),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3120),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2695),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8417),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6515),
  [443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6553),
  [446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7457),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8279),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7644),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3743),
  [458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(50),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2359),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5751),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3132),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3089),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1658),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7977),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2537),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6245),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5130),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5095),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5101),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7253),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7653),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1459),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8255),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7808),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(221),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8653),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1022),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8056),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8058),
  [524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8565),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7660),
  [530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8426),
  [533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1277),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1138),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7972),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8148),
  [545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8679),
  [548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6726),
  [551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4250),
  [554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7371),
  [557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7117),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3889),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3870),
  [566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2501),
  [569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8343),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4204),
  [575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5233),
  [578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1559),
  [581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(826),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7656),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1280),
  [590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6586),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8738),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8739),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1187),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1452),
  [608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7724),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1327),
  [614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5008),
  [617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5353),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, 0, 0),
  [622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(879),
  [627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6588),
  [630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8693),
  [633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5712),
  [636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8404),
  [639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7666),
  [642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1321),
  [651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5242),
  [660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(901),
  [663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(483),
  [666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(232),
  [669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3705),
  [672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3120),
  [675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2660),
  [678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8417),
  [681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6456),
  [684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6553),
  [687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7457),
  [690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8279),
  [693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7644),
  [696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3743),
  [699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(84),
  [702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2359),
  [705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5751),
  [708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3132),
  [711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3009),
  [714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1658),
  [717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7977),
  [720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2537),
  [723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6245),
  [726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5130),
  [729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5095),
  [732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5101),
  [735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7473),
  [738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7834),
  [741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1318),
  [744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8385),
  [747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7818),
  [750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(175),
  [753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8427),
  [756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1007),
  [759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8436),
  [762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8107),
  [765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8020),
  [768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1277),
  [771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1138),
  [774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7972),
  [777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8148),
  [780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8679),
  [783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6726),
  [786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4787),
  [789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7371),
  [792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7117),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4850),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3870),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2501),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8343),
  [807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4204),
  [810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5233),
  [813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(63),
  [816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6977),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6453),
  [822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1552),
  [825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(826),
  [828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7767),
  [831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1280),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1168),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6631),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8829),
  [843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8746),
  [846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1123),
  [849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1325),
  [852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7724),
  [855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1327),
  [858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5008),
  [861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5353),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6577),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8095),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5779),
  [878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8005),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7830),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3728),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6406),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7357),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7701),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8464),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7654),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8737),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8270),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8273),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8015),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7706),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8468),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7703),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6598),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8760),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8752),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(876),
  [943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6577),
  [946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8095),
  [949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5779),
  [952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8005),
  [955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7830),
  [958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(541),
  [961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(235),
  [964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3728),
  [967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2697),
  [970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6406),
  [973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(61),
  [976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3093),
  [979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7357),
  [982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7701),
  [985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1466),
  [988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8464),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7654),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(222),
  [997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8737),
  [1000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1006),
  [1003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8270),
  [1006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8273),
  [1009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8015),
  [1012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7706),
  [1015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8468),
  [1018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1563),
  [1021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7703),
  [1024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1171),
  [1027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6598),
  [1030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8760),
  [1033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8752),
  [1036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1178),
  [1039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1460),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [1048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(873),
  [1051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6635),
  [1054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8289),
  [1057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5758),
  [1060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8303),
  [1063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7793),
  [1066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(488),
  [1069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(229),
  [1072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3740),
  [1075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2690),
  [1078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6513),
  [1081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [1084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [1086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3081),
  [1089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7476),
  [1092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7806),
  [1095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1428),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8337),
  [1101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7802),
  [1104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(217),
  [1107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8310),
  [1110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1024),
  [1113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8342),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8348),
  [1119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8371),
  [1122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7871),
  [1125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8626),
  [1128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1558),
  [1131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7817),
  [1134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1145),
  [1137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6610),
  [1140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8654),
  [1143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8655),
  [1146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1174),
  [1149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1429),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7848),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8447),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7683),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6473),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(933),
  [1251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(160),
  [1256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [1259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [1262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1330),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1330),
  [1270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(274),
  [1273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(435),
  [1276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3711),
  [1279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2136),
  [1282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3132),
  [1285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8417),
  [1288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6553),
  [1291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7355),
  [1294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8279),
  [1297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(50),
  [1300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2359),
  [1303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5667),
  [1306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1658),
  [1309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7977),
  [1312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2537),
  [1315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6245),
  [1318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5130),
  [1321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5095),
  [1324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5101),
  [1327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7253),
  [1330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7653),
  [1333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7808),
  [1336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(221),
  [1339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8653),
  [1342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1022),
  [1345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8056),
  [1348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8058),
  [1351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8565),
  [1354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7660),
  [1357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8426),
  [1360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1277),
  [1363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1138),
  [1366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7972),
  [1369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8148),
  [1372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8679),
  [1375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6726),
  [1378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4250),
  [1381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7371),
  [1384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7117),
  [1387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3889),
  [1390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3870),
  [1393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2501),
  [1396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8343),
  [1399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5233),
  [1402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7789),
  [1405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7656),
  [1408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1280),
  [1411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [1414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1187),
  [1417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1452),
  [1420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7724),
  [1423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1327),
  [1426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5008),
  [1429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5353),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [1444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7355),
  [1450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5667),
  [1452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7789),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [1468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(977),
  [1473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(400),
  [1476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [1479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3705),
  [1482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(84),
  [1485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7473),
  [1488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7834),
  [1491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7818),
  [1494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(175),
  [1497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8427),
  [1500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1007),
  [1503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8436),
  [1506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8107),
  [1509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8020),
  [1512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7848),
  [1515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8447),
  [1518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7767),
  [1521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1168),
  [1524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1123),
  [1527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1325),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [1534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(975),
  [1537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(541),
  [1540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(436),
  [1543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3728),
  [1546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(61),
  [1549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7357),
  [1552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7701),
  [1555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7654),
  [1558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(222),
  [1561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8737),
  [1564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1006),
  [1567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8270),
  [1570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8273),
  [1573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8015),
  [1576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7706),
  [1579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8468),
  [1582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7703),
  [1585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1171),
  [1588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1178),
  [1591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1460),
  [1594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [1596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [1598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(927),
  [1601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(488),
  [1604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(449),
  [1607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3740),
  [1610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [1613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7476),
  [1616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7806),
  [1619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7802),
  [1622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(217),
  [1625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8310),
  [1628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1024),
  [1631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8342),
  [1634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8348),
  [1637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8371),
  [1640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7871),
  [1643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8626),
  [1646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7817),
  [1649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1145),
  [1652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1174),
  [1655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1429),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [1666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3720),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7402),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7726),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7702),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8750),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [1682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8479),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8482),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8101),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7733),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8110),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7747),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [1700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(957),
  [1703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(910),
  [1706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(444),
  [1709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3720),
  [1712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(66),
  [1715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7402),
  [1718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7726),
  [1721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7702),
  [1724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(185),
  [1727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8750),
  [1730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1025),
  [1733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8479),
  [1736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8482),
  [1739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8101),
  [1742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7733),
  [1745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8110),
  [1748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7747),
  [1751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1153),
  [1754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1156),
  [1757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1467),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8036),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7406),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7708),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8510),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7798),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3724),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8671),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8379),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6566),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6356),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4209),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5067),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6226),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5085),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5087),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5089),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8313),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8801),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8832),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6770),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7073),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3373),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8315),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5178),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7875),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5006),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8502),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [1872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [1882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6221),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5093),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5060),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5063),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [1894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8562),
  [1898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8810),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8835),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6747),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7002),
  [1910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3908),
  [1912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3906),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5195),
  [1916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7911),
  [1920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5022),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5367),
  [1926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7399),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [1944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6974),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8511),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8804),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8833),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6739),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7467),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6989),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8363),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7907),
  [1984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4999),
  [1988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5351),
  [1990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [1996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [2000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7403),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [2012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [2014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4994),
  [2016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6440),
  [2028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7021),
  [2030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2184),
  [2033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(160),
  [2036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1215),
  [2039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1215),
  [2042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1330),
  [2045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(488),
  [2048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1343),
  [2051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [2053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6553),
  [2056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7355),
  [2059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(39),
  [2062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5667),
  [2065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7021),
  [2068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7476),
  [2071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7806),
  [2074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1428),
  [2077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8337),
  [2080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7802),
  [2083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(217),
  [2086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8310),
  [2089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1024),
  [2092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8342),
  [2095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8348),
  [2098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8371),
  [2101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7871),
  [2104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8626),
  [2107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1277),
  [2110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1138),
  [2113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7972),
  [2116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8148),
  [2119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8679),
  [2122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6726),
  [2125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4250),
  [2128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7371),
  [2131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7117),
  [2134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3889),
  [2137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3870),
  [2140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8363),
  [2143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7789),
  [2146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7817),
  [2149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1280),
  [2152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1145),
  [2155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1174),
  [2158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1429),
  [2161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7724),
  [2164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1327),
  [2167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5008),
  [2170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5353),
  [2173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [2175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6415),
  [2177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2179),
  [2180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(274),
  [2183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(50),
  [2186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7253),
  [2189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7653),
  [2192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1459),
  [2195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8255),
  [2198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7808),
  [2201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(221),
  [2204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8653),
  [2207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1022),
  [2210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8056),
  [2213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8058),
  [2216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8565),
  [2219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7660),
  [2222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8426),
  [2225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7656),
  [2228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1183),
  [2231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1187),
  [2234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1452),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6463),
  [2241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2188),
  [2244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(541),
  [2247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(61),
  [2250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7357),
  [2253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7701),
  [2256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1466),
  [2259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8464),
  [2262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7654),
  [2265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(222),
  [2268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8737),
  [2271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1006),
  [2274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8270),
  [2277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8273),
  [2280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8015),
  [2283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7706),
  [2286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8468),
  [2289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7703),
  [2292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1171),
  [2295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1178),
  [2298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1460),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6410),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [2311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6574),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7466),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7108),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7918),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [2329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2178),
  [2332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(400),
  [2335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(84),
  [2338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7473),
  [2341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7834),
  [2344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1318),
  [2347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8385),
  [2350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7818),
  [2353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(175),
  [2356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8427),
  [2359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1007),
  [2362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8436),
  [2365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8107),
  [2368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8020),
  [2371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7848),
  [2374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8447),
  [2377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7767),
  [2380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1168),
  [2383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1123),
  [2386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1325),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [2393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2199),
  [2396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(910),
  [2399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(66),
  [2402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7402),
  [2405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7726),
  [2408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1451),
  [2411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8036),
  [2414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7702),
  [2417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(185),
  [2420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8750),
  [2423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1025),
  [2426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8479),
  [2429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8482),
  [2432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8101),
  [2435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7733),
  [2438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8110),
  [2441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7747),
  [2444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1153),
  [2447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1156),
  [2450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1467),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6982),
  [2461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2171),
  [2464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7406),
  [2467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7708),
  [2470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8510),
  [2473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7798),
  [2476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7670),
  [2483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 9),
  [2485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 9),
  [2487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7670),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6570),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7090),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8582),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8813),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8836),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6752),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7461),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7049),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3651),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3650),
  [2523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7913),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4982),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5355),
  [2533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [2545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [2547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [2549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [2551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2106),
  [2554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(160),
  [2557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1215),
  [2560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1330),
  [2563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1330),
  [2568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1343),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3747),
  [2573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6553),
  [2578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5667),
  [2581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7021),
  [2584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8363),
  [2587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7789),
  [2590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7582),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3773),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7582),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3713),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7099),
  [2613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 106),
  [2615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 106),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [2619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 169),
  [2621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 169),
  [2623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 51),
  [2625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 51),
  [2627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [2629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [2631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 159),
  [2633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 159),
  [2635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_loop, 5, 0, 160),
  [2637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_loop, 5, 0, 160),
  [2639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 88),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 88),
  [2643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 176),
  [2645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 176),
  [2647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [2649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [2651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, 0, 137),
  [2653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, 0, 137),
  [2655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, 0, 187),
  [2657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, 0, 187),
  [2659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [2661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [2665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 154),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 154),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [2677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 54),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 54),
  [2685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [2687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [2693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [2695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [2697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [2699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 137),
  [2701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 137),
  [2703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, 0, 68),
  [2705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 68),
  [2707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 88),
  [2713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 88),
  [2715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [2717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [2719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [2721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [2723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 155),
  [2725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 155),
  [2727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 107),
  [2729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 107),
  [2731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [2737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [2739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 119),
  [2761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 119),
  [2763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [2765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [2767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 120),
  [2769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 120),
  [2771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 3, 0, 78),
  [2773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 3, 0, 78),
  [2775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [2777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [2779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [2781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [2783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [2785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [2787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [2789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [2791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [2793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [2795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, 0, 36),
  [2797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, 0, 36),
  [2799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [2801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [2803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [2805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [2807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, 0, 37),
  [2809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, 0, 37),
  [2811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [2813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [2815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [2819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [2821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [2823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [2825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [2827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 3, 0, 59),
  [2829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 3, 0, 59),
  [2831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [2835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 62),
  [2837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 62),
  [2839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [2841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [2843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 69),
  [2845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 69),
  [2847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 71),
  [2849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 71),
  [2851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 78),
  [2853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 78),
  [2855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [2857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [2859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [2861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [2863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, 0, 79),
  [2865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, 0, 79),
  [2867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, 0, 80),
  [2869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, 0, 80),
  [2871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 81),
  [2873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 81),
  [2875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 82),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 82),
  [2879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [2881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [2883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [2885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [2887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 95),
  [2889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 95),
  [2891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 96),
  [2893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 96),
  [2895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 97),
  [2897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 97),
  [2899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 4, 0, 60),
  [2901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 4, 0, 60),
  [2903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 4, 0, 59),
  [2905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 4, 0, 59),
  [2907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [2909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [2911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 117),
  [2913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 117),
  [2915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 122),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 122),
  [2919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [2923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [2925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [2927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [2929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [2931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 4, 0, 127),
  [2933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 4, 0, 127),
  [2935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 130),
  [2937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 130),
  [2939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, 0, 131),
  [2941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, 0, 131),
  [2943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 132),
  [2945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 132),
  [2947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 81),
  [2949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 81),
  [2951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, 0, 133),
  [2953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, 0, 133),
  [2955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 5, 0, 138),
  [2957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 5, 0, 138),
  [2959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3807),
  [2961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8154),
  [2963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5762),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [2967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8674),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [2971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5686),
  [2973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8220),
  [2975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7646),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8045),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [2983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5242),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3732),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6416),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5478),
  [2995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8373),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2661),
  [3001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6241),
  [3003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5079),
  [3005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5080),
  [3007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5081),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5216),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8209),
  [3013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7070),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [3017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8768),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 144),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 144),
  [3023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 145),
  [3025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 145),
  [3027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 170),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 170),
  [3031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 171),
  [3033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 171),
  [3035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 5, 0, 172),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 5, 0, 172),
  [3039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [3041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [3043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(2106),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [3048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(1343),
  [3051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(6553),
  [3054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(7021),
  [3057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(8363),
  [3060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(7789),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 178),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 178),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 5, 0, 0),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 5, 0, 0),
  [3071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 5, 0, 182),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 5, 0, 182),
  [3075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 183),
  [3077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 183),
  [3079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 6, 0, 185),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 6, 0, 185),
  [3083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 7, 0, 215),
  [3085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 7, 0, 215),
  [3087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7715),
  [3089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [3091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [3093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [3095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [3097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7715),
  [3100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [3102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [3104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [3106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [3108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [3110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [3112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 5, 0, 0),
  [3114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 5, 0, 0),
  [3116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [3130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4239),
  [3132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4975),
  [3134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6267),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5109),
  [3138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5110),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5111),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [3144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [3146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8541),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8807),
  [3150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8834),
  [3152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6775),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7443),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6947),
  [3160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4829),
  [3162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4820),
  [3164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [3166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8564),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5177),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [3172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7910),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [3178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5012),
  [3180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5365),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [3196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [3214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [3216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [3220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, 0, 10),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [3224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, 0, 81),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [3228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 10),
  [3230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 81),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [3240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7568),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6446),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [3252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(2106),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [3257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(1343),
  [3260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(6553),
  [3263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(7021),
  [3266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(8363),
  [3269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(7789),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [3274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(2106),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [3279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(1343),
  [3282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0),
  [3284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(6553),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0),
  [3289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(7021),
  [3292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(8363),
  [3295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(7789),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [3302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7568),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [3313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [3316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [3319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [3321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [3327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4043),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4028),
  [3331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [3333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8309),
  [3335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [3341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [3345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3722),
  [3347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3726),
  [3349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2202),
  [3352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1382),
  [3355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6556),
  [3358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7099),
  [3361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [3363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [3365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [3369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5114),
  [3371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 1, 0, 0),
  [3373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 1, 0, 0),
  [3375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 57),
  [3377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 57),
  [3379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, 0, 47),
  [3381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, 0, 47),
  [3383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, 0, 165),
  [3385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, 0, 165),
  [3387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 110),
  [3389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, 0, 110),
  [3391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 47),
  [3393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, 0, 47),
  [3395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 111),
  [3397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, 0, 111),
  [3399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, 0, 112),
  [3401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, 0, 112),
  [3403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_declaration, 4, 0, 0),
  [3405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_declaration, 4, 0, 0),
  [3407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, 0, 47),
  [3409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, 0, 47),
  [3411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 110),
  [3413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 110),
  [3415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 6, 0, 165),
  [3417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 6, 0, 165),
  [3419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [3422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [3425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_declaration, 2, 0, 0),
  [3427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_declaration, 2, 0, 0),
  [3429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_module_fragment_declaration, 2, 0, 0),
  [3431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_module_fragment_declaration, 2, 0, 0),
  [3433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 47),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 47),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 111),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 111),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_private_module_fragment_declaration, 4, 0, 0),
  [3443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_private_module_fragment_declaration, 4, 0, 0),
  [3445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 10),
  [3447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 10),
  [3449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3807),
  [3452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8154),
  [3455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5762),
  [3458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [3460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8674),
  [3463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7646),
  [3466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4784),
  [3469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8045),
  [3472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2878),
  [3475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5242),
  [3478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5242),
  [3481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(587),
  [3484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3105),
  [3487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3732),
  [3490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3120),
  [3493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3132),
  [3496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8417),
  [3499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6416),
  [3502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5478),
  [3505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7401),
  [3508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8279),
  [3511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7644),
  [3514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2359),
  [3517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8373),
  [3520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1658),
  [3523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3098),
  [3526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7977),
  [3529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2661),
  [3532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6241),
  [3535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5079),
  [3538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5080),
  [3541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5081),
  [3544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2501),
  [3547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8343),
  [3550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4204),
  [3553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5216),
  [3556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8209),
  [3559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7070),
  [3562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(826),
  [3565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1636),
  [3568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8768),
  [3571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, 0, 10),
  [3573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, 0, 10),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, 0, 112),
  [3577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, 0, 112),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 56),
  [3581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 56),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_declaration, 3, 0, 0),
  [3589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_declaration, 3, 0, 0),
  [3591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, 0, 10),
  [3593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, 0, 10),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 56),
  [3597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, 0, 56),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 10),
  [3601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, 0, 10),
  [3603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 57),
  [3605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, 0, 57),
  [3607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [3611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [3617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [3619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7464),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7061),
  [3625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7905),
  [3629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [3631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5033),
  [3633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5354),
  [3635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8004),
  [3637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5652),
  [3639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8661),
  [3641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7770),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3063),
  [3647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3716),
  [3649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6481),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [3653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [3655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6980),
  [3657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [3659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8751),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [3671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8207),
  [3673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5778),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, 0, 0),
  [3677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8777),
  [3679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7754),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [3683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [3685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3734),
  [3687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6425),
  [3689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3101),
  [3691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6999),
  [3693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [3695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8775),
  [3697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, 0, 0),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [3711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8004),
  [3714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5652),
  [3717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8661),
  [3720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7770),
  [3723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(804),
  [3726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3063),
  [3729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3716),
  [3732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6481),
  [3735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [3737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3066),
  [3740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6980),
  [3743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1650),
  [3746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8751),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [3767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8207),
  [3770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5778),
  [3773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8777),
  [3776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7754),
  [3779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(812),
  [3782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2973),
  [3785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3734),
  [3788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6425),
  [3791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3101),
  [3794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6999),
  [3797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1646),
  [3800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8775),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4930),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [3823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [3825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [3829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [3833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7060),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [3845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [3847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [3849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [3851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [3855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6525),
  [3859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [3861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [3863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [3865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4981),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [3869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [3873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6564),
  [3877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [3881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [3883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [3889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6956),
  [3891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [3895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6599),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2674),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2982),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6240),
  [3915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5088),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5043),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5155),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5172),
  [3923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3205),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8501),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [3929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5903),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5800),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8241),
  [3935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2208),
  [3938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1297),
  [3941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6561),
  [3944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6956),
  [3947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [3949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [3951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [3953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [3955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2204),
  [3958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1234),
  [3961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6566),
  [3964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6982),
  [3967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2843),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8781),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [3973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8776),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5437),
  [3977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8764),
  [3979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8761),
  [3981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8778),
  [3983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8769),
  [3985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8755),
  [3987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3095),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7052),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [3993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8772),
  [3995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3099),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6964),
  [3999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [4001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8744),
  [4003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3092),
  [4005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7043),
  [4007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [4009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8356),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [4013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7115),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [4019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8561),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [4031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6062),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [4037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [4043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6017),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6018),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [4065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5830),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [4085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5832),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [4091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6401),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5995),
  [4103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [4115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [4121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [4125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [4141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7756),
  [4144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [4146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [4148] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [4154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [4156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(385),
  [4165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [4169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [4172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 1),
  [4174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2641),
  [4176] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [4184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1670),
  [4187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(148),
  [4190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1315),
  [4193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1242),
  [4196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6559),
  [4199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5667),
  [4202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(142),
  [4205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1247),
  [4208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1241),
  [4211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1241),
  [4214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7756),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [4220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [4222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [4224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2300),
  [4227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(169),
  [4230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1528),
  [4233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1528),
  [4236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1514),
  [4239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6525),
  [4242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1529),
  [4245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1190),
  [4248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7972),
  [4251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8148),
  [4254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8679),
  [4257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6726),
  [4260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(4250),
  [4263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7371),
  [4266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7117),
  [4269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(3889),
  [4272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(3870),
  [4275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1530),
  [4278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7724),
  [4281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1531),
  [4284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(4981),
  [4287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5353),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [4292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [4294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3189),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [4304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4570),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [4308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [4310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [4314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6551),
  [4326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7952),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [4334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8332),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8719),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7947),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7974),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [4380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5911),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5894),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [4406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(411),
  [4409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7102),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7915),
  [4415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [4419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2106),
  [4422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(160),
  [4425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [4428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [4431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1330),
  [4434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2759),
  [4437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1343),
  [4440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6553),
  [4443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1204),
  [4446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0),
  [4448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5667),
  [4451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7021),
  [4454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1277),
  [4457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1138),
  [4460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7972),
  [4463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8148),
  [4466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8679),
  [4469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6726),
  [4472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4250),
  [4475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7371),
  [4478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7117),
  [4481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3889),
  [4484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3870),
  [4487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8363),
  [4490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6551),
  [4493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7789),
  [4496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1280),
  [4499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7724),
  [4502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1327),
  [4505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5008),
  [4508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5353),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [4533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8083),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6443),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7800),
  [4545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4813),
  [4547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [4549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [4551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8173),
  [4553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_default_capture, 1, 0, 0),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [4559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8023),
  [4561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [4563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8026),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [4571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8399),
  [4573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [4575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8403),
  [4577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8162),
  [4579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [4581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8184),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [4601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7985),
  [4604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8050),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [4611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8267),
  [4614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8594),
  [4617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7940),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [4622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8747),
  [4625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8767),
  [4628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8812),
  [4631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7930),
  [4634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7968),
  [4637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8030),
  [4640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 197),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [4644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [4654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [4656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [4660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 81),
  [4662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 158),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [4666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [4670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 108),
  [4672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [4674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 0),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [4678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 108),
  [4680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8658),
  [4683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [4685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [4689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [4695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8002),
  [4698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8019),
  [4701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8507),
  [4704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8522),
  [4707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8563),
  [4710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8585),
  [4713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8604),
  [4716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8683),
  [4719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8690),
  [4722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8715),
  [4725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8717),
  [4728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8724),
  [4731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8374),
  [4734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8065),
  [4737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8084),
  [4740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8138),
  [4743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8662),
  [4746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8254),
  [4749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8312),
  [4752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8512),
  [4755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8520),
  [4758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8799),
  [4761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7962),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [4766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8809),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6074),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6073),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5855),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8446),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [4784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8381),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8123),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8009),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [4800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8018),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6380),
  [4804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7994),
  [4806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8001),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [4811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8382),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [4817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8692),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [4823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8355),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8735),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8587),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6066),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8521),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8333),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8548),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6403),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5820),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8568),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5749),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5769),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5787),
  [4913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5651),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [4923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [4927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3638),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5681),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5760),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5785),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5786),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5790),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [4951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [4953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [4955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [4957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [4959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [4961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [4963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [4965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 33),
  [4967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 33), REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [4970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [4972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33),
  [4974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [4977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(399),
  [4980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [4982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [4984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [4986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [4988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [4990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [4992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [4994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [4996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16),
  [4998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_function, 2, 0, 17),
  [5000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [5003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16),
  [5005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_function, 2, 0, 17),
  [5007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [5010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3031),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5971),
  [5018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5971),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [5022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3574),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [5030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(371),
  [5033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(371),
  [5036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7038),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7906),
  [5044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(407),
  [5047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [5049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [5051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1590),
  [5054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8615),
  [5057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(410),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [5062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7007),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7914),
  [5070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1585),
  [5077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(386),
  [5080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [5082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [5084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [5086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [5088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [5090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [5092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [5094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8615),
  [5096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [5098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [5100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0),
  [5102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [5108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2256),
  [5111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [5113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [5115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2277),
  [5118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [5120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [5124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [5126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [5128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8600),
  [5130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2535),
  [5132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 128),
  [5134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 128),
  [5136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [5138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [5140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 129),
  [5142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 129),
  [5144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [5146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [5148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_conjunction, 3, 0, 55),
  [5150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_conjunction, 3, 0, 55),
  [5152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [5154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [5156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [5164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [5166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 3, 0, 67),
  [5168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 3, 0, 67),
  [5170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 74),
  [5172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 74),
  [5174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2554),
  [5176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2573),
  [5180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [5182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [5184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 181),
  [5186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 181),
  [5188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 75),
  [5190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 75),
  [5192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [5194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [5198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [5200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [5202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8635),
  [5204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2606),
  [5206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [5208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [5210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [5212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1651),
  [5215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8600),
  [5218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2868),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6627),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [5224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1660),
  [5227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8635),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [5236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [5238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5096),
  [5240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5098),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5099),
  [5244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1658),
  [5247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(7977),
  [5250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1634),
  [5253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [5255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [5257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [5259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8631),
  [5261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2711),
  [5263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5116),
  [5265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5117),
  [5267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5118),
  [5269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [5271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [5273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2754),
  [5275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5134),
  [5277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5046),
  [5279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5065),
  [5281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5120),
  [5283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5121),
  [5285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5123),
  [5287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5049),
  [5289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5105),
  [5291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5055),
  [5293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5069),
  [5295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5070),
  [5297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5072),
  [5299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5061),
  [5301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5066),
  [5303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5090),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5074),
  [5307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5076),
  [5309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5077),
  [5311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5143),
  [5313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5149),
  [5315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5150),
  [5317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5042),
  [5319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5084),
  [5321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5086),
  [5323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5112),
  [5325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5113),
  [5327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5135),
  [5329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5073),
  [5331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5075),
  [5333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5078),
  [5335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5092),
  [5337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5094),
  [5339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5097),
  [5341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5119),
  [5343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5071),
  [5345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5103),
  [5347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1656),
  [5350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1688),
  [5353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8631),
  [5356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1695),
  [5359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8540),
  [5362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4887),
  [5364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4942),
  [5366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7114),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [5370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1669),
  [5373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(408),
  [5376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [5379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7771),
  [5381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [5383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [5385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7771),
  [5388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [5390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [5392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [5394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [5396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [5398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [5400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1692),
  [5403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [5405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [5407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6989),
  [5410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7907),
  [5413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 4, 0, 153),
  [5415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 4, 0, 153),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [5421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [5423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [5425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1868),
  [5428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1698),
  [5431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(8561),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7166),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7498),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [5442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7766),
  [5446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 7, 0, 217),
  [5448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 7, 0, 217),
  [5450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [5452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6637),
  [5456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 68),
  [5458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 68),
  [5460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6636),
  [5462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2975),
  [5464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3282),
  [5466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2999),
  [5468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8306),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7249),
  [5474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8308),
  [5476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8509),
  [5478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [5480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [5482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [5484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [5486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(407),
  [5489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [5491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [5493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [5495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [5497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8580),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5924),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [5503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5841),
  [5505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 81),
  [5507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 81),
  [5509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 82),
  [5511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 82),
  [5513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [5515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [5517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 68),
  [5519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 68),
  [5521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 189),
  [5523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 189),
  [5525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 190),
  [5527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 190),
  [5529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 132),
  [5531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 132),
  [5533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 81),
  [5535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 81),
  [5537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 133),
  [5539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 133),
  [5541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [5543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [5545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 58),
  [5547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 58),
  [5549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 203),
  [5551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 203),
  [5553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 68),
  [5555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 68),
  [5557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [5559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [5561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 207),
  [5563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 207),
  [5565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 189),
  [5567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 189),
  [5569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 208),
  [5571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 208),
  [5573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 190),
  [5575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 190),
  [5577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 7, 0, 216),
  [5579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 7, 0, 216),
  [5581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 183),
  [5583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 183),
  [5585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 58),
  [5587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 58),
  [5589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [5591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [5593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [5595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8678),
  [5597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 69),
  [5599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 69),
  [5601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 68),
  [5603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 68),
  [5605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [5607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [5609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 203),
  [5611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 203),
  [5613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 217),
  [5615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 217),
  [5617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 33),
  [5619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 33),
  [5621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 207),
  [5623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 207),
  [5625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 0),
  [5627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 0),
  [5629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype, 4, 0, 0),
  [5631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype, 4, 0, 0),
  [5633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 208),
  [5635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 208),
  [5637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 102),
  [5639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 102),
  [5641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [5643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [5645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7784),
  [5647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype_auto, 4, 0, 0),
  [5649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype_auto, 4, 0, 0),
  [5651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [5653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [5655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [5657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [5659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [5661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [5663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 105),
  [5665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 105),
  [5667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [5669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [5671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7738),
  [5673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [5675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [5677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [5679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [5681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 4, 0, 151),
  [5683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 4, 0, 151),
  [5685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [5687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [5689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7784),
  [5692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [5694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [5696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(416),
  [5699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [5701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [5703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(3369),
  [5706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [5708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [5710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8540),
  [5712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3368),
  [5714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(3378),
  [5717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [5719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3377),
  [5721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(427),
  [5724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [5728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [5730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [5732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [5734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [5736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [5738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [5740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, 0, 149),
  [5742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, 0, 149),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [5746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [5748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [5750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 100),
  [5752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 100),
  [5754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [5756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [5758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [5760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [5762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [5764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [5766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [5768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [5770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [5772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [5774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [5776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [5778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 5, 0, 150),
  [5780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 5, 0, 150),
  [5782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [5784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [5786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 3, 0, 104),
  [5788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 3, 0, 104),
  [5790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [5792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [5794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [5796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [5798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [5800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [5802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [5804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [5806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 97),
  [5808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 97),
  [5810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 99),
  [5812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 99),
  [5814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [5816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [5818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [5820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7738),
  [5823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 20),
  [5825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 20),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [5831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [5833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8043),
  [5835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(408),
  [5838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 1),
  [5840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [5842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 93),
  [5844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 93),
  [5846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(408),
  [5849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5859),
  [5851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [5857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4156),
  [5859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5860),
  [5863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [5865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [5867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [5869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 65),
  [5871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 65),
  [5873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 45),
  [5875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 45),
  [5877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1918),
  [5880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2229),
  [5883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8624),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [5888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [5890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [5894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 35),
  [5896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 35),
  [5898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [5900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [5902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 45),
  [5904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 45),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [5908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 4, 0, 45),
  [5910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, 0, 45),
  [5912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1, 0, 0),
  [5914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1, 0, 0),
  [5916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 4, -1, 77),
  [5918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, -1, 77),
  [5920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 77),
  [5922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 77),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [5926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 0),
  [5928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 0),
  [5930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 35),
  [5932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 35),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [5936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [5938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [5942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [5944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [5946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [5949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [5952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6949),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7920),
  [5958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [5960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [5962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2010),
  [5965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6949),
  [5968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7920),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [5975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4254),
  [5977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 101),
  [5979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 101),
  [5981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [5983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [5985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [5989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [5991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [5993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [5995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [5997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [5999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [6001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(399),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [6006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6943),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7919),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8539),
  [6016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8539),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [6022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [6024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 99),
  [6026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 99),
  [6028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [6030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [6036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4242),
  [6038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 5, 1, 177),
  [6040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, 1, 177),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7442),
  [6046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [6048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [6050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [6052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [6054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8624),
  [6056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2348),
  [6058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 149),
  [6060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 149),
  [6062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 150),
  [6064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 150),
  [6066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [6068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [6070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(7826),
  [6073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(8451),
  [6076] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(6061),
  [6080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [6084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [6086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [6088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [6090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 97),
  [6092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 97),
  [6094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [6096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 102),
  [6098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 102),
  [6100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 4, 1, 87),
  [6102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, 1, 87),
  [6104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [6106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8451),
  [6110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(6061),
  [6113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [6115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [6117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [6119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [6121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [6123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [6125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [6127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [6129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [6131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [6133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [6135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [6137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2196),
  [6140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7038),
  [6143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7906),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [6148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2198),
  [6151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [6153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [6155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [6157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [6159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(421),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [6164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [6166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [6168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 105),
  [6170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 105),
  [6172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 92),
  [6174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 92),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [6178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_disjunction, 3, 0, 55),
  [6180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_disjunction, 3, 0, 55),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5457),
  [6184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5457),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [6188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 141),
  [6190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 141),
  [6192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [6194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [6196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [6198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [6200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [6202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [6204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 116),
  [6206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 116),
  [6208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [6210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [6212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6998),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7916),
  [6218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [6220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [6222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, 0, 179),
  [6224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, 0, 179),
  [6226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [6230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 2, 0, 0),
  [6232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 2, 0, 0),
  [6235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [6237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7442),
  [6240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [6242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2269),
  [6244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0),
  [6246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 1, 0, 0),
  [6249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [6251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [6253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [6255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [6259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5451),
  [6261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [6263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 64),
  [6265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 64),
  [6267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [6269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [6271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [6273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 123),
  [6275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 123),
  [6277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [6279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [6281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [6283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(416),
  [6286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [6288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [6290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [6292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2293),
  [6295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, 0, 89),
  [6297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, 0, 89),
  [6299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2301),
  [6302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6998),
  [6305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7916),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [6310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 125),
  [6312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 1, 125),
  [6314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 125), SHIFT(408),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5847),
  [6323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2600),
  [6326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(1658),
  [6329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [6331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(7977),
  [6334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [6336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [6338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [6342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [6344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [6348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 124),
  [6350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 124),
  [6352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 3, 0, 173),
  [6354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 3, 0, 173),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8599),
  [6360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8599),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [6368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 72),
  [6370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 1, 72),
  [6372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 72), SHIFT(408),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [6383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2594),
  [6386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1658),
  [6389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [6391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(7977),
  [6394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [6398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 0, 33),
  [6400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 0, 33),
  [6402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [6404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [6406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [6408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [6410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [6412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [6416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2376),
  [6419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7102),
  [6422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7915),
  [6425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [6427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [6431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6105),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [6435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 4),
  [6437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 4),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [6441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [6443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [6445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [6447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [6449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 55),
  [6451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 55),
  [6453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [6455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [6457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2550),
  [6459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [6461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8362),
  [6463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [6465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [6467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 86),
  [6469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 86),
  [6471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [6473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [6475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2558),
  [6477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 2, 0, 0),
  [6479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 2, 0, 0),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [6483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [6485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [6487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 4, 0, 173),
  [6489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 4, 0, 173),
  [6491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [6493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8560),
  [6497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8560),
  [6499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [6501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 17),
  [6503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 17),
  [6505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [6507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [6509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [6511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [6513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76),
  [6515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, 0, 76),
  [6517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76), SHIFT(408),
  [6520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 29),
  [6522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 29),
  [6524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 55),
  [6526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 55),
  [6528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 63),
  [6530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 63),
  [6532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [6534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [6536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [6538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [6540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5924),
  [6542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [6544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [6546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [6548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 7),
  [6550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 7),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [6554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [6556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [6558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, 0, 86),
  [6560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, 0, 86),
  [6562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 91),
  [6564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 91),
  [6566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [6568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [6570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [6572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [6574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 73),
  [6576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 73),
  [6578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1, 0, 0),
  [6580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1, 0, 0),
  [6582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [6584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [6586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, 0, 109),
  [6588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, 0, 109),
  [6590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 114),
  [6592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 114),
  [6594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 115),
  [6596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 115),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [6600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5429),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8580),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [6606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 139),
  [6608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 139),
  [6610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 140),
  [6612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 140),
  [6614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [6616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [6618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 5, 0, 161),
  [6620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 5, 0, 161),
  [6622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 163),
  [6624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 163),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5417),
  [6628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5417),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [6632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 174),
  [6634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 174),
  [6636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 6, 0, 186),
  [6638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 6, 0, 186),
  [6640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [6642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [6644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, 0, 198),
  [6646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, 0, 198),
  [6648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 200),
  [6650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 200),
  [6652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 201),
  [6654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 201),
  [6656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 213),
  [6658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 213),
  [6660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 214),
  [6662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 214),
  [6664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [6666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [6668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 221),
  [6670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 221),
  [6672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 222),
  [6674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 222),
  [6676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [6678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [6680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, 0, 225),
  [6682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, 0, 225),
  [6684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [6686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8623),
  [6690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8623),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [6694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [6696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [6698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 3, 0, 0),
  [6700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 3, 0, 0),
  [6702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [6704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [6706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [6708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [6710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [6712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [6714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 164),
  [6716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 164),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [6720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1019),
  [6723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6321),
  [6731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [6733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [6735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2574),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [6739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [6741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [6743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [6745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(407),
  [6748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [6750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [6756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [6758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [6760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2975),
  [6763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2574),
  [6766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2999),
  [6769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8306),
  [6772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7249),
  [6775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8308),
  [6778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8509),
  [6781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2622),
  [6783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [6785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8614),
  [6791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8614),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6090),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [6799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [6801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2595),
  [6804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7061),
  [6807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7905),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [6814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [6818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2602),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8121),
  [6833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2628),
  [6835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [6837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [6839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(416),
  [6842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [6844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7041),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6279),
  [6852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [6854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [6856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [6858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [6860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [6862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3073),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8731),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [6880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [6882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [6884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [6886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [6888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [6892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [6894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [6902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [6904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [6908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(421),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [6915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [6917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [6919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement, 1, 0, 66),
  [6921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement, 1, 0, 66),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [6933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_expression, 2, 0, 0),
  [6935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_expression, 2, 0, 0),
  [6937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [6939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [6945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [6947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [6949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [6953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [6957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [6961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [6963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [6965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [6967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [6969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8259),
  [6987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [6989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [7005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [7007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [7011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, 0, 126),
  [7013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, 0, 126),
  [7015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [7017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [7019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 180),
  [7021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 180),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6086),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6348),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [7033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [7036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3, 0, 0),
  [7038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3, 0, 0),
  [7040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [7044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5407),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [7048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8508),
  [7051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8508),
  [7054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7423),
  [7057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [7059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3992),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8581),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [7065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6750),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [7069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5841),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8388),
  [7076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5434),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [7081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8508),
  [7085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8508),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8373),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7452),
  [7095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8175),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5275),
  [7109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5275),
  [7111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [7113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [7119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [7121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [7123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [7127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [7131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [7137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [7139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8417),
  [7149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7249),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7977),
  [7154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6750),
  [7157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6750),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [7162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5444),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [7169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5269),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [7175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5272),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [7187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [7189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [7191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [7193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [7195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [7201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [7203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [7205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [7211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [7215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [7217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [7219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [7221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [7225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [7229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [7231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [7253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [7255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [7259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [7267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6166),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5996),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8685),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [7279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5249),
  [7281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6651),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [7287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5257),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [7291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [7295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5263),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5838),
  [7299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5444),
  [7303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [7305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6070),
  [7307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8417),
  [7310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8417),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [7319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5459),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [7324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5999),
  [7327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5472),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [7332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5480),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [7339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [7341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [7347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [7349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [7351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [7355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [7359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [7363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [7365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [7371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6590),
  [7373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1028),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [7378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5459),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [7392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8570),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5480),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [7408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3717),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [7412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8087),
  [7418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7452),
  [7421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [7425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3587),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8774),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5800),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [7435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7460),
  [7437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [7443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6628),
  [7445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [7449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6602),
  [7451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [7453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6629),
  [7455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [7457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_fold_operator, 3, 0, 135),
  [7459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold_operator, 3, 0, 135),
  [7461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [7463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [7465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [7467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3733),
  [7469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [7471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [7473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [7477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [7479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [7481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [7483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6166),
  [7487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [7489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [7491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [7493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [7495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [7497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [7501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76), SHIFT(399),
  [7504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, 0, 113),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [7508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [7511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [7513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [7515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [7518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [7522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3137),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [7526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7460),
  [7529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3151),
  [7531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3151),
  [7534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6943),
  [7537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7919),
  [7540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76), SHIFT(371),
  [7543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 72), SHIFT(407),
  [7546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 125), SHIFT(407),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5469),
  [7553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5469),
  [7556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3363),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [7560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [7562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [7564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6143),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [7568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76), SHIFT(407),
  [7571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8147),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [7577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [7579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [7581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [7583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [7585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [7591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [7593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [7595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [7601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [7603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [7605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [7607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [7609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [7611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [7613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8186),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8190),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8192),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8194),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8198),
  [7625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8203),
  [7627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8208),
  [7629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8231),
  [7631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8260),
  [7633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8264),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8271),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [7655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 4, 0, 143),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [7663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6132),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [7671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [7673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [7679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [7681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [7683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [7687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [7689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [7695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [7697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [7705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3452),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [7709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [7717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [7719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 125), SHIFT(416),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [7724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1658),
  [7727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3269),
  [7730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3132),
  [7733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8417),
  [7736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7401),
  [7739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8279),
  [7742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7977),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [7749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [7751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [7753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2975),
  [7756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3282),
  [7759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2999),
  [7762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8306),
  [7765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7249),
  [7768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8308),
  [7771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8509),
  [7774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(4204),
  [7777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [7779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [7781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3761),
  [7784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3748),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [7789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 72), SHIFT(416),
  [7792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6021),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [7798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [7800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [7802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [7806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [7810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [7814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [7816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [7818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [7820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [7822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [7826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [7828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [7830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [7832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [7834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3374),
  [7836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3375),
  [7838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5357),
  [7848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5357),
  [7850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3761),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [7856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [7858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [7860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3395),
  [7862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3362),
  [7864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(427),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [7869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5443),
  [7872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3463),
  [7874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3463),
  [7877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7007),
  [7880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7914),
  [7883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3472),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [7890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5345),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [7896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5483),
  [7898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5456),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [7904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5352),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5443),
  [7908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76), SHIFT(416),
  [7911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [7913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [7915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [7921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [7923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [7925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [7929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [7933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [7935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [7937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [7939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [7941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [7943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [7945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5461),
  [7947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5467),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6002),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6332),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [7955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4308),
  [7957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6587),
  [7961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [7963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture, 2, 0, 0),
  [7965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture, 2, 0, 0),
  [7968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4001),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6630),
  [7972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6255),
  [7974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5062),
  [7976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5083),
  [7978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5108),
  [7980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5199),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [7986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5406),
  [7988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4980),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6593),
  [7992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4882),
  [7994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5243),
  [7996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6194),
  [7998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5115),
  [8000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5124),
  [8002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5128),
  [8004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5183),
  [8006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(386),
  [8009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3992),
  [8012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8581),
  [8015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [8017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [8019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4189),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6632),
  [8023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4069),
  [8025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4356),
  [8027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6186),
  [8029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5057),
  [8031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5059),
  [8033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5064),
  [8035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4948),
  [8037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8625),
  [8039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5170),
  [8041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [8043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [8047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4513),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [8051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [8053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4038),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [8057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [8059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [8061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6270),
  [8063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5082),
  [8065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5091),
  [8067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5132),
  [8069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4612),
  [8071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8602),
  [8073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5231),
  [8075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [8077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [8079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4880),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [8083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6172),
  [8085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5104),
  [8087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5102),
  [8089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5139),
  [8091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [8093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0),
  [8095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4043),
  [8098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4028),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [8103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4096),
  [8105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8282),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5470),
  [8111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5470),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [8123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5463),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8309),
  [8135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4181),
  [8137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(3992),
  [8140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4073),
  [8142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8581),
  [8145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4180),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8678),
  [8153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4195),
  [8155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(3992),
  [8158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4196),
  [8160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8581),
  [8163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4194),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [8171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5628),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7045),
  [8175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, 0, 58),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [8179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4025),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [8185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [8187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8227),
  [8193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [8199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5692),
  [8201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [8203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [8205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [8207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8362),
  [8213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(410),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [8220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5740),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [8226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5683),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [8232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5753),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [8236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5852),
  [8244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5852),
  [8246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [8248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [8250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [8252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6088),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5794),
  [8260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5794),
  [8262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6081),
  [8264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6082),
  [8266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3286),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [8274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5873),
  [8276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [8278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [8280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [8288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5863),
  [8290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [8292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8279),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [8304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5810),
  [8306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [8308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [8312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [8316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5848),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5861),
  [8322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5861),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [8328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5851),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5868),
  [8334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5868),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6070),
  [8340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4058),
  [8343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4375),
  [8345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4316),
  [8348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4238),
  [8350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8638),
  [8353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4371),
  [8355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4387),
  [8357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4316),
  [8360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4388),
  [8362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8638),
  [8365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4383),
  [8367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [8369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [8371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5910),
  [8373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [8375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [8377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5946),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [8381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5267),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8540),
  [8389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [8393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [8395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [8399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [8403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [8405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [8411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [8413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [8419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [8421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [8427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6283),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5948),
  [8435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5948),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [8439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [8441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [8443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [8445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [8447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [8449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, 0, 148),
  [8451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, 0, 148),
  [8453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4316),
  [8456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8638),
  [8459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6828),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [8465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5964),
  [8467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4289),
  [8470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8309),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [8477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5961),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8272),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5947),
  [8485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [8489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [8493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [8495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [8499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [8503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [8507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [8515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [8517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [8521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [8525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [8527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [8537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [8539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1658),
  [8542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(4186),
  [8545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3132),
  [8548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8417),
  [8551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7457),
  [8554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8279),
  [8557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7977),
  [8560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [8562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [8572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6039),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [8582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [8586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [8588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1695),
  [8591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4393),
  [8593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8540),
  [8596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(1695),
  [8599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8540),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [8606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6140),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [8610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5422),
  [8612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4217),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [8617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2229),
  [8620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4488),
  [8622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8624),
  [8625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2229),
  [8628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8624),
  [8631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [8633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [8635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8417),
  [8638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8417),
  [8641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [8643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5477),
  [8645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [8647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [8649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [8651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [8653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [8655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [8657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [8661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [8663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [8665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [8669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [8673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [8675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [8677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6182),
  [8689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6182),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [8699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 182),
  [8701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 182),
  [8703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, 0, 84),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [8709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [8713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [8719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [8723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [8727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [8731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4817),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [8747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, 0, 118),
  [8749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 4, 0, 192),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [8753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [8755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [8761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [8763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [8771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8508),
  [8774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8508),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [8787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [8789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [8795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [8811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [8815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [8821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [8825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [8829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [8857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [8861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [8863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT(1159),
  [8866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8630),
  [8876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8630),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [8884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [8894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [8896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [8904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 146), SHIFT(1159),
  [8907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 146),
  [8909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6433),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [8915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 156),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [8921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [8923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [8925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [8931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [8933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [8935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [8939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [8941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [8943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [8945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [8947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [8949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [8951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [8953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [8955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 3, 0, 168),
  [8957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 157),
  [8959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 193),
  [8961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 5, 0, 188),
  [8963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 194),
  [8965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [8967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6158),
  [8969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8248),
  [8971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [8973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [8975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [8981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 3, 0, 84),
  [8983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 196),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [8987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8466),
  [8989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [8991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6309),
  [8993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [8995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4, 0, 0),
  [8997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [8999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 1, 0),
  [9001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [9003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8195),
  [9005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [9009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 4, 0, 203),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8088),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6164),
  [9019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8456),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [9023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [9025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8346),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [9041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [9045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6120),
  [9047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8047),
  [9049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 147),
  [9051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [9053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [9059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, 1, 209),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [9063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [9065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [9067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [9071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [9075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [9079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [9081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7008),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7275),
  [9085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [9087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [9089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [9093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [9095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [9097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [9099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [9101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [9103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [9105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [9107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [9109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [9111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [9113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0), REDUCE(sym_argument_list, 2, 0, 0),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [9126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_left_fold, 3, 0, 55),
  [9128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 4, 0, 195),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [9152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [9158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [9168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [9170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [9172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [9174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [9176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [9182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [9184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8508),
  [9187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8508),
  [9190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7423),
  [9193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [9195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5841),
  [9198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5434),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [9205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [9207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [9209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [9213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7478),
  [9215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_expression_lhs, 3, 0, 55),
  [9217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [9219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [9221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7248),
  [9223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [9225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [9227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [9235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [9237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [9241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [9243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 5, 0, 210),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7142),
  [9247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold, 3, 0, 85),
  [9249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [9251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7285),
  [9253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [9255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [9257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [9259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [9261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [9263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [9265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [9267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7249),
  [9270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6750),
  [9273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6750),
  [9276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7249),
  [9279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5431),
  [9281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5444),
  [9284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture, 1, 0, 0),
  [9286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture, 1, 0, 0),
  [9289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5475),
  [9291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8417),
  [9294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8417),
  [9297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5999),
  [9300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5480),
  [9303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6091),
  [9305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [9307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(5021),
  [9310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4984),
  [9313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4985),
  [9316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5459),
  [9319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5035),
  [9322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5038),
  [9325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5007),
  [9328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5472),
  [9331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3274),
  [9333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7347),
  [9335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 1, 0, 0),
  [9337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [9339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6069),
  [9341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5469),
  [9344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [9346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8508),
  [9349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8508),
  [9352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7423),
  [9355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [9357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5841),
  [9360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5434),
  [9363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3119),
  [9365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [9367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7249),
  [9370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6750),
  [9373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6750),
  [9376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5444),
  [9379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1027),
  [9382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [9386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [9388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [9390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6179),
  [9392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5127),
  [9394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5129),
  [9396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5131),
  [9398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [9400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8543),
  [9402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5211),
  [9404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3980),
  [9406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6594),
  [9408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [9410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6215),
  [9412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5137),
  [9414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5140),
  [9416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5141),
  [9418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5187),
  [9420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5029),
  [9422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6626),
  [9426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [9428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6192),
  [9430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5136),
  [9432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5142),
  [9434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5145),
  [9436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5207),
  [9438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [9440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6620),
  [9442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [9444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2715),
  [9446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6180),
  [9448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5106),
  [9450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5107),
  [9452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5148),
  [9454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [9456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8616),
  [9458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5175),
  [9460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 0), SHIFT(1918),
  [9463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 45), SHIFT(5023),
  [9466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8417),
  [9469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8417),
  [9472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5459),
  [9475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(1918),
  [9478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5443),
  [9481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [9483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [9485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [9487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6243),
  [9489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5171),
  [9491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [9493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [9495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5999),
  [9498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5472),
  [9501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2568),
  [9503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [9505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [9507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2703),
  [9509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6256),
  [9511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5144),
  [9513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5152),
  [9515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5151),
  [9517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2976),
  [9519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8513),
  [9521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5159),
  [9523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20), SHIFT(5016),
  [9526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2722),
  [9528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [9530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [9532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [9534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6249),
  [9536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5058),
  [9538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5047),
  [9540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5056),
  [9542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3491),
  [9544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8584),
  [9546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5169),
  [9548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5480),
  [9551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20), SHIFT(1918),
  [9554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [9556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [9558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5267),
  [9561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5267),
  [9564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5268),
  [9567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 77), SHIFT(5024),
  [9570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, 0, 45), SHIFT(1918),
  [9573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, -1, 77), SHIFT(1918),
  [9576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [9578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6634),
  [9580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [9582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3737),
  [9584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6193),
  [9586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5122),
  [9588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5125),
  [9590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5126),
  [9592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4081),
  [9594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8632),
  [9596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5213),
  [9598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18), SHIFT(1918),
  [9601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 35), SHIFT(1918),
  [9604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5258),
  [9606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 35), SHIFT(5030),
  [9609] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(1918),
  [9613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2936),
  [9615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2971),
  [9617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [9619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4231),
  [9621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3170),
  [9623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4042),
  [9625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6604),
  [9627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4895),
  [9629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5469),
  [9632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [9634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4480),
  [9636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4601),
  [9638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3455),
  [9640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [9642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3770),
  [9644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3998),
  [9646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2555),
  [9648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5032),
  [9650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6183),
  [9652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5212),
  [9654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [9656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [9658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [9660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [9662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(4995),
  [9665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [9667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8508),
  [9670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8508),
  [9673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7423),
  [9676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [9678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5443),
  [9681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5841),
  [9684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5434),
  [9687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7249),
  [9690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6750),
  [9693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6750),
  [9696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5444),
  [9699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8417),
  [9702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8417),
  [9705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5999),
  [9708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5480),
  [9711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5459),
  [9714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5472),
  [9717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5469),
  [9720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [9722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [9724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [9726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7022),
  [9728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [9732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4183),
  [9734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6985),
  [9736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4257),
  [9738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [9740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [9742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [9744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7000),
  [9746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [9748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [9750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4825),
  [9752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6986),
  [9754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [9756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [9758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3837),
  [9760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7121),
  [9762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [9766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3478),
  [9768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7135),
  [9770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [9774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [9776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [9778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [9780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7780),
  [9784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [9788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [9790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7763),
  [9792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5443),
  [9795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [9797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [9799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [9801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [9803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [9805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [9807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [9809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [9811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6554),
  [9813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [9815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5449),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [9819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [9821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [9823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [9829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [9831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [9833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [9835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [9837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [9841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2459),
  [9843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [9845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [9847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [9849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [9853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6210),
  [9855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6971),
  [9857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [9859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [9861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5425),
  [9863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [9865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [9867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [9869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [9871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [9873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3839),
  [9875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [9877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4222),
  [9879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6878),
  [9881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [9883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5520),
  [9885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7023),
  [9887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5578),
  [9889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5579),
  [9891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [9893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [9895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [9897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [9899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [9901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [9905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5926),
  [9907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6994),
  [9909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5898),
  [9911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6265),
  [9913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6484),
  [9915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5427),
  [9917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6264),
  [9919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5841),
  [9922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5444),
  [9925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [9927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5841),
  [9930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5444),
  [9933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6235),
  [9935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [9937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [9939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6234),
  [9941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [9943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8432),
  [9945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [9947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7280),
  [9949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [9953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [9955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3435),
  [9957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7227),
  [9959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5817),
  [9961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6618),
  [9963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6019),
  [9965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [9967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3674),
  [9969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6230),
  [9971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [9973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [9975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6020),
  [9977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4174),
  [9979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4795),
  [9981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6487),
  [9983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4214),
  [9985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4126),
  [9987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7202),
  [9989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5885),
  [9991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6881),
  [9993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [9997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [9999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [10001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [10005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6726),
  [10007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7767),
  [10009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [10011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [10013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [10017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [10019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [10021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [10023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7656),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [10029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5435),
  [10031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5436),
  [10033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5438),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [10039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7821),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [10043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5770),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5546),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [10051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [10053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [10055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(5841),
  [10058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [10060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [10062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5700),
  [10064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [10066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5704),
  [10068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [10070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [10072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5710),
  [10074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [10076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5717),
  [10078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [10080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5719),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [10084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [10086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 3, 0, 0),
  [10088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 3, 0, 0),
  [10090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [10092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [10094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5434),
  [10097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5434),
  [10100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 1, 0, 0),
  [10102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [10104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 1, 0, 0),
  [10106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5802),
  [10108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8093),
  [10110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [10112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [10114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7703),
  [10116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5636),
  [10118] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [10120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6576),
  [10122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7544),
  [10124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8031),
  [10126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [10128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [10130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [10132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [10136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 4, 0, 0),
  [10138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 4, 0, 0),
  [10140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [10142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [10144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [10146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [10148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7817),
  [10150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [10152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5580),
  [10154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [10156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6773),
  [10158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8111),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6327),
  [10162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [10164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [10166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7222),
  [10168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 55),
  [10170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 55),
  [10172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [10174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [10176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [10178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [10180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5587),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [10184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7591),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [10188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5666),
  [10190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [10192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7254),
  [10194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2901),
  [10196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [10198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7270),
  [10200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3056),
  [10202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5793),
  [10204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5867),
  [10206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2945),
  [10208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8323),
  [10210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5659),
  [10212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7169),
  [10214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [10216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5872),
  [10218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5808),
  [10220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [10222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [10224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [10226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8430),
  [10230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [10232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7192),
  [10234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [10236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [10238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [10240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [10242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4047),
  [10244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7472),
  [10246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5840),
  [10248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7423),
  [10251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [10253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [10255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [10257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [10259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [10261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [10263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [10265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [10267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [10269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [10271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5766),
  [10273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [10275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8714),
  [10277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [10279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7177),
  [10281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [10283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [10285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [10287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [10289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5774),
  [10291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [10293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [10295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [10297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5844),
  [10299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5643),
  [10301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [10303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [10305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [10307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [10309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [10311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [10313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [10315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7210),
  [10317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [10319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5833),
  [10321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [10323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [10325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [10327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [10331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3068),
  [10333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [10335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7147),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5856),
  [10341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [10343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5821),
  [10345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [10347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [10349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [10351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [10353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8667),
  [10355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5750),
  [10357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7217),
  [10359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [10361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6683),
  [10363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [10367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [10369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [10371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [10373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [10375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [10377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [10379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7237),
  [10381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0),
  [10383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [10385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [10387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5831),
  [10389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [10391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [10393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [10395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [10397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [10399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [10401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7160),
  [10403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3190),
  [10405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5773),
  [10407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7244),
  [10409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [10411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [10413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7245),
  [10415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [10417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5857),
  [10419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5798),
  [10421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [10423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3817),
  [10425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7246),
  [10427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [10429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [10431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [10433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [10435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [10439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [10441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5788),
  [10443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7537),
  [10445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [10449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, 0, 39),
  [10451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 1, 0, 39),
  [10453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [10455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7457),
  [10458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7098),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [10462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7292),
  [10464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [10466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5724),
  [10468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5726),
  [10470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5727),
  [10472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5729),
  [10474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5730),
  [10476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5738),
  [10478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5739),
  [10480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5741),
  [10482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5742),
  [10484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5743),
  [10486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5897),
  [10488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [10490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [10492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [10494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [10496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6653),
  [10498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7242),
  [10500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [10502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [10504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [10506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [10508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6422),
  [10510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [10512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [10514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [10516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [10518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 184),
  [10520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 184),
  [10522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 123),
  [10524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 123),
  [10526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [10528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [10530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 134),
  [10532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 134),
  [10534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [10536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [10538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6157),
  [10540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [10542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [10544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [10546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [10548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [10550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [10552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [10554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5849),
  [10556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7532),
  [10558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [10560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [10562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [10564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [10566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [10568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, 0, 179),
  [10570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 5, 0, 179),
  [10572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [10574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6855),
  [10576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7379),
  [10578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [10580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [10582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 2, 0, 23),
  [10584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [10586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [10588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 1, 0, 0),
  [10590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [10592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 3, 0, 59),
  [10594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [10596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6485),
  [10598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 1, 0, 23),
  [10600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 2, 0, 59),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6414),
  [10604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5439),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [10610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6181),
  [10612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6859),
  [10614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [10616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5999),
  [10619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5480),
  [10622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6185),
  [10624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6272),
  [10626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6233),
  [10628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5999),
  [10631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5480),
  [10634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [10636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(5999),
  [10639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [10641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [10643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [10645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(8306),
  [10648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [10650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(8509),
  [10653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5970),
  [10655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7082),
  [10657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7912),
  [10659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 5),
  [10661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5959),
  [10663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [10665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7445),
  [10667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5970),
  [10670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7082),
  [10673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7912),
  [10676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7750),
  [10678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 2, 0, 0),
  [10680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6394),
  [10682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1, 0, 0),
  [10684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [10686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [10688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [10690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [10692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [10694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [10696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [10698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [10700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [10702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4200),
  [10704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4389),
  [10706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 123),
  [10708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 123),
  [10710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [10712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [10714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [10716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7966),
  [10719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6350),
  [10721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6852),
  [10723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [10725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [10727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3328),
  [10729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [10731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 38),
  [10733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [10735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 38),
  [10737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [10739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3385),
  [10741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [10743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [10745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [10747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [10749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 83),
  [10751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 83),
  [10753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 64),
  [10755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 64),
  [10757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [10759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [10761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, 0, 136),
  [10763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 4, 0, 136),
  [10765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 87),
  [10767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 87),
  [10769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [10771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [10773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4386),
  [10775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [10777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [10779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [10781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [10783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [10785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [10787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [10789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4026),
  [10791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4198),
  [10793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [10795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [10797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5459),
  [10800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3818),
  [10802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [10804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [10806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [10808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [10810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5472),
  [10813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, 0, 179),
  [10815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, 0, 179),
  [10817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5472),
  [10820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4280),
  [10822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [10824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [10826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2610),
  [10828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2714),
  [10830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [10832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2570),
  [10834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4853),
  [10836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5015),
  [10838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, 1, 177),
  [10840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 5, 1, 177),
  [10842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6302),
  [10846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [10848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [10850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [10852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [10854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [10856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5469),
  [10859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3297),
  [10861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [10863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6882),
  [10865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [10867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [10869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [10871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [10873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, 1, 87),
  [10875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 4, 1, 87),
  [10877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6277),
  [10879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6926),
  [10881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, 1, 177),
  [10883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 5, 1, 177),
  [10885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [10887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [10889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6659),
  [10891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, 0, 81),
  [10893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [10895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5657),
  [10897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8487),
  [10899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, 1, 87),
  [10901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 4, 1, 87),
  [10903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [10905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [10907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [10909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [10911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, 0, 10),
  [10913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6364),
  [10915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [10917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6339),
  [10919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [10921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6955),
  [10923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6387),
  [10925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6396),
  [10927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6353),
  [10929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6374),
  [10931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5469),
  [10934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6355),
  [10936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6354),
  [10938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6366),
  [10940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 68),
  [10942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [10944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [10946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [10948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [10950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7066),
  [10954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6371),
  [10956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [10958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7455),
  [10962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [10964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [10966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [10968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7447),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6991),
  [10972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6375),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7006),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [10982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6379),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5455),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [10990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [10992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7268),
  [10994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6954),
  [10996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5421),
  [10998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6359),
  [11000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6352),
  [11002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [11004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6376),
  [11006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6393),
  [11008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [11010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6382),
  [11012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6383),
  [11014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6400),
  [11016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [11018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5459),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [11023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [11025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6386),
  [11027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6390),
  [11029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [11031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7425),
  [11033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7065),
  [11035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [11037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [11039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [11041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [11043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7317),
  [11045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5768),
  [11047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8069),
  [11049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [11051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [11053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 103),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [11057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 103),
  [11059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3260),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [11067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [11069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [11071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [11073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [11075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [11079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5443),
  [11082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6757),
  [11084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [11090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6877),
  [11092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6862),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [11098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [11100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6724),
  [11102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [11104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [11106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [11108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [11110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [11112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [11114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [11120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3174),
  [11122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [11124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [11126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [11128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [11130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 123),
  [11132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 123),
  [11134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [11136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [11138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [11140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [11142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [11144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [11146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_declarator_repeat1, 2, 0, 0),
  [11148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(6554),
  [11151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, 0, 179),
  [11153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, 0, 179),
  [11155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6572),
  [11157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6644),
  [11159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6591),
  [11161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [11163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7019),
  [11165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6595),
  [11167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 81),
  [11169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7078),
  [11171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5782),
  [11173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8652),
  [11175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 81),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [11179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5784),
  [11181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8687),
  [11183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6992),
  [11185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6581),
  [11187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6708),
  [11189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6596),
  [11191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7077),
  [11193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6597),
  [11195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, 0, 81),
  [11197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [11199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, 0, 26),
  [11201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_declarators, 1, 0, 26),
  [11203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6709),
  [11205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6600),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8681),
  [11211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7005),
  [11213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6601),
  [11215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7317),
  [11218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5661),
  [11221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8726),
  [11224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7666),
  [11227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [11229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7103),
  [11231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6613),
  [11233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6923),
  [11235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7662),
  [11237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7364),
  [11239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6685),
  [11241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6617),
  [11243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7133),
  [11245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6605),
  [11247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7261),
  [11249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5443),
  [11252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, 0, 10),
  [11254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6692),
  [11256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6583),
  [11258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [11260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [11262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [11264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6527),
  [11266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [11268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6795),
  [11270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8389),
  [11272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [11274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7110),
  [11276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6585),
  [11278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [11280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6549),
  [11282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [11284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6780),
  [11286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6694),
  [11288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6584),
  [11290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 10),
  [11292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6657),
  [11294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6582),
  [11296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6557),
  [11298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 10),
  [11300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [11302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [11304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [11306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4990),
  [11308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [11310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5001),
  [11312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [11314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5025),
  [11316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2613),
  [11318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6589),
  [11320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [11322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [11324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4988),
  [11326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_specifier, 1, 0, 0),
  [11328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [11330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [11332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5010),
  [11334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1, 0, 0),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8261),
  [11338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [11340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4978),
  [11342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [11344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [11346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [11348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4979),
  [11350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1, 0, 0),
  [11352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8017),
  [11354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [11356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [11358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5014),
  [11360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [11362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4983),
  [11364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [11366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [11368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7484),
  [11370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7125),
  [11372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8368),
  [11374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [11376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7764),
  [11378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4444),
  [11380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7876),
  [11382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [11384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7815),
  [11386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7004),
  [11388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7032),
  [11390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7001),
  [11392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6884),
  [11394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8583),
  [11396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4847),
  [11398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7629),
  [11400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7282),
  [11402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8460),
  [11404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2601),
  [11406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7861),
  [11408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7273),
  [11410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4046),
  [11412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7704),
  [11414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4742),
  [11416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7823),
  [11418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3986),
  [11420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7105),
  [11422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6931),
  [11424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7042),
  [11426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [11428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7100),
  [11430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7207),
  [11432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7449),
  [11434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8174),
  [11436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2947),
  [11438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7829),
  [11440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7014),
  [11442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3150),
  [11444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7657),
  [11446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7027),
  [11448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [11450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7651),
  [11452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7012),
  [11454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5809),
  [11456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7561),
  [11458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [11460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7637),
  [11462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3708),
  [11464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7550),
  [11466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7141),
  [11468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7132),
  [11470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4229),
  [11472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7752),
  [11474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2559),
  [11476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7762),
  [11478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3456),
  [11480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7592),
  [11482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7492),
  [11484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8397),
  [11486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [11488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [11492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [11494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [11496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [11498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [11500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [11502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [11504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, 0, 6),
  [11506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, 0, 6),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6378),
  [11514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 3, 0, 23),
  [11516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 4, 0, 23),
  [11518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 4, 0, 59),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [11524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast, 3, 0, 60),
  [11526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7826),
  [11530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(6061),
  [11533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [11537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [11541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [11543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [11545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [11549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [11551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [11555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7317),
  [11558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [11560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [11562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0), SHIFT_REPEAT(6659),
  [11565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [11567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [11569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [11575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6365),
  [11579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [11583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 5, 0, 59),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [11587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 58),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6154),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6889),
  [11595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [11597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0),
  [11599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6889),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [11604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [11608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8165),
  [11610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [11612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7306),
  [11614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [11616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [11618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [11622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [11624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6121),
  [11626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6109),
  [11628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6111),
  [11630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [11632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [11634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6129),
  [11636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6131),
  [11638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6093),
  [11640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [11642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6136),
  [11644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6138),
  [11646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(1364),
  [11649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0),
  [11651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(8165),
  [11654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 68),
  [11656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7176),
  [11658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7250),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [11662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [11664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [11666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7450),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [11670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [11672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [11674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 132),
  [11676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 132),
  [11678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [11680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [11682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [11684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [11686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [11688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 3, 0, 0),
  [11690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [11692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [11694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [11696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [11698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 4, 0, 0),
  [11700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [11702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [11704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [11706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [11708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 81),
  [11710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 81),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [11722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [11724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [11730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [11734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [11736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [11740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [11742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [11744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [11746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [11748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [11750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [11754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [11756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 183),
  [11758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 183),
  [11760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [11762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [11764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [11766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [11768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 81),
  [11770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 81),
  [11772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [11774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [11776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [11778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 82),
  [11780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 82),
  [11782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [11784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [11786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [11788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [11790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [11794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [11798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [11800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 133),
  [11802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 133),
  [11804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [11806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [11808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [11810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [11812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [11816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [11818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [11820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [11822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7639),
  [11824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7736),
  [11826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [11828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [11830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [11832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [11834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [11836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [11838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7801),
  [11840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_name, 2, 0, 0),
  [11842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8689),
  [11844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7642),
  [11846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 191), SHIFT_REPEAT(5947),
  [11849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 191),
  [11851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 191),
  [11853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 121), SHIFT_REPEAT(5803),
  [11856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 121),
  [11858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 121),
  [11860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [11862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 6),
  [11864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8603),
  [11866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6850),
  [11868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [11870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [11872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_name_repeat1, 2, 0, 0),
  [11874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_name_repeat1, 2, 0, 0), SHIFT_REPEAT(8689),
  [11877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7628),
  [11879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7689),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5433),
  [11883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7294),
  [11885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5432),
  [11887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7658),
  [11889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [11895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1, 0, 0),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [11899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1, 0, 0),
  [11901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7593),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [11911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, 0, 90),
  [11913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_declarators, 2, 0, 90),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [11919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [11921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [11923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [11925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [11927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [11929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [11931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [11933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [11935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [11939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [11943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 142),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8489),
  [11947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6071),
  [11949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [11951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 4, 0, 202),
  [11953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [11955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [11959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [11961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [11963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_name, 1, 0, 0),
  [11965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [11967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 3, 0, 167),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [11971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [11973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [11975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7741),
  [11979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7618),
  [11981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7590),
  [11983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [11985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [11987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, 0, 199),
  [11989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6170),
  [11991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, 0, 212),
  [11993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [11995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7039),
  [11997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7039),
  [11999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [12001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [12003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator_cast_identifier, 2, 0, 33),
  [12005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [12007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3551),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [12011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6945),
  [12013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3207),
  [12015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7020),
  [12017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3577),
  [12019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3933),
  [12021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6993),
  [12023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6993),
  [12025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3213),
  [12027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [12029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6958),
  [12031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6958),
  [12033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [12035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2640),
  [12037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [12039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7378),
  [12041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8139),
  [12043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5674),
  [12045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2339),
  [12047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [12049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8676),
  [12051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [12053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [12055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 223), SHIFT_REPEAT(6170),
  [12058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 223),
  [12060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4205),
  [12062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7807),
  [12064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6259),
  [12066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [12068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [12070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8324),
  [12072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [12074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [12076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3408),
  [12078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [12080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7938),
  [12082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6923),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [12086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8345),
  [12088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [12092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [12094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [12096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7064),
  [12098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3764),
  [12100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [12102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4362),
  [12104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6978),
  [12108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6978),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7302),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5886),
  [12114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 3, 0, 0),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [12118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3953),
  [12120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [12122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4243),
  [12124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [12126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [12128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7015),
  [12130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 1, 0, 19),
  [12132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6875),
  [12134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [12136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6967),
  [12138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6967),
  [12140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [12144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [12146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7053),
  [12148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7053),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7315),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7538),
  [12156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 2, 0, 0),
  [12158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [12162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [12164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5828),
  [12166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8465),
  [12168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [12170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0),
  [12172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7020),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [12177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7759),
  [12181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7718),
  [12183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6860),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6675),
  [12187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, 0, 162),
  [12189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [12191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [12193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [12195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [12199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7579),
  [12201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7774),
  [12203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6430),
  [12205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6987),
  [12209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6987),
  [12211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [12213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7039),
  [12216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7039),
  [12219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [12221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3340),
  [12223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6960),
  [12225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6960),
  [12227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6851),
  [12229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7426),
  [12231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 1, 0, 0),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [12235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 94),
  [12237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2562),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [12241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7130),
  [12243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 206),
  [12245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 206),
  [12247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [12249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3874),
  [12251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [12253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [12255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [12257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8725),
  [12259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2, 0, 0),
  [12261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2, 0, 0),
  [12263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3749),
  [12265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7089),
  [12267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7089),
  [12269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [12271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [12273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7124),
  [12275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [12277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [12279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6499),
  [12281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7546),
  [12283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 4, 0, 0),
  [12285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [12287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [12289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [12291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6950),
  [12293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6950),
  [12295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [12297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [12299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [12301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [12303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [12305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8384),
  [12307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [12309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6250),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6966),
  [12313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6966),
  [12315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7713),
  [12319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7716),
  [12321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [12323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [12325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7945),
  [12327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3709),
  [12329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1, 0, 0),
  [12331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 211), SHIFT_REPEAT(6674),
  [12334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 211),
  [12336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, 0, 162),
  [12338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [12340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [12342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [12344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [12346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [12348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6952),
  [12350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6952),
  [12352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [12354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 6, 0, 204),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6434),
  [12360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, 0, 219),
  [12362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2391),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6937),
  [12366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6937),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7677),
  [12370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7602),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [12374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 211), SHIFT_REPEAT(6675),
  [12377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 211),
  [12379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7074),
  [12383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7074),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [12387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [12389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, 0, 199),
  [12391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [12393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 5, 0, 0),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7720),
  [12397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7598),
  [12399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [12401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8177),
  [12403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7018),
  [12405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7018),
  [12407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6419),
  [12409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [12411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [12413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [12415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6876),
  [12417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [12419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4749),
  [12421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7559),
  [12423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [12425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [12427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [12429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7775),
  [12431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 103),
  [12433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, 0, 218),
  [12435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6318),
  [12437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [12439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7782),
  [12441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 0),
  [12443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 162),
  [12445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [12447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [12449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 6, 0, 0),
  [12451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [12453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8454),
  [12455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, 0, 220),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6563),
  [12461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [12463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [12465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [12467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [12469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7828),
  [12471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 4, 0, 0),
  [12473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [12475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [12477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [12479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [12483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [12485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7738),
  [12487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7582),
  [12489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [12491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [12493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6438),
  [12495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6472),
  [12497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6490),
  [12499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6492),
  [12501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [12503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [12505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [12507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [12509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7568),
  [12511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [12513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [12515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [12517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [12519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [12521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [12523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [12525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6558),
  [12527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [12529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [12531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [12533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [12535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [12537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [12539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [12541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [12543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [12545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [12547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [12549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [12557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [12561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [12563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [12567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [12569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4807),
  [12573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5977),
  [12575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [12577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [12579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [12583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [12585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [12587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [12589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6498),
  [12591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [12593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [12595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7668),
  [12597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [12599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8370),
  [12601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [12603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [12605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [12607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [12609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [12611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [12615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7731),
  [12617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7822),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [12621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [12623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [12625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [12627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [12629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [12631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [12633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [12635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3787),
  [12638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [12644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [12646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [12648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, 0, 218),
  [12650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6867),
  [12652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8120),
  [12654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [12656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 212),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7860),
  [12662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7017),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [12666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [12668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, 0, 224),
  [12670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6010),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [12680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6506),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8180),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8360),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7996),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7670),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5900),
  [12702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 226), SHIFT_REPEAT(8454),
  [12705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 226),
  [12707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, 0, 227),
  [12709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, 0, 227),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7739),
  [12713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1037),
  [12716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [12718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6491),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [12722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5593),
  [12724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [12728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [12730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [12736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1000),
  [12739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [12741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [12743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [12745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [12747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [12749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [12751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 2, 0, 0),
  [12753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6880),
  [12755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [12757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [12759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [12761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [12763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [12765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [12767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [12769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [12771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [12773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7895),
  [12775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0),
  [12777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [12779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7715),
  [12781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [12783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(5886),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [12794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 2, 0, 61),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [12802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [12806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [12808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [12810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [12812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [12814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [12816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [12818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [12820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [12822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [12826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [12828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [12834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [12836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [12838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7722),
  [12840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 2, 0, 0),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [12844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3723),
  [12847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0),
  [12849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 162),
  [12851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [12857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [12859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [12861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7661),
  [12863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6948),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [12867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8126),
  [12869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [12871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [12873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8708),
  [12875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8710),
  [12877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [12879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [12881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [12883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, 0, 68),
  [12885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7756),
  [12887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [12889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6996),
  [12891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [12893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 2, 0, 70),
  [12895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 3, 0, 152),
  [12897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [12899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [12901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [12903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [12905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7278),
  [12907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7636),
  [12909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7029),
  [12911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [12913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [12915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 5, 0, 23),
  [12917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [12919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [12921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [12923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [12925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [12927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7148),
  [12929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 3, 0, 0),
  [12931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [12933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [12935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7559),
  [12938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0),
  [12940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [12942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [12944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [12946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [12948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [12950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7707),
  [12952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7051),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [12956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7771),
  [12958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7855),
  [12960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [12962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 3, 0),
  [12964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8162),
  [12966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8164),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8184),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [12972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(443),
  [12975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0),
  [12977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [12979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [12981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [12983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7360),
  [12985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [12987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [12989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [12993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [12995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [12997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6957),
  [12999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8163),
  [13001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8167),
  [13003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8168),
  [13005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 2, 0, 0),
  [13007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 6, 0, 59),
  [13009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8057),
  [13011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8059),
  [13013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [13015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7468),
  [13017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7475),
  [13019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7495),
  [13021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [13023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8196),
  [13025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_reference_declarator, 2, 0, 0),
  [13027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [13029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [13031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [13033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [13035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6061),
  [13037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(8451),
  [13040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0),
  [13042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7134),
  [13044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1663),
  [13047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0),
  [13049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6500),
  [13051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(5973),
  [13054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8023),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8025),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8026),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [13064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1780),
  [13067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0),
  [13069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6983),
  [13071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1708),
  [13074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8399),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8401),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8403),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [13084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6318),
  [13087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0),
  [13089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6972),
  [13091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6988),
  [13093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6963),
  [13095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1067),
  [13098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6944),
  [13100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7087),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6843),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7712),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7838),
  [13112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, 0, 98),
  [13114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, 0, 205),
  [13116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [13120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [13128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5783),
  [13131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [13133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [13135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [13137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [13139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [13141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7784),
  [13143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0), SHIFT_REPEAT(7731),
  [13146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7648),
  [13150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 5, 0, 0),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [13154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [13172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 7, 0, 0),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [13182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [13186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 121), SHIFT_REPEAT(5228),
  [13189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 121),
  [13191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [13193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [13195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [13197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [13199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [13201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [13203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [13205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [13207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [13209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [13211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [13213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [13215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [13217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [13219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [13221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [13223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6661),
  [13225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [13227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7650),
  [13229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 3, 0, 0),
  [13231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [13233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [13235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [13237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [13239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [13241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [13243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [13245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7603),
  [13247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_partition, 2, 0, 0),
  [13249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 94),
  [13251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6810),
  [13253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [13255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [13257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [13259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [13261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8099),
  [13263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [13265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_pack_expansion, 2, 0, 28),
  [13267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [13269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7959),
  [13271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7687),
  [13273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [13275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [13277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [13279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [13281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [13283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7909),
  [13285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [13287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [13289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [13291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7638),
  [13293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [13295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [13297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [13299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8506),
  [13301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 6, 0, 0),
  [13303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7630),
  [13305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7799),
  [13307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [13309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8660),
  [13311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [13313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1, 0, 0),
  [13315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [13317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [13319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8042),
  [13321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [13323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8359),
  [13325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [13327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8206),
  [13329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [13331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [13333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5968),
  [13335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7697),
  [13337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 2, 0),
  [13339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [13341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 3, 0, 166),
  [13343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8462),
  [13345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [13347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_template_parameter_declaration, 3, 0, 59),
  [13349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7819),
  [13351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [13353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [13355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 7, 0, 204),
  [13357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7663),
  [13359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [13361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8216),
  [13363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 3, 0, 175),
  [13365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 220),
  [13367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7589),
  [13369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7576),
  [13371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [13373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8380),
  [13375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 103),
  [13377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [13379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8244),
  [13381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 0),
  [13383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [13385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8405),
  [13387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [13389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8423),
  [13391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [13393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7679),
  [13395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [13397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8749),
  [13399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [13401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [13403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7887),
  [13405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_parameter_pack_expansion, 2, 0, 28),
  [13407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7877),
  [13409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [13411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8622),
  [13413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [13415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [13417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 5, 0, 142),
  [13419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [13421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7820),
  [13423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8340),
  [13425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8802),
  [13427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [13429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [13431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8032),
  [13433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [13435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8549),
  [13437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [13439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8526),
  [13441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8805),
  [13443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8552),
  [13445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8808),
  [13447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8572),
  [13449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8811),
  [13451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8591),
  [13453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8814),
  [13455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 6),
  [13457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8608),
  [13459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8816),
  [13461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8618),
  [13463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8817),
  [13465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8627),
  [13467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8818),
  [13469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8633),
  [13471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8819),
  [13473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8636),
  [13475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8820),
  [13477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8639),
  [13479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8821),
  [13481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8641),
  [13483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8822),
  [13485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8643),
  [13487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8823),
  [13489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8645),
  [13491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8824),
  [13493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8647),
  [13495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8825),
  [13497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8649),
  [13499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8826),
  [13501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [13503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [13505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [13507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [13509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [13511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [13513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [13515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [13517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [13519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [13521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [13523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [13525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [13527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [13529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8503),
  [13531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [13533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [13535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [13537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7928),
  [13539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [13541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [13543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [13545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8136),
  [13547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8542),
  [13549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [13551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [13553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [13555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [13557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [13559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [13561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [13563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [13565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [13567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [13569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [13571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [13573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6914),
  [13575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [13577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [13579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [13581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [13583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6244),
  [13585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [13587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [13589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [13591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [13593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [13595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [13597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [13599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [13601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [13603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [13605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [13607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7057),
  [13609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [13611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [13613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [13615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [13617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [13619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [13621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8537),
  [13623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [13625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8657),
  [13627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [13629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [13631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [13633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [13635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [13637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_right_fold, 3, 0, 55),
  [13639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [13641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [13643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7994),
  [13645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [13647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [13649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [13651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [13653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [13655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [13657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [13659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [13661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8249),
  [13663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [13665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [13667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [13669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [13671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [13673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [13675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [13677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [13679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8185),
  [13681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [13683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [13685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [13687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [13689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [13691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8481),
  [13693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [13695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [13697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [13699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [13701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [13703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8018),
  [13705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [13707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [13709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [13711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8008),
  [13713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [13715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [13717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8086),
  [13719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8092),
  [13721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [13723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [13725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [13727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8157),
  [13729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [13731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [13733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [13735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8182),
  [13737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [13739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [13741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [13743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [13745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7080),
  [13747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [13749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [13751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [13753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [13755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 6, 0, 23),
  [13757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7951),
  [13759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [13761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [13763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [13765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [13767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7751),
  [13769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [13771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [13773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [13775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [13777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [13779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [13781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [13783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [13785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8068),
  [13787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [13789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8559),
  [13791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [13793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 3, 0, 0),
  [13795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [13797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [13799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8176),
  [13801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [13803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [13805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [13807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [13809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8201),
  [13811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8010),
  [13813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7510),
  [13815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [13817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [13819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7520),
  [13821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [13823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [13825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [13827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [13829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8265),
  [13831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [13833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8395),
  [13835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [13837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8314),
  [13839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8321),
  [13841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7088),
  [13843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 7, 0, 59),
  [13845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [13847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [13849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, 0, 183),
  [13851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [13853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [13855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [13857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [13859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [13861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [13863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [13865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [13867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, 0, 183),
  [13869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [13871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8579),
  [13873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8113),
  [13875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8029),
  [13877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [13879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, 0, 183),
  [13881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [13883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [13885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8722),
  [13887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8080),
  [13889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [13891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [13893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8446),
  [13895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8090),
  [13897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 5, 0, 0),
  [13899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [13901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8424),
  [13903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [13905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 4, 0, 0),
  [13907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8122),
  [13909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [13911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 132),
  [13913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8131),
  [13915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8133),
  [13917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [13919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [13921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [13923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [13925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [13927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 132),
  [13929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [13931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [13933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [13935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [13937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [13939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [13941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [13943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [13945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [13947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [13949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [13951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [13953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [13955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [13957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 183),
  [13959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [13961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [13963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [13965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [13967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8458),
  [13969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [13971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [13973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [13977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [13979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [13981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, 0, 133),
  [13983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [13985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8009),
  [13987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8494),
  [13989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8495),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [13993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8097),
  [13995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [13997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [13999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, 0, 133),
  [14001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8702),
  [14003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8480),
  [14005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 82),
  [14007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8742),
  [14009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8815),
  [14013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [14015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [14017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8492),
  [14019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [14021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [14023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7987),
  [14025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [14027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8046),
  [14029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [14031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8353),
  [14033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [14035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8803),
  [14037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7990),
  [14039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8145),
  [14041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [14043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [14045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8129),
  [14047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8158),
  [14049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6959),
  [14051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [14053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8402),
  [14055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8420),
  [14057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8785),
  [14059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8795),
  [14061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7991),
  [14063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7992),
  [14065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8060),
  [14067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8063),
  [14069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [14071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8134),
  [14073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8210),
  [14075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8211),
  [14077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [14079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [14081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7840),
  [14083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [14085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8486),
  [14087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [14089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [14091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [14093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [14095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [14097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [14099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [14101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [14103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [14105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [14107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [14109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [14111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [14113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [14115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [14117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [14119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7566),
  [14121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8193),
  [14123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3803),
  [14125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [14127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [14129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [14131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8529),
  [14133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [14135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [14137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [14139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [14141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8619),
  [14143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [14145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [14147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [14149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [14151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 132),
  [14153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8181),
  [14155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [14157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [14159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [14161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [14163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8253),
  [14165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [14167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [14169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, 0, 82),
  [14171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8187),
  [14173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [14175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [14177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8491),
  [14181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7439),
  [14183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [14185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [14187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [14189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8443),
  [14191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7131),
  [14193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [14197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [14199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [14201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [14203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [14205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [14207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6817),
  [14209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [14211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 81),
  [14213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [14215] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [14217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [14219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [14221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8089),
  [14223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [14225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [14227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [14229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8091),
  [14231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [14233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [14235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [14237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8382),
  [14241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [14245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [14249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [14251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7611),
  [14255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [14257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [14259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [14261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [14263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 132),
  [14265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [14267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [14269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, 0, 133),
  [14271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [14273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [14275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8656),
  [14277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [14279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [14281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8170),
  [14283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [14285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [14287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [14289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [14291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [14293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8673),
  [14295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [14297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [14299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7691),
  [14301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7735),
  [14303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [14305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [14307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7761),
  [14309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [14313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [14315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8400),
  [14319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [14321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [14323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [14325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [14329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [14331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 82),
  [14333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [14335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2, 0, 0),
  [14337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [14339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [14341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [14343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6836),
  [14345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [14347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [14349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [14351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [14353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8709),
  [14355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [14357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7104),
  [14359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [14361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8355),
  [14363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [14365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [14367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [14369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [14371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6953),
  [14373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [14375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 2, 0, 0),
  [14377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [14379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6829),
  [14381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [14383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [14385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7659),
  [14387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [14389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [14391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [14393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [14395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, 0, 183),
  [14397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [14399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [14401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [14403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 132),
  [14405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7669),
  [14407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8793),
  [14409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [14411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8352),
  [14413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [14415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7924),
  [14417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [14419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, 0, 133),
  [14421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8416),
  [14423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [14425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7944),
  [14427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7955),
  [14429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [14431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [14433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [14435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7705),
  [14437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [14439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [14441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [14443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [14445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7714),
  [14447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8809),
  [14449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8055),
  [14451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [14453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [14455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [14457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8061),
  [14459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5609),
  [14461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [14463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5610),
  [14465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [14467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8079),
  [14469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [14471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8081),
  [14473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7732),
  [14475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [14477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [14479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [14481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8538),
  [14483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [14485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7737),
  [14487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8130),
  [14489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [14491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [14493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8135),
  [14495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [14497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8146),
  [14499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [14501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [14503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [14505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [14507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [14509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7749),
  [14511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [14513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [14515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [14517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [14519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [14521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [14523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [14525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [14527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8188),
  [14529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [14531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8199),
  [14533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [14535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8205),
  [14537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [14539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7979),
  [14541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7765),
  [14543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [14545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [14547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7048),
  [14549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [14551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [14553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [14557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [14559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [14561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8251),
  [14563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 82),
  [14565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7781),
  [14567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [14569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [14571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [14573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8263),
  [14575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [14577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [14579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8266),
  [14581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [14583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [14585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [14587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [14589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [14591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8275),
  [14593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [14595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8277),
  [14597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7787),
  [14599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [14601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [14603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8283),
  [14605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8284),
  [14607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [14609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8287),
  [14611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8288),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8291),
  [14617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8292),
  [14619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8293),
  [14621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8294),
  [14623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8295),
  [14625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8296),
  [14627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8297),
  [14629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8298),
  [14631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8299),
  [14633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8300),
  [14635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8301),
  [14637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8302),
  [14639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [14641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6429),
  [14643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [14645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [14647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8339),
  [14649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [14651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6819),
  [14653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [14655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [14657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6838),
  [14659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [14661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [14663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [14665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [14667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8378),
  [14669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [14671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [14673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [14675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8547),
  [14677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [14679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [14681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 10),
  [14683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [14685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5884),
  [14687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7995),
  [14690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [14692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [14694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8828),
  [14696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6941),
  [14698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [14700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [14702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6976),
  [14704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8024),
  [14706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [14708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [14710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [14712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [14714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [14716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8692),
  [14718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [14720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [14722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [14724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [14726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [14728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [14730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [14732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [14734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [14736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [14738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8381),
  [14740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [14742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [14744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6511),
  [14746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [14748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [14750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8721),
  [14752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [14754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [14756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [14758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [14760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [14762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [14764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8525),
  [14766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [14768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [14770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7037),
  [14772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8535),
  [14774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7970),
  [14776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [14778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8169),
  [14780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [14782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [14784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8551),
  [14786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [14788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [14790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7047),
  [14792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8557),
  [14794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [14796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [14798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [14800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [14802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8571),
  [14804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [14806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7055),
  [14808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8577),
  [14810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [14812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [14814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8590),
  [14816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [14818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [14820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7063),
  [14822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8596),
  [14824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [14826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8607),
  [14828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [14830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7072),
  [14832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8612),
  [14834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [14836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7076),
  [14838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8621),
  [14840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [14842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8629),
  [14844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [14846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [14848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [14850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8637),
  [14852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [14854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8640),
  [14856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [14858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8642),
  [14860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8125),
  [14862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8644),
  [14864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [14866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8646),
  [14868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [14870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8648),
  [14872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8650),
  [14874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [14876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8672),
  [14878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8735),
  [14880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [14882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8745),
  [14884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [14886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [14888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8756),
  [14890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [14892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [14894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8765),
  [14896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [14898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8773),
  [14900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [14902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8779),
  [14904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8782),
  [14906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8784),
  [14908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8786),
  [14910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8788),
  [14912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8790),
  [14914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8792),
  [14916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8794),
  [14918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8796),
  [14920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8798),
  [14922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8800),
  [14924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, 0, 133),
  [14926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [14928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [14930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [14932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [14934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [14936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [14938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [14940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 82),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_raw_string_delimiter = 0,
  ts_external_token_raw_string_content = 1,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_delimiter] = sym_raw_string_delimiter,
  [ts_external_token_raw_string_content] = sym_raw_string_content,
};

static const bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_delimiter] = true,
    [ts_external_token_raw_string_content] = true,
  },
  [2] = {
    [ts_external_token_raw_string_delimiter] = true,
  },
  [3] = {
    [ts_external_token_raw_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_cpp_external_scanner_create(void);
void tree_sitter_cpp_external_scanner_destroy(void *);
bool tree_sitter_cpp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_cpp_external_scanner_serialize(void *, char *);
void tree_sitter_cpp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_cpp(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_cpp_external_scanner_create,
      tree_sitter_cpp_external_scanner_destroy,
      tree_sitter_cpp_external_scanner_scan,
      tree_sitter_cpp_external_scanner_serialize,
      tree_sitter_cpp_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
